{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "import numpy as np\n",
    "import pandas as pd\n",
    "import matplotlib.pyplot as plt\n",
    "import seaborn as sns\n",
    "sns.set_context(\"talk\")\n",
    "%matplotlib inline"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<script type='text/javascript'>if(!window.Plotly){define('plotly', function(require, exports, module) {/**\n",
       "* plotly.js v1.30.0\n",
       "* Copyright 2012-2017, Plotly, Inc.\n",
       "* All rights reserved.\n",
       "* Licensed under the MIT license\n",
       "*/\n",
       "!function(t){if(\"object\"==typeof exports&&\"undefined\"!=typeof module)module.exports=t();else if(\"function\"==typeof define&&define.amd)define([],t);else{var e;e=\"undefined\"!=typeof window?window:\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:this,e.Plotly=t()}}(function(){var t;return function t(e,r,n){function i(o,s){if(!r[o]){if(!e[o]){var l=\"function\"==typeof require&&require;if(!s&&l)return l(o,!0);if(a)return a(o,!0);var u=new Error(\"Cannot find module '\"+o+\"'\");throw u.code=\"MODULE_NOT_FOUND\",u}var c=r[o]={exports:{}};e[o][0].call(c.exports,function(t){var r=e[o][1][t];return i(r||t)},c,c.exports,t,e,r,n)}return r[o].exports}for(var a=\"function\"==typeof require&&require,o=0;o<n.length;o++)i(n[o]);return i}({1:[function(t,e,r){\"use strict\";var n=t(\"../src/lib\"),i={\"X,X div\":\"font-family:'Open Sans', verdana, arial, sans-serif;margin:0;padding:0;\",\"X input,X button\":\"font-family:'Open Sans', verdana, arial, sans-serif;\",\"X input:focus,X button:focus\":\"outline:none;\",\"X a\":\"text-decoration:none;\",\"X a:hover\":\"text-decoration:none;\",\"X .crisp\":\"shape-rendering:crispEdges;\",\"X .user-select-none\":\"-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;-o-user-select:none;user-select:none;\",\"X svg\":\"overflow:hidden;\",\"X svg a\":\"fill:#447adb;\",\"X svg a:hover\":\"fill:#3c6dc5;\",\"X .main-svg\":\"position:absolute;top:0;left:0;pointer-events:none;\",\"X .main-svg .draglayer\":\"pointer-events:all;\",\"X .cursor-default\":\"cursor:default;\",\"X .cursor-pointer\":\"cursor:pointer;\",\"X .cursor-crosshair\":\"cursor:crosshair;\",\"X .cursor-move\":\"cursor:move;\",\"X .cursor-col-resize\":\"cursor:col-resize;\",\"X .cursor-row-resize\":\"cursor:row-resize;\",\"X .cursor-ns-resize\":\"cursor:ns-resize;\",\"X .cursor-ew-resize\":\"cursor:ew-resize;\",\"X .cursor-sw-resize\":\"cursor:sw-resize;\",\"X .cursor-s-resize\":\"cursor:s-resize;\",\"X .cursor-se-resize\":\"cursor:se-resize;\",\"X .cursor-w-resize\":\"cursor:w-resize;\",\"X .cursor-e-resize\":\"cursor:e-resize;\",\"X .cursor-nw-resize\":\"cursor:nw-resize;\",\"X .cursor-n-resize\":\"cursor:n-resize;\",\"X .cursor-ne-resize\":\"cursor:ne-resize;\",\"X .modebar\":\"position:absolute;top:2px;right:2px;z-index:1001;background:rgba(255,255,255,0.7);\",\"X .modebar--hover\":\"opacity:0;-webkit-transition:opacity 0.3s ease 0s;-moz-transition:opacity 0.3s ease 0s;-ms-transition:opacity 0.3s ease 0s;-o-transition:opacity 0.3s ease 0s;transition:opacity 0.3s ease 0s;\",\"X:hover .modebar--hover\":\"opacity:1;\",\"X .modebar-group\":\"float:left;display:inline-block;box-sizing:border-box;margin-left:8px;position:relative;vertical-align:middle;white-space:nowrap;\",\"X .modebar-group:first-child\":\"margin-left:0px;\",\"X .modebar-btn\":\"position:relative;font-size:16px;padding:3px 4px;cursor:pointer;line-height:normal;box-sizing:border-box;\",\"X .modebar-btn svg\":\"position:relative;top:2px;\",\"X .modebar-btn path\":\"fill:rgba(0,31,95,0.3);\",\"X .modebar-btn.active path,X .modebar-btn:hover path\":\"fill:rgba(0,22,72,0.5);\",\"X .modebar-btn.modebar-btn--logo\":\"padding:3px 1px;\",\"X .modebar-btn.modebar-btn--logo path\":\"fill:#447adb !important;\",\"X [data-title]:before,X [data-title]:after\":\"position:absolute;-webkit-transform:translate3d(0, 0, 0);-moz-transform:translate3d(0, 0, 0);-ms-transform:translate3d(0, 0, 0);-o-transform:translate3d(0, 0, 0);transform:translate3d(0, 0, 0);display:none;opacity:0;z-index:1001;pointer-events:none;top:110%;right:50%;\",\"X [data-title]:hover:before,X [data-title]:hover:after\":\"display:block;opacity:1;\",\"X [data-title]:before\":\"content:'';position:absolute;background:transparent;border:6px solid transparent;z-index:1002;margin-top:-12px;border-bottom-color:#69738a;margin-right:-6px;\",\"X [data-title]:after\":\"content:attr(data-title);background:#69738a;color:white;padding:8px 10px;font-size:12px;line-height:12px;white-space:nowrap;margin-right:-18px;border-radius:2px;\",\"X .select-outline\":\"fill:none;stroke-width:1;shape-rendering:crispEdges;\",\"X .select-outline-1\":\"stroke:white;\",\"X .select-outline-2\":\"stroke:black;stroke-dasharray:2px 2px;\",Y:\"font-family:'Open Sans';position:fixed;top:50px;right:20px;z-index:10000;font-size:10pt;max-width:180px;\",\"Y p\":\"margin:0;\",\"Y .notifier-note\":\"min-width:180px;max-width:250px;border:1px solid #fff;z-index:3000;margin:0;background-color:#8c97af;background-color:rgba(140,151,175,0.9);color:#fff;padding:10px;\",\"Y .notifier-close\":\"color:#fff;opacity:0.8;float:right;padding:0 5px;background:none;border:none;font-size:20px;font-weight:bold;line-height:20px;\",\"Y .notifier-close:hover\":\"color:#444;text-decoration:none;cursor:pointer;\"};for(var a in i){var o=a.replace(/^,/,\" ,\").replace(/X/g,\".js-plotly-plot .plotly\").replace(/Y/g,\".plotly-notifier\");n.addStyleRule(o,i[a])}},{\"../src/lib\":725}],2:[function(t,e,r){\"use strict\";e.exports={undo:{width:857.1,path:\"m857 350q0-87-34-166t-91-137-137-92-166-34q-96 0-183 41t-147 114q-4 6-4 13t5 11l76 77q6 5 14 5 9-1 13-7 41-53 100-82t126-29q58 0 110 23t92 61 61 91 22 111-22 111-61 91-92 61-110 23q-55 0-105-20t-90-57l77-77q17-16 8-38-10-23-33-23h-250q-15 0-25 11t-11 25v250q0 24 22 33 22 10 39-8l72-72q60 57 137 88t159 31q87 0 166-34t137-92 91-137 34-166z\",ascent:850,descent:-150},home:{width:928.6,path:\"m786 296v-267q0-15-11-26t-25-10h-214v214h-143v-214h-214q-15 0-25 10t-11 26v267q0 1 0 2t0 2l321 264 321-264q1-1 1-4z m124 39l-34-41q-5-5-12-6h-2q-7 0-12 3l-386 322-386-322q-7-4-13-4-7 2-12 7l-35 41q-4 5-3 13t6 12l401 334q18 15 42 15t43-15l136-114v109q0 8 5 13t13 5h107q8 0 13-5t5-13v-227l122-102q5-5 6-12t-4-13z\",ascent:850,descent:-150},\"camera-retro\":{width:1e3,path:\"m518 386q0 8-5 13t-13 5q-37 0-63-27t-26-63q0-8 5-13t13-5 12 5 5 13q0 23 16 38t38 16q8 0 13 5t5 13z m125-73q0-59-42-101t-101-42-101 42-42 101 42 101 101 42 101-42 42-101z m-572-320h858v71h-858v-71z m643 320q0 89-62 152t-152 62-151-62-63-152 63-151 151-63 152 63 62 151z m-571 358h214v72h-214v-72z m-72-107h858v143h-462l-36-71h-360v-72z m929 143v-714q0-30-21-51t-50-21h-858q-29 0-50 21t-21 51v714q0 30 21 51t50 21h858q29 0 50-21t21-51z\",ascent:850,descent:-150},zoombox:{width:1e3,path:\"m1000-25l-250 251c40 63 63 138 63 218 0 224-182 406-407 406-224 0-406-182-406-406s183-406 407-406c80 0 155 22 218 62l250-250 125 125z m-812 250l0 438 437 0 0-438-437 0z m62 375l313 0 0-312-313 0 0 312z\",ascent:850,descent:-150},pan:{width:1e3,path:\"m1000 350l-187 188 0-125-250 0 0 250 125 0-188 187-187-187 125 0 0-250-250 0 0 125-188-188 186-187 0 125 252 0 0-250-125 0 187-188 188 188-125 0 0 250 250 0 0-126 187 188z\",ascent:850,descent:-150},zoom_plus:{width:1e3,path:\"m1 787l0-875 875 0 0 875-875 0z m687-500l-187 0 0-187-125 0 0 187-188 0 0 125 188 0 0 187 125 0 0-187 187 0 0-125z\",ascent:850,descent:-150},zoom_minus:{width:1e3,path:\"m0 788l0-876 875 0 0 876-875 0z m688-500l-500 0 0 125 500 0 0-125z\",ascent:850,descent:-150},autoscale:{width:1e3,path:\"m250 850l-187 0-63 0 0-62 0-188 63 0 0 188 187 0 0 62z m688 0l-188 0 0-62 188 0 0-188 62 0 0 188 0 62-62 0z m-875-938l0 188-63 0 0-188 0-62 63 0 187 0 0 62-187 0z m875 188l0-188-188 0 0-62 188 0 62 0 0 62 0 188-62 0z m-125 188l-1 0-93-94-156 156 156 156 92-93 2 0 0 250-250 0 0-2 93-92-156-156-156 156 94 92 0 2-250 0 0-250 0 0 93 93 157-156-157-156-93 94 0 0 0-250 250 0 0 0-94 93 156 157 156-157-93-93 0 0 250 0 0 250z\",ascent:850,descent:-150},tooltip_basic:{width:1500,path:\"m375 725l0 0-375-375 375-374 0-1 1125 0 0 750-1125 0z\",ascent:850,descent:-150},tooltip_compare:{width:1125,path:\"m187 786l0 2-187-188 188-187 0 0 937 0 0 373-938 0z m0-499l0 1-187-188 188-188 0 0 937 0 0 376-938-1z\",ascent:850,descent:-150},plotlylogo:{width:1542,path:\"m0-10h182v-140h-182v140z m228 146h183v-286h-183v286z m225 714h182v-1000h-182v1000z m225-285h182v-715h-182v715z m225 142h183v-857h-183v857z m231-428h182v-429h-182v429z m225-291h183v-138h-183v138z\",ascent:850,descent:-150},\"z-axis\":{width:1e3,path:\"m833 5l-17 108v41l-130-65 130-66c0 0 0 38 0 39 0-1 36-14 39-25 4-15-6-22-16-30-15-12-39-16-56-20-90-22-187-23-279-23-261 0-341 34-353 59 3 60 228 110 228 110-140-8-351-35-351-116 0-120 293-142 474-142 155 0 477 22 477 142 0 50-74 79-163 96z m-374 94c-58-5-99-21-99-40 0-24 65-43 144-43 79 0 143 19 143 43 0 19-42 34-98 40v216h87l-132 135-133-135h88v-216z m167 515h-136v1c16 16 31 34 46 52l84 109v54h-230v-71h124v-1c-16-17-28-32-44-51l-89-114v-51h245v72z\",ascent:850,descent:-150},\"3d_rotate\":{width:1e3,path:\"m922 660c-5 4-9 7-14 11-359 263-580-31-580-31l-102 28 58-400c0 1 1 1 2 2 118 108 351 249 351 249s-62 27-100 42c88 83 222 183 347 122 16-8 30-17 44-27-2 1-4 2-6 4z m36-329c0 0 64 229-88 296-62 27-124 14-175-11 157-78 225-208 249-266 8-19 11-31 11-31 2 5 6 15 11 32-5-13-8-20-8-20z m-775-239c70-31 117-50 198-32-121 80-199 346-199 346l-96-15-58-12c0 0 55-226 155-287z m603 133l-317-139c0 0 4-4 19-14 7-5 24-15 24-15s-177-147-389 4c235-287 536-112 536-112l31-22 100 299-4-1z m-298-153c6-4 14-9 24-15 0 0-17 10-24 15z\",ascent:850,descent:-150},camera:{width:1e3,path:\"m500 450c-83 0-150-67-150-150 0-83 67-150 150-150 83 0 150 67 150 150 0 83-67 150-150 150z m400 150h-120c-16 0-34 13-39 29l-31 93c-6 15-23 28-40 28h-340c-16 0-34-13-39-28l-31-94c-6-15-23-28-40-28h-120c-55 0-100-45-100-100v-450c0-55 45-100 100-100h800c55 0 100 45 100 100v450c0 55-45 100-100 100z m-400-550c-138 0-250 112-250 250 0 138 112 250 250 250 138 0 250-112 250-250 0-138-112-250-250-250z m365 380c-19 0-35 16-35 35 0 19 16 35 35 35 19 0 35-16 35-35 0-19-16-35-35-35z\",ascent:850,descent:-150},movie:{width:1e3,path:\"m938 413l-188-125c0 37-17 71-44 94 64 38 107 107 107 187 0 121-98 219-219 219-121 0-219-98-219-219 0-61 25-117 66-156h-115c30 33 49 76 49 125 0 103-84 187-187 187s-188-84-188-187c0-57 26-107 65-141-38-22-65-62-65-109v-250c0-70 56-126 125-126h500c69 0 125 56 125 126l188-126c34 0 62 28 62 63v375c0 35-28 63-62 63z m-750 0c-69 0-125 56-125 125s56 125 125 125 125-56 125-125-56-125-125-125z m406-1c-87 0-157 70-157 157 0 86 70 156 157 156s156-70 156-156-70-157-156-157z\",ascent:850,descent:-150},question:{width:857.1,path:\"m500 82v107q0 8-5 13t-13 5h-107q-8 0-13-5t-5-13v-107q0-8 5-13t13-5h107q8 0 13 5t5 13z m143 375q0 49-31 91t-77 65-95 23q-136 0-207-119-9-14 4-24l74-55q4-4 10-4 9 0 14 7 30 38 48 51 19 14 48 14 27 0 48-15t21-33q0-21-11-34t-38-25q-35-16-65-48t-29-70v-20q0-8 5-13t13-5h107q8 0 13 5t5 13q0 10 12 27t30 28q18 10 28 16t25 19 25 27 16 34 7 45z m214-107q0-117-57-215t-156-156-215-58-216 58-155 156-58 215 58 215 155 156 216 58 215-58 156-156 57-215z\",ascent:850,descent:-150},disk:{width:857.1,path:\"m214-7h429v214h-429v-214z m500 0h72v500q0 8-6 21t-11 20l-157 156q-5 6-19 12t-22 5v-232q0-22-15-38t-38-16h-322q-22 0-37 16t-16 38v232h-72v-714h72v232q0 22 16 38t37 16h465q22 0 38-16t15-38v-232z m-214 518v178q0 8-5 13t-13 5h-107q-7 0-13-5t-5-13v-178q0-8 5-13t13-5h107q7 0 13 5t5 13z m357-18v-518q0-22-15-38t-38-16h-750q-23 0-38 16t-16 38v750q0 22 16 38t38 16h517q23 0 50-12t42-26l156-157q16-15 27-42t11-49z\",ascent:850,descent:-150},lasso:{width:1031,path:\"m1018 538c-36 207-290 336-568 286-277-48-473-256-436-463 10-57 36-108 76-151-13-66 11-137 68-183 34-28 75-41 114-42l-55-70 0 0c-2-1-3-2-4-3-10-14-8-34 5-45 14-11 34-8 45 4 1 1 2 3 2 5l0 0 113 140c16 11 31 24 45 40 4 3 6 7 8 11 48-3 100 0 151 9 278 48 473 255 436 462z m-624-379c-80 14-149 48-197 96 42 42 109 47 156 9 33-26 47-66 41-105z m-187-74c-19 16-33 37-39 60 50-32 109-55 174-68-42-25-95-24-135 8z m360 75c-34-7-69-9-102-8 8 62-16 128-68 170-73 59-175 54-244-5-9 20-16 40-20 61-28 159 121 317 333 354s407-60 434-217c28-159-121-318-333-355z\",ascent:850,descent:-150},selectbox:{width:1e3,path:\"m0 850l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-285l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z\",ascent:850,descent:-150},spikeline:{width:1e3,path:\"M512 409c0-57-46-104-103-104-57 0-104 47-104 104 0 57 47 103 104 103 57 0 103-46 103-103z m-327-39l92 0 0 92-92 0z m-185 0l92 0 0 92-92 0z m370-186l92 0 0 93-92 0z m0-184l92 0 0 92-92 0z\",ascent:850,descent:-150}}},{}],3:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/aggregate\")},{\"../src/transforms/aggregate\":1099}],4:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/bar\")},{\"../src/traces/bar\":858}],5:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/box\")},{\"../src/traces/box\":870}],6:[function(t,e,r){\"use strict\";e.exports=t(\"../src/components/calendars\")},{\"../src/components/calendars\":601}],7:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/candlestick\")},{\"../src/traces/candlestick\":878}],8:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/carpet\")},{\"../src/traces/carpet\":899}],9:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/choropleth\")},{\"../src/traces/choropleth\":914}],10:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/contour\")},{\"../src/traces/contour\":925}],11:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/contourcarpet\")},{\"../src/traces/contourcarpet\":940}],12:[function(t,e,r){\"use strict\";e.exports=t(\"../src/core\")},{\"../src/core\":708}],13:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/filter\")},{\"../src/transforms/filter\":1100}],14:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/groupby\")},{\"../src/transforms/groupby\":1101}],15:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/heatmap\")},{\"../src/traces/heatmap\":953}],16:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/heatmapgl\")},{\"../src/traces/heatmapgl\":962}],17:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram\")},{\"../src/traces/histogram\":970}],18:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram2d\")},{\"../src/traces/histogram2d\":975}],19:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram2dcontour\")},{\"../src/traces/histogram2dcontour\":979}],20:[function(t,e,r){\"use strict\";var n=t(\"./core\");n.register([t(\"./bar\"),t(\"./box\"),t(\"./heatmap\"),t(\"./histogram\"),t(\"./histogram2d\"),t(\"./histogram2dcontour\"),t(\"./pie\"),t(\"./contour\"),t(\"./scatterternary\"),t(\"./sankey\"),t(\"./scatter3d\"),t(\"./surface\"),t(\"./mesh3d\"),t(\"./scattergeo\"),t(\"./choropleth\"),t(\"./scattergl\"),t(\"./pointcloud\"),t(\"./heatmapgl\"),t(\"./parcoords\"),t(\"./scattermapbox\"),t(\"./carpet\"),t(\"./scattercarpet\"),t(\"./contourcarpet\"),t(\"./ohlc\"),t(\"./candlestick\")]),n.register([t(\"./aggregate\"),t(\"./filter\"),t(\"./groupby\"),t(\"./sort\")]),n.register([t(\"./calendars\")]),e.exports=n},{\"./aggregate\":3,\"./bar\":4,\"./box\":5,\"./calendars\":6,\"./candlestick\":7,\"./carpet\":8,\"./choropleth\":9,\"./contour\":10,\"./contourcarpet\":11,\"./core\":12,\"./filter\":13,\"./groupby\":14,\"./heatmap\":15,\"./heatmapgl\":16,\"./histogram\":17,\"./histogram2d\":18,\"./histogram2dcontour\":19,\"./mesh3d\":21,\"./ohlc\":22,\"./parcoords\":23,\"./pie\":24,\"./pointcloud\":25,\"./sankey\":26,\"./scatter3d\":27,\"./scattercarpet\":28,\"./scattergeo\":29,\"./scattergl\":30,\"./scattermapbox\":31,\"./scatterternary\":32,\"./sort\":33,\"./surface\":34}],21:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/mesh3d\")},{\"../src/traces/mesh3d\":985}],22:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/ohlc\")},{\"../src/traces/ohlc\":990}],23:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/parcoords\")},{\"../src/traces/parcoords\":999}],24:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/pie\")},{\"../src/traces/pie\":1008}],25:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/pointcloud\")},{\"../src/traces/pointcloud\":1017}],26:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/sankey\")},{\"../src/traces/sankey\":1023}],27:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scatter3d\")},{\"../src/traces/scatter3d\":1055}],28:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattercarpet\")},{\"../src/traces/scattercarpet\":1060}],29:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattergeo\")},{\"../src/traces/scattergeo\":1069}],30:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattergl\")},{\"../src/traces/scattergl\":1075}],31:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattermapbox\")},{\"../src/traces/scattermapbox\":1082}],32:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scatterternary\")},{\"../src/traces/scatterternary\":1089}],33:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/sort\")},{\"../src/transforms/sort\":1102}],34:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/surface\")},{\"../src/traces/surface\":1098}],35:[function(t,e,r){\"use strict\";function n(t,e){function r(e,r,n,a){var o=1/t.clientHeight,s=o*(r-m),l=o*(n-v),c=p.flipX?1:-1,f=p.flipY?1:-1,d=Math.PI*p.rotateSpeed,y=i();if(1&e)a.shift?u.rotate(y,0,0,-s*d):u.rotate(y,c*d*s,-f*d*l,0);else if(2&e)u.pan(y,-p.translateSpeed*s*h,p.translateSpeed*l*h,0);else if(4&e){var b=p.zoomSpeed*l/window.innerHeight*(y-u.lastT())*50;u.pan(y,0,0,h*(Math.exp(b)-1))}m=r,v=n,g=a}t=t||document.body,e=e||{};var n=[.01,1/0];\"distanceLimits\"in e&&(n[0]=e.distanceLimits[0],n[1]=e.distanceLimits[1]),\"zoomMin\"in e&&(n[0]=e.zoomMin),\"zoomMax\"in e&&(n[1]=e.zoomMax);var u=a({center:e.center||[0,0,0],up:e.up||[0,1,0],eye:e.eye||[0,0,10],mode:e.mode||\"orbit\",distanceLimits:n}),c=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],h=0,f=t.clientWidth,d=t.clientHeight,p={view:u,element:t,delay:e.delay||16,rotateSpeed:e.rotateSpeed||1,zoomSpeed:e.zoomSpeed||1,translateSpeed:e.translateSpeed||1,flipX:!!e.flipX,flipY:!!e.flipY,modes:u.modes,tick:function(){var e=i(),r=this.delay;u.idle(e-r),u.flush(e-(100+2*r));var n=e-2*r;u.recalcMatrix(n);for(var a=!0,o=u.computedMatrix,s=0;s<16;++s)a=a&&c[s]===o[s],c[s]=o[s];var l=t.clientWidth===f&&t.clientHeight===d;return f=t.clientWidth,d=t.clientHeight,a?!l:(h=Math.exp(u.computedRadius[0]),!0)},lookAt:function(t,e,r){u.lookAt(u.lastT(),t,e,r)},rotate:function(t,e,r){u.rotate(u.lastT(),t,e,r)},pan:function(t,e,r){u.pan(u.lastT(),t,e,r)},translate:function(t,e,r){u.translate(u.lastT(),t,e,r)}};Object.defineProperties(p,{matrix:{get:function(){return u.computedMatrix},set:function(t){return u.setMatrix(u.lastT(),t),u.computedMatrix},enumerable:!0},mode:{get:function(){return u.getMode()},set:function(t){return u.setMode(t),u.getMode()},enumerable:!0},center:{get:function(){return u.computedCenter},set:function(t){return u.lookAt(u.lastT(),t),u.computedCenter},enumerable:!0},eye:{get:function(){return u.computedEye},set:function(t){return u.lookAt(u.lastT(),null,t),u.computedEye},enumerable:!0},up:{get:function(){return u.computedUp},set:function(t){return u.lookAt(u.lastT(),null,null,t),u.computedUp},enumerable:!0},distance:{get:function(){return h},set:function(t){return u.setDistance(u.lastT(),t),t},enumerable:!0},distanceLimits:{get:function(){return u.getDistanceLimits(n)},set:function(t){return u.setDistanceLimits(t),t},enumerable:!0}}),t.addEventListener(\"contextmenu\",function(t){return t.preventDefault(),!1});var m=0,v=0,g={shift:!1,control:!1,alt:!1,meta:!1};return o(t,r),t.addEventListener(\"touchstart\",function(e){var n=l(e.changedTouches[0],t);r(0,n[0],n[1],g),r(1,n[0],n[1],g)}),t.addEventListener(\"touchmove\",function(e){var n=l(e.changedTouches[0],t);r(1,n[0],n[1],g)}),t.addEventListener(\"touchend\",function(e){l(e.changedTouches[0],t);r(0,m,v,g)}),s(t,function(t,e,r){var n=p.flipX?1:-1,a=p.flipY?1:-1,o=i();if(Math.abs(t)>Math.abs(e))u.rotate(o,0,0,-t*n*Math.PI*p.rotateSpeed/window.innerWidth);else{var s=p.zoomSpeed*a*e/window.innerHeight*(o-u.lastT())/100;u.pan(o,0,0,h*(Math.exp(s)-1))}},!0),p}e.exports=n;var i=t(\"right-now\"),a=t(\"3d-view\"),o=t(\"mouse-change\"),s=t(\"mouse-wheel\"),l=t(\"mouse-event-offset\")},{\"3d-view\":36,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454,\"right-now\":501}],36:[function(t,e,r){\"use strict\";function n(t,e){this._controllerNames=Object.keys(t),this._controllerList=this._controllerNames.map(function(e){return t[e]}),this._mode=e,this._active=t[e],this._active||(this._mode=\"turntable\",this._active=t.turntable),this.modes=this._controllerNames,this.computedMatrix=this._active.computedMatrix,this.computedEye=this._active.computedEye,this.computedUp=this._active.computedUp,this.computedCenter=this._active.computedCenter,this.computedRadius=this._active.computedRadius}function i(t){t=t||{};var e=t.eye||[0,0,1],r=t.center||[0,0,0],i=t.up||[0,1,0],l=t.distanceLimits||[0,1/0],u=t.mode||\"turntable\",c=a(),h=o(),f=s();return c.setDistanceLimits(l[0],l[1]),c.lookAt(0,e,r,i),h.setDistanceLimits(l[0],l[1]),h.lookAt(0,e,r,i),f.setDistanceLimits(l[0],l[1]),f.lookAt(0,e,r,i),new n({turntable:c,orbit:h,matrix:f},u)}e.exports=i;var a=t(\"turntable-camera-controller\"),o=t(\"orbit-camera-controller\"),s=t(\"matrix-camera-controller\"),l=n.prototype;[[\"flush\",1],[\"idle\",1],[\"lookAt\",4],[\"rotate\",4],[\"pan\",4],[\"translate\",4],[\"setMatrix\",2],[\"setDistanceLimits\",2],[\"setDistance\",2]].forEach(function(t){for(var e=t[0],r=[],n=0;n<t[1];++n)r.push(\"a\"+n);var i=\"var cc=this._controllerList;for(var i=0;i<cc.length;++i){cc[i].\"+t[0]+\"(\"+r.join()+\")}\";l[e]=Function.apply(null,r.concat(i))}),l.recalcMatrix=function(t){this._active.recalcMatrix(t)},l.getDistance=function(t){return this._active.getDistance(t)},l.getDistanceLimits=function(t){return this._active.getDistanceLimits(t)},l.lastT=function(){return this._active.lastT()},l.setMode=function(t){if(t!==this._mode){var e=this._controllerNames.indexOf(t);if(!(e<0)){var r=this._active,n=this._controllerList[e],i=Math.max(r.lastT(),n.lastT());r.recalcMatrix(i),n.setMatrix(i,r.computedMatrix),this._active=n,this._mode=t,this.computedMatrix=this._active.computedMatrix,this.computedEye=this._active.computedEye,this.computedUp=this._active.computedUp,this.computedCenter=this._active.computedCenter,this.computedRadius=this._active.computedRadius}}},l.getMode=function(){return this._mode}},{\"matrix-camera-controller\":449,\"orbit-camera-controller\":472,\"turntable-camera-controller\":537}],37:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-array\"),e(\"d3-collection\"),e(\"d3-interpolate\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-array\",\"d3-collection\",\"d3-interpolate\"],a):a(i.d3=i.d3||{},i.d3,i.d3,i.d3)}(this,function(t,e,r,n){\"use strict\";var i=function(){function t(){v.forEach(function(t){t.sourceLinks=[],t.targetLinks=[]}),g.forEach(function(t,e){var r=t.source,n=t.target;\"number\"==typeof r&&(r=t.source=v[t.source]),\"number\"==typeof n&&(n=t.target=v[t.target]),t.originalIndex=e,r.sourceLinks.push(t),n.targetLinks.push(t)})}function i(){v.forEach(function(t){t.value=Math.max(e.sum(t.sourceLinks,h),e.sum(t.targetLinks,h))})}function a(){for(var t,e=v,r=0;e.length;)t=[],e.forEach(function(e){e.x=r,e.dx=d,e.sourceLinks.forEach(function(e){t.indexOf(e.target)<0&&t.push(e.target)})}),e=t,++r;o(r),s((m[0]-d)/(r-1))}function o(t){v.forEach(function(e){e.sourceLinks.length||(e.x=t-1)})}function s(t){v.forEach(function(e){e.x*=t})}function l(t){function n(){a.forEach(function(t){var e,r,n,a=0,o=t.length;for(t.sort(i),n=0;n<o;++n)e=t[n],r=a-e.y,r>0&&(e.y+=r),a=e.y+e.dy+p;if((r=a-p-m[1])>0)for(a=e.y-=r,n=o-2;n>=0;--n)e=t[n],r=e.y+e.dy+p-a,r>0&&(e.y-=r),a=e.y})}function i(t,e){return t.y-e.y}var a=r.nest().key(function(t){return t.x}).sortKeys(e.ascending).entries(v).map(function(t){return t.values});!function(){var t=e.min(a,function(t){return(m[1]-(t.length-1)*p)/e.sum(t,h)});a.forEach(function(e){e.forEach(function(e,r){e.y=r,e.dy=e.value*t})}),g.forEach(function(e){e.dy=e.value*t})}(),n();for(var o=1;t>0;--t)!function(t){function r(t){return c(t.target)*t.value}a.slice().reverse().forEach(function(n){n.forEach(function(n){if(n.sourceLinks.length){var i=e.sum(n.sourceLinks,r)/e.sum(n.sourceLinks,h);n.y+=(i-c(n))*t}})})}(o*=.99),n(),function(t){function r(t){return c(t.source)*t.value}a.forEach(function(n){n.forEach(function(n){if(n.targetLinks.length){var i=e.sum(n.targetLinks,r)/e.sum(n.targetLinks,h);n.y+=(i-c(n))*t}})})}(o),n()}function u(){function t(t,e){return t.source.y-e.source.y||t.originalIndex-e.originalIndex}function e(t,e){return t.target.y-e.target.y||t.originalIndex-e.originalIndex}v.forEach(function(r){r.sourceLinks.sort(e),r.targetLinks.sort(t)}),v.forEach(function(t){var e=0,r=0;t.sourceLinks.forEach(function(t){t.sy=e,e+=t.dy}),t.targetLinks.forEach(function(t){t.ty=r,r+=t.dy})})}function c(t){return t.y+t.dy/2}function h(t){return t.value}var f={},d=24,p=8,m=[1,1],v=[],g=[];return f.nodeWidth=function(t){return arguments.length?(d=+t,f):d},f.nodePadding=function(t){return arguments.length?(p=+t,f):p},f.nodes=function(t){return arguments.length?(v=t,f):v},f.links=function(t){return arguments.length?(g=t,f):g},f.size=function(t){return arguments.length?(m=t,f):m},f.layout=function(e){return t(),i(),a(),l(e),u(),f},f.relayout=function(){return u(),f},f.link=function(){function t(t){var r=t.source.x+t.source.dx,i=t.target.x,a=n.interpolateNumber(r,i),o=a(e),s=a(1-e),l=t.source.y+t.sy,u=l+t.dy,c=t.target.y+t.ty,h=c+t.dy;return\"M\"+r+\",\"+l+\"C\"+o+\",\"+l+\" \"+s+\",\"+c+\" \"+i+\",\"+c+\"L\"+i+\",\"+h+\"C\"+s+\",\"+h+\" \"+o+\",\"+u+\" \"+r+\",\"+u+\"Z\"}var e=.5;return t.curvature=function(r){return arguments.length?(e=+r,t):e},t},f};t.sankey=i,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-array\":113,\"d3-collection\":114,\"d3-interpolate\":118}],38:[function(t,e,r){\"use strict\";function n(t){var e=s.get(t),r=e&&(e._triangleBuffer.handle||e._triangleBuffer.buffer);if(!r||!t.isBuffer(r)){var n=a(t,new Float32Array([-1,-1,-1,4,4,-1]));e=o(t,[{buffer:n,type:t.FLOAT,size:2}]),e._triangleBuffer=n,s.set(t,e)}e.bind(),t.drawArrays(t.TRIANGLES,0,3),e.unbind()}var i=\"undefined\"==typeof WeakMap?t(\"weak-map\"):WeakMap,a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=new i;e.exports=n},{\"gl-buffer\":155,\"gl-vao\":270,\"weak-map\":558}],39:[function(t,e,r){function n(t,e,r){e=\"number\"==typeof e?e:1,r=r||\": \";var n=t.split(/\\r?\\n/),a=String(n.length+e-1).length;return n.map(function(t,n){var o=n+e,s=String(o).length;return i(o,a-s)+r+t}).join(\"\\n\")}var i=t(\"pad-left\");e.exports=n},{\"pad-left\":473}],40:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(e+1),n=0;n<t.length;++n)r[n]=t[n];for(var n=0;n<=t.length;++n){for(var i=t.length;i<=e;++i){for(var o=new Array(e),s=0;s<e;++s)o[s]=Math.pow(i+1-n,s);r[i]=o}if(a.apply(void 0,r))return!0}return!1}function i(t){var e=t.length;if(0===e)return[];if(1===e)return[0];for(var r=t[0].length,i=[t[0]],a=[0],o=1;o<e;++o)if(i.push(t[o]),n(i,r)){if(a.push(o),a.length===r+1)return a}else i.pop();return a}e.exports=i;var a=t(\"robust-orientation\")},{\"robust-orientation\":507}],41:[function(t,e,r){\"use strict\";function n(t,e){return i(e).filter(function(r){for(var n=new Array(r.length),i=0;i<r.length;++i)n[i]=e[r[i]];return a(n)*t<1})}e.exports=n;var i=t(\"delaunay-triangulate\"),a=t(\"circumradius\")},{circumradius:86,\"delaunay-triangulate\":122}],42:[function(t,e,r){function n(t,e){return a(i(t,e))}e.exports=n;var i=t(\"alpha-complex\"),a=t(\"simplicial-complex-boundary\")},{\"alpha-complex\":41,\"simplicial-complex-boundary\":515}],43:[function(t,e,r){\"use strict\";function n(t,e){if(!t||null==t.length)throw Error(\"Argument should be an array\");e=null==e?1:Math.floor(e);for(var r=Array(2*e),n=0;n<e;n++){for(var i=-1/0,a=1/0,o=n,s=t.length;o<s;o+=e)t[o]>i&&(i=t[o]),t[o]<a&&(a=t[o]);r[n]=a,r[e+n]=i}return r}e.exports=n},{}],44:[function(t,e,r){\"use strict\";function n(t,e,r){if(!t||null==t.length)throw Error(\"Argument should be an array\");null==e&&(e=1),null==r&&(r=i(t,e));for(var n=0;n<e;n++){var a=r[e+n],o=r[n],s=n,l=t.length;if(a===1/0&&o===-1/0)for(s=n;s<l;s+=e)t[s]=t[s]===a?1:t[s]===o?0:.5;else if(a===1/0)for(s=n;s<l;s+=e)t[s]=t[s]===a?1:0;else if(o===-1/0)for(s=n;s<l;s+=e)t[s]=t[s]===o?0:1;else{var u=a-o;for(s=n;s<l;s+=e)t[s]=(t[s]-o)/u}}return t}var i=t(\"array-bounds\");e.exports=n},{\"array-bounds\":43}],45:[function(t,e,r){\"use strict\";e.exports=function(){function t(t){return!Array.isArray(t)&&null!==t&&\"object\"==typeof t}function e(t,e,r){for(var n=(e-t)/Math.max(r-1,1),i=[],a=0;a<r;a++)i.push(t+a*n);return i}function r(){for(var t=[].slice.call(arguments),e=t.map(function(t){return t.length}),r=Math.min.apply(null,e),n=[],i=0;i<r;i++){n[i]=[];for(var a=0;a<t.length;++a)n[i][a]=t[a][i]}return n}function n(t,e,r){for(var n=Math.min.apply(null,[t.length,e.length,r.length]),i=[],a=0;a<n;a++)i.push([t[a],e[a],r[a]]);return i}function i(t){function e(t){for(var n=0;n<t.length;n++)Array.isArray(t[n])?e(t[n],r):r+=t[n]}var r=0;return e(t,r),r}function a(t){for(var e=[],r=0;r<t.length;++r){e[r]=[];for(var n=0;n<t[r].length;++n)e[r][n]=t[r][n]}return e}function o(t){for(var e=[],r=0;r<t.length;++r)e[r]=t[r];return e}function s(t,e){if(t.length!==e.length)return!1;for(var r=t.length;r--;)if(t[r]!==e[r])return!1;return!0}function l(t,e){var r,n;if(\"string\"!=typeof t)return t;if(r=[],\"#\"===t[0]?(t=t.substr(1),3===t.length&&(t+=t),n=parseInt(t,16),r[0]=n>>16&255,r[1]=n>>8&255,r[2]=255&n):h.test(t)&&(n=t.match(f),r[0]=parseInt(n[1]),r[1]=parseInt(n[2]),r[2]=parseInt(n[3])),!e)for(var i=0;i<3;++i)r[i]=r[i]/255;return r}function u(t,e){var r,n;if(\"string\"!=typeof t)return t;if(r=[],\"#\"===t[0]?(t=t.substr(1),3===t.length&&(t+=t),n=parseInt(t,16),r[0]=n>>16&255,r[1]=n>>8&255,r[2]=255&n):h.test(t)&&(n=t.match(f),r[0]=parseInt(n[1]),r[1]=parseInt(n[2]),r[2]=parseInt(n[3]),n[4]?r[3]=parseFloat(n[4]):r[3]=1),!e)for(var i=0;i<3;++i)r[i]=r[i]/255;return r}var c={},h=/^rgba?\\(\\s*\\d{1,3}\\s*,\\s*\\d{1,3}\\s*,\\s*\\d{1,3}\\s*(,.*)?\\)$/,f=/^rgba?\\(\\s*(\\d{1,3})\\s*,\\s*(\\d{1,3})\\s*,\\s*(\\d{1,3})\\s*,?\\s*(.*)?\\)$/;return c.isPlainObject=t,c.linspace=e,c.zip3=n,c.sum=i,c.zip=r,c.isEqual=s,c.copy2D=a,c.copy1D=o,c.str2RgbArray=l,c.str2RgbaArray=u,c}()},{}],46:[function(t,e,r){(function(r){\"use strict\";function n(t,e){if(t===e)return 0;for(var r=t.length,n=e.length,i=0,a=Math.min(r,n);i<a;++i)if(t[i]!==e[i]){r=t[i],n=e[i];break}return r<n?-1:n<r?1:0}function i(t){return r.Buffer&&\"function\"==typeof r.Buffer.isBuffer?r.Buffer.isBuffer(t):!(null==t||!t._isBuffer)}function a(t){return Object.prototype.toString.call(t)}function o(t){return!i(t)&&(\"function\"==typeof r.ArrayBuffer&&(\"function\"==typeof ArrayBuffer.isView?ArrayBuffer.isView(t):!!t&&(t instanceof DataView||!!(t.buffer&&t.buffer instanceof ArrayBuffer))))}function s(t){if(x.isFunction(t)){if(M)return t.name;var e=t.toString(),r=e.match(A);return r&&r[1]}}function l(t,e){return\"string\"==typeof t?t.length<e?t:t.slice(0,e):t}function u(t){if(M||!x.isFunction(t))return x.inspect(t);var e=s(t);return\"[Function\"+(e?\": \"+e:\"\")+\"]\"}function c(t){return l(u(t.actual),128)+\" \"+t.operator+\" \"+l(u(t.expected),128)}function h(t,e,r,n,i){throw new k.AssertionError({message:r,actual:t,expected:e,operator:n,stackStartFunction:i})}function f(t,e){t||h(t,!0,e,\"==\",k.ok)}function d(t,e,r,s){if(t===e)return!0;if(i(t)&&i(e))return 0===n(t,e);if(x.isDate(t)&&x.isDate(e))return t.getTime()===e.getTime();if(x.isRegExp(t)&&x.isRegExp(e))return t.source===e.source&&t.global===e.global&&t.multiline===e.multiline&&t.lastIndex===e.lastIndex&&t.ignoreCase===e.ignoreCase;if(null!==t&&\"object\"==typeof t||null!==e&&\"object\"==typeof e){if(o(t)&&o(e)&&a(t)===a(e)&&!(t instanceof Float32Array||t instanceof Float64Array))return 0===n(new Uint8Array(t.buffer),new Uint8Array(e.buffer));if(i(t)!==i(e))return!1;s=s||{actual:[],expected:[]};var l=s.actual.indexOf(t);return-1!==l&&l===s.expected.indexOf(e)||(s.actual.push(t),s.expected.push(e),m(t,e,r,s))}return r?t===e:t==e}function p(t){return\"[object Arguments]\"==Object.prototype.toString.call(t)}function m(t,e,r,n){if(null===t||void 0===t||null===e||void 0===e)return!1;if(x.isPrimitive(t)||x.isPrimitive(e))return t===e;if(r&&Object.getPrototypeOf(t)!==Object.getPrototypeOf(e))return!1;var i=p(t),a=p(e);if(i&&!a||!i&&a)return!1;if(i)return t=w.call(t),e=w.call(e),d(t,e,r);var o,s,l=T(t),u=T(e);if(l.length!==u.length)return!1;for(l.sort(),u.sort(),s=l.length-1;s>=0;s--)if(l[s]!==u[s])return!1;for(s=l.length-1;s>=0;s--)if(o=l[s],!d(t[o],e[o],r,n))return!1;return!0}function v(t,e,r){d(t,e,!0)&&h(t,e,r,\"notDeepStrictEqual\",v)}function g(t,e){if(!t||!e)return!1\n",
       ";if(\"[object RegExp]\"==Object.prototype.toString.call(e))return e.test(t);try{if(t instanceof e)return!0}catch(t){}return!Error.isPrototypeOf(e)&&!0===e.call({},t)}function y(t){var e;try{t()}catch(t){e=t}return e}function b(t,e,r,n){var i;if(\"function\"!=typeof e)throw new TypeError('\"block\" argument must be a function');\"string\"==typeof r&&(n=r,r=null),i=y(e),n=(r&&r.name?\" (\"+r.name+\").\":\".\")+(n?\" \"+n:\".\"),t&&!i&&h(i,r,\"Missing expected exception\"+n);var a=\"string\"==typeof n,o=!t&&x.isError(i),s=!t&&i&&!r;if((o&&a&&g(i,r)||s)&&h(i,r,\"Got unwanted exception\"+n),t&&i&&r&&!g(i,r)||!t&&i)throw i}var x=t(\"util/\"),_=Object.prototype.hasOwnProperty,w=Array.prototype.slice,M=function(){return\"foo\"===function(){}.name}(),k=e.exports=f,A=/\\s*function\\s+([^\\(\\s]*)\\s*/;k.AssertionError=function(t){this.name=\"AssertionError\",this.actual=t.actual,this.expected=t.expected,this.operator=t.operator,t.message?(this.message=t.message,this.generatedMessage=!1):(this.message=c(this),this.generatedMessage=!0);var e=t.stackStartFunction||h;if(Error.captureStackTrace)Error.captureStackTrace(this,e);else{var r=new Error;if(r.stack){var n=r.stack,i=s(e),a=n.indexOf(\"\\n\"+i);if(a>=0){var o=n.indexOf(\"\\n\",a+1);n=n.substring(o+1)}this.stack=n}}},x.inherits(k.AssertionError,Error),k.fail=h,k.ok=f,k.equal=function(t,e,r){t!=e&&h(t,e,r,\"==\",k.equal)},k.notEqual=function(t,e,r){t==e&&h(t,e,r,\"!=\",k.notEqual)},k.deepEqual=function(t,e,r){d(t,e,!1)||h(t,e,r,\"deepEqual\",k.deepEqual)},k.deepStrictEqual=function(t,e,r){d(t,e,!0)||h(t,e,r,\"deepStrictEqual\",k.deepStrictEqual)},k.notDeepEqual=function(t,e,r){d(t,e,!1)&&h(t,e,r,\"notDeepEqual\",k.notDeepEqual)},k.notDeepStrictEqual=v,k.strictEqual=function(t,e,r){t!==e&&h(t,e,r,\"===\",k.strictEqual)},k.notStrictEqual=function(t,e,r){t===e&&h(t,e,r,\"!==\",k.notStrictEqual)},k.throws=function(t,e,r){b(!0,t,e,r)},k.doesNotThrow=function(t,e,r){b(!1,t,e,r)},k.ifError=function(t){if(t)throw t};var T=Object.keys||function(t){var e=[];for(var r in t)_.call(t,r)&&e.push(r);return e}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"util/\":548}],47:[function(t,e,r){e.exports=function(t){return atob(t)}},{}],48:[function(t,e,r){\"use strict\";function n(t){for(var e=0,r=0;r<t.length;++r)e+=t[r];return e}function i(t,e){for(var r=e.length,i=new Array(r+1),o=0;o<r;++o){for(var s=new Array(r+1),l=0;l<=r;++l)s[l]=t[l][o];i[o]=s}i[r]=new Array(r+1);for(var o=0;o<=r;++o)i[r][o]=1;for(var u=new Array(r+1),o=0;o<r;++o)u[o]=e[o];u[r]=1;var c=a(i,u),h=n(c[r+1]);0===h&&(h=1);for(var f=new Array(r+1),o=0;o<=r;++o)f[o]=n(c[o])/h;return f}e.exports=i;var a=t(\"robust-linear-solve\")},{\"robust-linear-solve\":506}],49:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]).add(e[0].mul(t[1])),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],50:[function(t,e,r){\"use strict\";function n(t,e){return t[0].mul(e[1]).cmp(e[0].mul(t[1]))}e.exports=n},{}],51:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]),t[1].mul(e[0]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],52:[function(t,e,r){\"use strict\";function n(t,e){if(i(t))return e?u(t,n(e)):[t[0].clone(),t[1].clone()];var r,c,h=0;if(a(t))r=t.clone();else if(\"string\"==typeof t)r=s(t);else{if(0===t)return[o(0),o(1)];if(t===Math.floor(t))r=o(t);else{for(;t!==Math.floor(t);)t*=Math.pow(2,256),h-=256;r=o(t)}}if(i(e))r.mul(e[1]),c=e[0].clone();else if(a(e))c=e.clone();else if(\"string\"==typeof e)c=s(e);else if(e)if(e===Math.floor(e))c=o(e);else{for(;e!==Math.floor(e);)e*=Math.pow(2,256),h+=256;c=o(e)}else c=o(1);return h>0?r=r.ushln(h):h<0&&(c=c.ushln(-h)),l(r,c)}var i=t(\"./is-rat\"),a=t(\"./lib/is-bn\"),o=t(\"./lib/num-to-bn\"),s=t(\"./lib/str-to-bn\"),l=t(\"./lib/rationalize\"),u=t(\"./div\");e.exports=n},{\"./div\":51,\"./is-rat\":53,\"./lib/is-bn\":57,\"./lib/num-to-bn\":58,\"./lib/rationalize\":59,\"./lib/str-to-bn\":60}],53:[function(t,e,r){\"use strict\";function n(t){return Array.isArray(t)&&2===t.length&&i(t[0])&&i(t[1])}var i=t(\"./lib/is-bn\");e.exports=n},{\"./lib/is-bn\":57}],54:[function(t,e,r){\"use strict\";function n(t){return t.cmp(new i(0))}var i=t(\"bn.js\");e.exports=n},{\"bn.js\":67}],55:[function(t,e,r){\"use strict\";function n(t){var e=t.length,r=t.words,n=0;if(1===e)n=r[0];else if(2===e)n=r[0]+67108864*r[1];else for(var a=0;a<e;a++){var o=r[a];n+=o*Math.pow(67108864,a)}return i(t)*n}var i=t(\"./bn-sign\");e.exports=n},{\"./bn-sign\":54}],56:[function(t,e,r){\"use strict\";function n(t){var e=a(i.lo(t));if(e<32)return e;var r=a(i.hi(t));return r>20?52:r+32}var i=t(\"double-bits\"),a=t(\"bit-twiddle\").countTrailingZeros;e.exports=n},{\"bit-twiddle\":66,\"double-bits\":123}],57:[function(t,e,r){\"use strict\";function n(t){return t&&\"object\"==typeof t&&Boolean(t.words)}t(\"bn.js\");e.exports=n},{\"bn.js\":67}],58:[function(t,e,r){\"use strict\";function n(t){var e=a.exponent(t);return e<52?new i(t):new i(t*Math.pow(2,52-e)).ushln(e-52)}var i=t(\"bn.js\"),a=t(\"double-bits\");e.exports=n},{\"bn.js\":67,\"double-bits\":123}],59:[function(t,e,r){\"use strict\";function n(t,e){var r=a(t),n=a(e);if(0===r)return[i(0),i(1)];if(0===n)return[i(0),i(0)];n<0&&(t=t.neg(),e=e.neg());var o=t.gcd(e);return o.cmpn(1)?[t.div(o),e.div(o)]:[t,e]}var i=t(\"./num-to-bn\"),a=t(\"./bn-sign\");e.exports=n},{\"./bn-sign\":54,\"./num-to-bn\":58}],60:[function(t,e,r){\"use strict\";function n(t){return new i(t)}var i=t(\"bn.js\");e.exports=n},{\"bn.js\":67}],61:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[0]),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],62:[function(t,e,r){\"use strict\";function n(t){return i(t[0])*i(t[1])}var i=t(\"./lib/bn-sign\");e.exports=n},{\"./lib/bn-sign\":54}],63:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]).sub(t[1].mul(e[0])),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],64:[function(t,e,r){\"use strict\";function n(t){var e=t[0],r=t[1];if(0===e.cmpn(0))return 0;var n=e.abs().divmod(r.abs()),o=n.div,s=i(o),l=n.mod,u=e.negative!==r.negative?-1:1;if(0===l.cmpn(0))return u*s;if(s){var c=a(s)+4,h=i(l.ushln(c).divRound(r));return u*(s+h*Math.pow(2,-c))}var f=r.bitLength()-l.bitLength()+53,h=i(l.ushln(f).divRound(r));return f<1023?u*h*Math.pow(2,-f):(h*=Math.pow(2,-1023),u*h*Math.pow(2,1023-f))}var i=t(\"./lib/bn-to-num\"),a=t(\"./lib/ctz\");e.exports=n},{\"./lib/bn-to-num\":55,\"./lib/ctz\":56}],65:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){var o=[\"function \",t,\"(a,l,h,\",n.join(\",\"),\"){\",a?\"\":\"var i=\",r?\"l-1\":\"h+1\",\";while(l<=h){var m=(l+h)>>>1,x=a\",i?\".get(m)\":\"[m]\"];return a?e.indexOf(\"c\")<0?o.push(\";if(x===y){return m}else if(x<=y){\"):o.push(\";var p=c(x,y);if(p===0){return m}else if(p<=0){\"):o.push(\";if(\",e,\"){i=m;\"),r?o.push(\"l=m+1}else{h=m-1}\"):o.push(\"h=m-1}else{l=m+1}\"),o.push(\"}\"),a?o.push(\"return -1};\"):o.push(\"return i};\"),o.join(\"\")}function i(t,e,r,i){return new Function([n(\"A\",\"x\"+t+\"y\",e,[\"y\"],!1,i),n(\"B\",\"x\"+t+\"y\",e,[\"y\"],!0,i),n(\"P\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],!1,i),n(\"Q\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],!0,i),\"function dispatchBsearch\",r,\"(a,y,c,l,h){if(a.shape){if(typeof(c)==='function'){return Q(a,(l===undefined)?0:l|0,(h===undefined)?a.shape[0]-1:h|0,y,c)}else{return B(a,(c===undefined)?0:c|0,(l===undefined)?a.shape[0]-1:l|0,y)}}else{if(typeof(c)==='function'){return P(a,(l===undefined)?0:l|0,(h===undefined)?a.length-1:h|0,y,c)}else{return A(a,(c===undefined)?0:c|0,(l===undefined)?a.length-1:l|0,y)}}}return dispatchBsearch\",r].join(\"\"))()}e.exports={ge:i(\">=\",!1,\"GE\"),gt:i(\">\",!1,\"GT\"),lt:i(\"<\",!0,\"LT\"),le:i(\"<=\",!0,\"LE\"),eq:i(\"-\",!0,\"EQ\",!0)}},{}],66:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){var e=32;return t&=-t,t&&e--,65535&t&&(e-=16),16711935&t&&(e-=8),252645135&t&&(e-=4),858993459&t&&(e-=2),1431655765&t&&(e-=1),e}r.INT_BITS=32,r.INT_MAX=2147483647,r.INT_MIN=-1<<31,r.sign=function(t){return(t>0)-(t<0)},r.abs=function(t){var e=t>>31;return(t^e)-e},r.min=function(t,e){return e^(t^e)&-(t<e)},r.max=function(t,e){return t^(t^e)&-(t<e)},r.isPow2=function(t){return!(t&t-1||!t)},r.log2=function(t){var e,r;return e=(t>65535)<<4,t>>>=e,r=(t>255)<<3,t>>>=r,e|=r,r=(t>15)<<2,t>>>=r,e|=r,r=(t>3)<<1,t>>>=r,(e|=r)|t>>1},r.log10=function(t){return t>=1e9?9:t>=1e8?8:t>=1e7?7:t>=1e6?6:t>=1e5?5:t>=1e4?4:t>=1e3?3:t>=100?2:t>=10?1:0},r.popCount=function(t){return t-=t>>>1&1431655765,16843009*((t=(858993459&t)+(t>>>2&858993459))+(t>>>4)&252645135)>>>24},r.countTrailingZeros=n,r.nextPow2=function(t){return t+=0===t,--t,t|=t>>>1,t|=t>>>2,t|=t>>>4,t|=t>>>8,(t|=t>>>16)+1},r.prevPow2=function(t){return t|=t>>>1,t|=t>>>2,t|=t>>>4,t|=t>>>8,(t|=t>>>16)-(t>>>1)},r.parity=function(t){return t^=t>>>16,t^=t>>>8,t^=t>>>4,27030>>>(t&=15)&1};var i=new Array(256);!function(t){for(var e=0;e<256;++e){var r=e,n=e,i=7;for(r>>>=1;r;r>>>=1)n<<=1,n|=1&r,--i;t[e]=n<<i&255}}(i),r.reverse=function(t){return i[255&t]<<24|i[t>>>8&255]<<16|i[t>>>16&255]<<8|i[t>>>24&255]},r.interleave2=function(t,e){return t&=65535,t=16711935&(t|t<<8),t=252645135&(t|t<<4),t=858993459&(t|t<<2),t=1431655765&(t|t<<1),e&=65535,e=16711935&(e|e<<8),e=252645135&(e|e<<4),e=858993459&(e|e<<2),e=1431655765&(e|e<<1),t|e<<1},r.deinterleave2=function(t,e){return t=t>>>e&1431655765,t=858993459&(t|t>>>1),t=252645135&(t|t>>>2),t=16711935&(t|t>>>4),(t=65535&(t|t>>>16))<<16>>16},r.interleave3=function(t,e,r){return t&=1023,t=4278190335&(t|t<<16),t=251719695&(t|t<<8),t=3272356035&(t|t<<4),t=1227133513&(t|t<<2),e&=1023,e=4278190335&(e|e<<16),e=251719695&(e|e<<8),e=3272356035&(e|e<<4),e=1227133513&(e|e<<2),t|=e<<1,r&=1023,r=4278190335&(r|r<<16),r=251719695&(r|r<<8),r=3272356035&(r|r<<4),r=1227133513&(r|r<<2),t|r<<2},r.deinterleave3=function(t,e){return t=t>>>e&1227133513,t=3272356035&(t|t>>>2),t=251719695&(t|t>>>4),t=4278190335&(t|t>>>8),(t=1023&(t|t>>>16))<<22>>22},r.nextCombination=function(t){var e=t|t-1;return e+1|(~e&-~e)-1>>>n(t)+1}},{}],67:[function(t,e,r){!function(e,r){\"use strict\";function n(t,e){if(!t)throw new Error(e||\"Assertion failed\")}function i(t,e){t.super_=e;var r=function(){};r.prototype=e.prototype,t.prototype=new r,t.prototype.constructor=t}function a(t,e,r){if(a.isBN(t))return t;this.negative=0,this.words=null,this.length=0,this.red=null,null!==t&&(\"le\"!==e&&\"be\"!==e||(r=e,e=10),this._init(t||0,e||10,r||\"be\"))}function o(t,e,r){for(var n=0,i=Math.min(t.length,r),a=e;a<i;a++){var o=t.charCodeAt(a)-48;n<<=4,n|=o>=49&&o<=54?o-49+10:o>=17&&o<=22?o-17+10:15&o}return n}function s(t,e,r,n){for(var i=0,a=Math.min(t.length,r),o=e;o<a;o++){var s=t.charCodeAt(o)-48;i*=n,i+=s>=49?s-49+10:s>=17?s-17+10:s}return i}function l(t){for(var e=new Array(t.bitLength()),r=0;r<e.length;r++){var n=r/26|0,i=r%26;e[r]=(t.words[n]&1<<i)>>>i}return e}function u(t,e,r){r.negative=e.negative^t.negative;var n=t.length+e.length|0;r.length=n,n=n-1|0;var i=0|t.words[0],a=0|e.words[0],o=i*a,s=67108863&o,l=o/67108864|0;r.words[0]=s;for(var u=1;u<n;u++){for(var c=l>>>26,h=67108863&l,f=Math.min(u,e.length-1),d=Math.max(0,u-t.length+1);d<=f;d++){var p=u-d|0;i=0|t.words[p],a=0|e.words[d],o=i*a+h,c+=o/67108864|0,h=67108863&o}r.words[u]=0|h,l=0|c}return 0!==l?r.words[u]=0|l:r.length--,r.strip()}function c(t,e,r){r.negative=e.negative^t.negative,r.length=t.length+e.length;for(var n=0,i=0,a=0;a<r.length-1;a++){var o=i;i=0;for(var s=67108863&n,l=Math.min(a,e.length-1),u=Math.max(0,a-t.length+1);u<=l;u++){var c=a-u,h=0|t.words[c],f=0|e.words[u],d=h*f,p=67108863&d;o=o+(d/67108864|0)|0,p=p+s|0,s=67108863&p,o=o+(p>>>26)|0,i+=o>>>26,o&=67108863}r.words[a]=s,n=o,o=i}return 0!==n?r.words[a]=n:r.length--,r.strip()}function h(t,e,r){return(new f).mulp(t,e,r)}function f(t,e){this.x=t,this.y=e}function d(t,e){this.name=t,this.p=new a(e,16),this.n=this.p.bitLength(),this.k=new a(1).iushln(this.n).isub(this.p),this.tmp=this._tmp()}function p(){d.call(this,\"k256\",\"ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f\")}function m(){d.call(this,\"p224\",\"ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001\")}function v(){d.call(this,\"p192\",\"ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff\")}function g(){d.call(this,\"25519\",\"7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed\")}function y(t){if(\"string\"==typeof t){var e=a._prime(t);this.m=e.p,this.prime=e}else n(t.gtn(1),\"modulus must be greater than 1\"),this.m=t,this.prime=null}function b(t){y.call(this,t),this.shift=this.m.bitLength(),this.shift%26!=0&&(this.shift+=26-this.shift%26),this.r=new a(1).iushln(this.shift),this.r2=this.imod(this.r.sqr()),this.rinv=this.r._invmp(this.m),this.minv=this.rinv.mul(this.r).isubn(1).div(this.m),this.minv=this.minv.umod(this.r),this.minv=this.r.sub(this.minv)}\"object\"==typeof e?e.exports=a:r.BN=a,a.BN=a,a.wordSize=26;var x;try{x=t(\"buffer\").Buffer}catch(t){}a.isBN=function(t){return t instanceof a||null!==t&&\"object\"==typeof t&&t.constructor.wordSize===a.wordSize&&Array.isArray(t.words)},a.max=function(t,e){return t.cmp(e)>0?t:e},a.min=function(t,e){return t.cmp(e)<0?t:e},a.prototype._init=function(t,e,r){if(\"number\"==typeof t)return this._initNumber(t,e,r);if(\"object\"==typeof t)return this._initArray(t,e,r);\"hex\"===e&&(e=16),n(e===(0|e)&&e>=2&&e<=36),t=t.toString().replace(/\\s+/g,\"\");var i=0;\"-\"===t[0]&&i++,16===e?this._parseHex(t,i):this._parseBase(t,e,i),\"-\"===t[0]&&(this.negative=1),this.strip(),\"le\"===r&&this._initArray(this.toArray(),e,r)},a.prototype._initNumber=function(t,e,r){t<0&&(this.negative=1,t=-t),t<67108864?(this.words=[67108863&t],this.length=1):t<4503599627370496?(this.words=[67108863&t,t/67108864&67108863],this.length=2):(n(t<9007199254740992),this.words=[67108863&t,t/67108864&67108863,1],this.length=3),\"le\"===r&&this._initArray(this.toArray(),e,r)},a.prototype._initArray=function(t,e,r){if(n(\"number\"==typeof t.length),t.length<=0)return this.words=[0],this.length=1,this;this.length=Math.ceil(t.length/3),this.words=new Array(this.length);for(var i=0;i<this.length;i++)this.words[i]=0;var a,o,s=0;if(\"be\"===r)for(i=t.length-1,a=0;i>=0;i-=3)o=t[i]|t[i-1]<<8|t[i-2]<<16,this.words[a]|=o<<s&67108863,this.words[a+1]=o>>>26-s&67108863,(s+=24)>=26&&(s-=26,a++);else if(\"le\"===r)for(i=0,a=0;i<t.length;i+=3)o=t[i]|t[i+1]<<8|t[i+2]<<16,this.words[a]|=o<<s&67108863,this.words[a+1]=o>>>26-s&67108863,(s+=24)>=26&&(s-=26,a++);return this.strip()},a.prototype._parseHex=function(t,e){this.length=Math.ceil((t.length-e)/6),this.words=new Array(this.length);for(var r=0;r<this.length;r++)this.words[r]=0;var n,i,a=0;for(r=t.length-6,n=0;r>=e;r-=6)i=o(t,r,r+6),this.words[n]|=i<<a&67108863,this.words[n+1]|=i>>>26-a&4194303,(a+=24)>=26&&(a-=26,n++);r+6!==e&&(i=o(t,e,r+6),this.words[n]|=i<<a&67108863,this.words[n+1]|=i>>>26-a&4194303),this.strip()},a.prototype._parseBase=function(t,e,r){this.words=[0],this.length=1;for(var n=0,i=1;i<=67108863;i*=e)n++;n--,i=i/e|0;for(var a=t.length-r,o=a%n,l=Math.min(a,a-o)+r,u=0,c=r;c<l;c+=n)u=s(t,c,c+n,e),this.imuln(i),this.words[0]+u<67108864?this.words[0]+=u:this._iaddn(u);if(0!==o){var h=1;for(u=s(t,c,t.length,e),c=0;c<o;c++)h*=e;this.imuln(h),this.words[0]+u<67108864?this.words[0]+=u:this._iaddn(u)}},a.prototype.copy=function(t){t.words=new Array(this.length);for(var e=0;e<this.length;e++)t.words[e]=this.words[e];t.length=this.length,t.negative=this.negative,t.red=this.red},a.prototype.clone=function(){var t=new a(null);return this.copy(t),t},a.prototype._expand=function(t){for(;this.length<t;)this.words[this.length++]=0;return this},a.prototype.strip=function(){for(;this.length>1&&0===this.words[this.length-1];)this.length--;return this._normSign()},a.prototype._normSign=function(){return 1===this.length&&0===this.words[0]&&(this.negative=0),this},a.prototype.inspect=function(){return(this.red?\"<BN-R: \":\"<BN: \")+this.toString(16)+\">\"};var _=[\"\",\"0\",\"00\",\"000\",\"0000\",\"00000\",\"000000\",\"0000000\",\"00000000\",\"000000000\",\"0000000000\",\"00000000000\",\"000000000000\",\"0000000000000\",\"00000000000000\",\"000000000000000\",\"0000000000000000\",\"00000000000000000\",\"000000000000000000\",\"0000000000000000000\",\"00000000000000000000\",\"000000000000000000000\",\"0000000000000000000000\",\"00000000000000000000000\",\"000000000000000000000000\",\"0000000000000000000000000\"],w=[0,0,25,16,12,11,10,9,8,8,7,7,7,7,6,6,6,6,6,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5],M=[0,0,33554432,43046721,16777216,48828125,60466176,40353607,16777216,43046721,1e7,19487171,35831808,62748517,7529536,11390625,16777216,24137569,34012224,47045881,64e6,4084101,5153632,6436343,7962624,9765625,11881376,14348907,17210368,20511149,243e5,28629151,33554432,39135393,45435424,52521875,60466176];a.prototype.toString=function(t,e){t=t||10,e=0|e||1;var r;if(16===t||\"hex\"===t){r=\"\";for(var i=0,a=0,o=0;o<this.length;o++){var s=this.words[o],l=(16777215&(s<<i|a)).toString(16);a=s>>>24-i&16777215,r=0!==a||o!==this.length-1?_[6-l.length]+l+r:l+r,i+=2,i>=26&&(i-=26,o--)}for(0!==a&&(r=a.toString(16)+r);r.length%e!=0;)r=\"0\"+r;return 0!==this.negative&&(r=\"-\"+r),r}if(t===(0|t)&&t>=2&&t<=36){var u=w[t],c=M[t];r=\"\";var h=this.clone();for(h.negative=0;!h.isZero();){var f=h.modn(c).toString(t);h=h.idivn(c),r=h.isZero()?f+r:_[u-f.length]+f+r}for(this.isZero()&&(r=\"0\"+r);r.length%e!=0;)r=\"0\"+r;return 0!==this.negative&&(r=\"-\"+r),r}n(!1,\"Base should be between 2 and 36\")},a.prototype.toNumber=function(){var t=this.words[0];return 2===this.length?t+=67108864*this.words[1]:3===this.length&&1===this.words[2]?t+=4503599627370496+67108864*this.words[1]:this.length>2&&n(!1,\"Number can only safely store up to 53 bits\"),0!==this.negative?-t:t},a.prototype.toJSON=function(){return this.toString(16)},a.prototype.toBuffer=function(t,e){return n(void 0!==x),this.toArrayLike(x,t,e)},a.prototype.toArray=function(t,e){return this.toArrayLike(Array,t,e)},a.prototype.toArrayLike=function(t,e,r){var i=this.byteLength(),a=r||Math.max(1,i);n(i<=a,\"byte array longer than desired length\"),n(a>0,\"Requested array length <= 0\"),this.strip();var o,s,l=\"le\"===e,u=new t(a),c=this.clone();if(l){for(s=0;!c.isZero();s++)o=c.andln(255),c.iushrn(8),u[s]=o;for(;s<a;s++)u[s]=0}else{for(s=0;s<a-i;s++)u[s]=0;for(s=0;!c.isZero();s++)o=c.andln(255),c.iushrn(8),u[a-s-1]=o}return u},Math.clz32?a.prototype._countBits=function(t){return 32-Math.clz32(t)}:a.prototype._countBits=function(t){var e=t,r=0;return e>=4096&&(r+=13,e>>>=13),e>=64&&(r+=7,e>>>=7),e>=8&&(r+=4,e>>>=4),e>=2&&(r+=2,e>>>=2),r+e},a.prototype._zeroBits=function(t){if(0===t)return 26;var e=t,r=0;return 0==(8191&e)&&(r+=13,e>>>=13),0==(127&e)&&(r+=7,e>>>=7),0==(15&e)&&(r+=4,e>>>=4),0==(3&e)&&(r+=2,e>>>=2),0==(1&e)&&r++,r},a.prototype.bitLength=function(){var t=this.words[this.length-1],e=this._countBits(t);return 26*(this.length-1)+e},a.prototype.zeroBits=function(){if(this.isZero())return 0;for(var t=0,e=0;e<this.length;e++){var r=this._zeroBits(this.words[e]);if(t+=r,26!==r)break}return t},a.prototype.byteLength=function(){return Math.ceil(this.bitLength()/8)},a.prototype.toTwos=function(t){return 0!==this.negative?this.abs().inotn(t).iaddn(1):this.clone()},a.prototype.fromTwos=function(t){return this.testn(t-1)?this.notn(t).iaddn(1).ineg():this.clone()},a.prototype.isNeg=function(){return 0!==this.negative},a.prototype.neg=function(){return this.clone().ineg()},a.prototype.ineg=function(){return this.isZero()||(this.negative^=1),this},a.prototype.iuor=function(t){for(;this.length<t.length;)this.words[this.length++]=0;for(var e=0;e<t.length;e++)this.words[e]=this.words[e]|t.words[e];return this.strip()},a.prototype.ior=function(t){return n(0==(this.negative|t.negative)),this.iuor(t)},a.prototype.or=function(t){return this.length>t.length?this.clone().ior(t):t.clone().ior(this)},a.prototype.uor=function(t){return this.length>t.length?this.clone().iuor(t):t.clone().iuor(this)},a.prototype.iuand=function(t){var e;e=this.length>t.length?t:this;for(var r=0;r<e.length;r++)this.words[r]=this.words[r]&t.words[r];return this.length=e.length,this.strip()},a.prototype.iand=function(t){return n(0==(this.negative|t.negative)),this.iuand(t)},a.prototype.and=function(t){return this.length>t.length?this.clone().iand(t):t.clone().iand(this)},a.prototype.uand=function(t){return this.length>t.length?this.clone().iuand(t):t.clone().iuand(this)},a.prototype.iuxor=function(t){var e,r;this.length>t.length?(e=this,r=t):(e=t,r=this);for(var n=0;n<r.length;n++)this.words[n]=e.words[n]^r.words[n];if(this!==e)for(;n<e.length;n++)this.words[n]=e.words[n];return this.length=e.length,this.strip()},a.prototype.ixor=function(t){return n(0==(this.negative|t.negative)),this.iuxor(t)},a.prototype.xor=function(t){return this.length>t.length?this.clone().ixor(t):t.clone().ixor(this)},a.prototype.uxor=function(t){return this.length>t.length?this.clone().iuxor(t):t.clone().iuxor(this)},a.prototype.inotn=function(t){n(\"number\"==typeof t&&t>=0);var e=0|Math.ceil(t/26),r=t%26;this._expand(e),r>0&&e--;for(var i=0;i<e;i++)this.words[i]=67108863&~this.words[i];return r>0&&(this.words[i]=~this.words[i]&67108863>>26-r),this.strip()},a.prototype.notn=function(t){return this.clone().inotn(t)},a.prototype.setn=function(t,e){n(\"number\"==typeof t&&t>=0);var r=t/26|0,i=t%26;return this._expand(r+1),this.words[r]=e?this.words[r]|1<<i:this.words[r]&~(1<<i),this.strip()},a.prototype.iadd=function(t){var e;if(0!==this.negative&&0===t.negative)return this.negative=0,e=this.isub(t),this.negative^=1,this._normSign();if(0===this.negative&&0!==t.negative)return t.negative=0,e=this.isub(t),t.negative=1,e._normSign();var r,n;this.length>t.length?(r=this,n=t):(r=t,n=this);for(var i=0,a=0;a<n.length;a++)e=(0|r.words[a])+(0|n.words[a])+i,this.words[a]=67108863&e,i=e>>>26;for(;0!==i&&a<r.length;a++)e=(0|r.words[a])+i,this.words[a]=67108863&e,i=e>>>26;if(this.length=r.length,0!==i)this.words[this.length]=i,this.length++;else if(r!==this)for(;a<r.length;a++)this.words[a]=r.words[a];return this},a.prototype.add=function(t){var e;return 0!==t.negative&&0===this.negative?(t.negative=0,e=this.sub(t),t.negative^=1,e):0===t.negative&&0!==this.negative?(this.negative=0,e=t.sub(this),this.negative=1,e):this.length>t.length?this.clone().iadd(t):t.clone().iadd(this)},a.prototype.isub=function(t){if(0!==t.negative){t.negative=0;var e=this.iadd(t);return t.negative=1,e._normSign()}if(0!==this.negative)return this.negative=0,this.iadd(t),this.negative=1,this._normSign();var r=this.cmp(t);if(0===r)return this.negative=0,this.length=1,this.words[0]=0,this;var n,i;r>0?(n=this,i=t):(n=t,i=this);for(var a=0,o=0;o<i.length;o++)e=(0|n.words[o])-(0|i.words[o])+a,a=e>>26,this.words[o]=67108863&e;for(;0!==a&&o<n.length;o++)e=(0|n.words[o])+a,a=e>>26,this.words[o]=67108863&e;if(0===a&&o<n.length&&n!==this)for(;o<n.length;o++)this.words[o]=n.words[o];return this.length=Math.max(this.length,o),n!==this&&(this.negative=1),this.strip()},a.prototype.sub=function(t){return this.clone().isub(t)};var k=function(t,e,r){var n,i,a,o=t.words,s=e.words,l=r.words,u=0,c=0|o[0],h=8191&c,f=c>>>13,d=0|o[1],p=8191&d,m=d>>>13,v=0|o[2],g=8191&v,y=v>>>13,b=0|o[3],x=8191&b,_=b>>>13,w=0|o[4],M=8191&w,k=w>>>13,A=0|o[5],T=8191&A,S=A>>>13,E=0|o[6],L=8191&E,C=E>>>13,z=0|o[7],I=8191&z,D=z>>>13,P=0|o[8],O=8191&P,R=P>>>13,F=0|o[9],j=8191&F,N=F>>>13,B=0|s[0],U=8191&B,V=B>>>13,H=0|s[1],q=8191&H,G=H>>>13,Y=0|s[2],X=8191&Y,W=Y>>>13,Z=0|s[3],J=8191&Z,K=Z>>>13,Q=0|s[4],$=8191&Q,tt=Q>>>13,et=0|s[5],rt=8191&et,nt=et>>>13,it=0|s[6],at=8191&it,ot=it>>>13,st=0|s[7],lt=8191&st,ut=st>>>13,ct=0|s[8],ht=8191&ct,ft=ct>>>13,dt=0|s[9],pt=8191&dt,mt=dt>>>13;r.negative=t.negative^e.negative,r.length=19,n=Math.imul(h,U),i=Math.imul(h,V),i=i+Math.imul(f,U)|0,a=Math.imul(f,V);var vt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(vt>>>26)|0,vt&=67108863,n=Math.imul(p,U),i=Math.imul(p,V),i=i+Math.imul(m,U)|0,a=Math.imul(m,V),n=n+Math.imul(h,q)|0,i=i+Math.imul(h,G)|0,i=i+Math.imul(f,q)|0,a=a+Math.imul(f,G)|0;var gt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(gt>>>26)|0,gt&=67108863,n=Math.imul(g,U),i=Math.imul(g,V),i=i+Math.imul(y,U)|0,a=Math.imul(y,V),n=n+Math.imul(p,q)|0,i=i+Math.imul(p,G)|0,i=i+Math.imul(m,q)|0,a=a+Math.imul(m,G)|0,n=n+Math.imul(h,X)|0,i=i+Math.imul(h,W)|0,i=i+Math.imul(f,X)|0,a=a+Math.imul(f,W)|0;var yt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(yt>>>26)|0,yt&=67108863,n=Math.imul(x,U),i=Math.imul(x,V),i=i+Math.imul(_,U)|0,a=Math.imul(_,V),n=n+Math.imul(g,q)|0,i=i+Math.imul(g,G)|0,i=i+Math.imul(y,q)|0,a=a+Math.imul(y,G)|0,n=n+Math.imul(p,X)|0,i=i+Math.imul(p,W)|0,i=i+Math.imul(m,X)|0,a=a+Math.imul(m,W)|0,n=n+Math.imul(h,J)|0,i=i+Math.imul(h,K)|0,i=i+Math.imul(f,J)|0,a=a+Math.imul(f,K)|0;var bt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(bt>>>26)|0,bt&=67108863,n=Math.imul(M,U),i=Math.imul(M,V),i=i+Math.imul(k,U)|0,a=Math.imul(k,V),n=n+Math.imul(x,q)|0,i=i+Math.imul(x,G)|0,i=i+Math.imul(_,q)|0,a=a+Math.imul(_,G)|0,n=n+Math.imul(g,X)|0,i=i+Math.imul(g,W)|0,i=i+Math.imul(y,X)|0,a=a+Math.imul(y,W)|0,n=n+Math.imul(p,J)|0,i=i+Math.imul(p,K)|0,i=i+Math.imul(m,J)|0,a=a+Math.imul(m,K)|0,n=n+Math.imul(h,$)|0,i=i+Math.imul(h,tt)|0,i=i+Math.imul(f,$)|0,a=a+Math.imul(f,tt)|0;var xt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(xt>>>26)|0,xt&=67108863,n=Math.imul(T,U),i=Math.imul(T,V),i=i+Math.imul(S,U)|0,a=Math.imul(S,V),n=n+Math.imul(M,q)|0,i=i+Math.imul(M,G)|0,i=i+Math.imul(k,q)|0,a=a+Math.imul(k,G)|0,n=n+Math.imul(x,X)|0,i=i+Math.imul(x,W)|0,i=i+Math.imul(_,X)|0,a=a+Math.imul(_,W)|0,n=n+Math.imul(g,J)|0,i=i+Math.imul(g,K)|0,i=i+Math.imul(y,J)|0,a=a+Math.imul(y,K)|0,n=n+Math.imul(p,$)|0,i=i+Math.imul(p,tt)|0,i=i+Math.imul(m,$)|0,a=a+Math.imul(m,tt)|0,n=n+Math.imul(h,rt)|0,i=i+Math.imul(h,nt)|0,i=i+Math.imul(f,rt)|0,a=a+Math.imul(f,nt)|0;var _t=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(_t>>>26)|0,_t&=67108863,n=Math.imul(L,U),i=Math.imul(L,V),i=i+Math.imul(C,U)|0,a=Math.imul(C,V),n=n+Math.imul(T,q)|0,i=i+Math.imul(T,G)|0,i=i+Math.imul(S,q)|0,a=a+Math.imul(S,G)|0,n=n+Math.imul(M,X)|0,i=i+Math.imul(M,W)|0,i=i+Math.imul(k,X)|0,a=a+Math.imul(k,W)|0,n=n+Math.imul(x,J)|0,i=i+Math.imul(x,K)|0,i=i+Math.imul(_,J)|0,a=a+Math.imul(_,K)|0,n=n+Math.imul(g,$)|0,i=i+Math.imul(g,tt)|0,i=i+Math.imul(y,$)|0,a=a+Math.imul(y,tt)|0,n=n+Math.imul(p,rt)|0,i=i+Math.imul(p,nt)|0,i=i+Math.imul(m,rt)|0,a=a+Math.imul(m,nt)|0,n=n+Math.imul(h,at)|0,i=i+Math.imul(h,ot)|0,i=i+Math.imul(f,at)|0,a=a+Math.imul(f,ot)|0;var wt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(wt>>>26)|0,wt&=67108863,n=Math.imul(I,U),i=Math.imul(I,V),i=i+Math.imul(D,U)|0,a=Math.imul(D,V),n=n+Math.imul(L,q)|0,i=i+Math.imul(L,G)|0,i=i+Math.imul(C,q)|0,a=a+Math.imul(C,G)|0,n=n+Math.imul(T,X)|0,i=i+Math.imul(T,W)|0,i=i+Math.imul(S,X)|0,a=a+Math.imul(S,W)|0,n=n+Math.imul(M,J)|0,i=i+Math.imul(M,K)|0,i=i+Math.imul(k,J)|0,a=a+Math.imul(k,K)|0,n=n+Math.imul(x,$)|0,i=i+Math.imul(x,tt)|0,i=i+Math.imul(_,$)|0,a=a+Math.imul(_,tt)|0,n=n+Math.imul(g,rt)|0,i=i+Math.imul(g,nt)|0,i=i+Math.imul(y,rt)|0,a=a+Math.imul(y,nt)|0,n=n+Math.imul(p,at)|0,i=i+Math.imul(p,ot)|0,i=i+Math.imul(m,at)|0,a=a+Math.imul(m,ot)|0,n=n+Math.imul(h,lt)|0,i=i+Math.imul(h,ut)|0,i=i+Math.imul(f,lt)|0,a=a+Math.imul(f,ut)|0;var Mt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Mt>>>26)|0,Mt&=67108863,n=Math.imul(O,U),i=Math.imul(O,V),i=i+Math.imul(R,U)|0,a=Math.imul(R,V),n=n+Math.imul(I,q)|0,i=i+Math.imul(I,G)|0,i=i+Math.imul(D,q)|0,a=a+Math.imul(D,G)|0,n=n+Math.imul(L,X)|0,i=i+Math.imul(L,W)|0,i=i+Math.imul(C,X)|0,a=a+Math.imul(C,W)|0,n=n+Math.imul(T,J)|0,i=i+Math.imul(T,K)|0,i=i+Math.imul(S,J)|0,a=a+Math.imul(S,K)|0,n=n+Math.imul(M,$)|0,i=i+Math.imul(M,tt)|0,i=i+Math.imul(k,$)|0,a=a+Math.imul(k,tt)|0,n=n+Math.imul(x,rt)|0,i=i+Math.imul(x,nt)|0,i=i+Math.imul(_,rt)|0,a=a+Math.imul(_,nt)|0,n=n+Math.imul(g,at)|0,i=i+Math.imul(g,ot)|0,i=i+Math.imul(y,at)|0,a=a+Math.imul(y,ot)|0,n=n+Math.imul(p,lt)|0,i=i+Math.imul(p,ut)|0,i=i+Math.imul(m,lt)|0,a=a+Math.imul(m,ut)|0,n=n+Math.imul(h,ht)|0,i=i+Math.imul(h,ft)|0,i=i+Math.imul(f,ht)|0,a=a+Math.imul(f,ft)|0;var kt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(kt>>>26)|0,kt&=67108863,n=Math.imul(j,U),i=Math.imul(j,V),i=i+Math.imul(N,U)|0,a=Math.imul(N,V),n=n+Math.imul(O,q)|0,i=i+Math.imul(O,G)|0,i=i+Math.imul(R,q)|0,a=a+Math.imul(R,G)|0,n=n+Math.imul(I,X)|0,i=i+Math.imul(I,W)|0,i=i+Math.imul(D,X)|0,a=a+Math.imul(D,W)|0,n=n+Math.imul(L,J)|0,i=i+Math.imul(L,K)|0,i=i+Math.imul(C,J)|0,a=a+Math.imul(C,K)|0,n=n+Math.imul(T,$)|0,i=i+Math.imul(T,tt)|0,i=i+Math.imul(S,$)|0,a=a+Math.imul(S,tt)|0,n=n+Math.imul(M,rt)|0,i=i+Math.imul(M,nt)|0,i=i+Math.imul(k,rt)|0,a=a+Math.imul(k,nt)|0,n=n+Math.imul(x,at)|0,i=i+Math.imul(x,ot)|0,i=i+Math.imul(_,at)|0,a=a+Math.imul(_,ot)|0,n=n+Math.imul(g,lt)|0,i=i+Math.imul(g,ut)|0,i=i+Math.imul(y,lt)|0,a=a+Math.imul(y,ut)|0,n=n+Math.imul(p,ht)|0,i=i+Math.imul(p,ft)|0,i=i+Math.imul(m,ht)|0,a=a+Math.imul(m,ft)|0,n=n+Math.imul(h,pt)|0,i=i+Math.imul(h,mt)|0,i=i+Math.imul(f,pt)|0,a=a+Math.imul(f,mt)|0;var At=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(At>>>26)|0,At&=67108863,n=Math.imul(j,q),i=Math.imul(j,G),i=i+Math.imul(N,q)|0,a=Math.imul(N,G),n=n+Math.imul(O,X)|0,i=i+Math.imul(O,W)|0,i=i+Math.imul(R,X)|0,a=a+Math.imul(R,W)|0,n=n+Math.imul(I,J)|0,i=i+Math.imul(I,K)|0,i=i+Math.imul(D,J)|0,a=a+Math.imul(D,K)|0,n=n+Math.imul(L,$)|0,i=i+Math.imul(L,tt)|0,i=i+Math.imul(C,$)|0,a=a+Math.imul(C,tt)|0,n=n+Math.imul(T,rt)|0,i=i+Math.imul(T,nt)|0,i=i+Math.imul(S,rt)|0,a=a+Math.imul(S,nt)|0,n=n+Math.imul(M,at)|0,i=i+Math.imul(M,ot)|0,i=i+Math.imul(k,at)|0,a=a+Math.imul(k,ot)|0,n=n+Math.imul(x,lt)|0,i=i+Math.imul(x,ut)|0,i=i+Math.imul(_,lt)|0,a=a+Math.imul(_,ut)|0,n=n+Math.imul(g,ht)|0,i=i+Math.imul(g,ft)|0,i=i+Math.imul(y,ht)|0,a=a+Math.imul(y,ft)|0,n=n+Math.imul(p,pt)|0,i=i+Math.imul(p,mt)|0,i=i+Math.imul(m,pt)|0,a=a+Math.imul(m,mt)|0;var Tt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Tt>>>26)|0,Tt&=67108863,n=Math.imul(j,X),i=Math.imul(j,W),i=i+Math.imul(N,X)|0,a=Math.imul(N,W),n=n+Math.imul(O,J)|0,i=i+Math.imul(O,K)|0,i=i+Math.imul(R,J)|0,a=a+Math.imul(R,K)|0,n=n+Math.imul(I,$)|0,i=i+Math.imul(I,tt)|0,i=i+Math.imul(D,$)|0,a=a+Math.imul(D,tt)|0,n=n+Math.imul(L,rt)|0,i=i+Math.imul(L,nt)|0,i=i+Math.imul(C,rt)|0,a=a+Math.imul(C,nt)|0,n=n+Math.imul(T,at)|0,i=i+Math.imul(T,ot)|0,i=i+Math.imul(S,at)|0,a=a+Math.imul(S,ot)|0,n=n+Math.imul(M,lt)|0,i=i+Math.imul(M,ut)|0,i=i+Math.imul(k,lt)|0,a=a+Math.imul(k,ut)|0,n=n+Math.imul(x,ht)|0,i=i+Math.imul(x,ft)|0,i=i+Math.imul(_,ht)|0,a=a+Math.imul(_,ft)|0,n=n+Math.imul(g,pt)|0,i=i+Math.imul(g,mt)|0,i=i+Math.imul(y,pt)|0,a=a+Math.imul(y,mt)|0;var St=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(St>>>26)|0,St&=67108863,n=Math.imul(j,J),i=Math.imul(j,K),i=i+Math.imul(N,J)|0,a=Math.imul(N,K),n=n+Math.imul(O,$)|0,i=i+Math.imul(O,tt)|0,i=i+Math.imul(R,$)|0,a=a+Math.imul(R,tt)|0,n=n+Math.imul(I,rt)|0,i=i+Math.imul(I,nt)|0,i=i+Math.imul(D,rt)|0,a=a+Math.imul(D,nt)|0,n=n+Math.imul(L,at)|0,i=i+Math.imul(L,ot)|0,i=i+Math.imul(C,at)|0,a=a+Math.imul(C,ot)|0,n=n+Math.imul(T,lt)|0,i=i+Math.imul(T,ut)|0,i=i+Math.imul(S,lt)|0,a=a+Math.imul(S,ut)|0,n=n+Math.imul(M,ht)|0,i=i+Math.imul(M,ft)|0,i=i+Math.imul(k,ht)|0,a=a+Math.imul(k,ft)|0,n=n+Math.imul(x,pt)|0,i=i+Math.imul(x,mt)|0,i=i+Math.imul(_,pt)|0,a=a+Math.imul(_,mt)|0;var Et=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Et>>>26)|0,Et&=67108863,n=Math.imul(j,$),i=Math.imul(j,tt),i=i+Math.imul(N,$)|0,a=Math.imul(N,tt),n=n+Math.imul(O,rt)|0,i=i+Math.imul(O,nt)|0,i=i+Math.imul(R,rt)|0,a=a+Math.imul(R,nt)|0,n=n+Math.imul(I,at)|0,i=i+Math.imul(I,ot)|0,i=i+Math.imul(D,at)|0,a=a+Math.imul(D,ot)|0,n=n+Math.imul(L,lt)|0,i=i+Math.imul(L,ut)|0,i=i+Math.imul(C,lt)|0,a=a+Math.imul(C,ut)|0,n=n+Math.imul(T,ht)|0,i=i+Math.imul(T,ft)|0,i=i+Math.imul(S,ht)|0,a=a+Math.imul(S,ft)|0,n=n+Math.imul(M,pt)|0,i=i+Math.imul(M,mt)|0,i=i+Math.imul(k,pt)|0,a=a+Math.imul(k,mt)|0;var Lt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Lt>>>26)|0,Lt&=67108863,n=Math.imul(j,rt),i=Math.imul(j,nt),i=i+Math.imul(N,rt)|0,a=Math.imul(N,nt),n=n+Math.imul(O,at)|0,i=i+Math.imul(O,ot)|0,i=i+Math.imul(R,at)|0,a=a+Math.imul(R,ot)|0,n=n+Math.imul(I,lt)|0,i=i+Math.imul(I,ut)|0,i=i+Math.imul(D,lt)|0,a=a+Math.imul(D,ut)|0,n=n+Math.imul(L,ht)|0,i=i+Math.imul(L,ft)|0,i=i+Math.imul(C,ht)|0,a=a+Math.imul(C,ft)|0,n=n+Math.imul(T,pt)|0,i=i+Math.imul(T,mt)|0,\n",
       "i=i+Math.imul(S,pt)|0,a=a+Math.imul(S,mt)|0;var Ct=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Ct>>>26)|0,Ct&=67108863,n=Math.imul(j,at),i=Math.imul(j,ot),i=i+Math.imul(N,at)|0,a=Math.imul(N,ot),n=n+Math.imul(O,lt)|0,i=i+Math.imul(O,ut)|0,i=i+Math.imul(R,lt)|0,a=a+Math.imul(R,ut)|0,n=n+Math.imul(I,ht)|0,i=i+Math.imul(I,ft)|0,i=i+Math.imul(D,ht)|0,a=a+Math.imul(D,ft)|0,n=n+Math.imul(L,pt)|0,i=i+Math.imul(L,mt)|0,i=i+Math.imul(C,pt)|0,a=a+Math.imul(C,mt)|0;var zt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(zt>>>26)|0,zt&=67108863,n=Math.imul(j,lt),i=Math.imul(j,ut),i=i+Math.imul(N,lt)|0,a=Math.imul(N,ut),n=n+Math.imul(O,ht)|0,i=i+Math.imul(O,ft)|0,i=i+Math.imul(R,ht)|0,a=a+Math.imul(R,ft)|0,n=n+Math.imul(I,pt)|0,i=i+Math.imul(I,mt)|0,i=i+Math.imul(D,pt)|0,a=a+Math.imul(D,mt)|0;var It=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(It>>>26)|0,It&=67108863,n=Math.imul(j,ht),i=Math.imul(j,ft),i=i+Math.imul(N,ht)|0,a=Math.imul(N,ft),n=n+Math.imul(O,pt)|0,i=i+Math.imul(O,mt)|0,i=i+Math.imul(R,pt)|0,a=a+Math.imul(R,mt)|0;var Dt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Dt>>>26)|0,Dt&=67108863,n=Math.imul(j,pt),i=Math.imul(j,mt),i=i+Math.imul(N,pt)|0,a=Math.imul(N,mt);var Pt=(u+n|0)+((8191&i)<<13)|0;return u=(a+(i>>>13)|0)+(Pt>>>26)|0,Pt&=67108863,l[0]=vt,l[1]=gt,l[2]=yt,l[3]=bt,l[4]=xt,l[5]=_t,l[6]=wt,l[7]=Mt,l[8]=kt,l[9]=At,l[10]=Tt,l[11]=St,l[12]=Et,l[13]=Lt,l[14]=Ct,l[15]=zt,l[16]=It,l[17]=Dt,l[18]=Pt,0!==u&&(l[19]=u,r.length++),r};Math.imul||(k=u),a.prototype.mulTo=function(t,e){var r=this.length+t.length;return 10===this.length&&10===t.length?k(this,t,e):r<63?u(this,t,e):r<1024?c(this,t,e):h(this,t,e)},f.prototype.makeRBT=function(t){for(var e=new Array(t),r=a.prototype._countBits(t)-1,n=0;n<t;n++)e[n]=this.revBin(n,r,t);return e},f.prototype.revBin=function(t,e,r){if(0===t||t===r-1)return t;for(var n=0,i=0;i<e;i++)n|=(1&t)<<e-i-1,t>>=1;return n},f.prototype.permute=function(t,e,r,n,i,a){for(var o=0;o<a;o++)n[o]=e[t[o]],i[o]=r[t[o]]},f.prototype.transform=function(t,e,r,n,i,a){this.permute(a,t,e,r,n,i);for(var o=1;o<i;o<<=1)for(var s=o<<1,l=Math.cos(2*Math.PI/s),u=Math.sin(2*Math.PI/s),c=0;c<i;c+=s)for(var h=l,f=u,d=0;d<o;d++){var p=r[c+d],m=n[c+d],v=r[c+d+o],g=n[c+d+o],y=h*v-f*g;g=h*g+f*v,v=y,r[c+d]=p+v,n[c+d]=m+g,r[c+d+o]=p-v,n[c+d+o]=m-g,d!==s&&(y=l*h-u*f,f=l*f+u*h,h=y)}},f.prototype.guessLen13b=function(t,e){var r=1|Math.max(e,t),n=1&r,i=0;for(r=r/2|0;r;r>>>=1)i++;return 1<<i+1+n},f.prototype.conjugate=function(t,e,r){if(!(r<=1))for(var n=0;n<r/2;n++){var i=t[n];t[n]=t[r-n-1],t[r-n-1]=i,i=e[n],e[n]=-e[r-n-1],e[r-n-1]=-i}},f.prototype.normalize13b=function(t,e){for(var r=0,n=0;n<e/2;n++){var i=8192*Math.round(t[2*n+1]/e)+Math.round(t[2*n]/e)+r;t[n]=67108863&i,r=i<67108864?0:i/67108864|0}return t},f.prototype.convert13b=function(t,e,r,i){for(var a=0,o=0;o<e;o++)a+=0|t[o],r[2*o]=8191&a,a>>>=13,r[2*o+1]=8191&a,a>>>=13;for(o=2*e;o<i;++o)r[o]=0;n(0===a),n(0==(-8192&a))},f.prototype.stub=function(t){for(var e=new Array(t),r=0;r<t;r++)e[r]=0;return e},f.prototype.mulp=function(t,e,r){var n=2*this.guessLen13b(t.length,e.length),i=this.makeRBT(n),a=this.stub(n),o=new Array(n),s=new Array(n),l=new Array(n),u=new Array(n),c=new Array(n),h=new Array(n),f=r.words;f.length=n,this.convert13b(t.words,t.length,o,n),this.convert13b(e.words,e.length,u,n),this.transform(o,a,s,l,n,i),this.transform(u,a,c,h,n,i);for(var d=0;d<n;d++){var p=s[d]*c[d]-l[d]*h[d];l[d]=s[d]*h[d]+l[d]*c[d],s[d]=p}return this.conjugate(s,l,n),this.transform(s,l,f,a,n,i),this.conjugate(f,a,n),this.normalize13b(f,n),r.negative=t.negative^e.negative,r.length=t.length+e.length,r.strip()},a.prototype.mul=function(t){var e=new a(null);return e.words=new Array(this.length+t.length),this.mulTo(t,e)},a.prototype.mulf=function(t){var e=new a(null);return e.words=new Array(this.length+t.length),h(this,t,e)},a.prototype.imul=function(t){return this.clone().mulTo(t,this)},a.prototype.imuln=function(t){n(\"number\"==typeof t),n(t<67108864);for(var e=0,r=0;r<this.length;r++){var i=(0|this.words[r])*t,a=(67108863&i)+(67108863&e);e>>=26,e+=i/67108864|0,e+=a>>>26,this.words[r]=67108863&a}return 0!==e&&(this.words[r]=e,this.length++),this},a.prototype.muln=function(t){return this.clone().imuln(t)},a.prototype.sqr=function(){return this.mul(this)},a.prototype.isqr=function(){return this.imul(this.clone())},a.prototype.pow=function(t){var e=l(t);if(0===e.length)return new a(1);for(var r=this,n=0;n<e.length&&0===e[n];n++,r=r.sqr());if(++n<e.length)for(var i=r.sqr();n<e.length;n++,i=i.sqr())0!==e[n]&&(r=r.mul(i));return r},a.prototype.iushln=function(t){n(\"number\"==typeof t&&t>=0);var e,r=t%26,i=(t-r)/26,a=67108863>>>26-r<<26-r;if(0!==r){var o=0;for(e=0;e<this.length;e++){var s=this.words[e]&a,l=(0|this.words[e])-s<<r;this.words[e]=l|o,o=s>>>26-r}o&&(this.words[e]=o,this.length++)}if(0!==i){for(e=this.length-1;e>=0;e--)this.words[e+i]=this.words[e];for(e=0;e<i;e++)this.words[e]=0;this.length+=i}return this.strip()},a.prototype.ishln=function(t){return n(0===this.negative),this.iushln(t)},a.prototype.iushrn=function(t,e,r){n(\"number\"==typeof t&&t>=0);var i;i=e?(e-e%26)/26:0;var a=t%26,o=Math.min((t-a)/26,this.length),s=67108863^67108863>>>a<<a,l=r;if(i-=o,i=Math.max(0,i),l){for(var u=0;u<o;u++)l.words[u]=this.words[u];l.length=o}if(0===o);else if(this.length>o)for(this.length-=o,u=0;u<this.length;u++)this.words[u]=this.words[u+o];else this.words[0]=0,this.length=1;var c=0;for(u=this.length-1;u>=0&&(0!==c||u>=i);u--){var h=0|this.words[u];this.words[u]=c<<26-a|h>>>a,c=h&s}return l&&0!==c&&(l.words[l.length++]=c),0===this.length&&(this.words[0]=0,this.length=1),this.strip()},a.prototype.ishrn=function(t,e,r){return n(0===this.negative),this.iushrn(t,e,r)},a.prototype.shln=function(t){return this.clone().ishln(t)},a.prototype.ushln=function(t){return this.clone().iushln(t)},a.prototype.shrn=function(t){return this.clone().ishrn(t)},a.prototype.ushrn=function(t){return this.clone().iushrn(t)},a.prototype.testn=function(t){n(\"number\"==typeof t&&t>=0);var e=t%26,r=(t-e)/26,i=1<<e;return!(this.length<=r)&&!!(this.words[r]&i)},a.prototype.imaskn=function(t){n(\"number\"==typeof t&&t>=0);var e=t%26,r=(t-e)/26;if(n(0===this.negative,\"imaskn works only with positive numbers\"),this.length<=r)return this;if(0!==e&&r++,this.length=Math.min(r,this.length),0!==e){var i=67108863^67108863>>>e<<e;this.words[this.length-1]&=i}return this.strip()},a.prototype.maskn=function(t){return this.clone().imaskn(t)},a.prototype.iaddn=function(t){return n(\"number\"==typeof t),n(t<67108864),t<0?this.isubn(-t):0!==this.negative?1===this.length&&(0|this.words[0])<t?(this.words[0]=t-(0|this.words[0]),this.negative=0,this):(this.negative=0,this.isubn(t),this.negative=1,this):this._iaddn(t)},a.prototype._iaddn=function(t){this.words[0]+=t;for(var e=0;e<this.length&&this.words[e]>=67108864;e++)this.words[e]-=67108864,e===this.length-1?this.words[e+1]=1:this.words[e+1]++;return this.length=Math.max(this.length,e+1),this},a.prototype.isubn=function(t){if(n(\"number\"==typeof t),n(t<67108864),t<0)return this.iaddn(-t);if(0!==this.negative)return this.negative=0,this.iaddn(t),this.negative=1,this;if(this.words[0]-=t,1===this.length&&this.words[0]<0)this.words[0]=-this.words[0],this.negative=1;else for(var e=0;e<this.length&&this.words[e]<0;e++)this.words[e]+=67108864,this.words[e+1]-=1;return this.strip()},a.prototype.addn=function(t){return this.clone().iaddn(t)},a.prototype.subn=function(t){return this.clone().isubn(t)},a.prototype.iabs=function(){return this.negative=0,this},a.prototype.abs=function(){return this.clone().iabs()},a.prototype._ishlnsubmul=function(t,e,r){var i,a=t.length+r;this._expand(a);var o,s=0;for(i=0;i<t.length;i++){o=(0|this.words[i+r])+s;var l=(0|t.words[i])*e;o-=67108863&l,s=(o>>26)-(l/67108864|0),this.words[i+r]=67108863&o}for(;i<this.length-r;i++)o=(0|this.words[i+r])+s,s=o>>26,this.words[i+r]=67108863&o;if(0===s)return this.strip();for(n(-1===s),s=0,i=0;i<this.length;i++)o=-(0|this.words[i])+s,s=o>>26,this.words[i]=67108863&o;return this.negative=1,this.strip()},a.prototype._wordDiv=function(t,e){var r=this.length-t.length,n=this.clone(),i=t,o=0|i.words[i.length-1];0!==(r=26-this._countBits(o))&&(i=i.ushln(r),n.iushln(r),o=0|i.words[i.length-1]);var s,l=n.length-i.length;if(\"mod\"!==e){s=new a(null),s.length=l+1,s.words=new Array(s.length);for(var u=0;u<s.length;u++)s.words[u]=0}var c=n.clone()._ishlnsubmul(i,1,l);0===c.negative&&(n=c,s&&(s.words[l]=1));for(var h=l-1;h>=0;h--){var f=67108864*(0|n.words[i.length+h])+(0|n.words[i.length+h-1]);for(f=Math.min(f/o|0,67108863),n._ishlnsubmul(i,f,h);0!==n.negative;)f--,n.negative=0,n._ishlnsubmul(i,1,h),n.isZero()||(n.negative^=1);s&&(s.words[h]=f)}return s&&s.strip(),n.strip(),\"div\"!==e&&0!==r&&n.iushrn(r),{div:s||null,mod:n}},a.prototype.divmod=function(t,e,r){if(n(!t.isZero()),this.isZero())return{div:new a(0),mod:new a(0)};var i,o,s;return 0!==this.negative&&0===t.negative?(s=this.neg().divmod(t,e),\"mod\"!==e&&(i=s.div.neg()),\"div\"!==e&&(o=s.mod.neg(),r&&0!==o.negative&&o.iadd(t)),{div:i,mod:o}):0===this.negative&&0!==t.negative?(s=this.divmod(t.neg(),e),\"mod\"!==e&&(i=s.div.neg()),{div:i,mod:s.mod}):0!=(this.negative&t.negative)?(s=this.neg().divmod(t.neg(),e),\"div\"!==e&&(o=s.mod.neg(),r&&0!==o.negative&&o.isub(t)),{div:s.div,mod:o}):t.length>this.length||this.cmp(t)<0?{div:new a(0),mod:this}:1===t.length?\"div\"===e?{div:this.divn(t.words[0]),mod:null}:\"mod\"===e?{div:null,mod:new a(this.modn(t.words[0]))}:{div:this.divn(t.words[0]),mod:new a(this.modn(t.words[0]))}:this._wordDiv(t,e)},a.prototype.div=function(t){return this.divmod(t,\"div\",!1).div},a.prototype.mod=function(t){return this.divmod(t,\"mod\",!1).mod},a.prototype.umod=function(t){return this.divmod(t,\"mod\",!0).mod},a.prototype.divRound=function(t){var e=this.divmod(t);if(e.mod.isZero())return e.div;var r=0!==e.div.negative?e.mod.isub(t):e.mod,n=t.ushrn(1),i=t.andln(1),a=r.cmp(n);return a<0||1===i&&0===a?e.div:0!==e.div.negative?e.div.isubn(1):e.div.iaddn(1)},a.prototype.modn=function(t){n(t<=67108863);for(var e=(1<<26)%t,r=0,i=this.length-1;i>=0;i--)r=(e*r+(0|this.words[i]))%t;return r},a.prototype.idivn=function(t){n(t<=67108863);for(var e=0,r=this.length-1;r>=0;r--){var i=(0|this.words[r])+67108864*e;this.words[r]=i/t|0,e=i%t}return this.strip()},a.prototype.divn=function(t){return this.clone().idivn(t)},a.prototype.egcd=function(t){n(0===t.negative),n(!t.isZero());var e=this,r=t.clone();e=0!==e.negative?e.umod(t):e.clone();for(var i=new a(1),o=new a(0),s=new a(0),l=new a(1),u=0;e.isEven()&&r.isEven();)e.iushrn(1),r.iushrn(1),++u;for(var c=r.clone(),h=e.clone();!e.isZero();){for(var f=0,d=1;0==(e.words[0]&d)&&f<26;++f,d<<=1);if(f>0)for(e.iushrn(f);f-- >0;)(i.isOdd()||o.isOdd())&&(i.iadd(c),o.isub(h)),i.iushrn(1),o.iushrn(1);for(var p=0,m=1;0==(r.words[0]&m)&&p<26;++p,m<<=1);if(p>0)for(r.iushrn(p);p-- >0;)(s.isOdd()||l.isOdd())&&(s.iadd(c),l.isub(h)),s.iushrn(1),l.iushrn(1);e.cmp(r)>=0?(e.isub(r),i.isub(s),o.isub(l)):(r.isub(e),s.isub(i),l.isub(o))}return{a:s,b:l,gcd:r.iushln(u)}},a.prototype._invmp=function(t){n(0===t.negative),n(!t.isZero());var e=this,r=t.clone();e=0!==e.negative?e.umod(t):e.clone();for(var i=new a(1),o=new a(0),s=r.clone();e.cmpn(1)>0&&r.cmpn(1)>0;){for(var l=0,u=1;0==(e.words[0]&u)&&l<26;++l,u<<=1);if(l>0)for(e.iushrn(l);l-- >0;)i.isOdd()&&i.iadd(s),i.iushrn(1);for(var c=0,h=1;0==(r.words[0]&h)&&c<26;++c,h<<=1);if(c>0)for(r.iushrn(c);c-- >0;)o.isOdd()&&o.iadd(s),o.iushrn(1);e.cmp(r)>=0?(e.isub(r),i.isub(o)):(r.isub(e),o.isub(i))}var f;return f=0===e.cmpn(1)?i:o,f.cmpn(0)<0&&f.iadd(t),f},a.prototype.gcd=function(t){if(this.isZero())return t.abs();if(t.isZero())return this.abs();var e=this.clone(),r=t.clone();e.negative=0,r.negative=0;for(var n=0;e.isEven()&&r.isEven();n++)e.iushrn(1),r.iushrn(1);for(;;){for(;e.isEven();)e.iushrn(1);for(;r.isEven();)r.iushrn(1);var i=e.cmp(r);if(i<0){var a=e;e=r,r=a}else if(0===i||0===r.cmpn(1))break;e.isub(r)}return r.iushln(n)},a.prototype.invm=function(t){return this.egcd(t).a.umod(t)},a.prototype.isEven=function(){return 0==(1&this.words[0])},a.prototype.isOdd=function(){return 1==(1&this.words[0])},a.prototype.andln=function(t){return this.words[0]&t},a.prototype.bincn=function(t){n(\"number\"==typeof t);var e=t%26,r=(t-e)/26,i=1<<e;if(this.length<=r)return this._expand(r+1),this.words[r]|=i,this;for(var a=i,o=r;0!==a&&o<this.length;o++){var s=0|this.words[o];s+=a,a=s>>>26,s&=67108863,this.words[o]=s}return 0!==a&&(this.words[o]=a,this.length++),this},a.prototype.isZero=function(){return 1===this.length&&0===this.words[0]},a.prototype.cmpn=function(t){var e=t<0;if(0!==this.negative&&!e)return-1;if(0===this.negative&&e)return 1;this.strip();var r;if(this.length>1)r=1;else{e&&(t=-t),n(t<=67108863,\"Number is too big\");var i=0|this.words[0];r=i===t?0:i<t?-1:1}return 0!==this.negative?0|-r:r},a.prototype.cmp=function(t){if(0!==this.negative&&0===t.negative)return-1;if(0===this.negative&&0!==t.negative)return 1;var e=this.ucmp(t);return 0!==this.negative?0|-e:e},a.prototype.ucmp=function(t){if(this.length>t.length)return 1;if(this.length<t.length)return-1;for(var e=0,r=this.length-1;r>=0;r--){var n=0|this.words[r],i=0|t.words[r];if(n!==i){n<i?e=-1:n>i&&(e=1);break}}return e},a.prototype.gtn=function(t){return 1===this.cmpn(t)},a.prototype.gt=function(t){return 1===this.cmp(t)},a.prototype.gten=function(t){return this.cmpn(t)>=0},a.prototype.gte=function(t){return this.cmp(t)>=0},a.prototype.ltn=function(t){return-1===this.cmpn(t)},a.prototype.lt=function(t){return-1===this.cmp(t)},a.prototype.lten=function(t){return this.cmpn(t)<=0},a.prototype.lte=function(t){return this.cmp(t)<=0},a.prototype.eqn=function(t){return 0===this.cmpn(t)},a.prototype.eq=function(t){return 0===this.cmp(t)},a.red=function(t){return new y(t)},a.prototype.toRed=function(t){return n(!this.red,\"Already a number in reduction context\"),n(0===this.negative,\"red works only with positives\"),t.convertTo(this)._forceRed(t)},a.prototype.fromRed=function(){return n(this.red,\"fromRed works only with numbers in reduction context\"),this.red.convertFrom(this)},a.prototype._forceRed=function(t){return this.red=t,this},a.prototype.forceRed=function(t){return n(!this.red,\"Already a number in reduction context\"),this._forceRed(t)},a.prototype.redAdd=function(t){return n(this.red,\"redAdd works only with red numbers\"),this.red.add(this,t)},a.prototype.redIAdd=function(t){return n(this.red,\"redIAdd works only with red numbers\"),this.red.iadd(this,t)},a.prototype.redSub=function(t){return n(this.red,\"redSub works only with red numbers\"),this.red.sub(this,t)},a.prototype.redISub=function(t){return n(this.red,\"redISub works only with red numbers\"),this.red.isub(this,t)},a.prototype.redShl=function(t){return n(this.red,\"redShl works only with red numbers\"),this.red.shl(this,t)},a.prototype.redMul=function(t){return n(this.red,\"redMul works only with red numbers\"),this.red._verify2(this,t),this.red.mul(this,t)},a.prototype.redIMul=function(t){return n(this.red,\"redMul works only with red numbers\"),this.red._verify2(this,t),this.red.imul(this,t)},a.prototype.redSqr=function(){return n(this.red,\"redSqr works only with red numbers\"),this.red._verify1(this),this.red.sqr(this)},a.prototype.redISqr=function(){return n(this.red,\"redISqr works only with red numbers\"),this.red._verify1(this),this.red.isqr(this)},a.prototype.redSqrt=function(){return n(this.red,\"redSqrt works only with red numbers\"),this.red._verify1(this),this.red.sqrt(this)},a.prototype.redInvm=function(){return n(this.red,\"redInvm works only with red numbers\"),this.red._verify1(this),this.red.invm(this)},a.prototype.redNeg=function(){return n(this.red,\"redNeg works only with red numbers\"),this.red._verify1(this),this.red.neg(this)},a.prototype.redPow=function(t){return n(this.red&&!t.red,\"redPow(normalNum)\"),this.red._verify1(this),this.red.pow(this,t)};var A={k256:null,p224:null,p192:null,p25519:null};d.prototype._tmp=function(){var t=new a(null);return t.words=new Array(Math.ceil(this.n/13)),t},d.prototype.ireduce=function(t){var e,r=t;do{this.split(r,this.tmp),r=this.imulK(r),r=r.iadd(this.tmp),e=r.bitLength()}while(e>this.n);var n=e<this.n?-1:r.ucmp(this.p);return 0===n?(r.words[0]=0,r.length=1):n>0?r.isub(this.p):r.strip(),r},d.prototype.split=function(t,e){t.iushrn(this.n,0,e)},d.prototype.imulK=function(t){return t.imul(this.k)},i(p,d),p.prototype.split=function(t,e){for(var r=Math.min(t.length,9),n=0;n<r;n++)e.words[n]=t.words[n];if(e.length=r,t.length<=9)return t.words[0]=0,void(t.length=1);var i=t.words[9];for(e.words[e.length++]=4194303&i,n=10;n<t.length;n++){var a=0|t.words[n];t.words[n-10]=(4194303&a)<<4|i>>>22,i=a}i>>>=22,t.words[n-10]=i,0===i&&t.length>10?t.length-=10:t.length-=9},p.prototype.imulK=function(t){t.words[t.length]=0,t.words[t.length+1]=0,t.length+=2;for(var e=0,r=0;r<t.length;r++){var n=0|t.words[r];e+=977*n,t.words[r]=67108863&e,e=64*n+(e/67108864|0)}return 0===t.words[t.length-1]&&(t.length--,0===t.words[t.length-1]&&t.length--),t},i(m,d),i(v,d),i(g,d),g.prototype.imulK=function(t){for(var e=0,r=0;r<t.length;r++){var n=19*(0|t.words[r])+e,i=67108863&n;n>>>=26,t.words[r]=i,e=n}return 0!==e&&(t.words[t.length++]=e),t},a._prime=function(t){if(A[t])return A[t];var e;if(\"k256\"===t)e=new p;else if(\"p224\"===t)e=new m;else if(\"p192\"===t)e=new v;else{if(\"p25519\"!==t)throw new Error(\"Unknown prime \"+t);e=new g}return A[t]=e,e},y.prototype._verify1=function(t){n(0===t.negative,\"red works only with positives\"),n(t.red,\"red works only with red numbers\")},y.prototype._verify2=function(t,e){n(0==(t.negative|e.negative),\"red works only with positives\"),n(t.red&&t.red===e.red,\"red works only with red numbers\")},y.prototype.imod=function(t){return this.prime?this.prime.ireduce(t)._forceRed(this):t.umod(this.m)._forceRed(this)},y.prototype.neg=function(t){return t.isZero()?t.clone():this.m.sub(t)._forceRed(this)},y.prototype.add=function(t,e){this._verify2(t,e);var r=t.add(e);return r.cmp(this.m)>=0&&r.isub(this.m),r._forceRed(this)},y.prototype.iadd=function(t,e){this._verify2(t,e);var r=t.iadd(e);return r.cmp(this.m)>=0&&r.isub(this.m),r},y.prototype.sub=function(t,e){this._verify2(t,e);var r=t.sub(e);return r.cmpn(0)<0&&r.iadd(this.m),r._forceRed(this)},y.prototype.isub=function(t,e){this._verify2(t,e);var r=t.isub(e);return r.cmpn(0)<0&&r.iadd(this.m),r},y.prototype.shl=function(t,e){return this._verify1(t),this.imod(t.ushln(e))},y.prototype.imul=function(t,e){return this._verify2(t,e),this.imod(t.imul(e))},y.prototype.mul=function(t,e){return this._verify2(t,e),this.imod(t.mul(e))},y.prototype.isqr=function(t){return this.imul(t,t.clone())},y.prototype.sqr=function(t){return this.mul(t,t)},y.prototype.sqrt=function(t){if(t.isZero())return t.clone();var e=this.m.andln(3);if(n(e%2==1),3===e){var r=this.m.add(new a(1)).iushrn(2);return this.pow(t,r)}for(var i=this.m.subn(1),o=0;!i.isZero()&&0===i.andln(1);)o++,i.iushrn(1);n(!i.isZero());var s=new a(1).toRed(this),l=s.redNeg(),u=this.m.subn(1).iushrn(1),c=this.m.bitLength();for(c=new a(2*c*c).toRed(this);0!==this.pow(c,u).cmp(l);)c.redIAdd(l);for(var h=this.pow(c,i),f=this.pow(t,i.addn(1).iushrn(1)),d=this.pow(t,i),p=o;0!==d.cmp(s);){for(var m=d,v=0;0!==m.cmp(s);v++)m=m.redSqr();n(v<p);var g=this.pow(h,new a(1).iushln(p-v-1));f=f.redMul(g),h=g.redSqr(),d=d.redMul(h),p=v}return f},y.prototype.invm=function(t){var e=t._invmp(this.m);return 0!==e.negative?(e.negative=0,this.imod(e).redNeg()):this.imod(e)},y.prototype.pow=function(t,e){if(e.isZero())return new a(1);if(0===e.cmpn(1))return t.clone();var r=new Array(16);r[0]=new a(1).toRed(this),r[1]=t;for(var n=2;n<r.length;n++)r[n]=this.mul(r[n-1],t);var i=r[0],o=0,s=0,l=e.bitLength()%26;for(0===l&&(l=26),n=e.length-1;n>=0;n--){for(var u=e.words[n],c=l-1;c>=0;c--){var h=u>>c&1;i!==r[0]&&(i=this.sqr(i)),0!==h||0!==o?(o<<=1,o|=h,(4===++s||0===n&&0===c)&&(i=this.mul(i,r[o]),s=0,o=0)):s=0}l=26}return i},y.prototype.convertTo=function(t){var e=t.umod(this.m);return e===t?e.clone():e},y.prototype.convertFrom=function(t){var e=t.clone();return e.red=null,e},a.mont=function(t){return new b(t)},i(b,y),b.prototype.convertTo=function(t){return this.imod(t.ushln(this.shift))},b.prototype.convertFrom=function(t){var e=this.imod(t.mul(this.rinv));return e.red=null,e},b.prototype.imul=function(t,e){if(t.isZero()||e.isZero())return t.words[0]=0,t.length=1,t;var r=t.imul(e),n=r.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m),i=r.isub(n).iushrn(this.shift),a=i;return i.cmp(this.m)>=0?a=i.isub(this.m):i.cmpn(0)<0&&(a=i.iadd(this.m)),a._forceRed(this)},b.prototype.mul=function(t,e){if(t.isZero()||e.isZero())return new a(0)._forceRed(this);var r=t.mul(e),n=r.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m),i=r.isub(n).iushrn(this.shift),o=i;return i.cmp(this.m)>=0?o=i.isub(this.m):i.cmpn(0)<0&&(o=i.iadd(this.m)),o._forceRed(this)},b.prototype.invm=function(t){return this.imod(t._invmp(this.m).mul(this.r2))._forceRed(this)}}(void 0===e||e,this)},{}],68:[function(t,e,r){\"use strict\";function n(t){var e,r,n,i=t.length,a=0;for(e=0;e<i;++e)a+=t[e].length;var o=new Array(a),s=0;for(e=0;e<i;++e){var l=t[e],u=l.length;for(r=0;r<u;++r){var c=o[s++]=new Array(u-1),h=0;for(n=0;n<u;++n)n!==r&&(c[h++]=l[n]);if(1&r){var f=c[1];c[1]=c[0],c[0]=f}}}return o}e.exports=n},{}],69:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0;r<t;++r)if(!(e[r]<=e[r+t]))return!0;return!1}function i(t,e,r,i){for(var a=0,o=0,s=0,l=t.length;s<l;++s){var u=t[s];if(!n(e,u)){for(var c=0;c<2*e;++c)r[a++]=u[c];i[o++]=s}}return o}function a(t,e,r,n){var a=t.length,o=e.length;if(!(a<=0||o<=0)){var s=t[0].length>>>1;if(!(s<=0)){var l,u=h.mallocDouble(2*s*a),c=h.mallocInt32(a);if((a=i(t,s,u,c))>0){if(1===s&&n)f.init(a),l=f.sweepComplete(s,r,0,a,u,c,0,a,u,c);else{var p=h.mallocDouble(2*s*o),m=h.mallocInt32(o);o=i(e,s,p,m),o>0&&(f.init(a+o),l=1===s?f.sweepBipartite(s,r,0,a,u,c,0,o,p,m):d(s,r,n,a,u,c,o,p,m),h.free(p),h.free(m))}h.free(u),h.free(c)}return l}}}function o(t,e){c.push([t,e])}function s(t){return c=[],a(t,t,o,!0),c}function l(t,e){return c=[],a(t,e,o,!1),c}function u(t,e,r){switch(arguments.length){case 1:return s(t);case 2:return\"function\"==typeof e?a(t,t,e,!0):l(t,e);case 3:return a(t,e,r,!1);default:throw new Error(\"box-intersect: Invalid arguments\")}}e.exports=u;var c,h=t(\"typedarray-pool\"),f=t(\"./lib/sweep\"),d=t(\"./lib/intersect\")},{\"./lib/intersect\":71,\"./lib/sweep\":75,\"typedarray-pool\":540}],70:[function(t,e,r){\"use strict\";function n(t,e,r){var n=\"bruteForce\"+(t?\"Red\":\"Blue\")+(e?\"Flip\":\"\")+(r?\"Full\":\"\"),i=[\"function \",n,\"(\",w.join(),\"){\",\"var \",u,\"=2*\",a,\";\"],l=\"for(var i=\"+c+\",\"+p+\"=\"+u+\"*\"+c+\";i<\"+h+\";++i,\"+p+\"+=\"+u+\"){var x0=\"+f+\"[\"+o+\"+\"+p+\"],x1=\"+f+\"[\"+o+\"+\"+p+\"+\"+a+\"],xi=\"+d+\"[i];\",M=\"for(var j=\"+m+\",\"+b+\"=\"+u+\"*\"+m+\";j<\"+v+\";++j,\"+b+\"+=\"+u+\"){var y0=\"+g+\"[\"+o+\"+\"+b+\"],\"+(r?\"y1=\"+g+\"[\"+o+\"+\"+b+\"+\"+a+\"],\":\"\")+\"yi=\"+y+\"[j];\";return t?i.push(l,_,\":\",M):i.push(M,_,\":\",l),r?i.push(\"if(y1<x0||x1<y0)continue;\"):e?i.push(\"if(y0<=x0||x1<y0)continue;\"):i.push(\"if(y0<x0||x1<y0)continue;\"),i.push(\"for(var k=\"+o+\"+1;k<\"+a+\";++k){var r0=\"+f+\"[k+\"+p+\"],r1=\"+f+\"[k+\"+a+\"+\"+p+\"],b0=\"+g+\"[k+\"+b+\"],b1=\"+g+\"[k+\"+a+\"+\"+b+\"];if(r1<b0||b1<r0)continue \"+_+\";}var \"+x+\"=\"+s+\"(\"),e?i.push(\"yi,xi\"):i.push(\"xi,yi\"),i.push(\");if(\"+x+\"!==void 0)return \"+x+\";}}}\"),{name:n,code:i.join(\"\")}}function i(t){function e(e,r){var a=n(e,r,t);i.push(a.code),o.push(\"return \"+a.name+\"(\"+w.join()+\");\")}var r=\"bruteForce\"+(t?\"Full\":\"Partial\"),i=[],a=w.slice();t||a.splice(3,0,l);var o=[\"function \"+r+\"(\"+a.join()+\"){\"];o.push(\"if(\"+h+\"-\"+c+\">\"+v+\"-\"+m+\"){\"),t?(e(!0,!1),o.push(\"}else{\"),e(!1,!1)):(o.push(\"if(\"+l+\"){\"),e(!0,!0),o.push(\"}else{\"),e(!0,!1),o.push(\"}}else{if(\"+l+\"){\"),e(!1,!0),o.push(\"}else{\"),e(!1,!1),o.push(\"}\")),o.push(\"}}return \"+r);var s=i.join(\"\")+o.join(\"\");return new Function(s)()}var a=\"d\",o=\"ax\",s=\"vv\",l=\"fp\",u=\"es\",c=\"rs\",h=\"re\",f=\"rb\",d=\"ri\",p=\"rp\",m=\"bs\",v=\"be\",g=\"bb\",y=\"bi\",b=\"bp\",x=\"rv\",_=\"Q\",w=[a,o,s,c,h,f,d,m,v,g,y];r.partial=i(!1),r.full=i(!0)},{}],71:[function(t,e,r){\"use strict\";function n(t,e){var r=8*u.log2(e+1)*(t+1)|0,n=u.nextPow2(A*r);S.length<n&&(l.free(S),S=l.mallocInt32(n));var i=u.nextPow2(T*r);E<i&&(l.free(E),E=l.mallocDouble(i))}function i(t,e,r,n,i,a,o,s,l){var u=A*t;S[u]=e,S[u+1]=r,S[u+2]=n,S[u+3]=i,S[u+4]=a,S[u+5]=o;var c=T*t;E[c]=s,E[c+1]=l}function a(t,e,r,n,i,a,o,s,l,u,c){var h=2*t,f=l*h,d=u[f+e];t:for(var p=i,m=i*h;p<a;++p,m+=h){var v=o[m+e],g=o[m+e+t];if(!(d<v||g<d)&&(!n||d!==v)){for(var y=s[p],b=e+1;b<t;++b){var v=o[m+b],g=o[m+b+t],x=u[f+b],_=u[f+b+t];if(g<x||_<v)continue t}var w;if(void 0!==(w=n?r(c,y):r(y,c)))return w}}}function o(t,e,r,n,i,a,o,s,l,u){var c=2*t,h=s*c,f=l[h+e];t:for(var d=n,p=n*c;d<i;++d,p+=c){var m=o[d];if(m!==u){var v=a[p+e],g=a[p+e+t];if(!(f<v||g<f)){for(var y=e+1;y<t;++y){var v=a[p+y],g=a[p+y+t],b=l[h+y],x=l[h+y+t];if(g<b||x<v)continue t}var _=r(m,u);if(void 0!==_)return _}}}}function s(t,e,r,s,l,u,c,m,L){n(t,s+c);var C,z=0,I=2*t;for(i(z++,0,0,s,0,c,r?16:0,-1/0,1/0),r||i(z++,0,0,c,0,s,1,-1/0,1/0);z>0;){z-=1;var D=z*A,P=S[D],O=S[D+1],R=S[D+2],F=S[D+3],j=S[D+4],N=S[D+5],B=z*T,U=E[B],V=E[B+1],H=1&N,q=!!(16&N),G=l,Y=u,X=m,W=L;if(H&&(G=m,Y=L,X=l,W=u),!(2&N&&(R=_(t,P,O,R,G,Y,V),O>=R)||4&N&&(O=w(t,P,O,R,G,Y,U))>=R)){var Z=R-O,J=j-F;if(q){if(t*Z*(Z+J)<y){if(void 0!==(C=d.scanComplete(t,P,e,O,R,G,Y,F,j,X,W)))return C;continue}}else{if(t*Math.min(Z,J)<v){if(void 0!==(C=h(t,P,e,H,O,R,G,Y,F,j,X,W)))return C;continue}if(t*Z*J<g){if(void 0!==(C=d.scanBipartite(t,P,e,H,O,R,G,Y,F,j,X,W)))return C;continue}}var K=b(t,P,O,R,G,Y,U,V);if(O<K)if(t*(K-O)<v){if(void 0!==(C=f(t,P+1,e,O,K,G,Y,F,j,X,W)))return C}else if(P===t-2){if(void 0!==(C=H?d.sweepBipartite(t,e,F,j,X,W,O,K,G,Y):d.sweepBipartite(t,e,O,K,G,Y,F,j,X,W)))return C}else i(z++,P+1,O,K,F,j,H,-1/0,1/0),i(z++,P+1,F,j,O,K,1^H,-1/0,1/0);if(K<R){var Q=p(t,P,F,j,X,W),$=X[I*Q+P],tt=x(t,P,Q,j,X,W,$);if(tt<j&&i(z++,P,K,R,tt,j,(4|H)+(q?16:0),$,V),F<Q&&i(z++,P,K,R,F,Q,(2|H)+(q?16:0),U,$),Q+1===tt){if(void 0!==(C=q?o(t,P,e,K,R,G,Y,Q,X,W[Q]):a(t,P,e,H,K,R,G,Y,Q,X,W[Q])))return C}else if(Q<tt){var et;if(q){if(et=M(t,P,K,R,G,Y,$),K<et){var rt=x(t,P,K,et,G,Y,$);if(P===t-2){if(K<rt&&void 0!==(C=d.sweepComplete(t,e,K,rt,G,Y,Q,tt,X,W)))return C;if(rt<et&&void 0!==(C=d.sweepBipartite(t,e,rt,et,G,Y,Q,tt,X,W)))return C}else K<rt&&i(z++,P+1,K,rt,Q,tt,16,-1/0,1/0),rt<et&&(i(z++,P+1,rt,et,Q,tt,0,-1/0,1/0),i(z++,P+1,Q,tt,rt,et,1,-1/0,1/0))}}else et=H?k(t,P,K,R,G,Y,$):M(t,P,K,R,G,Y,$),K<et&&(P===t-2?C=H?d.sweepBipartite(t,e,Q,tt,X,W,K,et,G,Y):d.sweepBipartite(t,e,K,et,G,Y,Q,tt,X,W):(i(z++,P+1,K,et,Q,tt,H,-1/0,1/0),i(z++,P+1,Q,tt,K,et,1^H,-1/0,1/0)))}}}}}e.exports=s;var l=t(\"typedarray-pool\"),u=t(\"bit-twiddle\"),c=t(\"./brute\"),h=c.partial,f=c.full,d=t(\"./sweep\"),p=t(\"./median\"),m=t(\"./partition\"),v=128,g=1<<22,y=1<<22,b=m(\"!(lo>=p0)&&!(p1>=hi)\",[\"p0\",\"p1\"]),x=m(\"lo===p0\",[\"p0\"]),_=m(\"lo<p0\",[\"p0\"]),w=m(\"hi<=p0\",[\"p0\"]),M=m(\"lo<=p0&&p0<=hi\",[\"p0\"]),k=m(\"lo<p0&&p0<=hi\",[\"p0\"]),A=6,T=2,S=l.mallocInt32(1024),E=l.mallocDouble(1024)},{\"./brute\":70,\"./median\":72,\"./partition\":73,\"./sweep\":75,\"bit-twiddle\":66,\"typedarray-pool\":540}],72:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){for(var o=2*t,s=o*(r+1)+e,l=r+1;l<n;++l,s+=o)for(var u=i[s],c=l,h=o*(l-1);c>r&&i[h+e]>u;--c,h-=o){for(var f=h,d=h+o,p=0;p<o;++p,++f,++d){var m=i[f];i[f]=i[d],i[d]=m}var v=a[c];a[c]=a[c-1],a[c-1]=v}}function i(t,e,r,i,a,l){if(i<=r+1)return r;for(var u=r,c=i,h=i+r>>>1,f=2*t,d=h,p=a[f*h+e];u<c;){if(c-u<s){n(t,e,u,c,a,l),p=a[f*h+e];break}var m=c-u,v=Math.random()*m+u|0,g=a[f*v+e],y=Math.random()*m+u|0,b=a[f*y+e],x=Math.random()*m+u|0,_=a[f*x+e];g<=b?_>=b?(d=y,p=b):g>=_?(d=v,p=g):(d=x,p=_):b>=_?(d=y,p=b):_>=g?(d=v,p=g):(d=x,p=_);for(var w=f*(c-1),M=f*d,k=0;k<f;++k,++w,++M){var A=a[w];a[w]=a[M],a[M]=A}var T=l[c-1];l[c-1]=l[d],l[d]=T,d=o(t,e,u,c-1,a,l,p);for(var w=f*(c-1),M=f*d,k=0;k<f;++k,++w,++M){var A=a[w];a[w]=a[M],a[M]=A}var T=l[c-1];if(l[c-1]=l[d],l[d]=T,h<d){for(c=d-1;u<c&&a[f*(c-1)+e]===p;)c-=1;c+=1}else{if(!(d<h))break;for(u=d+1;u<c&&a[f*u+e]===p;)u+=1}}return o(t,e,r,h,a,l,a[f*h+e])}e.exports=i;var a=t(\"./partition\"),o=a(\"lo<p0\",[\"p0\"]),s=8},{\"./partition\":73}],73:[function(t,e,r){\"use strict\";function n(t,e){var r=\"abcdef\".split(\"\").concat(e),n=[];return t.indexOf(\"lo\")>=0&&n.push(\"lo=e[k+n]\"),t.indexOf(\"hi\")>=0&&n.push(\"hi=e[k+o]\"),r.push(i.replace(\"_\",n.join()).replace(\"$\",t)),Function.apply(void 0,r)}e.exports=n;var i=\"for(var j=2*a,k=j*c,l=k,m=c,n=b,o=a+b,p=c;d>p;++p,k+=j){var _;if($)if(m===p)m+=1,l+=j;else{for(var s=0;j>s;++s){var t=e[k+s];e[k+s]=e[l],e[l++]=t}var u=f[p];f[p]=f[m],f[m++]=u}}return m\"},{}],74:[function(t,e,r){\"use strict\";function n(t,e){e<=4*f?i(0,e-1,t):h(0,e-1,t)}function i(t,e,r){for(var n=2*(t+1),i=t+1;i<=e;++i){for(var a=r[n++],o=r[n++],s=i,l=n-2;s-- >t;){var u=r[l-2],c=r[l-1];if(u<a)break;if(u===a&&c<o)break;r[l]=u,r[l+1]=c,l-=2}r[l]=a,r[l+1]=o}}function a(t,e,r){t*=2,e*=2;var n=r[t],i=r[t+1];r[t]=r[e],r[t+1]=r[e+1],r[e]=n,r[e+1]=i}function o(t,e,r){t*=2,e*=2,r[t]=r[e],r[t+1]=r[e+1]}function s(t,e,r,n){t*=2,e*=2,r*=2;var i=n[t],a=n[t+1];n[t]=n[e],n[t+1]=n[e+1],n[e]=n[r],n[e+1]=n[r+1],n[r]=i,n[r+1]=a}function l(t,e,r,n,i){t*=2,e*=2,i[t]=i[e],i[e]=r,i[t+1]=i[e+1],i[e+1]=n}function u(t,e,r){t*=2,e*=2;var n=r[t],i=r[e];return!(n<i)&&(n!==i||r[t+1]>r[e+1])}function c(t,e,r,n){t*=2;var i=n[t];return i<e||i===e&&n[t+1]<r}function h(t,e,r){var n=(e-t+1)/6|0,d=t+n,p=e-n,m=t+e>>1,v=m-n,g=m+n,y=d,b=v,x=m,_=g,w=p,M=t+1,k=e-1,A=0;u(y,b,r)&&(A=y,y=b,b=A),u(_,w,r)&&(A=_,_=w,w=A),u(y,x,r)&&(A=y,y=x,x=A),u(b,x,r)&&(A=b,b=x,x=A),u(y,_,r)&&(A=y,y=_,_=A),u(x,_,r)&&(A=x,x=_,_=A),u(b,w,r)&&(A=b,b=w,w=A),u(b,x,r)&&(A=b,b=x,x=A),u(_,w,r)&&(A=_,_=w,w=A);for(var T=r[2*b],S=r[2*b+1],E=r[2*_],L=r[2*_+1],C=2*y,z=2*x,I=2*w,D=2*d,P=2*m,O=2*p,R=0;R<2;++R){var F=r[C+R],j=r[z+R],N=r[I+R];r[D+R]=F,r[P+R]=j,r[O+R]=N}o(v,t,r),o(g,e,r);for(var B=M;B<=k;++B)if(c(B,T,S,r))B!==M&&a(B,M,r),++M;else if(!c(B,E,L,r))for(;;){if(c(k,E,L,r)){c(k,T,S,r)?(s(B,M,k,r),++M,--k):(a(B,k,r),--k);break}if(--k<B)break}l(t,M-1,T,S,r),l(e,k+1,E,L,r),M-2-t<=f?i(t,M-2,r):h(t,M-2,r),e-(k+2)<=f?i(k+2,e,r):h(k+2,e,r),k-M<=f?i(M,k,r):h(M,k,r)}e.exports=n;var f=32},{}],75:[function(t,e,r){\"use strict\";function n(t){var e=h.nextPow2(t);p.length<e&&(c.free(p),p=c.mallocInt32(e)),m.length<e&&(c.free(m),m=c.mallocInt32(e)),v.length<e&&(c.free(v),v=c.mallocInt32(e)),g.length<e&&(c.free(g),g=c.mallocInt32(e)),y.length<e&&(c.free(y),y=c.mallocInt32(e)),b.length<e&&(c.free(b),b=c.mallocInt32(e));var r=8*e;x.length<r&&(c.free(x),x=c.mallocDouble(r))}function i(t,e,r,n){var i=e[n],a=t[r-1];t[i]=a,e[a]=i}function a(t,e,r,n){t[r]=n,e[n]=r}function o(t,e,r,n,o,s,l,u,c,h){for(var y=0,b=2*t,_=t-1,w=b-1,M=r;M<n;++M){var k=s[M],A=b*M;x[y++]=o[A+_],x[y++]=-(k+1),x[y++]=o[A+w],x[y++]=k}for(var M=l;M<u;++M){var k=h[M]+d,T=b*M;x[y++]=c[T+_],x[y++]=-k,x[y++]=c[T+w],x[y++]=k}var S=y>>>1;f(x,S);for(var E=0,L=0,M=0;M<S;++M){var C=0|x[2*M+1];if(C>=d)C=C-d|0,i(v,g,L--,C);else if(C>=0)i(p,m,E--,C);else if(C<=-d){C=-C-d|0;for(var z=0;z<E;++z){var I=e(p[z],C);if(void 0!==I)return I}a(v,g,L++,C)}else{C=-C-1|0;for(var z=0;z<L;++z){var I=e(C,v[z]);if(void 0!==I)return I}a(p,m,E++,C)}}}function s(t,e,r,n,o,s,l,u,c,h){for(var d=0,_=2*t,w=t-1,M=_-1,k=r;k<n;++k){var A=s[k]+1<<1,T=_*k;x[d++]=o[T+w],x[d++]=-A,x[d++]=o[T+M],x[d++]=A}for(var k=l;k<u;++k){var A=h[k]+1<<1,S=_*k;x[d++]=c[S+w],x[d++]=1|-A,x[d++]=c[S+M],x[d++]=1|A}var E=d>>>1;f(x,E);for(var L=0,C=0,z=0,k=0;k<E;++k){var I=0|x[2*k+1],D=1&I;if(k<E-1&&I>>1==x[2*k+3]>>1&&(D=2,k+=1),I<0){for(var P=-(I>>1)-1,O=0;O<z;++O){var R=e(y[O],P);if(void 0!==R)return R}if(0!==D)for(var O=0;O<L;++O){var R=e(p[O],P);if(void 0!==R)return R}if(1!==D)for(var O=0;O<C;++O){var R=e(v[O],P);if(void 0!==R)return R}0===D?a(p,m,L++,P):1===D?a(v,g,C++,P):2===D&&a(y,b,z++,P)}else{var P=(I>>1)-1;0===D?i(p,m,L--,P):1===D?i(v,g,C--,P):2===D&&i(y,b,z--,P)}}}function l(t,e,r,n,o,s,l,u,c,h,v,g){var y=0,b=2*t,_=e,w=e+t,M=1,k=1;n?k=d:M=d;for(var A=o;A<s;++A){var T=A+M,S=b*A;x[y++]=l[S+_],x[y++]=-T,x[y++]=l[S+w],x[y++]=T}for(var A=c;A<h;++A){\n",
       "var T=A+k,E=b*A;x[y++]=v[E+_],x[y++]=-T}var L=y>>>1;f(x,L);for(var C=0,A=0;A<L;++A){var z=0|x[2*A+1];if(z<0){var T=-z,I=!1;if(T>=d?(I=!n,T-=d):(I=!!n,T-=1),I)a(p,m,C++,T);else{var D=g[T],P=b*T,O=v[P+e+1],R=v[P+e+1+t];t:for(var F=0;F<C;++F){var j=p[F],N=b*j;if(!(R<l[N+e+1]||l[N+e+1+t]<O)){for(var B=e+2;B<t;++B)if(v[P+B+t]<l[N+B]||l[N+B+t]<v[P+B])continue t;var U,V=u[j];if(void 0!==(U=n?r(D,V):r(V,D)))return U}}}}else i(p,m,C--,z-M)}}function u(t,e,r,n,i,a,o,s,l,u,c){for(var h=0,m=2*t,v=e,g=e+t,y=n;y<i;++y){var b=y+d,_=m*y;x[h++]=a[_+v],x[h++]=-b,x[h++]=a[_+g],x[h++]=b}for(var y=s;y<l;++y){var b=y+1,w=m*y;x[h++]=u[w+v],x[h++]=-b}var M=h>>>1;f(x,M);for(var k=0,y=0;y<M;++y){var A=0|x[2*y+1];if(A<0){var b=-A;if(b>=d)p[k++]=b-d;else{b-=1;var T=c[b],S=m*b,E=u[S+e+1],L=u[S+e+1+t];t:for(var C=0;C<k;++C){var z=p[C],I=o[z];if(I===T)break;var D=m*z;if(!(L<a[D+e+1]||a[D+e+1+t]<E)){for(var P=e+2;P<t;++P)if(u[S+P+t]<a[D+P]||a[D+P+t]<u[S+P])continue t;var O=r(I,T);if(void 0!==O)return O}}}}else{for(var b=A-d,C=k-1;C>=0;--C)if(p[C]===b){for(var P=C+1;P<k;++P)p[P-1]=p[P];break}--k}}}e.exports={init:n,sweepBipartite:o,sweepComplete:s,scanBipartite:l,scanComplete:u};var c=t(\"typedarray-pool\"),h=t(\"bit-twiddle\"),f=t(\"./sort\"),d=1<<28,p=c.mallocInt32(1024),m=c.mallocInt32(1024),v=c.mallocInt32(1024),g=c.mallocInt32(1024),y=c.mallocInt32(1024),b=c.mallocInt32(1024),x=c.mallocDouble(8192)},{\"./sort\":74,\"bit-twiddle\":66,\"typedarray-pool\":540}],76:[function(t,e,r){\"use strict\";function n(t){if(t>Z)throw new RangeError(\"Invalid typed array length\");var e=new Uint8Array(t);return e.__proto__=i.prototype,e}function i(t,e,r){if(\"number\"==typeof t){if(\"string\"==typeof e)throw new Error(\"If encoding is specified then the first argument must be a string\");return l(t)}return a(t,e,r)}function a(t,e,r){if(\"number\"==typeof t)throw new TypeError('\"value\" argument must not be a number');return t instanceof ArrayBuffer?h(t,e,r):\"string\"==typeof t?u(t,e):f(t)}function o(t){if(\"number\"!=typeof t)throw new TypeError('\"size\" argument must be a number');if(t<0)throw new RangeError('\"size\" argument must not be negative')}function s(t,e,r){return o(t),t<=0?n(t):void 0!==e?\"string\"==typeof r?n(t).fill(e,r):n(t).fill(e):n(t)}function l(t){return o(t),n(t<0?0:0|d(t))}function u(t,e){if(\"string\"==typeof e&&\"\"!==e||(e=\"utf8\"),!i.isEncoding(e))throw new TypeError('\"encoding\" must be a valid string encoding');var r=0|m(t,e),a=n(r),o=a.write(t,e);return o!==r&&(a=a.slice(0,o)),a}function c(t){for(var e=t.length<0?0:0|d(t.length),r=n(e),i=0;i<e;i+=1)r[i]=255&t[i];return r}function h(t,e,r){if(e<0||t.byteLength<e)throw new RangeError(\"'offset' is out of bounds\");if(t.byteLength<e+(r||0))throw new RangeError(\"'length' is out of bounds\");var n;return n=void 0===e&&void 0===r?new Uint8Array(t):void 0===r?new Uint8Array(t,e):new Uint8Array(t,e,r),n.__proto__=i.prototype,n}function f(t){if(i.isBuffer(t)){var e=0|d(t.length),r=n(e);return 0===r.length?r:(t.copy(r,0,0,e),r)}if(t){if(G(t)||\"length\"in t)return\"number\"!=typeof t.length||Y(t.length)?n(0):c(t);if(\"Buffer\"===t.type&&Array.isArray(t.data))return c(t.data)}throw new TypeError(\"First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.\")}function d(t){if(t>=Z)throw new RangeError(\"Attempt to allocate Buffer larger than maximum size: 0x\"+Z.toString(16)+\" bytes\");return 0|t}function p(t){return+t!=t&&(t=0),i.alloc(+t)}function m(t,e){if(i.isBuffer(t))return t.length;if(G(t)||t instanceof ArrayBuffer)return t.byteLength;\"string\"!=typeof t&&(t=\"\"+t);var r=t.length;if(0===r)return 0;for(var n=!1;;)switch(e){case\"ascii\":case\"latin1\":case\"binary\":return r;case\"utf8\":case\"utf-8\":case void 0:return B(t).length;case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return 2*r;case\"hex\":return r>>>1;case\"base64\":return H(t).length;default:if(n)return B(t).length;e=(\"\"+e).toLowerCase(),n=!0}}function v(t,e,r){var n=!1;if((void 0===e||e<0)&&(e=0),e>this.length)return\"\";if((void 0===r||r>this.length)&&(r=this.length),r<=0)return\"\";if(r>>>=0,e>>>=0,r<=e)return\"\";for(t||(t=\"utf8\");;)switch(t){case\"hex\":return z(this,e,r);case\"utf8\":case\"utf-8\":return S(this,e,r);case\"ascii\":return L(this,e,r);case\"latin1\":case\"binary\":return C(this,e,r);case\"base64\":return T(this,e,r);case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return I(this,e,r);default:if(n)throw new TypeError(\"Unknown encoding: \"+t);t=(t+\"\").toLowerCase(),n=!0}}function g(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}function y(t,e,r,n,a){if(0===t.length)return-1;if(\"string\"==typeof r?(n=r,r=0):r>2147483647?r=2147483647:r<-2147483648&&(r=-2147483648),r=+r,Y(r)&&(r=a?0:t.length-1),r<0&&(r=t.length+r),r>=t.length){if(a)return-1;r=t.length-1}else if(r<0){if(!a)return-1;r=0}if(\"string\"==typeof e&&(e=i.from(e,n)),i.isBuffer(e))return 0===e.length?-1:b(t,e,r,n,a);if(\"number\"==typeof e)return e&=255,\"function\"==typeof Uint8Array.prototype.indexOf?a?Uint8Array.prototype.indexOf.call(t,e,r):Uint8Array.prototype.lastIndexOf.call(t,e,r):b(t,[e],r,n,a);throw new TypeError(\"val must be string, number or Buffer\")}function b(t,e,r,n,i){function a(t,e){return 1===o?t[e]:t.readUInt16BE(e*o)}var o=1,s=t.length,l=e.length;if(void 0!==n&&(\"ucs2\"===(n=String(n).toLowerCase())||\"ucs-2\"===n||\"utf16le\"===n||\"utf-16le\"===n)){if(t.length<2||e.length<2)return-1;o=2,s/=2,l/=2,r/=2}var u;if(i){var c=-1;for(u=r;u<s;u++)if(a(t,u)===a(e,-1===c?0:u-c)){if(-1===c&&(c=u),u-c+1===l)return c*o}else-1!==c&&(u-=u-c),c=-1}else for(r+l>s&&(r=s-l),u=r;u>=0;u--){for(var h=!0,f=0;f<l;f++)if(a(t,u+f)!==a(e,f)){h=!1;break}if(h)return u}return-1}function x(t,e,r,n){r=Number(r)||0;var i=t.length-r;n?(n=Number(n))>i&&(n=i):n=i;var a=e.length;if(a%2!=0)throw new TypeError(\"Invalid hex string\");n>a/2&&(n=a/2);for(var o=0;o<n;++o){var s=parseInt(e.substr(2*o,2),16);if(Y(s))return o;t[r+o]=s}return o}function _(t,e,r,n){return q(B(e,t.length-r),t,r,n)}function w(t,e,r,n){return q(U(e),t,r,n)}function M(t,e,r,n){return w(t,e,r,n)}function k(t,e,r,n){return q(H(e),t,r,n)}function A(t,e,r,n){return q(V(e,t.length-r),t,r,n)}function T(t,e,r){return 0===e&&r===t.length?X.fromByteArray(t):X.fromByteArray(t.slice(e,r))}function S(t,e,r){r=Math.min(t.length,r);for(var n=[],i=e;i<r;){var a=t[i],o=null,s=a>239?4:a>223?3:a>191?2:1;if(i+s<=r){var l,u,c,h;switch(s){case 1:a<128&&(o=a);break;case 2:l=t[i+1],128==(192&l)&&(h=(31&a)<<6|63&l)>127&&(o=h);break;case 3:l=t[i+1],u=t[i+2],128==(192&l)&&128==(192&u)&&(h=(15&a)<<12|(63&l)<<6|63&u)>2047&&(h<55296||h>57343)&&(o=h);break;case 4:l=t[i+1],u=t[i+2],c=t[i+3],128==(192&l)&&128==(192&u)&&128==(192&c)&&(h=(15&a)<<18|(63&l)<<12|(63&u)<<6|63&c)>65535&&h<1114112&&(o=h)}}null===o?(o=65533,s=1):o>65535&&(o-=65536,n.push(o>>>10&1023|55296),o=56320|1023&o),n.push(o),i+=s}return E(n)}function E(t){var e=t.length;if(e<=J)return String.fromCharCode.apply(String,t);for(var r=\"\",n=0;n<e;)r+=String.fromCharCode.apply(String,t.slice(n,n+=J));return r}function L(t,e,r){var n=\"\";r=Math.min(t.length,r);for(var i=e;i<r;++i)n+=String.fromCharCode(127&t[i]);return n}function C(t,e,r){var n=\"\";r=Math.min(t.length,r);for(var i=e;i<r;++i)n+=String.fromCharCode(t[i]);return n}function z(t,e,r){var n=t.length;(!e||e<0)&&(e=0),(!r||r<0||r>n)&&(r=n);for(var i=\"\",a=e;a<r;++a)i+=N(t[a]);return i}function I(t,e,r){for(var n=t.slice(e,r),i=\"\",a=0;a<n.length;a+=2)i+=String.fromCharCode(n[a]+256*n[a+1]);return i}function D(t,e,r){if(t%1!=0||t<0)throw new RangeError(\"offset is not uint\");if(t+e>r)throw new RangeError(\"Trying to access beyond buffer length\")}function P(t,e,r,n,a,o){if(!i.isBuffer(t))throw new TypeError('\"buffer\" argument must be a Buffer instance');if(e>a||e<o)throw new RangeError('\"value\" argument is out of bounds');if(r+n>t.length)throw new RangeError(\"Index out of range\")}function O(t,e,r,n,i,a){if(r+n>t.length)throw new RangeError(\"Index out of range\");if(r<0)throw new RangeError(\"Index out of range\")}function R(t,e,r,n,i){return e=+e,r>>>=0,i||O(t,e,r,4,3.4028234663852886e38,-3.4028234663852886e38),W.write(t,e,r,n,23,4),r+4}function F(t,e,r,n,i){return e=+e,r>>>=0,i||O(t,e,r,8,1.7976931348623157e308,-1.7976931348623157e308),W.write(t,e,r,n,52,8),r+8}function j(t){if(t=t.trim().replace(K,\"\"),t.length<2)return\"\";for(;t.length%4!=0;)t+=\"=\";return t}function N(t){return t<16?\"0\"+t.toString(16):t.toString(16)}function B(t,e){e=e||1/0;for(var r,n=t.length,i=null,a=[],o=0;o<n;++o){if((r=t.charCodeAt(o))>55295&&r<57344){if(!i){if(r>56319){(e-=3)>-1&&a.push(239,191,189);continue}if(o+1===n){(e-=3)>-1&&a.push(239,191,189);continue}i=r;continue}if(r<56320){(e-=3)>-1&&a.push(239,191,189),i=r;continue}r=65536+(i-55296<<10|r-56320)}else i&&(e-=3)>-1&&a.push(239,191,189);if(i=null,r<128){if((e-=1)<0)break;a.push(r)}else if(r<2048){if((e-=2)<0)break;a.push(r>>6|192,63&r|128)}else if(r<65536){if((e-=3)<0)break;a.push(r>>12|224,r>>6&63|128,63&r|128)}else{if(!(r<1114112))throw new Error(\"Invalid code point\");if((e-=4)<0)break;a.push(r>>18|240,r>>12&63|128,r>>6&63|128,63&r|128)}}return a}function U(t){for(var e=[],r=0;r<t.length;++r)e.push(255&t.charCodeAt(r));return e}function V(t,e){for(var r,n,i,a=[],o=0;o<t.length&&!((e-=2)<0);++o)r=t.charCodeAt(o),n=r>>8,i=r%256,a.push(i),a.push(n);return a}function H(t){return X.toByteArray(j(t))}function q(t,e,r,n){for(var i=0;i<n&&!(i+r>=e.length||i>=t.length);++i)e[i+r]=t[i];return i}function G(t){return\"function\"==typeof ArrayBuffer.isView&&ArrayBuffer.isView(t)}function Y(t){return t!==t}var X=t(\"base64-js\"),W=t(\"ieee754\");r.Buffer=i,r.SlowBuffer=p,r.INSPECT_MAX_BYTES=50;var Z=2147483647;r.kMaxLength=Z,i.TYPED_ARRAY_SUPPORT=function(){try{var t=new Uint8Array(1);return t.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===t.foo()}catch(t){return!1}}(),i.TYPED_ARRAY_SUPPORT||\"undefined\"==typeof console||\"function\"!=typeof console.error||console.error(\"This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support.\"),\"undefined\"!=typeof Symbol&&Symbol.species&&i[Symbol.species]===i&&Object.defineProperty(i,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}),i.poolSize=8192,i.from=function(t,e,r){return a(t,e,r)},i.prototype.__proto__=Uint8Array.prototype,i.__proto__=Uint8Array,i.alloc=function(t,e,r){return s(t,e,r)},i.allocUnsafe=function(t){return l(t)},i.allocUnsafeSlow=function(t){return l(t)},i.isBuffer=function(t){return null!=t&&!0===t._isBuffer},i.compare=function(t,e){if(!i.isBuffer(t)||!i.isBuffer(e))throw new TypeError(\"Arguments must be Buffers\");if(t===e)return 0;for(var r=t.length,n=e.length,a=0,o=Math.min(r,n);a<o;++a)if(t[a]!==e[a]){r=t[a],n=e[a];break}return r<n?-1:n<r?1:0},i.isEncoding=function(t){switch(String(t).toLowerCase()){case\"hex\":case\"utf8\":case\"utf-8\":case\"ascii\":case\"latin1\":case\"binary\":case\"base64\":case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return!0;default:return!1}},i.concat=function(t,e){if(!Array.isArray(t))throw new TypeError('\"list\" argument must be an Array of Buffers');if(0===t.length)return i.alloc(0);var r;if(void 0===e)for(e=0,r=0;r<t.length;++r)e+=t[r].length;var n=i.allocUnsafe(e),a=0;for(r=0;r<t.length;++r){var o=t[r];if(!i.isBuffer(o))throw new TypeError('\"list\" argument must be an Array of Buffers');o.copy(n,a),a+=o.length}return n},i.byteLength=m,i.prototype._isBuffer=!0,i.prototype.swap16=function(){var t=this.length;if(t%2!=0)throw new RangeError(\"Buffer size must be a multiple of 16-bits\");for(var e=0;e<t;e+=2)g(this,e,e+1);return this},i.prototype.swap32=function(){var t=this.length;if(t%4!=0)throw new RangeError(\"Buffer size must be a multiple of 32-bits\");for(var e=0;e<t;e+=4)g(this,e,e+3),g(this,e+1,e+2);return this},i.prototype.swap64=function(){var t=this.length;if(t%8!=0)throw new RangeError(\"Buffer size must be a multiple of 64-bits\");for(var e=0;e<t;e+=8)g(this,e,e+7),g(this,e+1,e+6),g(this,e+2,e+5),g(this,e+3,e+4);return this},i.prototype.toString=function(){var t=this.length;return 0===t?\"\":0===arguments.length?S(this,0,t):v.apply(this,arguments)},i.prototype.equals=function(t){if(!i.isBuffer(t))throw new TypeError(\"Argument must be a Buffer\");return this===t||0===i.compare(this,t)},i.prototype.inspect=function(){var t=\"\",e=r.INSPECT_MAX_BYTES;return this.length>0&&(t=this.toString(\"hex\",0,e).match(/.{2}/g).join(\" \"),this.length>e&&(t+=\" ... \")),\"<Buffer \"+t+\">\"},i.prototype.compare=function(t,e,r,n,a){if(!i.isBuffer(t))throw new TypeError(\"Argument must be a Buffer\");if(void 0===e&&(e=0),void 0===r&&(r=t?t.length:0),void 0===n&&(n=0),void 0===a&&(a=this.length),e<0||r>t.length||n<0||a>this.length)throw new RangeError(\"out of range index\");if(n>=a&&e>=r)return 0;if(n>=a)return-1;if(e>=r)return 1;if(e>>>=0,r>>>=0,n>>>=0,a>>>=0,this===t)return 0;for(var o=a-n,s=r-e,l=Math.min(o,s),u=this.slice(n,a),c=t.slice(e,r),h=0;h<l;++h)if(u[h]!==c[h]){o=u[h],s=c[h];break}return o<s?-1:s<o?1:0},i.prototype.includes=function(t,e,r){return-1!==this.indexOf(t,e,r)},i.prototype.indexOf=function(t,e,r){return y(this,t,e,r,!0)},i.prototype.lastIndexOf=function(t,e,r){return y(this,t,e,r,!1)},i.prototype.write=function(t,e,r,n){if(void 0===e)n=\"utf8\",r=this.length,e=0;else if(void 0===r&&\"string\"==typeof e)n=e,r=this.length,e=0;else{if(!isFinite(e))throw new Error(\"Buffer.write(string, encoding, offset[, length]) is no longer supported\");e>>>=0,isFinite(r)?(r>>>=0,void 0===n&&(n=\"utf8\")):(n=r,r=void 0)}var i=this.length-e;if((void 0===r||r>i)&&(r=i),t.length>0&&(r<0||e<0)||e>this.length)throw new RangeError(\"Attempt to write outside buffer bounds\");n||(n=\"utf8\");for(var a=!1;;)switch(n){case\"hex\":return x(this,t,e,r);case\"utf8\":case\"utf-8\":return _(this,t,e,r);case\"ascii\":return w(this,t,e,r);case\"latin1\":case\"binary\":return M(this,t,e,r);case\"base64\":return k(this,t,e,r);case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return A(this,t,e,r);default:if(a)throw new TypeError(\"Unknown encoding: \"+n);n=(\"\"+n).toLowerCase(),a=!0}},i.prototype.toJSON=function(){return{type:\"Buffer\",data:Array.prototype.slice.call(this._arr||this,0)}};var J=4096;i.prototype.slice=function(t,e){var r=this.length;t=~~t,e=void 0===e?r:~~e,t<0?(t+=r)<0&&(t=0):t>r&&(t=r),e<0?(e+=r)<0&&(e=0):e>r&&(e=r),e<t&&(e=t);var n=this.subarray(t,e);return n.__proto__=i.prototype,n},i.prototype.readUIntLE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t],i=1,a=0;++a<e&&(i*=256);)n+=this[t+a]*i;return n},i.prototype.readUIntBE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t+--e],i=1;e>0&&(i*=256);)n+=this[t+--e]*i;return n},i.prototype.readUInt8=function(t,e){return t>>>=0,e||D(t,1,this.length),this[t]},i.prototype.readUInt16LE=function(t,e){return t>>>=0,e||D(t,2,this.length),this[t]|this[t+1]<<8},i.prototype.readUInt16BE=function(t,e){return t>>>=0,e||D(t,2,this.length),this[t]<<8|this[t+1]},i.prototype.readUInt32LE=function(t,e){return t>>>=0,e||D(t,4,this.length),(this[t]|this[t+1]<<8|this[t+2]<<16)+16777216*this[t+3]},i.prototype.readUInt32BE=function(t,e){return t>>>=0,e||D(t,4,this.length),16777216*this[t]+(this[t+1]<<16|this[t+2]<<8|this[t+3])},i.prototype.readIntLE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t],i=1,a=0;++a<e&&(i*=256);)n+=this[t+a]*i;return i*=128,n>=i&&(n-=Math.pow(2,8*e)),n},i.prototype.readIntBE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=e,i=1,a=this[t+--n];n>0&&(i*=256);)a+=this[t+--n]*i;return i*=128,a>=i&&(a-=Math.pow(2,8*e)),a},i.prototype.readInt8=function(t,e){return t>>>=0,e||D(t,1,this.length),128&this[t]?-1*(255-this[t]+1):this[t]},i.prototype.readInt16LE=function(t,e){t>>>=0,e||D(t,2,this.length);var r=this[t]|this[t+1]<<8;return 32768&r?4294901760|r:r},i.prototype.readInt16BE=function(t,e){t>>>=0,e||D(t,2,this.length);var r=this[t+1]|this[t]<<8;return 32768&r?4294901760|r:r},i.prototype.readInt32LE=function(t,e){return t>>>=0,e||D(t,4,this.length),this[t]|this[t+1]<<8|this[t+2]<<16|this[t+3]<<24},i.prototype.readInt32BE=function(t,e){return t>>>=0,e||D(t,4,this.length),this[t]<<24|this[t+1]<<16|this[t+2]<<8|this[t+3]},i.prototype.readFloatLE=function(t,e){return t>>>=0,e||D(t,4,this.length),W.read(this,t,!0,23,4)},i.prototype.readFloatBE=function(t,e){return t>>>=0,e||D(t,4,this.length),W.read(this,t,!1,23,4)},i.prototype.readDoubleLE=function(t,e){return t>>>=0,e||D(t,8,this.length),W.read(this,t,!0,52,8)},i.prototype.readDoubleBE=function(t,e){return t>>>=0,e||D(t,8,this.length),W.read(this,t,!1,52,8)},i.prototype.writeUIntLE=function(t,e,r,n){if(t=+t,e>>>=0,r>>>=0,!n){P(this,t,e,r,Math.pow(2,8*r)-1,0)}var i=1,a=0;for(this[e]=255&t;++a<r&&(i*=256);)this[e+a]=t/i&255;return e+r},i.prototype.writeUIntBE=function(t,e,r,n){if(t=+t,e>>>=0,r>>>=0,!n){P(this,t,e,r,Math.pow(2,8*r)-1,0)}var i=r-1,a=1;for(this[e+i]=255&t;--i>=0&&(a*=256);)this[e+i]=t/a&255;return e+r},i.prototype.writeUInt8=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,1,255,0),this[e]=255&t,e+1},i.prototype.writeUInt16LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,65535,0),this[e]=255&t,this[e+1]=t>>>8,e+2},i.prototype.writeUInt16BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,65535,0),this[e]=t>>>8,this[e+1]=255&t,e+2},i.prototype.writeUInt32LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,4294967295,0),this[e+3]=t>>>24,this[e+2]=t>>>16,this[e+1]=t>>>8,this[e]=255&t,e+4},i.prototype.writeUInt32BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,4294967295,0),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},i.prototype.writeIntLE=function(t,e,r,n){if(t=+t,e>>>=0,!n){var i=Math.pow(2,8*r-1);P(this,t,e,r,i-1,-i)}var a=0,o=1,s=0;for(this[e]=255&t;++a<r&&(o*=256);)t<0&&0===s&&0!==this[e+a-1]&&(s=1),this[e+a]=(t/o>>0)-s&255;return e+r},i.prototype.writeIntBE=function(t,e,r,n){if(t=+t,e>>>=0,!n){var i=Math.pow(2,8*r-1);P(this,t,e,r,i-1,-i)}var a=r-1,o=1,s=0;for(this[e+a]=255&t;--a>=0&&(o*=256);)t<0&&0===s&&0!==this[e+a+1]&&(s=1),this[e+a]=(t/o>>0)-s&255;return e+r},i.prototype.writeInt8=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,1,127,-128),t<0&&(t=255+t+1),this[e]=255&t,e+1},i.prototype.writeInt16LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,32767,-32768),this[e]=255&t,this[e+1]=t>>>8,e+2},i.prototype.writeInt16BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,32767,-32768),this[e]=t>>>8,this[e+1]=255&t,e+2},i.prototype.writeInt32LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,2147483647,-2147483648),this[e]=255&t,this[e+1]=t>>>8,this[e+2]=t>>>16,this[e+3]=t>>>24,e+4},i.prototype.writeInt32BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,2147483647,-2147483648),t<0&&(t=4294967295+t+1),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},i.prototype.writeFloatLE=function(t,e,r){return R(this,t,e,!0,r)},i.prototype.writeFloatBE=function(t,e,r){return R(this,t,e,!1,r)},i.prototype.writeDoubleLE=function(t,e,r){return F(this,t,e,!0,r)},i.prototype.writeDoubleBE=function(t,e,r){return F(this,t,e,!1,r)},i.prototype.copy=function(t,e,r,n){if(r||(r=0),n||0===n||(n=this.length),e>=t.length&&(e=t.length),e||(e=0),n>0&&n<r&&(n=r),n===r)return 0;if(0===t.length||0===this.length)return 0;if(e<0)throw new RangeError(\"targetStart out of bounds\");if(r<0||r>=this.length)throw new RangeError(\"sourceStart out of bounds\");if(n<0)throw new RangeError(\"sourceEnd out of bounds\");n>this.length&&(n=this.length),t.length-e<n-r&&(n=t.length-e+r);var i,a=n-r;if(this===t&&r<e&&e<n)for(i=a-1;i>=0;--i)t[i+e]=this[i+r];else if(a<1e3)for(i=0;i<a;++i)t[i+e]=this[i+r];else Uint8Array.prototype.set.call(t,this.subarray(r,r+a),e);return a},i.prototype.fill=function(t,e,r,n){if(\"string\"==typeof t){if(\"string\"==typeof e?(n=e,e=0,r=this.length):\"string\"==typeof r&&(n=r,r=this.length),1===t.length){var a=t.charCodeAt(0);a<256&&(t=a)}if(void 0!==n&&\"string\"!=typeof n)throw new TypeError(\"encoding must be a string\");if(\"string\"==typeof n&&!i.isEncoding(n))throw new TypeError(\"Unknown encoding: \"+n)}else\"number\"==typeof t&&(t&=255);if(e<0||this.length<e||this.length<r)throw new RangeError(\"Out of range index\");if(r<=e)return this;e>>>=0,r=void 0===r?this.length:r>>>0,t||(t=0);var o;if(\"number\"==typeof t)for(o=e;o<r;++o)this[o]=t;else{var s=i.isBuffer(t)?t:new i(t,n),l=s.length;for(o=0;o<r-e;++o)this[o+e]=s[o%l]}return this};var K=/[^+\\/0-9A-Za-z-_]/g},{\"base64-js\":77,ieee754:288}],77:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e%4>0)throw new Error(\"Invalid string. Length must be a multiple of 4\");return\"=\"===t[e-2]?2:\"=\"===t[e-1]?1:0}function i(t){return 3*t.length/4-n(t)}function a(t){var e,r,i,a,o,s,l=t.length;o=n(t),s=new h(3*l/4-o),i=o>0?l-4:l;var u=0;for(e=0,r=0;e<i;e+=4,r+=3)a=c[t.charCodeAt(e)]<<18|c[t.charCodeAt(e+1)]<<12|c[t.charCodeAt(e+2)]<<6|c[t.charCodeAt(e+3)],s[u++]=a>>16&255,s[u++]=a>>8&255,s[u++]=255&a;return 2===o?(a=c[t.charCodeAt(e)]<<2|c[t.charCodeAt(e+1)]>>4,s[u++]=255&a):1===o&&(a=c[t.charCodeAt(e)]<<10|c[t.charCodeAt(e+1)]<<4|c[t.charCodeAt(e+2)]>>2,s[u++]=a>>8&255,s[u++]=255&a),s}function o(t){return u[t>>18&63]+u[t>>12&63]+u[t>>6&63]+u[63&t]}function s(t,e,r){for(var n,i=[],a=e;a<r;a+=3)n=(t[a]<<16)+(t[a+1]<<8)+t[a+2],i.push(o(n));return i.join(\"\")}function l(t){for(var e,r=t.length,n=r%3,i=\"\",a=[],o=0,l=r-n;o<l;o+=16383)a.push(s(t,o,o+16383>l?l:o+16383));return 1===n?(e=t[r-1],i+=u[e>>2],i+=u[e<<4&63],i+=\"==\"):2===n&&(e=(t[r-2]<<8)+t[r-1],i+=u[e>>10],i+=u[e>>4&63],i+=u[e<<2&63],i+=\"=\"),a.push(i),a.join(\"\")}r.byteLength=i,r.toByteArray=a,r.fromByteArray=l;for(var u=[],c=[],h=\"undefined\"!=typeof Uint8Array?Uint8Array:Array,f=\"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\",d=0,p=f.length;d<p;++d)u[d]=f[d],c[f.charCodeAt(d)]=d;c[\"-\".charCodeAt(0)]=62,c[\"_\".charCodeAt(0)]=63},{}],78:[function(t,e,r){\"use strict\";function n(t){return[Math.min(t[0],t[1]),Math.max(t[0],t[1])]}function i(t,e){return t[0]-e[0]||t[1]-e[1]}function a(t){return t.map(n).sort(i)}function o(t,e,r){return e in t?t[e]:r}function s(t,e,r){Array.isArray(e)?(r=r||{},e=e||[]):(r=e||{},e=[]);var n=!!o(r,\"delaunay\",!0),i=!!o(r,\"interior\",!0),s=!!o(r,\"exterior\",!0),f=!!o(r,\"infinity\",!1);if(!i&&!s||0===t.length)return[];var d=l(t,e);if(n||i!==s||f){for(var p=u(t.length,a(e)),m=0;m<d.length;++m){var v=d[m];p.addTriangle(v[0],v[1],v[2])}return n&&c(t,p),s?i?f?h(p,0,f):p.cells():h(p,1,f):h(p,-1)}return d}var l=t(\"./lib/monotone\"),u=t(\"./lib/triangulation\"),c=t(\"./lib/delaunay\"),h=t(\"./lib/filter\");e.exports=s},{\"./lib/delaunay\":79,\"./lib/filter\":80,\"./lib/monotone\":81,\"./lib/triangulation\":82}],79:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,o){var s=e.opposite(n,i);if(!(s<0)){if(i<n){var l=n;n=i,i=l,l=o,o=s,s=l}e.isConstraint(n,i)||a(t[n],t[i],t[o],t[s])<0&&r.push(n,i)}}function i(t,e){for(var r=[],i=t.length,o=e.stars,s=0;s<i;++s)for(var l=o[s],u=1;u<l.length;u+=2){var c=l[u];if(!(c<s)&&!e.isConstraint(s,c)){for(var h=l[u-1],f=-1,d=1;d<l.length;d+=2)if(l[d-1]===c){f=l[d];break}f<0||a(t[s],t[c],t[h],t[f])<0&&r.push(s,c)}}for(;r.length>0;){for(var c=r.pop(),s=r.pop(),h=-1,f=-1,l=o[s],p=1;p<l.length;p+=2){var m=l[p-1],v=l[p];m===c?f=v:v===c&&(h=m)}h<0||f<0||(a(t[s],t[c],t[h],t[f])>=0||(e.flip(s,c),n(t,e,r,h,s,f),n(t,e,r,s,f,h),n(t,e,r,f,c,h),n(t,e,r,c,h,f)))}}var a=t(\"robust-in-sphere\")[4];t(\"binary-search-bounds\");e.exports=i},{\"binary-search-bounds\":83,\"robust-in-sphere\":505}],80:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.cells=t,this.neighbor=e,this.flags=n,this.constraint=r,this.active=i,this.next=a,this.boundary=o}function i(t,e){return t[0]-e[0]||t[1]-e[1]||t[2]-e[2]}function a(t,e){for(var r=t.cells(),a=r.length,o=0;o<a;++o){var s=r[o],l=s[0],u=s[1],c=s[2];u<c?u<l&&(s[0]=u,s[1]=c,s[2]=l):c<l&&(s[0]=c,s[1]=l,s[2]=u)}r.sort(i);for(var h=new Array(a),o=0;o<h.length;++o)h[o]=0;var f=[],d=[],p=new Array(3*a),m=new Array(3*a),v=null;e&&(v=[]);for(var g=new n(r,p,m,h,f,d,v),o=0;o<a;++o)for(var s=r[o],y=0;y<3;++y){var l=s[y],u=s[(y+1)%3],b=p[3*o+y]=g.locate(u,l,t.opposite(u,l)),x=m[3*o+y]=t.isConstraint(l,u);b<0&&(x?d.push(o):(f.push(o),h[o]=1),e&&v.push([u,l,-1]))}return g}function o(t,e,r){for(var n=0,i=0;i<t.length;++i)e[i]===r&&(t[n++]=t[i]);return t.length=n,t}function s(t,e,r){var n=a(t,r);if(0===e)return r?n.cells.concat(n.boundary):n.cells;for(var i=1,s=n.active,l=n.next,u=n.flags,c=n.cells,h=n.constraint,f=n.neighbor;s.length>0||l.length>0;){for(;s.length>0;){var d=s.pop();if(u[d]!==-i){u[d]=i;for(var p=(c[d],0);p<3;++p){var m=f[3*d+p];m>=0&&0===u[m]&&(h[3*d+p]?l.push(m):(s.push(m),u[m]=i))}}}var v=l;l=s,s=v,l.length=0,i=-i}var g=o(c,u,e);return r?g.concat(n.boundary):g}var l=t(\"binary-search-bounds\");e.exports=s,n.prototype.locate=function(){var t=[0,0,0];return function(e,r,n){var a=e,o=r,s=n;return r<n?r<e&&(a=r,o=n,s=e):n<e&&(a=n,o=e,s=r),a<0?-1:(t[0]=a,t[1]=o,t[2]=s,l.eq(this.cells,t,i))}}()},{\"binary-search-bounds\":83}],81:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.a=t,this.b=e,this.idx=r,this.lowerIds=n,this.upperIds=i}function i(t,e,r,n){this.a=t,this.b=e,this.type=r,this.idx=n}function a(t,e){var r=t.a[0]-e.a[0]||t.a[1]-e.a[1]||t.type-e.type;return r||(t.type!==p&&(r=d(t.a,t.b,e.b))?r:t.idx-e.idx)}function o(t,e){return d(t.a,t.b,e)}function s(t,e,r,n,i){for(var a=f.lt(e,n,o),s=f.gt(e,n,o),l=a;l<s;++l){for(var u=e[l],c=u.lowerIds,h=c.length;h>1&&d(r[c[h-2]],r[c[h-1]],n)>0;)t.push([c[h-1],c[h-2],i]),h-=1;c.length=h,c.push(i);for(var p=u.upperIds,h=p.length;h>1&&d(r[p[h-2]],r[p[h-1]],n)<0;)t.push([p[h-2],p[h-1],i]),h-=1;p.length=h,p.push(i)}}function l(t,e){var r;return(r=t.a[0]<e.a[0]?d(t.a,t.b,e.a):d(e.b,e.a,t.a))?r:(r=e.b[0]<t.b[0]?d(t.a,t.b,e.b):d(e.b,e.a,t.b))||t.idx-e.idx}function u(t,e,r){var i=f.le(t,r,l),a=t[i],o=a.upperIds,s=o[o.length-1];a.upperIds=[s],t.splice(i+1,0,new n(r.a,r.b,r.idx,[s],o))}function c(t,e,r){var n=r.a;r.a=r.b,r.b=n;var i=f.eq(t,r,l),a=t[i];t[i-1].upperIds=a.upperIds,t.splice(i,1)}function h(t,e){for(var r=t.length,o=e.length,l=[],h=0;h<r;++h)l.push(new i(t[h],null,p,h));for(var h=0;h<o;++h){var f=e[h],d=t[f[0]],g=t[f[1]];d[0]<g[0]?l.push(new i(d,g,v,h),new i(g,d,m,h)):d[0]>g[0]&&l.push(new i(g,d,v,h),new i(d,g,m,h))}l.sort(a);for(var y=l[0].a[0]-(1+Math.abs(l[0].a[0]))*Math.pow(2,-52),b=[new n([y,1],[y,0],-1,[],[],[],[])],x=[],h=0,_=l.length;h<_;++h){var w=l[h],M=w.type;M===p?s(x,b,t,w.a,w.idx):M===v?u(b,t,w):c(b,t,w)}return x}var f=t(\"binary-search-bounds\"),d=t(\"robust-orientation\")[3],p=0,m=1,v=2;e.exports=h},{\"binary-search-bounds\":83,\"robust-orientation\":507}],82:[function(t,e,r){\"use strict\";function n(t,e){this.stars=t,this.edges=e}function i(t,e,r){for(var n=1,i=t.length;n<i;n+=2)if(t[n-1]===e&&t[n]===r)return t[n-1]=t[i-2],t[n]=t[i-1],void(t.length=i-2)}function a(t,e){for(var r=new Array(t),i=0;i<t;++i)r[i]=[];return new n(r,e)}var o=t(\"binary-search-bounds\");e.exports=a;var s=n.prototype;s.isConstraint=function(){function t(t,e){return t[0]-e[0]||t[1]-e[1]}var e=[0,0];return function(r,n){return e[0]=Math.min(r,n),e[1]=Math.max(r,n),o.eq(this.edges,e,t)>=0}}(),s.removeTriangle=function(t,e,r){var n=this.stars;i(n[t],e,r),i(n[e],r,t),i(n[r],t,e)},s.addTriangle=function(t,e,r){var n=this.stars;n[t].push(e,r),n[e].push(r,t),n[r].push(t,e)},s.opposite=function(t,e){for(var r=this.stars[e],n=1,i=r.length;n<i;n+=2)if(r[n]===t)return r[n-1];return-1},s.flip=function(t,e){var r=this.opposite(t,e),n=this.opposite(e,t);this.removeTriangle(t,e,r),this.removeTriangle(e,t,n),this.addTriangle(t,n,r),this.addTriangle(e,r,n)},s.edges=function(){for(var t=this.stars,e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;a+=2)e.push([i[a],i[a+1]]);return e},s.cells=function(){for(var t=this.stars,e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;a+=2){var s=i[a],l=i[a+1];r<Math.min(s,l)&&e.push([r,s,l])}return e}},{\"binary-search-bounds\":83}],83:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=[\"function \",t,\"(a,l,h,\",n.join(\",\"),\"){\",i?\"\":\"var i=\",r?\"l-1\":\"h+1\",\";while(l<=h){var m=(l+h)>>>1,x=a[m]\"];return i?e.indexOf(\"c\")<0?a.push(\";if(x===y){return m}else if(x<=y){\"):a.push(\";var p=c(x,y);if(p===0){return m}else if(p<=0){\"):a.push(\";if(\",e,\"){i=m;\"),r?a.push(\"l=m+1}else{h=m-1}\"):a.push(\"h=m-1}else{l=m+1}\"),a.push(\"}\"),i?a.push(\"return -1};\"):a.push(\"return i};\"),a.join(\"\")}function i(t,e,r,i){return new Function([n(\"A\",\"x\"+t+\"y\",e,[\"y\"],i),n(\"P\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],i),\"function dispatchBsearch\",r,\"(a,y,c,l,h){if(typeof(c)==='function'){return P(a,(l===void 0)?0:l|0,(h===void 0)?a.length-1:h|0,y,c)}else{return A(a,(c===void 0)?0:c|0,(l===void 0)?a.length-1:l|0,y)}}return dispatchBsearch\",r].join(\"\"))()}e.exports={ge:i(\">=\",!1,\"GE\"),gt:i(\">\",!1,\"GT\"),lt:i(\"<\",!0,\"LT\"),le:i(\"<=\",!0,\"LE\"),eq:i(\"-\",!0,\"EQ\",!0)}},{}],84:[function(t,e,r){\"use strict\";function n(t){for(var e=1,r=1;r<t.length;++r)for(var n=0;n<r;++n)if(t[r]<t[n])e=-e;else if(t[n]===t[r])return 0;return e}e.exports=n},{}],85:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0,n=t.length,i=0;i<n;++i)r+=t[i]*e[i];return r}function i(t){var e=t.length;if(0===e)return[];var r=(t[0].length,o([t.length+1,t.length+1],1)),i=o([t.length+1],1);r[e][e]=0;for(var a=0;a<e;++a){for(var l=0;l<=a;++l)r[l][a]=r[a][l]=2*n(t[a],t[l]);i[a]=n(t[a],t[a])}for(var u=s(r,i),c=0,h=u[e+1],a=0;a<h.length;++a)c+=h[a];for(var f=new Array(e),a=0;a<e;++a){for(var h=u[a],d=0,l=0;l<h.length;++l)d+=h[l];f[a]=d/c}return f}function a(t){if(0===t.length)return[];for(var e=t[0].length,r=o([e]),n=i(t),a=0;a<t.length;++a)for(var s=0;s<e;++s)r[s]+=t[a][s]*n[a];return r}var o=t(\"dup\"),s=t(\"robust-linear-solve\");a.barycenetric=i,e.exports=a},{dup:124,\"robust-linear-solve\":506}],86:[function(t,e,r){function n(t){for(var e=i(t),r=0,n=0;n<t.length;++n)for(var a=t[n],o=0;o<e.length;++o)r+=Math.pow(a[o]-e[o],2);return Math.sqrt(r/t.length)}e.exports=n;var i=t(\"circumcenter\")},{circumcenter:85}],87:[function(t,e,r){function n(t,e,r){return e<r?t<e?e:t>r?r:t:t<r?r:t>e?e:t}e.exports=n},{}],88:[function(t,e,r){\"use strict\";function n(t){var e=_(t);return[M(e,-1/0),M(e,1/0)]}function i(t,e){for(var r=new Array(e.length),n=0;n<e.length;++n){var i=e[n],a=t[i[0]],o=t[i[1]];r[n]=[M(Math.min(a[0],o[0]),-1/0),M(Math.min(a[1],o[1]),-1/0),M(Math.max(a[0],o[0]),1/0),M(Math.max(a[1],o[1]),1/0)]}return r}function a(t){for(var e=new Array(t.length),r=0;r<t.length;++r){var n=t[r];e[r]=[M(n[0],-1/0),M(n[1],-1/0),M(n[0],1/0),M(n[1],1/0)]}return e}function o(t,e,r){var n=[];return g(r,function(r,i){var a=e[r],o=e[i];if(a[0]!==o[0]&&a[0]!==o[1]&&a[1]!==o[0]&&a[1]!==o[1]){var s=t[a[0]],l=t[a[1]],u=t[o[0]],c=t[o[1]];y(s,l,u,c)&&n.push([r,i])}}),n}function s(t,e,r,n){var i=[];return g(r,n,function(r,n){var a=e[r];if(a[0]!==n&&a[1]!==n){var o=t[n],s=t[a[0]],l=t[a[1]];y(s,l,o,o)&&i.push([r,n])}}),i}function l(t,e,r,n,i){var a,o,s=t.map(function(t){return[b(t[0]),b(t[1])]});for(a=0;a<r.length;++a){var l=r[a];o=l[0];var u=l[1],c=e[o],h=e[u],f=k(w(t[c[0]]),w(t[c[1]]),w(t[h[0]]),w(t[h[1]]));if(f){var d=t.length;t.push([_(f[0]),_(f[1])]),s.push(f),n.push([o,d],[u,d])}}for(n.sort(function(t,e){if(t[0]!==e[0])return t[0]-e[0];var r=s[t[1]],n=s[e[1]];return x(r[0],n[0])||x(r[1],n[1])}),a=n.length-1;a>=0;--a){var p=n[a];o=p[0];var m=e[o],v=m[0],g=m[1],y=t[v],M=t[g];if((y[0]-M[0]||y[1]-M[1])<0){var A=v;v=g,g=A}m[0]=v;var T,S=m[1]=p[1];for(i&&(T=m[2]);a>0&&n[a-1][0]===o;){var p=n[--a],E=p[1];i?e.push([S,E,T]):e.push([S,E]),S=E}i?e.push([S,g,T]):e.push([S,g])}return s}function u(t,e,r){for(var i=e.length,a=new v(i),o=[],s=0;s<e.length;++s){var l=e[s],u=n(l[0]),c=n(l[1]);o.push([M(u[0],-1/0),M(c[0],-1/0),M(u[1],1/0),M(c[1],1/0)])}g(o,function(t,e){a.link(t,e)});for(var h=!0,f=new Array(i),s=0;s<i;++s){var d=a.find(s);d!==s&&(h=!1,t[d]=[Math.min(t[s][0],t[d][0]),Math.min(t[s][1],t[d][1])])}if(h)return null;for(var p=0,s=0;s<i;++s){var d=a.find(s);d===s?(f[s]=p,t[p++]=t[s]):f[s]=-1}t.length=p;for(var s=0;s<i;++s)f[s]<0&&(f[s]=f[a.find(s)]);return f}function c(t,e){return t[0]-e[0]||t[1]-e[1]}function h(t,e){var r=t[0]-e[0]||t[1]-e[1];return r||(t[2]<e[2]?-1:t[2]>e[2]?1:0)}function f(t,e,r){if(0!==t.length){if(e)for(var n=0;n<t.length;++n){var i=t[n],a=e[i[0]],o=e[i[1]]\n",
       ";i[0]=Math.min(a,o),i[1]=Math.max(a,o)}else for(var n=0;n<t.length;++n){var i=t[n],a=i[0],o=i[1];i[0]=Math.min(a,o),i[1]=Math.max(a,o)}r?t.sort(h):t.sort(c);for(var s=1,n=1;n<t.length;++n){var l=t[n-1],u=t[n];(u[0]!==l[0]||u[1]!==l[1]||r&&u[2]!==l[2])&&(t[s++]=u)}t.length=s}}function d(t,e,r){var n=u(t,[],a(t));return f(e,n,r),!!n}function p(t,e,r){var n=i(t,e),c=o(t,e,n),h=a(t),d=s(t,e,n,h),p=l(t,e,c,d,r),m=u(t,p,h);return f(e,m,r),!!m||(c.length>0||d.length>0)}function m(t,e,r){var n;if(r){n=e;for(var i=new Array(e.length),a=0;a<e.length;++a){var o=e[a];i[a]=[o[0],o[1],r[a]]}e=i}for(var s=d(t,e,!!r);p(t,e,!!r);)s=!0;if(r&&s){n.length=0,r.length=0;for(var a=0;a<e.length;++a){var o=e[a];n.push([o[0],o[1]]),r.push(o[2])}}return s}e.exports=m;var v=t(\"union-find\"),g=t(\"box-intersect\"),y=t(\"robust-segment-intersect\"),b=t(\"big-rat\"),x=t(\"big-rat/cmp\"),_=t(\"big-rat/to-float\"),w=t(\"rat-vec\"),M=t(\"nextafter\"),k=t(\"./lib/rat-seg-intersect\")},{\"./lib/rat-seg-intersect\":89,\"big-rat\":52,\"big-rat/cmp\":50,\"big-rat/to-float\":64,\"box-intersect\":69,nextafter:467,\"rat-vec\":494,\"robust-segment-intersect\":510,\"union-find\":541}],89:[function(t,e,r){\"use strict\";function n(t,e){return s(a(t[0],e[1]),a(t[1],e[0]))}function i(t,e,r,i){var a=u(e,t),s=u(i,r),f=n(a,s);if(0===l(f))return null;var d=u(t,r),p=n(s,d),m=o(p,f),v=h(a,m);return c(t,v)}e.exports=i;var a=t(\"big-rat/mul\"),o=t(\"big-rat/div\"),s=t(\"big-rat/sub\"),l=t(\"big-rat/sign\"),u=t(\"rat-vec/sub\"),c=t(\"rat-vec/add\"),h=t(\"rat-vec/muls\")},{\"big-rat/div\":51,\"big-rat/mul\":61,\"big-rat/sign\":62,\"big-rat/sub\":63,\"rat-vec/add\":493,\"rat-vec/muls\":495,\"rat-vec/sub\":496}],90:[function(t,e,r){(function(t){var r=function(){\"use strict\";function e(r,n,i,a){function s(r,i){if(null===r)return null;if(0==i)return r;var h,f;if(\"object\"!=typeof r)return r;if(e.__isArray(r))h=[];else if(e.__isRegExp(r))h=new RegExp(r.source,o(r)),r.lastIndex&&(h.lastIndex=r.lastIndex);else if(e.__isDate(r))h=new Date(r.getTime());else{if(c&&t.isBuffer(r))return h=new t(r.length),r.copy(h),h;void 0===a?(f=Object.getPrototypeOf(r),h=Object.create(f)):(h=Object.create(a),f=a)}if(n){var d=l.indexOf(r);if(-1!=d)return u[d];l.push(r),u.push(h)}for(var p in r){var m;f&&(m=Object.getOwnPropertyDescriptor(f,p)),m&&null==m.set||(h[p]=s(r[p],i-1))}return h}\"object\"==typeof n&&(i=n.depth,a=n.prototype,n.filter,n=n.circular);var l=[],u=[],c=void 0!==t;return void 0===n&&(n=!0),void 0===i&&(i=1/0),s(r,i)}function r(t){return Object.prototype.toString.call(t)}function n(t){return\"object\"==typeof t&&\"[object Date]\"===r(t)}function i(t){return\"object\"==typeof t&&\"[object Array]\"===r(t)}function a(t){return\"object\"==typeof t&&\"[object RegExp]\"===r(t)}function o(t){var e=\"\";return t.global&&(e+=\"g\"),t.ignoreCase&&(e+=\"i\"),t.multiline&&(e+=\"m\"),e}return e.clonePrototype=function(t){if(null===t)return null;var e=function(){};return e.prototype=t,new e},e.__objToStr=r,e.__isDate=n,e.__isArray=i,e.__isRegExp=a,e.__getRegExpFlags=o,e}();\"object\"==typeof e&&e.exports&&(e.exports=r)}).call(this,t(\"buffer\").Buffer)},{buffer:76}],91:[function(t,e,r){\"use strict\";function n(t,e){null==e&&(e=!0);var r=t[0],n=t[1],i=t[2],o=t[3];return null==o&&(o=e?1:255),e&&(r*=255,n*=255,i*=255,o*=255),r=255&a(r,0,255),n=255&a(n,0,255),i=255&a(i,0,255),o=255&a(o,0,255),16777216*r+(n<<16)+(i<<8)+o}function i(t,e){t=+t;var r=t>>>24,n=(16711680&t)>>>16,i=(65280&t)>>>8,a=255&t;return!1===e?[r,n,i,a]:[r/255,n/255,i/255,a/255]}var a=t(\"clamp\");e.exports=n,e.exports.to=n,e.exports.from=i},{clamp:87}],92:[function(t,e,r){\"use strict\";e.exports={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]}},{}],93:[function(t,e,r){(function(r){\"use strict\";function n(t){var e,n,s=[],l=1;if(\"string\"==typeof t)if(i[t])s=i[t].slice(),n=\"rgb\";else if(\"transparent\"===t)l=0,n=\"rgb\",s=[0,0,0];else if(/^#[A-Fa-f0-9]+$/.test(t)){var u=t.slice(1),c=u.length,h=c<=4;l=1,h?(s=[parseInt(u[0]+u[0],16),parseInt(u[1]+u[1],16),parseInt(u[2]+u[2],16)],4===c&&(l=parseInt(u[3]+u[3],16)/255)):(s=[parseInt(u[0]+u[1],16),parseInt(u[2]+u[3],16),parseInt(u[4]+u[5],16)],8===c&&(l=parseInt(u[6]+u[7],16)/255)),s[0]||(s[0]=0),s[1]||(s[1]=0),s[2]||(s[2]=0),n=\"rgb\"}else if(e=/^((?:rgb|hs[lvb]|hwb|cmyk?|xy[zy]|gray|lab|lchu?v?|[ly]uv|lms)a?)\\s*\\(([^\\)]*)\\)/.exec(t)){var f=e[1],u=f.replace(/a$/,\"\");n=u;var c=\"cmyk\"===u?4:\"gray\"===u?1:3;s=e[2].trim().split(/\\s*,\\s*/).map(function(t,e){if(/%$/.test(t))return e===c?parseFloat(t)/100:\"rgb\"===u?255*parseFloat(t)/100:parseFloat(t);if(\"h\"===u[e]){if(/deg$/.test(t))return parseFloat(t);if(void 0!==o[t])return o[t]}return parseFloat(t)}),f===u&&s.push(1),l=void 0===s[c]?1:s[c],s=s.slice(0,c)}else t.length>10&&/[0-9](?:\\s|\\/)/.test(t)&&(s=t.match(/([0-9]+)/g).map(function(t){return parseFloat(t)}),n=t.match(/([a-z])/gi).join(\"\").toLowerCase());else\"number\"==typeof t?(n=\"rgb\",s=[t>>>16,(65280&t)>>>8,255&t]):a(t)?(null!=t.r?(s=[t.r,t.g,t.b],n=\"rgb\"):null!=t.red?(s=[t.red,t.green,t.blue],n=\"rgb\"):null!=t.h?(s=[t.h,t.s,t.l],n=\"hsl\"):null!=t.hue&&(s=[t.hue,t.saturation,t.lightness],n=\"hsl\"),null!=t.a?l=t.a:null!=t.alpha?l=t.alpha:null!=t.opacity&&(l=t.opacity/100)):(Array.isArray(t)||r.ArrayBuffer&&ArrayBuffer.isView&&ArrayBuffer.isView(t))&&(s=[t[0],t[1],t[2]],n=\"rgb\",l=4===t.length?t[3]:1);return{space:n,values:s,alpha:l}}e.exports=n;var i=t(\"color-name\"),a=t(\"is-plain-obj\"),o={red:0,orange:60,yellow:120,green:180,blue:240,purple:300}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"color-name\":92,\"is-plain-obj\":296}],94:[function(t,e,r){\"use strict\";var n=t(\"color-parse\"),i=t(\"color-space/hsl\"),a=t(\"clamp\");e.exports=function(t,e){if(Array.isArray(t))return t;null==e&&(e=!0);var r=n(t);if(!r.space)return[];var o,s=r.values,l=s.length;for(o=0;o<l;o++)s[o]=a(s[o],0,255);if(\"h\"===r.space[0]&&(s=i.rgb(s)),e)for(o=0;o<l;o++)s[o]/=255;return s.push(a(r.alpha,0,1)),s}},{clamp:87,\"color-parse\":93,\"color-space/hsl\":95}],95:[function(t,e,r){\"use strict\";var n=t(\"./rgb\");e.exports={name:\"hsl\",min:[0,0,0],max:[360,100,100],channel:[\"hue\",\"saturation\",\"lightness\"],alias:[\"HSL\"],rgb:function(t){var e,r,n,i,a,o=t[0]/360,s=t[1]/100,l=t[2]/100;if(0===s)return a=255*l,[a,a,a];r=l<.5?l*(1+s):l+s-l*s,e=2*l-r,i=[0,0,0];for(var u=0;u<3;u++)n=o+1/3*-(u-1),n<0?n++:n>1&&n--,a=6*n<1?e+6*(r-e)*n:2*n<1?r:3*n<2?e+(r-e)*(2/3-n)*6:e,i[u]=255*a;return i}},n.hsl=function(t){var e,r,n,i=t[0]/255,a=t[1]/255,o=t[2]/255,s=Math.min(i,a,o),l=Math.max(i,a,o),u=l-s;return l===s?e=0:i===l?e=(a-o)/u:a===l?e=2+(o-i)/u:o===l&&(e=4+(i-a)/u),e=Math.min(60*e,360),e<0&&(e+=360),n=(s+l)/2,r=l===s?0:n<=.5?u/(l+s):u/(2-l-s),[e,100*r,100*n]}},{\"./rgb\":96}],96:[function(t,e,r){\"use strict\";e.exports={name:\"rgb\",min:[0,0,0],max:[255,255,255],channel:[\"red\",\"green\",\"blue\"],alias:[\"RGB\"]}},{}],97:[function(t,e,r){e.exports={jet:[{index:0,rgb:[0,0,131]},{index:.125,rgb:[0,60,170]},{index:.375,rgb:[5,255,255]},{index:.625,rgb:[255,255,0]},{index:.875,rgb:[250,0,0]},{index:1,rgb:[128,0,0]}],hsv:[{index:0,rgb:[255,0,0]},{index:.169,rgb:[253,255,2]},{index:.173,rgb:[247,255,2]},{index:.337,rgb:[0,252,4]},{index:.341,rgb:[0,252,10]},{index:.506,rgb:[1,249,255]},{index:.671,rgb:[2,0,253]},{index:.675,rgb:[8,0,253]},{index:.839,rgb:[255,0,251]},{index:.843,rgb:[255,0,245]},{index:1,rgb:[255,0,6]}],hot:[{index:0,rgb:[0,0,0]},{index:.3,rgb:[230,0,0]},{index:.6,rgb:[255,210,0]},{index:1,rgb:[255,255,255]}],cool:[{index:0,rgb:[0,255,255]},{index:1,rgb:[255,0,255]}],spring:[{index:0,rgb:[255,0,255]},{index:1,rgb:[255,255,0]}],summer:[{index:0,rgb:[0,128,102]},{index:1,rgb:[255,255,102]}],autumn:[{index:0,rgb:[255,0,0]},{index:1,rgb:[255,255,0]}],winter:[{index:0,rgb:[0,0,255]},{index:1,rgb:[0,255,128]}],bone:[{index:0,rgb:[0,0,0]},{index:.376,rgb:[84,84,116]},{index:.753,rgb:[169,200,200]},{index:1,rgb:[255,255,255]}],copper:[{index:0,rgb:[0,0,0]},{index:.804,rgb:[255,160,102]},{index:1,rgb:[255,199,127]}],greys:[{index:0,rgb:[0,0,0]},{index:1,rgb:[255,255,255]}],yignbu:[{index:0,rgb:[8,29,88]},{index:.125,rgb:[37,52,148]},{index:.25,rgb:[34,94,168]},{index:.375,rgb:[29,145,192]},{index:.5,rgb:[65,182,196]},{index:.625,rgb:[127,205,187]},{index:.75,rgb:[199,233,180]},{index:.875,rgb:[237,248,217]},{index:1,rgb:[255,255,217]}],greens:[{index:0,rgb:[0,68,27]},{index:.125,rgb:[0,109,44]},{index:.25,rgb:[35,139,69]},{index:.375,rgb:[65,171,93]},{index:.5,rgb:[116,196,118]},{index:.625,rgb:[161,217,155]},{index:.75,rgb:[199,233,192]},{index:.875,rgb:[229,245,224]},{index:1,rgb:[247,252,245]}],yiorrd:[{index:0,rgb:[128,0,38]},{index:.125,rgb:[189,0,38]},{index:.25,rgb:[227,26,28]},{index:.375,rgb:[252,78,42]},{index:.5,rgb:[253,141,60]},{index:.625,rgb:[254,178,76]},{index:.75,rgb:[254,217,118]},{index:.875,rgb:[255,237,160]},{index:1,rgb:[255,255,204]}],bluered:[{index:0,rgb:[0,0,255]},{index:1,rgb:[255,0,0]}],rdbu:[{index:0,rgb:[5,10,172]},{index:.35,rgb:[106,137,247]},{index:.5,rgb:[190,190,190]},{index:.6,rgb:[220,170,132]},{index:.7,rgb:[230,145,90]},{index:1,rgb:[178,10,28]}],picnic:[{index:0,rgb:[0,0,255]},{index:.1,rgb:[51,153,255]},{index:.2,rgb:[102,204,255]},{index:.3,rgb:[153,204,255]},{index:.4,rgb:[204,204,255]},{index:.5,rgb:[255,255,255]},{index:.6,rgb:[255,204,255]},{index:.7,rgb:[255,153,255]},{index:.8,rgb:[255,102,204]},{index:.9,rgb:[255,102,102]},{index:1,rgb:[255,0,0]}],rainbow:[{index:0,rgb:[150,0,90]},{index:.125,rgb:[0,0,200]},{index:.25,rgb:[0,25,255]},{index:.375,rgb:[0,152,255]},{index:.5,rgb:[44,255,150]},{index:.625,rgb:[151,255,0]},{index:.75,rgb:[255,234,0]},{index:.875,rgb:[255,111,0]},{index:1,rgb:[255,0,0]}],portland:[{index:0,rgb:[12,51,131]},{index:.25,rgb:[10,136,186]},{index:.5,rgb:[242,211,56]},{index:.75,rgb:[242,143,56]},{index:1,rgb:[217,30,30]}],blackbody:[{index:0,rgb:[0,0,0]},{index:.2,rgb:[230,0,0]},{index:.4,rgb:[230,210,0]},{index:.7,rgb:[255,255,255]},{index:1,rgb:[160,200,255]}],earth:[{index:0,rgb:[0,0,130]},{index:.1,rgb:[0,180,180]},{index:.2,rgb:[40,210,40]},{index:.4,rgb:[230,230,50]},{index:.6,rgb:[120,70,20]},{index:1,rgb:[255,255,255]}],electric:[{index:0,rgb:[0,0,0]},{index:.15,rgb:[30,0,100]},{index:.4,rgb:[120,0,100]},{index:.6,rgb:[160,90,0]},{index:.8,rgb:[230,200,0]},{index:1,rgb:[255,250,220]}],alpha:[{index:0,rgb:[255,255,255,0]},{index:0,rgb:[255,255,255,1]}],viridis:[{index:0,rgb:[68,1,84]},{index:.13,rgb:[71,44,122]},{index:.25,rgb:[59,81,139]},{index:.38,rgb:[44,113,142]},{index:.5,rgb:[33,144,141]},{index:.63,rgb:[39,173,129]},{index:.75,rgb:[92,200,99]},{index:.88,rgb:[170,220,50]},{index:1,rgb:[253,231,37]}],inferno:[{index:0,rgb:[0,0,4]},{index:.13,rgb:[31,12,72]},{index:.25,rgb:[85,15,109]},{index:.38,rgb:[136,34,106]},{index:.5,rgb:[186,54,85]},{index:.63,rgb:[227,89,51]},{index:.75,rgb:[249,140,10]},{index:.88,rgb:[249,201,50]},{index:1,rgb:[252,255,164]}],magma:[{index:0,rgb:[0,0,4]},{index:.13,rgb:[28,16,68]},{index:.25,rgb:[79,18,123]},{index:.38,rgb:[129,37,129]},{index:.5,rgb:[181,54,122]},{index:.63,rgb:[229,80,100]},{index:.75,rgb:[251,135,97]},{index:.88,rgb:[254,194,135]},{index:1,rgb:[252,253,191]}],plasma:[{index:0,rgb:[13,8,135]},{index:.13,rgb:[75,3,161]},{index:.25,rgb:[125,3,168]},{index:.38,rgb:[168,34,150]},{index:.5,rgb:[203,70,121]},{index:.63,rgb:[229,107,93]},{index:.75,rgb:[248,148,65]},{index:.88,rgb:[253,195,40]},{index:1,rgb:[240,249,33]}],warm:[{index:0,rgb:[125,0,179]},{index:.13,rgb:[172,0,187]},{index:.25,rgb:[219,0,170]},{index:.38,rgb:[255,0,130]},{index:.5,rgb:[255,63,74]},{index:.63,rgb:[255,123,0]},{index:.75,rgb:[234,176,0]},{index:.88,rgb:[190,228,0]},{index:1,rgb:[147,255,0]}],cool:[{index:0,rgb:[125,0,179]},{index:.13,rgb:[116,0,218]},{index:.25,rgb:[98,74,237]},{index:.38,rgb:[68,146,231]},{index:.5,rgb:[0,204,197]},{index:.63,rgb:[0,247,146]},{index:.75,rgb:[0,255,88]},{index:.88,rgb:[40,255,8]},{index:1,rgb:[147,255,0]}],\"rainbow-soft\":[{index:0,rgb:[125,0,179]},{index:.1,rgb:[199,0,180]},{index:.2,rgb:[255,0,121]},{index:.3,rgb:[255,108,0]},{index:.4,rgb:[222,194,0]},{index:.5,rgb:[150,255,0]},{index:.6,rgb:[0,255,55]},{index:.7,rgb:[0,246,150]},{index:.8,rgb:[50,167,222]},{index:.9,rgb:[103,51,235]},{index:1,rgb:[124,0,186]}],bathymetry:[{index:0,rgb:[40,26,44]},{index:.13,rgb:[59,49,90]},{index:.25,rgb:[64,76,139]},{index:.38,rgb:[63,110,151]},{index:.5,rgb:[72,142,158]},{index:.63,rgb:[85,174,163]},{index:.75,rgb:[120,206,163]},{index:.88,rgb:[187,230,172]},{index:1,rgb:[253,254,204]}],cdom:[{index:0,rgb:[47,15,62]},{index:.13,rgb:[87,23,86]},{index:.25,rgb:[130,28,99]},{index:.38,rgb:[171,41,96]},{index:.5,rgb:[206,67,86]},{index:.63,rgb:[230,106,84]},{index:.75,rgb:[242,149,103]},{index:.88,rgb:[249,193,135]},{index:1,rgb:[254,237,176]}],chlorophyll:[{index:0,rgb:[18,36,20]},{index:.13,rgb:[25,63,41]},{index:.25,rgb:[24,91,59]},{index:.38,rgb:[13,119,72]},{index:.5,rgb:[18,148,80]},{index:.63,rgb:[80,173,89]},{index:.75,rgb:[132,196,122]},{index:.88,rgb:[175,221,162]},{index:1,rgb:[215,249,208]}],density:[{index:0,rgb:[54,14,36]},{index:.13,rgb:[89,23,80]},{index:.25,rgb:[110,45,132]},{index:.38,rgb:[120,77,178]},{index:.5,rgb:[120,113,213]},{index:.63,rgb:[115,151,228]},{index:.75,rgb:[134,185,227]},{index:.88,rgb:[177,214,227]},{index:1,rgb:[230,241,241]}],\"freesurface-blue\":[{index:0,rgb:[30,4,110]},{index:.13,rgb:[47,14,176]},{index:.25,rgb:[41,45,236]},{index:.38,rgb:[25,99,212]},{index:.5,rgb:[68,131,200]},{index:.63,rgb:[114,156,197]},{index:.75,rgb:[157,181,203]},{index:.88,rgb:[200,208,216]},{index:1,rgb:[241,237,236]}],\"freesurface-red\":[{index:0,rgb:[60,9,18]},{index:.13,rgb:[100,17,27]},{index:.25,rgb:[142,20,29]},{index:.38,rgb:[177,43,27]},{index:.5,rgb:[192,87,63]},{index:.63,rgb:[205,125,105]},{index:.75,rgb:[216,162,148]},{index:.88,rgb:[227,199,193]},{index:1,rgb:[241,237,236]}],oxygen:[{index:0,rgb:[64,5,5]},{index:.13,rgb:[106,6,15]},{index:.25,rgb:[144,26,7]},{index:.38,rgb:[168,64,3]},{index:.5,rgb:[188,100,4]},{index:.63,rgb:[206,136,11]},{index:.75,rgb:[220,174,25]},{index:.88,rgb:[231,215,44]},{index:1,rgb:[248,254,105]}],par:[{index:0,rgb:[51,20,24]},{index:.13,rgb:[90,32,35]},{index:.25,rgb:[129,44,34]},{index:.38,rgb:[159,68,25]},{index:.5,rgb:[182,99,19]},{index:.63,rgb:[199,134,22]},{index:.75,rgb:[212,171,35]},{index:.88,rgb:[221,210,54]},{index:1,rgb:[225,253,75]}],phase:[{index:0,rgb:[145,105,18]},{index:.13,rgb:[184,71,38]},{index:.25,rgb:[186,58,115]},{index:.38,rgb:[160,71,185]},{index:.5,rgb:[110,97,218]},{index:.63,rgb:[50,123,164]},{index:.75,rgb:[31,131,110]},{index:.88,rgb:[77,129,34]},{index:1,rgb:[145,105,18]}],salinity:[{index:0,rgb:[42,24,108]},{index:.13,rgb:[33,50,162]},{index:.25,rgb:[15,90,145]},{index:.38,rgb:[40,118,137]},{index:.5,rgb:[59,146,135]},{index:.63,rgb:[79,175,126]},{index:.75,rgb:[120,203,104]},{index:.88,rgb:[193,221,100]},{index:1,rgb:[253,239,154]}],temperature:[{index:0,rgb:[4,35,51]},{index:.13,rgb:[23,51,122]},{index:.25,rgb:[85,59,157]},{index:.38,rgb:[129,79,143]},{index:.5,rgb:[175,95,130]},{index:.63,rgb:[222,112,101]},{index:.75,rgb:[249,146,66]},{index:.88,rgb:[249,196,65]},{index:1,rgb:[232,250,91]}],turbidity:[{index:0,rgb:[34,31,27]},{index:.13,rgb:[65,50,41]},{index:.25,rgb:[98,69,52]},{index:.38,rgb:[131,89,57]},{index:.5,rgb:[161,112,59]},{index:.63,rgb:[185,140,66]},{index:.75,rgb:[202,174,88]},{index:.88,rgb:[216,209,126]},{index:1,rgb:[233,246,171]}],\"velocity-blue\":[{index:0,rgb:[17,32,64]},{index:.13,rgb:[35,52,116]},{index:.25,rgb:[29,81,156]},{index:.38,rgb:[31,113,162]},{index:.5,rgb:[50,144,169]},{index:.63,rgb:[87,173,176]},{index:.75,rgb:[149,196,189]},{index:.88,rgb:[203,221,211]},{index:1,rgb:[254,251,230]}],\"velocity-green\":[{index:0,rgb:[23,35,19]},{index:.13,rgb:[24,64,38]},{index:.25,rgb:[11,95,45]},{index:.38,rgb:[39,123,35]},{index:.5,rgb:[95,146,12]},{index:.63,rgb:[152,165,18]},{index:.75,rgb:[201,186,69]},{index:.88,rgb:[233,216,137]},{index:1,rgb:[255,253,205]}],cubehelix:[{index:0,rgb:[0,0,0]},{index:.07,rgb:[22,5,59]},{index:.13,rgb:[60,4,105]},{index:.2,rgb:[109,1,135]},{index:.27,rgb:[161,0,147]},{index:.33,rgb:[210,2,142]},{index:.4,rgb:[251,11,123]},{index:.47,rgb:[255,29,97]},{index:.53,rgb:[255,54,69]},{index:.6,rgb:[255,85,46]},{index:.67,rgb:[255,120,34]},{index:.73,rgb:[255,157,37]},{index:.8,rgb:[241,191,57]},{index:.87,rgb:[224,220,93]},{index:.93,rgb:[218,241,142]},{index:1,rgb:[227,253,198]}]}},{}],98:[function(t,e,r){\"use strict\";function n(t){var e,r,n,u,c,h,f,d,p,m,v,g,y,b=[],x=[],_=[],w=[];if(o.isPlainObject(t)||(t={}),p=t.nshades||72,d=t.format||\"hex\",f=t.colormap,f||(f=\"jet\"),\"string\"==typeof f){if(f=f.toLowerCase(),!l[f])throw Error(f+\" not a supported colorscale\");h=s(l[f])}else{if(!Array.isArray(f))throw Error(\"unsupported colormap option\",f);h=s(f)}if(h.length>p)throw new Error(f+\" map requires nshades to be at least size \"+h.length);for(v=Array.isArray(t.alpha)?2!==t.alpha.length?[1,1]:s(t.alpha):\"number\"==typeof t.alpha?[t.alpha,t.alpha]:[1,1],e=h.map(function(t){return Math.round(t.index*p)}),v[0]<0&&(v[0]=0),v[1]<0&&(v[0]=0),v[0]>1&&(v[0]=1),v[1]>1&&(v[0]=1),y=0;y<e.length;++y)g=h[y].index,r=h[y].rgb,4===r.length&&r[3]>=0&&r[3]<=1||(r[3]=v[0]+(v[1]-v[0])*g);for(y=0;y<e.length-1;++y)c=e[y+1]-e[y],n=h[y].rgb,u=h[y+1].rgb,b=b.concat(o.linspace(n[0],u[0],c)),x=x.concat(o.linspace(n[1],u[1],c)),_=_.concat(o.linspace(n[2],u[2],c)),w=w.concat(o.linspace(n[3],u[3],c));return b=b.map(Math.round),x=x.map(Math.round),_=_.map(Math.round),m=o.zip(b,x,_,w),\"hex\"===d&&(m=m.map(i)),\"rgbaString\"===d&&(m=m.map(a)),m}function i(t){for(var e,r=\"#\",n=0;n<3;++n)e=t[n],e=e.toString(16),r+=(\"00\"+e).substr(e.length);return r}function a(t){return\"rgba(\"+t.join(\",\")+\")\"}var o=t(\"arraytools\"),s=t(\"clone\"),l=t(\"./colorScales\");e.exports=n},{\"./colorScales\":97,arraytools:45,clone:90}],99:[function(t,e,r){\"use strict\";function n(t,e,r){var n=s(t[0],-e[0]),i=s(t[1],-e[1]),a=s(r[0],-e[0]),o=s(r[1],-e[1]),c=u(l(n,a),l(i,o));return c[c.length-1]>=0}function i(t,e,r,i){var s=a(e,r,i);if(0===s){var l=o(a(t,e,r)),u=o(a(t,e,i));if(l===u){if(0===l){var c=n(t,e,r);return c===n(t,e,i)?0:c?1:-1}return 0}return 0===u?l>0?-1:n(t,e,i)?-1:1:0===l?u>0?1:n(t,e,r)?1:-1:o(u-l)}var h=a(t,e,r);return h>0?s>0&&a(t,e,i)>0?1:-1:h<0?s>0||a(t,e,i)>0?1:-1:a(t,e,i)>0?1:n(t,e,r)?1:-1}e.exports=i;var a=t(\"robust-orientation\"),o=t(\"signum\"),s=t(\"two-sum\"),l=t(\"robust-product\"),u=t(\"robust-sum\")},{\"robust-orientation\":507,\"robust-product\":508,\"robust-sum\":512,signum:514,\"two-sum\":539}],100:[function(t,e,r){function n(t,e){return t-e}function i(t,e){var r=t.length,i=t.length-e.length;if(i)return i;switch(r){case 0:return 0;case 1:return t[0]-e[0];case 2:return t[0]+t[1]-e[0]-e[1]||a(t[0],t[1])-a(e[0],e[1]);case 3:var o=t[0]+t[1],s=e[0]+e[1];if(i=o+t[2]-(s+e[2]))return i;var l=a(t[0],t[1]),u=a(e[0],e[1]);return a(l,t[2])-a(u,e[2])||a(l+t[2],o)-a(u+e[2],s);case 4:var c=t[0],h=t[1],f=t[2],d=t[3],p=e[0],m=e[1],v=e[2],g=e[3];return c+h+f+d-(p+m+v+g)||a(c,h,f,d)-a(p,m,v,g,p)||a(c+h,c+f,c+d,h+f,h+d,f+d)-a(p+m,p+v,p+g,m+v,m+g,v+g)||a(c+h+f,c+h+d,c+f+d,h+f+d)-a(p+m+v,p+m+g,p+v+g,m+v+g);default:for(var y=t.slice().sort(n),b=e.slice().sort(n),x=0;x<r;++x)if(i=y[x]-b[x])return i;return 0}}e.exports=i;var a=Math.min},{}],101:[function(t,e,r){\"use strict\";function n(t,e){return i(t,e)||a(t)-a(e)}var i=t(\"compare-cell\"),a=t(\"cell-orientation\");e.exports=n},{\"cell-orientation\":84,\"compare-cell\":100}],102:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(0===e)return[];if(1===e)return[[0]];var r=t[0].length;return 0===r?[]:1===r?i(t):2===r?a(t):o(t,r)}var i=t(\"./lib/ch1d\"),a=t(\"./lib/ch2d\"),o=t(\"./lib/chnd\");e.exports=n},{\"./lib/ch1d\":103,\"./lib/ch2d\":104,\"./lib/chnd\":105}],103:[function(t,e,r){\"use strict\";function n(t){for(var e=0,r=0,n=1;n<t.length;++n)t[n][0]<t[e][0]&&(e=n),t[n][0]>t[r][0]&&(r=n);return e<r?[[e],[r]]:e>r?[[r],[e]]:[[e]]}e.exports=n},{}],104:[function(t,e,r){\"use strict\";function n(t){var e=i(t),r=e.length;if(r<=2)return[];for(var n=new Array(r),a=e[r-1],o=0;o<r;++o){var s=e[o];n[o]=[a,s],a=s}return n}e.exports=n;var i=t(\"monotone-convex-hull-2d\")},{\"monotone-convex-hull-2d\":450}],105:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),i=0;i<e.length;++i)n[i]=t[e[i]];for(var a=e.length,i=0;i<r;++i)e.indexOf(i)<0&&(n[a++]=t[i]);return n}function i(t,e){for(var r=t.length,n=e.length,i=0;i<r;++i)for(var a=t[i],o=0;o<a.length;++o){var s=a[o];if(s<n)a[o]=e[s];else{s-=n;for(var l=0;l<n;++l)s>=e[l]&&(s+=1);a[o]=s}}return t}function a(t,e){try{return o(t,!0)}catch(u){var r=s(t);if(r.length<=e)return[];var a=n(t,r),l=o(a,!0);return i(l,r)}}e.exports=a;var o=t(\"incremental-convex-hull\"),s=t(\"affine-hull\")},{\"affine-hull\":40,\"incremental-convex-hull\":289}],106:[function(t,e,r){e.exports={AFG:\"afghan\",ALA:\"\\\\b\\\\wland\",ALB:\"albania\",DZA:\"algeria\",ASM:\"^(?=.*americ).*samoa\",AND:\"andorra\",AGO:\"angola\",AIA:\"anguill?a\",ATA:\"antarctica\",ATG:\"antigua\",ARG:\"argentin\",ARM:\"armenia\",ABW:\"^(?!.*bonaire).*\\\\baruba\",AUS:\"australia\",AUT:\"^(?!.*hungary).*austria|\\\\baustri.*\\\\bemp\",AZE:\"azerbaijan\",BHS:\"bahamas\",BHR:\"bahrain\",BGD:\"bangladesh|^(?=.*east).*paki?stan\",BRB:\"barbados\",BLR:\"belarus|byelo\",BEL:\"^(?!.*luxem).*belgium\",BLZ:\"belize|^(?=.*british).*honduras\",BEN:\"benin|dahome\",BMU:\"bermuda\",BTN:\"bhutan\",BOL:\"bolivia\",BES:\"^(?=.*bonaire).*eustatius|^(?=.*carib).*netherlands|\\\\bbes.?islands\",BIH:\"herzegovina|bosnia\",BWA:\"botswana|bechuana\",BVT:\"bouvet\",BRA:\"brazil\",IOT:\"british.?indian.?ocean\",BRN:\"brunei\",BGR:\"bulgaria\",BFA:\"burkina|\\\\bfaso|upper.?volta\",BDI:\"burundi\",CPV:\"verde\",KHM:\"cambodia|kampuchea|khmer\",CMR:\"cameroon\",CAN:\"canada\",CYM:\"cayman\",CAF:\"\\\\bcentral.african.republic\",TCD:\"\\\\bchad\",CHL:\"\\\\bchile\",CHN:\"^(?!.*\\\\bmac)(?!.*\\\\bhong)(?!.*\\\\btai)(?!.*\\\\brep).*china|^(?=.*peo)(?=.*rep).*china\",CXR:\"christmas\",CCK:\"\\\\bcocos|keeling\",COL:\"colombia\",COM:\"comoro\",COG:\"^(?!.*\\\\bdem)(?!.*\\\\bd[\\\\.]?r)(?!.*kinshasa)(?!.*zaire)(?!.*belg)(?!.*l.opoldville)(?!.*free).*\\\\bcongo\",COK:\"\\\\bcook\",CRI:\"costa.?rica\",CIV:\"ivoire|ivory\",HRV:\"croatia\",CUB:\"\\\\bcuba\",CUW:\"^(?!.*bonaire).*\\\\bcura(c|\\xe7)ao\",CYP:\"cyprus\",CSK:\"czechoslovakia\",CZE:\"^(?=.*rep).*czech|czechia|bohemia\",COD:\"\\\\bdem.*congo|congo.*\\\\bdem|congo.*\\\\bd[\\\\.]?r|\\\\bd[\\\\.]?r.*congo|belgian.?congo|congo.?free.?state|kinshasa|zaire|l.opoldville|drc|droc|rdc\",DNK:\"denmark\",DJI:\"djibouti\",DMA:\"dominica(?!n)\",DOM:\"dominican.rep\",ECU:\"ecuador\",EGY:\"egypt\",SLV:\"el.?salvador\",GNQ:\"guine.*eq|eq.*guine|^(?=.*span).*guinea\",ERI:\"eritrea\",EST:\"estonia\",ETH:\"ethiopia|abyssinia\",FLK:\"falkland|malvinas\",FRO:\"faroe|faeroe\",FJI:\"fiji\",FIN:\"finland\",FRA:\"^(?!.*\\\\bdep)(?!.*martinique).*france|french.?republic|\\\\bgaul\",GUF:\"^(?=.*french).*guiana\",PYF:\"french.?polynesia|tahiti\",ATF:\"french.?southern\",GAB:\"gabon\",GMB:\"gambia\",GEO:\"^(?!.*south).*georgia\",DDR:\"german.?democratic.?republic|democratic.?republic.*germany|east.germany\",DEU:\"^(?!.*east).*germany|^(?=.*\\\\bfed.*\\\\brep).*german\",GHA:\"ghana|gold.?coast\",GIB:\"gibraltar\",GRC:\"greece|hellenic|hellas\",GRL:\"greenland\",GRD:\"grenada\",GLP:\"guadeloupe\",GUM:\"\\\\bguam\",GTM:\"guatemala\",GGY:\"guernsey\",GIN:\"^(?!.*eq)(?!.*span)(?!.*bissau)(?!.*portu)(?!.*new).*guinea\",GNB:\"bissau|^(?=.*portu).*guinea\",GUY:\"guyana|british.?guiana\",HTI:\"haiti\",HMD:\"heard.*mcdonald\",VAT:\"holy.?see|vatican|papal.?st\",HND:\"^(?!.*brit).*honduras\",HKG:\"hong.?kong\",HUN:\"^(?!.*austr).*hungary\",ISL:\"iceland\",IND:\"india(?!.*ocea)\",IDN:\"indonesia\",IRN:\"\\\\biran|persia\",IRQ:\"\\\\biraq|mesopotamia\",IRL:\"(^ireland)|(^republic.*ireland)\",IMN:\"^(?=.*isle).*\\\\bman\",ISR:\"israel\",ITA:\"italy\",JAM:\"jamaica\",JPN:\"japan\",JEY:\"jersey\",JOR:\"jordan\",KAZ:\"kazak\",KEN:\"kenya|british.?east.?africa|east.?africa.?prot\",KIR:\"kiribati\",PRK:\"^(?=.*democrat|people|north|d.*p.*.r).*\\\\bkorea|dprk|korea.*(d.*p.*r)\",KWT:\"kuwait\",KGZ:\"kyrgyz|kirghiz\",LAO:\"\\\\blaos?\\\\b\",LVA:\"latvia\",LBN:\"lebanon\",LSO:\"lesotho|basuto\",LBR:\"liberia\",LBY:\"libya\",LIE:\"liechtenstein\",LTU:\"lithuania\",LUX:\"^(?!.*belg).*luxem\",MAC:\"maca(o|u)\",MDG:\"madagascar|malagasy\",MWI:\"malawi|nyasa\",MYS:\"malaysia\",MDV:\"maldive\",MLI:\"\\\\bmali\\\\b\",MLT:\"\\\\bmalta\",MHL:\"marshall\",MTQ:\"martinique\",MRT:\"mauritania\",MUS:\"mauritius\",MYT:\"\\\\bmayotte\",MEX:\"\\\\bmexic\",FSM:\"fed.*micronesia|micronesia.*fed\",MCO:\"monaco\",MNG:\"mongolia\",MNE:\"^(?!.*serbia).*montenegro\",MSR:\"montserrat\",MAR:\"morocco|\\\\bmaroc\",MOZ:\"mozambique\",MMR:\"myanmar|burma\",NAM:\"namibia\",NRU:\"nauru\",NPL:\"nepal\",NLD:\"^(?!.*\\\\bant)(?!.*\\\\bcarib).*netherlands\",ANT:\"^(?=.*\\\\bant).*(nether|dutch)\",NCL:\"new.?caledonia\",NZL:\"new.?zealand\",NIC:\"nicaragua\",NER:\"\\\\bniger(?!ia)\",NGA:\"nigeria\",NIU:\"niue\",NFK:\"norfolk\",MNP:\"mariana\",NOR:\"norway\",OMN:\"\\\\boman|trucial\",PAK:\"^(?!.*east).*paki?stan\",PLW:\"palau\",PSE:\"palestin|\\\\bgaza|west.?bank\",PAN:\"panama\",PNG:\"papua|new.?guinea\",PRY:\"paraguay\",PER:\"peru\",PHL:\"philippines\",PCN:\"pitcairn\",POL:\"poland\",PRT:\"portugal\",PRI:\"puerto.?rico\",QAT:\"qatar\",KOR:\"^(?!.*d.*p.*r)(?!.*democrat)(?!.*people)(?!.*north).*\\\\bkorea(?!.*d.*p.*r)\",MDA:\"moldov|b(a|e)ssarabia\",REU:\"r(e|\\xe9)union\",ROU:\"r(o|u|ou)mania\",RUS:\"\\\\brussia|soviet.?union|u\\\\.?s\\\\.?s\\\\.?r|socialist.?republics\",RWA:\"rwanda\",BLM:\"barth(e|\\xe9)lemy\",SHN:\"helena\",KNA:\"kitts|\\\\bnevis\",LCA:\"\\\\blucia\",MAF:\"^(?=.*collectivity).*martin|^(?=.*france).*martin(?!ique)|^(?=.*french).*martin(?!ique)\",SPM:\"miquelon\",VCT:\"vincent\",WSM:\"^(?!.*amer).*samoa\",SMR:\"san.?marino\",STP:\"\\\\bs(a|\\xe3)o.?tom(e|\\xe9)\",SAU:\"\\\\bsa\\\\w*.?arabia\",SEN:\"senegal\",SRB:\"^(?!.*monte).*serbia\",SYC:\"seychell\",SLE:\"sierra\",SGP:\"singapore\",SXM:\"^(?!.*martin)(?!.*saba).*maarten\",SVK:\"^(?!.*cze).*slovak\",SVN:\"slovenia\",SLB:\"solomon\",SOM:\"somali\",ZAF:\"south.africa|s\\\\\\\\..?africa\",SGS:\"south.?georgia|sandwich\",SSD:\"\\\\bs\\\\w*.?sudan\",ESP:\"spain\",LKA:\"sri.?lanka|ceylon\",SDN:\"^(?!.*\\\\bs(?!u)).*sudan\",SUR:\"surinam|dutch.?guiana\",SJM:\"svalbard\",SWZ:\"swaziland\",SWE:\"sweden\",CHE:\"switz|swiss\",SYR:\"syria\",TWN:\"taiwan|taipei|formosa|^(?!.*peo)(?=.*rep).*china\",TJK:\"tajik\",THA:\"thailand|\\\\bsiam\",MKD:\"macedonia|fyrom\",TLS:\"^(?=.*leste).*timor|^(?=.*east).*timor\",TGO:\"togo\",TKL:\"tokelau\",TON:\"tonga\",TTO:\"trinidad|tobago\",TUN:\"tunisia\",TUR:\"turkey\",TKM:\"turkmen\",TCA:\"turks\",TUV:\"tuvalu\",UGA:\"uganda\",UKR:\"ukrain\",ARE:\"emirates|^u\\\\.?a\\\\.?e\\\\.?$|united.?arab.?em\",GBR:\"united.?kingdom|britain|^u\\\\.?k\\\\.?$\",TZA:\"tanzania\",USA:\"united.?states\\\\b(?!.*islands)|\\\\bu\\\\.?s\\\\.?a\\\\.?\\\\b|^\\\\s*u\\\\.?s\\\\.?\\\\b(?!.*islands)\",UMI:\"minor.?outlying.?is\",URY:\"uruguay\",UZB:\"uzbek\",VUT:\"vanuatu|new.?hebrides\",VEN:\"venezuela\",VNM:\"^(?!.*republic).*viet.?nam|^(?=.*socialist).*viet.?nam\",VGB:\"^(?=.*\\\\bu\\\\.?\\\\s?k).*virgin|^(?=.*brit).*virgin|^(?=.*kingdom).*virgin\",VIR:\"^(?=.*\\\\bu\\\\.?\\\\s?s).*virgin|^(?=.*states).*virgin\",WLF:\"futuna|wallis\",ESH:\"western.sahara\",YEM:\"^(?!.*arab)(?!.*north)(?!.*sana)(?!.*peo)(?!.*dem)(?!.*south)(?!.*aden)(?!.*\\\\bp\\\\.?d\\\\.?r).*yemen\",YMD:\"^(?=.*peo).*yemen|^(?!.*rep)(?=.*dem).*yemen|^(?=.*south).*yemen|^(?=.*aden).*yemen|^(?=.*\\\\bp\\\\.?d\\\\.?r).*yemen\",YUG:\"yugoslavia\",ZMB:\"zambia|northern.?rhodesia\",EAZ:\"zanzibar\",ZWE:\"zimbabwe|^(?!.*northern).*rhodesia\"}},{}],107:[function(t,e,r){function n(t){return t=Math.round(t),t<0?0:t>255?255:t}function i(t){return t<0?0:t>1?1:t}function a(t){return n(\"%\"===t[t.length-1]?parseFloat(t)/100*255:parseInt(t))}function o(t){return i(\"%\"===t[t.length-1]?parseFloat(t)/100:parseFloat(t))}function s(t,e,r){return r<0?r+=1:r>1&&(r-=1),6*r<1?t+(e-t)*r*6:2*r<1?e:3*r<2?t+(e-t)*(2/3-r)*6:t}function l(t){var e=t.replace(/ /g,\"\").toLowerCase();if(e in u)return u[e].slice();if(\"#\"===e[0]){if(4===e.length){var r=parseInt(e.substr(1),16);return r>=0&&r<=4095?[(3840&r)>>4|(3840&r)>>8,240&r|(240&r)>>4,15&r|(15&r)<<4,1]:null}if(7===e.length){var r=parseInt(e.substr(1),16);return r>=0&&r<=16777215?[(16711680&r)>>16,(65280&r)>>8,255&r,1]:null}return null}var i=e.indexOf(\"(\"),l=e.indexOf(\")\");if(-1!==i&&l+1===e.length){var c=e.substr(0,i),h=e.substr(i+1,l-(i+1)).split(\",\"),f=1;switch(c){case\"rgba\":if(4!==h.length)return null;f=o(h.pop());case\"rgb\":return 3!==h.length?null:[a(h[0]),a(h[1]),a(h[2]),f];case\"hsla\":if(4!==h.length)return null;f=o(h.pop());case\"hsl\":if(3!==h.length)return null;var d=(parseFloat(h[0])%360+360)%360/360,p=o(h[1]),m=o(h[2]),v=m<=.5?m*(p+1):m+p-m*p,g=2*m-v;return[n(255*s(g,v,d+1/3)),n(255*s(g,v,d)),n(255*s(g,v,d-1/3)),f];default:return null}}return null}var u={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],\n",
       "darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};try{r.parseCSSColor=l}catch(t){}},{}],108:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){var o=6*i*i-6*i,s=3*i*i-4*i+1,l=-6*i*i+6*i,u=3*i*i-2*i;if(t.length){a||(a=new Array(t.length));for(var c=t.length-1;c>=0;--c)a[c]=o*t[c]+s*e[c]+l*r[c]+u*n[c];return a}return o*t+s*e+l*r[c]+u*n}function i(t,e,r,n,i,a){var o=i-1,s=i*i,l=o*o,u=(1+2*i)*l,c=i*l,h=s*(3-2*i),f=s*o;if(t.length){a||(a=new Array(t.length));for(var d=t.length-1;d>=0;--d)a[d]=u*t[d]+c*e[d]+h*r[d]+f*n[d];return a}return u*t+c*e+h*r+f*n}e.exports=i,e.exports.derivative=n},{}],109:[function(t,e,r){\"use strict\";function n(){this.argTypes=[],this.shimArgs=[],this.arrayArgs=[],this.arrayBlockIndices=[],this.scalarArgs=[],this.offsetArgs=[],this.offsetArgIndex=[],this.indexArgs=[],this.shapeArgs=[],this.funcName=\"\",this.pre=null,this.body=null,this.post=null,this.debug=!1}function i(t){var e=new n;e.pre=t.pre,e.body=t.body,e.post=t.post;var r=t.args.slice(0);e.argTypes=r;for(var i=0;i<r.length;++i){var o=r[i];if(\"array\"===o||\"object\"==typeof o&&o.blockIndices){if(e.argTypes[i]=\"array\",e.arrayArgs.push(i),e.arrayBlockIndices.push(o.blockIndices?o.blockIndices:0),e.shimArgs.push(\"array\"+i),i<e.pre.args.length&&e.pre.args[i].count>0)throw new Error(\"cwise: pre() block may not reference array args\");if(i<e.post.args.length&&e.post.args[i].count>0)throw new Error(\"cwise: post() block may not reference array args\")}else if(\"scalar\"===o)e.scalarArgs.push(i),e.shimArgs.push(\"scalar\"+i);else if(\"index\"===o){if(e.indexArgs.push(i),i<e.pre.args.length&&e.pre.args[i].count>0)throw new Error(\"cwise: pre() block may not reference array index\");if(i<e.body.args.length&&e.body.args[i].lvalue)throw new Error(\"cwise: body() block may not write to array index\");if(i<e.post.args.length&&e.post.args[i].count>0)throw new Error(\"cwise: post() block may not reference array index\")}else if(\"shape\"===o){if(e.shapeArgs.push(i),i<e.pre.args.length&&e.pre.args[i].lvalue)throw new Error(\"cwise: pre() block may not write to array shape\");if(i<e.body.args.length&&e.body.args[i].lvalue)throw new Error(\"cwise: body() block may not write to array shape\");if(i<e.post.args.length&&e.post.args[i].lvalue)throw new Error(\"cwise: post() block may not write to array shape\")}else{if(\"object\"!=typeof o||!o.offset)throw new Error(\"cwise: Unknown argument type \"+r[i]);e.argTypes[i]=\"offset\",e.offsetArgs.push({array:o.array,offset:o.offset}),e.offsetArgIndex.push(i)}}if(e.arrayArgs.length<=0)throw new Error(\"cwise: No array arguments specified\");if(e.pre.args.length>r.length)throw new Error(\"cwise: Too many arguments in pre() block\");if(e.body.args.length>r.length)throw new Error(\"cwise: Too many arguments in body() block\");if(e.post.args.length>r.length)throw new Error(\"cwise: Too many arguments in post() block\");return e.debug=!!t.printCode||!!t.debug,e.funcName=t.funcName||\"cwise\",e.blockSize=t.blockSize||64,a(e)}var a=t(\"./lib/thunk.js\");e.exports=i},{\"./lib/thunk.js\":111}],110:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a=t.length,o=e.arrayArgs.length,s=e.indexArgs.length>0,l=[],u=[],c=0,h=0;for(n=0;n<a;++n)u.push([\"i\",n,\"=0\"].join(\"\"));for(i=0;i<o;++i)for(n=0;n<a;++n)h=c,c=t[n],0===n?u.push([\"d\",i,\"s\",n,\"=t\",i,\"p\",c].join(\"\")):u.push([\"d\",i,\"s\",n,\"=(t\",i,\"p\",c,\"-s\",h,\"*t\",i,\"p\",h,\")\"].join(\"\"));for(u.length>0&&l.push(\"var \"+u.join(\",\")),n=a-1;n>=0;--n)c=t[n],l.push([\"for(i\",n,\"=0;i\",n,\"<s\",c,\";++i\",n,\"){\"].join(\"\"));for(l.push(r),n=0;n<a;++n){for(h=c,c=t[n],i=0;i<o;++i)l.push([\"p\",i,\"+=d\",i,\"s\",n].join(\"\"));s&&(n>0&&l.push([\"index[\",h,\"]-=s\",h].join(\"\")),l.push([\"++index[\",c,\"]\"].join(\"\"))),l.push(\"}\")}return l.join(\"\\n\")}function i(t,e,r,i){for(var a=e.length,o=r.arrayArgs.length,s=r.blockSize,l=r.indexArgs.length>0,u=[],c=0;c<o;++c)u.push([\"var offset\",c,\"=p\",c].join(\"\"));for(var c=t;c<a;++c)u.push([\"for(var j\"+c+\"=SS[\",e[c],\"]|0;j\",c,\">0;){\"].join(\"\")),u.push([\"if(j\",c,\"<\",s,\"){\"].join(\"\")),u.push([\"s\",e[c],\"=j\",c].join(\"\")),u.push([\"j\",c,\"=0\"].join(\"\")),u.push([\"}else{s\",e[c],\"=\",s].join(\"\")),u.push([\"j\",c,\"-=\",s,\"}\"].join(\"\")),l&&u.push([\"index[\",e[c],\"]=j\",c].join(\"\"));for(var c=0;c<o;++c){for(var h=[\"offset\"+c],f=t;f<a;++f)h.push([\"j\",f,\"*t\",c,\"p\",e[f]].join(\"\"));u.push([\"p\",c,\"=(\",h.join(\"+\"),\")\"].join(\"\"))}u.push(n(e,r,i));for(var c=t;c<a;++c)u.push(\"}\");return u.join(\"\\n\")}function a(t){for(var e=0,r=t[0].length;e<r;){for(var n=1;n<t.length;++n)if(t[n][e]!==t[0][e])return e;++e}return e}function o(t,e,r){for(var n=t.body,i=[],a=[],o=0;o<t.args.length;++o){var s=t.args[o];if(!(s.count<=0)){var l=new RegExp(s.name,\"g\"),u=\"\",c=e.arrayArgs.indexOf(o);switch(e.argTypes[o]){case\"offset\":var h=e.offsetArgIndex.indexOf(o);c=e.offsetArgs[h].array,u=\"+q\"+h;case\"array\":u=\"p\"+c+u;var f=\"l\"+o,d=\"a\"+c;if(0===e.arrayBlockIndices[c])1===s.count?\"generic\"===r[c]?s.lvalue?(i.push([\"var \",f,\"=\",d,\".get(\",u,\")\"].join(\"\")),n=n.replace(l,f),a.push([d,\".set(\",u,\",\",f,\")\"].join(\"\"))):n=n.replace(l,[d,\".get(\",u,\")\"].join(\"\")):n=n.replace(l,[d,\"[\",u,\"]\"].join(\"\")):\"generic\"===r[c]?(i.push([\"var \",f,\"=\",d,\".get(\",u,\")\"].join(\"\")),n=n.replace(l,f),s.lvalue&&a.push([d,\".set(\",u,\",\",f,\")\"].join(\"\"))):(i.push([\"var \",f,\"=\",d,\"[\",u,\"]\"].join(\"\")),n=n.replace(l,f),s.lvalue&&a.push([d,\"[\",u,\"]=\",f].join(\"\")));else{for(var p=[s.name],m=[u],v=0;v<Math.abs(e.arrayBlockIndices[c]);v++)p.push(\"\\\\s*\\\\[([^\\\\]]+)\\\\]\"),m.push(\"$\"+(v+1)+\"*t\"+c+\"b\"+v);if(l=new RegExp(p.join(\"\"),\"g\"),u=m.join(\"+\"),\"generic\"===r[c])throw new Error(\"cwise: Generic arrays not supported in combination with blocks!\");n=n.replace(l,[d,\"[\",u,\"]\"].join(\"\"))}break;case\"scalar\":n=n.replace(l,\"Y\"+e.scalarArgs.indexOf(o));break;case\"index\":n=n.replace(l,\"index\");break;case\"shape\":n=n.replace(l,\"shape\")}}}return[i.join(\"\\n\"),n,a.join(\"\\n\")].join(\"\\n\").trim()}function s(t){for(var e=new Array(t.length),r=!0,n=0;n<t.length;++n){var i=t[n],a=i.match(/\\d+/);a=a?a[0]:\"\",0===i.charAt(0)?e[n]=\"u\"+i.charAt(1)+a:e[n]=i.charAt(0)+a,n>0&&(r=r&&e[n]===e[n-1])}return r?e[0]:e.join(\"\")}function l(t,e){for(var r=e[1].length-Math.abs(t.arrayBlockIndices[0])|0,l=new Array(t.arrayArgs.length),c=new Array(t.arrayArgs.length),h=0;h<t.arrayArgs.length;++h)c[h]=e[2*h],l[h]=e[2*h+1];for(var f=[],d=[],p=[],m=[],v=[],h=0;h<t.arrayArgs.length;++h){t.arrayBlockIndices[h]<0?(p.push(0),m.push(r),f.push(r),d.push(r+t.arrayBlockIndices[h])):(p.push(t.arrayBlockIndices[h]),m.push(t.arrayBlockIndices[h]+r),f.push(0),d.push(t.arrayBlockIndices[h]));for(var g=[],y=0;y<l[h].length;y++)p[h]<=l[h][y]&&l[h][y]<m[h]&&g.push(l[h][y]-p[h]);v.push(g)}for(var b=[\"SS\"],x=[\"'use strict'\"],_=[],y=0;y<r;++y)_.push([\"s\",y,\"=SS[\",y,\"]\"].join(\"\"));for(var h=0;h<t.arrayArgs.length;++h){b.push(\"a\"+h),b.push(\"t\"+h),b.push(\"p\"+h);for(var y=0;y<r;++y)_.push([\"t\",h,\"p\",y,\"=t\",h,\"[\",p[h]+y,\"]\"].join(\"\"));for(var y=0;y<Math.abs(t.arrayBlockIndices[h]);++y)_.push([\"t\",h,\"b\",y,\"=t\",h,\"[\",f[h]+y,\"]\"].join(\"\"))}for(var h=0;h<t.scalarArgs.length;++h)b.push(\"Y\"+h);if(t.shapeArgs.length>0&&_.push(\"shape=SS.slice(0)\"),t.indexArgs.length>0){for(var w=new Array(r),h=0;h<r;++h)w[h]=\"0\";_.push([\"index=[\",w.join(\",\"),\"]\"].join(\"\"))}for(var h=0;h<t.offsetArgs.length;++h){for(var M=t.offsetArgs[h],k=[],y=0;y<M.offset.length;++y)0!==M.offset[y]&&(1===M.offset[y]?k.push([\"t\",M.array,\"p\",y].join(\"\")):k.push([M.offset[y],\"*t\",M.array,\"p\",y].join(\"\")));0===k.length?_.push(\"q\"+h+\"=0\"):_.push([\"q\",h,\"=\",k.join(\"+\")].join(\"\"))}var A=u([].concat(t.pre.thisVars).concat(t.body.thisVars).concat(t.post.thisVars));_=_.concat(A),_.length>0&&x.push(\"var \"+_.join(\",\"));for(var h=0;h<t.arrayArgs.length;++h)x.push(\"p\"+h+\"|=0\");t.pre.body.length>3&&x.push(o(t.pre,t,c));var T=o(t.body,t,c),S=a(v);S<r?x.push(i(S,v[0],t,T)):x.push(n(v[0],t,T)),t.post.body.length>3&&x.push(o(t.post,t,c)),t.debug&&console.log(\"-----Generated cwise routine for \",e,\":\\n\"+x.join(\"\\n\")+\"\\n----------\");var E=[t.funcName||\"unnamed\",\"_cwise_loop_\",l[0].join(\"s\"),\"m\",S,s(c)].join(\"\");return new Function([\"function \",E,\"(\",b.join(\",\"),\"){\",x.join(\"\\n\"),\"} return \",E].join(\"\"))()}var u=t(\"uniq\");e.exports=l},{uniq:542}],111:[function(t,e,r){\"use strict\";function n(t){var e=[\"'use strict'\",\"var CACHED={}\"],r=[],n=t.funcName+\"_cwise_thunk\";e.push([\"return function \",n,\"(\",t.shimArgs.join(\",\"),\"){\"].join(\"\"));for(var a=[],o=[],s=[[\"array\",t.arrayArgs[0],\".shape.slice(\",Math.max(0,t.arrayBlockIndices[0]),t.arrayBlockIndices[0]<0?\",\"+t.arrayBlockIndices[0]+\")\":\")\"].join(\"\")],l=[],u=[],c=0;c<t.arrayArgs.length;++c){var h=t.arrayArgs[c];r.push([\"t\",h,\"=array\",h,\".dtype,\",\"r\",h,\"=array\",h,\".order\"].join(\"\")),a.push(\"t\"+h),a.push(\"r\"+h),o.push(\"t\"+h),o.push(\"r\"+h+\".join()\"),s.push(\"array\"+h+\".data\"),s.push(\"array\"+h+\".stride\"),s.push(\"array\"+h+\".offset|0\"),c>0&&(l.push(\"array\"+t.arrayArgs[0]+\".shape.length===array\"+h+\".shape.length+\"+(Math.abs(t.arrayBlockIndices[0])-Math.abs(t.arrayBlockIndices[c]))),u.push(\"array\"+t.arrayArgs[0]+\".shape[shapeIndex+\"+Math.max(0,t.arrayBlockIndices[0])+\"]===array\"+h+\".shape[shapeIndex+\"+Math.max(0,t.arrayBlockIndices[c])+\"]\"))}t.arrayArgs.length>1&&(e.push(\"if (!(\"+l.join(\" && \")+\")) throw new Error('cwise: Arrays do not all have the same dimensionality!')\"),e.push(\"for(var shapeIndex=array\"+t.arrayArgs[0]+\".shape.length-\"+Math.abs(t.arrayBlockIndices[0])+\"; shapeIndex--\\x3e0;) {\"),e.push(\"if (!(\"+u.join(\" && \")+\")) throw new Error('cwise: Arrays do not all have the same shape!')\"),e.push(\"}\"));for(var c=0;c<t.scalarArgs.length;++c)s.push(\"scalar\"+t.scalarArgs[c]);return r.push([\"type=[\",o.join(\",\"),\"].join()\"].join(\"\")),r.push(\"proc=CACHED[type]\"),e.push(\"var \"+r.join(\",\")),e.push([\"if(!proc){\",\"CACHED[type]=proc=compile([\",a.join(\",\"),\"])}\",\"return proc(\",s.join(\",\"),\")}\"].join(\"\")),t.debug&&console.log(\"-----Generated thunk:\\n\"+e.join(\"\\n\")+\"\\n----------\"),new Function(\"compile\",e.join(\"\\n\"))(i.bind(void 0,t))}var i=t(\"./compile.js\");e.exports=n},{\"./compile.js\":110}],112:[function(t,e,r){e.exports=t(\"cwise-compiler\")},{\"cwise-compiler\":109}],113:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t){return function(e,r){return o(t(e),r)}}function r(t,e){return[t,e]}function n(t,e,r){var n=(e-t)/Math.max(0,r),i=Math.floor(Math.log(n)/Math.LN10),a=n/Math.pow(10,i);return i>=0?(a>=k?10:a>=A?5:a>=T?2:1)*Math.pow(10,i):-Math.pow(10,-i)/(a>=k?10:a>=A?5:a>=T?2:1)}function i(t,e,r){var n=Math.abs(e-t)/Math.max(0,r),i=Math.pow(10,Math.floor(Math.log(n)/Math.LN10)),a=n/i;return a>=k?i*=10:a>=A?i*=5:a>=T&&(i*=2),e<t?-i:i}function a(t){return t.length}var o=function(t,e){return t<e?-1:t>e?1:t>=e?0:NaN},s=function(t){return 1===t.length&&(t=e(t)),{left:function(e,r,n,i){for(null==n&&(n=0),null==i&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)<0?n=a+1:i=a}return n},right:function(e,r,n,i){for(null==n&&(n=0),null==i&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)>0?i=a:n=a+1}return n}}},l=s(o),u=l.right,c=l.left,h=function(t,e){null==e&&(e=r);for(var n=0,i=t.length-1,a=t[0],o=new Array(i<0?0:i);n<i;)o[n]=e(a,a=t[++n]);return o},f=function(t,e,n){var i,a,o,s,l=t.length,u=e.length,c=new Array(l*u);for(null==n&&(n=r),i=o=0;i<l;++i)for(s=t[i],a=0;a<u;++a,++o)c[o]=n(s,e[a]);return c},d=function(t,e){return e<t?-1:e>t?1:e>=t?0:NaN},p=function(t){return null===t?NaN:+t},m=function(t,e){var r,n,i=t.length,a=0,o=-1,s=0,l=0;if(null==e)for(;++o<i;)isNaN(r=p(t[o]))||(n=r-s,s+=n/++a,l+=n*(r-s));else for(;++o<i;)isNaN(r=p(e(t[o],o,t)))||(n=r-s,s+=n/++a,l+=n*(r-s));if(a>1)return l/(a-1)},v=function(t,e){var r=m(t,e);return r?Math.sqrt(r):r},g=function(t,e){var r,n,i,a=t.length,o=-1;if(null==e){for(;++o<a;)if(null!=(r=t[o])&&r>=r)for(n=i=r;++o<a;)null!=(r=t[o])&&(n>r&&(n=r),i<r&&(i=r))}else for(;++o<a;)if(null!=(r=e(t[o],o,t))&&r>=r)for(n=i=r;++o<a;)null!=(r=e(t[o],o,t))&&(n>r&&(n=r),i<r&&(i=r));return[n,i]},y=Array.prototype,b=y.slice,x=y.map,_=function(t){return function(){return t}},w=function(t){return t},M=function(t,e,r){t=+t,e=+e,r=(i=arguments.length)<2?(e=t,t=0,1):i<3?1:+r;for(var n=-1,i=0|Math.max(0,Math.ceil((e-t)/r)),a=new Array(i);++n<i;)a[n]=t+n*r;return a},k=Math.sqrt(50),A=Math.sqrt(10),T=Math.sqrt(2),S=function(t,e,r){var i,a,o,s=e<t,l=-1;if(s&&(i=t,t=e,e=i),0===(o=n(t,e,r))||!isFinite(o))return[];if(o>0)for(t=Math.ceil(t/o),e=Math.floor(e/o),a=new Array(i=Math.ceil(e-t+1));++l<i;)a[l]=(t+l)*o;else for(t=Math.floor(t*o),e=Math.ceil(e*o),a=new Array(i=Math.ceil(t-e+1));++l<i;)a[l]=(t-l)/o;return s&&a.reverse(),a},E=function(t){return Math.ceil(Math.log(t.length)/Math.LN2)+1},L=function(){function t(t){var a,o,s=t.length,l=new Array(s);for(a=0;a<s;++a)l[a]=e(t[a],a,t);var c=r(l),h=c[0],f=c[1],d=n(l,h,f);Array.isArray(d)||(d=i(h,f,d),d=M(Math.ceil(h/d)*d,Math.floor(f/d)*d,d));for(var p=d.length;d[0]<=h;)d.shift(),--p;for(;d[p-1]>f;)d.pop(),--p;var m,v=new Array(p+1);for(a=0;a<=p;++a)m=v[a]=[],m.x0=a>0?d[a-1]:h,m.x1=a<p?d[a]:f;for(a=0;a<s;++a)o=l[a],h<=o&&o<=f&&v[u(d,o,0,p)].push(t[a]);return v}var e=w,r=g,n=E;return t.value=function(r){return arguments.length?(e=\"function\"==typeof r?r:_(r),t):e},t.domain=function(e){return arguments.length?(r=\"function\"==typeof e?e:_([e[0],e[1]]),t):r},t.thresholds=function(e){return arguments.length?(n=\"function\"==typeof e?e:_(Array.isArray(e)?b.call(e):e),t):n},t},C=function(t,e,r){if(null==r&&(r=p),n=t.length){if((e=+e)<=0||n<2)return+r(t[0],0,t);if(e>=1)return+r(t[n-1],n-1,t);var n,i=(n-1)*e,a=Math.floor(i),o=+r(t[a],a,t);return o+(+r(t[a+1],a+1,t)-o)*(i-a)}},z=function(t,e,r){return t=x.call(t,p).sort(o),Math.ceil((r-e)/(2*(C(t,.75)-C(t,.25))*Math.pow(t.length,-1/3)))},I=function(t,e,r){return Math.ceil((r-e)/(3.5*v(t)*Math.pow(t.length,-1/3)))},D=function(t,e){var r,n,i=t.length,a=-1;if(null==e){for(;++a<i;)if(null!=(r=t[a])&&r>=r)for(n=r;++a<i;)null!=(r=t[a])&&r>n&&(n=r)}else for(;++a<i;)if(null!=(r=e(t[a],a,t))&&r>=r)for(n=r;++a<i;)null!=(r=e(t[a],a,t))&&r>n&&(n=r);return n},P=function(t,e){var r,n=t.length,i=n,a=-1,o=0;if(null==e)for(;++a<n;)isNaN(r=p(t[a]))?--i:o+=r;else for(;++a<n;)isNaN(r=p(e(t[a],a,t)))?--i:o+=r;if(i)return o/i},O=function(t,e){var r,n=t.length,i=-1,a=[];if(null==e)for(;++i<n;)isNaN(r=p(t[i]))||a.push(r);else for(;++i<n;)isNaN(r=p(e(t[i],i,t)))||a.push(r);return C(a.sort(o),.5)},R=function(t){for(var e,r,n,i=t.length,a=-1,o=0;++a<i;)o+=t[a].length;for(r=new Array(o);--i>=0;)for(n=t[i],e=n.length;--e>=0;)r[--o]=n[e];return r},F=function(t,e){var r,n,i=t.length,a=-1;if(null==e){for(;++a<i;)if(null!=(r=t[a])&&r>=r)for(n=r;++a<i;)null!=(r=t[a])&&n>r&&(n=r)}else for(;++a<i;)if(null!=(r=e(t[a],a,t))&&r>=r)for(n=r;++a<i;)null!=(r=e(t[a],a,t))&&n>r&&(n=r);return n},j=function(t,e){for(var r=e.length,n=new Array(r);r--;)n[r]=t[e[r]];return n},N=function(t,e){if(r=t.length){var r,n,i=0,a=0,s=t[a];for(null==e&&(e=o);++i<r;)(e(n=t[i],s)<0||0!==e(s,s))&&(s=n,a=i);return 0===e(s,s)?a:void 0}},B=function(t,e,r){for(var n,i,a=(null==r?t.length:r)-(e=null==e?0:+e);a;)i=Math.random()*a--|0,n=t[a+e],t[a+e]=t[i+e],t[i+e]=n;return t},U=function(t,e){var r,n=t.length,i=-1,a=0;if(null==e)for(;++i<n;)(r=+t[i])&&(a+=r);else for(;++i<n;)(r=+e(t[i],i,t))&&(a+=r);return a},V=function(t){if(!(i=t.length))return[];for(var e=-1,r=F(t,a),n=new Array(r);++e<r;)for(var i,o=-1,s=n[e]=new Array(i);++o<i;)s[o]=t[o][e];return n},H=function(){return V(arguments)};t.bisect=u,t.bisectRight=u,t.bisectLeft=c,t.ascending=o,t.bisector=s,t.cross=f,t.descending=d,t.deviation=v,t.extent=g,t.histogram=L,t.thresholdFreedmanDiaconis=z,t.thresholdScott=I,t.thresholdSturges=E,t.max=D,t.mean=P,t.median=O,t.merge=R,t.min=F,t.pairs=h,t.permute=j,t.quantile=C,t.range=M,t.scan=N,t.shuffle=B,t.sum=U,t.ticks=S,t.tickIncrement=n,t.tickStep=i,t.transpose=V,t.variance=m,t.zip=H,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],114:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){}function r(t,r){var n=new e;if(t instanceof e)t.each(function(t,e){n.set(e,t)});else if(Array.isArray(t)){var i,a=-1,o=t.length;if(null==r)for(;++a<o;)n.set(a,t[a]);else for(;++a<o;)n.set(r(i=t[a],a,t),i)}else if(t)for(var s in t)n.set(s,t[s]);return n}function n(){return{}}function i(t,e,r){t[e]=r}function a(){return r()}function o(t,e,r){t.set(e,r)}function s(){}function l(t,e){var r=new s;if(t instanceof s)t.each(function(t){r.add(t)});else if(t){var n=-1,i=t.length;if(null==e)for(;++n<i;)r.add(t[n]);else for(;++n<i;)r.add(e(t[n],n,t))}return r}e.prototype=r.prototype={constructor:e,has:function(t){return\"$\"+t in this},get:function(t){return this[\"$\"+t]},set:function(t,e){return this[\"$\"+t]=e,this},remove:function(t){var e=\"$\"+t;return e in this&&delete this[e]},clear:function(){for(var t in this)\"$\"===t[0]&&delete this[t]},keys:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push(e.slice(1));return t},values:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push(this[e]);return t},entries:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push({key:e.slice(1),value:this[e]});return t},size:function(){var t=0;for(var e in this)\"$\"===e[0]&&++t;return t},empty:function(){for(var t in this)if(\"$\"===t[0])return!1;return!0},each:function(t){for(var e in this)\"$\"===e[0]&&t(this[e],e.slice(1),this)}};var u=function(){function t(e,n,i,a){if(n>=c.length)return null!=l?l(e):null!=s?e.sort(s):e;for(var o,u,h,f=-1,d=e.length,p=c[n++],m=r(),v=i();++f<d;)(h=m.get(o=p(u=e[f])+\"\"))?h.push(u):m.set(o,[u]);return m.each(function(e,r){a(v,r,t(e,n,i,a))}),v}function e(t,r){if(++r>c.length)return t;var n,i=h[r-1];return null!=l&&r>=c.length?n=t.entries():(n=[],t.each(function(t,i){n.push({key:i,values:e(t,r)})})),null!=i?n.sort(function(t,e){return i(t.key,e.key)}):n}var s,l,u,c=[],h=[];return u={object:function(e){return t(e,0,n,i)},map:function(e){return t(e,0,a,o)},entries:function(r){return e(t(r,0,a,o),0)},key:function(t){return c.push(t),u},sortKeys:function(t){return h[c.length-1]=t,u},sortValues:function(t){return s=t,u},rollup:function(t){return l=t,u}}},c=r.prototype;s.prototype=l.prototype={constructor:s,has:c.has,add:function(t){return t+=\"\",this[\"$\"+t]=t,this},remove:c.remove,clear:c.clear,values:c.keys,size:c.size,empty:c.empty,each:c.each};var h=function(t){var e=[];for(var r in t)e.push(r);return e},f=function(t){var e=[];for(var r in t)e.push(t[r]);return e},d=function(t){var e=[];for(var r in t)e.push({key:r,value:t[r]});return e};t.nest=u,t.set=l,t.map=r,t.keys=h,t.values=f,t.entries=d,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],115:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t,e){var r=Object.create(t.prototype);for(var n in e)r[n]=e[n];return r}function r(){}function n(t){var e;return t=(t+\"\").trim().toLowerCase(),(e=z.exec(t))?(e=parseInt(e[1],16),new l(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1)):(e=I.exec(t))?i(parseInt(e[1],16)):(e=D.exec(t))?new l(e[1],e[2],e[3],1):(e=P.exec(t))?new l(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=O.exec(t))?a(e[1],e[2],e[3],e[4]):(e=R.exec(t))?a(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=F.exec(t))?u(e[1],e[2]/100,e[3]/100,1):(e=j.exec(t))?u(e[1],e[2]/100,e[3]/100,e[4]):N.hasOwnProperty(t)?i(N[t]):\"transparent\"===t?new l(NaN,NaN,NaN,0):null}function i(t){return new l(t>>16&255,t>>8&255,255&t,1)}function a(t,e,r,n){return n<=0&&(t=e=r=NaN),new l(t,e,r,n)}function o(t){return t instanceof r||(t=n(t)),t?(t=t.rgb(),new l(t.r,t.g,t.b,t.opacity)):new l}function s(t,e,r,n){return 1===arguments.length?o(t):new l(t,e,r,null==n?1:n)}function l(t,e,r,n){this.r=+t,this.g=+e,this.b=+r,this.opacity=+n}function u(t,e,r,n){return n<=0?t=e=r=NaN:r<=0||r>=1?t=e=NaN:e<=0&&(t=NaN),new f(t,e,r,n)}function c(t){if(t instanceof f)return new f(t.h,t.s,t.l,t.opacity);if(t instanceof r||(t=n(t)),!t)return new f;if(t instanceof f)return t;t=t.rgb();var e=t.r/255,i=t.g/255,a=t.b/255,o=Math.min(e,i,a),s=Math.max(e,i,a),l=NaN,u=s-o,c=(s+o)/2;return u?(l=e===s?(i-a)/u+6*(i<a):i===s?(a-e)/u+2:(e-i)/u+4,u/=c<.5?s+o:2-s-o,l*=60):u=c>0&&c<1?0:l,new f(l,u,c,t.opacity)}function h(t,e,r,n){return 1===arguments.length?c(t):new f(t,e,r,null==n?1:n)}function f(t,e,r,n){this.h=+t,this.s=+e,this.l=+r,this.opacity=+n}function d(t,e,r){return 255*(t<60?e+(r-e)*t/60:t<180?r:t<240?e+(r-e)*(240-t)/60:e)}function p(t){if(t instanceof v)return new v(t.l,t.a,t.b,t.opacity);if(t instanceof M){var e=t.h*B;return new v(t.l,Math.cos(e)*t.c,Math.sin(e)*t.c,t.opacity)}t instanceof l||(t=o(t));var r=x(t.r),n=x(t.g),i=x(t.b),a=g((.4124564*r+.3575761*n+.1804375*i)/V),s=g((.2126729*r+.7151522*n+.072175*i)/H);return new v(116*s-16,500*(a-s),200*(s-g((.0193339*r+.119192*n+.9503041*i)/q)),t.opacity)}function m(t,e,r,n){return 1===arguments.length?p(t):new v(t,e,r,null==n?1:n)}function v(t,e,r,n){this.l=+t,this.a=+e,this.b=+r,this.opacity=+n}function g(t){return t>W?Math.pow(t,1/3):t/X+G}function y(t){return t>Y?t*t*t:X*(t-G)}function b(t){return 255*(t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055)}function x(t){return(t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function _(t){if(t instanceof M)return new M(t.h,t.c,t.l,t.opacity);t instanceof v||(t=p(t));var e=Math.atan2(t.b,t.a)*U;return new M(e<0?e+360:e,Math.sqrt(t.a*t.a+t.b*t.b),t.l,t.opacity)}function w(t,e,r,n){return 1===arguments.length?_(t):new M(t,e,r,null==n?1:n)}function M(t,e,r,n){this.h=+t,this.c=+e,this.l=+r,this.opacity=+n}function k(t){if(t instanceof T)return new T(t.h,t.s,t.l,t.opacity);t instanceof l||(t=o(t));var e=t.r/255,r=t.g/255,n=t.b/255,i=(rt*n+tt*e-et*r)/(rt+tt-et),a=n-i,s=($*(r-i)-K*a)/Q,u=Math.sqrt(s*s+a*a)/($*i*(1-i)),c=u?Math.atan2(s,a)*U-120:NaN;return new T(c<0?c+360:c,u,i,t.opacity)}function A(t,e,r,n){return 1===arguments.length?k(t):new T(t,e,r,null==n?1:n)}function T(t,e,r,n){this.h=+t,this.s=+e,this.l=+r,this.opacity=+n}var S=function(t,e,r){t.prototype=e.prototype=r,r.constructor=t},E=\"\\\\s*([+-]?\\\\d+)\\\\s*\",L=\"\\\\s*([+-]?\\\\d*\\\\.?\\\\d+(?:[eE][+-]?\\\\d+)?)\\\\s*\",C=\"\\\\s*([+-]?\\\\d*\\\\.?\\\\d+(?:[eE][+-]?\\\\d+)?)%\\\\s*\",z=/^#([0-9a-f]{3})$/,I=/^#([0-9a-f]{6})$/,D=new RegExp(\"^rgb\\\\(\"+[E,E,E]+\"\\\\)$\"),P=new RegExp(\"^rgb\\\\(\"+[C,C,C]+\"\\\\)$\"),O=new RegExp(\"^rgba\\\\(\"+[E,E,E,L]+\"\\\\)$\"),R=new RegExp(\"^rgba\\\\(\"+[C,C,C,L]+\"\\\\)$\"),F=new RegExp(\"^hsl\\\\(\"+[L,C,C]+\"\\\\)$\"),j=new RegExp(\"^hsla\\\\(\"+[L,C,C,L]+\"\\\\)$\"),N={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};S(r,n,{displayable:function(){return this.rgb().displayable()},toString:function(){return this.rgb()+\"\"}}),S(l,s,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new l(this.r*t,this.g*t,this.b*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new l(this.r*t,this.g*t,this.b*t,this.opacity)},rgb:function(){return this},displayable:function(){return 0<=this.r&&this.r<=255&&0<=this.g&&this.g<=255&&0<=this.b&&this.b<=255&&0<=this.opacity&&this.opacity<=1},toString:function(){var t=this.opacity;return t=isNaN(t)?1:Math.max(0,Math.min(1,t)),(1===t?\"rgb(\":\"rgba(\")+Math.max(0,Math.min(255,Math.round(this.r)||0))+\", \"+Math.max(0,Math.min(255,Math.round(this.g)||0))+\", \"+Math.max(0,Math.min(255,Math.round(this.b)||0))+(1===t?\")\":\", \"+t+\")\")}})),S(f,h,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new f(this.h,this.s,this.l*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new f(this.h,this.s,this.l*t,this.opacity)},rgb:function(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,r=this.l,n=r+(r<.5?r:1-r)*e,i=2*r-n;return new l(d(t>=240?t-240:t+120,i,n),d(t,i,n),d(t<120?t+240:t-120,i,n),this.opacity)},displayable:function(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1}}));var B=Math.PI/180,U=180/Math.PI,V=.95047,H=1,q=1.08883,G=4/29,Y=6/29,X=3*Y*Y,W=Y*Y*Y;S(v,m,e(r,{brighter:function(t){return new v(this.l+18*(null==t?1:t),this.a,this.b,this.opacity)},darker:function(t){return new v(this.l-18*(null==t?1:t),this.a,this.b,this.opacity)},rgb:function(){var t=(this.l+16)/116,e=isNaN(this.a)?t:t+this.a/500,r=isNaN(this.b)?t:t-this.b/200;return t=H*y(t),e=V*y(e),r=q*y(r),new l(b(3.2404542*e-1.5371385*t-.4985314*r),b(-.969266*e+1.8760108*t+.041556*r),b(.0556434*e-.2040259*t+1.0572252*r),this.opacity)}})),S(M,w,e(r,{brighter:function(t){return new M(this.h,this.c,this.l+18*(null==t?1:t),this.opacity)},darker:function(t){return new M(this.h,this.c,this.l-18*(null==t?1:t),this.opacity)},rgb:function(){return p(this).rgb()}}));var Z=-.14861,J=1.78277,K=-.29227,Q=-.90649,$=1.97294,tt=$*Q,et=$*J,rt=J*K-Q*Z;S(T,A,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new T(this.h,this.s,this.l*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new T(this.h,this.s,this.l*t,this.opacity)},rgb:function(){var t=isNaN(this.h)?0:(this.h+120)*B,e=+this.l,r=isNaN(this.s)?0:this.s*e*(1-e),n=Math.cos(t),i=Math.sin(t);return new l(255*(e+r*(Z*n+J*i)),255*(e+r*(K*n+Q*i)),255*(e+r*($*n)),this.opacity)}})),t.color=n,t.rgb=s,t.hsl=h,t.lab=m,t.hcl=w,t.cubehelix=A,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],116:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){for(var t,e=0,n=arguments.length,i={};e<n;++e){if(!(t=arguments[e]+\"\")||t in i)throw new Error(\"illegal type: \"+t);i[t]=[]}return new r(i)}function r(t){this._=t}function n(t,e){return t.trim().split(/^|\\s+/).map(function(t){var r=\"\",n=t.indexOf(\".\");if(n>=0&&(r=t.slice(n+1),t=t.slice(0,n)),t&&!e.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);return{type:t,name:r}})}function i(t,e){for(var r,n=0,i=t.length;n<i;++n)if((r=t[n]).name===e)return r.value}function a(t,e,r){for(var n=0,i=t.length;n<i;++n)if(t[n].name===e){t[n]=o,t=t.slice(0,n).concat(t.slice(n+1));break}return null!=r&&t.push({name:e,value:r}),t}var o={value:function(){}};r.prototype=e.prototype={constructor:r,on:function(t,e){var r,o=this._,s=n(t+\"\",o),l=-1,u=s.length;{if(!(arguments.length<2)){if(null!=e&&\"function\"!=typeof e)throw new Error(\"invalid callback: \"+e)\n",
       ";for(;++l<u;)if(r=(t=s[l]).type)o[r]=a(o[r],t.name,e);else if(null==e)for(r in o)o[r]=a(o[r],t.name,null);return this}for(;++l<u;)if((r=(t=s[l]).type)&&(r=i(o[r],t.name)))return r}},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new r(t)},call:function(t,e){if((r=arguments.length-2)>0)for(var r,n,i=new Array(r),a=0;a<r;++a)i[a]=arguments[a+2];if(!this._.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);for(n=this._[t],a=0,r=n.length;a<r;++a)n[a].value.apply(e,i)},apply:function(t,e,r){if(!this._.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);for(var n=this._[t],i=0,a=n.length;i<a;++i)n[i].value.apply(e,r)}},t.dispatch=e,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],117:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-quadtree\"),e(\"d3-collection\"),e(\"d3-dispatch\"),e(\"d3-timer\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-quadtree\",\"d3-collection\",\"d3-dispatch\",\"d3-timer\"],a):a(i.d3=i.d3||{},i.d3,i.d3,i.d3,i.d3)}(this,function(t,e,r,n,i){\"use strict\";function a(t){return t.x+t.vx}function o(t){return t.y+t.vy}function s(t){return t.index}function l(t,e){var r=t.get(e);if(!r)throw new Error(\"missing: \"+e);return r}function u(t){return t.x}function c(t){return t.y}var h=function(t,e){function r(){var r,i,a=n.length,o=0,s=0;for(r=0;r<a;++r)i=n[r],o+=i.x,s+=i.y;for(o=o/a-t,s=s/a-e,r=0;r<a;++r)i=n[r],i.x-=o,i.y-=s}var n;return null==t&&(t=0),null==e&&(e=0),r.initialize=function(t){n=t},r.x=function(e){return arguments.length?(t=+e,r):t},r.y=function(t){return arguments.length?(e=+t,r):e},r},f=function(t){return function(){return t}},d=function(){return 1e-6*(Math.random()-.5)},p=function(t){function r(){function t(t,e,r,n,i){var a=t.data,o=t.r,s=m+o;{if(!a)return e>f+s||n<f-s||r>p+s||i<p-s;if(a.index>h.index){var l=f-a.x-a.vx,c=p-a.y-a.vy,g=l*l+c*c;g<s*s&&(0===l&&(l=d(),g+=l*l),0===c&&(c=d(),g+=c*c),g=(s-(g=Math.sqrt(g)))/g*u,h.vx+=(l*=g)*(s=(o*=o)/(v+o)),h.vy+=(c*=g)*s,a.vx-=l*(s=1-s),a.vy-=c*s)}}}for(var r,i,h,f,p,m,v,g=s.length,y=0;y<c;++y)for(i=e.quadtree(s,a,o).visitAfter(n),r=0;r<g;++r)h=s[r],m=l[h.index],v=m*m,f=h.x+h.vx,p=h.y+h.vy,i.visit(t)}function n(t){if(t.data)return t.r=l[t.data.index];for(var e=t.r=0;e<4;++e)t[e]&&t[e].r>t.r&&(t.r=t[e].r)}function i(){if(s){var e,r,n=s.length;for(l=new Array(n),e=0;e<n;++e)r=s[e],l[r.index]=+t(r,e,s)}}var s,l,u=1,c=1;return\"function\"!=typeof t&&(t=f(null==t?1:+t)),r.initialize=function(t){s=t,i()},r.iterations=function(t){return arguments.length?(c=+t,r):c},r.strength=function(t){return arguments.length?(u=+t,r):u},r.radius=function(e){return arguments.length?(t=\"function\"==typeof e?e:f(+e),i(),r):t},r},m=function(t){function e(t){return 1/Math.min(p[t.source.index],p[t.target.index])}function n(e){for(var r=0,n=t.length;r<b;++r)for(var i,a,o,s,l,h,f,p=0;p<n;++p)i=t[p],a=i.source,o=i.target,s=o.x+o.vx-a.x-a.vx||d(),l=o.y+o.vy-a.y-a.vy||d(),h=Math.sqrt(s*s+l*l),h=(h-c[p])/h*e*u[p],s*=h,l*=h,o.vx-=s*(f=m[p]),o.vy-=l*f,a.vx+=s*(f=1-f),a.vy+=l*f}function i(){if(h){var e,n,i=h.length,s=t.length,f=r.map(h,v);for(e=0,p=new Array(i);e<s;++e)n=t[e],n.index=e,\"object\"!=typeof n.source&&(n.source=l(f,n.source)),\"object\"!=typeof n.target&&(n.target=l(f,n.target)),p[n.source.index]=(p[n.source.index]||0)+1,p[n.target.index]=(p[n.target.index]||0)+1;for(e=0,m=new Array(s);e<s;++e)n=t[e],m[e]=p[n.source.index]/(p[n.source.index]+p[n.target.index]);u=new Array(s),a(),c=new Array(s),o()}}function a(){if(h)for(var e=0,r=t.length;e<r;++e)u[e]=+g(t[e],e,t)}function o(){if(h)for(var e=0,r=t.length;e<r;++e)c[e]=+y(t[e],e,t)}var u,c,h,p,m,v=s,g=e,y=f(30),b=1;return null==t&&(t=[]),n.initialize=function(t){h=t,i()},n.links=function(e){return arguments.length?(t=e,i(),n):t},n.id=function(t){return arguments.length?(v=t,n):v},n.iterations=function(t){return arguments.length?(b=+t,n):b},n.strength=function(t){return arguments.length?(g=\"function\"==typeof t?t:f(+t),a(),n):g},n.distance=function(t){return arguments.length?(y=\"function\"==typeof t?t:f(+t),o(),n):y},n},v=10,g=Math.PI*(3-Math.sqrt(5)),y=function(t){function e(){a(),y.call(\"tick\",l),u<c&&(m.stop(),y.call(\"end\",l))}function a(){var e,r,n=t.length;for(u+=(f-u)*h,p.each(function(t){t(u)}),e=0;e<n;++e)r=t[e],null==r.fx?r.x+=r.vx*=d:(r.x=r.fx,r.vx=0),null==r.fy?r.y+=r.vy*=d:(r.y=r.fy,r.vy=0)}function o(){for(var e,r=0,n=t.length;r<n;++r){if(e=t[r],e.index=r,isNaN(e.x)||isNaN(e.y)){var i=v*Math.sqrt(r),a=r*g;e.x=i*Math.cos(a),e.y=i*Math.sin(a)}(isNaN(e.vx)||isNaN(e.vy))&&(e.vx=e.vy=0)}}function s(e){return e.initialize&&e.initialize(t),e}var l,u=1,c=.001,h=1-Math.pow(c,1/300),f=0,d=.6,p=r.map(),m=i.timer(e),y=n.dispatch(\"tick\",\"end\");return null==t&&(t=[]),o(),l={tick:a,restart:function(){return m.restart(e),l},stop:function(){return m.stop(),l},nodes:function(e){return arguments.length?(t=e,o(),p.each(s),l):t},alpha:function(t){return arguments.length?(u=+t,l):u},alphaMin:function(t){return arguments.length?(c=+t,l):c},alphaDecay:function(t){return arguments.length?(h=+t,l):+h},alphaTarget:function(t){return arguments.length?(f=+t,l):f},velocityDecay:function(t){return arguments.length?(d=1-t,l):1-d},force:function(t,e){return arguments.length>1?(null==e?p.remove(t):p.set(t,s(e)),l):p.get(t)},find:function(e,r,n){var i,a,o,s,l,u=0,c=t.length;for(null==n?n=1/0:n*=n,u=0;u<c;++u)s=t[u],i=e-s.x,a=r-s.y,(o=i*i+a*a)<n&&(l=s,n=o);return l},on:function(t,e){return arguments.length>1?(y.on(t,e),l):y.on(t)}}},b=function(){function t(t){var r,l=a.length,h=e.quadtree(a,u,c).visitAfter(n);for(s=t,r=0;r<l;++r)o=a[r],h.visit(i)}function r(){if(a){var t,e,r=a.length;for(l=new Array(r),t=0;t<r;++t)e=a[t],l[e.index]=+h(e,t,a)}}function n(t){var e,r,n,i,a,o=0;if(t.length){for(n=i=a=0;a<4;++a)(e=t[a])&&(r=e.value)&&(o+=r,n+=r*e.x,i+=r*e.y);t.x=n/o,t.y=i/o}else{e=t,e.x=e.data.x,e.y=e.data.y;do{o+=l[e.data.index]}while(e=e.next)}t.value=o}function i(t,e,r,n){if(!t.value)return!0;var i=t.x-o.x,a=t.y-o.y,u=n-e,c=i*i+a*a;if(u*u/v<c)return c<m&&(0===i&&(i=d(),c+=i*i),0===a&&(a=d(),c+=a*a),c<p&&(c=Math.sqrt(p*c)),o.vx+=i*t.value*s/c,o.vy+=a*t.value*s/c),!0;if(!(t.length||c>=m)){(t.data!==o||t.next)&&(0===i&&(i=d(),c+=i*i),0===a&&(a=d(),c+=a*a),c<p&&(c=Math.sqrt(p*c)));do{t.data!==o&&(u=l[t.data.index]*s/c,o.vx+=i*u,o.vy+=a*u)}while(t=t.next)}}var a,o,s,l,h=f(-30),p=1,m=1/0,v=.81;return t.initialize=function(t){a=t,r()},t.strength=function(e){return arguments.length?(h=\"function\"==typeof e?e:f(+e),r(),t):h},t.distanceMin=function(e){return arguments.length?(p=e*e,t):Math.sqrt(p)},t.distanceMax=function(e){return arguments.length?(m=e*e,t):Math.sqrt(m)},t.theta=function(e){return arguments.length?(v=e*e,t):Math.sqrt(v)},t},x=function(t){function e(t){for(var e,r=0,o=n.length;r<o;++r)e=n[r],e.vx+=(a[r]-e.x)*i[r]*t}function r(){if(n){var e,r=n.length;for(i=new Array(r),a=new Array(r),e=0;e<r;++e)i[e]=isNaN(a[e]=+t(n[e],e,n))?0:+o(n[e],e,n)}}var n,i,a,o=f(.1);return\"function\"!=typeof t&&(t=f(null==t?0:+t)),e.initialize=function(t){n=t,r()},e.strength=function(t){return arguments.length?(o=\"function\"==typeof t?t:f(+t),r(),e):o},e.x=function(n){return arguments.length?(t=\"function\"==typeof n?n:f(+n),r(),e):t},e},_=function(t){function e(t){for(var e,r=0,o=n.length;r<o;++r)e=n[r],e.vy+=(a[r]-e.y)*i[r]*t}function r(){if(n){var e,r=n.length;for(i=new Array(r),a=new Array(r),e=0;e<r;++e)i[e]=isNaN(a[e]=+t(n[e],e,n))?0:+o(n[e],e,n)}}var n,i,a,o=f(.1);return\"function\"!=typeof t&&(t=f(null==t?0:+t)),e.initialize=function(t){n=t,r()},e.strength=function(t){return arguments.length?(o=\"function\"==typeof t?t:f(+t),r(),e):o},e.y=function(n){return arguments.length?(t=\"function\"==typeof n?n:f(+n),r(),e):t},e};t.forceCenter=h,t.forceCollide=p,t.forceLink=m,t.forceManyBody=b,t.forceSimulation=y,t.forceX=x,t.forceY=_,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-collection\":114,\"d3-dispatch\":116,\"d3-quadtree\":119,\"d3-timer\":120}],118:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-color\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-color\"],a):a(i.d3=i.d3||{},i.d3)}(this,function(t,e){\"use strict\";function r(t,e,r,n,i){var a=t*t,o=a*t;return((1-3*t+3*a-o)*e+(4-6*a+3*o)*r+(1+3*t+3*a-3*o)*n+o*i)/6}function n(t,e){return function(r){return t+r*e}}function i(t,e,r){return t=Math.pow(t,r),e=Math.pow(e,r)-t,r=1/r,function(n){return Math.pow(t+n*e,r)}}function a(t,e){var r=e-t;return r?n(t,r>180||r<-180?r-360*Math.round(r/360):r):S(isNaN(t)?e:t)}function o(t){return 1==(t=+t)?s:function(e,r){return r-e?i(e,r,t):S(isNaN(e)?r:e)}}function s(t,e){var r=e-t;return r?n(t,r):S(isNaN(t)?e:t)}function l(t){return function(r){var n,i,a=r.length,o=new Array(a),s=new Array(a),l=new Array(a);for(n=0;n<a;++n)i=e.rgb(r[n]),o[n]=i.r||0,s[n]=i.g||0,l[n]=i.b||0;return o=t(o),s=t(s),l=t(l),i.opacity=1,function(t){return i.r=o(t),i.g=s(t),i.b=l(t),i+\"\"}}}function u(t){return function(){return t}}function c(t){return function(e){return t(e)+\"\"}}function h(t){return\"none\"===t?U:(_||(_=document.createElement(\"DIV\"),w=document.documentElement,M=document.defaultView),_.style.transform=t,t=M.getComputedStyle(w.appendChild(_),null).getPropertyValue(\"transform\"),w.removeChild(_),t=t.slice(7,-1).split(\",\"),V(+t[0],+t[1],+t[2],+t[3],+t[4],+t[5]))}function f(t){return null==t?U:(k||(k=document.createElementNS(\"http://www.w3.org/2000/svg\",\"g\")),k.setAttribute(\"transform\",t),(t=k.transform.baseVal.consolidate())?(t=t.matrix,V(t.a,t.b,t.c,t.d,t.e,t.f)):U)}function d(t,e,r,n){function i(t){return t.length?t.pop()+\" \":\"\"}function a(t,n,i,a,o,s){if(t!==i||n!==a){var l=o.push(\"translate(\",null,e,null,r);s.push({i:l-4,x:D(t,i)},{i:l-2,x:D(n,a)})}else(i||a)&&o.push(\"translate(\"+i+e+a+r)}function o(t,e,r,a){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),a.push({i:r.push(i(r)+\"rotate(\",null,n)-2,x:D(t,e)})):e&&r.push(i(r)+\"rotate(\"+e+n)}function s(t,e,r,a){t!==e?a.push({i:r.push(i(r)+\"skewX(\",null,n)-2,x:D(t,e)}):e&&r.push(i(r)+\"skewX(\"+e+n)}function l(t,e,r,n,a,o){if(t!==r||e!==n){var s=a.push(i(a)+\"scale(\",null,\",\",null,\")\");o.push({i:s-4,x:D(t,r)},{i:s-2,x:D(e,n)})}else 1===r&&1===n||a.push(i(a)+\"scale(\"+r+\",\"+n+\")\")}return function(e,r){var n=[],i=[];return e=t(e),r=t(r),a(e.translateX,e.translateY,r.translateX,r.translateY,n,i),o(e.rotate,r.rotate,n,i),s(e.skewX,r.skewX,n,i),l(e.scaleX,e.scaleY,r.scaleX,r.scaleY,n,i),e=r=null,function(t){for(var e,r=-1,a=i.length;++r<a;)n[(e=i[r]).i]=e.x(t);return n.join(\"\")}}}function p(t){return((t=Math.exp(t))+1/t)/2}function m(t){return((t=Math.exp(t))-1/t)/2}function v(t){return((t=Math.exp(2*t))-1)/(t+1)}function g(t){return function(r,n){var i=t((r=e.hsl(r)).h,(n=e.hsl(n)).h),a=s(r.s,n.s),o=s(r.l,n.l),l=s(r.opacity,n.opacity);return function(t){return r.h=i(t),r.s=a(t),r.l=o(t),r.opacity=l(t),r+\"\"}}}function y(t,r){var n=s((t=e.lab(t)).l,(r=e.lab(r)).l),i=s(t.a,r.a),a=s(t.b,r.b),o=s(t.opacity,r.opacity);return function(e){return t.l=n(e),t.a=i(e),t.b=a(e),t.opacity=o(e),t+\"\"}}function b(t){return function(r,n){var i=t((r=e.hcl(r)).h,(n=e.hcl(n)).h),a=s(r.c,n.c),o=s(r.l,n.l),l=s(r.opacity,n.opacity);return function(t){return r.h=i(t),r.c=a(t),r.l=o(t),r.opacity=l(t),r+\"\"}}}function x(t){return function r(n){function i(r,i){var a=t((r=e.cubehelix(r)).h,(i=e.cubehelix(i)).h),o=s(r.s,i.s),l=s(r.l,i.l),u=s(r.opacity,i.opacity);return function(t){return r.h=a(t),r.s=o(t),r.l=l(Math.pow(t,n)),r.opacity=u(t),r+\"\"}}return n=+n,i.gamma=r,i}(1)}var _,w,M,k,A=function(t){var e=t.length-1;return function(n){var i=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),a=t[i],o=t[i+1],s=i>0?t[i-1]:2*a-o,l=i<e-1?t[i+2]:2*o-a;return r((n-i/e)*e,s,a,o,l)}},T=function(t){var e=t.length;return function(n){var i=Math.floor(((n%=1)<0?++n:n)*e),a=t[(i+e-1)%e],o=t[i%e],s=t[(i+1)%e],l=t[(i+2)%e];return r((n-i/e)*e,a,o,s,l)}},S=function(t){return function(){return t}},E=function t(r){function n(t,r){var n=i((t=e.rgb(t)).r,(r=e.rgb(r)).r),a=i(t.g,r.g),o=i(t.b,r.b),l=s(t.opacity,r.opacity);return function(e){return t.r=n(e),t.g=a(e),t.b=o(e),t.opacity=l(e),t+\"\"}}var i=o(r);return n.gamma=t,n}(1),L=l(A),C=l(T),z=function(t,e){var r,n=e?e.length:0,i=t?Math.min(n,t.length):0,a=new Array(n),o=new Array(n);for(r=0;r<i;++r)a[r]=j(t[r],e[r]);for(;r<n;++r)o[r]=e[r];return function(t){for(r=0;r<i;++r)o[r]=a[r](t);return o}},I=function(t,e){var r=new Date;return t=+t,e-=t,function(n){return r.setTime(t+e*n),r}},D=function(t,e){return t=+t,e-=t,function(r){return t+e*r}},P=function(t,e){var r,n={},i={};null!==t&&\"object\"==typeof t||(t={}),null!==e&&\"object\"==typeof e||(e={});for(r in e)r in t?n[r]=j(t[r],e[r]):i[r]=e[r];return function(t){for(r in n)i[r]=n[r](t);return i}},O=/[-+]?(?:\\d+\\.?\\d*|\\.?\\d+)(?:[eE][-+]?\\d+)?/g,R=new RegExp(O.source,\"g\"),F=function(t,e){var r,n,i,a=O.lastIndex=R.lastIndex=0,o=-1,s=[],l=[];for(t+=\"\",e+=\"\";(r=O.exec(t))&&(n=R.exec(e));)(i=n.index)>a&&(i=e.slice(a,i),s[o]?s[o]+=i:s[++o]=i),(r=r[0])===(n=n[0])?s[o]?s[o]+=n:s[++o]=n:(s[++o]=null,l.push({i:o,x:D(r,n)})),a=R.lastIndex;return a<e.length&&(i=e.slice(a),s[o]?s[o]+=i:s[++o]=i),s.length<2?l[0]?c(l[0].x):u(e):(e=l.length,function(t){for(var r,n=0;n<e;++n)s[(r=l[n]).i]=r.x(t);return s.join(\"\")})},j=function(t,r){var n,i=typeof r;return null==r||\"boolean\"===i?S(r):(\"number\"===i?D:\"string\"===i?(n=e.color(r))?(r=n,E):F:r instanceof e.color?E:r instanceof Date?I:Array.isArray(r)?z:\"function\"!=typeof r.valueOf&&\"function\"!=typeof r.toString||isNaN(r)?P:D)(t,r)},N=function(t,e){return t=+t,e-=t,function(r){return Math.round(t+e*r)}},B=180/Math.PI,U={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1},V=function(t,e,r,n,i,a){var o,s,l;return(o=Math.sqrt(t*t+e*e))&&(t/=o,e/=o),(l=t*r+e*n)&&(r-=t*l,n-=e*l),(s=Math.sqrt(r*r+n*n))&&(r/=s,n/=s,l/=s),t*n<e*r&&(t=-t,e=-e,l=-l,o=-o),{translateX:i,translateY:a,rotate:Math.atan2(e,t)*B,skewX:Math.atan(l)*B,scaleX:o,scaleY:s}},H=d(h,\"px, \",\"px)\",\"deg)\"),q=d(f,\", \",\")\",\")\"),G=Math.SQRT2,Y=function(t,e){var r,n,i=t[0],a=t[1],o=t[2],s=e[0],l=e[1],u=e[2],c=s-i,h=l-a,f=c*c+h*h;if(f<1e-12)n=Math.log(u/o)/G,r=function(t){return[i+t*c,a+t*h,o*Math.exp(G*t*n)]};else{var d=Math.sqrt(f),g=(u*u-o*o+4*f)/(2*o*2*d),y=(u*u-o*o-4*f)/(2*u*2*d),b=Math.log(Math.sqrt(g*g+1)-g),x=Math.log(Math.sqrt(y*y+1)-y);n=(x-b)/G,r=function(t){var e=t*n,r=p(b),s=o/(2*d)*(r*v(G*e+b)-m(b));return[i+s*c,a+s*h,o*r/p(G*e+b)]}}return r.duration=1e3*n,r},X=g(a),W=g(s),Z=b(a),J=b(s),K=x(a),Q=x(s),$=function(t,e){for(var r=new Array(e),n=0;n<e;++n)r[n]=t(n/(e-1));return r};t.interpolate=j,t.interpolateArray=z,t.interpolateBasis=A,t.interpolateBasisClosed=T,t.interpolateDate=I,t.interpolateNumber=D,t.interpolateObject=P,t.interpolateRound=N,t.interpolateString=F,t.interpolateTransformCss=H,t.interpolateTransformSvg=q,t.interpolateZoom=Y,t.interpolateRgb=E,t.interpolateRgbBasis=L,t.interpolateRgbBasisClosed=C,t.interpolateHsl=X,t.interpolateHslLong=W,t.interpolateLab=y,t.interpolateHcl=Z,t.interpolateHclLong=J,t.interpolateCubehelix=K,t.interpolateCubehelixLong=Q,t.quantize=$,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-color\":115}],119:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t,e,r,n){if(isNaN(e)||isNaN(r))return t;var i,a,o,s,l,u,c,h,f,d=t._root,p={data:n},m=t._x0,v=t._y0,g=t._x1,y=t._y1;if(!d)return t._root=p,t;for(;d.length;)if((u=e>=(a=(m+g)/2))?m=a:g=a,(c=r>=(o=(v+y)/2))?v=o:y=o,i=d,!(d=d[h=c<<1|u]))return i[h]=p,t;if(s=+t._x.call(null,d.data),l=+t._y.call(null,d.data),e===s&&r===l)return p.next=d,i?i[h]=p:t._root=p,t;do{i=i?i[h]=new Array(4):t._root=new Array(4),(u=e>=(a=(m+g)/2))?m=a:g=a,(c=r>=(o=(v+y)/2))?v=o:y=o}while((h=c<<1|u)==(f=(l>=o)<<1|s>=a));return i[f]=d,i[h]=p,t}function r(t){var r,n,i,a,o=t.length,s=new Array(o),l=new Array(o),u=1/0,c=1/0,h=-1/0,f=-1/0;for(n=0;n<o;++n)isNaN(i=+this._x.call(null,r=t[n]))||isNaN(a=+this._y.call(null,r))||(s[n]=i,l[n]=a,i<u&&(u=i),i>h&&(h=i),a<c&&(c=a),a>f&&(f=a));for(h<u&&(u=this._x0,h=this._x1),f<c&&(c=this._y0,f=this._y1),this.cover(u,c).cover(h,f),n=0;n<o;++n)e(this,s[n],l[n],t[n]);return this}function n(t){for(var e=0,r=t.length;e<r;++e)this.remove(t[e]);return this}function i(t){return t[0]}function a(t){return t[1]}function o(t,e,r){var n=new s(null==e?i:e,null==r?a:r,NaN,NaN,NaN,NaN);return null==t?n:n.addAll(t)}function s(t,e,r,n,i,a){this._x=t,this._y=e,this._x0=r,this._y0=n,this._x1=i,this._y1=a,this._root=void 0}function l(t){for(var e={data:t.data},r=e;t=t.next;)r=r.next={data:t.data};return e}var u=function(t){var r=+this._x.call(null,t),n=+this._y.call(null,t);return e(this.cover(r,n),r,n,t)},c=function(t,e){if(isNaN(t=+t)||isNaN(e=+e))return this;var r=this._x0,n=this._y0,i=this._x1,a=this._y1;if(isNaN(r))i=(r=Math.floor(t))+1,a=(n=Math.floor(e))+1;else{if(!(r>t||t>i||n>e||e>a))return this;var o,s,l=i-r,u=this._root;switch(s=(e<(n+a)/2)<<1|t<(r+i)/2){case 0:do{o=new Array(4),o[s]=u,u=o}while(l*=2,i=r+l,a=n+l,t>i||e>a);break;case 1:do{o=new Array(4),o[s]=u,u=o}while(l*=2,r=i-l,a=n+l,r>t||e>a);break;case 2:do{o=new Array(4),o[s]=u,u=o}while(l*=2,i=r+l,n=a-l,t>i||n>e);break;case 3:do{o=new Array(4),o[s]=u,u=o}while(l*=2,r=i-l,n=a-l,r>t||n>e)}this._root&&this._root.length&&(this._root=u)}return this._x0=r,this._y0=n,this._x1=i,this._y1=a,this},h=function(){var t=[];return this.visit(function(e){if(!e.length)do{t.push(e.data)}while(e=e.next)}),t},f=function(t){return arguments.length?this.cover(+t[0][0],+t[0][1]).cover(+t[1][0],+t[1][1]):isNaN(this._x0)?void 0:[[this._x0,this._y0],[this._x1,this._y1]]},d=function(t,e,r,n,i){this.node=t,this.x0=e,this.y0=r,this.x1=n,this.y1=i},p=function(t,e,r){var n,i,a,o,s,l,u,c=this._x0,h=this._y0,f=this._x1,p=this._y1,m=[],v=this._root;for(v&&m.push(new d(v,c,h,f,p)),null==r?r=1/0:(c=t-r,h=e-r,f=t+r,p=e+r,r*=r);l=m.pop();)if(!(!(v=l.node)||(i=l.x0)>f||(a=l.y0)>p||(o=l.x1)<c||(s=l.y1)<h))if(v.length){var g=(i+o)/2,y=(a+s)/2;m.push(new d(v[3],g,y,o,s),new d(v[2],i,y,g,s),new d(v[1],g,a,o,y),new d(v[0],i,a,g,y)),(u=(e>=y)<<1|t>=g)&&(l=m[m.length-1],m[m.length-1]=m[m.length-1-u],m[m.length-1-u]=l)}else{var b=t-+this._x.call(null,v.data),x=e-+this._y.call(null,v.data),_=b*b+x*x;if(_<r){var w=Math.sqrt(r=_);c=t-w,h=e-w,f=t+w,p=e+w,n=v.data}}return n},m=function(t){if(isNaN(a=+this._x.call(null,t))||isNaN(o=+this._y.call(null,t)))return this;var e,r,n,i,a,o,s,l,u,c,h,f,d=this._root,p=this._x0,m=this._y0,v=this._x1,g=this._y1;if(!d)return this;if(d.length)for(;;){if((u=a>=(s=(p+v)/2))?p=s:v=s,(c=o>=(l=(m+g)/2))?m=l:g=l,e=d,!(d=d[h=c<<1|u]))return this;if(!d.length)break;(e[h+1&3]||e[h+2&3]||e[h+3&3])&&(r=e,f=h)}for(;d.data!==t;)if(n=d,!(d=d.next))return this;return(i=d.next)&&delete d.next,n?(i?n.next=i:delete n.next,this):e?(i?e[h]=i:delete e[h],(d=e[0]||e[1]||e[2]||e[3])&&d===(e[3]||e[2]||e[1]||e[0])&&!d.length&&(r?r[f]=d:this._root=d),this):(this._root=i,this)},v=function(){return this._root},g=function(){var t=0;return this.visit(function(e){if(!e.length)do{++t}while(e=e.next)}),t},y=function(t){var e,r,n,i,a,o,s=[],l=this._root;for(l&&s.push(new d(l,this._x0,this._y0,this._x1,this._y1));e=s.pop();)if(!t(l=e.node,n=e.x0,i=e.y0,a=e.x1,o=e.y1)&&l.length){var u=(n+a)/2,c=(i+o)/2;(r=l[3])&&s.push(new d(r,u,c,a,o)),(r=l[2])&&s.push(new d(r,n,c,u,o)),(r=l[1])&&s.push(new d(r,u,i,a,c)),(r=l[0])&&s.push(new d(r,n,i,u,c))}return this},b=function(t){var e,r=[],n=[];for(this._root&&r.push(new d(this._root,this._x0,this._y0,this._x1,this._y1));e=r.pop();){var i=e.node;if(i.length){var a,o=e.x0,s=e.y0,l=e.x1,u=e.y1,c=(o+l)/2,h=(s+u)/2;(a=i[0])&&r.push(new d(a,o,s,c,h)),(a=i[1])&&r.push(new d(a,c,s,l,h)),(a=i[2])&&r.push(new d(a,o,h,c,u)),(a=i[3])&&r.push(new d(a,c,h,l,u))}n.push(e)}for(;e=n.pop();)t(e.node,e.x0,e.y0,e.x1,e.y1);return this},x=function(t){return arguments.length?(this._x=t,this):this._x},_=function(t){return arguments.length?(this._y=t,this):this._y},w=o.prototype=s.prototype;w.copy=function(){var t,e,r=new s(this._x,this._y,this._x0,this._y0,this._x1,this._y1),n=this._root;if(!n)return r;if(!n.length)return r._root=l(n),r;for(t=[{source:n,target:r._root=new Array(4)}];n=t.pop();)for(var i=0;i<4;++i)(e=n.source[i])&&(e.length?t.push({source:e,target:n.target[i]=new Array(4)}):n.target[i]=l(e));return r},w.add=u,w.addAll=r,w.cover=c,w.data=h,w.extent=f,w.find=p,w.remove=m,w.removeAll=n,w.root=v,w.size=g,w.visit=y,w.visitAfter=b,w.x=x,w.y=_,t.quadtree=o,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],120:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){return g||(x(r),g=b.now()+y)}function r(){g=0}function n(){this._call=this._time=this._next=null}function i(t,e,r){var i=new n;return i.restart(t,e,r),i}function a(){e(),++f;for(var t,r=c;r;)(t=g-r._time)>=0&&r._call.call(null,t),r=r._next;--f}function o(){g=(v=b.now())+y,f=d=0;try{a()}finally{f=0,l(),g=0}}function s(){var t=b.now(),e=t-v;e>m&&(y-=e,v=t)}function l(){for(var t,e,r=c,n=1/0;r;)r._call?(n>r._time&&(n=r._time),t=r,r=r._next):(e=r._next,r._next=null,r=t?t._next=e:c=e);h=t,u(n)}function u(t){if(!f){d&&(d=clearTimeout(d));var e=t-g;e>24?(t<1/0&&(d=setTimeout(o,e)),p&&(p=clearInterval(p))):(p||(v=g,p=setInterval(s,m)),f=1,x(o))}}var c,h,f=0,d=0,p=0,m=1e3,v=0,g=0,y=0,b=\"object\"==typeof performance&&performance.now?performance:Date,x=\"function\"==typeof requestAnimationFrame?requestAnimationFrame:function(t){setTimeout(t,17)};n.prototype=i.prototype={constructor:n,restart:function(t,r,n){if(\"function\"!=typeof t)throw new TypeError(\"callback is not a function\");n=(null==n?e():+n)+(null==r?0:+r),this._next||h===this||(h?h._next=this:c=this,h=this),this._call=t,this._time=n,u()},stop:function(){this._call&&(this._call=null,this._time=1/0,u())}};var _=function(t,e,r){var i=new n;return e=null==e?0:+e,i.restart(function(r){i.stop(),t(r+e)},e,r),i},w=function(t,r,i){var a=new n,o=r;return null==r?(a.restart(t,r,i),a):(r=+r,i=null==i?e():+i,a.restart(function e(n){n+=o,a.restart(e,o+=r,i),t(n)},r,i),a)};t.now=e,t.timer=i,t.timerFlush=a,t.timeout=_,t.interval=w,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],121:[function(e,r,n){!function(){function e(t){return t&&(t.ownerDocument||t.document||t).documentElement}function n(t){return t&&(t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView)}function i(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}function a(t){return null===t?NaN:+t}function o(t){return!isNaN(t)}function s(t){return{left:function(e,r,n,i){for(arguments.length<3&&(n=0),arguments.length<4&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)<0?n=a+1:i=a}return n},right:function(e,r,n,i){for(arguments.length<3&&(n=0),arguments.length<4&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)>0?i=a:n=a+1}return n}}}function l(t){return t.length}function u(t){for(var e=1;t*e%1;)e*=10;return e}function c(t,e){for(var r in e)Object.defineProperty(t.prototype,r,{value:e[r],enumerable:!1})}function h(){this._=Object.create(null)}function f(t){return(t+=\"\")===_o||t[0]===wo?wo+t:t}function d(t){return(t+=\"\")[0]===wo?t.slice(1):t}function p(t){return f(t)in this._}function m(t){return(t=f(t))in this._&&delete this._[t]}function v(){var t=[];for(var e in this._)t.push(d(e));return t}function g(){var t=0;for(var e in this._)++t;return t}function y(){for(var t in this._)return!1;return!0}function b(){this._=Object.create(null)}function x(t){return t}function _(t,e,r){return function(){var n=r.apply(e,arguments);return n===e?t:n}}function w(t,e){if(e in t)return e;e=e.charAt(0).toUpperCase()+e.slice(1);for(var r=0,n=Mo.length;r<n;++r){var i=Mo[r]+e;if(i in t)return i}}function M(){}function k(){}function A(t){function e(){for(var e,n=r,i=-1,a=n.length;++i<a;)(e=n[i].on)&&e.apply(this,arguments);return t}var r=[],n=new h;return e.on=function(e,i){var a,o=n.get(e);return arguments.length<2?o&&o.on:(o&&(o.on=null,r=r.slice(0,a=r.indexOf(o)).concat(r.slice(a+1)),n.remove(e)),i&&r.push(n.set(e,{on:i})),t)},e}function T(){uo.event.preventDefault()}function S(){for(var t,e=uo.event;t=e.sourceEvent;)e=t;return e}function E(t){for(var e=new k,r=0,n=arguments.length;++r<n;)e[arguments[r]]=A(e);return e.of=function(r,n){return function(i){try{var a=i.sourceEvent=uo.event;i.target=t,uo.event=i,e[i.type].apply(r,n)}finally{uo.event=a}}},e}function L(t){return Ao(t,Lo),t}function C(t){return\"function\"==typeof t?t:function(){return To(t,this)}}function z(t){return\"function\"==typeof t?t:function(){return So(t,this)}}function I(t,e){function r(){this.removeAttribute(t)}function n(){this.removeAttributeNS(t.space,t.local)}function i(){this.setAttribute(t,e)}function a(){this.setAttributeNS(t.space,t.local,e)}function o(){var r=e.apply(this,arguments);null==r?this.removeAttribute(t):this.setAttribute(t,r)}function s(){var r=e.apply(this,arguments);null==r?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,r)}return t=uo.ns.qualify(t),null==e?t.local?n:r:\"function\"==typeof e?t.local?s:o:t.local?a:i}function D(t){return t.trim().replace(/\\s+/g,\" \")}function P(t){return new RegExp(\"(?:^|\\\\s+)\"+uo.requote(t)+\"(?:\\\\s+|$)\",\"g\")}function O(t){return(t+\"\").trim().split(/^|\\s+/)}function R(t,e){function r(){for(var r=-1;++r<i;)t[r](this,e)}function n(){for(var r=-1,n=e.apply(this,arguments);++r<i;)t[r](this,n)}t=O(t).map(F);var i=t.length;return\"function\"==typeof e?n:r}function F(t){var e=P(t);return function(r,n){if(i=r.classList)return n?i.add(t):i.remove(t);var i=r.getAttribute(\"class\")||\"\";n?(e.lastIndex=0,e.test(i)||r.setAttribute(\"class\",D(i+\" \"+t))):r.setAttribute(\"class\",D(i.replace(e,\" \")))}}function j(t,e,r){function n(){this.style.removeProperty(t)}function i(){this.style.setProperty(t,e,r)}function a(){var n=e.apply(this,arguments);null==n?this.style.removeProperty(t):this.style.setProperty(t,n,r)}return null==e?n:\"function\"==typeof e?a:i}function N(t,e){function r(){delete this[t]}function n(){this[t]=e}function i(){var r=e.apply(this,arguments);null==r?delete this[t]:this[t]=r}return null==e?r:\"function\"==typeof e?i:n}function B(t){function e(){var e=this.ownerDocument,r=this.namespaceURI;return r===Co&&e.documentElement.namespaceURI===Co?e.createElement(t):e.createElementNS(r,t)}function r(){return this.ownerDocument.createElementNS(t.space,t.local)}return\"function\"==typeof t?t:(t=uo.ns.qualify(t)).local?r:e}function U(){var t=this.parentNode;t&&t.removeChild(this)}function V(t){return{__data__:t}}function H(t){return function(){return Eo(this,t)}}function q(t){return arguments.length||(t=i),function(e,r){return e&&r?t(e.__data__,r.__data__):!e-!r}}function G(t,e){for(var r=0,n=t.length;r<n;r++)for(var i,a=t[r],o=0,s=a.length;o<s;o++)(i=a[o])&&e(i,o,r);return t}function Y(t){return Ao(t,Io),t}function X(t){var e,r;return function(n,i,a){var o,s=t[a].update,l=s.length;for(a!=r&&(r=a,e=0),i>=e&&(e=i+1);!(o=s[e])&&++e<l;);return o}}function W(t,e,r){function n(){var e=this[o];e&&(this.removeEventListener(t,e,e.$),delete this[o])}function i(){var i=l(e,ho(arguments));n.call(this),this.addEventListener(t,this[o]=i,i.$=r),i._=e}function a(){var e,r=new RegExp(\"^__on([^.]+)\"+uo.requote(t)+\"$\");for(var n in this)if(e=n.match(r)){var i=this[n];this.removeEventListener(e[1],i,i.$),delete this[n]}}var o=\"__on\"+t,s=t.indexOf(\".\"),l=Z;s>0&&(t=t.slice(0,s));var u=Do.get(t);return u&&(t=u,l=J),s?e?i:n:e?M:a}function Z(t,e){return function(r){var n=uo.event;uo.event=r,e[0]=this.__data__;try{t.apply(this,e)}finally{uo.event=n}}}function J(t,e){var r=Z(t,e);return function(t){var e=this,n=t.relatedTarget;n&&(n===e||8&n.compareDocumentPosition(e))||r.call(e,t)}}function K(t){var r=\".dragsuppress-\"+ ++Oo,i=\"click\"+r,a=uo.select(n(t)).on(\"touchmove\"+r,T).on(\"dragstart\"+r,T).on(\"selectstart\"+r,T);if(null==Po&&(Po=!(\"onselectstart\"in t)&&w(t.style,\"userSelect\")),Po){var o=e(t).style,s=o[Po];o[Po]=\"none\"}return function(t){if(a.on(r,null),Po&&(o[Po]=s),t){var e=function(){a.on(i,null)};a.on(i,function(){T(),e()},!0),setTimeout(e,0)}}}function Q(t,e){e.changedTouches&&(e=e.changedTouches[0]);var r=t.ownerSVGElement||t;if(r.createSVGPoint){var i=r.createSVGPoint();if(Ro<0){var a=n(t);if(a.scrollX||a.scrollY){r=uo.select(\"body\").append(\"svg\").style({position:\"absolute\",top:0,left:0,margin:0,padding:0,border:\"none\"},\"important\");var o=r[0][0].getScreenCTM();Ro=!(o.f||o.e),r.remove()}}return Ro?(i.x=e.pageX,i.y=e.pageY):(i.x=e.clientX,i.y=e.clientY),i=i.matrixTransform(t.getScreenCTM().inverse()),[i.x,i.y]}var s=t.getBoundingClientRect();return[e.clientX-s.left-t.clientLeft,e.clientY-s.top-t.clientTop]}function $(){return uo.event.changedTouches[0].identifier}function tt(t){return t>0?1:t<0?-1:0}function et(t,e,r){return(e[0]-t[0])*(r[1]-t[1])-(e[1]-t[1])*(r[0]-t[0])}function rt(t){return t>1?0:t<-1?No:Math.acos(t)}function nt(t){return t>1?Vo:t<-1?-Vo:Math.asin(t)}function it(t){return((t=Math.exp(t))-1/t)/2}function at(t){return((t=Math.exp(t))+1/t)/2}function ot(t){return((t=Math.exp(2*t))-1)/(t+1)}function st(t){return(t=Math.sin(t/2))*t}function lt(){}function ut(t,e,r){return this instanceof ut?(this.h=+t,this.s=+e,void(this.l=+r)):arguments.length<2?t instanceof ut?new ut(t.h,t.s,t.l):Mt(\"\"+t,kt,ut):new ut(t,e,r)}function ct(t,e,r){function n(t){return t>360?t-=360:t<0&&(t+=360),t<60?a+(o-a)*t/60:t<180?o:t<240?a+(o-a)*(240-t)/60:a}function i(t){return Math.round(255*n(t))}var a,o;return t=isNaN(t)?0:(t%=360)<0?t+360:t,e=isNaN(e)?0:e<0?0:e>1?1:e,r=r<0?0:r>1?1:r,o=r<=.5?r*(1+e):r+e-r*e,a=2*r-o,new bt(i(t+120),i(t),i(t-120))}function ht(t,e,r){return this instanceof ht?(this.h=+t,this.c=+e,void(this.l=+r)):arguments.length<2?t instanceof ht?new ht(t.h,t.c,t.l):t instanceof dt?mt(t.l,t.a,t.b):mt((t=At((t=uo.rgb(t)).r,t.g,t.b)).l,t.a,t.b):new ht(t,e,r)}function ft(t,e,r){return isNaN(t)&&(t=0),isNaN(e)&&(e=0),new dt(r,Math.cos(t*=Ho)*e,Math.sin(t)*e)}function dt(t,e,r){return this instanceof dt?(this.l=+t,this.a=+e,void(this.b=+r)):arguments.length<2?t instanceof dt?new dt(t.l,t.a,t.b):t instanceof ht?ft(t.h,t.c,t.l):At((t=bt(t)).r,t.g,t.b):new dt(t,e,r)}function pt(t,e,r){var n=(t+16)/116,i=n+e/500,a=n-r/200;return i=vt(i)*Qo,n=vt(n)*$o,a=vt(a)*ts,new bt(yt(3.2404542*i-1.5371385*n-.4985314*a),yt(-.969266*i+1.8760108*n+.041556*a),yt(.0556434*i-.2040259*n+1.0572252*a))}function mt(t,e,r){return t>0?new ht(Math.atan2(r,e)*qo,Math.sqrt(e*e+r*r),t):new ht(NaN,NaN,t)}function vt(t){return t>.206893034?t*t*t:(t-4/29)/7.787037}function gt(t){return t>.008856?Math.pow(t,1/3):7.787037*t+4/29}function yt(t){return Math.round(255*(t<=.00304?12.92*t:1.055*Math.pow(t,1/2.4)-.055))}function bt(t,e,r){return this instanceof bt?(this.r=~~t,this.g=~~e,void(this.b=~~r)):arguments.length<2?t instanceof bt?new bt(t.r,t.g,t.b):Mt(\"\"+t,bt,ct):new bt(t,e,r)}function xt(t){return new bt(t>>16,t>>8&255,255&t)}function _t(t){return xt(t)+\"\"}function wt(t){return t<16?\"0\"+Math.max(0,t).toString(16):Math.min(255,t).toString(16)}function Mt(t,e,r){var n,i,a,o=0,s=0,l=0;if(n=/([a-z]+)\\((.*)\\)/.exec(t=t.toLowerCase()))switch(i=n[2].split(\",\"),n[1]){case\"hsl\":return r(parseFloat(i[0]),parseFloat(i[1])/100,parseFloat(i[2])/100);case\"rgb\":return e(St(i[0]),St(i[1]),St(i[2]))}return(a=ns.get(t))?e(a.r,a.g,a.b):(null==t||\"#\"!==t.charAt(0)||isNaN(a=parseInt(t.slice(1),16))||(4===t.length?(o=(3840&a)>>4,o|=o>>4,s=240&a,s|=s>>4,l=15&a,l|=l<<4):7===t.length&&(o=(16711680&a)>>16,s=(65280&a)>>8,l=255&a)),e(o,s,l))}function kt(t,e,r){var n,i,a=Math.min(t/=255,e/=255,r/=255),o=Math.max(t,e,r),s=o-a,l=(o+a)/2;return s?(i=l<.5?s/(o+a):s/(2-o-a),n=t==o?(e-r)/s+(e<r?6:0):e==o?(r-t)/s+2:(t-e)/s+4,n*=60):(n=NaN,i=l>0&&l<1?0:n),new ut(n,i,l)}function At(t,e,r){t=Tt(t),e=Tt(e),r=Tt(r);var n=gt((.4124564*t+.3575761*e+.1804375*r)/Qo),i=gt((.2126729*t+.7151522*e+.072175*r)/$o);return dt(116*i-16,500*(n-i),200*(i-gt((.0193339*t+.119192*e+.9503041*r)/ts)))}function Tt(t){return(t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function St(t){var e=parseFloat(t);return\"%\"===t.charAt(t.length-1)?Math.round(2.55*e):e}function Et(t){return\"function\"==typeof t?t:function(){return t}}\n",
       "function Lt(t){return function(e,r,n){return 2===arguments.length&&\"function\"==typeof r&&(n=r,r=null),Ct(e,r,t,n)}}function Ct(t,e,r,n){function i(){var t,e=l.status;if(!e&&It(l)||e>=200&&e<300||304===e){try{t=r.call(a,l)}catch(t){return void o.error.call(a,t)}o.load.call(a,t)}else o.error.call(a,l)}var a={},o=uo.dispatch(\"beforesend\",\"progress\",\"load\",\"error\"),s={},l=new XMLHttpRequest,u=null;return!this.XDomainRequest||\"withCredentials\"in l||!/^(http(s)?:)?\\/\\//.test(t)||(l=new XDomainRequest),\"onload\"in l?l.onload=l.onerror=i:l.onreadystatechange=function(){l.readyState>3&&i()},l.onprogress=function(t){var e=uo.event;uo.event=t;try{o.progress.call(a,l)}finally{uo.event=e}},a.header=function(t,e){return t=(t+\"\").toLowerCase(),arguments.length<2?s[t]:(null==e?delete s[t]:s[t]=e+\"\",a)},a.mimeType=function(t){return arguments.length?(e=null==t?null:t+\"\",a):e},a.responseType=function(t){return arguments.length?(u=t,a):u},a.response=function(t){return r=t,a},[\"get\",\"post\"].forEach(function(t){a[t]=function(){return a.send.apply(a,[t].concat(ho(arguments)))}}),a.send=function(r,n,i){if(2===arguments.length&&\"function\"==typeof n&&(i=n,n=null),l.open(r,t,!0),null==e||\"accept\"in s||(s.accept=e+\",*/*\"),l.setRequestHeader)for(var c in s)l.setRequestHeader(c,s[c]);return null!=e&&l.overrideMimeType&&l.overrideMimeType(e),null!=u&&(l.responseType=u),null!=i&&a.on(\"error\",i).on(\"load\",function(t){i(null,t)}),o.beforesend.call(a,l),l.send(null==n?null:n),a},a.abort=function(){return l.abort(),a},uo.rebind(a,o,\"on\"),null==n?a:a.get(zt(n))}function zt(t){return 1===t.length?function(e,r){t(null==e?r:null)}:t}function It(t){var e=t.responseType;return e&&\"text\"!==e?t.response:t.responseText}function Dt(t,e,r){var n=arguments.length;n<2&&(e=0),n<3&&(r=Date.now());var i=r+e,a={c:t,t:i,n:null};return as?as.n=a:is=a,as=a,os||(ss=clearTimeout(ss),os=1,ls(Pt)),a}function Pt(){var t=Ot(),e=Rt()-t;e>24?(isFinite(e)&&(clearTimeout(ss),ss=setTimeout(Pt,e)),os=0):(os=1,ls(Pt))}function Ot(){for(var t=Date.now(),e=is;e;)t>=e.t&&e.c(t-e.t)&&(e.c=null),e=e.n;return t}function Rt(){for(var t,e=is,r=1/0;e;)e.c?(e.t<r&&(r=e.t),e=(t=e).n):e=t?t.n=e.n:is=e.n;return as=t,r}function Ft(t,e){return e-(t?Math.ceil(Math.log(t)/Math.LN10):1)}function jt(t,e){var r=Math.pow(10,3*xo(8-e));return{scale:e>8?function(t){return t/r}:function(t){return t*r},symbol:t}}function Nt(t){var e=t.decimal,r=t.thousands,n=t.grouping,i=t.currency,a=n&&r?function(t,e){for(var i=t.length,a=[],o=0,s=n[0],l=0;i>0&&s>0&&(l+s+1>e&&(s=Math.max(1,e-l)),a.push(t.substring(i-=s,i+s)),!((l+=s+1)>e));)s=n[o=(o+1)%n.length];return a.reverse().join(r)}:x;return function(t){var r=cs.exec(t),n=r[1]||\" \",o=r[2]||\">\",s=r[3]||\"-\",l=r[4]||\"\",u=r[5],c=+r[6],h=r[7],f=r[8],d=r[9],p=1,m=\"\",v=\"\",g=!1,y=!0;switch(f&&(f=+f.substring(1)),(u||\"0\"===n&&\"=\"===o)&&(u=n=\"0\",o=\"=\"),d){case\"n\":h=!0,d=\"g\";break;case\"%\":p=100,v=\"%\",d=\"f\";break;case\"p\":p=100,v=\"%\",d=\"r\";break;case\"b\":case\"o\":case\"x\":case\"X\":\"#\"===l&&(m=\"0\"+d.toLowerCase());case\"c\":y=!1;case\"d\":g=!0,f=0;break;case\"s\":p=-1,d=\"r\"}\"$\"===l&&(m=i[0],v=i[1]),\"r\"!=d||f||(d=\"g\"),null!=f&&(\"g\"==d?f=Math.max(1,Math.min(21,f)):\"e\"!=d&&\"f\"!=d||(f=Math.max(0,Math.min(20,f)))),d=hs.get(d)||Bt;var b=u&&h;return function(t){var r=v;if(g&&t%1)return\"\";var i=t<0||0===t&&1/t<0?(t=-t,\"-\"):\"-\"===s?\"\":s;if(p<0){var l=uo.formatPrefix(t,f);t=l.scale(t),r=l.symbol+v}else t*=p;t=d(t,f);var x,_,w=t.lastIndexOf(\".\");if(w<0){var M=y?t.lastIndexOf(\"e\"):-1;M<0?(x=t,_=\"\"):(x=t.substring(0,M),_=t.substring(M))}else x=t.substring(0,w),_=e+t.substring(w+1);!u&&h&&(x=a(x,1/0));var k=m.length+x.length+_.length+(b?0:i.length),A=k<c?new Array(k=c-k+1).join(n):\"\";return b&&(x=a(A+x,A.length?c-_.length:1/0)),i+=m,t=x+_,(\"<\"===o?i+t+A:\">\"===o?A+i+t:\"^\"===o?A.substring(0,k>>=1)+i+t+A.substring(k):i+(b?t:A+t))+r}}}function Bt(t){return t+\"\"}function Ut(){this._=new Date(arguments.length>1?Date.UTC.apply(this,arguments):arguments[0])}function Vt(t,e,r){function n(e){var r=t(e),n=a(r,1);return e-r<n-e?r:n}function i(r){return e(r=t(new ds(r-1)),1),r}function a(t,r){return e(t=new ds(+t),r),t}function o(t,n,a){var o=i(t),s=[];if(a>1)for(;o<n;)r(o)%a||s.push(new Date(+o)),e(o,1);else for(;o<n;)s.push(new Date(+o)),e(o,1);return s}function s(t,e,r){try{ds=Ut;var n=new Ut;return n._=t,o(n,e,r)}finally{ds=Date}}t.floor=t,t.round=n,t.ceil=i,t.offset=a,t.range=o;var l=t.utc=Ht(t);return l.floor=l,l.round=Ht(n),l.ceil=Ht(i),l.offset=Ht(a),l.range=s,t}function Ht(t){return function(e,r){try{ds=Ut;var n=new Ut;return n._=e,t(n,r)._}finally{ds=Date}}}function qt(t){function e(t){function e(e){for(var r,i,a,o=[],s=-1,l=0;++s<n;)37===t.charCodeAt(s)&&(o.push(t.slice(l,s)),null!=(i=ms[r=t.charAt(++s)])&&(r=t.charAt(++s)),(a=E[r])&&(r=a(e,null==i?\"e\"===r?\" \":\"0\":i)),o.push(r),l=s+1);return o.push(t.slice(l,s)),o.join(\"\")}var n=t.length;return e.parse=function(e){var n={y:1900,m:0,d:1,H:0,M:0,S:0,L:0,Z:null};if(r(n,t,e,0)!=e.length)return null;\"p\"in n&&(n.H=n.H%12+12*n.p);var i=null!=n.Z&&ds!==Ut,a=new(i?Ut:ds);return\"j\"in n?a.setFullYear(n.y,0,n.j):\"W\"in n||\"U\"in n?(\"w\"in n||(n.w=\"W\"in n?1:0),a.setFullYear(n.y,0,1),a.setFullYear(n.y,0,\"W\"in n?(n.w+6)%7+7*n.W-(a.getDay()+5)%7:n.w+7*n.U-(a.getDay()+6)%7)):a.setFullYear(n.y,n.m,n.d),a.setHours(n.H+(n.Z/100|0),n.M+n.Z%100,n.S,n.L),i?a._:a},e.toString=function(){return t},e}function r(t,e,r,n){for(var i,a,o,s=0,l=e.length,u=r.length;s<l;){if(n>=u)return-1;if(37===(i=e.charCodeAt(s++))){if(o=e.charAt(s++),!(a=L[o in ms?e.charAt(s++):o])||(n=a(t,r,n))<0)return-1}else if(i!=r.charCodeAt(n++))return-1}return n}function n(t,e,r){w.lastIndex=0;var n=w.exec(e.slice(r));return n?(t.w=M.get(n[0].toLowerCase()),r+n[0].length):-1}function i(t,e,r){x.lastIndex=0;var n=x.exec(e.slice(r));return n?(t.w=_.get(n[0].toLowerCase()),r+n[0].length):-1}function a(t,e,r){T.lastIndex=0;var n=T.exec(e.slice(r));return n?(t.m=S.get(n[0].toLowerCase()),r+n[0].length):-1}function o(t,e,r){k.lastIndex=0;var n=k.exec(e.slice(r));return n?(t.m=A.get(n[0].toLowerCase()),r+n[0].length):-1}function s(t,e,n){return r(t,E.c.toString(),e,n)}function l(t,e,n){return r(t,E.x.toString(),e,n)}function u(t,e,n){return r(t,E.X.toString(),e,n)}function c(t,e,r){var n=b.get(e.slice(r,r+=2).toLowerCase());return null==n?-1:(t.p=n,r)}var h=t.dateTime,f=t.date,d=t.time,p=t.periods,m=t.days,v=t.shortDays,g=t.months,y=t.shortMonths;e.utc=function(t){function r(t){try{ds=Ut;var e=new ds;return e._=t,n(e)}finally{ds=Date}}var n=e(t);return r.parse=function(t){try{ds=Ut;var e=n.parse(t);return e&&e._}finally{ds=Date}},r.toString=n.toString,r},e.multi=e.utc.multi=ce;var b=uo.map(),x=Yt(m),_=Xt(m),w=Yt(v),M=Xt(v),k=Yt(g),A=Xt(g),T=Yt(y),S=Xt(y);p.forEach(function(t,e){b.set(t.toLowerCase(),e)});var E={a:function(t){return v[t.getDay()]},A:function(t){return m[t.getDay()]},b:function(t){return y[t.getMonth()]},B:function(t){return g[t.getMonth()]},c:e(h),d:function(t,e){return Gt(t.getDate(),e,2)},e:function(t,e){return Gt(t.getDate(),e,2)},H:function(t,e){return Gt(t.getHours(),e,2)},I:function(t,e){return Gt(t.getHours()%12||12,e,2)},j:function(t,e){return Gt(1+fs.dayOfYear(t),e,3)},L:function(t,e){return Gt(t.getMilliseconds(),e,3)},m:function(t,e){return Gt(t.getMonth()+1,e,2)},M:function(t,e){return Gt(t.getMinutes(),e,2)},p:function(t){return p[+(t.getHours()>=12)]},S:function(t,e){return Gt(t.getSeconds(),e,2)},U:function(t,e){return Gt(fs.sundayOfYear(t),e,2)},w:function(t){return t.getDay()},W:function(t,e){return Gt(fs.mondayOfYear(t),e,2)},x:e(f),X:e(d),y:function(t,e){return Gt(t.getFullYear()%100,e,2)},Y:function(t,e){return Gt(t.getFullYear()%1e4,e,4)},Z:le,\"%\":function(){return\"%\"}},L={a:n,A:i,b:a,B:o,c:s,d:re,e:re,H:ie,I:ie,j:ne,L:se,m:ee,M:ae,p:c,S:oe,U:Zt,w:Wt,W:Jt,x:l,X:u,y:Qt,Y:Kt,Z:$t,\"%\":ue};return e}function Gt(t,e,r){var n=t<0?\"-\":\"\",i=(n?-t:t)+\"\",a=i.length;return n+(a<r?new Array(r-a+1).join(e)+i:i)}function Yt(t){return new RegExp(\"^(?:\"+t.map(uo.requote).join(\"|\")+\")\",\"i\")}function Xt(t){for(var e=new h,r=-1,n=t.length;++r<n;)e.set(t[r].toLowerCase(),r);return e}function Wt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+1));return n?(t.w=+n[0],r+n[0].length):-1}function Zt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r));return n?(t.U=+n[0],r+n[0].length):-1}function Jt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r));return n?(t.W=+n[0],r+n[0].length):-1}function Kt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+4));return n?(t.y=+n[0],r+n[0].length):-1}function Qt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.y=te(+n[0]),r+n[0].length):-1}function $t(t,e,r){return/^[+-]\\d{4}$/.test(e=e.slice(r,r+5))?(t.Z=-e,r+5):-1}function te(t){return t+(t>68?1900:2e3)}function ee(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.m=n[0]-1,r+n[0].length):-1}function re(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.d=+n[0],r+n[0].length):-1}function ne(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+3));return n?(t.j=+n[0],r+n[0].length):-1}function ie(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.H=+n[0],r+n[0].length):-1}function ae(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.M=+n[0],r+n[0].length):-1}function oe(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.S=+n[0],r+n[0].length):-1}function se(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+3));return n?(t.L=+n[0],r+n[0].length):-1}function le(t){var e=t.getTimezoneOffset(),r=e>0?\"-\":\"+\",n=xo(e)/60|0,i=xo(e)%60;return r+Gt(n,\"0\",2)+Gt(i,\"0\",2)}function ue(t,e,r){gs.lastIndex=0;var n=gs.exec(e.slice(r,r+1));return n?r+n[0].length:-1}function ce(t){for(var e=t.length,r=-1;++r<e;)t[r][0]=this(t[r][0]);return function(e){for(var r=0,n=t[r];!n[1](e);)n=t[++r];return n[0](e)}}function he(){}function fe(t,e,r){var n=r.s=t+e,i=n-t,a=n-i;r.t=t-a+(e-i)}function de(t,e){t&&_s.hasOwnProperty(t.type)&&_s[t.type](t,e)}function pe(t,e,r){var n,i=-1,a=t.length-r;for(e.lineStart();++i<a;)n=t[i],e.point(n[0],n[1],n[2]);e.lineEnd()}function me(t,e){var r=-1,n=t.length;for(e.polygonStart();++r<n;)pe(t[r],e,1);e.polygonEnd()}function ve(){function t(t,e){t*=Ho,e=e*Ho/2+No/4;var r=t-n,o=r>=0?1:-1,s=o*r,l=Math.cos(e),u=Math.sin(e),c=a*u,h=i*l+c*Math.cos(s),f=c*o*Math.sin(s);Ms.add(Math.atan2(f,h)),n=t,i=l,a=u}var e,r,n,i,a;ks.point=function(o,s){ks.point=t,n=(e=o)*Ho,i=Math.cos(s=(r=s)*Ho/2+No/4),a=Math.sin(s)},ks.lineEnd=function(){t(e,r)}}function ge(t){var e=t[0],r=t[1],n=Math.cos(r);return[n*Math.cos(e),n*Math.sin(e),Math.sin(r)]}function ye(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}function be(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]}function xe(t,e){t[0]+=e[0],t[1]+=e[1],t[2]+=e[2]}function _e(t,e){return[t[0]*e,t[1]*e,t[2]*e]}function we(t){var e=Math.sqrt(t[0]*t[0]+t[1]*t[1]+t[2]*t[2]);t[0]/=e,t[1]/=e,t[2]/=e}function Me(t){return[Math.atan2(t[1],t[0]),nt(t[2])]}function ke(t,e){return xo(t[0]-e[0])<Fo&&xo(t[1]-e[1])<Fo}function Ae(t,e){t*=Ho;var r=Math.cos(e*=Ho);Te(r*Math.cos(t),r*Math.sin(t),Math.sin(e))}function Te(t,e,r){++As,Ss+=(t-Ss)/As,Es+=(e-Es)/As,Ls+=(r-Ls)/As}function Se(){function t(t,i){t*=Ho;var a=Math.cos(i*=Ho),o=a*Math.cos(t),s=a*Math.sin(t),l=Math.sin(i),u=Math.atan2(Math.sqrt((u=r*l-n*s)*u+(u=n*o-e*l)*u+(u=e*s-r*o)*u),e*o+r*s+n*l);Ts+=u,Cs+=u*(e+(e=o)),zs+=u*(r+(r=s)),Is+=u*(n+(n=l)),Te(e,r,n)}var e,r,n;Rs.point=function(i,a){i*=Ho;var o=Math.cos(a*=Ho);e=o*Math.cos(i),r=o*Math.sin(i),n=Math.sin(a),Rs.point=t,Te(e,r,n)}}function Ee(){Rs.point=Ae}function Le(){function t(t,e){t*=Ho;var r=Math.cos(e*=Ho),o=r*Math.cos(t),s=r*Math.sin(t),l=Math.sin(e),u=i*l-a*s,c=a*o-n*l,h=n*s-i*o,f=Math.sqrt(u*u+c*c+h*h),d=n*o+i*s+a*l,p=f&&-rt(d)/f,m=Math.atan2(f,d);Ds+=p*u,Ps+=p*c,Os+=p*h,Ts+=m,Cs+=m*(n+(n=o)),zs+=m*(i+(i=s)),Is+=m*(a+(a=l)),Te(n,i,a)}var e,r,n,i,a;Rs.point=function(o,s){e=o,r=s,Rs.point=t,o*=Ho;var l=Math.cos(s*=Ho);n=l*Math.cos(o),i=l*Math.sin(o),a=Math.sin(s),Te(n,i,a)},Rs.lineEnd=function(){t(e,r),Rs.lineEnd=Ee,Rs.point=Ae}}function Ce(t,e){function r(r,n){return r=t(r,n),e(r[0],r[1])}return t.invert&&e.invert&&(r.invert=function(r,n){return(r=e.invert(r,n))&&t.invert(r[0],r[1])}),r}function ze(){return!0}function Ie(t,e,r,n,i){var a=[],o=[];if(t.forEach(function(t){if(!((e=t.length-1)<=0)){var e,r=t[0],n=t[e];if(ke(r,n)){i.lineStart();for(var s=0;s<e;++s)i.point((r=t[s])[0],r[1]);return void i.lineEnd()}var l=new Pe(r,t,null,!0),u=new Pe(r,null,l,!1);l.o=u,a.push(l),o.push(u),l=new Pe(n,t,null,!1),u=new Pe(n,null,l,!0),l.o=u,a.push(l),o.push(u)}}),o.sort(e),De(a),De(o),a.length){for(var s=0,l=r,u=o.length;s<u;++s)o[s].e=l=!l;for(var c,h,f=a[0];;){for(var d=f,p=!0;d.v;)if((d=d.n)===f)return;c=d.z,i.lineStart();do{if(d.v=d.o.v=!0,d.e){if(p)for(var s=0,u=c.length;s<u;++s)i.point((h=c[s])[0],h[1]);else n(d.x,d.n.x,1,i);d=d.n}else{if(p){c=d.p.z;for(var s=c.length-1;s>=0;--s)i.point((h=c[s])[0],h[1])}else n(d.x,d.p.x,-1,i);d=d.p}d=d.o,c=d.z,p=!p}while(!d.v);i.lineEnd()}}}function De(t){if(e=t.length){for(var e,r,n=0,i=t[0];++n<e;)i.n=r=t[n],r.p=i,i=r;i.n=r=t[0],r.p=i}}function Pe(t,e,r,n){this.x=t,this.z=e,this.o=r,this.e=n,this.v=!1,this.n=this.p=null}function Oe(t,e,r,n){return function(i,a){function o(e,r){var n=i(e,r);t(e=n[0],r=n[1])&&a.point(e,r)}function s(t,e){var r=i(t,e);v.point(r[0],r[1])}function l(){y.point=s,v.lineStart()}function u(){y.point=o,v.lineEnd()}function c(t,e){m.push([t,e]);var r=i(t,e);x.point(r[0],r[1])}function h(){x.lineStart(),m=[]}function f(){c(m[0][0],m[0][1]),x.lineEnd();var t,e=x.clean(),r=b.buffer(),n=r.length;if(m.pop(),p.push(m),m=null,n)if(1&e){t=r[0];var i,n=t.length-1,o=-1;if(n>0){for(_||(a.polygonStart(),_=!0),a.lineStart();++o<n;)a.point((i=t[o])[0],i[1]);a.lineEnd()}}else n>1&&2&e&&r.push(r.pop().concat(r.shift())),d.push(r.filter(Re))}var d,p,m,v=e(a),g=i.invert(n[0],n[1]),y={point:o,lineStart:l,lineEnd:u,polygonStart:function(){y.point=c,y.lineStart=h,y.lineEnd=f,d=[],p=[]},polygonEnd:function(){y.point=o,y.lineStart=l,y.lineEnd=u,d=uo.merge(d);var t=Ve(g,p);d.length?(_||(a.polygonStart(),_=!0),Ie(d,je,t,r,a)):t&&(_||(a.polygonStart(),_=!0),a.lineStart(),r(null,null,1,a),a.lineEnd()),_&&(a.polygonEnd(),_=!1),d=p=null},sphere:function(){a.polygonStart(),a.lineStart(),r(null,null,1,a),a.lineEnd(),a.polygonEnd()}},b=Fe(),x=e(b),_=!1;return y}}function Re(t){return t.length>1}function Fe(){var t,e=[];return{lineStart:function(){e.push(t=[])},point:function(e,r){t.push([e,r])},lineEnd:M,buffer:function(){var r=e;return e=[],t=null,r},rejoin:function(){e.length>1&&e.push(e.pop().concat(e.shift()))}}}function je(t,e){return((t=t.x)[0]<0?t[1]-Vo-Fo:Vo-t[1])-((e=e.x)[0]<0?e[1]-Vo-Fo:Vo-e[1])}function Ne(t){var e,r=NaN,n=NaN,i=NaN;return{lineStart:function(){t.lineStart(),e=1},point:function(a,o){var s=a>0?No:-No,l=xo(a-r);xo(l-No)<Fo?(t.point(r,n=(n+o)/2>0?Vo:-Vo),t.point(i,n),t.lineEnd(),t.lineStart(),t.point(s,n),t.point(a,n),e=0):i!==s&&l>=No&&(xo(r-i)<Fo&&(r-=i*Fo),xo(a-s)<Fo&&(a-=s*Fo),n=Be(r,n,a,o),t.point(i,n),t.lineEnd(),t.lineStart(),t.point(s,n),e=0),t.point(r=a,n=o),i=s},lineEnd:function(){t.lineEnd(),r=n=NaN},clean:function(){return 2-e}}}function Be(t,e,r,n){var i,a,o=Math.sin(t-r);return xo(o)>Fo?Math.atan((Math.sin(e)*(a=Math.cos(n))*Math.sin(r)-Math.sin(n)*(i=Math.cos(e))*Math.sin(t))/(i*a*o)):(e+n)/2}function Ue(t,e,r,n){var i;if(null==t)i=r*Vo,n.point(-No,i),n.point(0,i),n.point(No,i),n.point(No,0),n.point(No,-i),n.point(0,-i),n.point(-No,-i),n.point(-No,0),n.point(-No,i);else if(xo(t[0]-e[0])>Fo){var a=t[0]<e[0]?No:-No;i=r*a/2,n.point(-a,i),n.point(0,i),n.point(a,i)}else n.point(e[0],e[1])}function Ve(t,e){var r=t[0],n=t[1],i=[Math.sin(r),-Math.cos(r),0],a=0,o=0;Ms.reset();for(var s=0,l=e.length;s<l;++s){var u=e[s],c=u.length;if(c)for(var h=u[0],f=h[0],d=h[1]/2+No/4,p=Math.sin(d),m=Math.cos(d),v=1;;){v===c&&(v=0),t=u[v];var g=t[0],y=t[1]/2+No/4,b=Math.sin(y),x=Math.cos(y),_=g-f,w=_>=0?1:-1,M=w*_,k=M>No,A=p*b;if(Ms.add(Math.atan2(A*w*Math.sin(M),m*x+A*Math.cos(M))),a+=k?_+w*Bo:_,k^f>=r^g>=r){var T=be(ge(h),ge(t));we(T);var S=be(i,T);we(S);var E=(k^_>=0?-1:1)*nt(S[2]);(n>E||n===E&&(T[0]||T[1]))&&(o+=k^_>=0?1:-1)}if(!v++)break;f=g,p=b,m=x,h=t}}return(a<-Fo||a<Fo&&Ms<-Fo)^1&o}function He(t){function e(t,e){return Math.cos(t)*Math.cos(e)>a}function r(t){var r,a,l,u,c;return{lineStart:function(){u=l=!1,c=1},point:function(h,f){var d,p=[h,f],m=e(h,f),v=o?m?0:i(h,f):m?i(h+(h<0?No:-No),f):0;if(!r&&(u=l=m)&&t.lineStart(),m!==l&&(d=n(r,p),(ke(r,d)||ke(p,d))&&(p[0]+=Fo,p[1]+=Fo,m=e(p[0],p[1]))),m!==l)c=0,m?(t.lineStart(),d=n(p,r),t.point(d[0],d[1])):(d=n(r,p),t.point(d[0],d[1]),t.lineEnd()),r=d;else if(s&&r&&o^m){var g;v&a||!(g=n(p,r,!0))||(c=0,o?(t.lineStart(),t.point(g[0][0],g[0][1]),t.point(g[1][0],g[1][1]),t.lineEnd()):(t.point(g[1][0],g[1][1]),t.lineEnd(),t.lineStart(),t.point(g[0][0],g[0][1])))}!m||r&&ke(r,p)||t.point(p[0],p[1]),r=p,l=m,a=v},lineEnd:function(){l&&t.lineEnd(),r=null},clean:function(){return c|(u&&l)<<1}}}function n(t,e,r){var n=ge(t),i=ge(e),o=[1,0,0],s=be(n,i),l=ye(s,s),u=s[0],c=l-u*u;if(!c)return!r&&t;var h=a*l/c,f=-a*u/c,d=be(o,s),p=_e(o,h);xe(p,_e(s,f));var m=d,v=ye(p,m),g=ye(m,m),y=v*v-g*(ye(p,p)-1);if(!(y<0)){var b=Math.sqrt(y),x=_e(m,(-v-b)/g);if(xe(x,p),x=Me(x),!r)return x;var _,w=t[0],M=e[0],k=t[1],A=e[1];M<w&&(_=w,w=M,M=_);var T=M-w,S=xo(T-No)<Fo,E=S||T<Fo;if(!S&&A<k&&(_=k,k=A,A=_),E?S?k+A>0^x[1]<(xo(x[0]-w)<Fo?k:A):k<=x[1]&&x[1]<=A:T>No^(w<=x[0]&&x[0]<=M)){var L=_e(m,(-v+b)/g);return xe(L,p),[x,Me(L)]}}}function i(e,r){var n=o?t:No-t,i=0;return e<-n?i|=1:e>n&&(i|=2),r<-n?i|=4:r>n&&(i|=8),i}var a=Math.cos(t),o=a>0,s=xo(a)>Fo;return Oe(e,r,vr(t,6*Ho),o?[0,-t]:[-No,t-No])}function qe(t,e,r,n){return function(i){var a,o=i.a,s=i.b,l=o.x,u=o.y,c=s.x,h=s.y,f=0,d=1,p=c-l,m=h-u;if(a=t-l,p||!(a>0)){if(a/=p,p<0){if(a<f)return;a<d&&(d=a)}else if(p>0){if(a>d)return;a>f&&(f=a)}if(a=r-l,p||!(a<0)){if(a/=p,p<0){if(a>d)return;a>f&&(f=a)}else if(p>0){if(a<f)return;a<d&&(d=a)}if(a=e-u,m||!(a>0)){if(a/=m,m<0){if(a<f)return;a<d&&(d=a)}else if(m>0){if(a>d)return;a>f&&(f=a)}if(a=n-u,m||!(a<0)){if(a/=m,m<0){if(a>d)return;a>f&&(f=a)}else if(m>0){if(a<f)return;a<d&&(d=a)}return f>0&&(i.a={x:l+f*p,y:u+f*m}),d<1&&(i.b={x:l+d*p,y:u+d*m}),i}}}}}}function Ge(t,e,r,n){function i(n,i){return xo(n[0]-t)<Fo?i>0?0:3:xo(n[0]-r)<Fo?i>0?2:1:xo(n[1]-e)<Fo?i>0?1:0:i>0?3:2}function a(t,e){return o(t.x,e.x)}function o(t,e){var r=i(t,1),n=i(e,1);return r!==n?r-n:0===r?e[1]-t[1]:1===r?t[0]-e[0]:2===r?t[1]-e[1]:e[0]-t[0]}return function(s){function l(t){for(var e=0,r=v.length,n=t[1],i=0;i<r;++i)for(var a,o=1,s=v[i],l=s.length,u=s[0];o<l;++o)a=s[o],u[1]<=n?a[1]>n&&et(u,a,t)>0&&++e:a[1]<=n&&et(u,a,t)<0&&--e,u=a;return 0!==e}function u(a,s,l,u){var c=0,h=0;if(null==a||(c=i(a,l))!==(h=i(s,l))||o(a,s)<0^l>0)do{u.point(0===c||3===c?t:r,c>1?n:e)}while((c=(c+l+4)%4)!==h);else u.point(s[0],s[1])}function c(i,a){return t<=i&&i<=r&&e<=a&&a<=n}function h(t,e){c(t,e)&&s.point(t,e)}function f(){L.point=p,v&&v.push(g=[]),k=!0,M=!1,_=w=NaN}function d(){m&&(p(y,b),x&&M&&S.rejoin(),m.push(S.buffer())),L.point=h,M&&s.lineEnd()}function p(t,e){t=Math.max(-js,Math.min(js,t)),e=Math.max(-js,Math.min(js,e));var r=c(t,e);if(v&&g.push([t,e]),k)y=t,b=e,x=r,k=!1,r&&(s.lineStart(),s.point(t,e));else if(r&&M)s.point(t,e);else{var n={a:{x:_,y:w},b:{x:t,y:e}};E(n)?(M||(s.lineStart(),s.point(n.a.x,n.a.y)),s.point(n.b.x,n.b.y),r||s.lineEnd(),A=!1):r&&(s.lineStart(),s.point(t,e),A=!1)}_=t,w=e,M=r}var m,v,g,y,b,x,_,w,M,k,A,T=s,S=Fe(),E=qe(t,e,r,n),L={point:h,lineStart:f,lineEnd:d,polygonStart:function(){s=S,m=[],v=[],A=!0},polygonEnd:function(){s=T,m=uo.merge(m);var e=l([t,n]),r=A&&e,i=m.length;(r||i)&&(s.polygonStart(),r&&(s.lineStart(),u(null,null,1,s),s.lineEnd()),i&&Ie(m,a,e,u,s),s.polygonEnd()),m=v=g=null}};return L}}function Ye(t){var e=0,r=No/3,n=lr(t),i=n(e,r);return i.parallels=function(t){return arguments.length?n(e=t[0]*No/180,r=t[1]*No/180):[e/No*180,r/No*180]},i}function Xe(t,e){function r(t,e){var r=Math.sqrt(a-2*i*Math.sin(e))/i;return[r*Math.sin(t*=i),o-r*Math.cos(t)]}var n=Math.sin(t),i=(n+Math.sin(e))/2,a=1+n*(2*i-n),o=Math.sqrt(a)/i;return r.invert=function(t,e){var r=o-e;return[Math.atan2(t,r)/i,nt((a-(t*t+r*r)*i*i)/(2*i))]},r}function We(){function t(t,e){Bs+=i*t-n*e,n=t,i=e}var e,r,n,i;Gs.point=function(a,o){Gs.point=t,e=n=a,r=i=o},Gs.lineEnd=function(){t(e,r)}}function Ze(t,e){t<Us&&(Us=t),t>Hs&&(Hs=t),e<Vs&&(Vs=e),e>qs&&(qs=e)}function Je(){function t(t,e){o.push(\"M\",t,\",\",e,a)}function e(t,e){o.push(\"M\",t,\",\",e),s.point=r}function r(t,e){o.push(\"L\",t,\",\",e)}function n(){s.point=t}function i(){o.push(\"Z\")}var a=Ke(4.5),o=[],s={point:t,lineStart:function(){s.point=e},lineEnd:n,polygonStart:function(){s.lineEnd=i},polygonEnd:function(){s.lineEnd=n,s.point=t},pointRadius:function(t){return a=Ke(t),s},result:function(){if(o.length){var t=o.join(\"\");return o=[],t}}};return s}function Ke(t){return\"m0,\"+t+\"a\"+t+\",\"+t+\" 0 1,1 0,\"+-2*t+\"a\"+t+\",\"+t+\" 0 1,1 0,\"+2*t+\"z\"}function Qe(t,e){Ss+=t,Es+=e,++Ls}function $e(){function t(t,n){var i=t-e,a=n-r,o=Math.sqrt(i*i+a*a);Cs+=o*(e+t)/2,zs+=o*(r+n)/2,Is+=o,Qe(e=t,r=n)}var e,r;Xs.point=function(n,i){Xs.point=t,Qe(e=n,r=i)}}function tr(){Xs.point=Qe}function er(){function t(t,e){var r=t-n,a=e-i,o=Math.sqrt(r*r+a*a);Cs+=o*(n+t)/2,zs+=o*(i+e)/2,Is+=o,o=i*t-n*e,Ds+=o*(n+t),Ps+=o*(i+e),Os+=3*o,Qe(n=t,i=e)}var e,r,n,i;Xs.point=function(a,o){Xs.point=t,Qe(e=n=a,r=i=o)},Xs.lineEnd=function(){t(e,r)}}function rr(t){function e(e,r){t.moveTo(e+o,r),t.arc(e,r,o,0,Bo)}function r(e,r){t.moveTo(e,r),s.point=n}function n(e,r){t.lineTo(e,r)}function i(){s.point=e}function a(){t.closePath()}var o=4.5,s={point:e,lineStart:function(){s.point=r},lineEnd:i,polygonStart:function(){s.lineEnd=a},polygonEnd:function(){s.lineEnd=i,s.point=e},pointRadius:function(t){return o=t,s},result:M};return s}function nr(t){function e(t){return(s?n:r)(t)}function r(e){return or(e,function(r,n){r=t(r,n),e.point(r[0],r[1])})}function n(e){function r(r,n){r=t(r,n),e.point(r[0],r[1])}function n(){b=NaN,k.point=a,e.lineStart()}function a(r,n){var a=ge([r,n]),o=t(r,n);i(b,x,y,_,w,M,b=o[0],x=o[1],y=r,_=a[0],w=a[1],M=a[2],s,e),e.point(b,x)}function o(){k.point=r,e.lineEnd()}function l(){n(),k.point=u,k.lineEnd=c}function u(t,e){a(h=t,f=e),d=b,p=x,m=_,v=w,g=M,k.point=a}function c(){i(b,x,y,_,w,M,d,p,h,m,v,g,s,e),k.lineEnd=o,o()}var h,f,d,p,m,v,g,y,b,x,_,w,M,k={point:r,lineStart:n,lineEnd:o,polygonStart:function(){e.polygonStart(),k.lineStart=l},polygonEnd:function(){e.polygonEnd(),k.lineStart=n}};return k}function i(e,r,n,s,l,u,c,h,f,d,p,m,v,g){var y=c-e,b=h-r,x=y*y+b*b;if(x>4*a&&v--){var _=s+d,w=l+p,M=u+m,k=Math.sqrt(_*_+w*w+M*M),A=Math.asin(M/=k),T=xo(xo(M)-1)<Fo||xo(n-f)<Fo?(n+f)/2:Math.atan2(w,_),S=t(T,A),E=S[0],L=S[1],C=E-e,z=L-r,I=b*C-y*z;(I*I/x>a||xo((y*C+b*z)/x-.5)>.3||s*d+l*p+u*m<o)&&(i(e,r,n,s,l,u,E,L,T,_/=k,w/=k,M,v,g),g.point(E,L),i(E,L,T,_,w,M,c,h,f,d,p,m,v,g))}}var a=.5,o=Math.cos(30*Ho),s=16;return e.precision=function(t){return arguments.length?(s=(a=t*t)>0&&16,e):Math.sqrt(a)},e}function ir(t){var e=nr(function(e,r){return t([e*qo,r*qo])});return function(t){return ur(e(t))}}function ar(t){this.stream=t}function or(t,e){return{point:e,sphere:function(){t.sphere()},lineStart:function(){t.lineStart()},lineEnd:function(){t.lineEnd()},polygonStart:function(){t.polygonStart()},polygonEnd:function(){t.polygonEnd()}}}function sr(t){return lr(function(){return t})()}function lr(t){function e(t){return t=s(t[0]*Ho,t[1]*Ho),[t[0]*f+l,u-t[1]*f]}function r(t){return(t=s.invert((t[0]-l)/f,(u-t[1])/f))&&[t[0]*qo,t[1]*qo]}function n(){s=Ce(o=fr(g,y,b),a);var t=a(m,v);return l=d-t[0]*f,u=p+t[1]*f,i()}function i(){return c&&(c.valid=!1,c=null),e}var a,o,s,l,u,c,h=nr(function(t,e){return t=a(t,e),[t[0]*f+l,u-t[1]*f]}),f=150,d=480,p=250,m=0,v=0,g=0,y=0,b=0,_=Fs,w=x,M=null,k=null;return e.stream=function(t){return c&&(c.valid=!1),c=ur(_(o,h(w(t)))),c.valid=!0,c},e.clipAngle=function(t){return arguments.length?(_=null==t?(M=t,Fs):He((M=+t)*Ho),i()):M},e.clipExtent=function(t){return arguments.length?(k=t,w=t?Ge(t[0][0],t[0][1],t[1][0],t[1][1]):x,i()):k},e.scale=function(t){return arguments.length?(f=+t,n()):f},e.translate=function(t){return arguments.length?(d=+t[0],p=+t[1],n()):[d,p]},e.center=function(t){return arguments.length?(m=t[0]%360*Ho,v=t[1]%360*Ho,n()):[m*qo,v*qo]},e.rotate=function(t){return arguments.length?(g=t[0]%360*Ho,y=t[1]%360*Ho,b=t.length>2?t[2]%360*Ho:0,n()):[g*qo,y*qo,b*qo]},uo.rebind(e,h,\"precision\"),function(){return a=t.apply(this,arguments),e.invert=a.invert&&r,n()}}function ur(t){return or(t,function(e,r){t.point(e*Ho,r*Ho)})}function cr(t,e){return[t,e]}function hr(t,e){return[t>No?t-Bo:t<-No?t+Bo:t,e]}function fr(t,e,r){return t?e||r?Ce(pr(t),mr(e,r)):pr(t):e||r?mr(e,r):hr}function dr(t){return function(e,r){return e+=t,[e>No?e-Bo:e<-No?e+Bo:e,r]}}function pr(t){var e=dr(t);return e.invert=dr(-t),e}function mr(t,e){function r(t,e){var r=Math.cos(e),s=Math.cos(t)*r,l=Math.sin(t)*r,u=Math.sin(e),c=u*n+s*i;return[Math.atan2(l*a-c*o,s*n-u*i),nt(c*a+l*o)]}var n=Math.cos(t),i=Math.sin(t),a=Math.cos(e),o=Math.sin(e);return r.invert=function(t,e){var r=Math.cos(e),s=Math.cos(t)*r,l=Math.sin(t)*r,u=Math.sin(e),c=u*a-l*o;return[Math.atan2(l*a+u*o,s*n+c*i),nt(c*n-s*i)]},r}function vr(t,e){var r=Math.cos(t),n=Math.sin(t);return function(i,a,o,s){var l=o*e;null!=i?(i=gr(r,i),a=gr(r,a),(o>0?i<a:i>a)&&(i+=o*Bo)):(i=t+o*Bo,a=t-.5*l);for(var u,c=i;o>0?c>a:c<a;c-=l)s.point((u=Me([r,-n*Math.cos(c),-n*Math.sin(c)]))[0],u[1])}}function gr(t,e){var r=ge(e);r[0]-=t,we(r);var n=rt(-r[1]);return((-r[2]<0?-n:n)+2*Math.PI-Fo)%(2*Math.PI)}function yr(t,e,r){var n=uo.range(t,e-Fo,r).concat(e);return function(t){return n.map(function(e){return[t,e]})}}function br(t,e,r){var n=uo.range(t,e-Fo,r).concat(e);return function(t){return n.map(function(e){return[e,t]})}}function xr(t){return t.source}function _r(t){return t.target}function wr(t,e,r,n){var i=Math.cos(e),a=Math.sin(e),o=Math.cos(n),s=Math.sin(n),l=i*Math.cos(t),u=i*Math.sin(t),c=o*Math.cos(r),h=o*Math.sin(r),f=2*Math.asin(Math.sqrt(st(n-e)+i*o*st(r-t))),d=1/Math.sin(f),p=f?function(t){var e=Math.sin(t*=f)*d,r=Math.sin(f-t)*d,n=r*l+e*c,i=r*u+e*h,o=r*a+e*s;return[Math.atan2(i,n)*qo,Math.atan2(o,Math.sqrt(n*n+i*i))*qo]}:function(){return[t*qo,e*qo]};return p.distance=f,p}function Mr(){function t(t,i){var a=Math.sin(i*=Ho),o=Math.cos(i),s=xo((t*=Ho)-e),l=Math.cos(s);Ws+=Math.atan2(Math.sqrt((s=o*Math.sin(s))*s+(s=n*a-r*o*l)*s),r*a+n*o*l),e=t,r=a,n=o}var e,r,n;Zs.point=function(i,a){e=i*Ho,r=Math.sin(a*=Ho),n=Math.cos(a),Zs.point=t},Zs.lineEnd=function(){Zs.point=Zs.lineEnd=M}}function kr(t,e){function r(e,r){var n=Math.cos(e),i=Math.cos(r),a=t(n*i);return[a*i*Math.sin(e),a*Math.sin(r)]}return r.invert=function(t,r){var n=Math.sqrt(t*t+r*r),i=e(n),a=Math.sin(i),o=Math.cos(i);return[Math.atan2(t*a,n*o),Math.asin(n&&r*a/n)]},r}function Ar(t,e){function r(t,e){o>0?e<-Vo+Fo&&(e=-Vo+Fo):e>Vo-Fo&&(e=Vo-Fo);var r=o/Math.pow(i(e),a);return[r*Math.sin(a*t),o-r*Math.cos(a*t)]}var n=Math.cos(t),i=function(t){return Math.tan(No/4+t/2)},a=t===e?Math.sin(t):Math.log(n/Math.cos(e))/Math.log(i(e)/i(t)),o=n*Math.pow(i(t),a)/a;return a?(r.invert=function(t,e){var r=o-e,n=tt(a)*Math.sqrt(t*t+r*r);return[Math.atan2(t,r)/a,2*Math.atan(Math.pow(o/n,1/a))-Vo]},r):Sr}function Tr(t,e){function r(t,e){var r=a-e;return[r*Math.sin(i*t),a-r*Math.cos(i*t)]}var n=Math.cos(t),i=t===e?Math.sin(t):(n-Math.cos(e))/(e-t),a=n/i+t;return xo(i)<Fo?cr:(r.invert=function(t,e){var r=a-e;return[Math.atan2(t,r)/i,a-tt(i)*Math.sqrt(t*t+r*r)]},r)}function Sr(t,e){return[t,Math.log(Math.tan(No/4+e/2))]}function Er(t){var e,r=sr(t),n=r.scale,i=r.translate,a=r.clipExtent;return r.scale=function(){var t=n.apply(r,arguments);return t===r?e?r.clipExtent(null):r:t},r.translate=function(){var t=i.apply(r,arguments);return t===r?e?r.clipExtent(null):r:t},r.clipExtent=function(t){var o=a.apply(r,arguments);if(o===r){if(e=null==t){var s=No*n(),l=i();a([[l[0]-s,l[1]-s],[l[0]+s,l[1]+s]])}}else e&&(o=null);return o},r.clipExtent(null)}function Lr(t,e){return[Math.log(Math.tan(No/4+e/2)),-t]}function Cr(t){return t[0]}function zr(t){return t[1]}function Ir(t){for(var e=t.length,r=[0,1],n=2,i=2;i<e;i++){for(;n>1&&et(t[r[n-2]],t[r[n-1]],t[i])<=0;)--n;r[n++]=i}return r.slice(0,n)}function Dr(t,e){return t[0]-e[0]||t[1]-e[1]}function Pr(t,e,r){return(r[0]-e[0])*(t[1]-e[1])<(r[1]-e[1])*(t[0]-e[0])}function Or(t,e,r,n){var i=t[0],a=r[0],o=e[0]-i,s=n[0]-a,l=t[1],u=r[1],c=e[1]-l,h=n[1]-u,f=(s*(l-u)-h*(i-a))/(h*o-s*c);return[i+f*o,l+f*c]}function Rr(t){var e=t[0],r=t[t.length-1];return!(e[0]-r[0]||e[1]-r[1])}function Fr(){an(this),this.edge=this.site=this.circle=null}function jr(t){var e=sl.pop()||new Fr;return e.site=t,e}function Nr(t){Zr(t),il.remove(t),sl.push(t),an(t)}function Br(t){var e=t.circle,r=e.x,n=e.cy,i={x:r,y:n},a=t.P,o=t.N,s=[t];Nr(t);for(var l=a;l.circle&&xo(r-l.circle.x)<Fo&&xo(n-l.circle.cy)<Fo;)a=l.P,s.unshift(l),Nr(l),l=a;s.unshift(l),Zr(l);for(var u=o;u.circle&&xo(r-u.circle.x)<Fo&&xo(n-u.circle.cy)<Fo;)o=u.N,s.push(u),Nr(u),u=o;s.push(u),Zr(u);var c,h=s.length;for(c=1;c<h;++c)u=s[c],l=s[c-1],en(u.edge,l.site,u.site,i);l=s[0],u=s[h-1],u.edge=$r(l.site,u.site,null,i),Wr(l),Wr(u)}function Ur(t){for(var e,r,n,i,a=t.x,o=t.y,s=il._;s;)if((n=Vr(s,o)-a)>Fo)s=s.L;else{if(!((i=a-Hr(s,o))>Fo)){n>-Fo?(e=s.P,r=s):i>-Fo?(e=s,r=s.N):e=r=s;break}if(!s.R){e=s;break}s=s.R}var l=jr(t);if(il.insert(e,l),e||r){if(e===r)return Zr(e),r=jr(e.site),il.insert(l,r),l.edge=r.edge=$r(e.site,l.site),Wr(e),void Wr(r);if(!r)return void(l.edge=$r(e.site,l.site));Zr(e),Zr(r);var u=e.site,c=u.x,h=u.y,f=t.x-c,d=t.y-h,p=r.site,m=p.x-c,v=p.y-h,g=2*(f*v-d*m),y=f*f+d*d,b=m*m+v*v,x={x:(v*y-d*b)/g+c,y:(f*b-m*y)/g+h};en(r.edge,u,p,x),l.edge=$r(u,t,null,x),r.edge=$r(t,p,null,x),Wr(e),Wr(r)}}function Vr(t,e){var r=t.site,n=r.x,i=r.y,a=i-e;if(!a)return n;var o=t.P;if(!o)return-1/0;r=o.site;var s=r.x,l=r.y,u=l-e;if(!u)return s;var c=s-n,h=1/a-1/u,f=c/u;return h?(-f+Math.sqrt(f*f-2*h*(c*c/(-2*u)-l+u/2+i-a/2)))/h+n:(n+s)/2}function Hr(t,e){var r=t.N;if(r)return Vr(r,e);var n=t.site;return n.y===e?n.x:1/0}function qr(t){this.site=t,this.edges=[]}function Gr(t){for(var e,r,n,i,a,o,s,l,u,c,h=t[0][0],f=t[1][0],d=t[0][1],p=t[1][1],m=nl,v=m.length;v--;)if((a=m[v])&&a.prepare())for(s=a.edges,l=s.length,o=0;o<l;)c=s[o].end(),n=c.x,i=c.y,u=s[++o%l].start(),e=u.x,r=u.y,(xo(n-e)>Fo||xo(i-r)>Fo)&&(s.splice(o,0,new rn(tn(a.site,c,xo(n-h)<Fo&&p-i>Fo?{x:h,y:xo(e-h)<Fo?r:p}:xo(i-p)<Fo&&f-n>Fo?{x:xo(r-p)<Fo?e:f,y:p}:xo(n-f)<Fo&&i-d>Fo?{x:f,y:xo(e-f)<Fo?r:d}:xo(i-d)<Fo&&n-h>Fo?{x:xo(r-d)<Fo?e:h,y:d}:null),a.site,null)),++l)}function Yr(t,e){return e.angle-t.angle}function Xr(){an(this),this.x=this.y=this.arc=this.site=this.cy=null}function Wr(t){var e=t.P,r=t.N;if(e&&r){var n=e.site,i=t.site,a=r.site;if(n!==a){var o=i.x,s=i.y,l=n.x-o,u=n.y-s,c=a.x-o,h=a.y-s,f=2*(l*h-u*c);if(!(f>=-jo)){var d=l*l+u*u,p=c*c+h*h,m=(h*d-u*p)/f,v=(l*p-c*d)/f,h=v+s,g=ll.pop()||new Xr;g.arc=t,g.site=i,g.x=m+o,g.y=h+Math.sqrt(m*m+v*v),g.cy=h,t.circle=g;for(var y=null,b=ol._;b;)if(g.y<b.y||g.y===b.y&&g.x<=b.x){if(!b.L){y=b.P;break}b=b.L}else{if(!b.R){y=b;break}b=b.R}ol.insert(y,g),y||(al=g)}}}}function Zr(t){var e=t.circle;e&&(e.P||(al=e.N),ol.remove(e),ll.push(e),an(e),t.circle=null)}function Jr(t){for(var e,r=rl,n=qe(t[0][0],t[0][1],t[1][0],t[1][1]),i=r.length;i--;)e=r[i],(!Kr(e,t)||!n(e)||xo(e.a.x-e.b.x)<Fo&&xo(e.a.y-e.b.y)<Fo)&&(e.a=e.b=null,r.splice(i,1))}function Kr(t,e){var r=t.b;if(r)return!0;var n,i,a=t.a,o=e[0][0],s=e[1][0],l=e[0][1],u=e[1][1],c=t.l,h=t.r,f=c.x,d=c.y,p=h.x,m=h.y,v=(f+p)/2,g=(d+m)/2;if(m===d){if(v<o||v>=s)return;if(f>p){if(a){if(a.y>=u)return}else a={x:v,y:l};r={x:v,y:u}}else{if(a){if(a.y<l)return}else a={x:v,y:u};r={x:v,y:l}}}else if(n=(f-p)/(m-d),i=g-n*v,n<-1||n>1)if(f>p){if(a){if(a.y>=u)return}else a={x:(l-i)/n,y:l};r={x:(u-i)/n,y:u}}else{if(a){if(a.y<l)return}else a={x:(u-i)/n,y:u};r={x:(l-i)/n,y:l}}else if(d<m){if(a){if(a.x>=s)return}else a={x:o,y:n*o+i};r={x:s,y:n*s+i}}else{if(a){if(a.x<o)return}else a={x:s,y:n*s+i};r={\n",
       "x:o,y:n*o+i}}return t.a=a,t.b=r,!0}function Qr(t,e){this.l=t,this.r=e,this.a=this.b=null}function $r(t,e,r,n){var i=new Qr(t,e);return rl.push(i),r&&en(i,t,e,r),n&&en(i,e,t,n),nl[t.i].edges.push(new rn(i,t,e)),nl[e.i].edges.push(new rn(i,e,t)),i}function tn(t,e,r){var n=new Qr(t,null);return n.a=e,n.b=r,rl.push(n),n}function en(t,e,r,n){t.a||t.b?t.l===r?t.b=n:t.a=n:(t.a=n,t.l=e,t.r=r)}function rn(t,e,r){var n=t.a,i=t.b;this.edge=t,this.site=e,this.angle=r?Math.atan2(r.y-e.y,r.x-e.x):t.l===e?Math.atan2(i.x-n.x,n.y-i.y):Math.atan2(n.x-i.x,i.y-n.y)}function nn(){this._=null}function an(t){t.U=t.C=t.L=t.R=t.P=t.N=null}function on(t,e){var r=e,n=e.R,i=r.U;i?i.L===r?i.L=n:i.R=n:t._=n,n.U=i,r.U=n,r.R=n.L,r.R&&(r.R.U=r),n.L=r}function sn(t,e){var r=e,n=e.L,i=r.U;i?i.L===r?i.L=n:i.R=n:t._=n,n.U=i,r.U=n,r.L=n.R,r.L&&(r.L.U=r),n.R=r}function ln(t){for(;t.L;)t=t.L;return t}function un(t,e){var r,n,i,a=t.sort(cn).pop();for(rl=[],nl=new Array(t.length),il=new nn,ol=new nn;;)if(i=al,a&&(!i||a.y<i.y||a.y===i.y&&a.x<i.x))a.x===r&&a.y===n||(nl[a.i]=new qr(a),Ur(a),r=a.x,n=a.y),a=t.pop();else{if(!i)break;Br(i.arc)}e&&(Jr(e),Gr(e));var o={cells:nl,edges:rl};return il=ol=rl=nl=null,o}function cn(t,e){return e.y-t.y||e.x-t.x}function hn(t,e,r){return(t.x-r.x)*(e.y-t.y)-(t.x-e.x)*(r.y-t.y)}function fn(t){return t.x}function dn(t){return t.y}function pn(){return{leaf:!0,nodes:[],point:null,x:null,y:null}}function mn(t,e,r,n,i,a){if(!t(e,r,n,i,a)){var o=.5*(r+i),s=.5*(n+a),l=e.nodes;l[0]&&mn(t,l[0],r,n,o,s),l[1]&&mn(t,l[1],o,n,i,s),l[2]&&mn(t,l[2],r,s,o,a),l[3]&&mn(t,l[3],o,s,i,a)}}function vn(t,e,r,n,i,a,o){var s,l=1/0;return function t(u,c,h,f,d){if(!(c>a||h>o||f<n||d<i)){if(p=u.point){var p,m=e-u.x,v=r-u.y,g=m*m+v*v;if(g<l){var y=Math.sqrt(l=g);n=e-y,i=r-y,a=e+y,o=r+y,s=p}}for(var b=u.nodes,x=.5*(c+f),_=.5*(h+d),w=e>=x,M=r>=_,k=M<<1|w,A=k+4;k<A;++k)if(u=b[3&k])switch(3&k){case 0:t(u,c,h,x,_);break;case 1:t(u,x,h,f,_);break;case 2:t(u,c,_,x,d);break;case 3:t(u,x,_,f,d)}}}(t,n,i,a,o),s}function gn(t,e){t=uo.rgb(t),e=uo.rgb(e);var r=t.r,n=t.g,i=t.b,a=e.r-r,o=e.g-n,s=e.b-i;return function(t){return\"#\"+wt(Math.round(r+a*t))+wt(Math.round(n+o*t))+wt(Math.round(i+s*t))}}function yn(t,e){var r,n={},i={};for(r in t)r in e?n[r]=_n(t[r],e[r]):i[r]=t[r];for(r in e)r in t||(i[r]=e[r]);return function(t){for(r in n)i[r]=n[r](t);return i}}function bn(t,e){return t=+t,e=+e,function(r){return t*(1-r)+e*r}}function xn(t,e){var r,n,i,a=cl.lastIndex=hl.lastIndex=0,o=-1,s=[],l=[];for(t+=\"\",e+=\"\";(r=cl.exec(t))&&(n=hl.exec(e));)(i=n.index)>a&&(i=e.slice(a,i),s[o]?s[o]+=i:s[++o]=i),(r=r[0])===(n=n[0])?s[o]?s[o]+=n:s[++o]=n:(s[++o]=null,l.push({i:o,x:bn(r,n)})),a=hl.lastIndex;return a<e.length&&(i=e.slice(a),s[o]?s[o]+=i:s[++o]=i),s.length<2?l[0]?(e=l[0].x,function(t){return e(t)+\"\"}):function(){return e}:(e=l.length,function(t){for(var r,n=0;n<e;++n)s[(r=l[n]).i]=r.x(t);return s.join(\"\")})}function _n(t,e){for(var r,n=uo.interpolators.length;--n>=0&&!(r=uo.interpolators[n](t,e)););return r}function wn(t,e){var r,n=[],i=[],a=t.length,o=e.length,s=Math.min(t.length,e.length);for(r=0;r<s;++r)n.push(_n(t[r],e[r]));for(;r<a;++r)i[r]=t[r];for(;r<o;++r)i[r]=e[r];return function(t){for(r=0;r<s;++r)i[r]=n[r](t);return i}}function Mn(t){return function(e){return e<=0?0:e>=1?1:t(e)}}function kn(t){return function(e){return 1-t(1-e)}}function An(t){return function(e){return.5*(e<.5?t(2*e):2-t(2-2*e))}}function Tn(t){return t*t}function Sn(t){return t*t*t}function En(t){if(t<=0)return 0;if(t>=1)return 1;var e=t*t,r=e*t;return 4*(t<.5?r:3*(t-e)+r-.75)}function Ln(t){return function(e){return Math.pow(e,t)}}function Cn(t){return 1-Math.cos(t*Vo)}function zn(t){return Math.pow(2,10*(t-1))}function In(t){return 1-Math.sqrt(1-t*t)}function Dn(t,e){var r;return arguments.length<2&&(e=.45),arguments.length?r=e/Bo*Math.asin(1/t):(t=1,r=e/4),function(n){return 1+t*Math.pow(2,-10*n)*Math.sin((n-r)*Bo/e)}}function Pn(t){return t||(t=1.70158),function(e){return e*e*((t+1)*e-t)}}function On(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375}function Rn(t,e){t=uo.hcl(t),e=uo.hcl(e);var r=t.h,n=t.c,i=t.l,a=e.h-r,o=e.c-n,s=e.l-i;return isNaN(o)&&(o=0,n=isNaN(n)?e.c:n),isNaN(a)?(a=0,r=isNaN(r)?e.h:r):a>180?a-=360:a<-180&&(a+=360),function(t){return ft(r+a*t,n+o*t,i+s*t)+\"\"}}function Fn(t,e){t=uo.hsl(t),e=uo.hsl(e);var r=t.h,n=t.s,i=t.l,a=e.h-r,o=e.s-n,s=e.l-i;return isNaN(o)&&(o=0,n=isNaN(n)?e.s:n),isNaN(a)?(a=0,r=isNaN(r)?e.h:r):a>180?a-=360:a<-180&&(a+=360),function(t){return ct(r+a*t,n+o*t,i+s*t)+\"\"}}function jn(t,e){t=uo.lab(t),e=uo.lab(e);var r=t.l,n=t.a,i=t.b,a=e.l-r,o=e.a-n,s=e.b-i;return function(t){return pt(r+a*t,n+o*t,i+s*t)+\"\"}}function Nn(t,e){return e-=t,function(r){return Math.round(t+e*r)}}function Bn(t){var e=[t.a,t.b],r=[t.c,t.d],n=Vn(e),i=Un(e,r),a=Vn(Hn(r,e,-i))||0;e[0]*r[1]<r[0]*e[1]&&(e[0]*=-1,e[1]*=-1,n*=-1,i*=-1),this.rotate=(n?Math.atan2(e[1],e[0]):Math.atan2(-r[0],r[1]))*qo,this.translate=[t.e,t.f],this.scale=[n,a],this.skew=a?Math.atan2(i,a)*qo:0}function Un(t,e){return t[0]*e[0]+t[1]*e[1]}function Vn(t){var e=Math.sqrt(Un(t,t));return e&&(t[0]/=e,t[1]/=e),e}function Hn(t,e,r){return t[0]+=r*e[0],t[1]+=r*e[1],t}function qn(t){return t.length?t.pop()+\",\":\"\"}function Gn(t,e,r,n){if(t[0]!==e[0]||t[1]!==e[1]){var i=r.push(\"translate(\",null,\",\",null,\")\");n.push({i:i-4,x:bn(t[0],e[0])},{i:i-2,x:bn(t[1],e[1])})}else(e[0]||e[1])&&r.push(\"translate(\"+e+\")\")}function Yn(t,e,r,n){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),n.push({i:r.push(qn(r)+\"rotate(\",null,\")\")-2,x:bn(t,e)})):e&&r.push(qn(r)+\"rotate(\"+e+\")\")}function Xn(t,e,r,n){t!==e?n.push({i:r.push(qn(r)+\"skewX(\",null,\")\")-2,x:bn(t,e)}):e&&r.push(qn(r)+\"skewX(\"+e+\")\")}function Wn(t,e,r,n){if(t[0]!==e[0]||t[1]!==e[1]){var i=r.push(qn(r)+\"scale(\",null,\",\",null,\")\");n.push({i:i-4,x:bn(t[0],e[0])},{i:i-2,x:bn(t[1],e[1])})}else 1===e[0]&&1===e[1]||r.push(qn(r)+\"scale(\"+e+\")\")}function Zn(t,e){var r=[],n=[];return t=uo.transform(t),e=uo.transform(e),Gn(t.translate,e.translate,r,n),Yn(t.rotate,e.rotate,r,n),Xn(t.skew,e.skew,r,n),Wn(t.scale,e.scale,r,n),t=e=null,function(t){for(var e,i=-1,a=n.length;++i<a;)r[(e=n[i]).i]=e.x(t);return r.join(\"\")}}function Jn(t,e){return e=(e-=t=+t)||1/e,function(r){return(r-t)/e}}function Kn(t,e){return e=(e-=t=+t)||1/e,function(r){return Math.max(0,Math.min(1,(r-t)/e))}}function Qn(t){for(var e=t.source,r=t.target,n=ti(e,r),i=[e];e!==n;)e=e.parent,i.push(e);for(var a=i.length;r!==n;)i.splice(a,0,r),r=r.parent;return i}function $n(t){for(var e=[],r=t.parent;null!=r;)e.push(t),t=r,r=r.parent;return e.push(t),e}function ti(t,e){if(t===e)return t;for(var r=$n(t),n=$n(e),i=r.pop(),a=n.pop(),o=null;i===a;)o=i,i=r.pop(),a=n.pop();return o}function ei(t){t.fixed|=2}function ri(t){t.fixed&=-7}function ni(t){t.fixed|=4,t.px=t.x,t.py=t.y}function ii(t){t.fixed&=-5}function ai(t,e,r){var n=0,i=0;if(t.charge=0,!t.leaf)for(var a,o=t.nodes,s=o.length,l=-1;++l<s;)null!=(a=o[l])&&(ai(a,e,r),t.charge+=a.charge,n+=a.charge*a.cx,i+=a.charge*a.cy);if(t.point){t.leaf||(t.point.x+=Math.random()-.5,t.point.y+=Math.random()-.5);var u=e*r[t.point.index];t.charge+=t.pointCharge=u,n+=u*t.point.x,i+=u*t.point.y}t.cx=n/t.charge,t.cy=i/t.charge}function oi(t,e){return uo.rebind(t,e,\"sort\",\"children\",\"value\"),t.nodes=t,t.links=fi,t}function si(t,e){for(var r=[t];null!=(t=r.pop());)if(e(t),(i=t.children)&&(n=i.length))for(var n,i;--n>=0;)r.push(i[n])}function li(t,e){for(var r=[t],n=[];null!=(t=r.pop());)if(n.push(t),(a=t.children)&&(i=a.length))for(var i,a,o=-1;++o<i;)r.push(a[o]);for(;null!=(t=n.pop());)e(t)}function ui(t){return t.children}function ci(t){return t.value}function hi(t,e){return e.value-t.value}function fi(t){return uo.merge(t.map(function(t){return(t.children||[]).map(function(e){return{source:t,target:e}})}))}function di(t){return t.x}function pi(t){return t.y}function mi(t,e,r){t.y0=e,t.y=r}function vi(t){return uo.range(t.length)}function gi(t){for(var e=-1,r=t[0].length,n=[];++e<r;)n[e]=0;return n}function yi(t){for(var e,r=1,n=0,i=t[0][1],a=t.length;r<a;++r)(e=t[r][1])>i&&(n=r,i=e);return n}function bi(t){return t.reduce(xi,0)}function xi(t,e){return t+e[1]}function _i(t,e){return wi(t,Math.ceil(Math.log(e.length)/Math.LN2+1))}function wi(t,e){for(var r=-1,n=+t[0],i=(t[1]-n)/e,a=[];++r<=e;)a[r]=i*r+n;return a}function Mi(t){return[uo.min(t),uo.max(t)]}function ki(t,e){return t.value-e.value}function Ai(t,e){var r=t._pack_next;t._pack_next=e,e._pack_prev=t,e._pack_next=r,r._pack_prev=e}function Ti(t,e){t._pack_next=e,e._pack_prev=t}function Si(t,e){var r=e.x-t.x,n=e.y-t.y,i=t.r+e.r;return.999*i*i>r*r+n*n}function Ei(t){function e(t){c=Math.min(t.x-t.r,c),h=Math.max(t.x+t.r,h),f=Math.min(t.y-t.r,f),d=Math.max(t.y+t.r,d)}if((r=t.children)&&(u=r.length)){var r,n,i,a,o,s,l,u,c=1/0,h=-1/0,f=1/0,d=-1/0;if(r.forEach(Li),n=r[0],n.x=-n.r,n.y=0,e(n),u>1&&(i=r[1],i.x=i.r,i.y=0,e(i),u>2))for(a=r[2],Ii(n,i,a),e(a),Ai(n,a),n._pack_prev=a,Ai(a,i),i=n._pack_next,o=3;o<u;o++){Ii(n,i,a=r[o]);var p=0,m=1,v=1;for(s=i._pack_next;s!==i;s=s._pack_next,m++)if(Si(s,a)){p=1;break}if(1==p)for(l=n._pack_prev;l!==s._pack_prev&&!Si(l,a);l=l._pack_prev,v++);p?(m<v||m==v&&i.r<n.r?Ti(n,i=s):Ti(n=l,i),o--):(Ai(n,a),i=a,e(a))}var g=(c+h)/2,y=(f+d)/2,b=0;for(o=0;o<u;o++)a=r[o],a.x-=g,a.y-=y,b=Math.max(b,a.r+Math.sqrt(a.x*a.x+a.y*a.y));t.r=b,r.forEach(Ci)}}function Li(t){t._pack_next=t._pack_prev=t}function Ci(t){delete t._pack_next,delete t._pack_prev}function zi(t,e,r,n){var i=t.children;if(t.x=e+=n*t.x,t.y=r+=n*t.y,t.r*=n,i)for(var a=-1,o=i.length;++a<o;)zi(i[a],e,r,n)}function Ii(t,e,r){var n=t.r+r.r,i=e.x-t.x,a=e.y-t.y;if(n&&(i||a)){var o=e.r+r.r,s=i*i+a*a;o*=o,n*=n;var l=.5+(n-o)/(2*s),u=Math.sqrt(Math.max(0,2*o*(n+s)-(n-=s)*n-o*o))/(2*s);r.x=t.x+l*i+u*a,r.y=t.y+l*a-u*i}else r.x=t.x+n,r.y=t.y}function Di(t,e){return t.parent==e.parent?1:2}function Pi(t){var e=t.children;return e.length?e[0]:t.t}function Oi(t){var e,r=t.children;return(e=r.length)?r[e-1]:t.t}function Ri(t,e,r){var n=r/(e.i-t.i);e.c-=n,e.s+=r,t.c+=n,e.z+=r,e.m+=r}function Fi(t){for(var e,r=0,n=0,i=t.children,a=i.length;--a>=0;)e=i[a],e.z+=r,e.m+=r,r+=e.s+(n+=e.c)}function ji(t,e,r){return t.a.parent===e.parent?t.a:r}function Ni(t){return 1+uo.max(t,function(t){return t.y})}function Bi(t){return t.reduce(function(t,e){return t+e.x},0)/t.length}function Ui(t){var e=t.children;return e&&e.length?Ui(e[0]):t}function Vi(t){var e,r=t.children;return r&&(e=r.length)?Vi(r[e-1]):t}function Hi(t){return{x:t.x,y:t.y,dx:t.dx,dy:t.dy}}function qi(t,e){var r=t.x+e[3],n=t.y+e[0],i=t.dx-e[1]-e[3],a=t.dy-e[0]-e[2];return i<0&&(r+=i/2,i=0),a<0&&(n+=a/2,a=0),{x:r,y:n,dx:i,dy:a}}function Gi(t){var e=t[0],r=t[t.length-1];return e<r?[e,r]:[r,e]}function Yi(t){return t.rangeExtent?t.rangeExtent():Gi(t.range())}function Xi(t,e,r,n){var i=r(t[0],t[1]),a=n(e[0],e[1]);return function(t){return a(i(t))}}function Wi(t,e){var r,n=0,i=t.length-1,a=t[n],o=t[i];return o<a&&(r=n,n=i,i=r,r=a,a=o,o=r),t[n]=e.floor(a),t[i]=e.ceil(o),t}function Zi(t){return t?{floor:function(e){return Math.floor(e/t)*t},ceil:function(e){return Math.ceil(e/t)*t}}:wl}function Ji(t,e,r,n){var i=[],a=[],o=0,s=Math.min(t.length,e.length)-1;for(t[s]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++o<=s;)i.push(r(t[o-1],t[o])),a.push(n(e[o-1],e[o]));return function(e){var r=uo.bisect(t,e,1,s)-1;return a[r](i[r](e))}}function Ki(t,e,r,n){function i(){var i=Math.min(t.length,e.length)>2?Ji:Xi,l=n?Kn:Jn;return o=i(t,e,l,r),s=i(e,t,l,_n),a}function a(t){return o(t)}var o,s;return a.invert=function(t){return s(t)},a.domain=function(e){return arguments.length?(t=e.map(Number),i()):t},a.range=function(t){return arguments.length?(e=t,i()):e},a.rangeRound=function(t){return a.range(t).interpolate(Nn)},a.clamp=function(t){return arguments.length?(n=t,i()):n},a.interpolate=function(t){return arguments.length?(r=t,i()):r},a.ticks=function(e){return ea(t,e)},a.tickFormat=function(e,r){return ra(t,e,r)},a.nice=function(e){return $i(t,e),i()},a.copy=function(){return Ki(t,e,r,n)},i()}function Qi(t,e){return uo.rebind(t,e,\"range\",\"rangeRound\",\"interpolate\",\"clamp\")}function $i(t,e){return Wi(t,Zi(ta(t,e)[2])),Wi(t,Zi(ta(t,e)[2])),t}function ta(t,e){null==e&&(e=10);var r=Gi(t),n=r[1]-r[0],i=Math.pow(10,Math.floor(Math.log(n/e)/Math.LN10)),a=e/n*i;return a<=.15?i*=10:a<=.35?i*=5:a<=.75&&(i*=2),r[0]=Math.ceil(r[0]/i)*i,r[1]=Math.floor(r[1]/i)*i+.5*i,r[2]=i,r}function ea(t,e){return uo.range.apply(uo,ta(t,e))}function ra(t,e,r){var n=ta(t,e);if(r){var i=cs.exec(r);if(i.shift(),\"s\"===i[8]){var a=uo.formatPrefix(Math.max(xo(n[0]),xo(n[1])));return i[7]||(i[7]=\".\"+na(a.scale(n[2]))),i[8]=\"f\",r=uo.format(i.join(\"\")),function(t){return r(a.scale(t))+a.symbol}}i[7]||(i[7]=\".\"+ia(i[8],n)),r=i.join(\"\")}else r=\",.\"+na(n[2])+\"f\";return uo.format(r)}function na(t){return-Math.floor(Math.log(t)/Math.LN10+.01)}function ia(t,e){var r=na(e[2]);return t in Ml?Math.abs(r-na(Math.max(xo(e[0]),xo(e[1]))))+ +(\"e\"!==t):r-2*(\"%\"===t)}function aa(t,e,r,n){function i(t){return(r?Math.log(t<0?0:t):-Math.log(t>0?0:-t))/Math.log(e)}function a(t){return r?Math.pow(e,t):-Math.pow(e,-t)}function o(e){return t(i(e))}return o.invert=function(e){return a(t.invert(e))},o.domain=function(e){return arguments.length?(r=e[0]>=0,t.domain((n=e.map(Number)).map(i)),o):n},o.base=function(r){return arguments.length?(e=+r,t.domain(n.map(i)),o):e},o.nice=function(){var e=Wi(n.map(i),r?Math:Al);return t.domain(e),n=e.map(a),o},o.ticks=function(){var t=Gi(n),o=[],s=t[0],l=t[1],u=Math.floor(i(s)),c=Math.ceil(i(l)),h=e%1?2:e;if(isFinite(c-u)){if(r){for(;u<c;u++)for(var f=1;f<h;f++)o.push(a(u)*f);o.push(a(u))}else for(o.push(a(u));u++<c;)for(var f=h-1;f>0;f--)o.push(a(u)*f);for(u=0;o[u]<s;u++);for(c=o.length;o[c-1]>l;c--);o=o.slice(u,c)}return o},o.tickFormat=function(t,r){if(!arguments.length)return kl;arguments.length<2?r=kl:\"function\"!=typeof r&&(r=uo.format(r));var n=Math.max(1,e*t/o.ticks().length);return function(t){var o=t/a(Math.round(i(t)));return o*e<e-.5&&(o*=e),o<=n?r(t):\"\"}},o.copy=function(){return aa(t.copy(),e,r,n)},Qi(o,t)}function oa(t,e,r){function n(e){return t(i(e))}var i=sa(e),a=sa(1/e);return n.invert=function(e){return a(t.invert(e))},n.domain=function(e){return arguments.length?(t.domain((r=e.map(Number)).map(i)),n):r},n.ticks=function(t){return ea(r,t)},n.tickFormat=function(t,e){return ra(r,t,e)},n.nice=function(t){return n.domain($i(r,t))},n.exponent=function(o){return arguments.length?(i=sa(e=o),a=sa(1/e),t.domain(r.map(i)),n):e},n.copy=function(){return oa(t.copy(),e,r)},Qi(n,t)}function sa(t){return function(e){return e<0?-Math.pow(-e,t):Math.pow(e,t)}}function la(t,e){function r(r){return a[((i.get(r)||(\"range\"===e.t?i.set(r,t.push(r)):NaN))-1)%a.length]}function n(e,r){return uo.range(t.length).map(function(t){return e+r*t})}var i,a,o;return r.domain=function(n){if(!arguments.length)return t;t=[],i=new h;for(var a,o=-1,s=n.length;++o<s;)i.has(a=n[o])||i.set(a,t.push(a));return r[e.t].apply(r,e.a)},r.range=function(t){return arguments.length?(a=t,o=0,e={t:\"range\",a:arguments},r):a},r.rangePoints=function(i,s){arguments.length<2&&(s=0);var l=i[0],u=i[1],c=t.length<2?(l=(l+u)/2,0):(u-l)/(t.length-1+s);return a=n(l+c*s/2,c),o=0,e={t:\"rangePoints\",a:arguments},r},r.rangeRoundPoints=function(i,s){arguments.length<2&&(s=0);var l=i[0],u=i[1],c=t.length<2?(l=u=Math.round((l+u)/2),0):(u-l)/(t.length-1+s)|0;return a=n(l+Math.round(c*s/2+(u-l-(t.length-1+s)*c)/2),c),o=0,e={t:\"rangeRoundPoints\",a:arguments},r},r.rangeBands=function(i,s,l){arguments.length<2&&(s=0),arguments.length<3&&(l=s);var u=i[1]<i[0],c=i[u-0],h=i[1-u],f=(h-c)/(t.length-s+2*l);return a=n(c+f*l,f),u&&a.reverse(),o=f*(1-s),e={t:\"rangeBands\",a:arguments},r},r.rangeRoundBands=function(i,s,l){arguments.length<2&&(s=0),arguments.length<3&&(l=s);var u=i[1]<i[0],c=i[u-0],h=i[1-u],f=Math.floor((h-c)/(t.length-s+2*l));return a=n(c+Math.round((h-c-(t.length-s)*f)/2),f),u&&a.reverse(),o=Math.round(f*(1-s)),e={t:\"rangeRoundBands\",a:arguments},r},r.rangeBand=function(){return o},r.rangeExtent=function(){return Gi(e.a[0])},r.copy=function(){return la(t,e)},r.domain(t)}function ua(t,e){function r(){var r=0,i=e.length;for(s=[];++r<i;)s[r-1]=uo.quantile(t,r/i);return n}function n(t){if(!isNaN(t=+t))return e[uo.bisect(s,t)]}var s;return n.domain=function(e){return arguments.length?(t=e.map(a).filter(o).sort(i),r()):t},n.range=function(t){return arguments.length?(e=t,r()):e},n.quantiles=function(){return s},n.invertExtent=function(r){return r=e.indexOf(r),r<0?[NaN,NaN]:[r>0?s[r-1]:t[0],r<s.length?s[r]:t[t.length-1]]},n.copy=function(){return ua(t,e)},r()}function ca(t,e,r){function n(e){return r[Math.max(0,Math.min(o,Math.floor(a*(e-t))))]}function i(){return a=r.length/(e-t),o=r.length-1,n}var a,o;return n.domain=function(r){return arguments.length?(t=+r[0],e=+r[r.length-1],i()):[t,e]},n.range=function(t){return arguments.length?(r=t,i()):r},n.invertExtent=function(e){return e=r.indexOf(e),e=e<0?NaN:e/a+t,[e,e+1/a]},n.copy=function(){return ca(t,e,r)},i()}function ha(t,e){function r(r){if(r<=r)return e[uo.bisect(t,r)]}return r.domain=function(e){return arguments.length?(t=e,r):t},r.range=function(t){return arguments.length?(e=t,r):e},r.invertExtent=function(r){return r=e.indexOf(r),[t[r-1],t[r]]},r.copy=function(){return ha(t,e)},r}function fa(t){function e(t){return+t}return e.invert=e,e.domain=e.range=function(r){return arguments.length?(t=r.map(e),e):t},e.ticks=function(e){return ea(t,e)},e.tickFormat=function(e,r){return ra(t,e,r)},e.copy=function(){return fa(t)},e}function da(){return 0}function pa(t){return t.innerRadius}function ma(t){return t.outerRadius}function va(t){return t.startAngle}function ga(t){return t.endAngle}function ya(t){return t&&t.padAngle}function ba(t,e,r,n){return(t-r)*e-(e-n)*t>0?0:1}function xa(t,e,r,n,i){var a=t[0]-e[0],o=t[1]-e[1],s=(i?n:-n)/Math.sqrt(a*a+o*o),l=s*o,u=-s*a,c=t[0]+l,h=t[1]+u,f=e[0]+l,d=e[1]+u,p=(c+f)/2,m=(h+d)/2,v=f-c,g=d-h,y=v*v+g*g,b=r-n,x=c*d-f*h,_=(g<0?-1:1)*Math.sqrt(Math.max(0,b*b*y-x*x)),w=(x*g-v*_)/y,M=(-x*v-g*_)/y,k=(x*g+v*_)/y,A=(-x*v+g*_)/y,T=w-p,S=M-m,E=k-p,L=A-m;return T*T+S*S>E*E+L*L&&(w=k,M=A),[[w-l,M-u],[w*r/b,M*r/b]]}function _a(t){function e(e){function o(){u.push(\"M\",a(t(c),s))}for(var l,u=[],c=[],h=-1,f=e.length,d=Et(r),p=Et(n);++h<f;)i.call(this,l=e[h],h)?c.push([+d.call(this,l,h),+p.call(this,l,h)]):c.length&&(o(),c=[]);return c.length&&o(),u.length?u.join(\"\"):null}var r=Cr,n=zr,i=ze,a=wa,o=a.key,s=.7;return e.x=function(t){return arguments.length?(r=t,e):r},e.y=function(t){return arguments.length?(n=t,e):n},e.defined=function(t){return arguments.length?(i=t,e):i},e.interpolate=function(t){return arguments.length?(o=\"function\"==typeof t?a=t:(a=zl.get(t)||wa).key,e):o},e.tension=function(t){return arguments.length?(s=t,e):s},e}function wa(t){return t.length>1?t.join(\"L\"):t+\"Z\"}function Ma(t){return t.join(\"L\")+\"Z\"}function ka(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"H\",(n[0]+(n=t[e])[0])/2,\"V\",n[1]);return r>1&&i.push(\"H\",n[0]),i.join(\"\")}function Aa(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"V\",(n=t[e])[1],\"H\",n[0]);return i.join(\"\")}function Ta(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"H\",(n=t[e])[0],\"V\",n[1]);return i.join(\"\")}function Sa(t,e){return t.length<4?wa(t):t[1]+Ca(t.slice(1,-1),za(t,e))}function Ea(t,e){return t.length<3?Ma(t):t[0]+Ca((t.push(t[0]),t),za([t[t.length-2]].concat(t,[t[1]]),e))}function La(t,e){return t.length<3?wa(t):t[0]+Ca(t,za(t,e))}function Ca(t,e){if(e.length<1||t.length!=e.length&&t.length!=e.length+2)return wa(t);var r=t.length!=e.length,n=\"\",i=t[0],a=t[1],o=e[0],s=o,l=1;if(r&&(n+=\"Q\"+(a[0]-2*o[0]/3)+\",\"+(a[1]-2*o[1]/3)+\",\"+a[0]+\",\"+a[1],i=t[1],l=2),e.length>1){s=e[1],a=t[l],l++,n+=\"C\"+(i[0]+o[0])+\",\"+(i[1]+o[1])+\",\"+(a[0]-s[0])+\",\"+(a[1]-s[1])+\",\"+a[0]+\",\"+a[1];for(var u=2;u<e.length;u++,l++)a=t[l],s=e[u],n+=\"S\"+(a[0]-s[0])+\",\"+(a[1]-s[1])+\",\"+a[0]+\",\"+a[1]}if(r){var c=t[l];n+=\"Q\"+(a[0]+2*s[0]/3)+\",\"+(a[1]+2*s[1]/3)+\",\"+c[0]+\",\"+c[1]}return n}function za(t,e){for(var r,n=[],i=(1-e)/2,a=t[0],o=t[1],s=1,l=t.length;++s<l;)r=a,a=o,o=t[s],n.push([i*(o[0]-r[0]),i*(o[1]-r[1])]);return n}function Ia(t){if(t.length<3)return wa(t);var e=1,r=t.length,n=t[0],i=n[0],a=n[1],o=[i,i,i,(n=t[1])[0]],s=[a,a,a,n[1]],l=[i,\",\",a,\"L\",Ra(Pl,o),\",\",Ra(Pl,s)];for(t.push(t[r-1]);++e<=r;)n=t[e],o.shift(),o.push(n[0]),s.shift(),s.push(n[1]),Fa(l,o,s);return t.pop(),l.push(\"L\",n),l.join(\"\")}function Da(t){if(t.length<4)return wa(t);for(var e,r=[],n=-1,i=t.length,a=[0],o=[0];++n<3;)e=t[n],a.push(e[0]),o.push(e[1]);for(r.push(Ra(Pl,a)+\",\"+Ra(Pl,o)),--n;++n<i;)e=t[n],a.shift(),a.push(e[0]),o.shift(),o.push(e[1]),Fa(r,a,o);return r.join(\"\")}function Pa(t){for(var e,r,n=-1,i=t.length,a=i+4,o=[],s=[];++n<4;)r=t[n%i],o.push(r[0]),s.push(r[1]);for(e=[Ra(Pl,o),\",\",Ra(Pl,s)],--n;++n<a;)r=t[n%i],o.shift(),o.push(r[0]),s.shift(),s.push(r[1]),Fa(e,o,s);return e.join(\"\")}function Oa(t,e){var r=t.length-1;if(r)for(var n,i,a=t[0][0],o=t[0][1],s=t[r][0]-a,l=t[r][1]-o,u=-1;++u<=r;)n=t[u],i=u/r,n[0]=e*n[0]+(1-e)*(a+i*s),n[1]=e*n[1]+(1-e)*(o+i*l);return Ia(t)}function Ra(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]}function Fa(t,e,r){t.push(\"C\",Ra(Il,e),\",\",Ra(Il,r),\",\",Ra(Dl,e),\",\",Ra(Dl,r),\",\",Ra(Pl,e),\",\",Ra(Pl,r))}function ja(t,e){return(e[1]-t[1])/(e[0]-t[0])}function Na(t){for(var e=0,r=t.length-1,n=[],i=t[0],a=t[1],o=n[0]=ja(i,a);++e<r;)n[e]=(o+(o=ja(i=a,a=t[e+1])))/2;return n[e]=o,n}function Ba(t){for(var e,r,n,i,a=[],o=Na(t),s=-1,l=t.length-1;++s<l;)e=ja(t[s],t[s+1]),xo(e)<Fo?o[s]=o[s+1]=0:(r=o[s]/e,n=o[s+1]/e,(i=r*r+n*n)>9&&(i=3*e/Math.sqrt(i),o[s]=i*r,o[s+1]=i*n));for(s=-1;++s<=l;)i=(t[Math.min(l,s+1)][0]-t[Math.max(0,s-1)][0])/(6*(1+o[s]*o[s])),a.push([i||0,o[s]*i||0]);return a}function Ua(t){return t.length<3?wa(t):t[0]+Ca(t,Ba(t))}function Va(t){for(var e,r,n,i=-1,a=t.length;++i<a;)e=t[i],r=e[0],n=e[1]-Vo,e[0]=r*Math.cos(n),e[1]=r*Math.sin(n);return t}function Ha(t){function e(e){function l(){m.push(\"M\",s(t(g),h),c,u(t(v.reverse()),h),\"Z\")}for(var f,d,p,m=[],v=[],g=[],y=-1,b=e.length,x=Et(r),_=Et(i),w=r===n?function(){return d}:Et(n),M=i===a?function(){return p}:Et(a);++y<b;)o.call(this,f=e[y],y)?(v.push([d=+x.call(this,f,y),p=+_.call(this,f,y)]),g.push([+w.call(this,f,y),+M.call(this,f,y)])):v.length&&(l(),v=[],g=[]);return v.length&&l(),m.length?m.join(\"\"):null}var r=Cr,n=Cr,i=0,a=zr,o=ze,s=wa,l=s.key,u=s,c=\"L\",h=.7;return e.x=function(t){return arguments.length?(r=n=t,e):n},e.x0=function(t){return arguments.length?(r=t,e):r},e.x1=function(t){return arguments.length?(n=t,e):n},e.y=function(t){return arguments.length?(i=a=t,e):a},e.y0=function(t){return arguments.length?(i=t,e):i},e.y1=function(t){return arguments.length?(a=t,e):a},e.defined=function(t){return arguments.length?(o=t,e):o},e.interpolate=function(t){return arguments.length?(l=\"function\"==typeof t?s=t:(s=zl.get(t)||wa).key,u=s.reverse||s,c=s.closed?\"M\":\"L\",e):l},e.tension=function(t){return arguments.length?(h=t,e):h},e}function qa(t){return t.radius}function Ga(t){return[t.x,t.y]}function Ya(t){return function(){var e=t.apply(this,arguments),r=e[0],n=e[1]-Vo;return[r*Math.cos(n),r*Math.sin(n)]}}function Xa(){return 64}function Wa(){return\"circle\"}function Za(t){var e=Math.sqrt(t/No);return\"M0,\"+e+\"A\"+e+\",\"+e+\" 0 1,1 0,\"+-e+\"A\"+e+\",\"+e+\" 0 1,1 0,\"+e+\"Z\"}function Ja(t){return function(){var e,r,n;(e=this[t])&&(n=e[r=e.active])&&(n.timer.c=null,n.timer.t=NaN,--e.count?delete e[r]:delete this[t],e.active+=.5,n.event&&n.event.interrupt.call(this,this.__data__,n.index))}}function Ka(t,e,r){return Ao(t,Ul),t.namespace=e,t.id=r,t}function Qa(t,e,r,n){var i=t.id,a=t.namespace;return G(t,\"function\"==typeof r?function(t,o,s){t[a][i].tween.set(e,n(r.call(t,t.__data__,o,s)))}:(r=n(r),function(t){t[a][i].tween.set(e,r)}))}function $a(t){return null==t&&(t=\"\"),function(){this.textContent=t}}function to(t){return null==t?\"__transition__\":\"__transition_\"+t+\"__\"}function eo(t,e,r,n,i){function a(t){var e=m.delay;if(u.t=e+l,e<=t)return o(t-e);u.c=o}function o(r){var i=p.active,a=p[i];a&&(a.timer.c=null,a.timer.t=NaN,--p.count,delete p[i],a.event&&a.event.interrupt.call(t,t.__data__,a.index));for(var o in p)if(+o<n){var h=p[o];h.timer.c=null,h.timer.t=NaN,--p.count,delete p[o]}u.c=s,Dt(function(){return u.c&&s(r||1)&&(u.c=null,u.t=NaN),1},0,l),p.active=n,m.event&&m.event.start.call(t,t.__data__,e),d=[],m.tween.forEach(function(r,n){(n=n.call(t,t.__data__,e))&&d.push(n)}),f=m.ease,c=m.duration}function s(i){for(var a=i/c,o=f(a),s=d.length;s>0;)d[--s].call(t,o);if(a>=1)return m.event&&m.event.end.call(t,t.__data__,e),--p.count?delete p[n]:delete t[r],1}var l,u,c,f,d,p=t[r]||(t[r]={active:0,count:0}),m=p[n];m||(l=i.time,u=Dt(a,0,l),m=p[n]={tween:new h,time:l,timer:u,delay:i.delay,duration:i.duration,ease:i.ease,index:e},i=null,++p.count)}function ro(t,e,r){t.attr(\"transform\",function(t){var n=e(t);return\"translate(\"+(isFinite(n)?n:r(t))+\",0)\"})}function no(t,e,r){t.attr(\"transform\",function(t){var n=e(t);return\"translate(0,\"+(isFinite(n)?n:r(t))+\")\"})}function io(t){return t.toISOString()}function ao(t,e,r){function n(e){return t(e)}function i(t,r){var n=t[1]-t[0],i=n/r,a=uo.bisect(Jl,i);return a==Jl.length?[e.year,ta(t.map(function(t){return t/31536e6}),r)[2]]:a?e[i/Jl[a-1]<Jl[a]/i?a-1:a]:[$l,ta(t,r)[2]]}return n.invert=function(e){return oo(t.invert(e))},n.domain=function(e){return arguments.length?(t.domain(e),n):t.domain().map(oo)},n.nice=function(t,e){function r(r){return!isNaN(r)&&!t.range(r,oo(+r+1),e).length}var a=n.domain(),o=Gi(a),s=null==t?i(o,10):\"number\"==typeof t&&i(o,t);return s&&(t=s[0],e=s[1]),n.domain(Wi(a,e>1?{floor:function(e){for(;r(e=t.floor(e));)e=oo(e-1);return e},ceil:function(e){for(;r(e=t.ceil(e));)e=oo(+e+1);return e}}:t))},n.ticks=function(t,e){var r=Gi(n.domain()),a=null==t?i(r,10):\"number\"==typeof t?i(r,t):!t.range&&[{range:t},e];return a&&(t=a[0],e=a[1]),t.range(r[0],oo(+r[1]+1),e<1?1:e)},n.tickFormat=function(){return r},n.copy=function(){return ao(t.copy(),e,r)},Qi(n,t)}function oo(t){return new Date(t)}function so(t){return JSON.parse(t.responseText)}function lo(t){var e=fo.createRange();return e.selectNode(fo.body),e.createContextualFragment(t.responseText)}var uo={version:\"3.5.17\"},co=[].slice,ho=function(t){return co.call(t)},fo=this.document;if(fo)try{ho(fo.documentElement.childNodes)[0].nodeType}catch(t){ho=function(t){for(var e=t.length,r=new Array(e);e--;)r[e]=t[e];return r}}if(Date.now||(Date.now=function(){return+new Date}),fo)try{fo.createElement(\"DIV\").style.setProperty(\"opacity\",0,\"\")}catch(t){var po=this.Element.prototype,mo=po.setAttribute,vo=po.setAttributeNS,go=this.CSSStyleDeclaration.prototype,yo=go.setProperty;po.setAttribute=function(t,e){mo.call(this,t,e+\"\")},po.setAttributeNS=function(t,e,r){vo.call(this,t,e,r+\"\")},go.setProperty=function(t,e,r){yo.call(this,t,e+\"\",r)}}uo.ascending=i,uo.descending=function(t,e){return e<t?-1:e>t?1:e>=t?0:NaN},uo.min=function(t,e){var r,n,i=-1,a=t.length;if(1===arguments.length){for(;++i<a;)if(null!=(n=t[i])&&n>=n){r=n;break}for(;++i<a;)null!=(n=t[i])&&r>n&&(r=n)}else{for(;++i<a;)if(null!=(n=e.call(t,t[i],i))&&n>=n){r=n;break}for(;++i<a;)null!=(n=e.call(t,t[i],i))&&r>n&&(r=n)}return r},uo.max=function(t,e){var r,n,i=-1,a=t.length;if(1===arguments.length){for(;++i<a;)if(null!=(n=t[i])&&n>=n){r=n;break}for(;++i<a;)null!=(n=t[i])&&n>r&&(r=n)}else{for(;++i<a;)if(null!=(n=e.call(t,t[i],i))&&n>=n){r=n;break}for(;++i<a;)null!=(n=e.call(t,t[i],i))&&n>r&&(r=n)}return r},uo.extent=function(t,e){var r,n,i,a=-1,o=t.length;if(1===arguments.length){for(;++a<o;)if(null!=(n=t[a])&&n>=n){r=i=n;break}for(;++a<o;)null!=(n=t[a])&&(r>n&&(r=n),i<n&&(i=n))}else{for(;++a<o;)if(null!=(n=e.call(t,t[a],a))&&n>=n){r=i=n;break}for(;++a<o;)null!=(n=e.call(t,t[a],a))&&(r>n&&(r=n),i<n&&(i=n))}return[r,i]},uo.sum=function(t,e){var r,n=0,i=t.length,a=-1;if(1===arguments.length)for(;++a<i;)o(r=+t[a])&&(n+=r);else for(;++a<i;)o(r=+e.call(t,t[a],a))&&(n+=r);return n},uo.mean=function(t,e){var r,n=0,i=t.length,s=-1,l=i;if(1===arguments.length)for(;++s<i;)o(r=a(t[s]))?n+=r:--l;else for(;++s<i;)o(r=a(e.call(t,t[s],s)))?n+=r:--l;if(l)return n/l},uo.quantile=function(t,e){var r=(t.length-1)*e+1,n=Math.floor(r),i=+t[n-1],a=r-n;return a?i+a*(t[n]-i):i},uo.median=function(t,e){var r,n=[],s=t.length,l=-1;if(1===arguments.length)for(;++l<s;)o(r=a(t[l]))&&n.push(r);else for(;++l<s;)o(r=a(e.call(t,t[l],l)))&&n.push(r);if(n.length)return uo.quantile(n.sort(i),.5)},uo.variance=function(t,e){var r,n,i=t.length,s=0,l=0,u=-1,c=0;if(1===arguments.length)for(;++u<i;)o(r=a(t[u]))&&(n=r-s,s+=n/++c,l+=n*(r-s));else for(;++u<i;)o(r=a(e.call(t,t[u],u)))&&(n=r-s,s+=n/++c,l+=n*(r-s));if(c>1)return l/(c-1)},uo.deviation=function(){var t=uo.variance.apply(this,arguments);return t?Math.sqrt(t):t};var bo=s(i);uo.bisectLeft=bo.left,uo.bisect=uo.bisectRight=bo.right,uo.bisector=function(t){return s(1===t.length?function(e,r){return i(t(e),r)}:t)},uo.shuffle=function(t,e,r){(a=arguments.length)<3&&(r=t.length,a<2&&(e=0));for(var n,i,a=r-e;a;)i=Math.random()*a--|0,n=t[a+e],t[a+e]=t[i+e],t[i+e]=n;return t},uo.permute=function(t,e){for(var r=e.length,n=new Array(r);r--;)n[r]=t[e[r]];return n},uo.pairs=function(t){for(var e=0,r=t.length-1,n=t[0],i=new Array(r<0?0:r);e<r;)i[e]=[n,n=t[++e]];return i},uo.transpose=function(t){if(!(i=t.length))return[];for(var e=-1,r=uo.min(t,l),n=new Array(r);++e<r;)for(var i,a=-1,o=n[e]=new Array(i);++a<i;)o[a]=t[a][e];return n},uo.zip=function(){return uo.transpose(arguments)},uo.keys=function(t){var e=[];for(var r in t)e.push(r);return e},uo.values=function(t){var e=[];for(var r in t)e.push(t[r]);return e},uo.entries=function(t){var e=[];for(var r in t)e.push({key:r,value:t[r]});return e},uo.merge=function(t){for(var e,r,n,i=t.length,a=-1,o=0;++a<i;)o+=t[a].length;for(r=new Array(o);--i>=0;)for(n=t[i],e=n.length;--e>=0;)r[--o]=n[e];return r};var xo=Math.abs;uo.range=function(t,e,r){if(arguments.length<3&&(r=1,arguments.length<2&&(e=t,t=0)),(e-t)/r==1/0)throw new Error(\"infinite range\");var n,i=[],a=u(xo(r)),o=-1;if(t*=a,e*=a,r*=a,r<0)for(;(n=t+r*++o)>e;)i.push(n/a);else for(;(n=t+r*++o)<e;)i.push(n/a);return i},uo.map=function(t,e){var r=new h;if(t instanceof h)t.forEach(function(t,e){r.set(t,e)});else if(Array.isArray(t)){var n,i=-1,a=t.length;if(1===arguments.length)for(;++i<a;)r.set(i,t[i]);else for(;++i<a;)r.set(e.call(t,n=t[i],i),n)}else for(var o in t)r.set(o,t[o]);return r};var _o=\"__proto__\",wo=\"\\0\";c(h,{has:p,get:function(t){return this._[f(t)]},set:function(t,e){return this._[f(t)]=e},remove:m,keys:v,values:function(){var t=[];for(var e in this._)t.push(this._[e]);return t},entries:function(){var t=[];for(var e in this._)t.push({key:d(e),value:this._[e]});return t},size:g,empty:y,forEach:function(t){for(var e in this._)t.call(this,d(e),this._[e])}}),uo.nest=function(){function t(e,o,s){if(s>=a.length)return n?n.call(i,o):r?o.sort(r):o;for(var l,u,c,f,d=-1,p=o.length,m=a[s++],v=new h;++d<p;)(f=v.get(l=m(u=o[d])))?f.push(u):v.set(l,[u]);return e?(u=e(),c=function(r,n){u.set(r,t(e,n,s))}):(u={},c=function(r,n){u[r]=t(e,n,s)}),v.forEach(c),u}function e(t,r){if(r>=a.length)return t;var n=[],i=o[r++];return t.forEach(function(t,i){n.push({key:t,values:e(i,r)})}),i?n.sort(function(t,e){return i(t.key,e.key)}):n}var r,n,i={},a=[],o=[];return i.map=function(e,r){return t(r,e,0)},i.entries=function(r){return e(t(uo.map,r,0),0)},i.key=function(t){return a.push(t),i},i.sortKeys=function(t){return o[a.length-1]=t,i},i.sortValues=function(t){return r=t,i},i.rollup=function(t){return n=t,i},i},uo.set=function(t){var e=new b;if(t)for(var r=0,n=t.length;r<n;++r)e.add(t[r]);return e},c(b,{has:p,add:function(t){return this._[f(t+=\"\")]=!0,t},remove:m,values:v,size:g,empty:y,forEach:function(t){for(var e in this._)t.call(this,d(e))}}),uo.behavior={},uo.rebind=function(t,e){for(var r,n=1,i=arguments.length;++n<i;)t[r=arguments[n]]=_(t,e,e[r]);return t}\n",
       ";var Mo=[\"webkit\",\"ms\",\"moz\",\"Moz\",\"o\",\"O\"];uo.dispatch=function(){for(var t=new k,e=-1,r=arguments.length;++e<r;)t[arguments[e]]=A(t);return t},k.prototype.on=function(t,e){var r=t.indexOf(\".\"),n=\"\";if(r>=0&&(n=t.slice(r+1),t=t.slice(0,r)),t)return arguments.length<2?this[t].on(n):this[t].on(n,e);if(2===arguments.length){if(null==e)for(t in this)this.hasOwnProperty(t)&&this[t].on(n,null);return this}},uo.event=null,uo.requote=function(t){return t.replace(ko,\"\\\\$&\")};var ko=/[\\\\\\^\\$\\*\\+\\?\\|\\[\\]\\(\\)\\.\\{\\}]/g,Ao={}.__proto__?function(t,e){t.__proto__=e}:function(t,e){for(var r in e)t[r]=e[r]},To=function(t,e){return e.querySelector(t)},So=function(t,e){return e.querySelectorAll(t)},Eo=function(t,e){var r=t.matches||t[w(t,\"matchesSelector\")];return(Eo=function(t,e){return r.call(t,e)})(t,e)};\"function\"==typeof Sizzle&&(To=function(t,e){return Sizzle(t,e)[0]||null},So=Sizzle,Eo=Sizzle.matchesSelector),uo.selection=function(){return uo.select(fo.documentElement)};var Lo=uo.selection.prototype=[];Lo.select=function(t){var e,r,n,i,a=[];t=C(t);for(var o=-1,s=this.length;++o<s;){a.push(e=[]),e.parentNode=(n=this[o]).parentNode;for(var l=-1,u=n.length;++l<u;)(i=n[l])?(e.push(r=t.call(i,i.__data__,l,o)),r&&\"__data__\"in i&&(r.__data__=i.__data__)):e.push(null)}return L(a)},Lo.selectAll=function(t){var e,r,n=[];t=z(t);for(var i=-1,a=this.length;++i<a;)for(var o=this[i],s=-1,l=o.length;++s<l;)(r=o[s])&&(n.push(e=ho(t.call(r,r.__data__,s,i))),e.parentNode=r);return L(n)};var Co=\"http://www.w3.org/1999/xhtml\",zo={svg:\"http://www.w3.org/2000/svg\",xhtml:Co,xlink:\"http://www.w3.org/1999/xlink\",xml:\"http://www.w3.org/XML/1998/namespace\",xmlns:\"http://www.w3.org/2000/xmlns/\"};uo.ns={prefix:zo,qualify:function(t){var e=t.indexOf(\":\"),r=t;return e>=0&&\"xmlns\"!==(r=t.slice(0,e))&&(t=t.slice(e+1)),zo.hasOwnProperty(r)?{space:zo[r],local:t}:t}},Lo.attr=function(t,e){if(arguments.length<2){if(\"string\"==typeof t){var r=this.node();return t=uo.ns.qualify(t),t.local?r.getAttributeNS(t.space,t.local):r.getAttribute(t)}for(e in t)this.each(I(e,t[e]));return this}return this.each(I(t,e))},Lo.classed=function(t,e){if(arguments.length<2){if(\"string\"==typeof t){var r=this.node(),n=(t=O(t)).length,i=-1;if(e=r.classList){for(;++i<n;)if(!e.contains(t[i]))return!1}else for(e=r.getAttribute(\"class\");++i<n;)if(!P(t[i]).test(e))return!1;return!0}for(e in t)this.each(R(e,t[e]));return this}return this.each(R(t,e))},Lo.style=function(t,e,r){var i=arguments.length;if(i<3){if(\"string\"!=typeof t){i<2&&(e=\"\");for(r in t)this.each(j(r,t[r],e));return this}if(i<2){var a=this.node();return n(a).getComputedStyle(a,null).getPropertyValue(t)}r=\"\"}return this.each(j(t,e,r))},Lo.property=function(t,e){if(arguments.length<2){if(\"string\"==typeof t)return this.node()[t];for(e in t)this.each(N(e,t[e]));return this}return this.each(N(t,e))},Lo.text=function(t){return arguments.length?this.each(\"function\"==typeof t?function(){var e=t.apply(this,arguments);this.textContent=null==e?\"\":e}:null==t?function(){this.textContent=\"\"}:function(){this.textContent=t}):this.node().textContent},Lo.html=function(t){return arguments.length?this.each(\"function\"==typeof t?function(){var e=t.apply(this,arguments);this.innerHTML=null==e?\"\":e}:null==t?function(){this.innerHTML=\"\"}:function(){this.innerHTML=t}):this.node().innerHTML},Lo.append=function(t){return t=B(t),this.select(function(){return this.appendChild(t.apply(this,arguments))})},Lo.insert=function(t,e){return t=B(t),e=C(e),this.select(function(){return this.insertBefore(t.apply(this,arguments),e.apply(this,arguments)||null)})},Lo.remove=function(){return this.each(U)},Lo.data=function(t,e){function r(t,r){var n,i,a,o=t.length,c=r.length,f=Math.min(o,c),d=new Array(c),p=new Array(c),m=new Array(o);if(e){var v,g=new h,y=new Array(o);for(n=-1;++n<o;)(i=t[n])&&(g.has(v=e.call(i,i.__data__,n))?m[n]=i:g.set(v,i),y[n]=v);for(n=-1;++n<c;)(i=g.get(v=e.call(r,a=r[n],n)))?!0!==i&&(d[n]=i,i.__data__=a):p[n]=V(a),g.set(v,!0);for(n=-1;++n<o;)n in y&&!0!==g.get(y[n])&&(m[n]=t[n])}else{for(n=-1;++n<f;)i=t[n],a=r[n],i?(i.__data__=a,d[n]=i):p[n]=V(a);for(;n<c;++n)p[n]=V(r[n]);for(;n<o;++n)m[n]=t[n]}p.update=d,p.parentNode=d.parentNode=m.parentNode=t.parentNode,s.push(p),l.push(d),u.push(m)}var n,i,a=-1,o=this.length;if(!arguments.length){for(t=new Array(o=(n=this[0]).length);++a<o;)(i=n[a])&&(t[a]=i.__data__);return t}var s=Y([]),l=L([]),u=L([]);if(\"function\"==typeof t)for(;++a<o;)r(n=this[a],t.call(n,n.parentNode.__data__,a));else for(;++a<o;)r(n=this[a],t);return l.enter=function(){return s},l.exit=function(){return u},l},Lo.datum=function(t){return arguments.length?this.property(\"__data__\",t):this.property(\"__data__\")},Lo.filter=function(t){var e,r,n,i=[];\"function\"!=typeof t&&(t=H(t));for(var a=0,o=this.length;a<o;a++){i.push(e=[]),e.parentNode=(r=this[a]).parentNode;for(var s=0,l=r.length;s<l;s++)(n=r[s])&&t.call(n,n.__data__,s,a)&&e.push(n)}return L(i)},Lo.order=function(){for(var t=-1,e=this.length;++t<e;)for(var r,n=this[t],i=n.length-1,a=n[i];--i>=0;)(r=n[i])&&(a&&a!==r.nextSibling&&a.parentNode.insertBefore(r,a),a=r);return this},Lo.sort=function(t){t=q.apply(this,arguments);for(var e=-1,r=this.length;++e<r;)this[e].sort(t);return this.order()},Lo.each=function(t){return G(this,function(e,r,n){t.call(e,e.__data__,r,n)})},Lo.call=function(t){var e=ho(arguments);return t.apply(e[0]=this,e),this},Lo.empty=function(){return!this.node()},Lo.node=function(){for(var t=0,e=this.length;t<e;t++)for(var r=this[t],n=0,i=r.length;n<i;n++){var a=r[n];if(a)return a}return null},Lo.size=function(){var t=0;return G(this,function(){++t}),t};var Io=[];uo.selection.enter=Y,uo.selection.enter.prototype=Io,Io.append=Lo.append,Io.empty=Lo.empty,Io.node=Lo.node,Io.call=Lo.call,Io.size=Lo.size,Io.select=function(t){for(var e,r,n,i,a,o=[],s=-1,l=this.length;++s<l;){n=(i=this[s]).update,o.push(e=[]),e.parentNode=i.parentNode;for(var u=-1,c=i.length;++u<c;)(a=i[u])?(e.push(n[u]=r=t.call(i.parentNode,a.__data__,u,s)),r.__data__=a.__data__):e.push(null)}return L(o)},Io.insert=function(t,e){return arguments.length<2&&(e=X(this)),Lo.insert.call(this,t,e)},uo.select=function(t){var r;return\"string\"==typeof t?(r=[To(t,fo)],r.parentNode=fo.documentElement):(r=[t],r.parentNode=e(t)),L([r])},uo.selectAll=function(t){var e;return\"string\"==typeof t?(e=ho(So(t,fo)),e.parentNode=fo.documentElement):(e=ho(t),e.parentNode=null),L([e])},Lo.on=function(t,e,r){var n=arguments.length;if(n<3){if(\"string\"!=typeof t){n<2&&(e=!1);for(r in t)this.each(W(r,t[r],e));return this}if(n<2)return(n=this.node()[\"__on\"+t])&&n._;r=!1}return this.each(W(t,e,r))};var Do=uo.map({mouseenter:\"mouseover\",mouseleave:\"mouseout\"});fo&&Do.forEach(function(t){\"on\"+t in fo&&Do.remove(t)});var Po,Oo=0;uo.mouse=function(t){return Q(t,S())};var Ro=this.navigator&&/WebKit/.test(this.navigator.userAgent)?-1:0;uo.touch=function(t,e,r){if(arguments.length<3&&(r=e,e=S().changedTouches),e)for(var n,i=0,a=e.length;i<a;++i)if((n=e[i]).identifier===r)return Q(t,n)},uo.behavior.drag=function(){function t(){this.on(\"mousedown.drag\",a).on(\"touchstart.drag\",o)}function e(t,e,n,a,o){return function(){function s(){var t,r,n=e(f,m);n&&(t=n[0]-b[0],r=n[1]-b[1],p|=t|r,b=n,d({type:\"drag\",x:n[0]+u[0],y:n[1]+u[1],dx:t,dy:r}))}function l(){e(f,m)&&(g.on(a+v,null).on(o+v,null),y(p),d({type:\"dragend\"}))}var u,c=this,h=uo.event.target.correspondingElement||uo.event.target,f=c.parentNode,d=r.of(c,arguments),p=0,m=t(),v=\".drag\"+(null==m?\"\":\"-\"+m),g=uo.select(n(h)).on(a+v,s).on(o+v,l),y=K(h),b=e(f,m);i?(u=i.apply(c,arguments),u=[u.x-b[0],u.y-b[1]]):u=[0,0],d({type:\"dragstart\"})}}var r=E(t,\"drag\",\"dragstart\",\"dragend\"),i=null,a=e(M,uo.mouse,n,\"mousemove\",\"mouseup\"),o=e($,uo.touch,x,\"touchmove\",\"touchend\");return t.origin=function(e){return arguments.length?(i=e,t):i},uo.rebind(t,r,\"on\")},uo.touches=function(t,e){return arguments.length<2&&(e=S().touches),e?ho(e).map(function(e){var r=Q(t,e);return r.identifier=e.identifier,r}):[]};var Fo=1e-6,jo=Fo*Fo,No=Math.PI,Bo=2*No,Uo=Bo-Fo,Vo=No/2,Ho=No/180,qo=180/No,Go=Math.SQRT2;uo.interpolateZoom=function(t,e){var r,n,i=t[0],a=t[1],o=t[2],s=e[0],l=e[1],u=e[2],c=s-i,h=l-a,f=c*c+h*h;if(f<jo)n=Math.log(u/o)/Go,r=function(t){return[i+t*c,a+t*h,o*Math.exp(Go*t*n)]};else{var d=Math.sqrt(f),p=(u*u-o*o+4*f)/(2*o*2*d),m=(u*u-o*o-4*f)/(2*u*2*d),v=Math.log(Math.sqrt(p*p+1)-p),g=Math.log(Math.sqrt(m*m+1)-m);n=(g-v)/Go,r=function(t){var e=t*n,r=at(v),s=o/(2*d)*(r*ot(Go*e+v)-it(v));return[i+s*c,a+s*h,o*r/at(Go*e+v)]}}return r.duration=1e3*n,r},uo.behavior.zoom=function(){function t(t){t.on(z,h).on(Xo+\".zoom\",d).on(\"dblclick.zoom\",p).on(P,f)}function e(t){return[(t[0]-k.x)/k.k,(t[1]-k.y)/k.k]}function r(t){return[t[0]*k.k+k.x,t[1]*k.k+k.y]}function i(t){k.k=Math.max(S[0],Math.min(S[1],t))}function a(t,e){e=r(e),k.x+=t[0]-e[0],k.y+=t[1]-e[1]}function o(e,r,n,o){e.__chart__={x:k.x,y:k.y,k:k.k},i(Math.pow(2,o)),a(v=r,n),e=uo.select(e),L>0&&(e=e.transition().duration(L)),e.call(t.event)}function s(){_&&_.domain(x.range().map(function(t){return(t-k.x)/k.k}).map(x.invert)),M&&M.domain(w.range().map(function(t){return(t-k.y)/k.k}).map(w.invert))}function l(t){C++||t({type:\"zoomstart\"})}function u(t){s(),t({type:\"zoom\",scale:k.k,translate:[k.x,k.y]})}function c(t){--C||(t({type:\"zoomend\"}),v=null)}function h(){function t(){s=1,a(uo.mouse(i),f),u(o)}function r(){h.on(I,null).on(D,null),d(s),c(o)}var i=this,o=O.of(i,arguments),s=0,h=uo.select(n(i)).on(I,t).on(D,r),f=e(uo.mouse(i)),d=K(i);Bl.call(i),l(o)}function f(){function t(){var t=uo.touches(p);return d=k.k,t.forEach(function(t){t.identifier in v&&(v[t.identifier]=e(t))}),t}function r(){var e=uo.event.target;uo.select(e).on(x,n).on(_,s),w.push(e);for(var r=uo.event.changedTouches,i=0,a=r.length;i<a;++i)v[r[i].identifier]=null;var l=t(),u=Date.now();if(1===l.length){if(u-b<500){var c=l[0];o(p,c,v[c.identifier],Math.floor(Math.log(k.k)/Math.LN2)+1),T()}b=u}else if(l.length>1){var c=l[0],h=l[1],f=c[0]-h[0],d=c[1]-h[1];g=f*f+d*d}}function n(){var t,e,r,n,o=uo.touches(p);Bl.call(p);for(var s=0,l=o.length;s<l;++s,n=null)if(r=o[s],n=v[r.identifier]){if(e)break;t=r,e=n}if(n){var c=(c=r[0]-t[0])*c+(c=r[1]-t[1])*c,h=g&&Math.sqrt(c/g);t=[(t[0]+r[0])/2,(t[1]+r[1])/2],e=[(e[0]+n[0])/2,(e[1]+n[1])/2],i(h*d)}b=null,a(t,e),u(m)}function s(){if(uo.event.touches.length){for(var e=uo.event.changedTouches,r=0,n=e.length;r<n;++r)delete v[e[r].identifier];for(var i in v)return void t()}uo.selectAll(w).on(y,null),M.on(z,h).on(P,f),A(),c(m)}var d,p=this,m=O.of(p,arguments),v={},g=0,y=\".zoom-\"+uo.event.changedTouches[0].identifier,x=\"touchmove\"+y,_=\"touchend\"+y,w=[],M=uo.select(p),A=K(p);r(),l(m),M.on(z,null).on(P,r)}function d(){var t=O.of(this,arguments);y?clearTimeout(y):(Bl.call(this),m=e(v=g||uo.mouse(this)),l(t)),y=setTimeout(function(){y=null,c(t)},50),T(),i(Math.pow(2,.002*Yo())*k.k),a(v,m),u(t)}function p(){var t=uo.mouse(this),r=Math.log(k.k)/Math.LN2;o(this,t,e(t),uo.event.shiftKey?Math.ceil(r)-1:Math.floor(r)+1)}var m,v,g,y,b,x,_,w,M,k={x:0,y:0,k:1},A=[960,500],S=Wo,L=250,C=0,z=\"mousedown.zoom\",I=\"mousemove.zoom\",D=\"mouseup.zoom\",P=\"touchstart.zoom\",O=E(t,\"zoomstart\",\"zoom\",\"zoomend\");return Xo||(Xo=\"onwheel\"in fo?(Yo=function(){return-uo.event.deltaY*(uo.event.deltaMode?120:1)},\"wheel\"):\"onmousewheel\"in fo?(Yo=function(){return uo.event.wheelDelta},\"mousewheel\"):(Yo=function(){return-uo.event.detail},\"MozMousePixelScroll\")),t.event=function(t){t.each(function(){var t=O.of(this,arguments),e=k;jl?uo.select(this).transition().each(\"start.zoom\",function(){k=this.__chart__||{x:0,y:0,k:1},l(t)}).tween(\"zoom:zoom\",function(){var r=A[0],n=A[1],i=v?v[0]:r/2,a=v?v[1]:n/2,o=uo.interpolateZoom([(i-k.x)/k.k,(a-k.y)/k.k,r/k.k],[(i-e.x)/e.k,(a-e.y)/e.k,r/e.k]);return function(e){var n=o(e),s=r/n[2];this.__chart__=k={x:i-n[0]*s,y:a-n[1]*s,k:s},u(t)}}).each(\"interrupt.zoom\",function(){c(t)}).each(\"end.zoom\",function(){c(t)}):(this.__chart__=k,l(t),u(t),c(t))})},t.translate=function(e){return arguments.length?(k={x:+e[0],y:+e[1],k:k.k},s(),t):[k.x,k.y]},t.scale=function(e){return arguments.length?(k={x:k.x,y:k.y,k:null},i(+e),s(),t):k.k},t.scaleExtent=function(e){return arguments.length?(S=null==e?Wo:[+e[0],+e[1]],t):S},t.center=function(e){return arguments.length?(g=e&&[+e[0],+e[1]],t):g},t.size=function(e){return arguments.length?(A=e&&[+e[0],+e[1]],t):A},t.duration=function(e){return arguments.length?(L=+e,t):L},t.x=function(e){return arguments.length?(_=e,x=e.copy(),k={x:0,y:0,k:1},t):_},t.y=function(e){return arguments.length?(M=e,w=e.copy(),k={x:0,y:0,k:1},t):M},uo.rebind(t,O,\"on\")};var Yo,Xo,Wo=[0,1/0];uo.color=lt,lt.prototype.toString=function(){return this.rgb()+\"\"},uo.hsl=ut;var Zo=ut.prototype=new lt;Zo.brighter=function(t){return t=Math.pow(.7,arguments.length?t:1),new ut(this.h,this.s,this.l/t)},Zo.darker=function(t){return t=Math.pow(.7,arguments.length?t:1),new ut(this.h,this.s,t*this.l)},Zo.rgb=function(){return ct(this.h,this.s,this.l)},uo.hcl=ht;var Jo=ht.prototype=new lt;Jo.brighter=function(t){return new ht(this.h,this.c,Math.min(100,this.l+Ko*(arguments.length?t:1)))},Jo.darker=function(t){return new ht(this.h,this.c,Math.max(0,this.l-Ko*(arguments.length?t:1)))},Jo.rgb=function(){return ft(this.h,this.c,this.l).rgb()},uo.lab=dt;var Ko=18,Qo=.95047,$o=1,ts=1.08883,es=dt.prototype=new lt;es.brighter=function(t){return new dt(Math.min(100,this.l+Ko*(arguments.length?t:1)),this.a,this.b)},es.darker=function(t){return new dt(Math.max(0,this.l-Ko*(arguments.length?t:1)),this.a,this.b)},es.rgb=function(){return pt(this.l,this.a,this.b)},uo.rgb=bt;var rs=bt.prototype=new lt;rs.brighter=function(t){t=Math.pow(.7,arguments.length?t:1);var e=this.r,r=this.g,n=this.b,i=30;return e||r||n?(e&&e<i&&(e=i),r&&r<i&&(r=i),n&&n<i&&(n=i),new bt(Math.min(255,e/t),Math.min(255,r/t),Math.min(255,n/t))):new bt(i,i,i)},rs.darker=function(t){return t=Math.pow(.7,arguments.length?t:1),new bt(t*this.r,t*this.g,t*this.b)},rs.hsl=function(){return kt(this.r,this.g,this.b)},rs.toString=function(){return\"#\"+wt(this.r)+wt(this.g)+wt(this.b)};var ns=uo.map({aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074});ns.forEach(function(t,e){ns.set(t,xt(e))}),uo.functor=Et,uo.xhr=Lt(x),uo.dsv=function(t,e){function r(t,r,a){arguments.length<3&&(a=r,r=null);var o=Ct(t,e,null==r?n:i(r),a);return o.row=function(t){return arguments.length?o.response(null==(r=t)?n:i(t)):r},o}function n(t){return r.parse(t.responseText)}function i(t){return function(e){return r.parse(e.responseText,t)}}function a(e){return e.map(o).join(t)}function o(t){return s.test(t)?'\"'+t.replace(/\\\"/g,'\"\"')+'\"':t}var s=new RegExp('[\"'+t+\"\\n]\"),l=t.charCodeAt(0);return r.parse=function(t,e){var n;return r.parseRows(t,function(t,r){if(n)return n(t,r-1);var i=new Function(\"d\",\"return {\"+t.map(function(t,e){return JSON.stringify(t)+\": d[\"+e+\"]\"}).join(\",\")+\"}\");n=e?function(t,r){return e(i(t),r)}:i})},r.parseRows=function(t,e){function r(){if(c>=u)return o;if(i)return i=!1,a;var e=c;if(34===t.charCodeAt(e)){for(var r=e;r++<u;)if(34===t.charCodeAt(r)){if(34!==t.charCodeAt(r+1))break;++r}c=r+2;var n=t.charCodeAt(r+1);return 13===n?(i=!0,10===t.charCodeAt(r+2)&&++c):10===n&&(i=!0),t.slice(e+1,r).replace(/\"\"/g,'\"')}for(;c<u;){var n=t.charCodeAt(c++),s=1;if(10===n)i=!0;else if(13===n)i=!0,10===t.charCodeAt(c)&&(++c,++s);else if(n!==l)continue;return t.slice(e,c-s)}return t.slice(e)}for(var n,i,a={},o={},s=[],u=t.length,c=0,h=0;(n=r())!==o;){for(var f=[];n!==a&&n!==o;)f.push(n),n=r();e&&null==(f=e(f,h++))||s.push(f)}return s},r.format=function(e){if(Array.isArray(e[0]))return r.formatRows(e);var n=new b,i=[];return e.forEach(function(t){for(var e in t)n.has(e)||i.push(n.add(e))}),[i.map(o).join(t)].concat(e.map(function(e){return i.map(function(t){return o(e[t])}).join(t)})).join(\"\\n\")},r.formatRows=function(t){return t.map(a).join(\"\\n\")},r},uo.csv=uo.dsv(\",\",\"text/csv\"),uo.tsv=uo.dsv(\"\\t\",\"text/tab-separated-values\");var is,as,os,ss,ls=this[w(this,\"requestAnimationFrame\")]||function(t){setTimeout(t,17)};uo.timer=function(){Dt.apply(this,arguments)},uo.timer.flush=function(){Ot(),Rt()},uo.round=function(t,e){return e?Math.round(t*(e=Math.pow(10,e)))/e:Math.round(t)};var us=[\"y\",\"z\",\"a\",\"f\",\"p\",\"n\",\"\\xb5\",\"m\",\"\",\"k\",\"M\",\"G\",\"T\",\"P\",\"E\",\"Z\",\"Y\"].map(jt);uo.formatPrefix=function(t,e){var r=0;return(t=+t)&&(t<0&&(t*=-1),e&&(t=uo.round(t,Ft(t,e))),r=1+Math.floor(1e-12+Math.log(t)/Math.LN10),r=Math.max(-24,Math.min(24,3*Math.floor((r-1)/3)))),us[8+r/3]};var cs=/(?:([^{])?([<>=^]))?([+\\- ])?([$#])?(0)?(\\d+)?(,)?(\\.-?\\d+)?([a-z%])?/i,hs=uo.map({b:function(t){return t.toString(2)},c:function(t){return String.fromCharCode(t)},o:function(t){return t.toString(8)},x:function(t){return t.toString(16)},X:function(t){return t.toString(16).toUpperCase()},g:function(t,e){return t.toPrecision(e)},e:function(t,e){return t.toExponential(e)},f:function(t,e){return t.toFixed(e)},r:function(t,e){return(t=uo.round(t,Ft(t,e))).toFixed(Math.max(0,Math.min(20,Ft(t*(1+1e-15),e))))}}),fs=uo.time={},ds=Date;Ut.prototype={getDate:function(){return this._.getUTCDate()},getDay:function(){return this._.getUTCDay()},getFullYear:function(){return this._.getUTCFullYear()},getHours:function(){return this._.getUTCHours()},getMilliseconds:function(){return this._.getUTCMilliseconds()},getMinutes:function(){return this._.getUTCMinutes()},getMonth:function(){return this._.getUTCMonth()},getSeconds:function(){return this._.getUTCSeconds()},getTime:function(){return this._.getTime()},getTimezoneOffset:function(){return 0},valueOf:function(){return this._.valueOf()},setDate:function(){ps.setUTCDate.apply(this._,arguments)},setDay:function(){ps.setUTCDay.apply(this._,arguments)},setFullYear:function(){ps.setUTCFullYear.apply(this._,arguments)},setHours:function(){ps.setUTCHours.apply(this._,arguments)},setMilliseconds:function(){ps.setUTCMilliseconds.apply(this._,arguments)},setMinutes:function(){ps.setUTCMinutes.apply(this._,arguments)},setMonth:function(){ps.setUTCMonth.apply(this._,arguments)},setSeconds:function(){ps.setUTCSeconds.apply(this._,arguments)},setTime:function(){ps.setTime.apply(this._,arguments)}};var ps=Date.prototype;fs.year=Vt(function(t){return t=fs.day(t),t.setMonth(0,1),t},function(t,e){t.setFullYear(t.getFullYear()+e)},function(t){return t.getFullYear()}),fs.years=fs.year.range,fs.years.utc=fs.year.utc.range,fs.day=Vt(function(t){var e=new ds(2e3,0);return e.setFullYear(t.getFullYear(),t.getMonth(),t.getDate()),e},function(t,e){t.setDate(t.getDate()+e)},function(t){return t.getDate()-1}),fs.days=fs.day.range,fs.days.utc=fs.day.utc.range,fs.dayOfYear=function(t){var e=fs.year(t);return Math.floor((t-e-6e4*(t.getTimezoneOffset()-e.getTimezoneOffset()))/864e5)},[\"sunday\",\"monday\",\"tuesday\",\"wednesday\",\"thursday\",\"friday\",\"saturday\"].forEach(function(t,e){e=7-e;var r=fs[t]=Vt(function(t){return(t=fs.day(t)).setDate(t.getDate()-(t.getDay()+e)%7),t},function(t,e){t.setDate(t.getDate()+7*Math.floor(e))},function(t){var r=fs.year(t).getDay();return Math.floor((fs.dayOfYear(t)+(r+e)%7)/7)-(r!==e)});fs[t+\"s\"]=r.range,fs[t+\"s\"].utc=r.utc.range,fs[t+\"OfYear\"]=function(t){var r=fs.year(t).getDay();return Math.floor((fs.dayOfYear(t)+(r+e)%7)/7)}}),fs.week=fs.sunday,fs.weeks=fs.sunday.range,fs.weeks.utc=fs.sunday.utc.range,fs.weekOfYear=fs.sundayOfYear;var ms={\"-\":\"\",_:\" \",0:\"0\"},vs=/^\\s*\\d+/,gs=/^%/;uo.locale=function(t){return{numberFormat:Nt(t),timeFormat:qt(t)}};var ys=uo.locale({decimal:\".\",thousands:\",\",grouping:[3],currency:[\"$\",\"\"],dateTime:\"%a %b %e %X %Y\",date:\"%m/%d/%Y\",time:\"%H:%M:%S\",periods:[\"AM\",\"PM\"],days:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],shortDays:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],months:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],shortMonths:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"]});uo.format=ys.numberFormat,uo.geo={},he.prototype={s:0,t:0,add:function(t){fe(t,this.t,bs),fe(bs.s,this.s,this),this.s?this.t+=bs.t:this.s=bs.t},reset:function(){this.s=this.t=0},valueOf:function(){return this.s}};var bs=new he;uo.geo.stream=function(t,e){t&&xs.hasOwnProperty(t.type)?xs[t.type](t,e):de(t,e)};var xs={Feature:function(t,e){de(t.geometry,e)},FeatureCollection:function(t,e){for(var r=t.features,n=-1,i=r.length;++n<i;)de(r[n].geometry,e)}},_s={Sphere:function(t,e){e.sphere()},Point:function(t,e){t=t.coordinates,e.point(t[0],t[1],t[2])},MultiPoint:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)t=r[n],e.point(t[0],t[1],t[2])},LineString:function(t,e){pe(t.coordinates,e,0)},MultiLineString:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)pe(r[n],e,0)},Polygon:function(t,e){me(t.coordinates,e)},MultiPolygon:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)me(r[n],e)},GeometryCollection:function(t,e){for(var r=t.geometries,n=-1,i=r.length;++n<i;)de(r[n],e)}};uo.geo.area=function(t){return ws=0,uo.geo.stream(t,ks),ws};var ws,Ms=new he,ks={sphere:function(){ws+=4*No},point:M,lineStart:M,lineEnd:M,polygonStart:function(){Ms.reset(),ks.lineStart=ve},polygonEnd:function(){var t=2*Ms;ws+=t<0?4*No+t:t,ks.lineStart=ks.lineEnd=ks.point=M}};uo.geo.bounds=function(){function t(t,e){b.push(x=[c=t,f=t]),e<h&&(h=e),e>d&&(d=e)}function e(e,r){var n=ge([e*Ho,r*Ho]);if(g){var i=be(g,n),a=[i[1],-i[0],0],o=be(a,i);we(o),o=Me(o);var l=e-p,u=l>0?1:-1,m=o[0]*qo*u,v=xo(l)>180;if(v^(u*p<m&&m<u*e)){var y=o[1]*qo;y>d&&(d=y)}else if(m=(m+360)%360-180,v^(u*p<m&&m<u*e)){var y=-o[1]*qo;y<h&&(h=y)}else r<h&&(h=r),r>d&&(d=r);v?e<p?s(c,e)>s(c,f)&&(f=e):s(e,f)>s(c,f)&&(c=e):f>=c?(e<c&&(c=e),e>f&&(f=e)):e>p?s(c,e)>s(c,f)&&(f=e):s(e,f)>s(c,f)&&(c=e)}else t(e,r);g=n,p=e}function r(){_.point=e}function n(){x[0]=c,x[1]=f,_.point=t,g=null}function i(t,r){if(g){var n=t-p;y+=xo(n)>180?n+(n>0?360:-360):n}else m=t,v=r;ks.point(t,r),e(t,r)}function a(){ks.lineStart()}function o(){i(m,v),ks.lineEnd(),xo(y)>Fo&&(c=-(f=180)),x[0]=c,x[1]=f,g=null}function s(t,e){return(e-=t)<0?e+360:e}function l(t,e){return t[0]-e[0]}function u(t,e){return e[0]<=e[1]?e[0]<=t&&t<=e[1]:t<e[0]||e[1]<t}var c,h,f,d,p,m,v,g,y,b,x,_={point:t,lineStart:r,lineEnd:n,polygonStart:function(){_.point=i,_.lineStart=a,_.lineEnd=o,y=0,ks.polygonStart()},polygonEnd:function(){ks.polygonEnd(),_.point=t,_.lineStart=r,_.lineEnd=n,Ms<0?(c=-(f=180),h=-(d=90)):y>Fo?d=90:y<-Fo&&(h=-90),x[0]=c,x[1]=f}};return function(t){d=f=-(c=h=1/0),b=[],uo.geo.stream(t,_);var e=b.length;if(e){b.sort(l);for(var r,n=1,i=b[0],a=[i];n<e;++n)r=b[n],u(r[0],i)||u(r[1],i)?(s(i[0],r[1])>s(i[0],i[1])&&(i[1]=r[1]),s(r[0],i[1])>s(i[0],i[1])&&(i[0]=r[0])):a.push(i=r);for(var o,r,p=-1/0,e=a.length-1,n=0,i=a[e];n<=e;i=r,++n)r=a[n],(o=s(i[1],r[0]))>p&&(p=o,c=r[0],f=i[1])}return b=x=null,c===1/0||h===1/0?[[NaN,NaN],[NaN,NaN]]:[[c,h],[f,d]]}}(),uo.geo.centroid=function(t){As=Ts=Ss=Es=Ls=Cs=zs=Is=Ds=Ps=Os=0,uo.geo.stream(t,Rs);var e=Ds,r=Ps,n=Os,i=e*e+r*r+n*n;return i<jo&&(e=Cs,r=zs,n=Is,Ts<Fo&&(e=Ss,r=Es,n=Ls),(i=e*e+r*r+n*n)<jo)?[NaN,NaN]:[Math.atan2(r,e)*qo,nt(n/Math.sqrt(i))*qo]};var As,Ts,Ss,Es,Ls,Cs,zs,Is,Ds,Ps,Os,Rs={sphere:M,point:Ae,lineStart:Se,lineEnd:Ee,polygonStart:function(){Rs.lineStart=Le},polygonEnd:function(){Rs.lineStart=Se}},Fs=Oe(ze,Ne,Ue,[-No,-No/2]),js=1e9;uo.geo.clipExtent=function(){var t,e,r,n,i,a,o={stream:function(t){return i&&(i.valid=!1),i=a(t),i.valid=!0,i},extent:function(s){return arguments.length?(a=Ge(t=+s[0][0],e=+s[0][1],r=+s[1][0],n=+s[1][1]),i&&(i.valid=!1,i=null),o):[[t,e],[r,n]]}};return o.extent([[0,0],[960,500]])},(uo.geo.conicEqualArea=function(){return Ye(Xe)}).raw=Xe,uo.geo.albers=function(){return uo.geo.conicEqualArea().rotate([96,0]).center([-.6,38.7]).parallels([29.5,45.5]).scale(1070)},uo.geo.albersUsa=function(){function t(t){var a=t[0],o=t[1];return e=null,r(a,o),e||(n(a,o),e)||i(a,o),e}var e,r,n,i,a=uo.geo.albers(),o=uo.geo.conicEqualArea().rotate([154,0]).center([-2,58.5]).parallels([55,65]),s=uo.geo.conicEqualArea().rotate([157,0]).center([-3,19.9]).parallels([8,18]),l={point:function(t,r){e=[t,r]}};return t.invert=function(t){var e=a.scale(),r=a.translate(),n=(t[0]-r[0])/e,i=(t[1]-r[1])/e;return(i>=.12&&i<.234&&n>=-.425&&n<-.214?o:i>=.166&&i<.234&&n>=-.214&&n<-.115?s:a).invert(t)},t.stream=function(t){var e=a.stream(t),r=o.stream(t),n=s.stream(t);return{point:function(t,i){e.point(t,i),r.point(t,i),n.point(t,i)},sphere:function(){e.sphere(),r.sphere(),n.sphere()},lineStart:function(){e.lineStart(),r.lineStart(),n.lineStart()},lineEnd:function(){e.lineEnd(),r.lineEnd(),n.lineEnd()},polygonStart:function(){e.polygonStart(),r.polygonStart(),n.polygonStart()},polygonEnd:function(){e.polygonEnd(),r.polygonEnd(),n.polygonEnd()}}},t.precision=function(e){return arguments.length?(a.precision(e),o.precision(e),s.precision(e),t):a.precision()},t.scale=function(e){return arguments.length?(a.scale(e),o.scale(.35*e),s.scale(e),t.translate(a.translate())):a.scale()},t.translate=function(e){if(!arguments.length)return a.translate();var u=a.scale(),c=+e[0],h=+e[1];return r=a.translate(e).clipExtent([[c-.455*u,h-.238*u],[c+.455*u,h+.238*u]]).stream(l).point,n=o.translate([c-.307*u,h+.201*u]).clipExtent([[c-.425*u+Fo,h+.12*u+Fo],[c-.214*u-Fo,h+.234*u-Fo]]).stream(l).point,i=s.translate([c-.205*u,h+.212*u]).clipExtent([[c-.214*u+Fo,h+.166*u+Fo],[c-.115*u-Fo,h+.234*u-Fo]]).stream(l).point,t},t.scale(1070)};var Ns,Bs,Us,Vs,Hs,qs,Gs={point:M,lineStart:M,lineEnd:M,polygonStart:function(){Bs=0,Gs.lineStart=We},polygonEnd:function(){Gs.lineStart=Gs.lineEnd=Gs.point=M,Ns+=xo(Bs/2)}},Ys={point:Ze,lineStart:M,lineEnd:M,polygonStart:M,polygonEnd:M},Xs={point:Qe,lineStart:$e,lineEnd:tr,polygonStart:function(){Xs.lineStart=er},polygonEnd:function(){Xs.point=Qe,Xs.lineStart=$e,Xs.lineEnd=tr}};uo.geo.path=function(){function t(t){return t&&(\"function\"==typeof s&&a.pointRadius(+s.apply(this,arguments)),o&&o.valid||(o=i(a)),uo.geo.stream(t,o)),a.result()}function e(){return o=null,t}var r,n,i,a,o,s=4.5;return t.area=function(t){return Ns=0,uo.geo.stream(t,i(Gs)),Ns},t.centroid=function(t){return Ss=Es=Ls=Cs=zs=Is=Ds=Ps=Os=0,uo.geo.stream(t,i(Xs)),Os?[Ds/Os,Ps/Os]:Is?[Cs/Is,zs/Is]:Ls?[Ss/Ls,Es/Ls]:[NaN,NaN]},t.bounds=function(t){return Hs=qs=-(Us=Vs=1/0),uo.geo.stream(t,i(Ys)),[[Us,Vs],[Hs,qs]]},t.projection=function(t){return arguments.length?(i=(r=t)?t.stream||ir(t):x,e()):r},t.context=function(t){return arguments.length?(a=null==(n=t)?new Je:new rr(t),\"function\"!=typeof s&&a.pointRadius(s),e()):n},t.pointRadius=function(e){return arguments.length?(s=\"function\"==typeof e?e:(a.pointRadius(+e),+e),t):s},t.projection(uo.geo.albersUsa()).context(null)},uo.geo.transform=function(t){return{stream:function(e){var r=new ar(e);for(var n in t)r[n]=t[n];return r}}},ar.prototype={point:function(t,e){this.stream.point(t,e)},sphere:function(){this.stream.sphere()},lineStart:function(){this.stream.lineStart()},lineEnd:function(){this.stream.lineEnd()},polygonStart:function(){this.stream.polygonStart()},polygonEnd:function(){this.stream.polygonEnd()}},uo.geo.projection=sr,uo.geo.projectionMutator=lr,(uo.geo.equirectangular=function(){return sr(cr)}).raw=cr.invert=cr,uo.geo.rotation=function(t){function e(e){return e=t(e[0]*Ho,e[1]*Ho),e[0]*=qo,e[1]*=qo,e}return t=fr(t[0]%360*Ho,t[1]*Ho,t.length>2?t[2]*Ho:0),e.invert=function(e){return e=t.invert(e[0]*Ho,e[1]*Ho),e[0]*=qo,e[1]*=qo,e},e},hr.invert=cr,uo.geo.circle=function(){function t(){var t=\"function\"==typeof n?n.apply(this,arguments):n,e=fr(-t[0]*Ho,-t[1]*Ho,0).invert,i=[];return r(null,null,1,{point:function(t,r){i.push(t=e(t,r)),t[0]*=qo,t[1]*=qo}}),{type:\"Polygon\",coordinates:[i]}}var e,r,n=[0,0],i=6;return t.origin=function(e){return arguments.length?(n=e,t):n},t.angle=function(n){return arguments.length?(r=vr((e=+n)*Ho,i*Ho),t):e},t.precision=function(n){return arguments.length?(r=vr(e*Ho,(i=+n)*Ho),t):i},t.angle(90)},uo.geo.distance=function(t,e){var r,n=(e[0]-t[0])*Ho,i=t[1]*Ho,a=e[1]*Ho,o=Math.sin(n),s=Math.cos(n),l=Math.sin(i),u=Math.cos(i),c=Math.sin(a),h=Math.cos(a);return Math.atan2(Math.sqrt((r=h*o)*r+(r=u*c-l*h*s)*r),l*c+u*h*s)},uo.geo.graticule=function(){function t(){return{type:\"MultiLineString\",coordinates:e()}}function e(){return uo.range(Math.ceil(a/v)*v,i,v).map(f).concat(uo.range(Math.ceil(u/g)*g,l,g).map(d)).concat(uo.range(Math.ceil(n/p)*p,r,p).filter(function(t){return xo(t%v)>Fo}).map(c)).concat(uo.range(Math.ceil(s/m)*m,o,m).filter(function(t){return xo(t%g)>Fo}).map(h))}var r,n,i,a,o,s,l,u,c,h,f,d,p=10,m=p,v=90,g=360,y=2.5;return t.lines=function(){return e().map(function(t){return{type:\"LineString\",coordinates:t}})},t.outline=function(){return{type:\"Polygon\",coordinates:[f(a).concat(d(l).slice(1),f(i).reverse().slice(1),d(u).reverse().slice(1))]}},t.extent=function(e){return arguments.length?t.majorExtent(e).minorExtent(e):t.minorExtent()},t.majorExtent=function(e){return arguments.length?(a=+e[0][0],i=+e[1][0],u=+e[0][1],l=+e[1][1],a>i&&(e=a,a=i,i=e),u>l&&(e=u,u=l,l=e),t.precision(y)):[[a,u],[i,l]]},t.minorExtent=function(e){return arguments.length?(n=+e[0][0],r=+e[1][0],s=+e[0][1],o=+e[1][1],n>r&&(e=n,n=r,r=e),s>o&&(e=s,s=o,o=e),t.precision(y)):[[n,s],[r,o]]},t.step=function(e){return arguments.length?t.majorStep(e).minorStep(e):t.minorStep()},t.majorStep=function(e){return arguments.length?(v=+e[0],g=+e[1],t):[v,g]},t.minorStep=function(e){return arguments.length?(p=+e[0],m=+e[1],t):[p,m]},t.precision=function(e){\n",
       "return arguments.length?(y=+e,c=yr(s,o,90),h=br(n,r,y),f=yr(u,l,90),d=br(a,i,y),t):y},t.majorExtent([[-180,-90+Fo],[180,90-Fo]]).minorExtent([[-180,-80-Fo],[180,80+Fo]])},uo.geo.greatArc=function(){function t(){return{type:\"LineString\",coordinates:[e||n.apply(this,arguments),r||i.apply(this,arguments)]}}var e,r,n=xr,i=_r;return t.distance=function(){return uo.geo.distance(e||n.apply(this,arguments),r||i.apply(this,arguments))},t.source=function(r){return arguments.length?(n=r,e=\"function\"==typeof r?null:r,t):n},t.target=function(e){return arguments.length?(i=e,r=\"function\"==typeof e?null:e,t):i},t.precision=function(){return arguments.length?t:0},t},uo.geo.interpolate=function(t,e){return wr(t[0]*Ho,t[1]*Ho,e[0]*Ho,e[1]*Ho)},uo.geo.length=function(t){return Ws=0,uo.geo.stream(t,Zs),Ws};var Ws,Zs={sphere:M,point:M,lineStart:Mr,lineEnd:M,polygonStart:M,polygonEnd:M},Js=kr(function(t){return Math.sqrt(2/(1+t))},function(t){return 2*Math.asin(t/2)});(uo.geo.azimuthalEqualArea=function(){return sr(Js)}).raw=Js;var Ks=kr(function(t){var e=Math.acos(t);return e&&e/Math.sin(e)},x);(uo.geo.azimuthalEquidistant=function(){return sr(Ks)}).raw=Ks,(uo.geo.conicConformal=function(){return Ye(Ar)}).raw=Ar,(uo.geo.conicEquidistant=function(){return Ye(Tr)}).raw=Tr;var Qs=kr(function(t){return 1/t},Math.atan);(uo.geo.gnomonic=function(){return sr(Qs)}).raw=Qs,Sr.invert=function(t,e){return[t,2*Math.atan(Math.exp(e))-Vo]},(uo.geo.mercator=function(){return Er(Sr)}).raw=Sr;var $s=kr(function(){return 1},Math.asin);(uo.geo.orthographic=function(){return sr($s)}).raw=$s;var tl=kr(function(t){return 1/(1+t)},function(t){return 2*Math.atan(t)});(uo.geo.stereographic=function(){return sr(tl)}).raw=tl,Lr.invert=function(t,e){return[-e,2*Math.atan(Math.exp(t))-Vo]},(uo.geo.transverseMercator=function(){var t=Er(Lr),e=t.center,r=t.rotate;return t.center=function(t){return t?e([-t[1],t[0]]):(t=e(),[t[1],-t[0]])},t.rotate=function(t){return t?r([t[0],t[1],t.length>2?t[2]+90:90]):(t=r(),[t[0],t[1],t[2]-90])},r([0,0,90])}).raw=Lr,uo.geom={},uo.geom.hull=function(t){function e(t){if(t.length<3)return[];var e,i=Et(r),a=Et(n),o=t.length,s=[],l=[];for(e=0;e<o;e++)s.push([+i.call(this,t[e],e),+a.call(this,t[e],e),e]);for(s.sort(Dr),e=0;e<o;e++)l.push([s[e][0],-s[e][1]]);var u=Ir(s),c=Ir(l),h=c[0]===u[0],f=c[c.length-1]===u[u.length-1],d=[];for(e=u.length-1;e>=0;--e)d.push(t[s[u[e]][2]]);for(e=+h;e<c.length-f;++e)d.push(t[s[c[e]][2]]);return d}var r=Cr,n=zr;return arguments.length?e(t):(e.x=function(t){return arguments.length?(r=t,e):r},e.y=function(t){return arguments.length?(n=t,e):n},e)},uo.geom.polygon=function(t){return Ao(t,el),t};var el=uo.geom.polygon.prototype=[];el.area=function(){for(var t,e=-1,r=this.length,n=this[r-1],i=0;++e<r;)t=n,n=this[e],i+=t[1]*n[0]-t[0]*n[1];return.5*i},el.centroid=function(t){var e,r,n=-1,i=this.length,a=0,o=0,s=this[i-1];for(arguments.length||(t=-1/(6*this.area()));++n<i;)e=s,s=this[n],r=e[0]*s[1]-s[0]*e[1],a+=(e[0]+s[0])*r,o+=(e[1]+s[1])*r;return[a*t,o*t]},el.clip=function(t){for(var e,r,n,i,a,o,s=Rr(t),l=-1,u=this.length-Rr(this),c=this[u-1];++l<u;){for(e=t.slice(),t.length=0,i=this[l],a=e[(n=e.length-s)-1],r=-1;++r<n;)o=e[r],Pr(o,c,i)?(Pr(a,c,i)||t.push(Or(a,o,c,i)),t.push(o)):Pr(a,c,i)&&t.push(Or(a,o,c,i)),a=o;s&&t.push(t[0]),c=i}return t};var rl,nl,il,al,ol,sl=[],ll=[];qr.prototype.prepare=function(){for(var t,e=this.edges,r=e.length;r--;)t=e[r].edge,t.b&&t.a||e.splice(r,1);return e.sort(Yr),e.length},rn.prototype={start:function(){return this.edge.l===this.site?this.edge.a:this.edge.b},end:function(){return this.edge.l===this.site?this.edge.b:this.edge.a}},nn.prototype={insert:function(t,e){var r,n,i;if(t){if(e.P=t,e.N=t.N,t.N&&(t.N.P=e),t.N=e,t.R){for(t=t.R;t.L;)t=t.L;t.L=e}else t.R=e;r=t}else this._?(t=ln(this._),e.P=null,e.N=t,t.P=t.L=e,r=t):(e.P=e.N=null,this._=e,r=null);for(e.L=e.R=null,e.U=r,e.C=!0,t=e;r&&r.C;)n=r.U,r===n.L?(i=n.R,i&&i.C?(r.C=i.C=!1,n.C=!0,t=n):(t===r.R&&(on(this,r),t=r,r=t.U),r.C=!1,n.C=!0,sn(this,n))):(i=n.L,i&&i.C?(r.C=i.C=!1,n.C=!0,t=n):(t===r.L&&(sn(this,r),t=r,r=t.U),r.C=!1,n.C=!0,on(this,n))),r=t.U;this._.C=!1},remove:function(t){t.N&&(t.N.P=t.P),t.P&&(t.P.N=t.N),t.N=t.P=null;var e,r,n,i=t.U,a=t.L,o=t.R;if(r=a?o?ln(o):a:o,i?i.L===t?i.L=r:i.R=r:this._=r,a&&o?(n=r.C,r.C=t.C,r.L=a,a.U=r,r!==o?(i=r.U,r.U=t.U,t=r.R,i.L=t,r.R=o,o.U=r):(r.U=i,i=r,t=r.R)):(n=t.C,t=r),t&&(t.U=i),!n){if(t&&t.C)return void(t.C=!1);do{if(t===this._)break;if(t===i.L){if(e=i.R,e.C&&(e.C=!1,i.C=!0,on(this,i),e=i.R),e.L&&e.L.C||e.R&&e.R.C){e.R&&e.R.C||(e.L.C=!1,e.C=!0,sn(this,e),e=i.R),e.C=i.C,i.C=e.R.C=!1,on(this,i),t=this._;break}}else if(e=i.L,e.C&&(e.C=!1,i.C=!0,sn(this,i),e=i.L),e.L&&e.L.C||e.R&&e.R.C){e.L&&e.L.C||(e.R.C=!1,e.C=!0,on(this,e),e=i.L),e.C=i.C,i.C=e.L.C=!1,sn(this,i),t=this._;break}e.C=!0,t=i,i=i.U}while(!t.C);t&&(t.C=!1)}}},uo.geom.voronoi=function(t){function e(t){var e=new Array(t.length),n=s[0][0],i=s[0][1],a=s[1][0],o=s[1][1];return un(r(t),s).cells.forEach(function(r,s){var l=r.edges,u=r.site;(e[s]=l.length?l.map(function(t){var e=t.start();return[e.x,e.y]}):u.x>=n&&u.x<=a&&u.y>=i&&u.y<=o?[[n,o],[a,o],[a,i],[n,i]]:[]).point=t[s]}),e}function r(t){return t.map(function(t,e){return{x:Math.round(a(t,e)/Fo)*Fo,y:Math.round(o(t,e)/Fo)*Fo,i:e}})}var n=Cr,i=zr,a=n,o=i,s=ul;return t?e(t):(e.links=function(t){return un(r(t)).edges.filter(function(t){return t.l&&t.r}).map(function(e){return{source:t[e.l.i],target:t[e.r.i]}})},e.triangles=function(t){var e=[];return un(r(t)).cells.forEach(function(r,n){for(var i,a=r.site,o=r.edges.sort(Yr),s=-1,l=o.length,u=o[l-1].edge,c=u.l===a?u.r:u.l;++s<l;)u,i=c,u=o[s].edge,c=u.l===a?u.r:u.l,n<i.i&&n<c.i&&hn(a,i,c)<0&&e.push([t[n],t[i.i],t[c.i]])}),e},e.x=function(t){return arguments.length?(a=Et(n=t),e):n},e.y=function(t){return arguments.length?(o=Et(i=t),e):i},e.clipExtent=function(t){return arguments.length?(s=null==t?ul:t,e):s===ul?null:s},e.size=function(t){return arguments.length?e.clipExtent(t&&[[0,0],t]):s===ul?null:s&&s[1]},e)};var ul=[[-1e6,-1e6],[1e6,1e6]];uo.geom.delaunay=function(t){return uo.geom.voronoi().triangles(t)},uo.geom.quadtree=function(t,e,r,n,i){function a(t){function a(t,e,r,n,i,a,o,s){if(!isNaN(r)&&!isNaN(n))if(t.leaf){var l=t.x,c=t.y;if(null!=l)if(xo(l-r)+xo(c-n)<.01)u(t,e,r,n,i,a,o,s);else{var h=t.point;t.x=t.y=t.point=null,u(t,h,l,c,i,a,o,s),u(t,e,r,n,i,a,o,s)}else t.x=r,t.y=n,t.point=e}else u(t,e,r,n,i,a,o,s)}function u(t,e,r,n,i,o,s,l){var u=.5*(i+s),c=.5*(o+l),h=r>=u,f=n>=c,d=f<<1|h;t.leaf=!1,t=t.nodes[d]||(t.nodes[d]=pn()),h?i=u:s=u,f?o=c:l=c,a(t,e,r,n,i,o,s,l)}var c,h,f,d,p,m,v,g,y,b=Et(s),x=Et(l);if(null!=e)m=e,v=r,g=n,y=i;else if(g=y=-(m=v=1/0),h=[],f=[],p=t.length,o)for(d=0;d<p;++d)c=t[d],c.x<m&&(m=c.x),c.y<v&&(v=c.y),c.x>g&&(g=c.x),c.y>y&&(y=c.y),h.push(c.x),f.push(c.y);else for(d=0;d<p;++d){var _=+b(c=t[d],d),w=+x(c,d);_<m&&(m=_),w<v&&(v=w),_>g&&(g=_),w>y&&(y=w),h.push(_),f.push(w)}var M=g-m,k=y-v;M>k?y=v+M:g=m+k;var A=pn();if(A.add=function(t){a(A,t,+b(t,++d),+x(t,d),m,v,g,y)},A.visit=function(t){mn(t,A,m,v,g,y)},A.find=function(t){return vn(A,t[0],t[1],m,v,g,y)},d=-1,null==e){for(;++d<p;)a(A,t[d],h[d],f[d],m,v,g,y);--d}else t.forEach(A.add);return h=f=t=c=null,A}var o,s=Cr,l=zr;return(o=arguments.length)?(s=fn,l=dn,3===o&&(i=r,n=e,r=e=0),a(t)):(a.x=function(t){return arguments.length?(s=t,a):s},a.y=function(t){return arguments.length?(l=t,a):l},a.extent=function(t){return arguments.length?(null==t?e=r=n=i=null:(e=+t[0][0],r=+t[0][1],n=+t[1][0],i=+t[1][1]),a):null==e?null:[[e,r],[n,i]]},a.size=function(t){return arguments.length?(null==t?e=r=n=i=null:(e=r=0,n=+t[0],i=+t[1]),a):null==e?null:[n-e,i-r]},a)},uo.interpolateRgb=gn,uo.interpolateObject=yn,uo.interpolateNumber=bn,uo.interpolateString=xn;var cl=/[-+]?(?:\\d+\\.?\\d*|\\.?\\d+)(?:[eE][-+]?\\d+)?/g,hl=new RegExp(cl.source,\"g\");uo.interpolate=_n,uo.interpolators=[function(t,e){var r=typeof e;return(\"string\"===r?ns.has(e.toLowerCase())||/^(#|rgb\\(|hsl\\()/i.test(e)?gn:xn:e instanceof lt?gn:Array.isArray(e)?wn:\"object\"===r&&isNaN(e)?yn:bn)(t,e)}],uo.interpolateArray=wn;var fl=function(){return x},dl=uo.map({linear:fl,poly:Ln,quad:function(){return Tn},cubic:function(){return Sn},sin:function(){return Cn},exp:function(){return zn},circle:function(){return In},elastic:Dn,back:Pn,bounce:function(){return On}}),pl=uo.map({in:x,out:kn,\"in-out\":An,\"out-in\":function(t){return An(kn(t))}});uo.ease=function(t){var e=t.indexOf(\"-\"),r=e>=0?t.slice(0,e):t,n=e>=0?t.slice(e+1):\"in\";return r=dl.get(r)||fl,n=pl.get(n)||x,Mn(n(r.apply(null,co.call(arguments,1))))},uo.interpolateHcl=Rn,uo.interpolateHsl=Fn,uo.interpolateLab=jn,uo.interpolateRound=Nn,uo.transform=function(t){var e=fo.createElementNS(uo.ns.prefix.svg,\"g\");return(uo.transform=function(t){if(null!=t){e.setAttribute(\"transform\",t);var r=e.transform.baseVal.consolidate()}return new Bn(r?r.matrix:ml)})(t)},Bn.prototype.toString=function(){return\"translate(\"+this.translate+\")rotate(\"+this.rotate+\")skewX(\"+this.skew+\")scale(\"+this.scale+\")\"};var ml={a:1,b:0,c:0,d:1,e:0,f:0};uo.interpolateTransform=Zn,uo.layout={},uo.layout.bundle=function(){return function(t){for(var e=[],r=-1,n=t.length;++r<n;)e.push(Qn(t[r]));return e}},uo.layout.chord=function(){function t(){var t,u,h,f,d,p={},m=[],v=uo.range(a),g=[];for(r=[],n=[],t=0,f=-1;++f<a;){for(u=0,d=-1;++d<a;)u+=i[f][d];m.push(u),g.push(uo.range(a)),t+=u}for(o&&v.sort(function(t,e){return o(m[t],m[e])}),s&&g.forEach(function(t,e){t.sort(function(t,r){return s(i[e][t],i[e][r])})}),t=(Bo-c*a)/t,u=0,f=-1;++f<a;){for(h=u,d=-1;++d<a;){var y=v[f],b=g[y][d],x=i[y][b],_=u,w=u+=x*t;p[y+\"-\"+b]={index:y,subindex:b,startAngle:_,endAngle:w,value:x}}n[y]={index:y,startAngle:h,endAngle:u,value:m[y]},u+=c}for(f=-1;++f<a;)for(d=f-1;++d<a;){var M=p[f+\"-\"+d],k=p[d+\"-\"+f];(M.value||k.value)&&r.push(M.value<k.value?{source:k,target:M}:{source:M,target:k})}l&&e()}function e(){r.sort(function(t,e){return l((t.source.value+t.target.value)/2,(e.source.value+e.target.value)/2)})}var r,n,i,a,o,s,l,u={},c=0;return u.matrix=function(t){return arguments.length?(a=(i=t)&&i.length,r=n=null,u):i},u.padding=function(t){return arguments.length?(c=t,r=n=null,u):c},u.sortGroups=function(t){return arguments.length?(o=t,r=n=null,u):o},u.sortSubgroups=function(t){return arguments.length?(s=t,r=null,u):s},u.sortChords=function(t){return arguments.length?(l=t,r&&e(),u):l},u.chords=function(){return r||t(),r},u.groups=function(){return n||t(),n},u},uo.layout.force=function(){function t(t){return function(e,r,n,i){if(e.point!==t){var a=e.cx-t.x,o=e.cy-t.y,s=i-r,l=a*a+o*o;if(s*s/g<l){if(l<m){var u=e.charge/l;t.px-=a*u,t.py-=o*u}return!0}if(e.point&&l&&l<m){var u=e.pointCharge/l;t.px-=a*u,t.py-=o*u}}return!e.charge}}function e(t){t.px=uo.event.x,t.py=uo.event.y,l.resume()}var r,n,i,a,o,s,l={},u=uo.dispatch(\"start\",\"tick\",\"end\"),c=[1,1],h=.9,f=vl,d=gl,p=-30,m=yl,v=.1,g=.64,y=[],b=[];return l.tick=function(){if((i*=.99)<.005)return r=null,u.end({type:\"end\",alpha:i=0}),!0;var e,n,l,f,d,m,g,x,_,w=y.length,M=b.length;for(n=0;n<M;++n)l=b[n],f=l.source,d=l.target,x=d.x-f.x,_=d.y-f.y,(m=x*x+_*_)&&(m=i*o[n]*((m=Math.sqrt(m))-a[n])/m,x*=m,_*=m,d.x-=x*(g=f.weight+d.weight?f.weight/(f.weight+d.weight):.5),d.y-=_*g,f.x+=x*(g=1-g),f.y+=_*g);if((g=i*v)&&(x=c[0]/2,_=c[1]/2,n=-1,g))for(;++n<w;)l=y[n],l.x+=(x-l.x)*g,l.y+=(_-l.y)*g;if(p)for(ai(e=uo.geom.quadtree(y),i,s),n=-1;++n<w;)(l=y[n]).fixed||e.visit(t(l));for(n=-1;++n<w;)l=y[n],l.fixed?(l.x=l.px,l.y=l.py):(l.x-=(l.px-(l.px=l.x))*h,l.y-=(l.py-(l.py=l.y))*h);u.tick({type:\"tick\",alpha:i})},l.nodes=function(t){return arguments.length?(y=t,l):y},l.links=function(t){return arguments.length?(b=t,l):b},l.size=function(t){return arguments.length?(c=t,l):c},l.linkDistance=function(t){return arguments.length?(f=\"function\"==typeof t?t:+t,l):f},l.distance=l.linkDistance,l.linkStrength=function(t){return arguments.length?(d=\"function\"==typeof t?t:+t,l):d},l.friction=function(t){return arguments.length?(h=+t,l):h},l.charge=function(t){return arguments.length?(p=\"function\"==typeof t?t:+t,l):p},l.chargeDistance=function(t){return arguments.length?(m=t*t,l):Math.sqrt(m)},l.gravity=function(t){return arguments.length?(v=+t,l):v},l.theta=function(t){return arguments.length?(g=t*t,l):Math.sqrt(g)},l.alpha=function(t){return arguments.length?(t=+t,i?t>0?i=t:(r.c=null,r.t=NaN,r=null,u.end({type:\"end\",alpha:i=0})):t>0&&(u.start({type:\"start\",alpha:i=t}),r=Dt(l.tick)),l):i},l.start=function(){function t(t,n){if(!r){for(r=new Array(i),l=0;l<i;++l)r[l]=[];for(l=0;l<u;++l){var a=b[l];r[a.source.index].push(a.target),r[a.target.index].push(a.source)}}for(var o,s=r[e],l=-1,c=s.length;++l<c;)if(!isNaN(o=s[l][t]))return o;return Math.random()*n}var e,r,n,i=y.length,u=b.length,h=c[0],m=c[1];for(e=0;e<i;++e)(n=y[e]).index=e,n.weight=0;for(e=0;e<u;++e)n=b[e],\"number\"==typeof n.source&&(n.source=y[n.source]),\"number\"==typeof n.target&&(n.target=y[n.target]),++n.source.weight,++n.target.weight;for(e=0;e<i;++e)n=y[e],isNaN(n.x)&&(n.x=t(\"x\",h)),isNaN(n.y)&&(n.y=t(\"y\",m)),isNaN(n.px)&&(n.px=n.x),isNaN(n.py)&&(n.py=n.y);if(a=[],\"function\"==typeof f)for(e=0;e<u;++e)a[e]=+f.call(this,b[e],e);else for(e=0;e<u;++e)a[e]=f;if(o=[],\"function\"==typeof d)for(e=0;e<u;++e)o[e]=+d.call(this,b[e],e);else for(e=0;e<u;++e)o[e]=d;if(s=[],\"function\"==typeof p)for(e=0;e<i;++e)s[e]=+p.call(this,y[e],e);else for(e=0;e<i;++e)s[e]=p;return l.resume()},l.resume=function(){return l.alpha(.1)},l.stop=function(){return l.alpha(0)},l.drag=function(){if(n||(n=uo.behavior.drag().origin(x).on(\"dragstart.force\",ei).on(\"drag.force\",e).on(\"dragend.force\",ri)),!arguments.length)return n;this.on(\"mouseover.force\",ni).on(\"mouseout.force\",ii).call(n)},uo.rebind(l,u,\"on\")};var vl=20,gl=1,yl=1/0;uo.layout.hierarchy=function(){function t(i){var a,o=[i],s=[];for(i.depth=0;null!=(a=o.pop());)if(s.push(a),(u=r.call(t,a,a.depth))&&(l=u.length)){for(var l,u,c;--l>=0;)o.push(c=u[l]),c.parent=a,c.depth=a.depth+1;n&&(a.value=0),a.children=u}else n&&(a.value=+n.call(t,a,a.depth)||0),delete a.children;return li(i,function(t){var r,i;e&&(r=t.children)&&r.sort(e),n&&(i=t.parent)&&(i.value+=t.value)}),s}var e=hi,r=ui,n=ci;return t.sort=function(r){return arguments.length?(e=r,t):e},t.children=function(e){return arguments.length?(r=e,t):r},t.value=function(e){return arguments.length?(n=e,t):n},t.revalue=function(e){return n&&(si(e,function(t){t.children&&(t.value=0)}),li(e,function(e){var r;e.children||(e.value=+n.call(t,e,e.depth)||0),(r=e.parent)&&(r.value+=e.value)})),e},t},uo.layout.partition=function(){function t(e,r,n,i){var a=e.children;if(e.x=r,e.y=e.depth*i,e.dx=n,e.dy=i,a&&(o=a.length)){var o,s,l,u=-1;for(n=e.value?n/e.value:0;++u<o;)t(s=a[u],r,l=s.value*n,i),r+=l}}function e(t){var r=t.children,n=0;if(r&&(i=r.length))for(var i,a=-1;++a<i;)n=Math.max(n,e(r[a]));return 1+n}function r(r,a){var o=n.call(this,r,a);return t(o[0],0,i[0],i[1]/e(o[0])),o}var n=uo.layout.hierarchy(),i=[1,1];return r.size=function(t){return arguments.length?(i=t,r):i},oi(r,n)},uo.layout.pie=function(){function t(o){var s,l=o.length,u=o.map(function(r,n){return+e.call(t,r,n)}),c=+(\"function\"==typeof n?n.apply(this,arguments):n),h=(\"function\"==typeof i?i.apply(this,arguments):i)-c,f=Math.min(Math.abs(h)/l,+(\"function\"==typeof a?a.apply(this,arguments):a)),d=f*(h<0?-1:1),p=uo.sum(u),m=p?(h-l*d)/p:0,v=uo.range(l),g=[];return null!=r&&v.sort(r===bl?function(t,e){return u[e]-u[t]}:function(t,e){return r(o[t],o[e])}),v.forEach(function(t){g[t]={data:o[t],value:s=u[t],startAngle:c,endAngle:c+=s*m+d,padAngle:f}}),g}var e=Number,r=bl,n=0,i=Bo,a=0;return t.value=function(r){return arguments.length?(e=r,t):e},t.sort=function(e){return arguments.length?(r=e,t):r},t.startAngle=function(e){return arguments.length?(n=e,t):n},t.endAngle=function(e){return arguments.length?(i=e,t):i},t.padAngle=function(e){return arguments.length?(a=e,t):a},t};var bl={};uo.layout.stack=function(){function t(s,l){if(!(f=s.length))return s;var u=s.map(function(r,n){return e.call(t,r,n)}),c=u.map(function(e){return e.map(function(e,r){return[a.call(t,e,r),o.call(t,e,r)]})}),h=r.call(t,c,l);u=uo.permute(u,h),c=uo.permute(c,h);var f,d,p,m,v=n.call(t,c,l),g=u[0].length;for(p=0;p<g;++p)for(i.call(t,u[0][p],m=v[p],c[0][p][1]),d=1;d<f;++d)i.call(t,u[d][p],m+=c[d-1][p][1],c[d][p][1]);return s}var e=x,r=vi,n=gi,i=mi,a=di,o=pi;return t.values=function(r){return arguments.length?(e=r,t):e},t.order=function(e){return arguments.length?(r=\"function\"==typeof e?e:xl.get(e)||vi,t):r},t.offset=function(e){return arguments.length?(n=\"function\"==typeof e?e:_l.get(e)||gi,t):n},t.x=function(e){return arguments.length?(a=e,t):a},t.y=function(e){return arguments.length?(o=e,t):o},t.out=function(e){return arguments.length?(i=e,t):i},t};var xl=uo.map({\"inside-out\":function(t){var e,r,n=t.length,i=t.map(yi),a=t.map(bi),o=uo.range(n).sort(function(t,e){return i[t]-i[e]}),s=0,l=0,u=[],c=[];for(e=0;e<n;++e)r=o[e],s<l?(s+=a[r],u.push(r)):(l+=a[r],c.push(r));return c.reverse().concat(u)},reverse:function(t){return uo.range(t.length).reverse()},default:vi}),_l=uo.map({silhouette:function(t){var e,r,n,i=t.length,a=t[0].length,o=[],s=0,l=[];for(r=0;r<a;++r){for(e=0,n=0;e<i;e++)n+=t[e][r][1];n>s&&(s=n),o.push(n)}for(r=0;r<a;++r)l[r]=(s-o[r])/2;return l},wiggle:function(t){var e,r,n,i,a,o,s,l,u,c=t.length,h=t[0],f=h.length,d=[];for(d[0]=l=u=0,r=1;r<f;++r){for(e=0,i=0;e<c;++e)i+=t[e][r][1];for(e=0,a=0,s=h[r][0]-h[r-1][0];e<c;++e){for(n=0,o=(t[e][r][1]-t[e][r-1][1])/(2*s);n<e;++n)o+=(t[n][r][1]-t[n][r-1][1])/s;a+=o*t[e][r][1]}d[r]=l-=i?a/i*s:0,l<u&&(u=l)}for(r=0;r<f;++r)d[r]-=u;return d},expand:function(t){var e,r,n,i=t.length,a=t[0].length,o=1/i,s=[];for(r=0;r<a;++r){for(e=0,n=0;e<i;e++)n+=t[e][r][1];if(n)for(e=0;e<i;e++)t[e][r][1]/=n;else for(e=0;e<i;e++)t[e][r][1]=o}for(r=0;r<a;++r)s[r]=0;return s},zero:gi});uo.layout.histogram=function(){function t(t,a){for(var o,s,l=[],u=t.map(r,this),c=n.call(this,u,a),h=i.call(this,c,u,a),a=-1,f=u.length,d=h.length-1,p=e?1:1/f;++a<d;)o=l[a]=[],o.dx=h[a+1]-(o.x=h[a]),o.y=0;if(d>0)for(a=-1;++a<f;)(s=u[a])>=c[0]&&s<=c[1]&&(o=l[uo.bisect(h,s,1,d)-1],o.y+=p,o.push(t[a]));return l}var e=!0,r=Number,n=Mi,i=_i;return t.value=function(e){return arguments.length?(r=e,t):r},t.range=function(e){return arguments.length?(n=Et(e),t):n},t.bins=function(e){return arguments.length?(i=\"number\"==typeof e?function(t){return wi(t,e)}:Et(e),t):i},t.frequency=function(r){return arguments.length?(e=!!r,t):e},t},uo.layout.pack=function(){function t(t,a){var o=r.call(this,t,a),s=o[0],l=i[0],u=i[1],c=null==e?Math.sqrt:\"function\"==typeof e?e:function(){return e};if(s.x=s.y=0,li(s,function(t){t.r=+c(t.value)}),li(s,Ei),n){var h=n*(e?1:Math.max(2*s.r/l,2*s.r/u))/2;li(s,function(t){t.r+=h}),li(s,Ei),li(s,function(t){t.r-=h})}return zi(s,l/2,u/2,e?1:1/Math.max(2*s.r/l,2*s.r/u)),o}var e,r=uo.layout.hierarchy().sort(ki),n=0,i=[1,1];return t.size=function(e){return arguments.length?(i=e,t):i},t.radius=function(r){return arguments.length?(e=null==r||\"function\"==typeof r?r:+r,t):e},t.padding=function(e){return arguments.length?(n=+e,t):n},oi(t,r)},uo.layout.tree=function(){function t(t,i){var c=o.call(this,t,i),h=c[0],f=e(h);if(li(f,r),f.parent.m=-f.z,si(f,n),u)si(h,a);else{var d=h,p=h,m=h;si(h,function(t){t.x<d.x&&(d=t),t.x>p.x&&(p=t),t.depth>m.depth&&(m=t)});var v=s(d,p)/2-d.x,g=l[0]/(p.x+s(p,d)/2+v),y=l[1]/(m.depth||1);si(h,function(t){t.x=(t.x+v)*g,t.y=t.depth*y})}return c}function e(t){for(var e,r={A:null,children:[t]},n=[r];null!=(e=n.pop());)for(var i,a=e.children,o=0,s=a.length;o<s;++o)n.push((a[o]=i={_:a[o],parent:e,children:(i=a[o].children)&&i.slice()||[],A:null,a:null,z:0,m:0,c:0,s:0,t:null,i:o}).a=i);return r.children[0]}function r(t){var e=t.children,r=t.parent.children,n=t.i?r[t.i-1]:null;if(e.length){Fi(t);var a=(e[0].z+e[e.length-1].z)/2;n?(t.z=n.z+s(t._,n._),t.m=t.z-a):t.z=a}else n&&(t.z=n.z+s(t._,n._));t.parent.A=i(t,n,t.parent.A||r[0])}function n(t){t._.x=t.z+t.parent.m,t.m+=t.parent.m}function i(t,e,r){if(e){for(var n,i=t,a=t,o=e,l=i.parent.children[0],u=i.m,c=a.m,h=o.m,f=l.m;o=Oi(o),i=Pi(i),o&&i;)l=Pi(l),a=Oi(a),a.a=t,n=o.z+h-i.z-u+s(o._,i._),n>0&&(Ri(ji(o,t,r),t,n),u+=n,c+=n),h+=o.m,u+=i.m,f+=l.m,c+=a.m;o&&!Oi(a)&&(a.t=o,a.m+=h-c),i&&!Pi(l)&&(l.t=i,l.m+=u-f,r=t)}return r}function a(t){t.x*=l[0],t.y=t.depth*l[1]}var o=uo.layout.hierarchy().sort(null).value(null),s=Di,l=[1,1],u=null;return t.separation=function(e){return arguments.length?(s=e,t):s},t.size=function(e){return arguments.length?(u=null==(l=e)?a:null,t):u?null:l},t.nodeSize=function(e){return arguments.length?(u=null==(l=e)?null:a,t):u?l:null},oi(t,o)},uo.layout.cluster=function(){function t(t,a){var o,s=e.call(this,t,a),l=s[0],u=0;li(l,function(t){var e=t.children;e&&e.length?(t.x=Bi(e),t.y=Ni(e)):(t.x=o?u+=r(t,o):0,t.y=0,o=t)});var c=Ui(l),h=Vi(l),f=c.x-r(c,h)/2,d=h.x+r(h,c)/2;return li(l,i?function(t){t.x=(t.x-l.x)*n[0],t.y=(l.y-t.y)*n[1]}:function(t){t.x=(t.x-f)/(d-f)*n[0],t.y=(1-(l.y?t.y/l.y:1))*n[1]}),s}var e=uo.layout.hierarchy().sort(null).value(null),r=Di,n=[1,1],i=!1;return t.separation=function(e){return arguments.length?(r=e,t):r},t.size=function(e){return arguments.length?(i=null==(n=e),t):i?null:n},t.nodeSize=function(e){return arguments.length?(i=null!=(n=e),t):i?n:null},oi(t,e)},uo.layout.treemap=function(){function t(t,e){for(var r,n,i=-1,a=t.length;++i<a;)n=(r=t[i]).value*(e<0?0:e),r.area=isNaN(n)||n<=0?0:n}function e(r){var a=r.children;if(a&&a.length){var o,s,l,u=h(r),c=[],f=a.slice(),p=1/0,m=\"slice\"===d?u.dx:\"dice\"===d?u.dy:\"slice-dice\"===d?1&r.depth?u.dy:u.dx:Math.min(u.dx,u.dy);for(t(f,u.dx*u.dy/r.value),c.area=0;(l=f.length)>0;)c.push(o=f[l-1]),c.area+=o.area,\"squarify\"!==d||(s=n(c,m))<=p?(f.pop(),p=s):(c.area-=c.pop().area,i(c,m,u,!1),m=Math.min(u.dx,u.dy),c.length=c.area=0,p=1/0);c.length&&(i(c,m,u,!0),c.length=c.area=0),a.forEach(e)}}function r(e){var n=e.children;if(n&&n.length){var a,o=h(e),s=n.slice(),l=[];for(t(s,o.dx*o.dy/e.value),l.area=0;a=s.pop();)l.push(a),l.area+=a.area,null!=a.z&&(i(l,a.z?o.dx:o.dy,o,!s.length),l.length=l.area=0);n.forEach(r)}}function n(t,e){for(var r,n=t.area,i=0,a=1/0,o=-1,s=t.length;++o<s;)(r=t[o].area)&&(r<a&&(a=r),r>i&&(i=r));return n*=n,e*=e,n?Math.max(e*i*p/n,n/(e*a*p)):1/0}function i(t,e,r,n){var i,a=-1,o=t.length,s=r.x,u=r.y,c=e?l(t.area/e):0;if(e==r.dx){for((n||c>r.dy)&&(c=r.dy);++a<o;)i=t[a],i.x=s,i.y=u,i.dy=c,s+=i.dx=Math.min(r.x+r.dx-s,c?l(i.area/c):0);i.z=!0,i.dx+=r.x+r.dx-s,r.y+=c,r.dy-=c}else{for((n||c>r.dx)&&(c=r.dx);++a<o;)i=t[a],i.x=s,i.y=u,i.dx=c,u+=i.dy=Math.min(r.y+r.dy-u,c?l(i.area/c):0);i.z=!1,i.dy+=r.y+r.dy-u,r.x+=c,r.dx-=c}}function a(n){var i=o||s(n),a=i[0];return a.x=a.y=0,a.value?(a.dx=u[0],a.dy=u[1]):a.dx=a.dy=0,o&&s.revalue(a),t([a],a.dx*a.dy/a.value),(o?r:e)(a),f&&(o=i),i}var o,s=uo.layout.hierarchy(),l=Math.round,u=[1,1],c=null,h=Hi,f=!1,d=\"squarify\",p=.5*(1+Math.sqrt(5));return a.size=function(t){return arguments.length?(u=t,a):u},a.padding=function(t){function e(e){var r=t.call(a,e,e.depth);return null==r?Hi(e):qi(e,\"number\"==typeof r?[r,r,r,r]:r)}function r(e){return qi(e,t)}if(!arguments.length)return c;var n;return h=null==(c=t)?Hi:\"function\"==(n=typeof t)?e:\"number\"===n?(t=[t,t,t,t],r):r,a},a.round=function(t){return arguments.length?(l=t?Math.round:Number,a):l!=Number},a.sticky=function(t){return arguments.length?(f=t,o=null,a):f},a.ratio=function(t){return arguments.length?(p=t,a):p},a.mode=function(t){return arguments.length?(d=t+\"\",a):d},oi(a,s)},uo.random={normal:function(t,e){var r=arguments.length;return r<2&&(e=1),r<1&&(t=0),function(){var r,n,i;do{r=2*Math.random()-1,n=2*Math.random()-1,i=r*r+n*n}while(!i||i>1);return t+e*r*Math.sqrt(-2*Math.log(i)/i)}},logNormal:function(){var t=uo.random.normal.apply(uo,arguments);return function(){return Math.exp(t())}},bates:function(t){var e=uo.random.irwinHall(t);return function(){return e()/t}},irwinHall:function(t){return function(){for(var e=0,r=0;r<t;r++)e+=Math.random();return e}}},uo.scale={};var wl={floor:x,ceil:x};uo.scale.linear=function(){return Ki([0,1],[0,1],_n,!1)};var Ml={s:1,g:1,p:1,r:1,e:1};uo.scale.log=function(){return aa(uo.scale.linear().domain([0,1]),10,!0,[1,10])};var kl=uo.format(\".0e\"),Al={floor:function(t){return-Math.ceil(-t)},ceil:function(t){return-Math.floor(-t)}};uo.scale.pow=function(){return oa(uo.scale.linear(),1,[0,1])},uo.scale.sqrt=function(){return uo.scale.pow().exponent(.5)},uo.scale.ordinal=function(){return la([],{t:\"range\",a:[[]]})},uo.scale.category10=function(){return uo.scale.ordinal().range(Tl)},uo.scale.category20=function(){return uo.scale.ordinal().range(Sl)},uo.scale.category20b=function(){return uo.scale.ordinal().range(El)},uo.scale.category20c=function(){return uo.scale.ordinal().range(Ll)};var Tl=[2062260,16744206,2924588,14034728,9725885,9197131,14907330,8355711,12369186,1556175].map(_t),Sl=[2062260,11454440,16744206,16759672,2924588,10018698,14034728,16750742,9725885,12955861,9197131,12885140,14907330,16234194,8355711,13092807,12369186,14408589,1556175,10410725].map(_t),El=[3750777,5395619,7040719,10264286,6519097,9216594,11915115,13556636,9202993,12426809,15186514,15190932,8666169,11356490,14049643,15177372,8077683,10834324,13528509,14589654].map(_t),Ll=[3244733,7057110,10406625,13032431,15095053,16616764,16625259,16634018,3253076,7652470,10607003,13101504,7695281,10394312,12369372,14342891,6513507,9868950,12434877,14277081].map(_t);uo.scale.quantile=function(){return ua([],[])},uo.scale.quantize=function(){return ca(0,1,[0,1])},uo.scale.threshold=function(){return ha([.5],[0,1])},uo.scale.identity=function(){return fa([0,1])},uo.svg={},uo.svg.arc=function(){function t(){var t=Math.max(0,+r.apply(this,arguments)),u=Math.max(0,+n.apply(this,arguments)),c=o.apply(this,arguments)-Vo,h=s.apply(this,arguments)-Vo,f=Math.abs(h-c),d=c>h?0:1;if(u<t&&(p=u,u=t,t=p),f>=Uo)return e(u,d)+(t?e(t,1-d):\"\")+\"Z\";var p,m,v,g,y,b,x,_,w,M,k,A,T=0,S=0,E=[];if((g=(+l.apply(this,arguments)||0)/2)&&(v=a===Cl?Math.sqrt(t*t+u*u):+a.apply(this,arguments),d||(S*=-1),u&&(S=nt(v/u*Math.sin(g))),t&&(T=nt(v/t*Math.sin(g)))),u){y=u*Math.cos(c+S),b=u*Math.sin(c+S),x=u*Math.cos(h-S),_=u*Math.sin(h-S);var L=Math.abs(h-c-2*S)<=No?0:1;if(S&&ba(y,b,x,_)===d^L){var C=(c+h)/2;y=u*Math.cos(C),b=u*Math.sin(C),x=_=null}}else y=b=0;if(t){w=t*Math.cos(h-T),M=t*Math.sin(h-T),k=t*Math.cos(c+T),A=t*Math.sin(c+T);var z=Math.abs(c-h+2*T)<=No?0:1;if(T&&ba(w,M,k,A)===1-d^z){var I=(c+h)/2;w=t*Math.cos(I),M=t*Math.sin(I),k=A=null}}else w=M=0;if(f>Fo&&(p=Math.min(Math.abs(u-t)/2,+i.apply(this,arguments)))>.001){m=t<u^d?0:1;var D=p,P=p;if(f<No){var O=null==k?[w,M]:null==x?[y,b]:Or([y,b],[k,A],[x,_],[w,M]),R=y-O[0],F=b-O[1],j=x-O[0],N=_-O[1],B=1/Math.sin(Math.acos((R*j+F*N)/(Math.sqrt(R*R+F*F)*Math.sqrt(j*j+N*N)))/2),U=Math.sqrt(O[0]*O[0]+O[1]*O[1]);P=Math.min(p,(t-U)/(B-1)),D=Math.min(p,(u-U)/(B+1))}if(null!=x){var V=xa(null==k?[w,M]:[k,A],[y,b],u,D,d),H=xa([x,_],[w,M],u,D,d);p===D?E.push(\"M\",V[0],\"A\",D,\",\",D,\" 0 0,\",m,\" \",V[1],\"A\",u,\",\",u,\" 0 \",1-d^ba(V[1][0],V[1][1],H[1][0],H[1][1]),\",\",d,\" \",H[1],\"A\",D,\",\",D,\" 0 0,\",m,\" \",H[0]):E.push(\"M\",V[0],\"A\",D,\",\",D,\" 0 1,\",m,\" \",H[0])}else E.push(\"M\",y,\",\",b);if(null!=k){var q=xa([y,b],[k,A],t,-P,d),G=xa([w,M],null==x?[y,b]:[x,_],t,-P,d);p===P?E.push(\"L\",G[0],\"A\",P,\",\",P,\" 0 0,\",m,\" \",G[1],\"A\",t,\",\",t,\" 0 \",d^ba(G[1][0],G[1][1],q[1][0],q[1][1]),\",\",1-d,\" \",q[1],\"A\",P,\",\",P,\" 0 0,\",m,\" \",q[0]):E.push(\"L\",G[0],\"A\",P,\",\",P,\" 0 0,\",m,\" \",q[0])}else E.push(\"L\",w,\",\",M)}else E.push(\"M\",y,\",\",b),null!=x&&E.push(\"A\",u,\",\",u,\" 0 \",L,\",\",d,\" \",x,\",\",_),E.push(\"L\",w,\",\",M),null!=k&&E.push(\"A\",t,\",\",t,\" 0 \",z,\",\",1-d,\" \",k,\",\",A);return E.push(\"Z\"),E.join(\"\")}function e(t,e){return\"M0,\"+t+\"A\"+t+\",\"+t+\" 0 1,\"+e+\" 0,\"+-t+\"A\"+t+\",\"+t+\" 0 1,\"+e+\" 0,\"+t}var r=pa,n=ma,i=da,a=Cl,o=va,s=ga,l=ya;return t.innerRadius=function(e){return arguments.length?(r=Et(e),t):r},t.outerRadius=function(e){return arguments.length?(n=Et(e),t):n},t.cornerRadius=function(e){return arguments.length?(i=Et(e),t):i},t.padRadius=function(e){return arguments.length?(a=e==Cl?Cl:Et(e),t):a},t.startAngle=function(e){return arguments.length?(o=Et(e),t):o},t.endAngle=function(e){return arguments.length?(s=Et(e),t):s},t.padAngle=function(e){return arguments.length?(l=Et(e),t):l},t.centroid=function(){var t=(+r.apply(this,arguments)+ +n.apply(this,arguments))/2,e=(+o.apply(this,arguments)+ +s.apply(this,arguments))/2-Vo;return[Math.cos(e)*t,Math.sin(e)*t]},t};var Cl=\"auto\";uo.svg.line=function(){return _a(x)};var zl=uo.map({linear:wa,\"linear-closed\":Ma,step:ka,\"step-before\":Aa,\"step-after\":Ta,basis:Ia,\"basis-open\":Da,\"basis-closed\":Pa,bundle:Oa,cardinal:La,\"cardinal-open\":Sa,\"cardinal-closed\":Ea,monotone:Ua});zl.forEach(function(t,e){e.key=t,e.closed=/-closed$/.test(t)});var Il=[0,2/3,1/3,0],Dl=[0,1/3,2/3,0],Pl=[0,1/6,2/3,1/6];uo.svg.line.radial=function(){var t=_a(Va);return t.radius=t.x,delete t.x,t.angle=t.y,delete t.y,t},Aa.reverse=Ta,Ta.reverse=Aa,uo.svg.area=function(){return Ha(x)},uo.svg.area.radial=function(){var t=Ha(Va);return t.radius=t.x,delete t.x,t.innerRadius=t.x0,delete t.x0,t.outerRadius=t.x1,delete t.x1,t.angle=t.y,delete t.y,t.startAngle=t.y0,delete t.y0,t.endAngle=t.y1,delete t.y1,t},uo.svg.chord=function(){function t(t,s){var l=e(this,a,t,s),u=e(this,o,t,s);return\"M\"+l.p0+n(l.r,l.p1,l.a1-l.a0)+(r(l,u)?i(l.r,l.p1,l.r,l.p0):i(l.r,l.p1,u.r,u.p0)+n(u.r,u.p1,u.a1-u.a0)+i(u.r,u.p1,l.r,l.p0))+\"Z\"}function e(t,e,r,n){var i=e.call(t,r,n),a=s.call(t,i,n),o=l.call(t,i,n)-Vo,c=u.call(t,i,n)-Vo;return{r:a,a0:o,a1:c,p0:[a*Math.cos(o),a*Math.sin(o)],p1:[a*Math.cos(c),a*Math.sin(c)]}}function r(t,e){return t.a0==e.a0&&t.a1==e.a1}function n(t,e,r){return\"A\"+t+\",\"+t+\" 0 \"+ +(r>No)+\",1 \"+e}function i(t,e,r,n){return\"Q 0,0 \"+n}var a=xr,o=_r,s=qa,l=va,u=ga;return t.radius=function(e){return arguments.length?(s=Et(e),t):s},t.source=function(e){return arguments.length?(a=Et(e),t):a},t.target=function(e){return arguments.length?(o=Et(e),t):o},t.startAngle=function(e){return arguments.length?(l=Et(e),t):l},t.endAngle=function(e){return arguments.length?(u=Et(e),t):u},t},uo.svg.diagonal=function(){function t(t,i){var a=e.call(this,t,i),o=r.call(this,t,i),s=(a.y+o.y)/2,l=[a,{x:a.x,y:s},{x:o.x,y:s},o];return l=l.map(n),\"M\"+l[0]+\"C\"+l[1]+\" \"+l[2]+\" \"+l[3]}var e=xr,r=_r,n=Ga;return t.source=function(r){return arguments.length?(e=Et(r),t):e},t.target=function(e){return arguments.length?(r=Et(e),t):r},t.projection=function(e){return arguments.length?(n=e,t):n},t},uo.svg.diagonal.radial=function(){var t=uo.svg.diagonal(),e=Ga,r=t.projection;return t.projection=function(t){return arguments.length?r(Ya(e=t)):e},t},uo.svg.symbol=function(){function t(t,n){return(Ol.get(e.call(this,t,n))||Za)(r.call(this,t,n))}var e=Wa,r=Xa;return t.type=function(r){return arguments.length?(e=Et(r),t):e},t.size=function(e){return arguments.length?(r=Et(e),t):r},t};var Ol=uo.map({circle:Za,cross:function(t){var e=Math.sqrt(t/5)/2;return\"M\"+-3*e+\",\"+-e+\"H\"+-e+\"V\"+-3*e+\"H\"+e+\"V\"+-e+\"H\"+3*e+\"V\"+e+\"H\"+e+\"V\"+3*e+\"H\"+-e+\"V\"+e+\"H\"+-3*e+\"Z\"},diamond:function(t){var e=Math.sqrt(t/(2*Fl)),r=e*Fl;return\"M0,\"+-e+\"L\"+r+\",0 0,\"+e+\" \"+-r+\",0Z\"},square:function(t){var e=Math.sqrt(t)/2;return\"M\"+-e+\",\"+-e+\"L\"+e+\",\"+-e+\" \"+e+\",\"+e+\" \"+-e+\",\"+e+\"Z\"},\"triangle-down\":function(t){var e=Math.sqrt(t/Rl),r=e*Rl/2;return\"M0,\"+r+\"L\"+e+\",\"+-r+\" \"+-e+\",\"+-r+\"Z\"},\"triangle-up\":function(t){var e=Math.sqrt(t/Rl),r=e*Rl/2;return\"M0,\"+-r+\"L\"+e+\",\"+r+\" \"+-e+\",\"+r+\"Z\"}});uo.svg.symbolTypes=Ol.keys();var Rl=Math.sqrt(3),Fl=Math.tan(30*Ho);Lo.transition=function(t){for(var e,r,n=jl||++Vl,i=to(t),a=[],o=Nl||{time:Date.now(),ease:En,delay:0,duration:250},s=-1,l=this.length;++s<l;){a.push(e=[]);for(var u=this[s],c=-1,h=u.length;++c<h;)(r=u[c])&&eo(r,c,i,n,o),e.push(r)}return Ka(a,i,n)},Lo.interrupt=function(t){return this.each(null==t?Bl:Ja(to(t)))};var jl,Nl,Bl=Ja(to()),Ul=[],Vl=0;Ul.call=Lo.call,Ul.empty=Lo.empty,Ul.node=Lo.node,Ul.size=Lo.size,uo.transition=function(t,e){return t&&t.transition?jl?t.transition(e):t:uo.selection().transition(t)},uo.transition.prototype=Ul,Ul.select=function(t){\n",
       "var e,r,n,i=this.id,a=this.namespace,o=[];t=C(t);for(var s=-1,l=this.length;++s<l;){o.push(e=[]);for(var u=this[s],c=-1,h=u.length;++c<h;)(n=u[c])&&(r=t.call(n,n.__data__,c,s))?(\"__data__\"in n&&(r.__data__=n.__data__),eo(r,c,a,i,n[a][i]),e.push(r)):e.push(null)}return Ka(o,a,i)},Ul.selectAll=function(t){var e,r,n,i,a,o=this.id,s=this.namespace,l=[];t=z(t);for(var u=-1,c=this.length;++u<c;)for(var h=this[u],f=-1,d=h.length;++f<d;)if(n=h[f]){a=n[s][o],r=t.call(n,n.__data__,f,u),l.push(e=[]);for(var p=-1,m=r.length;++p<m;)(i=r[p])&&eo(i,p,s,o,a),e.push(i)}return Ka(l,s,o)},Ul.filter=function(t){var e,r,n,i=[];\"function\"!=typeof t&&(t=H(t));for(var a=0,o=this.length;a<o;a++){i.push(e=[]);for(var r=this[a],s=0,l=r.length;s<l;s++)(n=r[s])&&t.call(n,n.__data__,s,a)&&e.push(n)}return Ka(i,this.namespace,this.id)},Ul.tween=function(t,e){var r=this.id,n=this.namespace;return arguments.length<2?this.node()[n][r].tween.get(t):G(this,null==e?function(e){e[n][r].tween.remove(t)}:function(i){i[n][r].tween.set(t,e)})},Ul.attr=function(t,e){function r(){this.removeAttribute(s)}function n(){this.removeAttributeNS(s.space,s.local)}function i(t){return null==t?r:(t+=\"\",function(){var e,r=this.getAttribute(s);return r!==t&&(e=o(r,t),function(t){this.setAttribute(s,e(t))})})}function a(t){return null==t?n:(t+=\"\",function(){var e,r=this.getAttributeNS(s.space,s.local);return r!==t&&(e=o(r,t),function(t){this.setAttributeNS(s.space,s.local,e(t))})})}if(arguments.length<2){for(e in t)this.attr(e,t[e]);return this}var o=\"transform\"==t?Zn:_n,s=uo.ns.qualify(t);return Qa(this,\"attr.\"+t,e,s.local?a:i)},Ul.attrTween=function(t,e){function r(t,r){var n=e.call(this,t,r,this.getAttribute(i));return n&&function(t){this.setAttribute(i,n(t))}}function n(t,r){var n=e.call(this,t,r,this.getAttributeNS(i.space,i.local));return n&&function(t){this.setAttributeNS(i.space,i.local,n(t))}}var i=uo.ns.qualify(t);return this.tween(\"attr.\"+t,i.local?n:r)},Ul.style=function(t,e,r){function i(){this.style.removeProperty(t)}function a(e){return null==e?i:(e+=\"\",function(){var i,a=n(this).getComputedStyle(this,null).getPropertyValue(t);return a!==e&&(i=_n(a,e),function(e){this.style.setProperty(t,i(e),r)})})}var o=arguments.length;if(o<3){if(\"string\"!=typeof t){o<2&&(e=\"\");for(r in t)this.style(r,t[r],e);return this}r=\"\"}return Qa(this,\"style.\"+t,e,a)},Ul.styleTween=function(t,e,r){function i(i,a){var o=e.call(this,i,a,n(this).getComputedStyle(this,null).getPropertyValue(t));return o&&function(e){this.style.setProperty(t,o(e),r)}}return arguments.length<3&&(r=\"\"),this.tween(\"style.\"+t,i)},Ul.text=function(t){return Qa(this,\"text\",t,$a)},Ul.remove=function(){var t=this.namespace;return this.each(\"end.transition\",function(){var e;this[t].count<2&&(e=this.parentNode)&&e.removeChild(this)})},Ul.ease=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].ease:(\"function\"!=typeof t&&(t=uo.ease.apply(uo,arguments)),G(this,function(n){n[r][e].ease=t}))},Ul.delay=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].delay:G(this,\"function\"==typeof t?function(n,i,a){n[r][e].delay=+t.call(n,n.__data__,i,a)}:(t=+t,function(n){n[r][e].delay=t}))},Ul.duration=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].duration:G(this,\"function\"==typeof t?function(n,i,a){n[r][e].duration=Math.max(1,t.call(n,n.__data__,i,a))}:(t=Math.max(1,t),function(n){n[r][e].duration=t}))},Ul.each=function(t,e){var r=this.id,n=this.namespace;if(arguments.length<2){var i=Nl,a=jl;try{jl=r,G(this,function(e,i,a){Nl=e[n][r],t.call(e,e.__data__,i,a)})}finally{Nl=i,jl=a}}else G(this,function(i){var a=i[n][r];(a.event||(a.event=uo.dispatch(\"start\",\"end\",\"interrupt\"))).on(t,e)});return this},Ul.transition=function(){for(var t,e,r,n,i=this.id,a=++Vl,o=this.namespace,s=[],l=0,u=this.length;l<u;l++){s.push(t=[]);for(var e=this[l],c=0,h=e.length;c<h;c++)(r=e[c])&&(n=r[o][i],eo(r,c,o,a,{time:n.time,ease:n.ease,delay:n.delay+n.duration,duration:n.duration})),t.push(r)}return Ka(s,o,a)},uo.svg.axis=function(){function t(t){t.each(function(){var t,u=uo.select(this),c=this.__chart__||r,h=this.__chart__=r.copy(),f=null==l?h.ticks?h.ticks.apply(h,s):h.domain():l,d=null==e?h.tickFormat?h.tickFormat.apply(h,s):x:e,p=u.selectAll(\".tick\").data(f,h),m=p.enter().insert(\"g\",\".domain\").attr(\"class\",\"tick\").style(\"opacity\",Fo),v=uo.transition(p.exit()).style(\"opacity\",Fo).remove(),g=uo.transition(p.order()).style(\"opacity\",1),y=Math.max(i,0)+o,b=Yi(h),_=u.selectAll(\".domain\").data([0]),w=(_.enter().append(\"path\").attr(\"class\",\"domain\"),uo.transition(_));m.append(\"line\"),m.append(\"text\");var M,k,A,T,S=m.select(\"line\"),E=g.select(\"line\"),L=p.select(\"text\").text(d),C=m.select(\"text\"),z=g.select(\"text\"),I=\"top\"===n||\"left\"===n?-1:1;if(\"bottom\"===n||\"top\"===n?(t=ro,M=\"x\",A=\"y\",k=\"x2\",T=\"y2\",L.attr(\"dy\",I<0?\"0em\":\".71em\").style(\"text-anchor\",\"middle\"),w.attr(\"d\",\"M\"+b[0]+\",\"+I*a+\"V0H\"+b[1]+\"V\"+I*a)):(t=no,M=\"y\",A=\"x\",k=\"y2\",T=\"x2\",L.attr(\"dy\",\".32em\").style(\"text-anchor\",I<0?\"end\":\"start\"),w.attr(\"d\",\"M\"+I*a+\",\"+b[0]+\"H0V\"+b[1]+\"H\"+I*a)),S.attr(T,I*i),C.attr(A,I*y),E.attr(k,0).attr(T,I*i),z.attr(M,0).attr(A,I*y),h.rangeBand){var D=h,P=D.rangeBand()/2;c=h=function(t){return D(t)+P}}else c.rangeBand?c=h:v.call(t,h,c);m.call(t,c,h),g.call(t,h,h)})}var e,r=uo.scale.linear(),n=Hl,i=6,a=6,o=3,s=[10],l=null;return t.scale=function(e){return arguments.length?(r=e,t):r},t.orient=function(e){return arguments.length?(n=e in ql?e+\"\":Hl,t):n},t.ticks=function(){return arguments.length?(s=ho(arguments),t):s},t.tickValues=function(e){return arguments.length?(l=e,t):l},t.tickFormat=function(r){return arguments.length?(e=r,t):e},t.tickSize=function(e){var r=arguments.length;return r?(i=+e,a=+arguments[r-1],t):i},t.innerTickSize=function(e){return arguments.length?(i=+e,t):i},t.outerTickSize=function(e){return arguments.length?(a=+e,t):a},t.tickPadding=function(e){return arguments.length?(o=+e,t):o},t.tickSubdivide=function(){return arguments.length&&t},t};var Hl=\"bottom\",ql={top:1,right:1,bottom:1,left:1};uo.svg.brush=function(){function t(n){n.each(function(){var n=uo.select(this).style(\"pointer-events\",\"all\").style(\"-webkit-tap-highlight-color\",\"rgba(0,0,0,0)\").on(\"mousedown.brush\",a).on(\"touchstart.brush\",a),o=n.selectAll(\".background\").data([0]);o.enter().append(\"rect\").attr(\"class\",\"background\").style(\"visibility\",\"hidden\").style(\"cursor\",\"crosshair\"),n.selectAll(\".extent\").data([0]).enter().append(\"rect\").attr(\"class\",\"extent\").style(\"cursor\",\"move\");var s=n.selectAll(\".resize\").data(m,x);s.exit().remove(),s.enter().append(\"g\").attr(\"class\",function(t){return\"resize \"+t}).style(\"cursor\",function(t){return Gl[t]}).append(\"rect\").attr(\"x\",function(t){return/[ew]$/.test(t)?-3:null}).attr(\"y\",function(t){return/^[ns]/.test(t)?-3:null}).attr(\"width\",6).attr(\"height\",6).style(\"visibility\",\"hidden\"),s.style(\"display\",t.empty()?\"none\":null);var l,h=uo.transition(n),f=uo.transition(o);u&&(l=Yi(u),f.attr(\"x\",l[0]).attr(\"width\",l[1]-l[0]),r(h)),c&&(l=Yi(c),f.attr(\"y\",l[0]).attr(\"height\",l[1]-l[0]),i(h)),e(h)})}function e(t){t.selectAll(\".resize\").attr(\"transform\",function(t){return\"translate(\"+h[+/e$/.test(t)]+\",\"+f[+/^s/.test(t)]+\")\"})}function r(t){t.select(\".extent\").attr(\"x\",h[0]),t.selectAll(\".extent,.n>rect,.s>rect\").attr(\"width\",h[1]-h[0])}function i(t){t.select(\".extent\").attr(\"y\",f[0]),t.selectAll(\".extent,.e>rect,.w>rect\").attr(\"height\",f[1]-f[0])}function a(){function a(){32==uo.event.keyCode&&(L||(b=null,z[0]-=h[1],z[1]-=f[1],L=2),T())}function m(){32==uo.event.keyCode&&2==L&&(z[0]+=h[1],z[1]+=f[1],L=0,T())}function v(){var t=uo.mouse(_),n=!1;x&&(t[0]+=x[0],t[1]+=x[1]),L||(uo.event.altKey?(b||(b=[(h[0]+h[1])/2,(f[0]+f[1])/2]),z[0]=h[+(t[0]<b[0])],z[1]=f[+(t[1]<b[1])]):b=null),S&&g(t,u,0)&&(r(k),n=!0),E&&g(t,c,1)&&(i(k),n=!0),n&&(e(k),M({type:\"brush\",mode:L?\"move\":\"resize\"}))}function g(t,e,r){var n,i,a=Yi(e),l=a[0],u=a[1],c=z[r],m=r?f:h,v=m[1]-m[0];if(L&&(l-=c,u-=v+c),n=(r?p:d)?Math.max(l,Math.min(u,t[r])):t[r],L?i=(n+=c)+v:(b&&(c=Math.max(l,Math.min(u,2*b[r]-n))),c<n?(i=n,n=c):i=c),m[0]!=n||m[1]!=i)return r?s=null:o=null,m[0]=n,m[1]=i,!0}function y(){v(),k.style(\"pointer-events\",\"all\").selectAll(\".resize\").style(\"display\",t.empty()?\"none\":null),uo.select(\"body\").style(\"cursor\",null),I.on(\"mousemove.brush\",null).on(\"mouseup.brush\",null).on(\"touchmove.brush\",null).on(\"touchend.brush\",null).on(\"keydown.brush\",null).on(\"keyup.brush\",null),C(),M({type:\"brushend\"})}var b,x,_=this,w=uo.select(uo.event.target),M=l.of(_,arguments),k=uo.select(_),A=w.datum(),S=!/^(n|s)$/.test(A)&&u,E=!/^(e|w)$/.test(A)&&c,L=w.classed(\"extent\"),C=K(_),z=uo.mouse(_),I=uo.select(n(_)).on(\"keydown.brush\",a).on(\"keyup.brush\",m);if(uo.event.changedTouches?I.on(\"touchmove.brush\",v).on(\"touchend.brush\",y):I.on(\"mousemove.brush\",v).on(\"mouseup.brush\",y),k.interrupt().selectAll(\"*\").interrupt(),L)z[0]=h[0]-z[0],z[1]=f[0]-z[1];else if(A){var D=+/w$/.test(A),P=+/^n/.test(A);x=[h[1-D]-z[0],f[1-P]-z[1]],z[0]=h[D],z[1]=f[P]}else uo.event.altKey&&(b=z.slice());k.style(\"pointer-events\",\"none\").selectAll(\".resize\").style(\"display\",null),uo.select(\"body\").style(\"cursor\",w.style(\"cursor\")),M({type:\"brushstart\"}),v()}var o,s,l=E(t,\"brushstart\",\"brush\",\"brushend\"),u=null,c=null,h=[0,0],f=[0,0],d=!0,p=!0,m=Yl[0];return t.event=function(t){t.each(function(){var t=l.of(this,arguments),e={x:h,y:f,i:o,j:s},r=this.__chart__||e;this.__chart__=e,jl?uo.select(this).transition().each(\"start.brush\",function(){o=r.i,s=r.j,h=r.x,f=r.y,t({type:\"brushstart\"})}).tween(\"brush:brush\",function(){var r=wn(h,e.x),n=wn(f,e.y);return o=s=null,function(i){h=e.x=r(i),f=e.y=n(i),t({type:\"brush\",mode:\"resize\"})}}).each(\"end.brush\",function(){o=e.i,s=e.j,t({type:\"brush\",mode:\"resize\"}),t({type:\"brushend\"})}):(t({type:\"brushstart\"}),t({type:\"brush\",mode:\"resize\"}),t({type:\"brushend\"}))})},t.x=function(e){return arguments.length?(u=e,m=Yl[!u<<1|!c],t):u},t.y=function(e){return arguments.length?(c=e,m=Yl[!u<<1|!c],t):c},t.clamp=function(e){return arguments.length?(u&&c?(d=!!e[0],p=!!e[1]):u?d=!!e:c&&(p=!!e),t):u&&c?[d,p]:u?d:c?p:null},t.extent=function(e){var r,n,i,a,l;return arguments.length?(u&&(r=e[0],n=e[1],c&&(r=r[0],n=n[0]),o=[r,n],u.invert&&(r=u(r),n=u(n)),n<r&&(l=r,r=n,n=l),r==h[0]&&n==h[1]||(h=[r,n])),c&&(i=e[0],a=e[1],u&&(i=i[1],a=a[1]),s=[i,a],c.invert&&(i=c(i),a=c(a)),a<i&&(l=i,i=a,a=l),i==f[0]&&a==f[1]||(f=[i,a])),t):(u&&(o?(r=o[0],n=o[1]):(r=h[0],n=h[1],u.invert&&(r=u.invert(r),n=u.invert(n)),n<r&&(l=r,r=n,n=l))),c&&(s?(i=s[0],a=s[1]):(i=f[0],a=f[1],c.invert&&(i=c.invert(i),a=c.invert(a)),a<i&&(l=i,i=a,a=l))),u&&c?[[r,i],[n,a]]:u?[r,n]:c&&[i,a])},t.clear=function(){return t.empty()||(h=[0,0],f=[0,0],o=s=null),t},t.empty=function(){return!!u&&h[0]==h[1]||!!c&&f[0]==f[1]},uo.rebind(t,l,\"on\")};var Gl={n:\"ns-resize\",e:\"ew-resize\",s:\"ns-resize\",w:\"ew-resize\",nw:\"nwse-resize\",ne:\"nesw-resize\",se:\"nwse-resize\",sw:\"nesw-resize\"},Yl=[[\"n\",\"e\",\"s\",\"w\",\"nw\",\"ne\",\"se\",\"sw\"],[\"e\",\"w\"],[\"n\",\"s\"],[]],Xl=fs.format=ys.timeFormat,Wl=Xl.utc,Zl=Wl(\"%Y-%m-%dT%H:%M:%S.%LZ\");Xl.iso=Date.prototype.toISOString&&+new Date(\"2000-01-01T00:00:00.000Z\")?io:Zl,io.parse=function(t){var e=new Date(t);return isNaN(e)?null:e},io.toString=Zl.toString,fs.second=Vt(function(t){return new ds(1e3*Math.floor(t/1e3))},function(t,e){t.setTime(t.getTime()+1e3*Math.floor(e))},function(t){return t.getSeconds()}),fs.seconds=fs.second.range,fs.seconds.utc=fs.second.utc.range,fs.minute=Vt(function(t){return new ds(6e4*Math.floor(t/6e4))},function(t,e){t.setTime(t.getTime()+6e4*Math.floor(e))},function(t){return t.getMinutes()}),fs.minutes=fs.minute.range,fs.minutes.utc=fs.minute.utc.range,fs.hour=Vt(function(t){var e=t.getTimezoneOffset()/60;return new ds(36e5*(Math.floor(t/36e5-e)+e))},function(t,e){t.setTime(t.getTime()+36e5*Math.floor(e))},function(t){return t.getHours()}),fs.hours=fs.hour.range,fs.hours.utc=fs.hour.utc.range,fs.month=Vt(function(t){return t=fs.day(t),t.setDate(1),t},function(t,e){t.setMonth(t.getMonth()+e)},function(t){return t.getMonth()}),fs.months=fs.month.range,fs.months.utc=fs.month.utc.range;var Jl=[1e3,5e3,15e3,3e4,6e4,3e5,9e5,18e5,36e5,108e5,216e5,432e5,864e5,1728e5,6048e5,2592e6,7776e6,31536e6],Kl=[[fs.second,1],[fs.second,5],[fs.second,15],[fs.second,30],[fs.minute,1],[fs.minute,5],[fs.minute,15],[fs.minute,30],[fs.hour,1],[fs.hour,3],[fs.hour,6],[fs.hour,12],[fs.day,1],[fs.day,2],[fs.week,1],[fs.month,1],[fs.month,3],[fs.year,1]],Ql=Xl.multi([[\".%L\",function(t){return t.getMilliseconds()}],[\":%S\",function(t){return t.getSeconds()}],[\"%I:%M\",function(t){return t.getMinutes()}],[\"%I %p\",function(t){return t.getHours()}],[\"%a %d\",function(t){return t.getDay()&&1!=t.getDate()}],[\"%b %d\",function(t){return 1!=t.getDate()}],[\"%B\",function(t){return t.getMonth()}],[\"%Y\",ze]]),$l={range:function(t,e,r){return uo.range(Math.ceil(t/r)*r,+e,r).map(oo)},floor:x,ceil:x};Kl.year=fs.year,fs.scale=function(){return ao(uo.scale.linear(),Kl,Ql)};var tu=Kl.map(function(t){return[t[0].utc,t[1]]}),eu=Wl.multi([[\".%L\",function(t){return t.getUTCMilliseconds()}],[\":%S\",function(t){return t.getUTCSeconds()}],[\"%I:%M\",function(t){return t.getUTCMinutes()}],[\"%I %p\",function(t){return t.getUTCHours()}],[\"%a %d\",function(t){return t.getUTCDay()&&1!=t.getUTCDate()}],[\"%b %d\",function(t){return 1!=t.getUTCDate()}],[\"%B\",function(t){return t.getUTCMonth()}],[\"%Y\",ze]]);tu.year=fs.year.utc,fs.scale.utc=function(){return ao(uo.scale.linear(),tu,eu)},uo.text=Lt(function(t){return t.responseText}),uo.json=function(t,e){return Ct(t,\"application/json\",so,e)},uo.html=function(t,e){return Ct(t,\"text/html\",lo,e)},uo.xml=Lt(function(t){return t.responseXML}),\"function\"==typeof t&&t.amd?(this.d3=uo,t(uo)):\"object\"==typeof r&&r.exports?r.exports=uo:this.d3=uo}()},{}],122:[function(t,e,r){\"use strict\";function n(t,e){this.point=t,this.index=e}function i(t,e){for(var r=t.point,n=e.point,i=r.length,a=0;a<i;++a){var o=n[a]-r[a];if(o)return o}return 0}function a(t,e,r){if(1===t)return r?[[-1,0]]:[];var n=e.map(function(t,e){return[t[0],e]});n.sort(function(t,e){return t[0]-e[0]});for(var i=new Array(t-1),a=1;a<t;++a){var o=n[a-1],s=n[a];i[a-1]=[o[1],s[1]]}return r&&i.push([-1,i[0][1]],[i[t-1][1],-1]),i}function o(t,e){var r=t.length;if(0===r)return[];var o=t[0].length;if(o<1)return[];if(1===o)return a(r,t,e);for(var u=new Array(r),c=1,h=0;h<r;++h){for(var f=t[h],d=new Array(o+1),p=0,m=0;m<o;++m){var v=f[m];d[m]=v,p+=v*v}d[o]=p,u[h]=new n(d,h),c=Math.max(p,c)}l(u,i),r=u.length;for(var g=new Array(r+o+1),y=new Array(r+o+1),b=(o+1)*(o+1)*c,x=new Array(o+1),h=0;h<=o;++h)x[h]=0;x[o]=b,g[0]=x.slice(),y[0]=-1;for(var h=0;h<=o;++h){var d=x.slice();d[h]=1,g[h+1]=d,y[h+1]=-1}for(var h=0;h<r;++h){var _=u[h];g[h+o+1]=_.point,y[h+o+1]=_.index}var w=s(g,!1);if(w=e?w.filter(function(t){for(var e=0,r=0;r<=o;++r){var n=y[t[r]];if(n<0&&++e>=2)return!1;t[r]=n}return!0}):w.filter(function(t){for(var e=0;e<=o;++e){var r=y[t[e]];if(r<0)return!1;t[e]=r}return!0}),1&o)for(var h=0;h<w.length;++h){var _=w[h],d=_[0];_[0]=_[1],_[1]=d}return w}var s=t(\"incremental-convex-hull\"),l=t(\"uniq\");e.exports=o},{\"incremental-convex-hull\":289,uniq:542}],123:[function(t,e,r){(function(t){function r(t,e){return d[0]=t,d[1]=e,f[0]}function n(t){return f[0]=t,d[0]}function i(t){return f[0]=t,d[1]}function a(t,e){return d[1]=t,d[0]=e,f[0]}function o(t){return f[0]=t,d[1]}function s(t){return f[0]=t,d[0]}function l(t,e){return p.writeUInt32LE(t,0,!0),p.writeUInt32LE(e,4,!0),p.readDoubleLE(0,!0)}function u(t){return p.writeDoubleLE(t,0,!0),p.readUInt32LE(0,!0)}function c(t){return p.writeDoubleLE(t,0,!0),p.readUInt32LE(4,!0)}var h=!1;if(\"undefined\"!=typeof Float64Array){var f=new Float64Array(1),d=new Uint32Array(f.buffer);f[0]=1,h=!0,1072693248===d[1]?(e.exports=function(t){return f[0]=t,[d[0],d[1]]},e.exports.pack=r,e.exports.lo=n,e.exports.hi=i):1072693248===d[0]?(e.exports=function(t){return f[0]=t,[d[1],d[0]]},e.exports.pack=a,e.exports.lo=o,e.exports.hi=s):h=!1}if(!h){var p=new t(8);e.exports=function(t){return p.writeDoubleLE(t,0,!0),[p.readUInt32LE(0,!0),p.readUInt32LE(4,!0)]},e.exports.pack=l,e.exports.lo=u,e.exports.hi=c}e.exports.sign=function(t){return e.exports.hi(t)>>>31},e.exports.exponent=function(t){return(e.exports.hi(t)<<1>>>21)-1023},e.exports.fraction=function(t){var r=e.exports.lo(t),n=e.exports.hi(t),i=1048575&n;return 2146435072&n&&(i+=1<<20),[r,i]},e.exports.denormalized=function(t){return!(2146435072&e.exports.hi(t))}}).call(this,t(\"buffer\").Buffer)},{buffer:76}],124:[function(t,e,r){\"use strict\";function n(t,e,r){var i=0|t[r];if(i<=0)return[];var a,o=new Array(i);if(r===t.length-1)for(a=0;a<i;++a)o[a]=e;else for(a=0;a<i;++a)o[a]=n(t,e,r+1);return o}function i(t,e){var r,n;for(r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function a(t,e){switch(void 0===e&&(e=0),typeof t){case\"number\":if(t>0)return i(0|t,e);break;case\"object\":if(\"number\"==typeof t.length)return n(t,e,0)}return[]}e.exports=a},{}],125:[function(t,e,r){\"use strict\";function n(t,e,r){r=r||2;var n=e&&e.length,a=n?e[0]*r:t.length,s=i(t,0,a,r,!0),l=[];if(!s)return l;var u,c,f,d,p,m,v;if(n&&(s=h(t,e,s,r)),t.length>80*r){u=f=t[0],c=d=t[1];for(var g=r;g<a;g+=r)p=t[g],m=t[g+1],p<u&&(u=p),m<c&&(c=m),p>f&&(f=p),m>d&&(d=m);v=Math.max(f-u,d-c)}return o(s,l,r,u,c,v),l}function i(t,e,r,n,i){var a,o;if(i===z(t,e,r,n)>0)for(a=e;a<r;a+=n)o=E(a,t[a],t[a+1],o);else for(a=r-n;a>=e;a-=n)o=E(a,t[a],t[a+1],o);return o&&w(o,o.next)&&(L(o),o=o.next),o}function a(t,e){if(!t)return t;e||(e=t);var r,n=t;do{if(r=!1,n.steiner||!w(n,n.next)&&0!==_(n.prev,n,n.next))n=n.next;else{if(L(n),(n=e=n.prev)===n.next)return null;r=!0}}while(r||n!==e);return e}function o(t,e,r,n,i,h,f){if(t){!f&&h&&m(t,n,i,h);for(var d,p,v=t;t.prev!==t.next;)if(d=t.prev,p=t.next,h?l(t,n,i,h):s(t))e.push(d.i/r),e.push(t.i/r),e.push(p.i/r),L(t),t=p.next,v=p.next;else if((t=p)===v){f?1===f?(t=u(t,e,r),o(t,e,r,n,i,h,2)):2===f&&c(t,e,r,n,i,h):o(a(t),e,r,n,i,h,1);break}}}function s(t){var e=t.prev,r=t,n=t.next;if(_(e,r,n)>=0)return!1;for(var i=t.next.next;i!==t.prev;){if(b(e.x,e.y,r.x,r.y,n.x,n.y,i.x,i.y)&&_(i.prev,i,i.next)>=0)return!1;i=i.next}return!0}function l(t,e,r,n){var i=t.prev,a=t,o=t.next;if(_(i,a,o)>=0)return!1;for(var s=i.x<a.x?i.x<o.x?i.x:o.x:a.x<o.x?a.x:o.x,l=i.y<a.y?i.y<o.y?i.y:o.y:a.y<o.y?a.y:o.y,u=i.x>a.x?i.x>o.x?i.x:o.x:a.x>o.x?a.x:o.x,c=i.y>a.y?i.y>o.y?i.y:o.y:a.y>o.y?a.y:o.y,h=g(s,l,e,r,n),f=g(u,c,e,r,n),d=t.nextZ;d&&d.z<=f;){if(d!==t.prev&&d!==t.next&&b(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&_(d.prev,d,d.next)>=0)return!1;d=d.nextZ}for(d=t.prevZ;d&&d.z>=h;){if(d!==t.prev&&d!==t.next&&b(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&_(d.prev,d,d.next)>=0)return!1;d=d.prevZ}return!0}function u(t,e,r){var n=t;do{var i=n.prev,a=n.next.next;!w(i,a)&&M(i,n,n.next,a)&&A(i,a)&&A(a,i)&&(e.push(i.i/r),e.push(n.i/r),e.push(a.i/r),L(n),L(n.next),n=t=a),n=n.next}while(n!==t);return n}function c(t,e,r,n,i,s){var l=t;do{for(var u=l.next.next;u!==l.prev;){if(l.i!==u.i&&x(l,u)){var c=S(l,u);return l=a(l,l.next),c=a(c,c.next),o(l,e,r,n,i,s),void o(c,e,r,n,i,s)}u=u.next}l=l.next}while(l!==t)}function h(t,e,r,n){var o,s,l,u,c,h=[];for(o=0,s=e.length;o<s;o++)l=e[o]*n,u=o<s-1?e[o+1]*n:t.length,c=i(t,l,u,n,!1),c===c.next&&(c.steiner=!0),h.push(y(c));for(h.sort(f),o=0;o<h.length;o++)d(h[o],r),r=a(r,r.next);return r}function f(t,e){return t.x-e.x}function d(t,e){if(e=p(t,e)){var r=S(e,t);a(r,r.next)}}function p(t,e){var r,n=e,i=t.x,a=t.y,o=-1/0;do{if(a<=n.y&&a>=n.next.y){var s=n.x+(a-n.y)*(n.next.x-n.x)/(n.next.y-n.y);if(s<=i&&s>o){if(o=s,s===i){if(a===n.y)return n;if(a===n.next.y)return n.next}r=n.x<n.next.x?n:n.next}}n=n.next}while(n!==e);if(!r)return null;if(i===o)return r.prev;var l,u=r,c=r.x,h=r.y,f=1/0;for(n=r.next;n!==u;)i>=n.x&&n.x>=c&&b(a<h?i:o,a,c,h,a<h?o:i,a,n.x,n.y)&&((l=Math.abs(a-n.y)/(i-n.x))<f||l===f&&n.x>r.x)&&A(n,t)&&(r=n,f=l),n=n.next;return r}function m(t,e,r,n){var i=t;do{null===i.z&&(i.z=g(i.x,i.y,e,r,n)),i.prevZ=i.prev,i.nextZ=i.next,i=i.next}while(i!==t);i.prevZ.nextZ=null,i.prevZ=null,v(i)}function v(t){var e,r,n,i,a,o,s,l,u=1;do{for(r=t,t=null,a=null,o=0;r;){for(o++,n=r,s=0,e=0;e<u&&(s++,n=n.nextZ);e++);for(l=u;s>0||l>0&&n;)0===s?(i=n,n=n.nextZ,l--):0!==l&&n?r.z<=n.z?(i=r,r=r.nextZ,s--):(i=n,n=n.nextZ,l--):(i=r,r=r.nextZ,s--),a?a.nextZ=i:t=i,i.prevZ=a,a=i;r=n}a.nextZ=null,u*=2}while(o>1);return t}function g(t,e,r,n,i){return t=32767*(t-r)/i,e=32767*(e-n)/i,t=16711935&(t|t<<8),t=252645135&(t|t<<4),t=858993459&(t|t<<2),t=1431655765&(t|t<<1),e=16711935&(e|e<<8),e=252645135&(e|e<<4),e=858993459&(e|e<<2),e=1431655765&(e|e<<1),t|e<<1}function y(t){var e=t,r=t;do{e.x<r.x&&(r=e),e=e.next}while(e!==t);return r}function b(t,e,r,n,i,a,o,s){return(i-o)*(e-s)-(t-o)*(a-s)>=0&&(t-o)*(n-s)-(r-o)*(e-s)>=0&&(r-o)*(a-s)-(i-o)*(n-s)>=0}function x(t,e){return t.next.i!==e.i&&t.prev.i!==e.i&&!k(t,e)&&A(t,e)&&A(e,t)&&T(t,e)}function _(t,e,r){return(e.y-t.y)*(r.x-e.x)-(e.x-t.x)*(r.y-e.y)}function w(t,e){return t.x===e.x&&t.y===e.y}function M(t,e,r,n){return!!(w(t,e)&&w(r,n)||w(t,n)&&w(r,e))||_(t,e,r)>0!=_(t,e,n)>0&&_(r,n,t)>0!=_(r,n,e)>0}function k(t,e){var r=t;do{if(r.i!==t.i&&r.next.i!==t.i&&r.i!==e.i&&r.next.i!==e.i&&M(r,r.next,t,e))return!0;r=r.next}while(r!==t);return!1}function A(t,e){return _(t.prev,t,t.next)<0?_(t,e,t.next)>=0&&_(t,t.prev,e)>=0:_(t,e,t.prev)<0||_(t,t.next,e)<0}function T(t,e){var r=t,n=!1,i=(t.x+e.x)/2,a=(t.y+e.y)/2;do{r.y>a!=r.next.y>a&&i<(r.next.x-r.x)*(a-r.y)/(r.next.y-r.y)+r.x&&(n=!n),r=r.next}while(r!==t);return n}function S(t,e){var r=new C(t.i,t.x,t.y),n=new C(e.i,e.x,e.y),i=t.next,a=e.prev;return t.next=e,e.prev=t,r.next=i,i.prev=r,n.next=r,r.prev=n,a.next=n,n.prev=a,n}function E(t,e,r,n){var i=new C(t,e,r);return n?(i.next=n.next,i.prev=n,n.next.prev=i,n.next=i):(i.prev=i,i.next=i),i}function L(t){t.next.prev=t.prev,t.prev.next=t.next,t.prevZ&&(t.prevZ.nextZ=t.nextZ),t.nextZ&&(t.nextZ.prevZ=t.prevZ)}function C(t,e,r){this.i=t,this.x=e,this.y=r,this.prev=null,this.next=null,this.z=null,this.prevZ=null,this.nextZ=null,this.steiner=!1}function z(t,e,r,n){for(var i=0,a=e,o=r-n;a<r;a+=n)i+=(t[o]-t[a])*(t[a+1]+t[o+1]),o=a;return i}e.exports=n,n.deviation=function(t,e,r,n){var i=e&&e.length,a=i?e[0]*r:t.length,o=Math.abs(z(t,0,a,r));if(i)for(var s=0,l=e.length;s<l;s++){var u=e[s]*r,c=s<l-1?e[s+1]*r:t.length;o-=Math.abs(z(t,u,c,r))}var h=0;for(s=0;s<n.length;s+=3){var f=n[s]*r,d=n[s+1]*r,p=n[s+2]*r;h+=Math.abs((t[f]-t[p])*(t[d+1]-t[f+1])-(t[f]-t[d])*(t[p+1]-t[f+1]))}return 0===o&&0===h?0:Math.abs((h-o)/o)},n.flatten=function(t){for(var e=t[0][0].length,r={vertices:[],holes:[],dimensions:e},n=0,i=0;i<t.length;i++){for(var a=0;a<t[i].length;a++)for(var o=0;o<e;o++)r.vertices.push(t[i][a][o]);i>0&&(n+=t[i-1].length,r.holes.push(n))}return r}},{}],126:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length;if(\"number\"!=typeof e){e=0;for(var n=0;n<r;++n){var a=t[n];e=Math.max(e,a[0],a[1])}e=1+(0|e)}e|=0;for(var o=new Array(e),n=0;n<e;++n)o[n]=[];for(var n=0;n<r;++n){var a=t[n];o[a[0]].push(a[1]),o[a[1]].push(a[0])}for(var s=0;s<e;++s)i(o[s],function(t,e){return t-e});return o}e.exports=n;var i=t(\"uniq\")},{uniq:542}],127:[function(e,r,n){(function(i,a){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.ES6Promise=i()}(this,function(){\"use strict\";function t(t){return\"function\"==typeof t||\"object\"==typeof t&&null!==t}function r(t){return\"function\"==typeof t}function n(t){G=t}function o(t){Y=t}function s(){return function(){q(u)}}function l(){var t=setTimeout;return function(){return t(u,1)}}function u(){for(var t=0;t<H;t+=2){(0,Q[t])(Q[t+1]),Q[t]=void 0,Q[t+1]=void 0}H=0}function c(t,e){var r=arguments,n=this,i=new this.constructor(f);void 0===i[tt]&&z(i);var a=n._state;return a?function(){var t=r[a-1];Y(function(){return E(a,i,t,n._result)})}():k(n,i,t,e),i}function h(t){var e=this;if(t&&\"object\"==typeof t&&t.constructor===e)return t;var r=new e(f);return x(r,t),r}function f(){}function d(){return new TypeError(\"You cannot resolve a promise with itself\")}function p(){return new TypeError(\"A promises callback cannot return that same promise.\")}function m(t){try{return t.then}catch(t){return it.error=t,it}}function v(t,e,r,n){try{t.call(e,r,n)}catch(t){return t}}function g(t,e,r){Y(function(t){var n=!1,i=v(r,e,function(r){n||(n=!0,e!==r?x(t,r):w(t,r))},function(e){n||(n=!0,M(t,e))},\"Settle: \"+(t._label||\" unknown promise\"));!n&&i&&(n=!0,M(t,i))},t)}function y(t,e){e._state===rt?w(t,e._result):e._state===nt?M(t,e._result):k(e,void 0,function(e){return x(t,e)},function(e){return M(t,e)})}function b(t,e,n){e.constructor===t.constructor&&n===c&&e.constructor.resolve===h?y(t,e):n===it?M(t,it.error):void 0===n?w(t,e):r(n)?g(t,e,n):w(t,e)}function x(e,r){e===r?M(e,d()):t(r)?b(e,r,m(r)):w(e,r)}function _(t){t._onerror&&t._onerror(t._result),A(t)}function w(t,e){t._state===et&&(t._result=e,t._state=rt,0!==t._subscribers.length&&Y(A,t))}function M(t,e){t._state===et&&(t._state=nt,t._result=e,Y(_,t))}function k(t,e,r,n){var i=t._subscribers,a=i.length;t._onerror=null,i[a]=e,i[a+rt]=r,i[a+nt]=n,0===a&&t._state&&Y(A,t)}function A(t){var e=t._subscribers,r=t._state;if(0!==e.length){for(var n=void 0,i=void 0,a=t._result,o=0;o<e.length;o+=3)n=e[o],i=e[o+r],n?E(r,n,i,a):i(a);t._subscribers.length=0}}function T(){this.error=null}function S(t,e){try{return t(e)}catch(t){return at.error=t,at}}function E(t,e,n,i){var a=r(n),o=void 0,s=void 0,l=void 0,u=void 0;if(a){if(o=S(n,i),o===at?(u=!0,s=o.error,o=null):l=!0,e===o)return void M(e,p())}else o=i,l=!0;e._state!==et||(a&&l?x(e,o):u?M(e,s):t===rt?w(e,o):t===nt&&M(e,o))}function L(t,e){try{e(function(e){x(t,e)},function(e){M(t,e)})}catch(e){M(t,e)}}function C(){return ot++}function z(t){t[tt]=ot++,t._state=void 0,t._result=void 0,t._subscribers=[]}function I(t,e){this._instanceConstructor=t,this.promise=new t(f),this.promise[tt]||z(this.promise),V(e)?(this._input=e,this.length=e.length,this._remaining=e.length,this._result=new Array(this.length),0===this.length?w(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&w(this.promise,this._result))):M(this.promise,D())}function D(){return new Error(\"Array Methods must be provided an Array\")}function P(t){return new I(this,t).promise}function O(t){var e=this;return new e(V(t)?function(r,n){for(var i=t.length,a=0;a<i;a++)e.resolve(t[a]).then(r,n)}:function(t,e){return e(new TypeError(\"You must pass an array to race.\"))})}function R(t){var e=this,r=new e(f);return M(r,t),r}function F(){throw new TypeError(\"You must pass a resolver function as the first argument to the promise constructor\")}function j(){throw new TypeError(\"Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.\")}function N(t){this[tt]=C(),this._result=this._state=void 0,this._subscribers=[],f!==t&&(\"function\"!=typeof t&&F(),this instanceof N?L(this,t):j())}function B(){var t=void 0;if(void 0!==a)t=a;else if(\"undefined\"!=typeof self)t=self;else try{t=Function(\"return this\")()}catch(t){throw new Error(\"polyfill failed because global object is unavailable in this environment\")}var e=t.Promise;if(e){var r=null;try{r=Object.prototype.toString.call(e.resolve())}catch(t){}if(\"[object Promise]\"===r&&!e.cast)return}t.Promise=N}var U=void 0;U=Array.isArray?Array.isArray:function(t){return\"[object Array]\"===Object.prototype.toString.call(t)};var V=U,H=0,q=void 0,G=void 0,Y=function(t,e){Q[H]=t,Q[H+1]=e,2===(H+=2)&&(G?G(u):$())},X=\"undefined\"!=typeof window?window:void 0,W=X||{},Z=W.MutationObserver||W.WebKitMutationObserver,J=\"undefined\"==typeof self&&void 0!==i&&\"[object process]\"==={}.toString.call(i),K=\"undefined\"!=typeof Uint8ClampedArray&&\"undefined\"!=typeof importScripts&&\"undefined\"!=typeof MessageChannel,Q=new Array(1e3),$=void 0;$=J?function(){return function(){return i.nextTick(u)}}():Z?function(){var t=0,e=new Z(u),r=document.createTextNode(\"\");return e.observe(r,{characterData:!0}),function(){r.data=t=++t%2}}():K?function(){var t=new MessageChannel;return t.port1.onmessage=u,function(){return t.port2.postMessage(0)}}():void 0===X&&\"function\"==typeof e?function(){try{var t=e,r=t(\"vertx\");return q=r.runOnLoop||r.runOnContext,s()}catch(t){return l()}}():l();var tt=Math.random().toString(36).substring(16),et=void 0,rt=1,nt=2,it=new T,at=new T,ot=0;return I.prototype._enumerate=function(){for(var t=this.length,e=this._input,r=0;this._state===et&&r<t;r++)this._eachEntry(e[r],r)},I.prototype._eachEntry=function(t,e){var r=this._instanceConstructor,n=r.resolve;if(n===h){var i=m(t);if(i===c&&t._state!==et)this._settledAt(t._state,e,t._result);else if(\"function\"!=typeof i)this._remaining--,this._result[e]=t;else if(r===N){var a=new r(f);b(a,t,i),this._willSettleAt(a,e)}else this._willSettleAt(new r(function(e){return e(t)}),e)}else this._willSettleAt(n(t),e)},I.prototype._settledAt=function(t,e,r){var n=this.promise;n._state===et&&(this._remaining--,t===nt?M(n,r):this._result[e]=r),0===this._remaining&&w(n,this._result)},I.prototype._willSettleAt=function(t,e){var r=this;k(t,void 0,function(t){return r._settledAt(rt,e,t)},function(t){return r._settledAt(nt,e,t)})},N.all=P,N.race=O,N.resolve=h,N.reject=R,N._setScheduler=n,N._setAsap=o,N._asap=Y,N.prototype={constructor:N,then:c,catch:function(t){return this.then(null,t)}},B(),N.polyfill=B,N.Promise=N,N})}).call(this,e(\"_process\"),\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{_process:486}],128:[function(t,e,r){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function i(t){return\"function\"==typeof t}function a(t){return\"number\"==typeof t}function o(t){return\"object\"==typeof t&&null!==t}function s(t){return void 0===t}e.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(t){if(!a(t)||t<0||isNaN(t))throw TypeError(\"n must be a positive number\");return this._maxListeners=t,this},n.prototype.emit=function(t){var e,r,n,a,l,u;if(this._events||(this._events={}),\"error\"===t&&(!this._events.error||o(this._events.error)&&!this._events.error.length)){if((e=arguments[1])instanceof Error)throw e;var c=new Error('Uncaught, unspecified \"error\" event. ('+e+\")\");throw c.context=e,c}if(r=this._events[t],s(r))return!1;if(i(r))switch(arguments.length){case 1:r.call(this);break;case 2:r.call(this,arguments[1]);break;case 3:r.call(this,arguments[1],arguments[2]);break;default:a=Array.prototype.slice.call(arguments,1),r.apply(this,a)}else if(o(r))for(a=Array.prototype.slice.call(arguments,1),u=r.slice(),n=u.length,l=0;l<n;l++)u[l].apply(this,a);return!0},n.prototype.addListener=function(t,e){var r;if(!i(e))throw TypeError(\"listener must be a function\");return this._events||(this._events={}),this._events.newListener&&this.emit(\"newListener\",t,i(e.listener)?e.listener:e),this._events[t]?o(this._events[t])?this._events[t].push(e):this._events[t]=[this._events[t],e]:this._events[t]=e,o(this._events[t])&&!this._events[t].warned&&(r=s(this._maxListeners)?n.defaultMaxListeners:this._maxListeners)&&r>0&&this._events[t].length>r&&(this._events[t].warned=!0,console.error(\"(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.\",this._events[t].length),\"function\"==typeof console.trace&&console.trace()),this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(t,e){function r(){this.removeListener(t,r),n||(n=!0,e.apply(this,arguments))}if(!i(e))throw TypeError(\"listener must be a function\");var n=!1;return r.listener=e,this.on(t,r),this},n.prototype.removeListener=function(t,e){var r,n,a,s;if(!i(e))throw TypeError(\"listener must be a function\");if(!this._events||!this._events[t])return this;if(r=this._events[t],a=r.length,n=-1,r===e||i(r.listener)&&r.listener===e)delete this._events[t],this._events.removeListener&&this.emit(\"removeListener\",t,e);else if(o(r)){\n",
       "for(s=a;s-- >0;)if(r[s]===e||r[s].listener&&r[s].listener===e){n=s;break}if(n<0)return this;1===r.length?(r.length=0,delete this._events[t]):r.splice(n,1),this._events.removeListener&&this.emit(\"removeListener\",t,e)}return this},n.prototype.removeAllListeners=function(t){var e,r;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[t]&&delete this._events[t],this;if(0===arguments.length){for(e in this._events)\"removeListener\"!==e&&this.removeAllListeners(e);return this.removeAllListeners(\"removeListener\"),this._events={},this}if(r=this._events[t],i(r))this.removeListener(t,r);else if(r)for(;r.length;)this.removeListener(t,r[r.length-1]);return delete this._events[t],this},n.prototype.listeners=function(t){return this._events&&this._events[t]?i(this._events[t])?[this._events[t]]:this._events[t].slice():[]},n.prototype.listenerCount=function(t){if(this._events){var e=this._events[t];if(i(e))return 1;if(e)return e.length}return 0},n.listenerCount=function(t,e){return t.listenerCount(e)}},{}],129:[function(t,e,r){\"use strict\";function n(t,e,r){var n=e||0,i=r||1;return[[t[12]+t[0],t[13]+t[1],t[14]+t[2],t[15]+t[3]],[t[12]-t[0],t[13]-t[1],t[14]-t[2],t[15]-t[3]],[t[12]+t[4],t[13]+t[5],t[14]+t[6],t[15]+t[7]],[t[12]-t[4],t[13]-t[5],t[14]-t[6],t[15]-t[7]],[n*t[12]+t[8],n*t[13]+t[9],n*t[14]+t[10],n*t[15]+t[11]],[i*t[12]-t[8],i*t[13]-t[9],i*t[14]-t[10],i*t[15]-t[11]]]}e.exports=n},{}],130:[function(t,e,r){\"use strict\";function n(t){for(var e,r=t.length,n=0;n<r;n++)if(((e=t.charCodeAt(n))<9||e>13)&&32!==e&&133!==e&&160!==e&&5760!==e&&6158!==e&&(e<8192||e>8205)&&8232!==e&&8233!==e&&8239!==e&&8287!==e&&8288!==e&&12288!==e&&65279!==e)return!1;return!0}e.exports=function(t){var e=typeof t;if(\"string\"===e){var r=t;if(0===(t=+t)&&n(r))return!1}else if(\"number\"!==e)return!1;return t-t<1}},{}],131:[function(t,e,r){\"use strict\";function n(t){return new Function(\"f\",\"var p = (f && f.properties || {}); return \"+i(t))}function i(t){if(!t)return\"true\";var e=t[0];return t.length<=1?\"any\"===e?\"false\":\"true\":\"(\"+(\"==\"===e?o(t[1],t[2],\"===\",!1):\"!=\"===e?o(t[1],t[2],\"!==\",!1):\"<\"===e||\">\"===e||\"<=\"===e||\">=\"===e?o(t[1],t[2],e,!0):\"any\"===e?s(t.slice(1),\"||\"):\"all\"===e?s(t.slice(1),\"&&\"):\"none\"===e?c(s(t.slice(1),\"||\")):\"in\"===e?l(t[1],t.slice(2)):\"!in\"===e?c(l(t[1],t.slice(2))):\"has\"===e?u(t[1]):\"!has\"===e?c(u([t[1]])):\"true\")+\")\"}function a(t){return\"$type\"===t?\"f.type\":\"$id\"===t?\"f.id\":\"p[\"+JSON.stringify(t)+\"]\"}function o(t,e,r,n){var i=a(t),o=\"$type\"===t?f.indexOf(e):JSON.stringify(e);return(n?\"typeof \"+i+\"=== typeof \"+o+\"&&\":\"\")+i+r+o}function s(t,e){return t.map(i).join(e)}function l(t,e){\"$type\"===t&&(e=e.map(function(t){return f.indexOf(t)}));var r=JSON.stringify(e.sort(h)),n=a(t);return e.length<=200?r+\".indexOf(\"+n+\") !== -1\":\"function(v, a, i, j) {while (i <= j) { var m = (i + j) >> 1;    if (a[m] === v) return true; if (a[m] > v) j = m - 1; else i = m + 1;}return false; }(\"+n+\", \"+r+\",0,\"+(e.length-1)+\")\"}function u(t){return JSON.stringify(t)+\" in p\"}function c(t){return\"!(\"+t+\")\"}function h(t,e){return t<e?-1:t>e?1:0}e.exports=n;var f=[\"Unknown\",\"Point\",\"LineString\",\"Polygon\"]},{}],132:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.min(e,Math.max(t,r))}function i(t,e,r){this.dimension=t.length,this.bounds=[new Array(this.dimension),new Array(this.dimension)];for(var n=0;n<this.dimension;++n)this.bounds[0][n]=-1/0,this.bounds[1][n]=1/0;this._state=t.slice().reverse(),this._velocity=e.slice().reverse(),this._time=[r],this._scratch=[t.slice(),t.slice(),t.slice(),t.slice(),t.slice()]}function a(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=0;return e}function o(t,e,r){switch(arguments.length){case 0:return new i([0],[0],0);case 1:if(\"number\"==typeof t){var n=a(t);return new i(n,n,0)}return new i(t,a(t.length),0);case 2:if(\"number\"==typeof e){var n=a(t.length);return new i(t,n,+e)}r=0;case 3:if(t.length!==e.length)throw new Error(\"state and velocity lengths must match\");return new i(t,e,r)}}e.exports=o;var s=t(\"cubic-hermite\"),l=t(\"binary-search-bounds\"),u=i.prototype;u.flush=function(t){var e=l.gt(this._time,t)-1;e<=0||(this._time.splice(0,e),this._state.splice(0,e*this.dimension),this._velocity.splice(0,e*this.dimension))},u.curve=function(t){var e=this._time,r=e.length,i=l.le(e,t),a=this._scratch[0],o=this._state,u=this._velocity,c=this.dimension,h=this.bounds;if(i<0)for(var f=c-1,d=0;d<c;++d,--f)a[d]=o[f];else if(i>=r-1)for(var f=o.length-1,p=t-e[r-1],d=0;d<c;++d,--f)a[d]=o[f]+p*u[f];else{for(var f=c*(i+1)-1,m=e[i],v=e[i+1],g=v-m||1,y=this._scratch[1],b=this._scratch[2],x=this._scratch[3],_=this._scratch[4],w=!0,d=0;d<c;++d,--f)y[d]=o[f],x[d]=u[f]*g,b[d]=o[f+c],_[d]=u[f+c]*g,w=w&&y[d]===b[d]&&x[d]===_[d]&&0===x[d];if(w)for(var d=0;d<c;++d)a[d]=y[d];else s(y,x,b,_,(t-m)/g,a)}for(var M=h[0],k=h[1],d=0;d<c;++d)a[d]=n(M[d],k[d],a[d]);return a},u.dcurve=function(t){var e=this._time,r=e.length,n=l.le(e,t),i=this._scratch[0],a=this._state,o=this._velocity,u=this.dimension;if(n>=r-1)for(var c=a.length-1,h=(e[r-1],0);h<u;++h,--c)i[h]=o[c];else{for(var c=u*(n+1)-1,f=e[n],d=e[n+1],p=d-f||1,m=this._scratch[1],v=this._scratch[2],g=this._scratch[3],y=this._scratch[4],b=!0,h=0;h<u;++h,--c)m[h]=a[c],g[h]=o[c]*p,v[h]=a[c+u],y[h]=o[c+u]*p,b=b&&m[h]===v[h]&&g[h]===y[h]&&0===g[h];if(b)for(var h=0;h<u;++h)i[h]=0;else{s.derivative(m,g,v,y,(t-f)/p,i);for(var h=0;h<u;++h)i[h]/=p}}return i},u.lastT=function(){var t=this._time;return t[t.length-1]},u.stable=function(){for(var t=this._velocity,e=t.length,r=this.dimension-1;r>=0;--r)if(t[--e])return!1;return!0},u.jump=function(t){var e=this.lastT(),r=this.dimension;if(!(t<e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=this.bounds,l=s[0],u=s[1];this._time.push(e,t);for(var c=0;c<2;++c)for(var h=0;h<r;++h)i.push(i[o++]),a.push(0);this._time.push(t);for(var h=r;h>0;--h)i.push(n(l[h-1],u[h-1],arguments[h])),a.push(0)}},u.push=function(t){var e=this.lastT(),r=this.dimension;if(!(t<e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=t-e,l=this.bounds,u=l[0],c=l[1],h=s>1e-6?1/s:0;this._time.push(t);for(var f=r;f>0;--f){var d=n(u[f-1],c[f-1],arguments[f]);i.push(d),a.push((d-i[o++])*h)}}},u.set=function(t){var e=this.dimension;if(!(t<this.lastT()||arguments.length!==e+1)){var r=this._state,i=this._velocity,a=this.bounds,o=a[0],s=a[1];this._time.push(t);for(var l=e;l>0;--l)r.push(n(o[l-1],s[l-1],arguments[l])),i.push(0)}},u.move=function(t){var e=this.lastT(),r=this.dimension;if(!(t<=e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=this.bounds,l=s[0],u=s[1],c=t-e,h=c>1e-6?1/c:0;this._time.push(t);for(var f=r;f>0;--f){var d=arguments[f];i.push(n(l[f-1],u[f-1],i[o++]+d)),a.push(d*h)}}},u.idle=function(t){var e=this.lastT();if(!(t<e)){var r=this.dimension,i=this._state,a=this._velocity,o=i.length-r,s=this.bounds,l=s[0],u=s[1],c=t-e;this._time.push(t);for(var h=r-1;h>=0;--h)i.push(n(l[h],u[h],i[o]+c*a[o])),a.push(0),o+=1}}},{\"binary-search-bounds\":65,\"cubic-hermite\":108}],133:[function(t,e,r){\"use strict\";function n(t){t=t||{};var e,r,n=t.canvas||document.createElement(\"canvas\"),o=t.family||\"sans-serif\",s=t.shape||[512,512],l=t.step||[32,32],u=parseFloat(t.size)||16,c=t.chars||[32,126],h=Math.floor((l[0]-u)/2),f=t.radius||1.5*h,d=new a(u,h,f,0,o),p=null==t.align?\"optical\":t.align,m=null==t.fit||1==t.fit?.5:t.fit;if(Array.isArray(c)){if(2===c.length&&\"number\"==typeof c[0]&&\"number\"==typeof c[1]){var v=[];for(e=c[0],r=0;e<=c[1];e++)v[r++]=String.fromCharCode(e);c=v}}else c=String(c).split(\"\");s=s.slice(),n.width=s[0],n.height=s[1];var g=n.getContext(\"2d\");g.fillStyle=\"#000\",g.fillRect(0,0,n.width,n.height),g.textBaseline=\"middle\";var y=l[0],b=l[1],x=0,_=0,w=u/b,M=Math.min(c.length,Math.floor(s[0]/y)*Math.ceil(s[1]/b)),k=d.ctx.textAlign,A=d.buffer,T=d.middle;for(d.ctx.textAlign=\"center\",d.buffer=d.size/2,e=0;e<M;e++)if(c[e]){var S=i(c[e],o,w),E=1,L=[0,0];if(m){var C=m;Array.isArray(m)&&(C=m[e]);var z=.5*(S.bounds[3]-S.bounds[1]),I=.5*(S.bounds[2]-S.bounds[0]),D=Math.max(z,I),P=Math.sqrt(z*z+I*I),O=.333*S.radius+.333*D+.333*P;E=b*C/(O*b*2),d.ctx.font=u*E+\"px \"+o}else d.ctx.font=u+\"px \"+o;p&&(L=\"optical\"===p||!0===p?[.5*y-y*S.center[0],.5*b-b*S.center[1]]:[.5*y-y*(S.bounds[2]+S.bounds[0])*.5,.5*b-b*(S.bounds[3]+S.bounds[1])*.5],d.middle=T+L[1]*E);var R=d.draw(c[e]);g.putImageData(R,x+L[0]*E,_),x+=l[0],x>s[0]-l[0]&&(x=0,_+=l[1])}return d.ctx.textAlign=k,d.buffer=A,d.middle=T,n}function i(t,e,r){if(s[e]&&s[e][t])return s[e][t];var n=200*r,i=o(t,{size:200,fontSize:n,fontFamily:e});s[e]||(s[e]={});var a={center:[i.center[0]/200,i.center[1]/200],bounds:i.bounds.map(function(t){return t/200}),radius:i.radius/200};return s[e][t]=a,a}var a=t(\"tiny-sdf\"),o=t(\"optical-properties\");e.exports=n;var s={}},{\"optical-properties\":470,\"tiny-sdf\":532}],134:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this._color=t,this.key=e,this.value=r,this.left=n,this.right=i,this._count=a}function i(t){return new n(t._color,t.key,t.value,t.left,t.right,t._count)}function a(t,e){return new n(t,e.key,e.value,e.left,e.right,e._count)}function o(t){t._count=1+(t.left?t.left._count:0)+(t.right?t.right._count:0)}function s(t,e){this._compare=t,this.root=e}function l(t,e){if(e.left){var r=l(t,e.left);if(r)return r}var r=t(e.key,e.value);return r||(e.right?l(t,e.right):void 0)}function u(t,e,r,n){if(e(t,n.key)<=0){if(n.left){var i=u(t,e,r,n.left);if(i)return i}var i=r(n.key,n.value);if(i)return i}if(n.right)return u(t,e,r,n.right)}function c(t,e,r,n,i){var a,o=r(t,i.key),s=r(e,i.key);if(o<=0){if(i.left&&(a=c(t,e,r,n,i.left)))return a;if(s>0&&(a=n(i.key,i.value)))return a}if(s>0&&i.right)return c(t,e,r,n,i.right)}function h(t,e){this.tree=t,this._stack=e}function f(t,e){t.key=e.key,t.value=e.value,t.left=e.left,t.right=e.right,t._color=e._color,t._count=e._count}function d(t){for(var e,r,n,s,l=t.length-1;l>=0;--l){if(e=t[l],0===l)return void(e._color=g);if(r=t[l-1],r.left===e){if(n=r.right,n.right&&n.right._color===v){if(n=r.right=i(n),s=n.right=i(n.right),r.right=n.left,n.left=r,n.right=s,n._color=r._color,e._color=g,r._color=g,s._color=g,o(r),o(n),l>1){var u=t[l-2];u.left===r?u.left=n:u.right=n}return void(t[l-1]=n)}if(n.left&&n.left._color===v){if(n=r.right=i(n),s=n.left=i(n.left),r.right=s.left,n.left=s.right,s.left=r,s.right=n,s._color=r._color,r._color=g,n._color=g,e._color=g,o(r),o(n),o(s),l>1){var u=t[l-2];u.left===r?u.left=s:u.right=s}return void(t[l-1]=s)}if(n._color===g){if(r._color===v)return r._color=g,void(r.right=a(v,n));r.right=a(v,n);continue}if(n=i(n),r.right=n.left,n.left=r,n._color=r._color,r._color=v,o(r),o(n),l>1){var u=t[l-2];u.left===r?u.left=n:u.right=n}t[l-1]=n,t[l]=r,l+1<t.length?t[l+1]=e:t.push(e),l+=2}else{if(n=r.left,n.left&&n.left._color===v){if(n=r.left=i(n),s=n.left=i(n.left),r.left=n.right,n.right=r,n.left=s,n._color=r._color,e._color=g,r._color=g,s._color=g,o(r),o(n),l>1){var u=t[l-2];u.right===r?u.right=n:u.left=n}return void(t[l-1]=n)}if(n.right&&n.right._color===v){if(n=r.left=i(n),s=n.right=i(n.right),r.left=s.right,n.right=s.left,s.right=r,s.left=n,s._color=r._color,r._color=g,n._color=g,e._color=g,o(r),o(n),o(s),l>1){var u=t[l-2];u.right===r?u.right=s:u.left=s}return void(t[l-1]=s)}if(n._color===g){if(r._color===v)return r._color=g,void(r.left=a(v,n));r.left=a(v,n);continue}if(n=i(n),r.left=n.right,n.right=r,n._color=r._color,r._color=v,o(r),o(n),l>1){var u=t[l-2];u.right===r?u.right=n:u.left=n}t[l-1]=n,t[l]=r,l+1<t.length?t[l+1]=e:t.push(e),l+=2}}}function p(t,e){return t<e?-1:t>e?1:0}function m(t){return new s(t||p,null)}e.exports=m;var v=0,g=1,y=s.prototype;Object.defineProperty(y,\"keys\",{get:function(){var t=[];return this.forEach(function(e,r){t.push(e)}),t}}),Object.defineProperty(y,\"values\",{get:function(){var t=[];return this.forEach(function(e,r){t.push(r)}),t}}),Object.defineProperty(y,\"length\",{get:function(){return this.root?this.root._count:0}}),y.insert=function(t,e){for(var r=this._compare,i=this.root,l=[],u=[];i;){var c=r(t,i.key);l.push(i),u.push(c),i=c<=0?i.left:i.right}l.push(new n(v,t,e,null,null,1));for(var h=l.length-2;h>=0;--h){var i=l[h];u[h]<=0?l[h]=new n(i._color,i.key,i.value,l[h+1],i.right,i._count+1):l[h]=new n(i._color,i.key,i.value,i.left,l[h+1],i._count+1)}for(var h=l.length-1;h>1;--h){var f=l[h-1],i=l[h];if(f._color===g||i._color===g)break;var d=l[h-2];if(d.left===f)if(f.left===i){var p=d.right;if(!p||p._color!==v){if(d._color=v,d.left=f.right,f._color=g,f.right=d,l[h-2]=f,l[h-1]=i,o(d),o(f),h>=3){var m=l[h-3];m.left===d?m.left=f:m.right=f}break}f._color=g,d.right=a(g,p),d._color=v,h-=1}else{var p=d.right;if(!p||p._color!==v){if(f.right=i.left,d._color=v,d.left=i.right,i._color=g,i.left=f,i.right=d,l[h-2]=i,l[h-1]=f,o(d),o(f),o(i),h>=3){var m=l[h-3];m.left===d?m.left=i:m.right=i}break}f._color=g,d.right=a(g,p),d._color=v,h-=1}else if(f.right===i){var p=d.left;if(!p||p._color!==v){if(d._color=v,d.right=f.left,f._color=g,f.left=d,l[h-2]=f,l[h-1]=i,o(d),o(f),h>=3){var m=l[h-3];m.right===d?m.right=f:m.left=f}break}f._color=g,d.left=a(g,p),d._color=v,h-=1}else{var p=d.left;if(!p||p._color!==v){if(f.left=i.right,d._color=v,d.right=i.left,i._color=g,i.right=f,i.left=d,l[h-2]=i,l[h-1]=f,o(d),o(f),o(i),h>=3){var m=l[h-3];m.right===d?m.right=i:m.left=i}break}f._color=g,d.left=a(g,p),d._color=v,h-=1}}return l[0]._color=g,new s(r,l[0])},y.forEach=function(t,e,r){if(this.root)switch(arguments.length){case 1:return l(t,this.root);case 2:return u(e,this._compare,t,this.root);case 3:if(this._compare(e,r)>=0)return;return c(e,r,this._compare,t,this.root)}},Object.defineProperty(y,\"begin\",{get:function(){for(var t=[],e=this.root;e;)t.push(e),e=e.left;return new h(this,t)}}),Object.defineProperty(y,\"end\",{get:function(){for(var t=[],e=this.root;e;)t.push(e),e=e.right;return new h(this,t)}}),y.at=function(t){if(t<0)return new h(this,[]);for(var e=this.root,r=[];;){if(r.push(e),e.left){if(t<e.left._count){e=e.left;continue}t-=e.left._count}if(!t)return new h(this,r);if(t-=1,!e.right)break;if(t>=e.right._count)break;e=e.right}return new h(this,[])},y.ge=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a<=0&&(i=n.length),r=a<=0?r.left:r.right}return n.length=i,new h(this,n)},y.gt=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a<0&&(i=n.length),r=a<0?r.left:r.right}return n.length=i,new h(this,n)},y.lt=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a>0&&(i=n.length),r=a<=0?r.left:r.right}return n.length=i,new h(this,n)},y.le=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a>=0&&(i=n.length),r=a<0?r.left:r.right}return n.length=i,new h(this,n)},y.find=function(t){for(var e=this._compare,r=this.root,n=[];r;){var i=e(t,r.key);if(n.push(r),0===i)return new h(this,n);r=i<=0?r.left:r.right}return new h(this,[])},y.remove=function(t){var e=this.find(t);return e?e.remove():this},y.get=function(t){for(var e=this._compare,r=this.root;r;){var n=e(t,r.key);if(0===n)return r.value;r=n<=0?r.left:r.right}};var b=h.prototype;Object.defineProperty(b,\"valid\",{get:function(){return this._stack.length>0}}),Object.defineProperty(b,\"node\",{get:function(){return this._stack.length>0?this._stack[this._stack.length-1]:null},enumerable:!0}),b.clone=function(){return new h(this.tree,this._stack.slice())},b.remove=function(){var t=this._stack;if(0===t.length)return this.tree;var e=new Array(t.length),r=t[t.length-1];e[e.length-1]=new n(r._color,r.key,r.value,r.left,r.right,r._count);for(var i=t.length-2;i>=0;--i){var r=t[i];r.left===t[i+1]?e[i]=new n(r._color,r.key,r.value,e[i+1],r.right,r._count):e[i]=new n(r._color,r.key,r.value,r.left,e[i+1],r._count)}if(r=e[e.length-1],r.left&&r.right){var a=e.length;for(r=r.left;r.right;)e.push(r),r=r.right;var o=e[a-1];e.push(new n(r._color,o.key,o.value,r.left,r.right,r._count)),e[a-1].key=r.key,e[a-1].value=r.value;for(var i=e.length-2;i>=a;--i)r=e[i],e[i]=new n(r._color,r.key,r.value,r.left,e[i+1],r._count);e[a-1].left=e[a]}if(r=e[e.length-1],r._color===v){var l=e[e.length-2];l.left===r?l.left=null:l.right===r&&(l.right=null),e.pop();for(var i=0;i<e.length;++i)e[i]._count--;return new s(this.tree._compare,e[0])}if(r.left||r.right){r.left?f(r,r.left):r.right&&f(r,r.right),r._color=g;for(var i=0;i<e.length-1;++i)e[i]._count--;return new s(this.tree._compare,e[0])}if(1===e.length)return new s(this.tree._compare,null);for(var i=0;i<e.length;++i)e[i]._count--;var u=e[e.length-2];return d(e),u.left===r?u.left=null:u.right=null,new s(this.tree._compare,e[0])},Object.defineProperty(b,\"key\",{get:function(){if(this._stack.length>0)return this._stack[this._stack.length-1].key},enumerable:!0}),Object.defineProperty(b,\"value\",{get:function(){if(this._stack.length>0)return this._stack[this._stack.length-1].value},enumerable:!0}),Object.defineProperty(b,\"index\",{get:function(){var t=0,e=this._stack;if(0===e.length){var r=this.tree.root;return r?r._count:0}e[e.length-1].left&&(t=e[e.length-1].left._count);for(var n=e.length-2;n>=0;--n)e[n+1]===e[n].right&&(++t,e[n].left&&(t+=e[n].left._count));return t},enumerable:!0}),b.next=function(){var t=this._stack;if(0!==t.length){var e=t[t.length-1];if(e.right)for(e=e.right;e;)t.push(e),e=e.left;else for(t.pop();t.length>0&&t[t.length-1].right===e;)e=t[t.length-1],t.pop()}},Object.defineProperty(b,\"hasNext\",{get:function(){var t=this._stack;if(0===t.length)return!1;if(t[t.length-1].right)return!0;for(var e=t.length-1;e>0;--e)if(t[e-1].left===t[e])return!0;return!1}}),b.update=function(t){var e=this._stack;if(0===e.length)throw new Error(\"Can't update empty node!\");var r=new Array(e.length),i=e[e.length-1];r[r.length-1]=new n(i._color,i.key,t,i.left,i.right,i._count);for(var a=e.length-2;a>=0;--a)i=e[a],i.left===e[a+1]?r[a]=new n(i._color,i.key,i.value,r[a+1],i.right,i._count):r[a]=new n(i._color,i.key,i.value,i.left,r[a+1],i._count);return new s(this.tree._compare,r[0])},b.prev=function(){var t=this._stack;if(0!==t.length){var e=t[t.length-1];if(e.left)for(e=e.left;e;)t.push(e),e=e.right;else for(t.pop();t.length>0&&t[t.length-1].left===e;)e=t[t.length-1],t.pop()}},Object.defineProperty(b,\"hasPrev\",{get:function(){var t=this._stack;if(0===t.length)return!1;if(t[t.length-1].left)return!0;for(var e=t.length-1;e>0;--e)if(t[e-1].right===t[e])return!0;return!1}})},{}],135:[function(t,e,r){function n(t){if(t<0)return Number(\"0/0\");for(var e=o[0],r=o.length-1;r>0;--r)e+=o[r]/(t+r);var n=t+a+.5;return.5*Math.log(2*Math.PI)+(t+.5)*Math.log(n)-n+Math.log(e)-Math.log(t)}var i=[.9999999999998099,676.5203681218851,-1259.1392167224028,771.3234287776531,-176.6150291621406,12.507343278686905,-.13857109526572012,9984369578019572e-21,1.5056327351493116e-7],a=607/128,o=[.9999999999999971,57.15623566586292,-59.59796035547549,14.136097974741746,-.4919138160976202,3399464998481189e-20,4652362892704858e-20,-9837447530487956e-20,.0001580887032249125,-.00021026444172410488,.00021743961811521265,-.0001643181065367639,8441822398385275e-20,-26190838401581408e-21,36899182659531625e-22];e.exports=function t(e){if(e<.5)return Math.PI/(Math.sin(Math.PI*e)*t(1-e));if(e>100)return Math.exp(n(e));e-=1;for(var r=i[0],a=1;a<9;a++)r+=i[a]/(e+a);var o=e+7+.5;return Math.sqrt(2*Math.PI)*Math.pow(o,e+.5)*Math.exp(-o)*r},e.exports.log=n},{}],136:[function(t,e,r){function n(t){if(\"Polygon\"===t.type)return i(t.coordinates);if(\"MultiPolygon\"===t.type){for(var e=0,r=0;r<t.coordinates.length;r++)e+=i(t.coordinates[r]);return e}return null}function i(t){var e=0;if(t&&t.length>0){e+=Math.abs(a(t[0]));for(var r=1;r<t.length;r++)e-=Math.abs(a(t[r]))}return e}function a(t){var e=0;if(t.length>2){for(var r,n,i=0;i<t.length-1;i++)r=t[i],n=t[i+1],e+=o(n[0]-r[0])*(2+Math.sin(o(r[1]))+Math.sin(o(n[1])));e=e*s.RADIUS*s.RADIUS/2}return e}function o(t){return t*Math.PI/180}var s=t(\"wgs84\");e.exports.geometry=n,e.exports.ring=a},{wgs84:564}],137:[function(t,e,r){function n(t,e){switch(t&&t.type||null){case\"FeatureCollection\":return t.features=t.features.map(i(n,e)),t;case\"Feature\":return t.geometry=n(t.geometry,e),t;case\"Polygon\":case\"MultiPolygon\":return a(t,e);default:return t}}function i(t,e){return function(r){return t(r,e)}}function a(t,e){return\"Polygon\"===t.type?t.coordinates=o(t.coordinates,e):\"MultiPolygon\"===t.type&&(t.coordinates=t.coordinates.map(i(o,e))),t}function o(t,e){e=!!e,t[0]=s(t[0],!e);for(var r=1;r<t.length;r++)t[r]=s(t[r],e);return t}function s(t,e){return l(t)===e?t:t.reverse()}function l(t){return u.ring(t)>=0}var u=t(\"geojson-area\");e.exports=n},{\"geojson-area\":136}],138:[function(t,e,r){\"use strict\";function n(t,e,r,n,o,l,u,c){if(r/=e,n/=e,u>=r&&c<=n)return t;if(u>n||c<r)return null;for(var h=[],f=0;f<t.length;f++){var d,p,m=t[f],v=m.geometry,g=m.type;if(d=m.min[o],p=m.max[o],d>=r&&p<=n)h.push(m);else if(!(d>n||p<r)){var y=1===g?i(v,r,n,o):a(v,r,n,o,l,3===g);y.length&&h.push(s(m.tags,g,y,m.id))}}return h.length?h:null}function i(t,e,r,n){for(var i=[],a=0;a<t.length;a++){var o=t[a],s=o[n];s>=e&&s<=r&&i.push(o)}return i}function a(t,e,r,n,i,a){for(var s=[],l=0;l<t.length;l++){var u,c,h,f=0,d=0,p=null,m=t[l],v=m.area,g=m.dist,y=m.outer,b=m.length,x=[];for(c=0;c<b-1;c++)u=p||m[c],p=m[c+1],f=d||u[n],d=p[n],f<e?d>r?(x.push(i(u,p,e),i(u,p,r)),a||(x=o(s,x,v,g,y))):d>=e&&x.push(i(u,p,e)):f>r?d<e?(x.push(i(u,p,r),i(u,p,e)),a||(x=o(s,x,v,g,y))):d<=r&&x.push(i(u,p,r)):(x.push(u),d<e?(x.push(i(u,p,e)),a||(x=o(s,x,v,g,y))):d>r&&(x.push(i(u,p,r)),a||(x=o(s,x,v,g,y))));u=m[b-1],f=u[n],f>=e&&f<=r&&x.push(u),h=x[x.length-1],a&&h&&(x[0][0]!==h[0]||x[0][1]!==h[1])&&x.push(x[0]),o(s,x,v,g,y)}return s}function o(t,e,r,n,i){return e.length&&(e.area=r,e.dist=n,void 0!==i&&(e.outer=i),t.push(e)),[]}e.exports=n;var s=t(\"./feature\")},{\"./feature\":140}],139:[function(t,e,r){\"use strict\";function n(t,e){var r=[];if(\"FeatureCollection\"===t.type)for(var n=0;n<t.features.length;n++)i(r,t.features[n],e);else\"Feature\"===t.type?i(r,t,e):i(r,{geometry:t},e);return r}function i(t,e,r){if(null!==e.geometry){var n,s,l,c,h=e.geometry,f=h.type,d=h.coordinates,p=e.properties,m=e.id;if(\"Point\"===f)t.push(u(p,1,[o(d)],m));else if(\"MultiPoint\"===f)t.push(u(p,1,a(d),m));else if(\"LineString\"===f)t.push(u(p,2,[a(d,r)],m));else if(\"MultiLineString\"===f||\"Polygon\"===f){for(l=[],n=0;n<d.length;n++)c=a(d[n],r),\"Polygon\"===f&&(c.outer=0===n),l.push(c);t.push(u(p,\"Polygon\"===f?3:2,l,m))}else if(\"MultiPolygon\"===f){for(l=[],n=0;n<d.length;n++)for(s=0;s<d[n].length;s++)c=a(d[n][s],r),c.outer=0===s,l.push(c);t.push(u(p,3,l,m))}else{if(\"GeometryCollection\"!==f)throw new Error(\"Input data is not a valid GeoJSON object.\");for(n=0;n<h.geometries.length;n++)i(t,{geometry:h.geometries[n],properties:p},r)}}}function a(t,e){for(var r=[],n=0;n<t.length;n++)r.push(o(t[n]));return e&&(l(r,e),s(r)),r}function o(t){var e=Math.sin(t[1]*Math.PI/180),r=t[0]/360+.5,n=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return n=n<0?0:n>1?1:n,[r,n,0]}function s(t){for(var e,r,n=0,i=0,a=0;a<t.length-1;a++)e=r||t[a],r=t[a+1],n+=e[0]*r[1]-r[0]*e[1],i+=Math.abs(r[0]-e[0])+Math.abs(r[1]-e[1]);t.area=Math.abs(n/2),t.dist=i}e.exports=n;var l=t(\"./simplify\"),u=t(\"./feature\")},{\"./feature\":140,\"./simplify\":142}],140:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a={id:n||null,type:e,geometry:r,tags:t||null,min:[1/0,1/0],max:[-1/0,-1/0]};return i(a),a}function i(t){var e=t.geometry,r=t.min,n=t.max;if(1===t.type)a(r,n,e);else for(var i=0;i<e.length;i++)a(r,n,e[i]);return t}function a(t,e,r){for(var n,i=0;i<r.length;i++)n=r[i],t[0]=Math.min(n[0],t[0]),e[0]=Math.max(n[0],e[0]),t[1]=Math.min(n[1],t[1]),e[1]=Math.max(n[1],e[1])}e.exports=n},{}],141:[function(t,e,r){\"use strict\";function n(t,e){return new i(t,e)}function i(t,e){e=this.options=l(Object.create(this.options),e);var r=e.debug;r&&console.time(\"preprocess data\");var n=1<<e.maxZoom,i=c(t,e.tolerance/(n*e.extent));this.tiles={},this.tileCoords=[],r&&(console.timeEnd(\"preprocess data\"),console.log(\"index: maxZoom: %d, maxPoints: %d\",e.indexMaxZoom,e.indexMaxPoints),console.time(\"generate tiles\"),this.stats={},this.total=0),i=d(i,e.buffer/e.extent,o),i.length&&this.splitTile(i,0,0,0),r&&(i.length&&console.log(\"features: %d, points: %d\",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd(\"generate tiles\"),console.log(\"tiles generated:\",this.total,JSON.stringify(this.stats)))}function a(t,e,r){return 32*((1<<t)*r+e)+t}function o(t,e,r){return[r,(r-t[0])*(e[1]-t[1])/(e[0]-t[0])+t[1],1]}function s(t,e,r){return[(r-t[1])*(e[0]-t[0])/(e[1]-t[1])+t[0],r,1]}function l(t,e){for(var r in e)t[r]=e[r];return t}function u(t,e,r){var n=t.source;if(1!==n.length)return!1;var i=n[0];if(3!==i.type||i.geometry.length>1)return!1;var a=i.geometry[0].length;if(5!==a)return!1;for(var o=0;o<a;o++){var s=h.point(i.geometry[0][o],e,t.z2,t.x,t.y);if(s[0]!==-r&&s[0]!==e+r||s[1]!==-r&&s[1]!==e+r)return!1}return!0}e.exports=n;var c=t(\"./convert\"),h=t(\"./transform\"),f=t(\"./clip\"),d=t(\"./wrap\"),p=t(\"./tile\");i.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,solidChildren:!1,tolerance:3,extent:4096,buffer:64,debug:0},i.prototype.splitTile=function(t,e,r,n,i,l,c){for(var h=[t,e,r,n],d=this.options,m=d.debug,v=null;h.length;){n=h.pop(),r=h.pop(),e=h.pop(),t=h.pop();var g=1<<e,y=a(e,r,n),b=this.tiles[y],x=e===d.maxZoom?0:d.tolerance/(g*d.extent);if(!b&&(m>1&&console.time(\"creation\"),b=this.tiles[y]=p(t,g,r,n,x,e===d.maxZoom),this.tileCoords.push({z:e,x:r,y:n}),m)){m>1&&(console.log(\"tile z%d-%d-%d (features: %d, points: %d, simplified: %d)\",e,r,n,b.numFeatures,b.numPoints,b.numSimplified),console.timeEnd(\"creation\"));var _=\"z\"+e;this.stats[_]=(this.stats[_]||0)+1,this.total++}if(b.source=t,i){if(e===d.maxZoom||e===i)continue;var w=1<<i-e;if(r!==Math.floor(l/w)||n!==Math.floor(c/w))continue}else if(e===d.indexMaxZoom||b.numPoints<=d.indexMaxPoints)continue;if(d.solidChildren||!u(b,d.extent,d.buffer)){b.source=null,m>1&&console.time(\"clipping\");var M,k,A,T,S,E,L=.5*d.buffer/d.extent,C=.5-L,z=.5+L,I=1+L;M=k=A=T=null,S=f(t,g,r-L,r+z,0,o,b.min[0],b.max[0]),E=f(t,g,r+C,r+I,0,o,b.min[0],b.max[0]),S&&(M=f(S,g,n-L,n+z,1,s,b.min[1],b.max[1]),k=f(S,g,n+C,n+I,1,s,b.min[1],b.max[1])),E&&(A=f(E,g,n-L,n+z,1,s,b.min[1],b.max[1]),T=f(E,g,n+C,n+I,1,s,b.min[1],b.max[1])),m>1&&console.timeEnd(\"clipping\"),t.length&&(h.push(M||[],e+1,2*r,2*n),h.push(k||[],e+1,2*r,2*n+1),h.push(A||[],e+1,2*r+1,2*n),h.push(T||[],e+1,2*r+1,2*n+1))}else i&&(v=e)}return v},i.prototype.getTile=function(t,e,r){var n=this.options,i=n.extent,o=n.debug,s=1<<t;e=(e%s+s)%s;var l=a(t,e,r);if(this.tiles[l])return h.tile(this.tiles[l],i);o>1&&console.log(\"drilling down to z%d-%d-%d\",t,e,r);for(var c,f=t,d=e,p=r;!c&&f>0;)f--,d=Math.floor(d/2),p=Math.floor(p/2),c=this.tiles[a(f,d,p)];if(!c||!c.source)return null;if(o>1&&console.log(\"found parent tile z%d-%d-%d\",f,d,p),u(c,i,n.buffer))return h.tile(c,i);o>1&&console.time(\"drilling down\");var m=this.splitTile(c.source,f,d,p,t,e,r);if(o>1&&console.timeEnd(\"drilling down\"),null!==m){var v=1<<t-m;l=a(m,Math.floor(e/v),Math.floor(r/v))}return this.tiles[l]?h.tile(this.tiles[l],i):null}},{\"./clip\":138,\"./convert\":139,\"./tile\":143,\"./transform\":144,\"./wrap\":145}],142:[function(t,e,r){\"use strict\";function n(t,e){var r,n,a,o,s=e*e,l=t.length,u=0,c=l-1,h=[];for(t[u][2]=1,t[c][2]=1;c;){for(n=0,r=u+1;r<c;r++)(a=i(t[r],t[u],t[c]))>n&&(o=r,n=a);n>s?(t[o][2]=n,h.push(u),h.push(o),u=o):(c=h.pop(),u=h.pop())}}function i(t,e,r){var n=e[0],i=e[1],a=r[0],o=r[1],s=t[0],l=t[1],u=a-n,c=o-i;if(0!==u||0!==c){var h=((s-n)*u+(l-i)*c)/(u*u+c*c);h>1?(n=a,i=o):h>0&&(n+=u*h,i+=c*h)}return u=s-n,c=l-i,u*u+c*c}e.exports=n},{}],143:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o){for(var s={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:n,z2:e,transformed:!1,min:[2,1],max:[-1,0]},l=0;l<t.length;l++){s.numFeatures++,i(s,t[l],a,o);var u=t[l].min,c=t[l].max;u[0]<s.min[0]&&(s.min[0]=u[0]),u[1]<s.min[1]&&(s.min[1]=u[1]),c[0]>s.max[0]&&(s.max[0]=c[0]),c[1]>s.max[1]&&(s.max[1]=c[1])}return s}function i(t,e,r,n){var i,o,s,l,u=e.geometry,c=e.type,h=[],f=r*r;if(1===c)for(i=0;i<u.length;i++)h.push(u[i]),t.numPoints++,t.numSimplified++;else for(i=0;i<u.length;i++)if(s=u[i],n||!(2===c&&s.dist<r||3===c&&s.area<f)){var d=[];for(o=0;o<s.length;o++)l=s[o],(n||l[2]>f)&&(d.push(l),t.numSimplified++),t.numPoints++;3===c&&a(d,s.outer),h.push(d)}else t.numPoints+=s.length;if(h.length){var p={geometry:h,type:c,tags:e.tags||null};null!==e.id&&(p.id=e.id),t.features.push(p)}}function a(t,e){o(t)<0===e&&t.reverse()}function o(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r[0]-e[0])*(e[1]+r[1]);return n}e.exports=n},{}],144:[function(t,e,r){\"use strict\";function n(t,e){if(t.transformed)return t;var r,n,a,o=t.z2,s=t.x,l=t.y;for(r=0;r<t.features.length;r++){var u=t.features[r],c=u.geometry;if(1===u.type)for(n=0;n<c.length;n++)c[n]=i(c[n],e,o,s,l);else for(n=0;n<c.length;n++){var h=c[n];for(a=0;a<h.length;a++)h[a]=i(h[a],e,o,s,l)}}return t.transformed=!0,t}function i(t,e,r,n,i){return[Math.round(e*(t[0]*r-n)),Math.round(e*(t[1]*r-i))]}r.tile=n,r.point=i},{}],145:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t,a=o(t,1,-1-e,e,0,r,-1,2),s=o(t,1,1-e,2+e,0,r,-1,2);return(a||s)&&(n=o(t,1,-e,1+e,0,r,-1,2)||[],a&&(n=i(a,1).concat(n)),s&&(n=n.concat(i(s,-1)))),n}function i(t,e){for(var r=[],n=0;n<t.length;n++){var i,o=t[n],l=o.type;if(1===l)i=a(o.geometry,e);else{i=[];for(var u=0;u<o.geometry.length;u++)i.push(a(o.geometry[u],e))}r.push(s(o.tags,l,i,o.id))}return r}function a(t,e){var r=[];r.area=t.area,r.dist=t.dist;for(var n=0;n<t.length;n++)r.push([t[n][0]+e,t[n][1],t[n][2]]);return r}var o=t(\"./clip\"),s=t(\"./feature\");e.exports=n},{\"./clip\":138,\"./feature\":140}],146:[function(t,e,r){function n(t,e){if(\"string\"!=typeof t)throw new TypeError(\"must specify type string\");if(e=e||{},\"undefined\"==typeof document&&!e.canvas)return null;var r=e.canvas||document.createElement(\"canvas\");\"number\"==typeof e.width&&(r.width=e.width),\"number\"==typeof e.height&&(r.height=e.height);var n,i=e;try{var a=[t];0===t.indexOf(\"webgl\")&&a.push(\"experimental-\"+t);for(var o=0;o<a.length;o++)if(n=r.getContext(a[o],i))return n}catch(t){n=null}return n||null}e.exports=n},{}],147:[function(t,e,r){\"use strict\";function n(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function i(t){this.gl=t,this.pixelRatio=1,this.bounds=[[-10,-10,-10],[10,10,10]],this.ticks=[[],[],[]],this.autoTicks=!0,this.tickSpacing=[1,1,1],this.tickEnable=[!0,!0,!0],this.tickFont=[\"sans-serif\",\"sans-serif\",\"sans-serif\"],this.tickSize=[12,12,12],this.tickAngle=[0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[10,10,10],this.lastCubeProps={cubeEdges:[0,0,0],axis:[0,0,0]},this.labels=[\"x\",\"y\",\"z\"],this.labelEnable=[!0,!0,!0],this.labelFont=\"sans-serif\",this.labelSize=[20,20,20],this.labelAngle=[0,0,0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[10,10,10],this.lineEnable=[!0,!0,!0],this.lineMirror=[!1,!1,!1],this.lineWidth=[1,1,1],this.lineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.lineTickEnable=[!0,!0,!0],this.lineTickMirror=[!1,!1,!1],this.lineTickLength=[0,0,0],this.lineTickWidth=[1,1,1],this.lineTickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.gridEnable=[!0,!0,!0],this.gridWidth=[1,1,1],this.gridColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroEnable=[!0,!0,!0],this.zeroLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroLineWidth=[2,2,2],this.backgroundEnable=[!1,!1,!1],this.backgroundColor=[[.8,.8,.8,.5],[.8,.8,.8,.5],[.8,.8,.8,.5]],this._firstInit=!0,this._text=null,this._lines=null,this._background=c(t)}function a(){this.primalOffset=[0,0,0],this.primalMinor=[0,0,0],this.mirrorOffset=[0,0,0],this.mirrorMinor=[0,0,0]}function o(t,e,r,n,i){for(var a=t.primalOffset,o=t.primalMinor,s=t.mirrorOffset,l=t.mirrorMinor,u=n[e],c=0;c<3;++c)if(e!==c){var h=a,f=s,d=o,p=l;u&1<<c&&(h=s,f=a,d=l,p=o),h[c]=r[0][c],f[c]=r[1][c],i[c]>0?(d[c]=-1,p[c]=0):(d[c]=0,p[c]=1)}}function s(t,e){var r=new i(t)\n",
       ";return r.update(e),r}e.exports=s;var l=t(\"./lib/text.js\"),u=t(\"./lib/lines.js\"),c=t(\"./lib/background.js\"),h=t(\"./lib/cube.js\"),f=t(\"./lib/ticks.js\"),d=new Float32Array([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]),p=i.prototype;p.update=function(t){function e(e,r,n){if(n in t){var i,a=t[n],o=this[n];(e?Array.isArray(a)&&Array.isArray(a[0]):Array.isArray(a))?this[n]=i=[r(a[0]),r(a[1]),r(a[2])]:this[n]=i=[r(a),r(a),r(a)];for(var s=0;s<3;++s)if(i[s]!==o[s])return!0}return!1}t=t||{};var r,n=e.bind(this,!1,Number),i=e.bind(this,!1,Boolean),a=e.bind(this,!1,String),o=e.bind(this,!0,function(t){if(Array.isArray(t)){if(3===t.length)return[+t[0],+t[1],+t[2],1];if(4===t.length)return[+t[0],+t[1],+t[2],+t[3]]}return[0,0,0,1]}),s=!1,c=!1;if(\"bounds\"in t)for(var h=t.bounds,d=0;d<2;++d)for(var p=0;p<3;++p)h[d][p]!==this.bounds[d][p]&&(c=!0),this.bounds[d][p]=h[d][p];if(\"ticks\"in t){r=t.ticks,s=!0,this.autoTicks=!1;for(var d=0;d<3;++d)this.tickSpacing[d]=0}else n(\"tickSpacing\")&&(this.autoTicks=!0,c=!0);if(this._firstInit&&(\"ticks\"in t||\"tickSpacing\"in t||(this.autoTicks=!0),c=!0,s=!0,this._firstInit=!1),c&&this.autoTicks&&(r=f.create(this.bounds,this.tickSpacing),s=!0),s){for(var d=0;d<3;++d)r[d].sort(function(t,e){return t.x-e.x});f.equal(r,this.ticks)?s=!1:this.ticks=r}i(\"tickEnable\"),a(\"tickFont\")&&(s=!0),n(\"tickSize\"),n(\"tickAngle\"),n(\"tickPad\"),o(\"tickColor\");var m=a(\"labels\");a(\"labelFont\")&&(m=!0),i(\"labelEnable\"),n(\"labelSize\"),n(\"labelPad\"),o(\"labelColor\"),i(\"lineEnable\"),i(\"lineMirror\"),n(\"lineWidth\"),o(\"lineColor\"),i(\"lineTickEnable\"),i(\"lineTickMirror\"),n(\"lineTickLength\"),n(\"lineTickWidth\"),o(\"lineTickColor\"),i(\"gridEnable\"),n(\"gridWidth\"),o(\"gridColor\"),i(\"zeroEnable\"),o(\"zeroLineColor\"),n(\"zeroLineWidth\"),i(\"backgroundEnable\"),o(\"backgroundColor\"),this._text?this._text&&(m||s)&&this._text.update(this.bounds,this.labels,this.labelFont,this.ticks,this.tickFont):this._text=l(this.gl,this.bounds,this.labels,this.labelFont,this.ticks,this.tickFont),this._lines&&s&&(this._lines.dispose(),this._lines=null),this._lines||(this._lines=u(this.gl,this.bounds,this.ticks))};var m=[new a,new a,new a],v=[0,0,0],g={model:d,view:d,projection:d};p.isOpaque=function(){return!0},p.isTransparent=function(){return!1},p.drawTransparent=function(t){};var y=[0,0,0],b=[0,0,0],x=[0,0,0];p.draw=function(t){t=t||g;for(var e=this.gl,r=t.model||d,i=t.view||d,a=t.projection||d,s=this.bounds,l=h(r,i,a,s),u=l.cubeEdges,c=l.axis,f=i[12],p=i[13],_=i[14],w=i[15],M=this.pixelRatio*(a[3]*f+a[7]*p+a[11]*_+a[15]*w)/e.drawingBufferHeight,k=0;k<3;++k)this.lastCubeProps.cubeEdges[k]=u[k],this.lastCubeProps.axis[k]=c[k];for(var A=m,k=0;k<3;++k)o(m[k],k,this.bounds,u,c);for(var e=this.gl,T=v,k=0;k<3;++k)this.backgroundEnable[k]?T[k]=c[k]:T[k]=0;this._background.draw(r,i,a,s,T,this.backgroundColor),this._lines.bind(r,i,a,this);for(var k=0;k<3;++k){var S=[0,0,0];c[k]>0?S[k]=s[1][k]:S[k]=s[0][k];for(var E=0;E<2;++E){var L=(k+1+E)%3,C=(k+1+(1^E))%3;this.gridEnable[L]&&this._lines.drawGrid(L,C,this.bounds,S,this.gridColor[L],this.gridWidth[L]*this.pixelRatio)}for(var E=0;E<2;++E){var L=(k+1+E)%3,C=(k+1+(1^E))%3;this.zeroEnable[C]&&s[0][C]<=0&&s[1][C]>=0&&this._lines.drawZero(L,C,this.bounds,S,this.zeroLineColor[C],this.zeroLineWidth[C]*this.pixelRatio)}}for(var k=0;k<3;++k){this.lineEnable[k]&&this._lines.drawAxisLine(k,this.bounds,A[k].primalOffset,this.lineColor[k],this.lineWidth[k]*this.pixelRatio),this.lineMirror[k]&&this._lines.drawAxisLine(k,this.bounds,A[k].mirrorOffset,this.lineColor[k],this.lineWidth[k]*this.pixelRatio);for(var z=n(y,A[k].primalMinor),I=n(b,A[k].mirrorMinor),D=this.lineTickLength,E=0;E<3;++E){var P=M/r[5*E];z[E]*=D[E]*P,I[E]*=D[E]*P}this.lineTickEnable[k]&&this._lines.drawAxisTicks(k,A[k].primalOffset,z,this.lineTickColor[k],this.lineTickWidth[k]*this.pixelRatio),this.lineTickMirror[k]&&this._lines.drawAxisTicks(k,A[k].mirrorOffset,I,this.lineTickColor[k],this.lineTickWidth[k]*this.pixelRatio)}this._text.bind(r,i,a,this.pixelRatio);for(var k=0;k<3;++k){for(var O=A[k].primalMinor,R=n(x,A[k].primalOffset),E=0;E<3;++E)this.lineTickEnable[k]&&(R[E]+=M*O[E]*Math.max(this.lineTickLength[E],0)/r[5*E]);if(this.tickEnable[k]){for(var E=0;E<3;++E)R[E]+=M*O[E]*this.tickPad[E]/r[5*E];this._text.drawTicks(k,this.tickSize[k],this.tickAngle[k],R,this.tickColor[k])}if(this.labelEnable[k]){for(var E=0;E<3;++E)R[E]+=M*O[E]*this.labelPad[E]/r[5*E];R[k]+=.5*(s[0][k]+s[1][k]),this._text.drawLabel(k,this.labelSize[k],this.labelAngle[k],R,this.labelColor[k])}}},p.dispose=function(){this._text.dispose(),this._lines.dispose(),this._background.dispose(),this._lines=null,this._text=null,this._background=null,this.gl=null}},{\"./lib/background.js\":148,\"./lib/cube.js\":149,\"./lib/lines.js\":150,\"./lib/text.js\":152,\"./lib/ticks.js\":153}],148:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.buffer=e,this.vao=r,this.shader=n}function i(t){for(var e=[],r=[],i=0,l=0;l<3;++l)for(var u=(l+1)%3,c=(l+2)%3,h=[0,0,0],f=[0,0,0],d=-1;d<=1;d+=2){r.push(i,i+2,i+1,i+1,i+2,i+3),h[l]=d,f[l]=d;for(var p=-1;p<=1;p+=2){h[u]=p;for(var m=-1;m<=1;m+=2)h[c]=m,e.push(h[0],h[1],h[2],f[0],f[1],f[2]),i+=1}var v=u;u=c,c=v}var g=a(t,new Float32Array(e)),y=a(t,new Uint16Array(r),t.ELEMENT_ARRAY_BUFFER),b=o(t,[{buffer:g,type:t.FLOAT,size:3,offset:0,stride:24},{buffer:g,type:t.FLOAT,size:3,offset:12,stride:24}],y),x=s(t);return x.attributes.position.location=0,x.attributes.normal.location=1,new n(t,g,b,x)}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=t(\"./shaders\").bg,l=n.prototype;l.draw=function(t,e,r,n,i,a){for(var o=!1,s=0;s<3;++s)o=o||i[s];if(o){var l=this.gl;l.enable(l.POLYGON_OFFSET_FILL),l.polygonOffset(1,2),this.shader.bind(),this.shader.uniforms={model:t,view:e,projection:r,bounds:n,enable:i,colors:a},this.vao.bind(),this.vao.draw(this.gl.TRIANGLES,36),l.disable(l.POLYGON_OFFSET_FILL)}},l.dispose=function(){this.vao.dispose(),this.buffer.dispose(),this.shader.dispose()}},{\"./shaders\":151,\"gl-buffer\":155,\"gl-vao\":270}],149:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<4;++n){t[n]=r[12+n];for(var i=0;i<3;++i)t[n]+=e[i]*r[4*i+n]}}function i(t){for(var e=0;e<m.length;++e)if(t=l.positive(t,m[e]),t.length<3)return 0;for(var r=t[0],n=r[0]/r[3],i=r[1]/r[3],a=0,e=1;e+1<t.length;++e){var o=t[e],s=t[e+1],u=o[0]/o[3],c=o[1]/o[3],h=s[0]/s[3],f=s[1]/s[3],d=u-n,p=c-i,v=h-n,g=f-i;a+=Math.abs(d*g-p*v)}return a}function a(t,e,r,a){s(c,e,t),s(c,r,c);for(var l=0,m=0;m<2;++m){d[2]=a[m][2];for(var b=0;b<2;++b){d[1]=a[b][1];for(var x=0;x<2;++x)d[0]=a[x][0],n(h[l],d,c),l+=1}}for(var _=-1,m=0;m<8;++m){for(var w=h[m][3],M=0;M<3;++M)f[m][M]=h[m][M]/w;w<0&&(_<0?_=m:f[m][2]<f[_][2]&&(_=m))}if(_<0){_=0;for(var k=0;k<3;++k){for(var A=(k+2)%3,T=(k+1)%3,S=-1,E=-1,L=0;L<2;++L){var C=L<<k,z=C+(L<<A)+(1-L<<T),I=C+(1-L<<A)+(L<<T);u(f[C],f[z],f[I],p)<0||(L?S=1:E=1)}if(S<0||E<0)E>S&&(_|=1<<k);else{for(var L=0;L<2;++L){var C=L<<k,z=C+(L<<A)+(1-L<<T),I=C+(1-L<<A)+(L<<T),D=i([h[C],h[z],h[I],h[C+(1<<A)+(1<<T)]]);L?S=D:E=D}E>S&&(_|=1<<k)}}}for(var P=7^_,O=-1,m=0;m<8;++m)m!==_&&m!==P&&(O<0?O=m:f[O][1]>f[m][1]&&(O=m));for(var R=-1,m=0;m<3;++m){var F=O^1<<m;if(F!==_&&F!==P){R<0&&(R=F);var T=f[F];T[0]<f[R][0]&&(R=F)}}for(var j=-1,m=0;m<3;++m){var F=O^1<<m;if(F!==_&&F!==P&&F!==R){j<0&&(j=F);var T=f[F];T[0]>f[j][0]&&(j=F)}}var N=v;N[0]=N[1]=N[2]=0,N[o.log2(R^O)]=O&R,N[o.log2(O^j)]=O&j;var B=7^j;B===_||B===P?(B=7^R,N[o.log2(j^B)]=B&j):N[o.log2(R^B)]=B&R;for(var U=g,V=_,k=0;k<3;++k)U[k]=V&1<<k?-1:1;return y}e.exports=a;var o=t(\"bit-twiddle\"),s=t(\"gl-mat4/multiply\"),l=(t(\"gl-mat4/invert\"),t(\"split-polygon\")),u=t(\"robust-orientation\"),c=new Array(16),h=(new Array(16),new Array(8)),f=new Array(8),d=new Array(3),p=[0,0,0];!function(){for(var t=0;t<8;++t)h[t]=[1,1,1,1],f[t]=[1,1,1]}();var m=[[0,0,1,0,0],[0,0,-1,1,0],[0,-1,0,1,0],[0,1,0,1,0],[-1,0,0,1,0],[1,0,0,1,0]],v=[1,1,1],g=[0,0,0],y={cubeEdges:v,axis:g}},{\"bit-twiddle\":66,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"robust-orientation\":507,\"split-polygon\":525}],150:[function(t,e,r){\"use strict\";function n(t){return t[0]=t[1]=t[2]=0,t}function i(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function a(t,e,r,n,i,a,o,s){this.gl=t,this.vertBuffer=e,this.vao=r,this.shader=n,this.tickCount=i,this.tickOffset=a,this.gridCount=o,this.gridOffset=s}function o(t,e,r){var n=[],i=[0,0,0],o=[0,0,0],c=[0,0,0],h=[0,0,0];n.push(0,0,1,0,1,1,0,0,-1,0,0,-1,0,1,1,0,1,-1);for(var f=0;f<3;++f){for(var d=n.length/3|0,p=0;p<r[f].length;++p){var m=+r[f][p].x;n.push(m,0,1,m,1,1,m,0,-1,m,0,-1,m,1,1,m,1,-1)}var v=n.length/3|0;i[f]=d,o[f]=v-d;for(var d=n.length/3|0,g=0;g<r[f].length;++g){var m=+r[f][g].x;n.push(m,0,1,m,1,1,m,0,-1,m,0,-1,m,1,1,m,1,-1)}var v=n.length/3|0;c[f]=d,h[f]=v-d}var y=s(t,new Float32Array(n)),b=l(t,[{buffer:y,type:t.FLOAT,size:3,stride:0,offset:0}]),x=u(t);return x.attributes.position.location=0,new a(t,y,b,x,o,i,h,c)}e.exports=o;var s=t(\"gl-buffer\"),l=t(\"gl-vao\"),u=t(\"./shaders\").line,c=[0,0,0],h=[0,0,0],f=[0,0,0],d=[0,0,0],p=[1,1],m=a.prototype;m.bind=function(t,e,r){this.shader.bind(),this.shader.uniforms.model=t,this.shader.uniforms.view=e,this.shader.uniforms.projection=r,p[0]=this.gl.drawingBufferWidth,p[1]=this.gl.drawingBufferHeight,this.shader.uniforms.screenShape=p,this.vao.bind()},m.drawAxisLine=function(t,e,r,a,o){var s=n(h);this.shader.uniforms.majorAxis=h,s[t]=e[1][t]-e[0][t],this.shader.uniforms.minorAxis=s;var l=i(d,r);l[t]+=e[0][t],this.shader.uniforms.offset=l,this.shader.uniforms.lineWidth=o,this.shader.uniforms.color=a;var u=n(f);u[(t+2)%3]=1,this.shader.uniforms.screenAxis=u,this.vao.draw(this.gl.TRIANGLES,6);var u=n(f);u[(t+1)%3]=1,this.shader.uniforms.screenAxis=u,this.vao.draw(this.gl.TRIANGLES,6)},m.drawAxisTicks=function(t,e,r,i,a){if(this.tickCount[t]){var o=n(c);o[t]=1,this.shader.uniforms.majorAxis=o,this.shader.uniforms.offset=e,this.shader.uniforms.minorAxis=r,this.shader.uniforms.color=i,this.shader.uniforms.lineWidth=a;var s=n(f);s[t]=1,this.shader.uniforms.screenAxis=s,this.vao.draw(this.gl.TRIANGLES,this.tickCount[t],this.tickOffset[t])}},m.drawGrid=function(t,e,r,a,o,s){if(this.gridCount[t]){var l=n(h);l[e]=r[1][e]-r[0][e],this.shader.uniforms.minorAxis=l;var u=i(d,a);u[e]+=r[0][e],this.shader.uniforms.offset=u;var p=n(c);p[t]=1,this.shader.uniforms.majorAxis=p;var m=n(f);m[t]=1,this.shader.uniforms.screenAxis=m,this.shader.uniforms.lineWidth=s,this.shader.uniforms.color=o,this.vao.draw(this.gl.TRIANGLES,this.gridCount[t],this.gridOffset[t])}},m.drawZero=function(t,e,r,a,o,s){var l=n(h);this.shader.uniforms.majorAxis=l,l[t]=r[1][t]-r[0][t],this.shader.uniforms.minorAxis=l;var u=i(d,a);u[t]+=r[0][t],this.shader.uniforms.offset=u;var c=n(f);c[e]=1,this.shader.uniforms.screenAxis=c,this.shader.uniforms.lineWidth=s,this.shader.uniforms.color=o,this.vao.draw(this.gl.TRIANGLES,6)},m.dispose=function(){this.vao.dispose(),this.vertBuffer.dispose(),this.shader.dispose()}},{\"./shaders\":151,\"gl-buffer\":155,\"gl-vao\":270}],151:[function(t,e,r){\"use strict\";var n=t(\"gl-shader\");r.line=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 offset, majorAxis, minorAxis, screenAxis;\\nuniform float lineWidth;\\nuniform vec2 screenShape;\\n\\nvec3 project(vec3 p) {\\n  vec4 pp = projection * view * model * vec4(p, 1.0);\\n  return pp.xyz / max(pp.w, 0.0001);\\n}\\n\\nvoid main() {\\n  vec3 major = position.x * majorAxis;\\n  vec3 minor = position.y * minorAxis;\\n\\n  vec3 vPosition = major + minor + offset;\\n  vec3 pPosition = project(vPosition);\\n  vec3 offset = project(vPosition + screenAxis * position.z);\\n\\n  vec2 screen = normalize((offset - pPosition).xy * screenShape) / screenShape;\\n\\n  gl_Position = vec4(pPosition + vec3(0.5 * screen * lineWidth, 0), 1.0);\\n}\\n\",\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = color;\\n}\",null,[{name:\"position\",type:\"vec3\"}])};r.text=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 offset, axis;\\nuniform float scale, angle, pixelScale;\\nuniform vec2 resolution;\\n\\nvoid main() {  \\n  //Compute plane offset\\n  vec2 planeCoord = position.xy * pixelScale;\\n  mat2 planeXform = scale * mat2(cos(angle), sin(angle),\\n                                -sin(angle), cos(angle));\\n  vec2 viewOffset = 2.0 * planeXform * planeCoord / resolution;\\n\\n  //Compute world offset\\n  float axisDistance = position.z;\\n  vec3 dataPosition = axisDistance * axis + offset;\\n  vec4 worldPosition = model * vec4(dataPosition, 1);\\n  \\n  //Compute clip position\\n  vec4 viewPosition = view * worldPosition;\\n  vec4 clipPosition = projection * viewPosition;\\n  clipPosition /= clipPosition.w;\\n\\n  //Apply text offset in clip coordinates\\n  clipPosition += vec4(viewOffset, 0, 0);\\n\\n  //Done\\n  gl_Position = clipPosition;\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = color;\\n}\",null,[{name:\"position\",type:\"vec3\"}])};r.bg=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\nattribute vec3 normal;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 enable;\\nuniform vec3 bounds[2];\\n\\nvarying vec3 colorChannel;\\n\\nvoid main() {\\n  if(dot(normal, enable) > 0.0) {\\n    vec3 nPosition = mix(bounds[0], bounds[1], 0.5 * (position + 1.0));\\n    gl_Position = projection * view * model * vec4(nPosition, 1.0);\\n  } else {\\n    gl_Position = vec4(0,0,0,0);\\n  }\\n  colorChannel = abs(normal);\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 colors[3];\\n\\nvarying vec3 colorChannel;\\n\\nvoid main() {\\n  gl_FragColor = colorChannel.x * colors[0] + \\n                 colorChannel.y * colors[1] +\\n                 colorChannel.z * colors[2];\\n}\",null,[{name:\"position\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}])}},{\"gl-shader\":254}],152:[function(t,e,r){(function(r){\"use strict\";function n(t,e,r,n){this.gl=t,this.shader=e,this.buffer=r,this.vao=n,this.tickOffset=this.tickCount=this.labelOffset=this.labelCount=null}function i(t,e){try{return l(t,e)}catch(t){return console.warn(\"error vectorizing text:\",t),{cells:[],positions:[]}}}function a(t,e,r,i,a,l){var c=o(t),h=s(t,[{buffer:c,size:3}]),f=u(t);f.attributes.position.location=0;var d=new n(t,f,c,h);return d.update(e,r,i,a,l),d}e.exports=a;var o=t(\"gl-buffer\"),s=t(\"gl-vao\"),l=t(\"vectorize-text\"),u=t(\"./shaders\").text,c=window||r.global||{},h=c.__TEXT_CACHE||{};c.__TEXT_CACHE={};var f=n.prototype,d=[0,0];f.bind=function(t,e,r,n){this.vao.bind(),this.shader.bind();var i=this.shader.uniforms;i.model=t,i.view=e,i.projection=r,i.pixelScale=n,d[0]=this.gl.drawingBufferWidth,d[1]=this.gl.drawingBufferHeight,this.shader.uniforms.resolution=d},f.update=function(t,e,r,n,a){function o(t,e,r,n){var a=h[r];a||(a=h[r]={});var o=a[e];o||(o=a[e]=i(e,{triangles:!0,font:r,textAlign:\"center\",textBaseline:\"middle\"}));for(var l=(n||12)/12,u=o.positions,c=o.cells,f=0,d=c.length;f<d;++f)for(var p=c[f],m=2;m>=0;--m){var v=u[p[m]];s.push(l*v[0],-l*v[1],t)}}for(var s=(this.gl,[]),l=[0,0,0],u=[0,0,0],c=[0,0,0],f=[0,0,0],d=0;d<3;++d){c[d]=s.length/3|0,o(.5*(t[0][d]+t[1][d]),e[d],r),f[d]=(s.length/3|0)-c[d],l[d]=s.length/3|0;for(var p=0;p<n[d].length;++p)n[d][p].text&&o(n[d][p].x,n[d][p].text,n[d][p].font||a,n[d][p].fontSize||12);u[d]=(s.length/3|0)-l[d]}this.buffer.update(s),this.tickOffset=l,this.tickCount=u,this.labelOffset=c,this.labelCount=f};var p=[0,0,0];f.drawTicks=function(t,e,r,n,i){if(this.tickCount[t]){var a=p;a[0]=a[1]=a[2]=0,a[t]=1,this.shader.uniforms.axis=a,this.shader.uniforms.color=i,this.shader.uniforms.angle=r,this.shader.uniforms.scale=e,this.shader.uniforms.offset=n,this.vao.draw(this.gl.TRIANGLES,this.tickCount[t],this.tickOffset[t])}};var m=[0,0,0];f.drawLabel=function(t,e,r,n,i){this.labelCount[t]&&(this.shader.uniforms.axis=m,this.shader.uniforms.color=i,this.shader.uniforms.angle=r,this.shader.uniforms.scale=e,this.shader.uniforms.offset=n,this.vao.draw(this.gl.TRIANGLES,this.labelCount[t],this.labelOffset[t]))},f.dispose=function(){this.shader.dispose(),this.vao.dispose(),this.buffer.dispose()}}).call(this,t(\"_process\"))},{\"./shaders\":151,_process:486,\"gl-buffer\":155,\"gl-vao\":270,\"vectorize-text\":553}],153:[function(t,e,r){\"use strict\";function n(t,e){var r=t+\"\",n=r.indexOf(\".\"),i=0;n>=0&&(i=r.length-n-1);var a=Math.pow(10,i),o=Math.round(t*e*a),s=o+\"\";if(s.indexOf(\"e\")>=0)return s;var l=o/a,u=o%a;o<0?(l=0|-Math.ceil(l),u=0|-u):(l=0|Math.floor(l),u|=0);var c=\"\"+l;if(o<0&&(c=\"-\"+c),i){for(var h=\"\"+u;h.length<i;)h=\"0\"+h;return c+\".\"+h}return c}function i(t,e){for(var r=[],i=0;i<3;++i){for(var a=[],o=(t[0][i],t[1][i],0);o*e[i]<=t[1][i];++o)a.push({x:o*e[i],text:n(e[i],o)});for(var o=-1;o*e[i]>=t[0][i];--o)a.push({x:o*e[i],text:n(e[i],o)});r.push(a)}return r}function a(t,e){for(var r=0;r<3;++r){if(t[r].length!==e[r].length)return!1;for(var n=0;n<t[r].length;++n){var i=t[r][n],a=e[r][n];if(i.x!==a.x||i.text!==a.text||i.font!==a.font||i.fontColor!==a.fontColor||i.fontSize!==a.fontSize||i.dx!==a.dx||i.dy!==a.dy)return!1}}return!0}r.create=i,r.equal=a},{}],154:[function(t,e,r){\"use strict\";function n(t,e,r){this.lo=t,this.hi=e,this.pixelsPerDataUnit=r}function i(t,e,r,n,i){for(var a=0;a<3;++a){for(var o=p,s=m,l=0;l<3;++l)s[l]=o[l]=r[l];s[3]=o[3]=1,s[a]+=1,h(s,s,e),s[3]<0&&(t[a]=1/0),o[a]-=1,h(o,o,e),o[3]<0&&(t[a]=1/0);var u=(o[0]/o[3]-s[0]/s[3])*n,c=(o[1]/o[3]-s[1]/s[3])*i;t[a]=.25*Math.sqrt(u*u+c*c)}return t}function a(t,e,r,n,a){var h=e.model||f,p=e.view||f,m=e.projection||f,y=t.bounds,a=a||l(h,p,m,y),b=a.axis;a.edges;u(d,p,h),u(d,m,d);for(var x=v,_=0;_<3;++_)x[_].lo=1/0,x[_].hi=-1/0,x[_].pixelsPerDataUnit=1/0;var w=o(c(d,d));c(d,d);for(var M=0;M<3;++M){var k=(M+1)%3,A=(M+2)%3,T=g;t:for(var _=0;_<2;++_){var S=[];if(b[M]<0!=!!_){T[M]=y[_][M];for(var E=0;E<2;++E){T[k]=y[E^_][k];for(var L=0;L<2;++L)T[A]=y[L^E^_][A],S.push(T.slice())}for(var E=0;E<w.length;++E){if(0===S.length)continue t;S=s.positive(S,w[E])}for(var E=0;E<S.length;++E)for(var A=S[E],C=i(g,d,A,r,n),L=0;L<3;++L)x[L].lo=Math.min(x[L].lo,A[L]),x[L].hi=Math.max(x[L].hi,A[L]),L!==M&&(x[L].pixelsPerDataUnit=Math.min(x[L].pixelsPerDataUnit,Math.abs(C[L])))}}}return x}e.exports=a;var o=t(\"extract-frustum-planes\"),s=t(\"split-polygon\"),l=t(\"./lib/cube.js\"),u=t(\"gl-mat4/multiply\"),c=t(\"gl-mat4/transpose\"),h=t(\"gl-vec4/transformMat4\"),f=new Float32Array([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]),d=new Float32Array(16),p=[0,0,0,1],m=[0,0,0,1],v=[new n(1/0,-1/0,1/0),new n(1/0,-1/0,1/0),new n(1/0,-1/0,1/0)],g=[0,0,0]},{\"./lib/cube.js\":149,\"extract-frustum-planes\":129,\"gl-mat4/multiply\":182,\"gl-mat4/transpose\":190,\"gl-vec4/transformMat4\":276,\"split-polygon\":525}],155:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.gl=t,this.type=e,this.handle=r,this.length=n,this.usage=i}function i(t,e,r,n,i,a){var o=i.length*i.BYTES_PER_ELEMENT;if(a<0)return t.bufferData(e,i,n),o;if(o+a>r)throw new Error(\"gl-buffer: If resizing buffer, must not specify offset\");return t.bufferSubData(e,a,i),r}function a(t,e){for(var r=l.malloc(t.length,e),n=t.length,i=0;i<n;++i)r[i]=t[i];return r}function o(t,e){for(var r=1,n=e.length-1;n>=0;--n){if(e[n]!==r)return!1;r*=t[n]}return!0}function s(t,e,r,i){if(r=r||t.ARRAY_BUFFER,i=i||t.DYNAMIC_DRAW,r!==t.ARRAY_BUFFER&&r!==t.ELEMENT_ARRAY_BUFFER)throw new Error(\"gl-buffer: Invalid type for webgl buffer, must be either gl.ARRAY_BUFFER or gl.ELEMENT_ARRAY_BUFFER\");if(i!==t.DYNAMIC_DRAW&&i!==t.STATIC_DRAW&&i!==t.STREAM_DRAW)throw new Error(\"gl-buffer: Invalid usage for buffer, must be either gl.DYNAMIC_DRAW, gl.STATIC_DRAW or gl.STREAM_DRAW\");var a=t.createBuffer(),o=new n(t,r,a,0,i);return o.update(e),o}var l=t(\"typedarray-pool\"),u=t(\"ndarray-ops\"),c=t(\"ndarray\"),h=[\"uint8\",\"uint8_clamped\",\"uint16\",\"uint32\",\"int8\",\"int16\",\"int32\",\"float32\"],f=n.prototype;f.bind=function(){this.gl.bindBuffer(this.type,this.handle)},f.unbind=function(){this.gl.bindBuffer(this.type,null)},f.dispose=function(){this.gl.deleteBuffer(this.handle)},f.update=function(t,e){if(\"number\"!=typeof e&&(e=-1),this.bind(),\"object\"==typeof t&&void 0!==t.shape){var r=t.dtype;if(h.indexOf(r)<0&&(r=\"float32\"),this.type===this.gl.ELEMENT_ARRAY_BUFFER){r=gl.getExtension(\"OES_element_index_uint\")&&\"uint16\"!==r?\"uint32\":\"uint16\"}if(r===t.dtype&&o(t.shape,t.stride))0===t.offset&&t.data.length===t.shape[0]?this.length=i(this.gl,this.type,this.length,this.usage,t.data,e):this.length=i(this.gl,this.type,this.length,this.usage,t.data.subarray(t.offset,t.shape[0]),e);else{var n=l.malloc(t.size,r),s=c(n,t.shape);u.assign(s,t),this.length=e<0?i(this.gl,this.type,this.length,this.usage,n,e):i(this.gl,this.type,this.length,this.usage,n.subarray(0,t.size),e),l.free(n)}}else if(Array.isArray(t)){var f;f=this.type===this.gl.ELEMENT_ARRAY_BUFFER?a(t,\"uint16\"):a(t,\"float32\"),this.length=e<0?i(this.gl,this.type,this.length,this.usage,f,e):i(this.gl,this.type,this.length,this.usage,f.subarray(0,t.length),e),l.free(f)}else if(\"object\"==typeof t&&\"number\"==typeof t.length)this.length=i(this.gl,this.type,this.length,this.usage,t,e);else{if(\"number\"!=typeof t&&void 0!==t)throw new Error(\"gl-buffer: Invalid data type\");if(e>=0)throw new Error(\"gl-buffer: Cannot specify offset when resizing buffer\");t|=0,t<=0&&(t=1),this.gl.bufferData(this.type,0|t,this.usage),this.length=t}},e.exports=s},{ndarray:466,\"ndarray-ops\":460,\"typedarray-pool\":540}],156:[function(t,e,r){e.exports={0:\"NONE\",1:\"ONE\",2:\"LINE_LOOP\",3:\"LINE_STRIP\",4:\"TRIANGLES\",5:\"TRIANGLE_STRIP\",6:\"TRIANGLE_FAN\",256:\"DEPTH_BUFFER_BIT\",512:\"NEVER\",513:\"LESS\",514:\"EQUAL\",515:\"LEQUAL\",516:\"GREATER\",517:\"NOTEQUAL\",518:\"GEQUAL\",519:\"ALWAYS\",768:\"SRC_COLOR\",769:\"ONE_MINUS_SRC_COLOR\",770:\"SRC_ALPHA\",771:\"ONE_MINUS_SRC_ALPHA\",772:\"DST_ALPHA\",773:\"ONE_MINUS_DST_ALPHA\",774:\"DST_COLOR\",775:\"ONE_MINUS_DST_COLOR\",776:\"SRC_ALPHA_SATURATE\",1024:\"STENCIL_BUFFER_BIT\",1028:\"FRONT\",1029:\"BACK\",1032:\"FRONT_AND_BACK\",1280:\"INVALID_ENUM\",1281:\"INVALID_VALUE\",1282:\"INVALID_OPERATION\",1285:\"OUT_OF_MEMORY\",1286:\"INVALID_FRAMEBUFFER_OPERATION\",2304:\"CW\",2305:\"CCW\",2849:\"LINE_WIDTH\",2884:\"CULL_FACE\",2885:\"CULL_FACE_MODE\",2886:\"FRONT_FACE\",2928:\"DEPTH_RANGE\",2929:\"DEPTH_TEST\",2930:\"DEPTH_WRITEMASK\",2931:\"DEPTH_CLEAR_VALUE\",2932:\"DEPTH_FUNC\",2960:\"STENCIL_TEST\",2961:\"STENCIL_CLEAR_VALUE\",2962:\"STENCIL_FUNC\",2963:\"STENCIL_VALUE_MASK\",2964:\"STENCIL_FAIL\",2965:\"STENCIL_PASS_DEPTH_FAIL\",2966:\"STENCIL_PASS_DEPTH_PASS\",2967:\"STENCIL_REF\",2968:\"STENCIL_WRITEMASK\",2978:\"VIEWPORT\",3024:\"DITHER\",3042:\"BLEND\",3088:\"SCISSOR_BOX\",3089:\"SCISSOR_TEST\",3106:\"COLOR_CLEAR_VALUE\",3107:\"COLOR_WRITEMASK\",3317:\"UNPACK_ALIGNMENT\",3333:\"PACK_ALIGNMENT\",3379:\"MAX_TEXTURE_SIZE\",3386:\"MAX_VIEWPORT_DIMS\",3408:\"SUBPIXEL_BITS\",3410:\"RED_BITS\",3411:\"GREEN_BITS\",3412:\"BLUE_BITS\",3413:\"ALPHA_BITS\",3414:\"DEPTH_BITS\",3415:\"STENCIL_BITS\",3553:\"TEXTURE_2D\",4352:\"DONT_CARE\",4353:\"FASTEST\",4354:\"NICEST\",5120:\"BYTE\",5121:\"UNSIGNED_BYTE\",5122:\"SHORT\",5123:\"UNSIGNED_SHORT\",5124:\"INT\",5125:\"UNSIGNED_INT\",5126:\"FLOAT\",5386:\"INVERT\",5890:\"TEXTURE\",6401:\"STENCIL_INDEX\",6402:\"DEPTH_COMPONENT\",6406:\"ALPHA\",6407:\"RGB\",6408:\"RGBA\",6409:\"LUMINANCE\",6410:\"LUMINANCE_ALPHA\",7680:\"KEEP\",7681:\"REPLACE\",7682:\"INCR\",7683:\"DECR\",7936:\"VENDOR\",7937:\"RENDERER\",7938:\"VERSION\",9728:\"NEAREST\",9729:\"LINEAR\",9984:\"NEAREST_MIPMAP_NEAREST\",9985:\"LINEAR_MIPMAP_NEAREST\",9986:\"NEAREST_MIPMAP_LINEAR\",9987:\"LINEAR_MIPMAP_LINEAR\",10240:\"TEXTURE_MAG_FILTER\",10241:\"TEXTURE_MIN_FILTER\",10242:\"TEXTURE_WRAP_S\",10243:\"TEXTURE_WRAP_T\",10497:\"REPEAT\",10752:\"POLYGON_OFFSET_UNITS\",16384:\"COLOR_BUFFER_BIT\",32769:\"CONSTANT_COLOR\",32770:\"ONE_MINUS_CONSTANT_COLOR\",32771:\"CONSTANT_ALPHA\",32772:\"ONE_MINUS_CONSTANT_ALPHA\",32773:\"BLEND_COLOR\",32774:\"FUNC_ADD\",32777:\"BLEND_EQUATION_RGB\",32778:\"FUNC_SUBTRACT\",32779:\"FUNC_REVERSE_SUBTRACT\",32819:\"UNSIGNED_SHORT_4_4_4_4\",32820:\"UNSIGNED_SHORT_5_5_5_1\",32823:\"POLYGON_OFFSET_FILL\",32824:\"POLYGON_OFFSET_FACTOR\",32854:\"RGBA4\",32855:\"RGB5_A1\",32873:\"TEXTURE_BINDING_2D\",32926:\"SAMPLE_ALPHA_TO_COVERAGE\",32928:\"SAMPLE_COVERAGE\",32936:\"SAMPLE_BUFFERS\",32937:\"SAMPLES\",32938:\"SAMPLE_COVERAGE_VALUE\",32939:\"SAMPLE_COVERAGE_INVERT\",32968:\"BLEND_DST_RGB\",32969:\"BLEND_SRC_RGB\",32970:\"BLEND_DST_ALPHA\",32971:\"BLEND_SRC_ALPHA\",33071:\"CLAMP_TO_EDGE\",33170:\"GENERATE_MIPMAP_HINT\",33189:\"DEPTH_COMPONENT16\",33306:\"DEPTH_STENCIL_ATTACHMENT\",33635:\"UNSIGNED_SHORT_5_6_5\",33648:\"MIRRORED_REPEAT\",33901:\"ALIASED_POINT_SIZE_RANGE\",33902:\"ALIASED_LINE_WIDTH_RANGE\",33984:\"TEXTURE0\",33985:\"TEXTURE1\",33986:\"TEXTURE2\",33987:\"TEXTURE3\",33988:\"TEXTURE4\",33989:\"TEXTURE5\",33990:\"TEXTURE6\",33991:\"TEXTURE7\",33992:\"TEXTURE8\",33993:\"TEXTURE9\",33994:\"TEXTURE10\",33995:\"TEXTURE11\",33996:\"TEXTURE12\",33997:\"TEXTURE13\",33998:\"TEXTURE14\",33999:\"TEXTURE15\",34e3:\"TEXTURE16\",34001:\"TEXTURE17\",34002:\"TEXTURE18\",34003:\"TEXTURE19\",34004:\"TEXTURE20\",34005:\"TEXTURE21\",34006:\"TEXTURE22\",34007:\"TEXTURE23\",34008:\"TEXTURE24\",34009:\"TEXTURE25\",34010:\"TEXTURE26\",34011:\"TEXTURE27\",34012:\"TEXTURE28\",34013:\"TEXTURE29\",34014:\"TEXTURE30\",34015:\"TEXTURE31\",34016:\"ACTIVE_TEXTURE\",34024:\"MAX_RENDERBUFFER_SIZE\",34041:\"DEPTH_STENCIL\",34055:\"INCR_WRAP\",34056:\"DECR_WRAP\",34067:\"TEXTURE_CUBE_MAP\",34068:\"TEXTURE_BINDING_CUBE_MAP\",34069:\"TEXTURE_CUBE_MAP_POSITIVE_X\",34070:\"TEXTURE_CUBE_MAP_NEGATIVE_X\",34071:\"TEXTURE_CUBE_MAP_POSITIVE_Y\",34072:\"TEXTURE_CUBE_MAP_NEGATIVE_Y\",34073:\"TEXTURE_CUBE_MAP_POSITIVE_Z\",34074:\"TEXTURE_CUBE_MAP_NEGATIVE_Z\",34076:\"MAX_CUBE_MAP_TEXTURE_SIZE\",34338:\"VERTEX_ATTRIB_ARRAY_ENABLED\",34339:\"VERTEX_ATTRIB_ARRAY_SIZE\",34340:\"VERTEX_ATTRIB_ARRAY_STRIDE\",34341:\"VERTEX_ATTRIB_ARRAY_TYPE\",34342:\"CURRENT_VERTEX_ATTRIB\",34373:\"VERTEX_ATTRIB_ARRAY_POINTER\",34466:\"NUM_COMPRESSED_TEXTURE_FORMATS\",34467:\"COMPRESSED_TEXTURE_FORMATS\",34660:\"BUFFER_SIZE\",34661:\"BUFFER_USAGE\",34816:\"STENCIL_BACK_FUNC\",34817:\"STENCIL_BACK_FAIL\",34818:\"STENCIL_BACK_PASS_DEPTH_FAIL\",34819:\"STENCIL_BACK_PASS_DEPTH_PASS\",34877:\"BLEND_EQUATION_ALPHA\",34921:\"MAX_VERTEX_ATTRIBS\",34922:\"VERTEX_ATTRIB_ARRAY_NORMALIZED\",34930:\"MAX_TEXTURE_IMAGE_UNITS\",34962:\"ARRAY_BUFFER\",34963:\"ELEMENT_ARRAY_BUFFER\",34964:\"ARRAY_BUFFER_BINDING\",34965:\"ELEMENT_ARRAY_BUFFER_BINDING\",34975:\"VERTEX_ATTRIB_ARRAY_BUFFER_BINDING\",35040:\"STREAM_DRAW\",35044:\"STATIC_DRAW\",35048:\"DYNAMIC_DRAW\",35632:\"FRAGMENT_SHADER\",35633:\"VERTEX_SHADER\",35660:\"MAX_VERTEX_TEXTURE_IMAGE_UNITS\",35661:\"MAX_COMBINED_TEXTURE_IMAGE_UNITS\",35663:\"SHADER_TYPE\",35664:\"FLOAT_VEC2\",35665:\"FLOAT_VEC3\",35666:\"FLOAT_VEC4\",35667:\"INT_VEC2\",35668:\"INT_VEC3\",35669:\"INT_VEC4\",35670:\"BOOL\",35671:\"BOOL_VEC2\",35672:\"BOOL_VEC3\",35673:\"BOOL_VEC4\",35674:\"FLOAT_MAT2\",35675:\"FLOAT_MAT3\",35676:\"FLOAT_MAT4\",35678:\"SAMPLER_2D\",35680:\"SAMPLER_CUBE\",35712:\"DELETE_STATUS\",35713:\"COMPILE_STATUS\",35714:\"LINK_STATUS\",35715:\"VALIDATE_STATUS\",35716:\"INFO_LOG_LENGTH\",35717:\"ATTACHED_SHADERS\",35718:\"ACTIVE_UNIFORMS\",35719:\"ACTIVE_UNIFORM_MAX_LENGTH\",35720:\"SHADER_SOURCE_LENGTH\",35721:\"ACTIVE_ATTRIBUTES\",35722:\"ACTIVE_ATTRIBUTE_MAX_LENGTH\",35724:\"SHADING_LANGUAGE_VERSION\",35725:\"CURRENT_PROGRAM\",36003:\"STENCIL_BACK_REF\",36004:\"STENCIL_BACK_VALUE_MASK\",36005:\"STENCIL_BACK_WRITEMASK\",36006:\"FRAMEBUFFER_BINDING\",36007:\"RENDERBUFFER_BINDING\",36048:\"FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE\",36049:\"FRAMEBUFFER_ATTACHMENT_OBJECT_NAME\",36050:\"FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL\",36051:\"FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE\",36053:\"FRAMEBUFFER_COMPLETE\",36054:\"FRAMEBUFFER_INCOMPLETE_ATTACHMENT\",36055:\"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT\",36057:\"FRAMEBUFFER_INCOMPLETE_DIMENSIONS\",36061:\"FRAMEBUFFER_UNSUPPORTED\",36064:\"COLOR_ATTACHMENT0\",36096:\"DEPTH_ATTACHMENT\",36128:\"STENCIL_ATTACHMENT\",36160:\"FRAMEBUFFER\",36161:\"RENDERBUFFER\",36162:\"RENDERBUFFER_WIDTH\",36163:\"RENDERBUFFER_HEIGHT\",36164:\"RENDERBUFFER_INTERNAL_FORMAT\",36168:\"STENCIL_INDEX8\",36176:\"RENDERBUFFER_RED_SIZE\",36177:\"RENDERBUFFER_GREEN_SIZE\",36178:\"RENDERBUFFER_BLUE_SIZE\",36179:\"RENDERBUFFER_ALPHA_SIZE\",36180:\"RENDERBUFFER_DEPTH_SIZE\",36181:\"RENDERBUFFER_STENCIL_SIZE\",36194:\"RGB565\",36336:\"LOW_FLOAT\",36337:\"MEDIUM_FLOAT\",36338:\"HIGH_FLOAT\",36339:\"LOW_INT\",36340:\"MEDIUM_INT\",36341:\"HIGH_INT\",36346:\"SHADER_COMPILER\",36347:\"MAX_VERTEX_UNIFORM_VECTORS\",36348:\"MAX_VARYING_VECTORS\",36349:\"MAX_FRAGMENT_UNIFORM_VECTORS\",37440:\"UNPACK_FLIP_Y_WEBGL\",37441:\"UNPACK_PREMULTIPLY_ALPHA_WEBGL\",37442:\"CONTEXT_LOST_WEBGL\",37443:\"UNPACK_COLORSPACE_CONVERSION_WEBGL\",37444:\"BROWSER_DEFAULT_WEBGL\"}},{}],157:[function(t,e,r){var n=t(\"./1.0/numbers\");e.exports=function(t){return n[t]}},{\"./1.0/numbers\":156}],158:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.plot=t,this.shader=e,this.bufferHi=r,this.bufferLo=n,this.bounds=[1/0,1/0,-1/0,-1/0],this.numPoints=0,this.color=[0,0,0,1]}function i(t,e){var r=a(t.gl,l.vertex,l.fragment),i=o(t.gl),s=o(t.gl),u=new n(t,r,i,s);return u.update(e),t.addObject(u),u}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"typedarray-pool\"),l=t(\"./lib/shaders\");e.exports=i;var u=[[1,0,0,1,0,0],[1,0,0,-1,0,0],[-1,0,0,-1,0,0],[-1,0,0,-1,0,0],[-1,0,0,1,0,0],[1,0,0,1,0,0],[1,0,-1,0,0,1],[1,0,-1,0,0,-1],[1,0,1,0,0,-1],[1,0,1,0,0,-1],[1,0,1,0,0,1],[1,0,-1,0,0,1],[-1,0,-1,0,0,1],[-1,0,-1,0,0,-1],[-1,0,1,0,0,-1],[-1,0,1,0,0,-1],[-1,0,1,0,0,1],[-1,0,-1,0,0,1],[0,1,1,0,0,0],[0,1,-1,0,0,0],[0,-1,-1,0,0,0],[0,-1,-1,0,0,0],[0,1,1,0,0,0],[0,-1,1,0,0,0],[0,1,0,-1,1,0],[0,1,0,-1,-1,0],[0,1,0,1,-1,0],[0,1,0,1,1,0],[0,1,0,-1,1,0],[0,1,0,1,-1,0],[0,-1,0,-1,1,0],[0,-1,0,-1,-1,0],[0,-1,0,1,-1,0],[0,-1,0,1,1,0],[0,-1,0,-1,1,0],[0,-1,0,1,-1,0]],c=n.prototype;c.draw=function(){var t=new Float32Array([0,0]),e=new Float32Array([0,0]),r=new Float32Array([0,0]),n=new Float32Array([0,0]),i=[1,1];return function(){var a=this.plot,o=this.shader,s=this.bounds,l=this.numPoints;if(l){var c=a.gl,h=a.dataBox,f=a.viewBox,d=a.pixelRatio,p=s[2]-s[0],m=s[3]-s[1],v=h[2]-h[0],g=h[3]-h[1],y=2*p/v,b=2*m/g,x=(s[0]-h[0]-.5*v)/p,_=(s[1]-h[1]-.5*g)/m;t[0]=y,t[1]=b,e[0]=y-t[0],e[1]=b-t[1],r[0]=x,r[1]=_,n[0]=x-r[0],n[1]=_-r[1];var w=f[2]-f[0],M=f[3]-f[1];i[0]=2*d/w,i[1]=2*d/M,o.bind(),o.uniforms.scaleHi=t,o.uniforms.scaleLo=e,o.uniforms.translateHi=r,o.uniforms.translateLo=n,o.uniforms.pixelScale=i,o.uniforms.color=this.color,this.bufferLo.bind(),o.attributes.positionLo.pointer(c.FLOAT,!1,16,0),this.bufferHi.bind(),o.attributes.positionHi.pointer(c.FLOAT,!1,16,0),o.attributes.pixelOffset.pointer(c.FLOAT,!1,16,8),c.drawArrays(c.TRIANGLES,0,l*u.length)}}}(),c.drawPick=function(t){return t},c.pick=function(){return null},c.update=function(t){t=t||{};var e,r,n,i=t.positions||[],a=t.errors||[],o=1;\"lineWidth\"in t&&(o=+t.lineWidth);var l=5;\"capSize\"in t&&(l=+t.capSize),this.color=(t.color||[0,0,0,1]).slice();var c=this.bounds=[1/0,1/0,-1/0,-1/0],h=this.numPoints=i.length>>1;for(e=0;e<h;++e)r=i[2*e],n=i[2*e+1],c[0]=Math.min(r,c[0]),c[1]=Math.min(n,c[1]),c[2]=Math.max(r,c[2]),c[3]=Math.max(n,c[3]);c[2]===c[0]&&(c[2]+=1),c[3]===c[1]&&(c[3]+=1);var f=1/(c[2]-c[0]),d=1/(c[3]-c[1]),p=c[0],m=c[1],v=s.mallocFloat64(h*u.length*4),g=s.mallocFloat32(h*u.length*4),y=s.mallocFloat32(h*u.length*4),b=0;for(e=0;e<h;++e){r=i[2*e],n=i[2*e+1];for(var x=a[4*e],_=a[4*e+1],w=a[4*e+2],M=a[4*e+3],k=0;k<u.length;++k){var A=u[k],T=A[0],S=A[1];T<0?T*=x:T>0&&(T*=_),S<0?S*=w:S>0&&(S*=M),v[b++]=f*(r-p+T),v[b++]=d*(n-m+S),v[b++]=o*A[2]+(l+o)*A[4],v[b++]=o*A[3]+(l+o)*A[5]}}for(e=0;e<v.length;e++)g[e]=v[e],y[e]=v[e]-g[e];this.bufferHi.update(g),this.bufferLo.update(y),s.free(v)},c.dispose=function(){this.plot.removeObject(this),this.shader.dispose(),this.bufferHi.dispose(),this.bufferLo.dispose()}},{\"./lib/shaders\":159,\"gl-buffer\":155,\"gl-shader\":254,\"typedarray-pool\":540}],159:[function(t,e,r){e.exports={\n",
       "vertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi;\\nattribute vec2 positionLo;\\nattribute vec2 pixelOffset;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo, pixelScale;\\n\\nvec2 project(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\nvoid main() {\\n  vec3 scrPosition = vec3(\\n         project(scaleHi, translateHi, scaleLo, translateLo, positionHi, positionLo),\\n         1);\\n  gl_Position = vec4(\\n    scrPosition.xy + scrPosition.z * pixelScale * pixelOffset,\\n    0,\\n    scrPosition.z);\\n}\\n\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = vec4(color.rgb * color.a, color.a);\\n}\\n\"}},{}],160:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.shader=n,this.buffer=e,this.vao=r,this.pixelRatio=1,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.lineWidth=[1,1,1],this.capSize=[10,10,10],this.lineCount=[0,0,0],this.lineOffset=[0,0,0],this.opacity=1}function i(t,e){for(var r=0;r<3;++r)t[0][r]=Math.min(t[0][r],e[r]),t[1][r]=Math.max(t[1][r],e[r])}function a(t,e,r,n){for(var i=f[n],a=0;a<i.length;++a){var o=i[a];t.push(e[0],e[1],e[2],r[0],r[1],r[2],r[3],o[0],o[1],o[2])}return i.length}function o(t){var e=t.gl,r=s(e),i=l(e,[{buffer:r,type:e.FLOAT,size:3,offset:0,stride:40},{buffer:r,type:e.FLOAT,size:4,offset:12,stride:40},{buffer:r,type:e.FLOAT,size:3,offset:28,stride:40}]),a=u(e);a.attributes.position.location=0,a.attributes.color.location=1,a.attributes.offset.location=2;var o=new n(e,r,i,a);return o.update(t),o}e.exports=o;var s=t(\"gl-buffer\"),l=t(\"gl-vao\"),u=t(\"./shaders/index\"),c=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],h=n.prototype;h.isOpaque=function(){return this.opacity>=1},h.isTransparent=function(){return this.opacity<1},h.drawTransparent=h.draw=function(t){var e=this.gl,r=this.shader.uniforms;this.shader.bind();var n=r.view=t.view||c,i=r.projection=t.projection||c;r.model=t.model||c,r.clipBounds=this.clipBounds,r.opacity=this.opacity;var a=n[12],o=n[13],s=n[14],l=n[15],u=this.pixelRatio*(i[3]*a+i[7]*o+i[11]*s+i[15]*l)/e.drawingBufferHeight;this.vao.bind();for(var h=0;h<3;++h)e.lineWidth(this.lineWidth[h]),r.capSize=this.capSize[h]*u,this.lineCount[h]&&e.drawArrays(e.LINES,this.lineOffset[h],this.lineCount[h]);this.vao.unbind()};var f=function(){for(var t=new Array(3),e=0;e<3;++e){for(var r=[],n=1;n<=2;++n)for(var i=-1;i<=1;i+=2){var a=(n+e)%3,o=[0,0,0];o[a]=i,r.push(o)}t[e]=r}return t}();h.update=function(t){t=t||{},\"lineWidth\"in t&&(this.lineWidth=t.lineWidth,Array.isArray(this.lineWidth)||(this.lineWidth=[this.lineWidth,this.lineWidth,this.lineWidth])),\"capSize\"in t&&(this.capSize=t.capSize,Array.isArray(this.capSize)||(this.capSize=[this.capSize,this.capSize,this.capSize])),\"opacity\"in t&&(this.opacity=t.opacity);var e=t.color||[[0,0,0],[0,0,0],[0,0,0]],r=t.position,n=t.error;if(Array.isArray(e[0])||(e=[e,e,e]),r&&n){var o=[],s=r.length,l=0;this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.lineCount=[0,0,0];for(var u=0;u<3;++u){this.lineOffset[u]=l;t:for(var c=0;c<s;++c){for(var h=r[c],f=0;f<3;++f)if(isNaN(h[f])||!isFinite(h[f]))continue t;var d=n[c],p=e[u];if(Array.isArray(p[0])&&(p=e[c]),3===p.length&&(p=[p[0],p[1],p[2],1]),!isNaN(d[0][u])&&!isNaN(d[1][u])){if(d[0][u]<0){var m=h.slice();m[u]+=d[0][u],o.push(h[0],h[1],h[2],p[0],p[1],p[2],p[3],0,0,0,m[0],m[1],m[2],p[0],p[1],p[2],p[3],0,0,0),i(this.bounds,m),l+=2+a(o,m,p,u)}if(d[1][u]>0){var m=h.slice();m[u]+=d[1][u],o.push(h[0],h[1],h[2],p[0],p[1],p[2],p[3],0,0,0,m[0],m[1],m[2],p[0],p[1],p[2],p[3],0,0,0),i(this.bounds,m),l+=2+a(o,m,p,u)}}}this.lineCount[u]=l-this.lineOffset[u]}this.buffer.update(o)}},h.dispose=function(){this.shader.dispose(),this.buffer.dispose(),this.vao.dispose()}},{\"./shaders/index\":162,\"gl-buffer\":155,\"gl-vao\":270}],161:[function(t,e,r){e.exports=function(t){\"string\"==typeof t&&(t=[t]);for(var e=[].slice.call(arguments,1),r=[],n=0;n<t.length-1;n++)r.push(t[n],e[n]||\"\");return r.push(t[n]),r.join(\"\")}},{}],162:[function(t,e,r){\"use strict\";var n=t(\"glslify\"),i=t(\"gl-shader\"),a=n([\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, offset;\\nattribute vec4 color;\\nuniform mat4 model, view, projection;\\nuniform float capSize;\\nvarying vec4 fragColor;\\nvarying vec3 fragPosition;\\n\\nvoid main() {\\n  vec4 worldPosition  = model * vec4(position, 1.0);\\n  worldPosition       = (worldPosition / worldPosition.w) + vec4(capSize * offset, 0.0);\\n  gl_Position         = projection * view * worldPosition;\\n  fragColor           = color;\\n  fragPosition        = position;\\n}\"]),o=n([\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec3 clipBounds[2];\\nuniform float opacity;\\nvarying vec3 fragPosition;\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(fragPosition, clipBounds[0])) || any(greaterThan(fragPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = opacity * fragColor;\\n}\"]);e.exports=function(t){return i(t,a,o,null,[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"offset\",type:\"vec3\"}])}},{\"gl-shader\":254,glslify:161}],163:[function(t,e,r){\"use strict\";function n(t){return[t.getParameter(t.FRAMEBUFFER_BINDING),t.getParameter(t.RENDERBUFFER_BINDING),t.getParameter(t.TEXTURE_BINDING_2D)]}function i(t,e){t.bindFramebuffer(t.FRAMEBUFFER,e[0]),t.bindRenderbuffer(t.RENDERBUFFER,e[1]),t.bindTexture(t.TEXTURE_2D,e[2])}function a(t,e){var r=t.getParameter(e.MAX_COLOR_ATTACHMENTS_WEBGL);y=new Array(r+1);for(var n=0;n<=r;++n){for(var i=new Array(r),a=0;a<n;++a)i[a]=t.COLOR_ATTACHMENT0+a;for(var a=n;a<r;++a)i[a]=t.NONE;y[n]=i}}function o(t){switch(t){case p:throw new Error(\"gl-fbo: Framebuffer unsupported\");case m:throw new Error(\"gl-fbo: Framebuffer incomplete attachment\");case v:throw new Error(\"gl-fbo: Framebuffer incomplete dimensions\");case g:throw new Error(\"gl-fbo: Framebuffer incomplete missing attachment\");default:throw new Error(\"gl-fbo: Framebuffer failed for unspecified reason\")}}function s(t,e,r,n,i,a){if(!n)return null;var o=d(t,e,r,i,n);return o.magFilter=t.NEAREST,o.minFilter=t.NEAREST,o.mipSamples=1,o.bind(),t.framebufferTexture2D(t.FRAMEBUFFER,a,t.TEXTURE_2D,o.handle,0),o}function l(t,e,r,n,i){var a=t.createRenderbuffer();return t.bindRenderbuffer(t.RENDERBUFFER,a),t.renderbufferStorage(t.RENDERBUFFER,n,e,r),t.framebufferRenderbuffer(t.FRAMEBUFFER,i,t.RENDERBUFFER,a),a}function u(t){var e=n(t.gl),r=t.gl,a=t.handle=r.createFramebuffer(),u=t._shape[0],c=t._shape[1],h=t.color.length,f=t._ext,d=t._useStencil,p=t._useDepth,m=t._colorType;r.bindFramebuffer(r.FRAMEBUFFER,a);for(var v=0;v<h;++v)t.color[v]=s(r,u,c,m,r.RGBA,r.COLOR_ATTACHMENT0+v);0===h?(t._color_rb=l(r,u,c,r.RGBA4,r.COLOR_ATTACHMENT0),f&&f.drawBuffersWEBGL(y[0])):h>1&&f.drawBuffersWEBGL(y[h]);var g=r.getExtension(\"WEBGL_depth_texture\");g?d?t.depth=s(r,u,c,g.UNSIGNED_INT_24_8_WEBGL,r.DEPTH_STENCIL,r.DEPTH_STENCIL_ATTACHMENT):p&&(t.depth=s(r,u,c,r.UNSIGNED_SHORT,r.DEPTH_COMPONENT,r.DEPTH_ATTACHMENT)):p&&d?t._depth_rb=l(r,u,c,r.DEPTH_STENCIL,r.DEPTH_STENCIL_ATTACHMENT):p?t._depth_rb=l(r,u,c,r.DEPTH_COMPONENT16,r.DEPTH_ATTACHMENT):d&&(t._depth_rb=l(r,u,c,r.STENCIL_INDEX,r.STENCIL_ATTACHMENT));var b=r.checkFramebufferStatus(r.FRAMEBUFFER);if(b!==r.FRAMEBUFFER_COMPLETE){t._destroyed=!0,r.bindFramebuffer(r.FRAMEBUFFER,null),r.deleteFramebuffer(t.handle),t.handle=null,t.depth&&(t.depth.dispose(),t.depth=null),t._depth_rb&&(r.deleteRenderbuffer(t._depth_rb),t._depth_rb=null);for(var v=0;v<t.color.length;++v)t.color[v].dispose(),t.color[v]=null;t._color_rb&&(r.deleteRenderbuffer(t._color_rb),t._color_rb=null),i(r,e),o(b)}i(r,e)}function c(t,e,r,n,i,a,o,s){this.gl=t,this._shape=[0|e,0|r],this._destroyed=!1,this._ext=s,this.color=new Array(i);for(var l=0;l<i;++l)this.color[l]=null;this._color_rb=null,this.depth=null,this._depth_rb=null,this._colorType=n,this._useDepth=a,this._useStencil=o;var c=this,h=[0|e,0|r];Object.defineProperties(h,{0:{get:function(){return c._shape[0]},set:function(t){return c.width=t}},1:{get:function(){return c._shape[1]},set:function(t){return c.height=t}}}),this._shapeVector=h,u(this)}function h(t,e,r){if(t._destroyed)throw new Error(\"gl-fbo: Can't resize destroyed FBO\");if(t._shape[0]!==e||t._shape[1]!==r){var a=t.gl,s=a.getParameter(a.MAX_RENDERBUFFER_SIZE);if(e<0||e>s||r<0||r>s)throw new Error(\"gl-fbo: Can't resize FBO, invalid dimensions\");t._shape[0]=e,t._shape[1]=r;for(var l=n(a),u=0;u<t.color.length;++u)t.color[u].shape=t._shape;t._color_rb&&(a.bindRenderbuffer(a.RENDERBUFFER,t._color_rb),a.renderbufferStorage(a.RENDERBUFFER,a.RGBA4,t._shape[0],t._shape[1])),t.depth&&(t.depth.shape=t._shape),t._depth_rb&&(a.bindRenderbuffer(a.RENDERBUFFER,t._depth_rb),t._useDepth&&t._useStencil?a.renderbufferStorage(a.RENDERBUFFER,a.DEPTH_STENCIL,t._shape[0],t._shape[1]):t._useDepth?a.renderbufferStorage(a.RENDERBUFFER,a.DEPTH_COMPONENT16,t._shape[0],t._shape[1]):t._useStencil&&a.renderbufferStorage(a.RENDERBUFFER,a.STENCIL_INDEX,t._shape[0],t._shape[1])),a.bindFramebuffer(a.FRAMEBUFFER,t.handle);var c=a.checkFramebufferStatus(a.FRAMEBUFFER);c!==a.FRAMEBUFFER_COMPLETE&&(t.dispose(),i(a,l),o(c)),i(a,l)}}function f(t,e,r,n){p||(p=t.FRAMEBUFFER_UNSUPPORTED,m=t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT,v=t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS,g=t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT);var i=t.getExtension(\"WEBGL_draw_buffers\");if(!y&&i&&a(t,i),Array.isArray(e)&&(n=r,r=0|e[1],e=0|e[0]),\"number\"!=typeof e)throw new Error(\"gl-fbo: Missing shape parameter\");var o=t.getParameter(t.MAX_RENDERBUFFER_SIZE);if(e<0||e>o||r<0||r>o)throw new Error(\"gl-fbo: Parameters are too large for FBO\");n=n||{};var s=1;if(\"color\"in n){if((s=Math.max(0|n.color,0))<0)throw new Error(\"gl-fbo: Must specify a nonnegative number of colors\");if(s>1){if(!i)throw new Error(\"gl-fbo: Multiple draw buffer extension not supported\");if(s>t.getParameter(i.MAX_COLOR_ATTACHMENTS_WEBGL))throw new Error(\"gl-fbo: Context does not support \"+s+\" draw buffers\")}}var l=t.UNSIGNED_BYTE,u=t.getExtension(\"OES_texture_float\");if(n.float&&s>0){if(!u)throw new Error(\"gl-fbo: Context does not support floating point textures\");l=t.FLOAT}else n.preferFloat&&s>0&&u&&(l=t.FLOAT);var h=!0;\"depth\"in n&&(h=!!n.depth);var f=!1;return\"stencil\"in n&&(f=!!n.stencil),new c(t,e,r,l,s,h,f,i)}var d=t(\"gl-texture2d\");e.exports=f;var p,m,v,g,y=null,b=c.prototype;Object.defineProperties(b,{shape:{get:function(){return this._destroyed?[0,0]:this._shapeVector},set:function(t){if(Array.isArray(t)||(t=[0|t,0|t]),2!==t.length)throw new Error(\"gl-fbo: Shape vector must be length 2\");var e=0|t[0],r=0|t[1];return h(this,e,r),[e,r]},enumerable:!1},width:{get:function(){return this._destroyed?0:this._shape[0]},set:function(t){return t|=0,h(this,t,this._shape[1]),t},enumerable:!1},height:{get:function(){return this._destroyed?0:this._shape[1]},set:function(t){return t|=0,h(this,this._shape[0],t),t},enumerable:!1}}),b.bind=function(){if(!this._destroyed){var t=this.gl;t.bindFramebuffer(t.FRAMEBUFFER,this.handle),t.viewport(0,0,this._shape[0],this._shape[1])}},b.dispose=function(){if(!this._destroyed){this._destroyed=!0;var t=this.gl;t.deleteFramebuffer(this.handle),this.handle=null,this.depth&&(this.depth.dispose(),this.depth=null),this._depth_rb&&(t.deleteRenderbuffer(this._depth_rb),this._depth_rb=null);for(var e=0;e<this.color.length;++e)this.color[e].dispose(),this.color[e]=null;this._color_rb&&(t.deleteRenderbuffer(this._color_rb),this._color_rb=null)}}},{\"gl-texture2d\":266}],164:[function(t,e,r){function n(t,e,r){\"use strict\";var n=o(e)||\"of unknown name (see npm glsl-shader-name)\",l=\"unknown type\";void 0!==r&&(l=r===a.FRAGMENT_SHADER?\"fragment\":\"vertex\");for(var u=i(\"Error compiling %s shader %s:\\n\",l,n),c=i(\"%s%s\",u,t),h=t.split(\"\\n\"),f={},d=0;d<h.length;d++){var p=h[d];if(\"\"!==p){var m=parseInt(p.split(\":\")[2]);if(isNaN(m))throw new Error(i(\"Could not parse error: %s\",p));f[m]=p}}for(var v=s(e).split(\"\\n\"),d=0;d<v.length;d++)if(f[d+3]||f[d+2]||f[d+1]){var g=v[d];if(u+=g+\"\\n\",f[d+1]){var y=f[d+1];y=y.substr(y.split(\":\",3).join(\":\").length+1).trim(),u+=i(\"^^^ %s\\n\\n\",y)}}return{long:u.trim(),short:c.trim()}}var i=t(\"sprintf-js\").sprintf,a=t(\"gl-constants/lookup\"),o=t(\"glsl-shader-name\"),s=t(\"add-line-numbers\");e.exports=n},{\"add-line-numbers\":39,\"gl-constants/lookup\":157,\"glsl-shader-name\":278,\"sprintf-js\":526}],165:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.plot=t,this.shader=e,this.pickShader=r,this.positionBuffer=n,this.weightBuffer=i,this.colorBuffer=a,this.idBuffer=o,this.xData=[],this.yData=[],this.shape=[0,0],this.bounds=[1/0,1/0,-1/0,-1/0],this.pickOffset=0}function i(t,e){var r=t.gl,i=l(r,c.vertex,c.fragment),a=l(r,c.pickVertex,c.pickFragment),o=u(r),s=u(r),h=u(r),f=u(r),d=new n(t,i,a,o,s,h,f);return d.update(e),t.addObject(d),d}e.exports=i;var a=t(\"binary-search-bounds\"),o=t(\"iota-array\"),s=t(\"typedarray-pool\"),l=t(\"gl-shader\"),u=t(\"gl-buffer\"),c=t(\"./lib/shaders\"),h=n.prototype,f=[0,0,1,0,0,1,1,0,1,1,0,1];h.draw=function(){var t=[1,0,0,0,1,0,0,0,1];return function(){var e=this.plot,r=this.shader,n=this.bounds,i=this.numVertices;if(!(i<=0)){var a=e.gl,o=e.dataBox,s=n[2]-n[0],l=n[3]-n[1],u=o[2]-o[0],c=o[3]-o[1];t[0]=2*s/u,t[4]=2*l/c,t[6]=2*(n[0]-o[0])/u-1,t[7]=2*(n[1]-o[1])/c-1,r.bind();var h=r.uniforms;h.viewTransform=t,h.shape=this.shape;var f=r.attributes;this.positionBuffer.bind(),f.position.pointer(),this.weightBuffer.bind(),f.weight.pointer(a.UNSIGNED_BYTE,!1),this.colorBuffer.bind(),f.color.pointer(a.UNSIGNED_BYTE,!0),a.drawArrays(a.TRIANGLES,0,i)}}}(),h.drawPick=function(){var t=[1,0,0,0,1,0,0,0,1],e=[0,0,0,0];return function(r){var n=this.plot,i=this.pickShader,a=this.bounds,o=this.numVertices;if(!(o<=0)){var s=n.gl,l=n.dataBox,u=a[2]-a[0],c=a[3]-a[1],h=l[2]-l[0],f=l[3]-l[1];t[0]=2*u/h,t[4]=2*c/f,t[6]=2*(a[0]-l[0])/h-1,t[7]=2*(a[1]-l[1])/f-1;for(var d=0;d<4;++d)e[d]=r>>8*d&255;this.pickOffset=r,i.bind();var p=i.uniforms;p.viewTransform=t,p.pickOffset=e,p.shape=this.shape;var m=i.attributes;return this.positionBuffer.bind(),m.position.pointer(),this.weightBuffer.bind(),m.weight.pointer(s.UNSIGNED_BYTE,!1),this.idBuffer.bind(),m.pickId.pointer(s.UNSIGNED_BYTE,!1),s.drawArrays(s.TRIANGLES,0,o),r+this.shape[0]*this.shape[1]}}}(),h.pick=function(t,e,r){var n=this.pickOffset,i=this.shape[0]*this.shape[1];if(r<n||r>=n+i)return null;var a=r-n,o=this.xData,s=this.yData;return{object:this,pointId:a,dataCoord:[o[a%this.shape[0]],s[a/this.shape[0]|0]]}},h.update=function(t){t=t||{};var e=t.shape||[0,0],r=t.x||o(e[0]),n=t.y||o(e[1]),i=t.z||new Float32Array(e[0]*e[1]);this.xData=r,this.yData=n;var l=t.colorLevels||[0],u=t.colorValues||[0,0,0,1],c=l.length,h=this.bounds,d=h[0]=r[0],p=h[1]=n[0],m=h[2]=r[r.length-1],v=h[3]=n[n.length-1],g=1/(m-d),y=1/(v-p),b=e[0],x=e[1];this.shape=[b,x];var _=(b-1)*(x-1)*(f.length>>>1);this.numVertices=_;for(var w=s.mallocUint8(4*_),M=s.mallocFloat32(2*_),k=s.mallocUint8(2*_),A=s.mallocUint32(_),T=0,S=0;S<x-1;++S)for(var E=y*(n[S]-p),L=y*(n[S+1]-p),C=0;C<b-1;++C)for(var z=g*(r[C]-d),I=g*(r[C+1]-d),D=0;D<f.length;D+=2){var P,O,R,F,j=f[D],N=f[D+1],B=(S+N)*b+(C+j),U=i[B],V=a.le(l,U);if(V<0)P=u[0],O=u[1],R=u[2],F=u[3];else if(V===c-1)P=u[4*c-4],O=u[4*c-3],R=u[4*c-2],F=u[4*c-1];else{var H=(U-l[V])/(l[V+1]-l[V]),q=1-H,G=4*V,Y=4*(V+1);P=q*u[G]+H*u[Y],O=q*u[G+1]+H*u[Y+1],R=q*u[G+2]+H*u[Y+2],F=q*u[G+3]+H*u[Y+3]}w[4*T]=255*P,w[4*T+1]=255*O,w[4*T+2]=255*R,w[4*T+3]=255*F,M[2*T]=.5*z+.5*I,M[2*T+1]=.5*E+.5*L,k[2*T]=j,k[2*T+1]=N,A[T]=S*b+C,T+=1}this.positionBuffer.update(M),this.weightBuffer.update(k),this.colorBuffer.update(w),this.idBuffer.update(A),s.free(M),s.free(w),s.free(k),s.free(A)},h.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBuffer.dispose(),this.weightBuffer.dispose(),this.colorBuffer.dispose(),this.idBuffer.dispose(),this.plot.removeObject(this)}},{\"./lib/shaders\":166,\"binary-search-bounds\":167,\"gl-buffer\":155,\"gl-shader\":254,\"iota-array\":292,\"typedarray-pool\":540}],166:[function(t,e,r){\"use strict\";e.exports={fragment:\"precision lowp float;\\n#define GLSLIFY 1\\nvarying vec4 fragColor;\\nvoid main() {\\n  gl_FragColor = vec4(fragColor.rgb * fragColor.a, fragColor.a);\\n}\\n\",vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 color;\\nattribute vec2 weight;\\n\\nuniform vec2 shape;\\nuniform mat3 viewTransform;\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\\n  fragColor = color;\\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\\n}\\n\",pickFragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\nvarying vec2 vWeight;\\n\\nuniform vec2 shape;\\nuniform vec4 pickOffset;\\n\\nvoid main() {\\n  vec2 d = step(.5, vWeight);\\n  vec4 id = fragId + pickOffset;\\n  id.x += d.x + d.y*shape.x;\\n\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  gl_FragColor = id/255.;\\n}\\n\",pickVertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 pickId;\\nattribute vec2 weight;\\n\\nuniform vec2 shape;\\nuniform mat3 viewTransform;\\n\\nvarying vec4 fragId;\\nvarying vec2 vWeight;\\n\\nvoid main() {\\n  vWeight = weight;\\n\\n  fragId = pickId;\\n\\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\\n}\\n\"}},{}],167:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],168:[function(t,e,r){r.lineVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi, dLo;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, screenShape;\\nuniform float width;\\n\\nvarying vec2 direction;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvec2 project_2_1(vec2 scHi, vec2 scLo, vec2 posHi, vec2 posLo) {\\n  return scHi * posHi\\n       + scLo * posHi\\n       + scHi * posLo\\n       + scLo * posLo;\\n}\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  vec2 dir = project_2_1(scaleHi, scaleLo, dHi, dLo);\\n  vec2 n = 0.5 * width * normalize(screenShape.yx * vec2(dir.y, -dir.x)) / screenShape.xy;\\n  vec2 tangent = normalize(screenShape.xy * dir);\\n  if(dir.x < 0.0 || (dir.x == 0.0 && dir.y < 0.0)) {\\n    direction = -tangent;\\n  } else {\\n    direction = tangent;\\n  }\\n  gl_Position = vec4(p + n, 0.0, 1.0);\\n}\",r.lineFragment=\"precision highp float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\nuniform vec2 screenShape;\\nuniform sampler2D dashPattern;\\nuniform float dashLength;\\n\\nvarying vec2 direction;\\n\\nvoid main() {\\n  float t = fract(dot(direction, gl_FragCoord.xy) / dashLength);\\n  vec4 pcolor = color * texture2D(dashPattern, vec2(t, 0.0)).r;\\n  gl_FragColor = vec4(pcolor.rgb * pcolor.a, pcolor.a);\\n}\",r.mitreVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo;\\nuniform float radius;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  gl_Position = vec4(p, 0.0, 1.0);\\n  gl_PointSize = radius;\\n}\",r.mitreFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  if(length(gl_PointCoord.xy - 0.5) > 0.25) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(color.rgb, color.a);\\n}\",r.pickVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi;\\nattribute vec4 pick0, pick1;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, screenShape;\\nuniform float width;\\n\\nvarying vec4 pickA, pickB;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  vec2 n = width * normalize(screenShape.yx * vec2(dHi.y, -dHi.x)) / screenShape.xy;\\n  gl_Position = vec4(p + n, 0, 1);\\n  pickA = pick0;\\n  pickB = pick1;\\n}\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 pickOffset;\\n\\nvarying vec4 pickA, pickB;\\n\\nvoid main() {\\n  vec4 fragId = vec4(pickA.xyz, 0.0);\\n  if(pickB.w > pickA.w) {\\n    fragId.xyz = pickB.xyz;\\n  }\\n\\n  fragId += pickOffset;\\n\\n  fragId.y += floor(fragId.x / 256.0);\\n  fragId.x -= floor(fragId.x / 256.0) * 256.0;\\n\\n  fragId.z += floor(fragId.y / 256.0);\\n  fragId.y -= floor(fragId.y / 256.0) * 256.0;\\n\\n  fragId.w += floor(fragId.z / 256.0);\\n  fragId.z -= floor(fragId.z / 256.0) * 256.0;\\n\\n  gl_FragColor = fragId / 255.0;\\n}\",r.fillVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, projectAxis;\\nuniform float projectValue, depth;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  if(dHi.y < 0.0 || (dHi.y == 0.0 && dHi.x < 0.0)) {\\n    if(dot(p, projectAxis) < projectValue) {\\n      p = p * (1.0 - abs(projectAxis)) + projectAxis * projectValue;\\n    }\\n  }\\n  gl_Position = vec4(p, depth, 1);\\n}\",r.fillFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = vec4(color.rgb * color.a, color.a);\\n}\"},{}],169:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l){this.plot=t,this.dashPattern=e,this.lineBufferHi=r,this.lineBufferLo=n,this.pickBuffer=i,this.lineShader=a,this.mitreShader=o,this.fillShader=s,this.pickShader=l,this.usingDashes=!1,this.bounds=[1/0,1/0,-1/0,-1/0],this.width=1,this.color=[0,0,1,1],this.fill=[!1,!1,!1,!1],this.fillColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.data=null,this.numPoints=0,this.vertCount=0,this.pickOffset=0}function i(t){return t.map(function(t){return t.slice()})}function a(t,e){var r=t.gl,i=s(r),a=s(r),u=s(r),c=l(r,[1,1]),f=o(r,h.lineVertex,h.lineFragment),d=o(r,h.mitreVertex,h.mitreFragment),p=o(r,h.fillVertex,h.fillFragment),m=o(r,h.pickVertex,h.pickFragment),v=new n(t,c,i,a,u,f,d,p,m);return t.addObject(v),v.update(e),v}e.exports=a;var o=t(\"gl-shader\"),s=t(\"gl-buffer\"),l=t(\"gl-texture2d\"),u=t(\"ndarray\"),c=t(\"typedarray-pool\"),h=t(\"./lib/shaders\"),f=n.prototype;f.setProjectionModel=function(){var t={scaleHi:new Float32Array([0,0]),scaleLo:new Float32Array([0,0]),translateHi:new Float32Array([0,0]),translateLo:new Float32Array([0,0]),screenShape:[0,0]};return function(){var e=this.bounds,r=this.plot.viewBox,n=this.plot.dataBox,i=e[2]-e[0],a=e[3]-e[1],o=n[2]-n[0],s=n[3]-n[1],l=r[2]-r[0],u=r[3]-r[1],c=2*i/o,h=2*a/s,f=(e[0]-n[0]-.5*o)/i,d=(e[1]-n[1]-.5*s)/a;return t.scaleHi[0]=c,t.scaleHi[1]=h,t.scaleLo[0]=c-t.scaleHi[0],t.scaleLo[1]=h-t.scaleHi[1],t.translateHi[0]=f,t.translateHi[1]=d,t.translateLo[0]=f-t.translateHi[0],t.translateLo[1]=d-t.translateHi[1],t.screenShape[0]=l,t.screenShape[1]=u,t}}(),f.setProjectionUniforms=function(t,e){t.scaleHi=e.scaleHi,t.scaleLo=e.scaleLo,t.translateHi=e.translateHi,t.translateLo=e.translateLo,t.screenShape=e.screenShape},f.draw=function(){var t=[1,0],e=[-1,0],r=[0,1],n=[0,-1];return function(){var i=this.vertCount;if(i){var a=this.setProjectionModel(),o=this.plot,s=this.width,l=o.gl,u=o.pixelRatio,c=this.color,h=this.fillShader.attributes;this.lineBufferLo.bind(),h.aLo.pointer(l.FLOAT,!1,16,0),this.lineBufferHi.bind();var f=this.fill;if(f[0]||f[1]||f[2]||f[3]){var d=this.fillShader;d.bind();var p=d.uniforms;this.setProjectionUniforms(p,a),p.depth=o.nextDepthValue(),h.aHi.pointer(l.FLOAT,!1,16,0),h.dHi.pointer(l.FLOAT,!1,16,8),l.depthMask(!0),l.enable(l.DEPTH_TEST);var m=this.fillColor;f[0]&&(p.color=m[0],p.projectAxis=e,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[1]&&(p.color=m[1],p.projectAxis=n,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[2]&&(p.color=m[2],p.projectAxis=t,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[3]&&(p.color=m[3],p.projectAxis=r,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),l.depthMask(!1),l.disable(l.DEPTH_TEST)}var v=this.lineShader;v.bind(),this.lineBufferLo.bind(),v.attributes.aLo.pointer(l.FLOAT,!1,16,0),v.attributes.dLo.pointer(l.FLOAT,!1,16,8),this.lineBufferHi.bind();var g=v.uniforms;this.setProjectionUniforms(g,a),g.color=c,g.width=s*u,g.dashPattern=this.dashPattern.bind(),g.dashLength=this.dashLength*u;var y=v.attributes;if(y.aHi.pointer(l.FLOAT,!1,16,0),y.dHi.pointer(l.FLOAT,!1,16,8),l.drawArrays(l.TRIANGLES,0,i),s>2&&!this.usingDashes){var b=this.mitreShader;this.lineBufferLo.bind(),b.attributes.aLo.pointer(l.FLOAT,!1,48,0),this.lineBufferHi.bind(),b.bind();var x=b.uniforms;this.setProjectionUniforms(x,a),x.color=c,x.radius=s*u,b.attributes.aHi.pointer(l.FLOAT,!1,48,0),l.drawArrays(l.POINTS,0,i/3|0)}}}}(),f.drawPick=function(){var t=[0,0,0,0];return function(e){var r=this.vertCount,n=this.numPoints;if(this.pickOffset=e,!r)return e+n;var i=this.setProjectionModel(),a=this.plot,o=this.width,s=a.gl,l=a.pickPixelRatio,u=this.pickShader,c=this.pickBuffer;t[0]=255&e,t[1]=e>>>8&255,t[2]=e>>>16&255,t[3]=e>>>24,u.bind();var h=u.uniforms;this.setProjectionUniforms(h,i),h.width=o*l,h.pickOffset=t;var f=u.attributes;return this.lineBufferHi.bind(),f.aHi.pointer(s.FLOAT,!1,16,0),f.dHi.pointer(s.FLOAT,!1,16,8),this.lineBufferLo.bind(),f.aLo.pointer(s.FLOAT,!1,16,0),c.bind(),f.pick0.pointer(s.UNSIGNED_BYTE,!1,8,0),f.pick1.pointer(s.UNSIGNED_BYTE,!1,8,4),s.drawArrays(s.TRIANGLES,0,r),e+n}}(),f.pick=function(t,e,r){var n=this.pickOffset,i=this.numPoints;if(r<n||r>=n+i)return null;var a=r-n,o=this.data;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}},f.update=function(t){t=t||{};var e,r,n,a,o,s=this.plot.gl;this.color=(t.color||[0,0,1,1]).slice(),this.width=+(t.width||1),this.fill=(t.fill||[!1,!1,!1,!1]).slice(),this.fillColor=i(t.fillColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]);var h=t.dashes||[1],f=0;for(e=0;e<h.length;++e)f+=h[e];var d=c.mallocUint8(f);n=0;var p=255;for(e=0;e<h.length;++e){for(r=0;r<h[e];++r)d[n++]=p;p^=255}this.dashPattern.dispose(),this.usingDashes=h.length>1,this.dashPattern=l(s,u(d,[f,1,4],[1,0,0])),this.dashPattern.minFilter=s.NEAREST,this.dashPattern.magFilter=s.NEAREST,this.dashLength=f,c.free(d);var m=t.positions;this.data=m;var v=this.bounds;v[0]=v[1]=1/0,v[2]=v[3]=-1/0;var g=this.numPoints=m.length>>>1;if(0!==g){for(e=0;e<g;++e)a=m[2*e],o=m[2*e+1],isNaN(a)||isNaN(o)||(v[0]=Math.min(v[0],a),v[1]=Math.min(v[1],o),v[2]=Math.max(v[2],a),v[3]=Math.max(v[3],o));v[0]===v[2]&&(v[2]+=1),v[3]===v[1]&&(v[3]+=1);var y=c.mallocFloat64(24*(g-1)),b=c.mallocFloat32(24*(g-1)),x=c.mallocFloat32(24*(g-1)),_=c.mallocUint32(12*(g-1)),w=b.length,M=_.length;n=g;for(var k=0;n>1;){var A=--n;a=m[2*n],o=m[2*n+1];var T=A-1,S=m[2*T],E=m[2*T+1];if(!(isNaN(a)||isNaN(o)||isNaN(S)||isNaN(E))){k+=1,a=(a-v[0])/(v[2]-v[0]),o=(o-v[1])/(v[3]-v[1]),S=(S-v[0])/(v[2]-v[0]),E=(E-v[1])/(v[3]-v[1]);var L=S-a,C=E-o,z=A|1<<24,I=A-1,D=A,P=A-1|1<<24;y[--w]=-C,y[--w]=-L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I,y[--w]=C,y[--w]=L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=-C,y[--w]=-L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=C,y[--w]=L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=-C,y[--w]=-L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I,y[--w]=C,y[--w]=L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I}}for(e=0;e<y.length;e++)b[e]=y[e],x[e]=y[e]-b[e];this.vertCount=6*k,this.lineBufferHi.update(b.subarray(w)),this.lineBufferLo.update(x.subarray(w)),this.pickBuffer.update(_.subarray(M)),c.free(y),c.free(b),c.free(x),c.free(_)}},f.dispose=function(){this.plot.removeObject(this),this.lineBufferLo.dispose(),this.lineBufferHi.dispose(),this.pickBuffer.dispose(),this.lineShader.dispose(),this.mitreShader.dispose(),this.fillShader.dispose(),this.pickShader.dispose(),this.dashPattern.dispose()}},{\"./lib/shaders\":168,\"gl-buffer\":155,\"gl-shader\":254,\"gl-texture2d\":266,ndarray:466,\"typedarray-pool\":540}],170:[function(t,e,r){var n=t(\"gl-shader\"),i=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, nextPosition;\\nattribute float arcLength, lineWidth;\\nattribute vec4 color;\\n\\nuniform vec2 screenShape;\\nuniform float pixelRatio;\\nuniform mat4 model, view, projection;\\n\\nvarying vec4 fragColor;\\nvarying vec3 worldPosition;\\nvarying float pixelArcLength;\\n\\nvoid main() {\\n  vec4 projected = projection * view * model * vec4(position, 1.0);\\n  vec4 tangentClip = projection * view * model * vec4(nextPosition - position, 0.0);\\n  vec2 tangent = normalize(screenShape * tangentClip.xy);\\n  vec2 offset = 0.5 * pixelRatio * lineWidth * vec2(tangent.y, -tangent.x) / screenShape;\\n\\n  gl_Position = vec4(projected.xy + projected.w * offset, projected.zw);\\n\\n  worldPosition = position;\\n  pixelArcLength = arcLength;\\n  fragColor = color;\\n}\\n\",a=[{name:\"position\",type:\"vec3\"},{name:\"nextPosition\",type:\"vec3\"},{name:\"arcLength\",type:\"float\"},{name:\"lineWidth\",type:\"float\"},{name:\"color\",type:\"vec4\"}];r.createShader=function(t){return n(t,i,\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3      clipBounds[2];\\nuniform sampler2D dashTexture;\\nuniform float     dashScale;\\nuniform float     opacity;\\n\\nvarying vec3    worldPosition;\\nvarying float   pixelArcLength;\\nvarying vec4    fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(worldPosition, clipBounds[0])) || any(greaterThan(worldPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  float dashWeight = texture2D(dashTexture, vec2(dashScale * pixelArcLength, 0)).r;\\n  if(dashWeight < 0.5) {\\n    discard;\\n  }\\n  gl_FragColor = fragColor * opacity;\\n}\\n\",null,a)},r.createPickShader=function(t){return n(t,i,\"precision mediump float;\\n#define GLSLIFY 1\\n\\n#define FLOAT_MAX  1.70141184e38\\n#define FLOAT_MIN  1.17549435e-38\\n\\nlowp vec4 encode_float_1_0(highp float v) {\\n  highp float av = abs(v);\\n\\n  //Handle special cases\\n  if(av < FLOAT_MIN) {\\n    return vec4(0.0, 0.0, 0.0, 0.0);\\n  } else if(v > FLOAT_MAX) {\\n    return vec4(127.0, 128.0, 0.0, 0.0) / 255.0;\\n  } else if(v < -FLOAT_MAX) {\\n    return vec4(255.0, 128.0, 0.0, 0.0) / 255.0;\\n  }\\n\\n  highp vec4 c = vec4(0,0,0,0);\\n\\n  //Compute exponent and mantissa\\n  highp float e = floor(log2(av));\\n  highp float m = av * pow(2.0, -e) - 1.0;\\n  \\n  //Unpack mantissa\\n  c[1] = floor(128.0 * m);\\n  m -= c[1] / 128.0;\\n  c[2] = floor(32768.0 * m);\\n  m -= c[2] / 32768.0;\\n  c[3] = floor(8388608.0 * m);\\n  \\n  //Unpack exponent\\n  highp float ebias = e + 127.0;\\n  c[0] = floor(ebias / 2.0);\\n  ebias -= c[0] * 2.0;\\n  c[1] += floor(ebias) * 128.0; \\n\\n  //Unpack sign bit\\n  c[0] += 128.0 * step(0.0, -v);\\n\\n  //Scale back to range\\n  return c / 255.0;\\n}\\n\\n\\n\\nuniform float pickId;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec3 worldPosition;\\nvarying float pixelArcLength;\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(worldPosition, clipBounds[0])) || any(greaterThan(worldPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(pickId/255.0, encode_float_1_0(pixelArcLength).xyz);\\n}\",null,a)}},{\"gl-shader\":254}],171:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0,n=0;n<3;++n){var i=t[n]-e[n];r+=i*i}return Math.sqrt(r)}function i(t){\n",
       "for(var e=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],r=0;r<3;++r)e[0][r]=Math.max(t[0][r],e[0][r]),e[1][r]=Math.min(t[1][r],e[1][r]);return e}function a(t,e,r,n){this.arcLength=t,this.position=e,this.index=r,this.dataCoordinate=n}function o(t,e,r,n,i,a){this.gl=t,this.shader=e,this.pickShader=r,this.buffer=n,this.vao=i,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.points=[],this.arcLength=[],this.vertexCount=0,this.bounds=[[0,0,0],[0,0,0]],this.pickId=0,this.lineWidth=1,this.texture=a,this.dashScale=1,this.opacity=1,this.dirty=!0,this.pixelRatio=1}function s(t){var e=t.gl||t.scene&&t.scene.gl,r=m(e);r.attributes.position.location=0,r.attributes.nextPosition.location=1,r.attributes.arcLength.location=2,r.attributes.lineWidth.location=3,r.attributes.color.location=4;var n=v(e);n.attributes.position.location=0,n.attributes.nextPosition.location=1,n.attributes.arcLength.location=2,n.attributes.lineWidth.location=3,n.attributes.color.location=4;for(var i=l(e),a=u(e,[{buffer:i,size:3,offset:0,stride:48},{buffer:i,size:3,offset:12,stride:48},{buffer:i,size:1,offset:24,stride:48},{buffer:i,size:1,offset:28,stride:48},{buffer:i,size:4,offset:32,stride:48}]),s=d(new Array(1024),[256,1,4]),h=0;h<1024;++h)s.data[h]=255;var f=c(e,s);f.wrap=e.REPEAT;var p=new o(e,r,n,i,a,f);return p.update(t),p}e.exports=s;var l=t(\"gl-buffer\"),u=t(\"gl-vao\"),c=t(\"gl-texture2d\"),h=t(\"glsl-read-float\"),f=t(\"binary-search-bounds\"),d=t(\"ndarray\"),p=t(\"./lib/shaders\"),m=p.createShader,v=p.createPickShader,g=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],y=o.prototype;y.isTransparent=function(){return this.opacity<1},y.isOpaque=function(){return this.opacity>=1},y.pickSlots=1,y.setPickBase=function(t){this.pickId=t},y.drawTransparent=y.draw=function(t){var e=this.gl,r=this.shader,n=this.vao;r.bind(),r.uniforms={model:t.model||g,view:t.view||g,projection:t.projection||g,clipBounds:i(this.clipBounds),dashTexture:this.texture.bind(),dashScale:this.dashScale/this.arcLength[this.arcLength.length-1],opacity:this.opacity,screenShape:[e.drawingBufferWidth,e.drawingBufferHeight],pixelRatio:this.pixelRatio},n.bind(),n.draw(e.TRIANGLE_STRIP,this.vertexCount)},y.drawPick=function(t){var e=this.gl,r=this.pickShader,n=this.vao;r.bind(),r.uniforms={model:t.model||g,view:t.view||g,projection:t.projection||g,pickId:this.pickId,clipBounds:i(this.clipBounds),screenShape:[e.drawingBufferWidth,e.drawingBufferHeight],pixelRatio:this.pixelRatio},n.bind(),n.draw(e.TRIANGLE_STRIP,this.vertexCount)},y.update=function(t){var e,r;this.dirty=!0;var i=!!t.connectGaps;\"dashScale\"in t&&(this.dashScale=t.dashScale),\"opacity\"in t&&(this.opacity=+t.opacity);var a=t.position||t.positions;if(a){var o=t.color||t.colors||[0,0,0,1],s=t.lineWidth||1,l=[],u=[],c=[],h=0,p=0,m=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],v=!1;t:for(e=1;e<a.length;++e){var g=a[e-1],y=a[e];for(u.push(h),c.push(g.slice()),r=0;r<3;++r){if(isNaN(g[r])||isNaN(y[r])||!isFinite(g[r])||!isFinite(y[r])){if(!i&&l.length>0){for(var b=0;b<24;++b)l.push(l[l.length-12]);p+=2,v=!0}continue t}m[0][r]=Math.min(m[0][r],g[r],y[r]),m[1][r]=Math.max(m[1][r],g[r],y[r])}var x,_;Array.isArray(o[0])?(x=o[e-1],_=o[e]):x=_=o,3===x.length&&(x=[x[0],x[1],x[2],1]),3===_.length&&(_=[_[0],_[1],_[2],1]);var w;w=Array.isArray(s)?s[e-1]:s;var M=h;if(h+=n(g,y),v){for(r=0;r<2;++r)l.push(g[0],g[1],g[2],y[0],y[1],y[2],M,w,x[0],x[1],x[2],x[3]);p+=2,v=!1}l.push(g[0],g[1],g[2],y[0],y[1],y[2],M,w,x[0],x[1],x[2],x[3],g[0],g[1],g[2],y[0],y[1],y[2],M,-w,x[0],x[1],x[2],x[3],y[0],y[1],y[2],g[0],g[1],g[2],h,-w,_[0],_[1],_[2],_[3],y[0],y[1],y[2],g[0],g[1],g[2],h,w,_[0],_[1],_[2],_[3]),p+=4}if(this.buffer.update(l),u.push(h),c.push(a[a.length-1].slice()),this.bounds=m,this.vertexCount=p,this.points=c,this.arcLength=u,\"dashes\"in t){var k=t.dashes,A=k.slice();for(A.unshift(0),e=1;e<A.length;++e)A[e]=A[e-1]+A[e];var T=d(new Array(1024),[256,1,4]);for(e=0;e<256;++e){for(r=0;r<4;++r)T.set(e,0,r,0);1&f.le(A,A[A.length-1]*e/255)?T.set(e,0,0,0):T.set(e,0,0,255)}this.texture.setPixels(T)}}},y.dispose=function(){this.shader.dispose(),this.vao.dispose(),this.buffer.dispose()},y.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=h(t.value[0],t.value[1],t.value[2],0),r=f.le(this.arcLength,e);if(r<0)return null;if(r===this.arcLength.length-1)return new a(this.arcLength[this.arcLength.length-1],this.points[this.points.length-1].slice(),r);for(var n=this.points[r],i=this.points[Math.min(r+1,this.points.length-1)],o=(e-this.arcLength[r])/(this.arcLength[r+1]-this.arcLength[r]),s=1-o,l=[0,0,0],u=0;u<3;++u)l[u]=s*n[u]+o*i[u];var c=Math.min(o<.5?r:r+1,this.points.length-1);return new a(e,l,c,this.points[c])}},{\"./lib/shaders\":170,\"binary-search-bounds\":65,\"gl-buffer\":155,\"gl-texture2d\":266,\"gl-vao\":270,\"glsl-read-float\":277,ndarray:466}],172:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*a-i*n;return o?(o=1/o,t[0]=a*o,t[1]=-n*o,t[2]=-i*o,t[3]=r*o,t):null}e.exports=n},{}],173:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=c*o-s*u,f=-c*a+s*l,d=u*a-o*l,p=r*h+n*f+i*d;return p?(p=1/p,t[0]=h*p,t[1]=(-c*n+i*u)*p,t[2]=(s*n-i*o)*p,t[3]=f*p,t[4]=(c*r-i*l)*p,t[5]=(-s*r+i*a)*p,t[6]=d*p,t[7]=(-u*r+n*l)*p,t[8]=(o*r-n*a)*p,t):null}e.exports=n},{}],174:[function(t,e,r){function n(t){var e=new Float32Array(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e}e.exports=n},{}],175:[function(t,e,r){function n(){var t=new Float32Array(16);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],176:[function(t,e,r){function n(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8],c=t[9],h=t[10],f=t[11],d=t[12],p=t[13],m=t[14],v=t[15];return(e*o-r*a)*(h*v-f*m)-(e*s-n*a)*(c*v-f*p)+(e*l-i*a)*(c*m-h*p)+(r*s-n*o)*(u*v-f*d)-(r*l-i*o)*(u*m-h*d)+(n*l-i*s)*(u*p-c*d)}e.exports=n},{}],177:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[1]=c+g,t[2]=f-v,t[3]=0,t[4]=c-g,t[5]=1-u-p,t[6]=d+m,t[7]=0,t[8]=f+v,t[9]=d-m,t[10]=1-u-h,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],178:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=n+n,l=i+i,u=a+a,c=n*s,h=n*l,f=n*u,d=i*l,p=i*u,m=a*u,v=o*s,g=o*l,y=o*u;return t[0]=1-(d+m),t[1]=h+y,t[2]=f-g,t[3]=0,t[4]=h-y,t[5]=1-(c+m),t[6]=p+v,t[7]=0,t[8]=f+g,t[9]=p-v,t[10]=1-(c+d),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t}e.exports=n},{}],179:[function(t,e,r){function n(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],180:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(i*E-n*L-a*S)*C,t[2]=(m*M-v*w+g*_)*C,t[3]=(f*w-h*M-d*_)*C,t[4]=(l*T-o*L-u*A)*C,t[5]=(r*L-i*T+a*A)*C,t[6]=(v*x-p*M-g*b)*C,t[7]=(c*M-f*x+d*b)*C,t[8]=(o*E-s*T+u*k)*C,t[9]=(n*T-r*E-a*k)*C,t[10]=(p*w-m*x+g*y)*C,t[11]=(h*x-c*w-d*y)*C,t[12]=(s*A-o*S-l*k)*C,t[13]=(r*S-n*A+i*k)*C,t[14]=(m*b-p*_-v*y)*C,t[15]=(c*_-h*b+f*y)*C,t):null}e.exports=n},{}],181:[function(t,e,r){function n(t,e,r,n){var a,o,s,l,u,c,h,f,d,p,m=e[0],v=e[1],g=e[2],y=n[0],b=n[1],x=n[2],_=r[0],w=r[1],M=r[2];return Math.abs(m-_)<1e-6&&Math.abs(v-w)<1e-6&&Math.abs(g-M)<1e-6?i(t):(h=m-_,f=v-w,d=g-M,p=1/Math.sqrt(h*h+f*f+d*d),h*=p,f*=p,d*=p,a=b*d-x*f,o=x*h-y*d,s=y*f-b*h,p=Math.sqrt(a*a+o*o+s*s),p?(p=1/p,a*=p,o*=p,s*=p):(a=0,o=0,s=0),l=f*s-d*o,u=d*a-h*s,c=h*o-f*a,p=Math.sqrt(l*l+u*u+c*c),p?(p=1/p,l*=p,u*=p,c*=p):(l=0,u=0,c=0),t[0]=a,t[1]=l,t[2]=h,t[3]=0,t[4]=o,t[5]=u,t[6]=f,t[7]=0,t[8]=s,t[9]=c,t[10]=d,t[11]=0,t[12]=-(a*m+o*v+s*g),t[13]=-(l*m+u*v+c*g),t[14]=-(h*m+f*v+d*g),t[15]=1,t)}var i=t(\"./identity\");e.exports=n},{\"./identity\":179}],182:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],m=e[12],v=e[13],g=e[14],y=e[15],b=r[0],x=r[1],_=r[2],w=r[3];return t[0]=b*n+x*s+_*h+w*m,t[1]=b*i+x*l+_*f+w*v,t[2]=b*a+x*u+_*d+w*g,t[3]=b*o+x*c+_*p+w*y,b=r[4],x=r[5],_=r[6],w=r[7],t[4]=b*n+x*s+_*h+w*m,t[5]=b*i+x*l+_*f+w*v,t[6]=b*a+x*u+_*d+w*g,t[7]=b*o+x*c+_*p+w*y,b=r[8],x=r[9],_=r[10],w=r[11],t[8]=b*n+x*s+_*h+w*m,t[9]=b*i+x*l+_*f+w*v,t[10]=b*a+x*u+_*d+w*g,t[11]=b*o+x*c+_*p+w*y,b=r[12],x=r[13],_=r[14],w=r[15],t[12]=b*n+x*s+_*h+w*m,t[13]=b*i+x*l+_*f+w*v,t[14]=b*a+x*u+_*d+w*g,t[15]=b*o+x*c+_*p+w*y,t}e.exports=n},{}],183:[function(t,e,r){function n(t,e,r,n,i){var a=1/Math.tan(e/2),o=1/(n-i);return t[0]=a/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=(i+n)*o,t[11]=-1,t[12]=0,t[13]=0,t[14]=2*i*n*o,t[15]=0,t}e.exports=n},{}],184:[function(t,e,r){function n(t,e,r,n){var i,a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T,S,E=n[0],L=n[1],C=n[2],z=Math.sqrt(E*E+L*L+C*C);return Math.abs(z)<1e-6?null:(z=1/z,E*=z,L*=z,C*=z,i=Math.sin(r),a=Math.cos(r),o=1-a,s=e[0],l=e[1],u=e[2],c=e[3],h=e[4],f=e[5],d=e[6],p=e[7],m=e[8],v=e[9],g=e[10],y=e[11],b=E*E*o+a,x=L*E*o+C*i,_=C*E*o-L*i,w=E*L*o-C*i,M=L*L*o+a,k=C*L*o+E*i,A=E*C*o+L*i,T=L*C*o-E*i,S=C*C*o+a,t[0]=s*b+h*x+m*_,t[1]=l*b+f*x+v*_,t[2]=u*b+d*x+g*_,t[3]=c*b+p*x+y*_,t[4]=s*w+h*M+m*k,t[5]=l*w+f*M+v*k,t[6]=u*w+d*M+g*k,t[7]=c*w+p*M+y*k,t[8]=s*A+h*T+m*S,t[9]=l*A+f*T+v*S,t[10]=u*A+d*T+g*S,t[11]=c*A+p*T+y*S,e!==t&&(t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t)}e.exports=n},{}],185:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[4],o=e[5],s=e[6],l=e[7],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=a*i+u*n,t[5]=o*i+c*n,t[6]=s*i+h*n,t[7]=l*i+f*n,t[8]=u*i-a*n,t[9]=c*i-o*n,t[10]=h*i-s*n,t[11]=f*i-l*n,t}e.exports=n},{}],186:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i-u*n,t[1]=o*i-c*n,t[2]=s*i-h*n,t[3]=l*i-f*n,t[8]=a*n+u*i,t[9]=o*n+c*i,t[10]=s*n+h*i,t[11]=l*n+f*i,t}e.exports=n},{}],187:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[4],c=e[5],h=e[6],f=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i+u*n,t[1]=o*i+c*n,t[2]=s*i+h*n,t[3]=l*i+f*n,t[4]=u*i-a*n,t[5]=c*i-o*n,t[6]=h*i-s*n,t[7]=f*i-l*n,t}e.exports=n},{}],188:[function(t,e,r){function n(t,e,r){var n=r[0],i=r[1],a=r[2];return t[0]=e[0]*n,t[1]=e[1]*n,t[2]=e[2]*n,t[3]=e[3]*n,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*a,t[9]=e[9]*a,t[10]=e[10]*a,t[11]=e[11]*a,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t}e.exports=n},{}],189:[function(t,e,r){function n(t,e,r){var n,i,a,o,s,l,u,c,h,f,d,p,m=r[0],v=r[1],g=r[2];return e===t?(t[12]=e[0]*m+e[4]*v+e[8]*g+e[12],t[13]=e[1]*m+e[5]*v+e[9]*g+e[13],t[14]=e[2]*m+e[6]*v+e[10]*g+e[14],t[15]=e[3]*m+e[7]*v+e[11]*g+e[15]):(n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=u,t[7]=c,t[8]=h,t[9]=f,t[10]=d,t[11]=p,t[12]=n*m+s*v+h*g+e[12],t[13]=i*m+l*v+f*g+e[13],t[14]=a*m+u*v+d*g+e[14],t[15]=o*m+c*v+p*g+e[15]),t}e.exports=n},{}],190:[function(t,e,r){function n(t,e){if(t===e){var r=e[1],n=e[2],i=e[3],a=e[6],o=e[7],s=e[11];t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=a,t[11]=e[14],t[12]=i,t[13]=o,t[14]=s}else t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15];return t}e.exports=n},{}],191:[function(t,e,r){\"use strict\";function n(t,e){switch(e.length){case 0:break;case 1:t[0]=1/e[0];break;case 4:i(t,e);break;case 9:a(t,e);break;case 16:o(t,e);break;default:throw new Error(\"currently supports matrices up to 4x4\")}return t}e.exports=n;var i=t(\"gl-mat2/invert\"),a=t(\"gl-mat3/invert\"),o=t(\"gl-mat4/invert\")},{\"gl-mat2/invert\":172,\"gl-mat3/invert\":173,\"gl-mat4/invert\":180}],192:[function(t,e,r){r.glMatrix=t(\"./gl-matrix/common.js\"),r.mat2=t(\"./gl-matrix/mat2.js\"),r.mat2d=t(\"./gl-matrix/mat2d.js\"),r.mat3=t(\"./gl-matrix/mat3.js\"),r.mat4=t(\"./gl-matrix/mat4.js\"),r.quat=t(\"./gl-matrix/quat.js\"),r.vec2=t(\"./gl-matrix/vec2.js\"),r.vec3=t(\"./gl-matrix/vec3.js\"),r.vec4=t(\"./gl-matrix/vec4.js\")},{\"./gl-matrix/common.js\":193,\"./gl-matrix/mat2.js\":194,\"./gl-matrix/mat2d.js\":195,\"./gl-matrix/mat3.js\":196,\"./gl-matrix/mat4.js\":197,\"./gl-matrix/quat.js\":198,\"./gl-matrix/vec2.js\":199,\"./gl-matrix/vec3.js\":200,\"./gl-matrix/vec4.js\":201}],193:[function(t,e,r){var n={};n.EPSILON=1e-6,n.ARRAY_TYPE=\"undefined\"!=typeof Float32Array?Float32Array:Array,n.RANDOM=Math.random,n.ENABLE_SIMD=!1,n.SIMD_AVAILABLE=n.ARRAY_TYPE===Float32Array&&\"SIMD\"in this,n.USE_SIMD=n.ENABLE_SIMD&&n.SIMD_AVAILABLE,n.setMatrixArrayType=function(t){n.ARRAY_TYPE=t};var i=Math.PI/180;n.toRadian=function(t){return t*i},n.equals=function(t,e){return Math.abs(t-e)<=n.EPSILON*Math.max(1,Math.abs(t),Math.abs(e))},e.exports=n},{}],194:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},i.clone=function(t){var e=new n.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},i.fromValues=function(t,e,r,i){var a=new n.ARRAY_TYPE(4);return a[0]=t,a[1]=e,a[2]=r,a[3]=i,a},i.set=function(t,e,r,n,i){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t},i.transpose=function(t,e){if(t===e){var r=e[1];t[1]=e[2],t[2]=r}else t[0]=e[0],t[1]=e[2],t[2]=e[1],t[3]=e[3];return t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*a-i*n;return o?(o=1/o,t[0]=a*o,t[1]=-n*o,t[2]=-i*o,t[3]=r*o,t):null},i.adjoint=function(t,e){var r=e[0];return t[0]=e[3],t[1]=-e[1],t[2]=-e[2],t[3]=r,t},i.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1],u=r[2],c=r[3];return t[0]=n*s+a*l,t[1]=i*s+o*l,t[2]=n*u+a*c,t[3]=i*u+o*c,t},i.mul=i.multiply,i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+a*s,t[1]=i*l+o*s,t[2]=n*-s+a*l,t[3]=i*-s+o*l,t},i.scale=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1];return t[0]=n*s,t[1]=i*s,t[2]=a*l,t[3]=o*l,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=-r,t[3]=n,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t},i.str=function(t){return\"mat2(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2))},i.LDU=function(t,e,r,n){return t[2]=n[2]/n[0],r[0]=n[0],r[1]=n[1],r[3]=n[3]-t[2]*r[1],[t,e,r]},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t},i.sub=i.subtract,i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=e[0],l=e[1],u=e[2],c=e[3];return Math.abs(r-s)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(i-l)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-u)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(u))&&Math.abs(o-c)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t},e.exports=i},{\"./common.js\":193}],195:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(6);return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(6);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},i.fromValues=function(t,e,r,i,a,o){var s=new n.ARRAY_TYPE(6);return s[0]=t,s[1]=e,s[2]=r,s[3]=i,s[4]=a,s[5]=o,s},i.set=function(t,e,r,n,i,a,o){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=r*a-n*i;return l?(l=1/l,t[0]=a*l,t[1]=-n*l,t[2]=-i*l,t[3]=r*l,t[4]=(i*s-a*o)*l,t[5]=(n*o-r*s)*l,t):null},i.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1],h=r[2],f=r[3],d=r[4],p=r[5];return t[0]=n*u+a*c,t[1]=i*u+o*c,t[2]=n*h+a*f,t[3]=i*h+o*f,t[4]=n*d+a*p+s,t[5]=i*d+o*p+l,t},i.mul=i.multiply,i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=Math.sin(r),c=Math.cos(r);return t[0]=n*c+a*u,t[1]=i*c+o*u,t[2]=n*-u+a*c,t[3]=i*-u+o*c,t[4]=s,t[5]=l,t},i.scale=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1];return t[0]=n*u,t[1]=i*u,t[2]=a*c,t[3]=o*c,t[4]=s,t[5]=l,t},i.translate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1];return t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=n*u+a*c+s,t[5]=i*u+o*c+l,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=-r,t[3]=n,t[4]=0,t[5]=0,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t[4]=0,t[5]=0,t},i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=e[0],t[5]=e[1],t},i.str=function(t){return\"mat2d(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+1)},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=e[0],c=e[1],h=e[2],f=e[3],d=e[4],p=e[5];return Math.abs(r-u)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(u))&&Math.abs(i-c)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(c))&&Math.abs(a-h)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(h))&&Math.abs(o-f)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))&&Math.abs(s-d)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(d))&&Math.abs(l-p)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(p))},e.exports=i},{\"./common.js\":193}],196:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(9);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromMat4=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t},i.clone=function(t){var e=new n.ARRAY_TYPE(9);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},i.fromValues=function(t,e,r,i,a,o,s,l,u){var c=new n.ARRAY_TYPE(9);return c[0]=t,c[1]=e,c[2]=r,c[3]=i,c[4]=a,c[5]=o,c[6]=s,c[7]=l,c[8]=u,c},i.set=function(t,e,r,n,i,a,o,s,l,u){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t[6]=s,t[7]=l,t[8]=u,t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.transpose=function(t,e){if(t===e){var r=e[1],n=e[2],i=e[5];t[1]=e[3],t[2]=e[6],t[3]=r,t[5]=e[7],t[6]=n,t[7]=i}else t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8];return t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=c*o-s*u,f=-c*a+s*l,d=u*a-o*l,p=r*h+n*f+i*d;return p?(p=1/p,t[0]=h*p,t[1]=(-c*n+i*u)*p,t[2]=(s*n-i*o)*p,t[3]=f*p,t[4]=(c*r-i*l)*p,t[5]=(-s*r+i*a)*p,t[6]=d*p,t[7]=(-u*r+n*l)*p,t[8]=(o*r-n*a)*p,t):null},i.adjoint=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8];return t[0]=o*c-s*u,t[1]=i*u-n*c,t[2]=n*s-i*o,t[3]=s*l-a*c,t[4]=r*c-i*l,t[5]=i*a-r*s,t[6]=a*u-o*l,t[7]=n*l-r*u,t[8]=r*o-n*a,t},i.determinant=function(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8];return e*(u*a-o*l)+r*(-u*i+o*s)+n*(l*i-a*s)},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=r[0],d=r[1],p=r[2],m=r[3],v=r[4],g=r[5],y=r[6],b=r[7],x=r[8];return t[0]=f*n+d*o+p*u,t[1]=f*i+d*s+p*c,t[2]=f*a+d*l+p*h,t[3]=m*n+v*o+g*u,t[4]=m*i+v*s+g*c,t[5]=m*a+v*l+g*h,t[6]=y*n+b*o+x*u,t[7]=y*i+b*s+x*c,t[8]=y*a+b*l+x*h,t},i.mul=i.multiply,i.translate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=r[0],d=r[1];return t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=f*n+d*o+u,t[7]=f*i+d*s+c,t[8]=f*a+d*l+h,t},i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=Math.sin(r),d=Math.cos(r);return t[0]=d*n+f*o,t[1]=d*i+f*s,t[2]=d*a+f*l,t[3]=d*o-f*n,t[4]=d*s-f*i,t[5]=d*l-f*a,t[6]=u,t[7]=c,t[8]=h,t},i.scale=function(t,e,r){var n=r[0],i=r[1];return t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=i*e[3],t[4]=i*e[4],t[5]=i*e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=e[0],t[7]=e[1],t[8]=1,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=0,t[3]=-r,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=e[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromMat2d=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=0,t[3]=e[2],t[4]=e[3],t[5]=0,t[6]=e[4],t[7]=e[5],t[8]=1,t},i.fromQuat=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[3]=c-g,t[6]=f+v,t[1]=c+g,t[4]=1-u-p,t[7]=d-m,t[2]=f-v,t[5]=d+m,t[8]=1-u-h,t},i.normalFromMat4=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(l*T-o*L-u*A)*C,t[2]=(o*E-s*T+u*k)*C,t[3]=(i*E-n*L-a*S)*C,t[4]=(r*L-i*T+a*A)*C,t[5]=(n*T-r*E-a*k)*C,t[6]=(m*M-v*w+g*_)*C,t[7]=(v*x-p*M-g*b)*C,t[8]=(p*w-m*x+g*y)*C,t):null},i.str=function(t){return\"mat3(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\", \"+t[6]+\", \"+t[7]+\", \"+t[8]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2))},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t[6]=e[6]+r[6]*n,t[7]=e[7]+r[7]*n,t[8]=e[8]+r[8]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=t[6],c=t[7],h=t[8],f=e[0],d=e[1],p=e[2],m=e[3],v=e[4],g=e[5],y=t[6],b=e[7],x=e[8];return Math.abs(r-f)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(i-d)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(d))&&Math.abs(a-p)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(p))&&Math.abs(o-m)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(m))&&Math.abs(s-v)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(v))&&Math.abs(l-g)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(g))&&Math.abs(u-y)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(y))&&Math.abs(c-b)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(b))&&Math.abs(h-x)<=n.EPSILON*Math.max(1,Math.abs(h),Math.abs(x))},e.exports=i},{\"./common.js\":193}],197:[function(t,e,r){var n=t(\"./common.js\"),i={scalar:{},SIMD:{}};i.create=function(){var t=new n.ARRAY_TYPE(16);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.clone=function(t){var e=new n.ARRAY_TYPE(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.fromValues=function(t,e,r,i,a,o,s,l,u,c,h,f,d,p,m,v){var g=new n.ARRAY_TYPE(16);return g[0]=t,g[1]=e,g[2]=r,g[3]=i,g[4]=a,g[5]=o,g[6]=s,g[7]=l,g[8]=u,g[9]=c,g[10]=h,g[11]=f,g[12]=d,g[13]=p,g[14]=m,g[15]=v,g},i.set=function(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p,m,v){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t[6]=s,t[7]=l,t[8]=u,t[9]=c,t[10]=h,t[11]=f,t[12]=d,t[13]=p,t[14]=m,t[15]=v,t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.scalar.transpose=function(t,e){if(t===e){var r=e[1],n=e[2],i=e[3],a=e[6],o=e[7],s=e[11];t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=a,t[11]=e[14],t[12]=i,t[13]=o,t[14]=s}else t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15];return t},i.SIMD.transpose=function(t,e){var r,n,i,a,o,s,l,u,c,h;return r=SIMD.Float32x4.load(e,0),n=SIMD.Float32x4.load(e,4),i=SIMD.Float32x4.load(e,8),a=SIMD.Float32x4.load(e,12),o=SIMD.Float32x4.shuffle(r,n,0,1,4,5),s=SIMD.Float32x4.shuffle(i,a,0,1,4,5),l=SIMD.Float32x4.shuffle(o,s,0,2,4,6),u=SIMD.Float32x4.shuffle(o,s,1,3,5,7),SIMD.Float32x4.store(t,0,l),SIMD.Float32x4.store(t,4,u),o=SIMD.Float32x4.shuffle(r,n,2,3,6,7),s=SIMD.Float32x4.shuffle(i,a,2,3,6,7),c=SIMD.Float32x4.shuffle(o,s,0,2,4,6),h=SIMD.Float32x4.shuffle(o,s,1,3,5,7),SIMD.Float32x4.store(t,8,c),SIMD.Float32x4.store(t,12,h),t},i.transpose=n.USE_SIMD?i.SIMD.transpose:i.scalar.transpose,i.scalar.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(i*E-n*L-a*S)*C,t[2]=(m*M-v*w+g*_)*C,t[3]=(f*w-h*M-d*_)*C,t[4]=(l*T-o*L-u*A)*C,t[5]=(r*L-i*T+a*A)*C,t[6]=(v*x-p*M-g*b)*C,t[7]=(c*M-f*x+d*b)*C,t[8]=(o*E-s*T+u*k)*C,t[9]=(n*T-r*E-a*k)*C,t[10]=(p*w-m*x+g*y)*C,t[11]=(h*x-c*w-d*y)*C,t[12]=(s*A-o*S-l*k)*C,t[13]=(r*S-n*A+i*k)*C,t[14]=(m*b-p*_-v*y)*C,t[15]=(c*_-h*b+f*y)*C,t):null},i.SIMD.invert=function(t,e){var r,n,i,a,o,s,l,u,c,h,f=SIMD.Float32x4.load(e,0),d=SIMD.Float32x4.load(e,4),p=SIMD.Float32x4.load(e,8),m=SIMD.Float32x4.load(e,12);return o=SIMD.Float32x4.shuffle(f,d,0,1,4,5),n=SIMD.Float32x4.shuffle(p,m,0,1,4,5),r=SIMD.Float32x4.shuffle(o,n,0,2,4,6),n=SIMD.Float32x4.shuffle(n,o,1,3,5,7),o=SIMD.Float32x4.shuffle(f,d,2,3,6,7),a=SIMD.Float32x4.shuffle(p,m,2,3,6,7),i=SIMD.Float32x4.shuffle(o,a,0,2,4,6),a=SIMD.Float32x4.shuffle(a,o,1,3,5,7),o=SIMD.Float32x4.mul(i,a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),s=SIMD.Float32x4.mul(n,o),l=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,o),s),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),o=SIMD.Float32x4.mul(n,i),o=SIMD.Float32x4.swizzle(o,1,0,3,2),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),s),c=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(a,o)),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),o=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(n,2,3,0,1),a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),i=SIMD.Float32x4.swizzle(i,2,3,0,1),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),s),u=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(i,o)),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),u),u=SIMD.Float32x4.swizzle(u,2,3,0,1),o=SIMD.Float32x4.mul(r,n),o=SIMD.Float32x4.swizzle(o,1,0,3,2),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),u),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(i,o),c),o=SIMD.Float32x4.swizzle(o,2,3,0,1),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,o),u),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(i,o)),o=SIMD.Float32x4.mul(r,a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(i,o)),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(n,o),u),o=SIMD.Float32x4.swizzle(o,2,3,0,1),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),l),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(n,o)),o=SIMD.Float32x4.mul(r,i),o=SIMD.Float32x4.swizzle(o,1,0,3,2),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),l),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(n,o)),o=SIMD.Float32x4.swizzle(o,2,3,0,1),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(a,o)),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(n,o),c),h=SIMD.Float32x4.mul(r,s),h=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(h,2,3,0,1),h),h=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(h,1,0,3,2),h),o=SIMD.Float32x4.reciprocalApproximation(h),h=SIMD.Float32x4.sub(SIMD.Float32x4.add(o,o),SIMD.Float32x4.mul(h,SIMD.Float32x4.mul(o,o))),(h=SIMD.Float32x4.swizzle(h,0,0,0,0))?(SIMD.Float32x4.store(t,0,SIMD.Float32x4.mul(h,s)),SIMD.Float32x4.store(t,4,SIMD.Float32x4.mul(h,l)),SIMD.Float32x4.store(t,8,SIMD.Float32x4.mul(h,u)),SIMD.Float32x4.store(t,12,SIMD.Float32x4.mul(h,c)),t):null},i.invert=n.USE_SIMD?i.SIMD.invert:i.scalar.invert,i.scalar.adjoint=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15];return t[0]=s*(f*g-d*v)-h*(l*g-u*v)+m*(l*d-u*f),t[1]=-(n*(f*g-d*v)-h*(i*g-a*v)+m*(i*d-a*f)),t[2]=n*(l*g-u*v)-s*(i*g-a*v)+m*(i*u-a*l),t[3]=-(n*(l*d-u*f)-s*(i*d-a*f)+h*(i*u-a*l)),t[4]=-(o*(f*g-d*v)-c*(l*g-u*v)+p*(l*d-u*f)),t[5]=r*(f*g-d*v)-c*(i*g-a*v)+p*(i*d-a*f),t[6]=-(r*(l*g-u*v)-o*(i*g-a*v)+p*(i*u-a*l)),t[7]=r*(l*d-u*f)-o*(i*d-a*f)+c*(i*u-a*l),t[8]=o*(h*g-d*m)-c*(s*g-u*m)+p*(s*d-u*h),t[9]=-(r*(h*g-d*m)-c*(n*g-a*m)+p*(n*d-a*h)),t[10]=r*(s*g-u*m)-o*(n*g-a*m)+p*(n*u-a*s),t[11]=-(r*(s*d-u*h)-o*(n*d-a*h)+c*(n*u-a*s)),t[12]=-(o*(h*v-f*m)-c*(s*v-l*m)+p*(s*f-l*h)),t[13]=r*(h*v-f*m)-c*(n*v-i*m)+p*(n*f-i*h),t[14]=-(r*(s*v-l*m)-o*(n*v-i*m)+p*(n*l-i*s)),t[15]=r*(s*f-l*h)-o*(n*f-i*h)+c*(n*l-i*s),t},i.SIMD.adjoint=function(t,e){var r,n,i,a,o,s,l,u,c,h,f,d,p,r=SIMD.Float32x4.load(e,0),n=SIMD.Float32x4.load(e,4),i=SIMD.Float32x4.load(e,8),a=SIMD.Float32x4.load(e,12)\n",
       ";return c=SIMD.Float32x4.shuffle(r,n,0,1,4,5),s=SIMD.Float32x4.shuffle(i,a,0,1,4,5),o=SIMD.Float32x4.shuffle(c,s,0,2,4,6),s=SIMD.Float32x4.shuffle(s,c,1,3,5,7),c=SIMD.Float32x4.shuffle(r,n,2,3,6,7),u=SIMD.Float32x4.shuffle(i,a,2,3,6,7),l=SIMD.Float32x4.shuffle(c,u,0,2,4,6),u=SIMD.Float32x4.shuffle(u,c,1,3,5,7),c=SIMD.Float32x4.mul(l,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),h=SIMD.Float32x4.mul(s,c),f=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(s,c),h),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),f),f=SIMD.Float32x4.swizzle(f,2,3,0,1),c=SIMD.Float32x4.mul(s,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),h),p=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(u,c)),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),p),p=SIMD.Float32x4.swizzle(p,2,3,0,1),c=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,3,0,1),u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),l=SIMD.Float32x4.swizzle(l,2,3,0,1),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),h),d=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(l,c)),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),d),d=SIMD.Float32x4.swizzle(d,2,3,0,1),c=SIMD.Float32x4.mul(o,s),c=SIMD.Float32x4.swizzle(c,1,0,3,2),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),d),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(l,c),p),c=SIMD.Float32x4.swizzle(c,2,3,0,1),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(u,c),d),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(l,c)),c=SIMD.Float32x4.mul(o,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(l,c)),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),d),c=SIMD.Float32x4.swizzle(c,2,3,0,1),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),f),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.mul(o,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),f),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.swizzle(c,2,3,0,1),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(u,c)),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),p),SIMD.Float32x4.store(t,0,h),SIMD.Float32x4.store(t,4,f),SIMD.Float32x4.store(t,8,d),SIMD.Float32x4.store(t,12,p),t},i.adjoint=n.USE_SIMD?i.SIMD.adjoint:i.scalar.adjoint,i.determinant=function(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8],c=t[9],h=t[10],f=t[11],d=t[12],p=t[13],m=t[14],v=t[15];return(e*o-r*a)*(h*v-f*m)-(e*s-n*a)*(c*v-f*p)+(e*l-i*a)*(c*m-h*p)+(r*s-n*o)*(u*v-f*d)-(r*l-i*o)*(u*m-h*d)+(n*l-i*s)*(u*p-c*d)},i.SIMD.multiply=function(t,e,r){var n=SIMD.Float32x4.load(e,0),i=SIMD.Float32x4.load(e,4),a=SIMD.Float32x4.load(e,8),o=SIMD.Float32x4.load(e,12),s=SIMD.Float32x4.load(r,0),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,3,3,3,3),o))));SIMD.Float32x4.store(t,0,l);var u=SIMD.Float32x4.load(r,4),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,3,3,3,3),o))));SIMD.Float32x4.store(t,4,c);var h=SIMD.Float32x4.load(r,8),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,3,3,3,3),o))));SIMD.Float32x4.store(t,8,f);var d=SIMD.Float32x4.load(r,12),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,3,3,3,3),o))));return SIMD.Float32x4.store(t,12,p),t},i.scalar.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],m=e[12],v=e[13],g=e[14],y=e[15],b=r[0],x=r[1],_=r[2],w=r[3];return t[0]=b*n+x*s+_*h+w*m,t[1]=b*i+x*l+_*f+w*v,t[2]=b*a+x*u+_*d+w*g,t[3]=b*o+x*c+_*p+w*y,b=r[4],x=r[5],_=r[6],w=r[7],t[4]=b*n+x*s+_*h+w*m,t[5]=b*i+x*l+_*f+w*v,t[6]=b*a+x*u+_*d+w*g,t[7]=b*o+x*c+_*p+w*y,b=r[8],x=r[9],_=r[10],w=r[11],t[8]=b*n+x*s+_*h+w*m,t[9]=b*i+x*l+_*f+w*v,t[10]=b*a+x*u+_*d+w*g,t[11]=b*o+x*c+_*p+w*y,b=r[12],x=r[13],_=r[14],w=r[15],t[12]=b*n+x*s+_*h+w*m,t[13]=b*i+x*l+_*f+w*v,t[14]=b*a+x*u+_*d+w*g,t[15]=b*o+x*c+_*p+w*y,t},i.multiply=n.USE_SIMD?i.SIMD.multiply:i.scalar.multiply,i.mul=i.multiply,i.scalar.translate=function(t,e,r){var n,i,a,o,s,l,u,c,h,f,d,p,m=r[0],v=r[1],g=r[2];return e===t?(t[12]=e[0]*m+e[4]*v+e[8]*g+e[12],t[13]=e[1]*m+e[5]*v+e[9]*g+e[13],t[14]=e[2]*m+e[6]*v+e[10]*g+e[14],t[15]=e[3]*m+e[7]*v+e[11]*g+e[15]):(n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=u,t[7]=c,t[8]=h,t[9]=f,t[10]=d,t[11]=p,t[12]=n*m+s*v+h*g+e[12],t[13]=i*m+l*v+f*g+e[13],t[14]=a*m+u*v+d*g+e[14],t[15]=o*m+c*v+p*g+e[15]),t},i.SIMD.translate=function(t,e,r){var n=SIMD.Float32x4.load(e,0),i=SIMD.Float32x4.load(e,4),a=SIMD.Float32x4.load(e,8),o=SIMD.Float32x4.load(e,12),s=SIMD.Float32x4(r[0],r[1],r[2],0);e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11]),n=SIMD.Float32x4.mul(n,SIMD.Float32x4.swizzle(s,0,0,0,0)),i=SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(s,1,1,1,1)),a=SIMD.Float32x4.mul(a,SIMD.Float32x4.swizzle(s,2,2,2,2));var l=SIMD.Float32x4.add(n,SIMD.Float32x4.add(i,SIMD.Float32x4.add(a,o)));return SIMD.Float32x4.store(t,12,l),t},i.translate=n.USE_SIMD?i.SIMD.translate:i.scalar.translate,i.scalar.scale=function(t,e,r){var n=r[0],i=r[1],a=r[2];return t[0]=e[0]*n,t[1]=e[1]*n,t[2]=e[2]*n,t[3]=e[3]*n,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*a,t[9]=e[9]*a,t[10]=e[10]*a,t[11]=e[11]*a,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.SIMD.scale=function(t,e,r){var n,i,a,o=SIMD.Float32x4(r[0],r[1],r[2],0);return n=SIMD.Float32x4.load(e,0),SIMD.Float32x4.store(t,0,SIMD.Float32x4.mul(n,SIMD.Float32x4.swizzle(o,0,0,0,0))),i=SIMD.Float32x4.load(e,4),SIMD.Float32x4.store(t,4,SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(o,1,1,1,1))),a=SIMD.Float32x4.load(e,8),SIMD.Float32x4.store(t,8,SIMD.Float32x4.mul(a,SIMD.Float32x4.swizzle(o,2,2,2,2))),t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.scale=n.USE_SIMD?i.SIMD.scale:i.scalar.scale,i.rotate=function(t,e,r,i){var a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T,S,E,L=i[0],C=i[1],z=i[2],I=Math.sqrt(L*L+C*C+z*z);return Math.abs(I)<n.EPSILON?null:(I=1/I,L*=I,C*=I,z*=I,a=Math.sin(r),o=Math.cos(r),s=1-o,l=e[0],u=e[1],c=e[2],h=e[3],f=e[4],d=e[5],p=e[6],m=e[7],v=e[8],g=e[9],y=e[10],b=e[11],x=L*L*s+o,_=C*L*s+z*a,w=z*L*s-C*a,M=L*C*s-z*a,k=C*C*s+o,A=z*C*s+L*a,T=L*z*s+C*a,S=C*z*s-L*a,E=z*z*s+o,t[0]=l*x+f*_+v*w,t[1]=u*x+d*_+g*w,t[2]=c*x+p*_+y*w,t[3]=h*x+m*_+b*w,t[4]=l*M+f*k+v*A,t[5]=u*M+d*k+g*A,t[6]=c*M+p*k+y*A,t[7]=h*M+m*k+b*A,t[8]=l*T+f*S+v*E,t[9]=u*T+d*S+g*E,t[10]=c*T+p*S+y*E,t[11]=h*T+m*S+b*E,e!==t&&(t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t)},i.scalar.rotateX=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[4],o=e[5],s=e[6],l=e[7],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=a*i+u*n,t[5]=o*i+c*n,t[6]=s*i+h*n,t[7]=l*i+f*n,t[8]=u*i-a*n,t[9]=c*i-o*n,t[10]=h*i-s*n,t[11]=f*i-l*n,t},i.SIMD.rotateX=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,4),o=SIMD.Float32x4.load(e,8);return SIMD.Float32x4.store(t,4,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,8,SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,n))),t},i.rotateX=n.USE_SIMD?i.SIMD.rotateX:i.scalar.rotateX,i.scalar.rotateY=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i-u*n,t[1]=o*i-c*n,t[2]=s*i-h*n,t[3]=l*i-f*n,t[8]=a*n+u*i,t[9]=o*n+c*i,t[10]=s*n+h*i,t[11]=l*n+f*i,t},i.SIMD.rotateY=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,0),o=SIMD.Float32x4.load(e,8);return SIMD.Float32x4.store(t,0,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,8,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,n),SIMD.Float32x4.mul(o,i))),t},i.rotateY=n.USE_SIMD?i.SIMD.rotateY:i.scalar.rotateY,i.scalar.rotateZ=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[4],c=e[5],h=e[6],f=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i+u*n,t[1]=o*i+c*n,t[2]=s*i+h*n,t[3]=l*i+f*n,t[4]=u*i-a*n,t[5]=c*i-o*n,t[6]=h*i-s*n,t[7]=f*i-l*n,t},i.SIMD.rotateZ=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,0),o=SIMD.Float32x4.load(e,4);return SIMD.Float32x4.store(t,0,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,4,SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,n))),t},i.rotateZ=n.USE_SIMD?i.SIMD.rotateZ:i.scalar.rotateZ,i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=e[0],t[13]=e[1],t[14]=e[2],t[15]=1,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromRotation=function(t,e,r){var i,a,o,s=r[0],l=r[1],u=r[2],c=Math.sqrt(s*s+l*l+u*u);return Math.abs(c)<n.EPSILON?null:(c=1/c,s*=c,l*=c,u*=c,i=Math.sin(e),a=Math.cos(e),o=1-a,t[0]=s*s*o+a,t[1]=l*s*o+u*i,t[2]=u*s*o-l*i,t[3]=0,t[4]=s*l*o-u*i,t[5]=l*l*o+a,t[6]=u*l*o+s*i,t[7]=0,t[8]=s*u*o+l*i,t[9]=l*u*o-s*i,t[10]=u*u*o+a,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t)},i.fromXRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=n,t[6]=r,t[7]=0,t[8]=0,t[9]=-r,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromYRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=0,t[2]=-r,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=r,t[9]=0,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromZRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=0,t[3]=0,t[4]=-r,t[5]=n,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromRotationTranslation=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=n+n,l=i+i,u=a+a,c=n*s,h=n*l,f=n*u,d=i*l,p=i*u,m=a*u,v=o*s,g=o*l,y=o*u;return t[0]=1-(d+m),t[1]=h+y,t[2]=f-g,t[3]=0,t[4]=h-y,t[5]=1-(c+m),t[6]=p+v,t[7]=0,t[8]=f+g,t[9]=p-v,t[10]=1-(c+d),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},i.getTranslation=function(t,e){return t[0]=e[12],t[1]=e[13],t[2]=e[14],t},i.getRotation=function(t,e){var r=e[0]+e[5]+e[10],n=0;return r>0?(n=2*Math.sqrt(r+1),t[3]=.25*n,t[0]=(e[6]-e[9])/n,t[1]=(e[8]-e[2])/n,t[2]=(e[1]-e[4])/n):e[0]>e[5]&e[0]>e[10]?(n=2*Math.sqrt(1+e[0]-e[5]-e[10]),t[3]=(e[6]-e[9])/n,t[0]=.25*n,t[1]=(e[1]+e[4])/n,t[2]=(e[8]+e[2])/n):e[5]>e[10]?(n=2*Math.sqrt(1+e[5]-e[0]-e[10]),t[3]=(e[8]-e[2])/n,t[0]=(e[1]+e[4])/n,t[1]=.25*n,t[2]=(e[6]+e[9])/n):(n=2*Math.sqrt(1+e[10]-e[0]-e[5]),t[3]=(e[1]-e[4])/n,t[0]=(e[8]+e[2])/n,t[1]=(e[6]+e[9])/n,t[2]=.25*n),t},i.fromRotationTranslationScale=function(t,e,r,n){var i=e[0],a=e[1],o=e[2],s=e[3],l=i+i,u=a+a,c=o+o,h=i*l,f=i*u,d=i*c,p=a*u,m=a*c,v=o*c,g=s*l,y=s*u,b=s*c,x=n[0],_=n[1],w=n[2];return t[0]=(1-(p+v))*x,t[1]=(f+b)*x,t[2]=(d-y)*x,t[3]=0,t[4]=(f-b)*_,t[5]=(1-(h+v))*_,t[6]=(m+g)*_,t[7]=0,t[8]=(d+y)*w,t[9]=(m-g)*w,t[10]=(1-(h+p))*w,t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},i.fromRotationTranslationScaleOrigin=function(t,e,r,n,i){var a=e[0],o=e[1],s=e[2],l=e[3],u=a+a,c=o+o,h=s+s,f=a*u,d=a*c,p=a*h,m=o*c,v=o*h,g=s*h,y=l*u,b=l*c,x=l*h,_=n[0],w=n[1],M=n[2],k=i[0],A=i[1],T=i[2];return t[0]=(1-(m+g))*_,t[1]=(d+x)*_,t[2]=(p-b)*_,t[3]=0,t[4]=(d-x)*w,t[5]=(1-(f+g))*w,t[6]=(v+y)*w,t[7]=0,t[8]=(p+b)*M,t[9]=(v-y)*M,t[10]=(1-(f+m))*M,t[11]=0,t[12]=r[0]+k-(t[0]*k+t[4]*A+t[8]*T),t[13]=r[1]+A-(t[1]*k+t[5]*A+t[9]*T),t[14]=r[2]+T-(t[2]*k+t[6]*A+t[10]*T),t[15]=1,t},i.fromQuat=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[1]=c+g,t[2]=f-v,t[3]=0,t[4]=c-g,t[5]=1-u-p,t[6]=d+m,t[7]=0,t[8]=f+v,t[9]=d-m,t[10]=1-u-h,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.frustum=function(t,e,r,n,i,a,o){var s=1/(r-e),l=1/(i-n),u=1/(a-o);return t[0]=2*a*s,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*a*l,t[6]=0,t[7]=0,t[8]=(r+e)*s,t[9]=(i+n)*l,t[10]=(o+a)*u,t[11]=-1,t[12]=0,t[13]=0,t[14]=o*a*2*u,t[15]=0,t},i.perspective=function(t,e,r,n,i){var a=1/Math.tan(e/2),o=1/(n-i);return t[0]=a/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=(i+n)*o,t[11]=-1,t[12]=0,t[13]=0,t[14]=2*i*n*o,t[15]=0,t},i.perspectiveFromFieldOfView=function(t,e,r,n){var i=Math.tan(e.upDegrees*Math.PI/180),a=Math.tan(e.downDegrees*Math.PI/180),o=Math.tan(e.leftDegrees*Math.PI/180),s=Math.tan(e.rightDegrees*Math.PI/180),l=2/(o+s),u=2/(i+a);return t[0]=l,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=-(o-s)*l*.5,t[9]=(i-a)*u*.5,t[10]=n/(r-n),t[11]=-1,t[12]=0,t[13]=0,t[14]=n*r/(r-n),t[15]=0,t},i.ortho=function(t,e,r,n,i,a,o){var s=1/(e-r),l=1/(n-i),u=1/(a-o);return t[0]=-2*s,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*u,t[11]=0,t[12]=(e+r)*s,t[13]=(i+n)*l,t[14]=(o+a)*u,t[15]=1,t},i.lookAt=function(t,e,r,a){var o,s,l,u,c,h,f,d,p,m,v=e[0],g=e[1],y=e[2],b=a[0],x=a[1],_=a[2],w=r[0],M=r[1],k=r[2];return Math.abs(v-w)<n.EPSILON&&Math.abs(g-M)<n.EPSILON&&Math.abs(y-k)<n.EPSILON?i.identity(t):(f=v-w,d=g-M,p=y-k,m=1/Math.sqrt(f*f+d*d+p*p),f*=m,d*=m,p*=m,o=x*p-_*d,s=_*f-b*p,l=b*d-x*f,m=Math.sqrt(o*o+s*s+l*l),m?(m=1/m,o*=m,s*=m,l*=m):(o=0,s=0,l=0),u=d*l-p*s,c=p*o-f*l,h=f*s-d*o,m=Math.sqrt(u*u+c*c+h*h),m?(m=1/m,u*=m,c*=m,h*=m):(u=0,c=0,h=0),t[0]=o,t[1]=u,t[2]=f,t[3]=0,t[4]=s,t[5]=c,t[6]=d,t[7]=0,t[8]=l,t[9]=h,t[10]=p,t[11]=0,t[12]=-(o*v+s*g+l*y),t[13]=-(u*v+c*g+h*y),t[14]=-(f*v+d*g+p*y),t[15]=1,t)},i.str=function(t){return\"mat4(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\", \"+t[6]+\", \"+t[7]+\", \"+t[8]+\", \"+t[9]+\", \"+t[10]+\", \"+t[11]+\", \"+t[12]+\", \"+t[13]+\", \"+t[14]+\", \"+t[15]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2)+Math.pow(t[9],2)+Math.pow(t[10],2)+Math.pow(t[11],2)+Math.pow(t[12],2)+Math.pow(t[13],2)+Math.pow(t[14],2)+Math.pow(t[15],2))},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t[9]=e[9]+r[9],t[10]=e[10]+r[10],t[11]=e[11]+r[11],t[12]=e[12]+r[12],t[13]=e[13]+r[13],t[14]=e[14]+r[14],t[15]=e[15]+r[15],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t[9]=e[9]-r[9],t[10]=e[10]-r[10],t[11]=e[11]-r[11],t[12]=e[12]-r[12],t[13]=e[13]-r[13],t[14]=e[14]-r[14],t[15]=e[15]-r[15],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t[9]=e[9]*r,t[10]=e[10]*r,t[11]=e[11]*r,t[12]=e[12]*r,t[13]=e[13]*r,t[14]=e[14]*r,t[15]=e[15]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t[6]=e[6]+r[6]*n,t[7]=e[7]+r[7]*n,t[8]=e[8]+r[8]*n,t[9]=e[9]+r[9]*n,t[10]=e[10]+r[10]*n,t[11]=e[11]+r[11]*n,t[12]=e[12]+r[12]*n,t[13]=e[13]+r[13]*n,t[14]=e[14]+r[14]*n,t[15]=e[15]+r[15]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]&&t[9]===e[9]&&t[10]===e[10]&&t[11]===e[11]&&t[12]===e[12]&&t[13]===e[13]&&t[14]===e[14]&&t[15]===e[15]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=t[6],c=t[7],h=t[8],f=t[9],d=t[10],p=t[11],m=t[12],v=t[13],g=t[14],y=t[15],b=e[0],x=e[1],_=e[2],w=e[3],M=e[4],k=e[5],A=e[6],T=e[7],S=e[8],E=e[9],L=e[10],C=e[11],z=e[12],I=e[13],D=e[14],P=e[15];return Math.abs(r-b)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(b))&&Math.abs(i-x)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(x))&&Math.abs(a-_)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(_))&&Math.abs(o-w)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(w))&&Math.abs(s-M)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(M))&&Math.abs(l-k)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(k))&&Math.abs(u-A)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(A))&&Math.abs(c-T)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(T))&&Math.abs(h-S)<=n.EPSILON*Math.max(1,Math.abs(h),Math.abs(S))&&Math.abs(f-E)<=n.EPSILON*Math.max(1,Math.abs(f),Math.abs(E))&&Math.abs(d-L)<=n.EPSILON*Math.max(1,Math.abs(d),Math.abs(L))&&Math.abs(p-C)<=n.EPSILON*Math.max(1,Math.abs(p),Math.abs(C))&&Math.abs(m-z)<=n.EPSILON*Math.max(1,Math.abs(m),Math.abs(z))&&Math.abs(v-I)<=n.EPSILON*Math.max(1,Math.abs(v),Math.abs(I))&&Math.abs(g-D)<=n.EPSILON*Math.max(1,Math.abs(g),Math.abs(D))&&Math.abs(y-P)<=n.EPSILON*Math.max(1,Math.abs(y),Math.abs(P))},e.exports=i},{\"./common.js\":193}],198:[function(t,e,r){var n=t(\"./common.js\"),i=t(\"./mat3.js\"),a=t(\"./vec3.js\"),o=t(\"./vec4.js\"),s={};s.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},s.rotationTo=function(){var t=a.create(),e=a.fromValues(1,0,0),r=a.fromValues(0,1,0);return function(n,i,o){var l=a.dot(i,o);return l<-.999999?(a.cross(t,e,i),a.length(t)<1e-6&&a.cross(t,r,i),a.normalize(t,t),s.setAxisAngle(n,t,Math.PI),n):l>.999999?(n[0]=0,n[1]=0,n[2]=0,n[3]=1,n):(a.cross(t,i,o),n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=1+l,s.normalize(n,n))}}(),s.setAxes=function(){var t=i.create();return function(e,r,n,i){return t[0]=n[0],t[3]=n[1],t[6]=n[2],t[1]=i[0],t[4]=i[1],t[7]=i[2],t[2]=-r[0],t[5]=-r[1],t[8]=-r[2],s.normalize(e,s.fromMat3(e,t))}}(),s.clone=o.clone,s.fromValues=o.fromValues,s.copy=o.copy,s.set=o.set,s.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},s.setAxisAngle=function(t,e,r){r*=.5;var n=Math.sin(r);return t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=Math.cos(r),t},s.getAxisAngle=function(t,e){var r=2*Math.acos(e[3]),n=Math.sin(r/2);return 0!=n?(t[0]=e[0]/n,t[1]=e[1]/n,t[2]=e[2]/n):(t[0]=1,t[1]=0,t[2]=0),r},s.add=o.add,s.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1],u=r[2],c=r[3];return t[0]=n*c+o*s+i*u-a*l,t[1]=i*c+o*l+a*s-n*u,t[2]=a*c+o*u+n*l-i*s,t[3]=o*c-n*s-i*l-a*u,t},s.mul=s.multiply,s.scale=o.scale,s.rotateX=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+o*s,t[1]=i*l+a*s,t[2]=a*l-i*s,t[3]=o*l-n*s,t},s.rotateY=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l-a*s,t[1]=i*l+o*s,t[2]=a*l+n*s,t[3]=o*l-i*s,t},s.rotateZ=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+i*s,t[1]=i*l-n*s,t[2]=a*l+o*s,t[3]=o*l-a*s,t},s.calculateW=function(t,e){var r=e[0],n=e[1],i=e[2];return t[0]=r,t[1]=n,t[2]=i,t[3]=Math.sqrt(Math.abs(1-r*r-n*n-i*i)),t},s.dot=o.dot,s.lerp=o.lerp,s.slerp=function(t,e,r,n){var i,a,o,s,l,u=e[0],c=e[1],h=e[2],f=e[3],d=r[0],p=r[1],m=r[2],v=r[3];return a=u*d+c*p+h*m+f*v,a<0&&(a=-a,d=-d,p=-p,m=-m,v=-v),1-a>1e-6?(i=Math.acos(a),o=Math.sin(i),s=Math.sin((1-n)*i)/o,l=Math.sin(n*i)/o):(s=1-n,l=n),t[0]=s*u+l*d,t[1]=s*c+l*p,t[2]=s*h+l*m,t[3]=s*f+l*v,t},s.sqlerp=function(){var t=s.create(),e=s.create();return function(r,n,i,a,o,l){return s.slerp(t,n,o,l),s.slerp(e,i,a,l),s.slerp(r,t,e,2*l*(1-l)),r}}(),s.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*r+n*n+i*i+a*a,s=o?1/o:0;return t[0]=-r*s,t[1]=-n*s,t[2]=-i*s,t[3]=a*s,t},s.conjugate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t},s.length=o.length,s.len=s.length,s.squaredLength=o.squaredLength,s.sqrLen=s.squaredLength,s.normalize=o.normalize,s.fromMat3=function(t,e){var r,n=e[0]+e[4]+e[8];if(n>0)r=Math.sqrt(n+1),t[3]=.5*r,r=.5/r,t[0]=(e[5]-e[7])*r,t[1]=(e[6]-e[2])*r,t[2]=(e[1]-e[3])*r;else{var i=0;e[4]>e[0]&&(i=1),e[8]>e[3*i+i]&&(i=2);var a=(i+1)%3,o=(i+2)%3;r=Math.sqrt(e[3*i+i]-e[3*a+a]-e[3*o+o]+1),t[i]=.5*r,r=.5/r,t[3]=(e[3*a+o]-e[3*o+a])*r,t[a]=(e[3*a+i]+e[3*i+a])*r,t[o]=(e[3*o+i]+e[3*i+o])*r}return t},s.str=function(t){return\"quat(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},s.exactEquals=o.exactEquals,s.equals=o.equals,e.exports=s},{\"./common.js\":193,\"./mat3.js\":196,\"./vec3.js\":200,\"./vec4.js\":201}],199:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(2);return t[0]=0,t[1]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(2);return e[0]=t[0],e[1]=t[1],e},i.fromValues=function(t,e){var r=new n.ARRAY_TYPE(2);return r[0]=t,r[1]=e,r},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t},i.set=function(t,e,r){return t[0]=e,t[1]=r,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1];return Math.sqrt(r*r+n*n)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1];return r*r+n*n},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1];return Math.sqrt(e*e+r*r)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1];return e*e+r*r},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=r*r+n*n;return i>0&&(i=1/Math.sqrt(i),t[0]=e[0]*i,t[1]=e[1]*i),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]},i.cross=function(t,e,r){var n=e[0]*r[1]-e[1]*r[0];return t[0]=t[1]=0,t[2]=n,t},i.lerp=function(t,e,r,n){var i=e[0],a=e[1];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t},i.random=function(t,e){e=e||1;var r=2*n.RANDOM()*Math.PI;return t[0]=Math.cos(r)*e,t[1]=Math.sin(r)*e,t},i.transformMat2=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[2]*i,t[1]=r[1]*n+r[3]*i,t},i.transformMat2d=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[2]*i+r[4],t[1]=r[1]*n+r[3]*i+r[5],t},i.transformMat3=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[3]*i+r[6],t[1]=r[1]*n+r[4]*i+r[7],t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[4]*i+r[12],t[1]=r[1]*n+r[5]*i+r[13],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=2),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],a(t,t,o),e[s]=t[0],e[s+1]=t[1];return e}}(),i.str=function(t){return\"vec2(\"+t[0]+\", \"+t[1]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]},i.equals=function(t,e){var r=t[0],i=t[1],a=e[0],o=e[1];return Math.abs(r-a)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(a))&&Math.abs(i-o)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(o))},e.exports=i},{\"./common.js\":193}],200:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(3);return t[0]=0,t[1]=0,t[2]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(3);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},i.fromValues=function(t,e,r){var i=new n.ARRAY_TYPE(3);return i[0]=t,i[1]=e,i[2]=r,i},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},i.set=function(t,e,r,n){return t[0]=e,t[1]=r,t[2]=n,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t[2]=e[2]*r[2],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t[2]=e[2]/r[2],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t[2]=Math.min(e[2],r[2]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t[2]=Math.max(e[2],r[2]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2];return Math.sqrt(r*r+n*n+i*i)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2];return r*r+n*n+i*i},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1],n=t[2];return Math.sqrt(e*e+r*r+n*n)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1],n=t[2];return e*e+r*r+n*n},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=e[2],a=r*r+n*n+i*i;return a>0&&(a=1/Math.sqrt(a),t[0]=e[0]*a,t[1]=e[1]*a,t[2]=e[2]*a),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]},i.cross=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2];return t[0]=i*l-a*s,t[1]=a*o-n*l,t[2]=n*s-i*o,t},i.lerp=function(t,e,r,n){var i=e[0],a=e[1],o=e[2];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t},i.hermite=function(t,e,r,n,i,a){var o=a*a,s=o*(2*a-3)+1,l=o*(a-2)+a,u=o*(a-1),c=o*(3-2*a);return t[0]=e[0]*s+r[0]*l+n[0]*u+i[0]*c,t[1]=e[1]*s+r[1]*l+n[1]*u+i[1]*c,t[2]=e[2]*s+r[2]*l+n[2]*u+i[2]*c,t},i.bezier=function(t,e,r,n,i,a){var o=1-a,s=o*o,l=a*a,u=s*o,c=3*a*s,h=3*l*o,f=l*a;return t[0]=e[0]*u+r[0]*c+n[0]*h+i[0]*f,t[1]=e[1]*u+r[1]*c+n[1]*h+i[1]*f,t[2]=e[2]*u+r[2]*c+n[2]*h+i[2]*f,t},i.random=function(t,e){e=e||1;var r=2*n.RANDOM()*Math.PI,i=2*n.RANDOM()-1,a=Math.sqrt(1-i*i)*e;return t[0]=Math.cos(r)*a,t[1]=Math.sin(r)*a,t[2]=i*e,t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[3]*n+r[7]*i+r[11]*a+r[15];return o=o||1,t[0]=(r[0]*n+r[4]*i+r[8]*a+r[12])/o,t[1]=(r[1]*n+r[5]*i+r[9]*a+r[13])/o,t[2]=(r[2]*n+r[6]*i+r[10]*a+r[14])/o,t},i.transformMat3=function(t,e,r){var n=e[0],i=e[1],a=e[2];return t[0]=n*r[0]+i*r[3]+a*r[6],t[1]=n*r[1]+i*r[4]+a*r[7],t[2]=n*r[2]+i*r[5]+a*r[8],t},i.transformQuat=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2],u=r[3],c=u*n+s*a-l*i,h=u*i+l*n-o*a,f=u*a+o*i-s*n,d=-o*n-s*i-l*a;return t[0]=c*u+d*-o+h*-l-f*-s,t[1]=h*u+d*-s+f*-o-c*-l,t[2]=f*u+d*-l+c*-s-h*-o,t},i.rotateX=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[0],a[1]=i[1]*Math.cos(n)-i[2]*Math.sin(n),a[2]=i[1]*Math.sin(n)+i[2]*Math.cos(n),t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.rotateY=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[2]*Math.sin(n)+i[0]*Math.cos(n),a[1]=i[1],a[2]=i[2]*Math.cos(n)-i[0]*Math.sin(n),t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.rotateZ=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[0]*Math.cos(n)-i[1]*Math.sin(n),a[1]=i[0]*Math.sin(n)+i[1]*Math.cos(n),a[2]=i[2],t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=3),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],t[2]=e[s+2],a(t,t,o),e[s]=t[0],e[s+1]=t[1],e[s+2]=t[2];return e}}(),i.angle=function(t,e){var r=i.fromValues(t[0],t[1],t[2]),n=i.fromValues(e[0],e[1],e[2]);i.normalize(r,r),i.normalize(n,n);var a=i.dot(r,n);return a>1?0:Math.acos(a)},i.str=function(t){return\"vec3(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=e[0],s=e[1],l=e[2];return Math.abs(r-o)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(i-s)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(s))&&Math.abs(a-l)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(l))},e.exports=i},{\"./common.js\":193}],201:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.fromValues=function(t,e,r,i){var a=new n.ARRAY_TYPE(4);return a[0]=t,a[1]=e,a[2]=r,a[3]=i,a},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.set=function(t,e,r,n,i){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t[2]=e[2]*r[2],t[3]=e[3]*r[3],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t[2]=e[2]/r[2],t[3]=e[3]/r[3],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t[3]=Math.ceil(e[3]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t[3]=Math.floor(e[3]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t[2]=Math.min(e[2],r[2]),t[3]=Math.min(e[3],r[3]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t[2]=Math.max(e[2],r[2]),t[3]=Math.max(e[3],r[3]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t[3]=Math.round(e[3]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2],a=e[3]-t[3];return Math.sqrt(r*r+n*n+i*i+a*a)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2],a=e[3]-t[3];return r*r+n*n+i*i+a*a},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1],n=t[2],i=t[3];return Math.sqrt(e*e+r*r+n*n+i*i)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1],n=t[2],i=t[3];return e*e+r*r+n*n+i*i},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],\n",
       "t[3]=1/e[3],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*r+n*n+i*i+a*a;return o>0&&(o=1/Math.sqrt(o),t[0]=r*o,t[1]=n*o,t[2]=i*o,t[3]=a*o),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]},i.lerp=function(t,e,r,n){var i=e[0],a=e[1],o=e[2],s=e[3];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t[3]=s+n*(r[3]-s),t},i.random=function(t,e){return e=e||1,t[0]=n.RANDOM(),t[1]=n.RANDOM(),t[2]=n.RANDOM(),t[3]=n.RANDOM(),i.normalize(t,t),i.scale(t,t,e),t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t},i.transformQuat=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2],u=r[3],c=u*n+s*a-l*i,h=u*i+l*n-o*a,f=u*a+o*i-s*n,d=-o*n-s*i-l*a;return t[0]=c*u+d*-o+h*-l-f*-s,t[1]=h*u+d*-s+f*-o-c*-l,t[2]=f*u+d*-l+c*-s-h*-o,t[3]=e[3],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=4),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],t[2]=e[s+2],t[3]=e[s+3],a(t,t,o),e[s]=t[0],e[s+1]=t[1],e[s+2]=t[2],e[s+3]=t[3];return e}}(),i.str=function(t){return\"vec4(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=e[0],l=e[1],u=e[2],c=e[3];return Math.abs(r-s)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(i-l)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-u)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(u))&&Math.abs(o-c)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},e.exports=i},{\"./common.js\":193}],202:[function(t,e,r){\"use strict\";function n(t,e){for(var r=[0,0,0,0],n=0;n<4;++n)for(var i=0;i<4;++i)r[i]+=t[4*n+i]*e[n];return r}function i(t,e,r,i,a){for(var o=n(i,n(r,n(e,[t[0],t[1],t[2],1]))),s=0;s<3;++s)o[s]/=o[3];return[.5*a[0]*(1+o[0]),.5*a[1]*(1-o[1])]}function a(t,e){if(2===t.length){for(var r=0,n=0,i=0;i<2;++i)r+=Math.pow(e[i]-t[0][i],2),n+=Math.pow(e[i]-t[1][i],2);return r=Math.sqrt(r),n=Math.sqrt(n),r+n<1e-6?[1,0]:[n/(r+n),r/(n+r)]}if(3===t.length){var a=[0,0];return u(t[0],t[1],t[2],e,a),l(t,a)}return[]}function o(t,e){for(var r=[0,0,0],n=0;n<t.length;++n)for(var i=t[n],a=e[n],o=0;o<3;++o)r[o]+=a*i[o];return r}function s(t,e,r,n,s,l){if(1===t.length)return[0,t[0].slice()];for(var u=new Array(t.length),c=0;c<t.length;++c)u[c]=i(t[c],r,n,s,l);for(var h=0,f=1/0,c=0;c<u.length;++c){for(var d=0,p=0;p<2;++p)d+=Math.pow(u[c][p]-e[p],2);d<f&&(f=d,h=c)}for(var m=a(u,e),v=0,c=0;c<3;++c){if(m[c]<-.001||m[c]>1.0001)return null;v+=m[c]}return Math.abs(v-1)>.001?null:[h,o(t,m),m]}var l=t(\"barycentric\"),u=t(\"polytope-closest-point/lib/closest_point_2d.js\");e.exports=s},{barycentric:48,\"polytope-closest-point/lib/closest_point_2d.js\":485}],203:[function(t,e,r){var n=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3  clipBounds[2];\\nuniform float pickId;\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  if(any(lessThan(f_position, clipBounds[0])) || \\n     any(greaterThan(f_position, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(pickId, f_id.xyz);\\n}\";r.meshShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, normal;\\nattribute vec4 color;\\nattribute vec2 uv;\\n\\nuniform mat4 model\\n           , view\\n           , projection;\\nuniform vec3 eyePosition\\n           , lightPosition;\\n\\nvarying vec3 f_normal\\n           , f_lightDirection\\n           , f_eyeDirection\\n           , f_data;\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  vec4 m_position  = model * vec4(position, 1.0);\\n  vec4 t_position  = view * m_position;\\n  gl_Position      = projection * t_position;\\n  f_color          = color;\\n  f_normal         = normal;\\n  f_data           = position;\\n  f_eyeDirection   = eyePosition   - position;\\n  f_lightDirection = lightPosition - position;\\n  f_uv             = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nfloat beckmannDistribution_2_0(float x, float roughness) {\\n  float NdotH = max(x, 0.0001);\\n  float cos2Alpha = NdotH * NdotH;\\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\\n  float roughness2 = roughness * roughness;\\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\\n  return exp(tan2Alpha / roughness2) / denom;\\n}\\n\\n\\n\\nfloat cookTorranceSpecular_1_1(\\n  vec3 lightDirection,\\n  vec3 viewDirection,\\n  vec3 surfaceNormal,\\n  float roughness,\\n  float fresnel) {\\n\\n  float VdotN = max(dot(viewDirection, surfaceNormal), 0.0);\\n  float LdotN = max(dot(lightDirection, surfaceNormal), 0.0);\\n\\n  //Half angle vector\\n  vec3 H = normalize(lightDirection + viewDirection);\\n\\n  //Geometric term\\n  float NdotH = max(dot(surfaceNormal, H), 0.0);\\n  float VdotH = max(dot(viewDirection, H), 0.000001);\\n  float LdotH = max(dot(lightDirection, H), 0.000001);\\n  float G1 = (2.0 * NdotH * VdotN) / VdotH;\\n  float G2 = (2.0 * NdotH * LdotN) / LdotH;\\n  float G = min(1.0, min(G1, G2));\\n  \\n  //Distribution term\\n  float D = beckmannDistribution_2_0(NdotH, roughness);\\n\\n  //Fresnel term\\n  float F = pow(1.0 - VdotN, fresnel);\\n\\n  //Multiply terms and done\\n  return  G * F * D / max(3.14159265 * VdotN, 0.000001);\\n}\\n\\n\\n\\nuniform vec3 clipBounds[2];\\nuniform float roughness\\n            , fresnel\\n            , kambient\\n            , kdiffuse\\n            , kspecular\\n            , opacity;\\nuniform sampler2D texture;\\n\\nvarying vec3 f_normal\\n           , f_lightDirection\\n           , f_eyeDirection\\n           , f_data;\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(f_data, clipBounds[0])) || \\n     any(greaterThan(f_data, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  vec3 N = normalize(f_normal);\\n  vec3 L = normalize(f_lightDirection);\\n  vec3 V = normalize(f_eyeDirection);\\n  \\n  if(!gl_FrontFacing) {\\n    N = -N;\\n  }\\n\\n  float specular = cookTorranceSpecular_1_1(L, V, N, roughness, fresnel);\\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\\n\\n  vec4 surfaceColor = f_color * texture2D(texture, f_uv);\\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\\n\\n  gl_FragColor = litColor * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"}]},r.wireShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 uv;\\n\\nuniform mat4 model, view, projection;\\n\\nvarying vec4 f_color;\\nvarying vec3 f_data;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n  f_color = color;\\n  f_data  = position;\\n  f_uv    = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 clipBounds[2];\\nuniform sampler2D texture;\\nuniform float opacity;\\n\\nvarying vec4 f_color;\\nvarying vec3 f_data;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(f_data, clipBounds[0])) || \\n     any(greaterThan(f_data, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"}]},r.pointShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 uv;\\nattribute float pointSize;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || \\n     any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    gl_Position = projection * view * model * vec4(position, 1.0);\\n  }\\n  gl_PointSize = pointSize;\\n  f_color = color;\\n  f_uv = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D texture;\\nuniform float opacity;\\n\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  vec2 pointR = gl_PointCoord.xy - vec2(0.5,0.5);\\n  if(dot(pointR, pointR) > 0.25) {\\n    discard;\\n  }\\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"},{name:\"pointSize\",type:\"float\"}]},r.pickShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 id;\\n\\nuniform mat4 model, view, projection;\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n  f_id        = id;\\n  f_position  = position;\\n}\",fragment:n,attributes:[{name:\"position\",type:\"vec3\"},{name:\"id\",type:\"vec4\"}]},r.pointPickShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3  position;\\nattribute float pointSize;\\nattribute vec4  id;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || \\n     any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    gl_Position  = projection * view * model * vec4(position, 1.0);\\n    gl_PointSize = pointSize;\\n  }\\n  f_id         = id;\\n  f_position   = position;\\n}\",fragment:n,attributes:[{name:\"position\",type:\"vec3\"},{name:\"pointSize\",type:\"float\"},{name:\"id\",type:\"vec4\"}]},r.contourShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 contourColor;\\n\\nvoid main() {\\n  gl_FragColor = vec4(contourColor,1);\\n}\\n\",attributes:[{name:\"position\",type:\"vec3\"}]}},{}],204:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T){this.gl=t,this.cells=[],this.positions=[],this.intensity=[],this.texture=e,this.dirty=!0,this.triShader=r,this.lineShader=n,this.pointShader=i,this.pickShader=a,this.pointPickShader=o,this.contourShader=s,this.trianglePositions=l,this.triangleColors=c,this.triangleNormals=f,this.triangleUVs=h,this.triangleIds=u,this.triangleVAO=d,this.triangleCount=0,this.lineWidth=1,this.edgePositions=p,this.edgeColors=v,this.edgeUVs=g,this.edgeIds=m,this.edgeVAO=y,this.edgeCount=0,this.pointPositions=b,this.pointColors=_,this.pointUVs=w,this.pointSizes=M,this.pointIds=x,this.pointVAO=k,this.pointCount=0,this.contourLineWidth=1,this.contourPositions=A,this.contourVAO=T,this.contourCount=0,this.contourColor=[0,0,0],this.contourEnable=!0,this.pickId=1,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.lightPosition=[1e5,1e5,0],this.ambientLight=.8,this.diffuseLight=.8,this.specularLight=2,this.roughness=.5,this.fresnel=1.5,this.opacity=1,this._model=D,this._view=D,this._projection=D,this._resolution=[1,1]}function i(t){for(var e=w({colormap:t,nshades:256,format:\"rgba\"}),r=new Uint8Array(1024),n=0;n<256;++n){for(var i=e[n],a=0;a<3;++a)r[4*n+a]=i[a];r[4*n+3]=255*i[3]}return _(r,[256,256,4],[4,0,1])}function a(t,e,r){for(var n=new Array(e),i=0;i<e;++i)n[i]=0;for(var a=t.length,i=0;i<a;++i)for(var o=t[i],s=0;s<o.length;++s)n[o[s]]=r[i];return n}function o(t){for(var e=t.length,r=new Array(e),n=0;n<e;++n)r[n]=t[n][2];return r}function s(t){var e=p(t,S.vertex,S.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e.attributes.normal.location=4,e}function l(t){var e=p(t,E.vertex,E.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e}function u(t){var e=p(t,L.vertex,L.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e.attributes.pointSize.location=4,e}function c(t){var e=p(t,C.vertex,C.fragment);return e.attributes.position.location=0,e.attributes.id.location=1,e}function h(t){var e=p(t,z.vertex,z.fragment);return e.attributes.position.location=0,e.attributes.id.location=1,e.attributes.pointSize.location=4,e}function f(t){var e=p(t,I.vertex,I.fragment);return e.attributes.position.location=0,e}function d(t,e){1===arguments.length&&(e=t,t=e.gl);var r=s(t),i=l(t),a=u(t),o=c(t),d=h(t),p=f(t),y=g(t,_(new Uint8Array([255,255,255,255]),[1,1,4]));y.generateMipmap(),y.minFilter=t.LINEAR_MIPMAP_LINEAR,y.magFilter=t.LINEAR;var b=m(t),x=m(t),w=m(t),M=m(t),k=m(t),A=v(t,[{buffer:b,type:t.FLOAT,size:3},{buffer:k,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:x,type:t.FLOAT,size:4},{buffer:w,type:t.FLOAT,size:2},{buffer:M,type:t.FLOAT,size:3}]),T=m(t),S=m(t),E=m(t),L=m(t),C=v(t,[{buffer:T,type:t.FLOAT,size:3},{buffer:L,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:S,type:t.FLOAT,size:4},{buffer:E,type:t.FLOAT,size:2}]),z=m(t),I=m(t),D=m(t),P=m(t),O=m(t),R=v(t,[{buffer:z,type:t.FLOAT,size:3},{buffer:O,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:I,type:t.FLOAT,size:4},{buffer:D,type:t.FLOAT,size:2},{buffer:P,type:t.FLOAT,size:1}]),F=m(t),j=v(t,[{buffer:F,type:t.FLOAT,size:3}]),N=new n(t,y,r,i,a,o,d,p,b,k,x,w,M,A,T,L,S,E,C,z,O,I,D,P,R,F,j);return N.update(e),N}var p=t(\"gl-shader\"),m=t(\"gl-buffer\"),v=t(\"gl-vao\"),g=t(\"gl-texture2d\"),y=t(\"normals\"),b=t(\"gl-mat4/multiply\"),x=t(\"gl-mat4/invert\"),_=t(\"ndarray\"),w=t(\"colormap\"),M=t(\"simplicial-complex-contour\"),k=t(\"typedarray-pool\"),A=t(\"./lib/shaders\"),T=t(\"./lib/closest-point\"),S=A.meshShader,E=A.wireShader,L=A.pointShader,C=A.pickShader,z=A.pointPickShader,I=A.contourShader,D=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],P=n.prototype;P.isOpaque=function(){return this.opacity>=1},P.isTransparent=function(){return this.opacity<1},P.pickSlots=1,P.setPickBase=function(t){this.pickId=t},P.highlight=function(t){if(!t||!this.contourEnable)return void(this.contourCount=0);for(var e=M(this.cells,this.intensity,t.intensity),r=e.cells,n=e.vertexIds,i=e.vertexWeights,a=r.length,o=k.mallocFloat32(6*a),s=0,l=0;l<a;++l)for(var u=r[l],c=0;c<2;++c){var h=u[0];2===u.length&&(h=u[c]);for(var f=n[h][0],d=n[h][1],p=i[h],m=1-p,v=this.positions[f],g=this.positions[d],y=0;y<3;++y)o[s++]=p*v[y]+m*g[y]}this.contourCount=s/3|0,this.contourPositions.update(o.subarray(0,s)),k.free(o)},P.update=function(t){t=t||{};var e=this.gl;this.dirty=!0,\"contourEnable\"in t&&(this.contourEnable=t.contourEnable),\"contourColor\"in t&&(this.contourColor=t.contourColor),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"lightPosition\"in t&&(this.lightPosition=t.lightPosition),\"opacity\"in t&&(this.opacity=t.opacity),\"ambient\"in t&&(this.ambientLight=t.ambient),\"diffuse\"in t&&(this.diffuseLight=t.diffuse),\"specular\"in t&&(this.specularLight=t.specular),\"roughness\"in t&&(this.roughness=t.roughness),\"fresnel\"in t&&(this.fresnel=t.fresnel),t.texture?(this.texture.dispose(),this.texture=g(e,t.texture)):t.colormap&&(this.texture.shape=[256,256],this.texture.minFilter=e.LINEAR_MIPMAP_LINEAR,this.texture.magFilter=e.LINEAR,this.texture.setPixels(i(t.colormap)),this.texture.generateMipmap());var r=t.cells,n=t.positions;if(n&&r){var s=[],l=[],u=[],c=[],h=[],f=[],d=[],p=[],m=[],v=[],b=[],x=[],_=[],w=[];this.cells=r,this.positions=n;var M=t.vertexNormals,k=t.cellNormals,A=void 0===t.vertexNormalsEpsilon?1e-6:t.vertexNormalsEpsilon,T=void 0===t.faceNormalsEpsilon?1e-6:t.faceNormalsEpsilon;t.useFacetNormals&&!k&&(k=y.faceNormals(r,n,T)),k||M||(M=y.vertexNormals(r,n,A));var S=t.vertexColors,E=t.cellColors,L=t.meshColor||[1,1,1,1],C=t.vertexUVs,z=t.vertexIntensity,I=t.cellUVs,D=t.cellIntensity,P=1/0,O=-1/0;if(!C&&!I)if(z)if(t.vertexIntensityBounds)P=+t.vertexIntensityBounds[0],O=+t.vertexIntensityBounds[1];else for(var R=0;R<z.length;++R){var F=z[R];P=Math.min(P,F),O=Math.max(O,F)}else if(D)for(var R=0;R<D.length;++R){var F=D[R];P=Math.min(P,F),O=Math.max(O,F)}else for(var R=0;R<n.length;++R){var F=n[R][2];P=Math.min(P,F),O=Math.max(O,F)}this.intensity=z||(D?a(r,n.length,D):o(n));var j=t.pointSizes,N=t.pointSize||1;this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]];for(var R=0;R<n.length;++R)for(var B=n[R],U=0;U<3;++U)!isNaN(B[U])&&isFinite(B[U])&&(this.bounds[0][U]=Math.min(this.bounds[0][U],B[U]),this.bounds[1][U]=Math.max(this.bounds[1][U],B[U]));var V=0,H=0,q=0;t:for(var R=0;R<r.length;++R){var G=r[R];switch(G.length){case 1:for(var Y=G[0],B=n[Y],U=0;U<3;++U)if(isNaN(B[U])||!isFinite(B[U]))continue t;v.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?b.push(X[0],X[1],X[2],1):b.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],x.push(W[0],W[1]),j?_.push(j[Y]):_.push(N),w.push(R),q+=1;break;case 2:for(var U=0;U<2;++U)for(var Y=G[U],B=n[Y],Z=0;Z<3;++Z)if(isNaN(B[Z])||!isFinite(B[Z]))continue t;for(var U=0;U<2;++U){var Y=G[U],B=n[Y];f.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?d.push(X[0],X[1],X[2],1):d.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],p.push(W[0],W[1]),m.push(R)}H+=1;break;case 3:for(var U=0;U<3;++U)for(var Y=G[U],B=n[Y],Z=0;Z<3;++Z)if(isNaN(B[Z])||!isFinite(B[Z]))continue t;for(var U=0;U<3;++U){var Y=G[U],B=n[Y];s.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?l.push(X[0],X[1],X[2],1):l.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],c.push(W[0],W[1]);var J;J=M?M[Y]:k[R],u.push(J[0],J[1],J[2]),h.push(R)}V+=1}}this.pointCount=q,this.edgeCount=H,this.triangleCount=V,this.pointPositions.update(v),this.pointColors.update(b),this.pointUVs.update(x),this.pointSizes.update(_),this.pointIds.update(new Uint32Array(w)),this.edgePositions.update(f),this.edgeColors.update(d),this.edgeUVs.update(p),this.edgeIds.update(new Uint32Array(m)),this.trianglePositions.update(s),this.triangleColors.update(l),this.triangleUVs.update(c),this.triangleNormals.update(u),this.triangleIds.update(new Uint32Array(h))}},P.drawTransparent=P.draw=function(t){t=t||{};for(var e=this.gl,r=t.model||D,n=t.view||D,i=t.projection||D,a=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],o=0;o<3;++o)a[0][o]=Math.max(a[0][o],this.clipBounds[0][o]),a[1][o]=Math.min(a[1][o],this.clipBounds[1][o]);var s={model:r,view:n,projection:i,clipBounds:a,kambient:this.ambientLight,kdiffuse:this.diffuseLight,kspecular:this.specularLight,roughness:this.roughness,fresnel:this.fresnel,eyePosition:[0,0,0],lightPosition:[0,0,0],opacity:this.opacity,contourColor:this.contourColor,texture:0};this.texture.bind(0);var l=new Array(16);b(l,s.view,s.model),b(l,s.projection,l),x(l,l);for(var o=0;o<3;++o)s.eyePosition[o]=l[12+o]/l[15];for(var u=l[15],o=0;o<3;++o)u+=this.lightPosition[o]*l[4*o+3];for(var o=0;o<3;++o){for(var c=l[12+o],h=0;h<3;++h)c+=l[4*h+o]*this.lightPosition[h];s.lightPosition[o]=c/u}if(this.triangleCount>0){var f=this.triShader;f.bind(),f.uniforms=s,this.triangleVAO.bind(),e.drawArrays(e.TRIANGLES,0,3*this.triangleCount),this.triangleVAO.unbind()}if(this.edgeCount>0&&this.lineWidth>0){var f=this.lineShader;f.bind(),f.uniforms=s,this.edgeVAO.bind(),e.lineWidth(this.lineWidth),e.drawArrays(e.LINES,0,2*this.edgeCount),this.edgeVAO.unbind()}if(this.pointCount>0){var f=this.pointShader;f.bind(),f.uniforms=s,this.pointVAO.bind(),e.drawArrays(e.POINTS,0,this.pointCount),this.pointVAO.unbind()}if(this.contourEnable&&this.contourCount>0&&this.contourLineWidth>0){var f=this.contourShader;f.bind(),f.uniforms=s,this.contourVAO.bind(),e.drawArrays(e.LINES,0,this.contourCount),this.contourVAO.unbind()}},P.drawPick=function(t){t=t||{};for(var e=this.gl,r=t.model||D,n=t.view||D,i=t.projection||D,a=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],o=0;o<3;++o)a[0][o]=Math.max(a[0][o],this.clipBounds[0][o]),a[1][o]=Math.min(a[1][o],this.clipBounds[1][o]);this._model=[].slice.call(r),this._view=[].slice.call(n),this._projection=[].slice.call(i),this._resolution=[e.drawingBufferWidth,e.drawingBufferHeight];var s={model:r,view:n,projection:i,clipBounds:a,pickId:this.pickId/255},l=this.pickShader;if(l.bind(),l.uniforms=s,this.triangleCount>0&&(this.triangleVAO.bind(),e.drawArrays(e.TRIANGLES,0,3*this.triangleCount),this.triangleVAO.unbind()),this.edgeCount>0&&(this.edgeVAO.bind(),e.lineWidth(this.lineWidth),e.drawArrays(e.LINES,0,2*this.edgeCount),this.edgeVAO.unbind()),this.pointCount>0){var l=this.pointPickShader;l.bind(),l.uniforms=s,this.pointVAO.bind(),e.drawArrays(e.POINTS,0,this.pointCount),this.pointVAO.unbind()}},P.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;for(var e=t.value[0]+256*t.value[1]+65536*t.value[2],r=this.cells[e],n=this.positions,i=new Array(r.length),a=0;a<r.length;++a)i[a]=n[r[a]];var o=T(i,[t.coord[0],this._resolution[1]-t.coord[1]],this._model,this._view,this._projection,this._resolution);if(!o)return null;for(var s=o[2],l=0,a=0;a<r.length;++a)l+=s[a]*this.intensity[r[a]];return{position:o[1],index:r[o[0]],cell:r,cellId:e,intensity:l,dataCoordinate:this.positions[r[o[0]]]}},P.dispose=function(){this.texture.dispose(),this.triShader.dispose(),this.lineShader.dispose(),this.pointShader.dispose(),this.pickShader.dispose(),this.pointPickShader.dispose(),this.triangleVAO.dispose(),this.trianglePositions.dispose(),this.triangleColors.dispose(),this.triangleUVs.dispose(),this.triangleNormals.dispose(),this.triangleIds.dispose(),this.edgeVAO.dispose(),this.edgePositions.dispose(),this.edgeColors.dispose(),this.edgeUVs.dispose(),this.edgeIds.dispose(),this.pointVAO.dispose(),this.pointPositions.dispose(),this.pointColors.dispose(),this.pointUVs.dispose(),this.pointSizes.dispose(),this.pointIds.dispose(),this.contourVAO.dispose(),this.contourPositions.dispose(),this.contourShader.dispose()},e.exports=d},{\"./lib/closest-point\":202,\"./lib/shaders\":203,colormap:98,\"gl-buffer\":155,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"gl-shader\":254,\"gl-texture2d\":266,\"gl-vao\":270,ndarray:466,normals:468,\"simplicial-complex-contour\":516,\"typedarray-pool\":540}],205:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r}function i(t){var e=t.gl;return new n(t,a(e,[0,0,0,1,1,0,1,1]),o(e,s.boxVert,s.lineFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"./shaders\"),l=n.prototype;l.bind=function(){var t=this.shader;this.vbo.bind(),this.shader.bind(),t.attributes.coord.pointer(),t.uniforms.screenBox=this.plot.screenBox},l.drawBox=function(){var t=[0,0],e=[0,0];return function(r,n,i,a,o){var s=this.plot,l=this.shader,u=s.gl;t[0]=r,t[1]=n,e[0]=i,e[1]=a,l.uniforms.lo=t,l.uniforms.hi=e,l.uniforms.color=o,u.drawArrays(u.TRIANGLE_STRIP,0,4)}}(),l.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"gl-buffer\":155,\"gl-shader\":211}],206:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.plot=t,this.vbo=e,this.shader=r,this.tickShader=n,this.ticks=[[],[]]}function i(t,e){return t-e}function a(t){var e=t.gl;return new n(t,o(e),s(e,u.gridVert,u.gridFrag),s(e,u.tickVert,u.gridFrag))}e.exports=a;var o=t(\"gl-buffer\"),s=t(\"gl-shader\"),l=t(\"binary-search-bounds\"),u=t(\"./shaders\"),c=n.prototype;c.draw=function(){var t=[0,0],e=[0,0],r=[0,0];return function(){for(var n=this.plot,i=this.vbo,a=this.shader,o=this.ticks,s=n.gl,l=n._tickBounds,u=n.dataBox,c=n.viewBox,h=n.gridLineWidth,f=n.gridLineColor,d=n.gridLineEnable,p=n.pixelRatio,m=0;m<2;++m){var v=l[m],g=l[m+2],y=g-v,b=.5*(u[m+2]+u[m]),x=u[m+2]-u[m];e[m]=2*y/x,t[m]=2*(v-b)/x}a.bind(),i.bind(),a.attributes.dataCoord.pointer(),a.uniforms.dataShift=t,a.uniforms.dataScale=e;for(var _=0,m=0;m<2;++m){r[0]=r[1]=0,r[m]=1,a.uniforms.dataAxis=r,a.uniforms.lineWidth=h[m]/(c[m+2]-c[m])*p,a.uniforms.color=f[m];var w=6*o[m].length;d[m]&&w&&s.drawArrays(s.TRIANGLES,_,w),_+=w}}}(),c.drawTickMarks=function(){var t=[0,0],e=[0,0],r=[1,0],n=[0,1],a=[0,0],o=[0,0];return function(){for(var s=this.plot,u=this.vbo,c=this.tickShader,h=this.ticks,f=s.gl,d=s._tickBounds,p=s.dataBox,m=s.viewBox,v=s.pixelRatio,g=s.screenBox,y=g[2]-g[0],b=g[3]-g[1],x=m[2]-m[0],_=m[3]-m[1],w=0;w<2;++w){var M=d[w],k=d[w+2],A=k-M,T=.5*(p[w+2]+p[w]),S=p[w+2]-p[w];e[w]=2*A/S,t[w]=2*(M-T)/S}e[0]*=x/y,t[0]*=x/y,e[1]*=_/b,t[1]*=_/b,c.bind(),u.bind(),c.attributes.dataCoord.pointer();var E=c.uniforms;E.dataShift=t,E.dataScale=e;var L=s.tickMarkLength,C=s.tickMarkWidth,z=s.tickMarkColor,I=6*h[0].length,D=Math.min(l.ge(h[0],(p[0]-d[0])/(d[2]-d[0]),i),h[0].length),P=Math.min(l.gt(h[0],(p[2]-d[0])/(d[2]-d[0]),i),h[0].length),O=0+6*D,R=6*Math.max(0,P-D),F=Math.min(l.ge(h[1],(p[1]-d[1])/(d[3]-d[1]),i),h[1].length),j=Math.min(l.gt(h[1],(p[3]-d[1])/(d[3]-d[1]),i),h[1].length),N=I+6*F,B=6*Math.max(0,j-F);a[0]=2*(m[0]-L[1])/y-1,a[1]=(m[3]+m[1])/b-1,o[0]=L[1]*v/y,o[1]=C[1]*v/b,B&&(E.color=z[1],E.tickScale=o,E.dataAxis=n,E.screenOffset=a,f.drawArrays(f.TRIANGLES,N,B)),a[0]=(m[2]+m[0])/y-1,a[1]=2*(m[1]-L[0])/b-1,o[0]=C[0]*v/y,o[1]=L[0]*v/b,R&&(E.color=z[0],E.tickScale=o,E.dataAxis=r,E.screenOffset=a,f.drawArrays(f.TRIANGLES,O,R)),a[0]=2*(m[2]+L[3])/y-1,a[1]=(m[3]+m[1])/b-1,o[0]=L[3]*v/y,o[1]=C[3]*v/b,B&&(E.color=z[3],E.tickScale=o,E.dataAxis=n,E.screenOffset=a,f.drawArrays(f.TRIANGLES,N,B)),a[0]=(m[2]+m[0])/y-1,a[1]=2*(m[3]+L[2])/b-1,o[0]=C[2]*v/y,o[1]=L[2]*v/b,R&&(E.color=z[2],E.tickScale=o,E.dataAxis=r,E.screenOffset=a,f.drawArrays(f.TRIANGLES,O,R))}}(),c.update=function(){var t=[1,1,-1,-1,1,-1],e=[1,-1,1,1,-1,-1];return function(r){for(var n=r.ticks,i=r.bounds,a=new Float32Array(18*(n[0].length+n[1].length)),o=(this.plot.zeroLineEnable,0),s=[[],[]],l=0;l<2;++l)for(var u=s[l],c=n[l],h=i[l],f=i[l+2],d=0;d<c.length;++d){var p=(c[d].x-h)/(f-h);u.push(p);for(var m=0;m<6;++m)a[o++]=p,a[o++]=t[m],a[o++]=e[m]}this.ticks=s,this.vbo.update(a)}}(),c.dispose=function(){this.vbo.dispose(),this.shader.dispose(),this.tickShader.dispose()}},{\"./shaders\":208,\"binary-search-bounds\":210,\"gl-buffer\":155,\"gl-shader\":211}],207:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r}function i(t){var e=t.gl;return new n(t,a(e,[-1,-1,-1,1,1,-1,1,1]),o(e,s.lineVert,s.lineFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"./shaders\"),l=n.prototype;l.bind=function(){var t=this.shader;this.vbo.bind(),this.shader.bind(),t.attributes.coord.pointer(),t.uniforms.screenBox=this.plot.screenBox},l.drawLine=function(){var t=[0,0],e=[0,0];return function(r,n,i,a,o,s){var l=this.plot,u=this.shader,c=l.gl;t[0]=r,t[1]=n,e[0]=i,e[1]=a,u.uniforms.start=t,u.uniforms.end=e,u.uniforms.width=o*l.pixelRatio,u.uniforms.color=s,c.drawArrays(c.TRIANGLE_STRIP,0,4)}}(),l.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"gl-buffer\":155,\"gl-shader\":211}],208:[function(t,e,r){\"use strict\";var n=\"precision lowp float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = vec4(color.xyz * color.w, color.w);\\n}\\n\";e.exports={lineVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 coord;\\n\\nuniform vec4 screenBox;\\nuniform vec2 start, end;\\nuniform float width;\\n\\nvec2 perp(vec2 v) {\\n  return vec2(v.y, -v.x);\\n}\\n\\nvec2 screen(vec2 v) {\\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\\n}\\n\\nvoid main() {\\n  vec2 delta = normalize(perp(start - end));\\n  vec2 offset = mix(start, end, 0.5 * (coord.y+1.0));\\n  gl_Position = vec4(screen(offset + 0.5 * width * delta * coord.x), 0, 1);\\n}\\n\",lineFrag:n,textVert:\"#define GLSLIFY 1\\nattribute vec3 textCoordinate;\\n\\nuniform vec2 dataScale, dataShift, dataAxis, screenOffset, textScale;\\nuniform float angle;\\n\\nvoid main() {\\n  float dataOffset  = textCoordinate.z;\\n  vec2 glyphOffset  = textCoordinate.xy;\\n  mat2 glyphMatrix = mat2(cos(angle), sin(angle), -sin(angle), cos(angle));\\n  vec2 screenCoordinate = dataAxis * (dataScale * dataOffset + dataShift) +\\n    glyphMatrix * glyphOffset * textScale + screenOffset;\\n  gl_Position = vec4(screenCoordinate, 0, 1);\\n}\\n\",textFrag:n,gridVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 dataCoord;\\n\\nuniform vec2 dataAxis, dataShift, dataScale;\\nuniform float lineWidth;\\n\\nvoid main() {\\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\\n  pos += 10.0 * dataCoord.y * vec2(dataAxis.y, -dataAxis.x) + dataCoord.z * lineWidth;\\n  gl_Position = vec4(pos, 0, 1);\\n}\\n\",gridFrag:n,boxVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 coord;\\n\\nuniform vec4 screenBox;\\nuniform vec2 lo, hi;\\n\\nvec2 screen(vec2 v) {\\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\\n}\\n\\nvoid main() {\\n  gl_Position = vec4(screen(mix(lo, hi, coord)), 0, 1);\\n}\\n\",tickVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 dataCoord;\\n\\nuniform vec2 dataAxis, dataShift, dataScale, screenOffset, tickScale;\\n\\nvoid main() {\\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\\n  gl_Position = vec4(pos + tickScale*dataCoord.yz + screenOffset, 0, 1);\\n}\\n\"}},{}],209:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r,this.tickOffset=[[],[]],this.tickX=[[],[]],this.labelOffset=[0,0],this.labelCount=[0,0]}function i(t){var e=t.gl;return new n(t,a(e),o(e,u.textVert,u.textFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"text-cache\"),l=t(\"binary-search-bounds\"),u=t(\"./shaders\"),c=n.prototype;c.drawTicks=function(){var t=[0,0],e=[0,0],r=[0,0];return function(n){var i=this.plot,a=this.shader,o=this.tickX[n],s=this.tickOffset[n],u=i.gl,c=i.viewBox,h=i.dataBox,f=i.screenBox,d=i.pixelRatio,p=i.tickEnable,m=i.tickPad,v=i.tickColor,g=i.tickAngle,y=i.labelEnable,b=i.labelPad,x=i.labelColor,_=i.labelAngle,w=this.labelOffset[n],M=this.labelCount[n],k=l.lt(o,h[n]),A=l.le(o,h[n+2]);t[0]=t[1]=0,t[n]=1,e[n]=(c[2+n]+c[n])/(f[2+n]-f[n])-1;var T=2/f[2+(1^n)]-f[1^n];e[1^n]=T*c[1^n]-1,p[n]&&(e[1^n]-=T*d*m[n],k<A&&s[A]>s[k]&&(a.uniforms.dataAxis=t,a.uniforms.screenOffset=e,a.uniforms.color=v[n],a.uniforms.angle=g[n],u.drawArrays(u.TRIANGLES,s[k],s[A]-s[k]))),y[n]&&M&&(e[1^n]-=T*d*b[n],a.uniforms.dataAxis=r,a.uniforms.screenOffset=e,a.uniforms.color=x[n],a.uniforms.angle=_[n],u.drawArrays(u.TRIANGLES,w,M)),e[1^n]=T*c[2+(1^n)]-1,p[n+2]&&(e[1^n]+=T*d*m[n+2],k<A&&s[A]>s[k]&&(a.uniforms.dataAxis=t,a.uniforms.screenOffset=e,a.uniforms.color=v[n+2],a.uniforms.angle=g[n+2],u.drawArrays(u.TRIANGLES,s[k],s[A]-s[k]))),y[n+2]&&M&&(e[1^n]+=T*d*b[n+2],a.uniforms.dataAxis=r,a.uniforms.screenOffset=e,a.uniforms.color=x[n+2],a.uniforms.angle=_[n+2],u.drawArrays(u.TRIANGLES,w,M))}}(),c.drawTitle=function(){var t=[0,0],e=[0,0];return function(){var r=this.plot,n=this.shader,i=r.gl,a=r.screenBox,o=r.titleCenter,s=r.titleAngle,l=r.titleColor,u=r.pixelRatio;if(this.titleCount){for(var c=0;c<2;++c)e[c]=2*(o[c]*u-a[c])/(a[2+c]-a[c])-1;n.bind(),n.uniforms.dataAxis=t,n.uniforms.screenOffset=e,n.uniforms.angle=s,n.uniforms.color=l,i.drawArrays(i.TRIANGLES,this.titleOffset,this.titleCount)}}}(),c.bind=function(){var t=[0,0],e=[0,0],r=[0,0];return function(){var n=this.plot,i=this.shader,a=n._tickBounds,o=n.dataBox,s=n.screenBox,l=n.viewBox;i.bind();for(var u=0;u<2;++u){var c=a[u],h=a[u+2],f=h-c,d=.5*(o[u+2]+o[u]),p=o[u+2]-o[u],m=l[u],v=l[u+2],g=v-m,y=s[u],b=s[u+2],x=b-y;e[u]=2*f/p*g/x,t[u]=2*(c-d)/p*g/x}r[1]=2*n.pixelRatio/(s[3]-s[1]),r[0]=r[1]*(s[3]-s[1])/(s[2]-s[0]),i.uniforms.dataScale=e,i.uniforms.dataShift=t,i.uniforms.textScale=r,this.vbo.bind(),i.attributes.textCoordinate.pointer()}}(),c.update=function(t){var e,r,n,i,a,o=[],l=t.ticks,u=t.bounds;for(a=0;a<2;++a){var c=[Math.floor(o.length/3)],h=[-1/0],f=l[a];for(e=0;e<f.length;++e){var d=f[e],p=d.x,m=d.text,v=d.font||\"sans-serif\";i=d.fontSize||12;for(var g=1/(u[a+2]-u[a]),y=u[a],b=m.split(\"\\n\"),x=0;x<b.length;x++)for(n=s(v,b[x]).data,r=0;r<n.length;r+=2)o.push(n[r]*i,-n[r+1]*i-x*i*1.2,(p-y)*g);c.push(Math.floor(o.length/3)),h.push(p)}this.tickOffset[a]=c,this.tickX[a]=h}for(a=0;a<2;++a){for(this.labelOffset[a]=Math.floor(o.length/3),n=s(t.labelFont[a],t.labels[a],{textAlign:\"center\"}).data,\n",
       "i=t.labelSize[a],e=0;e<n.length;e+=2)o.push(n[e]*i,-n[e+1]*i,0);this.labelCount[a]=Math.floor(o.length/3)-this.labelOffset[a]}for(this.titleOffset=Math.floor(o.length/3),n=s(t.titleFont,t.title).data,i=t.titleSize,e=0;e<n.length;e+=2)o.push(n[e]*i,-n[e+1]*i,0);this.titleCount=Math.floor(o.length/3)-this.titleOffset,this.vbo.update(o)},c.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"binary-search-bounds\":210,\"gl-buffer\":155,\"gl-shader\":211,\"text-cache\":531}],210:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],211:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this.gl.lastAttribCount=0,this._vref=this._fref=this._relink=this.vertShader=this.fragShader=this.program=this.attributes=this.uniforms=this.types=null}function i(t,e){return t.name<e.name?-1:1}function a(t,e,r,i,a){var o=new n(t);return o.update(e,r,i,a),o}var o=t(\"./lib/create-uniforms\"),s=t(\"./lib/create-attributes\"),l=t(\"./lib/reflect\"),u=t(\"./lib/shader-cache\"),c=t(\"./lib/runtime-reflect\"),h=t(\"./lib/GLError\"),f=n.prototype;f.bind=function(){this.program||this._relink();var t,e=this.gl.getProgramParameter(this.program,this.gl.ACTIVE_ATTRIBUTES),r=this.gl.lastAttribCount;if(e>r)for(t=r;t<e;t++)this.gl.enableVertexAttribArray(t);else if(r>e)for(t=e;t<r;t++)this.gl.disableVertexAttribArray(t);this.gl.lastAttribCount=e,this.gl.useProgram(this.program)},f.dispose=function(){for(var t=this.gl.lastAttribCount,e=0;e<t;e++)this.gl.disableVertexAttribArray(e);this.gl.lastAttribCount=0,this._fref&&this._fref.dispose(),this._vref&&this._vref.dispose(),this.attributes=this.types=this.vertShader=this.fragShader=this.program=this._relink=this._fref=this._vref=null},f.update=function(t,e,r,n){function a(){d.program=u.program(p,d._vref,d._fref,_,w);for(var t=0;t<r.length;++t)E[t]=p.getUniformLocation(d.program,r[t].name)}if(!e||1===arguments.length){var f=t;t=f.vertex,e=f.fragment,r=f.uniforms,n=f.attributes}var d=this,p=d.gl,m=d._vref;d._vref=u.shader(p,p.VERTEX_SHADER,t),m&&m.dispose(),d.vertShader=d._vref.shader;var v=this._fref;if(d._fref=u.shader(p,p.FRAGMENT_SHADER,e),v&&v.dispose(),d.fragShader=d._fref.shader,!r||!n){var g=p.createProgram();if(p.attachShader(g,d.fragShader),p.attachShader(g,d.vertShader),p.linkProgram(g),!p.getProgramParameter(g,p.LINK_STATUS)){var y=p.getProgramInfoLog(g);throw new h(y,\"Error linking program:\"+y)}r=r||c.uniforms(p,g),n=n||c.attributes(p,g),p.deleteProgram(g)}n=n.slice(),n.sort(i);var b,x=[],_=[],w=[];for(b=0;b<n.length;++b){var M=n[b];if(M.type.indexOf(\"mat\")>=0){for(var k=0|M.type.charAt(M.type.length-1),A=new Array(k),T=0;T<k;++T)A[T]=w.length,_.push(M.name+\"[\"+T+\"]\"),\"number\"==typeof M.location?w.push(M.location+T):Array.isArray(M.location)&&M.location.length===k&&\"number\"==typeof M.location[T]?w.push(0|M.location[T]):w.push(-1);x.push({name:M.name,type:M.type,locations:A})}else x.push({name:M.name,type:M.type,locations:[w.length]}),_.push(M.name),\"number\"==typeof M.location?w.push(0|M.location):w.push(-1)}var S=0;for(b=0;b<w.length;++b)if(w[b]<0){for(;w.indexOf(S)>=0;)S+=1;w[b]=S}var E=new Array(r.length);a(),d._relink=a,d.types={uniforms:l(r),attributes:l(n)},d.attributes=s(p,d,x,w),Object.defineProperty(d,\"uniforms\",o(p,d,r,E))},e.exports=a},{\"./lib/GLError\":212,\"./lib/create-attributes\":213,\"./lib/create-uniforms\":214,\"./lib/reflect\":215,\"./lib/runtime-reflect\":216,\"./lib/shader-cache\":217}],212:[function(t,e,r){function n(t,e,r){this.shortMessage=e||\"\",this.longMessage=r||\"\",this.rawError=t||\"\",this.message=\"gl-shader: \"+(e||t||\"\")+(r?\"\\n\"+r:\"\"),this.stack=(new Error).stack}n.prototype=new Error,n.prototype.name=\"GLError\",n.prototype.constructor=n,e.exports=n},{}],213:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this._gl=t,this._wrapper=e,this._index=r,this._locations=n,this._dimension=i,this._constFunc=a}function i(t,e,r,i,a,o,s){for(var l=[\"gl\",\"v\"],u=[],c=0;c<a;++c)l.push(\"x\"+c),u.push(\"x\"+c);l.push(\"if(x0.length===void 0){return gl.vertexAttrib\"+a+\"f(v,\"+u.join()+\")}else{return gl.vertexAttrib\"+a+\"fv(v,x0)}\");var h=Function.apply(null,l),f=new n(t,e,r,i,a,h);Object.defineProperty(o,s,{set:function(e){return t.disableVertexAttribArray(i[r]),h(t,i[r],e),e},get:function(){return f},enumerable:!0})}function a(t,e,r,n,a,o,s){for(var l=new Array(a),u=new Array(a),c=0;c<a;++c)i(t,e,r[c],n,a,l,c),u[c]=l[c];Object.defineProperty(l,\"location\",{set:function(t){if(Array.isArray(t))for(var e=0;e<a;++e)u[e].location=t[e];else for(var e=0;e<a;++e)u[e].location=t+e;return t},get:function(){for(var t=new Array(a),e=0;e<a;++e)t[e]=n[r[e]];return t},enumerable:!0}),l.pointer=function(e,i,o,s){e=e||t.FLOAT,i=!!i,o=o||a*a,s=s||0;for(var l=0;l<a;++l){var u=n[r[l]];t.vertexAttribPointer(u,a,e,i,o,s+l*a),t.enableVertexAttribArray(u)}};var h=new Array(a),f=t[\"vertexAttrib\"+a+\"fv\"];Object.defineProperty(o,s,{set:function(e){for(var i=0;i<a;++i){var o=n[r[i]];if(t.disableVertexAttribArray(o),Array.isArray(e[0]))f.call(t,o,e[i]);else{for(var s=0;s<a;++s)h[s]=e[a*i+s];f.call(t,o,h)}}return e},get:function(){return l},enumerable:!0})}function o(t,e,r,n){for(var o={},l=0,u=r.length;l<u;++l){var c=r[l],h=c.name,f=c.type,d=c.locations;switch(f){case\"bool\":case\"int\":case\"float\":i(t,e,d[0],n,1,o,h);break;default:if(f.indexOf(\"vec\")>=0){var p=f.charCodeAt(f.length-1)-48;if(p<2||p>4)throw new s(\"\",\"Invalid data type for attribute \"+h+\": \"+f);i(t,e,d[0],n,p,o,h)}else{if(!(f.indexOf(\"mat\")>=0))throw new s(\"\",\"Unknown data type for attribute \"+h+\": \"+f);var p=f.charCodeAt(f.length-1)-48;if(p<2||p>4)throw new s(\"\",\"Invalid data type for attribute \"+h+\": \"+f);a(t,e,d,n,p,o,h)}}}return o}e.exports=o;var s=t(\"./GLError\"),l=n.prototype;l.pointer=function(t,e,r,n){var i=this,a=i._gl,o=i._locations[i._index];a.vertexAttribPointer(o,i._dimension,t||a.FLOAT,!!e,r||0,n||0),a.enableVertexAttribArray(o)},l.set=function(t,e,r,n){return this._constFunc(this._locations[this._index],t,e,r,n)},Object.defineProperty(l,\"location\",{get:function(){return this._locations[this._index]},set:function(t){return t!==this._locations[this._index]&&(this._locations[this._index]=0|t,this._wrapper.program=null),0|t}})},{\"./GLError\":212}],214:[function(t,e,r){\"use strict\";function n(t){return new Function(\"y\",\"return function(){return y}\")(t)}function i(t,e){for(var r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function a(t,e,r,a){function l(r){return new Function(\"gl\",\"wrapper\",\"locations\",\"return function(){return gl.getUniform(wrapper.program,locations[\"+r+\"])}\")(t,e,a)}function u(t,e,r){switch(r){case\"bool\":case\"int\":case\"sampler2D\":case\"samplerCube\":return\"gl.uniform1i(locations[\"+e+\"],obj\"+t+\")\";case\"float\":return\"gl.uniform1f(locations[\"+e+\"],obj\"+t+\")\";default:var n=r.indexOf(\"vec\");if(!(0<=n&&n<=1&&r.length===4+n)){if(0===r.indexOf(\"mat\")&&4===r.length){var i=r.charCodeAt(r.length-1)-48;if(i<2||i>4)throw new s(\"\",\"Invalid uniform dimension type for matrix \"+name+\": \"+r);return\"gl.uniformMatrix\"+i+\"fv(locations[\"+e+\"],false,obj\"+t+\")\"}throw new s(\"\",\"Unknown uniform data type for \"+name+\": \"+r)}var i=r.charCodeAt(r.length-1)-48;if(i<2||i>4)throw new s(\"\",\"Invalid data type\");switch(r.charAt(0)){case\"b\":case\"i\":return\"gl.uniform\"+i+\"iv(locations[\"+e+\"],obj\"+t+\")\";case\"v\":return\"gl.uniform\"+i+\"fv(locations[\"+e+\"],obj\"+t+\")\";default:throw new s(\"\",\"Unrecognized data type for vector \"+name+\": \"+r)}}}function c(t,e){if(\"object\"!=typeof e)return[[t,e]];var r=[];for(var n in e){var i=e[n],a=t;parseInt(n)+\"\"===n?a+=\"[\"+n+\"]\":a+=\".\"+n,\"object\"==typeof i?r.push.apply(r,c(a,i)):r.push([a,i])}return r}function h(e){for(var n=[\"return function updateProperty(obj){\"],i=c(\"\",e),o=0;o<i.length;++o){var s=i[o],l=s[0],h=s[1];a[h]&&n.push(u(l,h,r[h].type))}return n.push(\"return obj}\"),new Function(\"gl\",\"locations\",n.join(\"\\n\"))(t,a)}function f(t){switch(t){case\"bool\":return!1;case\"int\":case\"sampler2D\":case\"samplerCube\":case\"float\":return 0;default:var e=t.indexOf(\"vec\");if(0<=e&&e<=1&&t.length===4+e){var r=t.charCodeAt(t.length-1)-48;if(r<2||r>4)throw new s(\"\",\"Invalid data type\");return\"b\"===t.charAt(0)?i(r,!1):i(r,0)}if(0===t.indexOf(\"mat\")&&4===t.length){var r=t.charCodeAt(t.length-1)-48;if(r<2||r>4)throw new s(\"\",\"Invalid uniform dimension type for matrix \"+name+\": \"+t);return i(r*r,0)}throw new s(\"\",\"Unknown uniform data type for \"+name+\": \"+t)}}function d(t,e,i){if(\"object\"==typeof i){var o=p(i);Object.defineProperty(t,e,{get:n(o),set:h(i),enumerable:!0,configurable:!1})}else a[i]?Object.defineProperty(t,e,{get:l(i),set:h(i),enumerable:!0,configurable:!1}):t[e]=f(r[i].type)}function p(t){var e;if(Array.isArray(t)){e=new Array(t.length);for(var r=0;r<t.length;++r)d(e,r,t[r])}else{e={};for(var n in t)d(e,n,t[n])}return e}var m=o(r,!0);return{get:n(p(m)),set:h(m),enumerable:!0,configurable:!0}}var o=t(\"./reflect\"),s=t(\"./GLError\");e.exports=a},{\"./GLError\":212,\"./reflect\":215}],215:[function(t,e,r){\"use strict\";function n(t,e){for(var r={},n=0;n<t.length;++n)for(var i=t[n].name,a=i.split(\".\"),o=r,s=0;s<a.length;++s){var l=a[s].split(\"[\");if(l.length>1){l[0]in o||(o[l[0]]=[]),o=o[l[0]];for(var u=1;u<l.length;++u){var c=parseInt(l[u]);u<l.length-1||s<a.length-1?(c in o||(u<l.length-1?o[c]=[]:o[c]={}),o=o[c]):o[c]=e?n:t[n].type}}else s<a.length-1?(l[0]in o||(o[l[0]]={}),o=o[l[0]]):o[l[0]]=e?n:t[n].type}return r}e.exports=n},{}],216:[function(t,e,r){\"use strict\";function n(t,e){if(!s){var r=Object.keys(o);s={};for(var n=0;n<r.length;++n){var i=r[n];s[t[i]]=o[i]}}return s[e]}function i(t,e){for(var r=t.getProgramParameter(e,t.ACTIVE_UNIFORMS),i=[],a=0;a<r;++a){var o=t.getActiveUniform(e,a);if(o){var s=n(t,o.type);if(o.size>1)for(var l=0;l<o.size;++l)i.push({name:o.name.replace(\"[0]\",\"[\"+l+\"]\"),type:s});else i.push({name:o.name,type:s})}}return i}function a(t,e){for(var r=t.getProgramParameter(e,t.ACTIVE_ATTRIBUTES),i=[],a=0;a<r;++a){var o=t.getActiveAttrib(e,a);o&&i.push({name:o.name,type:n(t,o.type)})}return i}r.uniforms=i,r.attributes=a;var o={FLOAT:\"float\",FLOAT_VEC2:\"vec2\",FLOAT_VEC3:\"vec3\",FLOAT_VEC4:\"vec4\",INT:\"int\",INT_VEC2:\"ivec2\",INT_VEC3:\"ivec3\",INT_VEC4:\"ivec4\",BOOL:\"bool\",BOOL_VEC2:\"bvec2\",BOOL_VEC3:\"bvec3\",BOOL_VEC4:\"bvec4\",FLOAT_MAT2:\"mat2\",FLOAT_MAT3:\"mat3\",FLOAT_MAT4:\"mat4\",SAMPLER_2D:\"sampler2D\",SAMPLER_CUBE:\"samplerCube\"},s=null},{}],217:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.id=t,this.src=e,this.type=r,this.shader=n,this.count=a,this.programs=[],this.cache=o}function i(t){this.gl=t,this.shaders=[{},{}],this.programs={}}function a(t,e,r){var n=t.createShader(e);if(t.shaderSource(n,r),t.compileShader(n),!t.getShaderParameter(n,t.COMPILE_STATUS)){var i=t.getShaderInfoLog(n);try{var a=h(i,r,e)}catch(t){throw console.warn(\"Failed to format compiler error: \"+t),new c(i,\"Error compiling shader:\\n\"+i)}throw new c(i,a.short,a.long)}return n}function o(t,e,r,n,i){var a=t.createProgram();t.attachShader(a,e),t.attachShader(a,r);for(var o=0;o<n.length;++o)t.bindAttribLocation(a,i[o],n[o]);if(t.linkProgram(a),!t.getProgramParameter(a,t.LINK_STATUS)){var s=t.getProgramInfoLog(a);throw new c(s,\"Error linking program: \"+s)}return a}function s(t){var e=d.get(t);return e||(e=new i(t),d.set(t,e)),e}function l(t,e,r){return s(t).getShaderReference(e,r)}function u(t,e,r,n,i){return s(t).getProgram(e,r,n,i)}r.shader=l,r.program=u;var c=t(\"./GLError\"),h=t(\"gl-format-compiler-error\"),f=\"undefined\"==typeof WeakMap?t(\"weakmap-shim\"):WeakMap,d=new f,p=0;n.prototype.dispose=function(){if(0==--this.count){for(var t=this.cache,e=t.gl,r=this.programs,n=0,i=r.length;n<i;++n){var a=t.programs[r[n]];a&&(delete t.programs[n],e.deleteProgram(a))}e.deleteShader(this.shader),delete t.shaders[this.type===e.FRAGMENT_SHADER|0][this.src]}};var m=i.prototype;m.getShaderReference=function(t,e){var r=this.gl,i=this.shaders[t===r.FRAGMENT_SHADER|0],o=i[e];if(o&&r.isShader(o.shader))o.count+=1;else{var s=a(r,t,e);o=i[e]=new n(p++,e,t,s,[],1,this)}return o},m.getProgram=function(t,e,r,n){var i=[t.id,e.id,r.join(\":\"),n.join(\":\")].join(\"@\"),a=this.programs[i];return a&&this.gl.isProgram(a)||(this.programs[i]=a=o(this.gl,t.shader,e.shader,r,n),t.programs.push(i),e.programs.push(i)),a}},{\"./GLError\":212,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],218:[function(t,e,r){\"use strict\";function n(t,e){this.gl=t,this.pickBuffer=e,this.screenBox=[0,0,t.drawingBufferWidth,t.drawingBufferHeight],this.viewBox=[0,0,0,0],this.dataBox=[-10,-10,10,10],this.gridLineEnable=[!0,!0],this.gridLineWidth=[1,1],this.gridLineColor=[[0,0,0,1],[0,0,0,1]],this.pixelRatio=1,this.tickMarkLength=[0,0,0,0],this.tickMarkWidth=[0,0,0,0],this.tickMarkColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[15,15,15,15],this.tickAngle=[0,0,0,0],this.tickEnable=[!0,!0,!0,!0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[15,15,15,15],this.labelAngle=[0,Math.PI/2,0,3*Math.PI/2],this.labelEnable=[!0,!0,!0,!0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.titleCenter=[0,0],this.titleEnable=!0,this.titleAngle=0,this.titleColor=[0,0,0,1],this.borderColor=[0,0,0,0],this.backgroundColor=[0,0,0,0],this.zeroLineEnable=[!0,!0],this.zeroLineWidth=[4,4],this.zeroLineColor=[[0,0,0,1],[0,0,0,1]],this.borderLineEnable=[!0,!0,!0,!0],this.borderLineWidth=[2,2,2,2],this.borderLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.grid=null,this.text=null,this.line=null,this.box=null,this.objects=[],this.overlays=[],this._tickBounds=[1/0,1/0,-1/0,-1/0],this.static=!1,this.dirty=!1,this.pickDirty=!1,this.pickDelay=120,this.pickRadius=10,this._pickTimeout=null,this._drawPick=this.drawPick.bind(this),this._depthCounter=0}function i(t){for(var e=t.slice(),r=0;r<e.length;++r)e[r]=e[r].slice();return e}function a(t,e){return t.x-e.x}function o(t){var e=t.gl,r=s(e,[e.drawingBufferWidth,e.drawingBufferHeight]),i=new n(e,r);return i.grid=l(i),i.text=u(i),i.line=c(i),i.box=h(i),i.update(t),i}e.exports=o;var s=t(\"gl-select-static\"),l=t(\"./lib/grid\"),u=t(\"./lib/text\"),c=t(\"./lib/line\"),h=t(\"./lib/box\"),f=n.prototype;f.setDirty=function(){this.dirty=this.pickDirty=!0},f.setOverlayDirty=function(){this.dirty=!0},f.nextDepthValue=function(){return this._depthCounter++/65536},f.draw=function(){return function(){var t=this.gl,e=this.screenBox,r=this.viewBox,n=this.dataBox,i=this.pixelRatio,a=this.grid,o=this.line,s=this.text,l=this.objects;if(this._depthCounter=0,this.pickDirty&&(this._pickTimeout&&clearTimeout(this._pickTimeout),this.pickDirty=!1,this._pickTimeout=setTimeout(this._drawPick,this.pickDelay)),this.dirty){this.dirty=!1,t.bindFramebuffer(t.FRAMEBUFFER,null),t.enable(t.SCISSOR_TEST),t.disable(t.DEPTH_TEST),t.depthFunc(t.LESS),t.depthMask(!1),t.enable(t.BLEND),t.blendEquation(t.FUNC_ADD,t.FUNC_ADD),t.blendFunc(t.ONE,t.ONE_MINUS_SRC_ALPHA),t.scissor(e[0],e[1],e[2]-e[0],e[3]-e[1]);var u=this.borderColor;t.clearColor(u[0]*u[3],u[1]*u[3],u[2]*u[3],u[3]),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT),t.scissor(r[0],r[1],r[2]-r[0],r[3]-r[1]),t.viewport(r[0],r[1],r[2]-r[0],r[3]-r[1]);var c=this.backgroundColor;t.clearColor(c[0]*c[3],c[1]*c[3],c[2]*c[3],c[3]),t.clear(t.COLOR_BUFFER_BIT),a.draw();var h=this.zeroLineEnable,f=this.zeroLineColor,d=this.zeroLineWidth;if(h[0]||h[1]){o.bind();for(var p=0;p<2;++p)if(h[p]&&n[p]<=0&&n[p+2]>=0){var m=e[p]-n[p]*(e[p+2]-e[p])/(n[p+2]-n[p]);0===p?o.drawLine(m,e[1],m,e[3],d[p],f[p]):o.drawLine(e[0],m,e[2],m,d[p],f[p])}}for(var p=0;p<l.length;++p)l[p].draw();t.viewport(e[0],e[1],e[2]-e[0],e[3]-e[1]),t.scissor(e[0],e[1],e[2]-e[0],e[3]-e[1]),this.grid.drawTickMarks(),o.bind();var v=this.borderLineEnable,g=this.borderLineWidth,y=this.borderLineColor;v[1]&&o.drawLine(r[0],r[1]-.5*g[1]*i,r[0],r[3]+.5*g[3]*i,g[1],y[1]),v[0]&&o.drawLine(r[0]-.5*g[0]*i,r[1],r[2]+.5*g[2]*i,r[1],g[0],y[0]),v[3]&&o.drawLine(r[2],r[1]-.5*g[1]*i,r[2],r[3]+.5*g[3]*i,g[3],y[3]),v[2]&&o.drawLine(r[0]-.5*g[0]*i,r[3],r[2]+.5*g[2]*i,r[3],g[2],y[2]),s.bind();for(var p=0;p<2;++p)s.drawTicks(p);this.titleEnable&&s.drawTitle();for(var b=this.overlays,p=0;p<b.length;++p)b[p].draw();t.disable(t.SCISSOR_TEST),t.disable(t.BLEND),t.depthMask(!0)}}}(),f.drawPick=function(){return function(){if(!this.static){var t=this.pickBuffer;this.gl;this._pickTimeout=null,t.begin();for(var e=1,r=this.objects,n=0;n<r.length;++n)e=r[n].drawPick(e);t.end()}}}(),f.pick=function(){return function(t,e){if(!this.static){var r=this.pixelRatio,n=this.pickPixelRatio,i=this.viewBox,a=0|Math.round((t-i[0]/r)*n),o=0|Math.round((e-i[1]/r)*n),s=this.pickBuffer.query(a,o,this.pickRadius);if(!s)return null;for(var l=s.id+(s.value[0]<<8)+(s.value[1]<<16)+(s.value[2]<<24),u=this.objects,c=0;c<u.length;++c){var h=u[c].pick(a,o,l);if(h)return h}return null}}}(),f.setScreenBox=function(t){var e=this.screenBox,r=this.pixelRatio;e[0]=0|Math.round(t[0]*r),e[1]=0|Math.round(t[1]*r),e[2]=0|Math.round(t[2]*r),e[3]=0|Math.round(t[3]*r),this.setDirty()},f.setDataBox=function(t){var e=this.dataBox;(e[0]!==t[0]||e[1]!==t[1]||e[2]!==t[2]||e[3]!==t[3])&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],this.setDirty())},f.setViewBox=function(t){var e=this.pixelRatio,r=this.viewBox;r[0]=0|Math.round(t[0]*e),r[1]=0|Math.round(t[1]*e),r[2]=0|Math.round(t[2]*e),r[3]=0|Math.round(t[3]*e);var n=this.pickPixelRatio;this.pickBuffer.shape=[0|Math.round((t[2]-t[0])*n),0|Math.round((t[3]-t[1])*n)],this.setDirty()},f.update=function(t){t=t||{};var e=this.gl;this.pixelRatio=t.pixelRatio||1;var r=this.pixelRatio;this.pickPixelRatio=Math.max(r,1),this.setScreenBox(t.screenBox||[0,0,e.drawingBufferWidth/r,e.drawingBufferHeight/r]);this.screenBox;this.setViewBox(t.viewBox||[.125*(this.screenBox[2]-this.screenBox[0])/r,.125*(this.screenBox[3]-this.screenBox[1])/r,.875*(this.screenBox[2]-this.screenBox[0])/r,.875*(this.screenBox[3]-this.screenBox[1])/r]);var n=this.viewBox,o=(n[2]-n[0])/(n[3]-n[1]);this.setDataBox(t.dataBox||[-10,-10/o,10,10/o]),this.borderColor=(t.borderColor||[0,0,0,0]).slice(),this.backgroundColor=(t.backgroundColor||[0,0,0,0]).slice(),this.gridLineEnable=(t.gridLineEnable||[!0,!0]).slice(),this.gridLineWidth=(t.gridLineWidth||[1,1]).slice(),this.gridLineColor=i(t.gridLineColor||[[.5,.5,.5,1],[.5,.5,.5,1]]),this.zeroLineEnable=(t.zeroLineEnable||[!0,!0]).slice(),this.zeroLineWidth=(t.zeroLineWidth||[4,4]).slice(),this.zeroLineColor=i(t.zeroLineColor||[[0,0,0,1],[0,0,0,1]]),this.tickMarkLength=(t.tickMarkLength||[0,0,0,0]).slice(),this.tickMarkWidth=(t.tickMarkWidth||[0,0,0,0]).slice(),this.tickMarkColor=i(t.tickMarkColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.titleCenter=(t.titleCenter||[.5*(n[0]+n[2])/r,(n[3]+120)/r]).slice(),this.titleEnable=!(\"titleEnable\"in t&&!t.titleEnable),this.titleAngle=t.titleAngle||0,this.titleColor=(t.titleColor||[0,0,0,1]).slice(),this.labelPad=(t.labelPad||[15,15,15,15]).slice(),this.labelAngle=(t.labelAngle||[0,Math.PI/2,0,3*Math.PI/2]).slice(),this.labelEnable=(t.labelEnable||[!0,!0,!0,!0]).slice(),this.labelColor=i(t.labelColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.tickPad=(t.tickPad||[15,15,15,15]).slice(),this.tickAngle=(t.tickAngle||[0,0,0,0]).slice(),this.tickEnable=(t.tickEnable||[!0,!0,!0,!0]).slice(),this.tickColor=i(t.tickColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.borderLineEnable=(t.borderLineEnable||[!0,!0,!0,!0]).slice(),this.borderLineWidth=(t.borderLineWidth||[2,2,2,2]).slice(),this.borderLineColor=i(t.borderLineColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]);var s=t.ticks||[[],[]],l=this._tickBounds;l[0]=l[1]=1/0,l[2]=l[3]=-1/0;for(var u=0;u<2;++u){var c=s[u].slice(0);0!==c.length&&(c.sort(a),l[u]=Math.min(l[u],c[0].x),l[u+2]=Math.max(l[u+2],c[c.length-1].x))}this.grid.update({bounds:l,ticks:s}),this.text.update({bounds:l,ticks:s,labels:t.labels||[\"x\",\"y\"],labelSize:t.labelSize||[12,12],labelFont:t.labelFont||[\"sans-serif\",\"sans-serif\"],title:t.title||\"\",titleSize:t.titleSize||18,titleFont:t.titleFont||\"sans-serif\"}),this.static=!!t.static,this.setDirty()},f.dispose=function(){this.box.dispose(),this.grid.dispose(),this.text.dispose(),this.line.dispose();for(var t=this.objects.length-1;t>=0;--t)this.objects[t].dispose();this.objects.length=0;for(var t=this.overlays.length-1;t>=0;--t)this.overlays[t].dispose();this.overlays.length=0,this.gl=null},f.addObject=function(t){this.objects.indexOf(t)<0&&(this.objects.push(t),this.setDirty())},f.removeObject=function(t){for(var e=this.objects,r=0;r<e.length;++r)if(e[r]===t){e.splice(r,1),this.setDirty();break}},f.addOverlay=function(t){this.overlays.indexOf(t)<0&&(this.overlays.push(t),this.setOverlayDirty())},f.removeOverlay=function(t){for(var e=this.overlays,r=0;r<e.length;++r)if(e[r]===t){e.splice(r,1),this.setOverlayDirty();break}}},{\"./lib/box\":205,\"./lib/grid\":206,\"./lib/line\":207,\"./lib/text\":209,\"gl-select-static\":253}],219:[function(t,e,r){var n=t(\"gl-shader\");e.exports=function(t){return n(t,\"precision mediump float;\\n#define GLSLIFY 1\\nattribute vec2 position;\\nvarying vec2 uv;\\nvoid main() {\\n  uv = position;\\n  gl_Position = vec4(position, 0, 1);\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D accumBuffer;\\nvarying vec2 uv;\\n\\nvoid main() {\\n  vec4 accum = texture2D(accumBuffer, 0.5 * (uv + 1.0));\\n  gl_FragColor = min(vec4(1,1,1,1), accum);\\n}\",null,[{name:\"position\",type:\"vec2\"}])}},{\"gl-shader\":254}],220:[function(t,e,r){\"use strict\";function n(){this.mouse=[-1,-1],this.screen=null,this.distance=1/0,this.index=null,this.dataCoordinate=null,this.dataPosition=null,this.object=null,this.data=null}function i(t,e){var r=null;try{r=t.getContext(\"webgl\",e),r||(r=t.getContext(\"experimental-webgl\",e))}catch(t){return null}return r}function a(t){var e=Math.round(Math.log(Math.abs(t))/Math.log(10));if(e<0){var r=Math.round(Math.pow(10,-e));return Math.ceil(t*r)/r}if(e>0){var r=Math.round(Math.pow(10,e));return Math.ceil(t/r)*r}return Math.ceil(t)}function o(t){return\"boolean\"!=typeof t||t}function s(t){function e(){if(!w&&G.autoResize){var t=M.parentNode,e=1,r=1;t&&t!==document.body?(e=t.clientWidth,r=t.clientHeight):(e=window.innerWidth,r=window.innerHeight);var n=0|Math.ceil(e*G.pixelRatio),i=0|Math.ceil(r*G.pixelRatio);if(n!==M.width||i!==M.height){M.width=n,M.height=i;var a=M.style;a.position=a.position||\"absolute\",a.left=\"0px\",a.top=\"0px\",a.width=e+\"px\",a.height=r+\"px\",N=!0}}}function r(){for(var t=O.length,e=j.length,r=0;r<e;++r)F[r]=0;t:for(var r=0;r<t;++r){var n=O[r],i=n.pickSlots;if(i){for(var a=0;a<e;++a)if(F[a]+i<255){R[r]=a,n.setPickBase(F[a]+1),F[a]+=i;continue t}var o=f(A,q);R[r]=e,j.push(o),F.push(i),n.setPickBase(1),e+=1}else R[r]=-1}for(;e>0&&0===F[e-1];)F.pop(),j.pop().dispose()}function s(){if(G.contextLost)return!0;A.isContextLost()&&(G.contextLost=!0,G.mouseListener.enabled=!1,G.selection.object=null,G.oncontextloss&&G.oncontextloss())}function b(){if(!s()){A.colorMask(!0,!0,!0,!0),A.depthMask(!0),A.disable(A.BLEND),A.enable(A.DEPTH_TEST);for(var t=O.length,e=j.length,r=0;r<e;++r){var n=j[r];n.shape=Y,n.begin();for(var i=0;i<t;++i)if(R[i]===r){var a=O[i];a.drawPick&&(a.pixelRatio=1,a.drawPick(H))}n.end()}}}function x(){if(!s()){e();var t=G.camera.tick();H.view=G.camera.matrix,N=N||t,B=B||t,I.pixelRatio=G.pixelRatio,P.pixelRatio=G.pixelRatio;var r=O.length,n=Z[0],i=Z[1];n[0]=n[1]=n[2]=1/0,i[0]=i[1]=i[2]=-1/0;for(var o=0;o<r;++o){var l=O[o];l.pixelRatio=G.pixelRatio,l.axes=G.axes,N=N||!!l.dirty,B=B||!!l.dirty;var u=l.bounds;if(u)for(var h=u[0],f=u[1],d=0;d<3;++d)n[d]=Math.min(n[d],h[d]),i[d]=Math.max(i[d],f[d])}var m=G.bounds;if(G.autoBounds)for(var d=0;d<3;++d){if(i[d]<n[d])n[d]=-1,i[d]=1;else{n[d]===i[d]&&(n[d]-=1,i[d]+=1);var g=.05*(i[d]-n[d]);n[d]=n[d]-g,i[d]=i[d]+g}m[0][d]=n[d],m[1][d]=i[d]}for(var y=!1,d=0;d<3;++d)y=y||J[0][d]!==m[0][d]||J[1][d]!==m[1][d],J[0][d]=m[0][d],J[1][d]=m[1][d];if(B=B||y,N=N||y){if(y){for(var x=[0,0,0],o=0;o<3;++o)x[o]=a((m[1][o]-m[0][o])/10);I.autoTicks?I.update({bounds:m,tickSpacing:x}):I.update({bounds:m})}var _=A.drawingBufferWidth,w=A.drawingBufferHeight;q[0]=_,q[1]=w,Y[0]=0|Math.max(_/G.pixelRatio,1),Y[1]=0|Math.max(w/G.pixelRatio,1),v(U,G.fovy,_/w,G.zNear,G.zFar);for(var o=0;o<16;++o)V[o]=0;V[15]=1;for(var M=0,o=0;o<3;++o)M=Math.max(M,m[1][o]-m[0][o]);for(var o=0;o<3;++o)G.autoScale?V[5*o]=G.aspect[o]/(m[1][o]-m[0][o]):V[5*o]=1/M,G.autoCenter&&(V[12+o]=.5*-V[5*o]*(m[0][o]+m[1][o]));for(var o=0;o<r;++o){var l=O[o];l.axesBounds=m,G.clipToBounds&&(l.clipBounds=m)}S.object&&(G.snapToData?P.position=S.dataCoordinate:P.position=S.dataPosition,P.bounds=m),B&&(B=!1,b()),G.axesPixels=c(G.axes,H,_,w),G.onrender&&G.onrender(),A.bindFramebuffer(A.FRAMEBUFFER,null),A.viewport(0,0,_,w);var k=G.clearColor;A.clearColor(k[0],k[1],k[2],k[3]),A.clear(A.COLOR_BUFFER_BIT|A.DEPTH_BUFFER_BIT),A.depthMask(!0),A.colorMask(!0,!0,!0,!0),A.enable(A.DEPTH_TEST),A.depthFunc(A.LEQUAL),A.disable(A.BLEND),A.disable(A.CULL_FACE);var T=!1;I.enable&&(T=T||I.isTransparent(),I.draw(H)),P.axes=I,S.object&&P.draw(H),A.disable(A.CULL_FACE);for(var o=0;o<r;++o){var l=O[o];l.axes=I,l.pixelRatio=G.pixelRatio,l.isOpaque&&l.isOpaque()&&l.draw(H),l.isTransparent&&l.isTransparent()&&(T=!0)}if(T){E.shape=q,E.bind(),A.clear(A.DEPTH_BUFFER_BIT),A.colorMask(!1,!1,!1,!1),A.depthMask(!0),A.depthFunc(A.LESS),I.enable&&I.isTransparent()&&I.drawTransparent(H);for(var o=0;o<r;++o){var l=O[o];l.isOpaque&&l.isOpaque()&&l.draw(H)}A.enable(A.BLEND),A.blendEquation(A.FUNC_ADD),A.blendFunc(A.ONE,A.ONE_MINUS_SRC_ALPHA),A.colorMask(!0,!0,!0,!0),A.depthMask(!1),A.clearColor(0,0,0,0),A.clear(A.COLOR_BUFFER_BIT),I.isTransparent()&&I.drawTransparent(H);for(var o=0;o<r;++o){var l=O[o];l.isTransparent&&l.isTransparent()&&l.drawTransparent(H)}A.bindFramebuffer(A.FRAMEBUFFER,null),A.blendFunc(A.ONE,A.ONE_MINUS_SRC_ALPHA),A.disable(A.DEPTH_TEST),L.bind(),E.color[0].bind(0),L.uniforms.accumBuffer=0,p(A),A.disable(A.BLEND)}N=!1;for(var o=0;o<r;++o)O[o].dirty=!1}}}function _(){w||G.contextLost||(requestAnimationFrame(_),x())}t=t||{};var w=!1,M=(t.pixelRatio||parseFloat(window.devicePixelRatio),t.canvas);if(!M)if(M=document.createElement(\"canvas\"),t.container){var k=t.container;k.appendChild(M)}else document.body.appendChild(M);var A=t.gl;if(A||(A=i(M,t.glOptions||{premultipliedAlpha:!0,antialias:!0})),!A)throw new Error(\"webgl not supported\");var T=t.bounds||[[-10,-10,-10],[10,10,10]],S=new n,E=d(A,[A.drawingBufferWidth,A.drawingBufferHeight],{preferFloat:!y}),L=g(A),C=t.camera||{eye:[2,0,0],center:[0,0,0],up:[0,1,0],zoomMin:.1,zoomMax:100,mode:\"turntable\"},z=t.axes||{},I=u(A,z);I.enable=!z.disable;var D=t.spikes||{},P=h(A,D),O=[],R=[],F=[],j=[],N=!0,B=!0,U=new Array(16),V=new Array(16),H={view:null,projection:U,model:V},B=!0,q=[A.drawingBufferWidth,A.drawingBufferHeight],G={gl:A,contextLost:!1,pixelRatio:t.pixelRatio||parseFloat(window.devicePixelRatio),canvas:M,selection:S,camera:l(M,C),axes:I,axesPixels:null,spikes:P,bounds:T,objects:O,shape:q,aspect:t.aspectRatio||[1,1,1],pickRadius:t.pickRadius||10,zNear:t.zNear||.01,zFar:t.zFar||1e3,fovy:t.fovy||Math.PI/4,clearColor:t.clearColor||[0,0,0,0],autoResize:o(t.autoResize),autoBounds:o(t.autoBounds),autoScale:!!t.autoScale,autoCenter:o(t.autoCenter),clipToBounds:o(t.clipToBounds),snapToData:!!t.snapToData,onselect:t.onselect||null,onrender:t.onrender||null,onclick:t.onclick||null,cameraParams:H,oncontextloss:null,mouseListener:null},Y=[A.drawingBufferWidth/G.pixelRatio|0,A.drawingBufferHeight/G.pixelRatio|0];G.autoResize&&e(),window.addEventListener(\"resize\",e),G.update=function(t){w||(t=t||{},N=!0,B=!0)},G.add=function(t){w||(t.axes=I,O.push(t),R.push(-1),N=!0,B=!0,r())},G.remove=function(t){if(!w){var e=O.indexOf(t);e<0||(O.splice(e,1),R.pop(),N=!0,B=!0,r())}},G.dispose=function(){if(!w&&(w=!0,window.removeEventListener(\"resize\",e),M.removeEventListener(\"webglcontextlost\",s),G.mouseListener.enabled=!1,!G.contextLost)){I.dispose(),P.dispose();for(var t=0;t<O.length;++t)O[t].dispose();E.dispose();for(var t=0;t<j.length;++t)j[t].dispose();L.dispose(),A=null,I=null,P=null,O=[]}};var X=!1,W=0;G.mouseListener=m(M,function(t,e,r){if(!w){var n=j.length,i=O.length,a=S.object;S.distance=1/0,S.mouse[0]=e,S.mouse[1]=r,S.object=null,S.screen=null,S.dataCoordinate=S.dataPosition=null;var o=!1;if(t&&W)X=!0;else{X&&(B=!0),X=!1;for(var s=0;s<n;++s){var l=j[s].query(e,Y[1]-r-1,G.pickRadius);if(l){if(l.distance>S.distance)continue;for(var u=0;u<i;++u){var c=O[u];if(R[u]===s){var h=c.pick(l);h&&(S.buttons=t,S.screen=l.coord,S.distance=l.distance,S.object=c,S.index=h.distance,S.dataPosition=h.position,S.dataCoordinate=h.dataCoordinate,S.data=h,o=!0)}}}}}a&&a!==S.object&&(a.highlight&&a.highlight(null),N=!0),S.object&&(S.object.highlight&&S.object.highlight(S.data),N=!0),o=o||S.object!==a,o&&G.onselect&&G.onselect(S),1&t&&!(1&W)&&G.onclick&&G.onclick(S),W=t}}),M.addEventListener(\"webglcontextlost\",s);var Z=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],J=[Z[0].slice(),Z[1].slice()];return _(),G.redraw=function(){w||(N=!0,x())},G}e.exports=s;var l=t(\"3d-view-controls\"),u=t(\"gl-axes3d\"),c=t(\"gl-axes3d/properties\"),h=t(\"gl-spikes3d\"),f=t(\"gl-select-static\"),d=t(\"gl-fbo\"),p=t(\"a-big-triangle\"),m=t(\"mouse-change\"),v=t(\"gl-mat4/perspective\"),g=t(\"./lib/shader\"),y=t(\"is-mobile\")()},{\"./lib/shader\":219,\"3d-view-controls\":35,\"a-big-triangle\":38,\"gl-axes3d\":147,\"gl-axes3d/properties\":154,\"gl-fbo\":163,\"gl-mat4/perspective\":183,\"gl-select-static\":253,\"gl-spikes3d\":263,\"is-mobile\":295,\"mouse-change\":451}],221:[function(t,e,r){r.pointVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\n\\nuniform mat3 matrix;\\nuniform float pointSize;\\nuniform float pointCloud;\\n\\nhighp float rand(vec2 co) {\\n  highp float a = 12.9898;\\n  highp float b = 78.233;\\n  highp float c = 43758.5453;\\n  highp float d = dot(co.xy, vec2(a, b));\\n  highp float e = mod(d, 3.14);\\n  return fract(sin(e) * c);\\n}\\n\\nvoid main() {\\n  vec3 hgPosition = matrix * vec3(position, 1);\\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\\n    // if we don't jitter the point size a bit, overall point cloud\\n    // saturation 'jumps' on zooming, which is disturbing and confusing\\n  gl_PointSize = pointSize * ((19.5 + rand(position)) / 20.0);\\n  if(pointCloud != 0.0) { // pointCloud is truthy\\n    // get the same square surface as circle would be\\n    gl_PointSize *= 0.886;\\n  }\\n}\",r.pointFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color, borderColor;\\nuniform float centerFraction;\\nuniform float pointCloud;\\n\\nvoid main() {\\n  float radius;\\n  vec4 baseColor;\\n  if(pointCloud != 0.0) { // pointCloud is truthy\\n    if(centerFraction == 1.0) {\\n      gl_FragColor = color;\\n    } else {\\n      gl_FragColor = mix(borderColor, color, centerFraction);\\n    }\\n  } else {\\n    radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n    if(radius > 1.0) {\\n      discard;\\n    }\\n    baseColor = mix(borderColor, color, step(radius, centerFraction));\\n    gl_FragColor = vec4(baseColor.rgb * baseColor.a, baseColor.a);\\n  }\\n}\\n\",r.pickVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 pickId;\\n\\nuniform mat3 matrix;\\nuniform float pointSize;\\nuniform vec4 pickOffset;\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  vec3 hgPosition = matrix * vec3(position, 1);\\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\\n  gl_PointSize = pointSize;\\n\\n  vec4 id = pickId + pickOffset;\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  fragId = id;\\n}\\n\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  float radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  gl_FragColor = fragId / 255.0;\\n}\\n\"},{}],222:[function(t,e,r){arguments[4][211][0].apply(r,arguments)},{\"./lib/GLError\":223,\"./lib/create-attributes\":224,\"./lib/create-uniforms\":225,\"./lib/reflect\":226,\"./lib/runtime-reflect\":227,\"./lib/shader-cache\":228,dup:211}],223:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],224:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\n",
       "\"./GLError\":223,dup:213}],225:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":223,\"./reflect\":226,dup:214}],226:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],227:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],228:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":223,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],229:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.plot=t,this.offsetBuffer=e,this.pickBuffer=r,this.shader=n,this.pickShader=i,this.sizeMin=.5,this.sizeMinCap=2,this.sizeMax=20,this.areaRatio=1,this.pointCount=0,this.color=[1,0,0,1],this.borderColor=[0,0,0,1],this.blend=!1,this.pickOffset=0,this.points=null}function i(t,e){var r,n=0,i=t.length>>>1;for(r=0;r<i;r++){var a=t[2*r],o=t[2*r+1];a>=e[0]&&a<=e[2]&&o>=e[1]&&o<=e[3]&&n++}return n}function a(t,e){var r=t.gl,i=s(r),a=s(r),l=o(r,u.pointVertex,u.pointFragment),c=o(r,u.pickVertex,u.pickFragment),h=new n(t,i,a,l,c);return h.update(e),t.addObject(h),h}var o=t(\"gl-shader\"),s=t(\"gl-buffer\"),l=t(\"typedarray-pool\"),u=t(\"./lib/shader\");e.exports=a;var c=n.prototype;c.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.offsetBuffer.dispose(),this.pickBuffer.dispose(),this.plot.removeObject(this)},c.update=function(t){function e(e,r){return e in t?t[e]:r}var r;t=t||{},this.sizeMin=e(\"sizeMin\",.5),this.sizeMax=e(\"sizeMax\",20),this.color=e(\"color\",[1,0,0,1]).slice(),this.areaRatio=e(\"areaRatio\",1),this.borderColor=e(\"borderColor\",[0,0,0,1]).slice(),this.blend=e(\"blend\",!1);var n=t.positions.length>>>1,i=t.positions instanceof Float32Array,a=t.idToIndex instanceof Int32Array&&t.idToIndex.length>=n,o=t.positions,s=i?o:l.mallocFloat32(o.length),u=a?t.idToIndex:l.mallocInt32(n);if(i||s.set(o),!a)for(s.set(o),r=0;r<n;r++)u[r]=r;this.points=o,this.offsetBuffer.update(s),this.pickBuffer.update(u),i||l.free(s),a||l.free(u),this.pointCount=n,this.pickOffset=0},c.unifiedDraw=function(){var t=[1,0,0,0,1,0,0,0,1],e=[0,0,0,0];return function(r){var n=void 0!==r,a=n?this.pickShader:this.shader,o=this.plot.gl,s=this.plot.dataBox;if(0===this.pointCount)return r;var l=s[2]-s[0],u=s[3]-s[1],c=i(this.points,s),h=this.plot.pickPixelRatio*Math.max(Math.min(this.sizeMinCap,this.sizeMin),Math.min(this.sizeMax,this.sizeMax/Math.pow(c,.33333)));t[0]=2/l,t[4]=2/u,t[6]=-2*s[0]/l-1,t[7]=-2*s[1]/u-1,this.offsetBuffer.bind(),a.bind(),a.attributes.position.pointer(),a.uniforms.matrix=t,a.uniforms.color=this.color,a.uniforms.borderColor=this.borderColor,a.uniforms.pointCloud=h<5,a.uniforms.pointSize=h,a.uniforms.centerFraction=Math.min(1,Math.max(0,Math.sqrt(1-this.areaRatio))),n&&(e[0]=255&r,e[1]=r>>8&255,e[2]=r>>16&255,e[3]=r>>24&255,this.pickBuffer.bind(),a.attributes.pickId.pointer(o.UNSIGNED_BYTE),a.uniforms.pickOffset=e,this.pickOffset=r);var f=o.getParameter(o.BLEND),d=o.getParameter(o.DITHER);return f&&!this.blend&&o.disable(o.BLEND),d&&o.disable(o.DITHER),o.drawArrays(o.POINTS,0,this.pointCount),f&&!this.blend&&o.enable(o.BLEND),d&&o.enable(o.DITHER),r+this.pointCount}}(),c.draw=c.unifiedDraw,c.drawPick=c.unifiedDraw,c.pick=function(t,e,r){var n=this.pickOffset,i=this.pointCount;if(r<n||r>=n+i)return null;var a=r-n,o=this.points;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}}},{\"./lib/shader\":221,\"gl-buffer\":155,\"gl-shader\":222,\"typedarray-pool\":540}],230:[function(t,e,r){function n(t,e,r,n){var i,a,o,s,l,u=e[0],c=e[1],h=e[2],f=e[3],d=r[0],p=r[1],m=r[2],v=r[3];return a=u*d+c*p+h*m+f*v,a<0&&(a=-a,d=-d,p=-p,m=-m,v=-v),1-a>1e-6?(i=Math.acos(a),o=Math.sin(i),s=Math.sin((1-n)*i)/o,l=Math.sin(n*i)/o):(s=1-n,l=n),t[0]=s*u+l*d,t[1]=s*c+l*p,t[2]=s*h+l*m,t[3]=s*f+l*v,t}e.exports=n},{}],231:[function(t,e,r){\"use strict\";e.exports={vertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\n\\nvec4 computePosition_1_0(vec2 posHi, vec2 posLo, vec2 scHi, vec2 scLo, vec2 trHi, vec2 trLo) {\\n  return vec4((posHi + trHi) * scHi\\n  \\t\\t\\t//FIXME: this thingy does not give noticeable precision gain, need test\\n            + (posLo + trLo) * scHi\\n            + (posHi + trHi) * scLo\\n            + (posLo + trLo) * scLo\\n            , 0, 1);\\n}\\n\\n\\nattribute vec2 positionHi, positionLo;\\nattribute float size, border;\\nattribute vec2 char, color;\\n\\n//this is 64-bit form of scale and translate\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pixelRatio;\\nuniform vec4 viewBox;\\nuniform sampler2D palette;\\n\\nvarying vec4 charColor, borderColor;\\nvarying vec2 charId;\\nvarying vec2 pointCoord;\\nvarying float pointSize;\\nvarying float borderWidth;\\n\\n\\nvoid main() {\\n  charColor = texture2D(palette, vec2(color.x / 255., 0));\\n  borderColor = texture2D(palette, vec2(color.y / 255., 0));\\n\\n  gl_PointSize = size * pixelRatio;\\n  pointSize = size * pixelRatio;\\n\\n  charId = char;\\n  borderWidth = border;\\n\\n  gl_Position = computePosition_1_0(\\n    positionHi, positionLo,\\n    scaleHi, scaleLo,\\n    translateHi, translateLo);\\n\\n  pointCoord = viewBox.xy + (viewBox.zw - viewBox.xy) * (gl_Position.xy * .5 + .5);\\n}\\n\",fragment:\"precision highp float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D chars;\\nuniform vec2 charsShape;\\nuniform float charsStep, pixelRatio, charOffset;\\n\\nvarying vec4 borderColor;\\nvarying vec4 charColor;\\nvarying vec2 charId;\\nvarying vec2 pointCoord;\\nvarying float pointSize;\\nvarying float borderWidth;\\n\\nvoid main() {\\n\\tvec2 pointUV = (pointCoord - gl_FragCoord.xy + pointSize * .5) / pointSize;\\n\\tpointUV.x = 1. - pointUV.x;\\n\\tvec2 texCoord = ((charId + pointUV) * charsStep) / charsShape;\\n\\tfloat dist = texture2D(chars, texCoord).r;\\n\\n\\t//max-distance alpha\\n\\tif (dist < 1e-2)\\n\\t\\tdiscard;\\n\\n\\tfloat gamma = .0045 * charsStep / pointSize;\\n\\n    //null-border case\\n \\tif (borderWidth * borderColor.a == 0.) {\\n\\t\\tfloat charAmt = smoothstep(.748 - gamma, .748 + gamma, dist);\\n\\t\\tgl_FragColor = vec4(charColor.rgb, charAmt*charColor.a);\\n\\t\\treturn;\\n\\t}\\n\\n\\tfloat dif = 5. * pixelRatio * borderWidth / pointSize;\\n\\tfloat borderLevel = .748 - dif * .5;\\n\\tfloat charLevel = .748 + dif * .5;\\n\\n\\tfloat borderAmt = smoothstep(borderLevel - gamma, borderLevel + gamma, dist);\\n\\tfloat charAmt = smoothstep(charLevel - gamma, charLevel + gamma, dist);\\n\\n\\tvec4 color = borderColor;\\n\\tcolor.a *= borderAmt;\\n\\n\\tgl_FragColor = mix(color, charColor, charAmt);\\n}\\n\",pickVertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi, positionLo;\\nattribute vec4 id;\\nattribute float size;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform vec4 pickOffset;\\nuniform float pixelRatio;\\n\\nvarying vec4 fragColor;\\n\\n\\nvec4 computePosition_1_0(vec2 posHi, vec2 posLo, vec2 scHi, vec2 scLo, vec2 trHi, vec2 trLo) {\\n  return vec4((posHi + trHi) * scHi\\n  \\t\\t\\t//FIXME: this thingy does not give noticeable precision gain, need test\\n            + (posLo + trLo) * scHi\\n            + (posHi + trHi) * scLo\\n            + (posLo + trLo) * scLo\\n            , 0, 1);\\n}\\n\\n\\nvoid main() {\\n  vec4 fragId = id + pickOffset;\\n\\n  fragId.y += floor(fragId.x / 256.0);\\n  fragId.x -= floor(fragId.x / 256.0) * 256.0;\\n\\n  fragId.z += floor(fragId.y / 256.0);\\n  fragId.y -= floor(fragId.y / 256.0) * 256.0;\\n\\n  fragId.w += floor(fragId.z / 256.0);\\n  fragId.z -= floor(fragId.z / 256.0) * 256.0;\\n\\n  fragColor = fragId / 255.0;\\n\\n  gl_PointSize = size * .25 * pixelRatio;\\n\\n  gl_Position = computePosition_1_0(\\n    positionHi, positionLo,\\n    scaleHi, scaleLo,\\n    translateHi, translateLo);\\n}\\n\",pickFragment:\"precision lowp float;\\n#define GLSLIFY 1\\nvarying vec4 fragColor;\\nvoid main() {\\n  gl_FragColor = fragColor;\\n}\\n\"}},{}],232:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],233:[function(t,e,r){arguments[4][211][0].apply(r,arguments)},{\"./lib/GLError\":234,\"./lib/create-attributes\":235,\"./lib/create-uniforms\":236,\"./lib/reflect\":237,\"./lib/runtime-reflect\":238,\"./lib/shader-cache\":239,dup:211}],234:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],235:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\"./GLError\":234,dup:213}],236:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":234,\"./reflect\":237,dup:214}],237:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],238:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],239:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":234,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],240:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){a<=4*f?i(0,a-1,t,e,r,n):h(0,a-1,t,e,r,n)}function i(t,e,r,n,i,a){for(var o=t+1;o<=e;++o){for(var s=r[o],l=n[2*o],u=n[2*o+1],c=i[o],h=a[o],f=o;f>t;){var d=r[f-1],p=n[2*(f-1)];if((d-s||l-p)>=0)break;r[f]=d,n[2*f]=p,n[2*f+1]=n[2*f-1],i[f]=i[f-1],a[f]=a[f-1],f-=1}r[f]=s,n[2*f]=l,n[2*f+1]=u,i[f]=c,a[f]=h}}function a(t,e,r,n,i,a){var o=r[t],s=n[2*t],l=n[2*t+1],u=i[t],c=a[t];r[t]=r[e],n[2*t]=n[2*e],n[2*t+1]=n[2*e+1],i[t]=i[e],a[t]=a[e],r[e]=o,n[2*e]=s,n[2*e+1]=l,i[e]=u,a[e]=c}function o(t,e,r,n,i,a){r[t]=r[e],n[2*t]=n[2*e],n[2*t+1]=n[2*e+1],i[t]=i[e],a[t]=a[e]}function s(t,e,r,n,i,a,o){var s=n[t],l=i[2*t],u=i[2*t+1],c=a[t],h=o[t];n[t]=n[e],i[2*t]=i[2*e],i[2*t+1]=i[2*e+1],a[t]=a[e],o[t]=o[e],n[e]=n[r],i[2*e]=i[2*r],i[2*e+1]=i[2*r+1],a[e]=a[r],o[e]=o[r],n[r]=s,i[2*r]=l,i[2*r+1]=u,a[r]=c,o[r]=h}function l(t,e,r,n,i,a,o,s,l,u,c){s[t]=s[e],l[2*t]=l[2*e],l[2*t+1]=l[2*e+1],u[t]=u[e],c[t]=c[e],s[e]=r,l[2*e]=n,l[2*e+1]=i,u[e]=a,c[e]=o}function u(t,e,r,n,i){return(r[t]-r[e]||n[2*e]-n[2*t]||i[t]-i[e])<0}function c(t,e,r,n,i,a,o,s){return(e-a[t]||o[2*t]-r||i-s[t])<0}function h(t,e,r,n,d,p){var m=(e-t+1)/6|0,v=t+m,g=e-m,y=t+e>>1,b=y-m,x=y+m,_=v,w=b,M=y,k=x,A=g,T=t+1,S=e-1,E=0;u(_,w,r,n,d,p)&&(E=_,_=w,w=E),u(k,A,r,n,d,p)&&(E=k,k=A,A=E),u(_,M,r,n,d,p)&&(E=_,_=M,M=E),u(w,M,r,n,d,p)&&(E=w,w=M,M=E),u(_,k,r,n,d,p)&&(E=_,_=k,k=E),u(M,k,r,n,d,p)&&(E=M,M=k,k=E),u(w,A,r,n,d,p)&&(E=w,w=A,A=E),u(w,M,r,n,d,p)&&(E=w,w=M,M=E),u(k,A,r,n,d,p)&&(E=k,k=A,A=E);var L=r[w],C=n[2*w],z=n[2*w+1],I=d[w],D=p[w],P=r[k],O=n[2*k],R=n[2*k+1],F=d[k],j=p[k],N=_,B=M,U=A,V=v,H=y,q=g,G=r[N],Y=r[B],X=r[U];r[V]=G,r[H]=Y,r[q]=X;for(var W=0;W<2;++W){var Z=n[2*N+W],J=n[2*B+W],K=n[2*U+W];n[2*V+W]=Z,n[2*H+W]=J,n[2*q+W]=K}var Q=d[N],$=d[B],tt=d[U];d[V]=Q,d[H]=$,d[q]=tt;var et=p[N],rt=p[B],nt=p[U];p[V]=et,p[H]=rt,p[q]=nt,o(b,t,r,n,d,p),o(x,e,r,n,d,p);for(var it=T;it<=S;++it)if(c(it,L,C,z,I,r,n,d))it!==T&&a(it,T,r,n,d,p),++T;else if(!c(it,P,O,R,F,r,n,d))for(;;){if(c(S,P,O,R,F,r,n,d)){c(S,L,C,z,I,r,n,d)?(s(it,T,S,r,n,d,p),++T,--S):(a(it,S,r,n,d,p),--S);break}if(--S<it)break}l(t,T-1,L,C,z,I,D,r,n,d,p),l(e,S+1,P,O,R,F,j,r,n,d,p),T-2-t<=f?i(t,T-2,r,n,d,p):h(t,T-2,r,n,d,p),e-(S+2)<=f?i(S+2,e,r,n,d,p):h(S+2,e,r,n,d,p),S-T<=f?i(T,S,r,n,d,p):h(T,S,r,n,d,p)}e.exports=n;var f=32},{}],241:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){for(var l=r,u=r;u<n;++u){var c=t[2*u],h=t[2*u+1],f=e[u];i<=c&&c<=o&&a<=h&&h<=s&&(u===l?l+=1:(t[2*u]=t[2*l],t[2*u+1]=t[2*l+1],e[u]=e[l],t[2*l]=c,t[2*l+1]=h,e[l]=f,l+=1))}return l}function i(t,e,r){this.pixelSize=t,this.offset=e,this.count=r}function a(t,e,r,a){function l(i,a,o,s,u,c){var h=.5*o,f=s+1,d=u-s;r[_]=d,x[_++]=c;for(var p=0;p<2;++p)for(var m=0;m<2;++m){var v=i+p*h,g=a+m*h,y=n(t,e,f,u,v,g,v+h,g+h);if(y!==f){if(y-f>=Math.max(.9*d,32)){var b=u+s>>>1;l(v,g,h,f,b,c+1),f=b}l(v,g,h,f,y,c+1),f=y}}}var u=t.length>>>1;if(u<1)return[];for(var c=1/0,h=1/0,f=-1/0,d=-1/0,p=0;p<u;++p){var m=t[2*p],v=t[2*p+1];c=Math.min(c,m),f=Math.max(f,m),h=Math.min(h,v),d=Math.max(d,v),e[p]=p}c===f&&(f+=1+Math.abs(f)),h===d&&(d+=1+Math.abs(f));var g=1/(f-c),y=1/(d-h),b=Math.max(f-c,d-h);a=a||[0,0,0,0],a[0]=c,a[1]=h,a[2]=f,a[3]=d;var x=o.mallocInt32(u),_=0;l(c,h,b,0,u,0),s(x,t,e,r,u);for(var w=[],M=0,k=u,_=u-1;_>=0;--_){t[2*_]=(t[2*_]-c)*g,t[2*_+1]=(t[2*_+1]-h)*y;var A=x[_];A!==M&&(w.push(new i(b*Math.pow(.5,A),_+1,k-(_+1))),k=_+1,M=A)}return w.push(new i(b*Math.pow(.5,A+1),0,k)),o.free(x),w}var o=t(\"typedarray-pool\"),s=t(\"./lib/sort\");e.exports=a},{\"./lib/sort\":240,\"typedarray-pool\":540}],242:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){this.plot=t,this.shader=e,this.pickShader=r,this.positionBuffer=n,this.sizeBuffer=i,this.colorBuffer=a,this.idBuffer=o,this.charBuffer=s,this.pointCount=0,this.pickOffset=0,this.points=null,this.scales=[],this.xCoords=[],this.charCanvas=document.createElement(\"canvas\"),this.charTexture=m(this.plot.gl,this.charCanvas),this.charStep=400,this.charFit=.255,this.snapThreshold=1e4,this.paletteTexture=m(this.plot.gl,[256,1])}function i(){var t=this.plot,e=t.viewBox,r=t.dataBox,n=t.pixelRatio,i=r[2]-r[0],a=r[3]-r[1],u=2/i,c=2/a,h=-r[0]-.5*i,f=-r[1]-.5*a;_[0]=u,w[0]=u-_[0],_[1]=c,w[1]=c-_[1],M[0]=h,k[0]=h-M[0],M[1]=f,k[1]=f-M[1];var d=e[2]-e[0],p=e[3]-e[1];o=Math.min(i/d,a/p),A[0]=2*n/d,A[1]=2*n/p,s=r[0],l=r[2]}function a(t,e){var r=t.gl,i=u(r,f.vertex,f.fragment),a=u(r,f.pickVertex,f.pickFragment),o=c(r),s=c(r),l=c(r),h=c(r),d=c(r),p=new n(t,i,a,o,s,l,h,d);return p.update(e),t.addObject(p),p}e.exports=a;var o,s,l,u=t(\"gl-shader\"),c=t(\"gl-buffer\"),h=t(\"typedarray-pool\"),f=t(\"./lib/shaders\"),d=t(\"snap-points-2d\"),p=t(\"font-atlas-sdf\"),m=t(\"gl-texture2d\"),v=t(\"color-id\"),g=t(\"ndarray\"),y=t(\"clamp\"),b=t(\"binary-search-bounds\"),x=n.prototype,_=new Float32Array([0,0]),w=new Float32Array([0,0]),M=new Float32Array([0,0]),k=new Float32Array([0,0]),A=[0,0],T=[0,0,0,0];x.drawPick=function(t){var e=void 0!==t,r=this.plot,n=this.pointCount,a=n>this.snapThreshold;if(!n)return t;i.call(this);var u=r.gl,c=e?this.pickShader:this.shader,h=u.isEnabled(u.BLEND);if(c.bind(),e){this.pickOffset=t;for(var f=0;f<4;++f)T[f]=t>>8*f&255;c.uniforms.pickOffset=T,this.idBuffer.bind(),c.attributes.id.pointer(u.UNSIGNED_BYTE,!1)}else u.blendFuncSeparate(u.SRC_ALPHA,u.ONE_MINUS_SRC_ALPHA,u.ONE,u.ONE_MINUS_SRC_ALPHA),u.blendColor(0,0,0,1),h||u.enable(u.BLEND),this.colorBuffer.bind(),c.attributes.color.pointer(u.UNSIGNED_BYTE,!1),this.charBuffer.bind(),c.attributes.char.pointer(u.UNSIGNED_BYTE,!1),c.uniforms.chars=this.charTexture.bind(0),c.uniforms.charsShape=[this.charCanvas.width,this.charCanvas.height],c.uniforms.charsStep=this.charStep,c.uniforms.palette=this.paletteTexture.bind(1);this.sizeBuffer.bind(),c.attributes.size.pointer(u.FLOAT,!1,8,0),e||c.attributes.border.pointer(u.FLOAT,!1,8,4),this.positionBuffer.bind(),c.attributes.positionHi.pointer(u.FLOAT,!1,16,0),c.attributes.positionLo.pointer(u.FLOAT,!1,16,8),c.uniforms.pixelRatio=r.pixelRatio,c.uniforms.scaleHi=_,c.uniforms.scaleLo=w,c.uniforms.translateHi=M,c.uniforms.translateLo=k,c.uniforms.viewBox=r.viewBox;var d=this.scales;if(a)for(var p=d.length-1;p>=0;p--){var m=d[p];if(!(m.pixelSize&&m.pixelSize<1.25*o&&p>1)){var v=m.offset,g=m.count+v,y=b.ge(this.xCoords,s,v,g-1),x=b.lt(this.xCoords,l,y,g-1)+1;x>y&&u.drawArrays(u.POINTS,y,x-y)}}else u.drawArrays(u.POINTS,0,n);if(e)return t+n;h?u.blendFunc(u.ONE,u.ONE_MINUS_SRC_ALPHA):u.disable(u.BLEND)},x.draw=x.drawPick,x.pick=function(t,e,r){var n=this.pickOffset,i=this.pointCount;if(r<n||r>=n+i)return null;var a=r-n,o=this.points;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}},x.update=function(t){t=t||{};var e=t.positions||[],r=t.colors||[],n=t.glyphs||[],i=t.sizes||[],a=t.borderWidths||[],o=t.borderColors||[],s=this.plot.gl,l=this.pointCount,u=l>this.snapThreshold;if(null!=t.positions){this.points=e,l=this.points.length/2,u=l>this.snapThreshold;var c=h.mallocFloat32(2*l),f=h.mallocFloat64(2*l),m=h.mallocUint32(l),b=h.mallocFloat32(4*l);f.set(this.points),u&&(this.i2idx&&h.free(this.i2idx),this.i2idx=h.mallocInt32(l),this.scales=d(f,this.i2idx,c)),this.pointCount=l;for(var x=0;x<l;++x){var _=u?this.i2idx[x]:x;m[x]=_;var w=e[2*_],M=e[2*_+1];b[4*x]=w,b[4*x+1]=M,b[4*x+2]=w-b[4*x],b[4*x+3]=M-b[4*x+1],this.xCoords[x]=w}this.idBuffer.update(m),this.positionBuffer.update(b),h.free(b),h.free(m),h.free(f),h.free(c)}for(var k=h.mallocFloat32(2*l),A=h.mallocUint8(2*l),T=h.mallocUint8(2*l),S={},E=[],L=[],C=[],x=0,z=l,I=0;x<z;++x){var D=[255*r[4*x],255*r[4*x+1],255*r[4*x+2],255*r[4*x+3]],P=v(D,!1);null==S[P]&&(S[P]=I++,L.push(D[0]),L.push(D[1]),L.push(D[2]),L.push(D[3])),E.push(P),o&&o.length&&(D=[255*o[4*x],255*o[4*x+1],255*o[4*x+2],255*o[4*x+3]],P=v(D,!1),null==S[P]&&(S[P]=I++,L.push(D[0]),L.push(D[1]),L.push(D[2]),L.push(D[3])),C.push(P))}for(var O={},x=0,z=l,I=0;x<z;x++){var R=n[x];null==O[R]&&(O[R]=I++)}for(var F=0,x=0,z=i.length;x<z;++x)i[x]>F&&(F=i[x]);var j=this.charStep;this.charStep=y(Math.ceil(4*F),128,768);var N=Object.keys(O),B=this.charStep,U=Math.floor(B/2),V=s.getParameter(s.MAX_TEXTURE_SIZE),H=V/B*(V/B),q=Math.min(V,B*N.length),G=Math.min(V,B*Math.ceil(B*N.length/V)),Y=Math.floor(q/B);N.length>H&&console.warn(\"gl-scatter2d-fancy: number of characters is more than maximum texture size. Try reducing it.\"),this.chars&&this.chars+\"\"==N+\"\"&&this.charStep==j||(this.charCanvas=p({canvas:this.charCanvas,family:\"sans-serif\",size:U,shape:[q,G],step:[B,B],chars:N,align:!0,fit:this.charFit}),this.chars=N);for(var x=0;x<l;++x){var _=u?this.i2idx[x]:x,X=i[_],W=a[_];k[2*x]=2*X,k[2*x+1]=W;var P=E[_],Z=S[P];A[2*x]=Z;var J=C[_],K=S[J];A[2*x+1]=K;var R=n[_],Q=O[R];T[2*x+1]=Math.floor(Q/Y),T[2*x]=Q%Y}this.sizeBuffer.update(k),this.colorBuffer.update(A),this.charBuffer.update(T),this.charTexture.shape=[this.charCanvas.width,this.charCanvas.height],this.charCanvas&&this.charCanvas.width&&this.charTexture.setPixels(this.charCanvas),this.paletteTexture.setPixels(g(L.slice(0,1024),[256,1,4])),h.free(k),h.free(A),h.free(T)},x.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBuffer.dispose(),this.sizeBuffer.dispose(),this.colorBuffer.dispose(),this.idBuffer.dispose(),this.charBuffer.dispose(),this.plot.removeObject(this)}},{\"./lib/shaders\":231,\"binary-search-bounds\":232,clamp:87,\"color-id\":91,\"font-atlas-sdf\":133,\"gl-buffer\":155,\"gl-shader\":233,\"gl-texture2d\":266,ndarray:466,\"snap-points-2d\":241,\"typedarray-pool\":540}],243:[function(t,e,r){r.pointVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi, positionLo;\\nattribute float weight;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pointSize, useWeight;\\n\\nvarying float fragWeight;\\n\\n\\nvec4 pfx_1_0(vec2 scaleHi, vec2 scaleLo, vec2 translateHi, vec2 translateLo, vec2 positionHi, vec2 positionLo) {\\n  return vec4((positionHi + translateHi) * scaleHi\\n            + (positionLo + translateLo) * scaleHi\\n            + (positionHi + translateHi) * scaleLo\\n            + (positionLo + translateLo) * scaleLo, 0.0, 1.0);\\n}\\n\\nvoid main() {\\n  gl_Position = pfx_1_0(scaleHi, scaleLo, translateHi, translateLo, positionHi, positionLo);\\n  gl_PointSize = pointSize;\\n  fragWeight = mix(1.0, weight, useWeight);\\n}\",r.pointFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color, borderColor;\\nuniform float centerFraction;\\n\\nvarying float fragWeight;\\n\\nfloat smoothStep(float x, float y) {\\n  return 1.0 / (1.0 + exp(50.0*(x - y)));\\n}\\n\\nvoid main() {\\n  float radius = length(2.0*gl_PointCoord.xy-1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  vec4 baseColor = mix(borderColor, color, smoothStep(radius, centerFraction));\\n  float alpha = 1.0 - pow(1.0 - baseColor.a, fragWeight);\\n  gl_FragColor = vec4(baseColor.rgb * alpha, alpha);\\n}\\n\",r.pickVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nvec4 pfx_1_0(vec2 scaleHi, vec2 scaleLo, vec2 translateHi, vec2 translateLo, vec2 positionHi, vec2 positionLo) {\\n  return vec4((positionHi + translateHi) * scaleHi\\n            + (positionLo + translateLo) * scaleHi\\n            + (positionHi + translateHi) * scaleLo\\n            + (positionLo + translateLo) * scaleLo, 0.0, 1.0);\\n}\\n\\nattribute vec2 positionHi, positionLo;\\nattribute vec4 pickId;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pointSize;\\nuniform vec4 pickOffset;\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n\\n  vec4 id = pickId + pickOffset;\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  gl_Position = pfx_1_0(scaleHi, scaleLo, translateHi, translateLo, positionHi, positionLo);\\n  gl_PointSize = pointSize;\\n  fragId = id;\\n}\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  float radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  gl_FragColor = fragId / 255.0;\\n}\"},{}],244:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],245:[function(t,e,r){arguments[4][240][0].apply(r,arguments)},{dup:240}],246:[function(t,e,r){arguments[4][241][0].apply(r,arguments)},{\"./lib/sort\":245,dup:241,\"typedarray-pool\":540}],247:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.plot=t,this.positionBufferHi=e,this.positionBufferLo=r,this.pickBuffer=n,this.weightBuffer=i,this.shader=a,this.pickShader=o,this.scales=[],this.size=12,this.borderSize=1,this.pointCount=0,this.color=[1,0,0,1],this.borderColor=[0,0,0,1],this.bounds=[1/0,1/0,-1/0,-1/0],this.pickOffset=0,this.points=null,this.xCoords=null,this.snapPoints=!0}function i(t,e){var r=t.gl,i=o(r),s=o(r),l=o(r),u=o(r),h=a(r,c.pointVertex,c.pointFragment),f=a(r,c.pickVertex,c.pickFragment),d=new n(t,i,s,l,u,h,f);return d.update(e),t.addObject(d),d}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"binary-search-bounds\"),l=t(\"snap-points-2d\"),u=t(\"typedarray-pool\"),c=t(\"./lib/shader\"),h=t(\"array-normalize\"),f=t(\"array-bounds\");e.exports=i;var d=n.prototype,p=new Float32Array(2),m=new Float32Array(2),v=new Float32Array(2),g=new Float32Array(2),y=[0,0,0,0];d.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBufferHi.dispose(),this.positionBufferLo.dispose(),this.pickBuffer.dispose(),this.xCoords&&u.free(this.xCoords),this.plot.removeObject(this)},d.update=function(t){function e(e,r){return e in t?t[e]:r}if(t=t||{},this.size=e(\"size\",12),this.color=e(\"color\",[1,0,0,1]).slice(),this.borderSize=e(\"borderSize\",1),this.borderColor=e(\"borderColor\",[0,0,0,1]).slice(),this.snapPoints=e(\"snapPoints\",!0),null!=t.positions){this.xCoords&&u.free(this.xCoords),this.points=t.positions;var r=this.points.length>>>1,n=u.mallocInt32(r),i=u.mallocFloat32(r),a=u.mallocFloat64(2*r);if(a.set(this.points),this.snapPoints)this.scales=l(a,n,i,this.bounds);else{this.bounds=f(a,2),h(a,2,this.bounds);for(var o=0;o<r;o++)n[o]=o,i[o]=1}var s=u.mallocFloat64(r),c=u.mallocFloat32(2*r),d=u.mallocFloat32(2*r);c.set(a);for(var o=0,p=0;o<r;o++,p+=2)d[p]=a[p]-c[p],d[p+1]=a[p+1]-c[p+1],s[o]=a[p];this.positionBufferHi.update(c),this.positionBufferLo.update(d),this.pickBuffer.update(n),this.weightBuffer.update(i),u.free(c),u.free(d),u.free(i),u.free(a),u.free(n),this.xCoords=s,this.pointCount=r,this.pickOffset=0}},d.draw=function(t){var e=void 0!==t,r=this.plot,n=e?this.pickShader:this.shader,i=this.scales,a=this.positionBufferHi,o=this.positionBufferLo,s=this.pickBuffer,l=this.bounds,u=this.size,c=this.borderSize,h=r.gl,f=e?r.pickPixelRatio:r.pixelRatio,d=r.viewBox,b=r.dataBox;if(0===this.pointCount)return t;var x=l[2]-l[0],_=l[3]-l[1],w=b[2]-b[0],M=b[3]-b[1],k=(d[2]-d[0])*f/r.pixelRatio,A=(d[3]-d[1])*f/r.pixelRatio,T=this.pixelSize=Math.min(w/k,M/A),S=2*x/w,E=2*_/M;p[0]=S,p[1]=E,m[0]=S-p[0],m[1]=E-p[1];var L=(l[0]-b[0]-.5*w)/x,C=(l[1]-b[1]-.5*M)/_;v[0]=L,v[1]=C,g[0]=L-v[0],g[1]=C-v[1],n.bind(),n.uniforms.scaleHi=p,n.uniforms.scaleLo=m,n.uniforms.translateHi=v,n.uniforms.translateLo=g,n.uniforms.color=this.color,n.uniforms.borderColor=this.borderColor,n.uniforms.pointSize=f*(u+c),n.uniforms.centerFraction=0===this.borderSize?2:u/(u+c+1.25),a.bind(),n.attributes.positionHi.pointer(),o.bind(),n.attributes.positionLo.pointer(),e?(this.pickOffset=t,y[0]=255&t,y[1]=t>>8&255,y[2]=t>>16&255,y[3]=t>>24&255,n.uniforms.pickOffset=y,s.bind(),n.attributes.pickId.pointer(h.UNSIGNED_BYTE)):(n.uniforms.useWeight=1,this.weightBuffer.bind(),n.attributes.weight.pointer());var z=!0;if(this.snapPoints)for(var I=i.length-1;I>=0;I--){var D=i[I];if(!(D.pixelSize<T&&I>1)){var P=this.getVisibleRange(D),O=P[0],R=P[1];R>O&&h.drawArrays(h.POINTS,O,R-O),!e&&z&&(z=!1,n.uniforms.useWeight=0)}}else h.drawArrays(h.POINTS,0,this.pointCount);return t+this.pointCount},d.getVisibleRange=function(t){var e=this.plot.dataBox,r=this.bounds,n=this.pixelSize,i=this.size,a=this.plot.pixelRatio,o=r[2]-r[0];r[3],r[1];if(!t)for(var t,l=this.scales.length-1;l>=0&&(t=this.scales[l],t.pixelSize<n&&l>1);l--);var u=this.xCoords,c=(e[0]-r[0]-n*i*a)/o,h=(e[2]-r[0]+n*i*a)/o,f=t.offset,d=t.count+f,p=s.ge(u,c,f,d-1);return[p,s.lt(u,h,p,d-1)+1]},d.drawPick=d.draw,d.pick=function(t,e,r){var n=r-this.pickOffset;return n<0||n>=this.pointCount?null:{object:this,pointId:n,dataCoord:[this.points[2*n],this.points[2*n+1]]}}},{\"./lib/shader\":243,\"array-bounds\":43,\"array-normalize\":44,\"binary-search-bounds\":244,\"gl-buffer\":155,\"gl-shader\":254,\"snap-points-2d\":246,\"typedarray-pool\":540}],248:[function(t,e,r){\"use strict\";function n(t,e){var r=a[e];if(r||(r=a[e]={}),t in r)return r[t];for(var n=i(t,{textAlign:\"center\",textBaseline:\"middle\",lineHeight:1,font:e}),o=i(t,{triangles:!0,textAlign:\"center\",textBaseline:\"middle\",lineHeight:1,font:e}),s=[[1/0,1/0],[-1/0,-1/0]],l=0;l<n.positions.length;++l)for(var u=n.positions[l],c=0;c<2;++c)s[0][c]=Math.min(s[0][c],u[c]),s[1][c]=Math.max(s[1][c],u[c]);return r[t]=[o,n,s]}var i=t(\"vectorize-text\");e.exports=n;var a={}},{\"vectorize-text\":553}],249:[function(t,e,r){function n(t,e){var r=i(t,e),n=r.attributes;return n.position.location=0,n.color.location=1,n.glyph.location=2,n.id.location=3,r}var i=t(\"gl-shader\"),a=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\n\\nuniform vec4 highlightId;\\nuniform float highlightScale;\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0]))   || \\n     any(greaterThan(position, clipBounds[1])) ) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float scale = 1.0;\\n    if(distance(highlightId, id) < 0.0001) {\\n      scale = highlightScale;\\n    }\\n\\n    vec4 worldPosition = model * vec4(position, 1);\\n    vec4 viewPosition = view * worldPosition;\\n    viewPosition = viewPosition / viewPosition.w;\\n    vec4 clipPosition = projection * (viewPosition + scale * vec4(glyph.x, -glyph.y, 0, 0));\\n    \\n    gl_Position = clipPosition;\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = position;\\n  }\\n}\",o=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\nuniform mat4 model, view, projection;\\nuniform vec2 screenSize;\\nuniform vec3 clipBounds[2];\\nuniform float highlightScale, pixelRatio;\\nuniform vec4 highlightId;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float scale = pixelRatio;\\n    if(distance(highlightId.bgr, id.bgr) < 0.001) {\\n      scale *= highlightScale;\\n    }\\n\\n    vec4 worldPosition = model * vec4(position, 1.0);\\n    vec4 viewPosition = view * worldPosition;\\n    vec4 clipPosition = projection * viewPosition;\\n    clipPosition /= clipPosition.w;\\n    \\n    gl_Position = clipPosition + vec4(screenSize * scale * vec2(glyph.x, -glyph.y), 0.0, 0.0);\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = position;\\n  }\\n}\",s=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\nuniform float highlightScale;\\nuniform vec4 highlightId;\\nuniform vec3 axes[2];\\nuniform mat4 model, view, projection;\\nuniform vec2 screenSize;\\nuniform vec3 clipBounds[2];\\nuniform float scale, pixelRatio;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0]))   ||\\n     any(greaterThan(position, clipBounds[1])) ) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float lscale = pixelRatio * scale;\\n    if(distance(highlightId, id) < 0.0001) {\\n      lscale *= highlightScale;\\n    }\\n\\n    vec4 clipCenter   = projection * view * model * vec4(position, 1);\\n    vec3 dataPosition = position + 0.5*lscale*(axes[0] * glyph.x + axes[1] * glyph.y) * clipCenter.w * screenSize.y;\\n    vec4 clipPosition = projection * view * model * vec4(dataPosition, 1);\\n\\n    gl_Position = clipPosition;\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = dataPosition;\\n  }\\n}\\n\",l=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 fragClipBounds[2];\\nuniform float opacity;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(dataCoordinate, fragClipBounds[0]))   ||\\n     any(greaterThan(dataCoordinate, fragClipBounds[1])) ) {\\n    discard;\\n  } else {\\n    gl_FragColor = interpColor * opacity;\\n  }\\n}\\n\",u=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 fragClipBounds[2];\\nuniform float pickGroup;\\n\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(dataCoordinate, fragClipBounds[0]))   || \\n     any(greaterThan(dataCoordinate, fragClipBounds[1])) ) {\\n    discard;\\n  } else {\\n    gl_FragColor = vec4(pickGroup, pickId.bgr);\\n  }\\n}\",c=[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"glyph\",type:\"vec2\"},{name:\"id\",type:\"vec4\"}],h={vertex:a,fragment:l,attributes:c},f={vertex:o,fragment:l,attributes:c},d={vertex:s,fragment:l,attributes:c},p={vertex:a,fragment:u,attributes:c},m={vertex:o,fragment:u,attributes:c},v={vertex:s,fragment:u,attributes:c};r.createPerspective=function(t){return n(t,h)},r.createOrtho=function(t){return n(t,f)},r.createProject=function(t){return n(t,d)},r.createPickPerspective=function(t){return n(t,p)},r.createPickOrtho=function(t){return n(t,m)},r.createPickProject=function(t){return n(t,v)}},{\"gl-shader\":254}],250:[function(t,e,r){\"use strict\";function n(t,e){var r=t[0],n=t[1],i=t[2],a=t[3];return t[0]=e[0]*r+e[4]*n+e[8]*i+e[12]*a,t[1]=e[1]*r+e[5]*n+e[9]*i+e[13]*a,t[2]=e[2]*r+e[6]*n+e[10]*i+e[14]*a,t[3]=e[3]*r+e[7]*n+e[11]*i+e[15]*a,t}function i(t,e,r,i){return n(i,i,r),n(i,i,e),n(i,i,t)}function a(t,e){this.index=t,this.dataCoordinate=this.position=e}function o(t,e,r,n,i,o,s,l,u,c,h,f){this.gl=t,this.pixelRatio=1,this.shader=e,this.orthoShader=r,this.projectShader=n,this.pointBuffer=i,this.colorBuffer=o,this.glyphBuffer=s,this.idBuffer=l,this.vao=u,this.vertexCount=0,this.lineVertexCount=0,this.opacity=1,this.lineWidth=0,this.projectScale=[2/3,2/3,2/3],this.projectOpacity=[1,1,1],this.pickId=0,this.pickPerspectiveShader=c,this.pickOrthoShader=h,this.pickProjectShader=f,this.points=[],this._selectResult=new a(0,[0,0,0]),this.useOrtho=!0,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.axesProject=[!0,!0,!0],this.axesBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.highlightId=[1,1,1,1],this.highlightScale=2,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.dirty=!0}function s(t){return t[0]=t[1]=t[2]=0,t}function l(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=1,t}function u(t,e,r,n){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[r]=n,t}function c(t){for(var e=L,r=0;r<2;++r)for(var n=0;n<3;++n)e[r][n]=Math.max(Math.min(t[r][n],1e8),-1e8);return e}function h(t,e,r,n,a){var o,h=e.axesProject,f=e.gl,d=t.uniforms,p=r.model||x,m=r.view||x,v=r.projection||x,y=e.axesBounds,b=c(e.clipBounds);o=e.axes?e.axes.lastCubeProps.axis:[1,1,1],w[0]=2/f.drawingBufferWidth,w[1]=2/f.drawingBufferHeight,t.bind(),d.view=m,d.projection=v,d.screenSize=w,d.highlightId=e.highlightId,d.highlightScale=e.highlightScale,d.clipBounds=b,\n",
       "d.pickGroup=e.pickId/255,d.pixelRatio=e.pixelRatio;for(var _=0;_<3;++_)if(h[_]&&e.projectOpacity[_]<1===n){d.scale=e.projectScale[_],d.opacity=e.projectOpacity[_];for(var L=S,C=0;C<16;++C)L[C]=0;for(var C=0;C<4;++C)L[5*C]=1;L[5*_]=0,o[_]<0?L[12+_]=y[0][_]:L[12+_]=y[1][_],g(L,p,L),d.model=L;var z=(_+1)%3,I=(_+2)%3,D=s(M),P=s(k);D[z]=1,P[I]=1;var O=i(v,m,p,l(A,D)),R=i(v,m,p,l(T,P));if(Math.abs(O[1])>Math.abs(R[1])){var F=O;O=R,R=F,F=D,D=P,P=F;var j=z;z=I,I=j}O[0]<0&&(D[z]=-1),R[1]>0&&(P[I]=-1);for(var N=0,B=0,C=0;C<4;++C)N+=Math.pow(p[4*z+C],2),B+=Math.pow(p[4*I+C],2);D[z]/=Math.sqrt(N),P[I]/=Math.sqrt(B),d.axes[0]=D,d.axes[1]=P,d.fragClipBounds[0]=u(E,b[0],_,-1e8),d.fragClipBounds[1]=u(E,b[1],_,1e8),e.vao.draw(f.TRIANGLES,e.vertexCount),e.lineWidth>0&&(f.lineWidth(e.lineWidth),e.vao.draw(f.LINES,e.lineVertexCount,e.vertexCount))}}function f(t,e,r,n,i,a){var o=r.gl;if(r.vao.bind(),i===r.opacity<1||a){t.bind();var s=t.uniforms;s.model=n.model||x,s.view=n.view||x,s.projection=n.projection||x,w[0]=2/o.drawingBufferWidth,w[1]=2/o.drawingBufferHeight,s.screenSize=w,s.highlightId=r.highlightId,s.highlightScale=r.highlightScale,s.fragClipBounds=I,s.clipBounds=r.axes.bounds,s.opacity=r.opacity,s.pickGroup=r.pickId/255,s.pixelRatio=r.pixelRatio,r.vao.draw(o.TRIANGLES,r.vertexCount),r.lineWidth>0&&(o.lineWidth(r.lineWidth),r.vao.draw(o.LINES,r.lineVertexCount,r.vertexCount))}h(e,r,n,i,a),r.vao.unbind()}function d(t){var e=t.gl,r=y.createPerspective(e),n=y.createOrtho(e),i=y.createProject(e),a=y.createPickPerspective(e),s=y.createPickOrtho(e),l=y.createPickProject(e),u=p(e),c=p(e),h=p(e),f=p(e),d=m(e,[{buffer:u,size:3,type:e.FLOAT},{buffer:c,size:4,type:e.FLOAT},{buffer:h,size:2,type:e.FLOAT},{buffer:f,size:4,type:e.UNSIGNED_BYTE,normalized:!0}]),v=new o(e,r,n,i,u,c,h,f,d,a,s,l);return v.update(t),v}var p=t(\"gl-buffer\"),m=t(\"gl-vao\"),v=t(\"typedarray-pool\"),g=t(\"gl-mat4/multiply\"),y=t(\"./lib/shaders\"),b=t(\"./lib/glyphs\"),x=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];e.exports=d;var _=o.prototype;_.pickSlots=1,_.setPickBase=function(t){this.pickId=t},_.isTransparent=function(){if(this.opacity<1)return!0;for(var t=0;t<3;++t)if(this.axesProject[t]&&this.projectOpacity[t]<1)return!0;return!1},_.isOpaque=function(){if(this.opacity>=1)return!0;for(var t=0;t<3;++t)if(this.axesProject[t]&&this.projectOpacity[t]>=1)return!0;return!1};var w=[0,0],M=[0,0,0],k=[0,0,0],A=[0,0,0,1],T=[0,0,0,1],S=x.slice(),E=[0,0,0],L=[[0,0,0],[0,0,0]],C=[-1e8,-1e8,-1e8],z=[1e8,1e8,1e8],I=[C,z];_.draw=function(t){f(this.useOrtho?this.orthoShader:this.shader,this.projectShader,this,t,!1,!1)},_.drawTransparent=function(t){f(this.useOrtho?this.orthoShader:this.shader,this.projectShader,this,t,!0,!1)},_.drawPick=function(t){f(this.useOrtho?this.pickOrthoShader:this.pickPerspectiveShader,this.pickProjectShader,this,t,!1,!0)},_.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=t.value[2]+(t.value[1]<<8)+(t.value[0]<<16);if(e>=this.pointCount||e<0)return null;var r=this.points[e],n=this._selectResult;n.index=e;for(var i=0;i<3;++i)n.position[i]=n.dataCoordinate[i]=r[i];return n},_.highlight=function(t){if(t){var e=t.index,r=255&e,n=e>>8&255,i=e>>16&255;this.highlightId=[r/255,n/255,i/255,0]}else this.highlightId=[1,1,1,1]},_.update=function(t){if(t=t||{},\"perspective\"in t&&(this.useOrtho=!t.perspective),\"orthographic\"in t&&(this.useOrtho=!!t.orthographic),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"project\"in t)if(Array.isArray(t.project))this.axesProject=t.project;else{var e=!!t.project;this.axesProject=[e,e,e]}if(\"projectScale\"in t)if(Array.isArray(t.projectScale))this.projectScale=t.projectScale.slice();else{var r=+t.projectScale;this.projectScale=[r,r,r]}if(\"projectOpacity\"in t)if(Array.isArray(t.projectOpacity))this.projectOpacity=t.projectOpacity.slice();else{var r=+t.projectOpacity;this.projectOpacity=[r,r,r]}\"opacity\"in t&&(this.opacity=t.opacity),this.dirty=!0;var n=t.position;if(n){var i=t.font||\"normal\",a=t.alignment||[0,0],o=[1/0,1/0,1/0],s=[-1/0,-1/0,-1/0],l=t.glyph,u=t.color,c=t.size,h=t.angle,f=t.lineColor,d=0,p=0,m=0,g=n.length;t:for(var y=0;y<g;++y){for(var x=n[y],_=0;_<3;++_)if(isNaN(x[_])||!isFinite(x[_]))continue t;var w;w=Array.isArray(l)?b(l[y],i):l?b(l,i):b(\"\\u25cf\",i);var M=w[0],k=w[1],A=w[2];p+=3*M.cells.length,m+=2*k.edges.length}var T=p+m,S=v.mallocFloat(3*T),E=v.mallocFloat(4*T),L=v.mallocFloat(2*T),C=v.mallocUint32(T),z=[0,a[1]],I=0,D=p,P=[0,0,0,1],O=[0,0,0,1],R=Array.isArray(u)&&Array.isArray(u[0]),F=Array.isArray(f)&&Array.isArray(f[0]);t:for(var y=0;y<g;++y){for(var x=n[y],_=0;_<3;++_){if(isNaN(x[_])||!isFinite(x[_])){d+=1;continue t}s[_]=Math.max(s[_],x[_]),o[_]=Math.min(o[_],x[_])}var w;w=Array.isArray(l)?b(l[y],i):l?b(l,i):b(\"\\u25cf\",i);var M=w[0],k=w[1],A=w[2];if(Array.isArray(u)){var j;if(j=R?u[y]:u,3===j.length){for(var _=0;_<3;++_)P[_]=j[_];P[3]=1}else if(4===j.length)for(var _=0;_<4;++_)P[_]=j[_]}else P[0]=P[1]=P[2]=0,P[3]=1;if(Array.isArray(f)){var j;if(j=F?f[y]:f,3===j.length){for(var _=0;_<3;++_)O[_]=j[_];O[_]=1}else if(4===j.length)for(var _=0;_<4;++_)O[_]=j[_]}else O[0]=O[1]=O[2]=0,O[3]=1;var N=.5;Array.isArray(c)?N=+c[y]:c?N=+c:this.useOrtho&&(N=12);var B=0;Array.isArray(h)?B=+h[y]:h&&(B=+h);for(var U=Math.cos(B),V=Math.sin(B),x=n[y],_=0;_<3;++_)s[_]=Math.max(s[_],x[_]),o[_]=Math.min(o[_],x[_]);a[0]<0?z[0]=a[0]*(1+A[1][0]):a[0]>0&&(z[0]=-a[0]*(1+A[0][0]));for(var H=M.cells,q=M.positions,_=0;_<H.length;++_)for(var G=H[_],Y=0;Y<3;++Y){for(var X=0;X<3;++X)S[3*I+X]=x[X];for(var X=0;X<4;++X)E[4*I+X]=P[X];C[I]=d;var W=q[G[Y]];L[2*I]=N*(U*W[0]-V*W[1]+z[0]),L[2*I+1]=N*(V*W[0]+U*W[1]+z[1]),I+=1}for(var H=k.edges,q=k.positions,_=0;_<H.length;++_)for(var G=H[_],Y=0;Y<2;++Y){for(var X=0;X<3;++X)S[3*D+X]=x[X];for(var X=0;X<4;++X)E[4*D+X]=O[X];C[D]=d;var W=q[G[Y]];L[2*D]=N*(U*W[0]-V*W[1]+z[0]),L[2*D+1]=N*(V*W[0]+U*W[1]+z[1]),D+=1}d+=1}this.vertexCount=p,this.lineVertexCount=m,this.pointBuffer.update(S),this.colorBuffer.update(E),this.glyphBuffer.update(L),this.idBuffer.update(new Uint32Array(C)),v.free(S),v.free(E),v.free(L),v.free(C),this.bounds=[o,s],this.points=n,this.pointCount=n.length}},_.dispose=function(){this.shader.dispose(),this.orthoShader.dispose(),this.pickPerspectiveShader.dispose(),this.pickOrthoShader.dispose(),this.vao.dispose(),this.pointBuffer.dispose(),this.colorBuffer.dispose(),this.glyphBuffer.dispose(),this.idBuffer.dispose()}},{\"./lib/glyphs\":248,\"./lib/shaders\":249,\"gl-buffer\":155,\"gl-mat4/multiply\":182,\"gl-vao\":270,\"typedarray-pool\":540}],251:[function(t,e,r){\"use strict\";r.boxVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 vertex;\\n\\nuniform vec2 cornerA, cornerB;\\n\\nvoid main() {\\n  gl_Position = vec4(mix(cornerA, cornerB, vertex), 0, 1);\\n}\\n\",r.boxFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = color;\\n}\\n\"},{}],252:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.boxBuffer=e,this.boxShader=r,this.enabled=!0,this.selectBox=[1/0,1/0,-1/0,-1/0],this.borderColor=[0,0,0,1],this.innerFill=!1,this.innerColor=[0,0,0,.25],this.outerFill=!0,this.outerColor=[0,0,0,.5],this.borderWidth=10}function i(t,e){var r=t.gl,i=o(r,[0,0,0,1,1,0,1,1]),l=a(r,s.boxVertex,s.boxFragment),u=new n(t,i,l);return u.update(e),t.addOverlay(u),u}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"./lib/shaders\");e.exports=i;var l=n.prototype;l.draw=function(){if(this.enabled){var t=this.plot,e=this.selectBox,r=this.borderWidth,n=(this.innerFill,this.innerColor),i=(this.outerFill,this.outerColor),a=this.borderColor,o=t.box,s=t.screenBox,l=t.dataBox,u=t.viewBox,c=t.pixelRatio,h=(e[0]-l[0])*(u[2]-u[0])/(l[2]-l[0])+u[0],f=(e[1]-l[1])*(u[3]-u[1])/(l[3]-l[1])+u[1],d=(e[2]-l[0])*(u[2]-u[0])/(l[2]-l[0])+u[0],p=(e[3]-l[1])*(u[3]-u[1])/(l[3]-l[1])+u[1];if(h=Math.max(h,u[0]),f=Math.max(f,u[1]),d=Math.min(d,u[2]),p=Math.min(p,u[3]),!(d<h||p<f)){o.bind();var m=s[2]-s[0],v=s[3]-s[1];if(this.outerFill&&(o.drawBox(0,0,m,f,i),o.drawBox(0,f,h,p,i),o.drawBox(0,p,m,v,i),o.drawBox(d,f,m,p,i)),this.innerFill&&o.drawBox(h,f,d,p,n),r>0){var g=r*c;o.drawBox(h-g,f-g,d+g,f+g,a),o.drawBox(h-g,p-g,d+g,p+g,a),o.drawBox(h-g,f-g,h+g,p+g,a),o.drawBox(d-g,f-g,d+g,p+g,a)}}}},l.update=function(t){t=t||{},this.innerFill=!!t.innerFill,this.outerFill=!!t.outerFill,this.innerColor=(t.innerColor||[0,0,0,.5]).slice(),this.outerColor=(t.outerColor||[0,0,0,.5]).slice(),this.borderColor=(t.borderColor||[0,0,0,1]).slice(),this.borderWidth=t.borderWidth||0,this.selectBox=(t.selectBox||this.selectBox).slice()},l.dispose=function(){this.boxBuffer.dispose(),this.boxShader.dispose(),this.plot.removeOverlay(this)}},{\"./lib/shaders\":251,\"gl-buffer\":155,\"gl-shader\":254}],253:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.coord=[t,e],this.id=r,this.value=n,this.distance=i}function i(t,e,r){this.gl=t,this.fbo=e,this.buffer=r,this._readTimeout=null;var n=this;this._readCallback=function(){n.gl&&(e.bind(),t.readPixels(0,0,e.shape[0],e.shape[1],t.RGBA,t.UNSIGNED_BYTE,n.buffer),n._readTimeout=null)}}function a(t,e){return new i(t,o(t,e),s.mallocUint8(e[0]*e[1]*4))}e.exports=a;var o=t(\"gl-fbo\"),s=t(\"typedarray-pool\"),l=t(\"ndarray\"),u=t(\"bit-twiddle\").nextPow2,c=t(\"cwise/lib/wrapper\")({args:[\"array\",{offset:[0,0,1],array:0},{offset:[0,0,2],array:0},{offset:[0,0,3],array:0},\"scalar\",\"scalar\",\"index\"],pre:{body:\"{this_closestD2=1e8,this_closestX=-1,this_closestY=-1}\",args:[],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[]},body:{body:\"{if(_inline_49_arg0_<255||_inline_49_arg1_<255||_inline_49_arg2_<255||_inline_49_arg3_<255){var _inline_49_l=_inline_49_arg4_-_inline_49_arg6_[0],_inline_49_a=_inline_49_arg5_-_inline_49_arg6_[1],_inline_49_f=_inline_49_l*_inline_49_l+_inline_49_a*_inline_49_a;_inline_49_f<this_closestD2&&(this_closestD2=_inline_49_f,this_closestX=_inline_49_arg6_[0],this_closestY=_inline_49_arg6_[1])}}\",args:[{name:\"_inline_49_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg4_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg5_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg6_\",lvalue:!1,rvalue:!0,count:4}],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[\"_inline_49_a\",\"_inline_49_f\",\"_inline_49_l\"]},post:{body:\"{return[this_closestX,this_closestY,this_closestD2]}\",args:[],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[]},debug:!1,funcName:\"cwise\",blockSize:64}),h=i.prototype;Object.defineProperty(h,\"shape\",{get:function(){return this.gl?this.fbo.shape.slice():[0,0]},set:function(t){if(this.gl){this.fbo.shape=t;var e=this.fbo.shape[0],r=this.fbo.shape[1];if(r*e*4>this.buffer.length){s.free(this.buffer);for(var n=this.buffer=s.mallocUint8(u(r*e*4)),i=0;i<r*e*4;++i)n[i]=255}return t}}}),h.begin=function(){var t=this.gl;this.shape;t&&(this.fbo.bind(),t.clearColor(1,1,1,1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT))},h.end=function(){var t=this.gl;t&&(t.bindFramebuffer(t.FRAMEBUFFER,null),this._readTimeout||clearTimeout(this._readTimeout),this._readTimeout=setTimeout(this._readCallback,1))},h.query=function(t,e,r){if(!this.gl)return null;var i=this.fbo.shape.slice();t|=0,e|=0,\"number\"!=typeof r&&(r=1);var a=0|Math.min(Math.max(t-r,0),i[0]),o=0|Math.min(Math.max(t+r,0),i[0]),s=0|Math.min(Math.max(e-r,0),i[1]),u=0|Math.min(Math.max(e+r,0),i[1]);if(o<=a||u<=s)return null;var h=[o-a,u-s],f=l(this.buffer,[h[0],h[1],4],[4,4*i[0],1],4*(a+i[0]*s)),d=c(f.hi(h[0],h[1],1),r,r),p=d[0],m=d[1];return p<0||Math.pow(this.radius,2)<d[2]?null:new n(p+a|0,m+s|0,f.get(p,m,0),[f.get(p,m,1),f.get(p,m,2),f.get(p,m,3)],Math.sqrt(d[2]))},h.dispose=function(){this.gl&&(this.fbo.dispose(),s.free(this.buffer),this.gl=null,this._readTimeout&&clearTimeout(this._readTimeout))}},{\"bit-twiddle\":66,\"cwise/lib/wrapper\":112,\"gl-fbo\":163,ndarray:466,\"typedarray-pool\":540}],254:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this._vref=this._fref=this._relink=this.vertShader=this.fragShader=this.program=this.attributes=this.uniforms=this.types=null}function i(t,e){return t.name<e.name?-1:1}function a(t,e,r,i,a){var o=new n(t);return o.update(e,r,i,a),o}var o=t(\"./lib/create-uniforms\"),s=t(\"./lib/create-attributes\"),l=t(\"./lib/reflect\"),u=t(\"./lib/shader-cache\"),c=t(\"./lib/runtime-reflect\"),h=t(\"./lib/GLError\"),f=n.prototype;f.bind=function(){this.program||this._relink(),this.gl.useProgram(this.program)},f.dispose=function(){this._fref&&this._fref.dispose(),this._vref&&this._vref.dispose(),this.attributes=this.types=this.vertShader=this.fragShader=this.program=this._relink=this._fref=this._vref=null},f.update=function(t,e,r,n){function a(){d.program=u.program(p,d._vref,d._fref,x,_);for(var t=0;t<r.length;++t)E[t]=p.getUniformLocation(d.program,r[t].name)}if(!e||1===arguments.length){var f=t;t=f.vertex,e=f.fragment,r=f.uniforms,n=f.attributes}var d=this,p=d.gl,m=d._vref;d._vref=u.shader(p,p.VERTEX_SHADER,t),m&&m.dispose(),d.vertShader=d._vref.shader;var v=this._fref;if(d._fref=u.shader(p,p.FRAGMENT_SHADER,e),v&&v.dispose(),d.fragShader=d._fref.shader,!r||!n){var g=p.createProgram();if(p.attachShader(g,d.fragShader),p.attachShader(g,d.vertShader),p.linkProgram(g),!p.getProgramParameter(g,p.LINK_STATUS)){var y=p.getProgramInfoLog(g);throw new h(y,\"Error linking program:\"+y)}r=r||c.uniforms(p,g),n=n||c.attributes(p,g),p.deleteProgram(g)}n=n.slice(),n.sort(i);for(var b=[],x=[],_=[],w=0;w<n.length;++w){var M=n[w];if(M.type.indexOf(\"mat\")>=0){for(var k=0|M.type.charAt(M.type.length-1),A=new Array(k),T=0;T<k;++T)A[T]=_.length,x.push(M.name+\"[\"+T+\"]\"),\"number\"==typeof M.location?_.push(M.location+T):Array.isArray(M.location)&&M.location.length===k&&\"number\"==typeof M.location[T]?_.push(0|M.location[T]):_.push(-1);b.push({name:M.name,type:M.type,locations:A})}else b.push({name:M.name,type:M.type,locations:[_.length]}),x.push(M.name),\"number\"==typeof M.location?_.push(0|M.location):_.push(-1)}for(var S=0,w=0;w<_.length;++w)if(_[w]<0){for(;_.indexOf(S)>=0;)S+=1;_[w]=S}var E=new Array(r.length);a(),d._relink=a,d.types={uniforms:l(r),attributes:l(n)},d.attributes=s(p,d,b,_),Object.defineProperty(d,\"uniforms\",o(p,d,r,E))},e.exports=a},{\"./lib/GLError\":255,\"./lib/create-attributes\":256,\"./lib/create-uniforms\":257,\"./lib/reflect\":258,\"./lib/runtime-reflect\":259,\"./lib/shader-cache\":260}],255:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],256:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\"./GLError\":255,dup:213}],257:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":255,\"./reflect\":258,dup:214}],258:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],259:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],260:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":255,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],261:[function(t,e,r){\"use strict\";function n(t){this.plot=t,this.enable=[!0,!0,!1,!1],this.width=[1,1,1,1],this.color=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.center=[1/0,1/0]}function i(t,e){var r=new n(t);return r.update(e),t.addOverlay(r),r}e.exports=i;var a=n.prototype;a.update=function(t){t=t||{},this.enable=(t.enable||[!0,!0,!1,!1]).slice(),this.width=(t.width||[1,1,1,1]).slice(),this.color=(t.color||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]).map(function(t){return t.slice()}),this.center=(t.center||[1/0,1/0]).slice(),this.plot.setOverlayDirty()},a.draw=function(){var t=this.enable,e=this.width,r=this.color,n=this.center,i=this.plot,a=i.line,o=i.dataBox,s=i.viewBox;if(a.bind(),o[0]<=n[0]&&n[0]<=o[2]&&o[1]<=n[1]&&n[1]<=o[3]){var l=s[0]+(n[0]-o[0])/(o[2]-o[0])*(s[2]-s[0]),u=s[1]+(n[1]-o[1])/(o[3]-o[1])*(s[3]-s[1]);t[0]&&a.drawLine(l,u,s[0],u,e[0],r[0]),t[1]&&a.drawLine(l,u,l,s[1],e[1],r[1]),t[2]&&a.drawLine(l,u,s[2],u,e[2],r[2]),t[3]&&a.drawLine(l,u,l,s[3],e[3],r[3])}},a.dispose=function(){this.plot.removeOverlay(this)}},{}],262:[function(t,e,r){\"use strict\";var n=t(\"gl-shader\");e.exports=function(t){return n(t,\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, color;\\nattribute float weight;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 coordinates[3];\\nuniform vec4 colors[3];\\nuniform vec2 screenShape;\\nuniform float lineWidth;\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  vec3 vertexPosition = mix(coordinates[0],\\n    mix(coordinates[2], coordinates[1], 0.5 * (position + 1.0)), abs(position));\\n\\n  vec4 clipPos = projection * view * model * vec4(vertexPosition, 1.0);\\n  vec2 clipOffset = (projection * view * model * vec4(color, 0.0)).xy;\\n  vec2 delta = weight * clipOffset * screenShape;\\n  vec2 lineOffset = normalize(vec2(delta.y, -delta.x)) / screenShape;\\n\\n  gl_Position   = vec4(clipPos.xy + clipPos.w * 0.5 * lineWidth * lineOffset, clipPos.z, clipPos.w);\\n  fragColor     = color.x * colors[0] + color.y * colors[1] + color.z * colors[2];\\n}\\n\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  gl_FragColor = fragColor;\\n}\",null,[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec3\"},{name:\"weight\",type:\"float\"}])}},{\"gl-shader\":254}],263:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.buffer=e,this.vao=r,this.shader=n,this.pixelRatio=1,this.bounds=[[-1e3,-1e3,-1e3],[1e3,1e3,1e3]],this.position=[0,0,0],this.lineWidth=[2,2,2],this.colors=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.enabled=[!0,!0,!0],this.drawSides=[!0,!0,!0],this.axes=null}function i(t,e){function r(t,e,r,n,a,o){var s=[t,e,r,0,0,0,1];s[n+3]=1,s[n]=a,i.push.apply(i,s),s[6]=-1,i.push.apply(i,s),s[n]=o,i.push.apply(i,s),i.push.apply(i,s),s[6]=1,i.push.apply(i,s),s[n]=a,i.push.apply(i,s)}var i=[];r(0,0,0,0,0,1),r(0,0,0,1,0,1),r(0,0,0,2,0,1),r(1,0,0,1,-1,1),r(1,0,0,2,-1,1),r(0,1,0,0,-1,1),r(0,1,0,2,-1,1),r(0,0,1,0,-1,1),r(0,0,1,1,-1,1);var l=a(t,i),u=o(t,[{type:t.FLOAT,buffer:l,size:3,offset:0,stride:28},{type:t.FLOAT,buffer:l,size:3,offset:12,stride:28},{type:t.FLOAT,buffer:l,size:1,offset:24,stride:28}]),c=s(t);c.attributes.position.location=0,c.attributes.color.location=1,c.attributes.weight.location=2;var h=new n(t,l,u,c);return h.update(e),h}var a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=t(\"./shaders/index\");e.exports=i;var l=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],u=n.prototype,c=[0,0,0],h=[0,0,0],f=[0,0];u.isTransparent=function(){return!1},u.drawTransparent=function(t){},u.draw=function(t){var e=this.gl,r=this.vao,n=this.shader;r.bind(),n.bind();var i,a=t.model||l,o=t.view||l,s=t.projection||l;this.axes&&(i=this.axes.lastCubeProps.axis);for(var u=c,d=h,p=0;p<3;++p)i&&i[p]<0?(u[p]=this.bounds[0][p],d[p]=this.bounds[1][p]):(u[p]=this.bounds[1][p],d[p]=this.bounds[0][p]);f[0]=e.drawingBufferWidth,f[1]=e.drawingBufferHeight,n.uniforms.model=a,n.uniforms.view=o,n.uniforms.projection=s,n.uniforms.coordinates=[this.position,u,d],n.uniforms.colors=this.colors,n.uniforms.screenShape=f;for(var p=0;p<3;++p)n.uniforms.lineWidth=this.lineWidth[p]*this.pixelRatio,this.enabled[p]&&(r.draw(e.TRIANGLES,6,6*p),this.drawSides[p]&&r.draw(e.TRIANGLES,12,18+12*p));r.unbind()},u.update=function(t){t&&(\"bounds\"in t&&(this.bounds=t.bounds),\"position\"in t&&(this.position=t.position),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"colors\"in t&&(this.colors=t.colors),\"enabled\"in t&&(this.enabled=t.enabled),\"drawSides\"in t&&(this.drawSides=t.drawSides))},u.dispose=function(){this.vao.dispose(),this.buffer.dispose(),this.shader.dispose()}},{\"./shaders/index\":262,\"gl-buffer\":155,\"gl-vao\":270}],264:[function(t,e,r){var n=t(\"gl-shader\"),i=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec4 uv;\\nattribute vec3 f;\\nattribute vec3 normal;\\n\\nuniform mat4 model, view, projection, inverseModel;\\nuniform vec3 lightPosition, eyePosition;\\nuniform sampler2D colormap;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  worldCoordinate = vec3(uv.zw, f.x);\\n  vec4 worldPosition = model * vec4(worldCoordinate, 1.0);\\n  vec4 clipPosition = projection * view * worldPosition;\\n  gl_Position = clipPosition;\\n  kill = f.y;\\n  value = f.z;\\n  planeCoordinate = uv.xy;\\n\\n  vColor = texture2D(colormap, vec2(value, value));\\n\\n  //Lighting geometry parameters\\n  vec4 cameraCoordinate = view * worldPosition;\\n  cameraCoordinate.xyz /= cameraCoordinate.w;\\n  lightDirection = lightPosition - cameraCoordinate.xyz;\\n  eyeDirection   = eyePosition - cameraCoordinate.xyz;\\n  surfaceNormal  = normalize((vec4(normal,0) * inverseModel).xyz);\\n}\\n\",a=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nfloat beckmannDistribution_2_0(float x, float roughness) {\\n  float NdotH = max(x, 0.0001);\\n  float cos2Alpha = NdotH * NdotH;\\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\\n  float roughness2 = roughness * roughness;\\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\\n  return exp(tan2Alpha / roughness2) / denom;\\n}\\n\\n\\n\\nfloat beckmannSpecular_1_1(\\n  vec3 lightDirection,\\n  vec3 viewDirection,\\n  vec3 surfaceNormal,\\n  float roughness) {\\n  return beckmannDistribution_2_0(dot(surfaceNormal, normalize(lightDirection + viewDirection)), roughness);\\n}\\n\\n\\n\\nuniform vec3 lowerBound, upperBound;\\nuniform float contourTint;\\nuniform vec4 contourColor;\\nuniform sampler2D colormap;\\nuniform vec3 clipBounds[2];\\nuniform float roughness, fresnel, kambient, kdiffuse, kspecular, opacity;\\nuniform float vertexColor;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  if (kill > 0.0 ||\\n    any(lessThan(worldCoordinate, clipBounds[0])) || any(greaterThan(worldCoordinate, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  vec3 N = normalize(surfaceNormal);\\n  vec3 V = normalize(eyeDirection);\\n  vec3 L = normalize(lightDirection);\\n\\n  if(gl_FrontFacing) {\\n    N = -N;\\n  }\\n\\n  float specular = max(beckmannSpecular_1_1(L, V, N, roughness), 0.);\\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\\n\\n  //decide how to interpolate color \\u2014 in vertex or in fragment\\n  vec4 surfaceColor = step(vertexColor, .5) * texture2D(colormap, vec2(value, value)) + step(.5, vertexColor) * vColor;\\n\\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\\n\\n  gl_FragColor = mix(litColor, contourColor, contourTint) * opacity;\\n}\\n\",o=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec4 uv;\\nattribute float f;\\n\\nuniform mat3 permutation;\\nuniform mat4 model, view, projection;\\nuniform float height, zOffset;\\nuniform sampler2D colormap;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  vec3 dataCoordinate = permutation * vec3(uv.xy, height);\\n  vec4 worldPosition = model * vec4(dataCoordinate, 1.0);\\n\\n  vec4 clipPosition = projection * view * worldPosition;\\n  clipPosition.z = clipPosition.z + zOffset;\\n\\n  gl_Position = clipPosition;\\n  value = f;\\n  kill = -1.0;\\n  worldCoordinate = dataCoordinate;\\n  planeCoordinate = uv.zw;\\n\\n  vColor = texture2D(colormap, vec2(value, value));\\n\\n  //Don't do lighting for contours\\n  surfaceNormal   = vec3(1,0,0);\\n  eyeDirection    = vec3(0,1,0);\\n  lightDirection  = vec3(0,0,1);\\n}\\n\",s=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec2 shape;\\nuniform vec3 clipBounds[2];\\nuniform float pickId;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 surfaceNormal;\\n\\nvec2 splitFloat(float v) {\\n  float vh = 255.0 * v;\\n  float upper = floor(vh);\\n  float lower = fract(vh);\\n  return vec2(upper / 255.0, floor(lower * 16.0) / 16.0);\\n}\\n\\nvoid main() {\\n  if(kill > 0.0 ||\\n    any(lessThan(worldCoordinate, clipBounds[0])) || any(greaterThan(worldCoordinate, clipBounds[1]))) {\\n    discard;\\n  }\\n  vec2 ux = splitFloat(planeCoordinate.x / shape.x);\\n  vec2 uy = splitFloat(planeCoordinate.y / shape.y);\\n  gl_FragColor = vec4(pickId, ux.x, uy.x, ux.y + (uy.y/16.0));\\n}\\n\";r.createShader=function(t){var e=n(t,i,a,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e.attributes.normal.location=2,e},r.createPickShader=function(t){var e=n(t,i,s,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e.attributes.normal.location=2,e},r.createContourShader=function(t){var e=n(t,o,a,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"float\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e},r.createPickContourShader=function(t){var e=n(t,o,s,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"float\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e}},{\"gl-shader\":254}],265:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.position=t,this.index=e,this.uv=r,this.level=n,this.dataCoordinate=i}function i(t){var e=x([y({colormap:t,nshades:R,format:\"rgba\"}).map(function(t){return[t[0],t[1],t[2],255*t[3]]})]);return b.divseq(e,255),e}function a(t,e,r,i,a,o,s,l,u,c,h,f,d,p){this.gl=t,this.shape=e,this.bounds=r,this.intensityBounds=[],this._shader=i,this._pickShader=a,this._coordinateBuffer=o,this._vao=s,this._colorMap=l,this._contourShader=u,this._contourPickShader=c,this._contourBuffer=h,this._contourVAO=f,this._contourOffsets=[[],[],[]],this._contourCounts=[[],[],[]],this._vertexCount=0,this._pickResult=new n([0,0,0],[0,0],[0,0],[0,0,0],[0,0,0]),this._dynamicBuffer=d,this._dynamicVAO=p,this._dynamicOffsets=[0,0,0],this._dynamicCounts=[0,0,0],this.contourWidth=[1,1,1],this.contourLevels=[[1],[1],[1]],this.contourTint=[0,0,0],this.contourColor=[[.5,.5,.5,1],[.5,.5,.5,1],[.5,.5,.5,1]],this.showContour=!0,this.showSurface=!0,this.enableHighlight=[!0,!0,!0],this.highlightColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.highlightTint=[1,1,1],this.highlightLevel=[-1,-1,-1],this.enableDynamic=[!0,!0,!0],this.dynamicLevel=[NaN,NaN,NaN],this.dynamicColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.dynamicTint=[1,1,1],this.dynamicWidth=[1,1,1],this.axesBounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.surfaceProject=[!1,!1,!1],this.contourProject=[[!1,!1,!1],[!1,!1,!1],[!1,!1,!1]],this.colorBounds=[!1,!1],this._field=[_(g.mallocFloat(1024),[0,0]),_(g.mallocFloat(1024),[0,0]),_(g.mallocFloat(1024),[0,0])],this.pickId=1,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.snapToData=!1,this.opacity=1,this.lightPosition=[10,1e4,0],this.ambientLight=.8,this.diffuseLight=.8,this.specularLight=2,this.roughness=.5,this.fresnel=1.5,this.vertexColor=0,this.dirty=!0}function o(t,e){var r,n,i,a=e.axes&&e.axes.lastCubeProps.axis||j,o=e.showSurface,s=e.showContour;for(r=0;r<3;++r)for(o=o||e.surfaceProject[r],n=0;n<3;++n)s=s||e.contourProject[r][n];for(r=0;r<3;++r){var l=N.projections[r];for(n=0;n<16;++n)l[n]=0;for(n=0;n<4;++n)l[5*n]=1;l[5*r]=0,l[12+r]=e.axesBounds[+(a[r]>0)][r],M(l,t.model,l);var u=N.clipBounds[r];for(i=0;i<2;++i)for(n=0;n<3;++n)u[i][n]=t.clipBounds[i][n];u[0][r]=-1e8,u[1][r]=1e8}return N.showSurface=o,N.showContour=s,N}function s(t,e){t=t||{};var r=this.gl;r.disable(r.CULL_FACE),this._colorMap.bind(0);var n=B;n.model=t.model||D,n.view=t.view||D,n.projection=t.projection||D,n.lowerBound=[this.bounds[0][0],this.bounds[0][1],this.colorBounds[0]||this.bounds[0][2]],n.upperBound=[this.bounds[1][0],this.bounds[1][1],this.colorBounds[1]||this.bounds[1][2]],n.contourColor=this.contourColor[0],n.inverseModel=k(n.inverseModel,n.model);for(var i=0;i<2;++i)for(var a=n.clipBounds[i],s=0;s<3;++s)a[s]=Math.min(Math.max(this.clipBounds[i][s],-1e8),1e8);n.kambient=this.ambientLight,n.kdiffuse=this.diffuseLight,n.kspecular=this.specularLight,n.roughness=this.roughness,n.fresnel=this.fresnel,n.opacity=this.opacity,n.height=0,n.permutation=V,n.vertexColor=this.vertexColor;var l=U;for(M(l,n.view,n.model),M(l,n.projection,l),k(l,l),i=0;i<3;++i)n.eyePosition[i]=l[12+i]/l[15];var u=l[15];for(i=0;i<3;++i)u+=this.lightPosition[i]*l[4*i+3];for(i=0;i<3;++i){var c=l[12+i];for(s=0;s<3;++s)c+=l[4*s+i]*this.lightPosition[s];n.lightPosition[i]=c/u}var h=o(n,this);if(h.showSurface&&e===this.opacity<1){for(this._shader.bind(),this._shader.uniforms=n,this._vao.bind(),this.showSurface&&this._vertexCount&&this._vao.draw(r.TRIANGLES,this._vertexCount),i=0;i<3;++i)this.surfaceProject[i]&&this.vertexCount&&(this._shader.uniforms.model=h.projections[i],this._shader.uniforms.clipBounds=h.clipBounds[i],this._vao.draw(r.TRIANGLES,this._vertexCount));this._vao.unbind()}if(h.showContour&&!e){var f=this._contourShader;n.kambient=1,n.kdiffuse=0,n.kspecular=0,n.opacity=1,f.bind(),f.uniforms=n;var d=this._contourVAO;for(d.bind(),i=0;i<3;++i)for(f.uniforms.permutation=O[i],r.lineWidth(this.contourWidth[i]),s=0;s<this.contourLevels[i].length;++s)this._contourCounts[i][s]&&(s===this.highlightLevel[i]?(f.uniforms.contourColor=this.highlightColor[i],f.uniforms.contourTint=this.highlightTint[i]):0!==s&&s-1!==this.highlightLevel[i]||(f.uniforms.contourColor=this.contourColor[i],f.uniforms.contourTint=this.contourTint[i]),f.uniforms.height=this.contourLevels[i][s],d.draw(r.LINES,this._contourCounts[i][s],this._contourOffsets[i][s]));for(i=0;i<3;++i)for(f.uniforms.model=h.projections[i],f.uniforms.clipBounds=h.clipBounds[i],s=0;s<3;++s)if(this.contourProject[i][s]){f.uniforms.permutation=O[s],r.lineWidth(this.contourWidth[s]);for(var p=0;p<this.contourLevels[s].length;++p)p===this.highlightLevel[s]?(f.uniforms.contourColor=this.highlightColor[s],f.uniforms.contourTint=this.highlightTint[s]):0!==p&&p-1!==this.highlightLevel[s]||(f.uniforms.contourColor=this.contourColor[s],f.uniforms.contourTint=this.contourTint[s]),f.uniforms.height=this.contourLevels[s][p],d.draw(r.LINES,this._contourCounts[s][p],this._contourOffsets[s][p])}for(d=this._dynamicVAO,d.bind(),i=0;i<3;++i)if(0!==this._dynamicCounts[i])for(f.uniforms.model=n.model,f.uniforms.clipBounds=n.clipBounds,f.uniforms.permutation=O[i],r.lineWidth(this.dynamicWidth[i]),f.uniforms.contourColor=this.dynamicColor[i],f.uniforms.contourTint=this.dynamicTint[i],f.uniforms.height=this.dynamicLevel[i],d.draw(r.LINES,this._dynamicCounts[i],this._dynamicOffsets[i]),s=0;s<3;++s)this.contourProject[s][i]&&(f.uniforms.model=h.projections[s],f.uniforms.clipBounds=h.clipBounds[s],d.draw(r.LINES,this._dynamicCounts[i],this._dynamicOffsets[i]));d.unbind()}}function l(t,e){var r=e.shape.slice(),n=t.shape.slice();b.assign(t.lo(1,1).hi(r[0],r[1]),e),b.assign(t.lo(1).hi(r[0],1),e.hi(r[0],1)),b.assign(t.lo(1,n[1]-1).hi(r[0],1),e.lo(0,r[1]-1).hi(r[0],1)),b.assign(t.lo(0,1).hi(1,r[1]),e.hi(1)),b.assign(t.lo(n[0]-1,1).hi(1,r[1]),e.lo(r[0]-1)),t.set(0,0,e.get(0,0)),t.set(0,n[1]-1,e.get(0,r[1]-1)),t.set(n[0]-1,0,e.get(r[0]-1,0)),t.set(n[0]-1,n[1]-1,e.get(r[0]-1,r[1]-1))}function u(t,e){return Array.isArray(t)?[e(t[0]),e(t[1]),e(t[2])]:[e(t),e(t),e(t)]}function c(t){return Array.isArray(t)?3===t.length?[t[0],t[1],t[2],1]:[t[0],t[1],t[2],t[3]]:[0,0,0,1]}function h(t){if(Array.isArray(t)){if(Array.isArray(t))return[c(t[0]),c(t[1]),c(t[2])];var e=c(t);return[e.slice(),e.slice(),e.slice()]}}function f(t){var e=t.gl,r=E(e),n=C(e),i=L(e),o=z(e),s=p(e),l=m(e,[{buffer:s,size:4,stride:I,offset:0},{buffer:s,size:3,stride:I,offset:16},{buffer:s,size:3,stride:I,offset:28}]),u=p(e),c=m(e,[{buffer:u,size:4,stride:20,offset:0},{buffer:u,size:1,stride:20,offset:16}]),h=p(e),f=m(e,[{buffer:h,size:2,type:e.FLOAT}]),d=v(e,1,R,e.RGBA,e.UNSIGNED_BYTE);d.minFilter=e.LINEAR,d.magFilter=e.LINEAR;var g=new a(e,[0,0],[[0,0,0],[0,0,0]],r,n,s,l,d,i,o,u,c,h,f),y={levels:[[],[],[]]};for(var b in t)y[b]=t[b];return y.colormap=y.colormap||\"jet\",g.update(y),g}e.exports=f\n",
       ";var d=t(\"bit-twiddle\"),p=t(\"gl-buffer\"),m=t(\"gl-vao\"),v=t(\"gl-texture2d\"),g=t(\"typedarray-pool\"),y=t(\"colormap\"),b=t(\"ndarray-ops\"),x=t(\"ndarray-pack\"),_=t(\"ndarray\"),w=t(\"surface-nets\"),M=t(\"gl-mat4/multiply\"),k=t(\"gl-mat4/invert\"),A=t(\"binary-search-bounds\"),T=t(\"ndarray-gradient\"),S=t(\"./lib/shaders\"),E=S.createShader,L=S.createContourShader,C=S.createPickShader,z=S.createPickContourShader,I=40,D=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],P=[[0,0],[0,1],[1,0],[1,1],[1,0],[0,1]],O=[[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0]];!function(){for(var t=0;t<3;++t){var e=O[t],r=(t+1)%3,n=(t+2)%3;e[r+0]=1,e[n+3]=1,e[t+6]=1}}();var R=256,F=a.prototype;F.isTransparent=function(){return this.opacity<1},F.isOpaque=function(){if(this.opacity>=1)return!0;for(var t=0;t<3;++t)if(this._contourCounts[t].length>0||this._dynamicCounts[t]>0)return!0;return!1},F.pickSlots=1,F.setPickBase=function(t){this.pickId=t};var j=[0,0,0],N={showSurface:!1,showContour:!1,projections:[D.slice(),D.slice(),D.slice()],clipBounds:[[[0,0,0],[0,0,0]],[[0,0,0],[0,0,0]],[[0,0,0],[0,0,0]]]},B={model:D,view:D,projection:D,inverseModel:D.slice(),lowerBound:[0,0,0],upperBound:[0,0,0],colorMap:0,clipBounds:[[0,0,0],[0,0,0]],height:0,contourTint:0,contourColor:[0,0,0,1],permutation:[1,0,0,0,1,0,0,0,1],zOffset:-1e-4,kambient:1,kdiffuse:1,kspecular:1,lightPosition:[1e3,1e3,1e3],eyePosition:[0,0,0],roughness:1,fresnel:1,opacity:1,vertexColor:0},U=D.slice(),V=[1,0,0,0,1,0,0,0,1];F.draw=function(t){return s.call(this,t,!1)},F.drawTransparent=function(t){return s.call(this,t,!0)};var H={model:D,view:D,projection:D,inverseModel:D,clipBounds:[[0,0,0],[0,0,0]],height:0,shape:[0,0],pickId:0,lowerBound:[0,0,0],upperBound:[0,0,0],zOffset:0,permutation:[1,0,0,0,1,0,0,0,1],lightPosition:[0,0,0],eyePosition:[0,0,0]};F.drawPick=function(t){t=t||{};var e=this.gl;e.disable(e.CULL_FACE);var r=H;r.model=t.model||D,r.view=t.view||D,r.projection=t.projection||D,r.shape=this._field[2].shape,r.pickId=this.pickId/255,r.lowerBound=this.bounds[0],r.upperBound=this.bounds[1],r.permutation=V;for(var n=0;n<2;++n)for(var i=r.clipBounds[n],a=0;a<3;++a)i[a]=Math.min(Math.max(this.clipBounds[n][a],-1e8),1e8);var s=o(r,this);if(s.showSurface){for(this._pickShader.bind(),this._pickShader.uniforms=r,this._vao.bind(),this._vao.draw(e.TRIANGLES,this._vertexCount),n=0;n<3;++n)this.surfaceProject[n]&&(this._pickShader.uniforms.model=s.projections[n],this._pickShader.uniforms.clipBounds=s.clipBounds[n],this._vao.draw(e.TRIANGLES,this._vertexCount));this._vao.unbind()}if(s.showContour){var l=this._contourPickShader;l.bind(),l.uniforms=r;var u=this._contourVAO;for(u.bind(),a=0;a<3;++a)for(e.lineWidth(this.contourWidth[a]),l.uniforms.permutation=O[a],n=0;n<this.contourLevels[a].length;++n)this._contourCounts[a][n]&&(l.uniforms.height=this.contourLevels[a][n],u.draw(e.LINES,this._contourCounts[a][n],this._contourOffsets[a][n]));for(n=0;n<3;++n)for(l.uniforms.model=s.projections[n],l.uniforms.clipBounds=s.clipBounds[n],a=0;a<3;++a)if(this.contourProject[n][a]){l.uniforms.permutation=O[a],e.lineWidth(this.contourWidth[a]);for(var c=0;c<this.contourLevels[a].length;++c)this._contourCounts[a][c]&&(l.uniforms.height=this.contourLevels[a][c],u.draw(e.LINES,this._contourCounts[a][c],this._contourOffsets[a][c]))}u.unbind()}},F.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=this._field[2].shape,r=this._pickResult,n=e[0]*(t.value[0]+(t.value[2]>>4)/16)/255,i=Math.floor(n),a=n-i,o=e[1]*(t.value[1]+(15&t.value[2])/16)/255,s=Math.floor(o),l=o-s;i+=1,s+=1;var u=r.position;u[0]=u[1]=u[2]=0;for(var c=0;c<2;++c)for(var h=c?a:1-a,f=0;f<2;++f)for(var d=f?l:1-l,p=i+c,m=s+f,v=h*d,g=0;g<3;++g)u[g]+=this._field[g].get(p,m)*v;for(var y=this._pickResult.level,b=0;b<3;++b)if(y[b]=A.le(this.contourLevels[b],u[b]),y[b]<0)this.contourLevels[b].length>0&&(y[b]=0);else if(y[b]<this.contourLevels[b].length-1){var x=this.contourLevels[b][y[b]],_=this.contourLevels[b][y[b]+1];Math.abs(x-u[b])>Math.abs(_-u[b])&&(y[b]+=1)}for(r.index[0]=a<.5?i:i+1,r.index[1]=l<.5?s:s+1,r.uv[0]=n/e[0],r.uv[1]=o/e[1],g=0;g<3;++g)r.dataCoordinate[g]=this._field[g].get(r.index[0],r.index[1]);return r},F.update=function(t){t=t||{},this.dirty=!0,\"contourWidth\"in t&&(this.contourWidth=u(t.contourWidth,Number)),\"showContour\"in t&&(this.showContour=u(t.showContour,Boolean)),\"showSurface\"in t&&(this.showSurface=!!t.showSurface),\"contourTint\"in t&&(this.contourTint=u(t.contourTint,Boolean)),\"contourColor\"in t&&(this.contourColor=h(t.contourColor)),\"contourProject\"in t&&(this.contourProject=u(t.contourProject,function(t){return u(t,Boolean)})),\"surfaceProject\"in t&&(this.surfaceProject=t.surfaceProject),\"dynamicColor\"in t&&(this.dynamicColor=h(t.dynamicColor)),\"dynamicTint\"in t&&(this.dynamicTint=u(t.dynamicTint,Number)),\"dynamicWidth\"in t&&(this.dynamicWidth=u(t.dynamicWidth,Number)),\"opacity\"in t&&(this.opacity=t.opacity),\"colorBounds\"in t&&(this.colorBounds=t.colorBounds),\"vertexColor\"in t&&(this.vertexColor=t.vertexColor?1:0);var e=t.field||t.coords&&t.coords[2]||null,r=!1;if(e||(e=this._field[2].shape[0]||this._field[2].shape[2]?this._field[2].lo(1,1).hi(this._field[2].shape[0]-2,this._field[2].shape[1]-2):this._field[2].hi(0,0)),\"field\"in t||\"coords\"in t){var n=(e.shape[0]+2)*(e.shape[1]+2);n>this._field[2].data.length&&(g.freeFloat(this._field[2].data),this._field[2].data=g.mallocFloat(d.nextPow2(n))),this._field[2]=_(this._field[2].data,[e.shape[0]+2,e.shape[1]+2]),l(this._field[2],e),this.shape=e.shape.slice();for(var a=this.shape,o=0;o<2;++o)this._field[2].size>this._field[o].data.length&&(g.freeFloat(this._field[o].data),this._field[o].data=g.mallocFloat(this._field[2].size)),this._field[o]=_(this._field[o].data,[a[0]+2,a[1]+2]);if(t.coords){var s=t.coords;if(!Array.isArray(s)||3!==s.length)throw new Error(\"gl-surface: invalid coordinates for x/y\");for(o=0;o<2;++o){var c=s[o];for(y=0;y<2;++y)if(c.shape[y]!==a[y])throw new Error(\"gl-surface: coords have incorrect shape\");l(this._field[o],c)}}else if(t.ticks){var f=t.ticks;if(!Array.isArray(f)||2!==f.length)throw new Error(\"gl-surface: invalid ticks\");for(o=0;o<2;++o){var p=f[o];if((Array.isArray(p)||p.length)&&(p=_(p)),p.shape[0]!==a[o])throw new Error(\"gl-surface: invalid tick length\");var m=_(p.data,a);m.stride[o]=p.stride[0],m.stride[1^o]=0,l(this._field[o],m)}}else{for(o=0;o<2;++o){var v=[0,0];v[o]=1,this._field[o]=_(this._field[o].data,[a[0]+2,a[1]+2],v,0)}this._field[0].set(0,0,0);for(var y=0;y<a[0];++y)this._field[0].set(y+1,0,y);for(this._field[0].set(a[0]+1,0,a[0]-1),this._field[1].set(0,0,0),y=0;y<a[1];++y)this._field[1].set(0,y+1,y);this._field[1].set(0,a[1]+1,a[1]-1)}var b=this._field,x=_(g.mallocFloat(3*b[2].size*2),[3,a[0]+2,a[1]+2,2]);for(o=0;o<3;++o)T(x.pick(o),b[o],\"mirror\");var M=_(g.mallocFloat(3*b[2].size),[a[0]+2,a[1]+2,3]);for(o=0;o<a[0]+2;++o)for(y=0;y<a[1]+2;++y){var k=x.get(0,o,y,0),A=x.get(0,o,y,1),S=x.get(1,o,y,0),E=x.get(1,o,y,1),L=x.get(2,o,y,0),C=x.get(2,o,y,1),z=S*C-E*L,I=L*A-C*k,D=k*E-A*S,O=Math.sqrt(z*z+I*I+D*D);O<1e-8?(O=Math.max(Math.abs(z),Math.abs(I),Math.abs(D)),O<1e-8?(D=1,I=z=0,O=1):O=1/O):O=1/Math.sqrt(O),M.set(o,y,0,z*O),M.set(o,y,1,I*O),M.set(o,y,2,D*O)}g.free(x.data);var R=[1/0,1/0,1/0],F=[-1/0,-1/0,-1/0],j=1/0,N=-1/0,B=(a[0]-1)*(a[1]-1)*6,U=g.mallocFloat(d.nextPow2(10*B)),V=0,H=0;for(o=0;o<a[0]-1;++o)t:for(y=0;y<a[1]-1;++y){for(var q=0;q<2;++q)for(var G=0;G<2;++G)for(var Y=0;Y<3;++Y){var X=this._field[Y].get(1+o+q,1+y+G);if(isNaN(X)||!isFinite(X))continue t}for(Y=0;Y<6;++Y){var W=o+P[Y][0],Z=y+P[Y][1],J=this._field[0].get(W+1,Z+1),K=this._field[1].get(W+1,Z+1);X=this._field[2].get(W+1,Z+1);var Q=X;z=M.get(W+1,Z+1,0),I=M.get(W+1,Z+1,1),D=M.get(W+1,Z+1,2),t.intensity&&(Q=t.intensity.get(W,Z)),U[V++]=W,U[V++]=Z,U[V++]=J,U[V++]=K,U[V++]=X,U[V++]=0,U[V++]=Q,U[V++]=z,U[V++]=I,U[V++]=D,R[0]=Math.min(R[0],J),R[1]=Math.min(R[1],K),R[2]=Math.min(R[2],X),j=Math.min(j,Q),F[0]=Math.max(F[0],J),F[1]=Math.max(F[1],K),F[2]=Math.max(F[2],X),N=Math.max(N,Q),H+=1}}for(t.intensityBounds&&(j=+t.intensityBounds[0],N=+t.intensityBounds[1]),o=6;o<V;o+=10)U[o]=(U[o]-j)/(N-j);this._vertexCount=H,this._coordinateBuffer.update(U.subarray(0,V)),g.freeFloat(U),g.free(M.data),this.bounds=[R,F],this.intensity=t.intensity||this._field[2],this.intensityBounds[0]===j&&this.intensityBounds[1]===N||(r=!0),this.intensityBounds=[j,N]}if(\"levels\"in t){var $=t.levels;for($=Array.isArray($[0])?$.slice():[[],[],$],o=0;o<3;++o)$[o]=$[o].slice(),$.sort(function(t,e){return t-e});t:for(o=0;o<3;++o){if($[o].length!==this.contourLevels[o].length){r=!0;break}for(y=0;y<$[o].length;++y)if($[o][y]!==this.contourLevels[o][y]){r=!0;break t}}this.contourLevels=$}if(r){b=this._field,a=this.shape;for(var tt=[],et=0;et<3;++et){$=this.contourLevels[et];var rt=[],nt=[],it=[0,0,0];for(o=0;o<$.length;++o){var at=w(this._field[et],$[o]);rt.push(tt.length/5|0),H=0;t:for(y=0;y<at.cells.length;++y){var ot=at.cells[y];for(Y=0;Y<2;++Y){var st=at.positions[ot[Y]],lt=st[0],ut=0|Math.floor(lt),ct=lt-ut,ht=st[1],ft=0|Math.floor(ht),dt=ht-ft,pt=!1;e:for(var mt=0;mt<3;++mt){it[mt]=0;var vt=(et+mt+1)%3;for(q=0;q<2;++q){var gt=q?ct:1-ct;for(W=0|Math.min(Math.max(ut+q,0),a[0]),G=0;G<2;++G){var yt=G?dt:1-dt;if(Z=0|Math.min(Math.max(ft+G,0),a[1]),X=mt<2?this._field[vt].get(W,Z):(this.intensity.get(W,Z)-this.intensityBounds[0])/(this.intensityBounds[1]-this.intensityBounds[0]),!isFinite(X)||isNaN(X)){pt=!0;break e}var bt=gt*yt;it[mt]+=bt*X}}}if(pt){if(Y>0){for(var xt=0;xt<5;++xt)tt.pop();H-=1}continue t}tt.push(it[0],it[1],st[0],st[1],it[2]),H+=1}}nt.push(H)}this._contourOffsets[et]=rt,this._contourCounts[et]=nt}var _t=g.mallocFloat(tt.length);for(o=0;o<tt.length;++o)_t[o]=tt[o];this._contourBuffer.update(_t),g.freeFloat(_t)}t.colormap&&this._colorMap.setPixels(i(t.colormap))},F.dispose=function(){this._shader.dispose(),this._vao.dispose(),this._coordinateBuffer.dispose(),this._colorMap.dispose(),this._contourBuffer.dispose(),this._contourVAO.dispose(),this._contourShader.dispose(),this._contourPickShader.dispose(),this._dynamicBuffer.dispose(),this._dynamicVAO.dispose();for(var t=0;t<3;++t)g.freeFloat(this._field[t].data)},F.highlight=function(t){if(!t)return this._dynamicCounts=[0,0,0],this.dyanamicLevel=[NaN,NaN,NaN],void(this.highlightLevel=[-1,-1,-1]);for(var e=0;e<3;++e)this.enableHighlight[e]?this.highlightLevel[e]=t.level[e]:this.highlightLevel[e]=-1;var r;if(r=this.snapToData?t.dataCoordinate:t.position,this.enableDynamic[0]&&r[0]!==this.dynamicLevel[0]||this.enableDynamic[1]&&r[1]!==this.dynamicLevel[1]||this.enableDynamic[2]&&r[2]!==this.dynamicLevel[2]){for(var n=0,i=this.shape,a=g.mallocFloat(12*i[0]*i[1]),o=0;o<3;++o)if(this.enableDynamic[o]){this.dynamicLevel[o]=r[o];var s=(o+1)%3,l=(o+2)%3,u=this._field[o],c=this._field[s],h=this._field[l],f=(this.intensity,w(u,r[o])),d=f.cells,p=f.positions;for(this._dynamicOffsets[o]=n,e=0;e<d.length;++e)for(var m=d[e],v=0;v<2;++v){var y=p[m[v]],b=+y[0],x=0|b,_=0|Math.min(x+1,i[0]),M=b-x,k=1-M,A=+y[1],T=0|A,S=0|Math.min(T+1,i[1]),E=A-T,L=1-E,C=k*L,z=k*E,I=M*L,D=M*E,P=C*c.get(x,T)+z*c.get(x,S)+I*c.get(_,T)+D*c.get(_,S),O=C*h.get(x,T)+z*h.get(x,S)+I*h.get(_,T)+D*h.get(_,S);if(isNaN(P)||isNaN(O)){v&&(n-=1);break}a[2*n+0]=P,a[2*n+1]=O,n+=1}this._dynamicCounts[o]=n-this._dynamicOffsets[o]}else this.dynamicLevel[o]=NaN,this._dynamicCounts[o]=0;this._dynamicBuffer.update(a.subarray(0,2*n)),g.freeFloat(a)}}},{\"./lib/shaders\":264,\"binary-search-bounds\":65,\"bit-twiddle\":66,colormap:98,\"gl-buffer\":155,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"gl-texture2d\":266,\"gl-vao\":270,ndarray:466,\"ndarray-gradient\":457,\"ndarray-ops\":460,\"ndarray-pack\":461,\"surface-nets\":530,\"typedarray-pool\":540}],266:[function(t,e,r){\"use strict\";function n(t){g=[t.LINEAR,t.NEAREST_MIPMAP_LINEAR,t.LINEAR_MIPMAP_NEAREST,t.LINEAR_MIPMAP_NEAREST],y=[t.NEAREST,t.LINEAR,t.NEAREST_MIPMAP_NEAREST,t.NEAREST_MIPMAP_LINEAR,t.LINEAR_MIPMAP_NEAREST,t.LINEAR_MIPMAP_LINEAR],b=[t.REPEAT,t.CLAMP_TO_EDGE,t.MIRRORED_REPEAT]}function i(t){return\"undefined\"!=typeof HTMLCanvasElement&&t instanceof HTMLCanvasElement||\"undefined\"!=typeof HTMLImageElement&&t instanceof HTMLImageElement||\"undefined\"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement||\"undefined\"!=typeof ImageData&&t instanceof ImageData}function a(t,e,r){var n=t.gl,i=n.getParameter(n.MAX_TEXTURE_SIZE);if(e<0||e>i||r<0||r>i)throw new Error(\"gl-texture2d: Invalid texture size\");return t._shape=[e,r],t.bind(),n.texImage2D(n.TEXTURE_2D,0,t.format,e,r,0,t.format,t.type,null),t._mipLevels=[0],t}function o(t,e,r,n,i,a){this.gl=t,this.handle=e,this.format=i,this.type=a,this._shape=[r,n],this._mipLevels=[0],this._magFilter=t.NEAREST,this._minFilter=t.NEAREST,this._wrapS=t.CLAMP_TO_EDGE,this._wrapT=t.CLAMP_TO_EDGE,this._anisoSamples=1;var o=this,s=[this._wrapS,this._wrapT];Object.defineProperties(s,[{get:function(){return o._wrapS},set:function(t){return o.wrapS=t}},{get:function(){return o._wrapT},set:function(t){return o.wrapT=t}}]),this._wrapVector=s;var l=[this._shape[0],this._shape[1]];Object.defineProperties(l,[{get:function(){return o._shape[0]},set:function(t){return o.width=t}},{get:function(){return o._shape[1]},set:function(t){return o.height=t}}]),this._shapeVector=l}function s(t,e){return 3===t.length?1===e[2]&&e[1]===t[0]*t[2]&&e[0]===t[2]:1===e[0]&&e[1]===t[0]}function l(t,e,r,n,i,a,o,l){var u=l.dtype,c=l.shape.slice();if(c.length<2||c.length>3)throw new Error(\"gl-texture2d: Invalid ndarray, must be 2d or 3d\");var h=0,f=0,d=s(c,l.stride.slice());\"float32\"===u?h=t.FLOAT:\"float64\"===u?(h=t.FLOAT,d=!1,u=\"float32\"):\"uint8\"===u?h=t.UNSIGNED_BYTE:(h=t.UNSIGNED_BYTE,d=!1,u=\"uint8\");if(2===c.length)f=t.LUMINANCE,c=[c[0],c[1],1],l=p(l.data,c,[l.stride[0],l.stride[1],1],l.offset);else{if(3!==c.length)throw new Error(\"gl-texture2d: Invalid shape for texture\");if(1===c[2])f=t.ALPHA;else if(2===c[2])f=t.LUMINANCE_ALPHA;else if(3===c[2])f=t.RGB;else{if(4!==c[2])throw new Error(\"gl-texture2d: Invalid shape for pixel coords\");f=t.RGBA}c[2]}if(f!==t.LUMINANCE&&f!==t.ALPHA||i!==t.LUMINANCE&&i!==t.ALPHA||(f=i),f!==i)throw new Error(\"gl-texture2d: Incompatible texture format for setPixels\");var g=l.size,y=o.indexOf(n)<0;if(y&&o.push(n),h===a&&d)0===l.offset&&l.data.length===g?y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,l.data):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,l.data):y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,l.data.subarray(l.offset,l.offset+g)):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,l.data.subarray(l.offset,l.offset+g));else{var b;b=a===t.FLOAT?v.mallocFloat32(g):v.mallocUint8(g);var _=p(b,c,[c[2],c[2]*c[0],1]);h===t.FLOAT&&a===t.UNSIGNED_BYTE?x(_,l):m.assign(_,l),y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,b.subarray(0,g)):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,b.subarray(0,g)),a===t.FLOAT?v.freeFloat32(b):v.freeUint8(b)}}function u(t){var e=t.createTexture();return t.bindTexture(t.TEXTURE_2D,e),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),e}function c(t,e,r,n,i){var a=t.getParameter(t.MAX_TEXTURE_SIZE);if(e<0||e>a||r<0||r>a)throw new Error(\"gl-texture2d: Invalid texture shape\");if(i===t.FLOAT&&!t.getExtension(\"OES_texture_float\"))throw new Error(\"gl-texture2d: Floating point textures not supported on this platform\");var s=u(t);return t.texImage2D(t.TEXTURE_2D,0,n,e,r,0,n,i,null),new o(t,s,e,r,n,i)}function h(t,e,r,n,i,a){var s=u(t);return t.texImage2D(t.TEXTURE_2D,0,i,i,a,e),new o(t,s,r,n,i,a)}function f(t,e){var r=e.dtype,n=e.shape.slice(),i=t.getParameter(t.MAX_TEXTURE_SIZE);if(n[0]<0||n[0]>i||n[1]<0||n[1]>i)throw new Error(\"gl-texture2d: Invalid texture size\");var a=s(n,e.stride.slice()),l=0;\"float32\"===r?l=t.FLOAT:\"float64\"===r?(l=t.FLOAT,a=!1,r=\"float32\"):\"uint8\"===r?l=t.UNSIGNED_BYTE:(l=t.UNSIGNED_BYTE,a=!1,r=\"uint8\");var c=0;if(2===n.length)c=t.LUMINANCE,n=[n[0],n[1],1],e=p(e.data,n,[e.stride[0],e.stride[1],1],e.offset);else{if(3!==n.length)throw new Error(\"gl-texture2d: Invalid shape for texture\");if(1===n[2])c=t.ALPHA;else if(2===n[2])c=t.LUMINANCE_ALPHA;else if(3===n[2])c=t.RGB;else{if(4!==n[2])throw new Error(\"gl-texture2d: Invalid shape for pixel coords\");c=t.RGBA}}l!==t.FLOAT||t.getExtension(\"OES_texture_float\")||(l=t.UNSIGNED_BYTE,a=!1);var h,f,d=e.size;if(a)h=0===e.offset&&e.data.length===d?e.data:e.data.subarray(e.offset,e.offset+d);else{var g=[n[2],n[2]*n[0],1];f=v.malloc(d,r);var y=p(f,n,g,0);\"float32\"!==r&&\"float64\"!==r||l!==t.UNSIGNED_BYTE?m.assign(y,e):x(y,e),h=f.subarray(0,d)}var b=u(t);return t.texImage2D(t.TEXTURE_2D,0,c,n[0],n[1],0,c,l,h),a||v.free(f),new o(t,b,n[0],n[1],c,l)}function d(t){if(arguments.length<=1)throw new Error(\"gl-texture2d: Missing arguments for texture2d constructor\");if(g||n(t),\"number\"==typeof arguments[1])return c(t,arguments[1],arguments[2],arguments[3]||t.RGBA,arguments[4]||t.UNSIGNED_BYTE);if(Array.isArray(arguments[1]))return c(t,0|arguments[1][0],0|arguments[1][1],arguments[2]||t.RGBA,arguments[3]||t.UNSIGNED_BYTE);if(\"object\"==typeof arguments[1]){var e=arguments[1],r=i(e)?e:e.raw;if(r)return h(t,r,0|e.width,0|e.height,arguments[2]||t.RGBA,arguments[3]||t.UNSIGNED_BYTE);if(e.shape&&e.data&&e.stride)return f(t,e)}throw new Error(\"gl-texture2d: Invalid arguments for texture2d constructor\")}var p=t(\"ndarray\"),m=t(\"ndarray-ops\"),v=t(\"typedarray-pool\");e.exports=d;var g=null,y=null,b=null,x=function(t,e){m.muls(t,e,255)},_=o.prototype;Object.defineProperties(_,{minFilter:{get:function(){return this._minFilter},set:function(t){this.bind();var e=this.gl;if(this.type===e.FLOAT&&g.indexOf(t)>=0&&(e.getExtension(\"OES_texture_float_linear\")||(t=e.NEAREST)),y.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown filter mode \"+t);return e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,t),this._minFilter=t}},magFilter:{get:function(){return this._magFilter},set:function(t){this.bind();var e=this.gl;if(this.type===e.FLOAT&&g.indexOf(t)>=0&&(e.getExtension(\"OES_texture_float_linear\")||(t=e.NEAREST)),y.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown filter mode \"+t);return e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,t),this._magFilter=t}},mipSamples:{get:function(){return this._anisoSamples},set:function(t){var e=this._anisoSamples;if(this._anisoSamples=0|Math.max(t,1),e!==this._anisoSamples){var r=this.gl.getExtension(\"EXT_texture_filter_anisotropic\");r&&this.gl.texParameterf(this.gl.TEXTURE_2D,r.TEXTURE_MAX_ANISOTROPY_EXT,this._anisoSamples)}return this._anisoSamples}},wrapS:{get:function(){return this._wrapS},set:function(t){if(this.bind(),b.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);return this.gl.texParameteri(this.gl.TEXTURE_2D,this.gl.TEXTURE_WRAP_S,t),this._wrapS=t}},wrapT:{get:function(){return this._wrapT},set:function(t){if(this.bind(),b.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);return this.gl.texParameteri(this.gl.TEXTURE_2D,this.gl.TEXTURE_WRAP_T,t),this._wrapT=t}},wrap:{get:function(){return this._wrapVector},set:function(t){if(Array.isArray(t)||(t=[t,t]),2!==t.length)throw new Error(\"gl-texture2d: Must specify wrap mode for rows and columns\");for(var e=0;e<2;++e)if(b.indexOf(t[e])<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);this._wrapS=t[0],this._wrapT=t[1];var r=this.gl;return this.bind(),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,this._wrapS),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,this._wrapT),t}},shape:{get:function(){return this._shapeVector},set:function(t){if(Array.isArray(t)){if(2!==t.length)throw new Error(\"gl-texture2d: Invalid texture shape\")}else t=[0|t,0|t];return a(this,0|t[0],0|t[1]),[0|t[0],0|t[1]]}},width:{get:function(){return this._shape[0]},set:function(t){return t|=0,a(this,t,this._shape[1]),t}},height:{get:function(){return this._shape[1]},set:function(t){return t|=0,a(this,this._shape[0],t),t}}}),_.bind=function(t){var e=this.gl;return void 0!==t&&e.activeTexture(e.TEXTURE0+(0|t)),e.bindTexture(e.TEXTURE_2D,this.handle),void 0!==t?0|t:e.getParameter(e.ACTIVE_TEXTURE)-e.TEXTURE0},_.dispose=function(){this.gl.deleteTexture(this.handle)},_.generateMipmap=function(){this.bind(),this.gl.generateMipmap(this.gl.TEXTURE_2D);for(var t=Math.min(this._shape[0],this._shape[1]),e=0;t>0;++e,t>>>=1)this._mipLevels.indexOf(e)<0&&this._mipLevels.push(e)},_.setPixels=function(t,e,r,n){var a=this.gl;this.bind(),Array.isArray(e)?(n=r,r=0|e[1],e=0|e[0]):(e=e||0,r=r||0),n=n||0;var o=i(t)?t:t.raw;if(o){this._mipLevels.indexOf(n)<0?(a.texImage2D(a.TEXTURE_2D,0,this.format,this.format,this.type,o),this._mipLevels.push(n)):a.texSubImage2D(a.TEXTURE_2D,n,e,r,this.format,this.type,o)}else{if(!(t.shape&&t.stride&&t.data))throw new Error(\"gl-texture2d: Unsupported data type\");if(t.shape.length<2||e+t.shape[1]>this._shape[1]>>>n||r+t.shape[0]>this._shape[0]>>>n||e<0||r<0)throw new Error(\"gl-texture2d: Texture dimensions are out of bounds\");l(a,e,r,n,this.format,this.type,this._mipLevels,t)}}},{ndarray:466,\"ndarray-ops\":460,\"typedarray-pool\":540}],267:[function(t,e,r){\"use strict\";function n(t,e,r){e?e.bind():t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,null);var n=0|t.getParameter(t.MAX_VERTEX_ATTRIBS);if(r){if(r.length>n)throw new Error(\"gl-vao: Too many vertex attributes\");for(var i=0;i<r.length;++i){var a=r[i];if(a.buffer){var o=a.buffer,s=a.size||4,l=a.type||t.FLOAT,u=!!a.normalized,c=a.stride||0,h=a.offset||0;o.bind(),t.enableVertexAttribArray(i),t.vertexAttribPointer(i,s,l,u,c,h)}else{if(\"number\"==typeof a)t.vertexAttrib1f(i,a);else if(1===a.length)t.vertexAttrib1f(i,a[0]);else if(2===a.length)t.vertexAttrib2f(i,a[0],a[1]);else if(3===a.length)t.vertexAttrib3f(i,a[0],a[1],a[2]);else{if(4!==a.length)throw new Error(\"gl-vao: Invalid vertex attribute\");t.vertexAttrib4f(i,a[0],a[1],a[2],a[3])}t.disableVertexAttribArray(i)}}for(;i<n;++i)t.disableVertexAttribArray(i)}else{t.bindBuffer(t.ARRAY_BUFFER,null);for(var i=0;i<n;++i)t.disableVertexAttribArray(i)}}e.exports=n},{}],268:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this._elements=null,this._attributes=null,this._elementsType=t.UNSIGNED_SHORT}function i(t){return new n(t)}var a=t(\"./do-bind.js\");n.prototype.bind=function(){a(this.gl,this._elements,this._attributes)},n.prototype.update=function(t,e,r){this._elements=e,this._attributes=t,this._elementsType=r||this.gl.UNSIGNED_SHORT},n.prototype.dispose=function(){},n.prototype.unbind=function(){},n.prototype.draw=function(t,e,r){r=r||0;var n=this.gl;this._elements?n.drawElements(t,e,this._elementsType,r):n.drawArrays(t,r,e)},e.exports=i},{\"./do-bind.js\":267}],269:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this.location=t,this.dimension=e,this.a=r,this.b=n,this.c=i,this.d=a}function i(t,e,r){this.gl=t,this._ext=e,this.handle=r,this._attribs=[],this._useElements=!1,this._elementsType=t.UNSIGNED_SHORT}function a(t,e){return new i(t,e,e.createVertexArrayOES())}var o=t(\"./do-bind.js\");n.prototype.bind=function(t){switch(this.dimension){case 1:t.vertexAttrib1f(this.location,this.a);break;case 2:t.vertexAttrib2f(this.location,this.a,this.b);break;case 3:t.vertexAttrib3f(this.location,this.a,this.b,this.c);break;case 4:t.vertexAttrib4f(this.location,this.a,this.b,this.c,this.d)}},i.prototype.bind=function(){this._ext.bindVertexArrayOES(this.handle);for(var t=0;t<this._attribs.length;++t)this._attribs[t].bind(this.gl)},i.prototype.unbind=function(){this._ext.bindVertexArrayOES(null)},i.prototype.dispose=function(){this._ext.deleteVertexArrayOES(this.handle)},i.prototype.update=function(t,e,r){if(this.bind(),o(this.gl,e,t),this.unbind(),this._attribs.length=0,t)for(var i=0;i<t.length;++i){var a=t[i];\"number\"==typeof a?this._attribs.push(new n(i,1,a)):Array.isArray(a)&&this._attribs.push(new n(i,a.length,a[0],a[1],a[2],a[3]))}this._useElements=!!e,this._elementsType=r||this.gl.UNSIGNED_SHORT},i.prototype.draw=function(t,e,r){r=r||0;var n=this.gl;this._useElements?n.drawElements(t,e,this._elementsType,r):n.drawArrays(t,r,e)},e.exports=a},{\"./do-bind.js\":267}],270:[function(t,e,r){\"use strict\";function n(t){this.bindVertexArrayOES=t.bindVertexArray.bind(t),this.createVertexArrayOES=t.createVertexArray.bind(t),this.deleteVertexArrayOES=t.deleteVertexArray.bind(t)}function i(t,e,r,i){var s,l=t.createVertexArray?new n(t):t.getExtension(\"OES_vertex_array_object\");return s=l?a(t,l):o(t),s.update(e,r,i),s}var a=t(\"./lib/vao-native.js\"),o=t(\"./lib/vao-emulated.js\");e.exports=i},{\"./lib/vao-emulated.js\":268,\"./lib/vao-native.js\":269}],271:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2];return t[0]=i*l-a*s,t[1]=a*o-n*l,t[2]=n*s-i*o,t}e.exports=n},{}],272:[function(t,e,r){function n(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}e.exports=n},{}],273:[function(t,e,r){function n(t){var e=t[0],r=t[1],n=t[2];return Math.sqrt(e*e+r*r+n*n)}e.exports=n},{}],274:[function(t,e,r){function n(t,e,r,n){var i=e[0],a=e[1],o=e[2];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t}e.exports=n},{}],275:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=r*r+n*n+i*i;return a>0&&(a=1/Math.sqrt(a),t[0]=e[0]*a,t[1]=e[1]*a,t[2]=e[2]*a),t}e.exports=n},{}],276:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t}e.exports=n},{}],277:[function(t,e,r){function n(t,e,r,n){return i[0]=n,i[1]=r,i[2]=e,i[3]=t,a[0]}e.exports=n;var i=new Uint8Array(4),a=new Float32Array(i.buffer)},{}],278:[function(t,e,r){function n(t){for(var e=Array.isArray(t)?t:i(t),r=0;r<e.length;r++){var n=e[r];if(\"preprocessor\"===n.type){var o=n.data.match(/\\#define\\s+SHADER_NAME(_B64)?\\s+(.+)$/);if(o&&o[2]){var s=o[1],l=o[2];return(s?a(l):l).trim()}}}}var i=t(\"glsl-tokenizer\"),a=t(\"atob-lite\");e.exports=n},{\"atob-lite\":47,\"glsl-tokenizer\":285}],279:[function(t,e,r){function n(t){function e(t){t.length&&V.push({type:M[B],data:t,position:G,line:H,column:q})}function r(t){j=0,W+=t,F=W.length;for(var e;O=W[j],j<F;){switch(e=j,B){case h:j=E();break;case f:j=S();break;case d:j=T();break;case p:j=L();break;case m:j=I();break;case w:j=z();break;case v:j=D();break;case c:j=P();break;case x:j=A();break;case u:j=k()}if(e!==j)switch(W[e]){case\"\\n\":q=0,++H;break;default:++q}}return N+=j,W=W.slice(j),V}function n(t){return U.length&&e(U.join(\"\")),B=_,e(\"(eof)\"),V}function k(){return U=U.length?[]:U,\"/\"===R&&\"*\"===O?(G=N+j-1,B=h,R=O,j+1):\"/\"===R&&\"/\"===O?(G=N+j-1,B=f,R=O,j+1):\"#\"===O?(B=d,G=N+j,j):/\\s/.test(O)?(B=x,G=N+j,j):(Y=/\\d/.test(O),X=/[^\\w_]/.test(O),G=N+j,B=Y?m:X?p:c,j)}function A(){return/[^\\s]/g.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function T(){return\"\\r\"!==O&&\"\\n\"!==O||\"\\\\\"===R?(U.push(O),R=O,j+1):(e(U.join(\"\")),B=u,j)}function S(){return T()}function E(){return\"/\"===O&&\"*\"===R?(U.push(O),e(U.join(\"\")),B=u,j+1):(U.push(O),R=O,j+1)}function L(){if(\".\"===R&&/\\d/.test(O))return B=v,j;if(\"/\"===R&&\"*\"===O)return B=h,j;if(\"/\"===R&&\"/\"===O)return B=f,j;if(\".\"===O&&U.length){for(;C(U););return B=v,j}if(\";\"===O||\")\"===O||\"(\"===O){if(U.length)for(;C(U););return e(O),B=u,j+1}var t=2===U.length&&\"=\"!==O;if(/[\\w_\\d\\s]/.test(O)||t){for(;C(U););return B=u,j}return U.push(O),R=O,j+1}function C(t){for(var r,n,i=0;;){if(r=a.indexOf(t.slice(0,t.length+i).join(\"\")),n=a[r],-1===r){if(i--+t.length>0)continue;n=t.slice(0,1).join(\"\")}return e(n),G+=n.length,U=U.slice(n.length),U.length}}function z(){return/[^a-fA-F0-9]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function I(){return\".\"===O?(U.push(O),B=v,R=O,j+1):/[eE]/.test(O)?(U.push(O),B=v,R=O,j+1):\"x\"===O&&1===U.length&&\"0\"===U[0]?(B=w,U.push(O),R=O,j+1):/[^\\d]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function D(){return\"f\"===O&&(U.push(O),R=O,j+=1),/[eE]/.test(O)?(U.push(O),R=O,j+1):\"-\"===O&&/[eE]/.test(R)?(U.push(O),R=O,j+1):/[^\\d]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function P(){if(/[^\\d\\w_]/.test(O)){var t=U.join(\"\");return B=J.indexOf(t)>-1?b:Z.indexOf(t)>-1?y:g,e(U.join(\"\")),B=u,j}return U.push(O),R=O,j+1}var O,R,F,j=0,N=0,B=u,U=[],V=[],H=1,q=0,G=0,Y=!1,X=!1,W=\"\";t=t||{};var Z=o,J=i;return\"300 es\"===t.version&&(Z=l,J=s),function(t){return V=[],null!==t?r(t.replace?t.replace(/\\r\\n/g,\"\\n\"):t):n()}}e.exports=n;var i=t(\"./lib/literals\"),a=t(\"./lib/operators\"),o=t(\"./lib/builtins\"),s=t(\"./lib/literals-300es\"),l=t(\"./lib/builtins-300es\"),u=999,c=9999,h=0,f=1,d=2,p=3,m=4,v=5,g=6,y=7,b=8,x=9,_=10,w=11,M=[\"block-comment\",\"line-comment\",\"preprocessor\",\"operator\",\"integer\",\"float\",\"ident\",\"builtin\",\"keyword\",\"whitespace\",\"eof\",\"integer\"]},{\"./lib/builtins\":281,\"./lib/builtins-300es\":280,\"./lib/literals\":283,\"./lib/literals-300es\":282,\"./lib/operators\":284}],280:[function(t,e,r){var n=t(\"./builtins\");n=n.slice().filter(function(t){return!/^(gl\\_|texture)/.test(t)}),e.exports=n.concat([\"gl_VertexID\",\"gl_InstanceID\",\"gl_Position\",\"gl_PointSize\",\"gl_FragCoord\",\"gl_FrontFacing\",\"gl_FragDepth\",\"gl_PointCoord\",\"gl_MaxVertexAttribs\",\"gl_MaxVertexUniformVectors\",\"gl_MaxVertexOutputVectors\",\"gl_MaxFragmentInputVectors\",\"gl_MaxVertexTextureImageUnits\",\"gl_MaxCombinedTextureImageUnits\",\"gl_MaxTextureImageUnits\",\"gl_MaxFragmentUniformVectors\",\"gl_MaxDrawBuffers\",\"gl_MinProgramTexelOffset\",\"gl_MaxProgramTexelOffset\",\"gl_DepthRangeParameters\",\"gl_DepthRange\",\"trunc\",\"round\",\"roundEven\",\"isnan\",\"isinf\",\"floatBitsToInt\",\"floatBitsToUint\",\"intBitsToFloat\",\"uintBitsToFloat\",\"packSnorm2x16\",\"unpackSnorm2x16\",\"packUnorm2x16\",\"unpackUnorm2x16\",\"packHalf2x16\",\"unpackHalf2x16\",\"outerProduct\",\"transpose\",\"determinant\",\"inverse\",\"texture\",\"textureSize\",\"textureProj\",\"textureLod\",\"textureOffset\",\"texelFetch\",\"texelFetchOffset\",\"textureProjOffset\",\"textureLodOffset\",\"textureProjLod\",\"textureProjLodOffset\",\"textureGrad\",\"textureGradOffset\",\"textureProjGrad\",\"textureProjGradOffset\"])},{\"./builtins\":281}],281:[function(t,e,r){\n",
       "e.exports=[\"abs\",\"acos\",\"all\",\"any\",\"asin\",\"atan\",\"ceil\",\"clamp\",\"cos\",\"cross\",\"dFdx\",\"dFdy\",\"degrees\",\"distance\",\"dot\",\"equal\",\"exp\",\"exp2\",\"faceforward\",\"floor\",\"fract\",\"gl_BackColor\",\"gl_BackLightModelProduct\",\"gl_BackLightProduct\",\"gl_BackMaterial\",\"gl_BackSecondaryColor\",\"gl_ClipPlane\",\"gl_ClipVertex\",\"gl_Color\",\"gl_DepthRange\",\"gl_DepthRangeParameters\",\"gl_EyePlaneQ\",\"gl_EyePlaneR\",\"gl_EyePlaneS\",\"gl_EyePlaneT\",\"gl_Fog\",\"gl_FogCoord\",\"gl_FogFragCoord\",\"gl_FogParameters\",\"gl_FragColor\",\"gl_FragCoord\",\"gl_FragData\",\"gl_FragDepth\",\"gl_FragDepthEXT\",\"gl_FrontColor\",\"gl_FrontFacing\",\"gl_FrontLightModelProduct\",\"gl_FrontLightProduct\",\"gl_FrontMaterial\",\"gl_FrontSecondaryColor\",\"gl_LightModel\",\"gl_LightModelParameters\",\"gl_LightModelProducts\",\"gl_LightProducts\",\"gl_LightSource\",\"gl_LightSourceParameters\",\"gl_MaterialParameters\",\"gl_MaxClipPlanes\",\"gl_MaxCombinedTextureImageUnits\",\"gl_MaxDrawBuffers\",\"gl_MaxFragmentUniformComponents\",\"gl_MaxLights\",\"gl_MaxTextureCoords\",\"gl_MaxTextureImageUnits\",\"gl_MaxTextureUnits\",\"gl_MaxVaryingFloats\",\"gl_MaxVertexAttribs\",\"gl_MaxVertexTextureImageUnits\",\"gl_MaxVertexUniformComponents\",\"gl_ModelViewMatrix\",\"gl_ModelViewMatrixInverse\",\"gl_ModelViewMatrixInverseTranspose\",\"gl_ModelViewMatrixTranspose\",\"gl_ModelViewProjectionMatrix\",\"gl_ModelViewProjectionMatrixInverse\",\"gl_ModelViewProjectionMatrixInverseTranspose\",\"gl_ModelViewProjectionMatrixTranspose\",\"gl_MultiTexCoord0\",\"gl_MultiTexCoord1\",\"gl_MultiTexCoord2\",\"gl_MultiTexCoord3\",\"gl_MultiTexCoord4\",\"gl_MultiTexCoord5\",\"gl_MultiTexCoord6\",\"gl_MultiTexCoord7\",\"gl_Normal\",\"gl_NormalMatrix\",\"gl_NormalScale\",\"gl_ObjectPlaneQ\",\"gl_ObjectPlaneR\",\"gl_ObjectPlaneS\",\"gl_ObjectPlaneT\",\"gl_Point\",\"gl_PointCoord\",\"gl_PointParameters\",\"gl_PointSize\",\"gl_Position\",\"gl_ProjectionMatrix\",\"gl_ProjectionMatrixInverse\",\"gl_ProjectionMatrixInverseTranspose\",\"gl_ProjectionMatrixTranspose\",\"gl_SecondaryColor\",\"gl_TexCoord\",\"gl_TextureEnvColor\",\"gl_TextureMatrix\",\"gl_TextureMatrixInverse\",\"gl_TextureMatrixInverseTranspose\",\"gl_TextureMatrixTranspose\",\"gl_Vertex\",\"greaterThan\",\"greaterThanEqual\",\"inversesqrt\",\"length\",\"lessThan\",\"lessThanEqual\",\"log\",\"log2\",\"matrixCompMult\",\"max\",\"min\",\"mix\",\"mod\",\"normalize\",\"not\",\"notEqual\",\"pow\",\"radians\",\"reflect\",\"refract\",\"sign\",\"sin\",\"smoothstep\",\"sqrt\",\"step\",\"tan\",\"texture2D\",\"texture2DLod\",\"texture2DProj\",\"texture2DProjLod\",\"textureCube\",\"textureCubeLod\",\"texture2DLodEXT\",\"texture2DProjLodEXT\",\"textureCubeLodEXT\",\"texture2DGradEXT\",\"texture2DProjGradEXT\",\"textureCubeGradEXT\"]},{}],282:[function(t,e,r){var n=t(\"./literals\");e.exports=n.slice().concat([\"layout\",\"centroid\",\"smooth\",\"case\",\"mat2x2\",\"mat2x3\",\"mat2x4\",\"mat3x2\",\"mat3x3\",\"mat3x4\",\"mat4x2\",\"mat4x3\",\"mat4x4\",\"uint\",\"uvec2\",\"uvec3\",\"uvec4\",\"samplerCubeShadow\",\"sampler2DArray\",\"sampler2DArrayShadow\",\"isampler2D\",\"isampler3D\",\"isamplerCube\",\"isampler2DArray\",\"usampler2D\",\"usampler3D\",\"usamplerCube\",\"usampler2DArray\",\"coherent\",\"restrict\",\"readonly\",\"writeonly\",\"resource\",\"atomic_uint\",\"noperspective\",\"patch\",\"sample\",\"subroutine\",\"common\",\"partition\",\"active\",\"filter\",\"image1D\",\"image2D\",\"image3D\",\"imageCube\",\"iimage1D\",\"iimage2D\",\"iimage3D\",\"iimageCube\",\"uimage1D\",\"uimage2D\",\"uimage3D\",\"uimageCube\",\"image1DArray\",\"image2DArray\",\"iimage1DArray\",\"iimage2DArray\",\"uimage1DArray\",\"uimage2DArray\",\"image1DShadow\",\"image2DShadow\",\"image1DArrayShadow\",\"image2DArrayShadow\",\"imageBuffer\",\"iimageBuffer\",\"uimageBuffer\",\"sampler1DArray\",\"sampler1DArrayShadow\",\"isampler1D\",\"isampler1DArray\",\"usampler1D\",\"usampler1DArray\",\"isampler2DRect\",\"usampler2DRect\",\"samplerBuffer\",\"isamplerBuffer\",\"usamplerBuffer\",\"sampler2DMS\",\"isampler2DMS\",\"usampler2DMS\",\"sampler2DMSArray\",\"isampler2DMSArray\",\"usampler2DMSArray\"])},{\"./literals\":283}],283:[function(t,e,r){e.exports=[\"precision\",\"highp\",\"mediump\",\"lowp\",\"attribute\",\"const\",\"uniform\",\"varying\",\"break\",\"continue\",\"do\",\"for\",\"while\",\"if\",\"else\",\"in\",\"out\",\"inout\",\"float\",\"int\",\"void\",\"bool\",\"true\",\"false\",\"discard\",\"return\",\"mat2\",\"mat3\",\"mat4\",\"vec2\",\"vec3\",\"vec4\",\"ivec2\",\"ivec3\",\"ivec4\",\"bvec2\",\"bvec3\",\"bvec4\",\"sampler1D\",\"sampler2D\",\"sampler3D\",\"samplerCube\",\"sampler1DShadow\",\"sampler2DShadow\",\"struct\",\"asm\",\"class\",\"union\",\"enum\",\"typedef\",\"template\",\"this\",\"packed\",\"goto\",\"switch\",\"default\",\"inline\",\"noinline\",\"volatile\",\"public\",\"static\",\"extern\",\"external\",\"interface\",\"long\",\"short\",\"double\",\"half\",\"fixed\",\"unsigned\",\"input\",\"output\",\"hvec2\",\"hvec3\",\"hvec4\",\"dvec2\",\"dvec3\",\"dvec4\",\"fvec2\",\"fvec3\",\"fvec4\",\"sampler2DRect\",\"sampler3DRect\",\"sampler2DRectShadow\",\"sizeof\",\"cast\",\"namespace\",\"using\"]},{}],284:[function(t,e,r){e.exports=[\"<<=\",\">>=\",\"++\",\"--\",\"<<\",\">>\",\"<=\",\">=\",\"==\",\"!=\",\"&&\",\"||\",\"+=\",\"-=\",\"*=\",\"/=\",\"%=\",\"&=\",\"^^\",\"^=\",\"|=\",\"(\",\")\",\"[\",\"]\",\".\",\"!\",\"~\",\"*\",\"/\",\"%\",\"+\",\"-\",\"<\",\">\",\"&\",\"^\",\"|\",\"?\",\":\",\"=\",\",\",\";\",\"{\",\"}\"]},{}],285:[function(t,e,r){function n(t,e){var r=i(e),n=[];return n=n.concat(r(t)),n=n.concat(r(null))}var i=t(\"./index\");e.exports=n},{\"./index\":279}],286:[function(t,e,r){\"use strict\";function n(t,e,r){var n=this.cells=[];if(t instanceof ArrayBuffer){this.arrayBuffer=t;var a=new Int32Array(this.arrayBuffer);t=a[0],e=a[1],r=a[2],this.d=e+2*r;for(var o=0;o<this.d*this.d;o++){var s=a[i+o],l=a[i+o+1];n.push(s===l?null:a.subarray(s,l))}var u=a[i+n.length],c=a[i+n.length+1];this.keys=a.subarray(u,c),this.bboxes=a.subarray(c),this.insert=this._insertReadonly}else{this.d=e+2*r;for(var h=0;h<this.d*this.d;h++)n.push([]);this.keys=[],this.bboxes=[]}this.n=e,this.extent=t,this.padding=r,this.scale=e/t,this.uid=0;var f=r/e*t;this.min=-f,this.max=t+f}e.exports=n;var i=3;n.prototype.insert=function(t,e,r,n,i){this._forEachCell(e,r,n,i,this._insertCell,this.uid++),this.keys.push(t),this.bboxes.push(e),this.bboxes.push(r),this.bboxes.push(n),this.bboxes.push(i)},n.prototype._insertReadonly=function(){throw\"Cannot insert into a GridIndex created from an ArrayBuffer.\"},n.prototype._insertCell=function(t,e,r,n,i,a){this.cells[i].push(a)},n.prototype.query=function(t,e,r,n){var i=this.min,a=this.max;if(t<=i&&e<=i&&a<=r&&a<=n)return Array.prototype.slice.call(this.keys);var o=[],s={};return this._forEachCell(t,e,r,n,this._queryCell,o,s),o},n.prototype._queryCell=function(t,e,r,n,i,a,o){var s=this.cells[i];if(null!==s)for(var l=this.keys,u=this.bboxes,c=0;c<s.length;c++){var h=s[c];if(void 0===o[h]){var f=4*h;t<=u[f+2]&&e<=u[f+3]&&r>=u[f+0]&&n>=u[f+1]?(o[h]=!0,a.push(l[h])):o[h]=!1}}},n.prototype._forEachCell=function(t,e,r,n,i,a,o){for(var s=this._convertToCellCoord(t),l=this._convertToCellCoord(e),u=this._convertToCellCoord(r),c=this._convertToCellCoord(n),h=s;h<=u;h++)for(var f=l;f<=c;f++){var d=this.d*f+h;if(i.call(this,t,e,r,n,d,a,o))return}},n.prototype._convertToCellCoord=function(t){return Math.max(0,Math.min(this.d-1,Math.floor(t*this.scale)+this.padding))},n.prototype.toArrayBuffer=function(){if(this.arrayBuffer)return this.arrayBuffer;for(var t=this.cells,e=i+this.cells.length+1+1,r=0,n=0;n<this.cells.length;n++)r+=this.cells[n].length;var a=new Int32Array(e+r+this.keys.length+this.bboxes.length);a[0]=this.extent,a[1]=this.n,a[2]=this.padding;for(var o=e,s=0;s<t.length;s++){var l=t[s];a[i+s]=o,a.set(l,o),o+=l.length}return a[i+t.length]=o,a.set(this.keys,o),o+=this.keys.length,a[i+t.length+1]=o,a.set(this.bboxes,o),o+=this.bboxes.length,a.buffer}},{}],287:[function(t,e,r){(function(r){\"use strict\";var n,i=t(\"is-browser\");n=\"function\"==typeof r.matchMedia?!r.matchMedia(\"(hover: none)\").matches:i,e.exports=n}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"is-browser\":293}],288:[function(t,e,r){r.read=function(t,e,r,n,i){var a,o,s=8*i-n-1,l=(1<<s)-1,u=l>>1,c=-7,h=r?i-1:0,f=r?-1:1,d=t[e+h];for(h+=f,a=d&(1<<-c)-1,d>>=-c,c+=s;c>0;a=256*a+t[e+h],h+=f,c-=8);for(o=a&(1<<-c)-1,a>>=-c,c+=n;c>0;o=256*o+t[e+h],h+=f,c-=8);if(0===a)a=1-u;else{if(a===l)return o?NaN:1/0*(d?-1:1);o+=Math.pow(2,n),a-=u}return(d?-1:1)*o*Math.pow(2,a-n)},r.write=function(t,e,r,n,i,a){var o,s,l,u=8*a-i-1,c=(1<<u)-1,h=c>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=n?0:a-1,p=n?1:-1,m=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(s=isNaN(e)?1:0,o=c):(o=Math.floor(Math.log(e)/Math.LN2),e*(l=Math.pow(2,-o))<1&&(o--,l*=2),e+=o+h>=1?f/l:f*Math.pow(2,1-h),e*l>=2&&(o++,l/=2),o+h>=c?(s=0,o=c):o+h>=1?(s=(e*l-1)*Math.pow(2,i),o+=h):(s=e*Math.pow(2,h-1)*Math.pow(2,i),o=0));i>=8;t[r+d]=255&s,d+=p,s/=256,i-=8);for(o=o<<i|s,u+=i;u>0;t[r+d]=255&o,d+=p,o/=256,u-=8);t[r+d-p]|=128*m}},{}],289:[function(t,e,r){\"use strict\";function n(t,e,r){this.vertices=t,this.adjacent=e,this.boundary=r,this.lastVisited=-1}function i(t,e,r){this.vertices=t,this.cell=e,this.index=r}function a(t,e){return c(t.vertices,e.vertices)}function o(t){for(var e=[\"function orient(){var tuple=this.tuple;return test(\"],r=0;r<=t;++r)r>0&&e.push(\",\"),e.push(\"tuple[\",r,\"]\");e.push(\")}return orient\");var n=new Function(\"test\",e.join(\"\")),i=u[t+1];return i||(i=u),n(i)}function s(t,e,r){this.dimension=t,this.vertices=e,this.simplices=r,this.interior=r.filter(function(t){return!t.boundary}),this.tuple=new Array(t+1);for(var n=0;n<=t;++n)this.tuple[n]=this.vertices[n];var i=h[t];i||(i=h[t]=o(t)),this.orient=i}function l(t,e){var r=t.length;if(0===r)throw new Error(\"Must have at least d+1 points\");var i=t[0].length;if(r<=i)throw new Error(\"Must input at least d+1 points\");var a=t.slice(0,i+1),o=u.apply(void 0,a);if(0===o)throw new Error(\"Input not in general position\");for(var l=new Array(i+1),c=0;c<=i;++c)l[c]=c;o<0&&(l[0]=1,l[1]=0);for(var h=new n(l,new Array(i+1),!1),f=h.adjacent,d=new Array(i+2),c=0;c<=i;++c){for(var p=l.slice(),m=0;m<=i;++m)m===c&&(p[m]=-1);var v=p[0];p[0]=p[1],p[1]=v;var g=new n(p,new Array(i+1),!0);f[c]=g,d[c]=g}d[i+1]=h;for(var c=0;c<=i;++c)for(var p=f[c].vertices,y=f[c].adjacent,m=0;m<=i;++m){var b=p[m];if(b<0)y[m]=h;else for(var x=0;x<=i;++x)f[x].vertices.indexOf(b)<0&&(y[m]=f[x])}for(var _=new s(i,a,d),w=!!e,c=i+1;c<r;++c)_.insert(t[c],w);return _.boundary()}e.exports=l;var u=t(\"robust-orientation\"),c=t(\"simplicial-complex\").compareCells;n.prototype.flip=function(){var t=this.vertices[0];this.vertices[0]=this.vertices[1],this.vertices[1]=t;var e=this.adjacent[0];this.adjacent[0]=this.adjacent[1],this.adjacent[1]=e};var h=[],f=s.prototype;f.handleBoundaryDegeneracy=function(t,e){var r=this.dimension,n=this.vertices.length-1,i=this.tuple,a=this.vertices,o=[t];for(t.lastVisited=-n;o.length>0;){t=o.pop();for(var s=(t.vertices,t.adjacent),l=0;l<=r;++l){var u=s[l];if(u.boundary&&!(u.lastVisited<=-n)){for(var c=u.vertices,h=0;h<=r;++h){var f=c[h];i[h]=f<0?e:a[f]}var d=this.orient();if(d>0)return u;u.lastVisited=-n,0===d&&o.push(u)}}}return null},f.walk=function(t,e){var r=this.vertices.length-1,n=this.dimension,i=this.vertices,a=this.tuple,o=e?this.interior.length*Math.random()|0:this.interior.length-1,s=this.interior[o];t:for(;!s.boundary;){for(var l=s.vertices,u=s.adjacent,c=0;c<=n;++c)a[c]=i[l[c]];s.lastVisited=r;for(var c=0;c<=n;++c){var h=u[c];if(!(h.lastVisited>=r)){var f=a[c];a[c]=t;var d=this.orient();if(a[c]=f,d<0){s=h;continue t}h.boundary?h.lastVisited=-r:h.lastVisited=r}}return}return s},f.addPeaks=function(t,e){var r=this.vertices.length-1,o=this.dimension,s=this.vertices,l=this.tuple,u=this.interior,c=this.simplices,h=[e];e.lastVisited=r,e.vertices[e.vertices.indexOf(-1)]=r,e.boundary=!1,u.push(e);for(var f=[];h.length>0;){var e=h.pop(),d=e.vertices,p=e.adjacent,m=d.indexOf(r);if(!(m<0))for(var v=0;v<=o;++v)if(v!==m){var g=p[v];if(g.boundary&&!(g.lastVisited>=r)){var y=g.vertices;if(g.lastVisited!==-r){for(var b=0,x=0;x<=o;++x)y[x]<0?(b=x,l[x]=t):l[x]=s[y[x]];var _=this.orient();if(_>0){y[b]=r,g.boundary=!1,u.push(g),h.push(g),g.lastVisited=r;continue}g.lastVisited=-r}var w=g.adjacent,M=d.slice(),k=p.slice(),A=new n(M,k,!0);c.push(A);var T=w.indexOf(e);if(!(T<0)){w[T]=A,k[m]=g,M[v]=-1,k[v]=e,p[v]=A,A.flip();for(var x=0;x<=o;++x){var S=M[x];if(!(S<0||S===r)){for(var E=new Array(o-1),L=0,C=0;C<=o;++C){var z=M[C];z<0||C===x||(E[L++]=z)}f.push(new i(E,A,x))}}}}}}f.sort(a);for(var v=0;v+1<f.length;v+=2){var I=f[v],D=f[v+1],P=I.index,O=D.index;P<0||O<0||(I.cell.adjacent[I.index]=D.cell,D.cell.adjacent[D.index]=I.cell)}},f.insert=function(t,e){var r=this.vertices;r.push(t);var n=this.walk(t,e);if(n){for(var i=this.dimension,a=this.tuple,o=0;o<=i;++o){var s=n.vertices[o];a[o]=s<0?t:r[s]}var l=this.orient(a);l<0||(0!==l||(n=this.handleBoundaryDegeneracy(n,t)))&&this.addPeaks(t,n)}},f.boundary=function(){for(var t=this.dimension,e=[],r=this.simplices,n=r.length,i=0;i<n;++i){var a=r[i];if(a.boundary){for(var o=new Array(t),s=a.vertices,l=0,u=0,c=0;c<=t;++c)s[c]>=0?o[l++]=s[c]:u=1&c;if(u===(1&t)){var h=o[0];o[0]=o[1],o[1]=h}e.push(o)}}return e}},{\"robust-orientation\":507,\"simplicial-complex\":518}],290:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.mid=t,this.left=e,this.right=r,this.leftPoints=n,this.rightPoints=i,this.count=(e?e.count:0)+(r?r.count:0)+n.length}function i(t,e){t.mid=e.mid,t.left=e.left,t.right=e.right,t.leftPoints=e.leftPoints,t.rightPoints=e.rightPoints,t.count=e.count}function a(t,e){var r=p(e);t.mid=r.mid,t.left=r.left,t.right=r.right,t.leftPoints=r.leftPoints,t.rightPoints=r.rightPoints,t.count=r.count}function o(t,e){var r=t.intervals([]);r.push(e),a(t,r)}function s(t,e){var r=t.intervals([]),n=r.indexOf(e);return n<0?y:(r.splice(n,1),a(t,r),b)}function l(t,e,r){for(var n=0;n<t.length&&t[n][0]<=e;++n){var i=r(t[n]);if(i)return i}}function u(t,e,r){for(var n=t.length-1;n>=0&&t[n][1]>=e;--n){var i=r(t[n]);if(i)return i}}function c(t,e){for(var r=0;r<t.length;++r){var n=e(t[r]);if(n)return n}}function h(t,e){return t-e}function f(t,e){var r=t[0]-e[0];return r||t[1]-e[1]}function d(t,e){var r=t[1]-e[1];return r||t[0]-e[0]}function p(t){if(0===t.length)return null;for(var e=[],r=0;r<t.length;++r)e.push(t[r][0],t[r][1]);e.sort(h);for(var i=e[e.length>>1],a=[],o=[],s=[],r=0;r<t.length;++r){var l=t[r];l[1]<i?a.push(l):i<l[0]?o.push(l):s.push(l)}var u=s,c=s.slice();return u.sort(f),c.sort(d),new n(i,p(a),p(o),u,c)}function m(t){this.root=t}function v(t){return new m(t&&0!==t.length?p(t):null)}var g=t(\"binary-search-bounds\"),y=0,b=1;e.exports=v;var x=n.prototype;x.intervals=function(t){return t.push.apply(t,this.leftPoints),this.left&&this.left.intervals(t),this.right&&this.right.intervals(t),t},x.insert=function(t){var e=this.count-this.leftPoints.length;if(this.count+=1,t[1]<this.mid)this.left?4*(this.left.count+1)>3*(e+1)?o(this,t):this.left.insert(t):this.left=p([t]);else if(t[0]>this.mid)this.right?4*(this.right.count+1)>3*(e+1)?o(this,t):this.right.insert(t):this.right=p([t]);else{var r=g.ge(this.leftPoints,t,f),n=g.ge(this.rightPoints,t,d);this.leftPoints.splice(r,0,t),this.rightPoints.splice(n,0,t)}},x.remove=function(t){var e=this.count-this.leftPoints;if(t[1]<this.mid){if(!this.left)return y;if(4*(this.right?this.right.count:0)>3*(e-1))return s(this,t);var r=this.left.remove(t);return 2===r?(this.left=null,this.count-=1,b):(r===b&&(this.count-=1),r)}if(t[0]>this.mid){if(!this.right)return y;if(4*(this.left?this.left.count:0)>3*(e-1))return s(this,t);var r=this.right.remove(t);return 2===r?(this.right=null,this.count-=1,b):(r===b&&(this.count-=1),r)}if(1===this.count)return this.leftPoints[0]===t?2:y;if(1===this.leftPoints.length&&this.leftPoints[0]===t){if(this.left&&this.right){for(var n=this,a=this.left;a.right;)n=a,a=a.right;if(n===this)a.right=this.right;else{var o=this.left,r=this.right;n.count-=a.count,n.right=a.left,a.left=o,a.right=r}i(this,a),this.count=(this.left?this.left.count:0)+(this.right?this.right.count:0)+this.leftPoints.length}else this.left?i(this,this.left):i(this,this.right);return b}for(var o=g.ge(this.leftPoints,t,f);o<this.leftPoints.length&&this.leftPoints[o][0]===t[0];++o)if(this.leftPoints[o]===t){this.count-=1,this.leftPoints.splice(o,1);for(var r=g.ge(this.rightPoints,t,d);r<this.rightPoints.length&&this.rightPoints[r][1]===t[1];++r)if(this.rightPoints[r]===t)return this.rightPoints.splice(r,1),b}return y},x.queryPoint=function(t,e){if(t<this.mid){if(this.left){var r=this.left.queryPoint(t,e);if(r)return r}return l(this.leftPoints,t,e)}if(t>this.mid){if(this.right){var r=this.right.queryPoint(t,e);if(r)return r}return u(this.rightPoints,t,e)}return c(this.leftPoints,e)},x.queryInterval=function(t,e,r){if(t<this.mid&&this.left){var n=this.left.queryInterval(t,e,r);if(n)return n}if(e>this.mid&&this.right){var n=this.right.queryInterval(t,e,r);if(n)return n}return e<this.mid?l(this.leftPoints,e,r):t>this.mid?u(this.rightPoints,t,r):c(this.leftPoints,r)};var _=m.prototype;_.insert=function(t){this.root?this.root.insert(t):this.root=new n(t[0],null,null,[t],[t])},_.remove=function(t){if(this.root){var e=this.root.remove(t);return 2===e&&(this.root=null),e!==y}return!1},_.queryPoint=function(t,e){if(this.root)return this.root.queryPoint(t,e)},_.queryInterval=function(t,e,r){if(t<=e&&this.root)return this.root.queryInterval(t,e,r)},Object.defineProperty(_,\"count\",{get:function(){return this.root?this.root.count:0}}),Object.defineProperty(_,\"intervals\",{get:function(){return this.root?this.root.intervals([]):[]}})},{\"binary-search-bounds\":65}],291:[function(t,e,r){\"use strict\";function n(t,e){e=e||new Array(t.length);for(var r=0;r<t.length;++r)e[t[r]]=r;return e}e.exports=n},{}],292:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=r;return e}e.exports=n},{}],293:[function(t,e,r){e.exports=!0},{}],294:[function(t,e,r){function n(t){return!!t.constructor&&\"function\"==typeof t.constructor.isBuffer&&t.constructor.isBuffer(t)}function i(t){return\"function\"==typeof t.readFloatLE&&\"function\"==typeof t.slice&&n(t.slice(0,0))}e.exports=function(t){return null!=t&&(n(t)||i(t)||!!t._isBuffer)}},{}],295:[function(t,e,r){function n(t){return t||\"undefined\"==typeof navigator||(t=navigator.userAgent),t&&t.headers&&\"string\"==typeof t.headers[\"user-agent\"]&&(t=t.headers[\"user-agent\"]),\"string\"==typeof t&&(/(android|bb\\d+|meego).+mobile|avantgo|bada\\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\\-|your|zeto|zte\\-/i.test(t.substr(0,4)))}e.exports=n},{}],296:[function(t,e,r){\"use strict\";var n=Object.prototype.toString;e.exports=function(t){var e;return\"[object Object]\"===n.call(t)&&(null===(e=Object.getPrototypeOf(t))||e===Object.getPrototypeOf({}))}},{}],297:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){return new i(t,e,r,n,a)}function i(t,e,r,n,i){e=e||a,r=r||o,i=i||Array,this.nodeSize=n||64,this.points=t,this.ids=new i(t.length),this.coords=new i(2*t.length);for(var l=0;l<t.length;l++)this.ids[l]=l,this.coords[2*l]=e(t[l]),this.coords[2*l+1]=r(t[l]);s(this.ids,this.coords,this.nodeSize,0,this.ids.length-1,0)}function a(t){return t[0]}function o(t){return t[1]}var s=t(\"./sort\"),l=t(\"./range\"),u=t(\"./within\");e.exports=n,i.prototype={range:function(t,e,r,n){return l(this.ids,this.coords,t,e,r,n,this.nodeSize)},within:function(t,e,r){return u(this.ids,this.coords,t,e,r,this.nodeSize)}}},{\"./range\":298,\"./sort\":299,\"./within\":300}],298:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){for(var s,l,u=[0,t.length-1,0],c=[];u.length;){var h=u.pop(),f=u.pop(),d=u.pop();if(f-d<=o)for(var p=d;p<=f;p++)s=e[2*p],l=e[2*p+1],s>=r&&s<=i&&l>=n&&l<=a&&c.push(t[p]);else{var m=Math.floor((d+f)/2);s=e[2*m],l=e[2*m+1],s>=r&&s<=i&&l>=n&&l<=a&&c.push(t[m]);var v=(h+1)%2;(0===h?r<=s:n<=l)&&(u.push(d),u.push(m-1),u.push(v)),(0===h?i>=s:a>=l)&&(u.push(m+1),u.push(f),u.push(v))}}return c}e.exports=n},{}],299:[function(t,e,r){\"use strict\";function n(t,e,r,a,o,s){if(!(o-a<=r)){var l=Math.floor((a+o)/2);i(t,e,l,a,o,s%2),n(t,e,r,a,l-1,s+1),n(t,e,r,l+1,o,s+1)}}function i(t,e,r,n,o,s){for(;o>n;){if(o-n>600){var l=o-n+1,u=r-n+1,c=Math.log(l),h=.5*Math.exp(2*c/3),f=.5*Math.sqrt(c*h*(l-h)/l)*(u-l/2<0?-1:1);i(t,e,r,Math.max(n,Math.floor(r-u*h/l+f)),Math.min(o,Math.floor(r+(l-u)*h/l+f)),s)}var d=e[2*r+s],p=n,m=o;for(a(t,e,n,r),e[2*o+s]>d&&a(t,e,n,o);p<m;){for(a(t,e,p,m),p++,m--;e[2*p+s]<d;)p++;for(;e[2*m+s]>d;)m--}e[2*n+s]===d?a(t,e,n,m):(m++,a(t,e,m,o)),m<=r&&(n=m+1),r<=m&&(o=m-1)}}function a(t,e,r,n){o(t,r,n),o(e,2*r,2*n),o(e,2*r+1,2*n+1)}function o(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}e.exports=n},{}],300:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o){for(var s=[0,t.length-1,0],l=[],u=a*a;s.length;){var c=s.pop(),h=s.pop(),f=s.pop();if(h-f<=o)for(var d=f;d<=h;d++)i(e[2*d],e[2*d+1],r,n)<=u&&l.push(t[d]);else{var p=Math.floor((f+h)/2),m=e[2*p],v=e[2*p+1];i(m,v,r,n)<=u&&l.push(t[p]);var g=(c+1)%2;(0===c?r-a<=m:n-a<=v)&&(s.push(f),s.push(p-1),s.push(g)),(0===c?r+a>=m:n+a>=v)&&(s.push(p+1),s.push(h),s.push(g))}}return l}function i(t,e,r,n){var i=t-r,a=e-n;return i*i+a*a}e.exports=n},{}],301:[function(t,e,r){\"use strict\";function n(t,e){var r;if(h(t)){var l,u=t.stops&&\"object\"==typeof t.stops[0][0],c=u||void 0!==t.property,f=u||!c,d=t.type||e||\"exponential\";if(\"exponential\"===d)l=o;else if(\"interval\"===d)l=a;else if(\"categorical\"===d)l=i;else{if(\"identity\"!==d)throw new Error('Unknown function type \"'+d+'\"');l=s}if(u){for(var p={},m=[],v=0;v<t.stops.length;v++){var g=t.stops[v];void 0===p[g[0].zoom]&&(p[g[0].zoom]={zoom:g[0].zoom,type:t.type,property:t.property,stops:[]}),p[g[0].zoom].stops.push([g[0].value,g[1]])}for(var y in p)m.push([p[y].zoom,n(p[y])]);r=function(e,r){return o({stops:m,base:t.base},e)(e,r)},r.isFeatureConstant=!1,r.isZoomConstant=!1}else f?(r=function(e){return l(t,e)},r.isFeatureConstant=!0,r.isZoomConstant=!1):(r=function(e,r){return l(t,r[t.property])},r.isFeatureConstant=!1,r.isZoomConstant=!0)}else r=function(){return t},r.isFeatureConstant=!0,r.isZoomConstant=!0;return r}function i(t,e){for(var r=0;r<t.stops.length;r++)if(e===t.stops[r][0])return t.stops[r][1];return t.stops[0][1]}function a(t,e){for(var r=0;r<t.stops.length&&!(e<t.stops[r][0]);r++);return t.stops[Math.max(r-1,0)][1]}function o(t,e){for(var r=void 0!==t.base?t.base:1,n=0;;){if(n>=t.stops.length)break;if(e<=t.stops[n][0])break;n++}return 0===n?t.stops[n][1]:n===t.stops.length?t.stops[n-1][1]:l(e,r,t.stops[n-1][0],t.stops[n][0],t.stops[n-1][1],t.stops[n][1])}function s(t,e){return e}function l(t,e,r,n,i,a){return\"function\"==typeof i?function(){var o=i.apply(void 0,arguments),s=a.apply(void 0,arguments);return l(t,e,r,n,o,s)}:i.length?c(t,e,r,n,i,a):u(t,e,r,n,i,a)}function u(t,e,r,n,i,a){var o,s=n-r,l=t-r;return o=1===e?l/s:(Math.pow(e,l)-1)/(Math.pow(e,s)-1),i*(1-o)+a*o}function c(t,e,r,n,i,a){for(var o=[],s=0;s<i.length;s++)o[s]=u(t,e,r,n,i[s],a[s]);return o}function h(t){return\"object\"==typeof t&&(t.stops||\"identity\"===t.type)}e.exports.isFunctionDefinition=h,e.exports.interpolated=function(t){return n(t,\"exponential\")},e.exports[\"piecewise-constant\"]=function(t){return n(t,\"interval\")}},{}],302:[function(t,e,r){t(\"path\");e.exports={debug:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\n\\nvoid main() {\\n    gl_FragColor = u_color;\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, step(32767.0, a_pos.x), 1);\\n}\\n\"},fill:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_FragColor = color * opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n}\\n\"},circle:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float blur\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_extrude;\\nvarying lowp float v_antialiasblur;\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float blur\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    float t = smoothstep(1.0 - max(blur, v_antialiasblur), 1.0, length(v_extrude));\\n    gl_FragColor = color * (1.0 - t) * opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform bool u_scale_with_map;\\nuniform vec2 u_extrude_scale;\\nuniform float u_devicepixelratio;\\n\\nattribute vec2 a_pos;\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define mediump float radius\\n#pragma mapbox: define lowp float blur\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_extrude;\\nvarying lowp float v_antialiasblur;\\n\\nvoid main(void) {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize mediump float radius\\n    #pragma mapbox: initialize lowp float blur\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    // unencode the extrusion vector that we snuck into the a_pos vector\\n    v_extrude = vec2(mod(a_pos, 2.0) * 2.0 - 1.0);\\n\\n    vec2 extrude = v_extrude * radius * u_extrude_scale;\\n    // multiply a_pos by 0.5, since we had it * 2 in order to sneak\\n    // in extrusion data\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5), 0, 1);\\n\\n    if (u_scale_with_map) {\\n        gl_Position.xy += extrude;\\n    } else {\\n        gl_Position.xy += extrude * gl_Position.w;\\n    }\\n\\n    // This is a minimum blur distance that serves as a faux-antialiasing for\\n    // the circle. since blur is a ratio of the circle's size and the intent is\\n    // to keep the blur at roughly 1px, the two are inversely related.\\n    v_antialiasblur = 1.0 / u_devicepixelratio / radius;\\n}\\n\"},line:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\nuniform float u_blur;\\n\\nvarying vec2 v_linewidth;\\nvarying vec2 v_normal;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform mediump float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\nuniform mediump float u_blur;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},linepattern:{\n",
       "fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_blur;\\n\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_fade;\\nuniform float u_opacity;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_linesofar;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    float x_a = mod(v_linesofar / u_pattern_size_a.x, 1.0);\\n    float x_b = mod(v_linesofar / u_pattern_size_b.x, 1.0);\\n    float y_a = 0.5 + (v_normal.y * v_linewidth.s / u_pattern_size_a.y);\\n    float y_b = 0.5 + (v_normal.y * v_linewidth.s / u_pattern_size_b.y);\\n    vec2 pos_a = mix(u_pattern_tl_a, u_pattern_br_a, vec2(x_a, y_a));\\n    vec2 pos_b = mix(u_pattern_tl_b, u_pattern_br_b, vec2(x_b, y_b));\\n\\n    vec4 color = mix(texture2D(u_image, pos_a), texture2D(u_image, pos_b), u_fade);\\n\\n    alpha *= u_opacity;\\n\\n    gl_FragColor = color * alpha;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\n// We scale the distance before adding it to the buffers so that we can store\\n// long distances for long segments. Use this value to unscale the distance.\\n#define LINE_DISTANCE_SCALE 2.0\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform mediump float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_linesofar;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n    float a_linesofar = (floor(a_data.z / 4.0) + a_data.w * 64.0) * LINE_DISTANCE_SCALE;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n    v_linesofar = a_linesofar;\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},linesdfpattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\n\\nuniform float u_blur;\\nuniform sampler2D u_image;\\nuniform float u_sdfgamma;\\nuniform float u_mix;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying vec2 v_tex_a;\\nvarying vec2 v_tex_b;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    float sdfdist_a = texture2D(u_image, v_tex_a).a;\\n    float sdfdist_b = texture2D(u_image, v_tex_b).a;\\n    float sdfdist = mix(sdfdist_a, sdfdist_b, u_mix);\\n    alpha *= smoothstep(0.5 - u_sdfgamma, 0.5 + u_sdfgamma, sdfdist);\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\n// We scale the distance before adding it to the buffers so that we can store\\n// long distances for long segments. Use this value to unscale the distance.\\n#define LINE_DISTANCE_SCALE 2.0\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform vec2 u_patternscale_a;\\nuniform float u_tex_y_a;\\nuniform vec2 u_patternscale_b;\\nuniform float u_tex_y_b;\\nuniform float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying vec2 v_tex_a;\\nvarying vec2 v_tex_b;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n    float a_linesofar = (floor(a_data.z / 4.0) + a_data.w * 64.0) * LINE_DISTANCE_SCALE;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n\\n    v_tex_a = vec2(a_linesofar * u_patternscale_a.x, normal.y * u_patternscale_a.y + u_tex_y_a);\\n    v_tex_b = vec2(a_linesofar * u_patternscale_b.x, normal.y * u_patternscale_b.y + u_tex_y_b);\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},outline:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 outline_color\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 outline_color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    float dist = length(v_pos - gl_FragCoord.xy);\\n    float alpha = smoothstep(1.0, 0.0, dist);\\n    gl_FragColor = outline_color * (alpha * opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_world;\\n\\nvarying vec2 v_pos;\\n\\n#pragma mapbox: define lowp vec4 outline_color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 outline_color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    v_pos = (gl_Position.xy / gl_Position.w + 1.0) / 2.0 * u_world;\\n}\\n\"},outlinepattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_mix;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    vec2 imagecoord = mod(v_pos_a, 1.0);\\n    vec2 pos = mix(u_pattern_tl_a, u_pattern_br_a, imagecoord);\\n    vec4 color1 = texture2D(u_image, pos);\\n\\n    vec2 imagecoord_b = mod(v_pos_b, 1.0);\\n    vec2 pos2 = mix(u_pattern_tl_b, u_pattern_br_b, imagecoord_b);\\n    vec4 color2 = texture2D(u_image, pos2);\\n\\n    // find distance to outline for alpha interpolation\\n\\n    float dist = length(v_pos - gl_FragCoord.xy);\\n    float alpha = smoothstep(1.0, 0.0, dist);\\n    \\n\\n    gl_FragColor = mix(color1, color2, u_mix) * alpha * u_opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pixel_coord_upper;\\nuniform vec2 u_pixel_coord_lower;\\nuniform float u_scale_a;\\nuniform float u_scale_b;\\nuniform float u_tile_units_to_pixels;\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_world;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    vec2 scaled_size_a = u_scale_a * u_pattern_size_a;\\n    vec2 scaled_size_b = u_scale_b * u_pattern_size_b;\\n\\n    // the correct offset needs to be calculated.\\n    //\\n    // The offset depends on how many pixels are between the world origin and\\n    // the edge of the tile:\\n    // vec2 offset = mod(pixel_coord, size)\\n    //\\n    // At high zoom levels there are a ton of pixels between the world origin\\n    // and the edge of the tile. The glsl spec only guarantees 16 bits of\\n    // precision for highp floats. We need more than that.\\n    //\\n    // The pixel_coord is passed in as two 16 bit values:\\n    // pixel_coord_upper = floor(pixel_coord / 2^16)\\n    // pixel_coord_lower = mod(pixel_coord, 2^16)\\n    //\\n    // The offset is calculated in a series of steps that should preserve this precision:\\n    vec2 offset_a = mod(mod(mod(u_pixel_coord_upper, scaled_size_a) * 256.0, scaled_size_a) * 256.0 + u_pixel_coord_lower, scaled_size_a);\\n    vec2 offset_b = mod(mod(mod(u_pixel_coord_upper, scaled_size_b) * 256.0, scaled_size_b) * 256.0 + u_pixel_coord_lower, scaled_size_b);\\n\\n    v_pos_a = (u_tile_units_to_pixels * a_pos + offset_a) / scaled_size_a;\\n    v_pos_b = (u_tile_units_to_pixels * a_pos + offset_b) / scaled_size_b;\\n\\n    v_pos = (gl_Position.xy / gl_Position.w + 1.0) / 2.0 * u_world;\\n}\\n\"},pattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_mix;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\n\\nvoid main() {\\n\\n    vec2 imagecoord = mod(v_pos_a, 1.0);\\n    vec2 pos = mix(u_pattern_tl_a, u_pattern_br_a, imagecoord);\\n    vec4 color1 = texture2D(u_image, pos);\\n\\n    vec2 imagecoord_b = mod(v_pos_b, 1.0);\\n    vec2 pos2 = mix(u_pattern_tl_b, u_pattern_br_b, imagecoord_b);\\n    vec4 color2 = texture2D(u_image, pos2);\\n\\n    gl_FragColor = mix(color1, color2, u_mix) * u_opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pixel_coord_upper;\\nuniform vec2 u_pixel_coord_lower;\\nuniform float u_scale_a;\\nuniform float u_scale_b;\\nuniform float u_tile_units_to_pixels;\\n\\nattribute vec2 a_pos;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    vec2 scaled_size_a = u_scale_a * u_pattern_size_a;\\n    vec2 scaled_size_b = u_scale_b * u_pattern_size_b;\\n\\n    // the correct offset needs to be calculated.\\n    //\\n    // The offset depends on how many pixels are between the world origin and\\n    // the edge of the tile:\\n    // vec2 offset = mod(pixel_coord, size)\\n    //\\n    // At high zoom levels there are a ton of pixels between the world origin\\n    // and the edge of the tile. The glsl spec only guarantees 16 bits of\\n    // precision for highp floats. We need more than that.\\n    //\\n    // The pixel_coord is passed in as two 16 bit values:\\n    // pixel_coord_upper = floor(pixel_coord / 2^16)\\n    // pixel_coord_lower = mod(pixel_coord, 2^16)\\n    //\\n    // The offset is calculated in a series of steps that should preserve this precision:\\n    vec2 offset_a = mod(mod(mod(u_pixel_coord_upper, scaled_size_a) * 256.0, scaled_size_a) * 256.0 + u_pixel_coord_lower, scaled_size_a);\\n    vec2 offset_b = mod(mod(mod(u_pixel_coord_upper, scaled_size_b) * 256.0, scaled_size_b) * 256.0 + u_pixel_coord_lower, scaled_size_b);\\n\\n    v_pos_a = (u_tile_units_to_pixels * a_pos + offset_a) / scaled_size_a;\\n    v_pos_b = (u_tile_units_to_pixels * a_pos + offset_b) / scaled_size_b;\\n}\\n\"},raster:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity0;\\nuniform float u_opacity1;\\nuniform sampler2D u_image0;\\nuniform sampler2D u_image1;\\nvarying vec2 v_pos0;\\nvarying vec2 v_pos1;\\n\\nuniform float u_brightness_low;\\nuniform float u_brightness_high;\\n\\nuniform float u_saturation_factor;\\nuniform float u_contrast_factor;\\nuniform vec3 u_spin_weights;\\n\\nvoid main() {\\n\\n    // read and cross-fade colors from the main and parent tiles\\n    vec4 color0 = texture2D(u_image0, v_pos0);\\n    vec4 color1 = texture2D(u_image1, v_pos1);\\n    vec4 color = color0 * u_opacity0 + color1 * u_opacity1;\\n    vec3 rgb = color.rgb;\\n\\n    // spin\\n    rgb = vec3(\\n        dot(rgb, u_spin_weights.xyz),\\n        dot(rgb, u_spin_weights.zxy),\\n        dot(rgb, u_spin_weights.yzx));\\n\\n    // saturation\\n    float average = (color.r + color.g + color.b) / 3.0;\\n    rgb += (average - rgb) * u_saturation_factor;\\n\\n    // contrast\\n    rgb = (rgb - 0.5) * u_contrast_factor + 0.5;\\n\\n    // brightness\\n    vec3 u_high_vec = vec3(u_brightness_low, u_brightness_low, u_brightness_low);\\n    vec3 u_low_vec = vec3(u_brightness_high, u_brightness_high, u_brightness_high);\\n\\n    gl_FragColor = vec4(mix(u_high_vec, u_low_vec, rgb), color.a);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_tl_parent;\\nuniform float u_scale_parent;\\nuniform float u_buffer_scale;\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_texture_pos;\\n\\nvarying vec2 v_pos0;\\nvarying vec2 v_pos1;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    v_pos0 = (((a_texture_pos / 32767.0) - 0.5) / u_buffer_scale ) + 0.5;\\n    v_pos1 = (v_pos0 * u_scale_parent) + u_tl_parent;\\n}\\n\"},icon:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform sampler2D u_texture;\\nuniform sampler2D u_fadetexture;\\nuniform lowp float u_opacity;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\n\\nvoid main() {\\n    lowp float alpha = texture2D(u_fadetexture, v_fade_tex).a * u_opacity;\\n    gl_FragColor = texture2D(u_texture, v_tex) * alpha;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_offset;\\nattribute vec2 a_texture_pos;\\nattribute vec4 a_data;\\n\\n\\n// matrix is for the vertex position.\\nuniform mat4 u_matrix;\\n\\nuniform mediump float u_zoom;\\nuniform bool u_rotate_with_map;\\nuniform vec2 u_extrude_scale;\\n\\nuniform vec2 u_texsize;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\n\\nvoid main() {\\n    vec2 a_tex = a_texture_pos.xy;\\n    mediump float a_labelminzoom = a_data[0];\\n    mediump vec2 a_zoom = a_data.pq;\\n    mediump float a_minzoom = a_zoom[0];\\n    mediump float a_maxzoom = a_zoom[1];\\n\\n    // u_zoom is the current zoom level adjusted for the change in font size\\n    mediump float z = 2.0 - step(a_minzoom, u_zoom) - (1.0 - step(a_maxzoom, u_zoom));\\n\\n    vec2 extrude = u_extrude_scale * (a_offset / 64.0);\\n    if (u_rotate_with_map) {\\n        gl_Position = u_matrix * vec4(a_pos + extrude, 0, 1);\\n        gl_Position.z += z * gl_Position.w;\\n    } else {\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n    }\\n\\n    v_tex = a_tex / u_texsize;\\n    v_fade_tex = vec2(a_labelminzoom / 255.0, 0.0);\\n}\\n\"},sdf:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform sampler2D u_texture;\\nuniform sampler2D u_fadetexture;\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\nuniform lowp float u_buffer;\\nuniform lowp float u_gamma;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    lowp float dist = texture2D(u_texture, v_tex).a;\\n    lowp float fade_alpha = texture2D(u_fadetexture, v_fade_tex).a;\\n    lowp float gamma = u_gamma * v_gamma_scale;\\n    lowp float alpha = smoothstep(u_buffer - gamma, u_buffer + gamma, dist) * fade_alpha;\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nconst float PI = 3.141592653589793;\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_offset;\\nattribute vec2 a_texture_pos;\\nattribute vec4 a_data;\\n\\n\\n// matrix is for the vertex position.\\nuniform mat4 u_matrix;\\n\\nuniform mediump float u_zoom;\\nuniform bool u_rotate_with_map;\\nuniform bool u_pitch_with_map;\\nuniform mediump float u_pitch;\\nuniform mediump float u_bearing;\\nuniform mediump float u_aspect_ratio;\\nuniform vec2 u_extrude_scale;\\n\\nuniform vec2 u_texsize;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_tex = a_texture_pos.xy;\\n    mediump float a_labelminzoom = a_data[0];\\n    mediump vec2 a_zoom = a_data.pq;\\n    mediump float a_minzoom = a_zoom[0];\\n    mediump float a_maxzoom = a_zoom[1];\\n\\n    // u_zoom is the current zoom level adjusted for the change in font size\\n    mediump float z = 2.0 - step(a_minzoom, u_zoom) - (1.0 - step(a_maxzoom, u_zoom));\\n\\n    // pitch-alignment: map\\n    // rotation-alignment: map | viewport\\n    if (u_pitch_with_map) {\\n        lowp float angle = u_rotate_with_map ? (a_data[1] / 256.0 * 2.0 * PI) : u_bearing;\\n        lowp float asin = sin(angle);\\n        lowp float acos = cos(angle);\\n        mat2 RotationMatrix = mat2(acos, asin, -1.0 * asin, acos);\\n        vec2 offset = RotationMatrix * a_offset;\\n        vec2 extrude = u_extrude_scale * (offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos + extrude, 0, 1);\\n        gl_Position.z += z * gl_Position.w;\\n    // pitch-alignment: viewport\\n    // rotation-alignment: map\\n    } else if (u_rotate_with_map) {\\n        // foreshortening factor to apply on pitched maps\\n        // as a label goes from horizontal <=> vertical in angle\\n        // it goes from 0% foreshortening to up to around 70% foreshortening\\n        lowp float pitchfactor = 1.0 - cos(u_pitch * sin(u_pitch * 0.75));\\n\\n        lowp float lineangle = a_data[1] / 256.0 * 2.0 * PI;\\n\\n        // use the lineangle to position points a,b along the line\\n        // project the points and calculate the label angle in projected space\\n        // this calculation allows labels to be rendered unskewed on pitched maps\\n        vec4 a = u_matrix * vec4(a_pos, 0, 1);\\n        vec4 b = u_matrix * vec4(a_pos + vec2(cos(lineangle),sin(lineangle)), 0, 1);\\n        lowp float angle = atan((b[1]/b[3] - a[1]/a[3])/u_aspect_ratio, b[0]/b[3] - a[0]/a[3]);\\n        lowp float asin = sin(angle);\\n        lowp float acos = cos(angle);\\n        mat2 RotationMatrix = mat2(acos, -1.0 * asin, asin, acos);\\n\\n        vec2 offset = RotationMatrix * (vec2((1.0-pitchfactor)+(pitchfactor*cos(angle*2.0)), 1.0) * a_offset);\\n        vec2 extrude = u_extrude_scale * (offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n        gl_Position.z += z * gl_Position.w;\\n    // pitch-alignment: viewport\\n    // rotation-alignment: viewport\\n    } else {\\n        vec2 extrude = u_extrude_scale * (a_offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n    }\\n\\n    v_gamma_scale = (gl_Position.w - 0.5);\\n\\n    v_tex = a_tex / u_texsize;\\n    v_fade_tex = vec2(a_labelminzoom / 255.0, 0.0);\\n}\\n\"},collisionbox:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_zoom;\\nuniform float u_maxzoom;\\n\\nvarying float v_max_zoom;\\nvarying float v_placement_zoom;\\n\\nvoid main() {\\n\\n    float alpha = 0.5;\\n\\n    gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0) * alpha;\\n\\n    if (v_placement_zoom > u_zoom) {\\n        gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0) * alpha;\\n    }\\n\\n    if (u_zoom >= v_max_zoom) {\\n        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0) * alpha * 0.25;\\n    }\\n\\n    if (v_placement_zoom >= u_maxzoom) {\\n        gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0) * alpha * 0.2;\\n    }\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_extrude;\\nattribute vec2 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform float u_scale;\\n\\nvarying float v_max_zoom;\\nvarying float v_placement_zoom;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos + a_extrude / u_scale, 0.0, 1.0);\\n\\n    v_max_zoom = a_data.x;\\n    v_placement_zoom = a_data.y;\\n}\\n\"}},e.exports.util=\"float evaluate_zoom_function_1(const vec4 values, const float t) {\\n    if (t < 1.0) {\\n        return mix(values[0], values[1], t);\\n    } else if (t < 2.0) {\\n        return mix(values[1], values[2], t - 1.0);\\n    } else {\\n        return mix(values[2], values[3], t - 2.0);\\n    }\\n}\\nvec4 evaluate_zoom_function_4(const vec4 value0, const vec4 value1, const vec4 value2, const vec4 value3, const float t) {\\n    if (t < 1.0) {\\n        return mix(value0, value1, t);\\n    } else if (t < 2.0) {\\n        return mix(value1, value2, t - 1.0);\\n    } else {\\n        return mix(value2, value3, t - 2.0);\\n    }\\n}\\n\"},{path:475}],303:[function(t,e,r){\"use strict\";function n(t,e){this.message=(t?t+\": \":\"\")+i.apply(i,Array.prototype.slice.call(arguments,2)),null!==e&&void 0!==e&&e.__line__&&(this.line=e.__line__)}var i=t(\"util\").format;e.exports=n},{util:548}],304:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)t[n]=r[n]}return t}},{}],305:[function(t,e,r){\"use strict\";e.exports=function(t){return t instanceof Number?\"number\":t instanceof String?\"string\":t instanceof Boolean?\"boolean\":Array.isArray(t)?\"array\":null===t?\"null\":typeof t}},{}],306:[function(t,e,r){\"use strict\";e.exports=function(t){return t instanceof Number||t instanceof String||t instanceof Boolean?t.valueOf():t}},{}],307:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"../util/extend\");e.exports=function(e){var r=t(\"./validate_function\"),o=t(\"./validate_object\"),s={\"*\":function(){return[]},array:t(\"./validate_array\"),boolean:t(\"./validate_boolean\"),number:t(\"./validate_number\"),color:t(\"./validate_color\"),constants:t(\"./validate_constants\"),enum:t(\"./validate_enum\"),filter:t(\"./validate_filter\"),function:t(\"./validate_function\"),layer:t(\"./validate_layer\"),object:t(\"./validate_object\"),source:t(\"./validate_source\"),string:t(\"./validate_string\")},l=e.value,u=e.valueSpec,c=e.key,h=e.styleSpec,f=e.style;if(\"string\"===i(l)&&\"@\"===l[0]){if(h.$version>7)return[new n(c,l,\"constants have been deprecated as of v8\")];if(!(l in f.constants))return[new n(c,l,'constant \"%s\" not found',l)];e=a({},e,{value:f.constants[l]})}return u.function&&\"object\"===i(l)?r(e):u.type&&s[u.type]?s[u.type](e):o(a({},e,{valueSpec:u.type?h[u.type]:u}))}},{\"../error/validation_error\":303,\"../util/extend\":304,\"../util/get_type\":305,\"./validate_array\":308,\"./validate_boolean\":309,\"./validate_color\":310,\"./validate_constants\":311,\"./validate_enum\":312,\"./validate_filter\":313,\"./validate_function\":314,\"./validate_layer\":316,\"./validate_number\":318,\"./validate_object\":319,\"./validate_source\":321,\"./validate_string\":322}],308:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"./validate\"),a=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.valueSpec,o=t.style,s=t.styleSpec,l=t.key,u=t.arrayElementValidator||i;if(\"array\"!==n(e))return[new a(l,e,\"array expected, %s found\",n(e))];if(r.length&&e.length!==r.length)return[new a(l,e,\"array length %d expected, length %d found\",r.length,e.length)];if(r[\"min-length\"]&&e.length<r[\"min-length\"])return[new a(l,e,\"array length at least %d expected, length %d found\",r[\"min-length\"],e.length)];var c={type:r.value};s.$version<7&&(c.function=r.function),\"object\"===n(r.value)&&(c=r.value);for(var h=[],f=0;f<e.length;f++)h=h.concat(u({array:e,arrayIndex:f,value:e[f],valueSpec:c,style:o,styleSpec:s,key:l+\"[\"+f+\"]\"}));return h}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307}],309:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.key,a=n(e);return\"boolean\"!==a?[new i(r,e,\"boolean expected, %s found\",a)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],310:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"csscolorparser\").parseCSSColor;e.exports=function(t){var e=t.key,r=t.value,o=i(r);return\"string\"!==o?[new n(e,r,\"color expected, %s found\",o)]:null===a(r)?[new n(e,r,'color expected, \"%s\" found',r)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305,csscolorparser:107}],311:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\");e.exports=function(t){var e=t.key,r=t.value;if(t.styleSpec.$version>7)return r?[new n(e,r,\"constants have been deprecated as of v8\")]:[];var a=i(r);if(\"object\"!==a)return[new n(e,r,\"object expected, %s found\",a)];var o=[];for(var s in r)\"@\"!==s[0]&&o.push(new n(e+\".\"+s,r[s],'constants must start with \"@\"'));return o}},{\"../error/validation_error\":303,\"../util/get_type\":305}],312:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\");e.exports=function(t){var e=t.key,r=t.value,a=t.valueSpec,o=[];return-1===a.values.indexOf(i(r))&&o.push(new n(e,r,\"expected one of [%s], %s found\",a.values.join(\", \"),r)),o}},{\"../error/validation_error\":303,\"../util/unbundle_jsonlint\":306}],313:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"./validate_enum\"),a=t(\"../util/get_type\"),o=t(\"../util/unbundle_jsonlint\");e.exports=function t(e){var r,s=e.value,l=e.key,u=e.styleSpec,c=[];if(\"array\"!==a(s))return[new n(l,s,\"array expected, %s found\",a(s))];if(s.length<1)return[new n(l,s,\"filter array must have at least 1 element\")];switch(c=c.concat(i({key:l+\"[0]\",value:s[0],valueSpec:u.filter_operator,style:e.style,styleSpec:e.styleSpec})),o(s[0])){case\"<\":case\"<=\":case\">\":case\">=\":s.length>=2&&\"$type\"==s[1]&&c.push(new n(l,s,'\"$type\" cannot be use with operator \"%s\"',s[0]));case\"==\":case\"!=\":3!=s.length&&c.push(new n(l,s,'filter array for operator \"%s\" must have 3 elements',s[0]));case\"in\":case\"!in\":s.length>=2&&(r=a(s[1]),\"string\"!==r?c.push(new n(l+\"[1]\",s[1],\"string expected, %s found\",r)):\"@\"===s[1][0]&&c.push(new n(l+\"[1]\",s[1],\"filter key cannot be a constant\")));for(var h=2;h<s.length;h++)r=a(s[h]),\"$type\"==s[1]?c=c.concat(i({key:l+\"[\"+h+\"]\",value:s[h],valueSpec:u.geometry_type,style:e.style,styleSpec:e.styleSpec})):\"string\"===r&&\"@\"===s[h][0]?c.push(new n(l+\"[\"+h+\"]\",s[h],\"filter value cannot be a constant\")):\"string\"!==r&&\"number\"!==r&&\"boolean\"!==r&&c.push(new n(l+\"[\"+h+\"]\",s[h],\"string, number, or boolean expected, %s found\",r));break;case\"any\":case\"all\":case\"none\":for(h=1;h<s.length;h++)c=c.concat(t({key:l+\"[\"+h+\"]\",value:s[h],style:e.style,styleSpec:e.styleSpec}));break;case\"has\":case\"!has\":r=a(s[1]),2!==s.length?c.push(new n(l,s,'filter array for \"%s\" operator must have 2 elements',s[0])):\"string\"!==r?c.push(new n(l+\"[1]\",s[1],\"string expected, %s found\",r)):\"@\"===s[1][0]&&c.push(new n(l+\"[1]\",s[1],\"filter key cannot be a constant\"))}return c}},{\"../error/validation_error\":303,\"../util/get_type\":305,\n",
       "\"../util/unbundle_jsonlint\":306,\"./validate_enum\":312}],314:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"./validate\"),o=t(\"./validate_object\"),s=t(\"./validate_array\"),l=t(\"./validate_number\");e.exports=function(t){function e(t){var e=[],a=t.value;return e=e.concat(s({key:t.key,value:a,valueSpec:t.valueSpec,style:t.style,styleSpec:t.styleSpec,arrayElementValidator:r})),\"array\"===i(a)&&0===a.length&&e.push(new n(t.key,a,\"array must have at least one stop\")),e}function r(t){var e=[],r=t.value,s=t.key;if(\"array\"!==i(r))return[new n(s,r,\"array expected, %s found\",i(r))];if(2!==r.length)return[new n(s,r,\"array length %d expected, length %d found\",2,r.length)];var f=i(r[0]);if(c||(c=f),f!==c)return[new n(s,r,\"%s stop key type must match previous stop key type %s\",f,c)];if(\"object\"===f){if(void 0===r[0].zoom)return[new n(s,r,\"object stop key must have zoom\")];if(void 0===r[0].value)return[new n(s,r,\"object stop key must have value\")];e=e.concat(o({key:s+\"[0]\",value:r[0],valueSpec:{zoom:{}},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{zoom:l,value:u}}))}else e=e.concat((d?l:u)({key:s+\"[0]\",value:r[0],valueSpec:{},style:t.style,styleSpec:t.styleSpec}));return e=e.concat(a({key:s+\"[1]\",value:r[1],valueSpec:h,style:t.style,styleSpec:t.styleSpec})),\"number\"===i(r[0])&&(\"piecewise-constant\"===h.function&&r[0]%1!=0&&e.push(new n(s+\"[0]\",r[0],\"zoom level for piecewise-constant functions must be an integer\")),0!==t.arrayIndex&&r[0]<t.array[t.arrayIndex-1][0]&&e.push(new n(s+\"[0]\",r[0],\"array stops must appear in ascending order\"))),e}function u(t){var e=[],r=i(t.value);return\"number\"!==r&&\"string\"!==r&&\"array\"!==r&&e.push(new n(t.key,t.value,\"property value must be a number, string or array\")),e}var c,h=t.valueSpec,f=void 0!==t.value.property||\"object\"===c,d=void 0===t.value.property||\"object\"===c,p=o({key:t.key,value:t.value,valueSpec:t.styleSpec.function,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{stops:e}});return t.styleSpec.$version>=8&&(f&&!t.valueSpec[\"property-function\"]?p.push(new n(t.key,t.value,\"property functions not supported\")):d&&!t.valueSpec[\"zoom-function\"]&&p.push(new n(t.key,t.value,\"zoom functions not supported\"))),p}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307,\"./validate_array\":308,\"./validate_number\":318,\"./validate_object\":319}],315:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"./validate_string\");e.exports=function(t){var e=t.value,r=t.key,a=i(t);return a.length?a:(-1===e.indexOf(\"{fontstack}\")&&a.push(new n(r,e,'\"glyphs\" url must include a \"{fontstack}\" token')),-1===e.indexOf(\"{range}\")&&a.push(new n(r,e,'\"glyphs\" url must include a \"{range}\" token')),a)}},{\"../error/validation_error\":303,\"./validate_string\":322}],316:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\"),a=t(\"./validate_object\"),o=t(\"./validate_filter\"),s=t(\"./validate_paint_property\"),l=t(\"./validate_layout_property\"),u=t(\"../util/extend\");e.exports=function(t){var e=[],r=t.value,c=t.key,h=t.style,f=t.styleSpec;r.type||r.ref||e.push(new n(c,r,'either \"type\" or \"ref\" is required'));var d=i(r.type),p=i(r.ref);if(r.id)for(var m=0;m<t.arrayIndex;m++){var v=h.layers[m];i(v.id)===i(r.id)&&e.push(new n(c,r.id,'duplicate layer id \"%s\", previously used at line %d',r.id,v.id.__line__))}if(\"ref\"in r){[\"type\",\"source\",\"source-layer\",\"filter\",\"layout\"].forEach(function(t){t in r&&e.push(new n(c,r[t],'\"%s\" is prohibited for ref layers',t))});var g;h.layers.forEach(function(t){t.id==p&&(g=t)}),g?g.ref?e.push(new n(c,r.ref,\"ref cannot reference another ref layer\")):d=i(g.type):e.push(new n(c,r.ref,'ref layer \"%s\" not found',p))}else if(\"background\"!==d)if(r.source){var y=h.sources&&h.sources[r.source];y?\"vector\"==y.type&&\"raster\"==d?e.push(new n(c,r.source,'layer \"%s\" requires a raster source',r.id)):\"raster\"==y.type&&\"raster\"!=d?e.push(new n(c,r.source,'layer \"%s\" requires a vector source',r.id)):\"vector\"!=y.type||r[\"source-layer\"]||e.push(new n(c,r,'layer \"%s\" must specify a \"source-layer\"',r.id)):e.push(new n(c,r.source,'source \"%s\" not found',r.source))}else e.push(new n(c,r,'missing required property \"source\"'));return e=e.concat(a({key:c,value:r,valueSpec:f.layer,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{filter:o,layout:function(t){return a({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{\"*\":function(t){return l(u({layerType:d},t))}}})},paint:function(t){return a({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{\"*\":function(t){return s(u({layerType:d},t))}}})}}}))}},{\"../error/validation_error\":303,\"../util/extend\":304,\"../util/unbundle_jsonlint\":306,\"./validate_filter\":313,\"./validate_layout_property\":317,\"./validate_object\":319,\"./validate_paint_property\":320}],317:[function(t,e,r){\"use strict\";var n=t(\"./validate\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.style,a=t.styleSpec,o=t.value,s=t.objectKey,l=a[\"layout_\"+t.layerType];if(t.valueSpec||l[s]){var u=[];return\"symbol\"===t.layerType&&(\"icon-image\"===s&&r&&!r.sprite?u.push(new i(e,o,'use of \"icon-image\" requires a style \"sprite\" property')):\"text-field\"===s&&r&&!r.glyphs&&u.push(new i(e,o,'use of \"text-field\" requires a style \"glyphs\" property'))),u.concat(n({key:t.key,value:o,valueSpec:t.valueSpec||l[s],style:r,styleSpec:a}))}return[new i(e,o,'unknown property \"%s\"',s)]}},{\"../error/validation_error\":303,\"./validate\":307}],318:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.value,a=t.valueSpec,o=n(r);return\"number\"!==o?[new i(e,r,\"number expected, %s found\",o)]:\"minimum\"in a&&r<a.minimum?[new i(e,r,\"%s is less than the minimum value %s\",r,a.minimum)]:\"maximum\"in a&&r>a.maximum?[new i(e,r,\"%s is greater than the maximum value %s\",r,a.maximum)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],319:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"./validate\");e.exports=function(t){var e=t.key,r=t.value,o=t.valueSpec,s=t.objectElementValidators||{},l=t.style,u=t.styleSpec,c=[],h=i(r);if(\"object\"!==h)return[new n(e,r,\"object expected, %s found\",h)];for(var f in r){var d=f.split(\".\")[0],p=o&&(o[d]||o[\"*\"]),m=s[d]||s[\"*\"];p||m?c=c.concat((m||a)({key:(e?e+\".\":e)+f,value:r[f],valueSpec:p,style:l,styleSpec:u,object:r,objectKey:f})):\"\"!==e&&1!==e.split(\".\").length&&c.push(new n(e,r[f],'unknown property \"%s\"',f))}for(d in o)o[d].required&&void 0===o[d].default&&void 0===r[d]&&c.push(new n(e,r,'missing required property \"%s\"',d));return c}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307}],320:[function(t,e,r){\"use strict\";var n=t(\"./validate\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.style,a=t.styleSpec,o=t.value,s=t.objectKey,l=a[\"paint_\"+t.layerType],u=s.match(/^(.*)-transition$/);return u&&l[u[1]]&&l[u[1]].transition?n({key:e,value:o,valueSpec:a.transition,style:r,styleSpec:a}):t.valueSpec||l[s]?n({key:t.key,value:o,valueSpec:t.valueSpec||l[s],style:r,styleSpec:a}):[new i(e,o,'unknown property \"%s\"',s)]}},{\"../error/validation_error\":303,\"./validate\":307}],321:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\"),a=t(\"./validate_object\"),o=t(\"./validate_enum\");e.exports=function(t){var e=t.value,r=t.key,s=t.styleSpec,l=t.style;if(!e.type)return[new n(r,e,'\"type\" is required')];switch(i(e.type)){case\"vector\":case\"raster\":var u=[];if(u=u.concat(a({key:r,value:e,valueSpec:s.source_tile,style:t.style,styleSpec:s})),\"url\"in e)for(var c in e)[\"type\",\"url\",\"tileSize\"].indexOf(c)<0&&u.push(new n(r+\".\"+c,e[c],'a source with a \"url\" property may not include a \"%s\" property',c));return u;case\"geojson\":return a({key:r,value:e,valueSpec:s.source_geojson,style:l,styleSpec:s});case\"video\":return a({key:r,value:e,valueSpec:s.source_video,style:l,styleSpec:s});case\"image\":return a({key:r,value:e,valueSpec:s.source_image,style:l,styleSpec:s});default:return o({key:r+\".type\",value:e.type,valueSpec:{values:[\"vector\",\"raster\",\"geojson\",\"video\",\"image\"]},style:l,styleSpec:s})}}},{\"../error/validation_error\":303,\"../util/unbundle_jsonlint\":306,\"./validate_enum\":312,\"./validate_object\":319}],322:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.key,a=n(e);return\"string\"!==a?[new i(r,e,\"string expected, %s found\",a)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],323:[function(t,e,r){\"use strict\";function n(t,e){e=e||l;var r=[];return r=r.concat(s({key:\"\",value:t,valueSpec:e.$root,styleSpec:e,style:t,objectElementValidators:{glyphs:u}})),e.$version>7&&t.constants&&(r=r.concat(o({key:\"constants\",value:t.constants,style:t,styleSpec:e}))),i(r)}function i(t){return[].concat(t).sort(function(t,e){return t.line-e.line})}function a(t){return function(){return i(t.apply(this,arguments))}}var o=t(\"./validate/validate_constants\"),s=t(\"./validate/validate\"),l=t(\"../reference/latest.min\"),u=t(\"./validate/validate_glyphs_url\");n.source=a(t(\"./validate/validate_source\")),n.layer=a(t(\"./validate/validate_layer\")),n.filter=a(t(\"./validate/validate_filter\")),n.paintProperty=a(t(\"./validate/validate_paint_property\")),n.layoutProperty=a(t(\"./validate/validate_layout_property\")),e.exports=n},{\"../reference/latest.min\":324,\"./validate/validate\":307,\"./validate/validate_constants\":311,\"./validate/validate_filter\":313,\"./validate/validate_glyphs_url\":315,\"./validate/validate_layer\":316,\"./validate/validate_layout_property\":317,\"./validate/validate_paint_property\":320,\"./validate/validate_source\":321}],324:[function(t,e,r){e.exports=t(\"./v8.min.json\")},{\"./v8.min.json\":325}],325:[function(t,e,r){e.exports={$version:8,$root:{version:{required:!0,type:\"enum\",values:[8]},name:{type:\"string\"},metadata:{type:\"*\"},center:{type:\"array\",value:\"number\"},zoom:{type:\"number\"},bearing:{type:\"number\",default:0,period:360,units:\"degrees\"},pitch:{type:\"number\",default:0,units:\"degrees\"},sources:{required:!0,type:\"sources\"},sprite:{type:\"string\"},glyphs:{type:\"string\"},transition:{type:\"transition\"},layers:{required:!0,type:\"array\",value:\"layer\"}},sources:{\"*\":{type:\"source\"}},source:[\"source_tile\",\"source_geojson\",\"source_video\",\"source_image\"],source_tile:{type:{required:!0,type:\"enum\",values:[\"vector\",\"raster\"]},url:{type:\"string\"},tiles:{type:\"array\",value:\"string\"},minzoom:{type:\"number\",default:0},maxzoom:{type:\"number\",default:22},tileSize:{type:\"number\",default:512,units:\"pixels\"},\"*\":{type:\"*\"}},source_geojson:{type:{required:!0,type:\"enum\",values:[\"geojson\"]},data:{type:\"*\"},maxzoom:{type:\"number\",default:14},buffer:{type:\"number\",default:64},tolerance:{type:\"number\",default:3},cluster:{type:\"boolean\",default:!1},clusterRadius:{type:\"number\",default:400},clusterMaxZoom:{type:\"number\"}},source_video:{type:{required:!0,type:\"enum\",values:[\"video\"]},urls:{required:!0,type:\"array\",value:\"string\"},coordinates:{required:!0,type:\"array\",length:4,value:{type:\"array\",length:2,value:\"number\"}}},source_image:{type:{required:!0,type:\"enum\",values:[\"image\"]},url:{required:!0,type:\"string\"},coordinates:{required:!0,type:\"array\",length:4,value:{type:\"array\",length:2,value:\"number\"}}},layer:{id:{type:\"string\",required:!0},type:{type:\"enum\",values:[\"fill\",\"line\",\"symbol\",\"circle\",\"raster\",\"background\"]},metadata:{type:\"*\"},ref:{type:\"string\"},source:{type:\"string\"},\"source-layer\":{type:\"string\"},minzoom:{type:\"number\",minimum:0,maximum:22},maxzoom:{type:\"number\",minimum:0,maximum:22},interactive:{type:\"boolean\",default:!1},filter:{type:\"filter\"},layout:{type:\"layout\"},paint:{type:\"paint\"},\"paint.*\":{type:\"paint\"}},layout:[\"layout_fill\",\"layout_line\",\"layout_circle\",\"layout_symbol\",\"layout_raster\",\"layout_background\"],layout_background:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_fill:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_circle:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_line:{\"line-cap\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"butt\",\"round\",\"square\"],default:\"butt\"},\"line-join\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"bevel\",\"round\",\"miter\"],default:\"miter\"},\"line-miter-limit\":{type:\"number\",default:2,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[{\"line-join\":\"miter\"}]},\"line-round-limit\":{type:\"number\",default:1.05,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[{\"line-join\":\"round\"}]},visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_symbol:{\"symbol-placement\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"point\",\"line\"],default:\"point\"},\"symbol-spacing\":{type:\"number\",default:250,minimum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"pixels\",requires:[{\"symbol-placement\":\"line\"}]},\"symbol-avoid-edges\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1},\"icon-allow-overlap\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\"]},\"icon-ignore-placement\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\"]},\"icon-optional\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\",\"text-field\"]},\"icon-rotation-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"viewport\",requires:[\"icon-image\"]},\"icon-size\":{type:\"number\",default:1,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\"]},\"icon-text-fit\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!1,values:[\"none\",\"both\",\"width\",\"height\"],default:\"none\",requires:[\"icon-image\",\"text-field\"]},\"icon-text-fit-padding\":{type:\"array\",value:\"number\",length:4,default:[0,0,0,0],units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\",\"icon-text-fit\",\"text-field\"]},\"icon-image\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,tokens:!0},\"icon-rotate\":{type:\"number\",default:0,period:360,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"degrees\",requires:[\"icon-image\"]},\"icon-padding\":{type:\"number\",default:2,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-keep-upright\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\",{\"icon-rotation-alignment\":\"map\"},{\"symbol-placement\":\"line\"}]},\"icon-offset\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\"]},\"text-pitch-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],requires:[\"text-field\"]},\"text-rotation-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"viewport\",requires:[\"text-field\"]},\"text-field\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:\"\",tokens:!0},\"text-font\":{type:\"array\",value:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:[\"Open Sans Regular\",\"Arial Unicode MS Regular\"],requires:[\"text-field\"]},\"text-size\":{type:\"number\",default:16,minimum:0,units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-max-width\":{type:\"number\",default:10,minimum:0,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-line-height\":{type:\"number\",default:1.2,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-letter-spacing\":{type:\"number\",default:0,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-justify\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"left\",\"center\",\"right\"],default:\"center\",requires:[\"text-field\"]},\"text-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"center\",\"left\",\"right\",\"top\",\"bottom\",\"top-left\",\"top-right\",\"bottom-left\",\"bottom-right\"],default:\"center\",requires:[\"text-field\"]},\"text-max-angle\":{type:\"number\",default:45,units:\"degrees\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\",{\"symbol-placement\":\"line\"}]},\"text-rotate\":{type:\"number\",default:0,period:360,units:\"degrees\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-padding\":{type:\"number\",default:2,minimum:0,units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-keep-upright\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!0,requires:[\"text-field\",{\"text-rotation-alignment\":\"map\"},{\"symbol-placement\":\"line\"}]},\"text-transform\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"none\",\"uppercase\",\"lowercase\"],default:\"none\",requires:[\"text-field\"]},\"text-offset\":{type:\"array\",value:\"number\",units:\"ems\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,length:2,default:[0,0],requires:[\"text-field\"]},\"text-allow-overlap\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\"]},\"text-ignore-placement\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\"]},\"text-optional\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\",\"icon-image\"]},visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_raster:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},filter:{type:\"array\",value:\"*\"},filter_operator:{type:\"enum\",values:[\"==\",\"!=\",\">\",\">=\",\"<\",\"<=\",\"in\",\"!in\",\"all\",\"any\",\"none\",\"has\",\"!has\"]},geometry_type:{type:\"enum\",values:[\"Point\",\"LineString\",\"Polygon\"]},color_operation:{type:\"enum\",values:[\"lighten\",\"saturate\",\"spin\",\"fade\",\"mix\"]},function:{stops:{type:\"array\",required:!0,value:\"function_stop\"},base:{type:\"number\",default:1,minimum:0},property:{type:\"string\",default:\"$zoom\"},type:{type:\"enum\",values:[\"exponential\",\"interval\",\"categorical\"],default:\"exponential\"}},function_stop:{type:\"array\",minimum:0,maximum:22,value:[\"number\",\"color\"],length:2},paint:[\"paint_fill\",\"paint_line\",\"paint_circle\",\"paint_symbol\",\"paint_raster\",\"paint_background\"],paint_fill:{\"fill-antialias\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!0},\"fill-opacity\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"fill-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"fill-pattern\"}]},\"fill-outline-color\":{type:\"color\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"fill-pattern\"},{\"fill-antialias\":!0}]},\"fill-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"fill-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"fill-translate\"]},\"fill-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,transition:!0}},paint_line:{\"line-opacity\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"line-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"line-pattern\"}]},\"line-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"line-translate\"]},\"line-width\":{type:\"number\",default:1,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-gap-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-offset\":{type:\"number\",default:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-dasharray\":{type:\"array\",value:\"number\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,minimum:0,transition:!0,units:\"line widths\",requires:[{\"!\":\"line-pattern\"}]},\"line-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,transition:!0}},paint_circle:{\"circle-radius\":{type:\"number\",default:5,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"circle-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-blur\":{type:\"number\",default:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"circle-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"circle-translate\"]},\"circle-pitch-scale\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\"}},paint_symbol:{\"icon-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-halo-color\":{type:\"color\",default:\"rgba(0, 0, 0, 0)\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-halo-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-halo-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"icon-image\",\"icon-translate\"]},\"text-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-halo-color\":{type:\"color\",default:\"rgba(0, 0, 0, 0)\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-halo-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-halo-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"text-field\",\"text-translate\"]}},paint_raster:{\"raster-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-hue-rotate\":{type:\"number\",default:0,period:360,function:\"interpolated\",\"zoom-function\":!0,transition:!0,units:\"degrees\"},\"raster-brightness-min\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,default:0,minimum:0,maximum:1,transition:!0},\"raster-brightness-max\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"raster-saturation\":{type:\"number\",default:0,minimum:-1,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-contrast\":{type:\"number\",default:0,minimum:-1,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-fade-duration\":{type:\"number\",default:300,minimum:0,function:\"interpolated\",\"zoom-function\":!0,transition:!0,units:\"milliseconds\"}},paint_background:{\"background-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,transition:!0,requires:[{\"!\":\"background-pattern\"}]},\"background-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,transition:!0},\"background-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0}},transition:{duration:{type:\"number\",default:300,minimum:0,units:\"milliseconds\"},delay:{type:\"number\",default:0,minimum:0,units:\"milliseconds\"}}}},{}],326:[function(t,e,r){\"use strict\";function n(t){return!!(i()&&a()&&o()&&s()&&l()&&u()&&c()&&h(t&&t.failIfMajorPerformanceCaveat))}function i(){return\"undefined\"!=typeof window&&\"undefined\"!=typeof document}function a(){return Array.prototype&&Array.prototype.every&&Array.prototype.filter&&Array.prototype.forEach&&Array.prototype.indexOf&&Array.prototype.lastIndexOf&&Array.prototype.map&&Array.prototype.some&&Array.prototype.reduce&&Array.prototype.reduceRight&&Array.isArray}function o(){return Function.prototype&&Function.prototype.bind}function s(){return Object.keys&&Object.create&&Object.getPrototypeOf&&Object.getOwnPropertyNames&&Object.isSealed&&Object.isFrozen&&Object.isExtensible&&Object.getOwnPropertyDescriptor&&Object.defineProperty&&Object.defineProperties&&Object.seal&&Object.freeze&&Object.preventExtensions}function l(){return\"JSON\"in window&&\"parse\"in JSON&&\"stringify\"in JSON}function u(){return\"Worker\"in window}function c(){return\"Uint8ClampedArray\"in window}function h(t){return void 0===d[t]&&(d[t]=f(t)),d[t]}function f(t){var e=document.createElement(\"canvas\"),r=Object.create(n.webGLContextAttributes);return r.failIfMajorPerformanceCaveat=t,e.probablySupportsContext?e.probablySupportsContext(\"webgl\",r)||e.probablySupportsContext(\"experimental-webgl\",r):e.supportsContext?e.supportsContext(\"webgl\",r)||e.supportsContext(\"experimental-webgl\",r):e.getContext(\"webgl\",r)||e.getContext(\"experimental-webgl\",r)}void 0!==e&&e.exports?e.exports=n:window&&(window.mapboxgl=window.mapboxgl||{},window.mapboxgl.supported=n);var d={};n.webGLContextAttributes={antialias:!1,alpha:!0,stencil:!0,depth:!0}},{}],327:[function(t,e,r){\"use strict\";function n(t){var e=t.layoutVertexArrayType;this.layoutVertexArray=new e;var r=t.elementArrayType;r&&(this.elementArray=new r);var n=t.elementArrayType2;n&&(this.elementArray2=new n),this.paintVertexArrays=i.mapObject(t.paintVertexArrayTypes,function(t){return new t})}var i=t(\"../util/util\");e.exports=n,n.MAX_VERTEX_ARRAY_LENGTH=Math.pow(2,16)-1,n.prototype.hasCapacityFor=function(t){return this.layoutVertexArray.length+t<=n.MAX_VERTEX_ARRAY_LENGTH},n.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},n.prototype.trim=function(){this.layoutVertexArray.trim(),this.elementArray&&this.elementArray.trim(),this.elementArray2&&this.elementArray2.trim();for(var t in this.paintVertexArrays)this.paintVertexArrays[t].trim()},n.prototype.serialize=function(){return{layoutVertexArray:this.layoutVertexArray.serialize(),elementArray:this.elementArray&&this.elementArray.serialize(),elementArray2:this.elementArray2&&this.elementArray2.serialize(),paintVertexArrays:i.mapObject(this.paintVertexArrays,function(t){return t.serialize()})}},n.prototype.getTransferables=function(t){t.push(this.layoutVertexArray.arrayBuffer),this.elementArray&&t.push(this.elementArray.arrayBuffer),this.elementArray2&&t.push(this.elementArray2.arrayBuffer);for(var e in this.paintVertexArrays)t.push(this.paintVertexArrays[e].arrayBuffer)}},{\"../util/util\":441}],328:[function(t,e,r){\"use strict\";function n(t){if(this.zoom=t.zoom,this.overscaling=t.overscaling,this.layer=t.layer,this.childLayers=t.childLayers,this.type=this.layer.type,this.features=[],this.id=this.layer.id,this.index=t.index,this.sourceLayer=this.layer.sourceLayer,this.sourceLayerIndex=t.sourceLayerIndex,this.minZoom=this.layer.minzoom,this.maxZoom=this.layer.maxzoom,this.paintAttributes=i(this),t.arrays){var e=this.programInterfaces;this.bufferGroups=c.mapObject(t.arrays,function(r,n){var i=e[n],a=t.paintVertexArrayTypes[n];return r.map(function(t){return new u(t,{layoutVertexArrayType:i.layoutVertexArrayType.serialize(),elementArrayType:i.elementArrayType&&i.elementArrayType.serialize(),elementArrayType2:i.elementArrayType2&&i.elementArrayType2.serialize(),paintVertexArrayTypes:a})})})}}function i(t){var e={};for(var r in t.programInterfaces){for(var n=e[r]={},i=0;i<t.childLayers.length;i++){n[t.childLayers[i].id]={attributes:[],uniforms:[],defines:[],vertexPragmas:{define:{},initialize:{}},fragmentPragmas:{define:{},initialize:{}}}}var s=t.programInterfaces[r];if(s.paintAttributes)for(var l=0;l<s.paintAttributes.length;l++){var u=s.paintAttributes[l];u.multiplier=u.multiplier||1;for(var h=0;h<t.childLayers.length;h++){var d=t.childLayers[h],p=n[d.id],m=u.name;f(\"a_\"===u.name.slice(0,2));var v,g=u.name.slice(2);if(p.fragmentPragmas.initialize[g]=\"\",d.isPaintValueFeatureConstant(u.paintProperty))p.uniforms.push(u),p.fragmentPragmas.define[g]=p.vertexPragmas.define[g]=[\"uniform\",\"{precision}\",\"{type}\",m].join(\" \")+\";\",p.fragmentPragmas.initialize[g]=p.vertexPragmas.initialize[g]=[\"{precision}\",\"{type}\",g,\"=\",m].join(\" \")+\";\\n\";else if(d.isPaintValueZoomConstant(u.paintProperty)){p.attributes.push(c.extend({},u,{name:m})),v=[\"varying\",\"{precision}\",\"{type}\",g].join(\" \")+\";\\n\"\n",
       ";var y=[p.fragmentPragmas.define[g],\"attribute\",\"{precision}\",\"{type}\",m].join(\" \")+\";\\n\";p.fragmentPragmas.define[g]=v,p.vertexPragmas.define[g]=v+y,p.vertexPragmas.initialize[g]=[g,\"=\",m,\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\"}else{for(var b=\"u_\"+m.slice(2)+\"_t\",x=d.getPaintValueStopZoomLevels(u.paintProperty),_=0;_<x.length&&x[_]<t.zoom;)_++;for(var w=Math.max(0,Math.min(x.length-4,_-2)),M=[],k=0;k<4;k++)M.push(x[Math.min(w+k,x.length-1)]);v=[\"varying\",\"{precision}\",\"{type}\",g].join(\" \")+\";\\n\",p.vertexPragmas.define[g]=v+[\"uniform\",\"lowp\",\"float\",b].join(\" \")+\";\\n\",p.fragmentPragmas.define[g]=v,p.uniforms.push(c.extend({},u,{name:b,getValue:o(u,w),components:1}));var A=u.components;if(1===A)p.attributes.push(c.extend({},u,{getValue:a(u,M),isFunction:!0,components:4*A})),p.vertexPragmas.define[g]+=[\"attribute\",\"{precision}\",\"vec4\",m].join(\" \")+\";\\n\",p.vertexPragmas.initialize[g]=[g,\"=\",\"evaluate_zoom_function_1(\"+m+\", \"+b+\")\",\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\";else{for(var T=[],S=0;S<4;S++)T.push(m+S),p.attributes.push(c.extend({},u,{getValue:a(u,[M[S]]),isFunction:!0,name:m+S})),p.vertexPragmas.define[g]+=[\"attribute\",\"{precision}\",\"{type}\",m+S].join(\" \")+\";\\n\";p.vertexPragmas.initialize[g]=[g,\" = \",\"evaluate_zoom_function_4(\"+T.join(\", \")+\", \"+b+\")\",\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\"}}}}}return e}function a(t,e){return function(r,n,i){if(1===e.length)return t.getValue(r,c.extend({},n,{zoom:e[0]}),i);for(var a=[],o=0;o<e.length;o++){var s=e[o];a.push(t.getValue(r,c.extend({},n,{zoom:s}),i)[0])}return a}}function o(t,e){return function(r,n){var i=r.getPaintInterpolationT(t.paintProperty,n.zoom);return[Math.max(0,Math.min(4,i-e))]}}var s=t(\"feature-filter\"),l=t(\"./array_group\"),u=t(\"./buffer_group\"),c=t(\"../util/util\"),h=t(\"../util/struct_array\"),f=t(\"assert\");e.exports=n,n.create=function(e){return new({fill:t(\"./bucket/fill_bucket\"),line:t(\"./bucket/line_bucket\"),circle:t(\"./bucket/circle_bucket\"),symbol:t(\"./bucket/symbol_bucket\")}[e.layer.type])(e)},n.EXTENT=8192,n.prototype.populateArrays=function(){this.createArrays(),this.recalculateStyleLayers();for(var t=0;t<this.features.length;t++)this.addFeature(this.features[t]);this.trimArrays()},n.prototype.prepareArrayGroup=function(t,e){var r=this.arrayGroups[t],n=r.length&&r[r.length-1];return n&&n.hasCapacityFor(e)||(n=new l({layoutVertexArrayType:this.programInterfaces[t].layoutVertexArrayType,elementArrayType:this.programInterfaces[t].elementArrayType,elementArrayType2:this.programInterfaces[t].elementArrayType2,paintVertexArrayTypes:this.paintVertexArrayTypes[t]}),n.index=r.length,r.push(n)),n},n.prototype.createArrays=function(){this.arrayGroups={},this.paintVertexArrayTypes={};for(var t in this.programInterfaces){this.arrayGroups[t]=[];var e=this.paintVertexArrayTypes[t]={},r=this.paintAttributes[t];for(var i in r)e[i]=new n.VertexArrayType(r[i].attributes)}},n.prototype.destroy=function(t){for(var e in this.bufferGroups)for(var r=this.bufferGroups[e],n=0;n<r.length;n++)r[n].destroy(t)},n.prototype.trimArrays=function(){for(var t in this.arrayGroups)for(var e=this.arrayGroups[t],r=0;r<e.length;r++)e[r].trim()},n.prototype.isEmpty=function(){for(var t in this.arrayGroups)for(var e=this.arrayGroups[t],r=0;r<e.length;r++)if(!e[r].isEmpty())return!1;return!0},n.prototype.getTransferables=function(t){for(var e in this.arrayGroups)for(var r=this.arrayGroups[e],n=0;n<r.length;n++)r[n].getTransferables(t)},n.prototype.setUniforms=function(t,e,r,n,i){for(var a=this.paintAttributes[e][n.id].uniforms,o=0;o<a.length;o++){var s=a[o],l=r[s.name];t[\"uniform\"+s.components+\"fv\"](l,s.getValue(n,i))}},n.prototype.serialize=function(){return{layerId:this.layer.id,zoom:this.zoom,arrays:c.mapObject(this.arrayGroups,function(t){return t.map(function(t){return t.serialize()})}),paintVertexArrayTypes:c.mapObject(this.paintVertexArrayTypes,function(t){return c.mapObject(t,function(t){return t.serialize()})}),childLayerIds:this.childLayers.map(function(t){return t.id})}},n.prototype.createFilter=function(){this.filter||(this.filter=s(this.layer.filter))};var d={lastIntegerZoom:1/0,lastIntegerZoomTime:0,lastZoom:0};n.prototype.recalculateStyleLayers=function(){for(var t=0;t<this.childLayers.length;t++)this.childLayers[t].recalculate(this.zoom,d)},n.prototype.populatePaintArrays=function(t,e,r,n,i){for(var a=0;a<this.childLayers.length;a++)for(var o=this.childLayers[a],s=this.arrayGroups[t],l=n.index;l<s.length;l++){var u=s[l],c=u.layoutVertexArray.length,h=u.paintVertexArrays[o.id];h.resize(c);for(var f=this.paintAttributes[t][o.id].attributes,d=0;d<f.length;d++)for(var p=f[d],m=p.getValue(o,e,r),v=p.multiplier||1,g=p.components||1,y=l===n.index?i:0,b=y;b<c;b++)for(var x=h.get(b),_=0;_<g;_++){var w=g>1?p.name+_:p.name;x[w]=m[_]*v}}},n.VertexArrayType=function(t){return new h({members:t,alignment:4})},n.ElementArrayType=function(t){return new h({members:[{type:\"Uint16\",name:\"vertices\",components:t||3}]})}},{\"../util/struct_array\":439,\"../util/util\":441,\"./array_group\":327,\"./bucket/circle_bucket\":329,\"./bucket/fill_bucket\":330,\"./bucket/line_bucket\":331,\"./bucket/symbol_bucket\":332,\"./buffer_group\":334,assert:46,\"feature-filter\":131}],329:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=i.EXTENT;e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.addCircleVertex=function(t,e,r,n,i){return t.emplaceBack(2*e+(n+1)/2,2*r+(i+1)/2)},n.prototype.programInterfaces={circle:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"}]),elementArrayType:new i.ElementArrayType,paintAttributes:[{name:\"a_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"circle-color\",e,r)},multiplier:255,paintProperty:\"circle-color\"},{name:\"a_radius\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-radius\",e,r)]},multiplier:10,paintProperty:\"circle-radius\"},{name:\"a_blur\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-blur\",e,r)]},multiplier:10,paintProperty:\"circle-blur\"},{name:\"a_opacity\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-opacity\",e,r)]},multiplier:255,paintProperty:\"circle-opacity\"}]}},n.prototype.addFeature=function(t){for(var e={zoom:this.zoom},r=o(t),n=this.prepareArrayGroup(\"circle\",0),i=n.layoutVertexArray.length,a=0;a<r.length;a++)for(var l=0;l<r[a].length;l++){var u=r[a][l].x,c=r[a][l].y;if(!(u<0||u>=s||c<0||c>=s)){var h=this.prepareArrayGroup(\"circle\",4),f=h.layoutVertexArray,d=this.addCircleVertex(f,u,c,-1,-1);this.addCircleVertex(f,u,c,1,-1),this.addCircleVertex(f,u,c,1,1),this.addCircleVertex(f,u,c,-1,1),h.elementArray.emplaceBack(d,d+1,d+2),h.elementArray.emplaceBack(d,d+3,d+2)}}this.populatePaintArrays(\"circle\",e,t.properties,n,i)}},{\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336}],330:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=t(\"earcut\"),l=t(\"../../util/classify_rings\");e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.programInterfaces={fill:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"}]),elementArrayType:new i.ElementArrayType(1),elementArrayType2:new i.ElementArrayType(2),paintAttributes:[{name:\"a_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"fill-color\",e,r)},multiplier:255,paintProperty:\"fill-color\"},{name:\"a_outline_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"fill-outline-color\",e,r)},multiplier:255,paintProperty:\"fill-outline-color\"},{name:\"a_opacity\",components:1,type:\"Uint8\",getValue:function(t,e,r){return[t.getPaintValue(\"fill-opacity\",e,r)]},multiplier:255,paintProperty:\"fill-opacity\"}]}},n.prototype.addFeature=function(t){for(var e=o(t),r=l(e,500),n=this.prepareArrayGroup(\"fill\",0),i=n.layoutVertexArray.length,a=0;a<r.length;a++)this.addPolygon(r[a]);this.populatePaintArrays(\"fill\",{zoom:this.zoom},t.properties,n,i)},n.prototype.addPolygon=function(t){for(var e=0,r=0;r<t.length;r++)e+=t[r].length;for(var n=this.prepareArrayGroup(\"fill\",e),i=[],a=[],o=n.layoutVertexArray.length,l=0;l<t.length;l++){var u=t[l];l>0&&a.push(i.length/2);for(var c=0;c<u.length;c++){var h=u[c],f=n.layoutVertexArray.emplaceBack(h.x,h.y);c>=1&&n.elementArray2.emplaceBack(f-1,f),i.push(h.x),i.push(h.y)}}for(var d=s(i,a),p=0;p<d.length;p++)n.elementArray.emplaceBack(d[p]+o)}},{\"../../util/classify_rings\":429,\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336,earcut:125}],331:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=i.EXTENT,l=Math.cos(Math.PI/180*37.5),u=Math.pow(2,14)/.5;e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.addLineVertex=function(t,e,r,n,i,a,o){return t.emplaceBack(e.x<<1|n,e.y<<1|i,Math.round(63*r.x)+128,Math.round(63*r.y)+128,1+(0===a?0:a<0?-1:1)|(.5*o&63)<<2,.5*o>>6)},n.prototype.programInterfaces={line:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_data\",components:4,type:\"Uint8\"}]),elementArrayType:new i.ElementArrayType}},n.prototype.addFeature=function(t){for(var e=o(t,15),r=0;r<e.length;r++)this.addLine(e[r],this.layer.layout[\"line-join\"],this.layer.layout[\"line-cap\"],this.layer.layout[\"line-miter-limit\"],this.layer.layout[\"line-round-limit\"])},n.prototype.addLine=function(t,e,r,n,i){for(var a=t.length;a>2&&t[a-1].equals(t[a-2]);)a--;if(!(t.length<2)){\"bevel\"===e&&(n=1.05);var o=s/(512*this.overscaling)*15,u=t[0],c=t[a-1],h=u.equals(c);if(this.prepareArrayGroup(\"line\",10*a),2!==a||!h){this.distance=0;var f,d,p,m,v,g,y,b=r,x=h?\"butt\":r,_=!0;this.e1=this.e2=this.e3=-1,h&&(f=t[a-2],v=u.sub(f)._unit()._perp());for(var w=0;w<a;w++)if(!(p=h&&w===a-1?t[1]:t[w+1])||!t[w].equals(p)){v&&(m=v),f&&(d=f),f=t[w],v=p?p.sub(f)._unit()._perp():m,m=m||v;var M=m.add(v)._unit(),k=M.x*v.x+M.y*v.y,A=1/k,T=k<l&&d&&p;if(T&&w>0){var S=f.dist(d);if(S>2*o){var E=f.sub(f.sub(d)._mult(o/S)._round());this.distance+=E.dist(d),this.addCurrentVertex(E,this.distance,m.mult(1),0,0,!1),d=E}}var L=d&&p,C=L?e:p?b:x;if(L&&\"round\"===C&&(A<i?C=\"miter\":A<=2&&(C=\"fakeround\")),\"miter\"===C&&A>n&&(C=\"bevel\"),\"bevel\"===C&&(A>2&&(C=\"flipbevel\"),A<n&&(C=\"miter\")),d&&(this.distance+=f.dist(d)),\"miter\"===C)M._mult(A),this.addCurrentVertex(f,this.distance,M,0,0,!1);else if(\"flipbevel\"===C){if(A>100)M=v.clone();else{var z=m.x*v.y-m.y*v.x>0?-1:1,I=A*m.add(v).mag()/m.sub(v).mag();M._perp()._mult(I*z)}this.addCurrentVertex(f,this.distance,M,0,0,!1),this.addCurrentVertex(f,this.distance,M.mult(-1),0,0,!1)}else if(\"bevel\"===C||\"fakeround\"===C){var D=m.x*v.y-m.y*v.x>0,P=-Math.sqrt(A*A-1);if(D?(y=0,g=P):(g=0,y=P),_||this.addCurrentVertex(f,this.distance,m,g,y,!1),\"fakeround\"===C){for(var O,R=Math.floor(8*(.5-(k-.5))),F=0;F<R;F++)O=v.mult((F+1)/(R+1))._add(m)._unit(),this.addPieSliceVertex(f,this.distance,O,D);this.addPieSliceVertex(f,this.distance,M,D);for(var j=R-1;j>=0;j--)O=m.mult((j+1)/(R+1))._add(v)._unit(),this.addPieSliceVertex(f,this.distance,O,D)}p&&this.addCurrentVertex(f,this.distance,v,-g,-y,!1)}else\"butt\"===C?(_||this.addCurrentVertex(f,this.distance,m,0,0,!1),p&&this.addCurrentVertex(f,this.distance,v,0,0,!1)):\"square\"===C?(_||(this.addCurrentVertex(f,this.distance,m,1,1,!1),this.e1=this.e2=-1),p&&this.addCurrentVertex(f,this.distance,v,-1,-1,!1)):\"round\"===C&&(_||(this.addCurrentVertex(f,this.distance,m,0,0,!1),this.addCurrentVertex(f,this.distance,m,1,1,!0),this.e1=this.e2=-1),p&&(this.addCurrentVertex(f,this.distance,v,-1,-1,!0),this.addCurrentVertex(f,this.distance,v,0,0,!1)));if(T&&w<a-1){var N=f.dist(p);if(N>2*o){var B=f.add(p.sub(f)._mult(o/N)._round());this.distance+=B.dist(f),this.addCurrentVertex(B,this.distance,v.mult(1),0,0,!1),f=B}}_=!1}}}},n.prototype.addCurrentVertex=function(t,e,r,n,i,a){var o,s=a?1:0,l=this.arrayGroups.line[this.arrayGroups.line.length-1],c=l.layoutVertexArray,h=l.elementArray;o=r.clone(),n&&o._sub(r.perp()._mult(n)),this.e3=this.addLineVertex(c,t,o,s,0,n,e),this.e1>=0&&this.e2>=0&&h.emplaceBack(this.e1,this.e2,this.e3),this.e1=this.e2,this.e2=this.e3,o=r.mult(-1),i&&o._sub(r.perp()._mult(i)),this.e3=this.addLineVertex(c,t,o,s,1,-i,e),this.e1>=0&&this.e2>=0&&h.emplaceBack(this.e1,this.e2,this.e3),this.e1=this.e2,this.e2=this.e3,e>u/2&&(this.distance=0,this.addCurrentVertex(t,this.distance,r,n,i,a))},n.prototype.addPieSliceVertex=function(t,e,r,n){var i=n?1:0;r=r.mult(n?-1:1);var a=this.arrayGroups.line[this.arrayGroups.line.length-1],o=a.layoutVertexArray,s=a.elementArray;this.e3=this.addLineVertex(o,t,r,0,i,0,e),this.e1>=0&&this.e2>=0&&s.emplaceBack(this.e1,this.e2,this.e3),n?this.e2=this.e3:this.e1=this.e3}},{\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336}],332:[function(t,e,r){\"use strict\";function n(t){o.apply(this,arguments),this.showCollisionBoxes=t.showCollisionBoxes,this.overscaling=t.overscaling,this.collisionBoxArray=t.collisionBoxArray,this.symbolQuadsArray=t.symbolQuadsArray,this.symbolInstancesArray=t.symbolInstancesArray,this.sdfIcons=t.sdfIcons,this.iconsNeedLinear=t.iconsNeedLinear,this.adjustedTextSize=t.adjustedTextSize,this.adjustedIconSize=t.adjustedIconSize,this.fontstack=t.fontstack}function i(t,e,r,n,i,a,o,s,l,u,c){return t.emplaceBack(e,r,Math.round(64*n),Math.round(64*i),a/4,o/4,10*(u||0),c,10*(s||0),10*Math.min(l||25,25))}var a=t(\"point-geometry\"),o=t(\"../bucket\"),s=t(\"../../symbol/anchor\"),l=t(\"../../symbol/get_anchors\"),u=t(\"../../util/token\"),c=t(\"../../symbol/quads\"),h=t(\"../../symbol/shaping\"),f=t(\"../../symbol/resolve_text\"),d=t(\"../../symbol/mergelines\"),p=t(\"../../symbol/clip_line\"),m=t(\"../../util/util\"),v=t(\"../load_geometry\"),g=t(\"../../symbol/collision_feature\"),y=h.shapeText,b=h.shapeIcon,x=c.getGlyphQuads,_=c.getIconQuads,w=o.EXTENT;e.exports=n,n.MAX_QUADS=65535,n.prototype=m.inherit(o,{}),n.prototype.serialize=function(){var t=o.prototype.serialize.apply(this);return t.sdfIcons=this.sdfIcons,t.iconsNeedLinear=this.iconsNeedLinear,t.adjustedTextSize=this.adjustedTextSize,t.adjustedIconSize=this.adjustedIconSize,t.fontstack=this.fontstack,t};var M=new o.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_offset\",components:2,type:\"Int16\"},{name:\"a_texture_pos\",components:2,type:\"Uint16\"},{name:\"a_data\",components:4,type:\"Uint8\"}]),k=new o.ElementArrayType;n.prototype.addCollisionBoxVertex=function(t,e,r,n,i){return t.emplaceBack(e.x,e.y,Math.round(r.x),Math.round(r.y),10*n,10*i)},n.prototype.programInterfaces={glyph:{layoutVertexArrayType:M,elementArrayType:k},icon:{layoutVertexArrayType:M,elementArrayType:k},collisionBox:{layoutVertexArrayType:new o.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_extrude\",components:2,type:\"Int16\"},{name:\"a_data\",components:2,type:\"Uint8\"}])}},n.prototype.populateArrays=function(t,e,r){var n={lastIntegerZoom:1/0,lastIntegerZoomTime:0,lastZoom:0};this.adjustedTextMaxSize=this.layer.getLayoutValue(\"text-size\",{zoom:18,zoomHistory:n}),this.adjustedTextSize=this.layer.getLayoutValue(\"text-size\",{zoom:this.zoom+1,zoomHistory:n}),this.adjustedIconMaxSize=this.layer.getLayoutValue(\"icon-size\",{zoom:18,zoomHistory:n}),this.adjustedIconSize=this.layer.getLayoutValue(\"icon-size\",{zoom:this.zoom+1,zoomHistory:n});var i=512*this.overscaling;this.tilePixelRatio=w/i,this.compareText={},this.iconsNeedLinear=!1,this.symbolInstancesStartIndex=this.symbolInstancesArray.length;var a=this.layer.layout,o=this.features,s=this.textFeatures,l=.5,c=.5;switch(a[\"text-anchor\"]){case\"right\":case\"top-right\":case\"bottom-right\":l=1;break;case\"left\":case\"top-left\":case\"bottom-left\":l=0}switch(a[\"text-anchor\"]){case\"bottom\":case\"bottom-right\":case\"bottom-left\":c=1;break;case\"top\":case\"top-right\":case\"top-left\":c=0}for(var h=\"right\"===a[\"text-justify\"]?1:\"left\"===a[\"text-justify\"]?0:.5,f=24*a[\"text-line-height\"],p=\"line\"!==a[\"symbol-placement\"]?24*a[\"text-max-width\"]:0,g=24*a[\"text-letter-spacing\"],x=[24*a[\"text-offset\"][0],24*a[\"text-offset\"][1]],_=this.fontstack=a[\"text-font\"].join(\",\"),M=[],k=0;k<o.length;k++)M.push(v(o[k]));if(\"line\"===a[\"symbol-placement\"]){var A=d(o,s,M);M=A.geometries,o=A.features,s=A.textFeatures}for(var T,S,E=0;E<o.length;E++)if(M[E]){if(T=s[E]?y(s[E],e[_],p,f,l,c,h,g,x):null,a[\"icon-image\"]){var L=u(o[E].properties,a[\"icon-image\"]),C=r[L];S=b(C,a),C&&(void 0===this.sdfIcons?this.sdfIcons=C.sdf:this.sdfIcons!==C.sdf&&m.warnOnce(\"Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer\"),1!==C.pixelRatio?this.iconsNeedLinear=!0:0===a[\"icon-rotate\"]&&this.layer.isLayoutValueFeatureConstant(\"icon-rotate\")||(this.iconsNeedLinear=!0))}else S=null;(T||S)&&this.addFeature(M[E],T,S,o[E])}this.symbolInstancesEndIndex=this.symbolInstancesArray.length,this.placeFeatures(t,this.showCollisionBoxes),this.trimArrays()},n.prototype.addFeature=function(t,e,r,n){var i=this.layer.layout,a=this.adjustedTextSize/24,o=void 0!==this.adjustedTextMaxSize?this.adjustedTextMaxSize:this.adjustedTextSize,u=this.tilePixelRatio*a,c=this.tilePixelRatio*o/24,h=this.tilePixelRatio*this.adjustedIconSize,f=this.tilePixelRatio*i[\"symbol-spacing\"],d=i[\"symbol-avoid-edges\"],m=i[\"text-padding\"]*this.tilePixelRatio,v=i[\"icon-padding\"]*this.tilePixelRatio,g=i[\"text-max-angle\"]/180*Math.PI,y=\"map\"===i[\"text-rotation-alignment\"]&&\"line\"===i[\"symbol-placement\"],b=\"map\"===i[\"icon-rotation-alignment\"]&&\"line\"===i[\"symbol-placement\"],x=i[\"text-allow-overlap\"]||i[\"icon-allow-overlap\"]||i[\"text-ignore-placement\"]||i[\"icon-ignore-placement\"],_=\"line\"===i[\"symbol-placement\"],M=f/2;_&&(t=p(t,0,0,w,w));for(var k=0;k<t.length;k++){var A,T=t[k];A=_?l(T,f,g,e,r,24,c,this.overscaling,w):[new s(T[0].x,T[0].y,0)];for(var S=0,E=A.length;S<E;S++){var L=A[S];if(!(e&&_&&this.anchorIsTooClose(e.text,M,L))){var C=!(L.x<0||L.x>w||L.y<0||L.y>w);if(!d||C){var z=C||x;this.addSymbolInstance(L,T,e,r,this.layer,z,this.symbolInstancesArray.length,this.collisionBoxArray,n.index,this.sourceLayerIndex,this.index,u,m,y,h,v,b,{zoom:this.zoom},n.properties)}}}}},n.prototype.anchorIsTooClose=function(t,e,r){var n=this.compareText;if(t in n){for(var i=n[t],a=i.length-1;a>=0;a--)if(r.dist(i[a])<e)return!0}else n[t]=[];return n[t].push(r),!1},n.prototype.placeFeatures=function(t,e){this.recalculateStyleLayers(),this.createArrays();var r=this.layer.layout,n=t.maxScale,i=\"map\"===r[\"text-rotation-alignment\"]&&\"line\"===r[\"symbol-placement\"],a=\"map\"===r[\"icon-rotation-alignment\"]&&\"line\"===r[\"symbol-placement\"];if(r[\"text-allow-overlap\"]||r[\"icon-allow-overlap\"]||r[\"text-ignore-placement\"]||r[\"icon-ignore-placement\"]){var o=this.symbolInstancesArray.toArray(this.symbolInstancesStartIndex,this.symbolInstancesEndIndex),s=t.angle,l=Math.sin(s),u=Math.cos(s);this.sortedSymbolInstances=o.sort(function(t,e){return(l*t.anchorPointX+u*t.anchorPointY|0)-(l*e.anchorPointX+u*e.anchorPointY|0)||e.index-t.index})}for(var c=this.symbolInstancesStartIndex;c<this.symbolInstancesEndIndex;c++){var h=this.sortedSymbolInstances?this.sortedSymbolInstances[c-this.symbolInstancesStartIndex]:this.symbolInstancesArray.get(c),f={boxStartIndex:h.textBoxStartIndex,boxEndIndex:h.textBoxEndIndex},d={boxStartIndex:h.iconBoxStartIndex,boxEndIndex:h.iconBoxEndIndex},p=!(h.textBoxStartIndex===h.textBoxEndIndex),m=!(h.iconBoxStartIndex===h.iconBoxEndIndex),v=r[\"text-optional\"]||!p,g=r[\"icon-optional\"]||!m,y=p?t.placeCollisionFeature(f,r[\"text-allow-overlap\"],r[\"symbol-avoid-edges\"]):t.minScale,b=m?t.placeCollisionFeature(d,r[\"icon-allow-overlap\"],r[\"symbol-avoid-edges\"]):t.minScale;v||g?!g&&y?y=Math.max(b,y):!v&&b&&(b=Math.max(b,y)):b=y=Math.max(b,y),p&&(t.insertCollisionFeature(f,y,r[\"text-ignore-placement\"]),y<=n&&this.addSymbols(\"glyph\",h.glyphQuadStartIndex,h.glyphQuadEndIndex,y,r[\"text-keep-upright\"],i,t.angle)),m&&(t.insertCollisionFeature(d,b,r[\"icon-ignore-placement\"]),b<=n&&this.addSymbols(\"icon\",h.iconQuadStartIndex,h.iconQuadEndIndex,b,r[\"icon-keep-upright\"],a,t.angle))}e&&this.addToDebugBuffers(t)},n.prototype.addSymbols=function(t,e,r,n,a,o,s){for(var l=this.prepareArrayGroup(t,4*(r-e)),u=l.elementArray,c=l.layoutVertexArray,h=this.zoom,f=Math.max(Math.log(n)/Math.LN2+h,0),d=e;d<r;d++){var p=this.symbolQuadsArray.get(d).SymbolQuad,m=(p.anchorAngle+s+Math.PI)%(2*Math.PI);if(!(a&&o&&(m<=Math.PI/2||m>3*Math.PI/2))){var v=p.tl,g=p.tr,y=p.bl,b=p.br,x=p.tex,_=p.anchorPoint,w=Math.max(h+Math.log(p.minScale)/Math.LN2,f),M=Math.min(h+Math.log(p.maxScale)/Math.LN2,25);if(!(M<=w)){w===f&&(w=0);var k=Math.round(p.glyphAngle/(2*Math.PI)*256),A=i(c,_.x,_.y,v.x,v.y,x.x,x.y,w,M,f,k);i(c,_.x,_.y,g.x,g.y,x.x+x.w,x.y,w,M,f,k),i(c,_.x,_.y,y.x,y.y,x.x,x.y+x.h,w,M,f,k),i(c,_.x,_.y,b.x,b.y,x.x+x.w,x.y+x.h,w,M,f,k),u.emplaceBack(A,A+1,A+2),u.emplaceBack(A+1,A+2,A+3)}}}},n.prototype.updateIcons=function(t){this.recalculateStyleLayers();var e=this.layer.layout[\"icon-image\"];if(e)for(var r=0;r<this.features.length;r++){var n=u(this.features[r].properties,e);n&&(t[n]=!0)}},n.prototype.updateFont=function(t){this.recalculateStyleLayers();var e=this.layer.layout[\"text-font\"],r=t[e]=t[e]||{};this.textFeatures=f(this.features,this.layer.layout,r)},n.prototype.addToDebugBuffers=function(t){for(var e=this.prepareArrayGroup(\"collisionBox\",0),r=e.layoutVertexArray,n=-t.angle,i=t.yStretch,o=this.symbolInstancesStartIndex;o<this.symbolInstancesEndIndex;o++){var s=this.symbolInstancesArray.get(o);s.textCollisionFeature={boxStartIndex:s.textBoxStartIndex,boxEndIndex:s.textBoxEndIndex},s.iconCollisionFeature={boxStartIndex:s.iconBoxStartIndex,boxEndIndex:s.iconBoxEndIndex};for(var l=0;l<2;l++){var u=s[0===l?\"textCollisionFeature\":\"iconCollisionFeature\"];if(u)for(var c=u.boxStartIndex;c<u.boxEndIndex;c++){var h=this.collisionBoxArray.get(c),f=h.anchorPoint,d=new a(h.x1,h.y1*i)._rotate(n),p=new a(h.x2,h.y1*i)._rotate(n),m=new a(h.x1,h.y2*i)._rotate(n),v=new a(h.x2,h.y2*i)._rotate(n),g=Math.max(0,Math.min(25,this.zoom+Math.log(h.maxScale)/Math.LN2)),y=Math.max(0,Math.min(25,this.zoom+Math.log(h.placementScale)/Math.LN2));this.addCollisionBoxVertex(r,f,d,g,y),this.addCollisionBoxVertex(r,f,p,g,y),this.addCollisionBoxVertex(r,f,p,g,y),this.addCollisionBoxVertex(r,f,v,g,y),this.addCollisionBoxVertex(r,f,v,g,y),this.addCollisionBoxVertex(r,f,m,g,y),this.addCollisionBoxVertex(r,f,m,g,y),this.addCollisionBoxVertex(r,f,d,g,y)}}}},n.prototype.addSymbolInstance=function(t,e,r,i,a,o,s,l,u,c,h,f,d,p,v,y,b,w,M){var k,A,T,S,E,L,C,z;if(r&&(C=o?x(t,r,f,e,a,p):[],E=new g(l,e,t,u,c,h,r,f,d,p,!1)),k=this.symbolQuadsArray.length,C&&C.length)for(var I=0;I<C.length;I++)this.addSymbolQuad(C[I]);A=this.symbolQuadsArray.length;var D=E?E.boxStartIndex:this.collisionBoxArray.length,P=E?E.boxEndIndex:this.collisionBoxArray.length;i&&(z=o?_(t,i,v,e,a,b,r,w,M):[],L=new g(l,e,t,u,c,h,i,v,y,b,!0)),T=this.symbolQuadsArray.length,z&&1===z.length&&this.addSymbolQuad(z[0]),S=this.symbolQuadsArray.length;var O=L?L.boxStartIndex:this.collisionBoxArray.length,R=L?L.boxEndIndex:this.collisionBoxArray.length;return S>n.MAX_QUADS&&m.warnOnce(\"Too many symbols being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907\"),A>n.MAX_QUADS&&m.warnOnce(\"Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907\"),this.symbolInstancesArray.emplaceBack(D,P,O,R,k,A,T,S,t.x,t.y,s)},n.prototype.addSymbolQuad=function(t){return this.symbolQuadsArray.emplaceBack(t.anchorPoint.x,t.anchorPoint.y,t.tl.x,t.tl.y,t.tr.x,t.tr.y,t.bl.x,t.bl.y,t.br.x,t.br.y,t.tex.h,t.tex.w,t.tex.x,t.tex.y,t.anchorAngle,t.glyphAngle,t.maxScale,t.minScale)}},{\"../../symbol/anchor\":390,\"../../symbol/clip_line\":392,\"../../symbol/collision_feature\":394,\"../../symbol/get_anchors\":396,\"../../symbol/mergelines\":399,\"../../symbol/quads\":400,\"../../symbol/resolve_text\":401,\"../../symbol/shaping\":402,\"../../util/token\":440,\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336,\"point-geometry\":483}],333:[function(t,e,r){\"use strict\";function n(t,e,r){this.arrayBuffer=t.arrayBuffer,this.length=t.length,this.attributes=e.members,this.itemSize=e.bytesPerElement,this.type=r,this.arrayType=e}e.exports=n,n.prototype.bind=function(t){var e=t[this.type];this.buffer?t.bindBuffer(e,this.buffer):(this.buffer=t.createBuffer(),t.bindBuffer(e,this.buffer),t.bufferData(e,this.arrayBuffer,t.STATIC_DRAW),this.arrayBuffer=null)};var i={Int8:\"BYTE\",Uint8:\"UNSIGNED_BYTE\",Int16:\"SHORT\",Uint16:\"UNSIGNED_SHORT\"};n.prototype.setVertexAttribPointers=function(t,e){for(var r=0;r<this.attributes.length;r++){var n=this.attributes[r],a=e[n.name];void 0!==a&&t.vertexAttribPointer(a,n.components,t[i[n.type]],!1,this.arrayType.bytesPerElement,n.offset)}},n.prototype.destroy=function(t){this.buffer&&t.deleteBuffer(this.buffer)},n.BufferType={VERTEX:\"ARRAY_BUFFER\",ELEMENT:\"ELEMENT_ARRAY_BUFFER\"}},{}],334:[function(t,e,r){\"use strict\";function n(t,e){this.layoutVertexBuffer=new a(t.layoutVertexArray,e.layoutVertexArrayType,a.BufferType.VERTEX),t.elementArray&&(this.elementBuffer=new a(t.elementArray,e.elementArrayType,a.BufferType.ELEMENT));var r,n=this.vaos={};t.elementArray2&&(this.elementBuffer2=new a(t.elementArray2,e.elementArrayType2,a.BufferType.ELEMENT),r=this.secondVaos={}),this.paintVertexBuffers=i.mapObject(t.paintVertexArrays,function(i,s){return n[s]=new o,t.elementArray2&&(r[s]=new o),new a(i,e.paintVertexArrayTypes[s],a.BufferType.VERTEX)})}var i=t(\"../util/util\"),a=t(\"./buffer\"),o=t(\"../render/vertex_array_object\");e.exports=n,n.prototype.destroy=function(t){this.layoutVertexBuffer.destroy(t),this.elementBuffer&&this.elementBuffer.destroy(t),this.elementBuffer2&&this.elementBuffer2.destroy(t);for(var e in this.paintVertexBuffers)this.paintVertexBuffers[e].destroy(t);for(var r in this.vaos)this.vaos[r].destroy(t);for(var n in this.secondVaos)this.secondVaos[n].destroy(t)}},{\"../render/vertex_array_object\":356,\"../util/util\":441,\"./buffer\":333}],335:[function(t,e,r){\"use strict\";function n(t,e,r){if(t.grid){var n=t,i=e;t=n.coord,e=n.overscaling,this.grid=new p(n.grid),this.featureIndexArray=new k(n.featureIndexArray),this.rawTileData=i,this.bucketLayerIDs=n.bucketLayerIDs}else this.grid=new p(h,16,0),this.featureIndexArray=new k;this.coord=t,this.overscaling=e,this.x=t.x,this.y=t.y,this.z=t.z-Math.log(e)/Math.LN2,this.setCollisionTile(r)}function i(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}function a(t,e){return e-t}function o(t){return t[\"line-gap-width\"]>0?t[\"line-gap-width\"]+2*t[\"line-width\"]:t[\"line-width\"]}function s(t,e,r,n,i){if(!e[0]&&!e[1])return t;e=u.convert(e),\"viewport\"===r&&e._rotate(-n);for(var a=[],o=0;o<t.length;o++){for(var s=t[o],l=[],c=0;c<s.length;c++)l.push(s[c].sub(e._mult(i)));a.push(l)}return a}function l(t,e){for(var r=[],n=new u(0,0),i=0;i<t.length;i++){for(var a=t[i],o=[],s=0;s<a.length;s++){var l=a[s-1],c=a[s],h=a[s+1],f=0===s?n:c.sub(l)._unit()._perp(),d=s===a.length-1?n:h.sub(c)._unit()._perp(),p=f._add(d)._unit(),m=p.x*d.x+p.y*d.y;p._mult(1/m),o.push(p._mult(e)._add(c))}r.push(o)}return r}var u=t(\"point-geometry\"),c=t(\"./load_geometry\"),h=t(\"./bucket\").EXTENT,f=t(\"feature-filter\"),d=t(\"../util/struct_array\"),p=t(\"grid-index\"),m=t(\"../util/dictionary_coder\"),v=t(\"vector-tile\"),g=t(\"pbf\"),y=t(\"../util/vectortile_to_geojson\"),b=t(\"../util/util\").arraysIntersect,x=t(\"../util/intersection_tests\"),_=x.multiPolygonIntersectsBufferedMultiPoint,w=x.multiPolygonIntersectsMultiPolygon,M=x.multiPolygonIntersectsBufferedMultiLine,k=new d({members:[{type:\"Uint32\",name:\"featureIndex\"},{type:\"Uint16\",name:\"sourceLayerIndex\"},{type:\"Uint16\",name:\"bucketIndex\"}]});e.exports=n,n.prototype.insert=function(t,e,r,n){var i=this.featureIndexArray.length;this.featureIndexArray.emplaceBack(e,r,n);for(var a=c(t),o=0;o<a.length;o++){for(var s=a[o],l=[1/0,1/0,-1/0,-1/0],u=0;u<s.length;u++){var h=s[u];l[0]=Math.min(l[0],h.x),l[1]=Math.min(l[1],h.y),l[2]=Math.max(l[2],h.x),l[3]=Math.max(l[3],h.y)}this.grid.insert(i,l[0],l[1],l[2],l[3])}},n.prototype.setCollisionTile=function(t){this.collisionTile=t},n.prototype.serialize=function(){var t={coord:this.coord,overscaling:this.overscaling,grid:this.grid.toArrayBuffer(),featureIndexArray:this.featureIndexArray.serialize(),bucketLayerIDs:this.bucketLayerIDs};return{data:t,transferables:[t.grid,t.featureIndexArray.arrayBuffer]}},n.prototype.query=function(t,e){this.vtLayers||(this.vtLayers=new v.VectorTile(new g(new Uint8Array(this.rawTileData))).layers,this.sourceLayerCoder=new m(this.vtLayers?Object.keys(this.vtLayers).sort():[\"_geojsonTileLayer\"]));var r={},n=t.params||{},s=h/t.tileSize/t.scale,l=f(n.filter),c=0;for(var d in e){var p=e[d],y=p.paint,b=0;\"line\"===p.type?b=o(y)/2+Math.abs(y[\"line-offset\"])+i(y[\"line-translate\"]):\"fill\"===p.type?b=i(y[\"fill-translate\"]):\"circle\"===p.type&&(b=y[\"circle-radius\"]+i(y[\"circle-translate\"])),c=Math.max(c,b*s)}for(var x=t.queryGeometry.map(function(t){return t.map(function(t){return new u(t.x,t.y)})}),_=1/0,w=1/0,M=-1/0,k=-1/0,A=0;A<x.length;A++)for(var T=x[A],S=0;S<T.length;S++){var E=T[S];_=Math.min(_,E.x),w=Math.min(w,E.y),M=Math.max(M,E.x),k=Math.max(k,E.y)}var L=this.grid.query(_-c,w-c,M+c,k+c);L.sort(a),this.filterMatching(r,L,this.featureIndexArray,x,l,n.layers,e,t.bearing,s);var C=this.collisionTile.queryRenderedSymbols(_,w,M,k,t.scale);return C.sort(),this.filterMatching(r,C,this.collisionTile.collisionBoxArray,x,l,n.layers,e,t.bearing,s),r},n.prototype.filterMatching=function(t,e,r,n,i,a,u,h,f){for(var d,p=0;p<e.length;p++){var m=e[p];if(m!==d){d=m;var v=r.get(m),g=this.bucketLayerIDs[v.bucketIndex];if(!a||b(a,g)){var x=this.sourceLayerCoder.decode(v.sourceLayerIndex),k=this.vtLayers[x],A=k.feature(v.featureIndex);if(i(A))for(var T=null,S=0;S<g.length;S++){var E=g[S];if(!(a&&a.indexOf(E)<0)){var L=u[E];if(L){var C;if(\"symbol\"!==L.type){T||(T=c(A));var z=L.paint;if(\"line\"===L.type){C=s(n,z[\"line-translate\"],z[\"line-translate-anchor\"],h,f);var I=o(z)/2*f;if(z[\"line-offset\"]&&(T=l(T,z[\"line-offset\"]*f)),!M(C,T,I))continue}else if(\"fill\"===L.type){if(C=s(n,z[\"fill-translate\"],z[\"fill-translate-anchor\"],h,f),!w(C,T))continue}else if(\"circle\"===L.type){C=s(n,z[\"circle-translate\"],z[\"circle-translate-anchor\"],h,f);var D=z[\"circle-radius\"]*f;if(!_(C,T,D))continue}}var P=new y(A,this.z,this.x,this.y);P.layer=L.serialize({includeRefProperties:!0});var O=t[E];void 0===O&&(O=t[E]=[]),O.push(P)}}}}}}}},{\"../util/dictionary_coder\":431,\"../util/intersection_tests\":436,\"../util/struct_array\":439,\"../util/util\":441,\"../util/vectortile_to_geojson\":442,\"./bucket\":328,\"./load_geometry\":336,\"feature-filter\":131,\"grid-index\":286,pbf:477,\"point-geometry\":483,\"vector-tile\":549}],336:[function(t,e,r){\"use strict\";function n(t){return{min:-1*Math.pow(2,t-1),max:Math.pow(2,t-1)-1}}var i=t(\"../util/util\"),a=t(\"./bucket\").EXTENT,o=t(\"assert\"),s={15:n(15),16:n(16)};e.exports=function(t,e){var r=s[e||16];o(r);for(var n=a/t.extent,l=t.loadGeometry(),u=0;u<l.length;u++)for(var c=l[u],h=0;h<c.length;h++){var f=c[h];f.x=Math.round(f.x*n),f.y=Math.round(f.y*n),(f.x<r.min||f.x>r.max||f.y<r.min||f.y>r.max)&&i.warnOnce(\"Geometry exceeds allowed extent, reduce your vector tile buffer size\")}return l}},{\"../util/util\":441,\"./bucket\":328,assert:46}],337:[function(t,e,r){\"use strict\";function n(t,e,r){this.column=t,this.row=e,this.zoom=r}e.exports=n,n.prototype={clone:function(){return new n(this.column,this.row,this.zoom)},zoomTo:function(t){return this.clone()._zoomTo(t)},sub:function(t){return this.clone()._sub(t)},_zoomTo:function(t){var e=Math.pow(2,t-this.zoom);return this.column*=e,this.row*=e,this.zoom=t,this},_sub:function(t){return t=t.zoomTo(this.zoom),this.column-=t.column,this.row-=t.row,this}}},{}],338:[function(t,e,r){\"use strict\";function n(t,e){if(isNaN(t)||isNaN(e))throw new Error(\"Invalid LngLat object: (\"+t+\", \"+e+\")\");if(this.lng=+t,this.lat=+e,this.lat>90||this.lat<-90)throw new Error(\"Invalid LngLat latitude value: must be between -90 and 90\")}e.exports=n\n",
       ";var i=t(\"../util/util\").wrap;n.prototype.wrap=function(){return new n(i(this.lng,-180,180),this.lat)},n.prototype.toArray=function(){return[this.lng,this.lat]},n.prototype.toString=function(){return\"LngLat(\"+this.lng+\", \"+this.lat+\")\"},n.convert=function(t){return t instanceof n?t:Array.isArray(t)?new n(t[0],t[1]):t}},{\"../util/util\":441}],339:[function(t,e,r){\"use strict\";function n(t,e){t&&(e?this.extend(t).extend(e):4===t.length?this.extend([t[0],t[1]]).extend([t[2],t[3]]):this.extend(t[0]).extend(t[1]))}e.exports=n;var i=t(\"./lng_lat\");n.prototype={extend:function(t){var e,r,a=this._sw,o=this._ne;if(t instanceof i)e=t,r=t;else{if(!(t instanceof n))return t?this.extend(i.convert(t)||n.convert(t)):this;if(e=t._sw,r=t._ne,!e||!r)return this}return a||o?(a.lng=Math.min(e.lng,a.lng),a.lat=Math.min(e.lat,a.lat),o.lng=Math.max(r.lng,o.lng),o.lat=Math.max(r.lat,o.lat)):(this._sw=new i(e.lng,e.lat),this._ne=new i(r.lng,r.lat)),this},getCenter:function(){return new i((this._sw.lng+this._ne.lng)/2,(this._sw.lat+this._ne.lat)/2)},getSouthWest:function(){return this._sw},getNorthEast:function(){return this._ne},getNorthWest:function(){return new i(this.getWest(),this.getNorth())},getSouthEast:function(){return new i(this.getEast(),this.getSouth())},getWest:function(){return this._sw.lng},getSouth:function(){return this._sw.lat},getEast:function(){return this._ne.lng},getNorth:function(){return this._ne.lat},toArray:function(){return[this._sw.toArray(),this._ne.toArray()]},toString:function(){return\"LngLatBounds(\"+this._sw.toString()+\", \"+this._ne.toString()+\")\"}},n.convert=function(t){return!t||t instanceof n?t:new n(t)}},{\"./lng_lat\":338}],340:[function(t,e,r){\"use strict\";function n(t,e){this.tileSize=512,this._minZoom=t||0,this._maxZoom=e||22,this.latRange=[-85.05113,85.05113],this.width=0,this.height=0,this._center=new i(0,0),this.zoom=0,this.angle=0,this._altitude=1.5,this._pitch=0,this._unmodified=!0}var i=t(\"./lng_lat\"),a=t(\"point-geometry\"),o=t(\"./coordinate\"),s=t(\"../util/util\").wrap,l=t(\"../util/interpolate\"),u=t(\"../source/tile_coord\"),c=t(\"../data/bucket\").EXTENT,h=t(\"gl-matrix\"),f=h.vec4,d=h.mat4,p=h.mat2;e.exports=n,n.prototype={get minZoom(){return this._minZoom},set minZoom(t){this._minZoom!==t&&(this._minZoom=t,this.zoom=Math.max(this.zoom,t))},get maxZoom(){return this._maxZoom},set maxZoom(t){this._maxZoom!==t&&(this._maxZoom=t,this.zoom=Math.min(this.zoom,t))},get worldSize(){return this.tileSize*this.scale},get centerPoint(){return this.size._div(2)},get size(){return new a(this.width,this.height)},get bearing(){return-this.angle/Math.PI*180},set bearing(t){var e=-s(t,-180,180)*Math.PI/180;this.angle!==e&&(this._unmodified=!1,this.angle=e,this._calcMatrices(),this.rotationMatrix=p.create(),p.rotate(this.rotationMatrix,this.rotationMatrix,this.angle))},get pitch(){return this._pitch/Math.PI*180},set pitch(t){var e=Math.min(60,t)/180*Math.PI;this._pitch!==e&&(this._unmodified=!1,this._pitch=e,this._calcMatrices())},get altitude(){return this._altitude},set altitude(t){var e=Math.max(.75,t);this._altitude!==e&&(this._unmodified=!1,this._altitude=e,this._calcMatrices())},get zoom(){return this._zoom},set zoom(t){var e=Math.min(Math.max(t,this.minZoom),this.maxZoom);this._zoom!==e&&(this._unmodified=!1,this._zoom=e,this.scale=this.zoomScale(e),this.tileZoom=Math.floor(e),this.zoomFraction=e-this.tileZoom,this._calcMatrices(),this._constrain())},get center(){return this._center},set center(t){t.lat===this._center.lat&&t.lng===this._center.lng||(this._unmodified=!1,this._center=t,this._calcMatrices(),this._constrain())},coveringZoomLevel:function(t){return(t.roundZoom?Math.round:Math.floor)(this.zoom+this.scaleZoom(this.tileSize/t.tileSize))},coveringTiles:function(t){var e=this.coveringZoomLevel(t),r=e;if(e<t.minzoom)return[];e>t.maxzoom&&(e=t.maxzoom);var n=this,i=n.locationCoordinate(n.center)._zoomTo(e),o=new a(i.column-.5,i.row-.5);return u.cover(e,[n.pointCoordinate(new a(0,0))._zoomTo(e),n.pointCoordinate(new a(n.width,0))._zoomTo(e),n.pointCoordinate(new a(n.width,n.height))._zoomTo(e),n.pointCoordinate(new a(0,n.height))._zoomTo(e)],t.reparseOverscaled?r:e).sort(function(t,e){return o.dist(t)-o.dist(e)})},resize:function(t,e){this.width=t,this.height=e,this.pixelsToGLUnits=[2/t,-2/e],this._calcMatrices(),this._constrain()},get unmodified(){return this._unmodified},zoomScale:function(t){return Math.pow(2,t)},scaleZoom:function(t){return Math.log(t)/Math.LN2},project:function(t,e){return new a(this.lngX(t.lng,e),this.latY(t.lat,e))},unproject:function(t,e){return new i(this.xLng(t.x,e),this.yLat(t.y,e))},get x(){return this.lngX(this.center.lng)},get y(){return this.latY(this.center.lat)},get point(){return new a(this.x,this.y)},lngX:function(t,e){return(180+t)*(e||this.worldSize)/360},latY:function(t,e){return(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+t*Math.PI/360)))*(e||this.worldSize)/360},xLng:function(t,e){return 360*t/(e||this.worldSize)-180},yLat:function(t,e){var r=180-360*t/(e||this.worldSize);return 360/Math.PI*Math.atan(Math.exp(r*Math.PI/180))-90},panBy:function(t){var e=this.centerPoint._add(t);this.center=this.pointLocation(e)},setLocationAtPoint:function(t,e){var r=this.locationCoordinate(t),n=this.pointCoordinate(e),i=this.pointCoordinate(this.centerPoint),a=n._sub(r);this._unmodified=!1,this.center=this.coordinateLocation(i._sub(a))},locationPoint:function(t){return this.coordinatePoint(this.locationCoordinate(t))},pointLocation:function(t){return this.coordinateLocation(this.pointCoordinate(t))},locationCoordinate:function(t){var e=this.zoomScale(this.tileZoom)/this.worldSize,r=i.convert(t);return new o(this.lngX(r.lng)*e,this.latY(r.lat)*e,this.tileZoom)},coordinateLocation:function(t){var e=this.zoomScale(t.zoom);return new i(this.xLng(t.column,e),this.yLat(t.row,e))},pointCoordinate:function(t){var e=[t.x,t.y,0,1],r=[t.x,t.y,1,1];f.transformMat4(e,e,this.pixelMatrixInverse),f.transformMat4(r,r,this.pixelMatrixInverse);var n=e[3],i=r[3],a=e[0]/n,s=r[0]/i,u=e[1]/n,c=r[1]/i,h=e[2]/n,d=r[2]/i,p=h===d?0:(0-h)/(d-h),m=this.worldSize/this.zoomScale(this.tileZoom);return new o(l(a,s,p)/m,l(u,c,p)/m,this.tileZoom)},coordinatePoint:function(t){var e=this.worldSize/this.zoomScale(t.zoom),r=[t.column*e,t.row*e,0,1];return f.transformMat4(r,r,this.pixelMatrix),new a(r[0]/r[3],r[1]/r[3])},calculatePosMatrix:function(t,e){void 0===e&&(e=1/0),t instanceof u&&(t=t.toCoordinate(e));var r=Math.min(t.zoom,e),n=this.worldSize/Math.pow(2,r),i=new Float64Array(16);return d.identity(i),d.translate(i,i,[t.column*n,t.row*n,0]),d.scale(i,i,[n/c,n/c,1]),d.multiply(i,this.projMatrix,i),new Float32Array(i)},_constrain:function(){if(this.center&&this.width&&this.height&&!this._constraining){this._constraining=!0;var t,e,r,n,i,o,s,l,u=this.size,c=this._unmodified;this.latRange&&(t=this.latY(this.latRange[1]),e=this.latY(this.latRange[0]),i=e-t<u.y?u.y/(e-t):0),this.lngRange&&(r=this.lngX(this.lngRange[0]),n=this.lngX(this.lngRange[1]),o=n-r<u.x?u.x/(n-r):0);var h=Math.max(o||0,i||0);if(h)return this.center=this.unproject(new a(o?(n+r)/2:this.x,i?(e+t)/2:this.y)),this.zoom+=this.scaleZoom(h),this._unmodified=c,void(this._constraining=!1);if(this.latRange){var f=this.y,d=u.y/2;f-d<t&&(l=t+d),f+d>e&&(l=e-d)}if(this.lngRange){var p=this.x,m=u.x/2;p-m<r&&(s=r+m),p+m>n&&(s=n-m)}void 0===s&&void 0===l||(this.center=this.unproject(new a(void 0!==s?s:this.x,void 0!==l?l:this.y))),this._unmodified=c,this._constraining=!1}},_calcMatrices:function(){if(this.height){var t=Math.atan(.5/this.altitude),e=Math.sin(t)*this.altitude/Math.sin(Math.PI/2-this._pitch-t),r=Math.cos(Math.PI/2-this._pitch)*e+this.altitude,n=new Float64Array(16);if(d.perspective(n,2*Math.atan(this.height/2/this.altitude),this.width/this.height,.1,r),d.translate(n,n,[0,0,-this.altitude]),d.scale(n,n,[1,-1,1/this.height]),d.rotateX(n,n,this._pitch),d.rotateZ(n,n,this.angle),d.translate(n,n,[-this.x,-this.y,0]),this.projMatrix=n,n=d.create(),d.scale(n,n,[this.width/2,-this.height/2,1]),d.translate(n,n,[1,-1,0]),this.pixelMatrix=d.multiply(new Float64Array(16),n,this.projMatrix),!(n=d.invert(new Float64Array(16),this.pixelMatrix)))throw new Error(\"failed to invert matrix\");this.pixelMatrixInverse=n}}}},{\"../data/bucket\":328,\"../source/tile_coord\":368,\"../util/interpolate\":435,\"../util/util\":441,\"./coordinate\":337,\"./lng_lat\":338,\"gl-matrix\":192,\"point-geometry\":483}],341:[function(t,e,r){\"use strict\";var n={\" \":[16,[]],\"!\":[10,[5,21,5,7,-1,-1,5,2,4,1,5,0,6,1,5,2]],'\"':[16,[4,21,4,14,-1,-1,12,21,12,14]],\"#\":[21,[11,25,4,-7,-1,-1,17,25,10,-7,-1,-1,4,12,18,12,-1,-1,3,6,17,6]],$:[20,[8,25,8,-4,-1,-1,12,25,12,-4,-1,-1,17,18,15,20,12,21,8,21,5,20,3,18,3,16,4,14,5,13,7,12,13,10,15,9,16,8,17,6,17,3,15,1,12,0,8,0,5,1,3,3]],\"%\":[24,[21,21,3,0,-1,-1,8,21,10,19,10,17,9,15,7,14,5,14,3,16,3,18,4,20,6,21,8,21,10,20,13,19,16,19,19,20,21,21,-1,-1,17,7,15,6,14,4,14,2,16,0,18,0,20,1,21,3,21,5,19,7,17,7]],\"&\":[26,[23,12,23,13,22,14,21,14,20,13,19,11,17,6,15,3,13,1,11,0,7,0,5,1,4,2,3,4,3,6,4,8,5,9,12,13,13,14,14,16,14,18,13,20,11,21,9,20,8,18,8,16,9,13,11,10,16,3,18,1,20,0,22,0,23,1,23,2]],\"'\":[10,[5,19,4,20,5,21,6,20,6,18,5,16,4,15]],\"(\":[14,[11,25,9,23,7,20,5,16,4,11,4,7,5,2,7,-2,9,-5,11,-7]],\")\":[14,[3,25,5,23,7,20,9,16,10,11,10,7,9,2,7,-2,5,-5,3,-7]],\"*\":[16,[8,21,8,9,-1,-1,3,18,13,12,-1,-1,13,18,3,12]],\"+\":[26,[13,18,13,0,-1,-1,4,9,22,9]],\",\":[10,[6,1,5,0,4,1,5,2,6,1,6,-1,5,-3,4,-4]],\"-\":[26,[4,9,22,9]],\".\":[10,[5,2,4,1,5,0,6,1,5,2]],\"/\":[22,[20,25,2,-7]],0:[20,[9,21,6,20,4,17,3,12,3,9,4,4,6,1,9,0,11,0,14,1,16,4,17,9,17,12,16,17,14,20,11,21,9,21]],1:[20,[6,17,8,18,11,21,11,0]],2:[20,[4,16,4,17,5,19,6,20,8,21,12,21,14,20,15,19,16,17,16,15,15,13,13,10,3,0,17,0]],3:[20,[5,21,16,21,10,13,13,13,15,12,16,11,17,8,17,6,16,3,14,1,11,0,8,0,5,1,4,2,3,4]],4:[20,[13,21,3,7,18,7,-1,-1,13,21,13,0]],5:[20,[15,21,5,21,4,12,5,13,8,14,11,14,14,13,16,11,17,8,17,6,16,3,14,1,11,0,8,0,5,1,4,2,3,4]],6:[20,[16,18,15,20,12,21,10,21,7,20,5,17,4,12,4,7,5,3,7,1,10,0,11,0,14,1,16,3,17,6,17,7,16,10,14,12,11,13,10,13,7,12,5,10,4,7]],7:[20,[17,21,7,0,-1,-1,3,21,17,21]],8:[20,[8,21,5,20,4,18,4,16,5,14,7,13,11,12,14,11,16,9,17,7,17,4,16,2,15,1,12,0,8,0,5,1,4,2,3,4,3,7,4,9,6,11,9,12,13,13,15,14,16,16,16,18,15,20,12,21,8,21]],9:[20,[16,14,15,11,13,9,10,8,9,8,6,9,4,11,3,14,3,15,4,18,6,20,9,21,10,21,13,20,15,18,16,14,16,9,15,4,13,1,10,0,8,0,5,1,4,3]],\":\":[10,[5,14,4,13,5,12,6,13,5,14,-1,-1,5,2,4,1,5,0,6,1,5,2]],\";\":[10,[5,14,4,13,5,12,6,13,5,14,-1,-1,6,1,5,0,4,1,5,2,6,1,6,-1,5,-3,4,-4]],\"<\":[24,[20,18,4,9,20,0]],\"=\":[26,[4,12,22,12,-1,-1,4,6,22,6]],\">\":[24,[4,18,20,9,4,0]],\"?\":[18,[3,16,3,17,4,19,5,20,7,21,11,21,13,20,14,19,15,17,15,15,14,13,13,12,9,10,9,7,-1,-1,9,2,8,1,9,0,10,1,9,2]],\"@\":[27,[18,13,17,15,15,16,12,16,10,15,9,14,8,11,8,8,9,6,11,5,14,5,16,6,17,8,-1,-1,12,16,10,14,9,11,9,8,10,6,11,5,-1,-1,18,16,17,8,17,6,19,5,21,5,23,7,24,10,24,12,23,15,22,17,20,19,18,20,15,21,12,21,9,20,7,19,5,17,4,15,3,12,3,9,4,6,5,4,7,2,9,1,12,0,15,0,18,1,20,2,21,3,-1,-1,19,16,18,8,18,6,19,5]],A:[18,[9,21,1,0,-1,-1,9,21,17,0,-1,-1,4,7,14,7]],B:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,15,17,13,16,12,13,11,-1,-1,4,11,13,11,16,10,17,9,18,7,18,4,17,2,16,1,13,0,4,0]],C:[21,[18,16,17,18,15,20,13,21,9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5]],D:[21,[4,21,4,0,-1,-1,4,21,11,21,14,20,16,18,17,16,18,13,18,8,17,5,16,3,14,1,11,0,4,0]],E:[19,[4,21,4,0,-1,-1,4,21,17,21,-1,-1,4,11,12,11,-1,-1,4,0,17,0]],F:[18,[4,21,4,0,-1,-1,4,21,17,21,-1,-1,4,11,12,11]],G:[21,[18,16,17,18,15,20,13,21,9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,18,8,-1,-1,13,8,18,8]],H:[22,[4,21,4,0,-1,-1,18,21,18,0,-1,-1,4,11,18,11]],I:[8,[4,21,4,0]],J:[16,[12,21,12,5,11,2,10,1,8,0,6,0,4,1,3,2,2,5,2,7]],K:[21,[4,21,4,0,-1,-1,18,21,4,7,-1,-1,9,12,18,0]],L:[17,[4,21,4,0,-1,-1,4,0,16,0]],M:[24,[4,21,4,0,-1,-1,4,21,12,0,-1,-1,20,21,12,0,-1,-1,20,21,20,0]],N:[22,[4,21,4,0,-1,-1,4,21,18,0,-1,-1,18,21,18,0]],O:[22,[9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,19,8,19,13,18,16,17,18,15,20,13,21,9,21]],P:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,14,17,12,16,11,13,10,4,10]],Q:[22,[9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,19,8,19,13,18,16,17,18,15,20,13,21,9,21,-1,-1,12,4,18,-2]],R:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,15,17,13,16,12,13,11,4,11,-1,-1,11,11,18,0]],S:[20,[17,18,15,20,12,21,8,21,5,20,3,18,3,16,4,14,5,13,7,12,13,10,15,9,16,8,17,6,17,3,15,1,12,0,8,0,5,1,3,3]],T:[16,[8,21,8,0,-1,-1,1,21,15,21]],U:[22,[4,21,4,6,5,3,7,1,10,0,12,0,15,1,17,3,18,6,18,21]],V:[18,[1,21,9,0,-1,-1,17,21,9,0]],W:[24,[2,21,7,0,-1,-1,12,21,7,0,-1,-1,12,21,17,0,-1,-1,22,21,17,0]],X:[20,[3,21,17,0,-1,-1,17,21,3,0]],Y:[18,[1,21,9,11,9,0,-1,-1,17,21,9,11]],Z:[20,[17,21,3,0,-1,-1,3,21,17,21,-1,-1,3,0,17,0]],\"[\":[14,[4,25,4,-7,-1,-1,5,25,5,-7,-1,-1,4,25,11,25,-1,-1,4,-7,11,-7]],\"\\\\\":[14,[0,21,14,-3]],\"]\":[14,[9,25,9,-7,-1,-1,10,25,10,-7,-1,-1,3,25,10,25,-1,-1,3,-7,10,-7]],\"^\":[16,[6,15,8,18,10,15,-1,-1,3,12,8,17,13,12,-1,-1,8,17,8,0]],_:[16,[0,-2,16,-2]],\"`\":[10,[6,21,5,20,4,18,4,16,5,15,6,16,5,17]],a:[19,[15,14,15,0,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],b:[19,[4,21,4,0,-1,-1,4,11,6,13,8,14,11,14,13,13,15,11,16,8,16,6,15,3,13,1,11,0,8,0,6,1,4,3]],c:[18,[15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],d:[19,[15,21,15,0,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],e:[18,[3,8,15,8,15,10,14,12,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],f:[12,[10,21,8,21,6,20,5,17,5,0,-1,-1,2,14,9,14]],g:[19,[15,14,15,-2,14,-5,13,-6,11,-7,8,-7,6,-6,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],h:[19,[4,21,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0]],i:[8,[3,21,4,20,5,21,4,22,3,21,-1,-1,4,14,4,0]],j:[10,[5,21,6,20,7,21,6,22,5,21,-1,-1,6,14,6,-3,5,-6,3,-7,1,-7]],k:[17,[4,21,4,0,-1,-1,14,14,4,4,-1,-1,8,8,15,0]],l:[8,[4,21,4,0]],m:[30,[4,14,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0,-1,-1,15,10,18,13,20,14,23,14,25,13,26,10,26,0]],n:[19,[4,14,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0]],o:[19,[8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3,16,6,16,8,15,11,13,13,11,14,8,14]],p:[19,[4,14,4,-7,-1,-1,4,11,6,13,8,14,11,14,13,13,15,11,16,8,16,6,15,3,13,1,11,0,8,0,6,1,4,3]],q:[19,[15,14,15,-7,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],r:[13,[4,14,4,0,-1,-1,4,8,5,11,7,13,9,14,12,14]],s:[17,[14,11,13,13,10,14,7,14,4,13,3,11,4,9,6,8,11,7,13,6,14,4,14,3,13,1,10,0,7,0,4,1,3,3]],t:[12,[5,21,5,4,6,1,8,0,10,0,-1,-1,2,14,9,14]],u:[19,[4,14,4,4,5,1,7,0,10,0,12,1,15,4,-1,-1,15,14,15,0]],v:[16,[2,14,8,0,-1,-1,14,14,8,0]],w:[22,[3,14,7,0,-1,-1,11,14,7,0,-1,-1,11,14,15,0,-1,-1,19,14,15,0]],x:[17,[3,14,14,0,-1,-1,14,14,3,0]],y:[16,[2,14,8,0,-1,-1,14,14,8,0,6,-4,4,-6,2,-7,1,-7]],z:[17,[14,14,3,0,-1,-1,3,14,14,14,-1,-1,3,0,14,0]],\"{\":[14,[9,25,7,24,6,23,5,21,5,19,6,17,7,16,8,14,8,12,6,10,-1,-1,7,24,6,22,6,20,7,18,8,17,9,15,9,13,8,11,4,9,8,7,9,5,9,3,8,1,7,0,6,-2,6,-4,7,-6,-1,-1,6,8,8,6,8,4,7,2,6,1,5,-1,5,-3,6,-5,7,-6,9,-7]],\"|\":[8,[4,25,4,-7]],\"}\":[14,[5,25,7,24,8,23,9,21,9,19,8,17,7,16,6,14,6,12,8,10,-1,-1,7,24,8,22,8,20,7,18,6,17,5,15,5,13,6,11,10,9,6,7,5,5,5,3,6,1,7,0,8,-2,8,-4,7,-6,-1,-1,8,8,6,6,6,4,7,2,8,1,9,-1,9,-3,8,-5,7,-6,5,-7]],\"~\":[24,[3,6,3,8,4,11,6,12,8,12,10,11,14,8,16,7,18,7,20,8,21,10,-1,-1,3,8,4,10,6,11,8,11,10,10,14,7,16,6,18,6,20,7,21,10,21,12]]};e.exports=function(t,e,r,i){i=i||1;var a,o,s,l,u,c,h,f,d=[];for(a=0,o=t.length;a<o;a++)if(u=n[t[a]]){for(f=null,s=0,l=u[1].length;s<l;s+=2)-1===u[1][s]&&-1===u[1][s+1]?f=null:(c=e+u[1][s]*i,h=r-u[1][s+1]*i,f&&d.push(f.x,f.y,c,h),f={x:c,y:h});e+=u[0]*i}return d}},{}],342:[function(t,e,r){\"use strict\";var n=e.exports={};n.version=t(\"../package.json\").version,n.Map=t(\"./ui/map\"),n.Control=t(\"./ui/control/control\"),n.Navigation=t(\"./ui/control/navigation\"),n.Geolocate=t(\"./ui/control/geolocate\"),n.Attribution=t(\"./ui/control/attribution\"),n.Popup=t(\"./ui/popup\"),n.Marker=t(\"./ui/marker\"),n.Style=t(\"./style/style\"),n.LngLat=t(\"./geo/lng_lat\"),n.LngLatBounds=t(\"./geo/lng_lat_bounds\"),n.Point=t(\"point-geometry\"),n.Evented=t(\"./util/evented\"),n.util=t(\"./util/util\"),n.supported=t(\"./util/browser\").supported;var i=t(\"./util/ajax\");n.util.getJSON=i.getJSON,n.util.getArrayBuffer=i.getArrayBuffer;var a=t(\"./util/config\");n.config=a,Object.defineProperty(n,\"accessToken\",{get:function(){return a.ACCESS_TOKEN},set:function(t){a.ACCESS_TOKEN=t}})},{\"../package.json\":443,\"./geo/lng_lat\":338,\"./geo/lng_lat_bounds\":339,\"./style/style\":377,\"./ui/control/attribution\":408,\"./ui/control/control\":409,\"./ui/control/geolocate\":410,\"./ui/control/navigation\":411,\"./ui/map\":420,\"./ui/marker\":421,\"./ui/popup\":422,\"./util/ajax\":424,\"./util/browser\":425,\"./util/config\":430,\"./util/evented\":433,\"./util/util\":441,\"point-geometry\":483}],343:[function(t,e,r){\"use strict\";var n=t(\"assert\");e.exports=function(t){for(var e={define:{},initialize:{}},r=0;r<t.length;r++){var i=t[r];n(\"u_\"===i.name.slice(0,2));var a=\"{precision} \"+(1===i.components?\"float\":\"vec\"+i.components);e.define[i.name.slice(2)]=\"uniform \"+a+\" \"+i.name+\";\\n\",e.initialize[i.name.slice(2)]=a+\" \"+i.name.slice(2)+\" = \"+i.name+\";\\n\"}return e}},{assert:46}],344:[function(t,e,r){\"use strict\";function n(t,e,r){var n,s=t.gl,l=t.transform,u=r.paint[\"background-color\"],c=r.paint[\"background-pattern\"],h=r.paint[\"background-opacity\"],f=c?t.spriteAtlas.getPosition(c.from,!0):null,d=c?t.spriteAtlas.getPosition(c.to,!0):null;if(t.setDepthSublayer(0),f&&d){if(t.isOpaquePass)return;n=t.useProgram(\"pattern\"),s.uniform1i(n.u_image,0),s.uniform2fv(n.u_pattern_tl_a,f.tl),s.uniform2fv(n.u_pattern_br_a,f.br),s.uniform2fv(n.u_pattern_tl_b,d.tl),s.uniform2fv(n.u_pattern_br_b,d.br),s.uniform1f(n.u_opacity,h),s.uniform1f(n.u_mix,c.t),s.uniform2fv(n.u_pattern_size_a,f.size),s.uniform2fv(n.u_pattern_size_b,d.size),s.uniform1f(n.u_scale_a,c.fromScale),s.uniform1f(n.u_scale_b,c.toScale),s.activeTexture(s.TEXTURE0),t.spriteAtlas.bind(s,!0),t.tileExtentPatternVAO.bind(s,n,t.tileExtentBuffer)}else{if(t.isOpaquePass!==(1===u[3]))return;var p=a([{name:\"u_color\",components:4},{name:\"u_opacity\",components:1}]);n=t.useProgram(\"fill\",[],p,p),s.uniform4fv(n.u_color,u),s.uniform1f(n.u_opacity,h),t.tileExtentVAO.bind(s,n,t.tileExtentBuffer)}s.disable(s.STENCIL_TEST);for(var m=l.coveringTiles({tileSize:o}),v=0;v<m.length;v++){var g=m[v];if(f&&d){var y={coord:g,tileSize:o};s.uniform1f(n.u_tile_units_to_pixels,1/i(y,1,t.transform.tileZoom));var b=y.tileSize*Math.pow(2,t.transform.tileZoom-y.coord.z),x=b*(y.coord.x+g.w*Math.pow(2,y.coord.z)),_=b*y.coord.y;s.uniform2f(n.u_pixel_coord_upper,x>>16,_>>16),s.uniform2f(n.u_pixel_coord_lower,65535&x,65535&_)}s.uniformMatrix4fv(n.u_matrix,!1,t.transform.calculatePosMatrix(g)),s.drawArrays(s.TRIANGLE_STRIP,0,t.tileExtentBuffer.length)}s.stencilMask(0),s.stencilFunc(s.EQUAL,128,128)}var i=t(\"../source/pixels_to_tile_units\"),a=t(\"./create_uniform_pragmas\"),o=512;e.exports=n},{\"../source/pixels_to_tile_units\":362,\"./create_uniform_pragmas\":343}],345:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=t.gl;t.setDepthSublayer(0),t.depthMask(!1),a.disable(a.STENCIL_TEST);for(var o=0;o<n.length;o++){var s=n[o],l=e.getTile(s),u=l.getBucket(r);if(u){var c=u.bufferGroups.circle;if(c){var h=u.paintAttributes.circle[r.id],f=t.useProgram(\"circle\",h.defines,h.vertexPragmas,h.fragmentPragmas);\"map\"===r.paint[\"circle-pitch-scale\"]?(a.uniform1i(f.u_scale_with_map,!0),a.uniform2f(f.u_extrude_scale,t.transform.pixelsToGLUnits[0]*t.transform.altitude,t.transform.pixelsToGLUnits[1]*t.transform.altitude)):(a.uniform1i(f.u_scale_with_map,!1),a.uniform2fv(f.u_extrude_scale,t.transform.pixelsToGLUnits)),a.uniform1f(f.u_devicepixelratio,i.devicePixelRatio),a.uniformMatrix4fv(f.u_matrix,!1,t.translatePosMatrix(s.posMatrix,l,r.paint[\"circle-translate\"],r.paint[\"circle-translate-anchor\"])),u.setUniforms(a,\"circle\",f,r,{zoom:t.transform.zoom});for(var d=0;d<c.length;d++){var p=c[d];p.vaos[r.id].bind(a,f,p.layoutVertexBuffer,p.elementBuffer,p.paintVertexBuffers[r.id]),a.drawElements(a.TRIANGLES,3*p.elementBuffer.length,a.UNSIGNED_SHORT,0)}}}}}}var i=t(\"../util/browser\");e.exports=n},{\"../util/browser\":425}],346:[function(t,e,r){\"use strict\";function n(t,e,r,n){var i=t.gl;i.enable(i.STENCIL_TEST);for(var a=t.useProgram(\"collisionbox\"),o=0;o<n.length;o++){var s=n[o],l=e.getTile(s),u=l.getBucket(r);if(u){var c=u.bufferGroups.collisionBox;if(c&&c.length){var h=c[0];0!==h.layoutVertexBuffer.length&&(i.uniformMatrix4fv(a.u_matrix,!1,s.posMatrix),t.enableTileClippingMask(s),t.lineWidth(1),i.uniform1f(a.u_scale,Math.pow(2,t.transform.zoom-l.coord.z)),i.uniform1f(a.u_zoom,10*t.transform.zoom),i.uniform1f(a.u_maxzoom,10*(l.coord.z+1)),h.vaos[r.id].bind(i,a,h.layoutVertexBuffer),i.drawArrays(i.LINES,0,h.layoutVertexBuffer.length))}}}}e.exports=n},{}],347:[function(t,e,r){\"use strict\";function n(t,e,r){if(!t.isOpaquePass&&t.options.debug)for(var n=0;n<r.length;n++)i(t,e,r[n])}function i(t,e,r){var n=t.gl;n.disable(n.STENCIL_TEST),t.lineWidth(1*o.devicePixelRatio);var i=r.posMatrix,h=t.useProgram(\"debug\");n.uniformMatrix4fv(h.u_matrix,!1,i),n.uniform4f(h.u_color,1,0,0,1),t.debugVAO.bind(n,h,t.debugBuffer),n.drawArrays(n.LINE_STRIP,0,t.debugBuffer.length);for(var f=a(r.toString(),50,200,5),d=new t.PosArray,p=0;p<f.length;p+=2)d.emplaceBack(f[p],f[p+1]);var m=new u(d.serialize(),t.PosArray.serialize(),u.BufferType.VERTEX);(new c).bind(n,h,m),n.uniform4f(h.u_color,1,1,1,1);for(var v=e.getTile(r).tileSize,g=l/(Math.pow(2,t.transform.zoom-r.z)*v),y=[[-1,-1],[-1,1],[1,-1],[1,1]],b=0;b<y.length;b++){var x=y[b];n.uniformMatrix4fv(h.u_matrix,!1,s.translate([],i,[g*x[0],g*x[1],0])),n.drawArrays(n.LINES,0,m.length)}n.uniform4f(h.u_color,0,0,0,1),n.uniformMatrix4fv(h.u_matrix,!1,i),n.drawArrays(n.LINES,0,m.length)}var a=t(\"../lib/debugtext\"),o=t(\"../util/browser\"),s=t(\"gl-matrix\").mat4,l=t(\"../data/bucket\").EXTENT,u=t(\"../data/buffer\"),c=t(\"./vertex_array_object\");e.exports=n},{\"../data/bucket\":328,\"../data/buffer\":333,\"../lib/debugtext\":341,\"../util/browser\":425,\"./vertex_array_object\":356,\"gl-matrix\":192}],348:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o=t.gl;o.enable(o.STENCIL_TEST);var s;if(s=!r.paint[\"fill-pattern\"]&&(r.isPaintValueFeatureConstant(\"fill-color\")&&r.isPaintValueFeatureConstant(\"fill-opacity\")&&1===r.paint[\"fill-color\"][3]&&1===r.paint[\"fill-opacity\"]),t.isOpaquePass===s){t.setDepthSublayer(1);for(var l=0;l<n.length;l++)i(t,e,r,n[l])}if(!t.isOpaquePass&&r.paint[\"fill-antialias\"]){t.lineWidth(2),t.depthMask(!1);var u=r.getPaintProperty(\"fill-outline-color\");(u||!r.paint[\"fill-pattern\"])&&u?t.setDepthSublayer(2):t.setDepthSublayer(0);for(var c=0;c<n.length;c++)a(t,e,r,n[c])}}function i(t,e,r,n){var i=e.getTile(n),a=i.getBucket(r);if(a){var s=a.bufferGroups.fill;if(s){var l,u=t.gl,c=r.paint[\"fill-pattern\"];if(c)l=t.useProgram(\"pattern\"),o(c,r.paint[\"fill-opacity\"],i,n,t,l),u.activeTexture(u.TEXTURE0),t.spriteAtlas.bind(u,!0);else{var h=a.paintAttributes.fill[r.id];l=t.useProgram(\"fill\",h.defines,h.vertexPragmas,h.fragmentPragmas),a.setUniforms(u,\"fill\",l,r,{zoom:t.transform.zoom})}u.uniformMatrix4fv(l.u_matrix,!1,t.translatePosMatrix(n.posMatrix,i,r.paint[\"fill-translate\"],r.paint[\"fill-translate-anchor\"])),t.enableTileClippingMask(n);for(var f=0;f<s.length;f++){var d=s[f];d.vaos[r.id].bind(u,l,d.layoutVertexBuffer,d.elementBuffer,d.paintVertexBuffers[r.id]),u.drawElements(u.TRIANGLES,d.elementBuffer.length,u.UNSIGNED_SHORT,0)}}}}function a(t,e,r,n){var i=e.getTile(n),a=i.getBucket(r);if(a){var s,l=t.gl,u=a.bufferGroups.fill,c=r.paint[\"fill-pattern\"],h=r.paint[\"fill-opacity\"],f=r.getPaintProperty(\"fill-outline-color\");if(c&&!f)s=t.useProgram(\"outlinepattern\"),l.uniform2f(s.u_world,l.drawingBufferWidth,l.drawingBufferHeight);else{var d=a.paintAttributes.fill[r.id];s=t.useProgram(\"outline\",d.defines,d.vertexPragmas,d.fragmentPragmas),l.uniform2f(s.u_world,l.drawingBufferWidth,l.drawingBufferHeight),l.uniform1f(s.u_opacity,h),a.setUniforms(l,\"fill\",s,r,{zoom:t.transform.zoom})}l.uniformMatrix4fv(s.u_matrix,!1,t.translatePosMatrix(n.posMatrix,i,r.paint[\"fill-translate\"],r.paint[\"fill-translate-anchor\"])),c&&o(c,h,i,n,t,s),t.enableTileClippingMask(n);for(var p=0;p<u.length;p++){var m=u[p];m.secondVaos[r.id].bind(l,s,m.layoutVertexBuffer,m.elementBuffer2,m.paintVertexBuffers[r.id]),l.drawElements(l.LINES,2*m.elementBuffer2.length,l.UNSIGNED_SHORT,0)}}}function o(t,e,r,n,i,a){var o=i.gl,l=i.spriteAtlas.getPosition(t.from,!0),u=i.spriteAtlas.getPosition(t.to,!0);if(l&&u){o.uniform1i(a.u_image,0),o.uniform2fv(a.u_pattern_tl_a,l.tl),o.uniform2fv(a.u_pattern_br_a,l.br),o.uniform2fv(a.u_pattern_tl_b,u.tl),o.uniform2fv(a.u_pattern_br_b,u.br),o.uniform1f(a.u_opacity,e),o.uniform1f(a.u_mix,t.t),o.uniform1f(a.u_tile_units_to_pixels,1/s(r,1,i.transform.tileZoom)),o.uniform2fv(a.u_pattern_size_a,l.size),o.uniform2fv(a.u_pattern_size_b,u.size),o.uniform1f(a.u_scale_a,t.fromScale),o.uniform1f(a.u_scale_b,t.toScale);var c=r.tileSize*Math.pow(2,i.transform.tileZoom-r.coord.z),h=c*(r.coord.x+n.w*Math.pow(2,r.coord.z)),f=c*r.coord.y;o.uniform2f(a.u_pixel_coord_upper,h>>16,f>>16),o.uniform2f(a.u_pixel_coord_lower,65535&h,65535&f),o.activeTexture(o.TEXTURE0),i.spriteAtlas.bind(o,!0)}}var s=t(\"../source/pixels_to_tile_units\");e.exports=n},{\"../source/pixels_to_tile_units\":362}],349:[function(t,e,r){\"use strict\";var n=t(\"../util/browser\"),i=t(\"gl-matrix\").mat2,a=t(\"../source/pixels_to_tile_units\");e.exports=function(t,e,r,o){if(!t.isOpaquePass){t.setDepthSublayer(0),t.depthMask(!1);var s=t.gl;if(s.enable(s.STENCIL_TEST),!(r.paint[\"line-width\"]<=0)){var l=1/n.devicePixelRatio,u=r.paint[\"line-blur\"]+l,c=r.paint[\"line-color\"],h=t.transform,f=i.create();i.scale(f,f,[1,Math.cos(h._pitch)]),i.rotate(f,f,t.transform.angle);var d,p,m,v,g,y=Math.sqrt(h.height*h.height/4*(1+h.altitude*h.altitude)),b=h.height/2*Math.tan(h._pitch),x=(y+b)/y-1,_=r.paint[\"line-dasharray\"],w=r.paint[\"line-pattern\"];if(_)d=t.useProgram(\"linesdfpattern\"),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform4fv(d.u_color,c),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]),p=t.lineAtlas.getDash(_.from,\"round\"===r.layout[\"line-cap\"]),m=t.lineAtlas.getDash(_.to,\"round\"===r.layout[\"line-cap\"]),s.uniform1i(d.u_image,0),s.activeTexture(s.TEXTURE0),t.lineAtlas.bind(s),s.uniform1f(d.u_tex_y_a,p.y),s.uniform1f(d.u_tex_y_b,m.y),s.uniform1f(d.u_mix,_.t),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f);else if(w){if(v=t.spriteAtlas.getPosition(w.from,!0),g=t.spriteAtlas.getPosition(w.to,!0),!v||!g)return;d=t.useProgram(\"linepattern\"),s.uniform1i(d.u_image,0),s.activeTexture(s.TEXTURE0),t.spriteAtlas.bind(s,!0),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform2fv(d.u_pattern_tl_a,v.tl),s.uniform2fv(d.u_pattern_br_a,v.br),s.uniform2fv(d.u_pattern_tl_b,g.tl),s.uniform2fv(d.u_pattern_br_b,g.br),s.uniform1f(d.u_fade,w.t),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f)}else d=t.useProgram(\"line\"),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f),s.uniform4fv(d.u_color,c),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]);for(var M=0;M<o.length;M++){var k=o[M],A=e.getTile(k),T=A.getBucket(r);if(T){var S=T.bufferGroups.line;if(S){t.enableTileClippingMask(k);var E=t.translatePosMatrix(k.posMatrix,A,r.paint[\"line-translate\"],r.paint[\"line-translate-anchor\"]);s.uniformMatrix4fv(d.u_matrix,!1,E);var L=1/a(A,1,t.transform.zoom);if(_){var C=p.width*_.fromScale,z=m.width*_.toScale,I=[1/a(A,C,t.transform.tileZoom),-p.height/2],D=[1/a(A,z,t.transform.tileZoom),-m.height/2],P=t.lineAtlas.width/(256*Math.min(C,z)*n.devicePixelRatio)/2;s.uniform1f(d.u_ratio,L),s.uniform2fv(d.u_patternscale_a,I),s.uniform2fv(d.u_patternscale_b,D),s.uniform1f(d.u_sdfgamma,P)}else w?(s.uniform1f(d.u_ratio,L),s.uniform2fv(d.u_pattern_size_a,[a(A,v.size[0]*w.fromScale,t.transform.tileZoom),g.size[1]]),s.uniform2fv(d.u_pattern_size_b,[a(A,g.size[0]*w.toScale,t.transform.tileZoom),g.size[1]])):s.uniform1f(d.u_ratio,L);for(var O=0;O<S.length;O++){var R=S[O];R.vaos[r.id].bind(s,d,R.layoutVertexBuffer,R.elementBuffer),s.drawElements(s.TRIANGLES,3*R.elementBuffer.length,s.UNSIGNED_SHORT,0)}}}}}}}},{\"../source/pixels_to_tile_units\":362,\"../util/browser\":425,\"gl-matrix\":192}],350:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=t.gl;a.enable(a.DEPTH_TEST),t.depthMask(!0),a.depthFunc(a.LESS);for(var o=n.length&&n[0].z,s=0;s<n.length;s++){var l=n[s];t.setDepthSublayer(l.z-o),i(t,e,r,l)}a.depthFunc(a.LEQUAL)}}function i(t,e,r,n){var i=t.gl;i.disable(i.STENCIL_TEST);var u=e.getTile(n),c=t.transform.calculatePosMatrix(n,e.maxzoom),h=t.useProgram(\"raster\");i.uniformMatrix4fv(h.u_matrix,!1,c),i.uniform1f(h.u_brightness_low,r.paint[\"raster-brightness-min\"]),i.uniform1f(h.u_brightness_high,r.paint[\"raster-brightness-max\"]),i.uniform1f(h.u_saturation_factor,s(r.paint[\"raster-saturation\"])),i.uniform1f(h.u_contrast_factor,o(r.paint[\"raster-contrast\"])),i.uniform3fv(h.u_spin_weights,a(r.paint[\"raster-hue-rotate\"]));var f,d,p=u.source&&u.source.findLoadedParent(n,0,{}),m=l(u,p,r,t.transform);i.activeTexture(i.TEXTURE0),i.bindTexture(i.TEXTURE_2D,u.texture),i.activeTexture(i.TEXTURE1),p?(i.bindTexture(i.TEXTURE_2D,p.texture),f=Math.pow(2,p.coord.z-u.coord.z),d=[u.coord.x*f%1,u.coord.y*f%1]):(i.bindTexture(i.TEXTURE_2D,u.texture),m[1]=0),i.uniform2fv(h.u_tl_parent,d||[0,0]),i.uniform1f(h.u_scale_parent,f||1),i.uniform1f(h.u_buffer_scale,1),i.uniform1f(h.u_opacity0,m[0]),i.uniform1f(h.u_opacity1,m[1]),i.uniform1i(h.u_image0,0),i.uniform1i(h.u_image1,1);var v=u.boundsBuffer||t.rasterBoundsBuffer;(u.boundsVAO||t.rasterBoundsVAO).bind(i,h,v),i.drawArrays(i.TRIANGLE_STRIP,0,v.length)}function a(t){t*=Math.PI/180;var e=Math.sin(t),r=Math.cos(t);return[(2*r+1)/3,(-Math.sqrt(3)*e-r+1)/3,(Math.sqrt(3)*e-r+1)/3]}function o(t){return t>0?1/(1-t):1+t}function s(t){return t>0?1-1/(1.001-t):-t}function l(t,e,r,n){var i=[1,0],a=r.paint[\"raster-fade-duration\"];if(t.source&&a>0){var o=(new Date).getTime(),s=(o-t.timeAdded)/a,l=e?(o-e.timeAdded)/a:-1,c=n.coveringZoomLevel(t.source),h=!!e&&Math.abs(e.coord.z-c)>Math.abs(t.coord.z-c);!e||h?(i[0]=u.clamp(s,0,1),i[1]=1-i[0]):(i[0]=u.clamp(1-l,0,1),i[1]=1-i[0])}var f=r.paint[\"raster-opacity\"];return i[0]*=f,i[1]*=f,i}var u=t(\"../util/util\"),c=t(\"../util/struct_array\");e.exports=n,n.RasterBoundsArray=new c({members:[{name:\"a_pos\",type:\"Int16\",components:2},{name:\"a_texture_pos\",type:\"Int16\",components:2}]})},{\"../util/struct_array\":439,\"../util/util\":441}],351:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=!(r.layout[\"text-allow-overlap\"]||r.layout[\"icon-allow-overlap\"]||r.layout[\"text-ignore-placement\"]||r.layout[\"icon-ignore-placement\"]),o=t.gl;a?o.disable(o.STENCIL_TEST):o.enable(o.STENCIL_TEST),t.setDepthSublayer(0),t.depthMask(!1),o.disable(o.DEPTH_TEST),i(t,e,r,n,!1,r.paint[\"icon-translate\"],r.paint[\"icon-translate-anchor\"],r.layout[\"icon-rotation-alignment\"],r.layout[\"icon-rotation-alignment\"],r.layout[\"icon-size\"],r.paint[\"icon-halo-width\"],r.paint[\"icon-halo-color\"],r.paint[\"icon-halo-blur\"],r.paint[\"icon-opacity\"],r.paint[\"icon-color\"]),\n",
       "i(t,e,r,n,!0,r.paint[\"text-translate\"],r.paint[\"text-translate-anchor\"],r.layout[\"text-rotation-alignment\"],r.layout[\"text-pitch-alignment\"],r.layout[\"text-size\"],r.paint[\"text-halo-width\"],r.paint[\"text-halo-color\"],r.paint[\"text-halo-blur\"],r.paint[\"text-opacity\"],r.paint[\"text-color\"]),o.enable(o.DEPTH_TEST),e.map.showCollisionBoxes&&s(t,e,r,n)}}function i(t,e,r,n,i,o,s,l,u,c,h,f,d,p,m){for(var v=0;v<n.length;v++){var g=e.getTile(n[v]),y=g.getBucket(r);if(y){var b=y.bufferGroups,x=i?b.glyph:b.icon;x.length&&(t.enableTileClippingMask(n[v]),a(t,r,n[v].posMatrix,g,y,x,i,i||y.sdfIcons,!i&&y.iconsNeedLinear,i?y.adjustedTextSize:y.adjustedIconSize,y.fontstack,o,s,l,u,c,h,f,d,p,m))}}}function a(t,e,r,n,i,a,s,u,c,h,f,d,p,m,v,g,y,b,x,_,w){var M,k,A,T=t.gl,S=t.transform,E=\"map\"===m,L=\"map\"===v,C=s?24:1,z=g/C;if(L?(k=l(n,1,t.transform.zoom)*z,A=1/Math.cos(S._pitch),M=[k,k]):(k=t.transform.altitude*z,A=1,M=[S.pixelsToGLUnits[0]*k,S.pixelsToGLUnits[1]*k]),s||t.style.sprite.loaded()){var I=t.useProgram(u?\"sdf\":\"icon\");if(T.uniformMatrix4fv(I.u_matrix,!1,t.translatePosMatrix(r,n,d,p)),T.uniform1i(I.u_rotate_with_map,E),T.uniform1i(I.u_pitch_with_map,L),T.uniform2fv(I.u_extrude_scale,M),T.activeTexture(T.TEXTURE0),T.uniform1i(I.u_texture,0),s){var D=f&&t.glyphSource.getGlyphAtlas(f);if(!D)return;D.updateTexture(T),T.uniform2f(I.u_texsize,D.width/4,D.height/4)}else{var P=t.options.rotating||t.options.zooming,O=1!==z||o.devicePixelRatio!==t.spriteAtlas.pixelRatio||c,R=L||t.transform.pitch;t.spriteAtlas.bind(T,u||P||O||R),T.uniform2f(I.u_texsize,t.spriteAtlas.width/4,t.spriteAtlas.height/4)}var F=Math.log(g/h)/Math.LN2||0;T.uniform1f(I.u_zoom,10*(t.transform.zoom-F)),T.activeTexture(T.TEXTURE1),t.frameHistory.bind(T),T.uniform1i(I.u_fadetexture,1);var j;if(u){var N=.105*C/g/o.devicePixelRatio;if(y){T.uniform1f(I.u_gamma,(1.19*x/z/8+N)*A),T.uniform4fv(I.u_color,b),T.uniform1f(I.u_opacity,_),T.uniform1f(I.u_buffer,(6-y/z)/8);for(var B=0;B<a.length;B++)j=a[B],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}T.uniform1f(I.u_gamma,N*A),T.uniform4fv(I.u_color,w),T.uniform1f(I.u_opacity,_),T.uniform1f(I.u_buffer,.75),T.uniform1f(I.u_pitch,S.pitch/360*2*Math.PI),T.uniform1f(I.u_bearing,S.bearing/360*2*Math.PI),T.uniform1f(I.u_aspect_ratio,S.width/S.height);for(var U=0;U<a.length;U++)j=a[U],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}else{T.uniform1f(I.u_opacity,_);for(var V=0;V<a.length;V++)j=a[V],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}}}var o=t(\"../util/browser\"),s=t(\"./draw_collision_debug\"),l=t(\"../source/pixels_to_tile_units\");e.exports=n},{\"../source/pixels_to_tile_units\":362,\"../util/browser\":425,\"./draw_collision_debug\":346}],352:[function(t,e,r){\"use strict\";function n(){this.changeTimes=new Float64Array(256),this.changeOpacities=new Uint8Array(256),this.opacities=new Uint8ClampedArray(256),this.array=new Uint8Array(this.opacities.buffer),this.fadeDuration=300,this.previousZoom=0,this.firstFrame=!0}e.exports=n,n.prototype.record=function(t){var e=Date.now();this.firstFrame&&(e=0,this.firstFrame=!1),t=Math.floor(10*t);var r;if(t<this.previousZoom)for(r=t+1;r<=this.previousZoom;r++)this.changeTimes[r]=e,this.changeOpacities[r]=this.opacities[r];else for(r=t;r>this.previousZoom;r--)this.changeTimes[r]=e,this.changeOpacities[r]=this.opacities[r];for(r=0;r<256;r++){var n=e-this.changeTimes[r],i=n/this.fadeDuration*255;this.opacities[r]=r<=t?this.changeOpacities[r]+i:this.changeOpacities[r]-i}this.changed=!0,this.previousZoom=t},n.prototype.bind=function(t){this.texture?(t.bindTexture(t.TEXTURE_2D,this.texture),this.changed&&(t.texSubImage2D(t.TEXTURE_2D,0,0,0,256,1,t.ALPHA,t.UNSIGNED_BYTE,this.array),this.changed=!1)):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texImage2D(t.TEXTURE_2D,0,t.ALPHA,256,1,0,t.ALPHA,t.UNSIGNED_BYTE,this.array))}},{}],353:[function(t,e,r){\"use strict\";function n(t,e){this.width=t,this.height=e,this.nextRow=0,this.bytes=4,this.data=new Uint8Array(this.width*this.height*this.bytes),this.positions={}}var i=t(\"../util/util\");e.exports=n,n.prototype.setSprite=function(t){this.sprite=t},n.prototype.getDash=function(t,e){var r=t.join(\",\")+e;return this.positions[r]||(this.positions[r]=this.addDash(t,e)),this.positions[r]},n.prototype.addDash=function(t,e){var r=e?7:0,n=2*r+1;if(this.nextRow+n>this.height)return i.warnOnce(\"LineAtlas out of space\"),null;for(var a=0,o=0;o<t.length;o++)a+=t[o];for(var s=this.width/a,l=s/2,u=t.length%2==1,c=-r;c<=r;c++)for(var h=this.nextRow+r+c,f=this.width*h,d=u?-t[t.length-1]:0,p=t[0],m=1,v=0;v<this.width;v++){for(;p<v/s;)d=p,p+=t[m],u&&m===t.length-1&&(p+=t[0]),m++;var g,y=Math.abs(v-d*s),b=Math.abs(v-p*s),x=Math.min(y,b),_=m%2==1;if(e){var w=r?c/r*(l+1):0;if(_){var M=l-Math.abs(w);g=Math.sqrt(x*x+M*M)}else g=l-Math.sqrt(x*x+w*w)}else g=(_?1:-1)*x;this.data[3+4*(f+v)]=Math.max(0,Math.min(255,g+128))}var k={y:(this.nextRow+r+.5)/this.height,height:2*r/this.height,width:a};return this.nextRow+=n,this.dirty=!0,k},n.prototype.bind=function(t){this.texture?(t.bindTexture(t.TEXTURE_2D,this.texture),this.dirty&&(this.dirty=!1,t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width,this.height,t.RGBA,t.UNSIGNED_BYTE,this.data))):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.REPEAT),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.REPEAT),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,this.width,this.height,0,t.RGBA,t.UNSIGNED_BYTE,this.data))}},{\"../util/util\":441}],354:[function(t,e,r){\"use strict\";function n(t,e){this.gl=t,this.transform=e,this.reusableTextures={},this.preFbos={},this.frameHistory=new o,this.setup(),this.numSublayers=s.maxUnderzooming+s.maxOverzooming+1,this.depthEpsilon=1/Math.pow(2,16),this.lineWidthRange=t.getParameter(t.ALIASED_LINE_WIDTH_RANGE)}var i=t(\"../util/browser\"),a=t(\"gl-matrix\").mat4,o=t(\"./frame_history\"),s=t(\"../source/source_cache\"),l=t(\"../data/bucket\").EXTENT,u=t(\"../source/pixels_to_tile_units\"),c=t(\"../util/util\"),h=t(\"../util/struct_array\"),f=t(\"../data/buffer\"),d=t(\"./vertex_array_object\"),p=t(\"./draw_raster\").RasterBoundsArray,m=t(\"./create_uniform_pragmas\");e.exports=n,c.extend(n.prototype,t(\"./painter/use_program\")),n.prototype.resize=function(t,e){var r=this.gl;this.width=t*i.devicePixelRatio,this.height=e*i.devicePixelRatio,r.viewport(0,0,this.width,this.height)},n.prototype.setup=function(){var t=this.gl;t.verbose=!0,t.enable(t.BLEND),t.blendFunc(t.ONE,t.ONE_MINUS_SRC_ALPHA),t.enable(t.STENCIL_TEST),t.enable(t.DEPTH_TEST),t.depthFunc(t.LEQUAL),this._depthMask=!1,t.depthMask(!1);var e=this.PosArray=new h({members:[{name:\"a_pos\",type:\"Int16\",components:2}]}),r=new e;r.emplaceBack(0,0),r.emplaceBack(l,0),r.emplaceBack(0,l),r.emplaceBack(l,l),this.tileExtentBuffer=new f(r.serialize(),e.serialize(),f.BufferType.VERTEX),this.tileExtentVAO=new d,this.tileExtentPatternVAO=new d;var n=new e;n.emplaceBack(0,0),n.emplaceBack(l,0),n.emplaceBack(l,l),n.emplaceBack(0,l),n.emplaceBack(0,0),this.debugBuffer=new f(n.serialize(),e.serialize(),f.BufferType.VERTEX),this.debugVAO=new d;var i=new p;i.emplaceBack(0,0,0,0),i.emplaceBack(l,0,32767,0),i.emplaceBack(0,l,0,32767),i.emplaceBack(l,l,32767,32767),this.rasterBoundsBuffer=new f(i.serialize(),p.serialize(),f.BufferType.VERTEX),this.rasterBoundsVAO=new d},n.prototype.clearColor=function(){var t=this.gl;t.clearColor(0,0,0,0),t.clear(t.COLOR_BUFFER_BIT)},n.prototype.clearStencil=function(){var t=this.gl;t.clearStencil(0),t.stencilMask(255),t.clear(t.STENCIL_BUFFER_BIT)},n.prototype.clearDepth=function(){var t=this.gl;t.clearDepth(1),this.depthMask(!0),t.clear(t.DEPTH_BUFFER_BIT)},n.prototype._renderTileClippingMasks=function(t){var e=this.gl;e.colorMask(!1,!1,!1,!1),this.depthMask(!1),e.disable(e.DEPTH_TEST),e.enable(e.STENCIL_TEST),e.stencilMask(248),e.stencilOp(e.KEEP,e.KEEP,e.REPLACE);var r=1;this._tileClippingMaskIDs={};for(var n=0;n<t.length;n++){var i=t[n],a=this._tileClippingMaskIDs[i.id]=r++<<3;e.stencilFunc(e.ALWAYS,a,248);var o=m([{name:\"u_color\",components:4},{name:\"u_opacity\",components:1}]),s=this.useProgram(\"fill\",[],o,o);e.uniformMatrix4fv(s.u_matrix,!1,i.posMatrix),this.tileExtentVAO.bind(e,s,this.tileExtentBuffer),e.drawArrays(e.TRIANGLE_STRIP,0,this.tileExtentBuffer.length)}e.stencilMask(0),e.colorMask(!0,!0,!0,!0),this.depthMask(!0),e.enable(e.DEPTH_TEST)},n.prototype.enableTileClippingMask=function(t){var e=this.gl;e.stencilFunc(e.EQUAL,this._tileClippingMaskIDs[t.id],248)},n.prototype.prepareBuffers=function(){},n.prototype.bindDefaultFramebuffer=function(){var t=this.gl;t.bindFramebuffer(t.FRAMEBUFFER,null)};var v={symbol:t(\"./draw_symbol\"),circle:t(\"./draw_circle\"),line:t(\"./draw_line\"),fill:t(\"./draw_fill\"),raster:t(\"./draw_raster\"),background:t(\"./draw_background\"),debug:t(\"./draw_debug\")};n.prototype.render=function(t,e){this.style=t,this.options=e,this.lineAtlas=t.lineAtlas,this.spriteAtlas=t.spriteAtlas,this.spriteAtlas.setSprite(t.sprite),this.glyphSource=t.glyphSource,this.frameHistory.record(this.transform.zoom),this.prepareBuffers(),this.clearColor(),this.clearDepth(),this.showOverdrawInspector(e.showOverdrawInspector),this.depthRange=(t._order.length+2)*this.numSublayers*this.depthEpsilon,this.renderPass({isOpaquePass:!0}),this.renderPass({isOpaquePass:!1})},n.prototype.renderPass=function(t){var e=this.style._groups,r=t.isOpaquePass;this.currentLayer=r?this.style._order.length:-1;for(var n=0;n<e.length;n++){var i,a=e[r?e.length-1-n:n],o=this.style.sources[a.source],s=[];if(o){for(s=o.getVisibleCoordinates(),i=0;i<s.length;i++)s[i].posMatrix=this.transform.calculatePosMatrix(s[i],o.maxzoom);this.clearStencil(),o.prepare&&o.prepare(),o.isTileClipped&&this._renderTileClippingMasks(s)}for(r?(this._showOverdrawInspector||this.gl.disable(this.gl.BLEND),this.isOpaquePass=!0):(this.gl.enable(this.gl.BLEND),this.isOpaquePass=!1,s.reverse()),i=0;i<a.length;i++){var l=a[r?a.length-1-i:i];this.currentLayer+=r?-1:1,this.renderLayer(this,o,l,s)}o&&v.debug(this,o,s)}},n.prototype.depthMask=function(t){t!==this._depthMask&&(this._depthMask=t,this.gl.depthMask(t))},n.prototype.renderLayer=function(t,e,r,n){r.isHidden(this.transform.zoom)||(\"background\"===r.type||n.length)&&(this.id=r.id,v[r.type](t,e,r,n))},n.prototype.setDepthSublayer=function(t){var e=1-((1+this.currentLayer)*this.numSublayers+t)*this.depthEpsilon,r=e-1+this.depthRange;this.gl.depthRange(r,e)},n.prototype.translatePosMatrix=function(t,e,r,n){if(!r[0]&&!r[1])return t;if(\"viewport\"===n){var i=Math.sin(-this.transform.angle),o=Math.cos(-this.transform.angle);r=[r[0]*o-r[1]*i,r[0]*i+r[1]*o]}var s=[u(e,r[0],this.transform.zoom),u(e,r[1],this.transform.zoom),0],l=new Float32Array(16);return a.translate(l,t,s),l},n.prototype.saveTexture=function(t){var e=this.reusableTextures[t.size];e?e.push(t):this.reusableTextures[t.size]=[t]},n.prototype.getTexture=function(t){var e=this.reusableTextures[t];return e&&e.length>0?e.pop():null},n.prototype.lineWidth=function(t){this.gl.lineWidth(c.clamp(t,this.lineWidthRange[0],this.lineWidthRange[1]))},n.prototype.showOverdrawInspector=function(t){if(t||this._showOverdrawInspector){this._showOverdrawInspector=t;var e=this.gl;if(t){e.blendFunc(e.CONSTANT_COLOR,e.ONE);e.blendColor(1/8,1/8,1/8,0),e.clearColor(0,0,0,1),e.clear(e.COLOR_BUFFER_BIT)}else e.blendFunc(e.ONE,e.ONE_MINUS_SRC_ALPHA)}}},{\"../data/bucket\":328,\"../data/buffer\":333,\"../source/pixels_to_tile_units\":362,\"../source/source_cache\":366,\"../util/browser\":425,\"../util/struct_array\":439,\"../util/util\":441,\"./create_uniform_pragmas\":343,\"./draw_background\":344,\"./draw_circle\":345,\"./draw_debug\":347,\"./draw_fill\":348,\"./draw_line\":349,\"./draw_raster\":350,\"./draw_symbol\":351,\"./frame_history\":352,\"./painter/use_program\":355,\"./vertex_array_object\":356,\"gl-matrix\":192}],355:[function(t,e,r){\"use strict\";function n(t,e){return t.replace(/#pragma mapbox: ([\\w]+) ([\\w]+) ([\\w]+) ([\\w]+)/g,function(t,r,n,i,a){return e[r][a].replace(/{type}/g,i).replace(/{precision}/g,n)})}var i=t(\"assert\"),a=t(\"../../util/util\"),o=t(\"mapbox-gl-shaders\"),s=o.util;e.exports._createProgram=function(t,e,r,l){for(var u=this.gl,c=u.createProgram(),h=o[t],f=\"#define MAPBOX_GL_JS;\\n\",d=0;d<e.length;d++)f+=\"#define \"+e[d]+\";\\n\";var p=u.createShader(u.FRAGMENT_SHADER);u.shaderSource(p,n(f+h.fragmentSource,l)),u.compileShader(p),i(u.getShaderParameter(p,u.COMPILE_STATUS),u.getShaderInfoLog(p)),u.attachShader(c,p);var m=u.createShader(u.VERTEX_SHADER);u.shaderSource(m,n(f+s+h.vertexSource,r)),u.compileShader(m),i(u.getShaderParameter(m,u.COMPILE_STATUS),u.getShaderInfoLog(m)),u.attachShader(c,m),u.linkProgram(c),i(u.getProgramParameter(c,u.LINK_STATUS),u.getProgramInfoLog(c));for(var v={},g=u.getProgramParameter(c,u.ACTIVE_ATTRIBUTES),y=0;y<g;y++){var b=u.getActiveAttrib(c,y);v[b.name]=u.getAttribLocation(c,b.name)}for(var x={},_=u.getProgramParameter(c,u.ACTIVE_UNIFORMS),w=0;w<_;w++){var M=u.getActiveUniform(c,w);x[M.name]=u.getUniformLocation(c,M.name)}return a.extend({program:c,definition:h,attributes:v,numAttributes:g},v,x)},e.exports._createProgramCached=function(t,e,r,n){this.cache=this.cache||{};var i=JSON.stringify({name:t,defines:e,vertexPragmas:r,fragmentPragmas:n});return this.cache[i]||(this.cache[i]=this._createProgram(t,e,r,n)),this.cache[i]},e.exports.useProgram=function(t,e,r,n){var i=this.gl;e=e||[],this._showOverdrawInspector&&(e=e.concat(\"OVERDRAW_INSPECTOR\"));var a=this._createProgramCached(t,e,r,n);return this.currentProgram!==a&&(i.useProgram(a.program),this.currentProgram=a),a}},{\"../../util/util\":441,assert:46,\"mapbox-gl-shaders\":302}],356:[function(t,e,r){\"use strict\";function n(){this.boundProgram=null,this.boundVertexBuffer=null,this.boundVertexBuffer2=null,this.boundElementBuffer=null,this.vao=null}var i=t(\"assert\");e.exports=n,n.prototype.bind=function(t,e,r,n,i){void 0===t.extVertexArrayObject&&(t.extVertexArrayObject=t.getExtension(\"OES_vertex_array_object\"));var a=!this.vao||this.boundProgram!==e||this.boundVertexBuffer!==r||this.boundVertexBuffer2!==i||this.boundElementBuffer!==n;!t.extVertexArrayObject||a?this.freshBind(t,e,r,n,i):t.extVertexArrayObject.bindVertexArrayOES(this.vao)},n.prototype.freshBind=function(t,e,r,n,a){var o,s=e.numAttributes;if(t.extVertexArrayObject)this.vao&&this.destroy(t),this.vao=t.extVertexArrayObject.createVertexArrayOES(),t.extVertexArrayObject.bindVertexArrayOES(this.vao),o=0,this.boundProgram=e,this.boundVertexBuffer=r,this.boundVertexBuffer2=a,this.boundElementBuffer=n;else{o=t.currentNumAttributes||0;for(var l=s;l<o;l++)i(0!==l),t.disableVertexAttribArray(l)}for(var u=o;u<s;u++)t.enableVertexAttribArray(u);r.bind(t),r.setVertexAttribPointers(t,e),a&&(a.bind(t),a.setVertexAttribPointers(t,e)),n&&n.bind(t),t.currentNumAttributes=s},n.prototype.unbind=function(t){var e=t.extVertexArrayObject;e&&e.bindVertexArrayOES(null)},n.prototype.destroy=function(t){var e=t.extVertexArrayObject;e&&this.vao&&(e.deleteVertexArrayOES(this.vao),this.vao=null)}},{assert:46}],357:[function(t,e,r){\"use strict\";function n(t,e,r){e=e||{},this.id=t,this.dispatcher=r,this._data=e.data,void 0!==e.maxzoom&&(this.maxzoom=e.maxzoom),e.type&&(this.type=e.type);var n=s/this.tileSize;this.workerOptions=a.extend({source:this.id,cluster:e.cluster||!1,geojsonVtOptions:{buffer:(void 0!==e.buffer?e.buffer:128)*n,tolerance:(void 0!==e.tolerance?e.tolerance:.375)*n,extent:s,maxZoom:this.maxzoom},superclusterOptions:{maxZoom:Math.min(e.clusterMaxZoom,this.maxzoom-1)||this.maxzoom-1,extent:s,radius:(e.clusterRadius||50)*n,log:!1}},e.workerOptions),this._updateWorkerData(function(t){if(t)return void this.fire(\"error\",{error:t});this.fire(\"load\")}.bind(this))}var i=t(\"../util/evented\"),a=t(\"../util/util\"),o=t(\"resolve-url\"),s=t(\"../data/bucket\").EXTENT;e.exports=n,n.prototype=a.inherit(i,{type:\"geojson\",minzoom:0,maxzoom:18,tileSize:512,isTileClipped:!0,reparseOverscaled:!0,onAdd:function(t){this.map=t},setData:function(t){return this._data=t,this._updateWorkerData(function(t){if(t)return this.fire(\"error\",{error:t});this.fire(\"change\")}.bind(this)),this},_updateWorkerData:function(t){var e=a.extend({},this.workerOptions),r=this._data;\"string\"==typeof r?e.url=\"undefined\"!=typeof window?o(window.location.href,r):r:e.data=JSON.stringify(r),this.workerID=this.dispatcher.send(this.type+\".loadData\",e,function(e){this._loaded=!0,t(e)}.bind(this))},loadTile:function(t,e){var r=t.coord.z>this.maxzoom?Math.pow(2,t.coord.z-this.maxzoom):1,n={type:this.type,uid:t.uid,coord:t.coord,zoom:t.coord.z,maxZoom:this.maxzoom,tileSize:this.tileSize,source:this.id,overscaling:r,angle:this.map.transform.angle,pitch:this.map.transform.pitch,showCollisionBoxes:this.map.showCollisionBoxes};t.workerID=this.dispatcher.send(\"load tile\",n,function(r,n){if(t.unloadVectorData(this.map.painter),!t.aborted)return r?e(r):(t.loadVectorData(n,this.map.style),t.redoWhenDone&&(t.redoWhenDone=!1,t.redoPlacement(this)),e(null))}.bind(this),this.workerID)},abortTile:function(t){t.aborted=!0},unloadTile:function(t){t.unloadVectorData(this.map.painter),this.dispatcher.send(\"remove tile\",{uid:t.uid,source:this.id},function(){},t.workerID)},serialize:function(){return{type:this.type,data:this._data}}})},{\"../data/bucket\":328,\"../util/evented\":433,\"../util/util\":441,\"resolve-url\":500}],358:[function(t,e,r){\"use strict\";function n(t,e,r){r&&(this.loadGeoJSON=r),h.call(this,t,e)}var i=t(\"../util/util\"),a=t(\"../util/ajax\"),o=t(\"geojson-rewind\"),s=t(\"./geojson_wrapper\"),l=t(\"vt-pbf\"),u=t(\"supercluster\"),c=t(\"geojson-vt\"),h=t(\"./vector_tile_worker_source\");e.exports=n,n.prototype=i.inherit(h,{_geoJSONIndexes:{},loadVectorData:function(t,e){var r=t.source,n=t.coord;if(!this._geoJSONIndexes[r])return e(null,null);var i=this._geoJSONIndexes[r].getTile(Math.min(n.z,t.maxZoom),n.x,n.y);if(!i)return e(null,null);var a=new s(i.features);a.name=\"_geojsonTileLayer\";var o=l({layers:{_geojsonTileLayer:a}});0===o.byteOffset&&o.byteLength===o.buffer.byteLength||(o=new Uint8Array(o)),e(null,{tile:a,rawTileData:o.buffer})},loadData:function(t,e){var r=function(r,n){return r?e(r):\"object\"!=typeof n?e(new Error(\"Input data is not a valid GeoJSON object.\")):(o(n,!0),void this._indexData(n,t,function(r,n){if(r)return e(r);this._geoJSONIndexes[t.source]=n,e(null)}.bind(this)))}.bind(this);this.loadGeoJSON(t,r)},loadGeoJSON:function(t,e){if(t.url)a.getJSON(t.url,e);else{if(\"string\"!=typeof t.data)return e(new Error(\"Input data is not a valid GeoJSON object.\"));try{return e(null,JSON.parse(t.data))}catch(t){return e(new Error(\"Input data is not a valid GeoJSON object.\"))}}},_indexData:function(t,e,r){try{e.cluster?r(null,u(e.superclusterOptions).load(t.features)):r(null,c(t,e.geojsonVtOptions))}catch(t){return r(t)}}})},{\"../util/ajax\":424,\"../util/util\":441,\"./geojson_wrapper\":359,\"./vector_tile_worker_source\":370,\"geojson-rewind\":137,\"geojson-vt\":141,supercluster:528,\"vt-pbf\":555}],359:[function(t,e,r){\"use strict\";function n(t){this.features=t,this.length=t.length,this.extent=s}function i(t){if(this.type=t.type,1===t.type){this.rawGeometry=[];for(var e=0;e<t.geometry.length;e++)this.rawGeometry.push([t.geometry[e]])}else this.rawGeometry=t.geometry;this.properties=t.tags,this.extent=s}var a=t(\"point-geometry\"),o=t(\"vector-tile\").VectorTileFeature,s=t(\"../data/bucket\").EXTENT;e.exports=n,n.prototype.feature=function(t){return new i(this.features[t])},i.prototype.loadGeometry=function(){var t=this.rawGeometry;this.geometry=[];for(var e=0;e<t.length;e++){for(var r=t[e],n=[],i=0;i<r.length;i++)n.push(new a(r[i][0],r[i][1]));this.geometry.push(n)}return this.geometry},i.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var t=this.geometry,e=1/0,r=-1/0,n=1/0,i=-1/0,a=0;a<t.length;a++)for(var o=t[a],s=0;s<o.length;s++){var l=o[s];e=Math.min(e,l.x),r=Math.max(r,l.x),n=Math.min(n,l.y),i=Math.max(i,l.y)}return[e,n,r,i]},i.prototype.toGeoJSON=o.prototype.toGeoJSON},{\"../data/bucket\":328,\"point-geometry\":483,\"vector-tile\":549}],360:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r,this.url=e.url,this.coordinates=e.coordinates,u.getImage(e.url,function(t,r){if(t)return this.fire(\"error\",{error:t});this.image=r,this.image.addEventListener(\"load\",function(){this.map._rerender()}.bind(this)),this._loaded=!0,this.fire(\"load\"),this.map&&this.setCoordinates(e.coordinates)}.bind(this))}var i=t(\"../util/util\"),a=t(\"./tile_coord\"),o=t(\"../geo/lng_lat\"),s=t(\"point-geometry\"),l=t(\"../util/evented\"),u=t(\"../util/ajax\"),c=t(\"../data/bucket\").EXTENT,h=t(\"../render/draw_raster\").RasterBoundsArray,f=t(\"../data/buffer\"),d=t(\"../render/vertex_array_object\");e.exports=n,n.prototype=i.inherit(l,{minzoom:0,maxzoom:22,tileSize:512,onAdd:function(t){this.map=t,this.image&&this.setCoordinates(this.coordinates)},setCoordinates:function(t){this.coordinates=t;var e=this.map,r=t.map(function(t){return e.transform.locationCoordinate(o.convert(t)).zoomTo(0)}),n=this.centerCoord=i.getCoordinatesCenter(r);return n.column=Math.round(n.column),n.row=Math.round(n.row),this.minzoom=this.maxzoom=n.zoom,this._coord=new a(n.zoom,n.column,n.row),this._tileCoords=r.map(function(t){var e=t.zoomTo(n.zoom);return new s(Math.round((e.column-n.column)*c),Math.round((e.row-n.row)*c))}),this.fire(\"change\"),this},_setTile:function(t){this._prepared=!1,this.tile=t;var e=new h;e.emplaceBack(this._tileCoords[0].x,this._tileCoords[0].y,0,0),e.emplaceBack(this._tileCoords[1].x,this._tileCoords[1].y,32767,0),e.emplaceBack(this._tileCoords[3].x,this._tileCoords[3].y,0,32767),e.emplaceBack(this._tileCoords[2].x,this._tileCoords[2].y,32767,32767),this.tile.buckets={},this.tile.boundsBuffer=new f(e.serialize(),h.serialize(),f.BufferType.VERTEX),this.tile.boundsVAO=new d,this.tile.state=\"loaded\"},prepare:function(){if(this._loaded&&this.image&&this.image.complete&&this.tile){var t=this.map.painter,e=t.gl;this._prepared?(e.bindTexture(e.TEXTURE_2D,this.tile.texture),e.texSubImage2D(e.TEXTURE_2D,0,0,0,e.RGBA,e.UNSIGNED_BYTE,this.image)):(this.tile.texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this.tile.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,e.RGBA,e.UNSIGNED_BYTE,this.image))}},loadTile:function(t,e){this._coord&&this._coord.toString()===t.coord.toString()?(this._setTile(t),e(null)):(t.state=\"errored\",e(null))},serialize:function(){return{type:\"image\",urls:this.url,coordinates:this.coordinates}}})},{\"../data/bucket\":328,\"../data/buffer\":333,\"../geo/lng_lat\":338,\"../render/draw_raster\":350,\"../render/vertex_array_object\":356,\"../util/ajax\":424,\"../util/evented\":433,\"../util/util\":441,\"./tile_coord\":368,\"point-geometry\":483}],361:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i=t(\"../util/ajax\"),a=t(\"../util/browser\"),o=t(\"../util/mapbox\").normalizeSourceURL;e.exports=function(t,e){var r=function(t,r){if(t)return e(t);var i=n.pick(r,[\"tiles\",\"minzoom\",\"maxzoom\",\"attribution\"]);r.vector_layers&&(i.vectorLayers=r.vector_layers,i.vectorLayerIds=i.vectorLayers.map(function(t){return t.id})),e(null,i)};t.url?i.getJSON(o(t.url),r):a.frame(r.bind(null,null,t))}},{\"../util/ajax\":424,\"../util/browser\":425,\"../util/mapbox\":438,\"../util/util\":441}],362:[function(t,e,r){\"use strict\";var n=t(\"../data/bucket\");e.exports=function(t,e,r){return e*(n.EXTENT/(t.tileSize*Math.pow(2,r-t.coord.z)))}},{\"../data/bucket\":328}],363:[function(t,e,r){\"use strict\";function n(t,e){var r=t.coord,n=e.coord;return r.z-n.z||r.y-n.y||r.w-n.w||r.x-n.x}function i(t){for(var e=t[0]||{},r=1;r<t.length;r++){var n=t[r];for(var i in n){var a=n[i],o=e[i];if(void 0===o)o=e[i]=a;else for(var s=0;s<a.length;s++)o.push(a[s])}}return e}var a=t(\"./tile_coord\");r.rendered=function(t,e,r,a,o,s){var l=t.tilesIn(r);l.sort(n);for(var u=[],c=0;c<l.length;c++){var h=l[c];h.tile.featureIndex&&u.push(h.tile.featureIndex.query({queryGeometry:h.queryGeometry,scale:h.scale,tileSize:h.tile.tileSize,bearing:s,params:a},e))}return i(u)},r.source=function(t,e){for(var r=t.getRenderableIds().map(function(e){return t.getTileByID(e)}),n=[],i={},o=0;o<r.length;o++){var s=r[o],l=new a(Math.min(s.sourceMaxZoom,s.coord.z),s.coord.x,s.coord.y,0).id;i[l]||(i[l]=!0,s.querySourceFeatures(n,e))}return n}},{\"./tile_coord\":368}],364:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r,i.extend(this,i.pick(e,[\"url\",\"scheme\",\"tileSize\"])),s(e,function(t,e){if(t)return this.fire(\"error\",t);i.extend(this,e),this.fire(\"load\")}.bind(this))}var i=t(\"../util/util\"),a=t(\"../util/ajax\"),o=t(\"../util/evented\"),s=t(\"./load_tilejson\"),l=t(\"../util/mapbox\").normalizeTileURL;e.exports=n,n.prototype=i.inherit(o,{minzoom:0,maxzoom:22,roundZoom:!0,scheme:\"xyz\",tileSize:512,_loaded:!1,onAdd:function(t){this.map=t},serialize:function(){return{type:\"raster\",url:this.url,tileSize:this.tileSize}},loadTile:function(t,e){function r(r,n){if(delete t.request,!t.aborted){if(r)return e(r);var i=this.map.painter.gl;t.texture=this.map.painter.getTexture(n.width),t.texture?(i.bindTexture(i.TEXTURE_2D,t.texture),i.texSubImage2D(i.TEXTURE_2D,0,0,0,i.RGBA,i.UNSIGNED_BYTE,n)):(t.texture=i.createTexture(),i.bindTexture(i.TEXTURE_2D,t.texture),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR_MIPMAP_NEAREST),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE),i.pixelStorei(i.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,i.RGBA,i.UNSIGNED_BYTE,n),t.texture.size=n.width),i.generateMipmap(i.TEXTURE_2D),this.map.animationLoop.set(this.map.style.rasterFadeDuration),t.state=\"loaded\",e(null)}}var n=l(t.coord.url(this.tiles,null,this.scheme),this.url,this.tileSize);t.request=a.getImage(n,r.bind(this))},abortTile:function(t){t.request&&(t.request.abort(),delete t.request)},unloadTile:function(t){t.texture&&this.map.painter.saveTexture(t.texture)}})},{\"../util/ajax\":424,\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./load_tilejson\":361}],365:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i={vector:t(\"../source/vector_tile_source\"),raster:t(\"../source/raster_tile_source\"),geojson:t(\"../source/geojson_source\"),video:t(\"../source/video_source\"),image:t(\"../source/image_source\")};r.create=function(t,e,r){if(e=new i[e.type](t,e,r),e.id!==t)throw new Error(\"Expected Source id to be \"+t+\" instead of \"+e.id);return n.bindAll([\"load\",\"abort\",\"unload\",\"serialize\",\"prepare\"],e),e},r.getType=function(t){return i[t]},r.setType=function(t,e){i[t]=e}},{\"../source/geojson_source\":357,\"../source/image_source\":360,\"../source/raster_tile_source\":364,\"../source/vector_tile_source\":369,\"../source/video_source\":371,\"../util/util\":441}],366:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r;var n=this._source=o.create(t,e,r).on(\"load\",function(){this.map&&this._source.onAdd&&this._source.onAdd(this.map),this._sourceLoaded=!0,this.tileSize=n.tileSize,this.minzoom=n.minzoom,this.maxzoom=n.maxzoom,this.roundZoom=n.roundZoom,this.reparseOverscaled=n.reparseOverscaled,this.isTileClipped=n.isTileClipped,this.attribution=n.attribution,this.vectorLayerIds=n.vectorLayerIds,this.fire(\"load\")}.bind(this)).on(\"error\",function(t){this._sourceErrored=!0,this.fire(\"error\",t)}.bind(this)).on(\"change\",function(){this.reload(),this.transform&&this.update(this.transform,this.map&&this.map.style.rasterFadeDuration),this.fire(\"change\")}.bind(this));this._tiles={},this._cache=new c(0,this.unloadTile.bind(this)),this._isIdRenderable=this._isIdRenderable.bind(this)}function i(t,e,r){var n=r.zoomTo(Math.min(t.z,e));return{x:(n.column-(t.x+t.w*Math.pow(2,t.z)))*d,y:(n.row-t.y)*d}}function a(t,e){return t%32-e%32}var o=t(\"./source\"),s=t(\"./tile\"),l=t(\"../util/evented\"),u=t(\"./tile_coord\"),c=t(\"../util/lru_cache\"),h=t(\"../geo/coordinate\"),f=t(\"../util/util\"),d=t(\"../data/bucket\").EXTENT;e.exports=n,n.maxOverzooming=10,n.maxUnderzooming=3,n.prototype=f.inherit(l,{onAdd:function(t){this.map=t,this._source&&this._source.onAdd&&this._source.onAdd(t)},loaded:function(){if(this._sourceErrored)return!0;if(!this._sourceLoaded)return!1;for(var t in this._tiles){var e=this._tiles[t];if(\"loaded\"!==e.state&&\"errored\"!==e.state)return!1}return!0},getSource:function(){return this._source},loadTile:function(t,e){return this._source.loadTile(t,e)},unloadTile:function(t){if(this._source.unloadTile)return this._source.unloadTile(t)},abortTile:function(t){if(this._source.abortTile)return this._source.abortTile(t)},serialize:function(){return this._source.serialize()},prepare:function(){if(this._sourceLoaded&&this._source.prepare)return this._source.prepare()},getIds:function(){return Object.keys(this._tiles).map(Number).sort(a)},getRenderableIds:function(){return this.getIds().filter(this._isIdRenderable)},_isIdRenderable:function(t){return this._tiles[t].isRenderable()&&!this._coveredTiles[t]},reload:function(){this._cache.reset();for(var t in this._tiles){var e=this._tiles[t];\"loading\"!==e.state&&(e.state=\"reloading\"),this.loadTile(this._tiles[t],this._tileLoaded.bind(this,this._tiles[t]))}},_tileLoaded:function(t,e){if(e)return t.state=\"errored\",this.fire(\"tile.error\",{tile:t,error:e}),void this._source.fire(\"tile.error\",{tile:t,error:e});t.source=this,t.timeAdded=(new Date).getTime(),this.fire(\"tile.load\",{tile:t}),this._source.fire(\"tile.load\",{tile:t})},getTile:function(t){return this.getTileByID(t.id)},getTileByID:function(t){return this._tiles[t]},getZoom:function(t){return t.zoom+t.scaleZoom(t.tileSize/this.tileSize)},findLoadedChildren:function(t,e,r){var n=!1;for(var i in this._tiles){var a=this._tiles[i];if(!(r[i]||!a.isRenderable()||a.coord.z<=t.z||a.coord.z>e)){var o=Math.pow(2,Math.min(a.coord.z,this.maxzoom)-Math.min(t.z,this.maxzoom));if(Math.floor(a.coord.x/o)===t.x&&Math.floor(a.coord.y/o)===t.y)for(r[i]=!0,n=!0;a&&a.coord.z-1>t.z;){var s=a.coord.parent(this.maxzoom).id;a=this._tiles[s],a&&a.isRenderable()&&(delete r[i],r[s]=!0)}}}return n},findLoadedParent:function(t,e,r){for(var n=t.z-1;n>=e;n--){t=t.parent(this.maxzoom);var i=this._tiles[t.id];if(i&&i.isRenderable())return r[t.id]=!0,i;if(this._cache.has(t.id))return this.addTile(t),r[t.id]=!0,this._tiles[t.id]}},updateCacheSize:function(t){var e=Math.ceil(t.width/t.tileSize)+1,r=Math.ceil(t.height/t.tileSize)+1,n=e*r;this._cache.setMaxSize(Math.floor(5*n))},update:function(t,e){if(this._sourceLoaded){var r,i,a;this.updateCacheSize(t);var o=(this.roundZoom?Math.round:Math.floor)(this.getZoom(t)),s=Math.max(o-n.maxOverzooming,this.minzoom),l=Math.max(o+n.maxUnderzooming,this.minzoom),c={},h=(new Date).getTime();this._coveredTiles={};var d=this.used?t.coveringTiles(this._source):[];for(r=0;r<d.length;r++)i=d[r],a=this.addTile(i),c[i.id]=!0,a.isRenderable()||this.findLoadedChildren(i,l,c)||this.findLoadedParent(i,s,c);for(var p={},m=Object.keys(c),v=0;v<m.length;v++){var g=m[v];i=u.fromID(g),a=this._tiles[g],a&&a.timeAdded>h-(e||0)&&(this.findLoadedChildren(i,l,c)&&(c[g]=!0),this.findLoadedParent(i,s,p))}var y;for(y in p)c[y]||(this._coveredTiles[y]=!0);for(y in p)c[y]=!0;var b=f.keysDifference(this._tiles,c);for(r=0;r<b.length;r++)this.removeTile(+b[r]);this.transform=t}},addTile:function(t){var e=this._tiles[t.id];if(e)return e;var r=t.wrapped()\n",
       ";if(e=this._tiles[r.id],e||(e=this._cache.get(r.id))&&this._redoPlacement&&this._redoPlacement(e),!e){var n=t.z,i=n>this.maxzoom?Math.pow(2,n-this.maxzoom):1;e=new s(r,this.tileSize*i,this.maxzoom),this.loadTile(e,this._tileLoaded.bind(this,e))}return e.uses++,this._tiles[t.id]=e,this.fire(\"tile.add\",{tile:e}),this._source.fire(\"tile.add\",{tile:e}),e},removeTile:function(t){var e=this._tiles[t];e&&(e.uses--,delete this._tiles[t],this.fire(\"tile.remove\",{tile:e}),this._source.fire(\"tile.remove\",{tile:e}),e.uses>0||(e.isRenderable()?this._cache.add(e.coord.wrapped().id,e):(e.aborted=!0,this.abortTile(e),this.unloadTile(e))))},clearTiles:function(){for(var t in this._tiles)this.removeTile(t);this._cache.reset()},tilesIn:function(t){for(var e={},r=this.getIds(),n=1/0,a=1/0,o=-1/0,s=-1/0,l=t[0].zoom,c=0;c<t.length;c++){var f=t[c];n=Math.min(n,f.column),a=Math.min(a,f.row),o=Math.max(o,f.column),s=Math.max(s,f.row)}for(var p=0;p<r.length;p++){var m=this._tiles[r[p]],v=u.fromID(r[p]),g=[i(v,m.sourceMaxZoom,new h(n,a,l)),i(v,m.sourceMaxZoom,new h(o,s,l))];if(g[0].x<d&&g[0].y<d&&g[1].x>=0&&g[1].y>=0){for(var y=[],b=0;b<t.length;b++)y.push(i(v,m.sourceMaxZoom,t[b]));var x=e[m.coord.id];void 0===x&&(x=e[m.coord.id]={tile:m,coord:v,queryGeometry:[],scale:Math.pow(2,this.transform.zoom-m.coord.z)}),x.queryGeometry.push(y)}}var _=[];for(var w in e)_.push(e[w]);return _},redoPlacement:function(){for(var t=this.getIds(),e=0;e<t.length;e++){this.getTileByID(t[e]).redoPlacement(this)}},getVisibleCoordinates:function(){return this.getRenderableIds().map(u.fromID)}})},{\"../data/bucket\":328,\"../geo/coordinate\":337,\"../util/evented\":433,\"../util/lru_cache\":437,\"../util/util\":441,\"./source\":365,\"./tile\":367,\"./tile_coord\":368}],367:[function(t,e,r){\"use strict\";function n(t,e,r){this.coord=t,this.uid=a.uniqueId(),this.uses=0,this.tileSize=e,this.sourceMaxZoom=r,this.buckets={},this.state=\"loading\"}function i(t,e){if(e){for(var r={},n=0;n<t.length;n++){var i=e.getLayer(t[n].layerId);if(i){var s=o.create(a.extend({layer:i,childLayers:t[n].childLayerIds.map(e.getLayer.bind(e)).filter(function(t){return t})},t[n]));r[s.id]=s}}return r}}var a=t(\"../util/util\"),o=t(\"../data/bucket\"),s=t(\"../data/feature_index\"),l=t(\"vector-tile\"),u=t(\"pbf\"),c=t(\"../util/vectortile_to_geojson\"),h=t(\"feature-filter\"),f=t(\"../symbol/collision_tile\"),d=t(\"../symbol/collision_box\"),p=t(\"../symbol/symbol_instances\"),m=t(\"../symbol/symbol_quads\");e.exports=n,n.prototype={loadVectorData:function(t,e){this.state=\"loaded\",t&&(this.collisionBoxArray=new d(t.collisionBoxArray),this.collisionTile=new f(t.collisionTile,this.collisionBoxArray),this.symbolInstancesArray=new p(t.symbolInstancesArray),this.symbolQuadsArray=new m(t.symbolQuadsArray),this.featureIndex=new s(t.featureIndex,t.rawTileData,this.collisionTile),this.rawTileData=t.rawTileData,this.buckets=i(t.buckets,e))},reloadSymbolData:function(t,e,r){if(\"unloaded\"!==this.state){this.collisionTile=new f(t.collisionTile,this.collisionBoxArray),this.featureIndex.setCollisionTile(this.collisionTile);for(var n in this.buckets){var o=this.buckets[n];\"symbol\"===o.type&&(o.destroy(e.gl),delete this.buckets[n])}a.extend(this.buckets,i(t.buckets,r))}},unloadVectorData:function(t){for(var e in this.buckets){this.buckets[e].destroy(t.gl)}this.collisionBoxArray=null,this.symbolQuadsArray=null,this.symbolInstancesArray=null,this.collisionTile=null,this.featureIndex=null,this.rawTileData=null,this.buckets=null,this.state=\"unloaded\"},redoPlacement:function(t){function e(e,r){this.reloadSymbolData(r,t.map.painter,t.map.style),t.fire(\"tile.load\",{tile:this}),this.state=\"loaded\",this.redoWhenDone&&(this.redoPlacement(t),this.redoWhenDone=!1)}if(\"loaded\"!==this.state||\"reloading\"===this.state)return void(this.redoWhenDone=!0);this.state=\"reloading\",t.dispatcher.send(\"redo placement\",{uid:this.uid,source:t.id,angle:t.map.transform.angle,pitch:t.map.transform.pitch,showCollisionBoxes:t.map.showCollisionBoxes},e.bind(this),this.workerID)},getBucket:function(t){return this.buckets&&this.buckets[t.ref||t.id]},querySourceFeatures:function(t,e){if(this.rawTileData){this.vtLayers||(this.vtLayers=new l.VectorTile(new u(new Uint8Array(this.rawTileData))).layers);var r=this.vtLayers._geojsonTileLayer||this.vtLayers[e.sourceLayer];if(r)for(var n=h(e.filter),i={z:this.coord.z,x:this.coord.x,y:this.coord.y},a=0;a<r.length;a++){var o=r.feature(a);if(n(o)){var s=new c(o,this.coord.z,this.coord.x,this.coord.y);s.tile=i,t.push(s)}}}},isRenderable:function(){return\"loaded\"===this.state||\"reloading\"===this.state}}},{\"../data/bucket\":328,\"../data/feature_index\":335,\"../symbol/collision_box\":393,\"../symbol/collision_tile\":395,\"../symbol/symbol_instances\":404,\"../symbol/symbol_quads\":405,\"../util/util\":441,\"../util/vectortile_to_geojson\":442,\"feature-filter\":131,pbf:477,\"vector-tile\":549}],368:[function(t,e,r){\"use strict\";function n(t,e,r,n){l(!isNaN(t)&&t>=0&&t%1==0),l(!isNaN(e)&&e>=0&&e%1==0),l(!isNaN(r)&&r>=0&&r%1==0),isNaN(n)&&(n=0),this.z=+t,this.x=+e,this.y=+r,this.w=+n,(n*=2)<0&&(n=-1*n-1);var i=1<<this.z;this.id=32*(i*i*n+i*this.y+this.x)+this.z,this.posMatrix=null}function i(t,e,r){for(var n,i=\"\",a=t;a>0;a--)n=1<<a-1,i+=(e&n?1:0)+(r&n?2:0);return i}function a(t,e){if(t.row>e.row){var r=t;t=e,e=r}return{x0:t.column,y0:t.row,x1:e.column,y1:e.row,dx:e.column-t.column,dy:e.row-t.row}}function o(t,e,r,n,i){var a=Math.max(r,Math.floor(e.y0)),o=Math.min(n,Math.ceil(e.y1));if(t.x0===e.x0&&t.y0===e.y0?t.x0+e.dy/t.dy*t.dx<e.x1:t.x1-e.dy/t.dy*t.dx<e.x0){var s=t;t=e,e=s}for(var l=t.dx/t.dy,u=e.dx/e.dy,c=t.dx>0,h=e.dx<0,f=a;f<o;f++){var d=l*Math.max(0,Math.min(t.dy,f+c-t.y0))+t.x0,p=u*Math.max(0,Math.min(e.dy,f+h-e.y0))+e.x0;i(Math.floor(p),Math.ceil(d),f)}}function s(t,e,r,n,i,s){var l,u=a(t,e),c=a(e,r),h=a(r,t);u.dy>c.dy&&(l=u,u=c,c=l),u.dy>h.dy&&(l=u,u=h,h=l),c.dy>h.dy&&(l=c,c=h,h=l),u.dy&&o(h,u,n,i,s),c.dy&&o(h,c,n,i,s)}var l=t(\"assert\"),u=t(\"whoots-js\"),c=t(\"../geo/coordinate\");e.exports=n,n.prototype.toString=function(){return this.z+\"/\"+this.x+\"/\"+this.y},n.prototype.toCoordinate=function(t){var e=Math.min(this.z,t),r=Math.pow(2,e),n=this.y,i=this.x+r*this.w;return new c(i,n,e)},n.fromID=function(t){var e=t%32,r=1<<e,i=(t-e)/32,a=i%r,o=(i-a)/r%r,s=Math.floor(i/(r*r));return s%2!=0&&(s=-1*s-1),s/=2,new n(e,a,o,s)},n.prototype.url=function(t,e,r){var n=u.getTileBBox(this.x,this.y,this.z),a=i(this.z,this.x,this.y);return t[(this.x+this.y)%t.length].replace(\"{prefix}\",(this.x%16).toString(16)+(this.y%16).toString(16)).replace(\"{z}\",Math.min(this.z,e||this.z)).replace(\"{x}\",this.x).replace(\"{y}\",\"tms\"===r?Math.pow(2,this.z)-this.y-1:this.y).replace(\"{quadkey}\",a).replace(\"{bbox-epsg-3857}\",n)},n.prototype.parent=function(t){return 0===this.z?null:this.z>t?new n(this.z-1,this.x,this.y,this.w):new n(this.z-1,Math.floor(this.x/2),Math.floor(this.y/2),this.w)},n.prototype.wrapped=function(){return new n(this.z,this.x,this.y,0)},n.prototype.children=function(t){if(this.z>=t)return[new n(this.z+1,this.x,this.y,this.w)];var e=this.z+1,r=2*this.x,i=2*this.y;return[new n(e,r,i,this.w),new n(e,r+1,i,this.w),new n(e,r,i+1,this.w),new n(e,r+1,i+1,this.w)]},n.cover=function(t,e,r){function i(t,e,i){var s,l,u;if(i>=0&&i<=a)for(s=t;s<e;s++)l=(s%a+a)%a,u=new n(r,l,i,Math.floor(s/a)),o[u.id]=u}var a=1<<t,o={};return s(e[0],e[1],e[2],0,a,i),s(e[2],e[3],e[0],0,a,i),Object.keys(o).map(function(t){return o[t]})}},{\"../geo/coordinate\":337,assert:46,\"whoots-js\":565}],369:[function(t,e,r){\"use strict\";function n(t,e,r){if(this.id=t,this.dispatcher=r,a.extend(this,a.pick(e,[\"url\",\"scheme\",\"tileSize\"])),this._options=a.extend({type:\"vector\"},e),512!==this.tileSize)throw new Error(\"vector tile sources must have a tileSize of 512\");o(e,function(t,e){if(t)return void this.fire(\"error\",t);a.extend(this,e),this.fire(\"load\")}.bind(this))}var i=t(\"../util/evented\"),a=t(\"../util/util\"),o=t(\"./load_tilejson\"),s=t(\"../util/mapbox\").normalizeTileURL;e.exports=n,n.prototype=a.inherit(i,{minzoom:0,maxzoom:22,scheme:\"xyz\",tileSize:512,reparseOverscaled:!0,isTileClipped:!0,onAdd:function(t){this.map=t},serialize:function(){return a.extend({},this._options)},loadTile:function(t,e){function r(r,n){if(!t.aborted){if(r)return e(r);t.loadVectorData(n,this.map.style),t.redoWhenDone&&(t.redoWhenDone=!1,t.redoPlacement(this)),e(null),t.reloadCallback&&(this.loadTile(t,t.reloadCallback),t.reloadCallback=null)}}var n=t.coord.z>this.maxzoom?Math.pow(2,t.coord.z-this.maxzoom):1,i={url:s(t.coord.url(this.tiles,this.maxzoom,this.scheme),this.url),uid:t.uid,coord:t.coord,zoom:t.coord.z,tileSize:this.tileSize*n,source:this.id,overscaling:n,angle:this.map.transform.angle,pitch:this.map.transform.pitch,showCollisionBoxes:this.map.showCollisionBoxes};t.workerID?\"loading\"===t.state?t.reloadCallback=e:(i.rawTileData=t.rawTileData,this.dispatcher.send(\"reload tile\",i,r.bind(this),t.workerID)):t.workerID=this.dispatcher.send(\"load tile\",i,r.bind(this))},abortTile:function(t){this.dispatcher.send(\"abort tile\",{uid:t.uid,source:this.id},null,t.workerID)},unloadTile:function(t){t.unloadVectorData(this.map.painter),this.dispatcher.send(\"remove tile\",{uid:t.uid,source:this.id},null,t.workerID)}})},{\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./load_tilejson\":361}],370:[function(t,e,r){\"use strict\";function n(t,e,r){this.actor=t,this.styleLayers=e,r&&(this.loadVectorData=r),this.loading={},this.loaded={}}var i=t(\"../util/ajax\"),a=t(\"vector-tile\"),o=t(\"pbf\"),s=t(\"./worker_tile\");e.exports=n,n.prototype={loadTile:function(t,e){function r(t,r){return delete this.loading[n][i],t?e(t):r?(a.data=r.tile,a.parse(a.data,this.styleLayers.getLayerFamilies(),this.actor,r.rawTileData,e),this.loaded[n]=this.loaded[n]||{},void(this.loaded[n][i]=a)):e(null,null)}var n=t.source,i=t.uid;this.loading[n]||(this.loading[n]={});var a=this.loading[n][i]=new s(t);a.abort=this.loadVectorData(t,r.bind(this))},reloadTile:function(t,e){var r=this.loaded[t.source],n=t.uid;if(r&&r[n]){var i=r[n];i.parse(i.data,this.styleLayers.getLayerFamilies(),this.actor,t.rawTileData,e)}},abortTile:function(t){var e=this.loading[t.source],r=t.uid;e&&e[r]&&e[r].abort&&(e[r].abort(),delete e[r])},removeTile:function(t){var e=this.loaded[t.source],r=t.uid;e&&e[r]&&delete e[r]},loadVectorData:function(t,e){function r(t,r){if(t)return e(t);var n=new a.VectorTile(new o(new Uint8Array(r)));e(t,{tile:n,rawTileData:r})}var n=i.getArrayBuffer(t.url,r.bind(this));return function(){n.abort()}},redoPlacement:function(t,e){var r=this.loaded[t.source],n=this.loading[t.source],i=t.uid;if(r&&r[i]){var a=r[i],o=a.redoPlacement(t.angle,t.pitch,t.showCollisionBoxes);o.result&&e(null,o.result,o.transferables)}else n&&n[i]&&(n[i].angle=t.angle)}}},{\"../util/ajax\":424,\"./worker_tile\":373,pbf:477,\"vector-tile\":549}],371:[function(t,e,r){\"use strict\";function n(t,e){this.id=t,this.urls=e.urls,this.coordinates=e.coordinates,u.getVideo(e.urls,function(t,r){if(t)return this.fire(\"error\",{error:t});this.video=r,this.video.loop=!0;var n;this.video.addEventListener(\"playing\",function(){n=this.map.style.animationLoop.set(1/0),this.map._rerender()}.bind(this)),this.video.addEventListener(\"pause\",function(){this.map.style.animationLoop.cancel(n)}.bind(this)),this.map&&(this.video.play(),this.setCoordinates(e.coordinates)),this.fire(\"load\")}.bind(this))}var i=t(\"../util/util\"),a=t(\"./tile_coord\"),o=t(\"../geo/lng_lat\"),s=t(\"point-geometry\"),l=t(\"../util/evented\"),u=t(\"../util/ajax\"),c=t(\"../data/bucket\").EXTENT,h=t(\"../render/draw_raster\").RasterBoundsArray,f=t(\"../data/buffer\"),d=t(\"../render/vertex_array_object\");e.exports=n,n.prototype=i.inherit(l,{minzoom:0,maxzoom:22,tileSize:512,roundZoom:!0,getVideo:function(){return this.video},onAdd:function(t){this.map||(this.map=t,this.video&&(this.video.play(),this.setCoordinates(this.coordinates)))},setCoordinates:function(t){this.coordinates=t;var e=this.map,r=t.map(function(t){return e.transform.locationCoordinate(o.convert(t)).zoomTo(0)}),n=this.centerCoord=i.getCoordinatesCenter(r);return n.column=Math.round(n.column),n.row=Math.round(n.row),this.minzoom=this.maxzoom=n.zoom,this._coord=new a(n.zoom,n.column,n.row),this._tileCoords=r.map(function(t){var e=t.zoomTo(n.zoom);return new s(Math.round((e.column-n.column)*c),Math.round((e.row-n.row)*c))}),this.fire(\"change\"),this},_setTile:function(t){this._prepared=!1,this.tile=t;var e=new h;e.emplaceBack(this._tileCoords[0].x,this._tileCoords[0].y,0,0),e.emplaceBack(this._tileCoords[1].x,this._tileCoords[1].y,32767,0),e.emplaceBack(this._tileCoords[3].x,this._tileCoords[3].y,0,32767),e.emplaceBack(this._tileCoords[2].x,this._tileCoords[2].y,32767,32767),this.tile.buckets={},this.tile.boundsBuffer=new f(e.serialize(),h.serialize(),f.BufferType.VERTEX),this.tile.boundsVAO=new d,this.tile.state=\"loaded\"},prepare:function(){if(!(this.video.readyState<2)&&this.tile){var t=this.map.painter.gl;this._prepared?(t.bindTexture(t.TEXTURE_2D,this.tile.texture),t.texSubImage2D(t.TEXTURE_2D,0,0,0,t.RGBA,t.UNSIGNED_BYTE,this.video)):(this._prepared=!0,this.tile.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.tile.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,this.video)),this._currentTime=this.video.currentTime}},loadTile:function(t,e){this._coord&&this._coord.toString()===t.coord.toString()?(this._setTile(t),e(null)):(t.state=\"errored\",e(null))},serialize:function(){return{type:\"video\",urls:this.urls,coordinates:this.coordinates}}})},{\"../data/bucket\":328,\"../data/buffer\":333,\"../geo/lng_lat\":338,\"../render/draw_raster\":350,\"../render/vertex_array_object\":356,\"../util/ajax\":424,\"../util/evented\":433,\"../util/util\":441,\"./tile_coord\":368,\"point-geometry\":483}],372:[function(t,e,r){\"use strict\";function n(t){this.self=t,this.actor=new a(t,this);var e={getLayers:function(){return this.layers}.bind(this),getLayerFamilies:function(){return this.layerFamilies}.bind(this)};this.workerSources={vector:new l(this.actor,e),geojson:new u(this.actor,e)},this.self.registerWorkerSource=function(t,r){if(this.workerSources[t])throw new Error('Worker source with name \"'+t+'\" already registered.');this.workerSources[t]=new r(this.actor,e)}.bind(this)}function i(t){var e={};for(var r in t){var n=t[r],i=n.ref||n.id,a=t[i];a.layout&&\"none\"===a.layout.visibility||(e[i]=e[i]||[],r===i?e[i].unshift(n):e[i].push(n))}return e}var a=t(\"../util/actor\"),o=t(\"../style/style_layer\"),s=t(\"../util/util\"),l=t(\"./vector_tile_worker_source\"),u=t(\"./geojson_worker_source\");e.exports=function(t){return new n(t)},s.extend(n.prototype,{\"set layers\":function(t){function e(t){var e=o.create(t,t.ref&&r.layers[t.ref]);e.updatePaintTransitions({},{transition:!1}),r.layers[e.id]=e}this.layers={};for(var r=this,n=[],a=0;a<t.length;a++){var s=t[a];\"fill\"!==s.type&&\"line\"!==s.type&&\"circle\"!==s.type&&\"symbol\"!==s.type||(s.ref?n.push(a):e(s))}for(var l=0;l<n.length;l++)e(t[n[l]]);this.layerFamilies=i(this.layers)},\"update layers\":function(t){function e(t){var e=a.layers[t.ref];a.layers[t.id]?a.layers[t.id].set(t,e):a.layers[t.id]=o.create(t,e),a.layers[t.id].updatePaintTransitions({},{transition:!1})}var r,n,a=this;for(r in t)n=t[r],n.ref&&e(n);for(r in t)n=t[r],n.ref||e(n);this.layerFamilies=i(this.layers)},\"load tile\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].loadTile(t,e)},\"reload tile\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].reloadTile(t,e)},\"abort tile\":function(t){var e=t.type||\"vector\";this.workerSources[e].abortTile(t)},\"remove tile\":function(t){var e=t.type||\"vector\";this.workerSources[e].removeTile(t)},\"redo placement\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].redoPlacement(t,e)},\"load worker source\":function(t,e){try{this.self.importScripts(t.url),e()}catch(t){e(t)}}})},{\"../style/style_layer\":380,\"../util/actor\":423,\"../util/util\":441,\"./geojson_worker_source\":358,\"./vector_tile_worker_source\":370}],373:[function(t,e,r){\"use strict\";function n(t){this.coord=t.coord,this.uid=t.uid,this.zoom=t.zoom,this.tileSize=t.tileSize,this.source=t.source,this.overscaling=t.overscaling,this.angle=t.angle,this.pitch=t.pitch,this.showCollisionBoxes=t.showCollisionBoxes}function i(t){return!t.isEmpty()}function a(t){return t.serialize()}function o(t){var e=[];for(var r in t)t[r].getTransferables(e);return e}function s(t){return t.id}var l=t(\"../data/feature_index\"),u=t(\"../symbol/collision_tile\"),c=t(\"../data/bucket\"),h=t(\"../symbol/collision_box\"),f=t(\"../util/dictionary_coder\"),d=t(\"../util/util\"),p=t(\"../symbol/symbol_instances\"),m=t(\"../symbol/symbol_quads\");e.exports=n,n.prototype.parse=function(t,e,r,n,v){function g(t,e){for(var r=0;r<t.length;r++){var n=t.feature(r);n.index=r;for(var i in e)e[i].filter(n)&&e[i].features.push(n)}}function y(t){if(t)return v(t);if(2===++N){for(var e=P.length-1;e>=0;e--)b(E,P[e]);x()}}function b(t,e){if(e.populateArrays(A,j,F),\"symbol\"!==e.type)for(var r=0;r<e.features.length;r++){var n=e.features[r];T.insert(n,n.index,e.sourceLayerIndex,e.index)}e.features=null}function x(){E.status=\"done\",E.redoPlacementAfterDone&&(E.redoPlacement(E.angle,E.pitch,null),E.redoPlacementAfterDone=!1);var t=T.serialize(),e=A.serialize(),r=E.collisionBoxArray.serialize(),s=E.symbolInstancesArray.serialize(),l=E.symbolQuadsArray.serialize(),u=[n].concat(t.transferables).concat(e.transferables),c=D.filter(i);v(null,{buckets:c.map(a),featureIndex:t.data,collisionTile:e.data,collisionBoxArray:r,symbolInstancesArray:s,symbolQuadsArray:l,rawTileData:n},o(c).concat(u))}this.status=\"parsing\",this.data=t,this.collisionBoxArray=new h,this.symbolInstancesArray=new p,this.symbolQuadsArray=new m;var _,w,M,k,A=new u(this.angle,this.pitch,this.collisionBoxArray),T=new l(this.coord,this.overscaling,A,t.layers),S=new f(t.layers?Object.keys(t.layers).sort():[\"_geojsonTileLayer\"]),E=this,L={},C={},z=0;for(var I in e)w=e[I][0],w.source===this.source&&(w.ref||w.minzoom&&this.zoom<w.minzoom||w.maxzoom&&this.zoom>=w.maxzoom||w.layout&&\"none\"===w.layout.visibility||t.layers&&!t.layers[w.sourceLayer]||(k=c.create({layer:w,index:z++,childLayers:e[I],zoom:this.zoom,overscaling:this.overscaling,showCollisionBoxes:this.showCollisionBoxes,collisionBoxArray:this.collisionBoxArray,symbolQuadsArray:this.symbolQuadsArray,symbolInstancesArray:this.symbolInstancesArray,sourceLayerIndex:S.encode(w.sourceLayer||\"_geojsonTileLayer\")}),k.createFilter(),L[w.id]=k,t.layers&&(M=w.sourceLayer,C[M]=C[M]||{},C[M][w.id]=k)));if(t.layers)for(M in C)1===w.version&&d.warnOnce('Vector tile source \"'+this.source+'\" layer \"'+M+'\" does not use vector tile spec v2 and therefore may have some rendering errors.'),(w=t.layers[M])&&g(w,C[M]);else g(t,L);var D=[],P=this.symbolBuckets=[],O=[];T.bucketLayerIDs={};for(var R in L)k=L[R],0!==k.features.length&&(T.bucketLayerIDs[k.index]=k.childLayers.map(s),D.push(k),\"symbol\"===k.type?P.push(k):O.push(k));var F={},j={},N=0;if(P.length>0){for(_=P.length-1;_>=0;_--)P[_].updateIcons(F),P[_].updateFont(j);for(var B in j)j[B]=Object.keys(j[B]).map(Number);F=Object.keys(F),r.send(\"get glyphs\",{uid:this.uid,stacks:j},function(t,e){j=e,y(t)}),F.length?r.send(\"get icons\",{icons:F},function(t,e){F=e,y(t)}):y()}for(_=O.length-1;_>=0;_--)b(this,O[_]);if(0===P.length)return x()},n.prototype.redoPlacement=function(t,e,r){if(\"done\"!==this.status)return this.redoPlacementAfterDone=!0,this.angle=t,{};for(var n=new u(t,e,this.collisionBoxArray),s=this.symbolBuckets,l=s.length-1;l>=0;l--)s[l].placeFeatures(n,r);var c=n.serialize(),h=s.filter(i);return{result:{buckets:h.map(a),collisionTile:c.data},transferables:o(h).concat(c.transferables)}}},{\"../data/bucket\":328,\"../data/feature_index\":335,\"../symbol/collision_box\":393,\"../symbol/collision_tile\":395,\"../symbol/symbol_instances\":404,\"../symbol/symbol_quads\":405,\"../util/dictionary_coder\":431,\"../util/util\":441}],374:[function(t,e,r){\"use strict\";function n(){this.n=0,this.times=[]}e.exports=n,n.prototype.stopped=function(){return this.times=this.times.filter(function(t){return t.time>=(new Date).getTime()}),!this.times.length},n.prototype.set=function(t){return this.times.push({id:this.n,time:t+(new Date).getTime()}),this.n++},n.prototype.cancel=function(t){this.times=this.times.filter(function(e){return e.id!==t})}},{}],375:[function(t,e,r){\"use strict\";function n(t){this.base=t,this.retina=s.devicePixelRatio>1;var e=this.retina?\"@2x\":\"\";o.getJSON(l(t,e,\".json\"),function(t,e){if(t)return void this.fire(\"error\",{error:t});this.data=e,this.img&&this.fire(\"load\")}.bind(this)),o.getImage(l(t,e,\".png\"),function(t,e){if(t)return void this.fire(\"error\",{error:t});for(var r=e.getData(),n=e.data=new Uint8Array(r.length),i=0;i<r.length;i+=4){var a=r[i+3]/255;n[i+0]=r[i+0]*a,n[i+1]=r[i+1]*a,n[i+2]=r[i+2]*a,n[i+3]=r[i+3]}this.img=e,this.data&&this.fire(\"load\")}.bind(this))}function i(){}var a=t(\"../util/evented\"),o=t(\"../util/ajax\"),s=t(\"../util/browser\"),l=t(\"../util/mapbox\").normalizeSpriteURL;e.exports=n,n.prototype=Object.create(a),n.prototype.toJSON=function(){return this.base},n.prototype.loaded=function(){return!(!this.data||!this.img)},n.prototype.resize=function(){if(s.devicePixelRatio>1!==this.retina){var t=new n(this.base);t.on(\"load\",function(){this.img=t.img,this.data=t.data,this.retina=t.retina}.bind(this))}},i.prototype={x:0,y:0,width:0,height:0,pixelRatio:1,sdf:!1},n.prototype.getSpritePosition=function(t){if(!this.loaded())return new i;var e=this.data&&this.data[t];return e&&this.img?e:new i}},{\"../util/ajax\":424,\"../util/browser\":425,\"../util/evented\":433,\"../util/mapbox\":438}],376:[function(t,e,r){\"use strict\";var n=t(\"csscolorparser\").parseCSSColor,i=t(\"../util/util\"),a=t(\"./style_function\"),o={};e.exports=function t(e){if(a.isFunctionDefinition(e))return i.extend({},e,{stops:e.stops.map(function(e){return[e[0],t(e[1])]})});if(\"string\"==typeof e){if(!o[e]){var r=n(e);if(!r)throw new Error(\"Invalid color \"+e);o[e]=[r[0]/255*r[3],r[1]/255*r[3],r[2]/255*r[3],r[3]]}return o[e]}throw new Error(\"Invalid color \"+e)}},{\"../util/util\":441,\"./style_function\":379,csscolorparser:107}],377:[function(t,e,r){\"use strict\";function n(t,e,r){this.animationLoop=e||new m,this.dispatcher=new p(r||1,this),this.spriteAtlas=new l(1024,1024),this.lineAtlas=new u(256,512),this._layers={},this._order=[],this._groups=[],this.sources={},this.zoomHistory={},c.bindAll([\"_forwardSourceEvent\",\"_forwardTileEvent\",\"_forwardLayerEvent\",\"_redoPlacement\"],this),this._resetUpdates();var n=function(t,e){if(t)return void this.fire(\"error\",{error:t});if(!v.emitErrors(this,v(e))){this._loaded=!0,this.stylesheet=e,this.updateClasses();var r=e.sources;for(var n in r)this.addSource(n,r[n]);e.sprite&&(this.sprite=new o(e.sprite),this.sprite.on(\"load\",this.fire.bind(this,\"change\"))),this.glyphSource=new s(e.glyphs),this._resolve(),this.fire(\"load\")}}.bind(this);\"string\"==typeof t?h.getJSON(f(t),n):d.frame(n.bind(this,null,t)),this.on(\"source.load\",function(t){var e=t.source;if(e&&e.vectorLayerIds)for(var r in this._layers){var n=this._layers[r];n.source===e.id&&this._validateLayer(n)}})}var i=t(\"../util/evented\"),a=t(\"./style_layer\"),o=t(\"./image_sprite\"),s=t(\"../symbol/glyph_source\"),l=t(\"../symbol/sprite_atlas\"),u=t(\"../render/line_atlas\"),c=t(\"../util/util\"),h=t(\"../util/ajax\"),f=t(\"../util/mapbox\").normalizeStyleURL,d=t(\"../util/browser\"),p=t(\"../util/dispatcher\"),m=t(\"./animation_loop\"),v=t(\"./validate_style\"),g=t(\"../source/source\"),y=t(\"../source/query_features\"),b=t(\"../source/source_cache\"),x=t(\"./style_spec\"),_=t(\"./style_function\");e.exports=n,n.prototype=c.inherit(i,{_loaded:!1,_validateLayer:function(t){var e=this.sources[t.source];t.sourceLayer&&e&&e.vectorLayerIds&&-1===e.vectorLayerIds.indexOf(t.sourceLayer)&&this.fire(\"error\",{error:new Error('Source layer \"'+t.sourceLayer+'\" does not exist on source \"'+e.id+'\" as specified by style layer \"'+t.id+'\"')})},loaded:function(){if(!this._loaded)return!1;if(Object.keys(this._updates.sources).length)return!1;for(var t in this.sources)if(!this.sources[t].loaded())return!1;return!(this.sprite&&!this.sprite.loaded())},_resolve:function(){var t,e;this._layers={},this._order=this.stylesheet.layers.map(function(t){return t.id});for(var r=0;r<this.stylesheet.layers.length;r++)e=this.stylesheet.layers[r],e.ref||(t=a.create(e),this._layers[t.id]=t,t.on(\"error\",this._forwardLayerEvent));for(var n=0;n<this.stylesheet.layers.length;n++)if(e=this.stylesheet.layers[n],e.ref){var i=this.getLayer(e.ref);t=a.create(e,i),this._layers[t.id]=t,t.on(\"error\",this._forwardLayerEvent)}this._groupLayers(),this._updateWorkerLayers()},_groupLayers:function(){var t;this._groups=[];for(var e=0;e<this._order.length;++e){var r=this._layers[this._order[e]];t&&r.source===t.source||(t=[],t.source=r.source,this._groups.push(t)),t.push(r)}},_updateWorkerLayers:function(t){this.dispatcher.broadcast(t?\"update layers\":\"set layers\",this._serializeLayers(t))},_serializeLayers:function(t){t=t||this._order;for(var e=[],r={includeRefProperties:!0},n=0;n<t.length;n++)e.push(this._layers[t[n]].serialize(r));return e},_applyClasses:function(t,e){if(this._loaded){t=t||[],e=e||{transition:!0};var r=this.stylesheet.transition||{},n=this._updates.allPaintProps?this._layers:this._updates.paintProps;for(var i in n){var a=this._layers[i],o=this._updates.paintProps[i];if(this._updates.allPaintProps||o.all)a.updatePaintTransitions(t,e,r,this.animationLoop);else for(var s in o)this._layers[i].updatePaintTransition(s,t,e,r,this.animationLoop)}}},_recalculate:function(t){for(var e in this.sources)this.sources[e].used=!1;this._updateZoomHistory(t),this.rasterFadeDuration=300;for(var r in this._layers){var n=this._layers[r];n.recalculate(t,this.zoomHistory),!n.isHidden(t)&&n.source&&(this.sources[n.source].used=!0)}Math.floor(this.z)!==Math.floor(t)&&this.animationLoop.set(300),this.z=t,this.fire(\"zoom\")},_updateZoomHistory:function(t){var e=this.zoomHistory;void 0===e.lastIntegerZoom&&(e.lastIntegerZoom=Math.floor(t),e.lastIntegerZoomTime=0,e.lastZoom=t),Math.floor(e.lastZoom)<Math.floor(t)?(e.lastIntegerZoom=Math.floor(t),e.lastIntegerZoomTime=Date.now()):Math.floor(e.lastZoom)>Math.floor(t)&&(e.lastIntegerZoom=Math.floor(t+1),e.lastIntegerZoomTime=Date.now()),e.lastZoom=t},_checkLoaded:function(){if(!this._loaded)throw new Error(\"Style is not done loading\")},update:function(t,e){if(!this._updates.changed)return this;if(this._updates.allLayers)this._groupLayers(),this._updateWorkerLayers();else{var r=Object.keys(this._updates.layers);r.length&&this._updateWorkerLayers(r)}var n,i=Object.keys(this._updates.sources);for(n=0;n<i.length;n++)this._reloadSource(i[n]);for(n=0;n<this._updates.events.length;n++){var a=this._updates.events[n];this.fire(a[0],a[1])}return this._applyClasses(t,e),this._updates.changed&&this.fire(\"change\"),this._resetUpdates(),this},_resetUpdates:function(){this._updates={events:[],layers:{},sources:{},paintProps:{}}},addSource:function(t,e){if(this._checkLoaded(),void 0!==this.sources[t])throw new Error(\"There is already a source with this ID\");if(!e.type)throw new Error(\"The type property must be defined, but the only the following properties were given: \"+Object.keys(e)+\".\");return[\"vector\",\"raster\",\"geojson\",\"video\",\"image\"].indexOf(e.type)>=0&&this._handleErrors(v.source,\"sources.\"+t,e)?this:(e=new b(t,e,this.dispatcher),this.sources[t]=e,e.style=this,e.on(\"load\",this._forwardSourceEvent).on(\"error\",this._forwardSourceEvent).on(\"change\",this._forwardSourceEvent).on(\"tile.add\",this._forwardTileEvent).on(\"tile.load\",this._forwardTileEvent).on(\"tile.error\",this._forwardTileEvent).on(\"tile.remove\",this._forwardTileEvent).on(\"tile.stats\",this._forwardTileEvent),this._updates.events.push([\"source.add\",{source:e}]),this._updates.changed=!0,this)},removeSource:function(t){if(this._checkLoaded(),void 0===this.sources[t])throw new Error(\"There is no source with this ID\");var e=this.sources[t];return delete this.sources[t],delete this._updates.sources[t],e.off(\"load\",this._forwardSourceEvent).off(\"error\",this._forwardSourceEvent).off(\"change\",this._forwardSourceEvent).off(\"tile.add\",this._forwardTileEvent).off(\"tile.load\",this._forwardTileEvent).off(\"tile.error\",this._forwardTileEvent).off(\"tile.remove\",this._forwardTileEvent).off(\"tile.stats\",this._forwardTileEvent),this._updates.events.push([\"source.remove\",{source:e}]),this._updates.changed=!0,this},getSource:function(t){return this.sources[t]&&this.sources[t].getSource()},addLayer:function(t,e){if(this._checkLoaded(),!(t instanceof a)){if(this._handleErrors(v.layer,\"layers.\"+t.id,t,!1,{arrayIndex:-1}))return this;var r=t.ref&&this.getLayer(t.ref);t=a.create(t,r)}return this._validateLayer(t),t.on(\"error\",this._forwardLayerEvent),this._layers[t.id]=t,this._order.splice(e?this._order.indexOf(e):1/0,0,t.id),this._updates.allLayers=!0,t.source&&(this._updates.sources[t.source]=!0),this._updates.events.push([\"layer.add\",{layer:t}]),this.updateClasses(t.id)},removeLayer:function(t){this._checkLoaded();var e=this._layers[t];if(void 0===e)throw new Error(\"There is no layer with this ID\");for(var r in this._layers)this._layers[r].ref===t&&this.removeLayer(r);return e.off(\"error\",this._forwardLayerEvent),delete this._layers[t],delete this._updates.layers[t],delete this._updates.paintProps[t],this._order.splice(this._order.indexOf(t),1),this._updates.allLayers=!0,this._updates.events.push([\"layer.remove\",{layer:e}]),this._updates.changed=!0,this},getLayer:function(t){return this._layers[t]},getReferentLayer:function(t){var e=this.getLayer(t);return e.ref&&(e=this.getLayer(e.ref)),e},setLayerZoomRange:function(t,e,r){this._checkLoaded();var n=this.getReferentLayer(t);return n.minzoom===e&&n.maxzoom===r?this:(null!=e&&(n.minzoom=e),null!=r&&(n.maxzoom=r),this._updateLayer(n))},setFilter:function(t,e){this._checkLoaded();var r=this.getReferentLayer(t);return null!==e&&this._handleErrors(v.filter,\"layers.\"+r.id+\".filter\",e)?this:c.deepEqual(r.filter,e)?this:(r.filter=c.clone(e),this._updateLayer(r))},getFilter:function(t){return this.getReferentLayer(t).filter},setLayoutProperty:function(t,e,r){this._checkLoaded();var n=this.getReferentLayer(t);return c.deepEqual(n.getLayoutProperty(e),r)?this:(n.setLayoutProperty(e,r),this._updateLayer(n))},getLayoutProperty:function(t,e){return this.getReferentLayer(t).getLayoutProperty(e)},setPaintProperty:function(t,e,r,n){this._checkLoaded();var i=this.getLayer(t);if(c.deepEqual(i.getPaintProperty(e,n),r))return this;var a=i.isPaintValueFeatureConstant(e);return i.setPaintProperty(e,r,n),!(r&&_.isFunctionDefinition(r)&&\"$zoom\"!==r.property&&void 0!==r.property)&&a||(this._updates.layers[t]=!0,i.source&&(this._updates.sources[i.source]=!0)),this.updateClasses(t,e)},getPaintProperty:function(t,e,r){return this.getLayer(t).getPaintProperty(e,r)},updateClasses:function(t,e){if(this._updates.changed=!0,t){var r=this._updates.paintProps;r[t]||(r[t]={}),r[t][e||\"all\"]=!0}else this._updates.allPaintProps=!0;return this},serialize:function(){return c.filterObject({version:this.stylesheet.version,name:this.stylesheet.name,metadata:this.stylesheet.metadata,center:this.stylesheet.center,zoom:this.stylesheet.zoom,bearing:this.stylesheet.bearing,pitch:this.stylesheet.pitch,sprite:this.stylesheet.sprite,glyphs:this.stylesheet.glyphs,transition:this.stylesheet.transition,sources:c.mapObject(this.sources,function(t){return t.serialize()}),layers:this._order.map(function(t){return this._layers[t].serialize()},this)},function(t){return void 0!==t})},_updateLayer:function(t){return this._updates.layers[t.id]=!0,t.source&&(this._updates.sources[t.source]=!0),this._updates.changed=!0,this},_flattenRenderedFeatures:function(t){for(var e=[],r=this._order.length-1;r>=0;r--)for(var n=this._order[r],i=0;i<t.length;i++){var a=t[i][n];if(a)for(var o=0;o<a.length;o++)e.push(a[o])}return e},queryRenderedFeatures:function(t,e,r,n){\n",
       "e&&e.filter&&this._handleErrors(v.filter,\"queryRenderedFeatures.filter\",e.filter,!0);var i={};if(e&&e.layers)for(var a=0;a<e.layers.length;a++){var o=e.layers[a];i[this._layers[o].source]=!0}var s=[];for(var l in this.sources)if(!e.layers||i[l]){var u=this.sources[l],c=y.rendered(u,this._layers,t,e,r,n);s.push(c)}return this._flattenRenderedFeatures(s)},querySourceFeatures:function(t,e){e&&e.filter&&this._handleErrors(v.filter,\"querySourceFeatures.filter\",e.filter,!0);var r=this.sources[t];return r?y.source(r,e):[]},addSourceType:function(t,e,r){return g.getType(t)?r(new Error('A source type called \"'+t+'\" already exists.')):(g.setType(t,e),e.workerSourceURL?void this.dispatcher.broadcast(\"load worker source\",{name:t,url:e.workerSourceURL},r):r(null,null))},_handleErrors:function(t,e,r,n,i){var a=n?v.throwErrors:v.emitErrors,o=t.call(v,c.extend({key:e,style:this.serialize(),value:r,styleSpec:x},i));return a.call(v,this,o)},_remove:function(){this.dispatcher.remove()},_reloadSource:function(t){this.sources[t].reload()},_updateSources:function(t){for(var e in this.sources)this.sources[e].update(t)},_redoPlacement:function(){for(var t in this.sources)this.sources[t].redoPlacement&&this.sources[t].redoPlacement()},_forwardSourceEvent:function(t){this.fire(\"source.\"+t.type,c.extend({source:t.target.getSource()},t))},_forwardTileEvent:function(t){this.fire(t.type,c.extend({source:t.target},t))},_forwardLayerEvent:function(t){this.fire(\"layer.\"+t.type,c.extend({layer:{id:t.target.id}},t))},\"get sprite json\":function(t,e){var r=this.sprite;r.loaded()?e(null,{sprite:r.data,retina:r.retina}):r.on(\"load\",function(){e(null,{sprite:r.data,retina:r.retina})})},\"get icons\":function(t,e){var r=this.sprite,n=this.spriteAtlas;r.loaded()?(n.setSprite(r),n.addIcons(t.icons,e)):r.on(\"load\",function(){n.setSprite(r),n.addIcons(t.icons,e)})},\"get glyphs\":function(t,e){function r(t,r,n){t&&console.error(t),a[n]=r,0===--i&&e(null,a)}var n=t.stacks,i=Object.keys(n).length,a={};for(var o in n)this.glyphSource.getSimpleGlyphs(o,n[o],t.uid,r)}})},{\"../render/line_atlas\":353,\"../source/query_features\":363,\"../source/source\":365,\"../source/source_cache\":366,\"../symbol/glyph_source\":398,\"../symbol/sprite_atlas\":403,\"../util/ajax\":424,\"../util/browser\":425,\"../util/dispatcher\":432,\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./animation_loop\":374,\"./image_sprite\":375,\"./style_function\":379,\"./style_layer\":380,\"./style_spec\":387,\"./validate_style\":389}],378:[function(t,e,r){\"use strict\";function n(t,e){this.value=s.clone(e),this.isFunction=a.isFunctionDefinition(e),this.json=JSON.stringify(this.value);var r=\"color\"===t.type&&this.value?o(this.value):e;if(this.calculate=a[t.function||\"piecewise-constant\"](r),this.isFeatureConstant=this.calculate.isFeatureConstant,this.isZoomConstant=this.calculate.isZoomConstant,\"piecewise-constant\"===t.function&&t.transition&&(this.calculate=i(this.calculate)),!this.isFeatureConstant&&!this.isZoomConstant){this.stopZoomLevels=[];for(var n=[],l=this.value.stops,u=0;u<this.value.stops.length;u++){var c=l[u][0].zoom;this.stopZoomLevels.indexOf(c)<0&&(this.stopZoomLevels.push(c),n.push([c,n.length]))}this.calculateInterpolationT=a.interpolated({stops:n,base:e.base})}}function i(t){return function(e,r){var n,i,a,o=e.zoom,s=e.zoomHistory,l=e.duration,u=o%1,c=Math.min((Date.now()-s.lastIntegerZoomTime)/l,1),h=1;return o>s.lastIntegerZoom?(n=u+(1-u)*c,h*=2,i=t({zoom:o-1},r),a=t({zoom:o},r)):(n=1-(1-c)*u,a=t({zoom:o},r),i=t({zoom:o+1},r),h/=2),void 0===i||void 0===a?void 0:{from:i,fromScale:h,to:a,toScale:1,t:n}}}var a=t(\"./style_function\"),o=t(\"./parse_color\"),s=t(\"../util/util\");e.exports=n},{\"../util/util\":441,\"./parse_color\":376,\"./style_function\":379}],379:[function(t,e,r){\"use strict\";var n=t(\"mapbox-gl-function\");r.interpolated=function(t){var e=n.interpolated(t),r=function(t,r){return e(t&&t.zoom,r||{})};return r.isFeatureConstant=e.isFeatureConstant,r.isZoomConstant=e.isZoomConstant,r},r[\"piecewise-constant\"]=function(t){var e=n[\"piecewise-constant\"](t),r=function(t,r){return e(t&&t.zoom,r||{})};return r.isFeatureConstant=e.isFeatureConstant,r.isZoomConstant=e.isZoomConstant,r},r.isFunctionDefinition=n.isFunctionDefinition},{\"mapbox-gl-function\":301}],380:[function(t,e,r){\"use strict\";function n(t,e){this.set(t,e)}function i(t){return t.value}var a=t(\"../util/util\"),o=t(\"./style_transition\"),s=t(\"./style_declaration\"),l=t(\"./style_spec\"),u=t(\"./validate_style\"),c=t(\"./parse_color\"),h=t(\"../util/evented\");e.exports=n;n.create=function(e,r){return new({background:t(\"./style_layer/background_style_layer\"),circle:t(\"./style_layer/circle_style_layer\"),fill:t(\"./style_layer/fill_style_layer\"),line:t(\"./style_layer/line_style_layer\"),raster:t(\"./style_layer/raster_style_layer\"),symbol:t(\"./style_layer/symbol_style_layer\")}[(r||e).type])(e,r)},n.prototype=a.inherit(h,{set:function(t,e){this.id=t.id,this.ref=t.ref,this.metadata=t.metadata,this.type=(e||t).type,this.source=(e||t).source,this.sourceLayer=(e||t)[\"source-layer\"],this.minzoom=(e||t).minzoom,this.maxzoom=(e||t).maxzoom,this.filter=(e||t).filter,this.paint={},this.layout={},this._paintSpecifications=l[\"paint_\"+this.type],this._layoutSpecifications=l[\"layout_\"+this.type],this._paintTransitions={},this._paintTransitionOptions={},this._paintDeclarations={},this._layoutDeclarations={},this._layoutFunctions={};var r,n;for(var i in t){var a=i.match(/^paint(?:\\.(.*))?$/);if(a){var o=a[1]||\"\";for(r in t[i])this.setPaintProperty(r,t[i][r],o)}}if(this.ref)this._layoutDeclarations=e._layoutDeclarations;else for(n in t.layout)this.setLayoutProperty(n,t.layout[n]);for(r in this._paintSpecifications)this.paint[r]=this.getPaintValue(r);for(n in this._layoutSpecifications)this._updateLayoutValue(n)},setLayoutProperty:function(t,e){if(null==e)delete this._layoutDeclarations[t];else{var r=\"layers.\"+this.id+\".layout.\"+t;if(this._handleErrors(u.layoutProperty,r,t,e))return;this._layoutDeclarations[t]=new s(this._layoutSpecifications[t],e)}this._updateLayoutValue(t)},getLayoutProperty:function(t){return this._layoutDeclarations[t]&&this._layoutDeclarations[t].value},getLayoutValue:function(t,e,r){var n=this._layoutSpecifications[t],i=this._layoutDeclarations[t];return i?i.calculate(e,r):n.default},setPaintProperty:function(t,e,r){var n=\"layers.\"+this.id+(r?'[\"paint.'+r+'\"].':\".paint.\")+t;if(a.endsWith(t,\"-transition\"))if(this._paintTransitionOptions[r||\"\"]||(this._paintTransitionOptions[r||\"\"]={}),null===e||void 0===e)delete this._paintTransitionOptions[r||\"\"][t];else{if(this._handleErrors(u.paintProperty,n,t,e))return;this._paintTransitionOptions[r||\"\"][t]=e}else if(this._paintDeclarations[r||\"\"]||(this._paintDeclarations[r||\"\"]={}),null===e||void 0===e)delete this._paintDeclarations[r||\"\"][t];else{if(this._handleErrors(u.paintProperty,n,t,e))return;this._paintDeclarations[r||\"\"][t]=new s(this._paintSpecifications[t],e)}},getPaintProperty:function(t,e){return e=e||\"\",a.endsWith(t,\"-transition\")?this._paintTransitionOptions[e]&&this._paintTransitionOptions[e][t]:this._paintDeclarations[e]&&this._paintDeclarations[e][t]&&this._paintDeclarations[e][t].value},getPaintValue:function(t,e,r){var n=this._paintSpecifications[t],i=this._paintTransitions[t];return i?i.calculate(e,r):\"color\"===n.type&&n.default?c(n.default):n.default},getPaintValueStopZoomLevels:function(t){var e=this._paintTransitions[t];return e?e.declaration.stopZoomLevels:[]},getPaintInterpolationT:function(t,e){return this._paintTransitions[t].declaration.calculateInterpolationT({zoom:e})},isPaintValueFeatureConstant:function(t){var e=this._paintTransitions[t];return!e||e.declaration.isFeatureConstant},isLayoutValueFeatureConstant:function(t){var e=this._layoutDeclarations[t];return!e||e.isFeatureConstant},isPaintValueZoomConstant:function(t){var e=this._paintTransitions[t];return!e||e.declaration.isZoomConstant},isHidden:function(t){return!!(this.minzoom&&t<this.minzoom)||(!!(this.maxzoom&&t>=this.maxzoom)||(\"none\"===this.layout.visibility||0===this.paint[this.type+\"-opacity\"]))},updatePaintTransitions:function(t,e,r,n){for(var i=a.extend({},this._paintDeclarations[\"\"]),o=0;o<t.length;o++)a.extend(i,this._paintDeclarations[t[o]]);var s;for(s in i)this._applyPaintDeclaration(s,i[s],e,r,n);for(s in this._paintTransitions)s in i||this._applyPaintDeclaration(s,null,e,r,n)},updatePaintTransition:function(t,e,r,n,i){for(var a=this._paintDeclarations[\"\"][t],o=0;o<e.length;o++){var s=this._paintDeclarations[e[o]];s&&s[t]&&(a=s[t])}this._applyPaintDeclaration(t,a,r,n,i)},recalculate:function(t,e){for(var r in this._paintTransitions)this.paint[r]=this.getPaintValue(r,{zoom:t,zoomHistory:e});for(var n in this._layoutFunctions)this.layout[n]=this.getLayoutValue(n,{zoom:t,zoomHistory:e})},serialize:function(t){var e={id:this.id,ref:this.ref,metadata:this.metadata,minzoom:this.minzoom,maxzoom:this.maxzoom};for(var r in this._paintDeclarations){e[\"\"===r?\"paint\":\"paint.\"+r]=a.mapObject(this._paintDeclarations[r],i)}return(!this.ref||t&&t.includeRefProperties)&&a.extend(e,{type:this.type,source:this.source,\"source-layer\":this.sourceLayer,filter:this.filter,layout:a.mapObject(this._layoutDeclarations,i)}),a.filterObject(e,function(t,e){return void 0!==t&&!(\"layout\"===e&&!Object.keys(t).length)})},_applyPaintDeclaration:function(t,e,r,n,i){var l=r.transition?this._paintTransitions[t]:void 0,u=this._paintSpecifications[t];if(null!==e&&void 0!==e||(e=new s(u,u.default)),!l||l.declaration.json!==e.json){var c=a.extend({duration:300,delay:0},n,this.getPaintProperty(t+\"-transition\")),h=this._paintTransitions[t]=new o(u,e,l,c);h.instant()||(h.loopID=i.set(h.endTime-Date.now())),l&&i.cancel(l.loopID)}},_updateLayoutValue:function(t){var e=this._layoutDeclarations[t];e&&e.isFunction?this._layoutFunctions[t]=!0:(delete this._layoutFunctions[t],this.layout[t]=this.getLayoutValue(t))},_handleErrors:function(t,e,r,n){return u.emitErrors(this,t.call(u,{key:e,layerType:this.type,objectKey:r,value:n,styleSpec:l,style:{glyphs:!0,sprite:!0}}))}})},{\"../util/evented\":433,\"../util/util\":441,\"./parse_color\":376,\"./style_declaration\":378,\"./style_layer/background_style_layer\":381,\"./style_layer/circle_style_layer\":382,\"./style_layer/fill_style_layer\":383,\"./style_layer/line_style_layer\":384,\"./style_layer/raster_style_layer\":385,\"./style_layer/symbol_style_layer\":386,\"./style_spec\":387,\"./style_transition\":388,\"./validate_style\":389}],381:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],382:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],383:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");n.prototype=i.inherit(a,{getPaintValue:function(t,e,r){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintValue.call(this,\"fill-color\",e,r):a.prototype.getPaintValue.call(this,t,e,r)},getPaintValueStopZoomLevels:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintValueStopZoomLevels.call(this,\"fill-color\"):a.prototype.getPaintValueStopZoomLevels.call(this,arguments)},getPaintInterpolationT:function(t,e){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintInterpolationT.call(this,\"fill-color\",e):a.prototype.getPaintInterpolationT.call(this,t,e)},isPaintValueFeatureConstant:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.isPaintValueFeatureConstant.call(this,\"fill-color\"):a.prototype.isPaintValueFeatureConstant.call(this,t)},isPaintValueZoomConstant:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.isPaintValueZoomConstant.call(this,\"fill-color\"):a.prototype.isPaintValueZoomConstant.call(this,t)}}),e.exports=n},{\"../../util/util\":441,\"../style_layer\":380}],384:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{getPaintValue:function(t,e,r){var n=a.prototype.getPaintValue.apply(this,arguments);if(n&&\"line-dasharray\"===t){var i=Math.floor(e.zoom);this._flooredZoom!==i&&(this._flooredZoom=i,this._flooredLineWidth=this.getPaintValue(\"line-width\",e,r)),n.fromScale*=this._flooredLineWidth,n.toScale*=this._flooredLineWidth}return n}})},{\"../../util/util\":441,\"../style_layer\":380}],385:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],386:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{isHidden:function(){if(a.prototype.isHidden.apply(this,arguments))return!0;var t=0===this.paint[\"text-opacity\"]||!this.layout[\"text-field\"],e=0===this.paint[\"icon-opacity\"]||!this.layout[\"icon-image\"];return!(!t||!e)},getLayoutValue:function(t,e,r){return(\"text-rotation-alignment\"!==t||\"line\"!==this.getLayoutValue(\"symbol-placement\",e,r)||this.getLayoutProperty(\"text-rotation-alignment\"))&&(\"icon-rotation-alignment\"!==t||\"line\"!==this.getLayoutValue(\"symbol-placement\",e,r)||this.getLayoutProperty(\"icon-rotation-alignment\"))?\"text-pitch-alignment\"!==t||this.getLayoutProperty(\"text-pitch-alignment\")?a.prototype.getLayoutValue.apply(this,arguments):this.getLayoutValue(\"text-rotation-alignment\"):\"map\"}})},{\"../../util/util\":441,\"../style_layer\":380}],387:[function(t,e,r){\"use strict\";e.exports=t(\"mapbox-gl-style-spec/reference/latest.min\")},{\"mapbox-gl-style-spec/reference/latest.min\":324}],388:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.declaration=e,this.startTime=this.endTime=(new Date).getTime(),\"piecewise-constant\"===t.function&&t.transition?this.interp=i:this.interp=o[t.type],this.oldTransition=r,this.duration=n.duration||0,this.delay=n.delay||0,this.instant()||(this.endTime=this.startTime+this.duration+this.delay,this.ease=a.easeCubicInOut),r&&r.endTime<=this.startTime&&delete r.oldTransition}function i(t,e,r){return void 0===(t&&t.to)||void 0===(e&&e.to)?void 0:{from:t.to,fromScale:t.toScale,to:e.to,toScale:e.toScale,t:r}}var a=t(\"../util/util\"),o=t(\"../util/interpolate\");e.exports=n,n.prototype.instant=function(){return!this.oldTransition||!this.interp||0===this.duration&&0===this.delay},n.prototype.calculate=function(t,e){var r=this.declaration.calculate(a.extend({},t,{duration:this.duration}),e);if(this.instant())return r;var n=t.time||Date.now();if(n<this.endTime){var i=this.oldTransition.calculate(a.extend({},t,{time:this.startTime}),e),o=this.ease((n-this.startTime-this.delay)/this.duration);r=this.interp(i,r,o)}return r}},{\"../util/interpolate\":435,\"../util/util\":441}],389:[function(t,e,r){\"use strict\";e.exports=t(\"mapbox-gl-style-spec/lib/validate_style.min\"),e.exports.emitErrors=function(t,e){if(e&&e.length){for(var r=0;r<e.length;r++)t.fire(\"error\",{error:new Error(e[r].message)});return!0}return!1},e.exports.throwErrors=function(t,e){if(e)for(var r=0;r<e.length;r++)throw new Error(e[r].message)}},{\"mapbox-gl-style-spec/lib/validate_style.min\":323}],390:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.x=t,this.y=e,this.angle=r,void 0!==n&&(this.segment=n)}var i=t(\"point-geometry\");e.exports=n,n.prototype=Object.create(i.prototype),n.prototype.clone=function(){return new n(this.x,this.y,this.angle,this.segment)}},{\"point-geometry\":483}],391:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){if(void 0===e.segment)return!0;for(var a=e,o=e.segment+1,s=0;s>-r/2;){if(--o<0)return!1;s-=t[o].dist(a),a=t[o]}s+=t[o].dist(t[o+1]),o++;for(var l=[],u=0;s<r/2;){var c=t[o-1],h=t[o],f=t[o+1];if(!f)return!1;var d=c.angleTo(h)-h.angleTo(f);for(d=Math.abs((d+3*Math.PI)%(2*Math.PI)-Math.PI),l.push({distance:s,angleDelta:d}),u+=d;s-l[0].distance>n;)u-=l.shift().angleDelta;if(u>i)return!1;o++,s+=h.dist(f)}return!0}e.exports=n},{}],392:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){for(var o=[],s=0;s<t.length;s++)for(var l,u=t[s],c=0;c<u.length-1;c++){var h=u[c],f=u[c+1];h.x<e&&f.x<e||(h.x<e?h=new i(e,h.y+(f.y-h.y)*((e-h.x)/(f.x-h.x)))._round():f.x<e&&(f=new i(e,h.y+(f.y-h.y)*((e-h.x)/(f.x-h.x)))._round()),h.y<r&&f.y<r||(h.y<r?h=new i(h.x+(f.x-h.x)*((r-h.y)/(f.y-h.y)),r)._round():f.y<r&&(f=new i(h.x+(f.x-h.x)*((r-h.y)/(f.y-h.y)),r)._round()),h.x>=n&&f.x>=n||(h.x>=n?h=new i(n,h.y+(f.y-h.y)*((n-h.x)/(f.x-h.x)))._round():f.x>=n&&(f=new i(n,h.y+(f.y-h.y)*((n-h.x)/(f.x-h.x)))._round()),h.y>=a&&f.y>=a||(h.y>=a?h=new i(h.x+(f.x-h.x)*((a-h.y)/(f.y-h.y)),a)._round():f.y>=a&&(f=new i(h.x+(f.x-h.x)*((a-h.y)/(f.y-h.y)),a)._round()),l&&h.equals(l[l.length-1])||(l=[h],o.push(l)),l.push(f)))))}return o}var i=t(\"point-geometry\");e.exports=n},{\"point-geometry\":483}],393:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=e.exports=new n({members:[{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Int16\",name:\"x1\"},{type:\"Int16\",name:\"y1\"},{type:\"Int16\",name:\"x2\"},{type:\"Int16\",name:\"y2\"},{type:\"Float32\",name:\"maxScale\"},{type:\"Uint32\",name:\"featureIndex\"},{type:\"Uint16\",name:\"sourceLayerIndex\"},{type:\"Uint16\",name:\"bucketIndex\"},{type:\"Int16\",name:\"bbox0\"},{type:\"Int16\",name:\"bbox1\"},{type:\"Int16\",name:\"bbox2\"},{type:\"Int16\",name:\"bbox3\"},{type:\"Float32\",name:\"placementScale\"}]});i.extendAll(o.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"point-geometry\":483}],394:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u,c){var h=o.top*s-l,f=o.bottom*s+l,d=o.left*s-l,p=o.right*s+l;if(this.boxStartIndex=t.length,u){var m=f-h,v=p-d;if(m>0)if(m=Math.max(10*s,m),c){var g=e[r.segment+1].sub(e[r.segment])._unit()._mult(v),y=[r.sub(g),r.add(g)];this._addLineCollisionBoxes(t,y,r,0,v,m,n,i,a)}else this._addLineCollisionBoxes(t,e,r,r.segment,v,m,n,i,a)}else t.emplaceBack(r.x,r.y,d,h,p,f,1/0,n,i,a,0,0,0,0,0);this.boxEndIndex=t.length}e.exports=n,n.prototype._addLineCollisionBoxes=function(t,e,r,n,i,a,o,s,l){var u=a/2,c=Math.floor(i/u),h=-a/2,f=this.boxes,d=r,p=n+1,m=h;do{if(--p<0)return f;m-=e[p].dist(d),d=e[p]}while(m>-i/2);for(var v=e[p].dist(e[p+1]),g=0;g<c;g++){for(var y=-i/2+g*u;m+v<y;){if(m+=v,++p+1>=e.length)return f;v=e[p].dist(e[p+1])}var b=y-m,x=e[p],_=e[p+1],w=_.sub(x)._unit()._mult(b)._add(x)._round(),M=Math.max(Math.abs(y-h)-u/2,0),k=i/2/M;t.emplaceBack(w.x,w.y,-a/2,-a/2,a/2,a/2,k,o,s,l,0,0,0,0,0)}return f}},{}],395:[function(t,e,r){\"use strict\";function n(t,e,r){if(\"object\"==typeof t){var n=t;r=e,t=n.angle,e=n.pitch,this.grid=new o(n.grid),this.ignoredGrid=new o(n.ignoredGrid)}else this.grid=new o(a,12,6),this.ignoredGrid=new o(a,12,0);this.angle=t,this.pitch=e;var i=Math.sin(t),s=Math.cos(t);if(this.rotationMatrix=[s,-i,i,s],this.reverseRotationMatrix=[s,i,-i,s],this.yStretch=1/Math.cos(e/180*Math.PI),this.yStretch=Math.pow(this.yStretch,1.3),this.collisionBoxArray=r,0===r.length){r.emplaceBack();r.emplaceBack(0,0,0,-32767,0,32767,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(a,0,0,-32767,0,32767,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(0,0,-32767,0,32767,0,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(0,a,-32767,0,32767,0,32767,0,0,0,0,0,0,0,0,0)}this.tempCollisionBox=r.get(0),this.edges=[r.get(1),r.get(2),r.get(3),r.get(4)]}var i=t(\"point-geometry\"),a=t(\"../data/bucket\").EXTENT,o=t(\"grid-index\");e.exports=n,n.prototype.serialize=function(){var t={angle:this.angle,pitch:this.pitch,grid:this.grid.toArrayBuffer(),ignoredGrid:this.ignoredGrid.toArrayBuffer()};return{data:t,transferables:[t.grid,t.ignoredGrid]}},n.prototype.minScale=.25,n.prototype.maxScale=2,n.prototype.placeCollisionFeature=function(t,e,r){for(var n=this.collisionBoxArray,a=this.minScale,o=this.rotationMatrix,s=this.yStretch,l=t.boxStartIndex;l<t.boxEndIndex;l++){var u=n.get(l),c=u.anchorPoint._matMult(o),h=c.x,f=c.y,d=h+u.x1,p=f+u.y1*s,m=h+u.x2,v=f+u.y2*s;if(u.bbox0=d,u.bbox1=p,u.bbox2=m,u.bbox3=v,!e)for(var g=this.grid.query(d,p,m,v),y=0;y<g.length;y++){var b=n.get(g[y]),x=b.anchorPoint._matMult(o);if((a=this.getPlacementScale(a,c,u,x,b))>=this.maxScale)return a}if(r){var _;if(this.angle){var w=this.reverseRotationMatrix,M=new i(u.x1,u.y1).matMult(w),k=new i(u.x2,u.y1).matMult(w),A=new i(u.x1,u.y2).matMult(w),T=new i(u.x2,u.y2).matMult(w);_=this.tempCollisionBox,_.anchorPointX=u.anchorPoint.x,_.anchorPointY=u.anchorPoint.y,_.x1=Math.min(M.x,k.x,A.x,T.x),_.y1=Math.min(M.y,k.x,A.x,T.x),_.x2=Math.max(M.x,k.x,A.x,T.x),_.y2=Math.max(M.y,k.x,A.x,T.x),_.maxScale=u.maxScale}else _=u;for(var S=0;S<this.edges.length;S++){var E=this.edges[S];if((a=this.getPlacementScale(a,u.anchorPoint,_,E.anchorPoint,E))>=this.maxScale)return a}}}return a},n.prototype.queryRenderedSymbols=function(t,e,r,n,a){var o={},s=[],l=this.collisionBoxArray,u=this.rotationMatrix,c=new i(t,e)._matMult(u),h=this.tempCollisionBox;h.anchorX=c.x,h.anchorY=c.y,h.x1=0,h.y1=0,h.x2=r-t,h.y2=n-e,h.maxScale=a,a=h.maxScale;for(var f=[c.x+h.x1/a,c.y+h.y1/a*this.yStretch,c.x+h.x2/a,c.y+h.y2/a*this.yStretch],d=this.grid.query(f[0],f[1],f[2],f[3]),p=this.ignoredGrid.query(f[0],f[1],f[2],f[3]),m=0;m<p.length;m++)d.push(p[m]);for(var v=0;v<d.length;v++){var g=l.get(d[v]),y=g.sourceLayerIndex,b=g.featureIndex;if(void 0===o[y]&&(o[y]={}),!o[y][b]){var x=g.anchorPoint.matMult(u);this.getPlacementScale(this.minScale,c,h,x,g)>=a&&(o[y][b]=!0,s.push(d[v]))}}return s},n.prototype.getPlacementScale=function(t,e,r,n,i){var a=e.x-n.x,o=e.y-n.y,s=(i.x1-r.x2)/a,l=(i.x2-r.x1)/a,u=(i.y1-r.y2)*this.yStretch/o,c=(i.y2-r.y1)*this.yStretch/o;(isNaN(s)||isNaN(l))&&(s=l=1),(isNaN(u)||isNaN(c))&&(u=c=1);var h=Math.min(Math.max(s,l),Math.max(u,c)),f=i.maxScale,d=r.maxScale;return h>f&&(h=f),h>d&&(h=d),h>t&&h>=i.placementScale&&(t=h),t},n.prototype.insertCollisionFeature=function(t,e,r){for(var n=r?this.ignoredGrid:this.grid,i=this.collisionBoxArray,a=t.boxStartIndex;a<t.boxEndIndex;a++){var o=i.get(a);o.placementScale=e,e<this.maxScale&&n.insert(a,o.bbox0,o.bbox1,o.bbox2,o.bbox3)}}},{\"../data/bucket\":328,\"grid-index\":286,\"point-geometry\":483}],396:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o,s,l,u){var c=n?.6*o*s:0,h=Math.max(n?n.right-n.left:0,a?a.right-a.left:0),f=0===t[0].x||t[0].x===u||0===t[0].y||t[0].y===u;e-h*s<e/4&&(e=h*s+e/4);var d=2*o;return i(t,f?e/2*l%e:(h/2+d)*s*l%e,e,c,r,h*s,f,!1,u)}function i(t,e,r,n,l,u,c,h,f){for(var d=u/2,p=0,m=0;m<t.length-1;m++)p+=t[m].dist(t[m+1]);for(var v=0,g=e-r,y=[],b=0;b<t.length-1;b++){for(var x=t[b],_=t[b+1],w=x.dist(_),M=_.angleTo(x);g+r<v+w;){g+=r;var k=(g-v)/w,A=a(x.x,_.x,k),T=a(x.y,_.y,k);if(A>=0&&A<f&&T>=0&&T<f&&g-d>=0&&g+d<=p){var S=new o(A,T,M,b)._round();n&&!s(t,S,u,n,l)||y.push(S)}}v+=w}return h||y.length||c||(y=i(t,v/2,r,n,l,u,c,!0,f)),y}var a=t(\"../util/interpolate\"),o=t(\"../symbol/anchor\"),s=t(\"./check_max_angle\");e.exports=n},{\"../symbol/anchor\":390,\"../util/interpolate\":435,\"./check_max_angle\":391}],397:[function(t,e,r){\"use strict\";function n(){this.width=o,this.height=o,this.bin=new i(this.width,this.height),this.index={},this.ids={},this.data=new Uint8Array(this.width*this.height)}var i=t(\"shelf-pack\"),a=t(\"../util/util\"),o=128;e.exports=n,n.prototype.getGlyphs=function(){var t,e,r,n={};for(var i in this.ids)t=i.split(\"#\"),e=t[0],r=t[1],n[e]||(n[e]=[]),n[e].push(r);return n},n.prototype.getRects=function(){var t,e,r,n={};for(var i in this.ids)t=i.split(\"#\"),e=t[0],r=t[1],n[e]||(n[e]={}),n[e][r]=this.index[i];return n},n.prototype.addGlyph=function(t,e,r,n){if(!r)return null;var i=e+\"#\"+r.id;if(this.index[i])return this.ids[i].indexOf(t)<0&&this.ids[i].push(t),this.index[i];if(!r.bitmap)return null;var o=r.width+2*n,s=r.height+2*n,l=o+2,u=s+2;l+=4-l%4,u+=4-u%4;var c=this.bin.packOne(l,u);if(c||(this.resize(),c=this.bin.packOne(l,u)),!c)return a.warnOnce(\"glyph bitmap overflow\"),null;this.index[i]=c,this.ids[i]=[t];for(var h=this.data,f=r.bitmap,d=0;d<s;d++)for(var p=this.width*(c.y+d+1)+c.x+1,m=o*d,v=0;v<o;v++)h[p+v]=f[m+v];return this.dirty=!0,c},n.prototype.resize=function(){var t=this.width,e=this.height;if(!(t>=2048||e>=2048)){this.texture&&(this.gl&&this.gl.deleteTexture(this.texture),this.texture=null),this.width*=4,this.height*=4,this.bin.resize(this.width,this.height);for(var r=new ArrayBuffer(this.width*this.height),n=0;n<e;n++){var i=new Uint8Array(this.data.buffer,e*n,t);new Uint8Array(r,e*n*4,t).set(i)}this.data=new Uint8Array(r)}},n.prototype.bind=function(t){this.gl=t,this.texture?t.bindTexture(t.TEXTURE_2D,this.texture):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texImage2D(t.TEXTURE_2D,0,t.ALPHA,this.width,this.height,0,t.ALPHA,t.UNSIGNED_BYTE,null))},n.prototype.updateTexture=function(t){this.bind(t),this.dirty&&(t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width,this.height,t.ALPHA,t.UNSIGNED_BYTE,this.data),this.dirty=!1)}},{\"../util/util\":441,\"shelf-pack\":513}],398:[function(t,e,r){\"use strict\";function n(t){this.url=t&&o(t),this.atlases={},this.stacks={},this.loading={}}function i(t,e,r){this.advance=t.advance,this.left=t.left-r-1,this.top=t.top+r+1,this.rect=e}function a(t,e,r,n){return n=n||\"abc\",r.replace(\"{s}\",n[t.length%n.length]).replace(\"{fontstack}\",t).replace(\"{range}\",e)}var o=t(\"../util/mapbox\").normalizeGlyphsURL,s=t(\"../util/ajax\").getArrayBuffer,l=t(\"../util/glyphs\"),u=t(\"../symbol/glyph_atlas\"),c=t(\"pbf\");e.exports=n,n.prototype.getSimpleGlyphs=function(t,e,r,n){void 0===this.stacks[t]&&(this.stacks[t]={}),void 0===this.atlases[t]&&(this.atlases[t]=new u);for(var a,o={},s=this.stacks[t],l=this.atlases[t],c={},h=0,f=0;f<e.length;f++){var d=e[f];if(a=Math.floor(d/256),s[a]){var p=s[a].glyphs[d],m=l.addGlyph(r,t,p,3);p&&(o[d]=new i(p,m,3))}else void 0===c[a]&&(c[a]=[],h++),c[a].push(d)}h||n(void 0,o,t);var v=function(e,a,s){if(!e)for(var u=this.stacks[t][a]=s.stacks[0],f=0;f<c[a].length;f++){var d=c[a][f],p=u.glyphs[d],m=l.addGlyph(r,t,p,3);p&&(o[d]=new i(p,m,3))}--h||n(void 0,o,t)}.bind(this);for(var g in c)this.loadRange(t,g,v)},n.prototype.loadRange=function(t,e,r){if(256*e>65535)return r(\"glyphs > 65535 not supported\");void 0===this.loading[t]&&(this.loading[t]={});var n=this.loading[t];if(n[e])n[e].push(r);else{n[e]=[r];var i=256*e+\"-\"+(256*e+255),o=a(t,i,this.url);s(o,function(t,r){for(var i=!t&&new l(new c(new Uint8Array(r))),a=0;a<n[e].length;a++)n[e][a](t,e,i);delete n[e]})}},n.prototype.getGlyphAtlas=function(t){return this.atlases[t]}},{\"../symbol/glyph_atlas\":397,\"../util/ajax\":424,\"../util/glyphs\":434,\"../util/mapbox\":438,pbf:477}],399:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){function n(n){c.push(t[n]),h.push(r[n]),f.push(e[n]),d++}function i(t,e,r){var n=u[t];return delete u[t],u[e]=n,h[n][0].pop(),h[n][0]=h[n][0].concat(r[0]),n}function a(t,e,r){var n=l[e];return delete l[e],l[t]=n,h[n][0].shift(),h[n][0]=r[0].concat(h[n][0]),n}function o(t,e,r){var n=r?e[0][e[0].length-1]:e[0][0];return t+\":\"+n.x+\":\"+n.y}var s,l={},u={},c=[],h=[],f=[],d=0;for(s=0;s<t.length;s++){var p=r[s],m=e[s];if(m){var v=o(m,p),g=o(m,p,!0);if(v in u&&g in l&&u[v]!==l[g]){var y=a(v,g,p),b=i(v,g,h[y]);delete l[v],delete u[g],u[o(m,h[b],!0)]=b,h[y]=null}else v in u?i(v,g,p):g in l?a(v,g,p):(n(s),l[v]=d-1,u[g]=d-1)}else n(s)}return{features:c,textFeatures:f,geometries:h}}},{}],400:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u){this.anchorPoint=t,this.tl=e,this.tr=r,this.bl=n,this.br=i,this.tex=a,this.anchorAngle=o,this.glyphAngle=s,this.minScale=l,this.maxScale=u}function i(t,e,r,i,a,o,u,c,h){var f,d,p,m,v=e.image.rect,g=a.layout,y=e.left-1,b=y+v.w/e.image.pixelRatio,x=e.top-1,_=x+v.h/e.image.pixelRatio;if(\"none\"!==g[\"icon-text-fit\"]&&u){var w=b-y,M=_-x,k=g[\"text-size\"]/24,A=u.left*k,T=u.right*k,S=u.top*k,E=u.bottom*k,L=T-A,C=E-S,z=g[\"icon-text-fit-padding\"][0],I=g[\"icon-text-fit-padding\"][1],D=g[\"icon-text-fit-padding\"][2],P=g[\"icon-text-fit-padding\"][3],O=\"width\"===g[\"icon-text-fit\"]?.5*(C-M):0,R=\"height\"===g[\"icon-text-fit\"]?.5*(L-w):0,F=\"width\"===g[\"icon-text-fit\"]||\"both\"===g[\"icon-text-fit\"]?L:w,j=\"height\"===g[\"icon-text-fit\"]||\"both\"===g[\"icon-text-fit\"]?C:M;f=new s(A+R-P,S+O-z),d=new s(A+R+I+F,S+O-z),p=new s(A+R+I+F,S+O+D+j),m=new s(A+R-P,S+O+D+j)}else f=new s(y,x),d=new s(b,x),p=new s(b,_),m=new s(y,_);var N=a.getLayoutValue(\"icon-rotate\",c,h)*Math.PI/180;if(o){var B=i[t.segment];if(t.y===B.y&&t.x===B.x&&t.segment+1<i.length){var U=i[t.segment+1];N+=Math.atan2(t.y-U.y,t.x-U.x)+Math.PI}else N+=Math.atan2(t.y-B.y,t.x-B.x)}if(N){var V=Math.sin(N),H=Math.cos(N),q=[H,-V,V,H];f=f.matMult(q),d=d.matMult(q),m=m.matMult(q),p=p.matMult(q)}return[new n(new s(t.x,t.y),f,d,m,p,e.image.rect,0,0,l,1/0)]}function a(t,e,r,i,a,u){for(var c=a.layout[\"text-rotate\"]*Math.PI/180,h=a.layout[\"text-keep-upright\"],f=e.positionedGlyphs,d=[],p=0;p<f.length;p++){var m=f[p],v=m.glyph,g=v.rect;if(g){var y,b=(m.x+v.advance/2)*r,x=l;u?(y=[],x=o(y,t,b,i,t.segment,!0),h&&(x=Math.min(x,o(y,t,b,i,t.segment,!1)))):y=[{anchorPoint:new s(t.x,t.y),offset:0,angle:0,maxScale:1/0,minScale:l}];for(var _=m.x+v.left,w=m.y-v.top,M=_+g.w,k=w+g.h,A=new s(_,w),T=new s(M,w),S=new s(_,k),E=new s(M,k),L=0;L<y.length;L++){var C=y[L],z=A,I=T,D=S,P=E;if(c){var O=Math.sin(c),R=Math.cos(c),F=[R,-O,O,R];z=z.matMult(F),I=I.matMult(F),D=D.matMult(F),P=P.matMult(F)}var j=Math.max(C.minScale,x),N=(t.angle+C.offset+2*Math.PI)%(2*Math.PI),B=(C.angle+C.offset+2*Math.PI)%(2*Math.PI);d.push(new n(C.anchorPoint,z,I,D,P,g,N,B,j,C.maxScale))}}}return d}function o(t,e,r,n,i,a){var o=!a;r<0&&(a=!a),a&&i++;var u=new s(e.x,e.y),c=n[i],h=1/0;r=Math.abs(r);for(var f=l;;){var d=u.dist(c),p=r/d,m=Math.atan2(c.y-u.y,c.x-u.x);if(a||(m+=Math.PI),t.push({anchorPoint:u,offset:o?Math.PI:0,minScale:p,maxScale:h,angle:(m+2*Math.PI)%(2*Math.PI)}),p<=f)break;for(u=c;u.equals(c);)if(i+=a?1:-1,!(c=n[i]))return p;var v=c.sub(u)._unit();u=u.sub(v._mult(d)),h=p}return f}var s=t(\"point-geometry\");e.exports={getIconQuads:i,getGlyphQuads:a,SymbolQuad:n};var l=.5},{\"point-geometry\":483}],401:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=[],a=0,o=t.length;a<o;a++){var s=i(t[a].properties,e[\"text-field\"]);if(s){s=s.toString();var l=e[\"text-transform\"];\"uppercase\"===l?s=s.toLocaleUpperCase():\"lowercase\"===l&&(s=s.toLocaleLowerCase());for(var u=0;u<s.length;u++)r[s.charCodeAt(u)]=!0;n[a]=s}else n[a]=null}return n}var i=t(\"../util/token\");e.exports=n},{\"../util/token\":440}],402:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.codePoint=t,this.x=e,this.y=r,this.glyph=n}function i(t,e,r,n,i,a){this.positionedGlyphs=t,this.text=e,this.top=r,this.bottom=n,this.left=i,this.right=a}function a(t,e,r,a,s,l,u,c,h){for(var f=[],d=new i(f,t,h[1],h[1],h[0],h[0]),p=0,m=0;m<t.length;m++){var v=t.charCodeAt(m),g=e[v];g&&(f.push(new n(v,p,-17,g)),p+=g.advance+c)}return!!f.length&&(o(d,e,a,r,s,l,u,h),d)}function o(t,e,r,n,i,a,o,u){var c=null,d=0,p=0,m=0,v=0,g=t.positionedGlyphs;if(n)for(var y=0;y<g.length;y++){var b=g[y];if(b.x-=d,b.y+=r*m,b.x>n&&null!==c){var x=g[c+1].x;v=Math.max(x,v);for(var _=c+1;_<=y;_++)g[_].y+=r,g[_].x-=x;if(o){var w=c;h[g[c].codePoint]&&w--,s(g,e,p,w,o)}p=c+1,c=null,d+=x,m++}f[b.codePoint]&&(c=y)}var M=g[g.length-1],k=M.x+e[M.codePoint].advance;v=Math.max(v,k);var A=(m+1)*r;s(g,e,p,g.length-1,o),l(g,o,i,a,v,r,m,u),t.top+=-a*A,t.bottom=t.top+A,t.left+=-i*v,t.right=t.left+v}function s(t,e,r,n,i){for(var a=e[t[n].codePoint].advance,o=(t[n].x+a)*i,s=r;s<=n;s++)t[s].x-=o}\n",
       "function l(t,e,r,n,i,a,o,s){for(var l=(e-r)*i+s[0],u=(-n*(o+1)+.5)*a+s[1],c=0;c<t.length;c++)t[c].x+=l,t[c].y+=u}function u(t,e){if(!t||!t.rect)return null;var r=e[\"icon-offset\"][0],n=e[\"icon-offset\"][1],i=r-t.width/2,a=i+t.width,o=n-t.height/2;return new c(t,o,o+t.height,i,a)}function c(t,e,r,n,i){this.image=t,this.top=e,this.bottom=r,this.left=n,this.right=i}e.exports={shapeText:a,shapeIcon:u};var h={32:!0,8203:!0},f={32:!0,38:!0,43:!0,45:!0,47:!0,173:!0,183:!0,8203:!0,8208:!0,8211:!0}},{}],403:[function(t,e,r){\"use strict\";function n(t,e){this.width=t,this.height=e,this.bin=new o(t,e),this.images={},this.data=!1,this.texture=0,this.filter=0,this.pixelRatio=1,this.dirty=!0}function i(t,e,r,n,i,a,o,s,l,u,c){var h,f,d=n*e+r,p=s*a+o;if(c)for(p-=a,f=-1;f<=u;f++,d=((f+u)%u+n)*e+r,p+=a)for(h=-1;h<=l;h++)i[p+h]=t[d+(h+l)%l];else for(f=0;f<u;f++,d+=e,p+=a)for(h=0;h<l;h++)i[p+h]=t[d+h]}function a(t,e,r,n,i){this.rect=t,this.width=e,this.height=r,this.sdf=n,this.pixelRatio=i}var o=t(\"shelf-pack\"),s=t(\"../util/browser\"),l=t(\"../util/util\");e.exports=n,n.prototype.allocateImage=function(t,e){t/=this.pixelRatio,e/=this.pixelRatio;var r=t+2+(4-(t+2)%4),n=e+2+(4-(e+2)%4),i=this.bin.packOne(r,n);return i||(l.warnOnce(\"SpriteAtlas out of space.\"),null)},n.prototype.getImage=function(t,e){if(this.images[t])return this.images[t];if(!this.sprite)return null;var r=this.sprite.getSpritePosition(t);if(!r.width||!r.height)return null;var n=this.allocateImage(r.width,r.height);if(!n)return null;var i=new a(n,r.width/r.pixelRatio,r.height/r.pixelRatio,r.sdf,r.pixelRatio/this.pixelRatio);return this.images[t]=i,this.copy(n,r,e),i},n.prototype.getPosition=function(t,e){var r=this.getImage(t,e),n=r&&r.rect;if(!n)return null;var i=r.width*r.pixelRatio,a=r.height*r.pixelRatio;return{size:[r.width,r.height],tl:[(n.x+1)/this.width,(n.y+1)/this.height],br:[(n.x+1+i)/this.width,(n.y+1+a)/this.height]}},n.prototype.allocate=function(){if(!this.data){var t=Math.floor(this.width*this.pixelRatio),e=Math.floor(this.height*this.pixelRatio);this.data=new Uint32Array(t*e);for(var r=0;r<this.data.length;r++)this.data[r]=0}},n.prototype.copy=function(t,e,r){if(this.sprite.img.data){var n=new Uint32Array(this.sprite.img.data.buffer);this.allocate();var a=this.data;i(n,this.sprite.img.width,e.x,e.y,a,this.width*this.pixelRatio,(t.x+1)*this.pixelRatio,(t.y+1)*this.pixelRatio,e.width,e.height,r),this.dirty=!0}},n.prototype.setSprite=function(t){t&&(this.pixelRatio=s.devicePixelRatio>1?2:1,this.canvas&&(this.canvas.width=this.width*this.pixelRatio,this.canvas.height=this.height*this.pixelRatio)),this.sprite=t},n.prototype.addIcons=function(t,e){for(var r=0;r<t.length;r++)this.getImage(t[r]);e(null,this.images)},n.prototype.bind=function(t,e){var r=!1;this.texture?t.bindTexture(t.TEXTURE_2D,this.texture):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),r=!0);var n=e?t.LINEAR:t.NEAREST;n!==this.filter&&(t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,n),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,n),this.filter=n),this.dirty&&(this.allocate(),r?t.texImage2D(t.TEXTURE_2D,0,t.RGBA,this.width*this.pixelRatio,this.height*this.pixelRatio,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array(this.data.buffer)):t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width*this.pixelRatio,this.height*this.pixelRatio,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array(this.data.buffer)),this.dirty=!1)}},{\"../util/browser\":425,\"../util/util\":441,\"shelf-pack\":513}],404:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=e.exports=new n({members:[{type:\"Uint16\",name:\"textBoxStartIndex\"},{type:\"Uint16\",name:\"textBoxEndIndex\"},{type:\"Uint16\",name:\"iconBoxStartIndex\"},{type:\"Uint16\",name:\"iconBoxEndIndex\"},{type:\"Uint16\",name:\"glyphQuadStartIndex\"},{type:\"Uint16\",name:\"glyphQuadEndIndex\"},{type:\"Uint16\",name:\"iconQuadStartIndex\"},{type:\"Uint16\",name:\"iconQuadEndIndex\"},{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Int8\",name:\"index\"}]});i.extendAll(o.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"point-geometry\":483}],405:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=t(\"./quads\").SymbolQuad,s=e.exports=new n({members:[{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Float32\",name:\"tlX\"},{type:\"Float32\",name:\"tlY\"},{type:\"Float32\",name:\"trX\"},{type:\"Float32\",name:\"trY\"},{type:\"Float32\",name:\"blX\"},{type:\"Float32\",name:\"blY\"},{type:\"Float32\",name:\"brX\"},{type:\"Float32\",name:\"brY\"},{type:\"Int16\",name:\"texH\"},{type:\"Int16\",name:\"texW\"},{type:\"Int16\",name:\"texX\"},{type:\"Int16\",name:\"texY\"},{type:\"Float32\",name:\"anchorAngle\"},{type:\"Float32\",name:\"glyphAngle\"},{type:\"Float32\",name:\"maxScale\"},{type:\"Float32\",name:\"minScale\"}]});i.extendAll(s.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)},get SymbolQuad(){return new o(this.anchorPoint,new a(this.tlX,this.tlY),new a(this.trX,this.trY),new a(this.blX,this.blY),new a(this.brX,this.brY),{x:this.texX,y:this.texY,h:this.texH,w:this.texW,height:this.texH,width:this.texW},this.anchorAngle,this.glyphAngle,this.minScale,this.maxScale)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"./quads\":400,\"point-geometry\":483}],406:[function(t,e,r){\"use strict\";var n=t(\"../util/dom\"),i=t(\"point-geometry\"),a={scrollZoom:t(\"./handler/scroll_zoom\"),boxZoom:t(\"./handler/box_zoom\"),dragRotate:t(\"./handler/drag_rotate\"),dragPan:t(\"./handler/drag_pan\"),keyboard:t(\"./handler/keyboard\"),doubleClickZoom:t(\"./handler/dblclick_zoom\"),touchZoomRotate:t(\"./handler/touch_zoom_rotate\")};e.exports=function(t,e){function r(t){g(\"mouseout\",t)}function o(e){t.stop(),_=n.mousePos(b,e),g(\"mousedown\",e)}function s(e){var r=t.dragRotate&&t.dragRotate.isActive();x&&!r&&g(\"contextmenu\",x),x=null,g(\"mouseup\",e)}function l(e){if(!(t.dragPan&&t.dragPan.isActive()||t.dragRotate&&t.dragRotate.isActive())){for(var r=e.toElement||e.target;r&&r!==b;)r=r.parentNode;r===b&&g(\"mousemove\",e)}}function u(e){t.stop(),y(\"touchstart\",e),!e.touches||e.touches.length>1||(w?(clearTimeout(w),w=null,g(\"dblclick\",e)):w=setTimeout(d,300))}function c(t){y(\"touchmove\",t)}function h(t){y(\"touchend\",t)}function f(t){y(\"touchcancel\",t)}function d(){w=null}function p(t){n.mousePos(b,t).equals(_)&&g(\"click\",t)}function m(t){g(\"dblclick\",t),t.preventDefault()}function v(t){x=t,t.preventDefault()}function g(e,r){var i=n.mousePos(b,r);return t.fire(e,{lngLat:t.unproject(i),point:i,originalEvent:r})}function y(e,r){var a=n.touchPos(b,r),o=a.reduce(function(t,e,r,n){return t.add(e.div(n.length))},new i(0,0));return t.fire(e,{lngLat:t.unproject(o),point:o,lngLats:a.map(function(e){return t.unproject(e)},this),points:a,originalEvent:r})}var b=t.getCanvasContainer(),x=null,_=null,w=null;for(var M in a)t[M]=new a[M](t,e),e.interactive&&e[M]&&t[M].enable();b.addEventListener(\"mouseout\",r,!1),b.addEventListener(\"mousedown\",o,!1),b.addEventListener(\"mouseup\",s,!1),b.addEventListener(\"mousemove\",l,!1),b.addEventListener(\"touchstart\",u,!1),b.addEventListener(\"touchend\",h,!1),b.addEventListener(\"touchmove\",c,!1),b.addEventListener(\"touchcancel\",f,!1),b.addEventListener(\"click\",p,!1),b.addEventListener(\"dblclick\",m,!1),b.addEventListener(\"contextmenu\",v,!1)}},{\"../util/dom\":427,\"./handler/box_zoom\":412,\"./handler/dblclick_zoom\":413,\"./handler/drag_pan\":414,\"./handler/drag_rotate\":415,\"./handler/keyboard\":416,\"./handler/scroll_zoom\":417,\"./handler/touch_zoom_rotate\":418,\"point-geometry\":483}],407:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i=t(\"../util/interpolate\"),a=t(\"../util/browser\"),o=t(\"../geo/lng_lat\"),s=t(\"../geo/lng_lat_bounds\"),l=t(\"point-geometry\"),u=e.exports=function(){};n.extend(u.prototype,{getCenter:function(){return this.transform.center},setCenter:function(t,e){return this.jumpTo({center:t},e),this},panBy:function(t,e,r){return this.panTo(this.transform.center,n.extend({offset:l.convert(t).mult(-1)},e),r),this},panTo:function(t,e,r){return this.easeTo(n.extend({center:t},e),r)},getZoom:function(){return this.transform.zoom},setZoom:function(t,e){return this.jumpTo({zoom:t},e),this},zoomTo:function(t,e,r){return this.easeTo(n.extend({zoom:t},e),r)},zoomIn:function(t,e){return this.zoomTo(this.getZoom()+1,t,e),this},zoomOut:function(t,e){return this.zoomTo(this.getZoom()-1,t,e),this},getBearing:function(){return this.transform.bearing},setBearing:function(t,e){return this.jumpTo({bearing:t},e),this},rotateTo:function(t,e,r){return this.easeTo(n.extend({bearing:t},e),r)},resetNorth:function(t,e){return this.rotateTo(0,n.extend({duration:1e3},t),e),this},snapToNorth:function(t,e){return Math.abs(this.getBearing())<this._bearingSnap?this.resetNorth(t,e):this},getPitch:function(){return this.transform.pitch},setPitch:function(t,e){return this.jumpTo({pitch:t},e),this},fitBounds:function(t,e,r){e=n.extend({padding:0,offset:[0,0],maxZoom:1/0},e),t=s.convert(t);var i=l.convert(e.offset),a=this.transform,o=a.project(t.getNorthWest()),u=a.project(t.getSouthEast()),c=u.sub(o),h=(a.width-2*e.padding-2*Math.abs(i.x))/c.x,f=(a.height-2*e.padding-2*Math.abs(i.y))/c.y;return e.center=a.unproject(o.add(u).div(2)),e.zoom=Math.min(a.scaleZoom(a.scale*Math.min(h,f)),e.maxZoom),e.bearing=0,e.linear?this.easeTo(e,r):this.flyTo(e,r)},jumpTo:function(t,e){this.stop();var r=this.transform,n=!1,i=!1,a=!1;return\"zoom\"in t&&r.zoom!==+t.zoom&&(n=!0,r.zoom=+t.zoom),\"center\"in t&&(r.center=o.convert(t.center)),\"bearing\"in t&&r.bearing!==+t.bearing&&(i=!0,r.bearing=+t.bearing),\"pitch\"in t&&r.pitch!==+t.pitch&&(a=!0,r.pitch=+t.pitch),this.fire(\"movestart\",e).fire(\"move\",e),n&&this.fire(\"zoomstart\",e).fire(\"zoom\",e).fire(\"zoomend\",e),i&&this.fire(\"rotate\",e),a&&this.fire(\"pitch\",e),this.fire(\"moveend\",e)},easeTo:function(t,e){this.stop(),t=n.extend({offset:[0,0],duration:500,easing:n.ease},t);var r,a,s=this.transform,u=l.convert(t.offset),c=this.getZoom(),h=this.getBearing(),f=this.getPitch(),d=\"zoom\"in t?+t.zoom:c,p=\"bearing\"in t?this._normalizeBearing(t.bearing,h):h,m=\"pitch\"in t?+t.pitch:f;\"center\"in t?(r=o.convert(t.center),a=s.centerPoint.add(u)):\"around\"in t?(r=o.convert(t.around),a=s.locationPoint(r)):(a=s.centerPoint.add(u),r=s.pointLocation(a));var v=s.locationPoint(r);return!1===t.animate&&(t.duration=0),this.zooming=d!==c,this.rotating=h!==p,this.pitching=m!==f,t.noMoveStart||this.fire(\"movestart\",e),this.zooming&&this.fire(\"zoomstart\",e),clearTimeout(this._onEaseEnd),this._ease(function(t){this.zooming&&(s.zoom=i(c,d,t)),this.rotating&&(s.bearing=i(h,p,t)),this.pitching&&(s.pitch=i(f,m,t)),s.setLocationAtPoint(r,v.add(a.sub(v)._mult(t))),this.fire(\"move\",e),this.zooming&&this.fire(\"zoom\",e),this.rotating&&this.fire(\"rotate\",e),this.pitching&&this.fire(\"pitch\",e)},function(){t.delayEndEvents?this._onEaseEnd=setTimeout(this._easeToEnd.bind(this,e),t.delayEndEvents):this._easeToEnd(e)}.bind(this),t),this},_easeToEnd:function(t){var e=this.zooming;this.zooming=!1,this.rotating=!1,this.pitching=!1,e&&this.fire(\"zoomend\",t),this.fire(\"moveend\",t)},flyTo:function(t,e){function r(t){var e=(A*A-k*k+(t?-1:1)*L*L*T*T)/(2*(t?A:k)*L*T);return Math.log(Math.sqrt(e*e+1)-e)}function a(t){return(Math.exp(t)-Math.exp(-t))/2}function s(t){return(Math.exp(t)+Math.exp(-t))/2}function u(t){return a(t)/s(t)}this.stop(),t=n.extend({offset:[0,0],speed:1.2,curve:1.42,easing:n.ease},t);var c=this.transform,h=l.convert(t.offset),f=this.getZoom(),d=this.getBearing(),p=this.getPitch(),m=\"center\"in t?o.convert(t.center):this.getCenter(),v=\"zoom\"in t?+t.zoom:f,g=\"bearing\"in t?this._normalizeBearing(t.bearing,d):d,y=\"pitch\"in t?+t.pitch:p;Math.abs(c.center.lng)+Math.abs(m.lng)>180&&(c.center.lng>0&&m.lng<0?m.lng+=360:c.center.lng<0&&m.lng>0&&(m.lng-=360));var b=c.zoomScale(v-f),x=c.point,_=\"center\"in t?c.project(m).sub(h.div(b)):x,w=c.worldSize,M=t.curve,k=Math.max(c.width,c.height),A=k/b,T=_.sub(x).mag();if(\"minZoom\"in t){var S=n.clamp(Math.min(t.minZoom,f,v),c.minZoom,c.maxZoom),E=k/c.zoomScale(S-f);M=Math.sqrt(E/T*2)}var L=M*M,C=r(0),z=function(t){return s(C)/s(C+M*t)},I=function(t){return k*((s(C)*u(C+M*t)-a(C))/L)/T},D=(r(1)-C)/M;if(Math.abs(T)<1e-6){if(Math.abs(k-A)<1e-6)return this.easeTo(t);var P=A<k?-1:1;D=Math.abs(Math.log(A/k))/M,I=function(){return 0},z=function(t){return Math.exp(P*M*t)}}if(\"duration\"in t)t.duration=+t.duration;else{var O=\"screenSpeed\"in t?+t.screenSpeed/M:+t.speed;t.duration=1e3*D/O}return this.zooming=!0,d!==g&&(this.rotating=!0),p!==y&&(this.pitching=!0),this.fire(\"movestart\",e),this.fire(\"zoomstart\",e),this._ease(function(t){var r=t*D,n=I(r);c.zoom=f+c.scaleZoom(1/z(r)),c.center=c.unproject(x.add(_.sub(x).mult(n)),w),this.rotating&&(c.bearing=i(d,g,t)),this.pitching&&(c.pitch=i(p,y,t)),this.fire(\"move\",e),this.fire(\"zoom\",e),this.rotating&&this.fire(\"rotate\",e),this.pitching&&this.fire(\"pitch\",e)},function(){this.zooming=!1,this.rotating=!1,this.pitching=!1,this.fire(\"zoomend\",e),this.fire(\"moveend\",e)},t),this},isEasing:function(){return!!this._abortFn},stop:function(){return this._abortFn&&(this._abortFn(),this._finishEase()),this},_ease:function(t,e,r){this._finishFn=e,this._abortFn=a.timed(function(e){t.call(this,r.easing(e)),1===e&&this._finishEase()},!1===r.animate?0:r.duration,this)},_finishEase:function(){delete this._abortFn;var t=this._finishFn;delete this._finishFn,t.call(this)},_normalizeBearing:function(t,e){t=n.wrap(t,-180,180);var r=Math.abs(t-e);return Math.abs(t-360-e)<r&&(t-=360),Math.abs(t+360-e)<r&&(t+=360),t},_updateEasing:function(t,e,r){var i;if(this.ease){var a=this.ease,o=(Date.now()-a.start)/a.duration,s=a.easing(o+.01)-a.easing(o),l=.27/Math.sqrt(s*s+1e-4)*.01,u=Math.sqrt(.0729-l*l);i=n.bezier(l,u,.25,1)}else i=r?n.bezier.apply(n,r):n.ease;return this.ease={start:(new Date).getTime(),to:Math.pow(2,e),duration:t,easing:i},i}})},{\"../geo/lng_lat\":338,\"../geo/lng_lat_bounds\":339,\"../util/browser\":425,\"../util/interpolate\":435,\"../util/util\":441,\"point-geometry\":483}],408:[function(t,e,r){\"use strict\";function n(t){o.setOptions(this,t)}var i=t(\"./control\"),a=t(\"../../util/dom\"),o=t(\"../../util/util\");e.exports=n,n.createAttributionString=function(t){var e=[];for(var r in t){var n=t[r];n.attribution&&e.indexOf(n.attribution)<0&&e.push(n.attribution)}return e.sort(function(t,e){return t.length-e.length}),e=e.filter(function(t,r){for(var n=r+1;n<e.length;n++)if(e[n].indexOf(t)>=0)return!1;return!0}),e.join(\" | \")},n.prototype=o.inherit(i,{options:{position:\"bottom-right\"},onAdd:function(t){var e=this._container=a.create(\"div\",\"mapboxgl-ctrl-attrib\",t.getContainer());return this._update(),t.on(\"source.load\",this._update.bind(this)),t.on(\"source.change\",this._update.bind(this)),t.on(\"source.remove\",this._update.bind(this)),t.on(\"moveend\",this._updateEditLink.bind(this)),e},_update:function(){this._map.style&&(this._container.innerHTML=n.createAttributionString(this._map.style.sources)),this._editLink=this._container.getElementsByClassName(\"mapbox-improve-map\")[0],this._updateEditLink()},_updateEditLink:function(){if(this._editLink){var t=this._map.getCenter();this._editLink.href=\"https://www.mapbox.com/map-feedback/#/\"+t.lng+\"/\"+t.lat+\"/\"+Math.round(this._map.getZoom()+1)}}})},{\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],409:[function(t,e,r){\"use strict\";function n(){}var i=t(\"../../util/util\"),a=t(\"../../util/evented\");e.exports=n,n.prototype={addTo:function(t){this._map=t;var e=this._container=this.onAdd(t);if(this.options&&this.options.position){var r=this.options.position,n=t._controlCorners[r];e.className+=\" mapboxgl-ctrl\",-1!==r.indexOf(\"bottom\")?n.insertBefore(e,n.firstChild):n.appendChild(e)}return this},remove:function(){return this._container.parentNode.removeChild(this._container),this.onRemove&&this.onRemove(this._map),this._map=null,this}},i.extend(n.prototype,a)},{\"../../util/evented\":433,\"../../util/util\":441}],410:[function(t,e,r){\"use strict\";function n(t){s.setOptions(this,t)}var i=t(\"./control\"),a=t(\"../../util/browser\"),o=t(\"../../util/dom\"),s=t(\"../../util/util\");e.exports=n;var l={enableHighAccuracy:!1,timeout:6e3};n.prototype=s.inherit(i,{options:{position:\"top-right\"},onAdd:function(t){var e=this._container=o.create(\"div\",\"mapboxgl-ctrl-group\",t.getContainer());return a.supportsGeolocation?(this._container.addEventListener(\"contextmenu\",this._onContextMenu.bind(this)),this._geolocateButton=o.create(\"button\",\"mapboxgl-ctrl-icon mapboxgl-ctrl-geolocate\",this._container),this._geolocateButton.type=\"button\",this._geolocateButton.addEventListener(\"click\",this._onClickGeolocate.bind(this)),e):e},_onContextMenu:function(t){t.preventDefault()},_onClickGeolocate:function(){navigator.geolocation.getCurrentPosition(this._success.bind(this),this._error.bind(this),l),this._timeoutId=setTimeout(this._finish.bind(this),1e4)},_success:function(t){this._map.jumpTo({center:[t.coords.longitude,t.coords.latitude],zoom:17,bearing:0,pitch:0}),this.fire(\"geolocate\",t),this._finish()},_error:function(t){this.fire(\"error\",t),this._finish()},_finish:function(){this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=void 0}})},{\"../../util/browser\":425,\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],411:[function(t,e,r){\"use strict\";function n(t){s.setOptions(this,t)}function i(t){return new MouseEvent(t.type,{button:2,buttons:2,bubbles:!0,cancelable:!0,detail:t.detail,view:t.view,screenX:t.screenX,screenY:t.screenY,clientX:t.clientX,clientY:t.clientY,movementX:t.movementX,movementY:t.movementY,ctrlKey:t.ctrlKey,shiftKey:t.shiftKey,altKey:t.altKey,metaKey:t.metaKey})}var a=t(\"./control\"),o=t(\"../../util/dom\"),s=t(\"../../util/util\");e.exports=n,n.prototype=s.inherit(a,{options:{position:\"top-right\"},onAdd:function(t){var e=\"mapboxgl-ctrl\",r=this._container=o.create(\"div\",e+\"-group\",t.getContainer());return this._container.addEventListener(\"contextmenu\",this._onContextMenu.bind(this)),this._zoomInButton=this._createButton(e+\"-icon \"+e+\"-zoom-in\",t.zoomIn.bind(t)),this._zoomOutButton=this._createButton(e+\"-icon \"+e+\"-zoom-out\",t.zoomOut.bind(t)),this._compass=this._createButton(e+\"-icon \"+e+\"-compass\",t.resetNorth.bind(t)),this._compassArrow=o.create(\"div\",\"arrow\",this._compass),this._compass.addEventListener(\"mousedown\",this._onCompassDown.bind(this)),this._onCompassMove=this._onCompassMove.bind(this),this._onCompassUp=this._onCompassUp.bind(this),t.on(\"rotate\",this._rotateCompassArrow.bind(this)),this._rotateCompassArrow(),this._el=t.getCanvasContainer(),r},_onContextMenu:function(t){t.preventDefault()},_onCompassDown:function(t){0===t.button&&(o.disableDrag(),document.addEventListener(\"mousemove\",this._onCompassMove),document.addEventListener(\"mouseup\",this._onCompassUp),this._el.dispatchEvent(i(t)),t.stopPropagation())},_onCompassMove:function(t){0===t.button&&(this._el.dispatchEvent(i(t)),t.stopPropagation())},_onCompassUp:function(t){0===t.button&&(document.removeEventListener(\"mousemove\",this._onCompassMove),document.removeEventListener(\"mouseup\",this._onCompassUp),o.enableDrag(),this._el.dispatchEvent(i(t)),t.stopPropagation())},_createButton:function(t,e){var r=o.create(\"button\",t,this._container);return r.type=\"button\",r.addEventListener(\"click\",function(){e()}),r},_rotateCompassArrow:function(){var t=\"rotate(\"+this._map.transform.angle*(180/Math.PI)+\"deg)\";this._compassArrow.style.transform=t}})},{\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],412:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),this._container=t.getContainer(),o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../geo/lng_lat_bounds\"),o=t(\"../../util/util\");e.exports=n,n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onMouseDown,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onMouseDown),this._enabled=!1)},_onMouseDown:function(t){t.shiftKey&&0===t.button&&(document.addEventListener(\"mousemove\",this._onMouseMove,!1),document.addEventListener(\"keydown\",this._onKeyDown,!1),document.addEventListener(\"mouseup\",this._onMouseUp,!1),i.disableDrag(),this._startPos=i.mousePos(this._el,t),this._active=!0)},_onMouseMove:function(t){var e=this._startPos,r=i.mousePos(this._el,t);this._box||(this._box=i.create(\"div\",\"mapboxgl-boxzoom\",this._container),this._container.classList.add(\"mapboxgl-crosshair\"),this._fireEvent(\"boxzoomstart\",t));var n=Math.min(e.x,r.x),a=Math.max(e.x,r.x),o=Math.min(e.y,r.y),s=Math.max(e.y,r.y);i.setTransform(this._box,\"translate(\"+n+\"px,\"+o+\"px)\"),this._box.style.width=a-n+\"px\",this._box.style.height=s-o+\"px\"},_onMouseUp:function(t){if(0===t.button){var e=this._startPos,r=i.mousePos(this._el,t),n=new a(this._map.unproject(e),this._map.unproject(r));this._finish(),e.x===r.x&&e.y===r.y?this._fireEvent(\"boxzoomcancel\",t):this._map.fitBounds(n,{linear:!0}).fire(\"boxzoomend\",{originalEvent:t,boxZoomBounds:n})}},_onKeyDown:function(t){27===t.keyCode&&(this._finish(),this._fireEvent(\"boxzoomcancel\",t))},_finish:function(){this._active=!1,document.removeEventListener(\"mousemove\",this._onMouseMove,!1),document.removeEventListener(\"keydown\",this._onKeyDown,!1),document.removeEventListener(\"mouseup\",this._onMouseUp,!1),this._container.classList.remove(\"mapboxgl-crosshair\"),this._box&&(this._box.parentNode.removeChild(this._box),this._box=null),i.enableDrag()},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})}}},{\"../../geo/lng_lat_bounds\":339,\"../../util/dom\":427,\"../../util/util\":441}],413:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._onDblClick=this._onDblClick.bind(this)}e.exports=n,n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._map.on(\"dblclick\",this._onDblClick),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._map.off(\"dblclick\",this._onDblClick),this._enabled=!1)},_onDblClick:function(t){this._map.zoomTo(this._map.getZoom()+(t.originalEvent.shiftKey?-1:1),{around:t.lngLat},t)}}},{}],414:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),a.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/util\");e.exports=n;var o=a.bezier(0,0,.3,1);n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onDown),this._el.addEventListener(\"touchstart\",this._onDown),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onDown),this._el.removeEventListener(\"touchstart\",this._onDown),this._enabled=!1)},_onDown:function(t){this._ignoreEvent(t)||this.isActive()||(t.touches?(document.addEventListener(\"touchmove\",this._onMove),document.addEventListener(\"touchend\",this._onTouchEnd)):(document.addEventListener(\"mousemove\",this._onMove),document.addEventListener(\"mouseup\",this._onMouseUp)),this._active=!1,this._startPos=this._pos=i.mousePos(this._el,t),this._inertia=[[Date.now(),this._pos]])},_onMove:function(t){if(!this._ignoreEvent(t)){this.isActive()||(this._active=!0,this._fireEvent(\"dragstart\",t),this._fireEvent(\"movestart\",t));var e=i.mousePos(this._el,t),r=this._map;r.stop(),this._drainInertiaBuffer(),this._inertia.push([Date.now(),e]),r.transform.setLocationAtPoint(r.transform.pointLocation(this._pos),e),this._fireEvent(\"drag\",t),this._fireEvent(\"move\",t),this._pos=e,t.preventDefault()}},_onUp:function(t){if(this.isActive()){this._active=!1,this._fireEvent(\"dragend\",t),this._drainInertiaBuffer();var e=function(){this._fireEvent(\"moveend\",t)}.bind(this),r=this._inertia;if(r.length<2)return void e();var n=r[r.length-1],i=r[0],a=n[1].sub(i[1]),s=(n[0]-i[0])/1e3;if(0===s||n[1].equals(i[1]))return void e();var l=a.mult(.3/s),u=l.mag();u>1400&&(u=1400,l._unit()._mult(u));var c=u/750,h=l.mult(-c/2);this._map.panBy(h,{duration:1e3*c,easing:o,noMoveStart:!0},{originalEvent:t})}},_onMouseUp:function(t){this._ignoreEvent(t)||(this._onUp(t),document.removeEventListener(\"mousemove\",this._onMove),document.removeEventListener(\"mouseup\",this._onMouseUp))},_onTouchEnd:function(t){this._ignoreEvent(t)||(this._onUp(t),document.removeEventListener(\"touchmove\",this._onMove),document.removeEventListener(\"touchend\",this._onTouchEnd))},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})},_ignoreEvent:function(t){var e=this._map;if(e.boxZoom&&e.boxZoom.isActive())return!0;if(e.dragRotate&&e.dragRotate.isActive())return!0;if(t.touches)return t.touches.length>1;if(t.ctrlKey)return!0;return\"mousemove\"===t.type?!1&t.buttons:0!==t.button},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>0&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441}],415:[function(t,e,r){\"use strict\";function n(t,e){this._map=t,this._el=t.getCanvasContainer(),this._bearingSnap=e.bearingSnap,o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"point-geometry\"),o=t(\"../../util/util\");e.exports=n;var s=o.bezier(0,0,.25,1);n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onDown),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onDown),this._enabled=!1)},_onDown:function(t){if(!this._ignoreEvent(t)&&!this.isActive()){document.addEventListener(\"mousemove\",this._onMove),document.addEventListener(\"mouseup\",this._onUp),this._active=!1,this._inertia=[[Date.now(),this._map.getBearing()]],this._startPos=this._pos=i.mousePos(this._el,t),this._center=this._map.transform.centerPoint;var e=this._startPos.sub(this._center);e.mag()<200&&(this._center=this._startPos.add(new a(-200,0)._rotate(e.angle()))),t.preventDefault()}},_onMove:function(t){if(!this._ignoreEvent(t)){this.isActive()||(this._active=!0,this._fireEvent(\"rotatestart\",t),this._fireEvent(\"movestart\",t));var e=this._map;e.stop();var r=this._pos,n=i.mousePos(this._el,t),a=this._center,o=r.sub(a).angleWith(n.sub(a))/Math.PI*180,s=e.getBearing()-o,l=this._inertia,u=l[l.length-1];this._drainInertiaBuffer(),l.push([Date.now(),e._normalizeBearing(s,u[1])]),e.transform.bearing=s,this._fireEvent(\"rotate\",t),this._fireEvent(\"move\",t),this._pos=n}},_onUp:function(t){if(!this._ignoreEvent(t)&&(document.removeEventListener(\"mousemove\",this._onMove),document.removeEventListener(\"mouseup\",this._onUp),this.isActive())){this._active=!1,this._fireEvent(\"rotateend\",t),this._drainInertiaBuffer();var e=this._map,r=e.getBearing(),n=this._inertia,i=function(){Math.abs(r)<this._bearingSnap?e.resetNorth({noMoveStart:!0},{originalEvent:t}):this._fireEvent(\"moveend\",t)}.bind(this);if(n.length<2)return void i();var a=n[0],o=n[n.length-1],l=n[n.length-2],u=e._normalizeBearing(r,l[1]),c=o[1]-a[1],h=c<0?-1:1,f=(o[0]-a[0])/1e3;if(0===c||0===f)return void i();var d=Math.abs(c*(.25/f));d>180&&(d=180);var p=d/180;u+=h*d*(p/2),Math.abs(e._normalizeBearing(u,0))<this._bearingSnap&&(u=e._normalizeBearing(0,u)),e.rotateTo(u,{duration:1e3*p,easing:s,noMoveStart:!0},{originalEvent:t})}},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})},_ignoreEvent:function(t){var e=this._map;if(e.boxZoom&&e.boxZoom.isActive())return!0;if(e.dragPan&&e.dragPan.isActive())return!0;if(t.touches)return t.touches.length>1;var r=t.ctrlKey?1:2,n=t.ctrlKey?0:2;return\"mousemove\"===t.type?t.buttons&0===r:t.button!==n},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>0&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441,\"point-geometry\":483}],416:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),this._onKeyDown=this._onKeyDown.bind(this)}e.exports=n;n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"keydown\",this._onKeyDown,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"keydown\",this._onKeyDown),this._enabled=!1)},_onKeyDown:function(t){if(!(t.altKey||t.ctrlKey||t.metaKey)){var e=this._map,r={originalEvent:t};if(!e.isEasing())switch(t.keyCode){case 61:case 107:case 171:case 187:e.zoomTo(Math.round(e.getZoom())+(t.shiftKey?2:1),r);break;case 189:case 109:case 173:e.zoomTo(Math.round(e.getZoom())-(t.shiftKey?2:1),r);break;case 37:t.shiftKey?e.easeTo({bearing:e.getBearing()-2},r):(t.preventDefault(),e.panBy([-80,0],r));break;case 39:t.shiftKey?e.easeTo({bearing:e.getBearing()+2},r):(t.preventDefault(),e.panBy([80,0],r));break;case 38:t.shiftKey?e.easeTo({pitch:e.getPitch()+5},r):(t.preventDefault(),e.panBy([0,-80],r));break;case 40:t.shiftKey?e.easeTo({pitch:Math.max(e.getPitch()-5,0)},r):(t.preventDefault(),e.panBy([0,80],r))}}}}},{}],417:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/browser\"),o=t(\"../../util/util\");e.exports=n;var s=\"undefined\"!=typeof navigator?navigator.userAgent.toLowerCase():\"\",l=-1!==s.indexOf(\"firefox\"),u=-1!==s.indexOf(\"safari\")&&-1===s.indexOf(\"chrom\");n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"wheel\",this._onWheel,!1),this._el.addEventListener(\"mousewheel\",this._onWheel,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"wheel\",this._onWheel),this._el.removeEventListener(\"mousewheel\",this._onWheel),this._enabled=!1)},_onWheel:function(t){var e;\"wheel\"===t.type?(e=t.deltaY,l&&t.deltaMode===window.WheelEvent.DOM_DELTA_PIXEL&&(e/=a.devicePixelRatio),t.deltaMode===window.WheelEvent.DOM_DELTA_LINE&&(e*=40)):\"mousewheel\"===t.type&&(e=-t.wheelDeltaY,u&&(e/=3));var r=a.now(),n=r-(this._time||0);this._pos=i.mousePos(this._el,t),this._time=r,0!==e&&e%4.000244140625==0?(this._type=\"wheel\",e=Math.floor(e/4)):0!==e&&Math.abs(e)<4?this._type=\"trackpad\":n>400?(this._type=null,this._lastValue=e,this._timeout=setTimeout(this._onTimeout,40)):this._type||(this._type=Math.abs(n*e)<200?\"trackpad\":\"wheel\",this._timeout&&(clearTimeout(this._timeout),this._timeout=null,e+=this._lastValue)),t.shiftKey&&e&&(e/=4),this._type&&this._zoom(-e,t),t.preventDefault()},_onTimeout:function(){this._type=\"wheel\",this._zoom(-this._lastValue)},_zoom:function(t,e){if(0!==t){var r=this._map,n=2/(1+Math.exp(-Math.abs(t/100)));t<0&&0!==n&&(n=1/n);var i=r.ease?r.ease.to:r.transform.scale,a=r.transform.scaleZoom(i*n);r.zoomTo(a,{duration:0,around:r.unproject(this._pos),delayEndEvents:200},{originalEvent:e})}}}},{\"../../util/browser\":425,\"../../util/dom\":427,\"../../util/util\":441}],418:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),a.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/util\");e.exports=n;var o=a.bezier(0,0,.15,1);n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"touchstart\",this._onStart,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"touchstart\",this._onStart),this._enabled=!1)},disableRotation:function(){this._rotationDisabled=!0},enableRotation:function(){this._rotationDisabled=!1},_onStart:function(t){if(2===t.touches.length){var e=i.mousePos(this._el,t.touches[0]),r=i.mousePos(this._el,t.touches[1]);this._startVec=e.sub(r),this._startScale=this._map.transform.scale,this._startBearing=this._map.transform.bearing,this._gestureIntent=void 0,this._inertia=[],\n",
       "document.addEventListener(\"touchmove\",this._onMove,!1),document.addEventListener(\"touchend\",this._onEnd,!1)}},_onMove:function(t){if(2===t.touches.length){var e=i.mousePos(this._el,t.touches[0]),r=i.mousePos(this._el,t.touches[1]),n=e.add(r).div(2),a=e.sub(r),o=a.mag()/this._startVec.mag(),s=this._rotationDisabled?0:180*a.angleWith(this._startVec)/Math.PI,l=this._map;if(this._gestureIntent){var u={duration:0,around:l.unproject(n)};\"rotate\"===this._gestureIntent&&(u.bearing=this._startBearing+s),\"zoom\"!==this._gestureIntent&&\"rotate\"!==this._gestureIntent||(u.zoom=l.transform.scaleZoom(this._startScale*o)),l.stop(),this._drainInertiaBuffer(),this._inertia.push([Date.now(),o,n]),l.easeTo(u,{originalEvent:t})}else{var c=Math.abs(1-o)>.15;Math.abs(s)>4?this._gestureIntent=\"rotate\":c&&(this._gestureIntent=\"zoom\"),this._gestureIntent&&(this._startVec=a,this._startScale=l.transform.scale,this._startBearing=l.transform.bearing)}t.preventDefault()}},_onEnd:function(t){document.removeEventListener(\"touchmove\",this._onMove),document.removeEventListener(\"touchend\",this._onEnd),this._drainInertiaBuffer();var e=this._inertia,r=this._map;if(e.length<2)return void r.snapToNorth({},{originalEvent:t});var n=e[e.length-1],i=e[0],a=r.transform.scaleZoom(this._startScale*n[1]),s=r.transform.scaleZoom(this._startScale*i[1]),l=a-s,u=(n[0]-i[0])/1e3,c=n[2];if(0===u||a===s)return void r.snapToNorth({},{originalEvent:t});var h=.15*l/u;Math.abs(h)>2.5&&(h=h>0?2.5:-2.5);var f=1e3*Math.abs(h/(12*.15)),d=a+h*f/2e3;d<0&&(d=0),r.easeTo({zoom:d,duration:f,easing:o,around:r.unproject(c)},{originalEvent:t})},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>2&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441}],419:[function(t,e,r){\"use strict\";function n(){i.bindAll([\"_onHashChange\",\"_updateHash\"],this)}e.exports=n;var i=t(\"../util/util\");n.prototype={addTo:function(t){return this._map=t,window.addEventListener(\"hashchange\",this._onHashChange,!1),this._map.on(\"moveend\",this._updateHash),this},remove:function(){return window.removeEventListener(\"hashchange\",this._onHashChange,!1),this._map.off(\"moveend\",this._updateHash),delete this._map,this},_onHashChange:function(){var t=location.hash.replace(\"#\",\"\").split(\"/\");return t.length>=3&&(this._map.jumpTo({center:[+t[2],+t[1]],zoom:+t[0],bearing:+(t[3]||0)}),!0)},_updateHash:function(){var t=this._map.getCenter(),e=this._map.getZoom(),r=this._map.getBearing(),n=Math.max(0,Math.ceil(Math.log(e)/Math.LN2)),i=\"#\"+Math.round(100*e)/100+\"/\"+t.lat.toFixed(n)+\"/\"+t.lng.toFixed(n)+(r?\"/\"+Math.round(10*r)/10:\"\");window.history.replaceState(\"\",\"\",i)}}},{\"../util/util\":441}],420:[function(t,e,r){\"use strict\";function n(t){t.parentNode&&t.parentNode.removeChild(t)}var i=t(\"../util/canvas\"),a=t(\"../util/util\"),o=t(\"../util/browser\"),s=t(\"../util/browser\").window,l=t(\"../util/evented\"),u=t(\"../util/dom\"),c=t(\"../style/style\"),h=t(\"../style/animation_loop\"),f=t(\"../render/painter\"),d=t(\"../geo/transform\"),p=t(\"./hash\"),m=t(\"./bind_handlers\"),v=t(\"./camera\"),g=t(\"../geo/lng_lat\"),y=t(\"../geo/lng_lat_bounds\"),b=t(\"point-geometry\"),x=t(\"./control/attribution\"),_={center:[0,0],zoom:0,bearing:0,pitch:0,minZoom:0,maxZoom:20,interactive:!0,scrollZoom:!0,boxZoom:!0,dragRotate:!0,dragPan:!0,keyboard:!0,doubleClickZoom:!0,touchZoomRotate:!0,bearingSnap:7,hash:!1,attributionControl:!0,failIfMajorPerformanceCaveat:!1,preserveDrawingBuffer:!1,trackResize:!0,workerCount:Math.max(o.hardwareConcurrency-1,1)},w=e.exports=function(t){if(t=a.extend({},_,t),t.workerCount<1)throw new Error(\"workerCount must an integer greater than or equal to 1.\");this._interactive=t.interactive,this._failIfMajorPerformanceCaveat=t.failIfMajorPerformanceCaveat,this._preserveDrawingBuffer=t.preserveDrawingBuffer,this._trackResize=t.trackResize,this._workerCount=t.workerCount,this._bearingSnap=t.bearingSnap,\"string\"==typeof t.container?this._container=document.getElementById(t.container):this._container=t.container,this.animationLoop=new h,this.transform=new d(t.minZoom,t.maxZoom),t.maxBounds&&this.setMaxBounds(t.maxBounds),a.bindAll([\"_forwardStyleEvent\",\"_forwardSourceEvent\",\"_forwardLayerEvent\",\"_forwardTileEvent\",\"_onStyleLoad\",\"_onStyleChange\",\"_onSourceAdd\",\"_onSourceRemove\",\"_onSourceUpdate\",\"_onWindowOnline\",\"_onWindowResize\",\"_update\",\"_render\"],this),this._setupContainer(),this._setupPainter(),this.on(\"move\",this._update.bind(this,!1)),this.on(\"zoom\",this._update.bind(this,!0)),this.on(\"moveend\",function(){this.animationLoop.set(300),this._rerender()}.bind(this)),void 0!==s&&(s.addEventListener(\"online\",this._onWindowOnline,!1),s.addEventListener(\"resize\",this._onWindowResize,!1)),m(this,t),this._hash=t.hash&&(new p).addTo(this),this._hash&&this._hash._onHashChange()||this.jumpTo({center:t.center,zoom:t.zoom,bearing:t.bearing,pitch:t.pitch}),this.stacks={},this._classes=[],this.resize(),t.classes&&this.setClasses(t.classes),t.style&&this.setStyle(t.style),t.attributionControl&&this.addControl(new x(t.attributionControl));var e=this.fire.bind(this,\"error\");this.on(\"style.error\",e),this.on(\"source.error\",e),this.on(\"tile.error\",e),this.on(\"layer.error\",e)};a.extend(w.prototype,l),a.extend(w.prototype,v.prototype),a.extend(w.prototype,{addControl:function(t){return t.addTo(this),this},addClass:function(t,e){return this._classes.indexOf(t)>=0||\"\"===t?this:(this._classes.push(t),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0))},removeClass:function(t,e){var r=this._classes.indexOf(t);return r<0||\"\"===t?this:(this._classes.splice(r,1),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0))},setClasses:function(t,e){for(var r={},n=0;n<t.length;n++)\"\"!==t[n]&&(r[t[n]]=!0);return this._classes=Object.keys(r),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0)},hasClass:function(t){return this._classes.indexOf(t)>=0},getClasses:function(){return this._classes},resize:function(){var t=0,e=0;return this._container&&(t=this._container.offsetWidth||400,e=this._container.offsetHeight||300),this._canvas.resize(t,e),this.transform.resize(t,e),this.painter.resize(t,e),this.fire(\"movestart\").fire(\"move\").fire(\"resize\").fire(\"moveend\")},getBounds:function(){var t=new y(this.transform.pointLocation(new b(0,0)),this.transform.pointLocation(this.transform.size));return(this.transform.angle||this.transform.pitch)&&(t.extend(this.transform.pointLocation(new b(this.transform.size.x,0))),t.extend(this.transform.pointLocation(new b(0,this.transform.size.y)))),t},setMaxBounds:function(t){if(t){var e=y.convert(t);this.transform.lngRange=[e.getWest(),e.getEast()],this.transform.latRange=[e.getSouth(),e.getNorth()],this.transform._constrain(),this._update()}else null!==t&&void 0!==t||(this.transform.lngRange=[],this.transform.latRange=[],this._update());return this},setMinZoom:function(t){if((t=null===t||void 0===t?0:t)>=0&&t<=this.transform.maxZoom)return this.transform.minZoom=t,this._update(),this.getZoom()<t&&this.setZoom(t),this;throw new Error(\"minZoom must be between 0 and the current maxZoom, inclusive\")},setMaxZoom:function(t){if((t=null===t||void 0===t?20:t)>=this.transform.minZoom&&t<=20)return this.transform.maxZoom=t,this._update(),this.getZoom()>t&&this.setZoom(t),this;throw new Error(\"maxZoom must be between the current minZoom and 20, inclusive\")},project:function(t){return this.transform.locationPoint(g.convert(t))},unproject:function(t){return this.transform.pointLocation(b.convert(t))},queryRenderedFeatures:function(){var t,e={};return 2===arguments.length?(t=arguments[0],e=arguments[1]):1===arguments.length&&function(t){return t instanceof b||Array.isArray(t)}(arguments[0])?t=arguments[0]:1===arguments.length&&(e=arguments[0]),this.style.queryRenderedFeatures(this._makeQueryGeometry(t),e,this.transform.zoom,this.transform.angle)},_makeQueryGeometry:function(t){void 0===t&&(t=[b.convert([0,0]),b.convert([this.transform.width,this.transform.height])]);var e;if(t instanceof b||\"number\"==typeof t[0])e=[b.convert(t)];else{var r=[b.convert(t[0]),b.convert(t[1])];e=[r[0],new b(r[1].x,r[0].y),r[1],new b(r[0].x,r[1].y),r[0]]}return e=e.map(function(t){return this.transform.pointCoordinate(t)}.bind(this))},querySourceFeatures:function(t,e){return this.style.querySourceFeatures(t,e)},setStyle:function(t){return this.style&&(this.style.off(\"load\",this._onStyleLoad).off(\"error\",this._forwardStyleEvent).off(\"change\",this._onStyleChange).off(\"source.add\",this._onSourceAdd).off(\"source.remove\",this._onSourceRemove).off(\"source.load\",this._onSourceUpdate).off(\"source.error\",this._forwardSourceEvent).off(\"source.change\",this._onSourceUpdate).off(\"layer.add\",this._forwardLayerEvent).off(\"layer.remove\",this._forwardLayerEvent).off(\"layer.error\",this._forwardLayerEvent).off(\"tile.add\",this._forwardTileEvent).off(\"tile.remove\",this._forwardTileEvent).off(\"tile.load\",this._update).off(\"tile.error\",this._forwardTileEvent).off(\"tile.stats\",this._forwardTileEvent)._remove(),this.off(\"rotate\",this.style._redoPlacement),this.off(\"pitch\",this.style._redoPlacement)),t?(this.style=t instanceof c?t:new c(t,this.animationLoop,this._workerCount),this.style.on(\"load\",this._onStyleLoad).on(\"error\",this._forwardStyleEvent).on(\"change\",this._onStyleChange).on(\"source.add\",this._onSourceAdd).on(\"source.remove\",this._onSourceRemove).on(\"source.load\",this._onSourceUpdate).on(\"source.error\",this._forwardSourceEvent).on(\"source.change\",this._onSourceUpdate).on(\"layer.add\",this._forwardLayerEvent).on(\"layer.remove\",this._forwardLayerEvent).on(\"layer.error\",this._forwardLayerEvent).on(\"tile.add\",this._forwardTileEvent).on(\"tile.remove\",this._forwardTileEvent).on(\"tile.load\",this._update).on(\"tile.error\",this._forwardTileEvent).on(\"tile.stats\",this._forwardTileEvent),this.on(\"rotate\",this.style._redoPlacement),this.on(\"pitch\",this.style._redoPlacement),this):(this.style=null,this)},getStyle:function(){if(this.style)return this.style.serialize()},addSource:function(t,e){return this.style.addSource(t,e),this._update(!0),this},addSourceType:function(t,e,r){return this.style.addSourceType(t,e,r)},removeSource:function(t){return this.style.removeSource(t),this._update(!0),this},getSource:function(t){return this.style.getSource(t)},addLayer:function(t,e){return this.style.addLayer(t,e),this._update(!0),this},removeLayer:function(t){return this.style.removeLayer(t),this._update(!0),this},getLayer:function(t){return this.style.getLayer(t)},setFilter:function(t,e){return this.style.setFilter(t,e),this._update(!0),this},setLayerZoomRange:function(t,e,r){return this.style.setLayerZoomRange(t,e,r),this._update(!0),this},getFilter:function(t){return this.style.getFilter(t)},setPaintProperty:function(t,e,r,n){return this.style.setPaintProperty(t,e,r,n),this._update(!0),this},getPaintProperty:function(t,e,r){return this.style.getPaintProperty(t,e,r)},setLayoutProperty:function(t,e,r){return this.style.setLayoutProperty(t,e,r),this._update(!0),this},getLayoutProperty:function(t,e){return this.style.getLayoutProperty(t,e)},getContainer:function(){return this._container},getCanvasContainer:function(){return this._canvasContainer},getCanvas:function(){return this._canvas.getElement()},_setupContainer:function(){var t=this._container;t.classList.add(\"mapboxgl-map\");var e=this._canvasContainer=u.create(\"div\",\"mapboxgl-canvas-container\",t);this._interactive&&e.classList.add(\"mapboxgl-interactive\"),this._canvas=new i(this,e);var r=this._controlContainer=u.create(\"div\",\"mapboxgl-control-container\",t),n=this._controlCorners={};[\"top-left\",\"top-right\",\"bottom-left\",\"bottom-right\"].forEach(function(t){n[t]=u.create(\"div\",\"mapboxgl-ctrl-\"+t,r)})},_setupPainter:function(){var t=this._canvas.getWebGLContext({failIfMajorPerformanceCaveat:this._failIfMajorPerformanceCaveat,preserveDrawingBuffer:this._preserveDrawingBuffer});if(!t)return void this.fire(\"error\",{error:new Error(\"Failed to initialize WebGL\")});this.painter=new f(t,this.transform)},_contextLost:function(t){t.preventDefault(),this._frameId&&o.cancelFrame(this._frameId),this.fire(\"webglcontextlost\",{originalEvent:t})},_contextRestored:function(t){this._setupPainter(),this.resize(),this._update(),this.fire(\"webglcontextrestored\",{originalEvent:t})},loaded:function(){return!this._styleDirty&&!this._sourcesDirty&&!(!this.style||!this.style.loaded())},_update:function(t){return this.style?(this._styleDirty=this._styleDirty||t,this._sourcesDirty=!0,this._rerender(),this):this},_render:function(){try{this.style&&this._styleDirty&&(this._styleDirty=!1,this.style.update(this._classes,this._classOptions),this._classOptions=null,this.style._recalculate(this.transform.zoom)),this.style&&this._sourcesDirty&&(this._sourcesDirty=!1,this.style._updateSources(this.transform)),this.painter.render(this.style,{debug:this.showTileBoundaries,showOverdrawInspector:this._showOverdrawInspector,vertices:this.vertices,rotating:this.rotating,zooming:this.zooming}),this.fire(\"render\"),this.loaded()&&!this._loaded&&(this._loaded=!0,this.fire(\"load\")),this._frameId=null,this.animationLoop.stopped()||(this._styleDirty=!0),(this._sourcesDirty||this._repaint||this._styleDirty)&&this._rerender()}catch(t){this.fire(\"error\",{error:t})}return this},remove:function(){this._hash&&this._hash.remove(),o.cancelFrame(this._frameId),this.setStyle(null),void 0!==s&&s.removeEventListener(\"resize\",this._onWindowResize,!1);var t=this.painter.gl.getExtension(\"WEBGL_lose_context\");t&&t.loseContext(),n(this._canvasContainer),n(this._controlContainer),this._container.classList.remove(\"mapboxgl-map\")},_rerender:function(){this.style&&!this._frameId&&(this._frameId=o.frame(this._render))},_forwardStyleEvent:function(t){this.fire(\"style.\"+t.type,a.extend({style:t.target},t))},_forwardSourceEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_forwardLayerEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_forwardTileEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_onStyleLoad:function(t){this.transform.unmodified&&this.jumpTo(this.style.stylesheet),this.style.update(this._classes,{transition:!1}),this._forwardStyleEvent(t)},_onStyleChange:function(t){this._update(!0),this._forwardStyleEvent(t)},_onSourceAdd:function(t){var e=t.source;e.onAdd&&e.onAdd(this),this._forwardSourceEvent(t)},_onSourceRemove:function(t){var e=t.source;e.onRemove&&e.onRemove(this),this._forwardSourceEvent(t)},_onSourceUpdate:function(t){this._update(),this._forwardSourceEvent(t)},_onWindowOnline:function(){this._update()},_onWindowResize:function(){this._trackResize&&this.stop().resize()._update()}}),a.extendAll(w.prototype,{_showTileBoundaries:!1,get showTileBoundaries(){return this._showTileBoundaries},set showTileBoundaries(t){this._showTileBoundaries!==t&&(this._showTileBoundaries=t,this._update())},_showCollisionBoxes:!1,get showCollisionBoxes(){return this._showCollisionBoxes},set showCollisionBoxes(t){this._showCollisionBoxes!==t&&(this._showCollisionBoxes=t,this.style._redoPlacement())},_showOverdrawInspector:!1,get showOverdrawInspector(){return this._showOverdrawInspector},set showOverdrawInspector(t){this._showOverdrawInspector!==t&&(this._showOverdrawInspector=t,this._update())},_repaint:!1,get repaint(){return this._repaint},set repaint(t){this._repaint=t,this._update()},_vertices:!1,get vertices(){return this._vertices},set vertices(t){this._vertices=t,this._update()}})},{\"../geo/lng_lat\":338,\"../geo/lng_lat_bounds\":339,\"../geo/transform\":340,\"../render/painter\":354,\"../style/animation_loop\":374,\"../style/style\":377,\"../util/browser\":425,\"../util/canvas\":426,\"../util/dom\":427,\"../util/evented\":433,\"../util/util\":441,\"./bind_handlers\":406,\"./camera\":407,\"./control/attribution\":408,\"./hash\":419,\"point-geometry\":483}],421:[function(t,e,r){\"use strict\";function n(t,e){t||(t=i.create(\"div\")),t.classList.add(\"mapboxgl-marker\"),this._el=t,this._offset=o.convert(e&&e.offset||[0,0]),this._update=this._update.bind(this)}e.exports=n;var i=t(\"../util/dom\"),a=t(\"../geo/lng_lat\"),o=t(\"point-geometry\");n.prototype={addTo:function(t){return this.remove(),this._map=t,t.getCanvasContainer().appendChild(this._el),t.on(\"move\",this._update),this._update(),this},remove:function(){this._map&&(this._map.off(\"move\",this._update),this._map=null);var t=this._el.parentNode;return t&&t.removeChild(this._el),this},getLngLat:function(){return this._lngLat},setLngLat:function(t){return this._lngLat=a.convert(t),this._update(),this},getElement:function(){return this._el},_update:function(){if(this._map){var t=this._map.project(this._lngLat)._add(this._offset);i.setTransform(this._el,\"translate(\"+t.x+\"px,\"+t.y+\"px)\")}}}},{\"../geo/lng_lat\":338,\"../util/dom\":427,\"point-geometry\":483}],422:[function(t,e,r){\"use strict\";function n(t){i.setOptions(this,t),i.bindAll([\"_update\",\"_onClickClose\"],this)}e.exports=n;var i=t(\"../util/util\"),a=t(\"../util/evented\"),o=t(\"../util/dom\"),s=t(\"../geo/lng_lat\");n.prototype=i.inherit(a,{options:{closeButton:!0,closeOnClick:!0},addTo:function(t){return this._map=t,this._map.on(\"move\",this._update),this.options.closeOnClick&&this._map.on(\"click\",this._onClickClose),this._update(),this},remove:function(){return this._content&&this._content.parentNode&&this._content.parentNode.removeChild(this._content),this._container&&(this._container.parentNode.removeChild(this._container),delete this._container),this._map&&(this._map.off(\"move\",this._update),this._map.off(\"click\",this._onClickClose),delete this._map),this.fire(\"close\"),this},getLngLat:function(){return this._lngLat},setLngLat:function(t){return this._lngLat=s.convert(t),this._update(),this},setText:function(t){return this.setDOMContent(document.createTextNode(t))},setHTML:function(t){var e,r=document.createDocumentFragment(),n=document.createElement(\"body\");for(n.innerHTML=t;;){if(!(e=n.firstChild))break;r.appendChild(e)}return this.setDOMContent(r)},setDOMContent:function(t){return this._createContent(),this._content.appendChild(t),this._update(),this},_createContent:function(){this._content&&this._content.parentNode&&this._content.parentNode.removeChild(this._content),this._content=o.create(\"div\",\"mapboxgl-popup-content\",this._container),this.options.closeButton&&(this._closeButton=o.create(\"button\",\"mapboxgl-popup-close-button\",this._content),this._closeButton.type=\"button\",this._closeButton.innerHTML=\"&#215;\",this._closeButton.addEventListener(\"click\",this._onClickClose))},_update:function(){if(this._map&&this._lngLat&&this._content){this._container||(this._container=o.create(\"div\",\"mapboxgl-popup\",this._map.getContainer()),this._tip=o.create(\"div\",\"mapboxgl-popup-tip\",this._container),this._container.appendChild(this._content));var t=this._map.project(this._lngLat).round(),e=this.options.anchor;if(!e){var r=this._container.offsetWidth,n=this._container.offsetHeight;e=t.y<n?[\"top\"]:t.y>this._map.transform.height-n?[\"bottom\"]:[],t.x<r/2?e.push(\"left\"):t.x>this._map.transform.width-r/2&&e.push(\"right\"),e=0===e.length?\"bottom\":e.join(\"-\")}var i={top:\"translate(-50%,0)\",\"top-left\":\"translate(0,0)\",\"top-right\":\"translate(-100%,0)\",bottom:\"translate(-50%,-100%)\",\"bottom-left\":\"translate(0,-100%)\",\"bottom-right\":\"translate(-100%,-100%)\",left:\"translate(0,-50%)\",right:\"translate(-100%,-50%)\"},a=this._container.classList;for(var s in i)a.remove(\"mapboxgl-popup-anchor-\"+s);a.add(\"mapboxgl-popup-anchor-\"+e),o.setTransform(this._container,i[e]+\" translate(\"+t.x+\"px,\"+t.y+\"px)\")}},_onClickClose:function(){this.remove()}})},{\"../geo/lng_lat\":338,\"../util/dom\":427,\"../util/evented\":433,\"../util/util\":441}],423:[function(t,e,r){\"use strict\";function n(t,e){this.target=t,this.parent=e,this.callbacks={},this.callbackID=0,this.receive=this.receive.bind(this),this.target.addEventListener(\"message\",this.receive,!1)}e.exports=n,n.prototype.receive=function(t){function e(t,e,r){this.postMessage({type:\"<response>\",id:String(i),error:t?String(t):null,data:e},r)}var r,n=t.data,i=n.id;if(\"<response>\"===n.type)r=this.callbacks[n.id],delete this.callbacks[n.id],r&&r(n.error||null,n.data);else if(void 0!==n.id&&this.parent[n.type])this.parent[n.type](n.data,e.bind(this));else if(void 0!==n.id&&this.parent.workerSources){var a=n.type.split(\".\");this.parent.workerSources[a[0]][a[1]](n.data,e.bind(this))}else this.parent[n.type](n.data)},n.prototype.send=function(t,e,r,n){var i=null;r&&(this.callbacks[i=this.callbackID++]=r),this.postMessage({type:t,id:String(i),data:e},n)},n.prototype.postMessage=function(t,e){this.target.postMessage(t,e)}},{}],424:[function(t,e,r){\"use strict\";function n(t){var e=document.createElement(\"a\");return e.href=t,e.protocol===document.location.protocol&&e.host===document.location.host}r.getJSON=function(t,e){var r=new XMLHttpRequest;return r.open(\"GET\",t,!0),r.setRequestHeader(\"Accept\",\"application/json\"),r.onerror=function(t){e(t)},r.onload=function(){if(r.status>=200&&r.status<300&&r.response){var t;try{t=JSON.parse(r.response)}catch(t){return e(t)}e(null,t)}else e(new Error(r.statusText))},r.send(),r},r.getArrayBuffer=function(t,e){var r=new XMLHttpRequest;return r.open(\"GET\",t,!0),r.responseType=\"arraybuffer\",r.onerror=function(t){e(t)},r.onload=function(){r.status>=200&&r.status<300&&r.response?e(null,r.response):e(new Error(r.statusText))},r.send(),r},r.getImage=function(t,e){return r.getArrayBuffer(t,function(t,r){if(t)return e(t);var n=new Image;n.onload=function(){e(null,n),(window.URL||window.webkitURL).revokeObjectURL(n.src)};var i=new Blob([new Uint8Array(r)],{type:\"image/png\"});return n.src=(window.URL||window.webkitURL).createObjectURL(i),n.getData=function(){var t=document.createElement(\"canvas\"),e=t.getContext(\"2d\");return t.width=n.width,t.height=n.height,e.drawImage(n,0,0),e.getImageData(0,0,n.width,n.height).data},n})},r.getVideo=function(t,e){var r=document.createElement(\"video\");r.onloadstart=function(){e(null,r)};for(var i=0;i<t.length;i++){var a=document.createElement(\"source\");n(t[i])||(r.crossOrigin=\"Anonymous\"),a.src=t[i],r.appendChild(a)}return r.getData=function(){return r},r}},{}],425:[function(t,e,r){\"use strict\";r.window=window,e.exports.now=function(){return window.performance&&window.performance.now?window.performance.now.bind(window.performance):Date.now.bind(Date)}();var n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame;r.frame=function(t){return n(t)};var i=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame;r.cancelFrame=function(t){i(t)},r.timed=function(t,n,i){function a(l){o||(l=e.exports.now(),l>=s+n?t.call(i,1):(t.call(i,(l-s)/n),r.frame(a)))}if(!n)return t.call(i,1),null;var o=!1,s=e.exports.now();return r.frame(a),function(){o=!0}},r.supported=t(\"mapbox-gl-supported\"),r.hardwareConcurrency=navigator.hardwareConcurrency||4,Object.defineProperty(r,\"devicePixelRatio\",{get:function(){return window.devicePixelRatio}}),r.supportsWebp=!1;var a=document.createElement(\"img\");a.onload=function(){r.supportsWebp=!0},a.src=\"data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=\",r.supportsGeolocation=!!navigator.geolocation},{\"mapbox-gl-supported\":326}],426:[function(t,e,r){\"use strict\";function n(t,e){this.canvas=document.createElement(\"canvas\"),t&&e&&(this.canvas.style.position=\"absolute\",this.canvas.classList.add(\"mapboxgl-canvas\"),this.canvas.addEventListener(\"webglcontextlost\",t._contextLost.bind(t),!1),this.canvas.addEventListener(\"webglcontextrestored\",t._contextRestored.bind(t),!1),this.canvas.setAttribute(\"tabindex\",0),e.appendChild(this.canvas))}var i=t(\"../util\"),a=t(\"mapbox-gl-supported\");e.exports=n,n.prototype.resize=function(t,e){var r=window.devicePixelRatio||1;this.canvas.width=r*t,this.canvas.height=r*e,this.canvas.style.width=t+\"px\",this.canvas.style.height=e+\"px\"},n.prototype.getWebGLContext=function(t){return t=i.extend({},t,a.webGLContextAttributes),this.canvas.getContext(\"webgl\",t)||this.canvas.getContext(\"experimental-webgl\",t)},n.prototype.getElement=function(){return this.canvas}},{\"../util\":441,\"mapbox-gl-supported\":326}],427:[function(t,e,r){\"use strict\";function n(t){for(var e=0;e<t.length;e++)if(t[e]in s)return t[e]}function i(t){t.preventDefault(),t.stopPropagation(),window.removeEventListener(\"click\",i,!0)}var a=t(\"point-geometry\");r.create=function(t,e,r){var n=document.createElement(t);return e&&(n.className=e),r&&r.appendChild(n),n};var o,s=document.documentElement.style,l=n([\"userSelect\",\"MozUserSelect\",\"WebkitUserSelect\",\"msUserSelect\"]);r.disableDrag=function(){l&&(o=s[l],s[l]=\"none\")},r.enableDrag=function(){l&&(s[l]=o)};var u=n([\"transform\",\"WebkitTransform\"]);r.setTransform=function(t,e){t.style[u]=e},r.suppressClick=function(){window.addEventListener(\"click\",i,!0),window.setTimeout(function(){window.removeEventListener(\"click\",i,!0)},0)},r.mousePos=function(t,e){var r=t.getBoundingClientRect();return e=e.touches?e.touches[0]:e,new a(e.clientX-r.left-t.clientLeft,e.clientY-r.top-t.clientTop)},r.touchPos=function(t,e){for(var r=t.getBoundingClientRect(),n=[],i=0;i<e.touches.length;i++)n.push(new a(e.touches[i].clientX-r.left-t.clientLeft,e.touches[i].clientY-r.top-t.clientTop));return n}},{\"point-geometry\":483}],428:[function(t,e,r){\"use strict\";var n=t(\"webworkify\");e.exports=function(){return new n(t(\"../../source/worker\"))}},{\"../../source/worker\":372,webworkify:563}],429:[function(t,e,r){\"use strict\";function n(t,e){return e.area-t.area}function i(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r.x-e.x)*(e.y+r.y);return n}var a=t(\"quickselect\");e.exports=function(t,e){var r=t.length;if(r<=1)return[t];for(var o,s,l=[],u=0;u<r;u++){var c=i(t[u]);0!==c&&(t[u].area=Math.abs(c),void 0===s&&(s=c<0),s===c<0?(o&&l.push(o),o=[t[u]]):o.push(t[u]))}if(o&&l.push(o),e>1)for(var h=0;h<l.length;h++)l[h].length<=e||(a(l[h],e,1,l[h].length-1,n),l[h]=l[h].slice(0,e));return l}},{quickselect:492}],430:[function(t,e,r){\"use strict\";e.exports={API_URL:\"https://api.mapbox.com\",REQUIRE_ACCESS_TOKEN:!0}},{}],431:[function(t,e,r){\"use strict\";function n(t){this._stringToNumber={},this._numberToString=[];for(var e=0;e<t.length;e++){var r=t[e];this._stringToNumber[r]=e,this._numberToString[e]=r}}var i=t(\"assert\");e.exports=n,n.prototype.encode=function(t){return i(t in this._stringToNumber),this._stringToNumber[t]},n.prototype.decode=function(t){return i(t<this._numberToString.length),this._numberToString[t]}},{assert:46}],432:[function(t,e,r){\"use strict\";function n(t,e){this.actors=[],this.currentActor=0;for(var r=0;r<t;r++){var n=new o,i=new a(n,e);i.name=\"Worker \"+r,this.actors.push(i)}}var i=t(\"./util\"),a=t(\"./actor\"),o=t(\"./web_worker\");e.exports=n,n.prototype={broadcast:function(t,e,r){r=r||function(){},i.asyncAll(this.actors,function(r,n){r.send(t,e,n)},r)},send:function(t,e,r,n,i){return(\"number\"!=typeof n||isNaN(n))&&(n=this.currentActor=(this.currentActor+1)%this.actors.length),this.actors[n].send(t,e,r,i),n},remove:function(){for(var t=0;t<this.actors.length;t++)this.actors[t].target.terminate();this.actors=[]}}},{\"./actor\":423,\"./util\":441,\"./web_worker\":428}],433:[function(t,e,r){\"use strict\";var n=t(\"./util\"),i={on:function(t,e){return this._events=this._events||{},this._events[t]=this._events[t]||[],this._events[t].push(e),this},off:function(t,e){if(!t)return delete this._events,this;if(!this.listens(t))return this;if(e){var r=this._events[t].indexOf(e);r>=0&&this._events[t].splice(r,1),this._events[t].length||delete this._events[t]}else delete this._events[t];return this},once:function(t,e){var r=function(n){this.off(t,r),e.call(this,n)}.bind(this);return this.on(t,r),this},fire:function(t,e){if(!this.listens(t))return n.endsWith(t,\"error\")&&console.error(e&&e.error||e||\"Empty error event\"),this;e=n.extend({},e),n.extend(e,{type:t,target:this});for(var r=this._events[t].slice(),i=0;i<r.length;i++)r[i].call(this,e);return this},listens:function(t){return!(!this._events||!this._events[t])}};e.exports=i},{\"./util\":441}],434:[function(t,e,r){\"use strict\";function n(t,e){this.stacks=t.readFields(i,[],e)}function i(t,e,r){if(1===t){var n=r.readMessage(a,{glyphs:{}});e.push(n)}}function a(t,e,r){if(1===t)e.name=r.readString();else if(2===t)e.range=r.readString();else if(3===t){var n=r.readMessage(o,{});e.glyphs[n.id]=n}}function o(t,e,r){1===t?e.id=r.readVarint():2===t?e.bitmap=r.readBytes():3===t?e.width=r.readVarint():4===t?e.height=r.readVarint():5===t?e.left=r.readSVarint():6===t?e.top=r.readSVarint():7===t&&(e.advance=r.readVarint())}e.exports=n},{}],435:[function(t,e,r){\"use strict\";function n(t,e,r){return t*(1-r)+e*r}e.exports=n,n.number=n,n.vec2=function(t,e,r){return[n(t[0],e[0],r),n(t[1],e[1],r)]},n.color=function(t,e,r){return[n(t[0],e[0],r),n(t[1],e[1],r),n(t[2],e[2],r),n(t[3],e[3],r)]},n.array=function(t,e,r){return t.map(function(t,i){return n(t,e[i],r)})}},{}],436:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<t.length;n++)for(var i=t[n],a=0;a<e.length;a++)for(var o=e[a],s=0;s<o.length;s++){var l=o[s];if(d(i,l))return!0;if(c(l,i,r))return!0}return!1}function i(t,e){if(1===t.length&&1===t[0].length)return f(e,t[0][0]);for(var r=0;r<e.length;r++)for(var n=e[r],i=0;i<n.length;i++)if(f(t,n[i]))return!0;for(var a=0;a<t.length;a++){for(var o=t[a],l=0;l<o.length;l++)if(f(e,o[l]))return!0;for(var u=0;u<e.length;u++)if(s(o,e[u]))return!0}return!1}function a(t,e,r){for(var n=0;n<e.length;n++)for(var i=e[n],a=0;a<t.length;a++){var s=t[a];if(s.length>=3)for(var l=0;l<i.length;l++)if(d(s,i[l]))return!0;if(o(s,i,r))return!0}return!1}function o(t,e,r){if(t.length>1){if(s(t,e))return!0;for(var n=0;n<e.length;n++)if(c(e[n],t,r))return!0}for(var i=0;i<t.length;i++)if(c(t[i],e,r))return!0;return!1}function s(t,e){for(var r=0;r<t.length-1;r++)for(var n=t[r],i=t[r+1],a=0;a<e.length-1;a++){var o=e[a],s=e[a+1];if(u(n,i,o,s))return!0}return!1}function l(t,e,r){return(r.y-t.y)*(e.x-t.x)>(e.y-t.y)*(r.x-t.x)}function u(t,e,r,n){return l(t,r,n)!==l(e,r,n)&&l(t,e,r)!==l(t,e,n)}function c(t,e,r){var n=r*r;if(1===e.length)return t.distSqr(e[0])<n;for(var i=1;i<e.length;i++){if(h(t,e[i-1],e[i])<n)return!0}return!1}function h(t,e,r){var n=e.distSqr(r);if(0===n)return t.distSqr(e);var i=((t.x-e.x)*(r.x-e.x)+(t.y-e.y)*(r.y-e.y))/n;return i<0?t.distSqr(e):i>1?t.distSqr(r):t.distSqr(r.sub(e)._mult(i)._add(e))}function f(t,e){for(var r,n,i,a=!1,o=0;o<t.length;o++){r=t[o];for(var s=0,l=r.length-1;s<r.length;l=s++)n=r[s],i=r[l],n.y>e.y!=i.y>e.y&&e.x<(i.x-n.x)*(e.y-n.y)/(i.y-n.y)+n.x&&(a=!a)}return a}function d(t,e){for(var r=!1,n=0,i=t.length-1;n<t.length;i=n++){var a=t[n],o=t[i];a.y>e.y!=o.y>e.y&&e.x<(o.x-a.x)*(e.y-a.y)/(o.y-a.y)+a.x&&(r=!r)}return r}e.exports={multiPolygonIntersectsBufferedMultiPoint:n,multiPolygonIntersectsMultiPolygon:i,multiPolygonIntersectsBufferedMultiLine:a}},{}],437:[function(t,e,r){\"use strict\";function n(t,e){this.max=t,this.onRemove=e,this.reset()}e.exports=n,n.prototype.reset=function(){for(var t in this.data)this.onRemove(this.data[t]);return this.data={},this.order=[],this},n.prototype.add=function(t,e){if(this.has(t))this.order.splice(this.order.indexOf(t),1),this.data[t]=e,this.order.push(t);else if(this.data[t]=e,this.order.push(t),this.order.length>this.max){var r=this.get(this.order[0]);r&&this.onRemove(r)}return this},n.prototype.has=function(t){return t in this.data},n.prototype.keys=function(){return this.order},n.prototype.get=function(t){if(!this.has(t))return null;var e=this.data[t];return delete this.data[t],this.order.splice(this.order.indexOf(t),1),e},n.prototype.setMaxSize=function(t){for(this.max=t;this.order.length>this.max;){var e=this.get(this.order[0]);e&&this.onRemove(e)}return this}},{}],438:[function(t,e,r){\"use strict\";function n(t,e,r){if(!(r=r||o.ACCESS_TOKEN)&&o.REQUIRE_ACCESS_TOKEN)throw new Error(\"An API access token is required to use Mapbox GL. See https://www.mapbox.com/developers/api/#access-tokens\");if(t=t.replace(/^mapbox:\\/\\//,o.API_URL+e),\n",
       "t+=-1!==t.indexOf(\"?\")?\"&access_token=\":\"?access_token=\",o.REQUIRE_ACCESS_TOKEN){if(\"s\"===r[0])throw new Error(\"Use a public access token (pk.*) with Mapbox GL JS, not a secret access token (sk.*). See https://www.mapbox.com/developers/api/#access-tokens\");t+=r}return t}function i(t){return t?\"?\"+t:\"\"}function a(t){return t.access_token&&\"tk.\"===t.access_token.slice(0,3)?u.extend({},t,{access_token:o.ACCESS_TOKEN}):t}var o=t(\"./config\"),s=t(\"./browser\"),l=t(\"url\"),u=t(\"./util\");e.exports.normalizeStyleURL=function(t,e){var r=l.parse(t);return\"mapbox:\"!==r.protocol?t:n(\"mapbox:/\"+r.pathname+i(r.query),\"/styles/v1/\",e)},e.exports.normalizeSourceURL=function(t,e){return\"mapbox:\"!==l.parse(t).protocol?t:n(t+\".json\",\"/v4/\",e)+\"&secure\"},e.exports.normalizeGlyphsURL=function(t,e){var r=l.parse(t);return\"mapbox:\"!==r.protocol?t:n(\"mapbox://\"+r.pathname.split(\"/\")[1]+\"/{fontstack}/{range}.pbf\"+i(r.query),\"/fonts/v1/\",e)},e.exports.normalizeSpriteURL=function(t,e,r,a){var o=l.parse(t);return\"mapbox:\"!==o.protocol?(o.pathname+=e+r,l.format(o)):n(\"mapbox:/\"+o.pathname+\"/sprite\"+e+r+i(o.query),\"/styles/v1/\",a)},e.exports.normalizeTileURL=function(t,e,r){var n=l.parse(t,!0);if(!e)return t;if(\"mapbox:\"!==l.parse(e).protocol)return t;var i=s.supportsWebp?\".webp\":\"$1\",o=s.devicePixelRatio>=2||512===r?\"@2x\":\"\";return l.format({protocol:n.protocol,hostname:n.hostname,pathname:n.pathname.replace(/(\\.(?:png|jpg)\\d*)/,o+i),query:a(n.query)})}},{\"./browser\":425,\"./config\":430,\"./util\":441,url:544}],439:[function(t,e,r){\"use strict\";function n(t){function e(){f.apply(this,arguments)}function r(){d.apply(this,arguments),this.members=e.prototype.members}var n=JSON.stringify(t);if(v[n])return v[n];void 0===t.alignment&&(t.alignment=1),e.prototype=Object.create(f.prototype);var s=0,u=0,g=[\"Uint8\"];return e.prototype.members=t.members.map(function(r){r={name:r.name,type:r.type,components:r.components||1},p(r.name.length),p(r.type in m),g.indexOf(r.type)<0&&g.push(r.type);var n=o(r.type);u=Math.max(u,n),r.offset=s=a(s,Math.max(t.alignment,n));for(var i=0;i<r.components;i++)Object.defineProperty(e.prototype,r.name+(1===r.components?\"\":i),{get:c(r,i),set:h(r,i)});return s+=n*r.components,r}),e.prototype.alignment=t.alignment,e.prototype.size=a(s,Math.max(u,t.alignment)),r.serialize=i,r.prototype=Object.create(d.prototype),r.prototype.StructType=e,r.prototype.bytesPerElement=e.prototype.size,r.prototype.emplaceBack=l(e.prototype.members,e.prototype.size),r.prototype._usedTypes=g,v[n]=r,r}function i(){return{members:this.prototype.StructType.prototype.members,alignment:this.prototype.StructType.prototype.alignment,bytesPerElement:this.prototype.bytesPerElement}}function a(t,e){return Math.ceil(t/e)*e}function o(t){return m[t].BYTES_PER_ELEMENT}function s(t){return t.toLowerCase()}function l(t,e){for(var r=[],n=[],i=\"var i = this.length;\\nthis.resize(this.length + 1);\\n\",a=0;a<t.length;a++){var l=t[a],u=o(l.type);r.indexOf(u)<0&&(r.push(u),i+=\"var o\"+u.toFixed(0)+\" = i * \"+(e/u).toFixed(0)+\";\\n\");for(var c=0;c<l.components;c++){var h=\"v\"+n.length,f=\"o\"+u.toFixed(0)+\" + \"+(l.offset/u+c).toFixed(0);i+=\"this.\"+s(l.type)+\"[\"+f+\"] = \"+h+\";\\n\",n.push(h)}}return i+=\"return i;\",new Function(n,i)}function u(t,e){var r=\"this._pos\"+o(t.type).toFixed(0),n=(t.offset/o(t.type)+e).toFixed(0),i=r+\" + \"+n;return\"this._structArray.\"+s(t.type)+\"[\"+i+\"]\"}function c(t,e){return new Function([],\"return \"+u(t,e)+\";\")}function h(t,e){return new Function([\"x\"],u(t,e)+\" = x;\")}function f(t,e){this._structArray=t,this._pos1=e*this.size,this._pos2=this._pos1/2,this._pos4=this._pos1/4,this._pos8=this._pos1/8}function d(t){void 0!==t?(this.arrayBuffer=t.arrayBuffer,this.length=t.length,this.capacity=this.arrayBuffer.byteLength/this.bytesPerElement,this._refreshViews()):(this.capacity=-1,this.resize(0))}var p=t(\"assert\");e.exports=n;var m={Int8:Int8Array,Uint8:Uint8Array,Uint8Clamped:Uint8ClampedArray,Int16:Int16Array,Uint16:Uint16Array,Int32:Int32Array,Uint32:Uint32Array,Float32:Float32Array,Float64:Float64Array},v={};d.prototype.DEFAULT_CAPACITY=128,d.prototype.RESIZE_MULTIPLIER=5,d.prototype.serialize=function(){return this.trim(),{length:this.length,arrayBuffer:this.arrayBuffer}},d.prototype.get=function(t){return new this.StructType(this,t)},d.prototype.trim=function(){this.length!==this.capacity&&(this.capacity=this.length,this.arrayBuffer=this.arrayBuffer.slice(0,this.length*this.bytesPerElement),this._refreshViews())},d.prototype.resize=function(t){if(this.length=t,t>this.capacity){this.capacity=Math.max(t,Math.floor(this.capacity*this.RESIZE_MULTIPLIER),this.DEFAULT_CAPACITY),this.arrayBuffer=new ArrayBuffer(this.capacity*this.bytesPerElement);var e=this.uint8;this._refreshViews(),e&&this.uint8.set(e)}},d.prototype._refreshViews=function(){for(var t=0;t<this._usedTypes.length;t++){var e=this._usedTypes[t];this[s(e)]=new m[e](this.arrayBuffer)}},d.prototype.toArray=function(t,e){for(var r=[],n=t;n<e;n++){var i=this.get(n);r.push(i)}return r}},{assert:46}],440:[function(t,e,r){\"use strict\";function n(t,e){return e.replace(/{([^{}]+)}/g,function(e,r){return r in t?t[r]:\"\"})}e.exports=n},{}],441:[function(t,e,r){\"use strict\";var n=t(\"unitbezier\"),i=t(\"../geo/coordinate\");r.easeCubicInOut=function(t){if(t<=0)return 0;if(t>=1)return 1;var e=t*t,r=e*t;return 4*(t<.5?r:3*(t-e)+r-.75)},r.bezier=function(t,e,r,i){var a=new n(t,e,r,i);return function(t){return a.solve(t)}},r.ease=r.bezier(.25,.1,.25,1),r.clamp=function(t,e,r){return Math.min(r,Math.max(e,t))},r.wrap=function(t,e,r){var n=r-e,i=((t-e)%n+n)%n+e;return i===e?r:i},r.coalesce=function(){for(var t=0;t<arguments.length;t++){var e=arguments[t];if(null!==e&&void 0!==e)return e}},r.asyncAll=function(t,e,r){if(!t.length)return r(null,[]);var n=t.length,i=new Array(t.length),a=null;t.forEach(function(t,o){e(t,function(t,e){t&&(a=t),i[o]=e,0==--n&&r(a,i)})})},r.keysDifference=function(t,e){var r=[];for(var n in t)n in e||r.push(n);return r},r.extend=function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)t[n]=r[n]}return t},r.extendAll=function(t,e){for(var r in e)Object.defineProperty(t,r,Object.getOwnPropertyDescriptor(e,r));return t},r.inherit=function(t,e){var n=\"function\"==typeof t?t.prototype:t,i=Object.create(n);return r.extendAll(i,e),i},r.pick=function(t,e){for(var r={},n=0;n<e.length;n++){var i=e[n];i in t&&(r[i]=t[i])}return r};var a=1;r.uniqueId=function(){return a++},r.debounce=function(t,e){var r,n;return function(){n=arguments,clearTimeout(r),r=setTimeout(function(){t.apply(null,n)},e)}},r.bindAll=function(t,e){t.forEach(function(t){e[t]&&(e[t]=e[t].bind(e))})},r.bindHandlers=function(t){for(var e in t)\"function\"==typeof t[e]&&0===e.indexOf(\"_on\")&&(t[e]=t[e].bind(t))},r.setOptions=function(t,e){t.hasOwnProperty(\"options\")||(t.options=t.options?Object.create(t.options):{});for(var r in e)t.options[r]=e[r];return t.options},r.getCoordinatesCenter=function(t){for(var e=1/0,r=1/0,n=-1/0,a=-1/0,o=0;o<t.length;o++)e=Math.min(e,t[o].column),r=Math.min(r,t[o].row),n=Math.max(n,t[o].column),a=Math.max(a,t[o].row);var s=n-e,l=a-r,u=Math.max(s,l);return new i((e+n)/2,(r+a)/2,0).zoomTo(Math.floor(-Math.log(u)/Math.LN2))},r.endsWith=function(t,e){return-1!==t.indexOf(e,t.length-e.length)},r.startsWith=function(t,e){return 0===t.indexOf(e)},r.mapObject=function(t,e,r){var n={};for(var i in t)n[i]=e.call(r||this,t[i],i,t);return n},r.filterObject=function(t,e,r){var n={};for(var i in t)e.call(r||this,t[i],i,t)&&(n[i]=t[i]);return n},r.deepEqual=function t(e,r){if(Array.isArray(e)){if(!Array.isArray(r)||e.length!==r.length)return!1;for(var n=0;n<e.length;n++)if(!t(e[n],r[n]))return!1;return!0}if(\"object\"==typeof e&&null!==e&&null!==r){if(\"object\"!=typeof r)return!1;if(Object.keys(e).length!==Object.keys(r).length)return!1;for(var i in e)if(!t(e[i],r[i]))return!1;return!0}return e===r},r.clone=function(t){return Array.isArray(t)?t.map(r.clone):\"object\"==typeof t?r.mapObject(t,r.clone):t},r.arraysIntersect=function(t,e){for(var r=0;r<t.length;r++)if(e.indexOf(t[r])>=0)return!0;return!1};var o={};r.warnOnce=function(t){o[t]||(\"undefined\"!=typeof console&&console.warn(t),o[t]=!0)}},{\"../geo/coordinate\":337,unitbezier:543}],442:[function(t,e,r){\"use strict\";function n(t,e,r,n){this._vectorTileFeature=t,t._z=e,t._x=r,t._y=n,this.properties=t.properties,null!=t.id&&(this.id=t.id)}e.exports=n,n.prototype={type:\"Feature\",get geometry(){return void 0===this._geometry&&(this._geometry=this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x,this._vectorTileFeature._y,this._vectorTileFeature._z).geometry),this._geometry},set geometry(t){this._geometry=t},toJSON:function(){var t={};for(var e in this)\"_geometry\"!==e&&\"_vectorTileFeature\"!==e&&\"toJSON\"!==e&&(t[e]=this[e]);return t}}},{}],443:[function(t,e,r){e.exports={_args:[[{raw:\"mapbox-gl@^0.22.0\",scope:null,escapedName:\"mapbox-gl\",name:\"mapbox-gl\",rawSpec:\"^0.22.0\",spec:\">=0.22.0 <0.23.0\",type:\"range\"},\"/home/etienne/Documents/plotly/plotly.js\"]],_from:\"mapbox-gl@>=0.22.0 <0.23.0\",_id:\"mapbox-gl@0.22.1\",_inCache:!0,_location:\"/mapbox-gl\",_nodeVersion:\"4.4.5\",_npmOperationalInternal:{host:\"packages-12-west.internal.npmjs.com\",tmp:\"tmp/mapbox-gl-0.22.1.tgz_1471549891670_0.8762630566488951\"},_npmUser:{name:\"lucaswoj\",email:\"lucas@lucaswoj.com\"},_npmVersion:\"2.15.5\",_phantomChildren:{},_requested:{raw:\"mapbox-gl@^0.22.0\",scope:null,escapedName:\"mapbox-gl\",name:\"mapbox-gl\",rawSpec:\"^0.22.0\",spec:\">=0.22.0 <0.23.0\",type:\"range\"},_requiredBy:[\"/\"],_resolved:\"https://registry.npmjs.org/mapbox-gl/-/mapbox-gl-0.22.1.tgz\",_shasum:\"92a965547d4c2f24c22cbc487eeda48694cb627a\",_shrinkwrap:null,_spec:\"mapbox-gl@^0.22.0\",_where:\"/home/etienne/Documents/plotly/plotly.js\",browser:{\"./js/util/ajax.js\":\"./js/util/browser/ajax.js\",\"./js/util/browser.js\":\"./js/util/browser/browser.js\",\"./js/util/canvas.js\":\"./js/util/browser/canvas.js\",\"./js/util/dom.js\":\"./js/util/browser/dom.js\",\"./js/util/web_worker.js\":\"./js/util/browser/web_worker.js\"},bugs:{url:\"https://github.com/mapbox/mapbox-gl-js/issues\"},dependencies:{csscolorparser:\"^1.0.2\",earcut:\"^2.0.3\",\"feature-filter\":\"^2.2.0\",\"geojson-rewind\":\"^0.1.0\",\"geojson-vt\":\"^2.4.0\",\"gl-matrix\":\"^2.3.1\",\"grid-index\":\"^1.0.0\",\"mapbox-gl-function\":\"^1.2.1\",\"mapbox-gl-shaders\":\"github:mapbox/mapbox-gl-shaders#de2ab007455aa2587c552694c68583f94c9f2747\",\"mapbox-gl-style-spec\":\"github:mapbox/mapbox-gl-style-spec#83b1a3e5837d785af582efd5ed1a212f2df6a4ae\",\"mapbox-gl-supported\":\"^1.2.0\",pbf:\"^1.3.2\",pngjs:\"^2.2.0\",\"point-geometry\":\"^0.0.0\",quickselect:\"^1.0.0\",request:\"^2.39.0\",\"resolve-url\":\"^0.2.1\",\"shelf-pack\":\"^1.0.0\",supercluster:\"^2.0.1\",unassertify:\"^2.0.0\",unitbezier:\"^0.0.0\",\"vector-tile\":\"^1.3.0\",\"vt-pbf\":\"^2.0.2\",webworkify:\"^1.3.0\",\"whoots-js\":\"^2.0.0\"},description:\"A WebGL interactive maps library\",devDependencies:{\"babel-preset-react\":\"^6.11.1\",babelify:\"^7.3.0\",benchmark:\"~2.1.0\",browserify:\"^13.0.0\",clipboard:\"^1.5.12\",\"concat-stream\":\"1.5.1\",coveralls:\"^2.11.8\",doctrine:\"^1.2.1\",documentation:\"https://github.com/documentationjs/documentation/archive/bb41619c734e59ef3fbc3648610032efcfdaaace.tar.gz\",\"documentation-theme-utils\":\"3.0.0\",envify:\"^3.4.0\",eslint:\"^2.5.3\",\"eslint-config-mourner\":\"^2.0.0\",\"eslint-plugin-html\":\"^1.5.1\",gl:\"^4.0.1\",handlebars:\"4.0.5\",\"highlight.js\":\"9.3.0\",istanbul:\"^0.4.2\",\"json-loader\":\"^0.5.4\",lodash:\"^4.13.1\",\"mapbox-gl-test-suite\":\"github:mapbox/mapbox-gl-test-suite#7babab52fb02788ebbc38384139bf350e8e38552\",\"memory-fs\":\"^0.3.0\",minifyify:\"^7.0.1\",\"npm-run-all\":\"^3.0.0\",nyc:\"6.4.0\",proxyquire:\"^1.7.9\",remark:\"4.2.2\",\"remark-html\":\"3.0.0\",sinon:\"^1.15.4\",st:\"^1.2.0\",tap:\"^5.7.0\",\"transform-loader\":\"^0.2.3\",\"unist-util-visit\":\"1.1.0\",vinyl:\"1.1.1\",\"vinyl-fs\":\"2.4.3\",watchify:\"^3.7.0\",webpack:\"^1.13.1\",\"webworkify-webpack\":\"^1.1.3\"},directories:{},dist:{shasum:\"92a965547d4c2f24c22cbc487eeda48694cb627a\",tarball:\"https://registry.npmjs.org/mapbox-gl/-/mapbox-gl-0.22.1.tgz\"},engines:{node:\">=4.0.0\"},gitHead:\"13a9015341f0602ccb55c98c53079838ad4b70b5\",homepage:\"https://github.com/mapbox/mapbox-gl-js#readme\",license:\"BSD-3-Clause\",main:\"js/mapbox-gl.js\",maintainers:[{name:\"aaronlidman\",email:\"aaronlidman@gmail.com\"},{name:\"ajashton\",email:\"aj.ashton@gmail.com\"},{name:\"ansis\",email:\"ansis.brammanis@gmail.com\"},{name:\"bergwerkgis\",email:\"wb@bergwerk-gis.at\"},{name:\"bhousel\",email:\"bryan@mapbox.com\"},{name:\"bsudekum\",email:\"bobby@mapbox.com\"},{name:\"camilleanne\",email:\"camille@mapbox.com\"},{name:\"dnomadb\",email:\"damon@mapbox.com\"},{name:\"dthompson\",email:\"dthompson@gmail.com\"},{name:\"emilymcafee\",email:\"emily@mapbox.com\"},{name:\"flippmoke\",email:\"flippmoke@gmail.com\"},{name:\"freenerd\",email:\"spam@freenerd.de\"},{name:\"gretacb\",email:\"carol@mapbox.com\"},{name:\"ian29\",email:\"ian.villeda@gmail.com\"},{name:\"ianshward\",email:\"ian@mapbox.com\"},{name:\"ingalls\",email:\"nicholas.ingalls@gmail.com\"},{name:\"jfirebaugh\",email:\"john.firebaugh@gmail.com\"},{name:\"jrpruit1\",email:\"jake@jakepruitt.com\"},{name:\"karenzshea\",email:\"karen@mapbox.com\"},{name:\"kkaefer\",email:\"kkaefer@gmail.com\"},{name:\"lbud\",email:\"lauren@mapbox.com\"},{name:\"lucaswoj\",email:\"lucas@lucaswoj.com\"},{name:\"lxbarth\",email:\"alex@mapbox.com\"},{name:\"lyzidiamond\",email:\"lyzi@mapbox.com\"},{name:\"mapbox-admin\",email:\"accounts@mapbox.com\"},{name:\"mateov\",email:\"matt@mapbox.com\"},{name:\"mcwhittemore\",email:\"mcwhittemore@gmail.com\"},{name:\"miccolis\",email:\"jeff@miccolis.net\"},{name:\"mikemorris\",email:\"michael.patrick.morris@gmail.com\"},{name:\"morganherlocker\",email:\"morgan.herlocker@gmail.com\"},{name:\"mourner\",email:\"agafonkin@gmail.com\"},{name:\"nickidlugash\",email:\"nicki@mapbox.com\"},{name:\"rclark\",email:\"ryan.clark.j@gmail.com\"},{name:\"samanbb\",email:\"saman@mapbox.com\"},{name:\"sbma44\",email:\"tlee@mapbox.com\"},{name:\"scothis\",email:\"scothis@gmail.com\"},{name:\"sgillies\",email:\"sean@mapbox.com\"},{name:\"springmeyer\",email:\"dane@mapbox.com\"},{name:\"themarex\",email:\"patrick@mapbox.com\"},{name:\"tmcw\",email:\"tom@macwright.org\"},{name:\"tristen\",email:\"tristen.brown@gmail.com\"},{name:\"willwhite\",email:\"will@mapbox.com\"},{name:\"yhahn\",email:\"young@mapbox.com\"}],name:\"mapbox-gl\",optionalDependencies:{},readme:\"ERROR: No README data found!\",repository:{type:\"git\",url:\"git://github.com/mapbox/mapbox-gl-js.git\"},scripts:{build:\"npm run build-docs # invoked by publisher when publishing docs on the mb-pages branch\",\"build-dev\":\"browserify js/mapbox-gl.js --debug --standalone mapboxgl > dist/mapbox-gl-dev.js && tap --no-coverage test/build/dev.test.js\",\"build-docs\":\"documentation build --github --format html -c documentation.yml --theme ./docs/_theme --output docs/api/\",\"build-min\":\"browserify js/mapbox-gl.js --debug -t unassertify --plugin [minifyify --map mapbox-gl.js.map --output dist/mapbox-gl.js.map] --standalone mapboxgl > dist/mapbox-gl.js && tap --no-coverage test/build/min.test.js\",\"build-token\":\"browserify debug/access-token-src.js --debug -t envify > debug/access-token.js\",lint:\"eslint  --ignore-path .gitignore js test bench docs/_posts/examples/*.html\",\"open-changed-examples\":\"git diff --name-only mb-pages HEAD -- docs/_posts/examples/*.html | awk '{print \\\"http://127.0.0.1:4000/mapbox-gl-js/example/\\\" substr($0,33,length($0)-37)}' | xargs open\",start:\"run-p build-token watch-dev watch-bench start-server\",\"start-bench\":\"run-p build-token watch-bench start-server\",\"start-debug\":\"run-p build-token watch-dev start-server\",\"start-docs\":\"npm run build-min && npm run build-docs && jekyll serve -w\",\"start-server\":\"st --no-cache --localhost --port 9966 --index index.html .\",test:\"npm run lint && tap --reporter dot test/js/*/*.js test/build/webpack.test.js\",\"test-suite\":\"node test/render.test.js && node test/query.test.js\",\"watch-bench\":\"node bench/download-data.js && watchify bench/index.js --plugin [minifyify --no-map] -t [babelify --presets react] -t unassertify -t envify -o bench/bench.js -v\",\"watch-dev\":\"watchify js/mapbox-gl.js --debug --standalone mapboxgl -o dist/mapbox-gl-dev.js -v\"},version:\"0.22.1\"}},{}],444:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=new Array(t),i=0;i<t;++i)n[i]=0,i===e&&(n[i]+=.5),i===r&&(n[i]+=.5);return n}function i(t,e){if(0===e||e===(1<<t+1)-1)return[];for(var r=[],i=[],a=0;a<=t;++a)if(e&1<<a){r.push(n(t,a-1,a-1)),i.push(null);for(var s=0;s<=t;++s)~e&1<<s&&(r.push(n(t,a-1,s-1)),i.push([a,s]))}var l=o(r),u=[];t:for(var a=0;a<l.length;++a){for(var c=l[a],h=[],s=0;s<c.length;++s){if(!i[c[s]])continue t;h.push(i[c[s]].slice())}u.push(h)}return u}function a(t){for(var e=1<<t+1,r=new Array(e),n=0;n<e;++n)r[n]=i(t,n);return r}e.exports=a;var o=t(\"convex-hull\")},{\"convex-hull\":102}],445:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t}function i(t,e){t[0][0]=e[0],t[0][1]=e[1],t[0][2]=e[2],t[1][0]=e[4],t[1][1]=e[5],t[1][2]=e[6],t[2][0]=e[8],t[2][1]=e[9],t[2][2]=e[10]}function a(t,e,r,n,i){t[0]=e[0]*n+r[0]*i,t[1]=e[1]*n+r[1]*i,t[2]=e[2]*n+r[2]*i}var o=t(\"./normalize\"),s=t(\"gl-mat4/create\"),l=t(\"gl-mat4/clone\"),u=t(\"gl-mat4/determinant\"),c=t(\"gl-mat4/invert\"),h=t(\"gl-mat4/transpose\"),f={length:t(\"gl-vec3/length\"),normalize:t(\"gl-vec3/normalize\"),dot:t(\"gl-vec3/dot\"),cross:t(\"gl-vec3/cross\")},d=s(),p=s(),m=[0,0,0,0],v=[[0,0,0],[0,0,0],[0,0,0]],g=[0,0,0];e.exports=function(t,e,r,s,y,b){if(e||(e=[0,0,0]),r||(r=[0,0,0]),s||(s=[0,0,0]),y||(y=[0,0,0,1]),b||(b=[0,0,0,1]),!o(d,t))return!1;if(l(p,d),p[3]=0,p[7]=0,p[11]=0,p[15]=1,Math.abs(u(p)<1e-8))return!1;var x=d[3],_=d[7],w=d[11],M=d[12],k=d[13],A=d[14],T=d[15];if(0!==x||0!==_||0!==w){m[0]=x,m[1]=_,m[2]=w,m[3]=T;if(!c(p,p))return!1;h(p,p),n(y,m,p)}else y[0]=y[1]=y[2]=0,y[3]=1;if(e[0]=M,e[1]=k,e[2]=A,i(v,d),r[0]=f.length(v[0]),f.normalize(v[0],v[0]),s[0]=f.dot(v[0],v[1]),a(v[1],v[1],v[0],1,-s[0]),r[1]=f.length(v[1]),f.normalize(v[1],v[1]),s[0]/=r[1],s[1]=f.dot(v[0],v[2]),a(v[2],v[2],v[0],1,-s[1]),s[2]=f.dot(v[1],v[2]),a(v[2],v[2],v[1],1,-s[2]),r[2]=f.length(v[2]),f.normalize(v[2],v[2]),s[1]/=r[2],s[2]/=r[2],f.cross(g,v[1],v[2]),f.dot(v[0],g)<0)for(var S=0;S<3;S++)r[S]*=-1,v[S][0]*=-1,v[S][1]*=-1,v[S][2]*=-1;return b[0]=.5*Math.sqrt(Math.max(1+v[0][0]-v[1][1]-v[2][2],0)),b[1]=.5*Math.sqrt(Math.max(1-v[0][0]+v[1][1]-v[2][2],0)),b[2]=.5*Math.sqrt(Math.max(1-v[0][0]-v[1][1]+v[2][2],0)),b[3]=.5*Math.sqrt(Math.max(1+v[0][0]+v[1][1]+v[2][2],0)),v[2][1]>v[1][2]&&(b[0]=-b[0]),v[0][2]>v[2][0]&&(b[1]=-b[1]),v[1][0]>v[0][1]&&(b[2]=-b[2]),!0}},{\"./normalize\":446,\"gl-mat4/clone\":174,\"gl-mat4/create\":175,\"gl-mat4/determinant\":176,\"gl-mat4/invert\":180,\"gl-mat4/transpose\":190,\"gl-vec3/cross\":271,\"gl-vec3/dot\":272,\"gl-vec3/length\":273,\"gl-vec3/normalize\":275}],446:[function(t,e,r){e.exports=function(t,e){var r=e[15];if(0===r)return!1;for(var n=1/r,i=0;i<16;i++)t[i]=e[i]*n;return!0}},{}],447:[function(t,e,r){function n(t,e,r,n){if(0===c(e)||0===c(r))return!1;var i=u(e,f.translate,f.scale,f.skew,f.perspective,f.quaternion),a=u(r,d.translate,d.scale,d.skew,d.perspective,d.quaternion);return!(!i||!a)&&(s(p.translate,f.translate,d.translate,n),s(p.skew,f.skew,d.skew,n),s(p.scale,f.scale,d.scale,n),s(p.perspective,f.perspective,d.perspective,n),h(p.quaternion,f.quaternion,d.quaternion,n),l(t,p.translate,p.scale,p.skew,p.perspective,p.quaternion),!0)}function i(){return{translate:a(),scale:a(1),skew:a(),perspective:o(),quaternion:o()}}function a(t){return[t||0,t||0,t||0]}function o(){return[0,0,0,1]}var s=t(\"gl-vec3/lerp\"),l=t(\"mat4-recompose\"),u=t(\"mat4-decompose\"),c=t(\"gl-mat4/determinant\"),h=t(\"quat-slerp\"),f=i(),d=i(),p=i();e.exports=n},{\"gl-mat4/determinant\":176,\"gl-vec3/lerp\":274,\"mat4-decompose\":445,\"mat4-recompose\":448,\"quat-slerp\":488}],448:[function(t,e,r){var n={identity:t(\"gl-mat4/identity\"),translate:t(\"gl-mat4/translate\"),multiply:t(\"gl-mat4/multiply\"),create:t(\"gl-mat4/create\"),scale:t(\"gl-mat4/scale\"),fromRotationTranslation:t(\"gl-mat4/fromRotationTranslation\")},i=(n.create(),n.create());e.exports=function(t,e,r,a,o,s){return n.identity(t),n.fromRotationTranslation(t,s,e),t[3]=o[0],t[7]=o[1],t[11]=o[2],t[15]=o[3],n.identity(i),0!==a[2]&&(i[9]=a[2],n.multiply(t,t,i)),0!==a[1]&&(i[9]=0,i[8]=a[1],n.multiply(t,t,i)),0!==a[0]&&(i[8]=0,i[4]=a[0],n.multiply(t,t,i)),n.scale(t,t,r),t}},{\"gl-mat4/create\":175,\"gl-mat4/fromRotationTranslation\":178,\"gl-mat4/identity\":179,\"gl-mat4/multiply\":182,\"gl-mat4/scale\":188,\"gl-mat4/translate\":189}],449:[function(t,e,r){\"use strict\";function n(t){this._components=t.slice(),this._time=[0],this.prevMatrix=t.slice(),this.nextMatrix=t.slice(),this.computedMatrix=t.slice(),this.computedInverse=t.slice(),this.computedEye=[0,0,0],this.computedUp=[0,0,0],this.computedCenter=[0,0,0],this.computedRadius=[0],this._limits=[-1/0,1/0]}function i(t){return t=t||{},new n(t.matrix||[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])}var a=t(\"binary-search-bounds\"),o=t(\"mat4-interpolate\"),s=t(\"gl-mat4/invert\"),l=t(\"gl-mat4/rotateX\"),u=t(\"gl-mat4/rotateY\"),c=t(\"gl-mat4/rotateZ\"),h=t(\"gl-mat4/lookAt\"),f=t(\"gl-mat4/translate\"),d=(t(\"gl-mat4/scale\"),t(\"gl-vec3/normalize\")),p=[0,0,0];e.exports=i;var m=n.prototype;m.recalcMatrix=function(t){var e=this._time,r=a.le(e,t),n=this.computedMatrix;if(!(r<0)){var i=this._components;if(r===e.length-1)for(var l=16*r,u=0;u<16;++u)n[u]=i[l++];else{for(var c=e[r+1]-e[r],l=16*r,h=this.prevMatrix,f=!0,u=0;u<16;++u)h[u]=i[l++];for(var p=this.nextMatrix,u=0;u<16;++u)p[u]=i[l++],f=f&&h[u]===p[u];if(c<1e-6||f)for(var u=0;u<16;++u)n[u]=h[u];else o(n,h,p,(t-e[r])/c)}var m=this.computedUp;m[0]=n[1],m[1]=n[5],m[2]=n[9],d(m,m);var v=this.computedInverse;s(v,n);var g=this.computedEye,y=v[15];g[0]=v[12]/y,g[1]=v[13]/y,g[2]=v[14]/y;for(var b=this.computedCenter,x=Math.exp(this.computedRadius[0]),u=0;u<3;++u)b[u]=g[u]-n[2+4*u]*x}},m.idle=function(t){if(!(t<this.lastT())){for(var e=this._components,r=e.length-16,n=0;n<16;++n)e.push(e[r++]);this._time.push(t)}},m.flush=function(t){var e=a.gt(this._time,t)-2;e<0||(this._time.splice(0,e),this._components.splice(0,16*e))},m.lastT=function(){return this._time[this._time.length-1]},m.lookAt=function(t,e,r,n){this.recalcMatrix(t),e=e||this.computedEye,r=r||p,n=n||this.computedUp,this.setMatrix(t,h(this.computedMatrix,e,r,n));for(var i=0,a=0;a<3;++a)i+=Math.pow(r[a]-e[a],2);i=Math.log(Math.sqrt(i)),this.computedRadius[0]=i},m.rotate=function(t,e,r,n){this.recalcMatrix(t);var i=this.computedInverse;e&&u(i,i,e),r&&l(i,i,r),n&&c(i,i,n),this.setMatrix(t,s(this.computedMatrix,i))};var v=[0,0,0];m.pan=function(t,e,r,n){v[0]=-(e||0),v[1]=-(r||0),v[2]=-(n||0),this.recalcMatrix(t);var i=this.computedInverse;f(i,i,v),this.setMatrix(t,s(i,i))},m.translate=function(t,e,r,n){v[0]=e||0,v[1]=r||0,v[2]=n||0,this.recalcMatrix(t);var i=this.computedMatrix;f(i,i,v),this.setMatrix(t,i)},m.setMatrix=function(t,e){if(!(t<this.lastT())){this._time.push(t);for(var r=0;r<16;++r)this._components.push(e[r])}},m.setDistance=function(t,e){this.computedRadius[0]=e},m.setDistanceLimits=function(t,e){var r=this._limits;r[0]=t,r[1]=e},m.getDistanceLimits=function(t){var e=this._limits;return t?(t[0]=e[0],t[1]=e[1],t):e}},{\"binary-search-bounds\":65,\"gl-mat4/invert\":180,\"gl-mat4/lookAt\":181,\"gl-mat4/rotateX\":185,\"gl-mat4/rotateY\":186,\"gl-mat4/rotateZ\":187,\"gl-mat4/scale\":188,\"gl-mat4/translate\":189,\"gl-vec3/normalize\":275,\"mat4-interpolate\":447}],450:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e<3){for(var r=new Array(e),n=0;n<e;++n)r[n]=n;return 2===e&&t[0][0]===t[1][0]&&t[0][1]===t[1][1]?[0]:r}for(var a=new Array(e),n=0;n<e;++n)a[n]=n;a.sort(function(e,r){var n=t[e][0]-t[r][0];return n||t[e][1]-t[r][1]});for(var o=[a[0],a[1]],s=[a[0],a[1]],n=2;n<e;++n){for(var l=a[n],u=t[l],c=o.length;c>1&&i(t[o[c-2]],t[o[c-1]],u)<=0;)c-=1,o.pop();for(o.push(l),c=s.length;c>1&&i(t[s[c-2]],t[s[c-1]],u)>=0;)c-=1,s.pop();s.push(l)}for(var r=new Array(s.length+o.length-2),h=0,n=0,f=o.length;n<f;++n)r[h++]=o[n];for(var d=s.length-2;d>0;--d)r[h++]=s[d];return r}e.exports=n;var i=t(\"robust-orientation\")[3]},{\"robust-orientation\":507}],451:[function(t,e,r){\"use strict\";function n(t,e){function r(t){var e=!1;return\"altKey\"in t&&(e=e||t.altKey!==v.alt,v.alt=!!t.altKey),\"shiftKey\"in t&&(e=e||t.shiftKey!==v.shift,v.shift=!!t.shiftKey),\"ctrlKey\"in t&&(e=e||t.ctrlKey!==v.control,v.control=!!t.ctrlKey),\"metaKey\"in t&&(e=e||t.metaKey!==v.meta,v.meta=!!t.metaKey),e}function n(t,n){var a=i.x(n),o=i.y(n);\"buttons\"in n&&(t=0|n.buttons),(t!==d||a!==p||o!==m||r(n))&&(d=0|t,p=a||0,m=o||0,e&&e(d,p,m,v))}function a(t){n(0,t)}function o(){(d||p||m||v.shift||v.alt||v.meta||v.control)&&(p=m=0,d=0,v.shift=v.alt=v.control=v.meta=!1,e&&e(0,0,0,v))}function s(t){r(t)&&e&&e(d,p,m,v)}function l(t){0===i.buttons(t)?n(0,t):n(d,t)}function u(t){n(d|i.buttons(t),t)}function c(t){n(d&~i.buttons(t),t)}function h(){g||(g=!0,t.addEventListener(\"mousemove\",l),t.addEventListener(\"mousedown\",u),t.addEventListener(\"mouseup\",c),t.addEventListener(\"mouseleave\",a),t.addEventListener(\"mouseenter\",a),t.addEventListener(\"mouseout\",a),t.addEventListener(\"mouseover\",a),t.addEventListener(\"blur\",o),t.addEventListener(\"keyup\",s),t.addEventListener(\"keydown\",s),t.addEventListener(\"keypress\",s),t!==window&&(window.addEventListener(\"blur\",o),window.addEventListener(\"keyup\",s),window.addEventListener(\"keydown\",s),window.addEventListener(\"keypress\",s)))}function f(){g&&(g=!1,t.removeEventListener(\"mousemove\",l),t.removeEventListener(\"mousedown\",u),t.removeEventListener(\"mouseup\",c),t.removeEventListener(\"mouseleave\",a),t.removeEventListener(\"mouseenter\",a),t.removeEventListener(\"mouseout\",a),t.removeEventListener(\"mouseover\",a),t.removeEventListener(\"blur\",o),t.removeEventListener(\"keyup\",s),t.removeEventListener(\"keydown\",s),t.removeEventListener(\"keypress\",s),t!==window&&(window.removeEventListener(\"blur\",o),window.removeEventListener(\"keyup\",s),window.removeEventListener(\"keydown\",s),window.removeEventListener(\"keypress\",s)))}e||(e=t,t=window);var d=0,p=0,m=0,v={shift:!1,alt:!1,control:!1,meta:!1},g=!1;h();var y={element:t};return Object.defineProperties(y,{enabled:{get:function(){return g},set:function(t){t?h():f()},enumerable:!0},buttons:{get:function(){return d},enumerable:!0},x:{get:function(){return p},enumerable:!0},y:{get:function(){return m},enumerable:!0},mods:{get:function(){return v},enumerable:!0}}),y}e.exports=n;var i=t(\"mouse-event\")},{\"mouse-event\":453}],452:[function(t,e,r){function n(t,e,r){e=e||t.currentTarget||t.srcElement,Array.isArray(r)||(r=[0,0]);var n=t.clientX||0,a=t.clientY||0,o=i(e);return r[0]=n-o.left,r[1]=a-o.top,r}function i(t){return t===window||t===document||t===document.body?a:t.getBoundingClientRect()}var a={left:0,top:0};e.exports=n},{}],453:[function(t,e,r){\"use strict\";function n(t){if(\"object\"==typeof t){if(\"buttons\"in t)return t.buttons;if(\"which\"in t){var e=t.which;if(2===e)return 4;if(3===e)return 2;if(e>0)return 1<<e-1}else if(\"button\"in t){var e=t.button;if(1===e)return 4;if(2===e)return 2;if(e>=0)return 1<<e}}return 0}function i(t){return t.target||t.srcElement||window}function a(t){if(\"object\"==typeof t){if(\"offsetX\"in t)return t.offsetX;var e=i(t),r=e.getBoundingClientRect();return t.clientX-r.left}return 0}function o(t){if(\"object\"==typeof t){if(\"offsetY\"in t)return t.offsetY;var e=i(t),r=e.getBoundingClientRect();return t.clientY-r.top}return 0}r.buttons=n,r.element=i,r.x=a,r.y=o},{}],454:[function(t,e,r){\"use strict\";function n(t,e,r){\"function\"==typeof t&&(r=!!e,e=t,t=window);var n=i(\"ex\",t),a=function(t){r&&t.preventDefault();var i=t.deltaX||0,a=t.deltaY||0,o=t.deltaZ||0,s=t.deltaMode,l=1;switch(s){case 1:l=n;break;case 2:l=window.innerHeight}if(i*=l,a*=l,o*=l,i||a||o)return e(i,a,o,t)};return t.addEventListener(\"wheel\",a),a}var i=t(\"to-px\");e.exports=n},{\"to-px\":534}],455:[function(t,e,r){\"use strict\";function n(t){return\"a\"+t}function i(t){return\"d\"+t}function a(t,e){return\"c\"+t+\"_\"+e}function o(t){return\"s\"+t}function s(t,e){return\"t\"+t+\"_\"+e}function l(t){return\"o\"+t}function u(t){return\"x\"+t}function c(t){return\"p\"+t}function h(t,e){return\"d\"+t+\"_\"+e}function f(t){return\"i\"+t}function d(t,e){return\"u\"+t+\"_\"+e}function p(t){return\"b\"+t}function m(t){return\"y\"+t}function v(t){return\"e\"+t}function g(t){return\"v\"+t}function y(t,e,r){for(var n=0,i=0;i<t;++i)e&1<<i&&(n|=1<<r[i]);return n}function b(t,e,r,b,x,E){function L(t,e){j.push(\"for(\",f(x[t]),\"=\",e,\";\",f(x[t]),\"<\",o(x[t]),\";\",\"++\",f(x[t]),\"){\")}function C(t){for(var e=0;e<O;++e)j.push(c(e),\"+=\",d(e,x[t]),\";\");j.push(\"}\")}function z(t){for(var e=t-1;e>=0;--e)L(e,0);for(var r=[],e=0;e<O;++e)E[e]?r.push(i(e)+\".get(\"+c(e)+\")\"):r.push(i(e)+\"[\"+c(e)+\"]\");for(var e=0;e<b;++e)r.push(u(e));j.push(M,\"[\",T,\"++]=phase(\",r.join(),\");\");for(var e=0;e<t;++e)C(e);for(var n=0;n<O;++n)j.push(c(n),\"+=\",d(n,x[t]),\";\")}function I(t){for(var e=0;e<O;++e)E[e]?j.push(a(e,0),\"=\",i(e),\".get(\",c(e),\");\"):j.push(a(e,0),\"=\",i(e),\"[\",c(e),\"];\");for(var r=[],e=0;e<O;++e)r.push(a(e,0));for(var e=0;e<b;++e)r.push(u(e));j.push(p(0),\"=\",M,\"[\",T,\"]=phase(\",r.join(),\");\");for(var n=1;n<1<<R;++n)j.push(p(n),\"=\",M,\"[\",T,\"+\",v(n),\"];\");for(var o=[],n=1;n<1<<R;++n)o.push(\"(\"+p(0)+\"!==\"+p(n)+\")\");j.push(\"if(\",o.join(\"||\"),\"){\");for(var s=[],e=0;e<R;++e)s.push(f(e));for(var e=0;e<O;++e){s.push(a(e,0));for(var n=1;n<1<<R;++n)E[e]?j.push(a(e,n),\"=\",i(e),\".get(\",c(e),\"+\",h(e,n),\");\"):j.push(a(e,n),\"=\",i(e),\"[\",c(e),\"+\",h(e,n),\"];\"),s.push(a(e,n))}for(var e=0;e<1<<R;++e)s.push(p(e));for(var e=0;e<b;++e)s.push(u(e));j.push(\"vertex(\",s.join(),\");\",g(0),\"=\",w,\"[\",T,\"]=\",k,\"++;\");for(var l=(1<<R)-1,d=p(l),n=0;n<R;++n)if(0==(t&~(1<<n))){for(var m=l^1<<n,y=p(m),x=[],_=m;_>0;_=_-1&m)x.push(w+\"[\"+T+\"+\"+v(_)+\"]\");x.push(g(0));for(var _=0;_<O;++_)1&n?x.push(a(_,l),a(_,m)):x.push(a(_,m),a(_,l));1&n?x.push(d,y):x.push(y,d);for(var _=0;_<b;++_)x.push(u(_));j.push(\"if(\",d,\"!==\",y,\"){\",\"face(\",x.join(),\")}\")}j.push(\"}\",T,\"+=1;\")}function D(){for(var t=1;t<1<<R;++t)j.push(S,\"=\",v(t),\";\",v(t),\"=\",m(t),\";\",m(t),\"=\",S,\";\")}function P(t,e){if(t<0)return void I(e);z(t),j.push(\"if(\",o(x[t]),\">0){\",f(x[t]),\"=1;\"),P(t-1,e|1<<x[t]);for(var r=0;r<O;++r)j.push(c(r),\"+=\",d(r,x[t]),\";\");t===R-1&&(j.push(T,\"=0;\"),D()),L(t,2),P(t-1,e),t===R-1&&(j.push(\"if(\",f(x[R-1]),\"&1){\",T,\"=0;}\"),D()),C(t),j.push(\"}\")}var O=E.length,R=x.length;if(R<2)throw new Error(\"ndarray-extract-contour: Dimension must be at least 2\");for(var F=\"extractContour\"+x.join(\"_\"),j=[],N=[],B=[],U=0;U<O;++U)B.push(n(U));for(var U=0;U<b;++U)B.push(u(U));for(var U=0;U<R;++U)N.push(o(U)+\"=\"+n(0)+\".shape[\"+U+\"]|0\");for(var U=0;U<O;++U){N.push(i(U)+\"=\"+n(U)+\".data\",l(U)+\"=\"+n(U)+\".offset|0\");for(var V=0;V<R;++V)N.push(s(U,V)+\"=\"+n(U)+\".stride[\"+V+\"]|0\")}for(var U=0;U<O;++U){N.push(c(U)+\"=\"+l(U)),N.push(a(U,0));for(var V=1;V<1<<R;++V){for(var H=[],q=0;q<R;++q)V&1<<q&&H.push(\"-\"+s(U,q));N.push(h(U,V)+\"=(\"+H.join(\"\")+\")|0\"),N.push(a(U,V)+\"=0\")}}for(var U=0;U<O;++U)for(var V=0;V<R;++V){var G=[s(U,x[V])];V>0&&G.push(s(U,x[V-1])+\"*\"+o(x[V-1])),N.push(d(U,x[V])+\"=(\"+G.join(\"-\")+\")|0\")}for(var U=0;U<R;++U)N.push(f(U)+\"=0\");N.push(k+\"=0\");for(var Y=[\"2\"],U=R-2;U>=0;--U)Y.push(o(x[U]));N.push(A+\"=(\"+Y.join(\"*\")+\")|0\",M+\"=mallocUint32(\"+A+\")\",w+\"=mallocUint32(\"+A+\")\",T+\"=0\"),N.push(p(0)+\"=0\");for(var V=1;V<1<<R;++V){for(var X=[],W=[],q=0;q<R;++q)V&1<<q&&(0===W.length?X.push(\"1\"):X.unshift(W.join(\"*\"))),W.push(o(x[q]));var Z=\"\";X[0].indexOf(o(x[R-2]))<0&&(Z=\"-\");var J=y(R,V,x);N.push(v(J)+\"=(-\"+X.join(\"-\")+\")|0\",m(J)+\"=(\"+Z+X.join(\"-\")+\")|0\",p(J)+\"=0\")}N.push(g(0)+\"=0\",S+\"=0\"),P(R-1,0),j.push(\"freeUint32(\",w,\");freeUint32(\",M,\");\");var K=[\"'use strict';\",\"function \",F,\"(\",B.join(),\"){\",\"var \",N.join(),\";\",j.join(\"\"),\"}\",\"return \",F].join(\"\");return new Function(\"vertex\",\"face\",\"phase\",\"mallocUint32\",\"freeUint32\",K)(t,e,r,_.mallocUint32,_.freeUint32)}function x(t){function e(t){throw new Error(\"ndarray-extract-contour: \"+t)}\"object\"!=typeof t&&e(\"Must specify arguments\");var r=t.order;Array.isArray(r)||e(\"Must specify order\");var n=t.arrayArguments||1;n<1&&e(\"Must have at least one array argument\");var i=t.scalarArguments||0;i<0&&e(\"Scalar arg count must be > 0\"),\n",
       "\"function\"!=typeof t.vertex&&e(\"Must specify vertex creation function\"),\"function\"!=typeof t.cell&&e(\"Must specify cell creation function\"),\"function\"!=typeof t.phase&&e(\"Must specify phase function\");for(var a=t.getters||[],o=new Array(n),s=0;s<n;++s)a.indexOf(s)>=0?o[s]=!0:o[s]=!1;return b(t.vertex,t.cell,t.phase,i,r,o)}var _=t(\"typedarray-pool\");e.exports=x;var w=\"V\",M=\"P\",k=\"N\",A=\"Q\",T=\"X\",S=\"T\"},{\"typedarray-pool\":540}],456:[function(t,e,r){\"use strict\";var n=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{_inline_7_arg1_=_inline_7_arg2_.apply(void 0,_inline_7_arg0_)}\",args:[{name:\"_inline_7_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_7_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_7_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"cwise\",blockSize:64});e.exports=function(t,e){return n(t,e),t}},{\"cwise/lib/wrapper\":112}],457:[function(t,e,r){\"use strict\";function n(t){if(t in l)return l[t];for(var e=[],r=0;r<t;++r)e.push(\"out\",r,\"s=0.5*(inp\",r,\"l-inp\",r,\"r);\");for(var n=[\"array\"],i=[\"junk\"],r=0;r<t;++r){n.push(\"array\"),i.push(\"out\"+r+\"s\");var a=o(t);a[r]=-1,n.push({array:0,offset:a.slice()}),a[r]=1,n.push({array:0,offset:a.slice()}),i.push(\"inp\"+r+\"l\",\"inp\"+r+\"r\")}return l[t]=s({args:n,pre:c,post:c,body:{body:e.join(\"\"),args:i.map(function(t){return{name:t,lvalue:0===t.indexOf(\"out\"),rvalue:0===t.indexOf(\"inp\"),count:\"junk\"!==t|0}}),thisVars:[],localVars:[]},funcName:\"fdTemplate\"+t})}function i(t){var e=t.join(),r=u[e];if(r)return r;for(var i=t.length,a=[\"function gradient(dst,src){var s=src.shape.slice();\"],o=0;o<1<<i;++o){for(var s=[],c=0;c<i;++c)o&1<<c&&s.push(c+1);for(var d=0;d<1<<s.length;++d){for(var p=s.slice(),c=0;c<s.length;++c)d&1<<c&&(p[c]=-p[c]);!function(e){for(var r=i-e.length,n=[],o=[],s=[],l=0;l<i;++l)e.indexOf(l+1)>=0?s.push(\"0\"):e.indexOf(-(l+1))>=0?s.push(\"s[\"+l+\"]-1\"):(s.push(\"-1\"),n.push(\"1\"),o.push(\"s[\"+l+\"]-2\"));var u=\".lo(\"+n.join()+\").hi(\"+o.join()+\")\";if(0===n.length&&(u=\"\"),r>0){a.push(\"if(1\");for(var l=0;l<i;++l)e.indexOf(l+1)>=0||e.indexOf(-(l+1))>=0||a.push(\"&&s[\",l,\"]>2\");a.push(\"){grad\",r,\"(src.pick(\",s.join(),\")\",u);for(var l=0;l<i;++l)e.indexOf(l+1)>=0||e.indexOf(-(l+1))>=0||a.push(\",dst.pick(\",s.join(),\",\",l,\")\",u);a.push(\");\")}for(var l=0;l<e.length;++l){var c=Math.abs(e[l])-1,h=\"dst.pick(\"+s.join()+\",\"+c+\")\"+u;switch(t[c]){case\"clamp\":var f=s.slice(),d=s.slice();e[l]<0?f[c]=\"s[\"+c+\"]-2\":d[c]=\"1\",0===r?a.push(\"if(s[\",c,\"]>1){dst.set(\",s.join(),\",\",c,\",0.5*(src.get(\",f.join(),\")-src.get(\",d.join(),\")))}else{dst.set(\",s.join(),\",\",c,\",0)};\"):a.push(\"if(s[\",c,\"]>1){diff(\",h,\",src.pick(\",f.join(),\")\",u,\",src.pick(\",d.join(),\")\",u,\");}else{zero(\",h,\");};\");break;case\"mirror\":0===r?a.push(\"dst.set(\",s.join(),\",\",c,\",0);\"):a.push(\"zero(\",h,\");\");break;case\"wrap\":var p=s.slice(),m=s.slice();e[l]<0?(p[c]=\"s[\"+c+\"]-2\",m[c]=\"0\"):(p[c]=\"s[\"+c+\"]-1\",m[c]=\"1\"),0===r?a.push(\"if(s[\",c,\"]>2){dst.set(\",s.join(),\",\",c,\",0.5*(src.get(\",p.join(),\")-src.get(\",m.join(),\")))}else{dst.set(\",s.join(),\",\",c,\",0)};\"):a.push(\"if(s[\",c,\"]>2){diff(\",h,\",src.pick(\",p.join(),\")\",u,\",src.pick(\",m.join(),\")\",u,\");}else{zero(\",h,\");};\");break;default:throw new Error(\"ndarray-gradient: Invalid boundary condition\")}}r>0&&a.push(\"};\")}(p)}}a.push(\"return dst;};return gradient\");for(var m=[\"diff\",\"zero\"],v=[h,f],o=1;o<=i;++o)m.push(\"grad\"+o),v.push(n(o));m.push(a.join(\"\"));var g=Function.apply(void 0,m),r=g.apply(void 0,v);return l[e]=r,r}function a(t,e,r){if(Array.isArray(r)){if(r.length!==e.dimension)throw new Error(\"ndarray-gradient: invalid boundary conditions\")}else r=\"string\"==typeof r?o(e.dimension,r):o(e.dimension,\"clamp\");if(t.dimension!==e.dimension+1)throw new Error(\"ndarray-gradient: output dimension must be +1 input dimension\");if(t.shape[e.dimension]!==e.dimension)throw new Error(\"ndarray-gradient: output shape must match input shape\");for(var n=0;n<e.dimension;++n)if(t.shape[n]!==e.shape[n])throw new Error(\"ndarray-gradient: shape mismatch\");return 0===e.size?t:e.dimension<=0?(t.set(0),t):i(r)(t,e)}e.exports=a;var o=t(\"dup\"),s=t(\"cwise-compiler\"),l={},u={},c={body:\"\",args:[],thisVars:[],localVars:[]},h=s({args:[\"array\",\"array\",\"array\"],pre:c,post:c,body:{args:[{name:\"out\",lvalue:!0,rvalue:!1,count:1},{name:\"left\",lvalue:!1,rvalue:!0,count:1},{name:\"right\",lvalue:!1,rvalue:!0,count:1}],body:\"out=0.5*(left-right)\",thisVars:[],localVars:[]},funcName:\"cdiff\"}),f=s({args:[\"array\"],pre:c,post:c,body:{args:[{name:\"out\",lvalue:!0,rvalue:!1,count:1}],body:\"out=0\",thisVars:[],localVars:[]},funcName:\"zero\"})},{\"cwise-compiler\":109,dup:124}],458:[function(t,e,r){\"use strict\";function n(t,e,r){var n=e.dimension,o=a([],r);return i(t,e,function(t,e){for(var r=0;r<n;++r){t[r]=o[(n+1)*n+r];for(var i=0;i<n;++i)t[r]+=o[(n+1)*i+r]*e[i]}for(var a=o[(n+1)*(n+1)-1],i=0;i<n;++i)a+=o[(n+1)*i+n]*e[i];for(var s=1/a,r=0;r<n;++r)t[r]*=s;return t}),t}var i=t(\"ndarray-warp\"),a=t(\"gl-matrix-invert\");e.exports=n},{\"gl-matrix-invert\":191,\"ndarray-warp\":465}],459:[function(t,e,r){\"use strict\";function n(t,e){var r=Math.floor(e),n=e-r,i=0<=r&&r<t.shape[0],a=0<=r+1&&r+1<t.shape[0];return(1-n)*(i?+t.get(r):0)+n*(a?+t.get(r+1):0)}function i(t,e,r){var n=Math.floor(e),i=e-n,a=0<=n&&n<t.shape[0],o=0<=n+1&&n+1<t.shape[0],s=Math.floor(r),l=r-s,u=0<=s&&s<t.shape[1],c=0<=s+1&&s+1<t.shape[1],h=a&&u?t.get(n,s):0,f=a&&c?t.get(n,s+1):0;return(1-l)*((1-i)*h+i*(o&&u?t.get(n+1,s):0))+l*((1-i)*f+i*(o&&c?t.get(n+1,s+1):0))}function a(t,e,r,n){var i=Math.floor(e),a=e-i,o=0<=i&&i<t.shape[0],s=0<=i+1&&i+1<t.shape[0],l=Math.floor(r),u=r-l,c=0<=l&&l<t.shape[1],h=0<=l+1&&l+1<t.shape[1],f=Math.floor(n),d=n-f,p=0<=f&&f<t.shape[2],m=0<=f+1&&f+1<t.shape[2],v=o&&c&&p?t.get(i,l,f):0,g=o&&h&&p?t.get(i,l+1,f):0,y=s&&c&&p?t.get(i+1,l,f):0,b=s&&h&&p?t.get(i+1,l+1,f):0,x=o&&c&&m?t.get(i,l,f+1):0,_=o&&h&&m?t.get(i,l+1,f+1):0;return(1-d)*((1-u)*((1-a)*v+a*y)+u*((1-a)*g+a*b))+d*((1-u)*((1-a)*x+a*(s&&c&&m?t.get(i+1,l,f+1):0))+u*((1-a)*_+a*(s&&h&&m?t.get(i+1,l+1,f+1):0)))}function o(t){var e,r,n=0|t.shape.length,i=new Array(n),a=new Array(n),o=new Array(n),s=new Array(n);for(e=0;e<n;++e)r=+arguments[e+1],i[e]=Math.floor(r),a[e]=r-i[e],o[e]=0<=i[e]&&i[e]<t.shape[e],s[e]=0<=i[e]+1&&i[e]+1<t.shape[e];var l,u,c,h=0;t:for(e=0;e<1<<n;++e){for(u=1,c=t.offset,l=0;l<n;++l)if(e&1<<l){if(!s[l])continue t;u*=a[l],c+=t.stride[l]*(i[l]+1)}else{if(!o[l])continue t;u*=1-a[l],c+=t.stride[l]*i[l]}h+=u*t.data[c]}return h}function s(t,e,r,s){switch(t.shape.length){case 0:return 0;case 1:return n(t,e);case 2:return i(t,e,r);case 3:return a(t,e,r,s);default:return o.apply(void 0,arguments)}}e.exports=s,e.exports.d1=n,e.exports.d2=i,e.exports.d3=a},{}],460:[function(t,e,r){\"use strict\";function n(t){if(!t)return s;for(var e=0;e<t.args.length;++e){var r=t.args[e];t.args[e]=0===e?{name:r,lvalue:!0,rvalue:!!t.rvalue,count:t.count||1}:{name:r,lvalue:!1,rvalue:!0,count:1}}return t.thisVars||(t.thisVars=[]),t.localVars||(t.localVars=[]),t}function i(t){return o({args:t.args,pre:n(t.pre),body:n(t.body),post:n(t.proc),funcName:t.funcName})}function a(t){for(var e=[],r=0;r<t.args.length;++r)e.push(\"a\"+r);return new Function(\"P\",[\"return function \",t.funcName,\"_ndarrayops(\",e.join(\",\"),\") {P(\",e.join(\",\"),\");return a0}\"].join(\"\"))(i(t))}var o=t(\"cwise-compiler\"),s={body:\"\",args:[],thisVars:[],localVars:[]},l={add:\"+\",sub:\"-\",mul:\"*\",div:\"/\",mod:\"%\",band:\"&\",bor:\"|\",bxor:\"^\",lshift:\"<<\",rshift:\">>\",rrshift:\">>>\"};!function(){for(var t in l){var e=l[t];r[t]=a({args:[\"array\",\"array\",\"array\"],body:{args:[\"a\",\"b\",\"c\"],body:\"a=b\"+e+\"c\"},funcName:t}),r[t+\"eq\"]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a\"+e+\"=b\"},rvalue:!0,funcName:t+\"eq\"}),r[t+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],body:{args:[\"a\",\"b\",\"s\"],body:\"a=b\"+e+\"s\"},funcName:t+\"s\"}),r[t+\"seq\"]=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"s\"],body:\"a\"+e+\"=s\"},rvalue:!0,funcName:t+\"seq\"})}}();var u={not:\"!\",bnot:\"~\",neg:\"-\",recip:\"1.0/\"};!function(){for(var t in u){var e=u[t];r[t]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=\"+e+\"b\"},funcName:t}),r[t+\"eq\"]=a({args:[\"array\"],body:{args:[\"a\"],body:\"a=\"+e+\"a\"},rvalue:!0,count:2,funcName:t+\"eq\"})}}();var c={and:\"&&\",or:\"||\",eq:\"===\",neq:\"!==\",lt:\"<\",gt:\">\",leq:\"<=\",geq:\">=\"};!function(){for(var t in c){var e=c[t];r[t]=a({args:[\"array\",\"array\",\"array\"],body:{args:[\"a\",\"b\",\"c\"],body:\"a=b\"+e+\"c\"},funcName:t}),r[t+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],body:{args:[\"a\",\"b\",\"s\"],body:\"a=b\"+e+\"s\"},funcName:t+\"s\"}),r[t+\"eq\"]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=a\"+e+\"b\"},rvalue:!0,count:2,funcName:t+\"eq\"}),r[t+\"seq\"]=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"s\"],body:\"a=a\"+e+\"s\"},rvalue:!0,count:2,funcName:t+\"seq\"})}}();var h=[\"abs\",\"acos\",\"asin\",\"atan\",\"ceil\",\"cos\",\"exp\",\"floor\",\"log\",\"round\",\"sin\",\"sqrt\",\"tan\"];!function(){for(var t=0;t<h.length;++t){var e=h[t];r[e]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b)\",thisVars:[\"this_f\"]},funcName:e}),r[e+\"eq\"]=a({args:[\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\"],body:\"a=this_f(a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"eq\"})}}();var f=[\"max\",\"min\",\"atan2\",\"pow\"];!function(){for(var t=0;t<f.length;++t){var e=f[t];r[e]=a({args:[\"array\",\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(b,c)\",thisVars:[\"this_f\"]},funcName:e}),r[e+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(b,c)\",thisVars:[\"this_f\"]},funcName:e+\"s\"}),r[e+\"eq\"]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(a,b)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"eq\"}),r[e+\"seq\"]=a({args:[\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(a,b)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"seq\"})}}();var d=[\"atan2\",\"pow\"];!function(){for(var t=0;t<d.length;++t){var e=d[t];r[e+\"op\"]=a({args:[\"array\",\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(c,b)\",thisVars:[\"this_f\"]},funcName:e+\"op\"}),r[e+\"ops\"]=a({args:[\"array\",\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(c,b)\",thisVars:[\"this_f\"]},funcName:e+\"ops\"}),r[e+\"opeq\"]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b,a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"opeq\"}),r[e+\"opseq\"]=a({args:[\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b,a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"opseq\"})}}(),r.any=o({args:[\"array\"],pre:s,body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"if(a){return true}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return false\"},funcName:\"any\"}),r.all=o({args:[\"array\"],pre:s,body:{args:[{name:\"x\",lvalue:!1,rvalue:!0,count:1}],body:\"if(!x){return false}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return true\"},funcName:\"all\"}),r.sum=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"this_s+=a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"sum\"}),r.prod=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=1\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"this_s*=a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"prod\"}),r.norm2squared=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:2}],body:\"this_s+=a*a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norm2squared\"}),r.norm2=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:2}],body:\"this_s+=a*a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return Math.sqrt(this_s)\"},funcName:\"norm2\"}),r.norminf=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:4}],body:\"if(-a>this_s){this_s=-a}else if(a>this_s){this_s=a}\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norminf\"}),r.norm1=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:3}],body:\"this_s+=a<0?-a:a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norm1\"}),r.sup=o({args:[\"array\"],pre:{body:\"this_h=-Infinity\",args:[],thisVars:[\"this_h\"],localVars:[]},body:{body:\"if(_inline_1_arg0_>this_h)this_h=_inline_1_arg0_\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_h\"],localVars:[]},post:{body:\"return this_h\",args:[],thisVars:[\"this_h\"],localVars:[]}}),r.inf=o({args:[\"array\"],pre:{body:\"this_h=Infinity\",args:[],thisVars:[\"this_h\"],localVars:[]},body:{body:\"if(_inline_1_arg0_<this_h)this_h=_inline_1_arg0_\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_h\"],localVars:[]},post:{body:\"return this_h\",args:[],thisVars:[\"this_h\"],localVars:[]}}),r.argmin=o({args:[\"index\",\"array\",\"shape\"],pre:{body:\"{this_v=Infinity;this_i=_inline_0_arg2_.slice(0)}\",args:[{name:\"_inline_0_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_i\",\"this_v\"],localVars:[]},body:{body:\"{if(_inline_1_arg1_<this_v){this_v=_inline_1_arg1_;for(var _inline_1_k=0;_inline_1_k<_inline_1_arg0_.length;++_inline_1_k){this_i[_inline_1_k]=_inline_1_arg0_[_inline_1_k]}}}\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_i\",\"this_v\"],localVars:[\"_inline_1_k\"]},post:{body:\"{return this_i}\",args:[],thisVars:[\"this_i\"],localVars:[]}}),r.argmax=o({args:[\"index\",\"array\",\"shape\"],pre:{body:\"{this_v=-Infinity;this_i=_inline_0_arg2_.slice(0)}\",args:[{name:\"_inline_0_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_i\",\"this_v\"],localVars:[]},body:{body:\"{if(_inline_1_arg1_>this_v){this_v=_inline_1_arg1_;for(var _inline_1_k=0;_inline_1_k<_inline_1_arg0_.length;++_inline_1_k){this_i[_inline_1_k]=_inline_1_arg0_[_inline_1_k]}}}\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_i\",\"this_v\"],localVars:[\"_inline_1_k\"]},post:{body:\"{return this_i}\",args:[],thisVars:[\"this_i\"],localVars:[]}}),r.random=a({args:[\"array\"],pre:{args:[],body:\"this_f=Math.random\",thisVars:[\"this_f\"]},body:{args:[\"a\"],body:\"a=this_f()\",thisVars:[\"this_f\"]},funcName:\"random\"}),r.assign=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=b\"},funcName:\"assign\"}),r.assigns=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"b\"],body:\"a=b\"},funcName:\"assigns\"}),r.equals=o({args:[\"array\",\"array\"],pre:s,body:{args:[{name:\"x\",lvalue:!1,rvalue:!0,count:1},{name:\"y\",lvalue:!1,rvalue:!0,count:1}],body:\"if(x!==y){return false}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return true\"},funcName:\"equals\"})},{\"cwise-compiler\":109}],461:[function(t,e,r){\"use strict\";var n=t(\"ndarray\"),i=t(\"./doConvert.js\");e.exports=function(t,e){for(var r=[],a=t,o=1;Array.isArray(a);)r.push(a.length),o*=a.length,a=a[0];return 0===r.length?n():(e||(e=n(new Float64Array(o),r)),i(e,t),e)}},{\"./doConvert.js\":462,ndarray:466}],462:[function(t,e,r){e.exports=t(\"cwise-compiler\")({args:[\"array\",\"scalar\",\"index\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{\\nvar _inline_1_v=_inline_1_arg1_,_inline_1_i\\nfor(_inline_1_i=0;_inline_1_i<_inline_1_arg2_.length-1;++_inline_1_i) {\\n_inline_1_v=_inline_1_v[_inline_1_arg2_[_inline_1_i]]\\n}\\n_inline_1_arg0_=_inline_1_v[_inline_1_arg2_[_inline_1_arg2_.length-1]]\\n}\",args:[{name:\"_inline_1_arg0_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg2_\",lvalue:!1,rvalue:!0,count:4}],thisVars:[],localVars:[\"_inline_1_i\",\"_inline_1_v\"]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},funcName:\"convert\",blockSize:64})},{\"cwise-compiler\":109}],463:[function(t,e,r){\"use strict\";function n(t){switch(t){case\"uint8\":return[l.mallocUint8,l.freeUint8];case\"uint16\":return[l.mallocUint16,l.freeUint16];case\"uint32\":return[l.mallocUint32,l.freeUint32];case\"int8\":return[l.mallocInt8,l.freeInt8];case\"int16\":return[l.mallocInt16,l.freeInt16];case\"int32\":return[l.mallocInt32,l.freeInt32];case\"float32\":return[l.mallocFloat,l.freeFloat];case\"float64\":return[l.mallocDouble,l.freeDouble];default:return null}}function i(t){for(var e=[],r=0;r<t;++r)e.push(\"s\"+r);for(var r=0;r<t;++r)e.push(\"n\"+r);for(var r=1;r<t;++r)e.push(\"d\"+r);for(var r=1;r<t;++r)e.push(\"e\"+r);for(var r=1;r<t;++r)e.push(\"f\"+r);return e}function a(t,e){function r(t){return\"generic\"===e?[\"data.get(\",t,\")\"].join(\"\"):[\"data[\",t,\"]\"].join(\"\")}function a(t,r){return\"generic\"===e?[\"data.set(\",t,\",\",r,\")\"].join(\"\"):[\"data[\",t,\"]=\",r].join(\"\")}var o=[\"'use strict'\"],s=[\"ndarrayInsertionSort\",t.join(\"d\"),e].join(\"\"),l=[\"left\",\"right\",\"data\",\"offset\"].concat(i(t.length)),u=n(e),c=[\"i,j,cptr,ptr=left*s0+offset\"];if(t.length>1){for(var h=[],f=1;f<t.length;++f)c.push(\"i\"+f),h.push(\"n\"+f);u?c.push(\"scratch=malloc(\"+h.join(\"*\")+\")\"):c.push(\"scratch=new Array(\"+h.join(\"*\")+\")\"),c.push(\"dptr\",\"sptr\",\"a\",\"b\")}else c.push(\"scratch\");if(o.push([\"function \",s,\"(\",l.join(\",\"),\"){var \",c.join(\",\")].join(\"\"),\"for(i=left+1;i<=right;++i){\",\"j=i;ptr+=s0\",\"cptr=ptr\"),t.length>1){o.push(\"dptr=0;sptr=ptr\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(\"scratch[dptr++]=\",r(\"sptr\"));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push(\"sptr+=d\"+d,\"}\")}o.push(\"__g:while(j--\\x3eleft){\",\"dptr=0\",\"sptr=cptr-s0\");for(var f=1;f<t.length;++f)1===f&&o.push(\"__l:\"),o.push([\"for(i\",f,\"=0;i\",f,\"<n\",f,\";++i\",f,\"){\"].join(\"\"));o.push([\"a=\",r(\"sptr\"),\"\\nb=scratch[dptr]\\nif(a<b){break __g}\\nif(a>b){break __l}\"].join(\"\"));for(var f=t.length-1;f>=1;--f)o.push(\"sptr+=e\"+f,\"dptr+=f\"+f,\"}\");o.push(\"dptr=cptr;sptr=cptr-s0\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(a(\"dptr\",r(\"sptr\")));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push([\"dptr+=d\",d,\";sptr+=d\",d].join(\"\"),\"}\")}o.push(\"cptr-=s0\\n}\"),o.push(\"dptr=cptr;sptr=0\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(a(\"dptr\",\"scratch[sptr++]\"));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push(\"dptr+=d\"+d,\"}\")}}else o.push(\"scratch=\"+r(\"ptr\"),\"while((j--\\x3eleft)&&(\"+r(\"cptr-s0\")+\">scratch)){\",a(\"cptr\",r(\"cptr-s0\")),\"cptr-=s0\",\"}\",a(\"cptr\",\"scratch\"));if(o.push(\"}\"),t.length>1&&u&&o.push(\"free(scratch)\"),o.push(\"} return \"+s),u){var p=new Function(\"malloc\",\"free\",o.join(\"\\n\"));return p(u[0],u[1])}var p=new Function(o.join(\"\\n\"));return p()}function o(t,e,r){function a(t){return[\"(offset+\",t,\"*s0)\"].join(\"\")}function o(t){return\"generic\"===e?[\"data.get(\",t,\")\"].join(\"\"):[\"data[\",t,\"]\"].join(\"\")}function s(t,r){return\"generic\"===e?[\"data.set(\",t,\",\",r,\")\"].join(\"\"):[\"data[\",t,\"]=\",r].join(\"\")}function l(e,r,n){if(1===e.length)_.push(\"ptr0=\"+a(e[0]));else for(var i=0;i<e.length;++i)_.push([\"b_ptr\",i,\"=s0*\",e[i]].join(\"\"));r&&_.push(\"pivot_ptr=0\"),_.push(\"ptr_shift=offset\");for(var i=t.length-1;i>=0;--i){var o=t[i];0!==o&&_.push([\"for(i\",o,\"=0;i\",o,\"<n\",o,\";++i\",o,\"){\"].join(\"\"))}if(e.length>1)for(var i=0;i<e.length;++i)_.push([\"ptr\",i,\"=b_ptr\",i,\"+ptr_shift\"].join(\"\"));_.push(n),r&&_.push(\"++pivot_ptr\");for(var i=0;i<t.length;++i){var o=t[i];0!==o&&(e.length>1?_.push(\"ptr_shift+=d\"+o):_.push(\"ptr0+=d\"+o),_.push(\"}\"))}}function c(e,r,n,i){if(1===r.length)_.push(\"ptr0=\"+a(r[0]));else{for(var o=0;o<r.length;++o)_.push([\"b_ptr\",o,\"=s0*\",r[o]].join(\"\"));_.push(\"ptr_shift=offset\")}n&&_.push(\"pivot_ptr=0\"),e&&_.push(e+\":\");for(var o=1;o<t.length;++o)_.push([\"for(i\",o,\"=0;i\",o,\"<n\",o,\";++i\",o,\"){\"].join(\"\"));if(r.length>1)for(var o=0;o<r.length;++o)_.push([\"ptr\",o,\"=b_ptr\",o,\"+ptr_shift\"].join(\"\"));_.push(i);for(var o=t.length-1;o>=1;--o)n&&_.push(\"pivot_ptr+=f\"+o),r.length>1?_.push(\"ptr_shift+=e\"+o):_.push(\"ptr0+=e\"+o),_.push(\"}\")}function h(){t.length>1&&k&&_.push(\"free(pivot1)\",\"free(pivot2)\")}function f(e,r){var n=\"el\"+e,i=\"el\"+r;if(t.length>1){var s=\"__l\"+ ++A;c(s,[n,i],!1,[\"comp=\",o(\"ptr0\"),\"-\",o(\"ptr1\"),\"\\n\",\"if(comp>0){tmp0=\",n,\";\",n,\"=\",i,\";\",i,\"=tmp0;break \",s,\"}\\n\",\"if(comp<0){break \",s,\"}\"].join(\"\"))}else _.push([\"if(\",o(a(n)),\">\",o(a(i)),\"){tmp0=\",n,\";\",n,\"=\",i,\";\",i,\"=tmp0}\"].join(\"\"))}function d(e,r){t.length>1?l([e,r],!1,s(\"ptr0\",o(\"ptr1\"))):_.push(s(a(e),o(a(r))))}function p(e,r,n){if(t.length>1){var i=\"__l\"+ ++A;c(i,[r],!0,[e,\"=\",o(\"ptr0\"),\"-pivot\",n,\"[pivot_ptr]\\n\",\"if(\",e,\"!==0){break \",i,\"}\"].join(\"\"))}else _.push([e,\"=\",o(a(r)),\"-pivot\",n].join(\"\"))}function m(e,r){t.length>1?l([e,r],!1,[\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",\"tmp\")].join(\"\")):_.push([\"ptr0=\",a(e),\"\\n\",\"ptr1=\",a(r),\"\\n\",\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",\"tmp\")].join(\"\"))}function v(e,r,n){t.length>1?(l([e,r,n],!1,[\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",o(\"ptr2\")),\"\\n\",s(\"ptr2\",\"tmp\")].join(\"\")),_.push(\"++\"+r,\"--\"+n)):_.push([\"ptr0=\",a(e),\"\\n\",\"ptr1=\",a(r),\"\\n\",\"ptr2=\",a(n),\"\\n\",\"++\",r,\"\\n\",\"--\",n,\"\\n\",\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",o(\"ptr2\")),\"\\n\",s(\"ptr2\",\"tmp\")].join(\"\"))}function g(t,e){m(t,e),_.push(\"--\"+e)}function y(e,r,n){t.length>1?l([e,r],!0,[s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",[\"pivot\",n,\"[pivot_ptr]\"].join(\"\"))].join(\"\")):_.push(s(a(e),o(a(r))),s(a(r),\"pivot\"+n))}function b(e,r){_.push([\"if((\",r,\"-\",e,\")<=\",u,\"){\\n\",\"insertionSort(\",e,\",\",r,\",data,offset,\",i(t.length).join(\",\"),\")\\n\",\"}else{\\n\",w,\"(\",e,\",\",r,\",data,offset,\",i(t.length).join(\",\"),\")\\n\",\"}\"].join(\"\"))}function x(e,r,n){t.length>1?(_.push([\"__l\",++A,\":while(true){\"].join(\"\")),l([e],!0,[\"if(\",o(\"ptr0\"),\"!==pivot\",r,\"[pivot_ptr]){break __l\",A,\"}\"].join(\"\")),_.push(n,\"}\")):_.push([\"while(\",o(a(e)),\"===pivot\",r,\"){\",n,\"}\"].join(\"\"))}var _=[\"'use strict'\"],w=[\"ndarrayQuickSort\",t.join(\"d\"),e].join(\"\"),M=[\"left\",\"right\",\"data\",\"offset\"].concat(i(t.length)),k=n(e),A=0;_.push([\"function \",w,\"(\",M.join(\",\"),\"){\"].join(\"\"));var T=[\"sixth=((right-left+1)/6)|0\",\"index1=left+sixth\",\"index5=right-sixth\",\"index3=(left+right)>>1\",\"index2=index3-sixth\",\"index4=index3+sixth\",\"el1=index1\",\"el2=index2\",\"el3=index3\",\"el4=index4\",\"el5=index5\",\"less=left+1\",\"great=right-1\",\"pivots_are_equal=true\",\"tmp\",\"tmp0\",\"x\",\"y\",\"z\",\"k\",\"ptr0\",\"ptr1\",\"ptr2\",\"comp_pivot1=0\",\"comp_pivot2=0\",\"comp=0\"];if(t.length>1){for(var S=[],E=1;E<t.length;++E)S.push(\"n\"+E),T.push(\"i\"+E);for(var E=0;E<8;++E)T.push(\"b_ptr\"+E);T.push(\"ptr3\",\"ptr4\",\"ptr5\",\"ptr6\",\"ptr7\",\"pivot_ptr\",\"ptr_shift\",\"elementSize=\"+S.join(\"*\")),k?T.push(\"pivot1=malloc(elementSize)\",\"pivot2=malloc(elementSize)\"):T.push(\"pivot1=new Array(elementSize),pivot2=new Array(elementSize)\")}else T.push(\"pivot1\",\"pivot2\");if(_.push(\"var \"+T.join(\",\")),f(1,2),f(4,5),f(1,3),f(2,3),f(1,4),f(3,4),f(2,5),f(2,3),f(4,5),t.length>1?l([\"el1\",\"el2\",\"el3\",\"el4\",\"el5\",\"index1\",\"index3\",\"index5\"],!0,[\"pivot1[pivot_ptr]=\",o(\"ptr1\"),\"\\n\",\"pivot2[pivot_ptr]=\",o(\"ptr3\"),\"\\n\",\"pivots_are_equal=pivots_are_equal&&(pivot1[pivot_ptr]===pivot2[pivot_ptr])\\n\",\"x=\",o(\"ptr0\"),\"\\n\",\"y=\",o(\"ptr2\"),\"\\n\",\"z=\",o(\"ptr4\"),\"\\n\",s(\"ptr5\",\"x\"),\"\\n\",s(\"ptr6\",\"y\"),\"\\n\",s(\"ptr7\",\"z\")].join(\"\")):_.push([\"pivot1=\",o(a(\"el2\")),\"\\n\",\"pivot2=\",o(a(\"el4\")),\"\\n\",\"pivots_are_equal=pivot1===pivot2\\n\",\"x=\",o(a(\"el1\")),\"\\n\",\"y=\",o(a(\"el3\")),\"\\n\",\"z=\",o(a(\"el5\")),\"\\n\",s(a(\"index1\"),\"x\"),\"\\n\",s(a(\"index3\"),\"y\"),\"\\n\",s(a(\"index5\"),\"z\")].join(\"\")),d(\"index2\",\"left\"),d(\"index4\",\"right\"),_.push(\"if(pivots_are_equal){\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp\",\"k\",1),_.push(\"if(comp===0){continue}\"),_.push(\"if(comp<0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),_.push(\"while(true){\"),p(\"comp\",\"great\",1),_.push(\"if(comp>0){\"),_.push(\"great--\"),_.push(\"}else if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"break\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}else{\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp_pivot1\",\"k\",1),_.push(\"if(comp_pivot1<0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),p(\"comp_pivot2\",\"k\",2),_.push(\"if(comp_pivot2>0){\"),_.push(\"while(true){\"),p(\"comp\",\"great\",2),_.push(\"if(comp>0){\"),_.push(\"if(--great<k){break}\"),_.push(\"continue\"),_.push(\"}else{\"),p(\"comp\",\"great\",1),_.push(\"if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"}\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),y(\"left\",\"(less-1)\",1),y(\"right\",\"(great+1)\",2),b(\"left\",\"(less-2)\"),b(\"(great+2)\",\"right\"),_.push(\"if(pivots_are_equal){\"),h(),_.push(\"return\"),_.push(\"}\"),_.push(\"if(less<index1&&great>index5){\"),x(\"less\",1,\"++less\"),x(\"great\",2,\"--great\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp_pivot1\",\"k\",1),_.push(\"if(comp_pivot1===0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),p(\"comp_pivot2\",\"k\",2),_.push(\"if(comp_pivot2===0){\"),_.push(\"while(true){\"),p(\"comp\",\"great\",2),_.push(\"if(comp===0){\"),_.push(\"if(--great<k){break}\"),_.push(\"continue\"),_.push(\"}else{\"),p(\"comp\",\"great\",1),_.push(\"if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"}\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),h(),b(\"less\",\"great\"),_.push(\"}return \"+w),t.length>1&&k){var L=new Function(\"insertionSort\",\"malloc\",\"free\",_.join(\"\\n\"));return L(r,k[0],k[1])}var L=new Function(\"insertionSort\",_.join(\"\\n\"));return L(r)}function s(t,e){var r=[\"'use strict'\"],n=[\"ndarraySortWrapper\",t.join(\"d\"),e].join(\"\"),s=[\"array\"];r.push([\"function \",n,\"(\",s.join(\",\"),\"){\"].join(\"\"));for(var l=[\"data=array.data,offset=array.offset|0,shape=array.shape,stride=array.stride\"],c=0;c<t.length;++c)l.push([\"s\",c,\"=stride[\",c,\"]|0,n\",c,\"=shape[\",c,\"]|0\"].join(\"\"));for(var h=new Array(t.length),f=[],c=0;c<t.length;++c){var d=t[c];0!==d&&(0===f.length?h[d]=\"1\":h[d]=f.join(\"*\"),f.push(\"n\"+d))}for(var p=-1,m=-1,c=0;c<t.length;++c){var v=t[c];0!==v&&(p>0?l.push([\"d\",v,\"=s\",v,\"-d\",p,\"*n\",p].join(\"\")):l.push([\"d\",v,\"=s\",v].join(\"\")),p=v);var d=t.length-1-c;0!==d&&(m>0?l.push([\"e\",d,\"=s\",d,\"-e\",m,\"*n\",m,\",f\",d,\"=\",h[d],\"-f\",m,\"*n\",m].join(\"\")):l.push([\"e\",d,\"=s\",d,\",f\",d,\"=\",h[d]].join(\"\")),m=d)}r.push(\"var \"+l.join(\",\"));var g=[\"0\",\"n0-1\",\"data\",\"offset\"].concat(i(t.length));r.push([\"if(n0<=\",u,\"){\",\"insertionSort(\",g.join(\",\"),\")}else{\",\"quickSort(\",g.join(\",\"),\")}\"].join(\"\")),r.push(\"}return \"+n);var y=new Function(\"insertionSort\",\"quickSort\",r.join(\"\\n\")),b=a(t,e);return y(b,o(t,e,b))}var l=t(\"typedarray-pool\"),u=32;e.exports=s},{\"typedarray-pool\":540}],464:[function(t,e,r){\"use strict\";function n(t){var e=t.order,r=t.dtype,n=[e,r],o=n.join(\":\"),s=a[o];return s||(a[o]=s=i(e,r)),s(t),t}var i=t(\"./lib/compile_sort.js\"),a={};e.exports=n},{\"./lib/compile_sort.js\":463}],465:[function(t,e,r){\"use strict\";var n=t(\"ndarray-linear-interpolate\"),i=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=new Array(_inline_33_arg4_)}\",args:[{name:\"_inline_33_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg2_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg3_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_34_arg2_(this_warped,_inline_34_arg0_),_inline_34_arg1_=_inline_34_arg3_.apply(void 0,this_warped)}\",args:[{name:\"_inline_34_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_34_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg4_\",lvalue:!1,rvalue:!1,count:0}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warpND\",blockSize:64}),a=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_37_arg2_(this_warped,_inline_37_arg0_),_inline_37_arg1_=_inline_37_arg3_(_inline_37_arg4_,this_warped[0])}\",args:[{name:\"_inline_37_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_37_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp1D\",blockSize:64}),o=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0,0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_40_arg2_(this_warped,_inline_40_arg0_),_inline_40_arg1_=_inline_40_arg3_(_inline_40_arg4_,this_warped[0],this_warped[1])}\",args:[{name:\"_inline_40_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_40_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp2D\",blockSize:64}),s=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0,0,0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_43_arg2_(this_warped,_inline_43_arg0_),_inline_43_arg1_=_inline_43_arg3_(_inline_43_arg4_,this_warped[0],this_warped[1],this_warped[2])}\",args:[{name:\"_inline_43_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_43_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp3D\",blockSize:64});e.exports=function(t,e,r){switch(e.shape.length){case 1:a(t,r,n.d1,e);break;case 2:o(t,r,n.d2,e);break;case 3:s(t,r,n.d3,e);break;default:i(t,r,n.bind(void 0,e),e.shape.length)}return t}},{\"cwise/lib/wrapper\":112,\"ndarray-linear-interpolate\":459}],466:[function(t,e,r){function n(t,e){return t[0]-e[0]}function i(){var t,e=this.stride,r=new Array(e.length);for(t=0;t<r.length;++t)r[t]=[Math.abs(e[t]),t];r.sort(n);var i=new Array(r.length);for(t=0;t<i.length;++t)i[t]=r[t][1];return i}function a(t,e){var r=[\"View\",e,\"d\",t].join(\"\");e<0&&(r=\"View_Nil\"+t);var n=\"generic\"===t;if(-1===e){\n",
       "var a=\"function \"+r+\"(a){this.data=a;};var proto=\"+r+\".prototype;proto.dtype='\"+t+\"';proto.index=function(){return -1};proto.size=0;proto.dimension=-1;proto.shape=proto.stride=proto.order=[];proto.lo=proto.hi=proto.transpose=proto.step=function(){return new \"+r+\"(this.data);};proto.get=proto.set=function(){};proto.pick=function(){return null};return function construct_\"+r+\"(a){return new \"+r+\"(a);}\",o=new Function(a);return o()}if(0===e){var a=\"function \"+r+\"(a,d) {this.data = a;this.offset = d};var proto=\"+r+\".prototype;proto.dtype='\"+t+\"';proto.index=function(){return this.offset};proto.dimension=0;proto.size=1;proto.shape=proto.stride=proto.order=[];proto.lo=proto.hi=proto.transpose=proto.step=function \"+r+\"_copy() {return new \"+r+\"(this.data,this.offset)};proto.pick=function \"+r+\"_pick(){return TrivialArray(this.data);};proto.valueOf=proto.get=function \"+r+\"_get(){return \"+(n?\"this.data.get(this.offset)\":\"this.data[this.offset]\")+\"};proto.set=function \"+r+\"_set(v){return \"+(n?\"this.data.set(this.offset,v)\":\"this.data[this.offset]=v\")+\"};return function construct_\"+r+\"(a,b,c,d){return new \"+r+\"(a,d)}\",o=new Function(\"TrivialArray\",a);return o(h[t][0])}var a=[\"'use strict'\"],s=l(e),u=s.map(function(t){return\"i\"+t}),c=\"this.offset+\"+s.map(function(t){return\"this.stride[\"+t+\"]*i\"+t}).join(\"+\"),f=s.map(function(t){return\"b\"+t}).join(\",\"),d=s.map(function(t){return\"c\"+t}).join(\",\");a.push(\"function \"+r+\"(a,\"+f+\",\"+d+\",d){this.data=a\",\"this.shape=[\"+f+\"]\",\"this.stride=[\"+d+\"]\",\"this.offset=d|0}\",\"var proto=\"+r+\".prototype\",\"proto.dtype='\"+t+\"'\",\"proto.dimension=\"+e),a.push(\"Object.defineProperty(proto,'size',{get:function \"+r+\"_size(){return \"+s.map(function(t){return\"this.shape[\"+t+\"]\"}).join(\"*\"),\"}})\"),1===e?a.push(\"proto.order=[0]\"):(a.push(\"Object.defineProperty(proto,'order',{get:\"),e<4?(a.push(\"function \"+r+\"_order(){\"),2===e?a.push(\"return (Math.abs(this.stride[0])>Math.abs(this.stride[1]))?[1,0]:[0,1]}})\"):3===e&&a.push(\"var s0=Math.abs(this.stride[0]),s1=Math.abs(this.stride[1]),s2=Math.abs(this.stride[2]);if(s0>s1){if(s1>s2){return [2,1,0];}else if(s0>s2){return [1,2,0];}else{return [1,0,2];}}else if(s0>s2){return [2,0,1];}else if(s2>s1){return [0,1,2];}else{return [0,2,1];}}})\")):a.push(\"ORDER})\")),a.push(\"proto.set=function \"+r+\"_set(\"+u.join(\",\")+\",v){\"),n?a.push(\"return this.data.set(\"+c+\",v)}\"):a.push(\"return this.data[\"+c+\"]=v}\"),a.push(\"proto.get=function \"+r+\"_get(\"+u.join(\",\")+\"){\"),n?a.push(\"return this.data.get(\"+c+\")}\"):a.push(\"return this.data[\"+c+\"]}\"),a.push(\"proto.index=function \"+r+\"_index(\",u.join(),\"){return \"+c+\"}\"),a.push(\"proto.hi=function \"+r+\"_hi(\"+u.join(\",\")+\"){return new \"+r+\"(this.data,\"+s.map(function(t){return[\"(typeof i\",t,\"!=='number'||i\",t,\"<0)?this.shape[\",t,\"]:i\",t,\"|0\"].join(\"\")}).join(\",\")+\",\"+s.map(function(t){return\"this.stride[\"+t+\"]\"}).join(\",\")+\",this.offset)}\");var p=s.map(function(t){return\"a\"+t+\"=this.shape[\"+t+\"]\"}),m=s.map(function(t){return\"c\"+t+\"=this.stride[\"+t+\"]\"});a.push(\"proto.lo=function \"+r+\"_lo(\"+u.join(\",\")+\"){var b=this.offset,d=0,\"+p.join(\",\")+\",\"+m.join(\",\"));for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'&&i\"+v+\">=0){d=i\"+v+\"|0;b+=c\"+v+\"*d;a\"+v+\"-=d}\");a.push(\"return new \"+r+\"(this.data,\"+s.map(function(t){return\"a\"+t}).join(\",\")+\",\"+s.map(function(t){return\"c\"+t}).join(\",\")+\",b)}\"),a.push(\"proto.step=function \"+r+\"_step(\"+u.join(\",\")+\"){var \"+s.map(function(t){return\"a\"+t+\"=this.shape[\"+t+\"]\"}).join(\",\")+\",\"+s.map(function(t){return\"b\"+t+\"=this.stride[\"+t+\"]\"}).join(\",\")+\",c=this.offset,d=0,ceil=Math.ceil\");for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'){d=i\"+v+\"|0;if(d<0){c+=b\"+v+\"*(a\"+v+\"-1);a\"+v+\"=ceil(-a\"+v+\"/d)}else{a\"+v+\"=ceil(a\"+v+\"/d)}b\"+v+\"*=d}\");a.push(\"return new \"+r+\"(this.data,\"+s.map(function(t){return\"a\"+t}).join(\",\")+\",\"+s.map(function(t){return\"b\"+t}).join(\",\")+\",c)}\");for(var g=new Array(e),y=new Array(e),v=0;v<e;++v)g[v]=\"a[i\"+v+\"]\",y[v]=\"b[i\"+v+\"]\";a.push(\"proto.transpose=function \"+r+\"_transpose(\"+u+\"){\"+u.map(function(t,e){return t+\"=(\"+t+\"===undefined?\"+e+\":\"+t+\"|0)\"}).join(\";\"),\"var a=this.shape,b=this.stride;return new \"+r+\"(this.data,\"+g.join(\",\")+\",\"+y.join(\",\")+\",this.offset)}\"),a.push(\"proto.pick=function \"+r+\"_pick(\"+u+\"){var a=[],b=[],c=this.offset\");for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'&&i\"+v+\">=0){c=(c+this.stride[\"+v+\"]*i\"+v+\")|0}else{a.push(this.shape[\"+v+\"]);b.push(this.stride[\"+v+\"])}\");a.push(\"var ctor=CTOR_LIST[a.length+1];return ctor(this.data,a,b,c)}\"),a.push(\"return function construct_\"+r+\"(data,shape,stride,offset){return new \"+r+\"(data,\"+s.map(function(t){return\"shape[\"+t+\"]\"}).join(\",\")+\",\"+s.map(function(t){return\"stride[\"+t+\"]\"}).join(\",\")+\",offset)}\");var o=new Function(\"CTOR_LIST\",\"ORDER\",a.join(\"\\n\"));return o(h[t],i)}function o(t){if(u(t))return\"buffer\";if(c)switch(Object.prototype.toString.call(t)){case\"[object Float64Array]\":return\"float64\";case\"[object Float32Array]\":return\"float32\";case\"[object Int8Array]\":return\"int8\";case\"[object Int16Array]\":return\"int16\";case\"[object Int32Array]\":return\"int32\";case\"[object Uint8Array]\":return\"uint8\";case\"[object Uint16Array]\":return\"uint16\";case\"[object Uint32Array]\":return\"uint32\";case\"[object Uint8ClampedArray]\":return\"uint8_clamped\"}return Array.isArray(t)?\"array\":\"generic\"}function s(t,e,r,n){if(void 0===t){var i=h.array[0];return i([])}\"number\"==typeof t&&(t=[t]),void 0===e&&(e=[t.length]);var s=e.length;if(void 0===r){r=new Array(s);for(var l=s-1,u=1;l>=0;--l)r[l]=u,u*=e[l]}if(void 0===n){n=0;for(var l=0;l<s;++l)r[l]<0&&(n-=(e[l]-1)*r[l])}for(var c=o(t),f=h[c];f.length<=s+1;)f.push(a(c,f.length-1));var i=f[s+1];return i(t,e,r,n)}var l=t(\"iota-array\"),u=t(\"is-buffer\"),c=\"undefined\"!=typeof Float64Array,h={float32:[],float64:[],int8:[],int16:[],int32:[],uint8:[],uint16:[],uint32:[],array:[],uint8_clamped:[],buffer:[],generic:[]};e.exports=s},{\"iota-array\":292,\"is-buffer\":294}],467:[function(t,e,r){\"use strict\";function n(t,e){if(isNaN(t)||isNaN(e))return NaN;if(t===e)return t;if(0===t)return e<0?-a:a;var r=i.hi(t),n=i.lo(t);return e>t==t>0?n===o?(r+=1,n=0):n+=1:0===n?(n=o,r-=1):n-=1,i.pack(n,r)}var i=t(\"double-bits\"),a=Math.pow(2,-1074),o=-1>>>0;e.exports=n},{\"double-bits\":123}],468:[function(t,e,r){r.vertexNormals=function(t,e,r){for(var n=e.length,i=new Array(n),a=void 0===r?1e-6:r,o=0;o<n;++o)i[o]=[0,0,0];for(var o=0;o<t.length;++o)for(var s=t[o],l=0,u=s[s.length-1],c=s[0],h=0;h<s.length;++h){l=u,u=c,c=s[(h+1)%s.length];for(var f=e[l],d=e[u],p=e[c],m=new Array(3),v=0,g=new Array(3),y=0,b=0;b<3;++b)m[b]=f[b]-d[b],v+=m[b]*m[b],g[b]=p[b]-d[b],y+=g[b]*g[b];if(v*y>a)for(var x=i[u],_=1/Math.sqrt(v*y),b=0;b<3;++b){var w=(b+1)%3,M=(b+2)%3;x[b]+=_*(g[w]*m[M]-g[M]*m[w])}}for(var o=0;o<n;++o){for(var x=i[o],k=0,b=0;b<3;++b)k+=x[b]*x[b];if(k>a)for(var _=1/Math.sqrt(k),b=0;b<3;++b)x[b]*=_;else for(var b=0;b<3;++b)x[b]=0}return i},r.faceNormals=function(t,e,r){for(var n=t.length,i=new Array(n),a=void 0===r?1e-6:r,o=0;o<n;++o){for(var s=t[o],l=new Array(3),u=0;u<3;++u)l[u]=e[s[u]];for(var c=new Array(3),h=new Array(3),u=0;u<3;++u)c[u]=l[1][u]-l[0][u],h[u]=l[2][u]-l[0][u];for(var f=new Array(3),d=0,u=0;u<3;++u){var p=(u+1)%3,m=(u+2)%3;f[u]=c[p]*h[m]-c[m]*h[p],d+=f[u]*f[u]}d=d>a?1/Math.sqrt(d):0;for(var u=0;u<3;++u)f[u]*=d;i[o]=f}return i}},{}],469:[function(t,e,r){\"use strict\";function n(t){if(null===t||void 0===t)throw new TypeError(\"Object.assign cannot be called with null or undefined\");return Object(t)}var i=Object.getOwnPropertySymbols,a=Object.prototype.hasOwnProperty,o=Object.prototype.propertyIsEnumerable;e.exports=function(){try{if(!Object.assign)return!1;var t=new String(\"abc\");if(t[5]=\"de\",\"5\"===Object.getOwnPropertyNames(t)[0])return!1;for(var e={},r=0;r<10;r++)e[\"_\"+String.fromCharCode(r)]=r;if(\"0123456789\"!==Object.getOwnPropertyNames(e).map(function(t){return e[t]}).join(\"\"))return!1;var n={};return\"abcdefghijklmnopqrst\".split(\"\").forEach(function(t){n[t]=t}),\"abcdefghijklmnopqrst\"===Object.keys(Object.assign({},n)).join(\"\")}catch(t){return!1}}()?Object.assign:function(t,e){for(var r,s,l=n(t),u=1;u<arguments.length;u++){r=Object(arguments[u]);for(var c in r)a.call(r,c)&&(l[c]=r[c]);if(i){s=i(r);for(var h=0;h<s.length;h++)o.call(r,s[h])&&(l[s[h]]=r[s[h]])}}return l}},{}],470:[function(t,e,r){\"use strict\";function n(t,e){var r,n,o;return\"string\"==typeof t?(r=i(t,e),n=r.width,o=r.height):t instanceof HTMLCanvasElement?(n=t.width,o=t.height,t=t.getContext(\"2d\"),r=t.getImageData(0,0,n,o)):t instanceof ImageData&&(n=t.width,o=t.height,r=t),a(r)}function i(t,e){e||(e={});var r=e.family||\"sans-serif\",n=l.width,i=l.height,a=e.width||e.height||e.size;a&&a!=n&&(n=i=l.width=l.height=a);var o=e.fontSize||n/2;return u.fillStyle=\"#000\",u.fillRect(0,0,n,i),u.font=o+\"px \"+r,u.textBaseline=\"middle\",u.textAlign=\"center\",u.fillStyle=\"white\",u.fillText(t,n/2,i/2),u.getImageData(0,0,n,i)}function a(t){var e,r,n,i,a,l,u,c,h,f,d,p,m,v=t.data,g=t.width,y=t.height,b=Array(y),x=Array(y),_=0,w=0,M=g,k=0,A=0,T=Array(y);for(r=0;r<y;r++)if(l=0,u=0,a=4*r*g,d=o(v.subarray(a,a+4*g),4),d[0]!==d[1]){for(_||(_=r),w=r,e=d[0];e<d[1];e++)i=4*e,n=v[a+i],l+=n,u+=e*n;b[r]=0===l?0:l/g,x[r]=0===l?0:u/l,d[0]<M&&(M=d[0]),d[1]>k&&(k=d[1]),T[r]=d}for(l=0,c=0,u=0,r=0;r<y;r++)(p=b[r])&&(c+=p*r,l+=p,u+=x[r]*p);for(f=c/l,h=u/l,A=0,m=0,r=0;r<y;r++)(d=T[r])&&(m=Math.max(s(h-d[0],f-r),s(h-d[1],f-r)))>A&&(A=m);return{center:[h,f],bounds:[M,_,k,w+1],radius:Math.sqrt(A)}}function o(t,e){var r=0,n=t.length,i=0;for(e||(e=4);!t[i]&&i<n;)i+=e;for(r=i,i=t.length;!t[i]&&i>r;)i-=e;return n=i,[r/e,n/e]}function s(t,e){return t*t+e*e}e.exports=n;var l=document.createElement(\"canvas\"),u=l.getContext(\"2d\");l.width=200,l.height=200,n.canvas=l},{}],471:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u){var c=e+a+u;if(h>0){var h=Math.sqrt(c+1);t[0]=.5*(o-l)/h,t[1]=.5*(s-n)/h,t[2]=.5*(r-a)/h,t[3]=.5*h}else{var f=Math.max(e,a,u),h=Math.sqrt(2*f-c+1);e>=f?(t[0]=.5*h,t[1]=.5*(i+r)/h,t[2]=.5*(s+n)/h,t[3]=.5*(o-l)/h):a>=f?(t[0]=.5*(r+i)/h,t[1]=.5*h,t[2]=.5*(l+o)/h,t[3]=.5*(s-n)/h):(t[0]=.5*(n+s)/h,t[1]=.5*(o+l)/h,t[2]=.5*h,t[3]=.5*(r-i)/h)}return t}e.exports=n},{}],472:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2))}function i(t,e,r,n){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2)+Math.pow(n,2))}function a(t,e){var r=e[0],n=e[1],a=e[2],o=e[3],s=i(r,n,a,o);s>1e-6?(t[0]=r/s,t[1]=n/s,t[2]=a/s,t[3]=o/s):(t[0]=t[1]=t[2]=0,t[3]=1)}function o(t,e,r){this.radius=l([r]),this.center=l(e),this.rotation=l(t),this.computedRadius=this.radius.curve(0),this.computedCenter=this.center.curve(0),this.computedRotation=this.rotation.curve(0),this.computedUp=[.1,0,0],this.computedEye=[.1,0,0],this.computedMatrix=[.1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],this.recalcMatrix(0)}function s(t){t=t||{};var e=t.center||[0,0,0],r=t.rotation||[0,0,0,1],n=t.radius||1;e=[].slice.call(e,0,3),r=[].slice.call(r,0,4),a(r,r);var i=new o(r,e,Math.log(n));return i.setDistanceLimits(t.zoomMin,t.zoomMax),(\"eye\"in t||\"up\"in t)&&i.lookAt(0,t.eye,t.center,t.up),i}e.exports=s;var l=t(\"filtered-vector\"),u=t(\"gl-mat4/lookAt\"),c=t(\"gl-mat4/fromQuat\"),h=t(\"gl-mat4/invert\"),f=t(\"./lib/quatFromFrame\"),d=o.prototype;d.lastT=function(){return Math.max(this.radius.lastT(),this.center.lastT(),this.rotation.lastT())},d.recalcMatrix=function(t){this.radius.curve(t),this.center.curve(t),this.rotation.curve(t);var e=this.computedRotation;a(e,e);var r=this.computedMatrix;c(r,e);var n=this.computedCenter,i=this.computedEye,o=this.computedUp,s=Math.exp(this.computedRadius[0]);i[0]=n[0]+s*r[2],i[1]=n[1]+s*r[6],i[2]=n[2]+s*r[10],o[0]=r[1],o[1]=r[5],o[2]=r[9];for(var l=0;l<3;++l){for(var u=0,h=0;h<3;++h)u+=r[l+4*h]*i[h];r[12+l]=-u}},d.getMatrix=function(t,e){this.recalcMatrix(t);var r=this.computedMatrix;if(e){for(var n=0;n<16;++n)e[n]=r[n];return e}return r},d.idle=function(t){this.center.idle(t),this.radius.idle(t),this.rotation.idle(t)},d.flush=function(t){this.center.flush(t),this.radius.flush(t),this.rotation.flush(t)},d.pan=function(t,e,r,i){e=e||0,r=r||0,i=i||0,this.recalcMatrix(t);var a=this.computedMatrix,o=a[1],s=a[5],l=a[9],u=n(o,s,l);o/=u,s/=u,l/=u;var c=a[0],h=a[4],f=a[8],d=c*o+h*s+f*l;c-=o*d,h-=s*d,f-=l*d;var p=n(c,h,f);c/=p,h/=p,f/=p;var m=a[2],v=a[6],g=a[10],y=m*o+v*s+g*l,b=m*c+v*h+g*f;m-=y*o+b*c,v-=y*s+b*h,g-=y*l+b*f;var x=n(m,v,g);m/=x,v/=x,g/=x;var _=c*e+o*r,w=h*e+s*r,M=f*e+l*r;this.center.move(t,_,w,M);var k=Math.exp(this.computedRadius[0]);k=Math.max(1e-4,k+i),this.radius.set(t,Math.log(k))},d.rotate=function(t,e,r,a){this.recalcMatrix(t),e=e||0,r=r||0;var o=this.computedMatrix,s=o[0],l=o[4],u=o[8],c=o[1],h=o[5],f=o[9],d=o[2],p=o[6],m=o[10],v=e*s+r*c,g=e*l+r*h,y=e*u+r*f,b=-(p*y-m*g),x=-(m*v-d*y),_=-(d*g-p*v),w=Math.sqrt(Math.max(0,1-Math.pow(b,2)-Math.pow(x,2)-Math.pow(_,2))),M=i(b,x,_,w);M>1e-6?(b/=M,x/=M,_/=M,w/=M):(b=x=_=0,w=1);var k=this.computedRotation,A=k[0],T=k[1],S=k[2],E=k[3],L=A*w+E*b+T*_-S*x,C=T*w+E*x+S*b-A*_,z=S*w+E*_+A*x-T*b,I=E*w-A*b-T*x-S*_;if(a){b=d,x=p,_=m;var D=Math.sin(a)/n(b,x,_);b*=D,x*=D,_*=D,w=Math.cos(e),L=L*w+I*b+C*_-z*x,C=C*w+I*x+z*b-L*_,z=z*w+I*_+L*x-C*b,I=I*w-L*b-C*x-z*_}var P=i(L,C,z,I);P>1e-6?(L/=P,C/=P,z/=P,I/=P):(L=C=z=0,I=1),this.rotation.set(t,L,C,z,I)},d.lookAt=function(t,e,r,n){this.recalcMatrix(t),r=r||this.computedCenter,e=e||this.computedEye,n=n||this.computedUp;var i=this.computedMatrix;u(i,e,r,n);var o=this.computedRotation;f(o,i[0],i[1],i[2],i[4],i[5],i[6],i[8],i[9],i[10]),a(o,o),this.rotation.set(t,o[0],o[1],o[2],o[3]);for(var s=0,l=0;l<3;++l)s+=Math.pow(r[l]-e[l],2);this.radius.set(t,.5*Math.log(Math.max(s,1e-6))),this.center.set(t,r[0],r[1],r[2])},d.translate=function(t,e,r,n){this.center.move(t,e||0,r||0,n||0)},d.setMatrix=function(t,e){var r=this.computedRotation;f(r,e[0],e[1],e[2],e[4],e[5],e[6],e[8],e[9],e[10]),a(r,r),this.rotation.set(t,r[0],r[1],r[2],r[3]);var n=this.computedMatrix;h(n,e);var i=n[15];if(Math.abs(i)>1e-6){var o=n[12]/i,s=n[13]/i,l=n[14]/i;this.recalcMatrix(t);var u=Math.exp(this.computedRadius[0]);this.center.set(t,o-n[2]*u,s-n[6]*u,l-n[10]*u),this.radius.idle(t)}else this.center.idle(t),this.radius.idle(t)},d.setDistance=function(t,e){e>0&&this.radius.set(t,Math.log(e))},d.setDistanceLimits=function(t,e){t=t>0?Math.log(t):-1/0,e=e>0?Math.log(e):1/0,e=Math.max(e,t),this.radius.bounds[0][0]=t,this.radius.bounds[1][0]=e},d.getDistanceLimits=function(t){var e=this.radius.bounds;return t?(t[0]=Math.exp(e[0][0]),t[1]=Math.exp(e[1][0]),t):[Math.exp(e[0][0]),Math.exp(e[1][0])]},d.toJSON=function(){return this.recalcMatrix(this.lastT()),{center:this.computedCenter.slice(),rotation:this.computedRotation.slice(),distance:Math.log(this.computedRadius[0]),zoomMin:this.radius.bounds[0][0],zoomMax:this.radius.bounds[1][0]}},d.fromJSON=function(t){var e=this.lastT(),r=t.center;r&&this.center.set(e,r[0],r[1],r[2]);var n=t.rotation;n&&this.rotation.set(e,n[0],n[1],n[2],n[3]);var i=t.distance;i&&i>0&&this.radius.set(e,Math.log(i)),this.setDistanceLimits(t.zoomMin,t.zoomMax)}},{\"./lib/quatFromFrame\":471,\"filtered-vector\":132,\"gl-mat4/fromQuat\":177,\"gl-mat4/invert\":180,\"gl-mat4/lookAt\":181}],473:[function(t,e,r){\"use strict\";var n=t(\"repeat-string\");e.exports=function(t,e,r){return r=void 0!==r?r+\"\":\" \",n(r,e)+t}},{\"repeat-string\":499}],474:[function(t,e,r){e.exports=function(t,e){e||(e=[0,\"\"]),t=String(t);var r=parseFloat(t,10);return e[0]=r,e[1]=t.match(/[\\d.\\-\\+]*\\s*(.*)/)[1]||\"\",e}},{}],475:[function(t,e,r){(function(t){function e(t,e){for(var r=0,n=t.length-1;n>=0;n--){var i=t[n];\".\"===i?t.splice(n,1):\"..\"===i?(t.splice(n,1),r++):r&&(t.splice(n,1),r--)}if(e)for(;r--;r)t.unshift(\"..\");return t}function n(t,e){if(t.filter)return t.filter(e);for(var r=[],n=0;n<t.length;n++)e(t[n],n,t)&&r.push(t[n]);return r}var i=/^(\\/?|)([\\s\\S]*?)((?:\\.{1,2}|[^\\/]+?|)(\\.[^.\\/]*|))(?:[\\/]*)$/,a=function(t){return i.exec(t).slice(1)};r.resolve=function(){for(var r=\"\",i=!1,a=arguments.length-1;a>=-1&&!i;a--){var o=a>=0?arguments[a]:t.cwd();if(\"string\"!=typeof o)throw new TypeError(\"Arguments to path.resolve must be strings\");o&&(r=o+\"/\"+r,i=\"/\"===o.charAt(0))}return r=e(n(r.split(\"/\"),function(t){return!!t}),!i).join(\"/\"),(i?\"/\":\"\")+r||\".\"},r.normalize=function(t){var i=r.isAbsolute(t),a=\"/\"===o(t,-1);return t=e(n(t.split(\"/\"),function(t){return!!t}),!i).join(\"/\"),t||i||(t=\".\"),t&&a&&(t+=\"/\"),(i?\"/\":\"\")+t},r.isAbsolute=function(t){return\"/\"===t.charAt(0)},r.join=function(){var t=Array.prototype.slice.call(arguments,0);return r.normalize(n(t,function(t,e){if(\"string\"!=typeof t)throw new TypeError(\"Arguments to path.join must be strings\");return t}).join(\"/\"))},r.relative=function(t,e){function n(t){for(var e=0;e<t.length&&\"\"===t[e];e++);for(var r=t.length-1;r>=0&&\"\"===t[r];r--);return e>r?[]:t.slice(e,r-e+1)}t=r.resolve(t).substr(1),e=r.resolve(e).substr(1);for(var i=n(t.split(\"/\")),a=n(e.split(\"/\")),o=Math.min(i.length,a.length),s=o,l=0;l<o;l++)if(i[l]!==a[l]){s=l;break}for(var u=[],l=s;l<i.length;l++)u.push(\"..\");return u=u.concat(a.slice(s)),u.join(\"/\")},r.sep=\"/\",r.delimiter=\":\",r.dirname=function(t){var e=a(t),r=e[0],n=e[1];return r||n?(n&&(n=n.substr(0,n.length-1)),r+n):\".\"},r.basename=function(t,e){var r=a(t)[2];return e&&r.substr(-1*e.length)===e&&(r=r.substr(0,r.length-e.length)),r},r.extname=function(t){return a(t)[3]};var o=\"b\"===\"ab\".substr(-1)?function(t,e,r){return t.substr(e,r)}:function(t,e,r){return e<0&&(e=t.length+e),t.substr(e,r)}}).call(this,t(\"_process\"))},{_process:486}],476:[function(t,e,r){\"use strict\";function n(t){var e;t&&t.length&&(e=t,t=e.length);var r=new Uint8Array(t||0);return e&&r.set(e),r.readUInt32LE=a.readUInt32LE,r.writeUInt32LE=a.writeUInt32LE,r.readInt32LE=a.readInt32LE,r.writeInt32LE=a.writeInt32LE,r.readFloatLE=a.readFloatLE,r.writeFloatLE=a.writeFloatLE,r.readDoubleLE=a.readDoubleLE,r.writeDoubleLE=a.writeDoubleLE,r.toString=a.toString,r.write=a.write,r.slice=a.slice,r.copy=a.copy,r._isBuffer=!0,r}function i(t){for(var e,r,n=t.length,i=[],a=0;a<n;a++){if((e=t.charCodeAt(a))>55295&&e<57344){if(!r){e>56319||a+1===n?i.push(239,191,189):r=e;continue}if(e<56320){i.push(239,191,189),r=e;continue}e=r-55296<<10|e-56320|65536,r=null}else r&&(i.push(239,191,189),r=null);e<128?i.push(e):e<2048?i.push(e>>6|192,63&e|128):e<65536?i.push(e>>12|224,e>>6&63|128,63&e|128):i.push(e>>18|240,e>>12&63|128,e>>6&63|128,63&e|128)}return i}e.exports=n;var a,o,s,l=t(\"ieee754\");a={readUInt32LE:function(t){return(this[t]|this[t+1]<<8|this[t+2]<<16)+16777216*this[t+3]},writeUInt32LE:function(t,e){this[e]=t,this[e+1]=t>>>8,this[e+2]=t>>>16,this[e+3]=t>>>24},readInt32LE:function(t){return(this[t]|this[t+1]<<8|this[t+2]<<16)+(this[t+3]<<24)},readFloatLE:function(t){return l.read(this,t,!0,23,4)},readDoubleLE:function(t){return l.read(this,t,!0,52,8)},writeFloatLE:function(t,e){return l.write(this,t,e,!0,23,4)},writeDoubleLE:function(t,e){return l.write(this,t,e,!0,52,8)},toString:function(t,e,r){var n=\"\",i=\"\";e=e||0,r=Math.min(this.length,r||this.length);for(var a=e;a<r;a++){var o=this[a];o<=127?(n+=decodeURIComponent(i)+String.fromCharCode(o),i=\"\"):i+=\"%\"+o.toString(16)}return n+=decodeURIComponent(i)},write:function(t,e){for(var r=t===o?s:i(t),n=0;n<r.length;n++)this[e+n]=r[n]},slice:function(t,e){return this.subarray(t,e)},copy:function(t,e){e=e||0;for(var r=0;r<this.length;r++)t[e+r]=this[r]}},a.writeInt32LE=a.writeUInt32LE,n.byteLength=function(t){return o=t,s=i(t),s.length},n.isBuffer=function(t){return!(!t||!t._isBuffer)}},{ieee754:288}],477:[function(t,e,r){(function(r){\"use strict\";function n(t){this.buf=v.isBuffer(t)?t:new v(t||0),this.pos=0,this.length=this.buf.length}function i(t,e){var r,n=e.buf;if(r=n[e.pos++],t+=268435456*(127&r),r<128)return t;if(r=n[e.pos++],t+=34359738368*(127&r),r<128)return t;if(r=n[e.pos++],t+=4398046511104*(127&r),r<128)return t;if(r=n[e.pos++],t+=562949953421312*(127&r),r<128)return t;if(r=n[e.pos++],t+=72057594037927940*(127&r),r<128)return t;if(r=n[e.pos++],t+=0x8000000000000000*(127&r),r<128)return t;throw new Error(\"Expected varint not more than 10 bytes\")}function a(t,e){e.realloc(10);for(var r=e.pos+10;t>=1;){if(e.pos>=r)throw new Error(\"Given varint doesn't fit into 10 bytes\");var n=255&t;e.buf[e.pos++]=n|(t>=128?128:0),t/=128}}function o(t,e,r){var n=e<=16383?1:e<=2097151?2:e<=268435455?3:Math.ceil(Math.log(e)/(7*Math.LN2));r.realloc(n);for(var i=r.pos-1;i>=t;i--)r.buf[i+n]=r.buf[i]}function s(t,e){for(var r=0;r<t.length;r++)e.writeVarint(t[r])}function l(t,e){for(var r=0;r<t.length;r++)e.writeSVarint(t[r])}function u(t,e){for(var r=0;r<t.length;r++)e.writeFloat(t[r])}function c(t,e){for(var r=0;r<t.length;r++)e.writeDouble(t[r])}function h(t,e){for(var r=0;r<t.length;r++)e.writeBoolean(t[r])}function f(t,e){for(var r=0;r<t.length;r++)e.writeFixed32(t[r])}function d(t,e){for(var r=0;r<t.length;r++)e.writeSFixed32(t[r])}function p(t,e){for(var r=0;r<t.length;r++)e.writeFixed64(t[r])}function m(t,e){for(var r=0;r<t.length;r++)e.writeSFixed64(t[r])}e.exports=n;var v=r.Buffer||t(\"./buffer\");n.Varint=0,n.Fixed64=1,n.Bytes=2,n.Fixed32=5;var g=Math.pow(2,63);n.prototype={destroy:function(){this.buf=null},readFields:function(t,e,r){for(r=r||this.length;this.pos<r;){var n=this.readVarint(),i=n>>3,a=this.pos;t(i,e,this),this.pos===a&&this.skip(n)}return e},readMessage:function(t,e){return this.readFields(t,e,this.readVarint()+this.pos)},readFixed32:function(){var t=this.buf.readUInt32LE(this.pos);return this.pos+=4,t},readSFixed32:function(){var t=this.buf.readInt32LE(this.pos);return this.pos+=4,t},readFixed64:function(){var t=this.buf.readUInt32LE(this.pos)+4294967296*this.buf.readUInt32LE(this.pos+4);return this.pos+=8,t},readSFixed64:function(){var t=this.buf.readUInt32LE(this.pos)+4294967296*this.buf.readInt32LE(this.pos+4);return this.pos+=8,t},readFloat:function(){var t=this.buf.readFloatLE(this.pos);return this.pos+=4,t},readDouble:function(){var t=this.buf.readDoubleLE(this.pos);return this.pos+=8,t},readVarint:function(){var t,e,r=this.buf;return e=r[this.pos++],t=127&e,e<128?t:(e=r[this.pos++],t|=(127&e)<<7,e<128?t:(e=r[this.pos++],t|=(127&e)<<14,e<128?t:(e=r[this.pos++],t|=(127&e)<<21,e<128?t:i(t,this))))},readVarint64:function(){var t=this.pos,e=this.readVarint();if(e<g)return e;for(var r=this.pos-2;255===this.buf[r];)r--;r<t&&(r=t),e=0;for(var n=0;n<r-t+1;n++){var i=127&~this.buf[t+n];e+=n<4?i<<7*n:i*Math.pow(2,7*n)}return-e-1},readSVarint:function(){var t=this.readVarint();return t%2==1?(t+1)/-2:t/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var t=this.readVarint()+this.pos,e=this.buf.toString(\"utf8\",this.pos,t);return this.pos=t,e},readBytes:function(){var t=this.readVarint()+this.pos,e=this.buf.slice(this.pos,t);return this.pos=t,e},readPackedVarint:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readVarint());return e},readPackedSVarint:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSVarint());return e},readPackedBoolean:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readBoolean());return e},readPackedFloat:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFloat());return e},readPackedDouble:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readDouble());return e},readPackedFixed32:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFixed32());return e},readPackedSFixed32:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSFixed32());return e},readPackedFixed64:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFixed64());return e},readPackedSFixed64:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSFixed64());return e},skip:function(t){var e=7&t;if(e===n.Varint)for(;this.buf[this.pos++]>127;);else if(e===n.Bytes)this.pos=this.readVarint()+this.pos;else if(e===n.Fixed32)this.pos+=4;else{if(e!==n.Fixed64)throw new Error(\"Unimplemented type: \"+e);this.pos+=8}},writeTag:function(t,e){this.writeVarint(t<<3|e)},realloc:function(t){for(var e=this.length||16;e<this.pos+t;)e*=2;if(e!==this.length){var r=new v(e);this.buf.copy(r),this.buf=r,this.length=e}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.slice(0,this.length)},writeFixed32:function(t){this.realloc(4),this.buf.writeUInt32LE(t,this.pos),this.pos+=4},writeSFixed32:function(t){this.realloc(4),this.buf.writeInt32LE(t,this.pos),this.pos+=4},writeFixed64:function(t){this.realloc(8),this.buf.writeInt32LE(-1&t,this.pos),this.buf.writeUInt32LE(Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8},writeSFixed64:function(t){this.realloc(8),this.buf.writeInt32LE(-1&t,this.pos),this.buf.writeInt32LE(Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8},writeVarint:function(t){if((t=+t)>268435455)return void a(t,this);this.realloc(4),this.buf[this.pos++]=127&t|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=t>>>7&127)))},writeSVarint:function(t){this.writeVarint(t<0?2*-t-1:2*t)},writeBoolean:function(t){this.writeVarint(Boolean(t))},writeString:function(t){t=String(t);var e=v.byteLength(t);this.writeVarint(e),this.realloc(e),this.buf.write(t,this.pos),this.pos+=e},writeFloat:function(t){this.realloc(4),this.buf.writeFloatLE(t,this.pos),this.pos+=4},writeDouble:function(t){this.realloc(8),this.buf.writeDoubleLE(t,this.pos),this.pos+=8},writeBytes:function(t){var e=t.length;this.writeVarint(e),this.realloc(e);for(var r=0;r<e;r++)this.buf[this.pos++]=t[r]},writeRawMessage:function(t,e){this.pos++;var r=this.pos;t(e,this);var n=this.pos-r;n>=128&&o(r,n,this),this.pos=r-1,this.writeVarint(n),this.pos+=n},writeMessage:function(t,e,r){this.writeTag(t,n.Bytes),this.writeRawMessage(e,r)},writePackedVarint:function(t,e){this.writeMessage(t,s,e)},writePackedSVarint:function(t,e){this.writeMessage(t,l,e)},writePackedBoolean:function(t,e){this.writeMessage(t,h,e)},writePackedFloat:function(t,e){this.writeMessage(t,u,e)},writePackedDouble:function(t,e){this.writeMessage(t,c,e)},writePackedFixed32:function(t,e){this.writeMessage(t,f,e)},writePackedSFixed32:function(t,e){this.writeMessage(t,d,e)},writePackedFixed64:function(t,e){this.writeMessage(t,p,e)},writePackedSFixed64:function(t,e){this.writeMessage(t,m,e)},writeBytesField:function(t,e){this.writeTag(t,n.Bytes),this.writeBytes(e)},writeFixed32Field:function(t,e){this.writeTag(t,n.Fixed32),this.writeFixed32(e)},writeSFixed32Field:function(t,e){this.writeTag(t,n.Fixed32),this.writeSFixed32(e)},writeFixed64Field:function(t,e){this.writeTag(t,n.Fixed64),this.writeFixed64(e)},writeSFixed64Field:function(t,e){this.writeTag(t,n.Fixed64),this.writeSFixed64(e)},writeVarintField:function(t,e){this.writeTag(t,n.Varint),this.writeVarint(e)},writeSVarintField:function(t,e){this.writeTag(t,n.Varint),this.writeSVarint(e)},writeStringField:function(t,e){this.writeTag(t,n.Bytes),this.writeString(e)},writeFloatField:function(t,e){this.writeTag(t,n.Fixed32),this.writeFloat(e)},writeDoubleField:function(t,e){this.writeTag(t,n.Fixed64),this.writeDouble(e)},writeBooleanField:function(t,e){this.writeVarintField(t,Boolean(e))}}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"./buffer\":476}],478:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e<i){for(var r=1,n=0;n<e;++n)for(var o=0;o<n;++o)if(t[n]<t[o])r=-r;else if(t[n]===t[o])return 0;return r}for(var s=a.mallocUint8(e),n=0;n<e;++n)s[n]=0;for(var r=1,n=0;n<e;++n)if(!s[n]){var l=1;s[n]=1;for(var o=t[n];o!==n;o=t[o]){if(s[o])return a.freeUint8(s),0;l+=1,s[o]=1}1&l||(r=-r)}return a.freeUint8(s),r}e.exports=n;var i=32,a=t(\"typedarray-pool\")},{\"typedarray-pool\":540}],479:[function(t,e,r){\"use strict\";function n(t){var e=t.length;switch(e){case 0:case 1:return 0;case 2:return t[1]}var r,n,i,s=a.mallocUint32(e),l=a.mallocUint32(e),u=0;for(o(t,l),i=0;i<e;++i)s[i]=t[i];for(i=e-1;i>0;--i)n=l[i],r=s[i],s[i]=s[n],s[n]=r,l[i]=l[r],l[r]=n,u=(u+r)*i;return a.freeUint32(l),a.freeUint32(s),u}function i(t,e,r){switch(t){case 0:return r||[];case 1:return r?(r[0]=0,r):[0];case 2:return r?(e?(r[0]=0,r[1]=1):(r[0]=1,r[1]=0),r):e?[0,1]:[1,0]}r=r||new Array(t);var n,i,a,o=1;for(r[0]=0,a=1;a<t;++a)r[a]=a,o=o*a|0;for(a=t-1;a>0;--a)n=e/o|0,e=e-n*o|0,o=o/a|0,i=0|r[a],r[a]=0|r[n],r[n]=0|i;return r}var a=t(\"typedarray-pool\"),o=t(\"invert-permutation\");r.rank=n,r.unrank=i},{\"invert-permutation\":291,\"typedarray-pool\":540}],480:[function(t,e,r){\"use strict\";function n(t,e){function r(t,e){var r=s[e][t[e]];r.splice(r.indexOf(t),1)}function n(t,n,a){for(var o,l,u,c=0;c<2;++c)if(s[c][n].length>0){o=s[c][n][0],u=c;break}l=o[1^u];for(var h=0;h<2;++h)for(var f=s[h][n],d=0;d<f.length;++d){var p=f[d],m=p[1^h],v=i(e[t],e[n],e[l],e[m]);v>0&&(o=p,l=m,u=h)}return a?l:(o&&r(o,u),l)}for(var a=0|e.length,o=t.length,s=[new Array(a),new Array(a)],l=0;l<a;++l)s[0][l]=[],s[1][l]=[];for(var l=0;l<o;++l){var u=t[l];s[0][u[0]].push(u),s[1][u[1]].push(u)}for(var c=[],l=0;l<a;++l)s[0][l].length+s[1][l].length===0&&c.push([l]);for(var l=0;l<a;++l)for(var h=0;h<2;++h){for(var f=[];s[h][l].length>0;){var d=(s[0][l].length,function(t,a){var o=s[a][t][0],l=[t];r(o,a);for(var u=o[1^a];;){for(;u!==t;)l.push(u),u=n(l[l.length-2],u,!1);if(s[0][t].length+s[1][t].length===0)break;var c=l[l.length-1],h=t,f=l[1],d=n(c,h,!0);if(i(e[c],e[h],e[f],e[d])<0)break;l.push(t),u=n(c,h)}return l}(l,h));!function(t,e){return e[1]===e[e.length-1]}(f,d)?(f.length>0&&c.push(f),f=d):f.push.apply(f,d)}f.length>0&&c.push(f)}return c}e.exports=n;var i=t(\"compare-angle\")},{\"compare-angle\":99}],481:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(t,e.length),n=new Array(e.length),a=new Array(e.length),o=[],s=0;s<e.length;++s){var l=r[s].length;a[s]=l,n[s]=!0,l<=1&&o.push(s)}for(;o.length>0;){var u=o.pop();n[u]=!1;for(var c=r[u],s=0;s<c.length;++s){var h=c[s];0==--a[h]&&o.push(h)}}for(var f=new Array(e.length),d=[],s=0;s<e.length;++s)if(n[s]){var u=d.length;f[s]=u,d.push(e[s])}else f[s]=-1;for(var p=[],s=0;s<t.length;++s){var m=t[s];n[m[0]]&&n[m[1]]&&p.push([f[m[0]],f[m[1]]])}return[p,d]}e.exports=n;var i=t(\"edges-to-adjacency-list\")},{\"edges-to-adjacency-list\":126}],482:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function i(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=[];return e}function a(t,e){function r(t){for(var r=t.length,n=[0],i=0;i<r;++i){var a=e[t[i]],o=e[t[(i+1)%r]],s=u(-a[0],a[1]),l=u(-a[0],o[1]),h=u(o[0],a[1]),f=u(o[0],o[1]);n=c(n,c(c(s,l),c(h,f)))}return n[n.length-1]>0}function a(t){for(var e=t.length,r=0;r<e;++r)if(!P[t[r]])return!1;return!0}var d=f(t,e);t=d[0],e=d[1];for(var p=e.length,m=(t.length,o(t,e.length)),v=0;v<p;++v)if(m[v].length%2==1)throw new Error(\"planar-graph-to-polyline: graph must be manifold\");var g=s(t,e);g=g.filter(r);for(var y=g.length,b=new Array(y),x=new Array(y),v=0;v<y;++v){b[v]=v;var _=new Array(y),w=g[v].map(function(t){return e[t]}),M=l([w]),k=0;t:for(var A=0;A<y;++A)if(_[A]=0,v!==A){for(var T=g[A],S=T.length,E=0;E<S;++E){var L=M(e[T[E]]);if(0!==L){L<0&&(_[A]=1,k+=1);continue t}}_[A]=1,k+=1}x[v]=[k,v,_]}x.sort(function(t,e){return e[0]-t[0]});for(var v=0;v<y;++v)for(var _=x[v],C=_[1],z=_[2],A=0;A<y;++A)z[A]&&(b[A]=C);for(var I=i(y),v=0;v<y;++v)I[v].push(b[v]),I[b[v]].push(v);for(var D={},P=n(p,!1),v=0;v<y;++v)for(var T=g[v],S=T.length,A=0;A<S;++A){var O=T[A],R=T[(A+1)%S],F=Math.min(O,R)+\":\"+Math.max(O,R);if(F in D){var j=D[F];I[j].push(v),I[v].push(j),P[O]=P[R]=!0}else D[F]=v}for(var N=[],B=n(y,-1),v=0;v<y;++v)b[v]!==v||a(g[v])?B[v]=-1:(N.push(v),B[v]=0);for(var d=[];N.length>0;){var U=N.pop(),V=I[U];h(V,function(t,e){return t-e});var H,q=V.length,G=B[U];if(0===G){var T=g[U];H=[T]}for(var v=0;v<q;++v){var Y=V[v];if(!(B[Y]>=0)&&(B[Y]=1^G,N.push(Y),0===G)){var T=g[Y];a(T)||(T.reverse(),H.push(T))}}0===G&&d.push(H)}return d}e.exports=a\n",
       ";var o=t(\"edges-to-adjacency-list\"),s=t(\"planar-dual\"),l=t(\"point-in-big-polygon\"),u=t(\"two-product\"),c=t(\"robust-sum\"),h=t(\"uniq\"),f=t(\"./lib/trim-leaves\")},{\"./lib/trim-leaves\":481,\"edges-to-adjacency-list\":126,\"planar-dual\":480,\"point-in-big-polygon\":484,\"robust-sum\":512,\"two-product\":538,uniq:542}],483:[function(t,e,r){\"use strict\";function n(t,e){this.x=t,this.y=e}e.exports=n,n.prototype={clone:function(){return new n(this.x,this.y)},add:function(t){return this.clone()._add(t)},sub:function(t){return this.clone()._sub(t)},mult:function(t){return this.clone()._mult(t)},div:function(t){return this.clone()._div(t)},rotate:function(t){return this.clone()._rotate(t)},matMult:function(t){return this.clone()._matMult(t)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(t){return this.x===t.x&&this.y===t.y},dist:function(t){return Math.sqrt(this.distSqr(t))},distSqr:function(t){var e=t.x-this.x,r=t.y-this.y;return e*e+r*r},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(t){return Math.atan2(this.y-t.y,this.x-t.x)},angleWith:function(t){return this.angleWithSep(t.x,t.y)},angleWithSep:function(t,e){return Math.atan2(this.x*e-this.y*t,this.x*t+this.y*e)},_matMult:function(t){var e=t[0]*this.x+t[1]*this.y,r=t[2]*this.x+t[3]*this.y;return this.x=e,this.y=r,this},_add:function(t){return this.x+=t.x,this.y+=t.y,this},_sub:function(t){return this.x-=t.x,this.y-=t.y,this},_mult:function(t){return this.x*=t,this.y*=t,this},_div:function(t){return this.x/=t,this.y/=t,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var t=this.y;return this.y=this.x,this.x=-t,this},_rotate:function(t){var e=Math.cos(t),r=Math.sin(t),n=e*this.x-r*this.y,i=r*this.x+e*this.y;return this.x=n,this.y=i,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},n.convert=function(t){return t instanceof n?t:Array.isArray(t)?new n(t[0],t[1]):t}},{}],484:[function(t,e,r){function n(){return!0}function i(t){return function(e,r){var i=t[e];return!!i&&!!i.queryPoint(r,n)}}function a(t){for(var e={},r=0;r<t.length;++r){var n=t[r],a=n[0][0],o=n[0][1],s=n[1][1],l=[Math.min(o,s),Math.max(o,s)];a in e?e[a].push(l):e[a]=[l]}for(var u={},c=Object.keys(e),r=0;r<c.length;++r){var h=e[c[r]];u[c[r]]=d(h)}return i(u)}function o(t,e){return function(r){var n=p.le(e,r[0]);if(n<0)return 1;var i=t[n];if(!i){if(!(n>0&&e[n]===r[0]))return 1;i=t[n-1]}for(var a=1;i;){var o=i.key,s=h(r,o[0],o[1]);if(o[0][0]<o[1][0])if(s<0)i=i.left;else{if(!(s>0))return 0;a=-1,i=i.right}else if(s>0)i=i.left;else{if(!(s<0))return 0;a=1,i=i.right}}return a}}function s(t){return 1}function l(t){return function(e){return t(e[0],e[1])?0:1}}function u(t,e){return function(r){return t(r[0],r[1])?0:e(r)}}function c(t){for(var e=t.length,r=[],n=[],i=0;i<e;++i)for(var c=t[i],h=c.length,d=h-1,p=0;p<h;d=p++){var m=c[d],v=c[p];m[0]===v[0]?n.push([m,v]):r.push([m,v])}if(0===r.length)return 0===n.length?s:l(a(n));var g=f(r),y=o(g.slabs,g.coordinates);return 0===n.length?y:u(a(n),y)}e.exports=c;var h=t(\"robust-orientation\")[3],f=t(\"slab-decomposition\"),d=t(\"interval-tree-1d\"),p=t(\"binary-search-bounds\")},{\"binary-search-bounds\":65,\"interval-tree-1d\":290,\"robust-orientation\":507,\"slab-decomposition\":524}],485:[function(t,e,r){\"use strict\";function n(t,e,r,n,s){i.length<n.length&&(i=new Float64Array(n.length),a=new Float64Array(n.length),o=new Float64Array(n.length));for(var l=0;l<n.length;++l)i[l]=t[l]-n[l],a[l]=e[l]-t[l],o[l]=r[l]-t[l];for(var u=0,c=0,h=0,f=0,d=0,p=0,l=0;l<n.length;++l){var m=a[l],v=o[l],g=i[l];u+=m*m,c+=m*v,h+=v*v,f+=g*m,d+=g*v,p+=g*g}var y,b=Math.abs(u*h-c*c),x=c*d-h*f,_=c*f-u*d;if(x+_<=b)if(x<0)_<0&&f<0?(_=0,-f>=u?(x=1,y=u+2*f+p):(x=-f/u,y=f*x+p)):(x=0,d>=0?(_=0,y=p):-d>=h?(_=1,y=h+2*d+p):(_=-d/h,y=d*_+p));else if(_<0)_=0,f>=0?(x=0,y=p):-f>=u?(x=1,y=u+2*f+p):(x=-f/u,y=f*x+p);else{var w=1/b;x*=w,_*=w,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p}else{var M,k,A,T;x<0?(M=c+f,k=h+d,k>M?(A=k-M,T=u-2*c+h,A>=T?(x=1,_=0,y=u+2*f+p):(x=A/T,_=1-x,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)):(x=0,k<=0?(_=1,y=h+2*d+p):d>=0?(_=0,y=p):(_=-d/h,y=d*_+p))):_<0?(M=c+d,k=u+f,k>M?(A=k-M,T=u-2*c+h,A>=T?(_=1,x=0,y=h+2*d+p):(_=A/T,x=1-_,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)):(_=0,k<=0?(x=1,y=u+2*f+p):f>=0?(x=0,y=p):(x=-f/u,y=f*x+p))):(A=h+d-c-f,A<=0?(x=0,_=1,y=h+2*d+p):(T=u-2*c+h,A>=T?(x=1,_=0,y=u+2*f+p):(x=A/T,_=1-x,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)))}for(var S=1-x-_,l=0;l<n.length;++l)s[l]=S*t[l]+x*e[l]+_*r[l];return y<0?0:y}var i=new Float64Array(4),a=new Float64Array(4),o=new Float64Array(4);e.exports=n},{}],486:[function(t,e,r){function n(){throw new Error(\"setTimeout has not been defined\")}function i(){throw new Error(\"clearTimeout has not been defined\")}function a(t){if(h===setTimeout)return setTimeout(t,0);if((h===n||!h)&&setTimeout)return h=setTimeout,setTimeout(t,0);try{return h(t,0)}catch(e){try{return h.call(null,t,0)}catch(e){return h.call(this,t,0)}}}function o(t){if(f===clearTimeout)return clearTimeout(t);if((f===i||!f)&&clearTimeout)return f=clearTimeout,clearTimeout(t);try{return f(t)}catch(e){try{return f.call(null,t)}catch(e){return f.call(this,t)}}}function s(){v&&p&&(v=!1,p.length?m=p.concat(m):g=-1,m.length&&l())}function l(){if(!v){var t=a(s);v=!0;for(var e=m.length;e;){for(p=m,m=[];++g<e;)p&&p[g].run();g=-1,e=m.length}p=null,v=!1,o(t)}}function u(t,e){this.fun=t,this.array=e}function c(){}var h,f,d=e.exports={};!function(){try{h=\"function\"==typeof setTimeout?setTimeout:n}catch(t){h=n}try{f=\"function\"==typeof clearTimeout?clearTimeout:i}catch(t){f=i}}();var p,m=[],v=!1,g=-1;d.nextTick=function(t){var e=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)e[r-1]=arguments[r];m.push(new u(t,e)),1!==m.length||v||a(l)},u.prototype.run=function(){this.fun.apply(null,this.array)},d.title=\"browser\",d.browser=!0,d.env={},d.argv=[],d.version=\"\",d.versions={},d.on=c,d.addListener=c,d.once=c,d.off=c,d.removeListener=c,d.removeAllListeners=c,d.emit=c,d.prependListener=c,d.prependOnceListener=c,d.listeners=function(t){return[]},d.binding=function(t){throw new Error(\"process.binding is not supported\")},d.cwd=function(){return\"/\"},d.chdir=function(t){throw new Error(\"process.chdir is not supported\")},d.umask=function(){return 0}},{}],487:[function(e,r,n){(function(e){!function(i){function a(t){throw new RangeError(P[t])}function o(t,e){for(var r=t.length,n=[];r--;)n[r]=e(t[r]);return n}function s(t,e){var r=t.split(\"@\"),n=\"\";return r.length>1&&(n=r[0]+\"@\",t=r[1]),t=t.replace(D,\".\"),n+o(t.split(\".\"),e).join(\".\")}function l(t){for(var e,r,n=[],i=0,a=t.length;i<a;)e=t.charCodeAt(i++),e>=55296&&e<=56319&&i<a?(r=t.charCodeAt(i++),56320==(64512&r)?n.push(((1023&e)<<10)+(1023&r)+65536):(n.push(e),i--)):n.push(e);return n}function u(t){return o(t,function(t){var e=\"\";return t>65535&&(t-=65536,e+=F(t>>>10&1023|55296),t=56320|1023&t),e+=F(t)}).join(\"\")}function c(t){return t-48<10?t-22:t-65<26?t-65:t-97<26?t-97:M}function h(t,e){return t+22+75*(t<26)-((0!=e)<<5)}function f(t,e,r){var n=0;for(t=r?R(t/S):t>>1,t+=R(t/e);t>O*A>>1;n+=M)t=R(t/O);return R(n+(O+1)*t/(t+T))}function d(t){var e,r,n,i,o,s,l,h,d,p,m=[],v=t.length,g=0,y=L,b=E;for(r=t.lastIndexOf(C),r<0&&(r=0),n=0;n<r;++n)t.charCodeAt(n)>=128&&a(\"not-basic\"),m.push(t.charCodeAt(n));for(i=r>0?r+1:0;i<v;){for(o=g,s=1,l=M;i>=v&&a(\"invalid-input\"),h=c(t.charCodeAt(i++)),(h>=M||h>R((w-g)/s))&&a(\"overflow\"),g+=h*s,d=l<=b?k:l>=b+A?A:l-b,!(h<d);l+=M)p=M-d,s>R(w/p)&&a(\"overflow\"),s*=p;e=m.length+1,b=f(g-o,e,0==o),R(g/e)>w-y&&a(\"overflow\"),y+=R(g/e),g%=e,m.splice(g++,0,y)}return u(m)}function p(t){var e,r,n,i,o,s,u,c,d,p,m,v,g,y,b,x=[];for(t=l(t),v=t.length,e=L,r=0,o=E,s=0;s<v;++s)(m=t[s])<128&&x.push(F(m));for(n=i=x.length,i&&x.push(C);n<v;){for(u=w,s=0;s<v;++s)(m=t[s])>=e&&m<u&&(u=m);for(g=n+1,u-e>R((w-r)/g)&&a(\"overflow\"),r+=(u-e)*g,e=u,s=0;s<v;++s)if(m=t[s],m<e&&++r>w&&a(\"overflow\"),m==e){for(c=r,d=M;p=d<=o?k:d>=o+A?A:d-o,!(c<p);d+=M)b=c-p,y=M-p,x.push(F(h(p+b%y,0))),c=R(b/y);x.push(F(h(c,0))),o=f(r,g,n==i),r=0,++n}++r,++e}return x.join(\"\")}function m(t){return s(t,function(t){return z.test(t)?d(t.slice(4).toLowerCase()):t})}function v(t){return s(t,function(t){return I.test(t)?\"xn--\"+p(t):t})}var g=\"object\"==typeof n&&n&&!n.nodeType&&n,y=\"object\"==typeof r&&r&&!r.nodeType&&r,b=\"object\"==typeof e&&e;b.global!==b&&b.window!==b&&b.self!==b||(i=b);var x,_,w=2147483647,M=36,k=1,A=26,T=38,S=700,E=72,L=128,C=\"-\",z=/^xn--/,I=/[^\\x20-\\x7E]/,D=/[\\x2E\\u3002\\uFF0E\\uFF61]/g,P={overflow:\"Overflow: input needs wider integers to process\",\"not-basic\":\"Illegal input >= 0x80 (not a basic code point)\",\"invalid-input\":\"Invalid input\"},O=M-k,R=Math.floor,F=String.fromCharCode;if(x={version:\"1.4.1\",ucs2:{decode:l,encode:u},decode:d,encode:p,toASCII:v,toUnicode:m},\"function\"==typeof t&&\"object\"==typeof t.amd&&t.amd)t(\"punycode\",function(){return x});else if(g&&y)if(r.exports==g)y.exports=x;else for(_ in x)x.hasOwnProperty(_)&&(g[_]=x[_]);else i.punycode=x}(this)}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{}],488:[function(t,e,r){e.exports=t(\"gl-quat/slerp\")},{\"gl-quat/slerp\":230}],489:[function(t,e,r){\"use strict\";function n(t,e){return Object.prototype.hasOwnProperty.call(t,e)}e.exports=function(t,e,r,a){e=e||\"&\",r=r||\"=\";var o={};if(\"string\"!=typeof t||0===t.length)return o;var s=/\\+/g;t=t.split(e);var l=1e3;a&&\"number\"==typeof a.maxKeys&&(l=a.maxKeys);var u=t.length;l>0&&u>l&&(u=l);for(var c=0;c<u;++c){var h,f,d,p,m=t[c].replace(s,\"%20\"),v=m.indexOf(r);v>=0?(h=m.substr(0,v),f=m.substr(v+1)):(h=m,f=\"\"),d=decodeURIComponent(h),p=decodeURIComponent(f),n(o,d)?i(o[d])?o[d].push(p):o[d]=[o[d],p]:o[d]=p}return o};var i=Array.isArray||function(t){return\"[object Array]\"===Object.prototype.toString.call(t)}},{}],490:[function(t,e,r){\"use strict\";function n(t,e){if(t.map)return t.map(e);for(var r=[],n=0;n<t.length;n++)r.push(e(t[n],n));return r}var i=function(t){switch(typeof t){case\"string\":return t;case\"boolean\":return t?\"true\":\"false\";case\"number\":return isFinite(t)?t:\"\";default:return\"\"}};e.exports=function(t,e,r,s){return e=e||\"&\",r=r||\"=\",null===t&&(t=void 0),\"object\"==typeof t?n(o(t),function(o){var s=encodeURIComponent(i(o))+r;return a(t[o])?n(t[o],function(t){return s+encodeURIComponent(i(t))}).join(e):s+encodeURIComponent(i(t[o]))}).join(e):s?encodeURIComponent(i(s))+r+encodeURIComponent(i(t)):\"\"};var a=Array.isArray||function(t){return\"[object Array]\"===Object.prototype.toString.call(t)},o=Object.keys||function(t){var e=[];for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.push(r);return e}},{}],491:[function(t,e,r){\"use strict\";r.decode=r.parse=t(\"./decode\"),r.encode=r.stringify=t(\"./encode\")},{\"./decode\":489,\"./encode\":490}],492:[function(t,e,r){\"use strict\";function n(t,e,r,o,s){for(r=r||0,o=o||t.length-1,s=s||a;o>r;){if(o-r>600){var l=o-r+1,u=e-r+1,c=Math.log(l),h=.5*Math.exp(2*c/3),f=.5*Math.sqrt(c*h*(l-h)/l)*(u-l/2<0?-1:1);n(t,e,Math.max(r,Math.floor(e-u*h/l+f)),Math.min(o,Math.floor(e+(l-u)*h/l+f)),s)}var d=t[e],p=r,m=o;for(i(t,r,e),s(t[o],d)>0&&i(t,r,o);p<m;){for(i(t,p,m),p++,m--;s(t[p],d)<0;)p++;for(;s(t[m],d)>0;)m--}0===s(t[r],d)?i(t,r,m):(m++,i(t,m,o)),m<=e&&(r=m+1),e<=m&&(o=m-1)}}function i(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}function a(t,e){return t<e?-1:t>e?1:0}e.exports=n},{}],493:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),a=0;a<r;++a)n[a]=i(t[a],e[a]);return n}var i=t(\"big-rat/add\");e.exports=n},{\"big-rat/add\":49}],494:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(t.length),r=0;r<t.length;++r)e[r]=i(t[r]);return e}e.exports=n;var i=t(\"big-rat\")},{\"big-rat\":52}],495:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(e),n=t.length,o=new Array(n),s=0;s<n;++s)o[s]=a(t[s],r);return o}var i=t(\"big-rat\"),a=t(\"big-rat/mul\");e.exports=n},{\"big-rat\":52,\"big-rat/mul\":61}],496:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),a=0;a<r;++a)n[a]=i(t[a],e[a]);return n}var i=t(\"big-rat/sub\");e.exports=n},{\"big-rat/sub\":63}],497:[function(t,e,r){\"use strict\";function n(t){t.sort(a);for(var e=t.length,r=0,n=0;n<e;++n){var s=t[n],l=o(s);if(0!==l){if(r>0){var u=t[r-1];if(0===i(s,u)&&o(u)!==l){r-=1;continue}}t[r++]=s}}return t.length=r,t}var i=t(\"compare-cell\"),a=t(\"compare-oriented-cell\"),o=t(\"cell-orientation\");e.exports=n},{\"cell-orientation\":84,\"compare-cell\":100,\"compare-oriented-cell\":101}],498:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.createREGL=i()}(this,function(){\"use strict\";function t(t){return\"undefined\"!=typeof btoa?btoa(t):\"base64:\"+t}function e(t){var e=new Error(\"(regl) \"+t);throw console.error(e),e}function r(t,r){t||e(r)}function n(t){return t?\": \"+t:\"\"}function i(t,r,i){t in r||e(\"unknown parameter (\"+t+\")\"+n(i)+\". possible values: \"+Object.keys(r).join())}function a(t,r){Qt(t)||e(\"invalid parameter type\"+n(r)+\". must be a typed array\")}function o(t,r,i){typeof t!==r&&e(\"invalid parameter type\"+n(i)+\". expected \"+r+\", got \"+typeof t)}function s(t,r){t>=0&&(0|t)===t||e(\"invalid parameter type, (\"+t+\")\"+n(r)+\". must be a nonnegative integer\")}function l(t,r,i){r.indexOf(t)<0&&e(\"invalid value\"+n(i)+\". must be one of: \"+r)}function u(t){Object.keys(t).forEach(function(t){te.indexOf(t)<0&&e('invalid regl constructor argument \"'+t+'\". must be one of '+te)})}function c(t,e){for(t+=\"\";t.length<e;)t=\" \"+t;return t}function h(){this.name=\"unknown\",this.lines=[],this.index={},this.hasErrors=!1}function f(t,e){this.number=t,this.line=e,this.errors=[]}function d(t,e,r){this.file=t,this.line=e,this.message=r}function p(){var t=new Error,e=(t.stack||t).toString(),r=/compileProcedure.*\\n\\s*at.*\\((.*)\\)/.exec(e);if(r)return r[1];var n=/compileProcedure.*\\n\\s*at\\s+(.*)(\\n|$)/.exec(e);return n?n[1]:\"unknown\"}function m(){var t=new Error,e=(t.stack||t).toString(),r=/at REGLCommand.*\\n\\s+at.*\\((.*)\\)/.exec(e);if(r)return r[1];var n=/at REGLCommand.*\\n\\s+at\\s+(.*)\\n/.exec(e);return n?n[1]:\"unknown\"}function v(e,r){var n=e.split(\"\\n\"),i=1,a=0,o={unknown:new h,0:new h};o.unknown.name=o[0].name=r||p(),o.unknown.lines.push(new f(0,\"\"));for(var s=0;s<n.length;++s){var l=n[s],u=/^\\s*\\#\\s*(\\w+)\\s+(.+)\\s*$/.exec(l);if(u)switch(u[1]){case\"line\":var c=/(\\d+)(\\s+\\d+)?/.exec(u[2]);c&&(i=0|c[1],c[2]&&((a=0|c[2])in o||(o[a]=new h)));break;case\"define\":var d=/SHADER_NAME(_B64)?\\s+(.*)$/.exec(u[2]);d&&(o[a].name=d[1]?t(d[2]):d[2])}o[a].lines.push(new f(i++,l))}return Object.keys(o).forEach(function(t){var e=o[t];e.lines.forEach(function(t){e.index[t.number]=t})}),o}function g(t){var e=[];return t.split(\"\\n\").forEach(function(t){if(!(t.length<5)){var r=/^ERROR\\:\\s+(\\d+)\\:(\\d+)\\:\\s*(.*)$/.exec(t);r?e.push(new d(0|r[1],0|r[2],r[3].trim())):t.length>0&&e.push(new d(\"unknown\",0,t))}}),e}function y(t,e){e.forEach(function(e){var r=t[e.file];if(r){var n=r.index[e.line];if(n)return n.errors.push(e),void(r.hasErrors=!0)}t.unknown.hasErrors=!0,t.unknown.lines[0].errors.push(e)})}function b(t,e,n,i,a){if(!t.getShaderParameter(e,t.COMPILE_STATUS)){var o=t.getShaderInfoLog(e),s=i===t.FRAGMENT_SHADER?\"fragment\":\"vertex\";T(n,\"string\",s+\" shader source must be a string\",a);var l=v(n,a),u=g(o);y(l,u),Object.keys(l).forEach(function(t){function e(t,e){n.push(t),i.push(e||\"\")}var r=l[t];if(r.hasErrors){var n=[\"\"],i=[\"\"];e(\"file number \"+t+\": \"+r.name+\"\\n\",\"color:red;text-decoration:underline;font-weight:bold\"),r.lines.forEach(function(t){if(t.errors.length>0){e(c(t.number,4)+\"|  \",\"background-color:yellow; font-weight:bold\"),e(t.line+\"\\n\",\"color:red; background-color:yellow; font-weight:bold\");var r=0;t.errors.forEach(function(n){var i=n.message,a=/^\\s*\\'(.*)\\'\\s*\\:\\s*(.*)$/.exec(i);if(a){var o=a[1];switch(i=a[2],o){case\"assign\":o=\"=\"}r=Math.max(t.line.indexOf(o,r),0)}else r=0;e(c(\"| \",6)),e(c(\"^^^\",r+3)+\"\\n\",\"font-weight:bold\"),e(c(\"| \",6)),e(i+\"\\n\",\"font-weight:bold\")}),e(c(\"| \",6)+\"\\n\")}else e(c(t.number,4)+\"|  \"),e(t.line+\"\\n\",\"color:red\")}),\"undefined\"!=typeof document?(i[0]=n.join(\"%c\"),console.log.apply(console,i)):console.log(n.join(\"\"))}}),r.raise(\"Error compiling \"+s+\" shader, \"+l[0].name)}}function x(t,e,n,i,a){if(!t.getProgramParameter(e,t.LINK_STATUS)){var o=t.getProgramInfoLog(e),s=v(n,a),l=v(i,a),u='Error linking program with vertex shader, \"'+l[0].name+'\", and fragment shader \"'+s[0].name+'\"';\"undefined\"!=typeof document?console.log(\"%c\"+u+\"\\n%c\"+o,\"color:red;text-decoration:underline;font-weight:bold\",\"color:red\"):console.log(u+\"\\n\"+o),r.raise(u)}}function _(t){t._commandRef=p()}function w(t,e,r,n){function i(t){return t?n.id(t):0}function a(t,e){Object.keys(e).forEach(function(e){t[n.id(e)]=!0})}_(t),t._fragId=i(t.static.frag),t._vertId=i(t.static.vert);var o=t._uniformSet={};a(o,e.static),a(o,e.dynamic);var s=t._attributeSet={};a(s,r.static),a(s,r.dynamic),t._hasCount=\"count\"in t.static||\"count\"in t.dynamic||\"elements\"in t.static||\"elements\"in t.dynamic}function M(t,r){var n=m();e(t+\" in command \"+(r||p())+(\"unknown\"===n?\"\":\" called from \"+n))}function k(t,e,r){t||M(e,r||p())}function A(t,e,r,i){t in e||M(\"unknown parameter (\"+t+\")\"+n(r)+\". possible values: \"+Object.keys(e).join(),i||p())}function T(t,e,r,i){typeof t!==e&&M(\"invalid parameter type\"+n(r)+\". expected \"+e+\", got \"+typeof t,i||p())}function S(t){t()}function E(t,e,r){t.texture?l(t.texture._texture.internalformat,e,\"unsupported texture format for attachment\"):l(t.renderbuffer._renderbuffer.format,r,\"unsupported renderbuffer format for attachment\")}function L(t,e){return t===ue||t===le||t===ce?2:t===he?4:fe[t]*e}function C(t){return!(t&t-1||!t)}function z(t,e,n){var i,a=e.width,o=e.height,s=e.channels;r(a>0&&a<=n.maxTextureSize&&o>0&&o<=n.maxTextureSize,\"invalid texture shape\"),t.wrapS===ee&&t.wrapT===ee||r(C(a)&&C(o),\"incompatible wrap mode for texture, both width and height must be power of 2\"),1===e.mipmask?1!==a&&1!==o&&r(t.minFilter!==ne&&t.minFilter!==ae&&t.minFilter!==ie&&t.minFilter!==oe,\"min filter requires mipmap\"):(r(C(a)&&C(o),\"texture must be a square power of 2 to support mipmapping\"),r(e.mipmask===(a<<1)-1,\"missing or incomplete mipmap data\")),e.type===se&&(n.extensions.indexOf(\"oes_texture_float_linear\")<0&&r(t.minFilter===re&&t.magFilter===re,\"filter not supported, must enable oes_texture_float_linear\"),r(!t.genMipmaps,\"mipmap generation not supported with float textures\"));var l=e.images;for(i=0;i<16;++i)if(l[i]){var u=a>>i,c=o>>i;r(e.mipmask&1<<i,\"missing mipmap data\");var h=l[i];if(r(h.width===u&&h.height===c,\"invalid shape for mip images\"),r(h.format===e.format&&h.internalformat===e.internalformat&&h.type===e.type,\"incompatible type for mip image\"),h.compressed);else if(h.data){var f=Math.ceil(L(h.type,s)*u/h.unpackAlignment)*h.unpackAlignment;r(h.data.byteLength===f*c,\"invalid data for image, buffer size is inconsistent with image format\")}else h.element||h.copy}else t.genMipmaps||r(0==(e.mipmask&1<<i),\"extra mipmap data\");e.compressed&&r(!t.genMipmaps,\"mipmap generation for compressed images not supported\")}function I(t,e,n,i){var a=t.width,o=t.height,s=t.channels;r(a>0&&a<=i.maxTextureSize&&o>0&&o<=i.maxTextureSize,\"invalid texture shape\"),r(a===o,\"cube map must be square\"),r(e.wrapS===ee&&e.wrapT===ee,\"wrap mode not supported by cube map\");for(var l=0;l<n.length;++l){var u=n[l];r(u.width===a&&u.height===o,\"inconsistent cube map face shape\"),e.genMipmaps&&(r(!u.compressed,\"can not generate mipmap for compressed textures\"),r(1===u.mipmask,\"can not specify mipmaps and generate mipmaps\"));for(var c=u.images,h=0;h<16;++h){var f=c[h];if(f){var d=a>>h,p=o>>h;r(u.mipmask&1<<h,\"missing mipmap data\"),r(f.width===d&&f.height===p,\"invalid shape for mip images\"),r(f.format===t.format&&f.internalformat===t.internalformat&&f.type===t.type,\"incompatible type for mip image\"),f.compressed||(f.data?r(f.data.byteLength===d*p*Math.max(L(f.type,s),f.unpackAlignment),\"invalid data for image, buffer size is inconsistent with image format\"):f.element||f.copy)}}}}function D(t,e){this.id=pe++,this.type=t,this.data=e}function P(t){return t.replace(/\\\\/g,\"\\\\\\\\\").replace(/\"/g,'\\\\\"')}function O(t){if(0===t.length)return[];var e=t.charAt(0),r=t.charAt(t.length-1);if(t.length>1&&e===r&&('\"'===e||\"'\"===e))return['\"'+P(t.substr(1,t.length-2))+'\"'];var n=/\\[(false|true|null|\\d+|'[^']*'|\"[^\"]*\")\\]/.exec(t);if(n)return O(t.substr(0,n.index)).concat(O(n[1])).concat(O(t.substr(n.index+n[0].length)));var i=t.split(\".\");if(1===i.length)return['\"'+P(t)+'\"'];for(var a=[],o=0;o<i.length;++o)a=a.concat(O(i[o]));return a}function R(t){return\"[\"+O(t).join(\"][\")+\"]\"}function F(t,e){return new D(t,R(e+\"\"))}function j(t){return\"function\"==typeof t&&!t._reglType||t instanceof D}function N(t,e){return\"function\"==typeof t?new D(me,t):t}function B(){var t={\"\":0},e=[\"\"];return{id:function(r){var n=t[r];return n||(n=t[r]=e.length,e.push(r),n)},str:function(t){return e[t]}}}function U(t,e,r){function n(){var e=window.innerWidth,n=window.innerHeight;if(t!==document.body){var i=t.getBoundingClientRect();e=i.right-i.left,n=i.bottom-i.top}a.width=r*e,a.height=r*n,$t(a.style,{width:e+\"px\",height:n+\"px\"})}function i(){window.removeEventListener(\"resize\",n),t.removeChild(a)}var a=document.createElement(\"canvas\");return $t(a.style,{border:0,margin:0,padding:0,top:0,left:0}),t.appendChild(a),t===document.body&&(a.style.position=\"absolute\",$t(t.style,{margin:0,padding:0})),window.addEventListener(\"resize\",n,!1),n(),{canvas:a,onDestroy:i}}function V(t,e){function r(r){try{return t.getContext(r,e)}catch(t){return null}}return r(\"webgl\")||r(\"experimental-webgl\")||r(\"webgl-experimental\")}function H(t){return\"string\"==typeof t.nodeName&&\"function\"==typeof t.appendChild&&\"function\"==typeof t.getBoundingClientRect}function q(t){return\"function\"==typeof t.drawArrays||\"function\"==typeof t.drawElements}function G(t){return\"string\"==typeof t?t.split():(de(Array.isArray(t),\"invalid extension array\"),t)}function Y(t){return\"string\"==typeof t?(de(\"undefined\"!=typeof document,\"not supported outside of DOM\"),document.querySelector(t)):t}function X(t){var e,r,n,i,a=t||{},o={},s=[],l=[],u=\"undefined\"==typeof window?1:window.devicePixelRatio,c=!1,h=function(t){t&&de.raise(t)},f=function(){};if(\"string\"==typeof a?(de(\"undefined\"!=typeof document,\"selector queries only supported in DOM enviroments\"),e=document.querySelector(a),de(e,\"invalid query string for element\")):\"object\"==typeof a?H(a)?e=a:q(a)?(i=a,n=i.canvas):(de.constructor(a),\"gl\"in a?i=a.gl:\"canvas\"in a?n=Y(a.canvas):\"container\"in a&&(r=Y(a.container)),\"attributes\"in a&&(o=a.attributes,de.type(o,\"object\",\"invalid context attributes\")),\"extensions\"in a&&(s=G(a.extensions)),\"optionalExtensions\"in a&&(l=G(a.optionalExtensions)),\"onDone\"in a&&(de.type(a.onDone,\"function\",\"invalid or missing onDone callback\"),h=a.onDone),\"profile\"in a&&(c=!!a.profile),\"pixelRatio\"in a&&(u=+a.pixelRatio,de(u>0,\"invalid pixel ratio\"))):de.raise(\"invalid arguments to regl\"),e&&(\"canvas\"===e.nodeName.toLowerCase()?n=e:r=e),!i){if(!n){de(\"undefined\"!=typeof document,\"must manually specify webgl context outside of DOM environments\");var d=U(r||document.body,h,u);if(!d)return null;n=d.canvas,f=d.onDestroy}i=V(n,o)}return i?{gl:i,canvas:n,container:r,extensions:s,optionalExtensions:l,pixelRatio:u,profile:c,onDone:h,onDestroy:f}:(f(),h(\"webgl not supported, try upgrading your browser or graphics drivers http://get.webgl.org\"),null)}function W(t,e){function r(e){de.type(e,\"string\",\"extension name must be string\");var r,i=e.toLowerCase();try{r=n[i]=t.getExtension(i)}catch(t){}return!!r}for(var n={},i=0;i<e.extensions.length;++i){var a=e.extensions[i];if(!r(a))return e.onDestroy(),e.onDone('\"'+a+'\" extension is not supported by the current WebGL context, try upgrading your system or a different browser'),null}return e.optionalExtensions.forEach(r),{extensions:n,restore:function(){Object.keys(n).forEach(function(t){if(!r(t))throw new Error(\"(regl): error restoring extension \"+t)})}}}function Z(t){return!!t&&\"object\"==typeof t&&Array.isArray(t.shape)&&Array.isArray(t.stride)&&\"number\"==typeof t.offset&&t.shape.length===t.stride.length&&(Array.isArray(t.data)||Qt(t.data))}function J(t,e){for(var r=Array(t),n=0;n<t;++n)r[n]=e(n);return r}function K(t){for(var e=16;e<=1<<28;e*=16)if(t<=e)return e;return 0}function Q(t){var e,r;return e=(t>65535)<<4,t>>>=e,r=(t>255)<<3,t>>>=r,e|=r,r=(t>15)<<2,t>>>=r,e|=r,r=(t>3)<<1,t>>>=r,(e|=r)|t>>1}function $(t){var e=K(t),r=Ee[Q(e)>>2];return r.length>0?r.pop():new ArrayBuffer(e)}function tt(t){Ee[Q(t.byteLength)>>2].push(t)}function et(t,e){var r=null;switch(t){case _e:r=new Int8Array($(e),0,e);break;case we:r=new Uint8Array($(e),0,e);break;case Me:r=new Int16Array($(2*e),0,e);break;case ke:r=new Uint16Array($(2*e),0,e);break;case Ae:r=new Int32Array($(4*e),0,e);break;case Te:r=new Uint32Array($(4*e),0,e);break;case Se:r=new Float32Array($(4*e),0,e);break;default:return null}return r.length!==e?r.subarray(0,e):r}function rt(t){tt(t.buffer)}function nt(t,e,r){for(var n=0;n<e;++n)r[n]=t[n]}function it(t,e,r,n){for(var i=0,a=0;a<e;++a)for(var o=t[a],s=0;s<r;++s)n[i++]=o[s]}function at(t,e,r,n,i,a){for(var o=a,s=0;s<e;++s)for(var l=t[s],u=0;u<r;++u)for(var c=l[u],h=0;h<n;++h)i[o++]=c[h]}function ot(t,e,r,n,i){for(var a=1,o=r+1;o<e.length;++o)a*=e[o];var s=e[r];if(e.length-r==4){var l=e[r+1],u=e[r+2],c=e[r+3];for(o=0;o<s;++o)at(t[o],l,u,c,n,i),i+=a}else for(o=0;o<s;++o)ot(t[o],e,r+1,n,i),i+=a}function st(t,e,r,n){var i=1;if(e.length)for(var a=0;a<e.length;++a)i*=e[a];else i=0;var o=n||Le.allocType(r,i);switch(e.length){case 0:break;case 1:nt(t,e[0],o);break;case 2:it(t,e[0],e[1],o);break;case 3:at(t,e[0],e[1],e[2],o,0);break;default:ot(t,e,0,o,0)}return o}function lt(t){for(var e=[],r=t;r.length;r=r[0])e.push(r.length);return e}function ut(t){return 0|Kt[Object.prototype.toString.call(t)]}function ct(t,e){for(var r=0;r<e.length;++r)t[r]=e[r]}function ht(t,e,r,n,i,a,o){for(var s=0,l=0;l<r;++l)for(var u=0;u<n;++u)t[s++]=e[i*l+a*u+o]}function ft(t,e,r){function n(e){this.id=h++,this.buffer=t.createBuffer(),this.type=e,this.usage=Oe,this.byteLength=0,this.dimension=1,this.dtype=Fe,this.persistentData=null,r.profile&&(this.stats={size:0})}function i(t,e){var r=d.pop();return r||(r=new n(t)),r.bind(),s(r,e,Re,0,1,!1),r}function a(t){d.push(t)}function o(e,r,n){e.byteLength=r.byteLength,t.bufferData(e.type,r,n)}function s(t,e,r,n,i,a){var s;if(t.usage=r,Array.isArray(e)){if(t.dtype=n||je,e.length>0){var l;if(Array.isArray(e[0])){s=Pe(e);for(var u=1,c=1;c<s.length;++c)u*=s[c];t.dimension=u,l=De(e,s,t.dtype),o(t,l,r),a?t.persistentData=l:Le.freeType(l)}else if(\"number\"==typeof e[0]){t.dimension=i;var h=Le.allocType(t.dtype,e.length);ct(h,e),o(t,h,r),a?t.persistentData=h:Le.freeType(h)}else Qt(e[0])?(t.dimension=e[0].length,t.dtype=n||ut(e[0])||je,l=De(e,[e.length,e[0].length],t.dtype),o(t,l,r),a?t.persistentData=l:Le.freeType(l)):de.raise(\"invalid buffer data\")}}else if(Qt(e))t.dtype=n||ut(e),t.dimension=i,o(t,e,r),a&&(t.persistentData=new Uint8Array(new Uint8Array(e.buffer)));else if(Z(e)){s=e.shape;var f=e.stride,d=e.offset,p=0,m=0,v=0,g=0;1===s.length?(p=s[0],m=1,v=f[0],g=0):2===s.length?(p=s[0],m=s[1],v=f[0],g=f[1]):de.raise(\"invalid shape\"),t.dtype=n||ut(e.data)||je,t.dimension=m;var y=Le.allocType(t.dtype,p*m);ht(y,e.data,p,m,v,g,d),o(t,y,r),a?t.persistentData=y:Le.freeType(y)}else de.raise(\"invalid buffer data\")}function l(r){e.bufferCount--;var n=r.buffer;de(n,\"buffer must not be deleted already\"),t.deleteBuffer(n),r.buffer=null,delete f[r.id]}function u(i,a,o,u){function c(e){var n=Oe,i=null,a=0,o=0,l=1;return Array.isArray(e)||Qt(e)||Z(e)?i=e:\"number\"==typeof e?a=0|e:e&&(de.type(e,\"object\",\"buffer arguments must be an object, a number or an array\"),\"data\"in e&&(de(null===i||Array.isArray(i)||Qt(i)||Z(i),\"invalid data for buffer\"),i=e.data),\"usage\"in e&&(de.parameter(e.usage,Ie,\"invalid buffer usage\"),n=Ie[e.usage]),\"type\"in e&&(de.parameter(e.type,ze,\"invalid buffer type\"),o=ze[e.type]),\"dimension\"in e&&(de.type(e.dimension,\"number\",\"invalid dimension\"),l=0|e.dimension),\"length\"in e&&(de.nni(a,\"buffer length must be a nonnegative integer\"),a=0|e.length)),p.bind(),i?s(p,i,n,o,l,u):(t.bufferData(p.type,a,n),p.dtype=o||Fe,p.usage=n,p.dimension=l,p.byteLength=a),r.profile&&(p.stats.size=p.byteLength*Ne[p.dtype]),c}function h(e,r){de(r+e.byteLength<=p.byteLength,\"invalid buffer subdata call, buffer is too small.  Can't write data of size \"+e.byteLength+\" starting from offset \"+r+\" to a buffer of size \"+p.byteLength),t.bufferSubData(p.type,r,e)}function d(t,e){var r,n=0|(e||0);if(p.bind(),Array.isArray(t)){if(t.length>0)if(\"number\"==typeof t[0]){var i=Le.allocType(p.dtype,t.length);ct(i,t),h(i,n),Le.freeType(i)}else if(Array.isArray(t[0])||Qt(t[0])){r=Pe(t);var a=De(t,r,p.dtype);h(a,n),Le.freeType(a)}else de.raise(\"invalid buffer data\")}else if(Qt(t))h(t,n);else if(Z(t)){r=t.shape;var o=t.stride,s=0,l=0,u=0,f=0;1===r.length?(s=r[0],l=1,u=o[0],f=0):2===r.length?(s=r[0],l=r[1],u=o[0],f=o[1]):de.raise(\"invalid shape\");var d=Array.isArray(t.data)?p.dtype:ut(t.data),m=Le.allocType(d,s*l);ht(m,t.data,s,l,u,f,t.offset),h(m,n),Le.freeType(m)}else de.raise(\"invalid data for buffer subdata\");return c}e.bufferCount++;var p=new n(a);return f[p.id]=p,o||c(i),c._reglType=\"buffer\",c._buffer=p,c.subdata=d,r.profile&&(c.stats=p.stats),c.destroy=function(){l(p)},c}function c(){xe(f).forEach(function(e){e.buffer=t.createBuffer(),t.bindBuffer(e.type,e.buffer),t.bufferData(e.type,e.persistentData||e.byteLength,e.usage)})}var h=0,f={};n.prototype.bind=function(){t.bindBuffer(this.type,this.buffer)},n.prototype.destroy=function(){l(this)};var d=[];return r.profile&&(e.getTotalBufferSize=function(){var t=0;return Object.keys(f).forEach(function(e){t+=f[e].stats.size}),t}),{create:u,createStream:i,destroyStream:a,clear:function(){xe(f).forEach(l),d.forEach(l)},getBuffer:function(t){return t&&t._buffer instanceof n?t._buffer:null},restore:c,_initBuffer:s}}function dt(t,e,r,n){function i(t){this.id=h++,c[this.id]=this,this.buffer=t,this.primType=He,this.vertCount=0,this.type=0}function a(t){var e=d.pop();return e||(e=new i(r.create(null,Je,!0,!1)._buffer)),s(e,t,Ke,-1,-1,0,0),e}function o(t){d.push(t)}function s(n,i,a,o,s,l,u){if(n.buffer.bind(),i){var c=u;u||Qt(i)&&(!Z(i)||Qt(i.data))||(c=e.oes_element_index_uint?Ze:Xe),r._initBuffer(n.buffer,i,a,c,3)}else t.bufferData(Je,l,a),n.buffer.dtype=h||Ge,n.buffer.usage=a,n.buffer.dimension=3,n.buffer.byteLength=l;var h=u;if(!u){switch(n.buffer.dtype){case Ge:case qe:h=Ge;break;case Xe:case Ye:h=Xe;break;case Ze:case We:h=Ze;break;default:de.raise(\"unsupported type for element array\")}n.buffer.dtype=h}n.type=h,de(h!==Ze||!!e.oes_element_index_uint,\"32 bit element buffers not supported, enable oes_element_index_uint first\");var f=s;f<0&&(f=n.buffer.byteLength,h===Xe?f>>=1:h===Ze&&(f>>=2)),n.vertCount=f;var d=o;if(o<0){d=He;var p=n.buffer.dimension;1===p&&(d=Ue),2===p&&(d=Ve),3===p&&(d=He)}n.primType=d}function l(t){n.elementsCount--,de(null!==t.buffer,\"must not double destroy elements\"),delete c[t.id],t.buffer.destroy(),t.buffer=null}function u(t,e){function a(t){if(t)if(\"number\"==typeof t)o(t),u.primType=He,u.vertCount=0|t,u.type=Ge;else{var e=null,r=Qe,n=-1,i=-1,l=0,c=0;Array.isArray(t)||Qt(t)||Z(t)?e=t:(de.type(t,\"object\",\"invalid arguments for elements\"),\"data\"in t&&(e=t.data,de(Array.isArray(e)||Qt(e)||Z(e),\"invalid data for element buffer\")),\"usage\"in t&&(de.parameter(t.usage,Ie,\"invalid element buffer usage\"),r=Ie[t.usage]),\"primitive\"in t&&(de.parameter(t.primitive,Be,\"invalid element buffer primitive\"),n=Be[t.primitive]),\"count\"in t&&(de(\"number\"==typeof t.count&&t.count>=0,\"invalid vertex count for elements\"),i=0|t.count),\"type\"in t&&(de.parameter(t.type,f,\"invalid buffer type\"),c=f[t.type]),\"length\"in t?l=0|t.length:(l=i,c===Xe||c===Ye?l*=2:c!==Ze&&c!==We||(l*=4))),s(u,e,r,n,i,l,c)}else o(),u.primType=He,\n",
       "u.vertCount=0,u.type=Ge;return a}var o=r.create(null,Je,!0),u=new i(o._buffer);return n.elementsCount++,a(t),a._reglType=\"elements\",a._elements=u,a.subdata=function(t,e){return o.subdata(t,e),a},a.destroy=function(){l(u)},a}var c={},h=0,f={uint8:Ge,uint16:Xe};e.oes_element_index_uint&&(f.uint32=Ze),i.prototype.bind=function(){this.buffer.bind()};var d=[];return{create:u,createStream:a,destroyStream:o,getElements:function(t){return\"function\"==typeof t&&t._elements instanceof i?t._elements:null},clear:function(){xe(c).forEach(l)}}}function pt(t){for(var e=Le.allocType(er,t.length),r=0;r<t.length;++r)if(isNaN(t[r]))e[r]=65535;else if(t[r]===1/0)e[r]=31744;else if(t[r]===-1/0)e[r]=64512;else{$e[0]=t[r];var n=tr[0],i=n>>>31<<15,a=(n<<1>>>24)-127,o=n>>13&1023;if(a<-24)e[r]=i;else if(a<-14){var s=-14-a;e[r]=i+(o+1024>>s)}else e[r]=a>15?i+31744:i+(a+15<<10)+o}return e}function mt(t){return Array.isArray(t)||Qt(t)}function vt(t){return\"[object \"+t+\"]\"}function gt(t){return Array.isArray(t)&&(0===t.length||\"number\"==typeof t[0])}function yt(t){return!!Array.isArray(t)&&!(0===t.length||!mt(t[0]))}function bt(t){return Object.prototype.toString.call(t)}function xt(t){return bt(t)===dn}function _t(t){return bt(t)===pn}function wt(t){return bt(t)===mn}function Mt(t){return bt(t)===vn}function kt(t){if(!t)return!1;var e=bt(t);return gn.indexOf(e)>=0||(gt(t)||yt(t)||Z(t))}function At(t){return 0|Kt[Object.prototype.toString.call(t)]}function Tt(t,e){var r=e.length;switch(t.type){case Or:case Rr:case Fr:case jr:var n=Le.allocType(t.type,r);n.set(e),t.data=n;break;case wr:t.data=pt(e);break;default:de.raise(\"unsupported texture type, must specify a typed array\")}}function St(t,e){return Le.allocType(t.type===wr?jr:t.type,e)}function Et(t,e){t.type===wr?(t.data=pt(e),Le.freeType(e)):t.data=e}function Lt(t,e,r,n,i,a){for(var o=t.width,s=t.height,l=t.channels,u=o*s*l,c=St(t,u),h=0,f=0;f<s;++f)for(var d=0;d<o;++d)for(var p=0;p<l;++p)c[h++]=e[r*d+n*f+i*p+a];Et(t,c)}function Ct(t,e,r,n,i,a){var o;if(o=void 0!==bn[t]?bn[t]:fn[t]*yn[e],a&&(o*=6),i){for(var s=0,l=r;l>=1;)s+=o*l*l,l/=2;return s}return o*r*n}function zt(t,e,r,n,i,a,o){function s(){this.internalformat=or,this.format=or,this.type=Or,this.compressed=!1,this.premultiplyAlpha=!1,this.flipY=!1,this.unpackAlignment=1,this.colorSpace=0,this.width=0,this.height=0,this.channels=0}function l(t,e){t.internalformat=e.internalformat,t.format=e.format,t.type=e.type,t.compressed=e.compressed,t.premultiplyAlpha=e.premultiplyAlpha,t.flipY=e.flipY,t.unpackAlignment=e.unpackAlignment,t.colorSpace=e.colorSpace,t.width=e.width,t.height=e.height,t.channels=e.channels}function u(t,n){if(\"object\"==typeof n&&n){if(\"premultiplyAlpha\"in n&&(de.type(n.premultiplyAlpha,\"boolean\",\"invalid premultiplyAlpha\"),t.premultiplyAlpha=n.premultiplyAlpha),\"flipY\"in n&&(de.type(n.flipY,\"boolean\",\"invalid texture flip\"),t.flipY=n.flipY),\"alignment\"in n&&(de.oneOf(n.alignment,[1,2,4,8],\"invalid texture unpack alignment\"),t.unpackAlignment=n.alignment),\"colorSpace\"in n&&(de.parameter(n.colorSpace,j,\"invalid colorSpace\"),t.colorSpace=j[n.colorSpace]),\"type\"in n){var i=n.type;de(e.oes_texture_float||!(\"float\"===i||\"float32\"===i),\"you must enable the OES_texture_float extension in order to use floating point textures.\"),de(e.oes_texture_half_float||!(\"half float\"===i||\"float16\"===i),\"you must enable the OES_texture_half_float extension in order to use 16-bit floating point textures.\"),de(e.webgl_depth_texture||!(\"uint16\"===i||\"uint32\"===i||\"depth stencil\"===i),\"you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures.\"),de.parameter(i,N,\"invalid texture type\"),t.type=N[i]}var a=t.width,o=t.height,s=t.channels,l=!1;\"shape\"in n?(de(Array.isArray(n.shape)&&n.shape.length>=2,\"shape must be an array\"),a=n.shape[0],o=n.shape[1],3===n.shape.length&&(s=n.shape[2],de(s>0&&s<=4,\"invalid number of channels\"),l=!0),de(a>=0&&a<=r.maxTextureSize,\"invalid width\"),de(o>=0&&o<=r.maxTextureSize,\"invalid height\")):(\"radius\"in n&&(a=o=n.radius,de(a>=0&&a<=r.maxTextureSize,\"invalid radius\")),\"width\"in n&&(a=n.width,de(a>=0&&a<=r.maxTextureSize,\"invalid width\")),\"height\"in n&&(o=n.height,de(o>=0&&o<=r.maxTextureSize,\"invalid height\")),\"channels\"in n&&(s=n.channels,de(s>0&&s<=4,\"invalid number of channels\"),l=!0)),t.width=0|a,t.height=0|o,t.channels=0|s;var u=!1;if(\"format\"in n){var c=n.format;de(e.webgl_depth_texture||!(\"depth\"===c||\"depth stencil\"===c),\"you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures.\"),de.parameter(c,B,\"invalid texture format\");var h=t.internalformat=B[c];t.format=J[h],c in N&&(\"type\"in n||(t.type=N[c])),c in U&&(t.compressed=!0),u=!0}!l&&u?t.channels=fn[t.format]:l&&!u?t.channels!==hn[t.format]&&(t.format=t.internalformat=hn[t.channels]):u&&l&&de(t.channels===fn[t.format],\"number of channels inconsistent with specified format\")}}function c(e){t.pixelStorei(an,e.flipY),t.pixelStorei(on,e.premultiplyAlpha),t.pixelStorei(sn,e.colorSpace),t.pixelStorei(nn,e.unpackAlignment)}function h(){s.call(this),this.xOffset=0,this.yOffset=0,this.data=null,this.needsFree=!1,this.element=null,this.needsCopy=!1}function f(t,e){var n=null;if(kt(e)?n=e:e&&(de.type(e,\"object\",\"invalid pixel data type\"),u(t,e),\"x\"in e&&(t.xOffset=0|e.x),\"y\"in e&&(t.yOffset=0|e.y),kt(e.data)&&(n=e.data)),de(!t.compressed||n instanceof Uint8Array,\"compressed texture data must be stored in a uint8array\"),e.copy){de(!n,\"can not specify copy and data field for the same texture\");var a=i.viewportWidth,o=i.viewportHeight;t.width=t.width||a-t.xOffset,t.height=t.height||o-t.yOffset,t.needsCopy=!0,de(t.xOffset>=0&&t.xOffset<a&&t.yOffset>=0&&t.yOffset<o&&t.width>0&&t.width<=a&&t.height>0&&t.height<=o,\"copy texture read out of bounds\")}else if(n){if(Qt(n))t.channels=t.channels||4,t.data=n,\"type\"in e||t.type!==Or||(t.type=At(n));else if(gt(n))t.channels=t.channels||4,Tt(t,n),t.alignment=1,t.needsFree=!0;else if(Z(n)){var s=n.data;Array.isArray(s)||t.type!==Or||(t.type=At(s));var l,c,h,f,d,p,m=n.shape,v=n.stride;3===m.length?(h=m[2],p=v[2]):(de(2===m.length,\"invalid ndarray pixel data, must be 2 or 3D\"),h=1,p=1),l=m[0],c=m[1],f=v[0],d=v[1],t.alignment=1,t.width=l,t.height=c,t.channels=h,t.format=t.internalformat=hn[h],t.needsFree=!0,Lt(t,s,f,d,p,n.offset)}else if(xt(n)||_t(n))xt(n)?t.element=n:t.element=n.canvas,t.width=t.element.width,t.height=t.element.height,t.channels=4;else if(wt(n))t.element=n,t.width=n.naturalWidth,t.height=n.naturalHeight,t.channels=4;else if(Mt(n))t.element=n,t.width=n.videoWidth,t.height=n.videoHeight,t.channels=4;else if(yt(n)){var g=t.width||n[0].length,y=t.height||n.length,b=t.channels;b=mt(n[0][0])?b||n[0][0].length:b||1;for(var x=Ce.shape(n),_=1,w=0;w<x.length;++w)_*=x[w];var M=St(t,_);Ce.flatten(n,x,\"\",M),Et(t,M),t.alignment=1,t.width=g,t.height=y,t.channels=b,t.format=t.internalformat=hn[b],t.needsFree=!0}}else t.width=t.width||1,t.height=t.height||1,t.channels=t.channels||4;t.type===jr?de(r.extensions.indexOf(\"oes_texture_float\")>=0,\"oes_texture_float extension not enabled\"):t.type===wr&&de(r.extensions.indexOf(\"oes_texture_half_float\")>=0,\"oes_texture_half_float extension not enabled\")}function d(e,r,i){var a=e.element,o=e.data,s=e.internalformat,l=e.format,u=e.type,h=e.width,f=e.height;c(e),a?t.texImage2D(r,i,l,l,u,a):e.compressed?t.compressedTexImage2D(r,i,s,h,f,0,o):e.needsCopy?(n(),t.copyTexImage2D(r,i,l,e.xOffset,e.yOffset,h,f,0)):t.texImage2D(r,i,l,h,f,0,l,u,o)}function p(e,r,i,a,o){var s=e.element,l=e.data,u=e.internalformat,h=e.format,f=e.type,d=e.width,p=e.height;c(e),s?t.texSubImage2D(r,o,i,a,h,f,s):e.compressed?t.compressedTexSubImage2D(r,o,i,a,u,d,p,l):e.needsCopy?(n(),t.copyTexSubImage2D(r,o,i,a,e.xOffset,e.yOffset,d,p)):t.texSubImage2D(r,o,i,a,d,p,h,f,l)}function m(){return K.pop()||new h}function v(t){t.needsFree&&Le.freeType(t.data),h.call(t),K.push(t)}function g(){s.call(this),this.genMipmaps=!1,this.mipmapHint=$r,this.mipmask=0,this.images=Array(16)}function y(t,e,r){var n=t.images[0]=m();t.mipmask=1,n.width=t.width=e,n.height=t.height=r,n.channels=t.channels=4}function b(t,e){var r=null;if(kt(e))r=t.images[0]=m(),l(r,t),f(r,e),t.mipmask=1;else if(u(t,e),Array.isArray(e.mipmap))for(var n=e.mipmap,i=0;i<n.length;++i)r=t.images[i]=m(),l(r,t),r.width>>=i,r.height>>=i,f(r,n[i]),t.mipmask|=1<<i;else r=t.images[0]=m(),l(r,t),f(r,e),t.mipmask=1;l(t,t.images[0]),(t.compressed&&t.internalformat===Mr||t.internalformat===kr||t.internalformat===Ar||t.internalformat===Tr)&&de(t.width%4==0&&t.height%4==0,\"for compressed texture formats, mipmap level 0 must have width and height that are a multiple of 4\")}function x(t,e){for(var r=t.images,n=0;n<r.length;++n){if(!r[n])return;d(r[n],e,n)}}function _(){var t=Q.pop()||new g;s.call(t),t.mipmask=0;for(var e=0;e<16;++e)t.images[e]=null;return t}function w(t){for(var e=t.images,r=0;r<e.length;++r)e[r]&&v(e[r]),e[r]=null;Q.push(t)}function M(){this.minFilter=Yr,this.magFilter=Yr,this.wrapS=Vr,this.wrapT=Vr,this.anisotropic=1,this.genMipmaps=!1,this.mipmapHint=$r}function k(t,e){if(\"min\"in e){var n=e.min;de.parameter(n,F),t.minFilter=F[n],cn.indexOf(t.minFilter)>=0&&(t.genMipmaps=!0)}if(\"mag\"in e){var i=e.mag;de.parameter(i,R),t.magFilter=R[i]}var a=t.wrapS,o=t.wrapT;if(\"wrap\"in e){var s=e.wrap;\"string\"==typeof s?(de.parameter(s,O),a=o=O[s]):Array.isArray(s)&&(de.parameter(s[0],O),de.parameter(s[1],O),a=O[s[0]],o=O[s[1]])}else{if(\"wrapS\"in e){var l=e.wrapS;de.parameter(l,O),a=O[l]}if(\"wrapT\"in e){var u=e.wrapT;de.parameter(u,O),o=O[u]}}if(t.wrapS=a,t.wrapT=o,\"anisotropic\"in e){var c=e.anisotropic;de(\"number\"==typeof c&&c>=1&&c<=r.maxAnisotropic,\"aniso samples must be between 1 and \"),t.anisotropic=e.anisotropic}if(\"mipmap\"in e){var h=!1;switch(typeof e.mipmap){case\"string\":de.parameter(e.mipmap,P,\"invalid mipmap hint\"),t.mipmapHint=P[e.mipmap],t.genMipmaps=!0,h=!0;break;case\"boolean\":h=t.genMipmaps=e.mipmap;break;case\"object\":de(Array.isArray(e.mipmap),\"invalid mipmap type\"),t.genMipmaps=!1,h=!0;break;default:de.raise(\"invalid mipmap type\")}!h||\"min\"in e||(t.minFilter=Wr)}}function A(r,n){t.texParameteri(n,Gr,r.minFilter),t.texParameteri(n,qr,r.magFilter),t.texParameteri(n,Nr,r.wrapS),t.texParameteri(n,Br,r.wrapT),e.ext_texture_filter_anisotropic&&t.texParameteri(n,rn,r.anisotropic),r.genMipmaps&&(t.hint(Qr,r.mipmapHint),t.generateMipmap(n))}function T(e){s.call(this),this.mipmask=0,this.internalformat=or,this.id=$++,this.refCount=1,this.target=e,this.texture=t.createTexture(),this.unit=-1,this.bindCount=0,this.texInfo=new M,o.profile&&(this.stats={size:0})}function S(e){t.activeTexture(un),t.bindTexture(e.target,e.texture)}function E(){var e=rt[0];e?t.bindTexture(e.target,e.texture):t.bindTexture(nr,null)}function L(e){var r=e.texture;de(r,\"must not double destroy texture\");var n=e.unit,i=e.target;n>=0&&(t.activeTexture(un+n),t.bindTexture(i,null),rt[n]=null),t.deleteTexture(r),e.texture=null,e.params=null,e.pixels=null,e.refCount=0,delete tt[e.id],a.textureCount--}function C(e,n){function i(t,e){var n=c.texInfo;M.call(n);var a=_();return\"number\"==typeof t?\"number\"==typeof e?y(a,0|t,0|e):y(a,0|t,0|t):t?(de.type(t,\"object\",\"invalid arguments to regl.texture\"),k(n,t),b(a,t)):y(a,1,1),n.genMipmaps&&(a.mipmask=(a.width<<1)-1),c.mipmask=a.mipmask,l(c,a),de.texture2D(n,a,r),c.internalformat=a.internalformat,i.width=a.width,i.height=a.height,S(c),x(a,nr),A(n,nr),E(),w(a),o.profile&&(c.stats.size=Ct(c.internalformat,c.type,a.width,a.height,n.genMipmaps,!1)),i.format=q[c.internalformat],i.type=G[c.type],i.mag=Y[n.magFilter],i.min=X[n.minFilter],i.wrapS=W[n.wrapS],i.wrapT=W[n.wrapT],i}function s(t,e,r,n){de(!!t,\"must specify image data\");var a=0|e,o=0|r,s=0|n,u=m();return l(u,c),u.width=0,u.height=0,f(u,t),u.width=u.width||(c.width>>s)-a,u.height=u.height||(c.height>>s)-o,de(c.type===u.type&&c.format===u.format&&c.internalformat===u.internalformat,\"incompatible format for texture.subimage\"),de(a>=0&&o>=0&&a+u.width<=c.width&&o+u.height<=c.height,\"texture.subimage write out of bounds\"),de(c.mipmask&1<<s,\"missing mipmap data\"),de(u.data||u.element||u.needsCopy,\"missing image data\"),S(c),p(u,nr,a,o,s),E(),v(u),i}function u(e,r){var n=0|e,a=0|r||n;if(n===c.width&&a===c.height)return i;i.width=c.width=n,i.height=c.height=a,S(c);for(var s=0;c.mipmask>>s;++s)t.texImage2D(nr,s,c.format,n>>s,a>>s,0,c.format,c.type,null);return E(),o.profile&&(c.stats.size=Ct(c.internalformat,c.type,n,a,!1,!1)),i}var c=new T(nr);return tt[c.id]=c,a.textureCount++,i(e,n),i.subimage=s,i.resize=u,i._reglType=\"texture2d\",i._texture=c,o.profile&&(i.stats=c.stats),i.destroy=function(){c.decRef()},i}function z(e,n,i,s,c,h){function d(t,e,n,i,a,s){var c,h=C.texInfo;for(M.call(h),c=0;c<6;++c)z[c]=_();if(\"number\"!=typeof t&&t)if(\"object\"==typeof t)if(e)b(z[0],t),b(z[1],e),b(z[2],n),b(z[3],i),b(z[4],a),b(z[5],s);else if(k(h,t),u(C,t),\"faces\"in t){var f=t.faces;for(de(Array.isArray(f)&&6===f.length,\"cube faces must be a length 6 array\"),c=0;c<6;++c)de(\"object\"==typeof f[c]&&!!f[c],\"invalid input for cube map face\"),l(z[c],C),b(z[c],f[c])}else for(c=0;c<6;++c)b(z[c],t);else de.raise(\"invalid arguments to cube map\");else{var p=0|t||1;for(c=0;c<6;++c)y(z[c],p,p)}for(l(C,z[0]),h.genMipmaps?C.mipmask=(z[0].width<<1)-1:C.mipmask=z[0].mipmask,de.textureCube(C,h,z,r),C.internalformat=z[0].internalformat,d.width=z[0].width,d.height=z[0].height,S(C),c=0;c<6;++c)x(z[c],ar+c);for(A(h,ir),E(),o.profile&&(C.stats.size=Ct(C.internalformat,C.type,d.width,d.height,h.genMipmaps,!0)),d.format=q[C.internalformat],d.type=G[C.type],d.mag=Y[h.magFilter],d.min=X[h.minFilter],d.wrapS=W[h.wrapS],d.wrapT=W[h.wrapT],c=0;c<6;++c)w(z[c]);return d}function g(t,e,r,n,i){de(!!e,\"must specify image data\"),de(\"number\"==typeof t&&t===(0|t)&&t>=0&&t<6,\"invalid face\");var a=0|r,o=0|n,s=0|i,u=m();return l(u,C),u.width=0,u.height=0,f(u,e),u.width=u.width||(C.width>>s)-a,u.height=u.height||(C.height>>s)-o,de(C.type===u.type&&C.format===u.format&&C.internalformat===u.internalformat,\"incompatible format for texture.subimage\"),de(a>=0&&o>=0&&a+u.width<=C.width&&o+u.height<=C.height,\"texture.subimage write out of bounds\"),de(C.mipmask&1<<s,\"missing mipmap data\"),de(u.data||u.element||u.needsCopy,\"missing image data\"),S(C),p(u,ar+t,a,o,s),E(),v(u),d}function L(e){var r=0|e;if(r!==C.width){d.width=C.width=r,d.height=C.height=r,S(C);for(var n=0;n<6;++n)for(var i=0;C.mipmask>>i;++i)t.texImage2D(ar+n,i,C.format,r>>i,r>>i,0,C.format,C.type,null);return E(),o.profile&&(C.stats.size=Ct(C.internalformat,C.type,d.width,d.height,!1,!0)),d}}var C=new T(ir);tt[C.id]=C,a.cubeCount++;var z=new Array(6);return d(e,n,i,s,c,h),d.subimage=g,d.resize=L,d._reglType=\"textureCube\",d._texture=C,o.profile&&(d.stats=C.stats),d.destroy=function(){C.decRef()},d}function I(){for(var e=0;e<et;++e)t.activeTexture(un+e),t.bindTexture(nr,null),rt[e]=null;xe(tt).forEach(L),a.cubeCount=0,a.textureCount=0}function D(){xe(tt).forEach(function(e){e.texture=t.createTexture(),t.bindTexture(e.target,e.texture);for(var r=0;r<32;++r)if(0!=(e.mipmask&1<<r))if(e.target===nr)t.texImage2D(nr,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);else for(var n=0;n<6;++n)t.texImage2D(ar+n,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);A(e.texInfo,e.target)})}var P={\"don't care\":$r,\"dont care\":$r,nice:en,fast:tn},O={repeat:Ur,clamp:Vr,mirror:Hr},R={nearest:Yr,linear:Xr},F=$t({mipmap:Kr,\"nearest mipmap nearest\":Wr,\"linear mipmap nearest\":Zr,\"nearest mipmap linear\":Jr,\"linear mipmap linear\":Kr},R),j={none:0,browser:ln},N={uint8:Or,rgba4:pr,rgb565:vr,\"rgb5 a1\":mr},B={alpha:sr,luminance:ur,\"luminance alpha\":cr,rgb:lr,rgba:or,rgba4:hr,\"rgb5 a1\":fr,rgb565:dr},U={};e.ext_srgb&&(B.srgb=xr,B.srgba=_r),e.oes_texture_float&&(N.float32=N.float=jr),e.oes_texture_half_float&&(N.float16=N[\"half float\"]=wr),e.webgl_depth_texture&&($t(B,{depth:yr,\"depth stencil\":br}),$t(N,{uint16:Rr,uint32:Fr,\"depth stencil\":gr})),e.webgl_compressed_texture_s3tc&&$t(U,{\"rgb s3tc dxt1\":Mr,\"rgba s3tc dxt1\":kr,\"rgba s3tc dxt3\":Ar,\"rgba s3tc dxt5\":Tr}),e.webgl_compressed_texture_atc&&$t(U,{\"rgb atc\":Sr,\"rgba atc explicit alpha\":Er,\"rgba atc interpolated alpha\":Lr}),e.webgl_compressed_texture_pvrtc&&$t(U,{\"rgb pvrtc 4bppv1\":Cr,\"rgb pvrtc 2bppv1\":zr,\"rgba pvrtc 4bppv1\":Ir,\"rgba pvrtc 2bppv1\":Dr}),e.webgl_compressed_texture_etc1&&(U[\"rgb etc1\"]=Pr);var V=Array.prototype.slice.call(t.getParameter(rr));Object.keys(U).forEach(function(t){var e=U[t];V.indexOf(e)>=0&&(B[t]=e)});var H=Object.keys(B);r.textureFormats=H;var q=[];Object.keys(B).forEach(function(t){var e=B[t];q[e]=t});var G=[];Object.keys(N).forEach(function(t){var e=N[t];G[e]=t});var Y=[];Object.keys(R).forEach(function(t){var e=R[t];Y[e]=t});var X=[];Object.keys(F).forEach(function(t){var e=F[t];X[e]=t});var W=[];Object.keys(O).forEach(function(t){var e=O[t];W[e]=t});var J=H.reduce(function(t,e){var r=B[e];return r===ur||r===sr||r===ur||r===cr||r===yr||r===br?t[r]=r:r===fr||e.indexOf(\"rgba\")>=0?t[r]=or:t[r]=lr,t},{}),K=[],Q=[],$=0,tt={},et=r.maxTextureUnits,rt=Array(et).map(function(){return null});return $t(T.prototype,{bind:function(){var e=this;e.bindCount+=1;var r=e.unit;if(r<0){for(var n=0;n<et;++n){var i=rt[n];if(i){if(i.bindCount>0)continue;i.unit=-1}rt[n]=e,r=n;break}r>=et&&de.raise(\"insufficient number of texture units\"),o.profile&&a.maxTextureUnits<r+1&&(a.maxTextureUnits=r+1),e.unit=r,t.activeTexture(un+r),t.bindTexture(e.target,e.texture)}return r},unbind:function(){this.bindCount-=1},decRef:function(){--this.refCount<=0&&L(this)}}),o.profile&&(a.getTotalTextureSize=function(){var t=0;return Object.keys(tt).forEach(function(e){t+=tt[e].stats.size}),t}),{create2D:C,createCube:z,clear:I,getTexture:function(t){return null},restore:D}}function It(t,e,r){return wn[t]*e*r}function Dt(t,e,r,n,i,a){function o(t,e,r){this.target=t,this.texture=e,this.renderbuffer=r;var n=0,i=0;e?(n=e.width,i=e.height):r&&(n=r.width,i=r.height),this.width=n,this.height=i}function s(t){t&&(t.texture&&t.texture._texture.decRef(),t.renderbuffer&&t.renderbuffer._renderbuffer.decRef())}function l(t,e,r){if(t)if(t.texture){var n=t.texture._texture,i=Math.max(1,n.width),a=Math.max(1,n.height);de(i===e&&a===r,\"inconsistent width/height for supplied texture\"),n.refCount+=1}else{var o=t.renderbuffer._renderbuffer;de(o.width===e&&o.height===r,\"inconsistent width/height for renderbuffer\"),o.refCount+=1}}function u(e,r){r&&(r.texture?t.framebufferTexture2D(kn,e,r.target,r.texture._texture.texture,0):t.framebufferRenderbuffer(kn,e,An,r.renderbuffer._renderbuffer.renderbuffer))}function c(t){var e=Tn,r=null,n=null,i=t;\"object\"==typeof t&&(i=t.data,\"target\"in t&&(e=0|t.target)),de.type(i,\"function\",\"invalid attachment data\");var a=i._reglType;return\"texture2d\"===a?(r=i,de(e===Tn)):\"textureCube\"===a?(r=i,de(e>=Sn&&e<Sn+6,\"invalid cube map target\")):\"renderbuffer\"===a?(n=i,e=An):de.raise(\"invalid regl object for attachment\"),new o(e,r,n)}function h(t,e,r,a,s){if(r){var l=n.create2D({width:t,height:e,format:a,type:s});return l._texture.refCount=0,new o(Tn,l,null)}var u=i.create({width:t,height:e,format:a});return u._renderbuffer.refCount=0,new o(An,null,u)}function f(t){return t&&(t.texture||t.renderbuffer)}function d(t,e,r){t&&(t.texture?t.texture.resize(e,r):t.renderbuffer&&t.renderbuffer.resize(e,r))}function p(){this.id=A++,T[this.id]=this,this.framebuffer=t.createFramebuffer(),this.width=0,this.height=0,this.colorAttachments=[],this.depthAttachment=null,this.stencilAttachment=null,this.depthStencilAttachment=null}function m(t){t.colorAttachments.forEach(s),s(t.depthAttachment),s(t.stencilAttachment),s(t.depthStencilAttachment)}function v(e){var r=e.framebuffer;de(r,\"must not double destroy framebuffer\"),t.deleteFramebuffer(r),e.framebuffer=null,a.framebufferCount--,delete T[e.id]}function g(e){var n;t.bindFramebuffer(kn,e.framebuffer);var i=e.colorAttachments;for(n=0;n<i.length;++n)u(En+n,i[n]);for(n=i.length;n<r.maxColorAttachments;++n)t.framebufferTexture2D(kn,En+n,Tn,null,0);t.framebufferTexture2D(kn,zn,Tn,null,0),t.framebufferTexture2D(kn,Ln,Tn,null,0),t.framebufferTexture2D(kn,Cn,Tn,null,0),u(Ln,e.depthAttachment),u(Cn,e.stencilAttachment),u(zn,e.depthStencilAttachment);var a=t.checkFramebufferStatus(kn);a!==In&&de.raise(\"framebuffer configuration not supported, status = \"+Un[a]),t.bindFramebuffer(kn,_.next),_.cur=_.next,t.getError()}function y(t,n){function i(t,n){var a;de(_.next!==s,\"can not update framebuffer which is currently in use\");var o=e.webgl_draw_buffers,u=0,d=0,p=!0,v=!0,y=null,b=!0,x=\"rgba\",A=\"uint8\",T=1,S=null,E=null,L=null,C=!1;if(\"number\"==typeof t)u=0|t,d=0|n||u;else if(t){de.type(t,\"object\",\"invalid arguments for framebuffer\");var z=t;if(\"shape\"in z){var I=z.shape;de(Array.isArray(I)&&I.length>=2,\"invalid shape for framebuffer\"),u=I[0],d=I[1]}else\"radius\"in z&&(u=d=z.radius),\"width\"in z&&(u=z.width),\"height\"in z&&(d=z.height);(\"color\"in z||\"colors\"in z)&&(y=z.color||z.colors,Array.isArray(y)&&de(1===y.length||o,\"multiple render targets not supported\")),y||(\"colorCount\"in z&&(T=0|z.colorCount,de(T>0,\"invalid color buffer count\")),\"colorTexture\"in z&&(b=!!z.colorTexture,x=\"rgba4\"),\"colorType\"in z&&(A=z.colorType,b?(de(e.oes_texture_float||!(\"float\"===A||\"float32\"===A),\"you must enable OES_texture_float in order to use floating point framebuffer objects\"),de(e.oes_texture_half_float||!(\"half float\"===A||\"float16\"===A),\"you must enable OES_texture_half_float in order to use 16-bit floating point framebuffer objects\")):\"half float\"===A||\"float16\"===A?(de(e.ext_color_buffer_half_float,\"you must enable EXT_color_buffer_half_float to use 16-bit render buffers\"),x=\"rgba16f\"):\"float\"!==A&&\"float32\"!==A||(de(e.webgl_color_buffer_float,\"you must enable WEBGL_color_buffer_float in order to use 32-bit floating point renderbuffers\"),x=\"rgba32f\"),de.oneOf(A,k,\"invalid color type\")),\"colorFormat\"in z&&(x=z.colorFormat,w.indexOf(x)>=0?b=!0:M.indexOf(x)>=0?b=!1:b?de.oneOf(z.colorFormat,w,\"invalid color format for texture\"):de.oneOf(z.colorFormat,M,\"invalid color format for renderbuffer\"))),(\"depthTexture\"in z||\"depthStencilTexture\"in z)&&(C=!(!z.depthTexture&&!z.depthStencilTexture),de(!C||e.webgl_depth_texture,\"webgl_depth_texture extension not supported\")),\"depth\"in z&&(\"boolean\"==typeof z.depth?p=z.depth:(S=z.depth,v=!1)),\"stencil\"in z&&(\"boolean\"==typeof z.stencil?v=z.stencil:(E=z.stencil,p=!1)),\"depthStencil\"in z&&(\"boolean\"==typeof z.depthStencil?p=v=z.depthStencil:(L=z.depthStencil,p=!1,v=!1))}else u=d=1;var D=null,P=null,O=null,R=null;if(Array.isArray(y))D=y.map(c);else if(y)D=[c(y)];else for(D=new Array(T),a=0;a<T;++a)D[a]=h(u,d,b,x,A);de(e.webgl_draw_buffers||D.length<=1,\"you must enable the WEBGL_draw_buffers extension in order to use multiple color buffers.\"),de(D.length<=r.maxColorAttachments,\"too many color attachments, not supported\"),u=u||D[0].width,d=d||D[0].height,S?P=c(S):p&&!v&&(P=h(u,d,C,\"depth\",\"uint32\")),E?O=c(E):v&&!p&&(O=h(u,d,!1,\"stencil\",\"uint8\")),L?R=c(L):!S&&!E&&v&&p&&(R=h(u,d,C,\"depth stencil\",\"depth stencil\")),de(!!S+!!E+!!L<=1,\"invalid framebuffer configuration, can specify exactly one depth/stencil attachment\");var F=null;for(a=0;a<D.length;++a)if(l(D[a],u,d),de(!D[a]||D[a].texture&&Pn.indexOf(D[a].texture._texture.format)>=0||D[a].renderbuffer&&Bn.indexOf(D[a].renderbuffer._renderbuffer.format)>=0,\"framebuffer color attachment \"+a+\" is invalid\"),D[a]&&D[a].texture){var j=On[D[a].texture._texture.format]*Rn[D[a].texture._texture.type];null===F?F=j:de(F===j,\"all color attachments much have the same number of bits per pixel.\")}return l(P,u,d),de(!P||P.texture&&P.texture._texture.format===Dn||P.renderbuffer&&P.renderbuffer._renderbuffer.format===Fn,\"invalid depth attachment for framebuffer object\"),l(O,u,d),de(!O||O.renderbuffer&&O.renderbuffer._renderbuffer.format===jn,\"invalid stencil attachment for framebuffer object\"),l(R,u,d),de(!R||R.texture&&R.texture._texture.format===Nn||R.renderbuffer&&R.renderbuffer._renderbuffer.format===Nn,\"invalid depth-stencil attachment for framebuffer object\"),m(s),s.width=u,s.height=d,s.colorAttachments=D,s.depthAttachment=P,s.stencilAttachment=O,s.depthStencilAttachment=R,i.color=D.map(f),i.depth=f(P),i.stencil=f(O),i.depthStencil=f(R),i.width=s.width,i.height=s.height,g(s),i}function o(t,e){de(_.next!==s,\"can not resize a framebuffer which is currently in use\");var r=0|t,n=0|e||r;if(r===s.width&&n===s.height)return i;for(var a=s.colorAttachments,o=0;o<a.length;++o)d(a[o],r,n);return d(s.depthAttachment,r,n),d(s.stencilAttachment,r,n),d(s.depthStencilAttachment,r,n),s.width=i.width=r,s.height=i.height=n,g(s),i}var s=new p;return a.framebufferCount++,i(t,n),$t(i,{resize:o,_reglType:\"framebuffer\",_framebuffer:s,destroy:function(){v(s),m(s)},use:function(t){_.setFBO({framebuffer:i},t)}})}function b(t){function i(t){var r;de(o.indexOf(_.next)<0,\"can not update framebuffer which is currently in use\");var a=e.webgl_draw_buffers,s={color:null},l=0,u=null,c=\"rgba\",h=\"uint8\",f=1;if(\"number\"==typeof t)l=0|t;else if(t){de.type(t,\"object\",\"invalid arguments for framebuffer\");var d=t;if(\"shape\"in d){var p=d.shape;de(Array.isArray(p)&&p.length>=2,\"invalid shape for framebuffer\"),de(p[0]===p[1],\"cube framebuffer must be square\"),l=p[0]}else\"radius\"in d&&(l=0|d.radius),\"width\"in d?(l=0|d.width,\"height\"in d&&de(d.height===l,\"must be square\")):\"height\"in d&&(l=0|d.height);(\"color\"in d||\"colors\"in d)&&(u=d.color||d.colors,Array.isArray(u)&&de(1===u.length||a,\"multiple render targets not supported\")),u||(\"colorCount\"in d&&(f=0|d.colorCount,de(f>0,\"invalid color buffer count\")),\"colorType\"in d&&(de.oneOf(d.colorType,k,\"invalid color type\"),h=d.colorType),\"colorFormat\"in d&&(c=d.colorFormat,de.oneOf(d.colorFormat,w,\"invalid color format for texture\"))),\"depth\"in d&&(s.depth=d.depth),\"stencil\"in d&&(s.stencil=d.stencil),\"depthStencil\"in d&&(s.depthStencil=d.depthStencil)}else l=1;var m;if(u)if(Array.isArray(u))for(m=[],r=0;r<u.length;++r)m[r]=u[r];else m=[u];else{m=Array(f);var v={radius:l,format:c,type:h};for(r=0;r<f;++r)m[r]=n.createCube(v)}for(s.color=Array(m.length),r=0;r<m.length;++r){var g=m[r];de(\"function\"==typeof g&&\"textureCube\"===g._reglType,\"invalid cube map\"),l=l||g.width,de(g.width===l&&g.height===l,\"invalid cube map shape\"),s.color[r]={target:Sn,data:m[r]}}for(r=0;r<6;++r){for(var b=0;b<m.length;++b)s.color[b].target=Sn+r;r>0&&(s.depth=o[0].depth,s.stencil=o[0].stencil,s.depthStencil=o[0].depthStencil),o[r]?o[r](s):o[r]=y(s)}return $t(i,{width:l,height:l,color:m})}function a(t){var e,n=0|t;if(de(n>0&&n<=r.maxCubeMapSize,\"invalid radius for cube fbo\"),n===i.width)return i;var a=i.color;for(e=0;e<a.length;++e)a[e].resize(n);for(e=0;e<6;++e)o[e].resize(n);return i.width=i.height=n,i}var o=Array(6);return i(t),$t(i,{faces:o,resize:a,_reglType:\"framebufferCube\",destroy:function(){o.forEach(function(t){t.destroy()})}})}function x(){xe(T).forEach(function(e){e.framebuffer=t.createFramebuffer(),g(e)})}var _={cur:null,next:null,dirty:!1,setFBO:null},w=[\"rgba\"],M=[\"rgba4\",\"rgb565\",\"rgb5 a1\"];e.ext_srgb&&M.push(\"srgba\"),e.ext_color_buffer_half_float&&M.push(\"rgba16f\",\"rgb16f\"),e.webgl_color_buffer_float&&M.push(\"rgba32f\");var k=[\"uint8\"];e.oes_texture_half_float&&k.push(\"half float\",\"float16\"),e.oes_texture_float&&k.push(\"float\",\"float32\");var A=0,T={};return $t(_,{getFramebuffer:function(t){if(\"function\"==typeof t&&\"framebuffer\"===t._reglType){var e=t._framebuffer;if(e instanceof p)return e}return null},create:y,createCube:b,clear:function(){xe(T).forEach(v)},restore:x})}function Pt(){this.state=0,this.x=0,this.y=0,this.z=0,this.w=0,this.buffer=null,this.size=0,this.normalized=!1,this.type=Vn,this.offset=0,this.stride=0,this.divisor=0}function Ot(t,e,r,n,i){for(var a=r.maxAttributes,o=new Array(a),s=0;s<a;++s)o[s]=new Pt;return{Record:Pt,scope:{},state:o}}function Rt(t,e,r,n){function i(t,e,r,n){this.name=t,this.id=e,this.location=r,this.info=n}function a(t,e){for(var r=0;r<t.length;++r)if(t[r].id===e.id)return void(t[r].location=e.location);t.push(e)}function o(r,n,i){var a=r===Hn?c:h,o=a[n];if(!o){var s=e.str(n);o=t.createShader(r),t.shaderSource(o,s),t.compileShader(o),de.shaderError(t,o,s,r,i),a[n]=o}return o}function s(t,e){this.id=p++,this.fragId=t,this.vertId=e,this.program=null,this.uniforms=[],this.attributes=[],n.profile&&(this.stats={uniformsCount:0,attributesCount:0})}function l(r,s){var l,u,c=o(Hn,r.fragId),h=o(qn,r.vertId),f=r.program=t.createProgram();t.attachShader(f,c),t.attachShader(f,h),t.linkProgram(f),de.linkError(t,f,e.str(r.fragId),e.str(r.vertId),s);var d=t.getProgramParameter(f,Gn);n.profile&&(r.stats.uniformsCount=d);var p=r.uniforms;for(l=0;l<d;++l)if(u=t.getActiveUniform(f,l))if(u.size>1)for(var m=0;m<u.size;++m){var v=u.name.replace(\"[0]\",\"[\"+m+\"]\");a(p,new i(v,e.id(v),t.getUniformLocation(f,v),u))}else a(p,new i(u.name,e.id(u.name),t.getUniformLocation(f,u.name),u));var g=t.getProgramParameter(f,Yn);n.profile&&(r.stats.attributesCount=g);var y=r.attributes;for(l=0;l<g;++l)(u=t.getActiveAttrib(f,l))&&a(y,new i(u.name,e.id(u.name),t.getAttribLocation(f,u.name),u))}function u(){c={},h={};for(var t=0;t<d.length;++t)l(d[t])}var c={},h={},f={},d=[],p=0;return n.profile&&(r.getMaxUniformsCount=function(){var t=0;return d.forEach(function(e){e.stats.uniformsCount>t&&(t=e.stats.uniformsCount)}),t},r.getMaxAttributesCount=function(){var t=0;return d.forEach(function(e){e.stats.attributesCount>t&&(t=e.stats.attributesCount)}),t}),{clear:function(){var e=t.deleteShader.bind(t);xe(c).forEach(e),c={},xe(h).forEach(e),h={},d.forEach(function(e){t.deleteProgram(e.program)}),d.length=0,f={},r.shaderCount=0},program:function(t,e,n){de.command(t>=0,\"missing vertex shader\",n),de.command(e>=0,\"missing fragment shader\",n);var i=f[e];i||(i=f[e]={});var a=i[t];return a||(a=new s(e,t),r.shaderCount++,l(a,n),i[t]=a,d.push(a)),a},restore:u,shader:o,frag:-1,vert:-1}}function Ft(t,e,r,n,i,a){function o(o){var s;null===e.next?(de(i.preserveDrawingBuffer,'you must create a webgl context with \"preserveDrawingBuffer\":true in order to read pixels from the drawing buffer'),s=Wn):(de(null!==e.next.colorAttachments[0].texture,\"You cannot read from a renderbuffer\"),s=e.next.colorAttachments[0].texture._texture.type,a.oes_texture_float?de(s===Wn||s===Jn,\"Reading from a framebuffer is only allowed for the types 'uint8' and 'float'\"):de(s===Wn,\"Reading from a framebuffer is only allowed for the type 'uint8'\"));var l=0,u=0,c=n.framebufferWidth,h=n.framebufferHeight,f=null;Qt(o)?f=o:o&&(de.type(o,\"object\",\"invalid arguments to regl.read()\"),l=0|o.x,u=0|o.y,de(l>=0&&l<n.framebufferWidth,\"invalid x offset for regl.read\"),de(u>=0&&u<n.framebufferHeight,\"invalid y offset for regl.read\"),c=0|(o.width||n.framebufferWidth-l),h=0|(o.height||n.framebufferHeight-u),f=o.data||null),f&&(s===Wn?de(f instanceof Uint8Array,\"buffer must be 'Uint8Array' when reading from a framebuffer of type 'uint8'\"):s===Jn&&de(f instanceof Float32Array,\"buffer must be 'Float32Array' when reading from a framebuffer of type 'float'\")),de(c>0&&c+l<=n.framebufferWidth,\"invalid width for read pixels\"),de(h>0&&h+u<=n.framebufferHeight,\"invalid height for read pixels\"),r();var d=c*h*4;return f||(s===Wn?f=new Uint8Array(d):s===Jn&&(f=f||new Float32Array(d))),de.isTypedArray(f,\"data buffer for regl.read() must be a typedarray\"),de(f.byteLength>=d,\"data buffer for regl.read() too small\"),t.pixelStorei(Zn,4),t.readPixels(l,u,c,h,Xn,s,f),f}function s(t){var r;return e.setFBO({framebuffer:t.framebuffer},function(){r=o(t)}),r}function l(t){return t&&\"framebuffer\"in t?s(t):o(t)}return l}function jt(t){return Array.prototype.slice.call(t)}function Nt(t){return jt(t).join(\"\")}function Bt(){function t(t){for(var e=0;e<l.length;++e)if(l[e]===t)return s[e];var r=\"g\"+o++;return s.push(r),l.push(t),r}function e(){function t(){r.push.apply(r,jt(arguments))}function e(){var t=\"v\"+o++;return n.push(t),arguments.length>0&&(r.push(t,\"=\"),r.push.apply(r,jt(arguments)),r.push(\";\")),t}var r=[],n=[];return $t(t,{def:e,toString:function(){return Nt([n.length>0?\"var \"+n+\";\":\"\",Nt(r)])}})}function r(){function t(t,e){\n",
       "n(t,e,\"=\",r.def(t,e),\";\")}var r=e(),n=e(),i=r.toString,a=n.toString;return $t(function(){r.apply(r,jt(arguments))},{def:r.def,entry:r,exit:n,save:t,set:function(e,n,i){t(e,n),r(e,n,\"=\",i,\";\")},toString:function(){return i()+a()}})}function n(){var t=Nt(arguments),e=r(),n=r(),i=e.toString,a=n.toString;return $t(e,{then:function(){return e.apply(e,jt(arguments)),this},else:function(){return n.apply(n,jt(arguments)),this},toString:function(){var e=a();return e&&(e=\"else{\"+e+\"}\"),Nt([\"if(\",t,\"){\",i(),\"}\",e])}})}function i(t,e){function n(){var t=\"a\"+i.length;return i.push(t),t}var i=[];e=e||0;for(var a=0;a<e;++a)n();var o=r(),s=o.toString;return c[t]=$t(o,{arg:n,toString:function(){return Nt([\"function(\",i.join(),\"){\",s(),\"}\"])}})}function a(){var t=['\"use strict\";',u,\"return {\"];Object.keys(c).forEach(function(e){t.push('\"',e,'\":',c[e].toString(),\",\")}),t.push(\"}\");var e=Nt(t).replace(/;/g,\";\\n\").replace(/}/g,\"}\\n\").replace(/{/g,\"{\\n\");return Function.apply(null,s.concat(e)).apply(null,l)}var o=0,s=[],l=[],u=e(),c={};return{global:u,link:t,block:e,proc:i,scope:r,cond:n,compile:a}}function Ut(t){return Array.isArray(t)||Qt(t)||Z(t)}function Vt(t){return t.sort(function(t,e){return t===Ii?-1:e===Ii?1:t<e?-1:1})}function Ht(t,e,r,n){this.thisDep=t,this.contextDep=e,this.propDep=r,this.append=n}function qt(t){return t&&!(t.thisDep||t.contextDep||t.propDep)}function Gt(t){return new Ht(!1,!1,!1,t)}function Yt(t,e){var r=t.type;if(r===ei){var n=t.data.length;return new Ht(!0,n>=1,n>=2,e)}if(r===ai){var i=t.data;return new Ht(i.thisDep,i.contextDep,i.propDep,e)}return new Ht(r===ii,r===ni,r===ri,e)}function Xt(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p){function m(t){return t.replace(\".\",\"_\")}function v(t,e,r){var n=m(t);et.push(t),tt[n]=$[n]=!!r,rt[n]=e}function g(t,e,r){var n=m(t);et.push(t),Array.isArray(r)?($[n]=r.slice(),tt[n]=r.slice()):$[n]=tt[n]=r,nt[n]=e}function y(){var t=Bt(),r=t.link,n=t.global;t.id=ot++,t.batchId=\"0\";var i=r(it),a=t.shared={props:\"a0\"};Object.keys(it).forEach(function(t){a[t]=n.def(i,\".\",t)}),de.optional(function(){t.CHECK=r(de),t.commandStr=de.guessCommand(),t.command=r(t.commandStr),t.assert=function(t,e,n){t(\"if(!(\",e,\"))\",this.CHECK,\".commandRaise(\",r(n),\",\",this.command,\");\")},at.invalidBlendCombinations=Ua});var o=t.next={},s=t.current={};Object.keys(nt).forEach(function(t){Array.isArray($[t])&&(o[t]=n.def(a.next,\".\",t),s[t]=n.def(a.current,\".\",t))});var l=t.constants={};Object.keys(at).forEach(function(t){l[t]=n.def(JSON.stringify(at[t]))}),t.invoke=function(e,n){switch(n.type){case ei:var i=[\"this\",a.context,a.props,t.batchId];return e.def(r(n.data),\".call(\",i.slice(0,Math.max(n.data.length+1,4)),\")\");case ri:return e.def(a.props,n.data);case ni:return e.def(a.context,n.data);case ii:return e.def(\"this\",n.data);case ai:return n.data.append(t,e),n.data.ref}},t.attribCache={};var c={};return t.scopeAttrib=function(t){var n=e.id(t);if(n in c)return c[n];var i=u.scope[n];return i||(i=u.scope[n]=new W),c[n]=r(i)},t}function b(t){var e,r=t.static,n=t.dynamic;if(Di in r){var i=!!r[Di];e=Gt(function(t,e){return i}),e.enable=i}else if(Di in n){var a=n[Di];e=Yt(a,function(t,e){return t.invoke(e,a)})}return e}function x(t,e){var r=t.static,n=t.dynamic;if(Pi in r){var i=r[Pi];return i?(i=s.getFramebuffer(i),de.command(i,\"invalid framebuffer object\"),Gt(function(t,e){var r=t.link(i),n=t.shared;e.set(n.framebuffer,\".next\",r);var a=n.context;return e.set(a,\".\"+Vi,r+\".width\"),e.set(a,\".\"+Hi,r+\".height\"),r})):Gt(function(t,e){var r=t.shared;e.set(r.framebuffer,\".next\",\"null\");var n=r.context;return e.set(n,\".\"+Vi,n+\".\"+Yi),e.set(n,\".\"+Hi,n+\".\"+Xi),\"null\"})}if(Pi in n){var a=n[Pi];return Yt(a,function(t,e){var r=t.invoke(e,a),n=t.shared,i=n.framebuffer,o=e.def(i,\".getFramebuffer(\",r,\")\");de.optional(function(){t.assert(e,\"!\"+r+\"||\"+o,\"invalid framebuffer object\")}),e.set(i,\".next\",o);var s=n.context;return e.set(s,\".\"+Vi,o+\"?\"+o+\".width:\"+s+\".\"+Yi),e.set(s,\".\"+Hi,o+\"?\"+o+\".height:\"+s+\".\"+Xi),o})}return null}function _(t,e,r){function n(t){if(t in i){var n=i[t];de.commandType(n,\"object\",\"invalid \"+t,r.commandStr);var o,s,l=!0,u=0|n.x,c=0|n.y;return\"width\"in n?(o=0|n.width,de.command(o>=0,\"invalid \"+t,r.commandStr)):l=!1,\"height\"in n?(s=0|n.height,de.command(s>=0,\"invalid \"+t,r.commandStr)):l=!1,new Ht(!l&&e&&e.thisDep,!l&&e&&e.contextDep,!l&&e&&e.propDep,function(t,e){var r=t.shared.context,i=o;\"width\"in n||(i=e.def(r,\".\",Vi,\"-\",u));var a=s;return\"height\"in n||(a=e.def(r,\".\",Hi,\"-\",c)),[u,c,i,a]})}if(t in a){var h=a[t],f=Yt(h,function(e,r){var n=e.invoke(r,h);de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)});var i=e.shared.context,a=r.def(n,\".x|0\"),o=r.def(n,\".y|0\"),s=r.def('\"width\" in ',n,\"?\",n,\".width|0:\",\"(\",i,\".\",Vi,\"-\",a,\")\"),l=r.def('\"height\" in ',n,\"?\",n,\".height|0:\",\"(\",i,\".\",Hi,\"-\",o,\")\");return de.optional(function(){e.assert(r,s+\">=0&&\"+l+\">=0\",\"invalid \"+t)}),[a,o,s,l]});return e&&(f.thisDep=f.thisDep||e.thisDep,f.contextDep=f.contextDep||e.contextDep,f.propDep=f.propDep||e.propDep),f}return e?new Ht(e.thisDep,e.contextDep,e.propDep,function(t,e){var r=t.shared.context;return[0,0,e.def(r,\".\",Vi),e.def(r,\".\",Hi)]}):null}var i=t.static,a=t.dynamic,o=n(Ii);if(o){var s=o;o=new Ht(o.thisDep,o.contextDep,o.propDep,function(t,e){var r=s.append(t,e),n=t.shared.context;return e.set(n,\".\"+qi,r[2]),e.set(n,\".\"+Gi,r[3]),r})}return{viewport:o,scissor_box:n(zi)}}function w(t){function r(t){if(t in i){var r=e.id(i[t]);de.optional(function(){c.shader(qa[t],r,de.guessCommand())});var n=Gt(function(){return r});return n.id=r,n}if(t in a){var o=a[t];return Yt(o,function(e,r){var n=e.invoke(r,o),i=r.def(e.shared.strings,\".id(\",n,\")\");return de.optional(function(){r(e.shared.shader,\".shader(\",qa[t],\",\",i,\",\",e.command,\");\")}),i})}return null}var n,i=t.static,a=t.dynamic,o=r(Ri),s=r(Oi),l=null;return qt(o)&&qt(s)?(l=c.program(s.id,o.id),n=Gt(function(t,e){return t.link(l)})):n=new Ht(o&&o.thisDep||s&&s.thisDep,o&&o.contextDep||s&&s.contextDep,o&&o.propDep||s&&s.propDep,function(t,e){var r,n=t.shared.shader;r=o?o.append(t,e):e.def(n,\".\",Ri);var i;i=s?s.append(t,e):e.def(n,\".\",Oi);var a=n+\".program(\"+i+\",\"+r;return de.optional(function(){a+=\",\"+t.command}),e.def(a+\")\")}),{frag:o,vert:s,progVar:n,program:l}}function M(t,e){function r(t,r){if(t in n){var a=0|n[t];return de.command(!r||a>=0,\"invalid \"+t,e.commandStr),Gt(function(t,e){return r&&(t.OFFSET=a),a})}if(t in i){var s=i[t];return Yt(s,function(e,n){var i=e.invoke(n,s);return r&&(e.OFFSET=i,de.optional(function(){e.assert(n,i+\">=0\",\"invalid \"+t)})),i})}return r&&o?Gt(function(t,e){return t.OFFSET=\"0\",0}):null}var n=t.static,i=t.dynamic,o=function(){if(Fi in n){var t=n[Fi];Ut(t)?t=a.getElements(a.create(t,!0)):t&&(t=a.getElements(t),de.command(t,\"invalid elements\",e.commandStr));var r=Gt(function(e,r){if(t){var n=e.link(t);return e.ELEMENTS=n,n}return e.ELEMENTS=null,null});return r.value=t,r}if(Fi in i){var o=i[Fi];return Yt(o,function(t,e){var r=t.shared,n=r.isBufferArgs,i=r.elements,a=t.invoke(e,o),s=e.def(\"null\"),l=e.def(n,\"(\",a,\")\"),u=t.cond(l).then(s,\"=\",i,\".createStream(\",a,\");\").else(s,\"=\",i,\".getElements(\",a,\");\");return de.optional(function(){t.assert(u.else,\"!\"+a+\"||\"+s,\"invalid elements\")}),e.entry(u),e.exit(t.cond(l).then(i,\".destroyStream(\",s,\");\")),t.ELEMENTS=s,s})}return null}(),s=r(Bi,!0);return{elements:o,primitive:function(){if(ji in n){var t=n[ji];return de.commandParameter(t,Be,\"invalid primitve\",e.commandStr),Gt(function(e,r){return Be[t]})}if(ji in i){var r=i[ji];return Yt(r,function(t,e){var n=t.constants.primTypes,i=t.invoke(e,r);return de.optional(function(){t.assert(e,i+\" in \"+n,\"invalid primitive, must be one of \"+Object.keys(Be))}),e.def(n,\"[\",i,\"]\")})}return o?qt(o)?Gt(o.value?function(t,e){return e.def(t.ELEMENTS,\".primType\")}:function(){return Aa}):new Ht(o.thisDep,o.contextDep,o.propDep,function(t,e){var r=t.ELEMENTS;return e.def(r,\"?\",r,\".primType:\",Aa)}):null}(),count:function(){if(Ni in n){var t=0|n[Ni];return de.command(\"number\"==typeof t&&t>=0,\"invalid vertex count\",e.commandStr),Gt(function(){return t})}if(Ni in i){var r=i[Ni];return Yt(r,function(t,e){var n=t.invoke(e,r);return de.optional(function(){t.assert(e,\"typeof \"+n+'===\"number\"&&'+n+\">=0&&\"+n+\"===(\"+n+\"|0)\",\"invalid vertex count\")}),n})}if(o){if(qt(o)){if(o)return s?new Ht(s.thisDep,s.contextDep,s.propDep,function(t,e){var r=e.def(t.ELEMENTS,\".vertCount-\",t.OFFSET);return de.optional(function(){t.assert(e,r+\">=0\",\"invalid vertex offset/element buffer too small\")}),r}):Gt(function(t,e){return e.def(t.ELEMENTS,\".vertCount\")});var a=Gt(function(){return-1});return de.optional(function(){a.MISSING=!0}),a}var l=new Ht(o.thisDep||s.thisDep,o.contextDep||s.contextDep,o.propDep||s.propDep,function(t,e){var r=t.ELEMENTS;return t.OFFSET?e.def(r,\"?\",r,\".vertCount-\",t.OFFSET,\":-1\"):e.def(r,\"?\",r,\".vertCount:-1\")});return de.optional(function(){l.DYNAMIC=!0}),l}return null}(),instances:r(Ui,!1),offset:s}}function k(t,e){var r=t.static,i=t.dynamic,a={};return et.forEach(function(t){function o(e,n){if(t in r){var o=e(r[t]);a[s]=Gt(function(){return o})}else if(t in i){var l=i[t];a[s]=Yt(l,function(t,e){return n(t,e,t.invoke(e,l))})}}var s=m(t);switch(t){case vi:case si:case oi:case Ai:case hi:case Ci:case xi:case wi:case Mi:case pi:return o(function(r){return de.commandType(r,\"boolean\",t,e.commandStr),r},function(e,r,n){return de.optional(function(){e.assert(r,\"typeof \"+n+'===\"boolean\"',\"invalid flag \"+t,e.commandStr)}),n});case fi:return o(function(r){return de.commandParameter(r,Va,\"invalid \"+t,e.commandStr),Va[r]},function(e,r,n){var i=e.constants.compareFuncs;return de.optional(function(){e.assert(r,n+\" in \"+i,\"invalid \"+t+\", must be one of \"+Object.keys(Va))}),r.def(i,\"[\",n,\"]\")});case di:return o(function(t){return de.command(mt(t)&&2===t.length&&\"number\"==typeof t[0]&&\"number\"==typeof t[1]&&t[0]<=t[1],\"depth range is 2d array\",e.commandStr),t},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===2&&typeof \"+r+'[0]===\"number\"&&typeof '+r+'[1]===\"number\"&&'+r+\"[0]<=\"+r+\"[1]\",\"depth range must be a 2d array\")}),[e.def(\"+\",r,\"[0]\"),e.def(\"+\",r,\"[1]\")]});case ci:return o(function(t){de.commandType(t,\"object\",\"blend.func\",e.commandStr);var r=\"srcRGB\"in t?t.srcRGB:t.src,n=\"srcAlpha\"in t?t.srcAlpha:t.src,i=\"dstRGB\"in t?t.dstRGB:t.dst,a=\"dstAlpha\"in t?t.dstAlpha:t.dst;return de.commandParameter(r,Ba,s+\".srcRGB\",e.commandStr),de.commandParameter(n,Ba,s+\".srcAlpha\",e.commandStr),de.commandParameter(i,Ba,s+\".dstRGB\",e.commandStr),de.commandParameter(a,Ba,s+\".dstAlpha\",e.commandStr),de.command(-1===Ua.indexOf(r+\", \"+i),\"unallowed blending combination (srcRGB, dstRGB) = (\"+r+\", \"+i+\")\",e.commandStr),[Ba[r],Ba[i],Ba[n],Ba[a]]},function(e,r,n){function i(i,o){var s=r.def('\"',i,o,'\" in ',n,\"?\",n,\".\",i,o,\":\",n,\".\",i);return de.optional(function(){e.assert(r,s+\" in \"+a,\"invalid \"+t+\".\"+i+o+\", must be one of \"+Object.keys(Ba))}),s}var a=e.constants.blendFuncs;de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid blend func, must be an object\")});var o=i(\"src\",\"RGB\"),s=i(\"dst\",\"RGB\");de.optional(function(){var t=e.constants.invalidBlendCombinations;e.assert(r,t+\".indexOf(\"+o+'+\", \"+'+s+\") === -1 \",\"unallowed blending combination for (srcRGB, dstRGB)\")});var l=r.def(a,\"[\",o,\"]\"),u=r.def(a,\"[\",i(\"src\",\"Alpha\"),\"]\");return[l,r.def(a,\"[\",s,\"]\"),u,r.def(a,\"[\",i(\"dst\",\"Alpha\"),\"]\")]});case ui:return o(function(r){return\"string\"==typeof r?(de.commandParameter(r,Z,\"invalid \"+t,e.commandStr),[Z[r],Z[r]]):\"object\"==typeof r?(de.commandParameter(r.rgb,Z,t+\".rgb\",e.commandStr),de.commandParameter(r.alpha,Z,t+\".alpha\",e.commandStr),[Z[r.rgb],Z[r.alpha]]):void de.commandRaise(\"invalid blend.equation\",e.commandStr)},function(e,r,n){var i=e.constants.blendEquations,a=r.def(),o=r.def(),s=e.cond(\"typeof \",n,'===\"string\"');return de.optional(function(){function r(t,r,n){e.assert(t,n+\" in \"+i,\"invalid \"+r+\", must be one of \"+Object.keys(Z))}r(s.then,t,n),e.assert(s.else,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t),r(s.else,t+\".rgb\",n+\".rgb\"),r(s.else,t+\".alpha\",n+\".alpha\")}),s.then(a,\"=\",o,\"=\",i,\"[\",n,\"];\"),s.else(a,\"=\",i,\"[\",n,\".rgb];\",o,\"=\",i,\"[\",n,\".alpha];\"),r(s),[a,o]});case li:return o(function(t){return de.command(mt(t)&&4===t.length,\"blend.color must be a 4d array\",e.commandStr),J(4,function(e){return+t[e]})},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===4\",\"blend.color must be a 4d array\")}),J(4,function(t){return e.def(\"+\",r,\"[\",t,\"]\")})});case Ti:return o(function(t){return de.commandType(t,\"number\",s,e.commandStr),0|t},function(t,e,r){return de.optional(function(){t.assert(e,\"typeof \"+r+'===\"number\"',\"invalid stencil.mask\")}),e.def(r,\"|0\")});case Si:return o(function(r){de.commandType(r,\"object\",s,e.commandStr);var n=r.cmp||\"keep\",i=r.ref||0,a=\"mask\"in r?r.mask:-1;return de.commandParameter(n,Va,t+\".cmp\",e.commandStr),de.commandType(i,\"number\",t+\".ref\",e.commandStr),de.commandType(a,\"number\",t+\".mask\",e.commandStr),[Va[n],i,a]},function(t,e,r){var n=t.constants.compareFuncs;return de.optional(function(){function i(){t.assert(e,Array.prototype.join.call(arguments,\"\"),\"invalid stencil.func\")}i(r+\"&&typeof \",r,'===\"object\"'),i('!(\"cmp\" in ',r,\")||(\",r,\".cmp in \",n,\")\")}),[e.def('\"cmp\" in ',r,\"?\",n,\"[\",r,\".cmp]\",\":\",Da),e.def(r,\".ref|0\"),e.def('\"mask\" in ',r,\"?\",r,\".mask|0:-1\")]});case Ei:case Li:return o(function(r){de.commandType(r,\"object\",s,e.commandStr);var n=r.fail||\"keep\",i=r.zfail||\"keep\",a=r.zpass||\"keep\";return de.commandParameter(n,Ha,t+\".fail\",e.commandStr),de.commandParameter(i,Ha,t+\".zfail\",e.commandStr),de.commandParameter(a,Ha,t+\".zpass\",e.commandStr),[t===Li?Sa:Ta,Ha[n],Ha[i],Ha[a]]},function(e,r,n){function i(i){return de.optional(function(){e.assert(r,'!(\"'+i+'\" in '+n+\")||(\"+n+\".\"+i+\" in \"+a+\")\",\"invalid \"+t+\".\"+i+\", must be one of \"+Object.keys(Ha))}),r.def('\"',i,'\" in ',n,\"?\",a,\"[\",n,\".\",i,\"]:\",Da)}var a=e.constants.stencilOps;return de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)}),[t===Li?Sa:Ta,i(\"fail\"),i(\"zfail\"),i(\"zpass\")]});case _i:return o(function(t){de.commandType(t,\"object\",s,e.commandStr);var r=0|t.factor,n=0|t.units;return de.commandType(r,\"number\",s+\".factor\",e.commandStr),de.commandType(n,\"number\",s+\".units\",e.commandStr),[r,n]},function(e,r,n){return de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)}),[r.def(n,\".factor|0\"),r.def(n,\".units|0\")]});case gi:return o(function(t){var r=0;return\"front\"===t?r=Ta:\"back\"===t&&(r=Sa),de.command(!!r,s,e.commandStr),r},function(t,e,r){return de.optional(function(){t.assert(e,r+'===\"front\"||'+r+'===\"back\"',\"invalid cull.face\")}),e.def(r,'===\"front\"?',Ta,\":\",Sa)});case bi:return o(function(t){return de.command(\"number\"==typeof t&&t>=n.lineWidthDims[0]&&t<=n.lineWidthDims[1],\"invalid line width, must positive number between \"+n.lineWidthDims[0]+\" and \"+n.lineWidthDims[1],e.commandStr),t},function(t,e,r){return de.optional(function(){t.assert(e,\"typeof \"+r+'===\"number\"&&'+r+\">=\"+n.lineWidthDims[0]+\"&&\"+r+\"<=\"+n.lineWidthDims[1],\"invalid line width\")}),r});case yi:return o(function(t){return de.commandParameter(t,Ga,s,e.commandStr),Ga[t]},function(t,e,r){return de.optional(function(){t.assert(e,r+'===\"cw\"||'+r+'===\"ccw\"',\"invalid frontFace, must be one of cw,ccw\")}),e.def(r+'===\"cw\"?'+Ea+\":\"+La)});case mi:return o(function(t){return de.command(mt(t)&&4===t.length,\"color.mask must be length 4 array\",e.commandStr),t.map(function(t){return!!t})},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===4\",\"invalid color.mask\")}),J(4,function(t){return\"!!\"+r+\"[\"+t+\"]\"})});case ki:return o(function(t){de.command(\"object\"==typeof t&&t,s,e.commandStr);var r=\"value\"in t?t.value:1,n=!!t.invert;return de.command(\"number\"==typeof r&&r>=0&&r<=1,\"sample.coverage.value must be a number between 0 and 1\",e.commandStr),[r,n]},function(t,e,r){return de.optional(function(){t.assert(e,r+\"&&typeof \"+r+'===\"object\"',\"invalid sample.coverage\")}),[e.def('\"value\" in ',r,\"?+\",r,\".value:1\"),e.def(\"!!\",r,\".invert\")]})}}),a}function A(t,e){var r=t.static,n=t.dynamic,i={};return Object.keys(r).forEach(function(t){var n,a=r[t];if(\"number\"==typeof a||\"boolean\"==typeof a)n=Gt(function(){return a});else if(\"function\"==typeof a){var o=a._reglType;\"texture2d\"===o||\"textureCube\"===o?n=Gt(function(t){return t.link(a)}):\"framebuffer\"===o||\"framebufferCube\"===o?(de.command(a.color.length>0,'missing color attachment for framebuffer sent to uniform \"'+t+'\"',e.commandStr),n=Gt(function(t){return t.link(a.color[0])})):de.commandRaise('invalid data for uniform \"'+t+'\"',e.commandStr)}else mt(a)?n=Gt(function(e){return e.global.def(\"[\",J(a.length,function(r){return de.command(\"number\"==typeof a[r]||\"boolean\"==typeof a[r],\"invalid uniform \"+t,e.commandStr),a[r]}),\"]\")}):de.commandRaise('invalid or missing data for uniform \"'+t+'\"',e.commandStr);n.value=a,i[t]=n}),Object.keys(n).forEach(function(t){var e=n[t];i[t]=Yt(e,function(t,r){return t.invoke(r,e)})}),i}function T(t,r){var n=t.static,a=t.dynamic,o={};return Object.keys(n).forEach(function(t){var a=n[t],s=e.id(t),l=new W;if(Ut(a))l.state=$n,l.buffer=i.getBuffer(i.create(a,Zi,!1,!0)),l.type=0;else{var u=i.getBuffer(a);if(u)l.state=$n,l.buffer=u,l.type=0;else if(de.command(\"object\"==typeof a&&a,\"invalid data for attribute \"+t,r.commandStr),a.constant){var c=a.constant;l.buffer=\"null\",l.state=ti,\"number\"==typeof c?l.x=c:(de.command(mt(c)&&c.length>0&&c.length<=4,\"invalid constant for attribute \"+t,r.commandStr),Kn.forEach(function(t,e){e<c.length&&(l[t]=c[e])}))}else{u=Ut(a.buffer)?i.getBuffer(i.create(a.buffer,Zi,!1,!0)):i.getBuffer(a.buffer),de.command(!!u,'missing buffer for attribute \"'+t+'\"',r.commandStr);var h=0|a.offset;de.command(h>=0,'invalid offset for attribute \"'+t+'\"',r.commandStr);var f=0|a.stride;de.command(f>=0&&f<256,'invalid stride for attribute \"'+t+'\", must be integer betweeen [0, 255]',r.commandStr);var d=0|a.size;de.command(!(\"size\"in a)||d>0&&d<=4,'invalid size for attribute \"'+t+'\", must be 1,2,3,4',r.commandStr);var p=!!a.normalized,m=0;\"type\"in a&&(de.commandParameter(a.type,ze,\"invalid type for attribute \"+t,r.commandStr),m=ze[a.type]);var v=0|a.divisor;\"divisor\"in a&&(de.command(0===v||K,'cannot specify divisor for attribute \"'+t+'\", instancing not supported',r.commandStr),de.command(v>=0,'invalid divisor for attribute \"'+t+'\"',r.commandStr)),de.optional(function(){var e=r.commandStr,n=[\"buffer\",\"offset\",\"divisor\",\"normalized\",\"type\",\"size\",\"stride\"];Object.keys(a).forEach(function(r){de.command(n.indexOf(r)>=0,'unknown parameter \"'+r+'\" for attribute pointer \"'+t+'\" (valid parameters are '+n+\")\",e)})}),l.buffer=u,l.state=$n,l.size=d,l.normalized=p,l.type=m||u.dtype,l.offset=h,l.stride=f,l.divisor=v}}o[t]=Gt(function(t,e){var r=t.attribCache;if(s in r)return r[s];var n={isStream:!1};return Object.keys(l).forEach(function(t){n[t]=l[t]}),l.buffer&&(n.buffer=t.link(l.buffer),n.type=n.type||n.buffer+\".dtype\"),r[s]=n,n})}),Object.keys(a).forEach(function(t){function e(e,n){function i(t){n(u[t],\"=\",a,\".\",t,\"|0;\")}var a=e.invoke(n,r),o=e.shared,s=o.isBufferArgs,l=o.buffer;de.optional(function(){e.assert(n,a+\"&&(typeof \"+a+'===\"object\"||typeof '+a+'===\"function\")&&('+s+\"(\"+a+\")||\"+l+\".getBuffer(\"+a+\")||\"+l+\".getBuffer(\"+a+\".buffer)||\"+s+\"(\"+a+'.buffer)||(\"constant\" in '+a+\"&&(typeof \"+a+'.constant===\"number\"||'+o.isArrayLike+\"(\"+a+\".constant))))\",'invalid dynamic attribute \"'+t+'\"')});var u={isStream:n.def(!1)},c=new W;c.state=$n,Object.keys(c).forEach(function(t){u[t]=n.def(\"\"+c[t])});var h=u.buffer,f=u.type;return n(\"if(\",s,\"(\",a,\")){\",u.isStream,\"=true;\",h,\"=\",l,\".createStream(\",Zi,\",\",a,\");\",f,\"=\",h,\".dtype;\",\"}else{\",h,\"=\",l,\".getBuffer(\",a,\");\",\"if(\",h,\"){\",f,\"=\",h,\".dtype;\",'}else if(\"constant\" in ',a,\"){\",u.state,\"=\",ti,\";\",\"if(typeof \"+a+'.constant === \"number\"){',u[Kn[0]],\"=\",a,\".constant;\",Kn.slice(1).map(function(t){return u[t]}).join(\"=\"),\"=0;\",\"}else{\",Kn.map(function(t,e){return u[t]+\"=\"+a+\".constant.length>=\"+e+\"?\"+a+\".constant[\"+e+\"]:0;\"}).join(\"\"),\"}}else{\",\"if(\",s,\"(\",a,\".buffer)){\",h,\"=\",l,\".createStream(\",Zi,\",\",a,\".buffer);\",\"}else{\",h,\"=\",l,\".getBuffer(\",a,\".buffer);\",\"}\",f,'=\"type\" in ',a,\"?\",o.glTypes,\"[\",a,\".type]:\",h,\".dtype;\",u.normalized,\"=!!\",a,\".normalized;\"),i(\"size\"),i(\"offset\"),i(\"stride\"),i(\"divisor\"),n(\"}}\"),n.exit(\"if(\",u.isStream,\"){\",l,\".destroyStream(\",h,\");\",\"}\"),u}var r=a[t];o[t]=Yt(r,e)}),o}function S(t){var e=t.static,r=t.dynamic,n={};return Object.keys(e).forEach(function(t){var r=e[t];n[t]=Gt(function(t,e){return\"number\"==typeof r||\"boolean\"==typeof r?\"\"+r:t.link(r)})}),Object.keys(r).forEach(function(t){var e=r[t];n[t]=Yt(e,function(t,r){return t.invoke(r,e)})}),n}function E(t,e,r,n,i){function a(t){var e=u[t];e&&(h[t]=e)}var o=t.static,s=t.dynamic;de.optional(function(){function t(t){Object.keys(t).forEach(function(t){de.command(e.indexOf(t)>=0,'unknown parameter \"'+t+'\"',i.commandStr)})}var e=[Pi,Oi,Ri,Fi,ji,Bi,Ni,Ui,Di].concat(et);t(o),t(s)});var l=x(t,i),u=_(t,l,i),c=M(t,i),h=k(t,i),f=w(t,i);a(Ii),a(m(zi));var d=Object.keys(h).length>0,p={framebuffer:l,draw:c,shader:f,state:h,dirty:d};return p.profile=b(t,i),p.uniforms=A(r,i),p.attributes=T(e,i),p.context=S(n,i),p}function L(t,e,r){var n=t.shared,i=n.context,a=t.scope();Object.keys(r).forEach(function(n){e.save(i,\".\"+n);var o=r[n];a(i,\".\",n,\"=\",o.append(t,e),\";\")}),e(a)}function C(t,e,r,n){var i,a=t.shared,o=a.gl,s=a.framebuffer;Q&&(i=e.def(a.extensions,\".webgl_draw_buffers\"));var l,u=t.constants,c=u.drawBuffer,h=u.backBuffer;l=r?r.append(t,e):e.def(s,\".next\"),n||e(\"if(\",l,\"!==\",s,\".cur){\"),e(\"if(\",l,\"){\",o,\".bindFramebuffer(\",ja,\",\",l,\".framebuffer);\"),Q&&e(i,\".drawBuffersWEBGL(\",c,\"[\",l,\".colorAttachments.length]);\"),e(\"}else{\",o,\".bindFramebuffer(\",ja,\",null);\"),Q&&e(i,\".drawBuffersWEBGL(\",h,\");\"),e(\"}\",s,\".cur=\",l,\";\"),n||e(\"}\")}function z(t,e,r){var n=t.shared,i=n.gl,a=t.current,o=t.next,s=n.current,l=n.next,u=t.cond(s,\".dirty\");et.forEach(function(e){var n=m(e);if(!(n in r.state)){var c,h;if(n in o){c=o[n],h=a[n];var f=J($[n].length,function(t){return u.def(c,\"[\",t,\"]\")});u(t.cond(f.map(function(t,e){return t+\"!==\"+h+\"[\"+e+\"]\"}).join(\"||\")).then(i,\".\",nt[n],\"(\",f,\");\",f.map(function(t,e){return h+\"[\"+e+\"]=\"+t}).join(\";\"),\";\"))}else{c=u.def(l,\".\",n);var d=t.cond(c,\"!==\",s,\".\",n);u(d),n in rt?d(t.cond(c).then(i,\".enable(\",rt[n],\");\").else(i,\".disable(\",rt[n],\");\"),s,\".\",n,\"=\",c,\";\"):d(i,\".\",nt[n],\"(\",c,\");\",s,\".\",n,\"=\",c,\";\")}}}),0===Object.keys(r.state).length&&u(s,\".dirty=false;\"),e(u)}function I(t,e,r,n){var i=t.shared,a=t.current,o=i.current,s=i.gl;Vt(Object.keys(r)).forEach(function(i){var l=r[i];if(!n||n(l)){var u=l.append(t,e);if(rt[i]){var c=rt[i];qt(l)?u?e(s,\".enable(\",c,\");\"):e(s,\".disable(\",c,\");\"):e(t.cond(u).then(s,\".enable(\",c,\");\").else(s,\".disable(\",c,\");\")),e(o,\".\",i,\"=\",u,\";\")}else if(mt(u)){var h=a[i];e(s,\".\",nt[i],\"(\",u,\");\",u.map(function(t,e){return h+\"[\"+e+\"]=\"+t}).join(\";\"),\";\")}else e(s,\".\",nt[i],\"(\",u,\");\",o,\".\",i,\"=\",u,\";\")}})}function D(t,e){K&&(t.instancing=e.def(t.shared.extensions,\".angle_instanced_arrays\"))}function P(t,e,r,n,i){function a(){return\"undefined\"==typeof performance?\"Date.now()\":\"performance.now()\"}function o(t){u=e.def(),t(u,\"=\",a(),\";\"),\"string\"==typeof i?t(p,\".count+=\",i,\";\"):t(p,\".count++;\"),d&&(n?(c=e.def(),t(c,\"=\",v,\".getNumPendingQueries();\")):t(v,\".beginQuery(\",p,\");\"))}function s(t){t(p,\".cpuTime+=\",a(),\"-\",u,\";\"),d&&(n?t(v,\".pushScopeStats(\",c,\",\",v,\".getNumPendingQueries(),\",p,\");\"):t(v,\".endQuery();\"))}function l(t){var r=e.def(m,\".profile\");e(m,\".profile=\",t,\";\"),e.exit(m,\".profile=\",r,\";\")}var u,c,h,f=t.shared,p=t.stats,m=f.current,v=f.timer,g=r.profile;if(g){if(qt(g))return void(g.enable?(o(e),s(e.exit),l(\"true\")):l(\"false\"));h=g.append(t,e),l(h)}else h=e.def(m,\".profile\");var y=t.block();o(y),e(\"if(\",h,\"){\",y,\"}\");var b=t.block();s(b),e.exit(\"if(\",h,\"){\",b,\"}\")}function O(t,e,r,n,i){function a(t){switch(t){case ua:case da:case ga:return 2;case ca:case pa:case ya:return 3;case ha:case ma:case ba:return 4;default:return 1}}function o(r,n,i){function a(){e(\"if(!\",c,\".buffer){\",l,\".enableVertexAttribArray(\",u,\");}\");var r,a=i.type;if(r=i.size?e.def(i.size,\"||\",n):n,e(\"if(\",c,\".type!==\",a,\"||\",c,\".size!==\",r,\"||\",p.map(function(t){return c+\".\"+t+\"!==\"+i[t]}).join(\"||\"),\"){\",l,\".bindBuffer(\",Zi,\",\",f,\".buffer);\",l,\".vertexAttribPointer(\",[u,r,a,i.normalized,i.stride,i.offset],\");\",c,\".type=\",a,\";\",c,\".size=\",r,\";\",p.map(function(t){return c+\".\"+t+\"=\"+i[t]+\";\"}).join(\"\"),\"}\"),K){var o=i.divisor;e(\"if(\",c,\".divisor!==\",o,\"){\",t.instancing,\".vertexAttribDivisorANGLE(\",[u,o],\");\",c,\".divisor=\",o,\";}\")}}function o(){e(\"if(\",c,\".buffer){\",l,\".disableVertexAttribArray(\",u,\");\",\"}if(\",Kn.map(function(t,e){return c+\".\"+t+\"!==\"+d[e]}).join(\"||\"),\"){\",l,\".vertexAttrib4f(\",u,\",\",d,\");\",Kn.map(function(t,e){return c+\".\"+t+\"=\"+d[e]+\";\"}).join(\"\"),\"}\")}var l=s.gl,u=e.def(r,\".location\"),c=e.def(s.attributes,\"[\",u,\"]\"),h=i.state,f=i.buffer,d=[i.x,i.y,i.z,i.w],p=[\"buffer\",\"normalized\",\"offset\",\"stride\"];h===$n?a():h===ti?o():(e(\"if(\",h,\"===\",$n,\"){\"),a(),e(\"}else{\"),o(),e(\"}\"))}var s=t.shared;n.forEach(function(n){var s,l=n.name,u=r.attributes[l];if(u){if(!i(u))return;s=u.append(t,e)}else{if(!i(Ya))return;var c=t.scopeAttrib(l);de.optional(function(){t.assert(e,c+\".state\",\"missing attribute \"+l)}),s={},Object.keys(new W).forEach(function(t){s[t]=e.def(c,\".\",t)})}o(t.link(n),a(n.info.type),s)})}function R(t,r,n,i,a){for(var o,s=t.shared,l=s.gl,u=0;u<i.length;++u){var c,h=i[u],f=h.name,d=h.info.type,p=n.uniforms[f],m=t.link(h),v=m+\".location\";if(p){if(!a(p))continue;if(qt(p)){var g=p.value;if(de.command(null!==g&&void 0!==g,'missing uniform \"'+f+'\"',t.commandStr),d===Ma||d===ka){de.command(\"function\"==typeof g&&(d===Ma&&(\"texture2d\"===g._reglType||\"framebuffer\"===g._reglType)||d===ka&&(\"textureCube\"===g._reglType||\"framebufferCube\"===g._reglType)),\"invalid texture for uniform \"+f,t.commandStr);var y=t.link(g._texture||g.color[0]._texture);r(l,\".uniform1i(\",v,\",\",y+\".bind());\"),r.exit(y,\".unbind();\")}else if(d===xa||d===_a||d===wa){de.optional(function(){de.command(mt(g),\"invalid matrix for uniform \"+f,t.commandStr),de.command(d===xa&&4===g.length||d===_a&&9===g.length||d===wa&&16===g.length,\"invalid length for matrix uniform \"+f,t.commandStr)});var b=t.global.def(\"new Float32Array([\"+Array.prototype.slice.call(g)+\"])\"),x=2;d===_a?x=3:d===wa&&(x=4),r(l,\".uniformMatrix\",x,\"fv(\",v,\",false,\",b,\");\")}else{switch(d){case la:de.commandType(g,\"number\",\"uniform \"+f,t.commandStr),o=\"1f\";break;case ua:de.command(mt(g)&&2===g.length,\"uniform \"+f,t.commandStr),o=\"2f\";break;case ca:de.command(mt(g)&&3===g.length,\"uniform \"+f,t.commandStr),o=\"3f\";break;case ha:de.command(mt(g)&&4===g.length,\"uniform \"+f,t.commandStr),o=\"4f\";break;case va:de.commandType(g,\"boolean\",\"uniform \"+f,t.commandStr),o=\"1i\";break;case fa:de.commandType(g,\"number\",\"uniform \"+f,t.commandStr),o=\"1i\";break;case ga:case da:de.command(mt(g)&&2===g.length,\"uniform \"+f,t.commandStr),o=\"2i\";break;case ya:case pa:de.command(mt(g)&&3===g.length,\"uniform \"+f,t.commandStr),o=\"3i\";break;case ba:case ma:de.command(mt(g)&&4===g.length,\"uniform \"+f,t.commandStr),o=\"4i\"}r(l,\".uniform\",o,\"(\",v,\",\",mt(g)?Array.prototype.slice.call(g):g,\");\")}continue}c=p.append(t,r)}else{if(!a(Ya))continue;c=r.def(s.uniforms,\"[\",e.id(f),\"]\")}d===Ma?r(\"if(\",c,\"&&\",c,'._reglType===\"framebuffer\"){',c,\"=\",c,\".color[0];\",\"}\"):d===ka&&r(\"if(\",c,\"&&\",c,'._reglType===\"framebufferCube\"){',c,\"=\",c,\".color[0];\",\"}\"),de.optional(function(){function e(e,n){t.assert(r,e,'bad data or missing for uniform \"'+f+'\".  '+n)}function n(t){e(\"typeof \"+c+'===\"'+t+'\"',\"invalid type, expected \"+t)}function i(r,n){e(s.isArrayLike+\"(\"+c+\")&&\"+c+\".length===\"+r,\"invalid vector, should have length \"+r,t.commandStr)}function a(r){e(\"typeof \"+c+'===\"function\"&&'+c+'._reglType===\"texture'+(r===Ki?\"2d\":\"Cube\")+'\"',\"invalid texture type\",t.commandStr)}switch(d){case fa:n(\"number\");break;case da:i(2,\"number\");break;case pa:i(3,\"number\");break;case ma:i(4,\"number\");break;case la:n(\"number\");break;case ua:i(2,\"number\");break;case ca:i(3,\"number\");break;case ha:i(4,\"number\");break;case va:n(\"boolean\");break;case ga:i(2,\"boolean\");break;case ya:i(3,\"boolean\");break;case ba:i(4,\"boolean\");break;case xa:i(4,\"number\");break;case _a:i(9,\"number\");break;case wa:i(16,\"number\");break;case Ma:a(Ki);break;case ka:a(Qi)}});var _=1;switch(d){case Ma:case ka:var w=r.def(c,\"._texture\");r(l,\".uniform1i(\",v,\",\",w,\".bind());\"),r.exit(w,\".unbind();\");continue;case fa:case va:o=\"1i\";break;case da:case ga:o=\"2i\",_=2;break;case pa:case ya:o=\"3i\",_=3;break;case ma:case ba:o=\"4i\",_=4;break;case la:o=\"1f\";break;case ua:o=\"2f\",_=2;break;case ca:o=\"3f\",_=3;break;case ha:o=\"4f\",_=4;break;case xa:o=\"Matrix2fv\";break;case _a:o=\"Matrix3fv\";break;case wa:o=\"Matrix4fv\"}if(r(l,\".uniform\",o,\"(\",v,\",\"),\"M\"===o.charAt(0)){var M=Math.pow(d-xa+2,2),k=t.global.def(\"new Float32Array(\",M,\")\");r(\"false,(Array.isArray(\",c,\")||\",c,\" instanceof Float32Array)?\",c,\":(\",J(M,function(t){return k+\"[\"+t+\"]=\"+c+\"[\"+t+\"]\"}),\",\",k,\")\")}else r(_>1?J(_,function(t){return c+\"[\"+t+\"]\"}):c);r(\");\")}}function F(t,e,r,n){function i(i){var a=c[i];return a?a.contextDep&&n.contextDynamic||a.propDep?a.append(t,r):a.append(t,e):e.def(u,\".\",i)}function a(){function t(){r(v,\".drawElementsInstancedANGLE(\",[f,p,g,d+\"<<((\"+g+\"-\"+Qn+\")>>1)\",m],\");\")}function e(){r(v,\".drawArraysInstancedANGLE(\",[f,d,p,m],\");\")}h?y?t():(r(\"if(\",h,\"){\"),t(),r(\"}else{\"),e(),r(\"}\")):e()}function o(){function t(){r(l+\".drawElements(\"+[f,p,g,d+\"<<((\"+g+\"-\"+Qn+\")>>1)\"]+\");\")}function e(){r(l+\".drawArrays(\"+[f,d,p]+\");\")}h?y?t():(r(\"if(\",h,\"){\"),t(),r(\"}else{\"),e(),r(\"}\")):e()}var s=t.shared,l=s.gl,u=s.draw,c=n.draw,h=function(){var i,a=c.elements,o=e;return a?((a.contextDep&&n.contextDynamic||a.propDep)&&(o=r),i=a.append(t,o)):i=o.def(u,\".\",Fi),i&&o(\"if(\"+i+\")\"+l+\".bindBuffer(\"+Ji+\",\"+i+\".buffer.buffer);\"),i}(),f=i(ji),d=i(Bi),p=function(){var i,a=c.count,o=e;return a?((a.contextDep&&n.contextDynamic||a.propDep)&&(o=r),i=a.append(t,o),de.optional(function(){a.MISSING&&t.assert(e,\"false\",\"missing vertex count\"),a.DYNAMIC&&t.assert(o,i+\">=0\",\"missing vertex count\")})):(i=o.def(u,\".\",Ni),de.optional(function(){t.assert(o,i+\">=0\",\"missing vertex count\")})),i}();if(\"number\"==typeof p){if(0===p)return}else r(\"if(\",p,\"){\"),r.exit(\"}\");var m,v;K&&(m=i(Ui),v=t.instancing);var g=h+\".type\",y=c.elements&&qt(c.elements);K&&(\"number\"!=typeof m||m>=0)?\"string\"==typeof m?(r(\"if(\",m,\">0){\"),a(),r(\"}else if(\",m,\"<0){\"),o(),r(\"}\")):a():o()}function j(t,e,r,n,i){var a=y(),o=a.proc(\"body\",i);return de.optional(function(){a.commandStr=e.commandStr,a.command=a.link(e.commandStr)}),K&&(a.instancing=o.def(a.shared.extensions,\".angle_instanced_arrays\")),t(a,o,r,n),a.compile().body}function N(t,e,r,n){D(t,e),O(t,e,r,n.attributes,function(){return!0}),R(t,e,r,n.uniforms,function(){return!0}),F(t,e,e,r)}function B(t,e){var r=t.proc(\"draw\",1);D(t,r),L(t,r,e.context),C(t,r,e.framebuffer),z(t,r,e),I(t,r,e.state),P(t,r,e,!1,!0);var n=e.shader.progVar.append(t,r);if(r(t.shared.gl,\".useProgram(\",n,\".program);\"),e.shader.program)N(t,r,e,e.shader.program);else{var i=t.global.def(\"{}\"),a=r.def(n,\".id\"),o=r.def(i,\"[\",a,\"]\");r(t.cond(o).then(o,\".call(this,a0);\").else(o,\"=\",i,\"[\",a,\"]=\",t.link(function(r){return j(N,t,e,r,1)}),\"(\",n,\");\",o,\".call(this,a0);\"))}Object.keys(e.state).length>0&&r(t.shared.current,\".dirty=true;\")}function U(t,e,r,n){function i(){return!0}t.batchId=\"a1\",D(t,e),O(t,e,r,n.attributes,i),R(t,e,r,n.uniforms,i),F(t,e,e,r)}function V(t,e,r,n){function i(t){return t.contextDep&&o||t.propDep}function a(t){return!i(t)}D(t,e);var o=r.contextDep,s=e.def(),l=e.def();t.shared.props=l,t.batchId=s;var u=t.scope(),c=t.scope();if(e(u.entry,\"for(\",s,\"=0;\",s,\"<\",\"a1\",\";++\",s,\"){\",l,\"=\",\"a0\",\"[\",s,\"];\",c,\"}\",u.exit),r.needsContext&&L(t,c,r.context),r.needsFramebuffer&&C(t,c,r.framebuffer),I(t,c,r.state,i),\n",
       "r.profile&&i(r.profile)&&P(t,c,r,!1,!0),n)O(t,u,r,n.attributes,a),O(t,c,r,n.attributes,i),R(t,u,r,n.uniforms,a),R(t,c,r,n.uniforms,i),F(t,u,c,r);else{var h=t.global.def(\"{}\"),f=r.shader.progVar.append(t,c),d=c.def(f,\".id\"),p=c.def(h,\"[\",d,\"]\");c(t.shared.gl,\".useProgram(\",f,\".program);\",\"if(!\",p,\"){\",p,\"=\",h,\"[\",d,\"]=\",t.link(function(e){return j(U,t,r,e,2)}),\"(\",f,\");}\",p,\".call(this,a0[\",s,\"],\",s,\");\")}}function H(t,e){function r(t){return t.contextDep&&i||t.propDep}var n=t.proc(\"batch\",2);t.batchId=\"0\",D(t,n);var i=!1,a=!0;Object.keys(e.context).forEach(function(t){i=i||e.context[t].propDep}),i||(L(t,n,e.context),a=!1);var o=e.framebuffer,s=!1;o?(o.propDep?i=s=!0:o.contextDep&&i&&(s=!0),s||C(t,n,o)):C(t,n,null),e.state.viewport&&e.state.viewport.propDep&&(i=!0),z(t,n,e),I(t,n,e.state,function(t){return!r(t)}),e.profile&&r(e.profile)||P(t,n,e,!1,\"a1\"),e.contextDep=i,e.needsContext=a,e.needsFramebuffer=s;var l=e.shader.progVar;if(l.contextDep&&i||l.propDep)V(t,n,e,null);else{var u=l.append(t,n);if(n(t.shared.gl,\".useProgram(\",u,\".program);\"),e.shader.program)V(t,n,e,e.shader.program);else{var c=t.global.def(\"{}\"),h=n.def(u,\".id\"),f=n.def(c,\"[\",h,\"]\");n(t.cond(f).then(f,\".call(this,a0,a1);\").else(f,\"=\",c,\"[\",h,\"]=\",t.link(function(r){return j(V,t,e,r,2)}),\"(\",u,\");\",f,\".call(this,a0,a1);\"))}}Object.keys(e.state).length>0&&n(t.shared.current,\".dirty=true;\")}function q(t,r){function n(e){var n=r.shader[e];n&&i.set(a.shader,\".\"+e,n.append(t,i))}var i=t.proc(\"scope\",3);t.batchId=\"a2\";var a=t.shared,o=a.current;L(t,i,r.context),r.framebuffer&&r.framebuffer.append(t,i),Vt(Object.keys(r.state)).forEach(function(e){var n=r.state[e],o=n.append(t,i);mt(o)?o.forEach(function(r,n){i.set(t.next[e],\"[\"+n+\"]\",r)}):i.set(a.next,\".\"+e,o)}),P(t,i,r,!0,!0),[Fi,Bi,Ni,Ui,ji].forEach(function(e){var n=r.draw[e];n&&i.set(a.draw,\".\"+e,\"\"+n.append(t,i))}),Object.keys(r.uniforms).forEach(function(n){i.set(a.uniforms,\"[\"+e.id(n)+\"]\",r.uniforms[n].append(t,i))}),Object.keys(r.attributes).forEach(function(e){var n=r.attributes[e].append(t,i),a=t.scopeAttrib(e);Object.keys(new W).forEach(function(t){i.set(a,\".\"+t,n[t])})}),n(Oi),n(Ri),Object.keys(r.state).length>0&&(i(o,\".dirty=true;\"),i.exit(o,\".dirty=true;\")),i(\"a1(\",t.shared.context,\",a0,\",t.batchId,\");\")}function G(t){if(\"object\"==typeof t&&!mt(t)){for(var e=Object.keys(t),r=0;r<e.length;++r)if(ve.isDynamic(t[e[r]]))return!0;return!1}}function Y(t,e,r){function n(t,e){o.forEach(function(r){var n=i[r];if(ve.isDynamic(n)){var a=t.invoke(e,n);e(c,\".\",r,\"=\",a,\";\")}})}var i=e.static[r];if(i&&G(i)){var a=t.global,o=Object.keys(i),s=!1,l=!1,u=!1,c=t.global.def(\"{}\");o.forEach(function(e){var r=i[e];if(ve.isDynamic(r)){\"function\"==typeof r&&(r=i[e]=ve.unbox(r));var n=Yt(r,null);s=s||n.thisDep,u=u||n.propDep,l=l||n.contextDep}else{switch(a(c,\".\",e,\"=\"),typeof r){case\"number\":a(r);break;case\"string\":a('\"',r,'\"');break;case\"object\":Array.isArray(r)&&a(\"[\",r.join(),\"]\");break;default:a(t.link(r))}a(\";\")}}),e.dynamic[r]=new ve.DynamicVariable(ai,{thisDep:s,contextDep:l,propDep:u,ref:c,append:n}),delete e.static[r]}}function X(t,e,r,n,i){var a=y();a.stats=a.link(i),Object.keys(e.static).forEach(function(t){Y(a,e,t)}),Wi.forEach(function(e){Y(a,t,e)});var o=E(t,e,r,n,a);return B(a,o),q(a,o),H(a,o),a.compile()}var W=u.Record,Z={add:32774,subtract:32778,\"reverse subtract\":32779};r.ext_blend_minmax&&(Z.min=Ca,Z.max=za);var K=r.angle_instanced_arrays,Q=r.webgl_draw_buffers,$={dirty:!0,profile:p.profile},tt={},et=[],rt={},nt={};v(oi,ea),v(si,ta),g(li,\"blendColor\",[0,0,0,0]),g(ui,\"blendEquationSeparate\",[Ra,Ra]),g(ci,\"blendFuncSeparate\",[Oa,Pa,Oa,Pa]),v(hi,na,!0),g(fi,\"depthFunc\",Fa),g(di,\"depthRange\",[0,1]),g(pi,\"depthMask\",!0),g(mi,mi,[!0,!0,!0,!0]),v(vi,$i),g(gi,\"cullFace\",Sa),g(yi,yi,La),g(bi,bi,1),v(xi,aa),g(_i,\"polygonOffset\",[0,0]),v(wi,oa),v(Mi,sa),g(ki,\"sampleCoverage\",[1,!1]),v(Ai,ra),g(Ti,\"stencilMask\",-1),g(Si,\"stencilFunc\",[Ia,0,-1]),g(Ei,\"stencilOpSeparate\",[Ta,Da,Da,Da]),g(Li,\"stencilOpSeparate\",[Sa,Da,Da,Da]),v(Ci,ia),g(zi,\"scissor\",[0,0,t.drawingBufferWidth,t.drawingBufferHeight]),g(Ii,Ii,[0,0,t.drawingBufferWidth,t.drawingBufferHeight]);var it={gl:t,context:f,strings:e,next:tt,current:$,draw:h,elements:a,buffer:i,shader:c,attributes:u.state,uniforms:l,framebuffer:s,extensions:r,timer:d,isBufferArgs:Ut},at={primTypes:Be,compareFuncs:Va,blendFuncs:Ba,blendEquations:Z,stencilOps:Ha,glTypes:ze,orientationType:Ga};de.optional(function(){it.isArrayLike=mt}),Q&&(at.backBuffer=[Sa],at.drawBuffer=J(n.maxDrawbuffers,function(t){return 0===t?[0]:J(t,function(t){return Na+t})}));var ot=0;return{next:tt,current:$,procs:function(){var e=y(),r=e.proc(\"poll\"),i=e.proc(\"refresh\"),a=e.block();r(a),i(a);var o=e.shared,s=o.gl,l=o.next,u=o.current;a(u,\".dirty=false;\"),C(e,r),C(e,i,null,!0);var c,h=t.getExtension(\"angle_instanced_arrays\");h&&(c=e.link(h));for(var f=0;f<n.maxAttributes;++f){var d=i.def(o.attributes,\"[\",f,\"]\"),p=e.cond(d,\".buffer\");p.then(s,\".enableVertexAttribArray(\",f,\");\",s,\".bindBuffer(\",Zi,\",\",d,\".buffer.buffer);\",s,\".vertexAttribPointer(\",f,\",\",d,\".size,\",d,\".type,\",d,\".normalized,\",d,\".stride,\",d,\".offset);\").else(s,\".disableVertexAttribArray(\",f,\");\",s,\".vertexAttrib4f(\",f,\",\",d,\".x,\",d,\".y,\",d,\".z,\",d,\".w);\",d,\".buffer=null;\"),i(p),h&&i(c,\".vertexAttribDivisorANGLE(\",f,\",\",d,\".divisor);\")}return Object.keys(rt).forEach(function(t){var n=rt[t],o=a.def(l,\".\",t),c=e.block();c(\"if(\",o,\"){\",s,\".enable(\",n,\")}else{\",s,\".disable(\",n,\")}\",u,\".\",t,\"=\",o,\";\"),i(c),r(\"if(\",o,\"!==\",u,\".\",t,\"){\",c,\"}\")}),Object.keys(nt).forEach(function(t){var n,o,c=nt[t],h=$[t],f=e.block();if(f(s,\".\",c,\"(\"),mt(h)){var d=h.length;n=e.global.def(l,\".\",t),o=e.global.def(u,\".\",t),f(J(d,function(t){return n+\"[\"+t+\"]\"}),\");\",J(d,function(t){return o+\"[\"+t+\"]=\"+n+\"[\"+t+\"];\"}).join(\"\")),r(\"if(\",J(d,function(t){return n+\"[\"+t+\"]!==\"+o+\"[\"+t+\"]\"}).join(\"||\"),\"){\",f,\"}\")}else n=a.def(l,\".\",t),o=a.def(u,\".\",t),f(n,\");\",u,\".\",t,\"=\",n,\";\"),r(\"if(\",n,\"!==\",o,\"){\",f,\"}\");i(f)}),e.compile()}(),compile:X}}function Wt(){return{bufferCount:0,elementsCount:0,framebufferCount:0,shaderCount:0,textureCount:0,cubeCount:0,renderbufferCount:0,maxTextureUnits:0}}function Zt(t,e){for(var r=0;r<t.length;++r)if(t[r]===e)return r;return-1}function Jt(t){function e(){if(0===q.length)return k&&k.update(),void(J=null);J=ge.next(e),f();for(var t=q.length-1;t>=0;--t){var r=q[t];r&&r(E,null,0)}g.flush(),k&&k.update()}function r(){!J&&q.length>0&&(J=ge.next(e))}function n(){J&&(ge.cancel(e),J=null)}function i(t){t.preventDefault(),b=!0,n(),G.forEach(function(t){t()})}function a(t){g.getError(),b=!1,x.restore(),O.restore(),I.restore(),R.restore(),F.restore(),j.restore(),k&&k.restore(),N.procs.refresh(),r(),Y.forEach(function(t){t()})}function o(){q.length=0,n(),H&&(H.removeEventListener(eo,i),H.removeEventListener(ro,a)),O.clear(),j.clear(),F.clear(),R.clear(),D.clear(),I.clear(),k&&k.clear(),Z.forEach(function(t){t()})}function s(t){function e(t){var e={},r={};return Object.keys(t).forEach(function(n){var i=t[n];ve.isDynamic(i)?r[n]=ve.unbox(i,n):e[n]=i}),{dynamic:r,static:e}}function r(t){for(;d.length<t;)d.push(null);return d}function n(t,e){var n;if(b&&de.raise(\"context lost\"),\"function\"==typeof t)return f.call(this,null,t,0);if(\"function\"==typeof e){if(\"number\"==typeof t){for(n=0;n<t;++n)f.call(this,null,e,n);return}if(Array.isArray(t)){for(n=0;n<t.length;++n)f.call(this,t[n],e,n);return}return f.call(this,t,e,0)}if(\"number\"==typeof t){if(t>0)return h.call(this,r(0|t),0|t)}else{if(!Array.isArray(t))return c.call(this,t);if(t.length)return h.call(this,t,t.length)}}de(!!t,\"invalid args to regl({...})\"),de.type(t,\"object\",\"invalid args to regl({...})\");var i=e(t.context||{}),a=e(t.uniforms||{}),o=e(t.attributes||{}),s=e(function(t){function e(t){if(t in r){var e=r[t];delete r[t],Object.keys(e).forEach(function(n){r[t+\".\"+n]=e[n]})}}var r=$t({},t);return delete r.uniforms,delete r.attributes,delete r.context,\"stencil\"in r&&r.stencil.op&&(r.stencil.opBack=r.stencil.opFront=r.stencil.op,delete r.stencil.op),e(\"blend\"),e(\"depth\"),e(\"cull\"),e(\"stencil\"),e(\"polygonOffset\"),e(\"scissor\"),e(\"sample\"),r}(t)),l={gpuTime:0,cpuTime:0,count:0},u=N.compile(s,o,a,i,l),c=u.draw,h=u.batch,f=u.scope,d=[];return $t(n,{stats:l})}function l(t,e){var r=0;N.procs.poll();var n=e.color;n&&(g.clearColor(+n[0]||0,+n[1]||0,+n[2]||0,+n[3]||0),r|=Ka),\"depth\"in e&&(g.clearDepth(+e.depth),r|=Qa),\"stencil\"in e&&(g.clearStencil(0|e.stencil),r|=$a),de(!!r,\"called regl.clear with no buffer specified\"),g.clear(r)}function u(t){if(de(\"object\"==typeof t&&t,\"regl.clear() takes an object as input\"),\"framebuffer\"in t)if(t.framebuffer&&\"framebufferCube\"===t.framebuffer_reglType)for(var e=0;e<6;++e)K($t({framebuffer:t.framebuffer.faces[e]},t),l);else K(t,l);else l(null,t)}function c(t){function e(){function e(){var t=Zt(q,e);q[t]=q[q.length-1],q.length-=1,q.length<=0&&n()}var r=Zt(q,t);de(r>=0,\"cannot cancel a frame twice\"),q[r]=e}return de.type(t,\"function\",\"regl.frame() callback must be a function\"),q.push(t),r(),{cancel:e}}function h(){var t=V.viewport,e=V.scissor_box;t[0]=t[1]=e[0]=e[1]=0,E.viewportWidth=E.framebufferWidth=E.drawingBufferWidth=t[2]=e[2]=g.drawingBufferWidth,E.viewportHeight=E.framebufferHeight=E.drawingBufferHeight=t[3]=e[3]=g.drawingBufferHeight}function f(){E.tick+=1,E.time=p(),h(),N.procs.poll()}function d(){h(),N.procs.refresh(),k&&k.update()}function p(){return(ye()-A)/1e3}function m(t,e){de.type(e,\"function\",\"listener callback must be a function\");var r;switch(t){case\"frame\":return c(e);case\"lost\":r=G;break;case\"restore\":r=Y;break;case\"destroy\":r=Z;break;default:de.raise(\"invalid event, must be one of frame,lost,restore,destroy\")}return r.push(e),{cancel:function(){for(var t=0;t<r.length;++t)if(r[t]===e)return r[t]=r[r.length-1],void r.pop()}}}var v=X(t);if(!v)return null;var g=v.gl,y=g.getContextAttributes(),b=g.isContextLost(),x=W(g,v);if(!x)return null;var _=B(),w=Wt(),M=x.extensions,k=Ja(g,M),A=ye(),T=g.drawingBufferWidth,S=g.drawingBufferHeight,E={tick:0,time:0,viewportWidth:T,viewportHeight:S,framebufferWidth:T,framebufferHeight:S,drawingBufferWidth:T,drawingBufferHeight:S,pixelRatio:v.pixelRatio},L={},C={elements:null,primitive:4,count:-1,offset:0,instances:-1},z=be(g,M),I=ft(g,w,v),D=dt(g,M,I,w),P=Ot(g,M,z,I,_),O=Rt(g,_,w,v),R=zt(g,M,z,function(){N.procs.poll()},E,w,v),F=Mn(g,M,z,w,v),j=Dt(g,M,z,R,F,w),N=Xt(g,_,M,z,I,D,R,j,L,P,O,C,E,k,v),U=Ft(g,j,N.procs.poll,E,y,M),V=N.next,H=g.canvas,q=[],G=[],Y=[],Z=[v.onDestroy],J=null;H&&(H.addEventListener(eo,i,!1),H.addEventListener(ro,a,!1));var K=j.setFBO=s({framebuffer:ve.define.call(null,no,\"framebuffer\")});d();var Q=$t(s,{clear:u,prop:ve.define.bind(null,no),context:ve.define.bind(null,io),this:ve.define.bind(null,ao),draw:s({}),buffer:function(t){return I.create(t,to,!1,!1)},elements:function(t){return D.create(t,!1)},texture:R.create2D,cube:R.createCube,renderbuffer:F.create,framebuffer:j.create,framebufferCube:j.createCube,attributes:y,frame:c,on:m,limits:z,hasExtension:function(t){return z.extensions.indexOf(t.toLowerCase())>=0},read:U,destroy:o,_gl:g,_refresh:d,poll:function(){f(),k&&k.update()},now:p,stats:w});return v.onDone(null,Q),Q}var Kt={\"[object Int8Array]\":5120,\"[object Int16Array]\":5122,\"[object Int32Array]\":5124,\"[object Uint8Array]\":5121,\"[object Uint8ClampedArray]\":5121,\"[object Uint16Array]\":5123,\"[object Uint32Array]\":5125,\"[object Float32Array]\":5126,\"[object Float64Array]\":5121,\"[object ArrayBuffer]\":5121},Qt=function(t){return Object.prototype.toString.call(t)in Kt},$t=function(t,e){for(var r=Object.keys(e),n=0;n<r.length;++n)t[r[n]]=e[r[n]];return t},te=[\"gl\",\"canvas\",\"container\",\"attributes\",\"pixelRatio\",\"extensions\",\"optionalExtensions\",\"profile\",\"onDone\"],ee=33071,re=9728,ne=9984,ie=9985,ae=9986,oe=9987,se=5126,le=32819,ue=32820,ce=33635,he=34042,fe={};fe[5120]=fe[5121]=1,fe[5122]=fe[5123]=fe[36193]=fe[ce]=fe[le]=fe[ue]=2,fe[5124]=fe[5125]=fe[se]=fe[he]=4;var de=$t(r,{optional:S,raise:e,commandRaise:M,command:k,parameter:i,commandParameter:A,constructor:u,type:o,commandType:T,isTypedArray:a,nni:s,oneOf:l,shaderError:b,linkError:x,callSite:m,saveCommandRef:_,saveDrawInfo:w,framebufferFormat:E,guessCommand:p,texture2D:z,textureCube:I}),pe=0,me=0,ve={DynamicVariable:D,define:F,isDynamic:j,unbox:N,accessor:R},ge={next:\"function\"==typeof requestAnimationFrame?function(t){return requestAnimationFrame(t)}:function(t){return setTimeout(t,16)},cancel:\"function\"==typeof cancelAnimationFrame?function(t){return cancelAnimationFrame(t)}:clearTimeout},ye=\"undefined\"!=typeof performance&&performance.now?function(){return performance.now()}:function(){return+new Date},be=function(t,e){var r=1;e.ext_texture_filter_anisotropic&&(r=t.getParameter(34047));var n=1,i=1;return e.webgl_draw_buffers&&(n=t.getParameter(34852),i=t.getParameter(36063)),{colorBits:[t.getParameter(3410),t.getParameter(3411),t.getParameter(3412),t.getParameter(3413)],depthBits:t.getParameter(3414),stencilBits:t.getParameter(3415),subpixelBits:t.getParameter(3408),extensions:Object.keys(e).filter(function(t){return!!e[t]}),maxAnisotropic:r,maxDrawbuffers:n,maxColorAttachments:i,pointSizeDims:t.getParameter(33901),lineWidthDims:t.getParameter(33902),maxViewportDims:t.getParameter(3386),maxCombinedTextureUnits:t.getParameter(35661),maxCubeMapSize:t.getParameter(34076),maxRenderbufferSize:t.getParameter(34024),maxTextureUnits:t.getParameter(34930),maxTextureSize:t.getParameter(3379),maxAttributes:t.getParameter(34921),maxVertexUniforms:t.getParameter(36347),maxVertexTextureUnits:t.getParameter(35660),maxVaryingVectors:t.getParameter(36348),maxFragmentUniforms:t.getParameter(36349),glsl:t.getParameter(35724),renderer:t.getParameter(7937),vendor:t.getParameter(7936),version:t.getParameter(7938)}},xe=function(t){return Object.keys(t).map(function(e){return t[e]})},_e=5120,we=5121,Me=5122,ke=5123,Ae=5124,Te=5125,Se=5126,Ee=J(8,function(){return[]}),Le={alloc:$,free:tt,allocType:et,freeType:rt},Ce={shape:lt,flatten:st},ze={int8:5120,int16:5122,int32:5124,uint8:5121,uint16:5123,uint32:5125,float:5126,float32:5126},Ie={dynamic:35048,stream:35040,static:35044},De=Ce.flatten,Pe=Ce.shape,Oe=35044,Re=35040,Fe=5121,je=5126,Ne=[];Ne[5120]=1,Ne[5122]=2,Ne[5124]=4,Ne[5121]=1,Ne[5123]=2,Ne[5125]=4,Ne[5126]=4;var Be={points:0,point:0,lines:1,line:1,triangles:4,triangle:4,\"line loop\":2,\"line strip\":3,\"triangle strip\":5,\"triangle fan\":6},Ue=0,Ve=1,He=4,qe=5120,Ge=5121,Ye=5122,Xe=5123,We=5124,Ze=5125,Je=34963,Ke=35040,Qe=35044,$e=new Float32Array(1),tr=new Uint32Array($e.buffer),er=5123,rr=34467,nr=3553,ir=34067,ar=34069,or=6408,sr=6406,lr=6407,ur=6409,cr=6410,hr=32854,fr=32855,dr=36194,pr=32819,mr=32820,vr=33635,gr=34042,yr=6402,br=34041,xr=35904,_r=35906,wr=36193,Mr=33776,kr=33777,Ar=33778,Tr=33779,Sr=35986,Er=35987,Lr=34798,Cr=35840,zr=35841,Ir=35842,Dr=35843,Pr=36196,Or=5121,Rr=5123,Fr=5125,jr=5126,Nr=10242,Br=10243,Ur=10497,Vr=33071,Hr=33648,qr=10240,Gr=10241,Yr=9728,Xr=9729,Wr=9984,Zr=9985,Jr=9986,Kr=9987,Qr=33170,$r=4352,tn=4353,en=4354,rn=34046,nn=3317,an=37440,on=37441,sn=37443,ln=37444,un=33984,cn=[Wr,Jr,Zr,Kr],hn=[0,ur,cr,lr,or],fn={};fn[ur]=fn[sr]=fn[yr]=1,fn[br]=fn[cr]=2,fn[lr]=fn[xr]=3,fn[or]=fn[_r]=4;var dn=vt(\"HTMLCanvasElement\"),pn=vt(\"CanvasRenderingContext2D\"),mn=vt(\"HTMLImageElement\"),vn=vt(\"HTMLVideoElement\"),gn=Object.keys(Kt).concat([dn,pn,mn,vn]),yn=[];yn[Or]=1,yn[jr]=4,yn[wr]=2,yn[Rr]=2,yn[Fr]=4;var bn=[];bn[hr]=2,bn[fr]=2,bn[dr]=2,bn[br]=4,bn[Mr]=.5,bn[kr]=.5,bn[Ar]=1,bn[Tr]=1,bn[Sr]=.5,bn[Er]=1,bn[Lr]=1,bn[Cr]=.5,bn[zr]=.25,bn[Ir]=.5,bn[Dr]=.25,bn[Pr]=.5;var xn=36161,_n=32854,wn=[];wn[_n]=2,wn[32855]=2,wn[36194]=2,wn[33189]=2,wn[36168]=1,wn[34041]=4,wn[35907]=4,wn[34836]=16,wn[34842]=8,wn[34843]=6;var Mn=function(t,e,r,n,i){function a(t){this.id=h++,this.refCount=1,this.renderbuffer=t,this.format=_n,this.width=0,this.height=0,i.profile&&(this.stats={size:0})}function o(e){var r=e.renderbuffer;de(r,\"must not double destroy renderbuffer\"),t.bindRenderbuffer(xn,null),t.deleteRenderbuffer(r),e.renderbuffer=null,e.refCount=0,delete f[e.id],n.renderbufferCount--}function s(e,o){function s(e,n){var a=0,o=0,l=_n;if(\"object\"==typeof e&&e){var f=e;if(\"shape\"in f){var d=f.shape;de(Array.isArray(d)&&d.length>=2,\"invalid renderbuffer shape\"),a=0|d[0],o=0|d[1]}else\"radius\"in f&&(a=o=0|f.radius),\"width\"in f&&(a=0|f.width),\"height\"in f&&(o=0|f.height);\"format\"in f&&(de.parameter(f.format,u,\"invalid renderbuffer format\"),l=u[f.format])}else\"number\"==typeof e?(a=0|e,o=\"number\"==typeof n?0|n:a):e?de.raise(\"invalid arguments to renderbuffer constructor\"):a=o=1;if(de(a>0&&o>0&&a<=r.maxRenderbufferSize&&o<=r.maxRenderbufferSize,\"invalid renderbuffer size\"),a!==h.width||o!==h.height||l!==h.format)return s.width=h.width=a,s.height=h.height=o,h.format=l,t.bindRenderbuffer(xn,h.renderbuffer),t.renderbufferStorage(xn,l,a,o),i.profile&&(h.stats.size=It(h.format,h.width,h.height)),s.format=c[h.format],s}function l(e,n){var a=0|e,o=0|n||a;return a===h.width&&o===h.height?s:(de(a>0&&o>0&&a<=r.maxRenderbufferSize&&o<=r.maxRenderbufferSize,\"invalid renderbuffer size\"),s.width=h.width=a,s.height=h.height=o,t.bindRenderbuffer(xn,h.renderbuffer),t.renderbufferStorage(xn,h.format,a,o),i.profile&&(h.stats.size=It(h.format,h.width,h.height)),s)}var h=new a(t.createRenderbuffer());return f[h.id]=h,n.renderbufferCount++,s(e,o),s.resize=l,s._reglType=\"renderbuffer\",s._renderbuffer=h,i.profile&&(s.stats=h.stats),s.destroy=function(){h.decRef()},s}function l(){xe(f).forEach(function(e){e.renderbuffer=t.createRenderbuffer(),t.bindRenderbuffer(xn,e.renderbuffer),t.renderbufferStorage(xn,e.format,e.width,e.height)}),t.bindRenderbuffer(xn,null)}var u={rgba4:_n,rgb565:36194,\"rgb5 a1\":32855,depth:33189,stencil:36168,\"depth stencil\":34041};e.ext_srgb&&(u.srgba=35907),e.ext_color_buffer_half_float&&(u.rgba16f=34842,u.rgb16f=34843),e.webgl_color_buffer_float&&(u.rgba32f=34836);var c=[];Object.keys(u).forEach(function(t){var e=u[t];c[e]=t});var h=0,f={};return a.prototype.decRef=function(){--this.refCount<=0&&o(this)},i.profile&&(n.getTotalRenderbufferSize=function(){var t=0;return Object.keys(f).forEach(function(e){t+=f[e].stats.size}),t}),{create:s,clear:function(){xe(f).forEach(o)},restore:l}},kn=36160,An=36161,Tn=3553,Sn=34069,En=36064,Ln=36096,Cn=36128,zn=33306,In=36053,Dn=6402,Pn=[6408],On=[];On[6408]=4;var Rn=[];Rn[5121]=1,Rn[5126]=4,Rn[36193]=2;var Fn=33189,jn=36168,Nn=34041,Bn=[32854,32855,36194,35907,34842,34843,34836],Un={};Un[In]=\"complete\",Un[36054]=\"incomplete attachment\",Un[36057]=\"incomplete dimensions\",Un[36055]=\"incomplete, missing attachment\",Un[36061]=\"unsupported\";var Vn=5126,Hn=35632,qn=35633,Gn=35718,Yn=35721,Xn=6408,Wn=5121,Zn=3333,Jn=5126,Kn=\"xyzw\".split(\"\"),Qn=5121,$n=1,ti=2,ei=0,ri=1,ni=2,ii=3,ai=4,oi=\"dither\",si=\"blend.enable\",li=\"blend.color\",ui=\"blend.equation\",ci=\"blend.func\",hi=\"depth.enable\",fi=\"depth.func\",di=\"depth.range\",pi=\"depth.mask\",mi=\"colorMask\",vi=\"cull.enable\",gi=\"cull.face\",yi=\"frontFace\",bi=\"lineWidth\",xi=\"polygonOffset.enable\",_i=\"polygonOffset.offset\",wi=\"sample.alpha\",Mi=\"sample.enable\",ki=\"sample.coverage\",Ai=\"stencil.enable\",Ti=\"stencil.mask\",Si=\"stencil.func\",Ei=\"stencil.opFront\",Li=\"stencil.opBack\",Ci=\"scissor.enable\",zi=\"scissor.box\",Ii=\"viewport\",Di=\"profile\",Pi=\"framebuffer\",Oi=\"vert\",Ri=\"frag\",Fi=\"elements\",ji=\"primitive\",Ni=\"count\",Bi=\"offset\",Ui=\"instances\",Vi=Pi+\"Width\",Hi=Pi+\"Height\",qi=Ii+\"Width\",Gi=Ii+\"Height\",Yi=\"drawingBufferWidth\",Xi=\"drawingBufferHeight\",Wi=[ci,ui,Si,Ei,Li,ki,Ii,zi,_i],Zi=34962,Ji=34963,Ki=3553,Qi=34067,$i=2884,ta=3042,ea=3024,ra=2960,na=2929,ia=3089,aa=32823,oa=32926,sa=32928,la=5126,ua=35664,ca=35665,ha=35666,fa=5124,da=35667,pa=35668,ma=35669,va=35670,ga=35671,ya=35672,ba=35673,xa=35674,_a=35675,wa=35676,Ma=35678,ka=35680,Aa=4,Ta=1028,Sa=1029,Ea=2304,La=2305,Ca=32775,za=32776,Ia=519,Da=7680,Pa=0,Oa=1,Ra=32774,Fa=513,ja=36160,Na=36064,Ba={0:0,1:1,zero:0,one:1,\"src color\":768,\"one minus src color\":769,\"src alpha\":770,\"one minus src alpha\":771,\"dst color\":774,\"one minus dst color\":775,\"dst alpha\":772,\"one minus dst alpha\":773,\"constant color\":32769,\"one minus constant color\":32770,\"constant alpha\":32771,\"one minus constant alpha\":32772,\"src alpha saturate\":776},Ua=[\"constant color, constant alpha\",\"one minus constant color, constant alpha\",\"constant color, one minus constant alpha\",\"one minus constant color, one minus constant alpha\",\"constant alpha, constant color\",\"constant alpha, one minus constant color\",\"one minus constant alpha, constant color\",\"one minus constant alpha, one minus constant color\"],Va={never:512,less:513,\"<\":513,equal:514,\"=\":514,\"==\":514,\"===\":514,lequal:515,\"<=\":515,greater:516,\">\":516,notequal:517,\"!=\":517,\"!==\":517,gequal:518,\">=\":518,always:519},Ha={0:0,zero:0,keep:7680,replace:7681,increment:7682,decrement:7683,\"increment wrap\":34055,\"decrement wrap\":34056,invert:5386},qa={frag:35632,vert:35633},Ga={cw:Ea,ccw:La},Ya=new Ht(!1,!1,!1,function(){}),Xa=34918,Wa=34919,Za=35007,Ja=function(t,e){function r(){return f.pop()||h.createQueryEXT()}function n(t){f.push(t)}function i(t){var e=r();h.beginQueryEXT(Za,e),d.push(e),u(d.length-1,d.length,t)}function a(){h.endQueryEXT(Za)}function o(){this.startQueryIndex=-1,this.endQueryIndex=-1,this.sum=0,this.stats=null}function s(){return p.pop()||new o}function l(t){p.push(t)}function u(t,e,r){var n=s();n.startQueryIndex=t,n.endQueryIndex=e,n.sum=0,n.stats=r,m.push(n)}function c(){var t,e,r=d.length;if(0!==r){g.length=Math.max(g.length,r+1),v.length=Math.max(v.length,r+1),v[0]=0,g[0]=0;var i=0;for(t=0,e=0;e<d.length;++e){var a=d[e];h.getQueryObjectEXT(a,Wa)?(i+=h.getQueryObjectEXT(a,Xa),n(a)):d[t++]=a,v[e+1]=i,g[e+1]=t}for(d.length=t,t=0,e=0;e<m.length;++e){var o=m[e],s=o.startQueryIndex,u=o.endQueryIndex;o.sum+=v[u]-v[s];var c=g[s],f=g[u];f===c?(o.stats.gpuTime+=o.sum/1e6,l(o)):(o.startQueryIndex=c,o.endQueryIndex=f,m[t++]=o)}m.length=t}}var h=e.ext_disjoint_timer_query;if(!h)return null;var f=[],d=[],p=[],m=[],v=[],g=[];return{beginQuery:i,endQuery:a,pushScopeStats:u,update:c,getNumPendingQueries:function(){return d.length},clear:function(){f.push.apply(f,d);for(var t=0;t<f.length;t++)h.deleteQueryEXT(f[t]);d.length=0,f.length=0},restore:function(){d.length=0,f.length=0}}},Ka=16384,Qa=256,$a=1024,to=34962,eo=\"webglcontextlost\",ro=\"webglcontextrestored\",no=1,io=2,ao=3;return Jt})},{}],499:[function(t,e,r){\"use strict\";function n(t,e){if(\"string\"!=typeof t)throw new TypeError(\"expected a string\");if(1===e)return t;if(2===e)return t+t;var r=t.length*e;if(i!==t||void 0===i)i=t,a=\"\";else if(a.length>=r)return a.substr(0,r);for(;r>a.length&&e>1;)1&e&&(a+=t),e>>=1,t+=t;return a+=t,a=a.substr(0,r)}var i,a=\"\";e.exports=n},{}],500:[function(e,r,n){!function(e,i){\"function\"==typeof t&&t.amd?t(i):\"object\"==typeof n?r.exports=i():e.resolveUrl=i()}(this,function(){function t(){var t=arguments.length;if(0===t)throw new Error(\"resolveUrl requires at least one argument; got none.\");var e=document.createElement(\"base\");if(e.href=arguments[0],1===t)return e.href;var r=document.getElementsByTagName(\"head\")[0];r.insertBefore(e,r.firstChild);for(var n,i=document.createElement(\"a\"),a=1;a<t;a++)i.href=arguments[a],n=i.href,e.href=n;return r.removeChild(e),n}return t})},{}],501:[function(t,e,r){(function(t){e.exports=t.performance&&t.performance.now?function(){return performance.now()}:Date.now||function(){return+new Date}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{}],502:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=t[t.length-1],n=e,i=e-2;i>=0;--i){var a=r,o=t[i];r=a+o;var s=r-a,l=o-s;l&&(t[--n]=r,r=l)}for(var u=0,i=n;i<e;++i){var a=t[i],o=r;r=a+o;var s=r-a,l=o-s;l&&(t[u++]=l)}return t[u++]=r,t.length=u,t}e.exports=n},{}],503:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m[\",r,\"][\",n,\"]\"].join(\"\")}return e}function a(t){return 1&t?\"-\":\"\"}function o(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",o(t.slice(0,e)),\",\",o(t.slice(e)),\")\"].join(\"\")}function s(t){if(2===t.length)return[\"sum(prod(\",t[0][0],\",\",t[1][1],\"),prod(-\",t[0][1],\",\",t[1][0],\"))\"].join(\"\");for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",s(n(t,r)),\",\",a(r),t[0][r],\")\"].join(\"\"));return o(e)}function l(t){return new Function(\"sum\",\"scale\",\"prod\",\"compress\",[\"function robustDeterminant\",t,\"(m){return compress(\",s(i(t)),\")};return robustDeterminant\",t].join(\"\"))(c,h,u,f)}var u=t(\"two-product\"),c=t(\"robust-sum\"),h=t(\"robust-scale\"),f=t(\"robust-compress\"),d=6,p=[function(){return[0]},function(t){return[t[0][0]]}];!function(){for(;p.length<d;)p.push(l(p.length));for(var t=[],r=[\"function robustDeterminant(m){switch(m.length){\"],n=0;n<d;++n)t.push(\"det\"+n),r.push(\"case \",n,\":return det\",n,\"(m);\");r.push(\"}var det=CACHE[m.length];if(!det)det=CACHE[m.length]=gen(m.length);return det(m);}return robustDeterminant\"),t.push(\"CACHE\",\"gen\",r.join(\"\"));var i=Function.apply(void 0,t);e.exports=i.apply(void 0,p.concat([p,l]));for(var n=0;n<p.length;++n)e.exports[n]=p[n]}()},{\"robust-compress\":502,\"robust-scale\":509,\"robust-sum\":512,\"two-product\":538}],504:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(t[0],e[0]),n=1;n<t.length;++n)r=a(r,i(t[n],e[n]));return r}var i=t(\"two-product\"),a=t(\"robust-sum\");e.exports=n},{\"robust-sum\":512,\"two-product\":538}],505:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m\",n,\"[\",t-r-2,\"]\"].join(\"\")}return e}function a(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",a(t.slice(0,e)),\",\",a(t.slice(e)),\")\"].join(\"\")}function o(t,e){if(\"m\"===t.charAt(0)){if(\"w\"===e.charAt(0)){var r=t.split(\"[\");return[\"w\",e.substr(1),\"m\",r[0].substr(1)].join(\"\")}return[\"prod(\",t,\",\",e,\")\"].join(\"\")}return o(e,t)}function s(t){return!0&t?\"-\":\"\"}function l(t){if(2===t.length)return[[\"diff(\",o(t[0][0],t[1][1]),\",\",o(t[1][0],t[0][1]),\")\"].join(\"\")];for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",a(l(n(t,r))),\",\",s(r),t[0][r],\")\"].join(\"\"));return e}function u(t,e){for(var r=[],n=0;n<e-2;++n)r.push([\"prod(m\",t,\"[\",n,\"],m\",t,\"[\",n,\"])\"].join(\"\"));return a(r)}function c(t){for(var e=[],r=[],o=i(t),s=0;s<t;++s)o[0][s]=\"1\",o[t-1][s]=\"w\"+s;for(var s=0;s<t;++s)0==(1&s)?e.push.apply(e,l(n(o,s))):r.push.apply(r,l(n(o,s)));for(var c=a(e),h=a(r),f=\"exactInSphere\"+t,d=[],s=0;s<t;++s)d.push(\"m\"+s);for(var p=[\"function \",f,\"(\",d.join(),\"){\"],s=0;s<t;++s){p.push(\"var w\",s,\"=\",u(s,t),\";\");for(var b=0;b<t;++b)b!==s&&p.push(\"var w\",s,\"m\",b,\"=scale(w\",s,\",m\",b,\"[0]);\")}return p.push(\"var p=\",c,\",n=\",h,\",d=diff(p,n);return d[d.length-1];}return \",f),new Function(\"sum\",\"diff\",\"prod\",\"scale\",p.join(\"\"))(v,g,m,y)}function h(){return 0}function f(){return 0}function d(){return 0}function p(t){var e=x[t.length];return e||(e=x[t.length]=c(t.length)),e.apply(void 0,t)}var m=t(\"two-product\"),v=t(\"robust-sum\"),g=t(\"robust-subtract\"),y=t(\"robust-scale\"),b=6,x=[h,f,d];!function(){for(;x.length<=b;)x.push(c(x.length));for(var t=[],r=[\"slow\"],n=0;n<=b;++n)t.push(\"a\"+n),r.push(\"o\"+n);for(var i=[\"function testInSphere(\",t.join(),\"){switch(arguments.length){case 0:case 1:return 0;\"],n=2;n<=b;++n)i.push(\"case \",n,\":return o\",n,\"(\",t.slice(0,n).join(),\");\");i.push(\"}var s=new Array(arguments.length);for(var i=0;i<arguments.length;++i){s[i]=arguments[i]};return slow(s);}return testInSphere\"),r.push(i.join(\"\"));var a=Function.apply(void 0,r);e.exports=a.apply(void 0,[p].concat(x));for(var n=0;n<=b;++n)e.exports[n]=x[n]}()},{\"robust-scale\":509,\"robust-subtract\":511,\"robust-sum\":512,\"two-product\":538}],506:[function(t,e,r){\"use strict\";function n(t){for(var e=\"robustLinearSolve\"+t+\"d\",r=[\"function \",e,\"(A,b){return [\"],n=0;n<t;++n){r.push(\"det([\");for(var i=0;i<t;++i){i>0&&r.push(\",\"),r.push(\"[\");for(var a=0;a<t;++a)a>0&&r.push(\",\"),a===n?r.push(\"+b[\",i,\"]\"):r.push(\"+A[\",i,\"][\",a,\"]\");r.push(\"]\")}r.push(\"]),\")}r.push(\"det(A)]}return \",e);var s=new Function(\"det\",r.join(\"\"));return s(t<6?o[t]:o)}function i(){return[0]}function a(t,e){return[[e[0]],[t[0][0]]]}var o=t(\"robust-determinant\"),s=6,l=[i,a];!function(){for(;l.length<s;)l.push(n(l.length));for(var t=[],r=[\"function dispatchLinearSolve(A,b){switch(A.length){\"],i=0;i<s;++i)t.push(\"s\"+i),r.push(\"case \",i,\":return s\",i,\"(A,b);\");r.push(\"}var s=CACHE[A.length];if(!s)s=CACHE[A.length]=g(A.length);return s(A,b)}return dispatchLinearSolve\"),t.push(\"CACHE\",\"g\",r.join(\"\"));var a=Function.apply(void 0,t);e.exports=a.apply(void 0,l.concat([l,n]));for(var i=0;i<s;++i)e.exports[i]=l[i]}()},{\"robust-determinant\":503}],507:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m\",n,\"[\",t-r-1,\"]\"].join(\"\")}return e}function a(t){return 1&t?\"-\":\"\"}function o(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",o(t.slice(0,e)),\",\",o(t.slice(e)),\")\"].join(\"\")}function s(t){if(2===t.length)return[[\"sum(prod(\",t[0][0],\",\",t[1][1],\"),prod(-\",t[0][1],\",\",t[1][0],\"))\"].join(\"\")];for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",o(s(n(t,r))),\",\",a(r),t[0][r],\")\"].join(\"\"));return e}function l(t){for(var e=[],r=[],a=i(t),l=[],u=0;u<t;++u)0==(1&u)?e.push.apply(e,s(n(a,u))):r.push.apply(r,s(n(a,u))),l.push(\"m\"+u);var p=o(e),m=o(r),v=\"orientation\"+t+\"Exact\",g=[\"function \",v,\"(\",l.join(),\"){var p=\",p,\",n=\",m,\",d=sub(p,n);return d[d.length-1];};return \",v].join(\"\");return new Function(\"sum\",\"prod\",\"scale\",\"sub\",g)(h,c,f,d)}function u(t){var e=g[t.length];return e||(e=g[t.length]=l(t.length)),e.apply(void 0,t)}var c=t(\"two-product\"),h=t(\"robust-sum\"),f=t(\"robust-scale\"),d=t(\"robust-subtract\"),p=5,m=l(3),v=l(4),g=[function(){return 0},function(){return 0},function(t,e){return e[0]-t[0]},function(t,e,r){var n,i=(t[1]-r[1])*(e[0]-r[0]),a=(t[0]-r[0])*(e[1]-r[1]),o=i-a;if(i>0){if(a<=0)return o;n=i+a}else{if(!(i<0))return o;if(a>=0)return o;n=-(i+a)}var s=3.3306690738754716e-16*n;return o>=s||o<=-s?o:m(t,e,r)},function(t,e,r,n){var i=t[0]-n[0],a=e[0]-n[0],o=r[0]-n[0],s=t[1]-n[1],l=e[1]-n[1],u=r[1]-n[1],c=t[2]-n[2],h=e[2]-n[2],f=r[2]-n[2],d=a*u,p=o*l,m=o*s,g=i*u,y=i*l,b=a*s,x=c*(d-p)+h*(m-g)+f*(y-b),_=(Math.abs(d)+Math.abs(p))*Math.abs(c)+(Math.abs(m)+Math.abs(g))*Math.abs(h)+(Math.abs(y)+Math.abs(b))*Math.abs(f),w=7.771561172376103e-16*_;return x>w||-x>w?x:v(t,e,r,n)}];!function(){for(;g.length<=p;)g.push(l(g.length));for(var t=[],r=[\"slow\"],n=0;n<=p;++n)t.push(\"a\"+n),r.push(\"o\"+n);for(var i=[\"function getOrientation(\",t.join(),\"){switch(arguments.length){case 0:case 1:return 0;\"],n=2;n<=p;++n)i.push(\"case \",n,\":return o\",n,\"(\",t.slice(0,n).join(),\");\");i.push(\"}var s=new Array(arguments.length);for(var i=0;i<arguments.length;++i){s[i]=arguments[i]};return slow(s);}return getOrientation\"),r.push(i.join(\"\"));var a=Function.apply(void 0,r);e.exports=a.apply(void 0,[u].concat(g));for(var n=0;n<=p;++n)e.exports[n]=g[n]}()},{\"robust-scale\":509,\"robust-subtract\":511,\"robust-sum\":512,\"two-product\":538}],508:[function(t,e,r){\"use strict\";function n(t,e){if(1===t.length)return a(e,t[0]);if(1===e.length)return a(t,e[0]);if(0===t.length||0===e.length)return[0];var r=[0];if(t.length<e.length)for(var n=0;n<t.length;++n)r=i(r,a(e,t[n]));else for(var n=0;n<e.length;++n)r=i(r,a(t,e[n]));return r}var i=t(\"robust-sum\"),a=t(\"robust-scale\");e.exports=n},{\"robust-scale\":509,\"robust-sum\":512}],\n",
       "509:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length;if(1===r){var n=i(t[0],e);return n[0]?n:[n[1]]}var o=new Array(2*r),s=[.1,.1],l=[.1,.1],u=0;i(t[0],e,s),s[0]&&(o[u++]=s[0]);for(var c=1;c<r;++c){i(t[c],e,l);var h=s[1];a(h,l[0],s),s[0]&&(o[u++]=s[0]);var f=l[1],d=s[1],p=f+d,m=p-f,v=d-m;s[1]=p,v&&(o[u++]=v)}return s[1]&&(o[u++]=s[1]),0===u&&(o[u++]=0),o.length=u,o}var i=t(\"two-product\"),a=t(\"two-sum\");e.exports=n},{\"two-product\":538,\"two-sum\":539}],510:[function(t,e,r){\"use strict\";function n(t,e,r,n){for(var i=0;i<2;++i){var a=t[i],o=e[i],s=Math.min(a,o),l=Math.max(a,o),u=r[i],c=n[i],h=Math.min(u,c);if(Math.max(u,c)<s||l<h)return!1}return!0}function i(t,e,r,i){var o=a(t,r,i),s=a(e,r,i);if(o>0&&s>0||o<0&&s<0)return!1;var l=a(r,t,e),u=a(i,t,e);return!(l>0&&u>0||l<0&&u<0)&&(0!==o||0!==s||0!==l||0!==u||n(t,e,r,i))}e.exports=i;var a=t(\"robust-orientation\")[3]},{\"robust-orientation\":507}],511:[function(t,e,r){\"use strict\";function n(t,e){var r=t+e,n=r-t,i=r-n,a=e-n,o=t-i,s=o+a;return s?[s,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],-e[0]);var a,o,s=r+i,l=new Array(s),u=0,c=0,h=0,f=Math.abs,d=t[c],p=f(d),m=-e[h],v=f(m);p<v?(o=d,(c+=1)<r&&(d=t[c],p=f(d))):(o=m,(h+=1)<i&&(m=-e[h],v=f(m))),c<r&&p<v||h>=i?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=-e[h],v=f(m)));for(var g,y,b,x,_,w=a+o,M=w-a,k=o-M,A=k,T=w;c<r&&h<i;)p<v?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=-e[h],v=f(m))),o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g;for(;c<r;)a=d,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(c+=1)<r&&(d=t[c]);for(;h<i;)a=m,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(h+=1)<i&&(m=-e[h]);return A&&(l[u++]=A),T&&(l[u++]=T),u||(l[u++]=0),l.length=u,l}e.exports=i},{}],512:[function(t,e,r){\"use strict\";function n(t,e){var r=t+e,n=r-t,i=r-n,a=e-n,o=t-i,s=o+a;return s?[s,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],e[0]);var a,o,s=r+i,l=new Array(s),u=0,c=0,h=0,f=Math.abs,d=t[c],p=f(d),m=e[h],v=f(m);p<v?(o=d,(c+=1)<r&&(d=t[c],p=f(d))):(o=m,(h+=1)<i&&(m=e[h],v=f(m))),c<r&&p<v||h>=i?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=e[h],v=f(m)));for(var g,y,b,x,_,w=a+o,M=w-a,k=o-M,A=k,T=w;c<r&&h<i;)p<v?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=e[h],v=f(m))),o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g;for(;c<r;)a=d,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(c+=1)<r&&(d=t[c]);for(;h<i;)a=m,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(h+=1)<i&&(m=e[h]);return A&&(l[u++]=A),T&&(l[u++]=T),u||(l[u++]=0),l.length=u,l}e.exports=i},{}],513:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.ShelfPack=i()}(this,function(){function t(t,e,r){r=r||{},this.w=t||64,this.h=e||64,this.autoResize=!!r.autoResize,this.shelves=[],this.stats={},this.count=function(t){this.stats[t]=1+(0|this.stats[t])}}function e(t,e,r){this.x=0,this.y=t,this.w=this.free=e,this.h=r}return t.prototype.pack=function(t,e){t=[].concat(t),e=e||{};for(var r,n,i,a=[],o=0;o<t.length;o++)if(r=t[o].w||t[o].width,n=t[o].h||t[o].height,r&&n){if(!(i=this.packOne(r,n)))continue;e.inPlace&&(t[o].x=i.x,t[o].y=i.y),a.push(i)}if(this.shelves.length>0){for(var s=0,l=0,u=0;u<this.shelves.length;u++){var c=this.shelves[u];l+=c.h,s=Math.max(c.w-c.free,s)}this.resize(s,l)}return a},t.prototype.packOne=function(t,r){for(var n,i,a=0,o={shelf:-1,waste:1/0},s=0;s<this.shelves.length;s++){if(n=this.shelves[s],a+=n.h,r===n.h&&t<=n.free)return this.count(r),n.alloc(t,r);r>n.h||t>n.free||r<n.h&&t<=n.free&&(i=n.h-r)<o.waste&&(o.waste=i,o.shelf=s)}if(-1!==o.shelf)return n=this.shelves[o.shelf],this.count(r),n.alloc(t,r);if(r<=this.h-a&&t<=this.w)return n=new e(a,this.w,r),this.shelves.push(n),this.count(r),n.alloc(t,r);if(this.autoResize){var l,u,c,h;return l=u=this.h,c=h=this.w,(c<=l||t>c)&&(h=2*Math.max(t,c)),(l<c||r>l)&&(u=2*Math.max(r,l)),this.resize(h,u),this.packOne(t,r)}return null},t.prototype.clear=function(){this.shelves=[],this.stats={}},t.prototype.resize=function(t,e){this.w=t,this.h=e;for(var r=0;r<this.shelves.length;r++)this.shelves[r].resize(t);return!0},e.prototype.alloc=function(t,e){if(t>this.free||e>this.h)return null;var r=this.x;return this.x+=t,this.free-=t,{x:r,y:this.y,w:t,h:e,width:t,height:e}},e.prototype.resize=function(t){return this.free+=t-this.w,this.w=t,!0},t})},{}],514:[function(t,e,r){\"use strict\";e.exports=function(t){return t<0?-1:t>0?1:0}},{}],515:[function(t,e,r){\"use strict\";function n(t){return a(i(t))}e.exports=n;var i=t(\"boundary-cells\"),a=t(\"reduce-simplicial-complex\")},{\"boundary-cells\":68,\"reduce-simplicial-complex\":497}],516:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=0,n=0;n<e;++n)r=0|Math.max(r,t[n].length);return r-1}function i(t,e){for(var r=t.length,n=h.mallocUint8(r),i=0;i<r;++i)n[i]=t[i]<e|0;return n}function a(t,e){for(var r=t.length,n=e*(e+1)/2*r|0,i=h.mallocUint32(2*n),a=0,o=0;o<r;++o)for(var s=t[o],e=s.length,l=0;l<e;++l)for(var u=0;u<l;++u){var d=s[u],p=s[l];i[a++]=0|Math.min(d,p),i[a++]=0|Math.max(d,p)}f(c(i,[a/2|0,2]));for(var m=2,o=2;o<a;o+=2)i[o-2]===i[o]&&i[o-1]===i[o+1]||(i[m++]=i[o],i[m++]=i[o+1]);return c(i,[m/2|0,2])}function o(t,e,r,n){for(var i=t.data,a=t.shape[0],o=h.mallocDouble(a),s=0,l=0;l<a;++l){var u=i[2*l],f=i[2*l+1];if(r[u]!==r[f]){var d=e[u],p=e[f];i[2*s]=u,i[2*s+1]=f,o[s++]=(p-n)/(p-d)}}return t.shape[0]=s,c(o,[s])}function s(t,e){var r=h.mallocInt32(2*e),n=t.shape[0],i=t.data;r[0]=0;for(var a=0,o=0;o<n;++o){var s=i[2*o];if(s!==a){for(r[2*a+1]=o;++a<s;)r[2*a]=o,r[2*a+1]=o;r[2*a]=o}}for(r[2*a+1]=n;++a<e;)r[2*a]=r[2*a+1]=n;return r}function l(t){for(var e=0|t.shape[0],r=t.data,n=new Array(e),i=0;i<e;++i)n[i]=[r[2*i],r[2*i+1]];return n}function u(t,e,r,u){if(r=r||0,void 0===u&&(u=n(t)),0===t.length||u<1)return{cells:[],vertexIds:[],vertexWeights:[]};var c=i(e,+r),f=a(t,u),p=o(f,e,c,+r),m=s(f,0|e.length),v=d(u)(t,f.data,m,c),g=l(f),y=[].slice.call(p.data,0,p.shape[0]);return h.free(c),h.free(f.data),h.free(p.data),h.free(m),{cells:v,vertexIds:g,vertexWeights:y}}e.exports=u;var c=t(\"ndarray\"),h=t(\"typedarray-pool\"),f=t(\"ndarray-sort\"),d=t(\"./lib/codegen\")},{\"./lib/codegen\":517,ndarray:466,\"ndarray-sort\":464,\"typedarray-pool\":540}],517:[function(t,e,r){\"use strict\";function n(t){var e=0,r=new Array(t+1);r[0]=[[]];for(var n=1;n<=t;++n)for(var i=r[n]=o(n),s=0;s<i.length;++s)e=Math.max(e,i[n].length);for(var l=[\"function B(C,E,i,j){\",\"var a=Math.min(i,j)|0,b=Math.max(i,j)|0,l=C[2*a],h=C[2*a+1];\",\"while(l<h){\",\"var m=(l+h)>>1,v=E[2*m+1];\",\"if(v===b){return m}\",\"if(b<v){h=m}else{l=m+1}\",\"}\",\"return l;\",\"};\",\"function getContour\",t,\"d(F,E,C,S){\",\"var n=F.length,R=[];\",\"for(var i=0;i<n;++i){var c=F[i],l=c.length;\"],n=t+1;n>1;--n){n<t+1&&l.push(\"else \"),l.push(\"if(l===\",n,\"){\");for(var u=[],s=0;s<n;++s)u.push(\"(S[c[\"+s+\"]]<<\"+s+\")\");l.push(\"var M=\",u.join(\"+\"),\";if(M===0||M===\",(1<<n)-1,\"){continue}switch(M){\");for(var i=r[n-1],s=0;s<i.length;++s)l.push(\"case \",s,\":\"),function(t){if(!(t.length<=0)){l.push(\"R.push(\");for(var e=0;e<t.length;++e){var r=t[e];e>0&&l.push(\",\"),l.push(\"[\");for(var n=0;n<r.length;++n){var i=r[n];n>0&&l.push(\",\"),l.push(\"B(C,E,c[\",i[0],\"],c[\",i[1],\"])\")}l.push(\"]\")}l.push(\");\")}}(i[s]),l.push(\"break;\");l.push(\"}}\")}return l.push(\"}return R;};return getContour\",t,\"d\"),new Function(\"pool\",l.join(\"\"))(a)}function i(t){var e=s[t];return e||(e=s[t]=n(t)),e}e.exports=i;var a=t(\"typedarray-pool\"),o=t(\"marching-simplex-table\"),s={}},{\"marching-simplex-table\":444,\"typedarray-pool\":540}],518:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){for(var e=0,r=Math.max,n=0,i=t.length;n<i;++n)e=r(e,t[n].length);return e-1}function i(t){for(var e=-1,r=Math.max,n=0,i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)e=r(e,a[o]);return e+1}function a(t){for(var e=new Array(t.length),r=0,n=t.length;r<n;++r)e[r]=t[r].slice(0);return e}function o(t,e){var r=t.length,n=t.length-e.length,i=Math.min;if(n)return n;switch(r){case 0:return 0;case 1:return t[0]-e[0];case 2:var a=t[0]+t[1]-e[0]-e[1];return a||i(t[0],t[1])-i(e[0],e[1]);case 3:var o=t[0]+t[1],s=e[0]+e[1];if(a=o+t[2]-(s+e[2]))return a;var l=i(t[0],t[1]),u=i(e[0],e[1]),a=i(l,t[2])-i(u,e[2]);return a||i(l+t[2],o)-i(u+e[2],s);default:var c=t.slice(0);c.sort();var h=e.slice(0);h.sort();for(var f=0;f<r;++f)if(n=c[f]-h[f])return n;return 0}}function s(t,e){return o(t[0],e[0])}function l(t,e){if(e){for(var r=t.length,n=new Array(r),i=0;i<r;++i)n[i]=[t[i],e[i]];n.sort(s);for(var i=0;i<r;++i)t[i]=n[i][0],e[i]=n[i][1];return t}return t.sort(o),t}function u(t){if(0===t.length)return[];for(var e=1,r=t.length,n=1;n<r;++n){var i=t[n];if(o(i,t[n-1])){if(n===e){e++;continue}t[e++]=i}}return t.length=e,t}function c(t,e){for(var r=0,n=t.length-1,i=-1;r<=n;){var a=r+n>>1,s=o(t[a],e);s<=0?(0===s&&(i=a),r=a+1):s>0&&(n=a-1)}return i}function h(t,e){for(var r=new Array(t.length),n=0,i=r.length;n<i;++n)r[n]=[];for(var a=[],n=0,s=e.length;n<s;++n)for(var l=e[n],u=l.length,h=1,f=1<<u;h<f;++h){a.length=b.popCount(h);for(var d=0,p=0;p<u;++p)h&1<<p&&(a[d++]=l[p]);var m=c(t,a);if(!(m<0))for(;;)if(r[m++].push(n),m>=t.length||0!==o(t[m],a))break}return r}function f(t,e){if(!e)return h(u(p(t,0)),t,0);for(var r=new Array(e),n=0;n<e;++n)r[n]=[];for(var n=0,i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)r[a[o]].push(n);return r}function d(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0|i.length,o=1,s=1<<a;o<s;++o){for(var u=[],c=0;c<a;++c)o>>>c&1&&u.push(i[c]);e.push(u)}return l(e)}function p(t,e){if(e<0)return[];for(var r=[],n=(1<<e+1)-1,i=0;i<t.length;++i)for(var a=t[i],o=n;o<1<<a.length;o=b.nextCombination(o)){for(var s=new Array(e+1),u=0,c=0;c<a.length;++c)o&1<<c&&(s[u++]=a[c]);r.push(s)}return l(r)}function m(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;++a){for(var s=new Array(i.length-1),u=0,c=0;u<o;++u)u!==a&&(s[c++]=i[u]);e.push(s)}return l(e)}function v(t,e){for(var r=new x(e),n=0;n<t.length;++n)for(var i=t[n],a=0;a<i.length;++a)for(var o=a+1;o<i.length;++o)r.link(i[a],i[o]);for(var s=[],l=r.ranks,n=0;n<l.length;++n)l[n]=-1;for(var n=0;n<t.length;++n){var u=r.find(t[n][0]);l[u]<0?(l[u]=s.length,s.push([t[n].slice(0)])):s[l[u]].push(t[n].slice(0))}return s}function g(t){for(var e=u(l(p(t,0))),r=new x(e.length),n=0;n<t.length;++n)for(var i=t[n],a=0;a<i.length;++a)for(var o=c(e,[i[a]]),s=a+1;s<i.length;++s)r.link(o,c(e,[i[s]]));for(var h=[],f=r.ranks,n=0;n<f.length;++n)f[n]=-1;for(var n=0;n<t.length;++n){var d=r.find(c(e,[t[n][0]]));f[d]<0?(f[d]=h.length,h.push([t[n].slice(0)])):h[f[d]].push(t[n].slice(0))}return h}function y(t,e){return e?v(t,e):g(t)}var b=t(\"bit-twiddle\"),x=t(\"union-find\");r.dimension=n,r.countVertices=i,r.cloneCells=a,r.compareCells=o,r.normalize=l,r.unique=u,r.findCell=c,r.incidence=h,r.dual=f,r.explode=d,r.skeleton=p,r.boundary=m,r.connectedComponents=y},{\"bit-twiddle\":66,\"union-find\":541}],519:[function(t,e,r){arguments[4][66][0].apply(r,arguments)},{dup:66}],520:[function(t,e,r){arguments[4][518][0].apply(r,arguments)},{\"bit-twiddle\":519,dup:518,\"union-find\":521}],521:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n,n.prototype.length=function(){return this.roots.length},n.prototype.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},n.prototype.find=function(t){for(var e=this.roots;e[t]!==t;){var r=e[t];e[t]=e[r],t=r}return t},n.prototype.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],522:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.abs(a(t,e,r))/Math.sqrt(Math.pow(e[0]-r[0],2)+Math.pow(e[1]-r[1],2))}function i(t,e,r){function i(t){if(b[t])return 1/0;var r=v[t],i=g[t];return r<0||i<0?1/0:n(e[t],e[r],e[i])}function a(t,e){var r=k[t],n=k[e];k[t]=n,k[e]=r,A[r]=e,A[n]=t}function s(t){return y[k[t]]}function l(t){return 1&t?t-1>>1:(t>>1)-1}function u(t){for(var e=s(t);;){var r=e,n=2*t+1,i=2*(t+1),o=t;if(n<T){var l=s(n);l<r&&(o=n,r=l)}if(i<T){s(i)<r&&(o=i)}if(o===t)return t;a(t,o),t=o}}function c(t){for(var e=s(t);t>0;){var r=l(t);if(r>=0){if(e<s(r)){a(t,r),t=r;continue}}return t}}function h(){if(T>0){var t=k[0];return a(0,T-1),T-=1,u(0),t}return-1}function f(t,e){var r=k[t];return y[r]===e?t:(y[r]=-1/0,c(t),h(),y[r]=e,T+=1,c(T-1))}function d(t,e){if(t[e]<0)return e;var r=e,n=e;do{var i=t[n];if(!b[n]||i<0||i===n)break;if(n=i,i=t[n],!b[n]||i<0||i===n)break;n=i,r=t[r]}while(r!==n);for(var a=e;a!==n;a=t[a])t[a]=n;return n}for(var p=e.length,m=t.length,v=new Array(p),g=new Array(p),y=new Array(p),b=new Array(p),x=0;x<p;++x)v[x]=g[x]=-1,y[x]=1/0,b[x]=!1;for(var x=0;x<m;++x){var _=t[x];if(2!==_.length)throw new Error(\"Input must be a graph\");var w=_[1],M=_[0];-1!==g[M]?g[M]=-2:g[M]=w,-1!==v[w]?v[w]=-2:v[w]=M}for(var k=[],A=new Array(p),x=0;x<p;++x){(y[x]=i(x))<1/0?(A[x]=k.length,k.push(x)):A[x]=-1}for(var T=k.length,x=T>>1;x>=0;--x)u(x);for(;;){var S=h();if(S<0||y[S]>r)break;!function(t){if(!b[t]){b[t]=!0;var e=v[t],r=g[t];v[r]>=0&&(v[r]=e),g[e]>=0&&(g[e]=r),A[e]>=0&&f(A[e],i(e)),A[r]>=0&&f(A[r],i(r))}}(S)}for(var E=[],x=0;x<p;++x)b[x]||(A[x]=E.length,E.push(e[x].slice()));var L=(E.length,[]);return t.forEach(function(t){var e=d(v,t[0]),r=d(g,t[1]);if(e>=0&&r>=0&&e!==r){var n=A[e],i=A[r];n!==i&&L.push([n,i])}}),o.unique(o.normalize(L)),{positions:E,edges:L}}e.exports=i;var a=t(\"robust-orientation\"),o=t(\"simplicial-complex\")},{\"robust-orientation\":507,\"simplicial-complex\":520}],523:[function(t,e,r){\"use strict\";function n(t,e){var r,n;if(e[0][0]<e[1][0])r=e[0],n=e[1];else{if(!(e[0][0]>e[1][0])){var i=Math.min(t[0][1],t[1][1]),o=Math.max(t[0][1],t[1][1]),s=Math.min(e[0][1],e[1][1]),l=Math.max(e[0][1],e[1][1]);return o<s?o-s:i>l?i-l:o-l}r=e[1],n=e[0]}var u,c;t[0][1]<t[1][1]?(u=t[0],c=t[1]):(u=t[1],c=t[0]);var h=a(n,r,u);return h||((h=a(n,r,c))||c-n)}function i(t,e){var r,i;if(e[0][0]<e[1][0])r=e[0],i=e[1];else{if(!(e[0][0]>e[1][0]))return n(e,t);r=e[1],i=e[0]}var o,s;if(t[0][0]<t[1][0])o=t[0],s=t[1];else{if(!(t[0][0]>t[1][0]))return-n(t,e);o=t[1],s=t[0]}var l=a(r,i,s),u=a(r,i,o);if(l<0){if(u<=0)return l}else if(l>0){if(u>=0)return l}else if(u)return u;if(l=a(s,o,i),u=a(s,o,r),l<0){if(u<=0)return l}else if(l>0){if(u>=0)return l}else if(u)return u;return i[0]-s[0]}e.exports=i;var a=t(\"robust-orientation\")},{\"robust-orientation\":507}],524:[function(t,e,r){\"use strict\";function n(t,e,r){this.slabs=t,this.coordinates=e,this.horizontal=r}function i(t,e){return t.y-e}function a(t,e){for(var r=null;t;){var n,i,o=t.key;o[0][0]<o[1][0]?(n=o[0],i=o[1]):(n=o[1],i=o[0]);var s=h(n,i,e);if(s<0)t=t.left;else if(s>0)if(e[0]!==o[1][0])r=t,t=t.right;else{var l=a(t.right,e);if(l)return l;t=t.left}else{if(e[0]!==o[1][0])return t;var l=a(t.right,e);if(l)return l;t=t.left}}return r}function o(t,e,r,n){this.y=t,this.index=e,this.start=r,this.closed=n}function s(t,e,r,n){this.x=t,this.segment=e,this.create=r,this.index=n}function l(t){for(var e=t.length,r=2*e,i=new Array(r),a=0;a<e;++a){var l=t[a],u=l[0][0]<l[1][0];i[2*a]=new s(l[0][0],l,u,a),i[2*a+1]=new s(l[1][0],l,!u,a)}i.sort(function(t,e){var r=t.x-e.x;return r||((r=t.create-e.create)||Math.min(t.segment[0][1],t.segment[1][1])-Math.min(e.segment[0][1],e.segment[1][1]))});for(var h=c(f),d=[],p=[],m=[],a=0;a<r;){for(var v=i[a].x,g=[];a<r;){var y=i[a];if(y.x!==v)break;a+=1,y.segment[0][0]===y.x&&y.segment[1][0]===y.x?y.create&&(y.segment[0][1]<y.segment[1][1]?(g.push(new o(y.segment[0][1],y.index,!0,!0)),g.push(new o(y.segment[1][1],y.index,!1,!1))):(g.push(new o(y.segment[1][1],y.index,!0,!1)),g.push(new o(y.segment[0][1],y.index,!1,!0)))):h=y.create?h.insert(y.segment,y.index):h.remove(y.segment)}d.push(h.root),p.push(v),m.push(g)}return new n(d,p,m)}e.exports=l;var u=t(\"binary-search-bounds\"),c=t(\"functional-red-black-tree\"),h=t(\"robust-orientation\"),f=t(\"./lib/order-segments\");n.prototype.castUp=function(t){var e=u.le(this.coordinates,t[0]);if(e<0)return-1;var r=(this.slabs[e],a(this.slabs[e],t)),n=-1;if(r&&(n=r.value),this.coordinates[e]===t[0]){var o=null;if(r&&(o=r.key),e>0){var s=a(this.slabs[e-1],t);s&&(o?f(s.key,o)>0&&(o=s.key,n=s.value):(n=s.value,o=s.key))}var l=this.horizontal[e];if(l.length>0){var c=u.ge(l,t[1],i);if(c<l.length){var d=l[c];if(t[1]===d.y){if(d.closed)return d.index;for(;c<l.length-1&&l[c+1].y===t[1];)if(c+=1,d=l[c],d.closed)return d.index;if(d.y===t[1]&&!d.start){if((c+=1)>=l.length)return n;d=l[c]}}if(d.start)if(o){var p=h(o[0],o[1],[t[0],d.y]);o[0][0]>o[1][0]&&(p=-p),p>0&&(n=d.index)}else n=d.index;else d.y!==t[1]&&(n=d.index)}}}return n}},{\"./lib/order-segments\":523,\"binary-search-bounds\":65,\"functional-red-black-tree\":134,\"robust-orientation\":507}],525:[function(t,e,r){\"use strict\";function n(t,e){var r=u(l(t,e),[e[e.length-1]]);return r[r.length-1]}function i(t,e,r,n){var i=n-e,a=-e/i;a<0?a=0:a>1&&(a=1);for(var o=1-a,s=t.length,l=new Array(s),u=0;u<s;++u)l[u]=a*t[u]+o*r[u];return l}function a(t,e){for(var r=[],a=[],o=n(t[t.length-1],e),s=t[t.length-1],l=t[0],u=0;u<t.length;++u,s=l){l=t[u];var c=n(l,e);if(o<0&&c>0||o>0&&c<0){var h=i(s,c,l,o);r.push(h),a.push(h.slice())}c<0?a.push(l.slice()):c>0?r.push(l.slice()):(r.push(l.slice()),a.push(l.slice())),o=c}return{positive:r,negative:a}}function o(t,e){for(var r=[],a=n(t[t.length-1],e),o=t[t.length-1],s=t[0],l=0;l<t.length;++l,o=s){s=t[l];var u=n(s,e);(a<0&&u>0||a>0&&u<0)&&r.push(i(o,u,s,a)),u>=0&&r.push(s.slice()),a=u}return r}function s(t,e){for(var r=[],a=n(t[t.length-1],e),o=t[t.length-1],s=t[0],l=0;l<t.length;++l,o=s){s=t[l];var u=n(s,e);(a<0&&u>0||a>0&&u<0)&&r.push(i(o,u,s,a)),u<=0&&r.push(s.slice()),a=u}return r}var l=t(\"robust-dot-product\"),u=t(\"robust-sum\");e.exports=a,e.exports.positive=o,e.exports.negative=s},{\"robust-dot-product\":504,\"robust-sum\":512}],526:[function(e,r,n){!function(){\"use strict\";function e(t){return i(a(t),arguments)}function r(t,r){return e.apply(null,[t].concat(r||[]))}function i(t,r){var n,i,a,s,l,u,c,h,f,d=1,p=t.length,m=\"\";for(i=0;i<p;i++)if(\"string\"==typeof t[i])m+=t[i];else if(Array.isArray(t[i])){if(s=t[i],s[2])for(n=r[d],a=0;a<s[2].length;a++){if(!n.hasOwnProperty(s[2][a]))throw new Error(e('[sprintf] property \"%s\" does not exist',s[2][a]));n=n[s[2][a]]}else n=s[1]?r[s[1]]:r[d++];if(o.not_type.test(s[8])&&o.not_primitive.test(s[8])&&n instanceof Function&&(n=n()),o.numeric_arg.test(s[8])&&\"number\"!=typeof n&&isNaN(n))throw new TypeError(e(\"[sprintf] expecting number but found %T\",n));switch(o.number.test(s[8])&&(h=n>=0),s[8]){case\"b\":n=parseInt(n,10).toString(2);break;case\"c\":n=String.fromCharCode(parseInt(n,10));break;case\"d\":case\"i\":n=parseInt(n,10);break;case\"j\":n=JSON.stringify(n,null,s[6]?parseInt(s[6]):0);break;case\"e\":n=s[7]?parseFloat(n).toExponential(s[7]):parseFloat(n).toExponential();break;case\"f\":n=s[7]?parseFloat(n).toFixed(s[7]):parseFloat(n);break;case\"g\":n=s[7]?String(Number(n.toPrecision(s[7]))):parseFloat(n);break;case\"o\":n=(parseInt(n,10)>>>0).toString(8);break;case\"s\":n=String(n),n=s[7]?n.substring(0,s[7]):n;break;case\"t\":n=String(!!n),n=s[7]?n.substring(0,s[7]):n;break;case\"T\":n=Object.prototype.toString.call(n).slice(8,-1).toLowerCase(),n=s[7]?n.substring(0,s[7]):n;break;case\"u\":n=parseInt(n,10)>>>0;break;case\"v\":n=n.valueOf(),n=s[7]?n.substring(0,s[7]):n;break;case\"x\":n=(parseInt(n,10)>>>0).toString(16);break;case\"X\":n=(parseInt(n,10)>>>0).toString(16).toUpperCase()}o.json.test(s[8])?m+=n:(!o.number.test(s[8])||h&&!s[3]?f=\"\":(f=h?\"+\":\"-\",n=n.toString().replace(o.sign,\"\")),u=s[4]?\"0\"===s[4]?\"0\":s[4].charAt(1):\" \",c=s[6]-(f+n).length,l=s[6]&&c>0?u.repeat(c):\"\",m+=s[5]?f+n+l:\"0\"===u?f+l+n:l+f+n)}return m}function a(t){if(s[t])return s[t];for(var e,r=t,n=[],i=0;r;){if(null!==(e=o.text.exec(r)))n.push(e[0]);else if(null!==(e=o.modulo.exec(r)))n.push(\"%\");else{if(null===(e=o.placeholder.exec(r)))throw new SyntaxError(\"[sprintf] unexpected placeholder\");if(e[2]){i|=1;var a=[],l=e[2],u=[];if(null===(u=o.key.exec(l)))throw new SyntaxError(\"[sprintf] failed to parse named argument key\");for(a.push(u[1]);\"\"!==(l=l.substring(u[0].length));)if(null!==(u=o.key_access.exec(l)))a.push(u[1]);else{if(null===(u=o.index_access.exec(l)))throw new SyntaxError(\"[sprintf] failed to parse named argument key\");a.push(u[1])}e[2]=a}else i|=2;if(3===i)throw new Error(\"[sprintf] mixing positional and named placeholders is not (yet) supported\");n.push(e)}r=r.substring(e[0].length)}return s[t]=n}var o={not_string:/[^s]/,not_bool:/[^t]/,not_type:/[^T]/,not_primitive:/[^v]/,number:/[diefg]/,numeric_arg:/[bcdiefguxX]/,json:/[j]/,not_json:/[^j]/,text:/^[^\\x25]+/,modulo:/^\\x25{2}/,placeholder:/^\\x25(?:([1-9]\\d*)\\$|\\(([^\\)]+)\\))?(\\+)?(0|'[^$])?(-)?(\\d+)?(?:\\.(\\d+))?([b-gijostTuvxX])/,key:/^([a-z_][a-z_\\d]*)/i,key_access:/^\\.([a-z_][a-z_\\d]*)/i,index_access:/^\\[(\\d+)\\]/,sign:/^[\\+\\-]/},s=Object.create(null);void 0!==n&&(n.sprintf=e,n.vsprintf=r),\"undefined\"!=typeof window&&(window.sprintf=e,window.vsprintf=r,\"function\"==typeof t&&t.amd&&t(function(){return{sprintf:e,vsprintf:r}}))}()},{}],527:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=new Array(e),n=new Array(e),i=new Array(e),a=new Array(e),o=new Array(e),s=new Array(e),l=0;l<e;++l)r[l]=-1,n[l]=0,i[l]=!1,a[l]=0,o[l]=-1,s[l]=[];for(var u=0,c=[],h=[],l=0;l<e;++l)r[l]<0&&function(e){var l=[e],f=[e];for(r[e]=n[e]=u,i[e]=!0,u+=1;f.length>0;){e=f[f.length-1];var d=t[e];if(a[e]<d.length){for(var p=a[e];p<d.length;++p){var m=d[p];if(r[m]<0){r[m]=n[m]=u,i[m]=!0,u+=1,l.push(m),f.push(m);break}i[m]&&(n[e]=0|Math.min(n[e],n[m])),o[m]>=0&&s[e].push(o[m])}a[e]=p}else{if(n[e]===r[e]){for(var v=[],g=[],y=0,p=l.length-1;p>=0;--p){var b=l[p];if(i[b]=!1,v.push(b),g.push(s[b]),y+=s[b].length,o[b]=c.length,b===e){l.length=p;break}}c.push(v);for(var x=new Array(y),p=0;p<g.length;p++)for(var _=0;_<g[p].length;_++)x[--y]=g[p][_];h.push(x)}f.pop()}}}(l);for(var f,l=0;l<h.length;l++){var d=h[l];if(0!==d.length){d.sort(function(t,e){return t-e}),f=[d[0]];for(var p=1;p<d.length;p++)d[p]!==d[p-1]&&f.push(d[p]);h[l]=f}}return{components:c,adjacencyList:h}}e.exports=n},{}],528:[function(t,e,r){\"use strict\";function n(t){return new i(t)}function i(t){this.options=d(Object.create(this.options),t),this.trees=new Array(this.options.maxZoom+1)}function a(t,e,r,n,i){return{x:t,y:e,zoom:1/0,id:n,properties:i,parentId:-1,numPoints:r}}function o(t,e){var r=t.geometry.coordinates;return{x:u(r[0]),y:c(r[1]),zoom:1/0,id:e,parentId:-1}}function s(t){return{type:\"Feature\",properties:l(t),geometry:{type:\"Point\",coordinates:[h(t.x),f(t.y)]}}}function l(t){var e=t.numPoints,r=e>=1e4?Math.round(e/1e3)+\"k\":e>=1e3?Math.round(e/100)/10+\"k\":e;return d(d({},t.properties),{cluster:!0,cluster_id:t.id,point_count:e,point_count_abbreviated:r})}function u(t){return t/360+.5}function c(t){var e=Math.sin(t*Math.PI/180),r=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return r<0?0:r>1?1:r}function h(t){return 360*(t-.5)}function f(t){var e=(180-360*t)*Math.PI/180;return 360*Math.atan(Math.exp(e))/Math.PI-90}function d(t,e){for(var r in e)t[r]=e[r];return t}function p(t){return t.x}function m(t){return t.y}var v=t(\"kdbush\");e.exports=n,i.prototype={options:{minZoom:0,maxZoom:16,radius:40,extent:512,nodeSize:64,log:!1,reduce:null,initial:function(){return{}},map:function(t){return t}},load:function(t){var e=this.options.log;e&&console.time(\"total time\");var r=\"prepare \"+t.length+\" points\";e&&console.time(r),this.points=t;var n=t.map(o);e&&console.timeEnd(r);for(var i=this.options.maxZoom;i>=this.options.minZoom;i--){var a=+Date.now();this.trees[i+1]=v(n,p,m,this.options.nodeSize,Float32Array),n=this._cluster(n,i),e&&console.log(\"z%d: %d clusters in %dms\",i,n.length,+Date.now()-a)}return this.trees[this.options.minZoom]=v(n,p,m,this.options.nodeSize,Float32Array),e&&console.timeEnd(\"total time\"),this},getClusters:function(t,e){for(var r=this.trees[this._limitZoom(e)],n=r.range(u(t[0]),c(t[3]),u(t[2]),c(t[1])),i=[],a=0;a<n.length;a++){var o=r.points[n[a]];i.push(o.numPoints?s(o):this.points[o.id])}return i},getChildren:function(t,e){for(var r=this.trees[e+1].points[t],n=this.options.radius/(this.options.extent*Math.pow(2,e)),i=this.trees[e+1].within(r.x,r.y,n),a=[],o=0;o<i.length;o++){var l=this.trees[e+1].points[i[o]];l.parentId===t&&a.push(l.numPoints?s(l):this.points[l.id])}return a},getLeaves:function(t,e,r,n){r=r||10,n=n||0;var i=[];return this._appendLeaves(i,t,e,r,n,0),i},getTile:function(t,e,r){var n=this.trees[this._limitZoom(t)],i=Math.pow(2,t),a=this.options.extent,o=this.options.radius,s=o/a,l=(r-s)/i,u=(r+1+s)/i,c={features:[]};return this._addTileFeatures(n.range((e-s)/i,l,(e+1+s)/i,u),n.points,e,r,i,c),0===e&&this._addTileFeatures(n.range(1-s/i,l,1,u),n.points,i,r,i,c),e===i-1&&this._addTileFeatures(n.range(0,l,s/i,u),n.points,-1,r,i,c),c.features.length?c:null},getClusterExpansionZoom:function(t,e){for(;e<this.options.maxZoom;){var r=this.getChildren(t,e);if(e++,1!==r.length)break;t=r[0].properties.cluster_id}return e},_appendLeaves:function(t,e,r,n,i,a){for(var o=this.getChildren(e,r),s=0;s<o.length;s++){var l=o[s].properties;if(l.cluster?a+l.point_count<=i?a+=l.point_count:a=this._appendLeaves(t,l.cluster_id,r+1,n,i,a):a<i?a++:t.push(o[s]),t.length===n)break}return a},_addTileFeatures:function(t,e,r,n,i,a){for(var o=0;o<t.length;o++){var s=e[t[o]];a.features.push({type:1,geometry:[[Math.round(this.options.extent*(s.x*i-r)),Math.round(this.options.extent*(s.y*i-n))]],tags:s.numPoints?l(s):this.points[s.id].properties})}},_limitZoom:function(t){return Math.max(this.options.minZoom,Math.min(t,this.options.maxZoom+1))},_cluster:function(t,e){for(var r=[],n=this.options.radius/(this.options.extent*Math.pow(2,e)),i=0;i<t.length;i++){var o=t[i];if(!(o.zoom<=e)){o.zoom=e;var s=this.trees[e+1],l=s.within(o.x,o.y,n),u=o.numPoints||1,c=o.x*u,h=o.y*u,f=null;this.options.reduce&&(f=this.options.initial(),this._accumulate(f,o));for(var d=0;d<l.length;d++){var p=s.points[l[d]];if(e<p.zoom){var m=p.numPoints||1;p.zoom=e,c+=p.x*m,h+=p.y*m,u+=m,p.parentId=i,this.options.reduce&&this._accumulate(f,p)}}1===u?r.push(o):(o.parentId=i,r.push(a(c/u,h/u,u,i,f)))}}return r},_accumulate:function(t,e){var r=e.numPoints?e.properties:this.options.map(this.points[e.id].properties);this.options.reduce(t,r)}}},{kdbush:297}],529:[function(t,e,r){\"use strict\";function n(t){return t.split(\"\").map(function(t){return t in i?i[t]:\"\"}).join(\"\")}e.exports=n;var i={\" \":\" \",0:\"\\u2070\",1:\"\\xb9\",2:\"\\xb2\",3:\"\\xb3\",4:\"\\u2074\",5:\"\\u2075\",6:\"\\u2076\",7:\"\\u2077\",8:\"\\u2078\",9:\"\\u2079\",\"+\":\"\\u207a\",\"-\":\"\\u207b\",a:\"\\u1d43\",b:\"\\u1d47\",c:\"\\u1d9c\",d:\"\\u1d48\",e:\"\\u1d49\",f:\"\\u1da0\",g:\"\\u1d4d\",h:\"\\u02b0\",i:\"\\u2071\",j:\"\\u02b2\",k:\"\\u1d4f\",l:\"\\u02e1\",m:\"\\u1d50\",n:\"\\u207f\",o:\"\\u1d52\",p:\"\\u1d56\",r:\"\\u02b3\",s:\"\\u02e2\",t:\"\\u1d57\",u:\"\\u1d58\",v:\"\\u1d5b\",w:\"\\u02b7\",x:\"\\u02e3\",y:\"\\u02b8\",z:\"\\u1dbb\"}},{}],530:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length,n=[\"'use strict';\"],i=\"surfaceNets\"+t.join(\"_\")+\"d\"+e;n.push(\"var contour=genContour({\",\"order:[\",t.join(),\"],\",\"scalarArguments: 3,\",\"phase:function phaseFunc(p,a,b,c) { return (p > c)|0 },\"),\"generic\"===e&&n.push(\"getters:[0],\");for(var a=[],l=[],u=0;u<r;++u)a.push(\"d\"+u),l.push(\"d\"+u);for(var u=0;u<1<<r;++u)a.push(\"v\"+u),l.push(\"v\"+u);for(var u=0;u<1<<r;++u)a.push(\"p\"+u),l.push(\"p\"+u);a.push(\"a\",\"b\",\"c\"),l.push(\"a\",\"c\"),n.push(\"vertex:function vertexFunc(\",a.join(),\"){\");for(var c=[],u=0;u<1<<r;++u)c.push(\"(p\"+u+\"<<\"+u+\")\");n.push(\"var m=(\",c.join(\"+\"),\")|0;if(m===0||m===\",(1<<(1<<r))-1,\"){return}\");var h=[],f=[];1<<(1<<r)<=128?(n.push(\"switch(m){\"),f=n):n.push(\"switch(m>>>7){\");for(var u=0;u<1<<(1<<r);++u){if(1<<(1<<r)>128&&u%128==0){h.length>0&&f.push(\"}}\");var d=\"vExtra\"+h.length;n.push(\"case \",u>>>7,\":\",d,\"(m&0x7f,\",l.join(),\");break;\"),f=[\"function \",d,\"(m,\",l.join(),\"){switch(m){\"],h.push(f)}f.push(\"case \",127&u,\":\");for(var p=new Array(r),m=new Array(r),v=new Array(r),g=new Array(r),y=0,b=0;b<r;++b)p[b]=[],m[b]=[],v[b]=0,g[b]=0;for(var b=0;b<1<<r;++b)for(var x=0;x<r;++x){var _=b^1<<x;if(!(_>b)&&!(u&1<<_)!=!(u&1<<b)){var w=1;u&1<<_?m[x].push(\"v\"+_+\"-v\"+b):(m[x].push(\"v\"+b+\"-v\"+_),w=-w),w<0?(p[x].push(\"-v\"+b+\"-v\"+_),v[x]+=2):(p[x].push(\"v\"+b+\"+v\"+_),v[x]-=2),y+=1;for(var M=0;M<r;++M)M!==x&&(_&1<<M?g[M]+=1:g[M]-=1)}}for(var k=[],x=0;x<r;++x)if(0===p[x].length)k.push(\"d\"+x+\"-0.5\");else{var A=\"\";v[x]<0?A=v[x]+\"*c\":v[x]>0&&(A=\"+\"+v[x]+\"*c\");var T=p[x].length/y*.5,S=.5+g[x]/y*.5;k.push(\"d\"+x+\"-\"+S+\"-\"+T+\"*(\"+p[x].join(\"+\")+A+\")/(\"+m[x].join(\"+\")+\")\")}f.push(\"a.push([\",k.join(),\"]);\",\"break;\")}n.push(\"}},\"),h.length>0&&f.push(\"}}\");for(var E=[],u=0;u<1<<r-1;++u)E.push(\"v\"+u);E.push(\"c0\",\"c1\",\"p0\",\"p1\",\"a\",\"b\",\"c\"),n.push(\"cell:function cellFunc(\",E.join(),\"){\");var L=s(r-1);n.push(\"if(p0){b.push(\",L.map(function(t){return\"[\"+t.map(function(t){return\"v\"+t})+\"]\"}).join(),\")}else{b.push(\",L.map(function(t){var e=t.slice();return e.reverse(),\"[\"+e.map(function(t){return\"v\"+t})+\"]\"}).join(),\")}}});function \",i,\"(array,level){var verts=[],cells=[];contour(array,verts,cells,level);return {positions:verts,cells:cells};} return \",i,\";\");for(var u=0;u<h.length;++u)n.push(h[u].join(\"\"));return new Function(\"genContour\",n.join(\"\"))(o)}function i(t,e){for(var r=l(t,e),n=r.length,i=new Array(n),a=new Array(n),o=0;o<n;++o)i[o]=[r[o]],a[o]=[o];return{positions:i,cells:a}}function a(t,e){if(t.dimension<=0)return{positions:[],cells:[]};if(1===t.dimension)return i(t,e);var r=t.order.join()+\"-\"+t.dtype,a=u[r],e=+e||0;return a||(a=u[r]=n(t.order,t.dtype)),a(t,e)}e.exports=a;var o=t(\"ndarray-extract-contour\"),s=t(\"triangulate-hypercube\"),l=t(\"zero-crossings\"),u={}},{\"ndarray-extract-contour\":455,\"triangulate-hypercube\":536,\"zero-crossings\":583}],531:[function(t,e,r){(function(r){\"use strict\";function n(t){for(var e=t.cells,r=t.positions,n=new Float32Array(6*e.length),i=0,a=0,o=0;o<e.length;++o)for(var s=e[o],l=0;l<3;++l){var u=r[s[l]];n[i++]=u[0],n[i++]=u[1]+1.4,a=Math.max(u[0],a)}return{data:n,shape:a}}function i(t,e,r){var r=r||{},o=s[t];o||(o=s[t]={\" \":{data:new Float32Array(0),shape:.2}});var l=o[e];if(!l)if(e.length<=1||!/\\d/.test(e))l=o[e]=n(a(e,{triangles:!0,font:t,textAlign:r.textAlign||\"left\",textBaseline:\"alphabetic\"}));else{for(var u=e.split(/(\\d|\\s)/),c=new Array(u.length),h=0,f=0,d=0;d<u.length;++d)c[d]=i(t,u[d]),h+=c[d].data.length,f+=c[d].shape,d>0&&(f+=.02);for(var p=new Float32Array(h),m=0,v=-.5*f,d=0;d<c.length;++d){for(var g=c[d].data,y=0;y<g.length;y+=2)p[m++]=g[y]+v,p[m++]=g[y+1];v+=c[d].shape+.02}l=o[e]={data:p,shape:f}}return l}e.exports=i;var a=t(\"vectorize-text\"),o=window||r.global||{},s=o.__TEXT_CACHE||{};o.__TEXT_CACHE={}}).call(this,t(\"_process\"))},{_process:486,\"vectorize-text\":553}],532:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.fontSize=t||24,this.buffer=void 0===e?3:e,this.cutoff=n||.25,this.fontFamily=i||\"sans-serif\",this.radius=r||8;var a=this.size=this.fontSize+2*this.buffer;this.canvas=document.createElement(\"canvas\"),this.canvas.width=this.canvas.height=a,this.ctx=this.canvas.getContext(\"2d\"),this.ctx.font=t+\"px \"+this.fontFamily,this.ctx.textBaseline=\"middle\",this.ctx.fillStyle=\"black\",this.gridOuter=new Float64Array(a*a),this.gridInner=new Float64Array(a*a),this.f=new Float64Array(a),this.d=new Float64Array(a),this.z=new Float64Array(a+1),this.v=new Int16Array(a),this.middle=Math.round(a/2*(navigator.userAgent.indexOf(\"Gecko/\")>=0?1.2:1))}function i(t,e,r,n,i,o,s){for(var l=0;l<e;l++){for(var u=0;u<r;u++)n[u]=t[u*e+l];for(a(n,i,o,s,r),u=0;u<r;u++)t[u*e+l]=i[u]}for(u=0;u<r;u++){for(l=0;l<e;l++)n[l]=t[u*e+l];for(a(n,i,o,s,e),l=0;l<e;l++)t[u*e+l]=Math.sqrt(i[l])}}function a(t,e,r,n,i){r[0]=0,n[0]=-o,n[1]=+o;for(var a=1,s=0;a<i;a++){for(var l=(t[a]+a*a-(t[r[s]]+r[s]*r[s]))/(2*a-2*r[s]);l<=n[s];)s--,l=(t[a]+a*a-(t[r[s]]+r[s]*r[s]))/(2*a-2*r[s]);s++,r[s]=a,n[s]=l,n[s+1]=+o}for(a=0,s=0;a<i;a++){\n",
       "for(;n[s+1]<a;)s++;e[a]=(a-r[s])*(a-r[s])+t[r[s]]}}e.exports=n;var o=1e20;n.prototype.draw=function(t){this.ctx.clearRect(0,0,this.size,this.size),this.ctx.fillText(t,this.buffer,this.middle);for(var e=this.ctx.getImageData(0,0,this.size,this.size),r=e.data,n=0;n<this.size*this.size;n++){var a=r[4*n+3]/255;this.gridOuter[n]=1===a?0:0===a?o:Math.pow(Math.max(0,.5-a),2),this.gridInner[n]=1===a?o:0===a?0:Math.pow(Math.max(0,a-.5),2)}for(i(this.gridOuter,this.size,this.size,this.f,this.d,this.v,this.z),i(this.gridInner,this.size,this.size,this.f,this.d,this.v,this.z),n=0;n<this.size*this.size;n++){var s=this.gridOuter[n]-this.gridInner[n],l=Math.max(0,Math.min(255,Math.round(255-255*(s/this.radius+this.cutoff))));r[4*n+0]=l,r[4*n+1]=l,r[4*n+2]=l,r[4*n+3]=255}return e}},{}],533:[function(e,r,n){!function(e){function n(t,e){if(t=t||\"\",e=e||{},t instanceof n)return t;if(!(this instanceof n))return new n(t,e);var r=i(t);this._originalInput=t,this._r=r.r,this._g=r.g,this._b=r.b,this._a=r.a,this._roundA=V(100*this._a)/100,this._format=e.format||r.format,this._gradientType=e.gradientType,this._r<1&&(this._r=V(this._r)),this._g<1&&(this._g=V(this._g)),this._b<1&&(this._b=V(this._b)),this._ok=r.ok,this._tc_id=U++}function i(t){var e={r:0,g:0,b:0},r=1,n=null,i=null,o=null,l=!1,c=!1;return\"string\"==typeof t&&(t=F(t)),\"object\"==typeof t&&(R(t.r)&&R(t.g)&&R(t.b)?(e=a(t.r,t.g,t.b),l=!0,c=\"%\"===String(t.r).substr(-1)?\"prgb\":\"rgb\"):R(t.h)&&R(t.s)&&R(t.v)?(n=D(t.s),i=D(t.v),e=u(t.h,n,i),l=!0,c=\"hsv\"):R(t.h)&&R(t.s)&&R(t.l)&&(n=D(t.s),o=D(t.l),e=s(t.h,n,o),l=!0,c=\"hsl\"),t.hasOwnProperty(\"a\")&&(r=t.a)),r=T(r),{ok:l,format:t.format||c,r:H(255,q(e.r,0)),g:H(255,q(e.g,0)),b:H(255,q(e.b,0)),a:r}}function a(t,e,r){return{r:255*S(t,255),g:255*S(e,255),b:255*S(r,255)}}function o(t,e,r){t=S(t,255),e=S(e,255),r=S(r,255);var n,i,a=q(t,e,r),o=H(t,e,r),s=(a+o)/2;if(a==o)n=i=0;else{var l=a-o;switch(i=s>.5?l/(2-a-o):l/(a+o),a){case t:n=(e-r)/l+(e<r?6:0);break;case e:n=(r-t)/l+2;break;case r:n=(t-e)/l+4}n/=6}return{h:n,s:i,l:s}}function s(t,e,r){function n(t,e,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?t+6*(e-t)*r:r<.5?e:r<2/3?t+(e-t)*(2/3-r)*6:t}var i,a,o;if(t=S(t,360),e=S(e,100),r=S(r,100),0===e)i=a=o=r;else{var s=r<.5?r*(1+e):r+e-r*e,l=2*r-s;i=n(l,s,t+1/3),a=n(l,s,t),o=n(l,s,t-1/3)}return{r:255*i,g:255*a,b:255*o}}function l(t,e,r){t=S(t,255),e=S(e,255),r=S(r,255);var n,i,a=q(t,e,r),o=H(t,e,r),s=a,l=a-o;if(i=0===a?0:l/a,a==o)n=0;else{switch(a){case t:n=(e-r)/l+(e<r?6:0);break;case e:n=(r-t)/l+2;break;case r:n=(t-e)/l+4}n/=6}return{h:n,s:i,v:s}}function u(t,r,n){t=6*S(t,360),r=S(r,100),n=S(n,100);var i=e.floor(t),a=t-i,o=n*(1-r),s=n*(1-a*r),l=n*(1-(1-a)*r),u=i%6;return{r:255*[n,s,o,o,l,n][u],g:255*[l,n,n,s,o,o][u],b:255*[o,o,l,n,n,s][u]}}function c(t,e,r,n){var i=[I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16))];return n&&i[0].charAt(0)==i[0].charAt(1)&&i[1].charAt(0)==i[1].charAt(1)&&i[2].charAt(0)==i[2].charAt(1)?i[0].charAt(0)+i[1].charAt(0)+i[2].charAt(0):i.join(\"\")}function h(t,e,r,n,i){var a=[I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16)),I(P(n))];return i&&a[0].charAt(0)==a[0].charAt(1)&&a[1].charAt(0)==a[1].charAt(1)&&a[2].charAt(0)==a[2].charAt(1)&&a[3].charAt(0)==a[3].charAt(1)?a[0].charAt(0)+a[1].charAt(0)+a[2].charAt(0)+a[3].charAt(0):a.join(\"\")}function f(t,e,r,n){return[I(P(n)),I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16))].join(\"\")}function d(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.s-=e/100,r.s=E(r.s),n(r)}function p(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.s+=e/100,r.s=E(r.s),n(r)}function m(t){return n(t).desaturate(100)}function v(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.l+=e/100,r.l=E(r.l),n(r)}function g(t,e){e=0===e?0:e||10;var r=n(t).toRgb();return r.r=q(0,H(255,r.r-V(-e/100*255))),r.g=q(0,H(255,r.g-V(-e/100*255))),r.b=q(0,H(255,r.b-V(-e/100*255))),n(r)}function y(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.l-=e/100,r.l=E(r.l),n(r)}function b(t,e){var r=n(t).toHsl(),i=(r.h+e)%360;return r.h=i<0?360+i:i,n(r)}function x(t){var e=n(t).toHsl();return e.h=(e.h+180)%360,n(e)}function _(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+120)%360,s:e.s,l:e.l}),n({h:(r+240)%360,s:e.s,l:e.l})]}function w(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+90)%360,s:e.s,l:e.l}),n({h:(r+180)%360,s:e.s,l:e.l}),n({h:(r+270)%360,s:e.s,l:e.l})]}function M(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+72)%360,s:e.s,l:e.l}),n({h:(r+216)%360,s:e.s,l:e.l})]}function k(t,e,r){e=e||6,r=r||30;var i=n(t).toHsl(),a=360/r,o=[n(t)];for(i.h=(i.h-(a*e>>1)+720)%360;--e;)i.h=(i.h+a)%360,o.push(n(i));return o}function A(t,e){e=e||6;for(var r=n(t).toHsv(),i=r.h,a=r.s,o=r.v,s=[],l=1/e;e--;)s.push(n({h:i,s:a,v:o})),o=(o+l)%1;return s}function T(t){return t=parseFloat(t),(isNaN(t)||t<0||t>1)&&(t=1),t}function S(t,r){C(t)&&(t=\"100%\");var n=z(t);return t=H(r,q(0,parseFloat(t))),n&&(t=parseInt(t*r,10)/100),e.abs(t-r)<1e-6?1:t%r/parseFloat(r)}function E(t){return H(1,q(0,t))}function L(t){return parseInt(t,16)}function C(t){return\"string\"==typeof t&&-1!=t.indexOf(\".\")&&1===parseFloat(t)}function z(t){return\"string\"==typeof t&&-1!=t.indexOf(\"%\")}function I(t){return 1==t.length?\"0\"+t:\"\"+t}function D(t){return t<=1&&(t=100*t+\"%\"),t}function P(t){return e.round(255*parseFloat(t)).toString(16)}function O(t){return L(t)/255}function R(t){return!!W.CSS_UNIT.exec(t)}function F(t){t=t.replace(N,\"\").replace(B,\"\").toLowerCase();var e=!1;if(Y[t])t=Y[t],e=!0;else if(\"transparent\"==t)return{r:0,g:0,b:0,a:0,format:\"name\"};var r;return(r=W.rgb.exec(t))?{r:r[1],g:r[2],b:r[3]}:(r=W.rgba.exec(t))?{r:r[1],g:r[2],b:r[3],a:r[4]}:(r=W.hsl.exec(t))?{h:r[1],s:r[2],l:r[3]}:(r=W.hsla.exec(t))?{h:r[1],s:r[2],l:r[3],a:r[4]}:(r=W.hsv.exec(t))?{h:r[1],s:r[2],v:r[3]}:(r=W.hsva.exec(t))?{h:r[1],s:r[2],v:r[3],a:r[4]}:(r=W.hex8.exec(t))?{r:L(r[1]),g:L(r[2]),b:L(r[3]),a:O(r[4]),format:e?\"name\":\"hex8\"}:(r=W.hex6.exec(t))?{r:L(r[1]),g:L(r[2]),b:L(r[3]),format:e?\"name\":\"hex\"}:(r=W.hex4.exec(t))?{r:L(r[1]+\"\"+r[1]),g:L(r[2]+\"\"+r[2]),b:L(r[3]+\"\"+r[3]),a:O(r[4]+\"\"+r[4]),format:e?\"name\":\"hex8\"}:!!(r=W.hex3.exec(t))&&{r:L(r[1]+\"\"+r[1]),g:L(r[2]+\"\"+r[2]),b:L(r[3]+\"\"+r[3]),format:e?\"name\":\"hex\"}}function j(t){var e,r;return t=t||{level:\"AA\",size:\"small\"},e=(t.level||\"AA\").toUpperCase(),r=(t.size||\"small\").toLowerCase(),\"AA\"!==e&&\"AAA\"!==e&&(e=\"AA\"),\"small\"!==r&&\"large\"!==r&&(r=\"small\"),{level:e,size:r}}var N=/^\\s+/,B=/\\s+$/,U=0,V=e.round,H=e.min,q=e.max,G=e.random;n.prototype={isDark:function(){return this.getBrightness()<128},isLight:function(){return!this.isDark()},isValid:function(){return this._ok},getOriginalInput:function(){return this._originalInput},getFormat:function(){return this._format},getAlpha:function(){return this._a},getBrightness:function(){var t=this.toRgb();return(299*t.r+587*t.g+114*t.b)/1e3},getLuminance:function(){var t,r,n,i,a,o,s=this.toRgb();return t=s.r/255,r=s.g/255,n=s.b/255,i=t<=.03928?t/12.92:e.pow((t+.055)/1.055,2.4),a=r<=.03928?r/12.92:e.pow((r+.055)/1.055,2.4),o=n<=.03928?n/12.92:e.pow((n+.055)/1.055,2.4),.2126*i+.7152*a+.0722*o},setAlpha:function(t){return this._a=T(t),this._roundA=V(100*this._a)/100,this},toHsv:function(){var t=l(this._r,this._g,this._b);return{h:360*t.h,s:t.s,v:t.v,a:this._a}},toHsvString:function(){var t=l(this._r,this._g,this._b),e=V(360*t.h),r=V(100*t.s),n=V(100*t.v);return 1==this._a?\"hsv(\"+e+\", \"+r+\"%, \"+n+\"%)\":\"hsva(\"+e+\", \"+r+\"%, \"+n+\"%, \"+this._roundA+\")\"},toHsl:function(){var t=o(this._r,this._g,this._b);return{h:360*t.h,s:t.s,l:t.l,a:this._a}},toHslString:function(){var t=o(this._r,this._g,this._b),e=V(360*t.h),r=V(100*t.s),n=V(100*t.l);return 1==this._a?\"hsl(\"+e+\", \"+r+\"%, \"+n+\"%)\":\"hsla(\"+e+\", \"+r+\"%, \"+n+\"%, \"+this._roundA+\")\"},toHex:function(t){return c(this._r,this._g,this._b,t)},toHexString:function(t){return\"#\"+this.toHex(t)},toHex8:function(t){return h(this._r,this._g,this._b,this._a,t)},toHex8String:function(t){return\"#\"+this.toHex8(t)},toRgb:function(){return{r:V(this._r),g:V(this._g),b:V(this._b),a:this._a}},toRgbString:function(){return 1==this._a?\"rgb(\"+V(this._r)+\", \"+V(this._g)+\", \"+V(this._b)+\")\":\"rgba(\"+V(this._r)+\", \"+V(this._g)+\", \"+V(this._b)+\", \"+this._roundA+\")\"},toPercentageRgb:function(){return{r:V(100*S(this._r,255))+\"%\",g:V(100*S(this._g,255))+\"%\",b:V(100*S(this._b,255))+\"%\",a:this._a}},toPercentageRgbString:function(){return 1==this._a?\"rgb(\"+V(100*S(this._r,255))+\"%, \"+V(100*S(this._g,255))+\"%, \"+V(100*S(this._b,255))+\"%)\":\"rgba(\"+V(100*S(this._r,255))+\"%, \"+V(100*S(this._g,255))+\"%, \"+V(100*S(this._b,255))+\"%, \"+this._roundA+\")\"},toName:function(){return 0===this._a?\"transparent\":!(this._a<1)&&(X[c(this._r,this._g,this._b,!0)]||!1)},toFilter:function(t){var e=\"#\"+f(this._r,this._g,this._b,this._a),r=e,i=this._gradientType?\"GradientType = 1, \":\"\";if(t){var a=n(t);r=\"#\"+f(a._r,a._g,a._b,a._a)}return\"progid:DXImageTransform.Microsoft.gradient(\"+i+\"startColorstr=\"+e+\",endColorstr=\"+r+\")\"},toString:function(t){var e=!!t;t=t||this._format;var r=!1,n=this._a<1&&this._a>=0;return e||!n||\"hex\"!==t&&\"hex6\"!==t&&\"hex3\"!==t&&\"hex4\"!==t&&\"hex8\"!==t&&\"name\"!==t?(\"rgb\"===t&&(r=this.toRgbString()),\"prgb\"===t&&(r=this.toPercentageRgbString()),\"hex\"!==t&&\"hex6\"!==t||(r=this.toHexString()),\"hex3\"===t&&(r=this.toHexString(!0)),\"hex4\"===t&&(r=this.toHex8String(!0)),\"hex8\"===t&&(r=this.toHex8String()),\"name\"===t&&(r=this.toName()),\"hsl\"===t&&(r=this.toHslString()),\"hsv\"===t&&(r=this.toHsvString()),r||this.toHexString()):\"name\"===t&&0===this._a?this.toName():this.toRgbString()},clone:function(){return n(this.toString())},_applyModification:function(t,e){var r=t.apply(null,[this].concat([].slice.call(e)));return this._r=r._r,this._g=r._g,this._b=r._b,this.setAlpha(r._a),this},lighten:function(){return this._applyModification(v,arguments)},brighten:function(){return this._applyModification(g,arguments)},darken:function(){return this._applyModification(y,arguments)},desaturate:function(){return this._applyModification(d,arguments)},saturate:function(){return this._applyModification(p,arguments)},greyscale:function(){return this._applyModification(m,arguments)},spin:function(){return this._applyModification(b,arguments)},_applyCombination:function(t,e){return t.apply(null,[this].concat([].slice.call(e)))},analogous:function(){return this._applyCombination(k,arguments)},complement:function(){return this._applyCombination(x,arguments)},monochromatic:function(){return this._applyCombination(A,arguments)},splitcomplement:function(){return this._applyCombination(M,arguments)},triad:function(){return this._applyCombination(_,arguments)},tetrad:function(){return this._applyCombination(w,arguments)}},n.fromRatio=function(t,e){if(\"object\"==typeof t){var r={};for(var i in t)t.hasOwnProperty(i)&&(r[i]=\"a\"===i?t[i]:D(t[i]));t=r}return n(t,e)},n.equals=function(t,e){return!(!t||!e)&&n(t).toRgbString()==n(e).toRgbString()},n.random=function(){return n.fromRatio({r:G(),g:G(),b:G()})},n.mix=function(t,e,r){r=0===r?0:r||50;var i=n(t).toRgb(),a=n(e).toRgb(),o=r/100;return n({r:(a.r-i.r)*o+i.r,g:(a.g-i.g)*o+i.g,b:(a.b-i.b)*o+i.b,a:(a.a-i.a)*o+i.a})},n.readability=function(t,r){var i=n(t),a=n(r);return(e.max(i.getLuminance(),a.getLuminance())+.05)/(e.min(i.getLuminance(),a.getLuminance())+.05)},n.isReadable=function(t,e,r){var i,a,o=n.readability(t,e);switch(a=!1,i=j(r),i.level+i.size){case\"AAsmall\":case\"AAAlarge\":a=o>=4.5;break;case\"AAlarge\":a=o>=3;break;case\"AAAsmall\":a=o>=7}return a},n.mostReadable=function(t,e,r){var i,a,o,s,l=null,u=0;r=r||{},a=r.includeFallbackColors,o=r.level,s=r.size;for(var c=0;c<e.length;c++)(i=n.readability(t,e[c]))>u&&(u=i,l=n(e[c]));return n.isReadable(t,l,{level:o,size:s})||!a?l:(r.includeFallbackColors=!1,n.mostReadable(t,[\"#fff\",\"#000\"],r))};var Y=n.names={aliceblue:\"f0f8ff\",antiquewhite:\"faebd7\",aqua:\"0ff\",aquamarine:\"7fffd4\",azure:\"f0ffff\",beige:\"f5f5dc\",bisque:\"ffe4c4\",black:\"000\",blanchedalmond:\"ffebcd\",blue:\"00f\",blueviolet:\"8a2be2\",brown:\"a52a2a\",burlywood:\"deb887\",burntsienna:\"ea7e5d\",cadetblue:\"5f9ea0\",chartreuse:\"7fff00\",chocolate:\"d2691e\",coral:\"ff7f50\",cornflowerblue:\"6495ed\",cornsilk:\"fff8dc\",crimson:\"dc143c\",cyan:\"0ff\",darkblue:\"00008b\",darkcyan:\"008b8b\",darkgoldenrod:\"b8860b\",darkgray:\"a9a9a9\",darkgreen:\"006400\",darkgrey:\"a9a9a9\",darkkhaki:\"bdb76b\",darkmagenta:\"8b008b\",darkolivegreen:\"556b2f\",darkorange:\"ff8c00\",darkorchid:\"9932cc\",darkred:\"8b0000\",darksalmon:\"e9967a\",darkseagreen:\"8fbc8f\",darkslateblue:\"483d8b\",darkslategray:\"2f4f4f\",darkslategrey:\"2f4f4f\",darkturquoise:\"00ced1\",darkviolet:\"9400d3\",deeppink:\"ff1493\",deepskyblue:\"00bfff\",dimgray:\"696969\",dimgrey:\"696969\",dodgerblue:\"1e90ff\",firebrick:\"b22222\",floralwhite:\"fffaf0\",forestgreen:\"228b22\",fuchsia:\"f0f\",gainsboro:\"dcdcdc\",ghostwhite:\"f8f8ff\",gold:\"ffd700\",goldenrod:\"daa520\",gray:\"808080\",green:\"008000\",greenyellow:\"adff2f\",grey:\"808080\",honeydew:\"f0fff0\",hotpink:\"ff69b4\",indianred:\"cd5c5c\",indigo:\"4b0082\",ivory:\"fffff0\",khaki:\"f0e68c\",lavender:\"e6e6fa\",lavenderblush:\"fff0f5\",lawngreen:\"7cfc00\",lemonchiffon:\"fffacd\",lightblue:\"add8e6\",lightcoral:\"f08080\",lightcyan:\"e0ffff\",lightgoldenrodyellow:\"fafad2\",lightgray:\"d3d3d3\",lightgreen:\"90ee90\",lightgrey:\"d3d3d3\",lightpink:\"ffb6c1\",lightsalmon:\"ffa07a\",lightseagreen:\"20b2aa\",lightskyblue:\"87cefa\",lightslategray:\"789\",lightslategrey:\"789\",lightsteelblue:\"b0c4de\",lightyellow:\"ffffe0\",lime:\"0f0\",limegreen:\"32cd32\",linen:\"faf0e6\",magenta:\"f0f\",maroon:\"800000\",mediumaquamarine:\"66cdaa\",mediumblue:\"0000cd\",mediumorchid:\"ba55d3\",mediumpurple:\"9370db\",mediumseagreen:\"3cb371\",mediumslateblue:\"7b68ee\",mediumspringgreen:\"00fa9a\",mediumturquoise:\"48d1cc\",mediumvioletred:\"c71585\",midnightblue:\"191970\",mintcream:\"f5fffa\",mistyrose:\"ffe4e1\",moccasin:\"ffe4b5\",navajowhite:\"ffdead\",navy:\"000080\",oldlace:\"fdf5e6\",olive:\"808000\",olivedrab:\"6b8e23\",orange:\"ffa500\",orangered:\"ff4500\",orchid:\"da70d6\",palegoldenrod:\"eee8aa\",palegreen:\"98fb98\",paleturquoise:\"afeeee\",palevioletred:\"db7093\",papayawhip:\"ffefd5\",peachpuff:\"ffdab9\",peru:\"cd853f\",pink:\"ffc0cb\",plum:\"dda0dd\",powderblue:\"b0e0e6\",purple:\"800080\",rebeccapurple:\"663399\",red:\"f00\",rosybrown:\"bc8f8f\",royalblue:\"4169e1\",saddlebrown:\"8b4513\",salmon:\"fa8072\",sandybrown:\"f4a460\",seagreen:\"2e8b57\",seashell:\"fff5ee\",sienna:\"a0522d\",silver:\"c0c0c0\",skyblue:\"87ceeb\",slateblue:\"6a5acd\",slategray:\"708090\",slategrey:\"708090\",snow:\"fffafa\",springgreen:\"00ff7f\",steelblue:\"4682b4\",tan:\"d2b48c\",teal:\"008080\",thistle:\"d8bfd8\",tomato:\"ff6347\",turquoise:\"40e0d0\",violet:\"ee82ee\",wheat:\"f5deb3\",white:\"fff\",whitesmoke:\"f5f5f5\",yellow:\"ff0\",yellowgreen:\"9acd32\"},X=n.hexNames=function(t){var e={};for(var r in t)t.hasOwnProperty(r)&&(e[t[r]]=r);return e}(Y),W=function(){var t=\"(?:[-\\\\+]?\\\\d*\\\\.\\\\d+%?)|(?:[-\\\\+]?\\\\d+%?)\",e=\"[\\\\s|\\\\(]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")\\\\s*\\\\)?\",r=\"[\\\\s|\\\\(]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")\\\\s*\\\\)?\";return{CSS_UNIT:new RegExp(t),rgb:new RegExp(\"rgb\"+e),rgba:new RegExp(\"rgba\"+r),hsl:new RegExp(\"hsl\"+e),hsla:new RegExp(\"hsla\"+r),hsv:new RegExp(\"hsv\"+e),hsva:new RegExp(\"hsva\"+r),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,hex4:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex8:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/}}();void 0!==r&&r.exports?r.exports=n:\"function\"==typeof t&&t.amd?t(function(){return n}):window.tinycolor=n}(Math)},{}],534:[function(t,e,r){\"use strict\";function n(t,e){var r=o(getComputedStyle(t).getPropertyValue(e));return r[0]*a(r[1],t)}function i(t,e){var r=document.createElement(\"div\");r.style[\"font-size\"]=\"128\"+t,e.appendChild(r);var i=n(r,\"font-size\")/128;return e.removeChild(r),i}function a(t,e){switch(e=e||document.body,t=(t||\"px\").trim().toLowerCase(),e!==window&&e!==document||(e=document.body),t){case\"%\":return e.clientHeight/100;case\"ch\":case\"ex\":return i(t,e);case\"em\":return n(e,\"font-size\");case\"rem\":return n(document.body,\"font-size\");case\"vw\":return window.innerWidth/100;case\"vh\":return window.innerHeight/100;case\"vmin\":return Math.min(window.innerWidth,window.innerHeight)/100;case\"vmax\":return Math.max(window.innerWidth,window.innerHeight)/100;case\"in\":return s;case\"cm\":return s/2.54;case\"mm\":return s/25.4;case\"pt\":return s/72;case\"pc\":return s/6}return 1}var o=t(\"parse-unit\");e.exports=a;var s=96},{\"parse-unit\":474}],535:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.topojson=e.topojson||{})}(this,function(t){\"use strict\";function e(t,e){var n=e.id,i=e.bbox,a=null==e.properties?{}:e.properties,o=r(t,e);return null==n&&null==i?{type:\"Feature\",properties:a,geometry:o}:null==i?{type:\"Feature\",id:n,properties:a,geometry:o}:{type:\"Feature\",id:n,bbox:i,properties:a,geometry:o}}function r(t,e){function r(t,e){e.length&&e.pop();for(var r=h[t<0?~t:t],n=0,i=r.length;n<i;++n)e.push(u(r[n].slice(),n));t<0&&c(e,i)}function n(t){return u(t.slice())}function i(t){for(var e=[],n=0,i=t.length;n<i;++n)r(t[n],e);return e.length<2&&e.push(e[0].slice()),e}function a(t){for(var e=i(t);e.length<4;)e.push(e[0].slice());return e}function o(t){return t.map(a)}function s(t){var e,r=t.type;switch(r){case\"GeometryCollection\":return{type:r,geometries:t.geometries.map(s)};case\"Point\":e=n(t.coordinates);break;case\"MultiPoint\":e=t.coordinates.map(n);break;case\"LineString\":e=i(t.arcs);break;case\"MultiLineString\":e=t.arcs.map(i);break;case\"Polygon\":e=o(t.arcs);break;case\"MultiPolygon\":e=t.arcs.map(o);break;default:return null}return{type:r,coordinates:e}}var u=l(t),h=t.arcs;return s(e)}function n(t,e,r){var n,a,o;if(arguments.length>1)n=i(t,e,r);else for(a=0,n=new Array(o=t.arcs.length);a<o;++a)n[a]=a;return{type:\"MultiLineString\",arcs:f(t,n)}}function i(t,e,r){function n(t){var e=t<0?~t:t;(c[e]||(c[e]=[])).push({i:t,g:l})}function i(t){t.forEach(n)}function a(t){t.forEach(i)}function o(t){t.forEach(a)}function s(t){switch(l=t,t.type){case\"GeometryCollection\":t.geometries.forEach(s);break;case\"LineString\":i(t.arcs);break;case\"MultiLineString\":case\"Polygon\":a(t.arcs);break;case\"MultiPolygon\":o(t.arcs)}}var l,u=[],c=[];return s(e),c.forEach(null==r?function(t){u.push(t[0].i)}:function(t){r(t[0].g,t[t.length-1].g)&&u.push(t[0].i)}),u}function a(t){for(var e,r=-1,n=t.length,i=t[n-1],a=0;++r<n;)e=i,i=t[r],a+=e[0]*i[1]-e[1]*i[0];return Math.abs(a)}function o(t,e){function n(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(n);break;case\"Polygon\":i(t.arcs);break;case\"MultiPolygon\":t.arcs.forEach(i)}}function i(t){t.forEach(function(e){e.forEach(function(e){(s[e=e<0?~e:e]||(s[e]=[])).push(t)})}),l.push(t)}function o(e){return a(r(t,{type:\"Polygon\",arcs:[e]}).coordinates[0])}var s={},l=[],u=[];return e.forEach(n),l.forEach(function(t){if(!t._){var e=[],r=[t];for(t._=1,u.push(e);t=r.pop();)e.push(t),t.forEach(function(t){t.forEach(function(t){s[t<0?~t:t].forEach(function(t){t._||(t._=1,r.push(t))})})})}}),l.forEach(function(t){delete t._}),{type:\"MultiPolygon\",arcs:u.map(function(e){var r,n=[];if(e.forEach(function(t){t.forEach(function(t){t.forEach(function(t){s[t<0?~t:t].length<2&&n.push(t)})})}),n=f(t,n),(r=n.length)>1)for(var i,a,l=1,u=o(n[0]);l<r;++l)(i=o(n[l]))>u&&(a=n[0],n[0]=n[l],n[l]=a,u=i);return n})}}var s=function(t){return t},l=function(t){if(null==(e=t.transform))return s;var e,r,n,i=e.scale[0],a=e.scale[1],o=e.translate[0],l=e.translate[1];return function(t,e){return e||(r=n=0),t[0]=(r+=t[0])*i+o,t[1]=(n+=t[1])*a+l,t}},u=function(t){function e(t){s[0]=t[0],s[1]=t[1],o(s),s[0]<u&&(u=s[0]),s[0]>h&&(h=s[0]),s[1]<c&&(c=s[1]),s[1]>f&&(f=s[1])}function r(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(r);break;case\"Point\":e(t.coordinates);break;case\"MultiPoint\":t.coordinates.forEach(e)}}var n=t.bbox;if(!n){var i,a,o=l(t),s=new Array(2),u=1/0,c=u,h=-u,f=-u;t.arcs.forEach(function(t){for(var e=-1,r=t.length;++e<r;)i=t[e],s[0]=i[0],s[1]=i[1],o(s,e),s[0]<u&&(u=s[0]),s[0]>h&&(h=s[0]),s[1]<c&&(c=s[1]),s[1]>f&&(f=s[1])});for(a in t.objects)r(t.objects[a]);n=t.bbox=[u,c,h,f]}return n},c=function(t,e){for(var r,n=t.length,i=n-e;i<--n;)r=t[i],t[i++]=t[n],t[n]=r},h=function(t,r){return\"GeometryCollection\"===r.type?{type:\"FeatureCollection\",features:r.geometries.map(function(r){return e(t,r)})}:e(t,r)},f=function(t,e){function r(e){var r,n=t.arcs[e<0?~e:e],i=n[0];return t.transform?(r=[0,0],n.forEach(function(t){r[0]+=t[0],r[1]+=t[1]})):r=n[n.length-1],e<0?[r,i]:[i,r]}function n(t,e){for(var r in t){var n=t[r];delete e[n.start],delete n.start,delete n.end,n.forEach(function(t){i[t<0?~t:t]=1}),s.push(n)}}var i={},a={},o={},s=[],l=-1;return e.forEach(function(r,n){var i,a=t.arcs[r<0?~r:r];a.length<3&&!a[1][0]&&!a[1][1]&&(i=e[++l],e[l]=r,e[n]=i)}),e.forEach(function(t){var e,n,i=r(t),s=i[0],l=i[1];if(e=o[s])if(delete o[e.end],e.push(t),e.end=l,n=a[l]){delete a[n.start];var u=n===e?e:e.concat(n);a[u.start=e.start]=o[u.end=n.end]=u}else a[e.start]=o[e.end]=e;else if(e=a[l])if(delete a[e.start],e.unshift(t),e.start=s,n=o[s]){delete o[n.end];var c=n===e?e:n.concat(e);a[c.start=n.start]=o[c.end=e.end]=c}else a[e.start]=o[e.end]=e;else e=[t],a[e.start=s]=o[e.end=l]=e}),n(o,a),n(a,o),e.forEach(function(t){i[t<0?~t:t]||s.push([t])}),s},d=function(t){return r(t,n.apply(this,arguments))},p=function(t){return r(t,o.apply(this,arguments))},m=function(t,e){for(var r=0,n=t.length;r<n;){var i=r+n>>>1;t[i]<e?r=i+1:n=i}return r},v=function(t){function e(t,e){t.forEach(function(t){t<0&&(t=~t);var r=i[t];r?r.push(e):i[t]=[e]})}function r(t,r){t.forEach(function(t){e(t,r)})}function n(t,e){\"GeometryCollection\"===t.type?t.geometries.forEach(function(t){n(t,e)}):t.type in o&&o[t.type](t.arcs,e)}var i={},a=t.map(function(){return[]}),o={LineString:e,MultiLineString:r,Polygon:r,MultiPolygon:function(t,e){t.forEach(function(t){r(t,e)})}};t.forEach(n);for(var s in i)for(var l=i[s],u=l.length,c=0;c<u;++c)for(var h=c+1;h<u;++h){var f,d=l[c],p=l[h];(f=a[d])[s=m(f,p)]!==p&&f.splice(s,0,p),(f=a[p])[s=m(f,d)]!==d&&f.splice(s,0,d)}return a},g=function(t,e){function r(t){t[0]=Math.round((t[0]-o)/s),t[1]=Math.round((t[1]-l)/c)}function n(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(n);break;case\"Point\":r(t.coordinates);break;case\"MultiPoint\":t.coordinates.forEach(r)}}if(!((e=Math.floor(e))>=2))throw new Error(\"n must be \\u22652\");if(t.transform)throw new Error(\"already quantized\");var i,a=u(t),o=a[0],s=(a[2]-o)/(e-1)||1,l=a[1],c=(a[3]-l)/(e-1)||1;t.arcs.forEach(function(t){for(var e,r,n,i=1,a=1,u=t.length,h=t[0],f=h[0]=Math.round((h[0]-o)/s),d=h[1]=Math.round((h[1]-l)/c);i<u;++i)h=t[i],r=Math.round((h[0]-o)/s),n=Math.round((h[1]-l)/c),r===f&&n===d||(e=t[a++],e[0]=r-f,f=r,e[1]=n-d,d=n);a<2&&(e=t[a++],e[0]=0,e[1]=0),t.length=a});for(i in t.objects)n(t.objects[i]);return t.transform={scale:[s,c],translate:[o,l]},t},y=function(t){if(null==(e=t.transform))return s;var e,r,n,i=e.scale[0],a=e.scale[1],o=e.translate[0],l=e.translate[1];return function(t,e){e||(r=n=0);var s=Math.round((t[0]-o)/i),u=Math.round((t[1]-l)/a);return t[0]=s-r,r=s,t[1]=u-n,n=u,t}};t.bbox=u,t.feature=h,t.mesh=d,t.meshArcs=n,t.merge=p,t.mergeArcs=o,t.neighbors=v,t.quantize=g,t.transform=l,t.untransform=y,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],536:[function(t,e,r){\"use strict\";function n(t){if(t<0)return[];if(0===t)return[[0]];for(var e=0|Math.round(o(t+1)),r=[],n=0;n<e;++n){for(var s=i.unrank(t,n),l=[0],u=0,c=0;c<s.length;++c)u+=1<<s[c],l.push(u);a(s)<1&&(l[0]=u,l[t]=0),r.push(l)}return r}e.exports=n;var i=t(\"permutation-rank\"),a=t(\"permutation-parity\"),o=t(\"gamma\")},{gamma:135,\"permutation-parity\":478,\"permutation-rank\":479}],537:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2))}function i(t){return Math.min(1,Math.max(-1,t))}function a(t){var e=Math.abs(t[0]),r=Math.abs(t[1]),n=Math.abs(t[2]),i=[0,0,0];e>Math.max(r,n)?i[2]=1:r>Math.max(e,n)?i[0]=1:i[1]=1;for(var a=0,o=0,s=0;s<3;++s)a+=t[s]*t[s],o+=i[s]*t[s];for(var s=0;s<3;++s)i[s]-=o/a*t[s];return f(i,i),i}function o(t,e,r,n,i,a,o,s){this.center=l(r),this.up=l(n),this.right=l(i),this.radius=l([a]),this.angle=l([o,s]),this.angle.bounds=[[-1/0,-Math.PI/2],[1/0,Math.PI/2]],this.setDistanceLimits(t,e),this.computedCenter=this.center.curve(0),this.computedUp=this.up.curve(0),this.computedRight=this.right.curve(0),this.computedRadius=this.radius.curve(0),this.computedAngle=this.angle.curve(0),this.computedToward=[0,0,0],this.computedEye=[0,0,0],this.computedMatrix=new Array(16);for(var u=0;u<16;++u)this.computedMatrix[u]=.5;this.recalcMatrix(0)}function s(t){t=t||{};var e=t.center||[0,0,0],r=t.up||[0,1,0],i=t.right||a(r),s=t.radius||1,l=t.theta||0,u=t.phi||0;if(e=[].slice.call(e,0,3),r=[].slice.call(r,0,3),f(r,r),i=[].slice.call(i,0,3),f(i,i),\"eye\"in t){var c=t.eye,p=[c[0]-e[0],c[1]-e[1],c[2]-e[2]];h(i,p,r),n(i[0],i[1],i[2])<1e-6?i=a(r):f(i,i),s=n(p[0],p[1],p[2]);var m=d(r,p)/s,v=d(i,p)/s;u=Math.acos(m),l=Math.acos(v)}return s=Math.log(s),new o(t.zoomMin,t.zoomMax,e,r,i,s,l,u)}e.exports=s;var l=t(\"filtered-vector\"),u=t(\"gl-mat4/invert\"),c=t(\"gl-mat4/rotate\"),h=t(\"gl-vec3/cross\"),f=t(\"gl-vec3/normalize\"),d=t(\"gl-vec3/dot\"),p=o.prototype;p.setDistanceLimits=function(t,e){t=t>0?Math.log(t):-1/0,e=e>0?Math.log(e):1/0,e=Math.max(e,t),this.radius.bounds[0][0]=t,this.radius.bounds[1][0]=e},p.getDistanceLimits=function(t){var e=this.radius.bounds[0];return t?(t[0]=Math.exp(e[0][0]),t[1]=Math.exp(e[1][0]),t):[Math.exp(e[0][0]),Math.exp(e[1][0])]},p.recalcMatrix=function(t){this.center.curve(t),this.up.curve(t),this.right.curve(t),this.radius.curve(t),this.angle.curve(t);for(var e=this.computedUp,r=this.computedRight,i=0,a=0,o=0;o<3;++o)a+=e[o]*r[o],i+=e[o]*e[o];for(var s=Math.sqrt(i),l=0,o=0;o<3;++o)r[o]-=e[o]*a/i,l+=r[o]*r[o],e[o]/=s;for(var u=Math.sqrt(l),o=0;o<3;++o)r[o]/=u;var c=this.computedToward;h(c,e,r),f(c,c);for(var d=Math.exp(this.computedRadius[0]),p=this.computedAngle[0],m=this.computedAngle[1],v=Math.cos(p),g=Math.sin(p),y=Math.cos(m),b=Math.sin(m),x=this.computedCenter,_=v*y,w=g*y,M=b,k=-v*b,A=-g*b,T=y,S=this.computedEye,E=this.computedMatrix,o=0;o<3;++o){var L=_*r[o]+w*c[o]+M*e[o];E[4*o+1]=k*r[o]+A*c[o]+T*e[o],E[4*o+2]=L,E[4*o+3]=0}var C=E[1],z=E[5],I=E[9],D=E[2],P=E[6],O=E[10],R=z*O-I*P,F=I*D-C*O,j=C*P-z*D,N=n(R,F,j);R/=N,F/=N,j/=N,E[0]=R,E[4]=F,E[8]=j;for(var o=0;o<3;++o)S[o]=x[o]+E[2+4*o]*d;for(var o=0;o<3;++o){for(var l=0,B=0;B<3;++B)l+=E[o+4*B]*S[B];E[12+o]=-l}E[15]=1},p.getMatrix=function(t,e){this.recalcMatrix(t);var r=this.computedMatrix;if(e){for(var n=0;n<16;++n)e[n]=r[n];return e}return r};var m=[0,0,0];p.rotate=function(t,e,r,n){if(this.angle.move(t,e,r),n){this.recalcMatrix(t);var i=this.computedMatrix;m[0]=i[2],m[1]=i[6],m[2]=i[10];for(var a=this.computedUp,o=this.computedRight,s=this.computedToward,l=0;l<3;++l)i[4*l]=a[l],i[4*l+1]=o[l],i[4*l+2]=s[l];c(i,i,n,m);for(var l=0;l<3;++l)a[l]=i[4*l],o[l]=i[4*l+1];this.up.set(t,a[0],a[1],a[2]),this.right.set(t,o[0],o[1],o[2])}},p.pan=function(t,e,r,i){e=e||0,r=r||0,i=i||0,this.recalcMatrix(t);var a=this.computedMatrix,o=(Math.exp(this.computedRadius[0]),a[1]),s=a[5],l=a[9],u=n(o,s,l);o/=u,s/=u,l/=u;var c=a[0],h=a[4],f=a[8],d=c*o+h*s+f*l;c-=o*d,h-=s*d,f-=l*d;var p=n(c,h,f);c/=p,h/=p,f/=p;var m=c*e+o*r,v=h*e+s*r,g=f*e+l*r;this.center.move(t,m,v,g);var y=Math.exp(this.computedRadius[0]);y=Math.max(1e-4,y+i),this.radius.set(t,Math.log(y))},p.translate=function(t,e,r,n){this.center.move(t,e||0,r||0,n||0)},p.setMatrix=function(t,e,r,a){var o=1;\"number\"==typeof r&&(o=0|r),(o<0||o>3)&&(o=1);var s=(o+2)%3;e||(this.recalcMatrix(t),e=this.computedMatrix);var l=e[o],c=e[o+4],h=e[o+8];if(a){var f=Math.abs(l),d=Math.abs(c),p=Math.abs(h),m=Math.max(f,d,p);f===m?(l=l<0?-1:1,c=h=0):p===m?(h=h<0?-1:1,l=c=0):(c=c<0?-1:1,l=h=0)}else{var v=n(l,c,h);l/=v,c/=v,h/=v}var g=e[s],y=e[s+4],b=e[s+8],x=g*l+y*c+b*h;g-=l*x,y-=c*x,b-=h*x;var _=n(g,y,b);g/=_,y/=_,b/=_;var w=c*b-h*y,M=h*g-l*b,k=l*y-c*g,A=n(w,M,k);w/=A,M/=A,k/=A,this.center.jump(t,q,G,Y),this.radius.idle(t),this.up.jump(t,l,c,h),this.right.jump(t,g,y,b);var T,S;if(2===o){var E=e[1],L=e[5],C=e[9],z=E*g+L*y+C*b,I=E*w+L*M+C*k;T=R<0?-Math.PI/2:Math.PI/2,S=Math.atan2(I,z)}else{var D=e[2],P=e[6],O=e[10],R=D*l+P*c+O*h,F=D*g+P*y+O*b,j=D*w+P*M+O*k;T=Math.asin(i(R)),S=Math.atan2(j,F)}this.angle.jump(t,S,T),this.recalcMatrix(t);var N=e[2],B=e[6],U=e[10],V=this.computedMatrix;u(V,e);var H=V[15],q=V[12]/H,G=V[13]/H,Y=V[14]/H,X=Math.exp(this.computedRadius[0]);this.center.jump(t,q-N*X,G-B*X,Y-U*X)},p.lastT=function(){return Math.max(this.center.lastT(),this.up.lastT(),this.right.lastT(),this.radius.lastT(),this.angle.lastT())},p.idle=function(t){this.center.idle(t),this.up.idle(t),this.right.idle(t),this.radius.idle(t),this.angle.idle(t)},p.flush=function(t){this.center.flush(t),this.up.flush(t),this.right.flush(t),this.radius.flush(t),this.angle.flush(t)},p.setDistance=function(t,e){e>0&&this.radius.set(t,Math.log(e))},p.lookAt=function(t,e,r,a){this.recalcMatrix(t),e=e||this.computedEye,r=r||this.computedCenter,a=a||this.computedUp;var o=a[0],s=a[1],l=a[2],u=n(o,s,l);if(!(u<1e-6)){o/=u,s/=u,l/=u;var c=e[0]-r[0],h=e[1]-r[1],f=e[2]-r[2],d=n(c,h,f);if(!(d<1e-6)){c/=d,h/=d,f/=d;var p=this.computedRight,m=p[0],v=p[1],g=p[2],y=o*m+s*v+l*g;m-=y*o,v-=y*s,g-=y*l;var b=n(m,v,g);if(!(b<.01&&(m=s*f-l*h,v=l*c-o*f,g=o*h-s*c,(b=n(m,v,g))<1e-6))){m/=b,v/=b,g/=b,this.up.set(t,o,s,l),this.right.set(t,m,v,g),this.center.set(t,r[0],r[1],r[2]),this.radius.set(t,Math.log(d));var x=s*g-l*v,_=l*m-o*g,w=o*v-s*m,M=n(x,_,w);x/=M,_/=M,w/=M;var k=o*c+s*h+l*f,A=m*c+v*h+g*f,T=x*c+_*h+w*f,S=Math.asin(i(k)),E=Math.atan2(T,A),L=this.angle._state,C=L[L.length-1],z=L[L.length-2];C%=2*Math.PI;var I=Math.abs(C+2*Math.PI-E),D=Math.abs(C-E),P=Math.abs(C-2*Math.PI-E);I<D&&(C+=2*Math.PI),P<D&&(C-=2*Math.PI),this.angle.jump(this.angle.lastT(),C,z),this.angle.set(t,E,S)}}}}},{\"filtered-vector\":132,\"gl-mat4/invert\":180,\"gl-mat4/rotate\":184,\"gl-vec3/cross\":271,\"gl-vec3/dot\":272,\"gl-vec3/normalize\":275}],538:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t*e,a=i*t,o=a-t,s=a-o,l=t-s,u=i*e,c=u-e,h=u-c,f=e-h,d=n-s*h,p=d-l*h,m=p-s*f,v=l*f-m;return r?(r[0]=v,r[1]=n,r):[v,n]}e.exports=n;var i=+(Math.pow(2,27)+1)},{}],539:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t+e,i=n-t,a=n-i,o=e-i,s=t-a;return r?(r[0]=s+o,r[1]=n,r):[s+o,n]}e.exports=n},{}],540:[function(t,e,r){(function(e,n){\"use strict\";function i(t){if(t){var e=t.length||t.byteLength,r=y.log2(e);w[r].push(t)}}function a(t){i(t.buffer)}function o(t){var t=y.nextPow2(t),e=y.log2(t),r=w[e];return r.length>0?r.pop():new ArrayBuffer(t)}function s(t){return new Uint8Array(o(t),0,t)}function l(t){return new Uint16Array(o(2*t),0,t)}function u(t){return new Uint32Array(o(4*t),0,t)}function c(t){return new Int8Array(o(t),0,t)}function h(t){return new Int16Array(o(2*t),0,t)}function f(t){return new Int32Array(o(4*t),0,t)}function d(t){return new Float32Array(o(4*t),0,t)}function p(t){return new Float64Array(o(8*t),0,t)}function m(t){return x?new Uint8ClampedArray(o(t),0,t):s(t)}function v(t){return new DataView(o(t),0,t)}function g(t){t=y.nextPow2(t);var e=y.log2(t),r=M[e];return r.length>0?r.pop():new n(t)}var y=t(\"bit-twiddle\"),b=t(\"dup\");e.__TYPEDARRAY_POOL||(e.__TYPEDARRAY_POOL={UINT8:b([32,0]),UINT16:b([32,0]),UINT32:b([32,0]),INT8:b([32,0]),INT16:b([32,0]),INT32:b([32,0]),FLOAT:b([32,0]),DOUBLE:b([32,0]),DATA:b([32,0]),UINT8C:b([32,0]),BUFFER:b([32,0])});var x=\"undefined\"!=typeof Uint8ClampedArray,_=e.__TYPEDARRAY_POOL;_.UINT8C||(_.UINT8C=b([32,0])),_.BUFFER||(_.BUFFER=b([32,0]));var w=_.DATA,M=_.BUFFER;r.free=function(t){if(n.isBuffer(t))M[y.log2(t.length)].push(t);else{if(\"[object ArrayBuffer]\"!==Object.prototype.toString.call(t)&&(t=t.buffer),!t)return;var e=t.length||t.byteLength,r=0|y.log2(e);w[r].push(t)}},r.freeUint8=r.freeUint16=r.freeUint32=r.freeInt8=r.freeInt16=r.freeInt32=r.freeFloat32=r.freeFloat=r.freeFloat64=r.freeDouble=r.freeUint8Clamped=r.freeDataView=a,r.freeArrayBuffer=i,r.freeBuffer=function(t){M[y.log2(t.length)].push(t)},r.malloc=function(t,e){\n",
       "if(void 0===e||\"arraybuffer\"===e)return o(t);switch(e){case\"uint8\":return s(t);case\"uint16\":return l(t);case\"uint32\":return u(t);case\"int8\":return c(t);case\"int16\":return h(t);case\"int32\":return f(t);case\"float\":case\"float32\":return d(t);case\"double\":case\"float64\":return p(t);case\"uint8_clamped\":return m(t);case\"buffer\":return g(t);case\"data\":case\"dataview\":return v(t);default:return null}return null},r.mallocArrayBuffer=o,r.mallocUint8=s,r.mallocUint16=l,r.mallocUint32=u,r.mallocInt8=c,r.mallocInt16=h,r.mallocInt32=f,r.mallocFloat32=r.mallocFloat=d,r.mallocFloat64=r.mallocDouble=p,r.mallocUint8Clamped=m,r.mallocDataView=v,r.mallocBuffer=g,r.clearCache=function(){for(var t=0;t<32;++t)_.UINT8[t].length=0,_.UINT16[t].length=0,_.UINT32[t].length=0,_.INT8[t].length=0,_.INT16[t].length=0,_.INT32[t].length=0,_.FLOAT[t].length=0,_.DOUBLE[t].length=0,_.UINT8C[t].length=0,w[t].length=0,M[t].length=0}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{},t(\"buffer\").Buffer)},{\"bit-twiddle\":66,buffer:76,dup:124}],541:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n;var i=n.prototype;Object.defineProperty(i,\"length\",{get:function(){return this.roots.length}}),i.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},i.find=function(t){for(var e=t,r=this.roots;r[t]!==t;)t=r[t];for(;r[e]!==t;){var n=r[e];r[e]=t,e=n}return t},i.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],542:[function(t,e,r){\"use strict\";function n(t,e){for(var r=1,n=t.length,i=t[0],a=t[0],o=1;o<n;++o)if(a=i,i=t[o],e(i,a)){if(o===r){r++;continue}t[r++]=i}return t.length=r,t}function i(t){for(var e=1,r=t.length,n=t[0],i=t[0],a=1;a<r;++a,i=n)if(i=n,(n=t[a])!==i){if(a===e){e++;continue}t[e++]=n}return t.length=e,t}function a(t,e,r){return 0===t.length?t:e?(r||t.sort(e),n(t,e)):(r||t.sort(),i(t))}e.exports=a},{}],543:[function(t,e,r){function n(t,e,r,n){this.cx=3*t,this.bx=3*(r-t)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*e,this.by=3*(n-e)-this.cy,this.ay=1-this.cy-this.by,this.p1x=t,this.p1y=n,this.p2x=r,this.p2y=n}e.exports=n,n.prototype.sampleCurveX=function(t){return((this.ax*t+this.bx)*t+this.cx)*t},n.prototype.sampleCurveY=function(t){return((this.ay*t+this.by)*t+this.cy)*t},n.prototype.sampleCurveDerivativeX=function(t){return(3*this.ax*t+2*this.bx)*t+this.cx},n.prototype.solveCurveX=function(t,e){void 0===e&&(e=1e-6);var r,n,i,a,o;for(i=t,o=0;o<8;o++){if(a=this.sampleCurveX(i)-t,Math.abs(a)<e)return i;var s=this.sampleCurveDerivativeX(i);if(Math.abs(s)<1e-6)break;i-=a/s}if(r=0,n=1,(i=t)<r)return r;if(i>n)return n;for(;r<n;){if(a=this.sampleCurveX(i),Math.abs(a-t)<e)return i;t>a?r=i:n=i,i=.5*(n-r)+r}return i},n.prototype.solve=function(t,e){return this.sampleCurveY(this.solveCurveX(t,e))}},{}],544:[function(t,e,r){\"use strict\";function n(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function i(t,e,r){if(t&&u.isObject(t)&&t instanceof n)return t;var i=new n;return i.parse(t,e,r),i}function a(t){return u.isString(t)&&(t=i(t)),t instanceof n?t.format():n.prototype.format.call(t)}function o(t,e){return i(t,!1,!0).resolve(e)}function s(t,e){return t?i(t,!1,!0).resolveObject(e):e}var l=t(\"punycode\"),u=t(\"./util\");r.parse=i,r.resolve=o,r.resolveObject=s,r.format=a,r.Url=n;var c=/^([a-z0-9.+-]+:)/i,h=/:[0-9]*$/,f=/^(\\/\\/?(?!\\/)[^\\?\\s]*)(\\?[^\\s]*)?$/,d=[\"<\",\">\",'\"',\"`\",\" \",\"\\r\",\"\\n\",\"\\t\"],p=[\"{\",\"}\",\"|\",\"\\\\\",\"^\",\"`\"].concat(d),m=[\"'\"].concat(p),v=[\"%\",\"/\",\"?\",\";\",\"#\"].concat(m),g=[\"/\",\"?\",\"#\"],y=/^[+a-z0-9A-Z_-]{0,63}$/,b=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,x={javascript:!0,\"javascript:\":!0},_={javascript:!0,\"javascript:\":!0},w={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,\"http:\":!0,\"https:\":!0,\"ftp:\":!0,\"gopher:\":!0,\"file:\":!0},M=t(\"querystring\");n.prototype.parse=function(t,e,r){if(!u.isString(t))throw new TypeError(\"Parameter 'url' must be a string, not \"+typeof t);var n=t.indexOf(\"?\"),i=-1!==n&&n<t.indexOf(\"#\")?\"?\":\"#\",a=t.split(i),o=/\\\\/g;a[0]=a[0].replace(o,\"/\"),t=a.join(i);var s=t;if(s=s.trim(),!r&&1===t.split(\"#\").length){var h=f.exec(s);if(h)return this.path=s,this.href=s,this.pathname=h[1],h[2]?(this.search=h[2],this.query=e?M.parse(this.search.substr(1)):this.search.substr(1)):e&&(this.search=\"\",this.query={}),this}var d=c.exec(s);if(d){d=d[0];var p=d.toLowerCase();this.protocol=p,s=s.substr(d.length)}if(r||d||s.match(/^\\/\\/[^@\\/]+@[^@\\/]+/)){var k=\"//\"===s.substr(0,2);!k||d&&_[d]||(s=s.substr(2),this.slashes=!0)}if(!_[d]&&(k||d&&!w[d])){for(var A=-1,T=0;T<g.length;T++){var S=s.indexOf(g[T]);-1!==S&&(-1===A||S<A)&&(A=S)}var E,L;L=-1===A?s.lastIndexOf(\"@\"):s.lastIndexOf(\"@\",A),-1!==L&&(E=s.slice(0,L),s=s.slice(L+1),this.auth=decodeURIComponent(E)),A=-1;for(var T=0;T<v.length;T++){var S=s.indexOf(v[T]);-1!==S&&(-1===A||S<A)&&(A=S)}-1===A&&(A=s.length),this.host=s.slice(0,A),s=s.slice(A),this.parseHost(),this.hostname=this.hostname||\"\";var C=\"[\"===this.hostname[0]&&\"]\"===this.hostname[this.hostname.length-1];if(!C)for(var z=this.hostname.split(/\\./),T=0,I=z.length;T<I;T++){var D=z[T];if(D&&!D.match(y)){for(var P=\"\",O=0,R=D.length;O<R;O++)D.charCodeAt(O)>127?P+=\"x\":P+=D[O];if(!P.match(y)){var F=z.slice(0,T),j=z.slice(T+1),N=D.match(b);N&&(F.push(N[1]),j.unshift(N[2])),j.length&&(s=\"/\"+j.join(\".\")+s),this.hostname=F.join(\".\");break}}}this.hostname.length>255?this.hostname=\"\":this.hostname=this.hostname.toLowerCase(),C||(this.hostname=l.toASCII(this.hostname));var B=this.port?\":\"+this.port:\"\",U=this.hostname||\"\";this.host=U+B,this.href+=this.host,C&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),\"/\"!==s[0]&&(s=\"/\"+s))}if(!x[p])for(var T=0,I=m.length;T<I;T++){var V=m[T];if(-1!==s.indexOf(V)){var H=encodeURIComponent(V);H===V&&(H=escape(V)),s=s.split(V).join(H)}}var q=s.indexOf(\"#\");-1!==q&&(this.hash=s.substr(q),s=s.slice(0,q));var G=s.indexOf(\"?\");if(-1!==G?(this.search=s.substr(G),this.query=s.substr(G+1),e&&(this.query=M.parse(this.query)),s=s.slice(0,G)):e&&(this.search=\"\",this.query={}),s&&(this.pathname=s),w[p]&&this.hostname&&!this.pathname&&(this.pathname=\"/\"),this.pathname||this.search){var B=this.pathname||\"\",Y=this.search||\"\";this.path=B+Y}return this.href=this.format(),this},n.prototype.format=function(){var t=this.auth||\"\";t&&(t=encodeURIComponent(t),t=t.replace(/%3A/i,\":\"),t+=\"@\");var e=this.protocol||\"\",r=this.pathname||\"\",n=this.hash||\"\",i=!1,a=\"\";this.host?i=t+this.host:this.hostname&&(i=t+(-1===this.hostname.indexOf(\":\")?this.hostname:\"[\"+this.hostname+\"]\"),this.port&&(i+=\":\"+this.port)),this.query&&u.isObject(this.query)&&Object.keys(this.query).length&&(a=M.stringify(this.query));var o=this.search||a&&\"?\"+a||\"\";return e&&\":\"!==e.substr(-1)&&(e+=\":\"),this.slashes||(!e||w[e])&&!1!==i?(i=\"//\"+(i||\"\"),r&&\"/\"!==r.charAt(0)&&(r=\"/\"+r)):i||(i=\"\"),n&&\"#\"!==n.charAt(0)&&(n=\"#\"+n),o&&\"?\"!==o.charAt(0)&&(o=\"?\"+o),r=r.replace(/[?#]/g,function(t){return encodeURIComponent(t)}),o=o.replace(\"#\",\"%23\"),e+i+r+o+n},n.prototype.resolve=function(t){return this.resolveObject(i(t,!1,!0)).format()},n.prototype.resolveObject=function(t){if(u.isString(t)){var e=new n;e.parse(t,!1,!0),t=e}for(var r=new n,i=Object.keys(this),a=0;a<i.length;a++){var o=i[a];r[o]=this[o]}if(r.hash=t.hash,\"\"===t.href)return r.href=r.format(),r;if(t.slashes&&!t.protocol){for(var s=Object.keys(t),l=0;l<s.length;l++){var c=s[l];\"protocol\"!==c&&(r[c]=t[c])}return w[r.protocol]&&r.hostname&&!r.pathname&&(r.path=r.pathname=\"/\"),r.href=r.format(),r}if(t.protocol&&t.protocol!==r.protocol){if(!w[t.protocol]){for(var h=Object.keys(t),f=0;f<h.length;f++){var d=h[f];r[d]=t[d]}return r.href=r.format(),r}if(r.protocol=t.protocol,t.host||_[t.protocol])r.pathname=t.pathname;else{for(var p=(t.pathname||\"\").split(\"/\");p.length&&!(t.host=p.shift()););t.host||(t.host=\"\"),t.hostname||(t.hostname=\"\"),\"\"!==p[0]&&p.unshift(\"\"),p.length<2&&p.unshift(\"\"),r.pathname=p.join(\"/\")}if(r.search=t.search,r.query=t.query,r.host=t.host||\"\",r.auth=t.auth,r.hostname=t.hostname||t.host,r.port=t.port,r.pathname||r.search){var m=r.pathname||\"\",v=r.search||\"\";r.path=m+v}return r.slashes=r.slashes||t.slashes,r.href=r.format(),r}var g=r.pathname&&\"/\"===r.pathname.charAt(0),y=t.host||t.pathname&&\"/\"===t.pathname.charAt(0),b=y||g||r.host&&t.pathname,x=b,M=r.pathname&&r.pathname.split(\"/\")||[],p=t.pathname&&t.pathname.split(\"/\")||[],k=r.protocol&&!w[r.protocol];if(k&&(r.hostname=\"\",r.port=null,r.host&&(\"\"===M[0]?M[0]=r.host:M.unshift(r.host)),r.host=\"\",t.protocol&&(t.hostname=null,t.port=null,t.host&&(\"\"===p[0]?p[0]=t.host:p.unshift(t.host)),t.host=null),b=b&&(\"\"===p[0]||\"\"===M[0])),y)r.host=t.host||\"\"===t.host?t.host:r.host,r.hostname=t.hostname||\"\"===t.hostname?t.hostname:r.hostname,r.search=t.search,r.query=t.query,M=p;else if(p.length)M||(M=[]),M.pop(),M=M.concat(p),r.search=t.search,r.query=t.query;else if(!u.isNullOrUndefined(t.search)){if(k){r.hostname=r.host=M.shift();var A=!!(r.host&&r.host.indexOf(\"@\")>0)&&r.host.split(\"@\");A&&(r.auth=A.shift(),r.host=r.hostname=A.shift())}return r.search=t.search,r.query=t.query,u.isNull(r.pathname)&&u.isNull(r.search)||(r.path=(r.pathname?r.pathname:\"\")+(r.search?r.search:\"\")),r.href=r.format(),r}if(!M.length)return r.pathname=null,r.search?r.path=\"/\"+r.search:r.path=null,r.href=r.format(),r;for(var T=M.slice(-1)[0],S=(r.host||t.host||M.length>1)&&(\".\"===T||\"..\"===T)||\"\"===T,E=0,L=M.length;L>=0;L--)T=M[L],\".\"===T?M.splice(L,1):\"..\"===T?(M.splice(L,1),E++):E&&(M.splice(L,1),E--);if(!b&&!x)for(;E--;E)M.unshift(\"..\");!b||\"\"===M[0]||M[0]&&\"/\"===M[0].charAt(0)||M.unshift(\"\"),S&&\"/\"!==M.join(\"/\").substr(-1)&&M.push(\"\");var C=\"\"===M[0]||M[0]&&\"/\"===M[0].charAt(0);if(k){r.hostname=r.host=C?\"\":M.length?M.shift():\"\";var A=!!(r.host&&r.host.indexOf(\"@\")>0)&&r.host.split(\"@\");A&&(r.auth=A.shift(),r.host=r.hostname=A.shift())}return b=b||r.host&&M.length,b&&!C&&M.unshift(\"\"),M.length?r.pathname=M.join(\"/\"):(r.pathname=null,r.path=null),u.isNull(r.pathname)&&u.isNull(r.search)||(r.path=(r.pathname?r.pathname:\"\")+(r.search?r.search:\"\")),r.auth=t.auth||r.auth,r.slashes=r.slashes||t.slashes,r.href=r.format(),r},n.prototype.parseHost=function(){var t=this.host,e=h.exec(t);e&&(e=e[0],\":\"!==e&&(this.port=e.substr(1)),t=t.substr(0,t.length-e.length)),t&&(this.hostname=t)}},{\"./util\":545,punycode:487,querystring:491}],545:[function(t,e,r){\"use strict\";e.exports={isString:function(t){return\"string\"==typeof t},isObject:function(t){return\"object\"==typeof t&&null!==t},isNull:function(t){return null===t},isNullOrUndefined:function(t){return null==t}}},{}],546:[function(t,e,r){\"function\"==typeof Object.create?e.exports=function(t,e){t.super_=e,t.prototype=Object.create(e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(t,e){t.super_=e;var r=function(){};r.prototype=e.prototype,t.prototype=new r,t.prototype.constructor=t}},{}],547:[function(t,e,r){e.exports=function(t){return t&&\"object\"==typeof t&&\"function\"==typeof t.copy&&\"function\"==typeof t.fill&&\"function\"==typeof t.readUInt8}},{}],548:[function(t,e,r){(function(e,n){function i(t,e){var n={seen:[],stylize:o};return arguments.length>=3&&(n.depth=arguments[2]),arguments.length>=4&&(n.colors=arguments[3]),m(e)?n.showHidden=e:e&&r._extend(n,e),_(n.showHidden)&&(n.showHidden=!1),_(n.depth)&&(n.depth=2),_(n.colors)&&(n.colors=!1),_(n.customInspect)&&(n.customInspect=!0),n.colors&&(n.stylize=a),l(n,t,n.depth)}function a(t,e){var r=i.styles[e];return r?\"\\x1b[\"+i.colors[r][0]+\"m\"+t+\"\\x1b[\"+i.colors[r][1]+\"m\":t}function o(t,e){return t}function s(t){var e={};return t.forEach(function(t,r){e[t]=!0}),e}function l(t,e,n){if(t.customInspect&&e&&T(e.inspect)&&e.inspect!==r.inspect&&(!e.constructor||e.constructor.prototype!==e)){var i=e.inspect(n,t);return b(i)||(i=l(t,i,n)),i}var a=u(t,e);if(a)return a;var o=Object.keys(e),m=s(o);if(t.showHidden&&(o=Object.getOwnPropertyNames(e)),A(e)&&(o.indexOf(\"message\")>=0||o.indexOf(\"description\")>=0))return c(e);if(0===o.length){if(T(e)){var v=e.name?\": \"+e.name:\"\";return t.stylize(\"[Function\"+v+\"]\",\"special\")}if(w(e))return t.stylize(RegExp.prototype.toString.call(e),\"regexp\");if(k(e))return t.stylize(Date.prototype.toString.call(e),\"date\");if(A(e))return c(e)}var g=\"\",y=!1,x=[\"{\",\"}\"];if(p(e)&&(y=!0,x=[\"[\",\"]\"]),T(e)){g=\" [Function\"+(e.name?\": \"+e.name:\"\")+\"]\"}if(w(e)&&(g=\" \"+RegExp.prototype.toString.call(e)),k(e)&&(g=\" \"+Date.prototype.toUTCString.call(e)),A(e)&&(g=\" \"+c(e)),0===o.length&&(!y||0==e.length))return x[0]+g+x[1];if(n<0)return w(e)?t.stylize(RegExp.prototype.toString.call(e),\"regexp\"):t.stylize(\"[Object]\",\"special\");t.seen.push(e);var _;return _=y?h(t,e,n,m,o):o.map(function(r){return f(t,e,n,m,r,y)}),t.seen.pop(),d(_,g,x)}function u(t,e){if(_(e))return t.stylize(\"undefined\",\"undefined\");if(b(e)){var r=\"'\"+JSON.stringify(e).replace(/^\"|\"$/g,\"\").replace(/'/g,\"\\\\'\").replace(/\\\\\"/g,'\"')+\"'\";return t.stylize(r,\"string\")}return y(e)?t.stylize(\"\"+e,\"number\"):m(e)?t.stylize(\"\"+e,\"boolean\"):v(e)?t.stylize(\"null\",\"null\"):void 0}function c(t){return\"[\"+Error.prototype.toString.call(t)+\"]\"}function h(t,e,r,n,i){for(var a=[],o=0,s=e.length;o<s;++o)z(e,String(o))?a.push(f(t,e,r,n,String(o),!0)):a.push(\"\");return i.forEach(function(i){i.match(/^\\d+$/)||a.push(f(t,e,r,n,i,!0))}),a}function f(t,e,r,n,i,a){var o,s,u;if(u=Object.getOwnPropertyDescriptor(e,i)||{value:e[i]},u.get?s=u.set?t.stylize(\"[Getter/Setter]\",\"special\"):t.stylize(\"[Getter]\",\"special\"):u.set&&(s=t.stylize(\"[Setter]\",\"special\")),z(n,i)||(o=\"[\"+i+\"]\"),s||(t.seen.indexOf(u.value)<0?(s=v(r)?l(t,u.value,null):l(t,u.value,r-1),s.indexOf(\"\\n\")>-1&&(s=a?s.split(\"\\n\").map(function(t){return\"  \"+t}).join(\"\\n\").substr(2):\"\\n\"+s.split(\"\\n\").map(function(t){return\"   \"+t}).join(\"\\n\"))):s=t.stylize(\"[Circular]\",\"special\")),_(o)){if(a&&i.match(/^\\d+$/))return s;o=JSON.stringify(\"\"+i),o.match(/^\"([a-zA-Z_][a-zA-Z_0-9]*)\"$/)?(o=o.substr(1,o.length-2),o=t.stylize(o,\"name\")):(o=o.replace(/'/g,\"\\\\'\").replace(/\\\\\"/g,'\"').replace(/(^\"|\"$)/g,\"'\"),o=t.stylize(o,\"string\"))}return o+\": \"+s}function d(t,e,r){var n=0;return t.reduce(function(t,e){return n++,e.indexOf(\"\\n\")>=0&&n++,t+e.replace(/\\u001b\\[\\d\\d?m/g,\"\").length+1},0)>60?r[0]+(\"\"===e?\"\":e+\"\\n \")+\" \"+t.join(\",\\n  \")+\" \"+r[1]:r[0]+e+\" \"+t.join(\", \")+\" \"+r[1]}function p(t){return Array.isArray(t)}function m(t){return\"boolean\"==typeof t}function v(t){return null===t}function g(t){return null==t}function y(t){return\"number\"==typeof t}function b(t){return\"string\"==typeof t}function x(t){return\"symbol\"==typeof t}function _(t){return void 0===t}function w(t){return M(t)&&\"[object RegExp]\"===E(t)}function M(t){return\"object\"==typeof t&&null!==t}function k(t){return M(t)&&\"[object Date]\"===E(t)}function A(t){return M(t)&&(\"[object Error]\"===E(t)||t instanceof Error)}function T(t){return\"function\"==typeof t}function S(t){return null===t||\"boolean\"==typeof t||\"number\"==typeof t||\"string\"==typeof t||\"symbol\"==typeof t||void 0===t}function E(t){return Object.prototype.toString.call(t)}function L(t){return t<10?\"0\"+t.toString(10):t.toString(10)}function C(){var t=new Date,e=[L(t.getHours()),L(t.getMinutes()),L(t.getSeconds())].join(\":\");return[t.getDate(),O[t.getMonth()],e].join(\" \")}function z(t,e){return Object.prototype.hasOwnProperty.call(t,e)}var I=/%[sdj%]/g;r.format=function(t){if(!b(t)){for(var e=[],r=0;r<arguments.length;r++)e.push(i(arguments[r]));return e.join(\" \")}for(var r=1,n=arguments,a=n.length,o=String(t).replace(I,function(t){if(\"%%\"===t)return\"%\";if(r>=a)return t;switch(t){case\"%s\":return String(n[r++]);case\"%d\":return Number(n[r++]);case\"%j\":try{return JSON.stringify(n[r++])}catch(t){return\"[Circular]\"}default:return t}}),s=n[r];r<a;s=n[++r])v(s)||!M(s)?o+=\" \"+s:o+=\" \"+i(s);return o},r.deprecate=function(t,i){function a(){if(!o){if(e.throwDeprecation)throw new Error(i);e.traceDeprecation?console.trace(i):console.error(i),o=!0}return t.apply(this,arguments)}if(_(n.process))return function(){return r.deprecate(t,i).apply(this,arguments)};if(!0===e.noDeprecation)return t;var o=!1;return a};var D,P={};r.debuglog=function(t){if(_(D)&&(D=e.env.NODE_DEBUG||\"\"),t=t.toUpperCase(),!P[t])if(new RegExp(\"\\\\b\"+t+\"\\\\b\",\"i\").test(D)){var n=e.pid;P[t]=function(){var e=r.format.apply(r,arguments);console.error(\"%s %d: %s\",t,n,e)}}else P[t]=function(){};return P[t]},r.inspect=i,i.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},i.styles={special:\"cyan\",number:\"yellow\",boolean:\"yellow\",undefined:\"grey\",null:\"bold\",string:\"green\",date:\"magenta\",regexp:\"red\"},r.isArray=p,r.isBoolean=m,r.isNull=v,r.isNullOrUndefined=g,r.isNumber=y,r.isString=b,r.isSymbol=x,r.isUndefined=_,r.isRegExp=w,r.isObject=M,r.isDate=k,r.isError=A,r.isFunction=T,r.isPrimitive=S,r.isBuffer=t(\"./support/isBuffer\");var O=[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"];r.log=function(){console.log(\"%s - %s\",C(),r.format.apply(r,arguments))},r.inherits=t(\"inherits\"),r._extend=function(t,e){if(!e||!M(e))return t;for(var r=Object.keys(e),n=r.length;n--;)t[r[n]]=e[r[n]];return t}}).call(this,t(\"_process\"),\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"./support/isBuffer\":547,_process:486,inherits:546}],549:[function(t,e,r){e.exports.VectorTile=t(\"./lib/vectortile.js\"),e.exports.VectorTileFeature=t(\"./lib/vectortilefeature.js\"),e.exports.VectorTileLayer=t(\"./lib/vectortilelayer.js\")},{\"./lib/vectortile.js\":550,\"./lib/vectortilefeature.js\":551,\"./lib/vectortilelayer.js\":552}],550:[function(t,e,r){\"use strict\";function n(t,e){this.layers=t.readFields(i,{},e)}function i(t,e,r){if(3===t){var n=new a(r,r.readVarint()+r.pos);n.length&&(e[n.name]=n)}}var a=t(\"./vectortilelayer\");e.exports=n},{\"./vectortilelayer\":552}],551:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){this.properties={},this.extent=r,this.type=0,this._pbf=t,this._geometry=-1,this._keys=n,this._values=a,t.readFields(i,this,e)}function i(t,e,r){1==t?e.id=r.readVarint():2==t?a(r,e):3==t?e.type=r.readVarint():4==t&&(e._geometry=r.pos)}function a(t,e){for(var r=t.readVarint()+t.pos;t.pos<r;){var n=e._keys[t.readVarint()],i=e._values[t.readVarint()];e.properties[n]=i}}function o(t){var e=t.length;if(e<=1)return[t];for(var r,n,i=[],a=0;a<e;a++){var o=s(t[a]);0!==o&&(void 0===n&&(n=o<0),n===o<0?(r&&i.push(r),r=[t[a]]):r.push(t[a]))}return r&&i.push(r),i}function s(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r.x-e.x)*(e.y+r.y);return n}var l=t(\"point-geometry\");e.exports=n,n.types=[\"Unknown\",\"Point\",\"LineString\",\"Polygon\"],n.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var e,r=t.readVarint()+t.pos,n=1,i=0,a=0,o=0,s=[];t.pos<r;){if(!i){var u=t.readVarint();n=7&u,i=u>>3}if(i--,1===n||2===n)a+=t.readSVarint(),o+=t.readSVarint(),1===n&&(e&&s.push(e),e=[]),e.push(new l(a,o));else{if(7!==n)throw new Error(\"unknown command \"+n);e&&e.push(e[0].clone())}}return e&&s.push(e),s},n.prototype.bbox=function(){var t=this._pbf;t.pos=this._geometry;for(var e=t.readVarint()+t.pos,r=1,n=0,i=0,a=0,o=1/0,s=-1/0,l=1/0,u=-1/0;t.pos<e;){if(!n){var c=t.readVarint();r=7&c,n=c>>3}if(n--,1===r||2===r)i+=t.readSVarint(),a+=t.readSVarint(),i<o&&(o=i),i>s&&(s=i),a<l&&(l=a),a>u&&(u=a);else if(7!==r)throw new Error(\"unknown command \"+r)}return[o,l,s,u]},n.prototype.toGeoJSON=function(t,e,r){function i(t){for(var e=0;e<t.length;e++){var r=t[e],n=180-360*(r.y+c)/l;t[e]=[360*(r.x+u)/l-180,360/Math.PI*Math.atan(Math.exp(n*Math.PI/180))-90]}}var a,s,l=this.extent*Math.pow(2,r),u=this.extent*t,c=this.extent*e,h=this.loadGeometry(),f=n.types[this.type];switch(this.type){case 1:var d=[];for(a=0;a<h.length;a++)d[a]=h[a][0];h=d,i(h);break;case 2:for(a=0;a<h.length;a++)i(h[a]);break;case 3:for(h=o(h),a=0;a<h.length;a++)for(s=0;s<h[a].length;s++)i(h[a][s])}1===h.length?h=h[0]:f=\"Multi\"+f;var p={type:\"Feature\",geometry:{type:f,coordinates:h},properties:this.properties};return\"id\"in this&&(p.id=this.id),p}},{\"point-geometry\":483}],552:[function(t,e,r){\"use strict\";function n(t,e){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=t,this._keys=[],this._values=[],this._features=[],t.readFields(i,this,e),this.length=this._features.length}function i(t,e,r){15===t?e.version=r.readVarint():1===t?e.name=r.readString():5===t?e.extent=r.readVarint():2===t?e._features.push(r.pos):3===t?e._keys.push(r.readString()):4===t&&e._values.push(a(r))}function a(t){for(var e=null,r=t.readVarint()+t.pos;t.pos<r;){var n=t.readVarint()>>3;e=1===n?t.readString():2===n?t.readFloat():3===n?t.readDouble():4===n?t.readVarint64():5===n?t.readVarint():6===n?t.readSVarint():7===n?t.readBoolean():null}return e}var o=t(\"./vectortilefeature.js\");e.exports=n,n.prototype.feature=function(t){if(t<0||t>=this._features.length)throw new Error(\"feature index out of bounds\");this._pbf.pos=this._features[t];var e=this._pbf.readVarint()+this._pbf.pos;return new o(this._pbf,e,this.extent,this._keys,this._values)}},{\"./vectortilefeature.js\":551}],553:[function(t,e,r){\"use strict\";function n(t,e){return\"object\"==typeof e&&null!==e||(e={}),i(t,e.canvas||a,e.context||o,e)}e.exports=n;var i=t(\"./lib/vtext\"),a=null,o=null;\"undefined\"!=typeof document&&(a=document.createElement(\"canvas\"),a.width=8192,a.height=1024,o=a.getContext(\"2d\"))},{\"./lib/vtext\":554}],554:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=e.textAlign||\"start\",i=e.textBaseline||\"alphabetic\",a=[1<<30,1<<30],o=[0,0],s=t.length,l=0;l<s;++l)for(var u=t[l],c=0;c<2;++c)a[c]=0|Math.min(a[c],u[c]),o[c]=0|Math.max(o[c],u[c]);var h=0;switch(n){case\"center\":h=-.5*(a[0]+o[0]);break;case\"right\":case\"end\":h=-o[0];break;case\"left\":case\"start\":h=-a[0];break;default:throw new Error(\"vectorize-text: Unrecognized textAlign: '\"+n+\"'\")}var f=0;switch(i){case\"hanging\":case\"top\":f=-a[1];break;case\"middle\":f=-.5*(a[1]+o[1]);break;case\"alphabetic\":case\"ideographic\":f=-3*r;break;case\"bottom\":f=-o[1];break;default:throw new Error(\"vectorize-text: Unrecoginized textBaseline: '\"+i+\"'\")}var d=1/r;return\"lineHeight\"in e?d*=+e.lineHeight:\"width\"in e?d=e.width/(o[0]-a[0]):\"height\"in e&&(d=e.height/(o[1]-a[1])),t.map(function(t){return[d*(t[0]+h),d*(t[1]+f)]})}function i(t,e,r,n){var i=0|Math.ceil(e.measureText(r).width+2*n);if(i>8192)throw new Error(\"vectorize-text: String too long (sorry, this will get fixed later)\");var a=3*n;t.height<a&&(t.height=a),e.fillStyle=\"#000\",e.fillRect(0,0,t.width,t.height),e.fillStyle=\"#fff\",e.fillText(r,n,2*n);var o=e.getImageData(0,0,i,a);return c(o.data,[a,i,4]).pick(-1,-1,0).transpose(1,0)}function a(t,e){var r=u(t,128);return e?h(r.cells,r.positions,.25):{edges:r.cells,positions:r.positions}}function o(t,e,r,i){var o=a(t,i),s=n(o.positions,e,r),l=o.edges,u=\"ccw\"===e.orientation;if(f(s,l),e.polygons||e.polygon||e.polyline){for(var c=p(l,s),h=new Array(c.length),m=0;m<c.length;++m){for(var v=c[m],g=new Array(v.length),y=0;y<v.length;++y){for(var b=v[y],x=new Array(b.length),_=0;_<b.length;++_)x[_]=s[b[_]].slice();u&&x.reverse(),g[y]=x}h[m]=g}return h}return e.triangles||e.triangulate||e.triangle?{cells:d(s,l,{delaunay:!1,exterior:!1,interior:!0}),positions:s}:{edges:l,positions:s}}function s(t,e,r){try{return o(t,e,r,!0)}catch(t){}try{return o(t,e,r,!1)}catch(t){}return e.polygons||e.polyline||e.polygon?[]:e.triangles||e.triangulate||e.triangle?{cells:[],positions:[]}:{edges:[],positions:[]}}function l(t,e,r,n){var a=n.size||64,o=n.font||\"normal\";return r.font=a+\"px \"+o,r.textAlign=\"start\",r.textBaseline=\"alphabetic\",r.direction=\"ltr\",s(i(e,r,t,a),n,a)}e.exports=l,e.exports.processPixels=s;var u=t(\"surface-nets\"),c=t(\"ndarray\"),h=t(\"simplify-planar-graph\"),f=t(\"clean-pslg\"),d=t(\"cdt2d\"),p=t(\"planar-graph-to-polyline\")},{cdt2d:78,\"clean-pslg\":88,ndarray:466,\"planar-graph-to-polyline\":482,\"simplify-planar-graph\":522,\"surface-nets\":530}],555:[function(t,e,r){function n(t){var e=[];for(var r in t.layers)e.push(a(t.layers[r]));var n=new c;return h.tile.write({layers:e},n),n.finish()}function i(t){var e={};for(var r in t)e[r]=new f(t[r].features),e[r].name=r;return n({layers:e})}function a(t){for(var e={name:t.name||\"\",version:t.version||1,extent:t.extent||4096,keys:[],values:[],features:[]},r={},n={},i=0;i<t.length;i++){var a=t.feature(i);a.geometry=l(a.loadGeometry());var o=[];for(var s in a.properties){var c=r[s];void 0===c&&(e.keys.push(s),c=e.keys.length-1,r[s]=c);var h=u(a.properties[s]),f=n[h.key];void 0===f&&(e.values.push(h),f=e.values.length-1,n[h.key]=f),o.push(c),o.push(f)}a.tags=o,e.features.push(a)}return e}function o(t,e){return(e<<3)+(7&t)}function s(t){return t<<1^t>>31}function l(t){for(var e=[],r=0,n=0,i=t.length,a=0;a<i;a++){var l=t[a];e.push(o(1,1));for(var u=0;u<l.length;u++){1===u&&e.push(o(2,l.length-1));var c=l[u].x-r,h=l[u].y-n;e.push(s(c),s(h)),r+=c,n+=h}}return e}function u(t){var e,r=typeof t;return\"string\"===r?e={string_value:t}:\"boolean\"===r?e={bool_value:t}:\"number\"===r?e=t%1!=0?{double_value:t}:t<0?{sint_value:t}:{uint_value:t}:(t=JSON.stringify(t),e={string_value:t}),e.key=r+\":\"+t,e}var c=t(\"pbf\"),h=t(\"./vector-tile-pb\"),f=t(\"./lib/geojson_wrapper\");e.exports=n,e.exports.fromVectorTileJs=n,e.exports.fromGeojsonVt=i,e.exports.GeoJSONWrapper=f},{\"./lib/geojson_wrapper\":556,\"./vector-tile-pb\":557,pbf:477}],556:[function(t,e,r){\"use strict\";function n(t){this.features=t,this.length=t.length}function i(t){this.id=\"number\"==typeof t.id?t.id:void 0,this.type=t.type,this.rawGeometry=1===t.type?[t.geometry]:t.geometry,this.properties=t.tags,this.extent=4096}var a=t(\"point-geometry\"),o=t(\"vector-tile\").VectorTileFeature;e.exports=n,n.prototype.feature=function(t){return new i(this.features[t])},i.prototype.loadGeometry=function(){var t=this.rawGeometry;this.geometry=[];for(var e=0;e<t.length;e++){for(var r=t[e],n=[],i=0;i<r.length;i++)n.push(new a(r[i][0],r[i][1]));this.geometry.push(n)}return this.geometry},i.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var t=this.geometry,e=1/0,r=-1/0,n=1/0,i=-1/0,a=0;a<t.length;a++)for(var o=t[a],s=0;s<o.length;s++){var l=o[s];e=Math.min(e,l.x),r=Math.max(r,l.x),n=Math.min(n,l.y),i=Math.max(i,l.y)}return[e,n,r,i]},i.prototype.toGeoJSON=o.prototype.toGeoJSON},{\"point-geometry\":483,\"vector-tile\":549}],557:[function(t,e,r){\"use strict\";function n(t,e){return t.readFields(i,{layers:[]},e)}function i(t,e,r){3===t&&e.layers.push(f(r,r.readVarint()+r.pos))}function a(t,e){var r;if(void 0!==t.layers)for(r=0;r<t.layers.length;r++)e.writeMessage(3,p,t.layers[r])}function o(t,e){return t.readFields(s,{},e)}function s(t,e,r){1===t?e.string_value=r.readString():2===t?e.float_value=r.readFloat():3===t?e.double_value=r.readDouble():4===t?e.int_value=r.readVarint():5===t?e.uint_value=r.readVarint():6===t?e.sint_value=r.readSVarint():7===t&&(e.bool_value=r.readBoolean())}function l(t,e){void 0!==t.string_value&&e.writeStringField(1,t.string_value),void 0!==t.float_value&&e.writeFloatField(2,t.float_value),void 0!==t.double_value&&e.writeDoubleField(3,t.double_value),void 0!==t.int_value&&e.writeVarintField(4,t.int_value),void 0!==t.uint_value&&e.writeVarintField(5,t.uint_value),void 0!==t.sint_value&&e.writeSVarintField(6,t.sint_value),void 0!==t.bool_value&&e.writeBooleanField(7,t.bool_value)}function u(t,e){var r=t.readFields(c,{},e);return void 0===r.type&&(r.type=\"Unknown\"),r}function c(t,e,r){1===t?e.id=r.readVarint():2===t?e.tags=r.readPackedVarint():3===t?e.type=r.readVarint():4===t&&(e.geometry=r.readPackedVarint())}function h(t,e){void 0!==t.id&&e.writeVarintField(1,t.id),void 0!==t.tags&&e.writePackedVarint(2,t.tags),void 0!==t.type&&e.writeVarintField(3,t.type),void 0!==t.geometry&&e.writePackedVarint(4,t.geometry)}function f(t,e){return t.readFields(d,{features:[],keys:[],values:[]},e)}function d(t,e,r){15===t?e.version=r.readVarint():1===t?e.name=r.readString():2===t?e.features.push(u(r,r.readVarint()+r.pos)):3===t?e.keys.push(r.readString()):4===t?e.values.push(o(r,r.readVarint()+r.pos)):5===t&&(e.extent=r.readVarint())}function p(t,e){void 0!==t.version&&e.writeVarintField(15,t.version),void 0!==t.name&&e.writeStringField(1,t.name);var r;if(void 0!==t.features)for(r=0;r<t.features.length;r++)e.writeMessage(2,h,t.features[r]);if(void 0!==t.keys)for(r=0;r<t.keys.length;r++)e.writeStringField(3,t.keys[r]);if(void 0!==t.values)for(r=0;r<t.values.length;r++)e.writeMessage(4,l,t.values[r]);void 0!==t.extent&&e.writeVarintField(5,t.extent)}var m=r.tile={read:n,write:a};m.GeomType={Unknown:0,Point:1,LineString:2,Polygon:3},m.value={read:o,write:l},m.feature={read:u,write:h},m.layer={read:f,write:p}},{}],558:[function(t,e,r){!function(){\"use strict\";function t(e){e.permitHostObjects___&&e.permitHostObjects___(t)}function r(t){return!(t.substr(0,d.length)==d&&\"___\"===t.substr(t.length-3))}function n(t){if(t!==Object(t))throw new TypeError(\"Not an object: \"+t);var e=t[p];if(e&&e.key===t)return e;if(f(t)){e={key:t};try{return h(t,p,{value:e,writable:!1,enumerable:!1,configurable:!1}),e}catch(t){return}}}function i(t){return t.prototype=null,Object.freeze(t)}function a(){y||\"undefined\"==typeof console||(y=!0,console.warn(\"WeakMap should be invoked as new WeakMap(), not WeakMap(). This will be an error in the future.\"))}if(\"undefined\"==typeof ses||!ses.ok||ses.ok()){\"undefined\"!=typeof ses&&(ses.weakMapPermitHostObjects=t);var o=!1;if(\"function\"==typeof WeakMap){var s=WeakMap;if(\"undefined\"!=typeof navigator&&/Firefox/.test(navigator.userAgent));else{var l=new s,u=Object.freeze({});if(l.set(u,1),1===l.get(u))return void(e.exports=WeakMap);o=!0}}var c=(Object.prototype.hasOwnProperty,Object.getOwnPropertyNames),h=Object.defineProperty,f=Object.isExtensible,d=\"weakmap:\",p=d+\"ident:\"+Math.random()+\"___\";if(\"undefined\"!=typeof crypto&&\"function\"==typeof crypto.getRandomValues&&\"function\"==typeof ArrayBuffer&&\"function\"==typeof Uint8Array){var m=new ArrayBuffer(25),v=new Uint8Array(m);crypto.getRandomValues(v),p=d+\"rand:\"+Array.prototype.map.call(v,function(t){return(t%36).toString(36)}).join(\"\")+\"___\"}if(h(Object,\"getOwnPropertyNames\",{value:function(t){return c(t).filter(r)}}),\"getPropertyNames\"in Object){var g=Object.getPropertyNames;h(Object,\"getPropertyNames\",{value:function(t){return g(t).filter(r)}})}!function(){var t=Object.freeze;h(Object,\"freeze\",{value:function(e){return n(e),t(e)}});var e=Object.seal;h(Object,\"seal\",{value:function(t){return n(t),e(t)}});var r=Object.preventExtensions;h(Object,\"preventExtensions\",{value:function(t){return n(t),r(t)}})}();var y=!1,b=0,x=function(){function t(t,e){var r,i=n(t);return i?u in i?i[u]:e:(r=s.indexOf(t),r>=0?l[r]:e)}function e(t){var e=n(t);return e?u in e:s.indexOf(t)>=0}function r(t,e){var r,i=n(t);return i?i[u]=e:(r=s.indexOf(t),r>=0?l[r]=e:(r=s.length,l[r]=e,s[r]=t)),this}function o(t){var e,r,i=n(t);return i?u in i&&delete i[u]:!((e=s.indexOf(t))<0)&&(r=s.length-1,s[e]=void 0,l[e]=l[r],s[e]=s[r],s.length=r,l.length=r,!0)}this instanceof x||a();var s=[],l=[],u=b++;return Object.create(x.prototype,{get___:{value:i(t)},has___:{value:i(e)},set___:{value:i(r)},delete___:{value:i(o)}})};x.prototype=Object.create(Object.prototype,{get:{value:function(t,e){return this.get___(t,e)},writable:!0,configurable:!0},has:{value:function(t){return this.has___(t)},writable:!0,configurable:!0},set:{value:function(t,e){return this.set___(t,e)},writable:!0,configurable:!0},delete:{value:function(t){return this.delete___(t)},writable:!0,configurable:!0}}),\"function\"==typeof s?function(){function r(){function e(t,e){return c?u.has(t)?u.get(t):c.get___(t,e):u.get(t,e)}function r(t){return u.has(t)||!!c&&c.has___(t)}function n(t){var e=!!u.delete(t);return c?c.delete___(t)||e:e}this instanceof x||a()\n",
       ";var l,u=new s,c=void 0,h=!1;return l=o?function(t,e){return u.set(t,e),u.has(t)||(c||(c=new x),c.set(t,e)),this}:function(t,e){if(h)try{u.set(t,e)}catch(r){c||(c=new x),c.set___(t,e)}else u.set(t,e);return this},Object.create(x.prototype,{get___:{value:i(e)},has___:{value:i(r)},set___:{value:i(l)},delete___:{value:i(n)},permitHostObjects___:{value:i(function(e){if(e!==t)throw new Error(\"bogus call to permitHostObjects___\");h=!0})}})}o&&\"undefined\"!=typeof Proxy&&(Proxy=void 0),r.prototype=x.prototype,e.exports=r,Object.defineProperty(WeakMap.prototype,\"constructor\",{value:WeakMap,enumerable:!1,configurable:!0,writable:!0})}():(\"undefined\"!=typeof Proxy&&(Proxy=void 0),e.exports=x)}}()},{}],559:[function(t,e,r){function n(){var t={};return function(e){if((\"object\"!=typeof e||null===e)&&\"function\"!=typeof e)throw new Error(\"Weakmap-shim: Key must be object\");var r=e.valueOf(t);return r&&r.identity===t?r:i(e,t)}}var i=t(\"./hidden-store.js\");e.exports=n},{\"./hidden-store.js\":560}],560:[function(t,e,r){function n(t,e){var r={identity:e},n=t.valueOf;return Object.defineProperty(t,\"valueOf\",{value:function(t){return t!==e?n.apply(this,arguments):r},writable:!0}),r}e.exports=n},{}],561:[function(t,e,r){function n(){var t=i();return{get:function(e,r){var n=t(e);return n.hasOwnProperty(\"value\")?n.value:r},set:function(e,r){return t(e).value=r,this},has:function(e){return\"value\"in t(e)},delete:function(e){return delete t(e).value}}}var i=t(\"./create-store.js\");e.exports=n},{\"./create-store.js\":559}],562:[function(t,e,r){var n=t(\"get-canvas-context\");e.exports=function(t){return n(\"webgl\",t)}},{\"get-canvas-context\":146}],563:[function(t,e,r){var n=arguments[3],i=arguments[4],a=arguments[5],o=JSON.stringify;e.exports=function(t,e){function r(t){v[t]=!0;for(var e in i[t][1]){var n=i[t][1][e];v[n]||r(n)}}for(var s,l=Object.keys(a),u=0,c=l.length;u<c;u++){var h=l[u],f=a[h].exports;if(f===t||f&&f.default===t){s=h;break}}if(!s){s=Math.floor(Math.pow(16,8)*Math.random()).toString(16);for(var d={},u=0,c=l.length;u<c;u++){var h=l[u];d[h]=h}i[s]=[Function([\"require\",\"module\",\"exports\"],\"(\"+t+\")(self)\"),d]}var p=Math.floor(Math.pow(16,8)*Math.random()).toString(16),m={};m[s]=s,i[p]=[Function([\"require\"],\"var f = require(\"+ o(s) +\");(f.default ? f.default : f)(self);\"),m];var v={};r(p);var g=\"(\"+n+\")({\"+Object.keys(v).map(function(t){return o(t)+\":[\"+i[t][0]+\",\"+o(i[t][1])+\"]\"}).join(\",\")+\"},{},[\"+o(p)+\"])\",y=window.URL||window.webkitURL||window.mozURL||window.msURL,b=new Blob([g],{type:\"text/javascript\"});if(e&&e.bare)return b;var x=y.createObjectURL(b),_=new Worker(x);return _.objectURL=x,_}},{}],564:[function(t,e,r){e.exports.RADIUS=6378137,e.exports.FLATTENING=1/298.257223563,e.exports.POLAR_RADIUS=6356752.3142},{}],565:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.WhooTS=e.WhooTS||{})}(this,function(t){function e(t,e,n,i,a,o){return o=o||{},t+\"?\"+[\"bbox=\"+r(n,i,a),\"format=\"+(o.format||\"image/png\"),\"service=\"+(o.service||\"WMS\"),\"version=\"+(o.version||\"1.1.1\"),\"request=\"+(o.request||\"GetMap\"),\"srs=\"+(o.srs||\"EPSG:3857\"),\"width=\"+(o.width||256),\"height=\"+(o.height||256),\"layers=\"+e].join(\"&\")}function r(t,e,r){e=Math.pow(2,r)-e-1;var i=n(256*t,256*e,r),a=n(256*(t+1),256*(e+1),r);return i[0]+\",\"+i[1]+\",\"+a[0]+\",\"+a[1]}function n(t,e,r){var n=2*Math.PI*6378137/256/Math.pow(2,r);return[t*n-2*Math.PI*6378137/2,e*n-2*Math.PI*6378137/2]}t.getURL=e,t.getTileBBox=r,t.getMercCoords=n,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],566:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e,r,n){var i,a;if(\"object\"==typeof t)i=t,a=e||{};else{if(!(\"number\"==typeof t&&t>=1888&&t<=2111))throw new Error(\"Solar year outside range 1888-2111\");if(!(\"number\"==typeof e&&e>=1&&e<=12))throw new Error(\"Solar month outside range 1 - 12\");if(!(\"number\"==typeof r&&r>=1&&r<=31))throw new Error(\"Solar day outside range 1 - 31\");i={year:t,month:e,day:r},a=n||{}}var o=p[i.year-p[0]],s=i.year<<9|i.month<<5|i.day;a.year=s>=o?i.year:i.year-1,o=p[a.year-p[0]];var l,u=o>>9&4095,c=o>>5&15,h=31&o,f=new Date(u,c-1,h),m=new Date(i.year,i.month-1,i.day);l=Math.round((m-f)/864e5);var v,g=d[a.year-d[0]];for(v=0;v<13;v++){var y=g&1<<12-v?30:29;if(l<y)break;l-=y}var b=g>>13;return!b||v<b?(a.isIntercalary=!1,a.month=1+v):v===b?(a.isIntercalary=!0,a.month=v):(a.isIntercalary=!1,a.month=v),a.day=1+l,a}function a(t,e,r,n,i){var a,o;if(\"object\"==typeof t)o=t,a=e||{};else{if(!(\"number\"==typeof t&&t>=1888&&t<=2111))throw new Error(\"Lunar year outside range 1888-2111\");if(!(\"number\"==typeof e&&e>=1&&e<=12))throw new Error(\"Lunar month outside range 1 - 12\");if(!(\"number\"==typeof r&&r>=1&&r<=30))throw new Error(\"Lunar day outside range 1 - 30\");var s;\"object\"==typeof n?(s=!1,a=n):(s=!!n,a=i||{}),o={year:t,month:e,day:r,isIntercalary:s}}var l;l=o.day-1;var u,c=d[o.year-d[0]],h=c>>13;u=h?o.month>h?o.month:o.isIntercalary?o.month:o.month-1:o.month-1;for(var f=0;f<u;f++){l+=c&1<<12-f?30:29}var m=p[o.year-p[0]],v=m>>9&4095,g=m>>5&15,y=31&m,b=new Date(v,g-1,y+l);return a.year=b.getFullYear(),a.month=1+b.getMonth(),a.day=b.getDate(),a}var o=t(\"../main\"),s=t(\"object-assign\"),l=o.instance();n.prototype=new o.baseCalendar,s(n.prototype,{name:\"Chinese\",jdEpoch:1721425.5,hasYearZero:!1,minMonth:0,firstMonth:0,minDay:1,regionalOptions:{\"\":{name:\"Chinese\",epochs:[\"BEC\",\"EC\"],monthNumbers:function(t,e){if(\"string\"==typeof t){var r=t.match(c);return r?r[0]:\"\"}var n=this._validateYear(t),i=t.month(),a=\"\"+this.toChineseMonth(n,i);return e&&a.length<2&&(a=\"0\"+a),this.isIntercalaryMonth(n,i)&&(a+=\"i\"),a},monthNames:function(t){if(\"string\"==typeof t){var e=t.match(h);return e?e[0]:\"\"}var r=this._validateYear(t),n=t.month(),i=this.toChineseMonth(r,n),a=[\"\\u4e00\\u6708\",\"\\u4e8c\\u6708\",\"\\u4e09\\u6708\",\"\\u56db\\u6708\",\"\\u4e94\\u6708\",\"\\u516d\\u6708\",\"\\u4e03\\u6708\",\"\\u516b\\u6708\",\"\\u4e5d\\u6708\",\"\\u5341\\u6708\",\"\\u5341\\u4e00\\u6708\",\"\\u5341\\u4e8c\\u6708\"][i-1];return this.isIntercalaryMonth(r,n)&&(a=\"\\u95f0\"+a),a},monthNamesShort:function(t){if(\"string\"==typeof t){var e=t.match(f);return e?e[0]:\"\"}var r=this._validateYear(t),n=t.month(),i=this.toChineseMonth(r,n),a=[\"\\u4e00\",\"\\u4e8c\",\"\\u4e09\",\"\\u56db\",\"\\u4e94\",\"\\u516d\",\"\\u4e03\",\"\\u516b\",\"\\u4e5d\",\"\\u5341\",\"\\u5341\\u4e00\",\"\\u5341\\u4e8c\"][i-1];return this.isIntercalaryMonth(r,n)&&(a=\"\\u95f0\"+a),a},parseMonth:function(t,e){t=this._validateYear(t);var r,n=parseInt(e);if(isNaN(n))\"\\u95f0\"===e[0]&&(r=!0,e=e.substring(1)),\"\\u6708\"===e[e.length-1]&&(e=e.substring(0,e.length-1)),n=1+[\"\\u4e00\",\"\\u4e8c\",\"\\u4e09\",\"\\u56db\",\"\\u4e94\",\"\\u516d\",\"\\u4e03\",\"\\u516b\",\"\\u4e5d\",\"\\u5341\",\"\\u5341\\u4e00\",\"\\u5341\\u4e8c\"].indexOf(e);else{var i=e[e.length-1];r=\"i\"===i||\"I\"===i}return this.toMonthIndex(t,n,r)},dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:1,isRTL:!1}},_validateYear:function(t,e){if(t.year&&(t=t.year()),\"number\"!=typeof t||t<1888||t>2111)throw e.replace(/\\{0\\}/,this.local.name);return t},toMonthIndex:function(t,e,r){var n=this.intercalaryMonth(t);if(r&&e!==n||e<1||e>12)throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return n?!r&&e<=n?e-1:e:e-1},toChineseMonth:function(t,e){t.year&&(t=t.year(),e=t.month());var r=this.intercalaryMonth(t),n=r?12:11;if(e<0||e>n)throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return r?e<r?e+1:e:e+1},intercalaryMonth:function(t){return t=this._validateYear(t),d[t-d[0]]>>13},isIntercalaryMonth:function(t,e){t.year&&(t=t.year(),e=t.month());var r=this.intercalaryMonth(t);return!!r&&r===e},leapYear:function(t){return 0!==this.intercalaryMonth(t)},weekOfYear:function(t,e,r){var n,i=this._validateYear(t,o.local.invalidyear),a=p[i-p[0]],s=a>>9&4095,u=a>>5&15,c=31&a;n=l.newDate(s,u,c),n.add(4-(n.dayOfWeek()||7),\"d\");var h=this.toJD(t,e,r)-n.toJD();return 1+Math.floor(h/7)},monthsInYear:function(t){return this.leapYear(t)?13:12},daysInMonth:function(t,e){t.year&&(e=t.month(),t=t.year()),t=this._validateYear(t);var r=d[t-d[0]];if(e>(r>>13?12:11))throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return r&1<<12-e?30:29},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,s,r,o.local.invalidDate);t=this._validateYear(n.year()),e=n.month(),r=n.day();var i=this.isIntercalaryMonth(t,e),s=this.toChineseMonth(t,e),u=a(t,s,r,i);return l.toJD(u.year,u.month,u.day)},fromJD:function(t){var e=l.fromJD(t),r=i(e.year(),e.month(),e.day()),n=this.toMonthIndex(r.year,r.month,r.isIntercalary);return this.newDate(r.year,n,r.day)},fromString:function(t){var e=t.match(u),r=this._validateYear(+e[1]),n=+e[2],i=!!e[3],a=this.toMonthIndex(r,n,i),o=+e[4];return this.newDate(r,a,o)},add:function(t,e,r){var i=t.year(),a=t.month(),o=this.isIntercalaryMonth(i,a),s=this.toChineseMonth(i,a),l=Object.getPrototypeOf(n.prototype).add.call(this,t,e,r);if(\"y\"===r){var u=l.year(),c=l.month(),h=this.isIntercalaryMonth(u,s),f=o&&h?this.toMonthIndex(u,s,!0):this.toMonthIndex(u,s,!1);f!==c&&l.month(f)}return l}});var u=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)[-\\/](\\d?\\d)([iI]?)[-\\/](\\d?\\d)/m,c=/^\\d?\\d[iI]?/m,h=/^\\u95f0?\\u5341?[\\u4e00\\u4e8c\\u4e09\\u56db\\u4e94\\u516d\\u4e03\\u516b\\u4e5d]?\\u6708/m,f=/^\\u95f0?\\u5341?[\\u4e00\\u4e8c\\u4e09\\u56db\\u4e94\\u516d\\u4e03\\u516b\\u4e5d]?/m;o.calendars.chinese=n;var d=[1887,5780,5802,19157,2742,50359,1198,2646,46378,7466,3412,30122,5482,67949,2396,5294,43597,6732,6954,36181,2772,4954,18781,2396,54427,5274,6730,47781,5800,6868,21210,4790,59703,2350,5270,46667,3402,3496,38325,1388,4782,18735,2350,52374,6804,7498,44457,2906,1388,29294,4700,63789,6442,6804,56138,5802,2772,38235,1210,4698,22827,5418,63125,3476,5802,43701,2484,5302,27223,2646,70954,7466,3412,54698,5482,2412,38062,5294,2636,32038,6954,60245,2772,4826,43357,2394,5274,39501,6730,72357,5800,5844,53978,4790,2358,38039,5270,87627,3402,3496,54708,5484,4782,43311,2350,3222,27978,7498,68965,2904,5484,45677,4700,6444,39573,6804,6986,19285,2772,62811,1210,4698,47403,5418,5780,38570,5546,76469,2420,5302,51799,2646,5414,36501,3412,5546,18869,2412,54446,5276,6732,48422,6822,2900,28010,4826,92509,2394,5274,55883,6730,6820,47956,5812,2778,18779,2358,62615,5270,5450,46757,3492,5556,27318,4718,67887,2350,3222,52554,7498,3428,38252,5468,4700,31022,6444,64149,6804,6986,43861,2772,5338,35421,2650,70955,5418,5780,54954,5546,2740,38074,5302,2646,29991,3366,61011,3412,5546,43445,2412,5294,35406,6732,72998,6820,6996,52586,2778,2396,38045,5274,6698,23333,6820,64338,5812,2746,43355,2358,5270,39499,5450,79525,3492,5548],p=[1887,966732,967231,967733,968265,968766,969297,969798,970298,970829,971330,971830,972362,972863,973395,973896,974397,974928,975428,975929,976461,976962,977462,977994,978494,979026,979526,980026,980558,981059,981559,982091,982593,983124,983624,984124,984656,985157,985656,986189,986690,987191,987722,988222,988753,989254,989754,990286,990788,991288,991819,992319,992851,993352,993851,994383,994885,995385,995917,996418,996918,997450,997949,998481,998982,999483,1000014,1000515,1001016,1001548,1002047,1002578,1003080,1003580,1004111,1004613,1005113,1005645,1006146,1006645,1007177,1007678,1008209,1008710,1009211,1009743,1010243,1010743,1011275,1011775,1012306,1012807,1013308,1013840,1014341,1014841,1015373,1015874,1016404,1016905,1017405,1017937,1018438,1018939,1019471,1019972,1020471,1021002,1021503,1022035,1022535,1023036,1023568,1024069,1024568,1025100,1025601,1026102,1026633,1027133,1027666,1028167,1028666,1029198,1029699,1030199,1030730,1031231,1031763,1032264,1032764,1033296,1033797,1034297,1034828,1035329,1035830,1036362,1036861,1037393,1037894,1038394,1038925,1039427,1039927,1040459,1040959,1041491,1041992,1042492,1043023,1043524,1044024,1044556,1045057,1045558,1046090,1046590,1047121,1047622,1048122,1048654,1049154,1049655,1050187,1050689,1051219,1051720,1052220,1052751,1053252,1053752,1054284,1054786,1055285,1055817,1056317,1056849,1057349,1057850,1058382,1058883,1059383,1059915,1060415,1060947,1061447,1061947,1062479,1062981,1063480,1064012,1064514,1065014,1065545,1066045,1066577,1067078,1067578,1068110,1068611,1069112,1069642,1070142,1070674,1071175,1071675,1072207,1072709,1073209,1073740,1074241,1074741,1075273,1075773,1076305,1076807,1077308,1077839,1078340,1078840,1079372,1079871,1080403,1080904]},{\"../main\":580,\"object-assign\":469}],567:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Coptic\",jdEpoch:1825029.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Coptic\",epochs:[\"BAM\",\"AM\"],monthNames:[\"Thout\",\"Paopi\",\"Hathor\",\"Koiak\",\"Tobi\",\"Meshir\",\"Paremhat\",\"Paremoude\",\"Pashons\",\"Paoni\",\"Epip\",\"Mesori\",\"Pi Kogi Enavot\"],monthNamesShort:[\"Tho\",\"Pao\",\"Hath\",\"Koi\",\"Tob\",\"Mesh\",\"Pat\",\"Pad\",\"Pash\",\"Pao\",\"Epi\",\"Meso\",\"PiK\"],dayNames:[\"Tkyriaka\",\"Pesnau\",\"Pshoment\",\"Peftoou\",\"Ptiou\",\"Psoou\",\"Psabbaton\"],dayNamesShort:[\"Tky\",\"Pes\",\"Psh\",\"Pef\",\"Pti\",\"Pso\",\"Psa\"],dayNamesMin:[\"Tk\",\"Pes\",\"Psh\",\"Pef\",\"Pt\",\"Pso\",\"Psa\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==3||t%4==-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),t<0&&t++,n.day()+30*(n.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),i.calendars.coptic=n},{\"../main\":580,\"object-assign\":469}],568:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Discworld\",jdEpoch:1721425.5,daysPerMonth:[16,32,32,32,32,32,32,32,32,32,32,32,32],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Discworld\",epochs:[\"BUC\",\"UC\"],monthNames:[\"Ick\",\"Offle\",\"February\",\"March\",\"April\",\"May\",\"June\",\"Grune\",\"August\",\"Spune\",\"Sektober\",\"Ember\",\"December\"],monthNamesShort:[\"Ick\",\"Off\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Gru\",\"Aug\",\"Spu\",\"Sek\",\"Emb\",\"Dec\"],dayNames:[\"Sunday\",\"Octeday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Oct\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Oc\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:2,isRTL:!1}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),!1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),13},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),400},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/8)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]},daysInWeek:function(){return 8},dayOfWeek:function(t,e,r){return(this._validate(t,e,r,i.local.invalidDate).day()+1)%8},weekDay:function(t,e,r){var n=this.dayOfWeek(t,e,r);return n>=2&&n<=6},extraInfo:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return{century:o[Math.floor((n.year()-1)/100)+1]||\"\"}},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year()+(n.year()<0?1:0),e=n.month(),(r=n.day())+(e>1?16:0)+(e>2?32*(e-2):0)+400*(t-1)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t+.5)-Math.floor(this.jdEpoch)-1;var e=Math.floor(t/400)+1;t-=400*(e-1),t+=t>15?16:0;var r=Math.floor(t/32)+1,n=t-32*(r-1)+1;return this.newDate(e<=0?e-1:e,r,n)}});var o={20:\"Fruitbat\",21:\"Anchovy\"};i.calendars.discworld=n},{\"../main\":580,\"object-assign\":469}],569:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Ethiopian\",jdEpoch:1724220.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Ethiopian\",epochs:[\"BEE\",\"EE\"],monthNames:[\"Meskerem\",\"Tikemet\",\"Hidar\",\"Tahesas\",\"Tir\",\"Yekatit\",\"Megabit\",\"Miazia\",\"Genbot\",\"Sene\",\"Hamle\",\"Nehase\",\"Pagume\"],monthNamesShort:[\"Mes\",\"Tik\",\"Hid\",\"Tah\",\"Tir\",\"Yek\",\"Meg\",\"Mia\",\"Gen\",\"Sen\",\"Ham\",\"Neh\",\"Pag\"],dayNames:[\"Ehud\",\"Segno\",\"Maksegno\",\"Irob\",\"Hamus\",\"Arb\",\"Kidame\"],dayNamesShort:[\"Ehu\",\"Seg\",\"Mak\",\"Iro\",\"Ham\",\"Arb\",\"Kid\"],dayNamesMin:[\"Eh\",\"Se\",\"Ma\",\"Ir\",\"Ha\",\"Ar\",\"Ki\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==3||t%4==-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),t<0&&t++,n.day()+30*(n.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),i.calendars.ethiopian=n},{\"../main\":580,\"object-assign\":469}],570:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}var a=t(\"../main\"),o=t(\"object-assign\");n.prototype=new a.baseCalendar,o(n.prototype,{name:\"Hebrew\",jdEpoch:347995.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29,29],hasYearZero:!1,minMonth:1,firstMonth:7,minDay:1,regionalOptions:{\"\":{name:\"Hebrew\",epochs:[\"BAM\",\"AM\"],monthNames:[\"Nisan\",\"Iyar\",\"Sivan\",\"Tammuz\",\"Av\",\"Elul\",\"Tishrei\",\"Cheshvan\",\"Kislev\",\"Tevet\",\"Shevat\",\"Adar\",\"Adar II\"],monthNamesShort:[\"Nis\",\"Iya\",\"Siv\",\"Tam\",\"Av\",\"Elu\",\"Tis\",\"Che\",\"Kis\",\"Tev\",\"She\",\"Ada\",\"Ad2\"],dayNames:[\"Yom Rishon\",\"Yom Sheni\",\"Yom Shlishi\",\"Yom Revi'i\",\"Yom Chamishi\",\"Yom Shishi\",\"Yom Shabbat\"],dayNamesShort:[\"Ris\",\"She\",\"Shl\",\"Rev\",\"Cha\",\"Shi\",\"Sha\"],dayNamesMin:[\"Ri\",\"She\",\"Shl\",\"Re\",\"Ch\",\"Shi\",\"Sha\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear);return this._leapYear(e.year())},_leapYear:function(t){return t=t<0?t+1:t,i(7*t+1,19)<7},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,a.local.invalidYear),this._leapYear(t.year?t.year():t)?13:12},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return t=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear).year(),this.toJD(-1===t?1:t+1,7,1)-this.toJD(t,7,1)},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,a.local.invalidMonth),12===e&&this.leapYear(t)?30:8===e&&5===i(this.daysInYear(t),10)?30:9===e&&3===i(this.daysInYear(t),10)?29:this.daysPerMonth[e-1]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},extraInfo:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);return{yearType:(this.leapYear(n)?\"embolismic\":\"common\")+\" \"+[\"deficient\",\"regular\",\"complete\"][this.daysInYear(n)%10-3]}},toJD:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var i=t<=0?t+1:t,o=this.jdEpoch+this._delay1(i)+this._delay2(i)+r+1;if(e<7){for(var s=7;s<=this.monthsInYear(t);s++)o+=this.daysInMonth(t,s);for(var s=1;s<e;s++)o+=this.daysInMonth(t,s)}else for(var s=7;s<e;s++)o+=this.daysInMonth(t,s);return o},_delay1:function(t){var e=Math.floor((235*t-234)/19),r=12084+13753*e,n=29*e+Math.floor(r/25920);return i(3*(n+1),7)<3&&n++,n},_delay2:function(t){var e=this._delay1(t-1),r=this._delay1(t);return this._delay1(t+1)-r==356?2:r-e==382?1:0},fromJD:function(t){t=Math.floor(t)+.5;for(var e=Math.floor(98496*(t-this.jdEpoch)/35975351)-1;t>=this.toJD(-1===e?1:e+1,7,1);)e++;for(var r=t<this.toJD(e,1,1)?7:1;t>this.toJD(e,r,this.daysInMonth(e,r));)r++;var n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),a.calendars.hebrew=n},{\"../main\":580,\"object-assign\":469}],571:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Islamic\",jdEpoch:1948439.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Islamic\",epochs:[\"BH\",\"AH\"],monthNames:[\"Muharram\",\"Safar\",\"Rabi' al-awwal\",\"Rabi' al-thani\",\"Jumada al-awwal\",\"Jumada al-thani\",\"Rajab\",\"Sha'aban\",\"Ramadan\",\"Shawwal\",\"Dhu al-Qi'dah\",\"Dhu al-Hijjah\"],monthNamesShort:[\"Muh\",\"Saf\",\"Rab1\",\"Rab2\",\"Jum1\",\"Jum2\",\"Raj\",\"Sha'\",\"Ram\",\"Shaw\",\"DhuQ\",\"DhuH\"],dayNames:[\"Yawm al-ahad\",\"Yawm al-ithnayn\",\"Yawm ath-thulaathaa'\",\"Yawm al-arbi'aa'\",\"Yawm al-kham\\u012bs\",\"Yawm al-jum'a\",\"Yawm as-sabt\"],dayNamesShort:[\"Aha\",\"Ith\",\"Thu\",\"Arb\",\"Kha\",\"Jum\",\"Sab\"],dayNamesMin:[\"Ah\",\"It\",\"Th\",\"Ar\",\"Kh\",\"Ju\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!1}},leapYear:function(t){return(11*this._validate(t,this.minMonth,this.minDay,i.local.invalidYear).year()+14)%30<11},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return this.leapYear(t)?355:354},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),e=n.month(),r=n.day(),t=t<=0?t+1:t,r+Math.ceil(29.5*(e-1))+354*(t-1)+Math.floor((3+11*t)/30)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t)+.5;var e=Math.floor((30*(t-this.jdEpoch)+10646)/10631);e=e<=0?e-1:e;var r=Math.min(12,Math.ceil((t-29-this.toJD(e,1,1))/29.5)+1),n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),i.calendars.islamic=n},{\"../main\":580,\"object-assign\":469}],572:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Julian\",jdEpoch:1721423.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Julian\",epochs:[\"BC\",\"AD\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"mm/dd/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()<0?e.year()+1:e.year();return t%4==0},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),e=n.month(),r=n.day(),t<0&&t++,e<=2&&(t--,e+=12),Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r-1524.5},fromJD:function(t){var e=Math.floor(t+.5),r=e+1524,n=Math.floor((r-122.1)/365.25),i=Math.floor(365.25*n),a=Math.floor((r-i)/30.6001),o=a-Math.floor(a<14?1:13),s=n-Math.floor(o>2?4716:4715),l=r-i-Math.floor(30.6001*a);return s<=0&&s--,this.newDate(s,o,l)}}),i.calendars.julian=n},{\"../main\":580,\"object-assign\":469}],573:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}function a(t,e){return i(t-1,e)+1}var o=t(\"../main\"),s=t(\"object-assign\");n.prototype=new o.baseCalendar,s(n.prototype,{name:\"Mayan\",jdEpoch:584282.5,hasYearZero:!0,minMonth:0,firstMonth:0,minDay:0,regionalOptions:{\"\":{name:\"Mayan\",epochs:[\"\",\"\"],monthNames:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\"],monthNamesShort:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\"],dayNames:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],dayNamesShort:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],dayNamesMin:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],digits:null,dateFormat:\"YYYY.m.d\",firstDay:0,isRTL:!1,haabMonths:[\"Pop\",\"Uo\",\"Zip\",\"Zotz\",\"Tzec\",\"Xul\",\"Yaxkin\",\"Mol\",\"Chen\",\"Yax\",\"Zac\",\"Ceh\",\"Mac\",\"Kankin\",\"Muan\",\"Pax\",\"Kayab\",\"Cumku\",\"Uayeb\"],tzolkinMonths:[\"Imix\",\"Ik\",\"Akbal\",\"Kan\",\"Chicchan\",\"Cimi\",\"Manik\",\"Lamat\",\"Muluc\",\"Oc\",\"Chuen\",\"Eb\",\"Ben\",\"Ix\",\"Men\",\"Cib\",\"Caban\",\"Etznab\",\"Cauac\",\"Ahau\"]}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),!1},formatYear:function(t){t=this._validate(t,this.minMonth,this.minDay,o.local.invalidYear).year();var e=Math.floor(t/400);return t%=400,t+=t<0?400:0,e+\".\"+Math.floor(t/20)+\".\"+t%20},forYear:function(t){if(t=t.split(\".\"),t.length<3)throw\"Invalid Mayan year\";for(var e=0,r=0;r<t.length;r++){var n=parseInt(t[r],10);if(Math.abs(n)>19||r>0&&n<0)throw\"Invalid Mayan year\";e=20*e+n}return e},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),18},weekOfYear:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate),0},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),360},daysInMonth:function(t,e){return this._validate(t,e,this.minDay,o.local.invalidMonth),20},daysInWeek:function(){return 5},dayOfWeek:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate).day()},weekDay:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate),!0},extraInfo:function(t,e,r){var n=this._validate(t,e,r,o.local.invalidDate),i=n.toJD(),a=this._toHaab(i),s=this._toTzolkin(i);return{haabMonthName:this.local.haabMonths[a[0]-1],haabMonth:a[0],haabDay:a[1],tzolkinDayName:this.local.tzolkinMonths[s[0]-1],tzolkinDay:s[0],tzolkinTrecena:s[1]}},_toHaab:function(t){t-=this.jdEpoch;var e=i(t+8+340,365);return[Math.floor(e/20)+1,i(e,20)]},_toTzolkin:function(t){return t-=this.jdEpoch,[a(t+20,20),a(t+4,13)]},toJD:function(t,e,r){var n=this._validate(t,e,r,o.local.invalidDate);return n.day()+20*n.month()+360*n.year()+this.jdEpoch},fromJD:function(t){t=Math.floor(t)+.5-this.jdEpoch;var e=Math.floor(t/360);t%=360,t+=t<0?360:0;var r=Math.floor(t/20),n=t%20;return this.newDate(e,r,n)}}),o.calendars.mayan=n},{\"../main\":580,\"object-assign\":469}],574:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar;var o=i.instance(\"gregorian\");a(n.prototype,{name:\"Nanakshahi\",jdEpoch:2257673.5,daysPerMonth:[31,31,31,31,31,30,30,30,30,30,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Nanakshahi\",epochs:[\"BN\",\"AN\"],monthNames:[\"Chet\",\"Vaisakh\",\"Jeth\",\"Harh\",\"Sawan\",\"Bhadon\",\"Assu\",\"Katak\",\"Maghar\",\"Poh\",\"Magh\",\"Phagun\"],monthNamesShort:[\"Che\",\"Vai\",\"Jet\",\"Har\",\"Saw\",\"Bha\",\"Ass\",\"Kat\",\"Mgr\",\"Poh\",\"Mgh\",\"Pha\"],dayNames:[\"Somvaar\",\"Mangalvar\",\"Budhvaar\",\"Veervaar\",\"Shukarvaar\",\"Sanicharvaar\",\"Etvaar\"],dayNamesShort:[\"Som\",\"Mangal\",\"Budh\",\"Veer\",\"Shukar\",\"Sanichar\",\"Et\"],dayNamesMin:[\"So\",\"Ma\",\"Bu\",\"Ve\",\"Sh\",\"Sa\",\"Et\"],digits:null,dateFormat:\"dd-mm-yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear);return o.leapYear(e.year()+(e.year()<1?1:0)+1469)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(1-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidMonth),t=n.year();t<0&&t++;for(var a=n.day(),s=1;s<n.month();s++)a+=this.daysPerMonth[s-1];return a+o.toJD(t+1468,3,13)},fromJD:function(t){t=Math.floor(t+.5);for(var e=Math.floor((t-(this.jdEpoch-1))/366);t>=this.toJD(e+1,1,1);)e++;for(var r=t-Math.floor(this.toJD(e,1,1)+.5)+1,n=1;r>this.daysInMonth(e,n);)r-=this.daysInMonth(e,n),n++;return this.newDate(e,n,r)}}),i.calendars.nanakshahi=n},{\"../main\":580,\"object-assign\":469}],575:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Nepali\",jdEpoch:1700709.5,daysPerMonth:[31,31,32,32,31,30,30,29,30,29,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,daysPerYear:365,regionalOptions:{\"\":{name:\"Nepali\",epochs:[\"BBS\",\"ABS\"],monthNames:[\"Baisakh\",\"Jestha\",\"Ashadh\",\"Shrawan\",\"Bhadra\",\"Ashwin\",\"Kartik\",\"Mangsir\",\"Paush\",\"Mangh\",\"Falgun\",\"Chaitra\"],monthNamesShort:[\"Bai\",\"Je\",\"As\",\"Shra\",\"Bha\",\"Ash\",\"Kar\",\"Mang\",\"Pau\",\"Ma\",\"Fal\",\"Chai\"],dayNames:[\"Aaitabaar\",\"Sombaar\",\"Manglbaar\",\"Budhabaar\",\"Bihibaar\",\"Shukrabaar\",\"Shanibaar\"],dayNamesShort:[\"Aaita\",\"Som\",\"Mangl\",\"Budha\",\"Bihi\",\"Shukra\",\"Shani\"],dayNamesMin:[\"Aai\",\"So\",\"Man\",\"Bu\",\"Bi\",\"Shu\",\"Sha\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:1,isRTL:!1}},leapYear:function(t){return this.daysInYear(t)!==this.daysPerYear},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){if(t=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear).year(),void 0===this.NEPALI_CALENDAR_DATA[t])return this.daysPerYear;for(var e=0,r=this.minMonth;r<=12;r++)e+=this.NEPALI_CALENDAR_DATA[t][r];return e},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,i.local.invalidMonth),void 0===this.NEPALI_CALENDAR_DATA[t]?this.daysPerMonth[e-1]:this.NEPALI_CALENDAR_DATA[t][e]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var a=i.instance(),o=0,s=e,l=t;this._createMissingCalendarData(t);var u=t-(s>9||9===s&&r>=this.NEPALI_CALENDAR_DATA[l][0]?56:57);for(9!==e&&(o=r,\n",
       "s--);9!==s;)s<=0&&(s=12,l--),o+=this.NEPALI_CALENDAR_DATA[l][s],s--;return 9===e?(o+=r-this.NEPALI_CALENDAR_DATA[l][0])<0&&(o+=a.daysInYear(u)):o+=this.NEPALI_CALENDAR_DATA[l][9]-this.NEPALI_CALENDAR_DATA[l][0],a.newDate(u,1,1).add(o,\"d\").toJD()},fromJD:function(t){var e=i.instance(),r=e.fromJD(t),n=r.year(),a=r.dayOfYear(),o=n+56;this._createMissingCalendarData(o);for(var s=9,l=this.NEPALI_CALENDAR_DATA[o][0],u=this.NEPALI_CALENDAR_DATA[o][s]-l+1;a>u;)s++,s>12&&(s=1,o++),u+=this.NEPALI_CALENDAR_DATA[o][s];var c=this.NEPALI_CALENDAR_DATA[o][s]-(u-a);return this.newDate(o,s,c)},_createMissingCalendarData:function(t){var e=this.daysPerMonth.slice(0);e.unshift(17);for(var r=t-1;r<t+2;r++)void 0===this.NEPALI_CALENDAR_DATA[r]&&(this.NEPALI_CALENDAR_DATA[r]=e)},NEPALI_CALENDAR_DATA:{1970:[18,31,31,32,31,31,31,30,29,30,29,30,30],1971:[18,31,31,32,31,32,30,30,29,30,29,30,30],1972:[17,31,32,31,32,31,30,30,30,29,29,30,30],1973:[19,30,32,31,32,31,30,30,30,29,30,29,31],1974:[19,31,31,32,30,31,31,30,29,30,29,30,30],1975:[18,31,31,32,32,30,31,30,29,30,29,30,30],1976:[17,31,32,31,32,31,30,30,30,29,29,30,31],1977:[18,31,32,31,32,31,31,29,30,29,30,29,31],1978:[18,31,31,32,31,31,31,30,29,30,29,30,30],1979:[18,31,31,32,32,31,30,30,29,30,29,30,30],1980:[17,31,32,31,32,31,30,30,30,29,29,30,31],1981:[18,31,31,31,32,31,31,29,30,30,29,30,30],1982:[18,31,31,32,31,31,31,30,29,30,29,30,30],1983:[18,31,31,32,32,31,30,30,29,30,29,30,30],1984:[17,31,32,31,32,31,30,30,30,29,29,30,31],1985:[18,31,31,31,32,31,31,29,30,30,29,30,30],1986:[18,31,31,32,31,31,31,30,29,30,29,30,30],1987:[18,31,32,31,32,31,30,30,29,30,29,30,30],1988:[17,31,32,31,32,31,30,30,30,29,29,30,31],1989:[18,31,31,31,32,31,31,30,29,30,29,30,30],1990:[18,31,31,32,31,31,31,30,29,30,29,30,30],1991:[18,31,32,31,32,31,30,30,29,30,29,30,30],1992:[17,31,32,31,32,31,30,30,30,29,30,29,31],1993:[18,31,31,31,32,31,31,30,29,30,29,30,30],1994:[18,31,31,32,31,31,31,30,29,30,29,30,30],1995:[17,31,32,31,32,31,30,30,30,29,29,30,30],1996:[17,31,32,31,32,31,30,30,30,29,30,29,31],1997:[18,31,31,32,31,31,31,30,29,30,29,30,30],1998:[18,31,31,32,31,31,31,30,29,30,29,30,30],1999:[17,31,32,31,32,31,30,30,30,29,29,30,31],2e3:[17,30,32,31,32,31,30,30,30,29,30,29,31],2001:[18,31,31,32,31,31,31,30,29,30,29,30,30],2002:[18,31,31,32,32,31,30,30,29,30,29,30,30],2003:[17,31,32,31,32,31,30,30,30,29,29,30,31],2004:[17,30,32,31,32,31,30,30,30,29,30,29,31],2005:[18,31,31,32,31,31,31,30,29,30,29,30,30],2006:[18,31,31,32,32,31,30,30,29,30,29,30,30],2007:[17,31,32,31,32,31,30,30,30,29,29,30,31],2008:[17,31,31,31,32,31,31,29,30,30,29,29,31],2009:[18,31,31,32,31,31,31,30,29,30,29,30,30],2010:[18,31,31,32,32,31,30,30,29,30,29,30,30],2011:[17,31,32,31,32,31,30,30,30,29,29,30,31],2012:[17,31,31,31,32,31,31,29,30,30,29,30,30],2013:[18,31,31,32,31,31,31,30,29,30,29,30,30],2014:[18,31,31,32,32,31,30,30,29,30,29,30,30],2015:[17,31,32,31,32,31,30,30,30,29,29,30,31],2016:[17,31,31,31,32,31,31,29,30,30,29,30,30],2017:[18,31,31,32,31,31,31,30,29,30,29,30,30],2018:[18,31,32,31,32,31,30,30,29,30,29,30,30],2019:[17,31,32,31,32,31,30,30,30,29,30,29,31],2020:[17,31,31,31,32,31,31,30,29,30,29,30,30],2021:[18,31,31,32,31,31,31,30,29,30,29,30,30],2022:[17,31,32,31,32,31,30,30,30,29,29,30,30],2023:[17,31,32,31,32,31,30,30,30,29,30,29,31],2024:[17,31,31,31,32,31,31,30,29,30,29,30,30],2025:[18,31,31,32,31,31,31,30,29,30,29,30,30],2026:[17,31,32,31,32,31,30,30,30,29,29,30,31],2027:[17,30,32,31,32,31,30,30,30,29,30,29,31],2028:[17,31,31,32,31,31,31,30,29,30,29,30,30],2029:[18,31,31,32,31,32,30,30,29,30,29,30,30],2030:[17,31,32,31,32,31,30,30,30,30,30,30,31],2031:[17,31,32,31,32,31,31,31,31,31,31,31,31],2032:[17,32,32,32,32,32,32,32,32,32,32,32,32],2033:[18,31,31,32,32,31,30,30,29,30,29,30,30],2034:[17,31,32,31,32,31,30,30,30,29,29,30,31],2035:[17,30,32,31,32,31,31,29,30,30,29,29,31],2036:[17,31,31,32,31,31,31,30,29,30,29,30,30],2037:[18,31,31,32,32,31,30,30,29,30,29,30,30],2038:[17,31,32,31,32,31,30,30,30,29,29,30,31],2039:[17,31,31,31,32,31,31,29,30,30,29,30,30],2040:[17,31,31,32,31,31,31,30,29,30,29,30,30],2041:[18,31,31,32,32,31,30,30,29,30,29,30,30],2042:[17,31,32,31,32,31,30,30,30,29,29,30,31],2043:[17,31,31,31,32,31,31,29,30,30,29,30,30],2044:[17,31,31,32,31,31,31,30,29,30,29,30,30],2045:[18,31,32,31,32,31,30,30,29,30,29,30,30],2046:[17,31,32,31,32,31,30,30,30,29,29,30,31],2047:[17,31,31,31,32,31,31,30,29,30,29,30,30],2048:[17,31,31,32,31,31,31,30,29,30,29,30,30],2049:[17,31,32,31,32,31,30,30,30,29,29,30,30],2050:[17,31,32,31,32,31,30,30,30,29,30,29,31],2051:[17,31,31,31,32,31,31,30,29,30,29,30,30],2052:[17,31,31,32,31,31,31,30,29,30,29,30,30],2053:[17,31,32,31,32,31,30,30,30,29,29,30,30],2054:[17,31,32,31,32,31,30,30,30,29,30,29,31],2055:[17,31,31,32,31,31,31,30,29,30,30,29,30],2056:[17,31,31,32,31,32,30,30,29,30,29,30,30],2057:[17,31,32,31,32,31,30,30,30,29,29,30,31],2058:[17,30,32,31,32,31,30,30,30,29,30,29,31],2059:[17,31,31,32,31,31,31,30,29,30,29,30,30],2060:[17,31,31,32,32,31,30,30,29,30,29,30,30],2061:[17,31,32,31,32,31,30,30,30,29,29,30,31],2062:[17,30,32,31,32,31,31,29,30,29,30,29,31],2063:[17,31,31,32,31,31,31,30,29,30,29,30,30],2064:[17,31,31,32,32,31,30,30,29,30,29,30,30],2065:[17,31,32,31,32,31,30,30,30,29,29,30,31],2066:[17,31,31,31,32,31,31,29,30,30,29,29,31],2067:[17,31,31,32,31,31,31,30,29,30,29,30,30],2068:[17,31,31,32,32,31,30,30,29,30,29,30,30],2069:[17,31,32,31,32,31,30,30,30,29,29,30,31],2070:[17,31,31,31,32,31,31,29,30,30,29,30,30],2071:[17,31,31,32,31,31,31,30,29,30,29,30,30],2072:[17,31,32,31,32,31,30,30,29,30,29,30,30],2073:[17,31,32,31,32,31,30,30,30,29,29,30,31],2074:[17,31,31,31,32,31,31,30,29,30,29,30,30],2075:[17,31,31,32,31,31,31,30,29,30,29,30,30],2076:[16,31,32,31,32,31,30,30,30,29,29,30,30],2077:[17,31,32,31,32,31,30,30,30,29,30,29,31],2078:[17,31,31,31,32,31,31,30,29,30,29,30,30],2079:[17,31,31,32,31,31,31,30,29,30,29,30,30],2080:[16,31,32,31,32,31,30,30,30,29,29,30,30],2081:[17,31,31,32,32,31,30,30,30,29,30,30,30],2082:[17,31,32,31,32,31,30,30,30,29,30,30,30],2083:[17,31,31,32,31,31,30,30,30,29,30,30,30],2084:[17,31,31,32,31,31,30,30,30,29,30,30,30],2085:[17,31,32,31,32,31,31,30,30,29,30,30,30],2086:[17,31,32,31,32,31,30,30,30,29,30,30,30],2087:[16,31,31,32,31,31,31,30,30,29,30,30,30],2088:[16,30,31,32,32,30,31,30,30,29,30,30,30],2089:[17,31,32,31,32,31,30,30,30,29,30,30,30],2090:[17,31,32,31,32,31,30,30,30,29,30,30,30],2091:[16,31,31,32,31,31,31,30,30,29,30,30,30],2092:[16,31,31,32,32,31,30,30,30,29,30,30,30],2093:[17,31,32,31,32,31,30,30,30,29,30,30,30],2094:[17,31,31,32,31,31,30,30,30,29,30,30,30],2095:[17,31,31,32,31,31,31,30,29,30,30,30,30],2096:[17,30,31,32,32,31,30,30,29,30,29,30,30],2097:[17,31,32,31,32,31,30,30,30,29,30,30,30],2098:[17,31,31,32,31,31,31,29,30,29,30,30,31],2099:[17,31,31,32,31,31,31,30,29,29,30,30,30],2100:[17,31,32,31,32,30,31,30,29,30,29,30,30]}}),i.calendars.nepali=n},{\"../main\":580,\"object-assign\":469}],576:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}var a=t(\"../main\"),o=t(\"object-assign\");n.prototype=new a.baseCalendar,o(n.prototype,{name:\"Persian\",jdEpoch:1948320.5,daysPerMonth:[31,31,31,31,31,31,30,30,30,30,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Persian\",epochs:[\"BP\",\"AP\"],monthNames:[\"Farvardin\",\"Ordibehesht\",\"Khordad\",\"Tir\",\"Mordad\",\"Shahrivar\",\"Mehr\",\"Aban\",\"Azar\",\"Day\",\"Bahman\",\"Esfand\"],monthNamesShort:[\"Far\",\"Ord\",\"Kho\",\"Tir\",\"Mor\",\"Sha\",\"Meh\",\"Aba\",\"Aza\",\"Day\",\"Bah\",\"Esf\"],dayNames:[\"Yekshambe\",\"Doshambe\",\"Seshambe\",\"Ch\\xe6harshambe\",\"Panjshambe\",\"Jom'e\",\"Shambe\"],dayNamesShort:[\"Yek\",\"Do\",\"Se\",\"Ch\\xe6\",\"Panj\",\"Jom\",\"Sha\"],dayNamesMin:[\"Ye\",\"Do\",\"Se\",\"Ch\",\"Pa\",\"Jo\",\"Sh\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear);return 682*((e.year()-(e.year()>0?474:473))%2820+474+38)%2816<682},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-(n.dayOfWeek()+1)%7,\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,a.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var o=t-(t>=0?474:473),s=474+i(o,2820);return r+(e<=7?31*(e-1):30*(e-1)+6)+Math.floor((682*s-110)/2816)+365*(s-1)+1029983*Math.floor(o/2820)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t)+.5;var e=t-this.toJD(475,1,1),r=Math.floor(e/1029983),n=i(e,1029983),a=2820;if(1029982!==n){var o=Math.floor(n/366),s=i(n,366);a=Math.floor((2134*o+2816*s+2815)/1028522)+o+1}var l=a+2820*r+474;l=l<=0?l-1:l;var u=t-this.toJD(l,1,1)+1,c=u<=186?Math.ceil(u/31):Math.ceil((u-6)/30),h=t-this.toJD(l,c,1)+1;return this.newDate(l,c,h)}}),a.calendars.persian=n,a.calendars.jalali=n},{\"../main\":580,\"object-assign\":469}],577:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\"),o=i.instance();n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Taiwan\",jdEpoch:2419402.5,yearsOffset:1911,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Taiwan\",epochs:[\"BROC\",\"ROC\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:1,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(e.year());return o.leapYear(t)},weekOfYear:function(t,e,r){var n=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(n.year());return o.weekOfYear(t,n.month(),n.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),t=this._t2gYear(n.year());return o.toJD(t,n.month(),n.day())},fromJD:function(t){var e=o.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)},_g2tYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)}}),i.calendars.taiwan=n},{\"../main\":580,\"object-assign\":469}],578:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\"),o=i.instance();n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Thai\",jdEpoch:1523098.5,yearsOffset:543,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Thai\",epochs:[\"BBE\",\"BE\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(e.year());return o.leapYear(t)},weekOfYear:function(t,e,r){var n=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(n.year());return o.weekOfYear(t,n.month(),n.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),t=this._t2gYear(n.year());return o.toJD(t,n.month(),n.day())},fromJD:function(t){var e=o.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)},_g2tYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)}}),i.calendars.thai=n},{\"../main\":580,\"object-assign\":469}],579:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"UmmAlQura\",hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Umm al-Qura\",epochs:[\"BH\",\"AH\"],monthNames:[\"Al-Muharram\",\"Safar\",\"Rabi' al-awwal\",\"Rabi' Al-Thani\",\"Jumada Al-Awwal\",\"Jumada Al-Thani\",\"Rajab\",\"Sha'aban\",\"Ramadan\",\"Shawwal\",\"Dhu al-Qi'dah\",\"Dhu al-Hijjah\"],monthNamesShort:[\"Muh\",\"Saf\",\"Rab1\",\"Rab2\",\"Jum1\",\"Jum2\",\"Raj\",\"Sha'\",\"Ram\",\"Shaw\",\"DhuQ\",\"DhuH\"],dayNames:[\"Yawm al-Ahad\",\"Yawm al-Ithnain\",\"Yawm al-Thal\\u0101th\\u0101\\u2019\",\"Yawm al-Arba\\u2018\\u0101\\u2019\",\"Yawm al-Kham\\u012bs\",\"Yawm al-Jum\\u2018a\",\"Yawm al-Sabt\"],dayNamesMin:[\"Ah\",\"Ith\",\"Th\",\"Ar\",\"Kh\",\"Ju\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!0}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear);return 355===this.daysInYear(e.year())},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){for(var e=0,r=1;r<=12;r++)e+=this.daysInMonth(t,r);return e},daysInMonth:function(t,e){for(var r=this._validate(t,e,this.minDay,i.local.invalidMonth),n=r.toJD()-24e5+.5,a=0,s=0;s<o.length;s++){if(o[s]>n)return o[a]-o[a-1];a++}return 30},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),a=12*(n.year()-1)+n.month()-15292;return n.day()+o[a-1]-1+24e5-.5},fromJD:function(t){for(var e=t-24e5+.5,r=0,n=0;n<o.length&&!(o[n]>e);n++)r++;var i=r+15292,a=Math.floor((i-1)/12),s=a+1,l=i-12*a,u=e-o[r-1]+1;return this.newDate(s,l,u)},isValid:function(t,e,r){var n=i.baseCalendar.prototype.isValid.apply(this,arguments);return n&&(t=null!=t.year?t.year:t,n=t>=1276&&t<=1500),n},_validate:function(t,e,r,n){var a=i.baseCalendar.prototype._validate.apply(this,arguments);if(a.year<1276||a.year>1500)throw n.replace(/\\{0\\}/,this.local.name);return a}}),i.calendars.ummalqura=n;var o=[20,50,79,109,138,168,197,227,256,286,315,345,374,404,433,463,492,522,551,581,611,641,670,700,729,759,788,818,847,877,906,936,965,995,1024,1054,1083,1113,1142,1172,1201,1231,1260,1290,1320,1350,1379,1409,1438,1468,1497,1527,1556,1586,1615,1645,1674,1704,1733,1763,1792,1822,1851,1881,1910,1940,1969,1999,2028,2058,2087,2117,2146,2176,2205,2235,2264,2294,2323,2353,2383,2413,2442,2472,2501,2531,2560,2590,2619,2649,2678,2708,2737,2767,2796,2826,2855,2885,2914,2944,2973,3003,3032,3062,3091,3121,3150,3180,3209,3239,3268,3298,3327,3357,3386,3416,3446,3476,3505,3535,3564,3594,3623,3653,3682,3712,3741,3771,3800,3830,3859,3889,3918,3948,3977,4007,4036,4066,4095,4125,4155,4185,4214,4244,4273,4303,4332,4362,4391,4421,4450,4480,4509,4539,4568,4598,4627,4657,4686,4716,4745,4775,4804,4834,4863,4893,4922,4952,4981,5011,5040,5070,5099,5129,5158,5188,5218,5248,5277,5307,5336,5366,5395,5425,5454,5484,5513,5543,5572,5602,5631,5661,5690,5720,5749,5779,5808,5838,5867,5897,5926,5956,5985,6015,6044,6074,6103,6133,6162,6192,6221,6251,6281,6311,6340,6370,6399,6429,6458,6488,6517,6547,6576,6606,6635,6665,6694,6724,6753,6783,6812,6842,6871,6901,6930,6960,6989,7019,7048,7078,7107,7137,7166,7196,7225,7255,7284,7314,7344,7374,7403,7433,7462,7492,7521,7551,7580,7610,7639,7669,7698,7728,7757,7787,7816,7846,7875,7905,7934,7964,7993,8023,8053,8083,8112,8142,8171,8201,8230,8260,8289,8319,8348,8378,8407,8437,8466,8496,8525,8555,8584,8614,8643,8673,8702,8732,8761,8791,8821,8850,8880,8909,8938,8968,8997,9027,9056,9086,9115,9145,9175,9205,9234,9264,9293,9322,9352,9381,9410,9440,9470,9499,9529,9559,9589,9618,9648,9677,9706,9736,9765,9794,9824,9853,9883,9913,9943,9972,10002,10032,10061,10090,10120,10149,10178,10208,10237,10267,10297,10326,10356,10386,10415,10445,10474,10504,10533,10562,10592,10621,10651,10680,10710,10740,10770,10799,10829,10858,10888,10917,10947,10976,11005,11035,11064,11094,11124,11153,11183,11213,11242,11272,11301,11331,11360,11389,11419,11448,11478,11507,11537,11567,11596,11626,11655,11685,11715,11744,11774,11803,11832,11862,11891,11921,11950,11980,12010,12039,12069,12099,12128,12158,12187,12216,12246,12275,12304,12334,12364,12393,12423,12453,12483,12512,12542,12571,12600,12630,12659,12688,12718,12747,12777,12807,12837,12866,12896,12926,12955,12984,13014,13043,13072,13102,13131,13161,13191,13220,13250,13280,13310,13339,13368,13398,13427,13456,13486,13515,13545,13574,13604,13634,13664,13693,13723,13752,13782,13811,13840,13870,13899,13929,13958,13988,14018,14047,14077,14107,14136,14166,14195,14224,14254,14283,14313,14342,14372,14401,14431,14461,14490,14520,14550,14579,14609,14638,14667,14697,14726,14756,14785,14815,14844,14874,14904,14933,14963,14993,15021,15051,15081,15110,15140,15169,15199,15228,15258,15287,15317,15347,15377,15406,15436,15465,15494,15524,15553,15582,15612,15641,15671,15701,15731,15760,15790,15820,15849,15878,15908,15937,15966,15996,16025,16055,16085,16114,16144,16174,16204,16233,16262,16292,16321,16350,16380,16409,16439,16468,16498,16528,16558,16587,16617,16646,16676,16705,16734,16764,16793,16823,16852,16882,16912,16941,16971,17001,17030,17060,17089,17118,17148,17177,17207,17236,17266,17295,17325,17355,17384,17414,17444,17473,17502,17532,17561,17591,17620,17650,17679,17709,17738,17768,17798,17827,17857,17886,17916,17945,17975,18004,18034,18063,18093,18122,18152,18181,18211,18241,18270,18300,18330,18359,18388,18418,18447,18476,18506,18535,18565,18595,18625,18654,18684,18714,18743,18772,18802,18831,18860,18890,18919,18949,18979,19008,19038,19068,19098,19127,19156,19186,19215,19244,19274,19303,19333,19362,19392,19422,19452,19481,19511,19540,19570,19599,19628,19658,19687,19717,19746,19776,19806,19836,19865,19895,19924,19954,19983,20012,20042,20071,20101,20130,20160,20190,20219,20249,20279,20308,20338,20367,20396,20426,20455,20485,20514,20544,20573,20603,20633,20662,20692,20721,20751,20780,20810,20839,20869,20898,20928,20957,20987,21016,21046,21076,21105,21135,21164,21194,21223,21253,21282,21312,21341,21371,21400,21430,21459,21489,21519,21548,21578,21607,21637,21666,21696,21725,21754,21784,21813,21843,21873,21902,21932,21962,21991,22021,22050,22080,22109,22138,22168,22197,22227,22256,22286,22316,22346,22375,22405,22434,22464,22493,22522,22552,22581,22611,22640,22670,22700,22730,22759,22789,22818,22848,22877,22906,22936,22965,22994,23024,23054,23083,23113,23143,23173,23202,23232,23261,23290,23320,23349,23379,23408,23438,23467,23497,23527,23556,23586,23616,23645,23674,23704,23733,23763,23792,23822,23851,23881,23910,23940,23970,23999,24029,24058,24088,24117,24147,24176,24206,24235,24265,24294,24324,24353,24383,24413,24442,24472,24501,24531,24560,24590,24619,24648,24678,24707,24737,24767,24796,24826,24856,24885,24915,24944,24974,25003,25032,25062,25091,25121,25150,25180,25210,25240,25269,25299,25328,25358,25387,25416,25446,25475,25505,25534,25564,25594,25624,25653,25683,25712,25742,25771,25800,25830,25859,25888,25918,25948,25977,26007,26037,26067,26096,26126,26155,26184,26214,26243,26272,26302,26332,26361,26391,26421,26451,26480,26510,26539,26568,26598,26627,26656,26686,26715,26745,26775,26805,26834,26864,26893,26923,26952,26982,27011,27041,27070,27099,27129,27159,27188,27218,27248,27277,27307,27336,27366,27395,27425,27454,27484,27513,27542,27572,27602,27631,27661,27691,27720,27750,27779,27809,27838,27868,27897,27926,27956,27985,28015,28045,28074,28104,28134,28163,28193,28222,28252,28281,28310,28340,28369,28399,28428,28458,28488,28517,28547,28577,28607,28636,28665,28695,28724,28754,28783,28813,28843,28872,28901,28931,28960,28990,29019,29049,29078,29108,29137,29167,29196,29226,29255,29285,29315,29345,29375,29404,29434,29463,29492,29522,29551,29580,29610,29640,29669,29699,29729,29759,29788,29818,29847,29876,29906,29935,29964,29994,30023,30053,30082,30112,30141,30171,30200,30230,30259,30289,30318,30348,30378,30408,30437,30467,30496,30526,30555,30585,30614,30644,30673,30703,30732,30762,30791,30821,30850,30880,30909,30939,30968,30998,31027,31057,31086,31116,31145,31175,31204,31234,31263,31293,31322,31352,31381,31411,31441,31471,31500,31530,31559,31589,31618,31648,31676,31706,31736,31766,31795,31825,31854,31884,31913,31943,31972,32002,32031,32061,32090,32120,32150,32180,32209,32239,32268,32298,32327,32357,32386,32416,32445,32475,32504,32534,32563,32593,32622,32652,32681,32711,32740,32770,32799,32829,32858,32888,32917,32947,32976,33006,33035,33065,33094,33124,33153,33183,33213,33243,33272,33302,33331,33361,33390,33420,33450,33479,33509,33539,33568,33598,33627,33657,33686,33716,33745,33775,33804,33834,33863,33893,33922,33952,33981,34011,34040,34069,34099,34128,34158,34187,34217,34247,34277,34306,34336,34365,34395,34424,34454,34483,34512,34542,34571,34601,34631,34660,34690,34719,34749,34778,34808,34837,34867,34896,34926,34955,34985,35015,35044,35074,35103,35133,35162,35192,35222,35251,35280,35310,35340,35370,35399,35429,35458,35488,35517,35547,35576,35605,35635,35665,35694,35723,35753,35782,35811,35841,35871,35901,35930,35960,35989,36019,36048,36078,36107,36136,36166,36195,36225,36254,36284,36314,36343,36373,36403,36433,36462,36492,36521,36551,36580,36610,36639,36669,36698,36728,36757,36786,36816,36845,36875,36904,36934,36963,36993,37022,37052,37081,37111,37141,37170,37200,37229,37259,37288,37318,37347,37377,37406,37436,37465,37495,37524,37554,37584,37613,37643,37672,37701,37731,37760,37790,37819,37849,37878,37908,37938,37967,37997,38027,38056,38085,38115,38144,38174,38203,38233,38262,38292,38322,38351,38381,38410,38440,38469,38499,38528,38558,38587,38617,38646,38676,38705,38735,38764,38794,38823,38853,38882,38912,38941,38971,39001,39030,39059,39089,39118,39148,39178,39208,39237,39267,39297,39326,39355,39385,39414,39444,39473,39503,39532,39562,39592,39621,39650,39680,39709,39739,39768,39798,39827,39857,39886,39916,39946,39975,40005,40035,40064,40094,40123,40153,40182,40212,40241,40271,40300,40330,40359,40389,40418,40448,40477,40507,40536,40566,40595,40625,40655,40685,40714,40744,40773,40803,40832,40862,40892,40921,40951,40980,41009,41039,41068,41098,41127,41157,41186,41216,41245,41275,41304,41334,41364,41393,41422,41452,41481,41511,41540,41570,41599,41629,41658,41688,41718,41748,41777,41807,41836,41865,41894,41924,41953,41983,42012,42042,42072,42102,42131,42161,42190,42220,42249,42279,42308,42337,42367,42397,42426,42456,42485,42515,42545,42574,42604,42633,42662,42692,42721,42751,42780,42810,42839,42869,42899,42929,42958,42988,43017,43046,43076,43105,43135,43164,43194,43223,43253,43283,43312,43342,43371,43401,43430,43460,43489,43519,43548,43578,43607,43637,43666,43696,43726,43755,43785,43814,43844,43873,43903,43932,43962,43991,44021,44050,44080,44109,44139,44169,44198,44228,44258,44287,44317,44346,44375,44405,44434,44464,44493,44523,44553,44582,44612,44641,44671,44700,44730,44759,44788,44818,44847,44877,44906,44936,44966,44996,45025,45055,45084,45114,45143,45172,45202,45231,45261,45290,45320,45350,45380,45409,45439,45468,45498,45527,45556,45586,45615,45644,45674,45704,45733,45763,45793,45823,45852,45882,45911,45940,45970,45999,46028,46058,46088,46117,46147,46177,46206,46236,46265,46295,46324,46354,46383,46413,46442,46472,46501,46531,46560,46590,46620,46649,46679,46708,46738,46767,46797,46826,46856,46885,46915,46944,46974,47003,47033,47063,47092,47122,47151,47181,47210,47240,47269,47298,47328,47357,47387,47417,47446,47476,47506,47535,47565,47594,47624,47653,47682,47712,47741,47771,47800,47830,47860,47890,47919,47949,47978,48008,48037,48066,48096,48125,48155,48184,48214,48244,48273,48303,48333,48362,48392,48421,48450,48480,48509,48538,48568,48598,48627,48657,48687,48717,48746,48776,48805,48834,48864,48893,48922,48952,48982,49011,49041,49071,49100,49130,49160,49189,49218,49248,49277,49306,49336,49365,49395,49425,49455,49484,49514,49543,49573,49602,49632,49661,49690,49720,49749,49779,49809,49838,49868,49898,49927,49957,49986,50016,50045,50075,50104,50133,50163,50192,50222,50252,50281,50311,50340,50370,50400,50429,50459,50488,50518,50547,50576,50606,50635,50665,50694,50724,50754,50784,50813,50843,50872,50902,50931,50960,50990,51019,51049,51078,51108,51138,51167,51197,51227,51256,51286,51315,51345,51374,51403,51433,51462,51492,51522,51552,51582,51611,51641,51670,51699,51729,51758,51787,51816,51846,51876,51906,51936,51965,51995,52025,52054,52083,52113,52142,52171,52200,52230,52260,52290,52319,52349,52379,52408,52438,52467,52497,52526,52555,52585,52614,52644,52673,52703,52733,52762,52792,52822,52851,52881,52910,52939,52969,52998,53028,53057,53087,53116,53146,53176,53205,53235,53264,53294,53324,53353,53383,53412,53441,53471,53500,53530,53559,53589,53619,53648,53678,53708,53737,53767,53796,53825,53855,53884,53913,53943,53973,54003,54032,54062,54092,54121,54151,54180,54209,54239,54268,54297,54327,54357,54387,54416,54446,54476,54505,54535,54564,54593,54623,54652,54681,54711,54741,54770,54800,54830,54859,54889,54919,54948,54977,55007,55036,55066,55095,55125,55154,55184,55213,55243,55273,55302,55332,55361,55391,55420,55450,55479,55508,55538,55567,55597,55627,55657,55686,55716,55745,55775,55804,55834,55863,55892,55922,55951,55981,56011,56040,56070,56100,56129,56159,56188,56218,56247,56276,56306,56335,56365,56394,56424,56454,56483,56513,56543,56572,56601,56631,56660,56690,56719,56749,56778,56808,56837,56867,56897,56926,56956,56985,57015,57044,57074,57103,57133,57162,57192,57221,57251,57280,57310,57340,57369,57399,57429,57458,57487,57517,57546,57576,57605,57634,57664,57694,57723,57753,57783,57813,57842,57871,57901,57930,57959,57989,58018,58048,58077,58107,58137,58167,58196,58226,58255,58285,58314,58343,58373,58402,58432,58461,58491,58521,58551,58580,58610,58639,58669,58698,58727,58757,58786,58816,58845,58875,58905,58934,58964,58994,59023,59053,59082,59111,59141,59170,59200,59229,59259,59288,59318,59348,59377,59407,59436,59466,59495,59525,59554,59584,59613,59643,59672,59702,59731,59761,59791,59820,59850,59879,59909,59939,59968,59997,60027,60056,60086,60115,60145,60174,60204,60234,60264,60293,60323,60352,60381,60411,60440,60469,60499,60528,60558,60588,60618,60648,60677,60707,60736,60765,60795,60824,60853,60883,60912,60942,60972,61002,61031,61061,61090,61120,61149,61179,61208,61237,61267,61296,61326,61356,61385,61415,61445,61474,61504,61533,61563,61592,61621,61651,61680,61710,61739,61769,61799,61828,61858,61888,61917,61947,61976,62006,62035,62064,62094,62123,62153,62182,62212,62242,62271,62301,62331,62360,62390,62419,62448,62478,62507,62537,62566,62596,62625,62655,62685,62715,62744,62774,62803,62832,62862,62891,62921,62950,62980,63009,63039,63069,63099,63128,63157,63187,63216,63246,63275,63305,63334,63363,63393,63423,63453,63482,63512,63541,63571,63600,63630,63659,63689,63718,63747,63777,63807,63836,63866,63895,63925,63955,63984,64014,64043,64073,64102,64131,64161,64190,64220,64249,64279,64309,64339,64368,64398,64427,64457,64486,64515,64545,64574,64603,64633,64663,64692,64722,64752,64782,64811,64841,64870,64899,64929,64958,64987,65017,65047,65076,65106,65136,65166,65195,65225,65254,65283,65313,65342,65371,65401,65431,65460,65490,65520,65549,65579,65608,65638,65667,65697,65726,65755,65785,65815,65844,65874,65903,65933,65963,65992,66022,66051,66081,66110,66140,66169,66199,66228,66258,66287,66317,66346,66376,66405,66435,66465,66494,66524,66553,66583,66612,66641,66671,66700,66730,66760,66789,66819,66849,66878,66908,66937,66967,66996,67025,67055,67084,67114,67143,67173,67203,67233,67262,67292,67321,67351,67380,67409,67439,67468,67497,67527,67557,67587,67617,67646,67676,67705,67735,67764,67793,67823,67852,67882,67911,67941,67971,68e3,68030,68060,68089,68119,68148,68177,68207,68236,68266,68295,68325,68354,68384,68414,68443,68473,68502,68532,68561,68591,68620,68650,68679,68708,68738,68768,68797,68827,68857,68886,68916,68946,68975,69004,69034,69063,69092,69122,69152,69181,69211,69240,69270,69300,69330,69359,69388,69418,69447,69476,69506,69535,69565,69595,69624,69654,69684,69713,69743,69772,69802,69831,69861,69890,69919,69949,69978,70008,70038,70067,70097,70126,70156,70186,70215,70245,70274,70303,70333,70362,70392,70421,70451,70481,70510,70540,70570,70599,70629,70658,70687,70717,70746,70776,70805,70835,70864,70894,70924,70954,70983,71013,71042,71071,71101,71130,71159,71189,71218,71248,71278,71308,71337,71367,71397,71426,71455,71485,71514,71543,71573,71602,71632,71662,71691,71721,71751,71781,71810,71839,71869,71898,71927,71957,71986,72016,72046,72075,72105,72135,72164,72194,72223,72253,72282,72311,72341,72370,72400,72429,72459,72489,72518,72548,72577,72607,72637,72666,72695,72725,72754,72784,72813,72843,72872,72902,72931,72961,72991,73020,73050,73080,73109,73139,73168,73197,73227,73256,73286,73315,73345,73375,73404,73434,73464,73493,73523,73552,73581,73611,73640,73669,73699,73729,73758,73788,73818,73848,73877,73907,73936,73965,73995,74024,74053,74083,74113,74142,74172,74202,74231,74261,74291,74320,74349,74379,74408,74437,74467,74497,74526,74556,74586,74615,74645,74675,74704,74733,74763,74792,74822,74851,74881,74910,74940,74969,74999,75029,75058,75088,75117,75147,75176,75206,75235,75264,75294,75323,75353,75383,75412,75442,75472,75501,75531,75560,75590,75619,75648,75678,75707,75737,75766,75796,75826,75856,75885,75915,75944,75974,76003,76032,76062,76091,76121,76150,76180,76210,76239,76269,76299,76328,76358,76387,76416,76446,76475,76505,76534,76564,76593,76623,76653,76682,76712,76741,76771,76801,76830,76859,76889,76918,76948,76977,77007,77036,77066,77096,77125,77155,77185,77214,77243,77273,77302,77332,77361,77390,77420,77450,77479,77509,77539,77569,77598,77627,77657,77686,77715,77745,77774,77804,77833,77863,77893,77923,77952,77982,78011,78041,78070,78099,78129,78158,78188,78217,78247,78277,78307,78336,78366,78395,78425,78454,78483,78513,78542,78572,78601,78631,78661,78690,78720,78750,78779,78808,78838,78867,78897,78926,78956,78985,79015,79044,79074,79104,79133,79163,79192,79222,79251,79281,79310,79340,79369,79399,79428,79458,79487,79517,79546,79576,79606,79635,79665,79695,79724,79753,79783,79812,79841,79871,79900,79930,79960,79990]},{\"../main\":580,\"object-assign\":469}],580:[function(t,e,r){function n(){this.regionalOptions=[],this.regionalOptions[\"\"]={invalidCalendar:\"Calendar {0} not found\",invalidDate:\"Invalid {0} date\",invalidMonth:\"Invalid {0} month\",invalidYear:\"Invalid {0} year\",differentCalendars:\"Cannot mix {0} and {1} dates\"},this.local=this.regionalOptions[\"\"],this.calendars={},this._localCals={}}function i(t,e,r,n){if(this._calendar=t,this._year=e,this._month=r,this._day=n,0===this._calendar._validateLevel&&!this._calendar.isValid(this._year,this._month,this._day))throw(u.local.invalidDate||u.regionalOptions[\"\"].invalidDate).replace(/\\{0\\}/,this._calendar.local.name)}function a(t,e){return t=\"\"+t,\"000000\".substring(0,e-t.length)+t}function o(){this.shortYearCutoff=\"+10\"}function s(t){this.local=this.regionalOptions[t]||this.regionalOptions[\"\"]}var l=t(\"object-assign\");l(n.prototype,{instance:function(t,e){t=(t||\"gregorian\").toLowerCase(),e=e||\"\";var r=this._localCals[t+\"-\"+e];if(!r&&this.calendars[t]&&(r=new this.calendars[t](e),this._localCals[t+\"-\"+e]=r),!r)throw(this.local.invalidCalendar||this.regionalOptions[\"\"].invalidCalendar).replace(/\\{0\\}/,t);return r},newDate:function(t,e,r,n,i){return n=(null!=t&&t.year?t.calendar():\"string\"==typeof n?this.instance(n,i):n)||this.instance(),n.newDate(t,e,r)},substituteDigits:function(t){\n",
       "return function(e){return(e+\"\").replace(/[0-9]/g,function(e){return t[e]})}},substituteChineseDigits:function(t,e){return function(r){for(var n=\"\",i=0;r>0;){var a=r%10;n=(0===a?\"\":t[a]+e[i])+n,i++,r=Math.floor(r/10)}return 0===n.indexOf(t[1]+e[1])&&(n=n.substr(1)),n||t[0]}}}),l(i.prototype,{newDate:function(t,e,r){return this._calendar.newDate(null==t?this:t,e,r)},year:function(t){return 0===arguments.length?this._year:this.set(t,\"y\")},month:function(t){return 0===arguments.length?this._month:this.set(t,\"m\")},day:function(t){return 0===arguments.length?this._day:this.set(t,\"d\")},date:function(t,e,r){if(!this._calendar.isValid(t,e,r))throw(u.local.invalidDate||u.regionalOptions[\"\"].invalidDate).replace(/\\{0\\}/,this._calendar.local.name);return this._year=t,this._month=e,this._day=r,this},leapYear:function(){return this._calendar.leapYear(this)},epoch:function(){return this._calendar.epoch(this)},formatYear:function(){return this._calendar.formatYear(this)},monthOfYear:function(){return this._calendar.monthOfYear(this)},weekOfYear:function(){return this._calendar.weekOfYear(this)},daysInYear:function(){return this._calendar.daysInYear(this)},dayOfYear:function(){return this._calendar.dayOfYear(this)},daysInMonth:function(){return this._calendar.daysInMonth(this)},dayOfWeek:function(){return this._calendar.dayOfWeek(this)},weekDay:function(){return this._calendar.weekDay(this)},extraInfo:function(){return this._calendar.extraInfo(this)},add:function(t,e){return this._calendar.add(this,t,e)},set:function(t,e){return this._calendar.set(this,t,e)},compareTo:function(t){if(this._calendar.name!==t._calendar.name)throw(u.local.differentCalendars||u.regionalOptions[\"\"].differentCalendars).replace(/\\{0\\}/,this._calendar.local.name).replace(/\\{1\\}/,t._calendar.local.name);var e=this._year!==t._year?this._year-t._year:this._month!==t._month?this.monthOfYear()-t.monthOfYear():this._day-t._day;return 0===e?0:e<0?-1:1},calendar:function(){return this._calendar},toJD:function(){return this._calendar.toJD(this)},fromJD:function(t){return this._calendar.fromJD(t)},toJSDate:function(){return this._calendar.toJSDate(this)},fromJSDate:function(t){return this._calendar.fromJSDate(t)},toString:function(){return(this.year()<0?\"-\":\"\")+a(Math.abs(this.year()),4)+\"-\"+a(this.month(),2)+\"-\"+a(this.day(),2)}}),l(o.prototype,{_validateLevel:0,newDate:function(t,e,r){return null==t?this.today():(t.year&&(this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),r=t.day(),e=t.month(),t=t.year()),new i(this,t,e,r))},today:function(){return this.fromJSDate(new Date)},epoch:function(t){return this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear).year()<0?this.local.epochs[0]:this.local.epochs[1]},formatYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear);return(e.year()<0?\"-\":\"\")+a(Math.abs(e.year()),4)},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear),12},monthOfYear:function(t,e){var r=this._validate(t,e,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth);return(r.month()+this.monthsInYear(r)-this.firstMonth)%this.monthsInYear(r)+this.minMonth},fromMonthOfYear:function(t,e){var r=(e+this.firstMonth-2*this.minMonth)%this.monthsInYear(t)+this.minMonth;return this._validate(t,r,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth),r},daysInYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear);return this.leapYear(e)?366:365},dayOfYear:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return n.toJD()-this.newDate(n.year(),this.fromMonthOfYear(n.year(),this.minMonth),this.minDay).toJD()+1},daysInWeek:function(){return 7},dayOfWeek:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return(Math.floor(this.toJD(n))+2)%this.daysInWeek()},extraInfo:function(t,e,r){return this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),{}},add:function(t,e,r){return this._validate(t,this.minMonth,this.minDay,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),this._correctAdd(t,this._add(t,e,r),e,r)},_add:function(t,e,r){if(this._validateLevel++,\"d\"===r||\"w\"===r){var n=t.toJD()+e*(\"w\"===r?this.daysInWeek():1),i=t.calendar().fromJD(n);return this._validateLevel--,[i.year(),i.month(),i.day()]}try{var a=t.year()+(\"y\"===r?e:0),o=t.monthOfYear()+(\"m\"===r?e:0),i=t.day();\"y\"===r?(t.month()!==this.fromMonthOfYear(a,o)&&(o=this.newDate(a,t.month(),this.minDay).monthOfYear()),o=Math.min(o,this.monthsInYear(a)),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o)))):\"m\"===r&&(!function(t){for(;o<t.minMonth;)a--,o+=t.monthsInYear(a);for(var e=t.monthsInYear(a);o>e-1+t.minMonth;)a++,o-=e,e=t.monthsInYear(a)}(this),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o))));var s=[a,this.fromMonthOfYear(a,o),i];return this._validateLevel--,s}catch(t){throw this._validateLevel--,t}},_correctAdd:function(t,e,r,n){if(!(this.hasYearZero||\"y\"!==n&&\"m\"!==n||0!==e[0]&&t.year()>0==e[0]>0)){var i={y:[1,1,\"y\"],m:[1,this.monthsInYear(-1),\"m\"],w:[this.daysInWeek(),this.daysInYear(-1),\"d\"],d:[1,this.daysInYear(-1),\"d\"]}[n],a=r<0?-1:1;e=this._add(t,r*i[0]+a*i[1],i[2])}return t.date(e[0],e[1],e[2])},set:function(t,e,r){this._validate(t,this.minMonth,this.minDay,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);var n=\"y\"===r?e:t.year(),i=\"m\"===r?e:t.month(),a=\"d\"===r?e:t.day();return\"y\"!==r&&\"m\"!==r||(a=Math.min(a,this.daysInMonth(n,i))),t.date(n,i,a)},isValid:function(t,e,r){this._validateLevel++;var n=this.hasYearZero||0!==t;if(n){var i=this.newDate(t,e,this.minDay);n=e>=this.minMonth&&e-this.minMonth<this.monthsInYear(i)&&r>=this.minDay&&r-this.minDay<this.daysInMonth(i)}return this._validateLevel--,n},toJSDate:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return u.instance().fromJD(this.toJD(n)).toJSDate()},fromJSDate:function(t){return this.fromJD(u.instance().fromJSDate(t).toJD())},_validate:function(t,e,r,n){if(t.year){if(0===this._validateLevel&&this.name!==t.calendar().name)throw(u.local.differentCalendars||u.regionalOptions[\"\"].differentCalendars).replace(/\\{0\\}/,this.local.name).replace(/\\{1\\}/,t.calendar().local.name);return t}try{if(1===++this._validateLevel&&!this.isValid(t,e,r))throw n.replace(/\\{0\\}/,this.local.name);var i=this.newDate(t,e,r);return this._validateLevel--,i}catch(t){throw this._validateLevel--,t}}}),s.prototype=new o,l(s.prototype,{name:\"Gregorian\",jdEpoch:1721425.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Gregorian\",epochs:[\"BCE\",\"CE\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"mm/dd/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==0&&(t%100!=0||t%400==0)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);t=n.year(),e=n.month(),r=n.day(),t<0&&t++,e<3&&(e+=12,t--);var i=Math.floor(t/100),a=2-i+Math.floor(i/4);return Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r+a-1524.5},fromJD:function(t){var e=Math.floor(t+.5),r=Math.floor((e-1867216.25)/36524.25);r=e+1+r-Math.floor(r/4);var n=r+1524,i=Math.floor((n-122.1)/365.25),a=Math.floor(365.25*i),o=Math.floor((n-a)/30.6001),s=n-a-Math.floor(30.6001*o),l=o-(o>13.5?13:1),u=i-(l>2.5?4716:4715);return u<=0&&u--,this.newDate(u,l,s)},toJSDate:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),i=new Date(n.year(),n.month()-1,n.day());return i.setHours(0),i.setMinutes(0),i.setSeconds(0),i.setMilliseconds(0),i.setHours(i.getHours()>12?i.getHours()+2:0),i},fromJSDate:function(t){return this.newDate(t.getFullYear(),t.getMonth()+1,t.getDate())}});var u=e.exports=new n;u.cdate=i,u.baseCalendar=o,u.calendars.gregorian=s},{\"object-assign\":469}],581:[function(t,e,r){var n=t(\"object-assign\"),i=t(\"./main\");n(i.regionalOptions[\"\"],{invalidArguments:\"Invalid arguments\",invalidFormat:\"Cannot format a date from another calendar\",missingNumberAt:\"Missing number at position {0}\",unknownNameAt:\"Unknown name at position {0}\",unexpectedLiteralAt:\"Unexpected literal at position {0}\",unexpectedText:\"Additional text found at end\"}),i.local=i.regionalOptions[\"\"],n(i.cdate.prototype,{formatDate:function(t,e){return\"string\"!=typeof t&&(e=t,t=\"\"),this._calendar.formatDate(t||\"\",this,e)}}),n(i.baseCalendar.prototype,{UNIX_EPOCH:i.instance().newDate(1970,1,1).toJD(),SECS_PER_DAY:86400,TICKS_EPOCH:i.instance().jdEpoch,TICKS_PER_DAY:864e9,ATOM:\"yyyy-mm-dd\",COOKIE:\"D, dd M yyyy\",FULL:\"DD, MM d, yyyy\",ISO_8601:\"yyyy-mm-dd\",JULIAN:\"J\",RFC_822:\"D, d M yy\",RFC_850:\"DD, dd-M-yy\",RFC_1036:\"D, d M yy\",RFC_1123:\"D, d M yyyy\",RFC_2822:\"D, d M yyyy\",RSS:\"D, d M yy\",TICKS:\"!\",TIMESTAMP:\"@\",W3C:\"yyyy-mm-dd\",formatDate:function(t,e,r){if(\"string\"!=typeof t&&(r=e,e=t,t=\"\"),!e)return\"\";if(e.calendar()!==this)throw i.local.invalidFormat||i.regionalOptions[\"\"].invalidFormat;t=t||this.local.dateFormat,r=r||{};for(var n=r.dayNamesShort||this.local.dayNamesShort,a=r.dayNames||this.local.dayNames,o=r.monthNumbers||this.local.monthNumbers,s=r.monthNamesShort||this.local.monthNamesShort,l=r.monthNames||this.local.monthNames,u=(r.calculateWeek||this.local.calculateWeek,function(e,r){for(var n=1;v+n<t.length&&t.charAt(v+n)===e;)n++;return v+=n-1,Math.floor(n/(r||1))>1}),c=function(t,e,r,n){var i=\"\"+e;if(u(t,n))for(;i.length<r;)i=\"0\"+i;return i},h=this,f=this.local.digits,d=function(t){return r.localNumbers&&f?f(t):t},p=\"\",m=!1,v=0;v<t.length;v++)if(m)\"'\"!==t.charAt(v)||u(\"'\")?p+=t.charAt(v):m=!1;else switch(t.charAt(v)){case\"d\":p+=d(c(\"d\",e.day(),2));break;case\"D\":p+=function(t,e,r,n){return u(t)?n[e]:r[e]}(\"D\",e.dayOfWeek(),n,a);break;case\"o\":p+=c(\"o\",e.dayOfYear(),3);break;case\"w\":p+=c(\"w\",e.weekOfYear(),2);break;case\"m\":p+=function(t){return\"function\"==typeof o?o.call(h,t,u(\"m\")):d(c(\"m\",t.month(),2))}(e);break;case\"M\":p+=function(t,e){return e?\"function\"==typeof l?l.call(h,t):l[t.month()-h.minMonth]:\"function\"==typeof s?s.call(h,t):s[t.month()-h.minMonth]}(e,u(\"M\"));break;case\"y\":p+=u(\"y\",2)?e.year():(e.year()%100<10?\"0\":\"\")+e.year()%100;break;case\"Y\":u(\"Y\",2),p+=e.formatYear();break;case\"J\":p+=e.toJD();break;case\"@\":p+=(e.toJD()-this.UNIX_EPOCH)*this.SECS_PER_DAY;break;case\"!\":p+=(e.toJD()-this.TICKS_EPOCH)*this.TICKS_PER_DAY;break;case\"'\":u(\"'\")?p+=\"'\":m=!0;break;default:p+=t.charAt(v)}return p},parseDate:function(t,e,r){if(null==e)throw i.local.invalidArguments||i.regionalOptions[\"\"].invalidArguments;if(\"\"===(e=\"object\"==typeof e?e.toString():e+\"\"))return null;t=t||this.local.dateFormat,r=r||{};var n=r.shortYearCutoff||this.shortYearCutoff;n=\"string\"!=typeof n?n:this.today().year()%100+parseInt(n,10);for(var a=r.dayNamesShort||this.local.dayNamesShort,o=r.dayNames||this.local.dayNames,s=r.parseMonth||this.local.parseMonth,l=r.monthNumbers||this.local.monthNumbers,u=r.monthNamesShort||this.local.monthNamesShort,c=r.monthNames||this.local.monthNames,h=-1,f=-1,d=-1,p=-1,m=-1,v=!1,g=!1,y=function(e,r){for(var n=1;k+n<t.length&&t.charAt(k+n)===e;)n++;return k+=n-1,Math.floor(n/(r||1))>1},b=function(t,r){var n=y(t,r),a=[2,3,n?4:2,n?4:2,10,11,20][\"oyYJ@!\".indexOf(t)+1],o=new RegExp(\"^-?\\\\d{1,\"+a+\"}\"),s=e.substring(M).match(o);if(!s)throw(i.local.missingNumberAt||i.regionalOptions[\"\"].missingNumberAt).replace(/\\{0\\}/,M);return M+=s[0].length,parseInt(s[0],10)},x=this,_=function(t,r,n,a){for(var o=y(t,a)?n:r,s=0;s<o.length;s++)if(e.substr(M,o[s].length).toLowerCase()===o[s].toLowerCase())return M+=o[s].length,s+x.minMonth;throw(i.local.unknownNameAt||i.regionalOptions[\"\"].unknownNameAt).replace(/\\{0\\}/,M)},w=function(){if(e.charAt(M)!==t.charAt(k))throw(i.local.unexpectedLiteralAt||i.regionalOptions[\"\"].unexpectedLiteralAt).replace(/\\{0\\}/,M);M++},M=0,k=0;k<t.length;k++)if(g)\"'\"!==t.charAt(k)||y(\"'\")?w():g=!1;else switch(t.charAt(k)){case\"d\":p=b(\"d\");break;case\"D\":_(\"D\",a,o);break;case\"o\":m=b(\"o\");break;case\"w\":b(\"w\");break;case\"m\":d=function(){if(\"function\"==typeof l){y(\"m\");var t=l.call(x,e.substring(M));return M+=t.length,t}return b(\"m\")}();break;case\"M\":d=function(){if(\"function\"==typeof c){var t=y(\"M\")?c.call(x,e.substring(M)):u.call(x,e.substring(M));return M+=t.length,t}return _(\"M\",u,c)}();break;case\"y\":var A=k;v=!y(\"y\",2),k=A,f=b(\"y\",2);break;case\"Y\":f=b(\"Y\",2);break;case\"J\":h=b(\"J\")+.5,\".\"===e.charAt(M)&&(M++,b(\"J\"));break;case\"@\":h=b(\"@\")/this.SECS_PER_DAY+this.UNIX_EPOCH;break;case\"!\":h=b(\"!\")/this.TICKS_PER_DAY+this.TICKS_EPOCH;break;case\"*\":M=e.length;break;case\"'\":y(\"'\")?w():g=!0;break;default:w()}if(M<e.length)throw i.local.unexpectedText||i.regionalOptions[\"\"].unexpectedText;if(-1===f?f=this.today().year():f<100&&v&&(f+=-1===n?1900:this.today().year()-this.today().year()%100-(f<=n?0:100)),\"string\"==typeof d&&(d=s.call(this,f,d)),m>-1){d=1,p=m;for(var T=this.daysInMonth(f,d);p>T;T=this.daysInMonth(f,d))d++,p-=T}return h>-1?this.fromJD(h):this.newDate(f,d,p)},determineDate:function(t,e,r,n,i){r&&\"object\"!=typeof r&&(i=n,n=r,r=null),\"string\"!=typeof n&&(i=n,n=\"\");var a=this;return e=e?e.newDate():null,t=null==t?e:\"string\"==typeof t?function(t){try{return a.parseDate(n,t,i)}catch(t){}t=t.toLowerCase();for(var e=(t.match(/^c/)&&r?r.newDate():null)||a.today(),o=/([+-]?[0-9]+)\\s*(d|w|m|y)?/g,s=o.exec(t);s;)e.add(parseInt(s[1],10),s[2]||\"d\"),s=o.exec(t);return e}(t):\"number\"==typeof t?isNaN(t)||t===1/0||t===-1/0?e:a.today().add(t,\"d\"):a.newDate(t)}})},{\"./main\":580,\"object-assign\":469}],582:[function(t,e,r){e.exports=t(\"cwise-compiler\")({args:[\"array\",{offset:[1],array:0},\"scalar\",\"scalar\",\"index\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{\\n        var _inline_1_da = _inline_1_arg0_ - _inline_1_arg3_\\n        var _inline_1_db = _inline_1_arg1_ - _inline_1_arg3_\\n        if((_inline_1_da >= 0) !== (_inline_1_db >= 0)) {\\n          _inline_1_arg2_.push(_inline_1_arg4_[0] + 0.5 + 0.5 * (_inline_1_da + _inline_1_db) / (_inline_1_da - _inline_1_db))\\n        }\\n      }\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg3_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[],localVars:[\"_inline_1_da\",\"_inline_1_db\"]},funcName:\"zeroCrossings\"})},{\"cwise-compiler\":109}],583:[function(t,e,r){\"use strict\";function n(t,e){var r=[];return e=+e||0,i(t.hi(t.shape[0]-1),r,e),r}e.exports=n;var i=t(\"./lib/zc-core\")},{\"./lib/zc-core\":582}],584:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"./common_defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s,l){function u(r,i){return n.coerce(t,e,o,r,i)}s=s||{},l=l||{};var c=u(\"visible\",!l.itemIsNotPlainObject),h=u(\"clicktoshow\");if(!c&&!h)return e;a(t,e,r,u);for(var f=e.showarrow,d=[\"x\",\"y\"],p=[-10,-30],m={_fullLayout:r},v=0;v<2;v++){var g=d[v],y=i.coerceRef(t,e,m,g,\"\",\"paper\");if(i.coercePosition(e,m,u,y,g,.5),f){var b=\"a\"+g,x=i.coerceRef(t,e,m,b,\"pixel\");\"pixel\"!==x&&x!==y&&(x=e[b]=\"pixel\");var _=\"pixel\"===x?p[v]:.4;i.coercePosition(e,m,u,x,b,_)}u(g+\"anchor\"),u(g+\"shift\")}if(n.noneOrAll(t,e,[\"x\",\"y\"]),f&&n.noneOrAll(t,e,[\"ax\",\"ay\"]),h){var w=u(\"xclick\"),M=u(\"yclick\");e._xclick=void 0===w?e.x:i.cleanPosition(w,m,e.xref),e._yclick=void 0===M?e.y:i.cleanPosition(M,m,e.yref)}return e}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./attributes\":586,\"./common_defaults\":589}],585:[function(t,e,r){\"use strict\";e.exports=[{path:\"\",backoff:0},{path:\"M-2.4,-3V3L0.6,0Z\",backoff:.6},{path:\"M-3.7,-2.5V2.5L1.3,0Z\",backoff:1.3},{path:\"M-4.45,-3L-1.65,-0.2V0.2L-4.45,3L1.55,0Z\",backoff:1.55},{path:\"M-2.2,-2.2L-0.2,-0.2V0.2L-2.2,2.2L-1.4,3L1.6,0L-1.4,-3Z\",backoff:1.6},{path:\"M-4.4,-2.1L-0.6,-0.2V0.2L-4.4,2.1L-4,3L2,0L-4,-3Z\",backoff:2},{path:\"M2,0A2,2 0 1,1 0,-2A2,2 0 0,1 2,0Z\",backoff:0},{path:\"M2,2V-2H-2V2Z\",backoff:0}]},{}],586:[function(t,e,r){\"use strict\";var n=t(\"./arrow_paths\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/cartesian/constants\"),o=t(\"../../lib/extend\").extendFlat;e.exports={_isLinkedToArray:\"annotation\",visible:{valType:\"boolean\",dflt:!0},text:{valType:\"string\"},textangle:{valType:\"angle\",dflt:0},font:o({},i,{}),width:{valType:\"number\",min:1,dflt:null},height:{valType:\"number\",min:1,dflt:null},opacity:{valType:\"number\",min:0,max:1,dflt:1},align:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"center\"},valign:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"middle\"},bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},bordercolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},borderpad:{valType:\"number\",min:0,dflt:1},borderwidth:{valType:\"number\",min:0,dflt:1},showarrow:{valType:\"boolean\",dflt:!0},arrowcolor:{valType:\"color\"},arrowhead:{valType:\"integer\",min:0,max:n.length,dflt:1},arrowsize:{valType:\"number\",min:.3,dflt:1},arrowwidth:{valType:\"number\",min:.1},standoff:{valType:\"number\",min:0,dflt:0},ax:{valType:\"any\"},ay:{valType:\"any\"},axref:{valType:\"enumerated\",dflt:\"pixel\",values:[\"pixel\",a.idRegex.x.toString()]},ayref:{valType:\"enumerated\",dflt:\"pixel\",values:[\"pixel\",a.idRegex.y.toString()]},xref:{valType:\"enumerated\",values:[\"paper\",a.idRegex.x.toString()]},x:{valType:\"any\"},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"auto\"},xshift:{valType:\"number\",dflt:0},yref:{valType:\"enumerated\",values:[\"paper\",a.idRegex.y.toString()]},y:{valType:\"any\"},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"auto\"},yshift:{valType:\"number\",dflt:0},clicktoshow:{valType:\"enumerated\",values:[!1,\"onoff\",\"onout\"],dflt:!1},xclick:{valType:\"any\"},yclick:{valType:\"any\"},hovertext:{valType:\"string\"},hoverlabel:{bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\"},font:o({},i,{})},captureevents:{valType:\"boolean\"},_deprecated:{ref:{valType:\"string\"}}}},{\"../../lib/extend\":716,\"../../plots/cartesian/constants\":771,\"../../plots/font_attributes\":790,\"./arrow_paths\":585}],587:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;i.filterVisible(e.annotations).forEach(function(e){var r,n,i=a.getFromId(t,e.xref),o=a.getFromId(t,e.yref),s=3*e.arrowsize*e.arrowwidth||0;i&&i.autorange&&(r=s+e.xshift,n=s-e.xshift,e.axref===e.xref?(a.expand(i,[i.r2c(e.x)],{ppadplus:r,ppadminus:n}),a.expand(i,[i.r2c(e.ax)],{ppadplus:e._xpadplus,ppadminus:e._xpadminus})):a.expand(i,[i.r2c(e.x)],{ppadplus:Math.max(e._xpadplus,r),ppadminus:Math.max(e._xpadminus,n)})),o&&o.autorange&&(r=s-e.yshift,n=s+e.yshift,e.ayref===e.yref?(a.expand(o,[o.r2c(e.y)],{ppadplus:r,ppadminus:n}),a.expand(o,[o.r2c(e.ay)],{ppadplus:e._ypadplus,ppadminus:e._ypadminus})):a.expand(o,[o.r2c(e.y)],{ppadplus:Math.max(e._ypadplus,r),ppadminus:Math.max(e._ypadminus,n)}))})}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"./draw\").draw;e.exports=function(t){var e=t._fullLayout,r=i.filterVisible(e.annotations);if(r.length&&t._fullData.length){var s={};r.forEach(function(t){s[t.xref]=!0,s[t.yref]=!0});if(a.list(t).filter(function(t){return t.autorange&&s[t._id]}).length)return i.syncOrAsync([o,n],t)}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./draw\":592}],588:[function(t,e,r){\"use strict\";function n(t,e){var r=a(t,e);return r.on.length>0||r.explicitOff.length>0}function i(t,e){var r,n=a(t,e),i=n.on,o=n.off.concat(n.explicitOff),l={};if(i.length||o.length){for(r=0;r<i.length;r++)l[\"annotations[\"+i[r]+\"].visible\"]=!0;for(r=0;r<o.length;r++)l[\"annotations[\"+o[r]+\"].visible\"]=!1;return s.update(t,{},l)}}function a(t,e){var r,n,i,a,s,l,u,c,h=t._fullLayout.annotations,f=[],d=[],p=[],m=(e||[]).length;for(r=0;r<h.length;r++)if(i=h[r],a=i.clicktoshow){for(n=0;n<m;n++)if(s=e[n],l=s.xaxis,u=s.yaxis,l._id===i.xref&&u._id===i.yref&&l.d2r(s.x)===o(i._xclick,l)&&u.d2r(s.y)===o(i._yclick,u)){c=i.visible?\"onout\"===a?d:p:f,c.push(r);break}n===m&&i.visible&&\"onout\"===a&&d.push(r)}return{on:f,off:d,explicitOff:p}}function o(t,e){return\"log\"===e.type?e.l2r(t):e.d2r(t)}var s=t(\"../../plotly\");e.exports={hasClickToShow:n,onClick:i}},{\"../../plotly\":761}],589:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../color\");e.exports=function(t,e,r,a){a(\"opacity\");var o=a(\"bgcolor\"),s=a(\"bordercolor\"),l=i.opacity(s);a(\"borderpad\");var u=a(\"borderwidth\"),c=a(\"showarrow\");a(\"text\",c?\" \":\"new text\"),a(\"textangle\"),n.coerceFont(a,\"font\",r.font),a(\"width\"),a(\"align\"),a(\"height\")&&a(\"valign\"),c&&(a(\"arrowcolor\",l?e.bordercolor:i.defaultLine),a(\"arrowhead\"),a(\"arrowsize\"),a(\"arrowwidth\",2*(l&&u||1)),a(\"standoff\"));var h=a(\"hovertext\"),f=r.hoverlabel||{};if(h){var d=a(\"hoverlabel.bgcolor\",f.bgcolor||(i.opacity(o)?i.rgb(o):i.defaultLine)),p=a(\"hoverlabel.bordercolor\",f.bordercolor||i.contrast(d));n.coerceFont(a,\"hoverlabel.font\",{family:f.font.family,size:f.font.size,color:f.font.color||p})}a(\"captureevents\",!!h)}},{\"../../lib\":725,\"../color\":603}],590:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib/to_log_range\");e.exports=function(t,e,r,a){function o(t){var r=u[t],o=null;o=s?i(r,e.range):Math.pow(10,r),n(o)||(o=null),a(c+t,o)}e=e||{};var s=\"log\"===r&&\"linear\"===e.type,l=\"linear\"===r&&\"log\"===e.type;if(s||l)for(var u,c,h=t._fullLayout.annotations,f=e._id.charAt(0),d=0;d<h.length;d++)u=h[d],c=\"annotations[\"+d+\"].\",u[f+\"ref\"]===e._id&&o(f),u[\"a\"+f+\"ref\"]===e._id&&o(\"a\"+f)}},{\"../../lib/to_log_range\":746,\"fast-isnumeric\":130}],591:[function(t,e,r){\"use strict\";var n=t(\"../../plots/array_container_defaults\"),i=t(\"./annotation_defaults\");e.exports=function(t,e){n(t,e,{name:\"annotations\",handleItemDefaults:i})}},{\"../../plots/array_container_defaults\":763,\"./annotation_defaults\":584}],592:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;e._infolayer.selectAll(\".annotation\").remove();for(var r=0;r<e.annotations.length;r++)e.annotations[r].visible&&i(t,r);return l.previousPromises(t)}function i(t,e){var r=t._fullLayout,n=r.annotations[e]||{};a(t,n,e,!1,c.getFromId(t,n.xref),c.getFromId(t,n.yref))}function a(t,e,r,n,i,a){function l(r){return r.call(f.font,F).attr({\"text-anchor\":{left:\"start\",right:\"end\"}[e.align]||\"middle\"}),p.convertToTspans(r,t,c),r}function c(){function r(t,e){return\"auto\"===e&&(e=t<1/3?\"left\":t>2/3?\"right\":\"center\"),{center:0,middle:0,left:.5,bottom:-.5,right:-.5,top:.5}[e]}var o=j.selectAll(\"a\");if(1===o.size()&&o.text()===j.text()){C.insert(\"a\",\":first-child\").attr({\"xlink:xlink:href\":o.attr(\"xlink:href\"),\"xlink:xlink:show\":o.attr(\"xlink:show\")}).style({cursor:\"pointer\"}).node().appendChild(P.node())}var l=C.select(\".annotation-text-math-group\"),c=!l.empty(),d=f.bBox((c?l:j).node()),y=d.width,L=d.height,I=e.width||y,F=e.height||L,N=Math.round(I+2*D),B=Math.round(F+2*D);e._w=I,e._h=F;for(var U=!1,V=[\"x\",\"y\"],H=0;H<V.length;H++){var q,G,Y,X,W,Z=V[H],J=e[Z+\"ref\"]||Z,K=e[\"a\"+Z+\"ref\"],Q={x:i,y:a}[Z],$=(A+(\"x\"===Z?0:-90))*Math.PI/180,tt=N*Math.cos($),et=B*Math.sin($),rt=Math.abs(tt)+Math.abs(et),nt=e[Z+\"anchor\"],it=e[Z+\"shift\"]*(\"x\"===Z?1:-1),at=k[Z];if(Q){var ot=Q.r2fraction(e[Z]);if((t._dragging||!Q.autorange)&&(ot<0||ot>1)&&(K===J?((ot=Q.r2fraction(e[\"a\"+Z]))<0||ot>1)&&(U=!0):U=!0,U))continue;q=Q._offset+Q.r2p(e[Z]),X=.5}else\"x\"===Z?(Y=e[Z],q=_.l+_.w*Y):(Y=1-e[Z],q=_.t+_.h*Y),X=e.showarrow?.5:Y;if(e.showarrow){at.head=q;var st=e[\"a\"+Z];W=tt*r(.5,e.xanchor)-et*r(.5,e.yanchor),K===J?(at.tail=Q._offset+Q.r2p(st),G=W):(at.tail=q+st,G=W+st),at.text=at.tail+W;var lt=x[\"x\"===Z?\"width\":\"height\"];if(\"paper\"===J&&(at.head=u.constrain(at.head,1,lt-1)),\"pixel\"===K){var ut=-Math.max(at.tail-3,at.text),ct=Math.min(at.tail+3,at.text)-lt;ut>0?(at.tail+=ut,at.text+=ut):ct>0&&(at.tail-=ct,at.text-=ct)}at.tail+=it,at.head+=it}else W=rt*r(X,nt),G=W,at.text=q+W;at.text+=it,W+=it,G+=it,e[\"_\"+Z+\"padplus\"]=rt/2+G,e[\"_\"+Z+\"padminus\"]=rt/2-G,e[\"_\"+Z+\"size\"]=rt,e[\"_\"+Z+\"shift\"]=W}if(U)return void C.remove();var ht=0,ft=0;if(\"left\"!==e.align&&(ht=(I-y)*(\"center\"===e.align?.5:1)),\"top\"!==e.valign&&(ft=(F-L)*(\"middle\"===e.valign?.5:1)),c)l.select(\"svg\").attr({x:D+ht-1,y:D+ft}).call(f.setClipUrl,O?M:null);else{var dt=D+ft-d.top,pt=D+ht-d.left;j.call(p.positionText,pt,dt).call(f.setClipUrl,O?M:null)}R.select(\"rect\").call(f.setRect,D,D,I,F),P.call(f.setRect,z/2,z/2,N-z,B-z),C.call(f.setTranslate,Math.round(k.x.text-N/2),Math.round(k.y.text-B/2)),S.attr({transform:\"rotate(\"+A+\",\"+k.x.text+\",\"+k.y.text+\")\"});var mt=function(r,o){T.selectAll(\".annotation-arrow-g\").remove();var l=k.x.head,c=k.y.head,d=k.x.tail+r,p=k.y.tail+o,m=k.x.text+r,y=k.y.text+o,x=u.rotationXYMatrix(A,m,y),M=u.apply2DTransform(x),E=u.apply2DTransform2(x),L=+P.attr(\"width\"),z=+P.attr(\"height\"),I=m-.5*L,D=I+L,O=y-.5*z,R=O+z,F=[[I,O,I,R],[I,R,D,R],[D,R,D,O],[D,O,I,O]].map(E);if(!F.reduce(function(t,e){return t^!!u.segmentsIntersect(l,c,l+1e6,c+1e6,e[0],e[1],e[2],e[3])},!1)){F.forEach(function(t){var e=u.segmentsIntersect(d,p,l,c,t[0],t[1],t[2],t[3]);e&&(d=e.x,p=e.y)});var j=e.arrowwidth,N=e.arrowcolor,B=T.append(\"g\").style({opacity:h.opacity(N)}).classed(\"annotation-arrow-g\",!0),U=B.append(\"path\").attr(\"d\",\"M\"+d+\",\"+p+\"L\"+l+\",\"+c).style(\"stroke-width\",j+\"px\").call(h.stroke,h.rgb(N));if(g(U,e.arrowhead,\"end\",e.arrowsize,e.standoff),w.annotationPosition&&U.node().parentNode&&!n){var V=l,H=c;if(e.standoff){var q=Math.sqrt(Math.pow(l-d,2)+Math.pow(c-p,2));V+=e.standoff*(d-l)/q,H+=e.standoff*(p-c)/q}var G,Y,X,W=B.append(\"path\").classed(\"annotation-arrow\",!0).classed(\"anndrag\",!0).attr({d:\"M3,3H-3V-3H3ZM0,0L\"+(d-V)+\",\"+(p-H),transform:\"translate(\"+V+\",\"+H+\")\"}).style(\"stroke-width\",j+6+\"px\").call(h.stroke,\"rgba(0,0,0,0)\").call(h.fill,\"rgba(0,0,0,0)\");v.init({element:W.node(),gd:t,prepFn:function(){var t=f.getTranslate(C);Y=t.x,X=t.y,G={},i&&i.autorange&&(G[i._name+\".autorange\"]=!0),a&&a.autorange&&(G[a._name+\".autorange\"]=!0)},moveFn:function(t,r){var n=M(Y,X),o=n[0]+t,s=n[1]+r;C.call(f.setTranslate,o,s),G[b+\".x\"]=i?i.p2r(i.r2p(e.x)+t):e.x+t/_.w,G[b+\".y\"]=a?a.p2r(a.r2p(e.y)+r):e.y-r/_.h,e.axref===e.xref&&(G[b+\".ax\"]=i.p2r(i.r2p(e.ax)+t)),e.ayref===e.yref&&(G[b+\".ay\"]=a.p2r(a.r2p(e.ay)+r)),B.attr(\"transform\",\"translate(\"+t+\",\"+r+\")\"),S.attr({transform:\"rotate(\"+A+\",\"+o+\",\"+s+\")\"})},doneFn:function(e){if(e){s.relayout(t,G);var r=document.querySelector(\".js-notes-box-panel\");r&&r.redraw(r.selectedObj)}}})}}};if(e.showarrow&&mt(0,0),E){var vt,gt;v.init({element:C.node(),gd:t,prepFn:function(){gt=S.attr(\"transform\"),vt={}},moveFn:function(t,r){var o=\"pointer\";if(e.showarrow)e.axref===e.xref?vt[b+\".ax\"]=i.p2r(i.r2p(e.ax)+t):vt[b+\".ax\"]=e.ax+t,e.ayref===e.yref?vt[b+\".ay\"]=a.p2r(a.r2p(e.ay)+r):vt[b+\".ay\"]=e.ay+r,mt(t,r);else{if(n)return;if(i)vt[b+\".x\"]=e.x+t/i._m;else{var s=e._xsize/_.w,l=e.x+(e._xshift-e.xshift)/_.w-s/2;vt[b+\".x\"]=v.align(l+t/_.w,s,0,1,e.xanchor)}if(a)vt[b+\".y\"]=e.y+r/a._m;else{var u=e._ysize/_.h,c=e.y-(e._yshift+e.yshift)/_.h-u/2;vt[b+\".y\"]=v.align(c-r/_.h,u,0,1,e.yanchor)}i&&a||(o=v.getCursor(i?.5:vt[b+\".x\"],a?.5:vt[b+\".y\"],e.xanchor,e.yanchor))}S.attr({transform:\"translate(\"+t+\",\"+r+\")\"+gt}),m(C,o)},doneFn:function(e){if(m(C),e){s.relayout(t,vt);var r=document.querySelector(\".js-notes-box-panel\");r&&r.redraw(r.selectedObj)}}})}}var y,b,x=t._fullLayout,_=t._fullLayout._size,w=t._context.edits;n?(y=\"annotation-\"+n,b=n+\".annotations[\"+r+\"]\"):(y=\"annotation\",b=\"annotations[\"+r+\"]\"),x._infolayer.selectAll(\".\"+y+'[data-index=\"'+r+'\"]').remove();var M=\"clip\"+x._uid+\"_ann\"+r;if(!e._input||!1===e.visible)return void o.selectAll(\"#\"+M).remove();var k={x:{},y:{}},A=+e.textangle||0,T=x._infolayer.append(\"g\").classed(y,!0).attr(\"data-index\",String(r)).style(\"opacity\",e.opacity),S=T.append(\"g\").classed(\"annotation-text-g\",!0),E=w[e.showarrow?\"annotationTail\":\"annotationPosition\"],L=e.captureevents||w.annotationText||E,C=S.append(\"g\").style(\"pointer-events\",L?\"all\":null).call(m,\"default\").on(\"click\",function(){t._dragging=!1;var i={index:r,annotation:e._input,fullAnnotation:e,event:o.event};n&&(i.subplotId=n),t.emit(\"plotly_clickannotation\",i)});e.hovertext&&C.on(\"mouseover\",function(){var r=e.hoverlabel,n=r.font,i=this.getBoundingClientRect(),a=t.getBoundingClientRect();d.loneHover({x0:i.left-a.left,x1:i.right-a.left,y:(i.top+i.bottom)/2-a.top,text:e.hovertext,color:r.bgcolor,borderColor:r.bordercolor,fontFamily:n.family,fontSize:n.size,fontColor:n.color},{container:x._hoverlayer.node(),outerContainer:x._paper.node(),gd:t})}).on(\"mouseout\",function(){d.loneUnhover(x._hoverlayer.node())});var z=e.borderwidth,I=e.borderpad,D=z+I,P=C.append(\"rect\").attr(\"class\",\"bg\").style(\"stroke-width\",z+\"px\").call(h.stroke,e.bordercolor).call(h.fill,e.bgcolor),O=e.width||e.height,R=x._defs.select(\".clips\").selectAll(\"#\"+M).data(O?[0]:[]);R.enter().append(\"clipPath\").classed(\"annclip\",!0).attr(\"id\",M).append(\"rect\"),R.exit().remove();var F=e.font,j=C.append(\"text\").classed(\"annotation-text\",!0).text(e.text);w.annotationText?j.call(p.makeEditable,{delegate:C,gd:t}).call(l).on(\"edit\",function(r){e.text=r,this.call(l);var n={};n[b+\".text\"]=e.text,i&&i.autorange&&(n[i._name+\".autorange\"]=!0),a&&a.autorange&&(n[a._name+\".autorange\"]=!0),s.relayout(t,n)}):j.call(l)}var o=t(\"d3\"),s=t(\"../../plotly\"),l=t(\"../../plots/plots\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/axes\"),h=t(\"../color\"),f=t(\"../drawing\"),d=t(\"../fx\"),p=t(\"../../lib/svg_text_utils\"),m=t(\"../../lib/setcursor\"),v=t(\"../dragelement\"),g=t(\"./draw_arrow_head\");e.exports={draw:n,drawOne:i,drawRaw:a}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"../fx\":644,\"./draw_arrow_head\":593,d3:121}],593:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../color\"),o=t(\"../drawing\"),s=t(\"./arrow_paths\");e.exports=function(t,e,r,l,u){function c(){t.style(\"stroke-dasharray\",\"0px,100px\")}function h(r,i){d.path&&(e>5&&(i=0),n.select(f.parentNode).append(\"path\").attr({class:t.attr(\"class\"),d:d.path,transform:\"translate(\"+r.x+\",\"+r.y+\")rotate(\"+180*i/Math.PI+\")scale(\"+y+\")\"}).style({fill:b,opacity:x,\"stroke-width\":0}))}i(l)||(l=1);var f=t.node(),d=s[e||0];\"string\"==typeof r&&r||(r=\"end\");var p,m,v,g,y=(o.getPx(t,\"stroke-width\")||1)*l,b=t.style(\"stroke\")||a.defaultLine,x=t.style(\"stroke-opacity\")||1,_=r.indexOf(\"start\")>=0,w=r.indexOf(\"end\")>=0,M=d.backoff*y+u;if(\"line\"===f.nodeName){p={x:+t.attr(\"x1\"),y:+t.attr(\"y1\")},m={x:+t.attr(\"x2\"),y:+t.attr(\"y2\")};var k=p.x-m.x,A=p.y-m.y;if(v=Math.atan2(A,k),g=v+Math.PI,M){if(M*M>k*k+A*A)return void c();var T=M*Math.cos(v),S=M*Math.sin(v);_&&(p.x-=T,p.y-=S,t.attr({x1:p.x,y1:p.y})),w&&(m.x+=T,m.y+=S,t.attr({x2:m.x,y2:m.y}))}}else if(\"path\"===f.nodeName){var E=f.getTotalLength(),L=\"\";if(E<M)return void c();if(_){var C=f.getPointAtLength(0),z=f.getPointAtLength(.1);v=Math.atan2(C.y-z.y,C.x-z.x),p=f.getPointAtLength(Math.min(M,E)),M&&(L=\"0px,\"+M+\"px,\")}if(w){var I=f.getPointAtLength(E),D=f.getPointAtLength(E-.1)\n",
       ";if(g=Math.atan2(I.y-D.y,I.x-D.x),m=f.getPointAtLength(Math.max(0,E-M)),M){var P=L?2*M:M;L+=E-P+\"px,\"+E+\"px\"}}else L&&(L+=E+\"px\");L&&t.style(\"stroke-dasharray\",L)}_&&h(p,v),w&&h(m,g)}},{\"../color\":603,\"../drawing\":627,\"./arrow_paths\":585,d3:121,\"fast-isnumeric\":130}],594:[function(t,e,r){\"use strict\";var n=t(\"./draw\"),i=t(\"./click\");e.exports={moduleType:\"component\",name:\"annotations\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:n.draw,drawOne:n.drawOne,drawRaw:n.drawRaw,hasClickToShow:i.hasClickToShow,onClick:i.onClick,convertCoords:t(\"./convert_coords\")}},{\"./attributes\":586,\"./calc_autorange\":587,\"./click\":588,\"./convert_coords\":590,\"./defaults\":591,\"./draw\":592}],595:[function(t,e,r){\"use strict\";var n=t(\"../annotations/attributes\");e.exports={_isLinkedToArray:\"annotation\",visible:n.visible,x:{valType:\"any\"},y:{valType:\"any\"},z:{valType:\"any\"},ax:{valType:\"number\"},ay:{valType:\"number\"},xanchor:n.xanchor,xshift:n.xshift,yanchor:n.yanchor,yshift:n.yshift,text:n.text,textangle:n.textangle,font:n.font,width:n.width,height:n.height,opacity:n.opacity,align:n.align,valign:n.valign,bgcolor:n.bgcolor,bordercolor:n.bordercolor,borderpad:n.borderpad,borderwidth:n.borderwidth,showarrow:n.showarrow,arrowcolor:n.arrowcolor,arrowhead:n.arrowhead,arrowsize:n.arrowsize,arrowwidth:n.arrowwidth,standoff:n.standoff,hovertext:n.hovertext,hoverlabel:n.hoverlabel,captureevents:n.captureevents}},{\"../annotations/attributes\":586}],596:[function(t,e,r){\"use strict\";function n(t,e){var r=e.fullSceneLayout,n=r.domain,o=e.fullLayout._size,s={pdata:null,type:\"linear\",autorange:!1,range:[-1/0,1/0]};t._xa={},i.extendFlat(t._xa,s),a.setConvert(t._xa),t._xa._offset=o.l+n.x[0]*o.w,t._xa.l2p=function(){return.5*(1+t.pdata[0]/t.pdata[3])*o.w*(n.x[1]-n.x[0])},t._ya={},i.extendFlat(t._ya,s),a.setConvert(t._ya),t._ya._offset=o.t+(1-n.y[1])*o.h,t._ya.l2p=function(){return.5*(1-t.pdata[1]/t.pdata[3])*o.h*(n.y[1]-n.y[0])}}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\");e.exports=function(t){for(var e=t.fullSceneLayout,r=e.annotations,i=0;i<r.length;i++)n(r[i],t);t.fullLayout._infolayer.selectAll(\".annotation-\"+t.id).remove()}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766}],597:[function(t,e,r){\"use strict\";function n(t,e,r,n,o){function u(r,n){return i.coerce(t,e,l,r,n)}function c(t){var n=t+\"axis\",i={_fullLayout:{}};return i._fullLayout[n]=r[n],a.coercePosition(e,i,u,t,t,.5)}return u(\"visible\",!o.itemIsNotPlainObject)?(s(t,e,n.fullLayout,u),c(\"x\"),c(\"y\"),c(\"z\"),i.noneOrAll(t,e,[\"x\",\"y\",\"z\"]),e.xref=\"x\",e.yref=\"y\",e.zref=\"z\",u(\"xanchor\"),u(\"yanchor\"),u(\"xshift\"),u(\"yshift\"),e.showarrow&&(e.axref=\"pixel\",e.ayref=\"pixel\",u(\"ax\",-10),u(\"ay\",-30),i.noneOrAll(t,e,[\"ax\",\"ay\"])),e):e}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"../annotations/common_defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r){o(t,e,{name:\"annotations\",handleItemDefaults:n,fullLayout:r.fullLayout})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"../../plots/cartesian/axes\":766,\"../annotations/common_defaults\":589,\"./attributes\":595}],598:[function(t,e,r){\"use strict\";var n=t(\"../annotations/draw\").drawRaw,i=t(\"../../plots/gl3d/project\"),a=[\"x\",\"y\",\"z\"];e.exports=function(t){for(var e=t.fullSceneLayout,r=t.dataScale,o=e.annotations,s=0;s<o.length;s++){for(var l=o[s],u=!1,c=0;c<3;c++){var h=a[c],f=l[h],d=e[h+\"axis\"],p=d.r2fraction(f);if(p<0||p>1){u=!0;break}}u?t.fullLayout._infolayer.select(\".annotation-\"+t.id+'[data-index=\"'+s+'\"]').remove():(l.pdata=i(t.glplot.cameraParams,[e.xaxis.r2l(l.x)*r[0],e.yaxis.r2l(l.y)*r[1],e.zaxis.r2l(l.z)*r[2]]),n(t.graphDiv,l,s,t.id,l._xa,l._ya))}}},{\"../../plots/gl3d/project\":818,\"../annotations/draw\":592}],599:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"annotations3d\",schema:{layout:{\"scene.annotations\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),convert:t(\"./convert\"),draw:t(\"./draw\")}},{\"./attributes\":595,\"./convert\":596,\"./defaults\":597,\"./draw\":598}],600:[function(t,e,r){\"use strict\";e.exports=t(\"world-calendars/dist/main\"),t(\"world-calendars/dist/plus\"),t(\"world-calendars/dist/calendars/chinese\"),t(\"world-calendars/dist/calendars/coptic\"),t(\"world-calendars/dist/calendars/discworld\"),t(\"world-calendars/dist/calendars/ethiopian\"),t(\"world-calendars/dist/calendars/hebrew\"),t(\"world-calendars/dist/calendars/islamic\"),t(\"world-calendars/dist/calendars/julian\"),t(\"world-calendars/dist/calendars/mayan\"),t(\"world-calendars/dist/calendars/nanakshahi\"),t(\"world-calendars/dist/calendars/nepali\"),t(\"world-calendars/dist/calendars/persian\"),t(\"world-calendars/dist/calendars/taiwan\"),t(\"world-calendars/dist/calendars/thai\"),t(\"world-calendars/dist/calendars/ummalqura\")},{\"world-calendars/dist/calendars/chinese\":566,\"world-calendars/dist/calendars/coptic\":567,\"world-calendars/dist/calendars/discworld\":568,\"world-calendars/dist/calendars/ethiopian\":569,\"world-calendars/dist/calendars/hebrew\":570,\"world-calendars/dist/calendars/islamic\":571,\"world-calendars/dist/calendars/julian\":572,\"world-calendars/dist/calendars/mayan\":573,\"world-calendars/dist/calendars/nanakshahi\":574,\"world-calendars/dist/calendars/nepali\":575,\"world-calendars/dist/calendars/persian\":576,\"world-calendars/dist/calendars/taiwan\":577,\"world-calendars/dist/calendars/thai\":578,\"world-calendars/dist/calendars/ummalqura\":579,\"world-calendars/dist/main\":580,\"world-calendars/dist/plus\":581}],601:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n,a,o,s,l,u=Math.floor((e+.05)/h)+c,f=i(r).fromJD(u),d=0;-1!==(d=t.indexOf(\"%\",d));)n=t.charAt(d+1),\"0\"===n||\"-\"===n||\"_\"===n?(o=3,a=t.charAt(d+2),\"_\"===n&&(n=\"-\")):(a=n,n=\"0\",o=2),s=b[a],s?(l=s===y?y:f.formatDate(s[n]),t=t.substr(0,d)+l+t.substr(d+o),d+=l.length):d+=o;return t}function i(t){var e=x[t];return e||(e=x[t]=s.instance(t))}function a(t){return l.extendFlat({},f,{description:t})}function o(t){return\"Sets the calendar system to use with `\"+t+\"` date data.\"}var s=t(\"./calendars\"),l=t(\"../../lib\"),u=t(\"../../constants/numerical\"),c=u.EPOCHJD,h=u.ONEDAY,f={valType:\"enumerated\",values:Object.keys(s.calendars),dflt:\"gregorian\"},d=function(t,e,r,n){var i={};return i[r]=f,l.coerce(t,e,i,r,n)},p=function(t,e,r,n){for(var i=0;i<r.length;i++)d(t,e,r[i]+\"calendar\",n.calendar)},m={chinese:\"2000-01-01\",coptic:\"2000-01-01\",discworld:\"2000-01-01\",ethiopian:\"2000-01-01\",hebrew:\"5000-01-01\",islamic:\"1000-01-01\",julian:\"2000-01-01\",mayan:\"5000-01-01\",nanakshahi:\"1000-01-01\",nepali:\"2000-01-01\",persian:\"1000-01-01\",jalali:\"1000-01-01\",taiwan:\"1000-01-01\",thai:\"2000-01-01\",ummalqura:\"1400-01-01\"},v={chinese:\"2000-01-02\",coptic:\"2000-01-03\",discworld:\"2000-01-03\",ethiopian:\"2000-01-05\",hebrew:\"5000-01-01\",islamic:\"1000-01-02\",julian:\"2000-01-03\",mayan:\"5000-01-01\",nanakshahi:\"1000-01-05\",nepali:\"2000-01-05\",persian:\"1000-01-01\",jalali:\"1000-01-01\",taiwan:\"1000-01-04\",thai:\"2000-01-04\",ummalqura:\"1400-01-06\"},g={chinese:[\"2000-01-01\",\"2001-01-01\"],coptic:[\"1700-01-01\",\"1701-01-01\"],discworld:[\"1800-01-01\",\"1801-01-01\"],ethiopian:[\"2000-01-01\",\"2001-01-01\"],hebrew:[\"5700-01-01\",\"5701-01-01\"],islamic:[\"1400-01-01\",\"1401-01-01\"],julian:[\"2000-01-01\",\"2001-01-01\"],mayan:[\"5200-01-01\",\"5201-01-01\"],nanakshahi:[\"0500-01-01\",\"0501-01-01\"],nepali:[\"2000-01-01\",\"2001-01-01\"],persian:[\"1400-01-01\",\"1401-01-01\"],jalali:[\"1400-01-01\",\"1401-01-01\"],taiwan:[\"0100-01-01\",\"0101-01-01\"],thai:[\"2500-01-01\",\"2501-01-01\"],ummalqura:[\"1400-01-01\",\"1401-01-01\"]},y=\"##\",b={d:{0:\"dd\",\"-\":\"d\"},e:{0:\"d\",\"-\":\"d\"},a:{0:\"D\",\"-\":\"D\"},A:{0:\"DD\",\"-\":\"DD\"},j:{0:\"oo\",\"-\":\"o\"},W:{0:\"ww\",\"-\":\"w\"},m:{0:\"mm\",\"-\":\"m\"},b:{0:\"M\",\"-\":\"M\"},B:{0:\"MM\",\"-\":\"MM\"},y:{0:\"yy\",\"-\":\"yy\"},Y:{0:\"yyyy\",\"-\":\"yyyy\"},U:y,w:y,c:{0:\"D M d %X yyyy\",\"-\":\"D M d %X yyyy\"},x:{0:\"mm/dd/yyyy\",\"-\":\"mm/dd/yyyy\"}},x={},_={xcalendar:a(o(\"x\"))},w=l.extendFlat({},_,{ycalendar:a(o(\"y\"))}),M=l.extendFlat({},w,{zcalendar:a(o(\"z\"))}),k=a([\"Sets the calendar system to use for `range` and `tick0`\",\"if this is a date axis. This does not set the calendar for\",\"interpreting data on this axis, that's specified in the trace\",\"or via the global `layout.calendar`\"].join(\" \"));e.exports={moduleType:\"component\",name:\"calendars\",schema:{traces:{scatter:w,bar:w,heatmap:w,contour:w,histogram:w,histogram2d:w,histogram2dcontour:w,scatter3d:M,surface:M,mesh3d:M,scattergl:w,ohlc:_,candlestick:_},layout:{calendar:a([\"Sets the default calendar system to use for interpreting and\",\"displaying dates throughout the plot.\"].join(\" \")),\"xaxis.calendar\":k,\"yaxis.calendar\":k,\"scene.xaxis.calendar\":k,\"scene.yaxis.calendar\":k,\"scene.zaxis.calendar\":k},transforms:{filter:{valuecalendar:a([\"Sets the calendar system to use for `value`, if it is a date.\"].join(\" \")),targetcalendar:a([\"Sets the calendar system to use for `target`, if it is an\",\"array of dates. If `target` is a string (eg *x*) we use the\",\"corresponding trace attribute (eg `xcalendar`) if it exists,\",\"even if `targetcalendar` is provided.\"].join(\" \"))}}},layoutAttributes:f,handleDefaults:d,handleTraceDefaults:p,CANONICAL_SUNDAY:v,CANONICAL_TICK:m,DFLTRANGE:g,getCal:i,worldCalFmt:n}},{\"../../constants/numerical\":705,\"../../lib\":725,\"./calendars\":600}],602:[function(t,e,r){\"use strict\";r.defaults=[\"#1f77b4\",\"#ff7f0e\",\"#2ca02c\",\"#d62728\",\"#9467bd\",\"#8c564b\",\"#e377c2\",\"#7f7f7f\",\"#bcbd22\",\"#17becf\"],r.defaultLine=\"#444\",r.lightLine=\"#eee\",r.background=\"#fff\",r.borderLine=\"#BEC8D9\",r.lightFraction=1e3/11},{}],603:[function(t,e,r){\"use strict\";function n(t){if(a(t)||\"string\"!=typeof t)return t;var e=t.trim();if(\"rgb\"!==e.substr(0,3))return t;var r=e.match(/^rgba?\\s*\\(([^()]*)\\)$/);if(!r)return t;var n=r[1].trim().split(/\\s*[\\s,]\\s*/),i=\"a\"===e.charAt(3)&&4===n.length;if(!i&&3!==n.length)return t;for(var o=0;o<n.length;o++){if(!n[o].length)return t;if(n[o]=Number(n[o]),!(n[o]>=0))return t;if(3===o)n[o]>1&&(n[o]=1);else if(n[o]>=1)return t}var s=Math.round(255*n[0])+\", \"+Math.round(255*n[1])+\", \"+Math.round(255*n[2]);return i?\"rgba(\"+s+\", \"+n[3]+\")\":\"rgb(\"+s+\")\"}var i=t(\"tinycolor2\"),a=t(\"fast-isnumeric\"),o=e.exports={},s=t(\"./attributes\");o.defaults=s.defaults;var l=o.defaultLine=s.defaultLine;o.lightLine=s.lightLine;var u=o.background=s.background;o.tinyRGB=function(t){var e=t.toRgb();return\"rgb(\"+Math.round(e.r)+\", \"+Math.round(e.g)+\", \"+Math.round(e.b)+\")\"},o.rgb=function(t){return o.tinyRGB(i(t))},o.opacity=function(t){return t?i(t).getAlpha():0},o.addOpacity=function(t,e){var r=i(t).toRgb();return\"rgba(\"+Math.round(r.r)+\", \"+Math.round(r.g)+\", \"+Math.round(r.b)+\", \"+e+\")\"},o.combine=function(t,e){var r=i(t).toRgb();if(1===r.a)return i(t).toRgbString();var n=i(e||u).toRgb(),a=1===n.a?n:{r:255*(1-n.a)+n.r*n.a,g:255*(1-n.a)+n.g*n.a,b:255*(1-n.a)+n.b*n.a},o={r:a.r*(1-r.a)+r.r*r.a,g:a.g*(1-r.a)+r.g*r.a,b:a.b*(1-r.a)+r.b*r.a};return i(o).toRgbString()},o.contrast=function(t,e,r){var n=i(t);return 1!==n.getAlpha()&&(n=i(o.combine(t,u))),(n.isDark()?e?n.lighten(e):u:r?n.darken(r):l).toString()},o.stroke=function(t,e){var r=i(e);t.style({stroke:o.tinyRGB(r),\"stroke-opacity\":r.getAlpha()})},o.fill=function(t,e){var r=i(e);t.style({fill:o.tinyRGB(r),\"fill-opacity\":r.getAlpha()})},o.clean=function(t){if(t&&\"object\"==typeof t){var e,r,i,a,s=Object.keys(t);for(e=0;e<s.length;e++)if(i=s[e],a=t[i],\"color\"===i.substr(i.length-5))if(Array.isArray(a))for(r=0;r<a.length;r++)a[r]=n(a[r]);else t[i]=n(a);else if(\"colorscale\"===i.substr(i.length-10)&&Array.isArray(a))for(r=0;r<a.length;r++)Array.isArray(a[r])&&(a[r][1]=n(a[r][1]));else if(Array.isArray(a)){var l=a[0];if(!Array.isArray(l)&&l&&\"object\"==typeof l)for(r=0;r<a.length;r++)o.clean(a[r])}else a&&\"object\"==typeof a&&o.clean(a)}}},{\"./attributes\":602,\"fast-isnumeric\":130,tinycolor2:533}],604:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/layout_attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../lib/extend\").extendFlat;e.exports={thicknessmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"pixels\"},thickness:{valType:\"number\",min:0,dflt:30},lenmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"fraction\"},len:{valType:\"number\",min:0,dflt:1},x:{valType:\"number\",dflt:1.02,min:-2,max:3},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},xpad:{valType:\"number\",min:0,dflt:10},y:{valType:\"number\",dflt:.5,min:-2,max:3},yanchor:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"middle\"},ypad:{valType:\"number\",min:0,dflt:10},outlinecolor:n.linecolor,outlinewidth:n.linewidth,bordercolor:n.linecolor,borderwidth:{valType:\"number\",min:0,dflt:0},bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},tickmode:n.tickmode,nticks:n.nticks,tick0:n.tick0,dtick:n.dtick,tickvals:n.tickvals,ticktext:n.ticktext,ticks:a({},n.ticks,{dflt:\"\"}),ticklen:n.ticklen,tickwidth:n.tickwidth,tickcolor:n.tickcolor,showticklabels:n.showticklabels,tickfont:n.tickfont,tickangle:n.tickangle,tickformat:n.tickformat,tickprefix:n.tickprefix,showtickprefix:n.showtickprefix,ticksuffix:n.ticksuffix,showticksuffix:n.showticksuffix,separatethousands:n.separatethousands,exponentformat:n.exponentformat,showexponent:n.showexponent,title:{valType:\"string\",dflt:\"Click to enter colorscale title\"},titlefont:a({},i,{}),titleside:{valType:\"enumerated\",values:[\"right\",\"top\",\"bottom\"],dflt:\"top\"}}},{\"../../lib/extend\":716,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/font_attributes\":790}],605:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/tick_value_defaults\"),a=t(\"../../plots/cartesian/tick_mark_defaults\"),o=t(\"../../plots/cartesian/tick_label_defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r){function l(t,e){return n.coerce(c,u,s,t,e)}var u=e.colorbar={},c=t.colorbar||{};l(\"thickness\",\"fraction\"===l(\"thicknessmode\")?30/(r.width-r.margin.l-r.margin.r):30),l(\"len\",\"fraction\"===l(\"lenmode\")?1:r.height-r.margin.t-r.margin.b),l(\"x\"),l(\"xanchor\"),l(\"xpad\"),l(\"y\"),l(\"yanchor\"),l(\"ypad\"),n.noneOrAll(c,u,[\"x\",\"y\"]),l(\"outlinecolor\"),l(\"outlinewidth\"),l(\"bordercolor\"),l(\"borderwidth\"),l(\"bgcolor\"),i(c,u,l,\"linear\"),o(c,u,l,\"linear\",{outerTicks:!1,font:r.font,noHover:!0}),a(c,u,l,\"linear\",{outerTicks:!1,font:r.font,noHover:!0}),l(\"title\"),n.coerceFont(l,\"titlefont\",r.font),l(\"titleside\")}},{\"../../lib\":725,\"../../plots/cartesian/tick_label_defaults\":784,\"../../plots/cartesian/tick_mark_defaults\":785,\"../../plots/cartesian/tick_value_defaults\":786,\"./attributes\":604}],606:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"tinycolor2\"),a=t(\"../../plotly\"),o=t(\"../../plots/plots\"),s=t(\"../../registry\"),l=t(\"../../plots/cartesian/axes\"),u=t(\"../dragelement\"),c=t(\"../../lib\"),h=t(\"../../lib/extend\").extendFlat,f=t(\"../../lib/setcursor\"),d=t(\"../drawing\"),p=t(\"../color\"),m=t(\"../titles\"),v=t(\"../../lib/svg_text_utils\"),g=t(\"../../constants/alignment\").LINE_SPACING,y=t(\"../../plots/cartesian/axis_defaults\"),b=t(\"../../plots/cartesian/position_defaults\"),x=t(\"../../plots/cartesian/layout_attributes\"),_=t(\"./attributes\");e.exports=function(t,e){function r(){function _(t,e){return c.coerce(et,rt,x,t,e)}function k(){if(-1!==[\"top\",\"bottom\"].indexOf(M.titleside)){var e=lt.select(\".cbtitle\"),r=e.select(\"text\"),a=[-M.outlinewidth/2,M.outlinewidth/2],o=e.select(\".h\"+rt._id+\"title-math-group\").node(),s=15.6;if(r.node()&&(s=parseInt(r.style(\"font-size\"),10)*g),o?(ct=d.bBox(o).height)>s&&(a[1]-=(ct-s)/2):r.node()&&!r.classed(\"js-placeholder\")&&(ct=d.bBox(r.node()).height),ct){if(ct+=5,\"top\"===M.titleside)rt.domain[1]-=ct/E.h,a[1]*=-1;else{rt.domain[0]+=ct/E.h;var u=v.lineCount(r);a[1]+=(1-u)*s}e.attr(\"transform\",\"translate(\"+a+\")\"),rt.setScale()}}lt.selectAll(\".cbfills,.cblines,.cbaxis\").attr(\"transform\",\"translate(0,\"+Math.round(E.h*(1-rt.domain[1]))+\")\");var h=lt.select(\".cbfills\").selectAll(\"rect.cbfill\").data(D);h.enter().append(\"rect\").classed(\"cbfill\",!0).style(\"stroke\",\"none\"),h.exit().remove(),h.each(function(t,e){var r=[0===e?z[0]:(D[e]+D[e-1])/2,e===D.length-1?z[1]:(D[e]+D[e+1])/2].map(rt.c2p).map(Math.round);e!==D.length-1&&(r[1]+=r[1]>r[0]?1:-1);var a=O(t).replace(\"e-\",\"\"),o=i(a).toHexString();n.select(this).attr({x:J,width:Math.max(H,2),y:n.min(r),height:Math.max(n.max(r)-n.min(r),2),fill:o})});var f=lt.select(\".cblines\").selectAll(\"path.cbline\").data(M.line.color&&M.line.width?I:[]);return f.enter().append(\"path\").classed(\"cbline\",!0),f.exit().remove(),f.each(function(t){n.select(this).attr(\"d\",\"M\"+J+\",\"+(Math.round(rt.c2p(t))+M.line.width/2%1)+\"h\"+H).call(d.lineGroupStyle,M.line.width,P(t),M.line.dash)}),rt._axislayer.selectAll(\"g.\"+rt._id+\"tick,path\").remove(),rt._pos=J+H+(M.outlinewidth||0)/2-(\"outside\"===M.ticks?1:0),rt.side=\"right\",c.syncOrAsync([function(){return l.doTicks(t,rt,!0)},function(){if(-1===[\"top\",\"bottom\"].indexOf(M.titleside)){var e=rt.titlefont.size,r=rt._offset+rt._length/2,i=E.l+(rt.position||0)*E.w+(\"right\"===rt.side?10+e*(rt.showticklabels?1:.5):-10-e*(rt.showticklabels?.5:0));A(\"h\"+rt._id+\"title\",{avoid:{selection:n.select(t).selectAll(\"g.\"+rt._id+\"tick\"),side:M.titleside,offsetLeft:E.l,offsetTop:E.t,maxShift:S.width},attributes:{x:i,y:r,\"text-anchor\":\"middle\"},transform:{rotate:\"-90\",offset:0}})}}])}function A(e,r){var n,i=w();n=s.traceIs(i,\"markerColorscale\")?\"marker.colorbar.title\":\"colorbar.title\";var a={propContainer:rt,propName:n,traceIndex:i.index,dfltName:\"colorscale\",containerGroup:lt.select(\".cbtitle\")},o=\"h\"===e.charAt(0)?e.substr(1):\"h\"+e;lt.selectAll(\".\"+o+\",.\"+o+\"-math-group\").remove(),m.draw(t,e,h(a,r||{}))}function T(){var r=H+M.outlinewidth/2+d.bBox(rt._axislayer.node()).width;if(B=ut.select(\"text\"),B.node()&&!B.classed(\"js-placeholder\")){var n,i=ut.select(\".h\"+rt._id+\"title-math-group\").node();n=i&&-1!==[\"top\",\"bottom\"].indexOf(M.titleside)?d.bBox(i).width:d.bBox(ut.node()).right-J-E.l,r=Math.max(r,n)}var a=2*M.xpad+r+M.borderwidth+M.outlinewidth/2,s=$-tt;lt.select(\".cbbg\").attr({x:J-M.xpad-(M.borderwidth+M.outlinewidth)/2,y:tt-W,width:Math.max(a,2),height:Math.max(s+2*W,2)}).call(p.fill,M.bgcolor).call(p.stroke,M.bordercolor).style({\"stroke-width\":M.borderwidth}),lt.selectAll(\".cboutline\").attr({x:J,y:tt+M.ypad+(\"top\"===M.titleside?ct:0),width:Math.max(H,2),height:Math.max(s-2*M.ypad-ct,2)}).call(p.stroke,M.outlinecolor).style({fill:\"None\",\"stroke-width\":M.outlinewidth});var l=({center:.5,right:1}[M.xanchor]||0)*a;lt.attr(\"transform\",\"translate(\"+(E.l-l)+\",\"+E.t+\")\"),o.autoMargin(t,e,{x:M.x,y:M.y,l:a*({right:1,center:.5}[M.xanchor]||0),r:a*({left:1,center:.5}[M.xanchor]||0),t:s*({bottom:1,middle:.5}[M.yanchor]||0),b:s*({top:1,middle:.5}[M.yanchor]||0)})}var S=t._fullLayout,E=S._size;if(\"function\"!=typeof M.fillcolor&&\"function\"!=typeof M.line.color)return void S._infolayer.selectAll(\"g.\"+e).remove();var L,C,z=n.extent((\"function\"==typeof M.fillcolor?M.fillcolor:M.line.color).domain()),I=[],D=[],P=\"function\"==typeof M.line.color?M.line.color:function(){return M.line.color},O=\"function\"==typeof M.fillcolor?M.fillcolor:function(){return M.fillcolor},R=M.levels.end+M.levels.size/100,F=M.levels.size,j=1.001*z[0]-.001*z[1],N=1.001*z[1]-.001*z[0];for(C=0;C<1e5&&(L=M.levels.start+C*F,!(F>0?L>=R:L<=R));C++)L>j&&L<N&&I.push(L);if(\"function\"==typeof M.fillcolor)if(M.filllevels)for(R=M.filllevels.end+M.filllevels.size/100,F=M.filllevels.size,C=0;C<1e5&&(L=M.filllevels.start+C*F,!(F>0?L>=R:L<=R));C++)L>z[0]&&L<z[1]&&D.push(L);else D=I.map(function(t){return t-M.levels.size/2}),D.push(D[D.length-1]+M.levels.size);else M.fillcolor&&\"string\"==typeof M.fillcolor&&(D=[0]);M.levels.size<0&&(I.reverse(),D.reverse());var B,U=S.height-S.margin.t-S.margin.b,V=S.width-S.margin.l-S.margin.r,H=Math.round(M.thickness*(\"fraction\"===M.thicknessmode?V:1)),q=H/E.w,G=Math.round(M.len*(\"fraction\"===M.lenmode?U:1)),Y=G/E.h,X=M.xpad/E.w,W=(M.borderwidth+M.outlinewidth)/2,Z=M.ypad/E.h,J=Math.round(M.x*E.w+M.xpad),K=M.x-q*({middle:.5,right:1}[M.xanchor]||0),Q=M.y+Y*(({top:-.5,bottom:.5}[M.yanchor]||0)-.5),$=Math.round(E.h*(1-Q)),tt=$-G,et={type:\"linear\",range:z,tickmode:M.tickmode,nticks:M.nticks,tick0:M.tick0,dtick:M.dtick,tickvals:M.tickvals,ticktext:M.ticktext,ticks:M.ticks,ticklen:M.ticklen,tickwidth:M.tickwidth,tickcolor:M.tickcolor,showticklabels:M.showticklabels,tickfont:M.tickfont,tickangle:M.tickangle,tickformat:M.tickformat,exponentformat:M.exponentformat,separatethousands:M.separatethousands,showexponent:M.showexponent,showtickprefix:M.showtickprefix,tickprefix:M.tickprefix,showticksuffix:M.showticksuffix,ticksuffix:M.ticksuffix,title:M.title,titlefont:M.titlefont,showline:!0,anchor:\"free\",position:1},rt={type:\"linear\",_id:\"y\"+e},nt={letter:\"y\",font:S.font,noHover:!0,calendar:S.calendar};if(y(et,rt,_,nt,S),b(et,rt,_,nt),rt.position=M.x+X+q,r.axis=rt,-1!==[\"top\",\"bottom\"].indexOf(M.titleside)&&(rt.titleside=M.titleside,rt.titlex=M.x+X,rt.titley=Q+(\"top\"===M.titleside?Y-Z:Z)),M.line.color&&\"auto\"===M.tickmode){rt.tickmode=\"linear\",rt.tick0=M.levels.start;var it=M.levels.size,at=c.constrain(($-tt)/50,4,15)+1,ot=(z[1]-z[0])/((M.nticks||at)*it);if(ot>1){var st=Math.pow(10,Math.floor(Math.log(ot)/Math.LN10));it*=st*c.roundUp(ot/st,[2,5,10]),(Math.abs(M.levels.start)/M.levels.size+1e-6)%1<2e-6&&(rt.tick0=0)}rt.dtick=it}rt.domain=[Q+Z,Q+Y-Z],rt.setScale();var lt=S._infolayer.selectAll(\"g.\"+e).data([0]);lt.enter().append(\"g\").classed(e,!0).each(function(){var t=n.select(this);t.append(\"rect\").classed(\"cbbg\",!0),t.append(\"g\").classed(\"cbfills\",!0),t.append(\"g\").classed(\"cblines\",!0),t.append(\"g\").classed(\"cbaxis\",!0).classed(\"crisp\",!0),t.append(\"g\").classed(\"cbtitleunshift\",!0).append(\"g\").classed(\"cbtitle\",!0),t.append(\"rect\").classed(\"cboutline\",!0),t.select(\".cbtitle\").datum(0)}),lt.attr(\"transform\",\"translate(\"+Math.round(E.l)+\",\"+Math.round(E.t)+\")\");var ut=lt.select(\".cbtitleunshift\").attr(\"transform\",\"translate(-\"+Math.round(E.l)+\",-\"+Math.round(E.t)+\")\");rt._axislayer=lt.select(\".cbaxis\");var ct=0;if(-1!==[\"top\",\"bottom\"].indexOf(M.titleside)){var ht,ft=E.l+(M.x+X)*E.w,dt=rt.titlefont.size;ht=\"top\"===M.titleside?(1-(Q+Y-Z))*E.h+E.t+3+.75*dt:(1-(Q+Z))*E.h+E.t-3-.25*dt,A(rt._id+\"title\",{attributes:{x:ft,y:ht,\"text-anchor\":\"start\"}})}var pt=c.syncOrAsync([o.previousPromises,k,o.previousPromises,T],t);if(pt&&pt.then&&(t._promises||[]).push(pt),t._context.edits.colorbarPosition){var mt,vt,gt;u.init({element:lt.node(),gd:t,prepFn:function(){mt=lt.attr(\"transform\"),f(lt)},moveFn:function(t,e){lt.attr(\"transform\",mt+\" translate(\"+t+\",\"+e+\")\"),vt=u.align(K+t/E.w,q,0,1,M.xanchor),gt=u.align(Q-e/E.h,Y,0,1,M.yanchor);var r=u.getCursor(vt,gt,M.xanchor,M.yanchor);f(lt,r)},doneFn:function(e){f(lt),e&&void 0!==vt&&void 0!==gt&&a.restyle(t,{\"colorbar.x\":vt,\"colorbar.y\":gt},w().index)}})}return pt}function w(){var r,n,i=e.substr(2);for(r=0;r<t._fullData.length;r++)if(n=t._fullData[r],n.uid===i)return n}var M={};return Object.keys(_).forEach(function(t){M[t]=null}),M.fillcolor=null,M.line={color:null,width:null,dash:null},M.levels={start:null,end:null,size:null},M.filllevels=null,Object.keys(M).forEach(function(t){r[t]=function(e){return arguments.length?(M[t]=c.isPlainObject(M[t])?c.extendFlat(M[t],e):e,r):M[t]}}),r.options=function(t){return Object.keys(t).forEach(function(e){\"function\"==typeof r[e]&&r[e](t[e])}),r},r._opts=M,r}},{\"../../constants/alignment\":699,\"../../lib\":725,\"../../lib/extend\":716,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_defaults\":768,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/cartesian/position_defaults\":780,\"../../plots/plots\":829,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"../titles\":692,\"./attributes\":604,d3:121,tinycolor2:533}],607:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t){return n.isPlainObject(t.colorbar)}},{\"../../lib\":725}],608:[function(t,e,r){\"use strict\";e.exports={zauto:{valType:\"boolean\",dflt:!0},zmin:{valType:\"number\",dflt:null},zmax:{valType:\"number\",dflt:null},colorscale:{valType:\"colorscale\"},autocolorscale:{valType:\"boolean\",dflt:!0},reversescale:{valType:\"boolean\",dflt:!1},showscale:{valType:\"boolean\",dflt:!0}}},{}],609:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./scales\"),a=t(\"./flip_scale\");e.exports=function(t,e,r,o){var s,l;r?(s=n.nestedProperty(t,r).get(),l=n.nestedProperty(t._input,r).get()):(s=t,l=t._input);var u=o+\"auto\",c=o+\"min\",h=o+\"max\",f=s[u],d=s[c],p=s[h],m=s.colorscale;!1===f&&void 0!==d||(d=n.aggNums(Math.min,null,e)),!1===f&&void 0!==p||(p=n.aggNums(Math.max,null,e)),d===p&&(d-=.5,p+=.5),s[c]=d,s[h]=p,l[c]=d,l[h]=p,l[u]=!1!==f||void 0===d&&void 0===p,s.autocolorscale&&(m=d*p<0?i.RdBu:d>=0?i.Reds:i.Blues,l.colorscale=m,s.reversescale&&(m=a(m)),s.colorscale=m)}},{\"../../lib\":725,\"./flip_scale\":614,\"./scales\":621}],610:[function(t,e,r){\"use strict\";var n=t(\"./attributes\"),i=t(\"../../lib/extend\").extendDeep;t(\"./scales.js\");e.exports=function(t){return{color:{valType:\"color\",arrayOk:!0},colorscale:i({},n.colorscale,{}),cauto:i({},n.zauto,{}),cmax:i({},n.zmax,{}),cmin:i({},n.zmin,{}),autocolorscale:i({},n.autocolorscale,{}),reversescale:i({},n.reversescale,{})}}},{\"../../lib/extend\":716,\"./attributes\":608,\"./scales.js\":621}],611:[function(t,e,r){\"use strict\";var n=t(\"./scales\");e.exports=n.RdBu},{\"./scales\":621}],612:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../colorbar/has_colorbar\"),o=t(\"../colorbar/defaults\"),s=t(\"./is_valid_scale\"),l=t(\"./flip_scale\");e.exports=function(t,e,r,u,c){var h=c.prefix,f=c.cLetter,d=h.slice(0,h.length-1),p=h?i.nestedProperty(t,d).get()||{}:t,m=h?i.nestedProperty(e,d).get()||{}:e,v=p[f+\"min\"],g=p[f+\"max\"],y=p.colorscale;u(h+f+\"auto\",!(n(v)&&n(g)&&v<g)),u(h+f+\"min\"),u(h+f+\"max\");var b;void 0!==y&&(b=!s(y)),u(h+\"autocolorscale\",b);var x=u(h+\"colorscale\");if(u(h+\"reversescale\")&&(m.colorscale=l(x)),\"marker.line.\"!==h){var _;h&&(_=a(p)),u(h+\"showscale\",_)&&o(p,m,r)}}},{\"../../lib\":725,\"../colorbar/defaults\":605,\"../colorbar/has_colorbar\":607,\"./flip_scale\":614,\"./is_valid_scale\":618,\"fast-isnumeric\":130}],613:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){for(var n=t.length,i=new Array(n),a=new Array(n),o=0;o<n;o++){var s=t[o];i[o]=e+s[0]*(r-e),a[o]=s[1]}return{domain:i,range:a}}},{}],614:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e,r=t.length,n=new Array(r),i=r-1,a=0;i>=0;i--,a++)e=t[i],n[a]=[1-e[0],e[1]];return n}},{}],615:[function(t,e,r){\"use strict\";var n=t(\"./scales\"),i=t(\"./default_scale\"),a=t(\"./is_valid_scale_array\");e.exports=function(t,e){function r(){try{t=n[t]||JSON.parse(t)}catch(r){t=e}}return e||(e=i),t?(\"string\"==typeof t&&(r(),\"string\"==typeof t&&r()),a(t)?t:e):e}},{\"./default_scale\":611,\"./is_valid_scale_array\":619,\"./scales\":621}],616:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"./is_valid_scale\");e.exports=function(t,e){var r=e?i.nestedProperty(t,e).get()||{}:t,o=r.color,s=!1;if(Array.isArray(o))for(var l=0;l<o.length;l++)if(n(o[l])){s=!0;break}return i.isPlainObject(r)&&(s||!0===r.showscale||n(r.cmin)&&n(r.cmax)||a(r.colorscale)||i.isPlainObject(r.colorbar))}},{\"../../lib\":725,\"./is_valid_scale\":618,\"fast-isnumeric\":130}],617:[function(t,e,r){\"use strict\";r.scales=t(\"./scales\"),r.defaultScale=t(\"./default_scale\"),r.attributes=t(\"./attributes\"),r.handleDefaults=t(\"./defaults\"),r.calc=t(\"./calc\"),r.hasColorscale=t(\"./has_colorscale\"),r.isValidScale=t(\"./is_valid_scale\"),r.getScale=t(\"./get_scale\"),r.flipScale=t(\"./flip_scale\"),r.extractScale=t(\"./extract_scale\"),r.makeColorScaleFunc=t(\"./make_color_scale_func\")},{\"./attributes\":608,\"./calc\":609,\"./default_scale\":611,\"./defaults\":612,\"./extract_scale\":613,\"./flip_scale\":614,\"./get_scale\":615,\"./has_colorscale\":616,\"./is_valid_scale\":618,\"./make_color_scale_func\":620,\"./scales\":621}],618:[function(t,e,r){\"use strict\";var n=t(\"./scales\"),i=t(\"./is_valid_scale_array\");e.exports=function(t){return void 0!==n[t]||i(t)}},{\"./is_valid_scale_array\":619,\"./scales\":621}],619:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\");e.exports=function(t){var e=0;if(!Array.isArray(t)||t.length<2)return!1;if(!t[0]||!t[t.length-1])return!1;if(0!=+t[0][0]||1!=+t[t.length-1][0])return!1;for(var r=0;r<t.length;r++){var i=t[r];if(2!==i.length||+i[0]<e||!n(i[1]).isValid())return!1;e=+i[0]}return!0}},{tinycolor2:533}],620:[function(t,e,r){\"use strict\";function n(t){var e={r:t[0],g:t[1],b:t[2],a:t[3]};return a(e).toRgbString()}var i=t(\"d3\"),a=t(\"tinycolor2\"),o=t(\"fast-isnumeric\"),s=t(\"../color\");e.exports=function(t,e){e=e||{};for(var r=t.domain,l=t.range,u=l.length,c=new Array(u),h=0;h<u;h++){var f=a(l[h]).toRgb();c[h]=[f.r,f.g,f.b,f.a]}var d,p=i.scale.linear().domain(r).range(c).clamp(!0),m=e.noNumericCheck,v=e.returnArray;return d=m&&v?p:m?function(t){return n(p(t))}:v?function(t){return o(t)?p(t):a(t).isValid()?t:s.defaultLine}:function(t){return o(t)?n(p(t)):a(t).isValid()?t:s.defaultLine},d.domain=p.domain,d.range=function(){return l},d}},{\"../color\":603,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],621:[function(t,e,r){\"use strict\";e.exports={Greys:[[0,\"rgb(0,0,0)\"],[1,\"rgb(255,255,255)\"]],YlGnBu:[[0,\"rgb(8,29,88)\"],[.125,\"rgb(37,52,148)\"],[.25,\"rgb(34,94,168)\"],[.375,\"rgb(29,145,192)\"],[.5,\"rgb(65,182,196)\"],[.625,\"rgb(127,205,187)\"],[.75,\"rgb(199,233,180)\"],[.875,\"rgb(237,248,217)\"],[1,\"rgb(255,255,217)\"]],Greens:[[0,\"rgb(0,68,27)\"],[.125,\"rgb(0,109,44)\"],[.25,\"rgb(35,139,69)\"],[.375,\"rgb(65,171,93)\"],[.5,\"rgb(116,196,118)\"],[.625,\"rgb(161,217,155)\"],[.75,\"rgb(199,233,192)\"],[.875,\"rgb(229,245,224)\"],[1,\"rgb(247,252,245)\"]],YlOrRd:[[0,\"rgb(128,0,38)\"],[.125,\"rgb(189,0,38)\"],[.25,\"rgb(227,26,28)\"],[.375,\"rgb(252,78,42)\"],[.5,\"rgb(253,141,60)\"],[.625,\"rgb(254,178,76)\"],[.75,\"rgb(254,217,118)\"],[.875,\"rgb(255,237,160)\"],[1,\"rgb(255,255,204)\"]],Bluered:[[0,\"rgb(0,0,255)\"],[1,\"rgb(255,0,0)\"]],RdBu:[[0,\"rgb(5,10,172)\"],[.35,\"rgb(106,137,247)\"],[.5,\"rgb(190,190,190)\"],[.6,\"rgb(220,170,132)\"],[.7,\"rgb(230,145,90)\"],[1,\"rgb(178,10,28)\"]],Reds:[[0,\"rgb(220,220,220)\"],[.2,\"rgb(245,195,157)\"],[.4,\"rgb(245,160,105)\"],[1,\"rgb(178,10,28)\"]],Blues:[[0,\"rgb(5,10,172)\"],[.35,\"rgb(40,60,190)\"],[.5,\"rgb(70,100,245)\"],[.6,\"rgb(90,120,245)\"],[.7,\"rgb(106,137,247)\"],[1,\"rgb(220,220,220)\"]],Picnic:[[0,\"rgb(0,0,255)\"],[.1,\"rgb(51,153,255)\"],[.2,\"rgb(102,204,255)\"],[.3,\"rgb(153,204,255)\"],[.4,\"rgb(204,204,255)\"],[.5,\"rgb(255,255,255)\"],[.6,\"rgb(255,204,255)\"],[.7,\"rgb(255,153,255)\"],[.8,\"rgb(255,102,204)\"],[.9,\"rgb(255,102,102)\"],[1,\"rgb(255,0,0)\"]],Rainbow:[[0,\"rgb(150,0,90)\"],[.125,\"rgb(0,0,200)\"],[.25,\"rgb(0,25,255)\"],[.375,\"rgb(0,152,255)\"],[.5,\"rgb(44,255,150)\"],[.625,\"rgb(151,255,0)\"],[.75,\"rgb(255,234,0)\"],[.875,\"rgb(255,111,0)\"],[1,\"rgb(255,0,0)\"]],Portland:[[0,\"rgb(12,51,131)\"],[.25,\"rgb(10,136,186)\"],[.5,\"rgb(242,211,56)\"],[.75,\"rgb(242,143,56)\"],[1,\"rgb(217,30,30)\"]],Jet:[[0,\"rgb(0,0,131)\"],[.125,\"rgb(0,60,170)\"],[.375,\"rgb(5,255,255)\"],[.625,\"rgb(255,255,0)\"],[.875,\"rgb(250,0,0)\"],[1,\"rgb(128,0,0)\"]],Hot:[[0,\"rgb(0,0,0)\"],[.3,\"rgb(230,0,0)\"],[.6,\"rgb(255,210,0)\"],[1,\"rgb(255,255,255)\"]],Blackbody:[[0,\"rgb(0,0,0)\"],[.2,\"rgb(230,0,0)\"],[.4,\"rgb(230,210,0)\"],[.7,\"rgb(255,255,255)\"],[1,\"rgb(160,200,255)\"]],Earth:[[0,\"rgb(0,0,130)\"],[.1,\"rgb(0,180,180)\"],[.2,\"rgb(40,210,40)\"],[.4,\"rgb(230,230,50)\"],[.6,\"rgb(120,70,20)\"],[1,\"rgb(255,255,255)\"]],Electric:[[0,\"rgb(0,0,0)\"],[.15,\"rgb(30,0,100)\"],[.4,\"rgb(120,0,100)\"],[.6,\"rgb(160,90,0)\"],[.8,\"rgb(230,200,0)\"],[1,\"rgb(255,250,220)\"]],Viridis:[[0,\"#440154\"],[.06274509803921569,\"#48186a\"],[.12549019607843137,\"#472d7b\"],[.18823529411764706,\"#424086\"],[.25098039215686274,\"#3b528b\"],[.3137254901960784,\"#33638d\"],[.3764705882352941,\"#2c728e\"],[.4392156862745098,\"#26828e\"],[.5019607843137255,\"#21918c\"],[.5647058823529412,\"#1fa088\"],[.6274509803921569,\"#28ae80\"],[.6901960784313725,\"#3fbc73\"],[.7529411764705882,\"#5ec962\"],[.8156862745098039,\"#84d44b\"],[.8784313725490196,\"#addc30\"],[.9411764705882353,\"#d8e219\"],[1,\"#fde725\"]]}},{}],622:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i){var a=(t-r)/(n-r),o=a+e/(n-r),s=(a+o)/2\n",
       ";return\"left\"===i||\"bottom\"===i?a:\"center\"===i||\"middle\"===i?s:\"right\"===i||\"top\"===i?o:a<2/3-s?a:o>4/3-s?o:s}},{}],623:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=[[\"sw-resize\",\"s-resize\",\"se-resize\"],[\"w-resize\",\"move\",\"e-resize\"],[\"nw-resize\",\"n-resize\",\"ne-resize\"]];e.exports=function(t,e,r,a){return t=\"left\"===r?0:\"center\"===r?1:\"right\"===r?2:n.constrain(Math.floor(3*t),0,2),e=\"bottom\"===a?0:\"middle\"===a?1:\"top\"===a?2:n.constrain(Math.floor(3*e),0,2),i[e][t]}},{\"../../lib\":725}],624:[function(t,e,r){\"use strict\";function n(){var t=document.createElement(\"div\");t.className=\"dragcover\";var e=t.style;return e.position=\"fixed\",e.left=0,e.right=0,e.top=0,e.bottom=0,e.zIndex=999999999,e.background=\"none\",document.body.appendChild(t),t}function i(t){t._dragging=!1,t._replotPending&&l.plot(t)}function a(t){return o(t.changedTouches?t.changedTouches[0]:t,document.body)}var o=t(\"mouse-event-offset\"),s=t(\"has-hover\"),l=t(\"../../plotly\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/constants\"),h=t(\"../../constants/interactions\"),f=e.exports={};f.align=t(\"./align\"),f.getCursor=t(\"./cursor\");var d=t(\"./unhover\");f.unhover=d.wrapped,f.unhoverRaw=d.raw,f.init=function(t){function e(e){y._dragged=!1,y._dragging=!0;var i=a(e);return l=i[0],d=i[1],g=e.target,p=(new Date).getTime(),p-y._mouseDownTime<x?b+=1:(b=1,y._mouseDownTime=p),t.prepFn&&t.prepFn(e,l,d),s?(v=n(),v.style.cursor=window.getComputedStyle(t.element).cursor):(v=document,m=window.getComputedStyle(document.documentElement).cursor,document.documentElement.style.cursor=window.getComputedStyle(t.element).cursor),v.addEventListener(\"mousemove\",r),v.addEventListener(\"mouseup\",o),v.addEventListener(\"mouseout\",o),v.addEventListener(\"touchmove\",r),v.addEventListener(\"touchend\",o),u.pauseEvent(e)}function r(e){var r=a(e),n=r[0]-l,i=r[1]-d,o=t.minDrag||c.MINDRAG;return Math.abs(n)<o&&(n=0),Math.abs(i)<o&&(i=0),(n||i)&&(y._dragged=!0,f.unhover(y)),t.moveFn&&t.moveFn(n,i,y._dragged),u.pauseEvent(e)}function o(e){if(v.removeEventListener(\"mousemove\",r),v.removeEventListener(\"mouseup\",o),v.removeEventListener(\"mouseout\",o),v.removeEventListener(\"touchmove\",r),v.removeEventListener(\"touchend\",o),s?u.removeElement(v):m&&(v.documentElement.style.cursor=m,m=null),!y._dragging)return void(y._dragged=!1);if(y._dragging=!1,(new Date).getTime()-y._mouseDownTime>x&&(b=Math.max(b-1,1)),t.doneFn&&t.doneFn(y._dragged,b,e),!y._dragged){var n;try{n=new MouseEvent(\"click\",e)}catch(t){var l=a(e);n=document.createEvent(\"MouseEvents\"),n.initMouseEvent(\"click\",e.bubbles,e.cancelable,e.view,e.detail,e.screenX,e.screenY,l[0],l[1],e.ctrlKey,e.altKey,e.shiftKey,e.metaKey,e.button,e.relatedTarget)}g.dispatchEvent(n)}return i(y),y._dragged=!1,u.pauseEvent(e)}var l,d,p,m,v,g,y=t.gd,b=1,x=h.DBLCLICKDELAY;y._mouseDownTime||(y._mouseDownTime=0),t.element.style.pointerEvents=\"all\",t.element.onmousedown=e,t.element.ontouchstart=e},f.coverSlip=n},{\"../../constants/interactions\":704,\"../../lib\":725,\"../../plotly\":761,\"../../plots/cartesian/constants\":771,\"./align\":622,\"./cursor\":623,\"./unhover\":625,\"has-hover\":287,\"mouse-event-offset\":452}],625:[function(t,e,r){\"use strict\";var n=t(\"../../lib/events\"),i=e.exports={};i.wrapped=function(t,e,r){\"string\"==typeof t&&(t=document.getElementById(t)),t._hoverTimer&&(clearTimeout(t._hoverTimer),t._hoverTimer=void 0),i.raw(t,e,r)},i.raw=function(t,e){var r=t._fullLayout,i=t._hoverdata;e||(e={}),e.target&&!1===n.triggerHandler(t,\"plotly_beforehover\",e)||(r._hoverlayer.selectAll(\"g\").remove(),r._hoverlayer.selectAll(\"line\").remove(),r._hoverlayer.selectAll(\"circle\").remove(),t._hoverdata=void 0,e.target&&i&&t.emit(\"plotly_unhover\",{event:e,points:i}))}},{\"../../lib/events\":715}],626:[function(t,e,r){\"use strict\";r.dash={valType:\"string\",values:[\"solid\",\"dot\",\"dash\",\"longdash\",\"dashdot\",\"longdashdot\"],dflt:\"solid\"}},{}],627:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){if(u.traceIs(r,\"symbols\")){var l=y(r);e.attr(\"d\",function(t){var e;e=\"various\"===t.ms||\"various\"===a.size?3:g.isBubble(r)?l(t.ms):(a.size||6)/2,t.mrc=e;var n=b.symbolNumber(t.mx||a.symbol)||0,i=n%100;return t.om=n%200>=100,b.symbolFuncs[i](e)+(n>=200?w:\"\")}).style(\"opacity\",function(t){return(t.mo+1||a.opacity+1)-1})}var h,f,d,p=!1;if(t.so?(d=o.outlierwidth,f=o.outliercolor,h=a.outliercolor):(d=(t.mlw+1||o.width+1||(t.trace?t.trace.marker.line.width:0)+1)-1,f=\"mlc\"in t?t.mlcc=i(t.mlc):Array.isArray(o.color)?c.defaultLine:o.color,Array.isArray(a.color)&&(h=c.defaultLine,p=!0),h=\"mc\"in t?t.mcc=n(t.mc):a.color||\"rgba(0,0,0,0)\"),t.om)e.call(c.stroke,h).style({\"stroke-width\":(d||1)+\"px\",fill:\"none\"});else{e.style(\"stroke-width\",d+\"px\");var m=a.gradient,v=t.mgt;if(v?p=!0:v=m&&m.type,v&&\"none\"!==v){var x=t.mgc;x?p=!0:x=m.color;var _=\"g\"+s._fullLayout._uid+\"-\"+r.uid;p&&(_+=\"-\"+t.i),e.call(b.gradient,s,_,v,h,x)}else e.call(c.fill,h);d&&e.call(c.stroke,f)}}function i(t,e,r,n){var i=t[0]-e[0],a=t[1]-e[1],s=r[0]-e[0],l=r[1]-e[1],u=Math.pow(i*i+a*a,T/2),c=Math.pow(s*s+l*l,T/2),h=(c*c*i-u*u*s)*n,f=(c*c*a-u*u*l)*n,d=3*c*(u+c),p=3*u*(u+c);return[[o.round(e[0]+(d&&h/d),2),o.round(e[1]+(d&&f/d),2)],[o.round(e[0]-(p&&h/p),2),o.round(e[1]-(p&&f/p),2)]]}function a(t){var e=t.getAttribute(\"data-unformatted\");if(null!==e)return e+t.getAttribute(\"data-math\")+t.getAttribute(\"text-anchor\")+t.getAttribute(\"style\")}var o=t(\"d3\"),s=t(\"fast-isnumeric\"),l=t(\"tinycolor2\"),u=t(\"../../registry\"),c=t(\"../color\"),h=t(\"../colorscale\"),f=t(\"../../lib\"),d=t(\"../../lib/svg_text_utils\"),p=t(\"../../constants/xmlns_namespaces\"),m=t(\"../../constants/alignment\"),v=m.LINE_SPACING,g=t(\"../../traces/scatter/subtypes\"),y=t(\"../../traces/scatter/make_bubble_size_func\"),b=e.exports={};b.font=function(t,e,r,n){f.isPlainObject(e)&&(n=e.color,r=e.size,e=e.family),e&&t.style(\"font-family\",e),r+1&&t.style(\"font-size\",r+\"px\"),n&&t.call(c.fill,n)},b.setPosition=function(t,e,r){t.attr(\"x\",e).attr(\"y\",r)},b.setSize=function(t,e,r){t.attr(\"width\",e).attr(\"height\",r)},b.setRect=function(t,e,r,n,i){t.call(b.setPosition,e,r).call(b.setSize,n,i)},b.translatePoint=function(t,e,r,n){var i=r.c2p(t.x),a=n.c2p(t.y);return!!(s(i)&&s(a)&&e.node())&&(\"text\"===e.node().nodeName?e.attr(\"x\",i).attr(\"y\",a):e.attr(\"transform\",\"translate(\"+i+\",\"+a+\")\"),!0)},b.translatePoints=function(t,e,r){t.each(function(t){var n=o.select(this);b.translatePoint(t,n,e,r)})},b.hideOutsideRangePoint=function(t,e,r,n){e.attr(\"display\",r.isPtWithinRange(t)&&n.isPtWithinRange(t)?null:\"none\")},b.hideOutsideRangePoints=function(t,e){if(e._hasClipOnAxisFalse){var r=e.xaxis,n=e.yaxis;t.each(function(t){b.hideOutsideRangePoint(t,o.select(this),r,n)})}},b.getPx=function(t,e){return Number(t.style(e).replace(/px$/,\"\"))},b.crispRound=function(t,e,r){return e&&s(e)?t._context.staticPlot?e:e<1?1:Math.round(e):r||0},b.singleLineStyle=function(t,e,r,n,i){e.style(\"fill\",\"none\");var a=(((t||[])[0]||{}).trace||{}).line||{},o=r||a.width||0,s=i||a.dash||\"\";c.stroke(e,n||a.color),b.dashLine(e,s,o)},b.lineGroupStyle=function(t,e,r,n){t.style(\"fill\",\"none\").each(function(t){var i=(((t||[])[0]||{}).trace||{}).line||{},a=e||i.width||0,s=n||i.dash||\"\";o.select(this).call(c.stroke,r||i.color).call(b.dashLine,s,a)})},b.dashLine=function(t,e,r){r=+r||0,e=b.dashStyle(e,r),t.style({\"stroke-dasharray\":e,\"stroke-width\":r+\"px\"})},b.dashStyle=function(t,e){e=+e||1;var r=Math.max(e,3);return\"solid\"===t?t=\"\":\"dot\"===t?t=r+\"px,\"+r+\"px\":\"dash\"===t?t=3*r+\"px,\"+3*r+\"px\":\"longdash\"===t?t=5*r+\"px,\"+5*r+\"px\":\"dashdot\"===t?t=3*r+\"px,\"+r+\"px,\"+r+\"px,\"+r+\"px\":\"longdashdot\"===t&&(t=5*r+\"px,\"+2*r+\"px,\"+r+\"px,\"+2*r+\"px\"),t},b.singleFillStyle=function(t){var e=o.select(t.node()),r=e.data(),n=(((r[0]||[])[0]||{}).trace||{}).fillcolor;n&&t.call(c.fill,n)},b.fillGroupStyle=function(t){t.style(\"stroke-width\",0).each(function(e){var r=o.select(this);try{r.call(c.fill,e[0].trace.fillcolor)}catch(e){f.error(e,t),r.remove()}})};var x=t(\"./symbol_defs\");b.symbolNames=[],b.symbolFuncs=[],b.symbolNeedLines={},b.symbolNoDot={},b.symbolList=[],Object.keys(x).forEach(function(t){var e=x[t];b.symbolList=b.symbolList.concat([e.n,t,e.n+100,t+\"-open\"]),b.symbolNames[e.n]=t,b.symbolFuncs[e.n]=e.f,e.needLine&&(b.symbolNeedLines[e.n]=!0),e.noDot?b.symbolNoDot[e.n]=!0:b.symbolList=b.symbolList.concat([e.n+200,t+\"-dot\",e.n+300,t+\"-open-dot\"])});var _=b.symbolNames.length,w=\"M0,0.5L0.5,0L0,-0.5L-0.5,0Z\";b.symbolNumber=function(t){if(\"string\"==typeof t){var e=0;t.indexOf(\"-open\")>0&&(e=100,t=t.replace(\"-open\",\"\")),t.indexOf(\"-dot\")>0&&(e+=200,t=t.replace(\"-dot\",\"\")),t=b.symbolNames.indexOf(t),t>=0&&(t+=e)}return t%100>=_||t>=400?0:Math.floor(Math.max(t,0))};var M={x1:1,x2:0,y1:0,y2:0},k={x1:0,x2:0,y1:1,y2:0};b.gradient=function(t,e,r,n,i,a){var s=e._fullLayout._defs.select(\".gradients\").selectAll(\"#\"+r).data([n+i+a],f.identity);s.exit().remove(),s.enter().append(\"radial\"===n?\"radialGradient\":\"linearGradient\").each(function(){var t=o.select(this);\"horizontal\"===n?t.attr(M):\"vertical\"===n&&t.attr(k),t.attr(\"id\",r);var e=l(i),s=l(a);t.append(\"stop\").attr({offset:\"0%\",\"stop-color\":c.tinyRGB(s),\"stop-opacity\":s.getAlpha()}),t.append(\"stop\").attr({offset:\"100%\",\"stop-color\":c.tinyRGB(e),\"stop-opacity\":e.getAlpha()})}),t.style({fill:\"url(#\"+r+\")\",\"fill-opacity\":null})},b.initGradients=function(t){var e=t._fullLayout._defs.selectAll(\".gradients\").data([0]);e.enter().append(\"g\").classed(\"gradients\",!0),e.selectAll(\"linearGradient,radialGradient\").remove()},b.singlePointStyle=function(t,e,r,i,a,o){var s=r.marker;n(t,e,r,i,a,s,s.line,o)},b.pointStyle=function(t,e,r){if(t.size()){var n=e.marker,i=b.tryColorscale(n,\"\"),a=b.tryColorscale(n,\"line\");t.each(function(t){b.singlePointStyle(t,o.select(this),e,i,a,r)})}},b.tryColorscale=function(t,e){var r=e?f.nestedProperty(t,e).get():t,n=r.colorscale,i=r.color;return n&&Array.isArray(i)?h.makeColorScaleFunc(h.extractScale(n,r.cmin,r.cmax)):f.identity};var A={start:1,end:-1,middle:0,bottom:1,top:-1};b.textPointStyle=function(t,e,r){t.each(function(t){var n=o.select(this),i=t.tx||e.text;if(!i||Array.isArray(i))return void n.remove();var a=t.tp||e.textposition,l=-1!==a.indexOf(\"top\")?\"top\":-1!==a.indexOf(\"bottom\")?\"bottom\":\"middle\",u=-1!==a.indexOf(\"left\")?\"end\":-1!==a.indexOf(\"right\")?\"start\":\"middle\",c=t.ts||e.textfont.size,h=t.mrc?t.mrc/.8+1:0;c=s(c)&&c>0?c:0,n.call(b.font,t.tf||e.textfont.family,c,t.tc||e.textfont.color).attr(\"text-anchor\",u).text(i).call(d.convertToTspans,r);var f=o.select(this.parentNode),p=(d.lineCount(n)-1)*v+1,m=A[u]*h,g=.75*c+A[l]*h+(A[l]-1)*p*c/2;f.attr(\"transform\",\"translate(\"+m+\",\"+g+\")\")})};var T=.5;b.smoothopen=function(t,e){if(t.length<3)return\"M\"+t.join(\"L\");var r,n=\"M\"+t[0],a=[];for(r=1;r<t.length-1;r++)a.push(i(t[r-1],t[r],t[r+1],e));for(n+=\"Q\"+a[0][0]+\" \"+t[1],r=2;r<t.length-1;r++)n+=\"C\"+a[r-2][1]+\" \"+a[r-1][0]+\" \"+t[r];return n+=\"Q\"+a[t.length-3][1]+\" \"+t[t.length-1]},b.smoothclosed=function(t,e){if(t.length<3)return\"M\"+t.join(\"L\")+\"Z\";var r,n=\"M\"+t[0],a=t.length-1,o=[i(t[a],t[0],t[1],e)];for(r=1;r<a;r++)o.push(i(t[r-1],t[r],t[r+1],e));for(o.push(i(t[a-1],t[a],t[0],e)),r=1;r<=a;r++)n+=\"C\"+o[r-1][1]+\" \"+o[r][0]+\" \"+t[r];return n+=\"C\"+o[a][1]+\" \"+o[0][0]+\" \"+t[0]+\"Z\"};var S={hv:function(t,e){return\"H\"+o.round(e[0],2)+\"V\"+o.round(e[1],2)},vh:function(t,e){return\"V\"+o.round(e[1],2)+\"H\"+o.round(e[0],2)},hvh:function(t,e){return\"H\"+o.round((t[0]+e[0])/2,2)+\"V\"+o.round(e[1],2)+\"H\"+o.round(e[0],2)},vhv:function(t,e){return\"V\"+o.round((t[1]+e[1])/2,2)+\"H\"+o.round(e[0],2)+\"V\"+o.round(e[1],2)}},E=function(t,e){return\"L\"+o.round(e[0],2)+\",\"+o.round(e[1],2)};b.steps=function(t){var e=S[t]||E;return function(t){for(var r=\"M\"+o.round(t[0][0],2)+\",\"+o.round(t[0][1],2),n=1;n<t.length;n++)r+=e(t[n-1],t[n]);return r}},b.makeTester=function(){var t=o.select(\"body\").selectAll(\"#js-plotly-tester\").data([0]);t.enter().append(\"svg\").attr(\"id\",\"js-plotly-tester\").attr(p.svgAttrs).style({position:\"absolute\",left:\"-10000px\",top:\"-10000px\",width:\"9000px\",height:\"9000px\",\"z-index\":\"1\"});var e=t.selectAll(\".js-reference-point\").data([0]);e.enter().append(\"path\").classed(\"js-reference-point\",!0).attr(\"d\",\"M0,0H1V1H0Z\").style({\"stroke-width\":0,fill:\"black\"}),b.tester=t,b.testref=e},b.savedBBoxes={};var L=0;b.bBox=function(t,e,r){r||(r=a(t));var n;if(r){if(n=b.savedBBoxes[r])return f.extendFlat({},n)}else if(1===t.childNodes.length){var i=t.childNodes[0];if(r=a(i)){var s=+i.getAttribute(\"x\")||0,l=+i.getAttribute(\"y\")||0,u=i.getAttribute(\"transform\");if(!u){var c=b.bBox(i,!1,r);return s&&(c.left+=s,c.right+=s),l&&(c.top+=l,c.bottom+=l),c}if(r+=\"~\"+s+\"~\"+l+\"~\"+u,n=b.savedBBoxes[r])return f.extendFlat({},n)}}var h,p;e?h=t:(p=b.tester.node(),h=t.cloneNode(!0),p.appendChild(h)),o.select(h).attr(\"transform\",null).call(d.positionText,0,0);var m=h.getBoundingClientRect(),v=b.testref.node().getBoundingClientRect();e||p.removeChild(h);var g={height:m.height,width:m.width,left:m.left-v.left,top:m.top-v.top,right:m.right-v.left,bottom:m.bottom-v.top};return L>=1e4&&(b.savedBBoxes={},L=0),r&&(b.savedBBoxes[r]=g),L++,f.extendFlat({},g)},b.setClipUrl=function(t,e){if(!e)return void t.attr(\"clip-path\",null);var r=\"#\"+e,n=o.select(\"base\");n.size()&&n.attr(\"href\")&&(r=window.location.href.split(\"#\")[0]+r),t.attr(\"clip-path\",\"url(\"+r+\")\")},b.getTranslate=function(t){var e=/.*\\btranslate\\((-?\\d*\\.?\\d*)[^-\\d]*(-?\\d*\\.?\\d*)[^\\d].*/,r=t.attr?\"attr\":\"getAttribute\",n=t[r](\"transform\")||\"\",i=n.replace(e,function(t,e,r){return[e,r].join(\" \")}).split(\" \");return{x:+i[0]||0,y:+i[1]||0}},b.setTranslate=function(t,e,r){var n=/(\\btranslate\\(.*?\\);?)/,i=t.attr?\"attr\":\"getAttribute\",a=t.attr?\"attr\":\"setAttribute\",o=t[i](\"transform\")||\"\";return e=e||0,r=r||0,o=o.replace(n,\"\").trim(),o+=\" translate(\"+e+\", \"+r+\")\",o=o.trim(),t[a](\"transform\",o),o},b.getScale=function(t){var e=/.*\\bscale\\((\\d*\\.?\\d*)[^\\d]*(\\d*\\.?\\d*)[^\\d].*/,r=t.attr?\"attr\":\"getAttribute\",n=t[r](\"transform\")||\"\",i=n.replace(e,function(t,e,r){return[e,r].join(\" \")}).split(\" \");return{x:+i[0]||1,y:+i[1]||1}},b.setScale=function(t,e,r){var n=/(\\bscale\\(.*?\\);?)/,i=t.attr?\"attr\":\"getAttribute\",a=t.attr?\"attr\":\"setAttribute\",o=t[i](\"transform\")||\"\";return e=e||1,r=r||1,o=o.replace(n,\"\").trim(),o+=\" scale(\"+e+\", \"+r+\")\",o=o.trim(),t[a](\"transform\",o),o},b.setPointGroupScale=function(t,e,r){var n,i,a;return e=e||1,r=r||1,i=1===e&&1===r?\"\":\" scale(\"+e+\",\"+r+\")\",a=/\\s*sc.*/,t.each(function(){n=(this.getAttribute(\"transform\")||\"\").replace(a,\"\"),n+=i,n=n.trim(),this.setAttribute(\"transform\",n)}),i};var C=/translate\\([^)]*\\)\\s*$/;b.setTextPointsScale=function(t,e,r){t.each(function(){var t,n=o.select(this),i=n.select(\"text\"),a=parseFloat(i.attr(\"x\")||0),s=parseFloat(i.attr(\"y\")||0),l=(n.attr(\"transform\")||\"\").match(C);t=1===e&&1===r?[]:[\"translate(\"+a+\",\"+s+\")\",\"scale(\"+e+\",\"+r+\")\",\"translate(\"+-a+\",\"+-s+\")\"],l&&t.push(l),n.attr(\"transform\",t.join(\" \"))})}},{\"../../constants/alignment\":699,\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../registry\":844,\"../../traces/scatter/make_bubble_size_func\":1042,\"../../traces/scatter/subtypes\":1047,\"../color\":603,\"../colorscale\":617,\"./symbol_defs\":628,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],628:[function(t,e,r){\"use strict\";var n=t(\"d3\");e.exports={circle:{n:0,f:function(t){var e=n.round(t,2);return\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"}},square:{n:1,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"}},diamond:{n:2,f:function(t){var e=n.round(1.3*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"Z\"}},cross:{n:3,f:function(t){var e=n.round(.4*t,2),r=n.round(1.2*t,2);return\"M\"+r+\",\"+e+\"H\"+e+\"V\"+r+\"H-\"+e+\"V\"+e+\"H-\"+r+\"V-\"+e+\"H-\"+e+\"V-\"+r+\"H\"+e+\"V-\"+e+\"H\"+r+\"Z\"}},x:{n:4,f:function(t){var e=n.round(.8*t/Math.sqrt(2),2),r=\"l\"+e+\",\"+e,i=\"l\"+e+\",-\"+e,a=\"l-\"+e+\",-\"+e,o=\"l-\"+e+\",\"+e;return\"M0,\"+e+r+i+a+i+a+o+a+o+r+o+r+\"Z\"}},\"triangle-up\":{n:5,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+e+\",\"+n.round(t/2,2)+\"H\"+e+\"L0,-\"+n.round(t,2)+\"Z\"}},\"triangle-down\":{n:6,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+e+\",-\"+n.round(t/2,2)+\"H\"+e+\"L0,\"+n.round(t,2)+\"Z\"}},\"triangle-left\":{n:7,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M\"+n.round(t/2,2)+\",-\"+e+\"V\"+e+\"L-\"+n.round(t,2)+\",0Z\"}},\"triangle-right\":{n:8,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+n.round(t/2,2)+\",-\"+e+\"V\"+e+\"L\"+n.round(t,2)+\",0Z\"}},\"triangle-ne\":{n:9,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M-\"+r+\",-\"+e+\"H\"+e+\"V\"+r+\"Z\"}},\"triangle-se\":{n:10,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M\"+e+\",-\"+r+\"V\"+e+\"H-\"+r+\"Z\"}},\"triangle-sw\":{n:11,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M\"+r+\",\"+e+\"H-\"+e+\"V-\"+r+\"Z\"}},\"triangle-nw\":{n:12,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M-\"+e+\",\"+r+\"V-\"+e+\"H\"+r+\"Z\"}},pentagon:{n:13,f:function(t){var e=n.round(.951*t,2),r=n.round(.588*t,2),i=n.round(-t,2),a=n.round(-.309*t,2);return\"M\"+e+\",\"+a+\"L\"+r+\",\"+n.round(.809*t,2)+\"H-\"+r+\"L-\"+e+\",\"+a+\"L0,\"+i+\"Z\"}},hexagon:{n:14,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return\"M\"+i+\",-\"+r+\"V\"+r+\"L0,\"+e+\"L-\"+i+\",\"+r+\"V-\"+r+\"L0,-\"+e+\"Z\"}},hexagon2:{n:15,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return\"M-\"+r+\",\"+i+\"H\"+r+\"L\"+e+\",0L\"+r+\",-\"+i+\"H-\"+r+\"L-\"+e+\",0Z\"}},octagon:{n:16,f:function(t){var e=n.round(.924*t,2),r=n.round(.383*t,2);return\"M-\"+r+\",-\"+e+\"H\"+r+\"L\"+e+\",-\"+r+\"V\"+r+\"L\"+r+\",\"+e+\"H-\"+r+\"L-\"+e+\",\"+r+\"V-\"+r+\"Z\"}},star:{n:17,f:function(t){var e=1.4*t,r=n.round(.225*e,2),i=n.round(.951*e,2),a=n.round(.363*e,2),o=n.round(.588*e,2),s=n.round(-e,2),l=n.round(-.309*e,2),u=n.round(.118*e,2),c=n.round(.809*e,2);return\"M\"+r+\",\"+l+\"H\"+i+\"L\"+a+\",\"+u+\"L\"+o+\",\"+c+\"L0,\"+n.round(.382*e,2)+\"L-\"+o+\",\"+c+\"L-\"+a+\",\"+u+\"L-\"+i+\",\"+l+\"H-\"+r+\"L0,\"+s+\"Z\"}},hexagram:{n:18,f:function(t){var e=n.round(.66*t,2),r=n.round(.38*t,2),i=n.round(.76*t,2);return\"M-\"+i+\",0l-\"+r+\",-\"+e+\"h\"+i+\"l\"+r+\",-\"+e+\"l\"+r+\",\"+e+\"h\"+i+\"l-\"+r+\",\"+e+\"l\"+r+\",\"+e+\"h-\"+i+\"l-\"+r+\",\"+e+\"l-\"+r+\",-\"+e+\"h-\"+i+\"Z\"}},\"star-triangle-up\":{n:19,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o=\"A \"+a+\",\"+a+\" 0 0 1 \";return\"M-\"+e+\",\"+r+o+e+\",\"+r+o+\"0,-\"+i+o+\"-\"+e+\",\"+r+\"Z\"}},\"star-triangle-down\":{n:20,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o=\"A \"+a+\",\"+a+\" 0 0 1 \";return\"M\"+e+\",-\"+r+o+\"-\"+e+\",-\"+r+o+\"0,\"+i+o+e+\",-\"+r+\"Z\"}},\"star-square\":{n:21,f:function(t){var e=n.round(1.1*t,2),r=n.round(2*t,2),i=\"A \"+r+\",\"+r+\" 0 0 1 \";return\"M-\"+e+\",-\"+e+i+\"-\"+e+\",\"+e+i+e+\",\"+e+i+e+\",-\"+e+i+\"-\"+e+\",-\"+e+\"Z\"}},\"star-diamond\":{n:22,f:function(t){var e=n.round(1.4*t,2),r=n.round(1.9*t,2),i=\"A \"+r+\",\"+r+\" 0 0 1 \";return\"M-\"+e+\",0\"+i+\"0,\"+e+i+e+\",0\"+i+\"0,-\"+e+i+\"-\"+e+\",0Z\"}},\"diamond-tall\":{n:23,f:function(t){var e=n.round(.7*t,2),r=n.round(1.4*t,2);return\"M0,\"+r+\"L\"+e+\",0L0,-\"+r+\"L-\"+e+\",0Z\"}},\"diamond-wide\":{n:24,f:function(t){var e=n.round(1.4*t,2),r=n.round(.7*t,2);return\"M0,\"+r+\"L\"+e+\",0L0,-\"+r+\"L-\"+e+\",0Z\"}},hourglass:{n:25,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"H-\"+e+\"L\"+e+\",-\"+e+\"H-\"+e+\"Z\"},noDot:!0},bowtie:{n:26,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"V-\"+e+\"L-\"+e+\",\"+e+\"V-\"+e+\"Z\"},noDot:!0},\"circle-cross\":{n:27,f:function(t){var e=n.round(t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"},needLine:!0,noDot:!0},\"circle-x\":{n:28,f:function(t){var e=n.round(t,2),r=n.round(t/Math.sqrt(2),2);return\"M\"+r+\",\"+r+\"L-\"+r+\",-\"+r+\"M\"+r+\",-\"+r+\"L-\"+r+\",\"+r+\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"},needLine:!0,noDot:!0},\"square-cross\":{n:29,f:function(t){var e=n.round(t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"},needLine:!0,noDot:!0},\"square-x\":{n:30,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e+\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e+\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"},needLine:!0,noDot:!0},\"diamond-cross\":{n:31,f:function(t){var e=n.round(1.3*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"ZM0,-\"+e+\"V\"+e+\"M-\"+e+\",0H\"+e},needLine:!0,noDot:!0},\"diamond-x\":{n:32,f:function(t){var e=n.round(1.3*t,2),r=n.round(.65*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"ZM-\"+r+\",-\"+r+\"L\"+r+\",\"+r+\"M-\"+r+\",\"+r+\"L\"+r+\",-\"+r},needLine:!0,noDot:!0},\"cross-thin\":{n:33,f:function(t){var e=n.round(1.4*t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e},needLine:!0,noDot:!0},\"x-thin\":{n:34,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e+\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e},needLine:!0,noDot:!0},asterisk:{n:35,f:function(t){var e=n.round(1.2*t,2),r=n.round(.85*t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+r+\",\"+r+\"L-\"+r+\",-\"+r+\"M\"+r+\",-\"+r+\"L-\"+r+\",\"+r},needLine:!0,noDot:!0},hash:{n:36,f:function(t){var e=n.round(t/2,2),r=n.round(t,2);return\"M\"+e+\",\"+r+\"V-\"+r+\"m-\"+r+\",0V\"+r+\"M\"+r+\",\"+e+\"H-\"+r+\"m0,-\"+r+\"H\"+r},needLine:!0},\"y-up\":{n:37,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+e+\",\"+i+\"L0,0M\"+e+\",\"+i+\"L0,0M0,-\"+r+\"L0,0\"},needLine:!0,noDot:!0},\"y-down\":{n:38,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+e+\",-\"+i+\"L0,0M\"+e+\",-\"+i+\"L0,0M0,\"+r+\"L0,0\"},needLine:!0,noDot:!0},\"y-left\":{n:39,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M\"+i+\",\"+e+\"L0,0M\"+i+\",-\"+e+\"L0,0M-\"+r+\",0L0,0\"},needLine:!0,noDot:!0},\"y-right\":{n:40,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+i+\",\"+e+\"L0,0M-\"+i+\",-\"+e+\"L0,0M\"+r+\",0L0,0\"},needLine:!0,noDot:!0},\"line-ew\":{n:41,f:function(t){var e=n.round(1.4*t,2);return\"M\"+e+\",0H-\"+e},needLine:!0,noDot:!0},\"line-ns\":{n:42,f:function(t){var e=n.round(1.4*t,2);return\"M0,\"+e+\"V-\"+e},needLine:!0,noDot:!0},\"line-ne\":{n:43,f:function(t){var e=n.round(t,2);return\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e},needLine:!0,noDot:!0},\"line-nw\":{n:44,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e},needLine:!0,noDot:!0}}},{d3:121}],629:[function(t,e,r){\"use strict\";e.exports={visible:{valType:\"boolean\"},type:{valType:\"enumerated\",values:[\"percent\",\"constant\",\"sqrt\",\"data\"]},symmetric:{valType:\"boolean\"},array:{valType:\"data_array\"},arrayminus:{valType:\"data_array\"},value:{valType:\"number\",min:0,dflt:10},valueminus:{valType:\"number\",min:0,dflt:10},traceref:{valType:\"integer\",min:0,dflt:0},tracerefminus:{valType:\"integer\",min:0,dflt:0},copy_ystyle:{valType:\"boolean\"},copy_zstyle:{valType:\"boolean\"},color:{valType:\"color\"},thickness:{valType:\"number\",min:0,dflt:2},width:{valType:\"number\",min:0},_deprecated:{opacity:{valType:\"number\"}}}},{}],630:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=e[\"error_\"+n]||{},l=a.visible&&-1!==[\"linear\",\"log\"].indexOf(r.type),u=[];if(l){for(var c=s(a),h=0;h<t.length;h++){var f=t[h],d=f[n];if(i(r.c2l(d))){var p=c(d,h);if(i(p[0])&&i(p[1])){var m=f[n+\"s\"]=d-p[0],v=f[n+\"h\"]=d+p[1];u.push(m,v)}}}o.expand(r,u,{padded:!0})}}var i=t(\"fast-isnumeric\"),a=t(\"../../registry\"),o=t(\"../../plots/cartesian/axes\"),s=t(\"./compute_error\");e.exports=function(t){for(var e=t.calcdata,r=0;r<e.length;r++){var i=e[r],s=i[0].trace;if(a.traceIs(s,\"errorBarsOK\")){var l=o.getFromId(t,s.xaxis),u=o.getFromId(t,s.yaxis);n(i,s,l,\"x\"),n(i,s,u,\"y\")}}}},{\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./compute_error\":631,\"fast-isnumeric\":130}],631:[function(t,e,r){\"use strict\";function n(t,e){return\"percent\"===t?function(t){return Math.abs(t*e/100)}:\"constant\"===t?function(){return Math.abs(e)}:\"sqrt\"===t?function(t){return Math.sqrt(Math.abs(t))}:void 0}e.exports=function(t){var e=t.type,r=t.symmetric;if(\"data\"===e){var i=t.array,a=t.arrayminus;return r||void 0===a?function(t,e){var r=+i[e];return[r,r]}:function(t,e){return[+a[e],+i[e]]}}var o=n(e,t.value),s=n(e,t.valueminus);return r||void 0===t.valueminus?function(t){var e=o(t);return[e,e]}:function(t){return[s(t),o(t)]}}},{}],632:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(t,e){return a.coerce(h,c,o,t,e)}var u=\"error_\"+s.axis,c=e[u]={},h=t[u]||{};if(!1!==l(\"visible\",void 0!==h.array||void 0!==h.value||\"sqrt\"===h.type)){var f=l(\"type\",\"array\"in h?\"data\":\"percent\"),d=!0;\"sqrt\"!==f&&(d=l(\"symmetric\",!((\"data\"===f?\"arrayminus\":\"valueminus\")in h))),\"data\"===f?(l(\"array\")||(c.array=[]),l(\"traceref\"),d||(l(\"arrayminus\")||(c.arrayminus=[]),l(\"tracerefminus\"))):\"percent\"!==f&&\"constant\"!==f||(l(\"value\"),d||l(\"valueminus\"));var p=\"copy_\"+s.inherit+\"style\";s.inherit&&(e[\"error_\"+s.inherit]||{}).visible&&l(p,!(h.color||n(h.thickness)||n(h.width))),s.inherit&&c[p]||(l(\"color\",r),l(\"thickness\"),l(\"width\",i.traceIs(e,\"gl3d\")?0:4))}}},{\"../../lib\":725,\"../../registry\":844,\"./attributes\":629,\"fast-isnumeric\":130}],633:[function(t,e,r){\"use strict\";var n=e.exports={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.calcFromTrace=function(t,e){for(var r=t.x||[],i=t.y||[],a=r.length||i.length,o=new Array(a),s=0;s<a;s++)o[s]={x:r[s],y:i[s]};return o[0].trace=t,n.calc({calcdata:[o],_fullLayout:e}),o},n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverInfo=function(t,e,r){(e.error_y||{}).visible&&(r.yerr=t.yh-t.y,e.error_y.symmetric||(r.yerrneg=t.y-t.ys)),(e.error_x||{}).visible&&(r.xerr=t.xh-t.x,e.error_x.symmetric||(r.xerrneg=t.x-t.xs))}},{\"./attributes\":629,\"./calc\":630,\"./defaults\":632,\"./plot\":634,\"./style\":635}],634:[function(t,e,r){\"use strict\";function n(t,e,r){var n={x:e.c2p(t.x),y:r.c2p(t.y)};return void 0!==t.yh&&(n.yh=r.c2p(t.yh),n.ys=r.c2p(t.ys),a(n.ys)||(n.noYS=!0,n.ys=r.c2p(t.ys,!0))),void 0!==t.xh&&(n.xh=e.c2p(t.xh),n.xs=e.c2p(t.xs),a(n.xs)||(n.noXS=!0,n.xs=e.c2p(t.xs,!0))),n}var i=t(\"d3\"),a=t(\"fast-isnumeric\"),o=t(\"../drawing\"),s=t(\"../../traces/scatter/subtypes\");e.exports=function(t,e,r){var l,u=e.xaxis,c=e.yaxis,h=r&&r.duration>0;t.each(function(t){var f,d=t[0].trace,p=d.error_x||{},m=d.error_y||{};d.ids&&(f=function(t){return t.id});var v=s.hasMarkers(d)&&d.marker.maxdisplayed>0;if(m.visible||p.visible){var g=i.select(this).selectAll(\"g.errorbar\").data(t,f);g.exit().remove(),g.style(\"opacity\",1);var y=g.enter().append(\"g\").classed(\"errorbar\",!0);h&&y.style(\"opacity\",0).transition().duration(r.duration).style(\"opacity\",1),o.setClipUrl(g,e.layerClipId),g.each(function(t){var e=i.select(this),o=n(t,u,c);if(!v||t.vis){var s;if(m.visible&&a(o.x)&&a(o.yh)&&a(o.ys)){var f=m.width;s=\"M\"+(o.x-f)+\",\"+o.yh+\"h\"+2*f+\"m-\"+f+\",0V\"+o.ys,o.noYS||(s+=\"m-\"+f+\",0h\"+2*f);var d=e.select(\"path.yerror\");l=!d.size(),l?d=e.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").classed(\"yerror\",!0):h&&(d=d.transition().duration(r.duration).ease(r.easing)),d.attr(\"d\",s)}if(p.visible&&a(o.y)&&a(o.xh)&&a(o.xs)){var g=(p.copy_ystyle?m:p).width;s=\"M\"+o.xh+\",\"+(o.y-g)+\"v\"+2*g+\"m0,-\"+g+\"H\"+o.xs,o.noXS||(s+=\"m0,-\"+g+\"v\"+2*g);var y=e.select(\"path.xerror\");l=!y.size(),l?y=e.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").classed(\"xerror\",!0):h&&(y=y.transition().duration(r.duration).ease(r.easing)),y.attr(\"d\",s)}}})}})}},{\"../../traces/scatter/subtypes\":1047,\"../drawing\":627,d3:121,\"fast-isnumeric\":130}],635:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../color\");e.exports=function(t){t.each(function(t){var e=t[0].trace,r=e.error_y||{},a=e.error_x||{},o=n.select(this);o.selectAll(\"path.yerror\").style(\"stroke-width\",r.thickness+\"px\").call(i.stroke,r.color),a.copy_ystyle&&(a=r),o.selectAll(\"path.xerror\").style(\"stroke-width\",a.thickness+\"px\").call(i.stroke,a.color)})}},{\"../color\":603,d3:121}],636:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\");e.exports={hoverlabel:{bgcolor:{valType:\"color\",arrayOk:!0},bordercolor:{valType:\"color\",arrayOk:!0},font:{family:n({},i.family,{arrayOk:!0}),size:n({},i.size,{arrayOk:!0}),color:n({},i.color,{arrayOk:!0})},namelength:{valType:\"integer\",min:-1,arrayOk:!0}}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790}],637:[function(t,e,r){\"use strict\";function n(t,e,r,n){n=n||i.identity,Array.isArray(t)&&(e[0][r]=n(t))}var i=t(\"../../lib\"),a=t(\"../../registry\");e.exports=function(t){for(var e=t.calcdata,r=t._fullLayout,o=0;o<e.length;o++){var s=e[o],l=s[0].trace;if(!a.traceIs(l,\"pie\")){var u=a.traceIs(l,\"2dMap\")?n:i.fillArray;u(l.hoverinfo,s,\"hi\",function(t){return function(e){return i.coerceHoverinfo({hoverinfo:e},{_module:t._module},r)}}(l)),l.hoverlabel&&(u(l.hoverlabel.bgcolor,s,\"hbg\"),u(l.hoverlabel.bordercolor,s,\"hbc\"),u(l.hoverlabel.font.size,s,\"hts\"),u(l.hoverlabel.font.color,s,\"htc\"),u(l.hoverlabel.font.family,s,\"htf\"),u(l.hoverlabel.namelength,s,\"hnl\"))}}}},{\"../../lib\":725,\"../../registry\":844}],638:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"./hover\").hover;e.exports=function(t,e,r){function a(){t.emit(\"plotly_click\",{points:t._hoverdata,event:e})}var o=n.getComponentMethod(\"annotations\",\"onClick\")(t,t._hoverdata);void 0!==r&&i(t,e,r,!0),t._hoverdata&&e&&e.target&&(o&&o.then?o.then(a):a(),e.stopImmediatePropagation&&e.stopImmediatePropagation())}},{\"../../registry\":844,\"./hover\":642}],639:[function(t,e,r){\"use strict\";e.exports={MAXDIST:20,YANGLE:60,HOVERARROWSIZE:6,HOVERTEXTPAD:3,HOVERFONTSIZE:13,HOVERFONT:\"Arial, sans-serif\",HOVERMINTIME:50}},{}],640:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"./hoverlabel_defaults\");e.exports=function(t,e,r,o){function s(r,a){return n.coerce(t,e,i,r,a)}a(t,e,s,o.hoverlabel)}},{\"../../lib\":725,\"./attributes\":636,\"./hoverlabel_defaults\":643}],641:[function(t,e,r){\"use strict\";function n(t,e){return function(r){var n=t(r),i=e(r);return Math.sqrt(n*n+i*i)}}var i=t(\"../../lib\"),a=t(\"./constants\");r.getSubplot=function(t){return t.subplot||t.xaxis+t.yaxis||t.geo},r.flat=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=e;return r},r.p2c=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=t[n].p2c(e);return r},r.getDistanceFunction=function(t,e,r,i){return\"closest\"===t?i||n(e,r):\"x\"===t?e:r},r.getClosest=function(t,e,r){if(!1!==r.index)r.index>=0&&r.index<t.length?r.distance=0:r.index=!1;else for(var n=0;n<t.length;n++){var i=e(t[n]);i<=r.distance&&(r.index=n,r.distance=i)}return r},r.inbox=function(t,e){return t*e<0||0===t?a.MAXDIST*(.6-.3/Math.max(3,Math.abs(t-e))):1/0},r.appendArrayPointValue=function(t,e,r){var n=e._arrayAttrs;if(n)for(var a=0;a<n.length;a++){var o,s=n[a];if(o=\"ids\"===s?\"id\":\"locations\"===s?\"location\":s,void 0===t[o]){var l=i.nestedProperty(e,s).get();Array.isArray(r)?Array.isArray(l)&&Array.isArray(l[r[0]])&&(t[o]=l[r[0]][r[1]]):t[o]=l[r]}}}},{\"../../lib\":725,\"./constants\":639}],642:[function(t,e,r){\"use strict\";function n(t,e,r,n){if((\"pie\"===r||\"sankey\"===r)&&!n)return void t.emit(\"plotly_hover\",{event:e.originalEvent,points:[e]});r||(r=\"xy\");var f=Array.isArray(r)?r:[r],m=t._fullLayout,g=m._plots||[],k=g[r];if(k){var A=k.overlays.map(function(t){return t.id});f=f.concat(A)}for(var T=f.length,S=new Array(T),E=new Array(T),L=0;L<T;L++){var C=f[L],z=g[C];if(z)S[L]=x.getFromId(t,z.xaxis._id),E[L]=x.getFromId(t,z.yaxis._id);else{var I=m[C]._subplot;S[L]=I.xaxis,E[L]=I.yaxis}}var D=e.hovermode||m.hovermode;if(-1===[\"x\",\"y\",\"closest\"].indexOf(D)||!t.calcdata||t.querySelector(\".zoombox\")||t._dragging)return b.unhoverRaw(t,e);var P,O,R,F,j,N,B,U,V,H,q,G,Y,X=[],W=[];if(Array.isArray(e))for(D=\"array\",R=0;R<e.length;R++)j=t.calcdata[e[R].curveNumber||0],\"skip\"!==j[0].trace.hoverinfo&&W.push(j);else{for(F=0;F<t.calcdata.length;F++)j=t.calcdata[F],N=j[0].trace,\"skip\"!==N.hoverinfo&&-1!==f.indexOf(w.getSubplot(N))&&W.push(j);var Z,J,K=!e.target;if(K)Z=\"xpx\"in e?e.xpx:S[0]._length/2,J=\"ypx\"in e?e.ypx:E[0]._length/2;else{if(!1===p.triggerHandler(t,\"plotly_beforehover\",e))return;var Q=e.target.getBoundingClientRect();if(Z=e.clientX-Q.left,J=e.clientY-Q.top,Z<0||Z>Q.width||J<0||J>Q.height)return b.unhoverRaw(t,e)}if(P=\"xval\"in e?w.flat(f,e.xval):w.p2c(S,Z),O=\"yval\"in e?w.flat(f,e.yval):w.p2c(E,J),!h(P[0])||!h(O[0]))return d.warn(\"Fx.hover failed\",e,t),b.unhoverRaw(t,e)}var $=1/0\n",
       ";for(F=0;F<W.length;F++)if((j=W[F])&&j[0]&&j[0].trace&&!0===j[0].trace.visible&&(N=j[0].trace,-1===[\"carpet\",\"contourcarpet\"].indexOf(N._module.name))){if(B=w.getSubplot(N),U=f.indexOf(B),V=D,G={cd:j,trace:N,xa:S[U],ya:E[U],index:!1,distance:Math.min($,M.MAXDIST),color:y.defaultLine,name:N.name,x0:void 0,x1:void 0,y0:void 0,y1:void 0,xLabelVal:void 0,yLabelVal:void 0,zLabelVal:void 0,text:void 0},m[B]&&(G.subplot=m[B]._subplot),Y=X.length,\"array\"===V){var tt=e[F];\"pointNumber\"in tt?(G.index=tt.pointNumber,V=\"closest\"):(V=\"\",\"xval\"in tt&&(H=tt.xval,V=\"x\"),\"yval\"in tt&&(q=tt.yval,V=V?\"closest\":\"y\"))}else H=P[U],q=O[U];if(N._module&&N._module.hoverPoints){var et=N._module.hoverPoints(G,H,q,V);if(et)for(var rt,nt=0;nt<et.length;nt++)rt=et[nt],h(rt.x0)&&h(rt.y0)&&X.push(s(rt,D))}else d.log(\"Unrecognized trace type in hover:\",N);\"closest\"===D&&X.length>Y&&(X.splice(0,Y),$=X[0].distance)}if(0===X.length)return b.unhoverRaw(t,e);X.sort(function(t,e){return t.distance-e.distance});var it=t._hoverdata,at=[];for(R=0;R<X.length;R++){var ot=X[R],st={data:ot.trace._input,fullData:ot.trace,curveNumber:ot.trace.index,pointNumber:ot.index};ot.trace._module.eventData?st=ot.trace._module.eventData(st,ot):(st.x=ot.xVal,st.y=ot.yVal,st.xaxis=ot.xa,st.yaxis=ot.ya,void 0!==ot.zLabelVal&&(st.z=ot.zLabelVal)),w.appendArrayPointValue(st,ot.trace,ot.index),at.push(st)}if(t._hoverdata=at,u(t,e,it)&&m._hasCartesian){l(X,{hovermode:D,fullLayout:m,container:m._hoverlayer,outerContainer:m._paperdiv})}var lt=\"y\"===D&&W.length>1,ut=y.combine(m.plot_bgcolor||y.background,m.paper_bgcolor),ct={hovermode:D,rotateLabels:lt,bgColor:ut,container:m._hoverlayer,outerContainer:m._paperdiv,commonLabelOpts:m.hoverlabel},ht=i(X,ct,t);if(a(X,lt?\"xa\":\"ya\"),o(ht,lt),e.target&&e.target.tagName){var ft=_.getComponentMethod(\"annotations\",\"hasClickToShow\")(t,at);v(c.select(e.target),ft?\"pointer\":\"\")}e.target&&!n&&u(t,e,it)&&(it&&t.emit(\"plotly_unhover\",{event:e,points:it}),t.emit(\"plotly_hover\",{event:e,points:t._hoverdata,xaxes:S,yaxes:E,xvals:P,yvals:O}))}function i(t,e,r){var n,i,a=e.hovermode,o=e.rotateLabels,s=e.bgColor,l=e.container,u=e.outerContainer,h=e.commonLabelOpts||{},f=e.fontFamily||M.HOVERFONT,d=e.fontSize||M.HOVERFONTSIZE,p=t[0],v=p.xa,b=p.ya,x=\"y\"===a?\"yLabel\":\"xLabel\",_=p[x],w=(String(_)||\"\").split(\" \")[0],A=u.node().getBoundingClientRect(),T=A.top,S=A.width,E=A.height,z=p.distance<=M.MAXDIST&&(\"x\"===a||\"y\"===a);for(n=0;n<t.length;n++){i=t[n].hoverinfo||t[n].trace.hoverinfo;var I=i.split(\"+\");if(-1===I.indexOf(\"all\")&&-1===I.indexOf(a)){z=!1;break}}var D=l.selectAll(\"g.axistext\").data(z?[0]:[]);D.enter().append(\"g\").classed(\"axistext\",!0),D.exit().remove(),D.each(function(){var e=c.select(this),n=e.selectAll(\"path\").data([0]),i=e.selectAll(\"text\").data([0]);n.enter().append(\"path\").style({fill:h.bgcolor||y.defaultLine,stroke:h.bordercolor||y.background,\"stroke-width\":\"1px\"}),i.enter().append(\"text\").call(g.font,h.font.family||f,h.font.size||d,h.font.color||y.background).attr(\"data-notex\",1),i.text(_).call(m.positionText,0,0).call(m.convertToTspans,r),e.attr(\"transform\",\"\");var o=i.node().getBoundingClientRect();if(\"x\"===a){i.attr(\"text-anchor\",\"middle\").call(m.positionText,0,\"top\"===v.side?T-o.bottom-L-C:T-o.top+L+C);var s=\"top\"===v.side?\"-\":\"\";n.attr(\"d\",\"M0,0L\"+L+\",\"+s+L+\"H\"+(C+o.width/2)+\"v\"+s+(2*C+o.height)+\"H-\"+(C+o.width/2)+\"V\"+s+L+\"H-\"+L+\"Z\"),e.attr(\"transform\",\"translate(\"+(v._offset+(p.x0+p.x1)/2)+\",\"+(b._offset+(\"top\"===v.side?0:b._length))+\")\")}else{i.attr(\"text-anchor\",\"right\"===b.side?\"start\":\"end\").call(m.positionText,(\"right\"===b.side?1:-1)*(C+L),T-o.top-o.height/2);var l=\"right\"===b.side?\"\":\"-\";n.attr(\"d\",\"M0,0L\"+l+L+\",\"+L+\"V\"+(C+o.height/2)+\"h\"+l+(2*C+o.width)+\"V-\"+(C+o.height/2)+\"H\"+l+L+\"V-\"+L+\"Z\"),e.attr(\"transform\",\"translate(\"+(v._offset+(\"right\"===b.side?v._length:0))+\",\"+(b._offset+(p.y0+p.y1)/2)+\")\")}t=t.filter(function(t){return void 0!==t.zLabelVal||(t[x]||\"\").split(\" \")[0]===w})});var P=l.selectAll(\"g.hovertext\").data(t,function(t){return[t.trace.index,t.index,t.x0,t.y0,t.name,t.attr,t.xa,t.ya||\"\"].join(\",\")});return P.enter().append(\"g\").classed(\"hovertext\",!0).each(function(){var t=c.select(this);t.append(\"rect\").call(y.fill,y.addOpacity(s,.8)),t.append(\"text\").classed(\"name\",!0),t.append(\"path\").style(\"stroke-width\",\"1px\"),t.append(\"text\").classed(\"nums\",!0).call(g.font,f,d)}),P.exit().remove(),P.each(function(t){var e=c.select(this).attr(\"transform\",\"\"),n=\"\",i=\"\",l=y.opacity(t.color)?t.color:y.defaultLine,u=y.combine(l,s),h=t.borderColor||y.contrast(u);if(void 0!==t.nameOverride&&(t.name=t.nameOverride),t.name){n=m.plainText(t.name||\"\");var p=Math.round(t.nameLength);p>-1&&n.length>p&&(n=p>3?n.substr(0,p-3)+\"...\":n.substr(0,p))}void 0!==t.extraText&&(i+=t.extraText),void 0!==t.zLabel?(void 0!==t.xLabel&&(i+=\"x: \"+t.xLabel+\"<br>\"),void 0!==t.yLabel&&(i+=\"y: \"+t.yLabel+\"<br>\"),i+=(i?\"z: \":\"\")+t.zLabel):z&&t[a+\"Label\"]===_?i=t[(\"x\"===a?\"y\":\"x\")+\"Label\"]||\"\":void 0===t.xLabel?void 0!==t.yLabel&&(i=t.yLabel):i=void 0===t.yLabel?t.xLabel:\"(\"+t.xLabel+\", \"+t.yLabel+\")\",t.text&&!Array.isArray(t.text)&&(i+=(i?\"<br>\":\"\")+t.text),\"\"===i&&(\"\"===n&&e.remove(),i=n);var v=e.select(\"text.nums\").call(g.font,t.fontFamily||f,t.fontSize||d,t.fontColor||h).text(i).attr(\"data-notex\",1).call(m.positionText,0,0).call(m.convertToTspans,r),b=e.select(\"text.name\"),x=0;n&&n!==i?(b.call(g.font,t.fontFamily||f,t.fontSize||d,u).text(n).attr(\"data-notex\",1).call(m.positionText,0,0).call(m.convertToTspans,r),x=b.node().getBoundingClientRect().width+2*C):(b.remove(),e.select(\"rect\").remove()),e.select(\"path\").style({fill:u,stroke:h});var w,M,A=v.node().getBoundingClientRect(),I=t.xa._offset+(t.x0+t.x1)/2,D=t.ya._offset+(t.y0+t.y1)/2,P=Math.abs(t.x1-t.x0),O=Math.abs(t.y1-t.y0),R=A.width+L+C+x;t.ty0=T-A.top,t.bx=A.width+2*C,t.by=A.height+2*C,t.anchor=\"start\",t.txwidth=A.width,t.tx2width=x,t.offset=0,o?(t.pos=I,w=D+O/2+R<=E,M=D-O/2-R>=0,\"top\"!==t.idealAlign&&w||!M?w?(D+=O/2,t.anchor=\"start\"):t.anchor=\"middle\":(D-=O/2,t.anchor=\"end\")):(t.pos=D,w=I+P/2+R<=S,M=I-P/2-R>=0,\"left\"!==t.idealAlign&&w||!M?w?(I+=P/2,t.anchor=\"start\"):t.anchor=\"middle\":(I-=P/2,t.anchor=\"end\")),v.attr(\"text-anchor\",t.anchor),x&&b.attr(\"text-anchor\",t.anchor),e.attr(\"transform\",\"translate(\"+I+\",\"+D+\")\"+(o?\"rotate(\"+k+\")\":\"\"))}),P}function a(t,e){function r(t){var e=t[0],r=t[t.length-1];if(i=e.pmin-e.pos-e.dp+e.size,a=r.pos+r.dp+r.size-e.pmax,i>.01){for(s=t.length-1;s>=0;s--)t[s].dp+=i;n=!1}if(!(a<.01)){if(i<-.01){for(s=t.length-1;s>=0;s--)t[s].dp-=a;n=!1}if(n){var u=0;for(o=0;o<t.length;o++)l=t[o],l.pos+l.dp+l.size>e.pmax&&u++;for(o=t.length-1;o>=0&&!(u<=0);o--)l=t[o],l.pos>e.pmax-1&&(l.del=!0,u--);for(o=0;o<t.length&&!(u<=0);o++)if(l=t[o],l.pos<e.pmin+1)for(l.del=!0,u--,a=2*l.size,s=t.length-1;s>=0;s--)t[s].dp-=a;for(o=t.length-1;o>=0&&!(u<=0);o--)l=t[o],l.pos+l.dp+l.size>e.pmax&&(l.del=!0,u--)}}}for(var n,i,a,o,s,l,u,c=0,h=t.map(function(t,r){var n=t[e];return[{i:r,dp:0,pos:t.pos,posref:t.posref,size:t.by*(\"x\"===n._id.charAt(0)?T:1)/2,pmin:n._offset,pmax:n._offset+n._length}]}).sort(function(t,e){return t[0].posref-e[0].posref});!n&&c<=t.length;){for(c++,n=!0,o=0;o<h.length-1;){var f=h[o],d=h[o+1],p=f[f.length-1],m=d[0];if((i=p.pos+p.dp+p.size-m.pos-m.dp+m.size)>.01&&p.pmin===m.pmin&&p.pmax===m.pmax){for(s=d.length-1;s>=0;s--)d[s].dp+=i;for(f.push.apply(f,d),h.splice(o+1,1),u=0,s=f.length-1;s>=0;s--)u+=f[s].dp;for(a=u/f.length,s=f.length-1;s>=0;s--)f[s].dp-=a;n=!1}else o++}h.forEach(r)}for(o=h.length-1;o>=0;o--){var v=h[o];for(s=v.length-1;s>=0;s--){var g=v[s],y=t[g.i];y.offset=g.dp,y.del=g.del}}}function o(t,e){t.each(function(t){var r=c.select(this);if(t.del)return void r.remove();var n=\"end\"===t.anchor?-1:1,i=r.select(\"text.nums\"),a={start:1,end:-1,middle:0}[t.anchor],o=a*(L+C),s=o+a*(t.txwidth+C),l=0,u=t.offset;\"middle\"===t.anchor&&(o-=t.tx2width/2,s-=t.tx2width/2),e&&(u*=-E,l=t.offset*S),r.select(\"path\").attr(\"d\",\"middle\"===t.anchor?\"M-\"+t.bx/2+\",-\"+t.by/2+\"h\"+t.bx+\"v\"+t.by+\"h-\"+t.bx+\"Z\":\"M0,0L\"+(n*L+l)+\",\"+(L+u)+\"v\"+(t.by/2-L)+\"h\"+n*t.bx+\"v-\"+t.by+\"H\"+(n*L+l)+\"V\"+(u-L)+\"Z\"),i.call(m.positionText,o+l,u+t.ty0-t.by/2+C),t.tx2width&&(r.select(\"text.name\").call(m.positionText,s+a*C+l,u+t.ty0-t.by/2+C),r.select(\"rect\").call(g.setRect,s+(a-1)*t.tx2width/2+l,u-t.by/2-1,t.tx2width,t.by+2))})}function s(t,e){function r(e,r,o){var s;if(a[r])s=a[r];else if(i[r]){var l=i[r];Array.isArray(l)&&Array.isArray(l[t.index[0]])&&(s=l[t.index[0]][t.index[1]])}else s=d.nestedProperty(n,o).get();s&&(t[e]=s)}var n=t.trace||{},i=t.cd[0],a=t.cd[t.index]||{};r(\"hoverinfo\",\"hi\",\"hoverinfo\"),r(\"color\",\"hbg\",\"hoverlabel.bgcolor\"),r(\"borderColor\",\"hbc\",\"hoverlabel.bordercolor\"),r(\"fontFamily\",\"htf\",\"hoverlabel.font.family\"),r(\"fontSize\",\"hts\",\"hoverlabel.font.size\"),r(\"fontColor\",\"htc\",\"hoverlabel.font.color\"),r(\"nameLength\",\"hnl\",\"hoverlabel.namelength\"),t.posref=\"y\"===e?(t.x0+t.x1)/2:(t.y0+t.y1)/2,t.x0=d.constrain(t.x0,0,t.xa._length),t.x1=d.constrain(t.x1,0,t.xa._length),t.y0=d.constrain(t.y0,0,t.ya._length),t.y1=d.constrain(t.y1,0,t.ya._length);var o;if(void 0!==t.xLabelVal){o=\"log\"===t.xa.type&&t.xLabelVal<=0;var s=x.tickText(t.xa,t.xa.c2l(o?-t.xLabelVal:t.xLabelVal),\"hover\");o?0===t.xLabelVal?t.xLabel=\"0\":t.xLabel=\"-\"+s.text:t.xLabel=s.text,t.xVal=t.xa.c2d(t.xLabelVal)}if(void 0!==t.yLabelVal){o=\"log\"===t.ya.type&&t.yLabelVal<=0;var l=x.tickText(t.ya,t.ya.c2l(o?-t.yLabelVal:t.yLabelVal),\"hover\");o?0===t.yLabelVal?t.yLabel=\"0\":t.yLabel=\"-\"+l.text:t.yLabel=l.text,t.yVal=t.ya.c2d(t.yLabelVal)}if(void 0!==t.zLabelVal&&(t.zLabel=String(t.zLabelVal)),!(isNaN(t.xerr)||\"log\"===t.xa.type&&t.xerr<=0)){var u=x.tickText(t.xa,t.xa.c2l(t.xerr),\"hover\").text;void 0!==t.xerrneg?t.xLabel+=\" +\"+u+\" / -\"+x.tickText(t.xa,t.xa.c2l(t.xerrneg),\"hover\").text:t.xLabel+=\" \\xb1 \"+u,\"x\"===e&&(t.distance+=1)}if(!(isNaN(t.yerr)||\"log\"===t.ya.type&&t.yerr<=0)){var c=x.tickText(t.ya,t.ya.c2l(t.yerr),\"hover\").text;void 0!==t.yerrneg?t.yLabel+=\" +\"+c+\" / -\"+x.tickText(t.ya,t.ya.c2l(t.yerrneg),\"hover\").text:t.yLabel+=\" \\xb1 \"+c,\"y\"===e&&(t.distance+=1)}var h=t.hoverinfo||t.trace.hoverinfo;return\"all\"!==h&&(h=h.split(\"+\"),-1===h.indexOf(\"x\")&&(t.xLabel=void 0),-1===h.indexOf(\"y\")&&(t.yLabel=void 0),-1===h.indexOf(\"z\")&&(t.zLabel=void 0),-1===h.indexOf(\"text\")&&(t.text=void 0),-1===h.indexOf(\"name\")&&(t.name=void 0)),t}function l(t,e){var r=e.hovermode,n=e.container,i=t[0],a=i.xa,o=i.ya,s=a.showspikes,l=o.showspikes;if(n.selectAll(\".spikeline\").remove(),\"closest\"===r&&(s||l)){var u=e.fullLayout,c=a._offset+(i.x0+i.x1)/2,h=o._offset+(i.y0+i.y1)/2,d=y.combine(u.plot_bgcolor,u.paper_bgcolor),p=f.readability(i.color,d)<1.5?y.contrast(d):i.color;if(l){var m=o.spikemode,v=o.spikethickness,b=o.spikecolor||p,x=o._boundingBox,_=(x.left+x.right)/2<c?x.right:x.left;if(-1!==m.indexOf(\"toaxis\")||-1!==m.indexOf(\"across\")){var w=_,M=c;-1!==m.indexOf(\"across\")&&(w=o._counterSpan[0],M=o._counterSpan[1]),n.append(\"line\").attr({x1:w,x2:M,y1:h,y2:h,\"stroke-width\":v+2,stroke:d}).classed(\"spikeline\",!0).classed(\"crisp\",!0),n.append(\"line\").attr({x1:w,x2:M,y1:h,y2:h,\"stroke-width\":v,stroke:b,\"stroke-dasharray\":g.dashStyle(o.spikedash,v)}).classed(\"spikeline\",!0).classed(\"crisp\",!0)}-1!==m.indexOf(\"marker\")&&n.append(\"circle\").attr({cx:_+(\"right\"!==o.side?v:-v),cy:h,r:v,fill:b}).classed(\"spikeline\",!0)}if(s){var k=a.spikemode,A=a.spikethickness,T=a.spikecolor||p,S=a._boundingBox,E=(S.top+S.bottom)/2<h?S.bottom:S.top;if(-1!==k.indexOf(\"toaxis\")||-1!==k.indexOf(\"across\")){var L=E,C=h;-1!==k.indexOf(\"across\")&&(L=a._counterSpan[0],C=a._counterSpan[1]),n.append(\"line\").attr({x1:c,x2:c,y1:L,y2:C,\"stroke-width\":A+2,stroke:d}).classed(\"spikeline\",!0).classed(\"crisp\",!0),n.append(\"line\").attr({x1:c,x2:c,y1:L,y2:C,\"stroke-width\":A,stroke:T,\"stroke-dasharray\":g.dashStyle(a.spikedash,A)}).classed(\"spikeline\",!0).classed(\"crisp\",!0)}-1!==k.indexOf(\"marker\")&&n.append(\"circle\").attr({cx:c,cy:E-(\"top\"!==a.side?A:-A),r:A,fill:T}).classed(\"spikeline\",!0)}}}function u(t,e,r){if(!r||r.length!==t._hoverdata.length)return!0;for(var n=r.length-1;n>=0;n--){var i=r[n],a=t._hoverdata[n];if(i.curveNumber!==a.curveNumber||String(i.pointNumber)!==String(a.pointNumber))return!0}return!1}var c=t(\"d3\"),h=t(\"fast-isnumeric\"),f=t(\"tinycolor2\"),d=t(\"../../lib\"),p=t(\"../../lib/events\"),m=t(\"../../lib/svg_text_utils\"),v=t(\"../../lib/override_cursor\"),g=t(\"../drawing\"),y=t(\"../color\"),b=t(\"../dragelement\"),x=t(\"../../plots/cartesian/axes\"),_=t(\"../../registry\"),w=t(\"./helpers\"),M=t(\"./constants\"),k=M.YANGLE,A=Math.PI*k/180,T=1/Math.sin(A),S=Math.cos(A),E=Math.sin(A),L=M.HOVERARROWSIZE,C=M.HOVERTEXTPAD;r.hover=function(t,e,r,i){if(\"string\"==typeof t&&(t=document.getElementById(t)),void 0===t._lastHoverTime&&(t._lastHoverTime=0),void 0!==t._hoverTimer&&(clearTimeout(t._hoverTimer),t._hoverTimer=void 0),Date.now()>t._lastHoverTime+M.HOVERMINTIME)return n(t,e,r,i),void(t._lastHoverTime=Date.now());t._hoverTimer=setTimeout(function(){n(t,e,r,i),t._lastHoverTime=Date.now(),t._hoverTimer=void 0},M.HOVERMINTIME)},r.loneHover=function(t,e){var r={color:t.color||y.defaultLine,x0:t.x0||t.x||0,x1:t.x1||t.x||0,y0:t.y0||t.y||0,y1:t.y1||t.y||0,xLabel:t.xLabel,yLabel:t.yLabel,zLabel:t.zLabel,text:t.text,name:t.name,idealAlign:t.idealAlign,borderColor:t.borderColor,fontFamily:t.fontFamily,fontSize:t.fontSize,fontColor:t.fontColor,trace:{index:0,hoverinfo:\"\"},xa:{_offset:0},ya:{_offset:0},index:0},n=c.select(e.container),a=e.outerContainer?c.select(e.outerContainer):n,s={hovermode:\"closest\",rotateLabels:!1,bgColor:e.bgColor||y.background,container:n,outerContainer:a},l=i([r],s,e.gd);return o(l,s.rotateLabels),l.node()}},{\"../../lib\":725,\"../../lib/events\":715,\"../../lib/override_cursor\":735,\"../../lib/svg_text_utils\":745,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":639,\"./helpers\":641,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],643:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r,i){i=i||{},r(\"hoverlabel.bgcolor\",i.bgcolor),r(\"hoverlabel.bordercolor\",i.bordercolor),r(\"hoverlabel.namelength\",i.namelength),n.coerceFont(r,\"hoverlabel.font\",i.font)}},{\"../../lib\":725}],644:[function(t,e,r){\"use strict\";function n(t){var e=s.isD3Selection(t)?t:o.select(t);e.selectAll(\"g.hovertext\").remove(),e.selectAll(\".spikeline\").remove()}function i(t,e,r){return s.castOption(t,e,\"hoverlabel.\"+r)}function a(t,e,r){function n(r){return s.coerceHoverinfo({hoverinfo:r},{_module:t._module},e)}return s.castOption(t,r,\"hoverinfo\",n)}var o=t(\"d3\"),s=t(\"../../lib\"),l=t(\"../dragelement\"),u=t(\"./helpers\"),c=t(\"./layout_attributes\");e.exports={moduleType:\"component\",name:\"fx\",constants:t(\"./constants\"),schema:{layout:c},attributes:t(\"./attributes\"),layoutAttributes:c,supplyLayoutGlobalDefaults:t(\"./layout_global_defaults\"),supplyDefaults:t(\"./defaults\"),supplyLayoutDefaults:t(\"./layout_defaults\"),calc:t(\"./calc\"),getDistanceFunction:u.getDistanceFunction,getClosest:u.getClosest,inbox:u.inbox,appendArrayPointValue:u.appendArrayPointValue,castHoverOption:i,castHoverinfo:a,hover:t(\"./hover\").hover,unhover:l.unhover,loneHover:t(\"./hover\").loneHover,loneUnhover:n,click:t(\"./click\")}},{\"../../lib\":725,\"../dragelement\":624,\"./attributes\":636,\"./calc\":637,\"./click\":638,\"./constants\":639,\"./defaults\":640,\"./helpers\":641,\"./hover\":642,\"./layout_attributes\":645,\"./layout_defaults\":646,\"./layout_global_defaults\":647,d3:121}],645:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"./constants\");e.exports={dragmode:{valType:\"enumerated\",values:[\"zoom\",\"pan\",\"select\",\"lasso\",\"orbit\",\"turntable\"],dflt:\"zoom\"},hovermode:{valType:\"enumerated\",values:[\"x\",\"y\",\"closest\",!1]},hoverlabel:{bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\"},font:{family:n({},i.family,{dflt:a.HOVERFONT}),size:n({},i.size,{dflt:a.HOVERFONTSIZE}),color:n({},i.color)},namelength:{valType:\"integer\",min:-1,dflt:15}}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"./constants\":639}],646:[function(t,e,r){\"use strict\";function n(t){for(var e=!0,r=0;r<t.length;r++){if(\"h\"!==t[r].orientation){e=!1;break}}return e}var i=t(\"../../lib\"),a=t(\"./layout_attributes\");e.exports=function(t,e,r){function o(r,n){return i.coerce(t,e,a,r,n)}o(\"dragmode\");var s;e._has(\"cartesian\")?(e._isHoriz=n(r),s=e._isHoriz?\"y\":\"x\"):s=\"closest\",o(\"hovermode\",s),e._has(\"mapbox\")&&1===e._basePlotModules.length&&\"zoom\"===e.dragmode&&(e.dragmode=\"pan\")}},{\"../../lib\":725,\"./layout_attributes\":645}],647:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./hoverlabel_defaults\"),a=t(\"./layout_attributes\");e.exports=function(t,e){function r(r,i){return n.coerce(t,e,a,r,i)}i(t,e,r)}},{\"../../lib\":725,\"./hoverlabel_defaults\":643,\"./layout_attributes\":645}],648:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/constants\");e.exports={_isLinkedToArray:\"image\",visible:{valType:\"boolean\",dflt:!0},source:{valType:\"string\"},layer:{valType:\"enumerated\",values:[\"below\",\"above\"],dflt:\"above\"},sizex:{valType:\"number\",dflt:0},sizey:{valType:\"number\",dflt:0},sizing:{valType:\"enumerated\",values:[\"fill\",\"contain\",\"stretch\"],dflt:\"contain\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},x:{valType:\"any\",dflt:0},y:{valType:\"any\",dflt:0},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},yanchor:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"top\"},xref:{valType:\"enumerated\",values:[\"paper\",n.idRegex.x.toString()],dflt:\"paper\"},yref:{valType:\"enumerated\",values:[\"paper\",n.idRegex.y.toString()],dflt:\"paper\"}}},{\"../../plots/cartesian/constants\":771}],649:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib/to_log_range\");e.exports=function(t,e,r,a){e=e||{};var o=\"log\"===r&&\"linear\"===e.type,s=\"linear\"===r&&\"log\"===e.type;if(o||s)for(var l,u,c=t._fullLayout.images,h=e._id.charAt(0),f=0;f<c.length;f++)if(l=c[f],u=\"images[\"+f+\"].\",l[h+\"ref\"]===e._id){var d=l[h],p=l[\"size\"+h],m=null,v=null;if(o){m=i(d,e.range);var g=p/Math.pow(10,m)/2;v=2*Math.log(g+Math.sqrt(1+g*g))/Math.LN10}else m=Math.pow(10,d),v=m*(Math.pow(10,p/2)-Math.pow(10,-p/2));n(m)?n(v)||(v=null):(m=null,v=null),a(u+h,m),a(u+\"size\"+h,v)}}},{\"../../lib/to_log_range\":746,\"fast-isnumeric\":130}],650:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return i.coerce(t,e,s,r,n)}if(!n(\"visible\",!!n(\"source\")))return e;n(\"layer\"),n(\"xanchor\"),n(\"yanchor\"),n(\"sizex\"),n(\"sizey\"),n(\"sizing\"),n(\"opacity\");for(var o={_fullLayout:r},l=[\"x\",\"y\"],u=0;u<2;u++){var c=l[u],h=a.coerceRef(t,e,o,c,\"paper\");a.coercePosition(e,o,n,h,c,0)}return e}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\");e.exports=function(t,e){o(t,e,{name:\"images\",handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"../../plots/cartesian/axes\":766,\"./attributes\":648}],651:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../drawing\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../constants/xmlns_namespaces\");e.exports=function(t){function e(e){var r=n.select(this);if(!this.img||this.img.src!==e.source){r.attr(\"xmlns\",o.svg);var i=new Promise(function(t){function n(){r.remove(),t()}var i=new Image;this.img=i,i.setAttribute(\"crossOrigin\",\"anonymous\"),i.onerror=n,i.onload=function(){var e=document.createElement(\"canvas\");e.width=this.width,e.height=this.height,e.getContext(\"2d\").drawImage(this,0,0);var n=e.toDataURL(\"image/png\");r.attr(\"xlink:href\",n),t()},r.on(\"error\",n),i.src=e.source}.bind(this));t._promises.push(i)}}function r(e){var r=n.select(this),o=a.getFromId(t,e.xref),s=a.getFromId(t,e.yref),l=u._size,c=o?Math.abs(o.l2p(e.sizex)-o.l2p(0)):e.sizex*l.w,h=s?Math.abs(s.l2p(e.sizey)-s.l2p(0)):e.sizey*l.h,f=c*m.x[e.xanchor].offset,d=h*m.y[e.yanchor].offset,p=m.x[e.xanchor].sizing+m.y[e.yanchor].sizing,v=(o?o.r2p(e.x)+o._offset:e.x*l.w+l.l)+f,g=(s?s.r2p(e.y)+s._offset:l.h-e.y*l.h+l.t)+d;switch(e.sizing){case\"fill\":p+=\" slice\";break;case\"stretch\":p=\"none\"}r.attr({x:v,y:g,width:c,height:h,preserveAspectRatio:p,opacity:e.opacity});var y=o?o._id:\"\",b=s?s._id:\"\",x=y+b;r.call(i.setClipUrl,x?\"clip\"+u._uid+x:null)}var s,l,u=t._fullLayout,c=[],h={},f=[];for(l=0;l<u.images.length;l++){var d=u.images[l];if(d.visible)if(\"below\"===d.layer&&\"paper\"!==d.xref&&\"paper\"!==d.yref){s=d.xref+d.yref;var p=u._plots[s];if(!p){f.push(d);continue}p.mainplot&&(s=p.mainplot.id),h[s]||(h[s]=[]),h[s].push(d)}else\"above\"===d.layer?c.push(d):f.push(d)}var m={x:{left:{sizing:\"xMin\",offset:0},center:{sizing:\"xMid\",offset:-.5},right:{sizing:\"xMax\",offset:-1}},y:{top:{sizing:\"YMin\",offset:0},middle:{sizing:\"YMid\",offset:-.5},bottom:{sizing:\"YMax\",offset:-1}}},v=u._imageLowerLayer.selectAll(\"image\").data(f),g=u._imageUpperLayer.selectAll(\"image\").data(c);v.enter().append(\"image\"),g.enter().append(\"image\"),v.exit().remove(),g.exit().remove(),v.each(function(t){e.bind(this)(t),r.bind(this)(t)}),g.each(function(t){e.bind(this)(t),r.bind(this)(t)});var y=Object.keys(u._plots);for(l=0;l<y.length;l++){s=y[l];var b=u._plots[s];if(b.imagelayer){var x=b.imagelayer.selectAll(\"image\").data(h[s]||[]);x.enter().append(\"image\"),x.exit().remove(),x.each(function(t){e.bind(this)(t),r.bind(this)(t)})}}}},{\"../../constants/xmlns_namespaces\":707,\"../../plots/cartesian/axes\":766,\"../drawing\":627,d3:121}],652:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"images\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\"),convertCoords:t(\"./convert_coords\")}},{\"./attributes\":648,\"./convert_coords\":649,\"./defaults\":650,\"./draw\":651}],653:[function(t,e,r){\"use strict\";r.isRightAnchor=function(t){return\"right\"===t.xanchor||\"auto\"===t.xanchor&&t.x>=2/3},r.isCenterAnchor=function(t){return\"center\"===t.xanchor||\"auto\"===t.xanchor&&t.x>1/3&&t.x<2/3},r.isBottomAnchor=function(t){return\"bottom\"===t.yanchor||\"auto\"===t.yanchor&&t.y<=1/3},r.isMiddleAnchor=function(t){return\"middle\"===t.yanchor||\"auto\"===t.yanchor&&t.y>1/3&&t.y<2/3}},{}],654:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat;e.exports={bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.defaultLine},borderwidth:{valType:\"number\",min:0,dflt:0},font:a({},n,{}),orientation:{valType:\"enumerated\",values:[\"v\",\"h\"],dflt:\"v\"},traceorder:{valType:\"flaglist\",flags:[\"reversed\",\"grouped\"],extras:[\"normal\"]},tracegroupgap:{valType:\"number\",min:0,dflt:10},x:{valType:\"number\",min:-2,max:3,dflt:1.02},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3,dflt:1},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"auto\"}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../color/attributes\":602}],655:[function(t,e,r){\"use strict\";e.exports={scrollBarWidth:4,scrollBarHeight:20,scrollBarColor:\"#808BA4\",scrollBarMargin:4}},{}],656:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"./attributes\"),o=t(\"../../plots/layout_attributes\"),s=t(\"./helpers\");e.exports=function(t,e,r){function l(t,e){return i.coerce(d,p,a,t,e)}for(var u,c,h,f,d=t.legend||{},p=e.legend={},m=0,v=\"normal\",g=0;g<r.length;g++){var y=r[g];s.legendGetsTrace(y)&&(m++,n.traceIs(y,\"pie\")&&m++),(n.traceIs(y,\"bar\")&&\"stack\"===e.barmode||-1!==[\"tonextx\",\"tonexty\"].indexOf(y.fill))&&(v=s.isGrouped({traceorder:v})?\"grouped+reversed\":\"reversed\"),void 0!==y.legendgroup&&\"\"!==y.legendgroup&&(v=s.isReversed({traceorder:v})?\"reversed+grouped\":\"grouped\")}if(!1!==i.coerce(t,e,o,\"showlegend\",m>1)){if(l(\"bgcolor\",e.paper_bgcolor),l(\"bordercolor\"),l(\"borderwidth\"),i.coerceFont(l,\"font\",e.font),l(\"orientation\"),\"h\"===p.orientation){var b=t.xaxis;b&&b.rangeslider&&b.rangeslider.visible?(u=0,h=\"left\",c=1.1,f=\"bottom\"):(u=0,h=\"left\",c=-.1,f=\"top\")}l(\"traceorder\",v),s.isGrouped(e.legend)&&l(\"tracegroupgap\"),l(\"x\",u),l(\"xanchor\",h),l(\"y\",c),l(\"yanchor\",f),i.noneOrAll(d,p,[\"x\",\"y\"])}}},{\"../../lib\":725,\"../../plots/layout_attributes\":820,\"../../registry\":844,\"./attributes\":654,\"./helpers\":659}],657:[function(t,e,r){\"use strict\";function n(t,e){function r(r){y.convertToTspans(r,e,function(){o(t,e)})}var n=t.data()[0][0],i=e._fullLayout,a=n.trace,s=p.traceIs(a,\"pie\"),l=a.index,u=s?n.label:a.name,c=t.selectAll(\"text.legendtext\").data([0]);c.enter().append(\"text\").classed(\"legendtext\",!0),c.attr(\"text-anchor\",\"start\").classed(\"user-select-none\",!0).call(v.font,i.legend.font).text(u),e._context.edits.legendText&&!s?c.call(y.makeEditable,{gd:e}).call(r).on(\"edit\",function(t){this.text(t).call(r);var i=t;this.text()||(t=\"    \");var a,o,s=n.trace._fullInput||{},u={};if(-1!==[\"ohlc\",\"candlestick\"].indexOf(s.type))a=n.trace.transforms,o=a[a.length-1].direction,u[o+\".name\"]=t;else if(p.hasTransform(s,\"groupby\")){var c=p.getTransformIndices(s,\"groupby\"),d=c[c.length-1],m=f.keyedContainer(s,\"transforms[\"+d+\"].styles\",\"target\",\"value.name\");\"\"===i?m.remove(n.trace._group):m.set(n.trace._group,t),u=m.constructUpdate()}else u.name=t;return h.restyle(e,u,l)}):c.call(r)}function i(t,e){var r,n=1,i=t.selectAll(\"rect\").data([0]);i.enter().append(\"rect\").classed(\"legendtoggle\",!0).style(\"cursor\",\"pointer\").attr(\"pointer-events\",\"all\").call(g.fill,\"rgba(0,0,0,0)\"),i.on(\"mousedown\",function(){r=(new Date).getTime(),r-e._legendMouseDownTime<S?n+=1:(n=1,e._legendMouseDownTime=r)}),i.on(\"mouseup\",function(){if(!e._dragged&&!e._editing){var r=e._fullLayout.legend;(new Date).getTime()-e._legendMouseDownTime>S&&(n=Math.max(n-1,1)),1===n?r._clickTimeout=setTimeout(function(){a(t,e,n)},S):2===n&&(r._clickTimeout&&clearTimeout(r._clickTimeout),e._legendMouseDownTime=0,a(t,e,n))}})}function a(t,e,r){if(!e._dragged&&!e._editing){var n,i,a=e._fullLayout.hiddenlabels?e._fullLayout.hiddenlabels.slice():[],o=t.data()[0][0],s=e._fullData,l=o.trace,u=l.legendgroup,c=[];if(1===r&&T&&e.data&&e._context.showTips?(f.notifier(\"Double click on legend to isolate individual trace\",\"long\"),T=!1):T=!1,p.traceIs(l,\"pie\")){var d=o.label,m=a.indexOf(d);1===r?-1===m?a.push(d):a.splice(m,1):2===r&&(a=[],e.calcdata[0].forEach(function(t){d!==t.label&&a.push(t.label)}),e._fullLayout.hiddenlabels&&e._fullLayout.hiddenlabels.length===a.length&&-1===m&&(a=[])),h.relayout(e,\"hiddenlabels\",a)}else{var v,g=[],y=[];for(v=0;v<s.length;v++)g.push(v),y.push(!!p.traceIs(s[v],\"notLegendIsolatable\")||\"legendonly\");if(\"\"===u)c=[l.index],y[l.index]=!0;else for(v=0;v<s.length;v++)n=s[v],n.legendgroup===u&&(c.push(n.index),y[g.indexOf(v)]=!0);if(1===r)i=!0!==l.visible||\"legendonly\",h.restyle(e,\"visible\",i,c);else if(2===r){var b=!0;for(v=0;v<s.length;v++)if(s[v].visible!==y[v]){b=!1;break}b&&(y=!0);var x=[];for(v=0;v<s.length;v++)x.push(g[v]);h.restyle(e,\"visible\",y,x)}}}}function o(t,e){var r=t.data()[0][0];if(!r.trace.showlegend)return void t.remove();var n,i,a=t.select(\"g[class*=math-group]\"),o=a.node(),s=e._fullLayout.legend,l=s.font.size*_;if(o){var u=v.bBox(o);n=u.height,i=u.width,v.setTranslate(a,0,n/4)}else{var c=t.select(\".legendtext\"),h=y.lineCount(c),f=c.node();n=l*h,i=f?v.bBox(f).width:0;var d=l*(.3+(1-h)/2);y.positionText(c,40,d)}n=Math.max(n,16)+3,r.height=n,r.width=i}function s(t,e,r){var n=t._fullLayout,i=n.legend,a=i.borderwidth,o=k.isGrouped(i),s=0;if(i.width=0,i.height=0,k.isVertical(i))o&&e.each(function(t,e){v.setTranslate(this,0,e*i.tracegroupgap)}),r.each(function(t){var e=t[0],r=e.height,n=e.width;v.setTranslate(this,a,5+a+i.height+r/2),i.height+=r,i.width=Math.max(i.width,n)}),i.width+=45+2*a,i.height+=10+2*a,o&&(i.height+=(i._lgroupsLength-1)*i.tracegroupgap),s=40;else if(o){for(var l=[i.width],u=e.data(),h=0,f=u.length;h<f;h++){var d=u[h].map(function(t){return t[0].width}),p=40+Math.max.apply(null,d);i.width+=i.tracegroupgap+p,l.push(i.width)}e.each(function(t,e){v.setTranslate(this,l[e],0)}),e.each(function(){var t=c.select(this),e=t.selectAll(\"g.traces\"),r=0;e.each(function(t){var e=t[0],n=e.height;v.setTranslate(this,0,5+a+r+n/2),r+=n}),i.height=Math.max(i.height,r)}),i.height+=10+2*a,i.width+=2*a}else{var m=0,g=0,y=0,b=0;r.each(function(t){y=Math.max(40+t[0].width,y)}),r.each(function(t){var e=t[0],r=y,o=i.tracegroupgap||5;a+b+o+r>n.width-(n.margin.r+n.margin.l)&&(b=0,m+=g,i.height=i.height+g,g=0),v.setTranslate(this,a+b,5+a+e.height/2+m),i.width+=o+r,i.height=Math.max(i.height,e.height),b+=o+r,g=Math.max(e.height,g)}),i.width+=2*a,i.height+=10+2*a}i.width=Math.ceil(i.width),i.height=Math.ceil(i.height),r.each(function(e){var r=e[0];c.select(this).select(\".legendtoggle\").call(v.setRect,0,-r.height/2,(t._context.edits.legendText?0:i.width)+s,r.height)})}function l(t){var e=t._fullLayout,r=e.legend,n=\"left\";A.isRightAnchor(r)?n=\"right\":A.isCenterAnchor(r)&&(n=\"center\");var i=\"top\";A.isBottomAnchor(r)?i=\"bottom\":A.isMiddleAnchor(r)&&(i=\"middle\"),d.autoMargin(t,\"legend\",{x:r.x,y:r.y,l:r.width*({right:1,center:.5}[n]||0),r:r.width*({left:1,center:.5}[n]||0),b:r.height*({top:1,middle:.5}[i]||0),t:r.height*({bottom:1,middle:.5}[i]||0)})}function u(t){var e=t._fullLayout,r=e.legend,n=\"left\";A.isRightAnchor(r)?n=\"right\":A.isCenterAnchor(r)&&(n=\"center\"),d.autoMargin(t,\"legend\",{x:r.x,y:.5,l:r.width*({right:1,center:.5}[n]||0),r:r.width*({left:1,center:.5}[n]||0),b:0,t:0})}var c=t(\"d3\"),h=t(\"../../plotly\"),f=t(\"../../lib\"),d=t(\"../../plots/plots\"),p=t(\"../../registry\"),m=t(\"../dragelement\"),v=t(\"../drawing\"),g=t(\"../color\"),y=t(\"../../lib/svg_text_utils\"),b=t(\"./constants\"),x=t(\"../../constants/interactions\"),_=t(\"../../constants/alignment\").LINE_SPACING,w=t(\"./get_legend_data\"),M=t(\"./style\"),k=t(\"./helpers\"),A=t(\"./anchor_utils\"),T=!0,S=x.DBLCLICKDELAY;e.exports=function(t){function e(t,e){L.attr(\"data-scroll\",e).call(v.setTranslate,0,e),C.call(v.setRect,N,t,b.scrollBarWidth,b.scrollBarHeight),T.select(\"rect\").attr({y:y.borderwidth-e})}var r=t._fullLayout,o=\"legend\"+r._uid;if(r._infolayer&&t.calcdata){t._legendMouseDownTime||(t._legendMouseDownTime=0);var y=r.legend,x=r.showlegend&&w(t.calcdata,y),_=r.hiddenlabels||[];if(!r.showlegend||!x.length)return r._infolayer.selectAll(\".legend\").remove(),r._topdefs.select(\"#\"+o).remove(),void d.autoMargin(t,\"legend\");var k=r._infolayer.selectAll(\"g.legend\").data([0]);k.enter().append(\"g\").attr({class:\"legend\",\"pointer-events\":\"all\"});var T=r._topdefs.selectAll(\"#\"+o).data([0]);T.enter().append(\"clipPath\").attr(\"id\",o).append(\"rect\");var E=k.selectAll(\"rect.bg\").data([0]);E.enter().append(\"rect\").attr({class:\"bg\",\"shape-rendering\":\"crispEdges\"}),E.call(g.stroke,y.bordercolor),E.call(g.fill,y.bgcolor),E.style(\"stroke-width\",y.borderwidth+\"px\");var L=k.selectAll(\"g.scrollbox\").data([0]);L.enter().append(\"g\").attr(\"class\",\"scrollbox\");var C=k.selectAll(\"rect.scrollbar\").data([0]);C.enter().append(\"rect\").attr({class:\"scrollbar\",rx:20,ry:2,width:0,height:0}).call(g.fill,\"#808BA4\");var z=L.selectAll(\"g.groups\").data(x);z.enter().append(\"g\").attr(\"class\",\"groups\"),z.exit().remove();var I=z.selectAll(\"g.traces\").data(f.identity);I.enter().append(\"g\").attr(\"class\",\"traces\"),I.exit().remove(),I.call(M,t).style(\"opacity\",function(t){var e=t[0].trace;return p.traceIs(e,\"pie\")?-1!==_.indexOf(t[0].label)?.5:1:\"legendonly\"===e.visible?.5:1}).each(function(){c.select(this).call(n,t).call(i,t)});var D=0!==k.enter().size();D&&(s(t,z,I),l(t));var P=r.width,O=r.height;s(t,z,I),y.height>O?u(t):l(t);var R=r._size,F=R.l+R.w*y.x,j=R.t+R.h*(1-y.y);A.isRightAnchor(y)?F-=y.width:A.isCenterAnchor(y)&&(F-=y.width/2),A.isBottomAnchor(y)?j-=y.height:A.isMiddleAnchor(y)&&(j-=y.height/2);var N=y.width,B=R.w;N>B?(F=R.l,N=B):(F+N>P&&(F=P-N),F<0&&(F=0),N=Math.min(P-F,y.width));var U=y.height,V=R.h;U>V?(j=R.t,U=V):(j+U>O&&(j=O-U),j<0&&(j=0),U=Math.min(O-j,y.height)),v.setTranslate(k,F,j);var H,q,G=U-b.scrollBarHeight-2*b.scrollBarMargin,Y=y.height-U;if(y.height<=U||t._context.staticPlot)E.attr({width:N-y.borderwidth,height:U-y.borderwidth,x:y.borderwidth/2,y:y.borderwidth/2}),v.setTranslate(L,0,0),T.select(\"rect\").attr({width:N-2*y.borderwidth,height:U-2*y.borderwidth,x:y.borderwidth,y:y.borderwidth}),\n",
       "L.call(v.setClipUrl,o);else{H=b.scrollBarMargin,q=L.attr(\"data-scroll\")||0,E.attr({width:N-2*y.borderwidth+b.scrollBarWidth+b.scrollBarMargin,height:U-y.borderwidth,x:y.borderwidth/2,y:y.borderwidth/2}),T.select(\"rect\").attr({width:N-2*y.borderwidth+b.scrollBarWidth+b.scrollBarMargin,height:U-2*y.borderwidth,x:y.borderwidth,y:y.borderwidth-q}),L.call(v.setClipUrl,o),D&&e(H,q),k.on(\"wheel\",null),k.on(\"wheel\",function(){q=f.constrain(L.attr(\"data-scroll\")-c.event.deltaY/G*Y,-Y,0),H=b.scrollBarMargin-q/Y*G,e(H,q),0!==q&&q!==-Y&&c.event.preventDefault()}),C.on(\".drag\",null),L.on(\".drag\",null);var X=c.behavior.drag().on(\"drag\",function(){H=f.constrain(c.event.y-b.scrollBarHeight/2,b.scrollBarMargin,b.scrollBarMargin+G),q=-(H-b.scrollBarMargin)/G*Y,e(H,q)});C.call(X),L.call(X)}if(t._context.edits.legendPosition){var W,Z,J,K;k.classed(\"cursor-move\",!0),m.init({element:k.node(),gd:t,prepFn:function(){var t=v.getTranslate(k);J=t.x,K=t.y},moveFn:function(t,e){var r=J+t,n=K+e;v.setTranslate(k,r,n),W=m.align(r,0,R.l,R.l+R.w,y.xanchor),Z=m.align(n,0,R.t+R.h,R.t,y.yanchor)},doneFn:function(e,n,i){if(e&&void 0!==W&&void 0!==Z)h.relayout(t,{\"legend.x\":W,\"legend.y\":Z});else{var o=r._infolayer.selectAll(\"g.traces\").filter(function(){var t=this.getBoundingClientRect();return i.clientX>=t.left&&i.clientX<=t.right&&i.clientY>=t.top&&i.clientY<=t.bottom});o.size()>0&&(1===n?k._clickTimeout=setTimeout(function(){a(o,t,n)},S):2===n&&(k._clickTimeout&&clearTimeout(k._clickTimeout),a(o,t,n)))}}})}}}},{\"../../constants/alignment\":699,\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/plots\":829,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./anchor_utils\":653,\"./constants\":655,\"./get_legend_data\":658,\"./helpers\":659,\"./style\":661,d3:121}],658:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"./helpers\");e.exports=function(t,e){function r(t,r){if(\"\"!==t&&i.isGrouped(e))-1===l.indexOf(t)?(l.push(t),u=!0,s[t]=[[r]]):s[t].push([r]);else{var n=\"~~i\"+h;l.push(n),s[n]=[[r]],h++}}var a,o,s={},l=[],u=!1,c={},h=0;for(a=0;a<t.length;a++){var f=t[a],d=f[0],p=d.trace,m=p.legendgroup;if(i.legendGetsTrace(p)&&p.showlegend)if(n.traceIs(p,\"pie\"))for(c[m]||(c[m]={}),o=0;o<f.length;o++){var v=f[o].label;c[m][v]||(r(m,{label:v,color:f[o].color,i:f[o].i,trace:p}),c[m][v]=!0)}else r(m,d)}if(!l.length)return[];var g,y,b=l.length;if(u&&i.isGrouped(e))for(y=new Array(b),a=0;a<b;a++)g=s[l[a]],y[a]=i.isReversed(e)?g.reverse():g;else{for(y=[new Array(b)],a=0;a<b;a++)g=s[l[a]][0],y[0][i.isReversed(e)?b-a-1:a]=g;b=1}return e._lgroupsLength=b,y}},{\"../../registry\":844,\"./helpers\":659}],659:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");r.legendGetsTrace=function(t){return t.visible&&n.traceIs(t,\"showLegend\")},r.isGrouped=function(t){return-1!==(t.traceorder||\"\").indexOf(\"grouped\")},r.isVertical=function(t){return\"h\"!==t.orientation},r.isReversed=function(t){return-1!==(t.traceorder||\"\").indexOf(\"reversed\")}},{\"../../registry\":844}],660:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"legend\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\"),style:t(\"./style\")}},{\"./attributes\":654,\"./defaults\":656,\"./draw\":657,\"./style\":661}],661:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../drawing\"),s=t(\"../color\"),l=t(\"../../traces/scatter/subtypes\"),u=t(\"../../traces/pie/style_one\");e.exports=function(t,e){function r(t){var e=t[0].trace,r=e.visible&&e.fill&&\"none\"!==e.fill,i=l.hasLines(e);e&&e._module&&\"contourcarpet\"===e._module.name&&(i=e.contours.showlines,r=\"fill\"===e.contours.coloring);var a=n.select(this).select(\".legendfill\").selectAll(\"path\").data(r?[t]:[]);a.enter().append(\"path\").classed(\"js-fill\",!0),a.exit().remove(),a.attr(\"d\",\"M5,0h30v6h-30z\").call(o.fillGroupStyle);var s=n.select(this).select(\".legendlines\").selectAll(\"path\").data(i?[t]:[]);s.enter().append(\"path\").classed(\"js-line\",!0).attr(\"d\",\"M5,0h30\"),s.exit().remove(),s.call(o.lineGroupStyle)}function c(t){function r(t,e,r){var n=a.nestedProperty(h,t).get(),i=Array.isArray(n)&&e?e(n):n;if(r){if(i<r[0])return r[0];if(i>r[1])return r[1]}return i}function i(t){return t[0]}var s,u,c=t[0],h=c.trace,f=l.hasMarkers(h),d=l.hasText(h),p=l.hasLines(h);if(f||d||p){var m={},v={};f&&(m.mc=r(\"marker.color\",i),m.mo=r(\"marker.opacity\",a.mean,[.2,1]),m.ms=r(\"marker.size\",a.mean,[2,16]),m.mlc=r(\"marker.line.color\",i),m.mlw=r(\"marker.line.width\",a.mean,[0,5]),v.marker={sizeref:1,sizemin:1,sizemode:\"diameter\"}),p&&(v.line={width:r(\"line.width\",i,[0,10])}),d&&(m.tx=\"Aa\",m.tp=r(\"textposition\",i),m.ts=10,m.tc=r(\"textfont.color\",i),m.tf=r(\"textfont.family\",i)),s=[a.minExtend(c,m)],u=a.minExtend(h,v)}var g=n.select(this).select(\"g.legendpoints\"),y=g.selectAll(\"path.scatterpts\").data(f?s:[]);y.enter().append(\"path\").classed(\"scatterpts\",!0).attr(\"transform\",\"translate(20,0)\"),y.exit().remove(),y.call(o.pointStyle,u,e),f&&(s[0].mrc=3);var b=g.selectAll(\"g.pointtext\").data(d?s:[]);b.enter().append(\"g\").classed(\"pointtext\",!0).append(\"text\").attr(\"transform\",\"translate(20,0)\"),b.exit().remove(),b.selectAll(\"text\").call(o.textPointStyle,u,e)}function h(t){var e=t[0].trace,r=e.marker||{},a=r.line||{},o=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendbar\").data(i.traceIs(e,\"bar\")?[t]:[]);o.enter().append(\"path\").classed(\"legendbar\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),o.exit().remove(),o.each(function(t){var e=n.select(this),i=t[0],o=(i.mlw+1||a.width+1)-1;e.style(\"stroke-width\",o+\"px\").call(s.fill,i.mc||r.color),o&&e.call(s.stroke,i.mlc||a.color)})}function f(t){var e=t[0].trace,r=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendbox\").data(i.traceIs(e,\"box\")&&e.visible?[t]:[]);r.enter().append(\"path\").classed(\"legendbox\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),r.exit().remove(),r.each(function(){var t=e.line.width,r=n.select(this);r.style(\"stroke-width\",t+\"px\").call(s.fill,e.fillcolor),t&&r.call(s.stroke,e.line.color)})}function d(t){var e=t[0].trace,r=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendpie\").data(i.traceIs(e,\"pie\")&&e.visible?[t]:[]);r.enter().append(\"path\").classed(\"legendpie\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),r.exit().remove(),r.size()&&r.call(u,t[0],e)}t.each(function(t){var e=n.select(this),r=e.selectAll(\"g.layers\").data([0]);r.enter().append(\"g\").classed(\"layers\",!0),r.style(\"opacity\",t[0].trace.opacity),r.selectAll(\"g.legendfill\").data([t]).enter().append(\"g\").classed(\"legendfill\",!0),r.selectAll(\"g.legendlines\").data([t]).enter().append(\"g\").classed(\"legendlines\",!0);var i=r.selectAll(\"g.legendsymbols\").data([t]);i.enter().append(\"g\").classed(\"legendsymbols\",!0),i.selectAll(\"g.legendpoints\").data([t]).enter().append(\"g\").classed(\"legendpoints\",!0)}).each(h).each(f).each(d).each(r).each(c)}},{\"../../lib\":725,\"../../registry\":844,\"../../traces/pie/style_one\":1013,\"../../traces/scatter/subtypes\":1047,\"../color\":603,\"../drawing\":627,d3:121}],662:[function(t,e,r){\"use strict\";function n(t,e){var r,n,i=e.currentTarget,a=i.getAttribute(\"data-attr\"),o=i.getAttribute(\"data-val\")||!0,s=t._fullLayout,l={},u=f.list(t,null,!0),h=\"on\";if(\"zoom\"===a){var d,p=\"in\"===o?.5:2,m=(1+p)/2,v=(1-p)/2;for(n=0;n<u.length;n++)if(r=u[n],!r.fixedrange)if(d=r._name,\"auto\"===o)l[d+\".autorange\"]=!0;else if(\"reset\"===o){if(void 0===r._rangeInitial)l[d+\".autorange\"]=!0;else{var g=r._rangeInitial.slice();l[d+\".range[0]\"]=g[0],l[d+\".range[1]\"]=g[1]}void 0!==r._showSpikeInitial&&(l[d+\".showspikes\"]=r._showSpikeInitial,\"on\"!==h||r._showSpikeInitial||(h=\"off\"))}else{var y=[r.r2l(r.range[0]),r.r2l(r.range[1])],b=[m*y[0]+v*y[1],m*y[1]+v*y[0]];l[d+\".range[0]\"]=r.l2r(b[0]),l[d+\".range[1]\"]=r.l2r(b[1])}s._cartesianSpikesEnabled=h}else{if(\"hovermode\"!==a||\"x\"!==o&&\"y\"!==o){if(\"hovermode\"===a&&\"closest\"===o){for(n=0;n<u.length;n++)r=u[n],\"on\"!==h||r.showspikes||(h=\"off\");s._cartesianSpikesEnabled=h}}else o=s._isHoriz?\"y\":\"x\",i.setAttribute(\"data-val\",o),\"closest\"!==o&&(s._cartesianSpikesEnabled=\"off\");l[a]=o}c.relayout(t,l)}function i(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=r.getAttribute(\"data-val\")||!0,a=t._fullLayout,o=h.getSubplotIds(a,\"gl3d\"),s={},l=n.split(\".\"),u=0;u<o.length;u++)s[o[u]+\".\"+l[1]]=i;c.relayout(t,s)}function a(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=t._fullLayout,a=h.getSubplotIds(i,\"gl3d\"),o={},s=0;s<a.length;s++){var l=a[s],u=l+\".camera\",f=i[l]._scene;\"resetDefault\"===n?o[u]=null:\"resetLastSave\"===n&&(o[u]=d.extendDeep({},f.cameraInitial))}c.relayout(t,o)}function o(t,e){var r=e.currentTarget,n=r._previousVal||!1,i=t.layout,a=t._fullLayout,o=h.getSubplotIds(a,\"gl3d\"),s=[\"xaxis\",\"yaxis\",\"zaxis\"],l=[\"showspikes\",\"spikesides\",\"spikethickness\",\"spikecolor\"],u={},f={},p={};if(n)p=d.extendDeep(i,n),r._previousVal=null;else{p={\"allaxes.showspikes\":!1};for(var m=0;m<o.length;m++){var v=o[m],g=a[v],y=u[v]={};y.hovermode=g.hovermode,p[v+\".hovermode\"]=!1;for(var b=0;b<3;b++){var x=s[b];f=y[x]={};for(var _=0;_<l.length;_++){var w=l[_];f[w]=g[x][w]}}}r._previousVal=d.extendDeep({},u)}c.relayout(t,p)}function s(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=r.getAttribute(\"data-val\")||!0,a=t._fullLayout,o=h.getSubplotIds(a,\"geo\"),s=0;s<o.length;s++){var l=a[o[s]]._subplot;if(\"zoom\"===n){var u=l.projection.scale(),c=\"in\"===i?2*u:.5*u;l.projection.scale(c),l.zoom.scale(c),l.render()}else\"reset\"===n&&l.zoomReset()}}function l(t){var e,r=t._fullLayout;e=r._has(\"cartesian\")?r._isHoriz?\"y\":\"x\":\"closest\";var n=!t._fullLayout.hovermode&&e;c.relayout(t,\"hovermode\",n)}function u(t){for(var e,r,n=t._fullLayout,i=f.list(t,null,!0),a={},o=0;o<i.length;o++)e=i[o],r=e._name,a[r+\".showspikes\"]=\"on\"===n._cartesianSpikesEnabled;return a}var c=t(\"../../plotly\"),h=t(\"../../plots/plots\"),f=t(\"../../plots/cartesian/axes\"),d=t(\"../../lib\"),p=t(\"../../snapshot/download\"),m=t(\"../../../build/ploticon\"),v=e.exports={};v.toImage={name:\"toImage\",title:\"Download plot as a png\",icon:m.camera,click:function(t){var e=\"png\";d.notifier(\"Taking snapshot - this may take a few seconds\",\"long\"),d.isIE()&&(d.notifier(\"IE only supports svg.  Changing format to svg.\",\"long\"),e=\"svg\"),p(t,{format:e}).then(function(t){d.notifier(\"Snapshot succeeded - \"+t,\"long\")}).catch(function(){d.notifier(\"Sorry there was a problem downloading your snapshot!\",\"long\")})}},v.sendDataToCloud={name:\"sendDataToCloud\",title:\"Save and edit plot in cloud\",icon:m.disk,click:function(t){h.sendDataToCloud(t)}},v.zoom2d={name:\"zoom2d\",title:\"Zoom\",attr:\"dragmode\",val:\"zoom\",icon:m.zoombox,click:n},v.pan2d={name:\"pan2d\",title:\"Pan\",attr:\"dragmode\",val:\"pan\",icon:m.pan,click:n},v.select2d={name:\"select2d\",title:\"Box Select\",attr:\"dragmode\",val:\"select\",icon:m.selectbox,click:n},v.lasso2d={name:\"lasso2d\",title:\"Lasso Select\",attr:\"dragmode\",val:\"lasso\",icon:m.lasso,click:n},v.zoomIn2d={name:\"zoomIn2d\",title:\"Zoom in\",attr:\"zoom\",val:\"in\",icon:m.zoom_plus,click:n},v.zoomOut2d={name:\"zoomOut2d\",title:\"Zoom out\",attr:\"zoom\",val:\"out\",icon:m.zoom_minus,click:n},v.autoScale2d={name:\"autoScale2d\",title:\"Autoscale\",attr:\"zoom\",val:\"auto\",icon:m.autoscale,click:n},v.resetScale2d={name:\"resetScale2d\",title:\"Reset axes\",attr:\"zoom\",val:\"reset\",icon:m.home,click:n},v.hoverClosestCartesian={name:\"hoverClosestCartesian\",title:\"Show closest data on hover\",attr:\"hovermode\",val:\"closest\",icon:m.tooltip_basic,gravity:\"ne\",click:n},v.hoverCompareCartesian={name:\"hoverCompareCartesian\",title:\"Compare data on hover\",attr:\"hovermode\",val:function(t){return t._fullLayout._isHoriz?\"y\":\"x\"},icon:m.tooltip_compare,gravity:\"ne\",click:n},v.zoom3d={name:\"zoom3d\",title:\"Zoom\",attr:\"scene.dragmode\",val:\"zoom\",icon:m.zoombox,click:i},v.pan3d={name:\"pan3d\",title:\"Pan\",attr:\"scene.dragmode\",val:\"pan\",icon:m.pan,click:i},v.orbitRotation={name:\"orbitRotation\",title:\"orbital rotation\",attr:\"scene.dragmode\",val:\"orbit\",icon:m[\"3d_rotate\"],click:i},v.tableRotation={name:\"tableRotation\",title:\"turntable rotation\",attr:\"scene.dragmode\",val:\"turntable\",icon:m[\"z-axis\"],click:i},v.resetCameraDefault3d={name:\"resetCameraDefault3d\",title:\"Reset camera to default\",attr:\"resetDefault\",icon:m.home,click:a},v.resetCameraLastSave3d={name:\"resetCameraLastSave3d\",title:\"Reset camera to last save\",attr:\"resetLastSave\",icon:m.movie,click:a},v.hoverClosest3d={name:\"hoverClosest3d\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:o},v.zoomInGeo={name:\"zoomInGeo\",title:\"Zoom in\",attr:\"zoom\",val:\"in\",icon:m.zoom_plus,click:s},v.zoomOutGeo={name:\"zoomOutGeo\",title:\"Zoom out\",attr:\"zoom\",val:\"out\",icon:m.zoom_minus,click:s},v.resetGeo={name:\"resetGeo\",title:\"Reset\",attr:\"reset\",val:null,icon:m.autoscale,click:s},v.hoverClosestGeo={name:\"hoverClosestGeo\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:l},v.hoverClosestGl2d={name:\"hoverClosestGl2d\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:l},v.hoverClosestPie={name:\"hoverClosestPie\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:\"closest\",icon:m.tooltip_basic,gravity:\"ne\",click:l},v.toggleHover={name:\"toggleHover\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:function(t,e){l(t),o(t,e)}},v.resetViews={name:\"resetViews\",title:\"Reset views\",icon:m.home,click:function(t,e){var r=e.currentTarget;r.setAttribute(\"data-attr\",\"zoom\"),r.setAttribute(\"data-val\",\"reset\"),n(t,e),r.setAttribute(\"data-attr\",\"resetLastSave\"),a(t,e)}},v.toggleSpikelines={name:\"toggleSpikelines\",title:\"Toggle Spike Lines\",icon:m.spikeline,attr:\"_cartesianSpikesEnabled\",val:\"on\",click:function(t){var e=t._fullLayout;e._cartesianSpikesEnabled=\"closest\"===e.hovermode&&\"on\"===e._cartesianSpikesEnabled?\"off\":\"on\";var r=u(t);r.hovermode=\"closest\",c.relayout(t,r)}},v.resetViewMapbox={name:\"resetViewMapbox\",title:\"Reset view\",attr:\"reset\",icon:m.home,click:function(t){for(var e=t._fullLayout,r=h.getSubplotIds(e,\"mapbox\"),n={},i=0;i<r.length;i++)for(var a=r[i],o=e[a]._subplot,s=o.viewInitial,l=Object.keys(s),u=0;u<l.length;u++){var f=l[u];n[a+\".\"+f]=s[f]}c.relayout(t,n)}}},{\"../../../build/ploticon\":2,\"../../lib\":725,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../../snapshot/download\":846}],663:[function(t,e,r){\"use strict\";r.manage=t(\"./manage\")},{\"./manage\":664}],664:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){for(var r=[],n=0;n<t.length;n++){var i=t[n];-1===e.indexOf(i)&&r.push(f[i])}g.push(r)}var s=t._fullLayout,l=t._fullData,u=s._has(\"cartesian\"),c=s._has(\"gl3d\"),h=s._has(\"geo\"),d=s._has(\"pie\"),p=s._has(\"gl2d\"),m=s._has(\"ternary\"),v=s._has(\"mapbox\"),g=[];if(n([\"toImage\",\"sendDataToCloud\"]),(u||p||d||m)+h+c>1)return n([\"resetViews\",\"toggleHover\"]),o(g,r);c&&(n([\"zoom3d\",\"pan3d\",\"orbitRotation\",\"tableRotation\"]),n([\"resetCameraDefault3d\",\"resetCameraLastSave3d\"]),n([\"hoverClosest3d\"])),h&&(n([\"zoomInGeo\",\"zoomOutGeo\",\"resetGeo\"]),n([\"hoverClosestGeo\"]));var y=i(s),b=[];return((u||p)&&!y||m)&&(b=[\"zoom2d\",\"pan2d\"]),v&&(b=[\"pan2d\"]),a(l)&&(b.push(\"select2d\"),b.push(\"lasso2d\")),b.length&&n(b),!u&&!p||y||m||n([\"zoomIn2d\",\"zoomOut2d\",\"autoScale2d\",\"resetScale2d\"]),u&&d?n([\"toggleHover\"]):p?n([\"hoverClosestGl2d\"]):u?n([\"toggleSpikelines\",\"hoverClosestCartesian\",\"hoverCompareCartesian\"]):d?n([\"hoverClosestPie\"]):v&&n([\"resetViewMapbox\",\"toggleHover\"]),o(g,r)}function i(t){for(var e=l.list({_fullLayout:t},null,!0),r=!0,n=0;n<e.length;n++)if(!e[n].fixedrange){r=!1;break}return r}function a(t){for(var e=!1,r=0;r<t.length&&!e;r++){var n=t[r];n._module&&n._module.selectPoints&&(c.traceIs(n,\"scatter-like\")?(u.hasMarkers(n)||u.hasText(n))&&(e=!0):e=!0)}return e}function o(t,e){if(e.length)if(Array.isArray(e[0]))for(var r=0;r<e.length;r++)t.push(e[r]);else t.push(e);return t}function s(t){for(var e=0;e<t.length;e++)for(var r=t[e],n=0;n<r.length;n++){var i=r[n];if(\"string\"==typeof i){if(void 0===f[i])throw new Error([\"*modeBarButtons* configuration options\",\"invalid button name\"].join(\" \"));t[e][n]=f[i]}}return t}var l=t(\"../../plots/cartesian/axes\"),u=t(\"../../traces/scatter/subtypes\"),c=t(\"../../registry\"),h=t(\"./modebar\"),f=t(\"./buttons\");e.exports=function(t){var e=t._fullLayout,r=t._context,i=e._modeBar;if(!r.displayModeBar)return void(i&&(i.destroy(),delete e._modeBar));if(!Array.isArray(r.modeBarButtonsToRemove))throw new Error([\"*modeBarButtonsToRemove* configuration options\",\"must be an array.\"].join(\" \"));if(!Array.isArray(r.modeBarButtonsToAdd))throw new Error([\"*modeBarButtonsToAdd* configuration options\",\"must be an array.\"].join(\" \"));var a,o=r.modeBarButtons;a=Array.isArray(o)&&o.length?s(o):n(t,r.modeBarButtonsToRemove,r.modeBarButtonsToAdd),i?i.update(t,a):e._modeBar=h(t,a)}},{\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../../traces/scatter/subtypes\":1047,\"./buttons\":662,\"./modebar\":665}],665:[function(t,e,r){\"use strict\";function n(t){this.container=t.container,this.element=document.createElement(\"div\"),this.update(t.graphInfo,t.buttons),this.container.appendChild(this.element)}function i(t,e){var r=t._fullLayout,i=new n({graphInfo:t,container:r._paperdiv.node(),buttons:e});return r._privateplot&&a.select(i.element).append(\"span\").classed(\"badge-private float--left\",!0).text(\"PRIVATE\"),i}var a=t(\"d3\"),o=t(\"../../lib\"),s=t(\"../../../build/ploticon\"),l=n.prototype;l.update=function(t,e){this.graphInfo=t;var r=this.graphInfo._context;\"hover\"===r.displayModeBar?this.element.className=\"modebar modebar--hover\":this.element.className=\"modebar\";var n=!this.hasButtons(e),i=this.hasLogo!==r.displaylogo;(n||i)&&(this.removeAllButtons(),this.updateButtons(e),r.displaylogo&&(this.element.appendChild(this.getLogo()),this.hasLogo=!0)),this.updateActiveButton()},l.updateButtons=function(t){var e=this;this.buttons=t,this.buttonElements=[],this.buttonsNames=[],this.buttons.forEach(function(t){var r=e.createGroup();t.forEach(function(t){var n=t.name;if(!n)throw new Error(\"must provide button 'name' in button config\");if(-1!==e.buttonsNames.indexOf(n))throw new Error(\"button name '\"+n+\"' is taken\");e.buttonsNames.push(n);var i=e.createButton(t);e.buttonElements.push(i),r.appendChild(i)}),e.element.appendChild(r)})},l.createGroup=function(){var t=document.createElement(\"div\");return t.className=\"modebar-group\",t},l.createButton=function(t){var e=this,r=document.createElement(\"a\");r.setAttribute(\"rel\",\"tooltip\"),r.className=\"modebar-btn\";var n=t.title;void 0===n&&(n=t.name),(n||0===n)&&r.setAttribute(\"data-title\",n),void 0!==t.attr&&r.setAttribute(\"data-attr\",t.attr);var i=t.val;if(void 0!==i&&(\"function\"==typeof i&&(i=i(this.graphInfo)),r.setAttribute(\"data-val\",i)),\"function\"!=typeof t.click)throw new Error(\"must provide button 'click' function in button config\");return r.addEventListener(\"click\",function(r){t.click(e.graphInfo,r),e.updateActiveButton(r.currentTarget)}),r.setAttribute(\"data-toggle\",t.toggle||!1),t.toggle&&a.select(r).classed(\"active\",!0),r.appendChild(this.createIcon(t.icon||s.question,t.name)),r.setAttribute(\"data-gravity\",t.gravity||\"n\"),r},l.createIcon=function(t,e){var r=t.ascent-t.descent,n=\"http://www.w3.org/2000/svg\",i=document.createElementNS(n,\"svg\"),a=document.createElementNS(n,\"path\");i.setAttribute(\"height\",\"1em\"),i.setAttribute(\"width\",t.width/r+\"em\"),i.setAttribute(\"viewBox\",[0,0,t.width,r].join(\" \"));var o=\"toggleSpikelines\"===e?\"matrix(1.5 0 0 -1.5 0 \"+t.ascent+\")\":\"matrix(1 0 0 -1 0 \"+t.ascent+\")\";return a.setAttribute(\"d\",t.path),a.setAttribute(\"transform\",o),i.appendChild(a),i},l.updateActiveButton=function(t){var e=this.graphInfo._fullLayout,r=void 0!==t?t.getAttribute(\"data-attr\"):null;this.buttonElements.forEach(function(t){var n=t.getAttribute(\"data-val\")||!0,i=t.getAttribute(\"data-attr\"),s=\"true\"===t.getAttribute(\"data-toggle\"),l=a.select(t);if(s)i===r&&l.classed(\"active\",!l.classed(\"active\"));else{var u=null===i?i:o.nestedProperty(e,i).get();l.classed(\"active\",u===n)}})},l.hasButtons=function(t){var e=this.buttons;if(!e)return!1;if(t.length!==e.length)return!1;for(var r=0;r<t.length;++r){if(t[r].length!==e[r].length)return!1;for(var n=0;n<t[r].length;n++)if(t[r][n].name!==e[r][n].name)return!1}return!0},l.getLogo=function(){var t=this.createGroup(),e=document.createElement(\"a\");return e.href=\"https://plot.ly/\",e.target=\"_blank\",e.setAttribute(\"data-title\",\"Produced with Plotly\"),e.className=\"modebar-btn plotlyjsicon modebar-btn--logo\",e.appendChild(this.createIcon(s.plotlylogo)),t.appendChild(e),t},l.removeAllButtons=function(){for(;this.element.firstChild;)this.element.removeChild(this.element.firstChild);this.hasLogo=!1},l.destroy=function(){o.removeElement(this.container.querySelector(\".modebar\"))},e.exports=i},{\"../../../build/ploticon\":2,\"../../lib\":725,d3:121}],666:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"./button_attributes\");o=a(o,{_isLinkedToArray:\"button\"}),e.exports={visible:{valType:\"boolean\"},buttons:o,x:{valType:\"number\",min:-2,max:3},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"bottom\"},font:a({},n,{}),bgcolor:{valType:\"color\",dflt:i.lightLine},activecolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.defaultLine},borderwidth:{valType:\"number\",min:0,dflt:0}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../color/attributes\":602,\"./button_attributes\":667}],667:[function(t,e,r){\"use strict\";e.exports={step:{valType:\"enumerated\",values:[\"month\",\"year\",\"day\",\"hour\",\"minute\",\"second\",\"all\"],dflt:\"month\"},stepmode:{valType:\"enumerated\",values:[\"backward\",\"todate\"],dflt:\"backward\"},count:{valType:\"number\",min:0,dflt:1},label:{valType:\"string\"}}},{}],668:[function(t,e,r){\"use strict\";e.exports={yPad:.02,minButtonWidth:30,rx:3,ry:3,lightAmount:25,darkAmount:10}},{}],669:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,e){return a.coerce(i,o,l,t,e)}for(var i,o,s=t.buttons||[],u=e.buttons=[],c=0;c<s.length;c++)if(i=s[c],o={},a.isPlainObject(i)){var h=n(\"step\");\"all\"!==h&&(!r||\"gregorian\"===r||\"month\"!==h&&\"year\"!==h?n(\"stepmode\"):o.stepmode=\"backward\",n(\"count\")),n(\"label\"),o._index=c,u.push(o)}return u}function i(t,e,r){for(var n=r.filter(function(r){return e[r].anchor===t._id}),i=0,a=0;a<n.length;a++){var o=e[n[a]].domain;o&&(i=Math.max(o[1],i))}return[t.domain[0],i+u.yPad]}var a=t(\"../../lib\"),o=t(\"../color\"),s=t(\"./attributes\"),l=t(\"./button_attributes\"),u=t(\"./constants\");e.exports=function(t,e,r,l,c){function h(t,e){return a.coerce(f,d,s,t,e)}var f=t.rangeselector||{},d=e.rangeselector={};if(h(\"visible\",n(f,d,c).length>0)){var p=i(e,r,l);h(\"x\",p[0]),h(\"y\",p[1]),a.noneOrAll(t,e,[\"x\",\"y\"]),h(\"xanchor\"),h(\"yanchor\"),a.coerceFont(h,\"font\",r.font);var m=h(\"bgcolor\");h(\"activecolor\",o.contrast(m,u.lightAmount,u.darkAmount)),h(\"bordercolor\"),h(\"borderwidth\")}}},{\"../../lib\":725,\"../color\":603,\"./attributes\":666,\"./button_attributes\":667,\"./constants\":668}],670:[function(t,e,r){\"use strict\";function n(t){for(var e=g.list(t,\"x\",!0),r=[],n=0;n<e.length;n++){var i=e[n];i.rangeselector&&i.rangeselector.visible&&r.push(i)}return r}function i(t){return t._id}function a(t,e,r){if(\"all\"===e.step)return!0===t.autorange;var n=Object.keys(r);return t.range[0]===r[n[0]]&&t.range[1]===r[n[1]]}function o(t,e,r){var n=t.selectAll(\"rect\").data([0]);n.enter().append(\"rect\").classed(\"selector-rect\",!0),n.attr(\"shape-rendering\",\"crispEdges\"),n.attr({rx:x.rx,ry:x.ry}),n.call(p.stroke,e.bordercolor).call(p.fill,s(e,r)).style(\"stroke-width\",e.borderwidth+\"px\")}function s(t,e){return e.isActive||e.isHovered?t.activecolor:t.bgcolor}function l(t,e,r,n){function i(t){v.convertToTspans(t,n)}var a=t.selectAll(\"text\").data([0]);a.enter().append(\"text\").classed(\"selector-text\",!0).classed(\"user-select-none\",!0),a.attr(\"text-anchor\",\"middle\"),a.call(m.font,e.font).text(u(r)).call(i)}function u(t){return t.label?t.label:\"all\"===t.step?\"all\":t.count+t.step.charAt(0)}function c(t,e,r,n){r.width=0,r.height=0;var i=r.borderwidth;e.each(function(){var t=h.select(this),e=t.select(\".selector-text\"),n=r.font.size*b,i=Math.max(n*v.lineCount(e),16)+3;r.height=Math.max(r.height,i)}),e.each(function(){var t=h.select(this),e=t.select(\".selector-rect\"),n=t.select(\".selector-text\"),a=n.node()&&m.bBox(n.node()).width,o=r.font.size*b,s=v.lineCount(n),l=Math.max(a+10,x.minButtonWidth);t.attr(\"transform\",\"translate(\"+(i+r.width)+\",\"+i+\")\"),e.attr({x:0,y:0,width:l,height:r.height}),v.positionText(n,l/2,r.height/2-(s-1)*o/2+3),r.width+=l+5}),e.selectAll(\"rect\").attr(\"height\",r.height);var a=t._fullLayout._size;r.lx=a.l+a.w*r.x,r.ly=a.t+a.h*(1-r.y);var o=\"left\";y.isRightAnchor(r)&&(r.lx-=r.width,o=\"right\"),y.isCenterAnchor(r)&&(r.lx-=r.width/2,o=\"center\");var s=\"top\";y.isBottomAnchor(r)&&(r.ly-=r.height,s=\"bottom\"),y.isMiddleAnchor(r)&&(r.ly-=r.height/2,s=\"middle\"),r.width=Math.ceil(r.width),r.height=Math.ceil(r.height),r.lx=Math.round(r.lx),r.ly=Math.round(r.ly),d.autoMargin(t,n+\"-range-selector\",{x:r.x,y:r.y,l:r.width*({right:1,center:.5}[o]||0),r:r.width*({left:1,center:.5}[o]||0),b:r.height*({top:1,middle:.5}[s]||0),t:r.height*({bottom:1,middle:.5}[s]||0)})}var h=t(\"d3\"),f=t(\"../../plotly\"),d=t(\"../../plots/plots\"),p=t(\"../color\"),m=t(\"../drawing\"),v=t(\"../../lib/svg_text_utils\"),g=t(\"../../plots/cartesian/axis_ids\"),y=t(\"../legend/anchor_utils\"),b=t(\"../../constants/alignment\").LINE_SPACING,x=t(\"./constants\"),_=t(\"./get_update_object\");e.exports=function(t){var e=t._fullLayout,r=e._infolayer.selectAll(\".rangeselector\").data(n(t),i);r.enter().append(\"g\").classed(\"rangeselector\",!0),r.exit().remove(),r.style({cursor:\"pointer\",\"pointer-events\":\"all\"}),r.each(function(e){var r=h.select(this),n=e,i=n.rangeselector,s=r.selectAll(\"g.button\").data(i.buttons);s.enter().append(\"g\").classed(\"button\",!0),s.exit().remove(),s.each(function(e){var r=h.select(this),s=_(n,e);e.isActive=a(n,e,s),r.call(o,i,e),r.call(l,i,e,t),r.on(\"click\",function(){t._dragged||f.relayout(t,s)}),r.on(\"mouseover\",function(){e.isHovered=!0,r.call(o,i,e)}),r.on(\"mouseout\",function(){e.isHovered=!1,r.call(o,i,e)})}),c(t,s,i,n._name),r.attr(\"transform\",\"translate(\"+i.lx+\",\"+i.ly+\")\")})}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axis_ids\":769,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":668,\"./get_update_object\":671,d3:121}],671:[function(t,e,r){\"use strict\";function n(t,e){var r,n=t.range,a=new Date(t.r2l(n[1])),o=e.step,s=e.count;switch(e.stepmode){case\"backward\":r=t.l2r(+i.time[o].utc.offset(a,-s));break;case\"todate\":var l=i.time[o].utc.offset(a,-s);r=t.l2r(+i.time[o].utc.ceil(l))}return[r,n[1]]}var i=t(\"d3\");e.exports=function(t,e){var r=t._name,i={};if(\"all\"===e.step)i[r+\".autorange\"]=!0;else{var a=n(t,e);i[r+\".range[0]\"]=a[0],i[r+\".range[1]\"]=a[1]}return i}},{d3:121}],672:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"rangeselector\",schema:{layout:{\"xaxis.rangeselector\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),draw:t(\"./draw\")}},{\"./attributes\":666,\"./defaults\":669,\"./draw\":670}],673:[function(t,e,r){\"use strict\";var n=t(\"../color/attributes\");e.exports={bgcolor:{valType:\"color\",dflt:n.background},bordercolor:{valType:\"color\",dflt:n.defaultLine},borderwidth:{valType:\"integer\",dflt:0,min:0},autorange:{valType:\"boolean\",dflt:!0},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},thickness:{valType:\"number\",dflt:.15,min:0,max:1},visible:{valType:\"boolean\",dflt:!0}}},{\"../color/attributes\":602}],674:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"./constants\");e.exports=function(t){for(var e=n.list(t,\"x\",!0),r=0;r<e.length;r++){var a=e[r],o=a[i.name];o&&o.visible&&o.autorange&&a._min.length&&a._max.length&&(o._input.autorange=!0,o._input.range=o.range=n.getAutoRange(a))}}},{\"../../plots/cartesian/axes\":766,\"./constants\":675}],675:[function(t,e,r){\"use strict\";e.exports={name:\"rangeslider\",containerClassName:\"rangeslider-container\",bgClassName:\"rangeslider-bg\",rangePlotClassName:\"rangeslider-rangeplot\",maskMinClassName:\"rangeslider-mask-min\",maskMaxClassName:\"rangeslider-mask-max\",slideBoxClassName:\"rangeslider-slidebox\",grabberMinClassName:\"rangeslider-grabber-min\",grabAreaMinClassName:\"rangeslider-grabarea-min\",handleMinClassName:\"rangeslider-handle-min\",grabberMaxClassName:\"rangeslider-grabber-max\",grabAreaMaxClassName:\"rangeslider-grabarea-max\",handleMaxClassName:\"rangeslider-handle-max\",maskColor:\"rgba(0,0,0,0.4)\",slideBoxFill:\"transparent\",slideBoxCursor:\"ew-resize\",grabAreaFill:\"transparent\",grabAreaCursor:\"col-resize\",grabAreaWidth:10,handleWidth:4,handleRadius:1,handleStrokeWidth:1,extraPad:15}},{}],676:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){function a(t,e){return n.coerce(o,l,i,t,e)}if(t[r].rangeslider){n.isPlainObject(t[r].rangeslider)||(t[r].rangeslider={});var o=t[r].rangeslider,s=e[r],l=s.rangeslider={};if(a(\"visible\")){if(a(\"bgcolor\",e.plot_bgcolor),a(\"bordercolor\"),a(\"borderwidth\"),a(\"thickness\"),a(\"autorange\",!s.isValidRange(o.range)),a(\"range\"),l.range){var u=l.range,c=s.range;u[0]=s.l2r(Math.min(s.r2l(u[0]),s.r2l(c[0]))),u[1]=s.l2r(Math.max(s.r2l(u[1]),s.r2l(c[1])))}s.cleanRange(\"rangeslider.range\"),l._input=o}}}},{\"../../lib\":725,\"./attributes\":673}],677:[function(t,e,r){\"use strict\";function n(t){var e=w.list({_fullLayout:t},\"x\",!0),r=A.name,n=[];if(t._has(\"gl2d\"))return n;for(var i=0;i<e.length;i++){var a=e[i];a[r]&&a[r].visible&&n.push(a)}return n}function i(t,e,r,n){var i=t.select(\"rect.\"+A.slideBoxClassName).node(),o=t.select(\"rect.\"+A.grabAreaMinClassName).node(),s=t.select(\"rect.\"+A.grabAreaMaxClassName).node();t.on(\"mousedown\",function(){function l(l){var u,c,y,b=+l.clientX-f;switch(h){case i:y=\"ew-resize\",u=p+b,c=v+b;break;case o:y=\"col-resize\",u=p+b,c=v;break;case s:y=\"col-resize\",u=p,c=v+b;break;default:y=\"ew-resize\",u=d,c=d+b}if(c<u){var x=c;c=u,u=x}n._pixelMin=u,n._pixelMax=c,k(m.select(g),y),a(t,e,r,n)}function u(){g.removeEventListener(\"mousemove\",l),g.removeEventListener(\"mouseup\",u),y.removeElement(g)}var c=m.event,h=c.target,f=c.clientX,d=f-t.node().getBoundingClientRect().left,p=n.d2p(r._rl[0]),v=n.d2p(r._rl[1]),g=M.coverSlip();g.addEventListener(\"mousemove\",l),g.addEventListener(\"mouseup\",u)})}function a(t,e,r,n){function i(t){return r.l2r(y.constrain(t,n._rl[0],n._rl[1]))}var a=i(n.p2d(n._pixelMin)),o=i(n.p2d(n._pixelMax));window.requestAnimationFrame(function(){v.relayout(e,r._name+\".range\",[a,o])})}function o(t,e,r,n){function i(t){return y.constrain(t,0,n._width)}function a(t){return y.constrain(t,-o,n._width+o)}var o=A.handleWidth/2,s=i(n.d2p(r._rl[0])),l=i(n.d2p(r._rl[1]));t.select(\"rect.\"+A.slideBoxClassName).attr(\"x\",s).attr(\"width\",l-s),t.select(\"rect.\"+A.maskMinClassName).attr(\"width\",s),t.select(\"rect.\"+A.maskMaxClassName).attr(\"x\",l).attr(\"width\",n._width-l);var u=Math.round(a(s-o))-.5,c=Math.round(a(l-o))+.5;t.select(\"g.\"+A.grabberMinClassName).attr(\"transform\",\"translate(\"+u+\",0.5)\"),t.select(\"g.\"+A.grabberMaxClassName).attr(\"transform\",\"translate(\"+c+\",0.5)\")}function s(t,e,r,n){var i=t.selectAll(\"rect.\"+A.bgClassName).data([0]);i.enter().append(\"rect\").classed(A.bgClassName,!0).attr({x:0,y:0,\"shape-rendering\":\"crispEdges\"});var a=n.borderwidth%2==0?n.borderwidth:n.borderwidth-1,o=-n._offsetShift,s=b.crispRound(e,n.borderwidth);i.attr({width:n._width+a,height:n._height+a,transform:\"translate(\"+o+\",\"+o+\")\",fill:n.bgcolor,stroke:n.bordercolor,\"stroke-width\":s})}function l(t,e,r,n){\n",
       "var i=e._fullLayout,a=i._topdefs.selectAll(\"#\"+n._clipId).data([0]);a.enter().append(\"clipPath\").attr(\"id\",n._clipId).append(\"rect\").attr({x:0,y:0}),a.select(\"rect\").attr({width:n._width,height:n._height})}function u(t,e,r,n){var i=w.getSubplots(e,r),a=e.calcdata,o=t.selectAll(\"g.\"+A.rangePlotClassName).data(i,y.identity);o.enter().append(\"g\").attr(\"class\",function(t){return A.rangePlotClassName+\" \"+t}).call(b.setClipUrl,n._clipId),o.order(),o.exit().remove();var s;o.each(function(t,i){var o=m.select(this),l=0===i,u=w.getFromId(e,t,\"y\"),h=u._name,f={data:[],layout:{xaxis:{type:r.type,domain:[0,1],range:n.range.slice(),calendar:r.calendar},width:n._width,height:n._height,margin:{t:0,b:0,l:0,r:0}}};f.layout[h]={type:u.type,domain:[0,1],range:u.range.slice(),calendar:u.calendar},g.supplyDefaults(f);var d=f._fullLayout.xaxis,p=f._fullLayout[h],v={id:t,plotgroup:o,xaxis:d,yaxis:p};l?s=v:(v.mainplot=\"xy\",v.mainplotinfo=s),_.rangePlot(e,v,c(a,t))})}function c(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n],a=i[0].trace;a.xaxis+a.yaxis===e&&r.push(i)}return r}function h(t,e,r,n){var i=t.selectAll(\"rect.\"+A.maskMinClassName).data([0]);i.enter().append(\"rect\").classed(A.maskMinClassName,!0).attr({x:0,y:0}).attr(\"shape-rendering\",\"crispEdges\"),i.attr(\"height\",n._height).call(x.fill,A.maskColor);var a=t.selectAll(\"rect.\"+A.maskMaxClassName).data([0]);a.enter().append(\"rect\").classed(A.maskMaxClassName,!0).attr(\"y\",0).attr(\"shape-rendering\",\"crispEdges\"),a.attr(\"height\",n._height).call(x.fill,A.maskColor)}function f(t,e,r,n){if(!e._context.staticPlot){var i=t.selectAll(\"rect.\"+A.slideBoxClassName).data([0]);i.enter().append(\"rect\").classed(A.slideBoxClassName,!0).attr(\"y\",0).attr(\"cursor\",A.slideBoxCursor).attr(\"shape-rendering\",\"crispEdges\"),i.attr({height:n._height,fill:A.slideBoxFill})}}function d(t,e,r,n){var i=t.selectAll(\"g.\"+A.grabberMinClassName).data([0]);i.enter().append(\"g\").classed(A.grabberMinClassName,!0);var a=t.selectAll(\"g.\"+A.grabberMaxClassName).data([0]);a.enter().append(\"g\").classed(A.grabberMaxClassName,!0);var o={x:0,width:A.handleWidth,rx:A.handleRadius,fill:x.background,stroke:x.defaultLine,\"stroke-width\":A.handleStrokeWidth,\"shape-rendering\":\"crispEdges\"},s={y:Math.round(n._height/4),height:Math.round(n._height/2)},l=i.selectAll(\"rect.\"+A.handleMinClassName).data([0]);l.enter().append(\"rect\").classed(A.handleMinClassName,!0).attr(o),l.attr(s);var u=a.selectAll(\"rect.\"+A.handleMaxClassName).data([0]);if(u.enter().append(\"rect\").classed(A.handleMaxClassName,!0).attr(o),u.attr(s),!e._context.staticPlot){var c={width:A.grabAreaWidth,x:0,y:0,fill:A.grabAreaFill,cursor:A.grabAreaCursor},h=i.selectAll(\"rect.\"+A.grabAreaMinClassName).data([0]);h.enter().append(\"rect\").classed(A.grabAreaMinClassName,!0).attr(c),h.attr(\"height\",n._height);var f=a.selectAll(\"rect.\"+A.grabAreaMaxClassName).data([0]);f.enter().append(\"rect\").classed(A.grabAreaMaxClassName,!0).attr(c),f.attr(\"height\",n._height)}}function p(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(A.name)&&g.autoMargin(t,i)}}var m=t(\"d3\"),v=t(\"../../plotly\"),g=t(\"../../plots/plots\"),y=t(\"../../lib\"),b=t(\"../drawing\"),x=t(\"../color\"),_=t(\"../../plots/cartesian\"),w=t(\"../../plots/cartesian/axes\"),M=t(\"../dragelement\"),k=t(\"../../lib/setcursor\"),A=t(\"./constants\");e.exports=function(t){function e(t){return t._name}var r=t._fullLayout,a=n(r),c=r._infolayer.selectAll(\"g.\"+A.containerClassName).data(a,e);c.enter().append(\"g\").classed(A.containerClassName,!0).attr(\"pointer-events\",\"all\"),c.exit().each(function(t){var e=m.select(this),n=t[A.name];e.remove(),r._topdefs.select(\"#\"+n._clipId).remove()}),c.exit().size()&&p(t),0!==a.length&&c.each(function(e){var n=m.select(this),a=e[A.name],c=r[w.id2name(e.anchor)],p=r.margin,v=r._size,y=e.domain,b=c.domain,x=(e._boundingBox||{}).height||0;a._id=A.name+e._id,a._clipId=a._id+\"-\"+r._uid,a._width=v.w*(y[1]-y[0]),a._height=(r.height-p.b-p.t)*a.thickness,a._offsetShift=Math.floor(a.borderwidth/2);var _=Math.round(p.l+v.w*y[0]),M=Math.round(p.t+v.h*(1-b[0])+x+a._offsetShift+A.extraPad);n.attr(\"transform\",\"translate(\"+_+\",\"+M+\")\");var k=e.r2l(a.range[0]),T=e.r2l(a.range[1]),S=T-k;a.p2d=function(t){return t/a._width*S+k},a.d2p=function(t){return(t-k)/S*a._width},a._rl=[k,T],n.call(s,t,e,a).call(l,t,e,a).call(u,t,e,a).call(h,t,e,a).call(f,t,e,a).call(d,t,e,a),i(n,t,e,a),o(n,t,e,a),g.autoMargin(t,a._id,{x:y[0],y:b[0],l:0,r:0,t:0,b:a._height+p.b+x,pad:A.extraPad+2*a._offsetShift})})}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../plotly\":761,\"../../plots/cartesian\":776,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":675,d3:121}],678:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"rangeslider\",schema:{layout:{\"xaxis.rangeslider\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:t(\"./draw\")}},{\"./attributes\":673,\"./calc_autorange\":674,\"./defaults\":676,\"./draw\":677}],679:[function(t,e,r){\"use strict\";var n=t(\"../annotations/attributes\"),i=t(\"../../traces/scatter/attributes\").line,a=t(\"../drawing/attributes\").dash,o=t(\"../../lib/extend\").extendFlat;e.exports={_isLinkedToArray:\"shape\",visible:{valType:\"boolean\",dflt:!0},type:{valType:\"enumerated\",values:[\"circle\",\"rect\",\"path\",\"line\"]},layer:{valType:\"enumerated\",values:[\"below\",\"above\"],dflt:\"above\"},xref:o({},n.xref,{}),x0:{valType:\"any\"},x1:{valType:\"any\"},yref:o({},n.yref,{}),y0:{valType:\"any\"},y1:{valType:\"any\"},path:{valType:\"string\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},line:{color:i.color,width:i.width,dash:a},fillcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"}}},{\"../../lib/extend\":716,\"../../traces/scatter/attributes\":1027,\"../annotations/attributes\":586,\"../drawing/attributes\":626}],680:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=\"category\"===t.type?t.r2c:t.d2c;if(void 0!==e)return[a(e),a(r)];if(n){var l,u,c,h,f,d=1/0,p=-1/0,m=n.match(o.segmentRE);for(\"date\"===t.type&&(a=s.decodeDate(a)),l=0;l<m.length;l++)u=m[l],void 0!==(c=i[u.charAt(0)].drawn)&&(!(h=m[l].substr(1).match(o.paramRE))||h.length<c||(f=a(h[c]),f<d&&(d=f),f>p&&(p=f)));return p>=d?[d,p]:void 0}}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"./constants\"),s=t(\"./helpers\");e.exports=function(t){var e=t._fullLayout,r=i.filterVisible(e.shapes);if(r.length&&t._fullData.length)for(var s=0;s<r.length;s++){var l,u,c=r[s],h=c.line.width/2;\"paper\"!==c.xref&&(l=a.getFromId(t,c.xref),(u=n(l,c.x0,c.x1,c.path,o.paramIsX))&&a.expand(l,u,{ppad:h})),\"paper\"!==c.yref&&(l=a.getFromId(t,c.yref),(u=n(l,c.y0,c.y1,c.path,o.paramIsY))&&a.expand(l,u,{ppad:h}))}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./constants\":681,\"./helpers\":684}],681:[function(t,e,r){\"use strict\";e.exports={segmentRE:/[MLHVQCTSZ][^MLHVQCTSZ]*/g,paramRE:/[^\\s,]+/g,paramIsX:{M:{0:!0,drawn:0},L:{0:!0,drawn:0},H:{0:!0,drawn:0},V:{},Q:{0:!0,2:!0,drawn:2},C:{0:!0,2:!0,4:!0,drawn:4},T:{0:!0,drawn:0},S:{0:!0,2:!0,drawn:2},Z:{}},paramIsY:{M:{1:!0,drawn:1},L:{1:!0,drawn:1},H:{},V:{0:!0,drawn:0},Q:{1:!0,3:!0,drawn:3},C:{1:!0,3:!0,5:!0,drawn:5},T:{1:!0,drawn:1},S:{1:!0,3:!0,drawn:5},Z:{}},numParams:{M:2,L:2,H:1,V:1,Q:4,C:6,T:2,S:4,Z:0}}},{}],682:[function(t,e,r){\"use strict\";var n=t(\"../../plots/array_container_defaults\"),i=t(\"./shape_defaults\");e.exports=function(t,e){n(t,e,{name:\"shapes\",handleItemDefaults:i})}},{\"../../plots/array_container_defaults\":763,\"./shape_defaults\":686}],683:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;e._shapeUpperLayer.selectAll(\"path\").remove(),e._shapeLowerLayer.selectAll(\"path\").remove(),e._shapeSubplotLayers.selectAll(\"path\").remove();for(var r=0;r<e.shapes.length;r++)e.shapes[r].visible&&i(t,r)}function i(t,e){function r(r){var n={\"data-index\":e,\"fill-rule\":\"evenodd\",d:o(t,i)},s=i.line.width?i.line.color:\"rgba(0,0,0,0)\",l=r.append(\"path\").attr(n).style(\"opacity\",i.opacity).call(f.stroke,s).call(f.fill,i.fillcolor).call(d.dashLine,i.line.dash,i.line.width),u=(i.xref+i.yref).replace(/paper/g,\"\");l.call(d.setClipUrl,u?\"clip\"+t._fullLayout._uid+u:null),t._context.edits.shapePosition&&a(t,l,i,e)}t._fullLayout._paper.selectAll('.shapelayer [data-index=\"'+e+'\"]').remove();var n=(t.layout.shapes||[])[e],i=t._fullLayout.shapes[e];if(n&&!1!==i.visible)if(\"below\"!==i.layer)r(t._fullLayout._shapeUpperLayer);else if(\"paper\"===i.xref||\"paper\"===i.yref)r(t._fullLayout._shapeLowerLayer);else{var s=t._fullLayout._plots[i.xref+i.yref];if(s){var l=s.mainplot||s;r(l.shapelayer)}else r(t._fullLayout._shapeLowerLayer)}}function a(t,e,r,n){function i(t){var r=Z.right-Z.left,n=Z.bottom-Z.top,i=t.clientX-Z.left,a=t.clientY-Z.top,o=r>Y&&n>X&&!t.shiftKey?p.getCursor(i/r,1-a/n):\"move\";m(e,o),G=o.split(\"-\")[0]}function a(e){N=h.getFromId(t,r.xref),B=h.getFromId(t,r.yref),U=g.getDataToPixel(t,N),V=g.getDataToPixel(t,B,!0),H=g.getPixelToData(t,N),q=g.getPixelToData(t,B,!0);var a=\"shapes[\"+n+\"]\";\"path\"===r.type?(F=r.path,j=a+\".path\"):(v=U(r.x0),y=V(r.y0),b=U(r.x1),x=V(r.y1),_=a+\".x0\",w=a+\".y0\",M=a+\".x1\",k=a+\".y1\"),v<b?(S=v,z=a+\".x0\",O=\"x0\",E=b,I=a+\".x1\",R=\"x1\"):(S=b,z=a+\".x1\",O=\"x1\",E=v,I=a+\".x0\",R=\"x0\"),y<x?(A=y,L=a+\".y0\",D=\"y0\",T=x,C=a+\".y1\",P=\"y1\"):(A=x,L=a+\".y1\",D=\"y1\",T=y,C=a+\".y0\",P=\"y0\"),d={},i(e),W.moveFn=\"move\"===G?c:f}function s(r){m(e),r&&u.relayout(t,d)}function c(n,i){if(\"path\"===r.type){var a=function(t){return H(U(t)+n)};N&&\"date\"===N.type&&(a=g.encodeDate(a));var s=function(t){return q(V(t)+i)};B&&\"date\"===B.type&&(s=g.encodeDate(s)),r.path=l(F,a,s),d[j]=r.path}else d[_]=r.x0=H(v+n),d[w]=r.y0=q(y+i),d[M]=r.x1=H(b+n),d[k]=r.y1=q(x+i);e.attr(\"d\",o(t,r))}function f(n,i){if(\"path\"===r.type){var a=function(t){return H(U(t)+n)};N&&\"date\"===N.type&&(a=g.encodeDate(a));var s=function(t){return q(V(t)+i)};B&&\"date\"===B.type&&(s=g.encodeDate(s)),r.path=l(F,a,s),d[j]=r.path}else{var u=~G.indexOf(\"n\")?A+i:A,c=~G.indexOf(\"s\")?T+i:T,h=~G.indexOf(\"w\")?S+n:S,f=~G.indexOf(\"e\")?E+n:E;c-u>X&&(d[L]=r[D]=q(u),d[C]=r[P]=q(c)),f-h>Y&&(d[z]=r[O]=H(h),d[I]=r[R]=H(f))}e.attr(\"d\",o(t,r))}var d,v,y,b,x,_,w,M,k,A,T,S,E,L,C,z,I,D,P,O,R,F,j,N,B,U,V,H,q,G,Y=10,X=10,W={element:e.node(),gd:t,prepFn:a,doneFn:s},Z=W.element.getBoundingClientRect();p.init(W),e.node().onmousemove=i}function o(t,e){var r,n,i,a,o=e.type,l=h.getFromId(t,e.xref),u=h.getFromId(t,e.yref),c=t._fullLayout._size;if(l?(r=g.shapePositionToRange(l),n=function(t){return l._offset+l.r2p(r(t,!0))}):n=function(t){return c.l+c.w*t},u?(i=g.shapePositionToRange(u),a=function(t){return u._offset+u.r2p(i(t,!0))}):a=function(t){return c.t+c.h*(1-t)},\"path\"===o)return l&&\"date\"===l.type&&(n=g.decodeDate(n)),u&&\"date\"===u.type&&(a=g.decodeDate(a)),s(e.path,n,a);var f=n(e.x0),d=n(e.x1),p=a(e.y0),m=a(e.y1);if(\"line\"===o)return\"M\"+f+\",\"+p+\"L\"+d+\",\"+m;if(\"rect\"===o)return\"M\"+f+\",\"+p+\"H\"+d+\"V\"+m+\"H\"+f+\"Z\";var v=(f+d)/2,y=(p+m)/2,b=Math.abs(v-f),x=Math.abs(y-p),_=\"A\"+b+\",\"+x,w=v+b+\",\"+y;return\"M\"+w+_+\" 0 1,1 \"+v+\",\"+(y-x)+_+\" 0 0,1 \"+w+\"Z\"}function s(t,e,r){return t.replace(v.segmentRE,function(t){var n=0,i=t.charAt(0),a=v.paramIsX[i],o=v.paramIsY[i],s=v.numParams[i],l=t.substr(1).replace(v.paramRE,function(t){return a[n]?t=e(t):o[n]&&(t=r(t)),n++,n>s&&(t=\"X\"),t});return n>s&&(l=l.replace(/[\\s,]*X.*/,\"\"),c.log(\"Ignoring extra params in segment \"+t)),i+l})}function l(t,e,r){return t.replace(v.segmentRE,function(t){var n=0,i=t.charAt(0),a=v.paramIsX[i],o=v.paramIsY[i],s=v.numParams[i];return i+t.substr(1).replace(v.paramRE,function(t){return n>=s?t:(a[n]?t=e(t):o[n]&&(t=r(t)),n++,t)})})}var u=t(\"../../plotly\"),c=t(\"../../lib\"),h=t(\"../../plots/cartesian/axes\"),f=t(\"../color\"),d=t(\"../drawing\"),p=t(\"../dragelement\"),m=t(\"../../lib/setcursor\"),v=t(\"./constants\"),g=t(\"./helpers\");e.exports={draw:n,drawOne:i}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":681,\"./helpers\":684}],684:[function(t,e,r){\"use strict\";r.rangeToShapePosition=function(t){return\"log\"===t.type?t.r2d:function(t){return t}},r.shapePositionToRange=function(t){return\"log\"===t.type?t.d2r:function(t){return t}},r.decodeDate=function(t){return function(e){return e.replace&&(e=e.replace(\"_\",\" \")),t(e)}},r.encodeDate=function(t){return function(e){return t(e).replace(\" \",\"_\")}},r.getDataToPixel=function(t,e,n){var i,a=t._fullLayout._size;if(e){var o=r.shapePositionToRange(e);i=function(t){return e._offset+e.r2p(o(t,!0))},\"date\"===e.type&&(i=r.decodeDate(i))}else i=n?function(t){return a.t+a.h*(1-t)}:function(t){return a.l+a.w*t};return i},r.getPixelToData=function(t,e,n){var i,a=t._fullLayout._size;if(e){var o=r.rangeToShapePosition(e);i=function(t){return o(e.p2r(t-e._offset))}}else i=n?function(t){return 1-(t-a.t)/a.h}:function(t){return(t-a.l)/a.w};return i}},{}],685:[function(t,e,r){\"use strict\";var n=t(\"./draw\");e.exports={moduleType:\"component\",name:\"shapes\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:n.draw,drawOne:n.drawOne}},{\"./attributes\":679,\"./calc_autorange\":680,\"./defaults\":682,\"./draw\":683}],686:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"./attributes\"),o=t(\"./helpers\");e.exports=function(t,e,r,s,l){function u(r,i){return n.coerce(t,e,a,r,i)}if(s=s||{},l=l||{},!u(\"visible\",!l.itemIsNotPlainObject))return e;u(\"layer\"),u(\"opacity\"),u(\"fillcolor\"),u(\"line.color\"),u(\"line.width\"),u(\"line.dash\");for(var c=t.path?\"path\":\"rect\",h=u(\"type\",c),f=[\"x\",\"y\"],d=0;d<2;d++){var p=f[d],m={_fullLayout:r},v=i.coerceRef(t,e,m,p,\"\",\"paper\");if(\"path\"!==h){var g,y,b;\"paper\"!==v?(g=i.getFromId(m,v),b=o.rangeToShapePosition(g),y=o.shapePositionToRange(g)):y=b=n.identity;var x=p+\"0\",_=p+\"1\",w=t[x],M=t[_];t[x]=y(t[x],!0),t[_]=y(t[_],!0),i.coercePosition(e,m,u,v,x,.25),i.coercePosition(e,m,u,v,_,.75),e[x]=b(e[x]),e[_]=b(e[_]),t[x]=w,t[_]=M}}return\"path\"===h?u(\"path\"):n.noneOrAll(t,e,[\"x0\",\"x1\",\"y0\",\"y1\"]),e}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./attributes\":679,\"./helpers\":684}],687:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../../plots/pad_attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"../../lib/extend\").extendDeep,s=t(\"../../plots/animation_attributes\"),l=t(\"./constants\"),u={_isLinkedToArray:\"step\",method:{valType:\"enumerated\",values:[\"restyle\",\"relayout\",\"animate\",\"update\",\"skip\"],dflt:\"restyle\"},args:{valType:\"info_array\",freeLength:!0,items:[{valType:\"any\"},{valType:\"any\"},{valType:\"any\"}]},label:{valType:\"string\"},value:{valType:\"string\"},execute:{valType:\"boolean\",dflt:!0}};e.exports={_isLinkedToArray:\"slider\",visible:{valType:\"boolean\",dflt:!0},active:{valType:\"number\",min:0,dflt:0},steps:u,lenmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"fraction\"},len:{valType:\"number\",min:0,dflt:1},x:{valType:\"number\",min:-2,max:3,dflt:0},pad:o({},i,{},{t:{dflt:20}}),xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3,dflt:0},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"top\"},transition:{duration:{valType:\"number\",min:0,dflt:150},easing:{valType:\"enumerated\",values:s.transition.easing.values,dflt:\"cubic-in-out\"}},currentvalue:{visible:{valType:\"boolean\",dflt:!0},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},offset:{valType:\"number\",dflt:10},prefix:{valType:\"string\"},suffix:{valType:\"string\"},font:a({},n,{})},font:a({},n,{}),activebgcolor:{valType:\"color\",dflt:l.gripBgActiveColor},bgcolor:{valType:\"color\",dflt:l.railBgColor},bordercolor:{valType:\"color\",dflt:l.railBorderColor},borderwidth:{valType:\"number\",min:0,dflt:l.railBorderWidth},ticklen:{valType:\"number\",min:0,dflt:l.tickLength},tickcolor:{valType:\"color\",dflt:l.tickColor},tickwidth:{valType:\"number\",min:0,dflt:1},minorticklen:{valType:\"number\",min:0,dflt:l.minorTickLength}}},{\"../../lib/extend\":716,\"../../plots/animation_attributes\":762,\"../../plots/font_attributes\":790,\"../../plots/pad_attributes\":828,\"./constants\":688}],688:[function(t,e,r){\"use strict\";e.exports={name:\"sliders\",containerClassName:\"slider-container\",groupClassName:\"slider-group\",inputAreaClass:\"slider-input-area\",railRectClass:\"slider-rail-rect\",railTouchRectClass:\"slider-rail-touch-rect\",gripRectClass:\"slider-grip-rect\",tickRectClass:\"slider-tick-rect\",inputProxyClass:\"slider-input-proxy\",labelsClass:\"slider-labels\",labelGroupClass:\"slider-label-group\",labelClass:\"slider-label\",currentValueClass:\"slider-current-value\",railHeight:5,menuIndexAttrName:\"slider-active-index\",autoMarginIdRoot:\"slider-\",minWidth:30,minHeight:30,textPadX:40,arrowOffsetX:4,railRadius:2,railWidth:5,railBorder:4,railBorderWidth:1,railBorderColor:\"#bec8d9\",railBgColor:\"#f8fafc\",railInset:8,stepInset:10,gripRadius:10,gripWidth:20,gripHeight:20,gripBorder:20,gripBorderWidth:1,gripBorderColor:\"#bec8d9\",gripBgColor:\"#f6f8fa\",gripBgActiveColor:\"#dbdde0\",labelPadding:8,labelOffset:0,tickWidth:1,tickColor:\"#333\",tickOffset:25,tickLength:7,minorTickOffset:25,minorTickColor:\"#333\",minorTickLength:4,currentValuePadding:8,currentValueInset:0}},{}],689:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return a.coerce(t,e,s,r,n)}n(\"visible\",i(t,e).length>0)&&(n(\"active\"),n(\"x\"),n(\"y\"),a.noneOrAll(t,e,[\"x\",\"y\"]),n(\"xanchor\"),n(\"yanchor\"),n(\"len\"),n(\"lenmode\"),n(\"pad.t\"),n(\"pad.r\"),n(\"pad.b\"),n(\"pad.l\"),a.coerceFont(n,\"font\",r.font),n(\"currentvalue.visible\")&&(n(\"currentvalue.xanchor\"),n(\"currentvalue.prefix\"),n(\"currentvalue.suffix\"),n(\"currentvalue.offset\"),a.coerceFont(n,\"currentvalue.font\",e.font)),n(\"transition.duration\"),n(\"transition.easing\"),n(\"bgcolor\"),n(\"activebgcolor\"),n(\"bordercolor\"),n(\"borderwidth\"),n(\"ticklen\"),n(\"tickwidth\"),n(\"tickcolor\"),n(\"minorticklen\"))}function i(t,e){function r(t,e){return a.coerce(n,i,c,t,e)}for(var n,i,o=t.steps||[],s=e.steps=[],l=0;l<o.length;l++)n=o[l],i={},r(\"method\"),a.isPlainObject(n)&&(\"skip\"===i.method||Array.isArray(n.args))&&(r(\"args\"),r(\"label\",\"step-\"+l),r(\"value\",i.label),r(\"execute\"),s.push(i));return s}var a=t(\"../../lib\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\"),l=t(\"./constants\"),u=l.name,c=s.steps;e.exports=function(t,e){o(t,e,{name:u,handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"./attributes\":687,\"./constants\":688}],690:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t[E.name],n=[],i=0;i<r.length;i++){var a=r[i];a.visible&&a.steps.length&&(a.gd=e,n.push(a))}return n}function i(t){return t._index}function a(t,e){var r=A.tester.selectAll(\"g.\"+E.labelGroupClass).data(e.steps);r.enter().append(\"g\").classed(E.labelGroupClass,!0);var n=0,i=0;r.each(function(t){var r=w.select(this),a=u(r,{step:t},e),o=a.node();if(o){var s=A.bBox(o);i=Math.max(i,s.height),n=Math.max(n,s.width)}}),r.remove(),e.inputAreaWidth=Math.max(E.railWidth,E.gripHeight);var a=t._fullLayout._size;e.lx=a.l+a.w*e.x,e.ly=a.t+a.h*(1-e.y),\"fraction\"===e.lenmode?e.outerLength=Math.round(a.w*e.len):e.outerLength=e.len,e.lenPad=Math.round(.5*E.gripWidth),e.inputAreaStart=0,e.inputAreaLength=Math.round(e.outerLength-e.pad.l-e.pad.r);var o=e.inputAreaLength-2*E.stepInset,l=o/(e.steps.length-1),c=n+E.labelPadding;if(e.labelStride=Math.max(1,Math.ceil(c/l)),e.labelHeight=i,e.currentValueMaxWidth=0,e.currentValueHeight=0,e.currentValueTotalHeight=0,e.currentValueMaxLines=1,e.currentvalue.visible){var h=A.tester.append(\"g\");r.each(function(t){var r=s(h,e,t.label),n=r.node()&&A.bBox(r.node())||{width:0,height:0},i=T.lineCount(r);e.currentValueMaxWidth=Math.max(e.currentValueMaxWidth,Math.ceil(n.width)),e.currentValueHeight=Math.max(e.currentValueHeight,Math.ceil(n.height)),e.currentValueMaxLines=Math.max(e.currentValueMaxLines,i)}),e.currentValueTotalHeight=e.currentValueHeight+e.currentvalue.offset,h.remove()}e.height=e.currentValueTotalHeight+E.tickOffset+e.ticklen+E.labelOffset+e.labelHeight+e.pad.t+e.pad.b;var f=\"left\";S.isRightAnchor(e)&&(e.lx-=e.outerLength,f=\"right\"),S.isCenterAnchor(e)&&(e.lx-=e.outerLength/2,f=\"center\");var d=\"top\";S.isBottomAnchor(e)&&(e.ly-=e.height,d=\"bottom\"),S.isMiddleAnchor(e)&&(e.ly-=e.height/2,d=\"middle\"),e.outerLength=Math.ceil(e.outerLength),e.height=Math.ceil(e.height),e.lx=Math.round(e.lx),e.ly=Math.round(e.ly),M.autoMargin(t,E.autoMarginIdRoot+e._index,{x:e.x,y:e.y,l:e.outerLength*({right:1,center:.5}[f]||0),r:e.outerLength*({left:1,center:.5}[f]||0),b:e.height*({top:1,middle:.5}[d]||0),t:e.height*({bottom:1,middle:.5}[d]||0)})}function o(t,e,r){r.active>=r.steps.length&&(r.active=0),e.call(s,r).call(x,r).call(c,r).call(p,r).call(b,t,r).call(l,t,r),A.setTranslate(e,r.lx+r.pad.l,r.ly+r.pad.t),e.call(v,r,r.active/(r.steps.length-1),!1),e.call(s,r)}function s(t,e,r){if(e.currentvalue.visible){var n,i,a=t.selectAll(\"text\").data([0]);switch(e.currentvalue.xanchor){case\"right\":n=e.inputAreaLength-E.currentValueInset-e.currentValueMaxWidth,i=\"left\";break;case\"center\":n=.5*e.inputAreaLength,i=\"middle\";break;default:n=E.currentValueInset,i=\"left\"}a.enter().append(\"text\").classed(E.labelClass,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":i,\"data-notex\":1});var o=e.currentvalue.prefix?e.currentvalue.prefix:\"\";if(\"string\"==typeof r)o+=r;else{o+=e.steps[e.active].label}e.currentvalue.suffix&&(o+=e.currentvalue.suffix),a.call(A.font,e.currentvalue.font).text(o).call(T.convertToTspans,e.gd);var s=T.lineCount(a),l=(e.currentValueMaxLines+1-s)*e.currentvalue.font.size*L;return T.positionText(a,n,l),a}}function l(t,e,r){var n=t.selectAll(\"rect.\"+E.gripRectClass).data([0]);n.enter().append(\"rect\").classed(E.gripRectClass,!0).call(d,e,t,r).style(\"pointer-events\",\"all\"),n.attr({width:E.gripWidth,height:E.gripHeight,rx:E.gripRadius,ry:E.gripRadius}).call(k.stroke,r.bordercolor).call(k.fill,r.bgcolor).style(\"stroke-width\",r.borderwidth+\"px\")}function u(t,e,r){var n=t.selectAll(\"text\").data([0]);return n.enter().append(\"text\").classed(E.labelClass,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":\"middle\",\"data-notex\":1}),n.call(A.font,r.font).text(e.step.label).call(T.convertToTspans,r.gd),n}function c(t,e){var r=t.selectAll(\"g.\"+E.labelsClass).data([0]);r.enter().append(\"g\").classed(E.labelsClass,!0);var n=r.selectAll(\"g.\"+E.labelGroupClass).data(e.labelSteps);n.enter().append(\"g\").classed(E.labelGroupClass,!0),n.exit().remove(),n.each(function(t){var r=w.select(this);r.call(u,t,e),A.setTranslate(r,g(e,t.fraction),E.tickOffset+e.ticklen+e.font.size*L+E.labelOffset+e.currentValueTotalHeight)})}function h(t,e,r,n,i){var a=Math.round(n*(r.steps.length-1));a!==r.active&&f(t,e,r,a,!0,i)}function f(t,e,r,n,i,a){var o=r.active;r._input.active=r.active=n;var l=r.steps[r.active];e.call(v,r,r.active/(r.steps.length-1),a),e.call(s,r),t.emit(\"plotly_sliderchange\",{slider:r,step:r.steps[r.active],interaction:i,previousActive:o}),l&&l.method&&i&&(e._nextMethod?(e._nextMethod.step=l,e._nextMethod.doCallback=i,e._nextMethod.doTransition=a):(e._nextMethod={step:l,doCallback:i,doTransition:a},e._nextMethodRaf=window.requestAnimationFrame(function(){var r=e._nextMethod.step;r.method&&(r.execute&&M.executeAPICommand(t,r.method,r.args),e._nextMethod=null,e._nextMethodRaf=null)})))}function d(t,e,r){function n(){return r.data()[0]}var i=r.node(),a=w.select(e);t.on(\"mousedown\",function(){var t=n();e.emit(\"plotly_sliderstart\",{slider:t});var o=r.select(\".\"+E.gripRectClass);w.event.stopPropagation(),w.event.preventDefault(),o.call(k.fill,t.activebgcolor);var s=y(t,w.mouse(i)[0]);h(e,r,t,s,!0),t._dragging=!0,a.on(\"mousemove\",function(){var t=n(),a=y(t,w.mouse(i)[0]);h(e,r,t,a,!1)}),a.on(\"mouseup\",function(){var t=n();t._dragging=!1,o.call(k.fill,t.bgcolor),a.on(\"mouseup\",null),a.on(\"mousemove\",null),e.emit(\"plotly_sliderend\",{slider:t,step:t.steps[t.active]})})})}function p(t,e){var r=t.selectAll(\"rect.\"+E.tickRectClass).data(e.steps);r.enter().append(\"rect\").classed(E.tickRectClass,!0),r.exit().remove(),r.attr({width:e.tickwidth+\"px\",\"shape-rendering\":\"crispEdges\"}),r.each(function(t,r){var n=r%e.labelStride==0,i=w.select(this);i.attr({height:n?e.ticklen:e.minorticklen}).call(k.fill,e.tickcolor),A.setTranslate(i,g(e,r/(e.steps.length-1))-.5*e.tickwidth,(n?E.tickOffset:E.minorTickOffset)+e.currentValueTotalHeight)})}function m(t){t.labelSteps=[];for(var e=t.steps.length,r=0;r<e;r+=t.labelStride)t.labelSteps.push({fraction:r/(e-1),step:t.steps[r]})}function v(t,e,r,n){var i=t.select(\"rect.\"+E.gripRectClass),a=g(e,r);if(!e._invokingCommand){var o=i;n&&e.transition.duration>0&&(o=o.transition().duration(e.transition.duration).ease(e.transition.easing)),o.attr(\"transform\",\"translate(\"+(a-.5*E.gripWidth)+\",\"+e.currentValueTotalHeight+\")\")}}function g(t,e){return t.inputAreaStart+E.stepInset+(t.inputAreaLength-2*E.stepInset)*Math.min(1,Math.max(0,e))}function y(t,e){return Math.min(1,Math.max(0,(e-E.stepInset-t.inputAreaStart)/(t.inputAreaLength-2*E.stepInset-2*t.inputAreaStart)))}function b(t,e,r){var n=t.selectAll(\"rect.\"+E.railTouchRectClass).data([0]);n.enter().append(\"rect\").classed(E.railTouchRectClass,!0).call(d,e,t,r).style(\"pointer-events\",\"all\"),n.attr({width:r.inputAreaLength,height:Math.max(r.inputAreaWidth,E.tickOffset+r.ticklen+r.labelHeight)}).call(k.fill,r.bgcolor).attr(\"opacity\",0),A.setTranslate(n,0,r.currentValueTotalHeight)}function x(t,e){var r=t.selectAll(\"rect.\"+E.railRectClass).data([0]);r.enter().append(\"rect\").classed(E.railRectClass,!0);var n=e.inputAreaLength-2*E.railInset;r.attr({width:n,height:E.railWidth,rx:E.railRadius,ry:E.railRadius,\"shape-rendering\":\"crispEdges\"}).call(k.stroke,e.bordercolor).call(k.fill,e.bgcolor).style(\"stroke-width\",e.borderwidth+\"px\"),A.setTranslate(r,E.railInset,.5*(e.inputAreaWidth-E.railWidth)+e.currentValueTotalHeight)}function _(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(E.autoMarginIdRoot)&&M.autoMargin(t,i)}}var w=t(\"d3\"),M=t(\"../../plots/plots\"),k=t(\"../color\"),A=t(\"../drawing\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../legend/anchor_utils\"),E=t(\"./constants\"),L=t(\"../../constants/alignment\").LINE_SPACING;e.exports=function(t){var e=t._fullLayout,r=n(e,t),s=e._infolayer.selectAll(\"g.\"+E.containerClassName).data(r.length>0?[0]:[]);if(s.enter().append(\"g\").classed(E.containerClassName,!0).style(\"cursor\",\"ew-resize\"),s.exit().remove(),s.exit().size()&&_(t),0!==r.length){var l=s.selectAll(\"g.\"+E.groupClassName).data(r,i);l.enter().append(\"g\").classed(E.groupClassName,!0),l.exit().each(function(e){w.select(this).remove(),e._commandObserver.remove(),delete e._commandObserver,M.autoMargin(t,E.autoMarginIdRoot+e._index)});for(var u=0;u<r.length;u++){var c=r[u];a(t,c)}l.each(function(e){if(!(e.steps.length<2)){var r=w.select(this);m(e),M.manageCommandObserver(t,e,e.steps,function(e){var n=r.data()[0];n.active!==e.index&&(n._dragging||f(t,r,n,e.index,!1,!0))}),o(t,w.select(this),e)}})}}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":688,d3:121}],691:[function(t,e,r){\"use strict\";var n=t(\"./constants\");e.exports={moduleType:\"component\",name:n.name,layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\")}},{\"./attributes\":687,\"./constants\":688,\"./defaults\":689,\"./draw\":690}],692:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../../plotly\"),o=t(\"../../plots/plots\"),s=t(\"../../lib\"),l=t(\"../drawing\"),u=t(\"../color\"),c=t(\"../../lib/svg_text_utils\"),h=t(\"../../constants/interactions\"),f=/Click to enter .+ title/;(e.exports={}).draw=function(t,e,r){function d(t){s.syncOrAsync([p,m],t)}function p(e){return e.attr(\"transform\",M?\"rotate(\"+[M.rotate,w.x,w.y]+\") translate(0, \"+M.offset+\")\":null),e.style({\"font-family\":T,\"font-size\":n.round(S,2)+\"px\",fill:u.rgb(E),opacity:L*u.opacity(E),\"font-weight\":o.fontWeight}).attr(w).call(c.convertToTspans,t),o.previousPromises(t)}function m(t){var e=n.select(t.node().parentNode);if(_&&_.selection&&_.side&&z){e.attr(\"transform\",null);var r=0,a={left:\"right\",right:\"left\",top:\"bottom\",bottom:\"top\"}[_.side],o=-1!==[\"left\",\"top\"].indexOf(_.side)?-1:1,u=i(_.pad)?_.pad:2,c=l.bBox(e.node()),h={left:0,top:0,right:A.width,bottom:A.height},f=_.maxShift||(h[_.side]-c[_.side])*(\"left\"===_.side||\"top\"===_.side?-1:1);if(f<0)r=f;else{var d=_.offsetLeft||0,p=_.offsetTop||0;c.left-=d,c.right-=d,c.top-=p,c.bottom-=p,_.selection.each(function(){var t=l.bBox(this);s.bBoxIntersect(c,t,u)&&(r=Math.max(r,o*(t[_.side]-c[a])+u))}),r=Math.min(f,r)}if(r>0||f<0){var m={left:[-r,0],right:[r,0],top:[0,-r],bottom:[0,r]}[_.side];e.attr(\"transform\",\"translate(\"+m+\")\")}}}var v,g=r.propContainer,y=r.propName,b=r.traceIndex,x=r.dfltName,_=r.avoid||{},w=r.attributes,M=r.transform,k=r.containerGroup,A=t._fullLayout,T=g.titlefont.family,S=g.titlefont.size,E=g.titlefont.color,L=1,C=!1,z=g.title.trim();\"title\"===y?v=\"titleText\":-1!==y.indexOf(\"axis\")?v=\"axisTitleText\":y.indexOf(!0)&&(v=\"colorbarTitleText\");var I=t._context.edits[v];\"\"===z&&(L=0),z.match(f)&&(L=.2,C=!0,I||(z=\"\"));var D=z||I;k||(k=A._infolayer.selectAll(\".g-\"+e).data([0]),k.enter().append(\"g\").classed(\"g-\"+e,!0));var P=k.selectAll(\"text\").data(D?[0]:[]);if(P.enter().append(\"text\"),P.text(z).attr(\"class\",e),P.exit().remove(),D){P.call(d);var O=\"Click to enter \"+x+\" title\";I&&(z?P.on(\".opacity\",null):function(){L=0,C=!0,z=O,P.text(z).on(\"mouseover.opacity\",function(){n.select(this).transition().duration(h.SHOW_PLACEHOLDER).style(\"opacity\",1)}).on(\"mouseout.opacity\",function(){n.select(this).transition().duration(h.HIDE_PLACEHOLDER).style(\"opacity\",0)})}(),P.call(c.makeEditable,{gd:t}).on(\"edit\",function(e){void 0!==b?a.restyle(t,y,e,b):a.relayout(t,y,e)}).on(\"cancel\",function(){this.text(this.attr(\"data-unformatted\")).call(d)}).on(\"input\",function(t){this.text(t||\" \").call(c.positionText,w.x,w.y)})),P.classed(\"js-placeholder\",C)}}},{\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,d3:121,\"fast-isnumeric\":130}],693:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"../../plots/pad_attributes\"),s={_isLinkedToArray:\"button\",method:{valType:\"enumerated\",values:[\"restyle\",\"relayout\",\"animate\",\"update\",\"skip\"],dflt:\"restyle\"},args:{valType:\"info_array\",freeLength:!0,items:[{valType:\"any\"},{valType:\"any\"},{valType:\"any\"}]},label:{valType:\"string\",dflt:\"\"},execute:{valType:\"boolean\",dflt:!0}};e.exports={_isLinkedToArray:\"updatemenu\",_arrayAttrRegexps:[/^updatemenus\\[(0|[1-9][0-9]+)\\]\\.buttons/],visible:{valType:\"boolean\"},type:{valType:\"enumerated\",values:[\"dropdown\",\"buttons\"],dflt:\"dropdown\"},direction:{valType:\"enumerated\",values:[\"left\",\"right\",\"up\",\"down\"],dflt:\"down\"},active:{valType:\"integer\",min:-1,dflt:0},showactive:{valType:\"boolean\",dflt:!0},buttons:s,x:{valType:\"number\",min:-2,max:3,dflt:-.05},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"right\"},y:{valType:\"number\",min:-2,max:3,dflt:1},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"top\"},pad:a({},o,{}),font:a({},n,{}),bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.borderLine},borderwidth:{valType:\"number\",min:0,dflt:1}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../../plots/pad_attributes\":828,\"../color/attributes\":602}],694:[function(t,e,r){\"use strict\";e.exports={name:\"updatemenus\",containerClassName:\"updatemenu-container\",headerGroupClassName:\"updatemenu-header-group\",headerClassName:\"updatemenu-header\",headerArrowClassName:\"updatemenu-header-arrow\",dropdownButtonGroupClassName:\"updatemenu-dropdown-button-group\",dropdownButtonClassName:\"updatemenu-dropdown-button\",buttonClassName:\"updatemenu-button\",itemRectClassName:\"updatemenu-item-rect\",itemTextClassName:\"updatemenu-item-text\",\n",
       "menuIndexAttrName:\"updatemenu-active-index\",autoMarginIdRoot:\"updatemenu-\",blankHeaderOpts:{label:\"  \"},minWidth:30,minHeight:30,textPadX:24,arrowPadX:16,rx:2,ry:2,textOffsetX:12,textOffsetY:3,arrowOffsetX:4,gapButtonHeader:5,gapButton:2,activeColor:\"#F4FAFF\",hoverColor:\"#F4FAFF\",arrowSymbol:{left:\"\\u25c4\",right:\"\\u25ba\",up:\"\\u25b2\",down:\"\\u25bc\"}}},{}],695:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return a.coerce(t,e,s,r,n)}n(\"visible\",i(t,e).length>0)&&(n(\"active\"),n(\"direction\"),n(\"type\"),n(\"showactive\"),n(\"x\"),n(\"y\"),a.noneOrAll(t,e,[\"x\",\"y\"]),n(\"xanchor\"),n(\"yanchor\"),n(\"pad.t\"),n(\"pad.r\"),n(\"pad.b\"),n(\"pad.l\"),a.coerceFont(n,\"font\",r.font),n(\"bgcolor\",r.paper_bgcolor),n(\"bordercolor\"),n(\"borderwidth\"))}function i(t,e){function r(t,e){return a.coerce(n,i,c,t,e)}for(var n,i,o=t.buttons||[],s=e.buttons=[],l=0;l<o.length;l++)n=o[l],i={},r(\"method\"),a.isPlainObject(n)&&(\"skip\"===i.method||Array.isArray(n.args))&&(r(\"args\"),r(\"label\"),r(\"execute\"),i._index=l,s.push(i));return s}var a=t(\"../../lib\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\"),l=t(\"./constants\"),u=l.name,c=s.buttons;e.exports=function(t,e){o(t,e,{name:u,handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"./attributes\":693,\"./constants\":694}],696:[function(t,e,r){\"use strict\";function n(t){for(var e=t[L.name],r=[],n=0;n<e.length;n++){var i=e[n];i.visible&&r.push(i)}return r}function i(t){return t._index}function a(t){return-1==+t.attr(L.menuIndexAttrName)}function o(t,e){return+t.attr(L.menuIndexAttrName)===e._index}function s(t,e,r,n,i,a,o,s){e._input.active=e.active=o,\"buttons\"===e.type?u(t,n,null,null,e):\"dropdown\"===e.type&&(i.attr(L.menuIndexAttrName,\"-1\"),l(t,n,i,a,e),s||u(t,n,i,a,e))}function l(t,e,r,n,i){var a=e.selectAll(\"g.\"+L.headerClassName).data([0]);a.enter().append(\"g\").classed(L.headerClassName,!0).style(\"pointer-events\",\"all\");var s=i.active,l=i.buttons[s]||L.blankHeaderOpts,c={y:i.pad.t,yPad:0,x:i.pad.l,xPad:0,index:0},h={width:i.headerWidth,height:i.headerHeight};a.call(f,i,l,t).call(b,i,c,h);var d=e.selectAll(\"text.\"+L.headerArrowClassName).data([0]);d.enter().append(\"text\").classed(L.headerArrowClassName,!0).classed(\"user-select-none\",!0).attr(\"text-anchor\",\"end\").call(A.font,i.font).text(L.arrowSymbol[i.direction]),d.attr({x:i.headerWidth-L.arrowOffsetX+i.pad.l,y:i.headerHeight/2+L.textOffsetY+i.pad.t}),a.on(\"click\",function(){r.call(x),r.attr(L.menuIndexAttrName,o(r,i)?-1:String(i._index)),u(t,e,r,n,i)}),a.on(\"mouseover\",function(){a.call(v)}),a.on(\"mouseout\",function(){a.call(g,i)}),A.setTranslate(e,i.lx,i.ly)}function u(t,e,r,n,i){r||(r=e,r.attr(\"pointer-events\",\"all\"));var o=a(r)&&\"buttons\"!==i.type?[]:i.buttons,l=\"dropdown\"===i.type?L.dropdownButtonClassName:L.buttonClassName,u=r.selectAll(\"g.\"+l).data(o),d=u.enter().append(\"g\").classed(l,!0),p=u.exit();\"dropdown\"===i.type?(d.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\"),p.transition().attr(\"opacity\",\"0\").remove()):p.remove();var y=0,x=0,_=-1!==[\"up\",\"down\"].indexOf(i.direction);\"dropdown\"===i.type&&(_?x=i.headerHeight+L.gapButtonHeader:y=i.headerWidth+L.gapButtonHeader),\"dropdown\"===i.type&&\"up\"===i.direction&&(x=-L.gapButtonHeader+L.gapButton-i.openHeight),\"dropdown\"===i.type&&\"left\"===i.direction&&(y=-L.gapButtonHeader+L.gapButton-i.openWidth);var k={x:i.lx+y+i.pad.l,y:i.ly+x+i.pad.t,yPad:L.gapButton,xPad:L.gapButton,index:0},A={l:k.x+i.borderwidth,t:k.y+i.borderwidth};u.each(function(a,o){var l=w.select(this);l.call(f,i,a,t).call(b,i,k),l.on(\"click\",function(){w.event.defaultPrevented||(s(t,i,a,e,r,n,o),a.execute&&M.executeAPICommand(t,a.method,a.args),t.emit(\"plotly_buttonclicked\",{menu:i,button:a,active:i.active}))}),l.on(\"mouseover\",function(){l.call(v)}),l.on(\"mouseout\",function(){l.call(g,i),u.call(m,i)})}),u.call(m,i),_?(A.w=Math.max(i.openWidth,i.headerWidth),A.h=k.y-A.t):(A.w=k.x-A.l,A.h=Math.max(i.openHeight,i.headerHeight)),A.direction=i.direction,n&&(u.size()?c(t,e,r,n,i,A):h(n))}function c(t,e,r,n,i,a){var o,s,l,u=i.direction,c=\"up\"===u||\"down\"===u,h=i.active;if(c)for(s=0,l=0;l<h;l++)s+=i.heights[l]+L.gapButton;else for(o=0,l=0;l<h;l++)o+=i.widths[l]+L.gapButton;n.enable(a,o,s),n.hbar&&n.hbar.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\"),n.vbar&&n.vbar.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\")}function h(t){var e=!!t.hbar,r=!!t.vbar;e&&t.hbar.transition().attr(\"opacity\",\"0\").each(\"end\",function(){e=!1,r||t.disable()}),r&&t.vbar.transition().attr(\"opacity\",\"0\").each(\"end\",function(){r=!1,e||t.disable()})}function f(t,e,r,n){t.call(d,e).call(p,e,r,n)}function d(t,e){var r=t.selectAll(\"rect\").data([0]);r.enter().append(\"rect\").classed(L.itemRectClassName,!0).attr({rx:L.rx,ry:L.ry,\"shape-rendering\":\"crispEdges\"}),r.call(k.stroke,e.bordercolor).call(k.fill,e.bgcolor).style(\"stroke-width\",e.borderwidth+\"px\")}function p(t,e,r,n){var i=t.selectAll(\"text\").data([0]);i.enter().append(\"text\").classed(L.itemTextClassName,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":\"start\",\"data-notex\":1}),i.call(A.font,e.font).text(r.label).call(T.convertToTspans,n)}function m(t,e){var r=e.active;t.each(function(t,n){var i=w.select(this);n===r&&e.showactive&&i.select(\"rect.\"+L.itemRectClassName).call(k.fill,L.activeColor)})}function v(t){t.select(\"rect.\"+L.itemRectClassName).call(k.fill,L.hoverColor)}function g(t,e){t.select(\"rect.\"+L.itemRectClassName).call(k.fill,e.bgcolor)}function y(t,e){e.width1=0,e.height1=0,e.heights=[],e.widths=[],e.totalWidth=0,e.totalHeight=0,e.openWidth=0,e.openHeight=0,e.lx=0,e.ly=0;var r=A.tester.selectAll(\"g.\"+L.dropdownButtonClassName).data(e.buttons);r.enter().append(\"g\").classed(L.dropdownButtonClassName,!0);var n=-1!==[\"up\",\"down\"].indexOf(e.direction);r.each(function(r,i){var a=w.select(this);a.call(f,e,r,t);var o=a.select(\".\"+L.itemTextClassName),s=o.node()&&A.bBox(o.node()).width,l=Math.max(s+L.textPadX,L.minWidth),u=e.font.size*E,c=T.lineCount(o),h=Math.max(u*c,L.minHeight)+L.textOffsetY;h=Math.ceil(h),l=Math.ceil(l),e.widths[i]=l,e.heights[i]=h,e.height1=Math.max(e.height1,h),e.width1=Math.max(e.width1,l),n?(e.totalWidth=Math.max(e.totalWidth,l),e.openWidth=e.totalWidth,e.totalHeight+=h+L.gapButton,e.openHeight+=h+L.gapButton):(e.totalWidth+=l+L.gapButton,e.openWidth+=l+L.gapButton,e.totalHeight=Math.max(e.totalHeight,h),e.openHeight=e.totalHeight)}),n?e.totalHeight-=L.gapButton:e.totalWidth-=L.gapButton,e.headerWidth=e.width1+L.arrowPadX,e.headerHeight=e.height1,\"dropdown\"===e.type&&(n?(e.width1+=L.arrowPadX,e.totalHeight=e.height1):e.totalWidth=e.width1,e.totalWidth+=L.arrowPadX),r.remove();var i=e.totalWidth+e.pad.l+e.pad.r,a=e.totalHeight+e.pad.t+e.pad.b,o=t._fullLayout._size;e.lx=o.l+o.w*e.x,e.ly=o.t+o.h*(1-e.y);var s=\"left\";S.isRightAnchor(e)&&(e.lx-=i,s=\"right\"),S.isCenterAnchor(e)&&(e.lx-=i/2,s=\"center\");var l=\"top\";S.isBottomAnchor(e)&&(e.ly-=a,l=\"bottom\"),S.isMiddleAnchor(e)&&(e.ly-=a/2,l=\"middle\"),e.totalWidth=Math.ceil(e.totalWidth),e.totalHeight=Math.ceil(e.totalHeight),e.lx=Math.round(e.lx),e.ly=Math.round(e.ly),M.autoMargin(t,L.autoMarginIdRoot+e._index,{x:e.x,y:e.y,l:i*({right:1,center:.5}[s]||0),r:i*({left:1,center:.5}[s]||0),b:a*({top:1,middle:.5}[l]||0),t:a*({bottom:1,middle:.5}[l]||0)})}function b(t,e,r,n){n=n||{};var i=t.select(\".\"+L.itemRectClassName),a=t.select(\".\"+L.itemTextClassName),o=e.borderwidth,s=r.index;A.setTranslate(t,o+r.x,o+r.y);var l=-1!==[\"up\",\"down\"].indexOf(e.direction),u=n.height||(l?e.heights[s]:e.height1);i.attr({x:0,y:0,width:n.width||(l?e.width1:e.widths[s]),height:u});var c=e.font.size*E,h=T.lineCount(a),f=(h-1)*c/2;T.positionText(a,L.textOffsetX,u/2-f+L.textOffsetY),l?r.y+=e.heights[s]+r.yPad:r.x+=e.widths[s]+r.xPad,r.index++}function x(t){t.selectAll(\"g.\"+L.dropdownButtonClassName).remove()}function _(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(L.autoMarginIdRoot)&&M.autoMargin(t,i)}}var w=t(\"d3\"),M=t(\"../../plots/plots\"),k=t(\"../color\"),A=t(\"../drawing\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../legend/anchor_utils\"),E=t(\"../../constants/alignment\").LINE_SPACING,L=t(\"./constants\"),C=t(\"./scrollbox\");e.exports=function(t){var e=t._fullLayout,r=n(e),a=e._infolayer.selectAll(\"g.\"+L.containerClassName).data(r.length>0?[0]:[]);if(a.enter().append(\"g\").classed(L.containerClassName,!0).style(\"cursor\",\"pointer\"),a.exit().remove(),a.exit().size()&&_(t),0!==r.length){var c=a.selectAll(\"g.\"+L.headerGroupClassName).data(r,i);c.enter().append(\"g\").classed(L.headerGroupClassName,!0);var h=a.selectAll(\"g.\"+L.dropdownButtonGroupClassName).data([0]);h.enter().append(\"g\").classed(L.dropdownButtonGroupClassName,!0).style(\"pointer-events\",\"all\");for(var f=0;f<r.length;f++){var d=r[f];y(t,d)}var p=\"updatemenus\"+e._uid,m=new C(t,h,p);c.enter().size()&&h.call(x).attr(L.menuIndexAttrName,\"-1\"),c.exit().each(function(e){w.select(this).remove(),h.call(x).attr(L.menuIndexAttrName,\"-1\"),M.autoMargin(t,L.autoMarginIdRoot+e._index)}),c.each(function(e){var r=w.select(this),n=\"dropdown\"===e.type?h:null;M.manageCommandObserver(t,e,e.buttons,function(i){s(t,e,e.buttons[i.index],r,n,m,i.index,!0)}),\"dropdown\"===e.type?(l(t,r,h,m,e),o(h,e)&&u(t,r,h,m,e)):u(t,r,null,null,e)})}}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":694,\"./scrollbox\":698,d3:121}],697:[function(t,e,r){arguments[4][691][0].apply(r,arguments)},{\"./attributes\":693,\"./constants\":694,\"./defaults\":695,\"./draw\":696,dup:691}],698:[function(t,e,r){\"use strict\";function n(t,e,r){this.gd=t,this.container=e,this.id=r,this.position=null,this.translateX=null,this.translateY=null,this.hbar=null,this.vbar=null,this.bg=this.container.selectAll(\"rect.scrollbox-bg\").data([0]),this.bg.exit().on(\".drag\",null).on(\"wheel\",null).remove(),this.bg.enter().append(\"rect\").classed(\"scrollbox-bg\",!0).style(\"pointer-events\",\"all\").attr({opacity:0,x:0,y:0,width:0,height:0})}e.exports=n;var i=t(\"d3\"),a=t(\"../color\"),o=t(\"../drawing\"),s=t(\"../../lib\");n.barWidth=2,n.barLength=20,n.barRadius=2,n.barPad=1,n.barColor=\"#808BA4\",n.prototype.enable=function(t,e,r){var s=this.gd._fullLayout,l=s.width,u=s.height;this.position=t;var c,h,f,d,p=this.position.l,m=this.position.w,v=this.position.t,g=this.position.h,y=this.position.direction,b=\"down\"===y,x=\"left\"===y,_=\"right\"===y,w=\"up\"===y,M=m,k=g;b||x||_||w||(this.position.direction=\"down\",b=!0),b||w?(c=p,h=c+M,b?(f=v,d=Math.min(f+k,u),k=d-f):(d=v+k,f=Math.max(d-k,0),k=d-f)):(f=v,d=f+k,x?(h=p+M,c=Math.max(h-M,0),M=h-c):(c=p,h=Math.min(c+M,l),M=h-c)),this._box={l:c,t:f,w:M,h:k};var A=m>M,T=n.barLength+2*n.barPad,S=n.barWidth+2*n.barPad,E=p,L=v+g;L+S>u&&(L=u-S);var C=this.container.selectAll(\"rect.scrollbar-horizontal\").data(A?[0]:[]);C.exit().on(\".drag\",null).remove(),C.enter().append(\"rect\").classed(\"scrollbar-horizontal\",!0).call(a.fill,n.barColor),A?(this.hbar=C.attr({rx:n.barRadius,ry:n.barRadius,x:E,y:L,width:T,height:S}),this._hbarXMin=E+T/2,this._hbarTranslateMax=M-T):(delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax);var z=g>k,I=n.barWidth+2*n.barPad,D=n.barLength+2*n.barPad,P=p+m,O=v;P+I>l&&(P=l-I);var R=this.container.selectAll(\"rect.scrollbar-vertical\").data(z?[0]:[]);R.exit().on(\".drag\",null).remove(),R.enter().append(\"rect\").classed(\"scrollbar-vertical\",!0).call(a.fill,n.barColor),z?(this.vbar=R.attr({rx:n.barRadius,ry:n.barRadius,x:P,y:O,width:I,height:D}),this._vbarYMin=O+D/2,this._vbarTranslateMax=k-D):(delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax);var F=this.id,j=c-.5,N=z?h+I+.5:h+.5,B=f-.5,U=A?d+S+.5:d+.5,V=s._topdefs.selectAll(\"#\"+F).data(A||z?[0]:[]);if(V.exit().remove(),V.enter().append(\"clipPath\").attr(\"id\",F).append(\"rect\"),A||z?(this._clipRect=V.select(\"rect\").attr({x:Math.floor(j),y:Math.floor(B),width:Math.ceil(N)-Math.floor(j),height:Math.ceil(U)-Math.floor(B)}),this.container.call(o.setClipUrl,F),this.bg.attr({x:p,y:v,width:m,height:g})):(this.bg.attr({width:0,height:0}),this.container.on(\"wheel\",null).on(\".drag\",null).call(o.setClipUrl,null),delete this._clipRect),A||z){var H=i.behavior.drag().on(\"dragstart\",function(){i.event.sourceEvent.preventDefault()}).on(\"drag\",this._onBoxDrag.bind(this));this.container.on(\"wheel\",null).on(\"wheel\",this._onBoxWheel.bind(this)).on(\".drag\",null).call(H);var q=i.behavior.drag().on(\"dragstart\",function(){i.event.sourceEvent.preventDefault(),i.event.sourceEvent.stopPropagation()}).on(\"drag\",this._onBarDrag.bind(this));A&&this.hbar.on(\".drag\",null).call(q),z&&this.vbar.on(\".drag\",null).call(q)}this.setTranslate(e,r)},n.prototype.disable=function(){(this.hbar||this.vbar)&&(this.bg.attr({width:0,height:0}),this.container.on(\"wheel\",null).on(\".drag\",null).call(o.setClipUrl,null),delete this._clipRect),this.hbar&&(this.hbar.on(\".drag\",null),this.hbar.remove(),delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax),this.vbar&&(this.vbar.on(\".drag\",null),this.vbar.remove(),delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax)},n.prototype._onBoxDrag=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t-=i.event.dx),this.vbar&&(e-=i.event.dy),this.setTranslate(t,e)},n.prototype._onBoxWheel=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t+=i.event.deltaY),this.vbar&&(e+=i.event.deltaY),this.setTranslate(t,e)},n.prototype._onBarDrag=function(){var t=this.translateX,e=this.translateY;if(this.hbar){var r=t+this._hbarXMin,n=r+this._hbarTranslateMax;t=(s.constrain(i.event.x,r,n)-r)/(n-r)*(this.position.w-this._box.w)}if(this.vbar){var a=e+this._vbarYMin,o=a+this._vbarTranslateMax;e=(s.constrain(i.event.y,a,o)-a)/(o-a)*(this.position.h-this._box.h)}this.setTranslate(t,e)},n.prototype.setTranslate=function(t,e){var r=this.position.w-this._box.w,n=this.position.h-this._box.h;if(t=s.constrain(t||0,0,r),e=s.constrain(e||0,0,n),this.translateX=t,this.translateY=e,this.container.call(o.setTranslate,this._box.l-this.position.l-t,this._box.t-this.position.t-e),this._clipRect&&this._clipRect.attr({x:Math.floor(this.position.l+t-.5),y:Math.floor(this.position.t+e-.5)}),this.hbar){var i=t/r;this.hbar.call(o.setTranslate,t+i*this._hbarTranslateMax,e)}if(this.vbar){var a=e/n;this.vbar.call(o.setTranslate,t,e+a*this._vbarTranslateMax)}}},{\"../../lib\":725,\"../color\":603,\"../drawing\":627,d3:121}],699:[function(t,e,r){\"use strict\";e.exports={FROM_BL:{left:0,center:.5,right:1,bottom:0,middle:.5,top:1},FROM_TL:{left:0,center:.5,right:1,bottom:1,middle:.5,top:0},LINE_SPACING:1.3,MID_SHIFT:.35}},{}],700:[function(t,e,r){\"use strict\";e.exports={solid:[1],dot:[1,1],dash:[4,1],longdash:[8,1],dashdot:[4,1,1,1],longdashdot:[8,1,1,1]}},{}],701:[function(t,e,r){\"use strict\";for(var n=t(\"../lib/extend\").extendFlat,i={circle:{unicode:\"\\u25cf\"},square:{unicode:\"\\u25a0\"},diamond:{unicode:\"\\u25c6\"},cross:{unicode:\"\\u271a\"},x:{unicode:\"\\u274c\"},\"triangle-up\":{unicode:\"\\u25b2\"},\"triangle-down\":{unicode:\"\\u25bc\"},\"triangle-left\":{unicode:\"\\u25c4\"},\"triangle-right\":{unicode:\"\\u25ba\"},\"triangle-ne\":{unicode:\"\\u25e5\"},\"triangle-nw\":{unicode:\"\\u25e4\"},\"triangle-se\":{unicode:\"\\u25e2\"},\"triangle-sw\":{unicode:\"\\u25e3\"},pentagon:{unicode:\"\\u2b1f\"},hexagon:{unicode:\"\\u2b22\"},hexagon2:{unicode:\"\\u2b23\"},star:{unicode:\"\\u2605\"},\"diamond-tall\":{unicode:\"\\u2666\"},bowtie:{unicode:\"\\u29d3\"},\"diamond-x\":{unicode:\"\\u2756\"},\"cross-thin\":{unicode:\"+\",noBorder:!0},asterisk:{unicode:\"\\u2733\",noBorder:!0},\"y-up\":{unicode:\"\\u2144\",noBorder:!0},\"y-down\":{unicode:\"Y\",noBorder:!0},\"line-ew\":{unicode:\"\\u2500\",noBorder:!0},\"line-ns\":{unicode:\"\\u2502\",noBorder:!0}},a={},o=Object.keys(i),s=0;s<o.length;s++){var l=o[s];a[l+\"-open\"]=n({},i[l])}var u={\"circle-cross-open\":{unicode:\"\\u2a01\",noFill:!0},\"circle-x-open\":{unicode:\"\\u2a02\",noFill:!0},\"square-cross-open\":{unicode:\"\\u229e\",noFill:!0},\"square-x-open\":{unicode:\"\\u22a0\",noFill:!0}};e.exports=n({},i,a,u)},{\"../lib/extend\":716}],702:[function(t,e,r){\"use strict\";e.exports={solid:[[],0],dot:[[.5,1],200],dash:[[.5,1],50],longdash:[[.5,1],10],dashdot:[[.5,.625,.875,1],50],longdashdot:[[.5,.7,.8,1],10]}},{}],703:[function(t,e,r){\"use strict\";e.exports={circle:\"\\u25cf\",\"circle-open\":\"\\u25cb\",square:\"\\u25a0\",\"square-open\":\"\\u25a1\",diamond:\"\\u25c6\",\"diamond-open\":\"\\u25c7\",cross:\"+\",x:\"\\u274c\"}},{}],704:[function(t,e,r){\"use strict\";e.exports={SHOW_PLACEHOLDER:100,HIDE_PLACEHOLDER:1e3,DBLCLICKDELAY:300,DESELECTDIM:.2}},{}],705:[function(t,e,r){\"use strict\";e.exports={BADNUM:void 0,FP_SAFE:Number.MAX_VALUE/1e4,ONEAVGYEAR:315576e5,ONEAVGMONTH:26298e5,ONEDAY:864e5,ONEHOUR:36e5,ONEMIN:6e4,ONESEC:1e3,EPOCHJD:2440587.5,ALMOST_EQUAL:1-1e-6,MINUS_SIGN:\"\\u2212\"}},{}],706:[function(t,e,r){\"use strict\";e.exports={entityToUnicode:{mu:\"\\u03bc\",\"#956\":\"\\u03bc\",amp:\"&\",\"#28\":\"&\",lt:\"<\",\"#60\":\"<\",gt:\">\",\"#62\":\">\",nbsp:\"\\xa0\",\"#160\":\"\\xa0\",times:\"\\xd7\",\"#215\":\"\\xd7\",plusmn:\"\\xb1\",\"#177\":\"\\xb1\",deg:\"\\xb0\",\"#176\":\"\\xb0\"}}},{}],707:[function(t,e,r){\"use strict\";r.xmlns=\"http://www.w3.org/2000/xmlns/\",r.svg=\"http://www.w3.org/2000/svg\",r.xlink=\"http://www.w3.org/1999/xlink\",r.svgAttrs={xmlns:r.svg,\"xmlns:xlink\":r.xlink}},{}],708:[function(t,e,r){\"use strict\";var n=t(\"./plotly\");r.version=\"1.30.0\",t(\"es6-promise\").polyfill(),t(\"../build/plotcss\"),t(\"./fonts/mathjax_config\"),r.plot=n.plot,r.newPlot=n.newPlot,r.restyle=n.restyle,r.relayout=n.relayout,r.redraw=n.redraw,r.update=n.update,r.extendTraces=n.extendTraces,r.prependTraces=n.prependTraces,r.addTraces=n.addTraces,r.deleteTraces=n.deleteTraces,r.moveTraces=n.moveTraces,r.purge=n.purge,r.setPlotConfig=t(\"./plot_api/set_plot_config\"),r.register=t(\"./plot_api/register\"),r.toImage=t(\"./plot_api/to_image\"),r.downloadImage=t(\"./snapshot/download\"),r.validate=t(\"./plot_api/validate\"),r.addFrames=n.addFrames,r.deleteFrames=n.deleteFrames,r.animate=n.animate,r.register(t(\"./traces/scatter\")),r.register([t(\"./components/fx\"),t(\"./components/legend\"),t(\"./components/annotations\"),t(\"./components/annotations3d\"),t(\"./components/shapes\"),t(\"./components/images\"),t(\"./components/updatemenus\"),t(\"./components/sliders\"),t(\"./components/rangeslider\"),t(\"./components/rangeselector\")]),r.Icons=t(\"../build/ploticon\"),r.Plots=n.Plots,r.Fx=t(\"./components/fx\"),r.Snapshot=t(\"./snapshot\"),r.PlotSchema=t(\"./plot_api/plot_schema\"),r.Queue=t(\"./lib/queue\"),r.d3=t(\"d3\")},{\"../build/plotcss\":1,\"../build/ploticon\":2,\"./components/annotations\":594,\"./components/annotations3d\":599,\"./components/fx\":644,\"./components/images\":652,\"./components/legend\":660,\"./components/rangeselector\":672,\"./components/rangeslider\":678,\"./components/shapes\":685,\"./components/sliders\":691,\"./components/updatemenus\":697,\"./fonts/mathjax_config\":709,\"./lib/queue\":738,\"./plot_api/plot_schema\":755,\"./plot_api/register\":756,\"./plot_api/set_plot_config\":757,\"./plot_api/to_image\":759,\"./plot_api/validate\":760,\"./plotly\":761,\"./snapshot\":849,\"./snapshot/download\":846,\"./traces/scatter\":1037,d3:121,\"es6-promise\":127}],709:[function(t,e,r){\"use strict\";\"undefined\"!=typeof MathJax?(r.MathJax=!0,MathJax.Hub.Config({messageStyle:\"none\",skipStartupTypeset:!0,displayAlign:\"left\",tex2jax:{inlineMath:[[\"$\",\"$\"],[\"\\\\(\",\"\\\\)\"]]}}),MathJax.Hub.Configured()):r.MathJax=!1},{}],710:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){Array.isArray(t)&&(e[r]=t[n])}},{}],711:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../constants/numerical\").BADNUM,a=/^['\"%,$#\\s']+|[, ]|['\"%,$#\\s']+$/g;e.exports=function(t){return\"string\"==typeof t&&(t=t.replace(a,\"\")),n(t)?Number(t):i}},{\"../constants/numerical\":705,\"fast-isnumeric\":130}],712:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"tinycolor2\"),a=t(\"../plots/attributes\"),o=t(\"../components/colorscale/get_scale\"),s=(Object.keys(t(\"../components/colorscale/scales\")),t(\"./nested_property\")),l=/^([2-9]|[1-9][0-9]+)$/;r.valObjects={data_array:{coerceFunction:function(t,e,r){Array.isArray(t)?e.set(t):void 0!==r&&e.set(r)}},enumerated:{coerceFunction:function(t,e,r,n){n.coerceNumber&&(t=+t),-1===n.values.indexOf(t)?e.set(r):e.set(t)},validateFunction:function(t,e){e.coerceNumber&&(t=+t);for(var r=e.values,n=0;n<r.length;n++){var i=String(r[n]);if(\"/\"===i.charAt(0)&&\"/\"===i.charAt(i.length-1)){if(new RegExp(i.substr(1,i.length-2)).test(t))return!0}else if(t===r[n])return!0}return!1}},boolean:{coerceFunction:function(t,e,r){!0===t||!1===t?e.set(t):e.set(r)}},number:{coerceFunction:function(t,e,r,i){!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},integer:{coerceFunction:function(t,e,r,i){t%1||!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},string:{coerceFunction:function(t,e,r,n){if(\"string\"!=typeof t){var i=\"number\"==typeof t;!0!==n.strict&&i?e.set(String(t)):e.set(r)}else n.noBlank&&!t?e.set(r):e.set(t)}},color:{coerceFunction:function(t,e,r){i(t).isValid()?e.set(t):e.set(r)}},colorscale:{coerceFunction:function(t,e,r){e.set(o(t,r))}},angle:{coerceFunction:function(t,e,r){\"auto\"===t?e.set(\"auto\"):n(t)?(Math.abs(t)>180&&(t-=360*Math.round(t/360)),e.set(+t)):e.set(r)}},subplotid:{coerceFunction:function(t,e,r){var n=r.length;if(\"string\"==typeof t&&t.substr(0,n)===r&&l.test(t.substr(n)))return void e.set(t);e.set(r)},validateFunction:function(t,e){var r=e.dflt,n=r.length;return t===r||\"string\"==typeof t&&!(t.substr(0,n)!==r||!l.test(t.substr(n)))}},flaglist:{coerceFunction:function(t,e,r,n){if(\"string\"!=typeof t)return void e.set(r);if(-1!==(n.extras||[]).indexOf(t))return void e.set(t);for(var i=t.split(\"+\"),a=0;a<i.length;){var o=i[a];-1===n.flags.indexOf(o)||i.indexOf(o)<a?i.splice(a,1):a++}i.length?e.set(i.join(\"+\")):e.set(r)}},any:{coerceFunction:function(t,e,r){void 0===t?e.set(r):e.set(t)}},info_array:{coerceFunction:function(t,e,n,i){if(!Array.isArray(t))return void e.set(n);var a=i.items,o=[];n=Array.isArray(n)?n:[];for(var s=0;s<a.length;s++)r.coerce(t,o,a,\"[\"+s+\"]\",n[s]);e.set(o)},validateFunction:function(t,e){if(!Array.isArray(t))return!1;var n=e.items;if(!e.freeLength&&t.length!==n.length)return!1;for(var i=0;i<t.length;i++){if(!r.validate(t[i],e.items[i]))return!1}return!0}}},r.coerce=function(t,e,n,i,a){var o=s(n,i).get(),l=s(t,i),u=s(e,i),c=l.get();return void 0===a&&(a=o.dflt),o.arrayOk&&Array.isArray(c)?(u.set(c),c):(r.valObjects[o.valType].coerceFunction(c,u,a,o),u.get())},r.coerce2=function(t,e,n,i,a){var o=s(t,i),l=r.coerce(t,e,n,i,a),u=o.get();return void 0!==u&&null!==u&&l},r.coerceFont=function(t,e,r){var n={};return r=r||{},n.family=t(e+\".family\",r.family),n.size=t(e+\".size\",r.size),n.color=t(e+\".color\",r.color),n},r.coerceHoverinfo=function(t,e,n){var i,o=e._module.attributes,s=o.hoverinfo?{hoverinfo:o.hoverinfo}:a,l=s.hoverinfo;if(1===n._dataLength){var u=\"all\"===l.dflt?l.flags.slice():l.dflt.split(\"+\");u.splice(u.indexOf(\"name\"),1),i=u.join(\"+\")}return r.coerce(t,e,s,\"hoverinfo\",i)},r.validate=function(t,e){var n=r.valObjects[e.valType];if(e.arrayOk&&Array.isArray(t))return!0;if(n.validateFunction)return n.validateFunction(t,e);var i={},a=i,o={set:function(t){a=t}};return n.coerceFunction(t,o,i,e),a!==i}},{\"../components/colorscale/get_scale\":615,\"../components/colorscale/scales\":621,\"../plots/attributes\":764,\"./nested_property\":732,\"fast-isnumeric\":130,tinycolor2:533}],713:[function(t,e,r){\"use strict\";function n(t){return t&&M.componentsRegistry.calendars&&\"string\"==typeof t&&\"gregorian\"!==t}function i(t,e){return String(t+Math.pow(10,e)).substr(1)}function a(t,e,r,n,a){if((e||r||n||a)&&(t+=\" \"+i(e,2)+\":\"+i(r,2),(n||a)&&(t+=\":\"+i(n,2),a))){for(var o=4;a%10==0;)o-=1,a/=10;t+=\".\"+i(a,o)}return t}function o(t,e,r){t=t.replace(D,function(t){var r=Math.min(+t.charAt(1)||6,6);return(e/1e3%1+2).toFixed(r).substr(2).replace(/0+$/,\"\")||\"0\"});var i=new Date(Math.floor(e+.05));if(n(r))try{t=M.getComponentMethod(\"calendars\",\"worldCalFmt\")(t,e,r)}catch(t){return\"Invalid\"}return k(t)(i)}function s(t,e){var r=m(t+.05,y),n=i(Math.floor(r/b),2)+\":\"+i(m(Math.floor(r/x),60),2);if(\"M\"!==e){d(e)||(e=0);var a=Math.min(m(t/_,60),P[e]),o=(100+a).toFixed(e).substr(1);e>0&&(o=o.replace(/0+$/,\"\").replace(/[\\.]$/,\"\")),n+=\":\"+o}return n}function l(t){return t.formatDate(\"yyyy\")}function u(t){return t.formatDate(\"M yyyy\")}function c(t){return t.formatDate(\"M d\")}function h(t){return t.formatDate(\"M d, yyyy\")}var f=t(\"d3\"),d=t(\"fast-isnumeric\"),p=t(\"./loggers\").error,m=t(\"./mod\"),v=t(\"../constants/numerical\"),g=v.BADNUM,y=v.ONEDAY,b=v.ONEHOUR,x=v.ONEMIN,_=v.ONESEC,w=v.EPOCHJD,M=t(\"../registry\"),k=f.time.format.utc,A=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)(-(\\d?\\d)(-(\\d?\\d)([ Tt]([01]?\\d|2[0-3])(:([0-5]\\d)(:([0-5]\\d(\\.\\d+)?))?(Z|z|[+\\-]\\d\\d:?\\d\\d)?)?)?)?)?\\s*$/m,T=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)(-(\\d?\\di?)(-(\\d?\\d)([ Tt]([01]?\\d|2[0-3])(:([0-5]\\d)(:([0-5]\\d(\\.\\d+)?))?(Z|z|[+\\-]\\d\\d:?\\d\\d)?)?)?)?)?\\s*$/m,S=(new Date).getFullYear()-70;r.dateTick0=function(t,e){return n(t)?e?M.getComponentMethod(\"calendars\",\"CANONICAL_SUNDAY\")[t]:M.getComponentMethod(\"calendars\",\"CANONICAL_TICK\")[t]:e?\"2000-01-02\":\"2000-01-01\"},r.dfltRange=function(t){return n(t)?M.getComponentMethod(\"calendars\",\"DFLTRANGE\")[t]:[\"2000-01-01\",\"2001-01-01\"]},r.isJSDate=function(t){return\"object\"==typeof t&&null!==t&&\"function\"==typeof t.getTime};var E,L;r.dateTime2ms=function(t,e){if(r.isJSDate(t))return t=Number(t)-t.getTimezoneOffset()*x,t>=E&&t<=L?t:g;if(\"string\"!=typeof t&&\"number\"!=typeof t)return g;t=String(t);var i=n(e),a=t.charAt(0);!i||\"G\"!==a&&\"g\"!==a||(t=t.substr(1),e=\"\");var o=i&&\"chinese\"===e.substr(0,7),s=t.match(o?T:A);if(!s)return g;var l=s[1],u=s[3]||\"1\",c=Number(s[5]||1),h=Number(s[7]||0),f=Number(s[9]||0),d=Number(s[11]||0);if(i){if(2===l.length)return g;l=Number(l);var p;try{var m=M.getComponentMethod(\"calendars\",\"getCal\")(e);if(o){var v=\"i\"===u.charAt(u.length-1);u=parseInt(u,10),p=m.newDate(l,m.toMonthIndex(l,u,v),c)}else p=m.newDate(l,Number(u),c)}catch(t){return g}return p?(p.toJD()-w)*y+h*b+f*x+d*_:g}l=2===l.length?(Number(l)+2e3-S)%100+S:Number(l),u-=1;var k=new Date(Date.UTC(2e3,u,c,h,f));return k.setUTCFullYear(l),k.getUTCMonth()!==u?g:k.getUTCDate()!==c?g:k.getTime()+d*_},E=r.MIN_MS=r.dateTime2ms(\"-9999\"),L=r.MAX_MS=r.dateTime2ms(\"9999-12-31 23:59:59.9999\"),r.isDateTime=function(t,e){return r.dateTime2ms(t,e)!==g};var C=90*y,z=3*b,I=5*x;r.ms2DateTime=function(t,e,r){if(\"number\"!=typeof t||!(t>=E&&t<=L))return g;e||(e=0);var i,o,s,l,u,c,h=Math.floor(10*m(t+.05,1)),f=Math.round(t-h/10);if(n(r)){var d=Math.floor(f/y)+w,p=Math.floor(m(t,y));try{i=M.getComponentMethod(\"calendars\",\"getCal\")(r).fromJD(d).formatDate(\"yyyy-mm-dd\")}catch(t){i=k(\"G%Y-%m-%d\")(new Date(f))}if(\"-\"===i.charAt(0))for(;i.length<11;)i=\"-0\"+i.substr(1);else for(;i.length<10;)i=\"0\"+i;o=e<C?Math.floor(p/b):0,s=e<C?Math.floor(p%b/x):0,l=e<z?Math.floor(p%x/_):0,u=e<I?p%_*10+h:0}else c=new Date(f),i=k(\"%Y-%m-%d\")(c),o=e<C?c.getUTCHours():0,s=e<C?c.getUTCMinutes():0,l=e<z?c.getUTCSeconds():0,u=e<I?10*c.getUTCMilliseconds()+h:0;return a(i,o,s,l,u)},r.ms2DateTimeLocal=function(t){if(!(t>=E+y&&t<=L-y))return g;var e=Math.floor(10*m(t+.05,1)),r=new Date(Math.round(t-e/10));return a(f.time.format(\"%Y-%m-%d\")(r),r.getHours(),r.getMinutes(),r.getSeconds(),10*r.getUTCMilliseconds()+e)},r.cleanDate=function(t,e,i){if(r.isJSDate(t)||\"number\"==typeof t){if(n(i))return p(\"JS Dates and milliseconds are incompatible with world calendars\",t),e;if(!(t=r.ms2DateTimeLocal(+t))&&void 0!==e)return e}else if(!r.isDateTime(t,i))return p(\"unrecognized date\",t),e;return t};var D=/%\\d?f/g,P=[59,59.9,59.99,59.999,59.9999],O=k(\"%Y\"),R=k(\"%b %Y\"),F=k(\"%b %-d\"),j=k(\"%b %-d, %Y\");r.formatDate=function(t,e,r,i){var a,f;if(i=n(i)&&i,e)return o(e,t,i);if(i)try{var d=Math.floor((t+.05)/y)+w,p=M.getComponentMethod(\"calendars\",\"getCal\")(i).fromJD(d);\"y\"===r?f=l(p):\"m\"===r?f=u(p):\"d\"===r?(a=l(p),f=c(p)):(a=h(p),f=s(t,r))}catch(t){return\"Invalid\"}else{var m=new Date(Math.floor(t+.05));\"y\"===r?f=O(m):\"m\"===r?f=R(m):\"d\"===r?(a=O(m),f=F(m)):(a=j(m),f=s(t,r))}return f+(a?\"\\n\"+a:\"\")};var N=3*y;r.incrementMonth=function(t,e,r){r=n(r)&&r;var i=m(t,y);if(t=Math.round(t-i),r)try{var a=Math.round(t/y)+w,o=M.getComponentMethod(\"calendars\",\"getCal\")(r),s=o.fromJD(a);return e%12?o.add(s,e,\"m\"):o.add(s,e/12,\"y\"),(s.toJD()-w)*y+i}catch(e){p(\"invalid ms \"+t+\" in calendar \"+r)}var l=new Date(t+N);return l.setUTCMonth(l.getUTCMonth()+e)+i-N},r.findExactDates=function(t,e){for(var r,i,a=0,o=0,s=0,l=0,u=n(e)&&M.getComponentMethod(\"calendars\",\"getCal\")(e),c=0;c<t.length;c++)if(i=t[c],d(i)){if(!(i%y))if(u)try{r=u.fromJD(i/y+w),1===r.day()?1===r.month()?a++:o++:s++}catch(t){}else r=new Date(i),1===r.getUTCDate()?0===r.getUTCMonth()?a++:o++:s++}else l++;o+=a,s+=o;var h=t.length-l;return{exactYears:a/h,exactMonths:o/h,exactDays:s/h}}},{\"../constants/numerical\":705,\"../registry\":844,\"./loggers\":729,\"./mod\":731,d3:121,\"fast-isnumeric\":130}],714:[function(t,e,r){\"use strict\";e.exports=function(t,e){return Array.isArray(t)||(t=[]),t.length=e,t}},{}],715:[function(t,e,r){\"use strict\";var n=t(\"events\").EventEmitter,i={init:function(t){if(t._ev instanceof n)return t;var e=new n,r=new n;return t._ev=e,t._internalEv=r,t.on=e.on.bind(e),t.once=e.once.bind(e),t.removeListener=e.removeListener.bind(e),t.removeAllListeners=e.removeAllListeners.bind(e),t._internalOn=r.on.bind(r),t._internalOnce=r.once.bind(r),t._removeInternalListener=r.removeListener.bind(r),t._removeAllInternalListeners=r.removeAllListeners.bind(r),t.emit=function(n,i){\"undefined\"!=typeof jQuery&&jQuery(t).trigger(n,i),e.emit(n,i),r.emit(n,i)},t},triggerHandler:function(t,e,r){var n,i;\"undefined\"!=typeof jQuery&&(n=jQuery(t).triggerHandler(e,r));var a=t._ev;if(!a)return n;var o=a._events[e];if(!o)return n;\"function\"==typeof o&&(o=[o]);for(var s=o.pop(),l=0;l<o.length;l++)o[l](r);return i=s(r),void 0!==n?n:i},purge:function(t){return delete t._ev,delete t.on,delete t.once,delete t.removeListener,delete t.removeAllListeners,delete t.emit,delete t._ev,delete t._internalEv,delete t._internalOn,delete t._internalOnce,delete t._removeInternalListener,delete t._removeAllInternalListeners,t}};e.exports=i},{events:128}],716:[function(t,e,r){\"use strict\";function n(t,e){var r,n;for(r=0;r<t.length;r++){if(null!==(n=t[r])&&\"object\"==typeof n)return!1;void 0!==n&&(e[r]=n)}return!0}function i(t,e,r,s){var l,u,c,h,f,d,p=t[0],m=t.length;if(2===m&&o(p)&&o(t[1])&&0===p.length){if(n(t[1],p))return p;p.splice(0,p.length)}for(var v=1;v<m;v++){l=t[v];for(u in l)c=p[u],h=l[u],s&&o(h)?p[u]=h:e&&h&&(a(h)||(f=o(h)))?(f?(f=!1,d=c&&o(c)?c:[]):d=c&&a(c)?c:{},p[u]=i([d,h],e,r,s)):(void 0!==h||r)&&(p[u]=h)}return p}var a=t(\"./is_plain_object.js\"),o=Array.isArray;r.extendFlat=function(){return i(arguments,!1,!1,!1)},r.extendDeep=function(){return i(arguments,!0,!1,!1)},r.extendDeepAll=function(){return i(arguments,!0,!0,!1)},r.extendDeepNoArrays=function(){return i(arguments,!0,!1,!0)}},{\"./is_plain_object.js\":727}],717:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e={},r=[],n=0,i=0;i<t.length;i++){var a=t[i];1!==e[a]&&(e[a]=1,r[n++]=a)}return r}},{}],718:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=[],r=0;r<t.length;r++){var n=t[r];!0===n.visible&&e.push(n)}return e}},{}],719:[function(t,e,r){\"use strict\";function n(t,e){return(0,l[t])(e)}function i(t){for(var e=0;e<s.length;e++){var r=s[e];if(new RegExp(a[r]).test(t.trim().toLowerCase()))return r}return o.warn(\"Unrecognized country name: \"+t+\".\"),!1}var a=t(\"country-regex\"),o=t(\"../lib\"),s=Object.keys(a),l={\"ISO-3\":o.identity,\"USA-states\":o.identity,\"country names\":i};r.locationToFeature=function(t,e,r){var i=n(t,e);if(i){for(var a=0;a<r.length;a++){var s=r[a];if(s.id===i)return s}o.warn([\"Location with id\",i,\"does not have a matching topojson feature at this resolution.\"].join(\" \"))}return!1}},{\"../lib\":725,\"country-regex\":106}],720:[function(t,e,r){\"use strict\";var n=t(\"../constants/numerical\").BADNUM;r.calcTraceToLineCoords=function(t){for(var e=t[0].trace,r=e.connectgaps,i=[],a=[],o=0;o<t.length;o++){var s=t[o],l=s.lonlat;l[0]!==n?a.push(l):!r&&a.length>0&&(i.push(a),a=[])}return a.length>0&&i.push(a),i},r.makeLine=function(t,e){var r={};return r=1===t.length?{\n",
       "type:\"LineString\",coordinates:t[0]}:{type:\"MultiLineString\",coordinates:t},e&&(r.trace=e),r},r.makePolygon=function(t,e){var r={};if(1===t.length)r={type:\"Polygon\",coordinates:t};else{for(var n=new Array(t.length),i=0;i<t.length;i++)n[i]=[t[i]];r={type:\"MultiPolygon\",coordinates:n}}return e&&(r.trace=e),r},r.makeBlank=function(){return{type:\"Point\",coordinates:[]}}},{\"../constants/numerical\":705}],721:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){var l=r-t,u=i-t,c=o-i,h=n-e,f=a-e,d=s-a,p=l*d-c*h;if(0===p)return null;var m=(u*d-c*f)/p,v=(u*h-l*f)/p;return v<0||v>1||m<0||m>1?null:{x:t+l*m,y:e+h*m}}function i(t,e,r,n,i){var a=n*t+i*e;if(a<0)return n*n+i*i;if(a>r){var o=n-t,s=i-e;return o*o+s*s}var l=n*e-i*t;return l*l/r}var a=t(\"./mod\");r.segmentsIntersect=n,r.segmentDistance=function(t,e,r,a,o,s,l,u){if(n(t,e,r,a,o,s,l,u))return 0;var c=r-t,h=a-e,f=l-o,d=u-s,p=c*c+h*h,m=f*f+d*d,v=Math.min(i(c,h,p,o-t,s-e),i(c,h,p,l-t,u-e),i(f,d,m,t-o,e-s),i(f,d,m,r-o,a-s));return Math.sqrt(v)};var o,s,l;r.getTextLocation=function(t,e,r,n){if(t===s&&n===l||(o={},s=t,l=n),o[r])return o[r];var i=t.getPointAtLength(a(r-n/2,e)),u=t.getPointAtLength(a(r+n/2,e)),c=Math.atan((u.y-i.y)/(u.x-i.x)),h=t.getPointAtLength(a(r,e)),f=(4*h.x+i.x+u.x)/6,d=(4*h.y+i.y+u.y)/6,p={x:f,y:d,theta:c};return o[r]=p,p},r.clearLocationCache=function(){s=null},r.getVisibleSegment=function(t,e,r){function n(e){var r=t.getPointAtLength(e);0===e?i=r:e===h&&(a=r);var n=r.x<o?o-r.x:r.x>s?r.x-s:0,c=r.y<l?l-r.y:r.y>u?r.y-u:0;return Math.sqrt(n*n+c*c)}for(var i,a,o=e.left,s=e.right,l=e.top,u=e.bottom,c=0,h=t.getTotalLength(),f=h,d=n(c);d;){if((c+=d+r)>f)return;d=n(c)}for(d=n(f);d;){if(f-=d+r,c>f)return;d=n(f)}return{min:c,max:f,len:f-c,total:h,isClosed:0===c&&f===h&&Math.abs(i.x-a.x)<.1&&Math.abs(i.y-a.y)<.1}}},{\"./mod\":731}],722:[function(t,e,r){\"use strict\";function n(t,e){var r=t;return r[3]*=e,r}function i(t){if(s(t))return h;var e=l(t);return e.length?e:h}function a(t){return s(t)?t:f}function o(t,e,r){var o,s,c,d,p,m=t.color,v=Array.isArray(m),g=Array.isArray(e),y=[];if(o=void 0!==t.colorscale?u.makeColorScaleFunc(u.extractScale(t.colorscale,t.cmin,t.cmax)):i,s=v?function(t,e){return void 0===t[e]?h:l(o(t[e]))}:i,c=g?function(t,e){return void 0===t[e]?f:a(t[e])}:a,v||g)for(var b=0;b<r;b++)d=s(m,b),p=c(e,b),y[b]=n(d,p);else y=n(l(m),e);return y}var s=t(\"fast-isnumeric\"),l=t(\"color-rgba\"),u=t(\"../components/colorscale\"),c=t(\"../components/color/attributes\").defaultLine,h=l(c),f=1;e.exports=o},{\"../components/color/attributes\":602,\"../components/colorscale\":617,\"color-rgba\":94,\"fast-isnumeric\":130}],723:[function(t,e,r){\"use strict\";function n(t){for(var e=0;(e=t.indexOf(\"<sup>\",e))>=0;){var r=t.indexOf(\"</sup>\",e);if(r<e)break;t=t.slice(0,e)+l(t.slice(e+5,r))+t.slice(r+6)}return t}function i(t){return t.replace(/\\<br\\>/g,\"\\n\")}function a(t){return t.replace(/\\<.*\\>/g,\"\")}function o(t){for(var e=u.entityToUnicode,r=0;(r=t.indexOf(\"&\",r))>=0;){var n=t.indexOf(\";\",r);if(n<r)r+=1;else{var i=e[t.slice(r+1,n)];t=i?t.slice(0,r)+i+t.slice(n+1):t.slice(0,r)+t.slice(n+1)}}return t}function s(t){return\"\"+o(a(n(i(t))))}var l=t(\"superscript-text\"),u=t(\"../constants/string_mappings\");e.exports=s},{\"../constants/string_mappings\":706,\"superscript-text\":529}],724:[function(t,e,r){\"use strict\";e.exports=function(t){return t}},{}],725:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../constants/numerical\"),o=a.FP_SAFE,s=a.BADNUM,l=e.exports={};l.nestedProperty=t(\"./nested_property\"),l.keyedContainer=t(\"./keyed_container\"),l.isPlainObject=t(\"./is_plain_object\"),l.isArray=t(\"./is_array\"),l.mod=t(\"./mod\"),l.toLogRange=t(\"./to_log_range\"),l.relinkPrivateKeys=t(\"./relink_private\"),l.ensureArray=t(\"./ensure_array\");var u=t(\"./coerce\");l.valObjects=u.valObjects,l.coerce=u.coerce,l.coerce2=u.coerce2,l.coerceFont=u.coerceFont,l.coerceHoverinfo=u.coerceHoverinfo,l.validate=u.validate;var c=t(\"./dates\");l.dateTime2ms=c.dateTime2ms,l.isDateTime=c.isDateTime,l.ms2DateTime=c.ms2DateTime,l.ms2DateTimeLocal=c.ms2DateTimeLocal,l.cleanDate=c.cleanDate,l.isJSDate=c.isJSDate,l.formatDate=c.formatDate,l.incrementMonth=c.incrementMonth,l.dateTick0=c.dateTick0,l.dfltRange=c.dfltRange,l.findExactDates=c.findExactDates,l.MIN_MS=c.MIN_MS,l.MAX_MS=c.MAX_MS;var h=t(\"./search\");l.findBin=h.findBin,l.sorterAsc=h.sorterAsc,l.sorterDes=h.sorterDes,l.distinctVals=h.distinctVals,l.roundUp=h.roundUp;var f=t(\"./stats\");l.aggNums=f.aggNums,l.len=f.len,l.mean=f.mean,l.variance=f.variance,l.stdev=f.stdev,l.interp=f.interp;var d=t(\"./matrix\");l.init2dArray=d.init2dArray,l.transposeRagged=d.transposeRagged,l.dot=d.dot,l.translationMatrix=d.translationMatrix,l.rotationMatrix=d.rotationMatrix,l.rotationXYMatrix=d.rotationXYMatrix,l.apply2DTransform=d.apply2DTransform,l.apply2DTransform2=d.apply2DTransform2;var p=t(\"./geometry2d\");l.segmentsIntersect=p.segmentsIntersect,l.segmentDistance=p.segmentDistance,l.getTextLocation=p.getTextLocation,l.clearLocationCache=p.clearLocationCache,l.getVisibleSegment=p.getVisibleSegment;var m=t(\"./extend\");l.extendFlat=m.extendFlat,l.extendDeep=m.extendDeep,l.extendDeepAll=m.extendDeepAll,l.extendDeepNoArrays=m.extendDeepNoArrays;var v=t(\"./loggers\");l.log=v.log,l.warn=v.warn,l.error=v.error,l.notifier=t(\"./notifier\"),l.filterUnique=t(\"./filter_unique\"),l.filterVisible=t(\"./filter_visible\"),l.pushUnique=t(\"./push_unique\"),l.cleanNumber=t(\"./clean_number\"),l.ensureNumber=function(t){return i(t)?(t=Number(t),t<-o||t>o?s:i(t)?Number(t):s):s},l.noop=t(\"./noop\"),l.identity=t(\"./identity\"),l.swapAttrs=function(t,e,r,n){r||(r=\"x\"),n||(n=\"y\");for(var i=0;i<e.length;i++){var a=e[i],o=l.nestedProperty(t,a.replace(\"?\",r)),s=l.nestedProperty(t,a.replace(\"?\",n)),u=o.get();o.set(s.get()),s.set(u)}},l.pauseEvent=function(t){return t.stopPropagation&&t.stopPropagation(),t.preventDefault&&t.preventDefault(),t.cancelBubble=!0,!1},l.constrain=function(t,e,r){return e>r?Math.max(r,Math.min(e,t)):Math.max(e,Math.min(r,t))},l.bBoxIntersect=function(t,e,r){return r=r||0,t.left<=e.right+r&&e.left<=t.right+r&&t.top<=e.bottom+r&&e.top<=t.bottom+r},l.simpleMap=function(t,e,r,n){for(var i=t.length,a=new Array(i),o=0;o<i;o++)a[o]=e(t[o],r,n);return a},l.randstr=function t(e,r,n){if(n||(n=16),void 0===r&&(r=24),r<=0)return\"0\";var i,a,o,s=Math.log(Math.pow(2,r))/Math.log(n),l=\"\";for(i=2;s===1/0;i*=2)s=Math.log(Math.pow(2,r/i))/Math.log(n)*i;var u=s-Math.floor(s);for(i=0;i<Math.floor(s);i++)o=Math.floor(Math.random()*n).toString(n),l=o+l;u&&(a=Math.pow(n,u),o=Math.floor(Math.random()*a).toString(n),l=o+l);var c=parseInt(l,n);return e&&e.indexOf(l)>-1||c!==1/0&&c>=Math.pow(2,r)?t(e,r,n):l},l.OptionControl=function(t,e){t||(t={}),e||(e=\"opt\");var r={};return r.optionList=[],r._newoption=function(n){n[e]=t,r[n.name]=n,r.optionList.push(n)},r[\"_\"+e]=t,r},l.smooth=function(t,e){if((e=Math.round(e)||0)<2)return t;var r,n,i,a,o=t.length,s=2*o,l=2*e-1,u=new Array(l),c=new Array(o);for(r=0;r<l;r++)u[r]=(1-Math.cos(Math.PI*(r+1)/e))/(2*e);for(r=0;r<o;r++){for(a=0,n=0;n<l;n++)i=r+n+1-e,i<-o?i-=s*Math.round(i/s):i>=s&&(i-=s*Math.floor(i/s)),i<0?i=-1-i:i>=o&&(i=s-1-i),a+=t[i]*u[n];c[r]=a}return c},l.syncOrAsync=function(t,e,r){function n(){return l.syncOrAsync(t,e,r)}for(var i,a;t.length;)if(a=t.splice(0,1)[0],(i=a(e))&&i.then)return i.then(n).then(void 0,l.promiseError);return r&&r(e)},l.stripTrailingSlash=function(t){return\"/\"===t.substr(-1)?t.substr(0,t.length-1):t},l.noneOrAll=function(t,e,r){if(t){var n,i,a=!1,o=!0;for(n=0;n<r.length;n++)i=t[r[n]],void 0!==i&&null!==i?a=!0:o=!1;if(a&&!o)for(n=0;n<r.length;n++)t[r[n]]=e[r[n]]}},l.mergeArray=function(t,e,r){if(Array.isArray(t))for(var n=Math.min(t.length,e.length),i=0;i<n;i++)e[i][r]=t[i]},l.fillArray=function(t,e,r,n){if(n=n||l.identity,Array.isArray(t))for(var i=0;i<e.length;i++)e[i][r]=n(t[i])},l.castOption=function(t,e,r,n){n=n||l.identity;var i=l.nestedProperty(t,r).get();return Array.isArray(i)?n(Array.isArray(e)&&Array.isArray(i[e[0]])?i[e[0]][e[1]]:i[e]):i},l.getTargetArray=function(t,e){var r=e.target;if(\"string\"==typeof r&&r){var n=l.nestedProperty(t,r).get();return!!Array.isArray(n)&&n}return!!Array.isArray(r)&&r},l.minExtend=function(t,e){var r={};\"object\"!=typeof e&&(e={});var n,i,a,o=Object.keys(t);for(n=0;n<o.length;n++)i=o[n],a=t[i],\"_\"!==i.charAt(0)&&\"function\"!=typeof a&&(\"module\"===i?r[i]=a:Array.isArray(a)?r[i]=a.slice(0,3):r[i]=a&&\"object\"==typeof a?l.minExtend(t[i],e[i]):a);for(o=Object.keys(e),n=0;n<o.length;n++)i=o[n],\"object\"==typeof(a=e[i])&&i in r&&\"object\"==typeof r[i]||(r[i]=a);return r},l.titleCase=function(t){return t.charAt(0).toUpperCase()+t.substr(1)},l.containsAny=function(t,e){for(var r=0;r<e.length;r++)if(-1!==t.indexOf(e[r]))return!0;return!1},l.isPlotDiv=function(t){var e=n.select(t);return e.node()instanceof HTMLElement&&e.size()&&e.classed(\"js-plotly-plot\")},l.removeElement=function(t){var e=t&&t.parentNode;e&&e.removeChild(t)},l.addStyleRule=function(t,e){if(!l.styleSheet){var r=document.createElement(\"style\");r.appendChild(document.createTextNode(\"\")),document.head.appendChild(r),l.styleSheet=r.sheet}var n=l.styleSheet;n.insertRule?n.insertRule(t+\"{\"+e+\"}\",0):n.addRule?n.addRule(t,e,0):l.warn(\"addStyleRule failed\")},l.isIE=function(){return void 0!==window.navigator.msSaveBlob},l.isD3Selection=function(t){return t&&\"function\"==typeof t.classed},l.objectFromPath=function(t,e){for(var r,n=t.split(\".\"),i=r={},a=0;a<n.length;a++){var o=n[a],s=null,l=n[a].match(/(.*)\\[([0-9]+)\\]/);l?(o=l[1],s=l[2],r=r[o]=[],a===n.length-1?r[s]=e:r[s]={},r=r[s]):(a===n.length-1?r[o]=e:r[o]={},r=r[o])}return i};var g=/^([^\\[\\.]+)\\.(.+)?/,y=/^([^\\.]+)\\[([0-9]+)\\](\\.)?(.+)?/;l.expandObjectPaths=function(t){var e,r,n,i,a,o,s;if(\"object\"==typeof t&&!Array.isArray(t))for(r in t)t.hasOwnProperty(r)&&((e=r.match(g))?(i=t[r],n=e[1],delete t[r],t[n]=l.extendDeepNoArrays(t[n]||{},l.objectFromPath(r,l.expandObjectPaths(i))[n])):(e=r.match(y))?(i=t[r],n=e[1],a=parseInt(e[2]),delete t[r],t[n]=t[n]||[],\".\"===e[3]?(s=e[4],o=t[n][a]=t[n][a]||{},l.extendDeepNoArrays(o,l.objectFromPath(s,l.expandObjectPaths(i)))):t[n][a]=l.expandObjectPaths(i)):t[r]=l.expandObjectPaths(t[r]));return t},l.numSeparate=function(t,e,r){if(r||(r=!1),\"string\"!=typeof e||0===e.length)throw new Error(\"Separator string required for formatting!\");\"number\"==typeof t&&(t=String(t));var n=/(\\d+)(\\d{3})/,i=e.charAt(0),a=e.charAt(1),o=t.split(\".\"),s=o[0],l=o.length>1?i+o[1]:\"\";if(a&&(o.length>1||s.length>4||r))for(;n.test(s);)s=s.replace(n,\"$1\"+a+\"$2\");return s+l};var b=/%{([^\\s%{}]*)}/g,x=/^\\w*$/;l.templateString=function(t,e){var r={};return t.replace(b,function(t,n){return x.test(n)?e[n]||\"\":(r[n]=r[n]||l.nestedProperty(e,n).get,r[n]()||\"\")})}},{\"../constants/numerical\":705,\"./clean_number\":711,\"./coerce\":712,\"./dates\":713,\"./ensure_array\":714,\"./extend\":716,\"./filter_unique\":717,\"./filter_visible\":718,\"./geometry2d\":721,\"./identity\":724,\"./is_array\":726,\"./is_plain_object\":727,\"./keyed_container\":728,\"./loggers\":729,\"./matrix\":730,\"./mod\":731,\"./nested_property\":732,\"./noop\":733,\"./notifier\":734,\"./push_unique\":737,\"./relink_private\":739,\"./search\":740,\"./stats\":743,\"./to_log_range\":746,d3:121,\"fast-isnumeric\":130}],726:[function(t,e,r){\"use strict\";var n=\"undefined\"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer:{isView:function(){return!1}};e.exports=function(t){return Array.isArray(t)||n.isView(t)}},{}],727:[function(t,e,r){\"use strict\";e.exports=function(t){return window&&window.process&&window.process.versions?\"[object Object]\"===Object.prototype.toString.call(t):\"[object Object]\"===Object.prototype.toString.call(t)&&Object.getPrototypeOf(t)===Object.prototype}},{}],728:[function(t,e,r){\"use strict\";var n=t(\"./nested_property\"),i=/^\\w*$/;e.exports=function(t,e,r,a){r=r||\"name\",a=a||\"value\";var o,s,l={};s=e&&e.length?n(t,e).get():t,e=e||\"\",s=s||[];var u={};for(o=0;o<s.length;o++)u[s[o][r]]=o;var c=i.test(a),h={set:function(t,e){var i=null===e?4:0,o=u[t];void 0===o?(i|=3,o=s.length,u[t]=o):e!==(c?s[o][a]:n(s[o],a).get())&&(i|=2);var f=s[o]=s[o]||{};return f[r]=t,c?f[a]=e:n(f,a).set(e),null!==e&&(i&=-5),l[o]=l[o]|i,h},get:function(t){var e=u[t];return void 0===e?void 0:c?s[e][a]:n(s[e],a).get()},rename:function(t,e){var n=u[t];return void 0===n?h:(l[n]=1|l[n],u[e]=n,delete u[t],s[n][r]=e,h)},remove:function(t){var e=u[t];if(void 0===e)return h;var i=s[e];if(Object.keys(i).length>2)return l[e]=2|l[e],h.set(t,null);if(c){for(o=e;o<s.length;o++)l[o]=3|l[o];for(o=e;o<s.length;o++)u[s[o][r]]--;s.splice(e,1),delete u[t]}else n(i,a).set(null),l[e]=6|l[e];return h},constructUpdate:function(){for(var t,i,o={},u=Object.keys(l),h=0;h<u.length;h++)i=u[h],t=e+\"[\"+i+\"]\",s[i]?(1&l[i]&&(o[t+\".\"+r]=s[i][r]),2&l[i]&&(o[t+\".\"+a]=c?4&l[i]?null:s[i][a]:4&l[i]?null:n(s[i],a).get())):o[t]=null;return o}};return h}},{\"./nested_property\":732}],729:[function(t,e,r){\"use strict\";function n(t,e){if(t.apply)t.apply(t,e);else for(var r=0;r<e.length;r++)t(e[r])}var i=t(\"../plot_api/plot_config\"),a=e.exports={};a.log=function(){if(i.logging>1){for(var t=[\"LOG:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.trace||console.log,t)}},a.warn=function(){if(i.logging>0){for(var t=[\"WARN:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.trace||console.log,t)}},a.error=function(){if(i.logging>0){for(var t=[\"ERROR:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.error,t)}}},{\"../plot_api/plot_config\":754}],730:[function(t,e,r){\"use strict\";r.init2dArray=function(t,e){for(var r=new Array(t),n=0;n<t;n++)r[n]=new Array(e);return r},r.transposeRagged=function(t){var e,r,n=0,i=t.length;for(e=0;e<i;e++)n=Math.max(n,t[e].length);var a=new Array(n);for(e=0;e<n;e++)for(a[e]=new Array(i),r=0;r<i;r++)a[e][r]=t[r][e];return a},r.dot=function(t,e){if(!t.length||!e.length||t.length!==e.length)return null;var n,i,a=t.length;if(t[0].length)for(n=new Array(a),i=0;i<a;i++)n[i]=r.dot(t[i],e);else if(e[0].length){var o=r.transposeRagged(e);for(n=new Array(o.length),i=0;i<o.length;i++)n[i]=r.dot(t,o[i])}else for(n=0,i=0;i<a;i++)n+=t[i]*e[i];return n},r.translationMatrix=function(t,e){return[[1,0,t],[0,1,e],[0,0,1]]},r.rotationMatrix=function(t){var e=t*Math.PI/180;return[[Math.cos(e),-Math.sin(e),0],[Math.sin(e),Math.cos(e),0],[0,0,1]]},r.rotationXYMatrix=function(t,e,n){return r.dot(r.dot(r.translationMatrix(e,n),r.rotationMatrix(t)),r.translationMatrix(-e,-n))},r.apply2DTransform=function(t){return function(){var e=arguments;3===e.length&&(e=e[0]);var n=1===arguments.length?e[0]:[e[0],e[1]];return r.dot(t,[n[0],n[1],1]).slice(0,2)}},r.apply2DTransform2=function(t){var e=r.apply2DTransform(t);return function(t){return e(t.slice(0,2)).concat(e(t.slice(2,4)))}}},{}],731:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r=t%e;return r<0?r+e:r}},{}],732:[function(t,e,r){\"use strict\";function n(t,e){return function(){var r,i,a,o,s,l=t;for(o=0;o<e.length-1;o++){if(-1===(r=e[o])){for(i=!0,a=[],s=0;s<l.length;s++)a[s]=n(l[s],e.slice(o+1))(),a[s]!==a[0]&&(i=!1);return i?a[0]:a}if(\"number\"==typeof r&&!d(l))return;if(\"object\"!=typeof(l=l[r])||null===l)return}if(\"object\"==typeof l&&null!==l&&null!==(a=l[e[o]]))return a}}function i(t,e){if(!c(t)||p(t)&&\"]\"===e.charAt(e.length-1)||e.match(g)&&void 0!==t)return!1;if(!d(t))return!0;if(e.match(v))return!0;var r=m(e);return r&&\"\"===r.index}function a(t,e,r){return function(n){var a,c,h=t,f=\"\",p=[[t,f]],m=i(n,r);for(c=0;c<e.length-1;c++){if(\"number\"==typeof(a=e[c])&&!d(h))throw\"array index but container is not an array\";if(-1===a){if(m=!s(h,e.slice(c+1),n,r))break;return}if(!l(h,a,e[c+1],m))break;if(\"object\"!=typeof(h=h[a])||null===h)throw\"container is not an object\";f=o(f,a),p.push([h,f])}m?(c===e.length-1&&delete h[e[c]],u(p)):h[e[c]]=n}}function o(t,e){var r=e;return f(e)?r=\"[\"+e+\"]\":t&&(r=\".\"+e),t+r}function s(t,e,r,n){var o,s=d(r),u=!0,c=r,h=n.replace(\"-1\",0),f=!s&&i(r,h),p=e[0];for(o=0;o<t.length;o++)h=n.replace(\"-1\",o),s&&(c=r[o%r.length],f=i(c,h)),f&&(u=!1),l(t,o,p,f)&&a(t[o],e,n.replace(\"-1\",o))(c);return u}function l(t,e,r,n){if(void 0===t[e]){if(n)return!1;t[e]=\"number\"==typeof r?[]:{}}return!0}function u(t){var e,r,n,a,s,l;for(e=t.length-1;e>=0;e--){if(n=t[e][0],a=t[e][1],l=!1,d(n))for(r=n.length-1;r>=0;r--)i(n[r],o(a,r))?l?n[r]=void 0:n.pop():l=!0;else if(\"object\"==typeof n&&null!==n)for(s=Object.keys(n),l=!1,r=s.length-1;r>=0;r--)i(n[s[r]],o(a,s[r]))?delete n[s[r]]:l=!0;if(l)return}}function c(t){return void 0===t||null===t||\"object\"==typeof t&&(d(t)?!t.length:!Object.keys(t).length)}function h(t,e,r){return{set:function(){throw\"bad container\"},get:function(){},astr:e,parts:r,obj:t}}var f=t(\"fast-isnumeric\"),d=t(\"./is_array\"),p=t(\"./is_plain_object\"),m=t(\"../plot_api/container_array_match\");e.exports=function(t,e){if(f(e))e=String(e);else if(\"string\"!=typeof e||\"[-1]\"===e.substr(e.length-4))throw\"bad property string\";for(var r,i,o,s=0,l=e.split(\".\");s<l.length;){if(r=String(l[s]).match(/^([^\\[\\]]*)((\\[\\-?[0-9]*\\])+)$/)){if(r[1])l[s]=r[1];else{if(0!==s)throw\"bad property string\";l.splice(0,1)}for(i=r[2].substr(1,r[2].length-2).split(\"][\"),o=0;o<i.length;o++)s++,l.splice(s,0,Number(i[o]))}s++}return\"object\"!=typeof t?h(t,e,l):{set:a(t,l,e),get:n(t,l),astr:e,parts:l,obj:t}};var v=/(^|\\.)((domain|range)(\\.[xy])?|args|parallels)$/,g=/(^|\\.)args\\[/},{\"../plot_api/container_array_match\":749,\"./is_array\":726,\"./is_plain_object\":727,\"fast-isnumeric\":130}],733:[function(t,e,r){\"use strict\";e.exports=function(){}},{}],734:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=[];e.exports=function(t,e){function r(t){t.duration(700).style(\"opacity\",0).each(\"end\",function(t){var e=a.indexOf(t);-1!==e&&a.splice(e,1),n.select(this).remove()})}if(-1===a.indexOf(t)){a.push(t);var o=1e3;i(e)?o=e:\"long\"===e&&(o=3e3);var s=n.select(\"body\").selectAll(\".plotly-notifier\").data([0]);s.enter().append(\"div\").classed(\"plotly-notifier\",!0);s.selectAll(\".notifier-note\").data(a).enter().append(\"div\").classed(\"notifier-note\",!0).style(\"opacity\",0).each(function(t){var e=n.select(this);e.append(\"button\").classed(\"notifier-close\",!0).html(\"&times;\").on(\"click\",function(){e.transition().call(r)});for(var i=e.append(\"p\"),a=t.split(/<br\\s*\\/?>/g),s=0;s<a.length;s++)s&&i.append(\"br\"),i.append(\"span\").text(a[s]);e.transition().duration(700).style(\"opacity\",1).transition().delay(o).call(r)})}}},{d3:121,\"fast-isnumeric\":130}],735:[function(t,e,r){\"use strict\";var n=t(\"./setcursor\"),i=\"data-savedcursor\";e.exports=function(t,e){var r=t.attr(i);if(e){if(!r){for(var a=(t.attr(\"class\")||\"\").split(\" \"),o=0;o<a.length;o++){var s=a[o];0===s.indexOf(\"cursor-\")&&t.attr(i,s.substr(7)).classed(s,!1)}t.attr(i)||t.attr(i,\"!!\")}n(t,e)}else r&&(t.attr(i,null),\"!!\"===r?n(t):n(t,r))}},{\"./setcursor\":741}],736:[function(t,e,r){\"use strict\";var n=t(\"./matrix\").dot,i=t(\"../constants/numerical\").BADNUM,a=e.exports={};a.tester=function(t){function e(t,e){var r=t[0],n=t[1];return!(r===i||r<a||r>o||n===i||n<s||n>l)&&(!e||!c(t))}function r(t,e){var r=t[0],u=t[1];if(r===i||r<a||r>o||u===i||u<s||u>l)return!1;var c,h,f,d,p,m=n.length,v=n[0][0],g=n[0][1],y=0;for(c=1;c<m;c++)if(h=v,f=g,v=n[c][0],g=n[c][1],d=Math.min(h,v),!(r<d||r>Math.max(h,v)||u>Math.max(f,g)))if(u<Math.min(f,g))r!==d&&y++;else{if(p=v===h?u:f+(r-h)*(g-f)/(v-h),u===p)return 1!==c||!e;u<=p&&r!==d&&y++}return y%2==1}var n=t.slice(),a=n[0][0],o=a,s=n[0][1],l=s;n.push(n[0]);for(var u=1;u<n.length;u++)a=Math.min(a,n[u][0]),o=Math.max(o,n[u][0]),s=Math.min(s,n[u][1]),l=Math.max(l,n[u][1]);var c,h=!1;return 5===n.length&&(n[0][0]===n[1][0]?n[2][0]===n[3][0]&&n[0][1]===n[3][1]&&n[1][1]===n[2][1]&&(h=!0,c=function(t){return t[0]===n[0][0]}):n[0][1]===n[1][1]&&n[2][1]===n[3][1]&&n[0][0]===n[3][0]&&n[1][0]===n[2][0]&&(h=!0,c=function(t){return t[1]===n[0][1]})),{xmin:a,xmax:o,ymin:s,ymax:l,pts:n,contains:h?e:r,isRect:h}};var o=a.isSegmentBent=function(t,e,r,i){var a,o,s,l=t[e],u=[t[r][0]-l[0],t[r][1]-l[1]],c=n(u,u),h=Math.sqrt(c),f=[-u[1]/h,u[0]/h];for(a=e+1;a<r;a++)if(o=[t[a][0]-l[0],t[a][1]-l[1]],(s=n(o,u))<0||s>c||Math.abs(n(o,f))>i)return!0;return!1};a.filter=function(t,e){function r(r){t.push(r);var s=n.length,l=i;n.splice(a+1);for(var u=l+1;u<t.length;u++)(u===t.length-1||o(t,l,u+1,e))&&(n.push(t[u]),n.length<s-2&&(i=u,a=n.length-1),l=u)}var n=[t[0]],i=0,a=0;if(t.length>1){r(t.pop())}return{addPt:r,raw:t,filtered:n}}},{\"../constants/numerical\":705,\"./matrix\":730}],737:[function(t,e,r){\"use strict\";e.exports=function(t,e){if(e instanceof RegExp){var r,n=e.toString();for(r=0;r<t.length;r++)if(t[r]instanceof RegExp&&t[r].toString()===n)return t;t.push(e)}else e&&-1===t.indexOf(e)&&t.push(e);return t}},{}],738:[function(t,e,r){\"use strict\";function n(t,e){for(var r,n=[],a=0;a<e.length;a++)r=e[a],n[a]=r===t?r:\"object\"==typeof r?Array.isArray(r)?i.extendDeep([],r):i.extendDeepAll({},r):r;return n}var i=t(\"../lib\"),a=t(\"../plot_api/plot_config\"),o={};o.add=function(t,e,r,n,i){var o,s;if(t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},s=t.undoQueue.index,t.autoplay)return void(t.undoQueue.inSequence||(t.autoplay=!1));!t.undoQueue.sequence||t.undoQueue.beginSequence?(o={undo:{calls:[],args:[]},redo:{calls:[],args:[]}},t.undoQueue.queue.splice(s,t.undoQueue.queue.length-s,o),t.undoQueue.index+=1):o=t.undoQueue.queue[s-1],t.undoQueue.beginSequence=!1,o&&(o.undo.calls.unshift(e),o.undo.args.unshift(r),o.redo.calls.push(n),o.redo.args.push(i)),t.undoQueue.queue.length>a.queueLength&&(t.undoQueue.queue.shift(),t.undoQueue.index--)},o.startSequence=function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!0,t.undoQueue.beginSequence=!0},o.stopSequence=function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!1,t.undoQueue.beginSequence=!1},o.undo=function(t){var e,r;if(t.framework&&t.framework.isPolar)return void t.framework.undo();if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index<=0)){for(t.undoQueue.index--,e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.undo.calls.length;r++)o.plotDo(t,e.undo.calls[r],e.undo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1}},o.redo=function(t){var e,r;if(t.framework&&t.framework.isPolar)return void t.framework.redo();if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index>=t.undoQueue.queue.length)){for(e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.redo.calls.length;r++)o.plotDo(t,e.redo.calls[r],e.redo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1,t.undoQueue.index++}},o.plotDo=function(t,e,r){t.autoplay=!0,r=n(t,r),e.apply(null,r)},e.exports=o},{\"../lib\":725,\"../plot_api/plot_config\":754}],739:[function(t,e,r){\"use strict\";var n=t(\"./is_array\"),i=t(\"./is_plain_object\");e.exports=function t(e,r){for(var a=Object.keys(r||{}),o=0;o<a.length;o++){var s=a[o],l=r[s],u=e[s];if(\"_\"===s.charAt(0)||\"function\"==typeof l){if(s in e)continue;e[s]=l}else if(n(l)&&n(u)&&i(l[0]))for(var c=0;c<l.length;c++)i(l[c])&&i(u[c])&&t(u[c],l[c]);else i(l)&&i(u)&&(t(u,l),Object.keys(u).length||delete e[s])}}},{\"./is_array\":726,\"./is_plain_object\":727}],740:[function(t,e,r){\"use strict\";function n(t,e){return t<e}function i(t,e){return t<=e}function a(t,e){return t>e}function o(t,e){return t>=e}var s=t(\"fast-isnumeric\"),l=t(\"./loggers\");r.findBin=function(t,e,r){if(s(e.start))return r?Math.ceil((t-e.start)/e.size)-1:Math.floor((t-e.start)/e.size);var u,c,h=0,f=e.length,d=0;for(c=e[e.length-1]>=e[0]?r?n:i:r?o:a;h<f&&d++<100;)u=Math.floor((h+f)/2),c(e[u],t)?h=u+1:f=u;return d>90&&l.log(\"Long binary search...\"),h-1},r.sorterAsc=function(t,e){return t-e},r.sorterDes=function(t,e){return e-t},r.distinctVals=function(t){var e=t.slice();e.sort(r.sorterAsc);for(var n=e.length-1,i=e[n]-e[0]||1,a=i/(n||1)/1e4,o=[e[0]],s=0;s<n;s++)e[s+1]>e[s]+a&&(i=Math.min(i,e[s+1]-e[s]),o.push(e[s+1]));return{vals:o,minDiff:i}},r.roundUp=function(t,e,r){for(var n,i=0,a=e.length-1,o=0,s=r?0:1,l=r?1:0,u=r?Math.ceil:Math.floor;i<a&&o++<100;)n=u((i+a)/2),e[n]<=t?i=n+s:a=n-l;return e[i]}},{\"./loggers\":729,\"fast-isnumeric\":130}],741:[function(t,e,r){\"use strict\";e.exports=function(t,e){(t.attr(\"class\")||\"\").split(\" \").forEach(function(e){0===e.indexOf(\"cursor-\")&&t.classed(e,!1)}),e&&t.classed(\"cursor-\"+e,!0)}},{}],742:[function(t,e,r){\"use strict\";var n=t(\"../components/color\"),i=function(){};e.exports=function(t){for(var e in t)\"function\"==typeof t[e]&&(t[e]=i);t.destroy=function(){t.container.parentNode.removeChild(t.container)};var r=document.createElement(\"div\");return r.textContent=\"Webgl is not supported by your browser - visit http://get.webgl.org for more info\",r.style.cursor=\"pointer\",r.style.fontSize=\"24px\",r.style.color=n.defaults[0],t.container.appendChild(r),t.container.style.background=\"#FFFFFF\",t.container.onclick=function(){window.open(\"http://get.webgl.org\")},!1}},{\"../components/color\":603}],743:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");r.aggNums=function(t,e,i,a){var o,s;if(a||(a=i.length),n(e)||(e=!1),Array.isArray(i[0])){for(s=new Array(a),o=0;o<a;o++)s[o]=r.aggNums(t,e,i[o]);i=s}for(o=0;o<a;o++)n(e)?n(i[o])&&(e=t(+e,+i[o])):e=i[o];return e},r.len=function(t){return r.aggNums(function(t){return t+1},0,t)},r.mean=function(t,e){return e||(e=r.len(t)),r.aggNums(function(t,e){return t+e},0,t)/e},r.variance=function(t,e,i){return e||(e=r.len(t)),n(i)||(i=r.mean(t,e)),r.aggNums(function(t,e){return t+Math.pow(e-i,2)},0,t)/e},r.stdev=function(t,e,n){return Math.sqrt(r.variance(t,e,n))},r.interp=function(t,e){if(!n(e))throw\"n should be a finite number\";if((e=e*t.length-.5)<0)return t[0];if(e>t.length-1)return t[t.length-1];var r=e%1;return r*t[Math.ceil(e)]+(1-r)*t[Math.floor(e)]}},{\"fast-isnumeric\":130}],744:[function(t,e,r){\"use strict\";function n(t){var e=i(t);return e.length?e:[0,0,0,1]}var i=t(\"color-rgba\");e.exports=n},{\"color-rgba\":94}],745:[function(t,e,r){\"use strict\";function n(t,e){return t.node().getBoundingClientRect()[e]}function i(t){return t.replace(g,\"\\\\lt \").replace(y,\"\\\\gt \")}function a(t,e,r){var n=\"math-output-\"+f.randstr([],64),a=h.select(\"body\").append(\"div\").attr({id:n}).style({visibility:\"hidden\",position:\"absolute\"}).style({\"font-size\":e.fontSize+\"px\"}).text(i(t));MathJax.Hub.Queue([\"Typeset\",MathJax.Hub,a.node()],function(){var e=h.select(\"body\").select(\"#MathJax_SVG_glyphs\");if(a.select(\".MathJax_SVG\").empty()||!a.select(\"svg\").node())f.log(\"There was an error in the tex syntax.\",t),r();else{var n=a.select(\"svg\").node().getBoundingClientRect();r(a.select(\".MathJax_SVG\"),e,n)}a.remove()})}function o(t,e){if(!t)return null;var r=t.match(e);return r&&(r[3]||r[4])}function s(t,e){if(!t)return\"\";for(var r=0;r<e.length;r++){var n=e[r];t=t.replace(n.regExp,n.sub)}return t}function l(t){return s(t,A)}function u(t,e){function r(){c++;var e=document.createElementNS(d.svg,\"tspan\");h.select(e).attr({class:\"line\",dy:c*m+\"em\"}),t.appendChild(e),a=e;var r=u;if(u=[{node:e}],r.length>1)for(var i=1;i<r.length;i++)n(r[i])}function n(t){var e,r=t.type,n={};if(\"a\"===r){e=\"a\";var o=t.target,s=t.href,l=t.popup;s&&(n={\"xlink:xlink:show\":\"_blank\"===o||\"_\"!==o.charAt(0)?\"new\":\"replace\",target:o,\"xlink:xlink:href\":s},l&&(n.onclick='window.open(this.href.baseVal,this.target.baseVal,\"'+l+'\");return false;'))}else e=\"tspan\";t.style&&(n.style=t.style);var c=document.createElementNS(d.svg,e);if(\"sup\"===r||\"sub\"===r){i(a,w),a.appendChild(c);var f=document.createElementNS(d.svg,\"tspan\");i(f,w),h.select(f).attr(\"dy\",_[r]),n.dy=x[r],a.appendChild(c),a.appendChild(f)}else a.appendChild(c);h.select(c).attr(n),a=t.node=c,u.push(t)}function i(t,e){t.appendChild(document.createTextNode(e))}e=l(e).replace(T,\" \");var a,s=!1,u=[],c=-1;L.test(e)?r():(a=t,u=[{node:t}]);for(var p=e.split(S),v=0;v<p.length;v++){var g=p[v],y=g.match(E),k=y&&y[2].toLowerCase(),A=b[k];if(\"br\"===k)r();else if(void 0===A)i(a,g);else if(y[1])!function(t){if(1===u.length)return void f.log(\"Ignoring unexpected end tag </\"+t+\">.\",e);var r=u.pop();t!==r.type&&f.log(\"Start tag <\"+r.type+\"> doesnt match end tag <\"+t+\">. Pretending it did match.\",e),a=u[u.length-1].node}(k);else{var O=y[4],R={type:k},F=o(O,C);if(F?(F=F.replace(P,\"$1 fill:\"),A&&(F+=\";\"+A)):A&&(F=A),F&&(R.style=F),\"a\"===k){s=!0;var j=o(O,z);if(j){var N=document.createElement(\"a\");N.href=j,-1!==M.indexOf(N.protocol)&&(R.href=encodeURI(j),R.target=o(O,I)||\"_blank\",R.popup=o(O,D))}}n(R)}}return s}function c(t,e,r){var n,i,a,o=r.horizontalAlign,s=r.verticalAlign||\"top\",l=t.node().getBoundingClientRect(),u=e.node().getBoundingClientRect();return i=\"bottom\"===s?function(){return l.bottom-n.height}:\"middle\"===s?function(){return l.top+(l.height-n.height)/2}:function(){return l.top},a=\"right\"===o?function(){return l.right-n.width}:\"center\"===o?function(){return l.left+(l.width-n.width)/2}:function(){return l.left},function(){return n=this.node().getBoundingClientRect(),this.style({top:i()-u.top+\"px\",left:a()-u.left+\"px\",\"z-index\":1e3}),this}}var h=t(\"d3\"),f=t(\"../lib\"),d=t(\"../constants/xmlns_namespaces\"),p=t(\"../constants/string_mappings\"),m=t(\"../constants/alignment\").LINE_SPACING,v=/([^$]*)([$]+[^$]*[$]+)([^$]*)/;r.convertToTspans=function(t,e,i){function o(){c.empty()||(f=t.attr(\"class\")+\"-math\",c.select(\"svg.\"+f).remove()),t.text(\"\").style(\"white-space\",\"pre\"),u(t.node(),s)&&t.style(\"pointer-events\",\"all\"),r.positionText(t),i&&i.call(t)}var s=t.text(),l=!t.attr(\"data-notex\")&&\"undefined\"!=typeof MathJax&&s.match(v),c=h.select(t.node().parentNode);if(!c.empty()){var f=t.attr(\"class\")?t.attr(\"class\").split(\" \")[0]:\"text\";return f+=\"-math\",c.selectAll(\"svg.\"+f).remove(),c.selectAll(\"g.\"+f+\"-group\").remove(),t.style(\"display\",null).attr({\"data-unformatted\":s,\"data-math\":\"N\"}),l?(e&&e._promises||[]).push(new Promise(function(e){t.style(\"display\",\"none\");var r={fontSize:parseInt(t.style(\"font-size\"),10)};a(l[2],r,function(r,a,l){c.selectAll(\"svg.\"+f).remove(),c.selectAll(\"g.\"+f+\"-group\").remove();var u=r&&r.select(\"svg\");if(!u||!u.node())return o(),void e();var h=c.append(\"g\").classed(f+\"-group\",!0).attr({\"pointer-events\":\"none\",\"data-unformatted\":s,\"data-math\":\"Y\"});h.node().appendChild(u.node()),a&&a.node()&&u.node().insertBefore(a.node().cloneNode(!0),u.node().firstChild),u.attr({class:f,height:l.height,preserveAspectRatio:\"xMinYMin meet\"}).style({overflow:\"visible\",\"pointer-events\":\"none\"});var d=t.style(\"fill\")||\"black\";u.select(\"g\").attr({fill:d,stroke:d});var p=n(u,\"width\"),m=n(u,\"height\"),v=+t.attr(\"x\")-p*{start:0,middle:.5,end:1}[t.attr(\"text-anchor\")||\"start\"],g=parseInt(t.style(\"font-size\"),10)||n(t,\"height\"),y=-g/4;\"y\"===f[0]?(h.attr({transform:\"rotate(\"+[-90,+t.attr(\"x\"),+t.attr(\"y\")]+\") translate(\"+[-p/2,y-m/2]+\")\"}),u.attr({x:+t.attr(\"x\"),y:+t.attr(\"y\")})):\"l\"===f[0]?u.attr({x:t.attr(\"x\"),y:y-m/2}):\"a\"===f[0]?u.attr({x:0,y:y}):u.attr({x:v,y:+t.attr(\"y\")+y-m/2}),i&&i.call(t,h),e(h)})})):o(),t}};var g=/(<|&lt;|&#60;)/g,y=/(>|&gt;|&#62;)/g,b={sup:\"font-size:70%\",sub:\"font-size:70%\",b:\"font-weight:bold\",i:\"font-style:italic\",a:\"cursor:pointer\",span:\"\",em:\"font-style:italic;font-weight:bold\"},x={sub:\"0.3em\",sup:\"-0.6em\"},_={sub:\"-0.21em\",sup:\"0.42em\"},w=\"\\u200b\",M=[\"http:\",\"https:\",\"mailto:\",\"\",void 0,\":\"],k=new RegExp(\"</?(\"+Object.keys(b).join(\"|\")+\")( [^>]*)?/?>\",\"g\"),A=Object.keys(p.entityToUnicode).map(function(t){return{regExp:new RegExp(\"&\"+t+\";\",\"g\"),sub:p.entityToUnicode[t]}}),T=/(\\r\\n?|\\n)/g,S=/(<[^<>]*>)/,E=/<(\\/?)([^ >]*)(\\s+(.*))?>/i,L=/<br(\\s+.*)?>/i,C=/(^|[\\s\"'])style\\s*=\\s*(\"([^\"]*);?\"|'([^']*);?')/i,z=/(^|[\\s\"'])href\\s*=\\s*(\"([^\"]*)\"|'([^']*)')/i,I=/(^|[\\s\"'])target\\s*=\\s*(\"([^\"\\s]*)\"|'([^'\\s]*)')/i,D=/(^|[\\s\"'])popup\\s*=\\s*(\"([\\w=,]*)\"|'([\\w=,]*)')/i,P=/(^|;)\\s*color:/;r.plainText=function(t){return(t||\"\").replace(k,\" \")},r.lineCount=function(t){return t.selectAll(\"tspan.line\").size()||1},r.positionText=function(t,e,r){return t.each(function(){function t(t,e){return void 0===e?null===(e=n.attr(t))&&(n.attr(t,0),e=0):n.attr(t,e),e}var n=h.select(this),i=t(\"x\",e),a=t(\"y\",r);\"text\"===this.nodeName&&n.selectAll(\"tspan.line\").attr({x:i,y:a})})},r.makeEditable=function(t,e){function r(){i(),t.style({opacity:0})\n",
       ";var e,r=l.attr(\"class\");(e=r?\".\"+r.split(\" \")[0]+\"-math-group\":\"[class*=-math-group]\")&&h.select(t.node().parentNode).select(e).style({opacity:0})}function n(t){var e=t.node(),r=document.createRange();r.selectNodeContents(e);var n=window.getSelection();n.removeAllRanges(),n.addRange(r),e.focus()}function i(){var r=h.select(a),i=r.select(\".svg-container\"),o=i.append(\"div\");o.classed(\"plugin-editable editable\",!0).style({position:\"absolute\",\"font-family\":t.style(\"font-family\")||\"Arial\",\"font-size\":t.style(\"font-size\")||12,color:e.fill||t.style(\"fill\")||\"black\",opacity:1,\"background-color\":e.background||\"transparent\",outline:\"#ffffff33 1px solid\",margin:[-parseFloat(t.style(\"font-size\"))/8+1,0,0,-1].join(\"px \")+\"px\",padding:\"0\",\"box-sizing\":\"border-box\"}).attr({contenteditable:!0}).text(e.text||t.attr(\"data-unformatted\")).call(c(t,i,e)).on(\"blur\",function(){a._editing=!1,t.text(this.textContent).style({opacity:1});var e,r=h.select(this).attr(\"class\");(e=r?\".\"+r.split(\" \")[0]+\"-math-group\":\"[class*=-math-group]\")&&h.select(t.node().parentNode).select(e).style({opacity:0});var n=this.textContent;h.select(this).transition().duration(0).remove(),h.select(document).on(\"mouseup\",null),s.edit.call(t,n)}).on(\"focus\",function(){var t=this;a._editing=!0,h.select(document).on(\"mouseup\",function(){if(h.event.target===t)return!1;document.activeElement===o.node()&&o.node().blur()})}).on(\"keyup\",function(){27===h.event.which?(a._editing=!1,t.style({opacity:1}),h.select(this).style({opacity:0}).on(\"blur\",function(){return!1}).transition().remove(),s.cancel.call(t,this.textContent)):(s.input.call(t,this.textContent),h.select(this).call(c(t,i,e)))}).on(\"keydown\",function(){13===h.event.which&&this.blur()}).call(n)}var a=e.gd,o=e.delegate,s=h.dispatch(\"edit\",\"input\",\"cancel\"),l=o||t;if(t.style({\"pointer-events\":o?\"none\":\"all\"}),1!==t.size())throw new Error(\"boo\");return e.immediate?r():l.on(\"click\",r),h.rebind(t,s,\"on\")}},{\"../constants/alignment\":699,\"../constants/string_mappings\":706,\"../constants/xmlns_namespaces\":707,\"../lib\":725,d3:121}],746:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t,e){if(t>0)return Math.log(t)/Math.LN10;var r=Math.log(Math.min(e[0],e[1]))/Math.LN10;return n(r)||(r=Math.log(Math.max(e[0],e[1]))/Math.LN10-6),r}},{\"fast-isnumeric\":130}],747:[function(t,e,r){\"use strict\";var n=e.exports={},i=t(\"../plots/geo/constants\").locationmodeToLayer,a=t(\"topojson-client\").feature;n.getTopojsonName=function(t){return[t.scope.replace(/ /g,\"-\"),\"_\",t.resolution.toString(),\"m\"].join(\"\")},n.getTopojsonPath=function(t,e){return t+e+\".json\"},n.getTopojsonFeatures=function(t,e){var r=i[t.locationmode],n=e.objects[r];return a(e,n).features}},{\"../plots/geo/constants\":792,\"topojson-client\":535}],748:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Float32Array(e),n=0;n<e;n++)r[n]=t[n];return r}function i(t,e){for(var r=new Float64Array(e),n=0;n<e;n++)r[n]=t[n];return r}e.exports=function(t,e){if(t instanceof Float32Array)return n(t,e);if(t instanceof Float64Array)return i(t,e);throw new Error(\"This array type is not yet supported by `truncate`.\")}},{}],749:[function(t,e,r){\"use strict\";var n=t(\"../registry\");e.exports=function(t){for(var e,r,i=n.layoutArrayContainers,a=n.layoutArrayRegexes,o=t.split(\"[\")[0],s=0;s<a.length;s++)if((r=t.match(a[s]))&&0===r.index){e=r[0];break}if(e||(e=i[i.indexOf(o)]),!e)return!1;var l=t.substr(e.length);return l?!!(r=l.match(/^\\[(0|[1-9][0-9]*)\\](\\.(.+))?$/))&&{array:e,index:Number(r[1]),property:r[3]||\"\"}:{array:e,index:\"\",property:\"\"}}},{\"../registry\":844}],750:[function(t,e,r){\"use strict\";e.exports={traces:function(){return{docalc:!1,docalcAutorange:!1,doplot:!1,dostyle:!1,docolorbars:!1,autorangeOn:!1,clearCalc:!1,fullReplot:!1}},layout:function(){return{dolegend:!1,doticks:!1,dolayoutstyle:!1,doplot:!1,docalc:!1,domodebar:!1,docamera:!1,layoutReplot:!1}},update:function(t,e){var r=e.editType;if(r)for(var n=r.split(\"+\"),i=0;i<n.length;i++)t[n[i]]=!0}}},{}],751:[function(t,e,r){\"use strict\";function n(t,e){var r=t[e],n=e.charAt(0);r&&\"paper\"!==r&&(t[e]=f.cleanId(r,n))}function i(t){var e=\"middle\",r=\"center\";return-1!==t.indexOf(\"top\")?e=\"top\":-1!==t.indexOf(\"bottom\")&&(e=\"bottom\"),-1!==t.indexOf(\"left\")?r=\"left\":-1!==t.indexOf(\"right\")&&(r=\"right\"),e+\" \"+r}function a(t,e){return e in t&&\"object\"==typeof t[e]&&0===Object.keys(t[e]).length}function o(t){var e=t.search(p);if(e>0)return t.substr(0,e)}var s=t(\"fast-isnumeric\"),l=t(\"gl-mat4/fromQuat\"),u=t(\"../registry\"),c=t(\"../lib\"),h=t(\"../plots/plots\"),f=t(\"../plots/cartesian/axes\"),d=t(\"../components/color\");r.getGraphDiv=function(t){var e;if(\"string\"==typeof t){if(null===(e=document.getElementById(t)))throw new Error(\"No DOM element with id '\"+t+\"' exists on the page.\");return e}if(null===t||void 0===t)throw new Error(\"DOM element provided is null or undefined\");return t},r.clearPromiseQueue=function(t){Array.isArray(t._promises)&&t._promises.length>0&&c.log(\"Clearing previous rejected promises from queue.\"),t._promises=[]},r.cleanLayout=function(t){var e,r;t||(t={}),t.xaxis1&&(t.xaxis||(t.xaxis=t.xaxis1),delete t.xaxis1),t.yaxis1&&(t.yaxis||(t.yaxis=t.yaxis1),delete t.yaxis1);var i=f.list({_fullLayout:t});for(e=0;e<i.length;e++){var o=i[e];o.anchor&&\"free\"!==o.anchor&&(o.anchor=f.cleanId(o.anchor)),o.overlaying&&(o.overlaying=f.cleanId(o.overlaying)),o.type||(o.isdate?o.type=\"date\":o.islog?o.type=\"log\":!1===o.isdate&&!1===o.islog&&(o.type=\"linear\")),\"withzero\"!==o.autorange&&\"tozero\"!==o.autorange||(o.autorange=!0,o.rangemode=\"tozero\"),delete o.islog,delete o.isdate,delete o.categories,a(o,\"domain\")&&delete o.domain,void 0!==o.autotick&&(void 0===o.tickmode&&(o.tickmode=o.autotick?\"auto\":\"linear\"),delete o.autotick)}var s=Array.isArray(t.annotations)?t.annotations.length:0;for(e=0;e<s;e++){var u=t.annotations[e];c.isPlainObject(u)&&(u.ref&&(\"paper\"===u.ref?(u.xref=\"paper\",u.yref=\"paper\"):\"data\"===u.ref&&(u.xref=\"x\",u.yref=\"y\"),delete u.ref),n(u,\"xref\"),n(u,\"yref\"))}var p=Array.isArray(t.shapes)?t.shapes.length:0;for(e=0;e<p;e++){var m=t.shapes[e];c.isPlainObject(m)&&(n(m,\"xref\"),n(m,\"yref\"))}var v=t.legend;v&&(v.x>3?(v.x=1.02,v.xanchor=\"left\"):v.x<-2&&(v.x=-.02,v.xanchor=\"right\"),v.y>3?(v.y=1.02,v.yanchor=\"bottom\"):v.y<-2&&(v.y=-.02,v.yanchor=\"top\")),\"rotate\"===t.dragmode&&(t.dragmode=\"orbit\"),t.scene1&&(t.scene||(t.scene=t.scene1),delete t.scene1);var g=h.getSubplotIds(t,\"gl3d\");for(e=0;e<g.length;e++){var y=t[g[e]],b=y.cameraposition;if(Array.isArray(b)&&4===b[0].length){var x=b[0],_=b[1],w=b[2],M=l([],x),k=[];for(r=0;r<3;++r)k[r]=_[e]+w*M[2+4*r];y.camera={eye:{x:k[0],y:k[1],z:k[2]},center:{x:_[0],y:_[1],z:_[2]},up:{x:M[1],y:M[5],z:M[9]}},delete y.cameraposition}}return d.clean(t),t},r.cleanData=function(t,e){for(var n=[],o=(t.concat(Array.isArray(e)?e:[]).filter(function(t){return\"uid\"in t}).map(function(t){return t.uid})),s=0;s<t.length;s++){var l,p=t[s];if(!(\"uid\"in p)||-1!==n.indexOf(p.uid)){var m;for(l=0;l<100&&(m=c.randstr(o),-1!==n.indexOf(m));l++);p.uid=c.randstr(o),o.push(p.uid)}if(n.push(p.uid),\"histogramy\"===p.type&&\"xbins\"in p&&!(\"ybins\"in p)&&(p.ybins=p.xbins,delete p.xbins),p.error_y&&\"opacity\"in p.error_y){var v=d.defaults,g=p.error_y.color||(u.traceIs(p,\"bar\")?d.defaultLine:v[s%v.length]);p.error_y.color=d.addOpacity(d.rgb(g),d.opacity(g)*p.error_y.opacity),delete p.error_y.opacity}if(\"bardir\"in p&&(\"h\"!==p.bardir||!u.traceIs(p,\"bar\")&&\"histogram\"!==p.type.substr(0,9)||(p.orientation=\"h\",r.swapXYData(p)),delete p.bardir),\"histogramy\"===p.type&&r.swapXYData(p),\"histogramx\"!==p.type&&\"histogramy\"!==p.type||(p.type=\"histogram\"),\"scl\"in p&&(p.colorscale=p.scl,delete p.scl),\"reversescl\"in p&&(p.reversescale=p.reversescl,delete p.reversescl),p.xaxis&&(p.xaxis=f.cleanId(p.xaxis,\"x\")),p.yaxis&&(p.yaxis=f.cleanId(p.yaxis,\"y\")),u.traceIs(p,\"gl3d\")&&p.scene&&(p.scene=h.subplotsRegistry.gl3d.cleanId(p.scene)),u.traceIs(p,\"pie\")||u.traceIs(p,\"bar\")||(Array.isArray(p.textposition)?p.textposition=p.textposition.map(i):p.textposition&&(p.textposition=i(p.textposition))),u.traceIs(p,\"2dMap\")&&(\"YIGnBu\"===p.colorscale&&(p.colorscale=\"YlGnBu\"),\"YIOrRd\"===p.colorscale&&(p.colorscale=\"YlOrRd\")),u.traceIs(p,\"markerColorscale\")&&p.marker){var y=p.marker;\"YIGnBu\"===y.colorscale&&(y.colorscale=\"YlGnBu\"),\"YIOrRd\"===y.colorscale&&(y.colorscale=\"YlOrRd\")}if(\"surface\"===p.type&&c.isPlainObject(p.contours)){var b=[\"x\",\"y\",\"z\"];for(l=0;l<b.length;l++){var x=p.contours[b[l]];c.isPlainObject(x)&&(x.highlightColor&&(x.highlightcolor=x.highlightColor,delete x.highlightColor),x.highlightWidth&&(x.highlightwidth=x.highlightWidth,delete x.highlightWidth))}}if(Array.isArray(p.transforms)){var _=p.transforms;for(l=0;l<_.length;l++){var w=_[l];if(c.isPlainObject(w))switch(w.type){case\"filter\":w.filtersrc&&(w.target=w.filtersrc,delete w.filtersrc),w.calendar&&(w.valuecalendar||(w.valuecalendar=w.calendar),delete w.calendar);break;case\"groupby\":if(w.styles=w.styles||w.style,w.styles&&!Array.isArray(w.styles)){var M=w.styles,k=Object.keys(M);w.styles=[];for(var A=0;A<k.length;A++)w.styles.push({target:k[A],value:M[k[A]]})}}}}a(p,\"line\")&&delete p.line,\"marker\"in p&&(a(p.marker,\"line\")&&delete p.marker.line,a(p,\"marker\")&&delete p.marker),d.clean(p)}},r.swapXYData=function(t){var e;if(c.swapAttrs(t,[\"?\",\"?0\",\"d?\",\"?bins\",\"nbins?\",\"autobin?\",\"?src\",\"error_?\"]),Array.isArray(t.z)&&Array.isArray(t.z[0])&&(t.transpose?delete t.transpose:t.transpose=!0),t.error_x&&t.error_y){var r=t.error_y,n=\"copy_ystyle\"in r?r.copy_ystyle:!(r.color||r.thickness||r.width);c.swapAttrs(t,[\"error_?.copy_ystyle\"]),n&&c.swapAttrs(t,[\"error_?.color\",\"error_?.thickness\",\"error_?.width\"])}if(\"string\"==typeof t.hoverinfo){var i=t.hoverinfo.split(\"+\");for(e=0;e<i.length;e++)\"x\"===i[e]?i[e]=\"y\":\"y\"===i[e]&&(i[e]=\"x\");t.hoverinfo=i.join(\"+\")}},r.coerceTraceIndices=function(t,e){return s(e)?[e]:Array.isArray(e)&&e.length?e:t.data.map(function(t,e){return e})},r.manageArrayContainers=function(t,e,r){var n=t.obj,i=t.parts,a=i.length,o=i[a-1],l=s(o);if(l&&null===e){var u=i.slice(0,a-1).join(\".\");c.nestedProperty(n,u).get().splice(o,1)}else l&&void 0===t.get()?(void 0===t.get()&&(r[t.astr]=null),t.set(e)):t.set(e)};var p=/(\\.[^\\[\\]\\.]+|\\[[^\\[\\]\\.]+\\])$/;r.hasParent=function(t,e){for(var r=o(e);r;){if(r in t)return!0;r=o(r)}return!1}},{\"../components/color\":603,\"../lib\":725,\"../plots/cartesian/axes\":766,\"../plots/plots\":829,\"../registry\":844,\"fast-isnumeric\":130,\"gl-mat4/fromQuat\":177}],752:[function(t,e,r){\"use strict\";var n=t(\"../lib/nested_property\"),i=t(\"../lib/is_plain_object\"),a=t(\"../lib/noop\"),o=t(\"../lib/loggers\"),s=t(\"../lib/search\").sorterAsc,l=t(\"../registry\");r.containerArrayMatch=t(\"./container_array_match\");var u=r.isAddVal=function(t){return\"add\"===t||i(t)},c=r.isRemoveVal=function(t){return null===t||\"remove\"===t};r.applyContainerArrayChanges=function(t,e,r,i){var h=e.astr,f=l.getComponentMethod(h,\"supplyLayoutDefaults\"),d=l.getComponentMethod(h,\"draw\"),p=l.getComponentMethod(h,\"drawOne\"),m=i.replot||i.recalc||f===a||d===a,v=t.layout,g=t._fullLayout;if(r[\"\"]){Object.keys(r).length>1&&o.warn(\"Full array edits are incompatible with other edits\",h);var y=r[\"\"][\"\"];if(c(y))e.set(null);else{if(!Array.isArray(y))return o.warn(\"Unrecognized full array edit value\",h,y),!0;e.set(y)}return!m&&(f(v,g),d(t),!0)}var b,x,_,w,M,k,A,T=Object.keys(r).map(Number).sort(s),S=e.get(),E=S||[],L=n(g,h).get(),C=[],z=-1,I=E.length;for(b=0;b<T.length;b++)if(_=T[b],w=r[_],M=Object.keys(w),k=w[\"\"],A=u(k),_<0||_>E.length-(A?0:1))o.warn(\"index out of range\",h,_);else if(void 0!==k)M.length>1&&o.warn(\"Insertion & removal are incompatible with edits to the same index.\",h,_),c(k)?C.push(_):A?(\"add\"===k&&(k={}),E.splice(_,0,k),L&&L.splice(_,0,{})):o.warn(\"Unrecognized full object edit value\",h,_,k),-1===z&&(z=_);else for(x=0;x<M.length;x++)n(E[_],M[x]).set(w[M[x]]);for(b=C.length-1;b>=0;b--)E.splice(C[b],1),L&&L.splice(C[b],1);if(E.length?S||e.set(E):e.set(null),m)return!1;if(f(v,g),p!==a){var D;if(-1===z)D=T;else{for(I=Math.max(E.length,I),D=[],b=0;b<T.length&&!((_=T[b])>=z);b++)D.push(_);for(b=z;b<I;b++)D.push(b)}for(b=0;b<D.length;b++)p(t,D[b])}else d(t);return!0}},{\"../lib/is_plain_object\":727,\"../lib/loggers\":729,\"../lib/nested_property\":732,\"../lib/noop\":733,\"../lib/search\":740,\"../registry\":844,\"./container_array_match\":749}],753:[function(t,e,r){\"use strict\";function n(t,e){try{t._fullLayout._paper.style(\"background\",e)}catch(t){_.error(t)}}function i(t,e){n(t,L.combine(e,\"white\"))}function a(t,e){t._context||(t._context=_.extendDeep({},x.defaultConfig));var r,a,o,s=t._context;if(e){for(a=Object.keys(e),r=0;r<a.length;r++)\"editable\"!==(o=a[r])&&\"edits\"!==o&&o in s&&(\"setBackground\"===o&&\"opaque\"===e[o]?s[o]=i:s[o]=e[o]);e.plot3dPixelRatio&&!s.plotGlPixelRatio&&(s.plotGlPixelRatio=s.plot3dPixelRatio);var l=e.editable;if(void 0!==l)for(s.editable=l,a=Object.keys(s.edits),r=0;r<a.length;r++)s.edits[a[r]]=l;if(e.edits)for(a=Object.keys(e.edits),r=0;r<a.length;r++)(o=a[r])in s.edits&&(s.edits[o]=e.edits[o])}s.staticPlot&&(s.editable=!1,s.edits={},s.autosizable=!1,s.scrollZoom=!1,s.doubleClick=!1,s.showTips=!1,s.showLink=!1,s.displayModeBar=!1),\"hover\"!==s.displayModeBar||b||(s.displayModeBar=!0),\"transparent\"!==s.setBackground&&\"function\"==typeof s.setBackground||(s.setBackground=n)}function o(t,e,r){var n=g.select(t).selectAll(\".plot-container\").data([0]);n.enter().insert(\"div\",\":first-child\").classed(\"plot-container plotly\",!0);var i=n.selectAll(\".svg-container\").data([0]);i.enter().append(\"div\").classed(\"svg-container\",!0).style(\"position\",\"relative\"),i.html(\"\"),e&&(t.data=e),r&&(t.layout=r),T.manager.fillLayout(t),i.style({width:t._fullLayout.width+\"px\",height:t._fullLayout.height+\"px\"}),t.framework=T.manager.framework(t),t.framework({data:t.data,layout:t.layout},i.node()),t.framework.setUndoPoint();var a=t.framework.svg(),o=1,s=t._fullLayout.title;\"\"!==s&&s||(o=0);var l=function(){this.call(I.convertToTspans,t)},u=a.select(\".title-group text\").call(l);if(t._context.edits.titleText){s&&\"Click to enter title\"!==s||(o=.2,u.attr({\"data-unformatted\":\"Click to enter title\"}).text(\"Click to enter title\").style({opacity:o}).on(\"mouseover.opacity\",function(){g.select(this).transition().duration(100).style(\"opacity\",1)}).on(\"mouseout.opacity\",function(){g.select(this).transition().duration(1e3).style(\"opacity\",0)}));var c=function(){this.call(I.makeEditable,{gd:t}).on(\"edit\",function(e){t.framework({layout:{title:e}}),this.text(e).call(l),this.call(c)}).on(\"cancel\",function(){var t=this.attr(\"data-unformatted\");this.text(t).call(l)})};u.call(c)}return t._context.setBackground(t,t._fullLayout.paper_bgcolor),A.addLinks(t),Promise.resolve()}function s(t,e){var r,n,i=e+1,a=[];for(r=0;r<t.length;r++)n=t[r],n<0?a.push(i+n):a.push(n);return a}function l(t,e,r){var n,i;for(n=0;n<e.length;n++){if((i=e[n])!==parseInt(i,10))throw new Error(\"all values in \"+r+\" must be integers\");if(i>=t.data.length||i<-t.data.length)throw new Error(r+\" must be valid indices for gd.data.\");if(e.indexOf(i,n+1)>-1||i>=0&&e.indexOf(-t.data.length+i)>-1||i<0&&e.indexOf(t.data.length+i)>-1)throw new Error(\"each index in \"+r+\" must be unique.\")}}function u(t,e,r){if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array.\");if(void 0===e)throw new Error(\"currentIndices is a required argument.\");if(Array.isArray(e)||(e=[e]),l(t,e,\"currentIndices\"),void 0===r||Array.isArray(r)||(r=[r]),void 0!==r&&l(t,r,\"newIndices\"),void 0!==r&&e.length!==r.length)throw new Error(\"current and new indices must be of equal length.\")}function c(t,e,r){var n,i;if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array.\");if(void 0===e)throw new Error(\"traces must be defined.\");for(Array.isArray(e)||(e=[e]),n=0;n<e.length;n++)if(\"object\"!=typeof(i=e[n])||Array.isArray(i)||null===i)throw new Error(\"all values in traces array must be non-array objects\");if(void 0===r||Array.isArray(r)||(r=[r]),void 0!==r&&r.length!==e.length)throw new Error(\"if indices is specified, traces.length must equal indices.length\")}function h(t,e,r,n){var i=_.isPlainObject(n);if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array\");if(!_.isPlainObject(e))throw new Error(\"update must be a key:value object\");if(void 0===r)throw new Error(\"indices must be an integer or array of integers\");l(t,r,\"indices\");for(var a in e){if(!Array.isArray(e[a])||e[a].length!==r.length)throw new Error(\"attribute \"+a+\" must be an array of length equal to indices array length\");if(i&&(!(a in n)||!Array.isArray(n[a])||n[a].length!==e[a].length))throw new Error(\"when maxPoints is set as a key:value object it must contain a 1:1 corrispondence with the keys and number of traces in the update object\")}}function f(t,e,r,n){var i,a,o,l,u,c=_.isPlainObject(n),h=[];Array.isArray(r)||(r=[r]),r=s(r,t.data.length-1);for(var f in e)for(var d=0;d<r.length;d++){if(i=t.data[r[d]],o=_.nestedProperty(i,f),a=o.get(),l=e[f][d],!Array.isArray(l))throw new Error(\"attribute: \"+f+\" index: \"+d+\" must be an array\");if(!Array.isArray(a))throw new Error(\"cannot extend missing or non-array attribute: \"+f);u=c?n[f][d]:n,y(u)||(u=-1),h.push({prop:o,target:a,insert:l,maxp:Math.floor(u)})}return h}function d(t,e,r,n,i,a){h(t,e,r,n);for(var o,s,l,u=f(t,e,r,n),c=[],d={},p={},m=0;m<u.length;m++)s=u[m].prop,l=u[m].maxp,o=i(u[m].target,u[m].insert),l>=0&&l<o.length&&(c=a(o,l)),l=u[m].target.length,s.set(o),Array.isArray(d[s.astr])||(d[s.astr]=[]),Array.isArray(p[s.astr])||(p[s.astr]=[]),d[s.astr].push(c),p[s.astr].push(l);return{update:d,maxPoints:p}}function p(t,e,r){function n(){return d.map(function(){})}function i(t){var e=x.Axes.id2name(t);-1===u.indexOf(e)&&u.push(e)}function a(t){return\"LAYOUT\"+t+\".autorange\"}function o(t){return\"LAYOUT\"+t+\".range\"}function s(r,i,a){if(Array.isArray(r))return void r.forEach(function(t){s(t,i,a)});if(!(r in e||P.hasParent(e,r))){var o;o=\"LAYOUT\"===r.substr(0,6)?_.nestedProperty(t.layout,r.replace(\"LAYOUT\",\"\")):_.nestedProperty(f[d[a]],r),r in v||(v[r]=n()),void 0===v[r][a]&&(v[r][a]=o.get()),void 0!==i&&o.set(i)}}var l,u,c=t._fullLayout,h=t._fullData,f=t.data,d=P.coerceTraceIndices(t,r),p=R.traces(),m={},v={},g={},y=[\"mode\",\"visible\",\"type\",\"orientation\",\"fill\",\"histfunc\",\"histnorm\",\"text\",\"x\",\"y\",\"z\",\"a\",\"b\",\"c\",\"open\",\"high\",\"low\",\"close\",\"base\",\"width\",\"offset\",\"xtype\",\"x0\",\"dx\",\"ytype\",\"y0\",\"dy\",\"xaxis\",\"yaxis\",\"line.width\",\"connectgaps\",\"transpose\",\"zsmooth\",\"showscale\",\"marker.showscale\",\"zauto\",\"marker.cauto\",\"autocolorscale\",\"marker.autocolorscale\",\"colorscale\",\"marker.colorscale\",\"reversescale\",\"marker.reversescale\",\"autobinx\",\"nbinsx\",\"xbins\",\"xbins.start\",\"xbins.end\",\"xbins.size\",\"autobiny\",\"nbinsy\",\"ybins\",\"ybins.start\",\"ybins.end\",\"ybins.size\",\"error_y\",\"error_y.visible\",\"error_y.value\",\"error_y.type\",\"error_y.traceref\",\"error_y.array\",\"error_y.symmetric\",\"error_y.arrayminus\",\"error_y.valueminus\",\"error_y.tracerefminus\",\"error_x\",\"error_x.visible\",\"error_x.value\",\"error_x.type\",\"error_x.traceref\",\"error_x.array\",\"error_x.symmetric\",\"error_x.arrayminus\",\"error_x.valueminus\",\"error_x.tracerefminus\",\"swapxy\",\"swapxyaxes\",\"orientationaxes\",\"marker.colors\",\"values\",\"labels\",\"label0\",\"dlabel\",\"sort\",\"textinfo\",\"textposition\",\"textfont.size\",\"textfont.family\",\"textfont.color\",\"insidetextfont.size\",\"insidetextfont.family\",\"insidetextfont.color\",\"outsidetextfont.size\",\"outsidetextfont.family\",\"outsidetextfont.color\",\"hole\",\"scalegroup\",\"domain\",\"domain.x\",\"domain.y\",\"domain.x[0]\",\"domain.x[1]\",\"domain.y[0]\",\"domain.y[1]\",\"tilt\",\"tiltaxis\",\"depth\",\"direction\",\"rotation\",\"pull\",\"line.showscale\",\"line.cauto\",\"line.autocolorscale\",\"line.reversescale\",\"marker.line.showscale\",\"marker.line.cauto\",\"marker.line.autocolorscale\",\"marker.line.reversescale\",\"xcalendar\",\"ycalendar\",\"cumulative\",\"cumulative.enabled\",\"cumulative.direction\",\"cumulative.currentbin\",\"a0\",\"da\",\"b0\",\"db\",\"atype\",\"btype\",\"cheaterslope\",\"carpet\",\"sum\"],b=[\"color\",\"smoothing\",\"title\",\"titlefont\",\"titlefont.size\",\"titlefont.family\",\"titlefont.color\",\"titleoffset\",\"type\",\"autorange\",\"rangemode\",\"range\",\"fixedrange\",\"cheatertype\",\"tickmode\",\"nticks\",\"tickvals\",\"ticktext\",\"ticks\",\"mirror\",\"ticklen\",\"tickwidth\",\"tickcolor\",\"showticklabels\",\"tickfont\",\"tickfont.size\",\"tickfont.family\",\"tickfont.color\",\"tickprefix\",\"showtickprefix\",\"ticksuffix\",\"showticksuffix\",\"showexponent\",\"exponentformat\",\"separatethousands\",\"tickformat\",\"categoryorder\",\"categoryarray\",\"labelpadding\",\"labelprefix\",\"labelsuffix\",\"labelfont\",\"labelfont.family\",\"labelfont.size\",\"labelfont.color\",\"showline\",\"linecolor\",\"linewidth\",\"gridcolor\",\"gridwidth\",\"showgrid\",\"minorgridcount\",\"minorgridwidth\",\"minorgridcolor\",\"startline\",\"startlinecolor\",\"startlinewidth\",\"endline\",\"endlinewidth\",\"endlinecolor\",\"tick0\",\"dtick\",\"arraytick0\",\"arraydtick\",\"hoverformat\",\"tickangle\"];for(l=0;l<b.length;l++)y.push(\"aaxis.\"+b[l]),y.push(\"baxis.\"+b[l]);for(l=0;l<d.length;l++)if(k.traceIs(h[d[l]],\"box\")){y.push(\"name\");break}var w=[\"marker\",\"marker.size\",\"textfont\",\"boxpoints\",\"jitter\",\"pointpos\",\"whiskerwidth\",\"boxmean\",\"tickwidth\"],M=[\"zmin\",\"zmax\",\"zauto\",\"xgap\",\"ygap\",\"marker.cmin\",\"marker.cmax\",\"marker.cauto\",\"line.cmin\",\"line.cmax\",\"marker.line.cmin\",\"marker.line.cmax\",\"line\",\"line.smoothing\",\"line.shape\",\"error_y.width\",\"error_x.width\",\"error_x.copy_ystyle\",\"marker.maxdisplayed\"],T=[\"type\",\"x\",\"y\",\"x0\",\"y0\",\"orientation\",\"xaxis\",\"yaxis\"],S=[\"zmin\",\"zmax\"],E=[\"cmin\",\"cmax\"],L=[\"xbins.start\",\"xbins.end\",\"xbins.size\"],C=[\"ybins.start\",\"ybins.end\",\"ybins.size\"],z=[\"contours.start\",\"contours.end\",\"contours.size\"],I=[\"cartesian\",\"pie\",\"ternary\"];c._basePlotModules.forEach(function(t){-1===I.indexOf(t.name)&&(p.docalc=!0)});for(var D in e){if(P.hasParent(e,D))throw new Error(\"cannot set \"+D+\"and a parent attribute simultaneously\");var O,F,j,N,B,U=e[D];if(m[D]=U,\"LAYOUT\"!==D.substr(0,6)){for(v[D]=n(),l=0;l<d.length;l++)if(O=f[d[l]],F=h[d[l]],j=_.nestedProperty(O,D),N=j.get(),void 0!==(B=Array.isArray(U)?U[l%U.length]:U)){if(-1!==S.indexOf(D)&&s(\"zauto\",!1,l),-1!==E.indexOf(D))s(\"cauto\",!1,l);else if(\"colorscale\"===D)s(\"autocolorscale\",!1,l);else if(\"autocolorscale\"===D)s(\"colorscale\",void 0,l);else if(\"marker.colorscale\"===D)s(\"marker.autocolorscale\",!1,l);else if(\"marker.autocolorscale\"===D)s(\"marker.colorscale\",void 0,l);else if(\"zauto\"===D)s(S,void 0,l);else if(-1!==L.indexOf(D))s(\"autobinx\",!1,l);else if(\"autobinx\"===D)s(L,void 0,l);else if(-1!==C.indexOf(D))s(\"autobiny\",!1,l);else if(\"autobiny\"===D)s(C,void 0,l);else if(-1!==z.indexOf(D))s(\"autocontour\",!1,l);else if(\"autocontour\"===D)s(z,void 0,l);else if(-1!==[\"x0\",\"dx\"].indexOf(D)&&F.x&&\"scaled\"!==F.xtype)s(\"xtype\",\"scaled\",l);else if(-1!==[\"y0\",\"dy\"].indexOf(D)&&F.y&&\"scaled\"!==F.ytype)s(\"ytype\",\"scaled\",l);else if(\"colorbar.thicknessmode\"===D&&j.get()!==B&&-1!==[\"fraction\",\"pixels\"].indexOf(B)&&F.colorbar){var V=-1!==[\"top\",\"bottom\"].indexOf(F.colorbar.orient)?c.height-c.margin.t-c.margin.b:c.width-c.margin.l-c.margin.r;s(\"colorbar.thickness\",F.colorbar.thickness*(\"fraction\"===B?1/V:V),l)}else if(\"colorbar.lenmode\"===D&&j.get()!==B&&-1!==[\"fraction\",\"pixels\"].indexOf(B)&&F.colorbar){var H=-1!==[\"top\",\"bottom\"].indexOf(F.colorbar.orient)?c.width-c.margin.l-c.margin.r:c.height-c.margin.t-c.margin.b;s(\"colorbar.len\",F.colorbar.len*(\"fraction\"===B?1/H:H),l)}else\"colorbar.tick0\"===D||\"colorbar.dtick\"===D?s(\"colorbar.tickmode\",\"linear\",l):\"colorbar.tickmode\"===D&&s([\"colorbar.tick0\",\"colorbar.dtick\"],void 0,l);if(\"type\"===D&&\"pie\"===B!=(\"pie\"===N)){var q=\"x\",G=\"y\";\"bar\"!==B&&\"bar\"!==N||\"h\"!==O.orientation||(q=\"y\",G=\"x\"),_.swapAttrs(O,[\"?\",\"?src\"],\"labels\",q),_.swapAttrs(O,[\"d?\",\"?0\"],\"label\",q),_.swapAttrs(O,[\"?\",\"?src\"],\"values\",G),\"pie\"===N?(_.nestedProperty(O,\"marker.color\").set(_.nestedProperty(O,\"marker.colors\").get()),c._pielayer.selectAll(\"g.trace\").remove()):k.traceIs(O,\"cartesian\")&&(_.nestedProperty(O,\"marker.colors\").set(_.nestedProperty(O,\"marker.color\").get()),g[O.xaxis||\"x\"]=!0,g[O.yaxis||\"y\"]=!0)}v[D][l]=N;var Y=[\"swapxy\",\"swapxyaxes\",\"orientation\",\"orientationaxes\"];if(-1!==Y.indexOf(D)){if(\"orientation\"===D){if(j.set(B),j.get()===v[D][l])continue}else\"orientationaxes\"===D&&(O.orientation={v:\"h\",h:\"v\"}[F.orientation]);P.swapXYData(O)}else if(-1!==A.dataArrayContainers.indexOf(j.parts[0]))P.manageArrayContainers(j,B,v),p.docalc=!0;else{var X=j.parts[0],W=(F._module||{}).attributes,Z=W&&W[X];if(Z||(Z=A.attributes[X]),Z){for(var J=1;J<j.parts.length;J++){var K=Z[j.parts[J]];if(!K)break;Z=K}(!Z.valType||Z.arrayOk&&(Array.isArray(B)||Array.isArray(N)))&&(p.docalc=!0),R.update(p,Z)}else p.docalc=!0;j.set(B)}}if(-1!==[\"swapxyaxes\",\"orientationaxes\"].indexOf(D)&&x.Axes.swap(t,d),\"orientationaxes\"===D){var Q=_.nestedProperty(t.layout,\"hovermode\");\"x\"===Q.get()?Q.set(\"y\"):\"y\"===Q.get()&&Q.set(\"x\")}-1!==d.indexOf(0)&&-1!==T.indexOf(D)&&(x.Axes.clearTypes(t,d),p.docalc=!0),-1!==[\"autobinx\",\"autobiny\",\"zauto\"].indexOf(D)&&!1===B||(p.dostyle=!0),(-1!==[\"colorbar\",\"line\"].indexOf(j.parts[0])||\"marker\"===j.parts[0]&&\"colorbar\"===j.parts[1])&&(p.docolorbars=!0);var $=D.indexOf(\"[\"),tt=-1===$?D:D.substr(0,$);if(-1!==y.indexOf(tt)){if(-1!==[\"orientation\",\"type\"].indexOf(D)){for(u=[],l=0;l<d.length;l++){var et=f[d[l]];k.traceIs(et,\"cartesian\")&&(i(et.xaxis||\"x\"),i(et.yaxis||\"y\"),\"type\"===D&&s([\"autobinx\",\"autobiny\"],!0,l))}s(u.map(a),!0,0),s(u.map(o),[0,1],0)}p.docalc=!0}else-1!==M.indexOf(tt)?p.doplot=!0:0===tt.indexOf(\"aaxis\")||0===tt.indexOf(\"baxis\")?p.doplot=!0:-1!==w.indexOf(tt)&&(p.docalcAutorange=!0)}else j=_.nestedProperty(t.layout,D.replace(\"LAYOUT\",\"\")),v[D]=[j.get()],j.set(Array.isArray(U)?U[0]:U),p.docalc=!0}x.Axes.list(t).forEach(function(t){t.autorange&&(p.autorangeOn=!0)});var rt=Object.keys(g);t:for(l=0;l<rt.length;l++){for(var nt=rt[l],it=nt.charAt(0),at=it+\"axis\",ot=0;ot<f.length;ot++)if(k.traceIs(f[ot],\"cartesian\")&&(f[ot][at]||it)===nt)continue t;s(\"LAYOUT\"+x.Axes.id2name(nt),null,0)}return(p.docalc||p.docalcAutorange&&p.autorangeOn)&&(p.clearCalc=!0),(p.docalc||p.doplot||p.docalcAutorange)&&(p.fullReplot=!0),{flags:p,undoit:v,redoit:m,traces:d,eventData:_.extendDeepNoArrays([],[m,d])}}function m(t,e){function r(t,n){if(Array.isArray(t))return void t.forEach(function(t){r(t,n)});if(!(t in e||P.hasParent(e,t))){var i=_.nestedProperty(l,t);t in b||(b[t]=i.get()),void 0!==n&&i.set(n)}}function n(e,r){if(!_.isPlainObject(e))return!1;var n=e[r+\"ref\"]||r,i=x.Axes.getFromId(t,n);return i||n.charAt(0)!==r||(i=x.Axes.getFromId(t,r)),(i||{}).autorange}function i(t){var e=U.name2id(t.split(\".\")[0]);return w[e]=1,e}var a,o,s,l=t.layout,u=t._fullLayout,c=Object.keys(e),h=x.Axes.list(t),f={};for(o=0;o<c.length;o++)if(0===c[o].indexOf(\"allaxes\")){for(s=0;s<h.length;s++){var d=h[s]._id.substr(1),p=-1!==d.indexOf(\"scene\")?d+\".\":\"\",m=c[o].replace(\"allaxes\",p+h[s]._name);e[m]||(e[m]=e[c[o]])}delete e[c[o]]}var v,g=R.layout(),y={},b={},w={};for(var M in e){if(P.hasParent(e,M))throw new Error(\"cannot set \"+M+\"and a parent attribute simultaneously\");var T=_.nestedProperty(l,M),S=e[M],E=T.parts.length,L=\"string\"==typeof T.parts[E-1]?E-1:E-2,C=T.parts[0],z=T.parts[L],I=T.parts[L-1]+\".\"+z,O=T.parts.slice(0,L).join(\".\"),j=_.nestedProperty(t.layout,O).get(),N=_.nestedProperty(u,O).get(),B=T.get();if(void 0!==S){if(y[M]=S,b[M]=\"reverse\"===z?S:B,-1!==[\"width\",\"height\"].indexOf(M)&&null===S)u[M]=t._initialAutoSize[M];else if(I.match(/^[xyz]axis[0-9]*\\.range(\\[[0|1]\\])?$/))r(O+\".autorange\",!1),i(I),_.nestedProperty(u,O+\"._inputRange\").set(null);else if(I.match(/^[xyz]axis[0-9]*\\.autorange$/)){r([O+\".range[0]\",O+\".range[1]\"],void 0),i(I),_.nestedProperty(u,O+\"._inputRange\").set(null);var V=_.nestedProperty(u,O).get();V._inputDomain&&(V._input.domain=V._inputDomain.slice())}else I.match(/^[xyz]axis[0-9]*\\.domain(\\[[0|1]\\])?$/)?_.nestedProperty(u,O+\"._inputDomain\").set(null):I.match(/^[xyz]axis[0-9]*\\.constrain.*$/)?g.docalc=!0:I.match(/^aspectratio\\.[xyz]$/)?r(C+\".aspectmode\",\"manual\"):I.match(/^aspectmode$/)?r([O+\".x\",O+\".y\",O+\".z\"],void 0):\"tick0\"===z||\"dtick\"===z?r(O+\".tickmode\",\"linear\"):\"tickmode\"===z?r([O+\".tick0\",O+\".dtick\"],void 0):/[xy]axis[0-9]*?$/.test(z)&&!Object.keys(S||{}).length?g.docalc=!0:/[xy]axis[0-9]*\\.categoryorder$/.test(I)?g.docalc=!0:/[xy]axis[0-9]*\\.categoryarray/.test(I)&&(g.docalc=!0);if(-1!==I.indexOf(\"rangeslider\")&&(g.docalc=!0),\"type\"===z){var H=j,q=\"linear\"===N.type&&\"log\"===S,G=\"log\"===N.type&&\"linear\"===S;if(q||G){if(H&&H.range)if(N.autorange)q&&(H.range=H.range[1]>H.range[0]?[1,2]:[2,1]);else{var Y=H.range[0],X=H.range[1];q?(Y<=0&&X<=0&&r(O+\".autorange\",!0),Y<=0?Y=X/1e6:X<=0&&(X=Y/1e6),r(O+\".range[0]\",Math.log(Y)/Math.LN10),r(O+\".range[1]\",Math.log(X)/Math.LN10)):(r(O+\".range[0]\",Math.pow(10,Y)),r(O+\".range[1]\",Math.pow(10,X)))}else r(O+\".autorange\",!0);k.getComponentMethod(\"annotations\",\"convertCoords\")(t,N,S,r),k.getComponentMethod(\"images\",\"convertCoords\")(t,N,S,r)}else r(O+\".autorange\",!0);_.nestedProperty(u,O+\"._inputRange\").set(null)}else if(z.match(F.AX_NAME_PATTERN)){var W=_.nestedProperty(u,M).get(),Z=(S||{}).type;Z&&\"-\"!==Z||(Z=\"linear\"),k.getComponentMethod(\"annotations\",\"convertCoords\")(t,W,Z,r),k.getComponentMethod(\"images\",\"convertCoords\")(t,W,Z,r)}var J=D.containerArrayMatch(M);if(J){a=J.array,o=J.index;var K=J.property,Q=_.nestedProperty(l,a),$=(Q||[])[o]||{};if(\"\"===o)-1===M.indexOf(\"updatemenus\")&&(g.docalc=!0);else if(\"\"===K){var tt=S;D.isAddVal(S)?b[M]=null:D.isRemoveVal(S)?(b[M]=$,tt=$):_.warn(\"unrecognized full object value\",e),(n(tt,\"x\")||n(tt,\"y\")&&-1===M.indexOf(\"updatemenus\"))&&(g.docalc=!0)}else!n($,\"x\")&&!n($,\"y\")||_.containsAny(M,[\"color\",\"opacity\",\"align\",\"dash\",\"updatemenus\"])||(g.docalc=!0);f[a]||(f[a]={});var et=f[a][o];et||(et=f[a][o]={}),et[K]=S,delete e[M]}else if(\"reverse\"===z)j.range?j.range.reverse():(r(O+\".autorange\",!0),j.range=[1,0]),N.autorange?g.docalc=!0:g.doplot=!0;else{var rt=String(T.parts[1]||\"\");0===C.indexOf(\"scene\")?\"camera\"===T.parts[1]?g.docamera=!0:g.doplot=!0:0===C.indexOf(\"geo\")?g.doplot=!0:0===C.indexOf(\"ternary\")?g.doplot=!0:\"paper_bgcolor\"===M?g.doplot=!0:\"margin\"===C||\"autorange\"===rt||\"rangemode\"===rt||\"type\"===rt||\"domain\"===rt||\"fixedrange\"===rt||\"scaleanchor\"===rt||\"scaleratio\"===rt||-1!==M.indexOf(\"calendar\")||M.match(/^(bar|box|font)/)?g.docalc=!0:!u._has(\"gl2d\")||-1===M.indexOf(\"axis\")&&\"plot_bgcolor\"!==M?!u._has(\"gl2d\")||\"dragmode\"!==M||\"lasso\"!==S&&\"select\"!==S||\"lasso\"===B||\"select\"===B?\"hiddenlabels\"===M?g.docalc=!0:-1!==C.indexOf(\"legend\")?g.dolegend=!0:-1!==M.indexOf(\"title\")?g.doticks=!0:-1!==C.indexOf(\"bgcolor\")?g.dolayoutstyle=!0:E>1&&_.containsAny(rt,[\"tick\",\"exponent\",\"grid\",\"zeroline\"])?g.doticks=!0:-1!==M.indexOf(\".linewidth\")&&-1!==M.indexOf(\"axis\")?g.doticks=g.dolayoutstyle=!0:E>1&&-1!==rt.indexOf(\"line\")?g.dolayoutstyle=!0:E>1&&\"mirror\"===rt?g.doticks=g.dolayoutstyle=!0:\"margin.pad\"===M?g.doticks=g.dolayoutstyle=!0:-1!==[\"hovermode\",\"dragmode\"].indexOf(M)||-1!==M.indexOf(\"spike\")?g.domodebar=!0:-1===[\"height\",\"width\",\"autosize\"].indexOf(M)&&(g.doplot=!0):g.docalc=!0:g.doplot=!0,T.set(S)}}}for(a in f){D.applyContainerArrayChanges(t,_.nestedProperty(l,a),f[a],g)||(g.doplot=!0)}var nt=u._axisConstraintGroups;for(v in w)for(o=0;o<nt.length;o++){var it=nt[o];if(it[v]){g.docalc=!0;for(var at in it)w[at]||(U.getFromId(t,at)._constraintShrinkable=!0)}}var ot=u.width,st=u.height;return t.layout.autosize&&A.plotAutoSize(t,t.layout,u),(e.height||e.width||u.width!==ot||u.height!==st)&&(g.docalc=!0),(g.doplot||g.docalc)&&(g.layoutReplot=!0),{flags:g,undoit:b,redoit:y,eventData:_.extendDeep({},y)}}function v(t){var e=g.select(t),r=t._fullLayout;if(r._container=e.selectAll(\".plot-container\").data([0]),r._container.enter().insert(\"div\",\":first-child\").classed(\"plot-container\",!0).classed(\"plotly\",!0),r._paperdiv=r._container.selectAll(\".svg-container\").data([0]),r._paperdiv.enter().append(\"div\").classed(\"svg-container\",!0).style(\"position\",\"relative\"),r._glcontainer=r._paperdiv.selectAll(\".gl-container\").data([0]),r._glcontainer.enter().append(\"div\").classed(\"gl-container\",!0),r._paperdiv.selectAll(\".main-svg\").remove(),\n",
       "r._paper=r._paperdiv.insert(\"svg\",\":first-child\").classed(\"main-svg\",!0),r._toppaper=r._paperdiv.append(\"svg\").classed(\"main-svg\",!0),!r._uid){var n=[];g.selectAll(\"defs\").each(function(){this.id&&n.push(this.id.split(\"-\")[1])}),r._uid=_.randstr(n)}r._paperdiv.selectAll(\".main-svg\").attr(z.svgAttrs),r._defs=r._paper.append(\"defs\").attr(\"id\",\"defs-\"+r._uid),r._topdefs=r._toppaper.append(\"defs\").attr(\"id\",\"topdefs-\"+r._uid),r._bgLayer=r._paper.append(\"g\").classed(\"bglayer\",!0),r._draggers=r._paper.append(\"g\").classed(\"draglayer\",!0);var i=r._paper.append(\"g\").classed(\"layer-below\",!0);r._imageLowerLayer=i.append(\"g\").classed(\"imagelayer\",!0),r._shapeLowerLayer=i.append(\"g\").classed(\"shapelayer\",!0),r._cartesianlayer=r._paper.append(\"g\").classed(\"cartesianlayer\",!0),r._ternarylayer=r._paper.append(\"g\").classed(\"ternarylayer\",!0),r._geolayer=r._paper.append(\"g\").classed(\"geolayer\",!0);var a=r._paper.append(\"g\").classed(\"layer-above\",!0);r._imageUpperLayer=a.append(\"g\").classed(\"imagelayer\",!0),r._shapeUpperLayer=a.append(\"g\").classed(\"shapelayer\",!0),r._pielayer=r._paper.append(\"g\").classed(\"pielayer\",!0),r._glimages=r._paper.append(\"g\").classed(\"glimages\",!0),r._infolayer=r._toppaper.append(\"g\").classed(\"infolayer\",!0),r._zoomlayer=r._toppaper.append(\"g\").classed(\"zoomlayer\",!0),r._hoverlayer=r._toppaper.append(\"g\").classed(\"hoverlayer\",!0),t.emit(\"plotly_framework\")}var g=t(\"d3\"),y=t(\"fast-isnumeric\"),b=t(\"has-hover\"),x=t(\"../plotly\"),_=t(\"../lib\"),w=t(\"../lib/events\"),M=t(\"../lib/queue\"),k=t(\"../registry\"),A=t(\"../plots/plots\"),T=t(\"../plots/polar\"),S=t(\"../plots/cartesian/graph_interact\"),E=t(\"../components/drawing\"),L=t(\"../components/color\"),C=t(\"../components/errorbars\"),z=t(\"../constants/xmlns_namespaces\"),I=t(\"../lib/svg_text_utils\"),D=t(\"./manage_arrays\"),P=t(\"./helpers\"),O=t(\"./subroutines\"),R=t(\"./edit_types\"),F=t(\"../plots/cartesian/constants\"),j=t(\"../plots/cartesian/constraints\"),N=j.enforce,B=j.clean,U=t(\"../plots/cartesian/axis_ids\");x.plot=function(t,e,r,n){function i(){if(m)return x.addFrames(t,m)}function s(){for(var e=M._basePlotModules,r=0;r<e.length;r++)e[r].drawFramework&&e[r].drawFramework(t);return _.syncOrAsync([O.layoutStyles],t)}function l(){var e,r,n,i=t.calcdata;for(k.getComponentMethod(\"legend\",\"draw\")(t),k.getComponentMethod(\"rangeselector\",\"draw\")(t),k.getComponentMethod(\"sliders\",\"draw\")(t),k.getComponentMethod(\"updatemenus\",\"draw\")(t),e=0;e<i.length;e++)r=i[e],n=r[0].trace,!0===n.visible&&n._module.colorbar?n._module.colorbar(t,r):A.autoMargin(t,\"cb\"+n.uid);return A.doAutoMargin(t),A.previousPromises(t)}function u(){if(JSON.stringify(M._size)!==z)return _.syncOrAsync([l,O.layoutStyles],t)}function c(){if(!T)return void N(t);var e,r,n,i=A.getSubplotIds(M,\"cartesian\"),a=M._modules,o=[];for(n=0;n<a.length;n++)_.pushUnique(o,a[n].setPositions);if(o.length)for(r=0;r<i.length;r++)for(e=M._plots[i[r]],n=0;n<o.length;n++)o[n](t,e);return C.calc(t),_.syncOrAsync([k.getComponentMethod(\"shapes\",\"calcAutorange\"),k.getComponentMethod(\"annotations\",\"calcAutorange\"),h,k.getComponentMethod(\"rangeslider\",\"calcAutorange\")],t)}function h(){if(!t._transitioning){for(var e=x.Axes.list(t,\"\",!0),r=0;r<e.length;r++){var n=e[r];B(t,n),x.Axes.doAutoRange(n)}N(t),b&&x.Axes.saveRangeInitial(t)}}function f(){return x.Axes.doTicks(t,\"redraw\")}function d(){var e,r=t.calcdata,n=M._infolayer.selectAll(\"g.rangeslider-container\");for(e=0;e<r.length;e++){var i=r[e][0].trace,a=!0===i.visible,o=i.uid;if(!a||!k.traceIs(i,\"2dMap\")){var s=\".hm\"+o+\",.contour\"+o+\",#clip\"+o;M._paper.selectAll(s).remove(),n.selectAll(s).remove()}a&&i._module.colorbar||M._infolayer.selectAll(\".cb\"+o).remove()}var l=M._basePlotModules;for(e=0;e<l.length;e++)l[e].plot(t);var u=M._paper.selectAll(\".layer-subplot\");return M._shapeSubplotLayers=u.selectAll(\".shapelayer\"),A.style(t),k.getComponentMethod(\"shapes\",\"draw\")(t),k.getComponentMethod(\"annotations\",\"draw\")(t),A.addLinks(t),M._replotting=!1,A.previousPromises(t)}function p(){k.getComponentMethod(\"shapes\",\"draw\")(t),k.getComponentMethod(\"images\",\"draw\")(t),k.getComponentMethod(\"annotations\",\"draw\")(t),k.getComponentMethod(\"legend\",\"draw\")(t),k.getComponentMethod(\"rangeslider\",\"draw\")(t),k.getComponentMethod(\"rangeselector\",\"draw\")(t),k.getComponentMethod(\"sliders\",\"draw\")(t),k.getComponentMethod(\"updatemenus\",\"draw\")(t)}var m;if(t=P.getGraphDiv(t),w.init(t),_.isPlainObject(e)){var y=e;e=y.data,r=y.layout,n=y.config,m=y.frames}if(!1===w.triggerHandler(t,\"plotly_beforeplot\",[e,r,n]))return Promise.reject();e||r||_.isPlotDiv(t)||_.warn(\"Calling Plotly.plot as if redrawing but this container doesn't yet have a plot.\",t),a(t,n),r||(r={}),g.select(t).classed(\"js-plotly-plot\",!0),E.makeTester(),t._promises=[];var b=0===(t.data||[]).length&&Array.isArray(e);if(Array.isArray(e)&&(P.cleanData(e,t.data),b?t.data=e:t.data.push.apply(t.data,e),t.empty=!1),t.layout&&!b||(t.layout=P.cleanLayout(r)),t._dragging&&!t._transitioning)return t._replotPending=!0,Promise.reject();t._replotPending=!1,A.supplyDefaults(t);var M=t._fullLayout;if(e&&e[0]&&e[0].r)return o(t,e,r);M._replotting=!0,b&&v(t),t.framework!==v&&(t.framework=v,v(t)),E.initGradients(t),b&&x.Axes.saveShowSpikeInitial(t);var T=!t.calcdata||t.calcdata.length!==(t._fullData||[]).length;T&&A.doCalcdata(t);for(var L=0;L<t.calcdata.length;L++)t.calcdata[L][0].trace=t._fullData[L];var z=JSON.stringify(M._size),I=[A.previousPromises,i,s,l,u,c,O.layoutStyles,f,d,p,S,A.rehover];return _.syncOrAsync(I,t),Promise.all(t._promises).then(function(){return t.emit(\"plotly_afterplot\"),t})},x.redraw=function(t){if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t);return P.cleanData(t.data,t.data),P.cleanLayout(t.layout),t.calcdata=void 0,x.plot(t).then(function(){return t.emit(\"plotly_redraw\"),t})},x.newPlot=function(t,e,r,n){return t=P.getGraphDiv(t),A.cleanPlot([],{},t._fullData||{},t._fullLayout||{}),A.purge(t),x.plot(t,e,r,n)},x.extendTraces=function t(e,r,n,i){e=P.getGraphDiv(e);var a=d(e,r,n,i,function(t,e){return t.concat(e)},function(t,e){return t.splice(0,t.length-e)}),o=x.redraw(e),s=[e,a.update,n,a.maxPoints];return M.add(e,x.prependTraces,s,t,arguments),o},x.prependTraces=function t(e,r,n,i){e=P.getGraphDiv(e);var a=d(e,r,n,i,function(t,e){return e.concat(t)},function(t,e){return t.splice(e,t.length)}),o=x.redraw(e),s=[e,a.update,n,a.maxPoints];return M.add(e,x.extendTraces,s,t,arguments),o},x.addTraces=function t(e,r,n){e=P.getGraphDiv(e);var i,a,o=[],s=x.deleteTraces,l=t,h=[e,o],f=[e,r];for(c(e,r,n),Array.isArray(r)||(r=[r]),r=r.map(function(t){return _.extendFlat({},t)}),P.cleanData(r,e.data),i=0;i<r.length;i++)e.data.push(r[i]);for(i=0;i<r.length;i++)o.push(-r.length+i);if(void 0===n)return a=x.redraw(e),M.add(e,s,h,l,f),a;Array.isArray(n)||(n=[n]);try{u(e,o,n)}catch(t){throw e.data.splice(e.data.length-r.length,r.length),t}return M.startSequence(e),M.add(e,s,h,l,f),a=x.moveTraces(e,o,n),M.stopSequence(e),a},x.deleteTraces=function t(e,r){e=P.getGraphDiv(e);var n,i,a=[],o=x.addTraces,u=t,c=[e,a,r],h=[e,r];if(void 0===r)throw new Error(\"indices must be an integer or array of integers.\");for(Array.isArray(r)||(r=[r]),l(e,r,\"indices\"),r=s(r,e.data.length-1),r.sort(_.sorterDes),n=0;n<r.length;n+=1)i=e.data.splice(r[n],1)[0],a.push(i);var f=x.redraw(e);return M.add(e,o,c,u,h),f},x.moveTraces=function t(e,r,n){e=P.getGraphDiv(e);var i,a=[],o=[],l=t,c=t,h=[e,n,r],f=[e,r,n];if(u(e,r,n),r=Array.isArray(r)?r:[r],void 0===n)for(n=[],i=0;i<r.length;i++)n.push(-r.length+i);for(n=Array.isArray(n)?n:[n],r=s(r,e.data.length-1),n=s(n,e.data.length-1),i=0;i<e.data.length;i++)-1===r.indexOf(i)&&a.push(e.data[i]);for(i=0;i<r.length;i++)o.push({newIndex:n[i],trace:e.data[r[i]]});for(o.sort(function(t,e){return t.newIndex-e.newIndex}),i=0;i<o.length;i+=1)a.splice(o[i].newIndex,0,o[i].trace);e.data=a;var d=x.redraw(e);return M.add(e,l,h,c,f),d},x.restyle=function t(e,r,n,i){e=P.getGraphDiv(e),P.clearPromiseQueue(e);var a={};if(\"string\"==typeof r)a[r]=n;else{if(!_.isPlainObject(r))return _.warn(\"Restyle fail.\",r,n,i),Promise.reject();a=_.extendFlat({},r),void 0===i&&(i=n)}Object.keys(a).length&&(e.changed=!0);var o=p(e,a,i),s=o.flags;s.clearCalc&&(e.calcdata=void 0);var l=[];s.fullReplot?l.push(x.plot):(l.push(A.previousPromises),A.supplyDefaults(e),s.dostyle&&l.push(O.doTraceStyle),s.docolorbars&&l.push(O.doColorBars)),l.push(A.rehover),M.add(e,t,[e,o.undoit,o.traces],t,[e,o.redoit,o.traces]);var u=_.syncOrAsync(l,e);return u&&u.then||(u=Promise.resolve()),u.then(function(){return e.emit(\"plotly_restyle\",o.eventData),e})},x.relayout=function t(e,r,n){if(e=P.getGraphDiv(e),P.clearPromiseQueue(e),e.framework&&e.framework.isPolar)return Promise.resolve(e);var i={};if(\"string\"==typeof r)i[r]=n;else{if(!_.isPlainObject(r))return _.warn(\"Relayout fail.\",r,n),Promise.reject();i=_.extendFlat({},r)}Object.keys(i).length&&(e.changed=!0);var a=m(e,i),o=a.flags;o.docalc&&(e.calcdata=void 0);var s=[A.previousPromises];o.layoutReplot?s.push(O.layoutReplot):Object.keys(i).length&&(A.supplyDefaults(e),o.dolegend&&s.push(O.doLegend),o.dolayoutstyle&&s.push(O.layoutStyles),o.doticks&&s.push(O.doTicksRelayout),o.domodebar&&s.push(O.doModeBar),o.docamera&&s.push(O.doCamera)),s.push(A.rehover),M.add(e,t,[e,a.undoit],t,[e,a.redoit]);var l=_.syncOrAsync(s,e);return l&&l.then||(l=Promise.resolve(e)),l.then(function(){return e.emit(\"plotly_relayout\",a.eventData),e})},x.update=function t(e,r,n,i){if(e=P.getGraphDiv(e),P.clearPromiseQueue(e),e.framework&&e.framework.isPolar)return Promise.resolve(e);_.isPlainObject(r)||(r={}),_.isPlainObject(n)||(n={}),Object.keys(r).length&&(e.changed=!0),Object.keys(n).length&&(e.changed=!0);var a=p(e,_.extendFlat({},r),i),o=a.flags,s=m(e,_.extendFlat({},n)),l=s.flags;(o.clearCalc||l.docalc)&&(e.calcdata=void 0);var u=[];if(o.fullReplot&&l.layoutReplot){var c=e.data,h=e.layout;e.data=void 0,e.layout=void 0,u.push(function(){return x.plot(e,c,h)})}else o.fullReplot?u.push(x.plot):l.layoutReplot?u.push(O.layoutReplot):(u.push(A.previousPromises),A.supplyDefaults(e),o.dostyle&&u.push(O.doTraceStyle),o.docolorbars&&u.push(O.doColorBars),l.dolegend&&u.push(O.doLegend),l.dolayoutstyle&&u.push(O.layoutStyles),l.doticks&&u.push(O.doTicksRelayout),l.domodebar&&u.push(O.doModeBar),l.doCamera&&u.push(O.doCamera));u.push(A.rehover),M.add(e,t,[e,a.undoit,s.undoit,a.traces],t,[e,a.redoit,s.redoit,a.traces]);var f=_.syncOrAsync(u,e);return f&&f.then||(f=Promise.resolve(e)),f.then(function(){return e.emit(\"plotly_update\",{data:a.eventData,layout:s.eventData}),e})},x.animate=function(t,e,r){function n(t){return Array.isArray(s)?t>=s.length?s[0]:s[t]:s}function i(t){return Array.isArray(l)?t>=l.length?l[0]:l[t]:l}function a(t,e){var r=0;return function(){if(t&&++r===e)return t()}}if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t+\". It's likely that you've failed to create a plot before animating it. For more details, see https://plot.ly/javascript/animations/\");var o=t._transitionData;o._frameQueue||(o._frameQueue=[]),r=A.supplyAnimationDefaults(r);var s=r.transition,l=r.frame;return void 0===o._frameWaitingCnt&&(o._frameWaitingCnt=0),new Promise(function(l,u){function c(){t.emit(\"plotly_animated\"),window.cancelAnimationFrame(o._animationRaf),o._animationRaf=null}function h(){o._currentFrame&&o._currentFrame.onComplete&&o._currentFrame.onComplete();var e=o._currentFrame=o._frameQueue.shift();if(e){var r=e.name?e.name.toString():null;t._fullLayout._currentFrame=r,o._lastFrameAt=Date.now(),o._timeToNext=e.frameOpts.duration,A.transition(t,e.frame.data,e.frame.layout,P.coerceTraceIndices(t,e.frame.traces),e.frameOpts,e.transitionOpts).then(function(){e.onComplete&&e.onComplete()}),t.emit(\"plotly_animatingframe\",{name:r,frame:e.frame,animation:{frame:e.frameOpts,transition:e.transitionOpts}})}else c()}function f(){t.emit(\"plotly_animating\"),o._lastFrameAt=-1/0,o._timeToNext=0,o._runningTransitions=0,o._currentFrame=null;var e=function(){o._animationRaf=window.requestAnimationFrame(e),Date.now()-o._lastFrameAt>o._timeToNext&&h()};e()}function d(t){return Array.isArray(s)?v>=s.length?t.transitionOpts=s[v]:t.transitionOpts=s[0]:t.transitionOpts=s,v++,t}var p,m,v=0,g=[],y=void 0===e||null===e,b=Array.isArray(e);if(y||b||!_.isPlainObject(e)){if(y||-1!==[\"string\",\"number\"].indexOf(typeof e))for(p=0;p<o._frames.length;p++)(m=o._frames[p])&&(y||String(m.group)===String(e))&&g.push({type:\"byname\",name:String(m.name),data:d({name:m.name})});else if(b)for(p=0;p<e.length;p++){var x=e[p];-1!==[\"number\",\"string\"].indexOf(typeof x)?(x=String(x),g.push({type:\"byname\",name:x,data:d({name:x})})):_.isPlainObject(x)&&g.push({type:\"object\",data:d(_.extendFlat({},x))})}}else g.push({type:\"object\",data:d(_.extendFlat({},e))});for(p=0;p<g.length;p++)if(m=g[p],\"byname\"===m.type&&!o._frameHash[m.data.name])return _.warn('animate failure: frame not found: \"'+m.data.name+'\"'),void u();-1!==[\"next\",\"immediate\"].indexOf(r.mode)&&function(){if(0!==o._frameQueue.length){for(;o._frameQueue.length;){var e=o._frameQueue.pop();e.onInterrupt&&e.onInterrupt()}t.emit(\"plotly_animationinterrupted\",[])}}(),\"reverse\"===r.direction&&g.reverse();var w=t._fullLayout._currentFrame;if(w&&r.fromcurrent){var M=-1;for(p=0;p<g.length;p++)if(m=g[p],\"byname\"===m.type&&m.name===w){M=p;break}if(M>0&&M<g.length-1){var k=[];for(p=0;p<g.length;p++)m=g[p],(\"byname\"!==g[p].type||p>M)&&k.push(m);g=k}}g.length>0?function(e){if(0!==e.length){for(var s=0;s<e.length;s++){var c;c=\"byname\"===e[s].type?A.computeFrame(t,e[s].name):e[s].data;var h=i(s),d=n(s);d.duration=Math.min(d.duration,h.duration);var p={frame:c,name:e[s].name,frameOpts:h,transitionOpts:d};s===e.length-1&&(p.onComplete=a(l,2),p.onInterrupt=u),o._frameQueue.push(p)}\"immediate\"===r.mode&&(o._lastFrameAt=-1/0),o._animationRaf||f()}}(g):(t.emit(\"plotly_animated\"),l())})},x.addFrames=function(t,e,r){t=P.getGraphDiv(t);var n=0;if(null===e||void 0===e)return Promise.resolve();if(!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t+\". It's likely that you've failed to create a plot before adding frames. For more details, see https://plot.ly/javascript/animations/\");var i,a,o,s,l=t._transitionData._frames,u=t._transitionData._frameHash;if(!Array.isArray(e))throw new Error(\"addFrames failure: frameList must be an Array of frame definitions\"+e);var c=l.length+2*e.length,h=[];for(i=e.length-1;i>=0;i--)if(_.isPlainObject(e[i])){var f=(u[e[i].name]||{}).name,d=e[i].name;f&&d&&\"number\"==typeof d&&u[f]&&(n++,_.warn('addFrames: overwriting frame \"'+u[f].name+'\" with a frame whose name of type \"number\" also equates to \"'+f+'\". This is valid but may potentially lead to unexpected behavior since all plotly.js frame names are stored internally as strings.'),n>5&&_.warn(\"addFrames: This API call has yielded too many warnings. For the rest of this call, further warnings about numeric frame names will be suppressed.\")),h.push({frame:A.supplyFrameDefaults(e[i]),index:r&&void 0!==r[i]&&null!==r[i]?r[i]:c+i})}h.sort(function(t,e){return t.index>e.index?-1:t.index<e.index?1:0});var p=[],m=[],v=l.length;for(i=h.length-1;i>=0;i--){if(a=h[i].frame,\"number\"==typeof a.name&&_.warn(\"Warning: addFrames accepts frames with numeric names, but the numbers areimplicitly cast to strings\"),!a.name)for(;u[a.name=\"frame \"+t._transitionData._counter++];);if(u[a.name]){for(o=0;o<l.length&&(l[o]||{}).name!==a.name;o++);p.push({type:\"replace\",index:o,value:a}),m.unshift({type:\"replace\",index:o,value:l[o]})}else s=Math.max(0,Math.min(h[i].index,v)),p.push({type:\"insert\",index:s,value:a}),m.unshift({type:\"delete\",index:s}),v++}var g=A.modifyFrames,y=A.modifyFrames,b=[t,m],x=[t,p];return M&&M.add(t,g,b,y,x),A.modifyFrames(t,p)},x.deleteFrames=function(t,e){if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t);var r,n,i=t._transitionData._frames,a=[],o=[];if(!e)for(e=[],r=0;r<i.length;r++)e.push(r);for(e=e.slice(0),e.sort(),r=e.length-1;r>=0;r--)n=e[r],a.push({type:\"delete\",index:n}),o.unshift({type:\"insert\",index:n,value:i[n]});var s=A.modifyFrames,l=A.modifyFrames,u=[t,o],c=[t,a];return M&&M.add(t,s,u,l,c),A.modifyFrames(t,a)},x.purge=function(t){t=P.getGraphDiv(t);var e=t._fullLayout||{},r=t._fullData||[];return A.cleanPlot([],{},r,e),A.purge(t),w.purge(t),e._container&&e._container.remove(),delete t._context,delete t._replotPending,delete t._mouseDownTime,delete t._legendMouseDownTime,delete t._hmpixcount,delete t._hmlumcount,t}},{\"../components/color\":603,\"../components/drawing\":627,\"../components/errorbars\":633,\"../constants/xmlns_namespaces\":707,\"../lib\":725,\"../lib/events\":715,\"../lib/queue\":738,\"../lib/svg_text_utils\":745,\"../plotly\":761,\"../plots/cartesian/axis_ids\":769,\"../plots/cartesian/constants\":771,\"../plots/cartesian/constraints\":773,\"../plots/cartesian/graph_interact\":775,\"../plots/plots\":829,\"../plots/polar\":832,\"../registry\":844,\"./edit_types\":750,\"./helpers\":751,\"./manage_arrays\":752,\"./subroutines\":758,d3:121,\"fast-isnumeric\":130,\"has-hover\":287}],754:[function(t,e,r){\"use strict\";e.exports={staticPlot:!1,editable:!1,edits:{annotationPosition:!1,annotationTail:!1,annotationText:!1,axisTitleText:!1,colorbarPosition:!1,colorbarTitleText:!1,legendPosition:!1,legendText:!1,shapePosition:!1,titleText:!1},autosizable:!1,queueLength:0,fillFrame:!1,frameMargins:0,scrollZoom:!1,doubleClick:\"reset+autosize\",showTips:!0,showAxisDragHandles:!0,showAxisRangeEntryBoxes:!0,showLink:!1,sendData:!0,linkText:\"Edit chart\",showSources:!1,displayModeBar:\"hover\",modeBarButtonsToRemove:[],modeBarButtonsToAdd:[],modeBarButtons:!1,displaylogo:!0,plotGlPixelRatio:2,setBackground:\"transparent\",topojsonURL:\"https://cdn.plot.ly/\",mapboxAccessToken:null,logging:!1,globalTransforms:[]}},{}],755:[function(t,e,r){\"use strict\";function n(t){var e,r;\"area\"===t?(e={attributes:b},r={}):(e=d.modules[t]._module,r=e.basePlotModule);var n={};n.type=null,M(n,m),M(n,e.attributes),r.attributes&&M(n,r.attributes),Object.keys(d.componentsRegistry).forEach(function(e){var r=d.componentsRegistry[e];r.schema&&r.schema.traces&&r.schema.traces[t]&&Object.keys(r.schema.traces[t]).forEach(function(e){f(n,r.schema.traces[t][e],e)})}),n.type=t;var i={meta:e.meta||{},attributes:s(n)};if(e.layoutAttributes){var a={};M(a,e.layoutAttributes),i.layoutAttributes=s(a)}return i}function i(){var t={};return M(t,v),Object.keys(d.subplotsRegistry).forEach(function(e){var r=d.subplotsRegistry[e];if(r.layoutAttributes)if(\"cartesian\"===r.name)h(t,r,\"xaxis\"),h(t,r,\"yaxis\");else{var n=\"subplot\"===r.attr?r.name:r.attr;h(t,r,n)}}),t=c(t),Object.keys(d.componentsRegistry).forEach(function(e){var r=d.componentsRegistry[e];r.layoutAttributes&&(r.schema&&r.schema.layout?Object.keys(r.schema.layout).forEach(function(e){f(t,r.schema.layout[e],e)}):f(t,r.layoutAttributes,r.name))}),{layoutAttributes:s(t)}}function a(t){var e=d.transformsRegistry[t],r=M({},e.attributes);return Object.keys(d.componentsRegistry).forEach(function(e){var n=d.componentsRegistry[e];n.schema&&n.schema.transforms&&n.schema.transforms[t]&&Object.keys(n.schema.transforms[t]).forEach(function(e){f(r,n.schema.transforms[t][e],e)})}),{attributes:s(r)}}function o(){var t={frames:p.extendDeep({},g)};return s(t),t.frames}function s(t){return l(t),u(t),t}function l(t){function e(t){return{valType:\"string\"}}function n(t,n,i){r.isValObject(t)?\"data_array\"===t.valType?(t.role=\"data\",i[n+\"src\"]=e(n)):!0===t.arrayOk&&(i[n+\"src\"]=e(n)):p.isPlainObject(t)&&(t.role=\"object\")}r.crawl(t,n)}function u(t){function e(t,e,r){if(t){var n=t[A];n&&(delete t[A],r[e]={items:{}},r[e].items[n]=t,r[e].role=\"object\")}}r.crawl(t,e)}function c(t){return w(t,{radialaxis:x.radialaxis,angularaxis:x.angularaxis}),w(t,x.layout),t}function h(t,e,r){var n=p.nestedProperty(t,r),i=M({},e.layoutAttributes);i[k]=!0,n.set(i)}function f(t,e,r){var n=p.nestedProperty(t,r);n.set(M(n.get()||{},e))}var d=t(\"../registry\"),p=t(\"../lib\"),m=t(\"../plots/attributes\"),v=t(\"../plots/layout_attributes\"),g=t(\"../plots/frame_attributes\"),y=t(\"../plots/animation_attributes\"),b=t(\"../plots/polar/area_attributes\"),x=t(\"../plots/polar/axis_attributes\"),_=t(\"./edit_types\"),w=p.extendFlat,M=p.extendDeep,k=\"_isSubplotObj\",A=\"_isLinkedToArray\",T=[k,A,\"_arrayAttrRegexps\",\"_deprecated\"];r.IS_SUBPLOT_OBJ=k,r.IS_LINKED_TO_ARRAY=A,r.DEPRECATED=\"_deprecated\",r.UNDERSCORE_ATTRS=T,r.get=function(){var t={};d.allTypes.concat(\"area\").forEach(function(e){t[e]=n(e)});var e={};return Object.keys(d.transformsRegistry).forEach(function(t){e[t]=a(t)}),{defs:{valObjects:p.valObjects,metaKeys:T.concat([\"description\",\"role\"]),editTypes:{traces:_.traces(),layout:_.layout()}},traces:t,layout:i(),transforms:e,frames:o(),animation:s(y)}},r.crawl=function(t,e,n){var i=n||0;Object.keys(t).forEach(function(n){var a=t[n];-1===T.indexOf(n)&&(e(a,n,t,i),r.isValObject(a)||p.isPlainObject(a)&&r.crawl(a,e,i+1))})},r.isValObject=function(t){return t&&void 0!==t.valType},r.findArrayAttributes=function(t){function e(e,r,o,s){if(a=a.slice(0,s).concat([r]),e&&(\"data_array\"===e.valType||!0===e.arrayOk)&&!(\"colorbar\"===a[s-1]&&(\"ticktext\"===r||\"tickvals\"===r))){var l=n(a),u=p.nestedProperty(t,l).get();Array.isArray(u)&&i.push(l)}}function n(t){return t.join(\".\")}var i=[],a=[];if(r.crawl(m,e),t._module&&t._module.attributes&&r.crawl(t._module.attributes,e),t.transforms)for(var o=t.transforms,s=0;s<o.length;s++){var l=o[s],u=l._module;u&&(a=[\"transforms[\"+s+\"]\"],r.crawl(u.attributes,e,1))}return t._fullInput&&t._fullInput._module&&t._fullInput._module.attributes&&(r.crawl(t._fullInput._module.attributes,e),i=p.filterUnique(i)),i}},{\"../lib\":725,\"../plots/animation_attributes\":762,\"../plots/attributes\":764,\"../plots/frame_attributes\":791,\"../plots/layout_attributes\":820,\"../plots/polar/area_attributes\":830,\"../plots/polar/axis_attributes\":831,\"../registry\":844,\"./edit_types\":750}],756:[function(t,e,r){\"use strict\";function n(t){o.register(t,t.name,t.categories,t.meta),o.subplotsRegistry[t.basePlotModule.name]||o.registerSubplot(t.basePlotModule)}function i(t){if(\"string\"!=typeof t.name)throw new Error(\"Transform module *name* must be a string.\");var e=\"Transform module \"+t.name,r=\"function\"==typeof t.transform,n=\"function\"==typeof t.calcTransform;if(!r&&!n)throw new Error(e+\" is missing a *transform* or *calcTransform* method.\");r&&n&&s.log([e+\" has both a *transform* and *calcTransform* methods.\",\"Please note that all *transform* methods are executed\",\"before all *calcTransform* methods.\"].join(\" \")),s.isPlainObject(t.attributes)||s.log(e+\" registered without an *attributes* object.\"),\"function\"!=typeof t.supplyDefaults&&s.log(e+\" registered without a *supplyDefaults* method.\"),o.transformsRegistry[t.name]=t}function a(t){if(\"string\"!=typeof t.name)throw new Error(\"Component module *name* must be a string.\");o.registerComponent(t)}var o=t(\"../registry\"),s=t(\"../lib\");e.exports=function(t){if(!t)throw new Error(\"No argument passed to Plotly.register.\");t&&!Array.isArray(t)&&(t=[t]);for(var e=0;e<t.length;e++){var r=t[e];if(!r)throw new Error(\"Invalid module was attempted to be registered!\");switch(r.moduleType){case\"trace\":n(r);break;case\"transform\":i(r);break;case\"component\":a(r);break;default:throw new Error(\"Invalid module was attempted to be registered!\")}}}},{\"../lib\":725,\"../registry\":844}],757:[function(t,e,r){\"use strict\";var n=t(\"../plotly\"),i=t(\"../lib\");e.exports=function(t){return i.extendFlat(n.defaultConfig,t)}},{\"../lib\":725,\"../plotly\":761}],758:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<r.length;n++){var i=r[n][0],a=r[n][1];if(!(i[0]>=t[1]||i[1]<=t[0])&&(a[0]<e[1]&&a[1]>e[0]))return!0}return!1}function i(t,e,r){return t._anchorAxis===e&&(t.mirror||t.side===r)||\"all\"===t.mirror||\"allticks\"===t.mirror||t.mirrors&&t.mirrors[e._id+r]}function a(t,e,r){var n=[],i=e._anchorAxis;if(i){var a=i._mainAxis;if(-1===n.indexOf(a)){n.push(a);for(var o=0;o<r.length;o++)r[o].overlaying===a._id&&-1===n.indexOf(r[o])&&n.push(r[o])}}return n}function o(t,e,r){for(var n=0;n<e.length;n++){var a=e[n],o=a._anchorAxis;if(o&&i(a,o,r))return p.crispRound(t,a.linewidth)}}function s(t,e,r,n,i,s){if(n)return r;var l,u=e._mainAxis,c=a(t,u,s),h=o(t,c,i);if(h)return h;for(l=0;l<s.length;l++)if(s[l].overlaying===u._id&&(c=a(t,s[l],s),h=o(t,c,i)))return h;return 0}var l=t(\"d3\"),u=t(\"../plotly\"),c=t(\"../registry\"),h=t(\"../plots/plots\"),f=t(\"../lib\"),d=t(\"../components/color\"),p=t(\"../components/drawing\"),m=t(\"../components/titles\"),v=t(\"../components/modebar\"),g=t(\"../plots/cartesian/graph_interact\"),y=t(\"../plots/cartesian/constants\");r.layoutStyles=function(t){return f.syncOrAsync([h.doAutoMargin,r.lsInner],t)},r.lsInner=function(t){var e,a=t._fullLayout,o=a._size,c=o.p,h=u.Axes.list(t),f=a._has(\"cartesian\");for(e=0;e<h.length;e++)h[e]._linepositions={};a._paperdiv.style({width:a.width+\"px\",height:a.height+\"px\"}).selectAll(\".main-svg\").call(p.setSize,a.width,a.height),t._context.setBackground(t,a.paper_bgcolor);var m=a._paper.selectAll(\"g.subplot\"),g=[],b=[];m.each(function(t){var e=a._plots[t];if(e.mainplot)return e.bg&&e.bg.remove(),void(e.bg=void 0);var r=e.xaxis.domain,i=e.yaxis.domain,o=[];n(r,i,b)?o=[0]:(g.push(t),b.push([r,i]));var s=e.plotgroup.selectAll(\".bg\").data(o);s.enter().append(\"rect\").classed(\"bg\",!0),s.exit().remove(),s.each(function(){e.bg=s;var t=e.plotgroup.node();t.insertBefore(this,t.childNodes[0])})});var x=a._bgLayer.selectAll(\".bg\").data(g);x.enter().append(\"rect\").classed(\"bg\",!0),x.exit().remove(),x.each(function(t){a._plots[t].bg=l.select(this)});var _={};return m.each(function(r){function n(t,e){return e?\"M\"+P+\",\"+t+\"H\"+R:\"\"}function l(t,e){return e?\"M\"+t+\",\"+H+\"V\"+U:\"\"}var u=a._plots[r],m=u.xaxis,v=u.yaxis;m.setScale(),v.setScale(),u.bg&&f&&u.bg.call(p.setRect,m._offset-c,v._offset-c,m._length+2*c,v._length+2*c).call(d.fill,a.plot_bgcolor).style(\"stroke-width\",0),u.clipId=\"clip\"+a._uid+r+\"plot\";var g=a._defs.selectAll(\"g.clips\").selectAll(\"#\"+u.clipId).data([0]);g.enter().append(\"clipPath\").attr({class:\"plotclip\",id:u.clipId}).append(\"rect\"),g.selectAll(\"rect\").attr({width:m._length,height:v._length}),p.setTranslate(u.plot,m._offset,v._offset);var b,x;for(u._hasClipOnAxisFalse?(b=null,x=u.clipId):(b=u.clipId,x=null),p.setClipUrl(u.plot,b),e=0;e<y.traceLayerClasses.length;e++){var w=y.traceLayerClasses[e];\"scatterlayer\"!==w&&u.plot.selectAll(\"g.\"+w).call(p.setClipUrl,x)}u.layerClipId=x;var M=!m._anchorAxis,k=M&&!_[m._id],A=i(m,v,\"bottom\"),T=i(m,v,\"top\"),S=!v._anchorAxis,E=S&&!_[v._id],L=i(v,m,\"left\"),C=i(v,m,\"right\"),z=p.crispRound(t,m.linewidth,1),I=p.crispRound(t,v.linewidth,1),D=s(t,m,I,L,\"left\",h),P=!M&&D?-c-D:0,O=s(t,m,I,C,\"right\",h),R=m._length+(!M&&O?c+O:0),F=o.h*(1-(m.position||0))+z/2%1,j=v._length+c+z/2,N=-c-z/2,B=!S&&s(t,v,z,A,\"bottom\",h),U=v._length+(B?c:0),V=!S&&s(t,v,z,T,\"top\",h),H=V?-c:0,q=o.w*(v.position||0)+I/2%1,G=-c-I/2,Y=m._length+c+I/2;m._linepositions[r]=[A?j:void 0,T?N:void 0,k?F:void 0],m._anchorAxis===v?m._linepositions[r][3]=\"top\"===m.side?N:j:k&&(m._linepositions[r][3]=F),v._linepositions[r]=[L?G:void 0,C?Y:void 0,E?q:void 0],v._anchorAxis===m?v._linepositions[r][3]=\"right\"===v.side?Y:G:E&&(v._linepositions[r][3]=q);var X=\"translate(\"+m._offset+\",\"+v._offset+\")\",W=X,Z=X;k&&(W=\"translate(\"+m._offset+\",\"+o.t+\")\",N+=v._offset-o.t,j+=v._offset-o.t),E&&(Z=\"translate(\"+o.l+\",\"+v._offset+\")\",G+=m._offset-o.l,Y+=m._offset-o.l),f&&(u.xlines.attr(\"transform\",W).attr(\"d\",n(j,A)+n(N,T)+n(F,k)||\"M0,0\").style(\"stroke-width\",z+\"px\").call(d.stroke,m.showline?m.linecolor:\"rgba(0,0,0,0)\"),u.ylines.attr(\"transform\",Z).attr(\"d\",l(G,L)+l(Y,C)+l(q,E)||\"M0,0\").style(\"stroke-width\",I+\"px\").call(d.stroke,v.showline?v.linecolor:\"rgba(0,0,0,0)\")),u.xaxislayer.attr(\"transform\",W),u.yaxislayer.attr(\"transform\",Z),u.gridlayer.attr(\"transform\",X),u.zerolinelayer.attr(\"transform\",X),u.draglayer.attr(\"transform\",X),k&&(_[m._id]=1),E&&(_[v._id]=1)}),u.Axes.makeClipPaths(t),r.drawMainTitle(t),v.manage(t),t._promises.length&&Promise.all(t._promises)},r.drawMainTitle=function(t){var e=t._fullLayout;m.draw(t,\"gtitle\",{propContainer:e,propName:\"title\",dfltName:\"Plot\",attributes:{x:e.width/2,y:e._size.t/2,\"text-anchor\":\"middle\"}})},r.doTraceStyle=function(t){for(var e=0;e<t.calcdata.length;e++){var r=t.calcdata[e],n=((r[0]||{}).trace||{})._module||{},i=n.arraysToCalcdata;i&&i(r,r[0].trace)}return h.style(t),c.getComponentMethod(\"legend\",\"draw\")(t),h.previousPromises(t)},r.doColorBars=function(t){for(var e=0;e<t.calcdata.length;e++){var r=t.calcdata[e][0];if((r.t||{}).cb){var n=r.trace,i=r.t.cb;c.traceIs(n,\"contour\")&&i.line({width:!1!==n.contours.showlines?n.line.width:0,dash:n.line.dash,color:\"line\"===n.contours.coloring?i._opts.line.color:n.line.color}),c.traceIs(n,\"markerColorscale\")?i.options(n.marker.colorbar)():i.options(n.colorbar)()}}return h.previousPromises(t)},r.layoutReplot=function(t){var e=t.layout;return t.layout=void 0,u.plot(t,\"\",e)},r.doLegend=function(t){return c.getComponentMethod(\"legend\",\"draw\")(t),h.previousPromises(t)},r.doTicksRelayout=function(t){return u.Axes.doTicks(t,\"redraw\"),r.drawMainTitle(t),h.previousPromises(t)},r.doModeBar=function(t){var e,r,n,i=t._fullLayout;for(v.manage(t),g(t),e=h.getSubplotIds(i,\"gl3d\"),n=0;n<e.length;n++)r=i[e[n]]._scene,r.updateFx(i.dragmode,i.hovermode);for(e=h.getSubplotIds(i,\"gl2d\"),n=0;n<e.length;n++)r=i._plots[e[n]]._scene2d,r.updateFx(i.dragmode);for(e=h.getSubplotIds(i,\"mapbox\"),n=0;n<e.length;n++)r=i[e[n]]._subplot,r.updateFx(i);return h.previousPromises(t)},r.doCamera=function(t){for(var e=t._fullLayout,r=h.getSubplotIds(e,\"gl3d\"),n=0;n<r.length;n++){var i=e[r[n]];i._scene.setCamera(i.camera)}}},{\"../components/color\":603,\"../components/drawing\":627,\"../components/modebar\":663,\"../components/titles\":692,\"../lib\":725,\"../plotly\":761,\"../plots/cartesian/constants\":771,\"../plots/cartesian/graph_interact\":775,\"../plots/plots\":829,\"../registry\":844,d3:121}],759:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return!(t in e)||a.validate(e[t],c[t])}function n(t,r){return a.coerce(e,y,c,t,r)}function f(){return new Promise(function(t){setTimeout(t,o.getDelay(k._fullLayout))})}function d(){return new Promise(function(t,e){var r=s(k),n=k._fullLayout.width,o=k._fullLayout.height;if(i.purge(k),document.body.removeChild(k),\"svg\"===b)return t(M?r:\"data:image/svg+xml,\"+encodeURIComponent(r));var u=document.createElement(\"canvas\");u.id=a.randstr(),l({format:b,width:n,height:o,canvas:u,svg:r,promise:!0}).then(t).catch(e)})}function p(t){return M?t.replace(h,\"\"):t}e=e||{};var m,v,g;if(a.isPlainObject(t)?(m=t.data||[],v=t.layout||{},g=t.config||{}):(t=u(t),m=a.extendDeep([],t.data),v=a.extendDeep({},t.layout),g=t._context),!r(\"width\")||!r(\"height\"))throw new Error(\"Height and width should be pixel values.\");if(!r(\"format\"))throw new Error(\"Image format is not jpeg, png, svg or webp.\");var y={},b=n(\"format\"),x=n(\"width\"),_=n(\"height\"),w=n(\"setBackground\"),M=n(\"imageDataOnly\"),k=document.createElement(\"div\");k.style.position=\"absolute\",k.style.left=\"-5000px\",document.body.appendChild(k);var A=a.extendFlat({},v);x&&(A.width=x),_&&(A.height=_);var T=a.extendFlat({},g,{staticPlot:!0,plotGlPixelRatio:g.plotGlPixelRatio||2,setBackground:w}),S=o.getRedrawFunc(k);return new Promise(function(t,e){i.plot(k,m,A,T).then(S).then(f).then(d).then(function(e){t(p(e))}).catch(function(t){e(t)})})}var i=t(\"../plotly\"),a=t(\"../lib\"),o=t(\"../snapshot/helpers\"),s=t(\"../snapshot/tosvg\"),l=t(\"../snapshot/svgtoimg\"),u=t(\"./helpers\").getGraphDiv,c={format:{valType:\"enumerated\",values:[\"png\",\"jpeg\",\"webp\",\"svg\"],dflt:\"png\"},width:{valType:\"number\",min:1},height:{valType:\"number\",min:1},setBackground:{valType:\"any\",dflt:!1},imageDataOnly:{valType:\"boolean\",dflt:!1}},h=/^data:image\\/\\w+;base64,/;e.exports=n},{\"../lib\":725,\"../plotly\":761,\"../snapshot/helpers\":848,\"../snapshot/svgtoimg\":850,\"../snapshot/tosvg\":852,\"./helpers\":751}],760:[function(t,e,r){\"use strict\";function n(t,e,r,i,a,u){u=u||[];for(var c=Object.keys(t),f=0;f<c.length;f++){var d=c[f];if(\"transforms\"!==d){var v=u.slice();v.push(d)\n",
       ";var g=t[d],y=e[d],b=l(r,d),x=\"info_array\"===(b||{}).valType,_=\"colorscale\"===(b||{}).valType;if(s(r,d))if(p(g)&&p(y))n(g,y,b,i,a,v);else if(b.items&&!x&&m(g)){var w,M,k=b.items,A=k[Object.keys(k)[0]],T=[];for(w=0;w<y.length;w++){var S=y[w]._index||w;M=v.slice(),M.push(S),p(g[S])&&p(y[w])&&(T.push(S),n(g[S],y[w],A,i,a,M))}for(w=0;w<g.length;w++)M=v.slice(),M.push(w),p(g[w])?-1===T.indexOf(w)&&i.push(o(\"unused\",a,M)):i.push(o(\"object\",a,M,g[w]))}else!p(g)&&p(y)?i.push(o(\"object\",a,v,g)):m(g)||!m(y)||x||_?d in e?h.validate(g,b)?\"enumerated\"===b.valType&&(b.coerceNumber&&g!==+y||g!==y)&&i.push(o(\"dynamic\",a,v,g,y)):i.push(o(\"value\",a,v,g)):i.push(o(\"unused\",a,v,g)):i.push(o(\"array\",a,v,g));else i.push(o(\"schema\",a,v))}}return i}function i(t,e){for(var r=0;r<e.length;r++){var n=e[r].type,i=t.traces[n].layoutAttributes;i&&h.extendFlat(t.layout.layoutAttributes,i)}return t.layout.layoutAttributes}function a(t){return m(t)?\"In data trace \"+t[1]+\", \":\"In \"+t+\", \"}function o(t,e,r,n,i){r=r||\"\";var a,o;m(e)?(a=e[0],o=e[1]):(a=e,o=null);var s=c(r),l=v[t](e,s,n,i);return h.log(l),{code:t,container:a,trace:o,path:r,astr:s,msg:l}}function s(t,e){var r=u(e),n=r.keyMinusId,i=r.id;return!!(n in t&&t[n]._isSubplotObj&&i)||e in t}function l(t,e){return t[u(e).keyMinusId]}function u(t){var e=/([2-9]|[1-9][0-9]+)$/,r=t.split(e)[0];return{keyMinusId:r,id:t.substr(r.length,t.length)}}function c(t){if(!m(t))return String(t);for(var e=\"\",r=0;r<t.length;r++){var n=t[r];\"number\"==typeof n?e=e.substr(0,e.length-1)+\"[\"+n+\"]\":e+=n,r<t.length-1&&(e+=\".\")}return e}var h=t(\"../lib\"),f=t(\"../plots/plots\"),d=t(\"./plot_schema\"),p=h.isPlainObject,m=Array.isArray;e.exports=function(t,e){var r,a,s=d.get(),l=[],u={};m(t)?(u.data=h.extendDeep([],t),r=t):(u.data=[],r=[],l.push(o(\"array\",\"data\"))),p(e)?(u.layout=h.extendDeep({},e),a=e):(u.layout={},a={},arguments.length>1&&l.push(o(\"object\",\"layout\"))),f.supplyDefaults(u);for(var c=u._fullData,v=r.length,g=0;g<v;g++){var y=r[g],b=[\"data\",g];if(p(y)){var x=c[g],_=x.type,w=s.traces[_].attributes;w.type={valType:\"enumerated\",values:[_]},!1===x.visible&&!1!==y.visible&&l.push(o(\"invisible\",b)),n(y,x,w,l,b);var M=y.transforms,k=x.transforms;if(M){m(M)||l.push(o(\"array\",b,[\"transforms\"])),b.push(\"transforms\");for(var A=0;A<M.length;A++){var T=[\"transforms\",A],S=M[A].type;if(p(M[A])){var E=s.transforms[S]?s.transforms[S].attributes:{};E.type={valType:\"enumerated\",values:Object.keys(s.transforms)},n(M[A],k[A],E,l,b,T)}else l.push(o(\"object\",b,T))}}}else l.push(o(\"object\",b))}return n(a,u._fullLayout,i(s,c),l,\"layout\"),0===l.length?void 0:l};var v={object:function(t,e){return(\"layout\"===t&&\"\"===e?\"The layout argument\":\"data\"===t[0]&&\"\"===e?\"Trace \"+t[1]+\" in the data argument\":a(t)+\"key \"+e)+\" must be linked to an object container\"},array:function(t,e){return(\"data\"===t?\"The data argument\":a(t)+\"key \"+e)+\" must be linked to an array container\"},schema:function(t,e){return a(t)+\"key \"+e+\" is not part of the schema\"},unused:function(t,e,r){var n=p(r)?\"container\":\"key\";return a(t)+n+\" \"+e+\" did not get coerced\"},dynamic:function(t,e,r,n){return[a(t)+\"key\",e,\"(set to '\"+r+\"')\",\"got reset to\",\"'\"+n+\"'\",\"during defaults.\"].join(\" \")},invisible:function(t){return\"Trace \"+t[1]+\" got defaulted to be not visible\"},value:function(t,e,r){return[a(t)+\"key \"+e,\"is set to an invalid value (\"+r+\")\"].join(\" \")}}},{\"../lib\":725,\"../plots/plots\":829,\"./plot_schema\":755}],761:[function(t,e,r){\"use strict\";r.defaultConfig=t(\"./plot_api/plot_config\"),r.Plots=t(\"./plots/plots\"),r.Axes=t(\"./plots/cartesian/axes\"),r.ModeBar=t(\"./components/modebar\"),t(\"./plot_api/plot_api\")},{\"./components/modebar\":663,\"./plot_api/plot_api\":753,\"./plot_api/plot_config\":754,\"./plots/cartesian/axes\":766,\"./plots/plots\":829}],762:[function(t,e,r){\"use strict\";e.exports={mode:{valType:\"enumerated\",dflt:\"afterall\",values:[\"immediate\",\"next\",\"afterall\"]},direction:{valType:\"enumerated\",values:[\"forward\",\"reverse\"],dflt:\"forward\"},fromcurrent:{valType:\"boolean\",dflt:!1},frame:{duration:{valType:\"number\",min:0,dflt:500},redraw:{valType:\"boolean\",dflt:!0}},transition:{duration:{valType:\"number\",min:0,dflt:500},easing:{valType:\"enumerated\",dflt:\"cubic-in-out\",values:[\"linear\",\"quad\",\"cubic\",\"sin\",\"exp\",\"circle\",\"elastic\",\"back\",\"bounce\",\"linear-in\",\"quad-in\",\"cubic-in\",\"sin-in\",\"exp-in\",\"circle-in\",\"elastic-in\",\"back-in\",\"bounce-in\",\"linear-out\",\"quad-out\",\"cubic-out\",\"sin-out\",\"exp-out\",\"circle-out\",\"elastic-out\",\"back-out\",\"bounce-out\",\"linear-in-out\",\"quad-in-out\",\"cubic-in-out\",\"sin-in-out\",\"exp-in-out\",\"circle-in-out\",\"elastic-in-out\",\"back-in-out\",\"bounce-in-out\"]}}}},{}],763:[function(t,e,r){\"use strict\";var n=t(\"../lib\");e.exports=function(t,e,r){var i,a=r.name,o=e[a],s=n.isArray(t[a])?t[a]:[],l=e[a]=[];for(i=0;i<s.length;i++){var u=s[i],c={},h={};n.isPlainObject(u)||(h.itemIsNotPlainObject=!0,u={}),r.handleItemDefaults(u,c,e,r,h),c._input=u,c._index=i,l.push(c)}if(n.isArray(o)){var f=Math.min(o.length,l.length);for(i=0;i<f;i++)n.relinkPrivateKeys(l[i],o[i])}}},{\"../lib\":725}],764:[function(t,e,r){\"use strict\";var n=t(\"../components/fx/attributes\");e.exports={type:{valType:\"enumerated\",values:[],dflt:\"scatter\"},visible:{valType:\"enumerated\",values:[!0,!1,\"legendonly\"],dflt:!0},showlegend:{valType:\"boolean\",dflt:!0},legendgroup:{valType:\"string\",dflt:\"\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},name:{valType:\"string\"},uid:{valType:\"string\",dflt:\"\"},ids:{valType:\"data_array\"},customdata:{valType:\"data_array\"},hoverinfo:{valType:\"flaglist\",flags:[\"x\",\"y\",\"z\",\"text\",\"name\"],extras:[\"all\",\"none\",\"skip\"],arrayOk:!0,dflt:\"all\"},hoverlabel:n.hoverlabel,stream:{token:{valType:\"string\",noBlank:!0,strict:!0},maxpoints:{valType:\"number\",min:0,max:1e4,dflt:500}}}},{\"../components/fx/attributes\":636}],765:[function(t,e,r){\"use strict\";e.exports={xaxis:{valType:\"subplotid\",dflt:\"x\"},yaxis:{valType:\"subplotid\",dflt:\"y\"}}},{}],766:[function(t,e,r){\"use strict\";function n(t){return+t}function i(t){return String(t)}function a(t,e,r,n,i){function a(e){return(1+100*(e-t)/r.dtick)%100<2}for(var o=0,s=0,l=0,u=0,c=0;c<e.length;c++)e[c]%1==0?l++:M(e[c])||u++,a(e[c])&&o++,a(e[c]+r.dtick/2)&&s++;var h=e.length-u;if(l===h&&\"date\"!==r.type)r.dtick<1?t=n-.5*r.dtick:(t-=.5)+r.dtick<n&&(t+=r.dtick);else if(s<.1*h&&(o>.3*h||a(n)||a(i))){var f=r.dtick/2;t+=t+f<n?f:-f}return t}function o(t,e,r,n,i){var a=A.findExactDates(e,i);if(a.exactDays>.8){var o=Number(r.substr(1));a.exactYears>.8&&o%12==0?t=B.tickIncrement(t,\"M6\",\"reverse\")+1.5*P:a.exactMonths>.8?t=B.tickIncrement(t,\"M1\",\"reverse\")+15.5*P:t-=P/2;var s=B.tickIncrement(t,r);if(s<=n)return s}return t}function s(t){var e,r,n=t.tickvals,i=t.ticktext,a=new Array(n.length),o=A.simpleMap(t.range,t.r2l),s=1.0001*o[0]-1e-4*o[1],l=1.0001*o[1]-1e-4*o[0],u=Math.min(s,l),h=Math.max(s,l),f=0;Array.isArray(i)||(i=[]);var d=\"category\"===t.type?t.d2l_noadd:t.d2l;for(\"log\"===t.type&&\"L\"!==String(t.dtick).charAt(0)&&(t.dtick=\"L\"+Math.pow(10,Math.floor(Math.min(t.range[0],t.range[1]))-1)),r=0;r<n.length;r++)(e=d(n[r]))>u&&e<h&&(void 0===i[r]?a[f]=B.tickText(t,e):a[f]=c(t,e,String(i[r])),f++);return f<n.length&&a.splice(f,n.length-f),a}function l(t,e,r){return e*A.roundUp(t/e,r)}function u(t){var e=t.dtick;if(t._tickexponent=0,M(e)||\"string\"==typeof e||(e=1),\"category\"===t.type&&(t._tickround=null),\"date\"===t.type){var r=t.r2l(t.tick0),n=t.l2r(r).replace(/(^-|i)/g,\"\"),i=n.length;if(\"M\"===String(e).charAt(0))i>10||\"01-01\"!==n.substr(5)?t._tickround=\"d\":t._tickround=+e.substr(1)%12==0?\"y\":\"m\";else if(e>=P&&i<=10||e>=15*P)t._tickround=\"d\";else if(e>=R&&i<=16||e>=O)t._tickround=\"M\";else if(e>=F&&i<=19||e>=R)t._tickround=\"S\";else{var a=t.l2r(r+e).replace(/^-/,\"\").length;t._tickround=Math.max(i,a)-20}}else if(M(e)||\"L\"===e.charAt(0)){var o=t.range.map(t.r2d||Number);M(e)||(e=Number(e.substr(1))),t._tickround=2-Math.floor(Math.log(e)/Math.LN10+.01);var s=Math.max(Math.abs(o[0]),Math.abs(o[1])),l=Math.floor(Math.log(s)/Math.LN10+.01);Math.abs(l)>3&&(m(t.exponentformat)&&!v(l)?t._tickexponent=3*Math.round((l-1)/3):t._tickexponent=l)}else t._tickround=null}function c(t,e,r){var n=t.tickfont||{};return{x:e,dx:0,dy:0,text:r||\"\",fontSize:n.size,font:n.family,fontColor:n.color}}function h(t,e,r,n){var i=t._tickround,a=r&&t.hoverformat||t.tickformat;n&&(i=M(i)?4:{y:\"m\",m:\"d\",d:\"M\",M:\"S\",S:4}[i]);var o,s=A.formatDate(e.x,a,i,t.calendar),l=s.indexOf(\"\\n\");-1!==l&&(o=s.substr(l+1),s=s.substr(0,l)),n&&(\"00:00:00\"===s||\"00:00\"===s?(s=o,o=\"\"):8===s.length&&(s=s.replace(/:00$/,\"\"))),o&&(r?\"d\"===i?s+=\", \"+o:s=o+(s?\", \"+s:\"\"):t._inCalcTicks&&o===t._prevDateHead||(s+=\"<br>\"+o,t._prevDateHead=o)),e.text=s}function f(t,e,r,n,i){var a=t.dtick,o=e.x;if(\"never\"===i&&(i=\"\"),!n||\"string\"==typeof a&&\"L\"===a.charAt(0)||(a=\"L3\"),t.tickformat||\"string\"==typeof a&&\"L\"===a.charAt(0))e.text=g(Math.pow(10,o),t,i,n);else if(M(a)||\"D\"===a.charAt(0)&&A.mod(o+.01,1)<.1){var s=Math.round(o);-1!==[\"e\",\"E\",\"power\"].indexOf(t.exponentformat)||m(t.exponentformat)&&v(s)?(e.text=0===s?1:1===s?\"10\":s>1?\"10<sup>\"+s+\"</sup>\":\"10<sup>\"+j+-s+\"</sup>\",e.fontSize*=1.25):(e.text=g(Math.pow(10,o),t,\"\",\"fakehover\"),\"D1\"===a&&\"y\"===t._id.charAt(0)&&(e.dy-=e.fontSize/6))}else{if(\"D\"!==a.charAt(0))throw\"unrecognized dtick \"+String(a);e.text=String(Math.round(Math.pow(10,A.mod(o,1)))),e.fontSize*=.75}if(\"D1\"===t.dtick){var l=String(e.text).charAt(0);\"0\"!==l&&\"1\"!==l||(\"y\"===t._id.charAt(0)?e.dx-=e.fontSize/4:(e.dy+=e.fontSize/2,e.dx+=(t.range[1]>t.range[0]?1:-1)*e.fontSize*(o<0?.5:.25)))}}function d(t,e){var r=t._categories[Math.round(e.x)];void 0===r&&(r=\"\"),e.text=String(r)}function p(t,e,r,n,i){\"never\"===i?i=\"\":\"all\"===t.showexponent&&Math.abs(e.x/t.dtick)<1e-6&&(i=\"hide\"),e.text=g(e.x,t,i,n)}function m(t){return\"SI\"===t||\"B\"===t}function v(t){return t>14||t<-15}function g(t,e,r,n){var i=t<0,a=e._tickround,o=r||e.exponentformat||\"B\",s=e._tickexponent,l=e.tickformat,c=e.separatethousands;if(n){var h={exponentformat:e.exponentformat,dtick:\"none\"===e.showexponent?e.dtick:M(t)?Math.abs(t)||1:1,range:\"none\"===e.showexponent?e.range.map(e.r2d):[0,t||1]};u(h),a=(Number(h._tickround)||0)+4,s=h._tickexponent,e.hoverformat&&(l=e.hoverformat)}if(l)return w.format(l)(t).replace(/-/g,j);var f=Math.pow(10,-a)/2;if(\"none\"===o&&(s=0),(t=Math.abs(t))<f)t=\"0\",i=!1;else{if(t+=f,s&&(t*=Math.pow(10,-s),a+=s),0===a)t=String(Math.floor(t));else if(a<0){t=String(Math.round(t)),t=t.substr(0,t.length+a);for(var d=a;d<0;d++)t+=\"0\"}else{t=String(t);var p=t.indexOf(\".\")+1;p&&(t=t.substr(0,p+a).replace(/\\.?0+$/,\"\"))}t=A.numSeparate(t,e._separators,c)}if(s&&\"hide\"!==o){m(o)&&v(s)&&(o=\"power\");var g;g=s<0?j+-s:\"power\"!==o?\"+\"+s:String(s),\"e\"===o?t+=\"e\"+g:\"E\"===o?t+=\"E\"+g:\"power\"===o?t+=\"\\xd710<sup>\"+g+\"</sup>\":\"B\"===o&&9===s?t+=\"B\":m(o)&&(t+=J[s/3+5])}return i?j+t:t}function y(t,e){var r,n,i=[];for(r=0;r<e.length;r++){var a=[],o=t._fullData[e[r]].xaxis,s=t._fullData[e[r]].yaxis;if(o&&s){for(n=0;n<i.length;n++)-1===i[n].x.indexOf(o)&&-1===i[n].y.indexOf(s)||a.push(n);if(a.length){var l,u=i[a[0]];if(a.length>1)for(n=1;n<a.length;n++)l=i[a[n]],b(u.x,l.x),b(u.y,l.y);b(u.x,[o]),b(u.y,[s])}else i.push({x:[o],y:[s]})}}return i}function b(t,e){for(var r=0;r<e.length;r++)-1===t.indexOf(e[r])&&t.push(e[r])}function x(t,e,r){var n,i,a=[],o=[],s=t.layout;for(n=0;n<e.length;n++)a.push(B.getFromId(t,e[n]));for(n=0;n<r.length;n++)o.push(B.getFromId(t,r[n]));var l=Object.keys(a[0]),u=[\"anchor\",\"domain\",\"overlaying\",\"position\",\"side\",\"tickangle\"],c=[\"linear\",\"log\"];for(n=0;n<l.length;n++){var h=l[n],f=a[0][h],d=o[0][h],p=!0,m=!1,v=!1;if(\"_\"!==h.charAt(0)&&\"function\"!=typeof f&&-1===u.indexOf(h)){for(i=1;i<a.length&&p;i++){var g=a[i][h];\"type\"===h&&-1!==c.indexOf(f)&&-1!==c.indexOf(g)&&f!==g?m=!0:g!==f&&(p=!1)}for(i=1;i<o.length&&p;i++){var y=o[i][h];\"type\"===h&&-1!==c.indexOf(d)&&-1!==c.indexOf(y)&&d!==y?v=!0:o[i][h]!==d&&(p=!1)}p&&(m&&(s[a[0]._name].type=\"linear\"),v&&(s[o[0]._name].type=\"linear\"),_(s,h,a,o))}}for(n=0;n<t._fullLayout.annotations.length;n++){var b=t._fullLayout.annotations[n];-1!==e.indexOf(b.xref)&&-1!==r.indexOf(b.yref)&&A.swapAttrs(s.annotations[n],[\"?\"])}}function _(t,e,r,n){var i,a=A.nestedProperty,o=a(t[r[0]._name],e).get(),s=a(t[n[0]._name],e).get();for(\"title\"===e&&(\"Click to enter X axis title\"===o&&(o=\"Click to enter Y axis title\"),\"Click to enter Y axis title\"===s&&(s=\"Click to enter X axis title\")),i=0;i<r.length;i++)a(t,r[i]._name+\".\"+e).set(s);for(i=0;i<n.length;i++)a(t,n[i]._name+\".\"+e).set(o)}var w=t(\"d3\"),M=t(\"fast-isnumeric\"),k=t(\"../../registry\"),A=t(\"../../lib\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../../components/titles\"),E=t(\"../../components/color\"),L=t(\"../../components/drawing\"),C=t(\"../../constants/numerical\"),z=C.FP_SAFE,I=C.ONEAVGYEAR,D=C.ONEAVGMONTH,P=C.ONEDAY,O=C.ONEHOUR,R=C.ONEMIN,F=C.ONESEC,j=C.MINUS_SIGN,N=t(\"../../constants/alignment\").MID_SHIFT,B=e.exports={};B.layoutAttributes=t(\"./layout_attributes\"),B.supplyLayoutDefaults=t(\"./layout_defaults\"),B.setConvert=t(\"./set_convert\");var U=t(\"./axis_autotype\"),V=t(\"./axis_ids\");B.id2name=V.id2name,B.cleanId=V.cleanId,B.list=V.list,B.listIds=V.listIds,B.getFromId=V.getFromId,B.getFromTrace=V.getFromTrace,B.coerceRef=function(t,e,r,n,i,a){var o=n.charAt(n.length-1),s=B.listIds(r,o),l=n+\"ref\",u={};return i||(i=s[0]||a),a||(a=i),u[l]={valType:\"enumerated\",values:s.concat(a?[a]:[]),dflt:i},A.coerce(t,e,u,l)},B.coercePosition=function(t,e,r,n,i,a){var o,s;if(\"paper\"===n||\"pixel\"===n)o=A.ensureNumber,s=r(i,a);else{var l=B.getFromId(e,n);a=l.fraction2r(a),s=r(i,a),o=l.cleanPos}t[i]=o(s)},B.cleanPosition=function(t,e,r){return(\"paper\"===r||\"pixel\"===r?A.ensureNumber:B.getFromId(e,r).cleanPos)(t)};var H=B.getDataConversions=function(t,e,r,a){var o,s=\"x\"===r||\"y\"===r||\"z\"===r?r:a;if(Array.isArray(s)){if(o={type:U(a),_categories:[]},B.setConvert(o),\"category\"===o.type)for(var l=0;l<a.length;l++)o.d2c(a[l])}else o=B.getFromTrace(t,e,s);return o?{d2c:o.d2c,c2d:o.c2d}:\"ids\"===s?{d2c:i,c2d:i}:{d2c:n,c2d:n}};B.getDataToCoordFunc=function(t,e,r,n){return H(t,e,r,n).d2c},B.clearTypes=function(t,e){Array.isArray(e)&&e.length||(e=t._fullData.map(function(t,e){return e})),e.forEach(function(e){var r=t.data[e];delete(B.getFromId(t,r.xaxis)||{}).type,delete(B.getFromId(t,r.yaxis)||{}).type})},B.counterLetter=function(t){var e=t.charAt(0);return\"x\"===e?\"y\":\"y\"===e?\"x\":void 0},B.minDtick=function(t,e,r,n){-1===[\"log\",\"category\"].indexOf(t.type)&&n?void 0===t._minDtick?(t._minDtick=e,t._forceTick0=r):t._minDtick&&((t._minDtick/e+1e-6)%1<2e-6&&((r-t._forceTick0)/e%1+1.000001)%1<2e-6?(t._minDtick=e,t._forceTick0=r):((e/t._minDtick+1e-6)%1>2e-6||((r-t._forceTick0)/t._minDtick%1+1.000001)%1>2e-6)&&(t._minDtick=0)):t._minDtick=0},B.getAutoRange=function(t){var e,r=[],n=t._min[0].val,i=t._max[0].val;for(e=1;e<t._min.length&&n===i;e++)n=Math.min(n,t._min[e].val);for(e=1;e<t._max.length&&n===i;e++)i=Math.max(i,t._max[e].val);var a,o,s,l,u,c,h,f=0,d=!1;if(t.range){var p=A.simpleMap(t.range,t.r2l);d=p[1]<p[0]}for(\"reversed\"===t.autorange&&(d=!0,t.autorange=!0),e=0;e<t._min.length;e++)for(o=t._min[e],a=0;a<t._max.length;a++)s=t._max[a],h=s.val-o.val,c=t._length-o.pad-s.pad,h>0&&c>0&&h/c>f&&(l=o,u=s,f=h/c);if(n===i){var m=n-1,v=n+1;r=\"tozero\"===t.rangemode?n<0?[m,0]:[0,v]:\"nonnegative\"===t.rangemode?[Math.max(0,m),Math.max(0,v)]:[m,v]}else f&&(\"linear\"!==t.type&&\"-\"!==t.type||(\"tozero\"===t.rangemode?(l.val>=0&&(l={val:0,pad:0}),u.val<=0&&(u={val:0,pad:0})):\"nonnegative\"===t.rangemode&&(l.val-f*l.pad<0&&(l={val:0,pad:0}),u.val<0&&(u={val:1,pad:0})),f=(u.val-l.val)/(t._length-l.pad-u.pad)),r=[l.val-f*l.pad,u.val+f*u.pad]);return r[0]===r[1]&&(\"tozero\"===t.rangemode?r=r[0]<0?[r[0],0]:r[0]>0?[0,r[0]]:[0,1]:(r=[r[0]-1,r[0]+1],\"nonnegative\"===t.rangemode&&(r[0]=Math.max(0,r[0])))),d&&r.reverse(),A.simpleMap(r,t.l2r||Number)},B.doAutoRange=function(t){t._length||t.setScale();var e=t._min&&t._max&&t._min.length&&t._max.length;if(t.autorange&&e){t.range=B.getAutoRange(t),t._r=t.range.slice(),t._rl=A.simpleMap(t._r,t.r2l);var r=t._input;r.range=t.range.slice(),r.autorange=t.autorange}},B.saveRangeInitial=function(t,e){for(var r=B.list(t,\"\",!0),n=!1,i=0;i<r.length;i++){var a=r[i],o=void 0===a._rangeInitial,s=o||!(a.range[0]===a._rangeInitial[0]&&a.range[1]===a._rangeInitial[1]);(o&&!1===a.autorange||e&&s)&&(a._rangeInitial=a.range.slice(),n=!0)}return n},B.saveShowSpikeInitial=function(t,e){for(var r=B.list(t,\"\",!0),n=!1,i=\"on\",a=0;a<r.length;a++){var o=r[a],s=void 0===o._showSpikeInitial,l=s||!(o.showspikes===o._showspikes);(s||e&&l)&&(o._showSpikeInitial=o.showspikes,n=!0),\"on\"!==i||o.showspikes||(i=\"off\")}return t._fullLayout._cartesianSpikesEnabled=i,n},B.expand=function(t,e,r){function n(t){if(Array.isArray(t))return function(e){return Math.max(Number(t[e]||0),0)};var e=Math.max(Number(t||0),0);return function(){return e}}function i(r){function n(t){return M(t)&&Math.abs(t)<z}if(l=e[r],M(l)){if(h=b(r)+g,f=x(r)+g,p=l-w(r),m=l+_(r),\"log\"===t.type&&p<m/10&&(p=m/10),u=t.c2l(p),c=t.c2l(m),y&&(u=Math.min(0,u),c=Math.max(0,c)),n(u)){for(d=!0,o=0;o<t._min.length&&d;o++)s=t._min[o],s.val<=u&&s.pad>=f?d=!1:s.val>=u&&s.pad<=f&&(t._min.splice(o,1),o--);d&&t._min.push({val:u,pad:y&&0===u?0:f})}if(n(c)){for(d=!0,o=0;o<t._max.length&&d;o++)s=t._max[o],s.val>=c&&s.pad>=h?d=!1:s.val<=c&&s.pad<=h&&(t._max.splice(o,1),o--);d&&t._max.push({val:c,pad:y&&0===c?0:h})}}}if((t.autorange||!!A.nestedProperty(t,\"rangeslider.autorange\").get())&&e){t._min||(t._min=[]),t._max||(t._max=[]),r||(r={}),t._m||t.setScale();var a,o,s,l,u,c,h,f,d,p,m,v=e.length,g=r.padded?.05*t._length:0,y=r.tozero&&(\"linear\"===t.type||\"-\"===t.type);g&&\"domain\"===t.constrain&&t._inputDomain&&(g*=(t._inputDomain[1]-t._inputDomain[0])/(t.domain[1]-t.domain[0]));var b=n((t._m>0?r.ppadplus:r.ppadminus)||r.ppad||0),x=n((t._m>0?r.ppadminus:r.ppadplus)||r.ppad||0),_=n(r.vpadplus||r.vpad),w=n(r.vpadminus||r.vpad);for(a=0;a<6;a++)i(a);for(a=v-1;a>5;a--)i(a)}},B.autoBin=function(t,e,r,n,i){var s=A.aggNums(Math.min,null,t),l=A.aggNums(Math.max,null,t);if(i||(i=e.calendar),\"category\"===e.type)return{start:s-.5,end:l+.5,size:1};var u;if(r)u=(l-s)/r;else{var c=A.distinctVals(t),h=Math.pow(10,Math.floor(Math.log(c.minDiff)/Math.LN10)),f=h*A.roundUp(c.minDiff/h,[.9,1.9,4.9,9.9],!0);u=Math.max(f,2*A.stdev(t)/Math.pow(t.length,n?.25:.4)),M(u)||(u=1)}var d;d=\"log\"===e.type?{type:\"linear\",range:[s,l]}:{type:e.type,range:A.simpleMap([s,l],e.c2r,0,i),calendar:i},B.setConvert(d),B.autoTicks(d,u);var p,m=B.tickIncrement(B.tickFirst(d),d.dtick,\"reverse\",i);if(\"number\"==typeof d.dtick){m=a(m,t,d,s,l);p=m+(1+Math.floor((l-m)/d.dtick))*d.dtick}else for(\"M\"===d.dtick.charAt(0)&&(m=o(m,t,d.dtick,s,i)),p=m;p<=l;)p=B.tickIncrement(p,d.dtick,!1,i);return{start:e.c2r(m,0,i),end:e.c2r(p,0,i),size:d.dtick}},B.calcTicks=function(t){var e=A.simpleMap(t.range,t.r2l);if(\"auto\"===t.tickmode||!t.dtick){var r,n=t.nticks;n||(\"category\"===t.type?(r=t.tickfont?1.2*(t.tickfont.size||12):15,n=t._length/r):(r=\"y\"===t._id.charAt(0)?40:80,n=A.constrain(t._length/r,4,9)+1)),\"array\"===t.tickmode&&(n*=100),B.autoTicks(t,Math.abs(e[1]-e[0])/n),t._minDtick>0&&t.dtick<2*t._minDtick&&(t.dtick=t._minDtick,t.tick0=t.l2r(t._forceTick0))}if(t.tick0||(t.tick0=\"date\"===t.type?\"2000-01-01\":0),u(t),\"array\"===t.tickmode)return s(t);t._tmin=B.tickFirst(t);var i=e[1]<e[0],a=[],o=1.0001*e[1]-1e-4*e[0];\"category\"===t.type&&(o=i?Math.max(-.5,o):Math.min(t._categories.length-.5,o));for(var l=null,c=Math.max(1e3,t._length||0),h=t._tmin;(i?h>=o:h<=o)&&!(a.length>c||h===l);h=B.tickIncrement(h,t.dtick,i,t.calendar))l=h,a.push(h);t._tmax=a[a.length-1],t._prevDateHead=\"\",t._inCalcTicks=!0;for(var f=new Array(a.length),d=0;d<a.length;d++)f[d]=B.tickText(t,a[d]);return t._inCalcTicks=!1,f};var q=[2,5,10],G=[1,2,3,6,12],Y=[1,2,5,10,15,30],X=[1,2,3,7,14],W=[-.046,0,.301,.477,.602,.699,.778,.845,.903,.954,1],Z=[-.301,0,.301,.699,1];B.autoTicks=function(t,e){var r;if(\"date\"===t.type){t.tick0=A.dateTick0(t.calendar);var n=2*e;n>I?(e/=I,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=\"M\"+12*l(e,r,q)):n>D?(e/=D,t.dtick=\"M\"+l(e,1,G)):n>P?(t.dtick=l(e,P,X),t.tick0=A.dateTick0(t.calendar,!0)):n>O?t.dtick=l(e,O,G):n>R?t.dtick=l(e,R,Y):n>F?t.dtick=l(e,F,Y):(r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=l(e,r,q))}else if(\"log\"===t.type){t.tick0=0;var i=A.simpleMap(t.range,t.r2l);if(e>.7)t.dtick=Math.ceil(e);else if(Math.abs(i[1]-i[0])<1){var a=1.5*Math.abs((i[1]-i[0])/e);e=Math.abs(Math.pow(10,i[1])-Math.pow(10,i[0]))/a,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=\"L\"+l(e,r,q)}else t.dtick=e>.3?\"D2\":\"D1\"}else\"category\"===t.type?(t.tick0=0,t.dtick=Math.ceil(Math.max(e,1))):(t.tick0=0,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=l(e,r,q));if(0===t.dtick&&(t.dtick=1),!M(t.dtick)&&\"string\"!=typeof t.dtick){var o=t.dtick;throw t.dtick=1,\"ax.dtick error: \"+String(o)}},B.tickIncrement=function(t,e,r,n){var i=r?-1:1;if(M(e))return t+i*e;var a=e.charAt(0),o=i*Number(e.substr(1));if(\"M\"===a)return A.incrementMonth(t,o,n);if(\"L\"===a)return Math.log(Math.pow(10,t)+o)/Math.LN10;if(\"D\"===a){var s=\"D2\"===e?Z:W,l=t+.01*i,u=A.roundUp(A.mod(l,1),s,r);return Math.floor(l)+Math.log(w.round(Math.pow(10,u),1))/Math.LN10}throw\"unrecognized dtick \"+String(e)},B.tickFirst=function(t){var e=t.r2l||Number,r=A.simpleMap(t.range,e),n=r[1]<r[0],i=n?Math.floor:Math.ceil,a=1.0001*r[0]-1e-4*r[1],o=t.dtick,s=e(t.tick0);if(M(o)){var l=i((a-s)/o)*o+s;return\"category\"===t.type&&(l=A.constrain(l,0,t._categories.length-1)),l}var u=o.charAt(0),c=Number(o.substr(1));if(\"M\"===u){for(var h,f,d,p=0,m=s;p<10;){if(((h=B.tickIncrement(m,o,n,t.calendar))-a)*(m-a)<=0)return n?Math.min(m,h):Math.max(m,h);f=(a-(m+h)/2)/(h-m),d=u+(Math.abs(Math.round(f))||1)*c,m=B.tickIncrement(m,d,f<0?!n:n,t.calendar),p++}return A.error(\"tickFirst did not converge\",t),m}if(\"L\"===u)return Math.log(i((Math.pow(10,a)-s)/c)*c+s)/Math.LN10;if(\"D\"===u){var v=\"D2\"===o?Z:W,g=A.roundUp(A.mod(a,1),v,n);return Math.floor(a)+Math.log(w.round(Math.pow(10,g),1))/Math.LN10}throw\"unrecognized dtick \"+String(o)},B.tickText=function(t,e,r){function n(n){var i;return void 0===n||(r?\"none\"===n:(i={first:t._tmin,last:t._tmax}[n],\"all\"!==n&&e!==i))}var i,a,o=c(t,e),s=\"array\"===t.tickmode,l=r||s,u=\"category\"===t.type?t.d2l_noadd:t.d2l;if(s&&Array.isArray(t.ticktext)){var m=A.simpleMap(t.range,t.r2l),v=Math.abs(m[1]-m[0])/1e4;for(a=0;a<t.ticktext.length&&!(Math.abs(e-u(t.tickvals[a]))<v);a++);if(a<t.ticktext.length)return o.text=String(t.ticktext[a]),o}return i=r?\"never\":\"none\"!==t.exponentformat&&n(t.showexponent)?\"hide\":\"\",\"date\"===t.type?h(t,o,r,l):\"log\"===t.type?f(t,o,r,l,i):\"category\"===t.type?d(t,o):p(t,o,r,l,i),t.tickprefix&&!n(t.showtickprefix)&&(o.text=t.tickprefix+o.text),t.ticksuffix&&!n(t.showticksuffix)&&(o.text+=t.ticksuffix),o};var J=[\"f\",\"p\",\"n\",\"\\u03bc\",\"m\",\"\",\"k\",\"M\",\"G\",\"T\"];B.subplotMatch=/^x([0-9]*)y([0-9]*)$/,B.getSubplots=function(t,e){var r,n,i,a=[],o=t._fullData||t.data||[];for(r=0;r<o.length;r++){var s=o[r];if(!1!==s.visible&&\"legendonly\"!==s.visible&&(k.traceIs(s,\"cartesian\")||k.traceIs(s,\"gl2d\"))){i=(s.xaxis||\"x\")+(s.yaxis||\"y\"),-1===a.indexOf(i)&&a.push(i)}}var l=B.list(t,\"\",!0);for(r=0;r<l.length;r++){var u=l[r],c=u._id.charAt(0),h=\"free\"===u.anchor?\"x\"===c?\"y\":\"x\":u.anchor,f=B.getFromId(t,h),d=!1;for(n=0;n<a.length;n++)if(function(t,e){return-1!==t.indexOf(e._id)}(a[n],u)){d=!0;break}\"free\"===u.anchor&&d||f&&(i=\"x\"===c?u._id+f._id:f._id+u._id,-1===a.indexOf(i)&&a.push(i))}var p=B.subplotMatch,m=[];for(r=0;r<a.length;r++)i=a[r],p.test(i)&&m.push(i);return m.sort(function(t,e){var r=t.match(p),n=e.match(p);return r[1]===n[1]?+(r[2]||1)-(n[2]||1):+(r[1]||0)-(n[1]||0)}),e?B.findSubplotsWithAxis(m,e):m},B.findSubplotsWithAxis=function(t,e){for(var r=new RegExp(\"x\"===e._id.charAt(0)?\"^\"+e._id+\"y\":e._id+\"$\"),n=[],i=0;i<t.length;i++){var a=t[i];r.test(a)&&n.push(a)}return n},B.makeClipPaths=function(t){var e,r,n=t._fullLayout,i=n._defs,a={_offset:0,_length:n.width,_id:\"\"},o={_offset:0,_length:n.height,_id:\"\"},s=B.list(t,\"x\",!0),l=B.list(t,\"y\",!0),u=[];for(e=0;e<s.length;e++)for(u.push({x:s[e],y:o}),r=0;r<l.length;r++)0===e&&u.push({x:a,y:l[r]}),u.push({x:s[e],y:l[r]});var c=i.selectAll(\"g.clips\").data([0]);c.enter().append(\"g\").classed(\"clips\",!0);var h=c.selectAll(\".axesclip\").data(u,function(t){return t.x._id+t.y._id});h.enter().append(\"clipPath\").classed(\"axesclip\",!0).attr(\"id\",function(t){return\"clip\"+n._uid+t.x._id+t.y._id}).append(\"rect\"),h.exit().remove(),h.each(function(t){w.select(this).select(\"rect\").attr({x:t.x._offset||0,y:t.y._offset||0,width:t.x._length||1,height:t.y._length||1})})},B.doTicks=function(t,e,r){function n(t){var e=u.l2p(t.x);return e>1&&e<u._length-1}function i(t,e){var r=t.selectAll(\"path.\"+_).data(\"inside\"===u.ticks?q:b,x);e&&u.ticks?(r.enter().append(\"path\").classed(_,1).classed(\"ticks\",1).classed(\"crisp\",1).call(E.stroke,u.tickcolor).style(\"stroke-width\",F+\"px\").attr(\"d\",e),r.attr(\"transform\",d),r.exit().remove()):r.remove()}function a(r,n){function i(t,e){t.each(function(t){var r=y(e),n=w.select(this),i=n.select(\".text-math-group\"),a=d(t)+(M(e)&&0!=+e?\" rotate(\"+e+\",\"+f(t)+\",\"+(p(t)-t.fontSize/2)+\")\":\"\");if(i.empty())n.select(\"text\").attr({transform:a,\"text-anchor\":r});else{var o=L.bBox(i.node()).width*{end:-.5,start:.5}[r];i.attr(\"transform\",a+(o?\"translate(\"+o+\",0)\":\"\"))}})}function a(){return z.length&&Promise.all(z)}function s(){if(i(h,u.tickangle),\"x\"===g&&!M(u.tickangle)&&(\"log\"!==u.type||\"D\"!==String(u.dtick).charAt(0))){var t=[];for(h.each(function(e){var r=w.select(this),n=r.select(\".text-math-group\"),i=u.l2p(e.x);n.empty()&&(n=r.select(\"text\"));var a=L.bBox(n.node());t.push({top:0,bottom:10,height:10,left:i-a.width/2,right:i+a.width/2+2,width:a.width+2})}),v=0;v<t.length-1;v++)if(A.bBoxIntersect(t[v],t[v+1])){C=30;break}if(C){Math.abs((b[b.length-1].x-b[0].x)*u._m)/(b.length-1)<2.5*E&&(C=90),i(h,C)}u._lastangle=C}return o(),e+\" done\"}function l(){function e(t,e){t[0]=Math.min(t[0],e[0]),t[1]=Math.max(t[1],e[1])}var n=r.node().getBoundingClientRect(),i=t.getBoundingClientRect();if(u._boundingBox={width:n.width,height:n.height,left:n.left-i.left,right:n.right-i.left,top:n.top-i.top,bottom:n.bottom-i.top},m){var a=u._counterSpan=[1/0,-1/0];for(v=0;v<m.length;v++){var o=c._plots[m[v]],s=o[\"x\"===g?\"yaxis\":\"xaxis\"];e(a,[s._offset,s._offset+s._length])}\"free\"===u.anchor&&e(a,\"x\"===g?[u._boundingBox.bottom,u._boundingBox.top]:[u._boundingBox.right,u._boundingBox.left])}}var h=r.selectAll(\"g.\"+_).data(b,x);if(!u.showticklabels||!M(n))return h.remove(),void o();var f,p,y,k,S;\"x\"===g?(S=\"bottom\"===U?1:-1,f=function(t){return t.dx+P*S},k=n+(D+I)*S,p=function(t){return t.dy+k+t.fontSize*(\"bottom\"===U?1:-.2)},y=function(t){return M(t)&&0!==t&&180!==t?t*S<0?\"end\":\"start\":\"middle\"}):(S=\"right\"===U?1:-1,p=function(t){return t.dy+t.fontSize*N-P*S},f=function(t){return t.dx+n+(D+I+(90===Math.abs(u.tickangle)?t.fontSize/2:0))*S},y=function(t){return M(t)&&90===Math.abs(t)?\"middle\":\"right\"===U?\"start\":\"end\"});var E=0,C=0,z=[];h.enter().append(\"g\").classed(_,1).append(\"text\").attr(\"text-anchor\",\"middle\").each(function(e){var r=w.select(this),n=t._promises.length;r.call(T.positionText,f(e),p(e)).call(L.font,e.font,e.fontSize,e.fontColor).text(e.text).call(T.convertToTspans,t),n=t._promises[n],n?z.push(t._promises.pop().then(function(){i(r,u.tickangle)})):i(r,u.tickangle)}),h.exit().remove(),h.each(function(t){E=Math.max(E,t.fontSize)}),i(h,u._lastangle||u.tickangle);var O=A.syncOrAsync([a,s,l]);return O&&O.then&&t._promises.push(O),O}function o(){if(!r){var n,i,a,o,s=V.getFromId(t,e),l=w.select(t).selectAll(\"g.\"+e+\"tick\"),u={selection:l,side:s.side},h=e.charAt(0),f=t._fullLayout._size,d=s.titlefont.size;if(l.size()){var p=L.getTranslate(l.node().parentNode);u.offsetLeft=p.x,u.offsetTop=p.y}var m=10+1.5*d+(s.linewidth?s.linewidth-1:0);\"x\"===h?(i=\"free\"===s.anchor?{_offset:f.t+(1-(s.position||0))*f.h,_length:0}:V.getFromId(t,s.anchor),a=s._offset+s._length/2,o=\"top\"===s.side?-m-d*(s.showticklabels?1:0):i._length+m+d*(s.showticklabels?1.5:.5),o+=i._offset,s.rangeslider&&s.rangeslider.visible&&s._boundingBox&&(o+=(c.height-c.margin.b-c.margin.t)*s.rangeslider.thickness+s._boundingBox.height),u.side||(u.side=\"bottom\")):(i=\"free\"===s.anchor?{_offset:f.l+(s.position||0)*f.w,_length:0}:V.getFromId(t,s.anchor),o=s._offset+s._length/2,a=\"right\"===s.side?i._length+m+d*(s.showticklabels?1:.5):-m-d*(s.showticklabels?.5:0),a+=i._offset,n={rotate:\"-90\",offset:0},u.side||(u.side=\"left\")),S.draw(t,e+\"title\",{propContainer:s,propName:s._name+\".title\",dfltName:h.toUpperCase()+\" axis\",avoid:u,transform:n,attributes:{x:a,y:o,\"text-anchor\":\"middle\"}})}}function s(t,e){return!0===t.visible&&t.xaxis+t.yaxis===e&&(!(!k.traceIs(t,\"bar\")||t.orientation!=={x:\"h\",y:\"v\"}[g])||t.fill&&t.fill.charAt(t.fill.length-1)===g)}function l(e,r,i){var a=e.gridlayer,o=e.zerolinelayer,l=e[\"hidegrid\"+g]?[]:q,c=u._gridpath||\"M0,0\"+(\"x\"===g?\"v\":\"h\")+r._length,h=a.selectAll(\"path.\"+C).data(!1===u.showgrid?[]:l,x);if(h.enter().append(\"path\").classed(C,1).classed(\"crisp\",1).attr(\"d\",c).each(function(t){u.zeroline&&(\"linear\"===u.type||\"-\"===u.type)&&Math.abs(t.x)<u.dtick/100&&w.select(this).remove()}),h.attr(\"transform\",d).call(E.stroke,u.gridcolor||\"#ddd\").style(\"stroke-width\",O+\"px\"),h.exit().remove(),o){for(var f=!1,p=0;p<t._fullData.length;p++)if(s(t._fullData[p],i)){f=!0;break}var m=A.simpleMap(u.range,u.r2l),v=m[0]*m[1]<=0&&u.zeroline&&(\"linear\"===u.type||\"-\"===u.type)&&l.length&&(f||n({x:0})||!u.showline),y=o.selectAll(\"path.\"+z).data(v?[{x:0}]:[]);y.enter().append(\"path\").classed(z,1).classed(\"zl\",1).classed(\"crisp\",1).attr(\"d\",c),y.attr(\"transform\",d).call(E.stroke,u.zerolinecolor||E.defaultLine).style(\"stroke-width\",R+\"px\"),y.exit().remove()}}var u,c=t._fullLayout,h=!1;if(\"object\"==typeof e)u=e,e=u._id,h=!0;else if(u=B.getFromId(t,e),\"redraw\"===e&&c._paper.selectAll(\"g.subplot\").each(function(t){var e=c._plots[t],r=e.xaxis,n=e.yaxis;e.xaxislayer.selectAll(\".\"+r._id+\"tick\").remove(),e.yaxislayer.selectAll(\".\"+n._id+\"tick\").remove(),e.gridlayer.selectAll(\"path\").remove(),e.zerolinelayer.selectAll(\"path\").remove()}),!e||\"redraw\"===e)return A.syncOrAsync(B.list(t,\"\",!0).map(function(r){return function(){if(r._id){var n=B.doTicks(t,r._id);return\"redraw\"===e&&(r._r=r.range.slice(),r._rl=A.simpleMap(r._r,r.r2l)),n}}}));u.tickformat||(-1===[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"].indexOf(u.exponentformat)&&(u.exponentformat=\"e\"),-1===[\"all\",\"first\",\"last\",\"none\"].indexOf(u.showexponent)&&(u.showexponent=\"all\")),u.setScale();var f,d,p,m,v,g=e.charAt(0),y=B.counterLetter(e),b=B.calcTicks(u),x=function(t){return[t.text,t.x,u.mirror].join(\"_\")},_=e+\"tick\",C=e+\"grid\",z=e+\"zl\",I=(u.linewidth||1)/2,D=\"outside\"===u.ticks?u.ticklen:0,P=0,O=L.crispRound(t,u.gridwidth,1),R=L.crispRound(t,u.zerolinewidth,O),F=L.crispRound(t,u.tickwidth,1);if(u._counterangle&&\"outside\"===u.ticks){var j=u._counterangle*Math.PI/180;D=u.ticklen*Math.cos(j)+1,P=u.ticklen*Math.sin(j)}if(u.showticklabels&&(\"outside\"===u.ticks||u.showline)&&(D+=.2*u.tickfont.size),\"x\"===g)f=[\"bottom\",\"top\"],d=function(t){return\"translate(\"+u.l2p(t.x)+\",0)\"},p=function(t,e){if(u._counterangle){var r=u._counterangle*Math.PI/180;return\"M0,\"+t+\"l\"+Math.sin(r)*e+\",\"+Math.cos(r)*e}return\"M0,\"+t+\"v\"+e};else{if(\"y\"!==g)return void A.warn(\"Unrecognized doTicks axis:\",e);f=[\"left\",\"right\"],d=function(t){return\"translate(0,\"+u.l2p(t.x)+\")\"},p=function(t,e){if(u._counterangle){var r=u._counterangle*Math.PI/180;return\"M\"+t+\",0l\"+Math.cos(r)*e+\",\"+-Math.sin(r)*e}return\"M\"+t+\",0h\"+e}}var U=u.side||f[0],H=[-1,1,U===f[1]?1:-1];if(\"inside\"!==u.ticks==(\"x\"===g)&&(H=H.map(function(t){return-t})),u.visible){var q=b.filter(n);if(h){if(i(u._axislayer,p(u._pos+I*H[2],H[2]*u.ticklen)),u._counteraxis){l({gridlayer:u._gridlayer,zerolinelayer:u._zerolinelayer},u._counteraxis)}return a(u._axislayer,u._pos)}m=B.getSubplots(t,u);var G=m.map(function(t){var e=c._plots[t];if(c._has(\"cartesian\")){var r=e[g+\"axislayer\"],n=u._linepositions[t]||[],o=e[y+\"axis\"],s=o._id===u.anchor,h=[!1,!1,!1],d=\"\"\n",
       ";if(\"allticks\"===u.mirror?h=[!0,!0,!1]:s&&(\"ticks\"===u.mirror?h=[!0,!0,!1]:h[f.indexOf(U)]=!0),u.mirrors)for(v=0;v<2;v++){var m=u.mirrors[o._id+f[v]];\"ticks\"!==m&&\"labels\"!==m||(h[v]=!0)}return void 0!==n[2]&&(h[2]=!0),h.forEach(function(t,e){var r=n[e],i=H[e];t&&M(r)&&(d+=p(r+I*i,i*u.ticklen))}),i(r,d),l(e,o,t),a(r,n[3])}}).filter(function(t){return t&&t.then});return G.length?Promise.all(G):0}},B.swap=function(t,e){for(var r=y(t,e),n=0;n<r.length;n++)x(t,r[n].x,r[n].y)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/titles\":692,\"../../constants/alignment\":699,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../registry\":844,\"./axis_autotype\":767,\"./axis_ids\":769,\"./layout_attributes\":777,\"./layout_defaults\":778,\"./set_convert\":783,d3:121,\"fast-isnumeric\":130}],767:[function(t,e,r){\"use strict\";function n(t){if(!t)return!1;for(var e=0;e<t.length;e++)if(o(t[e]))return!0;return!1}function i(t,e){for(var r,n=0,i=0,a=Math.max(1,(t.length-1)/1e3),l=0;l<t.length;l+=a)r=t[Math.round(l)],s.isDateTime(r,e)&&(n+=1),o(r)&&(i+=1);return n>2*i}function a(t){for(var e,r=Math.max(1,(t.length-1)/1e3),n=0,i=0,a=0;a<t.length;a+=r)e=t[Math.round(a)],s.cleanNumber(e)!==l?n++:\"string\"==typeof e&&\"\"!==e&&\"None\"!==e&&i++;return i>2*n}var o=t(\"fast-isnumeric\"),s=t(\"../../lib\"),l=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e){return i(t,e)?\"date\":a(t)?\"category\":n(t)?\"linear\":\"-\"}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],768:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../../components/color/attributes\").lightFraction,s=t(\"./layout_attributes\"),l=t(\"./tick_value_defaults\"),u=t(\"./tick_mark_defaults\"),c=t(\"./tick_label_defaults\"),h=t(\"./category_order_defaults\"),f=t(\"./set_convert\"),d=t(\"./ordered_categories\");e.exports=function(t,e,r,p,m){function v(r,n){return a.coerce2(t,e,s,r,n)}var g=p.letter,y=p.font||{},b=\"Click to enter \"+(p.title||g.toUpperCase()+\" axis\")+\" title\",x=r(\"visible\",!p.cheateronly),_=e.type;if(\"date\"===_){i.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\",p.calendar)}if(f(e,m),r(\"autorange\",!e.isValidRange(t.range))&&r(\"rangemode\"),r(\"range\"),e.cleanRange(),h(t,e,r),e._initialCategories=\"category\"===_?d(g,e.categoryorder,e.categoryarray,p.data):[],!x)return e;var w=r(\"color\"),M=w===t.color?w:y.color;r(\"title\",b),a.coerceFont(r,\"titlefont\",{family:y.family,size:Math.round(1.2*y.size),color:M}),l(t,e,r,_),c(t,e,r,_,p),u(t,e,r,p);var k=v(\"linecolor\",w),A=v(\"linewidth\"),T=r(\"showline\",!!k||!!A);T||(delete e.linecolor,delete e.linewidth),(T||e.ticks)&&r(\"mirror\");var S=v(\"gridcolor\",n(w,p.bgColor,o).toRgbString()),E=v(\"gridwidth\");r(\"showgrid\",p.showGrid||!!S||!!E)||(delete e.gridcolor,delete e.gridwidth);var L=v(\"zerolinecolor\",w),C=v(\"zerolinewidth\");return r(\"zeroline\",p.showGrid||!!L||!!C)||(delete e.zerolinecolor,delete e.zerolinewidth),e}},{\"../../components/color/attributes\":602,\"../../lib\":725,\"../../registry\":844,\"./category_order_defaults\":770,\"./layout_attributes\":777,\"./ordered_categories\":779,\"./set_convert\":783,\"./tick_label_defaults\":784,\"./tick_mark_defaults\":785,\"./tick_value_defaults\":786,tinycolor2:533}],769:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,r){for(var n=Object.keys(t),i=/^[xyz]axis[0-9]*/,a=[],o=0;o<n.length;o++){var s=n[o];e&&s.charAt(0)!==e||i.test(s)&&a.push(r+s)}return a.sort()}var i=t._fullLayout;if(!i)return[];var o=n(i,\"\");if(r)return o;for(var s=a.getSubplotIds(i,\"gl3d\")||[],l=0;l<s.length;l++){var u=s[l];o=o.concat(n(i[u],u+\".\"))}return o}var i=t(\"../../registry\"),a=t(\"../plots\"),o=t(\"../../lib\"),s=t(\"./constants\");r.id2name=function(t){if(\"string\"==typeof t&&t.match(s.AX_ID_PATTERN)){var e=t.substr(1);return\"1\"===e&&(e=\"\"),t.charAt(0)+\"axis\"+e}},r.name2id=function(t){if(t.match(s.AX_NAME_PATTERN)){var e=t.substr(5);return\"1\"===e&&(e=\"\"),t.charAt(0)+e}},r.cleanId=function(t,e){if(t.match(s.AX_ID_PATTERN)&&(!e||t.charAt(0)===e)){var r=t.substr(1).replace(/^0+/,\"\");return\"1\"===r&&(r=\"\"),t.charAt(0)+r}},r.list=function(t,e,r){return n(t,e,r).map(function(e){return o.nestedProperty(t._fullLayout,e).get()})},r.listIds=function(t,e){return n(t,e,!0).map(r.name2id)},r.getFromId=function(t,e,n){var i=t._fullLayout;return\"x\"===n?e=e.replace(/y[0-9]*/,\"\"):\"y\"===n&&(e=e.replace(/x[0-9]*/,\"\")),i[r.id2name(e)]},r.getFromTrace=function(t,e,n){var a=t._fullLayout,o=null;if(i.traceIs(e,\"gl3d\")){var s=e.scene;\"scene\"===s.substr(0,5)&&(o=a[s][n+\"axis\"])}else o=r.getFromId(t,e[n+\"axis\"]||n);return o}},{\"../../lib\":725,\"../../registry\":844,\"../plots\":829,\"./constants\":771}],770:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){if(\"category\"===e.type){var n,i=t.categoryarray,a=Array.isArray(i)&&i.length>0;a&&(n=\"array\");var o=r(\"categoryorder\",n);\"array\"===o&&r(\"categoryarray\"),a||\"array\"!==o||(e.categoryorder=\"trace\")}}},{}],771:[function(t,e,r){\"use strict\";e.exports={idRegex:{x:/^x([2-9]|[1-9][0-9]+)?$/,y:/^y([2-9]|[1-9][0-9]+)?$/},attrRegex:{x:/^xaxis([2-9]|[1-9][0-9]+)?$/,y:/^yaxis([2-9]|[1-9][0-9]+)?$/},xAxisMatch:/^xaxis[0-9]*$/,yAxisMatch:/^yaxis[0-9]*$/,AX_ID_PATTERN:/^[xyz][0-9]*$/,AX_NAME_PATTERN:/^[xyz]axis[0-9]*$/,MINDRAG:8,MINSELECT:12,MINZOOM:20,DRAGGERSIZE:20,BENDPX:1.5,REDRAWDELAY:50,DFLTRANGEX:[-1,6],DFLTRANGEY:[-1,4],traceLayerClasses:[\"imagelayer\",\"maplayer\",\"barlayer\",\"carpetlayer\",\"boxlayer\",\"scatterlayer\"],layerValue2layerClass:{\"above traces\":\"above\",\"below traces\":\"below\"}}},{}],772:[function(t,e,r){\"use strict\";function n(t,e,r,n){var i,a,s,l,u=n[o(e)].type,c=[];for(a=0;a<r.length;a++)(s=r[a])!==e&&(l=n[o(s)],l.type!==u||l.fixedrange||c.push(s));for(i=0;i<t.length;i++)if(t[i][e]){var h=t[i],f=[];for(a=0;a<c.length;a++)s=c[a],h[s]||f.push(s);return{linkableAxes:f,thisGroup:h}}return{linkableAxes:c,thisGroup:null}}function i(t,e,r,n,i){var a,o,s,l,u;null===e?(e={},e[r]=1,u=t.length,t.push(e)):u=t.indexOf(e);var c=Object.keys(e);for(a=0;a<t.length;a++)if(s=t[a],a!==u&&s[n]){var h=s[n];for(o=0;o<c.length;o++)l=c[o],s[l]=h*i*e[l];return void t.splice(u,1)}if(1!==i)for(o=0;o<c.length;o++)e[c[o]]*=i;e[n]=1}var a=t(\"../../lib\"),o=t(\"./axis_ids\").id2name;e.exports=function(t,e,r,o,s){var l=s._axisConstraintGroups,u=e._id,c=u.charAt(0);if(!e.fixedrange&&(r(\"constrain\"),a.coerce(t,e,{constraintoward:{valType:\"enumerated\",values:\"x\"===c?[\"left\",\"center\",\"right\"]:[\"bottom\",\"middle\",\"top\"],dflt:\"x\"===c?\"center\":\"middle\"}},\"constraintoward\"),t.scaleanchor)){var h=n(l,u,o,s),f=a.coerce(t,e,{scaleanchor:{valType:\"enumerated\",values:h.linkableAxes}},\"scaleanchor\");if(f){var d=r(\"scaleratio\");d||(d=e.scaleratio=1),i(l,h.thisGroup,u,f,d)}else-1!==o.indexOf(t.scaleanchor)&&a.warn(\"ignored \"+e._name+'.scaleanchor: \"'+t.scaleanchor+'\" to avoid either an infinite loop and possibly inconsistent scaleratios, or because the targetaxis has fixed range.')}}},{\"../../lib\":725,\"./axis_ids\":769}],773:[function(t,e,r){\"use strict\";function n(t,e){var r=t._inputDomain,n=s[t.constraintoward],i=r[0]+(r[1]-r[0])*n;t.domain=t._input.domain=[i+(r[0]-i)/e,i+(r[1]-i)/e]}var i=t(\"./axis_ids\").id2name,a=t(\"./scale_zoom\"),o=t(\"../../constants/numerical\").ALMOST_EQUAL,s=t(\"../../constants/alignment\").FROM_BL;r.enforce=function(t){var e,r,s,l,u,c,h,f=t._fullLayout,d=f._axisConstraintGroups;for(e=0;e<d.length;e++){var p=d[e],m=Object.keys(p),v=1/0,g=0,y=1/0,b={},x={},_=!1;for(r=0;r<m.length;r++)s=m[r],x[s]=l=f[i(s)],l._inputDomain?l.domain=l._inputDomain.slice():l._inputDomain=l.domain.slice(),l._inputRange||(l._inputRange=l.range.slice()),l.setScale(),b[s]=u=Math.abs(l._m)/p[s],v=Math.min(v,u),\"domain\"!==l.constrain&&l._constraintShrinkable||(y=Math.min(y,u)),delete l._constraintShrinkable,g=Math.max(g,u),\"domain\"===l.constrain&&(_=!0);if(!(v>o*g)||_)for(r=0;r<m.length;r++)if(s=m[r],u=b[s],l=x[s],c=l.constrain,u!==y||\"domain\"===c)if(h=u/y,\"range\"===c)a(l,h);else{var w=l._inputDomain,M=(l.domain[1]-l.domain[0])/(w[1]-w[0]),k=(l.r2l(l.range[1])-l.r2l(l.range[0]))/(l.r2l(l._inputRange[1])-l.r2l(l._inputRange[0]));if((h/=M)*k<1){l.domain=l._input.domain=w.slice(),a(l,h);continue}if(k<1&&(l.range=l._input.range=l._inputRange.slice(),h*=k),l.autorange&&l._min.length&&l._max.length){var A=l.r2l(l.range[0]),T=l.r2l(l.range[1]),S=(A+T)/2,E=S,L=S,C=Math.abs(T-S),z=S-C*h*1.0001,I=S+C*h*1.0001;n(l,h),l.setScale();var D,P,O=Math.abs(l._m);for(P=0;P<l._min.length;P++)(D=l._min[P].val-l._min[P].pad/O)>z&&D<E&&(E=D);for(P=0;P<l._max.length;P++)(D=l._max[P].val+l._max[P].pad/O)<I&&D>L&&(L=D);var R=(L-E)/(2*C);h/=R,E=l.l2r(E),L=l.l2r(L),l.range=l._input.range=A<T?[E,L]:[L,E]}n(l,h)}}},r.clean=function(t,e){if(e._inputDomain){for(var r=!1,n=e._id,i=t._fullLayout._axisConstraintGroups,a=0;a<i.length;a++)if(i[a][n]){r=!0;break}r&&\"domain\"===e.constrain||(e._input.domain=e.domain=e._inputDomain,delete e._inputDomain)}}},{\"../../constants/alignment\":699,\"../../constants/numerical\":705,\"./axis_ids\":769,\"./scale_zoom\":781}],774:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){var s=t.draglayer.selectAll(\".\"+e).data([0]);return s.enter().append(\"rect\").classed(\"drag\",!0).classed(e,!0).style({fill:\"transparent\",\"stroke-width\":0}).attr(\"data-subplot\",t.id),s.call(S.setRect,n,i,a,o).call(E,r),s.node()}function i(t,e){for(var r=0;r<t.length;r++)if(!t[r].fixedrange)return e;return\"\"}function a(t,e){var r,n=t.range[e],i=Math.abs(n-t.range[1-e]);return\"date\"===t.type?n:\"log\"===t.type?(r=Math.ceil(Math.max(0,-Math.log(i)/Math.LN10))+3,x.format(\".\"+r+\"g\")(Math.pow(10,n))):(r=Math.floor(Math.log(Math.abs(n))/Math.LN10)-Math.floor(Math.log(i)/Math.LN10)+4,x.format(\".\"+String(r)+\"g\")(n))}function o(t,e,r,n,i){var a,s,l,u;for(a=0;a<t.length;a++)s=t[a],s.fixedrange||(l=s._rl[0],u=s._rl[1]-l,s.range=[s.l2r(l+u*e),s.l2r(l+u*r)],n[s._name+\".range[0]\"]=s.range[0],n[s._name+\".range[1]\"]=s.range[1]);if(i&&i.length){var c=(e+(1-r))/2;o(i,c,1-c,n)}}function s(t,e){for(var r=0;r<t.length;r++){var n=t[r];n.fixedrange||(n.range=[n.l2r(n._rl[0]-e/n._m),n.l2r(n._rl[1]-e/n._m)])}}function l(t){return 1-(t>=0?Math.min(t,.9):1/(1/Math.max(t,-.3)+3.222))}function u(t,e){return t?\"nsew\"===t?\"pan\"===e?\"move\":\"crosshair\":t.toLowerCase()+\"-resize\":\"pointer\"}function c(t,e,r,n,i){return t.append(\"path\").attr(\"class\",\"zoombox\").style({fill:e>.2?\"rgba(0,0,0,0)\":\"rgba(255,255,255,0)\",\"stroke-width\":0}).attr(\"transform\",\"translate(\"+r+\", \"+n+\")\").attr(\"d\",i+\"Z\")}function h(t,e,r){return t.append(\"path\").attr(\"class\",\"zoombox-corners\").style({fill:T.background,stroke:T.defaultLine,\"stroke-width\":1,opacity:0}).attr(\"transform\",\"translate(\"+e+\", \"+r+\")\").attr(\"d\",\"M0,0Z\")}function f(t){t.selectAll(\".select-outline\").remove()}function d(t,e,r,n,i,a){t.attr(\"d\",n+\"M\"+r.l+\",\"+r.t+\"v\"+r.h+\"h\"+r.w+\"v-\"+r.h+\"h-\"+r.w+\"Z\"),i||(t.transition().style(\"fill\",a>.2?\"rgba(0,0,0,0.4)\":\"rgba(255,255,255,0.3)\").duration(200),e.transition().style(\"opacity\",1).duration(200))}function p(t){x.select(t).selectAll(\".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners\").remove()}function m(t){return-1!==[\"lasso\",\"select\"].indexOf(t)}function v(t,e){return\"M\"+(t.l-.5)+\",\"+(e-j-.5)+\"h-3v\"+(2*j+1)+\"h3ZM\"+(t.r+.5)+\",\"+(e-j-.5)+\"h3v\"+(2*j+1)+\"h-3Z\"}function g(t,e){return\"M\"+(e-j-.5)+\",\"+(t.t-.5)+\"v-3h\"+(2*j+1)+\"v3ZM\"+(e-j-.5)+\",\"+(t.b+.5)+\"v3h\"+(2*j+1)+\"v-3Z\"}function y(t){var e=Math.floor(Math.min(t.b-t.t,t.r-t.l,j)/2);return\"M\"+(t.l-3.5)+\",\"+(t.t-.5+e)+\"h3v\"+-e+\"h\"+e+\"v-3h-\"+(e+3)+\"ZM\"+(t.r+3.5)+\",\"+(t.t-.5+e)+\"h-3v\"+-e+\"h\"+-e+\"v-3h\"+(e+3)+\"ZM\"+(t.r+3.5)+\",\"+(t.b+.5-e)+\"h-3v\"+e+\"h\"+-e+\"v3h\"+(e+3)+\"ZM\"+(t.l-3.5)+\",\"+(t.b+.5-e)+\"h3v\"+e+\"h\"+e+\"v3h-\"+(e+3)+\"Z\"}function b(t,e,r){var n,i,a,o,s,l,u=!1,c={},h={};for(n=0;n<t.length;n++){for(o=t[n],i=0;i<e.length;i++)if(o[e[i]]){for(s in o)-1===(\"x\"===s.charAt(0)?e:r).indexOf(s)&&(c[s]=1);for(a=0;a<r.length;a++)o[r[a]]&&(u=!0)}for(i=0;i<r.length;i++)if(o[r[i]])for(l in o)-1===(\"x\"===l.charAt(0)?e:r).indexOf(l)&&(h[l]=1)}return u&&(k.extendFlat(c,h),h={}),{x:c,y:h,xy:u}}var x=t(\"d3\"),_=t(\"tinycolor2\"),w=t(\"../../plotly\"),M=t(\"../../registry\"),k=t(\"../../lib\"),A=t(\"../../lib/svg_text_utils\"),T=t(\"../../components/color\"),S=t(\"../../components/drawing\"),E=t(\"../../lib/setcursor\"),L=t(\"../../components/dragelement\"),C=t(\"../../constants/alignment\").FROM_TL,z=t(\"../plots\"),I=t(\"./axes\").doTicks,D=t(\"./axis_ids\").getFromId,P=t(\"./select\"),O=t(\"./scale_zoom\"),R=t(\"./constants\"),F=R.MINDRAG,j=R.MINZOOM,N=!0;e.exports=function(t,e,r,T,E,B,U,V){function H(){et=[e.xaxis],rt=[e.yaxis];var r=et[0],n=rt[0];at=r._length,ot=n._length;var a=dt._axisConstraintGroups,o=[r._id],s=[n._id];tt=[e].concat(U&&V?e.overlays:[]);for(var l=1;l<tt.length;l++){var c=tt[l].xaxis,h=tt[l].yaxis;-1===et.indexOf(c)&&(et.push(c),o.push(c._id)),-1===rt.indexOf(h)&&(rt.push(h),s.push(h._id))}st=i(et,V),lt=i(rt,U),ut=u(lt+st,dt.dragmode),nt=r._offset,it=n._offset;var f=b(a,o,s);ct=f.xy,ht=[];for(var d in f.x)ht.push(D(t,d));ft=[];for(var p in f.y)ft.push(D(t,p))}function q(e,r,n){var i=vt.getBoundingClientRect();yt=r-i.left,bt=n-i.top,xt={l:yt,r:yt,w:0,t:bt,b:bt,h:0},_t=t._hmpixcount?t._hmlumcount/t._hmpixcount:_(t._fullLayout.plot_bgcolor).getLuminance(),wt=\"M0,0H\"+at+\"V\"+ot+\"H0V0\",Mt=!1,kt=\"xy\",At=c(pt,_t,nt,it,wt),Tt=h(pt,nt,it),f(pt)}function G(e,r){function n(){kt=\"\",xt.r=xt.l,xt.t=xt.b,Tt.attr(\"d\",\"M0,0Z\")}if(t._transitioningWithDuration)return!1;var i=Math.max(0,Math.min(at,e+yt)),a=Math.max(0,Math.min(ot,r+bt)),o=Math.abs(i-yt),s=Math.abs(a-bt);xt.l=Math.min(yt,i),xt.r=Math.max(yt,i),xt.t=Math.min(bt,a),xt.b=Math.max(bt,a),ct?o>j||s>j?(kt=\"xy\",o/at>s/ot?(s=o*ot/at,bt>a?xt.t=bt-s:xt.b=bt+s):(o=s*at/ot,yt>i?xt.l=yt-o:xt.r=yt+o),Tt.attr(\"d\",y(xt))):n():!lt||s<Math.min(Math.max(.6*o,F),j)?o<F?n():(xt.t=0,xt.b=ot,kt=\"x\",Tt.attr(\"d\",v(xt,bt))):!st||o<Math.min(.6*s,j)?(xt.l=0,xt.r=at,kt=\"y\",Tt.attr(\"d\",g(xt,yt))):(kt=\"xy\",Tt.attr(\"d\",y(xt))),xt.w=xt.r-xt.l,xt.h=xt.b-xt.t,d(At,Tt,xt,wt,Mt,_t),Mt=!0}function Y(e,r){if(Math.min(xt.h,xt.w)<2*F)return 2===r&&K(),p(t);\"xy\"!==kt&&\"x\"!==kt||o(et,xt.l/at,xt.r/at,St,ht),\"xy\"!==kt&&\"y\"!==kt||o(rt,(ot-xt.b)/ot,(ot-xt.t)/ot,St,ft),p(t),Q(kt),N&&t.data&&t._context.showTips&&(k.notifier(\"Double-click to<br>zoom back out\",\"long\"),N=!1)}function X(e,r){var n=1===(U+V).length;if(e)Q();else if(2!==r||n){if(1===r&&n){var i=U?rt[0]:et[0],o=\"s\"===U||\"w\"===V?0:1,s=i._name+\".range[\"+o+\"]\",l=a(i,o),u=\"left\",c=\"middle\";if(i.fixedrange)return;U?(c=\"n\"===U?\"top\":\"bottom\",\"right\"===i.side&&(u=\"right\")):\"e\"===V&&(u=\"right\"),t._context.showAxisRangeEntryBoxes&&x.select(vt).call(A.makeEditable,{gd:t,immediate:!0,background:dt.paper_bgcolor,text:String(l),fill:i.tickfont?i.tickfont.color:\"#444\",horizontalAlign:u,verticalAlign:c}).on(\"edit\",function(e){var r=i.d2r(e);void 0!==r&&w.relayout(t,s,r)})}}else K()}function W(e){function r(t,e,r){function n(e){return t.l2r(a+(e-a)*r)}if(!t.fixedrange){var i=k.simpleMap(t.range,t.r2l),a=i[0]+(i[1]-i[0])*e;t.range=i.map(n)}}if(t._context.scrollZoom||dt._enablescrollzoom){if(t._transitioningWithDuration)return k.pauseEvent(e);var n=t.querySelector(\".plotly\");if(H(),!(n.scrollHeight-n.clientHeight>10||n.scrollWidth-n.clientWidth>10)){clearTimeout(Lt);var i=-e.deltaY;if(isFinite(i)||(i=e.wheelDelta/10),!isFinite(i))return void k.log(\"Did not find wheel motion attributes: \",e);var a,o=Math.exp(-Math.min(Math.max(i,-20),20)/100),s=zt.draglayer.select(\".nsewdrag\").node().getBoundingClientRect(),l=(e.clientX-s.left)/s.width,u=(s.bottom-e.clientY)/s.height;if(V||ct){for(V||(l=.5),a=0;a<et.length;a++)r(et[a],l,o);Et[2]*=o,Et[0]+=Et[2]*l*(1/o-1)}if(U||ct){for(U||(u=.5),a=0;a<rt.length;a++)r(rt[a],u,o);Et[3]*=o,Et[1]+=Et[3]*(1-u)*(1/o-1)}return $(Et),J(U,V),Lt=setTimeout(function(){Et=[0,0,at,ot];var t;t=ct?\"xy\":(V?\"x\":\"\")+(U?\"y\":\"\"),Q(t)},Ct),k.pauseEvent(e)}}}function Z(e,r){function n(t,e,r){for(var n,i,a=1-e,o=0;o<t.length;o++){var s=t[o];if(!s.fixedrange){n=s,i=s._rl[a]+(s._rl[e]-s._rl[a])/l(r/s._length);var u=s.l2r(i);!1!==u&&void 0!==u&&(s.range[e]=u)}}return n._length*(n._rl[e]-i)/(n._rl[e]-n._rl[a])}if(!t._transitioningWithDuration){if(H(),\"ew\"===st||\"ns\"===lt)return st&&s(et,e),lt&&s(rt,r),$([st?-e:0,lt?-r:0,at,ot]),void J(lt,st);if(ct&&st&&lt){var i=\"w\"===st==(\"n\"===lt)?1:-1,a=(e/at+i*r/ot)/2;e=a*at,r=i*a*ot}\"w\"===st?e=n(et,0,e):\"e\"===st?e=n(et,1,-e):st||(e=0),\"n\"===lt?r=n(rt,1,r):\"s\"===lt?r=n(rt,0,-r):lt||(r=0);var o=\"w\"===st?e:0,u=\"n\"===lt?r:0;if(ct){var c;if(!st&&1===lt.length){for(c=0;c<et.length;c++)et[c].range=et[c]._r.slice(),O(et[c],1-r/ot);e=r*at/ot,o=e/2}if(!lt&&1===st.length){for(c=0;c<rt.length;c++)rt[c].range=rt[c]._r.slice(),O(rt[c],1-e/at);r=e*ot/at,u=r/2}}$([o,u,at-e,ot-r]),J(lt,st)}}function J(e,r){function n(t){for(a=0;a<t.length;a++)t[a].fixedrange||o.push(t[a]._id)}function i(n,i,s){for(a=0;a<n.length;a++){var l=n[a];if((r&&-1!==o.indexOf(l.xref)||e&&-1!==o.indexOf(l.yref))&&(i(t,a),s))return}}var a,o=[];for((r||ct)&&(n(et),n(ht)),(e||ct)&&(n(rt),n(ft)),St={},a=0;a<o.length;a++){var s=o[a];I(t,s,!0);var l=D(t,s);St[l._name+\".range[0]\"]=l.range[0],St[l._name+\".range[1]\"]=l.range[1]}i(dt.annotations||[],M.getComponentMethod(\"annotations\",\"drawOne\")),i(dt.shapes||[],M.getComponentMethod(\"shapes\",\"drawOne\")),i(dt.images||[],M.getComponentMethod(\"images\",\"draw\"),!0)}function K(){if(!t._transitioningWithDuration){var e,r,n,i=t._context.doubleClick,a=(st?et:[]).concat(lt?rt:[]),o={};if(\"reset+autosize\"===i)for(i=\"autosize\",r=0;r<a.length;r++)if(e=a[r],e._rangeInitial&&(e.range[0]!==e._rangeInitial[0]||e.range[1]!==e._rangeInitial[1])||!e._rangeInitial&&!e.autorange){i=\"reset\";break}if(\"autosize\"===i)for(r=0;r<a.length;r++)e=a[r],e.fixedrange||(o[e._name+\".autorange\"]=!0);else if(\"reset\"===i)for((st||ct)&&(a=a.concat(ht)),lt&&!ct&&(a=a.concat(ft)),ct&&(st?lt||(a=a.concat(rt)):a=a.concat(et)),r=0;r<a.length;r++)e=a[r],e._rangeInitial?(n=e._rangeInitial,o[e._name+\".range[0]\"]=n[0],o[e._name+\".range[1]\"]=n[1]):o[e._name+\".autorange\"]=!0;t.emit(\"plotly_doubleclick\",null),w.relayout(t,o)}}function Q(e){void 0===e&&(e=(V?\"x\":\"\")+(U?\"y\":\"\")),$([0,0,at,ot]),k.syncOrAsync([z.previousPromises,function(){w.relayout(t,St)}],t)}function $(t){function e(t){return t.fixedrange?0:d&&-1!==ht.indexOf(t)?h:p&&-1!==(ct?ht:ft).indexOf(t)?f:0}function r(t,e){return e?(t.range=t._r.slice(),O(t,e),n(t,e)):0}function n(t,e){return t._length*(1-e)*C[t.constraintoward||\"middle\"]}var i,a,o,s,l,u=dt._plots,c=Object.keys(u),h=t[2]/et[0]._length,f=t[3]/rt[0]._length,d=V||ct,p=U||ct;for(i=0;i<c.length;i++){var m=u[c[i]],v=m.xaxis,g=m.yaxis,y=d&&!v.fixedrange&&-1!==et.indexOf(v),b=p&&!g.fixedrange&&-1!==rt.indexOf(g);if(y?(a=h,s=V?t[0]:n(v,a)):(a=e(v),s=r(v,a)),b?(o=f,l=U?t[1]:n(g,o)):(o=e(g),l=r(g,o)),a||o){a||(a=1),o||(o=1);var x=v._offset-s/a,_=g._offset-l/o;dt._defs.select(\"#\"+m.clipId+\"> rect\").call(S.setTranslate,s,l).call(S.setScale,a,o);var w=m.plot.selectAll(\".scatterlayer .points, .boxlayer .points\");m.plot.call(S.setTranslate,x,_).call(S.setScale,1/a,1/o),w.selectAll(\".point\").call(S.setPointGroupScale,a,o).call(S.hideOutsideRangePoints,m),w.selectAll(\".textpoint\").call(S.setTextPointsScale,a,o).call(S.hideOutsideRangePoints,m)}}}var tt,et,rt,nt,it,at,ot,st,lt,ut,ct,ht,ft,dt=t._fullLayout,pt=t._fullLayout._zoomlayer,mt=U+V===\"nsew\";H();var vt=n(e,U+V+\"drag\",ut,r,T,E,B);if(!lt&&!st&&!m(dt.dragmode))return vt.onmousedown=null,vt.style.pointerEvents=mt?\"all\":\"none\",vt;var gt={element:vt,gd:t,plotinfo:e,prepFn:function(e,r,n){var i=t._fullLayout.dragmode;mt?e.shiftKey&&(i=\"pan\"===i?\"zoom\":\"pan\"):i=\"pan\",gt.minDrag=\"lasso\"===i?1:void 0,\"zoom\"===i?(gt.moveFn=G,gt.doneFn=Y,gt.minDrag=1,q(e,r,n)):\"pan\"===i?(gt.moveFn=Z,gt.doneFn=X,f(pt)):m(i)&&(gt.xaxes=et,gt.yaxes=rt,P(e,r,n,gt,i))}};L.init(gt);var yt,bt,xt,_t,wt,Mt,kt,At,Tt,St={},Et=[0,0,at,ot],Lt=null,Ct=R.REDRAWDELAY,zt=e.mainplot?dt._plots[e.mainplot]:e;return U.length*V.length!=1&&(void 0!==vt.onwheel?vt.onwheel=W:void 0!==vt.onmousewheel&&(vt.onmousewheel=W)),vt}},{\"../../components/color\":603,\"../../components/dragelement\":624,\"../../components/drawing\":627,\"../../constants/alignment\":699,\"../../lib\":725,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../registry\":844,\"../plots\":829,\"./axes\":766,\"./axis_ids\":769,\"./constants\":771,\"./scale_zoom\":781,\"./select\":782,d3:121,tinycolor2:533}],775:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../components/fx\"),a=t(\"../../components/dragelement\"),o=t(\"./constants\"),s=t(\"./dragbox\");e.exports=function(t){var e=t._fullLayout;if((e._has(\"cartesian\")||e._has(\"gl2d\"))&&!t._context.staticPlot){Object.keys(e._plots||{}).sort(function(t,r){if((e._plots[t].mainplot&&!0)===(e._plots[r].mainplot&&!0)){var n=t.split(\"y\"),i=r.split(\"y\");return n[0]===i[0]?Number(n[1]||1)-Number(i[1]||1):Number(n[0]||1)-Number(i[0]||1)}return e._plots[t].mainplot?1:-1}).forEach(function(r){var l=e._plots[r],u=l.xaxis,c=l.yaxis,h=(u._linepositions[r]||[])[3],f=(c._linepositions[r]||[])[3],d=o.DRAGGERSIZE;if(n(h)&&\"top\"===u.side&&(h-=d),n(f)&&\"right\"!==c.side&&(f-=d),!l.mainplot){var p=s(t,l,0,0,u._length,c._length,\"ns\",\"ew\");p.onmousemove=function(e){t._fullLayout._rehover=function(){t._fullLayout._hoversubplot===r&&i.hover(t,e,r)},i.hover(t,e,r),t._fullLayout._lasthover=p,t._fullLayout._hoversubplot=r},p.onmouseout=function(e){t._dragging||(t._fullLayout._hoversubplot=null,a.unhover(t,e))},p.onclick=function(e){i.click(t,e,r)},t._context.showAxisDragHandles&&(s(t,l,-d,-d,d,d,\"n\",\"w\"),s(t,l,u._length,-d,d,d,\"n\",\"e\"),s(t,l,-d,c._length,d,d,\"s\",\"w\"),s(t,l,u._length,c._length,d,d,\"s\",\"e\"))}t._context.showAxisDragHandles&&(n(h)&&(\"free\"===u.anchor&&(h-=e._size.h*(1-c.domain[1])),s(t,l,.1*u._length,h,.8*u._length,d,\"\",\"ew\"),s(t,l,0,h,.1*u._length,d,\"\",\"w\"),s(t,l,.9*u._length,h,.1*u._length,d,\"\",\"e\")),n(f)&&(\"free\"===c.anchor&&(f-=e._size.w*u.domain[0]),s(t,l,f,.1*c._length,d,.8*c._length,\"ns\",\"\"),s(t,l,f,.9*c._length,d,.1*c._length,\"s\",\"\"),s(t,l,f,0,d,.1*c._length,\"n\",\"\")))});var r=e._hoverlayer.node();r.onmousemove=function(r){r.target=e._lasthover,i.hover(t,r,e._hoversubplot)},r.onclick=function(r){r.target=e._lasthover,i.click(t,r)},r.onmousedown=function(t){e._lasthover.onmousedown(t)}}}},{\"../../components/dragelement\":624,\"../../components/fx\":644,\"./constants\":771,\"./dragbox\":774,\"fast-isnumeric\":130}],776:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=t._fullLayout,o=a._modules;e.plot&&e.plot.selectAll(\"g:not(.scatterlayer)\").selectAll(\"g.trace\").remove();for(var s=0;s<o.length;s++){var l=o[s];if(\"cartesian\"===l.basePlotModule.name){for(var u=[],c=0;c<r.length;c++){var h=r[c],f=h[0].trace;f._module===l&&!0===f.visible&&u.push(h)}l.plot(t,e,u,n,i)}}}function i(t){for(var e=t._fullLayout,r=Object.keys(e._plots),n=[],i=[],a=0;a<r.length;a++){var o=r[a],s=e._plots[o],l=s.xaxis,u=s.yaxis,c=l._mainAxis,h=u._mainAxis,f=c._id+h._id;f!==o&&-1!==r.indexOf(f)?(s.mainplot=f,s.mainplotinfo=e._plots[f],i.push(o)):n.push(o)}return n=n.concat(i)}function a(t){var e=t.plotgroup,r=t.id,n=f.layerValue2layerClass[t.xaxis.layer],i=f.layerValue2layerClass[t.yaxis.layer];if(t.mainplot){var a=t.mainplotinfo,o=a.plotgroup,l=r+\"-x\",u=r+\"-y\";t.gridlayer=s(a.overgrid,\"g\",r),t.zerolinelayer=s(a.overzero,\"g\",r),s(a.overlinesBelow,\"path\",l),s(a.overlinesBelow,\"path\",u),s(a.overaxesBelow,\"g\",l),s(a.overaxesBelow,\"g\",u),t.plot=s(a.overplot,\"g\",r),s(a.overlinesAbove,\"path\",l),s(a.overlinesAbove,\"path\",u),s(a.overaxesAbove,\"g\",l),s(a.overaxesAbove,\"g\",u),t.xlines=o.select(\".overlines-\"+n).select(\".\"+l),t.ylines=o.select(\".overlines-\"+i).select(\".\"+u),t.xaxislayer=o.select(\".overaxes-\"+n).select(\".\"+l),t.yaxislayer=o.select(\".overaxes-\"+i).select(\".\"+u)}else{var c=s(e,\"g\",\"layer-subplot\");t.shapelayer=s(c,\"g\",\"shapelayer\"),t.imagelayer=s(c,\"g\",\"imagelayer\"),t.gridlayer=s(e,\"g\",\"gridlayer\"),t.overgrid=s(e,\"g\",\"overgrid\"),t.zerolinelayer=s(e,\"g\",\"zerolinelayer\"),t.overzero=s(e,\"g\",\"overzero\"),s(e,\"path\",\"xlines-below\"),s(e,\"path\",\"ylines-below\"),t.overlinesBelow=s(e,\"g\",\"overlines-below\"),s(e,\"g\",\"xaxislayer-below\"),s(e,\"g\",\"yaxislayer-below\"),t.overaxesBelow=s(e,\"g\",\"overaxes-below\"),t.plot=s(e,\"g\",\"plot\"),t.overplot=s(e,\"g\",\"overplot\"),s(e,\"path\",\"xlines-above\"),s(e,\"path\",\"ylines-above\"),t.overlinesAbove=s(e,\"g\",\"overlines-above\"),s(e,\"g\",\"xaxislayer-above\"),s(e,\"g\",\"yaxislayer-above\"),t.overaxesAbove=s(e,\"g\",\"overaxes-above\"),t.xlines=e.select(\".xlines-\"+n),t.ylines=e.select(\".ylines-\"+i),t.xaxislayer=e.select(\".xaxislayer-\"+n),t.yaxislayer=e.select(\".yaxislayer-\"+i)}for(var h=0;h<f.traceLayerClasses.length;h++)s(t.plot,\"g\",f.traceLayerClasses[h]);t.xlines.style(\"fill\",\"none\").classed(\"crisp\",!0),t.ylines.style(\"fill\",\"none\").classed(\"crisp\",!0)}function o(t,e){if(t){var r={};t.each(function(t){var n=l.select(this),i=\"clip\"+e._uid+t+\"plot\";n.remove(),e._draggers.selectAll(\"g.\"+t).remove(),e._defs.select(\"#\"+i).remove(),r[t]=!0});for(var n=e._plots,i=Object.keys(n),a=0;a<i.length;a++)for(var o=n[i[a]],s=o.overlays||[],u=0;u<s.length;u++){var c=s[u];r[c.id]&&c.plot.selectAll(\".trace\").remove()}}}function s(t,e,r){var n=t.selectAll(\".\"+r).data([0]);return n.enter().append(e).classed(r,!0),n}var l=t(\"d3\"),u=t(\"../../lib\"),c=t(\"../plots\"),h=t(\"./axis_ids\"),f=t(\"./constants\");r.name=\"cartesian\",r.attr=[\"xaxis\",\"yaxis\"],r.idRoot=[\"x\",\"y\"],r.idRegex=f.idRegex,r.attrRegex=f.attrRegex,r.attributes=t(\"./attributes\"),r.layoutAttributes=t(\"./layout_attributes\"),r.transitionAxes=t(\"./transition_axes\"),r.plot=function(t,e,r,i){var a,o=t._fullLayout,s=c.getSubplotIds(o,\"cartesian\"),l=t.calcdata;if(!Array.isArray(e))for(e=[],a=0;a<l.length;a++)e.push(a);for(a=0;a<s.length;a++){for(var u,h=s[a],f=o._plots[h],d=[],p=0;p<l.length;p++){var m=l[p],v=m[0].trace;v.xaxis+v.yaxis===h&&((-1!==e.indexOf(v.index)||v.carpet)&&(u&&u[0].trace.xaxis+u[0].trace.yaxis===h&&-1!==[\"tonextx\",\"tonexty\",\"tonext\"].indexOf(v.fill)&&-1===d.indexOf(u)&&d.push(u),d.push(m)),u=m)}n(t,f,d,r,i)}},r.clean=function(t,e,r,n){var i,a,s,l=n._modules||[],u=e._modules||[];for(s=0;s<l.length;s++)if(\"scatter\"===l[s].name){i=!0;break}for(s=0;s<u.length;s++)if(\"scatter\"===u[s].name){a=!0;break}if(i&&!a){var c=n._plots,f=Object.keys(c||{});for(s=0;s<f.length;s++){var d=c[f[s]];d.plot&&d.plot.select(\"g.scatterlayer\").selectAll(\"g.trace\").remove()}n._infolayer.selectAll(\"g.rangeslider-container\").select(\"g.scatterlayer\").selectAll(\"g.trace\").remove()}var p=n._has&&n._has(\"cartesian\"),m=e._has&&e._has(\"cartesian\");if(p&&!m){var v=n._cartesianlayer.selectAll(\".subplot\"),g=h.listIds({_fullLayout:n});for(v.call(o,n),n._defs.selectAll(\".axesclip\").remove(),s=0;s<g.length;s++)n._infolayer.select(\".\"+g[s]+\"title\").remove()}},r.drawFramework=function(t){var e=t._fullLayout,r=i(t),n=e._cartesianlayer.selectAll(\".subplot\").data(r,u.identity);n.enter().append(\"g\").attr(\"class\",function(t){return\"subplot \"+t}),n.order(),n.exit().call(o,e),n.each(function(t){var r=e._plots[t];if(r.plotgroup=l.select(this),r.overlays=[],a(r),r.mainplot){e._plots[r.mainplot].overlays.push(r)}r.draglayer=s(e._draggers,\"g\",t)})},r.rangePlot=function(t,e,r){a(e),n(t,e,r),c.style(t)}},{\"../../lib\":725,\"../plots\":829,\"./attributes\":765,\"./axis_ids\":769,\"./constants\":771,\"./layout_attributes\":777,\"./transition_axes\":787,d3:121}],777:[function(t,e,r){\"use strict\";var n=t(\"../font_attributes\"),i=t(\"../../components/color/attributes\"),a=t(\"../../components/drawing/attributes\").dash,o=t(\"../../lib/extend\").extendFlat,s=t(\"./constants\");e.exports={visible:{valType:\"boolean\"},color:{valType:\"color\",dflt:i.defaultLine},title:{valType:\"string\"},titlefont:o({},n,{}),type:{valType:\"enumerated\",values:[\"-\",\"linear\",\"log\",\"date\",\"category\"],dflt:\"-\"},autorange:{valType:\"enumerated\",values:[!0,!1,\"reversed\"],dflt:!0},rangemode:{valType:\"enumerated\",values:[\"normal\",\"tozero\",\"nonnegative\"],dflt:\"normal\"},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},fixedrange:{valType:\"boolean\",dflt:!1},scaleanchor:{valType:\"enumerated\",values:[s.idRegex.x.toString(),s.idRegex.y.toString()]},scaleratio:{valType:\"number\",min:0,dflt:1},constrain:{valType:\"enumerated\",values:[\"range\",\"domain\"],dflt:\"range\"},constraintoward:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\",\"top\",\"middle\",\"bottom\"]},tickmode:{valType:\"enumerated\",values:[\"auto\",\"linear\",\"array\"]},nticks:{valType:\"integer\",min:0,dflt:0},tick0:{valType:\"any\"},dtick:{valType:\"any\"},tickvals:{valType:\"data_array\"},ticktext:{valType:\"data_array\"},ticks:{valType:\"enumerated\",values:[\"outside\",\"inside\",\"\"]},mirror:{valType:\"enumerated\",values:[!0,\"ticks\",!1,\"all\",\"allticks\"],dflt:!1},ticklen:{valType:\"number\",min:0,dflt:5},tickwidth:{valType:\"number\",min:0,dflt:1},tickcolor:{valType:\"color\",dflt:i.defaultLine},showticklabels:{valType:\"boolean\",dflt:!0},showspikes:{valType:\"boolean\",dflt:!1},spikecolor:{valType:\"color\",dflt:null},spikethickness:{valType:\"number\",dflt:3},spikedash:o({},a,{dflt:\"dash\"}),spikemode:{valType:\"flaglist\",flags:[\"toaxis\",\"across\",\"marker\"],dflt:\"toaxis\"},tickfont:o({},n,{}),tickangle:{valType:\"angle\",dflt:\"auto\"},tickprefix:{valType:\"string\",dflt:\"\"},showtickprefix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},ticksuffix:{valType:\"string\",dflt:\"\"},showticksuffix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},showexponent:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},exponentformat:{valType:\"enumerated\",values:[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"],dflt:\"B\"},separatethousands:{valType:\"boolean\",dflt:!1},tickformat:{valType:\"string\",dflt:\"\"},hoverformat:{valType:\"string\",dflt:\"\"},showline:{valType:\"boolean\",dflt:!1},linecolor:{valType:\"color\",dflt:i.defaultLine},linewidth:{valType:\"number\",min:0,dflt:1},showgrid:{valType:\"boolean\"},gridcolor:{valType:\"color\",dflt:i.lightLine},gridwidth:{valType:\"number\",min:0,dflt:1},zeroline:{valType:\"boolean\"},zerolinecolor:{valType:\"color\",dflt:i.defaultLine},zerolinewidth:{valType:\"number\",dflt:1},anchor:{valType:\"enumerated\",values:[\"free\",s.idRegex.x.toString(),s.idRegex.y.toString()]},side:{valType:\"enumerated\",values:[\"top\",\"bottom\",\"left\",\"right\"]},overlaying:{valType:\"enumerated\",values:[\"free\",s.idRegex.x.toString(),s.idRegex.y.toString()]},layer:{valType:\"enumerated\",values:[\"above traces\",\"below traces\"],dflt:\"above traces\"},domain:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},position:{valType:\"number\",min:0,max:1,dflt:0},categoryorder:{valType:\"enumerated\",values:[\"trace\",\"category ascending\",\"category descending\",\"array\"],dflt:\"trace\"},categoryarray:{valType:\"data_array\"},_deprecated:{autotick:{valType:\"boolean\"}}}},{\"../../components/color/attributes\":602,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../font_attributes\":790,\"./constants\":771}],778:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"../layout_attributes\"),s=t(\"./constants\"),l=t(\"./layout_attributes\"),u=t(\"./type_defaults\"),c=t(\"./axis_defaults\"),h=t(\"./constraint_defaults\"),f=t(\"./position_defaults\"),d=t(\"./axis_ids\");e.exports=function(t,e,r){function p(t,e){return Number(t.substr(5)||1)-Number(e.substr(5)||1)}function m(t,e){return i.coerce(N,B,l,t,e)}function v(t){var e={x:P,y:D}[t];return i.simpleMap(e,d.name2id)}var g,y=Object.keys(t),b=[],x=[],_=[],w=[],M=[],k=[],A={},T={};for(g=0;g<r.length;g++){var S,E,L=r[g];if(n.traceIs(L,\"cartesian\"))S=b,E=x;else{if(!n.traceIs(L,\"gl2d\"))continue;S=_,E=w}var C=d.id2name(L.xaxis),z=d.id2name(L.yaxis);if(n.traceIs(L,\"carpet\")&&(\"carpet\"!==L.type||L._cheater)||C&&i.pushUnique(k,C),\"carpet\"===L.type&&L._cheater&&C&&i.pushUnique(M,C),C&&-1===S.indexOf(C)&&S.push(C),z&&-1===E.indexOf(z)&&E.push(z),n.traceIs(L,\"2dMap\")&&(A[C]=!0,A[z]=!0),n.traceIs(L,\"oriented\")){T[\"h\"===L.orientation?z:C]=!0}}if(!e._has(\"gl3d\")&&!e._has(\"geo\"))for(g=0;g<y.length;g++){var I=y[g];-1===_.indexOf(I)&&-1===b.indexOf(I)&&s.xAxisMatch.test(I)?b.push(I):-1===w.indexOf(I)&&-1===x.indexOf(I)&&s.yAxisMatch.test(I)&&x.push(I)}b.length&&x.length&&i.pushUnique(e._basePlotModules,n.subplotsRegistry.cartesian)\n",
       ";var D=b.concat(_).sort(p),P=x.concat(w).sort(p),O=D.concat(P),R=a.background;D.length&&P.length&&(R=i.coerce(t,e,o,\"plot_bgcolor\"));var F,j,N,B,U=a.combine(R,e.paper_bgcolor),V={x:v(\"x\"),y:v(\"y\")};for(g=0;g<O.length;g++){F=O[g],i.isPlainObject(t[F])||(t[F]={}),N=t[F],B=e[F]={},u(N,B,m,r,F),j=F.charAt(0);var H=function(e,r){for(var n={x:D,y:P}[e],i=[],a=0;a<n.length;a++){var o=n[a];o===r||(t[o]||{}).overlaying||i.push(d.name2id(o))}return i}(j,F),q={letter:j,font:e.font,outerTicks:A[F],showGrid:!T[F],data:r,bgColor:U,calendar:e.calendar,cheateronly:\"x\"===j&&-1!==M.indexOf(F)&&-1===k.indexOf(F)};c(N,B,m,q,e);m(\"showspikes\")&&(m(\"spikecolor\"),m(\"spikethickness\"),m(\"spikedash\"),m(\"spikemode\"));var G={letter:j,counterAxes:V[j],overlayableAxes:H};f(N,B,m,G),B._input=N}var Y=n.getComponentMethod(\"rangeslider\",\"handleDefaults\"),X=n.getComponentMethod(\"rangeselector\",\"handleDefaults\");for(g=0;g<D.length;g++)F=D[g],N=t[F],B=e[F],Y(t,e,F),\"date\"===B.type&&X(N,B,e,P,B.calendar),m(\"fixedrange\");for(g=0;g<P.length;g++){F=P[g],N=t[F],B=e[F];var W=e[d.id2name(B.anchor)];m(\"fixedrange\",W&&W.rangeslider&&W.rangeslider.visible)}e._axisConstraintGroups=[];var Z=V.x.concat(V.y);for(g=0;g<O.length;g++)F=O[g],j=F.charAt(0),N=t[F],B=e[F],h(N,B,m,Z,e)}},{\"../../components/color\":603,\"../../lib\":725,\"../../registry\":844,\"../layout_attributes\":820,\"./axis_defaults\":768,\"./axis_ids\":769,\"./constants\":771,\"./constraint_defaults\":772,\"./layout_attributes\":777,\"./position_defaults\":780,\"./type_defaults\":788}],779:[function(t,e,r){\"use strict\";function n(t,e,r){var n,a,o,s,l,u=[],c=r.map(function(e){return e[t]}),h=i.bisector(e).left;for(n=0;n<c.length;n++)for(o=c[n],a=0;a<o.length;a++)null!==(s=o[a])&&void 0!==s&&((l=h(u,s))<u.length&&u[l]===s||u.splice(l,0,s));return u}var i=t(\"d3\");e.exports=function(t,e,r,a){switch(e){case\"array\":return Array.isArray(r)?r.slice():[];case\"category ascending\":return n(t,i.ascending,a);case\"category descending\":return n(t,i.descending,a);case\"trace\":default:return[]}}},{d3:121}],780:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\");e.exports=function(t,e,r,a){var o=a.counterAxes||[],s=a.overlayableAxes||[],l=a.letter;\"free\"===i.coerce(t,e,{anchor:{valType:\"enumerated\",values:[\"free\"].concat(o),dflt:n(t.position)?\"free\":o[0]||\"free\"}},\"anchor\")&&r(\"position\"),i.coerce(t,e,{side:{valType:\"enumerated\",values:\"x\"===l?[\"bottom\",\"top\"]:[\"left\",\"right\"],dflt:\"x\"===l?\"bottom\":\"left\"}},\"side\");var u=!1;if(s.length&&(u=i.coerce(t,e,{overlaying:{valType:\"enumerated\",values:[!1].concat(s),dflt:!1}},\"overlaying\")),!u){var c=r(\"domain\");c[0]>c[1]-.01&&(e.domain=[0,1]),i.noneOrAll(t.domain,e.domain,[0,1])}return r(\"layer\"),e}},{\"../../lib\":725,\"fast-isnumeric\":130}],781:[function(t,e,r){\"use strict\";var n=t(\"../../constants/alignment\").FROM_BL;e.exports=function(t,e,r){void 0===r&&(r=n[t.constraintoward||\"center\"]);var i=[t.r2l(t.range[0]),t.r2l(t.range[1])],a=i[0]+(i[1]-i[0])*r;t.range=t._input.range=[t.l2r(a+(i[0]-a)*e),t.l2r(a+(i[1]-a)*e)]}},{\"../../constants/alignment\":699}],782:[function(t,e,r){\"use strict\";function n(t){return t._id}function i(t,e){if(Array.isArray(t))for(var r=e.cd[0].trace,n=0;n<t.length;n++){var i=t[n];i.curveNumber=r.index,i.data=r._input,i.fullData=r,s(i,r,i.pointNumber)}return t}var a=t(\"../../lib/polygon\"),o=t(\"../../components/color\"),s=t(\"../../components/fx/helpers\").appendArrayPointValue,l=t(\"./axes\"),u=t(\"./constants\"),c=a.filter,h=a.tester,f=u.MINSELECT;e.exports=function(t,e,r,a,s){function d(t){var e=\"y\"===t._id.charAt(0)?1:0;return function(r){return t.p2d(r[e])}}function p(t,e){return t-e}var m,v=a.gd._fullLayout._zoomlayer,g=a.element.getBoundingClientRect(),y=a.plotinfo,b=y.xaxis._offset,x=y.yaxis._offset,_=e-g.left,w=r-g.top,M=_,k=w,A=\"M\"+_+\",\"+w,T=a.xaxes[0]._length,S=a.yaxes[0]._length,E=a.xaxes.map(n),L=a.yaxes.map(n),C=a.xaxes.concat(a.yaxes);\"lasso\"===s&&(m=c([[_,w]],u.BENDPX));var z=v.selectAll(\"path.select-outline\").data([1,2]);z.enter().append(\"path\").attr(\"class\",function(t){return\"select-outline select-outline-\"+t}).attr(\"transform\",\"translate(\"+b+\", \"+x+\")\").attr(\"d\",A+\"Z\");var I,D,P,O,R,F=v.append(\"path\").attr(\"class\",\"zoombox-corners\").style({fill:o.background,stroke:o.defaultLine,\"stroke-width\":1}).attr(\"transform\",\"translate(\"+b+\", \"+x+\")\").attr(\"d\",\"M0,0Z\"),j=[],N=a.gd,B=[];for(I=0;I<N.calcdata.length;I++)if(D=N.calcdata[I],P=D[0].trace,P._module&&P._module.selectPoints)if(a.subplot){if(P.subplot!==a.subplot)continue;j.push({selectPoints:P._module.selectPoints,cd:D,xaxis:a.xaxes[0],yaxis:a.yaxes[0]})}else{if(-1===E.indexOf(P.xaxis))continue;if(-1===L.indexOf(P.yaxis))continue;j.push({selectPoints:P._module.selectPoints,cd:D,xaxis:l.getFromId(N,P.xaxis),yaxis:l.getFromId(N,P.yaxis)})}var U;U=y.fillRangeItems?y.fillRangeItems:\"select\"===s?function(t,e){var r=t.range={};for(I=0;I<C.length;I++){var n=C[I],i=n._id.charAt(0);r[n._id]=[n.p2d(e[i+\"min\"]),n.p2d(e[i+\"max\"])].sort(p)}}:function(t,e,r){var n=t.lassoPoints={};for(I=0;I<C.length;I++){var i=C[I];n[i._id]=r.filtered.map(d(i))}},a.moveFn=function(t,e){var r;M=Math.max(0,Math.min(T,t+_)),k=Math.max(0,Math.min(S,e+w));var n=Math.abs(M-_),o=Math.abs(k-w);for(\"select\"===s?(o<Math.min(.6*n,f)?(r=h([[_,0],[_,S],[M,S],[M,0]]),F.attr(\"d\",\"M\"+r.xmin+\",\"+(w-f)+\"h-4v\"+2*f+\"h4ZM\"+(r.xmax-1)+\",\"+(w-f)+\"h4v\"+2*f+\"h-4Z\")):n<Math.min(.6*o,f)?(r=h([[0,w],[0,k],[T,k],[T,w]]),F.attr(\"d\",\"M\"+(_-f)+\",\"+r.ymin+\"v-4h\"+2*f+\"v4ZM\"+(_-f)+\",\"+(r.ymax-1)+\"v4h\"+2*f+\"v-4Z\")):(r=h([[_,w],[_,k],[M,k],[M,w]]),F.attr(\"d\",\"M0,0Z\")),z.attr(\"d\",\"M\"+r.xmin+\",\"+r.ymin+\"H\"+(r.xmax-1)+\"V\"+(r.ymax-1)+\"H\"+r.xmin+\"Z\")):\"lasso\"===s&&(m.addPt([M,k]),r=h(m.filtered),z.attr(\"d\",\"M\"+m.filtered.join(\"L\")+\"Z\")),B=[],I=0;I<j.length;I++)O=j[I],[].push.apply(B,i(O.selectPoints(O,r),O));R={points:B},U(R,r,m),a.gd.emit(\"plotly_selecting\",R)},a.doneFn=function(t,e){if(F.remove(),t||2!==e)a.gd.emit(\"plotly_selected\",R);else{for(z.remove(),I=0;I<j.length;I++)O=j[I],O.selectPoints(O,!1);N.emit(\"plotly_deselect\",null)}}}},{\"../../components/color\":603,\"../../components/fx/helpers\":641,\"../../lib/polygon\":736,\"./axes\":766,\"./constants\":771}],783:[function(t,e,r){\"use strict\";function n(t){return Math.pow(10,t)}var i=t(\"d3\"),a=t(\"fast-isnumeric\"),o=t(\"../../lib\"),s=o.cleanNumber,l=o.ms2DateTime,u=o.dateTime2ms,c=o.ensureNumber,h=t(\"../../constants/numerical\"),f=h.FP_SAFE,d=h.BADNUM,p=t(\"./constants\"),m=t(\"./axis_ids\");e.exports=function(t,e){function r(e,r){if(e>0)return Math.log(e)/Math.LN10;if(e<=0&&r&&t.range&&2===t.range.length){var n=t.range[0],i=t.range[1];return.5*(n+i-3*M*Math.abs(n-i))}return d}function h(e,r,n){var i=u(e,n||t.calendar);if(i===d){if(!a(e))return d;i=u(new Date(+e))}return i}function v(e,r,n){return l(e,r,n||t.calendar)}function g(e){return t._categories[Math.round(e)]}function y(e){if(null!==e&&void 0!==e){if(void 0===t._categoriesMap&&(t._categoriesMap={}),void 0!==t._categoriesMap[e])return t._categoriesMap[e];t._categories.push(e);var r=t._categories.length-1;return t._categoriesMap[e]=r,r}return d}function b(e){if(t._categoriesMap){var r=t._categoriesMap[e];if(void 0!==r)return r}if(a(e))return+e}function x(e){return a(e)?i.round(t._b+t._m*e,2):d}function _(e){return(e-t._b)/t._m}e=e||{};var w=(t._id||\"x\").charAt(0),M=10;t.c2l=\"log\"===t.type?r:c,t.l2c=\"log\"===t.type?n:c,t.l2p=x,t.p2l=_,t.c2p=\"log\"===t.type?function(t,e){return x(r(t,e))}:x,t.p2c=\"log\"===t.type?function(t){return n(_(t))}:_,-1!==[\"linear\",\"-\"].indexOf(t.type)?(t.d2r=t.r2d=t.d2c=t.r2c=t.d2l=t.r2l=s,t.c2d=t.c2r=t.l2d=t.l2r=c,t.d2p=t.r2p=function(e){return t.l2p(s(e))},t.p2d=t.p2r=_,t.cleanPos=c):\"log\"===t.type?(t.d2r=t.d2l=function(t,e){return r(s(t),e)},t.r2d=t.r2c=function(t){return n(s(t))},t.d2c=t.r2l=s,t.c2d=t.l2r=c,t.c2r=r,t.l2d=n,t.d2p=function(e,r){return t.l2p(t.d2r(e,r))},t.p2d=function(t){return n(_(t))},t.r2p=function(e){return t.l2p(s(e))},t.p2r=_,t.cleanPos=c):\"date\"===t.type?(t.d2r=t.r2d=o.identity,t.d2c=t.r2c=t.d2l=t.r2l=h,t.c2d=t.c2r=t.l2d=t.l2r=v,t.d2p=t.r2p=function(e,r,n){return t.l2p(h(e,0,n))},t.p2d=t.p2r=function(t,e,r){return v(_(t),e,r)},t.cleanPos=function(e){return o.cleanDate(e,d,t.calendar)}):\"category\"===t.type&&(t.d2c=t.d2l=y,t.r2d=t.c2d=t.l2d=g,t.d2r=t.d2l_noadd=b,t.r2c=function(e){var r=b(e);return void 0!==r?r:t.fraction2r(.5)},t.l2r=t.c2r=c,t.r2l=b,t.d2p=function(e){return t.l2p(t.r2c(e))},t.p2d=function(t){return g(_(t))},t.r2p=t.d2p,t.p2r=_,t.cleanPos=function(t){return\"string\"==typeof t&&\"\"!==t?t:c(t)}),t.fraction2r=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return t.l2r(r+e*(n-r))},t.r2fraction=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return(t.r2l(e)-r)/(n-r)},t.cleanRange=function(e){e||(e=\"range\");var r,n,i=o.nestedProperty(t,e).get();if(n=\"date\"===t.type?o.dfltRange(t.calendar):\"y\"===w?p.DFLTRANGEY:p.DFLTRANGEX,n=n.slice(),!i||2!==i.length)return void o.nestedProperty(t,e).set(n);for(\"date\"===t.type&&(i[0]=o.cleanDate(i[0],d,t.calendar),i[1]=o.cleanDate(i[1],d,t.calendar)),r=0;r<2;r++)if(\"date\"===t.type){if(!o.isDateTime(i[r],t.calendar)){t[e]=n;break}if(t.r2l(i[0])===t.r2l(i[1])){var s=o.constrain(t.r2l(i[0]),o.MIN_MS+1e3,o.MAX_MS-1e3);i[0]=t.l2r(s-1e3),i[1]=t.l2r(s+1e3);break}}else{if(!a(i[r])){if(!a(i[1-r])){t[e]=n;break}i[r]=i[1-r]*(r?10:.1)}if(i[r]<-f?i[r]=-f:i[r]>f&&(i[r]=f),i[0]===i[1]){var l=Math.max(1,Math.abs(1e-6*i[0]));i[0]-=l,i[1]+=l}}},t.setScale=function(r){var n=e._size;if(t._categories||(t._categories=[]),t._categoriesMap||(t._categoriesMap={}),t.overlaying){var i=m.getFromId({_fullLayout:e},t.overlaying);t.domain=i.domain}var a=r&&t._r?\"_r\":\"range\",s=t.calendar;t.cleanRange(a);var l=t.r2l(t[a][0],s),u=t.r2l(t[a][1],s);if(\"y\"===w?(t._offset=n.t+(1-t.domain[1])*n.h,t._length=n.h*(t.domain[1]-t.domain[0]),t._m=t._length/(l-u),t._b=-t._m*u):(t._offset=n.l+t.domain[0]*n.w,t._length=n.w*(t.domain[1]-t.domain[0]),t._m=t._length/(u-l),t._b=-t._m*l),!isFinite(t._m)||!isFinite(t._b))throw o.notifier(\"Something went wrong with axis scaling\",\"long\"),e._replotting=!1,new Error(\"axis scaling\")},t.makeCalcdata=function(e,r){var n,i,a,o=\"date\"===t.type&&e[r+\"calendar\"];if(r in e)for(n=e[r],i=new Array(n.length),a=0;a<n.length;a++)i[a]=t.d2c(n[a],0,o);else{var s=r+\"0\"in e?t.d2c(e[r+\"0\"],0,o):0,l=e[\"d\"+r]?Number(e[\"d\"+r]):1;for(n=e[{x:\"y\",y:\"x\"}[r]],i=new Array(n.length),a=0;a<n.length;a++)i[a]=s+a*l}return i},t.isValidRange=function(e){return Array.isArray(e)&&2===e.length&&a(t.r2l(e[0]))&&a(t.r2l(e[1]))},t.isPtWithinRange=\"x\"===w?function(e){var r=e.x;return r>=t.range[0]&&r<=t.range[1]}:function(e){var r=e.y;return r>=t.range[0]&&r<=t.range[1]},t._min=[],t._max=[],t._separators=e.separators,delete t._minDtick,delete t._forceTick0}},{\"../../constants/numerical\":705,\"../../lib\":725,\"./axis_ids\":769,\"./constants\":771,d3:121,\"fast-isnumeric\":130}],784:[function(t,e,r){\"use strict\";function n(t){var e=[\"showexponent\",\"showtickprefix\",\"showticksuffix\"],r=e.filter(function(e){return void 0!==t[e]}),n=function(e){return t[e]===t[r[0]]};if(r.every(n)||1===r.length)return t[r[0]]}var i=t(\"../../lib\");e.exports=function(t,e,r,a,o){var s=n(t);if(r(\"tickprefix\")&&r(\"showtickprefix\",s),r(\"ticksuffix\")&&r(\"showticksuffix\",s),r(\"showticklabels\")){var l=o.font||{},u=e.color===t.color?e.color:l.color;i.coerceFont(r,\"tickfont\",{family:l.family,size:l.size,color:u}),r(\"tickangle\"),\"category\"!==a&&(r(\"tickformat\")||\"date\"===a||(r(\"showexponent\",s),r(\"exponentformat\"),r(\"separatethousands\")))}\"category\"===a||o.noHover||r(\"hoverformat\")}},{\"../../lib\":725}],785:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./layout_attributes\");e.exports=function(t,e,r,a){var o=n.coerce2(t,e,i,\"ticklen\"),s=n.coerce2(t,e,i,\"tickwidth\"),l=n.coerce2(t,e,i,\"tickcolor\",e.color);r(\"ticks\",a.outerTicks||o||s||l?\"outside\":\"\")||(delete e.ticklen,delete e.tickwidth,delete e.tickcolor)}},{\"../../lib\":725,\"./layout_attributes\":777}],786:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../constants/numerical\").ONEDAY;e.exports=function(t,e,r,o){var s=\"auto\";\"array\"!==t.tickmode||\"log\"!==o&&\"date\"!==o||(t.tickmode=\"auto\"),Array.isArray(t.tickvals)?s=\"array\":t.dtick&&(s=\"linear\");var l=r(\"tickmode\",s);if(\"auto\"===l)r(\"nticks\");else if(\"linear\"===l){var u=\"date\"===o?a:1,c=r(\"dtick\",u);if(n(c))e.dtick=c>0?Number(c):u;else if(\"string\"!=typeof c)e.dtick=u;else{var h=c.charAt(0),f=c.substr(1);f=n(f)?Number(f):0,(f<=0||!(\"date\"===o&&\"M\"===h&&f===Math.round(f)||\"log\"===o&&\"L\"===h||\"log\"===o&&\"D\"===h&&(1===f||2===f)))&&(e.dtick=u)}var d=\"date\"===o?i.dateTick0(e.calendar):0,p=r(\"tick0\",d);\"date\"===o?e.tick0=i.cleanDate(p,d):n(p)&&\"D1\"!==c&&\"D2\"!==c?e.tick0=Number(p):e.tick0=d}else{var m=r(\"tickvals\");void 0===m?e.tickmode=\"auto\":r(\"ticktext\")}}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],787:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../plotly\"),a=t(\"../../registry\"),o=t(\"../../components/drawing\"),s=t(\"./axes\"),l=/((x|y)([2-9]|[1-9][0-9]+)?)axis$/;e.exports=function(t,e,r,u){function c(e,r){function n(e,r,n){for(i=0;i<e.length;i++){var a=e[i];if(-1===o.indexOf(a.xref)&&-1===o.indexOf(a.yref)||r(t,i),n)return}}var i,o=[];for(o=[e._id,r._id],i=0;i<o.length;i++)s.doTicks(t,o[i],!0);n(v.annotations||[],a.getComponentMethod(\"annotations\",\"drawOne\")),n(v.shapes||[],a.getComponentMethod(\"shapes\",\"drawOne\")),n(v.images||[],a.getComponentMethod(\"images\",\"draw\"),!0)}function h(t){var e=t.xaxis,r=t.yaxis;v._defs.select(\"#\"+t.clipId+\"> rect\").call(o.setTranslate,0,0).call(o.setScale,1,1),t.plot.call(o.setTranslate,e._offset,r._offset).call(o.setScale,1,1);var n=t.plot.select(\".scatterlayer\").selectAll(\".points\");n.selectAll(\".point\").call(o.setPointGroupScale,1,1).call(o.hideOutsideRangePoints,t),n.selectAll(\".textpoint\").call(o.setTextPointsScale,1,1).call(o.hideOutsideRangePoints,t)}function f(e,r){var n,i,a,s=y[e.xaxis._id],l=y[e.yaxis._id],u=[];if(s){n=t._fullLayout[s.axisName],i=n._r,a=s.to,u[0]=(i[0]*(1-r)+r*a[0]-i[0])/(i[1]-i[0])*e.xaxis._length;var h=i[1]-i[0],f=a[1]-a[0];n.range[0]=i[0]*(1-r)+r*a[0],n.range[1]=i[1]*(1-r)+r*a[1],u[2]=e.xaxis._length*(1-r+r*f/h)}else u[0]=0,u[2]=e.xaxis._length;if(l){n=t._fullLayout[l.axisName],i=n._r,a=l.to,u[1]=(i[1]*(1-r)+r*a[1]-i[1])/(i[0]-i[1])*e.yaxis._length;var d=i[1]-i[0],p=a[1]-a[0];n.range[0]=i[0]*(1-r)+r*a[0],n.range[1]=i[1]*(1-r)+r*a[1],u[3]=e.yaxis._length*(1-r+r*p/d)}else u[1]=0,u[3]=e.yaxis._length;c(e.xaxis,e.yaxis);var m=e.xaxis,g=e.yaxis,b=!!s,x=!!l,_=b?m._length/u[2]:1,w=x?g._length/u[3]:1,M=b?u[0]:0,k=x?u[1]:0,A=b?u[0]/u[2]*m._length:0,T=x?u[1]/u[3]*g._length:0,S=m._offset-A,E=g._offset-T;v._defs.select(\"#\"+e.clipId+\"> rect\").call(o.setTranslate,M,k).call(o.setScale,1/_,1/w),e.plot.call(o.setTranslate,S,E).call(o.setScale,_,w).selectAll(\".points\").selectAll(\".point\").call(o.setPointGroupScale,1/_,1/w),e.plot.selectAll(\".points\").selectAll(\".textpoint\").call(o.setTextPointsScale,1/_,1/w)}function d(){for(var e={},r=0;r<b.length;r++){var n=t._fullLayout[y[b[r]].axisName],a=y[b[r]].to;e[n._name+\".range[0]\"]=a[0],e[n._name+\".range[1]\"]=a[1],n.range=a.slice()}return _&&_(),i.relayout(t,e).then(function(){for(var t=0;t<x.length;t++)h(x[t])})}function p(){for(var e={},r=0;r<b.length;r++){var n=t._fullLayout[b[r]+\"axis\"];e[n._name+\".range[0]\"]=n.range[0],e[n._name+\".range[1]\"]=n.range[1],n.range=n._r.slice()}return i.relayout(t,e).then(function(){for(var t=0;t<x.length;t++)h(x[t])})}function m(){M=Date.now();for(var t=Math.min(1,(M-w)/r.duration),e=A(t),n=0;n<x.length;n++)f(x[n],e);M-w>r.duration?(d(),k=window.cancelAnimationFrame(m)):k=window.requestAnimationFrame(m)}var v=t._fullLayout,g=[],y=function(t){var e,r,n,i,a,o={};for(e in t)if(r=e.split(\".\"),n=r[0].match(l)){var s=n[1],u=s+\"axis\";if(i=v[u],a={},Array.isArray(t[e])?a.to=t[e].slice(0):Array.isArray(t[e].range)&&(a.to=t[e].range.slice(0)),!a.to)continue;a.axisName=u,a.length=i._length,g.push(s),o[s]=a}return o}(e),b=Object.keys(y),x=function(t,e,r){var n,i,a,o=t._plots,s=[];for(n in o){var l=o[n];if(-1===s.indexOf(l)){var u=l.xaxis._id,c=l.yaxis._id,h=l.xaxis.range,f=l.yaxis.range;l.xaxis._r=l.xaxis.range.slice(),l.yaxis._r=l.yaxis.range.slice(),i=r[u]?r[u].to:h,a=r[c]?r[c].to:f,h[0]===i[0]&&h[1]===i[1]&&f[0]===a[0]&&f[1]===a[1]||-1===e.indexOf(u)&&-1===e.indexOf(c)||s.push(l)}}return s}(v,b,y);if(!x.length)return function(){function e(e,r,n){for(var i=0;i<e.length;i++)if(r(t,i),n)return}e(v.annotations||[],a.getComponentMethod(\"annotations\",\"drawOne\")),e(v.shapes||[],a.getComponentMethod(\"shapes\",\"drawOne\")),e(v.images||[],a.getComponentMethod(\"images\",\"draw\"),!0)}(),!1;var _;u&&(_=u());var w,M,k,A=n.ease(r.easing);return t._transitionData._interruptCallbacks.push(function(){return window.cancelAnimationFrame(k),k=null,p()}),w=Date.now(),k=window.requestAnimationFrame(m),Promise.resolve()}},{\"../../components/drawing\":627,\"../../plotly\":761,\"../../registry\":844,\"./axes\":766,d3:121}],788:[function(t,e,r){\"use strict\";function n(t,e){if(\"-\"===t.type){var r=t._id,n=r.charAt(0);-1!==r.indexOf(\"scene\")&&(r=n);var u=i(e,r,n);if(u){if(\"histogram\"===u.type&&n==={v:\"y\",h:\"x\"}[u.orientation||\"v\"])return void(t.type=\"linear\");var c=n+\"calendar\",h=u[c];if(o(u,n)){for(var f,d=a(u),p=[],m=0;m<e.length;m++)f=e[m],s.traceIs(f,\"box\")&&(f[n+\"axis\"]||n)===r&&(void 0!==f[d]?p.push(f[d][0]):void 0!==f.name?p.push(f.name):p.push(\"text\"),f[c]!==h&&(h=void 0));t.type=l(p,h)}else t.type=l(u[n]||[u[n+\"0\"]],h)}}}function i(t,e,r){for(var n=0;n<t.length;n++){var i=t[n];if((i[r+\"axis\"]||r)===e){if(o(i,r))return i;if((i[r]||[]).length||i[r+\"0\"])return i}}}function a(t){return{v:\"x\",h:\"y\"}[t.orientation||\"v\"]}function o(t,e){var r=a(t),n=s.traceIs(t,\"box\"),i=s.traceIs(t._fullInput||{},\"candlestick\");return n&&!i&&e===r&&void 0===t[r]&&void 0===t[r+\"0\"]}var s=t(\"../../registry\"),l=t(\"./axis_autotype\"),u=t(\"./axis_ids\").name2id;e.exports=function(t,e,r,i,a){a&&(e._name=a,e._id=u(a)),\"-\"===r(\"type\")&&(n(e,i),\"-\"===e.type?e.type=\"linear\":t.type=e.type)}},{\"../../registry\":844,\"./axis_autotype\":767,\"./axis_ids\":769}],789:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a,o=!1;if(\"data\"===e.type)n=t._fullData[null!==e.traces?e.traces[0]:0];else{if(\"layout\"!==e.type)return!1;n=t._fullLayout}return i=u.nestedProperty(n,e.prop).get(),a=r[e.type]=r[e.type]||{},a.hasOwnProperty(e.prop)&&a[e.prop]!==i&&(o=!0),a[e.prop]=i,{changed:o,value:i}}function i(t,e){return Array.isArray(e[0])&&1===e[0].length&&-1!==[\"string\",\"number\"].indexOf(typeof e[0][0])?[{type:\"layout\",prop:\"_currentFrame\",value:e[0][0].toString()}]:[]}function a(t,e){var r=[],n=e[0],i={};if(\"string\"==typeof n)i[n]=e[1];else{if(!u.isPlainObject(n))return r;i=n}return s(i,function(t,e,n){r.push({type:\"layout\",prop:t,value:n})},\"\",0),r}function o(t,e){var r,n,i,a,o=[];if(n=e[0],i=e[1],r=e[2],a={},\"string\"==typeof n)a[n]=i;else{if(!u.isPlainObject(n))return o;a=n,void 0===r&&(r=i)}return void 0===r&&(r=null),s(a,function(e,n,i){var a;if(Array.isArray(i)){var s=Math.min(i.length,t.data.length);r&&(s=Math.min(s,r.length)),a=[];for(var l=0;l<s;l++)a[l]=r?r[l]:l}else a=r?r.slice(0):null;if(null===a)Array.isArray(i)&&(i=i[0]);else if(Array.isArray(a)){if(!Array.isArray(i)){var u=i;i=[];for(var c=0;c<a.length;c++)i[c]=u}i.length=Math.min(a.length,i.length)}o.push({type:\"data\",prop:e,traces:a,value:i})},\"\",0),o}function s(t,e,r,n){Object.keys(t).forEach(function(i){var a=t[i];if(\"_\"!==i[0]){var o=r+(n>0?\".\":\"\")+i;u.isPlainObject(a)?s(a,e,o,n+1):e(o,i,a)}})}var l=t(\"../plotly\"),u=t(\"../lib\");r.manageCommandObserver=function(t,e,i,a){var o={},s=!0;e&&e._commandObserver&&(o=e._commandObserver),o.cache||(o.cache={}),o.lookupTable={};var l=r.hasSimpleAPICommandBindings(t,i,o.lookupTable);if(e&&e._commandObserver){if(l)return o;if(e._commandObserver.remove)return e._commandObserver.remove(),e._commandObserver=null,o}if(l){n(t,l,o.cache),o.check=function(){if(s){var e=n(t,l,o.cache);return e.changed&&a&&void 0!==o.lookupTable[e.value]&&(o.disable(),Promise.resolve(a({value:e.value,type:l.type,prop:l.prop,traces:l.traces,index:o.lookupTable[e.value]})).then(o.enable,o.enable)),e.changed}};for(var c=[\"plotly_relayout\",\"plotly_redraw\",\"plotly_restyle\",\"plotly_update\",\"plotly_animatingframe\",\"plotly_afterplot\"],h=0;h<c.length;h++)t._internalOn(c[h],o.check);o.remove=function(){for(var e=0;e<c.length;e++)t._removeInternalListener(c[e],o.check)}}else u.warn(\"Unable to automatically bind plot updates to API command\"),o.lookupTable={},o.remove=function(){};return o.disable=function(){s=!1},o.enable=function(){s=!0},e&&(e._commandObserver=o),o},r.hasSimpleAPICommandBindings=function(t,e,n){var i,a,o=e.length;for(i=0;i<o;i++){var s,l=e[i],u=l.method,c=l.args;if(Array.isArray(c)||(c=[]),!u)return!1;var h=r.computeAPICommandBindings(t,u,c);if(1!==h.length)return!1;if(a){if(s=h[0],s.type!==a.type)return!1;if(s.prop!==a.prop)return!1;if(Array.isArray(a.traces)){if(!Array.isArray(s.traces))return!1;s.traces.sort();for(var f=0;f<a.traces.length;f++)if(a.traces[f]!==s.traces[f])return!1}else if(s.prop!==a.prop)return!1}else a=h[0],Array.isArray(a.traces)&&a.traces.sort();s=h[0];var d=s.value;if(Array.isArray(d)){if(1!==d.length)return!1;d=d[0]}n&&(n[d]=i)}return a},r.executeAPICommand=function(t,e,r){if(\"skip\"===e)return Promise.resolve();var n=l[e],i=[t];Array.isArray(r)||(r=[]);for(var a=0;a<r.length;a++)i.push(r[a]);return n.apply(null,i).catch(function(t){return u.warn(\"API call to Plotly.\"+e+\" rejected.\",t),Promise.reject(t)})},r.computeAPICommandBindings=function(t,e,r){var n;switch(Array.isArray(r)||(r=[]),e){case\"restyle\":n=o(t,r);break;case\"relayout\":n=a(t,r);break;case\"update\":n=o(t,[r[0],r[2]]).concat(a(t,[r[1]]));break;case\"animate\":n=i(t,r);break;default:n=[]}return n}},{\"../lib\":725,\"../plotly\":761}],790:[function(t,e,r){\"use strict\";e.exports={family:{valType:\"string\",noBlank:!0,strict:!0},size:{valType:\"number\",min:1},color:{valType:\"color\"}}},{}],791:[function(t,e,r){\"use strict\";e.exports={_isLinkedToArray:\"frames_entry\",group:{valType:\"string\"},name:{valType:\"string\"},traces:{valType:\"any\"},baseframe:{valType:\"string\"},data:{valType:\"any\"},layout:{valType:\"any\"}}},{}],792:[function(t,e,r){\"use strict\";var n=e.exports={};n.projNames={equirectangular:\"equirectangular\",mercator:\"mercator\",orthographic:\"orthographic\",\"natural earth\":\"naturalEarth\",kavrayskiy7:\"kavrayskiy7\",miller:\"miller\",robinson:\"robinson\",eckert4:\"eckert4\",\"azimuthal equal area\":\"azimuthalEqualArea\",\"azimuthal equidistant\":\"azimuthalEquidistant\",\"conic equal area\":\"conicEqualArea\",\"conic conformal\":\"conicConformal\",\"conic equidistant\":\"conicEquidistant\",gnomonic:\"gnomonic\",stereographic:\"stereographic\",mollweide:\"mollweide\",hammer:\"hammer\",\"transverse mercator\":\"transverseMercator\",\"albers usa\":\"albersUsa\",\"winkel tripel\":\"winkel3\",aitoff:\"aitoff\",sinusoidal:\"sinusoidal\"},n.axesNames=[\"lonaxis\",\"lataxis\"],n.lonaxisSpan={orthographic:180,\"azimuthal equal area\":360,\"azimuthal equidistant\":360,\"conic conformal\":180,gnomonic:160,stereographic:180,\"transverse mercator\":180,\"*\":360},n.lataxisSpan={\"conic conformal\":150,stereographic:179.5,\"*\":180},n.scopeDefaults={world:{lonaxisRange:[-180,180],lataxisRange:[-90,90],projType:\"equirectangular\",projRotate:[0,0,0]},usa:{lonaxisRange:[-180,-50],lataxisRange:[15,80],projType:\"albers usa\"},europe:{lonaxisRange:[-30,60],lataxisRange:[30,80],projType:\"conic conformal\",projRotate:[15,0,0],projParallels:[0,60]},asia:{lonaxisRange:[22,160],lataxisRange:[-15,55],projType:\"mercator\",projRotate:[0,0,0]},africa:{lonaxisRange:[-30,60],lataxisRange:[-40,40],projType:\"mercator\",projRotate:[0,0,0]},\"north america\":{lonaxisRange:[-180,-45],lataxisRange:[5,85],projType:\"conic conformal\",projRotate:[-100,0,0],projParallels:[29.5,45.5]},\"south america\":{lonaxisRange:[-100,-30],lataxisRange:[-60,15],projType:\"mercator\",projRotate:[0,0,0]}},n.clipPad=.001,n.precision=.1,n.landColor=\"#F0DC82\",n.waterColor=\"#3399FF\",n.locationmodeToLayer={\"ISO-3\":\"countries\",\"USA-states\":\"subunits\",\"country names\":\"countries\"},n.sphereSVG={type:\"Sphere\"},n.fillLayers=[\"ocean\",\"land\",\"lakes\"],n.lineLayers=[\"subunits\",\"countries\",\"coastlines\",\"rivers\",\"frame\"],n.baseLayers=[\"ocean\",\"land\",\"lakes\",\"subunits\",\"countries\",\"coastlines\",\"rivers\",\"lataxis\",\"lonaxis\",\"frame\"],n.layerNameToAdjective={ocean:\"ocean\",land:\"land\",lakes:\"lake\",subunits:\"subunit\",countries:\"country\",coastlines:\"coastline\",rivers:\"river\",frame:\"frame\"},n.baseLayersOverChoropleth=[\"rivers\",\"lakes\"]},{}],793:[function(t,e,r){\"use strict\";function n(t){this.id=t.id,this.graphDiv=t.graphDiv,this.container=t.container,this.topojsonURL=t.topojsonURL,this.topojsonName=null,this.topojson=null,this.projectionType=null,this.projection=null,this.clipAngle=null,this.setScale=null,this.path=null,this.zoom=null,this.zoomReset=null,this.makeFramework(),this.traceHash={}}function i(t,e,r){return u.geo.graticule().extent([[t[0],e[0]],[t[1],e[1]]]).step(r)}function a(t,e,r){var n=b.layerNameToAdjective[e];t.select(\".\"+e).selectAll(\"path\").attr(\"stroke\",\"none\").call(c.fill,r[n+\"color\"])}function o(t,e,r){var n=b.layerNameToAdjective[e];t.select(\".\"+e).selectAll(\"path\").attr(\"fill\",\"none\").call(c.stroke,r[n+\"color\"]).call(h.dashLine,\"\",r[n+\"width\"])}function s(t,e,r){t.select(\".\"+e+\"graticule\").selectAll(\"path\").attr(\"fill\",\"none\").call(c.stroke,r[e].gridcolor).call(h.dashLine,\"\",r[e].gridwidth)}function l(t){var e={type:\"linear\",showexponent:\"all\",exponentformat:p.layoutAttributes.exponentformat.dflt};return p.setConvert(e,t),e}var u=t(\"d3\"),c=t(\"../../components/color\"),h=t(\"../../components/drawing\"),f=t(\"../../components/fx\"),d=t(\"../plots\"),p=t(\"../cartesian/axes\"),m=t(\"./projections\"),v=t(\"./set_scale\"),g=t(\"./zoom\"),y=t(\"./zoom_reset\"),b=t(\"./constants\"),x=t(\"../../lib/topojson_utils\"),_=t(\"topojson-client\").feature;m(u),e.exports=n;var w=n.prototype;w.plot=function(t,e,r){var n,i,a=this,o=e[a.id],s=e._size;a.projection=null,a.setScale=v(o,s),a.makeProjection(o),a.makePath(),a.adjustLayout(o,s),a.zoom=g(a,o),a.zoomReset=y(a,o),a.mockAxis=l(e),a.framework.call(a.zoom).on(\"dblclick.zoom\",a.zoomReset),a.framework.on(\"mousemove\",function(){var t=u.mouse(this),e=a.projection.invert(t);if(e&&!isNaN(e[0])&&!isNaN(e[1])){var r=u.event;r.xpx=t[0],r.ypx=t[1],a.xaxis.c2p=function(){return t[0]},a.xaxis.p2c=function(){return e[0]},a.yaxis.c2p=function(){return t[1]},a.yaxis.p2c=function(){return e[1]},f.hover(a.graphDiv,r,a.id)}}),a.framework.on(\"mouseout\",function(){f.loneUnhover(e._toppaper)}),a.framework.on(\"click\",function(){f.click(a.graphDiv,u.event)}),n=x.getTopojsonName(o),null===a.topojson||n!==a.topojsonName?(a.topojsonName=n,void 0!==PlotlyGeoAssets.topojson[a.topojsonName]?(a.topojson=PlotlyGeoAssets.topojson[a.topojsonName],a.onceTopojsonIsLoaded(t,o)):(i=x.getTopojsonPath(a.topojsonURL,a.topojsonName),r.push(new Promise(function(e,r){u.json(i,function(n,s){if(n)return void r(404===n.status?new Error([\"plotly.js could not find topojson file at\",i,\".\",\"Make sure the *topojsonURL* plot config option\",\"is set properly.\"].join(\" \")):new Error([\"unexpected error while fetching topojson file at\",i].join(\" \")));a.topojson=s,PlotlyGeoAssets.topojson[a.topojsonName]=s,a.onceTopojsonIsLoaded(t,o),e()})})))):a.onceTopojsonIsLoaded(t,o)},w.onceTopojsonIsLoaded=function(t,e){this.drawLayout(e),d.generalUpdatePerTraceModule(this,t,e),this.render()},w.makeProjection=function(t){var e,r=t.projection,n=r.type,i=null===this.projection||n!==this.projectionType;i?(this.projectionType=n,e=this.projection=u.geo[b.projNames[n]]()):e=this.projection,e.translate(r._translate0).precision(b.precision),t._isAlbersUsa||e.rotate(r._rotate).center(r._center),t._clipAngle?(this.clipAngle=t._clipAngle,e.clipAngle(t._clipAngle-b.clipPad)):this.clipAngle=null,r.parallels&&e.parallels(r.parallels),i&&this.setScale(e),e.translate(r._translate).scale(r._scale)},w.makePath=function(){this.path=u.geo.path().projection(this.projection)},w.makeFramework=function(){var t=this.graphDiv._fullLayout,e=\"clip\"+t._uid+this.id,r=t._defs.selectAll(\"g.clips\").data([0]);r.enter().append(\"g\").classed(\"clips\",!0),(this.clipDef=r.selectAll(\"#\"+e).data([0])).enter().append(\"clipPath\").attr(\"id\",e).append(\"rect\");var n=this.framework=u.select(this.container).append(\"g\");n.attr(\"class\",\"geo \"+this.id).style(\"pointer-events\",\"all\").call(h.setClipUrl,e),n.append(\"g\").attr(\"class\",\"bglayer\").append(\"rect\"),n.append(\"g\").attr(\"class\",\"baselayer\"),n.append(\"g\").attr(\"class\",\"choroplethlayer\"),n.append(\"g\").attr(\"class\",\"baselayeroverchoropleth\"),n.append(\"g\").attr(\"class\",\"scattergeolayer\"),n.on(\"dblclick.zoom\",null),this.xaxis={_id:\"x\"},this.yaxis={_id:\"y\"}},w.adjustLayout=function(t,e){var r=t.domain,n=e.l+e.w*r.x[0]+t._marginX,i=e.t+e.h*(1-r.y[1])+t._marginY;h.setTranslate(this.framework,n,i);var a={x:0,y:0,width:t._width,height:t._height};this.clipDef.select(\"rect\").attr(a),this.framework.select(\".bglayer\").select(\"rect\").attr(a).call(c.fill,t.bgcolor),this.xaxis._offset=n,this.xaxis._length=t._width,this.yaxis._offset=i,this.yaxis._length=t._height},w.drawTopo=function(t,e,r){if(!0===r[\"show\"+e]){var n=this.topojson,i=\"frame\"===e?b.sphereSVG:_(n,n.objects[e]);t.append(\"g\").datum(i).attr(\"class\",e).append(\"path\").attr(\"class\",\"basepath\")}},w.drawGraticule=function(t,e,r){var n=r[e];if(!0===n.showgrid){var a=b.scopeDefaults[r.scope],o=a.lonaxisRange,s=a.lataxisRange,l=\"lonaxis\"===e?[n.dtick]:[0,n.dtick],u=i(o,s,l);t.append(\"g\").datum(u).attr(\"class\",e+\"graticule\").append(\"path\").attr(\"class\",\"graticulepath\")}},w.drawLayout=function(t){var e,r=this.framework.select(\"g.baselayer\"),n=b.baseLayers,i=b.axesNames;r.selectAll(\"*\").remove();for(var a=0;a<n.length;a++)e=n[a],-1!==i.indexOf(e)?this.drawGraticule(r,e,t):this.drawTopo(r,e,t);this.styleLayout(t)},w.styleLayer=function(t,e,r){var n=b.fillLayers,i=b.lineLayers;-1!==n.indexOf(e)?a(t,e,r):-1!==i.indexOf(e)&&o(t,e,r)},w.styleLayout=function(t){for(var e,r=this.framework.select(\"g.baselayer\"),n=b.baseLayers,i=b.axesNames,a=0;a<n.length;a++)e=n[a],-1!==i.indexOf(e)?s(r,e,t):this.styleLayer(r,e,t)},w.isLonLatOverEdges=function(t){var e=this.clipAngle;if(null===e)return!1;var r=this.projection.rotate();return u.geo.distance(t,[-r[0],-r[1]])>e*Math.PI/180},w.render=function(){function t(t){var e=r.projection(t.lonlat);return e?\"translate(\"+e[0]+\",\"+e[1]+\")\":null}function e(t){return r.isLonLatOverEdges(t.lonlat)?\"0\":\"1.0\"}var r=this,n=r.framework,i=n.select(\"g.choroplethlayer\"),a=n.select(\"g.scattergeolayer\"),o=r.path;n.selectAll(\"path.basepath\").attr(\"d\",o),n.selectAll(\"path.graticulepath\").attr(\"d\",o),i.selectAll(\"path.choroplethlocation\").attr(\"d\",o),i.selectAll(\"path.basepath\").attr(\"d\",o),a.selectAll(\"path.js-line\").attr(\"d\",o),null!==r.clipAngle?(a.selectAll(\"path.point\").style(\"opacity\",e).attr(\"transform\",t),a.selectAll(\"text\").style(\"opacity\",e).attr(\"transform\",t)):(a.selectAll(\"path.point\").attr(\"transform\",t),a.selectAll(\"text\").attr(\"transform\",t))}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../lib/topojson_utils\":747,\"../cartesian/axes\":766,\"../plots\":829,\"./constants\":792,\"./projections\":800,\"./set_scale\":801,\"./zoom\":802,\"./zoom_reset\":803,d3:121,\"topojson-client\":535}],794:[function(t,e,r){\"use strict\";var n=t(\"./geo\"),i=t(\"../../plots/plots\");r.name=\"geo\",r.attr=\"geo\",r.idRoot=\"geo\",r.idRegex=/^geo([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^geo([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){var e=t._fullLayout,r=t.calcdata,a=i.getSubplotIds(e,\"geo\");void 0===window.PlotlyGeoAssets&&(window.PlotlyGeoAssets={topojson:{}});for(var o=0;o<a.length;o++){var s=a[o],l=i.getSubplotCalcData(r,\"geo\",s),u=e[s]._subplot;u||(u=new n({id:s,graphDiv:t,container:e._geolayer.node(),topojsonURL:t._context.topojsonURL}),e[s]._subplot=u),u.plot(l,e,t._promises)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"geo\"),o=0;o<a.length;o++){var s=a[o],l=n[s]._subplot;!e[s]&&l&&(l.framework.remove(),l.clipDef.remove())}}},{\"../../plots/plots\":829,\n",
       "\"./geo\":793,\"./layout/attributes\":795,\"./layout/defaults\":798,\"./layout/layout_attributes\":799}],795:[function(t,e,r){\"use strict\";e.exports={geo:{valType:\"subplotid\",dflt:\"geo\"}}},{}],796:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\");e.exports={range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},showgrid:{valType:\"boolean\",dflt:!1},tick0:{valType:\"number\"},dtick:{valType:\"number\"},gridcolor:{valType:\"color\",dflt:n.lightLine},gridwidth:{valType:\"number\",min:0,dflt:1}}},{\"../../../components/color/attributes\":602}],797:[function(t,e,r){\"use strict\";var n=t(\"../../../lib\"),i=t(\"../constants\"),a=t(\"./axis_attributes\");e.exports=function(t,e){function r(t,e){return n.coerce(o,s,a,t,e)}for(var o,s,l=i.axesNames,u=0;u<l.length;u++){var c=l[u];o=t[c]||{},s={};var h=function(t){var r,n,a,o,s,l,u=e.scope;return\"world\"===u?(r=e.projection,n=r.type,a=r.rotation,s=i[t+\"Span\"],l=void 0!==s[n]?s[n]/2:s[\"*\"]/2,o=\"lonaxis\"===t?a.lon:a.lat,[o-l,o+l]):i.scopeDefaults[u][t+\"Range\"]}(c),f=r(\"range\",h);n.noneOrAll(o.range,s.range,[0,1]),r(\"tick0\",f[0]),r(\"dtick\",\"lonaxis\"===c?30:10);r(\"showgrid\")&&(r(\"gridcolor\"),r(\"gridwidth\")),e[c]=s,e[c]._fullRange=h}}},{\"../../../lib\":725,\"../constants\":792,\"./axis_attributes\":796}],798:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i=r(\"scope\"),o=\"world\"!==i,l=a.scopeDefaults[i],u=r(\"resolution\"),c=r(\"projection.type\",l.projType),h=\"albers usa\"===c,f=-1!==c.indexOf(\"conic\");if(f){r(\"projection.parallels\",l.projParallels||[0,60])}if(h)e.scope=\"usa\";else{var d=l.projRotate||[0,0,0];r(\"projection.rotation.lon\",d[0]),r(\"projection.rotation.lat\",d[1]),r(\"projection.rotation.roll\",d[2]),n=r(\"showcoastlines\",!o),n&&(r(\"coastlinecolor\"),r(\"coastlinewidth\")),n=r(\"showocean\"),n&&r(\"oceancolor\")}r(\"projection.scale\"),n=r(\"showland\"),n&&r(\"landcolor\"),n=r(\"showlakes\"),n&&r(\"lakecolor\"),n=r(\"showrivers\"),n&&(r(\"rivercolor\"),r(\"riverwidth\")),n=r(\"showcountries\",o&&\"usa\"!==i),n&&(r(\"countrycolor\"),r(\"countrywidth\")),(\"usa\"===i||\"north america\"===i&&50===u)&&(r(\"showsubunits\",!0),r(\"subunitcolor\"),r(\"subunitwidth\")),o||(n=r(\"showframe\",!0))&&(r(\"framecolor\"),r(\"framewidth\")),r(\"bgcolor\"),s(t,e),e._isHighRes=50===u,e._clipAngle=a.lonaxisSpan[c]/2,e._isAlbersUsa=h,e._isConic=f,e._isScoped=o;var p=e.projection.rotation||{};e.projection._rotate=[-p.lon||0,-p.lat||0,p.roll||0]}var i=t(\"../../subplot_defaults\"),a=t(\"../constants\"),o=t(\"./layout_attributes\"),s=t(\"./axis_defaults\");e.exports=function(t,e,r){i(t,e,r,{type:\"geo\",attributes:o,handleDefaults:n,partition:\"y\"})}},{\"../../subplot_defaults\":836,\"../constants\":792,\"./axis_defaults\":797,\"./layout_attributes\":799}],799:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\"),i=t(\"../constants\"),a=t(\"./axis_attributes\");e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},resolution:{valType:\"enumerated\",values:[110,50],dflt:110,coerceNumber:!0},scope:{valType:\"enumerated\",values:Object.keys(i.scopeDefaults),dflt:\"world\"},projection:{type:{valType:\"enumerated\",values:Object.keys(i.projNames)},rotation:{lon:{valType:\"number\"},lat:{valType:\"number\"},roll:{valType:\"number\"}},parallels:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},scale:{valType:\"number\",min:0,max:10,dflt:1}},showcoastlines:{valType:\"boolean\"},coastlinecolor:{valType:\"color\",dflt:n.defaultLine},coastlinewidth:{valType:\"number\",min:0,dflt:1},showland:{valType:\"boolean\",dflt:!1},landcolor:{valType:\"color\",dflt:i.landColor},showocean:{valType:\"boolean\",dflt:!1},oceancolor:{valType:\"color\",dflt:i.waterColor},showlakes:{valType:\"boolean\",dflt:!1},lakecolor:{valType:\"color\",dflt:i.waterColor},showrivers:{valType:\"boolean\",dflt:!1},rivercolor:{valType:\"color\",dflt:i.waterColor},riverwidth:{valType:\"number\",min:0,dflt:1},showcountries:{valType:\"boolean\"},countrycolor:{valType:\"color\",dflt:n.defaultLine},countrywidth:{valType:\"number\",min:0,dflt:1},showsubunits:{valType:\"boolean\"},subunitcolor:{valType:\"color\",dflt:n.defaultLine},subunitwidth:{valType:\"number\",min:0,dflt:1},showframe:{valType:\"boolean\"},framecolor:{valType:\"color\",dflt:n.defaultLine},framewidth:{valType:\"number\",min:0,dflt:1},bgcolor:{valType:\"color\",dflt:n.background},lonaxis:a,lataxis:a}},{\"../../../components/color/attributes\":602,\"../constants\":792,\"./axis_attributes\":796}],800:[function(t,e,r){\"use strict\";function n(t){function e(t,e){return{type:\"Feature\",id:t.id,properties:t.properties,geometry:r(t.geometry,e)}}function r(e,n){if(!e)return null;if(\"GeometryCollection\"===e.type)return{type:\"GeometryCollection\",geometries:object.geometries.map(function(t){return r(t,n)})};if(!S.hasOwnProperty(e.type))return null;var i=S[e.type];return t.geo.stream(e,n(i)),i.result()}function n(){}function i(t){if((e=t.length)<4)return!1;for(var e,r=0,n=t[e-1][1]*t[0][0]-t[e-1][0]*t[0][1];++r<e;)n+=t[r-1][1]*t[r][0]-t[r-1][0]*t[r][1];return n<=0}function a(t,e){for(var r=e[0],n=e[1],i=!1,a=0,o=t.length,s=o-1;a<o;s=a++){var l=t[a],u=l[0],c=l[1],h=t[s],f=h[0],d=h[1];c>n^d>n&&r<(f-u)*(n-c)/(d-c)+u&&(i=!i)}return i}function o(t){return t?t/Math.sin(t):1}function s(t){return t>1?z:t<-1?-z:Math.asin(t)}function l(t){return t>1?0:t<-1?C:Math.acos(t)}function u(t,e){var r=(2+z)*Math.sin(e);e/=2;for(var n=0,i=1/0;n<10&&Math.abs(i)>E;n++){var a=Math.cos(e);e-=i=(e+Math.sin(e)*(a+2)-r)/(2*a*(1+a))}return[2/Math.sqrt(C*(4+C))*t*(1+Math.cos(e)),2*Math.sqrt(C/(4+C))*Math.sin(e)]}function c(t,e){function r(r,n){var i=R(r/e,n);return i[0]*=t,i}return arguments.length<2&&(e=t),1===e?R:e===1/0?f:(r.invert=function(r,n){var i=R.invert(r/t,n);return i[0]*=e,i},r)}function h(){var t=2,e=O(c),r=e(t);return r.coefficient=function(r){return arguments.length?e(t=+r):t},r}function f(t,e){return[t*Math.cos(e)/Math.cos(e/=2),2*Math.sin(e)]}function d(t,e){return[3*t/(2*C)*Math.sqrt(C*C/3-e*e),e]}function p(t,e){return[t,1.25*Math.log(Math.tan(C/4+.4*e))]}function m(t){return function(e){var r,n=t*Math.sin(e),i=30;do{e-=r=(e+Math.sin(e)-n)/(1+Math.cos(e))}while(Math.abs(r)>E&&--i>0);return e/2}}function v(t,e){var r=e*e,n=r*r;return[t*(.8707-.131979*r+n*(n*(.003971*r-.001529*n)-.013791)),e*(1.007226+r*(.015085+n*(.028874*r-.044475-.005916*n)))]}function g(t,e){var r,n=Math.min(18,36*Math.abs(e)/C),i=Math.floor(n),a=n-i,o=(r=j[i])[0],s=r[1],l=(r=j[++i])[0],u=r[1],c=(r=j[Math.min(19,++i)])[0],h=r[1];return[t*(l+a*(c-o)/2+a*a*(c-2*l+o)/2),(e>0?z:-z)*(u+a*(h-s)/2+a*a*(h-2*u+s)/2)]}function y(t,e){return[t*Math.cos(e),e]}function b(t,e){var r=Math.cos(e),n=o(l(r*Math.cos(t/=2)));return[2*r*Math.sin(t)*n,Math.sin(e)*n]}function x(t,e){var r=b(t,e);return[(r[0]+t/z)/2,(r[1]+e)/2]}t.geo.project=function(t,e){var n=e.stream;if(!n)throw new Error(\"not yet supported\");return(t&&_.hasOwnProperty(t.type)?_[t.type]:r)(t,n)};var _={Feature:e,FeatureCollection:function(t,r){return{type:\"FeatureCollection\",features:t.features.map(function(t){return e(t,r)})}}},w=[],M=[],k={point:function(t,e){w.push([t,e])},result:function(){var t=w.length?w.length<2?{type:\"Point\",coordinates:w[0]}:{type:\"MultiPoint\",coordinates:w}:null;return w=[],t}},A={lineStart:n,point:function(t,e){w.push([t,e])},lineEnd:function(){w.length&&(M.push(w),w=[])},result:function(){var t=M.length?M.length<2?{type:\"LineString\",coordinates:M[0]}:{type:\"MultiLineString\",coordinates:M}:null;return M=[],t}},T={polygonStart:n,lineStart:n,point:function(t,e){w.push([t,e])},lineEnd:function(){var t=w.length;if(t){do{w.push(w[0].slice())}while(++t<4);M.push(w),w=[]}},polygonEnd:n,result:function(){if(!M.length)return null;var t=[],e=[];return M.forEach(function(r){i(r)?t.push([r]):e.push(r)}),e.forEach(function(e){var r=e[0];t.some(function(t){if(a(t[0],r))return t.push(e),!0})||t.push([e])}),M=[],t.length?t.length>1?{type:\"MultiPolygon\",coordinates:t}:{type:\"Polygon\",coordinates:t[0]}:null}},S={Point:k,MultiPoint:k,LineString:A,MultiLineString:A,Polygon:T,MultiPolygon:T,Sphere:T},E=1e-6,L=E*E,C=Math.PI,z=C/2,I=(Math.sqrt(C),C/180),D=180/C,P=t.geo.projection,O=t.geo.projectionMutator;t.geo.interrupt=function(e){function r(t,r){for(var n=r<0?-1:1,i=l[+(r<0)],a=0,o=i.length-1;a<o&&t>i[a][2][0];++a);var s=e(t-i[a][1][0],r);return s[0]+=e(i[a][1][0],n*r>n*i[a][0][1]?i[a][0][1]:r)[0],s}function n(){s=l.map(function(t){return t.map(function(t){var r,n=e(t[0][0],t[0][1])[0],i=e(t[2][0],t[2][1])[0],a=e(t[1][0],t[0][1])[1],o=e(t[1][0],t[1][1])[1];return a>o&&(r=a,a=o,o=r),[[n,a],[i,o]]})})}function i(){for(var e=1e-6,r=[],n=0,i=l[0].length;n<i;++n){var o=l[0][n],s=180*o[0][0]/C,u=180*o[0][1]/C,c=180*o[1][1]/C,h=180*o[2][0]/C,f=180*o[2][1]/C;r.push(a([[s+e,u+e],[s+e,c-e],[h-e,c-e],[h-e,f+e]],30))}for(var n=l[1].length-1;n>=0;--n){var o=l[1][n],s=180*o[0][0]/C,u=180*o[0][1]/C,c=180*o[1][1]/C,h=180*o[2][0]/C,f=180*o[2][1]/C;r.push(a([[h-e,f-e],[h-e,c+e],[s+e,c+e],[s+e,u-e]],30))}return{type:\"Polygon\",coordinates:[t.merge(r)]}}function a(t,e){for(var r,n,i,a=-1,o=t.length,s=t[0],l=[];++a<o;){r=t[a],n=(r[0]-s[0])/e,i=(r[1]-s[1])/e;for(var u=0;u<e;++u)l.push([s[0]+u*n,s[1]+u*i]);s=r}return l.push(r),l}function o(t,e){return Math.abs(t[0]-e[0])<E&&Math.abs(t[1]-e[1])<E}var s,l=[[[[-C,0],[0,z],[C,0]]],[[[-C,0],[0,-z],[C,0]]]];e.invert&&(r.invert=function(t,n){for(var i=s[+(n<0)],a=l[+(n<0)],u=0,c=i.length;u<c;++u){var h=i[u];if(h[0][0]<=t&&t<h[1][0]&&h[0][1]<=n&&n<h[1][1]){var f=e.invert(t-e(a[u][1][0],0)[0],n);return f[0]+=a[u][1][0],o(r(f[0],f[1]),[t,n])?f:null}}});var u=t.geo.projection(r),c=u.stream;return u.stream=function(e){var r=u.rotate(),n=c(e),a=(u.rotate([0,0]),c(e));return u.rotate(r),n.sphere=function(){t.geo.stream(i(),a)},n},u.lobes=function(t){return arguments.length?(l=t.map(function(t){return t.map(function(t){return[[t[0][0]*C/180,t[0][1]*C/180],[t[1][0]*C/180,t[1][1]*C/180],[t[2][0]*C/180,t[2][1]*C/180]]})}),n(),u):l.map(function(t){return t.map(function(t){return[[180*t[0][0]/C,180*t[0][1]/C],[180*t[1][0]/C,180*t[1][1]/C],[180*t[2][0]/C,180*t[2][1]/C]]})})},u},u.invert=function(t,e){var r=.5*e*Math.sqrt((4+C)/C),n=s(r),i=Math.cos(n);return[t/(2/Math.sqrt(C*(4+C))*(1+i)),s((n+r*(i+2))/(2+z))]},(t.geo.eckert4=function(){return P(u)}).raw=u;var R=t.geo.azimuthalEqualArea.raw;f.invert=function(t,e){var r=2*s(e/2);return[t*Math.cos(r/2)/Math.cos(r),r]},(t.geo.hammer=h).raw=c,d.invert=function(t,e){return[2/3*C*t/Math.sqrt(C*C/3-e*e),e]},(t.geo.kavrayskiy7=function(){return P(d)}).raw=d,p.invert=function(t,e){return[t,2.5*Math.atan(Math.exp(.8*e))-.625*C]},(t.geo.miller=function(){return P(p)}).raw=p;var F=(m(C),function(t,e,r){function n(r,n){return[t*r*Math.cos(n=i(n)),e*Math.sin(n)]}var i=m(r);return n.invert=function(n,i){var a=s(i/e);return[n/(t*Math.cos(a)),s((2*a+Math.sin(2*a))/r)]},n}(Math.SQRT2/z,Math.SQRT2,C));(t.geo.mollweide=function(){return P(F)}).raw=F,v.invert=function(t,e){var r,n=e,i=25;do{var a=n*n,o=a*a;n-=r=(n*(1.007226+a*(.015085+o*(.028874*a-.044475-.005916*o)))-e)/(1.007226+a*(.045255+o*(.259866*a-.311325-.005916*11*o)))}while(Math.abs(r)>E&&--i>0);return[t/(.8707+(a=n*n)*(a*(a*a*a*(.003971-.001529*a)-.013791)-.131979)),n]},(t.geo.naturalEarth=function(){return P(v)}).raw=v;var j=[[.9986,-.062],[1,0],[.9986,.062],[.9954,.124],[.99,.186],[.9822,.248],[.973,.31],[.96,.372],[.9427,.434],[.9216,.4958],[.8962,.5571],[.8679,.6176],[.835,.6769],[.7986,.7346],[.7597,.7903],[.7186,.8435],[.6732,.8936],[.6213,.9394],[.5722,.9761],[.5322,1]];j.forEach(function(t){t[1]*=1.0144}),g.invert=function(t,e){var r=e/z,n=90*r,i=Math.min(18,Math.abs(n/5)),a=Math.max(0,Math.floor(i));do{var o=j[a][1],s=j[a+1][1],l=j[Math.min(19,a+2)][1],u=l-o,c=l-2*s+o,h=2*(Math.abs(r)-s)/u,f=c/u,d=h*(1-f*h*(1-2*f*h));if(d>=0||1===a){n=(e>=0?5:-5)*(d+i);var p,m=50;do{i=Math.min(18,Math.abs(n)/5),a=Math.floor(i),d=i-a,o=j[a][1],s=j[a+1][1],l=j[Math.min(19,a+2)][1],n-=(p=(e>=0?z:-z)*(s+d*(l-o)/2+d*d*(l-2*s+o)/2)-e)*D}while(Math.abs(p)>L&&--m>0);break}}while(--a>=0);var v=j[a][0],g=j[a+1][0],y=j[Math.min(19,a+2)][0];return[t/(g+d*(y-v)/2+d*d*(y-2*g+v)/2),n*I]},(t.geo.robinson=function(){return P(g)}).raw=g,y.invert=function(t,e){return[t/Math.cos(e),e]},(t.geo.sinusoidal=function(){return P(y)}).raw=y,b.invert=function(t,e){if(!(t*t+4*e*e>C*C+E)){var r=t,n=e,i=25;do{var a,o=Math.sin(r),s=Math.sin(r/2),u=Math.cos(r/2),c=Math.sin(n),h=Math.cos(n),f=Math.sin(2*n),d=c*c,p=h*h,m=s*s,v=1-p*u*u,g=v?l(h*u)*Math.sqrt(a=1/v):a=0,y=2*g*h*s-t,b=g*c-e,x=a*(p*m+g*h*u*d),_=a*(.5*o*f-2*g*c*s),w=.25*a*(f*s-g*c*p*o),M=a*(d*u+g*m*h),k=_*w-M*x;if(!k)break;var A=(b*_-y*M)/k,T=(y*w-b*x)/k;r-=A,n-=T}while((Math.abs(A)>E||Math.abs(T)>E)&&--i>0);return[r,n]}},(t.geo.aitoff=function(){return P(b)}).raw=b,x.invert=function(t,e){var r=t,n=e,i=25;do{var a,o=Math.cos(n),s=Math.sin(n),u=Math.sin(2*n),c=s*s,h=o*o,f=Math.sin(r),d=Math.cos(r/2),p=Math.sin(r/2),m=p*p,v=1-h*d*d,g=v?l(o*d)*Math.sqrt(a=1/v):a=0,y=.5*(2*g*o*p+r/z)-t,b=.5*(g*s+n)-e,x=.5*a*(h*m+g*o*d*c)+.5/z,_=a*(f*u/4-g*s*p),w=.125*a*(u*p-g*s*h*f),M=.5*a*(c*d+g*m*o)+.5,k=_*w-M*x,A=(b*_-y*M)/k,T=(y*w-b*x)/k;r-=A,n-=T}while((Math.abs(A)>E||Math.abs(T)>E)&&--i>0);return[r,n]},(t.geo.winkel3=function(){return P(x)}).raw=x}e.exports=n},{}],801:[function(t,e,r){\"use strict\";function n(t,e){var r=t.projection,n=t.lonaxis,o=t.lataxis,l=t.domain,u=t.framewidth||0,c=e.w*(l.x[1]-l.x[0]),h=e.h*(l.y[1]-l.y[0]),f=n.range[0]+s,d=n.range[1]-s,p=o.range[0]+s,m=o.range[1]-s,v=n._fullRange[0]+s,g=n._fullRange[1]-s,y=o._fullRange[0]+s,b=o._fullRange[1]-s;r._translate0=[e.l+c/2,e.t+h/2];var x=d-f,_=m-p,w=[f+x/2,p+_/2],M=r._rotate;return r._center=[w[0]+M[0],w[1]+M[1]],function(e){function n(t){return Math.min(_*c/(t[1][0]-t[0][0]),_*h/(t[1][1]-t[0][1]))}var o,s,l,x,_=e.scale(),w=r._translate0,M=i(f,p,d,m),k=i(v,y,g,b);l=a(e,M),o=n(l),x=a(e,k),r._fullScale=n(x),e.scale(o),l=a(e,M),s=[w[0]-l[0][0]+u,w[1]-l[0][1]+u],r._translate=s,e.translate(s),l=a(e,M),t._isAlbersUsa||e.clipExtent(l),o=r.scale*o,r._scale=o,t._width=Math.round(l[1][0])+u,t._height=Math.round(l[1][1])+u,t._marginX=(c-Math.round(l[1][0]))/2,t._marginY=(h-Math.round(l[1][1]))/2}}function i(t,e,r,n){var i=(r-t)/4;return{type:\"Polygon\",coordinates:[[[t,e],[t,n],[t+i,n],[t+2*i,n],[t+3*i,n],[r,n],[r,e],[r-i,e],[r-2*i,e],[r-3*i,e],[t,e]]]}}function a(t,e){return o.geo.path().projection(t).bounds(e)}var o=t(\"d3\"),s=t(\"./constants\").clipPad;e.exports=n},{\"./constants\":792,d3:121}],802:[function(t,e,r){\"use strict\";function n(t,e){return(e._isScoped?a:e._clipAngle?s:o)(t,e.projection)}function i(t,e){var r=e._fullScale;return _.behavior.zoom().translate(t.translate()).scale(t.scale()).scaleExtent([.5*r,100*r])}function a(t,e){function r(){_.select(this).style(k)}function n(){o.scale(_.event.scale).translate(_.event.translate),t.render()}function a(){_.select(this).style(A)}var o=t.projection,s=i(o,e);return s.on(\"zoomstart\",r).on(\"zoom\",n).on(\"zoomend\",a),s}function o(t,e){function r(t){return v.invert(t)}function n(t){var e=v(r(t));return Math.abs(e[0]-t[0])>y||Math.abs(e[1]-t[1])>y}function a(){_.select(this).style(k),l=_.mouse(this),u=v.rotate(),c=v.translate(),h=u,f=r(l)}function o(){if(d=_.mouse(this),n(l))return g.scale(v.scale()),void g.translate(v.translate());v.scale(_.event.scale),v.translate([c[0],_.event.translate[1]]),f?r(d)&&(m=r(d),p=[h[0]+(m[0]-f[0]),u[1],u[2]],v.rotate(p),h=p):(l=d,f=r(l)),t.render()}function s(){_.select(this).style(A)}var l,u,c,h,f,d,p,m,v=t.projection,g=i(v,e),y=2;return g.on(\"zoomstart\",a).on(\"zoom\",o).on(\"zoomend\",s),g}function s(t,e){function r(t){g++||t({type:\"zoomstart\"})}function n(t){t({type:\"zoom\"})}function a(t){--g||t({type:\"zoomend\"})}var o,s=t.projection,d={r:s.rotate(),k:s.scale()},p=i(s,e),m=x(p,\"zoomstart\",\"zoom\",\"zoomend\"),g=0,y=p.on;return p.on(\"zoomstart\",function(){_.select(this).style(k);var t=_.mouse(this),e=s.rotate(),i=e,a=s.translate(),g=u(e);o=l(s,t),y.call(p,\"zoom\",function(){var r=_.mouse(this);if(s.scale(d.k=_.event.scale),o){if(l(s,r)){s.rotate(e).translate(a);var u=l(s,r),p=h(o,u),y=v(c(g,p)),b=d.r=f(y,o,i);isFinite(b[0])&&isFinite(b[1])&&isFinite(b[2])||(b=i),s.rotate(b),i=b}}else t=r,o=l(s,t);n(m.of(this,arguments))}),r(m.of(this,arguments))}).on(\"zoomend\",function(){_.select(this).style(A),y.call(p,\"zoom\",null),a(m.of(this,arguments))}).on(\"zoom.redraw\",function(){t.render()}),_.rebind(p,m,\"on\")}function l(t,e){var r=t.invert(e);return r&&isFinite(r[0])&&isFinite(r[1])&&g(r)}function u(t){var e=.5*t[0]*w,r=.5*t[1]*w,n=.5*t[2]*w,i=Math.sin(e),a=Math.cos(e),o=Math.sin(r),s=Math.cos(r),l=Math.sin(n),u=Math.cos(n);return[a*s*u+i*o*l,i*s*u-a*o*l,a*o*u+i*s*l,a*s*l-i*o*u]}function c(t,e){var r=t[0],n=t[1],i=t[2],a=t[3],o=e[0],s=e[1],l=e[2],u=e[3];return[r*o-n*s-i*l-a*u,r*s+n*o+i*u-a*l,r*l-n*u+i*o+a*s,r*u+n*l-i*s+a*o]}function h(t,e){if(t&&e){var r=b(t,e),n=Math.sqrt(y(r,r)),i=.5*Math.acos(Math.max(-1,Math.min(1,y(t,e)))),a=Math.sin(i)/n;return n&&[Math.cos(i),r[2]*a,-r[1]*a,r[0]*a]}}function f(t,e,r){var n=m(e,2,t[0]);n=m(n,1,t[1]),n=m(n,0,t[2]-r[2]);var i,a,o=e[0],s=e[1],l=e[2],u=n[0],c=n[1],h=n[2],f=Math.atan2(s,o)*M,p=Math.sqrt(o*o+s*s);Math.abs(c)>p?(a=(c>0?90:-90)-f,i=0):(a=Math.asin(c/p)*M-f,i=Math.sqrt(p*p-c*c));var v=180-a-2*f,g=(Math.atan2(h,u)-Math.atan2(l,i))*M,y=(Math.atan2(h,u)-Math.atan2(l,-i))*M;return d(r[0],r[1],a,g)<=d(r[0],r[1],v,y)?[a,g,r[2]]:[v,y,r[2]]}function d(t,e,r,n){var i=p(r-t),a=p(n-e);return Math.sqrt(i*i+a*a)}function p(t){return(t%360+540)%360-180}function m(t,e,r){var n=r*w,i=t.slice(),a=0===e?1:0,o=2===e?1:2,s=Math.cos(n),l=Math.sin(n);return i[a]=t[a]*s-t[o]*l,i[o]=t[o]*s+t[a]*l,i}function v(t){return[Math.atan2(2*(t[0]*t[1]+t[2]*t[3]),1-2*(t[1]*t[1]+t[2]*t[2]))*M,Math.asin(Math.max(-1,Math.min(1,2*(t[0]*t[2]-t[3]*t[1]))))*M,Math.atan2(2*(t[0]*t[3]+t[1]*t[2]),1-2*(t[2]*t[2]+t[3]*t[3]))*M]}function g(t){var e=t[0]*w,r=t[1]*w,n=Math.cos(r);return[n*Math.cos(e),n*Math.sin(e),Math.sin(r)]}function y(t,e){for(var r=0,n=0,i=t.length;n<i;++n)r+=t[n]*e[n];return r}function b(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]}function x(t){for(var e=0,r=arguments.length,n=[];++e<r;)n.push(arguments[e]);var i=_.dispatch.apply(null,n);return i.of=function(e,r){return function(n){var a;try{a=n.sourceEvent=_.event,n.target=t,_.event=n,i[n.type].apply(e,r)}finally{_.event=a}}},i}var _=t(\"d3\"),w=Math.PI/180,M=180/Math.PI,k={cursor:\"pointer\"},A={cursor:\"auto\"};e.exports=n},{d3:121}],803:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r=t.projection,n=t.zoom;return function(){t.makeProjection(e),t.makePath(),n.scale(r.scale()),n.translate(r.translate()),t.render()}}},{}],804:[function(t,e,r){\"use strict\";function n(t,e){this.element=t,this.plot=e,this.mouseListener=null,this.wheelListener=null,this.lastInputTime=Date.now(),this.lastPos=[0,0],this.boxEnabled=!1,this.boxInited=!1,this.boxStart=[0,0],this.boxEnd=[0,0],this.dragStart=[0,0]}function i(t){function e(){t.xaxis.autorange=!1,t.yaxis.autorange=!1}function r(){for(var e=t.graphDiv._fullLayout._axisConstraintGroups,r=t.xaxis._id,n=t.yaxis._id,i=0;i<e.length;i++)if(-1!==e[i][r]){if(-1!==e[i][n])return!0;break}return!1}function i(n,i,a){function o(e,r,n){var i=Math.min(r,n),a=Math.max(r,n);i!==a?(f[e]=i,f[e+2]=a,h.dataBox=f,t.setRanges(f)):(t.selectBox.selectBox=[0,0,1,1],t.glplot.setDirty())}var s,u,f=t.calcDataBox(),d=c.viewBox,p=h.lastPos[0],m=h.lastPos[1],v=l.MINDRAG*c.pixelRatio,g=l.MINZOOM*c.pixelRatio;switch(i*=c.pixelRatio,a*=c.pixelRatio,a=d[3]-d[1]-a,t.fullLayout.dragmode){case\"zoom\":if(n){var y=i/(d[2]-d[0])*(f[2]-f[0])+f[0],b=a/(d[3]-d[1])*(f[3]-f[1])+f[1];h.boxInited||(h.boxStart[0]=y,h.boxStart[1]=b,h.dragStart[0]=i,h.dragStart[1]=a),h.boxEnd[0]=y,h.boxEnd[1]=b,h.boxInited=!0,h.boxEnabled||h.boxStart[0]===h.boxEnd[0]&&h.boxStart[1]===h.boxEnd[1]||(h.boxEnabled=!0);var x=Math.abs(h.dragStart[0]-i)<g,_=Math.abs(h.dragStart[1]-a)<g;if(!r()||x&&_)x&&(h.boxEnd[0]=h.boxStart[0]),_&&(h.boxEnd[1]=h.boxStart[1]);else{s=h.boxEnd[0]-h.boxStart[0],u=h.boxEnd[1]-h.boxStart[1];var w=(f[3]-f[1])/(f[2]-f[0]);Math.abs(s*w)>Math.abs(u)?(h.boxEnd[1]=h.boxStart[1]+Math.abs(s)*w*(u>=0?1:-1),h.boxEnd[1]<f[1]?(h.boxEnd[1]=f[1],h.boxEnd[0]=h.boxStart[0]+(f[1]-h.boxStart[1])/Math.abs(w)):h.boxEnd[1]>f[3]&&(h.boxEnd[1]=f[3],h.boxEnd[0]=h.boxStart[0]+(f[3]-h.boxStart[1])/Math.abs(w))):(h.boxEnd[0]=h.boxStart[0]+Math.abs(u)/w*(s>=0?1:-1),h.boxEnd[0]<f[0]?(h.boxEnd[0]=f[0],h.boxEnd[1]=h.boxStart[1]+(f[0]-h.boxStart[0])*Math.abs(w)):h.boxEnd[0]>f[2]&&(h.boxEnd[0]=f[2],h.boxEnd[1]=h.boxStart[1]+(f[2]-h.boxStart[0])*Math.abs(w)))}}else h.boxEnabled?(s=h.boxStart[0]!==h.boxEnd[0],u=h.boxStart[1]!==h.boxEnd[1],s||u?(s&&(o(0,h.boxStart[0],h.boxEnd[0]),t.xaxis.autorange=!1),u&&(o(1,h.boxStart[1],h.boxEnd[1]),t.yaxis.autorange=!1),t.relayoutCallback()):t.glplot.setDirty(),h.boxEnabled=!1,h.boxInited=!1):h.boxInited&&(h.boxInited=!1);break;case\"pan\":h.boxEnabled=!1,h.boxInited=!1,n?(h.panning||(h.dragStart[0]=i,h.dragStart[1]=a),Math.abs(h.dragStart[0]-i)<v&&(i=h.dragStart[0]),Math.abs(h.dragStart[1]-a)<v&&(a=h.dragStart[1]),s=(p-i)*(f[2]-f[0])/(c.viewBox[2]-c.viewBox[0]),u=(m-a)*(f[3]-f[1])/(c.viewBox[3]-c.viewBox[1]),f[0]+=s,f[2]+=s,f[1]+=u,f[3]+=u,t.setRanges(f),h.panning=!0,h.lastInputTime=Date.now(),e(),t.cameraChanged(),t.handleAnnotations()):h.panning&&(h.panning=!1,t.relayoutCallback())}h.lastPos[0]=i,h.lastPos[1]=a}var u=t.mouseContainer,c=t.glplot,h=new n(u,c);return h.mouseListener=a(u,i),u.addEventListener(\"touchstart\",function(t){var e=s(t.changedTouches[0],u);i(0,e[0],e[1]),i(1,e[0],e[1])}),u.addEventListener(\"touchmove\",function(t){t.preventDefault();var e=s(t.changedTouches[0],u);i(1,e[0],e[1])}),u.addEventListener(\"touchend\",function(){i(0,h.lastPos[0],h.lastPos[1])}),h.wheelListener=o(u,function(r,n){var i=t.calcDataBox(),a=c.viewBox,o=h.lastPos[0],s=h.lastPos[1];switch(t.fullLayout.dragmode){case\"zoom\":break;case\"pan\":var l=Math.exp(.1*n/(a[3]-a[1])),u=o/(a[2]-a[0])*(i[2]-i[0])+i[0],f=s/(a[3]-a[1])*(i[3]-i[1])+i[1];i[0]=(i[0]-u)*l+u,i[2]=(i[2]-u)*l+u,i[1]=(i[1]-f)*l+f,i[3]=(i[3]-f)*l+f,t.setRanges(i),h.lastInputTime=Date.now(),e(),t.cameraChanged(),t.handleAnnotations(),t.relayoutCallback()}return!0}),h}var a=t(\"mouse-change\"),o=t(\"mouse-wheel\"),s=t(\"mouse-event-offset\"),l=t(\"../cartesian/constants\");e.exports=i},{\"../cartesian/constants\":771,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454}],805:[function(t,e,r){\"use strict\";function n(t){this.scene=t,this.gl=t.gl,this.pixelRatio=t.pixelRatio,this.screenBox=[0,0,1,1],this.viewBox=[0,0,1,1],this.dataBox=[-1,-1,1,1],this.borderLineEnable=[!1,!1,!1,!1],this.borderLineWidth=[1,1,1,1],this.borderLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.ticks=[[],[]],this.tickEnable=[!0,!0,!1,!1],this.tickPad=[15,15,15,15],this.tickAngle=[0,0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickMarkLength=[0,0,0,0],this.tickMarkWidth=[0,0,0,0],this.tickMarkColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labels=[\"x\",\"y\"],this.labelEnable=[!0,!0,!1,!1],this.labelAngle=[0,Math.PI/2,0,3*Math.PI/2],this.labelPad=[15,15,15,15],this.labelSize=[12,12],this.labelFont=[\"sans-serif\",\"sans-serif\"],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.title=\"\",this.titleEnable=!0,this.titleCenter=[0,0,0,0],this.titleAngle=0,this.titleColor=[0,0,0,1],this.titleFont=\"sans-serif\",this.titleSize=18,this.gridLineEnable=[!0,!0],this.gridLineColor=[[0,0,0,.5],[0,0,0,.5]],this.gridLineWidth=[1,1],this.zeroLineEnable=[!0,!0],this.zeroLineWidth=[1,1],this.zeroLineColor=[[0,0,0,1],[0,0,0,1]],this.borderColor=[0,0,0,0],this.backgroundColor=[0,0,0,0],this.static=this.scene.staticPlot}function i(t){return new n(t)}var a=t(\"../plots\"),o=t(\"../cartesian/axes\"),s=t(\"../../lib/html2unicode\"),l=t(\"../../lib/str2rgbarray\"),u=n.prototype,c=[\"xaxis\",\"yaxis\"];u.merge=function(t){this.titleEnable=!1,this.backgroundColor=l(t.plot_bgcolor);var e,r,n,i,a,o,u,h,f,d,p;for(d=0;d<2;++d){for(e=c[d],r=t[this.scene[e]._name],n=/Click to enter .+ title/.test(r.title)?\"\":r.title,p=0;p<=2;p+=2)this.labelEnable[d+p]=!1,this.labels[d+p]=s(n),this.labelColor[d+p]=l(r.titlefont.color),this.labelFont[d+p]=r.titlefont.family,this.labelSize[d+p]=r.titlefont.size,this.labelPad[d+p]=this.getLabelPad(e,r),this.tickEnable[d+p]=!1,this.tickColor[d+p]=l((r.tickfont||{}).color),this.tickAngle[d+p]=\"auto\"===r.tickangle?0:Math.PI*-r.tickangle/180,this.tickPad[d+p]=this.getTickPad(r),this.tickMarkLength[d+p]=0,this.tickMarkWidth[d+p]=r.tickwidth||0,this.tickMarkColor[d+p]=l(r.tickcolor),this.borderLineEnable[d+p]=!1,this.borderLineColor[d+p]=l(r.linecolor),this.borderLineWidth[d+p]=r.linewidth||0;u=this.hasSharedAxis(r),a=this.hasAxisInDfltPos(e,r)&&!u,o=this.hasAxisInAltrPos(e,r)&&!u,i=r.mirror||!1,h=u?-1!==String(i).indexOf(\"all\"):!!i,f=u?\"allticks\"===i:-1!==String(i).indexOf(\"ticks\"),a?this.labelEnable[d]=!0:o&&(this.labelEnable[d+2]=!0),a?this.tickEnable[d]=r.showticklabels:o&&(this.tickEnable[d+2]=r.showticklabels),(a||h)&&(this.borderLineEnable[d]=r.showline),(o||h)&&(this.borderLineEnable[d+2]=r.showline),(a||f)&&(this.tickMarkLength[d]=this.getTickMarkLength(r)),(o||f)&&(this.tickMarkLength[d+2]=this.getTickMarkLength(r)),this.gridLineEnable[d]=r.showgrid,this.gridLineColor[d]=l(r.gridcolor),this.gridLineWidth[d]=r.gridwidth,this.zeroLineEnable[d]=r.zeroline,this.zeroLineColor[d]=l(r.zerolinecolor),this.zeroLineWidth[d]=r.zerolinewidth}},u.hasSharedAxis=function(t){var e=this.scene,r=a.getSubplotIds(e.fullLayout,\"gl2d\");return 0!==o.findSubplotsWithAxis(r,t).indexOf(e.id)},u.hasAxisInDfltPos=function(t,e){var r=e.side;return\"xaxis\"===t?\"bottom\"===r:\"yaxis\"===t?\"left\"===r:void 0},u.hasAxisInAltrPos=function(t,e){var r=e.side;return\"xaxis\"===t?\"top\"===r:\"yaxis\"===t?\"right\"===r:void 0},u.getLabelPad=function(t,e){var r=e.titlefont.size,n=e.showticklabels;return\"xaxis\"===t?\"top\"===e.side?r*(1.5+(n?1:0))-10:r*(1.5+(n?.5:0))-10:\"yaxis\"===t?\"right\"===e.side?10+r*(1.5+(n?1:.5)):10+r*(1.5+(n?.5:0)):void 0},u.getTickPad=function(t){return\"outside\"===t.ticks?10+t.ticklen:15},u.getTickMarkLength=function(t){if(!t.ticks)return 0;var e=t.ticklen;return\"inside\"===t.ticks?-e:e},e.exports=i},{\"../../lib/html2unicode\":723,\"../../lib/str2rgbarray\":744,\"../cartesian/axes\":766,\"../plots\":829}],806:[function(t,e,r){\"use strict\";var n=t(\"./scene2d\"),i=t(\"../plots\"),a=t(\"../../constants/xmlns_namespaces\"),o=t(\"../cartesian/constants\"),s=t(\"../cartesian\");r.name=\"gl2d\",r.attr=[\"xaxis\",\"yaxis\"],r.idRoot=[\"x\",\"y\"],r.idRegex=o.idRegex,r.attrRegex=o.attrRegex,r.attributes=t(\"../cartesian/attributes\"),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,a=i.getSubplotIds(e,\"gl2d\"),o=0;o<a.length;o++){var s=a[o],l=e._plots[s],u=i.getSubplotData(r,\"gl2d\",s),c=l._scene2d;void 0===c&&(c=new n({id:s,graphDiv:t,container:t.querySelector(\".gl-container\"),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio},e),l._scene2d=c),c.plot(u,t.calcdata,e,t.layout)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"gl2d\"),o=0;o<a.length;o++){var l=a[o],u=n._plots[l];if(u._scene2d){0===i.getSubplotData(t,\"gl2d\",l).length&&(u._scene2d.destroy(),delete n._plots[l])}}s.clean.apply(this,arguments)},r.drawFramework=function(t){t._context.staticPlot||s.drawFramework(t)},r.toSVG=function(t){for(var e=t._fullLayout,r=i.getSubplotIds(e,\"gl2d\"),n=0;n<r.length;n++){var o=e._plots[r[n]],s=o._scene2d,l=s.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:a.svg,\"xlink:href\":l,x:0,y:0,width:\"100%\",height:\"100%\",preserveAspectRatio:\"none\"}),s.destroy()}}},{\"../../constants/xmlns_namespaces\":707,\"../cartesian\":776,\"../cartesian/attributes\":765,\"../cartesian/constants\":771,\"../plots\":829,\"./scene2d\":807}],807:[function(t,e,r){\"use strict\";function n(t,e){this.container=t.container,this.graphDiv=t.graphDiv,this.pixelRatio=t.plotGlPixelRatio||window.devicePixelRatio,this.id=t.id,this.staticPlot=!!t.staticPlot,this.fullData=null,this.updateRefs(e),this.makeFramework(),this.glplotOptions=p(this),this.glplotOptions.merge(e),this.glplot=c(this.glplotOptions),this.camera=m(this),this.traces={},this.spikes=h(this.glplot),this.selectBox=f(this.glplot,{innerFill:!1,outerFill:!0}),this.lastButtonState=0,this.pickResult=null,this.isMouseOver=!0,this.bounds=[1/0,1/0,-1/0,-1/0],this.stopped=!1,this.redraw=this.draw.bind(this),this.redraw()}function i(t,e){for(var r=0;r<2;++r){var n=t[r],i=e[r];if(n.length!==i.length)return!0;for(var a=0;a<n.length;++a)if(n[a].x!==i[a].x)return!0}return!1}var a,o,s=t(\"../../registry\"),l=t(\"../../plots/cartesian/axes\"),u=t(\"../../components/fx\"),c=t(\"gl-plot2d\"),h=t(\"gl-spikes2d\"),f=t(\"gl-select-box\"),d=t(\"webgl-context\"),p=t(\"./convert\"),m=t(\"./camera\"),v=t(\"../../lib/html2unicode\"),g=t(\"../../lib/show_no_webgl_msg\"),y=t(\"../../plots/cartesian/constraints\"),b=y.enforce,x=y.clean,_=[\"xaxis\",\"yaxis\"];e.exports=n;var w=n.prototype;w.makeFramework=function(){if(this.staticPlot){if(!(o||(a=document.createElement(\"canvas\"),o=d({canvas:a,preserveDrawingBuffer:!1,premultipliedAlpha:!0,antialias:!0}))))throw new Error(\"Error creating static canvas/context for image server\");this.canvas=a,this.gl=o}else{var t=document.createElement(\"canvas\"),e=d({canvas:t,premultipliedAlpha:!0});e||g(this),this.canvas=t,this.gl=e}var r=this.canvas;r.style.width=\"100%\",r.style.height=\"100%\",r.style.position=\"absolute\",r.style.top=\"0px\",r.style.left=\"0px\",r.style[\"pointer-events\"]=\"none\",this.updateSize(r),r.className+=\"user-select-none\";var n=this.svgContainer=document.createElementNS(\"http://www.w3.org/2000/svg\",\"svg\");n.style.position=\"absolute\",n.style.top=n.style.left=\"0px\",n.style.width=n.style.height=\"100%\",n.style[\"z-index\"]=20,n.style[\"pointer-events\"]=\"none\";var i=this.mouseContainer=document.createElement(\"div\");i.style.position=\"absolute\",i.style[\"pointer-events\"]=\"auto\";var s=this.container;s.appendChild(r),s.appendChild(n),s.appendChild(i);var l=this;i.addEventListener(\"mouseout\",function(){l.isMouseOver=!1,l.unhover()}),i.addEventListener(\"mouseover\",function(){l.isMouseOver=!0})},w.toImage=function(t){t||(t=\"png\"),this.stopped=!0,this.staticPlot&&this.container.appendChild(a),this.updateSize(this.canvas),this.glplot.setDirty(),this.glplot.draw();var e=this.glplot.gl,r=e.drawingBufferWidth,n=e.drawingBufferHeight;e.bindFramebuffer(e.FRAMEBUFFER,null);var i=new Uint8Array(r*n*4);e.readPixels(0,0,r,n,e.RGBA,e.UNSIGNED_BYTE,i);for(var o=0,s=n-1;o<s;++o,--s)for(var l=0;l<r;++l)for(var u=0;u<4;++u){var c=i[4*(r*o+l)+u];i[4*(r*o+l)+u]=i[4*(r*s+l)+u],i[4*(r*s+l)+u]=c}var h=document.createElement(\"canvas\");h.width=r,h.height=n;var f=h.getContext(\"2d\"),d=f.createImageData(r,n);d.data.set(i),f.putImageData(d,0,0);var p;switch(t){case\"jpeg\":p=h.toDataURL(\"image/jpeg\");break;case\"webp\":p=h.toDataURL(\"image/webp\");break;default:p=h.toDataURL(\"image/png\")}return this.staticPlot&&this.container.removeChild(a),p},w.updateSize=function(t){t||(t=this.canvas);var e=this.pixelRatio,r=this.fullLayout,n=r.width,i=r.height,a=0|Math.ceil(e*n),o=0|Math.ceil(e*i);return t.width===a&&t.height===o||(t.width=a,t.height=o),this.redraw&&this.redraw(),t},w.computeTickMarks=function(){this.xaxis.setScale(),this.yaxis.setScale();for(var t=[l.calcTicks(this.xaxis),l.calcTicks(this.yaxis)],e=0;e<2;++e)for(var r=0;r<t[e].length;++r)t[e][r].text=v(t[e][r].text+\"\");return t},w.updateRefs=function(t){this.fullLayout=t;var e=l.subplotMatch,r=\"xaxis\"+this.id.match(e)[1],n=\"yaxis\"+this.id.match(e)[2];this.xaxis=this.fullLayout[r],this.yaxis=this.fullLayout[n]},w.relayoutCallback=function(){var t=this.graphDiv,e=this.xaxis,r=this.yaxis,n=t.layout;n.xaxis.autorange=e.autorange,n.xaxis.range=e.range.slice(0),n.yaxis.autorange=r.autorange,n.yaxis.range=r.range.slice(0);var i={lastInputTime:this.camera.lastInputTime};i[e._name]=e.range.slice(0),i[r._name]=r.range.slice(0),t.emit(\"plotly_relayout\",i)},w.cameraChanged=function(){var t=this.camera;this.glplot.setDataBox(this.calcDataBox());var e=this.computeTickMarks()\n",
       ";i(e,this.glplotOptions.ticks)&&(this.glplotOptions.ticks=e,this.glplotOptions.dataBox=t.dataBox,this.glplot.update(this.glplotOptions),this.handleAnnotations())},w.handleAnnotations=function(){for(var t=this.graphDiv,e=this.fullLayout.annotations,r=0;r<e.length;r++){var n=e[r];n.xref===this.xaxis._id&&n.yref===this.yaxis._id&&s.getComponentMethod(\"annotations\",\"drawOne\")(t,r)}},w.destroy=function(){if(this.glplot){var t=this.traces;t&&Object.keys(t).map(function(e){t[e].dispose(),delete t[e]}),this.glplot.dispose(),this.staticPlot||this.container.removeChild(this.canvas),this.container.removeChild(this.svgContainer),this.container.removeChild(this.mouseContainer),this.fullData=null,this.glplot=null,this.stopped=!0,this.camera.mouseListener.enabled=!1,this.mouseContainer.removeEventListener(\"wheel\",this.camera.wheelListener),this.camera=null}},w.plot=function(t,e,r){var n=this.glplot;this.updateRefs(r),this.updateTraces(t,e),this.updateFx(r.dragmode);var i=r.width,a=r.height;this.updateSize(this.canvas);var o=this.glplotOptions;o.merge(r),o.screenBox=[0,0,i,a];var s={_fullLayout:{_axisConstraintGroups:this.graphDiv._fullLayout._axisConstraintGroups,xaxis:this.xaxis,yaxis:this.yaxis}};x(s,this.xaxis),x(s,this.yaxis);var u=r._size,c=this.xaxis.domain,h=this.yaxis.domain;o.viewBox=[u.l+c[0]*u.w,u.b+h[0]*u.h,i-u.r-(1-c[1])*u.w,a-u.t-(1-h[1])*u.h],this.mouseContainer.style.width=u.w*(c[1]-c[0])+\"px\",this.mouseContainer.style.height=u.h*(h[1]-h[0])+\"px\",this.mouseContainer.height=u.h*(h[1]-h[0]),this.mouseContainer.style.left=u.l+c[0]*u.w+\"px\",this.mouseContainer.style.top=u.t+(1-h[1])*u.h+\"px\";var f=this.bounds;f[0]=f[1]=1/0,f[2]=f[3]=-1/0;var d,p,m=Object.keys(this.traces);for(p=0;p<m.length;++p)for(var v=this.traces[m[p]],g=0;g<2;++g)f[g]=Math.min(f[g],v.bounds[g]),f[g+2]=Math.max(f[g+2],v.bounds[g+2]);for(p=0;p<2;++p)f[p]>f[p+2]&&(f[p]=-1,f[p+2]=1),d=this[_[p]],d._length=o.viewBox[p+2]-o.viewBox[p],l.doAutoRange(d),d.setScale();b(s),o.ticks=this.computeTickMarks(),o.dataBox=this.calcDataBox(),o.merge(r),n.update(o),this.glplot.draw()},w.calcDataBox=function(){var t=this.xaxis,e=this.yaxis,r=t.range,n=e.range,i=t.r2l,a=e.r2l;return[i(r[0]),a(n[0]),i(r[1]),a(n[1])]},w.setRanges=function(t){var e=this.xaxis,r=this.yaxis,n=e.l2r,i=r.l2r;e.range=[n(t[0]),n(t[2])],r.range=[i(t[1]),i(t[3])]},w.updateTraces=function(t,e){var r,n,i,a=Object.keys(this.traces);this.fullData=t;t:for(r=0;r<a.length;r++){var o=a[r],s=this.traces[o];for(n=0;n<t.length;n++)if(i=t[n],i.uid===o&&i.type===s.type)continue t;s.dispose(),delete this.traces[o]}for(r=0;r<t.length;r++){i=t[r];var l=e[r],u=this.traces[i.uid];u?u.update(i,l):(u=i._module.plot(this,i,l),this.traces[i.uid]=u)}this.glplot.objects.sort(function(t,e){return t._trace.index-e._trace.index})},w.updateFx=function(t){this.mouseContainer.style[\"pointer-events\"]=\"lasso\"===t||\"select\"===t?\"none\":\"auto\",this.mouseContainer.style.cursor=\"pan\"===t?\"move\":\"zoom\"===t?\"crosshair\":null},w.emitPointAction=function(t,e){for(var r,n=t.trace.uid,i=t.pointIndex,a=0;a<this.fullData.length;a++)this.fullData[a].uid===n&&(r=this.fullData[a]);var o={x:t.traceCoord[0],y:t.traceCoord[1],curveNumber:r.index,pointNumber:i,data:r._input,fullData:this.fullData,xaxis:this.xaxis,yaxis:this.yaxis};u.appendArrayPointValue(o,r,i),this.graphDiv.emit(e,{points:[o]})},w.draw=function(){if(!this.stopped){requestAnimationFrame(this.redraw);var t=this.glplot,e=this.camera,r=e.mouseListener,n=1===this.lastButtonState&&0===r.buttons,i=this.fullLayout;this.lastButtonState=r.buttons,this.cameraChanged();var a,o=r.x*t.pixelRatio,s=this.canvas.height-t.pixelRatio*r.y;if(e.boxEnabled&&\"zoom\"===i.dragmode){this.selectBox.enabled=!0;for(var l=this.selectBox.selectBox=[Math.min(e.boxStart[0],e.boxEnd[0]),Math.min(e.boxStart[1],e.boxEnd[1]),Math.max(e.boxStart[0],e.boxEnd[0]),Math.max(e.boxStart[1],e.boxEnd[1])],c=0;c<2;c++)e.boxStart[c]===e.boxEnd[c]&&(l[c]=t.dataBox[c],l[c+2]=t.dataBox[c+2]);t.setDirty()}else if(!e.panning&&this.isMouseOver){this.selectBox.enabled=!1;var h=i._size,f=this.xaxis.domain,d=this.yaxis.domain;a=t.pick(o/t.pixelRatio+h.l+f[0]*h.w,s/t.pixelRatio-(h.t+(1-d[1])*h.h));var p=a&&a.object._trace.handlePick(a);if(p&&n&&this.emitPointAction(p,\"plotly_click\"),a&&\"skip\"!==a.object._trace.hoverinfo&&i.hovermode&&p&&(!this.lastPickResult||this.lastPickResult.traceUid!==p.trace.uid||this.lastPickResult.dataCoord[0]!==p.dataCoord[0]||this.lastPickResult.dataCoord[1]!==p.dataCoord[1])){var m=p;this.lastPickResult={traceUid:p.trace?p.trace.uid:null,dataCoord:p.dataCoord.slice()},this.spikes.update({center:a.dataCoord}),m.screenCoord=[((t.viewBox[2]-t.viewBox[0])*(a.dataCoord[0]-t.dataBox[0])/(t.dataBox[2]-t.dataBox[0])+t.viewBox[0])/t.pixelRatio,(this.canvas.height-(t.viewBox[3]-t.viewBox[1])*(a.dataCoord[1]-t.dataBox[1])/(t.dataBox[3]-t.dataBox[1])-t.viewBox[1])/t.pixelRatio],this.emitPointAction(p,\"plotly_hover\");var v=this.fullData[m.trace.index]||{},g=m.pointIndex,y=u.castHoverinfo(v,i,g);if(y&&\"all\"!==y){var b=y.split(\"+\");-1===b.indexOf(\"x\")&&(m.traceCoord[0]=void 0),-1===b.indexOf(\"y\")&&(m.traceCoord[1]=void 0),-1===b.indexOf(\"z\")&&(m.traceCoord[2]=void 0),-1===b.indexOf(\"text\")&&(m.textLabel=void 0),-1===b.indexOf(\"name\")&&(m.name=void 0)}u.loneHover({x:m.screenCoord[0],y:m.screenCoord[1],xLabel:this.hoverFormatter(\"xaxis\",m.traceCoord[0]),yLabel:this.hoverFormatter(\"yaxis\",m.traceCoord[1]),zLabel:m.traceCoord[2],text:m.textLabel,name:m.name,color:u.castHoverOption(v,g,\"bgcolor\")||m.color,borderColor:u.castHoverOption(v,g,\"bordercolor\"),fontFamily:u.castHoverOption(v,g,\"font.family\"),fontSize:u.castHoverOption(v,g,\"font.size\"),fontColor:u.castHoverOption(v,g,\"font.color\")},{container:this.svgContainer,gd:this.graphDiv})}}a||this.unhover(),t.draw()}},w.unhover=function(){this.lastPickResult&&(this.spikes.update({}),this.lastPickResult=null,this.graphDiv.emit(\"plotly_unhover\"),u.loneUnhover(this.svgContainer))},w.hoverFormatter=function(t,e){if(void 0!==e){var r=this[t];return l.tickText(r,r.c2l(e),\"hover\").text}}},{\"../../components/fx\":644,\"../../lib/html2unicode\":723,\"../../lib/show_no_webgl_msg\":742,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/constraints\":773,\"../../registry\":844,\"./camera\":804,\"./convert\":805,\"gl-plot2d\":218,\"gl-select-box\":252,\"gl-spikes2d\":261,\"webgl-context\":562}],808:[function(t,e,r){\"use strict\";function n(t,e){function r(e,r,n,a){var o=p.keyBindingMode;if(!1!==o){var s=\"rotate\"===o,l=\"pan\"===o,c=\"zoom\"===o,f=!!a.control,d=!!a.alt,y=!!a.shift,b=!!(1&e),x=!!(2&e),_=!!(4&e),w=1/t.clientHeight,M=w*(r-m),k=w*(n-v),A=p.flipX?1:-1,T=p.flipY?1:-1,S=i(),E=Math.PI*p.rotateSpeed;if((s&&b&&!f&&!d&&!y||b&&!f&&!d&&y)&&u.rotate(S,A*E*M,-T*E*k,0),(l&&b&&!f&&!d&&!y||x||b&&f&&!d&&!y)&&u.pan(S,-p.translateSpeed*M*h,p.translateSpeed*k*h,0),c&&b&&!f&&!d&&!y||_||b&&!f&&d&&!y){var L=-p.zoomSpeed*k/window.innerHeight*(S-u.lastT())*100;u.pan(S,0,0,h*(Math.exp(L)-1))}return m=r,v=n,g=a,!0}}t=t||document.body,e=e||{};var n=[.01,1/0];\"distanceLimits\"in e&&(n[0]=e.distanceLimits[0],n[1]=e.distanceLimits[1]),\"zoomMin\"in e&&(n[0]=e.zoomMin),\"zoomMax\"in e&&(n[1]=e.zoomMax);var u=a({center:e.center||[0,0,0],up:e.up||[0,1,0],eye:e.eye||[0,0,10],mode:e.mode||\"orbit\",distanceLimits:n}),c=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],h=0,f=t.clientWidth,d=t.clientHeight,p={keyBindingMode:\"rotate\",view:u,element:t,delay:e.delay||16,rotateSpeed:e.rotateSpeed||1,zoomSpeed:e.zoomSpeed||1,translateSpeed:e.translateSpeed||1,flipX:!!e.flipX,flipY:!!e.flipY,modes:u.modes,tick:function(){var e=i(),r=this.delay,n=e-2*r;u.idle(e-r),u.recalcMatrix(n),u.flush(e-(100+2*r));for(var a=!0,o=u.computedMatrix,s=0;s<16;++s)a=a&&c[s]===o[s],c[s]=o[s];var l=t.clientWidth===f&&t.clientHeight===d;return f=t.clientWidth,d=t.clientHeight,a?!l:(h=Math.exp(u.computedRadius[0]),!0)},lookAt:function(t,e,r){u.lookAt(u.lastT(),t,e,r)},rotate:function(t,e,r){u.rotate(u.lastT(),t,e,r)},pan:function(t,e,r){u.pan(u.lastT(),t,e,r)},translate:function(t,e,r){u.translate(u.lastT(),t,e,r)}};Object.defineProperties(p,{matrix:{get:function(){return u.computedMatrix},set:function(t){return u.setMatrix(u.lastT(),t),u.computedMatrix},enumerable:!0},mode:{get:function(){return u.getMode()},set:function(t){var e=u.computedUp.slice(),r=u.computedEye.slice(),n=u.computedCenter.slice();if(u.setMode(t),\"turntable\"===t){var a=i();u._active.lookAt(a,r,n,e),u._active.lookAt(a+500,r,n,[0,0,1]),u._active.flush(a)}return u.getMode()},enumerable:!0},center:{get:function(){return u.computedCenter},set:function(t){return u.lookAt(u.lastT(),null,t),u.computedCenter},enumerable:!0},eye:{get:function(){return u.computedEye},set:function(t){return u.lookAt(u.lastT(),t),u.computedEye},enumerable:!0},up:{get:function(){return u.computedUp},set:function(t){return u.lookAt(u.lastT(),null,null,t),u.computedUp},enumerable:!0},distance:{get:function(){return h},set:function(t){return u.setDistance(u.lastT(),t),t},enumerable:!0},distanceLimits:{get:function(){return u.getDistanceLimits(n)},set:function(t){return u.setDistanceLimits(t),t},enumerable:!0}}),t.addEventListener(\"contextmenu\",function(t){return t.preventDefault(),!1});var m=0,v=0,g={shift:!1,control:!1,alt:!1,meta:!1};return p.mouseListener=o(t,r),t.addEventListener(\"touchstart\",function(e){var n=l(e.changedTouches[0],t);r(0,n[0],n[1],g),r(1,n[0],n[1],g)}),t.addEventListener(\"touchmove\",function(e){var n=l(e.changedTouches[0],t);r(1,n[0],n[1],g)}),t.addEventListener(\"touchend\",function(){r(0,m,v,g)}),p.wheelListener=s(t,function(t,e){if(!1!==p.keyBindingMode){var r=p.flipX?1:-1,n=p.flipY?1:-1,a=i();if(Math.abs(t)>Math.abs(e))u.rotate(a,0,0,-t*r*Math.PI*p.rotateSpeed/window.innerWidth);else{var o=-p.zoomSpeed*n*e/window.innerHeight*(a-u.lastT())/100;u.pan(a,0,0,h*(Math.exp(o)-1))}}},!0),p}e.exports=n;var i=t(\"right-now\"),a=t(\"3d-view\"),o=t(\"mouse-change\"),s=t(\"mouse-wheel\"),l=t(\"mouse-event-offset\")},{\"3d-view\":36,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454,\"right-now\":501}],809:[function(t,e,r){\"use strict\";var n=t(\"./scene\"),i=t(\"../plots\"),a=t(\"../../lib\"),o=t(\"../../constants/xmlns_namespaces\");r.name=\"gl3d\",r.attr=\"scene\",r.idRoot=\"scene\",r.idRegex=/^scene([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^scene([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,o=i.getSubplotIds(e,\"gl3d\"),s=0;s<o.length;s++){var l=o[s],u=i.getSubplotData(r,\"gl3d\",l),c=e[l],h=c._scene;h||(h=new n({id:l,graphDiv:t,container:t.querySelector(\".gl-container\"),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio},e),c._scene=h),h.cameraInitial||(h.cameraInitial=a.extendDeep({},c.camera)),h.plot(u,e,t.layout)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"gl3d\"),o=0;o<a.length;o++){var s=a[o];!e[s]&&n[s]._scene&&(n[s]._scene.destroy(),n._infolayer&&n._infolayer.selectAll(\".annotation-\"+s).remove())}},r.toSVG=function(t){for(var e=t._fullLayout,r=i.getSubplotIds(e,\"gl3d\"),n=e._size,a=0;a<r.length;a++){var s=e[r[a]],l=s.domain,u=s._scene,c=u.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:o.svg,\"xlink:href\":c,x:n.l+n.w*l.x[0],y:n.t+n.h*(1-l.y[1]),width:n.w*(l.x[1]-l.x[0]),height:n.h*(l.y[1]-l.y[0]),preserveAspectRatio:\"none\"}),u.destroy()}},r.cleanId=function(t){if(t.match(/^scene[0-9]*$/)){var e=t.substr(5);return\"1\"===e&&(e=\"\"),\"scene\"+e}}},{\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../plots\":829,\"./layout/attributes\":810,\"./layout/defaults\":814,\"./layout/layout_attributes\":815,\"./scene\":819}],810:[function(t,e,r){\"use strict\";e.exports={scene:{valType:\"subplotid\",dflt:\"scene\"}}},{}],811:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color\"),i=t(\"../../cartesian/layout_attributes\"),a=t(\"../../../lib/extend\").extendFlat;e.exports={visible:i.visible,showspikes:{valType:\"boolean\",dflt:!0},spikesides:{valType:\"boolean\",dflt:!0},spikethickness:{valType:\"number\",min:0,dflt:2},spikecolor:{valType:\"color\",dflt:n.defaultLine},showbackground:{valType:\"boolean\",dflt:!1},backgroundcolor:{valType:\"color\",dflt:\"rgba(204, 204, 204, 0.5)\"},showaxeslabels:{valType:\"boolean\",dflt:!0},color:i.color,categoryorder:i.categoryorder,categoryarray:i.categoryarray,title:i.title,titlefont:i.titlefont,type:i.type,autorange:i.autorange,rangemode:i.rangemode,range:i.range,tickmode:i.tickmode,nticks:i.nticks,tick0:i.tick0,dtick:i.dtick,tickvals:i.tickvals,ticktext:i.ticktext,ticks:i.ticks,mirror:i.mirror,ticklen:i.ticklen,tickwidth:i.tickwidth,tickcolor:i.tickcolor,showticklabels:i.showticklabels,tickfont:i.tickfont,tickangle:i.tickangle,tickprefix:i.tickprefix,showtickprefix:i.showtickprefix,ticksuffix:i.ticksuffix,showticksuffix:i.showticksuffix,showexponent:i.showexponent,exponentformat:i.exponentformat,separatethousands:i.separatethousands,tickformat:i.tickformat,hoverformat:i.hoverformat,showline:i.showline,linecolor:i.linecolor,linewidth:i.linewidth,showgrid:i.showgrid,gridcolor:a({},i.gridcolor,{dflt:\"rgb(204, 204, 204)\"}),gridwidth:i.gridwidth,zeroline:i.zeroline,zerolinecolor:i.zerolinecolor,zerolinewidth:i.zerolinewidth}},{\"../../../components/color\":603,\"../../../lib/extend\":716,\"../../cartesian/layout_attributes\":777}],812:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../../lib\"),a=t(\"./axis_attributes\"),o=t(\"../../cartesian/type_defaults\"),s=t(\"../../cartesian/axis_defaults\"),l=[\"xaxis\",\"yaxis\",\"zaxis\"];e.exports=function(t,e,r){function u(t,e){return i.coerce(c,h,a,t,e)}for(var c,h,f=0;f<l.length;f++){var d=l[f];c=t[d]||{},h=e[d]={_id:d[0]+r.scene,_name:d},o(c,h,u,r.data),s(c,h,u,{font:r.font,letter:d[0],data:r.data,showGrid:!0,bgColor:r.bgColor,calendar:r.calendar}),u(\"gridcolor\",n(h.color,r.bgColor,13600/187).toRgbString()),u(\"title\",d[0]),h.setScale=i.noop,u(\"showspikes\")&&(u(\"spikesides\"),u(\"spikethickness\"),u(\"spikecolor\",h.color)),u(\"showaxeslabels\"),u(\"showbackground\")&&u(\"backgroundcolor\")}}},{\"../../../lib\":725,\"../../cartesian/axis_defaults\":768,\"../../cartesian/type_defaults\":788,\"./axis_attributes\":811,tinycolor2:533}],813:[function(t,e,r){\"use strict\";function n(){this.bounds=[[-10,-10,-10],[10,10,10]],this.ticks=[[],[],[]],this.tickEnable=[!0,!0,!0],this.tickFont=[\"sans-serif\",\"sans-serif\",\"sans-serif\"],this.tickSize=[12,12,12],this.tickAngle=[0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[18,18,18],this.labels=[\"x\",\"y\",\"z\"],this.labelEnable=[!0,!0,!0],this.labelFont=[\"Open Sans\",\"Open Sans\",\"Open Sans\"],this.labelSize=[20,20,20],this.labelAngle=[0,0,0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[30,30,30],this.lineEnable=[!0,!0,!0],this.lineMirror=[!1,!1,!1],this.lineWidth=[1,1,1],this.lineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.lineTickEnable=[!0,!0,!0],this.lineTickMirror=[!1,!1,!1],this.lineTickLength=[10,10,10],this.lineTickWidth=[1,1,1],this.lineTickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.gridEnable=[!0,!0,!0],this.gridWidth=[1,1,1],this.gridColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroEnable=[!0,!0,!0],this.zeroLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroLineWidth=[2,2,2],this.backgroundEnable=[!0,!0,!0],this.backgroundColor=[[.8,.8,.8,.5],[.8,.8,.8,.5],[.8,.8,.8,.5]],this._defaultTickPad=this.tickPad.slice(),this._defaultLabelPad=this.labelPad.slice(),this._defaultLineTickLength=this.lineTickLength.slice()}function i(t){var e=new n;return e.merge(t),e}var a=t(\"../../../lib/html2unicode\"),o=t(\"../../../lib/str2rgbarray\"),s=[\"xaxis\",\"yaxis\",\"zaxis\"];n.prototype.merge=function(t){for(var e=this,r=0;r<3;++r){var n=t[s[r]];n.visible?(e.labels[r]=a(n.title),\"titlefont\"in n&&(n.titlefont.color&&(e.labelColor[r]=o(n.titlefont.color)),n.titlefont.family&&(e.labelFont[r]=n.titlefont.family),n.titlefont.size&&(e.labelSize[r]=n.titlefont.size)),\"showline\"in n&&(e.lineEnable[r]=n.showline),\"linecolor\"in n&&(e.lineColor[r]=o(n.linecolor)),\"linewidth\"in n&&(e.lineWidth[r]=n.linewidth),\"showgrid\"in n&&(e.gridEnable[r]=n.showgrid),\"gridcolor\"in n&&(e.gridColor[r]=o(n.gridcolor)),\"gridwidth\"in n&&(e.gridWidth[r]=n.gridwidth),\"log\"===n.type?e.zeroEnable[r]=!1:\"zeroline\"in n&&(e.zeroEnable[r]=n.zeroline),\"zerolinecolor\"in n&&(e.zeroLineColor[r]=o(n.zerolinecolor)),\"zerolinewidth\"in n&&(e.zeroLineWidth[r]=n.zerolinewidth),\"ticks\"in n&&n.ticks?e.lineTickEnable[r]=!0:e.lineTickEnable[r]=!1,\"ticklen\"in n&&(e.lineTickLength[r]=e._defaultLineTickLength[r]=n.ticklen),\"tickcolor\"in n&&(e.lineTickColor[r]=o(n.tickcolor)),\"tickwidth\"in n&&(e.lineTickWidth[r]=n.tickwidth),\"tickangle\"in n&&(e.tickAngle[r]=\"auto\"===n.tickangle?0:Math.PI*-n.tickangle/180),\"showticklabels\"in n&&(e.tickEnable[r]=n.showticklabels),\"tickfont\"in n&&(n.tickfont.color&&(e.tickColor[r]=o(n.tickfont.color)),n.tickfont.family&&(e.tickFont[r]=n.tickfont.family),n.tickfont.size&&(e.tickSize[r]=n.tickfont.size)),\"mirror\"in n?-1!==[\"ticks\",\"all\",\"allticks\"].indexOf(n.mirror)?(e.lineTickMirror[r]=!0,e.lineMirror[r]=!0):!0===n.mirror?(e.lineTickMirror[r]=!1,e.lineMirror[r]=!0):(e.lineTickMirror[r]=!1,e.lineMirror[r]=!1):e.lineMirror[r]=!1,\"showbackground\"in n&&!1!==n.showbackground?(e.backgroundEnable[r]=!0,e.backgroundColor[r]=o(n.backgroundcolor)):e.backgroundEnable[r]=!1):(e.tickEnable[r]=!1,e.labelEnable[r]=!1,e.lineEnable[r]=!1,e.lineTickEnable[r]=!1,e.gridEnable[r]=!1,e.zeroEnable[r]=!1,e.backgroundEnable[r]=!1)}},e.exports=i},{\"../../../lib/html2unicode\":723,\"../../../lib/str2rgbarray\":744}],814:[function(t,e,r){\"use strict\";function n(t,e,r,n){for(var i=r(\"bgcolor\"),s=a.combine(i,n.paper_bgcolor),c=Object.keys(u.camera),h=0;h<c.length;h++)r(\"camera.\"+c[h]+\".x\"),r(\"camera.\"+c[h]+\".y\"),r(\"camera.\"+c[h]+\".z\");var f=!!r(\"aspectratio.x\")&&!!r(\"aspectratio.y\")&&!!r(\"aspectratio.z\"),d=f?\"manual\":\"auto\",p=r(\"aspectmode\",d);f||(t.aspectratio=e.aspectratio={x:1,y:1,z:1},\"manual\"===p&&(e.aspectmode=\"auto\")),l(t,e,{font:n.font,scene:n.id,data:n.fullData,bgColor:s,calendar:n.calendar}),o.getComponentMethod(\"annotations3d\",\"handleDefaults\")(t,e,n),r(\"dragmode\",n.getDfltFromLayout(\"dragmode\")),r(\"hovermode\",n.getDfltFromLayout(\"hovermode\"))}var i=t(\"../../../lib\"),a=t(\"../../../components/color\"),o=t(\"../../../registry\"),s=t(\"../../subplot_defaults\"),l=t(\"./axis_defaults\"),u=t(\"./layout_attributes\");e.exports=function(t,e,r){function a(e){if(!o){return i.validate(t[e],u[e])?t[e]:void 0}}var o=e._basePlotModules.length>1;s(t,e,r,{type:\"gl3d\",attributes:u,handleDefaults:n,fullLayout:e,font:e.font,fullData:r,getDfltFromLayout:a,paper_bgcolor:e.paper_bgcolor,calendar:e.calendar})}},{\"../../../components/color\":603,\"../../../lib\":725,\"../../../registry\":844,\"../../subplot_defaults\":836,\"./axis_defaults\":812,\"./layout_attributes\":815}],815:[function(t,e,r){\"use strict\";function n(t,e,r){return{x:{valType:\"number\",dflt:t},y:{valType:\"number\",dflt:e},z:{valType:\"number\",dflt:r}}}var i=t(\"./axis_attributes\"),a=t(\"../../../lib/extend\").extendFlat;e.exports={_arrayAttrRegexps:[/^scene([2-9]|[1-9][0-9]+)?\\.annotations/],bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},camera:{up:a(n(0,0,1),{}),center:a(n(0,0,0),{}),eye:a(n(1.25,1.25,1.25),{})},domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},aspectmode:{valType:\"enumerated\",values:[\"auto\",\"cube\",\"data\",\"manual\"],dflt:\"auto\"},aspectratio:{x:{valType:\"number\",min:0},y:{valType:\"number\",min:0},z:{valType:\"number\",min:0}},xaxis:i,yaxis:i,zaxis:i,dragmode:{valType:\"enumerated\",values:[\"orbit\",\"turntable\",\"zoom\",\"pan\",!1],dflt:\"turntable\"},hovermode:{valType:\"enumerated\",values:[\"closest\",!1],dflt:\"closest\"},_deprecated:{cameraposition:{valType:\"info_array\"}}}},{\"../../../lib/extend\":716,\"./axis_attributes\":811}],816:[function(t,e,r){\"use strict\";function n(){this.enabled=[!0,!0,!0],this.colors=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.drawSides=[!0,!0,!0],this.lineWidth=[1,1,1]}function i(t){var e=new n;return e.merge(t),e}var a=t(\"../../../lib/str2rgbarray\"),o=[\"xaxis\",\"yaxis\",\"zaxis\"];n.prototype.merge=function(t){for(var e=0;e<3;++e){var r=t[o[e]];r.visible?(this.enabled[e]=r.showspikes,this.colors[e]=a(r.spikecolor),this.drawSides[e]=r.spikesides,this.lineWidth[e]=r.spikethickness):(this.enabled[e]=!1,this.drawSides[e]=!1)}},e.exports=i},{\"../../../lib/str2rgbarray\":744}],817:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(3),r=0;r<3;++r){for(var n=t[r],i=new Array(n.length),a=0;a<n.length;++a)i[a]=n[a].x;e[r]=i}return e}function i(t){for(var e=t.axesOptions,r=t.glplot.axesPixels,i=t.fullSceneLayout,c=[[],[],[]],h=0;h<3;++h){var f=i[l[h]];if(f._length=(r[h].hi-r[h].lo)*r[h].pixelsPerDataUnit/t.dataScale[h],Math.abs(f._length)===1/0)c[h]=[];else{f.range[0]=r[h].lo/t.dataScale[h],f.range[1]=r[h].hi/t.dataScale[h],f._m=1/(t.dataScale[h]*r[h].pixelsPerDataUnit),f.range[0]===f.range[1]&&(f.range[0]-=1,f.range[1]+=1);var d=f.tickmode;if(\"auto\"===f.tickmode){f.tickmode=\"linear\";var p=f.nticks||o.constrain(f._length/40,4,9);a.autoTicks(f,Math.abs(f.range[1]-f.range[0])/p)}for(var m=a.calcTicks(f),v=0;v<m.length;++v)m[v].x=m[v].x*t.dataScale[h],m[v].text=s(m[v].text);c[h]=m,f.tickmode=d}}e.ticks=c;for(var h=0;h<3;++h){u[h]=.5*(t.glplot.bounds[0][h]+t.glplot.bounds[1][h]);for(var v=0;v<2;++v)e.bounds[v][h]=t.glplot.bounds[v][h]}t.contourLevels=n(c)}e.exports=i;var a=t(\"../../cartesian/axes\"),o=t(\"../../../lib\"),s=t(\"../../../lib/html2unicode\"),l=[\"xaxis\",\"yaxis\",\"zaxis\"],u=[0,0,0]},{\"../../../lib\":725,\"../../../lib/html2unicode\":723,\"../../cartesian/axes\":766}],818:[function(t,e,r){\"use strict\";function n(t,e){var r,n,i=[0,0,0,0];for(r=0;r<4;++r)for(n=0;n<4;++n)i[n]+=t[4*r+n]*e[r];return i}function i(t,e){return n(t.projection,n(t.view,n(t.model,[e[0],e[1],e[2],1])))}e.exports=i},{}],819:[function(t,e,r){\"use strict\";function n(t){function e(e,r){var n=t.fullSceneLayout[e];return v.tickText(n,n.d2l(r),\"hover\").text}var r,n=t.svgContainer,i=t.container.getBoundingClientRect(),a=i.width,o=i.height;n.setAttributeNS(null,\"viewBox\",\"0 0 \"+a+\" \"+o),n.setAttributeNS(null,\"width\",a),n.setAttributeNS(null,\"height\",o),k(t),t.glplot.axes.update(t.axesOptions);for(var s=Object.keys(t.traces),l=null,u=t.glplot.selection,c=0;c<s.length;++c)r=t.traces[s[c]],\"skip\"!==r.data.hoverinfo&&r.handlePick(u)&&(l=r),r.setContourLevels&&r.setContourLevels();var h;if(null!==l){var f=_(t.glplot.cameraParams,u.dataCoordinate);r=l.data;var d=u.index,p=g.castHoverinfo(r,t.fullLayout,d),m=e(\"xaxis\",u.traceCoordinate[0]),y=e(\"yaxis\",u.traceCoordinate[1]),b=e(\"zaxis\",u.traceCoordinate[2]);if(\"all\"!==p){var x=p.split(\"+\");-1===x.indexOf(\"x\")&&(m=void 0),-1===x.indexOf(\"y\")&&(y=void 0),-1===x.indexOf(\"z\")&&(b=void 0),-1===x.indexOf(\"text\")&&(u.textLabel=void 0),-1===x.indexOf(\"name\")&&(l.name=void 0)}t.fullSceneLayout.hovermode&&g.loneHover({x:(.5+.5*f[0]/f[3])*a,y:(.5-.5*f[1]/f[3])*o,xLabel:m,yLabel:y,zLabel:b,text:u.textLabel,name:l.name,color:g.castHoverOption(r,d,\"bgcolor\")||l.color,borderColor:g.castHoverOption(r,d,\"bordercolor\"),fontFamily:g.castHoverOption(r,d,\"font.family\"),fontSize:g.castHoverOption(r,d,\"font.size\"),fontColor:g.castHoverOption(r,d,\"font.color\")},{container:n,gd:t.graphDiv});var w={x:u.traceCoordinate[0],y:u.traceCoordinate[1],z:u.traceCoordinate[2],data:r._input,fullData:r,curveNumber:r.index,pointNumber:d};g.appendArrayPointValue(w,r,d);var M={points:[w]};u.buttons&&u.distance<5?t.graphDiv.emit(\"plotly_click\",M):t.graphDiv.emit(\"plotly_hover\",M),h=M}else g.loneUnhover(n),t.graphDiv.emit(\"plotly_unhover\",h);t.drawAnnotations(t)}function i(t,e,r,i){var a={canvas:r,gl:i,container:t.container,axes:t.axesOptions,spikes:t.spikeOptions,pickRadius:10,snapToData:!0,autoScale:!0,autoBounds:!1};if(t.staticMode){if(!(h||(c=document.createElement(\"canvas\"),h=d({canvas:c,preserveDrawingBuffer:!0,premultipliedAlpha:!0,antialias:!0}))))throw new Error(\"error creating static canvas/context for image server\");a.pixelRatio=t.pixelRatio,a.gl=h,a.canvas=c}try{t.glplot=f(a)}catch(e){b(t)}var o=function(t){if(!1!==t.fullSceneLayout.dragmode){var e={};e[t.id+\".camera\"]=u(t.camera),t.saveCamera(t.graphDiv.layout),t.graphDiv.emit(\"plotly_relayout\",e)}};if(t.glplot.canvas.addEventListener(\"mouseup\",o.bind(null,t)),t.glplot.canvas.addEventListener(\"wheel\",o.bind(null,t)),t.staticMode||t.glplot.canvas.addEventListener(\"webglcontextlost\",function(t){m.warn(\"Lost WebGL context.\"),t.preventDefault()}),!t.camera){var s=t.fullSceneLayout.camera;t.camera=x(t.container,{center:[s.center.x,s.center.y,s.center.z],eye:[s.eye.x,s.eye.y,s.eye.z],up:[s.up.x,s.up.y,s.up.z],zoomMin:.1,zoomMax:100,mode:\"orbit\"})}return t.glplot.camera=t.camera,t.glplot.oncontextloss=function(){t.recoverContext()},t.glplot.onrender=n.bind(null,t),t.traces={},!0}function a(t,e){var r=document.createElement(\"div\"),n=t.container;this.graphDiv=t.graphDiv;var a=document.createElementNS(\"http://www.w3.org/2000/svg\",\"svg\");a.style.position=\"absolute\",a.style.top=a.style.left=\"0px\",a.style.width=a.style.height=\"100%\",a.style[\"z-index\"]=20,a.style[\"pointer-events\"]=\"none\",r.appendChild(a),this.svgContainer=a,r.id=t.id,r.style.position=\"absolute\",r.style.top=r.style.left=\"0px\",r.style.width=r.style.height=\"100%\",n.appendChild(r),this.fullLayout=e,this.id=t.id||\"scene\",this.fullSceneLayout=e[this.id],this.plotArgs=[[],{},{}],this.axesOptions=w(e[this.id]),this.spikeOptions=M(e[this.id]),this.container=r,this.staticMode=!!t.staticPlot,this.pixelRatio=t.plotGlPixelRatio||2,this.dataScale=[1,1,1],this.contourLevels=[[],[],[]],this.convertAnnotations=p.getComponentMethod(\"annotations3d\",\"convert\"),this.drawAnnotations=p.getComponentMethod(\"annotations3d\",\"draw\"),i(this,e)}function o(t,e,r,n,i){for(var a,o=0;o<e.length;++o)if(Array.isArray(e[o]))for(var s=0;s<e[o].length;++s)a=t.d2l(e[o][s],0,i),!isNaN(a)&&isFinite(a)&&(n[0][r]=Math.min(n[0][r],a),n[1][r]=Math.max(n[1][r],a));else a=t.d2l(e[o],0,i),!isNaN(a)&&isFinite(a)&&(n[0][r]=Math.min(n[0][r],a),n[1][r]=Math.max(n[1][r],a))}function s(t,e,r){var n=t.fullSceneLayout;o(n.xaxis,e.x,0,r,e.xcalendar),o(n.yaxis,e.y,1,r,e.ycalendar),o(n.zaxis,e.z,2,r,e.zcalendar)}function l(t){return[[t.eye.x,t.eye.y,t.eye.z],[t.center.x,t.center.y,t.center.z],[t.up.x,t.up.y,t.up.z]]}function u(t){return{up:{x:t.up[0],y:t.up[1],z:t.up[2]},center:{x:t.center[0],y:t.center[1],z:t.center[2]},eye:{x:t.eye[0],y:t.eye[1],z:t.eye[2]}}}var c,h,f=t(\"gl-plot3d\"),d=t(\"webgl-context\"),p=t(\"../../registry\"),m=t(\"../../lib\"),v=t(\"../../plots/cartesian/axes\"),g=t(\"../../components/fx\"),y=t(\"../../lib/str2rgbarray\"),b=t(\"../../lib/show_no_webgl_msg\"),x=t(\"./camera\"),_=t(\"./project\"),w=t(\"./layout/convert\"),M=t(\"./layout/spikes\"),k=t(\"./layout/tick_marks\"),A=a.prototype;A.recoverContext=function(){function t(){return r.isContextLost()?void requestAnimationFrame(t):i(e,e.fullLayout,n,r)?void e.plot.apply(e,e.plotArgs):void m.error(\"Catastrophic and unrecoverable WebGL error. Context lost.\")}var e=this,r=this.glplot.gl,n=this.glplot.canvas;this.glplot.dispose(),requestAnimationFrame(t)};var T=[\"xaxis\",\"yaxis\",\"zaxis\"];A.plot=function(t,e,r){if(this.plotArgs=[t,e,r],!this.glplot.contextLost){var n,i,a,o,l,u,c=e[this.id],h=r[this.id];c.bgcolor?this.glplot.clearColor=y(c.bgcolor):this.glplot.clearColor=[0,0,0,0],this.glplot.snapToData=!0,this.fullLayout=e,this.fullSceneLayout=c,this.glplotLayout=c,this.axesOptions.merge(c),this.spikeOptions.merge(c),this.setCamera(c.camera),this.updateFx(c.dragmode,c.hovermode),this.glplot.update({}),this.setConvert(l),t?Array.isArray(t)||(t=[t]):t=[];var f=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]];for(a=0;a<t.length;++a)n=t[a],!0===n.visible&&s(this,n,f);var d=[1,1,1];for(o=0;o<3;++o)f[0][o]>f[1][o]?d[o]=1:f[1][o]===f[0][o]?d[o]=1:d[o]=1/(f[1][o]-f[0][o]);for(this.dataScale=d,this.convertAnnotations(this),a=0;a<t.length;++a)n=t[a],!0===n.visible&&(i=this.traces[n.uid],i?i.update(n):(i=n._module.plot(this,n),this.traces[n.uid]=i),i.name=n.name);var p=Object.keys(this.traces);t:for(a=0;a<p.length;++a){for(o=0;o<t.length;++o)if(t[o].uid===p[a]&&!0===t[o].visible)continue t;i=this.traces[p[a]],i.dispose(),delete this.traces[p[a]]}this.glplot.objects.sort(function(t,e){return t._trace.data.index-e._trace.data.index});var m=[[0,0,0],[0,0,0]],v=[],g={};for(a=0;a<3;++a){if(l=c[T[a]],u=l.type,u in g?(g[u].acc*=d[a],g[u].count+=1):g[u]={acc:d[a],count:1},l.autorange){m[0][a]=1/0,m[1][a]=-1/0;var b=this.glplot.objects,x=this.fullSceneLayout.annotations||[],_=l._name.charAt(0);for(o=0;o<b.length;o++){var w=b[o].bounds;m[0][a]=Math.min(m[0][a],w[0][a]/d[a]),m[1][a]=Math.max(m[1][a],w[1][a]/d[a])}for(o=0;o<x.length;o++){var M=x[o];if(M.visible){var k=l.r2l(M[_]);m[0][a]=Math.min(m[0][a],k),m[1][a]=Math.max(m[1][a],k)}}if(\"rangemode\"in l&&\"tozero\"===l.rangemode&&(m[0][a]=Math.min(m[0][a],0),m[1][a]=Math.max(m[1][a],0)),m[0][a]>m[1][a])m[0][a]=-1,m[1][a]=1;else{var A=m[1][a]-m[0][a];m[0][a]-=A/32,m[1][a]+=A/32}}else{var S=l.range;m[0][a]=l.r2l(S[0]),m[1][a]=l.r2l(S[1])}m[0][a]===m[1][a]&&(m[0][a]-=1,m[1][a]+=1),v[a]=m[1][a]-m[0][a],this.glplot.bounds[0][a]=m[0][a]*d[a],this.glplot.bounds[1][a]=m[1][a]*d[a]}var E=[1,1,1];for(a=0;a<3;++a){l=c[T[a]],u=l.type;var L=g[u];E[a]=Math.pow(L.acc,1/L.count)/d[a]}var C;if(\"auto\"===c.aspectmode)C=Math.max.apply(null,E)/Math.min.apply(null,E)<=4?E:[1,1,1];else if(\"cube\"===c.aspectmode)C=[1,1,1];else if(\"data\"===c.aspectmode)C=E;else{if(\"manual\"!==c.aspectmode)throw new Error(\"scene.js aspectRatio was not one of the enumerated types\");var z=c.aspectratio;C=[z.x,z.y,z.z]}c.aspectratio.x=h.aspectratio.x=C[0],c.aspectratio.y=h.aspectratio.y=C[1],c.aspectratio.z=h.aspectratio.z=C[2],this.glplot.aspect=C;var I=c.domain||null,D=e._size||null;if(I&&D){var P=this.container.style;P.position=\"absolute\",P.left=D.l+I.x[0]*D.w+\"px\",P.top=D.t+(1-I.y[1])*D.h+\"px\",P.width=D.w*(I.x[1]-I.x[0])+\"px\",P.height=D.h*(I.y[1]-I.y[0])+\"px\"}this.glplot.redraw()}},A.destroy=function(){this.glplot&&(this.camera.mouseListener.enabled=!1,this.container.removeEventListener(\"wheel\",this.camera.wheelListener),this.camera=this.glplot.camera=null,this.glplot.dispose(),this.container.parentNode.removeChild(this.container),this.glplot=null)},A.getCamera=function(){return this.glplot.camera.view.recalcMatrix(this.camera.view.lastT()),u(this.glplot.camera)},A.setCamera=function(t){this.glplot.camera.lookAt.apply(this,l(t))},A.saveCamera=function(t){var e=this.getCamera(),r=m.nestedProperty(t,this.id+\".camera\"),n=r.get(),i=!1;if(void 0===n)i=!0;else for(var a=0;a<3;a++)for(var o=0;o<3;o++)if(!function(t,e,r,n){var i=[\"up\",\"center\",\"eye\"],a=[\"x\",\"y\",\"z\"];return e[i[r]]&&t[i[r]][a[n]]===e[i[r]][a[n]]}(e,n,a,o)){i=!0;break}return i&&r.set(e),i},A.updateFx=function(t,e){var r=this.camera;r&&(\"orbit\"===t?(r.mode=\"orbit\",r.keyBindingMode=\"rotate\"):\"turntable\"===t?(r.up=[0,0,1],r.mode=\"turntable\",r.keyBindingMode=\"rotate\"):r.keyBindingMode=t),this.fullSceneLayout.hovermode=e},A.toImage=function(t){t||(t=\"png\"),this.staticMode&&this.container.appendChild(c),this.glplot.redraw();var e=this.glplot.gl,r=e.drawingBufferWidth,n=e.drawingBufferHeight;e.bindFramebuffer(e.FRAMEBUFFER,null);var i=new Uint8Array(r*n*4);e.readPixels(0,0,r,n,e.RGBA,e.UNSIGNED_BYTE,i);for(var a=0,o=n-1;a<o;++a,--o)for(var s=0;s<r;++s)for(var l=0;l<4;++l){var u=i[4*(r*a+s)+l];i[4*(r*a+s)+l]=i[4*(r*o+s)+l],i[4*(r*o+s)+l]=u}var h=document.createElement(\"canvas\");h.width=r,h.height=n;var f=h.getContext(\"2d\"),d=f.createImageData(r,n);d.data.set(i),f.putImageData(d,0,0);var p;switch(t){case\"jpeg\":p=h.toDataURL(\"image/jpeg\");break;case\"webp\":p=h.toDataURL(\"image/webp\");break;default:p=h.toDataURL(\"image/png\")}return this.staticMode&&this.container.removeChild(c),p},A.setConvert=function(){for(var t=0;t<3;t++){var e=this.fullSceneLayout[T[t]];v.setConvert(e,this.fullLayout),e.setScale=m.noop}},e.exports=a},{\"../../components/fx\":644,\"../../lib\":725,\"../../lib/show_no_webgl_msg\":742,\"../../lib/str2rgbarray\":744,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./camera\":808,\n",
       "\"./layout/convert\":813,\"./layout/spikes\":816,\"./layout/tick_marks\":817,\"./project\":818,\"gl-plot3d\":220,\"webgl-context\":562}],820:[function(t,e,r){\"use strict\";var n=t(\"../lib\"),i=n.extendFlat,a=t(\"./font_attributes\"),o=t(\"../components/color/attributes\");e.exports={font:{family:i({},a.family,{dflt:'\"Open Sans\", verdana, arial, sans-serif'}),size:i({},a.size,{dflt:12}),color:i({},a.color,{dflt:o.defaultLine})},title:{valType:\"string\",dflt:\"Click to enter Plot title\"},titlefont:i({},a,{}),autosize:{valType:\"boolean\",dflt:!1},width:{valType:\"number\",min:10,dflt:700},height:{valType:\"number\",min:10,dflt:450},margin:{l:{valType:\"number\",min:0,dflt:80},r:{valType:\"number\",min:0,dflt:80},t:{valType:\"number\",min:0,dflt:100},b:{valType:\"number\",min:0,dflt:80},pad:{valType:\"number\",min:0,dflt:0},autoexpand:{valType:\"boolean\",dflt:!0}},paper_bgcolor:{valType:\"color\",dflt:o.background},plot_bgcolor:{valType:\"color\",dflt:o.background},separators:{valType:\"string\",dflt:\".,\"},hidesources:{valType:\"boolean\",dflt:!1},smith:{valType:\"enumerated\",values:[!1],dflt:!1},showlegend:{valType:\"boolean\"}}},{\"../components/color/attributes\":602,\"../lib\":725,\"./font_attributes\":790}],821:[function(t,e,r){\"use strict\";e.exports={styleUrlPrefix:\"mapbox://styles/mapbox/\",styleUrlSuffix:\"v9\",controlContainerClassName:\"mapboxgl-control-container\",noAccessTokenErrorMsg:[\"Missing Mapbox access token.\",\"Mapbox trace type require a Mapbox access token to be registered.\",\"For example:\",\"  Plotly.plot(gd, data, layout, { mapboxAccessToken: 'my-access-token' });\",\"More info here: https://www.mapbox.com/help/define-access-token/\"].join(\"\\n\"),mapOnErrorMsg:\"Mapbox error.\"}},{}],822:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){var r=t.split(\" \"),i=r[0],a=r[1],o=Array.isArray(e)?n.mean(e):e,s=.5+o/100,l=1.5+o/100,u=[\"\",\"\"],c=[0,0];switch(i){case\"top\":u[0]=\"top\",c[1]=-l;break;case\"bottom\":u[0]=\"bottom\",c[1]=l}switch(a){case\"left\":u[1]=\"right\",c[0]=-s;break;case\"right\":u[1]=\"left\",c[0]=s}var h;return h=u[0]&&u[1]?u.join(\"-\"):u[0]?u[0]:u[1]?u[1]:\"center\",{anchor:h,offset:c}}},{\"../../lib\":725}],823:[function(t,e,r){\"use strict\";function n(t,e){var r=t._fullLayout,n=t._context;if(\"\"===n.mapboxAccessToken)return\"\";for(var i=n.mapboxAccessToken,a=0;a<e.length;a++){var o=r[e[a]];if(o.accesstoken){i=o.accesstoken;break}}if(!i)throw new Error(u.noAccessTokenErrorMsg);return i}var i=t(\"mapbox-gl\"),a=t(\"../../lib\"),o=t(\"../plots\"),s=t(\"../../constants/xmlns_namespaces\"),l=t(\"./mapbox\"),u=t(\"./constants\");r.name=\"mapbox\",r.attr=\"subplot\",r.idRoot=\"mapbox\",r.idRegex=/^mapbox([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^mapbox([2-9]|[1-9][0-9]+)?$/,r.attributes={subplot:{valType:\"subplotid\",dflt:\"mapbox\"}},r.layoutAttributes=t(\"./layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout_defaults\"),r.plot=function(t){var e=t._fullLayout,r=t.calcdata,s=o.getSubplotIds(e,\"mapbox\"),u=n(t,s);i.accessToken=u;for(var c=0;c<s.length;c++){var h=s[c],f=o.getSubplotCalcData(r,\"mapbox\",h),d=e[h],p=d._subplot;d.accesstoken=u,p||(p=l({gd:t,container:e._glcontainer.node(),id:h,fullLayout:e,staticPlot:t._context.staticPlot}),e[h]._subplot=p),p.viewInitial||(p.viewInitial={center:a.extendFlat({},d.center),zoom:d.zoom,bearing:d.bearing,pitch:d.pitch}),p.plot(f,e,t._promises)}},r.clean=function(t,e,r,n){for(var i=o.getSubplotIds(n,\"mapbox\"),a=0;a<i.length;a++){var s=i[a];!e[s]&&n[s]._subplot&&n[s]._subplot.destroy()}},r.toSVG=function(t){for(var e=t._fullLayout,r=o.getSubplotIds(e,\"mapbox\"),n=e._size,i=0;i<r.length;i++){var a=e[r[i]],l=a.domain,u=a._subplot,c=u.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:s.svg,\"xlink:href\":c,x:n.l+n.w*l.x[0],y:n.t+n.h*(1-l.y[1]),width:n.w*(l.x[1]-l.x[0]),height:n.h*(l.y[1]-l.y[0]),preserveAspectRatio:\"none\"}),u.destroy()}}},{\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../plots\":829,\"./constants\":821,\"./layout_attributes\":825,\"./layout_defaults\":826,\"./mapbox\":827,\"mapbox-gl\":342}],824:[function(t,e,r){\"use strict\";function n(t,e){this.mapbox=t,this.map=t.map,this.uid=t.uid+\"-layer\"+e,this.idSource=this.uid+\"-source\",this.idLayer=this.uid+\"-layer\",this.sourceType=null,this.source=null,this.layerType=null,this.below=null,this.visible=!1}function i(t){var e=t.source;return s.isPlainObject(e)||\"string\"==typeof e&&e.length>0}function a(t){var e={},r={};switch(t.type){case\"circle\":s.extendFlat(r,{\"circle-radius\":t.circle.radius,\"circle-color\":t.color,\"circle-opacity\":t.opacity});break;case\"line\":s.extendFlat(r,{\"line-width\":t.line.width,\"line-color\":t.color,\"line-opacity\":t.opacity});break;case\"fill\":s.extendFlat(r,{\"fill-color\":t.color,\"fill-outline-color\":t.fill.outlinecolor,\"fill-opacity\":t.opacity});break;case\"symbol\":var n=t.symbol,i=l(n.textposition,n.iconsize);s.extendFlat(e,{\"icon-image\":n.icon+\"-15\",\"icon-size\":n.iconsize/10,\"text-field\":n.text,\"text-size\":n.textfont.size,\"text-anchor\":i.anchor,\"text-offset\":i.offset}),s.extendFlat(r,{\"icon-color\":t.color,\"text-color\":n.textfont.color,\"text-opacity\":t.opacity})}return{layout:e,paint:r}}function o(t){var e,r=t.sourcetype,n=t.source,i={type:r},a=\"string\"==typeof n;return\"geojson\"===r?e=\"data\":\"vector\"===r&&(e=a?\"url\":\"tiles\"),i[e]=n,i}var s=t(\"../../lib\"),l=t(\"./convert_text_opts\"),u=n.prototype;u.update=function(t){this.visible?this.needsNewSource(t)?(this.updateLayer(t),this.updateSource(t)):this.needsNewLayer(t)&&this.updateLayer(t):(this.updateSource(t),this.updateLayer(t)),this.updateStyle(t),this.visible=i(t)},u.needsNewSource=function(t){return this.sourceType!==t.sourcetype||this.source!==t.source||this.layerType!==t.type},u.needsNewLayer=function(t){return this.layerType!==t.type||this.below!==t.below},u.updateSource=function(t){var e=this.map;if(e.getSource(this.idSource)&&e.removeSource(this.idSource),this.sourceType=t.sourcetype,this.source=t.source,i(t)){var r=o(t);e.addSource(this.idSource,r)}},u.updateLayer=function(t){var e=this.map;if(e.getLayer(this.idLayer)&&e.removeLayer(this.idLayer),this.layerType=t.type,i(t)){e.addLayer({id:this.idLayer,source:this.idSource,\"source-layer\":t.sourcelayer||\"\",type:t.type},t.below);var r={visibility:\"visible\"};this.mapbox.setOptions(this.idLayer,\"setLayoutProperty\",r)}},u.updateStyle=function(t){var e=a(t);i(t)&&(this.mapbox.setOptions(this.idLayer,\"setLayoutProperty\",e.layout),this.mapbox.setOptions(this.idLayer,\"setPaintProperty\",e.paint))},u.dispose=function(){var t=this.map;t.removeLayer(this.idLayer),t.removeSource(this.idSource)},e.exports=function(t,e,r){var i=new n(t,e);return i.update(r),i}},{\"../../lib\":725,\"./convert_text_opts\":822}],825:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/color\").defaultLine,a=t(\"../font_attributes\"),o=t(\"../../traces/scatter/attributes\").textposition;e.exports={_arrayAttrRegexps:[/^mapbox([2-9]|[1-9][0-9]+)?\\.layers/],domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},accesstoken:{valType:\"string\",noBlank:!0,strict:!0},style:{valType:\"any\",values:[\"basic\",\"streets\",\"outdoors\",\"light\",\"dark\",\"satellite\",\"satellite-streets\"],dflt:\"basic\"},center:{lon:{valType:\"number\",dflt:0},lat:{valType:\"number\",dflt:0}},zoom:{valType:\"number\",dflt:1},bearing:{valType:\"number\",dflt:0},pitch:{valType:\"number\",dflt:0},layers:{_isLinkedToArray:\"layer\",sourcetype:{valType:\"enumerated\",values:[\"geojson\",\"vector\"],dflt:\"geojson\"},source:{valType:\"any\"},sourcelayer:{valType:\"string\",dflt:\"\"},type:{valType:\"enumerated\",values:[\"circle\",\"line\",\"fill\",\"symbol\"],dflt:\"circle\"},below:{valType:\"string\",dflt:\"\"},color:{valType:\"color\",dflt:i},opacity:{valType:\"number\",min:0,max:1,dflt:1},circle:{radius:{valType:\"number\",dflt:15}},line:{width:{valType:\"number\",dflt:2}},fill:{outlinecolor:{valType:\"color\",dflt:i}},symbol:{icon:{valType:\"string\",dflt:\"marker\"},iconsize:{valType:\"number\",dflt:10},text:{valType:\"string\",dflt:\"\"},textfont:n.extendDeep({},a,{family:{dflt:\"Open Sans Regular, Arial Unicode MS Regular\"}}),textposition:n.extendFlat({},o,{arrayOk:!1})}}}},{\"../../components/color\":603,\"../../lib\":725,\"../../traces/scatter/attributes\":1027,\"../font_attributes\":790}],826:[function(t,e,r){\"use strict\";function n(t,e,r){r(\"accesstoken\"),r(\"style\"),r(\"center.lon\"),r(\"center.lat\"),r(\"zoom\"),r(\"bearing\"),r(\"pitch\"),i(t,e),e._input=t}function i(t,e){function r(t,e){return a.coerce(n,i,s.layers,t,e)}for(var n,i,o=t.layers||[],l=e.layers=[],u=0;u<o.length;u++)if(n=o[u],i={},a.isPlainObject(n)){var c=r(\"sourcetype\");r(\"source\"),\"vector\"===c&&r(\"sourcelayer\");var h=r(\"type\");r(\"below\"),r(\"color\"),r(\"opacity\"),\"circle\"===h&&r(\"circle.radius\"),\"line\"===h&&r(\"line.width\"),\"fill\"===h&&r(\"fill.outlinecolor\"),\"symbol\"===h&&(r(\"symbol.icon\"),r(\"symbol.iconsize\"),r(\"symbol.text\"),a.coerceFont(r,\"symbol.textfont\"),r(\"symbol.textposition\")),i._index=u,l.push(i)}}var a=t(\"../../lib\"),o=t(\"../subplot_defaults\"),s=t(\"./layout_attributes\");e.exports=function(t,e,r){o(t,e,r,{type:\"mapbox\",attributes:s,handleDefaults:n,partition:\"y\"})}},{\"../../lib\":725,\"../subplot_defaults\":836,\"./layout_attributes\":825}],827:[function(t,e,r){\"use strict\";function n(t){this.id=t.id,this.gd=t.gd,this.container=t.container,this.isStatic=t.staticPlot;var e=t.fullLayout;this.uid=e._uid+\"-\"+this.id,this.opts=e[this.id],this.div=null,this.xaxis=null,this.yaxis=null,this.createFramework(e),this.map=null,this.accessToken=null,this.styleObj=null,this.traceHash={},this.layerList=[]}function i(t){var e=d.style.values,r=d.style.dflt,n={};return u.isPlainObject(t)?(n.id=t.id,n.style=t):\"string\"==typeof t?(n.id=t,n.style=-1!==e.indexOf(t)?a(t):t):(n.id=r,n.style=a(r)),n}function a(t){return f.styleUrlPrefix+t+\"-\"+f.styleUrlSuffix}function o(t){return[t.lon,t.lat]}var s=t(\"mapbox-gl\"),l=t(\"../../components/fx\"),u=t(\"../../lib\"),c=t(\"../../components/dragelement\"),h=t(\"../cartesian/select\"),f=t(\"./constants\"),d=t(\"./layout_attributes\"),p=t(\"./layers\"),m=n.prototype;e.exports=function(t){return new n(t)},m.plot=function(t,e,r){var n=this,i=n.opts=e[this.id];n.map&&i.accesstoken!==n.accessToken&&(n.map.remove(),n.map=null,n.styleObj=null,n.traceHash=[],n.layerList={});var a;a=n.map?new Promise(function(r,i){n.updateMap(t,e,r,i)}):new Promise(function(r,i){n.createMap(t,e,r,i)}),r.push(a)},m.createMap=function(t,e,r,n){function a(){l.loneUnhover(e._toppaper)}var c=this,h=c.gd,d=c.opts,p=c.styleObj=i(d.style);c.accessToken=d.accesstoken;var m=c.map=new s.Map({container:c.div,style:p.style,center:o(d.center),zoom:d.zoom,bearing:d.bearing,pitch:d.pitch,interactive:!c.isStatic,preserveDrawingBuffer:c.isStatic,doubleClickZoom:!1,boxZoom:!1}),v=f.controlContainerClassName,g=c.div.getElementsByClassName(v)[0];c.div.removeChild(g),m._canvas.canvas.style.left=\"0px\",m._canvas.canvas.style.top=\"0px\",c.rejectOnError(n),m.once(\"load\",function(){c.updateData(t),c.updateLayout(e),c.resolveOnRender(r)}),c.isStatic||(m.on(\"moveend\",function(t){if(c.map){var e=c.getView();if(d._input.center=d.center=e.center,d._input.zoom=d.zoom=e.zoom,d._input.bearing=d.bearing=e.bearing,d._input.pitch=d.pitch=e.pitch,t.originalEvent){var r={};r[c.id]=u.extendFlat({},e),h.emit(\"plotly_relayout\",r)}}}),m.on(\"mousemove\",function(t){var e=c.div.getBoundingClientRect();t.clientX=t.point.x+e.left,t.clientY=t.point.y+e.top,t.target.getBoundingClientRect=function(){return e},c.xaxis.p2c=function(){return t.lngLat.lng},c.yaxis.p2c=function(){return t.lngLat.lat},l.hover(h,t,c.id)}),m.on(\"click\",function(t){l.click(h,t.originalEvent)}),m.on(\"dragstart\",a),m.on(\"zoomstart\",a),m.on(\"dblclick\",function(){var t=c.viewInitial;m.setCenter(o(t.center)),m.setZoom(t.zoom),m.setBearing(t.bearing),m.setPitch(t.pitch);var e=c.getView();d._input.center=d.center=e.center,d._input.zoom=d.zoom=e.zoom,d._input.bearing=d.bearing=e.bearing,d._input.pitch=d.pitch=e.pitch,h.emit(\"plotly_doubleclick\",null)}))},m.updateMap=function(t,e,r,n){var a=this,o=a.map;a.rejectOnError(n);var s=i(a.opts.style);a.styleObj.id!==s.id?(a.styleObj=s,o.setStyle(s.style),o.style.once(\"load\",function(){a.traceHash={},a.updateData(t),a.updateLayout(e),a.resolveOnRender(r)})):(a.updateData(t),a.updateLayout(e),a.resolveOnRender(r))},m.updateData=function(t){var e,r,n,i,a=this.traceHash;for(n=0;n<t.length;n++){var o=t[n];r=o[0].trace,e=a[r.uid],e?e.update(o):r._module&&(a[r.uid]=r._module.plot(this,o))}var s=Object.keys(a);t:for(n=0;n<s.length;n++){var l=s[n];for(i=0;i<t.length;i++)if(r=t[i][0].trace,l===r.uid)continue t;e=a[l],e.dispose(),delete a[l]}},m.updateLayout=function(t){var e=this.map,r=this.opts;e.setCenter(o(r.center)),e.setZoom(r.zoom),e.setBearing(r.bearing),e.setPitch(r.pitch),this.updateLayers(),this.updateFramework(t),this.updateFx(t),this.map.resize()},m.resolveOnRender=function(t){var e=this.map;e.on(\"render\",function r(){e.loaded()&&(e.off(\"render\",r),t())})},m.rejectOnError=function(t){function e(){t(new Error(f.mapOnErrorMsg))}var r=this.map;r.once(\"error\",e),r.once(\"style.error\",e),r.once(\"source.error\",e),r.once(\"tile.error\",e),r.once(\"layer.error\",e)},m.createFramework=function(t){var e=this,r=e.div=document.createElement(\"div\");r.id=e.uid,r.style.position=\"absolute\",e.container.appendChild(r),e.xaxis={_id:\"x\",c2p:function(t){return e.project(t).x}},e.yaxis={_id:\"y\",c2p:function(t){return e.project(t).y}},e.updateFramework(t)},m.updateFx=function(t){function e(t){var e=r.map.unproject(t);return[e.lng,e.lat]}var r=this,n=r.map,i=r.gd;if(!r.isStatic){var a,o=t.dragmode;if(a=\"select\"===o?function(t,n){(t.range={})[r.id]=[e([n.xmin,n.ymin]),e([n.xmax,n.ymax])]}:function(t,n,i){(t.lassoPoints={})[r.id]=i.filtered.map(e)},\"select\"===o||\"lasso\"===o){n.dragPan.disable();var s={element:r.div,gd:i,plotinfo:{xaxis:r.xaxis,yaxis:r.yaxis,fillRangeItems:a},xaxes:[r.xaxis],yaxes:[r.yaxis],subplot:r.id};s.prepFn=function(t,e,r){h(t,e,r,s,o)},s.doneFn=function(e,r){2===r&&t._zoomlayer.selectAll(\".select-outline\").remove()},c.init(s)}else n.dragPan.enable(),r.div.onmousedown=null}},m.updateFramework=function(t){var e=t[this.id].domain,r=t._size,n=this.div.style;n.width=r.w*(e.x[1]-e.x[0])+\"px\",n.height=r.h*(e.y[1]-e.y[0])+\"px\",n.left=r.l+e.x[0]*r.w+\"px\",n.top=r.t+(1-e.y[1])*r.h+\"px\",this.xaxis._offset=r.l+e.x[0]*r.w,this.xaxis._length=r.w*(e.x[1]-e.x[0]),this.yaxis._offset=r.t+(1-e.y[1])*r.h,this.yaxis._length=r.h*(e.y[1]-e.y[0])},m.updateLayers=function(){var t,e=this.opts,r=e.layers,n=this.layerList;if(r.length!==n.length){for(t=0;t<n.length;t++)n[t].dispose();for(n=this.layerList=[],t=0;t<r.length;t++)n.push(p(this,t,r[t]))}else for(t=0;t<r.length;t++)n[t].update(r[t])},m.destroy=function(){this.map&&(this.map.remove(),this.map=null,this.container.removeChild(this.div))},m.toImage=function(){return this.map.getCanvas().toDataURL()},m.initSource=function(t){var e={type:\"geojson\",data:{type:\"Feature\",geometry:{type:\"Point\",coordinates:[]}}};return this.map.addSource(t,e)},m.setSourceData=function(t,e){this.map.getSource(t).setData(e)},m.setOptions=function(t,e,r){for(var n=this.map,i=Object.keys(r),a=0;a<i.length;a++){var o=i[a];n[e](t,o,r[o])}},m.project=function(t){return this.map.project(new s.LngLat(t[0],t[1]))},m.getView=function(){var t=this.map,e=t.getCenter();return{center:{lon:e.lng,lat:e.lat},zoom:t.getZoom(),bearing:t.getBearing(),pitch:t.getPitch()}}},{\"../../components/dragelement\":624,\"../../components/fx\":644,\"../../lib\":725,\"../cartesian/select\":782,\"./constants\":821,\"./layers\":824,\"./layout_attributes\":825,\"mapbox-gl\":342}],828:[function(t,e,r){\"use strict\";e.exports={t:{valType:\"number\",dflt:0},r:{valType:\"number\",dflt:0},b:{valType:\"number\",dflt:0},l:{valType:\"number\",dflt:0}}},{}],829:[function(t,e,r){\"use strict\";function n(t,e){e.text(\"\");var r=e.append(\"a\").attr({\"xlink:xlink:href\":\"#\",class:\"link--impt link--embedview\",\"font-weight\":\"bold\"}).text(t._context.linkText+\" \"+String.fromCharCode(187));if(t._context.sendData)r.on(\"click\",function(){v.sendDataToCloud(t)});else{var n=window.location.pathname.split(\"/\"),i=window.location.search;r.attr({\"xlink:xlink:show\":\"new\",\"xlink:xlink:href\":\"/\"+n[2].split(\".\")[0]+\"/\"+n[1]+i})}}function i(t,e){var r,n,i=t.trace,a=i._arrayAttrs,o={};for(r=0;r<a.length;r++)n=a[r],o[n]=d.nestedProperty(i,n).get().slice();for(t.trace=e,r=0;r<a.length;r++)n=a[r],d.nestedProperty(t.trace,n).set(o[n])}function a(t,e,r,n){for(var i=t.transforms,a=[t],o=0;o<i.length;o++){var s=i[o],l=_[s.type];l&&l.transform&&(a=l.transform(a,{transform:s,fullTrace:t,fullData:e,layout:r,fullLayout:n,transformIndex:o}))}return a}function o(t){var e,r={left:0,right:0,bottom:0,top:0};if(t)for(e in t)t.hasOwnProperty(e)&&(r.left+=t[e].left||0,r.right+=t[e].right||0,r.bottom+=t[e].bottom||0,r.top+=t[e].top||0);return r}function s(t){for(var e=0;e<t.length;e++){t[e]._categories=t[e]._initialCategories.slice(),t[e]._categoriesMap={};for(var r=0;r<t[e]._categories.length;r++)t[e]._categoriesMap[t[e]._categories[r]]=r}}var l=t(\"d3\"),u=t(\"fast-isnumeric\"),c=t(\"../plotly\"),h=t(\"../plot_api/plot_schema\"),f=t(\"../registry\"),d=t(\"../lib\"),p=t(\"../components/color\"),m=t(\"../constants/numerical\").BADNUM,v=e.exports={},g=t(\"./animation_attributes\"),y=t(\"./frame_attributes\"),b=d.relinkPrivateKeys;d.extendFlat(v,f),v.attributes=t(\"./attributes\"),v.attributes.type.values=v.allTypes,v.fontAttrs=t(\"./font_attributes\"),v.layoutAttributes=t(\"./layout_attributes\"),v.fontWeight=\"normal\";var x=v.subplotsRegistry,_=v.transformsRegistry,w=t(\"../components/errorbars\"),M=t(\"./command\");v.executeAPICommand=M.executeAPICommand,v.computeAPICommandBindings=M.computeAPICommandBindings,v.manageCommandObserver=M.manageCommandObserver,v.hasSimpleAPICommandBindings=M.hasSimpleAPICommandBindings,v.findSubplotIds=function(t,e){var r=[];if(!v.subplotsRegistry[e])return r;for(var n=v.subplotsRegistry[e].attr,i=0;i<t.length;i++){var a=t[i];v.traceIs(a,e)&&-1===r.indexOf(a[n])&&r.push(a[n])}return r},v.getSubplotIds=function(t,e){var r=v.subplotsRegistry[e];if(!r)return[];if(!(\"cartesian\"!==e||t._has&&t._has(\"cartesian\")))return[];if(!(\"gl2d\"!==e||t._has&&t._has(\"gl2d\")))return[];if(\"cartesian\"===e||\"gl2d\"===e)return Object.keys(t._plots||{});for(var n=r.idRegex,i=Object.keys(t),a=[],o=0;o<i.length;o++){var s=i[o];n.test(s)&&a.push(s)}var l=r.idRoot.length;return a.sort(function(t,e){return+(t.substr(l)||1)-+(e.substr(l)||1)}),a},v.getSubplotData=function(t,e,r){if(!v.subplotsRegistry[e])return[];for(var n,i=v.subplotsRegistry[e].attr,a=[],o=0;o<t.length;o++)if(n=t[o],\"gl2d\"===e&&v.traceIs(n,\"gl2d\")){var s=c.Axes.subplotMatch,l=\"x\"+r.match(s)[1],u=\"y\"+r.match(s)[2];n[i[0]]===l&&n[i[1]]===u&&a.push(n)}else n[i]===r&&a.push(n);return a},v.getSubplotCalcData=function(t,e,r){if(!v.subplotsRegistry[e])return[];for(var n=v.subplotsRegistry[e].attr,i=[],a=0;a<t.length;a++){var o=t[a];o[0].trace[n]===r&&i.push(o)}return i},v.redrawText=function(t){if(!(t.data&&t.data[0]&&t.data[0].r))return new Promise(function(e){setTimeout(function(){f.getComponentMethod(\"annotations\",\"draw\")(t),f.getComponentMethod(\"legend\",\"draw\")(t),(t.calcdata||[]).forEach(function(t){t[0]&&t[0].t&&t[0].t.cb&&t[0].t.cb()}),e(v.previousPromises(t))},300)})},v.resize=function(t){return new Promise(function(e,r){t&&\"none\"!==l.select(t).style(\"display\")||r(new Error(\"Resize must be passed a plot div element.\")),t._redrawTimer&&clearTimeout(t._redrawTimer),t._redrawTimer=setTimeout(function(){if(t.layout.width&&t.layout.height)return void e(t);delete t.layout.width,delete t.layout.height;var r=t.changed;t.autoplay=!0,c.relayout(t,{autosize:!0}).then(function(){t.changed=r,e(t)})},100)})},v.previousPromises=function(t){if((t._promises||[]).length)return Promise.all(t._promises).then(function(){t._promises=[]})},v.addLinks=function(t){if(t._context.showLink||t._context.showSources){var e=t._fullLayout,r=e._paper.selectAll(\"text.js-plot-link-container\").data([0]);r.enter().append(\"text\").classed(\"js-plot-link-container\",!0).style({\"font-family\":'\"Open Sans\", Arial, sans-serif',\"font-size\":\"12px\",fill:p.defaultLine,\"pointer-events\":\"all\"}).each(function(){var t=l.select(this);t.append(\"tspan\").classed(\"js-link-to-tool\",!0),t.append(\"tspan\").classed(\"js-link-spacer\",!0),t.append(\"tspan\").classed(\"js-sourcelinks\",!0)});var i=r.node(),a={y:e._paper.attr(\"height\")-9};document.body.contains(i)&&i.getComputedTextLength()>=e.width-20?(a[\"text-anchor\"]=\"start\",a.x=5):(a[\"text-anchor\"]=\"end\",a.x=e._paper.attr(\"width\")-7),r.attr(a);var o=r.select(\".js-link-to-tool\"),s=r.select(\".js-link-spacer\"),u=r.select(\".js-sourcelinks\");t._context.showSources&&t._context.showSources(t),t._context.showLink&&n(t,o),s.text(o.text()&&u.text()?\" - \":\"\")}},v.sendDataToCloud=function(t){t.emit(\"plotly_beforeexport\");var e=window.PLOTLYENV&&window.PLOTLYENV.BASE_URL||\"https://plot.ly\",r=l.select(t).append(\"div\").attr(\"id\",\"hiddenform\").style(\"display\",\"none\"),n=r.append(\"form\").attr({action:e+\"/external\",method:\"post\",target:\"_blank\"});return n.append(\"input\").attr({type:\"text\",name:\"data\"}).node().value=v.graphJson(t,!1,\"keepdata\"),n.node().submit(),r.remove(),t.emit(\"plotly_afterexport\"),!1},v.supplyDefaults=function(t){var e,r=t._fullLayout||{},n=t._fullLayout={},a=t.layout||{},o=t._fullData||[],s=t._fullData=[],l=t.data||[];if(t._transitionData||v.createTransitionData(t),r._initialAutoSizeIsDone){var u=r.width,h=r.height;v.supplyLayoutGlobalDefaults(a,n),a.width||(n.width=u),a.height||(n.height=h)}else{v.supplyLayoutGlobalDefaults(a,n);var f=!a.width||!a.height,d=n.autosize,p=t._context&&t._context.autosizable;f&&(d||p)?v.plotAutoSize(t,a,n):f&&v.sanitizeMargins(t),!d&&f&&(a.width=n.width,a.height=n.height)}n._initialAutoSizeIsDone=!0,n._dataLength=l.length,n._globalTransforms=(t._context||{}).globalTransforms,v.supplyDataDefaults(l,s,a,n),n._has=v._hasPlotType.bind(n);var m=n._modules;for(e=0;e<m.length;e++){var g=m[e];g.cleanData&&g.cleanData(s)}if(o.length===l.length)for(e=0;e<s.length;e++)b(s[e],o[e]);v.supplyLayoutModuleDefaults(a,n,s,t._transitionData),n._hasCartesian=n._has(\"cartesian\"),n._hasGeo=n._has(\"geo\"),n._hasGL3D=n._has(\"gl3d\"),n._hasGL2D=n._has(\"gl2d\"),n._hasTernary=n._has(\"ternary\"),n._hasPie=n._has(\"pie\"),v.cleanPlot(s,n,o,r),v.linkSubplots(s,n,o,r),b(n,r),v.doAutoMargin(t);var y=c.Axes.list(t);for(e=0;e<y.length;e++){y[e].setScale()}if((t.calcdata||[]).length===s.length)for(e=0;e<s.length;e++){var x=s[e],_=t.calcdata[e][0];_&&_.trace&&(_.trace._hasCalcTransform?i(_,x):_.trace=x)}},v.createTransitionData=function(t){t._transitionData||(t._transitionData={}),t._transitionData._frames||(t._transitionData._frames=[]),t._transitionData._frameHash||(t._transitionData._frameHash={}),t._transitionData._counter||(t._transitionData._counter=0),t._transitionData._interruptCallbacks||(t._transitionData._interruptCallbacks=[])},v._hasPlotType=function(t){for(var e=this._basePlotModules||[],r=0;r<e.length;r++){if(e[r].name===t)return!0}return!1},v.cleanPlot=function(t,e,r,n){var i,a,o=n._basePlotModules||[];for(i=0;i<o.length;i++){var s=o[i];s.clean&&s.clean(t,e,r,n)}var l=!!n._paper,u=!!n._infolayer;t:for(i=0;i<r.length;i++){var c=r[i],h=c.uid;for(a=0;a<t.length;a++){var f=t[a];if(h===f.uid)continue t}var d=\".hm\"+h+\",.contour\"+h+\",.carpet\"+h+\",#clip\"+h+\",.trace\"+h;l&&n._paper.selectAll(d).remove(),u&&(n._infolayer.selectAll(\".cb\"+h).remove(),n._infolayer.selectAll(\"g.rangeslider-container\").selectAll(d).remove())}n._zoomlayer&&n._zoomlayer.selectAll(\".select-outline\").remove()},v.linkSubplots=function(t,e,r,n){var i,a=n._plots||{},o=e._plots={},s={_fullData:t,_fullLayout:e},l=c.Axes.getSubplots(s);for(i=0;i<l.length;i++){var u,h=l[i],f=a[h],d=c.Axes.getFromId(s,h,\"x\"),p=c.Axes.getFromId(s,h,\"y\");f?(u=o[h]=f,u._scene2d&&u._scene2d.updateRefs(e),u.xaxis.layer!==d.layer&&(u.xlines.attr(\"d\",null),u.xaxislayer.selectAll(\"*\").remove()),u.yaxis.layer!==p.layer&&(u.ylines.attr(\"d\",null),u.yaxislayer.selectAll(\"*\").remove())):(u=o[h]={},u.id=h),u.xaxis=d,u.yaxis=p,u._hasClipOnAxisFalse=!1;for(var m=0;m<t.length;m++){var v=t[m];if(v.xaxis===u.xaxis._id&&v.yaxis===u.yaxis._id&&!1===v.cliponaxis){u._hasClipOnAxisFalse=!0;break}}}var g=c.Axes.list(s,null,!0);for(i=0;i<g.length;i++){var y=g[i],b=null;y.overlaying&&(b=c.Axes.getFromId(s,y.overlaying))&&b.overlaying&&(y.overlaying=!1,b=null),y._mainAxis=b||y,b&&(y.domain=b.domain.slice()),y._anchorAxis=\"free\"===y.anchor?null:c.Axes.getFromId(s,y.anchor)}},v.clearExpandedTraceDefaultColors=function(t){function e(t,e,i,a){n[a]=e,n.length=a+1,\"color\"===t.valType&&void 0===t.dflt&&r.push(n.join(\".\"))}var r,n,i;for(n=[],r=t._module._colorAttrs,r||(t._module._colorAttrs=r=[],h.crawl(t._module.attributes,e)),i=0;i<r.length;i++){d.nestedProperty(t,\"_input.\"+r[i]).get()||d.nestedProperty(t,r[i]).set(null)}},v.supplyDataDefaults=function(t,e,r,n){function i(t){e.push(t);var r=t._module;r&&(d.pushUnique(u,r),d.pushUnique(c,t._module.basePlotModule),h++)}var o,s,l,u=n._modules=[],c=n._basePlotModules=[],h=0;n._transformModules=[];var p={},m=[];for(o=0;o<t.length;o++){if(l=t[o],s=v.supplyTraceDefaults(l,h,n,o),s.index=o,s._input=l,s._expandedIndex=h,s.transforms&&s.transforms.length)for(var g=a(s,e,r,n),y=0;y<g.length;y++){var x=g[y],_=v.supplyTraceDefaults(x,h,n,o);b(_,x),x.uid=_.uid=s.uid+y,_.index=o,_._input=l,_._fullInput=s,_._expandedIndex=h,_._expandedInput=x,i(_)}else s._fullInput=s,s._expandedInput=s,i(s);f.traceIs(s,\"carpetAxis\")&&(p[s.carpet]=s),f.traceIs(s,\"carpetDependent\")&&m.push(o)}for(o=0;o<m.length;o++)if(s=e[m[o]],s.visible){var w=p[s.carpet];s._carpet=w,w&&w.visible?(s.xaxis=w.xaxis,s.yaxis=w.yaxis):s.visible=!1}},v.supplyAnimationDefaults=function(t){function e(e,r){return d.coerce(t||{},n,g,e,r)}t=t||{};var r,n={};if(e(\"mode\"),e(\"direction\"),e(\"fromcurrent\"),Array.isArray(t.frame))for(n.frame=[],r=0;r<t.frame.length;r++)n.frame[r]=v.supplyAnimationFrameDefaults(t.frame[r]||{});else n.frame=v.supplyAnimationFrameDefaults(t.frame||{});if(Array.isArray(t.transition))for(n.transition=[],r=0;r<t.transition.length;r++)n.transition[r]=v.supplyAnimationTransitionDefaults(t.transition[r]||{});else n.transition=v.supplyAnimationTransitionDefaults(t.transition||{});return n},v.supplyAnimationFrameDefaults=function(t){function e(e,n){return d.coerce(t||{},r,g.frame,e,n)}var r={};return e(\"duration\"),e(\"redraw\"),r},v.supplyAnimationTransitionDefaults=function(t){function e(e,n){return d.coerce(t||{},r,g.transition,e,n)}var r={};return e(\"duration\"),e(\"easing\"),r},v.supplyFrameDefaults=function(t){function e(e,n){return d.coerce(t,r,y,e,n)}var r={};return e(\"group\"),e(\"name\"),e(\"traces\"),e(\"baseframe\"),e(\"data\"),e(\"layout\"),r},v.supplyTraceDefaults=function(t,e,r,n){function i(e,r){return d.coerce(t,o,v.attributes,e,r)}function a(e,r){if(v.traceIs(o,e))return d.coerce(t,o,v.subplotsRegistry[e].attributes,r)}var o={},s=p.defaults[e%p.defaults.length],l=i(\"visible\");i(\"type\"),i(\"uid\"),i(\"name\",\"trace \"+n);for(var u=Object.keys(x),c=0;c<u.length;c++){var h=u[c];if(-1===[\"cartesian\",\"gl2d\"].indexOf(h)){var m=x[h].attr;m&&a(h,m)}}if(l){i(\"customdata\"),i(\"ids\");var g=v.getModule(o);o._module=g,v.traceIs(o,\"showLegend\")&&(i(\"showlegend\"),i(\"legendgroup\")),f.getComponentMethod(\"fx\",\"supplyDefaults\")(t,o,s,r),g&&(g.supplyDefaults(t,o,s,r),d.coerceHoverinfo(t,o,r)),v.traceIs(o,\"noOpacity\")||i(\"opacity\"),a(\"cartesian\",\"xaxis\"),a(\"cartesian\",\"yaxis\"),a(\"gl2d\",\"xaxis\"),a(\"gl2d\",\"yaxis\"),v.traceIs(o,\"notLegendIsolatable\")&&(o.visible=!!o.visible),v.supplyTransformDefaults(t,o,r)}return o},v.supplyTransformDefaults=function(t,e,r){var n=r._globalTransforms||[],i=r._transformModules||[];if(Array.isArray(t.transforms)||0!==n.length)for(var a=t.transforms||[],o=n.concat(a),s=e.transforms=[],l=0;l<o.length;l++){var u,c=o[l],h=c.type,f=_[h];f||d.warn(\"Unrecognized transform type \"+h+\".\"),f&&f.supplyDefaults?(u=f.supplyDefaults(c,e,r,t),u.type=h,u._module=f,d.pushUnique(i,f)):u=d.extendFlat({},c),s.push(u)}},v.supplyLayoutGlobalDefaults=function(t,e){function r(r,n){return d.coerce(t,e,v.layoutAttributes,r,n)}var n=d.coerceFont(r,\"font\");r(\"title\"),d.coerceFont(r,\"titlefont\",{family:n.family,size:Math.round(1.4*n.size),color:n.color}),r(\"autosize\",!(t.width&&t.height)),r(\"width\"),r(\"height\"),r(\"margin.l\"),r(\"margin.r\"),r(\"margin.t\"),r(\"margin.b\"),r(\"margin.pad\"),r(\"margin.autoexpand\"),t.width&&t.height&&v.sanitizeMargins(e),r(\"paper_bgcolor\"),r(\"separators\"),r(\"hidesources\"),r(\"smith\"),f.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\"),f.getComponentMethod(\"fx\",\"supplyLayoutGlobalDefaults\")(t,e,r)},v.plotAutoSize=function(t,e,r){var n,i,a=t._context||{},s=a.frameMargins,l=d.isPlotDiv(t);if(l&&t.emit(\"plotly_autosize\"),a.fillFrame)n=window.innerWidth,i=window.innerHeight,document.body.style.overflow=\"hidden\";else if(u(s)&&s>0){var c=o(t._boundingBoxMargins),h=c.left+c.right,f=c.bottom+c.top,p=1-2*s,m=r._container&&r._container.node?r._container.node().getBoundingClientRect():{width:r.width,height:r.height};n=Math.round(p*(m.width-h)),i=Math.round(p*(m.height-f))}else{var g=l?window.getComputedStyle(t):{};n=parseFloat(g.width)||r.width,i=parseFloat(g.height)||r.height}var y=v.layoutAttributes.width.min,b=v.layoutAttributes.height.min;n<y&&(n=y),i<b&&(i=b);var x=!e.width&&Math.abs(r.width-n)>1,_=!e.height&&Math.abs(r.height-i)>1;(_||x)&&(x&&(r.width=n),_&&(r.height=i)),t._initialAutoSize||(t._initialAutoSize={width:n,height:i}),v.sanitizeMargins(r)},v.supplyLayoutModuleDefaults=function(t,e,r,n){var i,a;c.Axes.supplyLayoutDefaults(t,e,r);var o=e._basePlotModules;for(i=0;i<o.length;i++)a=o[i],\"cartesian\"!==a.name&&a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r);var s=e._modules;for(i=0;i<s.length;i++)a=s[i],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r);var l=e._transformModules;for(i=0;i<l.length;i++)a=l[i],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r,n);var u=Object.keys(f.componentsRegistry);for(i=0;i<u.length;i++)a=f.componentsRegistry[u[i]],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r)},v.purge=function(t){var e=t._fullLayout||{};void 0!==e._glcontainer&&e._glcontainer.remove(),void 0!==e._geocontainer&&e._geocontainer.remove(),e._modeBar&&e._modeBar.destroy(),t._transitionData&&(t._transitionData._interruptCallbacks&&(t._transitionData._interruptCallbacks.length=0),t._transitionData._animationRaf&&window.cancelAnimationFrame(t._transitionData._animationRaf)),delete t.data,delete t.layout,delete t._fullData,delete t._fullLayout,delete t.calcdata,delete t.framework,delete t.empty,delete t.fid,delete t.undoqueue,delete t.undonum,delete t.autoplay,delete t.changed,delete t._promises,delete t._redrawTimer,delete t.firstscatter,delete t.hmlumcount,delete t.hmpixcount,delete t.numboxes,delete t._hoverTimer,delete t._lastHoverTime,delete t._transitionData,delete t._transitioning,delete t._initialAutoSize,t.removeAllListeners&&t.removeAllListeners()},v.style=function(t){for(var e=t._fullLayout._modules,r=0;r<e.length;r++){var n=e[r];n.style&&n.style(t)}},v.sanitizeMargins=function(t){if(t&&t.margin){var e,r=t.width,n=t.height,i=t.margin,a=r-(i.l+i.r),o=n-(i.t+i.b);a<0&&(e=(r-1)/(i.l+i.r),i.l=Math.floor(e*i.l),i.r=Math.floor(e*i.r)),o<0&&(e=(n-1)/(i.t+i.b),i.t=Math.floor(e*i.t),i.b=Math.floor(e*i.b))}},v.autoMargin=function(t,e,r){var n=t._fullLayout;if(n._pushmargin||(n._pushmargin={}),!1!==n.margin.autoexpand){if(r){var i=void 0===r.pad?12:r.pad;r.l+r.r>.5*n.width&&(r.l=r.r=0),r.b+r.t>.5*n.height&&(r.b=r.t=0),n._pushmargin[e]={l:{val:r.x,size:r.l+i},r:{val:r.x,size:r.r+i},b:{val:r.y,size:r.b+i},t:{val:r.y,size:r.t+i}}}else delete n._pushmargin[e];n._replotting||v.doAutoMargin(t)}},v.doAutoMargin=function(t){var e=t._fullLayout;e._size||(e._size={}),e._pushmargin||(e._pushmargin={});var r=e._size,n=JSON.stringify(r),i=Math.max(e.margin.l||0,0),a=Math.max(e.margin.r||0,0),o=Math.max(e.margin.t||0,0),s=Math.max(e.margin.b||0,0),l=e._pushmargin;if(!1!==e.margin.autoexpand){l.base={l:{val:0,size:i},r:{val:1,size:a},t:{val:1,size:o},b:{val:0,size:s}}\n",
       ";for(var h=Object.keys(l),f=0;f<h.length;f++)for(var d=h[f],p=l[d].l||{},m=l[d].b||{},v=p.val,g=p.size,y=m.val,b=m.size,x=0;x<h.length;x++){var _=h[x];if(u(g)&&l[_].r){var w=l[_].r.val,M=l[_].r.size;if(w>v){var k=(g*w+(M-e.width)*v)/(w-v),A=(M*(1-v)+(g-e.width)*(1-w))/(w-v);k>=0&&A>=0&&k+A>i+a&&(i=k,a=A)}}if(u(b)&&l[_].t){var T=l[_].t.val,S=l[_].t.size;if(T>y){var E=(b*T+(S-e.height)*y)/(T-y),L=(S*(1-y)+(b-e.height)*(1-T))/(T-y);E>=0&&L>=0&&E+L>s+o&&(s=E,o=L)}}}}if(r.l=Math.round(i),r.r=Math.round(a),r.t=Math.round(o),r.b=Math.round(s),r.p=Math.round(e.margin.pad),r.w=Math.round(e.width)-r.l-r.r,r.h=Math.round(e.height)-r.t-r.b,!e._replotting&&\"{}\"!==n&&n!==JSON.stringify(e._size))return c.plot(t)},v.graphJson=function(t,e,r,n,i){function a(t){if(\"function\"==typeof t)return null;if(d.isPlainObject(t)){var e,n,i={};for(e in t)if(\"function\"!=typeof t[e]&&-1===[\"_\",\"[\"].indexOf(e.charAt(0))){if(\"keepdata\"===r){if(\"src\"===e.substr(e.length-3))continue}else if(\"keepstream\"===r){if(\"string\"==typeof(n=t[e+\"src\"])&&n.indexOf(\":\")>0&&!d.isPlainObject(t.stream))continue}else if(\"keepall\"!==r&&\"string\"==typeof(n=t[e+\"src\"])&&n.indexOf(\":\")>0)continue;i[e]=a(t[e])}return i}return Array.isArray(t)?t.map(a):d.isJSDate(t)?d.ms2DateTimeLocal(+t):t}(i&&e&&!t._fullData||i&&!e&&!t._fullLayout)&&v.supplyDefaults(t);var o=i?t._fullData:t.data,s=i?t._fullLayout:t.layout,l=(t._transitionData||{})._frames,u={data:(o||[]).map(function(t){var r=a(t);return e&&delete r.fit,r})};return e||(u.layout=a(s)),t.framework&&t.framework.isPolar&&(u=t.framework.getConfig()),l&&(u.frames=a(l)),\"object\"===n?u:JSON.stringify(u)},v.modifyFrames=function(t,e){var r,n,i,a=t._transitionData._frames,o=t._transitionData._frameHash;for(r=0;r<e.length;r++)switch(n=e[r],n.type){case\"replace\":i=n.value;var s=(a[n.index]||{}).name,l=i.name;a[n.index]=o[l]=i,l!==s&&(delete o[s],o[l]=i);break;case\"insert\":i=n.value,o[i.name]=i,a.splice(n.index,0,i);break;case\"delete\":i=a[n.index],delete o[i.name],a.splice(n.index,1)}return Promise.resolve()},v.computeFrame=function(t,e){var r,n,i,a,o=t._transitionData._frameHash;if(!e)throw new Error(\"computeFrame must be given a string frame name\");var s=o[e.toString()];if(!s)return!1;for(var l=[s],u=[s.name];s.baseframe&&(s=o[s.baseframe.toString()])&&-1===u.indexOf(s.name);)l.push(s),u.push(s.name);for(var c={};s=l.pop();)if(s.layout&&(c.layout=v.extendLayout(c.layout,s.layout)),s.data){if(c.data||(c.data=[]),!(n=s.traces))for(n=[],r=0;r<s.data.length;r++)n[r]=r;for(c.traces||(c.traces=[]),r=0;r<s.data.length;r++)void 0!==(i=n[r])&&null!==i&&(a=c.traces.indexOf(i),-1===a&&(a=c.data.length,c.traces[a]=i),c.data[a]=v.extendTrace(c.data[a],s.data[r]))}return c},v.recomputeFrameHash=function(t){for(var e=t._transitionData._frameHash={},r=t._transitionData._frames,n=0;n<r.length;n++){var i=r[n];i&&i.name&&(e[i.name]=i)}},v.extendObjectWithContainers=function(t,e,r){var n,i,a,o,s,l,u,c,h=d.extendDeepNoArrays({},e||{}),f=d.expandObjectPaths(h),p={};if(r&&r.length)for(a=0;a<r.length;a++)n=d.nestedProperty(f,r[a]),i=n.get(),void 0===i?d.nestedProperty(p,r[a]).set(null):(n.set(null),d.nestedProperty(p,r[a]).set(i));if(t=d.extendDeepNoArrays(t||{},f),r&&r.length)for(a=0;a<r.length;a++)if(s=d.nestedProperty(p,r[a]),u=s.get()){for(l=d.nestedProperty(t,r[a]),c=l.get(),Array.isArray(c)||(c=[],l.set(c)),o=0;o<u.length;o++){var m=u[o];c[o]=null===m?null:v.extendObjectWithContainers(c[o],m)}l.set(c)}return t},v.dataArrayContainers=[\"transforms\"],v.layoutArrayContainers=f.layoutArrayContainers,v.extendTrace=function(t,e){return v.extendObjectWithContainers(t,e,v.dataArrayContainers)},v.extendLayout=function(t,e){return v.extendObjectWithContainers(t,e,v.layoutArrayContainers)},v.transition=function(t,e,r,n,i,a){function o(){var n;for(n=0;n<y.length;n++){var i=y[n],a=t._fullData[i],o=a._module;o&&(o.animatable&&b.push(i),t.data[y[n]]=v.extendTrace(t.data[y[n]],e[n]))}var s=d.expandObjectPaths(d.extendDeepNoArrays({},r)),l=/^[xy]axis[0-9]*$/;for(var u in s)l.test(u)&&delete s[u].range;return v.extendLayout(t.layout,s),delete t.calcdata,v.supplyDefaults(t),v.doCalcdata(t),w.calc(t),Promise.resolve()}function s(t){var e=Promise.resolve();if(!t)return e;for(;t.length;)e=e.then(t.shift());return e}function l(t){if(t)for(;t.length;)t.shift()}function u(){return t.emit(\"plotly_transitioning\",[]),new Promise(function(e){function n(){return l++,function(){u++,x||u!==l||h(e)}}t._transitioning=!0,a.duration>0&&(t._transitioningWithDuration=!0),t._transitionData._interruptCallbacks.push(function(){x=!0}),i.redraw&&t._transitionData._interruptCallbacks.push(function(){return c.redraw(t)}),t._transitionData._interruptCallbacks.push(function(){t.emit(\"plotly_transitioninterrupted\",[])});var o,s,l=0,u=0,f=t._fullLayout._basePlotModules,p=!1;if(r)for(s=0;s<f.length;s++)if(f[s].transitionAxes){var m=d.expandObjectPaths(r);p=f[s].transitionAxes(t,m,a,n)||p}for(p?(o=d.extendFlat({},a),o.duration=0):o=a,s=0;s<f.length;s++)f[s].plot(t,b,o,n);setTimeout(n())})}function h(e){if(t._transitionData)return l(t._transitionData._interruptCallbacks),Promise.resolve().then(function(){if(i.redraw)return c.redraw(t)}).then(function(){t._transitioning=!1,t._transitioningWithDuration=!1,t.emit(\"plotly_transitioned\",[])}).then(e)}function f(){if(t._transitionData)return t._transitioning=!1,s(t._transitionData._interruptCallbacks)}var p,m,g=Array.isArray(e)?e.length:0,y=n.slice(0,g),b=[],x=!1;for(p=0;p<y.length;p++){m=y[p];var _=t._fullData[m],M=_._module;if(M&&!M.animatable){var k={};for(var A in e[p])k[A]=[e[p][A]]}}var T=[v.previousPromises,f,o,v.rehover,u],S=d.syncOrAsync(T,t);return S&&S.then||(S=Promise.resolve()),S.then(function(){return t})},v.doCalcdata=function(t,e){var r,n,i,a,o=c.Axes.list(t),l=t._fullData,u=t._fullLayout,d=new Array(l.length),p=(t.calcdata||[]).slice(0);for(t.calcdata=d,t.firstscatter=!0,t.numboxes=0,t._hmpixcount=0,t._hmlumcount=0,u._piecolormap={},u._piedefaultcolorcount=0,i=0;i<l.length;i++)Array.isArray(e)&&-1===e.indexOf(i)&&(d[i]=p[i]);for(i=0;i<l.length;i++)r=l[i],r._arrayAttrs=h.findArrayAttributes(r);s(o);var v=!1;for(i=0;i<l.length;i++)if(r=l[i],!0===r.visible&&r.transforms)for(n=r._module,n&&n.calc&&n.calc(t,r),a=0;a<r.transforms.length;a++){var g=r.transforms[a];n=_[g.type],n&&n.calcTransform&&(r._hasCalcTransform=!0,v=!0,n.calcTransform(t,r,g))}if(v){for(i=0;i<o.length;i++)o[i]._min=[],o[i]._max=[],o[i]._categories=[],o[i]._categoriesMap={};s(o)}for(i=0;i<l.length;i++){var y=[];r=l[i],!0===r.visible&&(n=r._module)&&n.calc&&(y=n.calc(t,r)),Array.isArray(y)&&y[0]||(y=[{x:m,y:m}]),y[0].t||(y[0].t={}),y[0].trace=r,d[i]=y}f.getComponentMethod(\"fx\",\"calc\")(t)},v.rehover=function(t){t._fullLayout._rehover&&t._fullLayout._rehover()},v.generalUpdatePerTraceModule=function(t,e,r){var n,i=t.traceHash,a={};for(n=0;n<e.length;n++){var o=e[n],s=o[0].trace;s.visible&&(a[s.type]=a[s.type]||[],a[s.type].push(o))}var l=Object.keys(i),u=Object.keys(a);for(n=0;n<l.length;n++){var c=l[n];if(-1===u.indexOf(c)){var h=i[c][0];h[0].trace.visible=!1,a[c]=[h]}}for(u=Object.keys(a),n=0;n<u.length;n++){var f=a[u[n]];f[0][0].trace._module.plot(t,function(t){for(var e=[],r=0;r<t.length;r++){var n=t[r];!0===n[0].trace.visible&&e.push(n)}return e}(f),r)}t.traceHash=a}},{\"../components/color\":603,\"../components/errorbars\":633,\"../constants/numerical\":705,\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plotly\":761,\"../registry\":844,\"./animation_attributes\":762,\"./attributes\":764,\"./command\":789,\"./font_attributes\":790,\"./frame_attributes\":791,\"./layout_attributes\":820,d3:121,\"fast-isnumeric\":130}],830:[function(t,e,r){\"use strict\";var n=t(\"../../traces/scatter/attributes\"),i=n.marker;e.exports={r:n.r,t:n.t,marker:{color:i.color,size:i.size,symbol:i.symbol,opacity:i.opacity}}},{\"../../traces/scatter/attributes\":1027}],831:[function(t,e,r){\"use strict\";function n(t,e){return a({},e,{showline:{valType:\"boolean\"},showticklabels:{valType:\"boolean\"},tickorientation:{valType:\"enumerated\",values:[\"horizontal\",\"vertical\"]},ticklen:{valType:\"number\",min:0},tickcolor:{valType:\"color\"},ticksuffix:{valType:\"string\"},endpadding:{valType:\"number\"},visible:{valType:\"boolean\"}})}var i=t(\"../cartesian/layout_attributes\"),a=t(\"../../lib/extend\").extendFlat,o=a({},i.domain,{});e.exports={radialaxis:n(\"radial\",{range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},domain:o,orientation:{valType:\"number\"}}),angularaxis:n(\"angular\",{range:{valType:\"info_array\",items:[{valType:\"number\",dflt:0},{valType:\"number\",dflt:360}]},domain:o}),layout:{direction:{valType:\"enumerated\",values:[\"clockwise\",\"counterclockwise\"]},orientation:{valType:\"angle\"}}}},{\"../../lib/extend\":716,\"../cartesian/layout_attributes\":777}],832:[function(t,e,r){\"use strict\";(e.exports=t(\"./micropolar\")).manager=t(\"./micropolar_manager\")},{\"./micropolar\":833,\"./micropolar_manager\":834}],833:[function(t,e,r){var n=t(\"d3\"),i=t(\"../../lib\"),a=i.extendDeepAll,o=t(\"../../constants/alignment\").MID_SHIFT,s=e.exports={version:\"0.2.2\"};s.Axis=function(){function t(t){r=t||r;var c=u.data,f=u.layout;return(\"string\"==typeof r||r.nodeName)&&(r=n.select(r)),r.datum(c).each(function(t,r){function u(t,e){return l(t)%360+f.orientation}var c=t.slice();h={data:s.util.cloneJson(c),layout:s.util.cloneJson(f)};var d=0;c.forEach(function(t,e){t.color||(t.color=f.defaultColorRange[d],d=(d+1)%f.defaultColorRange.length),t.strokeColor||(t.strokeColor=\"LinePlot\"===t.geometry?t.color:n.rgb(t.color).darker().toString()),h.data[e].color=t.color,h.data[e].strokeColor=t.strokeColor,h.data[e].strokeDash=t.strokeDash,h.data[e].strokeSize=t.strokeSize});var p=c.filter(function(t,e){var r=t.visible;return void 0===r||!0===r}),m=!1,v=p.map(function(t,e){return m=m||void 0!==t.groupId,t});if(m){var g=n.nest().key(function(t,e){return void 0!==t.groupId?t.groupId:\"unstacked\"}).entries(v),y=[],b=g.map(function(t,e){if(\"unstacked\"===t.key)return t.values;var r=t.values[0].r.map(function(t,e){return 0});return t.values.forEach(function(t,e,n){t.yStack=[r],y.push(r),r=s.util.sumArrays(t.r,r)}),t.values});p=n.merge(b)}p.forEach(function(t,e){t.t=Array.isArray(t.t[0])?t.t:[t.t],t.r=Array.isArray(t.r[0])?t.r:[t.r]});var x=Math.min(f.width-f.margin.left-f.margin.right,f.height-f.margin.top-f.margin.bottom)/2;x=Math.max(10,x);var _,w=[f.margin.left+x,f.margin.top+x];if(m){_=[0,n.max(s.util.sumArrays(s.util.arrayLast(p).r[0],s.util.arrayLast(y)))]}else _=n.extent(s.util.flattenArray(p.map(function(t,e){return t.r})));f.radialAxis.domain!=s.DATAEXTENT&&(_[0]=0),i=n.scale.linear().domain(f.radialAxis.domain!=s.DATAEXTENT&&f.radialAxis.domain?f.radialAxis.domain:_).range([0,x]),h.layout.radialAxis.domain=i.domain();var M,k=s.util.flattenArray(p.map(function(t,e){return t.t})),A=\"string\"==typeof k[0];A&&(k=s.util.deduplicate(k),M=k.slice(),k=n.range(k.length),p=p.map(function(t,e){var r=t;return t.t=[k],m&&(r.yStack=t.yStack),r}));var T=p.filter(function(t,e){return\"LinePlot\"===t.geometry||\"DotPlot\"===t.geometry}).length===p.length,S=null===f.needsEndSpacing?A||!T:f.needsEndSpacing,E=f.angularAxis.domain&&f.angularAxis.domain!=s.DATAEXTENT&&!A&&f.angularAxis.domain[0]>=0,L=E?f.angularAxis.domain:n.extent(k),C=Math.abs(k[1]-k[0]);T&&!A&&(C=0);var z=L.slice();S&&A&&(z[1]+=C);var I=f.angularAxis.ticksCount||4;I>8&&(I=I/(I/8)+I%8),f.angularAxis.ticksStep&&(I=(z[1]-z[0])/I);var D=f.angularAxis.ticksStep||(z[1]-z[0])/(I*(f.minorTicks+1));M&&(D=Math.max(Math.round(D),1)),z[2]||(z[2]=D);var P=n.range.apply(this,z);if(P=P.map(function(t,e){return parseFloat(t.toPrecision(12))}),l=n.scale.linear().domain(z.slice(0,2)).range(\"clockwise\"===f.direction?[0,360]:[360,0]),h.layout.angularAxis.domain=l.domain(),h.layout.angularAxis.endPadding=S?C:0,void 0===(e=n.select(this).select(\"svg.chart-root\"))||e.empty()){var O=(new DOMParser).parseFromString(\"<svg xmlns='http://www.w3.org/2000/svg' class='chart-root'>' + '<g class='outer-group'>' + '<g class='chart-group'>' + '<circle class='background-circle'></circle>' + '<g class='geometry-group'></g>' + '<g class='radial axis-group'>' + '<circle class='outside-circle'></circle>' + '</g>' + '<g class='angular axis-group'></g>' + '<g class='guides-group'><line></line><circle r='0'></circle></g>' + '</g>' + '<g class='legend-group'></g>' + '<g class='tooltips-group'></g>' + '<g class='title-group'><text></text></g>' + '</g>' + '</svg>\",\"application/xml\"),R=this.appendChild(this.ownerDocument.importNode(O.documentElement,!0));e=n.select(R)}e.select(\".guides-group\").style({\"pointer-events\":\"none\"}),e.select(\".angular.axis-group\").style({\"pointer-events\":\"none\"}),e.select(\".radial.axis-group\").style({\"pointer-events\":\"none\"});var F,j=e.select(\".chart-group\"),N={fill:\"none\",stroke:f.tickColor},B={\"font-size\":f.font.size,\"font-family\":f.font.family,fill:f.font.color,\"text-shadow\":[\"-1px 0px\",\"1px -1px\",\"-1px 1px\",\"1px 1px\"].map(function(t,e){return\" \"+t+\" 0 \"+f.font.outlineColor}).join(\",\")};if(f.showLegend){F=e.select(\".legend-group\").attr({transform:\"translate(\"+[x,f.margin.top]+\")\"}).style({display:\"block\"});var U=p.map(function(t,e){var r=s.util.cloneJson(t);return r.symbol=\"DotPlot\"===t.geometry?t.dotType||\"circle\":\"LinePlot\"!=t.geometry?\"square\":\"line\",r.visibleInLegend=void 0===t.visibleInLegend||t.visibleInLegend,r.color=\"LinePlot\"===t.geometry?t.strokeColor:t.color,r});s.Legend().config({data:p.map(function(t,e){return t.name||\"Element\"+e}),legendConfig:a({},s.Legend.defaultConfig().legendConfig,{container:F,elements:U,reverseOrder:f.legend.reverseOrder})})();var V=F.node().getBBox();x=Math.min(f.width-V.width-f.margin.left-f.margin.right,f.height-f.margin.top-f.margin.bottom)/2,x=Math.max(10,x),w=[f.margin.left+x,f.margin.top+x],i.range([0,x]),h.layout.radialAxis.domain=i.domain(),F.attr(\"transform\",\"translate(\"+[w[0]+x,w[1]-x]+\")\")}else F=e.select(\".legend-group\").style({display:\"none\"});e.attr({width:f.width,height:f.height}).style({opacity:f.opacity}),j.attr(\"transform\",\"translate(\"+w+\")\").style({cursor:\"crosshair\"});var H=[(f.width-(f.margin.left+f.margin.right+2*x+(V?V.width:0)))/2,(f.height-(f.margin.top+f.margin.bottom+2*x))/2];if(H[0]=Math.max(0,H[0]),H[1]=Math.max(0,H[1]),e.select(\".outer-group\").attr(\"transform\",\"translate(\"+H+\")\"),f.title){var q=e.select(\"g.title-group text\").style(B).text(f.title),G=q.node().getBBox();q.attr({x:w[0]-G.width/2,y:w[1]-x-20})}var Y=e.select(\".radial.axis-group\");if(f.radialAxis.gridLinesVisible){var X=Y.selectAll(\"circle.grid-circle\").data(i.ticks(5));X.enter().append(\"circle\").attr({class:\"grid-circle\"}).style(N),X.attr(\"r\",i),X.exit().remove()}Y.select(\"circle.outside-circle\").attr({r:x}).style(N);var W=e.select(\"circle.background-circle\").attr({r:x}).style({fill:f.backgroundColor,stroke:f.stroke});if(f.radialAxis.visible){var Z=n.svg.axis().scale(i).ticks(5).tickSize(5);Y.call(Z).attr({transform:\"rotate(\"+f.radialAxis.orientation+\")\"}),Y.selectAll(\".domain\").style(N),Y.selectAll(\"g>text\").text(function(t,e){return this.textContent+f.radialAxis.ticksSuffix}).style(B).style({\"text-anchor\":\"start\"}).attr({x:0,y:0,dx:0,dy:0,transform:function(t,e){return\"horizontal\"===f.radialAxis.tickOrientation?\"rotate(\"+-f.radialAxis.orientation+\") translate(\"+[0,B[\"font-size\"]]+\")\":\"translate(\"+[0,B[\"font-size\"]]+\")\"}}),Y.selectAll(\"g>line\").style({stroke:\"black\"})}var J=e.select(\".angular.axis-group\").selectAll(\"g.angular-tick\").data(P),K=J.enter().append(\"g\").classed(\"angular-tick\",!0);J.attr({transform:function(t,e){return\"rotate(\"+u(t,e)+\")\"}}).style({display:f.angularAxis.visible?\"block\":\"none\"}),J.exit().remove(),K.append(\"line\").classed(\"grid-line\",!0).classed(\"major\",function(t,e){return e%(f.minorTicks+1)==0}).classed(\"minor\",function(t,e){return!(e%(f.minorTicks+1)==0)}).style(N),K.selectAll(\".minor\").style({stroke:f.minorTickColor}),J.select(\"line.grid-line\").attr({x1:f.tickLength?x-f.tickLength:0,x2:x}).style({display:f.angularAxis.gridLinesVisible?\"block\":\"none\"}),K.append(\"text\").classed(\"axis-text\",!0).style(B);var Q=J.select(\"text.axis-text\").attr({x:x+f.labelOffset,dy:o+\"em\",transform:function(t,e){var r=u(t,e),n=x+f.labelOffset,i=f.angularAxis.tickOrientation;return\"horizontal\"==i?\"rotate(\"+-r+\" \"+n+\" 0)\":\"radial\"==i?r<270&&r>90?\"rotate(180 \"+n+\" 0)\":null:\"rotate(\"+(r<=180&&r>0?-90:90)+\" \"+n+\" 0)\"}}).style({\"text-anchor\":\"middle\",display:f.angularAxis.labelsVisible?\"block\":\"none\"}).text(function(t,e){return e%(f.minorTicks+1)!=0?\"\":M?M[t]+f.angularAxis.ticksSuffix:t+f.angularAxis.ticksSuffix}).style(B);f.angularAxis.rewriteTicks&&Q.text(function(t,e){return e%(f.minorTicks+1)!=0?\"\":f.angularAxis.rewriteTicks(this.textContent,e)});var $=n.max(j.selectAll(\".angular-tick text\")[0].map(function(t,e){return t.getCTM().e+t.getBBox().width}));F.attr({transform:\"translate(\"+[x+$,f.margin.top]+\")\"});var tt=e.select(\"g.geometry-group\").selectAll(\"g\").size()>0,et=e.select(\"g.geometry-group\").selectAll(\"g.geometry\").data(p);if(et.enter().append(\"g\").attr({class:function(t,e){return\"geometry geometry\"+e}}),et.exit().remove(),p[0]||tt){var rt=[];p.forEach(function(t,e){var r={};r.radialScale=i,r.angularScale=l,r.container=et.filter(function(t,r){return r==e}),r.geometry=t.geometry,r.orientation=f.orientation,r.direction=f.direction,r.index=e,rt.push({data:t,geometryConfig:r})});var nt=n.nest().key(function(t,e){return void 0!==t.data.groupId||\"unstacked\"}).entries(rt),it=[];nt.forEach(function(t,e){\"unstacked\"===t.key?it=it.concat(t.values.map(function(t,e){return[t]})):it.push(t.values)}),it.forEach(function(t,e){var r;r=Array.isArray(t)?t[0].geometryConfig.geometry:t.geometryConfig.geometry;var n=t.map(function(t,e){return a(s[r].defaultConfig(),t)});s[r]().config(n)()})}var at,ot,st=e.select(\".guides-group\"),lt=e.select(\".tooltips-group\"),ut=s.tooltipPanel().config({container:lt,fontSize:8})(),ct=s.tooltipPanel().config({container:lt,fontSize:8})(),ht=s.tooltipPanel().config({container:lt,hasTick:!0})();if(!A){var ft=st.select(\"line\").attr({x1:0,y1:0,y2:0}).style({stroke:\"grey\",\"pointer-events\":\"none\"});j.on(\"mousemove.angular-guide\",function(t,e){var r=s.util.getMousePos(W).angle;ft.attr({x2:-x,transform:\"rotate(\"+r+\")\"}).style({opacity:.5});var n=(r+180+360-f.orientation)%360;at=l.invert(n);var i=s.util.convertToCartesian(x+12,r+180);ut.text(s.util.round(at)).move([i[0]+w[0],i[1]+w[1]])}).on(\"mouseout.angular-guide\",function(t,e){st.select(\"line\").style({opacity:0})})}var dt=st.select(\"circle\").style({stroke:\"grey\",fill:\"none\"});j.on(\"mousemove.radial-guide\",function(t,e){var r=s.util.getMousePos(W).radius;dt.attr({r:r}).style({opacity:.5}),ot=i.invert(s.util.getMousePos(W).radius);var n=s.util.convertToCartesian(r,f.radialAxis.orientation);ct.text(s.util.round(ot)).move([n[0]+w[0],n[1]+w[1]])}).on(\"mouseout.radial-guide\",function(t,e){dt.style({opacity:0}),ht.hide(),ut.hide(),ct.hide()}),e.selectAll(\".geometry-group .mark\").on(\"mouseover.tooltip\",function(t,r){var i=n.select(this),a=i.style(\"fill\"),o=\"black\",l=i.style(\"opacity\")||1;if(i.attr({\"data-opacity\":l}),\"none\"!=a){i.attr({\"data-fill\":a}),o=n.hsl(a).darker().toString(),i.style({fill:o,opacity:1});var u={t:s.util.round(t[0]),r:s.util.round(t[1])};A&&(u.t=M[t[0]]);var c=\"t: \"+u.t+\", r: \"+u.r,h=this.getBoundingClientRect(),f=e.node().getBoundingClientRect(),d=[h.left+h.width/2-H[0]-f.left,h.top+h.height/2-H[1]-f.top];ht.config({color:o}).text(c),ht.move(d)}else a=i.style(\"stroke\"),i.attr({\"data-stroke\":a}),o=n.hsl(a).darker().toString(),i.style({stroke:o,opacity:1})}).on(\"mousemove.tooltip\",function(t,e){if(0!=n.event.which)return!1;n.select(this).attr(\"data-fill\")&&ht.show()}).on(\"mouseout.tooltip\",function(t,e){ht.hide();var r=n.select(this),i=r.attr(\"data-fill\");i?r.style({fill:i,opacity:r.attr(\"data-opacity\")}):r.style({stroke:r.attr(\"data-stroke\"),opacity:r.attr(\"data-opacity\")})})}),d}var e,r,i,l,u={data:[],layout:{}},c={},h={},f=n.dispatch(\"hover\"),d={};return d.render=function(e){return t(e),this},d.config=function(t){if(!arguments.length)return u;var e=s.util.cloneJson(t);return e.data.forEach(function(t,e){u.data[e]||(u.data[e]={}),a(u.data[e],s.Axis.defaultConfig().data[0]),a(u.data[e],t)}),a(u.layout,s.Axis.defaultConfig().layout),a(u.layout,e.layout),this},d.getLiveConfig=function(){return h},d.getinputConfig=function(){return c},d.radialScale=function(t){return i},d.angularScale=function(t){return l},d.svg=function(){return e},n.rebind(d,f,\"on\"),d},s.Axis.defaultConfig=function(t,e){return{data:[{t:[1,2,3,4],r:[10,11,12,13],name:\"Line1\",geometry:\"LinePlot\",color:null,strokeDash:\"solid\",strokeColor:null,strokeSize:\"1\",visibleInLegend:!0,opacity:1}],layout:{defaultColorRange:n.scale.category10().range(),title:null,height:450,width:500,margin:{top:40,right:40,bottom:40,left:40},font:{size:12,color:\"gray\",outlineColor:\"white\",family:\"Tahoma, sans-serif\"},direction:\"clockwise\",orientation:0,labelOffset:10,radialAxis:{domain:null,orientation:-45,ticksSuffix:\"\",visible:!0,gridLinesVisible:!0,tickOrientation:\"horizontal\",rewriteTicks:null},angularAxis:{domain:[0,360],ticksSuffix:\"\",visible:!0,gridLinesVisible:!0,labelsVisible:!0,tickOrientation:\"horizontal\",rewriteTicks:null,ticksCount:null,ticksStep:null},minorTicks:0,tickLength:null,tickColor:\"silver\",minorTickColor:\"#eee\",backgroundColor:\"none\",needsEndSpacing:null,showLegend:!0,legend:{reverseOrder:!1},opacity:1}}},s.util={},s.DATAEXTENT=\"dataExtent\",s.AREA=\"AreaChart\",s.LINE=\"LinePlot\",s.DOT=\"DotPlot\",s.BAR=\"BarChart\",s.util._override=function(t,e){for(var r in t)r in e&&(e[r]=t[r])},s.util._extend=function(t,e){for(var r in t)e[r]=t[r]},s.util._rndSnd=function(){return 2*Math.random()-1+(2*Math.random()-1)+(2*Math.random()-1)},s.util.dataFromEquation2=function(t,e){var r=e||6;return n.range(0,360+r,r).map(function(e,r){var n=e*Math.PI/180;return[e,t(n)]})},s.util.dataFromEquation=function(t,e,r){var i=e||6,a=[],o=[];n.range(0,360+i,i).forEach(function(e,r){var n=e*Math.PI/180,i=t(n);a.push(e),o.push(i)});var s={t:a,r:o};return r&&(s.name=r),s},s.util.ensureArray=function(t,e){if(void 0===t)return null;var r=[].concat(t);return n.range(e).map(function(t,e){return r[e]||r[0]})},s.util.fillArrays=function(t,e,r){return e.forEach(function(e,n){t[e]=s.util.ensureArray(t[e],r)}),t},s.util.cloneJson=function(t){return JSON.parse(JSON.stringify(t))},s.util.validateKeys=function(t,e){\"string\"==typeof e&&(e=e.split(\".\"));var r=e.shift();return t[r]&&(!e.length||objHasKeys(t[r],e))},s.util.sumArrays=function(t,e){return n.zip(t,e).map(function(t,e){return n.sum(t)})},s.util.arrayLast=function(t){return t[t.length-1]},s.util.arrayEqual=function(t,e){for(var r=Math.max(t.length,e.length,1);r-- >=0&&t[r]===e[r];);return-2===r},s.util.flattenArray=function(t){for(var e=[];!s.util.arrayEqual(e,t);)e=t,t=[].concat.apply([],t);return t},s.util.deduplicate=function(t){return t.filter(function(t,e,r){return r.indexOf(t)==e})},s.util.convertToCartesian=function(t,e){var r=e*Math.PI/180;return[t*Math.cos(r),t*Math.sin(r)]},s.util.round=function(t,e){var r=e||2,n=Math.pow(10,r);return Math.round(t*n)/n},s.util.getMousePos=function(t){var e=n.mouse(t.node()),r=e[0],i=e[1],a={};return a.x=r,a.y=i,a.pos=e,a.angle=180*(Math.atan2(i,r)+Math.PI)/Math.PI,a.radius=Math.sqrt(r*r+i*i),a},s.util.duplicatesCount=function(t){for(var e,r={},n={},i=0,a=t.length;i<a;i++)e=t[i],e in r?(r[e]++,n[e]=r[e]):r[e]=1;return n},s.util.duplicates=function(t){return Object.keys(s.util.duplicatesCount(t))},s.util.translator=function(t,e,r,n){if(n){var i=r.slice();r=e,e=i}var a=e.reduce(function(t,e){if(void 0!==t)return t[e]},t);void 0!==a&&(e.reduce(function(t,r,n){if(void 0!==t)return n===e.length-1&&delete t[r],t[r]},t),r.reduce(function(t,e,n){return void 0===t[e]&&(t[e]={}),n===r.length-1&&(t[e]=a),t[e]},t))},s.PolyChart=function(){function t(){var t=e[0].geometryConfig,r=t.container;\"string\"==typeof r&&(r=n.select(r)),r.datum(e).each(function(e,r){function a(e,r){return{r:t.radialScale(e[1]),t:(t.angularScale(e[0])+t.orientation)*Math.PI/180}}function o(t){return{x:t.r*Math.cos(t.t),y:t.r*Math.sin(t.t)}}var s=!!e[0].data.yStack,l=e.map(function(t,e){return s?n.zip(t.data.t[0],t.data.r[0],t.data.yStack[0]):n.zip(t.data.t[0],t.data.r[0])}),u=t.angularScale,c=t.radialScale.domain()[0],h={};h.bar=function(r,i,a){var o=e[a].data,s=t.radialScale(r[1])-t.radialScale(0),l=t.radialScale(r[2]||0),c=o.barWidth;n.select(this).attr({class:\"mark bar\",d:\"M\"+[[s+l,-c/2],[s+l,c/2],[l,c/2],[l,-c/2]].join(\"L\")+\"Z\",transform:function(e,r){return\"rotate(\"+(t.orientation+u(e[0]))+\")\"}})},h.dot=function(t,r,i){var s=t[2]?[t[0],t[1]+t[2]]:t,l=n.svg.symbol().size(e[i].data.dotSize).type(e[i].data.dotType)(t,r);n.select(this).attr({class:\"mark dot\",d:l,transform:function(t,e){var r=o(a(s));return\"translate(\"+[r.x,r.y]+\")\"}})};var f=n.svg.line.radial().interpolate(e[0].data.lineInterpolation).radius(function(e){return t.radialScale(e[1])}).angle(function(e){return t.angularScale(e[0])*Math.PI/180});h.line=function(r,i,a){var o=r[2]?l[a].map(function(t,e){return[t[0],t[1]+t[2]]}):l[a];if(n.select(this).each(h.dot).style({opacity:function(t,r){return+e[a].data.dotVisible},fill:v.stroke(r,i,a)}).attr({class:\"mark dot\"}),!(i>0)){var s=n.select(this.parentNode).selectAll(\"path.line\").data([0]);s.enter().insert(\"path\"),s.attr({class:\"line\",d:f(o),transform:function(e,r){return\"rotate(\"+(t.orientation+90)+\")\"},\"pointer-events\":\"none\"}).style({fill:function(t,e){return v.fill(r,i,a)},\"fill-opacity\":0,stroke:function(t,e){return v.stroke(r,i,a)},\"stroke-width\":function(t,e){return v[\"stroke-width\"](r,i,a)},\"stroke-dasharray\":function(t,e){return v[\"stroke-dasharray\"](r,i,a)},opacity:function(t,e){return v.opacity(r,i,a)},display:function(t,e){return v.display(r,i,a)}})}};var d=t.angularScale.range(),p=Math.abs(d[1]-d[0])/l[0].length*Math.PI/180,m=n.svg.arc().startAngle(function(t){return-p/2}).endAngle(function(t){return p/2}).innerRadius(function(e){return t.radialScale(c+(e[2]||0))}).outerRadius(function(e){return t.radialScale(c+(e[2]||0))+t.radialScale(e[1])});h.arc=function(e,r,i){n.select(this).attr({class:\"mark arc\",d:m,transform:function(e,r){return\"rotate(\"+(t.orientation+u(e[0])+90)+\")\"}})};var v={fill:function(t,r,n){return e[n].data.color},stroke:function(t,r,n){return e[n].data.strokeColor},\"stroke-width\":function(t,r,n){return e[n].data.strokeSize+\"px\"},\"stroke-dasharray\":function(t,r,n){return i[e[n].data.strokeDash]},opacity:function(t,r,n){return e[n].data.opacity},display:function(t,r,n){return void 0===e[n].data.visible||e[n].data.visible?\"block\":\"none\"}},g=n.select(this).selectAll(\"g.layer\").data(l);g.enter().append(\"g\").attr({class:\"layer\"});var y=g.selectAll(\"path.mark\").data(function(t,e){return t});y.enter().append(\"path\").attr({class:\"mark\"}),y.style(v).each(h[t.geometryType]),y.exit().remove(),g.exit().remove()})}var e=[s.PolyChart.defaultConfig()],r=n.dispatch(\"hover\"),i={solid:\"none\",dash:[5,2],dot:[2,5]};return t.config=function(t){return arguments.length?(t.forEach(function(t,r){e[r]||(e[r]={}),a(e[r],s.PolyChart.defaultConfig()),a(e[r],t)}),this):e},t.getColorScale=function(){},n.rebind(t,r,\"on\"),t},s.PolyChart.defaultConfig=function(){return{data:{name:\"geom1\",t:[[1,2,3,4]],r:[[1,2,3,4]],dotType:\"circle\",dotSize:64,dotVisible:!1,barWidth:20,color:\"#ffa500\",strokeSize:1,strokeColor:\"silver\",strokeDash:\"solid\",opacity:1,index:0,visible:!0,visibleInLegend:!0},geometryConfig:{geometry:\"LinePlot\",geometryType:\"arc\",direction:\"clockwise\",orientation:0,container:\"body\",radialScale:null,angularScale:null,colorScale:n.scale.category20()}}},s.BarChart=function(){return s.PolyChart()},s.BarChart.defaultConfig=function(){return{geometryConfig:{geometryType:\"bar\"}}},s.AreaChart=function(){return s.PolyChart()},s.AreaChart.defaultConfig=function(){return{geometryConfig:{geometryType:\"arc\"}}},s.DotPlot=function(){return s.PolyChart()},s.DotPlot.defaultConfig=function(){return{geometryConfig:{geometryType:\"dot\",dotType:\"circle\"}}},s.LinePlot=function(){return s.PolyChart()},s.LinePlot.defaultConfig=function(){return{geometryConfig:{geometryType:\"line\"}}},s.Legend=function(){function t(){var r=e.legendConfig,i=e.data.map(function(t,e){return[].concat(t).map(function(t,n){var i=a({},r.elements[e]);return i.name=t,i.color=[].concat(r.elements[e].color)[n],i})}),o=n.merge(i);o=o.filter(function(t,e){return r.elements[e]&&(r.elements[e].visibleInLegend||void 0===r.elements[e].visibleInLegend)}),r.reverseOrder&&(o=o.reverse());var s=r.container;(\"string\"==typeof s||s.nodeName)&&(s=n.select(s));var l=o.map(function(t,e){return t.color}),u=r.fontSize,c=null==r.isContinuous?\"number\"==typeof o[0]:r.isContinuous,h=c?r.height:u*o.length,f=s.classed(\"legend-group\",!0),d=f.selectAll(\"svg\").data([0]),p=d.enter().append(\"svg\").attr({width:300,height:h+u,xmlns:\"http://www.w3.org/2000/svg\",\"xmlns:xlink\":\"http://www.w3.org/1999/xlink\",version:\"1.1\"});p.append(\"g\").classed(\"legend-axis\",!0),p.append(\"g\").classed(\"legend-marks\",!0);var m=n.range(o.length),v=n.scale[c?\"linear\":\"ordinal\"]().domain(m).range(l),g=n.scale[c?\"linear\":\"ordinal\"]().domain(m)[c?\"range\":\"rangePoints\"]([0,h]),y=function(t,e){var r=3*e;return\"line\"===t?\"M\"+[[-e/2,-e/12],[e/2,-e/12],[e/2,e/12],[-e/2,e/12]]+\"Z\":-1!=n.svg.symbolTypes.indexOf(t)?n.svg.symbol().type(t).size(r)():n.svg.symbol().type(\"square\").size(r)()};if(c){var b=d.select(\".legend-marks\").append(\"defs\").append(\"linearGradient\").attr({id:\"grad1\",x1:\"0%\",y1:\"0%\",x2:\"0%\",y2:\"100%\"}).selectAll(\"stop\").data(l);b.enter().append(\"stop\"),b.attr({offset:function(t,e){return e/(l.length-1)*100+\"%\"}}).style({\"stop-color\":function(t,e){return t}}),d.append(\"rect\").classed(\"legend-mark\",!0).attr({height:r.height,width:r.colorBandWidth,fill:\"url(#grad1)\"})}else{var x=d.select(\".legend-marks\").selectAll(\"path.legend-mark\").data(o);x.enter().append(\"path\").classed(\"legend-mark\",!0),x.attr({transform:function(t,e){return\"translate(\"+[u/2,g(e)+u/2]+\")\"},d:function(t,e){var r=t.symbol;return y(r,u)},fill:function(t,e){return v(e)}}),x.exit().remove()}var _=n.svg.axis().scale(g).orient(\"right\"),w=d.select(\"g.legend-axis\").attr({transform:\"translate(\"+[c?r.colorBandWidth:u,u/2]+\")\"}).call(_);return w.selectAll(\".domain\").style({fill:\"none\",stroke:\"none\"}),w.selectAll(\"line\").style({fill:\"none\",stroke:c?r.textColor:\"none\"}),w.selectAll(\"text\").style({fill:r.textColor,\"font-size\":r.fontSize}).text(function(t,e){return o[e].name}),t}var e=s.Legend.defaultConfig(),r=n.dispatch(\"hover\");return t.config=function(t){return arguments.length?(a(e,t),this):e},n.rebind(t,r,\"on\"),t},s.Legend.defaultConfig=function(t,e){return{data:[\"a\",\"b\",\"c\"],legendConfig:{elements:[{symbol:\"line\",color:\"red\"},{symbol:\"square\",color:\"yellow\"},{symbol:\"diamond\",color:\"limegreen\"}],height:150,colorBandWidth:30,fontSize:12,container:\"body\",isContinuous:null,textColor:\"grey\",reverseOrder:!1}}},s.tooltipPanel=function(){var t,e,r,i={container:null,hasTick:!1,fontSize:12,color:\"white\",padding:5},o=\"tooltip-\"+s.tooltipPanel.uid++,l=function(){t=i.container.selectAll(\"g.\"+o).data([0]);var n=t.enter().append(\"g\").classed(o,!0).style({\"pointer-events\":\"none\",display:\"none\"});return r=n.append(\"path\").style({fill:\"white\",\"fill-opacity\":.9}).attr({d:\"M0 0\"}),e=n.append(\"text\").attr({dx:i.padding+10,dy:.3*+i.fontSize}),l};return l.text=function(a){var o=n.hsl(i.color).l,s=o>=.5?\"#aaa\":\"white\",u=o>=.5?\"black\":\"white\",c=a||\"\";e.style({fill:u,\"font-size\":i.fontSize+\"px\"}).text(c);var h=i.padding,f=e.node().getBBox(),d={fill:i.color,stroke:s,\"stroke-width\":\"2px\"},p=f.width+2*h+10,m=f.height+2*h;return r.attr({d:\"M\"+[[10,-m/2],[10,-m/4],[i.hasTick?0:10,0],[10,m/4],[10,m/2],[p,m/2],[p,-m/2]].join(\"L\")+\"Z\"}).style(d),t.attr({transform:\"translate(\"+[10,-m/2+2*h]+\")\"}),t.style({display:\"block\"}),l},l.move=function(e){if(t)return t.attr({transform:\"translate(\"+[e[0],e[1]]+\")\"}).style({display:\"block\"}),l},l.hide=function(){if(t)return t.style({display:\"none\"}),l},l.show=function(){if(t)return t.style({display:\"block\"}),l},l.config=function(t){return a(i,t),l},l},s.tooltipPanel.uid=1,s.adapter={},s.adapter.plotly=function(){var t={};return t.convert=function(t,e){\n",
       "var r={};if(t.data&&(r.data=t.data.map(function(t,r){var n=a({},t);return[[n,[\"marker\",\"color\"],[\"color\"]],[n,[\"marker\",\"opacity\"],[\"opacity\"]],[n,[\"marker\",\"line\",\"color\"],[\"strokeColor\"]],[n,[\"marker\",\"line\",\"dash\"],[\"strokeDash\"]],[n,[\"marker\",\"line\",\"width\"],[\"strokeSize\"]],[n,[\"marker\",\"symbol\"],[\"dotType\"]],[n,[\"marker\",\"size\"],[\"dotSize\"]],[n,[\"marker\",\"barWidth\"],[\"barWidth\"]],[n,[\"line\",\"interpolation\"],[\"lineInterpolation\"]],[n,[\"showlegend\"],[\"visibleInLegend\"]]].forEach(function(t,r){s.util.translator.apply(null,t.concat(e))}),e||delete n.marker,e&&delete n.groupId,e?(\"LinePlot\"===n.geometry?(n.type=\"scatter\",!0===n.dotVisible?(delete n.dotVisible,n.mode=\"lines+markers\"):n.mode=\"lines\"):\"DotPlot\"===n.geometry?(n.type=\"scatter\",n.mode=\"markers\"):\"AreaChart\"===n.geometry?n.type=\"area\":\"BarChart\"===n.geometry&&(n.type=\"bar\"),delete n.geometry):(\"scatter\"===n.type?\"lines\"===n.mode?n.geometry=\"LinePlot\":\"markers\"===n.mode?n.geometry=\"DotPlot\":\"lines+markers\"===n.mode&&(n.geometry=\"LinePlot\",n.dotVisible=!0):\"area\"===n.type?n.geometry=\"AreaChart\":\"bar\"===n.type&&(n.geometry=\"BarChart\"),delete n.mode,delete n.type),n}),!e&&t.layout&&\"stack\"===t.layout.barmode)){var i=s.util.duplicates(r.data.map(function(t,e){return t.geometry}));r.data.forEach(function(t,e){var n=i.indexOf(t.geometry);-1!=n&&(r.data[e].groupId=n)})}if(t.layout){var o=a({},t.layout);if([[o,[\"plot_bgcolor\"],[\"backgroundColor\"]],[o,[\"showlegend\"],[\"showLegend\"]],[o,[\"radialaxis\"],[\"radialAxis\"]],[o,[\"angularaxis\"],[\"angularAxis\"]],[o.angularaxis,[\"showline\"],[\"gridLinesVisible\"]],[o.angularaxis,[\"showticklabels\"],[\"labelsVisible\"]],[o.angularaxis,[\"nticks\"],[\"ticksCount\"]],[o.angularaxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.angularaxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.angularaxis,[\"range\"],[\"domain\"]],[o.angularaxis,[\"endpadding\"],[\"endPadding\"]],[o.radialaxis,[\"showline\"],[\"gridLinesVisible\"]],[o.radialaxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.radialaxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.radialaxis,[\"range\"],[\"domain\"]],[o.angularAxis,[\"showline\"],[\"gridLinesVisible\"]],[o.angularAxis,[\"showticklabels\"],[\"labelsVisible\"]],[o.angularAxis,[\"nticks\"],[\"ticksCount\"]],[o.angularAxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.angularAxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.angularAxis,[\"range\"],[\"domain\"]],[o.angularAxis,[\"endpadding\"],[\"endPadding\"]],[o.radialAxis,[\"showline\"],[\"gridLinesVisible\"]],[o.radialAxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.radialAxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.radialAxis,[\"range\"],[\"domain\"]],[o.font,[\"outlinecolor\"],[\"outlineColor\"]],[o.legend,[\"traceorder\"],[\"reverseOrder\"]],[o,[\"labeloffset\"],[\"labelOffset\"]],[o,[\"defaultcolorrange\"],[\"defaultColorRange\"]]].forEach(function(t,r){s.util.translator.apply(null,t.concat(e))}),e?(void 0!==o.tickLength&&(o.angularaxis.ticklen=o.tickLength,delete o.tickLength),o.tickColor&&(o.angularaxis.tickcolor=o.tickColor,delete o.tickColor)):(o.angularAxis&&void 0!==o.angularAxis.ticklen&&(o.tickLength=o.angularAxis.ticklen),o.angularAxis&&void 0!==o.angularAxis.tickcolor&&(o.tickColor=o.angularAxis.tickcolor)),o.legend&&\"boolean\"!=typeof o.legend.reverseOrder&&(o.legend.reverseOrder=\"normal\"!=o.legend.reverseOrder),o.legend&&\"boolean\"==typeof o.legend.traceorder&&(o.legend.traceorder=o.legend.traceorder?\"reversed\":\"normal\",delete o.legend.reverseOrder),o.margin&&void 0!==o.margin.t){var l=[\"t\",\"r\",\"b\",\"l\",\"pad\"],u=[\"top\",\"right\",\"bottom\",\"left\",\"pad\"],c={};n.entries(o.margin).forEach(function(t,e){c[u[l.indexOf(t.key)]]=t.value}),o.margin=c}e&&(delete o.needsEndSpacing,delete o.minorTickColor,delete o.minorTicks,delete o.angularaxis.ticksCount,delete o.angularaxis.ticksCount,delete o.angularaxis.ticksStep,delete o.angularaxis.rewriteTicks,delete o.angularaxis.nticks,delete o.radialaxis.ticksCount,delete o.radialaxis.ticksCount,delete o.radialaxis.ticksStep,delete o.radialaxis.rewriteTicks,delete o.radialaxis.nticks),r.layout=o}return r},t}},{\"../../constants/alignment\":699,\"../../lib\":725,d3:121}],834:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"./micropolar\"),s=t(\"./undo_manager\"),l=i.extendDeepAll,u=e.exports={};u.framework=function(t){function e(e,i){return i&&(h=i),n.select(n.select(h).node().parentNode).selectAll(\".svg-container>*:not(.chart-root)\").remove(),r=r?l(r,e):e,a||(a=o.Axis()),c=o.adapter.plotly().convert(r),a.config(c).render(h),t.data=r.data,t.layout=r.layout,u.fillLayout(t),r}var r,i,a,c,h,f=new s;return e.isPolar=!0,e.svg=function(){return a.svg()},e.getConfig=function(){return r},e.getLiveConfig=function(){return o.adapter.plotly().convert(a.getLiveConfig(),!0)},e.getLiveScales=function(){return{t:a.angularScale(),r:a.radialScale()}},e.setUndoPoint=function(){var t=this,e=o.util.cloneJson(r);!function(e,r){f.add({undo:function(){r&&t(r)},redo:function(){t(e)}})}(e,i),i=o.util.cloneJson(e)},e.undo=function(){f.undo()},e.redo=function(){f.redo()},e},u.fillLayout=function(t){var e=n.select(t).selectAll(\".plot-container\"),r=e.selectAll(\".svg-container\"),i=t.framework&&t.framework.svg&&t.framework.svg(),o={width:800,height:600,paper_bgcolor:a.background,_container:e,_paperdiv:r,_paper:i};t._fullLayout=l(o,t.layout)}},{\"../../components/color\":603,\"../../lib\":725,\"./micropolar\":833,\"./undo_manager\":835,d3:121}],835:[function(t,e,r){\"use strict\";e.exports=function(){function t(t,e){return t?(i=!0,t[e](),i=!1,this):this}var e,r=[],n=-1,i=!1;return{add:function(t){return i?this:(r.splice(n+1,r.length-n),r.push(t),n=r.length-1,this)},setCallback:function(t){e=t},undo:function(){var i=r[n];return i?(t(i,\"undo\"),n-=1,e&&e(i.undo),this):this},redo:function(){var i=r[n+1];return i?(t(i,\"redo\"),n+=1,e&&e(i.redo),this):this},clear:function(){r=[],n=-1},hasUndo:function(){return-1!==n},hasRedo:function(){return n<r.length-1},getCommands:function(){return r},getPreviousCommand:function(){return r[n-1]},getIndex:function(){return n}}}},{}],836:[function(t,e,r){\"use strict\";var n=t(\"../lib\"),i=t(\"./plots\");e.exports=function(t,e,r,a){function o(t,e){return n.coerce(s,l,c,t,e)}for(var s,l,u=a.type,c=a.attributes,h=a.handleDefaults,f=a.partition||\"x\",d=i.findSubplotIds(r,u),p=d.length,m=0;m<p;m++){var v=d[m];s=t[v]?t[v]:t[v]={},e[v]=l={},o(\"domain.\"+f,[m/p,(m+1)/p]),o(\"domain.\"+{x:\"y\",y:\"x\"}[f]),a.id=v,h(s,l,o,a)}}},{\"../lib\":725,\"./plots\":829}],837:[function(t,e,r){\"use strict\";var n=t(\"./ternary\"),i=t(\"../../plots/plots\");r.name=\"ternary\",r.attr=\"subplot\",r.idRoot=\"ternary\",r.idRegex=/^ternary([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^ternary([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){for(var e=t._fullLayout,r=t.calcdata,a=i.getSubplotIds(e,\"ternary\"),o=0;o<a.length;o++){var s=a[o],l=i.getSubplotCalcData(r,\"ternary\",s),u=e[s]._subplot;u||(u=new n({id:s,graphDiv:t,container:e._ternarylayer.node()},e),e[s]._subplot=u),u.plot(l,e,t._promises)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"ternary\"),o=0;o<a.length;o++){var s=a[o],l=n[s]._subplot;!e[s]&&l&&(l.plotContainer.remove(),l.clipDef.remove(),l.clipDefRelative.remove())}}},{\"../../plots/plots\":829,\"./layout/attributes\":838,\"./layout/defaults\":841,\"./layout/layout_attributes\":842,\"./ternary\":843}],838:[function(t,e,r){\"use strict\";e.exports={subplot:{valType:\"subplotid\",dflt:\"ternary\"}}},{}],839:[function(t,e,r){\"use strict\";var n=t(\"../../cartesian/layout_attributes\"),i=t(\"../../../lib/extend\").extendFlat;e.exports={title:n.title,titlefont:n.titlefont,color:n.color,tickmode:n.tickmode,nticks:i({},n.nticks,{dflt:6,min:1}),tick0:n.tick0,dtick:n.dtick,tickvals:n.tickvals,ticktext:n.ticktext,ticks:n.ticks,ticklen:n.ticklen,tickwidth:n.tickwidth,tickcolor:n.tickcolor,showticklabels:n.showticklabels,showtickprefix:n.showtickprefix,tickprefix:n.tickprefix,showticksuffix:n.showticksuffix,ticksuffix:n.ticksuffix,showexponent:n.showexponent,exponentformat:n.exponentformat,separatethousands:n.separatethousands,tickfont:n.tickfont,tickangle:n.tickangle,tickformat:n.tickformat,hoverformat:n.hoverformat,showline:i({},n.showline,{dflt:!0}),linecolor:n.linecolor,linewidth:n.linewidth,showgrid:i({},n.showgrid,{dflt:!0}),gridcolor:n.gridcolor,gridwidth:n.gridwidth,layer:n.layer,min:{valType:\"number\",dflt:0,min:0}}},{\"../../../lib/extend\":716,\"../../cartesian/layout_attributes\":777}],840:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../../lib\"),a=t(\"./axis_attributes\"),o=t(\"../../cartesian/tick_label_defaults\"),s=t(\"../../cartesian/tick_mark_defaults\"),l=t(\"../../cartesian/tick_value_defaults\");e.exports=function(t,e,r){function u(r,n){return i.coerce(t,e,a,r,n)}e.type=\"linear\";var c=u(\"color\"),h=c===t.color?c:r.font.color,f=e._name,d=f.charAt(0).toUpperCase(),p=\"Component \"+d,m=u(\"title\",p);e._hovertitle=m===p?m:d,i.coerceFont(u,\"titlefont\",{family:r.font.family,size:Math.round(1.2*r.font.size),color:h}),u(\"min\"),l(t,e,u,\"linear\"),o(t,e,u,\"linear\",{noHover:!1}),s(t,e,u,{outerTicks:!0}),u(\"showticklabels\")&&(i.coerceFont(u,\"tickfont\",{family:r.font.family,size:r.font.size,color:h}),u(\"tickangle\"),u(\"tickformat\")),u(\"hoverformat\"),u(\"showline\")&&(u(\"linecolor\",c),u(\"linewidth\")),u(\"showgrid\")&&(u(\"gridcolor\",n(c,r.bgColor,60).toRgbString()),u(\"gridwidth\")),u(\"layer\")}},{\"../../../lib\":725,\"../../cartesian/tick_label_defaults\":784,\"../../cartesian/tick_mark_defaults\":785,\"../../cartesian/tick_value_defaults\":786,\"./axis_attributes\":839,tinycolor2:533}],841:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=r(\"bgcolor\"),o=r(\"sum\");n.bgColor=i.combine(a,n.paper_bgcolor);for(var u,c,h,f=0;f<l.length;f++)u=l[f],c=t[u]||{},h=e[u]={_name:u,type:\"linear\"},s(c,h,n);var d=e.aaxis,p=e.baxis,m=e.caxis;d.min+p.min+m.min>=o&&(d.min=0,p.min=0,m.min=0,t.aaxis&&delete t.aaxis.min,t.baxis&&delete t.baxis.min,t.caxis&&delete t.caxis.min)}var i=t(\"../../../components/color\"),a=t(\"../../subplot_defaults\"),o=t(\"./layout_attributes\"),s=t(\"./axis_defaults\"),l=[\"aaxis\",\"baxis\",\"caxis\"];e.exports=function(t,e,r){a(t,e,r,{type:\"ternary\",attributes:o,handleDefaults:n,font:e.font,paper_bgcolor:e.paper_bgcolor})}},{\"../../../components/color\":603,\"../../subplot_defaults\":836,\"./axis_defaults\":840,\"./layout_attributes\":842}],842:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\"),i=t(\"./axis_attributes\");e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},bgcolor:{valType:\"color\",dflt:n.background},sum:{valType:\"number\",dflt:1,min:0},aaxis:i,baxis:i,caxis:i}},{\"../../../components/color/attributes\":602,\"./axis_attributes\":839}],843:[function(t,e,r){\"use strict\";function n(t,e){this.id=t.id,this.graphDiv=t.graphDiv,this.init(e),this.makeFramework(e)}function i(t){a.select(t).selectAll(\".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners\").remove()}var a=t(\"d3\"),o=t(\"tinycolor2\"),s=t(\"../../plotly\"),l=t(\"../../lib\"),u=t(\"../../components/color\"),c=t(\"../../components/drawing\"),h=t(\"../cartesian/set_convert\"),f=t(\"../../lib/extend\").extendFlat,d=t(\"../plots\"),p=t(\"../cartesian/axes\"),m=t(\"../../components/dragelement\"),v=t(\"../../components/fx\"),g=t(\"../../components/titles\"),y=t(\"../cartesian/select\"),b=t(\"../cartesian/constants\");e.exports=n;var x=n.prototype;x.init=function(t){this.container=t._ternarylayer,this.defs=t._defs,this.layoutId=t._uid,this.traceHash={},this.layers={}},x.plot=function(t,e){var r=this,n=e[r.id],i=e._size;r._hasClipOnAxisFalse=!1;for(var a=0;a<t.length;a++){if(!1===t[a][0].trace.cliponaxis){r._hasClipOnAxisFalse=!0;break}}r.updateLayers(n),r.adjustLayout(n,i),d.generalUpdatePerTraceModule(r,t,n),r.layers.plotbg.select(\"path\").call(u.fill,n.bgcolor)},x.makeFramework=function(t){var e=this,r=t[e.id],n=e.defs.selectAll(\"g.clips\").data([0]);n.enter().append(\"g\").classed(\"clips\",!0);var i=e.clipId=\"clip\"+e.layoutId+e.id;e.clipDef=n.selectAll(\"#\"+i).data([0]),e.clipDef.enter().append(\"clipPath\").attr(\"id\",i).append(\"path\").attr(\"d\",\"M0,0Z\");var a=e.clipIdRelative=\"clip-relative\"+e.layoutId+e.id;e.clipDefRelative=n.selectAll(\"#\"+a).data([0]),e.clipDefRelative.enter().append(\"clipPath\").attr(\"id\",a).append(\"path\").attr(\"d\",\"M0,0Z\"),e.plotContainer=e.container.selectAll(\"g.\"+e.id).data([0]),e.plotContainer.enter().append(\"g\").classed(e.id,!0),e.updateLayers(r),c.setClipUrl(e.layers.backplot,i),c.setClipUrl(e.layers.grids,i)},x.updateLayers=function(t){var e=this,r=e.layers,n=[\"draglayer\",\"plotbg\",\"backplot\",\"grids\"];\"below traces\"===t.aaxis.layer&&n.push(\"aaxis\",\"aline\"),\"below traces\"===t.baxis.layer&&n.push(\"baxis\",\"bline\"),\"below traces\"===t.caxis.layer&&n.push(\"caxis\",\"cline\"),n.push(\"frontplot\"),\"above traces\"===t.aaxis.layer&&n.push(\"aaxis\",\"aline\"),\"above traces\"===t.baxis.layer&&n.push(\"baxis\",\"bline\"),\"above traces\"===t.caxis.layer&&n.push(\"caxis\",\"cline\");var i=e.plotContainer.selectAll(\"g.toplevel\").data(n,String),o=[\"agrid\",\"bgrid\",\"cgrid\"];i.enter().append(\"g\").attr(\"class\",function(t){return\"toplevel \"+t}).each(function(t){var e=a.select(this);r[t]=e,\"frontplot\"===t?e.append(\"g\").classed(\"scatterlayer\",!0):\"backplot\"===t?e.append(\"g\").classed(\"maplayer\",!0):\"plotbg\"===t?e.append(\"path\").attr(\"d\",\"M0,0Z\"):\"aline\"===t||\"bline\"===t||\"cline\"===t?e.append(\"path\"):\"grids\"===t&&o.forEach(function(t){r[t]=e.append(\"g\").classed(\"grid \"+t,!0)})}),i.order()};var _=Math.sqrt(4/3);x.adjustLayout=function(t,e){var r,n,i,a,o,s,l=this,d=t.domain,p=(d.x[0]+d.x[1])/2,m=(d.y[0]+d.y[1])/2,v=d.x[1]-d.x[0],g=d.y[1]-d.y[0],y=v*e.w,b=g*e.h,x=t.sum,w=t.aaxis.min,M=t.baxis.min,k=t.caxis.min;y>_*b?(a=b,i=a*_):(i=y,a=i/_),o=v*i/y,s=g*a/b,r=e.l+e.w*p-i/2,n=e.t+e.h*(1-m)-a/2,l.x0=r,l.y0=n,l.w=i,l.h=a,l.sum=x,l.xaxis={type:\"linear\",range:[w+2*k-x,x-w-2*M],domain:[p-o/2,p+o/2],_id:\"x\"},h(l.xaxis,l.graphDiv._fullLayout),l.xaxis.setScale(),l.xaxis.isPtWithinRange=function(t){return t.a>=l.aaxis.range[0]&&t.a<=l.aaxis.range[1]&&t.b>=l.baxis.range[1]&&t.b<=l.baxis.range[0]&&t.c>=l.caxis.range[1]&&t.c<=l.caxis.range[0]},l.yaxis={type:\"linear\",range:[w,x-M-k],domain:[m-s/2,m+s/2],_id:\"y\"},h(l.yaxis,l.graphDiv._fullLayout),l.yaxis.setScale(),l.yaxis.isPtWithinRange=function(){return!0};var A=l.yaxis.domain[0],T=l.aaxis=f({},t.aaxis,{visible:!0,range:[w,x-M-k],side:\"left\",_counterangle:30,tickangle:(+t.aaxis.tickangle||0)-30,domain:[A,A+s*_],_axislayer:l.layers.aaxis,_gridlayer:l.layers.agrid,_pos:0,_id:\"y\",_length:i,_gridpath:\"M0,0l\"+a+\",-\"+i/2});h(T,l.graphDiv._fullLayout),T.setScale();var S=l.baxis=f({},t.baxis,{visible:!0,range:[x-w-k,M],side:\"bottom\",_counterangle:30,domain:l.xaxis.domain,_axislayer:l.layers.baxis,_gridlayer:l.layers.bgrid,_counteraxis:l.aaxis,_pos:0,_id:\"x\",_length:i,_gridpath:\"M0,0l-\"+i/2+\",-\"+a});h(S,l.graphDiv._fullLayout),S.setScale(),T._counteraxis=S;var E=l.caxis=f({},t.caxis,{visible:!0,range:[x-w-M,k],side:\"right\",_counterangle:30,tickangle:(+t.caxis.tickangle||0)+30,domain:[A,A+s*_],_axislayer:l.layers.caxis,_gridlayer:l.layers.cgrid,_counteraxis:l.baxis,_pos:0,_id:\"y\",_length:i,_gridpath:\"M0,0l-\"+a+\",\"+i/2});h(E,l.graphDiv._fullLayout),E.setScale();var L=\"M\"+r+\",\"+(n+a)+\"h\"+i+\"l-\"+i/2+\",-\"+a+\"Z\";l.clipDef.select(\"path\").attr(\"d\",L),l.layers.plotbg.select(\"path\").attr(\"d\",L);var C=\"M0,\"+a+\"h\"+i+\"l-\"+i/2+\",-\"+a+\"Z\";l.clipDefRelative.select(\"path\").attr(\"d\",C);var z=\"translate(\"+r+\",\"+n+\")\";l.plotContainer.selectAll(\".scatterlayer,.maplayer\").attr(\"transform\",z),l.clipDefRelative.select(\"path\").attr(\"transform\",null);var I=\"translate(\"+r+\",\"+(n+a)+\")\";l.layers.baxis.attr(\"transform\",I),l.layers.bgrid.attr(\"transform\",I);var D=\"translate(\"+(r+i/2)+\",\"+n+\")rotate(30)\";l.layers.aaxis.attr(\"transform\",D),l.layers.agrid.attr(\"transform\",D);var P=\"translate(\"+(r+i/2)+\",\"+n+\")rotate(-30)\";l.layers.caxis.attr(\"transform\",P),l.layers.cgrid.attr(\"transform\",P),l.drawAxes(!0),l.plotContainer.selectAll(\".crisp\").classed(\"crisp\",!1),l.layers.aline.select(\"path\").attr(\"d\",T.showline?\"M\"+r+\",\"+(n+a)+\"l\"+i/2+\",-\"+a:\"M0,0\").call(u.stroke,T.linecolor||\"#000\").style(\"stroke-width\",(T.linewidth||0)+\"px\"),l.layers.bline.select(\"path\").attr(\"d\",S.showline?\"M\"+r+\",\"+(n+a)+\"h\"+i:\"M0,0\").call(u.stroke,S.linecolor||\"#000\").style(\"stroke-width\",(S.linewidth||0)+\"px\"),l.layers.cline.select(\"path\").attr(\"d\",E.showline?\"M\"+(r+i/2)+\",\"+n+\"l\"+i/2+\",\"+a:\"M0,0\").call(u.stroke,E.linecolor||\"#000\").style(\"stroke-width\",(E.linewidth||0)+\"px\"),l.graphDiv._context.staticPlot||l.initInteractions(),c.setClipUrl(l.layers.frontplot,l._hasClipOnAxisFalse?null:l.clipId)},x.drawAxes=function(t){var e=this,r=e.graphDiv,n=e.id.substr(7)+\"title\",i=e.aaxis,a=e.baxis,o=e.caxis;if(p.doTicks(r,i,!0),p.doTicks(r,a,!0),p.doTicks(r,o,!0),t){var s=Math.max(i.showticklabels?i.tickfont.size/2:0,(o.showticklabels?.75*o.tickfont.size:0)+(\"outside\"===o.ticks?.87*o.ticklen:0));g.draw(r,\"a\"+n,{propContainer:i,propName:e.id+\".aaxis.title\",dfltName:\"Component A\",attributes:{x:e.x0+e.w/2,y:e.y0-i.titlefont.size/3-s,\"text-anchor\":\"middle\"}});var l=(a.showticklabels?a.tickfont.size:0)+(\"outside\"===a.ticks?a.ticklen:0)+3;g.draw(r,\"b\"+n,{propContainer:a,propName:e.id+\".baxis.title\",dfltName:\"Component B\",attributes:{x:e.x0-l,y:e.y0+e.h+.83*a.titlefont.size+l,\"text-anchor\":\"middle\"}}),g.draw(r,\"c\"+n,{propContainer:o,propName:e.id+\".caxis.title\",dfltName:\"Component C\",attributes:{x:e.x0+e.w+l,y:e.y0+e.h+.83*o.titlefont.size+l,\"text-anchor\":\"middle\"}})}};var w=b.MINZOOM/2+.87,M=\"m-0.87,.5h\"+w+\"v3h-\"+(w+5.2)+\"l\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l2.6,1.5l-\"+w/2+\",\"+.87*w+\"Z\",k=\"m0.87,.5h-\"+w+\"v3h\"+(w+5.2)+\"l-\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l-2.6,1.5l\"+w/2+\",\"+.87*w+\"Z\",A=\"m0,1l\"+w/2+\",\"+.87*w+\"l2.6,-1.5l-\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l-\"+(w/2+2.6)+\",\"+(.87*w+4.5)+\"l2.6,1.5l\"+w/2+\",-\"+.87*w+\"Z\",T=!0;x.initInteractions=function(){function t(t,e,r){var n=F.getBoundingClientRect();w=e-n.left,S=r-n.top,E={a:R.aaxis.range[0],b:R.baxis.range[1],c:R.caxis.range[1]},C=E,L=R.aaxis.range[1]-E.a,z=o(R.graphDiv._fullLayout[R.id].bgcolor).getLuminance(),I=\"M0,\"+R.h+\"L\"+R.w/2+\", 0L\"+R.w+\",\"+R.h+\"Z\",D=!1,P=N.append(\"path\").attr(\"class\",\"zoombox\").attr(\"transform\",\"translate(\"+R.x0+\", \"+R.y0+\")\").style({fill:z>.2?\"rgba(0,0,0,0)\":\"rgba(255,255,255,0)\",\"stroke-width\":0}).attr(\"d\",I),O=N.append(\"path\").attr(\"class\",\"zoombox-corners\").attr(\"transform\",\"translate(\"+R.x0+\", \"+R.y0+\")\").style({fill:u.background,stroke:u.defaultLine,\"stroke-width\":1,opacity:0}).attr(\"d\",\"M0,0Z\"),g()}function e(t,e){return 1-e/R.h}function r(t,e){return 1-(t+(R.h-e)/Math.sqrt(3))/R.w}function n(t,e){return(t-(R.h-e)/Math.sqrt(3))/R.w}function a(t,i){var a=w+t,o=S+i,s=Math.max(0,Math.min(1,e(w,S),e(a,o))),l=Math.max(0,Math.min(1,r(w,S),r(a,o))),u=Math.max(0,Math.min(1,n(w,S),n(a,o))),c=(s/2+u)*R.w,h=(1-s/2-l)*R.w,f=(c+h)/2,d=h-c,p=(1-s)*R.h,m=p-d/_;d<b.MINZOOM?(C=E,P.attr(\"d\",I),O.attr(\"d\",\"M0,0Z\")):(C={a:E.a+s*L,b:E.b+l*L,c:E.c+u*L},P.attr(\"d\",I+\"M\"+c+\",\"+p+\"H\"+h+\"L\"+f+\",\"+m+\"L\"+c+\",\"+p+\"Z\"),O.attr(\"d\",\"M\"+w+\",\"+S+\"m0.5,0.5h5v-2h-5v-5h-2v5h-5v2h5v5h2ZM\"+c+\",\"+p+M+\"M\"+h+\",\"+p+k+\"M\"+f+\",\"+m+A)),D||(P.transition().style(\"fill\",z>.2?\"rgba(0,0,0,0.4)\":\"rgba(255,255,255,0.3)\").duration(200),O.transition().style(\"opacity\",1).duration(200),D=!0)}function h(t,e){if(C===E)return 2===e&&x(),i(j);i(j);var r={};r[R.id+\".aaxis.min\"]=C.a,r[R.id+\".baxis.min\"]=C.b,r[R.id+\".caxis.min\"]=C.c,s.relayout(j,r),T&&j.data&&j._context.showTips&&(l.notifier(\"Double-click to<br>zoom back out\",\"long\"),T=!1)}function f(){E={a:R.aaxis.range[0],b:R.baxis.range[1],c:R.caxis.range[1]},C=E}function d(t,e){var r=t/R.xaxis._m,n=e/R.yaxis._m;C={a:E.a-n,b:E.b+(r+n)/2,c:E.c-(r-n)/2};var i=[C.a,C.b,C.c].sort(),a={a:i.indexOf(C.a),b:i.indexOf(C.b),c:i.indexOf(C.c)};i[0]<0&&(i[1]+i[0]/2<0?(i[2]+=i[0]+i[1],i[0]=i[1]=0):(i[2]+=i[0]/2,i[1]+=i[0]/2,i[0]=0),C={a:i[a.a],b:i[a.b],c:i[a.c]},e=(E.a-C.a)*R.yaxis._m,t=(E.c-C.c-E.b+C.b)*R.xaxis._m);var o=\"translate(\"+(R.x0+t)+\",\"+(R.y0+e)+\")\";R.plotContainer.selectAll(\".scatterlayer,.maplayer\").attr(\"transform\",o);var s=\"translate(\"+-t+\",\"+-e+\")\";if(R.clipDefRelative.select(\"path\").attr(\"transform\",s),R.aaxis.range=[C.a,R.sum-C.b-C.c],R.baxis.range=[R.sum-C.a-C.c,C.b],R.caxis.range=[R.sum-C.a-C.b,C.c],R.drawAxes(!1),R.plotContainer.selectAll(\".crisp\").classed(\"crisp\",!1),R._hasClipOnAxisFalse){var l=R.plotContainer.select(\".scatterlayer\").selectAll(\".points\");l.selectAll(\".point\").call(c.hideOutsideRangePoints,R),l.selectAll(\".textpoint\").call(c.hideOutsideRangePoints,R)}}function p(t,e){if(t){var r={};r[R.id+\".aaxis.min\"]=C.a,r[R.id+\".baxis.min\"]=C.b,r[R.id+\".caxis.min\"]=C.c,s.relayout(j,r)}else 2===e&&x()}function g(){N.selectAll(\".select-outline\").remove()}function x(){var t={};t[R.id+\".aaxis.min\"]=0,t[R.id+\".baxis.min\"]=0,t[R.id+\".caxis.min\"]=0,j.emit(\"plotly_doubleclick\",null),s.relayout(j,t)}var w,S,E,L,C,z,I,D,P,O,R=this,F=R.layers.plotbg.select(\"path\").node(),j=R.graphDiv,N=j._fullLayout._zoomlayer,B={element:F,gd:j,plotinfo:{xaxis:R.xaxis,yaxis:R.yaxis},doubleclick:x,subplot:R.id,prepFn:function(e,r,n){B.xaxes=[R.xaxis],B.yaxes=[R.yaxis];var i=j._fullLayout.dragmode;e.shiftKey&&(i=\"pan\"===i?\"zoom\":\"pan\"),B.minDrag=\"lasso\"===i?1:void 0,\"zoom\"===i?(B.moveFn=a,B.doneFn=h,t(e,r,n)):\"pan\"===i?(B.moveFn=d,B.doneFn=p,f(),g()):\"select\"!==i&&\"lasso\"!==i||y(e,r,n,B,i)}};F.onmousemove=function(t){v.hover(j,t,R.id),j._fullLayout._lasthover=F,j._fullLayout._hoversubplot=R.id},F.onmouseout=function(t){j._dragging||m.unhover(j,t)},F.onclick=function(t){v.click(j,t,R.id)},m.init(B)}},{\"../../components/color\":603,\"../../components/dragelement\":624,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../components/titles\":692,\"../../lib\":725,\"../../lib/extend\":716,\"../../plotly\":761,\"../cartesian/axes\":766,\"../cartesian/constants\":771,\"../cartesian/select\":782,\"../cartesian/set_convert\":783,\"../plots\":829,d3:121,tinycolor2:533}],844:[function(t,e,r){\"use strict\";function n(t){if(t.layoutAttributes){var e=t.layoutAttributes._arrayAttrRegexps;if(e)for(var n=0;n<e.length;n++)s(r.layoutArrayRegexes,e[n])}}function i(t){return\"object\"==typeof t&&(t=t.type),t}var a=t(\"./lib/loggers\"),o=t(\"./lib/noop\"),s=t(\"./lib/push_unique\"),l=t(\"./plots/attributes\");r.modules={},r.allCategories={},r.allTypes=[],r.subplotsRegistry={},r.transformsRegistry={},r.componentsRegistry={},r.layoutArrayContainers=[],r.layoutArrayRegexes=[],r.register=function(t,e,n,i){if(r.modules[e])return void a.log(\"Type \"+e+\" already registered\");for(var o={},s=0;s<n.length;s++)o[n[s]]=!0,r.allCategories[n[s]]=!0;r.modules[e]={_module:t,categories:o},i&&Object.keys(i).length&&(r.modules[e].meta=i),r.allTypes.push(e)},r.registerSubplot=function(t){var e=t.name;if(r.subplotsRegistry[e])return void a.log(\"Plot type \"+e+\" already registered.\");n(t),r.subplotsRegistry[e]=t},r.registerComponent=function(t){var e=t.name;r.componentsRegistry[e]=t,t.layoutAttributes&&(t.layoutAttributes._isLinkedToArray&&s(r.layoutArrayContainers,e),n(t))},r.getModule=function(t){if(void 0!==t.r)return a.warn(\"Tried to put a polar trace on an incompatible graph of cartesian data. Ignoring this dataset.\",t),!1;var e=r.modules[i(t)];return!!e&&e._module},r.traceIs=function(t,e){if(\"various\"===(t=i(t)))return!1;var n=r.modules[t];return n||(t&&\"area\"!==t&&a.log(\"Unrecognized trace type \"+t+\".\"),n=r.modules[l.type.dflt]),!!n.categories[e]},r.getTransformIndices=function(t,e){for(var r=[],n=t.transforms||[],i=0;i<n.length;i++)n[i].type===e&&r.push(i);return r},r.hasTransform=function(t,e){for(var r=t.transforms||[],n=0;n<r.length;n++)if(r[n].type===e)return!0;return!1},r.getComponentMethod=function(t,e){var n=r.componentsRegistry[t];return n?n[e]||o:o}},{\"./lib/loggers\":729,\"./lib/noop\":733,\"./lib/push_unique\":737,\"./plots/attributes\":764}],845:[function(t,e,r){\"use strict\";function n(t){var e;switch(t){case\"themes__thumb\":e={autosize:!0,width:150,height:150,title:\"\",showlegend:!1,margin:{l:5,r:5,t:5,b:5,pad:0},annotations:[]};break;case\"thumbnail\":e={title:\"\",hidesources:!0,showlegend:!1,borderwidth:0,bordercolor:\"\",margin:{l:1,r:1,t:1,b:1,pad:0},annotations:[]};break;default:e={}}return e}function i(t){return[\"xaxis\",\"yaxis\",\"zaxis\"].indexOf(t.slice(0,5))>-1}var a=t(\"../lib\"),o=t(\"../plots/plots\"),s=a.extendFlat,l=a.extendDeep;e.exports=function(t,e){t.framework&&t.framework.isPolar&&(t=t.framework.getConfig());var r,a=t.data,u=t.layout,c=l([],a),h=l({},u,n(e.tileClass)),f=t._context||{};if(e.width&&(h.width=e.width),e.height&&(h.height=e.height),\"thumbnail\"===e.tileClass||\"themes__thumb\"===e.tileClass){h.annotations=[];var d=Object.keys(h);for(r=0;r<d.length;r++)i(d[r])&&(h[d[r]].title=\"\");for(r=0;r<c.length;r++){var p=c[r];p.showscale=!1,p.marker&&(p.marker.showscale=!1),\"pie\"===p.type&&(p.textposition=\"none\")}}if(Array.isArray(e.annotations))for(r=0;r<e.annotations.length;r++)h.annotations.push(e.annotations[r]);var m=o.getSubplotIds(h,\"gl3d\");if(m.length){var v={};for(\"thumbnail\"===e.tileClass&&(v={title:\"\",showaxeslabels:!1,showticklabels:!1,linetickenable:!1}),r=0;r<m.length;r++){var g=h[m[r]];g.xaxis||(g.xaxis={}),g.yaxis||(g.yaxis={}),g.zaxis||(g.zaxis={}),s(g.xaxis,v),s(g.yaxis,v),s(g.zaxis,v),g._scene=null}}var y=document.createElement(\"div\");e.tileClass&&(y.className=e.tileClass);var b={gd:y,td:y,layout:h,data:c,config:{staticPlot:void 0===e.staticPlot||e.staticPlot,plotGlPixelRatio:void 0===e.plotGlPixelRatio?2:e.plotGlPixelRatio,displaylogo:e.displaylogo||!1,showLink:e.showLink||!1,showTips:e.showTips||!1,mapboxAccessToken:f.mapboxAccessToken}};return\"transparent\"!==e.setBackground&&(b.config.setBackground=e.setBackground||\"opaque\"),b.gd.defaultLayout=n(e.tileClass),b}},{\"../lib\":725,\"../plots/plots\":829}],846:[function(t,e,r){\"use strict\";function n(t,e){return e=e||{},e.format=e.format||\"png\",new Promise(function(r,n){t._snapshotInProgress&&n(new Error(\"Snapshotting already in progress.\")),a.isIE()&&\"svg\"!==e.format&&n(new Error(\"Sorry IE does not support downloading from canvas. Try {format:'svg'} instead.\")),t._snapshotInProgress=!0;var s=i(t,e),l=e.filename||t.fn||\"newplot\";l+=\".\"+e.format,s.then(function(e){return t._snapshotInProgress=!1,o(e,l)}).then(function(t){r(t)}).catch(function(e){t._snapshotInProgress=!1,n(e)})})}var i=t(\"../plot_api/to_image\"),a=t(\"../lib\"),o=t(\"./filesaver\");e.exports=n},{\"../lib\":725,\"../plot_api/to_image\":759,\"./filesaver\":847}],847:[function(t,e,r){\"use strict\";var n=function(t,e){var r=document.createElement(\"a\"),n=\"download\"in r,i=/Version\\/[\\d\\.]+.*Safari/.test(navigator.userAgent);return new Promise(function(a,o){\"undefined\"!=typeof navigator&&/MSIE [1-9]\\./.test(navigator.userAgent)&&o(new Error(\"IE < 10 unsupported\")),i&&(document.location.href=\"data:application/octet-stream\"+t.slice(t.search(/[,;]/)),a(e)),e||(e=\"download\"),n&&(r.href=t,r.download=e,document.body.appendChild(r),r.click(),document.body.removeChild(r),a(e)),\"undefined\"!=typeof navigator&&navigator.msSaveBlob&&(navigator.msSaveBlob(new Blob([t]),e),a(e)),o(new Error(\"download error\"))})};e.exports=n},{}],848:[function(t,e,r){\"use strict\";r.getDelay=function(t){return t._has&&(t._has(\"gl3d\")||t._has(\"gl2d\"))?500:0},r.getRedrawFunc=function(t){if(!(t.data&&t.data[0]&&t.data[0].r))return function(){(t.calcdata||[]).forEach(function(t){t[0]&&t[0].t&&t[0].t.cb&&t[0].t.cb()})}}},{}],849:[function(t,e,r){\"use strict\";var n=t(\"./helpers\"),i={getDelay:n.getDelay,getRedrawFunc:n.getRedrawFunc,clone:t(\"./cloneplot\"),toSVG:t(\"./tosvg\"),svgToImg:t(\"./svgtoimg\"),toImage:t(\"./toimage\"),downloadImage:t(\"./download\")};e.exports=i},{\"./cloneplot\":845,\"./download\":846,\"./helpers\":848,\"./svgtoimg\":850,\"./toimage\":851,\"./tosvg\":852}],850:[function(t,e,r){\"use strict\";function n(t){var e=t.emitter||new a,r=new Promise(function(n,a){var o=window.Image,s=t.svg,l=t.format||\"png\";if(i.isIE()&&\"svg\"!==l){var u=new Error(\"Sorry IE does not support downloading from canvas. Try {format:'svg'} instead.\");return a(u),t.promise?r:e.emit(\"error\",u)}var c=t.canvas,h=c.getContext(\"2d\"),f=new o,d=\"data:image/svg+xml,\"+encodeURIComponent(s);c.height=t.height||150,c.width=t.width||300,f.onload=function(){var r;switch(\"svg\"!==l&&h.drawImage(f,0,0),l){case\"jpeg\":r=c.toDataURL(\"image/jpeg\");break;case\"png\":r=c.toDataURL(\"image/png\");break;case\"webp\":r=c.toDataURL(\"image/webp\");break;case\"svg\":r=d;break;default:var i=\"Image format is not jpeg, png, svg or webp.\";if(a(new Error(i)),!t.promise)return e.emit(\"error\",i)}n(r),t.promise||e.emit(\"success\",r)},f.onerror=function(r){if(a(r),!t.promise)return e.emit(\"error\",r)},f.src=d});return t.promise?r:e}var i=t(\"../lib\"),a=t(\"events\").EventEmitter;e.exports=n},{\"../lib\":725,events:128}],851:[function(t,e,r){\"use strict\";function n(t,e){function r(){var t=s.getDelay(f._fullLayout);setTimeout(function(){var t=u(f),r=document.createElement(\"canvas\");r.id=o.randstr(),n=c({format:e.format,width:f._fullLayout.width,height:f._fullLayout.height,canvas:r,emitter:n,svg:t}),n.clean=function(){f&&document.body.removeChild(f)}},t)}var n=new i,h=l(t,{format:\"png\"}),f=h.gd;f.style.position=\"absolute\",f.style.left=\"-5000px\",document.body.appendChild(f);var d=s.getRedrawFunc(f);return a.plot(f,h.data,h.layout,h.config).then(d).then(r).catch(function(t){n.emit(\"error\",t)}),n}var i=t(\"events\").EventEmitter,a=t(\"../plotly\"),o=t(\"../lib\"),s=t(\"./helpers\"),l=t(\"./cloneplot\"),u=t(\"./tosvg\"),c=t(\"./svgtoimg\");e.exports=n},{\"../lib\":725,\"../plotly\":761,\"./cloneplot\":845,\"./helpers\":848,\"./svgtoimg\":850,\"./tosvg\":852,events:128}],852:[function(t,e,r){\"use strict\";function n(t){var e=a.select(\"body\").append(\"div\").style({display:\"none\"}).html(\"\"),r=t.replace(/(&[^;]*;)/gi,function(t){return\"&lt;\"===t?\"&#60;\":\"&rt;\"===t?\"&#62;\":-1!==t.indexOf(\"<\")||-1!==t.indexOf(\">\")?\"\":e.html(t).text()});return e.remove(),r}function i(t){return t.replace(/&(?!\\w+;|\\#[0-9]+;| \\#x[0-9A-F]+;)/g,\"&amp;\")}var a=t(\"d3\"),o=t(\"../lib\"),s=t(\"../components/drawing\"),l=t(\"../components/color\"),u=t(\"../constants/xmlns_namespaces\"),c=/\"/g,h=new RegExp('(\"TOBESTRIPPED)|(TOBESTRIPPED\")',\"g\");e.exports=function(t,e){var r,f=t._fullLayout,d=f._paper,p=f._toppaper;d.insert(\"rect\",\":first-child\").call(s.setRect,0,0,f.width,f.height).call(l.fill,f.paper_bgcolor);var m=f._basePlotModules||[];for(r=0;r<m.length;r++){var v=m[r];v.toSVG&&v.toSVG(t)}if(p){var g=p.node().childNodes,y=Array.prototype.slice.call(g);for(r=0;r<y.length;r++){var b=y[r];b.childNodes.length&&d.node().appendChild(b)}}f._draggers&&f._draggers.remove(),d.node().style.background=\"\",d.selectAll(\"text\").attr({\"data-unformatted\":null,\"data-math\":null}).each(function(){var t=a.select(this);if(\"hidden\"===t.style(\"visibility\")||\"none\"===t.style(\"display\"))return void t.remove();t.style({visibility:null,display:null});var e=t.style(\"font-family\");e&&-1!==e.indexOf('\"')&&t.style(\"font-family\",e.replace(c,\"TOBESTRIPPED\"))}),d.selectAll(\".point,.scatterpts\").each(function(){var t=a.select(this),e=t.style(\"fill\");e&&-1!==e.indexOf(\"url(\")&&t.style(\"fill\",e.replace(c,\"TOBESTRIPPED\"))}),\"pdf\"!==e&&\"eps\"!==e||d.selectAll(\"#MathJax_SVG_glyphs path\").attr(\"stroke-width\",0),d.node().setAttributeNS(u.xmlns,\"xmlns\",u.svg),d.node().setAttributeNS(u.xmlns,\"xmlns:xlink\",u.xlink);var x=(new window.XMLSerializer).serializeToString(d.node());return x=n(x),x=i(x),x=x.replace(h,\"'\"),o.isIE()&&(x=x.replace(/\"/gi,\"'\"),x=x.replace(/(\\('#)([^']*)('\\))/gi,'(\"$2\")'),x=x.replace(/(\\\\')/gi,'\"')),x}},{\"../components/color\":603,\"../components/drawing\":627,\"../constants/xmlns_namespaces\":707,\"../lib\":725,d3:121}],853:[function(t,e,r){\"use strict\";var n=t(\"../../lib\").mergeArray;e.exports=function(t,e){n(e.text,t,\"tx\"),n(e.hovertext,t,\"htx\");var r=e.marker;if(r){n(r.opacity,t,\"mo\"),n(r.color,t,\"mc\");var i=r.line;i&&(n(i.color,t,\"mlc\"),n(i.width,t,\"mlw\"))}}},{\"../../lib\":725}],854:[function(t,e,r){\"use strict\"\n",
       ";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/color_attributes\"),a=t(\"../../components/errorbars/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../plots/font_attributes\"),l=t(\"../../lib/extend\").extendFlat,u=t(\"../../lib/extend\").extendDeep,c=u({},s);c.family.arrayOk=!0,c.size.arrayOk=!0,c.color.arrayOk=!0;var h=n.marker,f=h.line,d=l({},f.width,{dflt:0}),p=l({},{width:d},i(\"marker.line\")),m=l({},{line:p},i(\"marker\"),{showscale:h.showscale,colorbar:o});e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:n.text,hovertext:n.hovertext,textposition:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"auto\",\"none\"],dflt:\"none\",arrayOk:!0},textfont:l({},c,{}),insidetextfont:l({},c,{}),outsidetextfont:l({},c,{}),constraintext:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"both\",\"none\"],dflt:\"both\"},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"]},base:{valType:\"any\",dflt:null,arrayOk:!0},offset:{valType:\"number\",dflt:null,arrayOk:!0},width:{valType:\"number\",dflt:null,min:0,arrayOk:!0},marker:m,r:n.r,t:n.t,error_y:a,error_x:a,_deprecated:{bardir:{valType:\"enumerated\",values:[\"v\",\"h\"]}}}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/errorbars/attributes\":629,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../scatter/attributes\":1027}],855:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../components/colorscale/has_colorscale\"),o=t(\"../../components/colorscale/calc\"),s=t(\"./arrays_to_calcdata\");e.exports=function(t,e){var r,l,u,c,h,f=i.getFromId(t,e.xaxis||\"x\"),d=i.getFromId(t,e.yaxis||\"y\"),p=e.orientation||(e.x&&!e.y?\"h\":\"v\");\"h\"===p?(r=f,u=f.makeCalcdata(e,\"x\"),l=d.makeCalcdata(e,\"y\"),h=e.xcalendar):(r=d,u=d.makeCalcdata(e,\"y\"),l=f.makeCalcdata(e,\"x\"),h=e.ycalendar);var m=Math.min(l.length,u.length),v=new Array(m);for(c=0;c<m;c++)v[c]={p:l[c],s:u[c]};var g,y=e.base;if(Array.isArray(y)){for(c=0;c<Math.min(y.length,v.length);c++)g=r.d2c(y[c],0,h),v[c].b=n(g)?g:0;for(;c<v.length;c++)v[c].b=0}else for(g=r.d2c(y,0,h),g=n(g)?g:0,c=0;c<v.length;c++)v[c].b=g;return a(e,\"marker\")&&o(e,e.marker.color,\"marker\",\"c\"),a(e,\"marker.line\")&&o(e,e.marker.line.color,\"marker.line\",\"c\"),s(v,e),v}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"../../plots/cartesian/axes\":766,\"./arrays_to_calcdata\":853,\"fast-isnumeric\":130}],856:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/color\"),a=t(\"../scatter/xy_defaults\"),o=t(\"../bar/style_defaults\"),s=t(\"../../components/errorbars/defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,l,r,i)}var h=n.coerceFont;if(!a(t,e,u,c))return void(e.visible=!1);c(\"orientation\",e.x&&!e.y?\"h\":\"v\"),c(\"base\"),c(\"offset\"),c(\"width\"),c(\"text\"),c(\"hovertext\");var f=c(\"textposition\"),d=Array.isArray(f)||\"auto\"===f,p=d||\"inside\"===f,m=d||\"outside\"===f;if(p||m){var v=h(c,\"textfont\",u.font);p&&h(c,\"insidetextfont\",v),m&&h(c,\"outsidetextfont\",v),c(\"constraintext\")}o(t,e,c,r,u),s(t,e,i.defaultLine,{axis:\"y\"}),s(t,e,i.defaultLine,{axis:\"x\",inherit:\"y\"})}},{\"../../components/color\":603,\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../bar/style_defaults\":865,\"../scatter/xy_defaults\":1049,\"./attributes\":854}],857:[function(t,e,r){\"use strict\";var n=t(\"../../components/fx\"),i=t(\"../../components/errorbars\"),a=t(\"../../components/color\");e.exports=function(t,e,r,o){var s,l,u,c,h,f,d,p=t.cd,m=p[0].trace,v=p[0].t,g=t.xa,y=t.ya,b=function(t){return n.inbox(c(t)-s,h(t)-s)};\"h\"===m.orientation?(s=r,l=function(t){return t.y-t.w/2},u=function(t){return t.y+t.w/2},f=function(t){return n.inbox(t.b-e,t.x-e)+(t.x-e)/(t.x-t.b)},d=b):(s=e,l=function(t){return t.x-t.w/2},u=function(t){return t.x+t.w/2},d=function(t){return n.inbox(t.b-r,t.y-r)+(t.y-r)/(t.y-t.b)},f=b),c=\"closest\"===o?l:function(t){return Math.min(l(t),t.p-v.bargroupwidth/2)},h=\"closest\"===o?u:function(t){return Math.max(u(t),t.p+v.bargroupwidth/2)};var x=n.getDistanceFunction(o,f,d);if(n.getClosest(p,x,t),!1!==t.index){var _=t.index,w=p[_],M=w.mcc||m.marker.color,k=w.mlcc||m.marker.line.color,A=w.mlw||m.marker.line.width;a.opacity(M)?t.color=M:a.opacity(k)&&A&&(t.color=k);var T=m.base?w.b+w.s:w.s;return\"h\"===m.orientation?(t.x0=t.x1=g.c2p(w.x,!0),t.xLabelVal=T,t.y0=y.c2p(c(w),!0),t.y1=y.c2p(h(w),!0),t.yLabelVal=w.p):(t.y0=t.y1=y.c2p(w.y,!0),t.yLabelVal=T,t.x0=g.c2p(c(w),!0),t.x1=g.c2p(h(w),!0),t.xLabelVal=w.p),w.htx?t.text=w.htx:m.hovertext?t.text=m.hovertext:w.tx?t.text=w.tx:m.text&&(t.text=m.text),i.hoverInfo(w,m,t),[t]}}},{\"../../components/color\":603,\"../../components/errorbars\":633,\"../../components/fx\":644}],858:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"./layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"./set_positions\"),n.colorbar=t(\"../scatter/colorbar\"),n.arraysToCalcdata=t(\"./arrays_to_calcdata\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"bar\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"bar\",\"oriented\",\"markerColorscale\",\"errorBarsOK\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../scatter/colorbar\":1030,\"./arrays_to_calcdata\":853,\"./attributes\":854,\"./calc\":855,\"./defaults\":856,\"./hover\":857,\"./layout_attributes\":859,\"./layout_defaults\":860,\"./plot\":861,\"./set_positions\":862,\"./style\":864}],859:[function(t,e,r){\"use strict\";e.exports={barmode:{valType:\"enumerated\",values:[\"stack\",\"group\",\"overlay\",\"relative\"],dflt:\"group\"},barnorm:{valType:\"enumerated\",values:[\"\",\"fraction\",\"percent\"],dflt:\"\"},bargap:{valType:\"number\",min:0,max:1},bargroupgap:{valType:\"number\",min:0,max:1,dflt:0}}},{}],860:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\"),o=t(\"./layout_attributes\");e.exports=function(t,e,r){function s(r,n){return a.coerce(t,e,o,r,n)}for(var l=!1,u=!1,c=!1,h={},f=0;f<r.length;f++){var d=r[f];if(n.traceIs(d,\"bar\")){if(l=!0,\"overlay\"!==t.barmode&&\"stack\"!==t.barmode){var p=d.xaxis+d.yaxis;h[p]&&(c=!0),h[p]=!0}if(d.visible&&\"histogram\"===d.type){\"category\"!==i.getFromId({_fullLayout:e},d[\"v\"===d.orientation?\"xaxis\":\"yaxis\"]).type&&(u=!0)}}}if(l){\"overlay\"!==s(\"barmode\")&&s(\"barnorm\"),s(\"bargap\",u&&!c?0:.2),s(\"bargroupgap\")}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./layout_attributes\":859}],861:[function(t,e,r){\"use strict\";function n(t,e,r,n,o,f,d,p){function m(e,r,n){return e.append(\"text\").text(r).attr({class:\"bartext\",transform:\"\",\"text-anchor\":\"middle\",\"data-notex\":1}).call(k.font,n).call(w.convertToTspans,t)}var v=r[0].trace,g=v.orientation,y=s(v,n);if(y){var b=l(v,n);if(\"none\"!==b){var x,_,M,A,T=u(v,n,t._fullLayout.font),S=c(v,n,T),E=h(v,n,T),L=t._fullLayout.barmode,C=\"stack\"===L,z=\"relative\"===L,D=C||z,P=r[n],O=!D||P._outmost,R=Math.abs(f-o)-2*I,F=Math.abs(p-d)-2*I;if(\"outside\"===b&&(O||(b=\"inside\")),\"auto\"===b)if(O){x=m(e,y,S),_=k.bBox(x.node()),M=_.width,A=_.height;var j=M>0&&A>0,N=M<=R&&A<=F,B=M<=F&&A<=R,U=\"h\"===g?R>=M*(F/A):F>=A*(R/M);j&&(N||B||U)?b=\"inside\":(b=\"outside\",x.remove(),x=null)}else b=\"inside\";if(!x&&(x=m(e,y,\"outside\"===b?E:S),_=k.bBox(x.node()),M=_.width,A=_.height,M<=0||A<=0))return void x.remove();var V,H;\"outside\"===b?(H=\"both\"===v.constraintext||\"outside\"===v.constraintext,V=a(o,f,d,p,_,g,H)):(H=\"both\"===v.constraintext||\"inside\"===v.constraintext,V=i(o,f,d,p,_,g,H)),x.attr(\"transform\",V)}}}function i(t,e,r,n,i,a,s){var l,u,c,h,f,d=i.width,p=i.height,m=(i.left+i.right)/2,v=(i.top+i.bottom)/2,g=Math.abs(e-t),y=Math.abs(n-r);g>2*I&&y>2*I?(f=I,g-=2*f,y-=2*f):f=0;var b,x;return d<=g&&p<=y?(b=!1,x=1):d<=y&&p<=g?(b=!0,x=1):d<p==g<y?(b=!1,x=s?Math.min(g/d,y/p):1):(b=!0,x=s?Math.min(y/d,g/p):1),b&&(b=90),b?(l=x*p,u=x*d):(l=x*d,u=x*p),\"h\"===a?e<t?(c=e+f+l/2,h=(r+n)/2):(c=e-f-l/2,h=(r+n)/2):n>r?(c=(t+e)/2,h=n-f-u/2):(c=(t+e)/2,h=n+f+u/2),o(m,v,c,h,x,b)}function a(t,e,r,n,i,a,s){var l,u=\"h\"===a?Math.abs(n-r):Math.abs(e-t);u>2*I&&(l=I);var c=1;s&&(c=\"h\"===a?Math.min(1,u/i.height):Math.min(1,u/i.width));var h,f,d,p,m=(i.left+i.right)/2,v=(i.top+i.bottom)/2;return h=c*i.width,f=c*i.height,\"h\"===a?e<t?(d=e-l-h/2,p=(r+n)/2):(d=e+l+h/2,p=(r+n)/2):n>r?(d=(t+e)/2,p=n+l+f/2):(d=(t+e)/2,p=n-l-f/2),o(m,v,d,p,c,!1)}function o(t,e,r,n,i,a){var o,s;return i<1?o=\"scale(\"+i+\") \":(i=1,o=\"\"),s=a?\"rotate(\"+a+\" \"+t+\" \"+e+\") \":\"\",\"translate(\"+(r-i*t)+\" \"+(n-i*e)+\")\"+o+s}function s(t,e){var r=d(t.text,e);return p(S,r)}function l(t,e){var r=d(t.textposition,e);return m(E,r)}function u(t,e,r){return f(L,t.textfont,e,r)}function c(t,e,r){return f(C,t.insidetextfont,e,r)}function h(t,e,r){return f(z,t.outsidetextfont,e,r)}function f(t,e,r,n){e=e||{};var i=d(e.family,r),a=d(e.size,r),o=d(e.color,r);return{family:p(t.family,i,n.family),size:v(t.size,a,n.size),color:g(t.color,o,n.color)}}function d(t,e){var r;return Array.isArray(t)?e<t.length&&(r=t[e]):r=t,r}function p(t,e,r){if(\"string\"==typeof e){if(e||!t.noBlank)return e}else if(\"number\"==typeof e&&!t.strict)return String(e);return void 0!==r?r:t.dflt}function m(t,e,r){return t.coerceNumber&&(e=+e),-1!==t.values.indexOf(e)?e:void 0!==r?r:t.dflt}function v(t,e,r){if(b(e)){e=+e;var n=t.min,i=t.max;if(!(void 0!==n&&e<n||void 0!==i&&e>i))return e}return void 0!==r?r:t.dflt}function g(t,e,r){return x(e).isValid()?e:void 0!==r?r:t.dflt}var y=t(\"d3\"),b=t(\"fast-isnumeric\"),x=t(\"tinycolor2\"),_=t(\"../../lib\"),w=t(\"../../lib/svg_text_utils\"),M=t(\"../../components/color\"),k=t(\"../../components/drawing\"),A=t(\"../../components/errorbars\"),T=t(\"./attributes\"),S=T.text,E=T.textposition,L=T.textfont,C=T.insidetextfont,z=T.outsidetextfont,I=3;e.exports=function(t,e,r){var i=e.xaxis,a=e.yaxis,o=t._fullLayout,s=e.plot.select(\".barlayer\").selectAll(\"g.trace.bars\").data(r);s.enter().append(\"g\").attr(\"class\",\"trace bars\"),s.append(\"g\").attr(\"class\",\"points\").each(function(e){var r=e[0].t,s=e[0].trace,l=r.poffset,u=Array.isArray(l);y.select(this).selectAll(\"g.point\").data(_.identity).enter().append(\"g\").classed(\"point\",!0).each(function(r,c){function h(t){return 0===o.bargap&&0===o.bargroupgap?y.round(Math.round(t)-A,2):t}function f(t,e){return Math.abs(t-e)>=2?h(t):t>e?Math.ceil(t):Math.floor(t)}var d,p,m,v,g=r.p+(u?l[c]:l),x=g+r.w,_=r.b,w=_+r.s;if(\"h\"===s.orientation?(m=a.c2p(g,!0),v=a.c2p(x,!0),d=i.c2p(_,!0),p=i.c2p(w,!0)):(d=i.c2p(g,!0),p=i.c2p(x,!0),m=a.c2p(_,!0),v=a.c2p(w,!0)),!(b(d)&&b(p)&&b(m)&&b(v)&&d!==p&&m!==v))return void y.select(this).remove();var k=(r.mlw+1||s.marker.line.width+1||(r.trace?r.trace.marker.line.width:0)+1)-1,A=y.round(k/2%1,2);if(!t._context.staticPlot){var T=M.opacity(r.mc||s.marker.color),S=T<1||k>.01?h:f;d=S(d,p),p=S(p,d),m=S(m,v),v=S(v,m)}var E=y.select(this);E.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").attr(\"d\",\"M\"+d+\",\"+m+\"V\"+v+\"H\"+p+\"V\"+m+\"Z\"),n(t,E,e,c,d,p,m,v)})}),s.call(A.plot,e)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/errorbars\":633,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"./attributes\":854,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],862:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(n.length){var s,l,u,c,h,f=t._fullLayout.barmode,d=\"overlay\"===f,p=\"group\"===f;if(d)i(t,e,r,n);else if(p){for(s=[],l=[],u=0;u<n.length;u++)c=n[u],h=c[0].trace,void 0===h.offset?l.push(c):s.push(c);l.length&&a(t,e,r,l),s.length&&i(t,e,r,s)}else{for(s=[],l=[],u=0;u<n.length;u++)c=n[u],h=c[0].trace,void 0===h.base?l.push(c):s.push(c);l.length&&o(t,e,r,l),s.length&&i(t,e,r,s)}}}function i(t,e,r,n){for(var i=t._fullLayout.barnorm,a=!i,o=0;o<n.length;o++){var l=n[o],u=new w([l],!1,a);s(t,e,u),i?(m(t,r,u),v(t,r,u)):d(t,r,u)}}function a(t,e,r,n){var i=t._fullLayout,a=i.barnorm,o=!a,s=new w(n,!1,o);l(t,e,s),a?(m(t,r,s),v(t,r,s)):d(t,r,s)}function o(t,e,r,n){var i=t._fullLayout,a=i.barmode,o=\"stack\"===a,l=\"relative\"===a,u=t._fullLayout.barnorm,c=l,h=!(u||o||l),f=new w(n,c,h);s(t,e,f),p(t,r,f);for(var d=0;d<n.length;d++)for(var m=n[d],g=0;g<m.length;g++){var y=m[g];if(y.s!==b){var x=y.b+y.s===f.get(y.p,y.s);x&&(y._outmost=!0)}}u&&v(t,r,f)}function s(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.bargap,f=s.bargroupgap,d=r.minDiff,p=r.traces,m=d*(1-l),v=m,g=v*(1-f),y=-g/2;for(n=0;n<p.length;n++)i=p[n],a=i[0],o=a.t,o.barwidth=g,o.poffset=y,o.bargroupwidth=m;r.binWidth=p[0][0].t.barwidth/100,u(r),c(t,e,r),h(t,e,r)}function l(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.bargap,f=s.bargroupgap,d=r.positions,p=r.distinctPositions,m=r.minDiff,v=r.traces,g=d.length!==p.length,y=v.length,b=m*(1-l),x=g?b/y:b,_=x*(1-f);for(n=0;n<y;n++){i=v[n],a=i[0];var w=g?((2*n+1-y)*x-_)/2:-_/2;o=a.t,o.barwidth=_,o.poffset=w,o.bargroupwidth=b}r.binWidth=v[0][0].t.barwidth/100,u(r),c(t,e,r),h(t,e,r,g)}function u(t){var e,r,n,i,a,o,s=t.traces;for(e=0;e<s.length;e++){r=s[e],n=r[0],i=n.trace,o=n.t;var l,u=i.offset,c=o.poffset;if(Array.isArray(u)){for(l=u.slice(0,r.length),a=0;a<l.length;a++)y(l[a])||(l[a]=c);for(a=l.length;a<r.length;a++)l.push(c);o.poffset=l}else void 0!==u&&(o.poffset=u);var h=i.width,f=o.barwidth;if(Array.isArray(h)){var d=h.slice(0,r.length);for(a=0;a<d.length;a++)y(d[a])||(d[a]=f);for(a=d.length;a<r.length;a++)d.push(f);if(o.barwidth=d,void 0===u){for(l=[],a=0;a<r.length;a++)l.push(c+(f-d[a])/2);o.poffset=l}}else void 0!==h&&(o.barwidth=h,void 0===u&&(o.poffset=c+(f-h)/2))}}function c(t,e,r){for(var n=r.traces,i=g(e),a=0;a<n.length;a++)for(var o=n[a],s=o[0].t,l=s.poffset,u=Array.isArray(l),c=s.barwidth,h=Array.isArray(c),f=0;f<o.length;f++){var d=o[f],p=d.w=h?c[f]:c;d[i]=d.p+(u?l[f]:l)+p/2}}function h(t,e,r,n){var i=r.traces,a=r.distinctPositions,o=a[0],s=r.minDiff,l=s/2;_.minDtick(e,s,o,n);for(var u=Math.min.apply(Math,a)-l,c=Math.max.apply(Math,a)+l,h=0;h<i.length;h++){var f=i[h],d=f[0],p=d.trace;if(void 0!==p.width||void 0!==p.offset)for(var m=d.t,v=m.poffset,g=m.barwidth,y=Array.isArray(v),b=Array.isArray(g),x=0;x<f.length;x++){var w=f[x],M=y?v[x]:v,k=b?g[x]:g,A=w.p,T=A+M,S=T+k;u=Math.min(u,T),c=Math.max(c,S)}}_.expand(e,[u,c],{padded:!1})}function f(t,e){y(t[0])?t[0]=Math.min(t[0],e):t[0]=e,y(t[1])?t[1]=Math.max(t[1],e):t[1]=e}function d(t,e,r){for(var n=r.traces,i=g(e),a=e.l2c(e.c2l(0)),o=[a,a],s=0;s<n.length;s++)for(var l=n[s],u=0;u<l.length;u++){var c=l[u],h=c.b,d=h+c.s;c[i]=d,y(e.c2l(d))&&f(o,d),y(e.c2l(h))&&f(o,h)}_.expand(e,o,{tozero:!0,padded:!0})}function p(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.barnorm,u=g(e),c=r.traces,h=e.l2c(e.c2l(0)),d=[h,h];for(n=0;n<c.length;n++)for(i=c[n],a=0;a<i.length;a++)if(o=i[a],o.s!==b){var p=r.put(o.p,o.b+o.s),m=p+o.b+o.s;o.b=p,o[u]=m,l||(y(e.c2l(m))&&f(d,m),y(e.c2l(p))&&f(d,p))}l||_.expand(e,d,{tozero:!0,padded:!0})}function m(t,e,r){for(var n=r.traces,i=0;i<n.length;i++)for(var a=n[i],o=0;o<a.length;o++){var s=a[o];s.s!==b&&r.put(s.p,s.b+s.s)}}function v(t,e,r){function n(t){y(e.c2l(t))&&(t<l-s||t>u+s||!y(l))&&(h=!0,f(c,t))}for(var i=r.traces,a=g(e),o=\"fraction\"===t._fullLayout.barnorm?1:100,s=o/1e9,l=e.l2c(e.c2l(0)),u=\"stack\"===t._fullLayout.barmode?o:l,c=[l,u],h=!1,d=0;d<i.length;d++)for(var p=i[d],m=0;m<p.length;m++){var v=p[m];if(v.s!==b){var x=Math.abs(o/r.get(v.p,v.s));v.b*=x,v.s*=x;var w=v.b,M=w+v.s;v[a]=M,n(M),n(w)}}_.expand(e,c,{tozero:!0,padded:h})}function g(t){return t._id.charAt(0)}var y=t(\"fast-isnumeric\"),b=t(\"../../constants/numerical\").BADNUM,x=t(\"../../registry\"),_=t(\"../../plots/cartesian/axes\"),w=t(\"./sieve.js\");e.exports=function(t,e){var r,i=e.xaxis,a=e.yaxis,o=t._fullData,s=t.calcdata,l=[],u=[];for(r=0;r<o.length;r++){var c=o[r];!0===c.visible&&x.traceIs(c,\"bar\")&&c.xaxis===i._id&&c.yaxis===a._id&&(\"h\"===c.orientation?l.push(s[r]):u.push(s[r]))}n(t,i,a,u),n(t,a,i,l)}},{\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./sieve.js\":863,\"fast-isnumeric\":130}],863:[function(t,e,r){\"use strict\";function n(t,e,r){this.traces=t,this.separateNegativeValues=e,this.dontMergeOverlappingData=r;for(var n=[],o=0;o<t.length;o++)for(var s=t[o],l=0;l<s.length;l++){var u=s[l];u.p!==a&&n.push(u.p)}this.positions=n;var c=i.distinctVals(this.positions);this.distinctPositions=c.vals,this.minDiff=c.minDiff,this.binWidth=this.minDiff,this.bins={}}e.exports=n;var i=t(\"../../lib\"),a=t(\"../../constants/numerical\").BADNUM;n.prototype.put=function(t,e){var r=this.getLabel(t,e),n=this.bins[r]||0;return this.bins[r]=n+e,n},n.prototype.get=function(t,e){var r=this.getLabel(t,e);return this.bins[r]||0},n.prototype.getLabel=function(t,e){return(e<0&&this.separateNegativeValues?\"v\":\"^\")+(this.dontMergeOverlappingData?t:Math.round(t/this.binWidth))}},{\"../../constants/numerical\":705,\"../../lib\":725}],864:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/color\"),a=t(\"../../components/drawing\"),o=t(\"../../components/errorbars\");e.exports=function(t){var e=n.select(t).selectAll(\"g.trace.bars\"),r=e.size(),s=t._fullLayout;e.style(\"opacity\",function(t){return t[0].trace.opacity}).each(function(t){(\"stack\"===s.barmode&&r>1||0===s.bargap&&0===s.bargroupgap&&!t[0].trace.marker.line.width)&&n.select(this).attr(\"shape-rendering\",\"crispEdges\")}),e.selectAll(\"g.points\").each(function(t){var e=t[0].trace,r=e.marker,o=r.line,s=a.tryColorscale(r,\"\"),l=a.tryColorscale(r,\"line\");n.select(this).selectAll(\"path\").each(function(t){var e,a,u=(t.mlw+1||o.width+1)-1,c=n.select(this);e=\"mc\"in t?t.mcc=s(t.mc):Array.isArray(r.color)?i.defaultLine:r.color,c.style(\"stroke-width\",u+\"px\").call(i.fill,e),u&&(a=\"mlc\"in t?t.mlcc=l(t.mlc):Array.isArray(o.color)?i.defaultLine:o.color,c.call(i.stroke,a))})}),e.call(o.style)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/errorbars\":633,d3:121}],865:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"../../components/colorscale/has_colorscale\"),a=t(\"../../components/colorscale/defaults\");e.exports=function(t,e,r,o,s){r(\"marker.color\",o),i(t,\"marker\")&&a(t,e,s,r,{prefix:\"marker.\",cLetter:\"c\"}),r(\"marker.line.color\",n.defaultLine),i(t,\"marker.line\")&&a(t,e,s,r,{prefix:\"marker.line.\",cLetter:\"c\"}),r(\"marker.line.width\")}},{\"../../components/color\":603,\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616}],866:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=n.marker,s=o.line;e.exports={y:{valType:\"data_array\"},x:{valType:\"data_array\"},x0:{valType:\"any\"},y0:{valType:\"any\"},xcalendar:n.xcalendar,ycalendar:n.ycalendar,whiskerwidth:{valType:\"number\",min:0,max:1,dflt:.5},boxpoints:{valType:\"enumerated\",values:[\"all\",\"outliers\",\"suspectedoutliers\",!1],dflt:\"outliers\"},boxmean:{valType:\"enumerated\",values:[!0,\"sd\",!1],dflt:!1},jitter:{valType:\"number\",min:0,max:1},pointpos:{valType:\"number\",min:-2,max:2},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"]},marker:{outliercolor:{valType:\"color\",dflt:\"rgba(0, 0, 0, 0)\"},symbol:a({},o.symbol,{arrayOk:!1}),opacity:a({},o.opacity,{arrayOk:!1,dflt:1}),size:a({},o.size,{arrayOk:!1}),color:a({},o.color,{arrayOk:!1}),line:{color:a({},s.color,{arrayOk:!1,dflt:i.defaultLine}),width:a({},s.width,{arrayOk:!1,dflt:0}),outliercolor:{valType:\"color\"},outlierwidth:{valType:\"number\",min:0,dflt:1}}},line:{color:{valType:\"color\"},width:{valType:\"number\",min:0,dflt:2}},fillcolor:n.fillcolor}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],867:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\");e.exports=function(t,e){var r,o,s,l,u,c,h,f,d,p=a.getFromId(t,e.xaxis||\"x\"),m=a.getFromId(t,e.yaxis||\"y\"),v=e.orientation,g=[];\"h\"===v?(r=p,o=\"x\",u=m,c=\"y\"):(r=m,o=\"y\",u=p,c=\"x\"),s=r.makeCalcdata(e,o),a.expand(r,s,{padded:!0}),h=function(t,e,r,a,o){var s;return r in e?h=a.makeCalcdata(e,r):(s=r+\"0\"in e?e[r+\"0\"]:\"name\"in e&&(\"category\"===a.type||n(e.name)&&-1!==[\"linear\",\"log\"].indexOf(a.type)||i.isDateTime(e.name)&&\"date\"===a.type)?e.name:t.numboxes,s=a.d2c(s,0,e[r+\"calendar\"]),h=o.map(function(){return s})),h}(t,e,c,u,s);var y=i.distinctVals(h);return f=y.vals,d=y.minDiff/2,l=function(t,e,r,a,o){var s,l,u,c,h=a.length,f=e.length,d=[],p=[];for(s=0;s<h;++s)l=a[s],t[s]={pos:l},p[s]=l-o,d[s]=[];for(p.push(a[h-1]+o),s=0;s<f;++s)c=e[s],n(c)&&(u=i.findBin(r[s],p))>=0&&u<f&&d[u].push(c);return d}(g,s,h,f,d),function(t,e){var r,n,a,o;for(o=0;o<e.length;++o)r=e[o].sort(i.sorterAsc),n=r.length,a=t[o],a.val=r,a.min=r[0],a.max=r[n-1],a.mean=i.mean(r,n),a.sd=i.stdev(r,n,a.mean),a.q1=i.interp(r,.25),a.med=i.interp(r,.5),a.q3=i.interp(r,.75),a.lf=Math.min(a.q1,r[Math.min(i.findBin(2.5*a.q1-1.5*a.q3,r,!0)+1,n-1)]),a.uf=Math.max(a.q3,r[Math.max(i.findBin(2.5*a.q3-1.5*a.q1,r),0)]),a.lo=4*a.q1-3*a.q3,a.uo=4*a.q3-3*a.q1}(g,l),g=g.filter(function(t){return t.val&&t.val.length}),g.length?(g[0].t={boxnum:t.numboxes,dPos:d},t.numboxes++,g):[{t:{emptybox:!0}}]}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"fast-isnumeric\":130}],868:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../registry\"),a=t(\"../../components/color\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}var u,c=l(\"y\"),h=l(\"x\");if(c&&c.length)u=\"v\",h||l(\"x0\");else{if(!h||!h.length)return void(e.visible=!1);u=\"h\",l(\"y0\")}i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],s),l(\"orientation\",u),l(\"line.color\",(t.marker||{}).color||r),l(\"line.width\",2),l(\"fillcolor\",a.addOpacity(e.line.color,.5)),l(\"whiskerwidth\"),l(\"boxmean\");var f=n.coerce2(t,e,o,\"marker.outliercolor\"),d=l(\"marker.line.outliercolor\"),p=f||d?l(\"boxpoints\",\"suspectedoutliers\"):l(\"boxpoints\");p&&(l(\"jitter\",\"all\"===p?.3:0),l(\"pointpos\",\"all\"===p?-1.5:0),l(\"marker.symbol\"),l(\"marker.opacity\"),l(\"marker.size\"),l(\"marker.color\",e.line.color),l(\"marker.line.color\"),l(\"marker.line.width\"),\"suspectedoutliers\"===p&&(l(\"marker.line.outliercolor\",e.marker.color),l(\"marker.line.outlierwidth\")))}},{\"../../components/color\":603,\"../../lib\":725,\"../../registry\":844,\"./attributes\":866}],869:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib\"),a=t(\"../../components/fx\"),o=t(\"../../components/color\");e.exports=function(t,e,r,s){var l,u,c,h,f,d,p,m,v,g=t.cd,y=g[0].trace,b=g[0].t,x=t.xa,_=t.ya,w=[];if(h=\"closest\"===s?2.5*b.bdPos:b.bdPos,\"h\"===y.orientation?(l=function(t){return a.inbox(t.min-e,t.max-e)},u=function(t){var e=t.pos+b.bPos-r;return a.inbox(e-h,e+h)},f=\"y\",d=_,m=\"x\",v=x):(l=function(t){var r=t.pos+b.bPos-e;return a.inbox(r-h,r+h)},u=function(t){return a.inbox(t.min-r,t.max-r)},f=\"x\",d=x,m=\"y\",v=_),c=a.getDistanceFunction(s,l,u),a.getClosest(g,c,t),!1!==t.index){var M=g[t.index],k=y.line.color,A=(y.marker||{}).color;o.opacity(k)&&y.line.width?t.color=k:o.opacity(A)&&y.boxpoints?t.color=A:t.color=y.fillcolor,t[f+\"0\"]=d.c2p(M.pos+b.bPos-b.bdPos,!0),t[f+\"1\"]=d.c2p(M.pos+b.bPos+b.bdPos,!0),n.tickText(d,d.c2l(M.pos),\"hover\").text,t[f+\"LabelVal\"]=M.pos;var T,S,E={},L=[\"med\",\"min\",\"q1\",\"q3\",\"max\"];y.boxmean&&L.push(\"mean\"),y.boxpoints&&[].push.apply(L,[\"lf\",\"uf\"]);for(var C=0;C<L.length;C++)(T=L[C])in M&&!(M[T]in E)&&(E[M[T]]=!0,p=v.c2p(M[T],!0),S=i.extendFlat({},t),S[m+\"0\"]=S[m+\"1\"]=p,S[m+\"LabelVal\"]=M[T],S.attr=T,\"mean\"===T&&\"sd\"in M&&\"sd\"===y.boxmean&&(S[m+\"err\"]=M.sd),t.name=\"\",w.push(S));return w}}},{\"../../components/color\":603,\"../../components/fx\":644,\"../../lib\":725,\"../../plots/cartesian/axes\":766}],870:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"./layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"./set_positions\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"box\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"symbols\",\"oriented\",\"box\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":866,\"./calc\":867,\"./defaults\":868,\"./hover\":869,\"./layout_attributes\":871,\"./layout_defaults\":872,\"./plot\":873,\"./set_positions\":874,\"./style\":875}],871:[function(t,e,r){\"use strict\";e.exports={boxmode:{valType:\"enumerated\",values:[\"group\",\"overlay\"],dflt:\"overlay\"},boxgap:{valType:\"number\",min:0,max:1,dflt:.3},boxgroupgap:{valType:\"number\",min:0,max:1,dflt:.3}}},{}],872:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"./layout_attributes\");e.exports=function(t,e,r){function o(r,n){return i.coerce(t,e,a,r,n)}for(var s,l=0;l<r.length;l++)if(n.traceIs(r[l],\"box\")){s=!0;break}s&&(o(\"boxmode\"),o(\"boxgap\"),o(\"boxgroupgap\"))}},{\"../../lib\":725,\"../../registry\":844,\"./layout_attributes\":871}],873:[function(t,e,r){\"use strict\";function n(){l=2e9}function i(){var t=l;return l=(69069*l+1)%4294967296,Math.abs(l-t)<429496729?i():l/4294967296}var a=t(\"d3\"),o=t(\"../../lib\"),s=t(\"../../components/drawing\"),l=2e9;e.exports=function(t,e,r){var l,u,c=t._fullLayout,h=e.xaxis,f=e.yaxis;e.plot.select(\".boxlayer\").selectAll(\"g.trace.boxes\").data(r).enter().append(\"g\").attr(\"class\",\"trace boxes\").each(function(e){var r=e[0].t,d=e[0].trace,p=\"group\"===c.boxmode&&t.numboxes>1,m=r.dPos*(1-c.boxgap)*(1-c.boxgroupgap)/(p?t.numboxes:1),v=p?2*r.dPos*((r.boxnum+.5)/t.numboxes-.5)*(1-c.boxgap):0,g=m*d.whiskerwidth;if(!0!==d.visible||r.emptybox)return void a.select(this).remove();\"h\"===d.orientation?(l=f,u=h):(l=h,u=f),r.bPos=v,r.bdPos=m,n(),a.select(this).selectAll(\"path.box\").data(o.identity).enter().append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").attr(\"class\",\"box\").each(function(t){var e=l.c2p(t.pos+v,!0),r=l.c2p(t.pos+v-m,!0),n=l.c2p(t.pos+v+m,!0),i=l.c2p(t.pos+v-g,!0),s=l.c2p(t.pos+v+g,!0),c=u.c2p(t.q1,!0),h=u.c2p(t.q3,!0),f=o.constrain(u.c2p(t.med,!0),Math.min(c,h)+1,Math.max(c,h)-1),p=u.c2p(!1===d.boxpoints?t.min:t.lf,!0),y=u.c2p(!1===d.boxpoints?t.max:t.uf,!0);\"h\"===d.orientation?a.select(this).attr(\"d\",\"M\"+f+\",\"+r+\"V\"+n+\"M\"+c+\",\"+r+\"V\"+n+\"H\"+h+\"V\"+r+\"ZM\"+c+\",\"+e+\"H\"+p+\"M\"+h+\",\"+e+\"H\"+y+(0===d.whiskerwidth?\"\":\"M\"+p+\",\"+i+\"V\"+s+\"M\"+y+\",\"+i+\"V\"+s)):a.select(this).attr(\"d\",\"M\"+r+\",\"+f+\"H\"+n+\"M\"+r+\",\"+c+\"H\"+n+\"V\"+h+\"H\"+r+\"ZM\"+e+\",\"+c+\"V\"+p+\"M\"+e+\",\"+h+\"V\"+y+(0===d.whiskerwidth?\"\":\"M\"+i+\",\"+p+\"H\"+s+\"M\"+i+\",\"+y+\"H\"+s))}),d.boxpoints&&a.select(this).selectAll(\"g.points\").data(function(t){return t.forEach(function(t){t.t=r,t.trace=d}),t}).enter().append(\"g\").attr(\"class\",\"points\").selectAll(\"path\").data(function(t){var e,r,n,a,s,l,u,c=\"all\"===d.boxpoints?t.val:t.val.filter(function(e){return e<t.lf||e>t.uf}),h=Math.max((t.max-t.min)/10,t.q3-t.q1),f=1e-9*h,p=.01*h,g=[],y=0;if(d.jitter){if(0===h)for(y=1,g=new Array(c.length),e=0;e<c.length;e++)g[e]=1;else for(e=0;e<c.length;e++)r=Math.max(0,e-5),a=c[r],n=Math.min(c.length-1,e+5),s=c[n],\"all\"!==d.boxpoints&&(c[e]<t.lf?s=Math.min(s,t.lf):a=Math.max(a,t.uf)),l=Math.sqrt(p*(n-r)/(s-a+f))||0,l=o.constrain(Math.abs(l),0,1),g.push(l),y=Math.max(l,y);u=2*d.jitter/y}return c.map(function(e,r){var n,a=d.pointpos;return d.jitter&&(a+=u*g[r]*(i()-.5)),n=\"h\"===d.orientation?{y:t.pos+a*m+v,x:e}:{x:t.pos+a*m+v,y:e},\"suspectedoutliers\"===d.boxpoints&&e<t.uo&&e>t.lo&&(n.so=!0),n})}).enter().append(\"path\").classed(\"point\",!0).call(s.translatePoints,h,f),d.boxmean&&a.select(this).selectAll(\"path.mean\").data(o.identity).enter().append(\"path\").attr(\"class\",\"mean\").style({fill:\"none\",\"vector-effect\":\"non-scaling-stroke\"}).each(function(t){var e=l.c2p(t.pos+v,!0),r=l.c2p(t.pos+v-m,!0),n=l.c2p(t.pos+v+m,!0),i=u.c2p(t.mean,!0),o=u.c2p(t.mean-t.sd,!0),s=u.c2p(t.mean+t.sd,!0);\"h\"===d.orientation?a.select(this).attr(\"d\",\"M\"+i+\",\"+r+\"V\"+n+(\"sd\"!==d.boxmean?\"\":\"m0,0L\"+o+\",\"+e+\"L\"+i+\",\"+r+\"L\"+s+\",\"+e+\"Z\")):a.select(this).attr(\"d\",\"M\"+r+\",\"+i+\"H\"+n+(\"sd\"!==d.boxmean?\"\":\"m0,0L\"+e+\",\"+o+\"L\"+r+\",\"+i+\"L\"+e+\",\"+s+\"Z\"))})})}},{\"../../components/drawing\":627,\"../../lib\":725,d3:121}],874:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\");e.exports=function(t,e){var r,o,s,l,u=t._fullLayout,c=e.xaxis,h=e.yaxis,f=[\"v\",\"h\"];for(o=0;o<f.length;++o){var d,p,m,v=f[o],g=[],y=[],b=0,x=0;for(r=\"h\"===v?h:c,s=0;s<t.calcdata.length;++s)d=t.calcdata[s],p=d[0].t,m=d[0].trace,!0===m.visible&&n.traceIs(m,\"box\")&&!p.emptybox&&m.orientation===v&&m.xaxis===c._id&&m.yaxis===h._id&&(g.push(s),!1!==m.boxpoints&&(b=Math.max(b,m.jitter-m.pointpos-1),x=Math.max(x,m.jitter+m.pointpos-1)));for(s=0;s<g.length;s++)for(d=t.calcdata[g[s]],l=0;l<d.length;l++)y.push(d[l].pos);if(y.length){var _=a.distinctVals(y),w=_.minDiff/2;for(y.length===_.vals.length&&(t.numboxes=1),i.minDtick(r,_.minDiff,_.vals[0],!0),o=0;o<g.length;o++){var M=g[o];t.calcdata[M][0].t.dPos=w}var k=(1-u.boxgap)*(1-u.boxgroupgap)*w/t.numboxes;i.expand(r,_.vals,{vpadminus:w+b*k,vpadplus:w+x*k})}}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844}],875:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/color\"),a=t(\"../../components/drawing\");e.exports=function(t){n.select(t).selectAll(\"g.trace.boxes\").style(\"opacity\",function(t){return t[0].trace.opacity}).each(function(e){var r=e[0].trace,o=r.line.width;n.select(this).selectAll(\"path.box\").style(\"stroke-width\",o+\"px\").call(i.stroke,r.line.color).call(i.fill,r.fillcolor),n.select(this).selectAll(\"path.mean\").style({\"stroke-width\":o,\"stroke-dasharray\":2*o+\"px,\"+o+\"px\"}).call(i.stroke,r.line.color),n.select(this).selectAll(\"g.points path\").call(a.pointStyle,r,t)})}},{\"../../components/color\":603,\"../../components/drawing\":627,d3:121}],876:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../ohlc/attributes\"),a=t(\"../box/attributes\"),o={name:i.increasing.name,showlegend:i.increasing.showlegend,line:{color:n.extendFlat({},a.line.color),width:n.extendFlat({},a.line.width)},fillcolor:n.extendFlat({},a.fillcolor)};e.exports={x:i.x,open:i.open,high:i.high,low:i.low,close:i.close,line:{width:n.extendFlat({},a.line.width,{})},increasing:n.extendDeep({},o,{line:{color:{dflt:i.increasing.line.color.dflt}}}),decreasing:n.extendDeep({},o,{line:{color:{dflt:i.decreasing.line.color.dflt}}}),text:i.text,whiskerwidth:n.extendFlat({},a.whiskerwidth,{dflt:0})}},{\"../../lib\":725,\"../box/attributes\":866,\"../ohlc/attributes\":986}],877:[function(t,e,r){\"use strict\";function n(t,e,r,n){o(t,e,r,n),r(n+\".line.color\"),r(n+\".line.width\",e.line.width),r(n+\".fillcolor\")}var i=t(\"../../lib\"),a=t(\"../ohlc/ohlc_defaults\"),o=t(\"../ohlc/direction_defaults\"),s=t(\"../ohlc/helpers\"),l=t(\"./attributes\");e.exports=function(t,e,r,o){function u(r,n){return i.coerce(t,e,l,r,n)}if(s.pushDummyTransformOpts(t,e),0===a(t,e,u,o))return void(e.visible=!1);u(\"line.width\"),n(t,e,u,\"increasing\"),n(t,e,u,\"decreasing\"),u(\"text\"),u(\"whiskerwidth\")}},{\"../../lib\":725,\"../ohlc/direction_defaults\":988,\"../ohlc/helpers\":989,\"../ohlc/ohlc_defaults\":991,\"./attributes\":876}],878:[function(t,e,r){\"use strict\";var n=t(\"../../plot_api/register\");e.exports={moduleType:\"trace\",name:\"candlestick\",basePlotModule:t(\"../../plots/cartesian\"),categories:[\"cartesian\",\"showLegend\",\"candlestick\"],meta:{},attributes:t(\"./attributes\"),supplyDefaults:t(\"./defaults\")},n(t(\"../box\")),n(t(\"./transform\"))},{\"../../plot_api/register\":756,\"../../plots/cartesian\":776,\"../box\":870,\"./attributes\":876,\"./defaults\":877,\"./transform\":879}],879:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"box\",boxpoints:!1,visible:t.visible,hoverinfo:t.hoverinfo,opacity:t.opacity,xaxis:t.xaxis,yaxis:t.yaxis,transforms:o.makeTransform(t,e,r)},i=t[r];return i&&a.extendFlat(n,{x:t.x||[0],xcalendar:t.xcalendar,y:[].concat(t.low).concat(t.high),whiskerwidth:t.whiskerwidth,text:t.text,name:i.name,showlegend:i.showlegend,line:i.line,fillcolor:i.fillcolor}),n}var i=t(\"fast-isnumeric\"),a=t(\"../../lib\"),o=t(\"../ohlc/helpers\");r.moduleType=\"transform\",r.name=\"candlestick\",r.attributes={},r.supplyDefaults=function(t,e,r,n){return o.clearEphemeralTransformOpts(n),o.copyOHLC(t,e),t},r.transform=function(t,e){for(var r=[],i=0;i<t.length;i++){\n",
       "var a=t[i];\"candlestick\"===a.type?r.push(n(a,e,\"increasing\"),n(a,e,\"decreasing\")):r.push(a)}return o.addRangeSlider(r,e.layout),r},r.calcTransform=function(t,e,r){for(var n=r.direction,a=o.getFilterFn(n),s=e.open,l=e.high,u=e.low,c=e.close,h=s.length,f=[],d=[],p=e._fullInput.x?function(t){var r=e.x[t];f.push(r,r,r,r,r,r)}:function(t){f.push(t,t,t,t,t,t)},m=0;m<h;m++)a(s[m],c[m])&&i(l[m])&&i(u[m])&&(p(m),function(t,e,r,n){d.push(r,t,n,n,n,e)}(s[m],l[m],u[m],c[m]));e.x=f,e.y=d}},{\"../../lib\":725,\"../ohlc/helpers\":989,\"fast-isnumeric\":130}],880:[function(t,e,r){\"use strict\";function n(t,e,r,n){[\"aaxis\",\"baxis\"].forEach(function(a){var o=a.charAt(0),s=t[a]||{},l={},u={tickfont:\"x\",id:o+\"axis\",letter:o,font:e.font,name:a,data:t[o],calendar:e.calendar,dfltColor:n,bgColor:r.paper_bgcolor,fullLayout:r};i(s,l,u),l._categories=l._categories||[],e[a]=l,t[a]||\"-\"===s.type||(t[a]={type:s.type})})}var i=t(\"./axis_defaults\");e.exports=function(t,e,r,i,a){i(\"a\")||(i(\"da\"),i(\"a0\")),i(\"b\")||(i(\"db\"),i(\"b0\")),n(t,e,r,a)}},{\"./axis_defaults\":885}],881:[function(t,e,r){\"use strict\";function n(t,e){if(!Array.isArray(t)||e>=10)return null;for(var r=1/0,i=-1/0,a=t.length,o=0;o<a;o++){var s=t[o];if(Array.isArray(s)){var l=n(s,e+1);l&&(r=Math.min(l[0],r),i=Math.max(l[1],i))}else r=Math.min(s,r),i=Math.max(s,i)}return[r,i]}e.exports=function(t){return n(t,0)}},{}],882:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"./axis_attributes\"),o=t(\"../../components/color/attributes\");e.exports={carpet:{valType:\"string\"},x:{valType:\"data_array\"},y:{valType:\"data_array\"},a:{valType:\"data_array\"},a0:{valType:\"number\",dflt:0},da:{valType:\"number\",dflt:1},b:{valType:\"data_array\"},b0:{valType:\"number\",dflt:0},db:{valType:\"number\",dflt:1},cheaterslope:{valType:\"number\",dflt:1},aaxis:n({},a),baxis:n({},a),font:{family:n({},i.family,{dflt:'\"Open Sans\", verdana, arial, sans-serif'}),size:n({},i.size,{dflt:12}),color:n({},i.color,{dflt:o.defaultLine})},color:{valType:\"color\",dflt:o.defaultLine}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"./axis_attributes\":884}],883:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s,l,u,c,h,f,d,p,m,v,g=Array.isArray(r)?\"a\":\"b\",y=\"a\"===g?t.aaxis:t.baxis,b=y.smoothing,x=\"a\"===g?t.a2i:t.b2j,_=\"a\"===g?r:n,w=\"a\"===g?n:r,M=\"a\"===g?e.a.length:e.b.length,k=\"a\"===g?e.b.length:e.a.length,A=Math.floor(\"a\"===g?t.b2j(w):t.a2i(w)),T=\"a\"===g?function(e){return t.evalxy([],e,A)}:function(e){return t.evalxy([],A,e)};b&&(o=Math.max(0,Math.min(k-2,A)),s=A-o,a=\"a\"===g?function(e,r){return t.dxydi([],e,o,r,s)}:function(e,r){return t.dxydj([],o,e,s,r)});var S=x(_[0]),E=x(_[1]),L=S<E?1:-1,C=1e-8*(E-S),z=L>0?Math.floor:Math.ceil,I=L>0?Math.ceil:Math.floor,D=L>0?Math.min:Math.max,P=L>0?Math.max:Math.min,O=z(S+C),R=I(E-C);c=T(S);var F=[[c]];for(i=O;i*L<R*L;i+=L)l=[],p=P(S,i),m=D(E,i+L),v=m-p,u=Math.max(0,Math.min(M-2,Math.floor(.5*(p+m)))),h=T(m),b&&(f=a(u,p-u),d=a(u,m-u),l.push([c[0]+f[0]/3*v,c[1]+f[1]/3*v]),l.push([h[0]-d[0]/3*v,h[1]-d[1]/3*v])),l.push(h),F.push(l),c=h;return F}},{}],884:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"../../components/color/attributes\");e.exports={color:{valType:\"color\"},smoothing:{valType:\"number\",dflt:1,min:0,max:1.3},title:{valType:\"string\"},titlefont:n({},i,{}),titleoffset:{valType:\"number\",dflt:10},type:{valType:\"enumerated\",values:[\"-\",\"linear\",\"date\",\"category\"],dflt:\"-\"},autorange:{valType:\"enumerated\",values:[!0,!1,\"reversed\"],dflt:!0},rangemode:{valType:\"enumerated\",values:[\"normal\",\"tozero\",\"nonnegative\"],dflt:\"normal\"},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},fixedrange:{valType:\"boolean\",dflt:!1},cheatertype:{valType:\"enumerated\",values:[\"index\",\"value\"],dflt:\"value\"},tickmode:{valType:\"enumerated\",values:[\"linear\",\"array\"],dflt:\"array\"},nticks:{valType:\"integer\",min:0,dflt:0},tickvals:{valType:\"data_array\"},ticktext:{valType:\"data_array\"},showticklabels:{valType:\"enumerated\",values:[\"start\",\"end\",\"both\",\"none\"],dflt:\"start\"},tickfont:n({},i,{}),tickangle:{valType:\"angle\",dflt:\"auto\"},tickprefix:{valType:\"string\",dflt:\"\"},showtickprefix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},ticksuffix:{valType:\"string\",dflt:\"\"},showticksuffix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},showexponent:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},exponentformat:{valType:\"enumerated\",values:[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"],dflt:\"B\"},separatethousands:{valType:\"boolean\",dflt:!1},tickformat:{valType:\"string\",dflt:\"\"},categoryorder:{valType:\"enumerated\",values:[\"trace\",\"category ascending\",\"category descending\",\"array\"],dflt:\"trace\"},categoryarray:{valType:\"data_array\"},labelpadding:{valType:\"integer\",dflt:10},labelprefix:{valType:\"string\"},labelsuffix:{valType:\"string\",dflt:\"\"},showline:{valType:\"boolean\",dflt:!1},linecolor:{valType:\"color\",dflt:a.defaultLine},linewidth:{valType:\"number\",min:0,dflt:1},gridcolor:{valType:\"color\"},gridwidth:{valType:\"number\",min:0,dflt:1},showgrid:{valType:\"boolean\",dflt:!0},minorgridcount:{valType:\"integer\",min:0,dflt:0},minorgridwidth:{valType:\"number\",min:0,dflt:1},minorgridcolor:{valType:\"color\",dflt:a.lightLine},startline:{valType:\"boolean\"},startlinecolor:{valType:\"color\"},startlinewidth:{valType:\"number\",dflt:1},endline:{valType:\"boolean\"},endlinewidth:{valType:\"number\",dflt:1},endlinecolor:{valType:\"color\"},tick0:{valType:\"number\",min:0,dflt:0},dtick:{valType:\"number\",min:0,dflt:1},arraytick0:{valType:\"integer\",min:0,dflt:0},arraydtick:{valType:\"integer\",min:1,dflt:1}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/font_attributes\":790}],885:[function(t,e,r){\"use strict\";function n(t,e){if(\"-\"===t.type){var r=t._id,n=r.charAt(0),i=n+\"calendar\",a=t[i];t.type=d(e,a)}}var i=t(\"./attributes\"),a=t(\"../../components/color\").addOpacity,o=t(\"../../registry\"),s=t(\"../../lib\"),l=t(\"../../plots/cartesian/tick_value_defaults\"),u=t(\"../../plots/cartesian/tick_label_defaults\"),c=t(\"../../plots/cartesian/category_order_defaults\"),h=t(\"../../plots/cartesian/set_convert\"),f=t(\"../../plots/cartesian/ordered_categories\"),d=t(\"../../plots/cartesian/axis_autotype\");e.exports=function(t,e,r){function d(r,n){return s.coerce(t,e,g,r,n)}function p(r,n){return s.coerce2(t,e,g,r,n)}var m=r.letter,v=r.font||{},g=i[m+\"axis\"];r.noHover=!0,r.name&&(e._name=r.name,e._id=r.name);var y=d(\"type\");if(\"-\"===y&&(r.data&&n(e,r.data),\"-\"===e.type?e.type=\"linear\":y=t.type=e.type),d(\"smoothing\"),d(\"cheatertype\"),d(\"showticklabels\"),d(\"labelprefix\",m+\" = \"),d(\"labelsuffix\"),d(\"showtickprefix\"),d(\"showticksuffix\"),d(\"separatethousands\"),d(\"tickformat\"),d(\"exponentformat\"),d(\"showexponent\"),d(\"categoryorder\"),d(\"tickmode\"),d(\"tickvals\"),d(\"ticktext\"),d(\"tick0\"),d(\"dtick\"),\"array\"===e.tickmode&&(d(\"arraytick0\"),d(\"arraydtick\")),d(\"labelpadding\"),e._hovertitle=m,\"date\"===y){o.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\",r.calendar)}h(e,r.fullLayout);var b=d(\"color\",r.dfltColor),x=b===t.color?b:v.color;d(\"title\"),s.coerceFont(d,\"titlefont\",{family:v.family,size:Math.round(1.2*v.size),color:x}),d(\"titleoffset\"),d(\"tickangle\"),d(\"autorange\",!e.isValidRange(t.range))&&d(\"rangemode\"),d(\"range\"),e.cleanRange(),d(\"fixedrange\"),l(t,e,d,y),u(t,e,d,y,r),c(t,e,d);var _=p(\"gridcolor\",a(b,.3)),w=p(\"gridwidth\"),M=d(\"showgrid\");M||(delete e.gridcolor,delete e.gridwidth);var k=p(\"startlinecolor\",b),A=p(\"startlinewidth\",w);d(\"startline\",e.showgrid||!!k||!!A)||(delete e.startlinecolor,delete e.startlinewidth);var T=p(\"endlinecolor\",b),S=p(\"endlinewidth\",w);return d(\"endline\",e.showgrid||!!T||!!S)||(delete e.endlinecolor,delete e.endlinewidth),M?(d(\"minorgridcount\"),d(\"minorgridwidth\",w),d(\"minorgridcolor\",a(_,.06)),e.minorgridcount||(delete e.minorgridwidth,delete e.minorgridcolor)):(delete e.gridcolor,delete e.gridWidth),e._separators=r.fullLayout.separators,e._initialCategories=\"category\"===y?f(m,e.categoryorder,e.categoryarray,r.data):[],\"none\"===e.showticklabels&&(delete e.tickfont,delete e.tickangle,delete e.showexponent,delete e.exponentformat,delete e.tickformat,delete e.showticksuffix,delete e.showtickprefix),e.showticksuffix||delete e.ticksuffix,e.showtickprefix||delete e.tickprefix,d(\"tickmode\"),(!e.title||e.title&&0===e.title.length)&&(delete e.titlefont,delete e.titleoffset),e}},{\"../../components/color\":603,\"../../lib\":725,\"../../plots/cartesian/axis_autotype\":767,\"../../plots/cartesian/category_order_defaults\":770,\"../../plots/cartesian/ordered_categories\":779,\"../../plots/cartesian/set_convert\":783,\"../../plots/cartesian/tick_label_defaults\":784,\"../../plots/cartesian/tick_value_defaults\":786,\"../../registry\":844,\"./attributes\":882}],886:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"./cheater_basis\"),a=t(\"./array_minmax\"),o=t(\"./map_2d_array\"),s=t(\"./calc_gridlines\"),l=t(\"./calc_labels\"),u=t(\"./calc_clippath\"),c=t(\"../heatmap/clean_2d_array\"),h=t(\"./smooth_fill_2d_array\");e.exports=function(t,e){var r,f=n.getFromId(t,e.xaxis||\"x\"),d=n.getFromId(t,e.yaxis||\"y\"),p=e.aaxis,m=e.baxis,v=e._a=e.a,g=e._b=e.b,y={},b=e.y;if(e._cheater){var x=\"index\"===p.cheatertype?v.length:v,_=\"index\"===m.cheatertype?g.length:g;e.x=r=i(x,_,e.cheaterslope)}else r=e.x;e._x=e.x=r=c(r),e._y=e.y=b=c(b),h(r,v,g),h(b,v,g),e.setScale(),y.xp=e.xp=o(e.xp,r,f.c2p),y.yp=e.yp=o(e.yp,b,d.c2p);var w=a(r),M=a(b),k=.5*(w[1]-w[0]),A=.5*(w[1]+w[0]),T=.5*(M[1]-M[0]),S=.5*(M[1]+M[0]);return w=[A-1.3*k,A+1.3*k],M=[S-1.3*T,S+1.3*T],n.expand(f,w,{padded:!0}),n.expand(d,M,{padded:!0}),s(e,y,\"a\",\"b\"),s(e,y,\"b\",\"a\"),l(e,p),l(e,m),y.clipsegments=u(e.xctrl,e.yctrl,p,m),y.x=r,y.y=b,y.a=v,y.b=g,[y]}},{\"../../plots/cartesian/axes\":766,\"../heatmap/clean_2d_array\":946,\"./array_minmax\":881,\"./calc_clippath\":887,\"./calc_gridlines\":888,\"./calc_labels\":889,\"./cheater_basis\":891,\"./map_2d_array\":903,\"./smooth_fill_2d_array\":907}],887:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s=[],l=!!r.smoothing,u=!!n.smoothing,c=t[0].length-1,h=t.length-1;for(i=0,a=[],o=[];i<=c;i++)a[i]=t[0][i],o[i]=e[0][i];for(s.push({x:a,y:o,bicubic:l}),i=0,a=[],o=[];i<=h;i++)a[i]=t[i][c],o[i]=e[i][c];for(s.push({x:a,y:o,bicubic:u}),i=c,a=[],o=[];i>=0;i--)a[c-i]=t[h][i],o[c-i]=e[h][i];for(s.push({x:a,y:o,bicubic:l}),i=h,a=[],o=[];i>=0;i--)a[h-i]=t[i][0],o[h-i]=e[i][0];return s.push({x:a,y:o,bicubic:u}),s}},{}],888:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib/extend\").extendFlat;e.exports=function(t,e,r,a){function o(e){var n,i,o,s,l,u,c,h,f,d,p,v,g=[],y=[],b={};if(\"b\"===r)for(i=t.b2j(e),o=Math.floor(Math.max(0,Math.min(P-2,i))),s=i-o,b.length=P,b.crossLength=D,b.xy=function(e){return t.evalxy([],e,i)},b.dxy=function(e,r){return t.dxydi([],e,o,r,s)},n=0;n<D;n++)u=Math.min(D-2,n),c=n-u,h=t.evalxy([],n,i),E.smoothing&&n>0&&(f=t.dxydi([],n-1,o,0,s),g.push(l[0]+f[0]/3),y.push(l[1]+f[1]/3),d=t.dxydi([],n-1,o,1,s),g.push(h[0]-d[0]/3),y.push(h[1]-d[1]/3)),g.push(h[0]),y.push(h[1]),l=h;else for(n=t.a2i(e),u=Math.floor(Math.max(0,Math.min(D-2,n))),c=n-u,b.length=D,b.crossLength=P,b.xy=function(e){return t.evalxy([],n,e)},b.dxy=function(e,r){return t.dxydj([],u,e,c,r)},i=0;i<P;i++)o=Math.min(P-2,i),s=i-o,h=t.evalxy([],n,i),E.smoothing&&i>0&&(p=t.dxydj([],u,i-1,c,0),g.push(l[0]+p[0]/3),y.push(l[1]+p[1]/3),v=t.dxydj([],u,i-1,c,1),g.push(h[0]-v[0]/3),y.push(h[1]-v[1]/3)),g.push(h[0]),y.push(h[1]),l=h;return b.axisLetter=r,b.axis=M,b.crossAxis=E,b.value=e,b.constvar=a,b.index=m,b.x=g,b.y=y,b.smoothing=E.smoothing,b}function s(e){var n,i,o,s,l,u=[],c=[],h={};if(h.length=w.length,h.crossLength=S.length,\"b\"===r)for(o=Math.max(0,Math.min(P-2,e)),l=Math.min(1,Math.max(0,e-o)),h.xy=function(r){return t.evalxy([],r,e)},h.dxy=function(e,r){return t.dxydi([],e,o,r,l)},n=0;n<z;n++)u[n]=L[e*O][n],c[n]=C[e*O][n];else for(i=Math.max(0,Math.min(D-2,e)),s=Math.min(1,Math.max(0,e-i)),h.xy=function(r){return t.evalxy([],e,r)},h.dxy=function(e,r){return t.dxydj([],i,e,s,r)},n=0;n<I;n++)u[n]=L[n][e*O],c[n]=C[n][e*O];return h.axisLetter=r,h.axis=M,h.crossAxis=E,h.value=w[e],h.constvar=a,h.index=e,h.x=u,h.y=c,h.smoothing=E.smoothing,h}var l,u,c,h,f,d,p,m,v,g,y,b,x,_,w=t[r],M=t[r+\"axis\"],k=M._gridlines=[],A=M._minorgridlines=[],T=M._boundarylines=[],S=t[a],E=t[a+\"axis\"];if(\"array\"===M.tickmode)for(M.tickvals=[],l=0;l<w.length;l++)M.tickvals.push(w[l]);var L=t.xctrl,C=t.yctrl,z=L[0].length,I=L.length,D=t.a.length,P=t.b.length;n.calcTicks(M);var O=M.smoothing?3:1;if(\"array\"===M.tickmode){for(h=5e-15,f=[Math.floor((w.length-1-M.arraytick0)/M.arraydtick*(1+h)),Math.ceil(-M.arraytick0/M.arraydtick/(1+h))].sort(function(t,e){return t-e}),d=f[0]-1,p=f[1]+1,m=d;m<p;m++)(u=M.arraytick0+M.arraydtick*m)<0||u>w.length-1||k.push(i(s(u),{color:M.gridcolor,width:M.gridwidth}));for(m=d;m<p;m++)if(c=M.arraytick0+M.arraydtick*m,y=Math.min(c+M.arraydtick,w.length-1),!(c<0||c>w.length-1||y<0||y>w.length-1))for(b=w[c],x=w[y],l=0;l<M.minorgridcount;l++)(_=y-c)<=0||(g=b+(x-b)*(l+1)/(M.minorgridcount+1)*(M.arraydtick/_))<w[0]||g>w[w.length-1]||A.push(i(o(g),{color:M.minorgridcolor,width:M.minorgridwidth}));M.startline&&T.push(i(s(0),{color:M.startlinecolor,width:M.startlinewidth})),M.endline&&T.push(i(s(w.length-1),{color:M.endlinecolor,width:M.endlinewidth}))}else{for(h=5e-15,f=[Math.floor((w[w.length-1]-M.tick0)/M.dtick*(1+h)),Math.ceil((w[0]-M.tick0)/M.dtick/(1+h))].sort(function(t,e){return t-e}),d=f[0],p=f[1],m=d;m<=p;m++)v=M.tick0+M.dtick*m,k.push(i(o(v),{color:M.gridcolor,width:M.gridwidth}));for(m=d-1;m<p+1;m++)for(v=M.tick0+M.dtick*m,l=0;l<M.minorgridcount;l++)(g=v+M.dtick*(l+1)/(M.minorgridcount+1))<w[0]||g>w[w.length-1]||A.push(i(o(g),{color:M.minorgridcolor,width:M.minorgridwidth}));M.startline&&T.push(i(o(w[0]),{color:M.startlinecolor,width:M.startlinewidth})),M.endline&&T.push(i(o(w[w.length-1]),{color:M.endlinecolor,width:M.endlinewidth}))}}},{\"../../lib/extend\":716,\"../../plots/cartesian/axes\":766}],889:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib/extend\").extendFlat;e.exports=function(t,e){var r,a,o,s=e._labels=[],l=e._gridlines;for(r=0;r<l.length;r++)o=l[r],-1!==[\"start\",\"both\"].indexOf(e.showticklabels)&&(a=n.tickText(e,o.value),i(a,{prefix:void 0,suffix:void 0,endAnchor:!0,xy:o.xy(0),dxy:o.dxy(0,0),axis:o.axis,length:o.crossAxis.length,font:o.axis.tickfont,isFirst:0===r,isLast:r===l.length-1}),s.push(a)),-1!==[\"end\",\"both\"].indexOf(e.showticklabels)&&(a=n.tickText(e,o.value),i(a,{endAnchor:!1,xy:o.xy(o.crossLength-1),dxy:o.dxy(o.crossLength-2,1),axis:o.axis,length:o.crossAxis.length,font:o.axis.tickfont,isFirst:0===r,isLast:r===l.length-1}),s.push(a))}},{\"../../lib/extend\":716,\"../../plots/cartesian/axes\":766}],890:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i=t[0]-e[0],a=t[1]-e[1],o=r[0]-e[0],s=r[1]-e[1],l=Math.pow(i*i+a*a,.25),u=Math.pow(o*o+s*s,.25),c=(u*u*i-l*l*o)*n,h=(u*u*a-l*l*s)*n,f=u*(l+u)*3,d=l*(l+u)*3;return[[e[0]+(f&&c/f),e[1]+(f&&h/f)],[e[0]-(d&&c/d),e[1]-(d&&h/d)]]}},{}],891:[function(t,e,r){\"use strict\";var n=t(\"../../lib\").isArray;e.exports=function(t,e,r){var i,a,o,s,l,u,c=[],h=n(t)?t.length:t,f=n(e)?e.length:e,d=n(t)?t:null,p=n(e)?e:null;d&&(o=(d.length-1)/(d[d.length-1]-d[0])/(h-1)),p&&(s=(p.length-1)/(p[p.length-1]-p[0])/(f-1));var m,v=1/0,g=-1/0;for(a=0;a<f;a++)for(c[a]=[],u=p?(p[a]-p[0])*s:a/(f-1),i=0;i<h;i++)l=d?(d[i]-d[0])*o:i/(h-1),m=l-u*r,v=Math.min(m,v),g=Math.max(m,g),c[a][i]=m;var y=1/(g-v),b=-v*y;for(a=0;a<f;a++)for(i=0;i<h;i++)c[a][i]=y*c[a][i]+b;return c}},{\"../../lib\":725}],892:[function(t,e,r){\"use strict\";function n(t,e,r){var n=-.5*r[0]+1.5*e[0],i=-.5*r[1]+1.5*e[1];return[(2*n+t[0])/3,(2*i+t[1])/3]}var i=t(\"./catmull_rom\"),a=t(\"../../lib\").ensureArray;e.exports=function(t,e,r,o,s,l){var u,c,h,f,d,p,m,v,g,y,b=r[0].length,x=r.length,_=s?3*b-2:b,w=l?3*x-2:x;for(t=a(t,w),e=a(e,w),h=0;h<w;h++)t[h]=a(t[h],_),e[h]=a(e[h],_);for(c=0,f=0;c<x;c++,f+=l?3:1)for(d=t[f],p=e[f],m=r[c],v=o[c],u=0,h=0;u<b;u++,h+=s?3:1)d[h]=m[u],p[h]=v[u];if(s)for(c=0,f=0;c<x;c++,f+=l?3:1){for(u=1,h=3;u<b-1;u++,h+=3)g=i([r[c][u-1],o[c][u-1]],[r[c][u],o[c][u]],[r[c][u+1],o[c][u+1]],s),t[f][h-1]=g[0][0],e[f][h-1]=g[0][1],t[f][h+1]=g[1][0],e[f][h+1]=g[1][1];y=n([t[f][0],e[f][0]],[t[f][2],e[f][2]],[t[f][3],e[f][3]]),t[f][1]=y[0],e[f][1]=y[1],y=n([t[f][_-1],e[f][_-1]],[t[f][_-3],e[f][_-3]],[t[f][_-4],e[f][_-4]]),t[f][_-2]=y[0],e[f][_-2]=y[1]}if(l)for(h=0;h<_;h++){for(f=3;f<w-3;f+=3)g=i([t[f-3][h],e[f-3][h]],[t[f][h],e[f][h]],[t[f+3][h],e[f+3][h]],l),t[f-1][h]=g[0][0],e[f-1][h]=g[0][1],t[f+1][h]=g[1][0],e[f+1][h]=g[1][1];y=n([t[0][h],e[0][h]],[t[2][h],e[2][h]],[t[3][h],e[3][h]]),t[1][h]=y[0],e[1][h]=y[1],y=n([t[w-1][h],e[w-1][h]],[t[w-3][h],e[w-3][h]],[t[w-4][h],e[w-4][h]]),t[w-2][h]=y[0],e[w-2][h]=y[1]}if(s&&l)for(f=1;f<w;f+=(f+1)%3==0?2:1){for(h=3;h<_-3;h+=3)g=i([t[f][h-3],e[f][h-3]],[t[f][h],e[f][h]],[t[f][h+3],e[f][h+3]],s),t[f][h-1]=.5*(t[f][h-1]+g[0][0]),e[f][h-1]=.5*(e[f][h-1]+g[0][1]),t[f][h+1]=.5*(t[f][h+1]+g[1][0]),e[f][h+1]=.5*(e[f][h+1]+g[1][1]);y=n([t[f][0],e[f][0]],[t[f][2],e[f][2]],[t[f][3],e[f][3]]),t[f][1]=.5*(t[f][1]+y[0]),e[f][1]=.5*(e[f][1]+y[1]),y=n([t[f][_-1],e[f][_-1]],[t[f][_-3],e[f][_-3]],[t[f][_-4],e[f][_-4]]),t[f][_-2]=.5*(t[f][_-2]+y[0]),e[f][_-2]=.5*(e[f][_-2]+y[1])}return[t,e]}},{\"../../lib\":725,\"./catmull_rom\":890}],893:[function(t,e,r){\"use strict\";e.exports={RELATIVE_CULL_TOLERANCE:1e-6}},{}],894:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3,n*=3;var f=i*i,d=1-i,p=d*d,m=d*i*2,v=-3*p,g=3*(p-m),y=3*(m-f),b=3*f,x=a*a,_=x*a,w=1-a,M=w*w,k=M*w;for(h=0;h<t.length;h++)c=t[h],o=v*c[n][r]+g*c[n][r+1]+y*c[n][r+2]+b*c[n][r+3],s=v*c[n+1][r]+g*c[n+1][r+1]+y*c[n+1][r+2]+b*c[n+1][r+3],l=v*c[n+2][r]+g*c[n+2][r+1]+y*c[n+2][r+2]+b*c[n+2][r+3],u=v*c[n+3][r]+g*c[n+3][r+1]+y*c[n+3][r+2]+b*c[n+3][r+3],e[h]=k*o+3*(M*a*s+w*x*l)+_*u;return e}:e?function(e,r,n,i,a){e||(e=[]);var o,s,l,u;r*=3;var c=i*i,h=1-i,f=h*h,d=h*i*2,p=-3*f,m=3*(f-d),v=3*(d-c),g=3*c,y=1-a;for(l=0;l<t.length;l++)u=t[l],o=p*u[n][r]+m*u[n][r+1]+v*u[n][r+2]+g*u[n][r+3],s=p*u[n+1][r]+m*u[n+1][r+1]+v*u[n+1][r+2]+g*u[n+1][r+3],e[l]=y*o+a*s;return e}:r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;n*=3;var f=a*a,d=f*a,p=1-a,m=p*p,v=m*p;for(c=0;c<t.length;c++)h=t[c],o=h[n][r+1]-h[n][r],s=h[n+1][r+1]-h[n+1][r],l=h[n+2][r+1]-h[n+2][r],u=h[n+3][r+1]-h[n+3][r],e[c]=v*o+3*(m*a*s+p*f*l)+d*u;return e}:function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c=1-a;for(l=0;l<t.length;l++)u=t[l],o=u[n][r+1]-u[n][r],s=u[n+1][r+1]-u[n+1][r],e[l]=c*o+a*s;return e}}},{}],895:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3,n*=3;var f=i*i,d=f*i,p=1-i,m=p*p,v=m*p,g=a*a,y=1-a,b=y*y,x=y*a*2,_=-3*b,w=3*(b-x),M=3*(x-g),k=3*g;for(h=0;h<t.length;h++)c=t[h],o=_*c[n][r]+w*c[n+1][r]+M*c[n+2][r]+k*c[n+3][r],s=_*c[n][r+1]+w*c[n+1][r+1]+M*c[n+2][r+1]+k*c[n+3][r+1],l=_*c[n][r+2]+w*c[n+1][r+2]+M*c[n+2][r+2]+k*c[n+3][r+2],u=_*c[n][r+3]+w*c[n+1][r+3]+M*c[n+2][r+3]+k*c[n+3][r+3],e[h]=v*o+3*(m*i*s+p*f*l)+d*u;return e}:e?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3;var f=a*a,d=f*a,p=1-a,m=p*p,v=m*p;for(c=0;c<t.length;c++)h=t[c],o=h[n+1][r]-h[n][r],s=h[n+1][r+1]-h[n][r+1],l=h[n+1][r+2]-h[n][r+2],u=h[n+1][r+3]-h[n][r+3],e[c]=v*o+3*(m*a*s+p*f*l)+d*u;return e}:r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u;n*=3;var c=1-i,h=a*a,f=1-a,d=f*f,p=f*a*2,m=-3*d,v=3*(d-p),g=3*(p-h),y=3*h;for(l=0;l<t.length;l++)u=t[l],o=m*u[n][r]+v*u[n+1][r]+g*u[n+2][r]+y*u[n+3][r],s=m*u[n][r+1]+v*u[n+1][r+1]+g*u[n+2][r+1]+y*u[n+3][r+1],e[l]=c*o+i*s;return e}:function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c=1-i;for(l=0;l<t.length;l++)u=t[l],o=u[n+1][r]-u[n][r],s=u[n+1][r+1]-u[n][r+1],e[l]=c*o+i*s;return e}}},{}],896:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i){var a=e-2,o=r-2;return n&&i?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));f*=3,d*=3;var v=p*p,g=v*p,y=1-p,b=y*y,x=b*y,_=m*m,w=_*m,M=1-m,k=M*M,A=k*M;for(h=0;h<t.length;h++)c=t[h],i=x*c[d][f]+3*(b*p*c[d][f+1]+y*v*c[d][f+2])+g*c[d][f+3],s=x*c[d+1][f]+3*(b*p*c[d+1][f+1]+y*v*c[d+1][f+2])+g*c[d+1][f+3],l=x*c[d+2][f]+3*(b*p*c[d+2][f+1]+y*v*c[d+2][f+2])+g*c[d+2][f+3],u=x*c[d+3][f]+3*(b*p*c[d+3][f+1]+y*v*c[d+3][f+2])+g*c[d+3][f+3],e[h]=A*i+3*(k*m*s+M*_*l)+w*u;return e}:n?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));f*=3;var v=p*p,g=v*p,y=1-p,b=y*y,x=b*y,_=1-m;for(c=0;c<t.length;c++)h=t[c],i=_*h[d][f]+m*h[d+1][f],s=_*h[d][f+1]+m*h[d+1][f+1],l=_*h[d][f+2]+m*h[d+1][f+1],u=_*h[d][f+3]+m*h[d+1][f+1],e[c]=x*i+3*(b*p*s+y*v*l)+g*u;return e}:i?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));d*=3;var v=m*m,g=v*m,y=1-m,b=y*y,x=b*y,_=1-p;for(c=0;c<t.length;c++)h=t[c],i=_*h[d][f]+p*h[d][f+1],s=_*h[d+1][f]+p*h[d+1][f+1],l=_*h[d+2][f]+p*h[d+2][f+1],u=_*h[d+3][f]+p*h[d+3][f+1],e[c]=x*i+3*(b*m*s+y*v*l)+g*u;return e}:function(e,r,n){e||(e=[]);var i,s,l,u,c=Math.max(0,Math.min(Math.floor(r),a)),h=Math.max(0,Math.min(Math.floor(n),o)),f=Math.max(0,Math.min(1,r-c)),d=Math.max(0,Math.min(1,n-h)),p=1-d,m=1-f;for(l=0;l<t.length;l++)u=t[l],i=m*u[h][c]+f*u[h][c+1],s=m*u[h+1][c]+f*u[h+1][c+1],e[l]=p*i+d*s;return e}}},{}],897:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./xy_defaults\"),a=t(\"./ab_defaults\"),o=t(\"./set_convert\"),s=t(\"./attributes\"),l=t(\"../../components/color/attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,s,r,i)}e._clipPathId=\"clip\"+e.uid+\"carpet\";var h=c(\"color\",l.defaultLine);if(n.coerceFont(c,\"font\"),c(\"carpet\"),a(t,e,u,c,h),!e.a||!e.b)return void(e.visible=!1);e.a.length<3&&(e.aaxis.smoothing=0),e.b.length<3&&(e.baxis.smoothing=0);var f=i(t,e,c);o(e),e._cheater&&c(\"cheaterslope\"),f||(e.visible=!1)}},{\"../../components/color/attributes\":602,\"../../lib\":725,\"./ab_defaults\":880,\"./attributes\":882,\"./set_convert\":906,\"./xy_defaults\":908}],898:[function(t,e,r){\"use strict\";e.exports=function(t){return Array.isArray(t[0])}},{}],899:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.plot=t(\"./plot\"),n.calc=t(\"./calc\"),n.animatable=!0,n.moduleType=\"trace\",n.name=\"carpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"carpet\",\"carpetAxis\",\"notLegendIsolatable\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":882,\"./calc\":886,\"./defaults\":897,\"./plot\":905}],900:[function(t,e,r){\"use strict\";e.exports=function(t,e){for(var r,n=t._fullData.length,i=0;i<n;i++){var a=t._fullData[i];if(a.index!==e.index&&(\"carpet\"===a.type&&(r||(r=a),a.carpet===e.carpet)))return a}return r}},{}],901:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){if(0===t.length)return\"\";var n,i=[],a=r?3:1;for(n=0;n<t.length;n+=a)i.push(t[n]+\",\"+e[n]),r&&n<t.length-a&&(i.push(\"C\"),i.push([t[n+1]+\",\"+e[n+1],t[n+2]+\",\"+e[n+2]+\" \"].join(\" \")));return i.join(r?\"\":\"L\")}},{}],902:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){var n;for(Array.isArray(t)?t.length>e.length&&(t=t.slice(0,e.length)):t=[],n=0;n<e.length;n++)t[n]=r(e[n]);return t}},{}],903:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){var n,i;for(Array.isArray(t)?t.length>e.length&&(t=t.slice(0,e.length)):t=[],n=0;n<e.length;n++)for(Array.isArray(t[n])?t[n].length>e.length&&(t[n]=t[n].slice(0,e.length)):t[n]=[],i=0;i<e[0].length;i++)t[n][i]=r(e[n][i]);return t}},{}],904:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i,a){var o=i[0]*t.dpdx(e),s=i[1]*t.dpdy(r),l=1,u=1;if(a){var c=Math.sqrt(i[0]*i[0]+i[1]*i[1]),h=Math.sqrt(a[0]*a[0]+a[1]*a[1]),f=(i[0]*a[0]+i[1]*a[1])/c/h;u=Math.max(0,f)}var d=180*Math.atan2(s,o)/Math.PI;return d<-90?(d+=180,l=-l):d>90&&(d-=180,l=-l),{angle:d,flip:l,p:t.c2p(n,e,r),offsetMultplier:u}}},{}],905:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t.selectAll(e+\".\"+r).data([0]);return n.enter().append(e).classed(r,!0),n}function i(t,e,r){var i=r[0],u=r[0].trace,c=e.xaxis,h=e.yaxis,f=u.aaxis,d=u.baxis,p=t._fullLayout,m=e.plot.selectAll(\".carpetlayer\"),v=n(p._defs,\"g\",\"clips\"),g=n(m,\"g\",\"carpet\"+u.uid).classed(\"trace\",!0),y=n(g,\"g\",\"minorlayer\"),b=n(g,\"g\",\"majorlayer\"),x=n(g,\"g\",\"boundarylayer\"),_=n(g,\"g\",\"labellayer\");g.style(\"opacity\",u.opacity),o(c,h,b,f,\"a\",f._gridlines),o(c,h,b,d,\"b\",d._gridlines),o(c,h,y,f,\"a\",f._minorgridlines),o(c,h,y,d,\"b\",d._minorgridlines),o(c,h,x,f,\"a-boundary\",f._boundarylines),o(c,h,x,d,\"b-boundary\",d._boundarylines),l(t,_,u,i,c,h,s(t,c,h,u,i,_,f._labels,\"a-label\"),s(t,c,h,u,i,_,d._labels,\"b-label\")),a(u,i,v,c,h)}function a(t,e,r,i,a){var o,s,l,u,c=r.select(\"#\"+t._clipPathId);c.size()||(c=r.append(\"clipPath\").classed(\"carpetclip\",!0));var h=n(c,\"path\",\"carpetboundary\"),p=e.clipsegments,m=[];for(u=0;u<p.length;u++)o=p[u],s=f([],o.x,i.c2p),l=f([],o.y,a.c2p),m.push(d(s,l,o.bicubic));var v=\"M\"+m.join(\"L\")+\"Z\";c.attr(\"id\",t._clipPathId),h.attr(\"d\",v)}function o(t,e,r,n,i,a){var o=\"const-\"+i+\"-lines\",s=r.selectAll(\".\"+o).data(a);s.enter().append(\"path\").classed(o,!0).style(\"vector-effect\",\"non-scaling-stroke\"),s.each(function(r){var n=r,i=n.x,a=n.y,o=f([],i,t.c2p),s=f([],a,e.c2p),l=\"M\"+d(o,s,n.smoothing);c.select(this).attr(\"d\",l).style(\"stroke-width\",n.width).style(\"stroke\",n.color).style(\"fill\",\"none\")}),s.exit().remove()}function s(t,e,r,n,i,a,o,s){var l=a.selectAll(\"text.\"+s).data(o);l.enter().append(\"text\").classed(s,!0);var u=0;return l.each(function(i){var a;if(\"auto\"===i.axis.tickangle)a=p(n,e,r,i.xy,i.dxy);else{var o=(i.axis.tickangle+180)*Math.PI/180;a=p(n,e,r,i.xy,[Math.cos(o),Math.sin(o)])}var s=(i.endAnchor?-1:1)*a.flip,l=c.select(this).attr({\"text-anchor\":s>0?\"start\":\"end\",\"data-notex\":1}).call(h.font,i.font).text(i.text).call(m.convertToTspans,t),f=h.bBox(this);l.attr(\"transform\",\"translate(\"+a.p[0]+\",\"+a.p[1]+\") rotate(\"+a.angle+\")translate(\"+i.axis.labelpadding*s+\",\"+.3*f.height+\")\"),u=Math.max(u,f.width+i.axis.labelpadding)}),l.exit().remove(),u}function l(t,e,r,n,i,a,o,s){var l,c,h,f;l=.5*(r.a[0]+r.a[r.a.length-1]),c=r.b[0],h=r.ab2xy(l,c,!0),f=r.dxyda_rough(l,c),u(t,e,r,n,h,f,r.aaxis,i,a,o,\"a-title\"),l=r.a[0],c=.5*(r.b[0]+r.b[r.b.length-1]),h=r.ab2xy(l,c,!0),f=r.dxydb_rough(l,c),u(t,e,r,n,h,f,r.baxis,i,a,s,\"b-title\")}function u(t,e,r,n,i,a,o,s,l,u,f){var d=[];o.title&&d.push(o.title);var v=e.selectAll(\"text.\"+f).data(d);v.enter().append(\"text\").classed(f,!0),v.each(function(){var e=p(r,s,l,i,a);-1===[\"start\",\"both\"].indexOf(o.showticklabels)&&(u=0),u+=o.titlefont.size+o.titleoffset,c.select(this).text(o.title||\"\").call(m.convertToTspans,t).attr(\"transform\",\"translate(\"+e.p[0]+\",\"+e.p[1]+\") rotate(\"+e.angle+\") translate(0,\"+u+\")\").classed(\"user-select-none\",!0).attr(\"text-anchor\",\"middle\").call(h.font,o.titlefont)}),v.exit().remove()}var c=t(\"d3\"),h=t(\"../../components/drawing\"),f=t(\"./map_1d_array\"),d=t(\"./makepath\"),p=t(\"./orient_text\"),m=t(\"../../lib/svg_text_utils\");e.exports=function(t,e,r){for(var n=0;n<r.length;n++)i(t,e,r[n])}},{\"../../components/drawing\":627,\"../../lib/svg_text_utils\":745,\"./makepath\":901,\"./map_1d_array\":902,\"./orient_text\":904,d3:121}],906:[function(t,e,r){\"use strict\";var n=t(\"./constants\"),i=t(\"../../lib/search\").findBin,a=t(\"./compute_control_points\"),o=t(\"./create_spline_evaluator\"),s=t(\"./create_i_derivative_evaluator\"),l=t(\"./create_j_derivative_evaluator\");e.exports=function(t){var e=t.a,r=t.b,u=t.a.length,c=t.b.length,h=t.aaxis,f=t.baxis,d=e[0],p=e[u-1],m=r[0],v=r[c-1],g=e[e.length-1]-e[0],y=r[r.length-1]-r[0],b=g*n.RELATIVE_CULL_TOLERANCE,x=y*n.RELATIVE_CULL_TOLERANCE;d-=b,p+=b,m-=x,v+=x,t.isVisible=function(t,e){return t>d&&t<p&&e>m&&e<v},t.isOccluded=function(t,e){return t<d||t>p||e<m||e>v},h.c2p=function(t){return t},f.c2p=function(t){return t},t.setScale=function(){var e=t.x,r=t.y,n=a(t.xctrl,t.yctrl,e,r,h.smoothing,f.smoothing);t.xctrl=n[0],t.yctrl=n[1],t.evalxy=o([t.xctrl,t.yctrl],u,c,h.smoothing,f.smoothing),t.dxydi=s([t.xctrl,t.yctrl],h.smoothing,f.smoothing),t.dxydj=l([t.xctrl,t.yctrl],h.smoothing,f.smoothing)},t.i2a=function(t){var r=Math.max(0,Math.floor(t[0]),u-2),n=t[0]-r;return(1-n)*e[r]+n*e[r+1]},t.j2b=function(t){var e=Math.max(0,Math.floor(t[1]),u-2),n=t[1]-e;return(1-n)*r[e]+n*r[e+1]},t.ij2ab=function(e){return[t.i2a(e[0]),t.j2b(e[1])]},t.a2i=function(t){var r=Math.max(0,Math.min(i(t,e),u-2)),n=e[r],a=e[r+1];return Math.max(0,Math.min(u-1,r+(t-n)/(a-n)))},t.b2j=function(t){var e=Math.max(0,Math.min(i(t,r),c-2)),n=r[e],a=r[e+1];return Math.max(0,Math.min(c-1,e+(t-n)/(a-n)))},t.ab2ij=function(e){return[t.a2i(e[0]),t.b2j(e[1])]},t.i2c=function(e,r){return t.evalxy([],e,r)},t.ab2xy=function(n,i,a){if(!a&&(n<e[0]||n>e[u-1]|i<r[0]||i>r[c-1]))return[!1,!1];var o=t.a2i(n),s=t.b2j(i),l=t.evalxy([],o,s);if(a){var h,f,d,p,m=0,v=0,g=[];n<e[0]?(h=0,f=0,m=(n-e[0])/(e[1]-e[0])):n>e[u-1]?(h=u-2,f=1,m=(n-e[u-1])/(e[u-1]-e[u-2])):(h=Math.max(0,Math.min(u-2,Math.floor(o))),f=o-h),i<r[0]?(d=0,p=0,v=(i-r[0])/(r[1]-r[0])):i>r[c-1]?(d=c-2,p=1,v=(i-r[c-1])/(r[c-1]-r[c-2])):(d=Math.max(0,Math.min(c-2,Math.floor(s))),p=s-d),m&&(t.dxydi(g,h,d,f,p),l[0]+=g[0]*m,l[1]+=g[1]*m),v&&(t.dxydj(g,h,d,f,p),l[0]+=g[0]*v,l[1]+=g[1]*v)}return l},t.c2p=function(t,e,r){return[e.c2p(t[0]),r.c2p(t[1])]},t.p2x=function(t,e,r){return[e.p2c(t[0]),r.p2c(t[1])]},t.dadi=function(t){var r=Math.max(0,Math.min(e.length-2,t));return e[r+1]-e[r]},t.dbdj=function(t){var e=Math.max(0,Math.min(r.length-2,t));return r[e+1]-r[e]},t.dxyda=function(e,r,n,i){var a=t.dxydi(null,e,r,n,i),o=t.dadi(e,n);return[a[0]/o,a[1]/o]},t.dxydb=function(e,r,n,i){var a=t.dxydj(null,e,r,n,i),o=t.dbdj(r,i);return[a[0]/o,a[1]/o]},t.dxyda_rough=function(e,r,n){var i=g*(n||.1),a=t.ab2xy(e+i,r,!0),o=t.ab2xy(e-i,r,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dxydb_rough=function(e,r,n){var i=y*(n||.1),a=t.ab2xy(e,r+i,!0),o=t.ab2xy(e,r-i,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dpdx=function(t){return t._m},t.dpdy=function(t){return t._m}}},{\"../../lib/search\":740,\"./compute_control_points\":892,\"./constants\":893,\"./create_i_derivative_evaluator\":894,\"./create_j_derivative_evaluator\":895,\"./create_spline_evaluator\":896}],907:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r){var i,a,o,s=[],l=[],u=t[0].length,c=t.length,h=0;for(i=0;i<u;i++)for(a=0;a<c;a++)void 0===t[a][i]&&(s.push(i),l.push(a),t[a][i]=function(e,r){var n,i=0,a=0;return e>0&&void 0!==(n=t[r][e-1])&&(a++,i+=n),e<u-1&&void 0!==(n=t[r][e+1])&&(a++,i+=n),r>0&&void 0!==(n=t[r-1][e])&&(a++,i+=n),r<c-1&&void 0!==(n=t[r+1][e])&&(a++,i+=n),i/Math.max(1,a)}(i,a)),h=Math.max(h,Math.abs(t[a][i]));if(!s.length)return t;var f,d,p,m,v,g,y,b,x,_,w,M=0,k=0,A=s.length;do{for(M=0,o=0;o<A;o++){i=s[o],a=l[o];var T,S,E,L,C,z,I=0,D=0;0===i?(C=Math.min(u-1,2),E=e[C],L=e[1],T=t[a][C],S=t[a][1],D+=S+(S-T)*(e[0]-L)/(L-E),I++):i===u-1&&(C=Math.max(0,u-3),E=e[C],L=e[u-2],T=t[a][C],S=t[a][u-2],D+=S+(S-T)*(e[u-1]-L)/(L-E),I++),(0===i||i===u-1)&&a>0&&a<c-1&&(f=r[a+1]-r[a],d=r[a]-r[a-1],D+=(d*t[a+1][i]+f*t[a-1][i])/(d+f),I++),0===a?(z=Math.min(c-1,2),E=r[z],L=r[1],T=t[z][i],S=t[1][i],D+=S+(S-T)*(r[0]-L)/(L-E),I++):a===c-1&&(z=Math.max(0,c-3),E=r[z],L=r[c-2],T=t[z][i],S=t[c-2][i],D+=S+(S-T)*(r[c-1]-L)/(L-E),I++),(0===a||a===c-1)&&i>0&&i<u-1&&(f=e[i+1]-e[i],d=e[i]-e[i-1],D+=(d*t[a][i+1]+f*t[a][i-1])/(d+f),I++),I?D/=I:(p=e[i+1]-e[i],m=e[i]-e[i-1],v=r[a+1]-r[a],g=r[a]-r[a-1],y=p*m*(p+m),b=v*g*(v+g),D=(y*(g*t[a+1][i]+v*t[a-1][i])+b*(m*t[a][i+1]+p*t[a][i-1]))/(b*(m+p)+y*(g+v))),x=D-t[a][i],_=x/h,M+=_*_,w=I?0:.85,t[a][i]+=x*(1+w)}M=Math.sqrt(M)}while(k++<100&&M>1e-5);return n.log(\"Smoother converged to\",M,\"after\",k,\"iterations\"),t}},{\"../../lib\":725}],908:[function(t,e,r){\"use strict\"\n",
       ";var n=t(\"./has_columns\"),i=t(\"../heatmap/convert_column_xyz\");e.exports=function(t,e,r){var a=[],o=r(\"x\");o&&!n(o)&&a.push(\"x\"),e._cheater=!o;var s=r(\"y\");if(s&&!n(s)&&a.push(\"y\"),o||s)return a.length&&i(e,e.aaxis,e.baxis,\"a\",\"b\",a),!0}},{\"../heatmap/convert_column_xyz\":948,\"./has_columns\":898}],909:[function(t,e,r){\"use strict\";var n=t(\"../scattergeo/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../plots/attributes\"),s=t(\"../../lib/extend\").extendFlat,l=n.marker.line;e.exports=s({},{locations:{valType:\"data_array\"},locationmode:n.locationmode,z:{valType:\"data_array\"},text:{valType:\"data_array\"},marker:{line:{color:l.color,width:s({},l.width,{dflt:1})}},hoverinfo:s({},o.hoverinfo,{flags:[\"location\",\"z\",\"text\",\"name\"]})},i,{colorbar:a})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scattergeo/attributes\":1064}],910:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){n(e,e.z,\"\",\"z\")}},{\"../../components/colorscale/calc\":609}],911:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/colorscale/defaults\"),a=t(\"./attributes\");e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l,u=s(\"locations\");if(u&&(l=u.length),!u||!l)return void(e.visible=!1);var c=s(\"z\");if(!Array.isArray(c))return void(e.visible=!1);c.length>l&&(e.z=c.slice(0,l)),s(\"locationmode\"),s(\"text\"),s(\"marker.line.color\"),s(\"marker.line.width\"),i(t,e,o,s,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":909}],912:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.location=e.location,t.z=e.z,t}},{}],913:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o=e.hoverinfo,s=\"all\"===o?a.hoverinfo.flags:o.split(\"+\"),l=-1!==s.indexOf(\"name\"),u=-1!==s.indexOf(\"location\"),c=-1!==s.indexOf(\"z\"),h=-1!==s.indexOf(\"text\"),f=!l&&u,d=[];f?t.nameOverride=r.id:(l&&(t.nameOverride=e.name),u&&d.push(r.id)),c&&d.push(function(t){return i.tickText(n,n.c2l(t),\"hover\").text}(r.z)),h&&d.push(r.tx),t.extraText=d.join(\"<br>\")}var i=t(\"../../plots/cartesian/axes\"),a=t(\"./attributes\");e.exports=function(t){var e=t.cd,r=e[0].trace,i=t.subplot,a=i.choroplethHoverPt;if(a){var o=i.projection(a.properties.ct);return t.x0=t.x1=o[0],t.y0=t.y1=o[1],t.index=a.index,t.location=a.id,t.z=a.z,n(t,r,a,i.mockAxis),[t]}}},{\"../../plots/cartesian/axes\":766,\"./attributes\":909}],914:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../heatmap/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.moduleType=\"trace\",n.name=\"choropleth\",n.basePlotModule=t(\"../../plots/geo\"),n.categories=[\"geo\",\"noOpacity\"],n.meta={},e.exports=n},{\"../../plots/geo\":794,\"../heatmap/colorbar\":947,\"./attributes\":909,\"./calc\":910,\"./defaults\":911,\"./event_data\":912,\"./hover\":913,\"./plot\":915}],915:[function(t,e,r){\"use strict\";function n(t,e){for(var r,n=[],i=t.locations,a=i.length,o=u(t,e),s=(t.marker||{}).line||{},l=0;l<a;l++)(r=c(t.locationmode,i[l],o))&&(r.z=t.z[l],void 0!==t.text&&(r.tx=t.text[l]),h(s.color,r,\"mlc\",l),h(s.width,r,\"mlw\",l),r.index=l,n.push(r));return n.length>0&&(n[0].trace=t),n}function i(t){t.framework.selectAll(\"g.trace.choropleth\").each(function(t){var e=t[0].trace,r=a.select(this),n=e.marker||{},i=n.line||{},u=l.makeColorScaleFunc(l.extractScale(e.colorscale,e.zmin,e.zmax));r.selectAll(\"path.choroplethlocation\").each(function(t){a.select(this).attr(\"fill\",function(t){return u(t.z)}).call(o.stroke,t.mlc||i.color).call(s.dashLine,\"\",t.mlw||i.width||0)})})}var a=t(\"d3\"),o=t(\"../../components/color\"),s=t(\"../../components/drawing\"),l=t(\"../../components/colorscale\"),u=t(\"../../lib/topojson_utils\").getTopojsonFeatures,c=t(\"../../lib/geo_location_utils\").locationToFeature,h=t(\"../../lib/array_to_calc_item\"),f=t(\"../../plots/geo/constants\");e.exports=function(t,e,r){function o(t){return t[0].trace.uid}var s,l=t.framework,u=l.select(\"g.choroplethlayer\"),c=l.select(\"g.baselayer\"),h=l.select(\"g.baselayeroverchoropleth\"),d=f.baseLayersOverChoropleth,p=u.selectAll(\"g.trace.choropleth\").data(e,o);p.enter().append(\"g\").attr(\"class\",\"trace choropleth\"),p.exit().remove(),p.each(function(e){var r=e[0].trace,i=n(r,t.topojson),o=a.select(this).selectAll(\"path.choroplethlocation\").data(i);o.enter().append(\"path\").classed(\"choroplethlocation\",!0).on(\"mouseover\",function(e){t.choroplethHoverPt=e}).on(\"mouseout\",function(){t.choroplethHoverPt=null}),o.exit().remove()}),h.selectAll(\"*\").remove();for(var m=0;m<d.length;m++)s=d[m],c.select(\"g.\"+s).remove(),t.drawTopo(h,s,r),t.styleLayer(h,s,r);i(t)}},{\"../../components/color\":603,\"../../components/colorscale\":617,\"../../components/drawing\":627,\"../../lib/array_to_calc_item\":710,\"../../lib/geo_location_utils\":719,\"../../lib/topojson_utils\":747,\"../../plots/geo/constants\":792,d3:121}],916:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/attributes\"),i=t(\"../scatter/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../components/drawing/attributes\").dash,l=t(\"../../plots/font_attributes\"),u=t(\"../../lib/extend\").extendFlat,c=i.line;e.exports=u({},{z:n.z,x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:n.text,transpose:n.transpose,xtype:n.xtype,ytype:n.ytype,connectgaps:n.connectgaps,autocontour:{valType:\"boolean\",dflt:!0,editType:\"docalc\"},ncontours:{valType:\"integer\",dflt:15,min:1,editType:\"docalc\"},contours:{start:{valType:\"number\",dflt:null,editType:\"doplot\"},end:{valType:\"number\",dflt:null,editType:\"doplot\"},size:{valType:\"number\",dflt:null,min:0,editType:\"doplot\"},coloring:{valType:\"enumerated\",values:[\"fill\",\"heatmap\",\"lines\",\"none\"],dflt:\"fill\",editType:\"docalc\"},showlines:{valType:\"boolean\",dflt:!0,editType:\"doplot\"},showlabels:{valType:\"boolean\",dflt:!1,editType:\"doplot\"},labelfont:u({},l,{family:u({},l.family,{editType:\"doplot\"}),size:u({},l.size,{editType:\"doplot\"}),color:u({},l.color,{editType:\"dostyle\"})}),labelformat:{valType:\"string\",dflt:\"\",editType:\"doplot\"}},line:{color:u({},c.color,{}),width:c.width,dash:s,smoothing:u({},c.smoothing,{})}},a,{autocolorscale:u({},a.autocolorscale,{dflt:!1}),zmin:u({},a.zmin,{editType:\"docalc\"}),zmax:u({},a.zmax,{editType:\"docalc\"})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../heatmap/attributes\":944,\"../scatter/attributes\":1027}],917:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"linear\",range:[t,e]};return i.autoTicks(n,(e-t)/(r||15)),n}var i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\").extendFlat,o=t(\"../heatmap/calc\");e.exports=function(t,e){var r=o(t,e),s=e.contours;if(!1!==e.autocontour){var l=n(e.zmin,e.zmax,e.ncontours);s.size=l.dtick,s.start=i.tickFirst(l),l.range.reverse(),s.end=i.tickFirst(l),s.start===e.zmin&&(s.start+=s.size),s.end===e.zmax&&(s.end-=s.size),s.start>s.end&&(s.start=s.end=(s.start+s.end)/2),e._input.contours||(e._input.contours={}),a(e._input.contours,{start:s.start,end:s.end,size:s.size}),e._input.autocontour=!0}else{var u=s.start,c=s.end,h=e._input.contours;if(u>c&&(s.start=h.start=c,c=s.end=h.end=u,u=s.start),!(s.size>0)){var f;f=u===c?1:n(u,c,e.ncontours).dtick,h.size=s.size=f}}return r}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../heatmap/calc\":945}],918:[function(t,e,r){\"use strict\";var n=t(\"../../plots/plots\"),i=t(\"../../components/colorbar/draw\"),a=t(\"./make_color_map\"),o=t(\"./end_plus\");e.exports=function(t,e){var r=e[0].trace,s=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+s).remove(),!r.showscale)return void n.autoMargin(t,s);var l=i(t,s);e[0].t.cb=l;var u=r.contours,c=r.line,h=u.size||1,f=u.coloring,d=a(r,{isColorbar:!0});\"heatmap\"===f&&l.filllevels({start:r.zmin,end:r.zmax,size:(r.zmax-r.zmin)/254}),l.fillcolor(\"fill\"===f||\"heatmap\"===f?d:\"\").line({color:\"lines\"===f?d:c.color,width:!1!==u.showlines?c.width:0,dash:c.dash}).levels({start:u.start,end:o(u),size:h}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../plots/plots\":829,\"./end_plus\":922,\"./make_color_map\":926}],919:[function(t,e,r){\"use strict\";e.exports={BOTTOMSTART:[1,9,13,104,713],TOPSTART:[4,6,7,104,713],LEFTSTART:[8,12,14,208,1114],RIGHTSTART:[2,3,11,208,1114],NEWDELTA:[null,[-1,0],[0,-1],[-1,0],[1,0],null,[0,-1],[-1,0],[0,1],[0,1],null,[0,1],[1,0],[1,0],[0,-1]],CHOOSESADDLE:{104:[4,1],208:[2,8],713:[7,13],1114:[11,14]},SADDLEREMAINDER:{1:4,2:8,4:1,7:13,8:2,11:14,13:7,14:11},LABELDISTANCE:2,LABELINCREASE:10,LABELMIN:3,LABELMAX:10,LABELOPTIMIZER:{EDGECOST:1,ANGLECOST:1,NEIGHBORCOST:5,SAMELEVELFACTOR:10,SAMELEVELDISTANCE:5,MAXCOST:100,INITIALSEARCHPOINTS:10,ITERATIONS:5}}},{}],920:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){var a,o=n.coerce2(t,e,i,\"contours.start\"),s=n.coerce2(t,e,i,\"contours.end\"),l=!1===o||!1===s,u=r(\"contours.size\");!(a=l?e.autocontour=!0:r(\"autocontour\",!1))&&u||r(\"ncontours\")}},{\"../../lib\":725,\"./attributes\":916}],921:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../heatmap/has_columns\"),a=t(\"../heatmap/xyz_defaults\"),o=t(\"./contours_defaults\"),s=t(\"./style_defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,l,r,i)}if(!a(t,e,c,u))return void(e.visible=!1);c(\"text\"),c(\"connectgaps\",i(e)),o(t,e,c),s(t,e,c,u)}},{\"../../lib\":725,\"../heatmap/has_columns\":951,\"../heatmap/xyz_defaults\":959,\"./attributes\":916,\"./contours_defaults\":920,\"./style_defaults\":930}],922:[function(t,e,r){\"use strict\";e.exports=function(t){return t.end+t.size/1e6}},{}],923:[function(t,e,r){\"use strict\";function n(t,e,r,n){return Math.abs(t[0]-e[0])<r&&Math.abs(t[1]-e[1])<n}function i(t,e){var r=t[2]-e[2],n=t[3]-e[3];return Math.sqrt(r*r+n*n)}function a(t,e,r,a,c){function h(t){return g[t%g.length]}var f,d=e.join(\",\"),p=d,m=t.crossings[p],v=o(m,r,e),g=[s(t,e,[-v[0],-v[1]])],y=v.join(\",\"),b=t.z.length,x=t.z[0].length;for(f=0;f<1e4;f++){if(m>20?(m=u.CHOOSESADDLE[m][(v[0]||v[1])<0?0:1],t.crossings[p]=u.SADDLEREMAINDER[m]):delete t.crossings[p],!(v=u.NEWDELTA[m])){l.log(\"Found bad marching index:\",m,e,t.level);break}g.push(s(t,e,v)),e[0]+=v[0],e[1]+=v[1],n(g[g.length-1],g[g.length-2],a,c)&&g.pop(),p=e.join(\",\");var _=v[0]&&(e[0]<0||e[0]>x-2)||v[1]&&(e[1]<0||e[1]>b-2);if(p===d&&v.join(\",\")===y||r&&_)break;m=t.crossings[p]}1e4===f&&l.log(\"Infinite loop in contour?\");var w,M,k,A,T,S,E,L=n(g[0],g[g.length-1],a,c),C=0,z=.2*t.smoothing,I=[],D=0;for(f=1;f<g.length;f++)E=i(g[f],g[f-1]),C+=E,I.push(E);var P=C/I.length*z;for(f=g.length-2;f>=D;f--)if((w=I[f])<P){for(k=0,M=f-1;M>=D&&w+I[M]<P;M--)w+=I[M];if(L&&f===g.length-2)for(k=0;k<M&&w+I[k]<P;k++)w+=I[k];T=f-M+k+1,S=Math.floor((f+M+k+2)/2),A=L||f!==g.length-2?L||-1!==M?T%2?h(S):[(h(S)[0]+h(S+1)[0])/2,(h(S)[1]+h(S+1)[1])/2]:g[0]:g[g.length-1],g.splice(M+1,f-M+1,A),f=M+1,k&&(D=k),L&&(f===g.length-2?g[k]=g[g.length-1]:0===f&&(g[g.length-1]=g[0]))}for(g.splice(0,D),f=0;f<g.length;f++)g[f].length=2;if(!(g.length<2))if(L)g.pop(),t.paths.push(g);else{r||l.log(\"Unclosed interior contour?\",t.level,d,g.join(\"L\"));var O=!1;t.edgepaths.forEach(function(e,r){if(!O&&n(e[0],g[g.length-1],a,c)){g.pop(),O=!0;var i=!1;t.edgepaths.forEach(function(e,o){!i&&n(e[e.length-1],g[0],a,c)&&(i=!0,g.splice(0,1),t.edgepaths.splice(r,1),o===r?t.paths.push(g.concat(e)):t.edgepaths[o]=t.edgepaths[o].concat(g,e))}),i||(t.edgepaths[r]=g.concat(e))}}),t.edgepaths.forEach(function(e,r){!O&&n(e[e.length-1],g[0],a,c)&&(g.splice(0,1),t.edgepaths[r]=e.concat(g),O=!0)}),O||t.edgepaths.push(g)}}function o(t,e,r){var n=0,i=0;return t>20&&e?208===t||1114===t?n=0===r[0]?1:-1:i=0===r[1]?1:-1:-1!==u.BOTTOMSTART.indexOf(t)?i=1:-1!==u.LEFTSTART.indexOf(t)?n=1:-1!==u.TOPSTART.indexOf(t)?i=-1:n=-1,[n,i]}function s(t,e,r){var n=e[0]+Math.max(r[0],0),i=e[1]+Math.max(r[1],0),a=t.z[i][n],o=t.xaxis,s=t.yaxis;if(r[1]){var l=(t.level-a)/(t.z[i][n+1]-a);return[o.c2p((1-l)*t.x[n]+l*t.x[n+1],!0),s.c2p(t.y[i],!0),n+l,i]}var u=(t.level-a)/(t.z[i+1][n]-a);return[o.c2p(t.x[n],!0),s.c2p((1-u)*t.y[i]+u*t.y[i+1],!0),n,i+u]}var l=t(\"../../lib\"),u=t(\"./constants\");e.exports=function(t,e,r){var n,i,o,s,u;for(e=e||.01,r=r||.01,o=0;o<t.length;o++){for(s=t[o],u=0;u<s.starts.length;u++)i=s.starts[u],a(s,i,\"edge\",e,r);for(n=0;Object.keys(s.crossings).length&&n<1e4;)n++,i=Object.keys(s.crossings)[0].split(\",\").map(Number),a(s,i,void 0,e,r);1e4===n&&l.log(\"Infinite loop in contour?\")}}},{\"../../lib\":725,\"./constants\":919}],924:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/hover\");e.exports=function(t,e,r,i){return n(t,e,r,i,!0)}},{\"../heatmap/hover\":952}],925:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\").plot,n.style=t(\"./style\"),n.colorbar=t(\"./colorbar\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"contour\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"contour\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":916,\"./calc\":917,\"./colorbar\":918,\"./defaults\":921,\"./hover\":924,\"./plot\":928,\"./style\":929}],926:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/colorscale\"),a=t(\"./end_plus\");e.exports=function(t){var e=t.contours,r=e.start,o=a(e),s=e.size||1,l=Math.floor((o-r)/s)+1,u=\"lines\"===e.coloring?0:1;isFinite(s)||(s=1,l=1);var c,h,f=t.colorscale,d=f.length,p=new Array(d),m=new Array(d);if(\"heatmap\"===e.coloring){for(t.zauto&&!1===t.autocontour&&(t.zmin=r-s/2,t.zmax=t.zmin+l*s),h=0;h<d;h++)c=f[h],p[h]=c[0]*(t.zmax-t.zmin)+t.zmin,m[h]=c[1];var v=n.extent([t.zmin,t.zmax,e.start,e.start+s*(l-1)]),g=v[t.zmin<t.zmax?0:1],y=v[t.zmin<t.zmax?1:0];g!==t.zmin&&(p.splice(0,0,g),m.splice(0,0,Range[0])),y!==t.zmax&&(p.push(y),m.push(m[m.length-1]))}else for(h=0;h<d;h++)c=f[h],p[h]=(c[0]*(l+u-1)-u/2)*s+r,m[h]=c[1];return i.makeColorScaleFunc({domain:p,range:m},{noNumericCheck:!0})}},{\"../../components/colorscale\":617,\"./end_plus\":922,d3:121}],927:[function(t,e,r){\"use strict\";function n(t,e){var r=(e[0][0]>t?0:1)+(e[0][1]>t?0:2)+(e[1][1]>t?0:4)+(e[1][0]>t?0:8);if(5===r||10===r){return t>(e[0][0]+e[0][1]+e[1][0]+e[1][1])/4?5===r?713:1114:5===r?104:208}return 15===r?0:r}var i=t(\"./constants\");e.exports=function(t){var e,r,a,o,s,l,u,c,h,f=t[0].z,d=f.length,p=f[0].length,m=2===d||2===p;for(r=0;r<d-1;r++)for(o=[],0===r&&(o=o.concat(i.BOTTOMSTART)),r===d-2&&(o=o.concat(i.TOPSTART)),e=0;e<p-1;e++)for(a=o.slice(),0===e&&(a=a.concat(i.LEFTSTART)),e===p-2&&(a=a.concat(i.RIGHTSTART)),s=e+\",\"+r,l=[[f[r][e],f[r][e+1]],[f[r+1][e],f[r+1][e+1]]],h=0;h<t.length;h++)c=t[h],(u=n(c.level,l))&&(c.crossings[s]=u,-1!==a.indexOf(u)&&(c.starts.push([e,r]),m&&-1!==a.indexOf(u,a.indexOf(u)+1)&&c.starts.push([e,r])))}},{\"./constants\":919}],928:[function(t,e,r){\"use strict\";function n(t,e,n){var s=n[0].trace,u=n[0].x,h=n[0].y,f=s.contours,d=s.uid,p=e.xaxis,m=e.yaxis,v=t._fullLayout,g=\"contour\"+d,_=i(f,e,n[0]);if(!0!==s.visible)return v._paper.selectAll(\".\"+g+\",.hm\"+d).remove(),void v._infolayer.selectAll(\".cb\"+d).remove();\"heatmap\"===f.coloring?(s.zauto&&!1===s.autocontour&&(s._input.zmin=s.zmin=f.start-f.size/2,s._input.zmax=s.zmax=s.zmin+_.length*f.size),y(t,e,[n])):(v._paper.selectAll(\".hm\"+d).remove(),v._infolayer.selectAll(\"g.rangeslider-container\").selectAll(\".hm\"+d).remove()),b(_),x(_);var w=p.c2p(u[0],!0),M=p.c2p(u[u.length-1],!0),k=m.c2p(h[0],!0),A=m.c2p(h[h.length-1],!0),T=[[w,A],[M,A],[M,k],[w,k]],S=r.makeContourGroup(e,n,g);a(S,T,f),o(S,_,T,f),l(S,_,t,n[0],f,T),c(S,e,v._defs,n[0],T)}function i(t,e,r){for(var n=t.size,i=[],a=_(t),o=t.start;o<a;o+=n)if(i.push({level:o,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:e.xaxis,yaxis:e.yaxis,x:r.x,y:r.y,z:r.z,smoothing:r.trace.line.smoothing}),i.length>1e3){d.warn(\"Too many contours, clipping at 1000\",t);break}return i}function a(t,e,r){var n=t.selectAll(\"g.contourbg\").data([0]);n.enter().append(\"g\").classed(\"contourbg\",!0);var i=n.selectAll(\"path\").data(\"fill\"===r.coloring?[0]:[]);i.enter().append(\"path\"),i.exit().remove(),i.attr(\"d\",\"M\"+e.join(\"L\")+\"Z\").style(\"stroke\",\"none\")}function o(t,e,r,n){var i=t.selectAll(\"g.contourfill\").data([0]);i.enter().append(\"g\").classed(\"contourfill\",!0);var a=i.selectAll(\"path\").data(\"fill\"===n.coloring?e:[]);a.enter().append(\"path\"),a.exit().remove(),a.each(function(t){var e=s(t,r);e?f.select(this).attr(\"d\",e).style(\"stroke\",\"none\"):f.select(this).remove()})}function s(t,e){function r(t){return Math.abs(t[0]-e[2][0])<.01}for(var n,i,a,o,s,l,u=Math.min(t.z[0][0],t.z[0][1]),c=t.edgepaths.length||u<=t.level?\"\":\"M\"+e.join(\"L\")+\"Z\",h=0,f=t.edgepaths.map(function(t,e){return e}),m=!0;f.length;){for(l=p.smoothopen(t.edgepaths[h],t.smoothing),c+=m?l:l.replace(/^M/,\"L\"),f.splice(f.indexOf(h),1),n=t.edgepaths[h][t.edgepaths[h].length-1],o=-1,a=0;a<4;a++){if(!n){d.log(\"Missing end?\",h,t);break}for(!function(t){return Math.abs(t[1]-e[0][1])<.01}(n)||r(n)?!function(t){return Math.abs(t[0]-e[0][0])<.01}(n)?!function(t){return Math.abs(t[1]-e[2][1])<.01}(n)?r(n)&&(i=e[2]):i=e[3]:i=e[0]:i=e[1],s=0;s<t.edgepaths.length;s++){var v=t.edgepaths[s][0];Math.abs(n[0]-i[0])<.01?Math.abs(n[0]-v[0])<.01&&(v[1]-n[1])*(i[1]-v[1])>=0&&(i=v,o=s):Math.abs(n[1]-i[1])<.01?Math.abs(n[1]-v[1])<.01&&(v[0]-n[0])*(i[0]-v[0])>=0&&(i=v,o=s):d.log(\"endpt to newendpt is not vert. or horz.\",n,i,v)}if(n=i,o>=0)break;c+=\"L\"+i}if(o===t.edgepaths.length){d.log(\"unclosed perimeter path\");break}h=o,m=-1===f.indexOf(h),m&&(h=f[0],c+=\"Z\")}for(h=0;h<t.paths.length;h++)c+=p.smoothclosed(t.paths[h],t.smoothing);return c}function l(t,e,n,i,a,o){var s=t.selectAll(\"g.contourlines\").data([0]);s.enter().append(\"g\").classed(\"contourlines\",!0);var l=!1!==a.showlines,u=a.showlabels,c=l&&u,h=r.createLines(s,l||u,e),m=r.createLineClip(s,c,n._fullLayout._defs,i.trace.uid),v=t.selectAll(\"g.contourlabels\").data(u?[0]:[]);if(v.exit().remove(),v.enter().append(\"g\").classed(\"contourlabels\",!0),u){var g=[o],y=[];d.clearLocationCache();var b=r.labelFormatter(a,i.t.cb,n._fullLayout),x=p.tester.append(\"text\").attr(\"data-notex\",1).call(p.font,a.labelfont),_=e[0].xaxis._length,M=e[0].yaxis._length,k={left:Math.max(o[0][0],0),right:Math.min(o[2][0],_),top:Math.max(o[0][1],0),bottom:Math.min(o[2][1],M)};k.middle=(k.top+k.bottom)/2,k.center=(k.left+k.right)/2;var A=Math.sqrt(_*_+M*M),T=w.LABELDISTANCE*A/Math.max(1,e.length/w.LABELINCREASE);h.each(function(t){var e=r.calcTextOpts(t.level,b,x,n);f.select(this).selectAll(\"path\").each(function(){var t=this,n=d.getVisibleSegment(t,k,e.height/2);if(n&&!(n.len<(e.width+e.height)*w.LABELMIN))for(var i=Math.min(Math.ceil(n.len/T),w.LABELMAX),a=0;a<i;a++){var o=r.findBestTextLocation(t,n,e,y,k);if(!o)break;r.addLabelData(o,e,y,g)}})}),x.remove(),r.drawLabels(v,y,n,m,c?g:null)}u&&!l&&h.remove()}function u(t,e,r,n){var i=e.width/2,a=e.height/2,o=t.x,s=t.y,l=t.theta,u=Math.cos(l)*i,c=Math.sin(l)*i,h=(o>n.center?n.right-o:o-n.left)/(u+Math.abs(Math.sin(l)*a)),f=(s>n.middle?n.bottom-s:s-n.top)/(Math.abs(c)+Math.cos(l)*a);if(h<1||f<1)return 1/0;var p=M.EDGECOST*(1/(h-1)+1/(f-1));p+=M.ANGLECOST*l*l;for(var m=o-u,v=s-c,g=o+u,y=s+c,b=0;b<r.length;b++){var x=r[b],_=Math.cos(x.theta)*x.width/2,w=Math.sin(x.theta)*x.width/2,k=2*d.segmentDistance(m,v,g,y,x.x-_,x.y-w,x.x+_,x.y+w)/(e.height+x.height),A=x.level===e.level,T=A?M.SAMELEVELDISTANCE:1;if(k<=T)return 1/0;p+=M.NEIGHBORCOST*(A?M.SAMELEVELFACTOR:1)/(k-T)}return p}function c(t,e,r,n,i){var a=\"clip\"+n.trace.uid,o=r.select(\".clips\").selectAll(\"#\"+a).data(n.trace.connectgaps?[]:[0]);if(o.enter().append(\"clipPath\").classed(\"contourclip\",!0).attr(\"id\",a),o.exit().remove(),!1===n.trace.connectgaps){var l={level:.9,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:e.xaxis,yaxis:e.yaxis,x:n.x,y:n.y,z:h(n),smoothing:0};b([l]),x([l]);var u=s(l,i),c=o.selectAll(\"path\").data([0]);c.enter().append(\"path\"),c.attr(\"d\",u)}else a=null;t.call(p.setClipUrl,a),e.plot.selectAll(\".hm\"+n.trace.uid).call(p.setClipUrl,a)}function h(t){var e,r,n=t.trace._emptypoints,i=[],a=t.z.length,o=t.z[0].length,s=[];for(e=0;e<o;e++)s.push(1);for(e=0;e<a;e++)i.push(s.slice());for(e=0;e<n.length;e++)r=n[e],i[r[0]][r[1]]=0;return t.zmask=i,i}var f=t(\"d3\"),d=t(\"../../lib\"),p=t(\"../../components/drawing\"),m=t(\"../../lib/svg_text_utils\"),v=t(\"../../plots/cartesian/axes\"),g=t(\"../../plots/cartesian/set_convert\"),y=t(\"../heatmap/plot\"),b=t(\"./make_crossings\"),x=t(\"./find_all_paths\"),_=t(\"./end_plus\"),w=t(\"./constants\"),M=w.LABELOPTIMIZER;r.plot=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])},r.makeContourGroup=function(t,e,r){var n=t.plot.select(\".maplayer\").selectAll(\"g.contour.\"+r).data(e);return n.enter().append(\"g\").classed(\"contour\",!0).classed(r,!0),n.exit().remove(),n},r.createLines=function(t,e,r){var n=r[0].smoothing,i=t.selectAll(\"g.contourlevel\").data(e?r:[]);if(i.exit().remove(),i.enter().append(\"g\").classed(\"contourlevel\",!0),e){var a=i.selectAll(\"path.openline\").data(function(t){return t.pedgepaths||t.edgepaths});a.exit().remove(),a.enter().append(\"path\").classed(\"openline\",!0),a.attr(\"d\",function(t){return p.smoothopen(t,n)}).style(\"stroke-miterlimit\",1).style(\"vector-effect\",\"non-scaling-stroke\");var o=i.selectAll(\"path.closedline\").data(function(t){return t.ppaths||t.paths});o.exit().remove(),o.enter().append(\"path\").classed(\"closedline\",!0),o.attr(\"d\",function(t){return p.smoothclosed(t,n)}).style(\"stroke-miterlimit\",1).style(\"vector-effect\",\"non-scaling-stroke\")}return i},r.createLineClip=function(t,e,r,n){var i=e?\"clipline\"+n:null,a=r.select(\".clips\").selectAll(\"#\"+i).data(e?[0]:[]);return a.exit().remove(),a.enter().append(\"clipPath\").classed(\"contourlineclip\",!0).attr(\"id\",i),p.setClipUrl(t,i),a},r.labelFormatter=function(t,e,r){if(t.labelformat)return f.format(t.labelformat);var n;return e?n=e.axis:(n={type:\"linear\",_separators:\".,\",_id:\"ycontour\",nticks:(t.end-t.start)/t.size,showexponent:\"all\",range:[t.start,t.end]},g(n,r),v.calcTicks(n),n._tmin=null,n._tmax=null),function(t){return v.tickText(n,t).text}},r.calcTextOpts=function(t,e,r,n){var i=e(t);r.text(i).call(m.convertToTspans,n);var a=p.bBox(r.node(),!0);return{text:i,width:a.width,height:a.height,level:t,dy:(a.top+a.bottom)/2}},r.findBestTextLocation=function(t,e,r,n,i){var a,o,s,l,c,h=r.width;e.isClosed?(o=e.len/M.INITIALSEARCHPOINTS,a=e.min+o/2,s=e.max):(o=(e.len-h)/(M.INITIALSEARCHPOINTS+1),a=e.min+o+h/2,s=e.max-(o+h)/2);for(var f=1/0,p=0;p<M.ITERATIONS;p++){for(var m=a;m<s;m+=o){var v=d.getTextLocation(t,e.total,m,h),g=u(v,r,n,i);g<f&&(f=g,c=v,l=m)}if(f>2*M.MAXCOST)break;p&&(o/=2),a=l-o/2,s=a+1.5*o}if(f<=M.MAXCOST)return c},r.addLabelData=function(t,e,r,n){var i=e.width/2,a=e.height/2,o=t.x,s=t.y,l=t.theta,u=Math.sin(l),c=Math.cos(l),h=i*c,f=a*u,d=i*u,p=-a*c,m=[[o-h-f,s-d-p],[o+h-f,s+d-p],[o+h+f,s+d+p],[o-h+f,s-d+p]];r.push({text:e.text,x:o,y:s,dy:e.dy,theta:l,level:e.level,width:e.width,height:e.height}),n.push(m)},r.drawLabels=function(t,e,r,n,i){var a=t.selectAll(\"text\").data(e,function(t){return t.text+\",\"+t.x+\",\"+t.y+\",\"+t.theta});if(a.exit().remove(),a.enter().append(\"text\").attr({\"data-notex\":1,\"text-anchor\":\"middle\"}).each(function(t){var e=t.x+Math.sin(t.theta)*t.dy,n=t.y-Math.cos(t.theta)*t.dy;f.select(this).text(t.text).attr({x:e,y:n,transform:\"rotate(\"+180*t.theta/Math.PI+\" \"+e+\" \"+n+\")\"}).call(m.convertToTspans,r)}),i){for(var o=\"\",s=0;s<i.length;s++)o+=\"M\"+i[s].join(\"L\")+\"Z\";var l=n.selectAll(\"path\").data([0]);l.enter().append(\"path\"),l.attr(\"d\",o)}}},{\"../../components/drawing\":627,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/set_convert\":783,\"../heatmap/plot\":957,\"./constants\":919,\"./end_plus\":922,\"./find_all_paths\":923,\"./make_crossings\":927,d3:121}],929:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/drawing\"),a=t(\"../heatmap/style\"),o=t(\"./make_color_map\");e.exports=function(t){var e=n.select(t).selectAll(\"g.contour\");e.style(\"opacity\",function(t){return t.trace.opacity}),e.each(function(t){var e=n.select(this),r=t.trace,a=r.contours,s=r.line,l=a.size||1,u=a.start,c=\"constraint\"===a.type,h=!c&&\"lines\"===a.coloring,f=!c&&\"fill\"===a.coloring,d=h||f?o(r):null;e.selectAll(\"g.contourlevel\").each(function(t){n.select(this).selectAll(\"path\").call(i.lineGroupStyle,s.width,h?d(t.level):s.color,s.dash)});var p=a.labelfont;if(e.selectAll(\"g.contourlabels text\").each(function(t){i.font(n.select(this),{family:p.family,size:p.size,color:p.color||(h?d(t.level):s.color)})}),c)e.selectAll(\"g.contourfill path\").style(\"fill\",r.fillcolor);else if(f){var m;e.selectAll(\"g.contourfill path\").style(\"fill\",function(t){return void 0===m&&(m=t.level),d(t.level+.5*l)}),void 0===m&&(m=u),e.selectAll(\"g.contourbg path\").style(\"fill\",d(m-.5*l))}}),a(t)}},{\"../../components/drawing\":627,\"../heatmap/style\":958,\"./make_color_map\":926,d3:121}],930:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/defaults\"),i=t(\"../../lib\");e.exports=function(t,e,r,a,o,s){var l,u=r(\"contours.coloring\"),c=\"\";if(\"fill\"===u&&(l=r(\"contours.showlines\")),!1!==l&&(\"lines\"!==u&&(c=r(\"line.color\",o||\"#000\")),r(\"line.width\",void 0===s?.5:s),r(\"line.dash\")),r(\"line.smoothing\"),\"none\"!==u&&n(t,e,a,r,{prefix:\"\",cLetter:\"z\"}),r(\"contours.showlabels\")){var h=a.font;i.coerceFont(r,\"contours.labelfont\",{family:h.family,size:h.size,color:c}),r(\"contours.labelformat\")}}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725}],931:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/attributes\"),i=t(\"../contour/attributes\"),a=i.contours,o=t(\"../scatter/attributes\"),s=t(\"../../components/colorscale/attributes\"),l=t(\"../../components/colorbar/attributes\"),u=t(\"../../lib/extend\").extendFlat,c=o.line,h=t(\"./constants\");e.exports=u({},{carpet:{valType:\"string\"},z:n.z,a:n.x,a0:n.x0,da:n.dx,b:n.y,b0:n.y0,db:n.dy,text:n.text,transpose:n.transpose,atype:n.xtype,btype:n.ytype,mode:{valType:\"flaglist\",flags:[\"lines\",\"fill\"],extras:[\"none\"]},connectgaps:n.connectgaps,fillcolor:{valType:\"color\"},autocontour:i.autocontour,ncontours:i.ncontours,contours:{type:{valType:\"enumerated\",values:[\"levels\",\"constraint\"],dflt:\"levels\",editType:\"docalc\"},start:a.start,end:a.end,size:a.size,coloring:{valType:\"enumerated\",values:[\"fill\",\"lines\",\"none\"],dflt:\"fill\",editType:\"docalc\"},showlines:a.showlines,showlabels:a.showlabels,labelfont:a.labelfont,labelformat:a.labelformat,operation:{valType:\"enumerated\",values:[].concat(h.INEQUALITY_OPS).concat(h.INTERVAL_OPS).concat(h.SET_OPS),dflt:\"=\",editType:\"docalc\"},value:{valType:\"any\",dflt:0,editType:\"docalc\"}},line:{color:u({},c.color,{}),width:c.width,dash:c.dash,smoothing:u({},c.smoothing,{})}},s,{autocolorscale:u({},s.autocolorscale,{dflt:!1})},{colorbar:l})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../contour/attributes\":916,\"../heatmap/attributes\":944,\"../scatter/attributes\":1027,\"./constants\":934}],932:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"linear\",range:[t,e]};return o.autoTicks(n,(e-t)/(r||15)),n}function i(t,e){function r(t){A=e._input.zsmooth=e.zsmooth=!1,a.notifier(\"cannot fast-zsmooth: \"+t)}var n,i,o,s,g,y,b,x,_=e.carpetTrace,w=_.aaxis,M=_.baxis,k=l.traceIs(e,\"contour\"),A=k?\"best\":e.zsmooth;if(w._minDtick=0,M._minDtick=0,c(e)&&h(e,w,M,\"a\",\"b\",[\"z\"]),n=e.a?w.makeCalcdata(e,\"a\"):[],s=e.b?M.makeCalcdata(e,\"b\"):[],i=e.a0||0,o=e.da||1,g=e.b0||0,y=e.db||1,b=f(e.z,e.transpose),e._emptypoints=m(b),e._interpz=p(b,e._emptypoints,e._interpz),\"fast\"===A)if(\"log\"===w.type||\"log\"===M.type)r(\"log axis found\");else{if(n.length){var T=(n[n.length-1]-n[0])/(n.length-1),S=Math.abs(T/100);for(x=0;x<n.length-1;x++)if(Math.abs(n[x+1]-n[x]-T)>S){r(\"a scale is not linear\");break}}if(s.length&&\"fast\"===A){var E=(s[s.length-1]-s[0])/(s.length-1),L=Math.abs(E/100);for(x=0;x<s.length-1;x++)if(Math.abs(s[x+1]-s[x]-E)>L){r(\"b scale is not linear\");break}}}var C=d(b),z=\"scaled\"===e.xtype?\"\":n,I=v(e,z,i,o,C,w),D=\"scaled\"===e.ytype?\"\":s,P=v(e,D,g,y,b.length,M),O={a:I,b:P,z:b};return\"levels\"===e.contours.type&&u(e,b,\"\",\"z\"),[O]}var a=t(\"../../lib\"),o=t(\"../../plots/cartesian/axes\"),s=t(\"../../lib\").extendFlat,l=t(\"../../registry\"),u=t(\"../../components/colorscale/calc\"),c=t(\"../heatmap/has_columns\"),h=t(\"../heatmap/convert_column_xyz\"),f=t(\"../heatmap/clean_2d_array\"),d=t(\"../heatmap/max_row_length\"),p=t(\"../heatmap/interp2d\"),m=t(\"../heatmap/find_empties\"),v=t(\"../heatmap/make_bound_array\"),g=t(\"./defaults\"),y=t(\"../carpet/lookup_carpetid\");e.exports=function(t,e){var r=e.carpetTrace=y(t,e);if(r&&r.visible&&\"legendonly\"!==r.visible){if(!e.a||!e.b){var a=t.data[r.index],l=t.data[e.index];l.a||(l.a=a.a),l.b||(l.b=a.b),g(l,e,e._defaultColor,t._fullLayout)}var u=i(t,e),c=e.contours;if(!0===e.autocontour){var h=n(e.zmin,e.zmax,e.ncontours);c.size=h.dtick,c.start=o.tickFirst(h),h.range.reverse(),c.end=o.tickFirst(h),c.start===e.zmin&&(c.start+=c.size),c.end===e.zmax&&(c.end-=c.size),c.start>c.end&&(c.start=c.end=(c.start+c.end)/2),e._input.contours=s({},c)}else{var f=c.start,d=c.end,p=e._input.contours;if(f>d&&(c.start=p.start=d,d=c.end=p.end=f,f=c.start),!(c.size>0)){var m;m=f===d?1:n(f,d,e.ncontours).dtick,p.size=c.size=m}}return u}}},{\"../../components/colorscale/calc\":609,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../carpet/lookup_carpetid\":900,\"../heatmap/clean_2d_array\":946,\"../heatmap/convert_column_xyz\":948,\"../heatmap/find_empties\":950,\"../heatmap/has_columns\":951,\"../heatmap/interp2d\":954,\"../heatmap/make_bound_array\":955,\"../heatmap/max_row_length\":956,\"./defaults\":938}],933:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s=n.a.length,l=n.b.length,u=n.z,c=-1/0,h=1/0;for(i=0;i<l;i++)h=Math.min(h,u[i][0]),h=Math.min(h,u[i][s-1]),c=Math.max(c,u[i][0]),c=Math.max(c,u[i][s-1]);for(i=1;i<s-1;i++)h=Math.min(h,u[0][i]),h=Math.min(h,u[l-1][i]),c=Math.max(c,u[0][i]),c=Math.max(c,u[l-1][i]);switch(e){case\">\":case\">=\":n.contours.value>c&&(t[0].prefixBoundary=!0);break;case\"<\":case\"<=\":n.contours.value<h&&(t[0].prefixBoundary=!0);break;case\"[]\":case\"()\":a=Math.min.apply(null,n.contours.value),o=Math.max.apply(null,n.contours.value),o<h&&(t[0].prefixBoundary=!0),a>c&&(t[0].prefixBoundary=!0);break;case\"][\":case\")(\":a=Math.min.apply(null,n.contours.value),o=Math.max.apply(null,n.contours.value),a<h&&o>c&&(t[0].prefixBoundary=!0)}}},{}],934:[function(t,e,r){\"use strict\";e.exports={INEQUALITY_OPS:[\"=\",\"<\",\">=\",\">\",\"<=\"],INTERVAL_OPS:[\"[]\",\"()\",\"[)\",\"(]\",\"][\",\")(\",\"](\",\")[\"],SET_OPS:[\"{}\",\"}{\"]}},{}],935:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return s(t)?+t:null}var n,i=Array.isArray(e);return-1!==o.INEQUALITY_OPS.indexOf(t)?n=r(i?e[0]:e):-1!==o.INTERVAL_OPS.indexOf(t)?n=i?[r(e[0]),r(e[1])]:[r(e),r(e)]:-1!==o.SET_OPS.indexOf(t)&&(n=i?e.map(r):[r(e)]),n}function i(t){return function(e){e=n(t,e);var r=Math.min(e[0],e[1]),i=Math.max(e[0],e[1]);return{start:r,end:i,size:i-r}}}function a(t){return function(e){return e=n(t,e),{start:e,end:1/0,size:1/0}}}var o=t(\"./constants\"),s=t(\"fast-isnumeric\");e.exports[\"[]\"]=i(\"[]\"),e.exports[\"()\"]=i(\"()\"),e.exports[\"[)\"]=i(\"[)\"),e.exports[\"(]\"]=i(\"(]\"),e.exports[\"][\"]=i(\"][\"),e.exports[\")(\"]=i(\")(\"),e.exports[\")[\"]=i(\")[\"),e.exports[\"](\"]=i(\"](\"),e.exports[\">\"]=a(\">\"),e.exports[\">=\"]=a(\">=\"),e.exports[\"<\"]=a(\"<\"),e.exports[\"<=\"]=a(\"<=\"),e.exports[\"=\"]=a(\"=\")},{\"./constants\":934,\"fast-isnumeric\":130}],936:[function(t,e,r){\"use strict\";var n=t(\"./constraint_mapping\"),i=t(\"fast-isnumeric\");e.exports=function(t,e){var r;-1===[\"=\",\"<\",\"<=\",\">\",\">=\"].indexOf(e.operation)?(t(\"contours.value\",[0,1]),Array.isArray(e.value)?e.value.length>2?e.value=e.value.slice(2):0===e.length?e.value=[0,1]:e.length<2?(r=parseFloat(e.value[0]),e.value=[r,r+1]):e.value=[parseFloat(e.value[0]),parseFloat(e.value[1])]:i(e.value)&&(r=parseFloat(e.value),\n",
       "e.value=[r,r+1])):(t(\"contours.value\",0),i(e.value)||(Array.isArray(e.value)?e.value=parseFloat(e.value[0]):e.value=0));var a=n[e.operation](e.value);e.start=a.start,e.end=a.end,e.size=a.size}},{\"./constraint_mapping\":935,\"fast-isnumeric\":130}],937:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){var r,i,a,o=function(t){return t.reverse()},s=function(t){return t};switch(e){case\"][\":case\")[\":case\"](\":case\")(\":var l=o;o=s,s=l;case\"[]\":case\"[)\":case\"(]\":case\"()\":if(2!==t.length)return void n.warn(\"Contour data invalid for the specified inequality range operation.\");for(i=t[0],a=t[1],r=0;r<i.edgepaths.length;r++)i.edgepaths[r]=o(i.edgepaths[r]);for(r=0;r<i.paths.length;r++)i.paths[r]=o(i.paths[r]);for(;a.edgepaths.length;)i.edgepaths.push(s(a.edgepaths.shift()));for(;a.paths.length;)i.paths.push(s(a.paths.shift()));t.pop();break;case\">=\":case\">\":if(1!==t.length)return void n.warn(\"Contour data invalid for the specified inequality operation.\");for(i=t[0],r=0;r<i.edgepaths.length;r++)i.edgepaths[r]=o(i.edgepaths[r]);for(r=0;r<i.paths.length;r++)i.paths[r]=o(i.paths[r])}}},{\"../../lib\":725}],938:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../heatmap/xyz_defaults\"),a=t(\"./attributes\"),o=t(\"../contour/style_defaults\"),s=t(\"../scatter/fillcolor_defaults\"),l=t(\"../../plots/attributes\"),u=t(\"./constraint_value_defaults\"),c=t(\"../../components/color\").addOpacity;e.exports=function(t,e,r,h){function f(r,i){return n.coerce(t,e,a,r,i)}if(f(\"carpet\"),t.a&&t.b){var d,p,m,v,g;if(!i(t,e,f,h,\"a\",\"b\"))return void(e.visible=!1);f(\"text\"),f(\"contours.type\");var y=e.contours;if(\"constraint\"===y.type){f(\"contours.operation\"),u(f,y),n.coerce(t,e,l,\"showlegend\",!0),f(\"contours.coloring\",\"=\"===y.operation?\"lines\":\"fill\"),f(\"contours.showlines\",!0),\"=\"===y.operation&&(y.coloring=\"lines\"),s(t,e,r,f);var b=e.fillcolor?c(e.fillcolor,1):r;o(t,e,f,h,b,2),\"=\"===y.operation&&(f(\"line.color\",r),\"fill\"===y.coloring&&(y.coloring=\"lines\"),\"lines\"===y.coloring&&delete e.fillcolor),delete e.showscale,delete e.autocontour,delete e.autocolorscale,delete e.colorscale,delete e.ncontours,delete e.colorbar,e.line&&(delete e.line.autocolorscale,delete e.line.colorscale,delete e.line.mincolor,delete e.line.maxcolor)}else n.coerce(t,e,l,\"showlegend\",!1),p=n.coerce2(t,e,a,\"contours.start\"),m=n.coerce2(t,e,a,\"contours.end\"),d=f(\"contours.size\"),f(\"contours.coloring\"),v=!1===p||!1===m,g=v?e.autocontour=!0:f(\"autocontour\",!1),!g&&d||f(\"ncontours\"),o(t,e,f,h),delete e.value,delete e.operation}else e._defaultColor=r}},{\"../../components/color\":603,\"../../lib\":725,\"../../plots/attributes\":764,\"../contour/style_defaults\":930,\"../heatmap/xyz_defaults\":959,\"../scatter/fillcolor_defaults\":1034,\"./attributes\":931,\"./constraint_value_defaults\":936}],939:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r){for(var i=t.size,a=[],o=r.trace.carpetTrace,s=t.start;s<t.end+i/10;s+=i)if(a.push({level:s,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:o.aaxis,yaxis:o.baxis,x:r.a,y:r.b,z:r.z,smoothing:r.trace.line.smoothing}),a.length>1e3){n.warn(\"Too many contours, clipping at 1000\",t);break}return a}},{\"../../lib\":725}],940:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../contour/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"../contour/style\"),n.moduleType=\"trace\",n.name=\"contourcarpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"carpet\",\"contour\",\"symbols\",\"showLegend\",\"hasLines\",\"carpetDependent\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../contour/colorbar\":918,\"../contour/style\":929,\"./attributes\":931,\"./calc\":932,\"./defaults\":938,\"./plot\":943}],941:[function(t,e,r){\"use strict\";var n=t(\"../../components/drawing\"),i=t(\"../carpet/axis_aligned_line\"),a=t(\"../../lib\");e.exports=function(t,e,r,o,s,l,u,c){function h(t){return Math.abs(t[1]-r[0][1])<S}function f(t){return Math.abs(t[1]-r[2][1])<S}function d(t){return Math.abs(t[0]-r[0][0])<T}function p(t){return Math.abs(t[0]-r[2][0])<T}function m(t,e){var r,n,a,o,m=\"\";for(h(t)&&!p(t)||f(t)&&!d(t)?(o=s.aaxis,a=i(s,l,[t[0],e[0]],.5*(t[1]+e[1]))):(o=s.baxis,a=i(s,l,.5*(t[0]+e[0]),[t[1],e[1]])),r=1;r<a.length;r++)for(m+=o.smoothing?\"C\":\"L\",n=0;n<a[r].length;n++){var v=a[r][n];m+=[u.c2p(v[0]),c.c2p(v[1])]+\" \"}return m}var v,g,y,b,x,_,w,M=\"\",k=e.edgepaths.map(function(t,e){return e}),A=!0,T=1e-4*Math.abs(r[0][0]-r[2][0]),S=1e-4*Math.abs(r[0][1]-r[2][1]);for(v=0,g=null;k.length;){var E=e.edgepaths[v][0];for(g&&(M+=m(g,E)),w=n.smoothopen(e.edgepaths[v].map(o),e.smoothing),M+=A?w:w.replace(/^M/,\"L\"),k.splice(k.indexOf(v),1),g=e.edgepaths[v][e.edgepaths[v].length-1],x=-1,b=0;b<4;b++){if(!g){a.log(\"Missing end?\",v,e);break}for(h(g)&&!p(g)?y=r[1]:d(g)?y=r[0]:f(g)?y=r[3]:p(g)&&(y=r[2]),_=0;_<e.edgepaths.length;_++){var L=e.edgepaths[_][0];Math.abs(g[0]-y[0])<T?Math.abs(g[0]-L[0])<T&&(L[1]-g[1])*(y[1]-L[1])>=0&&(y=L,x=_):Math.abs(g[1]-y[1])<S?Math.abs(g[1]-L[1])<S&&(L[0]-g[0])*(y[0]-L[0])>=0&&(y=L,x=_):a.log(\"endpt to newendpt is not vert. or horz.\",g,y,L)}if(x>=0)break;M+=m(g,y),g=y}if(x===e.edgepaths.length){a.log(\"unclosed perimeter path\");break}v=x,A=-1===k.indexOf(v),A&&(v=k[0],M+=m(g,y)+\"Z\",g=null)}for(v=0;v<e.paths.length;v++)M+=n.smoothclosed(e.paths[v].map(o),e.smoothing);return M}},{\"../../components/drawing\":627,\"../../lib\":725,\"../carpet/axis_aligned_line\":883}],942:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r,n,i,a,o,s,l,u,c;for(r=0;r<t.length;r++){for(a=t[r],o=a.pedgepaths=[],s=a.ppaths=[],n=0;n<a.edgepaths.length;n++){for(c=a.edgepaths[n],l=[],i=0;i<c.length;i++)l[i]=e(c[i]);o.push(l)}for(n=0;n<a.paths.length;n++){for(c=a.paths[n],u=[],i=0;i<c.length;i++)u[i]=e(c[i]);s.push(u)}}}},{}],943:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){var e=o.ab2xy(t[0],t[1],!0);return[_.c2p(e[0]),T.c2p(e[1])]}var a=r[0].trace,o=a.carpetTrace=k(t,a),s=t.calcdata[o.index][0];if(o.visible&&\"legendonly\"!==o.visible){var l=r[0].a,h=r[0].b,m=a.contours,b=a.uid,_=e.xaxis,T=e.yaxis,S=t._fullLayout,E=\"contour\"+b,L=w(m,e,r[0]),C=\"constraint\"===a.contours.type;if(!0!==a.visible)return void S._infolayer.selectAll(\".cb\"+b).remove();var z=[[l[0],h[h.length-1]],[l[l.length-1],h[h.length-1]],[l[l.length-1],h[0]],[l[0],h[0]]];v(L);var I=1e-8*(l[l.length-1]-l[0]),D=1e-8*(h[h.length-1]-h[0]);g(L,I,D),\"constraint\"===a.contours.type&&(x(L,a.contours.operation),A(L,a.contours.operation,z,a)),M(L,n);var P,O,R,F,j=y.makeContourGroup(e,r,E),N=[];for(F=s.clipsegments.length-1;F>=0;F--)P=s.clipsegments[F],O=f([],P.x,_.c2p),R=f([],P.y,T.c2p),O.reverse(),R.reverse(),N.push(d(O,R,P.bicubic));var B=\"M\"+N.join(\"L\")+\"Z\";u(j,s.clipsegments,_,T,C,m.coloring),c(a,j,_,T,L,z,n,o,s,m.coloring,B),i(j,L,t,r[0],m,e,o),p.setClipUrl(j,o._clipPathId)}}function i(t,e,r,n,i,o,s){var l=t.selectAll(\"g.contourlines\").data([0]);l.enter().append(\"g\").classed(\"contourlines\",!0);var u=!1!==i.showlines,c=i.showlabels,f=u&&c,d=y.createLines(l,u||c,e),v=y.createLineClip(l,f,r._fullLayout._defs,n.trace.uid),g=t.selectAll(\"g.contourlabels\").data(c?[0]:[]);if(g.exit().remove(),g.enter().append(\"g\").classed(\"contourlabels\",!0),c){var x=o.xaxis,_=o.yaxis,w=x._length,M=_._length,k=[[[0,0],[w,0],[w,M],[0,M]]],A=[];m.clearLocationCache();var T=y.labelFormatter(i,n.t.cb,r._fullLayout),S=p.tester.append(\"text\").attr(\"data-notex\",1).call(p.font,i.labelfont),E={left:0,right:w,center:w/2,top:0,bottom:M,middle:M/2},L=Math.sqrt(w*w+M*M),C=b.LABELDISTANCE*L/Math.max(1,e.length/b.LABELINCREASE);d.each(function(t){var e=y.calcTextOpts(t.level,T,S,r);h.select(this).selectAll(\"path\").each(function(r){var n=this,i=m.getVisibleSegment(n,E,e.height/2);if(i&&(a(n,r,t,i,s,e.height),!(i.len<(e.width+e.height)*b.LABELMIN)))for(var o=Math.min(Math.ceil(i.len/C),b.LABELMAX),l=0;l<o;l++){var u=y.findBestTextLocation(n,i,e,A,E);if(!u)break;y.addLabelData(u,e,A,k)}})}),S.remove(),y.drawLabels(g,A,r,v,f?k:null)}c&&!u&&d.remove()}function a(t,e,r,n,i,a){function u(t,e){var r,n=0;return(Math.abs(t[0]-f)<.1||Math.abs(t[0]-d)<.1)&&(r=s(i.dxydb_rough(t[0],t[1],.1)),n=Math.max(n,a*l(e,r)/2)),(Math.abs(t[1]-p)<.1||Math.abs(t[1]-m)<.1)&&(r=s(i.dxyda_rough(t[0],t[1],.1)),n=Math.max(n,a*l(e,r)/2)),n}for(var c,h=0;h<r.pedgepaths.length;h++)e===r.pedgepaths[h]&&(c=r.edgepaths[h]);if(c){var f=i.a[0],d=i.a[i.a.length-1],p=i.b[0],m=i.b[i.b.length-1],v=o(t,0,1),g=o(t,n.total,n.total-1),y=u(c[0],v),b=n.total-u(c[c.length-1],g);n.min<y&&(n.min=y),n.max>b&&(n.max=b),n.len=n.max-n.min}}function o(t,e,r){var n=t.getPointAtLength(e),i=t.getPointAtLength(r),a=i.x-n.x,o=i.y-n.y,s=Math.sqrt(a*a+o*o);return[a/s,o/s]}function s(t){var e=Math.sqrt(t[0]*t[0]+t[1]*t[1]);return[t[0]/e,t[1]/e]}function l(t,e){var r=Math.abs(t[0]*e[0]+t[1]*e[1]);return Math.sqrt(1-r*r)/r}function u(t,e,r,n,i,a){var o,s,l,u,c=t.selectAll(\"g.contourbg\").data([0]);c.enter().append(\"g\").classed(\"contourbg\",!0);var h=c.selectAll(\"path\").data(\"fill\"!==a||i?[]:[0]);h.enter().append(\"path\"),h.exit().remove();var p=[];for(u=0;u<e.length;u++)o=e[u],s=f([],o.x,r.c2p),l=f([],o.y,n.c2p),p.push(d(s,l,o.bicubic));h.attr(\"d\",\"M\"+p.join(\"L\")+\"Z\").style(\"stroke\",\"none\")}function c(t,e,r,n,i,a,o,s,l,u,c){var f=e.selectAll(\"g.contourfill\").data([0]);f.enter().append(\"g\").classed(\"contourfill\",!0);var d=f.selectAll(\"path\").data(\"fill\"===u?i:[]);d.enter().append(\"path\"),d.exit().remove(),d.each(function(e){var i=_(t,e,a,o,s,l,r,n);e.prefixBoundary&&(i=c+i),i?h.select(this).attr(\"d\",i).style(\"stroke\",\"none\"):h.select(this).remove()})}var h=t(\"d3\"),f=t(\"../carpet/map_1d_array\"),d=t(\"../carpet/makepath\"),p=t(\"../../components/drawing\"),m=t(\"../../lib\"),v=t(\"../contour/make_crossings\"),g=t(\"../contour/find_all_paths\"),y=t(\"../contour/plot\"),b=t(\"../contour/constants\"),x=t(\"./convert_to_constraints\"),_=t(\"./join_all_paths\"),w=t(\"./empty_pathinfo\"),M=t(\"./map_pathinfo\"),k=t(\"../carpet/lookup_carpetid\"),A=t(\"./close_boundaries\");e.exports=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])}},{\"../../components/drawing\":627,\"../../lib\":725,\"../carpet/lookup_carpetid\":900,\"../carpet/makepath\":901,\"../carpet/map_1d_array\":902,\"../contour/constants\":919,\"../contour/find_all_paths\":923,\"../contour/make_crossings\":927,\"../contour/plot\":928,\"./close_boundaries\":933,\"./convert_to_constraints\":937,\"./empty_pathinfo\":939,\"./join_all_paths\":941,\"./map_pathinfo\":942,d3:121}],944:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports=o({},{z:{valType:\"data_array\"},x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:{valType:\"data_array\"},transpose:{valType:\"boolean\",dflt:!1},xtype:{valType:\"enumerated\",values:[\"array\",\"scaled\"]},ytype:{valType:\"enumerated\",values:[\"array\",\"scaled\"]},zsmooth:{valType:\"enumerated\",values:[\"fast\",\"best\",!1],dflt:!1},connectgaps:{valType:\"boolean\",dflt:!1},xgap:{valType:\"number\",dflt:0,min:0},ygap:{valType:\"number\",dflt:0,min:0}},i,{autocolorscale:o({},i.autocolorscale,{dflt:!1})},{colorbar:a})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],945:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../histogram2d/calc\"),s=t(\"../../components/colorscale/calc\"),l=t(\"./has_columns\"),u=t(\"./convert_column_xyz\"),c=t(\"./max_row_length\"),h=t(\"./clean_2d_array\"),f=t(\"./interp2d\"),d=t(\"./find_empties\"),p=t(\"./make_bound_array\");e.exports=function(t,e){function r(t){E=e._input.zsmooth=e.zsmooth=!1,i.notifier(\"cannot fast-zsmooth: \"+t)}var m,v,g,y,b,x,_,w,M=a.getFromId(t,e.xaxis||\"x\"),k=a.getFromId(t,e.yaxis||\"y\"),A=n.traceIs(e,\"contour\"),T=n.traceIs(e,\"histogram\"),S=n.traceIs(e,\"gl2d\"),E=A?\"best\":e.zsmooth;if(M._minDtick=0,k._minDtick=0,T){var L=o(t,e);m=L.x,v=L.x0,g=L.dx,y=L.y,b=L.y0,x=L.dy,_=L.z}else l(e)?(u(e,M,k,\"x\",\"y\",[\"z\"]),m=e.x,y=e.y):(m=e.x?M.makeCalcdata(e,\"x\"):[],y=e.y?k.makeCalcdata(e,\"y\"):[]),v=e.x0||0,g=e.dx||1,b=e.y0||0,x=e.dy||1,_=h(e.z,e.transpose),(A||e.connectgaps)&&(e._emptypoints=d(_),e._interpz=f(_,e._emptypoints,e._interpz));if(\"fast\"===E)if(\"log\"===M.type||\"log\"===k.type)r(\"log axis found\");else if(!T){if(m.length){var C=(m[m.length-1]-m[0])/(m.length-1),z=Math.abs(C/100);for(w=0;w<m.length-1;w++)if(Math.abs(m[w+1]-m[w]-C)>z){r(\"x scale is not linear\");break}}if(y.length&&\"fast\"===E){var I=(y[y.length-1]-y[0])/(y.length-1),D=Math.abs(I/100);for(w=0;w<y.length-1;w++)if(Math.abs(y[w+1]-y[w]-I)>D){r(\"y scale is not linear\");break}}}var P=c(_),O=\"scaled\"===e.xtype?\"\":m,R=p(e,O,v,g,P,M),F=\"scaled\"===e.ytype?\"\":y,j=p(e,F,b,x,_.length,k);S||(a.expand(M,R),a.expand(k,j));var N={x:R,y:j,z:_,text:e.text};if(s(e,_,\"\",\"z\"),A&&e.contours&&\"heatmap\"===e.contours.coloring){var B={type:\"contour\"===e.type?\"heatmap\":\"histogram2d\",xcalendar:e.xcalendar,ycalendar:e.ycalendar};N.xfill=p(B,O,v,g,P,M),N.yfill=p(B,F,b,x,_.length,k)}return[N]}},{\"../../components/colorscale/calc\":609,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../histogram2d/calc\":973,\"./clean_2d_array\":946,\"./convert_column_xyz\":948,\"./find_empties\":950,\"./has_columns\":951,\"./interp2d\":954,\"./make_bound_array\":955,\"./max_row_length\":956}],946:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t,e){var r,i,a,o,s,l;if(e){for(r=0,s=0;s<t.length;s++)r=Math.max(r,t[s].length);if(0===r)return!1;a=function(t){return t.length},o=function(t,e,r){return t[r][e]}}else r=t.length,a=function(t,e){return t[e].length},o=function(t,e,r){return t[e][r]};var u=new Array(r);for(s=0;s<r;s++)for(i=a(t,s),u[s]=new Array(i),l=0;l<i;l++)u[s][l]=function(t){if(n(t))return+t}(o(t,s,l));return u}},{\"fast-isnumeric\":130}],947:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.zmin,c=r.zmax;if(n(u)||(u=i.aggNums(Math.min,null,r.z)),n(c)||(c=i.aggNums(Math.max,null,r.z)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var h=e[0].t.cb=s(t,l),f=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});h.fillcolor(f).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],948:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e,r,a,o,s){a=a||\"x\",o=o||\"y\",s=s||[\"z\"];var l,u,c,h,f,d=t[a].slice(),p=t[o].slice(),m=t.text,v=Math.min(d.length,p.length),g=void 0!==m&&!Array.isArray(m[0]),y=t[a+\"calendar\"],b=t[o+\"calendar\"];for(l=0;l<s.length;l++)(c=t[s[l]])&&(v=Math.min(v,c.length));for(v<d.length&&(d=d.slice(0,v)),v<p.length&&(p=p.slice(0,v)),l=0;l<v;l++)d[l]=e.d2c(d[l],0,y),p[l]=r.d2c(p[l],0,b);var x=n.distinctVals(d),_=x.vals,w=n.distinctVals(p),M=w.vals,k=[];for(l=0;l<s.length;l++)k[l]=n.init2dArray(M.length,_.length);var A,T,S;for(g&&(S=n.init2dArray(M.length,_.length)),l=0;l<v;l++)if(d[l]!==i&&p[l]!==i){for(A=n.findBin(d[l]+x.minDiff/2,_),T=n.findBin(p[l]+w.minDiff/2,M),u=0;u<s.length;u++)f=s[u],c=t[f],h=k[u],h[T][A]=c[l];g&&(S[T][A]=m[l])}for(t[a]=_,t[o]=M,u=0;u<s.length;u++)t[s[u]]=k[u];g&&(t.text=S)}},{\"../../constants/numerical\":705,\"../../lib\":725}],949:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./has_columns\"),a=t(\"./xyz_defaults\"),o=t(\"../../components/colorscale/defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,i){return n.coerce(t,e,s,r,i)}if(!a(t,e,u,l))return void(e.visible=!1);u(\"text\"),!1===u(\"zsmooth\")&&(u(\"xgap\"),u(\"ygap\")),u(\"connectgaps\",i(e)&&!1!==e.zsmooth),o(t,e,l,u,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":944,\"./has_columns\":951,\"./xyz_defaults\":959}],950:[function(t,e,r){\"use strict\";var n=t(\"./max_row_length\");e.exports=function(t){var e,r,i,a,o,s,l,u,c=[],h={},f=[],d=t[0],p=[],m=[0,0,0],v=n(t);for(r=0;r<t.length;r++)for(e=p,p=d,d=t[r+1]||[],i=0;i<v;i++)void 0===p[i]&&(s=(void 0!==p[i-1]?1:0)+(void 0!==p[i+1]?1:0)+(void 0!==e[i]?1:0)+(void 0!==d[i]?1:0),s?(0===r&&s++,0===i&&s++,r===t.length-1&&s++,i===p.length-1&&s++,s<4&&(h[[r,i]]=[r,i,s]),c.push([r,i,s])):f.push([r,i]));for(;f.length;){for(l={},u=!1,o=f.length-1;o>=0;o--)a=f[o],r=a[0],i=a[1],(s=((h[[r-1,i]]||m)[2]+(h[[r+1,i]]||m)[2]+(h[[r,i-1]]||m)[2]+(h[[r,i+1]]||m)[2])/20)&&(l[a]=[r,i,s],f.splice(o,1),u=!0);if(!u)throw\"findEmpties iterated with no new neighbors\";for(a in l)h[a]=l[a],c.push(l[a])}return c.sort(function(t,e){return e[2]-t[2]})}},{\"./max_row_length\":956}],951:[function(t,e,r){\"use strict\";e.exports=function(t){return!Array.isArray(t.z[0])}},{}],952:[function(t,e,r){\"use strict\";var n=t(\"../../components/fx\"),i=t(\"../../lib\"),a=n.constants.MAXDIST;e.exports=function(t,e,r,o,s){if(!(t.distance<a)){var l,u,c,h,f=t.cd[0],d=f.trace,p=t.xa,m=t.ya,v=f.x,g=f.y,y=f.z,b=f.zmask,x=v,_=g;if(!1!==t.index){try{c=Math.round(t.index[1]),h=Math.round(t.index[0])}catch(e){return void i.error(\"Error hovering on heatmap, pointNumber must be [row,col], found:\",t.index)}if(c<0||c>=y[0].length||h<0||h>y.length)return}else{if(n.inbox(e-v[0],e-v[v.length-1])>a||n.inbox(r-g[0],r-g[g.length-1])>a)return;if(s){var w;for(x=[2*v[0]-v[1]],w=1;w<v.length;w++)x.push((v[w]+v[w-1])/2);for(x.push([2*v[v.length-1]-v[v.length-2]]),_=[2*g[0]-g[1]],w=1;w<g.length;w++)_.push((g[w]+g[w-1])/2);_.push([2*g[g.length-1]-g[g.length-2]])}c=Math.max(0,Math.min(x.length-2,i.findBin(e,x))),h=Math.max(0,Math.min(_.length-2,i.findBin(r,_)))}var M=p.c2p(v[c]),k=p.c2p(v[c+1]),A=m.c2p(g[h]),T=m.c2p(g[h+1]);s?(k=M,l=v[c],T=A,u=g[h]):(l=(v[c]+v[c+1])/2,u=(g[h]+g[h+1])/2,d.zsmooth&&(M=k=(M+k)/2,A=T=(A+T)/2));var S=y[h][c];b&&!b[h][c]&&(S=void 0);var E;return Array.isArray(f.text)&&Array.isArray(f.text[h])&&(E=f.text[h][c]),[i.extendFlat(t,{index:[h,c],distance:a+10,x0:M,x1:k,y0:A,y1:T,xLabelVal:l,yLabelVal:u,zLabelVal:S,text:E})]}}},{\"../../components/fx\":644,\"../../lib\":725}],953:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"heatmap\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":944,\"./calc\":945,\"./colorbar\":947,\"./defaults\":949,\"./hover\":952,\"./plot\":957,\"./style\":958}],954:[function(t,e,r){\"use strict\";function n(t){return.5-.25*Math.min(1,.5*t)}function i(t,e,r){var n,i,a,s,l,u,c,h,f,d,p,m,v,g=0;for(s=0;s<e.length;s++){for(n=e[s],i=n[0],a=n[1],p=t[i][a],d=0,f=0,l=0;l<4;l++)u=o[l],(c=t[i+u[0]])&&void 0!==(h=c[a+u[1]])&&(0===d?m=v=h:(m=Math.min(m,h),v=Math.max(v,h)),f++,d+=h);if(0===f)throw\"iterateInterp2d order is wrong: no defined neighbors\";t[i][a]=d/f,void 0===p?f<4&&(g=1):(t[i][a]=(1+r)*t[i][a]-r*p,v>m&&(g=Math.max(g,Math.abs(t[i][a]-p)/(v-m))))}return g}var a=t(\"../../lib\"),o=[[-1,0],[1,0],[0,-1],[0,1]];e.exports=function(t,e,r){var o,s,l=1;if(Array.isArray(r))for(o=0;o<e.length;o++)s=e[o],t[s[0]][s[1]]=r[s[0]][s[1]];else i(t,e);for(o=0;o<e.length&&!(e[o][2]<4);o++);for(e=e.slice(o),o=0;o<100&&l>.01;o++)l=i(t,e,n(l));return l>.01&&a.log(\"interp2d didn't converge quickly\",l),t}},{\"../../lib\":725}],955:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i,a,o){var s,l,u,c=[],h=n.traceIs(t,\"contour\"),f=n.traceIs(t,\"histogram\"),d=n.traceIs(t,\"gl2d\");if(Array.isArray(e)&&e.length>1&&!f&&\"category\"!==o.type){var p=e.length;if(!(p<=a))return h?e.slice(0,a):e.slice(0,a+1);if(h||d)c=e.slice(0,a);else if(1===a)c=[e[0]-.5,e[0]+.5];else{for(c=[1.5*e[0]-.5*e[1]],u=1;u<p;u++)c.push(.5*(e[u-1]+e[u]));c.push(1.5*e[p-1]-.5*e[p-2])}if(p<a){var m=c[c.length-1],v=m-c[c.length-2];for(u=p;u<a;u++)m+=v,c.push(m)}}else{l=i||1;var g=t[o._id.charAt(0)+\"calendar\"];for(s=f||\"category\"===o.type?o.r2c(r,0,g)||0:Array.isArray(e)&&1===e.length?e[0]:void 0===r?0:o.d2c(r,0,g),u=h||d?0:-.5;u<a;u++)c.push(s+l*u)}return c}},{\"../../registry\":844}],956:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=0,r=0;r<t.length;r++)e=Math.max(e,t[r].length);return e}},{}],957:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,e){var r=e.length-2,n=o.constrain(o.findBin(t,e),0,r),i=e[n],a=e[n+1],s=o.constrain(n+(t-i)/(a-i)-.5,0,r),l=Math.round(s),u=Math.abs(s-l);return s&&s!==r&&u?{bin0:l,frac:u,bin1:Math.round(l+u/(s-l))}:{bin0:l,bin1:l,frac:0}}function c(t,e){if(void 0!==t){var r=q(t);return r[0]=Math.round(r[0]),r[1]=Math.round(r[1]),r[2]=Math.round(r[2]),rt+=e,nt+=r[0]*e,it+=r[1]*e,at+=r[2]*e,r}return[0,0,0,0]}function h(t,e,r){t[e]=r[0],t[e+1]=r[1],t[e+2]=r[2],t[e+3]=Math.round(255*r[3])}var f=r[0].trace,d=f.uid,p=e.xaxis,m=e.yaxis,v=t._fullLayout,g=\"hm\"+d;if(v._paper.selectAll(\".contour\"+d).remove(),v._infolayer.selectAll(\"g.rangeslider-container\").selectAll(\".contour\"+d).remove(),!0!==f.visible)return v._paper.selectAll(\".\"+g).remove(),void v._infolayer.selectAll(\".cb\"+d).remove();var y,b,x,_,w,M,k=r[0].z,A=r[0].x,T=r[0].y,S=a.traceIs(f,\"contour\"),E=S?\"best\":f.zsmooth,L=k.length,C=u(k),z=!1,I=!1;for(M=0;void 0===y&&M<A.length-1;)y=p.c2p(A[M]),M++;for(M=A.length-1;void 0===b&&M>0;)b=p.c2p(A[M]),M--;for(b<y&&(x=b,b=y,y=x,z=!0),M=0;void 0===_&&M<T.length-1;)_=m.c2p(T[M]),M++;for(M=T.length-1;void 0===w&&M>0;)w=m.c2p(T[M]),M--;if(w<_&&(x=_,_=w,w=x,I=!0),S&&(A=r[0].xfill,T=r[0].yfill),\"fast\"!==E){var D=\"best\"===E?0:.5;y=Math.max(-D*p._length,y),b=Math.min((1+D)*p._length,b),_=Math.max(-D*m._length,_),w=Math.min((1+D)*m._length,w)}var P=Math.round(b-y),O=Math.round(w-_),R=P<=0||O<=0,F=e.plot.select(\".imagelayer\").selectAll(\"g.hm.\"+g).data(R?[]:[0]);if(F.enter().append(\"g\").classed(\"hm\",!0).classed(g,!0),F.exit().remove(),!R){var j,N;\"fast\"===E?(j=C,N=L):(j=P,N=O);var B=document.createElement(\"canvas\");B.width=j,B.height=N;var U,V,H=B.getContext(\"2d\"),q=s.makeColorScaleFunc(s.extractScale(f.colorscale,f.zmin,f.zmax),{noNumericCheck:!0,returnArray:!0});\"fast\"===E?(U=z?function(t){return C-1-t}:o.identity,V=I?function(t){return L-1-t}:o.identity):(U=function(t){return o.constrain(Math.round(p.c2p(A[t])-y),0,P)},V=function(t){return o.constrain(Math.round(m.c2p(T[t])-_),0,O)});var G,Y,X,W,Z,J,K,Q=V(0),$=[Q,Q],tt=z?0:1,et=I?0:1,rt=0,nt=0,it=0,at=0;if(E){var ot,st=0;try{ot=new Uint8Array(P*O*4)}catch(t){ot=new Array(P*O*4)}if(\"best\"===E){var lt,ut,ct,ht=new Array(A.length),ft=new Array(T.length),dt=new Array(P);for(M=0;M<A.length;M++)ht[M]=Math.round(p.c2p(A[M])-y);for(M=0;M<T.length;M++)ft[M]=Math.round(m.c2p(T[M])-_);for(M=0;M<P;M++)dt[M]=n(M,ht);for(X=0;X<O;X++)for(lt=n(X,ft),ut=k[lt.bin0],ct=k[lt.bin1],M=0;M<P;M++,st+=4)K=function(t,e,r,n){var i=t[r.bin0];if(void 0===i)return c(void 0,1);var a,o=t[r.bin1],s=e[r.bin0],l=e[r.bin1],u=o-i||0,h=s-i||0;return a=void 0===o?void 0===l?0:void 0===s?2*(l-i):2*(2*l-s-i)/3:void 0===l?void 0===s?0:2*(2*i-o-s)/3:void 0===s?2*(2*l-o-i)/3:l+i-o-s,c(i+r.frac*u+n.frac*(h+r.frac*a))}(ut,ct,dt[M],lt),h(ot,st,K)}else for(X=0;X<L;X++)for(J=k[X],$=V(X),M=0;M<P;M++)K=c(J[M],1),st=4*($*P+U(M)),h(ot,st,K);var pt=H.createImageData(P,O);try{pt.data.set(ot)}catch(t){var mt=pt.data,vt=mt.length;for(X=0;X<vt;X++)mt[X]=ot[X]}H.putImageData(pt,0,0)}else for(X=0;X<L;X++)if(J=k[X],$.reverse(),$[et]=V(X+1),$[0]!==$[1]&&void 0!==$[0]&&void 0!==$[1])for(W=U(0),Y=[W,W],M=0;M<C;M++)Y.reverse(),Y[tt]=U(M+1),Y[0]!==Y[1]&&void 0!==Y[0]&&void 0!==Y[1]&&(Z=J[M],K=c(Z,(Y[1]-Y[0])*($[1]-$[0])),H.fillStyle=\"rgba(\"+K.join(\",\")+\")\",G=function(t,e,r,n,i,a,o,s,l){var u={x0:e,x1:r,y0:n,y1:i},c=2*t.xgap/3,h=2*t.ygap/3,f=t.xgap/3,d=t.ygap/3;return s===l-1&&(u.y1=i-h),a===o-1&&(u.x0=e+c),0===s&&(u.y0=n+h),0===a&&(u.x1=r-c),a>0&&a<o-1&&(u.x0=e+f,u.x1=r-f),s>0&&s<l-1&&(u.y0=n+d,u.y1=i-d),u}(f,Y[0],Y[1],$[0],$[1],M,C,X,L),H.fillRect(G.x0,G.y0,G.x1-G.x0,G.y1-G.y0));nt=Math.round(nt/rt),it=Math.round(it/rt),at=Math.round(at/rt);var gt=i(\"rgb(\"+nt+\",\"+it+\",\"+at+\")\");t._hmpixcount=(t._hmpixcount||0)+rt,t._hmlumcount=(t._hmlumcount||0)+rt*gt.getLuminance();var yt=F.selectAll(\"image\").data(r);yt.enter().append(\"svg:image\").attr({xmlns:l.svg,preserveAspectRatio:\"none\"}),yt.attr({height:O,width:P,x:y,y:_,\"xlink:href\":B.toDataURL(\"image/png\")}),yt.exit().remove()}}var i=t(\"tinycolor2\"),a=t(\"../../registry\"),o=t(\"../../lib\"),s=t(\"../../components/colorscale\"),l=t(\"../../constants/xmlns_namespaces\"),u=t(\"./max_row_length\");e.exports=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])}},{\"../../components/colorscale\":617,\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../../registry\":844,\"./max_row_length\":956,tinycolor2:533}],958:[function(t,e,r){\"use strict\";var n=t(\"d3\");e.exports=function(t){n.select(t).selectAll(\".hm image\").style(\"opacity\",function(t){return t.trace.opacity})}},{d3:121}],959:[function(t,e,r){\"use strict\";function n(t,e){var r=e(t);return\"scaled\"===(r?e(t+\"type\",\"array\"):\"scaled\")&&(e(t+\"0\"),e(\"d\"+t)),r}function i(t){for(var e,r=!0,n=!1,i=!1,o=0;o<t.length;o++){if(e=t[o],!Array.isArray(e)){r=!1;break}e.length>0&&(n=!0);for(var s=0;s<e.length;s++)if(a(e[s])){i=!0;break}}return r&&n&&i}var a=t(\"fast-isnumeric\"),o=t(\"../../registry\"),s=t(\"./has_columns\");e.exports=function(t,e,r,a,l,u){var c=r(\"z\");l=l||\"x\",u=u||\"y\";var h,f;if(void 0===c||!c.length)return 0;if(s(t)){if(h=r(l),f=r(u),!h||!f)return 0}else{if(h=n(l,r),f=n(u,r),!i(c))return 0;r(\"transpose\")}return o.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[l,u],a),e.z.length}},{\"../../registry\":844,\"./has_columns\":951,\"fast-isnumeric\":130}],960:[function(t,e,r){\"use strict\";for(var n=t(\"../heatmap/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../lib/extend\").extendFlat,s=[\"z\",\"x\",\"x0\",\"dx\",\"y\",\"y0\",\"dy\",\"text\",\"transpose\",\"xtype\",\"ytype\"],l={},u=0;u<s.length;u++){var c=s[u];l[c]=n[c]}o(l,i,{autocolorscale:o({},i.autocolorscale,{dflt:!1})},{colorbar:a}),e.exports=l},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../heatmap/attributes\":944}],961:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"heatmapgl\",this.name=\"\",this.hoverinfo=\"all\",this.xData=[],this.yData=[],this.zData=[],this.textLabels=[],this.idToIndex=[],this.bounds=[0,0,0,0],this.options={z:[],x:[],y:[],shape:[0,0],colorLevels:[0],colorValues:[0,0,0,1]},this.heatmap=o(t.glplot,this.options),this.heatmap._trace=this}function i(t){for(var e=t.colorscale,r=t.zmin,n=t.zmax,i=e.length,a=new Array(i),o=new Array(4*i),s=0;s<i;s++){var u=e[s],c=l(u[1]);a[s]=r+u[0]*(n-r);for(var h=0;h<4;h++)o[4*s+h]=c[h]}return{colorLevels:a,colorValues:o}}function a(t,e,r){var i=new n(t,e.uid);return i.update(e,r),i}var o=t(\"gl-heatmap2d\"),s=t(\"../../plots/cartesian/axes\"),l=t(\"../../lib/str2rgbarray\"),u=n.prototype;u.handlePick=function(t){var e=this.options,r=e.shape,n=t.pointId,i=n%r[0],a=Math.floor(n/r[0]),o=n;return{trace:this,dataCoord:t.dataCoord,traceCoord:[e.x[i],e.y[a],e.z[o]],textLabel:this.textLabels[n],name:this.name,pointIndex:[a,i],hoverinfo:this.hoverinfo}},u.update=function(t,e){var r=e[0];this.index=t.index,this.name=t.name,this.hoverinfo=t.hoverinfo;var n=r.z;this.options.z=[].concat.apply([],n);var a=n[0].length,o=n.length;this.options.shape=[a,o],this.options.x=r.x,this.options.y=r.y;var l=i(t);this.options.colorLevels=l.colorLevels,this.options.colorValues=l.colorValues,this.textLabels=[].concat.apply([],t.text),this.heatmap.update(this.options),s.expand(this.scene.xaxis,r.x),s.expand(this.scene.yaxis,r.y)},u.dispose=function(){this.heatmap.dispose()},e.exports=a},{\"../../lib/str2rgbarray\":744,\"../../plots/cartesian/axes\":766,\"gl-heatmap2d\":165}],962:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"../heatmap/defaults\"),n.colorbar=t(\"../heatmap/colorbar\"),n.calc=t(\"../heatmap/calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"heatmapgl\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"2dMap\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../heatmap/calc\":945,\"../heatmap/colorbar\":947,\"../heatmap/defaults\":949,\"./attributes\":960,\"./convert\":961}],963:[function(t,e,r){\"use strict\";function n(t){return{start:{valType:\"any\",dflt:null},end:{valType:\"any\",dflt:null},size:{valType:\"any\",dflt:null}}}var i=t(\"../bar/attributes\");e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},text:i.text,orientation:i.orientation,histfunc:{valType:\"enumerated\",values:[\"count\",\"sum\",\"avg\",\"min\",\"max\"],dflt:\"count\"},histnorm:{valType:\"enumerated\",values:[\"\",\"percent\",\"probability\",\"density\",\"probability density\"],dflt:\"\"},cumulative:{enabled:{valType:\"boolean\",dflt:!1},direction:{valType:\"enumerated\",values:[\"increasing\",\"decreasing\"],dflt:\"increasing\"},currentbin:{valType:\"enumerated\",values:[\"include\",\"exclude\",\"half\"],dflt:\"include\"}},autobinx:{valType:\"boolean\",dflt:null},nbinsx:{valType:\"integer\",min:0,dflt:0},xbins:n(\"x\"),autobiny:{valType:\"boolean\",dflt:null},nbinsy:{valType:\"integer\",min:0,dflt:0},ybins:n(\"y\"),marker:i.marker,error_y:i.error_y,error_x:i.error_x,_deprecated:{bardir:i._deprecated.bardir}}},{\"../bar/attributes\":854}],964:[function(t,e,r){\"use strict\";e.exports=function(t,e){for(var r=t.length,n=0,i=0;i<r;i++)e[i]?(t[i]/=e[i],n+=t[i]):t[i]=null;return n}},{}],965:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){return r(\"histnorm\"),n.forEach(function(t){r(t+\"bins.start\"),r(t+\"bins.end\"),r(t+\"bins.size\"),r(\"autobin\"+t),r(\"nbins\"+t)}),e}},{}],966:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports={count:function(t,e,r){return r[t]++,1},sum:function(t,e,r,i){var a=i[e];return n(a)?(a=Number(a),r[t]+=a,a):0},avg:function(t,e,r,i,a){var o=i[e];return n(o)&&(o=Number(o),r[t]+=o,a[t]++),0},min:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]>a){var o=a-r[t];return r[t]=a,o}}return 0},max:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]<a){var o=a-r[t];return r[t]=a,o}}return 0}}},{\"fast-isnumeric\":130}],967:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o,s,u,h,f,d=n+\"bins\";if(e._autoBinFinished)delete e._autoBinFinished;else{var p=i(t,e),m=[],v=1/0,g=1/0,y=-1/0,b=\"autobin\"+n;for(o=0;o<p.length;o++){s=p[o],f=s._pos0=r.makeCalcdata(s,n);var x=s[d];if(s[b]||!x||null===x.start||null===x.end){u=s[n+\"calendar\"];var _=s.cumulative;x=c.autoBin(f,r,s[\"nbins\"+n],!1,u),_.enabled&&\"include\"!==_.currentbin&&(\"decreasing\"===_.direction?g=Math.min(g,r.r2c(x.start,0,u)-x.size):y=Math.max(y,r.r2c(x.end,0,u)+x.size)),m.push(s)}else h||(h={size:x.size,start:r.r2c(x.start,0,u),end:r.r2c(x.end,0,u)});v=a(v,x.size),g=Math.min(g,r.r2c(x.start,0,u)),y=Math.max(y,r.r2c(x.end,0,u)),o&&(e._autoBinFinished=1)}if(h&&l(h.size)&&l(v)){v=v>h.size/1.9?h.size:h.size/Math.ceil(h.size/v);var w=h.start+(h.size-v)/2;g=w-v*Math.ceil((w-g)/v)}for(o=0;o<m.length;o++)s=m[o],u=s[n+\"calendar\"],s._input[d]=s[d]={start:r.c2r(g,0,u),end:r.c2r(y,0,u),size:v},s._input[b]=s[b]}return f=e._pos0,delete e._pos0,[e[d],f]}function i(t,e){if(\"overlay\"===t._fullLayout.barmode)return[e];for(var r=e.xaxis,n=e.yaxis,i=e.orientation,a=[],o=t._fullData,s=0;s<o.length;s++){var l=o[s];\"histogram\"===l.type&&l.orientation===i&&l.xaxis===r&&l.yaxis===n&&a.push(l)}return a}function a(t,e){if(t===1/0)return e;var r=o(t);return o(e)<r?e:t}function o(t){return l(t)?t:\"string\"==typeof t&&\"M\"===t.charAt(0)?v*+t.substr(1):1/0}function s(t,e,r){function n(e){s=t[e],t[e]/=2}function i(e){o=t[e],t[e]=s+o/2,s+=o}var a,o,s;if(\"half\"===r)if(\"increasing\"===e)for(n(0),a=1;a<t.length;a++)i(a);else for(n(t.length-1),a=t.length-2;a>=0;a--)i(a);else if(\"increasing\"===e){for(a=1;a<t.length;a++)t[a]+=t[a-1];\"exclude\"===r&&(t.unshift(0),t.pop())\n",
       "}else{for(a=t.length-2;a>=0;a--)t[a]+=t[a+1];\"exclude\"===r&&(t.push(0),t.shift())}}var l=t(\"fast-isnumeric\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/axes\"),h=t(\"../bar/arrays_to_calcdata\"),f=t(\"./bin_functions\"),d=t(\"./norm_functions\"),p=t(\"./average\"),m=t(\"./clean_bins\"),v=t(\"../../constants/numerical\").ONEAVGMONTH;e.exports=function(t,e){if(!0===e.visible){var r,i=[],a=[],o=c.getFromId(t,\"h\"===e.orientation?e.yaxis||\"y\":e.xaxis||\"x\"),v=\"h\"===e.orientation?\"y\":\"x\",g={x:\"y\",y:\"x\"}[v],y=e[v+\"calendar\"],b=e.cumulative;m(e,o,v);var x,_,w,M=n(t,e,o,v),k=M[0],A=M[1],T=\"string\"==typeof k.size,S=T?[]:k,E=[],L=[],C=0,z=e.histnorm,I=e.histfunc,D=-1!==z.indexOf(\"density\");b.enabled&&D&&(z=z.replace(/ ?density$/,\"\"),D=!1);var P,O=\"max\"===I||\"min\"===I,R=O?null:0,F=f.count,j=d[z],N=!1,B=function(t){return o.r2c(t,0,y)};for(Array.isArray(e[g])&&\"count\"!==I&&(P=e[g],N=\"avg\"===I,F=f[I]),r=B(k.start),_=B(k.end)+(r-c.tickIncrement(r,k.size,!1,y))/1e6;r<_&&i.length<1e6&&(x=c.tickIncrement(r,k.size,!1,y),i.push((r+x)/2),a.push(R),T&&S.push(r),D&&E.push(1/(x-r)),N&&L.push(0),!(x<=r));)r=x;T||\"date\"!==o.type||(S={start:B(S.start),end:B(S.end),size:S.size});var U=a.length;for(r=0;r<A.length;r++)(w=u.findBin(A[r],S))>=0&&w<U&&(C+=F(w,r,a,P,L));N&&(C=p(a,L)),j&&j(a,C,E),b.enabled&&s(a,b.direction,b.currentbin);var V=Math.min(i.length,a.length),H=[],q=0,G=V-1;for(r=0;r<V;r++)if(a[r]){q=r;break}for(r=V-1;r>q;r--)if(a[r]){G=r;break}for(r=q;r<=G;r++)l(i[r])&&l(a[r])&&H.push({p:i[r],s:a[r],b:0});return h(H,e),H}}},{\"../../constants/numerical\":705,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../bar/arrays_to_calcdata\":853,\"./average\":964,\"./bin_functions\":966,\"./clean_bins\":968,\"./norm_functions\":971,\"fast-isnumeric\":130}],968:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\").cleanDate,a=t(\"../../constants/numerical\"),o=a.ONEDAY,s=a.BADNUM;e.exports=function(t,e,r){var a=e.type,l=r+\"bins\",u=t[l];u||(u=t[l]={});var c=\"date\"===a?function(t){return t||0===t?i(t,s,u.calendar):null}:function(t){return n(t)?Number(t):null};u.start=c(u.start),u.end=c(u.end);var h=\"date\"===a?o:1,f=u.size;if(n(f))u.size=f>0?Number(f):h;else if(\"string\"!=typeof f)u.size=h;else{var d=f.charAt(0),p=f.substr(1);p=n(p)?Number(p):0,(p<=0||\"date\"!==a||\"M\"!==d||p!==Math.round(p))&&(u.size=h)}var m=\"autobin\"+r;\"boolean\"!=typeof t[m]&&(t[m]=!((u.start||0===u.start)&&(u.end||0===u.end))),t[m]||delete t[\"nbins\"+r]}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],969:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"./bin_defaults\"),s=t(\"../bar/style_defaults\"),l=t(\"../../components/errorbars/defaults\"),u=t(\"./attributes\");e.exports=function(t,e,r,c){function h(r,n){return i.coerce(t,e,u,r,n)}var f=h(\"x\"),d=h(\"y\");h(\"cumulative.enabled\")&&(h(\"cumulative.direction\"),h(\"cumulative.currentbin\")),h(\"text\");var p=h(\"orientation\",d&&!f?\"h\":\"v\"),m=e[\"v\"===p?\"x\":\"y\"];if(!m||!m.length)return void(e.visible=!1);n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],c),e[\"h\"===p?\"x\":\"y\"]&&h(\"histfunc\"),o(t,e,h,\"h\"===p?[\"y\"]:[\"x\"]),s(t,e,h,r,c),l(t,e,a.defaultLine,{axis:\"y\"}),l(t,e,a.defaultLine,{axis:\"x\",inherit:\"y\"})}},{\"../../components/color\":603,\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../../registry\":844,\"../bar/style_defaults\":865,\"./attributes\":963,\"./bin_defaults\":965}],970:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"../bar/layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"../bar/layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"../bar/set_positions\"),n.plot=t(\"../bar/plot\"),n.style=t(\"../bar/style\"),n.colorbar=t(\"../scatter/colorbar\"),n.hoverPoints=t(\"../bar/hover\"),n.moduleType=\"trace\",n.name=\"histogram\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"bar\",\"histogram\",\"oriented\",\"errorBarsOK\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../bar/hover\":857,\"../bar/layout_attributes\":859,\"../bar/layout_defaults\":860,\"../bar/plot\":861,\"../bar/set_positions\":862,\"../bar/style\":864,\"../scatter/colorbar\":1030,\"./attributes\":963,\"./calc\":967,\"./defaults\":969}],971:[function(t,e,r){\"use strict\";e.exports={percent:function(t,e){for(var r=t.length,n=100/e,i=0;i<r;i++)t[i]*=n},probability:function(t,e){for(var r=t.length,n=0;n<r;n++)t[n]/=e},density:function(t,e,r,n){var i=t.length;n=n||1;for(var a=0;a<i;a++)t[a]*=r[a]*n},\"probability density\":function(t,e,r,n){var i=t.length;n&&(e/=n);for(var a=0;a<i;a++)t[a]*=r[a]/e}}},{}],972:[function(t,e,r){\"use strict\";var n=t(\"../histogram/attributes\"),i=t(\"../heatmap/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports=s({},{x:n.x,y:n.y,z:{valType:\"data_array\"},marker:{color:{valType:\"data_array\"}},histnorm:n.histnorm,histfunc:n.histfunc,autobinx:n.autobinx,nbinsx:n.nbinsx,xbins:n.xbins,autobiny:n.autobiny,nbinsy:n.nbinsy,ybins:n.ybins,xgap:i.xgap,ygap:i.ygap,zsmooth:i.zsmooth},a,{autocolorscale:s({},a.autocolorscale,{dflt:!1})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../heatmap/attributes\":944,\"../histogram/attributes\":963}],973:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../histogram/bin_functions\"),o=t(\"../histogram/norm_functions\"),s=t(\"../histogram/average\"),l=t(\"../histogram/clean_bins\");e.exports=function(t,e){var r,u,c,h,f,d,p=i.getFromId(t,e.xaxis||\"x\"),m=e.x?p.makeCalcdata(e,\"x\"):[],v=i.getFromId(t,e.yaxis||\"y\"),g=e.y?v.makeCalcdata(e,\"y\"):[],y=e.xcalendar,b=e.ycalendar,x=function(t){return p.r2c(t,0,y)},_=function(t){return v.r2c(t,0,b)},w=function(t){return p.c2r(t,0,y)},M=function(t){return v.c2r(t,0,b)};l(e,p,\"x\"),l(e,v,\"y\");var k=Math.min(m.length,g.length);m.length>k&&m.splice(k,m.length-k),g.length>k&&g.splice(k,g.length-k),!e.autobinx&&e.xbins&&null!==e.xbins.start&&null!==e.xbins.end||(e.xbins=i.autoBin(m,p,e.nbinsx,\"2d\",y),\"histogram2dcontour\"===e.type&&(e.xbins.start=w(i.tickIncrement(x(e.xbins.start),e.xbins.size,!0,y)),e.xbins.end=w(i.tickIncrement(x(e.xbins.end),e.xbins.size,!1,y))),e._input.xbins=e.xbins,e._input.autobinx=e.autobinx),!e.autobiny&&e.ybins&&null!==e.ybins.start&&null!==e.ybins.end||(e.ybins=i.autoBin(g,v,e.nbinsy,\"2d\",b),\"histogram2dcontour\"===e.type&&(e.ybins.start=M(i.tickIncrement(_(e.ybins.start),e.ybins.size,!0,b)),e.ybins.end=M(i.tickIncrement(_(e.ybins.end),e.ybins.size,!1,b))),e._input.ybins=e.ybins,e._input.autobiny=e.autobiny),f=[];var A,T,S=[],E=[],L=\"string\"==typeof e.xbins.size,C=\"string\"==typeof e.ybins.size,z=L?[]:e.xbins,I=C?[]:e.ybins,D=0,P=[],O=e.histnorm,R=e.histfunc,F=-1!==O.indexOf(\"density\"),j=\"max\"===R||\"min\"===R,N=j?null:0,B=a.count,U=o[O],V=!1,H=[],q=[],G=\"z\"in e?e.z:\"marker\"in e&&Array.isArray(e.marker.color)?e.marker.color:\"\";G&&\"count\"!==R&&(V=\"avg\"===R,B=a[R]);var Y=e.xbins,X=x(Y.start),W=x(Y.end)+(X-i.tickIncrement(X,Y.size,!1,y))/1e6;for(d=X;d<W;d=i.tickIncrement(d,Y.size,!1,y))S.push(N),L&&z.push(d),V&&E.push(0);L&&z.push(d);var Z=S.length;r=e.xbins.start;var J=x(r);for(u=(d-J)/Z,r=w(J+u/2),Y=e.ybins,X=_(Y.start),W=_(Y.end)+(X-i.tickIncrement(X,Y.size,!1,b))/1e6,d=X;d<W;d=i.tickIncrement(d,Y.size,!1,b))f.push(S.concat()),C&&I.push(d),V&&P.push(E.concat());C&&I.push(d);var K=f.length;c=e.ybins.start;var Q=_(c);for(h=(d-Q)/K,c=M(Q+h/2),F&&(H=S.map(function(t,e){return L?1/(z[e+1]-z[e]):1/u}),q=f.map(function(t,e){return C?1/(I[e+1]-I[e]):1/h})),L||\"date\"!==p.type||(z={start:x(z.start),end:x(z.end),size:z.size}),C||\"date\"!==v.type||(I={start:_(I.start),end:_(I.end),size:I.size}),d=0;d<k;d++)A=n.findBin(m[d],z),T=n.findBin(g[d],I),A>=0&&A<Z&&T>=0&&T<K&&(D+=B(A,d,f[T],G,P[T]));if(V)for(T=0;T<K;T++)D+=s(f[T],P[T]);if(U)for(T=0;T<K;T++)U(f[T],D,H,q[T]);return{x:m,x0:r,dx:u,y:g,y0:c,dy:h,z:f}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../histogram/average\":964,\"../histogram/bin_functions\":966,\"../histogram/clean_bins\":968,\"../histogram/norm_functions\":971}],974:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./sample_defaults\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}i(t,e,l,s),!1===l(\"zsmooth\")&&(l(\"xgap\"),l(\"ygap\")),a(t,e,s,l,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":972,\"./sample_defaults\":976}],975:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../heatmap/calc\"),n.plot=t(\"../heatmap/plot\"),n.colorbar=t(\"../heatmap/colorbar\"),n.style=t(\"../heatmap/style\"),n.hoverPoints=t(\"../heatmap/hover\"),n.moduleType=\"trace\",n.name=\"histogram2d\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"histogram\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../heatmap/calc\":945,\"../heatmap/colorbar\":947,\"../heatmap/hover\":952,\"../heatmap/plot\":957,\"../heatmap/style\":958,\"./attributes\":972,\"./defaults\":974}],976:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../histogram/bin_defaults\");e.exports=function(t,e,r,a){var o=r(\"x\"),s=r(\"y\");if(!(o&&o.length&&s&&s.length))return void(e.visible=!1);n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],a),(r(\"z\")||r(\"marker.color\"))&&r(\"histfunc\"),i(t,e,r,[\"x\",\"y\"])}},{\"../../registry\":844,\"../histogram/bin_defaults\":965}],977:[function(t,e,r){\"use strict\";var n=t(\"../histogram2d/attributes\"),i=t(\"../contour/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports=s({},{x:n.x,y:n.y,z:n.z,marker:n.marker,histnorm:n.histnorm,histfunc:n.histfunc,autobinx:n.autobinx,nbinsx:n.nbinsx,xbins:n.xbins,autobiny:n.autobiny,nbinsy:n.nbinsy,ybins:n.ybins,autocontour:i.autocontour,ncontours:i.ncontours,contours:i.contours,line:i.line},a,{zmin:s({},a.zmin,{editType:\"docalc\"}),zmax:s({},a.zmax,{editType:\"docalc\"})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../contour/attributes\":916,\"../histogram2d/attributes\":972}],978:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../histogram2d/sample_defaults\"),a=t(\"../contour/contours_defaults\"),o=t(\"../contour/style_defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,i){return n.coerce(t,e,s,r,i)}i(t,e,u,l),a(t,e,u),o(t,e,u,l)}},{\"../../lib\":725,\"../contour/contours_defaults\":920,\"../contour/style_defaults\":930,\"../histogram2d/sample_defaults\":976,\"./attributes\":977}],979:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../contour/calc\"),n.plot=t(\"../contour/plot\").plot,n.style=t(\"../contour/style\"),n.colorbar=t(\"../contour/colorbar\"),n.hoverPoints=t(\"../contour/hover\"),n.moduleType=\"trace\",n.name=\"histogram2dcontour\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"contour\",\"histogram\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../contour/calc\":917,\"../contour/colorbar\":918,\"../contour/hover\":924,\"../contour/plot\":928,\"../contour/style\":929,\"./attributes\":977,\"./defaults\":978}],980:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/attributes\"),i=t(\"../../components/colorbar/attributes\"),a=t(\"../surface/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},z:{valType:\"data_array\"},i:{valType:\"data_array\"},j:{valType:\"data_array\"},k:{valType:\"data_array\"},delaunayaxis:{valType:\"enumerated\",values:[\"x\",\"y\",\"z\"],dflt:\"z\"},alphahull:{valType:\"number\",dflt:-1},intensity:{valType:\"data_array\"},color:{valType:\"color\"},vertexcolor:{valType:\"data_array\"},facecolor:{valType:\"data_array\"},opacity:o({},a.opacity),flatshading:{valType:\"boolean\",dflt:!1},contour:{show:o({},a.contours.x.show,{}),color:o({},a.contours.x.color),width:o({},a.contours.x.width)},cauto:n.zauto,cmin:n.zmin,cmax:n.zmax,colorscale:n.colorscale,reversescale:n.reversescale,autocolorscale:o({},n.autocolorscale,{dflt:!1}),showscale:n.showscale,colorbar:i,lightposition:{x:o({},a.lightposition.x,{dflt:1e5}),y:o({},a.lightposition.y,{dflt:1e5}),z:o({},a.lightposition.z,{dflt:0})},lighting:o({},{vertexnormalsepsilon:{valType:\"number\",min:0,max:1,dflt:1e-12},facenormalsepsilon:{valType:\"number\",min:0,max:1,dflt:1e-6}},a.lighting)}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../surface/attributes\":1093}],981:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){e.intensity&&n(e,e.intensity,\"\",\"c\")}},{\"../../components/colorscale/calc\":609}],982:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.cmin,c=r.cmax,h=r.intensity||[];if(n(u)||(u=i.aggNums(Math.min,null,h)),n(c)||(c=i.aggNums(Math.max,null,h)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var f=e[0].t.cb=s(t,l),d=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});f.fillcolor(d).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],983:[function(t,e,r){\"use strict\";function n(t,e,r){this.scene=t,this.uid=r,this.mesh=e,this.name=\"\",this.color=\"#fff\",this.data=null,this.showContour=!1}function i(t){return t.map(function(t){var e=t[0],r=u(t[1]),n=r.toRgb();return{index:e,rgb:[n.r,n.g,n.b,1]}})}function a(t){return t.map(d)}function o(t,e,r){for(var n=new Array(t.length),i=0;i<t.length;++i)n[i]=[t[i],e[i],r[i]];return n}function s(t,e){var r=t.glplot.gl,i=l({gl:r}),a=new n(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}var l=t(\"gl-mesh3d\"),u=t(\"tinycolor2\"),c=t(\"delaunay-triangulate\"),h=t(\"alpha-shape\"),f=t(\"convex-hull\"),d=t(\"../../lib/str2rgbarray\"),p=n.prototype;p.handlePick=function(t){if(t.object===this.mesh){var e=t.index=t.data.index;return t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]],!0}},p.update=function(t){function e(t,e,r,n){return e.map(function(e){return t.d2l(e,0,n)*r})}var r=this.scene,n=r.fullSceneLayout;this.data=t;var s,l=o(e(n.xaxis,t.x,r.dataScale[0],t.xcalendar),e(n.yaxis,t.y,r.dataScale[1],t.ycalendar),e(n.zaxis,t.z,r.dataScale[2],t.zcalendar));if(t.i&&t.j&&t.k)s=o(t.i,t.j,t.k);else if(0===t.alphahull)s=f(l);else if(t.alphahull>0)s=h(t.alphahull,l);else{var u=[\"x\",\"y\",\"z\"].indexOf(t.delaunayaxis);s=c(l.map(function(t){return[t[(u+1)%3],t[(u+2)%3]]}))}var p={positions:l,cells:s,lightPosition:[t.lightposition.x,t.lightposition.y,t.lightposition.z],ambient:t.lighting.ambient,diffuse:t.lighting.diffuse,specular:t.lighting.specular,roughness:t.lighting.roughness,fresnel:t.lighting.fresnel,vertexNormalsEpsilon:t.lighting.vertexnormalsepsilon,faceNormalsEpsilon:t.lighting.facenormalsepsilon,opacity:t.opacity,contourEnable:t.contour.show,contourColor:d(t.contour.color).slice(0,3),contourWidth:t.contour.width,useFacetNormals:t.flatshading};t.intensity?(this.color=\"#fff\",p.vertexIntensity=t.intensity,p.vertexIntensityBounds=[t.cmin,t.cmax],p.colormap=i(t.colorscale)):t.vertexcolor?(this.color=t.vertexcolor[0],p.vertexColors=a(t.vertexcolor)):t.facecolor?(this.color=t.facecolor[0],p.cellColors=a(t.facecolor)):(this.color=t.color,p.meshColor=d(t.color)),this.mesh.update(p)},p.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=s},{\"../../lib/str2rgbarray\":744,\"alpha-shape\":42,\"convex-hull\":102,\"delaunay-triangulate\":122,\"gl-mesh3d\":204,tinycolor2:533}],984:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,n){return i.coerce(t,e,o,r,n)}function u(t){var e=t.map(function(t){var e=l(t);return e&&Array.isArray(e)?e:null});return e.every(function(t){return t&&t.length===e[0].length})&&e}var c=u([\"x\",\"y\",\"z\"]),h=u([\"i\",\"j\",\"k\"]);if(!c)return void(e.visible=!1);h&&h.forEach(function(t){for(var e=0;e<t.length;++e)t[e]|=0}),n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],s),[\"lighting.ambient\",\"lighting.diffuse\",\"lighting.specular\",\"lighting.roughness\",\"lighting.fresnel\",\"lighting.vertexnormalsepsilon\",\"lighting.facenormalsepsilon\",\"lightposition.x\",\"lightposition.y\",\"lightposition.z\",\"contour.show\",\"contour.color\",\"contour.width\",\"colorscale\",\"reversescale\",\"flatshading\",\"alphahull\",\"delaunayaxis\",\"opacity\"].forEach(function(t){l(t)}),\"intensity\"in t?(l(\"intensity\"),a(t,e,s,l,{prefix:\"\",cLetter:\"c\"})):(e.showscale=!1,\"facecolor\"in t?l(\"facecolor\"):\"vertexcolor\"in t?l(\"vertexcolor\"):l(\"color\",r))}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"../../registry\":844,\"./attributes\":980}],985:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.colorbar=t(\"./colorbar\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"mesh3d\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\"],n.meta={},e.exports=n},{\"../../plots/gl3d\":809,\"./attributes\":980,\"./calc\":981,\"./colorbar\":982,\"./convert\":983,\"./defaults\":984}],986:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/attributes\"),a=t(\"../../components/drawing/attributes\").dash,o=i.line,s={name:{valType:\"string\"},showlegend:{valType:\"boolean\",dflt:!0},line:{color:o.color,width:o.width,dash:a}};e.exports={x:{valType:\"data_array\"},open:{valType:\"data_array\",dflt:[]},high:{valType:\"data_array\",dflt:[]},low:{valType:\"data_array\",dflt:[]},close:{valType:\"data_array\",dflt:[]},line:{width:n.extendFlat({},o.width,{}),dash:n.extendFlat({},a,{})},increasing:n.extendDeep({},s,{line:{color:{dflt:\"#3D9970\"}}}),decreasing:n.extendDeep({},s,{line:{color:{dflt:\"#FF4136\"}}}),text:{valType:\"string\",dflt:\"\",arrayOk:!0},tickwidth:{valType:\"number\",min:0,max:.5,dflt:.3}}},{\"../../components/drawing/attributes\":626,\"../../lib\":725,\"../scatter/attributes\":1027}],987:[function(t,e,r){\"use strict\";function n(t,e,r,n){o(t,e,r,n),r(n+\".line.color\"),r(n+\".line.width\",e.line.width),r(n+\".line.dash\",e.line.dash)}var i=t(\"../../lib\"),a=t(\"./ohlc_defaults\"),o=t(\"./direction_defaults\"),s=t(\"./attributes\"),l=t(\"./helpers\");e.exports=function(t,e,r,o){function u(r,n){return i.coerce(t,e,s,r,n)}if(l.pushDummyTransformOpts(t,e),0===a(t,e,u,o))return void(e.visible=!1);u(\"line.width\"),u(\"line.dash\"),n(t,e,u,\"increasing\"),n(t,e,u,\"decreasing\"),u(\"text\"),u(\"tickwidth\")}},{\"../../lib\":725,\"./attributes\":986,\"./direction_defaults\":988,\"./helpers\":989,\"./ohlc_defaults\":991}],988:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){r(n+\".showlegend\"),!1===t.showlegend&&(e[n].showlegend=!1),r(n+\".name\",e.name+\" - \"+n)}},{}],989:[function(t,e,r){\"use strict\";function n(t){function e(t,e){return t===e?e>o?a=!0:e<o&&(a=!1):a=t<e,o=e,a}function r(t,r){return i(t)&&i(r)&&e(+t,+r)}function n(t,r){return i(t)&&i(r)&&!e(+t,+r)}var a=!0,o=null;return\"increasing\"===t?r:n}var i=t(\"fast-isnumeric\"),a=t(\"../../lib\");r.pushDummyTransformOpts=function(t,e){var r={type:e.type,_ephemeral:!0};Array.isArray(t.transforms)?t.transforms.push(r):t.transforms=[r]},r.clearEphemeralTransformOpts=function(t){var e=t.transforms;if(Array.isArray(e)){for(var r=0;r<e.length;r++)e[r]._ephemeral&&e.splice(r,1);0===e.length&&delete t.transforms}},r.copyOHLC=function(t,e){t.open&&(e.open=t.open),t.high&&(e.high=t.high),t.low&&(e.low=t.low),t.close&&(e.close=t.close)},r.makeTransform=function(t,e,r){var n=a.extendFlat([],t.transforms);return n[e.transformIndex]={type:t.type,direction:r,open:t.open,high:t.high,low:t.low,close:t.close},n},r.getFilterFn=function(t){return new n(t)},r.addRangeSlider=function(t,e){for(var r=!1,n=0;n<t.length;n++)if(!0===t[n].visible){r=!0;break}r&&(e.xaxis||(e.xaxis={}),e.xaxis.rangeslider||(e.xaxis.rangeslider={}))}},{\"../../lib\":725,\"fast-isnumeric\":130}],990:[function(t,e,r){\"use strict\";var n=t(\"../../plot_api/register\");e.exports={moduleType:\"trace\",name:\"ohlc\",basePlotModule:t(\"../../plots/cartesian\"),categories:[\"cartesian\",\"showLegend\"],meta:{},attributes:t(\"./attributes\"),supplyDefaults:t(\"./defaults\")},n(t(\"../scatter\")),n(t(\"./transform\"))},{\"../../plot_api/register\":756,\"../../plots/cartesian\":776,\"../scatter\":1037,\"./attributes\":986,\"./defaults\":987,\"./transform\":992}],991:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i){var a,o=r(\"x\"),s=r(\"open\"),l=r(\"high\"),u=r(\"low\"),c=r(\"close\");return n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\"],i),a=Math.min(s.length,l.length,u.length,c.length),o&&(a=Math.min(a,o.length))<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.open=s.slice(0,a)),a<l.length&&(e.high=l.slice(0,a)),a<u.length&&(e.low=u.slice(0,a)),a<c.length&&(e.close=c.slice(0,a)),a}},{\"../../registry\":844}],992:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"scatter\",mode:\"lines\",connectgaps:!1,visible:t.visible,opacity:t.opacity,xaxis:t.xaxis,yaxis:t.yaxis,hoverinfo:i(t),transforms:l.makeTransform(t,e,r)},a=t[r];return a&&s.extendFlat(n,{x:t.x||[0],xcalendar:t.xcalendar,y:[].concat(t.low).concat(t.high),text:t.text,name:a.name,showlegend:a.showlegend,line:a.line}),n}function i(t){var e=t.hoverinfo;if(\"all\"===e)return\"x+text+name\";var r=e.split(\"+\"),n=r.indexOf(\"y\"),i=r.indexOf(\"text\");return-1!==n&&(r.splice(n,1),-1===i&&r.push(\"text\")),r.join(\"+\")}function a(t,e,r){var n=r._fullInput,i=n.tickwidth,a=n._minDiff;if(!a){var o=t._fullData,l=[];a=1/0;var u;for(u=0;u<o.length;u++){var c=o[u]._fullInput;if(\"ohlc\"===c.type&&!0===c.visible&&c.xaxis===e._id&&(l.push(c),c.x&&c.x.length>1)){var h=s.simpleMap(c.x,e.d2c,0,r.xcalendar),f=s.distinctVals(h).minDiff;a=Math.min(a,f)}}for(a===1/0&&(a=1),u=0;u<l.length;u++)l[u]._minDiff=a}return a*i}var o=t(\"fast-isnumeric\"),s=t(\"../../lib\"),l=t(\"./helpers\"),u=t(\"../../plots/cartesian/axes\"),c=t(\"../../plots/cartesian/axis_ids\");r.moduleType=\"transform\",r.name=\"ohlc\",r.attributes={},r.supplyDefaults=function(t,e,r,n){return l.clearEphemeralTransformOpts(n),l.copyOHLC(t,e),t},r.transform=function(t,e){for(var r=[],i=0;i<t.length;i++){var a=t[i];\"ohlc\"===a.type?r.push(n(a,e,\"increasing\"),n(a,e,\"decreasing\")):r.push(a)}return l.addRangeSlider(r,e.layout),r},r.calcTransform=function(t,e,r){var n,i=r.direction,s=l.getFilterFn(i),h=c.getFromTrace(t,e,\"x\"),f=c.getFromTrace(t,e,\"y\"),d=a(t,h,e),p=e.open,m=e.high,v=e.low,g=e.close,y=e.text,b=p.length,x=[],_=[],w=[];n=e._fullInput.x?function(t){var r=e.x[t],n=e.xcalendar,i=h.d2c(r,0,n);x.push(h.c2d(i-d,0,n),r,r,r,r,h.c2d(i+d,0,n),null)}:function(t){x.push(t-d,t,t,t,t,t+d,null)};for(var M=function(t,e){return u.tickText(t,t.c2l(e),\"hover\").text},k=e._fullInput.hoverinfo,A=k.split(\"+\"),T=\"all\"===k,S=T||-1!==A.indexOf(\"y\"),E=T||-1!==A.indexOf(\"text\"),L=Array.isArray(y)?function(t){return y[t]||\"\"}:function(){return y},C=0;C<b;C++)s(p[C],g[C])&&o(m[C])&&o(v[C])&&(n(C),function(t,e,r,n){_.push(t,t,e,r,n,n,null)}(p[C],m[C],v[C],g[C]),function(t,e,r,n,i){var a=[];S&&(a.push(\"Open: \"+M(f,e)),a.push(\"High: \"+M(f,r)),a.push(\"Low: \"+M(f,n)),a.push(\"Close: \"+M(f,i))),E&&a.push(L(t));var o=a.join(\"<br>\");w.push(o,o,o,o,o,o,null)}(C,p[C],m[C],v[C],g[C]));e.x=x,e.y=_,e.text=w}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_ids\":769,\"./helpers\":989,\"fast-isnumeric\":130}],993:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/color_attributes\"),i=t(\"../../components/colorbar/attributes\"),a=t(\"../../components/colorscale/scales\"),o=t(\"../../plots/cartesian/layout_attributes\"),s=t(\"../../plots/font_attributes\"),l=t(\"../../lib/extend\").extendDeep,u=t(\"../../lib/extend\").extendFlat;e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},labelfont:u({},s,{}),tickfont:u({},s,{}),rangefont:u({},s,{}),dimensions:{_isLinkedToArray:\"dimension\",label:{valType:\"string\"},tickvals:o.tickvals,ticktext:o.ticktext,tickformat:{valType:\"string\",dflt:\"3s\"},visible:{valType:\"boolean\",dflt:!0},range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},constraintrange:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},values:{valType:\"data_array\",dflt:[]}},line:u({},l({},n(\"line\"),{colorscale:l({},n(\"line\").colorscale,{dflt:a.Viridis}),autocolorscale:l({},n(\"line\").autocolorscale,{dflt:!1})}),{showscale:{valType:\"boolean\",dflt:!1},colorbar:i})}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/colorscale/scales\":621,\"../../lib/extend\":716,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/font_attributes\":790}],994:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../plots/plots\"),a=t(\"./plot\"),o=t(\"../../constants/xmlns_namespaces\"),s=t(\"./constants\");r.name=\"parcoords\",r.attr=\"type\",r.plot=function(t){var e=i.getSubplotCalcData(t.calcdata,\"parcoords\",\"parcoords\");e.length&&a(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"parcoords\"),a=e._has&&e._has(\"parcoords\");i&&!a&&(n._paperdiv.selectAll(\".parcoords-line-layers\").remove(),n._paperdiv.selectAll(\".parcoords-line-layers\").remove(),n._paperdiv.selectAll(\".parcoords\").remove(),n._paperdiv.selectAll(\".parcoords\").remove(),n._glimages.selectAll(\"*\").remove())},r.toSVG=function(t){function e(e){var n=this,i=n.toDataURL(\"image/png\"),a=r.append(\"svg:image\"),l=t._fullLayout._size,u=t._fullData[e.model.key].domain;a.attr({xmlns:o.svg,\"xlink:href\":i,x:l.l+l.w*u.x[0]-s.overdrag,y:l.t+l.h*(1-u.y[1]),width:(u.x[1]-u.x[0])*l.w+2*s.overdrag,height:(u.y[1]-u.y[0])*l.h,preserveAspectRatio:\"none\"})}var r=t._fullLayout._glimages,i=n.select(t).selectAll(\".svg-container\");i.filter(function(t,e){return e===i.size()-1}).selectAll(\".parcoords-lines.context, .parcoords-lines.focus\").each(e),window.setTimeout(function(){n.selectAll(\"#filterBarPattern\").attr(\"id\",\"filterBarPattern\")},60)}},{\"../../constants/xmlns_namespaces\":707,\"../../plots/plots\":829,\"./constants\":997,\"./plot\":1002,d3:121}],995:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/calc\"),a=t(\"../../lib\");e.exports=function(t,e){var r=!!e.line.colorscale&&a.isArray(e.line.color),o=r?e.line.color:Array.apply(0,Array(e.dimensions.reduce(function(t,e){return Math.max(t,e.values.length)},0))).map(function(){return.5}),s=r?e.line.colorscale:[[0,e.line.color],[1,e.line.color]];return n(e,\"line\")&&i(e,e.line.color,\"line\",\"c\"),[{lineColor:o,cscale:s}]}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"../../lib\":725}],996:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=r.line,u=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+u).remove(),void 0===l||!l.showscale)return void a.autoMargin(t,u);var c=l.color,h=l.cmin,f=l.cmax;n(h)||(h=i.aggNums(Math.min,null,c)),n(f)||(f=i.aggNums(Math.max,null,c));var d=e[0].t.cb=s(t,u),p=o.makeColorScaleFunc(o.extractScale(l.colorscale,h,f),{noNumericCheck:!0});d.fillcolor(p).filllevels({start:h,end:f,size:(f-h)/254}).options(l.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],997:[function(t,e,r){\"use strict\";e.exports={maxDimensionCount:60,overdrag:45,verticalPadding:2,tickDistance:50,canvasPixelRatio:1,blockLineCount:5e3,scatter:!1,layers:[\"contextLineLayer\",\"focusLineLayer\",\"pickLineLayer\"],axisTitleOffset:28,axisExtentOffset:10,bar:{width:4,capturewidth:10,fillcolor:\"magenta\",fillopacity:1,strokecolor:\"white\",strokeopacity:1,strokewidth:1,handleheight:16,handleopacity:1,handleoverlap:0}}},{}],998:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){i(\"line.color\",r),s(t,\"line\")&&a.isArray(t.line.color)?(i(\"line.colorscale\"),l(t,e,n,i,{prefix:\"line.\",cLetter:\"c\"})):i(\"line.color\",r)}function i(t,e){function r(t,e){return a.coerce(n,i,o.dimensions,t,e)}var n,i,s,l=t.dimensions||[],c=e.dimensions=[],h=1/0;for(l.length>u&&(a.log(\"parcoords traces support up to \"+u+\" dimensions at the moment\"),l.splice(u)),s=0;s<l.length;s++)if(n=l[s],i={},a.isPlainObject(n)){var f=r(\"values\"),d=r(\"visible\",f.length>0);d&&(r(\"label\"),r(\"tickvals\"),r(\"ticktext\"),r(\"tickformat\"),r(\"range\"),r(\"constraintrange\"),h=Math.min(h,i.values.length)),i._index=s,c.push(i)}if(isFinite(h))for(s=0;s<c.length;s++)i=c[s],i.visible&&i.values.length>h&&(i.values=i.values.slice(0,h));return c}var a=t(\"../../lib\"),o=t(\"./attributes\"),s=t(\"../../components/colorscale/has_colorscale\"),l=t(\"../../components/colorscale/defaults\"),u=t(\"./constants\").maxDimensionCount;e.exports=function(t,e,r,s){function l(r,n){return a.coerce(t,e,o,r,n)}var u=i(t,e);n(t,e,r,s,l),l(\"domain.x\"),l(\"domain.y\"),Array.isArray(u)&&u.length||(e.visible=!1);var c={family:s.font.family,size:Math.round(s.font.size*(10/12)),color:s.font.color};a.coerceFont(l,\"labelfont\",c),a.coerceFont(l,\"tickfont\",c),a.coerceFont(l,\"rangefont\",c)}},{\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616,\"../../lib\":725,\"./attributes\":993,\"./constants\":997}],999:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.moduleType=\"trace\",n.name=\"parcoords\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"gl\",\"noOpacity\"],n.meta={},e.exports=n},{\"./attributes\":993,\"./base_plot\":994,\"./calc\":995,\"./colorbar\":996,\"./defaults\":998,\"./plot\":1002}],1e3:[function(t,e,r){\"use strict\";function n(t){t.read({x:0,y:0,width:1,height:1,data:x})}function i(t,e,r,n,i){var a=t._gl;a.enable(a.SCISSOR_TEST),a.scissor(e,r,n,i),t.clear({color:[0,0,0,0],depth:1})}function a(t,e,r,a,o,s){function l(n){var c;c=Math.min(a,o-n*a),s.offset=g*n*a,s.count=g*c,0===n&&(window.cancelAnimationFrame(r.currentRafs[u]),delete r.currentRafs[u],i(t,s.scissorX,s.scissorY,s.scissorWidth,s.viewBoxSize[1])),r.clearOnly||(e(s),n*a+c<o&&(r.currentRafs[u]=window.requestAnimationFrame(function(){l(n+1)})),r.drawCompleted=!1)}var u=s.key;r.drawCompleted||(n(t),r.drawCompleted=!0),l(0)}function o(t){return Math.max(m,Math.min(1-m,t))}function s(t,e,r){for(var n=[],i=0;i<256;i++){var a=t(i/255);n.push((e?b:a).concat(r))}return n}function l(t,e){return(t>>>8*e)%256/255}function u(t,e,r,n){for(var i=[],a=0;a<t;a++)for(var s=0;s<v;s++)i.push(s<e?r[s].paddedUnitValues[a]:s===v-1?o(n[a]):s>=v-4?l(a,v-2-s):.5);return i}function c(t,e,r){var n,i,a,o=[];for(i=0;i<t;i++)for(a=0;a<g;a++)for(n=0;n<y;n++)o.push(e[i*v+r*y+n]),r*y+n===v-1&&a%2==0&&(o[o.length-1]*=-1);return o}function h(t,e){var r=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15],n=r.map(function(r){return c(t,e,r)}),i={};return n.forEach(function(t,e){i[\"p\"+e.toString(16)]=t}),i}function f(t,e,r){return t+e<=r}var d=t(\"regl\"),p=t(\"./constants\").verticalPadding,m=1e-6,v=64,g=2,y=4,b=[119,119,119],x=new Uint8Array(4),_=new Uint8Array(4);e.exports=function(t,e,r,n,o,l,c,m,v,g){function y(t){j[0]=t[0],j[1]=t[1]}function b(t,e,i,a,o,s,l,u,c,h,d){var v,g,y,b,x=[t,e],_=p/s,w=[0,1].map(function(){return[0,1,2,3].map(function(){return new Float32Array(16)})}),M=[0,1].map(function(){return[0,1,2,3].map(function(){return new Float32Array(16)})});for(v=0;v<2;v++)for(b=x[v],g=0;g<4;g++)for(y=0;y<16;y++){var k=y+16*g;w[v][g][y]=y+16*g===b?1:0,\n",
       "M[v][g][y]=(!m&&f(y,16*g,I)?A[0===k?0:1+(k-1)%(A.length-1)].filter[v]:v)+(2*v-1)*_}return{key:l,resolution:[r,n],viewBoxPosition:[i+z,a],viewBoxSize:[o,s],i:t,ii:e,dim1A:w[0][0],dim1B:w[0][1],dim1C:w[0][2],dim1D:w[0][3],dim2A:w[1][0],dim2B:w[1][1],dim2C:w[1][2],dim2D:w[1][3],loA:M[0][0],loB:M[0][1],loC:M[0][2],loD:M[0][3],hiA:M[1][0],hiB:M[1][1],hiC:M[1][2],hiD:M[1][3],colorClamp:j,scatter:u||0,scissorX:c===h?0:i+z,scissorWidth:(c===d?r-i+z:o+.5)+(c===h?i+z:0),scissorY:a,scissorHeight:s}}function x(t,o,s){var l,u,c,h=1/0,f=-1/0;for(l=0;l<I;l++)t[l].dim2.canvasX>f&&(f=t[l].dim2.canvasX,c=l),t[l].dim1.canvasX<h&&(h=t[l].dim1.canvasX,u=l);for(0===I&&i(O,0,0,r,n),l=0;l<I;l++){var d=t[l],p=d.dim1,m=p.crossfilterDimensionIndex,v=d.canvasX,y=d.canvasY,x=d.dim2,_=x.crossfilterDimensionIndex,w=d.panelSizeX,M=d.panelSizeY,A=v+w;if(o||!N[m]||N[m][0]!==v||N[m][1]!==A){N[m]=[v,A];var T=b(m,_,v,y,w,M,p.crossfilterDimensionIndex,g||p.scatter?1:0,l,u,c);k.clearOnly=s,a(O,F,k,o?e.blockLineCount:S,S,T)}}}function w(t,e){return O.read({x:t,y:e,width:1,height:1,data:_}),_}function M(t,e,r,n){var i=new Uint8Array(4*r*n);return O.read({x:t,y:e,width:r,height:n,data:i}),i}var k={currentRafs:{},drawCompleted:!0,clearOnly:!1},A=o.slice(),T=A.length,S=A[0]?A[0].values.length:0,E=m,L=v?e.color.map(function(t,r){return r/e.color.length}):e.color,C=Math.max(1/255,Math.pow(1/L.length,1/3)),z=e.canvasOverdrag,I=l.length,D=u(S,T,A,L),P=h(S,D),O=d({canvas:t,attributes:{preserveDrawingBuffer:!0,antialias:!v}}),R=O.texture({shape:[256,1],format:\"rgba\",type:\"uint8\",mag:\"nearest\",min:\"nearest\",data:s(c,m,Math.round(255*(m?C:1)))}),F=O({profile:!1,blend:{enable:E,func:{srcRGB:\"src alpha\",dstRGB:\"one minus src alpha\",srcAlpha:1,dstAlpha:1},equation:{rgb:\"add\",alpha:\"add\"},color:[0,0,0,0]},depth:{enable:!E,mask:!0,func:\"less\",range:[0,1]},cull:{enable:!0,face:\"back\"},scissor:{enable:!0,box:{x:O.prop(\"scissorX\"),y:O.prop(\"scissorY\"),width:O.prop(\"scissorWidth\"),height:O.prop(\"scissorHeight\")}},dither:!1,vert:v?\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec4 p0, p1, p2, p3,\\n               p4, p5, p6, p7,\\n               p8, p9, pa, pb,\\n               pc, pd, pe;\\n\\nattribute vec4 pf;\\n\\nuniform mat4 dim1A, dim2A, dim1B, dim2B, dim1C, dim2C, dim1D, dim2D,\\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\\n\\nuniform vec2 resolution,\\n             viewBoxPosition,\\n             viewBoxSize;\\n\\nuniform sampler2D palette;\\n\\nuniform vec2 colorClamp;\\n\\nuniform float scatter;\\n\\nvarying vec4 fragColor;\\n\\nvec4 zero = vec4(0, 0, 0, 0);\\nvec4 unit = vec4(1, 1, 1, 1);\\nvec2 xyProjection = vec2(1, 1);\\n\\nmat4 mclamp(mat4 m, mat4 lo, mat4 hi) {\\n    return mat4(clamp(m[0], lo[0], hi[0]),\\n                clamp(m[1], lo[1], hi[1]),\\n                clamp(m[2], lo[2], hi[2]),\\n                clamp(m[3], lo[3], hi[3]));\\n}\\n\\nbool mshow(mat4 p, mat4 lo, mat4 hi) {\\n    return mclamp(p, lo, hi) == p;\\n}\\n\\nfloat val(mat4 p, mat4 v) {\\n    return dot(matrixCompMult(p, v) * unit, unit);\\n}\\n\\nvoid main() {\\n\\n    float x = 0.5 * sign(pf[3]) + 0.5;\\n    float prominence = abs(pf[3]);\\n    float depth = 1.0 - prominence;\\n\\n    mat4 pA = mat4(p0, p1, p2, p3);\\n    mat4 pB = mat4(p4, p5, p6, p7);\\n    mat4 pC = mat4(p8, p9, pa, pb);\\n    mat4 pD = mat4(pc, pd, pe, abs(pf));\\n\\n    float show = float(mshow(pA, loA, hiA) &&\\n                       mshow(pB, loB, hiB) &&\\n                       mshow(pC, loC, hiC) &&\\n                       mshow(pD, loD, hiD));\\n\\n    vec2 yy = show * vec2(val(pA, dim2A) + val(pB, dim2B) + val(pC, dim2C) + val(pD, dim2D),\\n                          val(pA, dim1A) + val(pB, dim1B) + val(pC, dim1C) + val(pD, dim1D));\\n\\n    vec2 dimensionToggle = vec2(x, 1.0 - x);\\n\\n    vec2 scatterToggle = vec2(scatter, 1.0 - scatter);\\n\\n    float y = dot(yy, dimensionToggle);\\n    mat2 xy = mat2(viewBoxSize * yy + dimensionToggle, viewBoxSize * vec2(x, y));\\n\\n    vec2 viewBoxXY = viewBoxPosition + xy * scatterToggle;\\n\\n    float depthOrHide = depth + 2.0 * (1.0 - show);\\n\\n    gl_Position = vec4(\\n        xyProjection * (2.0 * viewBoxXY / resolution - 1.0),\\n        depthOrHide,\\n        1.0\\n    );\\n\\n    // pick coloring\\n    fragColor = vec4(pf.rgb, 1.0);\\n}\\n\":\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec4 p0, p1, p2, p3,\\n               p4, p5, p6, p7,\\n               p8, p9, pa, pb,\\n               pc, pd, pe;\\n\\nattribute vec4 pf;\\n\\nuniform mat4 dim1A, dim2A, dim1B, dim2B, dim1C, dim2C, dim1D, dim2D,\\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\\n\\nuniform vec2 resolution,\\n             viewBoxPosition,\\n             viewBoxSize;\\n\\nuniform sampler2D palette;\\n\\nuniform vec2 colorClamp;\\n\\nuniform float scatter;\\n\\nvarying vec4 fragColor;\\n\\nvec4 zero = vec4(0, 0, 0, 0);\\nvec4 unit = vec4(1, 1, 1, 1);\\nvec2 xyProjection = vec2(1, 1);\\n\\nmat4 mclamp(mat4 m, mat4 lo, mat4 hi) {\\n    return mat4(clamp(m[0], lo[0], hi[0]),\\n                clamp(m[1], lo[1], hi[1]),\\n                clamp(m[2], lo[2], hi[2]),\\n                clamp(m[3], lo[3], hi[3]));\\n}\\n\\nbool mshow(mat4 p, mat4 lo, mat4 hi) {\\n    return mclamp(p, lo, hi) == p;\\n}\\n\\nfloat val(mat4 p, mat4 v) {\\n    return dot(matrixCompMult(p, v) * unit, unit);\\n}\\n\\nvoid main() {\\n\\n    float x = 0.5 * sign(pf[3]) + 0.5;\\n    float prominence = abs(pf[3]);\\n    float depth = 1.0 - prominence;\\n\\n    mat4 pA = mat4(p0, p1, p2, p3);\\n    mat4 pB = mat4(p4, p5, p6, p7);\\n    mat4 pC = mat4(p8, p9, pa, pb);\\n    mat4 pD = mat4(pc, pd, pe, abs(pf));\\n\\n    float show = float(mshow(pA, loA, hiA) &&\\n                       mshow(pB, loB, hiB) &&\\n                       mshow(pC, loC, hiC) &&\\n                       mshow(pD, loD, hiD));\\n\\n    vec2 yy = show * vec2(val(pA, dim2A) + val(pB, dim2B) + val(pC, dim2C) + val(pD, dim2D),\\n                          val(pA, dim1A) + val(pB, dim1B) + val(pC, dim1C) + val(pD, dim1D));\\n\\n    vec2 dimensionToggle = vec2(x, 1.0 - x);\\n\\n    vec2 scatterToggle = vec2(scatter, 1.0 - scatter);\\n\\n    float y = dot(yy, dimensionToggle);\\n    mat2 xy = mat2(viewBoxSize * yy + dimensionToggle, viewBoxSize * vec2(x, y));\\n\\n    vec2 viewBoxXY = viewBoxPosition + xy * scatterToggle;\\n\\n    float depthOrHide = depth + 2.0 * (1.0 - show);\\n\\n    gl_Position = vec4(\\n        xyProjection * (2.0 * viewBoxXY / resolution - 1.0),\\n        depthOrHide,\\n        1.0\\n    );\\n\\n    // visible coloring\\n    float clampedColorIndex = clamp((prominence - colorClamp[0]) / (colorClamp[1] - colorClamp[0]), 0.0, 1.0);\\n    fragColor = texture2D(palette, vec2((clampedColorIndex * 255.0 + 0.5) / 256.0, 0.5));\\n}\\n\",frag:\"precision lowp float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n    gl_FragColor = fragColor;\\n}\\n\",primitive:\"lines\",lineWidth:1,attributes:P,uniforms:{resolution:O.prop(\"resolution\"),viewBoxPosition:O.prop(\"viewBoxPosition\"),viewBoxSize:O.prop(\"viewBoxSize\"),dim1A:O.prop(\"dim1A\"),dim2A:O.prop(\"dim2A\"),dim1B:O.prop(\"dim1B\"),dim2B:O.prop(\"dim2B\"),dim1C:O.prop(\"dim1C\"),dim2C:O.prop(\"dim2C\"),dim1D:O.prop(\"dim1D\"),dim2D:O.prop(\"dim2D\"),loA:O.prop(\"loA\"),hiA:O.prop(\"hiA\"),loB:O.prop(\"loB\"),hiB:O.prop(\"hiB\"),loC:O.prop(\"loC\"),hiC:O.prop(\"hiC\"),loD:O.prop(\"loD\"),hiD:O.prop(\"hiD\"),palette:R,colorClamp:O.prop(\"colorClamp\"),scatter:O.prop(\"scatter\")},offset:O.prop(\"offset\"),count:O.prop(\"count\")}),j=[0,1],N=[];return{setColorDomain:y,render:x,readPixel:w,readPixels:M,destroy:O.destroy}}},{\"./constants\":997,regl:498}],1001:[function(t,e,r){\"use strict\";function n(t){return t.key}function i(t){return[t]}function a(t){return!(\"visible\"in t)||t.visible}function o(t){var e=t.range?t.range[0]:w.min(t.values),r=t.range?t.range[1]:w.max(t.values);return!isNaN(e)&&isFinite(e)||(e=0),!isNaN(r)&&isFinite(r)||(r=0),e===r&&(void 0===e?(e=0,r=1):0===e?(e-=1,r+=1):(e*=.9,r*=1.1)),[e,r]}function s(t,e){var r,n,i,a,o;for(r=0,n=t.range(),i=1/0,a=n[0],o;r<n.length;r++){if((o=Math.abs(n[r]-e))>i)return a;i=o,a=n[r]}return n[n.length-1]}function l(t,e){return function(r,n){if(e){var i=e[n];return null===i||void 0===i?t(r):i}return t(r)}}function u(t,e,r){var n=o(r),i=r.ticktext;return r.tickvals?w.scale.ordinal().domain(r.tickvals.map(l(w.format(r.tickformat),i))).range(r.tickvals.map(function(t){return(t-n[0])/(n[1]-n[0])}).map(function(r){return t-e+r*(e-(t-e))})):w.scale.linear().domain(n).range([t-e,e])}function c(t,e){return w.scale.linear().range([t-e,e])}function h(t){return w.scale.linear().domain(o(t))}function f(t){var e=o(t);return t.tickvals&&w.scale.ordinal().domain(t.tickvals).range(t.tickvals.map(function(t){return(t-e[0])/(e[1]-e[0])}))}function d(t){var e=t.map(function(t){return t[0]}),r=t.map(function(t){return t[1]}),n=r.map(function(t){return w.rgb(t)}),i=function(t){return function(e){return e[t]}},a=\"rgb\".split(\"\").map(function(t){return w.scale.linear().clamp(!0).domain(e).range(n.map(i(t)))});return function(t){return a.map(function(e){return e(t)})}}function p(t){return t[0]}function m(t,e,r){var n=p(e),i=n.trace,o=n.lineColor,s=n.cscale,l=i.line,u=i.domain,c=i.dimensions,f=t.width,m=i.labelfont,v=i.tickfont,g=i.rangefont,y=_.extendDeep({},l,{color:o.map(h({values:o,range:[l.cmin,l.cmax]})),blockLineCount:x.blockLineCount,canvasOverdrag:x.overdrag*x.canvasPixelRatio}),b=Math.floor(f*(u.x[1]-u.x[0])),w=Math.floor(t.height*(u.y[1]-u.y[0])),M=t.margin||{l:80,r:80,t:100,b:80},k=b,A=w;return{key:r,colCount:c.filter(a).length,dimensions:c,tickDistance:x.tickDistance,unitToColor:d(s),lines:y,labelFont:m,tickFont:v,rangeFont:g,translateX:u.x[0]*f,translateY:t.height-u.y[1]*t.height,pad:M,canvasWidth:k*x.canvasPixelRatio+2*y.canvasOverdrag,canvasHeight:A*x.canvasPixelRatio,width:k,height:A,canvasPixelRatio:x.canvasPixelRatio}}function v(t){var e=t.width,r=t.height,n=t.dimensions,i=t.canvasPixelRatio,o=function(r){return e*r/Math.max(1,t.colCount-1)},s=x.verticalPadding/(r*i),l=1-2*s,d=function(t){return s+l*t},p={key:t.key,xScale:o,model:t},m={};return p.dimensions=n.filter(a).map(function(e,n){var a=h(e),s=m[e.label];return m[e.label]=(s||0)+1,{key:e.label+(s?\"__\"+s:\"\"),label:e.label,tickFormat:e.tickformat,tickvals:e.tickvals,ticktext:e.ticktext,ordinal:!!e.tickvals,scatter:x.scatter||e.scatter,xIndex:n,crossfilterDimensionIndex:n,visibleIndex:e._index,height:r,values:e.values,paddedUnitValues:e.values.map(a).map(d),xScale:o,x:o(n),canvasX:o(n)*i,unitScale:c(r,x.verticalPadding),domainScale:u(r,x.verticalPadding,e),ordinalScale:f(e),domainToUnitScale:a,filter:e.constraintrange?e.constraintrange.map(a):[0,1],parent:p,model:t}}),p}function g(t){return x.layers.map(function(e){return{key:e,context:\"contextLineLayer\"===e,pick:\"pickLineLayer\"===e,viewModel:t,model:t.model}})}function y(t){t.classed(\"axisExtentText\",!0).attr(\"text-anchor\",\"middle\").style(\"cursor\",\"default\").style(\"user-select\",\"none\")}var b=t(\"./lines\"),x=t(\"./constants\"),_=t(\"../../lib\"),w=t(\"d3\"),M=t(\"../../components/drawing\");e.exports=function(t,e,r,a,o){function l(t){var e=t.selectAll(\"defs\").data(i,n);e.enter().append(\"defs\");var r=e.selectAll(\"#filterBarPattern\").data(i,n);r.enter().append(\"pattern\").attr(\"id\",\"filterBarPattern\").attr(\"patternUnits\",\"userSpaceOnUse\"),r.attr(\"x\",-x.bar.width).attr(\"width\",x.bar.capturewidth).attr(\"height\",function(t){return t.model.height});var a=r.selectAll(\"rect\").data(i,n);a.enter().append(\"rect\").attr(\"shape-rendering\",\"crispEdges\"),a.attr(\"height\",function(t){return t.model.height}).attr(\"width\",x.bar.width).attr(\"x\",x.bar.width/2).attr(\"fill\",x.bar.fillcolor).attr(\"fill-opacity\",x.bar.fillopacity).attr(\"stroke\",x.bar.strokecolor).attr(\"stroke-opacity\",x.bar.strokeopacity).attr(\"stroke-width\",x.bar.strokewidth)}function u(t){return t.dimensions.some(function(t){return 0!==t.filter[0]||1!==t.filter[1]})}function c(t,e){for(var r=e.panels||(e.panels=[]),n=t.each(function(t){return t})[e.key].map(function(t){return t.__data__}),i=n.length-1,a=0;a<1;a++)for(var o=0;o<i;o++){var s=r[o+a*i]||(r[o+a*i]={}),l=n[o],u=n[o+1];s.dim1=l,s.dim2=u,s.canvasX=l.canvasX,s.panelSizeX=u.canvasX-l.canvasX,s.panelSizeY=e.model.canvasHeight/1,s.y=a*s.panelSizeY,s.canvasY=e.model.canvasHeight-s.y-s.panelSizeY}}function h(t,e){for(var r=e.panels||(e.panels=[]),n=t.each(function(t){return t})[e.key].map(function(t){return t.__data__}),i=n.length-1,a=i,o=0;o<i;o++)for(var s=0;s<i;s++){var l=r[s+o*i]||(r[s+o*i]={}),u=n[s],c=n[s+1];l.dim1=n[o+1],l.dim2=c,l.canvasX=u.canvasX,l.panelSizeX=c.canvasX-u.canvasX,l.panelSizeY=e.model.canvasHeight/a,l.y=o*l.panelSizeY,l.canvasY=e.model.canvasHeight-l.y-l.panelSizeY}}function f(t,e){return(x.scatter?h:c)(t,e)}function d(t){return t.ordinal?function(){return\"\"}:w.format(t.tickFormat)}function _(){X=!0,T=!0}function k(t){S=!1;var e=t.parent,r=t.brush.extent(),n=e.dimensions,i=n[t.xIndex].filter,a=X&&r[0]===r[1];a&&(t.brush.clear(),w.select(this).select(\"rect.extent\").attr(\"y\",-100));var o=a?[0,1]:r.slice();if(o[0]!==i[0]||o[1]!==i[1]){n[t.xIndex].filter=o,e.focusLineLayer&&e.focusLineLayer.render(e.panels,!0);var s=u(e);!W&&s?(e.contextLineLayer&&e.contextLineLayer.render(e.panels,!0),W=!0):W&&!s&&(e.contextLineLayer&&e.contextLineLayer.render(e.panels,!0,!0),W=!1)}X=!1}function A(t){var e=t.parent,r=t.brush.extent(),n=r[0]===r[1],i=e.dimensions,a=i[t.xIndex].filter;if(!n&&t.ordinal&&(a[0]=s(t.ordinalScale,a[0]),a[1]=s(t.ordinalScale,a[1]),a[0]===a[1]&&(a[0]=Math.max(0,a[0]-.05),a[1]=Math.min(1,a[1]+.05)),w.select(this).transition().duration(150).call(t.brush.extent(a)),e.focusLineLayer.render(e.panels,!0)),e.pickLineLayer&&e.pickLineLayer.render(e.panels,!0),S=!0,T=\"ending\",o&&o.filterChanged){var l=t.domainToUnitScale.invert,u=a.map(l);o.filterChanged(e.key,t.visibleIndex,u)}}var T=!1,S=!0,E=r.filter(function(t){return p(t).trace.visible}).map(m.bind(0,a)).map(v);t.selectAll(\".parcoords-line-layers\").remove();var L=t.selectAll(\".parcoords-line-layers\").data(E,n);L.enter().insert(\"div\",\".\"+e.attr(\"class\").split(\" \").join(\" .\")).classed(\"parcoords-line-layers\",!0).style(\"box-sizing\",\"content-box\"),L.style(\"transform\",function(t){return\"translate(\"+(t.model.translateX-x.overdrag)+\"px,\"+t.model.translateY+\"px)\"});var C=L.selectAll(\".parcoords-lines\").data(g,n),z={renderers:[],dimensions:[]},I=null;C.enter().append(\"canvas\").attr(\"class\",function(t){return\"parcoords-lines \"+(t.context?\"context\":t.pick?\"pick\":\"focus\")}).style(\"box-sizing\",\"content-box\").style(\"float\",\"left\").style(\"clear\",\"both\").style(\"left\",0).style(\"overflow\",\"visible\").style(\"position\",function(t,e){return\"absolute\"}).filter(function(t){return t.pick}).on(\"mousemove\",function(t){if(S&&t.lineLayer&&o&&o.hover){var e=w.event,r=this.width,n=this.height,i=w.mouse(this),a=i[0],s=i[1];if(a<0||s<0||a>=r||s>=n)return;var l=t.lineLayer.readPixel(a,n-1-s),u=0!==l[3],c=u?l[2]+256*(l[1]+256*l[0]):null,h={x:a,y:s,clientX:e.clientX,clientY:e.clientY,dataIndex:t.model.key,curveNumber:c};c!==I&&(u?o.hover(h):o.unhover&&o.unhover(h),I=c)}}),C.style(\"margin\",function(t){var e=t.model.pad;return e.t+\"px \"+e.r+\"px \"+e.b+\"px \"+e.l+\"px\"}).attr(\"width\",function(t){return t.model.canvasWidth}).attr(\"height\",function(t){return t.model.canvasHeight}).style(\"width\",function(t){return t.model.width+2*x.overdrag+\"px\"}).style(\"height\",function(t){return t.model.height+\"px\"}).style(\"opacity\",function(t){return t.pick?.01:1}),e.style(\"background\",\"rgba(255, 255, 255, 0)\");var D=e.selectAll(\".parcoords\").data(E,n);D.exit().remove(),D.enter().append(\"g\").classed(\"parcoords\",!0).attr(\"overflow\",\"visible\").style(\"box-sizing\",\"content-box\").style(\"position\",\"absolute\").style(\"left\",0).style(\"overflow\",\"visible\").style(\"shape-rendering\",\"crispEdges\").style(\"pointer-events\",\"none\").call(l),D.attr(\"width\",function(t){return t.model.width+t.model.pad.l+t.model.pad.r}).attr(\"height\",function(t){return t.model.height+t.model.pad.t+t.model.pad.b}).attr(\"transform\",function(t){return\"translate(\"+t.model.translateX+\",\"+t.model.translateY+\")\"});var P=D.selectAll(\".parcoordsControlView\").data(i,n);P.enter().append(\"g\").classed(\"parcoordsControlView\",!0).style(\"box-sizing\",\"content-box\"),P.attr(\"transform\",function(t){return\"translate(\"+t.model.pad.l+\",\"+t.model.pad.t+\")\"});var O=P.selectAll(\".yAxis\").data(function(t){return t.dimensions},n);O.enter().append(\"g\").classed(\"yAxis\",!0).each(function(t){z.dimensions.push(t)}),P.each(function(t){f(O,t)}),C.each(function(t){t.lineLayer=b(this,t.model.lines,t.model.canvasWidth,t.model.canvasHeight,t.viewModel.dimensions,t.viewModel.panels,t.model.unitToColor,t.context,t.pick,x.scatter),t.viewModel[t.key]=t.lineLayer,z.renderers.push(function(){t.lineLayer.render(t.viewModel.panels,!0)}),t.lineLayer.render(t.viewModel.panels,!t.context)}),O.attr(\"transform\",function(t){return\"translate(\"+t.xScale(t.xIndex)+\", 0)\"}),O.call(w.behavior.drag().origin(function(t){return t}).on(\"drag\",function(t){var e=t.parent;S=!1,T||(t.x=Math.max(-x.overdrag,Math.min(t.model.width+x.overdrag,w.event.x)),t.canvasX=t.x*t.model.canvasPixelRatio,O.sort(function(t,e){return t.x-e.x}).each(function(e,r){e.xIndex=r,e.x=t===e?e.x:e.xScale(e.xIndex),e.canvasX=e.x*e.model.canvasPixelRatio}),f(O,e),O.filter(function(e){return 0!==Math.abs(t.xIndex-e.xIndex)}).attr(\"transform\",function(t){return\"translate(\"+t.xScale(t.xIndex)+\", 0)\"}),w.select(this).attr(\"transform\",\"translate(\"+t.x+\", 0)\"),O.each(function(r,n,i){i===t.parent.key&&(e.dimensions[n]=r)}),e.contextLineLayer&&e.contextLineLayer.render(e.panels,!1,!u(e)),e.focusLineLayer.render&&e.focusLineLayer.render(e.panels))}).on(\"dragend\",function(t){var e=t.parent;if(T)return void(\"ending\"===T&&(T=!1));t.x=t.xScale(t.xIndex),t.canvasX=t.x*t.model.canvasPixelRatio,f(O,e),w.select(this).attr(\"transform\",function(t){return\"translate(\"+t.x+\", 0)\"}),e.contextLineLayer&&e.contextLineLayer.render(e.panels,!1,!u(e)),e.focusLineLayer&&e.focusLineLayer.render(e.panels),e.pickLineLayer&&e.pickLineLayer.render(e.panels,!0),S=!0,o&&o.axesMoved&&o.axesMoved(e.key,e.dimensions.map(function(t){return t.crossfilterDimensionIndex}))})),O.exit().remove();var R=O.selectAll(\".axisOverlays\").data(i,n);R.enter().append(\"g\").classed(\"axisOverlays\",!0),R.selectAll(\".axis\").remove();var F=R.selectAll(\".axis\").data(i,n);F.enter().append(\"g\").classed(\"axis\",!0),F.each(function(t){var e=t.model.height/t.model.tickDistance,r=t.domainScale,n=r.domain();w.select(this).call(w.svg.axis().orient(\"left\").tickSize(4).outerTickSize(2).ticks(e,t.tickFormat).tickValues(t.ordinal?n:null).tickFormat(t.ordinal?function(t){return t}:null).scale(r)),M.font(F.selectAll(\"text\"),t.model.tickFont)}),F.selectAll(\".domain, .tick>line\").attr(\"fill\",\"none\").attr(\"stroke\",\"black\").attr(\"stroke-opacity\",.25).attr(\"stroke-width\",\"1px\"),F.selectAll(\"text\").style(\"text-shadow\",\"1px 1px 1px #fff, -1px -1px 1px #fff, 1px -1px 1px #fff, -1px 1px 1px #fff\").style(\"cursor\",\"default\").style(\"user-select\",\"none\");var j=R.selectAll(\".axisHeading\").data(i,n);j.enter().append(\"g\").classed(\"axisHeading\",!0);var N=j.selectAll(\".axisTitle\").data(i,n);N.enter().append(\"text\").classed(\"axisTitle\",!0).attr(\"text-anchor\",\"middle\").style(\"cursor\",\"ew-resize\").style(\"user-select\",\"none\").style(\"pointer-events\",\"auto\"),N.attr(\"transform\",\"translate(0,\"+-x.axisTitleOffset+\")\").text(function(t){return t.label}).each(function(t){M.font(N,t.model.labelFont)});var B=R.selectAll(\".axisExtent\").data(i,n);B.enter().append(\"g\").classed(\"axisExtent\",!0);var U=B.selectAll(\".axisExtentTop\").data(i,n);U.enter().append(\"g\").classed(\"axisExtentTop\",!0),U.attr(\"transform\",\"translate(0,\"+-x.axisExtentOffset+\")\");var V=U.selectAll(\".axisExtentTopText\").data(i,n);V.enter().append(\"text\").classed(\"axisExtentTopText\",!0).attr(\"alignment-baseline\",\"after-edge\").call(y),V.text(function(t){return d(t)(t.domainScale.domain().slice(-1)[0])}).each(function(t){M.font(V,t.model.rangeFont)});var H=B.selectAll(\".axisExtentBottom\").data(i,n);H.enter().append(\"g\").classed(\"axisExtentBottom\",!0),H.attr(\"transform\",function(t){return\"translate(0,\"+(t.model.height+x.axisExtentOffset)+\")\"});var q=H.selectAll(\".axisExtentBottomText\").data(i,n);q.enter().append(\"text\").classed(\"axisExtentBottomText\",!0).attr(\"alignment-baseline\",\"before-edge\").call(y),q.text(function(t){return d(t)(t.domainScale.domain()[0])}).each(function(t){M.font(q,t.model.rangeFont)});var G=R.selectAll(\".axisBrush\").data(i,n),Y=G.enter().append(\"g\").classed(\"axisBrush\",!0);G.each(function(t){t.brush||(t.brush=w.svg.brush().y(t.unitScale).on(\"brushstart\",_).on(\"brush\",k).on(\"brushend\",A),0===t.filter[0]&&1===t.filter[1]||t.brush.extent(t.filter),w.select(this).call(t.brush))}),Y.selectAll(\"rect\").attr(\"x\",-x.bar.capturewidth/2).attr(\"width\",x.bar.capturewidth),Y.selectAll(\"rect.extent\").attr(\"fill\",\"url(#filterBarPattern)\").style(\"cursor\",\"ns-resize\").filter(function(t){return 0===t.filter[0]&&1===t.filter[1]}).attr(\"y\",-100),Y.selectAll(\".resize rect\").attr(\"height\",x.bar.handleheight).attr(\"opacity\",0).style(\"visibility\",\"visible\"),Y.selectAll(\".resize.n rect\").style(\"cursor\",\"n-resize\").attr(\"y\",x.bar.handleoverlap-x.bar.handleheight),Y.selectAll(\".resize.s rect\").style(\"cursor\",\"s-resize\").attr(\"y\",x.bar.handleoverlap);var X=!1,W=!1;return z}},{\"../../components/drawing\":627,\"../../lib\":725,\"./constants\":997,\"./lines\":1e3,d3:121}],1002:[function(t,e,r){\"use strict\";var n=t(\"./parcoords\");e.exports=function(t,e){var r=t._fullLayout,i=r._paper,a=r._paperdiv,o={},s={},l=r._size;e.forEach(function(e,r){o[r]=t.data[r].dimensions,s[r]=t.data[r].dimensions.slice()});var u=function(e,r,n){var i=s[e][r],a=i.constraintrange;a&&2===a.length||(a=i.constraintrange=[]),a[0]=n[0],a[1]=n[1],t.emit(\"plotly_restyle\")},c=function(e){t.emit(\"plotly_hover\",e)},h=function(e){t.emit(\"plotly_unhover\",e)},f=function(e,r){function n(t){return!(\"visible\"in t)||t.visible}function i(t,e,r){var n=e.indexOf(r),i=t.indexOf(n);return-1===i&&(i+=e.length),i}var a=function(t){return function(e,n){return i(r,t,e)-i(r,t,n)}}(s[e].filter(n));o[e].sort(a),s[e].filter(function(t){return!n(t)}).sort(function(t){return s[e].indexOf(t)}).forEach(function(t){o[e].splice(o[e].indexOf(t),1),o[e].splice(s[e].indexOf(t),0,t)}),t.emit(\"plotly_restyle\")};n(a,i,e,{width:l.w,height:l.h,margin:{t:l.t,r:l.r,b:l.b,l:l.l}},{filterChanged:u,hover:c,unhover:h,axesMoved:f})}},{\"./parcoords\":1001}],1003:[function(t,e,r){\"use strict\";var n=t(\"../../components/color/attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports={labels:{valType:\"data_array\"},label0:{valType:\"number\",dflt:0},dlabel:{valType:\"number\",dflt:1},values:{valType:\"data_array\"},marker:{colors:{valType:\"data_array\"},line:{color:{valType:\"color\",dflt:n.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:0,arrayOk:!0}}},text:{valType:\"data_array\"},hovertext:{valType:\"string\",dflt:\"\",arrayOk:!0},scalegroup:{valType:\"string\",dflt:\"\"},textinfo:{valType:\"flaglist\",flags:[\"label\",\"text\",\"value\",\"percent\"],extras:[\"none\"]},hoverinfo:o({},a.hoverinfo,{flags:[\"label\",\"text\",\"value\",\"percent\",\"name\"]}),textposition:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"auto\",\"none\"],dflt:\"auto\",arrayOk:!0},textfont:o({},i,{}),insidetextfont:o({},i,{}),outsidetextfont:o({},i,{}),domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},hole:{valType:\"number\",min:0,max:1,dflt:0},sort:{valType:\"boolean\",dflt:!0},direction:{valType:\"enumerated\",values:[\"clockwise\",\"counterclockwise\"],dflt:\"counterclockwise\"},rotation:{valType:\"number\",min:-360,max:360,dflt:0},pull:{valType:\"number\",min:0,max:1,dflt:0,arrayOk:!0}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/font_attributes\":790}],1004:[function(t,e,r){\"use strict\";function n(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n],a=i[0].trace;a._module===e&&!0===a.visible&&r.push(i)}return r}var i=t(\"../../registry\");r.name=\"pie\",r.plot=function(t){var e=i.getModule(\"pie\"),r=n(t.calcdata,e);r.length&&e.plot(t,r)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"pie\"),a=e._has&&e._has(\"pie\");i&&!a&&n._pielayer.selectAll(\"g.trace\").remove()}},{\"../../registry\":844}],1005:[function(t,e,r){\"use strict\";function n(t){if(!l){var e=o.defaults;l=e.slice();var r;for(r=0;r<e.length;r++)l.push(a(e[r]).lighten(20).toHexString());for(r=0;r<o.defaults.length;r++)l.push(a(e[r]).darken(20).toHexString())}return l[t%l.length]}var i=t(\"fast-isnumeric\"),a=t(\"tinycolor2\"),o=t(\"../../components/color\"),s=t(\"./helpers\");e.exports=function(t,e){var r,l,u,c,h,f,d=e.values,p=e.labels,m=[],v=t._fullLayout,g=v._piecolormap,y={},b=!1,x=0,_=v.hiddenlabels||[];if(e.dlabel)for(p=new Array(d.length),r=0;r<d.length;r++)p[r]=String(e.label0+r*e.dlabel);for(r=0;r<d.length;r++)l=d[r],i(l)&&((l=+l)<0||(u=p[r],void 0!==u&&\"\"!==u||(u=r),u=String(u),void 0===y[u]&&(y[u]=!0,c=a(e.marker.colors[r]),c.isValid()?(c=o.addOpacity(c,c.getAlpha()),g[u]||(g[u]=c)):g[u]?c=g[u]:(c=!1,b=!0),h=-1!==_.indexOf(u),h||(x+=l),m.push({v:l,label:u,color:c,i:r,hidden:h}))));if(e.sort&&m.sort(function(t,e){return e.v-t.v}),b)for(r=0;r<m.length;r++)f=m[r],!1===f.color&&(g[f.label]=f.color=n(v._piedefaultcolorcount),v._piedefaultcolorcount++);if(m[0]&&(m[0].vTotal=x),e.textinfo&&\"none\"!==e.textinfo){var w,M=-1!==e.textinfo.indexOf(\"label\"),k=-1!==e.textinfo.indexOf(\"text\"),A=-1!==e.textinfo.indexOf(\"value\"),T=-1!==e.textinfo.indexOf(\"percent\"),S=v.separators;for(r=0;r<m.length;r++)f=m[r],w=M?[f.label]:[],k&&e.text[f.i]&&w.push(e.text[f.i]),A&&w.push(s.formatPieValue(f.v,S)),T&&w.push(s.formatPiePercent(f.v/x,S)),f.text=w.join(\"<br>\")}return m};var l},{\"../../components/color\":603,\"./helpers\":1007,\"fast-isnumeric\":130,tinycolor2:533}],1006:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r,a){function o(r,a){return n.coerce(t,e,i,r,a)}var s=n.coerceFont,l=o(\"values\");if(!Array.isArray(l)||!l.length)return void(e.visible=!1);var u=o(\"labels\");Array.isArray(u)||(o(\"label0\"),o(\"dlabel\")),o(\"marker.line.width\")&&o(\"marker.line.color\");var c=o(\"marker.colors\");Array.isArray(c)||(e.marker.colors=[]),o(\"scalegroup\");var h=o(\"text\"),f=o(\"textinfo\",Array.isArray(h)?\"text+percent\":\"percent\");if(o(\"hovertext\"),f&&\"none\"!==f){var d=o(\"textposition\"),p=Array.isArray(d)||\"auto\"===d,m=p||\"inside\"===d,v=p||\"outside\"===d;if(m||v){var g=s(o,\"textfont\",a.font);m&&s(o,\"insidetextfont\",g),v&&s(o,\"outsidetextfont\",g)}}o(\"domain.x\"),o(\"domain.y\"),o(\"hole\"),o(\"sort\"),o(\"direction\"),o(\"rotation\"),o(\"pull\")}},{\"../../lib\":725,\"./attributes\":1003}],1007:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");r.formatPiePercent=function(t,e){var r=(100*t).toPrecision(3);return-1!==r.lastIndexOf(\".\")&&(r=r.replace(/[.]?0+$/,\"\")),n.numSeparate(r,e)+\"%\"},r.formatPieValue=function(t,e){var r=t.toPrecision(10);return-1!==r.lastIndexOf(\".\")&&(r=r.replace(/[.]?0+$/,\"\")),n.numSeparate(r,e)}},{\"../../lib\":725}],1008:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.layoutAttributes=t(\"./layout_attributes\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.styleOne=t(\"./style_one\"),n.moduleType=\"trace\",n.name=\"pie\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"pie\",\"showLegend\"],n.meta={},e.exports=n},{\"./attributes\":1003,\"./base_plot\":1004,\"./calc\":1005,\"./defaults\":1006,\"./layout_attributes\":1009,\"./layout_defaults\":1010,\"./plot\":1011,\"./style\":1012,\"./style_one\":1013}],1009:[function(t,e,r){\"use strict\";e.exports={hiddenlabels:{valType:\"data_array\"}}},{}],1010:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./layout_attributes\");e.exports=function(t,e){!function(r,a){n.coerce(t,e,i,r,a)}(\"hiddenlabels\")}},{\"../../lib\":725,\"./layout_attributes\":1009}],1011:[function(t,e,r){\"use strict\";function n(t,e,r){var n=Math.sqrt(t.width*t.width+t.height*t.height),a=t.width/t.height,o=Math.PI*Math.min(e.v/r.vTotal,.5),s=1-r.trace.hole,l=i(e,r),u={scale:l*r.r*2/n,rCenter:1-l,rotate:0};if(u.scale>=1)return u;var c=a+1/(2*Math.tan(o)),h=r.r*Math.min(1/(Math.sqrt(c*c+.5)+c),s/(Math.sqrt(a*a+s/2)+a)),f={scale:2*h/t.height,rCenter:Math.cos(h/r.r)-h*a/r.r,rotate:(180/Math.PI*e.midangle+720)%180-90},d=1/a,p=d+1/(2*Math.tan(o)),m=r.r*Math.min(1/(Math.sqrt(p*p+.5)+p),s/(Math.sqrt(d*d+s/2)+d)),v={scale:2*m/t.width,rCenter:Math.cos(m/r.r)-m/a/r.r,rotate:(180/Math.PI*e.midangle+810)%180-90},g=v.scale>f.scale?v:f;return u.scale<1&&g.scale>u.scale?g:u}function i(t,e){if(t.v===e.vTotal&&!e.trace.hole)return 1;var r=Math.PI*Math.min(t.v/e.vTotal,.5);return Math.min(1/(1+1/Math.sin(r)),(1-e.trace.hole)/2)}function a(t,e){var r=e.pxmid[0],n=e.pxmid[1],i=t.width/2,a=t.height/2;return r<0&&(i*=-1),n<0&&(a*=-1),{scale:1,rCenter:1,rotate:0,x:i+Math.abs(a)*(i>0?1:-1)/2,y:a/(1+r*r/(n*n)),outside:!0}}function o(t,e){function r(t,e){return t.pxmid[1]-e.pxmid[1]}function n(t,e){return e.pxmid[1]-t.pxmid[1]}var i,a,o,s,l,u,c,h,f,d,p,m,v;for(a=0;a<2;a++)for(o=a?r:n,l=a?Math.max:Math.min,c=a?1:-1,i=0;i<2;i++){for(s=i?Math.max:Math.min,u=i?1:-1,h=t[a][i],h.sort(o),f=t[1-a][i],d=f.concat(h),m=[],p=0;p<h.length;p++)void 0!==h[p].yLabelMid&&m.push(h[p]);for(v=!1,p=0;a&&p<f.length;p++)if(void 0!==f[p].yLabelMid){v=f[p];break}for(p=0;p<m.length;p++){var g=p&&m[p-1];v&&!p&&(g=v),function(t,r){r||(r={});var n,i,o,h,f,p,m=r.labelExtraY+(a?r.yLabelMax:r.yLabelMin),v=a?t.yLabelMin:t.yLabelMax,g=a?t.yLabelMax:t.yLabelMin,y=t.cyFinal+l(t.px0[1],t.px1[1]),b=m-v;if(b*c>0&&(t.labelExtraY=b),Array.isArray(e.pull))for(i=0;i<d.length;i++)(o=d[i])===t||(e.pull[t.i]||0)>=e.pull[o.i]||((t.pxmid[1]-o.pxmid[1])*c>0?(h=o.cyFinal+l(o.px0[1],o.px1[1]),(b=h-v-t.labelExtraY)*c>0&&(t.labelExtraY+=b)):(g+t.labelExtraY-y)*c>0&&(n=3*u*Math.abs(i-d.indexOf(t)),f=o.cxFinal+s(o.px0[0],o.px1[0]),(p=f+n-(t.cxFinal+t.pxmid[0])-t.labelExtraX)*u>0&&(t.labelExtraX+=p)))}(m[p],g)}}}function s(t,e){var r,n,i,a,o,s,l,c,h,f,d=[];for(i=0;i<t.length;i++){if(o=t[i][0],s=o.trace,r=e.w*(s.domain.x[1]-s.domain.x[0]),n=e.h*(s.domain.y[1]-s.domain.y[0]),l=s.tiltaxis*Math.PI/180,c=s.pull,Array.isArray(c))for(c=0,a=0;a<s.pull.length;a++)s.pull[a]>c&&(c=s.pull[a]);o.r=Math.min(r/u(s.tilt,Math.sin(l),s.depth),n/u(s.tilt,Math.cos(l),s.depth))/(2+2*c),o.cx=e.l+e.w*(s.domain.x[1]+s.domain.x[0])/2,o.cy=e.t+e.h*(2-s.domain.y[1]-s.domain.y[0])/2,s.scalegroup&&-1===d.indexOf(s.scalegroup)&&d.push(s.scalegroup)}for(a=0;a<d.length;a++){for(f=1/0,h=d[a],i=0;i<t.length;i++)o=t[i][0],o.trace.scalegroup===h&&(f=Math.min(f,o.r*o.r/o.vTotal));for(i=0;i<t.length;i++)o=t[i][0],o.trace.scalegroup===h&&(o.r=Math.sqrt(f*o.vTotal))}}function l(t){function e(t){var e=h.r*Math.sin(t),r=-h.r*Math.cos(t);return d?[e*(1-s*n*n)+r*o*s,e*o*s+r*(1-s*i*i),Math.sin(a)*(r*i-e*n)]:[e,r]}var r,n,i,a,o,s,l,u,c,h=t[0],f=h.trace,d=f.tilt,p=f.rotation*Math.PI/180,m=2*Math.PI/h.vTotal,v=\"px0\",g=\"px1\";if(\"counterclockwise\"===f.direction){for(l=0;l<t.length&&t[l].hidden;l++);if(l===t.length)return;p+=m*t[l].v,m*=-1,v=\"px1\",g=\"px0\"}for(d&&(a=d*Math.PI/180,r=f.tiltaxis*Math.PI/180,o=Math.sin(r)*Math.cos(r),s=1-Math.cos(a),n=Math.sin(r),i=Math.cos(r)),c=e(p),l=0;l<t.length;l++)u=t[l],u.hidden||(u[v]=c,p+=m*u.v/2,u.pxmid=e(p),u.midangle=p,p+=m*u.v/2,c=e(p),u[g]=c,u.largeArc=u.v>h.vTotal/2?1:0)}function u(t,e,r){if(!t)return 1;var n=Math.sin(t*Math.PI/180);return Math.max(.01,r*n*Math.abs(e)+2*Math.sqrt(1-n*n*e*e))}var c=t(\"d3\"),h=t(\"../../components/fx\"),f=t(\"../../components/color\"),d=t(\"../../components/drawing\"),p=t(\"../../lib/svg_text_utils\"),m=t(\"./helpers\");e.exports=function(t,e){var r=t._fullLayout;s(e,r._size);var u=r._pielayer.selectAll(\"g.trace\").data(e);u.enter().append(\"g\").attr({\"stroke-linejoin\":\"round\",class:\"trace\"}),u.exit().remove(),u.order(),u.each(function(e){\n",
       "var s=c.select(this),u=e[0],v=u.trace,g=(v.depth||0)*u.r*Math.sin(0)/2,y=v.tiltaxis||0,b=y*Math.PI/180,x=[g*Math.sin(b),g*Math.cos(b)],_=u.r*Math.cos(0),w=s.selectAll(\"g.part\").data(v.tilt?[\"top\",\"sides\"]:[\"top\"]);w.enter().append(\"g\").attr(\"class\",function(t){return t+\" part\"}),w.exit().remove(),w.order(),l(e),s.selectAll(\".top\").each(function(){var s=c.select(this).selectAll(\"g.slice\").data(e);s.enter().append(\"g\").classed(\"slice\",!0),s.exit().remove();var l=[[[],[]],[[],[]]],g=!1;s.each(function(e){function o(n){n.originalEvent=c.event;var a=t._fullLayout,o=t._fullData[v.index],s=h.castHoverinfo(o,a,e.i);if(\"all\"===s&&(s=\"label+text+value+percent+name\"),t._dragging||!1===a.hovermode||\"none\"===s||\"skip\"===s||!s)return void h.hover(t,n,\"pie\");var l=i(e,u),f=w+e.pxmid[0]*(1-l),d=M+e.pxmid[1]*(1-l),p=r.separators,g=[];-1!==s.indexOf(\"label\")&&g.push(e.label),-1!==s.indexOf(\"text\")&&(o.hovertext?g.push(Array.isArray(o.hovertext)?o.hovertext[e.i]:o.hovertext):o.text&&o.text[e.i]&&g.push(o.text[e.i])),-1!==s.indexOf(\"value\")&&g.push(m.formatPieValue(e.v,p)),-1!==s.indexOf(\"percent\")&&g.push(m.formatPiePercent(e.v/u.vTotal,p)),h.loneHover({x0:f-l*u.r,x1:f+l*u.r,y:d,text:g.join(\"<br>\"),name:-1!==s.indexOf(\"name\")?o.name:void 0,idealAlign:e.pxmid[0]<0?\"left\":\"right\",color:h.castHoverOption(v,e.i,\"bgcolor\")||e.color,borderColor:h.castHoverOption(v,e.i,\"bordercolor\"),fontFamily:h.castHoverOption(v,e.i,\"font.family\"),fontSize:h.castHoverOption(v,e.i,\"font.size\"),fontColor:h.castHoverOption(v,e.i,\"font.color\")},{container:a._hoverlayer.node(),outerContainer:a._paper.node(),gd:t}),h.hover(t,n,\"pie\"),T=!0}function s(e){e.originalEvent=c.event,t.emit(\"plotly_unhover\",{event:c.event,points:[e]}),T&&(h.loneUnhover(r._hoverlayer.node()),T=!1)}function f(){t._hoverdata=[e],t._hoverdata.trace=u.trace,h.click(t,c.event)}function b(t,r,n,i){return\"a\"+i*u.r+\",\"+i*_+\" \"+y+\" \"+e.largeArc+(n?\" 1 \":\" 0 \")+i*(r[0]-t[0])+\",\"+i*(r[1]-t[1])}if(e.hidden)return void c.select(this).selectAll(\"path,g\").remove();e.pointNumber=e.i,e.curveNumber=v.index,l[e.pxmid[1]<0?0:1][e.pxmid[0]<0?0:1].push(e);var w=u.cx+x[0],M=u.cy+x[1],k=c.select(this),A=k.selectAll(\"path.surface\").data([e]),T=!1;if(A.enter().append(\"path\").classed(\"surface\",!0).style({\"pointer-events\":\"all\"}),k.select(\"path.textline\").remove(),k.on(\"mouseover\",o).on(\"mouseout\",s).on(\"click\",f),v.pull){var S=+(Array.isArray(v.pull)?v.pull[e.i]:v.pull)||0;S>0&&(w+=S*e.pxmid[0],M+=S*e.pxmid[1])}e.cxFinal=w,e.cyFinal=M;var E=v.hole;if(e.v===u.vTotal){var L=\"M\"+(w+e.px0[0])+\",\"+(M+e.px0[1])+b(e.px0,e.pxmid,!0,1)+b(e.pxmid,e.px0,!0,1)+\"Z\";E?A.attr(\"d\",\"M\"+(w+E*e.px0[0])+\",\"+(M+E*e.px0[1])+b(e.px0,e.pxmid,!1,E)+b(e.pxmid,e.px0,!1,E)+\"Z\"+L):A.attr(\"d\",L)}else{var C=b(e.px0,e.px1,!0,1);if(E){var z=1-E;A.attr(\"d\",\"M\"+(w+E*e.px1[0])+\",\"+(M+E*e.px1[1])+b(e.px1,e.px0,!1,E)+\"l\"+z*e.px0[0]+\",\"+z*e.px0[1]+C+\"Z\")}else A.attr(\"d\",\"M\"+w+\",\"+M+\"l\"+e.px0[0]+\",\"+e.px0[1]+C+\"Z\")}var I=Array.isArray(v.textposition)?v.textposition[e.i]:v.textposition,D=k.selectAll(\"g.slicetext\").data(e.text&&\"none\"!==I?[0]:[]);D.enter().append(\"g\").classed(\"slicetext\",!0),D.exit().remove(),D.each(function(){var r=c.select(this).selectAll(\"text\").data([0]);r.enter().append(\"text\").attr(\"data-notex\",1),r.exit().remove(),r.text(e.text).attr({class:\"slicetext\",transform:\"\",\"text-anchor\":\"middle\"}).call(d.font,\"outside\"===I?v.outsidetextfont:v.insidetextfont).call(p.convertToTspans,t);var i,o=d.bBox(r.node());\"outside\"===I?i=a(o,e):(i=n(o,e,u),\"auto\"===I&&i.scale<1&&(r.call(d.font,v.outsidetextfont),v.outsidetextfont.family===v.insidetextfont.family&&v.outsidetextfont.size===v.insidetextfont.size||(o=d.bBox(r.node())),i=a(o,e)));var s=w+e.pxmid[0]*i.rCenter+(i.x||0),l=M+e.pxmid[1]*i.rCenter+(i.y||0);i.outside&&(e.yLabelMin=l-o.height/2,e.yLabelMid=l,e.yLabelMax=l+o.height/2,e.labelExtraX=0,e.labelExtraY=0,g=!0),r.attr(\"transform\",\"translate(\"+s+\",\"+l+\")\"+(i.scale<1?\"scale(\"+i.scale+\")\":\"\")+(i.rotate?\"rotate(\"+i.rotate+\")\":\"\")+\"translate(\"+-(o.left+o.right)/2+\",\"+-(o.top+o.bottom)/2+\")\")})}),g&&o(l,v),s.each(function(t){if(t.labelExtraX||t.labelExtraY){var e=c.select(this),r=e.select(\"g.slicetext text\");r.attr(\"transform\",\"translate(\"+t.labelExtraX+\",\"+t.labelExtraY+\")\"+r.attr(\"transform\"));var n=t.cxFinal+t.pxmid[0],i=t.cyFinal+t.pxmid[1],a=\"M\"+n+\",\"+i,o=(t.yLabelMax-t.yLabelMin)*(t.pxmid[0]<0?-1:1)/4;if(t.labelExtraX){var s=t.labelExtraX*t.pxmid[1]/t.pxmid[0],l=t.yLabelMid+t.labelExtraY-(t.cyFinal+t.pxmid[1]);Math.abs(s)>Math.abs(l)?a+=\"l\"+l*t.pxmid[0]/t.pxmid[1]+\",\"+l+\"H\"+(n+t.labelExtraX+o):a+=\"l\"+t.labelExtraX+\",\"+s+\"v\"+(l-s)+\"h\"+o}else a+=\"V\"+(t.yLabelMid+t.labelExtraY)+\"h\"+o;e.append(\"path\").classed(\"textline\",!0).call(f.stroke,v.outsidetextfont.color).attr({\"stroke-width\":Math.min(2,v.outsidetextfont.size/8),d:a,fill:\"none\"})}})})}),setTimeout(function(){u.selectAll(\"tspan\").each(function(){var t=c.select(this);t.attr(\"dy\")&&t.attr(\"dy\",t.attr(\"dy\"))})},0)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../lib/svg_text_utils\":745,\"./helpers\":1007,d3:121}],1012:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"./style_one\");e.exports=function(t){t._fullLayout._pielayer.selectAll(\".trace\").each(function(t){var e=t[0],r=e.trace,a=n.select(this);a.style({opacity:r.opacity}),a.selectAll(\".top path.surface\").each(function(t){n.select(this).call(i,t,r)})})}},{\"./style_one\":1013,d3:121}],1013:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\");e.exports=function(t,e,r){var i=r.marker.line.color;Array.isArray(i)&&(i=i[e.i]||n.defaultLine);var a=r.marker.line.width||0;Array.isArray(a)&&(a=a[e.i]||0),t.style({\"stroke-width\":a}).call(n.fill,e.color).call(n.stroke,i)}},{\"../../components/color\":603}],1014:[function(t,e,r){\"use strict\";var n=t(\"../scattergl/attributes\");e.exports={x:n.x,y:n.y,xy:{valType:\"data_array\"},indices:{valType:\"data_array\"},xbounds:{valType:\"data_array\"},ybounds:{valType:\"data_array\"},text:n.text,marker:{color:{valType:\"color\",arrayOk:!1},opacity:{valType:\"number\",min:0,max:1,dflt:1,arrayOk:!1},blend:{valType:\"boolean\",dflt:null},sizemin:{valType:\"number\",min:.1,max:2,dflt:.5},sizemax:{valType:\"number\",min:.1,dflt:20},border:{color:{valType:\"color\",arrayOk:!1},arearatio:{valType:\"number\",min:0,max:1,dflt:0}}}}},{\"../scattergl/attributes\":1071}],1015:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"pointcloud\",this.pickXData=[],this.pickYData=[],this.xData=[],this.yData=[],this.textLabels=[],this.color=\"rgb(0, 0, 0)\",this.name=\"\",this.hoverinfo=\"all\",this.idToIndex=new Int32Array(0),this.bounds=[0,0,0,0],this.pointcloudOptions={positions:new Float32Array(0),idToIndex:this.idToIndex,sizemin:.5,sizemax:12,color:[0,0,0,1],areaRatio:1,borderColor:[0,0,0,1]},this.pointcloud=a(t.glplot,this.pointcloudOptions),this.pointcloud._trace=this}function i(t,e){var r=new n(t,e.uid);return r.update(e),r}var a=t(\"gl-pointcloud2d\"),o=t(\"../../lib/str2rgbarray\"),s=t(\"../scatter/get_trace_color\"),l=[\"xaxis\",\"yaxis\"],u=n.prototype;u.handlePick=function(t){var e=this.idToIndex[t.pointId];return{trace:this,dataCoord:t.dataCoord,traceCoord:this.pickXYData?[this.pickXYData[2*e],this.pickXYData[2*e+1]]:[this.pickXData[e],this.pickYData[e]],textLabel:Array.isArray(this.textLabels)?this.textLabels[e]:this.textLabels,color:this.color,name:this.name,pointIndex:e,hoverinfo:this.hoverinfo}},u.update=function(t){this.index=t.index,this.textLabels=t.text,this.name=t.name,this.hoverinfo=t.hoverinfo,this.bounds=[1/0,1/0,-1/0,-1/0],this.updateFast(t),this.color=s(t,{})},u.updateFast=function(t){var e,r,n,i,a,s,l=this.xData=this.pickXData=t.x,u=this.yData=this.pickYData=t.y,c=this.pickXYData=t.xy,h=t.xbounds&&t.ybounds,f=t.indices,d=this.bounds;if(c){if(n=c,e=c.length>>>1,h)d[0]=t.xbounds[0],d[2]=t.xbounds[1],d[1]=t.ybounds[0],d[3]=t.ybounds[1];else for(s=0;s<e;s++)i=n[2*s],a=n[2*s+1],i<d[0]&&(d[0]=i),i>d[2]&&(d[2]=i),a<d[1]&&(d[1]=a),a>d[3]&&(d[3]=a);if(f)r=f;else for(r=new Int32Array(e),s=0;s<e;s++)r[s]=s}else for(e=l.length,n=new Float32Array(2*e),r=new Int32Array(e),s=0;s<e;s++)i=l[s],a=u[s],r[s]=s,n[2*s]=i,n[2*s+1]=a,i<d[0]&&(d[0]=i),i>d[2]&&(d[2]=i),a<d[1]&&(d[1]=a),a>d[3]&&(d[3]=a);this.idToIndex=r,this.pointcloudOptions.idToIndex=r,this.pointcloudOptions.positions=n;var p=o(t.marker.color),m=o(t.marker.border.color),v=t.opacity*t.marker.opacity;p[3]*=v,this.pointcloudOptions.color=p;var g=t.marker.blend;if(null===g){g=l.length<100||u.length<100}this.pointcloudOptions.blend=g,m[3]*=v,this.pointcloudOptions.borderColor=m;var y=t.marker.sizemin,b=Math.max(t.marker.sizemax,t.marker.sizemin);this.pointcloudOptions.sizeMin=y,this.pointcloudOptions.sizeMax=b,this.pointcloudOptions.areaRatio=t.marker.border.arearatio,this.pointcloud.update(this.pointcloudOptions),this.expandAxesFast(d,b/2)},u.expandAxesFast=function(t,e){for(var r,n,i,a=e||.5,o=0;o<2;o++)r=this.scene[l[o]],n=r._min,n||(n=[]),n.push({val:t[o],pad:a}),i=r._max,i||(i=[]),i.push({val:t[o+2],pad:a})},u.dispose=function(){this.pointcloud.dispose()},e.exports=i},{\"../../lib/str2rgbarray\":744,\"../scatter/get_trace_color\":1035,\"gl-pointcloud2d\":229}],1016:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){function a(r,a){return n.coerce(t,e,i,r,a)}a(\"x\"),a(\"y\"),a(\"xbounds\"),a(\"ybounds\"),t.xy&&t.xy instanceof Float32Array&&(e.xy=t.xy),t.indices&&t.indices instanceof Int32Array&&(e.indices=t.indices),a(\"text\"),a(\"marker.color\",r),a(\"marker.opacity\"),a(\"marker.blend\"),a(\"marker.sizemin\"),a(\"marker.sizemax\"),a(\"marker.border.color\",r),a(\"marker.border.arearatio\")}},{\"../../lib\":725,\"./attributes\":1014}],1017:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../scatter3d/calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"pointcloud\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../scatter3d/calc\":1051,\"./attributes\":1014,\"./convert\":1015,\"./defaults\":1016}],1018:[function(t,e,r){\"use strict\";var n=t(\"../../components/shapes/attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/attributes\"),o=t(\"../../components/color/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports={hoverinfo:s({},a.hoverinfo,{flags:[\"label\",\"text\",\"value\",\"percent\",\"name\"]}),domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"],dflt:\"h\"},valueformat:{valType:\"string\",dflt:\".3s\"},valuesuffix:{valType:\"string\",dflt:\"\"},arrangement:{valType:\"enumerated\",values:[\"snap\",\"perpendicular\",\"freeform\",\"fixed\"],dflt:\"snap\"},textfont:i,node:{label:{valType:\"data_array\",dflt:[]},color:s({},n.fillcolor,{arrayOk:!0}),line:{color:{valType:\"color\",dflt:o.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:.5,arrayOk:!0}},pad:{valType:\"number\",arrayOk:!1,min:0,dflt:20},thickness:{valType:\"number\",arrayOk:!1,min:1,dflt:20}},link:{label:{valType:\"data_array\",dflt:[]},color:s({},n.fillcolor,{arrayOk:!0}),line:{color:{valType:\"color\",dflt:o.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:0,arrayOk:!0}},source:{valType:\"data_array\",dflt:[]},target:{valType:\"data_array\",dflt:[]},value:{valType:\"data_array\",dflt:[]}}}},{\"../../components/color/attributes\":602,\"../../components/shapes/attributes\":679,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/font_attributes\":790}],1019:[function(t,e,r){\"use strict\";var n=t(\"../../plots/plots\"),i=t(\"./plot\");r.name=\"sankey\",r.attr=\"type\",r.plot=function(t){var e=n.getSubplotCalcData(t.calcdata,\"sankey\",\"sankey\");e.length&&i(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"sankey\"),a=e._has&&e._has(\"sankey\");i&&!a&&n._paperdiv.selectAll(\".sankey\").remove()}},{\"../../plots/plots\":829,\"./plot\":1024}],1020:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=t.map(function(){return[]}),a=0;a<Math.min(e.length,r.length);a++){if(e[a]===r[a])return!0;n[e[a]].push(r[a])}return i(n).components.some(function(t){return t.length>1})}var i=t(\"strongly-connected-components\"),a=t(\"../../lib\");e.exports=function(t,e){return n(e.node.label,e.link.source,e.link.target)&&(a.error(\"Circularity is present in the Sankey data. Removing all nodes and links.\"),e.link.label=[],e.link.source=[],e.link.target=[],e.link.value=[],e.link.color=[],e.node.label=[],e.node.color=[]),[{link:e.link,node:e.node}]}},{\"../../lib\":725,\"strongly-connected-components\":527}],1021:[function(t,e,r){\"use strict\";e.exports={nodeTextOffsetHorizontal:4,nodeTextOffsetVertical:3,nodePadAcross:10,sankeyIterations:50,forceIterations:5,forceTicksPerFrame:10,duration:500,ease:\"cubic-in-out\"}},{}],1022:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"../../components/color/attributes\").defaults,o=t(\"../../components/color\"),s=t(\"tinycolor2\");e.exports=function(t,e,r,l){function u(r,a){return n.coerce(t,e,i,r,a)}u(\"node.label\"),u(\"node.pad\"),u(\"node.thickness\"),u(\"node.line.color\"),u(\"node.line.width\");var c=function(t){return a[t%a.length]};u(\"node.color\",e.node.label.map(function(t,e){return o.addOpacity(c(e),.8)})),u(\"link.label\"),u(\"link.source\"),u(\"link.target\"),u(\"link.value\"),u(\"link.line.color\"),u(\"link.line.width\"),u(\"link.color\",e.link.value.map(function(){return s(l.paper_bgcolor).getLuminance()<.333?\"rgba(255, 255, 255, 0.6)\":\"rgba(0, 0, 0, 0.2)\"})),u(\"domain.x\"),u(\"domain.y\"),u(\"orientation\"),u(\"valueformat\"),u(\"valuesuffix\"),u(\"arrangement\"),n.coerceFont(u,\"textfont\",n.extendFlat({},l.font));var h=function(t,r){return-1===e.link.source.indexOf(r)&&-1===e.link.target.indexOf(r)};e.node.label.some(h)&&n.warn(\"Some of the nodes are neither sources nor targets, they will not be displayed.\")}},{\"../../components/color\":603,\"../../components/color/attributes\":602,\"../../lib\":725,\"./attributes\":1018,tinycolor2:533}],1023:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.moduleType=\"trace\",n.name=\"sankey\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"noOpacity\"],n.meta={},e.exports=n},{\"./attributes\":1018,\"./base_plot\":1019,\"./calc\":1020,\"./defaults\":1022,\"./plot\":1024}],1024:[function(t,e,r){\"use strict\";function n(t){return\"\"!==t}function i(t,e){return t.filter(function(t){return t.key===e.traceId})}function a(t,e){p.select(t).select(\"path\").style(\"fill-opacity\",e),p.select(t).select(\"rect\").style(\"fill-opacity\",e)}function o(t){p.select(t).select(\"text.name\").style(\"fill\",\"black\")}function s(t){return function(e){return-1!==t.node.sourceLinks.indexOf(e.link)||-1!==t.node.targetLinks.indexOf(e.link)}}function l(t){return function(e){return-1!==e.node.sourceLinks.indexOf(t.link)||-1!==e.node.targetLinks.indexOf(t.link)}}function u(t,e,r){e&&r&&i(r,e).selectAll(\".sankeyLink\").filter(s(e)).call(h.bind(0,e,r,!1))}function c(t,e,r){e&&r&&i(r,e).selectAll(\".sankeyLink\").filter(s(e)).call(f.bind(0,e,r,!1))}function h(t,e,r,n){var a=n.datum().link.label;n.style(\"fill-opacity\",.4),a&&i(e,t).selectAll(\".sankeyLink\").filter(function(t){return t.link.label===a}).style(\"fill-opacity\",.4),r&&i(e,t).selectAll(\".sankeyNode\").filter(l(t)).call(u)}function f(t,e,r,n){var a=n.datum().link.label;n.style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),a&&i(e,t).selectAll(\".sankeyLink\").filter(function(t){return t.link.label===a}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),r&&i(e,t).selectAll(\".sankeyNode\").filter(l(t)).call(c)}function d(t,e){var r=t.hoverlabel||{},n=y.nestedProperty(r,e).get();return!Array.isArray(n)&&n}var p=t(\"d3\"),m=t(\"./render\"),v=t(\"../../components/fx\"),g=t(\"../../components/color\"),y=t(\"../../lib\");e.exports=function(t,e){var r=t._fullLayout,i=r._paper,s=r._size,l=function(e,r){var n=r.link;n.originalEvent=p.event,t._hoverdata=[n],v.click(t,{target:!0})},y=function(e,r,n){var i=r.link;i.originalEvent=p.event,p.select(e).call(h.bind(0,r,n,!0)),v.hover(t,i,\"sankey\")},b=function(e,i){var s=i.link.trace,l=t.getBoundingClientRect(),u=e.getBoundingClientRect(),c=u.left+u.width/2,h=u.top+u.height/2,f=v.loneHover({x:c-l.left,y:h-l.top,name:p.format(i.valueFormat)(i.link.value)+i.valueSuffix,text:[i.link.label,[\"Source:\",i.link.source.label].join(\" \"),[\"Target:\",i.link.target.label].join(\" \")].filter(n).join(\"<br>\"),color:d(s,\"bgcolor\")||g.addOpacity(i.tinyColorHue,1),borderColor:d(s,\"bordercolor\"),fontFamily:d(s,\"font.family\"),fontSize:d(s,\"font.size\"),fontColor:d(s,\"font.color\"),idealAlign:p.event.x<c?\"right\":\"left\"},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t});a(f,.65),o(f)},x=function(e,n,i){p.select(e).call(f.bind(0,n,i,!0)),t.emit(\"plotly_unhover\",{event:p.event,points:[n.link]}),v.loneUnhover(r._hoverlayer.node())},_=function(e,r,n){var i=r.node;i.originalEvent=p.event,t._hoverdata=[i],p.select(e).call(c,r,n),v.click(t,{target:!0})},w=function(e,r,n){var i=r.node;i.originalEvent=p.event,p.select(e).call(u,r,n),v.hover(t,i,\"sankey\")},M=function(e,i){var s=i.node.trace,l=p.select(e).select(\".nodeRect\"),u=t.getBoundingClientRect(),c=l.node().getBoundingClientRect(),h=c.left-2-u.left,f=c.right+2-u.left,m=c.top+c.height/4-u.top,g=v.loneHover({x0:h,x1:f,y:m,name:p.format(i.valueFormat)(i.node.value)+i.valueSuffix,text:[i.node.label,[\"Incoming flow count:\",i.node.targetLinks.length].join(\" \"),[\"Outgoing flow count:\",i.node.sourceLinks.length].join(\" \")].filter(n).join(\"<br>\"),color:d(s,\"bgcolor\")||i.tinyColorHue,borderColor:d(s,\"bordercolor\"),fontFamily:d(s,\"font.family\"),fontSize:d(s,\"font.size\"),fontColor:d(s,\"font.color\"),idealAlign:\"left\"},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t});a(g,.85),o(g)},k=function(e,n,i){p.select(e).call(c,n,i),t.emit(\"plotly_unhover\",{event:p.event,points:[n.node]}),v.loneUnhover(r._hoverlayer.node())};m(i,e,{width:s.w,height:s.h,margin:{t:s.t,r:s.r,b:s.b,l:s.l}},{linkEvents:{hover:y,follow:b,unhover:x,select:l},nodeEvents:{hover:w,follow:M,unhover:k,select:_}})}},{\"../../components/color\":603,\"../../components/fx\":644,\"../../lib\":725,\"./render\":1025,d3:121}],1025:[function(t,e,r){\"use strict\";function n(t){return t.key}function i(t){return[t]}function a(t){return t[0]}function o(t){var e,r=[];for(e=0;e<t.length;e++)t[e].originalX=t[e].x,t[e].originalY=t[e].y,-1===r.indexOf(t[e].x)&&r.push(t[e].x);for(r.sort(function(t,e){return t-e}),e=0;e<t.length;e++)t[e].originalLayerIndex=r.indexOf(t[e].originalX),t[e].originalLayer=t[e].originalLayerIndex/(r.length-1)}function s(t){t.lastDraggedX=t.x,t.lastDraggedY=t.y}function l(t){return function(e){return e.node.originalX===t.node.originalX}}function u(t){for(var e=0;e<t.length;e++)t[e].y=t[e].y+t[e].dy/2}function c(t){for(var e=0;e<t.length;e++)t[e].y=t[e].y-t[e].dy/2}function h(t,e,r){for(var n,i=a(e).trace,o=i.domain,s=i.node,l=i.link,c=i.arrangement,h=\"h\"===i.orientation,f=i.node.pad,d=i.node.thickness,p=i.node.line.color,m=i.node.line.width,v=i.link.line.color,g=i.link.line.width,y=i.valueformat,b=i.valuesuffix,x=i.textfont,_=t.width*(o.x[1]-o.x[0]),w=t.height*(o.y[1]-o.y[0]),M=s.label.map(function(t,e){return{pointNumber:e,label:t,color:B.isArray(s.color)?s.color[e]:s.color}}),k=l.value.map(function(t,e){return{pointNumber:e,label:l.label[e],color:B.isArray(l.color)?l.color[e]:l.color,source:l.source[e],target:l.target[e],value:t}}),A=j().size(h?[_,w]:[w,_]).nodeWidth(d).nodePadding(f).nodes(M).links(k).layout(D.sankeyIterations),T=A.nodes(),S=0;S<T.length;S++)n=T[S],n.width=_,n.height=w;return u(M),{key:r,trace:i,guid:Math.floor(1e12*(1+Math.random())),horizontal:h,width:_,height:w,nodePad:f,nodeLineColor:p,nodeLineWidth:m,linkLineColor:v,linkLineWidth:g,valueFormat:y,valueSuffix:b,textFont:x,translateX:o.x[0]*_+t.margin.l,translateY:t.height-o.y[1]*t.height+t.margin.t,dragParallel:h?w:_,dragPerpendicular:h?_:w,nodes:M,links:k,arrangement:c,sankey:A,forceLayouts:{},interactionState:{dragInProgress:!1,hovered:!1}}}function f(t,e,r){var n=O(r.color),i=r.source.label+\"|\"+r.target.label,a=t[i];t[i]=(a||0)+1;var o=i+\"__\"+t[i];return r.trace=e.trace,r.curveNumber=e.trace.index,{key:o,traceId:e.key,link:r,tinyColorHue:R.tinyRGB(n),tinyColorAlpha:n.getAlpha(),linkLineColor:e.linkLineColor,linkLineWidth:e.linkLineWidth,valueFormat:e.valueFormat,valueSuffix:e.valueSuffix,sankey:e.sankey,interactionState:e.interactionState}}function d(t,e,r){var n=O(r.color),i=D.nodePadAcross,a=e.nodePad/2,o=r.dx+.5,s=r.dy-.5,l=r.label,u=t[l];t[l]=(u||0)+1;var c=l+\"__\"+t[l];return r.trace=e.trace,r.curveNumber=e.trace.index,{key:c,traceId:e.key,node:r,nodePad:e.nodePad,nodeLineColor:e.nodeLineColor,nodeLineWidth:e.nodeLineWidth,textFont:e.textFont,size:e.horizontal?e.height:e.width,visibleWidth:Math.ceil(o),visibleHeight:Math.ceil(s),zoneX:-i,zoneY:-a,zoneWidth:o+2*i,zoneHeight:s+2*a,labelY:e.horizontal?r.dy/2+1:r.dx/2+1,left:1===r.originalLayer,sizeAcross:e.width,forceLayouts:e.forceLayouts,horizontal:e.horizontal,darkBackground:n.getBrightness()<=128,tinyColorHue:R.tinyRGB(n),tinyColorAlpha:n.getAlpha(),valueFormat:e.valueFormat,valueSuffix:e.valueSuffix,sankey:e.sankey,arrangement:e.arrangement,uniqueNodeLabelPathId:[e.guid,e.key,c].join(\" \"),interactionState:e.interactionState}}function p(t){P.select(t.node().parentNode).style(\"shape-rendering\",\"crispEdges\")}function m(t){t.attr(\"transform\",function(t){return\"translate(\"+(t.node.x-.5)+\", \"+(t.node.y-t.node.dy/2+.5)+\")\"})}function v(t){var e=t.sankey.nodes();c(e);var r=t.sankey.link()(t.link);return u(e),r}function g(t){P.select(t.node().parentNode).style(\"shape-rendering\",\"optimizeSpeed\"),t.call(m)}function y(t,e){t.call(g),e.attr(\"d\",v)}function b(t){t.attr(\"width\",function(t){return t.visibleWidth}).attr(\"height\",function(t){return t.visibleHeight})}function x(t){return t.link.dy>1||t.linkLineWidth>0}function _(t){return\"translate(\"+t.translateX+\",\"+t.translateY+\")\"+(t.horizontal?\"matrix(1 0 0 1 0 0)\":\"matrix(0 1 1 0 0 0)\")}function w(t){return\"translate(\"+(t.horizontal?0:t.labelY)+\" \"+(t.horizontal?t.labelY:0)+\")\"}function M(t){return P.svg.line()([[t.horizontal?t.left?-t.sizeAcross:t.visibleWidth+D.nodeTextOffsetHorizontal:D.nodeTextOffsetHorizontal,0],[t.horizontal?t.left?-D.nodeTextOffsetHorizontal:t.sizeAcross:t.visibleHeight-D.nodeTextOffsetHorizontal,0]])}function k(t){return t.horizontal?\"matrix(1 0 0 1 0 0)\":\"matrix(0 1 1 0 0 0)\"}function A(t){return t.horizontal?\"scale(1 1)\":\"scale(-1 1)\"}function T(t){return t.darkBackground&&!t.horizontal?\"rgb(255,255,255)\":\"rgb(0,0,0)\"}function S(t){return t.horizontal&&t.left?\"100%\":\"0%\"}function E(t,e,r){t.on(\".basic\",null).on(\"mouseover.basic\",function(t){t.interactionState.dragInProgress||(r.hover(this,t,e),t.interactionState.hovered=[this,t])}).on(\"mousemove.basic\",function(t){t.interactionState.dragInProgress||(r.follow(this,t),t.interactionState.hovered=[this,t])}).on(\"mouseout.basic\",function(t){t.interactionState.dragInProgress||(r.unhover(this,t,e),t.interactionState.hovered=!1)}).on(\"click.basic\",function(t){t.interactionState.hovered&&(r.unhover(this,t,e),t.interactionState.hovered=!1),t.interactionState.dragInProgress||r.select(this,t,e)})}function L(t,e,r){var n=P.behavior.drag().origin(function(t){return t.node}).on(\"dragstart\",function(n){if(\"fixed\"!==n.arrangement&&(this.parentNode.appendChild(this),n.interactionState.dragInProgress=n.node,s(n.node),n.interactionState.hovered&&(r.nodeEvents.unhover.apply(0,n.interactionState.hovered),n.interactionState.hovered=!1),\"snap\"===n.arrangement)){var i=n.traceId+\"|\"+Math.floor(n.node.originalX);n.forceLayouts[i]?n.forceLayouts[i].alpha(1):C(t,i,n),z(t,e,n,i)}}).on(\"drag\",function(r){if(\"fixed\"!==r.arrangement){var n=P.event.x,i=P.event.y;\"snap\"===r.arrangement?(r.node.x=n,r.node.y=i):(\"freeform\"===r.arrangement&&(r.node.x=n),r.node.y=Math.max(r.node.dy/2,Math.min(r.size-r.node.dy/2,i))),s(r.node),\"snap\"!==r.arrangement&&(r.sankey.relayout(),y(t.filter(l(r)),e),t.call(p))}}).on(\"dragend\",function(t){t.interactionState.dragInProgress=!1});t.on(\".drag\",null).call(n)}function C(t,e,r){var n=r.sankey.nodes().filter(function(t){return t.originalX===r.node.originalX});r.forceLayouts[e]=N.forceSimulation(n).alphaDecay(0).force(\"collide\",N.forceCollide().radius(function(t){return t.dy/2+r.nodePad/2}).strength(1).iterations(D.forceIterations)).force(\"constrain\",I(t,e,n,r)).stop()}function z(t,e,r,n){window.requestAnimationFrame(function i(){for(var a=0;a<D.forceTicksPerFrame;a++)r.forceLayouts[n].tick();r.sankey.relayout(),y(t.filter(l(r)),e),r.forceLayouts[n].alpha()>0&&window.requestAnimationFrame(i)})}function I(t,e,r,n){return function(){for(var i=0,a=0;a<r.length;a++){var o=r[a];o===n.interactionState.dragInProgress?(o.x=o.lastDraggedX,o.y=o.lastDraggedY):(o.vx=(o.originalX-o.x)/D.forceTicksPerFrame,o.y=Math.min(n.size-o.dy/2,Math.max(o.dy/2,o.y))),i=Math.max(i,Math.abs(o.vx),Math.abs(o.vy))}!n.interactionState.dragInProgress&&i<.1&&n.forceLayouts[e].alpha()>0&&(n.forceLayouts[e].alpha(0),window.setTimeout(function(){t.call(p)},30))}}var D=t(\"./constants\"),P=t(\"d3\"),O=t(\"tinycolor2\"),R=t(\"../../components/color\"),F=t(\"../../components/drawing\"),j=t(\"@plotly/d3-sankey\").sankey,N=t(\"d3-force\"),B=t(\"../../lib\");e.exports=function(t,e,r,s){var l=t.selectAll(\".sankey\").data(e.filter(function(t){return a(t).trace.visible}).map(h.bind(null,r)),n);l.exit().remove(),l.enter().append(\"g\").classed(\"sankey\",!0).style(\"box-sizing\",\"content-box\").style(\"position\",\"absolute\").style(\"left\",0).style(\"shape-rendering\",\"geometricPrecision\").style(\"pointer-events\",\"auto\").style(\"box-sizing\",\"content-box\").attr(\"transform\",_),l.transition().ease(D.ease).duration(D.duration).attr(\"transform\",_);var u=l.selectAll(\".sankeyLinks\").data(i,n);u.enter().append(\"g\").classed(\"sankeyLinks\",!0).style(\"fill\",\"none\");var c=u.selectAll(\".sankeyLink\").data(function(t){var e={};return t.sankey.links().filter(function(t){return t.value}).map(f.bind(null,e,t))},n);c.enter().append(\"path\").classed(\"sankeyLink\",!0).attr(\"d\",v).call(E,l,s.linkEvents),c.style(\"stroke\",function(t){return x(t)?R.tinyRGB(O(t.linkLineColor)):t.tinyColorHue}).style(\"stroke-opacity\",function(t){return x(t)?R.opacity(t.linkLineColor):t.tinyColorAlpha}).style(\"stroke-width\",function(t){return x(t)?t.linkLineWidth:1}).style(\"fill\",function(t){return t.tinyColorHue}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),c.transition().ease(D.ease).duration(D.duration).attr(\"d\",v),c.exit().transition().ease(D.ease).duration(D.duration).style(\"opacity\",0).remove();var p=l.selectAll(\".sankeyNodeSet\").data(i,n);p.enter().append(\"g\").style(\"shape-rendering\",\"geometricPrecision\").classed(\"sankeyNodeSet\",!0),p.style(\"cursor\",function(t){switch(t.arrangement){case\"fixed\":return\"default\";case\"perpendicular\":return\"ns-resize\";default:return\"move\"}});var g=p.selectAll(\".sankeyNode\").data(function(t){var e=t.sankey.nodes(),r={};return o(e),e.filter(function(t){return t.value}).map(d.bind(null,r,t))},n);g.enter().append(\"g\").classed(\"sankeyNode\",!0).call(m).call(E,l,s.nodeEvents),g.call(L,c,s),g.transition().ease(D.ease).duration(D.duration).call(m),g.exit().transition().ease(D.ease).duration(D.duration).style(\"opacity\",0).remove();var y=g.selectAll(\".nodeRect\").data(i);y.enter().append(\"rect\").classed(\"nodeRect\",!0).call(b),y.style(\"stroke-width\",function(t){return t.nodeLineWidth}).style(\"stroke\",function(t){return R.tinyRGB(O(t.nodeLineColor))}).style(\"stroke-opacity\",function(t){return R.opacity(t.nodeLineColor)}).style(\"fill\",function(t){return t.tinyColorHue}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),y.transition().ease(D.ease).duration(D.duration).call(b);var C=g.selectAll(\".nodeCapture\").data(i);C.enter().append(\"rect\").classed(\"nodeCapture\",!0).style(\"fill-opacity\",0),C.attr(\"x\",function(t){return t.zoneX}).attr(\"y\",function(t){return t.zoneY}).attr(\"width\",function(t){return t.zoneWidth}).attr(\"height\",function(t){return t.zoneHeight});var z=g.selectAll(\".nodeCentered\").data(i);z.enter().append(\"g\").classed(\"nodeCentered\",!0).attr(\"transform\",w),z.transition().ease(D.ease).duration(D.duration).attr(\"transform\",w);var I=z.selectAll(\".nodeLabelGuide\").data(i);I.enter().append(\"path\").classed(\"nodeLabelGuide\",!0).attr(\"id\",function(t){return t.uniqueNodeLabelPathId}).attr(\"d\",M).attr(\"transform\",k),I.transition().ease(D.ease).duration(D.duration).attr(\"d\",M).attr(\"transform\",k);var P=z.selectAll(\".nodeLabel\").data(i);P.enter().append(\"text\").classed(\"nodeLabel\",!0).attr(\"transform\",A).style(\"user-select\",\"none\").style(\"cursor\",\"default\").style(\"fill\",\"black\"),P.style(\"text-shadow\",function(t){return t.horizontal?\"-1px 1px 1px #fff, 1px 1px 1px #fff, 1px -1px 1px #fff, -1px -1px 1px #fff\":\"none\"}).each(function(t){F.font(P,t.textFont)}),P.transition().ease(D.ease).duration(D.duration).attr(\"transform\",A);var j=P.selectAll(\".nodeLabelTextPath\").data(i);j.enter().append(\"textPath\").classed(\"nodeLabelTextPath\",!0).attr(\"alignment-baseline\",\"middle\").attr(\"xlink:href\",function(t){return\"#\"+t.uniqueNodeLabelPathId}).attr(\"startOffset\",S).style(\"fill\",T),j.text(function(t){return t.horizontal||t.node.dy>5?t.node.label:\"\"}).attr(\"text-anchor\",function(t){return t.horizontal&&t.left?\"end\":\"start\"}),j.transition().ease(D.ease).duration(D.duration).attr(\"startOffset\",S).style(\"fill\",T)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../lib\":725,\"./constants\":1021,\"@plotly/d3-sankey\":37,d3:121,\"d3-force\":117,tinycolor2:533}],1026:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){for(var r=0;r<t.length;r++)t[r].i=r;n.mergeArray(e.text,t,\"tx\"),n.mergeArray(e.hovertext,t,\"htx\"),n.mergeArray(e.customdata,t,\"data\"),n.mergeArray(e.textposition,t,\"tp\"),e.textfont&&(n.mergeArray(e.textfont.size,t,\"ts\"),n.mergeArray(e.textfont.color,t,\"tc\"),n.mergeArray(e.textfont.family,t,\"tf\"));var i=e.marker;if(i){n.mergeArray(i.size,t,\"ms\"),n.mergeArray(i.opacity,t,\"mo\"),n.mergeArray(i.symbol,t,\"mx\"),n.mergeArray(i.color,t,\"mc\");var a=i.line;i.line&&(n.mergeArray(a.color,t,\"mlc\"),n.mergeArray(a.width,t,\"mlw\"));var o=i.gradient;o&&\"none\"!==o.type&&(n.mergeArray(o.type,t,\"mgt\"),n.mergeArray(o.color,t,\"mgc\"))}}},{\"../../lib\":725}],1027:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/color_attributes\"),i=t(\"../../components/errorbars/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../components/drawing/attributes\").dash,s=t(\"../../components/drawing\"),l=(t(\"./constants\"),t(\"../../lib/extend\").extendFlat);e.exports={x:{valType:\"data_array\"},x0:{valType:\"any\",dflt:0},dx:{valType:\"number\",dflt:1},y:{valType:\"data_array\"},y0:{valType:\"any\",dflt:0},dy:{valType:\"number\",dflt:1},text:{valType:\"string\",dflt:\"\",arrayOk:!0},hovertext:{valType:\"string\",dflt:\"\",arrayOk:!0},mode:{valType:\"flaglist\",flags:[\"lines\",\"markers\",\"text\"],extras:[\"none\"]},hoveron:{valType:\"flaglist\",flags:[\"points\",\"fills\"]},line:{color:{valType:\"color\"},width:{valType:\"number\",min:0,dflt:2},shape:{valType:\"enumerated\",values:[\"linear\",\"spline\",\"hv\",\"vh\",\"hvh\",\"vhv\"],dflt:\"linear\"},smoothing:{valType:\"number\",min:0,max:1.3,dflt:1},dash:o,simplify:{valType:\"boolean\",dflt:!0}},connectgaps:{valType:\"boolean\",dflt:!1},cliponaxis:{valType:\"boolean\",dflt:!0,editType:\"doplot\"},fill:{valType:\"enumerated\",values:[\"none\",\"tozeroy\",\"tozerox\",\"tonexty\",\"tonextx\",\"toself\",\"tonext\"],dflt:\"none\"},fillcolor:{valType:\"color\"},marker:l({},{symbol:{valType:\"enumerated\",values:s.symbolList,dflt:\"circle\",arrayOk:!0},opacity:{valType:\"number\",min:0,max:1,arrayOk:!0},size:{valType:\"number\",min:0,dflt:6,arrayOk:!0},maxdisplayed:{valType:\"number\",min:0,dflt:0},sizeref:{valType:\"number\",dflt:1},sizemin:{valType:\"number\",min:0,dflt:0},sizemode:{valType:\"enumerated\",values:[\"diameter\",\"area\"],dflt:\"diameter\"},showscale:{valType:\"boolean\",dflt:!1},colorbar:a,line:l({},{width:{valType:\"number\",min:0,arrayOk:!0}},n(\"marker.line\")),gradient:{type:{valType:\"enumerated\",\n",
       "values:[\"radial\",\"horizontal\",\"vertical\",\"none\"],arrayOk:!0,dflt:\"none\"},color:{valType:\"color\",arrayOk:!0}}},n(\"marker\")),textposition:{valType:\"enumerated\",values:[\"top left\",\"top center\",\"top right\",\"middle left\",\"middle center\",\"middle right\",\"bottom left\",\"bottom center\",\"bottom right\"],dflt:\"middle center\",arrayOk:!0},textfont:{family:{valType:\"string\",noBlank:!0,strict:!0,arrayOk:!0},size:{valType:\"number\",min:1,arrayOk:!0},color:{valType:\"color\",arrayOk:!0}},r:{valType:\"data_array\"},t:{valType:\"data_array\"},error_y:i,error_x:i}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/drawing\":627,\"../../components/drawing/attributes\":626,\"../../components/errorbars/attributes\":629,\"../../lib/extend\":716,\"./constants\":1032}],1028:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../constants/numerical\").BADNUM,o=t(\"./subtypes\"),s=t(\"./colorscale_calc\"),l=t(\"./arrays_to_calcdata\");e.exports=function(t,e){var r,u,c,h=i.getFromId(t,e.xaxis||\"x\"),f=i.getFromId(t,e.yaxis||\"y\"),d=h.makeCalcdata(e,\"x\"),p=f.makeCalcdata(e,\"y\"),m=Math.min(d.length,p.length);h._minDtick=0,f._minDtick=0,d.length>m&&d.splice(m,d.length-m),p.length>m&&p.splice(m,p.length-m);var v={padded:!0},g={padded:!0};if(o.hasMarkers(e)){if(r=e.marker,u=r.size,Array.isArray(u)){var y={type:\"linear\"};i.setConvert(y),u=y.makeCalcdata(e.marker,\"size\"),u.length>m&&u.splice(m,u.length-m)}var b,x=1.6*(e.marker.sizeref||1);b=\"area\"===e.marker.sizemode?function(t){return Math.max(Math.sqrt((t||0)/x),3)}:function(t){return Math.max((t||0)/x,3)},v.ppad=g.ppad=Array.isArray(u)?u.map(b):b(u)}s(e),!(\"tozerox\"===e.fill||\"tonextx\"===e.fill&&t.firstscatter)||d[0]===d[m-1]&&p[0]===p[m-1]?e.error_y.visible||-1===[\"tonexty\",\"tozeroy\"].indexOf(e.fill)&&(o.hasMarkers(e)||o.hasText(e))||(v.padded=!1,v.ppad=0):v.tozero=!0,!(\"tozeroy\"===e.fill||\"tonexty\"===e.fill&&t.firstscatter)||d[0]===d[m-1]&&p[0]===p[m-1]?-1!==[\"tonextx\",\"tozerox\"].indexOf(e.fill)&&(g.padded=!1):g.tozero=!0,i.expand(h,d,v),i.expand(f,p,g);var _=new Array(m);for(c=0;c<m;c++)_[c]=n(d[c])&&n(p[c])?{x:d[c],y:p[c]}:{x:a,y:a},e.ids&&(_[c].id=String(e.ids[c]));return l(_,e),t.firstscatter=!1,_}},{\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"./arrays_to_calcdata\":1026,\"./colorscale_calc\":1031,\"./subtypes\":1047,\"fast-isnumeric\":130}],1029:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=0;e<t.length;e++){var r=t[e];if(\"scatter\"===r.type){var n=r.fill;if(\"none\"!==n&&\"toself\"!==n&&(r.opacity=void 0,\"tonexty\"===n||\"tonextx\"===n))for(var i=e-1;i>=0;i--){var a=t[i];if(\"scatter\"===a.type&&a.xaxis===r.xaxis&&a.yaxis===r.yaxis){a.opacity=void 0;break}}}}}},{}],1030:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=r.marker,u=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+u).remove(),void 0===l||!l.showscale)return void a.autoMargin(t,u);var c=l.color,h=l.cmin,f=l.cmax;n(h)||(h=i.aggNums(Math.min,null,c)),n(f)||(f=i.aggNums(Math.max,null,c));var d=e[0].t.cb=s(t,u),p=o.makeColorScaleFunc(o.extractScale(l.colorscale,h,f),{noNumericCheck:!0});d.fillcolor(p).filllevels({start:h,end:f,size:(f-h)/254}).options(l.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],1031:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/calc\"),a=t(\"./subtypes\");e.exports=function(t){a.hasLines(t)&&n(t,\"line\")&&i(t,t.line.color,\"line\",\"c\"),a.hasMarkers(t)&&(n(t,\"marker\")&&i(t,t.marker.color,\"marker\",\"c\"),n(t,\"marker.line\")&&i(t,t.marker.line.color,\"marker.line\",\"c\"))}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"./subtypes\":1047}],1032:[function(t,e,r){\"use strict\";e.exports={PTS_LINESONLY:20}},{}],1033:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"./constants\"),o=t(\"./subtypes\"),s=t(\"./xy_defaults\"),l=t(\"./marker_defaults\"),u=t(\"./line_defaults\"),c=t(\"./line_shape_defaults\"),h=t(\"./text_defaults\"),f=t(\"./fillcolor_defaults\"),d=t(\"../../components/errorbars/defaults\");e.exports=function(t,e,r,p){function m(r,a){return n.coerce(t,e,i,r,a)}var v=s(t,e,p,m),g=v<a.PTS_LINESONLY?\"lines+markers\":\"lines\";if(!v)return void(e.visible=!1);m(\"text\"),m(\"hovertext\"),m(\"mode\",g),o.hasLines(e)&&(u(t,e,r,p,m),c(t,e,m),m(\"connectgaps\"),m(\"line.simplify\")),o.hasMarkers(e)&&l(t,e,r,p,m,{gradient:!0}),o.hasText(e)&&h(t,e,p,m);var y=[];(o.hasMarkers(e)||o.hasText(e))&&(m(\"marker.maxdisplayed\"),y.push(\"points\")),m(\"fill\"),\"none\"!==e.fill&&(f(t,e,r,m),o.hasLines(e)||c(t,e,m)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||y.push(\"fills\"),m(\"hoveron\",y.join(\"+\")||\"points\"),d(t,e,r,{axis:\"y\"}),d(t,e,r,{axis:\"x\",inherit:\"y\"}),m(\"cliponaxis\")}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"./attributes\":1027,\"./constants\":1032,\"./fillcolor_defaults\":1034,\"./line_defaults\":1038,\"./line_shape_defaults\":1040,\"./marker_defaults\":1043,\"./subtypes\":1047,\"./text_defaults\":1048,\"./xy_defaults\":1049}],1034:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\");e.exports=function(t,e,r,i){var a=!1;if(e.marker){var o=e.marker.color,s=(e.marker.line||{}).color;o&&!Array.isArray(o)?a=o:s&&!Array.isArray(s)&&(a=s)}i(\"fillcolor\",n.addOpacity((e.line||{}).color||a||r,.5))}},{\"../../components/color\":603}],1035:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"./subtypes\");e.exports=function(t,e){var r,a;if(\"lines\"===t.mode)return r=t.line.color,r&&n.opacity(r)?r:t.fillcolor;if(\"none\"===t.mode)return t.fill?t.fillcolor:\"\";var o=e.mcc||(t.marker||{}).color,s=e.mlcc||((t.marker||{}).line||{}).color;return a=o&&n.opacity(o)?o:s&&n.opacity(s)&&(e.mlw||((t.marker||{}).line||{}).width)?s:\"\",a?n.opacity(a)<.3?n.addOpacity(a,.3):a:(r=(t.line||{}).color,r&&n.opacity(r)&&i.hasLines(t)&&t.line.width?r:t.fillcolor)}},{\"../../components/color\":603,\"./subtypes\":1047}],1036:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/fx\"),a=t(\"../../components/errorbars\"),o=t(\"./get_trace_color\"),s=t(\"../../components/color\"),l=i.constants.MAXDIST;e.exports=function(t,e,r,u){var c=t.cd,h=c[0].trace,f=t.xa,d=t.ya,p=f.c2p(e),m=d.c2p(r),v=[p,m],g=h.hoveron||\"\";if(-1!==g.indexOf(\"points\")){var y=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(f.c2p(t.x)-p)-e,1-3/e)},b=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(d.c2p(t.y)-m)-e,1-3/e)},x=function(t){var e=Math.max(3,t.mrc||0),r=f.c2p(t.x)-p,n=d.c2p(t.y)-m;return Math.max(Math.sqrt(r*r+n*n)-e,1-3/e)},_=i.getDistanceFunction(u,y,b,x);if(i.getClosest(c,_,t),!1!==t.index){var w=c[t.index],M=f.c2p(w.x,!0),k=d.c2p(w.y,!0),A=w.mrc||1;return n.extendFlat(t,{color:o(h,w),x0:M-A,x1:M+A,xLabelVal:w.x,y0:k-A,y1:k+A,yLabelVal:w.y}),w.htx?t.text=w.htx:h.hovertext?t.text=h.hovertext:w.tx?t.text=w.tx:h.text&&(t.text=h.text),a.hoverInfo(w,h,t),[t]}}if(-1!==g.indexOf(\"fills\")&&h._polygons){var T,S,E,L,C,z,I,D,P,O=h._polygons,R=[],F=!1,j=1/0,N=-1/0,B=1/0,U=-1/0;for(T=0;T<O.length;T++)E=O[T],E.contains(v)&&(F=!F,R.push(E),B=Math.min(B,E.ymin),U=Math.max(U,E.ymax));if(F){B=Math.max(B,0),U=Math.min(U,d._length);var V=(B+U)/2;for(T=0;T<R.length;T++)for(L=R[T].pts,S=1;S<L.length;S++)D=L[S-1][1],P=L[S][1],D>V!=P>=V&&(z=L[S-1][0],I=L[S][0],C=z+(I-z)*(V-D)/(P-D),j=Math.min(j,C),N=Math.max(N,C));j=Math.max(j,0),N=Math.min(N,f._length);var H=s.defaultLine;return s.opacity(h.fillcolor)?H=h.fillcolor:s.opacity((h.line||{}).color)&&(H=h.line.color),n.extendFlat(t,{distance:l+10,x0:j,x1:N,y0:V,y1:V,color:H}),delete t.index,h.text&&!Array.isArray(h.text)?t.text=String(h.text):t.text=h.name,[t]}}}},{\"../../components/color\":603,\"../../components/errorbars\":633,\"../../components/fx\":644,\"../../lib\":725,\"./get_trace_color\":1035}],1037:[function(t,e,r){\"use strict\";var n={},i=t(\"./subtypes\");n.hasLines=i.hasLines,n.hasMarkers=i.hasMarkers,n.hasText=i.hasText,n.isBubble=i.isBubble,n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.cleanData=t(\"./clean_data\"),n.calc=t(\"./calc\"),n.arraysToCalcdata=t(\"./arrays_to_calcdata\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.animatable=!0,n.moduleType=\"trace\",n.name=\"scatter\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"symbols\",\"markerColorscale\",\"errorBarsOK\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./arrays_to_calcdata\":1026,\"./attributes\":1027,\"./calc\":1028,\"./clean_data\":1029,\"./colorbar\":1030,\"./defaults\":1033,\"./hover\":1036,\"./plot\":1044,\"./select\":1045,\"./style\":1046,\"./subtypes\":1047}],1038:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/defaults\");e.exports=function(t,e,r,a,o,s){var l=(t.marker||{}).color;if(o(\"line.color\",r),n(t,\"line\"))i(t,e,a,o,{prefix:\"line.\",cLetter:\"c\"});else{o(\"line.color\",!Array.isArray(l)&&l||r)}o(\"line.width\"),(s||{}).noDash||o(\"line.dash\")}},{\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616}],1039:[function(t,e,r){\"use strict\";var n=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e){function r(e){var r=_.c2p(t[e].x),i=w.c2p(t[e].y);return r!==n&&i!==n&&[r,i]}function i(t){var e=t[0]/_._length,r=t[1]/w._length;return(1+10*Math.max(0,-e,e-1,-r,r-1))*A}var a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_=e.xaxis,w=e.yaxis,M=e.simplify,k=e.connectGaps,A=e.baseTolerance,T=e.linear,S=[],E=.2,L=new Array(t.length),C=0;for(M||(A=E=-1),a=0;a<t.length;a++)if(o=r(a)){for(C=0,L[C++]=o,a++;a<t.length;a++){if(!(l=r(a))){if(k)continue;break}if(T){if(!((h=function(t,e){var r=t[0]-e[0],n=t[1]-e[1];return Math.sqrt(r*r+n*n)}(l,o))<i(l)*E)){for(d=[(l[0]-o[0])/h,(l[1]-o[1])/h],u=o,m=h,v=y=b=0,f=!1,s=l,a++;a<t.length;a++){if(!(c=r(a))){if(k)continue;break}if(p=[c[0]-o[0],c[1]-o[1]],x=p[0]*d[1]-p[1]*d[0],y=Math.min(y,x),(b=Math.max(b,x))-y>i(c))break;s=c,g=p[0]*d[0]+p[1]*d[1],g>m?(m=g,l=c,f=!1):g<v&&(v=g,u=c,f=!0)}if(f?(L[C++]=l,s!==u&&(L[C++]=u)):(u!==o&&(L[C++]=u),s!==l&&(L[C++]=l)),L[C++]=s,a>=t.length||!c)break;L[C++]=c,o=c}}else L[C++]=l}S.push(L.slice(0,C))}return S}},{\"../../constants/numerical\":705}],1040:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){\"spline\"===r(\"line.shape\")&&r(\"line.smoothing\")}},{}],1041:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){for(var n,i,a=null,o=0;o<r.length;++o)n=r[o],i=n[0].trace,!0===i.visible?(i._nexttrace=null,-1!==[\"tonextx\",\"tonexty\",\"tonext\"].indexOf(i.fill)&&(i._prevtrace=a,a&&(a._nexttrace=i)),a=i):i._prevtrace=i._nexttrace=null}},{}],1042:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t){var e=t.marker,r=e.sizeref||1,i=e.sizemin||0,a=\"area\"===e.sizemode?function(t){return Math.sqrt(t/r)}:function(t){return t/r};return function(t){var e=a(t/2);return n(e)&&e>0?Math.max(e,i):0}}},{\"fast-isnumeric\":130}],1043:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"../../components/colorscale/has_colorscale\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./subtypes\");e.exports=function(t,e,r,s,l,u){var c,h=o.isBubble(t),f=(t.line||{}).color;if(u=u||{},f&&(r=f),l(\"marker.symbol\"),l(\"marker.opacity\",h?.7:1),l(\"marker.size\"),l(\"marker.color\",r),i(t,\"marker\")&&a(t,e,s,l,{prefix:\"marker.\",cLetter:\"c\"}),u.noLine||(c=f&&!Array.isArray(f)&&e.marker.color!==f?f:h?n.background:n.defaultLine,l(\"marker.line.color\",c),i(t,\"marker.line\")&&a(t,e,s,l,{prefix:\"marker.line.\",cLetter:\"c\"}),l(\"marker.line.width\",h?1:0)),h&&(l(\"marker.sizeref\"),l(\"marker.sizemin\"),l(\"marker.sizemode\")),u.gradient){\"none\"!==l(\"marker.gradient.type\")&&l(\"marker.gradient.color\")}}},{\"../../components/color\":603,\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616,\"./subtypes\":1047}],1044:[function(t,e,r){\"use strict\";function n(t,e,r){var n;e.selectAll(\"g.trace\").each(function(t){var e=o.select(this);if(n=t[0].trace,n._nexttrace){if(n._nextFill=e.select(\".js-fill.js-tonext\"),!n._nextFill.size()){var i=\":first-child\";e.select(\".js-fill.js-tozero\").size()&&(i+=\" + *\"),n._nextFill=e.insert(\"path\",i).attr(\"class\",\"js-fill js-tonext\")}}else e.selectAll(\".js-fill.js-tonext\").remove(),n._nextFill=null;n.fill&&(\"tozero\"===n.fill.substr(0,6)||\"toself\"===n.fill||\"to\"===n.fill.substr(0,2)&&!n._prevtrace)?(n._ownFill=e.select(\".js-fill.js-tozero\"),n._ownFill.size()||(n._ownFill=e.insert(\"path\",\":first-child\").attr(\"class\",\"js-fill js-tozero\"))):(e.selectAll(\".js-fill.js-tozero\").remove(),n._ownFill=null),e.selectAll(\".js-fill\").call(l.setClipUrl,r.layerClipId)})}function i(t,e,r,n,i,f,p){function m(t){return M?t.transition():t}function v(t){return t.filter(function(t){return t.vis})}function g(t){return t.id}function y(t){if(t.ids)return g}function b(){return!1}function x(e){var n,i,a,u=e[0].trace,h=o.select(this),f=c.hasMarkers(u),d=c.hasText(u),p=y(u),g=b,x=b;f&&(g=u.marker.maxdisplayed||u._needsCull?v:s.identity),d&&(x=u.marker.maxdisplayed||u._needsCull?v:s.identity),i=h.selectAll(\"path.point\"),n=i.data(g,p);var _=n.enter().append(\"path\").classed(\"point\",!0);M&&_.call(l.pointStyle,u,t).call(l.translatePoints,k,A).style(\"opacity\",0).transition().style(\"opacity\",1);var w=f&&l.tryColorscale(u.marker,\"\"),T=f&&l.tryColorscale(u.marker,\"line\");n.order(),n.each(function(e){var n=o.select(this),i=m(n);a=l.translatePoint(e,i,k,A),a?(l.singlePointStyle(e,i,u,w,T,t),r.layerClipId&&l.hideOutsideRangePoint(e,i,k,A),u.customdata&&n.classed(\"plotly-customdata\",null!==e.data&&void 0!==e.data)):i.remove()}),M?n.exit().transition().style(\"opacity\",0).remove():n.exit().remove(),i=h.selectAll(\"g\"),n=i.data(x,p),n.enter().append(\"g\").classed(\"textpoint\",!0).append(\"text\"),n.order(),n.each(function(t){var e=o.select(this),n=m(e.select(\"text\"));a=l.translatePoint(t,n,k,A),a?r.layerClipId&&l.hideOutsideRangePoint(t,e,k,A):e.remove()}),n.selectAll(\"text\").call(l.textPointStyle,u,t).each(function(t){var e=k.c2p(t.x),r=A.c2p(t.y);o.select(this).selectAll(\"tspan.line\").each(function(){m(o.select(this)).attr({x:e,y:r})})}),n.exit().remove()}var _,w;a(t,e,r,n,i);var M=!!p&&p.duration>0,k=r.xaxis,A=r.yaxis,T=n[0].trace,S=T.line,E=o.select(f);if(E.call(u.plot,r,p),!0===T.visible){m(E).style(\"opacity\",T.opacity);var L,C,z=T.fill.charAt(T.fill.length-1);\"x\"!==z&&\"y\"!==z&&(z=\"\"),n[0].node3=E;var I=\"\",D=[],P=T._prevtrace;P&&(I=P._prevRevpath||\"\",C=P._nextFill,D=P._polygons);var O,R,F,j,N,B,U,V,H,q=\"\",G=\"\",Y=[],X=s.noop;if(L=T._ownFill,c.hasLines(T)||\"none\"!==T.fill){for(C&&C.datum(n),-1!==[\"hv\",\"vh\",\"hvh\",\"vhv\"].indexOf(S.shape)?(F=l.steps(S.shape),j=l.steps(S.shape.split(\"\").reverse().join(\"\"))):F=j=\"spline\"===S.shape?function(t){var e=t[t.length-1];return t.length>1&&t[0][0]===e[0]&&t[0][1]===e[1]?l.smoothclosed(t.slice(1),S.smoothing):l.smoothopen(t,S.smoothing)}:function(t){return\"M\"+t.join(\"L\")},N=function(t){return j(t.reverse())},Y=h(n,{xaxis:k,yaxis:A,connectGaps:T.connectgaps,baseTolerance:Math.max(S.width||1,3)/4,linear:\"linear\"===S.shape,simplify:S.simplify}),H=T._polygons=new Array(Y.length),w=0;w<Y.length;w++)T._polygons[w]=d(Y[w]);Y.length&&(B=Y[0][0],U=Y[Y.length-1],V=U[U.length-1]),X=function(t){return function(e){if(O=F(e),R=N(e),q?z?(q+=\"L\"+O.substr(1),G=R+\"L\"+G.substr(1)):(q+=\"Z\"+O,G=R+\"Z\"+G):(q=O,G=R),c.hasLines(T)&&e.length>1){var r=o.select(this);if(r.datum(n),t)m(r.style(\"opacity\",0).attr(\"d\",O).call(l.lineGroupStyle)).style(\"opacity\",1);else{var i=m(r);i.attr(\"d\",O),l.singleLineStyle(n,i)}}}}}var W=E.selectAll(\".js-line\").data(Y);m(W.exit()).style(\"opacity\",0).remove(),W.each(X(!1)),W.enter().append(\"path\").classed(\"js-line\",!0).style(\"vector-effect\",\"non-scaling-stroke\").call(l.lineGroupStyle).each(X(!0)),l.setClipUrl(W,r.layerClipId),Y.length&&(L?B&&V&&(z?(\"y\"===z?B[1]=V[1]=A.c2p(0,!0):\"x\"===z&&(B[0]=V[0]=k.c2p(0,!0)),m(L).attr(\"d\",\"M\"+V+\"L\"+B+\"L\"+q.substr(1)).call(l.singleFillStyle)):m(L).attr(\"d\",q+\"Z\").call(l.singleFillStyle)):\"tonext\"===T.fill.substr(0,6)&&q&&I&&(\"tonext\"===T.fill?m(C).attr(\"d\",q+\"Z\"+I+\"Z\").call(l.singleFillStyle):m(C).attr(\"d\",q+\"L\"+I.substr(1)+\"Z\").call(l.singleFillStyle),T._polygons=T._polygons.concat(D)),T._prevRevpath=G,T._prevPolygons=H);var Z=E.selectAll(\".points\");_=Z.data([n]),Z.each(x),_.enter().append(\"g\").classed(\"points\",!0).each(x),_.exit().remove(),_.each(function(t){var e=!1===t[0].trace.cliponaxis;l.setClipUrl(o.select(this),e?null:r.layerClipId)})}}function a(t,e,r,n,i){var a=r.xaxis,l=r.yaxis,u=o.extent(s.simpleMap(a.range,a.r2c)),h=o.extent(s.simpleMap(l.range,l.r2c)),f=n[0].trace;if(c.hasMarkers(f)){var d=f.marker.maxdisplayed;if(0!==d){var p=n.filter(function(t){return t.x>=u[0]&&t.x<=u[1]&&t.y>=h[0]&&t.y<=h[1]}),m=Math.ceil(p.length/d),v=0;i.forEach(function(t,r){var n=t[0].trace;c.hasMarkers(n)&&n.marker.maxdisplayed>0&&r<e&&v++});var g=Math.round(v*m/3+Math.floor(v/3)*m/7.1);n.forEach(function(t){delete t.vis}),p.forEach(function(t,e){0===Math.round((e+g)%m)&&(t.vis=!0)})}}}var o=t(\"d3\"),s=t(\"../../lib\"),l=t(\"../../components/drawing\"),u=t(\"../../components/errorbars\"),c=t(\"./subtypes\"),h=t(\"./line_points\"),f=t(\"./link_traces\"),d=t(\"../../lib/polygon\").tester;e.exports=function(t,e,r,a,s){var l,u,c,h,d,p=e.plot.select(\"g.scatterlayer\"),m=!a,v=!!a&&a.duration>0;for(c=p.selectAll(\"g.trace\"),h=c.data(r,function(t){return t[0].trace.uid}),h.enter().append(\"g\").attr(\"class\",function(t){return\"trace scatter trace\"+t[0].trace.uid}).style(\"stroke-miterlimit\",2),f(t,e,r),n(t,p,e),l=0,u={};l<r.length;l++)u[r[l][0].trace.uid]=l;if(p.selectAll(\"g.trace\").sort(function(t,e){return u[t[0].trace.uid]>u[e[0].trace.uid]?1:-1}),v){s&&(d=s());o.transition().duration(a.duration).ease(a.easing).each(\"end\",function(){d&&d()}).each(\"interrupt\",function(){d&&d()}).each(function(){p.selectAll(\"g.trace\").each(function(n,o){i(t,o,e,n,r,this,a)})})}else p.selectAll(\"g.trace\").each(function(n,o){i(t,o,e,n,r,this,a)});m&&h.exit().remove(),p.selectAll(\"path:not([d])\").remove()}},{\"../../components/drawing\":627,\"../../components/errorbars\":633,\"../../lib\":725,\"../../lib/polygon\":736,\"./line_points\":1039,\"./link_traces\":1041,\"./subtypes\":1047,d3:121}],1045:[function(t,e,r){\"use strict\";var n=t(\"./subtypes\"),i=t(\"../../constants/interactions\").DESELECTDIM;e.exports=function(t,e){var r,a,o,s,l=t.cd,u=t.xaxis,c=t.yaxis,h=[],f=l[0].trace,d=f.marker,p=!n.hasMarkers(f)&&!n.hasText(f);if(!0===f.visible&&!p){var m=Array.isArray(d.opacity)?1:d.opacity;if(!1===e)for(r=0;r<l.length;r++)l[r].dim=0;else for(r=0;r<l.length;r++)a=l[r],o=u.c2p(a.x),s=c.c2p(a.y),e.contains([o,s])?(h.push({pointNumber:r,x:a.x,y:a.y}),a.dim=0):a.dim=1;return l[0].node3.selectAll(\"path.point\").style(\"opacity\",function(t){return((t.mo+1||m+1)-1)*(t.dim?i:1)}),l[0].node3.selectAll(\"text\").style(\"opacity\",function(t){return t.dim?i:1}),h}}},{\"../../constants/interactions\":704,\"./subtypes\":1047}],1046:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/drawing\"),a=t(\"../../components/errorbars\");e.exports=function(t){var e=n.select(t).selectAll(\"g.trace.scatter\");e.style(\"opacity\",function(t){return t[0].trace.opacity}),e.selectAll(\"g.points\").each(function(e){var r=n.select(this),a=r.selectAll(\"path.point\"),o=e.trace||e[0].trace;a.call(i.pointStyle,o,t),r.selectAll(\"text\").call(i.textPointStyle,o,t)}),e.selectAll(\"g.trace path.js-line\").call(i.lineGroupStyle),e.selectAll(\"g.trace path.js-fill\").call(i.fillGroupStyle),e.call(a.style)}},{\"../../components/drawing\":627,\"../../components/errorbars\":633,d3:121}],1047:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports={hasLines:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"lines\")},hasMarkers:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"markers\")},hasText:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"text\")},isBubble:function(t){return n.isPlainObject(t.marker)&&Array.isArray(t.marker.size)}}},{\"../../lib\":725}],1048:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r,i){i(\"textposition\"),n.coerceFont(i,\"textfont\",r.font)}},{\"../../lib\":725}],1049:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i){var a,o=i(\"x\"),s=i(\"y\");if(n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],r),o)s?(a=Math.min(o.length,s.length),a<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.y=s.slice(0,a))):(a=o.length,i(\"y0\"),i(\"dy\"));else{if(!s)return 0;a=e.y.length,i(\"x0\"),i(\"dx\")}return a}},{\"../../registry\":844}],1050:[function(t,e,r){\"use strict\";function n(t){return{show:{valType:\"boolean\",dflt:!1},opacity:{valType:\"number\",min:0,max:1,dflt:1},scale:{valType:\"number\",min:0,max:10,dflt:2/3}}}var i=t(\"../scatter/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/errorbars/attributes\"),s=t(\"../../constants/gl3d_dashes\"),l=t(\"../../constants/gl3d_markers\"),u=t(\"../../lib/extend\").extendFlat,c=i.line,h=i.marker,f=h.line;e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},z:{valType:\"data_array\"},text:u({},i.text,{}),hovertext:u({},i.hovertext,{}),mode:u({},i.mode,{dflt:\"lines+markers\"}),surfaceaxis:{valType:\"enumerated\",values:[-1,0,1,2],dflt:-1},surfacecolor:{valType:\"color\"},projection:{x:n(\"x\"),y:n(\"y\"),z:n(\"z\")},connectgaps:i.connectgaps,line:u({},{width:c.width,dash:{valType:\"enumerated\",values:Object.keys(s),dflt:\"solid\"},showscale:{valType:\"boolean\",dflt:!1}},a(\"line\")),marker:u({},{symbol:{valType:\"enumerated\",values:Object.keys(l),dflt:\"circle\",arrayOk:!0},size:u({},h.size,{dflt:8}),sizeref:h.sizeref,sizemin:h.sizemin,sizemode:h.sizemode,opacity:u({},h.opacity,{arrayOk:!1}),showscale:h.showscale,colorbar:h.colorbar,line:u({},{width:u({},f.width,{arrayOk:!1})},a(\"marker.line\"))},a(\"marker\")),textposition:u({},i.textposition,{dflt:\"top center\"}),textfont:i.textfont,error_x:o,error_y:o,error_z:o}},{\"../../components/colorscale/color_attributes\":610,\"../../components/errorbars/attributes\":629,\"../../constants/gl3d_dashes\":702,\"../../constants/gl3d_markers\":703,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],1051:[function(t,e,r){\"use strict\";var n=t(\"../scatter/arrays_to_calcdata\"),i=t(\"../scatter/colorscale_calc\");e.exports=function(t,e){var r=[{x:!1,y:!1,trace:e,t:{}}];return n(r,e),i(e),r}},{\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031}],1052:[function(t,e,r){\"use strict\";function n(t,e,r){if(!e||!e.visible)return null;for(var n=o(e),i=new Array(t.length),a=0;a<t.length;a++){var s=n(+t[a],a);i[a]=[-s[0]*r,s[1]*r]}return i}function i(t){for(var e=0;e<t.length;e++)if(t[e])return t[e].length;return 0}function a(t,e){var r=[n(t.x,t.error_x,e[0]),n(t.y,t.error_y,e[1]),n(t.z,t.error_z,e[2])],a=i(r);if(0===a)return null;for(var o=new Array(a),s=0;s<a;s++){for(var l=[[0,0,0],[0,0,0]],u=0;u<3;u++)if(r[u])for(var c=0;c<2;c++)l[c][u]=r[u][s][c];o[s]=l}return o}var o=t(\"../../components/errorbars/compute_error\");e.exports=a},{\"../../components/errorbars/compute_error\":631}],1053:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.linePlot=null,this.scatterPlot=null,this.errorBars=null,this.textMarkers=null,this.delaunayMesh=null,this.color=null,this.mode=\"\",this.dataPoints=[],this.axesBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.textLabels=null,this.data=null}function i(t,e,r){var n,i=(r+1)%3,a=(r+2)%3,o=[],s=[];for(n=0;n<t.length;++n){var l=t[n];!isNaN(l[i])&&isFinite(l[i])&&!isNaN(l[a])&&isFinite(l[a])&&(o.push([l[i],l[a]]),s.push(n))}var u=g(o);for(n=0;n<u.length;++n)for(var c=u[n],h=0;h<c.length;++h)c[h]=s[c[h]];return{positions:t,cells:u,meshColor:e}}function a(t){for(var e=[0,0,0],r=[[0,0,0],[0,0,0],[0,0,0]],n=[0,0,0],i=0;i<3;i++){var a=t[i];a&&!1!==a.copy_zstyle&&(a=t[2]),a&&(e[i]=a.width/2,r[i]=b(a.color),n=a.thickness)}return{capSize:e,color:r,lineWidth:n}}function o(t){var e=[0,0];return Array.isArray(t)?[0,-1]:(t.indexOf(\"bottom\")>=0&&(e[1]+=1),t.indexOf(\"top\")>=0&&(e[1]-=1),t.indexOf(\"left\")>=0&&(e[0]-=1),t.indexOf(\"right\")>=0&&(e[0]+=1),e)}function s(t,e){return e(4*t)}function l(t){return M[t]}function u(t,e,r,n,i){var a=null;if(Array.isArray(t)){a=[];for(var o=0;o<e;o++)void 0===t[o]?a[o]=n:a[o]=r(t[o],i)}else a=r(t,y.identity);return a}function c(t,e){var r,n,i,c,h,f,d=[],p=t.fullSceneLayout,m=t.dataScale,v=p.xaxis,g=p.yaxis,w=p.zaxis,M=e.marker,A=e.line,T=e.x||[],S=e.y||[],E=e.z||[],L=T.length,C=e.xcalendar,z=e.ycalendar,I=e.zcalendar;for(n=0;n<L;n++)i=v.d2l(T[n],0,C)*m[0],c=g.d2l(S[n],0,z)*m[1],h=w.d2l(E[n],0,I)*m[2],d[n]=[i,c,h];if(Array.isArray(e.text))f=e.text;else if(void 0!==e.text)for(f=new Array(L),n=0;n<L;n++)f[n]=e.text;if(r={position:d,mode:e.mode,text:f},\"line\"in e&&(r.lineColor=x(A,1,L),r.lineWidth=A.width,r.lineDashes=A.dash),\"marker\"in e){var D=_(e);r.scatterColor=x(M,1,L),r.scatterSize=u(M.size,L,s,20,D),r.scatterMarker=u(M.symbol,L,l,\"\\u25cf\"),r.scatterLineWidth=M.line.width,r.scatterLineColor=x(M.line,1,L),r.scatterAngle=0}\"textposition\"in e&&(r.textOffset=o(e.textposition),r.textColor=x(e.textfont,1,L),r.textSize=u(e.textfont.size,L,y.identity,12),r.textFont=e.textfont.family,r.textAngle=0);var P=[\"x\",\"y\",\"z\"];for(r.project=[!1,!1,!1],r.projectScale=[1,1,1],r.projectOpacity=[1,1,1],n=0;n<3;++n){var O=e.projection[P[n]];(r.project[n]=O.show)&&(r.projectOpacity[n]=O.opacity,r.projectScale[n]=O.scale)}r.errorBounds=k(e,m);var R=a([e.error_x,e.error_y,e.error_z]);return r.errorColor=R.color,r.errorLineWidth=R.lineWidth,r.errorCapSize=R.capSize,r.delaunayAxis=e.surfaceaxis,r.delaunayColor=b(e.surfacecolor),r}function h(t){if(Array.isArray(t)){var e=t[0];return Array.isArray(e)&&(t=e),\"rgb(\"+t.slice(0,3).map(function(t){return Math.round(255*t)})+\")\"}return null}function f(t,e){var r=new n(t,e.uid);return r.update(e),r}var d=t(\"gl-line3d\"),p=t(\"gl-scatter3d\"),m=t(\"gl-error3d\"),v=t(\"gl-mesh3d\"),g=t(\"delaunay-triangulate\"),y=t(\"../../lib\"),b=t(\"../../lib/str2rgbarray\"),x=t(\"../../lib/gl_format_color\"),_=t(\"../scatter/make_bubble_size_func\"),w=t(\"../../constants/gl3d_dashes\"),M=t(\"../../constants/gl3d_markers\"),k=t(\"./calc_errors\"),A=n.prototype;A.handlePick=function(t){if(t.object&&(t.object===this.linePlot||t.object===this.delaunayMesh||t.object===this.textMarkers||t.object===this.scatterPlot)){t.object.highlight&&t.object.highlight(null),this.scatterPlot&&(t.object=this.scatterPlot,this.scatterPlot.highlight(t.data)),this.textLabels?void 0!==this.textLabels[t.data.index]?t.textLabel=this.textLabels[t.data.index]:t.textLabel=this.textLabels:t.textLabel=\"\";var e=t.index=t.data.index;return t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]],!0}},A.update=function(t){var e,r,n,a,o=this.scene.glplot.gl,s=w.solid;this.data=t;var l=c(this.scene,t);\"mode\"in l&&(this.mode=l.mode),\"lineDashes\"in l&&l.lineDashes in w&&(s=w[l.lineDashes]),this.color=h(l.scatterColor)||h(l.lineColor),this.dataPoints=l.position,e={gl:o,position:l.position,color:l.lineColor,lineWidth:l.lineWidth||1,dashes:s[0],dashScale:s[1],opacity:t.opacity,connectGaps:t.connectgaps},-1!==this.mode.indexOf(\"lines\")?this.linePlot?this.linePlot.update(e):(this.linePlot=d(e),this.linePlot._trace=this,this.scene.glplot.add(this.linePlot)):this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose(),this.linePlot=null);var u=t.opacity;if(t.marker&&t.marker.opacity&&(u*=t.marker.opacity),r={gl:o,position:l.position,color:l.scatterColor,size:l.scatterSize,glyph:l.scatterMarker,opacity:u,orthographic:!0,lineWidth:l.scatterLineWidth,lineColor:l.scatterLineColor,project:l.project,projectScale:l.projectScale,projectOpacity:l.projectOpacity},-1!==this.mode.indexOf(\"markers\")?this.scatterPlot?this.scatterPlot.update(r):(this.scatterPlot=p(r),this.scatterPlot._trace=this,this.scatterPlot.highlightScale=1,this.scene.glplot.add(this.scatterPlot)):this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose(),this.scatterPlot=null),a={gl:o,position:l.position,glyph:l.text,color:l.textColor,size:l.textSize,angle:l.textAngle,alignment:l.textOffset,font:l.textFont,orthographic:!0,lineWidth:0,project:!1,opacity:t.opacity},this.textLabels=t.hovertext||t.text,-1!==this.mode.indexOf(\"text\")?this.textMarkers?this.textMarkers.update(a):(this.textMarkers=p(a),this.textMarkers._trace=this,this.textMarkers.highlightScale=1,this.scene.glplot.add(this.textMarkers)):this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose(),this.textMarkers=null),n={gl:o,position:l.position,color:l.errorColor,error:l.errorBounds,lineWidth:l.errorLineWidth,capSize:l.errorCapSize,opacity:t.opacity},this.errorBars?l.errorBounds?this.errorBars.update(n):(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose(),this.errorBars=null):l.errorBounds&&(this.errorBars=m(n),this.errorBars._trace=this,this.scene.glplot.add(this.errorBars)),l.delaunayAxis>=0){var f=i(l.position,l.delaunayColor,l.delaunayAxis);f.opacity=t.opacity,this.delaunayMesh?this.delaunayMesh.update(f):(f.gl=o,this.delaunayMesh=v(f),this.delaunayMesh._trace=this,this.scene.glplot.add(this.delaunayMesh))}else this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose(),this.delaunayMesh=null)},A.dispose=function(){this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose()),this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose()),this.errorBars&&(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose()),this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose()),this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose())},e.exports=f},{\"../../constants/gl3d_dashes\":702,\"../../constants/gl3d_markers\":703,\"../../lib\":725,\"../../lib/gl_format_color\":722,\"../../lib/str2rgbarray\":744,\"../scatter/make_bubble_size_func\":1042,\"./calc_errors\":1052,\"delaunay-triangulate\":122,\"gl-error3d\":160,\"gl-line3d\":171,\"gl-mesh3d\":204,\"gl-scatter3d\":250}],1054:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=0,o=r(\"x\"),s=r(\"y\"),l=r(\"z\");return i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],n),o&&s&&l&&(a=Math.min(o.length,s.length,l.length),a<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.y=s.slice(0,a)),a<l.length&&(e.z=l.slice(0,a))),a}var i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../scatter/subtypes\"),s=t(\"../scatter/marker_defaults\"),l=t(\"../scatter/line_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../../components/errorbars/defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,i){function f(r,n){return a.coerce(t,e,h,r,n)}if(!n(t,e,f,i))return void(e.visible=!1);f(\"text\"),f(\"hovertext\"),f(\"mode\"),o.hasLines(e)&&(f(\"connectgaps\"),l(t,e,r,i,f)),o.hasMarkers(e)&&s(t,e,r,i,f),o.hasText(e)&&u(t,e,i,f);var d=(e.line||{}).color,p=(e.marker||{}).color;f(\"surfaceaxis\")>=0&&f(\"surfacecolor\",d||p);for(var m=[\"x\",\"y\",\"z\"],v=0;v<3;++v){var g=\"projection.\"+m[v];f(g+\".show\")&&(f(g+\".opacity\"),f(g+\".scale\"))}c(t,e,r,{axis:\"z\"}),c(t,e,r,{axis:\"y\",inherit:\"z\"}),c(t,e,r,{axis:\"x\",inherit:\"z\"})}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../../registry\":844,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1050}],1055:[function(t,e,r){\"use strict\";var n={};n.plot=t(\"./convert\"),n.attributes=t(\"./attributes\"),n.markerSymbols=t(\"../../constants/gl3d_markers\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.moduleType=\"trace\",n.name=\"scatter3d\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\",\"symbols\",\"markerColorscale\",\"showLegend\"],n.meta={},e.exports=n},{\"../../constants/gl3d_markers\":703,\"../../plots/gl3d\":809,\"../scatter/colorbar\":1030,\"./attributes\":1050,\"./calc\":1051,\"./convert\":1053,\"./defaults\":1054}],\n",
       "1056:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat,l=n.marker,u=n.line,c=l.line;e.exports={carpet:{valType:\"string\"},a:{valType:\"data_array\"},b:{valType:\"data_array\"},sum:{valType:\"number\",dflt:0,min:0},mode:s({},n.mode,{dflt:\"markers\"}),text:s({},n.text,{}),line:{color:u.color,width:u.width,dash:u.dash,shape:s({},u.shape,{values:[\"linear\",\"spline\"]}),smoothing:u.smoothing},connectgaps:n.connectgaps,fill:s({},n.fill,{values:[\"none\",\"toself\",\"tonext\"]}),fillcolor:n.fillcolor,marker:s({},{symbol:l.symbol,opacity:l.opacity,maxdisplayed:l.maxdisplayed,size:l.size,sizeref:l.sizeref,sizemin:l.sizemin,sizemode:l.sizemode,line:s({},{width:c.width},a(\"marker\".line)),gradient:l.gradient},a(\"marker\"),{showscale:l.showscale,colorbar:o}),textfont:n.textfont,textposition:n.textposition,hoverinfo:s({},i.hoverinfo,{flags:[\"a\",\"b\",\"text\",\"name\"]}),hoveron:n.hoveron}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1057:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/colorscale_calc\"),s=t(\"../scatter/arrays_to_calcdata\"),l=t(\"../carpet/lookup_carpetid\");e.exports=function(t,e){var r=e.carpetTrace=l(t,e);if(r&&r.visible&&\"legendonly\"!==r.visible){var u;e.xaxis=r.xaxis,e.yaxis=r.yaxis;var c,h,f=e.a.length,d=new Array(f),p=!1;for(u=0;u<f;u++)if(c=e.a[u],h=e.b[u],n(c)&&n(h)){var m=r.ab2xy(+c,+h,!0),v=r.isVisible(+c,+h);v||(p=!0),d[u]={x:m[0],y:m[1],a:c,b:h,vis:v}}else d[u]={x:!1,y:!1};e._needsCull=p,d[0].carpet=r,d[0].trace=e;var g,y;if(a.hasMarkers(e)&&(g=e.marker,y=g.size,Array.isArray(y))){var b={type:\"linear\"};i.setConvert(b),y=b.makeCalcdata(e.marker,\"size\"),y.length>f&&y.splice(f,y.length-f)}return o(e),s(d,e),d}}},{\"../../plots/cartesian/axes\":766,\"../carpet/lookup_carpetid\":900,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1058:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/line_shape_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../scatter/fillcolor_defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}d(\"carpet\"),e.xaxis=\"x\",e.yaxis=\"y\";var p,m=d(\"a\"),v=d(\"b\");if(!(p=Math.min(m.length,v.length)))return void(e.visible=!1);m&&p<m.length&&(e.a=m.slice(0,p)),v&&p<v.length&&(e.b=v.slice(0,p)),d(\"sum\"),d(\"text\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(s(t,e,r,f,d),l(t,e,d),d(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,f,d,{gradient:!0}),a.hasText(e)&&u(t,e,f,d);var g=[];(a.hasMarkers(e)||a.hasText(e))&&(d(\"marker.maxdisplayed\"),g.push(\"points\")),d(\"fill\"),\"none\"!==e.fill&&(c(t,e,r,d),a.hasLines(e)||l(t,e,d)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||g.push(\"fills\"),d(\"hoveron\",g.join(\"+\")||\"points\")}},{\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/line_shape_defaults\":1040,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1056}],1059:[function(t,e,r){\"use strict\";var n=t(\"../scatter/hover\");e.exports=function(t,e,r,i){function a(t,e){v.push((t.labelprefix&&t.labelprefix.length>0?t.labelprefix:t._hovertitle+\": \")+e.toFixed(3)+t.labelsuffix)}var o=n(t,e,r,i);if(o&&!1!==o[0].index){var s=o[0];if(void 0===s.index){var l=1-s.y0/t.ya._length,u=t.xa._length,c=u*l/2,h=u-c;return s.x0=Math.max(Math.min(s.x0,h),c),s.x1=Math.max(Math.min(s.x1,h),c),o}var f=s.cd[s.index];s.a=f.a,s.b=f.b,s.xLabelVal=void 0,s.yLabelVal=void 0;var d=s.trace,p=d._carpet,m=d.hoverinfo.split(\"+\"),v=[];-1!==m.indexOf(\"all\")&&(m=[\"a\",\"b\"]),-1!==m.indexOf(\"a\")&&a(p.aaxis,f.a),-1!==m.indexOf(\"b\")&&a(p.baxis,f.b);var g=p.ab2ij([f.a,f.b]),y=Math.floor(g[0]),b=g[0]-y,x=Math.floor(g[1]),_=g[1]-x,w=p.evalxy([],y,x,b,_);return v.push(\"y: \"+w[1].toFixed(3)),s.extraText=v.join(\"<br>\"),o}}},{\"../scatter/hover\":1036}],1060:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattercarpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"carpet\",\"symbols\",\"markerColorscale\",\"showLegend\",\"carpetDependent\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../scatter/colorbar\":1030,\"./attributes\":1056,\"./calc\":1057,\"./defaults\":1058,\"./hover\":1059,\"./plot\":1061,\"./select\":1062,\"./style\":1063}],1061:[function(t,e,r){\"use strict\";var n=t(\"../scatter/plot\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../components/drawing\");e.exports=function(t,e,r){var o,s,l,u=r[0][0].carpet,c={xaxis:i.getFromId(t,u.xaxis||\"x\"),yaxis:i.getFromId(t,u.yaxis||\"y\"),plot:e.plot};for(n(t,c,r),o=0;o<r.length;o++)s=r[o][0].trace,l=c.plot.selectAll(\"g.trace\"+s.uid+\" .js-line\"),a.setClipUrl(l,u._clipPathId)}},{\"../../components/drawing\":627,\"../../plots/cartesian/axes\":766,\"../scatter/plot\":1044}],1062:[function(t,e,r){\"use strict\";var n=t(\"../scatter/select\");e.exports=function(t,e){var r=n(t,e);if(r){var i,a,o,s=t.cd;for(o=0;o<r.length;o++)i=r[o],a=s[i.pointNumber],i.a=a.a,i.b=a.b,i.c=a.c,delete i.x,delete i.y;return r}}},{\"../scatter/select\":1045}],1063:[function(t,e,r){\"use strict\";var n=t(\"../scatter/style\");e.exports=function(t){for(var e=t._fullLayout._modules,r=0;r<e.length;r++)if(\"scatter\"===e[r].name)return;n(t)}},{\"../scatter/style\":1046}],1064:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/drawing/attributes\").dash,s=t(\"../../lib/extend\").extendFlat,l=n.marker,u=n.line,c=l.line;e.exports={lon:{valType:\"data_array\"},lat:{valType:\"data_array\"},locations:{valType:\"data_array\"},locationmode:{valType:\"enumerated\",values:[\"ISO-3\",\"USA-states\",\"country names\"],dflt:\"ISO-3\"},mode:s({},n.mode,{dflt:\"markers\"}),text:s({},n.text,{}),hovertext:s({},n.hovertext,{}),textfont:n.textfont,textposition:n.textposition,line:{color:u.color,width:u.width,dash:o},connectgaps:n.connectgaps,marker:s({},{symbol:l.symbol,opacity:l.opacity,size:l.size,sizeref:l.sizeref,sizemin:l.sizemin,sizemode:l.sizemode,showscale:l.showscale,colorbar:l.colorbar,line:s({},{width:c.width},a(\"marker.line\")),gradient:l.gradient},a(\"marker\")),fill:{valType:\"enumerated\",values:[\"none\",\"toself\"],dflt:\"none\"},fillcolor:n.fillcolor,hoverinfo:s({},i.hoverinfo,{flags:[\"lon\",\"lat\",\"location\",\"text\",\"name\"]})}},{\"../../components/colorscale/color_attributes\":610,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1065:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../constants/numerical\").BADNUM,a=t(\"../scatter/colorscale_calc\"),o=t(\"../scatter/arrays_to_calcdata\");e.exports=function(t,e){for(var r=Array.isArray(e.locations),s=r?e.locations.length:e.lon.length,l=new Array(s),u=0;u<s;u++){var c=l[u]={};if(r){var h=e.locations[u];c.loc=\"string\"==typeof h?h:null}else{var f=e.lon[u],d=e.lat[u];n(f)&&n(d)?c.lonlat=[+f,+d]:c.lonlat=[i,i]}}return o(l,e),a(e),l}},{\"../../constants/numerical\":705,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"fast-isnumeric\":130}],1066:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a=0,o=r(\"locations\");return o?(r(\"locationmode\"),a=o.length):(n=r(\"lon\")||[],i=r(\"lat\")||[],a=Math.min(n.length,i.length),a<n.length&&(e.lon=n.slice(0,a)),a<i.length&&(e.lat=i.slice(0,a)),a)}var i=t(\"../../lib\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/text_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"./attributes\");e.exports=function(t,e,r,h){function f(r,n){return i.coerce(t,e,c,r,n)}if(!n(t,e,f))return void(e.visible=!1);f(\"text\"),f(\"hovertext\"),f(\"mode\"),a.hasLines(e)&&(s(t,e,r,h,f),f(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,h,f,{gradient:!0}),a.hasText(e)&&l(t,e,h,f),f(\"fill\"),\"none\"!==e.fill&&u(t,e,r,f)}},{\"../../lib\":725,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1064}],1067:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t.location=e.loc?e.loc:null,t}},{}],1068:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){return a.tickText(r,r.c2l(t),\"hover\").text+\"\\xb0\"}var i=t.hoverinfo,o=\"all\"===i?l.hoverinfo.flags:i.split(\"+\"),s=-1!==o.indexOf(\"location\")&&Array.isArray(t.locations),u=-1!==o.indexOf(\"lon\"),c=-1!==o.indexOf(\"lat\"),h=-1!==o.indexOf(\"text\"),f=[];if(s?f.push(e.loc):u&&c?f.push(\"(\"+n(e.lonlat[0])+\", \"+n(e.lonlat[1])+\")\"):u?f.push(\"lon: \"+n(e.lonlat[0])):c&&f.push(\"lat: \"+n(e.lonlat[1])),h){var d;e.htx?d=e.htx:t.hovertext?d=t.hovertext:e.tx?d=e.tx:t.text&&(d=t.text),Array.isArray(d)||f.push(d)}return f.join(\"<br>\")}var i=t(\"../../components/fx\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../constants/numerical\").BADNUM,s=t(\"../scatter/get_trace_color\"),l=t(\"./attributes\");e.exports=function(t){function e(t){return h.projection(t)}function r(t){var r=t.lonlat;if(r[0]===o)return 1/0;if(h.isLonLatOverEdges(r))return 1/0;var n=e(r),i=u.c2p(),a=c.c2p(),s=Math.abs(i-n[0]),l=Math.abs(a-n[1]),f=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(s*s+l*l)-f,1-3/f)}var a=t.cd,l=a[0].trace,u=t.xa,c=t.ya,h=t.subplot;if(i.getClosest(a,r,t),!1!==t.index){var f=a[t.index],d=f.lonlat,p=e(d),m=f.mrc||1;return t.x0=p[0]-m,t.x1=p[0]+m,t.y0=p[1]-m,t.y1=p[1]+m,t.loc=f.loc,t.lon=d[0],t.lat=d[1],t.color=s(l,f),t.extraText=n(l,f,h.mockAxis),[t]}}},{\"../../components/fx\":644,\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"../scatter/get_trace_color\":1035,\"./attributes\":1064}],1069:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.moduleType=\"trace\",n.name=\"scattergeo\",n.basePlotModule=t(\"../../plots/geo\"),n.categories=[\"geo\",\"symbols\",\"markerColorscale\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/geo\":794,\"../scatter/colorbar\":1030,\"./attributes\":1064,\"./calc\":1065,\"./defaults\":1066,\"./event_data\":1067,\"./hover\":1068,\"./plot\":1070}],1070:[function(t,e,r){\"use strict\";function n(t,e){var r=t[0].trace;if(Array.isArray(r.locations))for(var n=c(r,e),i=r.locationmode,a=0;a<t.length;a++){var o=t[a],s=h(i,o.loc,n);o.lonlat=s?s.properties.ct:[u,u]}}function i(t){var e=t.framework.selectAll(\"g.trace.scattergeo\");e.style(\"opacity\",function(t){return t[0].trace.opacity}),e.each(function(e){var r=e[0].trace,n=a.select(this);n.selectAll(\"path.point\").call(o.pointStyle,r,t.graphDiv),n.selectAll(\"text\").call(o.textPointStyle,r,t.graphDiv)}),e.selectAll(\"path.js-line\").style(\"fill\",\"none\").each(function(t){var e=a.select(this),r=t.trace,n=r.line||{};e.call(s.stroke,n.color).call(o.dashLine,n.dash||\"\",n.width||0),\"none\"!==r.fill&&e.call(s.fill,r.fillcolor)})}var a=t(\"d3\"),o=t(\"../../components/drawing\"),s=t(\"../../components/color\"),l=t(\"../../lib\"),u=t(\"../../constants/numerical\").BADNUM,c=t(\"../../lib/topojson_utils\").getTopojsonFeatures,h=t(\"../../lib/geo_location_utils\").locationToFeature,f=t(\"../../lib/geojson_utils\"),d=t(\"../scatter/subtypes\");e.exports=function(t,e){function r(t){return t[0].trace.uid}function o(t,e){t.lonlat[0]===u&&a.select(e).remove()}for(var s=0;s<e.length;s++)n(e[s],t.topojson);var c=t.framework.select(\".scattergeolayer\").selectAll(\"g.trace.scattergeo\").data(e,r);c.enter().append(\"g\").attr(\"class\",\"trace scattergeo\"),c.exit().remove(),c.selectAll(\"*\").remove(),c.each(function(t){var e=a.select(this),r=t[0].trace;if(d.hasLines(r)||\"none\"!==r.fill){var n=f.calcTraceToLineCoords(t),i=\"none\"!==r.fill?f.makePolygon(n,r):f.makeLine(n,r);e.selectAll(\"path.js-line\").data([i]).enter().append(\"path\").classed(\"js-line\",!0)}d.hasMarkers(r)&&e.selectAll(\"path.point\").data(l.identity).enter().append(\"path\").classed(\"point\",!0).each(function(t){o(t,this)}),d.hasText(r)&&e.selectAll(\"g\").data(l.identity).enter().append(\"g\").append(\"text\").each(function(t){o(t,this)})}),i(t)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/geo_location_utils\":719,\"../../lib/geojson_utils\":720,\"../../lib/topojson_utils\":747,\"../scatter/subtypes\":1047,d3:121}],1071:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/color_attributes\"),a=t(\"../../constants/gl2d_dashes\"),o=t(\"../../constants/gl2d_markers\"),s=t(\"../../lib/extend\").extendFlat,l=t(\"../../lib/extend\").extendDeep,u=n.line,c=n.marker,h=c.line;e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:s({},n.text,{}),mode:{valType:\"flaglist\",flags:[\"lines\",\"markers\"],extras:[\"none\"]},line:{color:u.color,width:u.width,dash:{valType:\"enumerated\",values:Object.keys(a),dflt:\"solid\"}},marker:l({},i(\"marker\"),{symbol:{valType:\"enumerated\",values:Object.keys(o),dflt:\"circle\",arrayOk:!0},size:c.size,sizeref:c.sizeref,sizemin:c.sizemin,sizemode:c.sizemode,opacity:c.opacity,showscale:c.showscale,colorbar:c.colorbar,line:l({},i(\"marker.line\"),{width:h.width})}),connectgaps:n.connectgaps,fill:s({},n.fill,{values:[\"none\",\"tozeroy\",\"tozerox\"]}),fillcolor:n.fillcolor,error_y:n.error_y,error_x:n.error_x}},{\"../../components/colorscale/color_attributes\":610,\"../../constants/gl2d_dashes\":700,\"../../constants/gl2d_markers\":701,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],1072:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../scatter/arrays_to_calcdata\"),a=t(\"../scatter/colorscale_calc\");e.exports=function(t,e){var r,o=t._fullLayout.dragmode;if(\"lasso\"===o||\"select\"===o){var s,l=n.getFromId(t,e.xaxis||\"x\"),u=n.getFromId(t,e.yaxis||\"y\"),c=l.makeCalcdata(e,\"x\"),h=u.makeCalcdata(e,\"y\"),f=Math.min(c.length,h.length);for(r=new Array(f),s=0;s<f;s++)r[s]={x:c[s],y:h[s]}}else r=[{x:!1,y:!1,trace:e,t:{}}],i(r,e);return a(e),r}},{\"../../plots/cartesian/axes\":766,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031}],1073:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"scattergl\",this.pickXData=[],this.pickYData=[],this.xData=[],this.yData=[],this.textLabels=[],this.color=\"rgb(0, 0, 0)\",this.name=\"\",this.hoverinfo=\"all\",this.connectgaps=!0,this.index=null,this.idToIndex=[],this.bounds=[0,0,0,0],this.isVisible=!1,this.hasLines=!1,this.hasErrorX=!1,this.hasErrorY=!1,this.hasMarkers=!1,this.line=this.initObject(m,{positions:new Float64Array(0),color:[0,0,0,1],width:1,fill:[!1,!1,!1,!1],fillColor:[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],dashes:[1]},0),this.errorX=this.initObject(v,{positions:new Float64Array(0),errors:new Float64Array(0),lineWidth:1,capSize:0,color:[0,0,0,1]},1),this.errorY=this.initObject(v,{positions:new Float64Array(0),errors:new Float64Array(0),lineWidth:1,capSize:0,color:[0,0,0,1]},2);var r={positions:new Float64Array(0),sizes:[],colors:[],glyphs:[],borderWidths:[],borderColors:[],size:12,color:[0,0,0,1],borderSize:1,borderColor:[0,0,0,1],snapPoints:!0},n=y.extendFlat({},r,{snapPoints:!1});this.scatter=this.initObject(d,r,3),this.fancyScatter=this.initObject(p,r,4),this.selectScatter=this.initObject(d,n,5)}function i(t,e,r){return Array.isArray(e)||(e=[e]),a(t,e,r)}function a(t,e,r){for(var n=new Array(r),i=e[0],a=0;a<r;++a)n[a]=t(a>=e.length?i:e[a]);return n}function o(t,e,r){return l(O(t,r),P(e,r),r)}function s(t,e,r,n){var i=k(t,e,n);return i=Array.isArray(i[0])?i:a(y.identity,[i],n),l(i,P(r,n),n)}function l(t,e,r){for(var n=new Array(4*r),i=0;i<r;++i){for(var a=0;a<3;++a)n[4*i+a]=t[i][a];n[4*i+3]=t[i][3]*e[i]}return n}function u(t){return\"\"===t.split(\"-open\")[1]}function c(t,e,r,n,i){var a,o=i?C:1;for(a=0;a<3;a++)t[4*r+a]=e[4*n+a];t[4*r+a]=o*e[4*n+a]}function h(t){for(var e,r=t.length,n=Math.max(1,(r-1)/Math.min(Math.max(r,1),1e3)),i=0;i<r;i+=n)if(e=t[Math.floor(i)],!(g(e)||e instanceof Date))return!1;return!0}function f(t,e,r){var i=new n(t,e.uid);return i.update(e,r),i}var d=t(\"gl-scatter2d\"),p=t(\"gl-scatter2d-sdf\"),m=t(\"gl-line2d\"),v=t(\"gl-error2d\"),g=t(\"fast-isnumeric\"),y=t(\"../../lib\"),b=t(\"../../plots/cartesian/axes\"),x=t(\"../../plots/cartesian/axis_autotype\"),_=t(\"../../components/errorbars\"),w=t(\"../../lib/str2rgbarray\"),M=t(\"../../lib/typed_array_truncate\"),k=t(\"../../lib/gl_format_color\"),A=t(\"../scatter/subtypes\"),T=t(\"../scatter/make_bubble_size_func\"),S=t(\"../scatter/get_trace_color\"),E=t(\"../../constants/gl2d_markers\"),L=t(\"../../constants/gl2d_dashes\"),C=t(\"../../constants/interactions\").DESELECTDIM,z=[\"xaxis\",\"yaxis\"],I=[0,0,0,0],D=n.prototype;D.initObject=function(t,e,r){function n(){u||(u=t(s,e),u._trace=o,u._index=r),u.update(e)}function i(){u&&u.update(l)}function a(){u&&u.dispose()}var o=this,s=o.scene.glplot,l=y.extendFlat({},e),u=null;return{options:e,update:n,clear:i,dispose:a}},D.handlePick=function(t){var e=t.pointId;(t.object!==this.line||this.connectgaps)&&(e=this.idToIndex[t.pointId]);var r=this.pickXData[e];return{trace:this,dataCoord:t.dataCoord,traceCoord:[g(r)||!y.isDateTime(r)?r:y.dateTime2ms(r),this.pickYData[e]],textLabel:Array.isArray(this.textLabels)?this.textLabels[e]:this.textLabels,color:Array.isArray(this.color)?this.color[e]:this.color,name:this.name,pointIndex:e,hoverinfo:this.hoverinfo}},D.isFancy=function(t){if(\"linear\"!==this.scene.xaxis.type&&\"date\"!==this.scene.xaxis.type)return!0;if(\"linear\"!==this.scene.yaxis.type)return!0;if(!t.x||!t.y)return!0;if(this.hasMarkers){var e=t.marker||{};if(Array.isArray(e.symbol)||\"circle\"!==e.symbol||Array.isArray(e.size)||Array.isArray(e.color)||Array.isArray(e.line.width)||Array.isArray(e.line.color)||Array.isArray(e.opacity))return!0}return!(!this.hasLines||this.connectgaps)||(!!this.hasErrorX||!!this.hasErrorY)};var P=i.bind(null,function(t){return+t}),O=i.bind(null,w),R=i.bind(null,function(t){return E[t]?t:\"circle\"});D.update=function(t,e){!0!==t.visible?(this.isVisible=!1,this.hasLines=!1,this.hasErrorX=!1,this.hasErrorY=!1,this.hasMarkers=!1):(this.isVisible=!0,this.hasLines=A.hasLines(t),this.hasErrorX=!0===t.error_x.visible,this.hasErrorY=!0===t.error_y.visible,this.hasMarkers=A.hasMarkers(t)),this.textLabels=t.text,this.name=t.name,this.hoverinfo=t.hoverinfo,this.bounds=[1/0,1/0,-1/0,-1/0],this.connectgaps=!!t.connectgaps,this.isVisible?this.isFancy(t)?this.updateFancy(t):this.updateFast(t):(this.line.clear(),this.errorX.clear(),this.errorY.clear(),this.scatter.clear(),this.fancyScatter.clear()),this.scene.glplot.objects.sort(function(t,e){return t._index-e._index}),this.index=t.index,this.color=S(t,{}),e&&e[0]&&!e[0]._glTrace&&(e[0]._glTrace=this)},D.updateFast=function(t){var e,r,n,i,a,o=this.xData=this.pickXData=t.x,s=this.yData=this.pickYData=t.y,l=o.length,u=new Array(l),c=new Float64Array(2*l),f=this.bounds,d=0,p=0,m=t.selection,v=t.xcalendar,b=h(o),_=!b&&\"date\"===x(o,v);if(b||_)for(e=0;e<l;++e)i=o[e],a=s[e],g(a)&&(b||(i=y.dateTime2ms(i,v)),c[p++]=i,c[p++]=a,u[d++]=e,f[0]=Math.min(f[0],i),f[1]=Math.min(f[1],a),f[2]=Math.max(f[2],i),f[3]=Math.max(f[3],a));if(c=M(c,p),this.idToIndex=u,m&&m.length)for(r=new Float64Array(2*m.length),e=0,n=m.length;e<n;e++)r[2*e+0]=m[e].x,r[2*e+1]=m[e].y;this.updateLines(t,c),this.updateError(\"X\",t),this.updateError(\"Y\",t);var k;if(this.hasMarkers){var A,T,S;r?(this.scatter.options.positions=null,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity*C,A[3]*=S,this.scatter.options.color=A,T[3]*=S,this.scatter.options.borderColor=T,k=t.marker.size,this.scatter.options.size=k,this.scatter.options.borderSize=t.marker.line.width,this.scatter.update(),this.scatter.options.positions=c,this.selectScatter.options.positions=r,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity,A[3]*=S,this.selectScatter.options.color=A,T[3]*=S,this.selectScatter.options.borderColor=T,k=t.marker.size,this.selectScatter.options.size=k,this.selectScatter.options.borderSize=t.marker.line.width,this.selectScatter.update()):(this.scatter.options.positions=c,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity,A[3]*=S,this.scatter.options.color=A,T[3]*=S,this.scatter.options.borderColor=T,k=t.marker.size,this.scatter.options.size=k,this.scatter.options.borderSize=t.marker.line.width,this.scatter.update())}else this.scatter.clear();this.fancyScatter.clear(),this.expandAxesFast(f,k)},D.updateFancy=function(t){var e=this.scene,r=e.xaxis,n=e.yaxis,a=this.bounds,o=t.selection,l=this.pickXData=r.makeCalcdata(t,\"x\").slice(),h=this.pickYData=n.makeCalcdata(t,\"y\").slice();this.xData=l.slice(),this.yData=h.slice();var f,d,p,m,v,g,y,b=_.calcFromTrace(t,e.fullLayout),x=l.length,w=new Array(x),k=new Float64Array(2*x),A=new Float64Array(4*x),S=new Float64Array(4*x),L=0,C=0,z=0,D=0,O=\"log\"===r.type?r.d2l:function(t){return t},F=\"log\"===n.type?n.d2l:function(t){return t};for(f=0;f<x;++f)this.xData[f]=d=O(l[f]),this.yData[f]=p=F(h[f]),isNaN(d)||isNaN(p)||(w[L++]=f,k[C++]=d,k[C++]=p,m=A[z++]=d-b[f].xs||0,v=A[z++]=b[f].xh-d||0,A[z++]=0,A[z++]=0,S[D++]=0,S[D++]=0,g=S[D++]=p-b[f].ys||0,y=S[D++]=b[f].yh-p||0,a[0]=Math.min(a[0],d-m),a[1]=Math.min(a[1],p-g),a[2]=Math.max(a[2],d+v),a[3]=Math.max(a[3],p+y));k=M(k,C),this.idToIndex=w,this.updateLines(t,k),this.updateError(\"X\",t,k,A),this.updateError(\"Y\",t,k,S);var j,N;if(o&&o.length)for(N={},f=0;f<o.length;f++)N[o[f].pointNumber]=!0;if(this.hasMarkers){this.scatter.options.positions=k,this.scatter.options.sizes=new Array(L),this.scatter.options.glyphs=new Array(L),this.scatter.options.borderWidths=new Array(L),this.scatter.options.colors=new Array(4*L),this.scatter.options.borderColors=new Array(4*L);var B,U,V,H,q,G,Y,X,W,Z,J=T(t),K=t.marker,Q=K.opacity,$=t.opacity,tt=R(K.symbol,x),et=s(K,Q,$,x),rt=P(K.line.width,x),nt=s(K.line,Q,$,x);for(j=i(J,K.size,x),f=0;f<L;++f)B=w[f],V=tt[B],H=E[V],q=u(V),G=N&&!N[B],Y=H.noBorder&&!q?nt:et,X=q?et:nt,U=j[B],W=rt[B],Z=H.noBorder||H.noFill?.1*U:0,this.scatter.options.sizes[f]=4*U,this.scatter.options.glyphs[f]=H.unicode,this.scatter.options.borderWidths[f]=.5*(W>Z?W-Z:0),!q||H.noBorder||H.noFill?c(this.scatter.options.colors,Y,f,B,G):c(this.scatter.options.colors,I,f,0),c(this.scatter.options.borderColors,X,f,B,G);N?(this.scatter.options.positions=null,this.fancyScatter.update(),this.scatter.options.positions=k):this.fancyScatter.update()}else this.fancyScatter.clear();this.scatter.clear(),this.expandAxesFancy(l,h,j)},D.updateLines=function(t,e){var r;if(this.hasLines){var n=e;if(!t.connectgaps){var i=0,a=this.xData,s=this.yData;for(n=new Float64Array(2*a.length),r=0;r<a.length;++r)n[i++]=a[r],n[i++]=s[r]}this.line.options.positions=n;var l=o(t.line.color,t.opacity,1),u=Math.round(.5*this.line.options.width),c=(L[t.line.dash]||[1]).slice();for(r=0;r<c.length;++r)c[r]*=u;switch(t.fill){case\"tozeroy\":this.line.options.fill=[!1,!0,!1,!1];break;case\"tozerox\":this.line.options.fill=[!0,!1,!1,!1];break;default:this.line.options.fill=[!1,!1,!1,!1]}var h=w(t.fillcolor);this.line.options.color=l,this.line.options.width=2*t.line.width,this.line.options.dashes=c,this.line.options.fillColor=[h,h,h,h],this.line.update()}else this.line.clear()},D.updateError=function(t,e,r,n){var i=this[\"error\"+t],a=e[\"error_\"+t.toLowerCase()];\"x\"===t.toLowerCase()&&a.copy_ystyle&&(a=e.error_y),this[\"hasError\"+t]?(i.options.positions=r,i.options.errors=n,i.options.capSize=a.width,i.options.lineWidth=a.thickness/2,i.options.color=o(a.color,1,1),i.update()):i.clear()},D.expandAxesFast=function(t,e){for(var r,n,i,a=e||10,o=0;o<2;o++)r=this.scene[z[o]],n=r._min,n||(n=[]),n.push({val:t[o],pad:a}),i=r._max,i||(i=[]),i.push({val:t[o+2],pad:a})},D.expandAxesFancy=function(t,e,r){var n=this.scene,i={padded:!0,ppad:r};b.expand(n.xaxis,t,i),b.expand(n.yaxis,e,i)},D.dispose=function(){this.line.dispose(),this.errorX.dispose(),this.errorY.dispose(),this.scatter.dispose(),this.fancyScatter.dispose()},e.exports=f},{\"../../components/errorbars\":633,\"../../constants/gl2d_dashes\":700,\"../../constants/gl2d_markers\":701,\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/gl_format_color\":722,\"../../lib/str2rgbarray\":744,\"../../lib/typed_array_truncate\":748,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_autotype\":767,\"../scatter/get_trace_color\":1035,\"../scatter/make_bubble_size_func\":1042,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130,\"gl-error2d\":158,\"gl-line2d\":169,\"gl-scatter2d\":247,\"gl-scatter2d-sdf\":242}],1074:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/xy_defaults\"),s=t(\"../scatter/marker_defaults\"),l=t(\"../scatter/line_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"../../components/errorbars/defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}var p=o(t,e,f,d);if(!p)return void(e.visible=!1);d(\"text\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(d(\"connectgaps\"),l(t,e,r,f,d)),a.hasMarkers(e)&&s(t,e,r,f,d),d(\"fill\"),\"none\"!==e.fill&&u(t,e,r,d),c(t,e,r,{axis:\"y\"}),c(t,e,r,{axis:\"x\",inherit:\"y\"})}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/xy_defaults\":1049,\"./attributes\":1071}],1075:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.hoverPoints=t(\"../scatter/hover\"),n.calc=t(\"./calc\"),n.plot=t(\"./convert\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattergl\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"symbols\",\"errorBarsOK\",\"markerColorscale\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../scatter/colorbar\":1030,\"../scatter/hover\":1036,\"./attributes\":1071,\"./calc\":1072,\"./convert\":1073,\"./defaults\":1074,\"./select\":1076}],1076:[function(t,e,r){\"use strict\";var n=t(\"../scatter/subtypes\");e.exports=function(t,e){var r,i,a,o,s=t.cd,l=t.xaxis,u=t.yaxis,c=[],h=s[0].trace,f=s[0]._glTrace,d=f.scene,p=!n.hasMarkers(h)&&!n.hasText(h);if(!0===h.visible&&!p){if(!1===e)for(r=0;r<s.length;r++)s[r].dim=0;else for(r=0;r<s.length;r++)i=s[r],a=l.c2p(i.x),o=u.c2p(i.y),e.contains([a,o])?(c.push({pointNumber:r,x:i.x,y:i.y}),i.dim=0):i.dim=1;return h.selection=c,f.update(h,s),d.glplot.setDirty(),c}}},{\"../scatter/subtypes\":1047}],1077:[function(t,e,r){\"use strict\";var n=t(\"../scattergeo/attributes\"),i=t(\"../scatter/attributes\"),a=t(\"../../plots/mapbox/layout_attributes\"),o=t(\"../../plots/attributes\"),s=t(\"../../components/colorbar/attributes\"),l=t(\"../../lib/extend\").extendFlat,u=n.line,c=n.marker;e.exports={lon:n.lon,lat:n.lat,mode:l({},i.mode,{dflt:\"markers\"}),text:l({},i.text,{}),hovertext:l({},i.hovertext,{}),line:{color:u.color,width:u.width},connectgaps:i.connectgaps,marker:{symbol:{valType:\"string\",dflt:\"circle\",arrayOk:!0},opacity:c.opacity,size:c.size,sizeref:c.sizeref,sizemin:c.sizemin,sizemode:c.sizemode,color:c.color,colorscale:c.colorscale,cauto:c.cauto,cmax:c.cmax,cmin:c.cmin,autocolorscale:c.autocolorscale,reversescale:c.reversescale,showscale:c.showscale,colorbar:s},fill:n.fill,fillcolor:i.fillcolor,textfont:a.layers.symbol.textfont,textposition:a.layers.symbol.textposition,hoverinfo:l({},o.hoverinfo,{flags:[\"lon\",\"lat\",\"text\",\"name\"]})}},{\"../../components/colorbar/attributes\":604,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/mapbox/layout_attributes\":825,\"../scatter/attributes\":1027,\"../scattergeo/attributes\":1064}],1078:[function(t,e,r){\"use strict\";function n(){return{geojson:v.makeBlank(),layout:{visibility:\"none\"},paint:{}}}function i(t,e){function r(t,e){return a.opacity*e*(t.dim?_:1)}function n(t,r,n,i){void 0===e[r][n]&&(e[r][n]=i),t[r]=e[r][n]}var i,a=t[0].trace,o=a.marker;g.hasColorscale(a,\"marker\")?i=g.makeColorScaleFunc(g.extractScale(o.colorscale,o.cmin,o.cmax)):Array.isArray(o.color)&&(i=p.identity);var s;b.isBubble(a)&&(s=y(a));var l;Array.isArray(o.opacity)?l=function(t){return r(t,d(t.mo)?+p.constrain(t.mo,0,1):0)}:a._hasDimmedPts&&(l=function(t){return r(t,o.opacity)});for(var u=[],c=0;c<t.length;c++){var h=t[c],m=h.lonlat;if(!f(m)){var v={};if(i){var x=h.mcc=i(h.mc);n(v,w,x,c)}s&&n(v,M,s(h.ms),c),l&&n(v,k,l(h),c),u.push({type:\"Feature\",geometry:{type:\"Point\",coordinates:m},properties:v})}}return{type:\"FeatureCollection\",features:u}}function a(t){for(var e=t[0].trace,r=e.marker||{},n=r.symbol,i=e.text,a=\"circle\"!==n?u(n):c,o=b.hasText(e)?u(i):c,s=[],l=0;l<t.length;l++){var h=t[l];f(h.lonlat)||s.push({type:\"Feature\",geometry:{type:\"Point\",coordinates:h.lonlat},properties:{symbol:a(h.mx),text:o(h.tx)}})}return{type:\"FeatureCollection\",features:s}}function o(t,e){var r,n=t.marker;if(Array.isArray(n.color)){for(var i=Object.keys(e[w]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[w][s],s])}r={property:w,stops:a}}else r=n.color;return r}function s(t,e){var r,n=t.marker;if(Array.isArray(n.size)){for(var i=Object.keys(e[M]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[M][s],+s])}r={property:M,stops:a.sort(h)}}else r=n.size/2;return r}function l(t,e){var r,n=t.marker;if(Array.isArray(n.opacity)||t._hasDimmedPts){for(var i=Object.keys(e[k]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[k][s],+s])}r={property:k,stops:a.sort(h)}}else r=t.opacity*n.opacity;return r}function u(t){return Array.isArray(t)?function(t){return t}:t?function(){return t}:c}function c(){return\"\"}function h(t,e){return t[0]-e[0]}function f(t){return t[0]===m}var d=t(\"fast-isnumeric\"),p=t(\"../../lib\"),m=t(\"../../constants/numerical\").BADNUM,v=t(\"../../lib/geojson_utils\"),g=t(\"../../components/colorscale\"),y=t(\"../scatter/make_bubble_size_func\"),b=t(\"../scatter/subtypes\"),x=t(\"../../plots/mapbox/convert_text_opts\"),_=t(\"../../constants/interactions\").DESELECTDIM,w=\"circle-color\",M=\"circle-radius\",k=\"circle-opacity\";e.exports=function(t){var e=t[0].trace,r=!0===e.visible,u=\"none\"!==e.fill,c=b.hasLines(e),h=b.hasMarkers(e),f=b.hasText(e),d=h&&\"circle\"===e.marker.symbol,m=h&&\"circle\"!==e.marker.symbol,g=n(),y=n(),_=n(),A=n(),T={fill:g,line:y,circle:_,symbol:A};if(!r)return T;var S;if((u||c)&&(S=v.calcTraceToLineCoords(t)),u&&(g.geojson=v.makePolygon(S),g.layout.visibility=\"visible\",p.extendFlat(g.paint,{\"fill-color\":e.fillcolor})),c&&(y.geojson=v.makeLine(S),y.layout.visibility=\"visible\",p.extendFlat(y.paint,{\"line-width\":e.line.width,\"line-color\":e.line.color,\"line-opacity\":e.opacity})),d){var E={};E[w]={},E[M]={},E[k]={},_.geojson=i(t,E),_.layout.visibility=\"visible\",p.extendFlat(_.paint,{\"circle-opacity\":l(e,E),\"circle-color\":o(e,E),\"circle-radius\":s(e,E)})}if((m||f)&&(A.geojson=a(t),p.extendFlat(A.layout,{visibility:\"visible\",\"icon-image\":\"{symbol}-15\",\"text-field\":\"{text}\"}),m&&(p.extendFlat(A.layout,{\"icon-size\":e.marker.size/10}),p.extendFlat(A.paint,{\"icon-opacity\":e.opacity*e.marker.opacity,\"icon-color\":e.marker.color})),f)){var L=(e.marker||{}).size,C=x(e.textposition,L);p.extendFlat(A.layout,{\"text-size\":e.textfont.size,\"text-anchor\":C.anchor,\"text-offset\":C.offset}),p.extendFlat(A.paint,{\"text-color\":e.textfont.color,\"text-opacity\":e.opacity})}return T}},{\"../../components/colorscale\":617,\"../../constants/interactions\":704,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/geojson_utils\":720,\"../../plots/mapbox/convert_text_opts\":822,\"../scatter/make_bubble_size_func\":1042,\n",
       "\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1079:[function(t,e,r){\"use strict\";function n(t,e,r){var n=r(\"lon\")||[],i=r(\"lat\")||[],a=Math.min(n.length,i.length);return a<n.length&&(e.lon=n.slice(0,a)),a<i.length&&(e.lat=i.slice(0,a)),a}var i=t(\"../../lib\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/text_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"./attributes\");e.exports=function(t,e,r,h){function f(r,n){return i.coerce(t,e,c,r,n)}if(!n(t,e,f))return void(e.visible=!1);if(f(\"text\"),f(\"hovertext\"),f(\"mode\"),a.hasLines(e)&&(s(t,e,r,h,f,{noDash:!0}),f(\"connectgaps\")),a.hasMarkers(e)){o(t,e,r,h,f,{noLine:!0});var d=e.marker;d.line={width:0},\"circle\"!==d.symbol&&(Array.isArray(d.size)&&(d.size=d.size[0]),Array.isArray(d.color)&&(d.color=d.color[0]))}a.hasText(e)&&l(t,e,h,f),f(\"fill\"),\"none\"!==e.fill&&u(t,e,r,f)}},{\"../../lib\":725,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1077}],1080:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t}},{}],1081:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return t+\"\\xb0\"}var n=t.hoverinfo.split(\"+\"),i=-1!==n.indexOf(\"all\"),a=-1!==n.indexOf(\"lon\"),o=-1!==n.indexOf(\"lat\"),s=e.lonlat,l=[];if(i||a&&o?l.push(\"(\"+r(s[0])+\", \"+r(s[1])+\")\"):a?l.push(\"lon: \"+r(s[0])):o&&l.push(\"lat: \"+r(s[1])),i||-1!==n.indexOf(\"text\")){var u;e.htx?u=e.htx:t.hovertext?u=t.hovertext:e.tx?u=e.tx:t.text&&(u=t.text),Array.isArray(u)||l.push(u)}return l.join(\"<br>\")}var i=t(\"../../components/fx\"),a=t(\"../scatter/get_trace_color\"),o=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e,r){function s(t){var e=t.lonlat;if(e[0]===o)return 1/0;var n=Math.abs(c.c2p(e)-c.c2p([p,e[1]])),i=Math.abs(h.c2p(e)-h.c2p([e[0],r])),a=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(n*n+i*i)-a,1-3/a)}var l=t.cd,u=l[0].trace,c=t.xa,h=t.ya,f=e>=0?Math.floor((e+180)/360):Math.ceil((e-180)/360),d=360*f,p=e-d;if(i.getClosest(l,s,t),!1!==t.index){var m=l[t.index],v=m.lonlat,g=[v[0]+d,v[1]],y=c.c2p(g),b=h.c2p(g),x=m.mrc||1;return t.x0=y-x,t.x1=y+x,t.y0=b-x,t.y1=b+x,t.color=a(u,m),t.extraText=n(u,m),[t]}}},{\"../../components/fx\":644,\"../../constants/numerical\":705,\"../scatter/get_trace_color\":1035}],1082:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"../scattergeo/calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattermapbox\",n.basePlotModule=t(\"../../plots/mapbox\"),n.categories=[\"mapbox\",\"gl\",\"symbols\",\"markerColorscale\",\"showLegend\",\"scatterlike\"],n.meta={},e.exports=n},{\"../../plots/mapbox\":823,\"../scatter/colorbar\":1030,\"../scattergeo/calc\":1065,\"./attributes\":1077,\"./defaults\":1079,\"./event_data\":1080,\"./hover\":1081,\"./plot\":1083,\"./select\":1084}],1083:[function(t,e,r){\"use strict\";function n(t,e){this.mapbox=t,this.map=t.map,this.uid=e,this.idSourceFill=e+\"-source-fill\",this.idSourceLine=e+\"-source-line\",this.idSourceCircle=e+\"-source-circle\",this.idSourceSymbol=e+\"-source-symbol\",this.idLayerFill=e+\"-layer-fill\",this.idLayerLine=e+\"-layer-line\",this.idLayerCircle=e+\"-layer-circle\",this.idLayerSymbol=e+\"-layer-symbol\",this.mapbox.initSource(this.idSourceFill),this.mapbox.initSource(this.idSourceLine),this.mapbox.initSource(this.idSourceCircle),this.mapbox.initSource(this.idSourceSymbol),this.map.addLayer({id:this.idLayerFill,source:this.idSourceFill,type:\"fill\"}),this.map.addLayer({id:this.idLayerLine,source:this.idSourceLine,type:\"line\"}),this.map.addLayer({id:this.idLayerCircle,source:this.idSourceCircle,type:\"circle\"}),this.map.addLayer({id:this.idLayerSymbol,source:this.idSourceSymbol,type:\"symbol\"})}function i(t){return\"visible\"===t.layout.visibility}var a=t(\"./convert\"),o=n.prototype;o.update=function(t){var e=this.mapbox,r=a(t);e.setOptions(this.idLayerFill,\"setLayoutProperty\",r.fill.layout),e.setOptions(this.idLayerLine,\"setLayoutProperty\",r.line.layout),e.setOptions(this.idLayerCircle,\"setLayoutProperty\",r.circle.layout),e.setOptions(this.idLayerSymbol,\"setLayoutProperty\",r.symbol.layout),i(r.fill)&&(e.setSourceData(this.idSourceFill,r.fill.geojson),e.setOptions(this.idLayerFill,\"setPaintProperty\",r.fill.paint)),i(r.line)&&(e.setSourceData(this.idSourceLine,r.line.geojson),e.setOptions(this.idLayerLine,\"setPaintProperty\",r.line.paint)),i(r.circle)&&(e.setSourceData(this.idSourceCircle,r.circle.geojson),e.setOptions(this.idLayerCircle,\"setPaintProperty\",r.circle.paint)),i(r.symbol)&&(e.setSourceData(this.idSourceSymbol,r.symbol.geojson),e.setOptions(this.idLayerSymbol,\"setPaintProperty\",r.symbol.paint)),t[0].trace._glTrace=this},o.dispose=function(){var t=this.map;t.removeLayer(this.idLayerFill),t.removeLayer(this.idLayerLine),t.removeLayer(this.idLayerCircle),t.removeLayer(this.idLayerSymbol),t.removeSource(this.idSourceFill),t.removeSource(this.idSourceLine),t.removeSource(this.idSourceCircle),t.removeSource(this.idSourceSymbol)},e.exports=function(t,e){var r=e[0].trace,i=new n(t,r.uid);return i.update(e),i}},{\"./convert\":1078}],1084:[function(t,e,r){\"use strict\";var n=t(\"../scatter/subtypes\");e.exports=function(t,e){var r,i,a,o,s,l=t.cd,u=t.xaxis,c=t.yaxis,h=[],f=l[0].trace;if(f._hasDimmedPts=!1,!0===f.visible&&n.hasMarkers(f)){if(!1===e)for(s=0;s<l.length;s++)l[s].dim=0;else for(s=0;s<l.length;s++)r=l[s],i=r.lonlat,a=u.c2p(i),o=c.c2p(i),e.contains([a,o])?(f._hasDimmedPts=!0,h.push({pointNumber:s,lon:i[0],lat:i[1]}),r.dim=0):r.dim=1;return f._glTrace.update(l),h}}},{\"../scatter/subtypes\":1047}],1085:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../components/drawing/attributes\").dash,l=t(\"../../lib/extend\").extendFlat,u=n.marker,c=n.line,h=u.line;e.exports={a:{valType:\"data_array\"},b:{valType:\"data_array\"},c:{valType:\"data_array\"},sum:{valType:\"number\",dflt:0,min:0},mode:l({},n.mode,{dflt:\"markers\"}),text:l({},n.text,{}),hovertext:l({},n.hovertext,{}),line:{color:c.color,width:c.width,dash:s,shape:l({},c.shape,{values:[\"linear\",\"spline\"]}),smoothing:c.smoothing},connectgaps:n.connectgaps,cliponaxis:n.cliponaxis,fill:l({},n.fill,{values:[\"none\",\"toself\",\"tonext\"]}),fillcolor:n.fillcolor,marker:l({},{symbol:u.symbol,opacity:u.opacity,maxdisplayed:u.maxdisplayed,size:u.size,sizeref:u.sizeref,sizemin:u.sizemin,sizemode:u.sizemode,line:l({},{width:h.width},a(\"marker\".line)),gradient:u.gradient},a(\"marker\"),{showscale:u.showscale,colorbar:o}),textfont:n.textfont,textposition:n.textposition,hoverinfo:l({},i.hoverinfo,{flags:[\"a\",\"b\",\"c\",\"text\",\"name\"]}),hoveron:n.hoveron}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1086:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/colorscale_calc\"),s=t(\"../scatter/arrays_to_calcdata\"),l=[\"a\",\"b\",\"c\"],u={a:[\"b\",\"c\"],b:[\"a\",\"c\"],c:[\"a\",\"b\"]};e.exports=function(t,e){var r,c,h,f,d,p,m=t._fullLayout[e.subplot],v=m.sum,g=e.sum||v;for(r=0;r<l.length;r++)if(h=l[r],!e[h]){for(d=e[u[h][0]],p=e[u[h][1]],f=new Array(d.length),c=0;c<d.length;c++)f[c]=g-d[c]-p[c];e[h]=f}var y,b,x,_,w,M,k=e.a.length,A=new Array(k);for(r=0;r<k;r++)y=e.a[r],b=e.b[r],x=e.c[r],n(y)&&n(b)&&n(x)?(y=+y,b=+b,x=+x,_=v/(y+b+x),1!==_&&(y*=_,b*=_,x*=_),M=y,w=x-b,A[r]={x:w,y:M,a:y,b:b,c:x}):A[r]={x:!1,y:!1};var T,S;if(a.hasMarkers(e)&&(T=e.marker,S=T.size,Array.isArray(S))){var E={type:\"linear\"};i.setConvert(E),S=E.makeCalcdata(e.marker,\"size\"),S.length>k&&S.splice(k,S.length-k)}return o(e),s(A,e),A}},{\"../../plots/cartesian/axes\":766,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1087:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/line_shape_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../scatter/fillcolor_defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}var p,m=d(\"a\"),v=d(\"b\"),g=d(\"c\");if(m?(p=m.length,v?(p=Math.min(p,v.length),g&&(p=Math.min(p,g.length))):p=g?Math.min(p,g.length):0):v&&g&&(p=Math.min(v.length,g.length)),!p)return void(e.visible=!1);m&&p<m.length&&(e.a=m.slice(0,p)),v&&p<v.length&&(e.b=v.slice(0,p)),g&&p<g.length&&(e.c=g.slice(0,p)),d(\"sum\"),d(\"text\"),d(\"hovertext\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(s(t,e,r,f,d),l(t,e,d),d(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,f,d,{gradient:!0}),a.hasText(e)&&u(t,e,f,d);var y=[];(a.hasMarkers(e)||a.hasText(e))&&(d(\"marker.maxdisplayed\"),y.push(\"points\")),d(\"fill\"),\"none\"!==e.fill&&(c(t,e,r,d),a.hasLines(e)||l(t,e,d)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||y.push(\"fills\"),d(\"hoveron\",y.join(\"+\")||\"points\"),d(\"cliponaxis\")}},{\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/line_shape_defaults\":1040,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1085}],1088:[function(t,e,r){\"use strict\";var n=t(\"../scatter/hover\"),i=t(\"../../plots/cartesian/axes\");e.exports=function(t,e,r,a){function o(t,e){g.push(t._hovertitle+\": \"+i.tickText(t,e,\"hover\").text)}var s=n(t,e,r,a);if(s&&!1!==s[0].index){var l=s[0];if(void 0===l.index){var u=1-l.y0/t.ya._length,c=t.xa._length,h=c*u/2,f=c-h;return l.x0=Math.max(Math.min(l.x0,f),h),l.x1=Math.max(Math.min(l.x1,f),h),s}var d=l.cd[l.index];l.a=d.a,l.b=d.b,l.c=d.c,l.xLabelVal=void 0,l.yLabelVal=void 0;var p=l.trace,m=p._ternary,v=p.hoverinfo.split(\"+\"),g=[];return-1!==v.indexOf(\"all\")&&(v=[\"a\",\"b\",\"c\"]),-1!==v.indexOf(\"a\")&&o(m.aaxis,d.a),-1!==v.indexOf(\"b\")&&o(m.baxis,d.b),-1!==v.indexOf(\"c\")&&o(m.caxis,d.c),l.extraText=g.join(\"<br>\"),s}}},{\"../../plots/cartesian/axes\":766,\"../scatter/hover\":1036}],1089:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scatterternary\",n.basePlotModule=t(\"../../plots/ternary\"),n.categories=[\"ternary\",\"symbols\",\"markerColorscale\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/ternary\":837,\"../scatter/colorbar\":1030,\"./attributes\":1085,\"./calc\":1086,\"./defaults\":1087,\"./hover\":1088,\"./plot\":1090,\"./select\":1091,\"./style\":1092}],1090:[function(t,e,r){\"use strict\";var n=t(\"../scatter/plot\");e.exports=function(t,e){var r=t.plotContainer;r.select(\".scatterlayer\").selectAll(\"*\").remove();for(var i={xaxis:t.xaxis,yaxis:t.yaxis,plot:r,layerClipId:t._hasClipOnAxisFalse?t.clipIdRelative:null},a=0;a<e.length;a++)e[a][0].trace._ternary=t;n(t.graphDiv,i,e)}},{\"../scatter/plot\":1044}],1091:[function(t,e,r){arguments[4][1062][0].apply(r,arguments)},{\"../scatter/select\":1045,dup:1062}],1092:[function(t,e,r){arguments[4][1063][0].apply(r,arguments)},{\"../scatter/style\":1046,dup:1063}],1093:[function(t,e,r){\"use strict\";function n(t){return{valType:\"boolean\",dflt:!1}}function i(t){return{show:{valType:\"boolean\",dflt:!1},project:{x:n(\"x\"),y:n(\"y\"),z:n(\"z\")},color:{valType:\"color\",dflt:a.defaultLine},usecolormap:{valType:\"boolean\",dflt:!1},width:{valType:\"number\",min:1,max:16,dflt:2},highlight:{valType:\"boolean\",dflt:!0},highlightcolor:{valType:\"color\",dflt:a.defaultLine},highlightwidth:{valType:\"number\",min:1,max:16,dflt:2}}}var a=t(\"../../components/color\"),o=t(\"../../components/colorscale/attributes\"),s=t(\"../../components/colorbar/attributes\"),l=t(\"../../lib/extend\").extendFlat;e.exports={z:{valType:\"data_array\"},x:{valType:\"data_array\"},y:{valType:\"data_array\"},text:{valType:\"data_array\"},surfacecolor:{valType:\"data_array\"},cauto:o.zauto,cmin:o.zmin,cmax:o.zmax,colorscale:o.colorscale,autocolorscale:l({},o.autocolorscale,{dflt:!1}),reversescale:o.reversescale,showscale:o.showscale,colorbar:s,contours:{x:i(\"x\"),y:i(\"y\"),z:i(\"z\")},hidesurface:{valType:\"boolean\",dflt:!1},lightposition:{x:{valType:\"number\",min:-1e5,max:1e5,dflt:10},y:{valType:\"number\",min:-1e5,max:1e5,dflt:1e4},z:{valType:\"number\",min:-1e5,max:1e5,dflt:0}},lighting:{ambient:{valType:\"number\",min:0,max:1,dflt:.8},diffuse:{valType:\"number\",min:0,max:1,dflt:.8},specular:{valType:\"number\",min:0,max:2,dflt:.05},roughness:{valType:\"number\",min:0,max:1,dflt:.5},fresnel:{valType:\"number\",min:0,max:5,dflt:.2}},opacity:{valType:\"number\",min:0,max:1,dflt:1},_deprecated:{zauto:l({},o.zauto,{}),zmin:l({},o.zmin,{}),zmax:l({},o.zmax,{})}}},{\"../../components/color\":603,\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716}],1094:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){e.surfacecolor?n(e,e.surfacecolor,\"\",\"c\"):n(e,e.z,\"\",\"c\")}},{\"../../components/colorscale/calc\":609}],1095:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.cmin,c=r.cmax,h=r.surfacecolor||r.z;if(n(u)||(u=i.aggNums(Math.min,null,h)),n(c)||(c=i.aggNums(Math.max,null,h)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var f=e[0].t.cb=s(t,l),d=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});f.fillcolor(d).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],1096:[function(t,e,r){\"use strict\";function n(t,e,r){this.scene=t,this.uid=r,this.surface=e,this.data=null,this.showContour=[!1,!1,!1],this.dataScale=1}function i(t,e){return void 0===e&&(e=1),t.map(function(t){var r=t[0],n=p(t[1]),i=n.toRgb();return{index:r,rgb:[i.r,i.g,i.b,e]}})}function a(t){var e=t[0].rgb,r=t[t.length-1].rgb;return e[0]===r[0]&&e[1]===r[1]&&e[2]===r[2]&&e[3]===r[3]}function o(t){var e=t.shape,r=[e[0]+2,e[1]+2],n=c(new Float32Array(r[0]*r[1]),r);return d.assign(n.lo(1,1).hi(e[0],e[1]),t),d.assign(n.lo(1).hi(e[0],1),t.hi(e[0],1)),d.assign(n.lo(1,r[1]-1).hi(e[0],1),t.lo(0,e[1]-1).hi(e[0],1)),d.assign(n.lo(0,1).hi(1,e[1]),t.hi(1)),d.assign(n.lo(r[0]-1,1).hi(1,e[1]),t.lo(e[0]-1)),n.set(0,0,t.get(0,0)),n.set(0,r[1]-1,t.get(0,e[1]-1)),n.set(r[0]-1,0,t.get(e[0]-1,0)),n.set(r[0]-1,r[1]-1,t.get(e[0]-1,e[1]-1)),n}function s(t){var e=Math.max(t[0].shape[0],t[0].shape[1]);if(e<v){for(var r=v/e,n=[0|Math.floor(t[0].shape[0]*r+1),0|Math.floor(t[0].shape[1]*r+1)],i=n[0]*n[1],a=0;a<t.length;++a){var s=o(t[a]),l=c(new Float32Array(i),n);h(l,s,[r,0,0,0,r,0,0,0,1]),t[a]=l}return r}return 1}function l(t,e){var r=t.glplot.gl,i=u({gl:r}),a=new n(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}var u=t(\"gl-surface3d\"),c=t(\"ndarray\"),h=t(\"ndarray-homography\"),f=t(\"ndarray-fill\"),d=t(\"ndarray-ops\"),p=t(\"tinycolor2\"),m=t(\"../../lib/str2rgbarray\"),v=128,g=n.prototype;g.handlePick=function(t){if(t.object===this.surface){var e=t.index=[Math.min(0|Math.round(t.data.index[0]/this.dataScale-1),this.data.z[0].length-1),Math.min(0|Math.round(t.data.index[1]/this.dataScale-1),this.data.z.length-1)],r=[0,0,0];Array.isArray(this.data.x[0])?r[0]=this.data.x[e[1]][e[0]]:r[0]=this.data.x[e[0]],Array.isArray(this.data.y[0])?r[1]=this.data.y[e[1]][e[0]]:r[1]=this.data.y[e[1]],r[2]=this.data.z[e[1]][e[0]],t.traceCoordinate=r;var n=this.scene.fullSceneLayout;t.dataCoordinate=[n.xaxis.d2l(r[0],0,this.data.xcalendar)*this.scene.dataScale[0],n.yaxis.d2l(r[1],0,this.data.ycalendar)*this.scene.dataScale[1],n.zaxis.d2l(r[2],0,this.data.zcalendar)*this.scene.dataScale[2]];var i=this.data.text;return i&&i[e[1]]&&void 0!==i[e[1]][e[0]]?t.textLabel=i[e[1]][e[0]]:t.textLabel=\"\",t.data.dataCoordinate=t.dataCoordinate.slice(),this.surface.highlight(t.data),this.scene.glplot.spikes.position=t.dataCoordinate,!0}},g.setContourLevels=function(){for(var t=[[],[],[]],e=!1,r=0;r<3;++r)this.showContour[r]&&(e=!0,t[r]=this.scene.contourLevels[r]);e&&this.surface.update({levels:t})},g.update=function(t){var e,r=this.scene,n=r.fullSceneLayout,o=this.surface,l=t.opacity,u=i(t.colorscale,l),h=t.z,d=t.x,p=t.y,v=n.xaxis,g=n.yaxis,y=n.zaxis,b=r.dataScale,x=h[0].length,_=h.length,w=[c(new Float32Array(x*_),[x,_]),c(new Float32Array(x*_),[x,_]),c(new Float32Array(x*_),[x,_])],M=w[0],k=w[1],A=r.contourLevels;this.data=t;var T=t.xcalendar,S=t.ycalendar,E=t.zcalendar;f(w[2],function(t,e){return y.d2l(h[e][t],0,E)*b[2]}),Array.isArray(d[0])?f(M,function(t,e){return v.d2l(d[e][t],0,T)*b[0]}):f(M,function(t){return v.d2l(d[t],0,T)*b[0]}),Array.isArray(p[0])?f(k,function(t,e){return g.d2l(p[e][t],0,S)*b[1]}):f(k,function(t,e){return g.d2l(p[e],0,S)*b[1]});var L={colormap:u,levels:[[],[],[]],showContour:[!0,!0,!0],showSurface:!t.hidesurface,contourProject:[[!1,!1,!1],[!1,!1,!1],[!1,!1,!1]],contourWidth:[1,1,1],contourColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],contourTint:[1,1,1],dynamicColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],dynamicWidth:[1,1,1],dynamicTint:[1,1,1],opacity:t.opacity};if(L.intensityBounds=[t.cmin,t.cmax],t.surfacecolor){var C=c(new Float32Array(x*_),[x,_]);f(C,function(e,r){return t.surfacecolor[r][e]}),w.push(C)}else L.intensityBounds[0]*=b[2],L.intensityBounds[1]*=b[2];this.dataScale=s(w),t.surfacecolor&&(L.intensity=w.pop());var z=[!0,!0,!0],I=[\"x\",\"y\",\"z\"];for(e=0;e<3;++e){var D=t.contours[I[e]];z[e]=D.highlight,L.showContour[e]=D.show||D.highlight,L.showContour[e]&&(L.contourProject[e]=[D.project.x,D.project.y,D.project.z],D.show?(this.showContour[e]=!0,L.levels[e]=A[e],o.highlightColor[e]=L.contourColor[e]=m(D.color),D.usecolormap?o.highlightTint[e]=L.contourTint[e]=0:o.highlightTint[e]=L.contourTint[e]=1,L.contourWidth[e]=D.width):this.showContour[e]=!1,D.highlight&&(L.dynamicColor[e]=m(D.highlightcolor),L.dynamicWidth[e]=D.highlightwidth))}a(u)&&(L.vertexColor=!0),L.coords=w,o.update(L),o.visible=t.visible,o.enableDynamic=z,o.snapToData=!0,\"lighting\"in t&&(o.ambientLight=t.lighting.ambient,o.diffuseLight=t.lighting.diffuse,o.specularLight=t.lighting.specular,o.roughness=t.lighting.roughness,o.fresnel=t.lighting.fresnel),\"lightposition\"in t&&(o.lightPosition=[t.lightposition.x,t.lightposition.y,t.lightposition.z]),l&&l<1&&(o.supportsTransparency=!0)},g.dispose=function(){this.scene.glplot.remove(this.surface),this.surface.dispose()},e.exports=l},{\"../../lib/str2rgbarray\":744,\"gl-surface3d\":265,ndarray:466,\"ndarray-fill\":456,\"ndarray-homography\":458,\"ndarray-ops\":460,tinycolor2:533}],1097:[function(t,e,r){\"use strict\";function n(t,e,r){e in t&&!(r in t)&&(t[r]=t[e])}var i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../../components/colorscale/defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,n){return a.coerce(t,e,s,r,n)}var c,h,f=u(\"z\");if(!f)return void(e.visible=!1);var d=f[0].length,p=f.length;if(u(\"x\"),u(\"y\"),i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],l),!Array.isArray(e.x))for(e.x=[],c=0;c<d;++c)e.x[c]=c;if(u(\"text\"),!Array.isArray(e.y))for(e.y=[],c=0;c<p;++c)e.y[c]=c;[\"lighting.ambient\",\"lighting.diffuse\",\"lighting.specular\",\"lighting.roughness\",\"lighting.fresnel\",\"lightposition.x\",\"lightposition.y\",\"lightposition.z\",\"hidesurface\",\"opacity\"].forEach(function(t){u(t)});var m=u(\"surfacecolor\");u(\"colorscale\");var v=[\"x\",\"y\",\"z\"];for(c=0;c<3;++c){var g=\"contours.\"+v[c],y=u(g+\".show\"),b=u(g+\".highlight\");if(y||b)for(h=0;h<3;++h)u(g+\".project.\"+v[h]);y&&(u(g+\".color\"),u(g+\".width\"),u(g+\".usecolormap\")),b&&(u(g+\".highlightcolor\"),u(g+\".highlightwidth\"))}m||(n(t,\"zmin\",\"cmin\"),n(t,\"zmax\",\"cmax\"),n(t,\"zauto\",\"cauto\")),o(t,e,l,u,{prefix:\"\",cLetter:\"c\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"../../registry\":844,\"./attributes\":1093}],1098:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"./colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"surface\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\",\"2dMap\",\"noOpacity\"],n.meta={},e.exports=n},{\"../../plots/gl3d\":809,\"./attributes\":1093,\"./calc\":1094,\"./colorbar\":1095,\"./convert\":1096,\"./defaults\":1097}],1099:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(n.enabled){for(var a=n.target,o=u.nestedProperty(e,a),s=o.get(),c=l.getDataConversions(t,e,a,s),h=i(n,c),f=new Array(r.length),d=0;d<r.length;d++)f[d]=h(s,r[d]);o.set(f)}}function i(t,e){var r=t.func,n=e.d2c,i=e.c2d;switch(r){case\"count\":return a;case\"first\":return o;case\"last\":return s;case\"sum\":return function(t,e){for(var r=0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r+=o)}return i(r)};case\"avg\":return function(t,e){for(var r=0,a=0,o=0;o<e.length;o++){var s=n(t[e[o]]);s!==h&&(r+=s,a++)}return a?i(r/a):h};case\"min\":return function(t,e){for(var r=1/0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r=Math.min(r,o))}return r===1/0?h:i(r)};case\"max\":return function(t,e){for(var r=-1/0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r=Math.max(r,o))}return r===-1/0?h:i(r)};case\"median\":return function(t,e){for(var r=[],a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&r.push(o)}if(!r.length)return h;r.sort();var s=(r.length-1)/2;return i((r[Math.floor(s)]+r[Math.ceil(s)])/2)};case\"mode\":return function(t,e){for(var r={},a=0,o=h,s=0;s<e.length;s++){var l=n(t[e[s]]);if(l!==h){var u=r[l]=(r[l]||0)+1;u>a&&(a=u,o=l)}}return a?i(o):h};case\"rms\":return function(t,e){for(var r=0,a=0,o=0;o<e.length;o++){var s=n(t[e[o]]);s!==h&&(r+=s*s,a++)}return a?i(Math.sqrt(r/a)):h};case\"stddev\":return function(e,r){var i,a=0,o=0,s=1,l=h;for(i=0;i<r.length&&l===h;i++)l=n(e[r[i]]);if(l===h)return h;for(;i<r.length;i++){var u=n(e[r[i]]);if(u!==h){var c=u-l;a+=c,o+=c*c,s++}}var f=\"sample\"===t.funcmode?s-1:s;return f?Math.sqrt((o-a*a/s)/f):0}}}function a(t,e){return e.length}function o(t,e){return t[e[0]]}function s(t,e){return t[e[e.length-1]]}var l=t(\"../plots/cartesian/axes\"),u=t(\"../lib\"),c=t(\"../plot_api/plot_schema\"),h=t(\"../constants/numerical\").BADNUM;r.moduleType=\"transform\",r.name=\"aggregate\";var f=r.attributes={enabled:{valType:\"boolean\",dflt:!0},groups:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},aggregations:{_isLinkedToArray:\"aggregation\",target:{valType:\"string\"},func:{valType:\"enumerated\",values:[\"count\",\"sum\",\"avg\",\"median\",\"mode\",\"rms\",\"stddev\",\"min\",\"max\",\"first\",\"last\"],dflt:\"first\"},funcmode:{valType:\"enumerated\",values:[\"sample\",\"population\"],dflt:\"sample\"},enabled:{valType:\"boolean\",dflt:!0}}},d=f.aggregations;r.supplyDefaults=function(t,e){function r(e,r){return u.coerce(t,a,f,e,r)}function n(t,e){return u.coerce(p[i],h,d,t,e)}var i,a={};if(!r(\"enabled\"))return a;var o=c.findArrayAttributes(e),s={};for(i=0;i<o.length;i++)s[o[i]]=1;var l=r(\"groups\");if(!Array.isArray(l)){if(!s[l])return void(a.enabled=!1);s[l]=0}var h,p=t.aggregations,m=a.aggregations=new Array(p.length);if(p)for(i=0;i<p.length;i++){h={};var v=n(\"target\"),g=n(\"func\"),y=n(\"enabled\");y&&v&&(s[v]||\"count\"===g&&void 0===s[v])?(\"stddev\"===g&&n(\"funcmode\"),s[v]=0,m[i]=h):m[i]={enabled:!1}}for(i=0;i<o.length;i++)s[o[i]]&&m.push({target:o[i],func:d.func.dflt,enabled:!0});return a},r.calcTransform=function(t,e,r){if(r.enabled){var i=r.groups,a=u.getTargetArray(e,{target:i});if(a){var o,s,l,c={},h=[];for(o=0;o<a.length;o++)s=a[o],l=c[s],void 0===l?(c[s]=h.length,h.push([o])):h[l].push(o);var f=r.aggregations;for(o=0;o<f.length;o++)n(t,e,h,f[o]);\"string\"==typeof i&&n(t,e,h,{target:i,func:\"first\",enabled:!0})}}}},{\"../constants/numerical\":705,\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plots/cartesian/axes\":766}],1100:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){return-1!==t.indexOf(a)}var i,a=t.operation,o=t.value,c=Array.isArray(o),h=function(r){return e(r,0,t.valuecalendar)},f=function(t){return e(t,0,r)};switch(n(s)?i=h(c?o[0]:o):n(l)?i=c?[h(o[0]),h(o[1])]:[h(o),h(o)]:n(u)&&(i=c?o.map(h):[h(o)]),a){case\"=\":return function(t){return f(t)===i};case\"!=\":return function(t){return f(t)!==i};case\"<\":return function(t){return f(t)<i};case\"<=\":return function(t){return f(t)<=i};case\">\":return function(t){return f(t)>i};case\">=\":return function(t){return f(t)>=i};case\"[]\":return function(t){var e=f(t);return e>=i[0]&&e<=i[1]};case\"()\":return function(t){var e=f(t);return e>i[0]&&e<i[1]};case\"[)\":return function(t){var e=f(t);return e>=i[0]&&e<i[1]};case\"(]\":return function(t){var e=f(t);return e>i[0]&&e<=i[1]};case\"][\":return function(t){var e=f(t);return e<=i[0]||e>=i[1]};case\")(\":return function(t){var e=f(t);return e<i[0]||e>i[1]};case\"](\":return function(t){var e=f(t);return e<=i[0]||e>i[1]};case\")[\":return function(t){var e=f(t);return e<i[0]||e>=i[1]};case\"{}\":return function(t){return-1!==i.indexOf(f(t))};case\"}{\":return function(t){return-1===i.indexOf(f(t))}}}var i=t(\"../lib\"),a=t(\"../registry\"),o=t(\"../plots/cartesian/axes\"),s=[\"=\",\"!=\",\"<\",\">=\",\">\",\"<=\"],l=[\"[]\",\"()\",\"[)\",\"(]\",\"][\",\")(\",\"](\",\")[\"],u=[\"{}\",\"}{\"];r.moduleType=\"transform\",r.name=\"filter\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},target:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},operation:{valType:\"enumerated\",values:[].concat(s).concat(l).concat(u),dflt:\"=\"},value:{valType:\"any\",dflt:0},preservegaps:{valType:\"boolean\",dflt:!1}},r.supplyDefaults=function(t){function e(e,a){return i.coerce(t,n,r.attributes,e,a)}var n={};if(e(\"enabled\")){e(\"preservegaps\"),e(\"operation\"),e(\"value\"),e(\"target\");var o=a.getComponentMethod(\"calendars\",\"handleDefaults\");o(t,n,\"valuecalendar\",null),o(t,n,\"targetcalendar\",null)}return n},r.calcTransform=function(t,e,r){function a(t,r){for(var n=0;n<h.length;n++){t(i.nestedProperty(e,h[n]),r)}}if(r.enabled){var s=i.getTargetArray(e,r);if(s){var l=r.target,u=s.length,c=r.targetcalendar,h=e._arrayAttrs;if(\"string\"==typeof l){var f=i.nestedProperty(e,l+\"calendar\").get();f&&(c=f)}var d,p,m=o.getDataToCoordFunc(t,e,l,s),v=n(r,m,c),g={};r.preservegaps?(d=function(t){g[t.astr]=i.extendDeep([],t.get()),t.set(new Array(u))},p=function(t,e){var r=g[t.astr][e];t.get()[e]=r}):(d=function(t){g[t.astr]=i.extendDeep([],t.get()),t.set([])},p=function(t,e){var r=g[t.astr][e];t.get().push(r)}),a(d);for(var y=0;y<u;y++){v(s[y])&&a(p,y)}}}}},{\"../lib\":725,\"../plots/cartesian/axes\":766,\"../registry\":844}],1101:[function(t,e,r){\"use strict\";function n(t,e){var r,n,s,l,u,c,h,f,d,p,m=e.transform,v=t.transforms[e.transformIndex].groups;if(!Array.isArray(v)||0===v.length)return[t];var g=i.filterUnique(v),y=new Array(g.length),b=v.length,x=a.findArrayAttributes(t),_=m.styles||[],w={};for(r=0;r<_.length;r++)w[_[r].target]=_[r].value;m.styles&&(p=i.keyedContainer(m,\"styles\",\"target\",\"value.name\"));var M={};for(r=0;r<g.length;r++){c=g[r],M[c]=r,h=y[r]=i.extendDeepNoArrays({},t),h._group=c;var k=null;for(p&&(k=p.get(c)),h.name=k||i.templateString(m.nameformat,{trace:t.name,group:c}),f=h.transforms,h.transforms=[],n=0;n<f.length;n++)h.transforms[n]=i.extendDeepNoArrays({},f[n]);for(n=0;n<x.length;n++)i.nestedProperty(h,x[n]).set([])}for(s=0;s<x.length;s++){for(l=x[s],n=0,d=[];n<g.length;n++)d[n]=i.nestedProperty(y[n],l).get();for(u=i.nestedProperty(t,l).get(),n=0;n<b;n++)d[M[v[n]]].push(u[n])}for(r=0;r<g.length;r++)c=g[r],h=y[r],o.clearExpandedTraceDefaultColors(h),h=i.extendDeepNoArrays(h,w[c]||{});return y}var i=t(\"../lib\"),a=t(\"../plot_api/plot_schema\"),o=t(\"../plots/plots\");r.moduleType=\"transform\",r.name=\"groupby\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},groups:{valType:\"data_array\",dflt:[]},nameformat:{valType:\"string\"},styles:{_isLinkedToArray:\"style\",target:{valType:\"string\"},value:{valType:\"any\",dflt:{}}}},r.supplyDefaults=function(t,e,n){function a(e,n){return i.coerce(t,s,r.attributes,e,n)}var o,s={};if(!a(\"enabled\"))return s;a(\"groups\"),a(\"nameformat\",n._dataLength>1?\"%{group} (%{trace})\":\"%{group}\");var l=t.styles,u=s.styles=[];if(l)for(o=0;o<l.length;o++)u[o]={},i.coerce(l[o],u[o],r.attributes.styles,\"target\"),i.coerce(l[o],u[o],r.attributes.styles,\"value\");return s},r.transform=function(t,e){var r,i,a,o=[];for(i=0;i<t.length;i++)for(r=n(t[i],e),a=0;a<r.length;a++)o.push(r[a]);return o}},{\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plots/plots\":829}],1102:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=e.length,a=new Array(n),o=e.slice().sort(i(t,r)),s=0;s<n;s++)for(var l=e[s],u=0;u<n;u++){var c=o[u];if(l===c){a[u]=s,o[u]=null;break}}return a}function i(t,e){switch(t.order){case\"ascending\":return function(t,r){return e(t)-e(r)};case\"descending\":return function(t,r){return e(r)-e(t)}}}var a=t(\"../lib\"),o=t(\"../plots/cartesian/axes\");r.moduleType=\"transform\",r.name=\"sort\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},target:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},order:{valType:\"enumerated\",values:[\"ascending\",\"descending\"],dflt:\"ascending\"}},r.supplyDefaults=function(t){function e(e,i){return a.coerce(t,n,r.attributes,e,i)}var n={};return e(\"enabled\")&&(e(\"target\"),e(\"order\")),n},r.calcTransform=function(t,e,r){if(r.enabled){var i=a.getTargetArray(e,r);if(i)for(var s=r.target,l=i.length,u=e._arrayAttrs,c=o.getDataToCoordFunc(t,e,s,i),h=n(r,i,c),f=0;f<u.length;f++){for(var d=a.nestedProperty(e,u[f]),p=d.get(),m=new Array(l),v=0;v<l;v++)m[v]=p[h[v]];d.set(m)}}}},{\"../lib\":725,\"../plots/cartesian/axes\":766}]},{},[20])(20)});\n",
       "});require(['plotly'], function(Plotly) {window.Plotly = Plotly;});}</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<script type='text/javascript'>if(!window.Plotly){define('plotly', function(require, exports, module) {/**\n",
       "* plotly.js v1.30.0\n",
       "* Copyright 2012-2017, Plotly, Inc.\n",
       "* All rights reserved.\n",
       "* Licensed under the MIT license\n",
       "*/\n",
       "!function(t){if(\"object\"==typeof exports&&\"undefined\"!=typeof module)module.exports=t();else if(\"function\"==typeof define&&define.amd)define([],t);else{var e;e=\"undefined\"!=typeof window?window:\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:this,e.Plotly=t()}}(function(){var t;return function t(e,r,n){function i(o,s){if(!r[o]){if(!e[o]){var l=\"function\"==typeof require&&require;if(!s&&l)return l(o,!0);if(a)return a(o,!0);var u=new Error(\"Cannot find module '\"+o+\"'\");throw u.code=\"MODULE_NOT_FOUND\",u}var c=r[o]={exports:{}};e[o][0].call(c.exports,function(t){var r=e[o][1][t];return i(r||t)},c,c.exports,t,e,r,n)}return r[o].exports}for(var a=\"function\"==typeof require&&require,o=0;o<n.length;o++)i(n[o]);return i}({1:[function(t,e,r){\"use strict\";var n=t(\"../src/lib\"),i={\"X,X div\":\"font-family:'Open Sans', verdana, arial, sans-serif;margin:0;padding:0;\",\"X input,X button\":\"font-family:'Open Sans', verdana, arial, sans-serif;\",\"X input:focus,X button:focus\":\"outline:none;\",\"X a\":\"text-decoration:none;\",\"X a:hover\":\"text-decoration:none;\",\"X .crisp\":\"shape-rendering:crispEdges;\",\"X .user-select-none\":\"-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;-o-user-select:none;user-select:none;\",\"X svg\":\"overflow:hidden;\",\"X svg a\":\"fill:#447adb;\",\"X svg a:hover\":\"fill:#3c6dc5;\",\"X .main-svg\":\"position:absolute;top:0;left:0;pointer-events:none;\",\"X .main-svg .draglayer\":\"pointer-events:all;\",\"X .cursor-default\":\"cursor:default;\",\"X .cursor-pointer\":\"cursor:pointer;\",\"X .cursor-crosshair\":\"cursor:crosshair;\",\"X .cursor-move\":\"cursor:move;\",\"X .cursor-col-resize\":\"cursor:col-resize;\",\"X .cursor-row-resize\":\"cursor:row-resize;\",\"X .cursor-ns-resize\":\"cursor:ns-resize;\",\"X .cursor-ew-resize\":\"cursor:ew-resize;\",\"X .cursor-sw-resize\":\"cursor:sw-resize;\",\"X .cursor-s-resize\":\"cursor:s-resize;\",\"X .cursor-se-resize\":\"cursor:se-resize;\",\"X .cursor-w-resize\":\"cursor:w-resize;\",\"X .cursor-e-resize\":\"cursor:e-resize;\",\"X .cursor-nw-resize\":\"cursor:nw-resize;\",\"X .cursor-n-resize\":\"cursor:n-resize;\",\"X .cursor-ne-resize\":\"cursor:ne-resize;\",\"X .modebar\":\"position:absolute;top:2px;right:2px;z-index:1001;background:rgba(255,255,255,0.7);\",\"X .modebar--hover\":\"opacity:0;-webkit-transition:opacity 0.3s ease 0s;-moz-transition:opacity 0.3s ease 0s;-ms-transition:opacity 0.3s ease 0s;-o-transition:opacity 0.3s ease 0s;transition:opacity 0.3s ease 0s;\",\"X:hover .modebar--hover\":\"opacity:1;\",\"X .modebar-group\":\"float:left;display:inline-block;box-sizing:border-box;margin-left:8px;position:relative;vertical-align:middle;white-space:nowrap;\",\"X .modebar-group:first-child\":\"margin-left:0px;\",\"X .modebar-btn\":\"position:relative;font-size:16px;padding:3px 4px;cursor:pointer;line-height:normal;box-sizing:border-box;\",\"X .modebar-btn svg\":\"position:relative;top:2px;\",\"X .modebar-btn path\":\"fill:rgba(0,31,95,0.3);\",\"X .modebar-btn.active path,X .modebar-btn:hover path\":\"fill:rgba(0,22,72,0.5);\",\"X .modebar-btn.modebar-btn--logo\":\"padding:3px 1px;\",\"X .modebar-btn.modebar-btn--logo path\":\"fill:#447adb !important;\",\"X [data-title]:before,X [data-title]:after\":\"position:absolute;-webkit-transform:translate3d(0, 0, 0);-moz-transform:translate3d(0, 0, 0);-ms-transform:translate3d(0, 0, 0);-o-transform:translate3d(0, 0, 0);transform:translate3d(0, 0, 0);display:none;opacity:0;z-index:1001;pointer-events:none;top:110%;right:50%;\",\"X [data-title]:hover:before,X [data-title]:hover:after\":\"display:block;opacity:1;\",\"X [data-title]:before\":\"content:'';position:absolute;background:transparent;border:6px solid transparent;z-index:1002;margin-top:-12px;border-bottom-color:#69738a;margin-right:-6px;\",\"X [data-title]:after\":\"content:attr(data-title);background:#69738a;color:white;padding:8px 10px;font-size:12px;line-height:12px;white-space:nowrap;margin-right:-18px;border-radius:2px;\",\"X .select-outline\":\"fill:none;stroke-width:1;shape-rendering:crispEdges;\",\"X .select-outline-1\":\"stroke:white;\",\"X .select-outline-2\":\"stroke:black;stroke-dasharray:2px 2px;\",Y:\"font-family:'Open Sans';position:fixed;top:50px;right:20px;z-index:10000;font-size:10pt;max-width:180px;\",\"Y p\":\"margin:0;\",\"Y .notifier-note\":\"min-width:180px;max-width:250px;border:1px solid #fff;z-index:3000;margin:0;background-color:#8c97af;background-color:rgba(140,151,175,0.9);color:#fff;padding:10px;\",\"Y .notifier-close\":\"color:#fff;opacity:0.8;float:right;padding:0 5px;background:none;border:none;font-size:20px;font-weight:bold;line-height:20px;\",\"Y .notifier-close:hover\":\"color:#444;text-decoration:none;cursor:pointer;\"};for(var a in i){var o=a.replace(/^,/,\" ,\").replace(/X/g,\".js-plotly-plot .plotly\").replace(/Y/g,\".plotly-notifier\");n.addStyleRule(o,i[a])}},{\"../src/lib\":725}],2:[function(t,e,r){\"use strict\";e.exports={undo:{width:857.1,path:\"m857 350q0-87-34-166t-91-137-137-92-166-34q-96 0-183 41t-147 114q-4 6-4 13t5 11l76 77q6 5 14 5 9-1 13-7 41-53 100-82t126-29q58 0 110 23t92 61 61 91 22 111-22 111-61 91-92 61-110 23q-55 0-105-20t-90-57l77-77q17-16 8-38-10-23-33-23h-250q-15 0-25 11t-11 25v250q0 24 22 33 22 10 39-8l72-72q60 57 137 88t159 31q87 0 166-34t137-92 91-137 34-166z\",ascent:850,descent:-150},home:{width:928.6,path:\"m786 296v-267q0-15-11-26t-25-10h-214v214h-143v-214h-214q-15 0-25 10t-11 26v267q0 1 0 2t0 2l321 264 321-264q1-1 1-4z m124 39l-34-41q-5-5-12-6h-2q-7 0-12 3l-386 322-386-322q-7-4-13-4-7 2-12 7l-35 41q-4 5-3 13t6 12l401 334q18 15 42 15t43-15l136-114v109q0 8 5 13t13 5h107q8 0 13-5t5-13v-227l122-102q5-5 6-12t-4-13z\",ascent:850,descent:-150},\"camera-retro\":{width:1e3,path:\"m518 386q0 8-5 13t-13 5q-37 0-63-27t-26-63q0-8 5-13t13-5 12 5 5 13q0 23 16 38t38 16q8 0 13 5t5 13z m125-73q0-59-42-101t-101-42-101 42-42 101 42 101 101 42 101-42 42-101z m-572-320h858v71h-858v-71z m643 320q0 89-62 152t-152 62-151-62-63-152 63-151 151-63 152 63 62 151z m-571 358h214v72h-214v-72z m-72-107h858v143h-462l-36-71h-360v-72z m929 143v-714q0-30-21-51t-50-21h-858q-29 0-50 21t-21 51v714q0 30 21 51t50 21h858q29 0 50-21t21-51z\",ascent:850,descent:-150},zoombox:{width:1e3,path:\"m1000-25l-250 251c40 63 63 138 63 218 0 224-182 406-407 406-224 0-406-182-406-406s183-406 407-406c80 0 155 22 218 62l250-250 125 125z m-812 250l0 438 437 0 0-438-437 0z m62 375l313 0 0-312-313 0 0 312z\",ascent:850,descent:-150},pan:{width:1e3,path:\"m1000 350l-187 188 0-125-250 0 0 250 125 0-188 187-187-187 125 0 0-250-250 0 0 125-188-188 186-187 0 125 252 0 0-250-125 0 187-188 188 188-125 0 0 250 250 0 0-126 187 188z\",ascent:850,descent:-150},zoom_plus:{width:1e3,path:\"m1 787l0-875 875 0 0 875-875 0z m687-500l-187 0 0-187-125 0 0 187-188 0 0 125 188 0 0 187 125 0 0-187 187 0 0-125z\",ascent:850,descent:-150},zoom_minus:{width:1e3,path:\"m0 788l0-876 875 0 0 876-875 0z m688-500l-500 0 0 125 500 0 0-125z\",ascent:850,descent:-150},autoscale:{width:1e3,path:\"m250 850l-187 0-63 0 0-62 0-188 63 0 0 188 187 0 0 62z m688 0l-188 0 0-62 188 0 0-188 62 0 0 188 0 62-62 0z m-875-938l0 188-63 0 0-188 0-62 63 0 187 0 0 62-187 0z m875 188l0-188-188 0 0-62 188 0 62 0 0 62 0 188-62 0z m-125 188l-1 0-93-94-156 156 156 156 92-93 2 0 0 250-250 0 0-2 93-92-156-156-156 156 94 92 0 2-250 0 0-250 0 0 93 93 157-156-157-156-93 94 0 0 0-250 250 0 0 0-94 93 156 157 156-157-93-93 0 0 250 0 0 250z\",ascent:850,descent:-150},tooltip_basic:{width:1500,path:\"m375 725l0 0-375-375 375-374 0-1 1125 0 0 750-1125 0z\",ascent:850,descent:-150},tooltip_compare:{width:1125,path:\"m187 786l0 2-187-188 188-187 0 0 937 0 0 373-938 0z m0-499l0 1-187-188 188-188 0 0 937 0 0 376-938-1z\",ascent:850,descent:-150},plotlylogo:{width:1542,path:\"m0-10h182v-140h-182v140z m228 146h183v-286h-183v286z m225 714h182v-1000h-182v1000z m225-285h182v-715h-182v715z m225 142h183v-857h-183v857z m231-428h182v-429h-182v429z m225-291h183v-138h-183v138z\",ascent:850,descent:-150},\"z-axis\":{width:1e3,path:\"m833 5l-17 108v41l-130-65 130-66c0 0 0 38 0 39 0-1 36-14 39-25 4-15-6-22-16-30-15-12-39-16-56-20-90-22-187-23-279-23-261 0-341 34-353 59 3 60 228 110 228 110-140-8-351-35-351-116 0-120 293-142 474-142 155 0 477 22 477 142 0 50-74 79-163 96z m-374 94c-58-5-99-21-99-40 0-24 65-43 144-43 79 0 143 19 143 43 0 19-42 34-98 40v216h87l-132 135-133-135h88v-216z m167 515h-136v1c16 16 31 34 46 52l84 109v54h-230v-71h124v-1c-16-17-28-32-44-51l-89-114v-51h245v72z\",ascent:850,descent:-150},\"3d_rotate\":{width:1e3,path:\"m922 660c-5 4-9 7-14 11-359 263-580-31-580-31l-102 28 58-400c0 1 1 1 2 2 118 108 351 249 351 249s-62 27-100 42c88 83 222 183 347 122 16-8 30-17 44-27-2 1-4 2-6 4z m36-329c0 0 64 229-88 296-62 27-124 14-175-11 157-78 225-208 249-266 8-19 11-31 11-31 2 5 6 15 11 32-5-13-8-20-8-20z m-775-239c70-31 117-50 198-32-121 80-199 346-199 346l-96-15-58-12c0 0 55-226 155-287z m603 133l-317-139c0 0 4-4 19-14 7-5 24-15 24-15s-177-147-389 4c235-287 536-112 536-112l31-22 100 299-4-1z m-298-153c6-4 14-9 24-15 0 0-17 10-24 15z\",ascent:850,descent:-150},camera:{width:1e3,path:\"m500 450c-83 0-150-67-150-150 0-83 67-150 150-150 83 0 150 67 150 150 0 83-67 150-150 150z m400 150h-120c-16 0-34 13-39 29l-31 93c-6 15-23 28-40 28h-340c-16 0-34-13-39-28l-31-94c-6-15-23-28-40-28h-120c-55 0-100-45-100-100v-450c0-55 45-100 100-100h800c55 0 100 45 100 100v450c0 55-45 100-100 100z m-400-550c-138 0-250 112-250 250 0 138 112 250 250 250 138 0 250-112 250-250 0-138-112-250-250-250z m365 380c-19 0-35 16-35 35 0 19 16 35 35 35 19 0 35-16 35-35 0-19-16-35-35-35z\",ascent:850,descent:-150},movie:{width:1e3,path:\"m938 413l-188-125c0 37-17 71-44 94 64 38 107 107 107 187 0 121-98 219-219 219-121 0-219-98-219-219 0-61 25-117 66-156h-115c30 33 49 76 49 125 0 103-84 187-187 187s-188-84-188-187c0-57 26-107 65-141-38-22-65-62-65-109v-250c0-70 56-126 125-126h500c69 0 125 56 125 126l188-126c34 0 62 28 62 63v375c0 35-28 63-62 63z m-750 0c-69 0-125 56-125 125s56 125 125 125 125-56 125-125-56-125-125-125z m406-1c-87 0-157 70-157 157 0 86 70 156 157 156s156-70 156-156-70-157-156-157z\",ascent:850,descent:-150},question:{width:857.1,path:\"m500 82v107q0 8-5 13t-13 5h-107q-8 0-13-5t-5-13v-107q0-8 5-13t13-5h107q8 0 13 5t5 13z m143 375q0 49-31 91t-77 65-95 23q-136 0-207-119-9-14 4-24l74-55q4-4 10-4 9 0 14 7 30 38 48 51 19 14 48 14 27 0 48-15t21-33q0-21-11-34t-38-25q-35-16-65-48t-29-70v-20q0-8 5-13t13-5h107q8 0 13 5t5 13q0 10 12 27t30 28q18 10 28 16t25 19 25 27 16 34 7 45z m214-107q0-117-57-215t-156-156-215-58-216 58-155 156-58 215 58 215 155 156 216 58 215-58 156-156 57-215z\",ascent:850,descent:-150},disk:{width:857.1,path:\"m214-7h429v214h-429v-214z m500 0h72v500q0 8-6 21t-11 20l-157 156q-5 6-19 12t-22 5v-232q0-22-15-38t-38-16h-322q-22 0-37 16t-16 38v232h-72v-714h72v232q0 22 16 38t37 16h465q22 0 38-16t15-38v-232z m-214 518v178q0 8-5 13t-13 5h-107q-7 0-13-5t-5-13v-178q0-8 5-13t13-5h107q7 0 13 5t5 13z m357-18v-518q0-22-15-38t-38-16h-750q-23 0-38 16t-16 38v750q0 22 16 38t38 16h517q23 0 50-12t42-26l156-157q16-15 27-42t11-49z\",ascent:850,descent:-150},lasso:{width:1031,path:\"m1018 538c-36 207-290 336-568 286-277-48-473-256-436-463 10-57 36-108 76-151-13-66 11-137 68-183 34-28 75-41 114-42l-55-70 0 0c-2-1-3-2-4-3-10-14-8-34 5-45 14-11 34-8 45 4 1 1 2 3 2 5l0 0 113 140c16 11 31 24 45 40 4 3 6 7 8 11 48-3 100 0 151 9 278 48 473 255 436 462z m-624-379c-80 14-149 48-197 96 42 42 109 47 156 9 33-26 47-66 41-105z m-187-74c-19 16-33 37-39 60 50-32 109-55 174-68-42-25-95-24-135 8z m360 75c-34-7-69-9-102-8 8 62-16 128-68 170-73 59-175 54-244-5-9 20-16 40-20 61-28 159 121 317 333 354s407-60 434-217c28-159-121-318-333-355z\",ascent:850,descent:-150},selectbox:{width:1e3,path:\"m0 850l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-285l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z\",ascent:850,descent:-150},spikeline:{width:1e3,path:\"M512 409c0-57-46-104-103-104-57 0-104 47-104 104 0 57 47 103 104 103 57 0 103-46 103-103z m-327-39l92 0 0 92-92 0z m-185 0l92 0 0 92-92 0z m370-186l92 0 0 93-92 0z m0-184l92 0 0 92-92 0z\",ascent:850,descent:-150}}},{}],3:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/aggregate\")},{\"../src/transforms/aggregate\":1099}],4:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/bar\")},{\"../src/traces/bar\":858}],5:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/box\")},{\"../src/traces/box\":870}],6:[function(t,e,r){\"use strict\";e.exports=t(\"../src/components/calendars\")},{\"../src/components/calendars\":601}],7:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/candlestick\")},{\"../src/traces/candlestick\":878}],8:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/carpet\")},{\"../src/traces/carpet\":899}],9:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/choropleth\")},{\"../src/traces/choropleth\":914}],10:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/contour\")},{\"../src/traces/contour\":925}],11:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/contourcarpet\")},{\"../src/traces/contourcarpet\":940}],12:[function(t,e,r){\"use strict\";e.exports=t(\"../src/core\")},{\"../src/core\":708}],13:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/filter\")},{\"../src/transforms/filter\":1100}],14:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/groupby\")},{\"../src/transforms/groupby\":1101}],15:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/heatmap\")},{\"../src/traces/heatmap\":953}],16:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/heatmapgl\")},{\"../src/traces/heatmapgl\":962}],17:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram\")},{\"../src/traces/histogram\":970}],18:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram2d\")},{\"../src/traces/histogram2d\":975}],19:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/histogram2dcontour\")},{\"../src/traces/histogram2dcontour\":979}],20:[function(t,e,r){\"use strict\";var n=t(\"./core\");n.register([t(\"./bar\"),t(\"./box\"),t(\"./heatmap\"),t(\"./histogram\"),t(\"./histogram2d\"),t(\"./histogram2dcontour\"),t(\"./pie\"),t(\"./contour\"),t(\"./scatterternary\"),t(\"./sankey\"),t(\"./scatter3d\"),t(\"./surface\"),t(\"./mesh3d\"),t(\"./scattergeo\"),t(\"./choropleth\"),t(\"./scattergl\"),t(\"./pointcloud\"),t(\"./heatmapgl\"),t(\"./parcoords\"),t(\"./scattermapbox\"),t(\"./carpet\"),t(\"./scattercarpet\"),t(\"./contourcarpet\"),t(\"./ohlc\"),t(\"./candlestick\")]),n.register([t(\"./aggregate\"),t(\"./filter\"),t(\"./groupby\"),t(\"./sort\")]),n.register([t(\"./calendars\")]),e.exports=n},{\"./aggregate\":3,\"./bar\":4,\"./box\":5,\"./calendars\":6,\"./candlestick\":7,\"./carpet\":8,\"./choropleth\":9,\"./contour\":10,\"./contourcarpet\":11,\"./core\":12,\"./filter\":13,\"./groupby\":14,\"./heatmap\":15,\"./heatmapgl\":16,\"./histogram\":17,\"./histogram2d\":18,\"./histogram2dcontour\":19,\"./mesh3d\":21,\"./ohlc\":22,\"./parcoords\":23,\"./pie\":24,\"./pointcloud\":25,\"./sankey\":26,\"./scatter3d\":27,\"./scattercarpet\":28,\"./scattergeo\":29,\"./scattergl\":30,\"./scattermapbox\":31,\"./scatterternary\":32,\"./sort\":33,\"./surface\":34}],21:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/mesh3d\")},{\"../src/traces/mesh3d\":985}],22:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/ohlc\")},{\"../src/traces/ohlc\":990}],23:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/parcoords\")},{\"../src/traces/parcoords\":999}],24:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/pie\")},{\"../src/traces/pie\":1008}],25:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/pointcloud\")},{\"../src/traces/pointcloud\":1017}],26:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/sankey\")},{\"../src/traces/sankey\":1023}],27:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scatter3d\")},{\"../src/traces/scatter3d\":1055}],28:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattercarpet\")},{\"../src/traces/scattercarpet\":1060}],29:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattergeo\")},{\"../src/traces/scattergeo\":1069}],30:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattergl\")},{\"../src/traces/scattergl\":1075}],31:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scattermapbox\")},{\"../src/traces/scattermapbox\":1082}],32:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/scatterternary\")},{\"../src/traces/scatterternary\":1089}],33:[function(t,e,r){\"use strict\";e.exports=t(\"../src/transforms/sort\")},{\"../src/transforms/sort\":1102}],34:[function(t,e,r){\"use strict\";e.exports=t(\"../src/traces/surface\")},{\"../src/traces/surface\":1098}],35:[function(t,e,r){\"use strict\";function n(t,e){function r(e,r,n,a){var o=1/t.clientHeight,s=o*(r-m),l=o*(n-v),c=p.flipX?1:-1,f=p.flipY?1:-1,d=Math.PI*p.rotateSpeed,y=i();if(1&e)a.shift?u.rotate(y,0,0,-s*d):u.rotate(y,c*d*s,-f*d*l,0);else if(2&e)u.pan(y,-p.translateSpeed*s*h,p.translateSpeed*l*h,0);else if(4&e){var b=p.zoomSpeed*l/window.innerHeight*(y-u.lastT())*50;u.pan(y,0,0,h*(Math.exp(b)-1))}m=r,v=n,g=a}t=t||document.body,e=e||{};var n=[.01,1/0];\"distanceLimits\"in e&&(n[0]=e.distanceLimits[0],n[1]=e.distanceLimits[1]),\"zoomMin\"in e&&(n[0]=e.zoomMin),\"zoomMax\"in e&&(n[1]=e.zoomMax);var u=a({center:e.center||[0,0,0],up:e.up||[0,1,0],eye:e.eye||[0,0,10],mode:e.mode||\"orbit\",distanceLimits:n}),c=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],h=0,f=t.clientWidth,d=t.clientHeight,p={view:u,element:t,delay:e.delay||16,rotateSpeed:e.rotateSpeed||1,zoomSpeed:e.zoomSpeed||1,translateSpeed:e.translateSpeed||1,flipX:!!e.flipX,flipY:!!e.flipY,modes:u.modes,tick:function(){var e=i(),r=this.delay;u.idle(e-r),u.flush(e-(100+2*r));var n=e-2*r;u.recalcMatrix(n);for(var a=!0,o=u.computedMatrix,s=0;s<16;++s)a=a&&c[s]===o[s],c[s]=o[s];var l=t.clientWidth===f&&t.clientHeight===d;return f=t.clientWidth,d=t.clientHeight,a?!l:(h=Math.exp(u.computedRadius[0]),!0)},lookAt:function(t,e,r){u.lookAt(u.lastT(),t,e,r)},rotate:function(t,e,r){u.rotate(u.lastT(),t,e,r)},pan:function(t,e,r){u.pan(u.lastT(),t,e,r)},translate:function(t,e,r){u.translate(u.lastT(),t,e,r)}};Object.defineProperties(p,{matrix:{get:function(){return u.computedMatrix},set:function(t){return u.setMatrix(u.lastT(),t),u.computedMatrix},enumerable:!0},mode:{get:function(){return u.getMode()},set:function(t){return u.setMode(t),u.getMode()},enumerable:!0},center:{get:function(){return u.computedCenter},set:function(t){return u.lookAt(u.lastT(),t),u.computedCenter},enumerable:!0},eye:{get:function(){return u.computedEye},set:function(t){return u.lookAt(u.lastT(),null,t),u.computedEye},enumerable:!0},up:{get:function(){return u.computedUp},set:function(t){return u.lookAt(u.lastT(),null,null,t),u.computedUp},enumerable:!0},distance:{get:function(){return h},set:function(t){return u.setDistance(u.lastT(),t),t},enumerable:!0},distanceLimits:{get:function(){return u.getDistanceLimits(n)},set:function(t){return u.setDistanceLimits(t),t},enumerable:!0}}),t.addEventListener(\"contextmenu\",function(t){return t.preventDefault(),!1});var m=0,v=0,g={shift:!1,control:!1,alt:!1,meta:!1};return o(t,r),t.addEventListener(\"touchstart\",function(e){var n=l(e.changedTouches[0],t);r(0,n[0],n[1],g),r(1,n[0],n[1],g)}),t.addEventListener(\"touchmove\",function(e){var n=l(e.changedTouches[0],t);r(1,n[0],n[1],g)}),t.addEventListener(\"touchend\",function(e){l(e.changedTouches[0],t);r(0,m,v,g)}),s(t,function(t,e,r){var n=p.flipX?1:-1,a=p.flipY?1:-1,o=i();if(Math.abs(t)>Math.abs(e))u.rotate(o,0,0,-t*n*Math.PI*p.rotateSpeed/window.innerWidth);else{var s=p.zoomSpeed*a*e/window.innerHeight*(o-u.lastT())/100;u.pan(o,0,0,h*(Math.exp(s)-1))}},!0),p}e.exports=n;var i=t(\"right-now\"),a=t(\"3d-view\"),o=t(\"mouse-change\"),s=t(\"mouse-wheel\"),l=t(\"mouse-event-offset\")},{\"3d-view\":36,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454,\"right-now\":501}],36:[function(t,e,r){\"use strict\";function n(t,e){this._controllerNames=Object.keys(t),this._controllerList=this._controllerNames.map(function(e){return t[e]}),this._mode=e,this._active=t[e],this._active||(this._mode=\"turntable\",this._active=t.turntable),this.modes=this._controllerNames,this.computedMatrix=this._active.computedMatrix,this.computedEye=this._active.computedEye,this.computedUp=this._active.computedUp,this.computedCenter=this._active.computedCenter,this.computedRadius=this._active.computedRadius}function i(t){t=t||{};var e=t.eye||[0,0,1],r=t.center||[0,0,0],i=t.up||[0,1,0],l=t.distanceLimits||[0,1/0],u=t.mode||\"turntable\",c=a(),h=o(),f=s();return c.setDistanceLimits(l[0],l[1]),c.lookAt(0,e,r,i),h.setDistanceLimits(l[0],l[1]),h.lookAt(0,e,r,i),f.setDistanceLimits(l[0],l[1]),f.lookAt(0,e,r,i),new n({turntable:c,orbit:h,matrix:f},u)}e.exports=i;var a=t(\"turntable-camera-controller\"),o=t(\"orbit-camera-controller\"),s=t(\"matrix-camera-controller\"),l=n.prototype;[[\"flush\",1],[\"idle\",1],[\"lookAt\",4],[\"rotate\",4],[\"pan\",4],[\"translate\",4],[\"setMatrix\",2],[\"setDistanceLimits\",2],[\"setDistance\",2]].forEach(function(t){for(var e=t[0],r=[],n=0;n<t[1];++n)r.push(\"a\"+n);var i=\"var cc=this._controllerList;for(var i=0;i<cc.length;++i){cc[i].\"+t[0]+\"(\"+r.join()+\")}\";l[e]=Function.apply(null,r.concat(i))}),l.recalcMatrix=function(t){this._active.recalcMatrix(t)},l.getDistance=function(t){return this._active.getDistance(t)},l.getDistanceLimits=function(t){return this._active.getDistanceLimits(t)},l.lastT=function(){return this._active.lastT()},l.setMode=function(t){if(t!==this._mode){var e=this._controllerNames.indexOf(t);if(!(e<0)){var r=this._active,n=this._controllerList[e],i=Math.max(r.lastT(),n.lastT());r.recalcMatrix(i),n.setMatrix(i,r.computedMatrix),this._active=n,this._mode=t,this.computedMatrix=this._active.computedMatrix,this.computedEye=this._active.computedEye,this.computedUp=this._active.computedUp,this.computedCenter=this._active.computedCenter,this.computedRadius=this._active.computedRadius}}},l.getMode=function(){return this._mode}},{\"matrix-camera-controller\":449,\"orbit-camera-controller\":472,\"turntable-camera-controller\":537}],37:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-array\"),e(\"d3-collection\"),e(\"d3-interpolate\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-array\",\"d3-collection\",\"d3-interpolate\"],a):a(i.d3=i.d3||{},i.d3,i.d3,i.d3)}(this,function(t,e,r,n){\"use strict\";var i=function(){function t(){v.forEach(function(t){t.sourceLinks=[],t.targetLinks=[]}),g.forEach(function(t,e){var r=t.source,n=t.target;\"number\"==typeof r&&(r=t.source=v[t.source]),\"number\"==typeof n&&(n=t.target=v[t.target]),t.originalIndex=e,r.sourceLinks.push(t),n.targetLinks.push(t)})}function i(){v.forEach(function(t){t.value=Math.max(e.sum(t.sourceLinks,h),e.sum(t.targetLinks,h))})}function a(){for(var t,e=v,r=0;e.length;)t=[],e.forEach(function(e){e.x=r,e.dx=d,e.sourceLinks.forEach(function(e){t.indexOf(e.target)<0&&t.push(e.target)})}),e=t,++r;o(r),s((m[0]-d)/(r-1))}function o(t){v.forEach(function(e){e.sourceLinks.length||(e.x=t-1)})}function s(t){v.forEach(function(e){e.x*=t})}function l(t){function n(){a.forEach(function(t){var e,r,n,a=0,o=t.length;for(t.sort(i),n=0;n<o;++n)e=t[n],r=a-e.y,r>0&&(e.y+=r),a=e.y+e.dy+p;if((r=a-p-m[1])>0)for(a=e.y-=r,n=o-2;n>=0;--n)e=t[n],r=e.y+e.dy+p-a,r>0&&(e.y-=r),a=e.y})}function i(t,e){return t.y-e.y}var a=r.nest().key(function(t){return t.x}).sortKeys(e.ascending).entries(v).map(function(t){return t.values});!function(){var t=e.min(a,function(t){return(m[1]-(t.length-1)*p)/e.sum(t,h)});a.forEach(function(e){e.forEach(function(e,r){e.y=r,e.dy=e.value*t})}),g.forEach(function(e){e.dy=e.value*t})}(),n();for(var o=1;t>0;--t)!function(t){function r(t){return c(t.target)*t.value}a.slice().reverse().forEach(function(n){n.forEach(function(n){if(n.sourceLinks.length){var i=e.sum(n.sourceLinks,r)/e.sum(n.sourceLinks,h);n.y+=(i-c(n))*t}})})}(o*=.99),n(),function(t){function r(t){return c(t.source)*t.value}a.forEach(function(n){n.forEach(function(n){if(n.targetLinks.length){var i=e.sum(n.targetLinks,r)/e.sum(n.targetLinks,h);n.y+=(i-c(n))*t}})})}(o),n()}function u(){function t(t,e){return t.source.y-e.source.y||t.originalIndex-e.originalIndex}function e(t,e){return t.target.y-e.target.y||t.originalIndex-e.originalIndex}v.forEach(function(r){r.sourceLinks.sort(e),r.targetLinks.sort(t)}),v.forEach(function(t){var e=0,r=0;t.sourceLinks.forEach(function(t){t.sy=e,e+=t.dy}),t.targetLinks.forEach(function(t){t.ty=r,r+=t.dy})})}function c(t){return t.y+t.dy/2}function h(t){return t.value}var f={},d=24,p=8,m=[1,1],v=[],g=[];return f.nodeWidth=function(t){return arguments.length?(d=+t,f):d},f.nodePadding=function(t){return arguments.length?(p=+t,f):p},f.nodes=function(t){return arguments.length?(v=t,f):v},f.links=function(t){return arguments.length?(g=t,f):g},f.size=function(t){return arguments.length?(m=t,f):m},f.layout=function(e){return t(),i(),a(),l(e),u(),f},f.relayout=function(){return u(),f},f.link=function(){function t(t){var r=t.source.x+t.source.dx,i=t.target.x,a=n.interpolateNumber(r,i),o=a(e),s=a(1-e),l=t.source.y+t.sy,u=l+t.dy,c=t.target.y+t.ty,h=c+t.dy;return\"M\"+r+\",\"+l+\"C\"+o+\",\"+l+\" \"+s+\",\"+c+\" \"+i+\",\"+c+\"L\"+i+\",\"+h+\"C\"+s+\",\"+h+\" \"+o+\",\"+u+\" \"+r+\",\"+u+\"Z\"}var e=.5;return t.curvature=function(r){return arguments.length?(e=+r,t):e},t},f};t.sankey=i,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-array\":113,\"d3-collection\":114,\"d3-interpolate\":118}],38:[function(t,e,r){\"use strict\";function n(t){var e=s.get(t),r=e&&(e._triangleBuffer.handle||e._triangleBuffer.buffer);if(!r||!t.isBuffer(r)){var n=a(t,new Float32Array([-1,-1,-1,4,4,-1]));e=o(t,[{buffer:n,type:t.FLOAT,size:2}]),e._triangleBuffer=n,s.set(t,e)}e.bind(),t.drawArrays(t.TRIANGLES,0,3),e.unbind()}var i=\"undefined\"==typeof WeakMap?t(\"weak-map\"):WeakMap,a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=new i;e.exports=n},{\"gl-buffer\":155,\"gl-vao\":270,\"weak-map\":558}],39:[function(t,e,r){function n(t,e,r){e=\"number\"==typeof e?e:1,r=r||\": \";var n=t.split(/\\r?\\n/),a=String(n.length+e-1).length;return n.map(function(t,n){var o=n+e,s=String(o).length;return i(o,a-s)+r+t}).join(\"\\n\")}var i=t(\"pad-left\");e.exports=n},{\"pad-left\":473}],40:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(e+1),n=0;n<t.length;++n)r[n]=t[n];for(var n=0;n<=t.length;++n){for(var i=t.length;i<=e;++i){for(var o=new Array(e),s=0;s<e;++s)o[s]=Math.pow(i+1-n,s);r[i]=o}if(a.apply(void 0,r))return!0}return!1}function i(t){var e=t.length;if(0===e)return[];if(1===e)return[0];for(var r=t[0].length,i=[t[0]],a=[0],o=1;o<e;++o)if(i.push(t[o]),n(i,r)){if(a.push(o),a.length===r+1)return a}else i.pop();return a}e.exports=i;var a=t(\"robust-orientation\")},{\"robust-orientation\":507}],41:[function(t,e,r){\"use strict\";function n(t,e){return i(e).filter(function(r){for(var n=new Array(r.length),i=0;i<r.length;++i)n[i]=e[r[i]];return a(n)*t<1})}e.exports=n;var i=t(\"delaunay-triangulate\"),a=t(\"circumradius\")},{circumradius:86,\"delaunay-triangulate\":122}],42:[function(t,e,r){function n(t,e){return a(i(t,e))}e.exports=n;var i=t(\"alpha-complex\"),a=t(\"simplicial-complex-boundary\")},{\"alpha-complex\":41,\"simplicial-complex-boundary\":515}],43:[function(t,e,r){\"use strict\";function n(t,e){if(!t||null==t.length)throw Error(\"Argument should be an array\");e=null==e?1:Math.floor(e);for(var r=Array(2*e),n=0;n<e;n++){for(var i=-1/0,a=1/0,o=n,s=t.length;o<s;o+=e)t[o]>i&&(i=t[o]),t[o]<a&&(a=t[o]);r[n]=a,r[e+n]=i}return r}e.exports=n},{}],44:[function(t,e,r){\"use strict\";function n(t,e,r){if(!t||null==t.length)throw Error(\"Argument should be an array\");null==e&&(e=1),null==r&&(r=i(t,e));for(var n=0;n<e;n++){var a=r[e+n],o=r[n],s=n,l=t.length;if(a===1/0&&o===-1/0)for(s=n;s<l;s+=e)t[s]=t[s]===a?1:t[s]===o?0:.5;else if(a===1/0)for(s=n;s<l;s+=e)t[s]=t[s]===a?1:0;else if(o===-1/0)for(s=n;s<l;s+=e)t[s]=t[s]===o?0:1;else{var u=a-o;for(s=n;s<l;s+=e)t[s]=(t[s]-o)/u}}return t}var i=t(\"array-bounds\");e.exports=n},{\"array-bounds\":43}],45:[function(t,e,r){\"use strict\";e.exports=function(){function t(t){return!Array.isArray(t)&&null!==t&&\"object\"==typeof t}function e(t,e,r){for(var n=(e-t)/Math.max(r-1,1),i=[],a=0;a<r;a++)i.push(t+a*n);return i}function r(){for(var t=[].slice.call(arguments),e=t.map(function(t){return t.length}),r=Math.min.apply(null,e),n=[],i=0;i<r;i++){n[i]=[];for(var a=0;a<t.length;++a)n[i][a]=t[a][i]}return n}function n(t,e,r){for(var n=Math.min.apply(null,[t.length,e.length,r.length]),i=[],a=0;a<n;a++)i.push([t[a],e[a],r[a]]);return i}function i(t){function e(t){for(var n=0;n<t.length;n++)Array.isArray(t[n])?e(t[n],r):r+=t[n]}var r=0;return e(t,r),r}function a(t){for(var e=[],r=0;r<t.length;++r){e[r]=[];for(var n=0;n<t[r].length;++n)e[r][n]=t[r][n]}return e}function o(t){for(var e=[],r=0;r<t.length;++r)e[r]=t[r];return e}function s(t,e){if(t.length!==e.length)return!1;for(var r=t.length;r--;)if(t[r]!==e[r])return!1;return!0}function l(t,e){var r,n;if(\"string\"!=typeof t)return t;if(r=[],\"#\"===t[0]?(t=t.substr(1),3===t.length&&(t+=t),n=parseInt(t,16),r[0]=n>>16&255,r[1]=n>>8&255,r[2]=255&n):h.test(t)&&(n=t.match(f),r[0]=parseInt(n[1]),r[1]=parseInt(n[2]),r[2]=parseInt(n[3])),!e)for(var i=0;i<3;++i)r[i]=r[i]/255;return r}function u(t,e){var r,n;if(\"string\"!=typeof t)return t;if(r=[],\"#\"===t[0]?(t=t.substr(1),3===t.length&&(t+=t),n=parseInt(t,16),r[0]=n>>16&255,r[1]=n>>8&255,r[2]=255&n):h.test(t)&&(n=t.match(f),r[0]=parseInt(n[1]),r[1]=parseInt(n[2]),r[2]=parseInt(n[3]),n[4]?r[3]=parseFloat(n[4]):r[3]=1),!e)for(var i=0;i<3;++i)r[i]=r[i]/255;return r}var c={},h=/^rgba?\\(\\s*\\d{1,3}\\s*,\\s*\\d{1,3}\\s*,\\s*\\d{1,3}\\s*(,.*)?\\)$/,f=/^rgba?\\(\\s*(\\d{1,3})\\s*,\\s*(\\d{1,3})\\s*,\\s*(\\d{1,3})\\s*,?\\s*(.*)?\\)$/;return c.isPlainObject=t,c.linspace=e,c.zip3=n,c.sum=i,c.zip=r,c.isEqual=s,c.copy2D=a,c.copy1D=o,c.str2RgbArray=l,c.str2RgbaArray=u,c}()},{}],46:[function(t,e,r){(function(r){\"use strict\";function n(t,e){if(t===e)return 0;for(var r=t.length,n=e.length,i=0,a=Math.min(r,n);i<a;++i)if(t[i]!==e[i]){r=t[i],n=e[i];break}return r<n?-1:n<r?1:0}function i(t){return r.Buffer&&\"function\"==typeof r.Buffer.isBuffer?r.Buffer.isBuffer(t):!(null==t||!t._isBuffer)}function a(t){return Object.prototype.toString.call(t)}function o(t){return!i(t)&&(\"function\"==typeof r.ArrayBuffer&&(\"function\"==typeof ArrayBuffer.isView?ArrayBuffer.isView(t):!!t&&(t instanceof DataView||!!(t.buffer&&t.buffer instanceof ArrayBuffer))))}function s(t){if(x.isFunction(t)){if(M)return t.name;var e=t.toString(),r=e.match(A);return r&&r[1]}}function l(t,e){return\"string\"==typeof t?t.length<e?t:t.slice(0,e):t}function u(t){if(M||!x.isFunction(t))return x.inspect(t);var e=s(t);return\"[Function\"+(e?\": \"+e:\"\")+\"]\"}function c(t){return l(u(t.actual),128)+\" \"+t.operator+\" \"+l(u(t.expected),128)}function h(t,e,r,n,i){throw new k.AssertionError({message:r,actual:t,expected:e,operator:n,stackStartFunction:i})}function f(t,e){t||h(t,!0,e,\"==\",k.ok)}function d(t,e,r,s){if(t===e)return!0;if(i(t)&&i(e))return 0===n(t,e);if(x.isDate(t)&&x.isDate(e))return t.getTime()===e.getTime();if(x.isRegExp(t)&&x.isRegExp(e))return t.source===e.source&&t.global===e.global&&t.multiline===e.multiline&&t.lastIndex===e.lastIndex&&t.ignoreCase===e.ignoreCase;if(null!==t&&\"object\"==typeof t||null!==e&&\"object\"==typeof e){if(o(t)&&o(e)&&a(t)===a(e)&&!(t instanceof Float32Array||t instanceof Float64Array))return 0===n(new Uint8Array(t.buffer),new Uint8Array(e.buffer));if(i(t)!==i(e))return!1;s=s||{actual:[],expected:[]};var l=s.actual.indexOf(t);return-1!==l&&l===s.expected.indexOf(e)||(s.actual.push(t),s.expected.push(e),m(t,e,r,s))}return r?t===e:t==e}function p(t){return\"[object Arguments]\"==Object.prototype.toString.call(t)}function m(t,e,r,n){if(null===t||void 0===t||null===e||void 0===e)return!1;if(x.isPrimitive(t)||x.isPrimitive(e))return t===e;if(r&&Object.getPrototypeOf(t)!==Object.getPrototypeOf(e))return!1;var i=p(t),a=p(e);if(i&&!a||!i&&a)return!1;if(i)return t=w.call(t),e=w.call(e),d(t,e,r);var o,s,l=T(t),u=T(e);if(l.length!==u.length)return!1;for(l.sort(),u.sort(),s=l.length-1;s>=0;s--)if(l[s]!==u[s])return!1;for(s=l.length-1;s>=0;s--)if(o=l[s],!d(t[o],e[o],r,n))return!1;return!0}function v(t,e,r){d(t,e,!0)&&h(t,e,r,\"notDeepStrictEqual\",v)}function g(t,e){if(!t||!e)return!1\n",
       ";if(\"[object RegExp]\"==Object.prototype.toString.call(e))return e.test(t);try{if(t instanceof e)return!0}catch(t){}return!Error.isPrototypeOf(e)&&!0===e.call({},t)}function y(t){var e;try{t()}catch(t){e=t}return e}function b(t,e,r,n){var i;if(\"function\"!=typeof e)throw new TypeError('\"block\" argument must be a function');\"string\"==typeof r&&(n=r,r=null),i=y(e),n=(r&&r.name?\" (\"+r.name+\").\":\".\")+(n?\" \"+n:\".\"),t&&!i&&h(i,r,\"Missing expected exception\"+n);var a=\"string\"==typeof n,o=!t&&x.isError(i),s=!t&&i&&!r;if((o&&a&&g(i,r)||s)&&h(i,r,\"Got unwanted exception\"+n),t&&i&&r&&!g(i,r)||!t&&i)throw i}var x=t(\"util/\"),_=Object.prototype.hasOwnProperty,w=Array.prototype.slice,M=function(){return\"foo\"===function(){}.name}(),k=e.exports=f,A=/\\s*function\\s+([^\\(\\s]*)\\s*/;k.AssertionError=function(t){this.name=\"AssertionError\",this.actual=t.actual,this.expected=t.expected,this.operator=t.operator,t.message?(this.message=t.message,this.generatedMessage=!1):(this.message=c(this),this.generatedMessage=!0);var e=t.stackStartFunction||h;if(Error.captureStackTrace)Error.captureStackTrace(this,e);else{var r=new Error;if(r.stack){var n=r.stack,i=s(e),a=n.indexOf(\"\\n\"+i);if(a>=0){var o=n.indexOf(\"\\n\",a+1);n=n.substring(o+1)}this.stack=n}}},x.inherits(k.AssertionError,Error),k.fail=h,k.ok=f,k.equal=function(t,e,r){t!=e&&h(t,e,r,\"==\",k.equal)},k.notEqual=function(t,e,r){t==e&&h(t,e,r,\"!=\",k.notEqual)},k.deepEqual=function(t,e,r){d(t,e,!1)||h(t,e,r,\"deepEqual\",k.deepEqual)},k.deepStrictEqual=function(t,e,r){d(t,e,!0)||h(t,e,r,\"deepStrictEqual\",k.deepStrictEqual)},k.notDeepEqual=function(t,e,r){d(t,e,!1)&&h(t,e,r,\"notDeepEqual\",k.notDeepEqual)},k.notDeepStrictEqual=v,k.strictEqual=function(t,e,r){t!==e&&h(t,e,r,\"===\",k.strictEqual)},k.notStrictEqual=function(t,e,r){t===e&&h(t,e,r,\"!==\",k.notStrictEqual)},k.throws=function(t,e,r){b(!0,t,e,r)},k.doesNotThrow=function(t,e,r){b(!1,t,e,r)},k.ifError=function(t){if(t)throw t};var T=Object.keys||function(t){var e=[];for(var r in t)_.call(t,r)&&e.push(r);return e}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"util/\":548}],47:[function(t,e,r){e.exports=function(t){return atob(t)}},{}],48:[function(t,e,r){\"use strict\";function n(t){for(var e=0,r=0;r<t.length;++r)e+=t[r];return e}function i(t,e){for(var r=e.length,i=new Array(r+1),o=0;o<r;++o){for(var s=new Array(r+1),l=0;l<=r;++l)s[l]=t[l][o];i[o]=s}i[r]=new Array(r+1);for(var o=0;o<=r;++o)i[r][o]=1;for(var u=new Array(r+1),o=0;o<r;++o)u[o]=e[o];u[r]=1;var c=a(i,u),h=n(c[r+1]);0===h&&(h=1);for(var f=new Array(r+1),o=0;o<=r;++o)f[o]=n(c[o])/h;return f}e.exports=i;var a=t(\"robust-linear-solve\")},{\"robust-linear-solve\":506}],49:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]).add(e[0].mul(t[1])),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],50:[function(t,e,r){\"use strict\";function n(t,e){return t[0].mul(e[1]).cmp(e[0].mul(t[1]))}e.exports=n},{}],51:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]),t[1].mul(e[0]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],52:[function(t,e,r){\"use strict\";function n(t,e){if(i(t))return e?u(t,n(e)):[t[0].clone(),t[1].clone()];var r,c,h=0;if(a(t))r=t.clone();else if(\"string\"==typeof t)r=s(t);else{if(0===t)return[o(0),o(1)];if(t===Math.floor(t))r=o(t);else{for(;t!==Math.floor(t);)t*=Math.pow(2,256),h-=256;r=o(t)}}if(i(e))r.mul(e[1]),c=e[0].clone();else if(a(e))c=e.clone();else if(\"string\"==typeof e)c=s(e);else if(e)if(e===Math.floor(e))c=o(e);else{for(;e!==Math.floor(e);)e*=Math.pow(2,256),h+=256;c=o(e)}else c=o(1);return h>0?r=r.ushln(h):h<0&&(c=c.ushln(-h)),l(r,c)}var i=t(\"./is-rat\"),a=t(\"./lib/is-bn\"),o=t(\"./lib/num-to-bn\"),s=t(\"./lib/str-to-bn\"),l=t(\"./lib/rationalize\"),u=t(\"./div\");e.exports=n},{\"./div\":51,\"./is-rat\":53,\"./lib/is-bn\":57,\"./lib/num-to-bn\":58,\"./lib/rationalize\":59,\"./lib/str-to-bn\":60}],53:[function(t,e,r){\"use strict\";function n(t){return Array.isArray(t)&&2===t.length&&i(t[0])&&i(t[1])}var i=t(\"./lib/is-bn\");e.exports=n},{\"./lib/is-bn\":57}],54:[function(t,e,r){\"use strict\";function n(t){return t.cmp(new i(0))}var i=t(\"bn.js\");e.exports=n},{\"bn.js\":67}],55:[function(t,e,r){\"use strict\";function n(t){var e=t.length,r=t.words,n=0;if(1===e)n=r[0];else if(2===e)n=r[0]+67108864*r[1];else for(var a=0;a<e;a++){var o=r[a];n+=o*Math.pow(67108864,a)}return i(t)*n}var i=t(\"./bn-sign\");e.exports=n},{\"./bn-sign\":54}],56:[function(t,e,r){\"use strict\";function n(t){var e=a(i.lo(t));if(e<32)return e;var r=a(i.hi(t));return r>20?52:r+32}var i=t(\"double-bits\"),a=t(\"bit-twiddle\").countTrailingZeros;e.exports=n},{\"bit-twiddle\":66,\"double-bits\":123}],57:[function(t,e,r){\"use strict\";function n(t){return t&&\"object\"==typeof t&&Boolean(t.words)}t(\"bn.js\");e.exports=n},{\"bn.js\":67}],58:[function(t,e,r){\"use strict\";function n(t){var e=a.exponent(t);return e<52?new i(t):new i(t*Math.pow(2,52-e)).ushln(e-52)}var i=t(\"bn.js\"),a=t(\"double-bits\");e.exports=n},{\"bn.js\":67,\"double-bits\":123}],59:[function(t,e,r){\"use strict\";function n(t,e){var r=a(t),n=a(e);if(0===r)return[i(0),i(1)];if(0===n)return[i(0),i(0)];n<0&&(t=t.neg(),e=e.neg());var o=t.gcd(e);return o.cmpn(1)?[t.div(o),e.div(o)]:[t,e]}var i=t(\"./num-to-bn\"),a=t(\"./bn-sign\");e.exports=n},{\"./bn-sign\":54,\"./num-to-bn\":58}],60:[function(t,e,r){\"use strict\";function n(t){return new i(t)}var i=t(\"bn.js\");e.exports=n},{\"bn.js\":67}],61:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[0]),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],62:[function(t,e,r){\"use strict\";function n(t){return i(t[0])*i(t[1])}var i=t(\"./lib/bn-sign\");e.exports=n},{\"./lib/bn-sign\":54}],63:[function(t,e,r){\"use strict\";function n(t,e){return i(t[0].mul(e[1]).sub(t[1].mul(e[0])),t[1].mul(e[1]))}var i=t(\"./lib/rationalize\");e.exports=n},{\"./lib/rationalize\":59}],64:[function(t,e,r){\"use strict\";function n(t){var e=t[0],r=t[1];if(0===e.cmpn(0))return 0;var n=e.abs().divmod(r.abs()),o=n.div,s=i(o),l=n.mod,u=e.negative!==r.negative?-1:1;if(0===l.cmpn(0))return u*s;if(s){var c=a(s)+4,h=i(l.ushln(c).divRound(r));return u*(s+h*Math.pow(2,-c))}var f=r.bitLength()-l.bitLength()+53,h=i(l.ushln(f).divRound(r));return f<1023?u*h*Math.pow(2,-f):(h*=Math.pow(2,-1023),u*h*Math.pow(2,1023-f))}var i=t(\"./lib/bn-to-num\"),a=t(\"./lib/ctz\");e.exports=n},{\"./lib/bn-to-num\":55,\"./lib/ctz\":56}],65:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){var o=[\"function \",t,\"(a,l,h,\",n.join(\",\"),\"){\",a?\"\":\"var i=\",r?\"l-1\":\"h+1\",\";while(l<=h){var m=(l+h)>>>1,x=a\",i?\".get(m)\":\"[m]\"];return a?e.indexOf(\"c\")<0?o.push(\";if(x===y){return m}else if(x<=y){\"):o.push(\";var p=c(x,y);if(p===0){return m}else if(p<=0){\"):o.push(\";if(\",e,\"){i=m;\"),r?o.push(\"l=m+1}else{h=m-1}\"):o.push(\"h=m-1}else{l=m+1}\"),o.push(\"}\"),a?o.push(\"return -1};\"):o.push(\"return i};\"),o.join(\"\")}function i(t,e,r,i){return new Function([n(\"A\",\"x\"+t+\"y\",e,[\"y\"],!1,i),n(\"B\",\"x\"+t+\"y\",e,[\"y\"],!0,i),n(\"P\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],!1,i),n(\"Q\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],!0,i),\"function dispatchBsearch\",r,\"(a,y,c,l,h){if(a.shape){if(typeof(c)==='function'){return Q(a,(l===undefined)?0:l|0,(h===undefined)?a.shape[0]-1:h|0,y,c)}else{return B(a,(c===undefined)?0:c|0,(l===undefined)?a.shape[0]-1:l|0,y)}}else{if(typeof(c)==='function'){return P(a,(l===undefined)?0:l|0,(h===undefined)?a.length-1:h|0,y,c)}else{return A(a,(c===undefined)?0:c|0,(l===undefined)?a.length-1:l|0,y)}}}return dispatchBsearch\",r].join(\"\"))()}e.exports={ge:i(\">=\",!1,\"GE\"),gt:i(\">\",!1,\"GT\"),lt:i(\"<\",!0,\"LT\"),le:i(\"<=\",!0,\"LE\"),eq:i(\"-\",!0,\"EQ\",!0)}},{}],66:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){var e=32;return t&=-t,t&&e--,65535&t&&(e-=16),16711935&t&&(e-=8),252645135&t&&(e-=4),858993459&t&&(e-=2),1431655765&t&&(e-=1),e}r.INT_BITS=32,r.INT_MAX=2147483647,r.INT_MIN=-1<<31,r.sign=function(t){return(t>0)-(t<0)},r.abs=function(t){var e=t>>31;return(t^e)-e},r.min=function(t,e){return e^(t^e)&-(t<e)},r.max=function(t,e){return t^(t^e)&-(t<e)},r.isPow2=function(t){return!(t&t-1||!t)},r.log2=function(t){var e,r;return e=(t>65535)<<4,t>>>=e,r=(t>255)<<3,t>>>=r,e|=r,r=(t>15)<<2,t>>>=r,e|=r,r=(t>3)<<1,t>>>=r,(e|=r)|t>>1},r.log10=function(t){return t>=1e9?9:t>=1e8?8:t>=1e7?7:t>=1e6?6:t>=1e5?5:t>=1e4?4:t>=1e3?3:t>=100?2:t>=10?1:0},r.popCount=function(t){return t-=t>>>1&1431655765,16843009*((t=(858993459&t)+(t>>>2&858993459))+(t>>>4)&252645135)>>>24},r.countTrailingZeros=n,r.nextPow2=function(t){return t+=0===t,--t,t|=t>>>1,t|=t>>>2,t|=t>>>4,t|=t>>>8,(t|=t>>>16)+1},r.prevPow2=function(t){return t|=t>>>1,t|=t>>>2,t|=t>>>4,t|=t>>>8,(t|=t>>>16)-(t>>>1)},r.parity=function(t){return t^=t>>>16,t^=t>>>8,t^=t>>>4,27030>>>(t&=15)&1};var i=new Array(256);!function(t){for(var e=0;e<256;++e){var r=e,n=e,i=7;for(r>>>=1;r;r>>>=1)n<<=1,n|=1&r,--i;t[e]=n<<i&255}}(i),r.reverse=function(t){return i[255&t]<<24|i[t>>>8&255]<<16|i[t>>>16&255]<<8|i[t>>>24&255]},r.interleave2=function(t,e){return t&=65535,t=16711935&(t|t<<8),t=252645135&(t|t<<4),t=858993459&(t|t<<2),t=1431655765&(t|t<<1),e&=65535,e=16711935&(e|e<<8),e=252645135&(e|e<<4),e=858993459&(e|e<<2),e=1431655765&(e|e<<1),t|e<<1},r.deinterleave2=function(t,e){return t=t>>>e&1431655765,t=858993459&(t|t>>>1),t=252645135&(t|t>>>2),t=16711935&(t|t>>>4),(t=65535&(t|t>>>16))<<16>>16},r.interleave3=function(t,e,r){return t&=1023,t=4278190335&(t|t<<16),t=251719695&(t|t<<8),t=3272356035&(t|t<<4),t=1227133513&(t|t<<2),e&=1023,e=4278190335&(e|e<<16),e=251719695&(e|e<<8),e=3272356035&(e|e<<4),e=1227133513&(e|e<<2),t|=e<<1,r&=1023,r=4278190335&(r|r<<16),r=251719695&(r|r<<8),r=3272356035&(r|r<<4),r=1227133513&(r|r<<2),t|r<<2},r.deinterleave3=function(t,e){return t=t>>>e&1227133513,t=3272356035&(t|t>>>2),t=251719695&(t|t>>>4),t=4278190335&(t|t>>>8),(t=1023&(t|t>>>16))<<22>>22},r.nextCombination=function(t){var e=t|t-1;return e+1|(~e&-~e)-1>>>n(t)+1}},{}],67:[function(t,e,r){!function(e,r){\"use strict\";function n(t,e){if(!t)throw new Error(e||\"Assertion failed\")}function i(t,e){t.super_=e;var r=function(){};r.prototype=e.prototype,t.prototype=new r,t.prototype.constructor=t}function a(t,e,r){if(a.isBN(t))return t;this.negative=0,this.words=null,this.length=0,this.red=null,null!==t&&(\"le\"!==e&&\"be\"!==e||(r=e,e=10),this._init(t||0,e||10,r||\"be\"))}function o(t,e,r){for(var n=0,i=Math.min(t.length,r),a=e;a<i;a++){var o=t.charCodeAt(a)-48;n<<=4,n|=o>=49&&o<=54?o-49+10:o>=17&&o<=22?o-17+10:15&o}return n}function s(t,e,r,n){for(var i=0,a=Math.min(t.length,r),o=e;o<a;o++){var s=t.charCodeAt(o)-48;i*=n,i+=s>=49?s-49+10:s>=17?s-17+10:s}return i}function l(t){for(var e=new Array(t.bitLength()),r=0;r<e.length;r++){var n=r/26|0,i=r%26;e[r]=(t.words[n]&1<<i)>>>i}return e}function u(t,e,r){r.negative=e.negative^t.negative;var n=t.length+e.length|0;r.length=n,n=n-1|0;var i=0|t.words[0],a=0|e.words[0],o=i*a,s=67108863&o,l=o/67108864|0;r.words[0]=s;for(var u=1;u<n;u++){for(var c=l>>>26,h=67108863&l,f=Math.min(u,e.length-1),d=Math.max(0,u-t.length+1);d<=f;d++){var p=u-d|0;i=0|t.words[p],a=0|e.words[d],o=i*a+h,c+=o/67108864|0,h=67108863&o}r.words[u]=0|h,l=0|c}return 0!==l?r.words[u]=0|l:r.length--,r.strip()}function c(t,e,r){r.negative=e.negative^t.negative,r.length=t.length+e.length;for(var n=0,i=0,a=0;a<r.length-1;a++){var o=i;i=0;for(var s=67108863&n,l=Math.min(a,e.length-1),u=Math.max(0,a-t.length+1);u<=l;u++){var c=a-u,h=0|t.words[c],f=0|e.words[u],d=h*f,p=67108863&d;o=o+(d/67108864|0)|0,p=p+s|0,s=67108863&p,o=o+(p>>>26)|0,i+=o>>>26,o&=67108863}r.words[a]=s,n=o,o=i}return 0!==n?r.words[a]=n:r.length--,r.strip()}function h(t,e,r){return(new f).mulp(t,e,r)}function f(t,e){this.x=t,this.y=e}function d(t,e){this.name=t,this.p=new a(e,16),this.n=this.p.bitLength(),this.k=new a(1).iushln(this.n).isub(this.p),this.tmp=this._tmp()}function p(){d.call(this,\"k256\",\"ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f\")}function m(){d.call(this,\"p224\",\"ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001\")}function v(){d.call(this,\"p192\",\"ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff\")}function g(){d.call(this,\"25519\",\"7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed\")}function y(t){if(\"string\"==typeof t){var e=a._prime(t);this.m=e.p,this.prime=e}else n(t.gtn(1),\"modulus must be greater than 1\"),this.m=t,this.prime=null}function b(t){y.call(this,t),this.shift=this.m.bitLength(),this.shift%26!=0&&(this.shift+=26-this.shift%26),this.r=new a(1).iushln(this.shift),this.r2=this.imod(this.r.sqr()),this.rinv=this.r._invmp(this.m),this.minv=this.rinv.mul(this.r).isubn(1).div(this.m),this.minv=this.minv.umod(this.r),this.minv=this.r.sub(this.minv)}\"object\"==typeof e?e.exports=a:r.BN=a,a.BN=a,a.wordSize=26;var x;try{x=t(\"buffer\").Buffer}catch(t){}a.isBN=function(t){return t instanceof a||null!==t&&\"object\"==typeof t&&t.constructor.wordSize===a.wordSize&&Array.isArray(t.words)},a.max=function(t,e){return t.cmp(e)>0?t:e},a.min=function(t,e){return t.cmp(e)<0?t:e},a.prototype._init=function(t,e,r){if(\"number\"==typeof t)return this._initNumber(t,e,r);if(\"object\"==typeof t)return this._initArray(t,e,r);\"hex\"===e&&(e=16),n(e===(0|e)&&e>=2&&e<=36),t=t.toString().replace(/\\s+/g,\"\");var i=0;\"-\"===t[0]&&i++,16===e?this._parseHex(t,i):this._parseBase(t,e,i),\"-\"===t[0]&&(this.negative=1),this.strip(),\"le\"===r&&this._initArray(this.toArray(),e,r)},a.prototype._initNumber=function(t,e,r){t<0&&(this.negative=1,t=-t),t<67108864?(this.words=[67108863&t],this.length=1):t<4503599627370496?(this.words=[67108863&t,t/67108864&67108863],this.length=2):(n(t<9007199254740992),this.words=[67108863&t,t/67108864&67108863,1],this.length=3),\"le\"===r&&this._initArray(this.toArray(),e,r)},a.prototype._initArray=function(t,e,r){if(n(\"number\"==typeof t.length),t.length<=0)return this.words=[0],this.length=1,this;this.length=Math.ceil(t.length/3),this.words=new Array(this.length);for(var i=0;i<this.length;i++)this.words[i]=0;var a,o,s=0;if(\"be\"===r)for(i=t.length-1,a=0;i>=0;i-=3)o=t[i]|t[i-1]<<8|t[i-2]<<16,this.words[a]|=o<<s&67108863,this.words[a+1]=o>>>26-s&67108863,(s+=24)>=26&&(s-=26,a++);else if(\"le\"===r)for(i=0,a=0;i<t.length;i+=3)o=t[i]|t[i+1]<<8|t[i+2]<<16,this.words[a]|=o<<s&67108863,this.words[a+1]=o>>>26-s&67108863,(s+=24)>=26&&(s-=26,a++);return this.strip()},a.prototype._parseHex=function(t,e){this.length=Math.ceil((t.length-e)/6),this.words=new Array(this.length);for(var r=0;r<this.length;r++)this.words[r]=0;var n,i,a=0;for(r=t.length-6,n=0;r>=e;r-=6)i=o(t,r,r+6),this.words[n]|=i<<a&67108863,this.words[n+1]|=i>>>26-a&4194303,(a+=24)>=26&&(a-=26,n++);r+6!==e&&(i=o(t,e,r+6),this.words[n]|=i<<a&67108863,this.words[n+1]|=i>>>26-a&4194303),this.strip()},a.prototype._parseBase=function(t,e,r){this.words=[0],this.length=1;for(var n=0,i=1;i<=67108863;i*=e)n++;n--,i=i/e|0;for(var a=t.length-r,o=a%n,l=Math.min(a,a-o)+r,u=0,c=r;c<l;c+=n)u=s(t,c,c+n,e),this.imuln(i),this.words[0]+u<67108864?this.words[0]+=u:this._iaddn(u);if(0!==o){var h=1;for(u=s(t,c,t.length,e),c=0;c<o;c++)h*=e;this.imuln(h),this.words[0]+u<67108864?this.words[0]+=u:this._iaddn(u)}},a.prototype.copy=function(t){t.words=new Array(this.length);for(var e=0;e<this.length;e++)t.words[e]=this.words[e];t.length=this.length,t.negative=this.negative,t.red=this.red},a.prototype.clone=function(){var t=new a(null);return this.copy(t),t},a.prototype._expand=function(t){for(;this.length<t;)this.words[this.length++]=0;return this},a.prototype.strip=function(){for(;this.length>1&&0===this.words[this.length-1];)this.length--;return this._normSign()},a.prototype._normSign=function(){return 1===this.length&&0===this.words[0]&&(this.negative=0),this},a.prototype.inspect=function(){return(this.red?\"<BN-R: \":\"<BN: \")+this.toString(16)+\">\"};var _=[\"\",\"0\",\"00\",\"000\",\"0000\",\"00000\",\"000000\",\"0000000\",\"00000000\",\"000000000\",\"0000000000\",\"00000000000\",\"000000000000\",\"0000000000000\",\"00000000000000\",\"000000000000000\",\"0000000000000000\",\"00000000000000000\",\"000000000000000000\",\"0000000000000000000\",\"00000000000000000000\",\"000000000000000000000\",\"0000000000000000000000\",\"00000000000000000000000\",\"000000000000000000000000\",\"0000000000000000000000000\"],w=[0,0,25,16,12,11,10,9,8,8,7,7,7,7,6,6,6,6,6,6,6,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5],M=[0,0,33554432,43046721,16777216,48828125,60466176,40353607,16777216,43046721,1e7,19487171,35831808,62748517,7529536,11390625,16777216,24137569,34012224,47045881,64e6,4084101,5153632,6436343,7962624,9765625,11881376,14348907,17210368,20511149,243e5,28629151,33554432,39135393,45435424,52521875,60466176];a.prototype.toString=function(t,e){t=t||10,e=0|e||1;var r;if(16===t||\"hex\"===t){r=\"\";for(var i=0,a=0,o=0;o<this.length;o++){var s=this.words[o],l=(16777215&(s<<i|a)).toString(16);a=s>>>24-i&16777215,r=0!==a||o!==this.length-1?_[6-l.length]+l+r:l+r,i+=2,i>=26&&(i-=26,o--)}for(0!==a&&(r=a.toString(16)+r);r.length%e!=0;)r=\"0\"+r;return 0!==this.negative&&(r=\"-\"+r),r}if(t===(0|t)&&t>=2&&t<=36){var u=w[t],c=M[t];r=\"\";var h=this.clone();for(h.negative=0;!h.isZero();){var f=h.modn(c).toString(t);h=h.idivn(c),r=h.isZero()?f+r:_[u-f.length]+f+r}for(this.isZero()&&(r=\"0\"+r);r.length%e!=0;)r=\"0\"+r;return 0!==this.negative&&(r=\"-\"+r),r}n(!1,\"Base should be between 2 and 36\")},a.prototype.toNumber=function(){var t=this.words[0];return 2===this.length?t+=67108864*this.words[1]:3===this.length&&1===this.words[2]?t+=4503599627370496+67108864*this.words[1]:this.length>2&&n(!1,\"Number can only safely store up to 53 bits\"),0!==this.negative?-t:t},a.prototype.toJSON=function(){return this.toString(16)},a.prototype.toBuffer=function(t,e){return n(void 0!==x),this.toArrayLike(x,t,e)},a.prototype.toArray=function(t,e){return this.toArrayLike(Array,t,e)},a.prototype.toArrayLike=function(t,e,r){var i=this.byteLength(),a=r||Math.max(1,i);n(i<=a,\"byte array longer than desired length\"),n(a>0,\"Requested array length <= 0\"),this.strip();var o,s,l=\"le\"===e,u=new t(a),c=this.clone();if(l){for(s=0;!c.isZero();s++)o=c.andln(255),c.iushrn(8),u[s]=o;for(;s<a;s++)u[s]=0}else{for(s=0;s<a-i;s++)u[s]=0;for(s=0;!c.isZero();s++)o=c.andln(255),c.iushrn(8),u[a-s-1]=o}return u},Math.clz32?a.prototype._countBits=function(t){return 32-Math.clz32(t)}:a.prototype._countBits=function(t){var e=t,r=0;return e>=4096&&(r+=13,e>>>=13),e>=64&&(r+=7,e>>>=7),e>=8&&(r+=4,e>>>=4),e>=2&&(r+=2,e>>>=2),r+e},a.prototype._zeroBits=function(t){if(0===t)return 26;var e=t,r=0;return 0==(8191&e)&&(r+=13,e>>>=13),0==(127&e)&&(r+=7,e>>>=7),0==(15&e)&&(r+=4,e>>>=4),0==(3&e)&&(r+=2,e>>>=2),0==(1&e)&&r++,r},a.prototype.bitLength=function(){var t=this.words[this.length-1],e=this._countBits(t);return 26*(this.length-1)+e},a.prototype.zeroBits=function(){if(this.isZero())return 0;for(var t=0,e=0;e<this.length;e++){var r=this._zeroBits(this.words[e]);if(t+=r,26!==r)break}return t},a.prototype.byteLength=function(){return Math.ceil(this.bitLength()/8)},a.prototype.toTwos=function(t){return 0!==this.negative?this.abs().inotn(t).iaddn(1):this.clone()},a.prototype.fromTwos=function(t){return this.testn(t-1)?this.notn(t).iaddn(1).ineg():this.clone()},a.prototype.isNeg=function(){return 0!==this.negative},a.prototype.neg=function(){return this.clone().ineg()},a.prototype.ineg=function(){return this.isZero()||(this.negative^=1),this},a.prototype.iuor=function(t){for(;this.length<t.length;)this.words[this.length++]=0;for(var e=0;e<t.length;e++)this.words[e]=this.words[e]|t.words[e];return this.strip()},a.prototype.ior=function(t){return n(0==(this.negative|t.negative)),this.iuor(t)},a.prototype.or=function(t){return this.length>t.length?this.clone().ior(t):t.clone().ior(this)},a.prototype.uor=function(t){return this.length>t.length?this.clone().iuor(t):t.clone().iuor(this)},a.prototype.iuand=function(t){var e;e=this.length>t.length?t:this;for(var r=0;r<e.length;r++)this.words[r]=this.words[r]&t.words[r];return this.length=e.length,this.strip()},a.prototype.iand=function(t){return n(0==(this.negative|t.negative)),this.iuand(t)},a.prototype.and=function(t){return this.length>t.length?this.clone().iand(t):t.clone().iand(this)},a.prototype.uand=function(t){return this.length>t.length?this.clone().iuand(t):t.clone().iuand(this)},a.prototype.iuxor=function(t){var e,r;this.length>t.length?(e=this,r=t):(e=t,r=this);for(var n=0;n<r.length;n++)this.words[n]=e.words[n]^r.words[n];if(this!==e)for(;n<e.length;n++)this.words[n]=e.words[n];return this.length=e.length,this.strip()},a.prototype.ixor=function(t){return n(0==(this.negative|t.negative)),this.iuxor(t)},a.prototype.xor=function(t){return this.length>t.length?this.clone().ixor(t):t.clone().ixor(this)},a.prototype.uxor=function(t){return this.length>t.length?this.clone().iuxor(t):t.clone().iuxor(this)},a.prototype.inotn=function(t){n(\"number\"==typeof t&&t>=0);var e=0|Math.ceil(t/26),r=t%26;this._expand(e),r>0&&e--;for(var i=0;i<e;i++)this.words[i]=67108863&~this.words[i];return r>0&&(this.words[i]=~this.words[i]&67108863>>26-r),this.strip()},a.prototype.notn=function(t){return this.clone().inotn(t)},a.prototype.setn=function(t,e){n(\"number\"==typeof t&&t>=0);var r=t/26|0,i=t%26;return this._expand(r+1),this.words[r]=e?this.words[r]|1<<i:this.words[r]&~(1<<i),this.strip()},a.prototype.iadd=function(t){var e;if(0!==this.negative&&0===t.negative)return this.negative=0,e=this.isub(t),this.negative^=1,this._normSign();if(0===this.negative&&0!==t.negative)return t.negative=0,e=this.isub(t),t.negative=1,e._normSign();var r,n;this.length>t.length?(r=this,n=t):(r=t,n=this);for(var i=0,a=0;a<n.length;a++)e=(0|r.words[a])+(0|n.words[a])+i,this.words[a]=67108863&e,i=e>>>26;for(;0!==i&&a<r.length;a++)e=(0|r.words[a])+i,this.words[a]=67108863&e,i=e>>>26;if(this.length=r.length,0!==i)this.words[this.length]=i,this.length++;else if(r!==this)for(;a<r.length;a++)this.words[a]=r.words[a];return this},a.prototype.add=function(t){var e;return 0!==t.negative&&0===this.negative?(t.negative=0,e=this.sub(t),t.negative^=1,e):0===t.negative&&0!==this.negative?(this.negative=0,e=t.sub(this),this.negative=1,e):this.length>t.length?this.clone().iadd(t):t.clone().iadd(this)},a.prototype.isub=function(t){if(0!==t.negative){t.negative=0;var e=this.iadd(t);return t.negative=1,e._normSign()}if(0!==this.negative)return this.negative=0,this.iadd(t),this.negative=1,this._normSign();var r=this.cmp(t);if(0===r)return this.negative=0,this.length=1,this.words[0]=0,this;var n,i;r>0?(n=this,i=t):(n=t,i=this);for(var a=0,o=0;o<i.length;o++)e=(0|n.words[o])-(0|i.words[o])+a,a=e>>26,this.words[o]=67108863&e;for(;0!==a&&o<n.length;o++)e=(0|n.words[o])+a,a=e>>26,this.words[o]=67108863&e;if(0===a&&o<n.length&&n!==this)for(;o<n.length;o++)this.words[o]=n.words[o];return this.length=Math.max(this.length,o),n!==this&&(this.negative=1),this.strip()},a.prototype.sub=function(t){return this.clone().isub(t)};var k=function(t,e,r){var n,i,a,o=t.words,s=e.words,l=r.words,u=0,c=0|o[0],h=8191&c,f=c>>>13,d=0|o[1],p=8191&d,m=d>>>13,v=0|o[2],g=8191&v,y=v>>>13,b=0|o[3],x=8191&b,_=b>>>13,w=0|o[4],M=8191&w,k=w>>>13,A=0|o[5],T=8191&A,S=A>>>13,E=0|o[6],L=8191&E,C=E>>>13,z=0|o[7],I=8191&z,D=z>>>13,P=0|o[8],O=8191&P,R=P>>>13,F=0|o[9],j=8191&F,N=F>>>13,B=0|s[0],U=8191&B,V=B>>>13,H=0|s[1],q=8191&H,G=H>>>13,Y=0|s[2],X=8191&Y,W=Y>>>13,Z=0|s[3],J=8191&Z,K=Z>>>13,Q=0|s[4],$=8191&Q,tt=Q>>>13,et=0|s[5],rt=8191&et,nt=et>>>13,it=0|s[6],at=8191&it,ot=it>>>13,st=0|s[7],lt=8191&st,ut=st>>>13,ct=0|s[8],ht=8191&ct,ft=ct>>>13,dt=0|s[9],pt=8191&dt,mt=dt>>>13;r.negative=t.negative^e.negative,r.length=19,n=Math.imul(h,U),i=Math.imul(h,V),i=i+Math.imul(f,U)|0,a=Math.imul(f,V);var vt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(vt>>>26)|0,vt&=67108863,n=Math.imul(p,U),i=Math.imul(p,V),i=i+Math.imul(m,U)|0,a=Math.imul(m,V),n=n+Math.imul(h,q)|0,i=i+Math.imul(h,G)|0,i=i+Math.imul(f,q)|0,a=a+Math.imul(f,G)|0;var gt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(gt>>>26)|0,gt&=67108863,n=Math.imul(g,U),i=Math.imul(g,V),i=i+Math.imul(y,U)|0,a=Math.imul(y,V),n=n+Math.imul(p,q)|0,i=i+Math.imul(p,G)|0,i=i+Math.imul(m,q)|0,a=a+Math.imul(m,G)|0,n=n+Math.imul(h,X)|0,i=i+Math.imul(h,W)|0,i=i+Math.imul(f,X)|0,a=a+Math.imul(f,W)|0;var yt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(yt>>>26)|0,yt&=67108863,n=Math.imul(x,U),i=Math.imul(x,V),i=i+Math.imul(_,U)|0,a=Math.imul(_,V),n=n+Math.imul(g,q)|0,i=i+Math.imul(g,G)|0,i=i+Math.imul(y,q)|0,a=a+Math.imul(y,G)|0,n=n+Math.imul(p,X)|0,i=i+Math.imul(p,W)|0,i=i+Math.imul(m,X)|0,a=a+Math.imul(m,W)|0,n=n+Math.imul(h,J)|0,i=i+Math.imul(h,K)|0,i=i+Math.imul(f,J)|0,a=a+Math.imul(f,K)|0;var bt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(bt>>>26)|0,bt&=67108863,n=Math.imul(M,U),i=Math.imul(M,V),i=i+Math.imul(k,U)|0,a=Math.imul(k,V),n=n+Math.imul(x,q)|0,i=i+Math.imul(x,G)|0,i=i+Math.imul(_,q)|0,a=a+Math.imul(_,G)|0,n=n+Math.imul(g,X)|0,i=i+Math.imul(g,W)|0,i=i+Math.imul(y,X)|0,a=a+Math.imul(y,W)|0,n=n+Math.imul(p,J)|0,i=i+Math.imul(p,K)|0,i=i+Math.imul(m,J)|0,a=a+Math.imul(m,K)|0,n=n+Math.imul(h,$)|0,i=i+Math.imul(h,tt)|0,i=i+Math.imul(f,$)|0,a=a+Math.imul(f,tt)|0;var xt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(xt>>>26)|0,xt&=67108863,n=Math.imul(T,U),i=Math.imul(T,V),i=i+Math.imul(S,U)|0,a=Math.imul(S,V),n=n+Math.imul(M,q)|0,i=i+Math.imul(M,G)|0,i=i+Math.imul(k,q)|0,a=a+Math.imul(k,G)|0,n=n+Math.imul(x,X)|0,i=i+Math.imul(x,W)|0,i=i+Math.imul(_,X)|0,a=a+Math.imul(_,W)|0,n=n+Math.imul(g,J)|0,i=i+Math.imul(g,K)|0,i=i+Math.imul(y,J)|0,a=a+Math.imul(y,K)|0,n=n+Math.imul(p,$)|0,i=i+Math.imul(p,tt)|0,i=i+Math.imul(m,$)|0,a=a+Math.imul(m,tt)|0,n=n+Math.imul(h,rt)|0,i=i+Math.imul(h,nt)|0,i=i+Math.imul(f,rt)|0,a=a+Math.imul(f,nt)|0;var _t=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(_t>>>26)|0,_t&=67108863,n=Math.imul(L,U),i=Math.imul(L,V),i=i+Math.imul(C,U)|0,a=Math.imul(C,V),n=n+Math.imul(T,q)|0,i=i+Math.imul(T,G)|0,i=i+Math.imul(S,q)|0,a=a+Math.imul(S,G)|0,n=n+Math.imul(M,X)|0,i=i+Math.imul(M,W)|0,i=i+Math.imul(k,X)|0,a=a+Math.imul(k,W)|0,n=n+Math.imul(x,J)|0,i=i+Math.imul(x,K)|0,i=i+Math.imul(_,J)|0,a=a+Math.imul(_,K)|0,n=n+Math.imul(g,$)|0,i=i+Math.imul(g,tt)|0,i=i+Math.imul(y,$)|0,a=a+Math.imul(y,tt)|0,n=n+Math.imul(p,rt)|0,i=i+Math.imul(p,nt)|0,i=i+Math.imul(m,rt)|0,a=a+Math.imul(m,nt)|0,n=n+Math.imul(h,at)|0,i=i+Math.imul(h,ot)|0,i=i+Math.imul(f,at)|0,a=a+Math.imul(f,ot)|0;var wt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(wt>>>26)|0,wt&=67108863,n=Math.imul(I,U),i=Math.imul(I,V),i=i+Math.imul(D,U)|0,a=Math.imul(D,V),n=n+Math.imul(L,q)|0,i=i+Math.imul(L,G)|0,i=i+Math.imul(C,q)|0,a=a+Math.imul(C,G)|0,n=n+Math.imul(T,X)|0,i=i+Math.imul(T,W)|0,i=i+Math.imul(S,X)|0,a=a+Math.imul(S,W)|0,n=n+Math.imul(M,J)|0,i=i+Math.imul(M,K)|0,i=i+Math.imul(k,J)|0,a=a+Math.imul(k,K)|0,n=n+Math.imul(x,$)|0,i=i+Math.imul(x,tt)|0,i=i+Math.imul(_,$)|0,a=a+Math.imul(_,tt)|0,n=n+Math.imul(g,rt)|0,i=i+Math.imul(g,nt)|0,i=i+Math.imul(y,rt)|0,a=a+Math.imul(y,nt)|0,n=n+Math.imul(p,at)|0,i=i+Math.imul(p,ot)|0,i=i+Math.imul(m,at)|0,a=a+Math.imul(m,ot)|0,n=n+Math.imul(h,lt)|0,i=i+Math.imul(h,ut)|0,i=i+Math.imul(f,lt)|0,a=a+Math.imul(f,ut)|0;var Mt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Mt>>>26)|0,Mt&=67108863,n=Math.imul(O,U),i=Math.imul(O,V),i=i+Math.imul(R,U)|0,a=Math.imul(R,V),n=n+Math.imul(I,q)|0,i=i+Math.imul(I,G)|0,i=i+Math.imul(D,q)|0,a=a+Math.imul(D,G)|0,n=n+Math.imul(L,X)|0,i=i+Math.imul(L,W)|0,i=i+Math.imul(C,X)|0,a=a+Math.imul(C,W)|0,n=n+Math.imul(T,J)|0,i=i+Math.imul(T,K)|0,i=i+Math.imul(S,J)|0,a=a+Math.imul(S,K)|0,n=n+Math.imul(M,$)|0,i=i+Math.imul(M,tt)|0,i=i+Math.imul(k,$)|0,a=a+Math.imul(k,tt)|0,n=n+Math.imul(x,rt)|0,i=i+Math.imul(x,nt)|0,i=i+Math.imul(_,rt)|0,a=a+Math.imul(_,nt)|0,n=n+Math.imul(g,at)|0,i=i+Math.imul(g,ot)|0,i=i+Math.imul(y,at)|0,a=a+Math.imul(y,ot)|0,n=n+Math.imul(p,lt)|0,i=i+Math.imul(p,ut)|0,i=i+Math.imul(m,lt)|0,a=a+Math.imul(m,ut)|0,n=n+Math.imul(h,ht)|0,i=i+Math.imul(h,ft)|0,i=i+Math.imul(f,ht)|0,a=a+Math.imul(f,ft)|0;var kt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(kt>>>26)|0,kt&=67108863,n=Math.imul(j,U),i=Math.imul(j,V),i=i+Math.imul(N,U)|0,a=Math.imul(N,V),n=n+Math.imul(O,q)|0,i=i+Math.imul(O,G)|0,i=i+Math.imul(R,q)|0,a=a+Math.imul(R,G)|0,n=n+Math.imul(I,X)|0,i=i+Math.imul(I,W)|0,i=i+Math.imul(D,X)|0,a=a+Math.imul(D,W)|0,n=n+Math.imul(L,J)|0,i=i+Math.imul(L,K)|0,i=i+Math.imul(C,J)|0,a=a+Math.imul(C,K)|0,n=n+Math.imul(T,$)|0,i=i+Math.imul(T,tt)|0,i=i+Math.imul(S,$)|0,a=a+Math.imul(S,tt)|0,n=n+Math.imul(M,rt)|0,i=i+Math.imul(M,nt)|0,i=i+Math.imul(k,rt)|0,a=a+Math.imul(k,nt)|0,n=n+Math.imul(x,at)|0,i=i+Math.imul(x,ot)|0,i=i+Math.imul(_,at)|0,a=a+Math.imul(_,ot)|0,n=n+Math.imul(g,lt)|0,i=i+Math.imul(g,ut)|0,i=i+Math.imul(y,lt)|0,a=a+Math.imul(y,ut)|0,n=n+Math.imul(p,ht)|0,i=i+Math.imul(p,ft)|0,i=i+Math.imul(m,ht)|0,a=a+Math.imul(m,ft)|0,n=n+Math.imul(h,pt)|0,i=i+Math.imul(h,mt)|0,i=i+Math.imul(f,pt)|0,a=a+Math.imul(f,mt)|0;var At=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(At>>>26)|0,At&=67108863,n=Math.imul(j,q),i=Math.imul(j,G),i=i+Math.imul(N,q)|0,a=Math.imul(N,G),n=n+Math.imul(O,X)|0,i=i+Math.imul(O,W)|0,i=i+Math.imul(R,X)|0,a=a+Math.imul(R,W)|0,n=n+Math.imul(I,J)|0,i=i+Math.imul(I,K)|0,i=i+Math.imul(D,J)|0,a=a+Math.imul(D,K)|0,n=n+Math.imul(L,$)|0,i=i+Math.imul(L,tt)|0,i=i+Math.imul(C,$)|0,a=a+Math.imul(C,tt)|0,n=n+Math.imul(T,rt)|0,i=i+Math.imul(T,nt)|0,i=i+Math.imul(S,rt)|0,a=a+Math.imul(S,nt)|0,n=n+Math.imul(M,at)|0,i=i+Math.imul(M,ot)|0,i=i+Math.imul(k,at)|0,a=a+Math.imul(k,ot)|0,n=n+Math.imul(x,lt)|0,i=i+Math.imul(x,ut)|0,i=i+Math.imul(_,lt)|0,a=a+Math.imul(_,ut)|0,n=n+Math.imul(g,ht)|0,i=i+Math.imul(g,ft)|0,i=i+Math.imul(y,ht)|0,a=a+Math.imul(y,ft)|0,n=n+Math.imul(p,pt)|0,i=i+Math.imul(p,mt)|0,i=i+Math.imul(m,pt)|0,a=a+Math.imul(m,mt)|0;var Tt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Tt>>>26)|0,Tt&=67108863,n=Math.imul(j,X),i=Math.imul(j,W),i=i+Math.imul(N,X)|0,a=Math.imul(N,W),n=n+Math.imul(O,J)|0,i=i+Math.imul(O,K)|0,i=i+Math.imul(R,J)|0,a=a+Math.imul(R,K)|0,n=n+Math.imul(I,$)|0,i=i+Math.imul(I,tt)|0,i=i+Math.imul(D,$)|0,a=a+Math.imul(D,tt)|0,n=n+Math.imul(L,rt)|0,i=i+Math.imul(L,nt)|0,i=i+Math.imul(C,rt)|0,a=a+Math.imul(C,nt)|0,n=n+Math.imul(T,at)|0,i=i+Math.imul(T,ot)|0,i=i+Math.imul(S,at)|0,a=a+Math.imul(S,ot)|0,n=n+Math.imul(M,lt)|0,i=i+Math.imul(M,ut)|0,i=i+Math.imul(k,lt)|0,a=a+Math.imul(k,ut)|0,n=n+Math.imul(x,ht)|0,i=i+Math.imul(x,ft)|0,i=i+Math.imul(_,ht)|0,a=a+Math.imul(_,ft)|0,n=n+Math.imul(g,pt)|0,i=i+Math.imul(g,mt)|0,i=i+Math.imul(y,pt)|0,a=a+Math.imul(y,mt)|0;var St=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(St>>>26)|0,St&=67108863,n=Math.imul(j,J),i=Math.imul(j,K),i=i+Math.imul(N,J)|0,a=Math.imul(N,K),n=n+Math.imul(O,$)|0,i=i+Math.imul(O,tt)|0,i=i+Math.imul(R,$)|0,a=a+Math.imul(R,tt)|0,n=n+Math.imul(I,rt)|0,i=i+Math.imul(I,nt)|0,i=i+Math.imul(D,rt)|0,a=a+Math.imul(D,nt)|0,n=n+Math.imul(L,at)|0,i=i+Math.imul(L,ot)|0,i=i+Math.imul(C,at)|0,a=a+Math.imul(C,ot)|0,n=n+Math.imul(T,lt)|0,i=i+Math.imul(T,ut)|0,i=i+Math.imul(S,lt)|0,a=a+Math.imul(S,ut)|0,n=n+Math.imul(M,ht)|0,i=i+Math.imul(M,ft)|0,i=i+Math.imul(k,ht)|0,a=a+Math.imul(k,ft)|0,n=n+Math.imul(x,pt)|0,i=i+Math.imul(x,mt)|0,i=i+Math.imul(_,pt)|0,a=a+Math.imul(_,mt)|0;var Et=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Et>>>26)|0,Et&=67108863,n=Math.imul(j,$),i=Math.imul(j,tt),i=i+Math.imul(N,$)|0,a=Math.imul(N,tt),n=n+Math.imul(O,rt)|0,i=i+Math.imul(O,nt)|0,i=i+Math.imul(R,rt)|0,a=a+Math.imul(R,nt)|0,n=n+Math.imul(I,at)|0,i=i+Math.imul(I,ot)|0,i=i+Math.imul(D,at)|0,a=a+Math.imul(D,ot)|0,n=n+Math.imul(L,lt)|0,i=i+Math.imul(L,ut)|0,i=i+Math.imul(C,lt)|0,a=a+Math.imul(C,ut)|0,n=n+Math.imul(T,ht)|0,i=i+Math.imul(T,ft)|0,i=i+Math.imul(S,ht)|0,a=a+Math.imul(S,ft)|0,n=n+Math.imul(M,pt)|0,i=i+Math.imul(M,mt)|0,i=i+Math.imul(k,pt)|0,a=a+Math.imul(k,mt)|0;var Lt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Lt>>>26)|0,Lt&=67108863,n=Math.imul(j,rt),i=Math.imul(j,nt),i=i+Math.imul(N,rt)|0,a=Math.imul(N,nt),n=n+Math.imul(O,at)|0,i=i+Math.imul(O,ot)|0,i=i+Math.imul(R,at)|0,a=a+Math.imul(R,ot)|0,n=n+Math.imul(I,lt)|0,i=i+Math.imul(I,ut)|0,i=i+Math.imul(D,lt)|0,a=a+Math.imul(D,ut)|0,n=n+Math.imul(L,ht)|0,i=i+Math.imul(L,ft)|0,i=i+Math.imul(C,ht)|0,a=a+Math.imul(C,ft)|0,n=n+Math.imul(T,pt)|0,i=i+Math.imul(T,mt)|0,\n",
       "i=i+Math.imul(S,pt)|0,a=a+Math.imul(S,mt)|0;var Ct=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Ct>>>26)|0,Ct&=67108863,n=Math.imul(j,at),i=Math.imul(j,ot),i=i+Math.imul(N,at)|0,a=Math.imul(N,ot),n=n+Math.imul(O,lt)|0,i=i+Math.imul(O,ut)|0,i=i+Math.imul(R,lt)|0,a=a+Math.imul(R,ut)|0,n=n+Math.imul(I,ht)|0,i=i+Math.imul(I,ft)|0,i=i+Math.imul(D,ht)|0,a=a+Math.imul(D,ft)|0,n=n+Math.imul(L,pt)|0,i=i+Math.imul(L,mt)|0,i=i+Math.imul(C,pt)|0,a=a+Math.imul(C,mt)|0;var zt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(zt>>>26)|0,zt&=67108863,n=Math.imul(j,lt),i=Math.imul(j,ut),i=i+Math.imul(N,lt)|0,a=Math.imul(N,ut),n=n+Math.imul(O,ht)|0,i=i+Math.imul(O,ft)|0,i=i+Math.imul(R,ht)|0,a=a+Math.imul(R,ft)|0,n=n+Math.imul(I,pt)|0,i=i+Math.imul(I,mt)|0,i=i+Math.imul(D,pt)|0,a=a+Math.imul(D,mt)|0;var It=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(It>>>26)|0,It&=67108863,n=Math.imul(j,ht),i=Math.imul(j,ft),i=i+Math.imul(N,ht)|0,a=Math.imul(N,ft),n=n+Math.imul(O,pt)|0,i=i+Math.imul(O,mt)|0,i=i+Math.imul(R,pt)|0,a=a+Math.imul(R,mt)|0;var Dt=(u+n|0)+((8191&i)<<13)|0;u=(a+(i>>>13)|0)+(Dt>>>26)|0,Dt&=67108863,n=Math.imul(j,pt),i=Math.imul(j,mt),i=i+Math.imul(N,pt)|0,a=Math.imul(N,mt);var Pt=(u+n|0)+((8191&i)<<13)|0;return u=(a+(i>>>13)|0)+(Pt>>>26)|0,Pt&=67108863,l[0]=vt,l[1]=gt,l[2]=yt,l[3]=bt,l[4]=xt,l[5]=_t,l[6]=wt,l[7]=Mt,l[8]=kt,l[9]=At,l[10]=Tt,l[11]=St,l[12]=Et,l[13]=Lt,l[14]=Ct,l[15]=zt,l[16]=It,l[17]=Dt,l[18]=Pt,0!==u&&(l[19]=u,r.length++),r};Math.imul||(k=u),a.prototype.mulTo=function(t,e){var r=this.length+t.length;return 10===this.length&&10===t.length?k(this,t,e):r<63?u(this,t,e):r<1024?c(this,t,e):h(this,t,e)},f.prototype.makeRBT=function(t){for(var e=new Array(t),r=a.prototype._countBits(t)-1,n=0;n<t;n++)e[n]=this.revBin(n,r,t);return e},f.prototype.revBin=function(t,e,r){if(0===t||t===r-1)return t;for(var n=0,i=0;i<e;i++)n|=(1&t)<<e-i-1,t>>=1;return n},f.prototype.permute=function(t,e,r,n,i,a){for(var o=0;o<a;o++)n[o]=e[t[o]],i[o]=r[t[o]]},f.prototype.transform=function(t,e,r,n,i,a){this.permute(a,t,e,r,n,i);for(var o=1;o<i;o<<=1)for(var s=o<<1,l=Math.cos(2*Math.PI/s),u=Math.sin(2*Math.PI/s),c=0;c<i;c+=s)for(var h=l,f=u,d=0;d<o;d++){var p=r[c+d],m=n[c+d],v=r[c+d+o],g=n[c+d+o],y=h*v-f*g;g=h*g+f*v,v=y,r[c+d]=p+v,n[c+d]=m+g,r[c+d+o]=p-v,n[c+d+o]=m-g,d!==s&&(y=l*h-u*f,f=l*f+u*h,h=y)}},f.prototype.guessLen13b=function(t,e){var r=1|Math.max(e,t),n=1&r,i=0;for(r=r/2|0;r;r>>>=1)i++;return 1<<i+1+n},f.prototype.conjugate=function(t,e,r){if(!(r<=1))for(var n=0;n<r/2;n++){var i=t[n];t[n]=t[r-n-1],t[r-n-1]=i,i=e[n],e[n]=-e[r-n-1],e[r-n-1]=-i}},f.prototype.normalize13b=function(t,e){for(var r=0,n=0;n<e/2;n++){var i=8192*Math.round(t[2*n+1]/e)+Math.round(t[2*n]/e)+r;t[n]=67108863&i,r=i<67108864?0:i/67108864|0}return t},f.prototype.convert13b=function(t,e,r,i){for(var a=0,o=0;o<e;o++)a+=0|t[o],r[2*o]=8191&a,a>>>=13,r[2*o+1]=8191&a,a>>>=13;for(o=2*e;o<i;++o)r[o]=0;n(0===a),n(0==(-8192&a))},f.prototype.stub=function(t){for(var e=new Array(t),r=0;r<t;r++)e[r]=0;return e},f.prototype.mulp=function(t,e,r){var n=2*this.guessLen13b(t.length,e.length),i=this.makeRBT(n),a=this.stub(n),o=new Array(n),s=new Array(n),l=new Array(n),u=new Array(n),c=new Array(n),h=new Array(n),f=r.words;f.length=n,this.convert13b(t.words,t.length,o,n),this.convert13b(e.words,e.length,u,n),this.transform(o,a,s,l,n,i),this.transform(u,a,c,h,n,i);for(var d=0;d<n;d++){var p=s[d]*c[d]-l[d]*h[d];l[d]=s[d]*h[d]+l[d]*c[d],s[d]=p}return this.conjugate(s,l,n),this.transform(s,l,f,a,n,i),this.conjugate(f,a,n),this.normalize13b(f,n),r.negative=t.negative^e.negative,r.length=t.length+e.length,r.strip()},a.prototype.mul=function(t){var e=new a(null);return e.words=new Array(this.length+t.length),this.mulTo(t,e)},a.prototype.mulf=function(t){var e=new a(null);return e.words=new Array(this.length+t.length),h(this,t,e)},a.prototype.imul=function(t){return this.clone().mulTo(t,this)},a.prototype.imuln=function(t){n(\"number\"==typeof t),n(t<67108864);for(var e=0,r=0;r<this.length;r++){var i=(0|this.words[r])*t,a=(67108863&i)+(67108863&e);e>>=26,e+=i/67108864|0,e+=a>>>26,this.words[r]=67108863&a}return 0!==e&&(this.words[r]=e,this.length++),this},a.prototype.muln=function(t){return this.clone().imuln(t)},a.prototype.sqr=function(){return this.mul(this)},a.prototype.isqr=function(){return this.imul(this.clone())},a.prototype.pow=function(t){var e=l(t);if(0===e.length)return new a(1);for(var r=this,n=0;n<e.length&&0===e[n];n++,r=r.sqr());if(++n<e.length)for(var i=r.sqr();n<e.length;n++,i=i.sqr())0!==e[n]&&(r=r.mul(i));return r},a.prototype.iushln=function(t){n(\"number\"==typeof t&&t>=0);var e,r=t%26,i=(t-r)/26,a=67108863>>>26-r<<26-r;if(0!==r){var o=0;for(e=0;e<this.length;e++){var s=this.words[e]&a,l=(0|this.words[e])-s<<r;this.words[e]=l|o,o=s>>>26-r}o&&(this.words[e]=o,this.length++)}if(0!==i){for(e=this.length-1;e>=0;e--)this.words[e+i]=this.words[e];for(e=0;e<i;e++)this.words[e]=0;this.length+=i}return this.strip()},a.prototype.ishln=function(t){return n(0===this.negative),this.iushln(t)},a.prototype.iushrn=function(t,e,r){n(\"number\"==typeof t&&t>=0);var i;i=e?(e-e%26)/26:0;var a=t%26,o=Math.min((t-a)/26,this.length),s=67108863^67108863>>>a<<a,l=r;if(i-=o,i=Math.max(0,i),l){for(var u=0;u<o;u++)l.words[u]=this.words[u];l.length=o}if(0===o);else if(this.length>o)for(this.length-=o,u=0;u<this.length;u++)this.words[u]=this.words[u+o];else this.words[0]=0,this.length=1;var c=0;for(u=this.length-1;u>=0&&(0!==c||u>=i);u--){var h=0|this.words[u];this.words[u]=c<<26-a|h>>>a,c=h&s}return l&&0!==c&&(l.words[l.length++]=c),0===this.length&&(this.words[0]=0,this.length=1),this.strip()},a.prototype.ishrn=function(t,e,r){return n(0===this.negative),this.iushrn(t,e,r)},a.prototype.shln=function(t){return this.clone().ishln(t)},a.prototype.ushln=function(t){return this.clone().iushln(t)},a.prototype.shrn=function(t){return this.clone().ishrn(t)},a.prototype.ushrn=function(t){return this.clone().iushrn(t)},a.prototype.testn=function(t){n(\"number\"==typeof t&&t>=0);var e=t%26,r=(t-e)/26,i=1<<e;return!(this.length<=r)&&!!(this.words[r]&i)},a.prototype.imaskn=function(t){n(\"number\"==typeof t&&t>=0);var e=t%26,r=(t-e)/26;if(n(0===this.negative,\"imaskn works only with positive numbers\"),this.length<=r)return this;if(0!==e&&r++,this.length=Math.min(r,this.length),0!==e){var i=67108863^67108863>>>e<<e;this.words[this.length-1]&=i}return this.strip()},a.prototype.maskn=function(t){return this.clone().imaskn(t)},a.prototype.iaddn=function(t){return n(\"number\"==typeof t),n(t<67108864),t<0?this.isubn(-t):0!==this.negative?1===this.length&&(0|this.words[0])<t?(this.words[0]=t-(0|this.words[0]),this.negative=0,this):(this.negative=0,this.isubn(t),this.negative=1,this):this._iaddn(t)},a.prototype._iaddn=function(t){this.words[0]+=t;for(var e=0;e<this.length&&this.words[e]>=67108864;e++)this.words[e]-=67108864,e===this.length-1?this.words[e+1]=1:this.words[e+1]++;return this.length=Math.max(this.length,e+1),this},a.prototype.isubn=function(t){if(n(\"number\"==typeof t),n(t<67108864),t<0)return this.iaddn(-t);if(0!==this.negative)return this.negative=0,this.iaddn(t),this.negative=1,this;if(this.words[0]-=t,1===this.length&&this.words[0]<0)this.words[0]=-this.words[0],this.negative=1;else for(var e=0;e<this.length&&this.words[e]<0;e++)this.words[e]+=67108864,this.words[e+1]-=1;return this.strip()},a.prototype.addn=function(t){return this.clone().iaddn(t)},a.prototype.subn=function(t){return this.clone().isubn(t)},a.prototype.iabs=function(){return this.negative=0,this},a.prototype.abs=function(){return this.clone().iabs()},a.prototype._ishlnsubmul=function(t,e,r){var i,a=t.length+r;this._expand(a);var o,s=0;for(i=0;i<t.length;i++){o=(0|this.words[i+r])+s;var l=(0|t.words[i])*e;o-=67108863&l,s=(o>>26)-(l/67108864|0),this.words[i+r]=67108863&o}for(;i<this.length-r;i++)o=(0|this.words[i+r])+s,s=o>>26,this.words[i+r]=67108863&o;if(0===s)return this.strip();for(n(-1===s),s=0,i=0;i<this.length;i++)o=-(0|this.words[i])+s,s=o>>26,this.words[i]=67108863&o;return this.negative=1,this.strip()},a.prototype._wordDiv=function(t,e){var r=this.length-t.length,n=this.clone(),i=t,o=0|i.words[i.length-1];0!==(r=26-this._countBits(o))&&(i=i.ushln(r),n.iushln(r),o=0|i.words[i.length-1]);var s,l=n.length-i.length;if(\"mod\"!==e){s=new a(null),s.length=l+1,s.words=new Array(s.length);for(var u=0;u<s.length;u++)s.words[u]=0}var c=n.clone()._ishlnsubmul(i,1,l);0===c.negative&&(n=c,s&&(s.words[l]=1));for(var h=l-1;h>=0;h--){var f=67108864*(0|n.words[i.length+h])+(0|n.words[i.length+h-1]);for(f=Math.min(f/o|0,67108863),n._ishlnsubmul(i,f,h);0!==n.negative;)f--,n.negative=0,n._ishlnsubmul(i,1,h),n.isZero()||(n.negative^=1);s&&(s.words[h]=f)}return s&&s.strip(),n.strip(),\"div\"!==e&&0!==r&&n.iushrn(r),{div:s||null,mod:n}},a.prototype.divmod=function(t,e,r){if(n(!t.isZero()),this.isZero())return{div:new a(0),mod:new a(0)};var i,o,s;return 0!==this.negative&&0===t.negative?(s=this.neg().divmod(t,e),\"mod\"!==e&&(i=s.div.neg()),\"div\"!==e&&(o=s.mod.neg(),r&&0!==o.negative&&o.iadd(t)),{div:i,mod:o}):0===this.negative&&0!==t.negative?(s=this.divmod(t.neg(),e),\"mod\"!==e&&(i=s.div.neg()),{div:i,mod:s.mod}):0!=(this.negative&t.negative)?(s=this.neg().divmod(t.neg(),e),\"div\"!==e&&(o=s.mod.neg(),r&&0!==o.negative&&o.isub(t)),{div:s.div,mod:o}):t.length>this.length||this.cmp(t)<0?{div:new a(0),mod:this}:1===t.length?\"div\"===e?{div:this.divn(t.words[0]),mod:null}:\"mod\"===e?{div:null,mod:new a(this.modn(t.words[0]))}:{div:this.divn(t.words[0]),mod:new a(this.modn(t.words[0]))}:this._wordDiv(t,e)},a.prototype.div=function(t){return this.divmod(t,\"div\",!1).div},a.prototype.mod=function(t){return this.divmod(t,\"mod\",!1).mod},a.prototype.umod=function(t){return this.divmod(t,\"mod\",!0).mod},a.prototype.divRound=function(t){var e=this.divmod(t);if(e.mod.isZero())return e.div;var r=0!==e.div.negative?e.mod.isub(t):e.mod,n=t.ushrn(1),i=t.andln(1),a=r.cmp(n);return a<0||1===i&&0===a?e.div:0!==e.div.negative?e.div.isubn(1):e.div.iaddn(1)},a.prototype.modn=function(t){n(t<=67108863);for(var e=(1<<26)%t,r=0,i=this.length-1;i>=0;i--)r=(e*r+(0|this.words[i]))%t;return r},a.prototype.idivn=function(t){n(t<=67108863);for(var e=0,r=this.length-1;r>=0;r--){var i=(0|this.words[r])+67108864*e;this.words[r]=i/t|0,e=i%t}return this.strip()},a.prototype.divn=function(t){return this.clone().idivn(t)},a.prototype.egcd=function(t){n(0===t.negative),n(!t.isZero());var e=this,r=t.clone();e=0!==e.negative?e.umod(t):e.clone();for(var i=new a(1),o=new a(0),s=new a(0),l=new a(1),u=0;e.isEven()&&r.isEven();)e.iushrn(1),r.iushrn(1),++u;for(var c=r.clone(),h=e.clone();!e.isZero();){for(var f=0,d=1;0==(e.words[0]&d)&&f<26;++f,d<<=1);if(f>0)for(e.iushrn(f);f-- >0;)(i.isOdd()||o.isOdd())&&(i.iadd(c),o.isub(h)),i.iushrn(1),o.iushrn(1);for(var p=0,m=1;0==(r.words[0]&m)&&p<26;++p,m<<=1);if(p>0)for(r.iushrn(p);p-- >0;)(s.isOdd()||l.isOdd())&&(s.iadd(c),l.isub(h)),s.iushrn(1),l.iushrn(1);e.cmp(r)>=0?(e.isub(r),i.isub(s),o.isub(l)):(r.isub(e),s.isub(i),l.isub(o))}return{a:s,b:l,gcd:r.iushln(u)}},a.prototype._invmp=function(t){n(0===t.negative),n(!t.isZero());var e=this,r=t.clone();e=0!==e.negative?e.umod(t):e.clone();for(var i=new a(1),o=new a(0),s=r.clone();e.cmpn(1)>0&&r.cmpn(1)>0;){for(var l=0,u=1;0==(e.words[0]&u)&&l<26;++l,u<<=1);if(l>0)for(e.iushrn(l);l-- >0;)i.isOdd()&&i.iadd(s),i.iushrn(1);for(var c=0,h=1;0==(r.words[0]&h)&&c<26;++c,h<<=1);if(c>0)for(r.iushrn(c);c-- >0;)o.isOdd()&&o.iadd(s),o.iushrn(1);e.cmp(r)>=0?(e.isub(r),i.isub(o)):(r.isub(e),o.isub(i))}var f;return f=0===e.cmpn(1)?i:o,f.cmpn(0)<0&&f.iadd(t),f},a.prototype.gcd=function(t){if(this.isZero())return t.abs();if(t.isZero())return this.abs();var e=this.clone(),r=t.clone();e.negative=0,r.negative=0;for(var n=0;e.isEven()&&r.isEven();n++)e.iushrn(1),r.iushrn(1);for(;;){for(;e.isEven();)e.iushrn(1);for(;r.isEven();)r.iushrn(1);var i=e.cmp(r);if(i<0){var a=e;e=r,r=a}else if(0===i||0===r.cmpn(1))break;e.isub(r)}return r.iushln(n)},a.prototype.invm=function(t){return this.egcd(t).a.umod(t)},a.prototype.isEven=function(){return 0==(1&this.words[0])},a.prototype.isOdd=function(){return 1==(1&this.words[0])},a.prototype.andln=function(t){return this.words[0]&t},a.prototype.bincn=function(t){n(\"number\"==typeof t);var e=t%26,r=(t-e)/26,i=1<<e;if(this.length<=r)return this._expand(r+1),this.words[r]|=i,this;for(var a=i,o=r;0!==a&&o<this.length;o++){var s=0|this.words[o];s+=a,a=s>>>26,s&=67108863,this.words[o]=s}return 0!==a&&(this.words[o]=a,this.length++),this},a.prototype.isZero=function(){return 1===this.length&&0===this.words[0]},a.prototype.cmpn=function(t){var e=t<0;if(0!==this.negative&&!e)return-1;if(0===this.negative&&e)return 1;this.strip();var r;if(this.length>1)r=1;else{e&&(t=-t),n(t<=67108863,\"Number is too big\");var i=0|this.words[0];r=i===t?0:i<t?-1:1}return 0!==this.negative?0|-r:r},a.prototype.cmp=function(t){if(0!==this.negative&&0===t.negative)return-1;if(0===this.negative&&0!==t.negative)return 1;var e=this.ucmp(t);return 0!==this.negative?0|-e:e},a.prototype.ucmp=function(t){if(this.length>t.length)return 1;if(this.length<t.length)return-1;for(var e=0,r=this.length-1;r>=0;r--){var n=0|this.words[r],i=0|t.words[r];if(n!==i){n<i?e=-1:n>i&&(e=1);break}}return e},a.prototype.gtn=function(t){return 1===this.cmpn(t)},a.prototype.gt=function(t){return 1===this.cmp(t)},a.prototype.gten=function(t){return this.cmpn(t)>=0},a.prototype.gte=function(t){return this.cmp(t)>=0},a.prototype.ltn=function(t){return-1===this.cmpn(t)},a.prototype.lt=function(t){return-1===this.cmp(t)},a.prototype.lten=function(t){return this.cmpn(t)<=0},a.prototype.lte=function(t){return this.cmp(t)<=0},a.prototype.eqn=function(t){return 0===this.cmpn(t)},a.prototype.eq=function(t){return 0===this.cmp(t)},a.red=function(t){return new y(t)},a.prototype.toRed=function(t){return n(!this.red,\"Already a number in reduction context\"),n(0===this.negative,\"red works only with positives\"),t.convertTo(this)._forceRed(t)},a.prototype.fromRed=function(){return n(this.red,\"fromRed works only with numbers in reduction context\"),this.red.convertFrom(this)},a.prototype._forceRed=function(t){return this.red=t,this},a.prototype.forceRed=function(t){return n(!this.red,\"Already a number in reduction context\"),this._forceRed(t)},a.prototype.redAdd=function(t){return n(this.red,\"redAdd works only with red numbers\"),this.red.add(this,t)},a.prototype.redIAdd=function(t){return n(this.red,\"redIAdd works only with red numbers\"),this.red.iadd(this,t)},a.prototype.redSub=function(t){return n(this.red,\"redSub works only with red numbers\"),this.red.sub(this,t)},a.prototype.redISub=function(t){return n(this.red,\"redISub works only with red numbers\"),this.red.isub(this,t)},a.prototype.redShl=function(t){return n(this.red,\"redShl works only with red numbers\"),this.red.shl(this,t)},a.prototype.redMul=function(t){return n(this.red,\"redMul works only with red numbers\"),this.red._verify2(this,t),this.red.mul(this,t)},a.prototype.redIMul=function(t){return n(this.red,\"redMul works only with red numbers\"),this.red._verify2(this,t),this.red.imul(this,t)},a.prototype.redSqr=function(){return n(this.red,\"redSqr works only with red numbers\"),this.red._verify1(this),this.red.sqr(this)},a.prototype.redISqr=function(){return n(this.red,\"redISqr works only with red numbers\"),this.red._verify1(this),this.red.isqr(this)},a.prototype.redSqrt=function(){return n(this.red,\"redSqrt works only with red numbers\"),this.red._verify1(this),this.red.sqrt(this)},a.prototype.redInvm=function(){return n(this.red,\"redInvm works only with red numbers\"),this.red._verify1(this),this.red.invm(this)},a.prototype.redNeg=function(){return n(this.red,\"redNeg works only with red numbers\"),this.red._verify1(this),this.red.neg(this)},a.prototype.redPow=function(t){return n(this.red&&!t.red,\"redPow(normalNum)\"),this.red._verify1(this),this.red.pow(this,t)};var A={k256:null,p224:null,p192:null,p25519:null};d.prototype._tmp=function(){var t=new a(null);return t.words=new Array(Math.ceil(this.n/13)),t},d.prototype.ireduce=function(t){var e,r=t;do{this.split(r,this.tmp),r=this.imulK(r),r=r.iadd(this.tmp),e=r.bitLength()}while(e>this.n);var n=e<this.n?-1:r.ucmp(this.p);return 0===n?(r.words[0]=0,r.length=1):n>0?r.isub(this.p):r.strip(),r},d.prototype.split=function(t,e){t.iushrn(this.n,0,e)},d.prototype.imulK=function(t){return t.imul(this.k)},i(p,d),p.prototype.split=function(t,e){for(var r=Math.min(t.length,9),n=0;n<r;n++)e.words[n]=t.words[n];if(e.length=r,t.length<=9)return t.words[0]=0,void(t.length=1);var i=t.words[9];for(e.words[e.length++]=4194303&i,n=10;n<t.length;n++){var a=0|t.words[n];t.words[n-10]=(4194303&a)<<4|i>>>22,i=a}i>>>=22,t.words[n-10]=i,0===i&&t.length>10?t.length-=10:t.length-=9},p.prototype.imulK=function(t){t.words[t.length]=0,t.words[t.length+1]=0,t.length+=2;for(var e=0,r=0;r<t.length;r++){var n=0|t.words[r];e+=977*n,t.words[r]=67108863&e,e=64*n+(e/67108864|0)}return 0===t.words[t.length-1]&&(t.length--,0===t.words[t.length-1]&&t.length--),t},i(m,d),i(v,d),i(g,d),g.prototype.imulK=function(t){for(var e=0,r=0;r<t.length;r++){var n=19*(0|t.words[r])+e,i=67108863&n;n>>>=26,t.words[r]=i,e=n}return 0!==e&&(t.words[t.length++]=e),t},a._prime=function(t){if(A[t])return A[t];var e;if(\"k256\"===t)e=new p;else if(\"p224\"===t)e=new m;else if(\"p192\"===t)e=new v;else{if(\"p25519\"!==t)throw new Error(\"Unknown prime \"+t);e=new g}return A[t]=e,e},y.prototype._verify1=function(t){n(0===t.negative,\"red works only with positives\"),n(t.red,\"red works only with red numbers\")},y.prototype._verify2=function(t,e){n(0==(t.negative|e.negative),\"red works only with positives\"),n(t.red&&t.red===e.red,\"red works only with red numbers\")},y.prototype.imod=function(t){return this.prime?this.prime.ireduce(t)._forceRed(this):t.umod(this.m)._forceRed(this)},y.prototype.neg=function(t){return t.isZero()?t.clone():this.m.sub(t)._forceRed(this)},y.prototype.add=function(t,e){this._verify2(t,e);var r=t.add(e);return r.cmp(this.m)>=0&&r.isub(this.m),r._forceRed(this)},y.prototype.iadd=function(t,e){this._verify2(t,e);var r=t.iadd(e);return r.cmp(this.m)>=0&&r.isub(this.m),r},y.prototype.sub=function(t,e){this._verify2(t,e);var r=t.sub(e);return r.cmpn(0)<0&&r.iadd(this.m),r._forceRed(this)},y.prototype.isub=function(t,e){this._verify2(t,e);var r=t.isub(e);return r.cmpn(0)<0&&r.iadd(this.m),r},y.prototype.shl=function(t,e){return this._verify1(t),this.imod(t.ushln(e))},y.prototype.imul=function(t,e){return this._verify2(t,e),this.imod(t.imul(e))},y.prototype.mul=function(t,e){return this._verify2(t,e),this.imod(t.mul(e))},y.prototype.isqr=function(t){return this.imul(t,t.clone())},y.prototype.sqr=function(t){return this.mul(t,t)},y.prototype.sqrt=function(t){if(t.isZero())return t.clone();var e=this.m.andln(3);if(n(e%2==1),3===e){var r=this.m.add(new a(1)).iushrn(2);return this.pow(t,r)}for(var i=this.m.subn(1),o=0;!i.isZero()&&0===i.andln(1);)o++,i.iushrn(1);n(!i.isZero());var s=new a(1).toRed(this),l=s.redNeg(),u=this.m.subn(1).iushrn(1),c=this.m.bitLength();for(c=new a(2*c*c).toRed(this);0!==this.pow(c,u).cmp(l);)c.redIAdd(l);for(var h=this.pow(c,i),f=this.pow(t,i.addn(1).iushrn(1)),d=this.pow(t,i),p=o;0!==d.cmp(s);){for(var m=d,v=0;0!==m.cmp(s);v++)m=m.redSqr();n(v<p);var g=this.pow(h,new a(1).iushln(p-v-1));f=f.redMul(g),h=g.redSqr(),d=d.redMul(h),p=v}return f},y.prototype.invm=function(t){var e=t._invmp(this.m);return 0!==e.negative?(e.negative=0,this.imod(e).redNeg()):this.imod(e)},y.prototype.pow=function(t,e){if(e.isZero())return new a(1);if(0===e.cmpn(1))return t.clone();var r=new Array(16);r[0]=new a(1).toRed(this),r[1]=t;for(var n=2;n<r.length;n++)r[n]=this.mul(r[n-1],t);var i=r[0],o=0,s=0,l=e.bitLength()%26;for(0===l&&(l=26),n=e.length-1;n>=0;n--){for(var u=e.words[n],c=l-1;c>=0;c--){var h=u>>c&1;i!==r[0]&&(i=this.sqr(i)),0!==h||0!==o?(o<<=1,o|=h,(4===++s||0===n&&0===c)&&(i=this.mul(i,r[o]),s=0,o=0)):s=0}l=26}return i},y.prototype.convertTo=function(t){var e=t.umod(this.m);return e===t?e.clone():e},y.prototype.convertFrom=function(t){var e=t.clone();return e.red=null,e},a.mont=function(t){return new b(t)},i(b,y),b.prototype.convertTo=function(t){return this.imod(t.ushln(this.shift))},b.prototype.convertFrom=function(t){var e=this.imod(t.mul(this.rinv));return e.red=null,e},b.prototype.imul=function(t,e){if(t.isZero()||e.isZero())return t.words[0]=0,t.length=1,t;var r=t.imul(e),n=r.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m),i=r.isub(n).iushrn(this.shift),a=i;return i.cmp(this.m)>=0?a=i.isub(this.m):i.cmpn(0)<0&&(a=i.iadd(this.m)),a._forceRed(this)},b.prototype.mul=function(t,e){if(t.isZero()||e.isZero())return new a(0)._forceRed(this);var r=t.mul(e),n=r.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m),i=r.isub(n).iushrn(this.shift),o=i;return i.cmp(this.m)>=0?o=i.isub(this.m):i.cmpn(0)<0&&(o=i.iadd(this.m)),o._forceRed(this)},b.prototype.invm=function(t){return this.imod(t._invmp(this.m).mul(this.r2))._forceRed(this)}}(void 0===e||e,this)},{}],68:[function(t,e,r){\"use strict\";function n(t){var e,r,n,i=t.length,a=0;for(e=0;e<i;++e)a+=t[e].length;var o=new Array(a),s=0;for(e=0;e<i;++e){var l=t[e],u=l.length;for(r=0;r<u;++r){var c=o[s++]=new Array(u-1),h=0;for(n=0;n<u;++n)n!==r&&(c[h++]=l[n]);if(1&r){var f=c[1];c[1]=c[0],c[0]=f}}}return o}e.exports=n},{}],69:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0;r<t;++r)if(!(e[r]<=e[r+t]))return!0;return!1}function i(t,e,r,i){for(var a=0,o=0,s=0,l=t.length;s<l;++s){var u=t[s];if(!n(e,u)){for(var c=0;c<2*e;++c)r[a++]=u[c];i[o++]=s}}return o}function a(t,e,r,n){var a=t.length,o=e.length;if(!(a<=0||o<=0)){var s=t[0].length>>>1;if(!(s<=0)){var l,u=h.mallocDouble(2*s*a),c=h.mallocInt32(a);if((a=i(t,s,u,c))>0){if(1===s&&n)f.init(a),l=f.sweepComplete(s,r,0,a,u,c,0,a,u,c);else{var p=h.mallocDouble(2*s*o),m=h.mallocInt32(o);o=i(e,s,p,m),o>0&&(f.init(a+o),l=1===s?f.sweepBipartite(s,r,0,a,u,c,0,o,p,m):d(s,r,n,a,u,c,o,p,m),h.free(p),h.free(m))}h.free(u),h.free(c)}return l}}}function o(t,e){c.push([t,e])}function s(t){return c=[],a(t,t,o,!0),c}function l(t,e){return c=[],a(t,e,o,!1),c}function u(t,e,r){switch(arguments.length){case 1:return s(t);case 2:return\"function\"==typeof e?a(t,t,e,!0):l(t,e);case 3:return a(t,e,r,!1);default:throw new Error(\"box-intersect: Invalid arguments\")}}e.exports=u;var c,h=t(\"typedarray-pool\"),f=t(\"./lib/sweep\"),d=t(\"./lib/intersect\")},{\"./lib/intersect\":71,\"./lib/sweep\":75,\"typedarray-pool\":540}],70:[function(t,e,r){\"use strict\";function n(t,e,r){var n=\"bruteForce\"+(t?\"Red\":\"Blue\")+(e?\"Flip\":\"\")+(r?\"Full\":\"\"),i=[\"function \",n,\"(\",w.join(),\"){\",\"var \",u,\"=2*\",a,\";\"],l=\"for(var i=\"+c+\",\"+p+\"=\"+u+\"*\"+c+\";i<\"+h+\";++i,\"+p+\"+=\"+u+\"){var x0=\"+f+\"[\"+o+\"+\"+p+\"],x1=\"+f+\"[\"+o+\"+\"+p+\"+\"+a+\"],xi=\"+d+\"[i];\",M=\"for(var j=\"+m+\",\"+b+\"=\"+u+\"*\"+m+\";j<\"+v+\";++j,\"+b+\"+=\"+u+\"){var y0=\"+g+\"[\"+o+\"+\"+b+\"],\"+(r?\"y1=\"+g+\"[\"+o+\"+\"+b+\"+\"+a+\"],\":\"\")+\"yi=\"+y+\"[j];\";return t?i.push(l,_,\":\",M):i.push(M,_,\":\",l),r?i.push(\"if(y1<x0||x1<y0)continue;\"):e?i.push(\"if(y0<=x0||x1<y0)continue;\"):i.push(\"if(y0<x0||x1<y0)continue;\"),i.push(\"for(var k=\"+o+\"+1;k<\"+a+\";++k){var r0=\"+f+\"[k+\"+p+\"],r1=\"+f+\"[k+\"+a+\"+\"+p+\"],b0=\"+g+\"[k+\"+b+\"],b1=\"+g+\"[k+\"+a+\"+\"+b+\"];if(r1<b0||b1<r0)continue \"+_+\";}var \"+x+\"=\"+s+\"(\"),e?i.push(\"yi,xi\"):i.push(\"xi,yi\"),i.push(\");if(\"+x+\"!==void 0)return \"+x+\";}}}\"),{name:n,code:i.join(\"\")}}function i(t){function e(e,r){var a=n(e,r,t);i.push(a.code),o.push(\"return \"+a.name+\"(\"+w.join()+\");\")}var r=\"bruteForce\"+(t?\"Full\":\"Partial\"),i=[],a=w.slice();t||a.splice(3,0,l);var o=[\"function \"+r+\"(\"+a.join()+\"){\"];o.push(\"if(\"+h+\"-\"+c+\">\"+v+\"-\"+m+\"){\"),t?(e(!0,!1),o.push(\"}else{\"),e(!1,!1)):(o.push(\"if(\"+l+\"){\"),e(!0,!0),o.push(\"}else{\"),e(!0,!1),o.push(\"}}else{if(\"+l+\"){\"),e(!1,!0),o.push(\"}else{\"),e(!1,!1),o.push(\"}\")),o.push(\"}}return \"+r);var s=i.join(\"\")+o.join(\"\");return new Function(s)()}var a=\"d\",o=\"ax\",s=\"vv\",l=\"fp\",u=\"es\",c=\"rs\",h=\"re\",f=\"rb\",d=\"ri\",p=\"rp\",m=\"bs\",v=\"be\",g=\"bb\",y=\"bi\",b=\"bp\",x=\"rv\",_=\"Q\",w=[a,o,s,c,h,f,d,m,v,g,y];r.partial=i(!1),r.full=i(!0)},{}],71:[function(t,e,r){\"use strict\";function n(t,e){var r=8*u.log2(e+1)*(t+1)|0,n=u.nextPow2(A*r);S.length<n&&(l.free(S),S=l.mallocInt32(n));var i=u.nextPow2(T*r);E<i&&(l.free(E),E=l.mallocDouble(i))}function i(t,e,r,n,i,a,o,s,l){var u=A*t;S[u]=e,S[u+1]=r,S[u+2]=n,S[u+3]=i,S[u+4]=a,S[u+5]=o;var c=T*t;E[c]=s,E[c+1]=l}function a(t,e,r,n,i,a,o,s,l,u,c){var h=2*t,f=l*h,d=u[f+e];t:for(var p=i,m=i*h;p<a;++p,m+=h){var v=o[m+e],g=o[m+e+t];if(!(d<v||g<d)&&(!n||d!==v)){for(var y=s[p],b=e+1;b<t;++b){var v=o[m+b],g=o[m+b+t],x=u[f+b],_=u[f+b+t];if(g<x||_<v)continue t}var w;if(void 0!==(w=n?r(c,y):r(y,c)))return w}}}function o(t,e,r,n,i,a,o,s,l,u){var c=2*t,h=s*c,f=l[h+e];t:for(var d=n,p=n*c;d<i;++d,p+=c){var m=o[d];if(m!==u){var v=a[p+e],g=a[p+e+t];if(!(f<v||g<f)){for(var y=e+1;y<t;++y){var v=a[p+y],g=a[p+y+t],b=l[h+y],x=l[h+y+t];if(g<b||x<v)continue t}var _=r(m,u);if(void 0!==_)return _}}}}function s(t,e,r,s,l,u,c,m,L){n(t,s+c);var C,z=0,I=2*t;for(i(z++,0,0,s,0,c,r?16:0,-1/0,1/0),r||i(z++,0,0,c,0,s,1,-1/0,1/0);z>0;){z-=1;var D=z*A,P=S[D],O=S[D+1],R=S[D+2],F=S[D+3],j=S[D+4],N=S[D+5],B=z*T,U=E[B],V=E[B+1],H=1&N,q=!!(16&N),G=l,Y=u,X=m,W=L;if(H&&(G=m,Y=L,X=l,W=u),!(2&N&&(R=_(t,P,O,R,G,Y,V),O>=R)||4&N&&(O=w(t,P,O,R,G,Y,U))>=R)){var Z=R-O,J=j-F;if(q){if(t*Z*(Z+J)<y){if(void 0!==(C=d.scanComplete(t,P,e,O,R,G,Y,F,j,X,W)))return C;continue}}else{if(t*Math.min(Z,J)<v){if(void 0!==(C=h(t,P,e,H,O,R,G,Y,F,j,X,W)))return C;continue}if(t*Z*J<g){if(void 0!==(C=d.scanBipartite(t,P,e,H,O,R,G,Y,F,j,X,W)))return C;continue}}var K=b(t,P,O,R,G,Y,U,V);if(O<K)if(t*(K-O)<v){if(void 0!==(C=f(t,P+1,e,O,K,G,Y,F,j,X,W)))return C}else if(P===t-2){if(void 0!==(C=H?d.sweepBipartite(t,e,F,j,X,W,O,K,G,Y):d.sweepBipartite(t,e,O,K,G,Y,F,j,X,W)))return C}else i(z++,P+1,O,K,F,j,H,-1/0,1/0),i(z++,P+1,F,j,O,K,1^H,-1/0,1/0);if(K<R){var Q=p(t,P,F,j,X,W),$=X[I*Q+P],tt=x(t,P,Q,j,X,W,$);if(tt<j&&i(z++,P,K,R,tt,j,(4|H)+(q?16:0),$,V),F<Q&&i(z++,P,K,R,F,Q,(2|H)+(q?16:0),U,$),Q+1===tt){if(void 0!==(C=q?o(t,P,e,K,R,G,Y,Q,X,W[Q]):a(t,P,e,H,K,R,G,Y,Q,X,W[Q])))return C}else if(Q<tt){var et;if(q){if(et=M(t,P,K,R,G,Y,$),K<et){var rt=x(t,P,K,et,G,Y,$);if(P===t-2){if(K<rt&&void 0!==(C=d.sweepComplete(t,e,K,rt,G,Y,Q,tt,X,W)))return C;if(rt<et&&void 0!==(C=d.sweepBipartite(t,e,rt,et,G,Y,Q,tt,X,W)))return C}else K<rt&&i(z++,P+1,K,rt,Q,tt,16,-1/0,1/0),rt<et&&(i(z++,P+1,rt,et,Q,tt,0,-1/0,1/0),i(z++,P+1,Q,tt,rt,et,1,-1/0,1/0))}}else et=H?k(t,P,K,R,G,Y,$):M(t,P,K,R,G,Y,$),K<et&&(P===t-2?C=H?d.sweepBipartite(t,e,Q,tt,X,W,K,et,G,Y):d.sweepBipartite(t,e,K,et,G,Y,Q,tt,X,W):(i(z++,P+1,K,et,Q,tt,H,-1/0,1/0),i(z++,P+1,Q,tt,K,et,1^H,-1/0,1/0)))}}}}}e.exports=s;var l=t(\"typedarray-pool\"),u=t(\"bit-twiddle\"),c=t(\"./brute\"),h=c.partial,f=c.full,d=t(\"./sweep\"),p=t(\"./median\"),m=t(\"./partition\"),v=128,g=1<<22,y=1<<22,b=m(\"!(lo>=p0)&&!(p1>=hi)\",[\"p0\",\"p1\"]),x=m(\"lo===p0\",[\"p0\"]),_=m(\"lo<p0\",[\"p0\"]),w=m(\"hi<=p0\",[\"p0\"]),M=m(\"lo<=p0&&p0<=hi\",[\"p0\"]),k=m(\"lo<p0&&p0<=hi\",[\"p0\"]),A=6,T=2,S=l.mallocInt32(1024),E=l.mallocDouble(1024)},{\"./brute\":70,\"./median\":72,\"./partition\":73,\"./sweep\":75,\"bit-twiddle\":66,\"typedarray-pool\":540}],72:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){for(var o=2*t,s=o*(r+1)+e,l=r+1;l<n;++l,s+=o)for(var u=i[s],c=l,h=o*(l-1);c>r&&i[h+e]>u;--c,h-=o){for(var f=h,d=h+o,p=0;p<o;++p,++f,++d){var m=i[f];i[f]=i[d],i[d]=m}var v=a[c];a[c]=a[c-1],a[c-1]=v}}function i(t,e,r,i,a,l){if(i<=r+1)return r;for(var u=r,c=i,h=i+r>>>1,f=2*t,d=h,p=a[f*h+e];u<c;){if(c-u<s){n(t,e,u,c,a,l),p=a[f*h+e];break}var m=c-u,v=Math.random()*m+u|0,g=a[f*v+e],y=Math.random()*m+u|0,b=a[f*y+e],x=Math.random()*m+u|0,_=a[f*x+e];g<=b?_>=b?(d=y,p=b):g>=_?(d=v,p=g):(d=x,p=_):b>=_?(d=y,p=b):_>=g?(d=v,p=g):(d=x,p=_);for(var w=f*(c-1),M=f*d,k=0;k<f;++k,++w,++M){var A=a[w];a[w]=a[M],a[M]=A}var T=l[c-1];l[c-1]=l[d],l[d]=T,d=o(t,e,u,c-1,a,l,p);for(var w=f*(c-1),M=f*d,k=0;k<f;++k,++w,++M){var A=a[w];a[w]=a[M],a[M]=A}var T=l[c-1];if(l[c-1]=l[d],l[d]=T,h<d){for(c=d-1;u<c&&a[f*(c-1)+e]===p;)c-=1;c+=1}else{if(!(d<h))break;for(u=d+1;u<c&&a[f*u+e]===p;)u+=1}}return o(t,e,r,h,a,l,a[f*h+e])}e.exports=i;var a=t(\"./partition\"),o=a(\"lo<p0\",[\"p0\"]),s=8},{\"./partition\":73}],73:[function(t,e,r){\"use strict\";function n(t,e){var r=\"abcdef\".split(\"\").concat(e),n=[];return t.indexOf(\"lo\")>=0&&n.push(\"lo=e[k+n]\"),t.indexOf(\"hi\")>=0&&n.push(\"hi=e[k+o]\"),r.push(i.replace(\"_\",n.join()).replace(\"$\",t)),Function.apply(void 0,r)}e.exports=n;var i=\"for(var j=2*a,k=j*c,l=k,m=c,n=b,o=a+b,p=c;d>p;++p,k+=j){var _;if($)if(m===p)m+=1,l+=j;else{for(var s=0;j>s;++s){var t=e[k+s];e[k+s]=e[l],e[l++]=t}var u=f[p];f[p]=f[m],f[m++]=u}}return m\"},{}],74:[function(t,e,r){\"use strict\";function n(t,e){e<=4*f?i(0,e-1,t):h(0,e-1,t)}function i(t,e,r){for(var n=2*(t+1),i=t+1;i<=e;++i){for(var a=r[n++],o=r[n++],s=i,l=n-2;s-- >t;){var u=r[l-2],c=r[l-1];if(u<a)break;if(u===a&&c<o)break;r[l]=u,r[l+1]=c,l-=2}r[l]=a,r[l+1]=o}}function a(t,e,r){t*=2,e*=2;var n=r[t],i=r[t+1];r[t]=r[e],r[t+1]=r[e+1],r[e]=n,r[e+1]=i}function o(t,e,r){t*=2,e*=2,r[t]=r[e],r[t+1]=r[e+1]}function s(t,e,r,n){t*=2,e*=2,r*=2;var i=n[t],a=n[t+1];n[t]=n[e],n[t+1]=n[e+1],n[e]=n[r],n[e+1]=n[r+1],n[r]=i,n[r+1]=a}function l(t,e,r,n,i){t*=2,e*=2,i[t]=i[e],i[e]=r,i[t+1]=i[e+1],i[e+1]=n}function u(t,e,r){t*=2,e*=2;var n=r[t],i=r[e];return!(n<i)&&(n!==i||r[t+1]>r[e+1])}function c(t,e,r,n){t*=2;var i=n[t];return i<e||i===e&&n[t+1]<r}function h(t,e,r){var n=(e-t+1)/6|0,d=t+n,p=e-n,m=t+e>>1,v=m-n,g=m+n,y=d,b=v,x=m,_=g,w=p,M=t+1,k=e-1,A=0;u(y,b,r)&&(A=y,y=b,b=A),u(_,w,r)&&(A=_,_=w,w=A),u(y,x,r)&&(A=y,y=x,x=A),u(b,x,r)&&(A=b,b=x,x=A),u(y,_,r)&&(A=y,y=_,_=A),u(x,_,r)&&(A=x,x=_,_=A),u(b,w,r)&&(A=b,b=w,w=A),u(b,x,r)&&(A=b,b=x,x=A),u(_,w,r)&&(A=_,_=w,w=A);for(var T=r[2*b],S=r[2*b+1],E=r[2*_],L=r[2*_+1],C=2*y,z=2*x,I=2*w,D=2*d,P=2*m,O=2*p,R=0;R<2;++R){var F=r[C+R],j=r[z+R],N=r[I+R];r[D+R]=F,r[P+R]=j,r[O+R]=N}o(v,t,r),o(g,e,r);for(var B=M;B<=k;++B)if(c(B,T,S,r))B!==M&&a(B,M,r),++M;else if(!c(B,E,L,r))for(;;){if(c(k,E,L,r)){c(k,T,S,r)?(s(B,M,k,r),++M,--k):(a(B,k,r),--k);break}if(--k<B)break}l(t,M-1,T,S,r),l(e,k+1,E,L,r),M-2-t<=f?i(t,M-2,r):h(t,M-2,r),e-(k+2)<=f?i(k+2,e,r):h(k+2,e,r),k-M<=f?i(M,k,r):h(M,k,r)}e.exports=n;var f=32},{}],75:[function(t,e,r){\"use strict\";function n(t){var e=h.nextPow2(t);p.length<e&&(c.free(p),p=c.mallocInt32(e)),m.length<e&&(c.free(m),m=c.mallocInt32(e)),v.length<e&&(c.free(v),v=c.mallocInt32(e)),g.length<e&&(c.free(g),g=c.mallocInt32(e)),y.length<e&&(c.free(y),y=c.mallocInt32(e)),b.length<e&&(c.free(b),b=c.mallocInt32(e));var r=8*e;x.length<r&&(c.free(x),x=c.mallocDouble(r))}function i(t,e,r,n){var i=e[n],a=t[r-1];t[i]=a,e[a]=i}function a(t,e,r,n){t[r]=n,e[n]=r}function o(t,e,r,n,o,s,l,u,c,h){for(var y=0,b=2*t,_=t-1,w=b-1,M=r;M<n;++M){var k=s[M],A=b*M;x[y++]=o[A+_],x[y++]=-(k+1),x[y++]=o[A+w],x[y++]=k}for(var M=l;M<u;++M){var k=h[M]+d,T=b*M;x[y++]=c[T+_],x[y++]=-k,x[y++]=c[T+w],x[y++]=k}var S=y>>>1;f(x,S);for(var E=0,L=0,M=0;M<S;++M){var C=0|x[2*M+1];if(C>=d)C=C-d|0,i(v,g,L--,C);else if(C>=0)i(p,m,E--,C);else if(C<=-d){C=-C-d|0;for(var z=0;z<E;++z){var I=e(p[z],C);if(void 0!==I)return I}a(v,g,L++,C)}else{C=-C-1|0;for(var z=0;z<L;++z){var I=e(C,v[z]);if(void 0!==I)return I}a(p,m,E++,C)}}}function s(t,e,r,n,o,s,l,u,c,h){for(var d=0,_=2*t,w=t-1,M=_-1,k=r;k<n;++k){var A=s[k]+1<<1,T=_*k;x[d++]=o[T+w],x[d++]=-A,x[d++]=o[T+M],x[d++]=A}for(var k=l;k<u;++k){var A=h[k]+1<<1,S=_*k;x[d++]=c[S+w],x[d++]=1|-A,x[d++]=c[S+M],x[d++]=1|A}var E=d>>>1;f(x,E);for(var L=0,C=0,z=0,k=0;k<E;++k){var I=0|x[2*k+1],D=1&I;if(k<E-1&&I>>1==x[2*k+3]>>1&&(D=2,k+=1),I<0){for(var P=-(I>>1)-1,O=0;O<z;++O){var R=e(y[O],P);if(void 0!==R)return R}if(0!==D)for(var O=0;O<L;++O){var R=e(p[O],P);if(void 0!==R)return R}if(1!==D)for(var O=0;O<C;++O){var R=e(v[O],P);if(void 0!==R)return R}0===D?a(p,m,L++,P):1===D?a(v,g,C++,P):2===D&&a(y,b,z++,P)}else{var P=(I>>1)-1;0===D?i(p,m,L--,P):1===D?i(v,g,C--,P):2===D&&i(y,b,z--,P)}}}function l(t,e,r,n,o,s,l,u,c,h,v,g){var y=0,b=2*t,_=e,w=e+t,M=1,k=1;n?k=d:M=d;for(var A=o;A<s;++A){var T=A+M,S=b*A;x[y++]=l[S+_],x[y++]=-T,x[y++]=l[S+w],x[y++]=T}for(var A=c;A<h;++A){\n",
       "var T=A+k,E=b*A;x[y++]=v[E+_],x[y++]=-T}var L=y>>>1;f(x,L);for(var C=0,A=0;A<L;++A){var z=0|x[2*A+1];if(z<0){var T=-z,I=!1;if(T>=d?(I=!n,T-=d):(I=!!n,T-=1),I)a(p,m,C++,T);else{var D=g[T],P=b*T,O=v[P+e+1],R=v[P+e+1+t];t:for(var F=0;F<C;++F){var j=p[F],N=b*j;if(!(R<l[N+e+1]||l[N+e+1+t]<O)){for(var B=e+2;B<t;++B)if(v[P+B+t]<l[N+B]||l[N+B+t]<v[P+B])continue t;var U,V=u[j];if(void 0!==(U=n?r(D,V):r(V,D)))return U}}}}else i(p,m,C--,z-M)}}function u(t,e,r,n,i,a,o,s,l,u,c){for(var h=0,m=2*t,v=e,g=e+t,y=n;y<i;++y){var b=y+d,_=m*y;x[h++]=a[_+v],x[h++]=-b,x[h++]=a[_+g],x[h++]=b}for(var y=s;y<l;++y){var b=y+1,w=m*y;x[h++]=u[w+v],x[h++]=-b}var M=h>>>1;f(x,M);for(var k=0,y=0;y<M;++y){var A=0|x[2*y+1];if(A<0){var b=-A;if(b>=d)p[k++]=b-d;else{b-=1;var T=c[b],S=m*b,E=u[S+e+1],L=u[S+e+1+t];t:for(var C=0;C<k;++C){var z=p[C],I=o[z];if(I===T)break;var D=m*z;if(!(L<a[D+e+1]||a[D+e+1+t]<E)){for(var P=e+2;P<t;++P)if(u[S+P+t]<a[D+P]||a[D+P+t]<u[S+P])continue t;var O=r(I,T);if(void 0!==O)return O}}}}else{for(var b=A-d,C=k-1;C>=0;--C)if(p[C]===b){for(var P=C+1;P<k;++P)p[P-1]=p[P];break}--k}}}e.exports={init:n,sweepBipartite:o,sweepComplete:s,scanBipartite:l,scanComplete:u};var c=t(\"typedarray-pool\"),h=t(\"bit-twiddle\"),f=t(\"./sort\"),d=1<<28,p=c.mallocInt32(1024),m=c.mallocInt32(1024),v=c.mallocInt32(1024),g=c.mallocInt32(1024),y=c.mallocInt32(1024),b=c.mallocInt32(1024),x=c.mallocDouble(8192)},{\"./sort\":74,\"bit-twiddle\":66,\"typedarray-pool\":540}],76:[function(t,e,r){\"use strict\";function n(t){if(t>Z)throw new RangeError(\"Invalid typed array length\");var e=new Uint8Array(t);return e.__proto__=i.prototype,e}function i(t,e,r){if(\"number\"==typeof t){if(\"string\"==typeof e)throw new Error(\"If encoding is specified then the first argument must be a string\");return l(t)}return a(t,e,r)}function a(t,e,r){if(\"number\"==typeof t)throw new TypeError('\"value\" argument must not be a number');return t instanceof ArrayBuffer?h(t,e,r):\"string\"==typeof t?u(t,e):f(t)}function o(t){if(\"number\"!=typeof t)throw new TypeError('\"size\" argument must be a number');if(t<0)throw new RangeError('\"size\" argument must not be negative')}function s(t,e,r){return o(t),t<=0?n(t):void 0!==e?\"string\"==typeof r?n(t).fill(e,r):n(t).fill(e):n(t)}function l(t){return o(t),n(t<0?0:0|d(t))}function u(t,e){if(\"string\"==typeof e&&\"\"!==e||(e=\"utf8\"),!i.isEncoding(e))throw new TypeError('\"encoding\" must be a valid string encoding');var r=0|m(t,e),a=n(r),o=a.write(t,e);return o!==r&&(a=a.slice(0,o)),a}function c(t){for(var e=t.length<0?0:0|d(t.length),r=n(e),i=0;i<e;i+=1)r[i]=255&t[i];return r}function h(t,e,r){if(e<0||t.byteLength<e)throw new RangeError(\"'offset' is out of bounds\");if(t.byteLength<e+(r||0))throw new RangeError(\"'length' is out of bounds\");var n;return n=void 0===e&&void 0===r?new Uint8Array(t):void 0===r?new Uint8Array(t,e):new Uint8Array(t,e,r),n.__proto__=i.prototype,n}function f(t){if(i.isBuffer(t)){var e=0|d(t.length),r=n(e);return 0===r.length?r:(t.copy(r,0,0,e),r)}if(t){if(G(t)||\"length\"in t)return\"number\"!=typeof t.length||Y(t.length)?n(0):c(t);if(\"Buffer\"===t.type&&Array.isArray(t.data))return c(t.data)}throw new TypeError(\"First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.\")}function d(t){if(t>=Z)throw new RangeError(\"Attempt to allocate Buffer larger than maximum size: 0x\"+Z.toString(16)+\" bytes\");return 0|t}function p(t){return+t!=t&&(t=0),i.alloc(+t)}function m(t,e){if(i.isBuffer(t))return t.length;if(G(t)||t instanceof ArrayBuffer)return t.byteLength;\"string\"!=typeof t&&(t=\"\"+t);var r=t.length;if(0===r)return 0;for(var n=!1;;)switch(e){case\"ascii\":case\"latin1\":case\"binary\":return r;case\"utf8\":case\"utf-8\":case void 0:return B(t).length;case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return 2*r;case\"hex\":return r>>>1;case\"base64\":return H(t).length;default:if(n)return B(t).length;e=(\"\"+e).toLowerCase(),n=!0}}function v(t,e,r){var n=!1;if((void 0===e||e<0)&&(e=0),e>this.length)return\"\";if((void 0===r||r>this.length)&&(r=this.length),r<=0)return\"\";if(r>>>=0,e>>>=0,r<=e)return\"\";for(t||(t=\"utf8\");;)switch(t){case\"hex\":return z(this,e,r);case\"utf8\":case\"utf-8\":return S(this,e,r);case\"ascii\":return L(this,e,r);case\"latin1\":case\"binary\":return C(this,e,r);case\"base64\":return T(this,e,r);case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return I(this,e,r);default:if(n)throw new TypeError(\"Unknown encoding: \"+t);t=(t+\"\").toLowerCase(),n=!0}}function g(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}function y(t,e,r,n,a){if(0===t.length)return-1;if(\"string\"==typeof r?(n=r,r=0):r>2147483647?r=2147483647:r<-2147483648&&(r=-2147483648),r=+r,Y(r)&&(r=a?0:t.length-1),r<0&&(r=t.length+r),r>=t.length){if(a)return-1;r=t.length-1}else if(r<0){if(!a)return-1;r=0}if(\"string\"==typeof e&&(e=i.from(e,n)),i.isBuffer(e))return 0===e.length?-1:b(t,e,r,n,a);if(\"number\"==typeof e)return e&=255,\"function\"==typeof Uint8Array.prototype.indexOf?a?Uint8Array.prototype.indexOf.call(t,e,r):Uint8Array.prototype.lastIndexOf.call(t,e,r):b(t,[e],r,n,a);throw new TypeError(\"val must be string, number or Buffer\")}function b(t,e,r,n,i){function a(t,e){return 1===o?t[e]:t.readUInt16BE(e*o)}var o=1,s=t.length,l=e.length;if(void 0!==n&&(\"ucs2\"===(n=String(n).toLowerCase())||\"ucs-2\"===n||\"utf16le\"===n||\"utf-16le\"===n)){if(t.length<2||e.length<2)return-1;o=2,s/=2,l/=2,r/=2}var u;if(i){var c=-1;for(u=r;u<s;u++)if(a(t,u)===a(e,-1===c?0:u-c)){if(-1===c&&(c=u),u-c+1===l)return c*o}else-1!==c&&(u-=u-c),c=-1}else for(r+l>s&&(r=s-l),u=r;u>=0;u--){for(var h=!0,f=0;f<l;f++)if(a(t,u+f)!==a(e,f)){h=!1;break}if(h)return u}return-1}function x(t,e,r,n){r=Number(r)||0;var i=t.length-r;n?(n=Number(n))>i&&(n=i):n=i;var a=e.length;if(a%2!=0)throw new TypeError(\"Invalid hex string\");n>a/2&&(n=a/2);for(var o=0;o<n;++o){var s=parseInt(e.substr(2*o,2),16);if(Y(s))return o;t[r+o]=s}return o}function _(t,e,r,n){return q(B(e,t.length-r),t,r,n)}function w(t,e,r,n){return q(U(e),t,r,n)}function M(t,e,r,n){return w(t,e,r,n)}function k(t,e,r,n){return q(H(e),t,r,n)}function A(t,e,r,n){return q(V(e,t.length-r),t,r,n)}function T(t,e,r){return 0===e&&r===t.length?X.fromByteArray(t):X.fromByteArray(t.slice(e,r))}function S(t,e,r){r=Math.min(t.length,r);for(var n=[],i=e;i<r;){var a=t[i],o=null,s=a>239?4:a>223?3:a>191?2:1;if(i+s<=r){var l,u,c,h;switch(s){case 1:a<128&&(o=a);break;case 2:l=t[i+1],128==(192&l)&&(h=(31&a)<<6|63&l)>127&&(o=h);break;case 3:l=t[i+1],u=t[i+2],128==(192&l)&&128==(192&u)&&(h=(15&a)<<12|(63&l)<<6|63&u)>2047&&(h<55296||h>57343)&&(o=h);break;case 4:l=t[i+1],u=t[i+2],c=t[i+3],128==(192&l)&&128==(192&u)&&128==(192&c)&&(h=(15&a)<<18|(63&l)<<12|(63&u)<<6|63&c)>65535&&h<1114112&&(o=h)}}null===o?(o=65533,s=1):o>65535&&(o-=65536,n.push(o>>>10&1023|55296),o=56320|1023&o),n.push(o),i+=s}return E(n)}function E(t){var e=t.length;if(e<=J)return String.fromCharCode.apply(String,t);for(var r=\"\",n=0;n<e;)r+=String.fromCharCode.apply(String,t.slice(n,n+=J));return r}function L(t,e,r){var n=\"\";r=Math.min(t.length,r);for(var i=e;i<r;++i)n+=String.fromCharCode(127&t[i]);return n}function C(t,e,r){var n=\"\";r=Math.min(t.length,r);for(var i=e;i<r;++i)n+=String.fromCharCode(t[i]);return n}function z(t,e,r){var n=t.length;(!e||e<0)&&(e=0),(!r||r<0||r>n)&&(r=n);for(var i=\"\",a=e;a<r;++a)i+=N(t[a]);return i}function I(t,e,r){for(var n=t.slice(e,r),i=\"\",a=0;a<n.length;a+=2)i+=String.fromCharCode(n[a]+256*n[a+1]);return i}function D(t,e,r){if(t%1!=0||t<0)throw new RangeError(\"offset is not uint\");if(t+e>r)throw new RangeError(\"Trying to access beyond buffer length\")}function P(t,e,r,n,a,o){if(!i.isBuffer(t))throw new TypeError('\"buffer\" argument must be a Buffer instance');if(e>a||e<o)throw new RangeError('\"value\" argument is out of bounds');if(r+n>t.length)throw new RangeError(\"Index out of range\")}function O(t,e,r,n,i,a){if(r+n>t.length)throw new RangeError(\"Index out of range\");if(r<0)throw new RangeError(\"Index out of range\")}function R(t,e,r,n,i){return e=+e,r>>>=0,i||O(t,e,r,4,3.4028234663852886e38,-3.4028234663852886e38),W.write(t,e,r,n,23,4),r+4}function F(t,e,r,n,i){return e=+e,r>>>=0,i||O(t,e,r,8,1.7976931348623157e308,-1.7976931348623157e308),W.write(t,e,r,n,52,8),r+8}function j(t){if(t=t.trim().replace(K,\"\"),t.length<2)return\"\";for(;t.length%4!=0;)t+=\"=\";return t}function N(t){return t<16?\"0\"+t.toString(16):t.toString(16)}function B(t,e){e=e||1/0;for(var r,n=t.length,i=null,a=[],o=0;o<n;++o){if((r=t.charCodeAt(o))>55295&&r<57344){if(!i){if(r>56319){(e-=3)>-1&&a.push(239,191,189);continue}if(o+1===n){(e-=3)>-1&&a.push(239,191,189);continue}i=r;continue}if(r<56320){(e-=3)>-1&&a.push(239,191,189),i=r;continue}r=65536+(i-55296<<10|r-56320)}else i&&(e-=3)>-1&&a.push(239,191,189);if(i=null,r<128){if((e-=1)<0)break;a.push(r)}else if(r<2048){if((e-=2)<0)break;a.push(r>>6|192,63&r|128)}else if(r<65536){if((e-=3)<0)break;a.push(r>>12|224,r>>6&63|128,63&r|128)}else{if(!(r<1114112))throw new Error(\"Invalid code point\");if((e-=4)<0)break;a.push(r>>18|240,r>>12&63|128,r>>6&63|128,63&r|128)}}return a}function U(t){for(var e=[],r=0;r<t.length;++r)e.push(255&t.charCodeAt(r));return e}function V(t,e){for(var r,n,i,a=[],o=0;o<t.length&&!((e-=2)<0);++o)r=t.charCodeAt(o),n=r>>8,i=r%256,a.push(i),a.push(n);return a}function H(t){return X.toByteArray(j(t))}function q(t,e,r,n){for(var i=0;i<n&&!(i+r>=e.length||i>=t.length);++i)e[i+r]=t[i];return i}function G(t){return\"function\"==typeof ArrayBuffer.isView&&ArrayBuffer.isView(t)}function Y(t){return t!==t}var X=t(\"base64-js\"),W=t(\"ieee754\");r.Buffer=i,r.SlowBuffer=p,r.INSPECT_MAX_BYTES=50;var Z=2147483647;r.kMaxLength=Z,i.TYPED_ARRAY_SUPPORT=function(){try{var t=new Uint8Array(1);return t.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===t.foo()}catch(t){return!1}}(),i.TYPED_ARRAY_SUPPORT||\"undefined\"==typeof console||\"function\"!=typeof console.error||console.error(\"This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support.\"),\"undefined\"!=typeof Symbol&&Symbol.species&&i[Symbol.species]===i&&Object.defineProperty(i,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}),i.poolSize=8192,i.from=function(t,e,r){return a(t,e,r)},i.prototype.__proto__=Uint8Array.prototype,i.__proto__=Uint8Array,i.alloc=function(t,e,r){return s(t,e,r)},i.allocUnsafe=function(t){return l(t)},i.allocUnsafeSlow=function(t){return l(t)},i.isBuffer=function(t){return null!=t&&!0===t._isBuffer},i.compare=function(t,e){if(!i.isBuffer(t)||!i.isBuffer(e))throw new TypeError(\"Arguments must be Buffers\");if(t===e)return 0;for(var r=t.length,n=e.length,a=0,o=Math.min(r,n);a<o;++a)if(t[a]!==e[a]){r=t[a],n=e[a];break}return r<n?-1:n<r?1:0},i.isEncoding=function(t){switch(String(t).toLowerCase()){case\"hex\":case\"utf8\":case\"utf-8\":case\"ascii\":case\"latin1\":case\"binary\":case\"base64\":case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return!0;default:return!1}},i.concat=function(t,e){if(!Array.isArray(t))throw new TypeError('\"list\" argument must be an Array of Buffers');if(0===t.length)return i.alloc(0);var r;if(void 0===e)for(e=0,r=0;r<t.length;++r)e+=t[r].length;var n=i.allocUnsafe(e),a=0;for(r=0;r<t.length;++r){var o=t[r];if(!i.isBuffer(o))throw new TypeError('\"list\" argument must be an Array of Buffers');o.copy(n,a),a+=o.length}return n},i.byteLength=m,i.prototype._isBuffer=!0,i.prototype.swap16=function(){var t=this.length;if(t%2!=0)throw new RangeError(\"Buffer size must be a multiple of 16-bits\");for(var e=0;e<t;e+=2)g(this,e,e+1);return this},i.prototype.swap32=function(){var t=this.length;if(t%4!=0)throw new RangeError(\"Buffer size must be a multiple of 32-bits\");for(var e=0;e<t;e+=4)g(this,e,e+3),g(this,e+1,e+2);return this},i.prototype.swap64=function(){var t=this.length;if(t%8!=0)throw new RangeError(\"Buffer size must be a multiple of 64-bits\");for(var e=0;e<t;e+=8)g(this,e,e+7),g(this,e+1,e+6),g(this,e+2,e+5),g(this,e+3,e+4);return this},i.prototype.toString=function(){var t=this.length;return 0===t?\"\":0===arguments.length?S(this,0,t):v.apply(this,arguments)},i.prototype.equals=function(t){if(!i.isBuffer(t))throw new TypeError(\"Argument must be a Buffer\");return this===t||0===i.compare(this,t)},i.prototype.inspect=function(){var t=\"\",e=r.INSPECT_MAX_BYTES;return this.length>0&&(t=this.toString(\"hex\",0,e).match(/.{2}/g).join(\" \"),this.length>e&&(t+=\" ... \")),\"<Buffer \"+t+\">\"},i.prototype.compare=function(t,e,r,n,a){if(!i.isBuffer(t))throw new TypeError(\"Argument must be a Buffer\");if(void 0===e&&(e=0),void 0===r&&(r=t?t.length:0),void 0===n&&(n=0),void 0===a&&(a=this.length),e<0||r>t.length||n<0||a>this.length)throw new RangeError(\"out of range index\");if(n>=a&&e>=r)return 0;if(n>=a)return-1;if(e>=r)return 1;if(e>>>=0,r>>>=0,n>>>=0,a>>>=0,this===t)return 0;for(var o=a-n,s=r-e,l=Math.min(o,s),u=this.slice(n,a),c=t.slice(e,r),h=0;h<l;++h)if(u[h]!==c[h]){o=u[h],s=c[h];break}return o<s?-1:s<o?1:0},i.prototype.includes=function(t,e,r){return-1!==this.indexOf(t,e,r)},i.prototype.indexOf=function(t,e,r){return y(this,t,e,r,!0)},i.prototype.lastIndexOf=function(t,e,r){return y(this,t,e,r,!1)},i.prototype.write=function(t,e,r,n){if(void 0===e)n=\"utf8\",r=this.length,e=0;else if(void 0===r&&\"string\"==typeof e)n=e,r=this.length,e=0;else{if(!isFinite(e))throw new Error(\"Buffer.write(string, encoding, offset[, length]) is no longer supported\");e>>>=0,isFinite(r)?(r>>>=0,void 0===n&&(n=\"utf8\")):(n=r,r=void 0)}var i=this.length-e;if((void 0===r||r>i)&&(r=i),t.length>0&&(r<0||e<0)||e>this.length)throw new RangeError(\"Attempt to write outside buffer bounds\");n||(n=\"utf8\");for(var a=!1;;)switch(n){case\"hex\":return x(this,t,e,r);case\"utf8\":case\"utf-8\":return _(this,t,e,r);case\"ascii\":return w(this,t,e,r);case\"latin1\":case\"binary\":return M(this,t,e,r);case\"base64\":return k(this,t,e,r);case\"ucs2\":case\"ucs-2\":case\"utf16le\":case\"utf-16le\":return A(this,t,e,r);default:if(a)throw new TypeError(\"Unknown encoding: \"+n);n=(\"\"+n).toLowerCase(),a=!0}},i.prototype.toJSON=function(){return{type:\"Buffer\",data:Array.prototype.slice.call(this._arr||this,0)}};var J=4096;i.prototype.slice=function(t,e){var r=this.length;t=~~t,e=void 0===e?r:~~e,t<0?(t+=r)<0&&(t=0):t>r&&(t=r),e<0?(e+=r)<0&&(e=0):e>r&&(e=r),e<t&&(e=t);var n=this.subarray(t,e);return n.__proto__=i.prototype,n},i.prototype.readUIntLE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t],i=1,a=0;++a<e&&(i*=256);)n+=this[t+a]*i;return n},i.prototype.readUIntBE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t+--e],i=1;e>0&&(i*=256);)n+=this[t+--e]*i;return n},i.prototype.readUInt8=function(t,e){return t>>>=0,e||D(t,1,this.length),this[t]},i.prototype.readUInt16LE=function(t,e){return t>>>=0,e||D(t,2,this.length),this[t]|this[t+1]<<8},i.prototype.readUInt16BE=function(t,e){return t>>>=0,e||D(t,2,this.length),this[t]<<8|this[t+1]},i.prototype.readUInt32LE=function(t,e){return t>>>=0,e||D(t,4,this.length),(this[t]|this[t+1]<<8|this[t+2]<<16)+16777216*this[t+3]},i.prototype.readUInt32BE=function(t,e){return t>>>=0,e||D(t,4,this.length),16777216*this[t]+(this[t+1]<<16|this[t+2]<<8|this[t+3])},i.prototype.readIntLE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=this[t],i=1,a=0;++a<e&&(i*=256);)n+=this[t+a]*i;return i*=128,n>=i&&(n-=Math.pow(2,8*e)),n},i.prototype.readIntBE=function(t,e,r){t>>>=0,e>>>=0,r||D(t,e,this.length);for(var n=e,i=1,a=this[t+--n];n>0&&(i*=256);)a+=this[t+--n]*i;return i*=128,a>=i&&(a-=Math.pow(2,8*e)),a},i.prototype.readInt8=function(t,e){return t>>>=0,e||D(t,1,this.length),128&this[t]?-1*(255-this[t]+1):this[t]},i.prototype.readInt16LE=function(t,e){t>>>=0,e||D(t,2,this.length);var r=this[t]|this[t+1]<<8;return 32768&r?4294901760|r:r},i.prototype.readInt16BE=function(t,e){t>>>=0,e||D(t,2,this.length);var r=this[t+1]|this[t]<<8;return 32768&r?4294901760|r:r},i.prototype.readInt32LE=function(t,e){return t>>>=0,e||D(t,4,this.length),this[t]|this[t+1]<<8|this[t+2]<<16|this[t+3]<<24},i.prototype.readInt32BE=function(t,e){return t>>>=0,e||D(t,4,this.length),this[t]<<24|this[t+1]<<16|this[t+2]<<8|this[t+3]},i.prototype.readFloatLE=function(t,e){return t>>>=0,e||D(t,4,this.length),W.read(this,t,!0,23,4)},i.prototype.readFloatBE=function(t,e){return t>>>=0,e||D(t,4,this.length),W.read(this,t,!1,23,4)},i.prototype.readDoubleLE=function(t,e){return t>>>=0,e||D(t,8,this.length),W.read(this,t,!0,52,8)},i.prototype.readDoubleBE=function(t,e){return t>>>=0,e||D(t,8,this.length),W.read(this,t,!1,52,8)},i.prototype.writeUIntLE=function(t,e,r,n){if(t=+t,e>>>=0,r>>>=0,!n){P(this,t,e,r,Math.pow(2,8*r)-1,0)}var i=1,a=0;for(this[e]=255&t;++a<r&&(i*=256);)this[e+a]=t/i&255;return e+r},i.prototype.writeUIntBE=function(t,e,r,n){if(t=+t,e>>>=0,r>>>=0,!n){P(this,t,e,r,Math.pow(2,8*r)-1,0)}var i=r-1,a=1;for(this[e+i]=255&t;--i>=0&&(a*=256);)this[e+i]=t/a&255;return e+r},i.prototype.writeUInt8=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,1,255,0),this[e]=255&t,e+1},i.prototype.writeUInt16LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,65535,0),this[e]=255&t,this[e+1]=t>>>8,e+2},i.prototype.writeUInt16BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,65535,0),this[e]=t>>>8,this[e+1]=255&t,e+2},i.prototype.writeUInt32LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,4294967295,0),this[e+3]=t>>>24,this[e+2]=t>>>16,this[e+1]=t>>>8,this[e]=255&t,e+4},i.prototype.writeUInt32BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,4294967295,0),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},i.prototype.writeIntLE=function(t,e,r,n){if(t=+t,e>>>=0,!n){var i=Math.pow(2,8*r-1);P(this,t,e,r,i-1,-i)}var a=0,o=1,s=0;for(this[e]=255&t;++a<r&&(o*=256);)t<0&&0===s&&0!==this[e+a-1]&&(s=1),this[e+a]=(t/o>>0)-s&255;return e+r},i.prototype.writeIntBE=function(t,e,r,n){if(t=+t,e>>>=0,!n){var i=Math.pow(2,8*r-1);P(this,t,e,r,i-1,-i)}var a=r-1,o=1,s=0;for(this[e+a]=255&t;--a>=0&&(o*=256);)t<0&&0===s&&0!==this[e+a+1]&&(s=1),this[e+a]=(t/o>>0)-s&255;return e+r},i.prototype.writeInt8=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,1,127,-128),t<0&&(t=255+t+1),this[e]=255&t,e+1},i.prototype.writeInt16LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,32767,-32768),this[e]=255&t,this[e+1]=t>>>8,e+2},i.prototype.writeInt16BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,2,32767,-32768),this[e]=t>>>8,this[e+1]=255&t,e+2},i.prototype.writeInt32LE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,2147483647,-2147483648),this[e]=255&t,this[e+1]=t>>>8,this[e+2]=t>>>16,this[e+3]=t>>>24,e+4},i.prototype.writeInt32BE=function(t,e,r){return t=+t,e>>>=0,r||P(this,t,e,4,2147483647,-2147483648),t<0&&(t=4294967295+t+1),this[e]=t>>>24,this[e+1]=t>>>16,this[e+2]=t>>>8,this[e+3]=255&t,e+4},i.prototype.writeFloatLE=function(t,e,r){return R(this,t,e,!0,r)},i.prototype.writeFloatBE=function(t,e,r){return R(this,t,e,!1,r)},i.prototype.writeDoubleLE=function(t,e,r){return F(this,t,e,!0,r)},i.prototype.writeDoubleBE=function(t,e,r){return F(this,t,e,!1,r)},i.prototype.copy=function(t,e,r,n){if(r||(r=0),n||0===n||(n=this.length),e>=t.length&&(e=t.length),e||(e=0),n>0&&n<r&&(n=r),n===r)return 0;if(0===t.length||0===this.length)return 0;if(e<0)throw new RangeError(\"targetStart out of bounds\");if(r<0||r>=this.length)throw new RangeError(\"sourceStart out of bounds\");if(n<0)throw new RangeError(\"sourceEnd out of bounds\");n>this.length&&(n=this.length),t.length-e<n-r&&(n=t.length-e+r);var i,a=n-r;if(this===t&&r<e&&e<n)for(i=a-1;i>=0;--i)t[i+e]=this[i+r];else if(a<1e3)for(i=0;i<a;++i)t[i+e]=this[i+r];else Uint8Array.prototype.set.call(t,this.subarray(r,r+a),e);return a},i.prototype.fill=function(t,e,r,n){if(\"string\"==typeof t){if(\"string\"==typeof e?(n=e,e=0,r=this.length):\"string\"==typeof r&&(n=r,r=this.length),1===t.length){var a=t.charCodeAt(0);a<256&&(t=a)}if(void 0!==n&&\"string\"!=typeof n)throw new TypeError(\"encoding must be a string\");if(\"string\"==typeof n&&!i.isEncoding(n))throw new TypeError(\"Unknown encoding: \"+n)}else\"number\"==typeof t&&(t&=255);if(e<0||this.length<e||this.length<r)throw new RangeError(\"Out of range index\");if(r<=e)return this;e>>>=0,r=void 0===r?this.length:r>>>0,t||(t=0);var o;if(\"number\"==typeof t)for(o=e;o<r;++o)this[o]=t;else{var s=i.isBuffer(t)?t:new i(t,n),l=s.length;for(o=0;o<r-e;++o)this[o+e]=s[o%l]}return this};var K=/[^+\\/0-9A-Za-z-_]/g},{\"base64-js\":77,ieee754:288}],77:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e%4>0)throw new Error(\"Invalid string. Length must be a multiple of 4\");return\"=\"===t[e-2]?2:\"=\"===t[e-1]?1:0}function i(t){return 3*t.length/4-n(t)}function a(t){var e,r,i,a,o,s,l=t.length;o=n(t),s=new h(3*l/4-o),i=o>0?l-4:l;var u=0;for(e=0,r=0;e<i;e+=4,r+=3)a=c[t.charCodeAt(e)]<<18|c[t.charCodeAt(e+1)]<<12|c[t.charCodeAt(e+2)]<<6|c[t.charCodeAt(e+3)],s[u++]=a>>16&255,s[u++]=a>>8&255,s[u++]=255&a;return 2===o?(a=c[t.charCodeAt(e)]<<2|c[t.charCodeAt(e+1)]>>4,s[u++]=255&a):1===o&&(a=c[t.charCodeAt(e)]<<10|c[t.charCodeAt(e+1)]<<4|c[t.charCodeAt(e+2)]>>2,s[u++]=a>>8&255,s[u++]=255&a),s}function o(t){return u[t>>18&63]+u[t>>12&63]+u[t>>6&63]+u[63&t]}function s(t,e,r){for(var n,i=[],a=e;a<r;a+=3)n=(t[a]<<16)+(t[a+1]<<8)+t[a+2],i.push(o(n));return i.join(\"\")}function l(t){for(var e,r=t.length,n=r%3,i=\"\",a=[],o=0,l=r-n;o<l;o+=16383)a.push(s(t,o,o+16383>l?l:o+16383));return 1===n?(e=t[r-1],i+=u[e>>2],i+=u[e<<4&63],i+=\"==\"):2===n&&(e=(t[r-2]<<8)+t[r-1],i+=u[e>>10],i+=u[e>>4&63],i+=u[e<<2&63],i+=\"=\"),a.push(i),a.join(\"\")}r.byteLength=i,r.toByteArray=a,r.fromByteArray=l;for(var u=[],c=[],h=\"undefined\"!=typeof Uint8Array?Uint8Array:Array,f=\"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/\",d=0,p=f.length;d<p;++d)u[d]=f[d],c[f.charCodeAt(d)]=d;c[\"-\".charCodeAt(0)]=62,c[\"_\".charCodeAt(0)]=63},{}],78:[function(t,e,r){\"use strict\";function n(t){return[Math.min(t[0],t[1]),Math.max(t[0],t[1])]}function i(t,e){return t[0]-e[0]||t[1]-e[1]}function a(t){return t.map(n).sort(i)}function o(t,e,r){return e in t?t[e]:r}function s(t,e,r){Array.isArray(e)?(r=r||{},e=e||[]):(r=e||{},e=[]);var n=!!o(r,\"delaunay\",!0),i=!!o(r,\"interior\",!0),s=!!o(r,\"exterior\",!0),f=!!o(r,\"infinity\",!1);if(!i&&!s||0===t.length)return[];var d=l(t,e);if(n||i!==s||f){for(var p=u(t.length,a(e)),m=0;m<d.length;++m){var v=d[m];p.addTriangle(v[0],v[1],v[2])}return n&&c(t,p),s?i?f?h(p,0,f):p.cells():h(p,1,f):h(p,-1)}return d}var l=t(\"./lib/monotone\"),u=t(\"./lib/triangulation\"),c=t(\"./lib/delaunay\"),h=t(\"./lib/filter\");e.exports=s},{\"./lib/delaunay\":79,\"./lib/filter\":80,\"./lib/monotone\":81,\"./lib/triangulation\":82}],79:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,o){var s=e.opposite(n,i);if(!(s<0)){if(i<n){var l=n;n=i,i=l,l=o,o=s,s=l}e.isConstraint(n,i)||a(t[n],t[i],t[o],t[s])<0&&r.push(n,i)}}function i(t,e){for(var r=[],i=t.length,o=e.stars,s=0;s<i;++s)for(var l=o[s],u=1;u<l.length;u+=2){var c=l[u];if(!(c<s)&&!e.isConstraint(s,c)){for(var h=l[u-1],f=-1,d=1;d<l.length;d+=2)if(l[d-1]===c){f=l[d];break}f<0||a(t[s],t[c],t[h],t[f])<0&&r.push(s,c)}}for(;r.length>0;){for(var c=r.pop(),s=r.pop(),h=-1,f=-1,l=o[s],p=1;p<l.length;p+=2){var m=l[p-1],v=l[p];m===c?f=v:v===c&&(h=m)}h<0||f<0||(a(t[s],t[c],t[h],t[f])>=0||(e.flip(s,c),n(t,e,r,h,s,f),n(t,e,r,s,f,h),n(t,e,r,f,c,h),n(t,e,r,c,h,f)))}}var a=t(\"robust-in-sphere\")[4];t(\"binary-search-bounds\");e.exports=i},{\"binary-search-bounds\":83,\"robust-in-sphere\":505}],80:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.cells=t,this.neighbor=e,this.flags=n,this.constraint=r,this.active=i,this.next=a,this.boundary=o}function i(t,e){return t[0]-e[0]||t[1]-e[1]||t[2]-e[2]}function a(t,e){for(var r=t.cells(),a=r.length,o=0;o<a;++o){var s=r[o],l=s[0],u=s[1],c=s[2];u<c?u<l&&(s[0]=u,s[1]=c,s[2]=l):c<l&&(s[0]=c,s[1]=l,s[2]=u)}r.sort(i);for(var h=new Array(a),o=0;o<h.length;++o)h[o]=0;var f=[],d=[],p=new Array(3*a),m=new Array(3*a),v=null;e&&(v=[]);for(var g=new n(r,p,m,h,f,d,v),o=0;o<a;++o)for(var s=r[o],y=0;y<3;++y){var l=s[y],u=s[(y+1)%3],b=p[3*o+y]=g.locate(u,l,t.opposite(u,l)),x=m[3*o+y]=t.isConstraint(l,u);b<0&&(x?d.push(o):(f.push(o),h[o]=1),e&&v.push([u,l,-1]))}return g}function o(t,e,r){for(var n=0,i=0;i<t.length;++i)e[i]===r&&(t[n++]=t[i]);return t.length=n,t}function s(t,e,r){var n=a(t,r);if(0===e)return r?n.cells.concat(n.boundary):n.cells;for(var i=1,s=n.active,l=n.next,u=n.flags,c=n.cells,h=n.constraint,f=n.neighbor;s.length>0||l.length>0;){for(;s.length>0;){var d=s.pop();if(u[d]!==-i){u[d]=i;for(var p=(c[d],0);p<3;++p){var m=f[3*d+p];m>=0&&0===u[m]&&(h[3*d+p]?l.push(m):(s.push(m),u[m]=i))}}}var v=l;l=s,s=v,l.length=0,i=-i}var g=o(c,u,e);return r?g.concat(n.boundary):g}var l=t(\"binary-search-bounds\");e.exports=s,n.prototype.locate=function(){var t=[0,0,0];return function(e,r,n){var a=e,o=r,s=n;return r<n?r<e&&(a=r,o=n,s=e):n<e&&(a=n,o=e,s=r),a<0?-1:(t[0]=a,t[1]=o,t[2]=s,l.eq(this.cells,t,i))}}()},{\"binary-search-bounds\":83}],81:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.a=t,this.b=e,this.idx=r,this.lowerIds=n,this.upperIds=i}function i(t,e,r,n){this.a=t,this.b=e,this.type=r,this.idx=n}function a(t,e){var r=t.a[0]-e.a[0]||t.a[1]-e.a[1]||t.type-e.type;return r||(t.type!==p&&(r=d(t.a,t.b,e.b))?r:t.idx-e.idx)}function o(t,e){return d(t.a,t.b,e)}function s(t,e,r,n,i){for(var a=f.lt(e,n,o),s=f.gt(e,n,o),l=a;l<s;++l){for(var u=e[l],c=u.lowerIds,h=c.length;h>1&&d(r[c[h-2]],r[c[h-1]],n)>0;)t.push([c[h-1],c[h-2],i]),h-=1;c.length=h,c.push(i);for(var p=u.upperIds,h=p.length;h>1&&d(r[p[h-2]],r[p[h-1]],n)<0;)t.push([p[h-2],p[h-1],i]),h-=1;p.length=h,p.push(i)}}function l(t,e){var r;return(r=t.a[0]<e.a[0]?d(t.a,t.b,e.a):d(e.b,e.a,t.a))?r:(r=e.b[0]<t.b[0]?d(t.a,t.b,e.b):d(e.b,e.a,t.b))||t.idx-e.idx}function u(t,e,r){var i=f.le(t,r,l),a=t[i],o=a.upperIds,s=o[o.length-1];a.upperIds=[s],t.splice(i+1,0,new n(r.a,r.b,r.idx,[s],o))}function c(t,e,r){var n=r.a;r.a=r.b,r.b=n;var i=f.eq(t,r,l),a=t[i];t[i-1].upperIds=a.upperIds,t.splice(i,1)}function h(t,e){for(var r=t.length,o=e.length,l=[],h=0;h<r;++h)l.push(new i(t[h],null,p,h));for(var h=0;h<o;++h){var f=e[h],d=t[f[0]],g=t[f[1]];d[0]<g[0]?l.push(new i(d,g,v,h),new i(g,d,m,h)):d[0]>g[0]&&l.push(new i(g,d,v,h),new i(d,g,m,h))}l.sort(a);for(var y=l[0].a[0]-(1+Math.abs(l[0].a[0]))*Math.pow(2,-52),b=[new n([y,1],[y,0],-1,[],[],[],[])],x=[],h=0,_=l.length;h<_;++h){var w=l[h],M=w.type;M===p?s(x,b,t,w.a,w.idx):M===v?u(b,t,w):c(b,t,w)}return x}var f=t(\"binary-search-bounds\"),d=t(\"robust-orientation\")[3],p=0,m=1,v=2;e.exports=h},{\"binary-search-bounds\":83,\"robust-orientation\":507}],82:[function(t,e,r){\"use strict\";function n(t,e){this.stars=t,this.edges=e}function i(t,e,r){for(var n=1,i=t.length;n<i;n+=2)if(t[n-1]===e&&t[n]===r)return t[n-1]=t[i-2],t[n]=t[i-1],void(t.length=i-2)}function a(t,e){for(var r=new Array(t),i=0;i<t;++i)r[i]=[];return new n(r,e)}var o=t(\"binary-search-bounds\");e.exports=a;var s=n.prototype;s.isConstraint=function(){function t(t,e){return t[0]-e[0]||t[1]-e[1]}var e=[0,0];return function(r,n){return e[0]=Math.min(r,n),e[1]=Math.max(r,n),o.eq(this.edges,e,t)>=0}}(),s.removeTriangle=function(t,e,r){var n=this.stars;i(n[t],e,r),i(n[e],r,t),i(n[r],t,e)},s.addTriangle=function(t,e,r){var n=this.stars;n[t].push(e,r),n[e].push(r,t),n[r].push(t,e)},s.opposite=function(t,e){for(var r=this.stars[e],n=1,i=r.length;n<i;n+=2)if(r[n]===t)return r[n-1];return-1},s.flip=function(t,e){var r=this.opposite(t,e),n=this.opposite(e,t);this.removeTriangle(t,e,r),this.removeTriangle(e,t,n),this.addTriangle(t,n,r),this.addTriangle(e,r,n)},s.edges=function(){for(var t=this.stars,e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;a+=2)e.push([i[a],i[a+1]]);return e},s.cells=function(){for(var t=this.stars,e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;a+=2){var s=i[a],l=i[a+1];r<Math.min(s,l)&&e.push([r,s,l])}return e}},{\"binary-search-bounds\":83}],83:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=[\"function \",t,\"(a,l,h,\",n.join(\",\"),\"){\",i?\"\":\"var i=\",r?\"l-1\":\"h+1\",\";while(l<=h){var m=(l+h)>>>1,x=a[m]\"];return i?e.indexOf(\"c\")<0?a.push(\";if(x===y){return m}else if(x<=y){\"):a.push(\";var p=c(x,y);if(p===0){return m}else if(p<=0){\"):a.push(\";if(\",e,\"){i=m;\"),r?a.push(\"l=m+1}else{h=m-1}\"):a.push(\"h=m-1}else{l=m+1}\"),a.push(\"}\"),i?a.push(\"return -1};\"):a.push(\"return i};\"),a.join(\"\")}function i(t,e,r,i){return new Function([n(\"A\",\"x\"+t+\"y\",e,[\"y\"],i),n(\"P\",\"c(x,y)\"+t+\"0\",e,[\"y\",\"c\"],i),\"function dispatchBsearch\",r,\"(a,y,c,l,h){if(typeof(c)==='function'){return P(a,(l===void 0)?0:l|0,(h===void 0)?a.length-1:h|0,y,c)}else{return A(a,(c===void 0)?0:c|0,(l===void 0)?a.length-1:l|0,y)}}return dispatchBsearch\",r].join(\"\"))()}e.exports={ge:i(\">=\",!1,\"GE\"),gt:i(\">\",!1,\"GT\"),lt:i(\"<\",!0,\"LT\"),le:i(\"<=\",!0,\"LE\"),eq:i(\"-\",!0,\"EQ\",!0)}},{}],84:[function(t,e,r){\"use strict\";function n(t){for(var e=1,r=1;r<t.length;++r)for(var n=0;n<r;++n)if(t[r]<t[n])e=-e;else if(t[n]===t[r])return 0;return e}e.exports=n},{}],85:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0,n=t.length,i=0;i<n;++i)r+=t[i]*e[i];return r}function i(t){var e=t.length;if(0===e)return[];var r=(t[0].length,o([t.length+1,t.length+1],1)),i=o([t.length+1],1);r[e][e]=0;for(var a=0;a<e;++a){for(var l=0;l<=a;++l)r[l][a]=r[a][l]=2*n(t[a],t[l]);i[a]=n(t[a],t[a])}for(var u=s(r,i),c=0,h=u[e+1],a=0;a<h.length;++a)c+=h[a];for(var f=new Array(e),a=0;a<e;++a){for(var h=u[a],d=0,l=0;l<h.length;++l)d+=h[l];f[a]=d/c}return f}function a(t){if(0===t.length)return[];for(var e=t[0].length,r=o([e]),n=i(t),a=0;a<t.length;++a)for(var s=0;s<e;++s)r[s]+=t[a][s]*n[a];return r}var o=t(\"dup\"),s=t(\"robust-linear-solve\");a.barycenetric=i,e.exports=a},{dup:124,\"robust-linear-solve\":506}],86:[function(t,e,r){function n(t){for(var e=i(t),r=0,n=0;n<t.length;++n)for(var a=t[n],o=0;o<e.length;++o)r+=Math.pow(a[o]-e[o],2);return Math.sqrt(r/t.length)}e.exports=n;var i=t(\"circumcenter\")},{circumcenter:85}],87:[function(t,e,r){function n(t,e,r){return e<r?t<e?e:t>r?r:t:t<r?r:t>e?e:t}e.exports=n},{}],88:[function(t,e,r){\"use strict\";function n(t){var e=_(t);return[M(e,-1/0),M(e,1/0)]}function i(t,e){for(var r=new Array(e.length),n=0;n<e.length;++n){var i=e[n],a=t[i[0]],o=t[i[1]];r[n]=[M(Math.min(a[0],o[0]),-1/0),M(Math.min(a[1],o[1]),-1/0),M(Math.max(a[0],o[0]),1/0),M(Math.max(a[1],o[1]),1/0)]}return r}function a(t){for(var e=new Array(t.length),r=0;r<t.length;++r){var n=t[r];e[r]=[M(n[0],-1/0),M(n[1],-1/0),M(n[0],1/0),M(n[1],1/0)]}return e}function o(t,e,r){var n=[];return g(r,function(r,i){var a=e[r],o=e[i];if(a[0]!==o[0]&&a[0]!==o[1]&&a[1]!==o[0]&&a[1]!==o[1]){var s=t[a[0]],l=t[a[1]],u=t[o[0]],c=t[o[1]];y(s,l,u,c)&&n.push([r,i])}}),n}function s(t,e,r,n){var i=[];return g(r,n,function(r,n){var a=e[r];if(a[0]!==n&&a[1]!==n){var o=t[n],s=t[a[0]],l=t[a[1]];y(s,l,o,o)&&i.push([r,n])}}),i}function l(t,e,r,n,i){var a,o,s=t.map(function(t){return[b(t[0]),b(t[1])]});for(a=0;a<r.length;++a){var l=r[a];o=l[0];var u=l[1],c=e[o],h=e[u],f=k(w(t[c[0]]),w(t[c[1]]),w(t[h[0]]),w(t[h[1]]));if(f){var d=t.length;t.push([_(f[0]),_(f[1])]),s.push(f),n.push([o,d],[u,d])}}for(n.sort(function(t,e){if(t[0]!==e[0])return t[0]-e[0];var r=s[t[1]],n=s[e[1]];return x(r[0],n[0])||x(r[1],n[1])}),a=n.length-1;a>=0;--a){var p=n[a];o=p[0];var m=e[o],v=m[0],g=m[1],y=t[v],M=t[g];if((y[0]-M[0]||y[1]-M[1])<0){var A=v;v=g,g=A}m[0]=v;var T,S=m[1]=p[1];for(i&&(T=m[2]);a>0&&n[a-1][0]===o;){var p=n[--a],E=p[1];i?e.push([S,E,T]):e.push([S,E]),S=E}i?e.push([S,g,T]):e.push([S,g])}return s}function u(t,e,r){for(var i=e.length,a=new v(i),o=[],s=0;s<e.length;++s){var l=e[s],u=n(l[0]),c=n(l[1]);o.push([M(u[0],-1/0),M(c[0],-1/0),M(u[1],1/0),M(c[1],1/0)])}g(o,function(t,e){a.link(t,e)});for(var h=!0,f=new Array(i),s=0;s<i;++s){var d=a.find(s);d!==s&&(h=!1,t[d]=[Math.min(t[s][0],t[d][0]),Math.min(t[s][1],t[d][1])])}if(h)return null;for(var p=0,s=0;s<i;++s){var d=a.find(s);d===s?(f[s]=p,t[p++]=t[s]):f[s]=-1}t.length=p;for(var s=0;s<i;++s)f[s]<0&&(f[s]=f[a.find(s)]);return f}function c(t,e){return t[0]-e[0]||t[1]-e[1]}function h(t,e){var r=t[0]-e[0]||t[1]-e[1];return r||(t[2]<e[2]?-1:t[2]>e[2]?1:0)}function f(t,e,r){if(0!==t.length){if(e)for(var n=0;n<t.length;++n){var i=t[n],a=e[i[0]],o=e[i[1]]\n",
       ";i[0]=Math.min(a,o),i[1]=Math.max(a,o)}else for(var n=0;n<t.length;++n){var i=t[n],a=i[0],o=i[1];i[0]=Math.min(a,o),i[1]=Math.max(a,o)}r?t.sort(h):t.sort(c);for(var s=1,n=1;n<t.length;++n){var l=t[n-1],u=t[n];(u[0]!==l[0]||u[1]!==l[1]||r&&u[2]!==l[2])&&(t[s++]=u)}t.length=s}}function d(t,e,r){var n=u(t,[],a(t));return f(e,n,r),!!n}function p(t,e,r){var n=i(t,e),c=o(t,e,n),h=a(t),d=s(t,e,n,h),p=l(t,e,c,d,r),m=u(t,p,h);return f(e,m,r),!!m||(c.length>0||d.length>0)}function m(t,e,r){var n;if(r){n=e;for(var i=new Array(e.length),a=0;a<e.length;++a){var o=e[a];i[a]=[o[0],o[1],r[a]]}e=i}for(var s=d(t,e,!!r);p(t,e,!!r);)s=!0;if(r&&s){n.length=0,r.length=0;for(var a=0;a<e.length;++a){var o=e[a];n.push([o[0],o[1]]),r.push(o[2])}}return s}e.exports=m;var v=t(\"union-find\"),g=t(\"box-intersect\"),y=t(\"robust-segment-intersect\"),b=t(\"big-rat\"),x=t(\"big-rat/cmp\"),_=t(\"big-rat/to-float\"),w=t(\"rat-vec\"),M=t(\"nextafter\"),k=t(\"./lib/rat-seg-intersect\")},{\"./lib/rat-seg-intersect\":89,\"big-rat\":52,\"big-rat/cmp\":50,\"big-rat/to-float\":64,\"box-intersect\":69,nextafter:467,\"rat-vec\":494,\"robust-segment-intersect\":510,\"union-find\":541}],89:[function(t,e,r){\"use strict\";function n(t,e){return s(a(t[0],e[1]),a(t[1],e[0]))}function i(t,e,r,i){var a=u(e,t),s=u(i,r),f=n(a,s);if(0===l(f))return null;var d=u(t,r),p=n(s,d),m=o(p,f),v=h(a,m);return c(t,v)}e.exports=i;var a=t(\"big-rat/mul\"),o=t(\"big-rat/div\"),s=t(\"big-rat/sub\"),l=t(\"big-rat/sign\"),u=t(\"rat-vec/sub\"),c=t(\"rat-vec/add\"),h=t(\"rat-vec/muls\")},{\"big-rat/div\":51,\"big-rat/mul\":61,\"big-rat/sign\":62,\"big-rat/sub\":63,\"rat-vec/add\":493,\"rat-vec/muls\":495,\"rat-vec/sub\":496}],90:[function(t,e,r){(function(t){var r=function(){\"use strict\";function e(r,n,i,a){function s(r,i){if(null===r)return null;if(0==i)return r;var h,f;if(\"object\"!=typeof r)return r;if(e.__isArray(r))h=[];else if(e.__isRegExp(r))h=new RegExp(r.source,o(r)),r.lastIndex&&(h.lastIndex=r.lastIndex);else if(e.__isDate(r))h=new Date(r.getTime());else{if(c&&t.isBuffer(r))return h=new t(r.length),r.copy(h),h;void 0===a?(f=Object.getPrototypeOf(r),h=Object.create(f)):(h=Object.create(a),f=a)}if(n){var d=l.indexOf(r);if(-1!=d)return u[d];l.push(r),u.push(h)}for(var p in r){var m;f&&(m=Object.getOwnPropertyDescriptor(f,p)),m&&null==m.set||(h[p]=s(r[p],i-1))}return h}\"object\"==typeof n&&(i=n.depth,a=n.prototype,n.filter,n=n.circular);var l=[],u=[],c=void 0!==t;return void 0===n&&(n=!0),void 0===i&&(i=1/0),s(r,i)}function r(t){return Object.prototype.toString.call(t)}function n(t){return\"object\"==typeof t&&\"[object Date]\"===r(t)}function i(t){return\"object\"==typeof t&&\"[object Array]\"===r(t)}function a(t){return\"object\"==typeof t&&\"[object RegExp]\"===r(t)}function o(t){var e=\"\";return t.global&&(e+=\"g\"),t.ignoreCase&&(e+=\"i\"),t.multiline&&(e+=\"m\"),e}return e.clonePrototype=function(t){if(null===t)return null;var e=function(){};return e.prototype=t,new e},e.__objToStr=r,e.__isDate=n,e.__isArray=i,e.__isRegExp=a,e.__getRegExpFlags=o,e}();\"object\"==typeof e&&e.exports&&(e.exports=r)}).call(this,t(\"buffer\").Buffer)},{buffer:76}],91:[function(t,e,r){\"use strict\";function n(t,e){null==e&&(e=!0);var r=t[0],n=t[1],i=t[2],o=t[3];return null==o&&(o=e?1:255),e&&(r*=255,n*=255,i*=255,o*=255),r=255&a(r,0,255),n=255&a(n,0,255),i=255&a(i,0,255),o=255&a(o,0,255),16777216*r+(n<<16)+(i<<8)+o}function i(t,e){t=+t;var r=t>>>24,n=(16711680&t)>>>16,i=(65280&t)>>>8,a=255&t;return!1===e?[r,n,i,a]:[r/255,n/255,i/255,a/255]}var a=t(\"clamp\");e.exports=n,e.exports.to=n,e.exports.from=i},{clamp:87}],92:[function(t,e,r){\"use strict\";e.exports={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]}},{}],93:[function(t,e,r){(function(r){\"use strict\";function n(t){var e,n,s=[],l=1;if(\"string\"==typeof t)if(i[t])s=i[t].slice(),n=\"rgb\";else if(\"transparent\"===t)l=0,n=\"rgb\",s=[0,0,0];else if(/^#[A-Fa-f0-9]+$/.test(t)){var u=t.slice(1),c=u.length,h=c<=4;l=1,h?(s=[parseInt(u[0]+u[0],16),parseInt(u[1]+u[1],16),parseInt(u[2]+u[2],16)],4===c&&(l=parseInt(u[3]+u[3],16)/255)):(s=[parseInt(u[0]+u[1],16),parseInt(u[2]+u[3],16),parseInt(u[4]+u[5],16)],8===c&&(l=parseInt(u[6]+u[7],16)/255)),s[0]||(s[0]=0),s[1]||(s[1]=0),s[2]||(s[2]=0),n=\"rgb\"}else if(e=/^((?:rgb|hs[lvb]|hwb|cmyk?|xy[zy]|gray|lab|lchu?v?|[ly]uv|lms)a?)\\s*\\(([^\\)]*)\\)/.exec(t)){var f=e[1],u=f.replace(/a$/,\"\");n=u;var c=\"cmyk\"===u?4:\"gray\"===u?1:3;s=e[2].trim().split(/\\s*,\\s*/).map(function(t,e){if(/%$/.test(t))return e===c?parseFloat(t)/100:\"rgb\"===u?255*parseFloat(t)/100:parseFloat(t);if(\"h\"===u[e]){if(/deg$/.test(t))return parseFloat(t);if(void 0!==o[t])return o[t]}return parseFloat(t)}),f===u&&s.push(1),l=void 0===s[c]?1:s[c],s=s.slice(0,c)}else t.length>10&&/[0-9](?:\\s|\\/)/.test(t)&&(s=t.match(/([0-9]+)/g).map(function(t){return parseFloat(t)}),n=t.match(/([a-z])/gi).join(\"\").toLowerCase());else\"number\"==typeof t?(n=\"rgb\",s=[t>>>16,(65280&t)>>>8,255&t]):a(t)?(null!=t.r?(s=[t.r,t.g,t.b],n=\"rgb\"):null!=t.red?(s=[t.red,t.green,t.blue],n=\"rgb\"):null!=t.h?(s=[t.h,t.s,t.l],n=\"hsl\"):null!=t.hue&&(s=[t.hue,t.saturation,t.lightness],n=\"hsl\"),null!=t.a?l=t.a:null!=t.alpha?l=t.alpha:null!=t.opacity&&(l=t.opacity/100)):(Array.isArray(t)||r.ArrayBuffer&&ArrayBuffer.isView&&ArrayBuffer.isView(t))&&(s=[t[0],t[1],t[2]],n=\"rgb\",l=4===t.length?t[3]:1);return{space:n,values:s,alpha:l}}e.exports=n;var i=t(\"color-name\"),a=t(\"is-plain-obj\"),o={red:0,orange:60,yellow:120,green:180,blue:240,purple:300}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"color-name\":92,\"is-plain-obj\":296}],94:[function(t,e,r){\"use strict\";var n=t(\"color-parse\"),i=t(\"color-space/hsl\"),a=t(\"clamp\");e.exports=function(t,e){if(Array.isArray(t))return t;null==e&&(e=!0);var r=n(t);if(!r.space)return[];var o,s=r.values,l=s.length;for(o=0;o<l;o++)s[o]=a(s[o],0,255);if(\"h\"===r.space[0]&&(s=i.rgb(s)),e)for(o=0;o<l;o++)s[o]/=255;return s.push(a(r.alpha,0,1)),s}},{clamp:87,\"color-parse\":93,\"color-space/hsl\":95}],95:[function(t,e,r){\"use strict\";var n=t(\"./rgb\");e.exports={name:\"hsl\",min:[0,0,0],max:[360,100,100],channel:[\"hue\",\"saturation\",\"lightness\"],alias:[\"HSL\"],rgb:function(t){var e,r,n,i,a,o=t[0]/360,s=t[1]/100,l=t[2]/100;if(0===s)return a=255*l,[a,a,a];r=l<.5?l*(1+s):l+s-l*s,e=2*l-r,i=[0,0,0];for(var u=0;u<3;u++)n=o+1/3*-(u-1),n<0?n++:n>1&&n--,a=6*n<1?e+6*(r-e)*n:2*n<1?r:3*n<2?e+(r-e)*(2/3-n)*6:e,i[u]=255*a;return i}},n.hsl=function(t){var e,r,n,i=t[0]/255,a=t[1]/255,o=t[2]/255,s=Math.min(i,a,o),l=Math.max(i,a,o),u=l-s;return l===s?e=0:i===l?e=(a-o)/u:a===l?e=2+(o-i)/u:o===l&&(e=4+(i-a)/u),e=Math.min(60*e,360),e<0&&(e+=360),n=(s+l)/2,r=l===s?0:n<=.5?u/(l+s):u/(2-l-s),[e,100*r,100*n]}},{\"./rgb\":96}],96:[function(t,e,r){\"use strict\";e.exports={name:\"rgb\",min:[0,0,0],max:[255,255,255],channel:[\"red\",\"green\",\"blue\"],alias:[\"RGB\"]}},{}],97:[function(t,e,r){e.exports={jet:[{index:0,rgb:[0,0,131]},{index:.125,rgb:[0,60,170]},{index:.375,rgb:[5,255,255]},{index:.625,rgb:[255,255,0]},{index:.875,rgb:[250,0,0]},{index:1,rgb:[128,0,0]}],hsv:[{index:0,rgb:[255,0,0]},{index:.169,rgb:[253,255,2]},{index:.173,rgb:[247,255,2]},{index:.337,rgb:[0,252,4]},{index:.341,rgb:[0,252,10]},{index:.506,rgb:[1,249,255]},{index:.671,rgb:[2,0,253]},{index:.675,rgb:[8,0,253]},{index:.839,rgb:[255,0,251]},{index:.843,rgb:[255,0,245]},{index:1,rgb:[255,0,6]}],hot:[{index:0,rgb:[0,0,0]},{index:.3,rgb:[230,0,0]},{index:.6,rgb:[255,210,0]},{index:1,rgb:[255,255,255]}],cool:[{index:0,rgb:[0,255,255]},{index:1,rgb:[255,0,255]}],spring:[{index:0,rgb:[255,0,255]},{index:1,rgb:[255,255,0]}],summer:[{index:0,rgb:[0,128,102]},{index:1,rgb:[255,255,102]}],autumn:[{index:0,rgb:[255,0,0]},{index:1,rgb:[255,255,0]}],winter:[{index:0,rgb:[0,0,255]},{index:1,rgb:[0,255,128]}],bone:[{index:0,rgb:[0,0,0]},{index:.376,rgb:[84,84,116]},{index:.753,rgb:[169,200,200]},{index:1,rgb:[255,255,255]}],copper:[{index:0,rgb:[0,0,0]},{index:.804,rgb:[255,160,102]},{index:1,rgb:[255,199,127]}],greys:[{index:0,rgb:[0,0,0]},{index:1,rgb:[255,255,255]}],yignbu:[{index:0,rgb:[8,29,88]},{index:.125,rgb:[37,52,148]},{index:.25,rgb:[34,94,168]},{index:.375,rgb:[29,145,192]},{index:.5,rgb:[65,182,196]},{index:.625,rgb:[127,205,187]},{index:.75,rgb:[199,233,180]},{index:.875,rgb:[237,248,217]},{index:1,rgb:[255,255,217]}],greens:[{index:0,rgb:[0,68,27]},{index:.125,rgb:[0,109,44]},{index:.25,rgb:[35,139,69]},{index:.375,rgb:[65,171,93]},{index:.5,rgb:[116,196,118]},{index:.625,rgb:[161,217,155]},{index:.75,rgb:[199,233,192]},{index:.875,rgb:[229,245,224]},{index:1,rgb:[247,252,245]}],yiorrd:[{index:0,rgb:[128,0,38]},{index:.125,rgb:[189,0,38]},{index:.25,rgb:[227,26,28]},{index:.375,rgb:[252,78,42]},{index:.5,rgb:[253,141,60]},{index:.625,rgb:[254,178,76]},{index:.75,rgb:[254,217,118]},{index:.875,rgb:[255,237,160]},{index:1,rgb:[255,255,204]}],bluered:[{index:0,rgb:[0,0,255]},{index:1,rgb:[255,0,0]}],rdbu:[{index:0,rgb:[5,10,172]},{index:.35,rgb:[106,137,247]},{index:.5,rgb:[190,190,190]},{index:.6,rgb:[220,170,132]},{index:.7,rgb:[230,145,90]},{index:1,rgb:[178,10,28]}],picnic:[{index:0,rgb:[0,0,255]},{index:.1,rgb:[51,153,255]},{index:.2,rgb:[102,204,255]},{index:.3,rgb:[153,204,255]},{index:.4,rgb:[204,204,255]},{index:.5,rgb:[255,255,255]},{index:.6,rgb:[255,204,255]},{index:.7,rgb:[255,153,255]},{index:.8,rgb:[255,102,204]},{index:.9,rgb:[255,102,102]},{index:1,rgb:[255,0,0]}],rainbow:[{index:0,rgb:[150,0,90]},{index:.125,rgb:[0,0,200]},{index:.25,rgb:[0,25,255]},{index:.375,rgb:[0,152,255]},{index:.5,rgb:[44,255,150]},{index:.625,rgb:[151,255,0]},{index:.75,rgb:[255,234,0]},{index:.875,rgb:[255,111,0]},{index:1,rgb:[255,0,0]}],portland:[{index:0,rgb:[12,51,131]},{index:.25,rgb:[10,136,186]},{index:.5,rgb:[242,211,56]},{index:.75,rgb:[242,143,56]},{index:1,rgb:[217,30,30]}],blackbody:[{index:0,rgb:[0,0,0]},{index:.2,rgb:[230,0,0]},{index:.4,rgb:[230,210,0]},{index:.7,rgb:[255,255,255]},{index:1,rgb:[160,200,255]}],earth:[{index:0,rgb:[0,0,130]},{index:.1,rgb:[0,180,180]},{index:.2,rgb:[40,210,40]},{index:.4,rgb:[230,230,50]},{index:.6,rgb:[120,70,20]},{index:1,rgb:[255,255,255]}],electric:[{index:0,rgb:[0,0,0]},{index:.15,rgb:[30,0,100]},{index:.4,rgb:[120,0,100]},{index:.6,rgb:[160,90,0]},{index:.8,rgb:[230,200,0]},{index:1,rgb:[255,250,220]}],alpha:[{index:0,rgb:[255,255,255,0]},{index:0,rgb:[255,255,255,1]}],viridis:[{index:0,rgb:[68,1,84]},{index:.13,rgb:[71,44,122]},{index:.25,rgb:[59,81,139]},{index:.38,rgb:[44,113,142]},{index:.5,rgb:[33,144,141]},{index:.63,rgb:[39,173,129]},{index:.75,rgb:[92,200,99]},{index:.88,rgb:[170,220,50]},{index:1,rgb:[253,231,37]}],inferno:[{index:0,rgb:[0,0,4]},{index:.13,rgb:[31,12,72]},{index:.25,rgb:[85,15,109]},{index:.38,rgb:[136,34,106]},{index:.5,rgb:[186,54,85]},{index:.63,rgb:[227,89,51]},{index:.75,rgb:[249,140,10]},{index:.88,rgb:[249,201,50]},{index:1,rgb:[252,255,164]}],magma:[{index:0,rgb:[0,0,4]},{index:.13,rgb:[28,16,68]},{index:.25,rgb:[79,18,123]},{index:.38,rgb:[129,37,129]},{index:.5,rgb:[181,54,122]},{index:.63,rgb:[229,80,100]},{index:.75,rgb:[251,135,97]},{index:.88,rgb:[254,194,135]},{index:1,rgb:[252,253,191]}],plasma:[{index:0,rgb:[13,8,135]},{index:.13,rgb:[75,3,161]},{index:.25,rgb:[125,3,168]},{index:.38,rgb:[168,34,150]},{index:.5,rgb:[203,70,121]},{index:.63,rgb:[229,107,93]},{index:.75,rgb:[248,148,65]},{index:.88,rgb:[253,195,40]},{index:1,rgb:[240,249,33]}],warm:[{index:0,rgb:[125,0,179]},{index:.13,rgb:[172,0,187]},{index:.25,rgb:[219,0,170]},{index:.38,rgb:[255,0,130]},{index:.5,rgb:[255,63,74]},{index:.63,rgb:[255,123,0]},{index:.75,rgb:[234,176,0]},{index:.88,rgb:[190,228,0]},{index:1,rgb:[147,255,0]}],cool:[{index:0,rgb:[125,0,179]},{index:.13,rgb:[116,0,218]},{index:.25,rgb:[98,74,237]},{index:.38,rgb:[68,146,231]},{index:.5,rgb:[0,204,197]},{index:.63,rgb:[0,247,146]},{index:.75,rgb:[0,255,88]},{index:.88,rgb:[40,255,8]},{index:1,rgb:[147,255,0]}],\"rainbow-soft\":[{index:0,rgb:[125,0,179]},{index:.1,rgb:[199,0,180]},{index:.2,rgb:[255,0,121]},{index:.3,rgb:[255,108,0]},{index:.4,rgb:[222,194,0]},{index:.5,rgb:[150,255,0]},{index:.6,rgb:[0,255,55]},{index:.7,rgb:[0,246,150]},{index:.8,rgb:[50,167,222]},{index:.9,rgb:[103,51,235]},{index:1,rgb:[124,0,186]}],bathymetry:[{index:0,rgb:[40,26,44]},{index:.13,rgb:[59,49,90]},{index:.25,rgb:[64,76,139]},{index:.38,rgb:[63,110,151]},{index:.5,rgb:[72,142,158]},{index:.63,rgb:[85,174,163]},{index:.75,rgb:[120,206,163]},{index:.88,rgb:[187,230,172]},{index:1,rgb:[253,254,204]}],cdom:[{index:0,rgb:[47,15,62]},{index:.13,rgb:[87,23,86]},{index:.25,rgb:[130,28,99]},{index:.38,rgb:[171,41,96]},{index:.5,rgb:[206,67,86]},{index:.63,rgb:[230,106,84]},{index:.75,rgb:[242,149,103]},{index:.88,rgb:[249,193,135]},{index:1,rgb:[254,237,176]}],chlorophyll:[{index:0,rgb:[18,36,20]},{index:.13,rgb:[25,63,41]},{index:.25,rgb:[24,91,59]},{index:.38,rgb:[13,119,72]},{index:.5,rgb:[18,148,80]},{index:.63,rgb:[80,173,89]},{index:.75,rgb:[132,196,122]},{index:.88,rgb:[175,221,162]},{index:1,rgb:[215,249,208]}],density:[{index:0,rgb:[54,14,36]},{index:.13,rgb:[89,23,80]},{index:.25,rgb:[110,45,132]},{index:.38,rgb:[120,77,178]},{index:.5,rgb:[120,113,213]},{index:.63,rgb:[115,151,228]},{index:.75,rgb:[134,185,227]},{index:.88,rgb:[177,214,227]},{index:1,rgb:[230,241,241]}],\"freesurface-blue\":[{index:0,rgb:[30,4,110]},{index:.13,rgb:[47,14,176]},{index:.25,rgb:[41,45,236]},{index:.38,rgb:[25,99,212]},{index:.5,rgb:[68,131,200]},{index:.63,rgb:[114,156,197]},{index:.75,rgb:[157,181,203]},{index:.88,rgb:[200,208,216]},{index:1,rgb:[241,237,236]}],\"freesurface-red\":[{index:0,rgb:[60,9,18]},{index:.13,rgb:[100,17,27]},{index:.25,rgb:[142,20,29]},{index:.38,rgb:[177,43,27]},{index:.5,rgb:[192,87,63]},{index:.63,rgb:[205,125,105]},{index:.75,rgb:[216,162,148]},{index:.88,rgb:[227,199,193]},{index:1,rgb:[241,237,236]}],oxygen:[{index:0,rgb:[64,5,5]},{index:.13,rgb:[106,6,15]},{index:.25,rgb:[144,26,7]},{index:.38,rgb:[168,64,3]},{index:.5,rgb:[188,100,4]},{index:.63,rgb:[206,136,11]},{index:.75,rgb:[220,174,25]},{index:.88,rgb:[231,215,44]},{index:1,rgb:[248,254,105]}],par:[{index:0,rgb:[51,20,24]},{index:.13,rgb:[90,32,35]},{index:.25,rgb:[129,44,34]},{index:.38,rgb:[159,68,25]},{index:.5,rgb:[182,99,19]},{index:.63,rgb:[199,134,22]},{index:.75,rgb:[212,171,35]},{index:.88,rgb:[221,210,54]},{index:1,rgb:[225,253,75]}],phase:[{index:0,rgb:[145,105,18]},{index:.13,rgb:[184,71,38]},{index:.25,rgb:[186,58,115]},{index:.38,rgb:[160,71,185]},{index:.5,rgb:[110,97,218]},{index:.63,rgb:[50,123,164]},{index:.75,rgb:[31,131,110]},{index:.88,rgb:[77,129,34]},{index:1,rgb:[145,105,18]}],salinity:[{index:0,rgb:[42,24,108]},{index:.13,rgb:[33,50,162]},{index:.25,rgb:[15,90,145]},{index:.38,rgb:[40,118,137]},{index:.5,rgb:[59,146,135]},{index:.63,rgb:[79,175,126]},{index:.75,rgb:[120,203,104]},{index:.88,rgb:[193,221,100]},{index:1,rgb:[253,239,154]}],temperature:[{index:0,rgb:[4,35,51]},{index:.13,rgb:[23,51,122]},{index:.25,rgb:[85,59,157]},{index:.38,rgb:[129,79,143]},{index:.5,rgb:[175,95,130]},{index:.63,rgb:[222,112,101]},{index:.75,rgb:[249,146,66]},{index:.88,rgb:[249,196,65]},{index:1,rgb:[232,250,91]}],turbidity:[{index:0,rgb:[34,31,27]},{index:.13,rgb:[65,50,41]},{index:.25,rgb:[98,69,52]},{index:.38,rgb:[131,89,57]},{index:.5,rgb:[161,112,59]},{index:.63,rgb:[185,140,66]},{index:.75,rgb:[202,174,88]},{index:.88,rgb:[216,209,126]},{index:1,rgb:[233,246,171]}],\"velocity-blue\":[{index:0,rgb:[17,32,64]},{index:.13,rgb:[35,52,116]},{index:.25,rgb:[29,81,156]},{index:.38,rgb:[31,113,162]},{index:.5,rgb:[50,144,169]},{index:.63,rgb:[87,173,176]},{index:.75,rgb:[149,196,189]},{index:.88,rgb:[203,221,211]},{index:1,rgb:[254,251,230]}],\"velocity-green\":[{index:0,rgb:[23,35,19]},{index:.13,rgb:[24,64,38]},{index:.25,rgb:[11,95,45]},{index:.38,rgb:[39,123,35]},{index:.5,rgb:[95,146,12]},{index:.63,rgb:[152,165,18]},{index:.75,rgb:[201,186,69]},{index:.88,rgb:[233,216,137]},{index:1,rgb:[255,253,205]}],cubehelix:[{index:0,rgb:[0,0,0]},{index:.07,rgb:[22,5,59]},{index:.13,rgb:[60,4,105]},{index:.2,rgb:[109,1,135]},{index:.27,rgb:[161,0,147]},{index:.33,rgb:[210,2,142]},{index:.4,rgb:[251,11,123]},{index:.47,rgb:[255,29,97]},{index:.53,rgb:[255,54,69]},{index:.6,rgb:[255,85,46]},{index:.67,rgb:[255,120,34]},{index:.73,rgb:[255,157,37]},{index:.8,rgb:[241,191,57]},{index:.87,rgb:[224,220,93]},{index:.93,rgb:[218,241,142]},{index:1,rgb:[227,253,198]}]}},{}],98:[function(t,e,r){\"use strict\";function n(t){var e,r,n,u,c,h,f,d,p,m,v,g,y,b=[],x=[],_=[],w=[];if(o.isPlainObject(t)||(t={}),p=t.nshades||72,d=t.format||\"hex\",f=t.colormap,f||(f=\"jet\"),\"string\"==typeof f){if(f=f.toLowerCase(),!l[f])throw Error(f+\" not a supported colorscale\");h=s(l[f])}else{if(!Array.isArray(f))throw Error(\"unsupported colormap option\",f);h=s(f)}if(h.length>p)throw new Error(f+\" map requires nshades to be at least size \"+h.length);for(v=Array.isArray(t.alpha)?2!==t.alpha.length?[1,1]:s(t.alpha):\"number\"==typeof t.alpha?[t.alpha,t.alpha]:[1,1],e=h.map(function(t){return Math.round(t.index*p)}),v[0]<0&&(v[0]=0),v[1]<0&&(v[0]=0),v[0]>1&&(v[0]=1),v[1]>1&&(v[0]=1),y=0;y<e.length;++y)g=h[y].index,r=h[y].rgb,4===r.length&&r[3]>=0&&r[3]<=1||(r[3]=v[0]+(v[1]-v[0])*g);for(y=0;y<e.length-1;++y)c=e[y+1]-e[y],n=h[y].rgb,u=h[y+1].rgb,b=b.concat(o.linspace(n[0],u[0],c)),x=x.concat(o.linspace(n[1],u[1],c)),_=_.concat(o.linspace(n[2],u[2],c)),w=w.concat(o.linspace(n[3],u[3],c));return b=b.map(Math.round),x=x.map(Math.round),_=_.map(Math.round),m=o.zip(b,x,_,w),\"hex\"===d&&(m=m.map(i)),\"rgbaString\"===d&&(m=m.map(a)),m}function i(t){for(var e,r=\"#\",n=0;n<3;++n)e=t[n],e=e.toString(16),r+=(\"00\"+e).substr(e.length);return r}function a(t){return\"rgba(\"+t.join(\",\")+\")\"}var o=t(\"arraytools\"),s=t(\"clone\"),l=t(\"./colorScales\");e.exports=n},{\"./colorScales\":97,arraytools:45,clone:90}],99:[function(t,e,r){\"use strict\";function n(t,e,r){var n=s(t[0],-e[0]),i=s(t[1],-e[1]),a=s(r[0],-e[0]),o=s(r[1],-e[1]),c=u(l(n,a),l(i,o));return c[c.length-1]>=0}function i(t,e,r,i){var s=a(e,r,i);if(0===s){var l=o(a(t,e,r)),u=o(a(t,e,i));if(l===u){if(0===l){var c=n(t,e,r);return c===n(t,e,i)?0:c?1:-1}return 0}return 0===u?l>0?-1:n(t,e,i)?-1:1:0===l?u>0?1:n(t,e,r)?1:-1:o(u-l)}var h=a(t,e,r);return h>0?s>0&&a(t,e,i)>0?1:-1:h<0?s>0||a(t,e,i)>0?1:-1:a(t,e,i)>0?1:n(t,e,r)?1:-1}e.exports=i;var a=t(\"robust-orientation\"),o=t(\"signum\"),s=t(\"two-sum\"),l=t(\"robust-product\"),u=t(\"robust-sum\")},{\"robust-orientation\":507,\"robust-product\":508,\"robust-sum\":512,signum:514,\"two-sum\":539}],100:[function(t,e,r){function n(t,e){return t-e}function i(t,e){var r=t.length,i=t.length-e.length;if(i)return i;switch(r){case 0:return 0;case 1:return t[0]-e[0];case 2:return t[0]+t[1]-e[0]-e[1]||a(t[0],t[1])-a(e[0],e[1]);case 3:var o=t[0]+t[1],s=e[0]+e[1];if(i=o+t[2]-(s+e[2]))return i;var l=a(t[0],t[1]),u=a(e[0],e[1]);return a(l,t[2])-a(u,e[2])||a(l+t[2],o)-a(u+e[2],s);case 4:var c=t[0],h=t[1],f=t[2],d=t[3],p=e[0],m=e[1],v=e[2],g=e[3];return c+h+f+d-(p+m+v+g)||a(c,h,f,d)-a(p,m,v,g,p)||a(c+h,c+f,c+d,h+f,h+d,f+d)-a(p+m,p+v,p+g,m+v,m+g,v+g)||a(c+h+f,c+h+d,c+f+d,h+f+d)-a(p+m+v,p+m+g,p+v+g,m+v+g);default:for(var y=t.slice().sort(n),b=e.slice().sort(n),x=0;x<r;++x)if(i=y[x]-b[x])return i;return 0}}e.exports=i;var a=Math.min},{}],101:[function(t,e,r){\"use strict\";function n(t,e){return i(t,e)||a(t)-a(e)}var i=t(\"compare-cell\"),a=t(\"cell-orientation\");e.exports=n},{\"cell-orientation\":84,\"compare-cell\":100}],102:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(0===e)return[];if(1===e)return[[0]];var r=t[0].length;return 0===r?[]:1===r?i(t):2===r?a(t):o(t,r)}var i=t(\"./lib/ch1d\"),a=t(\"./lib/ch2d\"),o=t(\"./lib/chnd\");e.exports=n},{\"./lib/ch1d\":103,\"./lib/ch2d\":104,\"./lib/chnd\":105}],103:[function(t,e,r){\"use strict\";function n(t){for(var e=0,r=0,n=1;n<t.length;++n)t[n][0]<t[e][0]&&(e=n),t[n][0]>t[r][0]&&(r=n);return e<r?[[e],[r]]:e>r?[[r],[e]]:[[e]]}e.exports=n},{}],104:[function(t,e,r){\"use strict\";function n(t){var e=i(t),r=e.length;if(r<=2)return[];for(var n=new Array(r),a=e[r-1],o=0;o<r;++o){var s=e[o];n[o]=[a,s],a=s}return n}e.exports=n;var i=t(\"monotone-convex-hull-2d\")},{\"monotone-convex-hull-2d\":450}],105:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),i=0;i<e.length;++i)n[i]=t[e[i]];for(var a=e.length,i=0;i<r;++i)e.indexOf(i)<0&&(n[a++]=t[i]);return n}function i(t,e){for(var r=t.length,n=e.length,i=0;i<r;++i)for(var a=t[i],o=0;o<a.length;++o){var s=a[o];if(s<n)a[o]=e[s];else{s-=n;for(var l=0;l<n;++l)s>=e[l]&&(s+=1);a[o]=s}}return t}function a(t,e){try{return o(t,!0)}catch(u){var r=s(t);if(r.length<=e)return[];var a=n(t,r),l=o(a,!0);return i(l,r)}}e.exports=a;var o=t(\"incremental-convex-hull\"),s=t(\"affine-hull\")},{\"affine-hull\":40,\"incremental-convex-hull\":289}],106:[function(t,e,r){e.exports={AFG:\"afghan\",ALA:\"\\\\b\\\\wland\",ALB:\"albania\",DZA:\"algeria\",ASM:\"^(?=.*americ).*samoa\",AND:\"andorra\",AGO:\"angola\",AIA:\"anguill?a\",ATA:\"antarctica\",ATG:\"antigua\",ARG:\"argentin\",ARM:\"armenia\",ABW:\"^(?!.*bonaire).*\\\\baruba\",AUS:\"australia\",AUT:\"^(?!.*hungary).*austria|\\\\baustri.*\\\\bemp\",AZE:\"azerbaijan\",BHS:\"bahamas\",BHR:\"bahrain\",BGD:\"bangladesh|^(?=.*east).*paki?stan\",BRB:\"barbados\",BLR:\"belarus|byelo\",BEL:\"^(?!.*luxem).*belgium\",BLZ:\"belize|^(?=.*british).*honduras\",BEN:\"benin|dahome\",BMU:\"bermuda\",BTN:\"bhutan\",BOL:\"bolivia\",BES:\"^(?=.*bonaire).*eustatius|^(?=.*carib).*netherlands|\\\\bbes.?islands\",BIH:\"herzegovina|bosnia\",BWA:\"botswana|bechuana\",BVT:\"bouvet\",BRA:\"brazil\",IOT:\"british.?indian.?ocean\",BRN:\"brunei\",BGR:\"bulgaria\",BFA:\"burkina|\\\\bfaso|upper.?volta\",BDI:\"burundi\",CPV:\"verde\",KHM:\"cambodia|kampuchea|khmer\",CMR:\"cameroon\",CAN:\"canada\",CYM:\"cayman\",CAF:\"\\\\bcentral.african.republic\",TCD:\"\\\\bchad\",CHL:\"\\\\bchile\",CHN:\"^(?!.*\\\\bmac)(?!.*\\\\bhong)(?!.*\\\\btai)(?!.*\\\\brep).*china|^(?=.*peo)(?=.*rep).*china\",CXR:\"christmas\",CCK:\"\\\\bcocos|keeling\",COL:\"colombia\",COM:\"comoro\",COG:\"^(?!.*\\\\bdem)(?!.*\\\\bd[\\\\.]?r)(?!.*kinshasa)(?!.*zaire)(?!.*belg)(?!.*l.opoldville)(?!.*free).*\\\\bcongo\",COK:\"\\\\bcook\",CRI:\"costa.?rica\",CIV:\"ivoire|ivory\",HRV:\"croatia\",CUB:\"\\\\bcuba\",CUW:\"^(?!.*bonaire).*\\\\bcura(c|\\xe7)ao\",CYP:\"cyprus\",CSK:\"czechoslovakia\",CZE:\"^(?=.*rep).*czech|czechia|bohemia\",COD:\"\\\\bdem.*congo|congo.*\\\\bdem|congo.*\\\\bd[\\\\.]?r|\\\\bd[\\\\.]?r.*congo|belgian.?congo|congo.?free.?state|kinshasa|zaire|l.opoldville|drc|droc|rdc\",DNK:\"denmark\",DJI:\"djibouti\",DMA:\"dominica(?!n)\",DOM:\"dominican.rep\",ECU:\"ecuador\",EGY:\"egypt\",SLV:\"el.?salvador\",GNQ:\"guine.*eq|eq.*guine|^(?=.*span).*guinea\",ERI:\"eritrea\",EST:\"estonia\",ETH:\"ethiopia|abyssinia\",FLK:\"falkland|malvinas\",FRO:\"faroe|faeroe\",FJI:\"fiji\",FIN:\"finland\",FRA:\"^(?!.*\\\\bdep)(?!.*martinique).*france|french.?republic|\\\\bgaul\",GUF:\"^(?=.*french).*guiana\",PYF:\"french.?polynesia|tahiti\",ATF:\"french.?southern\",GAB:\"gabon\",GMB:\"gambia\",GEO:\"^(?!.*south).*georgia\",DDR:\"german.?democratic.?republic|democratic.?republic.*germany|east.germany\",DEU:\"^(?!.*east).*germany|^(?=.*\\\\bfed.*\\\\brep).*german\",GHA:\"ghana|gold.?coast\",GIB:\"gibraltar\",GRC:\"greece|hellenic|hellas\",GRL:\"greenland\",GRD:\"grenada\",GLP:\"guadeloupe\",GUM:\"\\\\bguam\",GTM:\"guatemala\",GGY:\"guernsey\",GIN:\"^(?!.*eq)(?!.*span)(?!.*bissau)(?!.*portu)(?!.*new).*guinea\",GNB:\"bissau|^(?=.*portu).*guinea\",GUY:\"guyana|british.?guiana\",HTI:\"haiti\",HMD:\"heard.*mcdonald\",VAT:\"holy.?see|vatican|papal.?st\",HND:\"^(?!.*brit).*honduras\",HKG:\"hong.?kong\",HUN:\"^(?!.*austr).*hungary\",ISL:\"iceland\",IND:\"india(?!.*ocea)\",IDN:\"indonesia\",IRN:\"\\\\biran|persia\",IRQ:\"\\\\biraq|mesopotamia\",IRL:\"(^ireland)|(^republic.*ireland)\",IMN:\"^(?=.*isle).*\\\\bman\",ISR:\"israel\",ITA:\"italy\",JAM:\"jamaica\",JPN:\"japan\",JEY:\"jersey\",JOR:\"jordan\",KAZ:\"kazak\",KEN:\"kenya|british.?east.?africa|east.?africa.?prot\",KIR:\"kiribati\",PRK:\"^(?=.*democrat|people|north|d.*p.*.r).*\\\\bkorea|dprk|korea.*(d.*p.*r)\",KWT:\"kuwait\",KGZ:\"kyrgyz|kirghiz\",LAO:\"\\\\blaos?\\\\b\",LVA:\"latvia\",LBN:\"lebanon\",LSO:\"lesotho|basuto\",LBR:\"liberia\",LBY:\"libya\",LIE:\"liechtenstein\",LTU:\"lithuania\",LUX:\"^(?!.*belg).*luxem\",MAC:\"maca(o|u)\",MDG:\"madagascar|malagasy\",MWI:\"malawi|nyasa\",MYS:\"malaysia\",MDV:\"maldive\",MLI:\"\\\\bmali\\\\b\",MLT:\"\\\\bmalta\",MHL:\"marshall\",MTQ:\"martinique\",MRT:\"mauritania\",MUS:\"mauritius\",MYT:\"\\\\bmayotte\",MEX:\"\\\\bmexic\",FSM:\"fed.*micronesia|micronesia.*fed\",MCO:\"monaco\",MNG:\"mongolia\",MNE:\"^(?!.*serbia).*montenegro\",MSR:\"montserrat\",MAR:\"morocco|\\\\bmaroc\",MOZ:\"mozambique\",MMR:\"myanmar|burma\",NAM:\"namibia\",NRU:\"nauru\",NPL:\"nepal\",NLD:\"^(?!.*\\\\bant)(?!.*\\\\bcarib).*netherlands\",ANT:\"^(?=.*\\\\bant).*(nether|dutch)\",NCL:\"new.?caledonia\",NZL:\"new.?zealand\",NIC:\"nicaragua\",NER:\"\\\\bniger(?!ia)\",NGA:\"nigeria\",NIU:\"niue\",NFK:\"norfolk\",MNP:\"mariana\",NOR:\"norway\",OMN:\"\\\\boman|trucial\",PAK:\"^(?!.*east).*paki?stan\",PLW:\"palau\",PSE:\"palestin|\\\\bgaza|west.?bank\",PAN:\"panama\",PNG:\"papua|new.?guinea\",PRY:\"paraguay\",PER:\"peru\",PHL:\"philippines\",PCN:\"pitcairn\",POL:\"poland\",PRT:\"portugal\",PRI:\"puerto.?rico\",QAT:\"qatar\",KOR:\"^(?!.*d.*p.*r)(?!.*democrat)(?!.*people)(?!.*north).*\\\\bkorea(?!.*d.*p.*r)\",MDA:\"moldov|b(a|e)ssarabia\",REU:\"r(e|\\xe9)union\",ROU:\"r(o|u|ou)mania\",RUS:\"\\\\brussia|soviet.?union|u\\\\.?s\\\\.?s\\\\.?r|socialist.?republics\",RWA:\"rwanda\",BLM:\"barth(e|\\xe9)lemy\",SHN:\"helena\",KNA:\"kitts|\\\\bnevis\",LCA:\"\\\\blucia\",MAF:\"^(?=.*collectivity).*martin|^(?=.*france).*martin(?!ique)|^(?=.*french).*martin(?!ique)\",SPM:\"miquelon\",VCT:\"vincent\",WSM:\"^(?!.*amer).*samoa\",SMR:\"san.?marino\",STP:\"\\\\bs(a|\\xe3)o.?tom(e|\\xe9)\",SAU:\"\\\\bsa\\\\w*.?arabia\",SEN:\"senegal\",SRB:\"^(?!.*monte).*serbia\",SYC:\"seychell\",SLE:\"sierra\",SGP:\"singapore\",SXM:\"^(?!.*martin)(?!.*saba).*maarten\",SVK:\"^(?!.*cze).*slovak\",SVN:\"slovenia\",SLB:\"solomon\",SOM:\"somali\",ZAF:\"south.africa|s\\\\\\\\..?africa\",SGS:\"south.?georgia|sandwich\",SSD:\"\\\\bs\\\\w*.?sudan\",ESP:\"spain\",LKA:\"sri.?lanka|ceylon\",SDN:\"^(?!.*\\\\bs(?!u)).*sudan\",SUR:\"surinam|dutch.?guiana\",SJM:\"svalbard\",SWZ:\"swaziland\",SWE:\"sweden\",CHE:\"switz|swiss\",SYR:\"syria\",TWN:\"taiwan|taipei|formosa|^(?!.*peo)(?=.*rep).*china\",TJK:\"tajik\",THA:\"thailand|\\\\bsiam\",MKD:\"macedonia|fyrom\",TLS:\"^(?=.*leste).*timor|^(?=.*east).*timor\",TGO:\"togo\",TKL:\"tokelau\",TON:\"tonga\",TTO:\"trinidad|tobago\",TUN:\"tunisia\",TUR:\"turkey\",TKM:\"turkmen\",TCA:\"turks\",TUV:\"tuvalu\",UGA:\"uganda\",UKR:\"ukrain\",ARE:\"emirates|^u\\\\.?a\\\\.?e\\\\.?$|united.?arab.?em\",GBR:\"united.?kingdom|britain|^u\\\\.?k\\\\.?$\",TZA:\"tanzania\",USA:\"united.?states\\\\b(?!.*islands)|\\\\bu\\\\.?s\\\\.?a\\\\.?\\\\b|^\\\\s*u\\\\.?s\\\\.?\\\\b(?!.*islands)\",UMI:\"minor.?outlying.?is\",URY:\"uruguay\",UZB:\"uzbek\",VUT:\"vanuatu|new.?hebrides\",VEN:\"venezuela\",VNM:\"^(?!.*republic).*viet.?nam|^(?=.*socialist).*viet.?nam\",VGB:\"^(?=.*\\\\bu\\\\.?\\\\s?k).*virgin|^(?=.*brit).*virgin|^(?=.*kingdom).*virgin\",VIR:\"^(?=.*\\\\bu\\\\.?\\\\s?s).*virgin|^(?=.*states).*virgin\",WLF:\"futuna|wallis\",ESH:\"western.sahara\",YEM:\"^(?!.*arab)(?!.*north)(?!.*sana)(?!.*peo)(?!.*dem)(?!.*south)(?!.*aden)(?!.*\\\\bp\\\\.?d\\\\.?r).*yemen\",YMD:\"^(?=.*peo).*yemen|^(?!.*rep)(?=.*dem).*yemen|^(?=.*south).*yemen|^(?=.*aden).*yemen|^(?=.*\\\\bp\\\\.?d\\\\.?r).*yemen\",YUG:\"yugoslavia\",ZMB:\"zambia|northern.?rhodesia\",EAZ:\"zanzibar\",ZWE:\"zimbabwe|^(?!.*northern).*rhodesia\"}},{}],107:[function(t,e,r){function n(t){return t=Math.round(t),t<0?0:t>255?255:t}function i(t){return t<0?0:t>1?1:t}function a(t){return n(\"%\"===t[t.length-1]?parseFloat(t)/100*255:parseInt(t))}function o(t){return i(\"%\"===t[t.length-1]?parseFloat(t)/100:parseFloat(t))}function s(t,e,r){return r<0?r+=1:r>1&&(r-=1),6*r<1?t+(e-t)*r*6:2*r<1?e:3*r<2?t+(e-t)*(2/3-r)*6:t}function l(t){var e=t.replace(/ /g,\"\").toLowerCase();if(e in u)return u[e].slice();if(\"#\"===e[0]){if(4===e.length){var r=parseInt(e.substr(1),16);return r>=0&&r<=4095?[(3840&r)>>4|(3840&r)>>8,240&r|(240&r)>>4,15&r|(15&r)<<4,1]:null}if(7===e.length){var r=parseInt(e.substr(1),16);return r>=0&&r<=16777215?[(16711680&r)>>16,(65280&r)>>8,255&r,1]:null}return null}var i=e.indexOf(\"(\"),l=e.indexOf(\")\");if(-1!==i&&l+1===e.length){var c=e.substr(0,i),h=e.substr(i+1,l-(i+1)).split(\",\"),f=1;switch(c){case\"rgba\":if(4!==h.length)return null;f=o(h.pop());case\"rgb\":return 3!==h.length?null:[a(h[0]),a(h[1]),a(h[2]),f];case\"hsla\":if(4!==h.length)return null;f=o(h.pop());case\"hsl\":if(3!==h.length)return null;var d=(parseFloat(h[0])%360+360)%360/360,p=o(h[1]),m=o(h[2]),v=m<=.5?m*(p+1):m+p-m*p,g=2*m-v;return[n(255*s(g,v,d+1/3)),n(255*s(g,v,d)),n(255*s(g,v,d-1/3)),f];default:return null}}return null}var u={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],\n",
       "darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};try{r.parseCSSColor=l}catch(t){}},{}],108:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){var o=6*i*i-6*i,s=3*i*i-4*i+1,l=-6*i*i+6*i,u=3*i*i-2*i;if(t.length){a||(a=new Array(t.length));for(var c=t.length-1;c>=0;--c)a[c]=o*t[c]+s*e[c]+l*r[c]+u*n[c];return a}return o*t+s*e+l*r[c]+u*n}function i(t,e,r,n,i,a){var o=i-1,s=i*i,l=o*o,u=(1+2*i)*l,c=i*l,h=s*(3-2*i),f=s*o;if(t.length){a||(a=new Array(t.length));for(var d=t.length-1;d>=0;--d)a[d]=u*t[d]+c*e[d]+h*r[d]+f*n[d];return a}return u*t+c*e+h*r+f*n}e.exports=i,e.exports.derivative=n},{}],109:[function(t,e,r){\"use strict\";function n(){this.argTypes=[],this.shimArgs=[],this.arrayArgs=[],this.arrayBlockIndices=[],this.scalarArgs=[],this.offsetArgs=[],this.offsetArgIndex=[],this.indexArgs=[],this.shapeArgs=[],this.funcName=\"\",this.pre=null,this.body=null,this.post=null,this.debug=!1}function i(t){var e=new n;e.pre=t.pre,e.body=t.body,e.post=t.post;var r=t.args.slice(0);e.argTypes=r;for(var i=0;i<r.length;++i){var o=r[i];if(\"array\"===o||\"object\"==typeof o&&o.blockIndices){if(e.argTypes[i]=\"array\",e.arrayArgs.push(i),e.arrayBlockIndices.push(o.blockIndices?o.blockIndices:0),e.shimArgs.push(\"array\"+i),i<e.pre.args.length&&e.pre.args[i].count>0)throw new Error(\"cwise: pre() block may not reference array args\");if(i<e.post.args.length&&e.post.args[i].count>0)throw new Error(\"cwise: post() block may not reference array args\")}else if(\"scalar\"===o)e.scalarArgs.push(i),e.shimArgs.push(\"scalar\"+i);else if(\"index\"===o){if(e.indexArgs.push(i),i<e.pre.args.length&&e.pre.args[i].count>0)throw new Error(\"cwise: pre() block may not reference array index\");if(i<e.body.args.length&&e.body.args[i].lvalue)throw new Error(\"cwise: body() block may not write to array index\");if(i<e.post.args.length&&e.post.args[i].count>0)throw new Error(\"cwise: post() block may not reference array index\")}else if(\"shape\"===o){if(e.shapeArgs.push(i),i<e.pre.args.length&&e.pre.args[i].lvalue)throw new Error(\"cwise: pre() block may not write to array shape\");if(i<e.body.args.length&&e.body.args[i].lvalue)throw new Error(\"cwise: body() block may not write to array shape\");if(i<e.post.args.length&&e.post.args[i].lvalue)throw new Error(\"cwise: post() block may not write to array shape\")}else{if(\"object\"!=typeof o||!o.offset)throw new Error(\"cwise: Unknown argument type \"+r[i]);e.argTypes[i]=\"offset\",e.offsetArgs.push({array:o.array,offset:o.offset}),e.offsetArgIndex.push(i)}}if(e.arrayArgs.length<=0)throw new Error(\"cwise: No array arguments specified\");if(e.pre.args.length>r.length)throw new Error(\"cwise: Too many arguments in pre() block\");if(e.body.args.length>r.length)throw new Error(\"cwise: Too many arguments in body() block\");if(e.post.args.length>r.length)throw new Error(\"cwise: Too many arguments in post() block\");return e.debug=!!t.printCode||!!t.debug,e.funcName=t.funcName||\"cwise\",e.blockSize=t.blockSize||64,a(e)}var a=t(\"./lib/thunk.js\");e.exports=i},{\"./lib/thunk.js\":111}],110:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a=t.length,o=e.arrayArgs.length,s=e.indexArgs.length>0,l=[],u=[],c=0,h=0;for(n=0;n<a;++n)u.push([\"i\",n,\"=0\"].join(\"\"));for(i=0;i<o;++i)for(n=0;n<a;++n)h=c,c=t[n],0===n?u.push([\"d\",i,\"s\",n,\"=t\",i,\"p\",c].join(\"\")):u.push([\"d\",i,\"s\",n,\"=(t\",i,\"p\",c,\"-s\",h,\"*t\",i,\"p\",h,\")\"].join(\"\"));for(u.length>0&&l.push(\"var \"+u.join(\",\")),n=a-1;n>=0;--n)c=t[n],l.push([\"for(i\",n,\"=0;i\",n,\"<s\",c,\";++i\",n,\"){\"].join(\"\"));for(l.push(r),n=0;n<a;++n){for(h=c,c=t[n],i=0;i<o;++i)l.push([\"p\",i,\"+=d\",i,\"s\",n].join(\"\"));s&&(n>0&&l.push([\"index[\",h,\"]-=s\",h].join(\"\")),l.push([\"++index[\",c,\"]\"].join(\"\"))),l.push(\"}\")}return l.join(\"\\n\")}function i(t,e,r,i){for(var a=e.length,o=r.arrayArgs.length,s=r.blockSize,l=r.indexArgs.length>0,u=[],c=0;c<o;++c)u.push([\"var offset\",c,\"=p\",c].join(\"\"));for(var c=t;c<a;++c)u.push([\"for(var j\"+c+\"=SS[\",e[c],\"]|0;j\",c,\">0;){\"].join(\"\")),u.push([\"if(j\",c,\"<\",s,\"){\"].join(\"\")),u.push([\"s\",e[c],\"=j\",c].join(\"\")),u.push([\"j\",c,\"=0\"].join(\"\")),u.push([\"}else{s\",e[c],\"=\",s].join(\"\")),u.push([\"j\",c,\"-=\",s,\"}\"].join(\"\")),l&&u.push([\"index[\",e[c],\"]=j\",c].join(\"\"));for(var c=0;c<o;++c){for(var h=[\"offset\"+c],f=t;f<a;++f)h.push([\"j\",f,\"*t\",c,\"p\",e[f]].join(\"\"));u.push([\"p\",c,\"=(\",h.join(\"+\"),\")\"].join(\"\"))}u.push(n(e,r,i));for(var c=t;c<a;++c)u.push(\"}\");return u.join(\"\\n\")}function a(t){for(var e=0,r=t[0].length;e<r;){for(var n=1;n<t.length;++n)if(t[n][e]!==t[0][e])return e;++e}return e}function o(t,e,r){for(var n=t.body,i=[],a=[],o=0;o<t.args.length;++o){var s=t.args[o];if(!(s.count<=0)){var l=new RegExp(s.name,\"g\"),u=\"\",c=e.arrayArgs.indexOf(o);switch(e.argTypes[o]){case\"offset\":var h=e.offsetArgIndex.indexOf(o);c=e.offsetArgs[h].array,u=\"+q\"+h;case\"array\":u=\"p\"+c+u;var f=\"l\"+o,d=\"a\"+c;if(0===e.arrayBlockIndices[c])1===s.count?\"generic\"===r[c]?s.lvalue?(i.push([\"var \",f,\"=\",d,\".get(\",u,\")\"].join(\"\")),n=n.replace(l,f),a.push([d,\".set(\",u,\",\",f,\")\"].join(\"\"))):n=n.replace(l,[d,\".get(\",u,\")\"].join(\"\")):n=n.replace(l,[d,\"[\",u,\"]\"].join(\"\")):\"generic\"===r[c]?(i.push([\"var \",f,\"=\",d,\".get(\",u,\")\"].join(\"\")),n=n.replace(l,f),s.lvalue&&a.push([d,\".set(\",u,\",\",f,\")\"].join(\"\"))):(i.push([\"var \",f,\"=\",d,\"[\",u,\"]\"].join(\"\")),n=n.replace(l,f),s.lvalue&&a.push([d,\"[\",u,\"]=\",f].join(\"\")));else{for(var p=[s.name],m=[u],v=0;v<Math.abs(e.arrayBlockIndices[c]);v++)p.push(\"\\\\s*\\\\[([^\\\\]]+)\\\\]\"),m.push(\"$\"+(v+1)+\"*t\"+c+\"b\"+v);if(l=new RegExp(p.join(\"\"),\"g\"),u=m.join(\"+\"),\"generic\"===r[c])throw new Error(\"cwise: Generic arrays not supported in combination with blocks!\");n=n.replace(l,[d,\"[\",u,\"]\"].join(\"\"))}break;case\"scalar\":n=n.replace(l,\"Y\"+e.scalarArgs.indexOf(o));break;case\"index\":n=n.replace(l,\"index\");break;case\"shape\":n=n.replace(l,\"shape\")}}}return[i.join(\"\\n\"),n,a.join(\"\\n\")].join(\"\\n\").trim()}function s(t){for(var e=new Array(t.length),r=!0,n=0;n<t.length;++n){var i=t[n],a=i.match(/\\d+/);a=a?a[0]:\"\",0===i.charAt(0)?e[n]=\"u\"+i.charAt(1)+a:e[n]=i.charAt(0)+a,n>0&&(r=r&&e[n]===e[n-1])}return r?e[0]:e.join(\"\")}function l(t,e){for(var r=e[1].length-Math.abs(t.arrayBlockIndices[0])|0,l=new Array(t.arrayArgs.length),c=new Array(t.arrayArgs.length),h=0;h<t.arrayArgs.length;++h)c[h]=e[2*h],l[h]=e[2*h+1];for(var f=[],d=[],p=[],m=[],v=[],h=0;h<t.arrayArgs.length;++h){t.arrayBlockIndices[h]<0?(p.push(0),m.push(r),f.push(r),d.push(r+t.arrayBlockIndices[h])):(p.push(t.arrayBlockIndices[h]),m.push(t.arrayBlockIndices[h]+r),f.push(0),d.push(t.arrayBlockIndices[h]));for(var g=[],y=0;y<l[h].length;y++)p[h]<=l[h][y]&&l[h][y]<m[h]&&g.push(l[h][y]-p[h]);v.push(g)}for(var b=[\"SS\"],x=[\"'use strict'\"],_=[],y=0;y<r;++y)_.push([\"s\",y,\"=SS[\",y,\"]\"].join(\"\"));for(var h=0;h<t.arrayArgs.length;++h){b.push(\"a\"+h),b.push(\"t\"+h),b.push(\"p\"+h);for(var y=0;y<r;++y)_.push([\"t\",h,\"p\",y,\"=t\",h,\"[\",p[h]+y,\"]\"].join(\"\"));for(var y=0;y<Math.abs(t.arrayBlockIndices[h]);++y)_.push([\"t\",h,\"b\",y,\"=t\",h,\"[\",f[h]+y,\"]\"].join(\"\"))}for(var h=0;h<t.scalarArgs.length;++h)b.push(\"Y\"+h);if(t.shapeArgs.length>0&&_.push(\"shape=SS.slice(0)\"),t.indexArgs.length>0){for(var w=new Array(r),h=0;h<r;++h)w[h]=\"0\";_.push([\"index=[\",w.join(\",\"),\"]\"].join(\"\"))}for(var h=0;h<t.offsetArgs.length;++h){for(var M=t.offsetArgs[h],k=[],y=0;y<M.offset.length;++y)0!==M.offset[y]&&(1===M.offset[y]?k.push([\"t\",M.array,\"p\",y].join(\"\")):k.push([M.offset[y],\"*t\",M.array,\"p\",y].join(\"\")));0===k.length?_.push(\"q\"+h+\"=0\"):_.push([\"q\",h,\"=\",k.join(\"+\")].join(\"\"))}var A=u([].concat(t.pre.thisVars).concat(t.body.thisVars).concat(t.post.thisVars));_=_.concat(A),_.length>0&&x.push(\"var \"+_.join(\",\"));for(var h=0;h<t.arrayArgs.length;++h)x.push(\"p\"+h+\"|=0\");t.pre.body.length>3&&x.push(o(t.pre,t,c));var T=o(t.body,t,c),S=a(v);S<r?x.push(i(S,v[0],t,T)):x.push(n(v[0],t,T)),t.post.body.length>3&&x.push(o(t.post,t,c)),t.debug&&console.log(\"-----Generated cwise routine for \",e,\":\\n\"+x.join(\"\\n\")+\"\\n----------\");var E=[t.funcName||\"unnamed\",\"_cwise_loop_\",l[0].join(\"s\"),\"m\",S,s(c)].join(\"\");return new Function([\"function \",E,\"(\",b.join(\",\"),\"){\",x.join(\"\\n\"),\"} return \",E].join(\"\"))()}var u=t(\"uniq\");e.exports=l},{uniq:542}],111:[function(t,e,r){\"use strict\";function n(t){var e=[\"'use strict'\",\"var CACHED={}\"],r=[],n=t.funcName+\"_cwise_thunk\";e.push([\"return function \",n,\"(\",t.shimArgs.join(\",\"),\"){\"].join(\"\"));for(var a=[],o=[],s=[[\"array\",t.arrayArgs[0],\".shape.slice(\",Math.max(0,t.arrayBlockIndices[0]),t.arrayBlockIndices[0]<0?\",\"+t.arrayBlockIndices[0]+\")\":\")\"].join(\"\")],l=[],u=[],c=0;c<t.arrayArgs.length;++c){var h=t.arrayArgs[c];r.push([\"t\",h,\"=array\",h,\".dtype,\",\"r\",h,\"=array\",h,\".order\"].join(\"\")),a.push(\"t\"+h),a.push(\"r\"+h),o.push(\"t\"+h),o.push(\"r\"+h+\".join()\"),s.push(\"array\"+h+\".data\"),s.push(\"array\"+h+\".stride\"),s.push(\"array\"+h+\".offset|0\"),c>0&&(l.push(\"array\"+t.arrayArgs[0]+\".shape.length===array\"+h+\".shape.length+\"+(Math.abs(t.arrayBlockIndices[0])-Math.abs(t.arrayBlockIndices[c]))),u.push(\"array\"+t.arrayArgs[0]+\".shape[shapeIndex+\"+Math.max(0,t.arrayBlockIndices[0])+\"]===array\"+h+\".shape[shapeIndex+\"+Math.max(0,t.arrayBlockIndices[c])+\"]\"))}t.arrayArgs.length>1&&(e.push(\"if (!(\"+l.join(\" && \")+\")) throw new Error('cwise: Arrays do not all have the same dimensionality!')\"),e.push(\"for(var shapeIndex=array\"+t.arrayArgs[0]+\".shape.length-\"+Math.abs(t.arrayBlockIndices[0])+\"; shapeIndex--\\x3e0;) {\"),e.push(\"if (!(\"+u.join(\" && \")+\")) throw new Error('cwise: Arrays do not all have the same shape!')\"),e.push(\"}\"));for(var c=0;c<t.scalarArgs.length;++c)s.push(\"scalar\"+t.scalarArgs[c]);return r.push([\"type=[\",o.join(\",\"),\"].join()\"].join(\"\")),r.push(\"proc=CACHED[type]\"),e.push(\"var \"+r.join(\",\")),e.push([\"if(!proc){\",\"CACHED[type]=proc=compile([\",a.join(\",\"),\"])}\",\"return proc(\",s.join(\",\"),\")}\"].join(\"\")),t.debug&&console.log(\"-----Generated thunk:\\n\"+e.join(\"\\n\")+\"\\n----------\"),new Function(\"compile\",e.join(\"\\n\"))(i.bind(void 0,t))}var i=t(\"./compile.js\");e.exports=n},{\"./compile.js\":110}],112:[function(t,e,r){e.exports=t(\"cwise-compiler\")},{\"cwise-compiler\":109}],113:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t){return function(e,r){return o(t(e),r)}}function r(t,e){return[t,e]}function n(t,e,r){var n=(e-t)/Math.max(0,r),i=Math.floor(Math.log(n)/Math.LN10),a=n/Math.pow(10,i);return i>=0?(a>=k?10:a>=A?5:a>=T?2:1)*Math.pow(10,i):-Math.pow(10,-i)/(a>=k?10:a>=A?5:a>=T?2:1)}function i(t,e,r){var n=Math.abs(e-t)/Math.max(0,r),i=Math.pow(10,Math.floor(Math.log(n)/Math.LN10)),a=n/i;return a>=k?i*=10:a>=A?i*=5:a>=T&&(i*=2),e<t?-i:i}function a(t){return t.length}var o=function(t,e){return t<e?-1:t>e?1:t>=e?0:NaN},s=function(t){return 1===t.length&&(t=e(t)),{left:function(e,r,n,i){for(null==n&&(n=0),null==i&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)<0?n=a+1:i=a}return n},right:function(e,r,n,i){for(null==n&&(n=0),null==i&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)>0?i=a:n=a+1}return n}}},l=s(o),u=l.right,c=l.left,h=function(t,e){null==e&&(e=r);for(var n=0,i=t.length-1,a=t[0],o=new Array(i<0?0:i);n<i;)o[n]=e(a,a=t[++n]);return o},f=function(t,e,n){var i,a,o,s,l=t.length,u=e.length,c=new Array(l*u);for(null==n&&(n=r),i=o=0;i<l;++i)for(s=t[i],a=0;a<u;++a,++o)c[o]=n(s,e[a]);return c},d=function(t,e){return e<t?-1:e>t?1:e>=t?0:NaN},p=function(t){return null===t?NaN:+t},m=function(t,e){var r,n,i=t.length,a=0,o=-1,s=0,l=0;if(null==e)for(;++o<i;)isNaN(r=p(t[o]))||(n=r-s,s+=n/++a,l+=n*(r-s));else for(;++o<i;)isNaN(r=p(e(t[o],o,t)))||(n=r-s,s+=n/++a,l+=n*(r-s));if(a>1)return l/(a-1)},v=function(t,e){var r=m(t,e);return r?Math.sqrt(r):r},g=function(t,e){var r,n,i,a=t.length,o=-1;if(null==e){for(;++o<a;)if(null!=(r=t[o])&&r>=r)for(n=i=r;++o<a;)null!=(r=t[o])&&(n>r&&(n=r),i<r&&(i=r))}else for(;++o<a;)if(null!=(r=e(t[o],o,t))&&r>=r)for(n=i=r;++o<a;)null!=(r=e(t[o],o,t))&&(n>r&&(n=r),i<r&&(i=r));return[n,i]},y=Array.prototype,b=y.slice,x=y.map,_=function(t){return function(){return t}},w=function(t){return t},M=function(t,e,r){t=+t,e=+e,r=(i=arguments.length)<2?(e=t,t=0,1):i<3?1:+r;for(var n=-1,i=0|Math.max(0,Math.ceil((e-t)/r)),a=new Array(i);++n<i;)a[n]=t+n*r;return a},k=Math.sqrt(50),A=Math.sqrt(10),T=Math.sqrt(2),S=function(t,e,r){var i,a,o,s=e<t,l=-1;if(s&&(i=t,t=e,e=i),0===(o=n(t,e,r))||!isFinite(o))return[];if(o>0)for(t=Math.ceil(t/o),e=Math.floor(e/o),a=new Array(i=Math.ceil(e-t+1));++l<i;)a[l]=(t+l)*o;else for(t=Math.floor(t*o),e=Math.ceil(e*o),a=new Array(i=Math.ceil(t-e+1));++l<i;)a[l]=(t-l)/o;return s&&a.reverse(),a},E=function(t){return Math.ceil(Math.log(t.length)/Math.LN2)+1},L=function(){function t(t){var a,o,s=t.length,l=new Array(s);for(a=0;a<s;++a)l[a]=e(t[a],a,t);var c=r(l),h=c[0],f=c[1],d=n(l,h,f);Array.isArray(d)||(d=i(h,f,d),d=M(Math.ceil(h/d)*d,Math.floor(f/d)*d,d));for(var p=d.length;d[0]<=h;)d.shift(),--p;for(;d[p-1]>f;)d.pop(),--p;var m,v=new Array(p+1);for(a=0;a<=p;++a)m=v[a]=[],m.x0=a>0?d[a-1]:h,m.x1=a<p?d[a]:f;for(a=0;a<s;++a)o=l[a],h<=o&&o<=f&&v[u(d,o,0,p)].push(t[a]);return v}var e=w,r=g,n=E;return t.value=function(r){return arguments.length?(e=\"function\"==typeof r?r:_(r),t):e},t.domain=function(e){return arguments.length?(r=\"function\"==typeof e?e:_([e[0],e[1]]),t):r},t.thresholds=function(e){return arguments.length?(n=\"function\"==typeof e?e:_(Array.isArray(e)?b.call(e):e),t):n},t},C=function(t,e,r){if(null==r&&(r=p),n=t.length){if((e=+e)<=0||n<2)return+r(t[0],0,t);if(e>=1)return+r(t[n-1],n-1,t);var n,i=(n-1)*e,a=Math.floor(i),o=+r(t[a],a,t);return o+(+r(t[a+1],a+1,t)-o)*(i-a)}},z=function(t,e,r){return t=x.call(t,p).sort(o),Math.ceil((r-e)/(2*(C(t,.75)-C(t,.25))*Math.pow(t.length,-1/3)))},I=function(t,e,r){return Math.ceil((r-e)/(3.5*v(t)*Math.pow(t.length,-1/3)))},D=function(t,e){var r,n,i=t.length,a=-1;if(null==e){for(;++a<i;)if(null!=(r=t[a])&&r>=r)for(n=r;++a<i;)null!=(r=t[a])&&r>n&&(n=r)}else for(;++a<i;)if(null!=(r=e(t[a],a,t))&&r>=r)for(n=r;++a<i;)null!=(r=e(t[a],a,t))&&r>n&&(n=r);return n},P=function(t,e){var r,n=t.length,i=n,a=-1,o=0;if(null==e)for(;++a<n;)isNaN(r=p(t[a]))?--i:o+=r;else for(;++a<n;)isNaN(r=p(e(t[a],a,t)))?--i:o+=r;if(i)return o/i},O=function(t,e){var r,n=t.length,i=-1,a=[];if(null==e)for(;++i<n;)isNaN(r=p(t[i]))||a.push(r);else for(;++i<n;)isNaN(r=p(e(t[i],i,t)))||a.push(r);return C(a.sort(o),.5)},R=function(t){for(var e,r,n,i=t.length,a=-1,o=0;++a<i;)o+=t[a].length;for(r=new Array(o);--i>=0;)for(n=t[i],e=n.length;--e>=0;)r[--o]=n[e];return r},F=function(t,e){var r,n,i=t.length,a=-1;if(null==e){for(;++a<i;)if(null!=(r=t[a])&&r>=r)for(n=r;++a<i;)null!=(r=t[a])&&n>r&&(n=r)}else for(;++a<i;)if(null!=(r=e(t[a],a,t))&&r>=r)for(n=r;++a<i;)null!=(r=e(t[a],a,t))&&n>r&&(n=r);return n},j=function(t,e){for(var r=e.length,n=new Array(r);r--;)n[r]=t[e[r]];return n},N=function(t,e){if(r=t.length){var r,n,i=0,a=0,s=t[a];for(null==e&&(e=o);++i<r;)(e(n=t[i],s)<0||0!==e(s,s))&&(s=n,a=i);return 0===e(s,s)?a:void 0}},B=function(t,e,r){for(var n,i,a=(null==r?t.length:r)-(e=null==e?0:+e);a;)i=Math.random()*a--|0,n=t[a+e],t[a+e]=t[i+e],t[i+e]=n;return t},U=function(t,e){var r,n=t.length,i=-1,a=0;if(null==e)for(;++i<n;)(r=+t[i])&&(a+=r);else for(;++i<n;)(r=+e(t[i],i,t))&&(a+=r);return a},V=function(t){if(!(i=t.length))return[];for(var e=-1,r=F(t,a),n=new Array(r);++e<r;)for(var i,o=-1,s=n[e]=new Array(i);++o<i;)s[o]=t[o][e];return n},H=function(){return V(arguments)};t.bisect=u,t.bisectRight=u,t.bisectLeft=c,t.ascending=o,t.bisector=s,t.cross=f,t.descending=d,t.deviation=v,t.extent=g,t.histogram=L,t.thresholdFreedmanDiaconis=z,t.thresholdScott=I,t.thresholdSturges=E,t.max=D,t.mean=P,t.median=O,t.merge=R,t.min=F,t.pairs=h,t.permute=j,t.quantile=C,t.range=M,t.scan=N,t.shuffle=B,t.sum=U,t.ticks=S,t.tickIncrement=n,t.tickStep=i,t.transpose=V,t.variance=m,t.zip=H,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],114:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){}function r(t,r){var n=new e;if(t instanceof e)t.each(function(t,e){n.set(e,t)});else if(Array.isArray(t)){var i,a=-1,o=t.length;if(null==r)for(;++a<o;)n.set(a,t[a]);else for(;++a<o;)n.set(r(i=t[a],a,t),i)}else if(t)for(var s in t)n.set(s,t[s]);return n}function n(){return{}}function i(t,e,r){t[e]=r}function a(){return r()}function o(t,e,r){t.set(e,r)}function s(){}function l(t,e){var r=new s;if(t instanceof s)t.each(function(t){r.add(t)});else if(t){var n=-1,i=t.length;if(null==e)for(;++n<i;)r.add(t[n]);else for(;++n<i;)r.add(e(t[n],n,t))}return r}e.prototype=r.prototype={constructor:e,has:function(t){return\"$\"+t in this},get:function(t){return this[\"$\"+t]},set:function(t,e){return this[\"$\"+t]=e,this},remove:function(t){var e=\"$\"+t;return e in this&&delete this[e]},clear:function(){for(var t in this)\"$\"===t[0]&&delete this[t]},keys:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push(e.slice(1));return t},values:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push(this[e]);return t},entries:function(){var t=[];for(var e in this)\"$\"===e[0]&&t.push({key:e.slice(1),value:this[e]});return t},size:function(){var t=0;for(var e in this)\"$\"===e[0]&&++t;return t},empty:function(){for(var t in this)if(\"$\"===t[0])return!1;return!0},each:function(t){for(var e in this)\"$\"===e[0]&&t(this[e],e.slice(1),this)}};var u=function(){function t(e,n,i,a){if(n>=c.length)return null!=l?l(e):null!=s?e.sort(s):e;for(var o,u,h,f=-1,d=e.length,p=c[n++],m=r(),v=i();++f<d;)(h=m.get(o=p(u=e[f])+\"\"))?h.push(u):m.set(o,[u]);return m.each(function(e,r){a(v,r,t(e,n,i,a))}),v}function e(t,r){if(++r>c.length)return t;var n,i=h[r-1];return null!=l&&r>=c.length?n=t.entries():(n=[],t.each(function(t,i){n.push({key:i,values:e(t,r)})})),null!=i?n.sort(function(t,e){return i(t.key,e.key)}):n}var s,l,u,c=[],h=[];return u={object:function(e){return t(e,0,n,i)},map:function(e){return t(e,0,a,o)},entries:function(r){return e(t(r,0,a,o),0)},key:function(t){return c.push(t),u},sortKeys:function(t){return h[c.length-1]=t,u},sortValues:function(t){return s=t,u},rollup:function(t){return l=t,u}}},c=r.prototype;s.prototype=l.prototype={constructor:s,has:c.has,add:function(t){return t+=\"\",this[\"$\"+t]=t,this},remove:c.remove,clear:c.clear,values:c.keys,size:c.size,empty:c.empty,each:c.each};var h=function(t){var e=[];for(var r in t)e.push(r);return e},f=function(t){var e=[];for(var r in t)e.push(t[r]);return e},d=function(t){var e=[];for(var r in t)e.push({key:r,value:t[r]});return e};t.nest=u,t.set=l,t.map=r,t.keys=h,t.values=f,t.entries=d,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],115:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t,e){var r=Object.create(t.prototype);for(var n in e)r[n]=e[n];return r}function r(){}function n(t){var e;return t=(t+\"\").trim().toLowerCase(),(e=z.exec(t))?(e=parseInt(e[1],16),new l(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1)):(e=I.exec(t))?i(parseInt(e[1],16)):(e=D.exec(t))?new l(e[1],e[2],e[3],1):(e=P.exec(t))?new l(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=O.exec(t))?a(e[1],e[2],e[3],e[4]):(e=R.exec(t))?a(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=F.exec(t))?u(e[1],e[2]/100,e[3]/100,1):(e=j.exec(t))?u(e[1],e[2]/100,e[3]/100,e[4]):N.hasOwnProperty(t)?i(N[t]):\"transparent\"===t?new l(NaN,NaN,NaN,0):null}function i(t){return new l(t>>16&255,t>>8&255,255&t,1)}function a(t,e,r,n){return n<=0&&(t=e=r=NaN),new l(t,e,r,n)}function o(t){return t instanceof r||(t=n(t)),t?(t=t.rgb(),new l(t.r,t.g,t.b,t.opacity)):new l}function s(t,e,r,n){return 1===arguments.length?o(t):new l(t,e,r,null==n?1:n)}function l(t,e,r,n){this.r=+t,this.g=+e,this.b=+r,this.opacity=+n}function u(t,e,r,n){return n<=0?t=e=r=NaN:r<=0||r>=1?t=e=NaN:e<=0&&(t=NaN),new f(t,e,r,n)}function c(t){if(t instanceof f)return new f(t.h,t.s,t.l,t.opacity);if(t instanceof r||(t=n(t)),!t)return new f;if(t instanceof f)return t;t=t.rgb();var e=t.r/255,i=t.g/255,a=t.b/255,o=Math.min(e,i,a),s=Math.max(e,i,a),l=NaN,u=s-o,c=(s+o)/2;return u?(l=e===s?(i-a)/u+6*(i<a):i===s?(a-e)/u+2:(e-i)/u+4,u/=c<.5?s+o:2-s-o,l*=60):u=c>0&&c<1?0:l,new f(l,u,c,t.opacity)}function h(t,e,r,n){return 1===arguments.length?c(t):new f(t,e,r,null==n?1:n)}function f(t,e,r,n){this.h=+t,this.s=+e,this.l=+r,this.opacity=+n}function d(t,e,r){return 255*(t<60?e+(r-e)*t/60:t<180?r:t<240?e+(r-e)*(240-t)/60:e)}function p(t){if(t instanceof v)return new v(t.l,t.a,t.b,t.opacity);if(t instanceof M){var e=t.h*B;return new v(t.l,Math.cos(e)*t.c,Math.sin(e)*t.c,t.opacity)}t instanceof l||(t=o(t));var r=x(t.r),n=x(t.g),i=x(t.b),a=g((.4124564*r+.3575761*n+.1804375*i)/V),s=g((.2126729*r+.7151522*n+.072175*i)/H);return new v(116*s-16,500*(a-s),200*(s-g((.0193339*r+.119192*n+.9503041*i)/q)),t.opacity)}function m(t,e,r,n){return 1===arguments.length?p(t):new v(t,e,r,null==n?1:n)}function v(t,e,r,n){this.l=+t,this.a=+e,this.b=+r,this.opacity=+n}function g(t){return t>W?Math.pow(t,1/3):t/X+G}function y(t){return t>Y?t*t*t:X*(t-G)}function b(t){return 255*(t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055)}function x(t){return(t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function _(t){if(t instanceof M)return new M(t.h,t.c,t.l,t.opacity);t instanceof v||(t=p(t));var e=Math.atan2(t.b,t.a)*U;return new M(e<0?e+360:e,Math.sqrt(t.a*t.a+t.b*t.b),t.l,t.opacity)}function w(t,e,r,n){return 1===arguments.length?_(t):new M(t,e,r,null==n?1:n)}function M(t,e,r,n){this.h=+t,this.c=+e,this.l=+r,this.opacity=+n}function k(t){if(t instanceof T)return new T(t.h,t.s,t.l,t.opacity);t instanceof l||(t=o(t));var e=t.r/255,r=t.g/255,n=t.b/255,i=(rt*n+tt*e-et*r)/(rt+tt-et),a=n-i,s=($*(r-i)-K*a)/Q,u=Math.sqrt(s*s+a*a)/($*i*(1-i)),c=u?Math.atan2(s,a)*U-120:NaN;return new T(c<0?c+360:c,u,i,t.opacity)}function A(t,e,r,n){return 1===arguments.length?k(t):new T(t,e,r,null==n?1:n)}function T(t,e,r,n){this.h=+t,this.s=+e,this.l=+r,this.opacity=+n}var S=function(t,e,r){t.prototype=e.prototype=r,r.constructor=t},E=\"\\\\s*([+-]?\\\\d+)\\\\s*\",L=\"\\\\s*([+-]?\\\\d*\\\\.?\\\\d+(?:[eE][+-]?\\\\d+)?)\\\\s*\",C=\"\\\\s*([+-]?\\\\d*\\\\.?\\\\d+(?:[eE][+-]?\\\\d+)?)%\\\\s*\",z=/^#([0-9a-f]{3})$/,I=/^#([0-9a-f]{6})$/,D=new RegExp(\"^rgb\\\\(\"+[E,E,E]+\"\\\\)$\"),P=new RegExp(\"^rgb\\\\(\"+[C,C,C]+\"\\\\)$\"),O=new RegExp(\"^rgba\\\\(\"+[E,E,E,L]+\"\\\\)$\"),R=new RegExp(\"^rgba\\\\(\"+[C,C,C,L]+\"\\\\)$\"),F=new RegExp(\"^hsl\\\\(\"+[L,C,C]+\"\\\\)$\"),j=new RegExp(\"^hsla\\\\(\"+[L,C,C,L]+\"\\\\)$\"),N={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};S(r,n,{displayable:function(){return this.rgb().displayable()},toString:function(){return this.rgb()+\"\"}}),S(l,s,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new l(this.r*t,this.g*t,this.b*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new l(this.r*t,this.g*t,this.b*t,this.opacity)},rgb:function(){return this},displayable:function(){return 0<=this.r&&this.r<=255&&0<=this.g&&this.g<=255&&0<=this.b&&this.b<=255&&0<=this.opacity&&this.opacity<=1},toString:function(){var t=this.opacity;return t=isNaN(t)?1:Math.max(0,Math.min(1,t)),(1===t?\"rgb(\":\"rgba(\")+Math.max(0,Math.min(255,Math.round(this.r)||0))+\", \"+Math.max(0,Math.min(255,Math.round(this.g)||0))+\", \"+Math.max(0,Math.min(255,Math.round(this.b)||0))+(1===t?\")\":\", \"+t+\")\")}})),S(f,h,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new f(this.h,this.s,this.l*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new f(this.h,this.s,this.l*t,this.opacity)},rgb:function(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,r=this.l,n=r+(r<.5?r:1-r)*e,i=2*r-n;return new l(d(t>=240?t-240:t+120,i,n),d(t,i,n),d(t<120?t+240:t-120,i,n),this.opacity)},displayable:function(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1}}));var B=Math.PI/180,U=180/Math.PI,V=.95047,H=1,q=1.08883,G=4/29,Y=6/29,X=3*Y*Y,W=Y*Y*Y;S(v,m,e(r,{brighter:function(t){return new v(this.l+18*(null==t?1:t),this.a,this.b,this.opacity)},darker:function(t){return new v(this.l-18*(null==t?1:t),this.a,this.b,this.opacity)},rgb:function(){var t=(this.l+16)/116,e=isNaN(this.a)?t:t+this.a/500,r=isNaN(this.b)?t:t-this.b/200;return t=H*y(t),e=V*y(e),r=q*y(r),new l(b(3.2404542*e-1.5371385*t-.4985314*r),b(-.969266*e+1.8760108*t+.041556*r),b(.0556434*e-.2040259*t+1.0572252*r),this.opacity)}})),S(M,w,e(r,{brighter:function(t){return new M(this.h,this.c,this.l+18*(null==t?1:t),this.opacity)},darker:function(t){return new M(this.h,this.c,this.l-18*(null==t?1:t),this.opacity)},rgb:function(){return p(this).rgb()}}));var Z=-.14861,J=1.78277,K=-.29227,Q=-.90649,$=1.97294,tt=$*Q,et=$*J,rt=J*K-Q*Z;S(T,A,e(r,{brighter:function(t){return t=null==t?1/.7:Math.pow(1/.7,t),new T(this.h,this.s,this.l*t,this.opacity)},darker:function(t){return t=null==t?.7:Math.pow(.7,t),new T(this.h,this.s,this.l*t,this.opacity)},rgb:function(){var t=isNaN(this.h)?0:(this.h+120)*B,e=+this.l,r=isNaN(this.s)?0:this.s*e*(1-e),n=Math.cos(t),i=Math.sin(t);return new l(255*(e+r*(Z*n+J*i)),255*(e+r*(K*n+Q*i)),255*(e+r*($*n)),this.opacity)}})),t.color=n,t.rgb=s,t.hsl=h,t.lab=m,t.hcl=w,t.cubehelix=A,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],116:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){for(var t,e=0,n=arguments.length,i={};e<n;++e){if(!(t=arguments[e]+\"\")||t in i)throw new Error(\"illegal type: \"+t);i[t]=[]}return new r(i)}function r(t){this._=t}function n(t,e){return t.trim().split(/^|\\s+/).map(function(t){var r=\"\",n=t.indexOf(\".\");if(n>=0&&(r=t.slice(n+1),t=t.slice(0,n)),t&&!e.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);return{type:t,name:r}})}function i(t,e){for(var r,n=0,i=t.length;n<i;++n)if((r=t[n]).name===e)return r.value}function a(t,e,r){for(var n=0,i=t.length;n<i;++n)if(t[n].name===e){t[n]=o,t=t.slice(0,n).concat(t.slice(n+1));break}return null!=r&&t.push({name:e,value:r}),t}var o={value:function(){}};r.prototype=e.prototype={constructor:r,on:function(t,e){var r,o=this._,s=n(t+\"\",o),l=-1,u=s.length;{if(!(arguments.length<2)){if(null!=e&&\"function\"!=typeof e)throw new Error(\"invalid callback: \"+e)\n",
       ";for(;++l<u;)if(r=(t=s[l]).type)o[r]=a(o[r],t.name,e);else if(null==e)for(r in o)o[r]=a(o[r],t.name,null);return this}for(;++l<u;)if((r=(t=s[l]).type)&&(r=i(o[r],t.name)))return r}},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new r(t)},call:function(t,e){if((r=arguments.length-2)>0)for(var r,n,i=new Array(r),a=0;a<r;++a)i[a]=arguments[a+2];if(!this._.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);for(n=this._[t],a=0,r=n.length;a<r;++a)n[a].value.apply(e,i)},apply:function(t,e,r){if(!this._.hasOwnProperty(t))throw new Error(\"unknown type: \"+t);for(var n=this._[t],i=0,a=n.length;i<a;++i)n[i].value.apply(e,r)}},t.dispatch=e,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],117:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-quadtree\"),e(\"d3-collection\"),e(\"d3-dispatch\"),e(\"d3-timer\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-quadtree\",\"d3-collection\",\"d3-dispatch\",\"d3-timer\"],a):a(i.d3=i.d3||{},i.d3,i.d3,i.d3,i.d3)}(this,function(t,e,r,n,i){\"use strict\";function a(t){return t.x+t.vx}function o(t){return t.y+t.vy}function s(t){return t.index}function l(t,e){var r=t.get(e);if(!r)throw new Error(\"missing: \"+e);return r}function u(t){return t.x}function c(t){return t.y}var h=function(t,e){function r(){var r,i,a=n.length,o=0,s=0;for(r=0;r<a;++r)i=n[r],o+=i.x,s+=i.y;for(o=o/a-t,s=s/a-e,r=0;r<a;++r)i=n[r],i.x-=o,i.y-=s}var n;return null==t&&(t=0),null==e&&(e=0),r.initialize=function(t){n=t},r.x=function(e){return arguments.length?(t=+e,r):t},r.y=function(t){return arguments.length?(e=+t,r):e},r},f=function(t){return function(){return t}},d=function(){return 1e-6*(Math.random()-.5)},p=function(t){function r(){function t(t,e,r,n,i){var a=t.data,o=t.r,s=m+o;{if(!a)return e>f+s||n<f-s||r>p+s||i<p-s;if(a.index>h.index){var l=f-a.x-a.vx,c=p-a.y-a.vy,g=l*l+c*c;g<s*s&&(0===l&&(l=d(),g+=l*l),0===c&&(c=d(),g+=c*c),g=(s-(g=Math.sqrt(g)))/g*u,h.vx+=(l*=g)*(s=(o*=o)/(v+o)),h.vy+=(c*=g)*s,a.vx-=l*(s=1-s),a.vy-=c*s)}}}for(var r,i,h,f,p,m,v,g=s.length,y=0;y<c;++y)for(i=e.quadtree(s,a,o).visitAfter(n),r=0;r<g;++r)h=s[r],m=l[h.index],v=m*m,f=h.x+h.vx,p=h.y+h.vy,i.visit(t)}function n(t){if(t.data)return t.r=l[t.data.index];for(var e=t.r=0;e<4;++e)t[e]&&t[e].r>t.r&&(t.r=t[e].r)}function i(){if(s){var e,r,n=s.length;for(l=new Array(n),e=0;e<n;++e)r=s[e],l[r.index]=+t(r,e,s)}}var s,l,u=1,c=1;return\"function\"!=typeof t&&(t=f(null==t?1:+t)),r.initialize=function(t){s=t,i()},r.iterations=function(t){return arguments.length?(c=+t,r):c},r.strength=function(t){return arguments.length?(u=+t,r):u},r.radius=function(e){return arguments.length?(t=\"function\"==typeof e?e:f(+e),i(),r):t},r},m=function(t){function e(t){return 1/Math.min(p[t.source.index],p[t.target.index])}function n(e){for(var r=0,n=t.length;r<b;++r)for(var i,a,o,s,l,h,f,p=0;p<n;++p)i=t[p],a=i.source,o=i.target,s=o.x+o.vx-a.x-a.vx||d(),l=o.y+o.vy-a.y-a.vy||d(),h=Math.sqrt(s*s+l*l),h=(h-c[p])/h*e*u[p],s*=h,l*=h,o.vx-=s*(f=m[p]),o.vy-=l*f,a.vx+=s*(f=1-f),a.vy+=l*f}function i(){if(h){var e,n,i=h.length,s=t.length,f=r.map(h,v);for(e=0,p=new Array(i);e<s;++e)n=t[e],n.index=e,\"object\"!=typeof n.source&&(n.source=l(f,n.source)),\"object\"!=typeof n.target&&(n.target=l(f,n.target)),p[n.source.index]=(p[n.source.index]||0)+1,p[n.target.index]=(p[n.target.index]||0)+1;for(e=0,m=new Array(s);e<s;++e)n=t[e],m[e]=p[n.source.index]/(p[n.source.index]+p[n.target.index]);u=new Array(s),a(),c=new Array(s),o()}}function a(){if(h)for(var e=0,r=t.length;e<r;++e)u[e]=+g(t[e],e,t)}function o(){if(h)for(var e=0,r=t.length;e<r;++e)c[e]=+y(t[e],e,t)}var u,c,h,p,m,v=s,g=e,y=f(30),b=1;return null==t&&(t=[]),n.initialize=function(t){h=t,i()},n.links=function(e){return arguments.length?(t=e,i(),n):t},n.id=function(t){return arguments.length?(v=t,n):v},n.iterations=function(t){return arguments.length?(b=+t,n):b},n.strength=function(t){return arguments.length?(g=\"function\"==typeof t?t:f(+t),a(),n):g},n.distance=function(t){return arguments.length?(y=\"function\"==typeof t?t:f(+t),o(),n):y},n},v=10,g=Math.PI*(3-Math.sqrt(5)),y=function(t){function e(){a(),y.call(\"tick\",l),u<c&&(m.stop(),y.call(\"end\",l))}function a(){var e,r,n=t.length;for(u+=(f-u)*h,p.each(function(t){t(u)}),e=0;e<n;++e)r=t[e],null==r.fx?r.x+=r.vx*=d:(r.x=r.fx,r.vx=0),null==r.fy?r.y+=r.vy*=d:(r.y=r.fy,r.vy=0)}function o(){for(var e,r=0,n=t.length;r<n;++r){if(e=t[r],e.index=r,isNaN(e.x)||isNaN(e.y)){var i=v*Math.sqrt(r),a=r*g;e.x=i*Math.cos(a),e.y=i*Math.sin(a)}(isNaN(e.vx)||isNaN(e.vy))&&(e.vx=e.vy=0)}}function s(e){return e.initialize&&e.initialize(t),e}var l,u=1,c=.001,h=1-Math.pow(c,1/300),f=0,d=.6,p=r.map(),m=i.timer(e),y=n.dispatch(\"tick\",\"end\");return null==t&&(t=[]),o(),l={tick:a,restart:function(){return m.restart(e),l},stop:function(){return m.stop(),l},nodes:function(e){return arguments.length?(t=e,o(),p.each(s),l):t},alpha:function(t){return arguments.length?(u=+t,l):u},alphaMin:function(t){return arguments.length?(c=+t,l):c},alphaDecay:function(t){return arguments.length?(h=+t,l):+h},alphaTarget:function(t){return arguments.length?(f=+t,l):f},velocityDecay:function(t){return arguments.length?(d=1-t,l):1-d},force:function(t,e){return arguments.length>1?(null==e?p.remove(t):p.set(t,s(e)),l):p.get(t)},find:function(e,r,n){var i,a,o,s,l,u=0,c=t.length;for(null==n?n=1/0:n*=n,u=0;u<c;++u)s=t[u],i=e-s.x,a=r-s.y,(o=i*i+a*a)<n&&(l=s,n=o);return l},on:function(t,e){return arguments.length>1?(y.on(t,e),l):y.on(t)}}},b=function(){function t(t){var r,l=a.length,h=e.quadtree(a,u,c).visitAfter(n);for(s=t,r=0;r<l;++r)o=a[r],h.visit(i)}function r(){if(a){var t,e,r=a.length;for(l=new Array(r),t=0;t<r;++t)e=a[t],l[e.index]=+h(e,t,a)}}function n(t){var e,r,n,i,a,o=0;if(t.length){for(n=i=a=0;a<4;++a)(e=t[a])&&(r=e.value)&&(o+=r,n+=r*e.x,i+=r*e.y);t.x=n/o,t.y=i/o}else{e=t,e.x=e.data.x,e.y=e.data.y;do{o+=l[e.data.index]}while(e=e.next)}t.value=o}function i(t,e,r,n){if(!t.value)return!0;var i=t.x-o.x,a=t.y-o.y,u=n-e,c=i*i+a*a;if(u*u/v<c)return c<m&&(0===i&&(i=d(),c+=i*i),0===a&&(a=d(),c+=a*a),c<p&&(c=Math.sqrt(p*c)),o.vx+=i*t.value*s/c,o.vy+=a*t.value*s/c),!0;if(!(t.length||c>=m)){(t.data!==o||t.next)&&(0===i&&(i=d(),c+=i*i),0===a&&(a=d(),c+=a*a),c<p&&(c=Math.sqrt(p*c)));do{t.data!==o&&(u=l[t.data.index]*s/c,o.vx+=i*u,o.vy+=a*u)}while(t=t.next)}}var a,o,s,l,h=f(-30),p=1,m=1/0,v=.81;return t.initialize=function(t){a=t,r()},t.strength=function(e){return arguments.length?(h=\"function\"==typeof e?e:f(+e),r(),t):h},t.distanceMin=function(e){return arguments.length?(p=e*e,t):Math.sqrt(p)},t.distanceMax=function(e){return arguments.length?(m=e*e,t):Math.sqrt(m)},t.theta=function(e){return arguments.length?(v=e*e,t):Math.sqrt(v)},t},x=function(t){function e(t){for(var e,r=0,o=n.length;r<o;++r)e=n[r],e.vx+=(a[r]-e.x)*i[r]*t}function r(){if(n){var e,r=n.length;for(i=new Array(r),a=new Array(r),e=0;e<r;++e)i[e]=isNaN(a[e]=+t(n[e],e,n))?0:+o(n[e],e,n)}}var n,i,a,o=f(.1);return\"function\"!=typeof t&&(t=f(null==t?0:+t)),e.initialize=function(t){n=t,r()},e.strength=function(t){return arguments.length?(o=\"function\"==typeof t?t:f(+t),r(),e):o},e.x=function(n){return arguments.length?(t=\"function\"==typeof n?n:f(+n),r(),e):t},e},_=function(t){function e(t){for(var e,r=0,o=n.length;r<o;++r)e=n[r],e.vy+=(a[r]-e.y)*i[r]*t}function r(){if(n){var e,r=n.length;for(i=new Array(r),a=new Array(r),e=0;e<r;++e)i[e]=isNaN(a[e]=+t(n[e],e,n))?0:+o(n[e],e,n)}}var n,i,a,o=f(.1);return\"function\"!=typeof t&&(t=f(null==t?0:+t)),e.initialize=function(t){n=t,r()},e.strength=function(t){return arguments.length?(o=\"function\"==typeof t?t:f(+t),r(),e):o},e.y=function(n){return arguments.length?(t=\"function\"==typeof n?n:f(+n),r(),e):t},e};t.forceCenter=h,t.forceCollide=p,t.forceLink=m,t.forceManyBody=b,t.forceSimulation=y,t.forceX=x,t.forceY=_,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-collection\":114,\"d3-dispatch\":116,\"d3-quadtree\":119,\"d3-timer\":120}],118:[function(e,r,n){!function(i,a){\"object\"==typeof n&&void 0!==r?a(n,e(\"d3-color\")):\"function\"==typeof t&&t.amd?t([\"exports\",\"d3-color\"],a):a(i.d3=i.d3||{},i.d3)}(this,function(t,e){\"use strict\";function r(t,e,r,n,i){var a=t*t,o=a*t;return((1-3*t+3*a-o)*e+(4-6*a+3*o)*r+(1+3*t+3*a-3*o)*n+o*i)/6}function n(t,e){return function(r){return t+r*e}}function i(t,e,r){return t=Math.pow(t,r),e=Math.pow(e,r)-t,r=1/r,function(n){return Math.pow(t+n*e,r)}}function a(t,e){var r=e-t;return r?n(t,r>180||r<-180?r-360*Math.round(r/360):r):S(isNaN(t)?e:t)}function o(t){return 1==(t=+t)?s:function(e,r){return r-e?i(e,r,t):S(isNaN(e)?r:e)}}function s(t,e){var r=e-t;return r?n(t,r):S(isNaN(t)?e:t)}function l(t){return function(r){var n,i,a=r.length,o=new Array(a),s=new Array(a),l=new Array(a);for(n=0;n<a;++n)i=e.rgb(r[n]),o[n]=i.r||0,s[n]=i.g||0,l[n]=i.b||0;return o=t(o),s=t(s),l=t(l),i.opacity=1,function(t){return i.r=o(t),i.g=s(t),i.b=l(t),i+\"\"}}}function u(t){return function(){return t}}function c(t){return function(e){return t(e)+\"\"}}function h(t){return\"none\"===t?U:(_||(_=document.createElement(\"DIV\"),w=document.documentElement,M=document.defaultView),_.style.transform=t,t=M.getComputedStyle(w.appendChild(_),null).getPropertyValue(\"transform\"),w.removeChild(_),t=t.slice(7,-1).split(\",\"),V(+t[0],+t[1],+t[2],+t[3],+t[4],+t[5]))}function f(t){return null==t?U:(k||(k=document.createElementNS(\"http://www.w3.org/2000/svg\",\"g\")),k.setAttribute(\"transform\",t),(t=k.transform.baseVal.consolidate())?(t=t.matrix,V(t.a,t.b,t.c,t.d,t.e,t.f)):U)}function d(t,e,r,n){function i(t){return t.length?t.pop()+\" \":\"\"}function a(t,n,i,a,o,s){if(t!==i||n!==a){var l=o.push(\"translate(\",null,e,null,r);s.push({i:l-4,x:D(t,i)},{i:l-2,x:D(n,a)})}else(i||a)&&o.push(\"translate(\"+i+e+a+r)}function o(t,e,r,a){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),a.push({i:r.push(i(r)+\"rotate(\",null,n)-2,x:D(t,e)})):e&&r.push(i(r)+\"rotate(\"+e+n)}function s(t,e,r,a){t!==e?a.push({i:r.push(i(r)+\"skewX(\",null,n)-2,x:D(t,e)}):e&&r.push(i(r)+\"skewX(\"+e+n)}function l(t,e,r,n,a,o){if(t!==r||e!==n){var s=a.push(i(a)+\"scale(\",null,\",\",null,\")\");o.push({i:s-4,x:D(t,r)},{i:s-2,x:D(e,n)})}else 1===r&&1===n||a.push(i(a)+\"scale(\"+r+\",\"+n+\")\")}return function(e,r){var n=[],i=[];return e=t(e),r=t(r),a(e.translateX,e.translateY,r.translateX,r.translateY,n,i),o(e.rotate,r.rotate,n,i),s(e.skewX,r.skewX,n,i),l(e.scaleX,e.scaleY,r.scaleX,r.scaleY,n,i),e=r=null,function(t){for(var e,r=-1,a=i.length;++r<a;)n[(e=i[r]).i]=e.x(t);return n.join(\"\")}}}function p(t){return((t=Math.exp(t))+1/t)/2}function m(t){return((t=Math.exp(t))-1/t)/2}function v(t){return((t=Math.exp(2*t))-1)/(t+1)}function g(t){return function(r,n){var i=t((r=e.hsl(r)).h,(n=e.hsl(n)).h),a=s(r.s,n.s),o=s(r.l,n.l),l=s(r.opacity,n.opacity);return function(t){return r.h=i(t),r.s=a(t),r.l=o(t),r.opacity=l(t),r+\"\"}}}function y(t,r){var n=s((t=e.lab(t)).l,(r=e.lab(r)).l),i=s(t.a,r.a),a=s(t.b,r.b),o=s(t.opacity,r.opacity);return function(e){return t.l=n(e),t.a=i(e),t.b=a(e),t.opacity=o(e),t+\"\"}}function b(t){return function(r,n){var i=t((r=e.hcl(r)).h,(n=e.hcl(n)).h),a=s(r.c,n.c),o=s(r.l,n.l),l=s(r.opacity,n.opacity);return function(t){return r.h=i(t),r.c=a(t),r.l=o(t),r.opacity=l(t),r+\"\"}}}function x(t){return function r(n){function i(r,i){var a=t((r=e.cubehelix(r)).h,(i=e.cubehelix(i)).h),o=s(r.s,i.s),l=s(r.l,i.l),u=s(r.opacity,i.opacity);return function(t){return r.h=a(t),r.s=o(t),r.l=l(Math.pow(t,n)),r.opacity=u(t),r+\"\"}}return n=+n,i.gamma=r,i}(1)}var _,w,M,k,A=function(t){var e=t.length-1;return function(n){var i=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),a=t[i],o=t[i+1],s=i>0?t[i-1]:2*a-o,l=i<e-1?t[i+2]:2*o-a;return r((n-i/e)*e,s,a,o,l)}},T=function(t){var e=t.length;return function(n){var i=Math.floor(((n%=1)<0?++n:n)*e),a=t[(i+e-1)%e],o=t[i%e],s=t[(i+1)%e],l=t[(i+2)%e];return r((n-i/e)*e,a,o,s,l)}},S=function(t){return function(){return t}},E=function t(r){function n(t,r){var n=i((t=e.rgb(t)).r,(r=e.rgb(r)).r),a=i(t.g,r.g),o=i(t.b,r.b),l=s(t.opacity,r.opacity);return function(e){return t.r=n(e),t.g=a(e),t.b=o(e),t.opacity=l(e),t+\"\"}}var i=o(r);return n.gamma=t,n}(1),L=l(A),C=l(T),z=function(t,e){var r,n=e?e.length:0,i=t?Math.min(n,t.length):0,a=new Array(n),o=new Array(n);for(r=0;r<i;++r)a[r]=j(t[r],e[r]);for(;r<n;++r)o[r]=e[r];return function(t){for(r=0;r<i;++r)o[r]=a[r](t);return o}},I=function(t,e){var r=new Date;return t=+t,e-=t,function(n){return r.setTime(t+e*n),r}},D=function(t,e){return t=+t,e-=t,function(r){return t+e*r}},P=function(t,e){var r,n={},i={};null!==t&&\"object\"==typeof t||(t={}),null!==e&&\"object\"==typeof e||(e={});for(r in e)r in t?n[r]=j(t[r],e[r]):i[r]=e[r];return function(t){for(r in n)i[r]=n[r](t);return i}},O=/[-+]?(?:\\d+\\.?\\d*|\\.?\\d+)(?:[eE][-+]?\\d+)?/g,R=new RegExp(O.source,\"g\"),F=function(t,e){var r,n,i,a=O.lastIndex=R.lastIndex=0,o=-1,s=[],l=[];for(t+=\"\",e+=\"\";(r=O.exec(t))&&(n=R.exec(e));)(i=n.index)>a&&(i=e.slice(a,i),s[o]?s[o]+=i:s[++o]=i),(r=r[0])===(n=n[0])?s[o]?s[o]+=n:s[++o]=n:(s[++o]=null,l.push({i:o,x:D(r,n)})),a=R.lastIndex;return a<e.length&&(i=e.slice(a),s[o]?s[o]+=i:s[++o]=i),s.length<2?l[0]?c(l[0].x):u(e):(e=l.length,function(t){for(var r,n=0;n<e;++n)s[(r=l[n]).i]=r.x(t);return s.join(\"\")})},j=function(t,r){var n,i=typeof r;return null==r||\"boolean\"===i?S(r):(\"number\"===i?D:\"string\"===i?(n=e.color(r))?(r=n,E):F:r instanceof e.color?E:r instanceof Date?I:Array.isArray(r)?z:\"function\"!=typeof r.valueOf&&\"function\"!=typeof r.toString||isNaN(r)?P:D)(t,r)},N=function(t,e){return t=+t,e-=t,function(r){return Math.round(t+e*r)}},B=180/Math.PI,U={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1},V=function(t,e,r,n,i,a){var o,s,l;return(o=Math.sqrt(t*t+e*e))&&(t/=o,e/=o),(l=t*r+e*n)&&(r-=t*l,n-=e*l),(s=Math.sqrt(r*r+n*n))&&(r/=s,n/=s,l/=s),t*n<e*r&&(t=-t,e=-e,l=-l,o=-o),{translateX:i,translateY:a,rotate:Math.atan2(e,t)*B,skewX:Math.atan(l)*B,scaleX:o,scaleY:s}},H=d(h,\"px, \",\"px)\",\"deg)\"),q=d(f,\", \",\")\",\")\"),G=Math.SQRT2,Y=function(t,e){var r,n,i=t[0],a=t[1],o=t[2],s=e[0],l=e[1],u=e[2],c=s-i,h=l-a,f=c*c+h*h;if(f<1e-12)n=Math.log(u/o)/G,r=function(t){return[i+t*c,a+t*h,o*Math.exp(G*t*n)]};else{var d=Math.sqrt(f),g=(u*u-o*o+4*f)/(2*o*2*d),y=(u*u-o*o-4*f)/(2*u*2*d),b=Math.log(Math.sqrt(g*g+1)-g),x=Math.log(Math.sqrt(y*y+1)-y);n=(x-b)/G,r=function(t){var e=t*n,r=p(b),s=o/(2*d)*(r*v(G*e+b)-m(b));return[i+s*c,a+s*h,o*r/p(G*e+b)]}}return r.duration=1e3*n,r},X=g(a),W=g(s),Z=b(a),J=b(s),K=x(a),Q=x(s),$=function(t,e){for(var r=new Array(e),n=0;n<e;++n)r[n]=t(n/(e-1));return r};t.interpolate=j,t.interpolateArray=z,t.interpolateBasis=A,t.interpolateBasisClosed=T,t.interpolateDate=I,t.interpolateNumber=D,t.interpolateObject=P,t.interpolateRound=N,t.interpolateString=F,t.interpolateTransformCss=H,t.interpolateTransformSvg=q,t.interpolateZoom=Y,t.interpolateRgb=E,t.interpolateRgbBasis=L,t.interpolateRgbBasisClosed=C,t.interpolateHsl=X,t.interpolateHslLong=W,t.interpolateLab=y,t.interpolateHcl=Z,t.interpolateHclLong=J,t.interpolateCubehelix=K,t.interpolateCubehelixLong=Q,t.quantize=$,Object.defineProperty(t,\"__esModule\",{value:!0})})},{\"d3-color\":115}],119:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(t,e,r,n){if(isNaN(e)||isNaN(r))return t;var i,a,o,s,l,u,c,h,f,d=t._root,p={data:n},m=t._x0,v=t._y0,g=t._x1,y=t._y1;if(!d)return t._root=p,t;for(;d.length;)if((u=e>=(a=(m+g)/2))?m=a:g=a,(c=r>=(o=(v+y)/2))?v=o:y=o,i=d,!(d=d[h=c<<1|u]))return i[h]=p,t;if(s=+t._x.call(null,d.data),l=+t._y.call(null,d.data),e===s&&r===l)return p.next=d,i?i[h]=p:t._root=p,t;do{i=i?i[h]=new Array(4):t._root=new Array(4),(u=e>=(a=(m+g)/2))?m=a:g=a,(c=r>=(o=(v+y)/2))?v=o:y=o}while((h=c<<1|u)==(f=(l>=o)<<1|s>=a));return i[f]=d,i[h]=p,t}function r(t){var r,n,i,a,o=t.length,s=new Array(o),l=new Array(o),u=1/0,c=1/0,h=-1/0,f=-1/0;for(n=0;n<o;++n)isNaN(i=+this._x.call(null,r=t[n]))||isNaN(a=+this._y.call(null,r))||(s[n]=i,l[n]=a,i<u&&(u=i),i>h&&(h=i),a<c&&(c=a),a>f&&(f=a));for(h<u&&(u=this._x0,h=this._x1),f<c&&(c=this._y0,f=this._y1),this.cover(u,c).cover(h,f),n=0;n<o;++n)e(this,s[n],l[n],t[n]);return this}function n(t){for(var e=0,r=t.length;e<r;++e)this.remove(t[e]);return this}function i(t){return t[0]}function a(t){return t[1]}function o(t,e,r){var n=new s(null==e?i:e,null==r?a:r,NaN,NaN,NaN,NaN);return null==t?n:n.addAll(t)}function s(t,e,r,n,i,a){this._x=t,this._y=e,this._x0=r,this._y0=n,this._x1=i,this._y1=a,this._root=void 0}function l(t){for(var e={data:t.data},r=e;t=t.next;)r=r.next={data:t.data};return e}var u=function(t){var r=+this._x.call(null,t),n=+this._y.call(null,t);return e(this.cover(r,n),r,n,t)},c=function(t,e){if(isNaN(t=+t)||isNaN(e=+e))return this;var r=this._x0,n=this._y0,i=this._x1,a=this._y1;if(isNaN(r))i=(r=Math.floor(t))+1,a=(n=Math.floor(e))+1;else{if(!(r>t||t>i||n>e||e>a))return this;var o,s,l=i-r,u=this._root;switch(s=(e<(n+a)/2)<<1|t<(r+i)/2){case 0:do{o=new Array(4),o[s]=u,u=o}while(l*=2,i=r+l,a=n+l,t>i||e>a);break;case 1:do{o=new Array(4),o[s]=u,u=o}while(l*=2,r=i-l,a=n+l,r>t||e>a);break;case 2:do{o=new Array(4),o[s]=u,u=o}while(l*=2,i=r+l,n=a-l,t>i||n>e);break;case 3:do{o=new Array(4),o[s]=u,u=o}while(l*=2,r=i-l,n=a-l,r>t||n>e)}this._root&&this._root.length&&(this._root=u)}return this._x0=r,this._y0=n,this._x1=i,this._y1=a,this},h=function(){var t=[];return this.visit(function(e){if(!e.length)do{t.push(e.data)}while(e=e.next)}),t},f=function(t){return arguments.length?this.cover(+t[0][0],+t[0][1]).cover(+t[1][0],+t[1][1]):isNaN(this._x0)?void 0:[[this._x0,this._y0],[this._x1,this._y1]]},d=function(t,e,r,n,i){this.node=t,this.x0=e,this.y0=r,this.x1=n,this.y1=i},p=function(t,e,r){var n,i,a,o,s,l,u,c=this._x0,h=this._y0,f=this._x1,p=this._y1,m=[],v=this._root;for(v&&m.push(new d(v,c,h,f,p)),null==r?r=1/0:(c=t-r,h=e-r,f=t+r,p=e+r,r*=r);l=m.pop();)if(!(!(v=l.node)||(i=l.x0)>f||(a=l.y0)>p||(o=l.x1)<c||(s=l.y1)<h))if(v.length){var g=(i+o)/2,y=(a+s)/2;m.push(new d(v[3],g,y,o,s),new d(v[2],i,y,g,s),new d(v[1],g,a,o,y),new d(v[0],i,a,g,y)),(u=(e>=y)<<1|t>=g)&&(l=m[m.length-1],m[m.length-1]=m[m.length-1-u],m[m.length-1-u]=l)}else{var b=t-+this._x.call(null,v.data),x=e-+this._y.call(null,v.data),_=b*b+x*x;if(_<r){var w=Math.sqrt(r=_);c=t-w,h=e-w,f=t+w,p=e+w,n=v.data}}return n},m=function(t){if(isNaN(a=+this._x.call(null,t))||isNaN(o=+this._y.call(null,t)))return this;var e,r,n,i,a,o,s,l,u,c,h,f,d=this._root,p=this._x0,m=this._y0,v=this._x1,g=this._y1;if(!d)return this;if(d.length)for(;;){if((u=a>=(s=(p+v)/2))?p=s:v=s,(c=o>=(l=(m+g)/2))?m=l:g=l,e=d,!(d=d[h=c<<1|u]))return this;if(!d.length)break;(e[h+1&3]||e[h+2&3]||e[h+3&3])&&(r=e,f=h)}for(;d.data!==t;)if(n=d,!(d=d.next))return this;return(i=d.next)&&delete d.next,n?(i?n.next=i:delete n.next,this):e?(i?e[h]=i:delete e[h],(d=e[0]||e[1]||e[2]||e[3])&&d===(e[3]||e[2]||e[1]||e[0])&&!d.length&&(r?r[f]=d:this._root=d),this):(this._root=i,this)},v=function(){return this._root},g=function(){var t=0;return this.visit(function(e){if(!e.length)do{++t}while(e=e.next)}),t},y=function(t){var e,r,n,i,a,o,s=[],l=this._root;for(l&&s.push(new d(l,this._x0,this._y0,this._x1,this._y1));e=s.pop();)if(!t(l=e.node,n=e.x0,i=e.y0,a=e.x1,o=e.y1)&&l.length){var u=(n+a)/2,c=(i+o)/2;(r=l[3])&&s.push(new d(r,u,c,a,o)),(r=l[2])&&s.push(new d(r,n,c,u,o)),(r=l[1])&&s.push(new d(r,u,i,a,c)),(r=l[0])&&s.push(new d(r,n,i,u,c))}return this},b=function(t){var e,r=[],n=[];for(this._root&&r.push(new d(this._root,this._x0,this._y0,this._x1,this._y1));e=r.pop();){var i=e.node;if(i.length){var a,o=e.x0,s=e.y0,l=e.x1,u=e.y1,c=(o+l)/2,h=(s+u)/2;(a=i[0])&&r.push(new d(a,o,s,c,h)),(a=i[1])&&r.push(new d(a,c,s,l,h)),(a=i[2])&&r.push(new d(a,o,h,c,u)),(a=i[3])&&r.push(new d(a,c,h,l,u))}n.push(e)}for(;e=n.pop();)t(e.node,e.x0,e.y0,e.x1,e.y1);return this},x=function(t){return arguments.length?(this._x=t,this):this._x},_=function(t){return arguments.length?(this._y=t,this):this._y},w=o.prototype=s.prototype;w.copy=function(){var t,e,r=new s(this._x,this._y,this._x0,this._y0,this._x1,this._y1),n=this._root;if(!n)return r;if(!n.length)return r._root=l(n),r;for(t=[{source:n,target:r._root=new Array(4)}];n=t.pop();)for(var i=0;i<4;++i)(e=n.source[i])&&(e.length?t.push({source:e,target:n.target[i]=new Array(4)}):n.target[i]=l(e));return r},w.add=u,w.addAll=r,w.cover=c,w.data=h,w.extent=f,w.find=p,w.remove=m,w.removeAll=n,w.root=v,w.size=g,w.visit=y,w.visitAfter=b,w.x=x,w.y=_,t.quadtree=o,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],120:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.d3=e.d3||{})}(this,function(t){\"use strict\";function e(){return g||(x(r),g=b.now()+y)}function r(){g=0}function n(){this._call=this._time=this._next=null}function i(t,e,r){var i=new n;return i.restart(t,e,r),i}function a(){e(),++f;for(var t,r=c;r;)(t=g-r._time)>=0&&r._call.call(null,t),r=r._next;--f}function o(){g=(v=b.now())+y,f=d=0;try{a()}finally{f=0,l(),g=0}}function s(){var t=b.now(),e=t-v;e>m&&(y-=e,v=t)}function l(){for(var t,e,r=c,n=1/0;r;)r._call?(n>r._time&&(n=r._time),t=r,r=r._next):(e=r._next,r._next=null,r=t?t._next=e:c=e);h=t,u(n)}function u(t){if(!f){d&&(d=clearTimeout(d));var e=t-g;e>24?(t<1/0&&(d=setTimeout(o,e)),p&&(p=clearInterval(p))):(p||(v=g,p=setInterval(s,m)),f=1,x(o))}}var c,h,f=0,d=0,p=0,m=1e3,v=0,g=0,y=0,b=\"object\"==typeof performance&&performance.now?performance:Date,x=\"function\"==typeof requestAnimationFrame?requestAnimationFrame:function(t){setTimeout(t,17)};n.prototype=i.prototype={constructor:n,restart:function(t,r,n){if(\"function\"!=typeof t)throw new TypeError(\"callback is not a function\");n=(null==n?e():+n)+(null==r?0:+r),this._next||h===this||(h?h._next=this:c=this,h=this),this._call=t,this._time=n,u()},stop:function(){this._call&&(this._call=null,this._time=1/0,u())}};var _=function(t,e,r){var i=new n;return e=null==e?0:+e,i.restart(function(r){i.stop(),t(r+e)},e,r),i},w=function(t,r,i){var a=new n,o=r;return null==r?(a.restart(t,r,i),a):(r=+r,i=null==i?e():+i,a.restart(function e(n){n+=o,a.restart(e,o+=r,i),t(n)},r,i),a)};t.now=e,t.timer=i,t.timerFlush=a,t.timeout=_,t.interval=w,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],121:[function(e,r,n){!function(){function e(t){return t&&(t.ownerDocument||t.document||t).documentElement}function n(t){return t&&(t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView)}function i(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}function a(t){return null===t?NaN:+t}function o(t){return!isNaN(t)}function s(t){return{left:function(e,r,n,i){for(arguments.length<3&&(n=0),arguments.length<4&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)<0?n=a+1:i=a}return n},right:function(e,r,n,i){for(arguments.length<3&&(n=0),arguments.length<4&&(i=e.length);n<i;){var a=n+i>>>1;t(e[a],r)>0?i=a:n=a+1}return n}}}function l(t){return t.length}function u(t){for(var e=1;t*e%1;)e*=10;return e}function c(t,e){for(var r in e)Object.defineProperty(t.prototype,r,{value:e[r],enumerable:!1})}function h(){this._=Object.create(null)}function f(t){return(t+=\"\")===_o||t[0]===wo?wo+t:t}function d(t){return(t+=\"\")[0]===wo?t.slice(1):t}function p(t){return f(t)in this._}function m(t){return(t=f(t))in this._&&delete this._[t]}function v(){var t=[];for(var e in this._)t.push(d(e));return t}function g(){var t=0;for(var e in this._)++t;return t}function y(){for(var t in this._)return!1;return!0}function b(){this._=Object.create(null)}function x(t){return t}function _(t,e,r){return function(){var n=r.apply(e,arguments);return n===e?t:n}}function w(t,e){if(e in t)return e;e=e.charAt(0).toUpperCase()+e.slice(1);for(var r=0,n=Mo.length;r<n;++r){var i=Mo[r]+e;if(i in t)return i}}function M(){}function k(){}function A(t){function e(){for(var e,n=r,i=-1,a=n.length;++i<a;)(e=n[i].on)&&e.apply(this,arguments);return t}var r=[],n=new h;return e.on=function(e,i){var a,o=n.get(e);return arguments.length<2?o&&o.on:(o&&(o.on=null,r=r.slice(0,a=r.indexOf(o)).concat(r.slice(a+1)),n.remove(e)),i&&r.push(n.set(e,{on:i})),t)},e}function T(){uo.event.preventDefault()}function S(){for(var t,e=uo.event;t=e.sourceEvent;)e=t;return e}function E(t){for(var e=new k,r=0,n=arguments.length;++r<n;)e[arguments[r]]=A(e);return e.of=function(r,n){return function(i){try{var a=i.sourceEvent=uo.event;i.target=t,uo.event=i,e[i.type].apply(r,n)}finally{uo.event=a}}},e}function L(t){return Ao(t,Lo),t}function C(t){return\"function\"==typeof t?t:function(){return To(t,this)}}function z(t){return\"function\"==typeof t?t:function(){return So(t,this)}}function I(t,e){function r(){this.removeAttribute(t)}function n(){this.removeAttributeNS(t.space,t.local)}function i(){this.setAttribute(t,e)}function a(){this.setAttributeNS(t.space,t.local,e)}function o(){var r=e.apply(this,arguments);null==r?this.removeAttribute(t):this.setAttribute(t,r)}function s(){var r=e.apply(this,arguments);null==r?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,r)}return t=uo.ns.qualify(t),null==e?t.local?n:r:\"function\"==typeof e?t.local?s:o:t.local?a:i}function D(t){return t.trim().replace(/\\s+/g,\" \")}function P(t){return new RegExp(\"(?:^|\\\\s+)\"+uo.requote(t)+\"(?:\\\\s+|$)\",\"g\")}function O(t){return(t+\"\").trim().split(/^|\\s+/)}function R(t,e){function r(){for(var r=-1;++r<i;)t[r](this,e)}function n(){for(var r=-1,n=e.apply(this,arguments);++r<i;)t[r](this,n)}t=O(t).map(F);var i=t.length;return\"function\"==typeof e?n:r}function F(t){var e=P(t);return function(r,n){if(i=r.classList)return n?i.add(t):i.remove(t);var i=r.getAttribute(\"class\")||\"\";n?(e.lastIndex=0,e.test(i)||r.setAttribute(\"class\",D(i+\" \"+t))):r.setAttribute(\"class\",D(i.replace(e,\" \")))}}function j(t,e,r){function n(){this.style.removeProperty(t)}function i(){this.style.setProperty(t,e,r)}function a(){var n=e.apply(this,arguments);null==n?this.style.removeProperty(t):this.style.setProperty(t,n,r)}return null==e?n:\"function\"==typeof e?a:i}function N(t,e){function r(){delete this[t]}function n(){this[t]=e}function i(){var r=e.apply(this,arguments);null==r?delete this[t]:this[t]=r}return null==e?r:\"function\"==typeof e?i:n}function B(t){function e(){var e=this.ownerDocument,r=this.namespaceURI;return r===Co&&e.documentElement.namespaceURI===Co?e.createElement(t):e.createElementNS(r,t)}function r(){return this.ownerDocument.createElementNS(t.space,t.local)}return\"function\"==typeof t?t:(t=uo.ns.qualify(t)).local?r:e}function U(){var t=this.parentNode;t&&t.removeChild(this)}function V(t){return{__data__:t}}function H(t){return function(){return Eo(this,t)}}function q(t){return arguments.length||(t=i),function(e,r){return e&&r?t(e.__data__,r.__data__):!e-!r}}function G(t,e){for(var r=0,n=t.length;r<n;r++)for(var i,a=t[r],o=0,s=a.length;o<s;o++)(i=a[o])&&e(i,o,r);return t}function Y(t){return Ao(t,Io),t}function X(t){var e,r;return function(n,i,a){var o,s=t[a].update,l=s.length;for(a!=r&&(r=a,e=0),i>=e&&(e=i+1);!(o=s[e])&&++e<l;);return o}}function W(t,e,r){function n(){var e=this[o];e&&(this.removeEventListener(t,e,e.$),delete this[o])}function i(){var i=l(e,ho(arguments));n.call(this),this.addEventListener(t,this[o]=i,i.$=r),i._=e}function a(){var e,r=new RegExp(\"^__on([^.]+)\"+uo.requote(t)+\"$\");for(var n in this)if(e=n.match(r)){var i=this[n];this.removeEventListener(e[1],i,i.$),delete this[n]}}var o=\"__on\"+t,s=t.indexOf(\".\"),l=Z;s>0&&(t=t.slice(0,s));var u=Do.get(t);return u&&(t=u,l=J),s?e?i:n:e?M:a}function Z(t,e){return function(r){var n=uo.event;uo.event=r,e[0]=this.__data__;try{t.apply(this,e)}finally{uo.event=n}}}function J(t,e){var r=Z(t,e);return function(t){var e=this,n=t.relatedTarget;n&&(n===e||8&n.compareDocumentPosition(e))||r.call(e,t)}}function K(t){var r=\".dragsuppress-\"+ ++Oo,i=\"click\"+r,a=uo.select(n(t)).on(\"touchmove\"+r,T).on(\"dragstart\"+r,T).on(\"selectstart\"+r,T);if(null==Po&&(Po=!(\"onselectstart\"in t)&&w(t.style,\"userSelect\")),Po){var o=e(t).style,s=o[Po];o[Po]=\"none\"}return function(t){if(a.on(r,null),Po&&(o[Po]=s),t){var e=function(){a.on(i,null)};a.on(i,function(){T(),e()},!0),setTimeout(e,0)}}}function Q(t,e){e.changedTouches&&(e=e.changedTouches[0]);var r=t.ownerSVGElement||t;if(r.createSVGPoint){var i=r.createSVGPoint();if(Ro<0){var a=n(t);if(a.scrollX||a.scrollY){r=uo.select(\"body\").append(\"svg\").style({position:\"absolute\",top:0,left:0,margin:0,padding:0,border:\"none\"},\"important\");var o=r[0][0].getScreenCTM();Ro=!(o.f||o.e),r.remove()}}return Ro?(i.x=e.pageX,i.y=e.pageY):(i.x=e.clientX,i.y=e.clientY),i=i.matrixTransform(t.getScreenCTM().inverse()),[i.x,i.y]}var s=t.getBoundingClientRect();return[e.clientX-s.left-t.clientLeft,e.clientY-s.top-t.clientTop]}function $(){return uo.event.changedTouches[0].identifier}function tt(t){return t>0?1:t<0?-1:0}function et(t,e,r){return(e[0]-t[0])*(r[1]-t[1])-(e[1]-t[1])*(r[0]-t[0])}function rt(t){return t>1?0:t<-1?No:Math.acos(t)}function nt(t){return t>1?Vo:t<-1?-Vo:Math.asin(t)}function it(t){return((t=Math.exp(t))-1/t)/2}function at(t){return((t=Math.exp(t))+1/t)/2}function ot(t){return((t=Math.exp(2*t))-1)/(t+1)}function st(t){return(t=Math.sin(t/2))*t}function lt(){}function ut(t,e,r){return this instanceof ut?(this.h=+t,this.s=+e,void(this.l=+r)):arguments.length<2?t instanceof ut?new ut(t.h,t.s,t.l):Mt(\"\"+t,kt,ut):new ut(t,e,r)}function ct(t,e,r){function n(t){return t>360?t-=360:t<0&&(t+=360),t<60?a+(o-a)*t/60:t<180?o:t<240?a+(o-a)*(240-t)/60:a}function i(t){return Math.round(255*n(t))}var a,o;return t=isNaN(t)?0:(t%=360)<0?t+360:t,e=isNaN(e)?0:e<0?0:e>1?1:e,r=r<0?0:r>1?1:r,o=r<=.5?r*(1+e):r+e-r*e,a=2*r-o,new bt(i(t+120),i(t),i(t-120))}function ht(t,e,r){return this instanceof ht?(this.h=+t,this.c=+e,void(this.l=+r)):arguments.length<2?t instanceof ht?new ht(t.h,t.c,t.l):t instanceof dt?mt(t.l,t.a,t.b):mt((t=At((t=uo.rgb(t)).r,t.g,t.b)).l,t.a,t.b):new ht(t,e,r)}function ft(t,e,r){return isNaN(t)&&(t=0),isNaN(e)&&(e=0),new dt(r,Math.cos(t*=Ho)*e,Math.sin(t)*e)}function dt(t,e,r){return this instanceof dt?(this.l=+t,this.a=+e,void(this.b=+r)):arguments.length<2?t instanceof dt?new dt(t.l,t.a,t.b):t instanceof ht?ft(t.h,t.c,t.l):At((t=bt(t)).r,t.g,t.b):new dt(t,e,r)}function pt(t,e,r){var n=(t+16)/116,i=n+e/500,a=n-r/200;return i=vt(i)*Qo,n=vt(n)*$o,a=vt(a)*ts,new bt(yt(3.2404542*i-1.5371385*n-.4985314*a),yt(-.969266*i+1.8760108*n+.041556*a),yt(.0556434*i-.2040259*n+1.0572252*a))}function mt(t,e,r){return t>0?new ht(Math.atan2(r,e)*qo,Math.sqrt(e*e+r*r),t):new ht(NaN,NaN,t)}function vt(t){return t>.206893034?t*t*t:(t-4/29)/7.787037}function gt(t){return t>.008856?Math.pow(t,1/3):7.787037*t+4/29}function yt(t){return Math.round(255*(t<=.00304?12.92*t:1.055*Math.pow(t,1/2.4)-.055))}function bt(t,e,r){return this instanceof bt?(this.r=~~t,this.g=~~e,void(this.b=~~r)):arguments.length<2?t instanceof bt?new bt(t.r,t.g,t.b):Mt(\"\"+t,bt,ct):new bt(t,e,r)}function xt(t){return new bt(t>>16,t>>8&255,255&t)}function _t(t){return xt(t)+\"\"}function wt(t){return t<16?\"0\"+Math.max(0,t).toString(16):Math.min(255,t).toString(16)}function Mt(t,e,r){var n,i,a,o=0,s=0,l=0;if(n=/([a-z]+)\\((.*)\\)/.exec(t=t.toLowerCase()))switch(i=n[2].split(\",\"),n[1]){case\"hsl\":return r(parseFloat(i[0]),parseFloat(i[1])/100,parseFloat(i[2])/100);case\"rgb\":return e(St(i[0]),St(i[1]),St(i[2]))}return(a=ns.get(t))?e(a.r,a.g,a.b):(null==t||\"#\"!==t.charAt(0)||isNaN(a=parseInt(t.slice(1),16))||(4===t.length?(o=(3840&a)>>4,o|=o>>4,s=240&a,s|=s>>4,l=15&a,l|=l<<4):7===t.length&&(o=(16711680&a)>>16,s=(65280&a)>>8,l=255&a)),e(o,s,l))}function kt(t,e,r){var n,i,a=Math.min(t/=255,e/=255,r/=255),o=Math.max(t,e,r),s=o-a,l=(o+a)/2;return s?(i=l<.5?s/(o+a):s/(2-o-a),n=t==o?(e-r)/s+(e<r?6:0):e==o?(r-t)/s+2:(t-e)/s+4,n*=60):(n=NaN,i=l>0&&l<1?0:n),new ut(n,i,l)}function At(t,e,r){t=Tt(t),e=Tt(e),r=Tt(r);var n=gt((.4124564*t+.3575761*e+.1804375*r)/Qo),i=gt((.2126729*t+.7151522*e+.072175*r)/$o);return dt(116*i-16,500*(n-i),200*(i-gt((.0193339*t+.119192*e+.9503041*r)/ts)))}function Tt(t){return(t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function St(t){var e=parseFloat(t);return\"%\"===t.charAt(t.length-1)?Math.round(2.55*e):e}function Et(t){return\"function\"==typeof t?t:function(){return t}}\n",
       "function Lt(t){return function(e,r,n){return 2===arguments.length&&\"function\"==typeof r&&(n=r,r=null),Ct(e,r,t,n)}}function Ct(t,e,r,n){function i(){var t,e=l.status;if(!e&&It(l)||e>=200&&e<300||304===e){try{t=r.call(a,l)}catch(t){return void o.error.call(a,t)}o.load.call(a,t)}else o.error.call(a,l)}var a={},o=uo.dispatch(\"beforesend\",\"progress\",\"load\",\"error\"),s={},l=new XMLHttpRequest,u=null;return!this.XDomainRequest||\"withCredentials\"in l||!/^(http(s)?:)?\\/\\//.test(t)||(l=new XDomainRequest),\"onload\"in l?l.onload=l.onerror=i:l.onreadystatechange=function(){l.readyState>3&&i()},l.onprogress=function(t){var e=uo.event;uo.event=t;try{o.progress.call(a,l)}finally{uo.event=e}},a.header=function(t,e){return t=(t+\"\").toLowerCase(),arguments.length<2?s[t]:(null==e?delete s[t]:s[t]=e+\"\",a)},a.mimeType=function(t){return arguments.length?(e=null==t?null:t+\"\",a):e},a.responseType=function(t){return arguments.length?(u=t,a):u},a.response=function(t){return r=t,a},[\"get\",\"post\"].forEach(function(t){a[t]=function(){return a.send.apply(a,[t].concat(ho(arguments)))}}),a.send=function(r,n,i){if(2===arguments.length&&\"function\"==typeof n&&(i=n,n=null),l.open(r,t,!0),null==e||\"accept\"in s||(s.accept=e+\",*/*\"),l.setRequestHeader)for(var c in s)l.setRequestHeader(c,s[c]);return null!=e&&l.overrideMimeType&&l.overrideMimeType(e),null!=u&&(l.responseType=u),null!=i&&a.on(\"error\",i).on(\"load\",function(t){i(null,t)}),o.beforesend.call(a,l),l.send(null==n?null:n),a},a.abort=function(){return l.abort(),a},uo.rebind(a,o,\"on\"),null==n?a:a.get(zt(n))}function zt(t){return 1===t.length?function(e,r){t(null==e?r:null)}:t}function It(t){var e=t.responseType;return e&&\"text\"!==e?t.response:t.responseText}function Dt(t,e,r){var n=arguments.length;n<2&&(e=0),n<3&&(r=Date.now());var i=r+e,a={c:t,t:i,n:null};return as?as.n=a:is=a,as=a,os||(ss=clearTimeout(ss),os=1,ls(Pt)),a}function Pt(){var t=Ot(),e=Rt()-t;e>24?(isFinite(e)&&(clearTimeout(ss),ss=setTimeout(Pt,e)),os=0):(os=1,ls(Pt))}function Ot(){for(var t=Date.now(),e=is;e;)t>=e.t&&e.c(t-e.t)&&(e.c=null),e=e.n;return t}function Rt(){for(var t,e=is,r=1/0;e;)e.c?(e.t<r&&(r=e.t),e=(t=e).n):e=t?t.n=e.n:is=e.n;return as=t,r}function Ft(t,e){return e-(t?Math.ceil(Math.log(t)/Math.LN10):1)}function jt(t,e){var r=Math.pow(10,3*xo(8-e));return{scale:e>8?function(t){return t/r}:function(t){return t*r},symbol:t}}function Nt(t){var e=t.decimal,r=t.thousands,n=t.grouping,i=t.currency,a=n&&r?function(t,e){for(var i=t.length,a=[],o=0,s=n[0],l=0;i>0&&s>0&&(l+s+1>e&&(s=Math.max(1,e-l)),a.push(t.substring(i-=s,i+s)),!((l+=s+1)>e));)s=n[o=(o+1)%n.length];return a.reverse().join(r)}:x;return function(t){var r=cs.exec(t),n=r[1]||\" \",o=r[2]||\">\",s=r[3]||\"-\",l=r[4]||\"\",u=r[5],c=+r[6],h=r[7],f=r[8],d=r[9],p=1,m=\"\",v=\"\",g=!1,y=!0;switch(f&&(f=+f.substring(1)),(u||\"0\"===n&&\"=\"===o)&&(u=n=\"0\",o=\"=\"),d){case\"n\":h=!0,d=\"g\";break;case\"%\":p=100,v=\"%\",d=\"f\";break;case\"p\":p=100,v=\"%\",d=\"r\";break;case\"b\":case\"o\":case\"x\":case\"X\":\"#\"===l&&(m=\"0\"+d.toLowerCase());case\"c\":y=!1;case\"d\":g=!0,f=0;break;case\"s\":p=-1,d=\"r\"}\"$\"===l&&(m=i[0],v=i[1]),\"r\"!=d||f||(d=\"g\"),null!=f&&(\"g\"==d?f=Math.max(1,Math.min(21,f)):\"e\"!=d&&\"f\"!=d||(f=Math.max(0,Math.min(20,f)))),d=hs.get(d)||Bt;var b=u&&h;return function(t){var r=v;if(g&&t%1)return\"\";var i=t<0||0===t&&1/t<0?(t=-t,\"-\"):\"-\"===s?\"\":s;if(p<0){var l=uo.formatPrefix(t,f);t=l.scale(t),r=l.symbol+v}else t*=p;t=d(t,f);var x,_,w=t.lastIndexOf(\".\");if(w<0){var M=y?t.lastIndexOf(\"e\"):-1;M<0?(x=t,_=\"\"):(x=t.substring(0,M),_=t.substring(M))}else x=t.substring(0,w),_=e+t.substring(w+1);!u&&h&&(x=a(x,1/0));var k=m.length+x.length+_.length+(b?0:i.length),A=k<c?new Array(k=c-k+1).join(n):\"\";return b&&(x=a(A+x,A.length?c-_.length:1/0)),i+=m,t=x+_,(\"<\"===o?i+t+A:\">\"===o?A+i+t:\"^\"===o?A.substring(0,k>>=1)+i+t+A.substring(k):i+(b?t:A+t))+r}}}function Bt(t){return t+\"\"}function Ut(){this._=new Date(arguments.length>1?Date.UTC.apply(this,arguments):arguments[0])}function Vt(t,e,r){function n(e){var r=t(e),n=a(r,1);return e-r<n-e?r:n}function i(r){return e(r=t(new ds(r-1)),1),r}function a(t,r){return e(t=new ds(+t),r),t}function o(t,n,a){var o=i(t),s=[];if(a>1)for(;o<n;)r(o)%a||s.push(new Date(+o)),e(o,1);else for(;o<n;)s.push(new Date(+o)),e(o,1);return s}function s(t,e,r){try{ds=Ut;var n=new Ut;return n._=t,o(n,e,r)}finally{ds=Date}}t.floor=t,t.round=n,t.ceil=i,t.offset=a,t.range=o;var l=t.utc=Ht(t);return l.floor=l,l.round=Ht(n),l.ceil=Ht(i),l.offset=Ht(a),l.range=s,t}function Ht(t){return function(e,r){try{ds=Ut;var n=new Ut;return n._=e,t(n,r)._}finally{ds=Date}}}function qt(t){function e(t){function e(e){for(var r,i,a,o=[],s=-1,l=0;++s<n;)37===t.charCodeAt(s)&&(o.push(t.slice(l,s)),null!=(i=ms[r=t.charAt(++s)])&&(r=t.charAt(++s)),(a=E[r])&&(r=a(e,null==i?\"e\"===r?\" \":\"0\":i)),o.push(r),l=s+1);return o.push(t.slice(l,s)),o.join(\"\")}var n=t.length;return e.parse=function(e){var n={y:1900,m:0,d:1,H:0,M:0,S:0,L:0,Z:null};if(r(n,t,e,0)!=e.length)return null;\"p\"in n&&(n.H=n.H%12+12*n.p);var i=null!=n.Z&&ds!==Ut,a=new(i?Ut:ds);return\"j\"in n?a.setFullYear(n.y,0,n.j):\"W\"in n||\"U\"in n?(\"w\"in n||(n.w=\"W\"in n?1:0),a.setFullYear(n.y,0,1),a.setFullYear(n.y,0,\"W\"in n?(n.w+6)%7+7*n.W-(a.getDay()+5)%7:n.w+7*n.U-(a.getDay()+6)%7)):a.setFullYear(n.y,n.m,n.d),a.setHours(n.H+(n.Z/100|0),n.M+n.Z%100,n.S,n.L),i?a._:a},e.toString=function(){return t},e}function r(t,e,r,n){for(var i,a,o,s=0,l=e.length,u=r.length;s<l;){if(n>=u)return-1;if(37===(i=e.charCodeAt(s++))){if(o=e.charAt(s++),!(a=L[o in ms?e.charAt(s++):o])||(n=a(t,r,n))<0)return-1}else if(i!=r.charCodeAt(n++))return-1}return n}function n(t,e,r){w.lastIndex=0;var n=w.exec(e.slice(r));return n?(t.w=M.get(n[0].toLowerCase()),r+n[0].length):-1}function i(t,e,r){x.lastIndex=0;var n=x.exec(e.slice(r));return n?(t.w=_.get(n[0].toLowerCase()),r+n[0].length):-1}function a(t,e,r){T.lastIndex=0;var n=T.exec(e.slice(r));return n?(t.m=S.get(n[0].toLowerCase()),r+n[0].length):-1}function o(t,e,r){k.lastIndex=0;var n=k.exec(e.slice(r));return n?(t.m=A.get(n[0].toLowerCase()),r+n[0].length):-1}function s(t,e,n){return r(t,E.c.toString(),e,n)}function l(t,e,n){return r(t,E.x.toString(),e,n)}function u(t,e,n){return r(t,E.X.toString(),e,n)}function c(t,e,r){var n=b.get(e.slice(r,r+=2).toLowerCase());return null==n?-1:(t.p=n,r)}var h=t.dateTime,f=t.date,d=t.time,p=t.periods,m=t.days,v=t.shortDays,g=t.months,y=t.shortMonths;e.utc=function(t){function r(t){try{ds=Ut;var e=new ds;return e._=t,n(e)}finally{ds=Date}}var n=e(t);return r.parse=function(t){try{ds=Ut;var e=n.parse(t);return e&&e._}finally{ds=Date}},r.toString=n.toString,r},e.multi=e.utc.multi=ce;var b=uo.map(),x=Yt(m),_=Xt(m),w=Yt(v),M=Xt(v),k=Yt(g),A=Xt(g),T=Yt(y),S=Xt(y);p.forEach(function(t,e){b.set(t.toLowerCase(),e)});var E={a:function(t){return v[t.getDay()]},A:function(t){return m[t.getDay()]},b:function(t){return y[t.getMonth()]},B:function(t){return g[t.getMonth()]},c:e(h),d:function(t,e){return Gt(t.getDate(),e,2)},e:function(t,e){return Gt(t.getDate(),e,2)},H:function(t,e){return Gt(t.getHours(),e,2)},I:function(t,e){return Gt(t.getHours()%12||12,e,2)},j:function(t,e){return Gt(1+fs.dayOfYear(t),e,3)},L:function(t,e){return Gt(t.getMilliseconds(),e,3)},m:function(t,e){return Gt(t.getMonth()+1,e,2)},M:function(t,e){return Gt(t.getMinutes(),e,2)},p:function(t){return p[+(t.getHours()>=12)]},S:function(t,e){return Gt(t.getSeconds(),e,2)},U:function(t,e){return Gt(fs.sundayOfYear(t),e,2)},w:function(t){return t.getDay()},W:function(t,e){return Gt(fs.mondayOfYear(t),e,2)},x:e(f),X:e(d),y:function(t,e){return Gt(t.getFullYear()%100,e,2)},Y:function(t,e){return Gt(t.getFullYear()%1e4,e,4)},Z:le,\"%\":function(){return\"%\"}},L={a:n,A:i,b:a,B:o,c:s,d:re,e:re,H:ie,I:ie,j:ne,L:se,m:ee,M:ae,p:c,S:oe,U:Zt,w:Wt,W:Jt,x:l,X:u,y:Qt,Y:Kt,Z:$t,\"%\":ue};return e}function Gt(t,e,r){var n=t<0?\"-\":\"\",i=(n?-t:t)+\"\",a=i.length;return n+(a<r?new Array(r-a+1).join(e)+i:i)}function Yt(t){return new RegExp(\"^(?:\"+t.map(uo.requote).join(\"|\")+\")\",\"i\")}function Xt(t){for(var e=new h,r=-1,n=t.length;++r<n;)e.set(t[r].toLowerCase(),r);return e}function Wt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+1));return n?(t.w=+n[0],r+n[0].length):-1}function Zt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r));return n?(t.U=+n[0],r+n[0].length):-1}function Jt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r));return n?(t.W=+n[0],r+n[0].length):-1}function Kt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+4));return n?(t.y=+n[0],r+n[0].length):-1}function Qt(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.y=te(+n[0]),r+n[0].length):-1}function $t(t,e,r){return/^[+-]\\d{4}$/.test(e=e.slice(r,r+5))?(t.Z=-e,r+5):-1}function te(t){return t+(t>68?1900:2e3)}function ee(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.m=n[0]-1,r+n[0].length):-1}function re(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.d=+n[0],r+n[0].length):-1}function ne(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+3));return n?(t.j=+n[0],r+n[0].length):-1}function ie(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.H=+n[0],r+n[0].length):-1}function ae(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.M=+n[0],r+n[0].length):-1}function oe(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+2));return n?(t.S=+n[0],r+n[0].length):-1}function se(t,e,r){vs.lastIndex=0;var n=vs.exec(e.slice(r,r+3));return n?(t.L=+n[0],r+n[0].length):-1}function le(t){var e=t.getTimezoneOffset(),r=e>0?\"-\":\"+\",n=xo(e)/60|0,i=xo(e)%60;return r+Gt(n,\"0\",2)+Gt(i,\"0\",2)}function ue(t,e,r){gs.lastIndex=0;var n=gs.exec(e.slice(r,r+1));return n?r+n[0].length:-1}function ce(t){for(var e=t.length,r=-1;++r<e;)t[r][0]=this(t[r][0]);return function(e){for(var r=0,n=t[r];!n[1](e);)n=t[++r];return n[0](e)}}function he(){}function fe(t,e,r){var n=r.s=t+e,i=n-t,a=n-i;r.t=t-a+(e-i)}function de(t,e){t&&_s.hasOwnProperty(t.type)&&_s[t.type](t,e)}function pe(t,e,r){var n,i=-1,a=t.length-r;for(e.lineStart();++i<a;)n=t[i],e.point(n[0],n[1],n[2]);e.lineEnd()}function me(t,e){var r=-1,n=t.length;for(e.polygonStart();++r<n;)pe(t[r],e,1);e.polygonEnd()}function ve(){function t(t,e){t*=Ho,e=e*Ho/2+No/4;var r=t-n,o=r>=0?1:-1,s=o*r,l=Math.cos(e),u=Math.sin(e),c=a*u,h=i*l+c*Math.cos(s),f=c*o*Math.sin(s);Ms.add(Math.atan2(f,h)),n=t,i=l,a=u}var e,r,n,i,a;ks.point=function(o,s){ks.point=t,n=(e=o)*Ho,i=Math.cos(s=(r=s)*Ho/2+No/4),a=Math.sin(s)},ks.lineEnd=function(){t(e,r)}}function ge(t){var e=t[0],r=t[1],n=Math.cos(r);return[n*Math.cos(e),n*Math.sin(e),Math.sin(r)]}function ye(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}function be(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]}function xe(t,e){t[0]+=e[0],t[1]+=e[1],t[2]+=e[2]}function _e(t,e){return[t[0]*e,t[1]*e,t[2]*e]}function we(t){var e=Math.sqrt(t[0]*t[0]+t[1]*t[1]+t[2]*t[2]);t[0]/=e,t[1]/=e,t[2]/=e}function Me(t){return[Math.atan2(t[1],t[0]),nt(t[2])]}function ke(t,e){return xo(t[0]-e[0])<Fo&&xo(t[1]-e[1])<Fo}function Ae(t,e){t*=Ho;var r=Math.cos(e*=Ho);Te(r*Math.cos(t),r*Math.sin(t),Math.sin(e))}function Te(t,e,r){++As,Ss+=(t-Ss)/As,Es+=(e-Es)/As,Ls+=(r-Ls)/As}function Se(){function t(t,i){t*=Ho;var a=Math.cos(i*=Ho),o=a*Math.cos(t),s=a*Math.sin(t),l=Math.sin(i),u=Math.atan2(Math.sqrt((u=r*l-n*s)*u+(u=n*o-e*l)*u+(u=e*s-r*o)*u),e*o+r*s+n*l);Ts+=u,Cs+=u*(e+(e=o)),zs+=u*(r+(r=s)),Is+=u*(n+(n=l)),Te(e,r,n)}var e,r,n;Rs.point=function(i,a){i*=Ho;var o=Math.cos(a*=Ho);e=o*Math.cos(i),r=o*Math.sin(i),n=Math.sin(a),Rs.point=t,Te(e,r,n)}}function Ee(){Rs.point=Ae}function Le(){function t(t,e){t*=Ho;var r=Math.cos(e*=Ho),o=r*Math.cos(t),s=r*Math.sin(t),l=Math.sin(e),u=i*l-a*s,c=a*o-n*l,h=n*s-i*o,f=Math.sqrt(u*u+c*c+h*h),d=n*o+i*s+a*l,p=f&&-rt(d)/f,m=Math.atan2(f,d);Ds+=p*u,Ps+=p*c,Os+=p*h,Ts+=m,Cs+=m*(n+(n=o)),zs+=m*(i+(i=s)),Is+=m*(a+(a=l)),Te(n,i,a)}var e,r,n,i,a;Rs.point=function(o,s){e=o,r=s,Rs.point=t,o*=Ho;var l=Math.cos(s*=Ho);n=l*Math.cos(o),i=l*Math.sin(o),a=Math.sin(s),Te(n,i,a)},Rs.lineEnd=function(){t(e,r),Rs.lineEnd=Ee,Rs.point=Ae}}function Ce(t,e){function r(r,n){return r=t(r,n),e(r[0],r[1])}return t.invert&&e.invert&&(r.invert=function(r,n){return(r=e.invert(r,n))&&t.invert(r[0],r[1])}),r}function ze(){return!0}function Ie(t,e,r,n,i){var a=[],o=[];if(t.forEach(function(t){if(!((e=t.length-1)<=0)){var e,r=t[0],n=t[e];if(ke(r,n)){i.lineStart();for(var s=0;s<e;++s)i.point((r=t[s])[0],r[1]);return void i.lineEnd()}var l=new Pe(r,t,null,!0),u=new Pe(r,null,l,!1);l.o=u,a.push(l),o.push(u),l=new Pe(n,t,null,!1),u=new Pe(n,null,l,!0),l.o=u,a.push(l),o.push(u)}}),o.sort(e),De(a),De(o),a.length){for(var s=0,l=r,u=o.length;s<u;++s)o[s].e=l=!l;for(var c,h,f=a[0];;){for(var d=f,p=!0;d.v;)if((d=d.n)===f)return;c=d.z,i.lineStart();do{if(d.v=d.o.v=!0,d.e){if(p)for(var s=0,u=c.length;s<u;++s)i.point((h=c[s])[0],h[1]);else n(d.x,d.n.x,1,i);d=d.n}else{if(p){c=d.p.z;for(var s=c.length-1;s>=0;--s)i.point((h=c[s])[0],h[1])}else n(d.x,d.p.x,-1,i);d=d.p}d=d.o,c=d.z,p=!p}while(!d.v);i.lineEnd()}}}function De(t){if(e=t.length){for(var e,r,n=0,i=t[0];++n<e;)i.n=r=t[n],r.p=i,i=r;i.n=r=t[0],r.p=i}}function Pe(t,e,r,n){this.x=t,this.z=e,this.o=r,this.e=n,this.v=!1,this.n=this.p=null}function Oe(t,e,r,n){return function(i,a){function o(e,r){var n=i(e,r);t(e=n[0],r=n[1])&&a.point(e,r)}function s(t,e){var r=i(t,e);v.point(r[0],r[1])}function l(){y.point=s,v.lineStart()}function u(){y.point=o,v.lineEnd()}function c(t,e){m.push([t,e]);var r=i(t,e);x.point(r[0],r[1])}function h(){x.lineStart(),m=[]}function f(){c(m[0][0],m[0][1]),x.lineEnd();var t,e=x.clean(),r=b.buffer(),n=r.length;if(m.pop(),p.push(m),m=null,n)if(1&e){t=r[0];var i,n=t.length-1,o=-1;if(n>0){for(_||(a.polygonStart(),_=!0),a.lineStart();++o<n;)a.point((i=t[o])[0],i[1]);a.lineEnd()}}else n>1&&2&e&&r.push(r.pop().concat(r.shift())),d.push(r.filter(Re))}var d,p,m,v=e(a),g=i.invert(n[0],n[1]),y={point:o,lineStart:l,lineEnd:u,polygonStart:function(){y.point=c,y.lineStart=h,y.lineEnd=f,d=[],p=[]},polygonEnd:function(){y.point=o,y.lineStart=l,y.lineEnd=u,d=uo.merge(d);var t=Ve(g,p);d.length?(_||(a.polygonStart(),_=!0),Ie(d,je,t,r,a)):t&&(_||(a.polygonStart(),_=!0),a.lineStart(),r(null,null,1,a),a.lineEnd()),_&&(a.polygonEnd(),_=!1),d=p=null},sphere:function(){a.polygonStart(),a.lineStart(),r(null,null,1,a),a.lineEnd(),a.polygonEnd()}},b=Fe(),x=e(b),_=!1;return y}}function Re(t){return t.length>1}function Fe(){var t,e=[];return{lineStart:function(){e.push(t=[])},point:function(e,r){t.push([e,r])},lineEnd:M,buffer:function(){var r=e;return e=[],t=null,r},rejoin:function(){e.length>1&&e.push(e.pop().concat(e.shift()))}}}function je(t,e){return((t=t.x)[0]<0?t[1]-Vo-Fo:Vo-t[1])-((e=e.x)[0]<0?e[1]-Vo-Fo:Vo-e[1])}function Ne(t){var e,r=NaN,n=NaN,i=NaN;return{lineStart:function(){t.lineStart(),e=1},point:function(a,o){var s=a>0?No:-No,l=xo(a-r);xo(l-No)<Fo?(t.point(r,n=(n+o)/2>0?Vo:-Vo),t.point(i,n),t.lineEnd(),t.lineStart(),t.point(s,n),t.point(a,n),e=0):i!==s&&l>=No&&(xo(r-i)<Fo&&(r-=i*Fo),xo(a-s)<Fo&&(a-=s*Fo),n=Be(r,n,a,o),t.point(i,n),t.lineEnd(),t.lineStart(),t.point(s,n),e=0),t.point(r=a,n=o),i=s},lineEnd:function(){t.lineEnd(),r=n=NaN},clean:function(){return 2-e}}}function Be(t,e,r,n){var i,a,o=Math.sin(t-r);return xo(o)>Fo?Math.atan((Math.sin(e)*(a=Math.cos(n))*Math.sin(r)-Math.sin(n)*(i=Math.cos(e))*Math.sin(t))/(i*a*o)):(e+n)/2}function Ue(t,e,r,n){var i;if(null==t)i=r*Vo,n.point(-No,i),n.point(0,i),n.point(No,i),n.point(No,0),n.point(No,-i),n.point(0,-i),n.point(-No,-i),n.point(-No,0),n.point(-No,i);else if(xo(t[0]-e[0])>Fo){var a=t[0]<e[0]?No:-No;i=r*a/2,n.point(-a,i),n.point(0,i),n.point(a,i)}else n.point(e[0],e[1])}function Ve(t,e){var r=t[0],n=t[1],i=[Math.sin(r),-Math.cos(r),0],a=0,o=0;Ms.reset();for(var s=0,l=e.length;s<l;++s){var u=e[s],c=u.length;if(c)for(var h=u[0],f=h[0],d=h[1]/2+No/4,p=Math.sin(d),m=Math.cos(d),v=1;;){v===c&&(v=0),t=u[v];var g=t[0],y=t[1]/2+No/4,b=Math.sin(y),x=Math.cos(y),_=g-f,w=_>=0?1:-1,M=w*_,k=M>No,A=p*b;if(Ms.add(Math.atan2(A*w*Math.sin(M),m*x+A*Math.cos(M))),a+=k?_+w*Bo:_,k^f>=r^g>=r){var T=be(ge(h),ge(t));we(T);var S=be(i,T);we(S);var E=(k^_>=0?-1:1)*nt(S[2]);(n>E||n===E&&(T[0]||T[1]))&&(o+=k^_>=0?1:-1)}if(!v++)break;f=g,p=b,m=x,h=t}}return(a<-Fo||a<Fo&&Ms<-Fo)^1&o}function He(t){function e(t,e){return Math.cos(t)*Math.cos(e)>a}function r(t){var r,a,l,u,c;return{lineStart:function(){u=l=!1,c=1},point:function(h,f){var d,p=[h,f],m=e(h,f),v=o?m?0:i(h,f):m?i(h+(h<0?No:-No),f):0;if(!r&&(u=l=m)&&t.lineStart(),m!==l&&(d=n(r,p),(ke(r,d)||ke(p,d))&&(p[0]+=Fo,p[1]+=Fo,m=e(p[0],p[1]))),m!==l)c=0,m?(t.lineStart(),d=n(p,r),t.point(d[0],d[1])):(d=n(r,p),t.point(d[0],d[1]),t.lineEnd()),r=d;else if(s&&r&&o^m){var g;v&a||!(g=n(p,r,!0))||(c=0,o?(t.lineStart(),t.point(g[0][0],g[0][1]),t.point(g[1][0],g[1][1]),t.lineEnd()):(t.point(g[1][0],g[1][1]),t.lineEnd(),t.lineStart(),t.point(g[0][0],g[0][1])))}!m||r&&ke(r,p)||t.point(p[0],p[1]),r=p,l=m,a=v},lineEnd:function(){l&&t.lineEnd(),r=null},clean:function(){return c|(u&&l)<<1}}}function n(t,e,r){var n=ge(t),i=ge(e),o=[1,0,0],s=be(n,i),l=ye(s,s),u=s[0],c=l-u*u;if(!c)return!r&&t;var h=a*l/c,f=-a*u/c,d=be(o,s),p=_e(o,h);xe(p,_e(s,f));var m=d,v=ye(p,m),g=ye(m,m),y=v*v-g*(ye(p,p)-1);if(!(y<0)){var b=Math.sqrt(y),x=_e(m,(-v-b)/g);if(xe(x,p),x=Me(x),!r)return x;var _,w=t[0],M=e[0],k=t[1],A=e[1];M<w&&(_=w,w=M,M=_);var T=M-w,S=xo(T-No)<Fo,E=S||T<Fo;if(!S&&A<k&&(_=k,k=A,A=_),E?S?k+A>0^x[1]<(xo(x[0]-w)<Fo?k:A):k<=x[1]&&x[1]<=A:T>No^(w<=x[0]&&x[0]<=M)){var L=_e(m,(-v+b)/g);return xe(L,p),[x,Me(L)]}}}function i(e,r){var n=o?t:No-t,i=0;return e<-n?i|=1:e>n&&(i|=2),r<-n?i|=4:r>n&&(i|=8),i}var a=Math.cos(t),o=a>0,s=xo(a)>Fo;return Oe(e,r,vr(t,6*Ho),o?[0,-t]:[-No,t-No])}function qe(t,e,r,n){return function(i){var a,o=i.a,s=i.b,l=o.x,u=o.y,c=s.x,h=s.y,f=0,d=1,p=c-l,m=h-u;if(a=t-l,p||!(a>0)){if(a/=p,p<0){if(a<f)return;a<d&&(d=a)}else if(p>0){if(a>d)return;a>f&&(f=a)}if(a=r-l,p||!(a<0)){if(a/=p,p<0){if(a>d)return;a>f&&(f=a)}else if(p>0){if(a<f)return;a<d&&(d=a)}if(a=e-u,m||!(a>0)){if(a/=m,m<0){if(a<f)return;a<d&&(d=a)}else if(m>0){if(a>d)return;a>f&&(f=a)}if(a=n-u,m||!(a<0)){if(a/=m,m<0){if(a>d)return;a>f&&(f=a)}else if(m>0){if(a<f)return;a<d&&(d=a)}return f>0&&(i.a={x:l+f*p,y:u+f*m}),d<1&&(i.b={x:l+d*p,y:u+d*m}),i}}}}}}function Ge(t,e,r,n){function i(n,i){return xo(n[0]-t)<Fo?i>0?0:3:xo(n[0]-r)<Fo?i>0?2:1:xo(n[1]-e)<Fo?i>0?1:0:i>0?3:2}function a(t,e){return o(t.x,e.x)}function o(t,e){var r=i(t,1),n=i(e,1);return r!==n?r-n:0===r?e[1]-t[1]:1===r?t[0]-e[0]:2===r?t[1]-e[1]:e[0]-t[0]}return function(s){function l(t){for(var e=0,r=v.length,n=t[1],i=0;i<r;++i)for(var a,o=1,s=v[i],l=s.length,u=s[0];o<l;++o)a=s[o],u[1]<=n?a[1]>n&&et(u,a,t)>0&&++e:a[1]<=n&&et(u,a,t)<0&&--e,u=a;return 0!==e}function u(a,s,l,u){var c=0,h=0;if(null==a||(c=i(a,l))!==(h=i(s,l))||o(a,s)<0^l>0)do{u.point(0===c||3===c?t:r,c>1?n:e)}while((c=(c+l+4)%4)!==h);else u.point(s[0],s[1])}function c(i,a){return t<=i&&i<=r&&e<=a&&a<=n}function h(t,e){c(t,e)&&s.point(t,e)}function f(){L.point=p,v&&v.push(g=[]),k=!0,M=!1,_=w=NaN}function d(){m&&(p(y,b),x&&M&&S.rejoin(),m.push(S.buffer())),L.point=h,M&&s.lineEnd()}function p(t,e){t=Math.max(-js,Math.min(js,t)),e=Math.max(-js,Math.min(js,e));var r=c(t,e);if(v&&g.push([t,e]),k)y=t,b=e,x=r,k=!1,r&&(s.lineStart(),s.point(t,e));else if(r&&M)s.point(t,e);else{var n={a:{x:_,y:w},b:{x:t,y:e}};E(n)?(M||(s.lineStart(),s.point(n.a.x,n.a.y)),s.point(n.b.x,n.b.y),r||s.lineEnd(),A=!1):r&&(s.lineStart(),s.point(t,e),A=!1)}_=t,w=e,M=r}var m,v,g,y,b,x,_,w,M,k,A,T=s,S=Fe(),E=qe(t,e,r,n),L={point:h,lineStart:f,lineEnd:d,polygonStart:function(){s=S,m=[],v=[],A=!0},polygonEnd:function(){s=T,m=uo.merge(m);var e=l([t,n]),r=A&&e,i=m.length;(r||i)&&(s.polygonStart(),r&&(s.lineStart(),u(null,null,1,s),s.lineEnd()),i&&Ie(m,a,e,u,s),s.polygonEnd()),m=v=g=null}};return L}}function Ye(t){var e=0,r=No/3,n=lr(t),i=n(e,r);return i.parallels=function(t){return arguments.length?n(e=t[0]*No/180,r=t[1]*No/180):[e/No*180,r/No*180]},i}function Xe(t,e){function r(t,e){var r=Math.sqrt(a-2*i*Math.sin(e))/i;return[r*Math.sin(t*=i),o-r*Math.cos(t)]}var n=Math.sin(t),i=(n+Math.sin(e))/2,a=1+n*(2*i-n),o=Math.sqrt(a)/i;return r.invert=function(t,e){var r=o-e;return[Math.atan2(t,r)/i,nt((a-(t*t+r*r)*i*i)/(2*i))]},r}function We(){function t(t,e){Bs+=i*t-n*e,n=t,i=e}var e,r,n,i;Gs.point=function(a,o){Gs.point=t,e=n=a,r=i=o},Gs.lineEnd=function(){t(e,r)}}function Ze(t,e){t<Us&&(Us=t),t>Hs&&(Hs=t),e<Vs&&(Vs=e),e>qs&&(qs=e)}function Je(){function t(t,e){o.push(\"M\",t,\",\",e,a)}function e(t,e){o.push(\"M\",t,\",\",e),s.point=r}function r(t,e){o.push(\"L\",t,\",\",e)}function n(){s.point=t}function i(){o.push(\"Z\")}var a=Ke(4.5),o=[],s={point:t,lineStart:function(){s.point=e},lineEnd:n,polygonStart:function(){s.lineEnd=i},polygonEnd:function(){s.lineEnd=n,s.point=t},pointRadius:function(t){return a=Ke(t),s},result:function(){if(o.length){var t=o.join(\"\");return o=[],t}}};return s}function Ke(t){return\"m0,\"+t+\"a\"+t+\",\"+t+\" 0 1,1 0,\"+-2*t+\"a\"+t+\",\"+t+\" 0 1,1 0,\"+2*t+\"z\"}function Qe(t,e){Ss+=t,Es+=e,++Ls}function $e(){function t(t,n){var i=t-e,a=n-r,o=Math.sqrt(i*i+a*a);Cs+=o*(e+t)/2,zs+=o*(r+n)/2,Is+=o,Qe(e=t,r=n)}var e,r;Xs.point=function(n,i){Xs.point=t,Qe(e=n,r=i)}}function tr(){Xs.point=Qe}function er(){function t(t,e){var r=t-n,a=e-i,o=Math.sqrt(r*r+a*a);Cs+=o*(n+t)/2,zs+=o*(i+e)/2,Is+=o,o=i*t-n*e,Ds+=o*(n+t),Ps+=o*(i+e),Os+=3*o,Qe(n=t,i=e)}var e,r,n,i;Xs.point=function(a,o){Xs.point=t,Qe(e=n=a,r=i=o)},Xs.lineEnd=function(){t(e,r)}}function rr(t){function e(e,r){t.moveTo(e+o,r),t.arc(e,r,o,0,Bo)}function r(e,r){t.moveTo(e,r),s.point=n}function n(e,r){t.lineTo(e,r)}function i(){s.point=e}function a(){t.closePath()}var o=4.5,s={point:e,lineStart:function(){s.point=r},lineEnd:i,polygonStart:function(){s.lineEnd=a},polygonEnd:function(){s.lineEnd=i,s.point=e},pointRadius:function(t){return o=t,s},result:M};return s}function nr(t){function e(t){return(s?n:r)(t)}function r(e){return or(e,function(r,n){r=t(r,n),e.point(r[0],r[1])})}function n(e){function r(r,n){r=t(r,n),e.point(r[0],r[1])}function n(){b=NaN,k.point=a,e.lineStart()}function a(r,n){var a=ge([r,n]),o=t(r,n);i(b,x,y,_,w,M,b=o[0],x=o[1],y=r,_=a[0],w=a[1],M=a[2],s,e),e.point(b,x)}function o(){k.point=r,e.lineEnd()}function l(){n(),k.point=u,k.lineEnd=c}function u(t,e){a(h=t,f=e),d=b,p=x,m=_,v=w,g=M,k.point=a}function c(){i(b,x,y,_,w,M,d,p,h,m,v,g,s,e),k.lineEnd=o,o()}var h,f,d,p,m,v,g,y,b,x,_,w,M,k={point:r,lineStart:n,lineEnd:o,polygonStart:function(){e.polygonStart(),k.lineStart=l},polygonEnd:function(){e.polygonEnd(),k.lineStart=n}};return k}function i(e,r,n,s,l,u,c,h,f,d,p,m,v,g){var y=c-e,b=h-r,x=y*y+b*b;if(x>4*a&&v--){var _=s+d,w=l+p,M=u+m,k=Math.sqrt(_*_+w*w+M*M),A=Math.asin(M/=k),T=xo(xo(M)-1)<Fo||xo(n-f)<Fo?(n+f)/2:Math.atan2(w,_),S=t(T,A),E=S[0],L=S[1],C=E-e,z=L-r,I=b*C-y*z;(I*I/x>a||xo((y*C+b*z)/x-.5)>.3||s*d+l*p+u*m<o)&&(i(e,r,n,s,l,u,E,L,T,_/=k,w/=k,M,v,g),g.point(E,L),i(E,L,T,_,w,M,c,h,f,d,p,m,v,g))}}var a=.5,o=Math.cos(30*Ho),s=16;return e.precision=function(t){return arguments.length?(s=(a=t*t)>0&&16,e):Math.sqrt(a)},e}function ir(t){var e=nr(function(e,r){return t([e*qo,r*qo])});return function(t){return ur(e(t))}}function ar(t){this.stream=t}function or(t,e){return{point:e,sphere:function(){t.sphere()},lineStart:function(){t.lineStart()},lineEnd:function(){t.lineEnd()},polygonStart:function(){t.polygonStart()},polygonEnd:function(){t.polygonEnd()}}}function sr(t){return lr(function(){return t})()}function lr(t){function e(t){return t=s(t[0]*Ho,t[1]*Ho),[t[0]*f+l,u-t[1]*f]}function r(t){return(t=s.invert((t[0]-l)/f,(u-t[1])/f))&&[t[0]*qo,t[1]*qo]}function n(){s=Ce(o=fr(g,y,b),a);var t=a(m,v);return l=d-t[0]*f,u=p+t[1]*f,i()}function i(){return c&&(c.valid=!1,c=null),e}var a,o,s,l,u,c,h=nr(function(t,e){return t=a(t,e),[t[0]*f+l,u-t[1]*f]}),f=150,d=480,p=250,m=0,v=0,g=0,y=0,b=0,_=Fs,w=x,M=null,k=null;return e.stream=function(t){return c&&(c.valid=!1),c=ur(_(o,h(w(t)))),c.valid=!0,c},e.clipAngle=function(t){return arguments.length?(_=null==t?(M=t,Fs):He((M=+t)*Ho),i()):M},e.clipExtent=function(t){return arguments.length?(k=t,w=t?Ge(t[0][0],t[0][1],t[1][0],t[1][1]):x,i()):k},e.scale=function(t){return arguments.length?(f=+t,n()):f},e.translate=function(t){return arguments.length?(d=+t[0],p=+t[1],n()):[d,p]},e.center=function(t){return arguments.length?(m=t[0]%360*Ho,v=t[1]%360*Ho,n()):[m*qo,v*qo]},e.rotate=function(t){return arguments.length?(g=t[0]%360*Ho,y=t[1]%360*Ho,b=t.length>2?t[2]%360*Ho:0,n()):[g*qo,y*qo,b*qo]},uo.rebind(e,h,\"precision\"),function(){return a=t.apply(this,arguments),e.invert=a.invert&&r,n()}}function ur(t){return or(t,function(e,r){t.point(e*Ho,r*Ho)})}function cr(t,e){return[t,e]}function hr(t,e){return[t>No?t-Bo:t<-No?t+Bo:t,e]}function fr(t,e,r){return t?e||r?Ce(pr(t),mr(e,r)):pr(t):e||r?mr(e,r):hr}function dr(t){return function(e,r){return e+=t,[e>No?e-Bo:e<-No?e+Bo:e,r]}}function pr(t){var e=dr(t);return e.invert=dr(-t),e}function mr(t,e){function r(t,e){var r=Math.cos(e),s=Math.cos(t)*r,l=Math.sin(t)*r,u=Math.sin(e),c=u*n+s*i;return[Math.atan2(l*a-c*o,s*n-u*i),nt(c*a+l*o)]}var n=Math.cos(t),i=Math.sin(t),a=Math.cos(e),o=Math.sin(e);return r.invert=function(t,e){var r=Math.cos(e),s=Math.cos(t)*r,l=Math.sin(t)*r,u=Math.sin(e),c=u*a-l*o;return[Math.atan2(l*a+u*o,s*n+c*i),nt(c*n-s*i)]},r}function vr(t,e){var r=Math.cos(t),n=Math.sin(t);return function(i,a,o,s){var l=o*e;null!=i?(i=gr(r,i),a=gr(r,a),(o>0?i<a:i>a)&&(i+=o*Bo)):(i=t+o*Bo,a=t-.5*l);for(var u,c=i;o>0?c>a:c<a;c-=l)s.point((u=Me([r,-n*Math.cos(c),-n*Math.sin(c)]))[0],u[1])}}function gr(t,e){var r=ge(e);r[0]-=t,we(r);var n=rt(-r[1]);return((-r[2]<0?-n:n)+2*Math.PI-Fo)%(2*Math.PI)}function yr(t,e,r){var n=uo.range(t,e-Fo,r).concat(e);return function(t){return n.map(function(e){return[t,e]})}}function br(t,e,r){var n=uo.range(t,e-Fo,r).concat(e);return function(t){return n.map(function(e){return[e,t]})}}function xr(t){return t.source}function _r(t){return t.target}function wr(t,e,r,n){var i=Math.cos(e),a=Math.sin(e),o=Math.cos(n),s=Math.sin(n),l=i*Math.cos(t),u=i*Math.sin(t),c=o*Math.cos(r),h=o*Math.sin(r),f=2*Math.asin(Math.sqrt(st(n-e)+i*o*st(r-t))),d=1/Math.sin(f),p=f?function(t){var e=Math.sin(t*=f)*d,r=Math.sin(f-t)*d,n=r*l+e*c,i=r*u+e*h,o=r*a+e*s;return[Math.atan2(i,n)*qo,Math.atan2(o,Math.sqrt(n*n+i*i))*qo]}:function(){return[t*qo,e*qo]};return p.distance=f,p}function Mr(){function t(t,i){var a=Math.sin(i*=Ho),o=Math.cos(i),s=xo((t*=Ho)-e),l=Math.cos(s);Ws+=Math.atan2(Math.sqrt((s=o*Math.sin(s))*s+(s=n*a-r*o*l)*s),r*a+n*o*l),e=t,r=a,n=o}var e,r,n;Zs.point=function(i,a){e=i*Ho,r=Math.sin(a*=Ho),n=Math.cos(a),Zs.point=t},Zs.lineEnd=function(){Zs.point=Zs.lineEnd=M}}function kr(t,e){function r(e,r){var n=Math.cos(e),i=Math.cos(r),a=t(n*i);return[a*i*Math.sin(e),a*Math.sin(r)]}return r.invert=function(t,r){var n=Math.sqrt(t*t+r*r),i=e(n),a=Math.sin(i),o=Math.cos(i);return[Math.atan2(t*a,n*o),Math.asin(n&&r*a/n)]},r}function Ar(t,e){function r(t,e){o>0?e<-Vo+Fo&&(e=-Vo+Fo):e>Vo-Fo&&(e=Vo-Fo);var r=o/Math.pow(i(e),a);return[r*Math.sin(a*t),o-r*Math.cos(a*t)]}var n=Math.cos(t),i=function(t){return Math.tan(No/4+t/2)},a=t===e?Math.sin(t):Math.log(n/Math.cos(e))/Math.log(i(e)/i(t)),o=n*Math.pow(i(t),a)/a;return a?(r.invert=function(t,e){var r=o-e,n=tt(a)*Math.sqrt(t*t+r*r);return[Math.atan2(t,r)/a,2*Math.atan(Math.pow(o/n,1/a))-Vo]},r):Sr}function Tr(t,e){function r(t,e){var r=a-e;return[r*Math.sin(i*t),a-r*Math.cos(i*t)]}var n=Math.cos(t),i=t===e?Math.sin(t):(n-Math.cos(e))/(e-t),a=n/i+t;return xo(i)<Fo?cr:(r.invert=function(t,e){var r=a-e;return[Math.atan2(t,r)/i,a-tt(i)*Math.sqrt(t*t+r*r)]},r)}function Sr(t,e){return[t,Math.log(Math.tan(No/4+e/2))]}function Er(t){var e,r=sr(t),n=r.scale,i=r.translate,a=r.clipExtent;return r.scale=function(){var t=n.apply(r,arguments);return t===r?e?r.clipExtent(null):r:t},r.translate=function(){var t=i.apply(r,arguments);return t===r?e?r.clipExtent(null):r:t},r.clipExtent=function(t){var o=a.apply(r,arguments);if(o===r){if(e=null==t){var s=No*n(),l=i();a([[l[0]-s,l[1]-s],[l[0]+s,l[1]+s]])}}else e&&(o=null);return o},r.clipExtent(null)}function Lr(t,e){return[Math.log(Math.tan(No/4+e/2)),-t]}function Cr(t){return t[0]}function zr(t){return t[1]}function Ir(t){for(var e=t.length,r=[0,1],n=2,i=2;i<e;i++){for(;n>1&&et(t[r[n-2]],t[r[n-1]],t[i])<=0;)--n;r[n++]=i}return r.slice(0,n)}function Dr(t,e){return t[0]-e[0]||t[1]-e[1]}function Pr(t,e,r){return(r[0]-e[0])*(t[1]-e[1])<(r[1]-e[1])*(t[0]-e[0])}function Or(t,e,r,n){var i=t[0],a=r[0],o=e[0]-i,s=n[0]-a,l=t[1],u=r[1],c=e[1]-l,h=n[1]-u,f=(s*(l-u)-h*(i-a))/(h*o-s*c);return[i+f*o,l+f*c]}function Rr(t){var e=t[0],r=t[t.length-1];return!(e[0]-r[0]||e[1]-r[1])}function Fr(){an(this),this.edge=this.site=this.circle=null}function jr(t){var e=sl.pop()||new Fr;return e.site=t,e}function Nr(t){Zr(t),il.remove(t),sl.push(t),an(t)}function Br(t){var e=t.circle,r=e.x,n=e.cy,i={x:r,y:n},a=t.P,o=t.N,s=[t];Nr(t);for(var l=a;l.circle&&xo(r-l.circle.x)<Fo&&xo(n-l.circle.cy)<Fo;)a=l.P,s.unshift(l),Nr(l),l=a;s.unshift(l),Zr(l);for(var u=o;u.circle&&xo(r-u.circle.x)<Fo&&xo(n-u.circle.cy)<Fo;)o=u.N,s.push(u),Nr(u),u=o;s.push(u),Zr(u);var c,h=s.length;for(c=1;c<h;++c)u=s[c],l=s[c-1],en(u.edge,l.site,u.site,i);l=s[0],u=s[h-1],u.edge=$r(l.site,u.site,null,i),Wr(l),Wr(u)}function Ur(t){for(var e,r,n,i,a=t.x,o=t.y,s=il._;s;)if((n=Vr(s,o)-a)>Fo)s=s.L;else{if(!((i=a-Hr(s,o))>Fo)){n>-Fo?(e=s.P,r=s):i>-Fo?(e=s,r=s.N):e=r=s;break}if(!s.R){e=s;break}s=s.R}var l=jr(t);if(il.insert(e,l),e||r){if(e===r)return Zr(e),r=jr(e.site),il.insert(l,r),l.edge=r.edge=$r(e.site,l.site),Wr(e),void Wr(r);if(!r)return void(l.edge=$r(e.site,l.site));Zr(e),Zr(r);var u=e.site,c=u.x,h=u.y,f=t.x-c,d=t.y-h,p=r.site,m=p.x-c,v=p.y-h,g=2*(f*v-d*m),y=f*f+d*d,b=m*m+v*v,x={x:(v*y-d*b)/g+c,y:(f*b-m*y)/g+h};en(r.edge,u,p,x),l.edge=$r(u,t,null,x),r.edge=$r(t,p,null,x),Wr(e),Wr(r)}}function Vr(t,e){var r=t.site,n=r.x,i=r.y,a=i-e;if(!a)return n;var o=t.P;if(!o)return-1/0;r=o.site;var s=r.x,l=r.y,u=l-e;if(!u)return s;var c=s-n,h=1/a-1/u,f=c/u;return h?(-f+Math.sqrt(f*f-2*h*(c*c/(-2*u)-l+u/2+i-a/2)))/h+n:(n+s)/2}function Hr(t,e){var r=t.N;if(r)return Vr(r,e);var n=t.site;return n.y===e?n.x:1/0}function qr(t){this.site=t,this.edges=[]}function Gr(t){for(var e,r,n,i,a,o,s,l,u,c,h=t[0][0],f=t[1][0],d=t[0][1],p=t[1][1],m=nl,v=m.length;v--;)if((a=m[v])&&a.prepare())for(s=a.edges,l=s.length,o=0;o<l;)c=s[o].end(),n=c.x,i=c.y,u=s[++o%l].start(),e=u.x,r=u.y,(xo(n-e)>Fo||xo(i-r)>Fo)&&(s.splice(o,0,new rn(tn(a.site,c,xo(n-h)<Fo&&p-i>Fo?{x:h,y:xo(e-h)<Fo?r:p}:xo(i-p)<Fo&&f-n>Fo?{x:xo(r-p)<Fo?e:f,y:p}:xo(n-f)<Fo&&i-d>Fo?{x:f,y:xo(e-f)<Fo?r:d}:xo(i-d)<Fo&&n-h>Fo?{x:xo(r-d)<Fo?e:h,y:d}:null),a.site,null)),++l)}function Yr(t,e){return e.angle-t.angle}function Xr(){an(this),this.x=this.y=this.arc=this.site=this.cy=null}function Wr(t){var e=t.P,r=t.N;if(e&&r){var n=e.site,i=t.site,a=r.site;if(n!==a){var o=i.x,s=i.y,l=n.x-o,u=n.y-s,c=a.x-o,h=a.y-s,f=2*(l*h-u*c);if(!(f>=-jo)){var d=l*l+u*u,p=c*c+h*h,m=(h*d-u*p)/f,v=(l*p-c*d)/f,h=v+s,g=ll.pop()||new Xr;g.arc=t,g.site=i,g.x=m+o,g.y=h+Math.sqrt(m*m+v*v),g.cy=h,t.circle=g;for(var y=null,b=ol._;b;)if(g.y<b.y||g.y===b.y&&g.x<=b.x){if(!b.L){y=b.P;break}b=b.L}else{if(!b.R){y=b;break}b=b.R}ol.insert(y,g),y||(al=g)}}}}function Zr(t){var e=t.circle;e&&(e.P||(al=e.N),ol.remove(e),ll.push(e),an(e),t.circle=null)}function Jr(t){for(var e,r=rl,n=qe(t[0][0],t[0][1],t[1][0],t[1][1]),i=r.length;i--;)e=r[i],(!Kr(e,t)||!n(e)||xo(e.a.x-e.b.x)<Fo&&xo(e.a.y-e.b.y)<Fo)&&(e.a=e.b=null,r.splice(i,1))}function Kr(t,e){var r=t.b;if(r)return!0;var n,i,a=t.a,o=e[0][0],s=e[1][0],l=e[0][1],u=e[1][1],c=t.l,h=t.r,f=c.x,d=c.y,p=h.x,m=h.y,v=(f+p)/2,g=(d+m)/2;if(m===d){if(v<o||v>=s)return;if(f>p){if(a){if(a.y>=u)return}else a={x:v,y:l};r={x:v,y:u}}else{if(a){if(a.y<l)return}else a={x:v,y:u};r={x:v,y:l}}}else if(n=(f-p)/(m-d),i=g-n*v,n<-1||n>1)if(f>p){if(a){if(a.y>=u)return}else a={x:(l-i)/n,y:l};r={x:(u-i)/n,y:u}}else{if(a){if(a.y<l)return}else a={x:(u-i)/n,y:u};r={x:(l-i)/n,y:l}}else if(d<m){if(a){if(a.x>=s)return}else a={x:o,y:n*o+i};r={x:s,y:n*s+i}}else{if(a){if(a.x<o)return}else a={x:s,y:n*s+i};r={\n",
       "x:o,y:n*o+i}}return t.a=a,t.b=r,!0}function Qr(t,e){this.l=t,this.r=e,this.a=this.b=null}function $r(t,e,r,n){var i=new Qr(t,e);return rl.push(i),r&&en(i,t,e,r),n&&en(i,e,t,n),nl[t.i].edges.push(new rn(i,t,e)),nl[e.i].edges.push(new rn(i,e,t)),i}function tn(t,e,r){var n=new Qr(t,null);return n.a=e,n.b=r,rl.push(n),n}function en(t,e,r,n){t.a||t.b?t.l===r?t.b=n:t.a=n:(t.a=n,t.l=e,t.r=r)}function rn(t,e,r){var n=t.a,i=t.b;this.edge=t,this.site=e,this.angle=r?Math.atan2(r.y-e.y,r.x-e.x):t.l===e?Math.atan2(i.x-n.x,n.y-i.y):Math.atan2(n.x-i.x,i.y-n.y)}function nn(){this._=null}function an(t){t.U=t.C=t.L=t.R=t.P=t.N=null}function on(t,e){var r=e,n=e.R,i=r.U;i?i.L===r?i.L=n:i.R=n:t._=n,n.U=i,r.U=n,r.R=n.L,r.R&&(r.R.U=r),n.L=r}function sn(t,e){var r=e,n=e.L,i=r.U;i?i.L===r?i.L=n:i.R=n:t._=n,n.U=i,r.U=n,r.L=n.R,r.L&&(r.L.U=r),n.R=r}function ln(t){for(;t.L;)t=t.L;return t}function un(t,e){var r,n,i,a=t.sort(cn).pop();for(rl=[],nl=new Array(t.length),il=new nn,ol=new nn;;)if(i=al,a&&(!i||a.y<i.y||a.y===i.y&&a.x<i.x))a.x===r&&a.y===n||(nl[a.i]=new qr(a),Ur(a),r=a.x,n=a.y),a=t.pop();else{if(!i)break;Br(i.arc)}e&&(Jr(e),Gr(e));var o={cells:nl,edges:rl};return il=ol=rl=nl=null,o}function cn(t,e){return e.y-t.y||e.x-t.x}function hn(t,e,r){return(t.x-r.x)*(e.y-t.y)-(t.x-e.x)*(r.y-t.y)}function fn(t){return t.x}function dn(t){return t.y}function pn(){return{leaf:!0,nodes:[],point:null,x:null,y:null}}function mn(t,e,r,n,i,a){if(!t(e,r,n,i,a)){var o=.5*(r+i),s=.5*(n+a),l=e.nodes;l[0]&&mn(t,l[0],r,n,o,s),l[1]&&mn(t,l[1],o,n,i,s),l[2]&&mn(t,l[2],r,s,o,a),l[3]&&mn(t,l[3],o,s,i,a)}}function vn(t,e,r,n,i,a,o){var s,l=1/0;return function t(u,c,h,f,d){if(!(c>a||h>o||f<n||d<i)){if(p=u.point){var p,m=e-u.x,v=r-u.y,g=m*m+v*v;if(g<l){var y=Math.sqrt(l=g);n=e-y,i=r-y,a=e+y,o=r+y,s=p}}for(var b=u.nodes,x=.5*(c+f),_=.5*(h+d),w=e>=x,M=r>=_,k=M<<1|w,A=k+4;k<A;++k)if(u=b[3&k])switch(3&k){case 0:t(u,c,h,x,_);break;case 1:t(u,x,h,f,_);break;case 2:t(u,c,_,x,d);break;case 3:t(u,x,_,f,d)}}}(t,n,i,a,o),s}function gn(t,e){t=uo.rgb(t),e=uo.rgb(e);var r=t.r,n=t.g,i=t.b,a=e.r-r,o=e.g-n,s=e.b-i;return function(t){return\"#\"+wt(Math.round(r+a*t))+wt(Math.round(n+o*t))+wt(Math.round(i+s*t))}}function yn(t,e){var r,n={},i={};for(r in t)r in e?n[r]=_n(t[r],e[r]):i[r]=t[r];for(r in e)r in t||(i[r]=e[r]);return function(t){for(r in n)i[r]=n[r](t);return i}}function bn(t,e){return t=+t,e=+e,function(r){return t*(1-r)+e*r}}function xn(t,e){var r,n,i,a=cl.lastIndex=hl.lastIndex=0,o=-1,s=[],l=[];for(t+=\"\",e+=\"\";(r=cl.exec(t))&&(n=hl.exec(e));)(i=n.index)>a&&(i=e.slice(a,i),s[o]?s[o]+=i:s[++o]=i),(r=r[0])===(n=n[0])?s[o]?s[o]+=n:s[++o]=n:(s[++o]=null,l.push({i:o,x:bn(r,n)})),a=hl.lastIndex;return a<e.length&&(i=e.slice(a),s[o]?s[o]+=i:s[++o]=i),s.length<2?l[0]?(e=l[0].x,function(t){return e(t)+\"\"}):function(){return e}:(e=l.length,function(t){for(var r,n=0;n<e;++n)s[(r=l[n]).i]=r.x(t);return s.join(\"\")})}function _n(t,e){for(var r,n=uo.interpolators.length;--n>=0&&!(r=uo.interpolators[n](t,e)););return r}function wn(t,e){var r,n=[],i=[],a=t.length,o=e.length,s=Math.min(t.length,e.length);for(r=0;r<s;++r)n.push(_n(t[r],e[r]));for(;r<a;++r)i[r]=t[r];for(;r<o;++r)i[r]=e[r];return function(t){for(r=0;r<s;++r)i[r]=n[r](t);return i}}function Mn(t){return function(e){return e<=0?0:e>=1?1:t(e)}}function kn(t){return function(e){return 1-t(1-e)}}function An(t){return function(e){return.5*(e<.5?t(2*e):2-t(2-2*e))}}function Tn(t){return t*t}function Sn(t){return t*t*t}function En(t){if(t<=0)return 0;if(t>=1)return 1;var e=t*t,r=e*t;return 4*(t<.5?r:3*(t-e)+r-.75)}function Ln(t){return function(e){return Math.pow(e,t)}}function Cn(t){return 1-Math.cos(t*Vo)}function zn(t){return Math.pow(2,10*(t-1))}function In(t){return 1-Math.sqrt(1-t*t)}function Dn(t,e){var r;return arguments.length<2&&(e=.45),arguments.length?r=e/Bo*Math.asin(1/t):(t=1,r=e/4),function(n){return 1+t*Math.pow(2,-10*n)*Math.sin((n-r)*Bo/e)}}function Pn(t){return t||(t=1.70158),function(e){return e*e*((t+1)*e-t)}}function On(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375}function Rn(t,e){t=uo.hcl(t),e=uo.hcl(e);var r=t.h,n=t.c,i=t.l,a=e.h-r,o=e.c-n,s=e.l-i;return isNaN(o)&&(o=0,n=isNaN(n)?e.c:n),isNaN(a)?(a=0,r=isNaN(r)?e.h:r):a>180?a-=360:a<-180&&(a+=360),function(t){return ft(r+a*t,n+o*t,i+s*t)+\"\"}}function Fn(t,e){t=uo.hsl(t),e=uo.hsl(e);var r=t.h,n=t.s,i=t.l,a=e.h-r,o=e.s-n,s=e.l-i;return isNaN(o)&&(o=0,n=isNaN(n)?e.s:n),isNaN(a)?(a=0,r=isNaN(r)?e.h:r):a>180?a-=360:a<-180&&(a+=360),function(t){return ct(r+a*t,n+o*t,i+s*t)+\"\"}}function jn(t,e){t=uo.lab(t),e=uo.lab(e);var r=t.l,n=t.a,i=t.b,a=e.l-r,o=e.a-n,s=e.b-i;return function(t){return pt(r+a*t,n+o*t,i+s*t)+\"\"}}function Nn(t,e){return e-=t,function(r){return Math.round(t+e*r)}}function Bn(t){var e=[t.a,t.b],r=[t.c,t.d],n=Vn(e),i=Un(e,r),a=Vn(Hn(r,e,-i))||0;e[0]*r[1]<r[0]*e[1]&&(e[0]*=-1,e[1]*=-1,n*=-1,i*=-1),this.rotate=(n?Math.atan2(e[1],e[0]):Math.atan2(-r[0],r[1]))*qo,this.translate=[t.e,t.f],this.scale=[n,a],this.skew=a?Math.atan2(i,a)*qo:0}function Un(t,e){return t[0]*e[0]+t[1]*e[1]}function Vn(t){var e=Math.sqrt(Un(t,t));return e&&(t[0]/=e,t[1]/=e),e}function Hn(t,e,r){return t[0]+=r*e[0],t[1]+=r*e[1],t}function qn(t){return t.length?t.pop()+\",\":\"\"}function Gn(t,e,r,n){if(t[0]!==e[0]||t[1]!==e[1]){var i=r.push(\"translate(\",null,\",\",null,\")\");n.push({i:i-4,x:bn(t[0],e[0])},{i:i-2,x:bn(t[1],e[1])})}else(e[0]||e[1])&&r.push(\"translate(\"+e+\")\")}function Yn(t,e,r,n){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),n.push({i:r.push(qn(r)+\"rotate(\",null,\")\")-2,x:bn(t,e)})):e&&r.push(qn(r)+\"rotate(\"+e+\")\")}function Xn(t,e,r,n){t!==e?n.push({i:r.push(qn(r)+\"skewX(\",null,\")\")-2,x:bn(t,e)}):e&&r.push(qn(r)+\"skewX(\"+e+\")\")}function Wn(t,e,r,n){if(t[0]!==e[0]||t[1]!==e[1]){var i=r.push(qn(r)+\"scale(\",null,\",\",null,\")\");n.push({i:i-4,x:bn(t[0],e[0])},{i:i-2,x:bn(t[1],e[1])})}else 1===e[0]&&1===e[1]||r.push(qn(r)+\"scale(\"+e+\")\")}function Zn(t,e){var r=[],n=[];return t=uo.transform(t),e=uo.transform(e),Gn(t.translate,e.translate,r,n),Yn(t.rotate,e.rotate,r,n),Xn(t.skew,e.skew,r,n),Wn(t.scale,e.scale,r,n),t=e=null,function(t){for(var e,i=-1,a=n.length;++i<a;)r[(e=n[i]).i]=e.x(t);return r.join(\"\")}}function Jn(t,e){return e=(e-=t=+t)||1/e,function(r){return(r-t)/e}}function Kn(t,e){return e=(e-=t=+t)||1/e,function(r){return Math.max(0,Math.min(1,(r-t)/e))}}function Qn(t){for(var e=t.source,r=t.target,n=ti(e,r),i=[e];e!==n;)e=e.parent,i.push(e);for(var a=i.length;r!==n;)i.splice(a,0,r),r=r.parent;return i}function $n(t){for(var e=[],r=t.parent;null!=r;)e.push(t),t=r,r=r.parent;return e.push(t),e}function ti(t,e){if(t===e)return t;for(var r=$n(t),n=$n(e),i=r.pop(),a=n.pop(),o=null;i===a;)o=i,i=r.pop(),a=n.pop();return o}function ei(t){t.fixed|=2}function ri(t){t.fixed&=-7}function ni(t){t.fixed|=4,t.px=t.x,t.py=t.y}function ii(t){t.fixed&=-5}function ai(t,e,r){var n=0,i=0;if(t.charge=0,!t.leaf)for(var a,o=t.nodes,s=o.length,l=-1;++l<s;)null!=(a=o[l])&&(ai(a,e,r),t.charge+=a.charge,n+=a.charge*a.cx,i+=a.charge*a.cy);if(t.point){t.leaf||(t.point.x+=Math.random()-.5,t.point.y+=Math.random()-.5);var u=e*r[t.point.index];t.charge+=t.pointCharge=u,n+=u*t.point.x,i+=u*t.point.y}t.cx=n/t.charge,t.cy=i/t.charge}function oi(t,e){return uo.rebind(t,e,\"sort\",\"children\",\"value\"),t.nodes=t,t.links=fi,t}function si(t,e){for(var r=[t];null!=(t=r.pop());)if(e(t),(i=t.children)&&(n=i.length))for(var n,i;--n>=0;)r.push(i[n])}function li(t,e){for(var r=[t],n=[];null!=(t=r.pop());)if(n.push(t),(a=t.children)&&(i=a.length))for(var i,a,o=-1;++o<i;)r.push(a[o]);for(;null!=(t=n.pop());)e(t)}function ui(t){return t.children}function ci(t){return t.value}function hi(t,e){return e.value-t.value}function fi(t){return uo.merge(t.map(function(t){return(t.children||[]).map(function(e){return{source:t,target:e}})}))}function di(t){return t.x}function pi(t){return t.y}function mi(t,e,r){t.y0=e,t.y=r}function vi(t){return uo.range(t.length)}function gi(t){for(var e=-1,r=t[0].length,n=[];++e<r;)n[e]=0;return n}function yi(t){for(var e,r=1,n=0,i=t[0][1],a=t.length;r<a;++r)(e=t[r][1])>i&&(n=r,i=e);return n}function bi(t){return t.reduce(xi,0)}function xi(t,e){return t+e[1]}function _i(t,e){return wi(t,Math.ceil(Math.log(e.length)/Math.LN2+1))}function wi(t,e){for(var r=-1,n=+t[0],i=(t[1]-n)/e,a=[];++r<=e;)a[r]=i*r+n;return a}function Mi(t){return[uo.min(t),uo.max(t)]}function ki(t,e){return t.value-e.value}function Ai(t,e){var r=t._pack_next;t._pack_next=e,e._pack_prev=t,e._pack_next=r,r._pack_prev=e}function Ti(t,e){t._pack_next=e,e._pack_prev=t}function Si(t,e){var r=e.x-t.x,n=e.y-t.y,i=t.r+e.r;return.999*i*i>r*r+n*n}function Ei(t){function e(t){c=Math.min(t.x-t.r,c),h=Math.max(t.x+t.r,h),f=Math.min(t.y-t.r,f),d=Math.max(t.y+t.r,d)}if((r=t.children)&&(u=r.length)){var r,n,i,a,o,s,l,u,c=1/0,h=-1/0,f=1/0,d=-1/0;if(r.forEach(Li),n=r[0],n.x=-n.r,n.y=0,e(n),u>1&&(i=r[1],i.x=i.r,i.y=0,e(i),u>2))for(a=r[2],Ii(n,i,a),e(a),Ai(n,a),n._pack_prev=a,Ai(a,i),i=n._pack_next,o=3;o<u;o++){Ii(n,i,a=r[o]);var p=0,m=1,v=1;for(s=i._pack_next;s!==i;s=s._pack_next,m++)if(Si(s,a)){p=1;break}if(1==p)for(l=n._pack_prev;l!==s._pack_prev&&!Si(l,a);l=l._pack_prev,v++);p?(m<v||m==v&&i.r<n.r?Ti(n,i=s):Ti(n=l,i),o--):(Ai(n,a),i=a,e(a))}var g=(c+h)/2,y=(f+d)/2,b=0;for(o=0;o<u;o++)a=r[o],a.x-=g,a.y-=y,b=Math.max(b,a.r+Math.sqrt(a.x*a.x+a.y*a.y));t.r=b,r.forEach(Ci)}}function Li(t){t._pack_next=t._pack_prev=t}function Ci(t){delete t._pack_next,delete t._pack_prev}function zi(t,e,r,n){var i=t.children;if(t.x=e+=n*t.x,t.y=r+=n*t.y,t.r*=n,i)for(var a=-1,o=i.length;++a<o;)zi(i[a],e,r,n)}function Ii(t,e,r){var n=t.r+r.r,i=e.x-t.x,a=e.y-t.y;if(n&&(i||a)){var o=e.r+r.r,s=i*i+a*a;o*=o,n*=n;var l=.5+(n-o)/(2*s),u=Math.sqrt(Math.max(0,2*o*(n+s)-(n-=s)*n-o*o))/(2*s);r.x=t.x+l*i+u*a,r.y=t.y+l*a-u*i}else r.x=t.x+n,r.y=t.y}function Di(t,e){return t.parent==e.parent?1:2}function Pi(t){var e=t.children;return e.length?e[0]:t.t}function Oi(t){var e,r=t.children;return(e=r.length)?r[e-1]:t.t}function Ri(t,e,r){var n=r/(e.i-t.i);e.c-=n,e.s+=r,t.c+=n,e.z+=r,e.m+=r}function Fi(t){for(var e,r=0,n=0,i=t.children,a=i.length;--a>=0;)e=i[a],e.z+=r,e.m+=r,r+=e.s+(n+=e.c)}function ji(t,e,r){return t.a.parent===e.parent?t.a:r}function Ni(t){return 1+uo.max(t,function(t){return t.y})}function Bi(t){return t.reduce(function(t,e){return t+e.x},0)/t.length}function Ui(t){var e=t.children;return e&&e.length?Ui(e[0]):t}function Vi(t){var e,r=t.children;return r&&(e=r.length)?Vi(r[e-1]):t}function Hi(t){return{x:t.x,y:t.y,dx:t.dx,dy:t.dy}}function qi(t,e){var r=t.x+e[3],n=t.y+e[0],i=t.dx-e[1]-e[3],a=t.dy-e[0]-e[2];return i<0&&(r+=i/2,i=0),a<0&&(n+=a/2,a=0),{x:r,y:n,dx:i,dy:a}}function Gi(t){var e=t[0],r=t[t.length-1];return e<r?[e,r]:[r,e]}function Yi(t){return t.rangeExtent?t.rangeExtent():Gi(t.range())}function Xi(t,e,r,n){var i=r(t[0],t[1]),a=n(e[0],e[1]);return function(t){return a(i(t))}}function Wi(t,e){var r,n=0,i=t.length-1,a=t[n],o=t[i];return o<a&&(r=n,n=i,i=r,r=a,a=o,o=r),t[n]=e.floor(a),t[i]=e.ceil(o),t}function Zi(t){return t?{floor:function(e){return Math.floor(e/t)*t},ceil:function(e){return Math.ceil(e/t)*t}}:wl}function Ji(t,e,r,n){var i=[],a=[],o=0,s=Math.min(t.length,e.length)-1;for(t[s]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++o<=s;)i.push(r(t[o-1],t[o])),a.push(n(e[o-1],e[o]));return function(e){var r=uo.bisect(t,e,1,s)-1;return a[r](i[r](e))}}function Ki(t,e,r,n){function i(){var i=Math.min(t.length,e.length)>2?Ji:Xi,l=n?Kn:Jn;return o=i(t,e,l,r),s=i(e,t,l,_n),a}function a(t){return o(t)}var o,s;return a.invert=function(t){return s(t)},a.domain=function(e){return arguments.length?(t=e.map(Number),i()):t},a.range=function(t){return arguments.length?(e=t,i()):e},a.rangeRound=function(t){return a.range(t).interpolate(Nn)},a.clamp=function(t){return arguments.length?(n=t,i()):n},a.interpolate=function(t){return arguments.length?(r=t,i()):r},a.ticks=function(e){return ea(t,e)},a.tickFormat=function(e,r){return ra(t,e,r)},a.nice=function(e){return $i(t,e),i()},a.copy=function(){return Ki(t,e,r,n)},i()}function Qi(t,e){return uo.rebind(t,e,\"range\",\"rangeRound\",\"interpolate\",\"clamp\")}function $i(t,e){return Wi(t,Zi(ta(t,e)[2])),Wi(t,Zi(ta(t,e)[2])),t}function ta(t,e){null==e&&(e=10);var r=Gi(t),n=r[1]-r[0],i=Math.pow(10,Math.floor(Math.log(n/e)/Math.LN10)),a=e/n*i;return a<=.15?i*=10:a<=.35?i*=5:a<=.75&&(i*=2),r[0]=Math.ceil(r[0]/i)*i,r[1]=Math.floor(r[1]/i)*i+.5*i,r[2]=i,r}function ea(t,e){return uo.range.apply(uo,ta(t,e))}function ra(t,e,r){var n=ta(t,e);if(r){var i=cs.exec(r);if(i.shift(),\"s\"===i[8]){var a=uo.formatPrefix(Math.max(xo(n[0]),xo(n[1])));return i[7]||(i[7]=\".\"+na(a.scale(n[2]))),i[8]=\"f\",r=uo.format(i.join(\"\")),function(t){return r(a.scale(t))+a.symbol}}i[7]||(i[7]=\".\"+ia(i[8],n)),r=i.join(\"\")}else r=\",.\"+na(n[2])+\"f\";return uo.format(r)}function na(t){return-Math.floor(Math.log(t)/Math.LN10+.01)}function ia(t,e){var r=na(e[2]);return t in Ml?Math.abs(r-na(Math.max(xo(e[0]),xo(e[1]))))+ +(\"e\"!==t):r-2*(\"%\"===t)}function aa(t,e,r,n){function i(t){return(r?Math.log(t<0?0:t):-Math.log(t>0?0:-t))/Math.log(e)}function a(t){return r?Math.pow(e,t):-Math.pow(e,-t)}function o(e){return t(i(e))}return o.invert=function(e){return a(t.invert(e))},o.domain=function(e){return arguments.length?(r=e[0]>=0,t.domain((n=e.map(Number)).map(i)),o):n},o.base=function(r){return arguments.length?(e=+r,t.domain(n.map(i)),o):e},o.nice=function(){var e=Wi(n.map(i),r?Math:Al);return t.domain(e),n=e.map(a),o},o.ticks=function(){var t=Gi(n),o=[],s=t[0],l=t[1],u=Math.floor(i(s)),c=Math.ceil(i(l)),h=e%1?2:e;if(isFinite(c-u)){if(r){for(;u<c;u++)for(var f=1;f<h;f++)o.push(a(u)*f);o.push(a(u))}else for(o.push(a(u));u++<c;)for(var f=h-1;f>0;f--)o.push(a(u)*f);for(u=0;o[u]<s;u++);for(c=o.length;o[c-1]>l;c--);o=o.slice(u,c)}return o},o.tickFormat=function(t,r){if(!arguments.length)return kl;arguments.length<2?r=kl:\"function\"!=typeof r&&(r=uo.format(r));var n=Math.max(1,e*t/o.ticks().length);return function(t){var o=t/a(Math.round(i(t)));return o*e<e-.5&&(o*=e),o<=n?r(t):\"\"}},o.copy=function(){return aa(t.copy(),e,r,n)},Qi(o,t)}function oa(t,e,r){function n(e){return t(i(e))}var i=sa(e),a=sa(1/e);return n.invert=function(e){return a(t.invert(e))},n.domain=function(e){return arguments.length?(t.domain((r=e.map(Number)).map(i)),n):r},n.ticks=function(t){return ea(r,t)},n.tickFormat=function(t,e){return ra(r,t,e)},n.nice=function(t){return n.domain($i(r,t))},n.exponent=function(o){return arguments.length?(i=sa(e=o),a=sa(1/e),t.domain(r.map(i)),n):e},n.copy=function(){return oa(t.copy(),e,r)},Qi(n,t)}function sa(t){return function(e){return e<0?-Math.pow(-e,t):Math.pow(e,t)}}function la(t,e){function r(r){return a[((i.get(r)||(\"range\"===e.t?i.set(r,t.push(r)):NaN))-1)%a.length]}function n(e,r){return uo.range(t.length).map(function(t){return e+r*t})}var i,a,o;return r.domain=function(n){if(!arguments.length)return t;t=[],i=new h;for(var a,o=-1,s=n.length;++o<s;)i.has(a=n[o])||i.set(a,t.push(a));return r[e.t].apply(r,e.a)},r.range=function(t){return arguments.length?(a=t,o=0,e={t:\"range\",a:arguments},r):a},r.rangePoints=function(i,s){arguments.length<2&&(s=0);var l=i[0],u=i[1],c=t.length<2?(l=(l+u)/2,0):(u-l)/(t.length-1+s);return a=n(l+c*s/2,c),o=0,e={t:\"rangePoints\",a:arguments},r},r.rangeRoundPoints=function(i,s){arguments.length<2&&(s=0);var l=i[0],u=i[1],c=t.length<2?(l=u=Math.round((l+u)/2),0):(u-l)/(t.length-1+s)|0;return a=n(l+Math.round(c*s/2+(u-l-(t.length-1+s)*c)/2),c),o=0,e={t:\"rangeRoundPoints\",a:arguments},r},r.rangeBands=function(i,s,l){arguments.length<2&&(s=0),arguments.length<3&&(l=s);var u=i[1]<i[0],c=i[u-0],h=i[1-u],f=(h-c)/(t.length-s+2*l);return a=n(c+f*l,f),u&&a.reverse(),o=f*(1-s),e={t:\"rangeBands\",a:arguments},r},r.rangeRoundBands=function(i,s,l){arguments.length<2&&(s=0),arguments.length<3&&(l=s);var u=i[1]<i[0],c=i[u-0],h=i[1-u],f=Math.floor((h-c)/(t.length-s+2*l));return a=n(c+Math.round((h-c-(t.length-s)*f)/2),f),u&&a.reverse(),o=Math.round(f*(1-s)),e={t:\"rangeRoundBands\",a:arguments},r},r.rangeBand=function(){return o},r.rangeExtent=function(){return Gi(e.a[0])},r.copy=function(){return la(t,e)},r.domain(t)}function ua(t,e){function r(){var r=0,i=e.length;for(s=[];++r<i;)s[r-1]=uo.quantile(t,r/i);return n}function n(t){if(!isNaN(t=+t))return e[uo.bisect(s,t)]}var s;return n.domain=function(e){return arguments.length?(t=e.map(a).filter(o).sort(i),r()):t},n.range=function(t){return arguments.length?(e=t,r()):e},n.quantiles=function(){return s},n.invertExtent=function(r){return r=e.indexOf(r),r<0?[NaN,NaN]:[r>0?s[r-1]:t[0],r<s.length?s[r]:t[t.length-1]]},n.copy=function(){return ua(t,e)},r()}function ca(t,e,r){function n(e){return r[Math.max(0,Math.min(o,Math.floor(a*(e-t))))]}function i(){return a=r.length/(e-t),o=r.length-1,n}var a,o;return n.domain=function(r){return arguments.length?(t=+r[0],e=+r[r.length-1],i()):[t,e]},n.range=function(t){return arguments.length?(r=t,i()):r},n.invertExtent=function(e){return e=r.indexOf(e),e=e<0?NaN:e/a+t,[e,e+1/a]},n.copy=function(){return ca(t,e,r)},i()}function ha(t,e){function r(r){if(r<=r)return e[uo.bisect(t,r)]}return r.domain=function(e){return arguments.length?(t=e,r):t},r.range=function(t){return arguments.length?(e=t,r):e},r.invertExtent=function(r){return r=e.indexOf(r),[t[r-1],t[r]]},r.copy=function(){return ha(t,e)},r}function fa(t){function e(t){return+t}return e.invert=e,e.domain=e.range=function(r){return arguments.length?(t=r.map(e),e):t},e.ticks=function(e){return ea(t,e)},e.tickFormat=function(e,r){return ra(t,e,r)},e.copy=function(){return fa(t)},e}function da(){return 0}function pa(t){return t.innerRadius}function ma(t){return t.outerRadius}function va(t){return t.startAngle}function ga(t){return t.endAngle}function ya(t){return t&&t.padAngle}function ba(t,e,r,n){return(t-r)*e-(e-n)*t>0?0:1}function xa(t,e,r,n,i){var a=t[0]-e[0],o=t[1]-e[1],s=(i?n:-n)/Math.sqrt(a*a+o*o),l=s*o,u=-s*a,c=t[0]+l,h=t[1]+u,f=e[0]+l,d=e[1]+u,p=(c+f)/2,m=(h+d)/2,v=f-c,g=d-h,y=v*v+g*g,b=r-n,x=c*d-f*h,_=(g<0?-1:1)*Math.sqrt(Math.max(0,b*b*y-x*x)),w=(x*g-v*_)/y,M=(-x*v-g*_)/y,k=(x*g+v*_)/y,A=(-x*v+g*_)/y,T=w-p,S=M-m,E=k-p,L=A-m;return T*T+S*S>E*E+L*L&&(w=k,M=A),[[w-l,M-u],[w*r/b,M*r/b]]}function _a(t){function e(e){function o(){u.push(\"M\",a(t(c),s))}for(var l,u=[],c=[],h=-1,f=e.length,d=Et(r),p=Et(n);++h<f;)i.call(this,l=e[h],h)?c.push([+d.call(this,l,h),+p.call(this,l,h)]):c.length&&(o(),c=[]);return c.length&&o(),u.length?u.join(\"\"):null}var r=Cr,n=zr,i=ze,a=wa,o=a.key,s=.7;return e.x=function(t){return arguments.length?(r=t,e):r},e.y=function(t){return arguments.length?(n=t,e):n},e.defined=function(t){return arguments.length?(i=t,e):i},e.interpolate=function(t){return arguments.length?(o=\"function\"==typeof t?a=t:(a=zl.get(t)||wa).key,e):o},e.tension=function(t){return arguments.length?(s=t,e):s},e}function wa(t){return t.length>1?t.join(\"L\"):t+\"Z\"}function Ma(t){return t.join(\"L\")+\"Z\"}function ka(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"H\",(n[0]+(n=t[e])[0])/2,\"V\",n[1]);return r>1&&i.push(\"H\",n[0]),i.join(\"\")}function Aa(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"V\",(n=t[e])[1],\"H\",n[0]);return i.join(\"\")}function Ta(t){for(var e=0,r=t.length,n=t[0],i=[n[0],\",\",n[1]];++e<r;)i.push(\"H\",(n=t[e])[0],\"V\",n[1]);return i.join(\"\")}function Sa(t,e){return t.length<4?wa(t):t[1]+Ca(t.slice(1,-1),za(t,e))}function Ea(t,e){return t.length<3?Ma(t):t[0]+Ca((t.push(t[0]),t),za([t[t.length-2]].concat(t,[t[1]]),e))}function La(t,e){return t.length<3?wa(t):t[0]+Ca(t,za(t,e))}function Ca(t,e){if(e.length<1||t.length!=e.length&&t.length!=e.length+2)return wa(t);var r=t.length!=e.length,n=\"\",i=t[0],a=t[1],o=e[0],s=o,l=1;if(r&&(n+=\"Q\"+(a[0]-2*o[0]/3)+\",\"+(a[1]-2*o[1]/3)+\",\"+a[0]+\",\"+a[1],i=t[1],l=2),e.length>1){s=e[1],a=t[l],l++,n+=\"C\"+(i[0]+o[0])+\",\"+(i[1]+o[1])+\",\"+(a[0]-s[0])+\",\"+(a[1]-s[1])+\",\"+a[0]+\",\"+a[1];for(var u=2;u<e.length;u++,l++)a=t[l],s=e[u],n+=\"S\"+(a[0]-s[0])+\",\"+(a[1]-s[1])+\",\"+a[0]+\",\"+a[1]}if(r){var c=t[l];n+=\"Q\"+(a[0]+2*s[0]/3)+\",\"+(a[1]+2*s[1]/3)+\",\"+c[0]+\",\"+c[1]}return n}function za(t,e){for(var r,n=[],i=(1-e)/2,a=t[0],o=t[1],s=1,l=t.length;++s<l;)r=a,a=o,o=t[s],n.push([i*(o[0]-r[0]),i*(o[1]-r[1])]);return n}function Ia(t){if(t.length<3)return wa(t);var e=1,r=t.length,n=t[0],i=n[0],a=n[1],o=[i,i,i,(n=t[1])[0]],s=[a,a,a,n[1]],l=[i,\",\",a,\"L\",Ra(Pl,o),\",\",Ra(Pl,s)];for(t.push(t[r-1]);++e<=r;)n=t[e],o.shift(),o.push(n[0]),s.shift(),s.push(n[1]),Fa(l,o,s);return t.pop(),l.push(\"L\",n),l.join(\"\")}function Da(t){if(t.length<4)return wa(t);for(var e,r=[],n=-1,i=t.length,a=[0],o=[0];++n<3;)e=t[n],a.push(e[0]),o.push(e[1]);for(r.push(Ra(Pl,a)+\",\"+Ra(Pl,o)),--n;++n<i;)e=t[n],a.shift(),a.push(e[0]),o.shift(),o.push(e[1]),Fa(r,a,o);return r.join(\"\")}function Pa(t){for(var e,r,n=-1,i=t.length,a=i+4,o=[],s=[];++n<4;)r=t[n%i],o.push(r[0]),s.push(r[1]);for(e=[Ra(Pl,o),\",\",Ra(Pl,s)],--n;++n<a;)r=t[n%i],o.shift(),o.push(r[0]),s.shift(),s.push(r[1]),Fa(e,o,s);return e.join(\"\")}function Oa(t,e){var r=t.length-1;if(r)for(var n,i,a=t[0][0],o=t[0][1],s=t[r][0]-a,l=t[r][1]-o,u=-1;++u<=r;)n=t[u],i=u/r,n[0]=e*n[0]+(1-e)*(a+i*s),n[1]=e*n[1]+(1-e)*(o+i*l);return Ia(t)}function Ra(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]}function Fa(t,e,r){t.push(\"C\",Ra(Il,e),\",\",Ra(Il,r),\",\",Ra(Dl,e),\",\",Ra(Dl,r),\",\",Ra(Pl,e),\",\",Ra(Pl,r))}function ja(t,e){return(e[1]-t[1])/(e[0]-t[0])}function Na(t){for(var e=0,r=t.length-1,n=[],i=t[0],a=t[1],o=n[0]=ja(i,a);++e<r;)n[e]=(o+(o=ja(i=a,a=t[e+1])))/2;return n[e]=o,n}function Ba(t){for(var e,r,n,i,a=[],o=Na(t),s=-1,l=t.length-1;++s<l;)e=ja(t[s],t[s+1]),xo(e)<Fo?o[s]=o[s+1]=0:(r=o[s]/e,n=o[s+1]/e,(i=r*r+n*n)>9&&(i=3*e/Math.sqrt(i),o[s]=i*r,o[s+1]=i*n));for(s=-1;++s<=l;)i=(t[Math.min(l,s+1)][0]-t[Math.max(0,s-1)][0])/(6*(1+o[s]*o[s])),a.push([i||0,o[s]*i||0]);return a}function Ua(t){return t.length<3?wa(t):t[0]+Ca(t,Ba(t))}function Va(t){for(var e,r,n,i=-1,a=t.length;++i<a;)e=t[i],r=e[0],n=e[1]-Vo,e[0]=r*Math.cos(n),e[1]=r*Math.sin(n);return t}function Ha(t){function e(e){function l(){m.push(\"M\",s(t(g),h),c,u(t(v.reverse()),h),\"Z\")}for(var f,d,p,m=[],v=[],g=[],y=-1,b=e.length,x=Et(r),_=Et(i),w=r===n?function(){return d}:Et(n),M=i===a?function(){return p}:Et(a);++y<b;)o.call(this,f=e[y],y)?(v.push([d=+x.call(this,f,y),p=+_.call(this,f,y)]),g.push([+w.call(this,f,y),+M.call(this,f,y)])):v.length&&(l(),v=[],g=[]);return v.length&&l(),m.length?m.join(\"\"):null}var r=Cr,n=Cr,i=0,a=zr,o=ze,s=wa,l=s.key,u=s,c=\"L\",h=.7;return e.x=function(t){return arguments.length?(r=n=t,e):n},e.x0=function(t){return arguments.length?(r=t,e):r},e.x1=function(t){return arguments.length?(n=t,e):n},e.y=function(t){return arguments.length?(i=a=t,e):a},e.y0=function(t){return arguments.length?(i=t,e):i},e.y1=function(t){return arguments.length?(a=t,e):a},e.defined=function(t){return arguments.length?(o=t,e):o},e.interpolate=function(t){return arguments.length?(l=\"function\"==typeof t?s=t:(s=zl.get(t)||wa).key,u=s.reverse||s,c=s.closed?\"M\":\"L\",e):l},e.tension=function(t){return arguments.length?(h=t,e):h},e}function qa(t){return t.radius}function Ga(t){return[t.x,t.y]}function Ya(t){return function(){var e=t.apply(this,arguments),r=e[0],n=e[1]-Vo;return[r*Math.cos(n),r*Math.sin(n)]}}function Xa(){return 64}function Wa(){return\"circle\"}function Za(t){var e=Math.sqrt(t/No);return\"M0,\"+e+\"A\"+e+\",\"+e+\" 0 1,1 0,\"+-e+\"A\"+e+\",\"+e+\" 0 1,1 0,\"+e+\"Z\"}function Ja(t){return function(){var e,r,n;(e=this[t])&&(n=e[r=e.active])&&(n.timer.c=null,n.timer.t=NaN,--e.count?delete e[r]:delete this[t],e.active+=.5,n.event&&n.event.interrupt.call(this,this.__data__,n.index))}}function Ka(t,e,r){return Ao(t,Ul),t.namespace=e,t.id=r,t}function Qa(t,e,r,n){var i=t.id,a=t.namespace;return G(t,\"function\"==typeof r?function(t,o,s){t[a][i].tween.set(e,n(r.call(t,t.__data__,o,s)))}:(r=n(r),function(t){t[a][i].tween.set(e,r)}))}function $a(t){return null==t&&(t=\"\"),function(){this.textContent=t}}function to(t){return null==t?\"__transition__\":\"__transition_\"+t+\"__\"}function eo(t,e,r,n,i){function a(t){var e=m.delay;if(u.t=e+l,e<=t)return o(t-e);u.c=o}function o(r){var i=p.active,a=p[i];a&&(a.timer.c=null,a.timer.t=NaN,--p.count,delete p[i],a.event&&a.event.interrupt.call(t,t.__data__,a.index));for(var o in p)if(+o<n){var h=p[o];h.timer.c=null,h.timer.t=NaN,--p.count,delete p[o]}u.c=s,Dt(function(){return u.c&&s(r||1)&&(u.c=null,u.t=NaN),1},0,l),p.active=n,m.event&&m.event.start.call(t,t.__data__,e),d=[],m.tween.forEach(function(r,n){(n=n.call(t,t.__data__,e))&&d.push(n)}),f=m.ease,c=m.duration}function s(i){for(var a=i/c,o=f(a),s=d.length;s>0;)d[--s].call(t,o);if(a>=1)return m.event&&m.event.end.call(t,t.__data__,e),--p.count?delete p[n]:delete t[r],1}var l,u,c,f,d,p=t[r]||(t[r]={active:0,count:0}),m=p[n];m||(l=i.time,u=Dt(a,0,l),m=p[n]={tween:new h,time:l,timer:u,delay:i.delay,duration:i.duration,ease:i.ease,index:e},i=null,++p.count)}function ro(t,e,r){t.attr(\"transform\",function(t){var n=e(t);return\"translate(\"+(isFinite(n)?n:r(t))+\",0)\"})}function no(t,e,r){t.attr(\"transform\",function(t){var n=e(t);return\"translate(0,\"+(isFinite(n)?n:r(t))+\")\"})}function io(t){return t.toISOString()}function ao(t,e,r){function n(e){return t(e)}function i(t,r){var n=t[1]-t[0],i=n/r,a=uo.bisect(Jl,i);return a==Jl.length?[e.year,ta(t.map(function(t){return t/31536e6}),r)[2]]:a?e[i/Jl[a-1]<Jl[a]/i?a-1:a]:[$l,ta(t,r)[2]]}return n.invert=function(e){return oo(t.invert(e))},n.domain=function(e){return arguments.length?(t.domain(e),n):t.domain().map(oo)},n.nice=function(t,e){function r(r){return!isNaN(r)&&!t.range(r,oo(+r+1),e).length}var a=n.domain(),o=Gi(a),s=null==t?i(o,10):\"number\"==typeof t&&i(o,t);return s&&(t=s[0],e=s[1]),n.domain(Wi(a,e>1?{floor:function(e){for(;r(e=t.floor(e));)e=oo(e-1);return e},ceil:function(e){for(;r(e=t.ceil(e));)e=oo(+e+1);return e}}:t))},n.ticks=function(t,e){var r=Gi(n.domain()),a=null==t?i(r,10):\"number\"==typeof t?i(r,t):!t.range&&[{range:t},e];return a&&(t=a[0],e=a[1]),t.range(r[0],oo(+r[1]+1),e<1?1:e)},n.tickFormat=function(){return r},n.copy=function(){return ao(t.copy(),e,r)},Qi(n,t)}function oo(t){return new Date(t)}function so(t){return JSON.parse(t.responseText)}function lo(t){var e=fo.createRange();return e.selectNode(fo.body),e.createContextualFragment(t.responseText)}var uo={version:\"3.5.17\"},co=[].slice,ho=function(t){return co.call(t)},fo=this.document;if(fo)try{ho(fo.documentElement.childNodes)[0].nodeType}catch(t){ho=function(t){for(var e=t.length,r=new Array(e);e--;)r[e]=t[e];return r}}if(Date.now||(Date.now=function(){return+new Date}),fo)try{fo.createElement(\"DIV\").style.setProperty(\"opacity\",0,\"\")}catch(t){var po=this.Element.prototype,mo=po.setAttribute,vo=po.setAttributeNS,go=this.CSSStyleDeclaration.prototype,yo=go.setProperty;po.setAttribute=function(t,e){mo.call(this,t,e+\"\")},po.setAttributeNS=function(t,e,r){vo.call(this,t,e,r+\"\")},go.setProperty=function(t,e,r){yo.call(this,t,e+\"\",r)}}uo.ascending=i,uo.descending=function(t,e){return e<t?-1:e>t?1:e>=t?0:NaN},uo.min=function(t,e){var r,n,i=-1,a=t.length;if(1===arguments.length){for(;++i<a;)if(null!=(n=t[i])&&n>=n){r=n;break}for(;++i<a;)null!=(n=t[i])&&r>n&&(r=n)}else{for(;++i<a;)if(null!=(n=e.call(t,t[i],i))&&n>=n){r=n;break}for(;++i<a;)null!=(n=e.call(t,t[i],i))&&r>n&&(r=n)}return r},uo.max=function(t,e){var r,n,i=-1,a=t.length;if(1===arguments.length){for(;++i<a;)if(null!=(n=t[i])&&n>=n){r=n;break}for(;++i<a;)null!=(n=t[i])&&n>r&&(r=n)}else{for(;++i<a;)if(null!=(n=e.call(t,t[i],i))&&n>=n){r=n;break}for(;++i<a;)null!=(n=e.call(t,t[i],i))&&n>r&&(r=n)}return r},uo.extent=function(t,e){var r,n,i,a=-1,o=t.length;if(1===arguments.length){for(;++a<o;)if(null!=(n=t[a])&&n>=n){r=i=n;break}for(;++a<o;)null!=(n=t[a])&&(r>n&&(r=n),i<n&&(i=n))}else{for(;++a<o;)if(null!=(n=e.call(t,t[a],a))&&n>=n){r=i=n;break}for(;++a<o;)null!=(n=e.call(t,t[a],a))&&(r>n&&(r=n),i<n&&(i=n))}return[r,i]},uo.sum=function(t,e){var r,n=0,i=t.length,a=-1;if(1===arguments.length)for(;++a<i;)o(r=+t[a])&&(n+=r);else for(;++a<i;)o(r=+e.call(t,t[a],a))&&(n+=r);return n},uo.mean=function(t,e){var r,n=0,i=t.length,s=-1,l=i;if(1===arguments.length)for(;++s<i;)o(r=a(t[s]))?n+=r:--l;else for(;++s<i;)o(r=a(e.call(t,t[s],s)))?n+=r:--l;if(l)return n/l},uo.quantile=function(t,e){var r=(t.length-1)*e+1,n=Math.floor(r),i=+t[n-1],a=r-n;return a?i+a*(t[n]-i):i},uo.median=function(t,e){var r,n=[],s=t.length,l=-1;if(1===arguments.length)for(;++l<s;)o(r=a(t[l]))&&n.push(r);else for(;++l<s;)o(r=a(e.call(t,t[l],l)))&&n.push(r);if(n.length)return uo.quantile(n.sort(i),.5)},uo.variance=function(t,e){var r,n,i=t.length,s=0,l=0,u=-1,c=0;if(1===arguments.length)for(;++u<i;)o(r=a(t[u]))&&(n=r-s,s+=n/++c,l+=n*(r-s));else for(;++u<i;)o(r=a(e.call(t,t[u],u)))&&(n=r-s,s+=n/++c,l+=n*(r-s));if(c>1)return l/(c-1)},uo.deviation=function(){var t=uo.variance.apply(this,arguments);return t?Math.sqrt(t):t};var bo=s(i);uo.bisectLeft=bo.left,uo.bisect=uo.bisectRight=bo.right,uo.bisector=function(t){return s(1===t.length?function(e,r){return i(t(e),r)}:t)},uo.shuffle=function(t,e,r){(a=arguments.length)<3&&(r=t.length,a<2&&(e=0));for(var n,i,a=r-e;a;)i=Math.random()*a--|0,n=t[a+e],t[a+e]=t[i+e],t[i+e]=n;return t},uo.permute=function(t,e){for(var r=e.length,n=new Array(r);r--;)n[r]=t[e[r]];return n},uo.pairs=function(t){for(var e=0,r=t.length-1,n=t[0],i=new Array(r<0?0:r);e<r;)i[e]=[n,n=t[++e]];return i},uo.transpose=function(t){if(!(i=t.length))return[];for(var e=-1,r=uo.min(t,l),n=new Array(r);++e<r;)for(var i,a=-1,o=n[e]=new Array(i);++a<i;)o[a]=t[a][e];return n},uo.zip=function(){return uo.transpose(arguments)},uo.keys=function(t){var e=[];for(var r in t)e.push(r);return e},uo.values=function(t){var e=[];for(var r in t)e.push(t[r]);return e},uo.entries=function(t){var e=[];for(var r in t)e.push({key:r,value:t[r]});return e},uo.merge=function(t){for(var e,r,n,i=t.length,a=-1,o=0;++a<i;)o+=t[a].length;for(r=new Array(o);--i>=0;)for(n=t[i],e=n.length;--e>=0;)r[--o]=n[e];return r};var xo=Math.abs;uo.range=function(t,e,r){if(arguments.length<3&&(r=1,arguments.length<2&&(e=t,t=0)),(e-t)/r==1/0)throw new Error(\"infinite range\");var n,i=[],a=u(xo(r)),o=-1;if(t*=a,e*=a,r*=a,r<0)for(;(n=t+r*++o)>e;)i.push(n/a);else for(;(n=t+r*++o)<e;)i.push(n/a);return i},uo.map=function(t,e){var r=new h;if(t instanceof h)t.forEach(function(t,e){r.set(t,e)});else if(Array.isArray(t)){var n,i=-1,a=t.length;if(1===arguments.length)for(;++i<a;)r.set(i,t[i]);else for(;++i<a;)r.set(e.call(t,n=t[i],i),n)}else for(var o in t)r.set(o,t[o]);return r};var _o=\"__proto__\",wo=\"\\0\";c(h,{has:p,get:function(t){return this._[f(t)]},set:function(t,e){return this._[f(t)]=e},remove:m,keys:v,values:function(){var t=[];for(var e in this._)t.push(this._[e]);return t},entries:function(){var t=[];for(var e in this._)t.push({key:d(e),value:this._[e]});return t},size:g,empty:y,forEach:function(t){for(var e in this._)t.call(this,d(e),this._[e])}}),uo.nest=function(){function t(e,o,s){if(s>=a.length)return n?n.call(i,o):r?o.sort(r):o;for(var l,u,c,f,d=-1,p=o.length,m=a[s++],v=new h;++d<p;)(f=v.get(l=m(u=o[d])))?f.push(u):v.set(l,[u]);return e?(u=e(),c=function(r,n){u.set(r,t(e,n,s))}):(u={},c=function(r,n){u[r]=t(e,n,s)}),v.forEach(c),u}function e(t,r){if(r>=a.length)return t;var n=[],i=o[r++];return t.forEach(function(t,i){n.push({key:t,values:e(i,r)})}),i?n.sort(function(t,e){return i(t.key,e.key)}):n}var r,n,i={},a=[],o=[];return i.map=function(e,r){return t(r,e,0)},i.entries=function(r){return e(t(uo.map,r,0),0)},i.key=function(t){return a.push(t),i},i.sortKeys=function(t){return o[a.length-1]=t,i},i.sortValues=function(t){return r=t,i},i.rollup=function(t){return n=t,i},i},uo.set=function(t){var e=new b;if(t)for(var r=0,n=t.length;r<n;++r)e.add(t[r]);return e},c(b,{has:p,add:function(t){return this._[f(t+=\"\")]=!0,t},remove:m,values:v,size:g,empty:y,forEach:function(t){for(var e in this._)t.call(this,d(e))}}),uo.behavior={},uo.rebind=function(t,e){for(var r,n=1,i=arguments.length;++n<i;)t[r=arguments[n]]=_(t,e,e[r]);return t}\n",
       ";var Mo=[\"webkit\",\"ms\",\"moz\",\"Moz\",\"o\",\"O\"];uo.dispatch=function(){for(var t=new k,e=-1,r=arguments.length;++e<r;)t[arguments[e]]=A(t);return t},k.prototype.on=function(t,e){var r=t.indexOf(\".\"),n=\"\";if(r>=0&&(n=t.slice(r+1),t=t.slice(0,r)),t)return arguments.length<2?this[t].on(n):this[t].on(n,e);if(2===arguments.length){if(null==e)for(t in this)this.hasOwnProperty(t)&&this[t].on(n,null);return this}},uo.event=null,uo.requote=function(t){return t.replace(ko,\"\\\\$&\")};var ko=/[\\\\\\^\\$\\*\\+\\?\\|\\[\\]\\(\\)\\.\\{\\}]/g,Ao={}.__proto__?function(t,e){t.__proto__=e}:function(t,e){for(var r in e)t[r]=e[r]},To=function(t,e){return e.querySelector(t)},So=function(t,e){return e.querySelectorAll(t)},Eo=function(t,e){var r=t.matches||t[w(t,\"matchesSelector\")];return(Eo=function(t,e){return r.call(t,e)})(t,e)};\"function\"==typeof Sizzle&&(To=function(t,e){return Sizzle(t,e)[0]||null},So=Sizzle,Eo=Sizzle.matchesSelector),uo.selection=function(){return uo.select(fo.documentElement)};var Lo=uo.selection.prototype=[];Lo.select=function(t){var e,r,n,i,a=[];t=C(t);for(var o=-1,s=this.length;++o<s;){a.push(e=[]),e.parentNode=(n=this[o]).parentNode;for(var l=-1,u=n.length;++l<u;)(i=n[l])?(e.push(r=t.call(i,i.__data__,l,o)),r&&\"__data__\"in i&&(r.__data__=i.__data__)):e.push(null)}return L(a)},Lo.selectAll=function(t){var e,r,n=[];t=z(t);for(var i=-1,a=this.length;++i<a;)for(var o=this[i],s=-1,l=o.length;++s<l;)(r=o[s])&&(n.push(e=ho(t.call(r,r.__data__,s,i))),e.parentNode=r);return L(n)};var Co=\"http://www.w3.org/1999/xhtml\",zo={svg:\"http://www.w3.org/2000/svg\",xhtml:Co,xlink:\"http://www.w3.org/1999/xlink\",xml:\"http://www.w3.org/XML/1998/namespace\",xmlns:\"http://www.w3.org/2000/xmlns/\"};uo.ns={prefix:zo,qualify:function(t){var e=t.indexOf(\":\"),r=t;return e>=0&&\"xmlns\"!==(r=t.slice(0,e))&&(t=t.slice(e+1)),zo.hasOwnProperty(r)?{space:zo[r],local:t}:t}},Lo.attr=function(t,e){if(arguments.length<2){if(\"string\"==typeof t){var r=this.node();return t=uo.ns.qualify(t),t.local?r.getAttributeNS(t.space,t.local):r.getAttribute(t)}for(e in t)this.each(I(e,t[e]));return this}return this.each(I(t,e))},Lo.classed=function(t,e){if(arguments.length<2){if(\"string\"==typeof t){var r=this.node(),n=(t=O(t)).length,i=-1;if(e=r.classList){for(;++i<n;)if(!e.contains(t[i]))return!1}else for(e=r.getAttribute(\"class\");++i<n;)if(!P(t[i]).test(e))return!1;return!0}for(e in t)this.each(R(e,t[e]));return this}return this.each(R(t,e))},Lo.style=function(t,e,r){var i=arguments.length;if(i<3){if(\"string\"!=typeof t){i<2&&(e=\"\");for(r in t)this.each(j(r,t[r],e));return this}if(i<2){var a=this.node();return n(a).getComputedStyle(a,null).getPropertyValue(t)}r=\"\"}return this.each(j(t,e,r))},Lo.property=function(t,e){if(arguments.length<2){if(\"string\"==typeof t)return this.node()[t];for(e in t)this.each(N(e,t[e]));return this}return this.each(N(t,e))},Lo.text=function(t){return arguments.length?this.each(\"function\"==typeof t?function(){var e=t.apply(this,arguments);this.textContent=null==e?\"\":e}:null==t?function(){this.textContent=\"\"}:function(){this.textContent=t}):this.node().textContent},Lo.html=function(t){return arguments.length?this.each(\"function\"==typeof t?function(){var e=t.apply(this,arguments);this.innerHTML=null==e?\"\":e}:null==t?function(){this.innerHTML=\"\"}:function(){this.innerHTML=t}):this.node().innerHTML},Lo.append=function(t){return t=B(t),this.select(function(){return this.appendChild(t.apply(this,arguments))})},Lo.insert=function(t,e){return t=B(t),e=C(e),this.select(function(){return this.insertBefore(t.apply(this,arguments),e.apply(this,arguments)||null)})},Lo.remove=function(){return this.each(U)},Lo.data=function(t,e){function r(t,r){var n,i,a,o=t.length,c=r.length,f=Math.min(o,c),d=new Array(c),p=new Array(c),m=new Array(o);if(e){var v,g=new h,y=new Array(o);for(n=-1;++n<o;)(i=t[n])&&(g.has(v=e.call(i,i.__data__,n))?m[n]=i:g.set(v,i),y[n]=v);for(n=-1;++n<c;)(i=g.get(v=e.call(r,a=r[n],n)))?!0!==i&&(d[n]=i,i.__data__=a):p[n]=V(a),g.set(v,!0);for(n=-1;++n<o;)n in y&&!0!==g.get(y[n])&&(m[n]=t[n])}else{for(n=-1;++n<f;)i=t[n],a=r[n],i?(i.__data__=a,d[n]=i):p[n]=V(a);for(;n<c;++n)p[n]=V(r[n]);for(;n<o;++n)m[n]=t[n]}p.update=d,p.parentNode=d.parentNode=m.parentNode=t.parentNode,s.push(p),l.push(d),u.push(m)}var n,i,a=-1,o=this.length;if(!arguments.length){for(t=new Array(o=(n=this[0]).length);++a<o;)(i=n[a])&&(t[a]=i.__data__);return t}var s=Y([]),l=L([]),u=L([]);if(\"function\"==typeof t)for(;++a<o;)r(n=this[a],t.call(n,n.parentNode.__data__,a));else for(;++a<o;)r(n=this[a],t);return l.enter=function(){return s},l.exit=function(){return u},l},Lo.datum=function(t){return arguments.length?this.property(\"__data__\",t):this.property(\"__data__\")},Lo.filter=function(t){var e,r,n,i=[];\"function\"!=typeof t&&(t=H(t));for(var a=0,o=this.length;a<o;a++){i.push(e=[]),e.parentNode=(r=this[a]).parentNode;for(var s=0,l=r.length;s<l;s++)(n=r[s])&&t.call(n,n.__data__,s,a)&&e.push(n)}return L(i)},Lo.order=function(){for(var t=-1,e=this.length;++t<e;)for(var r,n=this[t],i=n.length-1,a=n[i];--i>=0;)(r=n[i])&&(a&&a!==r.nextSibling&&a.parentNode.insertBefore(r,a),a=r);return this},Lo.sort=function(t){t=q.apply(this,arguments);for(var e=-1,r=this.length;++e<r;)this[e].sort(t);return this.order()},Lo.each=function(t){return G(this,function(e,r,n){t.call(e,e.__data__,r,n)})},Lo.call=function(t){var e=ho(arguments);return t.apply(e[0]=this,e),this},Lo.empty=function(){return!this.node()},Lo.node=function(){for(var t=0,e=this.length;t<e;t++)for(var r=this[t],n=0,i=r.length;n<i;n++){var a=r[n];if(a)return a}return null},Lo.size=function(){var t=0;return G(this,function(){++t}),t};var Io=[];uo.selection.enter=Y,uo.selection.enter.prototype=Io,Io.append=Lo.append,Io.empty=Lo.empty,Io.node=Lo.node,Io.call=Lo.call,Io.size=Lo.size,Io.select=function(t){for(var e,r,n,i,a,o=[],s=-1,l=this.length;++s<l;){n=(i=this[s]).update,o.push(e=[]),e.parentNode=i.parentNode;for(var u=-1,c=i.length;++u<c;)(a=i[u])?(e.push(n[u]=r=t.call(i.parentNode,a.__data__,u,s)),r.__data__=a.__data__):e.push(null)}return L(o)},Io.insert=function(t,e){return arguments.length<2&&(e=X(this)),Lo.insert.call(this,t,e)},uo.select=function(t){var r;return\"string\"==typeof t?(r=[To(t,fo)],r.parentNode=fo.documentElement):(r=[t],r.parentNode=e(t)),L([r])},uo.selectAll=function(t){var e;return\"string\"==typeof t?(e=ho(So(t,fo)),e.parentNode=fo.documentElement):(e=ho(t),e.parentNode=null),L([e])},Lo.on=function(t,e,r){var n=arguments.length;if(n<3){if(\"string\"!=typeof t){n<2&&(e=!1);for(r in t)this.each(W(r,t[r],e));return this}if(n<2)return(n=this.node()[\"__on\"+t])&&n._;r=!1}return this.each(W(t,e,r))};var Do=uo.map({mouseenter:\"mouseover\",mouseleave:\"mouseout\"});fo&&Do.forEach(function(t){\"on\"+t in fo&&Do.remove(t)});var Po,Oo=0;uo.mouse=function(t){return Q(t,S())};var Ro=this.navigator&&/WebKit/.test(this.navigator.userAgent)?-1:0;uo.touch=function(t,e,r){if(arguments.length<3&&(r=e,e=S().changedTouches),e)for(var n,i=0,a=e.length;i<a;++i)if((n=e[i]).identifier===r)return Q(t,n)},uo.behavior.drag=function(){function t(){this.on(\"mousedown.drag\",a).on(\"touchstart.drag\",o)}function e(t,e,n,a,o){return function(){function s(){var t,r,n=e(f,m);n&&(t=n[0]-b[0],r=n[1]-b[1],p|=t|r,b=n,d({type:\"drag\",x:n[0]+u[0],y:n[1]+u[1],dx:t,dy:r}))}function l(){e(f,m)&&(g.on(a+v,null).on(o+v,null),y(p),d({type:\"dragend\"}))}var u,c=this,h=uo.event.target.correspondingElement||uo.event.target,f=c.parentNode,d=r.of(c,arguments),p=0,m=t(),v=\".drag\"+(null==m?\"\":\"-\"+m),g=uo.select(n(h)).on(a+v,s).on(o+v,l),y=K(h),b=e(f,m);i?(u=i.apply(c,arguments),u=[u.x-b[0],u.y-b[1]]):u=[0,0],d({type:\"dragstart\"})}}var r=E(t,\"drag\",\"dragstart\",\"dragend\"),i=null,a=e(M,uo.mouse,n,\"mousemove\",\"mouseup\"),o=e($,uo.touch,x,\"touchmove\",\"touchend\");return t.origin=function(e){return arguments.length?(i=e,t):i},uo.rebind(t,r,\"on\")},uo.touches=function(t,e){return arguments.length<2&&(e=S().touches),e?ho(e).map(function(e){var r=Q(t,e);return r.identifier=e.identifier,r}):[]};var Fo=1e-6,jo=Fo*Fo,No=Math.PI,Bo=2*No,Uo=Bo-Fo,Vo=No/2,Ho=No/180,qo=180/No,Go=Math.SQRT2;uo.interpolateZoom=function(t,e){var r,n,i=t[0],a=t[1],o=t[2],s=e[0],l=e[1],u=e[2],c=s-i,h=l-a,f=c*c+h*h;if(f<jo)n=Math.log(u/o)/Go,r=function(t){return[i+t*c,a+t*h,o*Math.exp(Go*t*n)]};else{var d=Math.sqrt(f),p=(u*u-o*o+4*f)/(2*o*2*d),m=(u*u-o*o-4*f)/(2*u*2*d),v=Math.log(Math.sqrt(p*p+1)-p),g=Math.log(Math.sqrt(m*m+1)-m);n=(g-v)/Go,r=function(t){var e=t*n,r=at(v),s=o/(2*d)*(r*ot(Go*e+v)-it(v));return[i+s*c,a+s*h,o*r/at(Go*e+v)]}}return r.duration=1e3*n,r},uo.behavior.zoom=function(){function t(t){t.on(z,h).on(Xo+\".zoom\",d).on(\"dblclick.zoom\",p).on(P,f)}function e(t){return[(t[0]-k.x)/k.k,(t[1]-k.y)/k.k]}function r(t){return[t[0]*k.k+k.x,t[1]*k.k+k.y]}function i(t){k.k=Math.max(S[0],Math.min(S[1],t))}function a(t,e){e=r(e),k.x+=t[0]-e[0],k.y+=t[1]-e[1]}function o(e,r,n,o){e.__chart__={x:k.x,y:k.y,k:k.k},i(Math.pow(2,o)),a(v=r,n),e=uo.select(e),L>0&&(e=e.transition().duration(L)),e.call(t.event)}function s(){_&&_.domain(x.range().map(function(t){return(t-k.x)/k.k}).map(x.invert)),M&&M.domain(w.range().map(function(t){return(t-k.y)/k.k}).map(w.invert))}function l(t){C++||t({type:\"zoomstart\"})}function u(t){s(),t({type:\"zoom\",scale:k.k,translate:[k.x,k.y]})}function c(t){--C||(t({type:\"zoomend\"}),v=null)}function h(){function t(){s=1,a(uo.mouse(i),f),u(o)}function r(){h.on(I,null).on(D,null),d(s),c(o)}var i=this,o=O.of(i,arguments),s=0,h=uo.select(n(i)).on(I,t).on(D,r),f=e(uo.mouse(i)),d=K(i);Bl.call(i),l(o)}function f(){function t(){var t=uo.touches(p);return d=k.k,t.forEach(function(t){t.identifier in v&&(v[t.identifier]=e(t))}),t}function r(){var e=uo.event.target;uo.select(e).on(x,n).on(_,s),w.push(e);for(var r=uo.event.changedTouches,i=0,a=r.length;i<a;++i)v[r[i].identifier]=null;var l=t(),u=Date.now();if(1===l.length){if(u-b<500){var c=l[0];o(p,c,v[c.identifier],Math.floor(Math.log(k.k)/Math.LN2)+1),T()}b=u}else if(l.length>1){var c=l[0],h=l[1],f=c[0]-h[0],d=c[1]-h[1];g=f*f+d*d}}function n(){var t,e,r,n,o=uo.touches(p);Bl.call(p);for(var s=0,l=o.length;s<l;++s,n=null)if(r=o[s],n=v[r.identifier]){if(e)break;t=r,e=n}if(n){var c=(c=r[0]-t[0])*c+(c=r[1]-t[1])*c,h=g&&Math.sqrt(c/g);t=[(t[0]+r[0])/2,(t[1]+r[1])/2],e=[(e[0]+n[0])/2,(e[1]+n[1])/2],i(h*d)}b=null,a(t,e),u(m)}function s(){if(uo.event.touches.length){for(var e=uo.event.changedTouches,r=0,n=e.length;r<n;++r)delete v[e[r].identifier];for(var i in v)return void t()}uo.selectAll(w).on(y,null),M.on(z,h).on(P,f),A(),c(m)}var d,p=this,m=O.of(p,arguments),v={},g=0,y=\".zoom-\"+uo.event.changedTouches[0].identifier,x=\"touchmove\"+y,_=\"touchend\"+y,w=[],M=uo.select(p),A=K(p);r(),l(m),M.on(z,null).on(P,r)}function d(){var t=O.of(this,arguments);y?clearTimeout(y):(Bl.call(this),m=e(v=g||uo.mouse(this)),l(t)),y=setTimeout(function(){y=null,c(t)},50),T(),i(Math.pow(2,.002*Yo())*k.k),a(v,m),u(t)}function p(){var t=uo.mouse(this),r=Math.log(k.k)/Math.LN2;o(this,t,e(t),uo.event.shiftKey?Math.ceil(r)-1:Math.floor(r)+1)}var m,v,g,y,b,x,_,w,M,k={x:0,y:0,k:1},A=[960,500],S=Wo,L=250,C=0,z=\"mousedown.zoom\",I=\"mousemove.zoom\",D=\"mouseup.zoom\",P=\"touchstart.zoom\",O=E(t,\"zoomstart\",\"zoom\",\"zoomend\");return Xo||(Xo=\"onwheel\"in fo?(Yo=function(){return-uo.event.deltaY*(uo.event.deltaMode?120:1)},\"wheel\"):\"onmousewheel\"in fo?(Yo=function(){return uo.event.wheelDelta},\"mousewheel\"):(Yo=function(){return-uo.event.detail},\"MozMousePixelScroll\")),t.event=function(t){t.each(function(){var t=O.of(this,arguments),e=k;jl?uo.select(this).transition().each(\"start.zoom\",function(){k=this.__chart__||{x:0,y:0,k:1},l(t)}).tween(\"zoom:zoom\",function(){var r=A[0],n=A[1],i=v?v[0]:r/2,a=v?v[1]:n/2,o=uo.interpolateZoom([(i-k.x)/k.k,(a-k.y)/k.k,r/k.k],[(i-e.x)/e.k,(a-e.y)/e.k,r/e.k]);return function(e){var n=o(e),s=r/n[2];this.__chart__=k={x:i-n[0]*s,y:a-n[1]*s,k:s},u(t)}}).each(\"interrupt.zoom\",function(){c(t)}).each(\"end.zoom\",function(){c(t)}):(this.__chart__=k,l(t),u(t),c(t))})},t.translate=function(e){return arguments.length?(k={x:+e[0],y:+e[1],k:k.k},s(),t):[k.x,k.y]},t.scale=function(e){return arguments.length?(k={x:k.x,y:k.y,k:null},i(+e),s(),t):k.k},t.scaleExtent=function(e){return arguments.length?(S=null==e?Wo:[+e[0],+e[1]],t):S},t.center=function(e){return arguments.length?(g=e&&[+e[0],+e[1]],t):g},t.size=function(e){return arguments.length?(A=e&&[+e[0],+e[1]],t):A},t.duration=function(e){return arguments.length?(L=+e,t):L},t.x=function(e){return arguments.length?(_=e,x=e.copy(),k={x:0,y:0,k:1},t):_},t.y=function(e){return arguments.length?(M=e,w=e.copy(),k={x:0,y:0,k:1},t):M},uo.rebind(t,O,\"on\")};var Yo,Xo,Wo=[0,1/0];uo.color=lt,lt.prototype.toString=function(){return this.rgb()+\"\"},uo.hsl=ut;var Zo=ut.prototype=new lt;Zo.brighter=function(t){return t=Math.pow(.7,arguments.length?t:1),new ut(this.h,this.s,this.l/t)},Zo.darker=function(t){return t=Math.pow(.7,arguments.length?t:1),new ut(this.h,this.s,t*this.l)},Zo.rgb=function(){return ct(this.h,this.s,this.l)},uo.hcl=ht;var Jo=ht.prototype=new lt;Jo.brighter=function(t){return new ht(this.h,this.c,Math.min(100,this.l+Ko*(arguments.length?t:1)))},Jo.darker=function(t){return new ht(this.h,this.c,Math.max(0,this.l-Ko*(arguments.length?t:1)))},Jo.rgb=function(){return ft(this.h,this.c,this.l).rgb()},uo.lab=dt;var Ko=18,Qo=.95047,$o=1,ts=1.08883,es=dt.prototype=new lt;es.brighter=function(t){return new dt(Math.min(100,this.l+Ko*(arguments.length?t:1)),this.a,this.b)},es.darker=function(t){return new dt(Math.max(0,this.l-Ko*(arguments.length?t:1)),this.a,this.b)},es.rgb=function(){return pt(this.l,this.a,this.b)},uo.rgb=bt;var rs=bt.prototype=new lt;rs.brighter=function(t){t=Math.pow(.7,arguments.length?t:1);var e=this.r,r=this.g,n=this.b,i=30;return e||r||n?(e&&e<i&&(e=i),r&&r<i&&(r=i),n&&n<i&&(n=i),new bt(Math.min(255,e/t),Math.min(255,r/t),Math.min(255,n/t))):new bt(i,i,i)},rs.darker=function(t){return t=Math.pow(.7,arguments.length?t:1),new bt(t*this.r,t*this.g,t*this.b)},rs.hsl=function(){return kt(this.r,this.g,this.b)},rs.toString=function(){return\"#\"+wt(this.r)+wt(this.g)+wt(this.b)};var ns=uo.map({aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074});ns.forEach(function(t,e){ns.set(t,xt(e))}),uo.functor=Et,uo.xhr=Lt(x),uo.dsv=function(t,e){function r(t,r,a){arguments.length<3&&(a=r,r=null);var o=Ct(t,e,null==r?n:i(r),a);return o.row=function(t){return arguments.length?o.response(null==(r=t)?n:i(t)):r},o}function n(t){return r.parse(t.responseText)}function i(t){return function(e){return r.parse(e.responseText,t)}}function a(e){return e.map(o).join(t)}function o(t){return s.test(t)?'\"'+t.replace(/\\\"/g,'\"\"')+'\"':t}var s=new RegExp('[\"'+t+\"\\n]\"),l=t.charCodeAt(0);return r.parse=function(t,e){var n;return r.parseRows(t,function(t,r){if(n)return n(t,r-1);var i=new Function(\"d\",\"return {\"+t.map(function(t,e){return JSON.stringify(t)+\": d[\"+e+\"]\"}).join(\",\")+\"}\");n=e?function(t,r){return e(i(t),r)}:i})},r.parseRows=function(t,e){function r(){if(c>=u)return o;if(i)return i=!1,a;var e=c;if(34===t.charCodeAt(e)){for(var r=e;r++<u;)if(34===t.charCodeAt(r)){if(34!==t.charCodeAt(r+1))break;++r}c=r+2;var n=t.charCodeAt(r+1);return 13===n?(i=!0,10===t.charCodeAt(r+2)&&++c):10===n&&(i=!0),t.slice(e+1,r).replace(/\"\"/g,'\"')}for(;c<u;){var n=t.charCodeAt(c++),s=1;if(10===n)i=!0;else if(13===n)i=!0,10===t.charCodeAt(c)&&(++c,++s);else if(n!==l)continue;return t.slice(e,c-s)}return t.slice(e)}for(var n,i,a={},o={},s=[],u=t.length,c=0,h=0;(n=r())!==o;){for(var f=[];n!==a&&n!==o;)f.push(n),n=r();e&&null==(f=e(f,h++))||s.push(f)}return s},r.format=function(e){if(Array.isArray(e[0]))return r.formatRows(e);var n=new b,i=[];return e.forEach(function(t){for(var e in t)n.has(e)||i.push(n.add(e))}),[i.map(o).join(t)].concat(e.map(function(e){return i.map(function(t){return o(e[t])}).join(t)})).join(\"\\n\")},r.formatRows=function(t){return t.map(a).join(\"\\n\")},r},uo.csv=uo.dsv(\",\",\"text/csv\"),uo.tsv=uo.dsv(\"\\t\",\"text/tab-separated-values\");var is,as,os,ss,ls=this[w(this,\"requestAnimationFrame\")]||function(t){setTimeout(t,17)};uo.timer=function(){Dt.apply(this,arguments)},uo.timer.flush=function(){Ot(),Rt()},uo.round=function(t,e){return e?Math.round(t*(e=Math.pow(10,e)))/e:Math.round(t)};var us=[\"y\",\"z\",\"a\",\"f\",\"p\",\"n\",\"\\xb5\",\"m\",\"\",\"k\",\"M\",\"G\",\"T\",\"P\",\"E\",\"Z\",\"Y\"].map(jt);uo.formatPrefix=function(t,e){var r=0;return(t=+t)&&(t<0&&(t*=-1),e&&(t=uo.round(t,Ft(t,e))),r=1+Math.floor(1e-12+Math.log(t)/Math.LN10),r=Math.max(-24,Math.min(24,3*Math.floor((r-1)/3)))),us[8+r/3]};var cs=/(?:([^{])?([<>=^]))?([+\\- ])?([$#])?(0)?(\\d+)?(,)?(\\.-?\\d+)?([a-z%])?/i,hs=uo.map({b:function(t){return t.toString(2)},c:function(t){return String.fromCharCode(t)},o:function(t){return t.toString(8)},x:function(t){return t.toString(16)},X:function(t){return t.toString(16).toUpperCase()},g:function(t,e){return t.toPrecision(e)},e:function(t,e){return t.toExponential(e)},f:function(t,e){return t.toFixed(e)},r:function(t,e){return(t=uo.round(t,Ft(t,e))).toFixed(Math.max(0,Math.min(20,Ft(t*(1+1e-15),e))))}}),fs=uo.time={},ds=Date;Ut.prototype={getDate:function(){return this._.getUTCDate()},getDay:function(){return this._.getUTCDay()},getFullYear:function(){return this._.getUTCFullYear()},getHours:function(){return this._.getUTCHours()},getMilliseconds:function(){return this._.getUTCMilliseconds()},getMinutes:function(){return this._.getUTCMinutes()},getMonth:function(){return this._.getUTCMonth()},getSeconds:function(){return this._.getUTCSeconds()},getTime:function(){return this._.getTime()},getTimezoneOffset:function(){return 0},valueOf:function(){return this._.valueOf()},setDate:function(){ps.setUTCDate.apply(this._,arguments)},setDay:function(){ps.setUTCDay.apply(this._,arguments)},setFullYear:function(){ps.setUTCFullYear.apply(this._,arguments)},setHours:function(){ps.setUTCHours.apply(this._,arguments)},setMilliseconds:function(){ps.setUTCMilliseconds.apply(this._,arguments)},setMinutes:function(){ps.setUTCMinutes.apply(this._,arguments)},setMonth:function(){ps.setUTCMonth.apply(this._,arguments)},setSeconds:function(){ps.setUTCSeconds.apply(this._,arguments)},setTime:function(){ps.setTime.apply(this._,arguments)}};var ps=Date.prototype;fs.year=Vt(function(t){return t=fs.day(t),t.setMonth(0,1),t},function(t,e){t.setFullYear(t.getFullYear()+e)},function(t){return t.getFullYear()}),fs.years=fs.year.range,fs.years.utc=fs.year.utc.range,fs.day=Vt(function(t){var e=new ds(2e3,0);return e.setFullYear(t.getFullYear(),t.getMonth(),t.getDate()),e},function(t,e){t.setDate(t.getDate()+e)},function(t){return t.getDate()-1}),fs.days=fs.day.range,fs.days.utc=fs.day.utc.range,fs.dayOfYear=function(t){var e=fs.year(t);return Math.floor((t-e-6e4*(t.getTimezoneOffset()-e.getTimezoneOffset()))/864e5)},[\"sunday\",\"monday\",\"tuesday\",\"wednesday\",\"thursday\",\"friday\",\"saturday\"].forEach(function(t,e){e=7-e;var r=fs[t]=Vt(function(t){return(t=fs.day(t)).setDate(t.getDate()-(t.getDay()+e)%7),t},function(t,e){t.setDate(t.getDate()+7*Math.floor(e))},function(t){var r=fs.year(t).getDay();return Math.floor((fs.dayOfYear(t)+(r+e)%7)/7)-(r!==e)});fs[t+\"s\"]=r.range,fs[t+\"s\"].utc=r.utc.range,fs[t+\"OfYear\"]=function(t){var r=fs.year(t).getDay();return Math.floor((fs.dayOfYear(t)+(r+e)%7)/7)}}),fs.week=fs.sunday,fs.weeks=fs.sunday.range,fs.weeks.utc=fs.sunday.utc.range,fs.weekOfYear=fs.sundayOfYear;var ms={\"-\":\"\",_:\" \",0:\"0\"},vs=/^\\s*\\d+/,gs=/^%/;uo.locale=function(t){return{numberFormat:Nt(t),timeFormat:qt(t)}};var ys=uo.locale({decimal:\".\",thousands:\",\",grouping:[3],currency:[\"$\",\"\"],dateTime:\"%a %b %e %X %Y\",date:\"%m/%d/%Y\",time:\"%H:%M:%S\",periods:[\"AM\",\"PM\"],days:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],shortDays:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],months:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],shortMonths:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"]});uo.format=ys.numberFormat,uo.geo={},he.prototype={s:0,t:0,add:function(t){fe(t,this.t,bs),fe(bs.s,this.s,this),this.s?this.t+=bs.t:this.s=bs.t},reset:function(){this.s=this.t=0},valueOf:function(){return this.s}};var bs=new he;uo.geo.stream=function(t,e){t&&xs.hasOwnProperty(t.type)?xs[t.type](t,e):de(t,e)};var xs={Feature:function(t,e){de(t.geometry,e)},FeatureCollection:function(t,e){for(var r=t.features,n=-1,i=r.length;++n<i;)de(r[n].geometry,e)}},_s={Sphere:function(t,e){e.sphere()},Point:function(t,e){t=t.coordinates,e.point(t[0],t[1],t[2])},MultiPoint:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)t=r[n],e.point(t[0],t[1],t[2])},LineString:function(t,e){pe(t.coordinates,e,0)},MultiLineString:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)pe(r[n],e,0)},Polygon:function(t,e){me(t.coordinates,e)},MultiPolygon:function(t,e){for(var r=t.coordinates,n=-1,i=r.length;++n<i;)me(r[n],e)},GeometryCollection:function(t,e){for(var r=t.geometries,n=-1,i=r.length;++n<i;)de(r[n],e)}};uo.geo.area=function(t){return ws=0,uo.geo.stream(t,ks),ws};var ws,Ms=new he,ks={sphere:function(){ws+=4*No},point:M,lineStart:M,lineEnd:M,polygonStart:function(){Ms.reset(),ks.lineStart=ve},polygonEnd:function(){var t=2*Ms;ws+=t<0?4*No+t:t,ks.lineStart=ks.lineEnd=ks.point=M}};uo.geo.bounds=function(){function t(t,e){b.push(x=[c=t,f=t]),e<h&&(h=e),e>d&&(d=e)}function e(e,r){var n=ge([e*Ho,r*Ho]);if(g){var i=be(g,n),a=[i[1],-i[0],0],o=be(a,i);we(o),o=Me(o);var l=e-p,u=l>0?1:-1,m=o[0]*qo*u,v=xo(l)>180;if(v^(u*p<m&&m<u*e)){var y=o[1]*qo;y>d&&(d=y)}else if(m=(m+360)%360-180,v^(u*p<m&&m<u*e)){var y=-o[1]*qo;y<h&&(h=y)}else r<h&&(h=r),r>d&&(d=r);v?e<p?s(c,e)>s(c,f)&&(f=e):s(e,f)>s(c,f)&&(c=e):f>=c?(e<c&&(c=e),e>f&&(f=e)):e>p?s(c,e)>s(c,f)&&(f=e):s(e,f)>s(c,f)&&(c=e)}else t(e,r);g=n,p=e}function r(){_.point=e}function n(){x[0]=c,x[1]=f,_.point=t,g=null}function i(t,r){if(g){var n=t-p;y+=xo(n)>180?n+(n>0?360:-360):n}else m=t,v=r;ks.point(t,r),e(t,r)}function a(){ks.lineStart()}function o(){i(m,v),ks.lineEnd(),xo(y)>Fo&&(c=-(f=180)),x[0]=c,x[1]=f,g=null}function s(t,e){return(e-=t)<0?e+360:e}function l(t,e){return t[0]-e[0]}function u(t,e){return e[0]<=e[1]?e[0]<=t&&t<=e[1]:t<e[0]||e[1]<t}var c,h,f,d,p,m,v,g,y,b,x,_={point:t,lineStart:r,lineEnd:n,polygonStart:function(){_.point=i,_.lineStart=a,_.lineEnd=o,y=0,ks.polygonStart()},polygonEnd:function(){ks.polygonEnd(),_.point=t,_.lineStart=r,_.lineEnd=n,Ms<0?(c=-(f=180),h=-(d=90)):y>Fo?d=90:y<-Fo&&(h=-90),x[0]=c,x[1]=f}};return function(t){d=f=-(c=h=1/0),b=[],uo.geo.stream(t,_);var e=b.length;if(e){b.sort(l);for(var r,n=1,i=b[0],a=[i];n<e;++n)r=b[n],u(r[0],i)||u(r[1],i)?(s(i[0],r[1])>s(i[0],i[1])&&(i[1]=r[1]),s(r[0],i[1])>s(i[0],i[1])&&(i[0]=r[0])):a.push(i=r);for(var o,r,p=-1/0,e=a.length-1,n=0,i=a[e];n<=e;i=r,++n)r=a[n],(o=s(i[1],r[0]))>p&&(p=o,c=r[0],f=i[1])}return b=x=null,c===1/0||h===1/0?[[NaN,NaN],[NaN,NaN]]:[[c,h],[f,d]]}}(),uo.geo.centroid=function(t){As=Ts=Ss=Es=Ls=Cs=zs=Is=Ds=Ps=Os=0,uo.geo.stream(t,Rs);var e=Ds,r=Ps,n=Os,i=e*e+r*r+n*n;return i<jo&&(e=Cs,r=zs,n=Is,Ts<Fo&&(e=Ss,r=Es,n=Ls),(i=e*e+r*r+n*n)<jo)?[NaN,NaN]:[Math.atan2(r,e)*qo,nt(n/Math.sqrt(i))*qo]};var As,Ts,Ss,Es,Ls,Cs,zs,Is,Ds,Ps,Os,Rs={sphere:M,point:Ae,lineStart:Se,lineEnd:Ee,polygonStart:function(){Rs.lineStart=Le},polygonEnd:function(){Rs.lineStart=Se}},Fs=Oe(ze,Ne,Ue,[-No,-No/2]),js=1e9;uo.geo.clipExtent=function(){var t,e,r,n,i,a,o={stream:function(t){return i&&(i.valid=!1),i=a(t),i.valid=!0,i},extent:function(s){return arguments.length?(a=Ge(t=+s[0][0],e=+s[0][1],r=+s[1][0],n=+s[1][1]),i&&(i.valid=!1,i=null),o):[[t,e],[r,n]]}};return o.extent([[0,0],[960,500]])},(uo.geo.conicEqualArea=function(){return Ye(Xe)}).raw=Xe,uo.geo.albers=function(){return uo.geo.conicEqualArea().rotate([96,0]).center([-.6,38.7]).parallels([29.5,45.5]).scale(1070)},uo.geo.albersUsa=function(){function t(t){var a=t[0],o=t[1];return e=null,r(a,o),e||(n(a,o),e)||i(a,o),e}var e,r,n,i,a=uo.geo.albers(),o=uo.geo.conicEqualArea().rotate([154,0]).center([-2,58.5]).parallels([55,65]),s=uo.geo.conicEqualArea().rotate([157,0]).center([-3,19.9]).parallels([8,18]),l={point:function(t,r){e=[t,r]}};return t.invert=function(t){var e=a.scale(),r=a.translate(),n=(t[0]-r[0])/e,i=(t[1]-r[1])/e;return(i>=.12&&i<.234&&n>=-.425&&n<-.214?o:i>=.166&&i<.234&&n>=-.214&&n<-.115?s:a).invert(t)},t.stream=function(t){var e=a.stream(t),r=o.stream(t),n=s.stream(t);return{point:function(t,i){e.point(t,i),r.point(t,i),n.point(t,i)},sphere:function(){e.sphere(),r.sphere(),n.sphere()},lineStart:function(){e.lineStart(),r.lineStart(),n.lineStart()},lineEnd:function(){e.lineEnd(),r.lineEnd(),n.lineEnd()},polygonStart:function(){e.polygonStart(),r.polygonStart(),n.polygonStart()},polygonEnd:function(){e.polygonEnd(),r.polygonEnd(),n.polygonEnd()}}},t.precision=function(e){return arguments.length?(a.precision(e),o.precision(e),s.precision(e),t):a.precision()},t.scale=function(e){return arguments.length?(a.scale(e),o.scale(.35*e),s.scale(e),t.translate(a.translate())):a.scale()},t.translate=function(e){if(!arguments.length)return a.translate();var u=a.scale(),c=+e[0],h=+e[1];return r=a.translate(e).clipExtent([[c-.455*u,h-.238*u],[c+.455*u,h+.238*u]]).stream(l).point,n=o.translate([c-.307*u,h+.201*u]).clipExtent([[c-.425*u+Fo,h+.12*u+Fo],[c-.214*u-Fo,h+.234*u-Fo]]).stream(l).point,i=s.translate([c-.205*u,h+.212*u]).clipExtent([[c-.214*u+Fo,h+.166*u+Fo],[c-.115*u-Fo,h+.234*u-Fo]]).stream(l).point,t},t.scale(1070)};var Ns,Bs,Us,Vs,Hs,qs,Gs={point:M,lineStart:M,lineEnd:M,polygonStart:function(){Bs=0,Gs.lineStart=We},polygonEnd:function(){Gs.lineStart=Gs.lineEnd=Gs.point=M,Ns+=xo(Bs/2)}},Ys={point:Ze,lineStart:M,lineEnd:M,polygonStart:M,polygonEnd:M},Xs={point:Qe,lineStart:$e,lineEnd:tr,polygonStart:function(){Xs.lineStart=er},polygonEnd:function(){Xs.point=Qe,Xs.lineStart=$e,Xs.lineEnd=tr}};uo.geo.path=function(){function t(t){return t&&(\"function\"==typeof s&&a.pointRadius(+s.apply(this,arguments)),o&&o.valid||(o=i(a)),uo.geo.stream(t,o)),a.result()}function e(){return o=null,t}var r,n,i,a,o,s=4.5;return t.area=function(t){return Ns=0,uo.geo.stream(t,i(Gs)),Ns},t.centroid=function(t){return Ss=Es=Ls=Cs=zs=Is=Ds=Ps=Os=0,uo.geo.stream(t,i(Xs)),Os?[Ds/Os,Ps/Os]:Is?[Cs/Is,zs/Is]:Ls?[Ss/Ls,Es/Ls]:[NaN,NaN]},t.bounds=function(t){return Hs=qs=-(Us=Vs=1/0),uo.geo.stream(t,i(Ys)),[[Us,Vs],[Hs,qs]]},t.projection=function(t){return arguments.length?(i=(r=t)?t.stream||ir(t):x,e()):r},t.context=function(t){return arguments.length?(a=null==(n=t)?new Je:new rr(t),\"function\"!=typeof s&&a.pointRadius(s),e()):n},t.pointRadius=function(e){return arguments.length?(s=\"function\"==typeof e?e:(a.pointRadius(+e),+e),t):s},t.projection(uo.geo.albersUsa()).context(null)},uo.geo.transform=function(t){return{stream:function(e){var r=new ar(e);for(var n in t)r[n]=t[n];return r}}},ar.prototype={point:function(t,e){this.stream.point(t,e)},sphere:function(){this.stream.sphere()},lineStart:function(){this.stream.lineStart()},lineEnd:function(){this.stream.lineEnd()},polygonStart:function(){this.stream.polygonStart()},polygonEnd:function(){this.stream.polygonEnd()}},uo.geo.projection=sr,uo.geo.projectionMutator=lr,(uo.geo.equirectangular=function(){return sr(cr)}).raw=cr.invert=cr,uo.geo.rotation=function(t){function e(e){return e=t(e[0]*Ho,e[1]*Ho),e[0]*=qo,e[1]*=qo,e}return t=fr(t[0]%360*Ho,t[1]*Ho,t.length>2?t[2]*Ho:0),e.invert=function(e){return e=t.invert(e[0]*Ho,e[1]*Ho),e[0]*=qo,e[1]*=qo,e},e},hr.invert=cr,uo.geo.circle=function(){function t(){var t=\"function\"==typeof n?n.apply(this,arguments):n,e=fr(-t[0]*Ho,-t[1]*Ho,0).invert,i=[];return r(null,null,1,{point:function(t,r){i.push(t=e(t,r)),t[0]*=qo,t[1]*=qo}}),{type:\"Polygon\",coordinates:[i]}}var e,r,n=[0,0],i=6;return t.origin=function(e){return arguments.length?(n=e,t):n},t.angle=function(n){return arguments.length?(r=vr((e=+n)*Ho,i*Ho),t):e},t.precision=function(n){return arguments.length?(r=vr(e*Ho,(i=+n)*Ho),t):i},t.angle(90)},uo.geo.distance=function(t,e){var r,n=(e[0]-t[0])*Ho,i=t[1]*Ho,a=e[1]*Ho,o=Math.sin(n),s=Math.cos(n),l=Math.sin(i),u=Math.cos(i),c=Math.sin(a),h=Math.cos(a);return Math.atan2(Math.sqrt((r=h*o)*r+(r=u*c-l*h*s)*r),l*c+u*h*s)},uo.geo.graticule=function(){function t(){return{type:\"MultiLineString\",coordinates:e()}}function e(){return uo.range(Math.ceil(a/v)*v,i,v).map(f).concat(uo.range(Math.ceil(u/g)*g,l,g).map(d)).concat(uo.range(Math.ceil(n/p)*p,r,p).filter(function(t){return xo(t%v)>Fo}).map(c)).concat(uo.range(Math.ceil(s/m)*m,o,m).filter(function(t){return xo(t%g)>Fo}).map(h))}var r,n,i,a,o,s,l,u,c,h,f,d,p=10,m=p,v=90,g=360,y=2.5;return t.lines=function(){return e().map(function(t){return{type:\"LineString\",coordinates:t}})},t.outline=function(){return{type:\"Polygon\",coordinates:[f(a).concat(d(l).slice(1),f(i).reverse().slice(1),d(u).reverse().slice(1))]}},t.extent=function(e){return arguments.length?t.majorExtent(e).minorExtent(e):t.minorExtent()},t.majorExtent=function(e){return arguments.length?(a=+e[0][0],i=+e[1][0],u=+e[0][1],l=+e[1][1],a>i&&(e=a,a=i,i=e),u>l&&(e=u,u=l,l=e),t.precision(y)):[[a,u],[i,l]]},t.minorExtent=function(e){return arguments.length?(n=+e[0][0],r=+e[1][0],s=+e[0][1],o=+e[1][1],n>r&&(e=n,n=r,r=e),s>o&&(e=s,s=o,o=e),t.precision(y)):[[n,s],[r,o]]},t.step=function(e){return arguments.length?t.majorStep(e).minorStep(e):t.minorStep()},t.majorStep=function(e){return arguments.length?(v=+e[0],g=+e[1],t):[v,g]},t.minorStep=function(e){return arguments.length?(p=+e[0],m=+e[1],t):[p,m]},t.precision=function(e){\n",
       "return arguments.length?(y=+e,c=yr(s,o,90),h=br(n,r,y),f=yr(u,l,90),d=br(a,i,y),t):y},t.majorExtent([[-180,-90+Fo],[180,90-Fo]]).minorExtent([[-180,-80-Fo],[180,80+Fo]])},uo.geo.greatArc=function(){function t(){return{type:\"LineString\",coordinates:[e||n.apply(this,arguments),r||i.apply(this,arguments)]}}var e,r,n=xr,i=_r;return t.distance=function(){return uo.geo.distance(e||n.apply(this,arguments),r||i.apply(this,arguments))},t.source=function(r){return arguments.length?(n=r,e=\"function\"==typeof r?null:r,t):n},t.target=function(e){return arguments.length?(i=e,r=\"function\"==typeof e?null:e,t):i},t.precision=function(){return arguments.length?t:0},t},uo.geo.interpolate=function(t,e){return wr(t[0]*Ho,t[1]*Ho,e[0]*Ho,e[1]*Ho)},uo.geo.length=function(t){return Ws=0,uo.geo.stream(t,Zs),Ws};var Ws,Zs={sphere:M,point:M,lineStart:Mr,lineEnd:M,polygonStart:M,polygonEnd:M},Js=kr(function(t){return Math.sqrt(2/(1+t))},function(t){return 2*Math.asin(t/2)});(uo.geo.azimuthalEqualArea=function(){return sr(Js)}).raw=Js;var Ks=kr(function(t){var e=Math.acos(t);return e&&e/Math.sin(e)},x);(uo.geo.azimuthalEquidistant=function(){return sr(Ks)}).raw=Ks,(uo.geo.conicConformal=function(){return Ye(Ar)}).raw=Ar,(uo.geo.conicEquidistant=function(){return Ye(Tr)}).raw=Tr;var Qs=kr(function(t){return 1/t},Math.atan);(uo.geo.gnomonic=function(){return sr(Qs)}).raw=Qs,Sr.invert=function(t,e){return[t,2*Math.atan(Math.exp(e))-Vo]},(uo.geo.mercator=function(){return Er(Sr)}).raw=Sr;var $s=kr(function(){return 1},Math.asin);(uo.geo.orthographic=function(){return sr($s)}).raw=$s;var tl=kr(function(t){return 1/(1+t)},function(t){return 2*Math.atan(t)});(uo.geo.stereographic=function(){return sr(tl)}).raw=tl,Lr.invert=function(t,e){return[-e,2*Math.atan(Math.exp(t))-Vo]},(uo.geo.transverseMercator=function(){var t=Er(Lr),e=t.center,r=t.rotate;return t.center=function(t){return t?e([-t[1],t[0]]):(t=e(),[t[1],-t[0]])},t.rotate=function(t){return t?r([t[0],t[1],t.length>2?t[2]+90:90]):(t=r(),[t[0],t[1],t[2]-90])},r([0,0,90])}).raw=Lr,uo.geom={},uo.geom.hull=function(t){function e(t){if(t.length<3)return[];var e,i=Et(r),a=Et(n),o=t.length,s=[],l=[];for(e=0;e<o;e++)s.push([+i.call(this,t[e],e),+a.call(this,t[e],e),e]);for(s.sort(Dr),e=0;e<o;e++)l.push([s[e][0],-s[e][1]]);var u=Ir(s),c=Ir(l),h=c[0]===u[0],f=c[c.length-1]===u[u.length-1],d=[];for(e=u.length-1;e>=0;--e)d.push(t[s[u[e]][2]]);for(e=+h;e<c.length-f;++e)d.push(t[s[c[e]][2]]);return d}var r=Cr,n=zr;return arguments.length?e(t):(e.x=function(t){return arguments.length?(r=t,e):r},e.y=function(t){return arguments.length?(n=t,e):n},e)},uo.geom.polygon=function(t){return Ao(t,el),t};var el=uo.geom.polygon.prototype=[];el.area=function(){for(var t,e=-1,r=this.length,n=this[r-1],i=0;++e<r;)t=n,n=this[e],i+=t[1]*n[0]-t[0]*n[1];return.5*i},el.centroid=function(t){var e,r,n=-1,i=this.length,a=0,o=0,s=this[i-1];for(arguments.length||(t=-1/(6*this.area()));++n<i;)e=s,s=this[n],r=e[0]*s[1]-s[0]*e[1],a+=(e[0]+s[0])*r,o+=(e[1]+s[1])*r;return[a*t,o*t]},el.clip=function(t){for(var e,r,n,i,a,o,s=Rr(t),l=-1,u=this.length-Rr(this),c=this[u-1];++l<u;){for(e=t.slice(),t.length=0,i=this[l],a=e[(n=e.length-s)-1],r=-1;++r<n;)o=e[r],Pr(o,c,i)?(Pr(a,c,i)||t.push(Or(a,o,c,i)),t.push(o)):Pr(a,c,i)&&t.push(Or(a,o,c,i)),a=o;s&&t.push(t[0]),c=i}return t};var rl,nl,il,al,ol,sl=[],ll=[];qr.prototype.prepare=function(){for(var t,e=this.edges,r=e.length;r--;)t=e[r].edge,t.b&&t.a||e.splice(r,1);return e.sort(Yr),e.length},rn.prototype={start:function(){return this.edge.l===this.site?this.edge.a:this.edge.b},end:function(){return this.edge.l===this.site?this.edge.b:this.edge.a}},nn.prototype={insert:function(t,e){var r,n,i;if(t){if(e.P=t,e.N=t.N,t.N&&(t.N.P=e),t.N=e,t.R){for(t=t.R;t.L;)t=t.L;t.L=e}else t.R=e;r=t}else this._?(t=ln(this._),e.P=null,e.N=t,t.P=t.L=e,r=t):(e.P=e.N=null,this._=e,r=null);for(e.L=e.R=null,e.U=r,e.C=!0,t=e;r&&r.C;)n=r.U,r===n.L?(i=n.R,i&&i.C?(r.C=i.C=!1,n.C=!0,t=n):(t===r.R&&(on(this,r),t=r,r=t.U),r.C=!1,n.C=!0,sn(this,n))):(i=n.L,i&&i.C?(r.C=i.C=!1,n.C=!0,t=n):(t===r.L&&(sn(this,r),t=r,r=t.U),r.C=!1,n.C=!0,on(this,n))),r=t.U;this._.C=!1},remove:function(t){t.N&&(t.N.P=t.P),t.P&&(t.P.N=t.N),t.N=t.P=null;var e,r,n,i=t.U,a=t.L,o=t.R;if(r=a?o?ln(o):a:o,i?i.L===t?i.L=r:i.R=r:this._=r,a&&o?(n=r.C,r.C=t.C,r.L=a,a.U=r,r!==o?(i=r.U,r.U=t.U,t=r.R,i.L=t,r.R=o,o.U=r):(r.U=i,i=r,t=r.R)):(n=t.C,t=r),t&&(t.U=i),!n){if(t&&t.C)return void(t.C=!1);do{if(t===this._)break;if(t===i.L){if(e=i.R,e.C&&(e.C=!1,i.C=!0,on(this,i),e=i.R),e.L&&e.L.C||e.R&&e.R.C){e.R&&e.R.C||(e.L.C=!1,e.C=!0,sn(this,e),e=i.R),e.C=i.C,i.C=e.R.C=!1,on(this,i),t=this._;break}}else if(e=i.L,e.C&&(e.C=!1,i.C=!0,sn(this,i),e=i.L),e.L&&e.L.C||e.R&&e.R.C){e.L&&e.L.C||(e.R.C=!1,e.C=!0,on(this,e),e=i.L),e.C=i.C,i.C=e.L.C=!1,sn(this,i),t=this._;break}e.C=!0,t=i,i=i.U}while(!t.C);t&&(t.C=!1)}}},uo.geom.voronoi=function(t){function e(t){var e=new Array(t.length),n=s[0][0],i=s[0][1],a=s[1][0],o=s[1][1];return un(r(t),s).cells.forEach(function(r,s){var l=r.edges,u=r.site;(e[s]=l.length?l.map(function(t){var e=t.start();return[e.x,e.y]}):u.x>=n&&u.x<=a&&u.y>=i&&u.y<=o?[[n,o],[a,o],[a,i],[n,i]]:[]).point=t[s]}),e}function r(t){return t.map(function(t,e){return{x:Math.round(a(t,e)/Fo)*Fo,y:Math.round(o(t,e)/Fo)*Fo,i:e}})}var n=Cr,i=zr,a=n,o=i,s=ul;return t?e(t):(e.links=function(t){return un(r(t)).edges.filter(function(t){return t.l&&t.r}).map(function(e){return{source:t[e.l.i],target:t[e.r.i]}})},e.triangles=function(t){var e=[];return un(r(t)).cells.forEach(function(r,n){for(var i,a=r.site,o=r.edges.sort(Yr),s=-1,l=o.length,u=o[l-1].edge,c=u.l===a?u.r:u.l;++s<l;)u,i=c,u=o[s].edge,c=u.l===a?u.r:u.l,n<i.i&&n<c.i&&hn(a,i,c)<0&&e.push([t[n],t[i.i],t[c.i]])}),e},e.x=function(t){return arguments.length?(a=Et(n=t),e):n},e.y=function(t){return arguments.length?(o=Et(i=t),e):i},e.clipExtent=function(t){return arguments.length?(s=null==t?ul:t,e):s===ul?null:s},e.size=function(t){return arguments.length?e.clipExtent(t&&[[0,0],t]):s===ul?null:s&&s[1]},e)};var ul=[[-1e6,-1e6],[1e6,1e6]];uo.geom.delaunay=function(t){return uo.geom.voronoi().triangles(t)},uo.geom.quadtree=function(t,e,r,n,i){function a(t){function a(t,e,r,n,i,a,o,s){if(!isNaN(r)&&!isNaN(n))if(t.leaf){var l=t.x,c=t.y;if(null!=l)if(xo(l-r)+xo(c-n)<.01)u(t,e,r,n,i,a,o,s);else{var h=t.point;t.x=t.y=t.point=null,u(t,h,l,c,i,a,o,s),u(t,e,r,n,i,a,o,s)}else t.x=r,t.y=n,t.point=e}else u(t,e,r,n,i,a,o,s)}function u(t,e,r,n,i,o,s,l){var u=.5*(i+s),c=.5*(o+l),h=r>=u,f=n>=c,d=f<<1|h;t.leaf=!1,t=t.nodes[d]||(t.nodes[d]=pn()),h?i=u:s=u,f?o=c:l=c,a(t,e,r,n,i,o,s,l)}var c,h,f,d,p,m,v,g,y,b=Et(s),x=Et(l);if(null!=e)m=e,v=r,g=n,y=i;else if(g=y=-(m=v=1/0),h=[],f=[],p=t.length,o)for(d=0;d<p;++d)c=t[d],c.x<m&&(m=c.x),c.y<v&&(v=c.y),c.x>g&&(g=c.x),c.y>y&&(y=c.y),h.push(c.x),f.push(c.y);else for(d=0;d<p;++d){var _=+b(c=t[d],d),w=+x(c,d);_<m&&(m=_),w<v&&(v=w),_>g&&(g=_),w>y&&(y=w),h.push(_),f.push(w)}var M=g-m,k=y-v;M>k?y=v+M:g=m+k;var A=pn();if(A.add=function(t){a(A,t,+b(t,++d),+x(t,d),m,v,g,y)},A.visit=function(t){mn(t,A,m,v,g,y)},A.find=function(t){return vn(A,t[0],t[1],m,v,g,y)},d=-1,null==e){for(;++d<p;)a(A,t[d],h[d],f[d],m,v,g,y);--d}else t.forEach(A.add);return h=f=t=c=null,A}var o,s=Cr,l=zr;return(o=arguments.length)?(s=fn,l=dn,3===o&&(i=r,n=e,r=e=0),a(t)):(a.x=function(t){return arguments.length?(s=t,a):s},a.y=function(t){return arguments.length?(l=t,a):l},a.extent=function(t){return arguments.length?(null==t?e=r=n=i=null:(e=+t[0][0],r=+t[0][1],n=+t[1][0],i=+t[1][1]),a):null==e?null:[[e,r],[n,i]]},a.size=function(t){return arguments.length?(null==t?e=r=n=i=null:(e=r=0,n=+t[0],i=+t[1]),a):null==e?null:[n-e,i-r]},a)},uo.interpolateRgb=gn,uo.interpolateObject=yn,uo.interpolateNumber=bn,uo.interpolateString=xn;var cl=/[-+]?(?:\\d+\\.?\\d*|\\.?\\d+)(?:[eE][-+]?\\d+)?/g,hl=new RegExp(cl.source,\"g\");uo.interpolate=_n,uo.interpolators=[function(t,e){var r=typeof e;return(\"string\"===r?ns.has(e.toLowerCase())||/^(#|rgb\\(|hsl\\()/i.test(e)?gn:xn:e instanceof lt?gn:Array.isArray(e)?wn:\"object\"===r&&isNaN(e)?yn:bn)(t,e)}],uo.interpolateArray=wn;var fl=function(){return x},dl=uo.map({linear:fl,poly:Ln,quad:function(){return Tn},cubic:function(){return Sn},sin:function(){return Cn},exp:function(){return zn},circle:function(){return In},elastic:Dn,back:Pn,bounce:function(){return On}}),pl=uo.map({in:x,out:kn,\"in-out\":An,\"out-in\":function(t){return An(kn(t))}});uo.ease=function(t){var e=t.indexOf(\"-\"),r=e>=0?t.slice(0,e):t,n=e>=0?t.slice(e+1):\"in\";return r=dl.get(r)||fl,n=pl.get(n)||x,Mn(n(r.apply(null,co.call(arguments,1))))},uo.interpolateHcl=Rn,uo.interpolateHsl=Fn,uo.interpolateLab=jn,uo.interpolateRound=Nn,uo.transform=function(t){var e=fo.createElementNS(uo.ns.prefix.svg,\"g\");return(uo.transform=function(t){if(null!=t){e.setAttribute(\"transform\",t);var r=e.transform.baseVal.consolidate()}return new Bn(r?r.matrix:ml)})(t)},Bn.prototype.toString=function(){return\"translate(\"+this.translate+\")rotate(\"+this.rotate+\")skewX(\"+this.skew+\")scale(\"+this.scale+\")\"};var ml={a:1,b:0,c:0,d:1,e:0,f:0};uo.interpolateTransform=Zn,uo.layout={},uo.layout.bundle=function(){return function(t){for(var e=[],r=-1,n=t.length;++r<n;)e.push(Qn(t[r]));return e}},uo.layout.chord=function(){function t(){var t,u,h,f,d,p={},m=[],v=uo.range(a),g=[];for(r=[],n=[],t=0,f=-1;++f<a;){for(u=0,d=-1;++d<a;)u+=i[f][d];m.push(u),g.push(uo.range(a)),t+=u}for(o&&v.sort(function(t,e){return o(m[t],m[e])}),s&&g.forEach(function(t,e){t.sort(function(t,r){return s(i[e][t],i[e][r])})}),t=(Bo-c*a)/t,u=0,f=-1;++f<a;){for(h=u,d=-1;++d<a;){var y=v[f],b=g[y][d],x=i[y][b],_=u,w=u+=x*t;p[y+\"-\"+b]={index:y,subindex:b,startAngle:_,endAngle:w,value:x}}n[y]={index:y,startAngle:h,endAngle:u,value:m[y]},u+=c}for(f=-1;++f<a;)for(d=f-1;++d<a;){var M=p[f+\"-\"+d],k=p[d+\"-\"+f];(M.value||k.value)&&r.push(M.value<k.value?{source:k,target:M}:{source:M,target:k})}l&&e()}function e(){r.sort(function(t,e){return l((t.source.value+t.target.value)/2,(e.source.value+e.target.value)/2)})}var r,n,i,a,o,s,l,u={},c=0;return u.matrix=function(t){return arguments.length?(a=(i=t)&&i.length,r=n=null,u):i},u.padding=function(t){return arguments.length?(c=t,r=n=null,u):c},u.sortGroups=function(t){return arguments.length?(o=t,r=n=null,u):o},u.sortSubgroups=function(t){return arguments.length?(s=t,r=null,u):s},u.sortChords=function(t){return arguments.length?(l=t,r&&e(),u):l},u.chords=function(){return r||t(),r},u.groups=function(){return n||t(),n},u},uo.layout.force=function(){function t(t){return function(e,r,n,i){if(e.point!==t){var a=e.cx-t.x,o=e.cy-t.y,s=i-r,l=a*a+o*o;if(s*s/g<l){if(l<m){var u=e.charge/l;t.px-=a*u,t.py-=o*u}return!0}if(e.point&&l&&l<m){var u=e.pointCharge/l;t.px-=a*u,t.py-=o*u}}return!e.charge}}function e(t){t.px=uo.event.x,t.py=uo.event.y,l.resume()}var r,n,i,a,o,s,l={},u=uo.dispatch(\"start\",\"tick\",\"end\"),c=[1,1],h=.9,f=vl,d=gl,p=-30,m=yl,v=.1,g=.64,y=[],b=[];return l.tick=function(){if((i*=.99)<.005)return r=null,u.end({type:\"end\",alpha:i=0}),!0;var e,n,l,f,d,m,g,x,_,w=y.length,M=b.length;for(n=0;n<M;++n)l=b[n],f=l.source,d=l.target,x=d.x-f.x,_=d.y-f.y,(m=x*x+_*_)&&(m=i*o[n]*((m=Math.sqrt(m))-a[n])/m,x*=m,_*=m,d.x-=x*(g=f.weight+d.weight?f.weight/(f.weight+d.weight):.5),d.y-=_*g,f.x+=x*(g=1-g),f.y+=_*g);if((g=i*v)&&(x=c[0]/2,_=c[1]/2,n=-1,g))for(;++n<w;)l=y[n],l.x+=(x-l.x)*g,l.y+=(_-l.y)*g;if(p)for(ai(e=uo.geom.quadtree(y),i,s),n=-1;++n<w;)(l=y[n]).fixed||e.visit(t(l));for(n=-1;++n<w;)l=y[n],l.fixed?(l.x=l.px,l.y=l.py):(l.x-=(l.px-(l.px=l.x))*h,l.y-=(l.py-(l.py=l.y))*h);u.tick({type:\"tick\",alpha:i})},l.nodes=function(t){return arguments.length?(y=t,l):y},l.links=function(t){return arguments.length?(b=t,l):b},l.size=function(t){return arguments.length?(c=t,l):c},l.linkDistance=function(t){return arguments.length?(f=\"function\"==typeof t?t:+t,l):f},l.distance=l.linkDistance,l.linkStrength=function(t){return arguments.length?(d=\"function\"==typeof t?t:+t,l):d},l.friction=function(t){return arguments.length?(h=+t,l):h},l.charge=function(t){return arguments.length?(p=\"function\"==typeof t?t:+t,l):p},l.chargeDistance=function(t){return arguments.length?(m=t*t,l):Math.sqrt(m)},l.gravity=function(t){return arguments.length?(v=+t,l):v},l.theta=function(t){return arguments.length?(g=t*t,l):Math.sqrt(g)},l.alpha=function(t){return arguments.length?(t=+t,i?t>0?i=t:(r.c=null,r.t=NaN,r=null,u.end({type:\"end\",alpha:i=0})):t>0&&(u.start({type:\"start\",alpha:i=t}),r=Dt(l.tick)),l):i},l.start=function(){function t(t,n){if(!r){for(r=new Array(i),l=0;l<i;++l)r[l]=[];for(l=0;l<u;++l){var a=b[l];r[a.source.index].push(a.target),r[a.target.index].push(a.source)}}for(var o,s=r[e],l=-1,c=s.length;++l<c;)if(!isNaN(o=s[l][t]))return o;return Math.random()*n}var e,r,n,i=y.length,u=b.length,h=c[0],m=c[1];for(e=0;e<i;++e)(n=y[e]).index=e,n.weight=0;for(e=0;e<u;++e)n=b[e],\"number\"==typeof n.source&&(n.source=y[n.source]),\"number\"==typeof n.target&&(n.target=y[n.target]),++n.source.weight,++n.target.weight;for(e=0;e<i;++e)n=y[e],isNaN(n.x)&&(n.x=t(\"x\",h)),isNaN(n.y)&&(n.y=t(\"y\",m)),isNaN(n.px)&&(n.px=n.x),isNaN(n.py)&&(n.py=n.y);if(a=[],\"function\"==typeof f)for(e=0;e<u;++e)a[e]=+f.call(this,b[e],e);else for(e=0;e<u;++e)a[e]=f;if(o=[],\"function\"==typeof d)for(e=0;e<u;++e)o[e]=+d.call(this,b[e],e);else for(e=0;e<u;++e)o[e]=d;if(s=[],\"function\"==typeof p)for(e=0;e<i;++e)s[e]=+p.call(this,y[e],e);else for(e=0;e<i;++e)s[e]=p;return l.resume()},l.resume=function(){return l.alpha(.1)},l.stop=function(){return l.alpha(0)},l.drag=function(){if(n||(n=uo.behavior.drag().origin(x).on(\"dragstart.force\",ei).on(\"drag.force\",e).on(\"dragend.force\",ri)),!arguments.length)return n;this.on(\"mouseover.force\",ni).on(\"mouseout.force\",ii).call(n)},uo.rebind(l,u,\"on\")};var vl=20,gl=1,yl=1/0;uo.layout.hierarchy=function(){function t(i){var a,o=[i],s=[];for(i.depth=0;null!=(a=o.pop());)if(s.push(a),(u=r.call(t,a,a.depth))&&(l=u.length)){for(var l,u,c;--l>=0;)o.push(c=u[l]),c.parent=a,c.depth=a.depth+1;n&&(a.value=0),a.children=u}else n&&(a.value=+n.call(t,a,a.depth)||0),delete a.children;return li(i,function(t){var r,i;e&&(r=t.children)&&r.sort(e),n&&(i=t.parent)&&(i.value+=t.value)}),s}var e=hi,r=ui,n=ci;return t.sort=function(r){return arguments.length?(e=r,t):e},t.children=function(e){return arguments.length?(r=e,t):r},t.value=function(e){return arguments.length?(n=e,t):n},t.revalue=function(e){return n&&(si(e,function(t){t.children&&(t.value=0)}),li(e,function(e){var r;e.children||(e.value=+n.call(t,e,e.depth)||0),(r=e.parent)&&(r.value+=e.value)})),e},t},uo.layout.partition=function(){function t(e,r,n,i){var a=e.children;if(e.x=r,e.y=e.depth*i,e.dx=n,e.dy=i,a&&(o=a.length)){var o,s,l,u=-1;for(n=e.value?n/e.value:0;++u<o;)t(s=a[u],r,l=s.value*n,i),r+=l}}function e(t){var r=t.children,n=0;if(r&&(i=r.length))for(var i,a=-1;++a<i;)n=Math.max(n,e(r[a]));return 1+n}function r(r,a){var o=n.call(this,r,a);return t(o[0],0,i[0],i[1]/e(o[0])),o}var n=uo.layout.hierarchy(),i=[1,1];return r.size=function(t){return arguments.length?(i=t,r):i},oi(r,n)},uo.layout.pie=function(){function t(o){var s,l=o.length,u=o.map(function(r,n){return+e.call(t,r,n)}),c=+(\"function\"==typeof n?n.apply(this,arguments):n),h=(\"function\"==typeof i?i.apply(this,arguments):i)-c,f=Math.min(Math.abs(h)/l,+(\"function\"==typeof a?a.apply(this,arguments):a)),d=f*(h<0?-1:1),p=uo.sum(u),m=p?(h-l*d)/p:0,v=uo.range(l),g=[];return null!=r&&v.sort(r===bl?function(t,e){return u[e]-u[t]}:function(t,e){return r(o[t],o[e])}),v.forEach(function(t){g[t]={data:o[t],value:s=u[t],startAngle:c,endAngle:c+=s*m+d,padAngle:f}}),g}var e=Number,r=bl,n=0,i=Bo,a=0;return t.value=function(r){return arguments.length?(e=r,t):e},t.sort=function(e){return arguments.length?(r=e,t):r},t.startAngle=function(e){return arguments.length?(n=e,t):n},t.endAngle=function(e){return arguments.length?(i=e,t):i},t.padAngle=function(e){return arguments.length?(a=e,t):a},t};var bl={};uo.layout.stack=function(){function t(s,l){if(!(f=s.length))return s;var u=s.map(function(r,n){return e.call(t,r,n)}),c=u.map(function(e){return e.map(function(e,r){return[a.call(t,e,r),o.call(t,e,r)]})}),h=r.call(t,c,l);u=uo.permute(u,h),c=uo.permute(c,h);var f,d,p,m,v=n.call(t,c,l),g=u[0].length;for(p=0;p<g;++p)for(i.call(t,u[0][p],m=v[p],c[0][p][1]),d=1;d<f;++d)i.call(t,u[d][p],m+=c[d-1][p][1],c[d][p][1]);return s}var e=x,r=vi,n=gi,i=mi,a=di,o=pi;return t.values=function(r){return arguments.length?(e=r,t):e},t.order=function(e){return arguments.length?(r=\"function\"==typeof e?e:xl.get(e)||vi,t):r},t.offset=function(e){return arguments.length?(n=\"function\"==typeof e?e:_l.get(e)||gi,t):n},t.x=function(e){return arguments.length?(a=e,t):a},t.y=function(e){return arguments.length?(o=e,t):o},t.out=function(e){return arguments.length?(i=e,t):i},t};var xl=uo.map({\"inside-out\":function(t){var e,r,n=t.length,i=t.map(yi),a=t.map(bi),o=uo.range(n).sort(function(t,e){return i[t]-i[e]}),s=0,l=0,u=[],c=[];for(e=0;e<n;++e)r=o[e],s<l?(s+=a[r],u.push(r)):(l+=a[r],c.push(r));return c.reverse().concat(u)},reverse:function(t){return uo.range(t.length).reverse()},default:vi}),_l=uo.map({silhouette:function(t){var e,r,n,i=t.length,a=t[0].length,o=[],s=0,l=[];for(r=0;r<a;++r){for(e=0,n=0;e<i;e++)n+=t[e][r][1];n>s&&(s=n),o.push(n)}for(r=0;r<a;++r)l[r]=(s-o[r])/2;return l},wiggle:function(t){var e,r,n,i,a,o,s,l,u,c=t.length,h=t[0],f=h.length,d=[];for(d[0]=l=u=0,r=1;r<f;++r){for(e=0,i=0;e<c;++e)i+=t[e][r][1];for(e=0,a=0,s=h[r][0]-h[r-1][0];e<c;++e){for(n=0,o=(t[e][r][1]-t[e][r-1][1])/(2*s);n<e;++n)o+=(t[n][r][1]-t[n][r-1][1])/s;a+=o*t[e][r][1]}d[r]=l-=i?a/i*s:0,l<u&&(u=l)}for(r=0;r<f;++r)d[r]-=u;return d},expand:function(t){var e,r,n,i=t.length,a=t[0].length,o=1/i,s=[];for(r=0;r<a;++r){for(e=0,n=0;e<i;e++)n+=t[e][r][1];if(n)for(e=0;e<i;e++)t[e][r][1]/=n;else for(e=0;e<i;e++)t[e][r][1]=o}for(r=0;r<a;++r)s[r]=0;return s},zero:gi});uo.layout.histogram=function(){function t(t,a){for(var o,s,l=[],u=t.map(r,this),c=n.call(this,u,a),h=i.call(this,c,u,a),a=-1,f=u.length,d=h.length-1,p=e?1:1/f;++a<d;)o=l[a]=[],o.dx=h[a+1]-(o.x=h[a]),o.y=0;if(d>0)for(a=-1;++a<f;)(s=u[a])>=c[0]&&s<=c[1]&&(o=l[uo.bisect(h,s,1,d)-1],o.y+=p,o.push(t[a]));return l}var e=!0,r=Number,n=Mi,i=_i;return t.value=function(e){return arguments.length?(r=e,t):r},t.range=function(e){return arguments.length?(n=Et(e),t):n},t.bins=function(e){return arguments.length?(i=\"number\"==typeof e?function(t){return wi(t,e)}:Et(e),t):i},t.frequency=function(r){return arguments.length?(e=!!r,t):e},t},uo.layout.pack=function(){function t(t,a){var o=r.call(this,t,a),s=o[0],l=i[0],u=i[1],c=null==e?Math.sqrt:\"function\"==typeof e?e:function(){return e};if(s.x=s.y=0,li(s,function(t){t.r=+c(t.value)}),li(s,Ei),n){var h=n*(e?1:Math.max(2*s.r/l,2*s.r/u))/2;li(s,function(t){t.r+=h}),li(s,Ei),li(s,function(t){t.r-=h})}return zi(s,l/2,u/2,e?1:1/Math.max(2*s.r/l,2*s.r/u)),o}var e,r=uo.layout.hierarchy().sort(ki),n=0,i=[1,1];return t.size=function(e){return arguments.length?(i=e,t):i},t.radius=function(r){return arguments.length?(e=null==r||\"function\"==typeof r?r:+r,t):e},t.padding=function(e){return arguments.length?(n=+e,t):n},oi(t,r)},uo.layout.tree=function(){function t(t,i){var c=o.call(this,t,i),h=c[0],f=e(h);if(li(f,r),f.parent.m=-f.z,si(f,n),u)si(h,a);else{var d=h,p=h,m=h;si(h,function(t){t.x<d.x&&(d=t),t.x>p.x&&(p=t),t.depth>m.depth&&(m=t)});var v=s(d,p)/2-d.x,g=l[0]/(p.x+s(p,d)/2+v),y=l[1]/(m.depth||1);si(h,function(t){t.x=(t.x+v)*g,t.y=t.depth*y})}return c}function e(t){for(var e,r={A:null,children:[t]},n=[r];null!=(e=n.pop());)for(var i,a=e.children,o=0,s=a.length;o<s;++o)n.push((a[o]=i={_:a[o],parent:e,children:(i=a[o].children)&&i.slice()||[],A:null,a:null,z:0,m:0,c:0,s:0,t:null,i:o}).a=i);return r.children[0]}function r(t){var e=t.children,r=t.parent.children,n=t.i?r[t.i-1]:null;if(e.length){Fi(t);var a=(e[0].z+e[e.length-1].z)/2;n?(t.z=n.z+s(t._,n._),t.m=t.z-a):t.z=a}else n&&(t.z=n.z+s(t._,n._));t.parent.A=i(t,n,t.parent.A||r[0])}function n(t){t._.x=t.z+t.parent.m,t.m+=t.parent.m}function i(t,e,r){if(e){for(var n,i=t,a=t,o=e,l=i.parent.children[0],u=i.m,c=a.m,h=o.m,f=l.m;o=Oi(o),i=Pi(i),o&&i;)l=Pi(l),a=Oi(a),a.a=t,n=o.z+h-i.z-u+s(o._,i._),n>0&&(Ri(ji(o,t,r),t,n),u+=n,c+=n),h+=o.m,u+=i.m,f+=l.m,c+=a.m;o&&!Oi(a)&&(a.t=o,a.m+=h-c),i&&!Pi(l)&&(l.t=i,l.m+=u-f,r=t)}return r}function a(t){t.x*=l[0],t.y=t.depth*l[1]}var o=uo.layout.hierarchy().sort(null).value(null),s=Di,l=[1,1],u=null;return t.separation=function(e){return arguments.length?(s=e,t):s},t.size=function(e){return arguments.length?(u=null==(l=e)?a:null,t):u?null:l},t.nodeSize=function(e){return arguments.length?(u=null==(l=e)?null:a,t):u?l:null},oi(t,o)},uo.layout.cluster=function(){function t(t,a){var o,s=e.call(this,t,a),l=s[0],u=0;li(l,function(t){var e=t.children;e&&e.length?(t.x=Bi(e),t.y=Ni(e)):(t.x=o?u+=r(t,o):0,t.y=0,o=t)});var c=Ui(l),h=Vi(l),f=c.x-r(c,h)/2,d=h.x+r(h,c)/2;return li(l,i?function(t){t.x=(t.x-l.x)*n[0],t.y=(l.y-t.y)*n[1]}:function(t){t.x=(t.x-f)/(d-f)*n[0],t.y=(1-(l.y?t.y/l.y:1))*n[1]}),s}var e=uo.layout.hierarchy().sort(null).value(null),r=Di,n=[1,1],i=!1;return t.separation=function(e){return arguments.length?(r=e,t):r},t.size=function(e){return arguments.length?(i=null==(n=e),t):i?null:n},t.nodeSize=function(e){return arguments.length?(i=null!=(n=e),t):i?n:null},oi(t,e)},uo.layout.treemap=function(){function t(t,e){for(var r,n,i=-1,a=t.length;++i<a;)n=(r=t[i]).value*(e<0?0:e),r.area=isNaN(n)||n<=0?0:n}function e(r){var a=r.children;if(a&&a.length){var o,s,l,u=h(r),c=[],f=a.slice(),p=1/0,m=\"slice\"===d?u.dx:\"dice\"===d?u.dy:\"slice-dice\"===d?1&r.depth?u.dy:u.dx:Math.min(u.dx,u.dy);for(t(f,u.dx*u.dy/r.value),c.area=0;(l=f.length)>0;)c.push(o=f[l-1]),c.area+=o.area,\"squarify\"!==d||(s=n(c,m))<=p?(f.pop(),p=s):(c.area-=c.pop().area,i(c,m,u,!1),m=Math.min(u.dx,u.dy),c.length=c.area=0,p=1/0);c.length&&(i(c,m,u,!0),c.length=c.area=0),a.forEach(e)}}function r(e){var n=e.children;if(n&&n.length){var a,o=h(e),s=n.slice(),l=[];for(t(s,o.dx*o.dy/e.value),l.area=0;a=s.pop();)l.push(a),l.area+=a.area,null!=a.z&&(i(l,a.z?o.dx:o.dy,o,!s.length),l.length=l.area=0);n.forEach(r)}}function n(t,e){for(var r,n=t.area,i=0,a=1/0,o=-1,s=t.length;++o<s;)(r=t[o].area)&&(r<a&&(a=r),r>i&&(i=r));return n*=n,e*=e,n?Math.max(e*i*p/n,n/(e*a*p)):1/0}function i(t,e,r,n){var i,a=-1,o=t.length,s=r.x,u=r.y,c=e?l(t.area/e):0;if(e==r.dx){for((n||c>r.dy)&&(c=r.dy);++a<o;)i=t[a],i.x=s,i.y=u,i.dy=c,s+=i.dx=Math.min(r.x+r.dx-s,c?l(i.area/c):0);i.z=!0,i.dx+=r.x+r.dx-s,r.y+=c,r.dy-=c}else{for((n||c>r.dx)&&(c=r.dx);++a<o;)i=t[a],i.x=s,i.y=u,i.dx=c,u+=i.dy=Math.min(r.y+r.dy-u,c?l(i.area/c):0);i.z=!1,i.dy+=r.y+r.dy-u,r.x+=c,r.dx-=c}}function a(n){var i=o||s(n),a=i[0];return a.x=a.y=0,a.value?(a.dx=u[0],a.dy=u[1]):a.dx=a.dy=0,o&&s.revalue(a),t([a],a.dx*a.dy/a.value),(o?r:e)(a),f&&(o=i),i}var o,s=uo.layout.hierarchy(),l=Math.round,u=[1,1],c=null,h=Hi,f=!1,d=\"squarify\",p=.5*(1+Math.sqrt(5));return a.size=function(t){return arguments.length?(u=t,a):u},a.padding=function(t){function e(e){var r=t.call(a,e,e.depth);return null==r?Hi(e):qi(e,\"number\"==typeof r?[r,r,r,r]:r)}function r(e){return qi(e,t)}if(!arguments.length)return c;var n;return h=null==(c=t)?Hi:\"function\"==(n=typeof t)?e:\"number\"===n?(t=[t,t,t,t],r):r,a},a.round=function(t){return arguments.length?(l=t?Math.round:Number,a):l!=Number},a.sticky=function(t){return arguments.length?(f=t,o=null,a):f},a.ratio=function(t){return arguments.length?(p=t,a):p},a.mode=function(t){return arguments.length?(d=t+\"\",a):d},oi(a,s)},uo.random={normal:function(t,e){var r=arguments.length;return r<2&&(e=1),r<1&&(t=0),function(){var r,n,i;do{r=2*Math.random()-1,n=2*Math.random()-1,i=r*r+n*n}while(!i||i>1);return t+e*r*Math.sqrt(-2*Math.log(i)/i)}},logNormal:function(){var t=uo.random.normal.apply(uo,arguments);return function(){return Math.exp(t())}},bates:function(t){var e=uo.random.irwinHall(t);return function(){return e()/t}},irwinHall:function(t){return function(){for(var e=0,r=0;r<t;r++)e+=Math.random();return e}}},uo.scale={};var wl={floor:x,ceil:x};uo.scale.linear=function(){return Ki([0,1],[0,1],_n,!1)};var Ml={s:1,g:1,p:1,r:1,e:1};uo.scale.log=function(){return aa(uo.scale.linear().domain([0,1]),10,!0,[1,10])};var kl=uo.format(\".0e\"),Al={floor:function(t){return-Math.ceil(-t)},ceil:function(t){return-Math.floor(-t)}};uo.scale.pow=function(){return oa(uo.scale.linear(),1,[0,1])},uo.scale.sqrt=function(){return uo.scale.pow().exponent(.5)},uo.scale.ordinal=function(){return la([],{t:\"range\",a:[[]]})},uo.scale.category10=function(){return uo.scale.ordinal().range(Tl)},uo.scale.category20=function(){return uo.scale.ordinal().range(Sl)},uo.scale.category20b=function(){return uo.scale.ordinal().range(El)},uo.scale.category20c=function(){return uo.scale.ordinal().range(Ll)};var Tl=[2062260,16744206,2924588,14034728,9725885,9197131,14907330,8355711,12369186,1556175].map(_t),Sl=[2062260,11454440,16744206,16759672,2924588,10018698,14034728,16750742,9725885,12955861,9197131,12885140,14907330,16234194,8355711,13092807,12369186,14408589,1556175,10410725].map(_t),El=[3750777,5395619,7040719,10264286,6519097,9216594,11915115,13556636,9202993,12426809,15186514,15190932,8666169,11356490,14049643,15177372,8077683,10834324,13528509,14589654].map(_t),Ll=[3244733,7057110,10406625,13032431,15095053,16616764,16625259,16634018,3253076,7652470,10607003,13101504,7695281,10394312,12369372,14342891,6513507,9868950,12434877,14277081].map(_t);uo.scale.quantile=function(){return ua([],[])},uo.scale.quantize=function(){return ca(0,1,[0,1])},uo.scale.threshold=function(){return ha([.5],[0,1])},uo.scale.identity=function(){return fa([0,1])},uo.svg={},uo.svg.arc=function(){function t(){var t=Math.max(0,+r.apply(this,arguments)),u=Math.max(0,+n.apply(this,arguments)),c=o.apply(this,arguments)-Vo,h=s.apply(this,arguments)-Vo,f=Math.abs(h-c),d=c>h?0:1;if(u<t&&(p=u,u=t,t=p),f>=Uo)return e(u,d)+(t?e(t,1-d):\"\")+\"Z\";var p,m,v,g,y,b,x,_,w,M,k,A,T=0,S=0,E=[];if((g=(+l.apply(this,arguments)||0)/2)&&(v=a===Cl?Math.sqrt(t*t+u*u):+a.apply(this,arguments),d||(S*=-1),u&&(S=nt(v/u*Math.sin(g))),t&&(T=nt(v/t*Math.sin(g)))),u){y=u*Math.cos(c+S),b=u*Math.sin(c+S),x=u*Math.cos(h-S),_=u*Math.sin(h-S);var L=Math.abs(h-c-2*S)<=No?0:1;if(S&&ba(y,b,x,_)===d^L){var C=(c+h)/2;y=u*Math.cos(C),b=u*Math.sin(C),x=_=null}}else y=b=0;if(t){w=t*Math.cos(h-T),M=t*Math.sin(h-T),k=t*Math.cos(c+T),A=t*Math.sin(c+T);var z=Math.abs(c-h+2*T)<=No?0:1;if(T&&ba(w,M,k,A)===1-d^z){var I=(c+h)/2;w=t*Math.cos(I),M=t*Math.sin(I),k=A=null}}else w=M=0;if(f>Fo&&(p=Math.min(Math.abs(u-t)/2,+i.apply(this,arguments)))>.001){m=t<u^d?0:1;var D=p,P=p;if(f<No){var O=null==k?[w,M]:null==x?[y,b]:Or([y,b],[k,A],[x,_],[w,M]),R=y-O[0],F=b-O[1],j=x-O[0],N=_-O[1],B=1/Math.sin(Math.acos((R*j+F*N)/(Math.sqrt(R*R+F*F)*Math.sqrt(j*j+N*N)))/2),U=Math.sqrt(O[0]*O[0]+O[1]*O[1]);P=Math.min(p,(t-U)/(B-1)),D=Math.min(p,(u-U)/(B+1))}if(null!=x){var V=xa(null==k?[w,M]:[k,A],[y,b],u,D,d),H=xa([x,_],[w,M],u,D,d);p===D?E.push(\"M\",V[0],\"A\",D,\",\",D,\" 0 0,\",m,\" \",V[1],\"A\",u,\",\",u,\" 0 \",1-d^ba(V[1][0],V[1][1],H[1][0],H[1][1]),\",\",d,\" \",H[1],\"A\",D,\",\",D,\" 0 0,\",m,\" \",H[0]):E.push(\"M\",V[0],\"A\",D,\",\",D,\" 0 1,\",m,\" \",H[0])}else E.push(\"M\",y,\",\",b);if(null!=k){var q=xa([y,b],[k,A],t,-P,d),G=xa([w,M],null==x?[y,b]:[x,_],t,-P,d);p===P?E.push(\"L\",G[0],\"A\",P,\",\",P,\" 0 0,\",m,\" \",G[1],\"A\",t,\",\",t,\" 0 \",d^ba(G[1][0],G[1][1],q[1][0],q[1][1]),\",\",1-d,\" \",q[1],\"A\",P,\",\",P,\" 0 0,\",m,\" \",q[0]):E.push(\"L\",G[0],\"A\",P,\",\",P,\" 0 0,\",m,\" \",q[0])}else E.push(\"L\",w,\",\",M)}else E.push(\"M\",y,\",\",b),null!=x&&E.push(\"A\",u,\",\",u,\" 0 \",L,\",\",d,\" \",x,\",\",_),E.push(\"L\",w,\",\",M),null!=k&&E.push(\"A\",t,\",\",t,\" 0 \",z,\",\",1-d,\" \",k,\",\",A);return E.push(\"Z\"),E.join(\"\")}function e(t,e){return\"M0,\"+t+\"A\"+t+\",\"+t+\" 0 1,\"+e+\" 0,\"+-t+\"A\"+t+\",\"+t+\" 0 1,\"+e+\" 0,\"+t}var r=pa,n=ma,i=da,a=Cl,o=va,s=ga,l=ya;return t.innerRadius=function(e){return arguments.length?(r=Et(e),t):r},t.outerRadius=function(e){return arguments.length?(n=Et(e),t):n},t.cornerRadius=function(e){return arguments.length?(i=Et(e),t):i},t.padRadius=function(e){return arguments.length?(a=e==Cl?Cl:Et(e),t):a},t.startAngle=function(e){return arguments.length?(o=Et(e),t):o},t.endAngle=function(e){return arguments.length?(s=Et(e),t):s},t.padAngle=function(e){return arguments.length?(l=Et(e),t):l},t.centroid=function(){var t=(+r.apply(this,arguments)+ +n.apply(this,arguments))/2,e=(+o.apply(this,arguments)+ +s.apply(this,arguments))/2-Vo;return[Math.cos(e)*t,Math.sin(e)*t]},t};var Cl=\"auto\";uo.svg.line=function(){return _a(x)};var zl=uo.map({linear:wa,\"linear-closed\":Ma,step:ka,\"step-before\":Aa,\"step-after\":Ta,basis:Ia,\"basis-open\":Da,\"basis-closed\":Pa,bundle:Oa,cardinal:La,\"cardinal-open\":Sa,\"cardinal-closed\":Ea,monotone:Ua});zl.forEach(function(t,e){e.key=t,e.closed=/-closed$/.test(t)});var Il=[0,2/3,1/3,0],Dl=[0,1/3,2/3,0],Pl=[0,1/6,2/3,1/6];uo.svg.line.radial=function(){var t=_a(Va);return t.radius=t.x,delete t.x,t.angle=t.y,delete t.y,t},Aa.reverse=Ta,Ta.reverse=Aa,uo.svg.area=function(){return Ha(x)},uo.svg.area.radial=function(){var t=Ha(Va);return t.radius=t.x,delete t.x,t.innerRadius=t.x0,delete t.x0,t.outerRadius=t.x1,delete t.x1,t.angle=t.y,delete t.y,t.startAngle=t.y0,delete t.y0,t.endAngle=t.y1,delete t.y1,t},uo.svg.chord=function(){function t(t,s){var l=e(this,a,t,s),u=e(this,o,t,s);return\"M\"+l.p0+n(l.r,l.p1,l.a1-l.a0)+(r(l,u)?i(l.r,l.p1,l.r,l.p0):i(l.r,l.p1,u.r,u.p0)+n(u.r,u.p1,u.a1-u.a0)+i(u.r,u.p1,l.r,l.p0))+\"Z\"}function e(t,e,r,n){var i=e.call(t,r,n),a=s.call(t,i,n),o=l.call(t,i,n)-Vo,c=u.call(t,i,n)-Vo;return{r:a,a0:o,a1:c,p0:[a*Math.cos(o),a*Math.sin(o)],p1:[a*Math.cos(c),a*Math.sin(c)]}}function r(t,e){return t.a0==e.a0&&t.a1==e.a1}function n(t,e,r){return\"A\"+t+\",\"+t+\" 0 \"+ +(r>No)+\",1 \"+e}function i(t,e,r,n){return\"Q 0,0 \"+n}var a=xr,o=_r,s=qa,l=va,u=ga;return t.radius=function(e){return arguments.length?(s=Et(e),t):s},t.source=function(e){return arguments.length?(a=Et(e),t):a},t.target=function(e){return arguments.length?(o=Et(e),t):o},t.startAngle=function(e){return arguments.length?(l=Et(e),t):l},t.endAngle=function(e){return arguments.length?(u=Et(e),t):u},t},uo.svg.diagonal=function(){function t(t,i){var a=e.call(this,t,i),o=r.call(this,t,i),s=(a.y+o.y)/2,l=[a,{x:a.x,y:s},{x:o.x,y:s},o];return l=l.map(n),\"M\"+l[0]+\"C\"+l[1]+\" \"+l[2]+\" \"+l[3]}var e=xr,r=_r,n=Ga;return t.source=function(r){return arguments.length?(e=Et(r),t):e},t.target=function(e){return arguments.length?(r=Et(e),t):r},t.projection=function(e){return arguments.length?(n=e,t):n},t},uo.svg.diagonal.radial=function(){var t=uo.svg.diagonal(),e=Ga,r=t.projection;return t.projection=function(t){return arguments.length?r(Ya(e=t)):e},t},uo.svg.symbol=function(){function t(t,n){return(Ol.get(e.call(this,t,n))||Za)(r.call(this,t,n))}var e=Wa,r=Xa;return t.type=function(r){return arguments.length?(e=Et(r),t):e},t.size=function(e){return arguments.length?(r=Et(e),t):r},t};var Ol=uo.map({circle:Za,cross:function(t){var e=Math.sqrt(t/5)/2;return\"M\"+-3*e+\",\"+-e+\"H\"+-e+\"V\"+-3*e+\"H\"+e+\"V\"+-e+\"H\"+3*e+\"V\"+e+\"H\"+e+\"V\"+3*e+\"H\"+-e+\"V\"+e+\"H\"+-3*e+\"Z\"},diamond:function(t){var e=Math.sqrt(t/(2*Fl)),r=e*Fl;return\"M0,\"+-e+\"L\"+r+\",0 0,\"+e+\" \"+-r+\",0Z\"},square:function(t){var e=Math.sqrt(t)/2;return\"M\"+-e+\",\"+-e+\"L\"+e+\",\"+-e+\" \"+e+\",\"+e+\" \"+-e+\",\"+e+\"Z\"},\"triangle-down\":function(t){var e=Math.sqrt(t/Rl),r=e*Rl/2;return\"M0,\"+r+\"L\"+e+\",\"+-r+\" \"+-e+\",\"+-r+\"Z\"},\"triangle-up\":function(t){var e=Math.sqrt(t/Rl),r=e*Rl/2;return\"M0,\"+-r+\"L\"+e+\",\"+r+\" \"+-e+\",\"+r+\"Z\"}});uo.svg.symbolTypes=Ol.keys();var Rl=Math.sqrt(3),Fl=Math.tan(30*Ho);Lo.transition=function(t){for(var e,r,n=jl||++Vl,i=to(t),a=[],o=Nl||{time:Date.now(),ease:En,delay:0,duration:250},s=-1,l=this.length;++s<l;){a.push(e=[]);for(var u=this[s],c=-1,h=u.length;++c<h;)(r=u[c])&&eo(r,c,i,n,o),e.push(r)}return Ka(a,i,n)},Lo.interrupt=function(t){return this.each(null==t?Bl:Ja(to(t)))};var jl,Nl,Bl=Ja(to()),Ul=[],Vl=0;Ul.call=Lo.call,Ul.empty=Lo.empty,Ul.node=Lo.node,Ul.size=Lo.size,uo.transition=function(t,e){return t&&t.transition?jl?t.transition(e):t:uo.selection().transition(t)},uo.transition.prototype=Ul,Ul.select=function(t){\n",
       "var e,r,n,i=this.id,a=this.namespace,o=[];t=C(t);for(var s=-1,l=this.length;++s<l;){o.push(e=[]);for(var u=this[s],c=-1,h=u.length;++c<h;)(n=u[c])&&(r=t.call(n,n.__data__,c,s))?(\"__data__\"in n&&(r.__data__=n.__data__),eo(r,c,a,i,n[a][i]),e.push(r)):e.push(null)}return Ka(o,a,i)},Ul.selectAll=function(t){var e,r,n,i,a,o=this.id,s=this.namespace,l=[];t=z(t);for(var u=-1,c=this.length;++u<c;)for(var h=this[u],f=-1,d=h.length;++f<d;)if(n=h[f]){a=n[s][o],r=t.call(n,n.__data__,f,u),l.push(e=[]);for(var p=-1,m=r.length;++p<m;)(i=r[p])&&eo(i,p,s,o,a),e.push(i)}return Ka(l,s,o)},Ul.filter=function(t){var e,r,n,i=[];\"function\"!=typeof t&&(t=H(t));for(var a=0,o=this.length;a<o;a++){i.push(e=[]);for(var r=this[a],s=0,l=r.length;s<l;s++)(n=r[s])&&t.call(n,n.__data__,s,a)&&e.push(n)}return Ka(i,this.namespace,this.id)},Ul.tween=function(t,e){var r=this.id,n=this.namespace;return arguments.length<2?this.node()[n][r].tween.get(t):G(this,null==e?function(e){e[n][r].tween.remove(t)}:function(i){i[n][r].tween.set(t,e)})},Ul.attr=function(t,e){function r(){this.removeAttribute(s)}function n(){this.removeAttributeNS(s.space,s.local)}function i(t){return null==t?r:(t+=\"\",function(){var e,r=this.getAttribute(s);return r!==t&&(e=o(r,t),function(t){this.setAttribute(s,e(t))})})}function a(t){return null==t?n:(t+=\"\",function(){var e,r=this.getAttributeNS(s.space,s.local);return r!==t&&(e=o(r,t),function(t){this.setAttributeNS(s.space,s.local,e(t))})})}if(arguments.length<2){for(e in t)this.attr(e,t[e]);return this}var o=\"transform\"==t?Zn:_n,s=uo.ns.qualify(t);return Qa(this,\"attr.\"+t,e,s.local?a:i)},Ul.attrTween=function(t,e){function r(t,r){var n=e.call(this,t,r,this.getAttribute(i));return n&&function(t){this.setAttribute(i,n(t))}}function n(t,r){var n=e.call(this,t,r,this.getAttributeNS(i.space,i.local));return n&&function(t){this.setAttributeNS(i.space,i.local,n(t))}}var i=uo.ns.qualify(t);return this.tween(\"attr.\"+t,i.local?n:r)},Ul.style=function(t,e,r){function i(){this.style.removeProperty(t)}function a(e){return null==e?i:(e+=\"\",function(){var i,a=n(this).getComputedStyle(this,null).getPropertyValue(t);return a!==e&&(i=_n(a,e),function(e){this.style.setProperty(t,i(e),r)})})}var o=arguments.length;if(o<3){if(\"string\"!=typeof t){o<2&&(e=\"\");for(r in t)this.style(r,t[r],e);return this}r=\"\"}return Qa(this,\"style.\"+t,e,a)},Ul.styleTween=function(t,e,r){function i(i,a){var o=e.call(this,i,a,n(this).getComputedStyle(this,null).getPropertyValue(t));return o&&function(e){this.style.setProperty(t,o(e),r)}}return arguments.length<3&&(r=\"\"),this.tween(\"style.\"+t,i)},Ul.text=function(t){return Qa(this,\"text\",t,$a)},Ul.remove=function(){var t=this.namespace;return this.each(\"end.transition\",function(){var e;this[t].count<2&&(e=this.parentNode)&&e.removeChild(this)})},Ul.ease=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].ease:(\"function\"!=typeof t&&(t=uo.ease.apply(uo,arguments)),G(this,function(n){n[r][e].ease=t}))},Ul.delay=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].delay:G(this,\"function\"==typeof t?function(n,i,a){n[r][e].delay=+t.call(n,n.__data__,i,a)}:(t=+t,function(n){n[r][e].delay=t}))},Ul.duration=function(t){var e=this.id,r=this.namespace;return arguments.length<1?this.node()[r][e].duration:G(this,\"function\"==typeof t?function(n,i,a){n[r][e].duration=Math.max(1,t.call(n,n.__data__,i,a))}:(t=Math.max(1,t),function(n){n[r][e].duration=t}))},Ul.each=function(t,e){var r=this.id,n=this.namespace;if(arguments.length<2){var i=Nl,a=jl;try{jl=r,G(this,function(e,i,a){Nl=e[n][r],t.call(e,e.__data__,i,a)})}finally{Nl=i,jl=a}}else G(this,function(i){var a=i[n][r];(a.event||(a.event=uo.dispatch(\"start\",\"end\",\"interrupt\"))).on(t,e)});return this},Ul.transition=function(){for(var t,e,r,n,i=this.id,a=++Vl,o=this.namespace,s=[],l=0,u=this.length;l<u;l++){s.push(t=[]);for(var e=this[l],c=0,h=e.length;c<h;c++)(r=e[c])&&(n=r[o][i],eo(r,c,o,a,{time:n.time,ease:n.ease,delay:n.delay+n.duration,duration:n.duration})),t.push(r)}return Ka(s,o,a)},uo.svg.axis=function(){function t(t){t.each(function(){var t,u=uo.select(this),c=this.__chart__||r,h=this.__chart__=r.copy(),f=null==l?h.ticks?h.ticks.apply(h,s):h.domain():l,d=null==e?h.tickFormat?h.tickFormat.apply(h,s):x:e,p=u.selectAll(\".tick\").data(f,h),m=p.enter().insert(\"g\",\".domain\").attr(\"class\",\"tick\").style(\"opacity\",Fo),v=uo.transition(p.exit()).style(\"opacity\",Fo).remove(),g=uo.transition(p.order()).style(\"opacity\",1),y=Math.max(i,0)+o,b=Yi(h),_=u.selectAll(\".domain\").data([0]),w=(_.enter().append(\"path\").attr(\"class\",\"domain\"),uo.transition(_));m.append(\"line\"),m.append(\"text\");var M,k,A,T,S=m.select(\"line\"),E=g.select(\"line\"),L=p.select(\"text\").text(d),C=m.select(\"text\"),z=g.select(\"text\"),I=\"top\"===n||\"left\"===n?-1:1;if(\"bottom\"===n||\"top\"===n?(t=ro,M=\"x\",A=\"y\",k=\"x2\",T=\"y2\",L.attr(\"dy\",I<0?\"0em\":\".71em\").style(\"text-anchor\",\"middle\"),w.attr(\"d\",\"M\"+b[0]+\",\"+I*a+\"V0H\"+b[1]+\"V\"+I*a)):(t=no,M=\"y\",A=\"x\",k=\"y2\",T=\"x2\",L.attr(\"dy\",\".32em\").style(\"text-anchor\",I<0?\"end\":\"start\"),w.attr(\"d\",\"M\"+I*a+\",\"+b[0]+\"H0V\"+b[1]+\"H\"+I*a)),S.attr(T,I*i),C.attr(A,I*y),E.attr(k,0).attr(T,I*i),z.attr(M,0).attr(A,I*y),h.rangeBand){var D=h,P=D.rangeBand()/2;c=h=function(t){return D(t)+P}}else c.rangeBand?c=h:v.call(t,h,c);m.call(t,c,h),g.call(t,h,h)})}var e,r=uo.scale.linear(),n=Hl,i=6,a=6,o=3,s=[10],l=null;return t.scale=function(e){return arguments.length?(r=e,t):r},t.orient=function(e){return arguments.length?(n=e in ql?e+\"\":Hl,t):n},t.ticks=function(){return arguments.length?(s=ho(arguments),t):s},t.tickValues=function(e){return arguments.length?(l=e,t):l},t.tickFormat=function(r){return arguments.length?(e=r,t):e},t.tickSize=function(e){var r=arguments.length;return r?(i=+e,a=+arguments[r-1],t):i},t.innerTickSize=function(e){return arguments.length?(i=+e,t):i},t.outerTickSize=function(e){return arguments.length?(a=+e,t):a},t.tickPadding=function(e){return arguments.length?(o=+e,t):o},t.tickSubdivide=function(){return arguments.length&&t},t};var Hl=\"bottom\",ql={top:1,right:1,bottom:1,left:1};uo.svg.brush=function(){function t(n){n.each(function(){var n=uo.select(this).style(\"pointer-events\",\"all\").style(\"-webkit-tap-highlight-color\",\"rgba(0,0,0,0)\").on(\"mousedown.brush\",a).on(\"touchstart.brush\",a),o=n.selectAll(\".background\").data([0]);o.enter().append(\"rect\").attr(\"class\",\"background\").style(\"visibility\",\"hidden\").style(\"cursor\",\"crosshair\"),n.selectAll(\".extent\").data([0]).enter().append(\"rect\").attr(\"class\",\"extent\").style(\"cursor\",\"move\");var s=n.selectAll(\".resize\").data(m,x);s.exit().remove(),s.enter().append(\"g\").attr(\"class\",function(t){return\"resize \"+t}).style(\"cursor\",function(t){return Gl[t]}).append(\"rect\").attr(\"x\",function(t){return/[ew]$/.test(t)?-3:null}).attr(\"y\",function(t){return/^[ns]/.test(t)?-3:null}).attr(\"width\",6).attr(\"height\",6).style(\"visibility\",\"hidden\"),s.style(\"display\",t.empty()?\"none\":null);var l,h=uo.transition(n),f=uo.transition(o);u&&(l=Yi(u),f.attr(\"x\",l[0]).attr(\"width\",l[1]-l[0]),r(h)),c&&(l=Yi(c),f.attr(\"y\",l[0]).attr(\"height\",l[1]-l[0]),i(h)),e(h)})}function e(t){t.selectAll(\".resize\").attr(\"transform\",function(t){return\"translate(\"+h[+/e$/.test(t)]+\",\"+f[+/^s/.test(t)]+\")\"})}function r(t){t.select(\".extent\").attr(\"x\",h[0]),t.selectAll(\".extent,.n>rect,.s>rect\").attr(\"width\",h[1]-h[0])}function i(t){t.select(\".extent\").attr(\"y\",f[0]),t.selectAll(\".extent,.e>rect,.w>rect\").attr(\"height\",f[1]-f[0])}function a(){function a(){32==uo.event.keyCode&&(L||(b=null,z[0]-=h[1],z[1]-=f[1],L=2),T())}function m(){32==uo.event.keyCode&&2==L&&(z[0]+=h[1],z[1]+=f[1],L=0,T())}function v(){var t=uo.mouse(_),n=!1;x&&(t[0]+=x[0],t[1]+=x[1]),L||(uo.event.altKey?(b||(b=[(h[0]+h[1])/2,(f[0]+f[1])/2]),z[0]=h[+(t[0]<b[0])],z[1]=f[+(t[1]<b[1])]):b=null),S&&g(t,u,0)&&(r(k),n=!0),E&&g(t,c,1)&&(i(k),n=!0),n&&(e(k),M({type:\"brush\",mode:L?\"move\":\"resize\"}))}function g(t,e,r){var n,i,a=Yi(e),l=a[0],u=a[1],c=z[r],m=r?f:h,v=m[1]-m[0];if(L&&(l-=c,u-=v+c),n=(r?p:d)?Math.max(l,Math.min(u,t[r])):t[r],L?i=(n+=c)+v:(b&&(c=Math.max(l,Math.min(u,2*b[r]-n))),c<n?(i=n,n=c):i=c),m[0]!=n||m[1]!=i)return r?s=null:o=null,m[0]=n,m[1]=i,!0}function y(){v(),k.style(\"pointer-events\",\"all\").selectAll(\".resize\").style(\"display\",t.empty()?\"none\":null),uo.select(\"body\").style(\"cursor\",null),I.on(\"mousemove.brush\",null).on(\"mouseup.brush\",null).on(\"touchmove.brush\",null).on(\"touchend.brush\",null).on(\"keydown.brush\",null).on(\"keyup.brush\",null),C(),M({type:\"brushend\"})}var b,x,_=this,w=uo.select(uo.event.target),M=l.of(_,arguments),k=uo.select(_),A=w.datum(),S=!/^(n|s)$/.test(A)&&u,E=!/^(e|w)$/.test(A)&&c,L=w.classed(\"extent\"),C=K(_),z=uo.mouse(_),I=uo.select(n(_)).on(\"keydown.brush\",a).on(\"keyup.brush\",m);if(uo.event.changedTouches?I.on(\"touchmove.brush\",v).on(\"touchend.brush\",y):I.on(\"mousemove.brush\",v).on(\"mouseup.brush\",y),k.interrupt().selectAll(\"*\").interrupt(),L)z[0]=h[0]-z[0],z[1]=f[0]-z[1];else if(A){var D=+/w$/.test(A),P=+/^n/.test(A);x=[h[1-D]-z[0],f[1-P]-z[1]],z[0]=h[D],z[1]=f[P]}else uo.event.altKey&&(b=z.slice());k.style(\"pointer-events\",\"none\").selectAll(\".resize\").style(\"display\",null),uo.select(\"body\").style(\"cursor\",w.style(\"cursor\")),M({type:\"brushstart\"}),v()}var o,s,l=E(t,\"brushstart\",\"brush\",\"brushend\"),u=null,c=null,h=[0,0],f=[0,0],d=!0,p=!0,m=Yl[0];return t.event=function(t){t.each(function(){var t=l.of(this,arguments),e={x:h,y:f,i:o,j:s},r=this.__chart__||e;this.__chart__=e,jl?uo.select(this).transition().each(\"start.brush\",function(){o=r.i,s=r.j,h=r.x,f=r.y,t({type:\"brushstart\"})}).tween(\"brush:brush\",function(){var r=wn(h,e.x),n=wn(f,e.y);return o=s=null,function(i){h=e.x=r(i),f=e.y=n(i),t({type:\"brush\",mode:\"resize\"})}}).each(\"end.brush\",function(){o=e.i,s=e.j,t({type:\"brush\",mode:\"resize\"}),t({type:\"brushend\"})}):(t({type:\"brushstart\"}),t({type:\"brush\",mode:\"resize\"}),t({type:\"brushend\"}))})},t.x=function(e){return arguments.length?(u=e,m=Yl[!u<<1|!c],t):u},t.y=function(e){return arguments.length?(c=e,m=Yl[!u<<1|!c],t):c},t.clamp=function(e){return arguments.length?(u&&c?(d=!!e[0],p=!!e[1]):u?d=!!e:c&&(p=!!e),t):u&&c?[d,p]:u?d:c?p:null},t.extent=function(e){var r,n,i,a,l;return arguments.length?(u&&(r=e[0],n=e[1],c&&(r=r[0],n=n[0]),o=[r,n],u.invert&&(r=u(r),n=u(n)),n<r&&(l=r,r=n,n=l),r==h[0]&&n==h[1]||(h=[r,n])),c&&(i=e[0],a=e[1],u&&(i=i[1],a=a[1]),s=[i,a],c.invert&&(i=c(i),a=c(a)),a<i&&(l=i,i=a,a=l),i==f[0]&&a==f[1]||(f=[i,a])),t):(u&&(o?(r=o[0],n=o[1]):(r=h[0],n=h[1],u.invert&&(r=u.invert(r),n=u.invert(n)),n<r&&(l=r,r=n,n=l))),c&&(s?(i=s[0],a=s[1]):(i=f[0],a=f[1],c.invert&&(i=c.invert(i),a=c.invert(a)),a<i&&(l=i,i=a,a=l))),u&&c?[[r,i],[n,a]]:u?[r,n]:c&&[i,a])},t.clear=function(){return t.empty()||(h=[0,0],f=[0,0],o=s=null),t},t.empty=function(){return!!u&&h[0]==h[1]||!!c&&f[0]==f[1]},uo.rebind(t,l,\"on\")};var Gl={n:\"ns-resize\",e:\"ew-resize\",s:\"ns-resize\",w:\"ew-resize\",nw:\"nwse-resize\",ne:\"nesw-resize\",se:\"nwse-resize\",sw:\"nesw-resize\"},Yl=[[\"n\",\"e\",\"s\",\"w\",\"nw\",\"ne\",\"se\",\"sw\"],[\"e\",\"w\"],[\"n\",\"s\"],[]],Xl=fs.format=ys.timeFormat,Wl=Xl.utc,Zl=Wl(\"%Y-%m-%dT%H:%M:%S.%LZ\");Xl.iso=Date.prototype.toISOString&&+new Date(\"2000-01-01T00:00:00.000Z\")?io:Zl,io.parse=function(t){var e=new Date(t);return isNaN(e)?null:e},io.toString=Zl.toString,fs.second=Vt(function(t){return new ds(1e3*Math.floor(t/1e3))},function(t,e){t.setTime(t.getTime()+1e3*Math.floor(e))},function(t){return t.getSeconds()}),fs.seconds=fs.second.range,fs.seconds.utc=fs.second.utc.range,fs.minute=Vt(function(t){return new ds(6e4*Math.floor(t/6e4))},function(t,e){t.setTime(t.getTime()+6e4*Math.floor(e))},function(t){return t.getMinutes()}),fs.minutes=fs.minute.range,fs.minutes.utc=fs.minute.utc.range,fs.hour=Vt(function(t){var e=t.getTimezoneOffset()/60;return new ds(36e5*(Math.floor(t/36e5-e)+e))},function(t,e){t.setTime(t.getTime()+36e5*Math.floor(e))},function(t){return t.getHours()}),fs.hours=fs.hour.range,fs.hours.utc=fs.hour.utc.range,fs.month=Vt(function(t){return t=fs.day(t),t.setDate(1),t},function(t,e){t.setMonth(t.getMonth()+e)},function(t){return t.getMonth()}),fs.months=fs.month.range,fs.months.utc=fs.month.utc.range;var Jl=[1e3,5e3,15e3,3e4,6e4,3e5,9e5,18e5,36e5,108e5,216e5,432e5,864e5,1728e5,6048e5,2592e6,7776e6,31536e6],Kl=[[fs.second,1],[fs.second,5],[fs.second,15],[fs.second,30],[fs.minute,1],[fs.minute,5],[fs.minute,15],[fs.minute,30],[fs.hour,1],[fs.hour,3],[fs.hour,6],[fs.hour,12],[fs.day,1],[fs.day,2],[fs.week,1],[fs.month,1],[fs.month,3],[fs.year,1]],Ql=Xl.multi([[\".%L\",function(t){return t.getMilliseconds()}],[\":%S\",function(t){return t.getSeconds()}],[\"%I:%M\",function(t){return t.getMinutes()}],[\"%I %p\",function(t){return t.getHours()}],[\"%a %d\",function(t){return t.getDay()&&1!=t.getDate()}],[\"%b %d\",function(t){return 1!=t.getDate()}],[\"%B\",function(t){return t.getMonth()}],[\"%Y\",ze]]),$l={range:function(t,e,r){return uo.range(Math.ceil(t/r)*r,+e,r).map(oo)},floor:x,ceil:x};Kl.year=fs.year,fs.scale=function(){return ao(uo.scale.linear(),Kl,Ql)};var tu=Kl.map(function(t){return[t[0].utc,t[1]]}),eu=Wl.multi([[\".%L\",function(t){return t.getUTCMilliseconds()}],[\":%S\",function(t){return t.getUTCSeconds()}],[\"%I:%M\",function(t){return t.getUTCMinutes()}],[\"%I %p\",function(t){return t.getUTCHours()}],[\"%a %d\",function(t){return t.getUTCDay()&&1!=t.getUTCDate()}],[\"%b %d\",function(t){return 1!=t.getUTCDate()}],[\"%B\",function(t){return t.getUTCMonth()}],[\"%Y\",ze]]);tu.year=fs.year.utc,fs.scale.utc=function(){return ao(uo.scale.linear(),tu,eu)},uo.text=Lt(function(t){return t.responseText}),uo.json=function(t,e){return Ct(t,\"application/json\",so,e)},uo.html=function(t,e){return Ct(t,\"text/html\",lo,e)},uo.xml=Lt(function(t){return t.responseXML}),\"function\"==typeof t&&t.amd?(this.d3=uo,t(uo)):\"object\"==typeof r&&r.exports?r.exports=uo:this.d3=uo}()},{}],122:[function(t,e,r){\"use strict\";function n(t,e){this.point=t,this.index=e}function i(t,e){for(var r=t.point,n=e.point,i=r.length,a=0;a<i;++a){var o=n[a]-r[a];if(o)return o}return 0}function a(t,e,r){if(1===t)return r?[[-1,0]]:[];var n=e.map(function(t,e){return[t[0],e]});n.sort(function(t,e){return t[0]-e[0]});for(var i=new Array(t-1),a=1;a<t;++a){var o=n[a-1],s=n[a];i[a-1]=[o[1],s[1]]}return r&&i.push([-1,i[0][1]],[i[t-1][1],-1]),i}function o(t,e){var r=t.length;if(0===r)return[];var o=t[0].length;if(o<1)return[];if(1===o)return a(r,t,e);for(var u=new Array(r),c=1,h=0;h<r;++h){for(var f=t[h],d=new Array(o+1),p=0,m=0;m<o;++m){var v=f[m];d[m]=v,p+=v*v}d[o]=p,u[h]=new n(d,h),c=Math.max(p,c)}l(u,i),r=u.length;for(var g=new Array(r+o+1),y=new Array(r+o+1),b=(o+1)*(o+1)*c,x=new Array(o+1),h=0;h<=o;++h)x[h]=0;x[o]=b,g[0]=x.slice(),y[0]=-1;for(var h=0;h<=o;++h){var d=x.slice();d[h]=1,g[h+1]=d,y[h+1]=-1}for(var h=0;h<r;++h){var _=u[h];g[h+o+1]=_.point,y[h+o+1]=_.index}var w=s(g,!1);if(w=e?w.filter(function(t){for(var e=0,r=0;r<=o;++r){var n=y[t[r]];if(n<0&&++e>=2)return!1;t[r]=n}return!0}):w.filter(function(t){for(var e=0;e<=o;++e){var r=y[t[e]];if(r<0)return!1;t[e]=r}return!0}),1&o)for(var h=0;h<w.length;++h){var _=w[h],d=_[0];_[0]=_[1],_[1]=d}return w}var s=t(\"incremental-convex-hull\"),l=t(\"uniq\");e.exports=o},{\"incremental-convex-hull\":289,uniq:542}],123:[function(t,e,r){(function(t){function r(t,e){return d[0]=t,d[1]=e,f[0]}function n(t){return f[0]=t,d[0]}function i(t){return f[0]=t,d[1]}function a(t,e){return d[1]=t,d[0]=e,f[0]}function o(t){return f[0]=t,d[1]}function s(t){return f[0]=t,d[0]}function l(t,e){return p.writeUInt32LE(t,0,!0),p.writeUInt32LE(e,4,!0),p.readDoubleLE(0,!0)}function u(t){return p.writeDoubleLE(t,0,!0),p.readUInt32LE(0,!0)}function c(t){return p.writeDoubleLE(t,0,!0),p.readUInt32LE(4,!0)}var h=!1;if(\"undefined\"!=typeof Float64Array){var f=new Float64Array(1),d=new Uint32Array(f.buffer);f[0]=1,h=!0,1072693248===d[1]?(e.exports=function(t){return f[0]=t,[d[0],d[1]]},e.exports.pack=r,e.exports.lo=n,e.exports.hi=i):1072693248===d[0]?(e.exports=function(t){return f[0]=t,[d[1],d[0]]},e.exports.pack=a,e.exports.lo=o,e.exports.hi=s):h=!1}if(!h){var p=new t(8);e.exports=function(t){return p.writeDoubleLE(t,0,!0),[p.readUInt32LE(0,!0),p.readUInt32LE(4,!0)]},e.exports.pack=l,e.exports.lo=u,e.exports.hi=c}e.exports.sign=function(t){return e.exports.hi(t)>>>31},e.exports.exponent=function(t){return(e.exports.hi(t)<<1>>>21)-1023},e.exports.fraction=function(t){var r=e.exports.lo(t),n=e.exports.hi(t),i=1048575&n;return 2146435072&n&&(i+=1<<20),[r,i]},e.exports.denormalized=function(t){return!(2146435072&e.exports.hi(t))}}).call(this,t(\"buffer\").Buffer)},{buffer:76}],124:[function(t,e,r){\"use strict\";function n(t,e,r){var i=0|t[r];if(i<=0)return[];var a,o=new Array(i);if(r===t.length-1)for(a=0;a<i;++a)o[a]=e;else for(a=0;a<i;++a)o[a]=n(t,e,r+1);return o}function i(t,e){var r,n;for(r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function a(t,e){switch(void 0===e&&(e=0),typeof t){case\"number\":if(t>0)return i(0|t,e);break;case\"object\":if(\"number\"==typeof t.length)return n(t,e,0)}return[]}e.exports=a},{}],125:[function(t,e,r){\"use strict\";function n(t,e,r){r=r||2;var n=e&&e.length,a=n?e[0]*r:t.length,s=i(t,0,a,r,!0),l=[];if(!s)return l;var u,c,f,d,p,m,v;if(n&&(s=h(t,e,s,r)),t.length>80*r){u=f=t[0],c=d=t[1];for(var g=r;g<a;g+=r)p=t[g],m=t[g+1],p<u&&(u=p),m<c&&(c=m),p>f&&(f=p),m>d&&(d=m);v=Math.max(f-u,d-c)}return o(s,l,r,u,c,v),l}function i(t,e,r,n,i){var a,o;if(i===z(t,e,r,n)>0)for(a=e;a<r;a+=n)o=E(a,t[a],t[a+1],o);else for(a=r-n;a>=e;a-=n)o=E(a,t[a],t[a+1],o);return o&&w(o,o.next)&&(L(o),o=o.next),o}function a(t,e){if(!t)return t;e||(e=t);var r,n=t;do{if(r=!1,n.steiner||!w(n,n.next)&&0!==_(n.prev,n,n.next))n=n.next;else{if(L(n),(n=e=n.prev)===n.next)return null;r=!0}}while(r||n!==e);return e}function o(t,e,r,n,i,h,f){if(t){!f&&h&&m(t,n,i,h);for(var d,p,v=t;t.prev!==t.next;)if(d=t.prev,p=t.next,h?l(t,n,i,h):s(t))e.push(d.i/r),e.push(t.i/r),e.push(p.i/r),L(t),t=p.next,v=p.next;else if((t=p)===v){f?1===f?(t=u(t,e,r),o(t,e,r,n,i,h,2)):2===f&&c(t,e,r,n,i,h):o(a(t),e,r,n,i,h,1);break}}}function s(t){var e=t.prev,r=t,n=t.next;if(_(e,r,n)>=0)return!1;for(var i=t.next.next;i!==t.prev;){if(b(e.x,e.y,r.x,r.y,n.x,n.y,i.x,i.y)&&_(i.prev,i,i.next)>=0)return!1;i=i.next}return!0}function l(t,e,r,n){var i=t.prev,a=t,o=t.next;if(_(i,a,o)>=0)return!1;for(var s=i.x<a.x?i.x<o.x?i.x:o.x:a.x<o.x?a.x:o.x,l=i.y<a.y?i.y<o.y?i.y:o.y:a.y<o.y?a.y:o.y,u=i.x>a.x?i.x>o.x?i.x:o.x:a.x>o.x?a.x:o.x,c=i.y>a.y?i.y>o.y?i.y:o.y:a.y>o.y?a.y:o.y,h=g(s,l,e,r,n),f=g(u,c,e,r,n),d=t.nextZ;d&&d.z<=f;){if(d!==t.prev&&d!==t.next&&b(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&_(d.prev,d,d.next)>=0)return!1;d=d.nextZ}for(d=t.prevZ;d&&d.z>=h;){if(d!==t.prev&&d!==t.next&&b(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&_(d.prev,d,d.next)>=0)return!1;d=d.prevZ}return!0}function u(t,e,r){var n=t;do{var i=n.prev,a=n.next.next;!w(i,a)&&M(i,n,n.next,a)&&A(i,a)&&A(a,i)&&(e.push(i.i/r),e.push(n.i/r),e.push(a.i/r),L(n),L(n.next),n=t=a),n=n.next}while(n!==t);return n}function c(t,e,r,n,i,s){var l=t;do{for(var u=l.next.next;u!==l.prev;){if(l.i!==u.i&&x(l,u)){var c=S(l,u);return l=a(l,l.next),c=a(c,c.next),o(l,e,r,n,i,s),void o(c,e,r,n,i,s)}u=u.next}l=l.next}while(l!==t)}function h(t,e,r,n){var o,s,l,u,c,h=[];for(o=0,s=e.length;o<s;o++)l=e[o]*n,u=o<s-1?e[o+1]*n:t.length,c=i(t,l,u,n,!1),c===c.next&&(c.steiner=!0),h.push(y(c));for(h.sort(f),o=0;o<h.length;o++)d(h[o],r),r=a(r,r.next);return r}function f(t,e){return t.x-e.x}function d(t,e){if(e=p(t,e)){var r=S(e,t);a(r,r.next)}}function p(t,e){var r,n=e,i=t.x,a=t.y,o=-1/0;do{if(a<=n.y&&a>=n.next.y){var s=n.x+(a-n.y)*(n.next.x-n.x)/(n.next.y-n.y);if(s<=i&&s>o){if(o=s,s===i){if(a===n.y)return n;if(a===n.next.y)return n.next}r=n.x<n.next.x?n:n.next}}n=n.next}while(n!==e);if(!r)return null;if(i===o)return r.prev;var l,u=r,c=r.x,h=r.y,f=1/0;for(n=r.next;n!==u;)i>=n.x&&n.x>=c&&b(a<h?i:o,a,c,h,a<h?o:i,a,n.x,n.y)&&((l=Math.abs(a-n.y)/(i-n.x))<f||l===f&&n.x>r.x)&&A(n,t)&&(r=n,f=l),n=n.next;return r}function m(t,e,r,n){var i=t;do{null===i.z&&(i.z=g(i.x,i.y,e,r,n)),i.prevZ=i.prev,i.nextZ=i.next,i=i.next}while(i!==t);i.prevZ.nextZ=null,i.prevZ=null,v(i)}function v(t){var e,r,n,i,a,o,s,l,u=1;do{for(r=t,t=null,a=null,o=0;r;){for(o++,n=r,s=0,e=0;e<u&&(s++,n=n.nextZ);e++);for(l=u;s>0||l>0&&n;)0===s?(i=n,n=n.nextZ,l--):0!==l&&n?r.z<=n.z?(i=r,r=r.nextZ,s--):(i=n,n=n.nextZ,l--):(i=r,r=r.nextZ,s--),a?a.nextZ=i:t=i,i.prevZ=a,a=i;r=n}a.nextZ=null,u*=2}while(o>1);return t}function g(t,e,r,n,i){return t=32767*(t-r)/i,e=32767*(e-n)/i,t=16711935&(t|t<<8),t=252645135&(t|t<<4),t=858993459&(t|t<<2),t=1431655765&(t|t<<1),e=16711935&(e|e<<8),e=252645135&(e|e<<4),e=858993459&(e|e<<2),e=1431655765&(e|e<<1),t|e<<1}function y(t){var e=t,r=t;do{e.x<r.x&&(r=e),e=e.next}while(e!==t);return r}function b(t,e,r,n,i,a,o,s){return(i-o)*(e-s)-(t-o)*(a-s)>=0&&(t-o)*(n-s)-(r-o)*(e-s)>=0&&(r-o)*(a-s)-(i-o)*(n-s)>=0}function x(t,e){return t.next.i!==e.i&&t.prev.i!==e.i&&!k(t,e)&&A(t,e)&&A(e,t)&&T(t,e)}function _(t,e,r){return(e.y-t.y)*(r.x-e.x)-(e.x-t.x)*(r.y-e.y)}function w(t,e){return t.x===e.x&&t.y===e.y}function M(t,e,r,n){return!!(w(t,e)&&w(r,n)||w(t,n)&&w(r,e))||_(t,e,r)>0!=_(t,e,n)>0&&_(r,n,t)>0!=_(r,n,e)>0}function k(t,e){var r=t;do{if(r.i!==t.i&&r.next.i!==t.i&&r.i!==e.i&&r.next.i!==e.i&&M(r,r.next,t,e))return!0;r=r.next}while(r!==t);return!1}function A(t,e){return _(t.prev,t,t.next)<0?_(t,e,t.next)>=0&&_(t,t.prev,e)>=0:_(t,e,t.prev)<0||_(t,t.next,e)<0}function T(t,e){var r=t,n=!1,i=(t.x+e.x)/2,a=(t.y+e.y)/2;do{r.y>a!=r.next.y>a&&i<(r.next.x-r.x)*(a-r.y)/(r.next.y-r.y)+r.x&&(n=!n),r=r.next}while(r!==t);return n}function S(t,e){var r=new C(t.i,t.x,t.y),n=new C(e.i,e.x,e.y),i=t.next,a=e.prev;return t.next=e,e.prev=t,r.next=i,i.prev=r,n.next=r,r.prev=n,a.next=n,n.prev=a,n}function E(t,e,r,n){var i=new C(t,e,r);return n?(i.next=n.next,i.prev=n,n.next.prev=i,n.next=i):(i.prev=i,i.next=i),i}function L(t){t.next.prev=t.prev,t.prev.next=t.next,t.prevZ&&(t.prevZ.nextZ=t.nextZ),t.nextZ&&(t.nextZ.prevZ=t.prevZ)}function C(t,e,r){this.i=t,this.x=e,this.y=r,this.prev=null,this.next=null,this.z=null,this.prevZ=null,this.nextZ=null,this.steiner=!1}function z(t,e,r,n){for(var i=0,a=e,o=r-n;a<r;a+=n)i+=(t[o]-t[a])*(t[a+1]+t[o+1]),o=a;return i}e.exports=n,n.deviation=function(t,e,r,n){var i=e&&e.length,a=i?e[0]*r:t.length,o=Math.abs(z(t,0,a,r));if(i)for(var s=0,l=e.length;s<l;s++){var u=e[s]*r,c=s<l-1?e[s+1]*r:t.length;o-=Math.abs(z(t,u,c,r))}var h=0;for(s=0;s<n.length;s+=3){var f=n[s]*r,d=n[s+1]*r,p=n[s+2]*r;h+=Math.abs((t[f]-t[p])*(t[d+1]-t[f+1])-(t[f]-t[d])*(t[p+1]-t[f+1]))}return 0===o&&0===h?0:Math.abs((h-o)/o)},n.flatten=function(t){for(var e=t[0][0].length,r={vertices:[],holes:[],dimensions:e},n=0,i=0;i<t.length;i++){for(var a=0;a<t[i].length;a++)for(var o=0;o<e;o++)r.vertices.push(t[i][a][o]);i>0&&(n+=t[i-1].length,r.holes.push(n))}return r}},{}],126:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length;if(\"number\"!=typeof e){e=0;for(var n=0;n<r;++n){var a=t[n];e=Math.max(e,a[0],a[1])}e=1+(0|e)}e|=0;for(var o=new Array(e),n=0;n<e;++n)o[n]=[];for(var n=0;n<r;++n){var a=t[n];o[a[0]].push(a[1]),o[a[1]].push(a[0])}for(var s=0;s<e;++s)i(o[s],function(t,e){return t-e});return o}e.exports=n;var i=t(\"uniq\")},{uniq:542}],127:[function(e,r,n){(function(i,a){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.ES6Promise=i()}(this,function(){\"use strict\";function t(t){return\"function\"==typeof t||\"object\"==typeof t&&null!==t}function r(t){return\"function\"==typeof t}function n(t){G=t}function o(t){Y=t}function s(){return function(){q(u)}}function l(){var t=setTimeout;return function(){return t(u,1)}}function u(){for(var t=0;t<H;t+=2){(0,Q[t])(Q[t+1]),Q[t]=void 0,Q[t+1]=void 0}H=0}function c(t,e){var r=arguments,n=this,i=new this.constructor(f);void 0===i[tt]&&z(i);var a=n._state;return a?function(){var t=r[a-1];Y(function(){return E(a,i,t,n._result)})}():k(n,i,t,e),i}function h(t){var e=this;if(t&&\"object\"==typeof t&&t.constructor===e)return t;var r=new e(f);return x(r,t),r}function f(){}function d(){return new TypeError(\"You cannot resolve a promise with itself\")}function p(){return new TypeError(\"A promises callback cannot return that same promise.\")}function m(t){try{return t.then}catch(t){return it.error=t,it}}function v(t,e,r,n){try{t.call(e,r,n)}catch(t){return t}}function g(t,e,r){Y(function(t){var n=!1,i=v(r,e,function(r){n||(n=!0,e!==r?x(t,r):w(t,r))},function(e){n||(n=!0,M(t,e))},\"Settle: \"+(t._label||\" unknown promise\"));!n&&i&&(n=!0,M(t,i))},t)}function y(t,e){e._state===rt?w(t,e._result):e._state===nt?M(t,e._result):k(e,void 0,function(e){return x(t,e)},function(e){return M(t,e)})}function b(t,e,n){e.constructor===t.constructor&&n===c&&e.constructor.resolve===h?y(t,e):n===it?M(t,it.error):void 0===n?w(t,e):r(n)?g(t,e,n):w(t,e)}function x(e,r){e===r?M(e,d()):t(r)?b(e,r,m(r)):w(e,r)}function _(t){t._onerror&&t._onerror(t._result),A(t)}function w(t,e){t._state===et&&(t._result=e,t._state=rt,0!==t._subscribers.length&&Y(A,t))}function M(t,e){t._state===et&&(t._state=nt,t._result=e,Y(_,t))}function k(t,e,r,n){var i=t._subscribers,a=i.length;t._onerror=null,i[a]=e,i[a+rt]=r,i[a+nt]=n,0===a&&t._state&&Y(A,t)}function A(t){var e=t._subscribers,r=t._state;if(0!==e.length){for(var n=void 0,i=void 0,a=t._result,o=0;o<e.length;o+=3)n=e[o],i=e[o+r],n?E(r,n,i,a):i(a);t._subscribers.length=0}}function T(){this.error=null}function S(t,e){try{return t(e)}catch(t){return at.error=t,at}}function E(t,e,n,i){var a=r(n),o=void 0,s=void 0,l=void 0,u=void 0;if(a){if(o=S(n,i),o===at?(u=!0,s=o.error,o=null):l=!0,e===o)return void M(e,p())}else o=i,l=!0;e._state!==et||(a&&l?x(e,o):u?M(e,s):t===rt?w(e,o):t===nt&&M(e,o))}function L(t,e){try{e(function(e){x(t,e)},function(e){M(t,e)})}catch(e){M(t,e)}}function C(){return ot++}function z(t){t[tt]=ot++,t._state=void 0,t._result=void 0,t._subscribers=[]}function I(t,e){this._instanceConstructor=t,this.promise=new t(f),this.promise[tt]||z(this.promise),V(e)?(this._input=e,this.length=e.length,this._remaining=e.length,this._result=new Array(this.length),0===this.length?w(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&w(this.promise,this._result))):M(this.promise,D())}function D(){return new Error(\"Array Methods must be provided an Array\")}function P(t){return new I(this,t).promise}function O(t){var e=this;return new e(V(t)?function(r,n){for(var i=t.length,a=0;a<i;a++)e.resolve(t[a]).then(r,n)}:function(t,e){return e(new TypeError(\"You must pass an array to race.\"))})}function R(t){var e=this,r=new e(f);return M(r,t),r}function F(){throw new TypeError(\"You must pass a resolver function as the first argument to the promise constructor\")}function j(){throw new TypeError(\"Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.\")}function N(t){this[tt]=C(),this._result=this._state=void 0,this._subscribers=[],f!==t&&(\"function\"!=typeof t&&F(),this instanceof N?L(this,t):j())}function B(){var t=void 0;if(void 0!==a)t=a;else if(\"undefined\"!=typeof self)t=self;else try{t=Function(\"return this\")()}catch(t){throw new Error(\"polyfill failed because global object is unavailable in this environment\")}var e=t.Promise;if(e){var r=null;try{r=Object.prototype.toString.call(e.resolve())}catch(t){}if(\"[object Promise]\"===r&&!e.cast)return}t.Promise=N}var U=void 0;U=Array.isArray?Array.isArray:function(t){return\"[object Array]\"===Object.prototype.toString.call(t)};var V=U,H=0,q=void 0,G=void 0,Y=function(t,e){Q[H]=t,Q[H+1]=e,2===(H+=2)&&(G?G(u):$())},X=\"undefined\"!=typeof window?window:void 0,W=X||{},Z=W.MutationObserver||W.WebKitMutationObserver,J=\"undefined\"==typeof self&&void 0!==i&&\"[object process]\"==={}.toString.call(i),K=\"undefined\"!=typeof Uint8ClampedArray&&\"undefined\"!=typeof importScripts&&\"undefined\"!=typeof MessageChannel,Q=new Array(1e3),$=void 0;$=J?function(){return function(){return i.nextTick(u)}}():Z?function(){var t=0,e=new Z(u),r=document.createTextNode(\"\");return e.observe(r,{characterData:!0}),function(){r.data=t=++t%2}}():K?function(){var t=new MessageChannel;return t.port1.onmessage=u,function(){return t.port2.postMessage(0)}}():void 0===X&&\"function\"==typeof e?function(){try{var t=e,r=t(\"vertx\");return q=r.runOnLoop||r.runOnContext,s()}catch(t){return l()}}():l();var tt=Math.random().toString(36).substring(16),et=void 0,rt=1,nt=2,it=new T,at=new T,ot=0;return I.prototype._enumerate=function(){for(var t=this.length,e=this._input,r=0;this._state===et&&r<t;r++)this._eachEntry(e[r],r)},I.prototype._eachEntry=function(t,e){var r=this._instanceConstructor,n=r.resolve;if(n===h){var i=m(t);if(i===c&&t._state!==et)this._settledAt(t._state,e,t._result);else if(\"function\"!=typeof i)this._remaining--,this._result[e]=t;else if(r===N){var a=new r(f);b(a,t,i),this._willSettleAt(a,e)}else this._willSettleAt(new r(function(e){return e(t)}),e)}else this._willSettleAt(n(t),e)},I.prototype._settledAt=function(t,e,r){var n=this.promise;n._state===et&&(this._remaining--,t===nt?M(n,r):this._result[e]=r),0===this._remaining&&w(n,this._result)},I.prototype._willSettleAt=function(t,e){var r=this;k(t,void 0,function(t){return r._settledAt(rt,e,t)},function(t){return r._settledAt(nt,e,t)})},N.all=P,N.race=O,N.resolve=h,N.reject=R,N._setScheduler=n,N._setAsap=o,N._asap=Y,N.prototype={constructor:N,then:c,catch:function(t){return this.then(null,t)}},B(),N.polyfill=B,N.Promise=N,N})}).call(this,e(\"_process\"),\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{_process:486}],128:[function(t,e,r){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function i(t){return\"function\"==typeof t}function a(t){return\"number\"==typeof t}function o(t){return\"object\"==typeof t&&null!==t}function s(t){return void 0===t}e.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(t){if(!a(t)||t<0||isNaN(t))throw TypeError(\"n must be a positive number\");return this._maxListeners=t,this},n.prototype.emit=function(t){var e,r,n,a,l,u;if(this._events||(this._events={}),\"error\"===t&&(!this._events.error||o(this._events.error)&&!this._events.error.length)){if((e=arguments[1])instanceof Error)throw e;var c=new Error('Uncaught, unspecified \"error\" event. ('+e+\")\");throw c.context=e,c}if(r=this._events[t],s(r))return!1;if(i(r))switch(arguments.length){case 1:r.call(this);break;case 2:r.call(this,arguments[1]);break;case 3:r.call(this,arguments[1],arguments[2]);break;default:a=Array.prototype.slice.call(arguments,1),r.apply(this,a)}else if(o(r))for(a=Array.prototype.slice.call(arguments,1),u=r.slice(),n=u.length,l=0;l<n;l++)u[l].apply(this,a);return!0},n.prototype.addListener=function(t,e){var r;if(!i(e))throw TypeError(\"listener must be a function\");return this._events||(this._events={}),this._events.newListener&&this.emit(\"newListener\",t,i(e.listener)?e.listener:e),this._events[t]?o(this._events[t])?this._events[t].push(e):this._events[t]=[this._events[t],e]:this._events[t]=e,o(this._events[t])&&!this._events[t].warned&&(r=s(this._maxListeners)?n.defaultMaxListeners:this._maxListeners)&&r>0&&this._events[t].length>r&&(this._events[t].warned=!0,console.error(\"(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.\",this._events[t].length),\"function\"==typeof console.trace&&console.trace()),this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(t,e){function r(){this.removeListener(t,r),n||(n=!0,e.apply(this,arguments))}if(!i(e))throw TypeError(\"listener must be a function\");var n=!1;return r.listener=e,this.on(t,r),this},n.prototype.removeListener=function(t,e){var r,n,a,s;if(!i(e))throw TypeError(\"listener must be a function\");if(!this._events||!this._events[t])return this;if(r=this._events[t],a=r.length,n=-1,r===e||i(r.listener)&&r.listener===e)delete this._events[t],this._events.removeListener&&this.emit(\"removeListener\",t,e);else if(o(r)){\n",
       "for(s=a;s-- >0;)if(r[s]===e||r[s].listener&&r[s].listener===e){n=s;break}if(n<0)return this;1===r.length?(r.length=0,delete this._events[t]):r.splice(n,1),this._events.removeListener&&this.emit(\"removeListener\",t,e)}return this},n.prototype.removeAllListeners=function(t){var e,r;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[t]&&delete this._events[t],this;if(0===arguments.length){for(e in this._events)\"removeListener\"!==e&&this.removeAllListeners(e);return this.removeAllListeners(\"removeListener\"),this._events={},this}if(r=this._events[t],i(r))this.removeListener(t,r);else if(r)for(;r.length;)this.removeListener(t,r[r.length-1]);return delete this._events[t],this},n.prototype.listeners=function(t){return this._events&&this._events[t]?i(this._events[t])?[this._events[t]]:this._events[t].slice():[]},n.prototype.listenerCount=function(t){if(this._events){var e=this._events[t];if(i(e))return 1;if(e)return e.length}return 0},n.listenerCount=function(t,e){return t.listenerCount(e)}},{}],129:[function(t,e,r){\"use strict\";function n(t,e,r){var n=e||0,i=r||1;return[[t[12]+t[0],t[13]+t[1],t[14]+t[2],t[15]+t[3]],[t[12]-t[0],t[13]-t[1],t[14]-t[2],t[15]-t[3]],[t[12]+t[4],t[13]+t[5],t[14]+t[6],t[15]+t[7]],[t[12]-t[4],t[13]-t[5],t[14]-t[6],t[15]-t[7]],[n*t[12]+t[8],n*t[13]+t[9],n*t[14]+t[10],n*t[15]+t[11]],[i*t[12]-t[8],i*t[13]-t[9],i*t[14]-t[10],i*t[15]-t[11]]]}e.exports=n},{}],130:[function(t,e,r){\"use strict\";function n(t){for(var e,r=t.length,n=0;n<r;n++)if(((e=t.charCodeAt(n))<9||e>13)&&32!==e&&133!==e&&160!==e&&5760!==e&&6158!==e&&(e<8192||e>8205)&&8232!==e&&8233!==e&&8239!==e&&8287!==e&&8288!==e&&12288!==e&&65279!==e)return!1;return!0}e.exports=function(t){var e=typeof t;if(\"string\"===e){var r=t;if(0===(t=+t)&&n(r))return!1}else if(\"number\"!==e)return!1;return t-t<1}},{}],131:[function(t,e,r){\"use strict\";function n(t){return new Function(\"f\",\"var p = (f && f.properties || {}); return \"+i(t))}function i(t){if(!t)return\"true\";var e=t[0];return t.length<=1?\"any\"===e?\"false\":\"true\":\"(\"+(\"==\"===e?o(t[1],t[2],\"===\",!1):\"!=\"===e?o(t[1],t[2],\"!==\",!1):\"<\"===e||\">\"===e||\"<=\"===e||\">=\"===e?o(t[1],t[2],e,!0):\"any\"===e?s(t.slice(1),\"||\"):\"all\"===e?s(t.slice(1),\"&&\"):\"none\"===e?c(s(t.slice(1),\"||\")):\"in\"===e?l(t[1],t.slice(2)):\"!in\"===e?c(l(t[1],t.slice(2))):\"has\"===e?u(t[1]):\"!has\"===e?c(u([t[1]])):\"true\")+\")\"}function a(t){return\"$type\"===t?\"f.type\":\"$id\"===t?\"f.id\":\"p[\"+JSON.stringify(t)+\"]\"}function o(t,e,r,n){var i=a(t),o=\"$type\"===t?f.indexOf(e):JSON.stringify(e);return(n?\"typeof \"+i+\"=== typeof \"+o+\"&&\":\"\")+i+r+o}function s(t,e){return t.map(i).join(e)}function l(t,e){\"$type\"===t&&(e=e.map(function(t){return f.indexOf(t)}));var r=JSON.stringify(e.sort(h)),n=a(t);return e.length<=200?r+\".indexOf(\"+n+\") !== -1\":\"function(v, a, i, j) {while (i <= j) { var m = (i + j) >> 1;    if (a[m] === v) return true; if (a[m] > v) j = m - 1; else i = m + 1;}return false; }(\"+n+\", \"+r+\",0,\"+(e.length-1)+\")\"}function u(t){return JSON.stringify(t)+\" in p\"}function c(t){return\"!(\"+t+\")\"}function h(t,e){return t<e?-1:t>e?1:0}e.exports=n;var f=[\"Unknown\",\"Point\",\"LineString\",\"Polygon\"]},{}],132:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.min(e,Math.max(t,r))}function i(t,e,r){this.dimension=t.length,this.bounds=[new Array(this.dimension),new Array(this.dimension)];for(var n=0;n<this.dimension;++n)this.bounds[0][n]=-1/0,this.bounds[1][n]=1/0;this._state=t.slice().reverse(),this._velocity=e.slice().reverse(),this._time=[r],this._scratch=[t.slice(),t.slice(),t.slice(),t.slice(),t.slice()]}function a(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=0;return e}function o(t,e,r){switch(arguments.length){case 0:return new i([0],[0],0);case 1:if(\"number\"==typeof t){var n=a(t);return new i(n,n,0)}return new i(t,a(t.length),0);case 2:if(\"number\"==typeof e){var n=a(t.length);return new i(t,n,+e)}r=0;case 3:if(t.length!==e.length)throw new Error(\"state and velocity lengths must match\");return new i(t,e,r)}}e.exports=o;var s=t(\"cubic-hermite\"),l=t(\"binary-search-bounds\"),u=i.prototype;u.flush=function(t){var e=l.gt(this._time,t)-1;e<=0||(this._time.splice(0,e),this._state.splice(0,e*this.dimension),this._velocity.splice(0,e*this.dimension))},u.curve=function(t){var e=this._time,r=e.length,i=l.le(e,t),a=this._scratch[0],o=this._state,u=this._velocity,c=this.dimension,h=this.bounds;if(i<0)for(var f=c-1,d=0;d<c;++d,--f)a[d]=o[f];else if(i>=r-1)for(var f=o.length-1,p=t-e[r-1],d=0;d<c;++d,--f)a[d]=o[f]+p*u[f];else{for(var f=c*(i+1)-1,m=e[i],v=e[i+1],g=v-m||1,y=this._scratch[1],b=this._scratch[2],x=this._scratch[3],_=this._scratch[4],w=!0,d=0;d<c;++d,--f)y[d]=o[f],x[d]=u[f]*g,b[d]=o[f+c],_[d]=u[f+c]*g,w=w&&y[d]===b[d]&&x[d]===_[d]&&0===x[d];if(w)for(var d=0;d<c;++d)a[d]=y[d];else s(y,x,b,_,(t-m)/g,a)}for(var M=h[0],k=h[1],d=0;d<c;++d)a[d]=n(M[d],k[d],a[d]);return a},u.dcurve=function(t){var e=this._time,r=e.length,n=l.le(e,t),i=this._scratch[0],a=this._state,o=this._velocity,u=this.dimension;if(n>=r-1)for(var c=a.length-1,h=(e[r-1],0);h<u;++h,--c)i[h]=o[c];else{for(var c=u*(n+1)-1,f=e[n],d=e[n+1],p=d-f||1,m=this._scratch[1],v=this._scratch[2],g=this._scratch[3],y=this._scratch[4],b=!0,h=0;h<u;++h,--c)m[h]=a[c],g[h]=o[c]*p,v[h]=a[c+u],y[h]=o[c+u]*p,b=b&&m[h]===v[h]&&g[h]===y[h]&&0===g[h];if(b)for(var h=0;h<u;++h)i[h]=0;else{s.derivative(m,g,v,y,(t-f)/p,i);for(var h=0;h<u;++h)i[h]/=p}}return i},u.lastT=function(){var t=this._time;return t[t.length-1]},u.stable=function(){for(var t=this._velocity,e=t.length,r=this.dimension-1;r>=0;--r)if(t[--e])return!1;return!0},u.jump=function(t){var e=this.lastT(),r=this.dimension;if(!(t<e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=this.bounds,l=s[0],u=s[1];this._time.push(e,t);for(var c=0;c<2;++c)for(var h=0;h<r;++h)i.push(i[o++]),a.push(0);this._time.push(t);for(var h=r;h>0;--h)i.push(n(l[h-1],u[h-1],arguments[h])),a.push(0)}},u.push=function(t){var e=this.lastT(),r=this.dimension;if(!(t<e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=t-e,l=this.bounds,u=l[0],c=l[1],h=s>1e-6?1/s:0;this._time.push(t);for(var f=r;f>0;--f){var d=n(u[f-1],c[f-1],arguments[f]);i.push(d),a.push((d-i[o++])*h)}}},u.set=function(t){var e=this.dimension;if(!(t<this.lastT()||arguments.length!==e+1)){var r=this._state,i=this._velocity,a=this.bounds,o=a[0],s=a[1];this._time.push(t);for(var l=e;l>0;--l)r.push(n(o[l-1],s[l-1],arguments[l])),i.push(0)}},u.move=function(t){var e=this.lastT(),r=this.dimension;if(!(t<=e||arguments.length!==r+1)){var i=this._state,a=this._velocity,o=i.length-this.dimension,s=this.bounds,l=s[0],u=s[1],c=t-e,h=c>1e-6?1/c:0;this._time.push(t);for(var f=r;f>0;--f){var d=arguments[f];i.push(n(l[f-1],u[f-1],i[o++]+d)),a.push(d*h)}}},u.idle=function(t){var e=this.lastT();if(!(t<e)){var r=this.dimension,i=this._state,a=this._velocity,o=i.length-r,s=this.bounds,l=s[0],u=s[1],c=t-e;this._time.push(t);for(var h=r-1;h>=0;--h)i.push(n(l[h],u[h],i[o]+c*a[o])),a.push(0),o+=1}}},{\"binary-search-bounds\":65,\"cubic-hermite\":108}],133:[function(t,e,r){\"use strict\";function n(t){t=t||{};var e,r,n=t.canvas||document.createElement(\"canvas\"),o=t.family||\"sans-serif\",s=t.shape||[512,512],l=t.step||[32,32],u=parseFloat(t.size)||16,c=t.chars||[32,126],h=Math.floor((l[0]-u)/2),f=t.radius||1.5*h,d=new a(u,h,f,0,o),p=null==t.align?\"optical\":t.align,m=null==t.fit||1==t.fit?.5:t.fit;if(Array.isArray(c)){if(2===c.length&&\"number\"==typeof c[0]&&\"number\"==typeof c[1]){var v=[];for(e=c[0],r=0;e<=c[1];e++)v[r++]=String.fromCharCode(e);c=v}}else c=String(c).split(\"\");s=s.slice(),n.width=s[0],n.height=s[1];var g=n.getContext(\"2d\");g.fillStyle=\"#000\",g.fillRect(0,0,n.width,n.height),g.textBaseline=\"middle\";var y=l[0],b=l[1],x=0,_=0,w=u/b,M=Math.min(c.length,Math.floor(s[0]/y)*Math.ceil(s[1]/b)),k=d.ctx.textAlign,A=d.buffer,T=d.middle;for(d.ctx.textAlign=\"center\",d.buffer=d.size/2,e=0;e<M;e++)if(c[e]){var S=i(c[e],o,w),E=1,L=[0,0];if(m){var C=m;Array.isArray(m)&&(C=m[e]);var z=.5*(S.bounds[3]-S.bounds[1]),I=.5*(S.bounds[2]-S.bounds[0]),D=Math.max(z,I),P=Math.sqrt(z*z+I*I),O=.333*S.radius+.333*D+.333*P;E=b*C/(O*b*2),d.ctx.font=u*E+\"px \"+o}else d.ctx.font=u+\"px \"+o;p&&(L=\"optical\"===p||!0===p?[.5*y-y*S.center[0],.5*b-b*S.center[1]]:[.5*y-y*(S.bounds[2]+S.bounds[0])*.5,.5*b-b*(S.bounds[3]+S.bounds[1])*.5],d.middle=T+L[1]*E);var R=d.draw(c[e]);g.putImageData(R,x+L[0]*E,_),x+=l[0],x>s[0]-l[0]&&(x=0,_+=l[1])}return d.ctx.textAlign=k,d.buffer=A,d.middle=T,n}function i(t,e,r){if(s[e]&&s[e][t])return s[e][t];var n=200*r,i=o(t,{size:200,fontSize:n,fontFamily:e});s[e]||(s[e]={});var a={center:[i.center[0]/200,i.center[1]/200],bounds:i.bounds.map(function(t){return t/200}),radius:i.radius/200};return s[e][t]=a,a}var a=t(\"tiny-sdf\"),o=t(\"optical-properties\");e.exports=n;var s={}},{\"optical-properties\":470,\"tiny-sdf\":532}],134:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this._color=t,this.key=e,this.value=r,this.left=n,this.right=i,this._count=a}function i(t){return new n(t._color,t.key,t.value,t.left,t.right,t._count)}function a(t,e){return new n(t,e.key,e.value,e.left,e.right,e._count)}function o(t){t._count=1+(t.left?t.left._count:0)+(t.right?t.right._count:0)}function s(t,e){this._compare=t,this.root=e}function l(t,e){if(e.left){var r=l(t,e.left);if(r)return r}var r=t(e.key,e.value);return r||(e.right?l(t,e.right):void 0)}function u(t,e,r,n){if(e(t,n.key)<=0){if(n.left){var i=u(t,e,r,n.left);if(i)return i}var i=r(n.key,n.value);if(i)return i}if(n.right)return u(t,e,r,n.right)}function c(t,e,r,n,i){var a,o=r(t,i.key),s=r(e,i.key);if(o<=0){if(i.left&&(a=c(t,e,r,n,i.left)))return a;if(s>0&&(a=n(i.key,i.value)))return a}if(s>0&&i.right)return c(t,e,r,n,i.right)}function h(t,e){this.tree=t,this._stack=e}function f(t,e){t.key=e.key,t.value=e.value,t.left=e.left,t.right=e.right,t._color=e._color,t._count=e._count}function d(t){for(var e,r,n,s,l=t.length-1;l>=0;--l){if(e=t[l],0===l)return void(e._color=g);if(r=t[l-1],r.left===e){if(n=r.right,n.right&&n.right._color===v){if(n=r.right=i(n),s=n.right=i(n.right),r.right=n.left,n.left=r,n.right=s,n._color=r._color,e._color=g,r._color=g,s._color=g,o(r),o(n),l>1){var u=t[l-2];u.left===r?u.left=n:u.right=n}return void(t[l-1]=n)}if(n.left&&n.left._color===v){if(n=r.right=i(n),s=n.left=i(n.left),r.right=s.left,n.left=s.right,s.left=r,s.right=n,s._color=r._color,r._color=g,n._color=g,e._color=g,o(r),o(n),o(s),l>1){var u=t[l-2];u.left===r?u.left=s:u.right=s}return void(t[l-1]=s)}if(n._color===g){if(r._color===v)return r._color=g,void(r.right=a(v,n));r.right=a(v,n);continue}if(n=i(n),r.right=n.left,n.left=r,n._color=r._color,r._color=v,o(r),o(n),l>1){var u=t[l-2];u.left===r?u.left=n:u.right=n}t[l-1]=n,t[l]=r,l+1<t.length?t[l+1]=e:t.push(e),l+=2}else{if(n=r.left,n.left&&n.left._color===v){if(n=r.left=i(n),s=n.left=i(n.left),r.left=n.right,n.right=r,n.left=s,n._color=r._color,e._color=g,r._color=g,s._color=g,o(r),o(n),l>1){var u=t[l-2];u.right===r?u.right=n:u.left=n}return void(t[l-1]=n)}if(n.right&&n.right._color===v){if(n=r.left=i(n),s=n.right=i(n.right),r.left=s.right,n.right=s.left,s.right=r,s.left=n,s._color=r._color,r._color=g,n._color=g,e._color=g,o(r),o(n),o(s),l>1){var u=t[l-2];u.right===r?u.right=s:u.left=s}return void(t[l-1]=s)}if(n._color===g){if(r._color===v)return r._color=g,void(r.left=a(v,n));r.left=a(v,n);continue}if(n=i(n),r.left=n.right,n.right=r,n._color=r._color,r._color=v,o(r),o(n),l>1){var u=t[l-2];u.right===r?u.right=n:u.left=n}t[l-1]=n,t[l]=r,l+1<t.length?t[l+1]=e:t.push(e),l+=2}}}function p(t,e){return t<e?-1:t>e?1:0}function m(t){return new s(t||p,null)}e.exports=m;var v=0,g=1,y=s.prototype;Object.defineProperty(y,\"keys\",{get:function(){var t=[];return this.forEach(function(e,r){t.push(e)}),t}}),Object.defineProperty(y,\"values\",{get:function(){var t=[];return this.forEach(function(e,r){t.push(r)}),t}}),Object.defineProperty(y,\"length\",{get:function(){return this.root?this.root._count:0}}),y.insert=function(t,e){for(var r=this._compare,i=this.root,l=[],u=[];i;){var c=r(t,i.key);l.push(i),u.push(c),i=c<=0?i.left:i.right}l.push(new n(v,t,e,null,null,1));for(var h=l.length-2;h>=0;--h){var i=l[h];u[h]<=0?l[h]=new n(i._color,i.key,i.value,l[h+1],i.right,i._count+1):l[h]=new n(i._color,i.key,i.value,i.left,l[h+1],i._count+1)}for(var h=l.length-1;h>1;--h){var f=l[h-1],i=l[h];if(f._color===g||i._color===g)break;var d=l[h-2];if(d.left===f)if(f.left===i){var p=d.right;if(!p||p._color!==v){if(d._color=v,d.left=f.right,f._color=g,f.right=d,l[h-2]=f,l[h-1]=i,o(d),o(f),h>=3){var m=l[h-3];m.left===d?m.left=f:m.right=f}break}f._color=g,d.right=a(g,p),d._color=v,h-=1}else{var p=d.right;if(!p||p._color!==v){if(f.right=i.left,d._color=v,d.left=i.right,i._color=g,i.left=f,i.right=d,l[h-2]=i,l[h-1]=f,o(d),o(f),o(i),h>=3){var m=l[h-3];m.left===d?m.left=i:m.right=i}break}f._color=g,d.right=a(g,p),d._color=v,h-=1}else if(f.right===i){var p=d.left;if(!p||p._color!==v){if(d._color=v,d.right=f.left,f._color=g,f.left=d,l[h-2]=f,l[h-1]=i,o(d),o(f),h>=3){var m=l[h-3];m.right===d?m.right=f:m.left=f}break}f._color=g,d.left=a(g,p),d._color=v,h-=1}else{var p=d.left;if(!p||p._color!==v){if(f.left=i.right,d._color=v,d.right=i.left,i._color=g,i.right=f,i.left=d,l[h-2]=i,l[h-1]=f,o(d),o(f),o(i),h>=3){var m=l[h-3];m.right===d?m.right=i:m.left=i}break}f._color=g,d.left=a(g,p),d._color=v,h-=1}}return l[0]._color=g,new s(r,l[0])},y.forEach=function(t,e,r){if(this.root)switch(arguments.length){case 1:return l(t,this.root);case 2:return u(e,this._compare,t,this.root);case 3:if(this._compare(e,r)>=0)return;return c(e,r,this._compare,t,this.root)}},Object.defineProperty(y,\"begin\",{get:function(){for(var t=[],e=this.root;e;)t.push(e),e=e.left;return new h(this,t)}}),Object.defineProperty(y,\"end\",{get:function(){for(var t=[],e=this.root;e;)t.push(e),e=e.right;return new h(this,t)}}),y.at=function(t){if(t<0)return new h(this,[]);for(var e=this.root,r=[];;){if(r.push(e),e.left){if(t<e.left._count){e=e.left;continue}t-=e.left._count}if(!t)return new h(this,r);if(t-=1,!e.right)break;if(t>=e.right._count)break;e=e.right}return new h(this,[])},y.ge=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a<=0&&(i=n.length),r=a<=0?r.left:r.right}return n.length=i,new h(this,n)},y.gt=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a<0&&(i=n.length),r=a<0?r.left:r.right}return n.length=i,new h(this,n)},y.lt=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a>0&&(i=n.length),r=a<=0?r.left:r.right}return n.length=i,new h(this,n)},y.le=function(t){for(var e=this._compare,r=this.root,n=[],i=0;r;){var a=e(t,r.key);n.push(r),a>=0&&(i=n.length),r=a<0?r.left:r.right}return n.length=i,new h(this,n)},y.find=function(t){for(var e=this._compare,r=this.root,n=[];r;){var i=e(t,r.key);if(n.push(r),0===i)return new h(this,n);r=i<=0?r.left:r.right}return new h(this,[])},y.remove=function(t){var e=this.find(t);return e?e.remove():this},y.get=function(t){for(var e=this._compare,r=this.root;r;){var n=e(t,r.key);if(0===n)return r.value;r=n<=0?r.left:r.right}};var b=h.prototype;Object.defineProperty(b,\"valid\",{get:function(){return this._stack.length>0}}),Object.defineProperty(b,\"node\",{get:function(){return this._stack.length>0?this._stack[this._stack.length-1]:null},enumerable:!0}),b.clone=function(){return new h(this.tree,this._stack.slice())},b.remove=function(){var t=this._stack;if(0===t.length)return this.tree;var e=new Array(t.length),r=t[t.length-1];e[e.length-1]=new n(r._color,r.key,r.value,r.left,r.right,r._count);for(var i=t.length-2;i>=0;--i){var r=t[i];r.left===t[i+1]?e[i]=new n(r._color,r.key,r.value,e[i+1],r.right,r._count):e[i]=new n(r._color,r.key,r.value,r.left,e[i+1],r._count)}if(r=e[e.length-1],r.left&&r.right){var a=e.length;for(r=r.left;r.right;)e.push(r),r=r.right;var o=e[a-1];e.push(new n(r._color,o.key,o.value,r.left,r.right,r._count)),e[a-1].key=r.key,e[a-1].value=r.value;for(var i=e.length-2;i>=a;--i)r=e[i],e[i]=new n(r._color,r.key,r.value,r.left,e[i+1],r._count);e[a-1].left=e[a]}if(r=e[e.length-1],r._color===v){var l=e[e.length-2];l.left===r?l.left=null:l.right===r&&(l.right=null),e.pop();for(var i=0;i<e.length;++i)e[i]._count--;return new s(this.tree._compare,e[0])}if(r.left||r.right){r.left?f(r,r.left):r.right&&f(r,r.right),r._color=g;for(var i=0;i<e.length-1;++i)e[i]._count--;return new s(this.tree._compare,e[0])}if(1===e.length)return new s(this.tree._compare,null);for(var i=0;i<e.length;++i)e[i]._count--;var u=e[e.length-2];return d(e),u.left===r?u.left=null:u.right=null,new s(this.tree._compare,e[0])},Object.defineProperty(b,\"key\",{get:function(){if(this._stack.length>0)return this._stack[this._stack.length-1].key},enumerable:!0}),Object.defineProperty(b,\"value\",{get:function(){if(this._stack.length>0)return this._stack[this._stack.length-1].value},enumerable:!0}),Object.defineProperty(b,\"index\",{get:function(){var t=0,e=this._stack;if(0===e.length){var r=this.tree.root;return r?r._count:0}e[e.length-1].left&&(t=e[e.length-1].left._count);for(var n=e.length-2;n>=0;--n)e[n+1]===e[n].right&&(++t,e[n].left&&(t+=e[n].left._count));return t},enumerable:!0}),b.next=function(){var t=this._stack;if(0!==t.length){var e=t[t.length-1];if(e.right)for(e=e.right;e;)t.push(e),e=e.left;else for(t.pop();t.length>0&&t[t.length-1].right===e;)e=t[t.length-1],t.pop()}},Object.defineProperty(b,\"hasNext\",{get:function(){var t=this._stack;if(0===t.length)return!1;if(t[t.length-1].right)return!0;for(var e=t.length-1;e>0;--e)if(t[e-1].left===t[e])return!0;return!1}}),b.update=function(t){var e=this._stack;if(0===e.length)throw new Error(\"Can't update empty node!\");var r=new Array(e.length),i=e[e.length-1];r[r.length-1]=new n(i._color,i.key,t,i.left,i.right,i._count);for(var a=e.length-2;a>=0;--a)i=e[a],i.left===e[a+1]?r[a]=new n(i._color,i.key,i.value,r[a+1],i.right,i._count):r[a]=new n(i._color,i.key,i.value,i.left,r[a+1],i._count);return new s(this.tree._compare,r[0])},b.prev=function(){var t=this._stack;if(0!==t.length){var e=t[t.length-1];if(e.left)for(e=e.left;e;)t.push(e),e=e.right;else for(t.pop();t.length>0&&t[t.length-1].left===e;)e=t[t.length-1],t.pop()}},Object.defineProperty(b,\"hasPrev\",{get:function(){var t=this._stack;if(0===t.length)return!1;if(t[t.length-1].left)return!0;for(var e=t.length-1;e>0;--e)if(t[e-1].right===t[e])return!0;return!1}})},{}],135:[function(t,e,r){function n(t){if(t<0)return Number(\"0/0\");for(var e=o[0],r=o.length-1;r>0;--r)e+=o[r]/(t+r);var n=t+a+.5;return.5*Math.log(2*Math.PI)+(t+.5)*Math.log(n)-n+Math.log(e)-Math.log(t)}var i=[.9999999999998099,676.5203681218851,-1259.1392167224028,771.3234287776531,-176.6150291621406,12.507343278686905,-.13857109526572012,9984369578019572e-21,1.5056327351493116e-7],a=607/128,o=[.9999999999999971,57.15623566586292,-59.59796035547549,14.136097974741746,-.4919138160976202,3399464998481189e-20,4652362892704858e-20,-9837447530487956e-20,.0001580887032249125,-.00021026444172410488,.00021743961811521265,-.0001643181065367639,8441822398385275e-20,-26190838401581408e-21,36899182659531625e-22];e.exports=function t(e){if(e<.5)return Math.PI/(Math.sin(Math.PI*e)*t(1-e));if(e>100)return Math.exp(n(e));e-=1;for(var r=i[0],a=1;a<9;a++)r+=i[a]/(e+a);var o=e+7+.5;return Math.sqrt(2*Math.PI)*Math.pow(o,e+.5)*Math.exp(-o)*r},e.exports.log=n},{}],136:[function(t,e,r){function n(t){if(\"Polygon\"===t.type)return i(t.coordinates);if(\"MultiPolygon\"===t.type){for(var e=0,r=0;r<t.coordinates.length;r++)e+=i(t.coordinates[r]);return e}return null}function i(t){var e=0;if(t&&t.length>0){e+=Math.abs(a(t[0]));for(var r=1;r<t.length;r++)e-=Math.abs(a(t[r]))}return e}function a(t){var e=0;if(t.length>2){for(var r,n,i=0;i<t.length-1;i++)r=t[i],n=t[i+1],e+=o(n[0]-r[0])*(2+Math.sin(o(r[1]))+Math.sin(o(n[1])));e=e*s.RADIUS*s.RADIUS/2}return e}function o(t){return t*Math.PI/180}var s=t(\"wgs84\");e.exports.geometry=n,e.exports.ring=a},{wgs84:564}],137:[function(t,e,r){function n(t,e){switch(t&&t.type||null){case\"FeatureCollection\":return t.features=t.features.map(i(n,e)),t;case\"Feature\":return t.geometry=n(t.geometry,e),t;case\"Polygon\":case\"MultiPolygon\":return a(t,e);default:return t}}function i(t,e){return function(r){return t(r,e)}}function a(t,e){return\"Polygon\"===t.type?t.coordinates=o(t.coordinates,e):\"MultiPolygon\"===t.type&&(t.coordinates=t.coordinates.map(i(o,e))),t}function o(t,e){e=!!e,t[0]=s(t[0],!e);for(var r=1;r<t.length;r++)t[r]=s(t[r],e);return t}function s(t,e){return l(t)===e?t:t.reverse()}function l(t){return u.ring(t)>=0}var u=t(\"geojson-area\");e.exports=n},{\"geojson-area\":136}],138:[function(t,e,r){\"use strict\";function n(t,e,r,n,o,l,u,c){if(r/=e,n/=e,u>=r&&c<=n)return t;if(u>n||c<r)return null;for(var h=[],f=0;f<t.length;f++){var d,p,m=t[f],v=m.geometry,g=m.type;if(d=m.min[o],p=m.max[o],d>=r&&p<=n)h.push(m);else if(!(d>n||p<r)){var y=1===g?i(v,r,n,o):a(v,r,n,o,l,3===g);y.length&&h.push(s(m.tags,g,y,m.id))}}return h.length?h:null}function i(t,e,r,n){for(var i=[],a=0;a<t.length;a++){var o=t[a],s=o[n];s>=e&&s<=r&&i.push(o)}return i}function a(t,e,r,n,i,a){for(var s=[],l=0;l<t.length;l++){var u,c,h,f=0,d=0,p=null,m=t[l],v=m.area,g=m.dist,y=m.outer,b=m.length,x=[];for(c=0;c<b-1;c++)u=p||m[c],p=m[c+1],f=d||u[n],d=p[n],f<e?d>r?(x.push(i(u,p,e),i(u,p,r)),a||(x=o(s,x,v,g,y))):d>=e&&x.push(i(u,p,e)):f>r?d<e?(x.push(i(u,p,r),i(u,p,e)),a||(x=o(s,x,v,g,y))):d<=r&&x.push(i(u,p,r)):(x.push(u),d<e?(x.push(i(u,p,e)),a||(x=o(s,x,v,g,y))):d>r&&(x.push(i(u,p,r)),a||(x=o(s,x,v,g,y))));u=m[b-1],f=u[n],f>=e&&f<=r&&x.push(u),h=x[x.length-1],a&&h&&(x[0][0]!==h[0]||x[0][1]!==h[1])&&x.push(x[0]),o(s,x,v,g,y)}return s}function o(t,e,r,n,i){return e.length&&(e.area=r,e.dist=n,void 0!==i&&(e.outer=i),t.push(e)),[]}e.exports=n;var s=t(\"./feature\")},{\"./feature\":140}],139:[function(t,e,r){\"use strict\";function n(t,e){var r=[];if(\"FeatureCollection\"===t.type)for(var n=0;n<t.features.length;n++)i(r,t.features[n],e);else\"Feature\"===t.type?i(r,t,e):i(r,{geometry:t},e);return r}function i(t,e,r){if(null!==e.geometry){var n,s,l,c,h=e.geometry,f=h.type,d=h.coordinates,p=e.properties,m=e.id;if(\"Point\"===f)t.push(u(p,1,[o(d)],m));else if(\"MultiPoint\"===f)t.push(u(p,1,a(d),m));else if(\"LineString\"===f)t.push(u(p,2,[a(d,r)],m));else if(\"MultiLineString\"===f||\"Polygon\"===f){for(l=[],n=0;n<d.length;n++)c=a(d[n],r),\"Polygon\"===f&&(c.outer=0===n),l.push(c);t.push(u(p,\"Polygon\"===f?3:2,l,m))}else if(\"MultiPolygon\"===f){for(l=[],n=0;n<d.length;n++)for(s=0;s<d[n].length;s++)c=a(d[n][s],r),c.outer=0===s,l.push(c);t.push(u(p,3,l,m))}else{if(\"GeometryCollection\"!==f)throw new Error(\"Input data is not a valid GeoJSON object.\");for(n=0;n<h.geometries.length;n++)i(t,{geometry:h.geometries[n],properties:p},r)}}}function a(t,e){for(var r=[],n=0;n<t.length;n++)r.push(o(t[n]));return e&&(l(r,e),s(r)),r}function o(t){var e=Math.sin(t[1]*Math.PI/180),r=t[0]/360+.5,n=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return n=n<0?0:n>1?1:n,[r,n,0]}function s(t){for(var e,r,n=0,i=0,a=0;a<t.length-1;a++)e=r||t[a],r=t[a+1],n+=e[0]*r[1]-r[0]*e[1],i+=Math.abs(r[0]-e[0])+Math.abs(r[1]-e[1]);t.area=Math.abs(n/2),t.dist=i}e.exports=n;var l=t(\"./simplify\"),u=t(\"./feature\")},{\"./feature\":140,\"./simplify\":142}],140:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a={id:n||null,type:e,geometry:r,tags:t||null,min:[1/0,1/0],max:[-1/0,-1/0]};return i(a),a}function i(t){var e=t.geometry,r=t.min,n=t.max;if(1===t.type)a(r,n,e);else for(var i=0;i<e.length;i++)a(r,n,e[i]);return t}function a(t,e,r){for(var n,i=0;i<r.length;i++)n=r[i],t[0]=Math.min(n[0],t[0]),e[0]=Math.max(n[0],e[0]),t[1]=Math.min(n[1],t[1]),e[1]=Math.max(n[1],e[1])}e.exports=n},{}],141:[function(t,e,r){\"use strict\";function n(t,e){return new i(t,e)}function i(t,e){e=this.options=l(Object.create(this.options),e);var r=e.debug;r&&console.time(\"preprocess data\");var n=1<<e.maxZoom,i=c(t,e.tolerance/(n*e.extent));this.tiles={},this.tileCoords=[],r&&(console.timeEnd(\"preprocess data\"),console.log(\"index: maxZoom: %d, maxPoints: %d\",e.indexMaxZoom,e.indexMaxPoints),console.time(\"generate tiles\"),this.stats={},this.total=0),i=d(i,e.buffer/e.extent,o),i.length&&this.splitTile(i,0,0,0),r&&(i.length&&console.log(\"features: %d, points: %d\",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd(\"generate tiles\"),console.log(\"tiles generated:\",this.total,JSON.stringify(this.stats)))}function a(t,e,r){return 32*((1<<t)*r+e)+t}function o(t,e,r){return[r,(r-t[0])*(e[1]-t[1])/(e[0]-t[0])+t[1],1]}function s(t,e,r){return[(r-t[1])*(e[0]-t[0])/(e[1]-t[1])+t[0],r,1]}function l(t,e){for(var r in e)t[r]=e[r];return t}function u(t,e,r){var n=t.source;if(1!==n.length)return!1;var i=n[0];if(3!==i.type||i.geometry.length>1)return!1;var a=i.geometry[0].length;if(5!==a)return!1;for(var o=0;o<a;o++){var s=h.point(i.geometry[0][o],e,t.z2,t.x,t.y);if(s[0]!==-r&&s[0]!==e+r||s[1]!==-r&&s[1]!==e+r)return!1}return!0}e.exports=n;var c=t(\"./convert\"),h=t(\"./transform\"),f=t(\"./clip\"),d=t(\"./wrap\"),p=t(\"./tile\");i.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,solidChildren:!1,tolerance:3,extent:4096,buffer:64,debug:0},i.prototype.splitTile=function(t,e,r,n,i,l,c){for(var h=[t,e,r,n],d=this.options,m=d.debug,v=null;h.length;){n=h.pop(),r=h.pop(),e=h.pop(),t=h.pop();var g=1<<e,y=a(e,r,n),b=this.tiles[y],x=e===d.maxZoom?0:d.tolerance/(g*d.extent);if(!b&&(m>1&&console.time(\"creation\"),b=this.tiles[y]=p(t,g,r,n,x,e===d.maxZoom),this.tileCoords.push({z:e,x:r,y:n}),m)){m>1&&(console.log(\"tile z%d-%d-%d (features: %d, points: %d, simplified: %d)\",e,r,n,b.numFeatures,b.numPoints,b.numSimplified),console.timeEnd(\"creation\"));var _=\"z\"+e;this.stats[_]=(this.stats[_]||0)+1,this.total++}if(b.source=t,i){if(e===d.maxZoom||e===i)continue;var w=1<<i-e;if(r!==Math.floor(l/w)||n!==Math.floor(c/w))continue}else if(e===d.indexMaxZoom||b.numPoints<=d.indexMaxPoints)continue;if(d.solidChildren||!u(b,d.extent,d.buffer)){b.source=null,m>1&&console.time(\"clipping\");var M,k,A,T,S,E,L=.5*d.buffer/d.extent,C=.5-L,z=.5+L,I=1+L;M=k=A=T=null,S=f(t,g,r-L,r+z,0,o,b.min[0],b.max[0]),E=f(t,g,r+C,r+I,0,o,b.min[0],b.max[0]),S&&(M=f(S,g,n-L,n+z,1,s,b.min[1],b.max[1]),k=f(S,g,n+C,n+I,1,s,b.min[1],b.max[1])),E&&(A=f(E,g,n-L,n+z,1,s,b.min[1],b.max[1]),T=f(E,g,n+C,n+I,1,s,b.min[1],b.max[1])),m>1&&console.timeEnd(\"clipping\"),t.length&&(h.push(M||[],e+1,2*r,2*n),h.push(k||[],e+1,2*r,2*n+1),h.push(A||[],e+1,2*r+1,2*n),h.push(T||[],e+1,2*r+1,2*n+1))}else i&&(v=e)}return v},i.prototype.getTile=function(t,e,r){var n=this.options,i=n.extent,o=n.debug,s=1<<t;e=(e%s+s)%s;var l=a(t,e,r);if(this.tiles[l])return h.tile(this.tiles[l],i);o>1&&console.log(\"drilling down to z%d-%d-%d\",t,e,r);for(var c,f=t,d=e,p=r;!c&&f>0;)f--,d=Math.floor(d/2),p=Math.floor(p/2),c=this.tiles[a(f,d,p)];if(!c||!c.source)return null;if(o>1&&console.log(\"found parent tile z%d-%d-%d\",f,d,p),u(c,i,n.buffer))return h.tile(c,i);o>1&&console.time(\"drilling down\");var m=this.splitTile(c.source,f,d,p,t,e,r);if(o>1&&console.timeEnd(\"drilling down\"),null!==m){var v=1<<t-m;l=a(m,Math.floor(e/v),Math.floor(r/v))}return this.tiles[l]?h.tile(this.tiles[l],i):null}},{\"./clip\":138,\"./convert\":139,\"./tile\":143,\"./transform\":144,\"./wrap\":145}],142:[function(t,e,r){\"use strict\";function n(t,e){var r,n,a,o,s=e*e,l=t.length,u=0,c=l-1,h=[];for(t[u][2]=1,t[c][2]=1;c;){for(n=0,r=u+1;r<c;r++)(a=i(t[r],t[u],t[c]))>n&&(o=r,n=a);n>s?(t[o][2]=n,h.push(u),h.push(o),u=o):(c=h.pop(),u=h.pop())}}function i(t,e,r){var n=e[0],i=e[1],a=r[0],o=r[1],s=t[0],l=t[1],u=a-n,c=o-i;if(0!==u||0!==c){var h=((s-n)*u+(l-i)*c)/(u*u+c*c);h>1?(n=a,i=o):h>0&&(n+=u*h,i+=c*h)}return u=s-n,c=l-i,u*u+c*c}e.exports=n},{}],143:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o){for(var s={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:n,z2:e,transformed:!1,min:[2,1],max:[-1,0]},l=0;l<t.length;l++){s.numFeatures++,i(s,t[l],a,o);var u=t[l].min,c=t[l].max;u[0]<s.min[0]&&(s.min[0]=u[0]),u[1]<s.min[1]&&(s.min[1]=u[1]),c[0]>s.max[0]&&(s.max[0]=c[0]),c[1]>s.max[1]&&(s.max[1]=c[1])}return s}function i(t,e,r,n){var i,o,s,l,u=e.geometry,c=e.type,h=[],f=r*r;if(1===c)for(i=0;i<u.length;i++)h.push(u[i]),t.numPoints++,t.numSimplified++;else for(i=0;i<u.length;i++)if(s=u[i],n||!(2===c&&s.dist<r||3===c&&s.area<f)){var d=[];for(o=0;o<s.length;o++)l=s[o],(n||l[2]>f)&&(d.push(l),t.numSimplified++),t.numPoints++;3===c&&a(d,s.outer),h.push(d)}else t.numPoints+=s.length;if(h.length){var p={geometry:h,type:c,tags:e.tags||null};null!==e.id&&(p.id=e.id),t.features.push(p)}}function a(t,e){o(t)<0===e&&t.reverse()}function o(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r[0]-e[0])*(e[1]+r[1]);return n}e.exports=n},{}],144:[function(t,e,r){\"use strict\";function n(t,e){if(t.transformed)return t;var r,n,a,o=t.z2,s=t.x,l=t.y;for(r=0;r<t.features.length;r++){var u=t.features[r],c=u.geometry;if(1===u.type)for(n=0;n<c.length;n++)c[n]=i(c[n],e,o,s,l);else for(n=0;n<c.length;n++){var h=c[n];for(a=0;a<h.length;a++)h[a]=i(h[a],e,o,s,l)}}return t.transformed=!0,t}function i(t,e,r,n,i){return[Math.round(e*(t[0]*r-n)),Math.round(e*(t[1]*r-i))]}r.tile=n,r.point=i},{}],145:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t,a=o(t,1,-1-e,e,0,r,-1,2),s=o(t,1,1-e,2+e,0,r,-1,2);return(a||s)&&(n=o(t,1,-e,1+e,0,r,-1,2)||[],a&&(n=i(a,1).concat(n)),s&&(n=n.concat(i(s,-1)))),n}function i(t,e){for(var r=[],n=0;n<t.length;n++){var i,o=t[n],l=o.type;if(1===l)i=a(o.geometry,e);else{i=[];for(var u=0;u<o.geometry.length;u++)i.push(a(o.geometry[u],e))}r.push(s(o.tags,l,i,o.id))}return r}function a(t,e){var r=[];r.area=t.area,r.dist=t.dist;for(var n=0;n<t.length;n++)r.push([t[n][0]+e,t[n][1],t[n][2]]);return r}var o=t(\"./clip\"),s=t(\"./feature\");e.exports=n},{\"./clip\":138,\"./feature\":140}],146:[function(t,e,r){function n(t,e){if(\"string\"!=typeof t)throw new TypeError(\"must specify type string\");if(e=e||{},\"undefined\"==typeof document&&!e.canvas)return null;var r=e.canvas||document.createElement(\"canvas\");\"number\"==typeof e.width&&(r.width=e.width),\"number\"==typeof e.height&&(r.height=e.height);var n,i=e;try{var a=[t];0===t.indexOf(\"webgl\")&&a.push(\"experimental-\"+t);for(var o=0;o<a.length;o++)if(n=r.getContext(a[o],i))return n}catch(t){n=null}return n||null}e.exports=n},{}],147:[function(t,e,r){\"use strict\";function n(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function i(t){this.gl=t,this.pixelRatio=1,this.bounds=[[-10,-10,-10],[10,10,10]],this.ticks=[[],[],[]],this.autoTicks=!0,this.tickSpacing=[1,1,1],this.tickEnable=[!0,!0,!0],this.tickFont=[\"sans-serif\",\"sans-serif\",\"sans-serif\"],this.tickSize=[12,12,12],this.tickAngle=[0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[10,10,10],this.lastCubeProps={cubeEdges:[0,0,0],axis:[0,0,0]},this.labels=[\"x\",\"y\",\"z\"],this.labelEnable=[!0,!0,!0],this.labelFont=\"sans-serif\",this.labelSize=[20,20,20],this.labelAngle=[0,0,0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[10,10,10],this.lineEnable=[!0,!0,!0],this.lineMirror=[!1,!1,!1],this.lineWidth=[1,1,1],this.lineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.lineTickEnable=[!0,!0,!0],this.lineTickMirror=[!1,!1,!1],this.lineTickLength=[0,0,0],this.lineTickWidth=[1,1,1],this.lineTickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.gridEnable=[!0,!0,!0],this.gridWidth=[1,1,1],this.gridColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroEnable=[!0,!0,!0],this.zeroLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroLineWidth=[2,2,2],this.backgroundEnable=[!1,!1,!1],this.backgroundColor=[[.8,.8,.8,.5],[.8,.8,.8,.5],[.8,.8,.8,.5]],this._firstInit=!0,this._text=null,this._lines=null,this._background=c(t)}function a(){this.primalOffset=[0,0,0],this.primalMinor=[0,0,0],this.mirrorOffset=[0,0,0],this.mirrorMinor=[0,0,0]}function o(t,e,r,n,i){for(var a=t.primalOffset,o=t.primalMinor,s=t.mirrorOffset,l=t.mirrorMinor,u=n[e],c=0;c<3;++c)if(e!==c){var h=a,f=s,d=o,p=l;u&1<<c&&(h=s,f=a,d=l,p=o),h[c]=r[0][c],f[c]=r[1][c],i[c]>0?(d[c]=-1,p[c]=0):(d[c]=0,p[c]=1)}}function s(t,e){var r=new i(t)\n",
       ";return r.update(e),r}e.exports=s;var l=t(\"./lib/text.js\"),u=t(\"./lib/lines.js\"),c=t(\"./lib/background.js\"),h=t(\"./lib/cube.js\"),f=t(\"./lib/ticks.js\"),d=new Float32Array([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]),p=i.prototype;p.update=function(t){function e(e,r,n){if(n in t){var i,a=t[n],o=this[n];(e?Array.isArray(a)&&Array.isArray(a[0]):Array.isArray(a))?this[n]=i=[r(a[0]),r(a[1]),r(a[2])]:this[n]=i=[r(a),r(a),r(a)];for(var s=0;s<3;++s)if(i[s]!==o[s])return!0}return!1}t=t||{};var r,n=e.bind(this,!1,Number),i=e.bind(this,!1,Boolean),a=e.bind(this,!1,String),o=e.bind(this,!0,function(t){if(Array.isArray(t)){if(3===t.length)return[+t[0],+t[1],+t[2],1];if(4===t.length)return[+t[0],+t[1],+t[2],+t[3]]}return[0,0,0,1]}),s=!1,c=!1;if(\"bounds\"in t)for(var h=t.bounds,d=0;d<2;++d)for(var p=0;p<3;++p)h[d][p]!==this.bounds[d][p]&&(c=!0),this.bounds[d][p]=h[d][p];if(\"ticks\"in t){r=t.ticks,s=!0,this.autoTicks=!1;for(var d=0;d<3;++d)this.tickSpacing[d]=0}else n(\"tickSpacing\")&&(this.autoTicks=!0,c=!0);if(this._firstInit&&(\"ticks\"in t||\"tickSpacing\"in t||(this.autoTicks=!0),c=!0,s=!0,this._firstInit=!1),c&&this.autoTicks&&(r=f.create(this.bounds,this.tickSpacing),s=!0),s){for(var d=0;d<3;++d)r[d].sort(function(t,e){return t.x-e.x});f.equal(r,this.ticks)?s=!1:this.ticks=r}i(\"tickEnable\"),a(\"tickFont\")&&(s=!0),n(\"tickSize\"),n(\"tickAngle\"),n(\"tickPad\"),o(\"tickColor\");var m=a(\"labels\");a(\"labelFont\")&&(m=!0),i(\"labelEnable\"),n(\"labelSize\"),n(\"labelPad\"),o(\"labelColor\"),i(\"lineEnable\"),i(\"lineMirror\"),n(\"lineWidth\"),o(\"lineColor\"),i(\"lineTickEnable\"),i(\"lineTickMirror\"),n(\"lineTickLength\"),n(\"lineTickWidth\"),o(\"lineTickColor\"),i(\"gridEnable\"),n(\"gridWidth\"),o(\"gridColor\"),i(\"zeroEnable\"),o(\"zeroLineColor\"),n(\"zeroLineWidth\"),i(\"backgroundEnable\"),o(\"backgroundColor\"),this._text?this._text&&(m||s)&&this._text.update(this.bounds,this.labels,this.labelFont,this.ticks,this.tickFont):this._text=l(this.gl,this.bounds,this.labels,this.labelFont,this.ticks,this.tickFont),this._lines&&s&&(this._lines.dispose(),this._lines=null),this._lines||(this._lines=u(this.gl,this.bounds,this.ticks))};var m=[new a,new a,new a],v=[0,0,0],g={model:d,view:d,projection:d};p.isOpaque=function(){return!0},p.isTransparent=function(){return!1},p.drawTransparent=function(t){};var y=[0,0,0],b=[0,0,0],x=[0,0,0];p.draw=function(t){t=t||g;for(var e=this.gl,r=t.model||d,i=t.view||d,a=t.projection||d,s=this.bounds,l=h(r,i,a,s),u=l.cubeEdges,c=l.axis,f=i[12],p=i[13],_=i[14],w=i[15],M=this.pixelRatio*(a[3]*f+a[7]*p+a[11]*_+a[15]*w)/e.drawingBufferHeight,k=0;k<3;++k)this.lastCubeProps.cubeEdges[k]=u[k],this.lastCubeProps.axis[k]=c[k];for(var A=m,k=0;k<3;++k)o(m[k],k,this.bounds,u,c);for(var e=this.gl,T=v,k=0;k<3;++k)this.backgroundEnable[k]?T[k]=c[k]:T[k]=0;this._background.draw(r,i,a,s,T,this.backgroundColor),this._lines.bind(r,i,a,this);for(var k=0;k<3;++k){var S=[0,0,0];c[k]>0?S[k]=s[1][k]:S[k]=s[0][k];for(var E=0;E<2;++E){var L=(k+1+E)%3,C=(k+1+(1^E))%3;this.gridEnable[L]&&this._lines.drawGrid(L,C,this.bounds,S,this.gridColor[L],this.gridWidth[L]*this.pixelRatio)}for(var E=0;E<2;++E){var L=(k+1+E)%3,C=(k+1+(1^E))%3;this.zeroEnable[C]&&s[0][C]<=0&&s[1][C]>=0&&this._lines.drawZero(L,C,this.bounds,S,this.zeroLineColor[C],this.zeroLineWidth[C]*this.pixelRatio)}}for(var k=0;k<3;++k){this.lineEnable[k]&&this._lines.drawAxisLine(k,this.bounds,A[k].primalOffset,this.lineColor[k],this.lineWidth[k]*this.pixelRatio),this.lineMirror[k]&&this._lines.drawAxisLine(k,this.bounds,A[k].mirrorOffset,this.lineColor[k],this.lineWidth[k]*this.pixelRatio);for(var z=n(y,A[k].primalMinor),I=n(b,A[k].mirrorMinor),D=this.lineTickLength,E=0;E<3;++E){var P=M/r[5*E];z[E]*=D[E]*P,I[E]*=D[E]*P}this.lineTickEnable[k]&&this._lines.drawAxisTicks(k,A[k].primalOffset,z,this.lineTickColor[k],this.lineTickWidth[k]*this.pixelRatio),this.lineTickMirror[k]&&this._lines.drawAxisTicks(k,A[k].mirrorOffset,I,this.lineTickColor[k],this.lineTickWidth[k]*this.pixelRatio)}this._text.bind(r,i,a,this.pixelRatio);for(var k=0;k<3;++k){for(var O=A[k].primalMinor,R=n(x,A[k].primalOffset),E=0;E<3;++E)this.lineTickEnable[k]&&(R[E]+=M*O[E]*Math.max(this.lineTickLength[E],0)/r[5*E]);if(this.tickEnable[k]){for(var E=0;E<3;++E)R[E]+=M*O[E]*this.tickPad[E]/r[5*E];this._text.drawTicks(k,this.tickSize[k],this.tickAngle[k],R,this.tickColor[k])}if(this.labelEnable[k]){for(var E=0;E<3;++E)R[E]+=M*O[E]*this.labelPad[E]/r[5*E];R[k]+=.5*(s[0][k]+s[1][k]),this._text.drawLabel(k,this.labelSize[k],this.labelAngle[k],R,this.labelColor[k])}}},p.dispose=function(){this._text.dispose(),this._lines.dispose(),this._background.dispose(),this._lines=null,this._text=null,this._background=null,this.gl=null}},{\"./lib/background.js\":148,\"./lib/cube.js\":149,\"./lib/lines.js\":150,\"./lib/text.js\":152,\"./lib/ticks.js\":153}],148:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.buffer=e,this.vao=r,this.shader=n}function i(t){for(var e=[],r=[],i=0,l=0;l<3;++l)for(var u=(l+1)%3,c=(l+2)%3,h=[0,0,0],f=[0,0,0],d=-1;d<=1;d+=2){r.push(i,i+2,i+1,i+1,i+2,i+3),h[l]=d,f[l]=d;for(var p=-1;p<=1;p+=2){h[u]=p;for(var m=-1;m<=1;m+=2)h[c]=m,e.push(h[0],h[1],h[2],f[0],f[1],f[2]),i+=1}var v=u;u=c,c=v}var g=a(t,new Float32Array(e)),y=a(t,new Uint16Array(r),t.ELEMENT_ARRAY_BUFFER),b=o(t,[{buffer:g,type:t.FLOAT,size:3,offset:0,stride:24},{buffer:g,type:t.FLOAT,size:3,offset:12,stride:24}],y),x=s(t);return x.attributes.position.location=0,x.attributes.normal.location=1,new n(t,g,b,x)}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=t(\"./shaders\").bg,l=n.prototype;l.draw=function(t,e,r,n,i,a){for(var o=!1,s=0;s<3;++s)o=o||i[s];if(o){var l=this.gl;l.enable(l.POLYGON_OFFSET_FILL),l.polygonOffset(1,2),this.shader.bind(),this.shader.uniforms={model:t,view:e,projection:r,bounds:n,enable:i,colors:a},this.vao.bind(),this.vao.draw(this.gl.TRIANGLES,36),l.disable(l.POLYGON_OFFSET_FILL)}},l.dispose=function(){this.vao.dispose(),this.buffer.dispose(),this.shader.dispose()}},{\"./shaders\":151,\"gl-buffer\":155,\"gl-vao\":270}],149:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<4;++n){t[n]=r[12+n];for(var i=0;i<3;++i)t[n]+=e[i]*r[4*i+n]}}function i(t){for(var e=0;e<m.length;++e)if(t=l.positive(t,m[e]),t.length<3)return 0;for(var r=t[0],n=r[0]/r[3],i=r[1]/r[3],a=0,e=1;e+1<t.length;++e){var o=t[e],s=t[e+1],u=o[0]/o[3],c=o[1]/o[3],h=s[0]/s[3],f=s[1]/s[3],d=u-n,p=c-i,v=h-n,g=f-i;a+=Math.abs(d*g-p*v)}return a}function a(t,e,r,a){s(c,e,t),s(c,r,c);for(var l=0,m=0;m<2;++m){d[2]=a[m][2];for(var b=0;b<2;++b){d[1]=a[b][1];for(var x=0;x<2;++x)d[0]=a[x][0],n(h[l],d,c),l+=1}}for(var _=-1,m=0;m<8;++m){for(var w=h[m][3],M=0;M<3;++M)f[m][M]=h[m][M]/w;w<0&&(_<0?_=m:f[m][2]<f[_][2]&&(_=m))}if(_<0){_=0;for(var k=0;k<3;++k){for(var A=(k+2)%3,T=(k+1)%3,S=-1,E=-1,L=0;L<2;++L){var C=L<<k,z=C+(L<<A)+(1-L<<T),I=C+(1-L<<A)+(L<<T);u(f[C],f[z],f[I],p)<0||(L?S=1:E=1)}if(S<0||E<0)E>S&&(_|=1<<k);else{for(var L=0;L<2;++L){var C=L<<k,z=C+(L<<A)+(1-L<<T),I=C+(1-L<<A)+(L<<T),D=i([h[C],h[z],h[I],h[C+(1<<A)+(1<<T)]]);L?S=D:E=D}E>S&&(_|=1<<k)}}}for(var P=7^_,O=-1,m=0;m<8;++m)m!==_&&m!==P&&(O<0?O=m:f[O][1]>f[m][1]&&(O=m));for(var R=-1,m=0;m<3;++m){var F=O^1<<m;if(F!==_&&F!==P){R<0&&(R=F);var T=f[F];T[0]<f[R][0]&&(R=F)}}for(var j=-1,m=0;m<3;++m){var F=O^1<<m;if(F!==_&&F!==P&&F!==R){j<0&&(j=F);var T=f[F];T[0]>f[j][0]&&(j=F)}}var N=v;N[0]=N[1]=N[2]=0,N[o.log2(R^O)]=O&R,N[o.log2(O^j)]=O&j;var B=7^j;B===_||B===P?(B=7^R,N[o.log2(j^B)]=B&j):N[o.log2(R^B)]=B&R;for(var U=g,V=_,k=0;k<3;++k)U[k]=V&1<<k?-1:1;return y}e.exports=a;var o=t(\"bit-twiddle\"),s=t(\"gl-mat4/multiply\"),l=(t(\"gl-mat4/invert\"),t(\"split-polygon\")),u=t(\"robust-orientation\"),c=new Array(16),h=(new Array(16),new Array(8)),f=new Array(8),d=new Array(3),p=[0,0,0];!function(){for(var t=0;t<8;++t)h[t]=[1,1,1,1],f[t]=[1,1,1]}();var m=[[0,0,1,0,0],[0,0,-1,1,0],[0,-1,0,1,0],[0,1,0,1,0],[-1,0,0,1,0],[1,0,0,1,0]],v=[1,1,1],g=[0,0,0],y={cubeEdges:v,axis:g}},{\"bit-twiddle\":66,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"robust-orientation\":507,\"split-polygon\":525}],150:[function(t,e,r){\"use strict\";function n(t){return t[0]=t[1]=t[2]=0,t}function i(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t}function a(t,e,r,n,i,a,o,s){this.gl=t,this.vertBuffer=e,this.vao=r,this.shader=n,this.tickCount=i,this.tickOffset=a,this.gridCount=o,this.gridOffset=s}function o(t,e,r){var n=[],i=[0,0,0],o=[0,0,0],c=[0,0,0],h=[0,0,0];n.push(0,0,1,0,1,1,0,0,-1,0,0,-1,0,1,1,0,1,-1);for(var f=0;f<3;++f){for(var d=n.length/3|0,p=0;p<r[f].length;++p){var m=+r[f][p].x;n.push(m,0,1,m,1,1,m,0,-1,m,0,-1,m,1,1,m,1,-1)}var v=n.length/3|0;i[f]=d,o[f]=v-d;for(var d=n.length/3|0,g=0;g<r[f].length;++g){var m=+r[f][g].x;n.push(m,0,1,m,1,1,m,0,-1,m,0,-1,m,1,1,m,1,-1)}var v=n.length/3|0;c[f]=d,h[f]=v-d}var y=s(t,new Float32Array(n)),b=l(t,[{buffer:y,type:t.FLOAT,size:3,stride:0,offset:0}]),x=u(t);return x.attributes.position.location=0,new a(t,y,b,x,o,i,h,c)}e.exports=o;var s=t(\"gl-buffer\"),l=t(\"gl-vao\"),u=t(\"./shaders\").line,c=[0,0,0],h=[0,0,0],f=[0,0,0],d=[0,0,0],p=[1,1],m=a.prototype;m.bind=function(t,e,r){this.shader.bind(),this.shader.uniforms.model=t,this.shader.uniforms.view=e,this.shader.uniforms.projection=r,p[0]=this.gl.drawingBufferWidth,p[1]=this.gl.drawingBufferHeight,this.shader.uniforms.screenShape=p,this.vao.bind()},m.drawAxisLine=function(t,e,r,a,o){var s=n(h);this.shader.uniforms.majorAxis=h,s[t]=e[1][t]-e[0][t],this.shader.uniforms.minorAxis=s;var l=i(d,r);l[t]+=e[0][t],this.shader.uniforms.offset=l,this.shader.uniforms.lineWidth=o,this.shader.uniforms.color=a;var u=n(f);u[(t+2)%3]=1,this.shader.uniforms.screenAxis=u,this.vao.draw(this.gl.TRIANGLES,6);var u=n(f);u[(t+1)%3]=1,this.shader.uniforms.screenAxis=u,this.vao.draw(this.gl.TRIANGLES,6)},m.drawAxisTicks=function(t,e,r,i,a){if(this.tickCount[t]){var o=n(c);o[t]=1,this.shader.uniforms.majorAxis=o,this.shader.uniforms.offset=e,this.shader.uniforms.minorAxis=r,this.shader.uniforms.color=i,this.shader.uniforms.lineWidth=a;var s=n(f);s[t]=1,this.shader.uniforms.screenAxis=s,this.vao.draw(this.gl.TRIANGLES,this.tickCount[t],this.tickOffset[t])}},m.drawGrid=function(t,e,r,a,o,s){if(this.gridCount[t]){var l=n(h);l[e]=r[1][e]-r[0][e],this.shader.uniforms.minorAxis=l;var u=i(d,a);u[e]+=r[0][e],this.shader.uniforms.offset=u;var p=n(c);p[t]=1,this.shader.uniforms.majorAxis=p;var m=n(f);m[t]=1,this.shader.uniforms.screenAxis=m,this.shader.uniforms.lineWidth=s,this.shader.uniforms.color=o,this.vao.draw(this.gl.TRIANGLES,this.gridCount[t],this.gridOffset[t])}},m.drawZero=function(t,e,r,a,o,s){var l=n(h);this.shader.uniforms.majorAxis=l,l[t]=r[1][t]-r[0][t],this.shader.uniforms.minorAxis=l;var u=i(d,a);u[t]+=r[0][t],this.shader.uniforms.offset=u;var c=n(f);c[e]=1,this.shader.uniforms.screenAxis=c,this.shader.uniforms.lineWidth=s,this.shader.uniforms.color=o,this.vao.draw(this.gl.TRIANGLES,6)},m.dispose=function(){this.vao.dispose(),this.vertBuffer.dispose(),this.shader.dispose()}},{\"./shaders\":151,\"gl-buffer\":155,\"gl-vao\":270}],151:[function(t,e,r){\"use strict\";var n=t(\"gl-shader\");r.line=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 offset, majorAxis, minorAxis, screenAxis;\\nuniform float lineWidth;\\nuniform vec2 screenShape;\\n\\nvec3 project(vec3 p) {\\n  vec4 pp = projection * view * model * vec4(p, 1.0);\\n  return pp.xyz / max(pp.w, 0.0001);\\n}\\n\\nvoid main() {\\n  vec3 major = position.x * majorAxis;\\n  vec3 minor = position.y * minorAxis;\\n\\n  vec3 vPosition = major + minor + offset;\\n  vec3 pPosition = project(vPosition);\\n  vec3 offset = project(vPosition + screenAxis * position.z);\\n\\n  vec2 screen = normalize((offset - pPosition).xy * screenShape) / screenShape;\\n\\n  gl_Position = vec4(pPosition + vec3(0.5 * screen * lineWidth, 0), 1.0);\\n}\\n\",\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = color;\\n}\",null,[{name:\"position\",type:\"vec3\"}])};r.text=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 offset, axis;\\nuniform float scale, angle, pixelScale;\\nuniform vec2 resolution;\\n\\nvoid main() {  \\n  //Compute plane offset\\n  vec2 planeCoord = position.xy * pixelScale;\\n  mat2 planeXform = scale * mat2(cos(angle), sin(angle),\\n                                -sin(angle), cos(angle));\\n  vec2 viewOffset = 2.0 * planeXform * planeCoord / resolution;\\n\\n  //Compute world offset\\n  float axisDistance = position.z;\\n  vec3 dataPosition = axisDistance * axis + offset;\\n  vec4 worldPosition = model * vec4(dataPosition, 1);\\n  \\n  //Compute clip position\\n  vec4 viewPosition = view * worldPosition;\\n  vec4 clipPosition = projection * viewPosition;\\n  clipPosition /= clipPosition.w;\\n\\n  //Apply text offset in clip coordinates\\n  clipPosition += vec4(viewOffset, 0, 0);\\n\\n  //Done\\n  gl_Position = clipPosition;\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = color;\\n}\",null,[{name:\"position\",type:\"vec3\"}])};r.bg=function(t){return n(t,\"#define GLSLIFY 1\\nattribute vec3 position;\\nattribute vec3 normal;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 enable;\\nuniform vec3 bounds[2];\\n\\nvarying vec3 colorChannel;\\n\\nvoid main() {\\n  if(dot(normal, enable) > 0.0) {\\n    vec3 nPosition = mix(bounds[0], bounds[1], 0.5 * (position + 1.0));\\n    gl_Position = projection * view * model * vec4(nPosition, 1.0);\\n  } else {\\n    gl_Position = vec4(0,0,0,0);\\n  }\\n  colorChannel = abs(normal);\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 colors[3];\\n\\nvarying vec3 colorChannel;\\n\\nvoid main() {\\n  gl_FragColor = colorChannel.x * colors[0] + \\n                 colorChannel.y * colors[1] +\\n                 colorChannel.z * colors[2];\\n}\",null,[{name:\"position\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}])}},{\"gl-shader\":254}],152:[function(t,e,r){(function(r){\"use strict\";function n(t,e,r,n){this.gl=t,this.shader=e,this.buffer=r,this.vao=n,this.tickOffset=this.tickCount=this.labelOffset=this.labelCount=null}function i(t,e){try{return l(t,e)}catch(t){return console.warn(\"error vectorizing text:\",t),{cells:[],positions:[]}}}function a(t,e,r,i,a,l){var c=o(t),h=s(t,[{buffer:c,size:3}]),f=u(t);f.attributes.position.location=0;var d=new n(t,f,c,h);return d.update(e,r,i,a,l),d}e.exports=a;var o=t(\"gl-buffer\"),s=t(\"gl-vao\"),l=t(\"vectorize-text\"),u=t(\"./shaders\").text,c=window||r.global||{},h=c.__TEXT_CACHE||{};c.__TEXT_CACHE={};var f=n.prototype,d=[0,0];f.bind=function(t,e,r,n){this.vao.bind(),this.shader.bind();var i=this.shader.uniforms;i.model=t,i.view=e,i.projection=r,i.pixelScale=n,d[0]=this.gl.drawingBufferWidth,d[1]=this.gl.drawingBufferHeight,this.shader.uniforms.resolution=d},f.update=function(t,e,r,n,a){function o(t,e,r,n){var a=h[r];a||(a=h[r]={});var o=a[e];o||(o=a[e]=i(e,{triangles:!0,font:r,textAlign:\"center\",textBaseline:\"middle\"}));for(var l=(n||12)/12,u=o.positions,c=o.cells,f=0,d=c.length;f<d;++f)for(var p=c[f],m=2;m>=0;--m){var v=u[p[m]];s.push(l*v[0],-l*v[1],t)}}for(var s=(this.gl,[]),l=[0,0,0],u=[0,0,0],c=[0,0,0],f=[0,0,0],d=0;d<3;++d){c[d]=s.length/3|0,o(.5*(t[0][d]+t[1][d]),e[d],r),f[d]=(s.length/3|0)-c[d],l[d]=s.length/3|0;for(var p=0;p<n[d].length;++p)n[d][p].text&&o(n[d][p].x,n[d][p].text,n[d][p].font||a,n[d][p].fontSize||12);u[d]=(s.length/3|0)-l[d]}this.buffer.update(s),this.tickOffset=l,this.tickCount=u,this.labelOffset=c,this.labelCount=f};var p=[0,0,0];f.drawTicks=function(t,e,r,n,i){if(this.tickCount[t]){var a=p;a[0]=a[1]=a[2]=0,a[t]=1,this.shader.uniforms.axis=a,this.shader.uniforms.color=i,this.shader.uniforms.angle=r,this.shader.uniforms.scale=e,this.shader.uniforms.offset=n,this.vao.draw(this.gl.TRIANGLES,this.tickCount[t],this.tickOffset[t])}};var m=[0,0,0];f.drawLabel=function(t,e,r,n,i){this.labelCount[t]&&(this.shader.uniforms.axis=m,this.shader.uniforms.color=i,this.shader.uniforms.angle=r,this.shader.uniforms.scale=e,this.shader.uniforms.offset=n,this.vao.draw(this.gl.TRIANGLES,this.labelCount[t],this.labelOffset[t]))},f.dispose=function(){this.shader.dispose(),this.vao.dispose(),this.buffer.dispose()}}).call(this,t(\"_process\"))},{\"./shaders\":151,_process:486,\"gl-buffer\":155,\"gl-vao\":270,\"vectorize-text\":553}],153:[function(t,e,r){\"use strict\";function n(t,e){var r=t+\"\",n=r.indexOf(\".\"),i=0;n>=0&&(i=r.length-n-1);var a=Math.pow(10,i),o=Math.round(t*e*a),s=o+\"\";if(s.indexOf(\"e\")>=0)return s;var l=o/a,u=o%a;o<0?(l=0|-Math.ceil(l),u=0|-u):(l=0|Math.floor(l),u|=0);var c=\"\"+l;if(o<0&&(c=\"-\"+c),i){for(var h=\"\"+u;h.length<i;)h=\"0\"+h;return c+\".\"+h}return c}function i(t,e){for(var r=[],i=0;i<3;++i){for(var a=[],o=(t[0][i],t[1][i],0);o*e[i]<=t[1][i];++o)a.push({x:o*e[i],text:n(e[i],o)});for(var o=-1;o*e[i]>=t[0][i];--o)a.push({x:o*e[i],text:n(e[i],o)});r.push(a)}return r}function a(t,e){for(var r=0;r<3;++r){if(t[r].length!==e[r].length)return!1;for(var n=0;n<t[r].length;++n){var i=t[r][n],a=e[r][n];if(i.x!==a.x||i.text!==a.text||i.font!==a.font||i.fontColor!==a.fontColor||i.fontSize!==a.fontSize||i.dx!==a.dx||i.dy!==a.dy)return!1}}return!0}r.create=i,r.equal=a},{}],154:[function(t,e,r){\"use strict\";function n(t,e,r){this.lo=t,this.hi=e,this.pixelsPerDataUnit=r}function i(t,e,r,n,i){for(var a=0;a<3;++a){for(var o=p,s=m,l=0;l<3;++l)s[l]=o[l]=r[l];s[3]=o[3]=1,s[a]+=1,h(s,s,e),s[3]<0&&(t[a]=1/0),o[a]-=1,h(o,o,e),o[3]<0&&(t[a]=1/0);var u=(o[0]/o[3]-s[0]/s[3])*n,c=(o[1]/o[3]-s[1]/s[3])*i;t[a]=.25*Math.sqrt(u*u+c*c)}return t}function a(t,e,r,n,a){var h=e.model||f,p=e.view||f,m=e.projection||f,y=t.bounds,a=a||l(h,p,m,y),b=a.axis;a.edges;u(d,p,h),u(d,m,d);for(var x=v,_=0;_<3;++_)x[_].lo=1/0,x[_].hi=-1/0,x[_].pixelsPerDataUnit=1/0;var w=o(c(d,d));c(d,d);for(var M=0;M<3;++M){var k=(M+1)%3,A=(M+2)%3,T=g;t:for(var _=0;_<2;++_){var S=[];if(b[M]<0!=!!_){T[M]=y[_][M];for(var E=0;E<2;++E){T[k]=y[E^_][k];for(var L=0;L<2;++L)T[A]=y[L^E^_][A],S.push(T.slice())}for(var E=0;E<w.length;++E){if(0===S.length)continue t;S=s.positive(S,w[E])}for(var E=0;E<S.length;++E)for(var A=S[E],C=i(g,d,A,r,n),L=0;L<3;++L)x[L].lo=Math.min(x[L].lo,A[L]),x[L].hi=Math.max(x[L].hi,A[L]),L!==M&&(x[L].pixelsPerDataUnit=Math.min(x[L].pixelsPerDataUnit,Math.abs(C[L])))}}}return x}e.exports=a;var o=t(\"extract-frustum-planes\"),s=t(\"split-polygon\"),l=t(\"./lib/cube.js\"),u=t(\"gl-mat4/multiply\"),c=t(\"gl-mat4/transpose\"),h=t(\"gl-vec4/transformMat4\"),f=new Float32Array([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]),d=new Float32Array(16),p=[0,0,0,1],m=[0,0,0,1],v=[new n(1/0,-1/0,1/0),new n(1/0,-1/0,1/0),new n(1/0,-1/0,1/0)],g=[0,0,0]},{\"./lib/cube.js\":149,\"extract-frustum-planes\":129,\"gl-mat4/multiply\":182,\"gl-mat4/transpose\":190,\"gl-vec4/transformMat4\":276,\"split-polygon\":525}],155:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.gl=t,this.type=e,this.handle=r,this.length=n,this.usage=i}function i(t,e,r,n,i,a){var o=i.length*i.BYTES_PER_ELEMENT;if(a<0)return t.bufferData(e,i,n),o;if(o+a>r)throw new Error(\"gl-buffer: If resizing buffer, must not specify offset\");return t.bufferSubData(e,a,i),r}function a(t,e){for(var r=l.malloc(t.length,e),n=t.length,i=0;i<n;++i)r[i]=t[i];return r}function o(t,e){for(var r=1,n=e.length-1;n>=0;--n){if(e[n]!==r)return!1;r*=t[n]}return!0}function s(t,e,r,i){if(r=r||t.ARRAY_BUFFER,i=i||t.DYNAMIC_DRAW,r!==t.ARRAY_BUFFER&&r!==t.ELEMENT_ARRAY_BUFFER)throw new Error(\"gl-buffer: Invalid type for webgl buffer, must be either gl.ARRAY_BUFFER or gl.ELEMENT_ARRAY_BUFFER\");if(i!==t.DYNAMIC_DRAW&&i!==t.STATIC_DRAW&&i!==t.STREAM_DRAW)throw new Error(\"gl-buffer: Invalid usage for buffer, must be either gl.DYNAMIC_DRAW, gl.STATIC_DRAW or gl.STREAM_DRAW\");var a=t.createBuffer(),o=new n(t,r,a,0,i);return o.update(e),o}var l=t(\"typedarray-pool\"),u=t(\"ndarray-ops\"),c=t(\"ndarray\"),h=[\"uint8\",\"uint8_clamped\",\"uint16\",\"uint32\",\"int8\",\"int16\",\"int32\",\"float32\"],f=n.prototype;f.bind=function(){this.gl.bindBuffer(this.type,this.handle)},f.unbind=function(){this.gl.bindBuffer(this.type,null)},f.dispose=function(){this.gl.deleteBuffer(this.handle)},f.update=function(t,e){if(\"number\"!=typeof e&&(e=-1),this.bind(),\"object\"==typeof t&&void 0!==t.shape){var r=t.dtype;if(h.indexOf(r)<0&&(r=\"float32\"),this.type===this.gl.ELEMENT_ARRAY_BUFFER){r=gl.getExtension(\"OES_element_index_uint\")&&\"uint16\"!==r?\"uint32\":\"uint16\"}if(r===t.dtype&&o(t.shape,t.stride))0===t.offset&&t.data.length===t.shape[0]?this.length=i(this.gl,this.type,this.length,this.usage,t.data,e):this.length=i(this.gl,this.type,this.length,this.usage,t.data.subarray(t.offset,t.shape[0]),e);else{var n=l.malloc(t.size,r),s=c(n,t.shape);u.assign(s,t),this.length=e<0?i(this.gl,this.type,this.length,this.usage,n,e):i(this.gl,this.type,this.length,this.usage,n.subarray(0,t.size),e),l.free(n)}}else if(Array.isArray(t)){var f;f=this.type===this.gl.ELEMENT_ARRAY_BUFFER?a(t,\"uint16\"):a(t,\"float32\"),this.length=e<0?i(this.gl,this.type,this.length,this.usage,f,e):i(this.gl,this.type,this.length,this.usage,f.subarray(0,t.length),e),l.free(f)}else if(\"object\"==typeof t&&\"number\"==typeof t.length)this.length=i(this.gl,this.type,this.length,this.usage,t,e);else{if(\"number\"!=typeof t&&void 0!==t)throw new Error(\"gl-buffer: Invalid data type\");if(e>=0)throw new Error(\"gl-buffer: Cannot specify offset when resizing buffer\");t|=0,t<=0&&(t=1),this.gl.bufferData(this.type,0|t,this.usage),this.length=t}},e.exports=s},{ndarray:466,\"ndarray-ops\":460,\"typedarray-pool\":540}],156:[function(t,e,r){e.exports={0:\"NONE\",1:\"ONE\",2:\"LINE_LOOP\",3:\"LINE_STRIP\",4:\"TRIANGLES\",5:\"TRIANGLE_STRIP\",6:\"TRIANGLE_FAN\",256:\"DEPTH_BUFFER_BIT\",512:\"NEVER\",513:\"LESS\",514:\"EQUAL\",515:\"LEQUAL\",516:\"GREATER\",517:\"NOTEQUAL\",518:\"GEQUAL\",519:\"ALWAYS\",768:\"SRC_COLOR\",769:\"ONE_MINUS_SRC_COLOR\",770:\"SRC_ALPHA\",771:\"ONE_MINUS_SRC_ALPHA\",772:\"DST_ALPHA\",773:\"ONE_MINUS_DST_ALPHA\",774:\"DST_COLOR\",775:\"ONE_MINUS_DST_COLOR\",776:\"SRC_ALPHA_SATURATE\",1024:\"STENCIL_BUFFER_BIT\",1028:\"FRONT\",1029:\"BACK\",1032:\"FRONT_AND_BACK\",1280:\"INVALID_ENUM\",1281:\"INVALID_VALUE\",1282:\"INVALID_OPERATION\",1285:\"OUT_OF_MEMORY\",1286:\"INVALID_FRAMEBUFFER_OPERATION\",2304:\"CW\",2305:\"CCW\",2849:\"LINE_WIDTH\",2884:\"CULL_FACE\",2885:\"CULL_FACE_MODE\",2886:\"FRONT_FACE\",2928:\"DEPTH_RANGE\",2929:\"DEPTH_TEST\",2930:\"DEPTH_WRITEMASK\",2931:\"DEPTH_CLEAR_VALUE\",2932:\"DEPTH_FUNC\",2960:\"STENCIL_TEST\",2961:\"STENCIL_CLEAR_VALUE\",2962:\"STENCIL_FUNC\",2963:\"STENCIL_VALUE_MASK\",2964:\"STENCIL_FAIL\",2965:\"STENCIL_PASS_DEPTH_FAIL\",2966:\"STENCIL_PASS_DEPTH_PASS\",2967:\"STENCIL_REF\",2968:\"STENCIL_WRITEMASK\",2978:\"VIEWPORT\",3024:\"DITHER\",3042:\"BLEND\",3088:\"SCISSOR_BOX\",3089:\"SCISSOR_TEST\",3106:\"COLOR_CLEAR_VALUE\",3107:\"COLOR_WRITEMASK\",3317:\"UNPACK_ALIGNMENT\",3333:\"PACK_ALIGNMENT\",3379:\"MAX_TEXTURE_SIZE\",3386:\"MAX_VIEWPORT_DIMS\",3408:\"SUBPIXEL_BITS\",3410:\"RED_BITS\",3411:\"GREEN_BITS\",3412:\"BLUE_BITS\",3413:\"ALPHA_BITS\",3414:\"DEPTH_BITS\",3415:\"STENCIL_BITS\",3553:\"TEXTURE_2D\",4352:\"DONT_CARE\",4353:\"FASTEST\",4354:\"NICEST\",5120:\"BYTE\",5121:\"UNSIGNED_BYTE\",5122:\"SHORT\",5123:\"UNSIGNED_SHORT\",5124:\"INT\",5125:\"UNSIGNED_INT\",5126:\"FLOAT\",5386:\"INVERT\",5890:\"TEXTURE\",6401:\"STENCIL_INDEX\",6402:\"DEPTH_COMPONENT\",6406:\"ALPHA\",6407:\"RGB\",6408:\"RGBA\",6409:\"LUMINANCE\",6410:\"LUMINANCE_ALPHA\",7680:\"KEEP\",7681:\"REPLACE\",7682:\"INCR\",7683:\"DECR\",7936:\"VENDOR\",7937:\"RENDERER\",7938:\"VERSION\",9728:\"NEAREST\",9729:\"LINEAR\",9984:\"NEAREST_MIPMAP_NEAREST\",9985:\"LINEAR_MIPMAP_NEAREST\",9986:\"NEAREST_MIPMAP_LINEAR\",9987:\"LINEAR_MIPMAP_LINEAR\",10240:\"TEXTURE_MAG_FILTER\",10241:\"TEXTURE_MIN_FILTER\",10242:\"TEXTURE_WRAP_S\",10243:\"TEXTURE_WRAP_T\",10497:\"REPEAT\",10752:\"POLYGON_OFFSET_UNITS\",16384:\"COLOR_BUFFER_BIT\",32769:\"CONSTANT_COLOR\",32770:\"ONE_MINUS_CONSTANT_COLOR\",32771:\"CONSTANT_ALPHA\",32772:\"ONE_MINUS_CONSTANT_ALPHA\",32773:\"BLEND_COLOR\",32774:\"FUNC_ADD\",32777:\"BLEND_EQUATION_RGB\",32778:\"FUNC_SUBTRACT\",32779:\"FUNC_REVERSE_SUBTRACT\",32819:\"UNSIGNED_SHORT_4_4_4_4\",32820:\"UNSIGNED_SHORT_5_5_5_1\",32823:\"POLYGON_OFFSET_FILL\",32824:\"POLYGON_OFFSET_FACTOR\",32854:\"RGBA4\",32855:\"RGB5_A1\",32873:\"TEXTURE_BINDING_2D\",32926:\"SAMPLE_ALPHA_TO_COVERAGE\",32928:\"SAMPLE_COVERAGE\",32936:\"SAMPLE_BUFFERS\",32937:\"SAMPLES\",32938:\"SAMPLE_COVERAGE_VALUE\",32939:\"SAMPLE_COVERAGE_INVERT\",32968:\"BLEND_DST_RGB\",32969:\"BLEND_SRC_RGB\",32970:\"BLEND_DST_ALPHA\",32971:\"BLEND_SRC_ALPHA\",33071:\"CLAMP_TO_EDGE\",33170:\"GENERATE_MIPMAP_HINT\",33189:\"DEPTH_COMPONENT16\",33306:\"DEPTH_STENCIL_ATTACHMENT\",33635:\"UNSIGNED_SHORT_5_6_5\",33648:\"MIRRORED_REPEAT\",33901:\"ALIASED_POINT_SIZE_RANGE\",33902:\"ALIASED_LINE_WIDTH_RANGE\",33984:\"TEXTURE0\",33985:\"TEXTURE1\",33986:\"TEXTURE2\",33987:\"TEXTURE3\",33988:\"TEXTURE4\",33989:\"TEXTURE5\",33990:\"TEXTURE6\",33991:\"TEXTURE7\",33992:\"TEXTURE8\",33993:\"TEXTURE9\",33994:\"TEXTURE10\",33995:\"TEXTURE11\",33996:\"TEXTURE12\",33997:\"TEXTURE13\",33998:\"TEXTURE14\",33999:\"TEXTURE15\",34e3:\"TEXTURE16\",34001:\"TEXTURE17\",34002:\"TEXTURE18\",34003:\"TEXTURE19\",34004:\"TEXTURE20\",34005:\"TEXTURE21\",34006:\"TEXTURE22\",34007:\"TEXTURE23\",34008:\"TEXTURE24\",34009:\"TEXTURE25\",34010:\"TEXTURE26\",34011:\"TEXTURE27\",34012:\"TEXTURE28\",34013:\"TEXTURE29\",34014:\"TEXTURE30\",34015:\"TEXTURE31\",34016:\"ACTIVE_TEXTURE\",34024:\"MAX_RENDERBUFFER_SIZE\",34041:\"DEPTH_STENCIL\",34055:\"INCR_WRAP\",34056:\"DECR_WRAP\",34067:\"TEXTURE_CUBE_MAP\",34068:\"TEXTURE_BINDING_CUBE_MAP\",34069:\"TEXTURE_CUBE_MAP_POSITIVE_X\",34070:\"TEXTURE_CUBE_MAP_NEGATIVE_X\",34071:\"TEXTURE_CUBE_MAP_POSITIVE_Y\",34072:\"TEXTURE_CUBE_MAP_NEGATIVE_Y\",34073:\"TEXTURE_CUBE_MAP_POSITIVE_Z\",34074:\"TEXTURE_CUBE_MAP_NEGATIVE_Z\",34076:\"MAX_CUBE_MAP_TEXTURE_SIZE\",34338:\"VERTEX_ATTRIB_ARRAY_ENABLED\",34339:\"VERTEX_ATTRIB_ARRAY_SIZE\",34340:\"VERTEX_ATTRIB_ARRAY_STRIDE\",34341:\"VERTEX_ATTRIB_ARRAY_TYPE\",34342:\"CURRENT_VERTEX_ATTRIB\",34373:\"VERTEX_ATTRIB_ARRAY_POINTER\",34466:\"NUM_COMPRESSED_TEXTURE_FORMATS\",34467:\"COMPRESSED_TEXTURE_FORMATS\",34660:\"BUFFER_SIZE\",34661:\"BUFFER_USAGE\",34816:\"STENCIL_BACK_FUNC\",34817:\"STENCIL_BACK_FAIL\",34818:\"STENCIL_BACK_PASS_DEPTH_FAIL\",34819:\"STENCIL_BACK_PASS_DEPTH_PASS\",34877:\"BLEND_EQUATION_ALPHA\",34921:\"MAX_VERTEX_ATTRIBS\",34922:\"VERTEX_ATTRIB_ARRAY_NORMALIZED\",34930:\"MAX_TEXTURE_IMAGE_UNITS\",34962:\"ARRAY_BUFFER\",34963:\"ELEMENT_ARRAY_BUFFER\",34964:\"ARRAY_BUFFER_BINDING\",34965:\"ELEMENT_ARRAY_BUFFER_BINDING\",34975:\"VERTEX_ATTRIB_ARRAY_BUFFER_BINDING\",35040:\"STREAM_DRAW\",35044:\"STATIC_DRAW\",35048:\"DYNAMIC_DRAW\",35632:\"FRAGMENT_SHADER\",35633:\"VERTEX_SHADER\",35660:\"MAX_VERTEX_TEXTURE_IMAGE_UNITS\",35661:\"MAX_COMBINED_TEXTURE_IMAGE_UNITS\",35663:\"SHADER_TYPE\",35664:\"FLOAT_VEC2\",35665:\"FLOAT_VEC3\",35666:\"FLOAT_VEC4\",35667:\"INT_VEC2\",35668:\"INT_VEC3\",35669:\"INT_VEC4\",35670:\"BOOL\",35671:\"BOOL_VEC2\",35672:\"BOOL_VEC3\",35673:\"BOOL_VEC4\",35674:\"FLOAT_MAT2\",35675:\"FLOAT_MAT3\",35676:\"FLOAT_MAT4\",35678:\"SAMPLER_2D\",35680:\"SAMPLER_CUBE\",35712:\"DELETE_STATUS\",35713:\"COMPILE_STATUS\",35714:\"LINK_STATUS\",35715:\"VALIDATE_STATUS\",35716:\"INFO_LOG_LENGTH\",35717:\"ATTACHED_SHADERS\",35718:\"ACTIVE_UNIFORMS\",35719:\"ACTIVE_UNIFORM_MAX_LENGTH\",35720:\"SHADER_SOURCE_LENGTH\",35721:\"ACTIVE_ATTRIBUTES\",35722:\"ACTIVE_ATTRIBUTE_MAX_LENGTH\",35724:\"SHADING_LANGUAGE_VERSION\",35725:\"CURRENT_PROGRAM\",36003:\"STENCIL_BACK_REF\",36004:\"STENCIL_BACK_VALUE_MASK\",36005:\"STENCIL_BACK_WRITEMASK\",36006:\"FRAMEBUFFER_BINDING\",36007:\"RENDERBUFFER_BINDING\",36048:\"FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE\",36049:\"FRAMEBUFFER_ATTACHMENT_OBJECT_NAME\",36050:\"FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL\",36051:\"FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE\",36053:\"FRAMEBUFFER_COMPLETE\",36054:\"FRAMEBUFFER_INCOMPLETE_ATTACHMENT\",36055:\"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT\",36057:\"FRAMEBUFFER_INCOMPLETE_DIMENSIONS\",36061:\"FRAMEBUFFER_UNSUPPORTED\",36064:\"COLOR_ATTACHMENT0\",36096:\"DEPTH_ATTACHMENT\",36128:\"STENCIL_ATTACHMENT\",36160:\"FRAMEBUFFER\",36161:\"RENDERBUFFER\",36162:\"RENDERBUFFER_WIDTH\",36163:\"RENDERBUFFER_HEIGHT\",36164:\"RENDERBUFFER_INTERNAL_FORMAT\",36168:\"STENCIL_INDEX8\",36176:\"RENDERBUFFER_RED_SIZE\",36177:\"RENDERBUFFER_GREEN_SIZE\",36178:\"RENDERBUFFER_BLUE_SIZE\",36179:\"RENDERBUFFER_ALPHA_SIZE\",36180:\"RENDERBUFFER_DEPTH_SIZE\",36181:\"RENDERBUFFER_STENCIL_SIZE\",36194:\"RGB565\",36336:\"LOW_FLOAT\",36337:\"MEDIUM_FLOAT\",36338:\"HIGH_FLOAT\",36339:\"LOW_INT\",36340:\"MEDIUM_INT\",36341:\"HIGH_INT\",36346:\"SHADER_COMPILER\",36347:\"MAX_VERTEX_UNIFORM_VECTORS\",36348:\"MAX_VARYING_VECTORS\",36349:\"MAX_FRAGMENT_UNIFORM_VECTORS\",37440:\"UNPACK_FLIP_Y_WEBGL\",37441:\"UNPACK_PREMULTIPLY_ALPHA_WEBGL\",37442:\"CONTEXT_LOST_WEBGL\",37443:\"UNPACK_COLORSPACE_CONVERSION_WEBGL\",37444:\"BROWSER_DEFAULT_WEBGL\"}},{}],157:[function(t,e,r){var n=t(\"./1.0/numbers\");e.exports=function(t){return n[t]}},{\"./1.0/numbers\":156}],158:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.plot=t,this.shader=e,this.bufferHi=r,this.bufferLo=n,this.bounds=[1/0,1/0,-1/0,-1/0],this.numPoints=0,this.color=[0,0,0,1]}function i(t,e){var r=a(t.gl,l.vertex,l.fragment),i=o(t.gl),s=o(t.gl),u=new n(t,r,i,s);return u.update(e),t.addObject(u),u}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"typedarray-pool\"),l=t(\"./lib/shaders\");e.exports=i;var u=[[1,0,0,1,0,0],[1,0,0,-1,0,0],[-1,0,0,-1,0,0],[-1,0,0,-1,0,0],[-1,0,0,1,0,0],[1,0,0,1,0,0],[1,0,-1,0,0,1],[1,0,-1,0,0,-1],[1,0,1,0,0,-1],[1,0,1,0,0,-1],[1,0,1,0,0,1],[1,0,-1,0,0,1],[-1,0,-1,0,0,1],[-1,0,-1,0,0,-1],[-1,0,1,0,0,-1],[-1,0,1,0,0,-1],[-1,0,1,0,0,1],[-1,0,-1,0,0,1],[0,1,1,0,0,0],[0,1,-1,0,0,0],[0,-1,-1,0,0,0],[0,-1,-1,0,0,0],[0,1,1,0,0,0],[0,-1,1,0,0,0],[0,1,0,-1,1,0],[0,1,0,-1,-1,0],[0,1,0,1,-1,0],[0,1,0,1,1,0],[0,1,0,-1,1,0],[0,1,0,1,-1,0],[0,-1,0,-1,1,0],[0,-1,0,-1,-1,0],[0,-1,0,1,-1,0],[0,-1,0,1,1,0],[0,-1,0,-1,1,0],[0,-1,0,1,-1,0]],c=n.prototype;c.draw=function(){var t=new Float32Array([0,0]),e=new Float32Array([0,0]),r=new Float32Array([0,0]),n=new Float32Array([0,0]),i=[1,1];return function(){var a=this.plot,o=this.shader,s=this.bounds,l=this.numPoints;if(l){var c=a.gl,h=a.dataBox,f=a.viewBox,d=a.pixelRatio,p=s[2]-s[0],m=s[3]-s[1],v=h[2]-h[0],g=h[3]-h[1],y=2*p/v,b=2*m/g,x=(s[0]-h[0]-.5*v)/p,_=(s[1]-h[1]-.5*g)/m;t[0]=y,t[1]=b,e[0]=y-t[0],e[1]=b-t[1],r[0]=x,r[1]=_,n[0]=x-r[0],n[1]=_-r[1];var w=f[2]-f[0],M=f[3]-f[1];i[0]=2*d/w,i[1]=2*d/M,o.bind(),o.uniforms.scaleHi=t,o.uniforms.scaleLo=e,o.uniforms.translateHi=r,o.uniforms.translateLo=n,o.uniforms.pixelScale=i,o.uniforms.color=this.color,this.bufferLo.bind(),o.attributes.positionLo.pointer(c.FLOAT,!1,16,0),this.bufferHi.bind(),o.attributes.positionHi.pointer(c.FLOAT,!1,16,0),o.attributes.pixelOffset.pointer(c.FLOAT,!1,16,8),c.drawArrays(c.TRIANGLES,0,l*u.length)}}}(),c.drawPick=function(t){return t},c.pick=function(){return null},c.update=function(t){t=t||{};var e,r,n,i=t.positions||[],a=t.errors||[],o=1;\"lineWidth\"in t&&(o=+t.lineWidth);var l=5;\"capSize\"in t&&(l=+t.capSize),this.color=(t.color||[0,0,0,1]).slice();var c=this.bounds=[1/0,1/0,-1/0,-1/0],h=this.numPoints=i.length>>1;for(e=0;e<h;++e)r=i[2*e],n=i[2*e+1],c[0]=Math.min(r,c[0]),c[1]=Math.min(n,c[1]),c[2]=Math.max(r,c[2]),c[3]=Math.max(n,c[3]);c[2]===c[0]&&(c[2]+=1),c[3]===c[1]&&(c[3]+=1);var f=1/(c[2]-c[0]),d=1/(c[3]-c[1]),p=c[0],m=c[1],v=s.mallocFloat64(h*u.length*4),g=s.mallocFloat32(h*u.length*4),y=s.mallocFloat32(h*u.length*4),b=0;for(e=0;e<h;++e){r=i[2*e],n=i[2*e+1];for(var x=a[4*e],_=a[4*e+1],w=a[4*e+2],M=a[4*e+3],k=0;k<u.length;++k){var A=u[k],T=A[0],S=A[1];T<0?T*=x:T>0&&(T*=_),S<0?S*=w:S>0&&(S*=M),v[b++]=f*(r-p+T),v[b++]=d*(n-m+S),v[b++]=o*A[2]+(l+o)*A[4],v[b++]=o*A[3]+(l+o)*A[5]}}for(e=0;e<v.length;e++)g[e]=v[e],y[e]=v[e]-g[e];this.bufferHi.update(g),this.bufferLo.update(y),s.free(v)},c.dispose=function(){this.plot.removeObject(this),this.shader.dispose(),this.bufferHi.dispose(),this.bufferLo.dispose()}},{\"./lib/shaders\":159,\"gl-buffer\":155,\"gl-shader\":254,\"typedarray-pool\":540}],159:[function(t,e,r){e.exports={\n",
       "vertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi;\\nattribute vec2 positionLo;\\nattribute vec2 pixelOffset;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo, pixelScale;\\n\\nvec2 project(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\nvoid main() {\\n  vec3 scrPosition = vec3(\\n         project(scaleHi, translateHi, scaleLo, translateLo, positionHi, positionLo),\\n         1);\\n  gl_Position = vec4(\\n    scrPosition.xy + scrPosition.z * pixelScale * pixelOffset,\\n    0,\\n    scrPosition.z);\\n}\\n\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = vec4(color.rgb * color.a, color.a);\\n}\\n\"}},{}],160:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.shader=n,this.buffer=e,this.vao=r,this.pixelRatio=1,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.lineWidth=[1,1,1],this.capSize=[10,10,10],this.lineCount=[0,0,0],this.lineOffset=[0,0,0],this.opacity=1}function i(t,e){for(var r=0;r<3;++r)t[0][r]=Math.min(t[0][r],e[r]),t[1][r]=Math.max(t[1][r],e[r])}function a(t,e,r,n){for(var i=f[n],a=0;a<i.length;++a){var o=i[a];t.push(e[0],e[1],e[2],r[0],r[1],r[2],r[3],o[0],o[1],o[2])}return i.length}function o(t){var e=t.gl,r=s(e),i=l(e,[{buffer:r,type:e.FLOAT,size:3,offset:0,stride:40},{buffer:r,type:e.FLOAT,size:4,offset:12,stride:40},{buffer:r,type:e.FLOAT,size:3,offset:28,stride:40}]),a=u(e);a.attributes.position.location=0,a.attributes.color.location=1,a.attributes.offset.location=2;var o=new n(e,r,i,a);return o.update(t),o}e.exports=o;var s=t(\"gl-buffer\"),l=t(\"gl-vao\"),u=t(\"./shaders/index\"),c=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],h=n.prototype;h.isOpaque=function(){return this.opacity>=1},h.isTransparent=function(){return this.opacity<1},h.drawTransparent=h.draw=function(t){var e=this.gl,r=this.shader.uniforms;this.shader.bind();var n=r.view=t.view||c,i=r.projection=t.projection||c;r.model=t.model||c,r.clipBounds=this.clipBounds,r.opacity=this.opacity;var a=n[12],o=n[13],s=n[14],l=n[15],u=this.pixelRatio*(i[3]*a+i[7]*o+i[11]*s+i[15]*l)/e.drawingBufferHeight;this.vao.bind();for(var h=0;h<3;++h)e.lineWidth(this.lineWidth[h]),r.capSize=this.capSize[h]*u,this.lineCount[h]&&e.drawArrays(e.LINES,this.lineOffset[h],this.lineCount[h]);this.vao.unbind()};var f=function(){for(var t=new Array(3),e=0;e<3;++e){for(var r=[],n=1;n<=2;++n)for(var i=-1;i<=1;i+=2){var a=(n+e)%3,o=[0,0,0];o[a]=i,r.push(o)}t[e]=r}return t}();h.update=function(t){t=t||{},\"lineWidth\"in t&&(this.lineWidth=t.lineWidth,Array.isArray(this.lineWidth)||(this.lineWidth=[this.lineWidth,this.lineWidth,this.lineWidth])),\"capSize\"in t&&(this.capSize=t.capSize,Array.isArray(this.capSize)||(this.capSize=[this.capSize,this.capSize,this.capSize])),\"opacity\"in t&&(this.opacity=t.opacity);var e=t.color||[[0,0,0],[0,0,0],[0,0,0]],r=t.position,n=t.error;if(Array.isArray(e[0])||(e=[e,e,e]),r&&n){var o=[],s=r.length,l=0;this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.lineCount=[0,0,0];for(var u=0;u<3;++u){this.lineOffset[u]=l;t:for(var c=0;c<s;++c){for(var h=r[c],f=0;f<3;++f)if(isNaN(h[f])||!isFinite(h[f]))continue t;var d=n[c],p=e[u];if(Array.isArray(p[0])&&(p=e[c]),3===p.length&&(p=[p[0],p[1],p[2],1]),!isNaN(d[0][u])&&!isNaN(d[1][u])){if(d[0][u]<0){var m=h.slice();m[u]+=d[0][u],o.push(h[0],h[1],h[2],p[0],p[1],p[2],p[3],0,0,0,m[0],m[1],m[2],p[0],p[1],p[2],p[3],0,0,0),i(this.bounds,m),l+=2+a(o,m,p,u)}if(d[1][u]>0){var m=h.slice();m[u]+=d[1][u],o.push(h[0],h[1],h[2],p[0],p[1],p[2],p[3],0,0,0,m[0],m[1],m[2],p[0],p[1],p[2],p[3],0,0,0),i(this.bounds,m),l+=2+a(o,m,p,u)}}}this.lineCount[u]=l-this.lineOffset[u]}this.buffer.update(o)}},h.dispose=function(){this.shader.dispose(),this.buffer.dispose(),this.vao.dispose()}},{\"./shaders/index\":162,\"gl-buffer\":155,\"gl-vao\":270}],161:[function(t,e,r){e.exports=function(t){\"string\"==typeof t&&(t=[t]);for(var e=[].slice.call(arguments,1),r=[],n=0;n<t.length-1;n++)r.push(t[n],e[n]||\"\");return r.push(t[n]),r.join(\"\")}},{}],162:[function(t,e,r){\"use strict\";var n=t(\"glslify\"),i=t(\"gl-shader\"),a=n([\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, offset;\\nattribute vec4 color;\\nuniform mat4 model, view, projection;\\nuniform float capSize;\\nvarying vec4 fragColor;\\nvarying vec3 fragPosition;\\n\\nvoid main() {\\n  vec4 worldPosition  = model * vec4(position, 1.0);\\n  worldPosition       = (worldPosition / worldPosition.w) + vec4(capSize * offset, 0.0);\\n  gl_Position         = projection * view * worldPosition;\\n  fragColor           = color;\\n  fragPosition        = position;\\n}\"]),o=n([\"precision mediump float;\\n#define GLSLIFY 1\\nuniform vec3 clipBounds[2];\\nuniform float opacity;\\nvarying vec3 fragPosition;\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(fragPosition, clipBounds[0])) || any(greaterThan(fragPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = opacity * fragColor;\\n}\"]);e.exports=function(t){return i(t,a,o,null,[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"offset\",type:\"vec3\"}])}},{\"gl-shader\":254,glslify:161}],163:[function(t,e,r){\"use strict\";function n(t){return[t.getParameter(t.FRAMEBUFFER_BINDING),t.getParameter(t.RENDERBUFFER_BINDING),t.getParameter(t.TEXTURE_BINDING_2D)]}function i(t,e){t.bindFramebuffer(t.FRAMEBUFFER,e[0]),t.bindRenderbuffer(t.RENDERBUFFER,e[1]),t.bindTexture(t.TEXTURE_2D,e[2])}function a(t,e){var r=t.getParameter(e.MAX_COLOR_ATTACHMENTS_WEBGL);y=new Array(r+1);for(var n=0;n<=r;++n){for(var i=new Array(r),a=0;a<n;++a)i[a]=t.COLOR_ATTACHMENT0+a;for(var a=n;a<r;++a)i[a]=t.NONE;y[n]=i}}function o(t){switch(t){case p:throw new Error(\"gl-fbo: Framebuffer unsupported\");case m:throw new Error(\"gl-fbo: Framebuffer incomplete attachment\");case v:throw new Error(\"gl-fbo: Framebuffer incomplete dimensions\");case g:throw new Error(\"gl-fbo: Framebuffer incomplete missing attachment\");default:throw new Error(\"gl-fbo: Framebuffer failed for unspecified reason\")}}function s(t,e,r,n,i,a){if(!n)return null;var o=d(t,e,r,i,n);return o.magFilter=t.NEAREST,o.minFilter=t.NEAREST,o.mipSamples=1,o.bind(),t.framebufferTexture2D(t.FRAMEBUFFER,a,t.TEXTURE_2D,o.handle,0),o}function l(t,e,r,n,i){var a=t.createRenderbuffer();return t.bindRenderbuffer(t.RENDERBUFFER,a),t.renderbufferStorage(t.RENDERBUFFER,n,e,r),t.framebufferRenderbuffer(t.FRAMEBUFFER,i,t.RENDERBUFFER,a),a}function u(t){var e=n(t.gl),r=t.gl,a=t.handle=r.createFramebuffer(),u=t._shape[0],c=t._shape[1],h=t.color.length,f=t._ext,d=t._useStencil,p=t._useDepth,m=t._colorType;r.bindFramebuffer(r.FRAMEBUFFER,a);for(var v=0;v<h;++v)t.color[v]=s(r,u,c,m,r.RGBA,r.COLOR_ATTACHMENT0+v);0===h?(t._color_rb=l(r,u,c,r.RGBA4,r.COLOR_ATTACHMENT0),f&&f.drawBuffersWEBGL(y[0])):h>1&&f.drawBuffersWEBGL(y[h]);var g=r.getExtension(\"WEBGL_depth_texture\");g?d?t.depth=s(r,u,c,g.UNSIGNED_INT_24_8_WEBGL,r.DEPTH_STENCIL,r.DEPTH_STENCIL_ATTACHMENT):p&&(t.depth=s(r,u,c,r.UNSIGNED_SHORT,r.DEPTH_COMPONENT,r.DEPTH_ATTACHMENT)):p&&d?t._depth_rb=l(r,u,c,r.DEPTH_STENCIL,r.DEPTH_STENCIL_ATTACHMENT):p?t._depth_rb=l(r,u,c,r.DEPTH_COMPONENT16,r.DEPTH_ATTACHMENT):d&&(t._depth_rb=l(r,u,c,r.STENCIL_INDEX,r.STENCIL_ATTACHMENT));var b=r.checkFramebufferStatus(r.FRAMEBUFFER);if(b!==r.FRAMEBUFFER_COMPLETE){t._destroyed=!0,r.bindFramebuffer(r.FRAMEBUFFER,null),r.deleteFramebuffer(t.handle),t.handle=null,t.depth&&(t.depth.dispose(),t.depth=null),t._depth_rb&&(r.deleteRenderbuffer(t._depth_rb),t._depth_rb=null);for(var v=0;v<t.color.length;++v)t.color[v].dispose(),t.color[v]=null;t._color_rb&&(r.deleteRenderbuffer(t._color_rb),t._color_rb=null),i(r,e),o(b)}i(r,e)}function c(t,e,r,n,i,a,o,s){this.gl=t,this._shape=[0|e,0|r],this._destroyed=!1,this._ext=s,this.color=new Array(i);for(var l=0;l<i;++l)this.color[l]=null;this._color_rb=null,this.depth=null,this._depth_rb=null,this._colorType=n,this._useDepth=a,this._useStencil=o;var c=this,h=[0|e,0|r];Object.defineProperties(h,{0:{get:function(){return c._shape[0]},set:function(t){return c.width=t}},1:{get:function(){return c._shape[1]},set:function(t){return c.height=t}}}),this._shapeVector=h,u(this)}function h(t,e,r){if(t._destroyed)throw new Error(\"gl-fbo: Can't resize destroyed FBO\");if(t._shape[0]!==e||t._shape[1]!==r){var a=t.gl,s=a.getParameter(a.MAX_RENDERBUFFER_SIZE);if(e<0||e>s||r<0||r>s)throw new Error(\"gl-fbo: Can't resize FBO, invalid dimensions\");t._shape[0]=e,t._shape[1]=r;for(var l=n(a),u=0;u<t.color.length;++u)t.color[u].shape=t._shape;t._color_rb&&(a.bindRenderbuffer(a.RENDERBUFFER,t._color_rb),a.renderbufferStorage(a.RENDERBUFFER,a.RGBA4,t._shape[0],t._shape[1])),t.depth&&(t.depth.shape=t._shape),t._depth_rb&&(a.bindRenderbuffer(a.RENDERBUFFER,t._depth_rb),t._useDepth&&t._useStencil?a.renderbufferStorage(a.RENDERBUFFER,a.DEPTH_STENCIL,t._shape[0],t._shape[1]):t._useDepth?a.renderbufferStorage(a.RENDERBUFFER,a.DEPTH_COMPONENT16,t._shape[0],t._shape[1]):t._useStencil&&a.renderbufferStorage(a.RENDERBUFFER,a.STENCIL_INDEX,t._shape[0],t._shape[1])),a.bindFramebuffer(a.FRAMEBUFFER,t.handle);var c=a.checkFramebufferStatus(a.FRAMEBUFFER);c!==a.FRAMEBUFFER_COMPLETE&&(t.dispose(),i(a,l),o(c)),i(a,l)}}function f(t,e,r,n){p||(p=t.FRAMEBUFFER_UNSUPPORTED,m=t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT,v=t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS,g=t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT);var i=t.getExtension(\"WEBGL_draw_buffers\");if(!y&&i&&a(t,i),Array.isArray(e)&&(n=r,r=0|e[1],e=0|e[0]),\"number\"!=typeof e)throw new Error(\"gl-fbo: Missing shape parameter\");var o=t.getParameter(t.MAX_RENDERBUFFER_SIZE);if(e<0||e>o||r<0||r>o)throw new Error(\"gl-fbo: Parameters are too large for FBO\");n=n||{};var s=1;if(\"color\"in n){if((s=Math.max(0|n.color,0))<0)throw new Error(\"gl-fbo: Must specify a nonnegative number of colors\");if(s>1){if(!i)throw new Error(\"gl-fbo: Multiple draw buffer extension not supported\");if(s>t.getParameter(i.MAX_COLOR_ATTACHMENTS_WEBGL))throw new Error(\"gl-fbo: Context does not support \"+s+\" draw buffers\")}}var l=t.UNSIGNED_BYTE,u=t.getExtension(\"OES_texture_float\");if(n.float&&s>0){if(!u)throw new Error(\"gl-fbo: Context does not support floating point textures\");l=t.FLOAT}else n.preferFloat&&s>0&&u&&(l=t.FLOAT);var h=!0;\"depth\"in n&&(h=!!n.depth);var f=!1;return\"stencil\"in n&&(f=!!n.stencil),new c(t,e,r,l,s,h,f,i)}var d=t(\"gl-texture2d\");e.exports=f;var p,m,v,g,y=null,b=c.prototype;Object.defineProperties(b,{shape:{get:function(){return this._destroyed?[0,0]:this._shapeVector},set:function(t){if(Array.isArray(t)||(t=[0|t,0|t]),2!==t.length)throw new Error(\"gl-fbo: Shape vector must be length 2\");var e=0|t[0],r=0|t[1];return h(this,e,r),[e,r]},enumerable:!1},width:{get:function(){return this._destroyed?0:this._shape[0]},set:function(t){return t|=0,h(this,t,this._shape[1]),t},enumerable:!1},height:{get:function(){return this._destroyed?0:this._shape[1]},set:function(t){return t|=0,h(this,this._shape[0],t),t},enumerable:!1}}),b.bind=function(){if(!this._destroyed){var t=this.gl;t.bindFramebuffer(t.FRAMEBUFFER,this.handle),t.viewport(0,0,this._shape[0],this._shape[1])}},b.dispose=function(){if(!this._destroyed){this._destroyed=!0;var t=this.gl;t.deleteFramebuffer(this.handle),this.handle=null,this.depth&&(this.depth.dispose(),this.depth=null),this._depth_rb&&(t.deleteRenderbuffer(this._depth_rb),this._depth_rb=null);for(var e=0;e<this.color.length;++e)this.color[e].dispose(),this.color[e]=null;this._color_rb&&(t.deleteRenderbuffer(this._color_rb),this._color_rb=null)}}},{\"gl-texture2d\":266}],164:[function(t,e,r){function n(t,e,r){\"use strict\";var n=o(e)||\"of unknown name (see npm glsl-shader-name)\",l=\"unknown type\";void 0!==r&&(l=r===a.FRAGMENT_SHADER?\"fragment\":\"vertex\");for(var u=i(\"Error compiling %s shader %s:\\n\",l,n),c=i(\"%s%s\",u,t),h=t.split(\"\\n\"),f={},d=0;d<h.length;d++){var p=h[d];if(\"\"!==p){var m=parseInt(p.split(\":\")[2]);if(isNaN(m))throw new Error(i(\"Could not parse error: %s\",p));f[m]=p}}for(var v=s(e).split(\"\\n\"),d=0;d<v.length;d++)if(f[d+3]||f[d+2]||f[d+1]){var g=v[d];if(u+=g+\"\\n\",f[d+1]){var y=f[d+1];y=y.substr(y.split(\":\",3).join(\":\").length+1).trim(),u+=i(\"^^^ %s\\n\\n\",y)}}return{long:u.trim(),short:c.trim()}}var i=t(\"sprintf-js\").sprintf,a=t(\"gl-constants/lookup\"),o=t(\"glsl-shader-name\"),s=t(\"add-line-numbers\");e.exports=n},{\"add-line-numbers\":39,\"gl-constants/lookup\":157,\"glsl-shader-name\":278,\"sprintf-js\":526}],165:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.plot=t,this.shader=e,this.pickShader=r,this.positionBuffer=n,this.weightBuffer=i,this.colorBuffer=a,this.idBuffer=o,this.xData=[],this.yData=[],this.shape=[0,0],this.bounds=[1/0,1/0,-1/0,-1/0],this.pickOffset=0}function i(t,e){var r=t.gl,i=l(r,c.vertex,c.fragment),a=l(r,c.pickVertex,c.pickFragment),o=u(r),s=u(r),h=u(r),f=u(r),d=new n(t,i,a,o,s,h,f);return d.update(e),t.addObject(d),d}e.exports=i;var a=t(\"binary-search-bounds\"),o=t(\"iota-array\"),s=t(\"typedarray-pool\"),l=t(\"gl-shader\"),u=t(\"gl-buffer\"),c=t(\"./lib/shaders\"),h=n.prototype,f=[0,0,1,0,0,1,1,0,1,1,0,1];h.draw=function(){var t=[1,0,0,0,1,0,0,0,1];return function(){var e=this.plot,r=this.shader,n=this.bounds,i=this.numVertices;if(!(i<=0)){var a=e.gl,o=e.dataBox,s=n[2]-n[0],l=n[3]-n[1],u=o[2]-o[0],c=o[3]-o[1];t[0]=2*s/u,t[4]=2*l/c,t[6]=2*(n[0]-o[0])/u-1,t[7]=2*(n[1]-o[1])/c-1,r.bind();var h=r.uniforms;h.viewTransform=t,h.shape=this.shape;var f=r.attributes;this.positionBuffer.bind(),f.position.pointer(),this.weightBuffer.bind(),f.weight.pointer(a.UNSIGNED_BYTE,!1),this.colorBuffer.bind(),f.color.pointer(a.UNSIGNED_BYTE,!0),a.drawArrays(a.TRIANGLES,0,i)}}}(),h.drawPick=function(){var t=[1,0,0,0,1,0,0,0,1],e=[0,0,0,0];return function(r){var n=this.plot,i=this.pickShader,a=this.bounds,o=this.numVertices;if(!(o<=0)){var s=n.gl,l=n.dataBox,u=a[2]-a[0],c=a[3]-a[1],h=l[2]-l[0],f=l[3]-l[1];t[0]=2*u/h,t[4]=2*c/f,t[6]=2*(a[0]-l[0])/h-1,t[7]=2*(a[1]-l[1])/f-1;for(var d=0;d<4;++d)e[d]=r>>8*d&255;this.pickOffset=r,i.bind();var p=i.uniforms;p.viewTransform=t,p.pickOffset=e,p.shape=this.shape;var m=i.attributes;return this.positionBuffer.bind(),m.position.pointer(),this.weightBuffer.bind(),m.weight.pointer(s.UNSIGNED_BYTE,!1),this.idBuffer.bind(),m.pickId.pointer(s.UNSIGNED_BYTE,!1),s.drawArrays(s.TRIANGLES,0,o),r+this.shape[0]*this.shape[1]}}}(),h.pick=function(t,e,r){var n=this.pickOffset,i=this.shape[0]*this.shape[1];if(r<n||r>=n+i)return null;var a=r-n,o=this.xData,s=this.yData;return{object:this,pointId:a,dataCoord:[o[a%this.shape[0]],s[a/this.shape[0]|0]]}},h.update=function(t){t=t||{};var e=t.shape||[0,0],r=t.x||o(e[0]),n=t.y||o(e[1]),i=t.z||new Float32Array(e[0]*e[1]);this.xData=r,this.yData=n;var l=t.colorLevels||[0],u=t.colorValues||[0,0,0,1],c=l.length,h=this.bounds,d=h[0]=r[0],p=h[1]=n[0],m=h[2]=r[r.length-1],v=h[3]=n[n.length-1],g=1/(m-d),y=1/(v-p),b=e[0],x=e[1];this.shape=[b,x];var _=(b-1)*(x-1)*(f.length>>>1);this.numVertices=_;for(var w=s.mallocUint8(4*_),M=s.mallocFloat32(2*_),k=s.mallocUint8(2*_),A=s.mallocUint32(_),T=0,S=0;S<x-1;++S)for(var E=y*(n[S]-p),L=y*(n[S+1]-p),C=0;C<b-1;++C)for(var z=g*(r[C]-d),I=g*(r[C+1]-d),D=0;D<f.length;D+=2){var P,O,R,F,j=f[D],N=f[D+1],B=(S+N)*b+(C+j),U=i[B],V=a.le(l,U);if(V<0)P=u[0],O=u[1],R=u[2],F=u[3];else if(V===c-1)P=u[4*c-4],O=u[4*c-3],R=u[4*c-2],F=u[4*c-1];else{var H=(U-l[V])/(l[V+1]-l[V]),q=1-H,G=4*V,Y=4*(V+1);P=q*u[G]+H*u[Y],O=q*u[G+1]+H*u[Y+1],R=q*u[G+2]+H*u[Y+2],F=q*u[G+3]+H*u[Y+3]}w[4*T]=255*P,w[4*T+1]=255*O,w[4*T+2]=255*R,w[4*T+3]=255*F,M[2*T]=.5*z+.5*I,M[2*T+1]=.5*E+.5*L,k[2*T]=j,k[2*T+1]=N,A[T]=S*b+C,T+=1}this.positionBuffer.update(M),this.weightBuffer.update(k),this.colorBuffer.update(w),this.idBuffer.update(A),s.free(M),s.free(w),s.free(k),s.free(A)},h.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBuffer.dispose(),this.weightBuffer.dispose(),this.colorBuffer.dispose(),this.idBuffer.dispose(),this.plot.removeObject(this)}},{\"./lib/shaders\":166,\"binary-search-bounds\":167,\"gl-buffer\":155,\"gl-shader\":254,\"iota-array\":292,\"typedarray-pool\":540}],166:[function(t,e,r){\"use strict\";e.exports={fragment:\"precision lowp float;\\n#define GLSLIFY 1\\nvarying vec4 fragColor;\\nvoid main() {\\n  gl_FragColor = vec4(fragColor.rgb * fragColor.a, fragColor.a);\\n}\\n\",vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 color;\\nattribute vec2 weight;\\n\\nuniform vec2 shape;\\nuniform mat3 viewTransform;\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\\n  fragColor = color;\\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\\n}\\n\",pickFragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\nvarying vec2 vWeight;\\n\\nuniform vec2 shape;\\nuniform vec4 pickOffset;\\n\\nvoid main() {\\n  vec2 d = step(.5, vWeight);\\n  vec4 id = fragId + pickOffset;\\n  id.x += d.x + d.y*shape.x;\\n\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  gl_FragColor = id/255.;\\n}\\n\",pickVertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 pickId;\\nattribute vec2 weight;\\n\\nuniform vec2 shape;\\nuniform mat3 viewTransform;\\n\\nvarying vec4 fragId;\\nvarying vec2 vWeight;\\n\\nvoid main() {\\n  vWeight = weight;\\n\\n  fragId = pickId;\\n\\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\\n}\\n\"}},{}],167:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],168:[function(t,e,r){r.lineVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi, dLo;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, screenShape;\\nuniform float width;\\n\\nvarying vec2 direction;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvec2 project_2_1(vec2 scHi, vec2 scLo, vec2 posHi, vec2 posLo) {\\n  return scHi * posHi\\n       + scLo * posHi\\n       + scHi * posLo\\n       + scLo * posLo;\\n}\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  vec2 dir = project_2_1(scaleHi, scaleLo, dHi, dLo);\\n  vec2 n = 0.5 * width * normalize(screenShape.yx * vec2(dir.y, -dir.x)) / screenShape.xy;\\n  vec2 tangent = normalize(screenShape.xy * dir);\\n  if(dir.x < 0.0 || (dir.x == 0.0 && dir.y < 0.0)) {\\n    direction = -tangent;\\n  } else {\\n    direction = tangent;\\n  }\\n  gl_Position = vec4(p + n, 0.0, 1.0);\\n}\",r.lineFragment=\"precision highp float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\nuniform vec2 screenShape;\\nuniform sampler2D dashPattern;\\nuniform float dashLength;\\n\\nvarying vec2 direction;\\n\\nvoid main() {\\n  float t = fract(dot(direction, gl_FragCoord.xy) / dashLength);\\n  vec4 pcolor = color * texture2D(dashPattern, vec2(t, 0.0)).r;\\n  gl_FragColor = vec4(pcolor.rgb * pcolor.a, pcolor.a);\\n}\",r.mitreVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo;\\nuniform float radius;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  gl_Position = vec4(p, 0.0, 1.0);\\n  gl_PointSize = radius;\\n}\",r.mitreFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  if(length(gl_PointCoord.xy - 0.5) > 0.25) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(color.rgb, color.a);\\n}\",r.pickVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi;\\nattribute vec4 pick0, pick1;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, screenShape;\\nuniform float width;\\n\\nvarying vec4 pickA, pickB;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  vec2 n = width * normalize(screenShape.yx * vec2(dHi.y, -dHi.x)) / screenShape.xy;\\n  gl_Position = vec4(p + n, 0, 1);\\n  pickA = pick0;\\n  pickB = pick1;\\n}\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 pickOffset;\\n\\nvarying vec4 pickA, pickB;\\n\\nvoid main() {\\n  vec4 fragId = vec4(pickA.xyz, 0.0);\\n  if(pickB.w > pickA.w) {\\n    fragId.xyz = pickB.xyz;\\n  }\\n\\n  fragId += pickOffset;\\n\\n  fragId.y += floor(fragId.x / 256.0);\\n  fragId.x -= floor(fragId.x / 256.0) * 256.0;\\n\\n  fragId.z += floor(fragId.y / 256.0);\\n  fragId.y -= floor(fragId.y / 256.0) * 256.0;\\n\\n  fragId.w += floor(fragId.z / 256.0);\\n  fragId.z -= floor(fragId.z / 256.0) * 256.0;\\n\\n  gl_FragColor = fragId / 255.0;\\n}\",r.fillVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 aHi, aLo, dHi;\\n\\nuniform vec2 scaleHi, translateHi, scaleLo, translateLo, projectAxis;\\nuniform float projectValue, depth;\\n\\n\\nvec2 project_1_0(vec2 scHi, vec2 trHi, vec2 scLo, vec2 trLo, vec2 posHi, vec2 posLo) {\\n  return (posHi + trHi) * scHi\\n       + (posLo + trLo) * scHi\\n       + (posHi + trHi) * scLo\\n       + (posLo + trLo) * scLo;\\n}\\n\\n\\nvoid main() {\\n  vec2 p = project_1_0(scaleHi, translateHi, scaleLo, translateLo, aHi, aLo);\\n  if(dHi.y < 0.0 || (dHi.y == 0.0 && dHi.x < 0.0)) {\\n    if(dot(p, projectAxis) < projectValue) {\\n      p = p * (1.0 - abs(projectAxis)) + projectAxis * projectValue;\\n    }\\n  }\\n  gl_Position = vec4(p, depth, 1);\\n}\",r.fillFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = vec4(color.rgb * color.a, color.a);\\n}\"},{}],169:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l){this.plot=t,this.dashPattern=e,this.lineBufferHi=r,this.lineBufferLo=n,this.pickBuffer=i,this.lineShader=a,this.mitreShader=o,this.fillShader=s,this.pickShader=l,this.usingDashes=!1,this.bounds=[1/0,1/0,-1/0,-1/0],this.width=1,this.color=[0,0,1,1],this.fill=[!1,!1,!1,!1],this.fillColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.data=null,this.numPoints=0,this.vertCount=0,this.pickOffset=0}function i(t){return t.map(function(t){return t.slice()})}function a(t,e){var r=t.gl,i=s(r),a=s(r),u=s(r),c=l(r,[1,1]),f=o(r,h.lineVertex,h.lineFragment),d=o(r,h.mitreVertex,h.mitreFragment),p=o(r,h.fillVertex,h.fillFragment),m=o(r,h.pickVertex,h.pickFragment),v=new n(t,c,i,a,u,f,d,p,m);return t.addObject(v),v.update(e),v}e.exports=a;var o=t(\"gl-shader\"),s=t(\"gl-buffer\"),l=t(\"gl-texture2d\"),u=t(\"ndarray\"),c=t(\"typedarray-pool\"),h=t(\"./lib/shaders\"),f=n.prototype;f.setProjectionModel=function(){var t={scaleHi:new Float32Array([0,0]),scaleLo:new Float32Array([0,0]),translateHi:new Float32Array([0,0]),translateLo:new Float32Array([0,0]),screenShape:[0,0]};return function(){var e=this.bounds,r=this.plot.viewBox,n=this.plot.dataBox,i=e[2]-e[0],a=e[3]-e[1],o=n[2]-n[0],s=n[3]-n[1],l=r[2]-r[0],u=r[3]-r[1],c=2*i/o,h=2*a/s,f=(e[0]-n[0]-.5*o)/i,d=(e[1]-n[1]-.5*s)/a;return t.scaleHi[0]=c,t.scaleHi[1]=h,t.scaleLo[0]=c-t.scaleHi[0],t.scaleLo[1]=h-t.scaleHi[1],t.translateHi[0]=f,t.translateHi[1]=d,t.translateLo[0]=f-t.translateHi[0],t.translateLo[1]=d-t.translateHi[1],t.screenShape[0]=l,t.screenShape[1]=u,t}}(),f.setProjectionUniforms=function(t,e){t.scaleHi=e.scaleHi,t.scaleLo=e.scaleLo,t.translateHi=e.translateHi,t.translateLo=e.translateLo,t.screenShape=e.screenShape},f.draw=function(){var t=[1,0],e=[-1,0],r=[0,1],n=[0,-1];return function(){var i=this.vertCount;if(i){var a=this.setProjectionModel(),o=this.plot,s=this.width,l=o.gl,u=o.pixelRatio,c=this.color,h=this.fillShader.attributes;this.lineBufferLo.bind(),h.aLo.pointer(l.FLOAT,!1,16,0),this.lineBufferHi.bind();var f=this.fill;if(f[0]||f[1]||f[2]||f[3]){var d=this.fillShader;d.bind();var p=d.uniforms;this.setProjectionUniforms(p,a),p.depth=o.nextDepthValue(),h.aHi.pointer(l.FLOAT,!1,16,0),h.dHi.pointer(l.FLOAT,!1,16,8),l.depthMask(!0),l.enable(l.DEPTH_TEST);var m=this.fillColor;f[0]&&(p.color=m[0],p.projectAxis=e,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[1]&&(p.color=m[1],p.projectAxis=n,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[2]&&(p.color=m[2],p.projectAxis=t,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),f[3]&&(p.color=m[3],p.projectAxis=r,p.projectValue=1,l.drawArrays(l.TRIANGLES,0,i)),l.depthMask(!1),l.disable(l.DEPTH_TEST)}var v=this.lineShader;v.bind(),this.lineBufferLo.bind(),v.attributes.aLo.pointer(l.FLOAT,!1,16,0),v.attributes.dLo.pointer(l.FLOAT,!1,16,8),this.lineBufferHi.bind();var g=v.uniforms;this.setProjectionUniforms(g,a),g.color=c,g.width=s*u,g.dashPattern=this.dashPattern.bind(),g.dashLength=this.dashLength*u;var y=v.attributes;if(y.aHi.pointer(l.FLOAT,!1,16,0),y.dHi.pointer(l.FLOAT,!1,16,8),l.drawArrays(l.TRIANGLES,0,i),s>2&&!this.usingDashes){var b=this.mitreShader;this.lineBufferLo.bind(),b.attributes.aLo.pointer(l.FLOAT,!1,48,0),this.lineBufferHi.bind(),b.bind();var x=b.uniforms;this.setProjectionUniforms(x,a),x.color=c,x.radius=s*u,b.attributes.aHi.pointer(l.FLOAT,!1,48,0),l.drawArrays(l.POINTS,0,i/3|0)}}}}(),f.drawPick=function(){var t=[0,0,0,0];return function(e){var r=this.vertCount,n=this.numPoints;if(this.pickOffset=e,!r)return e+n;var i=this.setProjectionModel(),a=this.plot,o=this.width,s=a.gl,l=a.pickPixelRatio,u=this.pickShader,c=this.pickBuffer;t[0]=255&e,t[1]=e>>>8&255,t[2]=e>>>16&255,t[3]=e>>>24,u.bind();var h=u.uniforms;this.setProjectionUniforms(h,i),h.width=o*l,h.pickOffset=t;var f=u.attributes;return this.lineBufferHi.bind(),f.aHi.pointer(s.FLOAT,!1,16,0),f.dHi.pointer(s.FLOAT,!1,16,8),this.lineBufferLo.bind(),f.aLo.pointer(s.FLOAT,!1,16,0),c.bind(),f.pick0.pointer(s.UNSIGNED_BYTE,!1,8,0),f.pick1.pointer(s.UNSIGNED_BYTE,!1,8,4),s.drawArrays(s.TRIANGLES,0,r),e+n}}(),f.pick=function(t,e,r){var n=this.pickOffset,i=this.numPoints;if(r<n||r>=n+i)return null;var a=r-n,o=this.data;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}},f.update=function(t){t=t||{};var e,r,n,a,o,s=this.plot.gl;this.color=(t.color||[0,0,1,1]).slice(),this.width=+(t.width||1),this.fill=(t.fill||[!1,!1,!1,!1]).slice(),this.fillColor=i(t.fillColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]);var h=t.dashes||[1],f=0;for(e=0;e<h.length;++e)f+=h[e];var d=c.mallocUint8(f);n=0;var p=255;for(e=0;e<h.length;++e){for(r=0;r<h[e];++r)d[n++]=p;p^=255}this.dashPattern.dispose(),this.usingDashes=h.length>1,this.dashPattern=l(s,u(d,[f,1,4],[1,0,0])),this.dashPattern.minFilter=s.NEAREST,this.dashPattern.magFilter=s.NEAREST,this.dashLength=f,c.free(d);var m=t.positions;this.data=m;var v=this.bounds;v[0]=v[1]=1/0,v[2]=v[3]=-1/0;var g=this.numPoints=m.length>>>1;if(0!==g){for(e=0;e<g;++e)a=m[2*e],o=m[2*e+1],isNaN(a)||isNaN(o)||(v[0]=Math.min(v[0],a),v[1]=Math.min(v[1],o),v[2]=Math.max(v[2],a),v[3]=Math.max(v[3],o));v[0]===v[2]&&(v[2]+=1),v[3]===v[1]&&(v[3]+=1);var y=c.mallocFloat64(24*(g-1)),b=c.mallocFloat32(24*(g-1)),x=c.mallocFloat32(24*(g-1)),_=c.mallocUint32(12*(g-1)),w=b.length,M=_.length;n=g;for(var k=0;n>1;){var A=--n;a=m[2*n],o=m[2*n+1];var T=A-1,S=m[2*T],E=m[2*T+1];if(!(isNaN(a)||isNaN(o)||isNaN(S)||isNaN(E))){k+=1,a=(a-v[0])/(v[2]-v[0]),o=(o-v[1])/(v[3]-v[1]),S=(S-v[0])/(v[2]-v[0]),E=(E-v[1])/(v[3]-v[1]);var L=S-a,C=E-o,z=A|1<<24,I=A-1,D=A,P=A-1|1<<24;y[--w]=-C,y[--w]=-L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I,y[--w]=C,y[--w]=L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=-C,y[--w]=-L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=C,y[--w]=L,y[--w]=E,y[--w]=S,_[--M]=D,_[--M]=P,y[--w]=-C,y[--w]=-L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I,y[--w]=C,y[--w]=L,y[--w]=o,y[--w]=a,_[--M]=z,_[--M]=I}}for(e=0;e<y.length;e++)b[e]=y[e],x[e]=y[e]-b[e];this.vertCount=6*k,this.lineBufferHi.update(b.subarray(w)),this.lineBufferLo.update(x.subarray(w)),this.pickBuffer.update(_.subarray(M)),c.free(y),c.free(b),c.free(x),c.free(_)}},f.dispose=function(){this.plot.removeObject(this),this.lineBufferLo.dispose(),this.lineBufferHi.dispose(),this.pickBuffer.dispose(),this.lineShader.dispose(),this.mitreShader.dispose(),this.fillShader.dispose(),this.pickShader.dispose(),this.dashPattern.dispose()}},{\"./lib/shaders\":168,\"gl-buffer\":155,\"gl-shader\":254,\"gl-texture2d\":266,ndarray:466,\"typedarray-pool\":540}],170:[function(t,e,r){var n=t(\"gl-shader\"),i=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, nextPosition;\\nattribute float arcLength, lineWidth;\\nattribute vec4 color;\\n\\nuniform vec2 screenShape;\\nuniform float pixelRatio;\\nuniform mat4 model, view, projection;\\n\\nvarying vec4 fragColor;\\nvarying vec3 worldPosition;\\nvarying float pixelArcLength;\\n\\nvoid main() {\\n  vec4 projected = projection * view * model * vec4(position, 1.0);\\n  vec4 tangentClip = projection * view * model * vec4(nextPosition - position, 0.0);\\n  vec2 tangent = normalize(screenShape * tangentClip.xy);\\n  vec2 offset = 0.5 * pixelRatio * lineWidth * vec2(tangent.y, -tangent.x) / screenShape;\\n\\n  gl_Position = vec4(projected.xy + projected.w * offset, projected.zw);\\n\\n  worldPosition = position;\\n  pixelArcLength = arcLength;\\n  fragColor = color;\\n}\\n\",a=[{name:\"position\",type:\"vec3\"},{name:\"nextPosition\",type:\"vec3\"},{name:\"arcLength\",type:\"float\"},{name:\"lineWidth\",type:\"float\"},{name:\"color\",type:\"vec4\"}];r.createShader=function(t){return n(t,i,\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3      clipBounds[2];\\nuniform sampler2D dashTexture;\\nuniform float     dashScale;\\nuniform float     opacity;\\n\\nvarying vec3    worldPosition;\\nvarying float   pixelArcLength;\\nvarying vec4    fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(worldPosition, clipBounds[0])) || any(greaterThan(worldPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  float dashWeight = texture2D(dashTexture, vec2(dashScale * pixelArcLength, 0)).r;\\n  if(dashWeight < 0.5) {\\n    discard;\\n  }\\n  gl_FragColor = fragColor * opacity;\\n}\\n\",null,a)},r.createPickShader=function(t){return n(t,i,\"precision mediump float;\\n#define GLSLIFY 1\\n\\n#define FLOAT_MAX  1.70141184e38\\n#define FLOAT_MIN  1.17549435e-38\\n\\nlowp vec4 encode_float_1_0(highp float v) {\\n  highp float av = abs(v);\\n\\n  //Handle special cases\\n  if(av < FLOAT_MIN) {\\n    return vec4(0.0, 0.0, 0.0, 0.0);\\n  } else if(v > FLOAT_MAX) {\\n    return vec4(127.0, 128.0, 0.0, 0.0) / 255.0;\\n  } else if(v < -FLOAT_MAX) {\\n    return vec4(255.0, 128.0, 0.0, 0.0) / 255.0;\\n  }\\n\\n  highp vec4 c = vec4(0,0,0,0);\\n\\n  //Compute exponent and mantissa\\n  highp float e = floor(log2(av));\\n  highp float m = av * pow(2.0, -e) - 1.0;\\n  \\n  //Unpack mantissa\\n  c[1] = floor(128.0 * m);\\n  m -= c[1] / 128.0;\\n  c[2] = floor(32768.0 * m);\\n  m -= c[2] / 32768.0;\\n  c[3] = floor(8388608.0 * m);\\n  \\n  //Unpack exponent\\n  highp float ebias = e + 127.0;\\n  c[0] = floor(ebias / 2.0);\\n  ebias -= c[0] * 2.0;\\n  c[1] += floor(ebias) * 128.0; \\n\\n  //Unpack sign bit\\n  c[0] += 128.0 * step(0.0, -v);\\n\\n  //Scale back to range\\n  return c / 255.0;\\n}\\n\\n\\n\\nuniform float pickId;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec3 worldPosition;\\nvarying float pixelArcLength;\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  if(any(lessThan(worldPosition, clipBounds[0])) || any(greaterThan(worldPosition, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(pickId/255.0, encode_float_1_0(pixelArcLength).xyz);\\n}\",null,a)}},{\"gl-shader\":254}],171:[function(t,e,r){\"use strict\";function n(t,e){for(var r=0,n=0;n<3;++n){var i=t[n]-e[n];r+=i*i}return Math.sqrt(r)}function i(t){\n",
       "for(var e=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],r=0;r<3;++r)e[0][r]=Math.max(t[0][r],e[0][r]),e[1][r]=Math.min(t[1][r],e[1][r]);return e}function a(t,e,r,n){this.arcLength=t,this.position=e,this.index=r,this.dataCoordinate=n}function o(t,e,r,n,i,a){this.gl=t,this.shader=e,this.pickShader=r,this.buffer=n,this.vao=i,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.points=[],this.arcLength=[],this.vertexCount=0,this.bounds=[[0,0,0],[0,0,0]],this.pickId=0,this.lineWidth=1,this.texture=a,this.dashScale=1,this.opacity=1,this.dirty=!0,this.pixelRatio=1}function s(t){var e=t.gl||t.scene&&t.scene.gl,r=m(e);r.attributes.position.location=0,r.attributes.nextPosition.location=1,r.attributes.arcLength.location=2,r.attributes.lineWidth.location=3,r.attributes.color.location=4;var n=v(e);n.attributes.position.location=0,n.attributes.nextPosition.location=1,n.attributes.arcLength.location=2,n.attributes.lineWidth.location=3,n.attributes.color.location=4;for(var i=l(e),a=u(e,[{buffer:i,size:3,offset:0,stride:48},{buffer:i,size:3,offset:12,stride:48},{buffer:i,size:1,offset:24,stride:48},{buffer:i,size:1,offset:28,stride:48},{buffer:i,size:4,offset:32,stride:48}]),s=d(new Array(1024),[256,1,4]),h=0;h<1024;++h)s.data[h]=255;var f=c(e,s);f.wrap=e.REPEAT;var p=new o(e,r,n,i,a,f);return p.update(t),p}e.exports=s;var l=t(\"gl-buffer\"),u=t(\"gl-vao\"),c=t(\"gl-texture2d\"),h=t(\"glsl-read-float\"),f=t(\"binary-search-bounds\"),d=t(\"ndarray\"),p=t(\"./lib/shaders\"),m=p.createShader,v=p.createPickShader,g=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],y=o.prototype;y.isTransparent=function(){return this.opacity<1},y.isOpaque=function(){return this.opacity>=1},y.pickSlots=1,y.setPickBase=function(t){this.pickId=t},y.drawTransparent=y.draw=function(t){var e=this.gl,r=this.shader,n=this.vao;r.bind(),r.uniforms={model:t.model||g,view:t.view||g,projection:t.projection||g,clipBounds:i(this.clipBounds),dashTexture:this.texture.bind(),dashScale:this.dashScale/this.arcLength[this.arcLength.length-1],opacity:this.opacity,screenShape:[e.drawingBufferWidth,e.drawingBufferHeight],pixelRatio:this.pixelRatio},n.bind(),n.draw(e.TRIANGLE_STRIP,this.vertexCount)},y.drawPick=function(t){var e=this.gl,r=this.pickShader,n=this.vao;r.bind(),r.uniforms={model:t.model||g,view:t.view||g,projection:t.projection||g,pickId:this.pickId,clipBounds:i(this.clipBounds),screenShape:[e.drawingBufferWidth,e.drawingBufferHeight],pixelRatio:this.pixelRatio},n.bind(),n.draw(e.TRIANGLE_STRIP,this.vertexCount)},y.update=function(t){var e,r;this.dirty=!0;var i=!!t.connectGaps;\"dashScale\"in t&&(this.dashScale=t.dashScale),\"opacity\"in t&&(this.opacity=+t.opacity);var a=t.position||t.positions;if(a){var o=t.color||t.colors||[0,0,0,1],s=t.lineWidth||1,l=[],u=[],c=[],h=0,p=0,m=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],v=!1;t:for(e=1;e<a.length;++e){var g=a[e-1],y=a[e];for(u.push(h),c.push(g.slice()),r=0;r<3;++r){if(isNaN(g[r])||isNaN(y[r])||!isFinite(g[r])||!isFinite(y[r])){if(!i&&l.length>0){for(var b=0;b<24;++b)l.push(l[l.length-12]);p+=2,v=!0}continue t}m[0][r]=Math.min(m[0][r],g[r],y[r]),m[1][r]=Math.max(m[1][r],g[r],y[r])}var x,_;Array.isArray(o[0])?(x=o[e-1],_=o[e]):x=_=o,3===x.length&&(x=[x[0],x[1],x[2],1]),3===_.length&&(_=[_[0],_[1],_[2],1]);var w;w=Array.isArray(s)?s[e-1]:s;var M=h;if(h+=n(g,y),v){for(r=0;r<2;++r)l.push(g[0],g[1],g[2],y[0],y[1],y[2],M,w,x[0],x[1],x[2],x[3]);p+=2,v=!1}l.push(g[0],g[1],g[2],y[0],y[1],y[2],M,w,x[0],x[1],x[2],x[3],g[0],g[1],g[2],y[0],y[1],y[2],M,-w,x[0],x[1],x[2],x[3],y[0],y[1],y[2],g[0],g[1],g[2],h,-w,_[0],_[1],_[2],_[3],y[0],y[1],y[2],g[0],g[1],g[2],h,w,_[0],_[1],_[2],_[3]),p+=4}if(this.buffer.update(l),u.push(h),c.push(a[a.length-1].slice()),this.bounds=m,this.vertexCount=p,this.points=c,this.arcLength=u,\"dashes\"in t){var k=t.dashes,A=k.slice();for(A.unshift(0),e=1;e<A.length;++e)A[e]=A[e-1]+A[e];var T=d(new Array(1024),[256,1,4]);for(e=0;e<256;++e){for(r=0;r<4;++r)T.set(e,0,r,0);1&f.le(A,A[A.length-1]*e/255)?T.set(e,0,0,0):T.set(e,0,0,255)}this.texture.setPixels(T)}}},y.dispose=function(){this.shader.dispose(),this.vao.dispose(),this.buffer.dispose()},y.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=h(t.value[0],t.value[1],t.value[2],0),r=f.le(this.arcLength,e);if(r<0)return null;if(r===this.arcLength.length-1)return new a(this.arcLength[this.arcLength.length-1],this.points[this.points.length-1].slice(),r);for(var n=this.points[r],i=this.points[Math.min(r+1,this.points.length-1)],o=(e-this.arcLength[r])/(this.arcLength[r+1]-this.arcLength[r]),s=1-o,l=[0,0,0],u=0;u<3;++u)l[u]=s*n[u]+o*i[u];var c=Math.min(o<.5?r:r+1,this.points.length-1);return new a(e,l,c,this.points[c])}},{\"./lib/shaders\":170,\"binary-search-bounds\":65,\"gl-buffer\":155,\"gl-texture2d\":266,\"gl-vao\":270,\"glsl-read-float\":277,ndarray:466}],172:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*a-i*n;return o?(o=1/o,t[0]=a*o,t[1]=-n*o,t[2]=-i*o,t[3]=r*o,t):null}e.exports=n},{}],173:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=c*o-s*u,f=-c*a+s*l,d=u*a-o*l,p=r*h+n*f+i*d;return p?(p=1/p,t[0]=h*p,t[1]=(-c*n+i*u)*p,t[2]=(s*n-i*o)*p,t[3]=f*p,t[4]=(c*r-i*l)*p,t[5]=(-s*r+i*a)*p,t[6]=d*p,t[7]=(-u*r+n*l)*p,t[8]=(o*r-n*a)*p,t):null}e.exports=n},{}],174:[function(t,e,r){function n(t){var e=new Float32Array(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e}e.exports=n},{}],175:[function(t,e,r){function n(){var t=new Float32Array(16);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],176:[function(t,e,r){function n(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8],c=t[9],h=t[10],f=t[11],d=t[12],p=t[13],m=t[14],v=t[15];return(e*o-r*a)*(h*v-f*m)-(e*s-n*a)*(c*v-f*p)+(e*l-i*a)*(c*m-h*p)+(r*s-n*o)*(u*v-f*d)-(r*l-i*o)*(u*m-h*d)+(n*l-i*s)*(u*p-c*d)}e.exports=n},{}],177:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[1]=c+g,t[2]=f-v,t[3]=0,t[4]=c-g,t[5]=1-u-p,t[6]=d+m,t[7]=0,t[8]=f+v,t[9]=d-m,t[10]=1-u-h,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],178:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=n+n,l=i+i,u=a+a,c=n*s,h=n*l,f=n*u,d=i*l,p=i*u,m=a*u,v=o*s,g=o*l,y=o*u;return t[0]=1-(d+m),t[1]=h+y,t[2]=f-g,t[3]=0,t[4]=h-y,t[5]=1-(c+m),t[6]=p+v,t[7]=0,t[8]=f+g,t[9]=p-v,t[10]=1-(c+d),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t}e.exports=n},{}],179:[function(t,e,r){function n(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}e.exports=n},{}],180:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(i*E-n*L-a*S)*C,t[2]=(m*M-v*w+g*_)*C,t[3]=(f*w-h*M-d*_)*C,t[4]=(l*T-o*L-u*A)*C,t[5]=(r*L-i*T+a*A)*C,t[6]=(v*x-p*M-g*b)*C,t[7]=(c*M-f*x+d*b)*C,t[8]=(o*E-s*T+u*k)*C,t[9]=(n*T-r*E-a*k)*C,t[10]=(p*w-m*x+g*y)*C,t[11]=(h*x-c*w-d*y)*C,t[12]=(s*A-o*S-l*k)*C,t[13]=(r*S-n*A+i*k)*C,t[14]=(m*b-p*_-v*y)*C,t[15]=(c*_-h*b+f*y)*C,t):null}e.exports=n},{}],181:[function(t,e,r){function n(t,e,r,n){var a,o,s,l,u,c,h,f,d,p,m=e[0],v=e[1],g=e[2],y=n[0],b=n[1],x=n[2],_=r[0],w=r[1],M=r[2];return Math.abs(m-_)<1e-6&&Math.abs(v-w)<1e-6&&Math.abs(g-M)<1e-6?i(t):(h=m-_,f=v-w,d=g-M,p=1/Math.sqrt(h*h+f*f+d*d),h*=p,f*=p,d*=p,a=b*d-x*f,o=x*h-y*d,s=y*f-b*h,p=Math.sqrt(a*a+o*o+s*s),p?(p=1/p,a*=p,o*=p,s*=p):(a=0,o=0,s=0),l=f*s-d*o,u=d*a-h*s,c=h*o-f*a,p=Math.sqrt(l*l+u*u+c*c),p?(p=1/p,l*=p,u*=p,c*=p):(l=0,u=0,c=0),t[0]=a,t[1]=l,t[2]=h,t[3]=0,t[4]=o,t[5]=u,t[6]=f,t[7]=0,t[8]=s,t[9]=c,t[10]=d,t[11]=0,t[12]=-(a*m+o*v+s*g),t[13]=-(l*m+u*v+c*g),t[14]=-(h*m+f*v+d*g),t[15]=1,t)}var i=t(\"./identity\");e.exports=n},{\"./identity\":179}],182:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],m=e[12],v=e[13],g=e[14],y=e[15],b=r[0],x=r[1],_=r[2],w=r[3];return t[0]=b*n+x*s+_*h+w*m,t[1]=b*i+x*l+_*f+w*v,t[2]=b*a+x*u+_*d+w*g,t[3]=b*o+x*c+_*p+w*y,b=r[4],x=r[5],_=r[6],w=r[7],t[4]=b*n+x*s+_*h+w*m,t[5]=b*i+x*l+_*f+w*v,t[6]=b*a+x*u+_*d+w*g,t[7]=b*o+x*c+_*p+w*y,b=r[8],x=r[9],_=r[10],w=r[11],t[8]=b*n+x*s+_*h+w*m,t[9]=b*i+x*l+_*f+w*v,t[10]=b*a+x*u+_*d+w*g,t[11]=b*o+x*c+_*p+w*y,b=r[12],x=r[13],_=r[14],w=r[15],t[12]=b*n+x*s+_*h+w*m,t[13]=b*i+x*l+_*f+w*v,t[14]=b*a+x*u+_*d+w*g,t[15]=b*o+x*c+_*p+w*y,t}e.exports=n},{}],183:[function(t,e,r){function n(t,e,r,n,i){var a=1/Math.tan(e/2),o=1/(n-i);return t[0]=a/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=(i+n)*o,t[11]=-1,t[12]=0,t[13]=0,t[14]=2*i*n*o,t[15]=0,t}e.exports=n},{}],184:[function(t,e,r){function n(t,e,r,n){var i,a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T,S,E=n[0],L=n[1],C=n[2],z=Math.sqrt(E*E+L*L+C*C);return Math.abs(z)<1e-6?null:(z=1/z,E*=z,L*=z,C*=z,i=Math.sin(r),a=Math.cos(r),o=1-a,s=e[0],l=e[1],u=e[2],c=e[3],h=e[4],f=e[5],d=e[6],p=e[7],m=e[8],v=e[9],g=e[10],y=e[11],b=E*E*o+a,x=L*E*o+C*i,_=C*E*o-L*i,w=E*L*o-C*i,M=L*L*o+a,k=C*L*o+E*i,A=E*C*o+L*i,T=L*C*o-E*i,S=C*C*o+a,t[0]=s*b+h*x+m*_,t[1]=l*b+f*x+v*_,t[2]=u*b+d*x+g*_,t[3]=c*b+p*x+y*_,t[4]=s*w+h*M+m*k,t[5]=l*w+f*M+v*k,t[6]=u*w+d*M+g*k,t[7]=c*w+p*M+y*k,t[8]=s*A+h*T+m*S,t[9]=l*A+f*T+v*S,t[10]=u*A+d*T+g*S,t[11]=c*A+p*T+y*S,e!==t&&(t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t)}e.exports=n},{}],185:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[4],o=e[5],s=e[6],l=e[7],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=a*i+u*n,t[5]=o*i+c*n,t[6]=s*i+h*n,t[7]=l*i+f*n,t[8]=u*i-a*n,t[9]=c*i-o*n,t[10]=h*i-s*n,t[11]=f*i-l*n,t}e.exports=n},{}],186:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i-u*n,t[1]=o*i-c*n,t[2]=s*i-h*n,t[3]=l*i-f*n,t[8]=a*n+u*i,t[9]=o*n+c*i,t[10]=s*n+h*i,t[11]=l*n+f*i,t}e.exports=n},{}],187:[function(t,e,r){function n(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[4],c=e[5],h=e[6],f=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i+u*n,t[1]=o*i+c*n,t[2]=s*i+h*n,t[3]=l*i+f*n,t[4]=u*i-a*n,t[5]=c*i-o*n,t[6]=h*i-s*n,t[7]=f*i-l*n,t}e.exports=n},{}],188:[function(t,e,r){function n(t,e,r){var n=r[0],i=r[1],a=r[2];return t[0]=e[0]*n,t[1]=e[1]*n,t[2]=e[2]*n,t[3]=e[3]*n,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*a,t[9]=e[9]*a,t[10]=e[10]*a,t[11]=e[11]*a,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t}e.exports=n},{}],189:[function(t,e,r){function n(t,e,r){var n,i,a,o,s,l,u,c,h,f,d,p,m=r[0],v=r[1],g=r[2];return e===t?(t[12]=e[0]*m+e[4]*v+e[8]*g+e[12],t[13]=e[1]*m+e[5]*v+e[9]*g+e[13],t[14]=e[2]*m+e[6]*v+e[10]*g+e[14],t[15]=e[3]*m+e[7]*v+e[11]*g+e[15]):(n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=u,t[7]=c,t[8]=h,t[9]=f,t[10]=d,t[11]=p,t[12]=n*m+s*v+h*g+e[12],t[13]=i*m+l*v+f*g+e[13],t[14]=a*m+u*v+d*g+e[14],t[15]=o*m+c*v+p*g+e[15]),t}e.exports=n},{}],190:[function(t,e,r){function n(t,e){if(t===e){var r=e[1],n=e[2],i=e[3],a=e[6],o=e[7],s=e[11];t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=a,t[11]=e[14],t[12]=i,t[13]=o,t[14]=s}else t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15];return t}e.exports=n},{}],191:[function(t,e,r){\"use strict\";function n(t,e){switch(e.length){case 0:break;case 1:t[0]=1/e[0];break;case 4:i(t,e);break;case 9:a(t,e);break;case 16:o(t,e);break;default:throw new Error(\"currently supports matrices up to 4x4\")}return t}e.exports=n;var i=t(\"gl-mat2/invert\"),a=t(\"gl-mat3/invert\"),o=t(\"gl-mat4/invert\")},{\"gl-mat2/invert\":172,\"gl-mat3/invert\":173,\"gl-mat4/invert\":180}],192:[function(t,e,r){r.glMatrix=t(\"./gl-matrix/common.js\"),r.mat2=t(\"./gl-matrix/mat2.js\"),r.mat2d=t(\"./gl-matrix/mat2d.js\"),r.mat3=t(\"./gl-matrix/mat3.js\"),r.mat4=t(\"./gl-matrix/mat4.js\"),r.quat=t(\"./gl-matrix/quat.js\"),r.vec2=t(\"./gl-matrix/vec2.js\"),r.vec3=t(\"./gl-matrix/vec3.js\"),r.vec4=t(\"./gl-matrix/vec4.js\")},{\"./gl-matrix/common.js\":193,\"./gl-matrix/mat2.js\":194,\"./gl-matrix/mat2d.js\":195,\"./gl-matrix/mat3.js\":196,\"./gl-matrix/mat4.js\":197,\"./gl-matrix/quat.js\":198,\"./gl-matrix/vec2.js\":199,\"./gl-matrix/vec3.js\":200,\"./gl-matrix/vec4.js\":201}],193:[function(t,e,r){var n={};n.EPSILON=1e-6,n.ARRAY_TYPE=\"undefined\"!=typeof Float32Array?Float32Array:Array,n.RANDOM=Math.random,n.ENABLE_SIMD=!1,n.SIMD_AVAILABLE=n.ARRAY_TYPE===Float32Array&&\"SIMD\"in this,n.USE_SIMD=n.ENABLE_SIMD&&n.SIMD_AVAILABLE,n.setMatrixArrayType=function(t){n.ARRAY_TYPE=t};var i=Math.PI/180;n.toRadian=function(t){return t*i},n.equals=function(t,e){return Math.abs(t-e)<=n.EPSILON*Math.max(1,Math.abs(t),Math.abs(e))},e.exports=n},{}],194:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},i.clone=function(t){var e=new n.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},i.fromValues=function(t,e,r,i){var a=new n.ARRAY_TYPE(4);return a[0]=t,a[1]=e,a[2]=r,a[3]=i,a},i.set=function(t,e,r,n,i){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t},i.transpose=function(t,e){if(t===e){var r=e[1];t[1]=e[2],t[2]=r}else t[0]=e[0],t[1]=e[2],t[2]=e[1],t[3]=e[3];return t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*a-i*n;return o?(o=1/o,t[0]=a*o,t[1]=-n*o,t[2]=-i*o,t[3]=r*o,t):null},i.adjoint=function(t,e){var r=e[0];return t[0]=e[3],t[1]=-e[1],t[2]=-e[2],t[3]=r,t},i.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1],u=r[2],c=r[3];return t[0]=n*s+a*l,t[1]=i*s+o*l,t[2]=n*u+a*c,t[3]=i*u+o*c,t},i.mul=i.multiply,i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+a*s,t[1]=i*l+o*s,t[2]=n*-s+a*l,t[3]=i*-s+o*l,t},i.scale=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1];return t[0]=n*s,t[1]=i*s,t[2]=a*l,t[3]=o*l,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=-r,t[3]=n,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t},i.str=function(t){return\"mat2(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2))},i.LDU=function(t,e,r,n){return t[2]=n[2]/n[0],r[0]=n[0],r[1]=n[1],r[3]=n[3]-t[2]*r[1],[t,e,r]},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t},i.sub=i.subtract,i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=e[0],l=e[1],u=e[2],c=e[3];return Math.abs(r-s)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(i-l)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-u)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(u))&&Math.abs(o-c)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t},e.exports=i},{\"./common.js\":193}],195:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(6);return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(6);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},i.fromValues=function(t,e,r,i,a,o){var s=new n.ARRAY_TYPE(6);return s[0]=t,s[1]=e,s[2]=r,s[3]=i,s[4]=a,s[5]=o,s},i.set=function(t,e,r,n,i,a,o){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=r*a-n*i;return l?(l=1/l,t[0]=a*l,t[1]=-n*l,t[2]=-i*l,t[3]=r*l,t[4]=(i*s-a*o)*l,t[5]=(n*o-r*s)*l,t):null},i.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1],h=r[2],f=r[3],d=r[4],p=r[5];return t[0]=n*u+a*c,t[1]=i*u+o*c,t[2]=n*h+a*f,t[3]=i*h+o*f,t[4]=n*d+a*p+s,t[5]=i*d+o*p+l,t},i.mul=i.multiply,i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=Math.sin(r),c=Math.cos(r);return t[0]=n*c+a*u,t[1]=i*c+o*u,t[2]=n*-u+a*c,t[3]=i*-u+o*c,t[4]=s,t[5]=l,t},i.scale=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1];return t[0]=n*u,t[1]=i*u,t[2]=a*c,t[3]=o*c,t[4]=s,t[5]=l,t},i.translate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=r[0],c=r[1];return t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=n*u+a*c+s,t[5]=i*u+o*c+l,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=-r,t[3]=n,t[4]=0,t[5]=0,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=e[1],t[4]=0,t[5]=0,t},i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=e[0],t[5]=e[1],t},i.str=function(t){return\"mat2d(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+1)},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=e[0],c=e[1],h=e[2],f=e[3],d=e[4],p=e[5];return Math.abs(r-u)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(u))&&Math.abs(i-c)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(c))&&Math.abs(a-h)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(h))&&Math.abs(o-f)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(f))&&Math.abs(s-d)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(d))&&Math.abs(l-p)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(p))},e.exports=i},{\"./common.js\":193}],196:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(9);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromMat4=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t},i.clone=function(t){var e=new n.ARRAY_TYPE(9);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},i.fromValues=function(t,e,r,i,a,o,s,l,u){var c=new n.ARRAY_TYPE(9);return c[0]=t,c[1]=e,c[2]=r,c[3]=i,c[4]=a,c[5]=o,c[6]=s,c[7]=l,c[8]=u,c},i.set=function(t,e,r,n,i,a,o,s,l,u){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t[6]=s,t[7]=l,t[8]=u,t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.transpose=function(t,e){if(t===e){var r=e[1],n=e[2],i=e[5];t[1]=e[3],t[2]=e[6],t[3]=r,t[5]=e[7],t[6]=n,t[7]=i}else t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8];return t},i.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=c*o-s*u,f=-c*a+s*l,d=u*a-o*l,p=r*h+n*f+i*d;return p?(p=1/p,t[0]=h*p,t[1]=(-c*n+i*u)*p,t[2]=(s*n-i*o)*p,t[3]=f*p,t[4]=(c*r-i*l)*p,t[5]=(-s*r+i*a)*p,t[6]=d*p,t[7]=(-u*r+n*l)*p,t[8]=(o*r-n*a)*p,t):null},i.adjoint=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8];return t[0]=o*c-s*u,t[1]=i*u-n*c,t[2]=n*s-i*o,t[3]=s*l-a*c,t[4]=r*c-i*l,t[5]=i*a-r*s,t[6]=a*u-o*l,t[7]=n*l-r*u,t[8]=r*o-n*a,t},i.determinant=function(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8];return e*(u*a-o*l)+r*(-u*i+o*s)+n*(l*i-a*s)},i.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=r[0],d=r[1],p=r[2],m=r[3],v=r[4],g=r[5],y=r[6],b=r[7],x=r[8];return t[0]=f*n+d*o+p*u,t[1]=f*i+d*s+p*c,t[2]=f*a+d*l+p*h,t[3]=m*n+v*o+g*u,t[4]=m*i+v*s+g*c,t[5]=m*a+v*l+g*h,t[6]=y*n+b*o+x*u,t[7]=y*i+b*s+x*c,t[8]=y*a+b*l+x*h,t},i.mul=i.multiply,i.translate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=r[0],d=r[1];return t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=f*n+d*o+u,t[7]=f*i+d*s+c,t[8]=f*a+d*l+h,t},i.rotate=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=Math.sin(r),d=Math.cos(r);return t[0]=d*n+f*o,t[1]=d*i+f*s,t[2]=d*a+f*l,t[3]=d*o-f*n,t[4]=d*s-f*i,t[5]=d*l-f*a,t[6]=u,t[7]=c,t[8]=h,t},i.scale=function(t,e,r){var n=r[0],i=r[1];return t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=i*e[3],t[4]=i*e[4],t[5]=i*e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=e[0],t[7]=e[1],t[8]=1,t},i.fromRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=0,t[3]=-r,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=e[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},i.fromMat2d=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=0,t[3]=e[2],t[4]=e[3],t[5]=0,t[6]=e[4],t[7]=e[5],t[8]=1,t},i.fromQuat=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[3]=c-g,t[6]=f+v,t[1]=c+g,t[4]=1-u-p,t[7]=d-m,t[2]=f-v,t[5]=d+m,t[8]=1-u-h,t},i.normalFromMat4=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(l*T-o*L-u*A)*C,t[2]=(o*E-s*T+u*k)*C,t[3]=(i*E-n*L-a*S)*C,t[4]=(r*L-i*T+a*A)*C,t[5]=(n*T-r*E-a*k)*C,t[6]=(m*M-v*w+g*_)*C,t[7]=(v*x-p*M-g*b)*C,t[8]=(p*w-m*x+g*y)*C,t):null},i.str=function(t){return\"mat3(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\", \"+t[6]+\", \"+t[7]+\", \"+t[8]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2))},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t[6]=e[6]+r[6]*n,t[7]=e[7]+r[7]*n,t[8]=e[8]+r[8]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=t[6],c=t[7],h=t[8],f=e[0],d=e[1],p=e[2],m=e[3],v=e[4],g=e[5],y=t[6],b=e[7],x=e[8];return Math.abs(r-f)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(i-d)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(d))&&Math.abs(a-p)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(p))&&Math.abs(o-m)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(m))&&Math.abs(s-v)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(v))&&Math.abs(l-g)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(g))&&Math.abs(u-y)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(y))&&Math.abs(c-b)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(b))&&Math.abs(h-x)<=n.EPSILON*Math.max(1,Math.abs(h),Math.abs(x))},e.exports=i},{\"./common.js\":193}],197:[function(t,e,r){var n=t(\"./common.js\"),i={scalar:{},SIMD:{}};i.create=function(){var t=new n.ARRAY_TYPE(16);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.clone=function(t){var e=new n.ARRAY_TYPE(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.fromValues=function(t,e,r,i,a,o,s,l,u,c,h,f,d,p,m,v){var g=new n.ARRAY_TYPE(16);return g[0]=t,g[1]=e,g[2]=r,g[3]=i,g[4]=a,g[5]=o,g[6]=s,g[7]=l,g[8]=u,g[9]=c,g[10]=h,g[11]=f,g[12]=d,g[13]=p,g[14]=m,g[15]=v,g},i.set=function(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p,m,v){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t[4]=a,t[5]=o,t[6]=s,t[7]=l,t[8]=u,t[9]=c,t[10]=h,t[11]=f,t[12]=d,t[13]=p,t[14]=m,t[15]=v,t},i.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.scalar.transpose=function(t,e){if(t===e){var r=e[1],n=e[2],i=e[3],a=e[6],o=e[7],s=e[11];t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=r,t[6]=e[9],t[7]=e[13],t[8]=n,t[9]=a,t[11]=e[14],t[12]=i,t[13]=o,t[14]=s}else t[0]=e[0],t[1]=e[4],t[2]=e[8],t[3]=e[12],t[4]=e[1],t[5]=e[5],t[6]=e[9],t[7]=e[13],t[8]=e[2],t[9]=e[6],t[10]=e[10],t[11]=e[14],t[12]=e[3],t[13]=e[7],t[14]=e[11],t[15]=e[15];return t},i.SIMD.transpose=function(t,e){var r,n,i,a,o,s,l,u,c,h;return r=SIMD.Float32x4.load(e,0),n=SIMD.Float32x4.load(e,4),i=SIMD.Float32x4.load(e,8),a=SIMD.Float32x4.load(e,12),o=SIMD.Float32x4.shuffle(r,n,0,1,4,5),s=SIMD.Float32x4.shuffle(i,a,0,1,4,5),l=SIMD.Float32x4.shuffle(o,s,0,2,4,6),u=SIMD.Float32x4.shuffle(o,s,1,3,5,7),SIMD.Float32x4.store(t,0,l),SIMD.Float32x4.store(t,4,u),o=SIMD.Float32x4.shuffle(r,n,2,3,6,7),s=SIMD.Float32x4.shuffle(i,a,2,3,6,7),c=SIMD.Float32x4.shuffle(o,s,0,2,4,6),h=SIMD.Float32x4.shuffle(o,s,1,3,5,7),SIMD.Float32x4.store(t,8,c),SIMD.Float32x4.store(t,12,h),t},i.transpose=n.USE_SIMD?i.SIMD.transpose:i.scalar.transpose,i.scalar.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15],y=r*s-n*o,b=r*l-i*o,x=r*u-a*o,_=n*l-i*s,w=n*u-a*s,M=i*u-a*l,k=c*m-h*p,A=c*v-f*p,T=c*g-d*p,S=h*v-f*m,E=h*g-d*m,L=f*g-d*v,C=y*L-b*E+x*S+_*T-w*A+M*k;return C?(C=1/C,t[0]=(s*L-l*E+u*S)*C,t[1]=(i*E-n*L-a*S)*C,t[2]=(m*M-v*w+g*_)*C,t[3]=(f*w-h*M-d*_)*C,t[4]=(l*T-o*L-u*A)*C,t[5]=(r*L-i*T+a*A)*C,t[6]=(v*x-p*M-g*b)*C,t[7]=(c*M-f*x+d*b)*C,t[8]=(o*E-s*T+u*k)*C,t[9]=(n*T-r*E-a*k)*C,t[10]=(p*w-m*x+g*y)*C,t[11]=(h*x-c*w-d*y)*C,t[12]=(s*A-o*S-l*k)*C,t[13]=(r*S-n*A+i*k)*C,t[14]=(m*b-p*_-v*y)*C,t[15]=(c*_-h*b+f*y)*C,t):null},i.SIMD.invert=function(t,e){var r,n,i,a,o,s,l,u,c,h,f=SIMD.Float32x4.load(e,0),d=SIMD.Float32x4.load(e,4),p=SIMD.Float32x4.load(e,8),m=SIMD.Float32x4.load(e,12);return o=SIMD.Float32x4.shuffle(f,d,0,1,4,5),n=SIMD.Float32x4.shuffle(p,m,0,1,4,5),r=SIMD.Float32x4.shuffle(o,n,0,2,4,6),n=SIMD.Float32x4.shuffle(n,o,1,3,5,7),o=SIMD.Float32x4.shuffle(f,d,2,3,6,7),a=SIMD.Float32x4.shuffle(p,m,2,3,6,7),i=SIMD.Float32x4.shuffle(o,a,0,2,4,6),a=SIMD.Float32x4.shuffle(a,o,1,3,5,7),o=SIMD.Float32x4.mul(i,a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),s=SIMD.Float32x4.mul(n,o),l=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(SIMD.Float32x4.mul(n,o),s),l=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),l),l=SIMD.Float32x4.swizzle(l,2,3,0,1),o=SIMD.Float32x4.mul(n,i),o=SIMD.Float32x4.swizzle(o,1,0,3,2),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),s),c=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(a,o)),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),o=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(n,2,3,0,1),a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),i=SIMD.Float32x4.swizzle(i,2,3,0,1),s=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),s),u=SIMD.Float32x4.mul(r,o),o=SIMD.Float32x4.swizzle(o,2,3,0,1),s=SIMD.Float32x4.sub(s,SIMD.Float32x4.mul(i,o)),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(r,o),u),u=SIMD.Float32x4.swizzle(u,2,3,0,1),o=SIMD.Float32x4.mul(r,n),o=SIMD.Float32x4.swizzle(o,1,0,3,2),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),u),c=SIMD.Float32x4.sub(SIMD.Float32x4.mul(i,o),c),o=SIMD.Float32x4.swizzle(o,2,3,0,1),u=SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,o),u),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(i,o)),o=SIMD.Float32x4.mul(r,a),o=SIMD.Float32x4.swizzle(o,1,0,3,2),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(i,o)),u=SIMD.Float32x4.add(SIMD.Float32x4.mul(n,o),u),o=SIMD.Float32x4.swizzle(o,2,3,0,1),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(i,o),l),u=SIMD.Float32x4.sub(u,SIMD.Float32x4.mul(n,o)),o=SIMD.Float32x4.mul(r,i),o=SIMD.Float32x4.swizzle(o,1,0,3,2),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(a,o),l),c=SIMD.Float32x4.sub(c,SIMD.Float32x4.mul(n,o)),o=SIMD.Float32x4.swizzle(o,2,3,0,1),l=SIMD.Float32x4.sub(l,SIMD.Float32x4.mul(a,o)),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(n,o),c),h=SIMD.Float32x4.mul(r,s),h=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(h,2,3,0,1),h),h=SIMD.Float32x4.add(SIMD.Float32x4.swizzle(h,1,0,3,2),h),o=SIMD.Float32x4.reciprocalApproximation(h),h=SIMD.Float32x4.sub(SIMD.Float32x4.add(o,o),SIMD.Float32x4.mul(h,SIMD.Float32x4.mul(o,o))),(h=SIMD.Float32x4.swizzle(h,0,0,0,0))?(SIMD.Float32x4.store(t,0,SIMD.Float32x4.mul(h,s)),SIMD.Float32x4.store(t,4,SIMD.Float32x4.mul(h,l)),SIMD.Float32x4.store(t,8,SIMD.Float32x4.mul(h,u)),SIMD.Float32x4.store(t,12,SIMD.Float32x4.mul(h,c)),t):null},i.invert=n.USE_SIMD?i.SIMD.invert:i.scalar.invert,i.scalar.adjoint=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=e[4],s=e[5],l=e[6],u=e[7],c=e[8],h=e[9],f=e[10],d=e[11],p=e[12],m=e[13],v=e[14],g=e[15];return t[0]=s*(f*g-d*v)-h*(l*g-u*v)+m*(l*d-u*f),t[1]=-(n*(f*g-d*v)-h*(i*g-a*v)+m*(i*d-a*f)),t[2]=n*(l*g-u*v)-s*(i*g-a*v)+m*(i*u-a*l),t[3]=-(n*(l*d-u*f)-s*(i*d-a*f)+h*(i*u-a*l)),t[4]=-(o*(f*g-d*v)-c*(l*g-u*v)+p*(l*d-u*f)),t[5]=r*(f*g-d*v)-c*(i*g-a*v)+p*(i*d-a*f),t[6]=-(r*(l*g-u*v)-o*(i*g-a*v)+p*(i*u-a*l)),t[7]=r*(l*d-u*f)-o*(i*d-a*f)+c*(i*u-a*l),t[8]=o*(h*g-d*m)-c*(s*g-u*m)+p*(s*d-u*h),t[9]=-(r*(h*g-d*m)-c*(n*g-a*m)+p*(n*d-a*h)),t[10]=r*(s*g-u*m)-o*(n*g-a*m)+p*(n*u-a*s),t[11]=-(r*(s*d-u*h)-o*(n*d-a*h)+c*(n*u-a*s)),t[12]=-(o*(h*v-f*m)-c*(s*v-l*m)+p*(s*f-l*h)),t[13]=r*(h*v-f*m)-c*(n*v-i*m)+p*(n*f-i*h),t[14]=-(r*(s*v-l*m)-o*(n*v-i*m)+p*(n*l-i*s)),t[15]=r*(s*f-l*h)-o*(n*f-i*h)+c*(n*l-i*s),t},i.SIMD.adjoint=function(t,e){var r,n,i,a,o,s,l,u,c,h,f,d,p,r=SIMD.Float32x4.load(e,0),n=SIMD.Float32x4.load(e,4),i=SIMD.Float32x4.load(e,8),a=SIMD.Float32x4.load(e,12)\n",
       ";return c=SIMD.Float32x4.shuffle(r,n,0,1,4,5),s=SIMD.Float32x4.shuffle(i,a,0,1,4,5),o=SIMD.Float32x4.shuffle(c,s,0,2,4,6),s=SIMD.Float32x4.shuffle(s,c,1,3,5,7),c=SIMD.Float32x4.shuffle(r,n,2,3,6,7),u=SIMD.Float32x4.shuffle(i,a,2,3,6,7),l=SIMD.Float32x4.shuffle(c,u,0,2,4,6),u=SIMD.Float32x4.shuffle(u,c,1,3,5,7),c=SIMD.Float32x4.mul(l,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),h=SIMD.Float32x4.mul(s,c),f=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(SIMD.Float32x4.mul(s,c),h),f=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),f),f=SIMD.Float32x4.swizzle(f,2,3,0,1),c=SIMD.Float32x4.mul(s,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),h),p=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(u,c)),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),p),p=SIMD.Float32x4.swizzle(p,2,3,0,1),c=SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,3,0,1),u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),l=SIMD.Float32x4.swizzle(l,2,3,0,1),h=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),h),d=SIMD.Float32x4.mul(o,c),c=SIMD.Float32x4.swizzle(c,2,3,0,1),h=SIMD.Float32x4.sub(h,SIMD.Float32x4.mul(l,c)),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,c),d),d=SIMD.Float32x4.swizzle(d,2,3,0,1),c=SIMD.Float32x4.mul(o,s),c=SIMD.Float32x4.swizzle(c,1,0,3,2),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),d),p=SIMD.Float32x4.sub(SIMD.Float32x4.mul(l,c),p),c=SIMD.Float32x4.swizzle(c,2,3,0,1),d=SIMD.Float32x4.sub(SIMD.Float32x4.mul(u,c),d),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(l,c)),c=SIMD.Float32x4.mul(o,u),c=SIMD.Float32x4.swizzle(c,1,0,3,2),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(l,c)),d=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),d),c=SIMD.Float32x4.swizzle(c,2,3,0,1),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(l,c),f),d=SIMD.Float32x4.sub(d,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.mul(o,l),c=SIMD.Float32x4.swizzle(c,1,0,3,2),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(u,c),f),p=SIMD.Float32x4.sub(p,SIMD.Float32x4.mul(s,c)),c=SIMD.Float32x4.swizzle(c,2,3,0,1),f=SIMD.Float32x4.sub(f,SIMD.Float32x4.mul(u,c)),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(s,c),p),SIMD.Float32x4.store(t,0,h),SIMD.Float32x4.store(t,4,f),SIMD.Float32x4.store(t,8,d),SIMD.Float32x4.store(t,12,p),t},i.adjoint=n.USE_SIMD?i.SIMD.adjoint:i.scalar.adjoint,i.determinant=function(t){var e=t[0],r=t[1],n=t[2],i=t[3],a=t[4],o=t[5],s=t[6],l=t[7],u=t[8],c=t[9],h=t[10],f=t[11],d=t[12],p=t[13],m=t[14],v=t[15];return(e*o-r*a)*(h*v-f*m)-(e*s-n*a)*(c*v-f*p)+(e*l-i*a)*(c*m-h*p)+(r*s-n*o)*(u*v-f*d)-(r*l-i*o)*(u*m-h*d)+(n*l-i*s)*(u*p-c*d)},i.SIMD.multiply=function(t,e,r){var n=SIMD.Float32x4.load(e,0),i=SIMD.Float32x4.load(e,4),a=SIMD.Float32x4.load(e,8),o=SIMD.Float32x4.load(e,12),s=SIMD.Float32x4.load(r,0),l=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(s,3,3,3,3),o))));SIMD.Float32x4.store(t,0,l);var u=SIMD.Float32x4.load(r,4),c=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(u,3,3,3,3),o))));SIMD.Float32x4.store(t,4,c);var h=SIMD.Float32x4.load(r,8),f=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(h,3,3,3,3),o))));SIMD.Float32x4.store(t,8,f);var d=SIMD.Float32x4.load(r,12),p=SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,0,0,0,0),n),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,1,1,1,1),i),SIMD.Float32x4.add(SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,2,2,2,2),a),SIMD.Float32x4.mul(SIMD.Float32x4.swizzle(d,3,3,3,3),o))));return SIMD.Float32x4.store(t,12,p),t},i.scalar.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],m=e[12],v=e[13],g=e[14],y=e[15],b=r[0],x=r[1],_=r[2],w=r[3];return t[0]=b*n+x*s+_*h+w*m,t[1]=b*i+x*l+_*f+w*v,t[2]=b*a+x*u+_*d+w*g,t[3]=b*o+x*c+_*p+w*y,b=r[4],x=r[5],_=r[6],w=r[7],t[4]=b*n+x*s+_*h+w*m,t[5]=b*i+x*l+_*f+w*v,t[6]=b*a+x*u+_*d+w*g,t[7]=b*o+x*c+_*p+w*y,b=r[8],x=r[9],_=r[10],w=r[11],t[8]=b*n+x*s+_*h+w*m,t[9]=b*i+x*l+_*f+w*v,t[10]=b*a+x*u+_*d+w*g,t[11]=b*o+x*c+_*p+w*y,b=r[12],x=r[13],_=r[14],w=r[15],t[12]=b*n+x*s+_*h+w*m,t[13]=b*i+x*l+_*f+w*v,t[14]=b*a+x*u+_*d+w*g,t[15]=b*o+x*c+_*p+w*y,t},i.multiply=n.USE_SIMD?i.SIMD.multiply:i.scalar.multiply,i.mul=i.multiply,i.scalar.translate=function(t,e,r){var n,i,a,o,s,l,u,c,h,f,d,p,m=r[0],v=r[1],g=r[2];return e===t?(t[12]=e[0]*m+e[4]*v+e[8]*g+e[12],t[13]=e[1]*m+e[5]*v+e[9]*g+e[13],t[14]=e[2]*m+e[6]*v+e[10]*g+e[14],t[15]=e[3]*m+e[7]*v+e[11]*g+e[15]):(n=e[0],i=e[1],a=e[2],o=e[3],s=e[4],l=e[5],u=e[6],c=e[7],h=e[8],f=e[9],d=e[10],p=e[11],t[0]=n,t[1]=i,t[2]=a,t[3]=o,t[4]=s,t[5]=l,t[6]=u,t[7]=c,t[8]=h,t[9]=f,t[10]=d,t[11]=p,t[12]=n*m+s*v+h*g+e[12],t[13]=i*m+l*v+f*g+e[13],t[14]=a*m+u*v+d*g+e[14],t[15]=o*m+c*v+p*g+e[15]),t},i.SIMD.translate=function(t,e,r){var n=SIMD.Float32x4.load(e,0),i=SIMD.Float32x4.load(e,4),a=SIMD.Float32x4.load(e,8),o=SIMD.Float32x4.load(e,12),s=SIMD.Float32x4(r[0],r[1],r[2],0);e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11]),n=SIMD.Float32x4.mul(n,SIMD.Float32x4.swizzle(s,0,0,0,0)),i=SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(s,1,1,1,1)),a=SIMD.Float32x4.mul(a,SIMD.Float32x4.swizzle(s,2,2,2,2));var l=SIMD.Float32x4.add(n,SIMD.Float32x4.add(i,SIMD.Float32x4.add(a,o)));return SIMD.Float32x4.store(t,12,l),t},i.translate=n.USE_SIMD?i.SIMD.translate:i.scalar.translate,i.scalar.scale=function(t,e,r){var n=r[0],i=r[1],a=r[2];return t[0]=e[0]*n,t[1]=e[1]*n,t[2]=e[2]*n,t[3]=e[3]*n,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*a,t[9]=e[9]*a,t[10]=e[10]*a,t[11]=e[11]*a,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.SIMD.scale=function(t,e,r){var n,i,a,o=SIMD.Float32x4(r[0],r[1],r[2],0);return n=SIMD.Float32x4.load(e,0),SIMD.Float32x4.store(t,0,SIMD.Float32x4.mul(n,SIMD.Float32x4.swizzle(o,0,0,0,0))),i=SIMD.Float32x4.load(e,4),SIMD.Float32x4.store(t,4,SIMD.Float32x4.mul(i,SIMD.Float32x4.swizzle(o,1,1,1,1))),a=SIMD.Float32x4.load(e,8),SIMD.Float32x4.store(t,8,SIMD.Float32x4.mul(a,SIMD.Float32x4.swizzle(o,2,2,2,2))),t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},i.scale=n.USE_SIMD?i.SIMD.scale:i.scalar.scale,i.rotate=function(t,e,r,i){var a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T,S,E,L=i[0],C=i[1],z=i[2],I=Math.sqrt(L*L+C*C+z*z);return Math.abs(I)<n.EPSILON?null:(I=1/I,L*=I,C*=I,z*=I,a=Math.sin(r),o=Math.cos(r),s=1-o,l=e[0],u=e[1],c=e[2],h=e[3],f=e[4],d=e[5],p=e[6],m=e[7],v=e[8],g=e[9],y=e[10],b=e[11],x=L*L*s+o,_=C*L*s+z*a,w=z*L*s-C*a,M=L*C*s-z*a,k=C*C*s+o,A=z*C*s+L*a,T=L*z*s+C*a,S=C*z*s-L*a,E=z*z*s+o,t[0]=l*x+f*_+v*w,t[1]=u*x+d*_+g*w,t[2]=c*x+p*_+y*w,t[3]=h*x+m*_+b*w,t[4]=l*M+f*k+v*A,t[5]=u*M+d*k+g*A,t[6]=c*M+p*k+y*A,t[7]=h*M+m*k+b*A,t[8]=l*T+f*S+v*E,t[9]=u*T+d*S+g*E,t[10]=c*T+p*S+y*E,t[11]=h*T+m*S+b*E,e!==t&&(t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t)},i.scalar.rotateX=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[4],o=e[5],s=e[6],l=e[7],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=a*i+u*n,t[5]=o*i+c*n,t[6]=s*i+h*n,t[7]=l*i+f*n,t[8]=u*i-a*n,t[9]=c*i-o*n,t[10]=h*i-s*n,t[11]=f*i-l*n,t},i.SIMD.rotateX=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,4),o=SIMD.Float32x4.load(e,8);return SIMD.Float32x4.store(t,4,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,8,SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,n))),t},i.rotateX=n.USE_SIMD?i.SIMD.rotateX:i.scalar.rotateX,i.scalar.rotateY=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[8],c=e[9],h=e[10],f=e[11];return e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i-u*n,t[1]=o*i-c*n,t[2]=s*i-h*n,t[3]=l*i-f*n,t[8]=a*n+u*i,t[9]=o*n+c*i,t[10]=s*n+h*i,t[11]=l*n+f*i,t},i.SIMD.rotateY=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,0),o=SIMD.Float32x4.load(e,8);return SIMD.Float32x4.store(t,0,SIMD.Float32x4.sub(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,8,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,n),SIMD.Float32x4.mul(o,i))),t},i.rotateY=n.USE_SIMD?i.SIMD.rotateY:i.scalar.rotateY,i.scalar.rotateZ=function(t,e,r){var n=Math.sin(r),i=Math.cos(r),a=e[0],o=e[1],s=e[2],l=e[3],u=e[4],c=e[5],h=e[6],f=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*i+u*n,t[1]=o*i+c*n,t[2]=s*i+h*n,t[3]=l*i+f*n,t[4]=u*i-a*n,t[5]=c*i-o*n,t[6]=h*i-s*n,t[7]=f*i-l*n,t},i.SIMD.rotateZ=function(t,e,r){var n=SIMD.Float32x4.splat(Math.sin(r)),i=SIMD.Float32x4.splat(Math.cos(r));e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]);var a=SIMD.Float32x4.load(e,0),o=SIMD.Float32x4.load(e,4);return SIMD.Float32x4.store(t,0,SIMD.Float32x4.add(SIMD.Float32x4.mul(a,i),SIMD.Float32x4.mul(o,n))),SIMD.Float32x4.store(t,4,SIMD.Float32x4.sub(SIMD.Float32x4.mul(o,i),SIMD.Float32x4.mul(a,n))),t},i.rotateZ=n.USE_SIMD?i.SIMD.rotateZ:i.scalar.rotateZ,i.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=e[0],t[13]=e[1],t[14]=e[2],t[15]=1,t},i.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=e[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=e[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromRotation=function(t,e,r){var i,a,o,s=r[0],l=r[1],u=r[2],c=Math.sqrt(s*s+l*l+u*u);return Math.abs(c)<n.EPSILON?null:(c=1/c,s*=c,l*=c,u*=c,i=Math.sin(e),a=Math.cos(e),o=1-a,t[0]=s*s*o+a,t[1]=l*s*o+u*i,t[2]=u*s*o-l*i,t[3]=0,t[4]=s*l*o-u*i,t[5]=l*l*o+a,t[6]=u*l*o+s*i,t[7]=0,t[8]=s*u*o+l*i,t[9]=l*u*o-s*i,t[10]=u*u*o+a,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t)},i.fromXRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=n,t[6]=r,t[7]=0,t[8]=0,t[9]=-r,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromYRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=0,t[2]=-r,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=r,t[9]=0,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromZRotation=function(t,e){var r=Math.sin(e),n=Math.cos(e);return t[0]=n,t[1]=r,t[2]=0,t[3]=0,t[4]=-r,t[5]=n,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.fromRotationTranslation=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=n+n,l=i+i,u=a+a,c=n*s,h=n*l,f=n*u,d=i*l,p=i*u,m=a*u,v=o*s,g=o*l,y=o*u;return t[0]=1-(d+m),t[1]=h+y,t[2]=f-g,t[3]=0,t[4]=h-y,t[5]=1-(c+m),t[6]=p+v,t[7]=0,t[8]=f+g,t[9]=p-v,t[10]=1-(c+d),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},i.getTranslation=function(t,e){return t[0]=e[12],t[1]=e[13],t[2]=e[14],t},i.getRotation=function(t,e){var r=e[0]+e[5]+e[10],n=0;return r>0?(n=2*Math.sqrt(r+1),t[3]=.25*n,t[0]=(e[6]-e[9])/n,t[1]=(e[8]-e[2])/n,t[2]=(e[1]-e[4])/n):e[0]>e[5]&e[0]>e[10]?(n=2*Math.sqrt(1+e[0]-e[5]-e[10]),t[3]=(e[6]-e[9])/n,t[0]=.25*n,t[1]=(e[1]+e[4])/n,t[2]=(e[8]+e[2])/n):e[5]>e[10]?(n=2*Math.sqrt(1+e[5]-e[0]-e[10]),t[3]=(e[8]-e[2])/n,t[0]=(e[1]+e[4])/n,t[1]=.25*n,t[2]=(e[6]+e[9])/n):(n=2*Math.sqrt(1+e[10]-e[0]-e[5]),t[3]=(e[1]-e[4])/n,t[0]=(e[8]+e[2])/n,t[1]=(e[6]+e[9])/n,t[2]=.25*n),t},i.fromRotationTranslationScale=function(t,e,r,n){var i=e[0],a=e[1],o=e[2],s=e[3],l=i+i,u=a+a,c=o+o,h=i*l,f=i*u,d=i*c,p=a*u,m=a*c,v=o*c,g=s*l,y=s*u,b=s*c,x=n[0],_=n[1],w=n[2];return t[0]=(1-(p+v))*x,t[1]=(f+b)*x,t[2]=(d-y)*x,t[3]=0,t[4]=(f-b)*_,t[5]=(1-(h+v))*_,t[6]=(m+g)*_,t[7]=0,t[8]=(d+y)*w,t[9]=(m-g)*w,t[10]=(1-(h+p))*w,t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},i.fromRotationTranslationScaleOrigin=function(t,e,r,n,i){var a=e[0],o=e[1],s=e[2],l=e[3],u=a+a,c=o+o,h=s+s,f=a*u,d=a*c,p=a*h,m=o*c,v=o*h,g=s*h,y=l*u,b=l*c,x=l*h,_=n[0],w=n[1],M=n[2],k=i[0],A=i[1],T=i[2];return t[0]=(1-(m+g))*_,t[1]=(d+x)*_,t[2]=(p-b)*_,t[3]=0,t[4]=(d-x)*w,t[5]=(1-(f+g))*w,t[6]=(v+y)*w,t[7]=0,t[8]=(p+b)*M,t[9]=(v-y)*M,t[10]=(1-(f+m))*M,t[11]=0,t[12]=r[0]+k-(t[0]*k+t[4]*A+t[8]*T),t[13]=r[1]+A-(t[1]*k+t[5]*A+t[9]*T),t[14]=r[2]+T-(t[2]*k+t[6]*A+t[10]*T),t[15]=1,t},i.fromQuat=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r+r,s=n+n,l=i+i,u=r*o,c=n*o,h=n*s,f=i*o,d=i*s,p=i*l,m=a*o,v=a*s,g=a*l;return t[0]=1-h-p,t[1]=c+g,t[2]=f-v,t[3]=0,t[4]=c-g,t[5]=1-u-p,t[6]=d+m,t[7]=0,t[8]=f+v,t[9]=d-m,t[10]=1-u-h,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},i.frustum=function(t,e,r,n,i,a,o){var s=1/(r-e),l=1/(i-n),u=1/(a-o);return t[0]=2*a*s,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*a*l,t[6]=0,t[7]=0,t[8]=(r+e)*s,t[9]=(i+n)*l,t[10]=(o+a)*u,t[11]=-1,t[12]=0,t[13]=0,t[14]=o*a*2*u,t[15]=0,t},i.perspective=function(t,e,r,n,i){var a=1/Math.tan(e/2),o=1/(n-i);return t[0]=a/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=(i+n)*o,t[11]=-1,t[12]=0,t[13]=0,t[14]=2*i*n*o,t[15]=0,t},i.perspectiveFromFieldOfView=function(t,e,r,n){var i=Math.tan(e.upDegrees*Math.PI/180),a=Math.tan(e.downDegrees*Math.PI/180),o=Math.tan(e.leftDegrees*Math.PI/180),s=Math.tan(e.rightDegrees*Math.PI/180),l=2/(o+s),u=2/(i+a);return t[0]=l,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=-(o-s)*l*.5,t[9]=(i-a)*u*.5,t[10]=n/(r-n),t[11]=-1,t[12]=0,t[13]=0,t[14]=n*r/(r-n),t[15]=0,t},i.ortho=function(t,e,r,n,i,a,o){var s=1/(e-r),l=1/(n-i),u=1/(a-o);return t[0]=-2*s,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*l,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*u,t[11]=0,t[12]=(e+r)*s,t[13]=(i+n)*l,t[14]=(o+a)*u,t[15]=1,t},i.lookAt=function(t,e,r,a){var o,s,l,u,c,h,f,d,p,m,v=e[0],g=e[1],y=e[2],b=a[0],x=a[1],_=a[2],w=r[0],M=r[1],k=r[2];return Math.abs(v-w)<n.EPSILON&&Math.abs(g-M)<n.EPSILON&&Math.abs(y-k)<n.EPSILON?i.identity(t):(f=v-w,d=g-M,p=y-k,m=1/Math.sqrt(f*f+d*d+p*p),f*=m,d*=m,p*=m,o=x*p-_*d,s=_*f-b*p,l=b*d-x*f,m=Math.sqrt(o*o+s*s+l*l),m?(m=1/m,o*=m,s*=m,l*=m):(o=0,s=0,l=0),u=d*l-p*s,c=p*o-f*l,h=f*s-d*o,m=Math.sqrt(u*u+c*c+h*h),m?(m=1/m,u*=m,c*=m,h*=m):(u=0,c=0,h=0),t[0]=o,t[1]=u,t[2]=f,t[3]=0,t[4]=s,t[5]=c,t[6]=d,t[7]=0,t[8]=l,t[9]=h,t[10]=p,t[11]=0,t[12]=-(o*v+s*g+l*y),t[13]=-(u*v+c*g+h*y),t[14]=-(f*v+d*g+p*y),t[15]=1,t)},i.str=function(t){return\"mat4(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\", \"+t[4]+\", \"+t[5]+\", \"+t[6]+\", \"+t[7]+\", \"+t[8]+\", \"+t[9]+\", \"+t[10]+\", \"+t[11]+\", \"+t[12]+\", \"+t[13]+\", \"+t[14]+\", \"+t[15]+\")\"},i.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2)+Math.pow(t[9],2)+Math.pow(t[10],2)+Math.pow(t[11],2)+Math.pow(t[12],2)+Math.pow(t[13],2)+Math.pow(t[14],2)+Math.pow(t[15],2))},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t[4]=e[4]+r[4],t[5]=e[5]+r[5],t[6]=e[6]+r[6],t[7]=e[7]+r[7],t[8]=e[8]+r[8],t[9]=e[9]+r[9],t[10]=e[10]+r[10],t[11]=e[11]+r[11],t[12]=e[12]+r[12],t[13]=e[13]+r[13],t[14]=e[14]+r[14],t[15]=e[15]+r[15],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t[4]=e[4]-r[4],t[5]=e[5]-r[5],t[6]=e[6]-r[6],t[7]=e[7]-r[7],t[8]=e[8]-r[8],t[9]=e[9]-r[9],t[10]=e[10]-r[10],t[11]=e[11]-r[11],t[12]=e[12]-r[12],t[13]=e[13]-r[13],t[14]=e[14]-r[14],t[15]=e[15]-r[15],t},i.sub=i.subtract,i.multiplyScalar=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t[4]=e[4]*r,t[5]=e[5]*r,t[6]=e[6]*r,t[7]=e[7]*r,t[8]=e[8]*r,t[9]=e[9]*r,t[10]=e[10]*r,t[11]=e[11]*r,t[12]=e[12]*r,t[13]=e[13]*r,t[14]=e[14]*r,t[15]=e[15]*r,t},i.multiplyScalarAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t[4]=e[4]+r[4]*n,t[5]=e[5]+r[5]*n,t[6]=e[6]+r[6]*n,t[7]=e[7]+r[7]*n,t[8]=e[8]+r[8]*n,t[9]=e[9]+r[9]*n,t[10]=e[10]+r[10]*n,t[11]=e[11]+r[11]*n,t[12]=e[12]+r[12]*n,t[13]=e[13]+r[13]*n,t[14]=e[14]+r[14]*n,t[15]=e[15]+r[15]*n,t},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]&&t[9]===e[9]&&t[10]===e[10]&&t[11]===e[11]&&t[12]===e[12]&&t[13]===e[13]&&t[14]===e[14]&&t[15]===e[15]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=t[4],l=t[5],u=t[6],c=t[7],h=t[8],f=t[9],d=t[10],p=t[11],m=t[12],v=t[13],g=t[14],y=t[15],b=e[0],x=e[1],_=e[2],w=e[3],M=e[4],k=e[5],A=e[6],T=e[7],S=e[8],E=e[9],L=e[10],C=e[11],z=e[12],I=e[13],D=e[14],P=e[15];return Math.abs(r-b)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(b))&&Math.abs(i-x)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(x))&&Math.abs(a-_)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(_))&&Math.abs(o-w)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(w))&&Math.abs(s-M)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(M))&&Math.abs(l-k)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(k))&&Math.abs(u-A)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(A))&&Math.abs(c-T)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(T))&&Math.abs(h-S)<=n.EPSILON*Math.max(1,Math.abs(h),Math.abs(S))&&Math.abs(f-E)<=n.EPSILON*Math.max(1,Math.abs(f),Math.abs(E))&&Math.abs(d-L)<=n.EPSILON*Math.max(1,Math.abs(d),Math.abs(L))&&Math.abs(p-C)<=n.EPSILON*Math.max(1,Math.abs(p),Math.abs(C))&&Math.abs(m-z)<=n.EPSILON*Math.max(1,Math.abs(m),Math.abs(z))&&Math.abs(v-I)<=n.EPSILON*Math.max(1,Math.abs(v),Math.abs(I))&&Math.abs(g-D)<=n.EPSILON*Math.max(1,Math.abs(g),Math.abs(D))&&Math.abs(y-P)<=n.EPSILON*Math.max(1,Math.abs(y),Math.abs(P))},e.exports=i},{\"./common.js\":193}],198:[function(t,e,r){var n=t(\"./common.js\"),i=t(\"./mat3.js\"),a=t(\"./vec3.js\"),o=t(\"./vec4.js\"),s={};s.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},s.rotationTo=function(){var t=a.create(),e=a.fromValues(1,0,0),r=a.fromValues(0,1,0);return function(n,i,o){var l=a.dot(i,o);return l<-.999999?(a.cross(t,e,i),a.length(t)<1e-6&&a.cross(t,r,i),a.normalize(t,t),s.setAxisAngle(n,t,Math.PI),n):l>.999999?(n[0]=0,n[1]=0,n[2]=0,n[3]=1,n):(a.cross(t,i,o),n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=1+l,s.normalize(n,n))}}(),s.setAxes=function(){var t=i.create();return function(e,r,n,i){return t[0]=n[0],t[3]=n[1],t[6]=n[2],t[1]=i[0],t[4]=i[1],t[7]=i[2],t[2]=-r[0],t[5]=-r[1],t[8]=-r[2],s.normalize(e,s.fromMat3(e,t))}}(),s.clone=o.clone,s.fromValues=o.fromValues,s.copy=o.copy,s.set=o.set,s.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},s.setAxisAngle=function(t,e,r){r*=.5;var n=Math.sin(r);return t[0]=n*e[0],t[1]=n*e[1],t[2]=n*e[2],t[3]=Math.cos(r),t},s.getAxisAngle=function(t,e){var r=2*Math.acos(e[3]),n=Math.sin(r/2);return 0!=n?(t[0]=e[0]/n,t[1]=e[1]/n,t[2]=e[2]/n):(t[0]=1,t[1]=0,t[2]=0),r},s.add=o.add,s.multiply=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3],s=r[0],l=r[1],u=r[2],c=r[3];return t[0]=n*c+o*s+i*u-a*l,t[1]=i*c+o*l+a*s-n*u,t[2]=a*c+o*u+n*l-i*s,t[3]=o*c-n*s-i*l-a*u,t},s.mul=s.multiply,s.scale=o.scale,s.rotateX=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+o*s,t[1]=i*l+a*s,t[2]=a*l-i*s,t[3]=o*l-n*s,t},s.rotateY=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l-a*s,t[1]=i*l+o*s,t[2]=a*l+n*s,t[3]=o*l-i*s,t},s.rotateZ=function(t,e,r){r*=.5;var n=e[0],i=e[1],a=e[2],o=e[3],s=Math.sin(r),l=Math.cos(r);return t[0]=n*l+i*s,t[1]=i*l-n*s,t[2]=a*l+o*s,t[3]=o*l-a*s,t},s.calculateW=function(t,e){var r=e[0],n=e[1],i=e[2];return t[0]=r,t[1]=n,t[2]=i,t[3]=Math.sqrt(Math.abs(1-r*r-n*n-i*i)),t},s.dot=o.dot,s.lerp=o.lerp,s.slerp=function(t,e,r,n){var i,a,o,s,l,u=e[0],c=e[1],h=e[2],f=e[3],d=r[0],p=r[1],m=r[2],v=r[3];return a=u*d+c*p+h*m+f*v,a<0&&(a=-a,d=-d,p=-p,m=-m,v=-v),1-a>1e-6?(i=Math.acos(a),o=Math.sin(i),s=Math.sin((1-n)*i)/o,l=Math.sin(n*i)/o):(s=1-n,l=n),t[0]=s*u+l*d,t[1]=s*c+l*p,t[2]=s*h+l*m,t[3]=s*f+l*v,t},s.sqlerp=function(){var t=s.create(),e=s.create();return function(r,n,i,a,o,l){return s.slerp(t,n,o,l),s.slerp(e,i,a,l),s.slerp(r,t,e,2*l*(1-l)),r}}(),s.invert=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*r+n*n+i*i+a*a,s=o?1/o:0;return t[0]=-r*s,t[1]=-n*s,t[2]=-i*s,t[3]=a*s,t},s.conjugate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=e[3],t},s.length=o.length,s.len=s.length,s.squaredLength=o.squaredLength,s.sqrLen=s.squaredLength,s.normalize=o.normalize,s.fromMat3=function(t,e){var r,n=e[0]+e[4]+e[8];if(n>0)r=Math.sqrt(n+1),t[3]=.5*r,r=.5/r,t[0]=(e[5]-e[7])*r,t[1]=(e[6]-e[2])*r,t[2]=(e[1]-e[3])*r;else{var i=0;e[4]>e[0]&&(i=1),e[8]>e[3*i+i]&&(i=2);var a=(i+1)%3,o=(i+2)%3;r=Math.sqrt(e[3*i+i]-e[3*a+a]-e[3*o+o]+1),t[i]=.5*r,r=.5/r,t[3]=(e[3*a+o]-e[3*o+a])*r,t[a]=(e[3*a+i]+e[3*i+a])*r,t[o]=(e[3*o+i]+e[3*i+o])*r}return t},s.str=function(t){return\"quat(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},s.exactEquals=o.exactEquals,s.equals=o.equals,e.exports=s},{\"./common.js\":193,\"./mat3.js\":196,\"./vec3.js\":200,\"./vec4.js\":201}],199:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(2);return t[0]=0,t[1]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(2);return e[0]=t[0],e[1]=t[1],e},i.fromValues=function(t,e){var r=new n.ARRAY_TYPE(2);return r[0]=t,r[1]=e,r},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t},i.set=function(t,e,r){return t[0]=e,t[1]=r,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1];return Math.sqrt(r*r+n*n)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1];return r*r+n*n},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1];return Math.sqrt(e*e+r*r)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1];return e*e+r*r},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=r*r+n*n;return i>0&&(i=1/Math.sqrt(i),t[0]=e[0]*i,t[1]=e[1]*i),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]},i.cross=function(t,e,r){var n=e[0]*r[1]-e[1]*r[0];return t[0]=t[1]=0,t[2]=n,t},i.lerp=function(t,e,r,n){var i=e[0],a=e[1];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t},i.random=function(t,e){e=e||1;var r=2*n.RANDOM()*Math.PI;return t[0]=Math.cos(r)*e,t[1]=Math.sin(r)*e,t},i.transformMat2=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[2]*i,t[1]=r[1]*n+r[3]*i,t},i.transformMat2d=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[2]*i+r[4],t[1]=r[1]*n+r[3]*i+r[5],t},i.transformMat3=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[3]*i+r[6],t[1]=r[1]*n+r[4]*i+r[7],t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1];return t[0]=r[0]*n+r[4]*i+r[12],t[1]=r[1]*n+r[5]*i+r[13],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=2),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],a(t,t,o),e[s]=t[0],e[s+1]=t[1];return e}}(),i.str=function(t){return\"vec2(\"+t[0]+\", \"+t[1]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]},i.equals=function(t,e){var r=t[0],i=t[1],a=e[0],o=e[1];return Math.abs(r-a)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(a))&&Math.abs(i-o)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(o))},e.exports=i},{\"./common.js\":193}],200:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(3);return t[0]=0,t[1]=0,t[2]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(3);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},i.fromValues=function(t,e,r){var i=new n.ARRAY_TYPE(3);return i[0]=t,i[1]=e,i[2]=r,i},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},i.set=function(t,e,r,n){return t[0]=e,t[1]=r,t[2]=n,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t[2]=e[2]*r[2],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t[2]=e[2]/r[2],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t[2]=Math.min(e[2],r[2]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t[2]=Math.max(e[2],r[2]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2];return Math.sqrt(r*r+n*n+i*i)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2];return r*r+n*n+i*i},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1],n=t[2];return Math.sqrt(e*e+r*r+n*n)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1],n=t[2];return e*e+r*r+n*n},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=e[2],a=r*r+n*n+i*i;return a>0&&(a=1/Math.sqrt(a),t[0]=e[0]*a,t[1]=e[1]*a,t[2]=e[2]*a),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]},i.cross=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2];return t[0]=i*l-a*s,t[1]=a*o-n*l,t[2]=n*s-i*o,t},i.lerp=function(t,e,r,n){var i=e[0],a=e[1],o=e[2];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t},i.hermite=function(t,e,r,n,i,a){var o=a*a,s=o*(2*a-3)+1,l=o*(a-2)+a,u=o*(a-1),c=o*(3-2*a);return t[0]=e[0]*s+r[0]*l+n[0]*u+i[0]*c,t[1]=e[1]*s+r[1]*l+n[1]*u+i[1]*c,t[2]=e[2]*s+r[2]*l+n[2]*u+i[2]*c,t},i.bezier=function(t,e,r,n,i,a){var o=1-a,s=o*o,l=a*a,u=s*o,c=3*a*s,h=3*l*o,f=l*a;return t[0]=e[0]*u+r[0]*c+n[0]*h+i[0]*f,t[1]=e[1]*u+r[1]*c+n[1]*h+i[1]*f,t[2]=e[2]*u+r[2]*c+n[2]*h+i[2]*f,t},i.random=function(t,e){e=e||1;var r=2*n.RANDOM()*Math.PI,i=2*n.RANDOM()-1,a=Math.sqrt(1-i*i)*e;return t[0]=Math.cos(r)*a,t[1]=Math.sin(r)*a,t[2]=i*e,t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[3]*n+r[7]*i+r[11]*a+r[15];return o=o||1,t[0]=(r[0]*n+r[4]*i+r[8]*a+r[12])/o,t[1]=(r[1]*n+r[5]*i+r[9]*a+r[13])/o,t[2]=(r[2]*n+r[6]*i+r[10]*a+r[14])/o,t},i.transformMat3=function(t,e,r){var n=e[0],i=e[1],a=e[2];return t[0]=n*r[0]+i*r[3]+a*r[6],t[1]=n*r[1]+i*r[4]+a*r[7],t[2]=n*r[2]+i*r[5]+a*r[8],t},i.transformQuat=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2],u=r[3],c=u*n+s*a-l*i,h=u*i+l*n-o*a,f=u*a+o*i-s*n,d=-o*n-s*i-l*a;return t[0]=c*u+d*-o+h*-l-f*-s,t[1]=h*u+d*-s+f*-o-c*-l,t[2]=f*u+d*-l+c*-s-h*-o,t},i.rotateX=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[0],a[1]=i[1]*Math.cos(n)-i[2]*Math.sin(n),a[2]=i[1]*Math.sin(n)+i[2]*Math.cos(n),t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.rotateY=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[2]*Math.sin(n)+i[0]*Math.cos(n),a[1]=i[1],a[2]=i[2]*Math.cos(n)-i[0]*Math.sin(n),t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.rotateZ=function(t,e,r,n){var i=[],a=[];return i[0]=e[0]-r[0],i[1]=e[1]-r[1],i[2]=e[2]-r[2],a[0]=i[0]*Math.cos(n)-i[1]*Math.sin(n),a[1]=i[0]*Math.sin(n)+i[1]*Math.cos(n),a[2]=i[2],t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=3),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],t[2]=e[s+2],a(t,t,o),e[s]=t[0],e[s+1]=t[1],e[s+2]=t[2];return e}}(),i.angle=function(t,e){var r=i.fromValues(t[0],t[1],t[2]),n=i.fromValues(e[0],e[1],e[2]);i.normalize(r,r),i.normalize(n,n);var a=i.dot(r,n);return a>1?0:Math.acos(a)},i.str=function(t){return\"vec3(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=e[0],s=e[1],l=e[2];return Math.abs(r-o)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(o))&&Math.abs(i-s)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(s))&&Math.abs(a-l)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(l))},e.exports=i},{\"./common.js\":193}],201:[function(t,e,r){var n=t(\"./common.js\"),i={};i.create=function(){var t=new n.ARRAY_TYPE(4);return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},i.clone=function(t){var e=new n.ARRAY_TYPE(4);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e},i.fromValues=function(t,e,r,i){var a=new n.ARRAY_TYPE(4);return a[0]=t,a[1]=e,a[2]=r,a[3]=i,a},i.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t},i.set=function(t,e,r,n,i){return t[0]=e,t[1]=r,t[2]=n,t[3]=i,t},i.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t[3]=e[3]+r[3],t},i.subtract=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t[3]=e[3]-r[3],t},i.sub=i.subtract,i.multiply=function(t,e,r){return t[0]=e[0]*r[0],t[1]=e[1]*r[1],t[2]=e[2]*r[2],t[3]=e[3]*r[3],t},i.mul=i.multiply,i.divide=function(t,e,r){return t[0]=e[0]/r[0],t[1]=e[1]/r[1],t[2]=e[2]/r[2],t[3]=e[3]/r[3],t},i.div=i.divide,i.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t[3]=Math.ceil(e[3]),t},i.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t[3]=Math.floor(e[3]),t},i.min=function(t,e,r){return t[0]=Math.min(e[0],r[0]),t[1]=Math.min(e[1],r[1]),t[2]=Math.min(e[2],r[2]),t[3]=Math.min(e[3],r[3]),t},i.max=function(t,e,r){return t[0]=Math.max(e[0],r[0]),t[1]=Math.max(e[1],r[1]),t[2]=Math.max(e[2],r[2]),t[3]=Math.max(e[3],r[3]),t},i.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t[3]=Math.round(e[3]),t},i.scale=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t},i.scaleAndAdd=function(t,e,r,n){return t[0]=e[0]+r[0]*n,t[1]=e[1]+r[1]*n,t[2]=e[2]+r[2]*n,t[3]=e[3]+r[3]*n,t},i.distance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2],a=e[3]-t[3];return Math.sqrt(r*r+n*n+i*i+a*a)},i.dist=i.distance,i.squaredDistance=function(t,e){var r=e[0]-t[0],n=e[1]-t[1],i=e[2]-t[2],a=e[3]-t[3];return r*r+n*n+i*i+a*a},i.sqrDist=i.squaredDistance,i.length=function(t){var e=t[0],r=t[1],n=t[2],i=t[3];return Math.sqrt(e*e+r*r+n*n+i*i)},i.len=i.length,i.squaredLength=function(t){var e=t[0],r=t[1],n=t[2],i=t[3];return e*e+r*r+n*n+i*i},i.sqrLen=i.squaredLength,i.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t},i.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],\n",
       "t[3]=1/e[3],t},i.normalize=function(t,e){var r=e[0],n=e[1],i=e[2],a=e[3],o=r*r+n*n+i*i+a*a;return o>0&&(o=1/Math.sqrt(o),t[0]=r*o,t[1]=n*o,t[2]=i*o,t[3]=a*o),t},i.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]},i.lerp=function(t,e,r,n){var i=e[0],a=e[1],o=e[2],s=e[3];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t[3]=s+n*(r[3]-s),t},i.random=function(t,e){return e=e||1,t[0]=n.RANDOM(),t[1]=n.RANDOM(),t[2]=n.RANDOM(),t[3]=n.RANDOM(),i.normalize(t,t),i.scale(t,t,e),t},i.transformMat4=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t},i.transformQuat=function(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2],u=r[3],c=u*n+s*a-l*i,h=u*i+l*n-o*a,f=u*a+o*i-s*n,d=-o*n-s*i-l*a;return t[0]=c*u+d*-o+h*-l-f*-s,t[1]=h*u+d*-s+f*-o-c*-l,t[2]=f*u+d*-l+c*-s-h*-o,t[3]=e[3],t},i.forEach=function(){var t=i.create();return function(e,r,n,i,a,o){var s,l;for(r||(r=4),n||(n=0),l=i?Math.min(i*r+n,e.length):e.length,s=n;s<l;s+=r)t[0]=e[s],t[1]=e[s+1],t[2]=e[s+2],t[3]=e[s+3],a(t,t,o),e[s]=t[0],e[s+1]=t[1],e[s+2]=t[2],e[s+3]=t[3];return e}}(),i.str=function(t){return\"vec4(\"+t[0]+\", \"+t[1]+\", \"+t[2]+\", \"+t[3]+\")\"},i.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]},i.equals=function(t,e){var r=t[0],i=t[1],a=t[2],o=t[3],s=e[0],l=e[1],u=e[2],c=e[3];return Math.abs(r-s)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(i-l)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(l))&&Math.abs(a-u)<=n.EPSILON*Math.max(1,Math.abs(a),Math.abs(u))&&Math.abs(o-c)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(c))},e.exports=i},{\"./common.js\":193}],202:[function(t,e,r){\"use strict\";function n(t,e){for(var r=[0,0,0,0],n=0;n<4;++n)for(var i=0;i<4;++i)r[i]+=t[4*n+i]*e[n];return r}function i(t,e,r,i,a){for(var o=n(i,n(r,n(e,[t[0],t[1],t[2],1]))),s=0;s<3;++s)o[s]/=o[3];return[.5*a[0]*(1+o[0]),.5*a[1]*(1-o[1])]}function a(t,e){if(2===t.length){for(var r=0,n=0,i=0;i<2;++i)r+=Math.pow(e[i]-t[0][i],2),n+=Math.pow(e[i]-t[1][i],2);return r=Math.sqrt(r),n=Math.sqrt(n),r+n<1e-6?[1,0]:[n/(r+n),r/(n+r)]}if(3===t.length){var a=[0,0];return u(t[0],t[1],t[2],e,a),l(t,a)}return[]}function o(t,e){for(var r=[0,0,0],n=0;n<t.length;++n)for(var i=t[n],a=e[n],o=0;o<3;++o)r[o]+=a*i[o];return r}function s(t,e,r,n,s,l){if(1===t.length)return[0,t[0].slice()];for(var u=new Array(t.length),c=0;c<t.length;++c)u[c]=i(t[c],r,n,s,l);for(var h=0,f=1/0,c=0;c<u.length;++c){for(var d=0,p=0;p<2;++p)d+=Math.pow(u[c][p]-e[p],2);d<f&&(f=d,h=c)}for(var m=a(u,e),v=0,c=0;c<3;++c){if(m[c]<-.001||m[c]>1.0001)return null;v+=m[c]}return Math.abs(v-1)>.001?null:[h,o(t,m),m]}var l=t(\"barycentric\"),u=t(\"polytope-closest-point/lib/closest_point_2d.js\");e.exports=s},{barycentric:48,\"polytope-closest-point/lib/closest_point_2d.js\":485}],203:[function(t,e,r){var n=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3  clipBounds[2];\\nuniform float pickId;\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  if(any(lessThan(f_position, clipBounds[0])) || \\n     any(greaterThan(f_position, clipBounds[1]))) {\\n    discard;\\n  }\\n  gl_FragColor = vec4(pickId, f_id.xyz);\\n}\";r.meshShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, normal;\\nattribute vec4 color;\\nattribute vec2 uv;\\n\\nuniform mat4 model\\n           , view\\n           , projection;\\nuniform vec3 eyePosition\\n           , lightPosition;\\n\\nvarying vec3 f_normal\\n           , f_lightDirection\\n           , f_eyeDirection\\n           , f_data;\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  vec4 m_position  = model * vec4(position, 1.0);\\n  vec4 t_position  = view * m_position;\\n  gl_Position      = projection * t_position;\\n  f_color          = color;\\n  f_normal         = normal;\\n  f_data           = position;\\n  f_eyeDirection   = eyePosition   - position;\\n  f_lightDirection = lightPosition - position;\\n  f_uv             = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nfloat beckmannDistribution_2_0(float x, float roughness) {\\n  float NdotH = max(x, 0.0001);\\n  float cos2Alpha = NdotH * NdotH;\\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\\n  float roughness2 = roughness * roughness;\\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\\n  return exp(tan2Alpha / roughness2) / denom;\\n}\\n\\n\\n\\nfloat cookTorranceSpecular_1_1(\\n  vec3 lightDirection,\\n  vec3 viewDirection,\\n  vec3 surfaceNormal,\\n  float roughness,\\n  float fresnel) {\\n\\n  float VdotN = max(dot(viewDirection, surfaceNormal), 0.0);\\n  float LdotN = max(dot(lightDirection, surfaceNormal), 0.0);\\n\\n  //Half angle vector\\n  vec3 H = normalize(lightDirection + viewDirection);\\n\\n  //Geometric term\\n  float NdotH = max(dot(surfaceNormal, H), 0.0);\\n  float VdotH = max(dot(viewDirection, H), 0.000001);\\n  float LdotH = max(dot(lightDirection, H), 0.000001);\\n  float G1 = (2.0 * NdotH * VdotN) / VdotH;\\n  float G2 = (2.0 * NdotH * LdotN) / LdotH;\\n  float G = min(1.0, min(G1, G2));\\n  \\n  //Distribution term\\n  float D = beckmannDistribution_2_0(NdotH, roughness);\\n\\n  //Fresnel term\\n  float F = pow(1.0 - VdotN, fresnel);\\n\\n  //Multiply terms and done\\n  return  G * F * D / max(3.14159265 * VdotN, 0.000001);\\n}\\n\\n\\n\\nuniform vec3 clipBounds[2];\\nuniform float roughness\\n            , fresnel\\n            , kambient\\n            , kdiffuse\\n            , kspecular\\n            , opacity;\\nuniform sampler2D texture;\\n\\nvarying vec3 f_normal\\n           , f_lightDirection\\n           , f_eyeDirection\\n           , f_data;\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(f_data, clipBounds[0])) || \\n     any(greaterThan(f_data, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  vec3 N = normalize(f_normal);\\n  vec3 L = normalize(f_lightDirection);\\n  vec3 V = normalize(f_eyeDirection);\\n  \\n  if(!gl_FrontFacing) {\\n    N = -N;\\n  }\\n\\n  float specular = cookTorranceSpecular_1_1(L, V, N, roughness, fresnel);\\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\\n\\n  vec4 surfaceColor = f_color * texture2D(texture, f_uv);\\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\\n\\n  gl_FragColor = litColor * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"}]},r.wireShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 uv;\\n\\nuniform mat4 model, view, projection;\\n\\nvarying vec4 f_color;\\nvarying vec3 f_data;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n  f_color = color;\\n  f_data  = position;\\n  f_uv    = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 clipBounds[2];\\nuniform sampler2D texture;\\nuniform float opacity;\\n\\nvarying vec4 f_color;\\nvarying vec3 f_data;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(f_data, clipBounds[0])) || \\n     any(greaterThan(f_data, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"}]},r.pointShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 uv;\\nattribute float pointSize;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || \\n     any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    gl_Position = projection * view * model * vec4(position, 1.0);\\n  }\\n  gl_PointSize = pointSize;\\n  f_color = color;\\n  f_uv = uv;\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D texture;\\nuniform float opacity;\\n\\nvarying vec4 f_color;\\nvarying vec2 f_uv;\\n\\nvoid main() {\\n  vec2 pointR = gl_PointCoord.xy - vec2(0.5,0.5);\\n  if(dot(pointR, pointR) > 0.25) {\\n    discard;\\n  }\\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\\n}\",attributes:[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"uv\",type:\"vec2\"},{name:\"pointSize\",type:\"float\"}]},r.pickShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 id;\\n\\nuniform mat4 model, view, projection;\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n  f_id        = id;\\n  f_position  = position;\\n}\",fragment:n,attributes:[{name:\"position\",type:\"vec3\"},{name:\"id\",type:\"vec4\"}]},r.pointPickShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3  position;\\nattribute float pointSize;\\nattribute vec4  id;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec3 f_position;\\nvarying vec4 f_id;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || \\n     any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    gl_Position  = projection * view * model * vec4(position, 1.0);\\n    gl_PointSize = pointSize;\\n  }\\n  f_id         = id;\\n  f_position   = position;\\n}\",fragment:n,attributes:[{name:\"position\",type:\"vec3\"},{name:\"pointSize\",type:\"float\"},{name:\"id\",type:\"vec4\"}]},r.contourShader={vertex:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\n\\nuniform mat4 model, view, projection;\\n\\nvoid main() {\\n  gl_Position = projection * view * model * vec4(position, 1.0);\\n}\",fragment:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 contourColor;\\n\\nvoid main() {\\n  gl_FragColor = vec4(contourColor,1);\\n}\\n\",attributes:[{name:\"position\",type:\"vec3\"}]}},{}],204:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_,w,M,k,A,T){this.gl=t,this.cells=[],this.positions=[],this.intensity=[],this.texture=e,this.dirty=!0,this.triShader=r,this.lineShader=n,this.pointShader=i,this.pickShader=a,this.pointPickShader=o,this.contourShader=s,this.trianglePositions=l,this.triangleColors=c,this.triangleNormals=f,this.triangleUVs=h,this.triangleIds=u,this.triangleVAO=d,this.triangleCount=0,this.lineWidth=1,this.edgePositions=p,this.edgeColors=v,this.edgeUVs=g,this.edgeIds=m,this.edgeVAO=y,this.edgeCount=0,this.pointPositions=b,this.pointColors=_,this.pointUVs=w,this.pointSizes=M,this.pointIds=x,this.pointVAO=k,this.pointCount=0,this.contourLineWidth=1,this.contourPositions=A,this.contourVAO=T,this.contourCount=0,this.contourColor=[0,0,0],this.contourEnable=!0,this.pickId=1,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.lightPosition=[1e5,1e5,0],this.ambientLight=.8,this.diffuseLight=.8,this.specularLight=2,this.roughness=.5,this.fresnel=1.5,this.opacity=1,this._model=D,this._view=D,this._projection=D,this._resolution=[1,1]}function i(t){for(var e=w({colormap:t,nshades:256,format:\"rgba\"}),r=new Uint8Array(1024),n=0;n<256;++n){for(var i=e[n],a=0;a<3;++a)r[4*n+a]=i[a];r[4*n+3]=255*i[3]}return _(r,[256,256,4],[4,0,1])}function a(t,e,r){for(var n=new Array(e),i=0;i<e;++i)n[i]=0;for(var a=t.length,i=0;i<a;++i)for(var o=t[i],s=0;s<o.length;++s)n[o[s]]=r[i];return n}function o(t){for(var e=t.length,r=new Array(e),n=0;n<e;++n)r[n]=t[n][2];return r}function s(t){var e=p(t,S.vertex,S.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e.attributes.normal.location=4,e}function l(t){var e=p(t,E.vertex,E.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e}function u(t){var e=p(t,L.vertex,L.fragment);return e.attributes.position.location=0,e.attributes.color.location=2,e.attributes.uv.location=3,e.attributes.pointSize.location=4,e}function c(t){var e=p(t,C.vertex,C.fragment);return e.attributes.position.location=0,e.attributes.id.location=1,e}function h(t){var e=p(t,z.vertex,z.fragment);return e.attributes.position.location=0,e.attributes.id.location=1,e.attributes.pointSize.location=4,e}function f(t){var e=p(t,I.vertex,I.fragment);return e.attributes.position.location=0,e}function d(t,e){1===arguments.length&&(e=t,t=e.gl);var r=s(t),i=l(t),a=u(t),o=c(t),d=h(t),p=f(t),y=g(t,_(new Uint8Array([255,255,255,255]),[1,1,4]));y.generateMipmap(),y.minFilter=t.LINEAR_MIPMAP_LINEAR,y.magFilter=t.LINEAR;var b=m(t),x=m(t),w=m(t),M=m(t),k=m(t),A=v(t,[{buffer:b,type:t.FLOAT,size:3},{buffer:k,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:x,type:t.FLOAT,size:4},{buffer:w,type:t.FLOAT,size:2},{buffer:M,type:t.FLOAT,size:3}]),T=m(t),S=m(t),E=m(t),L=m(t),C=v(t,[{buffer:T,type:t.FLOAT,size:3},{buffer:L,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:S,type:t.FLOAT,size:4},{buffer:E,type:t.FLOAT,size:2}]),z=m(t),I=m(t),D=m(t),P=m(t),O=m(t),R=v(t,[{buffer:z,type:t.FLOAT,size:3},{buffer:O,type:t.UNSIGNED_BYTE,size:4,normalized:!0},{buffer:I,type:t.FLOAT,size:4},{buffer:D,type:t.FLOAT,size:2},{buffer:P,type:t.FLOAT,size:1}]),F=m(t),j=v(t,[{buffer:F,type:t.FLOAT,size:3}]),N=new n(t,y,r,i,a,o,d,p,b,k,x,w,M,A,T,L,S,E,C,z,O,I,D,P,R,F,j);return N.update(e),N}var p=t(\"gl-shader\"),m=t(\"gl-buffer\"),v=t(\"gl-vao\"),g=t(\"gl-texture2d\"),y=t(\"normals\"),b=t(\"gl-mat4/multiply\"),x=t(\"gl-mat4/invert\"),_=t(\"ndarray\"),w=t(\"colormap\"),M=t(\"simplicial-complex-contour\"),k=t(\"typedarray-pool\"),A=t(\"./lib/shaders\"),T=t(\"./lib/closest-point\"),S=A.meshShader,E=A.wireShader,L=A.pointShader,C=A.pickShader,z=A.pointPickShader,I=A.contourShader,D=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],P=n.prototype;P.isOpaque=function(){return this.opacity>=1},P.isTransparent=function(){return this.opacity<1},P.pickSlots=1,P.setPickBase=function(t){this.pickId=t},P.highlight=function(t){if(!t||!this.contourEnable)return void(this.contourCount=0);for(var e=M(this.cells,this.intensity,t.intensity),r=e.cells,n=e.vertexIds,i=e.vertexWeights,a=r.length,o=k.mallocFloat32(6*a),s=0,l=0;l<a;++l)for(var u=r[l],c=0;c<2;++c){var h=u[0];2===u.length&&(h=u[c]);for(var f=n[h][0],d=n[h][1],p=i[h],m=1-p,v=this.positions[f],g=this.positions[d],y=0;y<3;++y)o[s++]=p*v[y]+m*g[y]}this.contourCount=s/3|0,this.contourPositions.update(o.subarray(0,s)),k.free(o)},P.update=function(t){t=t||{};var e=this.gl;this.dirty=!0,\"contourEnable\"in t&&(this.contourEnable=t.contourEnable),\"contourColor\"in t&&(this.contourColor=t.contourColor),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"lightPosition\"in t&&(this.lightPosition=t.lightPosition),\"opacity\"in t&&(this.opacity=t.opacity),\"ambient\"in t&&(this.ambientLight=t.ambient),\"diffuse\"in t&&(this.diffuseLight=t.diffuse),\"specular\"in t&&(this.specularLight=t.specular),\"roughness\"in t&&(this.roughness=t.roughness),\"fresnel\"in t&&(this.fresnel=t.fresnel),t.texture?(this.texture.dispose(),this.texture=g(e,t.texture)):t.colormap&&(this.texture.shape=[256,256],this.texture.minFilter=e.LINEAR_MIPMAP_LINEAR,this.texture.magFilter=e.LINEAR,this.texture.setPixels(i(t.colormap)),this.texture.generateMipmap());var r=t.cells,n=t.positions;if(n&&r){var s=[],l=[],u=[],c=[],h=[],f=[],d=[],p=[],m=[],v=[],b=[],x=[],_=[],w=[];this.cells=r,this.positions=n;var M=t.vertexNormals,k=t.cellNormals,A=void 0===t.vertexNormalsEpsilon?1e-6:t.vertexNormalsEpsilon,T=void 0===t.faceNormalsEpsilon?1e-6:t.faceNormalsEpsilon;t.useFacetNormals&&!k&&(k=y.faceNormals(r,n,T)),k||M||(M=y.vertexNormals(r,n,A));var S=t.vertexColors,E=t.cellColors,L=t.meshColor||[1,1,1,1],C=t.vertexUVs,z=t.vertexIntensity,I=t.cellUVs,D=t.cellIntensity,P=1/0,O=-1/0;if(!C&&!I)if(z)if(t.vertexIntensityBounds)P=+t.vertexIntensityBounds[0],O=+t.vertexIntensityBounds[1];else for(var R=0;R<z.length;++R){var F=z[R];P=Math.min(P,F),O=Math.max(O,F)}else if(D)for(var R=0;R<D.length;++R){var F=D[R];P=Math.min(P,F),O=Math.max(O,F)}else for(var R=0;R<n.length;++R){var F=n[R][2];P=Math.min(P,F),O=Math.max(O,F)}this.intensity=z||(D?a(r,n.length,D):o(n));var j=t.pointSizes,N=t.pointSize||1;this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]];for(var R=0;R<n.length;++R)for(var B=n[R],U=0;U<3;++U)!isNaN(B[U])&&isFinite(B[U])&&(this.bounds[0][U]=Math.min(this.bounds[0][U],B[U]),this.bounds[1][U]=Math.max(this.bounds[1][U],B[U]));var V=0,H=0,q=0;t:for(var R=0;R<r.length;++R){var G=r[R];switch(G.length){case 1:for(var Y=G[0],B=n[Y],U=0;U<3;++U)if(isNaN(B[U])||!isFinite(B[U]))continue t;v.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?b.push(X[0],X[1],X[2],1):b.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],x.push(W[0],W[1]),j?_.push(j[Y]):_.push(N),w.push(R),q+=1;break;case 2:for(var U=0;U<2;++U)for(var Y=G[U],B=n[Y],Z=0;Z<3;++Z)if(isNaN(B[Z])||!isFinite(B[Z]))continue t;for(var U=0;U<2;++U){var Y=G[U],B=n[Y];f.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?d.push(X[0],X[1],X[2],1):d.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],p.push(W[0],W[1]),m.push(R)}H+=1;break;case 3:for(var U=0;U<3;++U)for(var Y=G[U],B=n[Y],Z=0;Z<3;++Z)if(isNaN(B[Z])||!isFinite(B[Z]))continue t;for(var U=0;U<3;++U){var Y=G[U],B=n[Y];s.push(B[0],B[1],B[2]);var X;X=S?S[Y]:E?E[R]:L,3===X.length?l.push(X[0],X[1],X[2],1):l.push(X[0],X[1],X[2],X[3]);var W;W=C?C[Y]:z?[(z[Y]-P)/(O-P),0]:I?I[R]:D?[(D[R]-P)/(O-P),0]:[(B[2]-P)/(O-P),0],c.push(W[0],W[1]);var J;J=M?M[Y]:k[R],u.push(J[0],J[1],J[2]),h.push(R)}V+=1}}this.pointCount=q,this.edgeCount=H,this.triangleCount=V,this.pointPositions.update(v),this.pointColors.update(b),this.pointUVs.update(x),this.pointSizes.update(_),this.pointIds.update(new Uint32Array(w)),this.edgePositions.update(f),this.edgeColors.update(d),this.edgeUVs.update(p),this.edgeIds.update(new Uint32Array(m)),this.trianglePositions.update(s),this.triangleColors.update(l),this.triangleUVs.update(c),this.triangleNormals.update(u),this.triangleIds.update(new Uint32Array(h))}},P.drawTransparent=P.draw=function(t){t=t||{};for(var e=this.gl,r=t.model||D,n=t.view||D,i=t.projection||D,a=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],o=0;o<3;++o)a[0][o]=Math.max(a[0][o],this.clipBounds[0][o]),a[1][o]=Math.min(a[1][o],this.clipBounds[1][o]);var s={model:r,view:n,projection:i,clipBounds:a,kambient:this.ambientLight,kdiffuse:this.diffuseLight,kspecular:this.specularLight,roughness:this.roughness,fresnel:this.fresnel,eyePosition:[0,0,0],lightPosition:[0,0,0],opacity:this.opacity,contourColor:this.contourColor,texture:0};this.texture.bind(0);var l=new Array(16);b(l,s.view,s.model),b(l,s.projection,l),x(l,l);for(var o=0;o<3;++o)s.eyePosition[o]=l[12+o]/l[15];for(var u=l[15],o=0;o<3;++o)u+=this.lightPosition[o]*l[4*o+3];for(var o=0;o<3;++o){for(var c=l[12+o],h=0;h<3;++h)c+=l[4*h+o]*this.lightPosition[h];s.lightPosition[o]=c/u}if(this.triangleCount>0){var f=this.triShader;f.bind(),f.uniforms=s,this.triangleVAO.bind(),e.drawArrays(e.TRIANGLES,0,3*this.triangleCount),this.triangleVAO.unbind()}if(this.edgeCount>0&&this.lineWidth>0){var f=this.lineShader;f.bind(),f.uniforms=s,this.edgeVAO.bind(),e.lineWidth(this.lineWidth),e.drawArrays(e.LINES,0,2*this.edgeCount),this.edgeVAO.unbind()}if(this.pointCount>0){var f=this.pointShader;f.bind(),f.uniforms=s,this.pointVAO.bind(),e.drawArrays(e.POINTS,0,this.pointCount),this.pointVAO.unbind()}if(this.contourEnable&&this.contourCount>0&&this.contourLineWidth>0){var f=this.contourShader;f.bind(),f.uniforms=s,this.contourVAO.bind(),e.drawArrays(e.LINES,0,this.contourCount),this.contourVAO.unbind()}},P.drawPick=function(t){t=t||{};for(var e=this.gl,r=t.model||D,n=t.view||D,i=t.projection||D,a=[[-1e6,-1e6,-1e6],[1e6,1e6,1e6]],o=0;o<3;++o)a[0][o]=Math.max(a[0][o],this.clipBounds[0][o]),a[1][o]=Math.min(a[1][o],this.clipBounds[1][o]);this._model=[].slice.call(r),this._view=[].slice.call(n),this._projection=[].slice.call(i),this._resolution=[e.drawingBufferWidth,e.drawingBufferHeight];var s={model:r,view:n,projection:i,clipBounds:a,pickId:this.pickId/255},l=this.pickShader;if(l.bind(),l.uniforms=s,this.triangleCount>0&&(this.triangleVAO.bind(),e.drawArrays(e.TRIANGLES,0,3*this.triangleCount),this.triangleVAO.unbind()),this.edgeCount>0&&(this.edgeVAO.bind(),e.lineWidth(this.lineWidth),e.drawArrays(e.LINES,0,2*this.edgeCount),this.edgeVAO.unbind()),this.pointCount>0){var l=this.pointPickShader;l.bind(),l.uniforms=s,this.pointVAO.bind(),e.drawArrays(e.POINTS,0,this.pointCount),this.pointVAO.unbind()}},P.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;for(var e=t.value[0]+256*t.value[1]+65536*t.value[2],r=this.cells[e],n=this.positions,i=new Array(r.length),a=0;a<r.length;++a)i[a]=n[r[a]];var o=T(i,[t.coord[0],this._resolution[1]-t.coord[1]],this._model,this._view,this._projection,this._resolution);if(!o)return null;for(var s=o[2],l=0,a=0;a<r.length;++a)l+=s[a]*this.intensity[r[a]];return{position:o[1],index:r[o[0]],cell:r,cellId:e,intensity:l,dataCoordinate:this.positions[r[o[0]]]}},P.dispose=function(){this.texture.dispose(),this.triShader.dispose(),this.lineShader.dispose(),this.pointShader.dispose(),this.pickShader.dispose(),this.pointPickShader.dispose(),this.triangleVAO.dispose(),this.trianglePositions.dispose(),this.triangleColors.dispose(),this.triangleUVs.dispose(),this.triangleNormals.dispose(),this.triangleIds.dispose(),this.edgeVAO.dispose(),this.edgePositions.dispose(),this.edgeColors.dispose(),this.edgeUVs.dispose(),this.edgeIds.dispose(),this.pointVAO.dispose(),this.pointPositions.dispose(),this.pointColors.dispose(),this.pointUVs.dispose(),this.pointSizes.dispose(),this.pointIds.dispose(),this.contourVAO.dispose(),this.contourPositions.dispose(),this.contourShader.dispose()},e.exports=d},{\"./lib/closest-point\":202,\"./lib/shaders\":203,colormap:98,\"gl-buffer\":155,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"gl-shader\":254,\"gl-texture2d\":266,\"gl-vao\":270,ndarray:466,normals:468,\"simplicial-complex-contour\":516,\"typedarray-pool\":540}],205:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r}function i(t){var e=t.gl;return new n(t,a(e,[0,0,0,1,1,0,1,1]),o(e,s.boxVert,s.lineFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"./shaders\"),l=n.prototype;l.bind=function(){var t=this.shader;this.vbo.bind(),this.shader.bind(),t.attributes.coord.pointer(),t.uniforms.screenBox=this.plot.screenBox},l.drawBox=function(){var t=[0,0],e=[0,0];return function(r,n,i,a,o){var s=this.plot,l=this.shader,u=s.gl;t[0]=r,t[1]=n,e[0]=i,e[1]=a,l.uniforms.lo=t,l.uniforms.hi=e,l.uniforms.color=o,u.drawArrays(u.TRIANGLE_STRIP,0,4)}}(),l.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"gl-buffer\":155,\"gl-shader\":211}],206:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.plot=t,this.vbo=e,this.shader=r,this.tickShader=n,this.ticks=[[],[]]}function i(t,e){return t-e}function a(t){var e=t.gl;return new n(t,o(e),s(e,u.gridVert,u.gridFrag),s(e,u.tickVert,u.gridFrag))}e.exports=a;var o=t(\"gl-buffer\"),s=t(\"gl-shader\"),l=t(\"binary-search-bounds\"),u=t(\"./shaders\"),c=n.prototype;c.draw=function(){var t=[0,0],e=[0,0],r=[0,0];return function(){for(var n=this.plot,i=this.vbo,a=this.shader,o=this.ticks,s=n.gl,l=n._tickBounds,u=n.dataBox,c=n.viewBox,h=n.gridLineWidth,f=n.gridLineColor,d=n.gridLineEnable,p=n.pixelRatio,m=0;m<2;++m){var v=l[m],g=l[m+2],y=g-v,b=.5*(u[m+2]+u[m]),x=u[m+2]-u[m];e[m]=2*y/x,t[m]=2*(v-b)/x}a.bind(),i.bind(),a.attributes.dataCoord.pointer(),a.uniforms.dataShift=t,a.uniforms.dataScale=e;for(var _=0,m=0;m<2;++m){r[0]=r[1]=0,r[m]=1,a.uniforms.dataAxis=r,a.uniforms.lineWidth=h[m]/(c[m+2]-c[m])*p,a.uniforms.color=f[m];var w=6*o[m].length;d[m]&&w&&s.drawArrays(s.TRIANGLES,_,w),_+=w}}}(),c.drawTickMarks=function(){var t=[0,0],e=[0,0],r=[1,0],n=[0,1],a=[0,0],o=[0,0];return function(){for(var s=this.plot,u=this.vbo,c=this.tickShader,h=this.ticks,f=s.gl,d=s._tickBounds,p=s.dataBox,m=s.viewBox,v=s.pixelRatio,g=s.screenBox,y=g[2]-g[0],b=g[3]-g[1],x=m[2]-m[0],_=m[3]-m[1],w=0;w<2;++w){var M=d[w],k=d[w+2],A=k-M,T=.5*(p[w+2]+p[w]),S=p[w+2]-p[w];e[w]=2*A/S,t[w]=2*(M-T)/S}e[0]*=x/y,t[0]*=x/y,e[1]*=_/b,t[1]*=_/b,c.bind(),u.bind(),c.attributes.dataCoord.pointer();var E=c.uniforms;E.dataShift=t,E.dataScale=e;var L=s.tickMarkLength,C=s.tickMarkWidth,z=s.tickMarkColor,I=6*h[0].length,D=Math.min(l.ge(h[0],(p[0]-d[0])/(d[2]-d[0]),i),h[0].length),P=Math.min(l.gt(h[0],(p[2]-d[0])/(d[2]-d[0]),i),h[0].length),O=0+6*D,R=6*Math.max(0,P-D),F=Math.min(l.ge(h[1],(p[1]-d[1])/(d[3]-d[1]),i),h[1].length),j=Math.min(l.gt(h[1],(p[3]-d[1])/(d[3]-d[1]),i),h[1].length),N=I+6*F,B=6*Math.max(0,j-F);a[0]=2*(m[0]-L[1])/y-1,a[1]=(m[3]+m[1])/b-1,o[0]=L[1]*v/y,o[1]=C[1]*v/b,B&&(E.color=z[1],E.tickScale=o,E.dataAxis=n,E.screenOffset=a,f.drawArrays(f.TRIANGLES,N,B)),a[0]=(m[2]+m[0])/y-1,a[1]=2*(m[1]-L[0])/b-1,o[0]=C[0]*v/y,o[1]=L[0]*v/b,R&&(E.color=z[0],E.tickScale=o,E.dataAxis=r,E.screenOffset=a,f.drawArrays(f.TRIANGLES,O,R)),a[0]=2*(m[2]+L[3])/y-1,a[1]=(m[3]+m[1])/b-1,o[0]=L[3]*v/y,o[1]=C[3]*v/b,B&&(E.color=z[3],E.tickScale=o,E.dataAxis=n,E.screenOffset=a,f.drawArrays(f.TRIANGLES,N,B)),a[0]=(m[2]+m[0])/y-1,a[1]=2*(m[3]+L[2])/b-1,o[0]=C[2]*v/y,o[1]=L[2]*v/b,R&&(E.color=z[2],E.tickScale=o,E.dataAxis=r,E.screenOffset=a,f.drawArrays(f.TRIANGLES,O,R))}}(),c.update=function(){var t=[1,1,-1,-1,1,-1],e=[1,-1,1,1,-1,-1];return function(r){for(var n=r.ticks,i=r.bounds,a=new Float32Array(18*(n[0].length+n[1].length)),o=(this.plot.zeroLineEnable,0),s=[[],[]],l=0;l<2;++l)for(var u=s[l],c=n[l],h=i[l],f=i[l+2],d=0;d<c.length;++d){var p=(c[d].x-h)/(f-h);u.push(p);for(var m=0;m<6;++m)a[o++]=p,a[o++]=t[m],a[o++]=e[m]}this.ticks=s,this.vbo.update(a)}}(),c.dispose=function(){this.vbo.dispose(),this.shader.dispose(),this.tickShader.dispose()}},{\"./shaders\":208,\"binary-search-bounds\":210,\"gl-buffer\":155,\"gl-shader\":211}],207:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r}function i(t){var e=t.gl;return new n(t,a(e,[-1,-1,-1,1,1,-1,1,1]),o(e,s.lineVert,s.lineFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"./shaders\"),l=n.prototype;l.bind=function(){var t=this.shader;this.vbo.bind(),this.shader.bind(),t.attributes.coord.pointer(),t.uniforms.screenBox=this.plot.screenBox},l.drawLine=function(){var t=[0,0],e=[0,0];return function(r,n,i,a,o,s){var l=this.plot,u=this.shader,c=l.gl;t[0]=r,t[1]=n,e[0]=i,e[1]=a,u.uniforms.start=t,u.uniforms.end=e,u.uniforms.width=o*l.pixelRatio,u.uniforms.color=s,c.drawArrays(c.TRIANGLE_STRIP,0,4)}}(),l.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"gl-buffer\":155,\"gl-shader\":211}],208:[function(t,e,r){\"use strict\";var n=\"precision lowp float;\\n#define GLSLIFY 1\\nuniform vec4 color;\\nvoid main() {\\n  gl_FragColor = vec4(color.xyz * color.w, color.w);\\n}\\n\";e.exports={lineVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 coord;\\n\\nuniform vec4 screenBox;\\nuniform vec2 start, end;\\nuniform float width;\\n\\nvec2 perp(vec2 v) {\\n  return vec2(v.y, -v.x);\\n}\\n\\nvec2 screen(vec2 v) {\\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\\n}\\n\\nvoid main() {\\n  vec2 delta = normalize(perp(start - end));\\n  vec2 offset = mix(start, end, 0.5 * (coord.y+1.0));\\n  gl_Position = vec4(screen(offset + 0.5 * width * delta * coord.x), 0, 1);\\n}\\n\",lineFrag:n,textVert:\"#define GLSLIFY 1\\nattribute vec3 textCoordinate;\\n\\nuniform vec2 dataScale, dataShift, dataAxis, screenOffset, textScale;\\nuniform float angle;\\n\\nvoid main() {\\n  float dataOffset  = textCoordinate.z;\\n  vec2 glyphOffset  = textCoordinate.xy;\\n  mat2 glyphMatrix = mat2(cos(angle), sin(angle), -sin(angle), cos(angle));\\n  vec2 screenCoordinate = dataAxis * (dataScale * dataOffset + dataShift) +\\n    glyphMatrix * glyphOffset * textScale + screenOffset;\\n  gl_Position = vec4(screenCoordinate, 0, 1);\\n}\\n\",textFrag:n,gridVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 dataCoord;\\n\\nuniform vec2 dataAxis, dataShift, dataScale;\\nuniform float lineWidth;\\n\\nvoid main() {\\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\\n  pos += 10.0 * dataCoord.y * vec2(dataAxis.y, -dataAxis.x) + dataCoord.z * lineWidth;\\n  gl_Position = vec4(pos, 0, 1);\\n}\\n\",gridFrag:n,boxVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 coord;\\n\\nuniform vec4 screenBox;\\nuniform vec2 lo, hi;\\n\\nvec2 screen(vec2 v) {\\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\\n}\\n\\nvoid main() {\\n  gl_Position = vec4(screen(mix(lo, hi, coord)), 0, 1);\\n}\\n\",tickVert:\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 dataCoord;\\n\\nuniform vec2 dataAxis, dataShift, dataScale, screenOffset, tickScale;\\n\\nvoid main() {\\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\\n  gl_Position = vec4(pos + tickScale*dataCoord.yz + screenOffset, 0, 1);\\n}\\n\"}},{}],209:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.vbo=e,this.shader=r,this.tickOffset=[[],[]],this.tickX=[[],[]],this.labelOffset=[0,0],this.labelCount=[0,0]}function i(t){var e=t.gl;return new n(t,a(e),o(e,u.textVert,u.textFrag))}e.exports=i;var a=t(\"gl-buffer\"),o=t(\"gl-shader\"),s=t(\"text-cache\"),l=t(\"binary-search-bounds\"),u=t(\"./shaders\"),c=n.prototype;c.drawTicks=function(){var t=[0,0],e=[0,0],r=[0,0];return function(n){var i=this.plot,a=this.shader,o=this.tickX[n],s=this.tickOffset[n],u=i.gl,c=i.viewBox,h=i.dataBox,f=i.screenBox,d=i.pixelRatio,p=i.tickEnable,m=i.tickPad,v=i.tickColor,g=i.tickAngle,y=i.labelEnable,b=i.labelPad,x=i.labelColor,_=i.labelAngle,w=this.labelOffset[n],M=this.labelCount[n],k=l.lt(o,h[n]),A=l.le(o,h[n+2]);t[0]=t[1]=0,t[n]=1,e[n]=(c[2+n]+c[n])/(f[2+n]-f[n])-1;var T=2/f[2+(1^n)]-f[1^n];e[1^n]=T*c[1^n]-1,p[n]&&(e[1^n]-=T*d*m[n],k<A&&s[A]>s[k]&&(a.uniforms.dataAxis=t,a.uniforms.screenOffset=e,a.uniforms.color=v[n],a.uniforms.angle=g[n],u.drawArrays(u.TRIANGLES,s[k],s[A]-s[k]))),y[n]&&M&&(e[1^n]-=T*d*b[n],a.uniforms.dataAxis=r,a.uniforms.screenOffset=e,a.uniforms.color=x[n],a.uniforms.angle=_[n],u.drawArrays(u.TRIANGLES,w,M)),e[1^n]=T*c[2+(1^n)]-1,p[n+2]&&(e[1^n]+=T*d*m[n+2],k<A&&s[A]>s[k]&&(a.uniforms.dataAxis=t,a.uniforms.screenOffset=e,a.uniforms.color=v[n+2],a.uniforms.angle=g[n+2],u.drawArrays(u.TRIANGLES,s[k],s[A]-s[k]))),y[n+2]&&M&&(e[1^n]+=T*d*b[n+2],a.uniforms.dataAxis=r,a.uniforms.screenOffset=e,a.uniforms.color=x[n+2],a.uniforms.angle=_[n+2],u.drawArrays(u.TRIANGLES,w,M))}}(),c.drawTitle=function(){var t=[0,0],e=[0,0];return function(){var r=this.plot,n=this.shader,i=r.gl,a=r.screenBox,o=r.titleCenter,s=r.titleAngle,l=r.titleColor,u=r.pixelRatio;if(this.titleCount){for(var c=0;c<2;++c)e[c]=2*(o[c]*u-a[c])/(a[2+c]-a[c])-1;n.bind(),n.uniforms.dataAxis=t,n.uniforms.screenOffset=e,n.uniforms.angle=s,n.uniforms.color=l,i.drawArrays(i.TRIANGLES,this.titleOffset,this.titleCount)}}}(),c.bind=function(){var t=[0,0],e=[0,0],r=[0,0];return function(){var n=this.plot,i=this.shader,a=n._tickBounds,o=n.dataBox,s=n.screenBox,l=n.viewBox;i.bind();for(var u=0;u<2;++u){var c=a[u],h=a[u+2],f=h-c,d=.5*(o[u+2]+o[u]),p=o[u+2]-o[u],m=l[u],v=l[u+2],g=v-m,y=s[u],b=s[u+2],x=b-y;e[u]=2*f/p*g/x,t[u]=2*(c-d)/p*g/x}r[1]=2*n.pixelRatio/(s[3]-s[1]),r[0]=r[1]*(s[3]-s[1])/(s[2]-s[0]),i.uniforms.dataScale=e,i.uniforms.dataShift=t,i.uniforms.textScale=r,this.vbo.bind(),i.attributes.textCoordinate.pointer()}}(),c.update=function(t){var e,r,n,i,a,o=[],l=t.ticks,u=t.bounds;for(a=0;a<2;++a){var c=[Math.floor(o.length/3)],h=[-1/0],f=l[a];for(e=0;e<f.length;++e){var d=f[e],p=d.x,m=d.text,v=d.font||\"sans-serif\";i=d.fontSize||12;for(var g=1/(u[a+2]-u[a]),y=u[a],b=m.split(\"\\n\"),x=0;x<b.length;x++)for(n=s(v,b[x]).data,r=0;r<n.length;r+=2)o.push(n[r]*i,-n[r+1]*i-x*i*1.2,(p-y)*g);c.push(Math.floor(o.length/3)),h.push(p)}this.tickOffset[a]=c,this.tickX[a]=h}for(a=0;a<2;++a){for(this.labelOffset[a]=Math.floor(o.length/3),n=s(t.labelFont[a],t.labels[a],{textAlign:\"center\"}).data,\n",
       "i=t.labelSize[a],e=0;e<n.length;e+=2)o.push(n[e]*i,-n[e+1]*i,0);this.labelCount[a]=Math.floor(o.length/3)-this.labelOffset[a]}for(this.titleOffset=Math.floor(o.length/3),n=s(t.titleFont,t.title).data,i=t.titleSize,e=0;e<n.length;e+=2)o.push(n[e]*i,-n[e+1]*i,0);this.titleCount=Math.floor(o.length/3)-this.titleOffset,this.vbo.update(o)},c.dispose=function(){this.vbo.dispose(),this.shader.dispose()}},{\"./shaders\":208,\"binary-search-bounds\":210,\"gl-buffer\":155,\"gl-shader\":211,\"text-cache\":531}],210:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],211:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this.gl.lastAttribCount=0,this._vref=this._fref=this._relink=this.vertShader=this.fragShader=this.program=this.attributes=this.uniforms=this.types=null}function i(t,e){return t.name<e.name?-1:1}function a(t,e,r,i,a){var o=new n(t);return o.update(e,r,i,a),o}var o=t(\"./lib/create-uniforms\"),s=t(\"./lib/create-attributes\"),l=t(\"./lib/reflect\"),u=t(\"./lib/shader-cache\"),c=t(\"./lib/runtime-reflect\"),h=t(\"./lib/GLError\"),f=n.prototype;f.bind=function(){this.program||this._relink();var t,e=this.gl.getProgramParameter(this.program,this.gl.ACTIVE_ATTRIBUTES),r=this.gl.lastAttribCount;if(e>r)for(t=r;t<e;t++)this.gl.enableVertexAttribArray(t);else if(r>e)for(t=e;t<r;t++)this.gl.disableVertexAttribArray(t);this.gl.lastAttribCount=e,this.gl.useProgram(this.program)},f.dispose=function(){for(var t=this.gl.lastAttribCount,e=0;e<t;e++)this.gl.disableVertexAttribArray(e);this.gl.lastAttribCount=0,this._fref&&this._fref.dispose(),this._vref&&this._vref.dispose(),this.attributes=this.types=this.vertShader=this.fragShader=this.program=this._relink=this._fref=this._vref=null},f.update=function(t,e,r,n){function a(){d.program=u.program(p,d._vref,d._fref,_,w);for(var t=0;t<r.length;++t)E[t]=p.getUniformLocation(d.program,r[t].name)}if(!e||1===arguments.length){var f=t;t=f.vertex,e=f.fragment,r=f.uniforms,n=f.attributes}var d=this,p=d.gl,m=d._vref;d._vref=u.shader(p,p.VERTEX_SHADER,t),m&&m.dispose(),d.vertShader=d._vref.shader;var v=this._fref;if(d._fref=u.shader(p,p.FRAGMENT_SHADER,e),v&&v.dispose(),d.fragShader=d._fref.shader,!r||!n){var g=p.createProgram();if(p.attachShader(g,d.fragShader),p.attachShader(g,d.vertShader),p.linkProgram(g),!p.getProgramParameter(g,p.LINK_STATUS)){var y=p.getProgramInfoLog(g);throw new h(y,\"Error linking program:\"+y)}r=r||c.uniforms(p,g),n=n||c.attributes(p,g),p.deleteProgram(g)}n=n.slice(),n.sort(i);var b,x=[],_=[],w=[];for(b=0;b<n.length;++b){var M=n[b];if(M.type.indexOf(\"mat\")>=0){for(var k=0|M.type.charAt(M.type.length-1),A=new Array(k),T=0;T<k;++T)A[T]=w.length,_.push(M.name+\"[\"+T+\"]\"),\"number\"==typeof M.location?w.push(M.location+T):Array.isArray(M.location)&&M.location.length===k&&\"number\"==typeof M.location[T]?w.push(0|M.location[T]):w.push(-1);x.push({name:M.name,type:M.type,locations:A})}else x.push({name:M.name,type:M.type,locations:[w.length]}),_.push(M.name),\"number\"==typeof M.location?w.push(0|M.location):w.push(-1)}var S=0;for(b=0;b<w.length;++b)if(w[b]<0){for(;w.indexOf(S)>=0;)S+=1;w[b]=S}var E=new Array(r.length);a(),d._relink=a,d.types={uniforms:l(r),attributes:l(n)},d.attributes=s(p,d,x,w),Object.defineProperty(d,\"uniforms\",o(p,d,r,E))},e.exports=a},{\"./lib/GLError\":212,\"./lib/create-attributes\":213,\"./lib/create-uniforms\":214,\"./lib/reflect\":215,\"./lib/runtime-reflect\":216,\"./lib/shader-cache\":217}],212:[function(t,e,r){function n(t,e,r){this.shortMessage=e||\"\",this.longMessage=r||\"\",this.rawError=t||\"\",this.message=\"gl-shader: \"+(e||t||\"\")+(r?\"\\n\"+r:\"\"),this.stack=(new Error).stack}n.prototype=new Error,n.prototype.name=\"GLError\",n.prototype.constructor=n,e.exports=n},{}],213:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this._gl=t,this._wrapper=e,this._index=r,this._locations=n,this._dimension=i,this._constFunc=a}function i(t,e,r,i,a,o,s){for(var l=[\"gl\",\"v\"],u=[],c=0;c<a;++c)l.push(\"x\"+c),u.push(\"x\"+c);l.push(\"if(x0.length===void 0){return gl.vertexAttrib\"+a+\"f(v,\"+u.join()+\")}else{return gl.vertexAttrib\"+a+\"fv(v,x0)}\");var h=Function.apply(null,l),f=new n(t,e,r,i,a,h);Object.defineProperty(o,s,{set:function(e){return t.disableVertexAttribArray(i[r]),h(t,i[r],e),e},get:function(){return f},enumerable:!0})}function a(t,e,r,n,a,o,s){for(var l=new Array(a),u=new Array(a),c=0;c<a;++c)i(t,e,r[c],n,a,l,c),u[c]=l[c];Object.defineProperty(l,\"location\",{set:function(t){if(Array.isArray(t))for(var e=0;e<a;++e)u[e].location=t[e];else for(var e=0;e<a;++e)u[e].location=t+e;return t},get:function(){for(var t=new Array(a),e=0;e<a;++e)t[e]=n[r[e]];return t},enumerable:!0}),l.pointer=function(e,i,o,s){e=e||t.FLOAT,i=!!i,o=o||a*a,s=s||0;for(var l=0;l<a;++l){var u=n[r[l]];t.vertexAttribPointer(u,a,e,i,o,s+l*a),t.enableVertexAttribArray(u)}};var h=new Array(a),f=t[\"vertexAttrib\"+a+\"fv\"];Object.defineProperty(o,s,{set:function(e){for(var i=0;i<a;++i){var o=n[r[i]];if(t.disableVertexAttribArray(o),Array.isArray(e[0]))f.call(t,o,e[i]);else{for(var s=0;s<a;++s)h[s]=e[a*i+s];f.call(t,o,h)}}return e},get:function(){return l},enumerable:!0})}function o(t,e,r,n){for(var o={},l=0,u=r.length;l<u;++l){var c=r[l],h=c.name,f=c.type,d=c.locations;switch(f){case\"bool\":case\"int\":case\"float\":i(t,e,d[0],n,1,o,h);break;default:if(f.indexOf(\"vec\")>=0){var p=f.charCodeAt(f.length-1)-48;if(p<2||p>4)throw new s(\"\",\"Invalid data type for attribute \"+h+\": \"+f);i(t,e,d[0],n,p,o,h)}else{if(!(f.indexOf(\"mat\")>=0))throw new s(\"\",\"Unknown data type for attribute \"+h+\": \"+f);var p=f.charCodeAt(f.length-1)-48;if(p<2||p>4)throw new s(\"\",\"Invalid data type for attribute \"+h+\": \"+f);a(t,e,d,n,p,o,h)}}}return o}e.exports=o;var s=t(\"./GLError\"),l=n.prototype;l.pointer=function(t,e,r,n){var i=this,a=i._gl,o=i._locations[i._index];a.vertexAttribPointer(o,i._dimension,t||a.FLOAT,!!e,r||0,n||0),a.enableVertexAttribArray(o)},l.set=function(t,e,r,n){return this._constFunc(this._locations[this._index],t,e,r,n)},Object.defineProperty(l,\"location\",{get:function(){return this._locations[this._index]},set:function(t){return t!==this._locations[this._index]&&(this._locations[this._index]=0|t,this._wrapper.program=null),0|t}})},{\"./GLError\":212}],214:[function(t,e,r){\"use strict\";function n(t){return new Function(\"y\",\"return function(){return y}\")(t)}function i(t,e){for(var r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function a(t,e,r,a){function l(r){return new Function(\"gl\",\"wrapper\",\"locations\",\"return function(){return gl.getUniform(wrapper.program,locations[\"+r+\"])}\")(t,e,a)}function u(t,e,r){switch(r){case\"bool\":case\"int\":case\"sampler2D\":case\"samplerCube\":return\"gl.uniform1i(locations[\"+e+\"],obj\"+t+\")\";case\"float\":return\"gl.uniform1f(locations[\"+e+\"],obj\"+t+\")\";default:var n=r.indexOf(\"vec\");if(!(0<=n&&n<=1&&r.length===4+n)){if(0===r.indexOf(\"mat\")&&4===r.length){var i=r.charCodeAt(r.length-1)-48;if(i<2||i>4)throw new s(\"\",\"Invalid uniform dimension type for matrix \"+name+\": \"+r);return\"gl.uniformMatrix\"+i+\"fv(locations[\"+e+\"],false,obj\"+t+\")\"}throw new s(\"\",\"Unknown uniform data type for \"+name+\": \"+r)}var i=r.charCodeAt(r.length-1)-48;if(i<2||i>4)throw new s(\"\",\"Invalid data type\");switch(r.charAt(0)){case\"b\":case\"i\":return\"gl.uniform\"+i+\"iv(locations[\"+e+\"],obj\"+t+\")\";case\"v\":return\"gl.uniform\"+i+\"fv(locations[\"+e+\"],obj\"+t+\")\";default:throw new s(\"\",\"Unrecognized data type for vector \"+name+\": \"+r)}}}function c(t,e){if(\"object\"!=typeof e)return[[t,e]];var r=[];for(var n in e){var i=e[n],a=t;parseInt(n)+\"\"===n?a+=\"[\"+n+\"]\":a+=\".\"+n,\"object\"==typeof i?r.push.apply(r,c(a,i)):r.push([a,i])}return r}function h(e){for(var n=[\"return function updateProperty(obj){\"],i=c(\"\",e),o=0;o<i.length;++o){var s=i[o],l=s[0],h=s[1];a[h]&&n.push(u(l,h,r[h].type))}return n.push(\"return obj}\"),new Function(\"gl\",\"locations\",n.join(\"\\n\"))(t,a)}function f(t){switch(t){case\"bool\":return!1;case\"int\":case\"sampler2D\":case\"samplerCube\":case\"float\":return 0;default:var e=t.indexOf(\"vec\");if(0<=e&&e<=1&&t.length===4+e){var r=t.charCodeAt(t.length-1)-48;if(r<2||r>4)throw new s(\"\",\"Invalid data type\");return\"b\"===t.charAt(0)?i(r,!1):i(r,0)}if(0===t.indexOf(\"mat\")&&4===t.length){var r=t.charCodeAt(t.length-1)-48;if(r<2||r>4)throw new s(\"\",\"Invalid uniform dimension type for matrix \"+name+\": \"+t);return i(r*r,0)}throw new s(\"\",\"Unknown uniform data type for \"+name+\": \"+t)}}function d(t,e,i){if(\"object\"==typeof i){var o=p(i);Object.defineProperty(t,e,{get:n(o),set:h(i),enumerable:!0,configurable:!1})}else a[i]?Object.defineProperty(t,e,{get:l(i),set:h(i),enumerable:!0,configurable:!1}):t[e]=f(r[i].type)}function p(t){var e;if(Array.isArray(t)){e=new Array(t.length);for(var r=0;r<t.length;++r)d(e,r,t[r])}else{e={};for(var n in t)d(e,n,t[n])}return e}var m=o(r,!0);return{get:n(p(m)),set:h(m),enumerable:!0,configurable:!0}}var o=t(\"./reflect\"),s=t(\"./GLError\");e.exports=a},{\"./GLError\":212,\"./reflect\":215}],215:[function(t,e,r){\"use strict\";function n(t,e){for(var r={},n=0;n<t.length;++n)for(var i=t[n].name,a=i.split(\".\"),o=r,s=0;s<a.length;++s){var l=a[s].split(\"[\");if(l.length>1){l[0]in o||(o[l[0]]=[]),o=o[l[0]];for(var u=1;u<l.length;++u){var c=parseInt(l[u]);u<l.length-1||s<a.length-1?(c in o||(u<l.length-1?o[c]=[]:o[c]={}),o=o[c]):o[c]=e?n:t[n].type}}else s<a.length-1?(l[0]in o||(o[l[0]]={}),o=o[l[0]]):o[l[0]]=e?n:t[n].type}return r}e.exports=n},{}],216:[function(t,e,r){\"use strict\";function n(t,e){if(!s){var r=Object.keys(o);s={};for(var n=0;n<r.length;++n){var i=r[n];s[t[i]]=o[i]}}return s[e]}function i(t,e){for(var r=t.getProgramParameter(e,t.ACTIVE_UNIFORMS),i=[],a=0;a<r;++a){var o=t.getActiveUniform(e,a);if(o){var s=n(t,o.type);if(o.size>1)for(var l=0;l<o.size;++l)i.push({name:o.name.replace(\"[0]\",\"[\"+l+\"]\"),type:s});else i.push({name:o.name,type:s})}}return i}function a(t,e){for(var r=t.getProgramParameter(e,t.ACTIVE_ATTRIBUTES),i=[],a=0;a<r;++a){var o=t.getActiveAttrib(e,a);o&&i.push({name:o.name,type:n(t,o.type)})}return i}r.uniforms=i,r.attributes=a;var o={FLOAT:\"float\",FLOAT_VEC2:\"vec2\",FLOAT_VEC3:\"vec3\",FLOAT_VEC4:\"vec4\",INT:\"int\",INT_VEC2:\"ivec2\",INT_VEC3:\"ivec3\",INT_VEC4:\"ivec4\",BOOL:\"bool\",BOOL_VEC2:\"bvec2\",BOOL_VEC3:\"bvec3\",BOOL_VEC4:\"bvec4\",FLOAT_MAT2:\"mat2\",FLOAT_MAT3:\"mat3\",FLOAT_MAT4:\"mat4\",SAMPLER_2D:\"sampler2D\",SAMPLER_CUBE:\"samplerCube\"},s=null},{}],217:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.id=t,this.src=e,this.type=r,this.shader=n,this.count=a,this.programs=[],this.cache=o}function i(t){this.gl=t,this.shaders=[{},{}],this.programs={}}function a(t,e,r){var n=t.createShader(e);if(t.shaderSource(n,r),t.compileShader(n),!t.getShaderParameter(n,t.COMPILE_STATUS)){var i=t.getShaderInfoLog(n);try{var a=h(i,r,e)}catch(t){throw console.warn(\"Failed to format compiler error: \"+t),new c(i,\"Error compiling shader:\\n\"+i)}throw new c(i,a.short,a.long)}return n}function o(t,e,r,n,i){var a=t.createProgram();t.attachShader(a,e),t.attachShader(a,r);for(var o=0;o<n.length;++o)t.bindAttribLocation(a,i[o],n[o]);if(t.linkProgram(a),!t.getProgramParameter(a,t.LINK_STATUS)){var s=t.getProgramInfoLog(a);throw new c(s,\"Error linking program: \"+s)}return a}function s(t){var e=d.get(t);return e||(e=new i(t),d.set(t,e)),e}function l(t,e,r){return s(t).getShaderReference(e,r)}function u(t,e,r,n,i){return s(t).getProgram(e,r,n,i)}r.shader=l,r.program=u;var c=t(\"./GLError\"),h=t(\"gl-format-compiler-error\"),f=\"undefined\"==typeof WeakMap?t(\"weakmap-shim\"):WeakMap,d=new f,p=0;n.prototype.dispose=function(){if(0==--this.count){for(var t=this.cache,e=t.gl,r=this.programs,n=0,i=r.length;n<i;++n){var a=t.programs[r[n]];a&&(delete t.programs[n],e.deleteProgram(a))}e.deleteShader(this.shader),delete t.shaders[this.type===e.FRAGMENT_SHADER|0][this.src]}};var m=i.prototype;m.getShaderReference=function(t,e){var r=this.gl,i=this.shaders[t===r.FRAGMENT_SHADER|0],o=i[e];if(o&&r.isShader(o.shader))o.count+=1;else{var s=a(r,t,e);o=i[e]=new n(p++,e,t,s,[],1,this)}return o},m.getProgram=function(t,e,r,n){var i=[t.id,e.id,r.join(\":\"),n.join(\":\")].join(\"@\"),a=this.programs[i];return a&&this.gl.isProgram(a)||(this.programs[i]=a=o(this.gl,t.shader,e.shader,r,n),t.programs.push(i),e.programs.push(i)),a}},{\"./GLError\":212,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],218:[function(t,e,r){\"use strict\";function n(t,e){this.gl=t,this.pickBuffer=e,this.screenBox=[0,0,t.drawingBufferWidth,t.drawingBufferHeight],this.viewBox=[0,0,0,0],this.dataBox=[-10,-10,10,10],this.gridLineEnable=[!0,!0],this.gridLineWidth=[1,1],this.gridLineColor=[[0,0,0,1],[0,0,0,1]],this.pixelRatio=1,this.tickMarkLength=[0,0,0,0],this.tickMarkWidth=[0,0,0,0],this.tickMarkColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[15,15,15,15],this.tickAngle=[0,0,0,0],this.tickEnable=[!0,!0,!0,!0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[15,15,15,15],this.labelAngle=[0,Math.PI/2,0,3*Math.PI/2],this.labelEnable=[!0,!0,!0,!0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.titleCenter=[0,0],this.titleEnable=!0,this.titleAngle=0,this.titleColor=[0,0,0,1],this.borderColor=[0,0,0,0],this.backgroundColor=[0,0,0,0],this.zeroLineEnable=[!0,!0],this.zeroLineWidth=[4,4],this.zeroLineColor=[[0,0,0,1],[0,0,0,1]],this.borderLineEnable=[!0,!0,!0,!0],this.borderLineWidth=[2,2,2,2],this.borderLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.grid=null,this.text=null,this.line=null,this.box=null,this.objects=[],this.overlays=[],this._tickBounds=[1/0,1/0,-1/0,-1/0],this.static=!1,this.dirty=!1,this.pickDirty=!1,this.pickDelay=120,this.pickRadius=10,this._pickTimeout=null,this._drawPick=this.drawPick.bind(this),this._depthCounter=0}function i(t){for(var e=t.slice(),r=0;r<e.length;++r)e[r]=e[r].slice();return e}function a(t,e){return t.x-e.x}function o(t){var e=t.gl,r=s(e,[e.drawingBufferWidth,e.drawingBufferHeight]),i=new n(e,r);return i.grid=l(i),i.text=u(i),i.line=c(i),i.box=h(i),i.update(t),i}e.exports=o;var s=t(\"gl-select-static\"),l=t(\"./lib/grid\"),u=t(\"./lib/text\"),c=t(\"./lib/line\"),h=t(\"./lib/box\"),f=n.prototype;f.setDirty=function(){this.dirty=this.pickDirty=!0},f.setOverlayDirty=function(){this.dirty=!0},f.nextDepthValue=function(){return this._depthCounter++/65536},f.draw=function(){return function(){var t=this.gl,e=this.screenBox,r=this.viewBox,n=this.dataBox,i=this.pixelRatio,a=this.grid,o=this.line,s=this.text,l=this.objects;if(this._depthCounter=0,this.pickDirty&&(this._pickTimeout&&clearTimeout(this._pickTimeout),this.pickDirty=!1,this._pickTimeout=setTimeout(this._drawPick,this.pickDelay)),this.dirty){this.dirty=!1,t.bindFramebuffer(t.FRAMEBUFFER,null),t.enable(t.SCISSOR_TEST),t.disable(t.DEPTH_TEST),t.depthFunc(t.LESS),t.depthMask(!1),t.enable(t.BLEND),t.blendEquation(t.FUNC_ADD,t.FUNC_ADD),t.blendFunc(t.ONE,t.ONE_MINUS_SRC_ALPHA),t.scissor(e[0],e[1],e[2]-e[0],e[3]-e[1]);var u=this.borderColor;t.clearColor(u[0]*u[3],u[1]*u[3],u[2]*u[3],u[3]),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT),t.scissor(r[0],r[1],r[2]-r[0],r[3]-r[1]),t.viewport(r[0],r[1],r[2]-r[0],r[3]-r[1]);var c=this.backgroundColor;t.clearColor(c[0]*c[3],c[1]*c[3],c[2]*c[3],c[3]),t.clear(t.COLOR_BUFFER_BIT),a.draw();var h=this.zeroLineEnable,f=this.zeroLineColor,d=this.zeroLineWidth;if(h[0]||h[1]){o.bind();for(var p=0;p<2;++p)if(h[p]&&n[p]<=0&&n[p+2]>=0){var m=e[p]-n[p]*(e[p+2]-e[p])/(n[p+2]-n[p]);0===p?o.drawLine(m,e[1],m,e[3],d[p],f[p]):o.drawLine(e[0],m,e[2],m,d[p],f[p])}}for(var p=0;p<l.length;++p)l[p].draw();t.viewport(e[0],e[1],e[2]-e[0],e[3]-e[1]),t.scissor(e[0],e[1],e[2]-e[0],e[3]-e[1]),this.grid.drawTickMarks(),o.bind();var v=this.borderLineEnable,g=this.borderLineWidth,y=this.borderLineColor;v[1]&&o.drawLine(r[0],r[1]-.5*g[1]*i,r[0],r[3]+.5*g[3]*i,g[1],y[1]),v[0]&&o.drawLine(r[0]-.5*g[0]*i,r[1],r[2]+.5*g[2]*i,r[1],g[0],y[0]),v[3]&&o.drawLine(r[2],r[1]-.5*g[1]*i,r[2],r[3]+.5*g[3]*i,g[3],y[3]),v[2]&&o.drawLine(r[0]-.5*g[0]*i,r[3],r[2]+.5*g[2]*i,r[3],g[2],y[2]),s.bind();for(var p=0;p<2;++p)s.drawTicks(p);this.titleEnable&&s.drawTitle();for(var b=this.overlays,p=0;p<b.length;++p)b[p].draw();t.disable(t.SCISSOR_TEST),t.disable(t.BLEND),t.depthMask(!0)}}}(),f.drawPick=function(){return function(){if(!this.static){var t=this.pickBuffer;this.gl;this._pickTimeout=null,t.begin();for(var e=1,r=this.objects,n=0;n<r.length;++n)e=r[n].drawPick(e);t.end()}}}(),f.pick=function(){return function(t,e){if(!this.static){var r=this.pixelRatio,n=this.pickPixelRatio,i=this.viewBox,a=0|Math.round((t-i[0]/r)*n),o=0|Math.round((e-i[1]/r)*n),s=this.pickBuffer.query(a,o,this.pickRadius);if(!s)return null;for(var l=s.id+(s.value[0]<<8)+(s.value[1]<<16)+(s.value[2]<<24),u=this.objects,c=0;c<u.length;++c){var h=u[c].pick(a,o,l);if(h)return h}return null}}}(),f.setScreenBox=function(t){var e=this.screenBox,r=this.pixelRatio;e[0]=0|Math.round(t[0]*r),e[1]=0|Math.round(t[1]*r),e[2]=0|Math.round(t[2]*r),e[3]=0|Math.round(t[3]*r),this.setDirty()},f.setDataBox=function(t){var e=this.dataBox;(e[0]!==t[0]||e[1]!==t[1]||e[2]!==t[2]||e[3]!==t[3])&&(e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],this.setDirty())},f.setViewBox=function(t){var e=this.pixelRatio,r=this.viewBox;r[0]=0|Math.round(t[0]*e),r[1]=0|Math.round(t[1]*e),r[2]=0|Math.round(t[2]*e),r[3]=0|Math.round(t[3]*e);var n=this.pickPixelRatio;this.pickBuffer.shape=[0|Math.round((t[2]-t[0])*n),0|Math.round((t[3]-t[1])*n)],this.setDirty()},f.update=function(t){t=t||{};var e=this.gl;this.pixelRatio=t.pixelRatio||1;var r=this.pixelRatio;this.pickPixelRatio=Math.max(r,1),this.setScreenBox(t.screenBox||[0,0,e.drawingBufferWidth/r,e.drawingBufferHeight/r]);this.screenBox;this.setViewBox(t.viewBox||[.125*(this.screenBox[2]-this.screenBox[0])/r,.125*(this.screenBox[3]-this.screenBox[1])/r,.875*(this.screenBox[2]-this.screenBox[0])/r,.875*(this.screenBox[3]-this.screenBox[1])/r]);var n=this.viewBox,o=(n[2]-n[0])/(n[3]-n[1]);this.setDataBox(t.dataBox||[-10,-10/o,10,10/o]),this.borderColor=(t.borderColor||[0,0,0,0]).slice(),this.backgroundColor=(t.backgroundColor||[0,0,0,0]).slice(),this.gridLineEnable=(t.gridLineEnable||[!0,!0]).slice(),this.gridLineWidth=(t.gridLineWidth||[1,1]).slice(),this.gridLineColor=i(t.gridLineColor||[[.5,.5,.5,1],[.5,.5,.5,1]]),this.zeroLineEnable=(t.zeroLineEnable||[!0,!0]).slice(),this.zeroLineWidth=(t.zeroLineWidth||[4,4]).slice(),this.zeroLineColor=i(t.zeroLineColor||[[0,0,0,1],[0,0,0,1]]),this.tickMarkLength=(t.tickMarkLength||[0,0,0,0]).slice(),this.tickMarkWidth=(t.tickMarkWidth||[0,0,0,0]).slice(),this.tickMarkColor=i(t.tickMarkColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.titleCenter=(t.titleCenter||[.5*(n[0]+n[2])/r,(n[3]+120)/r]).slice(),this.titleEnable=!(\"titleEnable\"in t&&!t.titleEnable),this.titleAngle=t.titleAngle||0,this.titleColor=(t.titleColor||[0,0,0,1]).slice(),this.labelPad=(t.labelPad||[15,15,15,15]).slice(),this.labelAngle=(t.labelAngle||[0,Math.PI/2,0,3*Math.PI/2]).slice(),this.labelEnable=(t.labelEnable||[!0,!0,!0,!0]).slice(),this.labelColor=i(t.labelColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.tickPad=(t.tickPad||[15,15,15,15]).slice(),this.tickAngle=(t.tickAngle||[0,0,0,0]).slice(),this.tickEnable=(t.tickEnable||[!0,!0,!0,!0]).slice(),this.tickColor=i(t.tickColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]),this.borderLineEnable=(t.borderLineEnable||[!0,!0,!0,!0]).slice(),this.borderLineWidth=(t.borderLineWidth||[2,2,2,2]).slice(),this.borderLineColor=i(t.borderLineColor||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]);var s=t.ticks||[[],[]],l=this._tickBounds;l[0]=l[1]=1/0,l[2]=l[3]=-1/0;for(var u=0;u<2;++u){var c=s[u].slice(0);0!==c.length&&(c.sort(a),l[u]=Math.min(l[u],c[0].x),l[u+2]=Math.max(l[u+2],c[c.length-1].x))}this.grid.update({bounds:l,ticks:s}),this.text.update({bounds:l,ticks:s,labels:t.labels||[\"x\",\"y\"],labelSize:t.labelSize||[12,12],labelFont:t.labelFont||[\"sans-serif\",\"sans-serif\"],title:t.title||\"\",titleSize:t.titleSize||18,titleFont:t.titleFont||\"sans-serif\"}),this.static=!!t.static,this.setDirty()},f.dispose=function(){this.box.dispose(),this.grid.dispose(),this.text.dispose(),this.line.dispose();for(var t=this.objects.length-1;t>=0;--t)this.objects[t].dispose();this.objects.length=0;for(var t=this.overlays.length-1;t>=0;--t)this.overlays[t].dispose();this.overlays.length=0,this.gl=null},f.addObject=function(t){this.objects.indexOf(t)<0&&(this.objects.push(t),this.setDirty())},f.removeObject=function(t){for(var e=this.objects,r=0;r<e.length;++r)if(e[r]===t){e.splice(r,1),this.setDirty();break}},f.addOverlay=function(t){this.overlays.indexOf(t)<0&&(this.overlays.push(t),this.setOverlayDirty())},f.removeOverlay=function(t){for(var e=this.overlays,r=0;r<e.length;++r)if(e[r]===t){e.splice(r,1),this.setOverlayDirty();break}}},{\"./lib/box\":205,\"./lib/grid\":206,\"./lib/line\":207,\"./lib/text\":209,\"gl-select-static\":253}],219:[function(t,e,r){var n=t(\"gl-shader\");e.exports=function(t){return n(t,\"precision mediump float;\\n#define GLSLIFY 1\\nattribute vec2 position;\\nvarying vec2 uv;\\nvoid main() {\\n  uv = position;\\n  gl_Position = vec4(position, 0, 1);\\n}\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D accumBuffer;\\nvarying vec2 uv;\\n\\nvoid main() {\\n  vec4 accum = texture2D(accumBuffer, 0.5 * (uv + 1.0));\\n  gl_FragColor = min(vec4(1,1,1,1), accum);\\n}\",null,[{name:\"position\",type:\"vec2\"}])}},{\"gl-shader\":254}],220:[function(t,e,r){\"use strict\";function n(){this.mouse=[-1,-1],this.screen=null,this.distance=1/0,this.index=null,this.dataCoordinate=null,this.dataPosition=null,this.object=null,this.data=null}function i(t,e){var r=null;try{r=t.getContext(\"webgl\",e),r||(r=t.getContext(\"experimental-webgl\",e))}catch(t){return null}return r}function a(t){var e=Math.round(Math.log(Math.abs(t))/Math.log(10));if(e<0){var r=Math.round(Math.pow(10,-e));return Math.ceil(t*r)/r}if(e>0){var r=Math.round(Math.pow(10,e));return Math.ceil(t/r)*r}return Math.ceil(t)}function o(t){return\"boolean\"!=typeof t||t}function s(t){function e(){if(!w&&G.autoResize){var t=M.parentNode,e=1,r=1;t&&t!==document.body?(e=t.clientWidth,r=t.clientHeight):(e=window.innerWidth,r=window.innerHeight);var n=0|Math.ceil(e*G.pixelRatio),i=0|Math.ceil(r*G.pixelRatio);if(n!==M.width||i!==M.height){M.width=n,M.height=i;var a=M.style;a.position=a.position||\"absolute\",a.left=\"0px\",a.top=\"0px\",a.width=e+\"px\",a.height=r+\"px\",N=!0}}}function r(){for(var t=O.length,e=j.length,r=0;r<e;++r)F[r]=0;t:for(var r=0;r<t;++r){var n=O[r],i=n.pickSlots;if(i){for(var a=0;a<e;++a)if(F[a]+i<255){R[r]=a,n.setPickBase(F[a]+1),F[a]+=i;continue t}var o=f(A,q);R[r]=e,j.push(o),F.push(i),n.setPickBase(1),e+=1}else R[r]=-1}for(;e>0&&0===F[e-1];)F.pop(),j.pop().dispose()}function s(){if(G.contextLost)return!0;A.isContextLost()&&(G.contextLost=!0,G.mouseListener.enabled=!1,G.selection.object=null,G.oncontextloss&&G.oncontextloss())}function b(){if(!s()){A.colorMask(!0,!0,!0,!0),A.depthMask(!0),A.disable(A.BLEND),A.enable(A.DEPTH_TEST);for(var t=O.length,e=j.length,r=0;r<e;++r){var n=j[r];n.shape=Y,n.begin();for(var i=0;i<t;++i)if(R[i]===r){var a=O[i];a.drawPick&&(a.pixelRatio=1,a.drawPick(H))}n.end()}}}function x(){if(!s()){e();var t=G.camera.tick();H.view=G.camera.matrix,N=N||t,B=B||t,I.pixelRatio=G.pixelRatio,P.pixelRatio=G.pixelRatio;var r=O.length,n=Z[0],i=Z[1];n[0]=n[1]=n[2]=1/0,i[0]=i[1]=i[2]=-1/0;for(var o=0;o<r;++o){var l=O[o];l.pixelRatio=G.pixelRatio,l.axes=G.axes,N=N||!!l.dirty,B=B||!!l.dirty;var u=l.bounds;if(u)for(var h=u[0],f=u[1],d=0;d<3;++d)n[d]=Math.min(n[d],h[d]),i[d]=Math.max(i[d],f[d])}var m=G.bounds;if(G.autoBounds)for(var d=0;d<3;++d){if(i[d]<n[d])n[d]=-1,i[d]=1;else{n[d]===i[d]&&(n[d]-=1,i[d]+=1);var g=.05*(i[d]-n[d]);n[d]=n[d]-g,i[d]=i[d]+g}m[0][d]=n[d],m[1][d]=i[d]}for(var y=!1,d=0;d<3;++d)y=y||J[0][d]!==m[0][d]||J[1][d]!==m[1][d],J[0][d]=m[0][d],J[1][d]=m[1][d];if(B=B||y,N=N||y){if(y){for(var x=[0,0,0],o=0;o<3;++o)x[o]=a((m[1][o]-m[0][o])/10);I.autoTicks?I.update({bounds:m,tickSpacing:x}):I.update({bounds:m})}var _=A.drawingBufferWidth,w=A.drawingBufferHeight;q[0]=_,q[1]=w,Y[0]=0|Math.max(_/G.pixelRatio,1),Y[1]=0|Math.max(w/G.pixelRatio,1),v(U,G.fovy,_/w,G.zNear,G.zFar);for(var o=0;o<16;++o)V[o]=0;V[15]=1;for(var M=0,o=0;o<3;++o)M=Math.max(M,m[1][o]-m[0][o]);for(var o=0;o<3;++o)G.autoScale?V[5*o]=G.aspect[o]/(m[1][o]-m[0][o]):V[5*o]=1/M,G.autoCenter&&(V[12+o]=.5*-V[5*o]*(m[0][o]+m[1][o]));for(var o=0;o<r;++o){var l=O[o];l.axesBounds=m,G.clipToBounds&&(l.clipBounds=m)}S.object&&(G.snapToData?P.position=S.dataCoordinate:P.position=S.dataPosition,P.bounds=m),B&&(B=!1,b()),G.axesPixels=c(G.axes,H,_,w),G.onrender&&G.onrender(),A.bindFramebuffer(A.FRAMEBUFFER,null),A.viewport(0,0,_,w);var k=G.clearColor;A.clearColor(k[0],k[1],k[2],k[3]),A.clear(A.COLOR_BUFFER_BIT|A.DEPTH_BUFFER_BIT),A.depthMask(!0),A.colorMask(!0,!0,!0,!0),A.enable(A.DEPTH_TEST),A.depthFunc(A.LEQUAL),A.disable(A.BLEND),A.disable(A.CULL_FACE);var T=!1;I.enable&&(T=T||I.isTransparent(),I.draw(H)),P.axes=I,S.object&&P.draw(H),A.disable(A.CULL_FACE);for(var o=0;o<r;++o){var l=O[o];l.axes=I,l.pixelRatio=G.pixelRatio,l.isOpaque&&l.isOpaque()&&l.draw(H),l.isTransparent&&l.isTransparent()&&(T=!0)}if(T){E.shape=q,E.bind(),A.clear(A.DEPTH_BUFFER_BIT),A.colorMask(!1,!1,!1,!1),A.depthMask(!0),A.depthFunc(A.LESS),I.enable&&I.isTransparent()&&I.drawTransparent(H);for(var o=0;o<r;++o){var l=O[o];l.isOpaque&&l.isOpaque()&&l.draw(H)}A.enable(A.BLEND),A.blendEquation(A.FUNC_ADD),A.blendFunc(A.ONE,A.ONE_MINUS_SRC_ALPHA),A.colorMask(!0,!0,!0,!0),A.depthMask(!1),A.clearColor(0,0,0,0),A.clear(A.COLOR_BUFFER_BIT),I.isTransparent()&&I.drawTransparent(H);for(var o=0;o<r;++o){var l=O[o];l.isTransparent&&l.isTransparent()&&l.drawTransparent(H)}A.bindFramebuffer(A.FRAMEBUFFER,null),A.blendFunc(A.ONE,A.ONE_MINUS_SRC_ALPHA),A.disable(A.DEPTH_TEST),L.bind(),E.color[0].bind(0),L.uniforms.accumBuffer=0,p(A),A.disable(A.BLEND)}N=!1;for(var o=0;o<r;++o)O[o].dirty=!1}}}function _(){w||G.contextLost||(requestAnimationFrame(_),x())}t=t||{};var w=!1,M=(t.pixelRatio||parseFloat(window.devicePixelRatio),t.canvas);if(!M)if(M=document.createElement(\"canvas\"),t.container){var k=t.container;k.appendChild(M)}else document.body.appendChild(M);var A=t.gl;if(A||(A=i(M,t.glOptions||{premultipliedAlpha:!0,antialias:!0})),!A)throw new Error(\"webgl not supported\");var T=t.bounds||[[-10,-10,-10],[10,10,10]],S=new n,E=d(A,[A.drawingBufferWidth,A.drawingBufferHeight],{preferFloat:!y}),L=g(A),C=t.camera||{eye:[2,0,0],center:[0,0,0],up:[0,1,0],zoomMin:.1,zoomMax:100,mode:\"turntable\"},z=t.axes||{},I=u(A,z);I.enable=!z.disable;var D=t.spikes||{},P=h(A,D),O=[],R=[],F=[],j=[],N=!0,B=!0,U=new Array(16),V=new Array(16),H={view:null,projection:U,model:V},B=!0,q=[A.drawingBufferWidth,A.drawingBufferHeight],G={gl:A,contextLost:!1,pixelRatio:t.pixelRatio||parseFloat(window.devicePixelRatio),canvas:M,selection:S,camera:l(M,C),axes:I,axesPixels:null,spikes:P,bounds:T,objects:O,shape:q,aspect:t.aspectRatio||[1,1,1],pickRadius:t.pickRadius||10,zNear:t.zNear||.01,zFar:t.zFar||1e3,fovy:t.fovy||Math.PI/4,clearColor:t.clearColor||[0,0,0,0],autoResize:o(t.autoResize),autoBounds:o(t.autoBounds),autoScale:!!t.autoScale,autoCenter:o(t.autoCenter),clipToBounds:o(t.clipToBounds),snapToData:!!t.snapToData,onselect:t.onselect||null,onrender:t.onrender||null,onclick:t.onclick||null,cameraParams:H,oncontextloss:null,mouseListener:null},Y=[A.drawingBufferWidth/G.pixelRatio|0,A.drawingBufferHeight/G.pixelRatio|0];G.autoResize&&e(),window.addEventListener(\"resize\",e),G.update=function(t){w||(t=t||{},N=!0,B=!0)},G.add=function(t){w||(t.axes=I,O.push(t),R.push(-1),N=!0,B=!0,r())},G.remove=function(t){if(!w){var e=O.indexOf(t);e<0||(O.splice(e,1),R.pop(),N=!0,B=!0,r())}},G.dispose=function(){if(!w&&(w=!0,window.removeEventListener(\"resize\",e),M.removeEventListener(\"webglcontextlost\",s),G.mouseListener.enabled=!1,!G.contextLost)){I.dispose(),P.dispose();for(var t=0;t<O.length;++t)O[t].dispose();E.dispose();for(var t=0;t<j.length;++t)j[t].dispose();L.dispose(),A=null,I=null,P=null,O=[]}};var X=!1,W=0;G.mouseListener=m(M,function(t,e,r){if(!w){var n=j.length,i=O.length,a=S.object;S.distance=1/0,S.mouse[0]=e,S.mouse[1]=r,S.object=null,S.screen=null,S.dataCoordinate=S.dataPosition=null;var o=!1;if(t&&W)X=!0;else{X&&(B=!0),X=!1;for(var s=0;s<n;++s){var l=j[s].query(e,Y[1]-r-1,G.pickRadius);if(l){if(l.distance>S.distance)continue;for(var u=0;u<i;++u){var c=O[u];if(R[u]===s){var h=c.pick(l);h&&(S.buttons=t,S.screen=l.coord,S.distance=l.distance,S.object=c,S.index=h.distance,S.dataPosition=h.position,S.dataCoordinate=h.dataCoordinate,S.data=h,o=!0)}}}}}a&&a!==S.object&&(a.highlight&&a.highlight(null),N=!0),S.object&&(S.object.highlight&&S.object.highlight(S.data),N=!0),o=o||S.object!==a,o&&G.onselect&&G.onselect(S),1&t&&!(1&W)&&G.onclick&&G.onclick(S),W=t}}),M.addEventListener(\"webglcontextlost\",s);var Z=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],J=[Z[0].slice(),Z[1].slice()];return _(),G.redraw=function(){w||(N=!0,x())},G}e.exports=s;var l=t(\"3d-view-controls\"),u=t(\"gl-axes3d\"),c=t(\"gl-axes3d/properties\"),h=t(\"gl-spikes3d\"),f=t(\"gl-select-static\"),d=t(\"gl-fbo\"),p=t(\"a-big-triangle\"),m=t(\"mouse-change\"),v=t(\"gl-mat4/perspective\"),g=t(\"./lib/shader\"),y=t(\"is-mobile\")()},{\"./lib/shader\":219,\"3d-view-controls\":35,\"a-big-triangle\":38,\"gl-axes3d\":147,\"gl-axes3d/properties\":154,\"gl-fbo\":163,\"gl-mat4/perspective\":183,\"gl-select-static\":253,\"gl-spikes3d\":263,\"is-mobile\":295,\"mouse-change\":451}],221:[function(t,e,r){r.pointVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\n\\nuniform mat3 matrix;\\nuniform float pointSize;\\nuniform float pointCloud;\\n\\nhighp float rand(vec2 co) {\\n  highp float a = 12.9898;\\n  highp float b = 78.233;\\n  highp float c = 43758.5453;\\n  highp float d = dot(co.xy, vec2(a, b));\\n  highp float e = mod(d, 3.14);\\n  return fract(sin(e) * c);\\n}\\n\\nvoid main() {\\n  vec3 hgPosition = matrix * vec3(position, 1);\\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\\n    // if we don't jitter the point size a bit, overall point cloud\\n    // saturation 'jumps' on zooming, which is disturbing and confusing\\n  gl_PointSize = pointSize * ((19.5 + rand(position)) / 20.0);\\n  if(pointCloud != 0.0) { // pointCloud is truthy\\n    // get the same square surface as circle would be\\n    gl_PointSize *= 0.886;\\n  }\\n}\",r.pointFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color, borderColor;\\nuniform float centerFraction;\\nuniform float pointCloud;\\n\\nvoid main() {\\n  float radius;\\n  vec4 baseColor;\\n  if(pointCloud != 0.0) { // pointCloud is truthy\\n    if(centerFraction == 1.0) {\\n      gl_FragColor = color;\\n    } else {\\n      gl_FragColor = mix(borderColor, color, centerFraction);\\n    }\\n  } else {\\n    radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n    if(radius > 1.0) {\\n      discard;\\n    }\\n    baseColor = mix(borderColor, color, step(radius, centerFraction));\\n    gl_FragColor = vec4(baseColor.rgb * baseColor.a, baseColor.a);\\n  }\\n}\\n\",r.pickVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 position;\\nattribute vec4 pickId;\\n\\nuniform mat3 matrix;\\nuniform float pointSize;\\nuniform vec4 pickOffset;\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  vec3 hgPosition = matrix * vec3(position, 1);\\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\\n  gl_PointSize = pointSize;\\n\\n  vec4 id = pickId + pickOffset;\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  fragId = id;\\n}\\n\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  float radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  gl_FragColor = fragId / 255.0;\\n}\\n\"},{}],222:[function(t,e,r){arguments[4][211][0].apply(r,arguments)},{\"./lib/GLError\":223,\"./lib/create-attributes\":224,\"./lib/create-uniforms\":225,\"./lib/reflect\":226,\"./lib/runtime-reflect\":227,\"./lib/shader-cache\":228,dup:211}],223:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],224:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\n",
       "\"./GLError\":223,dup:213}],225:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":223,\"./reflect\":226,dup:214}],226:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],227:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],228:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":223,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],229:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.plot=t,this.offsetBuffer=e,this.pickBuffer=r,this.shader=n,this.pickShader=i,this.sizeMin=.5,this.sizeMinCap=2,this.sizeMax=20,this.areaRatio=1,this.pointCount=0,this.color=[1,0,0,1],this.borderColor=[0,0,0,1],this.blend=!1,this.pickOffset=0,this.points=null}function i(t,e){var r,n=0,i=t.length>>>1;for(r=0;r<i;r++){var a=t[2*r],o=t[2*r+1];a>=e[0]&&a<=e[2]&&o>=e[1]&&o<=e[3]&&n++}return n}function a(t,e){var r=t.gl,i=s(r),a=s(r),l=o(r,u.pointVertex,u.pointFragment),c=o(r,u.pickVertex,u.pickFragment),h=new n(t,i,a,l,c);return h.update(e),t.addObject(h),h}var o=t(\"gl-shader\"),s=t(\"gl-buffer\"),l=t(\"typedarray-pool\"),u=t(\"./lib/shader\");e.exports=a;var c=n.prototype;c.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.offsetBuffer.dispose(),this.pickBuffer.dispose(),this.plot.removeObject(this)},c.update=function(t){function e(e,r){return e in t?t[e]:r}var r;t=t||{},this.sizeMin=e(\"sizeMin\",.5),this.sizeMax=e(\"sizeMax\",20),this.color=e(\"color\",[1,0,0,1]).slice(),this.areaRatio=e(\"areaRatio\",1),this.borderColor=e(\"borderColor\",[0,0,0,1]).slice(),this.blend=e(\"blend\",!1);var n=t.positions.length>>>1,i=t.positions instanceof Float32Array,a=t.idToIndex instanceof Int32Array&&t.idToIndex.length>=n,o=t.positions,s=i?o:l.mallocFloat32(o.length),u=a?t.idToIndex:l.mallocInt32(n);if(i||s.set(o),!a)for(s.set(o),r=0;r<n;r++)u[r]=r;this.points=o,this.offsetBuffer.update(s),this.pickBuffer.update(u),i||l.free(s),a||l.free(u),this.pointCount=n,this.pickOffset=0},c.unifiedDraw=function(){var t=[1,0,0,0,1,0,0,0,1],e=[0,0,0,0];return function(r){var n=void 0!==r,a=n?this.pickShader:this.shader,o=this.plot.gl,s=this.plot.dataBox;if(0===this.pointCount)return r;var l=s[2]-s[0],u=s[3]-s[1],c=i(this.points,s),h=this.plot.pickPixelRatio*Math.max(Math.min(this.sizeMinCap,this.sizeMin),Math.min(this.sizeMax,this.sizeMax/Math.pow(c,.33333)));t[0]=2/l,t[4]=2/u,t[6]=-2*s[0]/l-1,t[7]=-2*s[1]/u-1,this.offsetBuffer.bind(),a.bind(),a.attributes.position.pointer(),a.uniforms.matrix=t,a.uniforms.color=this.color,a.uniforms.borderColor=this.borderColor,a.uniforms.pointCloud=h<5,a.uniforms.pointSize=h,a.uniforms.centerFraction=Math.min(1,Math.max(0,Math.sqrt(1-this.areaRatio))),n&&(e[0]=255&r,e[1]=r>>8&255,e[2]=r>>16&255,e[3]=r>>24&255,this.pickBuffer.bind(),a.attributes.pickId.pointer(o.UNSIGNED_BYTE),a.uniforms.pickOffset=e,this.pickOffset=r);var f=o.getParameter(o.BLEND),d=o.getParameter(o.DITHER);return f&&!this.blend&&o.disable(o.BLEND),d&&o.disable(o.DITHER),o.drawArrays(o.POINTS,0,this.pointCount),f&&!this.blend&&o.enable(o.BLEND),d&&o.enable(o.DITHER),r+this.pointCount}}(),c.draw=c.unifiedDraw,c.drawPick=c.unifiedDraw,c.pick=function(t,e,r){var n=this.pickOffset,i=this.pointCount;if(r<n||r>=n+i)return null;var a=r-n,o=this.points;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}}},{\"./lib/shader\":221,\"gl-buffer\":155,\"gl-shader\":222,\"typedarray-pool\":540}],230:[function(t,e,r){function n(t,e,r,n){var i,a,o,s,l,u=e[0],c=e[1],h=e[2],f=e[3],d=r[0],p=r[1],m=r[2],v=r[3];return a=u*d+c*p+h*m+f*v,a<0&&(a=-a,d=-d,p=-p,m=-m,v=-v),1-a>1e-6?(i=Math.acos(a),o=Math.sin(i),s=Math.sin((1-n)*i)/o,l=Math.sin(n*i)/o):(s=1-n,l=n),t[0]=s*u+l*d,t[1]=s*c+l*p,t[2]=s*h+l*m,t[3]=s*f+l*v,t}e.exports=n},{}],231:[function(t,e,r){\"use strict\";e.exports={vertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\n\\nvec4 computePosition_1_0(vec2 posHi, vec2 posLo, vec2 scHi, vec2 scLo, vec2 trHi, vec2 trLo) {\\n  return vec4((posHi + trHi) * scHi\\n  \\t\\t\\t//FIXME: this thingy does not give noticeable precision gain, need test\\n            + (posLo + trLo) * scHi\\n            + (posHi + trHi) * scLo\\n            + (posLo + trLo) * scLo\\n            , 0, 1);\\n}\\n\\n\\nattribute vec2 positionHi, positionLo;\\nattribute float size, border;\\nattribute vec2 char, color;\\n\\n//this is 64-bit form of scale and translate\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pixelRatio;\\nuniform vec4 viewBox;\\nuniform sampler2D palette;\\n\\nvarying vec4 charColor, borderColor;\\nvarying vec2 charId;\\nvarying vec2 pointCoord;\\nvarying float pointSize;\\nvarying float borderWidth;\\n\\n\\nvoid main() {\\n  charColor = texture2D(palette, vec2(color.x / 255., 0));\\n  borderColor = texture2D(palette, vec2(color.y / 255., 0));\\n\\n  gl_PointSize = size * pixelRatio;\\n  pointSize = size * pixelRatio;\\n\\n  charId = char;\\n  borderWidth = border;\\n\\n  gl_Position = computePosition_1_0(\\n    positionHi, positionLo,\\n    scaleHi, scaleLo,\\n    translateHi, translateLo);\\n\\n  pointCoord = viewBox.xy + (viewBox.zw - viewBox.xy) * (gl_Position.xy * .5 + .5);\\n}\\n\",fragment:\"precision highp float;\\n#define GLSLIFY 1\\n\\nuniform sampler2D chars;\\nuniform vec2 charsShape;\\nuniform float charsStep, pixelRatio, charOffset;\\n\\nvarying vec4 borderColor;\\nvarying vec4 charColor;\\nvarying vec2 charId;\\nvarying vec2 pointCoord;\\nvarying float pointSize;\\nvarying float borderWidth;\\n\\nvoid main() {\\n\\tvec2 pointUV = (pointCoord - gl_FragCoord.xy + pointSize * .5) / pointSize;\\n\\tpointUV.x = 1. - pointUV.x;\\n\\tvec2 texCoord = ((charId + pointUV) * charsStep) / charsShape;\\n\\tfloat dist = texture2D(chars, texCoord).r;\\n\\n\\t//max-distance alpha\\n\\tif (dist < 1e-2)\\n\\t\\tdiscard;\\n\\n\\tfloat gamma = .0045 * charsStep / pointSize;\\n\\n    //null-border case\\n \\tif (borderWidth * borderColor.a == 0.) {\\n\\t\\tfloat charAmt = smoothstep(.748 - gamma, .748 + gamma, dist);\\n\\t\\tgl_FragColor = vec4(charColor.rgb, charAmt*charColor.a);\\n\\t\\treturn;\\n\\t}\\n\\n\\tfloat dif = 5. * pixelRatio * borderWidth / pointSize;\\n\\tfloat borderLevel = .748 - dif * .5;\\n\\tfloat charLevel = .748 + dif * .5;\\n\\n\\tfloat borderAmt = smoothstep(borderLevel - gamma, borderLevel + gamma, dist);\\n\\tfloat charAmt = smoothstep(charLevel - gamma, charLevel + gamma, dist);\\n\\n\\tvec4 color = borderColor;\\n\\tcolor.a *= borderAmt;\\n\\n\\tgl_FragColor = mix(color, charColor, charAmt);\\n}\\n\",pickVertex:\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi, positionLo;\\nattribute vec4 id;\\nattribute float size;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform vec4 pickOffset;\\nuniform float pixelRatio;\\n\\nvarying vec4 fragColor;\\n\\n\\nvec4 computePosition_1_0(vec2 posHi, vec2 posLo, vec2 scHi, vec2 scLo, vec2 trHi, vec2 trLo) {\\n  return vec4((posHi + trHi) * scHi\\n  \\t\\t\\t//FIXME: this thingy does not give noticeable precision gain, need test\\n            + (posLo + trLo) * scHi\\n            + (posHi + trHi) * scLo\\n            + (posLo + trLo) * scLo\\n            , 0, 1);\\n}\\n\\n\\nvoid main() {\\n  vec4 fragId = id + pickOffset;\\n\\n  fragId.y += floor(fragId.x / 256.0);\\n  fragId.x -= floor(fragId.x / 256.0) * 256.0;\\n\\n  fragId.z += floor(fragId.y / 256.0);\\n  fragId.y -= floor(fragId.y / 256.0) * 256.0;\\n\\n  fragId.w += floor(fragId.z / 256.0);\\n  fragId.z -= floor(fragId.z / 256.0) * 256.0;\\n\\n  fragColor = fragId / 255.0;\\n\\n  gl_PointSize = size * .25 * pixelRatio;\\n\\n  gl_Position = computePosition_1_0(\\n    positionHi, positionLo,\\n    scaleHi, scaleLo,\\n    translateHi, translateLo);\\n}\\n\",pickFragment:\"precision lowp float;\\n#define GLSLIFY 1\\nvarying vec4 fragColor;\\nvoid main() {\\n  gl_FragColor = fragColor;\\n}\\n\"}},{}],232:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],233:[function(t,e,r){arguments[4][211][0].apply(r,arguments)},{\"./lib/GLError\":234,\"./lib/create-attributes\":235,\"./lib/create-uniforms\":236,\"./lib/reflect\":237,\"./lib/runtime-reflect\":238,\"./lib/shader-cache\":239,dup:211}],234:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],235:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\"./GLError\":234,dup:213}],236:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":234,\"./reflect\":237,dup:214}],237:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],238:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],239:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":234,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],240:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){a<=4*f?i(0,a-1,t,e,r,n):h(0,a-1,t,e,r,n)}function i(t,e,r,n,i,a){for(var o=t+1;o<=e;++o){for(var s=r[o],l=n[2*o],u=n[2*o+1],c=i[o],h=a[o],f=o;f>t;){var d=r[f-1],p=n[2*(f-1)];if((d-s||l-p)>=0)break;r[f]=d,n[2*f]=p,n[2*f+1]=n[2*f-1],i[f]=i[f-1],a[f]=a[f-1],f-=1}r[f]=s,n[2*f]=l,n[2*f+1]=u,i[f]=c,a[f]=h}}function a(t,e,r,n,i,a){var o=r[t],s=n[2*t],l=n[2*t+1],u=i[t],c=a[t];r[t]=r[e],n[2*t]=n[2*e],n[2*t+1]=n[2*e+1],i[t]=i[e],a[t]=a[e],r[e]=o,n[2*e]=s,n[2*e+1]=l,i[e]=u,a[e]=c}function o(t,e,r,n,i,a){r[t]=r[e],n[2*t]=n[2*e],n[2*t+1]=n[2*e+1],i[t]=i[e],a[t]=a[e]}function s(t,e,r,n,i,a,o){var s=n[t],l=i[2*t],u=i[2*t+1],c=a[t],h=o[t];n[t]=n[e],i[2*t]=i[2*e],i[2*t+1]=i[2*e+1],a[t]=a[e],o[t]=o[e],n[e]=n[r],i[2*e]=i[2*r],i[2*e+1]=i[2*r+1],a[e]=a[r],o[e]=o[r],n[r]=s,i[2*r]=l,i[2*r+1]=u,a[r]=c,o[r]=h}function l(t,e,r,n,i,a,o,s,l,u,c){s[t]=s[e],l[2*t]=l[2*e],l[2*t+1]=l[2*e+1],u[t]=u[e],c[t]=c[e],s[e]=r,l[2*e]=n,l[2*e+1]=i,u[e]=a,c[e]=o}function u(t,e,r,n,i){return(r[t]-r[e]||n[2*e]-n[2*t]||i[t]-i[e])<0}function c(t,e,r,n,i,a,o,s){return(e-a[t]||o[2*t]-r||i-s[t])<0}function h(t,e,r,n,d,p){var m=(e-t+1)/6|0,v=t+m,g=e-m,y=t+e>>1,b=y-m,x=y+m,_=v,w=b,M=y,k=x,A=g,T=t+1,S=e-1,E=0;u(_,w,r,n,d,p)&&(E=_,_=w,w=E),u(k,A,r,n,d,p)&&(E=k,k=A,A=E),u(_,M,r,n,d,p)&&(E=_,_=M,M=E),u(w,M,r,n,d,p)&&(E=w,w=M,M=E),u(_,k,r,n,d,p)&&(E=_,_=k,k=E),u(M,k,r,n,d,p)&&(E=M,M=k,k=E),u(w,A,r,n,d,p)&&(E=w,w=A,A=E),u(w,M,r,n,d,p)&&(E=w,w=M,M=E),u(k,A,r,n,d,p)&&(E=k,k=A,A=E);var L=r[w],C=n[2*w],z=n[2*w+1],I=d[w],D=p[w],P=r[k],O=n[2*k],R=n[2*k+1],F=d[k],j=p[k],N=_,B=M,U=A,V=v,H=y,q=g,G=r[N],Y=r[B],X=r[U];r[V]=G,r[H]=Y,r[q]=X;for(var W=0;W<2;++W){var Z=n[2*N+W],J=n[2*B+W],K=n[2*U+W];n[2*V+W]=Z,n[2*H+W]=J,n[2*q+W]=K}var Q=d[N],$=d[B],tt=d[U];d[V]=Q,d[H]=$,d[q]=tt;var et=p[N],rt=p[B],nt=p[U];p[V]=et,p[H]=rt,p[q]=nt,o(b,t,r,n,d,p),o(x,e,r,n,d,p);for(var it=T;it<=S;++it)if(c(it,L,C,z,I,r,n,d))it!==T&&a(it,T,r,n,d,p),++T;else if(!c(it,P,O,R,F,r,n,d))for(;;){if(c(S,P,O,R,F,r,n,d)){c(S,L,C,z,I,r,n,d)?(s(it,T,S,r,n,d,p),++T,--S):(a(it,S,r,n,d,p),--S);break}if(--S<it)break}l(t,T-1,L,C,z,I,D,r,n,d,p),l(e,S+1,P,O,R,F,j,r,n,d,p),T-2-t<=f?i(t,T-2,r,n,d,p):h(t,T-2,r,n,d,p),e-(S+2)<=f?i(S+2,e,r,n,d,p):h(S+2,e,r,n,d,p),S-T<=f?i(T,S,r,n,d,p):h(T,S,r,n,d,p)}e.exports=n;var f=32},{}],241:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){for(var l=r,u=r;u<n;++u){var c=t[2*u],h=t[2*u+1],f=e[u];i<=c&&c<=o&&a<=h&&h<=s&&(u===l?l+=1:(t[2*u]=t[2*l],t[2*u+1]=t[2*l+1],e[u]=e[l],t[2*l]=c,t[2*l+1]=h,e[l]=f,l+=1))}return l}function i(t,e,r){this.pixelSize=t,this.offset=e,this.count=r}function a(t,e,r,a){function l(i,a,o,s,u,c){var h=.5*o,f=s+1,d=u-s;r[_]=d,x[_++]=c;for(var p=0;p<2;++p)for(var m=0;m<2;++m){var v=i+p*h,g=a+m*h,y=n(t,e,f,u,v,g,v+h,g+h);if(y!==f){if(y-f>=Math.max(.9*d,32)){var b=u+s>>>1;l(v,g,h,f,b,c+1),f=b}l(v,g,h,f,y,c+1),f=y}}}var u=t.length>>>1;if(u<1)return[];for(var c=1/0,h=1/0,f=-1/0,d=-1/0,p=0;p<u;++p){var m=t[2*p],v=t[2*p+1];c=Math.min(c,m),f=Math.max(f,m),h=Math.min(h,v),d=Math.max(d,v),e[p]=p}c===f&&(f+=1+Math.abs(f)),h===d&&(d+=1+Math.abs(f));var g=1/(f-c),y=1/(d-h),b=Math.max(f-c,d-h);a=a||[0,0,0,0],a[0]=c,a[1]=h,a[2]=f,a[3]=d;var x=o.mallocInt32(u),_=0;l(c,h,b,0,u,0),s(x,t,e,r,u);for(var w=[],M=0,k=u,_=u-1;_>=0;--_){t[2*_]=(t[2*_]-c)*g,t[2*_+1]=(t[2*_+1]-h)*y;var A=x[_];A!==M&&(w.push(new i(b*Math.pow(.5,A),_+1,k-(_+1))),k=_+1,M=A)}return w.push(new i(b*Math.pow(.5,A+1),0,k)),o.free(x),w}var o=t(\"typedarray-pool\"),s=t(\"./lib/sort\");e.exports=a},{\"./lib/sort\":240,\"typedarray-pool\":540}],242:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){this.plot=t,this.shader=e,this.pickShader=r,this.positionBuffer=n,this.sizeBuffer=i,this.colorBuffer=a,this.idBuffer=o,this.charBuffer=s,this.pointCount=0,this.pickOffset=0,this.points=null,this.scales=[],this.xCoords=[],this.charCanvas=document.createElement(\"canvas\"),this.charTexture=m(this.plot.gl,this.charCanvas),this.charStep=400,this.charFit=.255,this.snapThreshold=1e4,this.paletteTexture=m(this.plot.gl,[256,1])}function i(){var t=this.plot,e=t.viewBox,r=t.dataBox,n=t.pixelRatio,i=r[2]-r[0],a=r[3]-r[1],u=2/i,c=2/a,h=-r[0]-.5*i,f=-r[1]-.5*a;_[0]=u,w[0]=u-_[0],_[1]=c,w[1]=c-_[1],M[0]=h,k[0]=h-M[0],M[1]=f,k[1]=f-M[1];var d=e[2]-e[0],p=e[3]-e[1];o=Math.min(i/d,a/p),A[0]=2*n/d,A[1]=2*n/p,s=r[0],l=r[2]}function a(t,e){var r=t.gl,i=u(r,f.vertex,f.fragment),a=u(r,f.pickVertex,f.pickFragment),o=c(r),s=c(r),l=c(r),h=c(r),d=c(r),p=new n(t,i,a,o,s,l,h,d);return p.update(e),t.addObject(p),p}e.exports=a;var o,s,l,u=t(\"gl-shader\"),c=t(\"gl-buffer\"),h=t(\"typedarray-pool\"),f=t(\"./lib/shaders\"),d=t(\"snap-points-2d\"),p=t(\"font-atlas-sdf\"),m=t(\"gl-texture2d\"),v=t(\"color-id\"),g=t(\"ndarray\"),y=t(\"clamp\"),b=t(\"binary-search-bounds\"),x=n.prototype,_=new Float32Array([0,0]),w=new Float32Array([0,0]),M=new Float32Array([0,0]),k=new Float32Array([0,0]),A=[0,0],T=[0,0,0,0];x.drawPick=function(t){var e=void 0!==t,r=this.plot,n=this.pointCount,a=n>this.snapThreshold;if(!n)return t;i.call(this);var u=r.gl,c=e?this.pickShader:this.shader,h=u.isEnabled(u.BLEND);if(c.bind(),e){this.pickOffset=t;for(var f=0;f<4;++f)T[f]=t>>8*f&255;c.uniforms.pickOffset=T,this.idBuffer.bind(),c.attributes.id.pointer(u.UNSIGNED_BYTE,!1)}else u.blendFuncSeparate(u.SRC_ALPHA,u.ONE_MINUS_SRC_ALPHA,u.ONE,u.ONE_MINUS_SRC_ALPHA),u.blendColor(0,0,0,1),h||u.enable(u.BLEND),this.colorBuffer.bind(),c.attributes.color.pointer(u.UNSIGNED_BYTE,!1),this.charBuffer.bind(),c.attributes.char.pointer(u.UNSIGNED_BYTE,!1),c.uniforms.chars=this.charTexture.bind(0),c.uniforms.charsShape=[this.charCanvas.width,this.charCanvas.height],c.uniforms.charsStep=this.charStep,c.uniforms.palette=this.paletteTexture.bind(1);this.sizeBuffer.bind(),c.attributes.size.pointer(u.FLOAT,!1,8,0),e||c.attributes.border.pointer(u.FLOAT,!1,8,4),this.positionBuffer.bind(),c.attributes.positionHi.pointer(u.FLOAT,!1,16,0),c.attributes.positionLo.pointer(u.FLOAT,!1,16,8),c.uniforms.pixelRatio=r.pixelRatio,c.uniforms.scaleHi=_,c.uniforms.scaleLo=w,c.uniforms.translateHi=M,c.uniforms.translateLo=k,c.uniforms.viewBox=r.viewBox;var d=this.scales;if(a)for(var p=d.length-1;p>=0;p--){var m=d[p];if(!(m.pixelSize&&m.pixelSize<1.25*o&&p>1)){var v=m.offset,g=m.count+v,y=b.ge(this.xCoords,s,v,g-1),x=b.lt(this.xCoords,l,y,g-1)+1;x>y&&u.drawArrays(u.POINTS,y,x-y)}}else u.drawArrays(u.POINTS,0,n);if(e)return t+n;h?u.blendFunc(u.ONE,u.ONE_MINUS_SRC_ALPHA):u.disable(u.BLEND)},x.draw=x.drawPick,x.pick=function(t,e,r){var n=this.pickOffset,i=this.pointCount;if(r<n||r>=n+i)return null;var a=r-n,o=this.points;return{object:this,pointId:a,dataCoord:[o[2*a],o[2*a+1]]}},x.update=function(t){t=t||{};var e=t.positions||[],r=t.colors||[],n=t.glyphs||[],i=t.sizes||[],a=t.borderWidths||[],o=t.borderColors||[],s=this.plot.gl,l=this.pointCount,u=l>this.snapThreshold;if(null!=t.positions){this.points=e,l=this.points.length/2,u=l>this.snapThreshold;var c=h.mallocFloat32(2*l),f=h.mallocFloat64(2*l),m=h.mallocUint32(l),b=h.mallocFloat32(4*l);f.set(this.points),u&&(this.i2idx&&h.free(this.i2idx),this.i2idx=h.mallocInt32(l),this.scales=d(f,this.i2idx,c)),this.pointCount=l;for(var x=0;x<l;++x){var _=u?this.i2idx[x]:x;m[x]=_;var w=e[2*_],M=e[2*_+1];b[4*x]=w,b[4*x+1]=M,b[4*x+2]=w-b[4*x],b[4*x+3]=M-b[4*x+1],this.xCoords[x]=w}this.idBuffer.update(m),this.positionBuffer.update(b),h.free(b),h.free(m),h.free(f),h.free(c)}for(var k=h.mallocFloat32(2*l),A=h.mallocUint8(2*l),T=h.mallocUint8(2*l),S={},E=[],L=[],C=[],x=0,z=l,I=0;x<z;++x){var D=[255*r[4*x],255*r[4*x+1],255*r[4*x+2],255*r[4*x+3]],P=v(D,!1);null==S[P]&&(S[P]=I++,L.push(D[0]),L.push(D[1]),L.push(D[2]),L.push(D[3])),E.push(P),o&&o.length&&(D=[255*o[4*x],255*o[4*x+1],255*o[4*x+2],255*o[4*x+3]],P=v(D,!1),null==S[P]&&(S[P]=I++,L.push(D[0]),L.push(D[1]),L.push(D[2]),L.push(D[3])),C.push(P))}for(var O={},x=0,z=l,I=0;x<z;x++){var R=n[x];null==O[R]&&(O[R]=I++)}for(var F=0,x=0,z=i.length;x<z;++x)i[x]>F&&(F=i[x]);var j=this.charStep;this.charStep=y(Math.ceil(4*F),128,768);var N=Object.keys(O),B=this.charStep,U=Math.floor(B/2),V=s.getParameter(s.MAX_TEXTURE_SIZE),H=V/B*(V/B),q=Math.min(V,B*N.length),G=Math.min(V,B*Math.ceil(B*N.length/V)),Y=Math.floor(q/B);N.length>H&&console.warn(\"gl-scatter2d-fancy: number of characters is more than maximum texture size. Try reducing it.\"),this.chars&&this.chars+\"\"==N+\"\"&&this.charStep==j||(this.charCanvas=p({canvas:this.charCanvas,family:\"sans-serif\",size:U,shape:[q,G],step:[B,B],chars:N,align:!0,fit:this.charFit}),this.chars=N);for(var x=0;x<l;++x){var _=u?this.i2idx[x]:x,X=i[_],W=a[_];k[2*x]=2*X,k[2*x+1]=W;var P=E[_],Z=S[P];A[2*x]=Z;var J=C[_],K=S[J];A[2*x+1]=K;var R=n[_],Q=O[R];T[2*x+1]=Math.floor(Q/Y),T[2*x]=Q%Y}this.sizeBuffer.update(k),this.colorBuffer.update(A),this.charBuffer.update(T),this.charTexture.shape=[this.charCanvas.width,this.charCanvas.height],this.charCanvas&&this.charCanvas.width&&this.charTexture.setPixels(this.charCanvas),this.paletteTexture.setPixels(g(L.slice(0,1024),[256,1,4])),h.free(k),h.free(A),h.free(T)},x.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBuffer.dispose(),this.sizeBuffer.dispose(),this.colorBuffer.dispose(),this.idBuffer.dispose(),this.charBuffer.dispose(),this.plot.removeObject(this)}},{\"./lib/shaders\":231,\"binary-search-bounds\":232,clamp:87,\"color-id\":91,\"font-atlas-sdf\":133,\"gl-buffer\":155,\"gl-shader\":233,\"gl-texture2d\":266,ndarray:466,\"snap-points-2d\":241,\"typedarray-pool\":540}],243:[function(t,e,r){r.pointVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec2 positionHi, positionLo;\\nattribute float weight;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pointSize, useWeight;\\n\\nvarying float fragWeight;\\n\\n\\nvec4 pfx_1_0(vec2 scaleHi, vec2 scaleLo, vec2 translateHi, vec2 translateLo, vec2 positionHi, vec2 positionLo) {\\n  return vec4((positionHi + translateHi) * scaleHi\\n            + (positionLo + translateLo) * scaleHi\\n            + (positionHi + translateHi) * scaleLo\\n            + (positionLo + translateLo) * scaleLo, 0.0, 1.0);\\n}\\n\\nvoid main() {\\n  gl_Position = pfx_1_0(scaleHi, scaleLo, translateHi, translateLo, positionHi, positionLo);\\n  gl_PointSize = pointSize;\\n  fragWeight = mix(1.0, weight, useWeight);\\n}\",r.pointFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color, borderColor;\\nuniform float centerFraction;\\n\\nvarying float fragWeight;\\n\\nfloat smoothStep(float x, float y) {\\n  return 1.0 / (1.0 + exp(50.0*(x - y)));\\n}\\n\\nvoid main() {\\n  float radius = length(2.0*gl_PointCoord.xy-1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  vec4 baseColor = mix(borderColor, color, smoothStep(radius, centerFraction));\\n  float alpha = 1.0 - pow(1.0 - baseColor.a, fragWeight);\\n  gl_FragColor = vec4(baseColor.rgb * alpha, alpha);\\n}\\n\",r.pickVertex=\"precision highp float;\\n#define GLSLIFY 1\\n\\nvec4 pfx_1_0(vec2 scaleHi, vec2 scaleLo, vec2 translateHi, vec2 translateLo, vec2 positionHi, vec2 positionLo) {\\n  return vec4((positionHi + translateHi) * scaleHi\\n            + (positionLo + translateLo) * scaleHi\\n            + (positionHi + translateHi) * scaleLo\\n            + (positionLo + translateLo) * scaleLo, 0.0, 1.0);\\n}\\n\\nattribute vec2 positionHi, positionLo;\\nattribute vec4 pickId;\\n\\nuniform vec2 scaleHi, scaleLo, translateHi, translateLo;\\nuniform float pointSize;\\nuniform vec4 pickOffset;\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n\\n  vec4 id = pickId + pickOffset;\\n  id.y += floor(id.x / 256.0);\\n  id.x -= floor(id.x / 256.0) * 256.0;\\n\\n  id.z += floor(id.y / 256.0);\\n  id.y -= floor(id.y / 256.0) * 256.0;\\n\\n  id.w += floor(id.z / 256.0);\\n  id.z -= floor(id.z / 256.0) * 256.0;\\n\\n  gl_Position = pfx_1_0(scaleHi, scaleLo, translateHi, translateLo, positionHi, positionLo);\\n  gl_PointSize = pointSize;\\n  fragId = id;\\n}\",r.pickFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragId;\\n\\nvoid main() {\\n  float radius = length(2.0 * gl_PointCoord.xy - 1.0);\\n  if(radius > 1.0) {\\n    discard;\\n  }\\n  gl_FragColor = fragId / 255.0;\\n}\"},{}],244:[function(t,e,r){arguments[4][83][0].apply(r,arguments)},{dup:83}],245:[function(t,e,r){arguments[4][240][0].apply(r,arguments)},{dup:240}],246:[function(t,e,r){arguments[4][241][0].apply(r,arguments)},{\"./lib/sort\":245,dup:241,\"typedarray-pool\":540}],247:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){this.plot=t,this.positionBufferHi=e,this.positionBufferLo=r,this.pickBuffer=n,this.weightBuffer=i,this.shader=a,this.pickShader=o,this.scales=[],this.size=12,this.borderSize=1,this.pointCount=0,this.color=[1,0,0,1],this.borderColor=[0,0,0,1],this.bounds=[1/0,1/0,-1/0,-1/0],this.pickOffset=0,this.points=null,this.xCoords=null,this.snapPoints=!0}function i(t,e){var r=t.gl,i=o(r),s=o(r),l=o(r),u=o(r),h=a(r,c.pointVertex,c.pointFragment),f=a(r,c.pickVertex,c.pickFragment),d=new n(t,i,s,l,u,h,f);return d.update(e),t.addObject(d),d}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"binary-search-bounds\"),l=t(\"snap-points-2d\"),u=t(\"typedarray-pool\"),c=t(\"./lib/shader\"),h=t(\"array-normalize\"),f=t(\"array-bounds\");e.exports=i;var d=n.prototype,p=new Float32Array(2),m=new Float32Array(2),v=new Float32Array(2),g=new Float32Array(2),y=[0,0,0,0];d.dispose=function(){this.shader.dispose(),this.pickShader.dispose(),this.positionBufferHi.dispose(),this.positionBufferLo.dispose(),this.pickBuffer.dispose(),this.xCoords&&u.free(this.xCoords),this.plot.removeObject(this)},d.update=function(t){function e(e,r){return e in t?t[e]:r}if(t=t||{},this.size=e(\"size\",12),this.color=e(\"color\",[1,0,0,1]).slice(),this.borderSize=e(\"borderSize\",1),this.borderColor=e(\"borderColor\",[0,0,0,1]).slice(),this.snapPoints=e(\"snapPoints\",!0),null!=t.positions){this.xCoords&&u.free(this.xCoords),this.points=t.positions;var r=this.points.length>>>1,n=u.mallocInt32(r),i=u.mallocFloat32(r),a=u.mallocFloat64(2*r);if(a.set(this.points),this.snapPoints)this.scales=l(a,n,i,this.bounds);else{this.bounds=f(a,2),h(a,2,this.bounds);for(var o=0;o<r;o++)n[o]=o,i[o]=1}var s=u.mallocFloat64(r),c=u.mallocFloat32(2*r),d=u.mallocFloat32(2*r);c.set(a);for(var o=0,p=0;o<r;o++,p+=2)d[p]=a[p]-c[p],d[p+1]=a[p+1]-c[p+1],s[o]=a[p];this.positionBufferHi.update(c),this.positionBufferLo.update(d),this.pickBuffer.update(n),this.weightBuffer.update(i),u.free(c),u.free(d),u.free(i),u.free(a),u.free(n),this.xCoords=s,this.pointCount=r,this.pickOffset=0}},d.draw=function(t){var e=void 0!==t,r=this.plot,n=e?this.pickShader:this.shader,i=this.scales,a=this.positionBufferHi,o=this.positionBufferLo,s=this.pickBuffer,l=this.bounds,u=this.size,c=this.borderSize,h=r.gl,f=e?r.pickPixelRatio:r.pixelRatio,d=r.viewBox,b=r.dataBox;if(0===this.pointCount)return t;var x=l[2]-l[0],_=l[3]-l[1],w=b[2]-b[0],M=b[3]-b[1],k=(d[2]-d[0])*f/r.pixelRatio,A=(d[3]-d[1])*f/r.pixelRatio,T=this.pixelSize=Math.min(w/k,M/A),S=2*x/w,E=2*_/M;p[0]=S,p[1]=E,m[0]=S-p[0],m[1]=E-p[1];var L=(l[0]-b[0]-.5*w)/x,C=(l[1]-b[1]-.5*M)/_;v[0]=L,v[1]=C,g[0]=L-v[0],g[1]=C-v[1],n.bind(),n.uniforms.scaleHi=p,n.uniforms.scaleLo=m,n.uniforms.translateHi=v,n.uniforms.translateLo=g,n.uniforms.color=this.color,n.uniforms.borderColor=this.borderColor,n.uniforms.pointSize=f*(u+c),n.uniforms.centerFraction=0===this.borderSize?2:u/(u+c+1.25),a.bind(),n.attributes.positionHi.pointer(),o.bind(),n.attributes.positionLo.pointer(),e?(this.pickOffset=t,y[0]=255&t,y[1]=t>>8&255,y[2]=t>>16&255,y[3]=t>>24&255,n.uniforms.pickOffset=y,s.bind(),n.attributes.pickId.pointer(h.UNSIGNED_BYTE)):(n.uniforms.useWeight=1,this.weightBuffer.bind(),n.attributes.weight.pointer());var z=!0;if(this.snapPoints)for(var I=i.length-1;I>=0;I--){var D=i[I];if(!(D.pixelSize<T&&I>1)){var P=this.getVisibleRange(D),O=P[0],R=P[1];R>O&&h.drawArrays(h.POINTS,O,R-O),!e&&z&&(z=!1,n.uniforms.useWeight=0)}}else h.drawArrays(h.POINTS,0,this.pointCount);return t+this.pointCount},d.getVisibleRange=function(t){var e=this.plot.dataBox,r=this.bounds,n=this.pixelSize,i=this.size,a=this.plot.pixelRatio,o=r[2]-r[0];r[3],r[1];if(!t)for(var t,l=this.scales.length-1;l>=0&&(t=this.scales[l],t.pixelSize<n&&l>1);l--);var u=this.xCoords,c=(e[0]-r[0]-n*i*a)/o,h=(e[2]-r[0]+n*i*a)/o,f=t.offset,d=t.count+f,p=s.ge(u,c,f,d-1);return[p,s.lt(u,h,p,d-1)+1]},d.drawPick=d.draw,d.pick=function(t,e,r){var n=r-this.pickOffset;return n<0||n>=this.pointCount?null:{object:this,pointId:n,dataCoord:[this.points[2*n],this.points[2*n+1]]}}},{\"./lib/shader\":243,\"array-bounds\":43,\"array-normalize\":44,\"binary-search-bounds\":244,\"gl-buffer\":155,\"gl-shader\":254,\"snap-points-2d\":246,\"typedarray-pool\":540}],248:[function(t,e,r){\"use strict\";function n(t,e){var r=a[e];if(r||(r=a[e]={}),t in r)return r[t];for(var n=i(t,{textAlign:\"center\",textBaseline:\"middle\",lineHeight:1,font:e}),o=i(t,{triangles:!0,textAlign:\"center\",textBaseline:\"middle\",lineHeight:1,font:e}),s=[[1/0,1/0],[-1/0,-1/0]],l=0;l<n.positions.length;++l)for(var u=n.positions[l],c=0;c<2;++c)s[0][c]=Math.min(s[0][c],u[c]),s[1][c]=Math.max(s[1][c],u[c]);return r[t]=[o,n,s]}var i=t(\"vectorize-text\");e.exports=n;var a={}},{\"vectorize-text\":553}],249:[function(t,e,r){function n(t,e){var r=i(t,e),n=r.attributes;return n.position.location=0,n.color.location=1,n.glyph.location=2,n.id.location=3,r}var i=t(\"gl-shader\"),a=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\n\\nuniform vec4 highlightId;\\nuniform float highlightScale;\\nuniform mat4 model, view, projection;\\nuniform vec3 clipBounds[2];\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0]))   || \\n     any(greaterThan(position, clipBounds[1])) ) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float scale = 1.0;\\n    if(distance(highlightId, id) < 0.0001) {\\n      scale = highlightScale;\\n    }\\n\\n    vec4 worldPosition = model * vec4(position, 1);\\n    vec4 viewPosition = view * worldPosition;\\n    viewPosition = viewPosition / viewPosition.w;\\n    vec4 clipPosition = projection * (viewPosition + scale * vec4(glyph.x, -glyph.y, 0, 0));\\n    \\n    gl_Position = clipPosition;\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = position;\\n  }\\n}\",o=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\nuniform mat4 model, view, projection;\\nuniform vec2 screenSize;\\nuniform vec3 clipBounds[2];\\nuniform float highlightScale, pixelRatio;\\nuniform vec4 highlightId;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0])) || any(greaterThan(position, clipBounds[1]))) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float scale = pixelRatio;\\n    if(distance(highlightId.bgr, id.bgr) < 0.001) {\\n      scale *= highlightScale;\\n    }\\n\\n    vec4 worldPosition = model * vec4(position, 1.0);\\n    vec4 viewPosition = view * worldPosition;\\n    vec4 clipPosition = projection * viewPosition;\\n    clipPosition /= clipPosition.w;\\n    \\n    gl_Position = clipPosition + vec4(screenSize * scale * vec2(glyph.x, -glyph.y), 0.0, 0.0);\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = position;\\n  }\\n}\",s=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position;\\nattribute vec4 color;\\nattribute vec2 glyph;\\nattribute vec4 id;\\n\\nuniform float highlightScale;\\nuniform vec4 highlightId;\\nuniform vec3 axes[2];\\nuniform mat4 model, view, projection;\\nuniform vec2 screenSize;\\nuniform vec3 clipBounds[2];\\nuniform float scale, pixelRatio;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(position, clipBounds[0]))   ||\\n     any(greaterThan(position, clipBounds[1])) ) {\\n    gl_Position = vec4(0,0,0,0);\\n  } else {\\n    float lscale = pixelRatio * scale;\\n    if(distance(highlightId, id) < 0.0001) {\\n      lscale *= highlightScale;\\n    }\\n\\n    vec4 clipCenter   = projection * view * model * vec4(position, 1);\\n    vec3 dataPosition = position + 0.5*lscale*(axes[0] * glyph.x + axes[1] * glyph.y) * clipCenter.w * screenSize.y;\\n    vec4 clipPosition = projection * view * model * vec4(dataPosition, 1);\\n\\n    gl_Position = clipPosition;\\n    interpColor = color;\\n    pickId = id;\\n    dataCoordinate = dataPosition;\\n  }\\n}\\n\",l=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 fragClipBounds[2];\\nuniform float opacity;\\n\\nvarying vec4 interpColor;\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(dataCoordinate, fragClipBounds[0]))   ||\\n     any(greaterThan(dataCoordinate, fragClipBounds[1])) ) {\\n    discard;\\n  } else {\\n    gl_FragColor = interpColor * opacity;\\n  }\\n}\\n\",u=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec3 fragClipBounds[2];\\nuniform float pickGroup;\\n\\nvarying vec4 pickId;\\nvarying vec3 dataCoordinate;\\n\\nvoid main() {\\n  if(any(lessThan(dataCoordinate, fragClipBounds[0]))   || \\n     any(greaterThan(dataCoordinate, fragClipBounds[1])) ) {\\n    discard;\\n  } else {\\n    gl_FragColor = vec4(pickGroup, pickId.bgr);\\n  }\\n}\",c=[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec4\"},{name:\"glyph\",type:\"vec2\"},{name:\"id\",type:\"vec4\"}],h={vertex:a,fragment:l,attributes:c},f={vertex:o,fragment:l,attributes:c},d={vertex:s,fragment:l,attributes:c},p={vertex:a,fragment:u,attributes:c},m={vertex:o,fragment:u,attributes:c},v={vertex:s,fragment:u,attributes:c};r.createPerspective=function(t){return n(t,h)},r.createOrtho=function(t){return n(t,f)},r.createProject=function(t){return n(t,d)},r.createPickPerspective=function(t){return n(t,p)},r.createPickOrtho=function(t){return n(t,m)},r.createPickProject=function(t){return n(t,v)}},{\"gl-shader\":254}],250:[function(t,e,r){\"use strict\";function n(t,e){var r=t[0],n=t[1],i=t[2],a=t[3];return t[0]=e[0]*r+e[4]*n+e[8]*i+e[12]*a,t[1]=e[1]*r+e[5]*n+e[9]*i+e[13]*a,t[2]=e[2]*r+e[6]*n+e[10]*i+e[14]*a,t[3]=e[3]*r+e[7]*n+e[11]*i+e[15]*a,t}function i(t,e,r,i){return n(i,i,r),n(i,i,e),n(i,i,t)}function a(t,e){this.index=t,this.dataCoordinate=this.position=e}function o(t,e,r,n,i,o,s,l,u,c,h,f){this.gl=t,this.pixelRatio=1,this.shader=e,this.orthoShader=r,this.projectShader=n,this.pointBuffer=i,this.colorBuffer=o,this.glyphBuffer=s,this.idBuffer=l,this.vao=u,this.vertexCount=0,this.lineVertexCount=0,this.opacity=1,this.lineWidth=0,this.projectScale=[2/3,2/3,2/3],this.projectOpacity=[1,1,1],this.pickId=0,this.pickPerspectiveShader=c,this.pickOrthoShader=h,this.pickProjectShader=f,this.points=[],this._selectResult=new a(0,[0,0,0]),this.useOrtho=!0,this.bounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.axesProject=[!0,!0,!0],this.axesBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.highlightId=[1,1,1,1],this.highlightScale=2,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.dirty=!0}function s(t){return t[0]=t[1]=t[2]=0,t}function l(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=1,t}function u(t,e,r,n){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[r]=n,t}function c(t){for(var e=L,r=0;r<2;++r)for(var n=0;n<3;++n)e[r][n]=Math.max(Math.min(t[r][n],1e8),-1e8);return e}function h(t,e,r,n,a){var o,h=e.axesProject,f=e.gl,d=t.uniforms,p=r.model||x,m=r.view||x,v=r.projection||x,y=e.axesBounds,b=c(e.clipBounds);o=e.axes?e.axes.lastCubeProps.axis:[1,1,1],w[0]=2/f.drawingBufferWidth,w[1]=2/f.drawingBufferHeight,t.bind(),d.view=m,d.projection=v,d.screenSize=w,d.highlightId=e.highlightId,d.highlightScale=e.highlightScale,d.clipBounds=b,\n",
       "d.pickGroup=e.pickId/255,d.pixelRatio=e.pixelRatio;for(var _=0;_<3;++_)if(h[_]&&e.projectOpacity[_]<1===n){d.scale=e.projectScale[_],d.opacity=e.projectOpacity[_];for(var L=S,C=0;C<16;++C)L[C]=0;for(var C=0;C<4;++C)L[5*C]=1;L[5*_]=0,o[_]<0?L[12+_]=y[0][_]:L[12+_]=y[1][_],g(L,p,L),d.model=L;var z=(_+1)%3,I=(_+2)%3,D=s(M),P=s(k);D[z]=1,P[I]=1;var O=i(v,m,p,l(A,D)),R=i(v,m,p,l(T,P));if(Math.abs(O[1])>Math.abs(R[1])){var F=O;O=R,R=F,F=D,D=P,P=F;var j=z;z=I,I=j}O[0]<0&&(D[z]=-1),R[1]>0&&(P[I]=-1);for(var N=0,B=0,C=0;C<4;++C)N+=Math.pow(p[4*z+C],2),B+=Math.pow(p[4*I+C],2);D[z]/=Math.sqrt(N),P[I]/=Math.sqrt(B),d.axes[0]=D,d.axes[1]=P,d.fragClipBounds[0]=u(E,b[0],_,-1e8),d.fragClipBounds[1]=u(E,b[1],_,1e8),e.vao.draw(f.TRIANGLES,e.vertexCount),e.lineWidth>0&&(f.lineWidth(e.lineWidth),e.vao.draw(f.LINES,e.lineVertexCount,e.vertexCount))}}function f(t,e,r,n,i,a){var o=r.gl;if(r.vao.bind(),i===r.opacity<1||a){t.bind();var s=t.uniforms;s.model=n.model||x,s.view=n.view||x,s.projection=n.projection||x,w[0]=2/o.drawingBufferWidth,w[1]=2/o.drawingBufferHeight,s.screenSize=w,s.highlightId=r.highlightId,s.highlightScale=r.highlightScale,s.fragClipBounds=I,s.clipBounds=r.axes.bounds,s.opacity=r.opacity,s.pickGroup=r.pickId/255,s.pixelRatio=r.pixelRatio,r.vao.draw(o.TRIANGLES,r.vertexCount),r.lineWidth>0&&(o.lineWidth(r.lineWidth),r.vao.draw(o.LINES,r.lineVertexCount,r.vertexCount))}h(e,r,n,i,a),r.vao.unbind()}function d(t){var e=t.gl,r=y.createPerspective(e),n=y.createOrtho(e),i=y.createProject(e),a=y.createPickPerspective(e),s=y.createPickOrtho(e),l=y.createPickProject(e),u=p(e),c=p(e),h=p(e),f=p(e),d=m(e,[{buffer:u,size:3,type:e.FLOAT},{buffer:c,size:4,type:e.FLOAT},{buffer:h,size:2,type:e.FLOAT},{buffer:f,size:4,type:e.UNSIGNED_BYTE,normalized:!0}]),v=new o(e,r,n,i,u,c,h,f,d,a,s,l);return v.update(t),v}var p=t(\"gl-buffer\"),m=t(\"gl-vao\"),v=t(\"typedarray-pool\"),g=t(\"gl-mat4/multiply\"),y=t(\"./lib/shaders\"),b=t(\"./lib/glyphs\"),x=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1];e.exports=d;var _=o.prototype;_.pickSlots=1,_.setPickBase=function(t){this.pickId=t},_.isTransparent=function(){if(this.opacity<1)return!0;for(var t=0;t<3;++t)if(this.axesProject[t]&&this.projectOpacity[t]<1)return!0;return!1},_.isOpaque=function(){if(this.opacity>=1)return!0;for(var t=0;t<3;++t)if(this.axesProject[t]&&this.projectOpacity[t]>=1)return!0;return!1};var w=[0,0],M=[0,0,0],k=[0,0,0],A=[0,0,0,1],T=[0,0,0,1],S=x.slice(),E=[0,0,0],L=[[0,0,0],[0,0,0]],C=[-1e8,-1e8,-1e8],z=[1e8,1e8,1e8],I=[C,z];_.draw=function(t){f(this.useOrtho?this.orthoShader:this.shader,this.projectShader,this,t,!1,!1)},_.drawTransparent=function(t){f(this.useOrtho?this.orthoShader:this.shader,this.projectShader,this,t,!0,!1)},_.drawPick=function(t){f(this.useOrtho?this.pickOrthoShader:this.pickPerspectiveShader,this.pickProjectShader,this,t,!1,!0)},_.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=t.value[2]+(t.value[1]<<8)+(t.value[0]<<16);if(e>=this.pointCount||e<0)return null;var r=this.points[e],n=this._selectResult;n.index=e;for(var i=0;i<3;++i)n.position[i]=n.dataCoordinate[i]=r[i];return n},_.highlight=function(t){if(t){var e=t.index,r=255&e,n=e>>8&255,i=e>>16&255;this.highlightId=[r/255,n/255,i/255,0]}else this.highlightId=[1,1,1,1]},_.update=function(t){if(t=t||{},\"perspective\"in t&&(this.useOrtho=!t.perspective),\"orthographic\"in t&&(this.useOrtho=!!t.orthographic),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"project\"in t)if(Array.isArray(t.project))this.axesProject=t.project;else{var e=!!t.project;this.axesProject=[e,e,e]}if(\"projectScale\"in t)if(Array.isArray(t.projectScale))this.projectScale=t.projectScale.slice();else{var r=+t.projectScale;this.projectScale=[r,r,r]}if(\"projectOpacity\"in t)if(Array.isArray(t.projectOpacity))this.projectOpacity=t.projectOpacity.slice();else{var r=+t.projectOpacity;this.projectOpacity=[r,r,r]}\"opacity\"in t&&(this.opacity=t.opacity),this.dirty=!0;var n=t.position;if(n){var i=t.font||\"normal\",a=t.alignment||[0,0],o=[1/0,1/0,1/0],s=[-1/0,-1/0,-1/0],l=t.glyph,u=t.color,c=t.size,h=t.angle,f=t.lineColor,d=0,p=0,m=0,g=n.length;t:for(var y=0;y<g;++y){for(var x=n[y],_=0;_<3;++_)if(isNaN(x[_])||!isFinite(x[_]))continue t;var w;w=Array.isArray(l)?b(l[y],i):l?b(l,i):b(\"\\u25cf\",i);var M=w[0],k=w[1],A=w[2];p+=3*M.cells.length,m+=2*k.edges.length}var T=p+m,S=v.mallocFloat(3*T),E=v.mallocFloat(4*T),L=v.mallocFloat(2*T),C=v.mallocUint32(T),z=[0,a[1]],I=0,D=p,P=[0,0,0,1],O=[0,0,0,1],R=Array.isArray(u)&&Array.isArray(u[0]),F=Array.isArray(f)&&Array.isArray(f[0]);t:for(var y=0;y<g;++y){for(var x=n[y],_=0;_<3;++_){if(isNaN(x[_])||!isFinite(x[_])){d+=1;continue t}s[_]=Math.max(s[_],x[_]),o[_]=Math.min(o[_],x[_])}var w;w=Array.isArray(l)?b(l[y],i):l?b(l,i):b(\"\\u25cf\",i);var M=w[0],k=w[1],A=w[2];if(Array.isArray(u)){var j;if(j=R?u[y]:u,3===j.length){for(var _=0;_<3;++_)P[_]=j[_];P[3]=1}else if(4===j.length)for(var _=0;_<4;++_)P[_]=j[_]}else P[0]=P[1]=P[2]=0,P[3]=1;if(Array.isArray(f)){var j;if(j=F?f[y]:f,3===j.length){for(var _=0;_<3;++_)O[_]=j[_];O[_]=1}else if(4===j.length)for(var _=0;_<4;++_)O[_]=j[_]}else O[0]=O[1]=O[2]=0,O[3]=1;var N=.5;Array.isArray(c)?N=+c[y]:c?N=+c:this.useOrtho&&(N=12);var B=0;Array.isArray(h)?B=+h[y]:h&&(B=+h);for(var U=Math.cos(B),V=Math.sin(B),x=n[y],_=0;_<3;++_)s[_]=Math.max(s[_],x[_]),o[_]=Math.min(o[_],x[_]);a[0]<0?z[0]=a[0]*(1+A[1][0]):a[0]>0&&(z[0]=-a[0]*(1+A[0][0]));for(var H=M.cells,q=M.positions,_=0;_<H.length;++_)for(var G=H[_],Y=0;Y<3;++Y){for(var X=0;X<3;++X)S[3*I+X]=x[X];for(var X=0;X<4;++X)E[4*I+X]=P[X];C[I]=d;var W=q[G[Y]];L[2*I]=N*(U*W[0]-V*W[1]+z[0]),L[2*I+1]=N*(V*W[0]+U*W[1]+z[1]),I+=1}for(var H=k.edges,q=k.positions,_=0;_<H.length;++_)for(var G=H[_],Y=0;Y<2;++Y){for(var X=0;X<3;++X)S[3*D+X]=x[X];for(var X=0;X<4;++X)E[4*D+X]=O[X];C[D]=d;var W=q[G[Y]];L[2*D]=N*(U*W[0]-V*W[1]+z[0]),L[2*D+1]=N*(V*W[0]+U*W[1]+z[1]),D+=1}d+=1}this.vertexCount=p,this.lineVertexCount=m,this.pointBuffer.update(S),this.colorBuffer.update(E),this.glyphBuffer.update(L),this.idBuffer.update(new Uint32Array(C)),v.free(S),v.free(E),v.free(L),v.free(C),this.bounds=[o,s],this.points=n,this.pointCount=n.length}},_.dispose=function(){this.shader.dispose(),this.orthoShader.dispose(),this.pickPerspectiveShader.dispose(),this.pickOrthoShader.dispose(),this.vao.dispose(),this.pointBuffer.dispose(),this.colorBuffer.dispose(),this.glyphBuffer.dispose(),this.idBuffer.dispose()}},{\"./lib/glyphs\":248,\"./lib/shaders\":249,\"gl-buffer\":155,\"gl-mat4/multiply\":182,\"gl-vao\":270,\"typedarray-pool\":540}],251:[function(t,e,r){\"use strict\";r.boxVertex=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec2 vertex;\\n\\nuniform vec2 cornerA, cornerB;\\n\\nvoid main() {\\n  gl_Position = vec4(mix(cornerA, cornerB, vertex), 0, 1);\\n}\\n\",r.boxFragment=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec4 color;\\n\\nvoid main() {\\n  gl_FragColor = color;\\n}\\n\"},{}],252:[function(t,e,r){\"use strict\";function n(t,e,r){this.plot=t,this.boxBuffer=e,this.boxShader=r,this.enabled=!0,this.selectBox=[1/0,1/0,-1/0,-1/0],this.borderColor=[0,0,0,1],this.innerFill=!1,this.innerColor=[0,0,0,.25],this.outerFill=!0,this.outerColor=[0,0,0,.5],this.borderWidth=10}function i(t,e){var r=t.gl,i=o(r,[0,0,0,1,1,0,1,1]),l=a(r,s.boxVertex,s.boxFragment),u=new n(t,i,l);return u.update(e),t.addOverlay(u),u}var a=t(\"gl-shader\"),o=t(\"gl-buffer\"),s=t(\"./lib/shaders\");e.exports=i;var l=n.prototype;l.draw=function(){if(this.enabled){var t=this.plot,e=this.selectBox,r=this.borderWidth,n=(this.innerFill,this.innerColor),i=(this.outerFill,this.outerColor),a=this.borderColor,o=t.box,s=t.screenBox,l=t.dataBox,u=t.viewBox,c=t.pixelRatio,h=(e[0]-l[0])*(u[2]-u[0])/(l[2]-l[0])+u[0],f=(e[1]-l[1])*(u[3]-u[1])/(l[3]-l[1])+u[1],d=(e[2]-l[0])*(u[2]-u[0])/(l[2]-l[0])+u[0],p=(e[3]-l[1])*(u[3]-u[1])/(l[3]-l[1])+u[1];if(h=Math.max(h,u[0]),f=Math.max(f,u[1]),d=Math.min(d,u[2]),p=Math.min(p,u[3]),!(d<h||p<f)){o.bind();var m=s[2]-s[0],v=s[3]-s[1];if(this.outerFill&&(o.drawBox(0,0,m,f,i),o.drawBox(0,f,h,p,i),o.drawBox(0,p,m,v,i),o.drawBox(d,f,m,p,i)),this.innerFill&&o.drawBox(h,f,d,p,n),r>0){var g=r*c;o.drawBox(h-g,f-g,d+g,f+g,a),o.drawBox(h-g,p-g,d+g,p+g,a),o.drawBox(h-g,f-g,h+g,p+g,a),o.drawBox(d-g,f-g,d+g,p+g,a)}}}},l.update=function(t){t=t||{},this.innerFill=!!t.innerFill,this.outerFill=!!t.outerFill,this.innerColor=(t.innerColor||[0,0,0,.5]).slice(),this.outerColor=(t.outerColor||[0,0,0,.5]).slice(),this.borderColor=(t.borderColor||[0,0,0,1]).slice(),this.borderWidth=t.borderWidth||0,this.selectBox=(t.selectBox||this.selectBox).slice()},l.dispose=function(){this.boxBuffer.dispose(),this.boxShader.dispose(),this.plot.removeOverlay(this)}},{\"./lib/shaders\":251,\"gl-buffer\":155,\"gl-shader\":254}],253:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.coord=[t,e],this.id=r,this.value=n,this.distance=i}function i(t,e,r){this.gl=t,this.fbo=e,this.buffer=r,this._readTimeout=null;var n=this;this._readCallback=function(){n.gl&&(e.bind(),t.readPixels(0,0,e.shape[0],e.shape[1],t.RGBA,t.UNSIGNED_BYTE,n.buffer),n._readTimeout=null)}}function a(t,e){return new i(t,o(t,e),s.mallocUint8(e[0]*e[1]*4))}e.exports=a;var o=t(\"gl-fbo\"),s=t(\"typedarray-pool\"),l=t(\"ndarray\"),u=t(\"bit-twiddle\").nextPow2,c=t(\"cwise/lib/wrapper\")({args:[\"array\",{offset:[0,0,1],array:0},{offset:[0,0,2],array:0},{offset:[0,0,3],array:0},\"scalar\",\"scalar\",\"index\"],pre:{body:\"{this_closestD2=1e8,this_closestX=-1,this_closestY=-1}\",args:[],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[]},body:{body:\"{if(_inline_49_arg0_<255||_inline_49_arg1_<255||_inline_49_arg2_<255||_inline_49_arg3_<255){var _inline_49_l=_inline_49_arg4_-_inline_49_arg6_[0],_inline_49_a=_inline_49_arg5_-_inline_49_arg6_[1],_inline_49_f=_inline_49_l*_inline_49_l+_inline_49_a*_inline_49_a;_inline_49_f<this_closestD2&&(this_closestD2=_inline_49_f,this_closestX=_inline_49_arg6_[0],this_closestY=_inline_49_arg6_[1])}}\",args:[{name:\"_inline_49_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg4_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg5_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_49_arg6_\",lvalue:!1,rvalue:!0,count:4}],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[\"_inline_49_a\",\"_inline_49_f\",\"_inline_49_l\"]},post:{body:\"{return[this_closestX,this_closestY,this_closestD2]}\",args:[],thisVars:[\"this_closestD2\",\"this_closestX\",\"this_closestY\"],localVars:[]},debug:!1,funcName:\"cwise\",blockSize:64}),h=i.prototype;Object.defineProperty(h,\"shape\",{get:function(){return this.gl?this.fbo.shape.slice():[0,0]},set:function(t){if(this.gl){this.fbo.shape=t;var e=this.fbo.shape[0],r=this.fbo.shape[1];if(r*e*4>this.buffer.length){s.free(this.buffer);for(var n=this.buffer=s.mallocUint8(u(r*e*4)),i=0;i<r*e*4;++i)n[i]=255}return t}}}),h.begin=function(){var t=this.gl;this.shape;t&&(this.fbo.bind(),t.clearColor(1,1,1,1),t.clear(t.COLOR_BUFFER_BIT|t.DEPTH_BUFFER_BIT))},h.end=function(){var t=this.gl;t&&(t.bindFramebuffer(t.FRAMEBUFFER,null),this._readTimeout||clearTimeout(this._readTimeout),this._readTimeout=setTimeout(this._readCallback,1))},h.query=function(t,e,r){if(!this.gl)return null;var i=this.fbo.shape.slice();t|=0,e|=0,\"number\"!=typeof r&&(r=1);var a=0|Math.min(Math.max(t-r,0),i[0]),o=0|Math.min(Math.max(t+r,0),i[0]),s=0|Math.min(Math.max(e-r,0),i[1]),u=0|Math.min(Math.max(e+r,0),i[1]);if(o<=a||u<=s)return null;var h=[o-a,u-s],f=l(this.buffer,[h[0],h[1],4],[4,4*i[0],1],4*(a+i[0]*s)),d=c(f.hi(h[0],h[1],1),r,r),p=d[0],m=d[1];return p<0||Math.pow(this.radius,2)<d[2]?null:new n(p+a|0,m+s|0,f.get(p,m,0),[f.get(p,m,1),f.get(p,m,2),f.get(p,m,3)],Math.sqrt(d[2]))},h.dispose=function(){this.gl&&(this.fbo.dispose(),s.free(this.buffer),this.gl=null,this._readTimeout&&clearTimeout(this._readTimeout))}},{\"bit-twiddle\":66,\"cwise/lib/wrapper\":112,\"gl-fbo\":163,ndarray:466,\"typedarray-pool\":540}],254:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this._vref=this._fref=this._relink=this.vertShader=this.fragShader=this.program=this.attributes=this.uniforms=this.types=null}function i(t,e){return t.name<e.name?-1:1}function a(t,e,r,i,a){var o=new n(t);return o.update(e,r,i,a),o}var o=t(\"./lib/create-uniforms\"),s=t(\"./lib/create-attributes\"),l=t(\"./lib/reflect\"),u=t(\"./lib/shader-cache\"),c=t(\"./lib/runtime-reflect\"),h=t(\"./lib/GLError\"),f=n.prototype;f.bind=function(){this.program||this._relink(),this.gl.useProgram(this.program)},f.dispose=function(){this._fref&&this._fref.dispose(),this._vref&&this._vref.dispose(),this.attributes=this.types=this.vertShader=this.fragShader=this.program=this._relink=this._fref=this._vref=null},f.update=function(t,e,r,n){function a(){d.program=u.program(p,d._vref,d._fref,x,_);for(var t=0;t<r.length;++t)E[t]=p.getUniformLocation(d.program,r[t].name)}if(!e||1===arguments.length){var f=t;t=f.vertex,e=f.fragment,r=f.uniforms,n=f.attributes}var d=this,p=d.gl,m=d._vref;d._vref=u.shader(p,p.VERTEX_SHADER,t),m&&m.dispose(),d.vertShader=d._vref.shader;var v=this._fref;if(d._fref=u.shader(p,p.FRAGMENT_SHADER,e),v&&v.dispose(),d.fragShader=d._fref.shader,!r||!n){var g=p.createProgram();if(p.attachShader(g,d.fragShader),p.attachShader(g,d.vertShader),p.linkProgram(g),!p.getProgramParameter(g,p.LINK_STATUS)){var y=p.getProgramInfoLog(g);throw new h(y,\"Error linking program:\"+y)}r=r||c.uniforms(p,g),n=n||c.attributes(p,g),p.deleteProgram(g)}n=n.slice(),n.sort(i);for(var b=[],x=[],_=[],w=0;w<n.length;++w){var M=n[w];if(M.type.indexOf(\"mat\")>=0){for(var k=0|M.type.charAt(M.type.length-1),A=new Array(k),T=0;T<k;++T)A[T]=_.length,x.push(M.name+\"[\"+T+\"]\"),\"number\"==typeof M.location?_.push(M.location+T):Array.isArray(M.location)&&M.location.length===k&&\"number\"==typeof M.location[T]?_.push(0|M.location[T]):_.push(-1);b.push({name:M.name,type:M.type,locations:A})}else b.push({name:M.name,type:M.type,locations:[_.length]}),x.push(M.name),\"number\"==typeof M.location?_.push(0|M.location):_.push(-1)}for(var S=0,w=0;w<_.length;++w)if(_[w]<0){for(;_.indexOf(S)>=0;)S+=1;_[w]=S}var E=new Array(r.length);a(),d._relink=a,d.types={uniforms:l(r),attributes:l(n)},d.attributes=s(p,d,b,_),Object.defineProperty(d,\"uniforms\",o(p,d,r,E))},e.exports=a},{\"./lib/GLError\":255,\"./lib/create-attributes\":256,\"./lib/create-uniforms\":257,\"./lib/reflect\":258,\"./lib/runtime-reflect\":259,\"./lib/shader-cache\":260}],255:[function(t,e,r){arguments[4][212][0].apply(r,arguments)},{dup:212}],256:[function(t,e,r){arguments[4][213][0].apply(r,arguments)},{\"./GLError\":255,dup:213}],257:[function(t,e,r){arguments[4][214][0].apply(r,arguments)},{\"./GLError\":255,\"./reflect\":258,dup:214}],258:[function(t,e,r){arguments[4][215][0].apply(r,arguments)},{dup:215}],259:[function(t,e,r){arguments[4][216][0].apply(r,arguments)},{dup:216}],260:[function(t,e,r){arguments[4][217][0].apply(r,arguments)},{\"./GLError\":255,dup:217,\"gl-format-compiler-error\":164,\"weakmap-shim\":561}],261:[function(t,e,r){\"use strict\";function n(t){this.plot=t,this.enable=[!0,!0,!1,!1],this.width=[1,1,1,1],this.color=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.center=[1/0,1/0]}function i(t,e){var r=new n(t);return r.update(e),t.addOverlay(r),r}e.exports=i;var a=n.prototype;a.update=function(t){t=t||{},this.enable=(t.enable||[!0,!0,!1,!1]).slice(),this.width=(t.width||[1,1,1,1]).slice(),this.color=(t.color||[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]]).map(function(t){return t.slice()}),this.center=(t.center||[1/0,1/0]).slice(),this.plot.setOverlayDirty()},a.draw=function(){var t=this.enable,e=this.width,r=this.color,n=this.center,i=this.plot,a=i.line,o=i.dataBox,s=i.viewBox;if(a.bind(),o[0]<=n[0]&&n[0]<=o[2]&&o[1]<=n[1]&&n[1]<=o[3]){var l=s[0]+(n[0]-o[0])/(o[2]-o[0])*(s[2]-s[0]),u=s[1]+(n[1]-o[1])/(o[3]-o[1])*(s[3]-s[1]);t[0]&&a.drawLine(l,u,s[0],u,e[0],r[0]),t[1]&&a.drawLine(l,u,l,s[1],e[1],r[1]),t[2]&&a.drawLine(l,u,s[2],u,e[2],r[2]),t[3]&&a.drawLine(l,u,l,s[3],e[3],r[3])}},a.dispose=function(){this.plot.removeOverlay(this)}},{}],262:[function(t,e,r){\"use strict\";var n=t(\"gl-shader\");e.exports=function(t){return n(t,\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec3 position, color;\\nattribute float weight;\\n\\nuniform mat4 model, view, projection;\\nuniform vec3 coordinates[3];\\nuniform vec4 colors[3];\\nuniform vec2 screenShape;\\nuniform float lineWidth;\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  vec3 vertexPosition = mix(coordinates[0],\\n    mix(coordinates[2], coordinates[1], 0.5 * (position + 1.0)), abs(position));\\n\\n  vec4 clipPos = projection * view * model * vec4(vertexPosition, 1.0);\\n  vec2 clipOffset = (projection * view * model * vec4(color, 0.0)).xy;\\n  vec2 delta = weight * clipOffset * screenShape;\\n  vec2 lineOffset = normalize(vec2(delta.y, -delta.x)) / screenShape;\\n\\n  gl_Position   = vec4(clipPos.xy + clipPos.w * 0.5 * lineWidth * lineOffset, clipPos.z, clipPos.w);\\n  fragColor     = color.x * colors[0] + color.y * colors[1] + color.z * colors[2];\\n}\\n\",\"precision mediump float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n  gl_FragColor = fragColor;\\n}\",null,[{name:\"position\",type:\"vec3\"},{name:\"color\",type:\"vec3\"},{name:\"weight\",type:\"float\"}])}},{\"gl-shader\":254}],263:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.gl=t,this.buffer=e,this.vao=r,this.shader=n,this.pixelRatio=1,this.bounds=[[-1e3,-1e3,-1e3],[1e3,1e3,1e3]],this.position=[0,0,0],this.lineWidth=[2,2,2],this.colors=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.enabled=[!0,!0,!0],this.drawSides=[!0,!0,!0],this.axes=null}function i(t,e){function r(t,e,r,n,a,o){var s=[t,e,r,0,0,0,1];s[n+3]=1,s[n]=a,i.push.apply(i,s),s[6]=-1,i.push.apply(i,s),s[n]=o,i.push.apply(i,s),i.push.apply(i,s),s[6]=1,i.push.apply(i,s),s[n]=a,i.push.apply(i,s)}var i=[];r(0,0,0,0,0,1),r(0,0,0,1,0,1),r(0,0,0,2,0,1),r(1,0,0,1,-1,1),r(1,0,0,2,-1,1),r(0,1,0,0,-1,1),r(0,1,0,2,-1,1),r(0,0,1,0,-1,1),r(0,0,1,1,-1,1);var l=a(t,i),u=o(t,[{type:t.FLOAT,buffer:l,size:3,offset:0,stride:28},{type:t.FLOAT,buffer:l,size:3,offset:12,stride:28},{type:t.FLOAT,buffer:l,size:1,offset:24,stride:28}]),c=s(t);c.attributes.position.location=0,c.attributes.color.location=1,c.attributes.weight.location=2;var h=new n(t,l,u,c);return h.update(e),h}var a=t(\"gl-buffer\"),o=t(\"gl-vao\"),s=t(\"./shaders/index\");e.exports=i;var l=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],u=n.prototype,c=[0,0,0],h=[0,0,0],f=[0,0];u.isTransparent=function(){return!1},u.drawTransparent=function(t){},u.draw=function(t){var e=this.gl,r=this.vao,n=this.shader;r.bind(),n.bind();var i,a=t.model||l,o=t.view||l,s=t.projection||l;this.axes&&(i=this.axes.lastCubeProps.axis);for(var u=c,d=h,p=0;p<3;++p)i&&i[p]<0?(u[p]=this.bounds[0][p],d[p]=this.bounds[1][p]):(u[p]=this.bounds[1][p],d[p]=this.bounds[0][p]);f[0]=e.drawingBufferWidth,f[1]=e.drawingBufferHeight,n.uniforms.model=a,n.uniforms.view=o,n.uniforms.projection=s,n.uniforms.coordinates=[this.position,u,d],n.uniforms.colors=this.colors,n.uniforms.screenShape=f;for(var p=0;p<3;++p)n.uniforms.lineWidth=this.lineWidth[p]*this.pixelRatio,this.enabled[p]&&(r.draw(e.TRIANGLES,6,6*p),this.drawSides[p]&&r.draw(e.TRIANGLES,12,18+12*p));r.unbind()},u.update=function(t){t&&(\"bounds\"in t&&(this.bounds=t.bounds),\"position\"in t&&(this.position=t.position),\"lineWidth\"in t&&(this.lineWidth=t.lineWidth),\"colors\"in t&&(this.colors=t.colors),\"enabled\"in t&&(this.enabled=t.enabled),\"drawSides\"in t&&(this.drawSides=t.drawSides))},u.dispose=function(){this.vao.dispose(),this.buffer.dispose(),this.shader.dispose()}},{\"./shaders/index\":262,\"gl-buffer\":155,\"gl-vao\":270}],264:[function(t,e,r){var n=t(\"gl-shader\"),i=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec4 uv;\\nattribute vec3 f;\\nattribute vec3 normal;\\n\\nuniform mat4 model, view, projection, inverseModel;\\nuniform vec3 lightPosition, eyePosition;\\nuniform sampler2D colormap;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  worldCoordinate = vec3(uv.zw, f.x);\\n  vec4 worldPosition = model * vec4(worldCoordinate, 1.0);\\n  vec4 clipPosition = projection * view * worldPosition;\\n  gl_Position = clipPosition;\\n  kill = f.y;\\n  value = f.z;\\n  planeCoordinate = uv.xy;\\n\\n  vColor = texture2D(colormap, vec2(value, value));\\n\\n  //Lighting geometry parameters\\n  vec4 cameraCoordinate = view * worldPosition;\\n  cameraCoordinate.xyz /= cameraCoordinate.w;\\n  lightDirection = lightPosition - cameraCoordinate.xyz;\\n  eyeDirection   = eyePosition - cameraCoordinate.xyz;\\n  surfaceNormal  = normalize((vec4(normal,0) * inverseModel).xyz);\\n}\\n\",a=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nfloat beckmannDistribution_2_0(float x, float roughness) {\\n  float NdotH = max(x, 0.0001);\\n  float cos2Alpha = NdotH * NdotH;\\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\\n  float roughness2 = roughness * roughness;\\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\\n  return exp(tan2Alpha / roughness2) / denom;\\n}\\n\\n\\n\\nfloat beckmannSpecular_1_1(\\n  vec3 lightDirection,\\n  vec3 viewDirection,\\n  vec3 surfaceNormal,\\n  float roughness) {\\n  return beckmannDistribution_2_0(dot(surfaceNormal, normalize(lightDirection + viewDirection)), roughness);\\n}\\n\\n\\n\\nuniform vec3 lowerBound, upperBound;\\nuniform float contourTint;\\nuniform vec4 contourColor;\\nuniform sampler2D colormap;\\nuniform vec3 clipBounds[2];\\nuniform float roughness, fresnel, kambient, kdiffuse, kspecular, opacity;\\nuniform float vertexColor;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  if (kill > 0.0 ||\\n    any(lessThan(worldCoordinate, clipBounds[0])) || any(greaterThan(worldCoordinate, clipBounds[1]))) {\\n    discard;\\n  }\\n\\n  vec3 N = normalize(surfaceNormal);\\n  vec3 V = normalize(eyeDirection);\\n  vec3 L = normalize(lightDirection);\\n\\n  if(gl_FrontFacing) {\\n    N = -N;\\n  }\\n\\n  float specular = max(beckmannSpecular_1_1(L, V, N, roughness), 0.);\\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\\n\\n  //decide how to interpolate color \\u2014 in vertex or in fragment\\n  vec4 surfaceColor = step(vertexColor, .5) * texture2D(colormap, vec2(value, value)) + step(.5, vertexColor) * vColor;\\n\\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\\n\\n  gl_FragColor = mix(litColor, contourColor, contourTint) * opacity;\\n}\\n\",o=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nattribute vec4 uv;\\nattribute float f;\\n\\nuniform mat3 permutation;\\nuniform mat4 model, view, projection;\\nuniform float height, zOffset;\\nuniform sampler2D colormap;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\\nvarying vec4 vColor;\\n\\nvoid main() {\\n  vec3 dataCoordinate = permutation * vec3(uv.xy, height);\\n  vec4 worldPosition = model * vec4(dataCoordinate, 1.0);\\n\\n  vec4 clipPosition = projection * view * worldPosition;\\n  clipPosition.z = clipPosition.z + zOffset;\\n\\n  gl_Position = clipPosition;\\n  value = f;\\n  kill = -1.0;\\n  worldCoordinate = dataCoordinate;\\n  planeCoordinate = uv.zw;\\n\\n  vColor = texture2D(colormap, vec2(value, value));\\n\\n  //Don't do lighting for contours\\n  surfaceNormal   = vec3(1,0,0);\\n  eyeDirection    = vec3(0,1,0);\\n  lightDirection  = vec3(0,0,1);\\n}\\n\",s=\"precision mediump float;\\n#define GLSLIFY 1\\n\\nuniform vec2 shape;\\nuniform vec3 clipBounds[2];\\nuniform float pickId;\\n\\nvarying float value, kill;\\nvarying vec3 worldCoordinate;\\nvarying vec2 planeCoordinate;\\nvarying vec3 surfaceNormal;\\n\\nvec2 splitFloat(float v) {\\n  float vh = 255.0 * v;\\n  float upper = floor(vh);\\n  float lower = fract(vh);\\n  return vec2(upper / 255.0, floor(lower * 16.0) / 16.0);\\n}\\n\\nvoid main() {\\n  if(kill > 0.0 ||\\n    any(lessThan(worldCoordinate, clipBounds[0])) || any(greaterThan(worldCoordinate, clipBounds[1]))) {\\n    discard;\\n  }\\n  vec2 ux = splitFloat(planeCoordinate.x / shape.x);\\n  vec2 uy = splitFloat(planeCoordinate.y / shape.y);\\n  gl_FragColor = vec4(pickId, ux.x, uy.x, ux.y + (uy.y/16.0));\\n}\\n\";r.createShader=function(t){var e=n(t,i,a,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e.attributes.normal.location=2,e},r.createPickShader=function(t){var e=n(t,i,s,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"vec3\"},{name:\"normal\",type:\"vec3\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e.attributes.normal.location=2,e},r.createContourShader=function(t){var e=n(t,o,a,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"float\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e},r.createPickContourShader=function(t){var e=n(t,o,s,null,[{name:\"uv\",type:\"vec4\"},{name:\"f\",type:\"float\"}]);return e.attributes.uv.location=0,e.attributes.f.location=1,e}},{\"gl-shader\":254}],265:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.position=t,this.index=e,this.uv=r,this.level=n,this.dataCoordinate=i}function i(t){var e=x([y({colormap:t,nshades:R,format:\"rgba\"}).map(function(t){return[t[0],t[1],t[2],255*t[3]]})]);return b.divseq(e,255),e}function a(t,e,r,i,a,o,s,l,u,c,h,f,d,p){this.gl=t,this.shape=e,this.bounds=r,this.intensityBounds=[],this._shader=i,this._pickShader=a,this._coordinateBuffer=o,this._vao=s,this._colorMap=l,this._contourShader=u,this._contourPickShader=c,this._contourBuffer=h,this._contourVAO=f,this._contourOffsets=[[],[],[]],this._contourCounts=[[],[],[]],this._vertexCount=0,this._pickResult=new n([0,0,0],[0,0],[0,0],[0,0,0],[0,0,0]),this._dynamicBuffer=d,this._dynamicVAO=p,this._dynamicOffsets=[0,0,0],this._dynamicCounts=[0,0,0],this.contourWidth=[1,1,1],this.contourLevels=[[1],[1],[1]],this.contourTint=[0,0,0],this.contourColor=[[.5,.5,.5,1],[.5,.5,.5,1],[.5,.5,.5,1]],this.showContour=!0,this.showSurface=!0,this.enableHighlight=[!0,!0,!0],this.highlightColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.highlightTint=[1,1,1],this.highlightLevel=[-1,-1,-1],this.enableDynamic=[!0,!0,!0],this.dynamicLevel=[NaN,NaN,NaN],this.dynamicColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.dynamicTint=[1,1,1],this.dynamicWidth=[1,1,1],this.axesBounds=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]],this.surfaceProject=[!1,!1,!1],this.contourProject=[[!1,!1,!1],[!1,!1,!1],[!1,!1,!1]],this.colorBounds=[!1,!1],this._field=[_(g.mallocFloat(1024),[0,0]),_(g.mallocFloat(1024),[0,0]),_(g.mallocFloat(1024),[0,0])],this.pickId=1,this.clipBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.snapToData=!1,this.opacity=1,this.lightPosition=[10,1e4,0],this.ambientLight=.8,this.diffuseLight=.8,this.specularLight=2,this.roughness=.5,this.fresnel=1.5,this.vertexColor=0,this.dirty=!0}function o(t,e){var r,n,i,a=e.axes&&e.axes.lastCubeProps.axis||j,o=e.showSurface,s=e.showContour;for(r=0;r<3;++r)for(o=o||e.surfaceProject[r],n=0;n<3;++n)s=s||e.contourProject[r][n];for(r=0;r<3;++r){var l=N.projections[r];for(n=0;n<16;++n)l[n]=0;for(n=0;n<4;++n)l[5*n]=1;l[5*r]=0,l[12+r]=e.axesBounds[+(a[r]>0)][r],M(l,t.model,l);var u=N.clipBounds[r];for(i=0;i<2;++i)for(n=0;n<3;++n)u[i][n]=t.clipBounds[i][n];u[0][r]=-1e8,u[1][r]=1e8}return N.showSurface=o,N.showContour=s,N}function s(t,e){t=t||{};var r=this.gl;r.disable(r.CULL_FACE),this._colorMap.bind(0);var n=B;n.model=t.model||D,n.view=t.view||D,n.projection=t.projection||D,n.lowerBound=[this.bounds[0][0],this.bounds[0][1],this.colorBounds[0]||this.bounds[0][2]],n.upperBound=[this.bounds[1][0],this.bounds[1][1],this.colorBounds[1]||this.bounds[1][2]],n.contourColor=this.contourColor[0],n.inverseModel=k(n.inverseModel,n.model);for(var i=0;i<2;++i)for(var a=n.clipBounds[i],s=0;s<3;++s)a[s]=Math.min(Math.max(this.clipBounds[i][s],-1e8),1e8);n.kambient=this.ambientLight,n.kdiffuse=this.diffuseLight,n.kspecular=this.specularLight,n.roughness=this.roughness,n.fresnel=this.fresnel,n.opacity=this.opacity,n.height=0,n.permutation=V,n.vertexColor=this.vertexColor;var l=U;for(M(l,n.view,n.model),M(l,n.projection,l),k(l,l),i=0;i<3;++i)n.eyePosition[i]=l[12+i]/l[15];var u=l[15];for(i=0;i<3;++i)u+=this.lightPosition[i]*l[4*i+3];for(i=0;i<3;++i){var c=l[12+i];for(s=0;s<3;++s)c+=l[4*s+i]*this.lightPosition[s];n.lightPosition[i]=c/u}var h=o(n,this);if(h.showSurface&&e===this.opacity<1){for(this._shader.bind(),this._shader.uniforms=n,this._vao.bind(),this.showSurface&&this._vertexCount&&this._vao.draw(r.TRIANGLES,this._vertexCount),i=0;i<3;++i)this.surfaceProject[i]&&this.vertexCount&&(this._shader.uniforms.model=h.projections[i],this._shader.uniforms.clipBounds=h.clipBounds[i],this._vao.draw(r.TRIANGLES,this._vertexCount));this._vao.unbind()}if(h.showContour&&!e){var f=this._contourShader;n.kambient=1,n.kdiffuse=0,n.kspecular=0,n.opacity=1,f.bind(),f.uniforms=n;var d=this._contourVAO;for(d.bind(),i=0;i<3;++i)for(f.uniforms.permutation=O[i],r.lineWidth(this.contourWidth[i]),s=0;s<this.contourLevels[i].length;++s)this._contourCounts[i][s]&&(s===this.highlightLevel[i]?(f.uniforms.contourColor=this.highlightColor[i],f.uniforms.contourTint=this.highlightTint[i]):0!==s&&s-1!==this.highlightLevel[i]||(f.uniforms.contourColor=this.contourColor[i],f.uniforms.contourTint=this.contourTint[i]),f.uniforms.height=this.contourLevels[i][s],d.draw(r.LINES,this._contourCounts[i][s],this._contourOffsets[i][s]));for(i=0;i<3;++i)for(f.uniforms.model=h.projections[i],f.uniforms.clipBounds=h.clipBounds[i],s=0;s<3;++s)if(this.contourProject[i][s]){f.uniforms.permutation=O[s],r.lineWidth(this.contourWidth[s]);for(var p=0;p<this.contourLevels[s].length;++p)p===this.highlightLevel[s]?(f.uniforms.contourColor=this.highlightColor[s],f.uniforms.contourTint=this.highlightTint[s]):0!==p&&p-1!==this.highlightLevel[s]||(f.uniforms.contourColor=this.contourColor[s],f.uniforms.contourTint=this.contourTint[s]),f.uniforms.height=this.contourLevels[s][p],d.draw(r.LINES,this._contourCounts[s][p],this._contourOffsets[s][p])}for(d=this._dynamicVAO,d.bind(),i=0;i<3;++i)if(0!==this._dynamicCounts[i])for(f.uniforms.model=n.model,f.uniforms.clipBounds=n.clipBounds,f.uniforms.permutation=O[i],r.lineWidth(this.dynamicWidth[i]),f.uniforms.contourColor=this.dynamicColor[i],f.uniforms.contourTint=this.dynamicTint[i],f.uniforms.height=this.dynamicLevel[i],d.draw(r.LINES,this._dynamicCounts[i],this._dynamicOffsets[i]),s=0;s<3;++s)this.contourProject[s][i]&&(f.uniforms.model=h.projections[s],f.uniforms.clipBounds=h.clipBounds[s],d.draw(r.LINES,this._dynamicCounts[i],this._dynamicOffsets[i]));d.unbind()}}function l(t,e){var r=e.shape.slice(),n=t.shape.slice();b.assign(t.lo(1,1).hi(r[0],r[1]),e),b.assign(t.lo(1).hi(r[0],1),e.hi(r[0],1)),b.assign(t.lo(1,n[1]-1).hi(r[0],1),e.lo(0,r[1]-1).hi(r[0],1)),b.assign(t.lo(0,1).hi(1,r[1]),e.hi(1)),b.assign(t.lo(n[0]-1,1).hi(1,r[1]),e.lo(r[0]-1)),t.set(0,0,e.get(0,0)),t.set(0,n[1]-1,e.get(0,r[1]-1)),t.set(n[0]-1,0,e.get(r[0]-1,0)),t.set(n[0]-1,n[1]-1,e.get(r[0]-1,r[1]-1))}function u(t,e){return Array.isArray(t)?[e(t[0]),e(t[1]),e(t[2])]:[e(t),e(t),e(t)]}function c(t){return Array.isArray(t)?3===t.length?[t[0],t[1],t[2],1]:[t[0],t[1],t[2],t[3]]:[0,0,0,1]}function h(t){if(Array.isArray(t)){if(Array.isArray(t))return[c(t[0]),c(t[1]),c(t[2])];var e=c(t);return[e.slice(),e.slice(),e.slice()]}}function f(t){var e=t.gl,r=E(e),n=C(e),i=L(e),o=z(e),s=p(e),l=m(e,[{buffer:s,size:4,stride:I,offset:0},{buffer:s,size:3,stride:I,offset:16},{buffer:s,size:3,stride:I,offset:28}]),u=p(e),c=m(e,[{buffer:u,size:4,stride:20,offset:0},{buffer:u,size:1,stride:20,offset:16}]),h=p(e),f=m(e,[{buffer:h,size:2,type:e.FLOAT}]),d=v(e,1,R,e.RGBA,e.UNSIGNED_BYTE);d.minFilter=e.LINEAR,d.magFilter=e.LINEAR;var g=new a(e,[0,0],[[0,0,0],[0,0,0]],r,n,s,l,d,i,o,u,c,h,f),y={levels:[[],[],[]]};for(var b in t)y[b]=t[b];return y.colormap=y.colormap||\"jet\",g.update(y),g}e.exports=f\n",
       ";var d=t(\"bit-twiddle\"),p=t(\"gl-buffer\"),m=t(\"gl-vao\"),v=t(\"gl-texture2d\"),g=t(\"typedarray-pool\"),y=t(\"colormap\"),b=t(\"ndarray-ops\"),x=t(\"ndarray-pack\"),_=t(\"ndarray\"),w=t(\"surface-nets\"),M=t(\"gl-mat4/multiply\"),k=t(\"gl-mat4/invert\"),A=t(\"binary-search-bounds\"),T=t(\"ndarray-gradient\"),S=t(\"./lib/shaders\"),E=S.createShader,L=S.createContourShader,C=S.createPickShader,z=S.createPickContourShader,I=40,D=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],P=[[0,0],[0,1],[1,0],[1,1],[1,0],[0,1]],O=[[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0]];!function(){for(var t=0;t<3;++t){var e=O[t],r=(t+1)%3,n=(t+2)%3;e[r+0]=1,e[n+3]=1,e[t+6]=1}}();var R=256,F=a.prototype;F.isTransparent=function(){return this.opacity<1},F.isOpaque=function(){if(this.opacity>=1)return!0;for(var t=0;t<3;++t)if(this._contourCounts[t].length>0||this._dynamicCounts[t]>0)return!0;return!1},F.pickSlots=1,F.setPickBase=function(t){this.pickId=t};var j=[0,0,0],N={showSurface:!1,showContour:!1,projections:[D.slice(),D.slice(),D.slice()],clipBounds:[[[0,0,0],[0,0,0]],[[0,0,0],[0,0,0]],[[0,0,0],[0,0,0]]]},B={model:D,view:D,projection:D,inverseModel:D.slice(),lowerBound:[0,0,0],upperBound:[0,0,0],colorMap:0,clipBounds:[[0,0,0],[0,0,0]],height:0,contourTint:0,contourColor:[0,0,0,1],permutation:[1,0,0,0,1,0,0,0,1],zOffset:-1e-4,kambient:1,kdiffuse:1,kspecular:1,lightPosition:[1e3,1e3,1e3],eyePosition:[0,0,0],roughness:1,fresnel:1,opacity:1,vertexColor:0},U=D.slice(),V=[1,0,0,0,1,0,0,0,1];F.draw=function(t){return s.call(this,t,!1)},F.drawTransparent=function(t){return s.call(this,t,!0)};var H={model:D,view:D,projection:D,inverseModel:D,clipBounds:[[0,0,0],[0,0,0]],height:0,shape:[0,0],pickId:0,lowerBound:[0,0,0],upperBound:[0,0,0],zOffset:0,permutation:[1,0,0,0,1,0,0,0,1],lightPosition:[0,0,0],eyePosition:[0,0,0]};F.drawPick=function(t){t=t||{};var e=this.gl;e.disable(e.CULL_FACE);var r=H;r.model=t.model||D,r.view=t.view||D,r.projection=t.projection||D,r.shape=this._field[2].shape,r.pickId=this.pickId/255,r.lowerBound=this.bounds[0],r.upperBound=this.bounds[1],r.permutation=V;for(var n=0;n<2;++n)for(var i=r.clipBounds[n],a=0;a<3;++a)i[a]=Math.min(Math.max(this.clipBounds[n][a],-1e8),1e8);var s=o(r,this);if(s.showSurface){for(this._pickShader.bind(),this._pickShader.uniforms=r,this._vao.bind(),this._vao.draw(e.TRIANGLES,this._vertexCount),n=0;n<3;++n)this.surfaceProject[n]&&(this._pickShader.uniforms.model=s.projections[n],this._pickShader.uniforms.clipBounds=s.clipBounds[n],this._vao.draw(e.TRIANGLES,this._vertexCount));this._vao.unbind()}if(s.showContour){var l=this._contourPickShader;l.bind(),l.uniforms=r;var u=this._contourVAO;for(u.bind(),a=0;a<3;++a)for(e.lineWidth(this.contourWidth[a]),l.uniforms.permutation=O[a],n=0;n<this.contourLevels[a].length;++n)this._contourCounts[a][n]&&(l.uniforms.height=this.contourLevels[a][n],u.draw(e.LINES,this._contourCounts[a][n],this._contourOffsets[a][n]));for(n=0;n<3;++n)for(l.uniforms.model=s.projections[n],l.uniforms.clipBounds=s.clipBounds[n],a=0;a<3;++a)if(this.contourProject[n][a]){l.uniforms.permutation=O[a],e.lineWidth(this.contourWidth[a]);for(var c=0;c<this.contourLevels[a].length;++c)this._contourCounts[a][c]&&(l.uniforms.height=this.contourLevels[a][c],u.draw(e.LINES,this._contourCounts[a][c],this._contourOffsets[a][c]))}u.unbind()}},F.pick=function(t){if(!t)return null;if(t.id!==this.pickId)return null;var e=this._field[2].shape,r=this._pickResult,n=e[0]*(t.value[0]+(t.value[2]>>4)/16)/255,i=Math.floor(n),a=n-i,o=e[1]*(t.value[1]+(15&t.value[2])/16)/255,s=Math.floor(o),l=o-s;i+=1,s+=1;var u=r.position;u[0]=u[1]=u[2]=0;for(var c=0;c<2;++c)for(var h=c?a:1-a,f=0;f<2;++f)for(var d=f?l:1-l,p=i+c,m=s+f,v=h*d,g=0;g<3;++g)u[g]+=this._field[g].get(p,m)*v;for(var y=this._pickResult.level,b=0;b<3;++b)if(y[b]=A.le(this.contourLevels[b],u[b]),y[b]<0)this.contourLevels[b].length>0&&(y[b]=0);else if(y[b]<this.contourLevels[b].length-1){var x=this.contourLevels[b][y[b]],_=this.contourLevels[b][y[b]+1];Math.abs(x-u[b])>Math.abs(_-u[b])&&(y[b]+=1)}for(r.index[0]=a<.5?i:i+1,r.index[1]=l<.5?s:s+1,r.uv[0]=n/e[0],r.uv[1]=o/e[1],g=0;g<3;++g)r.dataCoordinate[g]=this._field[g].get(r.index[0],r.index[1]);return r},F.update=function(t){t=t||{},this.dirty=!0,\"contourWidth\"in t&&(this.contourWidth=u(t.contourWidth,Number)),\"showContour\"in t&&(this.showContour=u(t.showContour,Boolean)),\"showSurface\"in t&&(this.showSurface=!!t.showSurface),\"contourTint\"in t&&(this.contourTint=u(t.contourTint,Boolean)),\"contourColor\"in t&&(this.contourColor=h(t.contourColor)),\"contourProject\"in t&&(this.contourProject=u(t.contourProject,function(t){return u(t,Boolean)})),\"surfaceProject\"in t&&(this.surfaceProject=t.surfaceProject),\"dynamicColor\"in t&&(this.dynamicColor=h(t.dynamicColor)),\"dynamicTint\"in t&&(this.dynamicTint=u(t.dynamicTint,Number)),\"dynamicWidth\"in t&&(this.dynamicWidth=u(t.dynamicWidth,Number)),\"opacity\"in t&&(this.opacity=t.opacity),\"colorBounds\"in t&&(this.colorBounds=t.colorBounds),\"vertexColor\"in t&&(this.vertexColor=t.vertexColor?1:0);var e=t.field||t.coords&&t.coords[2]||null,r=!1;if(e||(e=this._field[2].shape[0]||this._field[2].shape[2]?this._field[2].lo(1,1).hi(this._field[2].shape[0]-2,this._field[2].shape[1]-2):this._field[2].hi(0,0)),\"field\"in t||\"coords\"in t){var n=(e.shape[0]+2)*(e.shape[1]+2);n>this._field[2].data.length&&(g.freeFloat(this._field[2].data),this._field[2].data=g.mallocFloat(d.nextPow2(n))),this._field[2]=_(this._field[2].data,[e.shape[0]+2,e.shape[1]+2]),l(this._field[2],e),this.shape=e.shape.slice();for(var a=this.shape,o=0;o<2;++o)this._field[2].size>this._field[o].data.length&&(g.freeFloat(this._field[o].data),this._field[o].data=g.mallocFloat(this._field[2].size)),this._field[o]=_(this._field[o].data,[a[0]+2,a[1]+2]);if(t.coords){var s=t.coords;if(!Array.isArray(s)||3!==s.length)throw new Error(\"gl-surface: invalid coordinates for x/y\");for(o=0;o<2;++o){var c=s[o];for(y=0;y<2;++y)if(c.shape[y]!==a[y])throw new Error(\"gl-surface: coords have incorrect shape\");l(this._field[o],c)}}else if(t.ticks){var f=t.ticks;if(!Array.isArray(f)||2!==f.length)throw new Error(\"gl-surface: invalid ticks\");for(o=0;o<2;++o){var p=f[o];if((Array.isArray(p)||p.length)&&(p=_(p)),p.shape[0]!==a[o])throw new Error(\"gl-surface: invalid tick length\");var m=_(p.data,a);m.stride[o]=p.stride[0],m.stride[1^o]=0,l(this._field[o],m)}}else{for(o=0;o<2;++o){var v=[0,0];v[o]=1,this._field[o]=_(this._field[o].data,[a[0]+2,a[1]+2],v,0)}this._field[0].set(0,0,0);for(var y=0;y<a[0];++y)this._field[0].set(y+1,0,y);for(this._field[0].set(a[0]+1,0,a[0]-1),this._field[1].set(0,0,0),y=0;y<a[1];++y)this._field[1].set(0,y+1,y);this._field[1].set(0,a[1]+1,a[1]-1)}var b=this._field,x=_(g.mallocFloat(3*b[2].size*2),[3,a[0]+2,a[1]+2,2]);for(o=0;o<3;++o)T(x.pick(o),b[o],\"mirror\");var M=_(g.mallocFloat(3*b[2].size),[a[0]+2,a[1]+2,3]);for(o=0;o<a[0]+2;++o)for(y=0;y<a[1]+2;++y){var k=x.get(0,o,y,0),A=x.get(0,o,y,1),S=x.get(1,o,y,0),E=x.get(1,o,y,1),L=x.get(2,o,y,0),C=x.get(2,o,y,1),z=S*C-E*L,I=L*A-C*k,D=k*E-A*S,O=Math.sqrt(z*z+I*I+D*D);O<1e-8?(O=Math.max(Math.abs(z),Math.abs(I),Math.abs(D)),O<1e-8?(D=1,I=z=0,O=1):O=1/O):O=1/Math.sqrt(O),M.set(o,y,0,z*O),M.set(o,y,1,I*O),M.set(o,y,2,D*O)}g.free(x.data);var R=[1/0,1/0,1/0],F=[-1/0,-1/0,-1/0],j=1/0,N=-1/0,B=(a[0]-1)*(a[1]-1)*6,U=g.mallocFloat(d.nextPow2(10*B)),V=0,H=0;for(o=0;o<a[0]-1;++o)t:for(y=0;y<a[1]-1;++y){for(var q=0;q<2;++q)for(var G=0;G<2;++G)for(var Y=0;Y<3;++Y){var X=this._field[Y].get(1+o+q,1+y+G);if(isNaN(X)||!isFinite(X))continue t}for(Y=0;Y<6;++Y){var W=o+P[Y][0],Z=y+P[Y][1],J=this._field[0].get(W+1,Z+1),K=this._field[1].get(W+1,Z+1);X=this._field[2].get(W+1,Z+1);var Q=X;z=M.get(W+1,Z+1,0),I=M.get(W+1,Z+1,1),D=M.get(W+1,Z+1,2),t.intensity&&(Q=t.intensity.get(W,Z)),U[V++]=W,U[V++]=Z,U[V++]=J,U[V++]=K,U[V++]=X,U[V++]=0,U[V++]=Q,U[V++]=z,U[V++]=I,U[V++]=D,R[0]=Math.min(R[0],J),R[1]=Math.min(R[1],K),R[2]=Math.min(R[2],X),j=Math.min(j,Q),F[0]=Math.max(F[0],J),F[1]=Math.max(F[1],K),F[2]=Math.max(F[2],X),N=Math.max(N,Q),H+=1}}for(t.intensityBounds&&(j=+t.intensityBounds[0],N=+t.intensityBounds[1]),o=6;o<V;o+=10)U[o]=(U[o]-j)/(N-j);this._vertexCount=H,this._coordinateBuffer.update(U.subarray(0,V)),g.freeFloat(U),g.free(M.data),this.bounds=[R,F],this.intensity=t.intensity||this._field[2],this.intensityBounds[0]===j&&this.intensityBounds[1]===N||(r=!0),this.intensityBounds=[j,N]}if(\"levels\"in t){var $=t.levels;for($=Array.isArray($[0])?$.slice():[[],[],$],o=0;o<3;++o)$[o]=$[o].slice(),$.sort(function(t,e){return t-e});t:for(o=0;o<3;++o){if($[o].length!==this.contourLevels[o].length){r=!0;break}for(y=0;y<$[o].length;++y)if($[o][y]!==this.contourLevels[o][y]){r=!0;break t}}this.contourLevels=$}if(r){b=this._field,a=this.shape;for(var tt=[],et=0;et<3;++et){$=this.contourLevels[et];var rt=[],nt=[],it=[0,0,0];for(o=0;o<$.length;++o){var at=w(this._field[et],$[o]);rt.push(tt.length/5|0),H=0;t:for(y=0;y<at.cells.length;++y){var ot=at.cells[y];for(Y=0;Y<2;++Y){var st=at.positions[ot[Y]],lt=st[0],ut=0|Math.floor(lt),ct=lt-ut,ht=st[1],ft=0|Math.floor(ht),dt=ht-ft,pt=!1;e:for(var mt=0;mt<3;++mt){it[mt]=0;var vt=(et+mt+1)%3;for(q=0;q<2;++q){var gt=q?ct:1-ct;for(W=0|Math.min(Math.max(ut+q,0),a[0]),G=0;G<2;++G){var yt=G?dt:1-dt;if(Z=0|Math.min(Math.max(ft+G,0),a[1]),X=mt<2?this._field[vt].get(W,Z):(this.intensity.get(W,Z)-this.intensityBounds[0])/(this.intensityBounds[1]-this.intensityBounds[0]),!isFinite(X)||isNaN(X)){pt=!0;break e}var bt=gt*yt;it[mt]+=bt*X}}}if(pt){if(Y>0){for(var xt=0;xt<5;++xt)tt.pop();H-=1}continue t}tt.push(it[0],it[1],st[0],st[1],it[2]),H+=1}}nt.push(H)}this._contourOffsets[et]=rt,this._contourCounts[et]=nt}var _t=g.mallocFloat(tt.length);for(o=0;o<tt.length;++o)_t[o]=tt[o];this._contourBuffer.update(_t),g.freeFloat(_t)}t.colormap&&this._colorMap.setPixels(i(t.colormap))},F.dispose=function(){this._shader.dispose(),this._vao.dispose(),this._coordinateBuffer.dispose(),this._colorMap.dispose(),this._contourBuffer.dispose(),this._contourVAO.dispose(),this._contourShader.dispose(),this._contourPickShader.dispose(),this._dynamicBuffer.dispose(),this._dynamicVAO.dispose();for(var t=0;t<3;++t)g.freeFloat(this._field[t].data)},F.highlight=function(t){if(!t)return this._dynamicCounts=[0,0,0],this.dyanamicLevel=[NaN,NaN,NaN],void(this.highlightLevel=[-1,-1,-1]);for(var e=0;e<3;++e)this.enableHighlight[e]?this.highlightLevel[e]=t.level[e]:this.highlightLevel[e]=-1;var r;if(r=this.snapToData?t.dataCoordinate:t.position,this.enableDynamic[0]&&r[0]!==this.dynamicLevel[0]||this.enableDynamic[1]&&r[1]!==this.dynamicLevel[1]||this.enableDynamic[2]&&r[2]!==this.dynamicLevel[2]){for(var n=0,i=this.shape,a=g.mallocFloat(12*i[0]*i[1]),o=0;o<3;++o)if(this.enableDynamic[o]){this.dynamicLevel[o]=r[o];var s=(o+1)%3,l=(o+2)%3,u=this._field[o],c=this._field[s],h=this._field[l],f=(this.intensity,w(u,r[o])),d=f.cells,p=f.positions;for(this._dynamicOffsets[o]=n,e=0;e<d.length;++e)for(var m=d[e],v=0;v<2;++v){var y=p[m[v]],b=+y[0],x=0|b,_=0|Math.min(x+1,i[0]),M=b-x,k=1-M,A=+y[1],T=0|A,S=0|Math.min(T+1,i[1]),E=A-T,L=1-E,C=k*L,z=k*E,I=M*L,D=M*E,P=C*c.get(x,T)+z*c.get(x,S)+I*c.get(_,T)+D*c.get(_,S),O=C*h.get(x,T)+z*h.get(x,S)+I*h.get(_,T)+D*h.get(_,S);if(isNaN(P)||isNaN(O)){v&&(n-=1);break}a[2*n+0]=P,a[2*n+1]=O,n+=1}this._dynamicCounts[o]=n-this._dynamicOffsets[o]}else this.dynamicLevel[o]=NaN,this._dynamicCounts[o]=0;this._dynamicBuffer.update(a.subarray(0,2*n)),g.freeFloat(a)}}},{\"./lib/shaders\":264,\"binary-search-bounds\":65,\"bit-twiddle\":66,colormap:98,\"gl-buffer\":155,\"gl-mat4/invert\":180,\"gl-mat4/multiply\":182,\"gl-texture2d\":266,\"gl-vao\":270,ndarray:466,\"ndarray-gradient\":457,\"ndarray-ops\":460,\"ndarray-pack\":461,\"surface-nets\":530,\"typedarray-pool\":540}],266:[function(t,e,r){\"use strict\";function n(t){g=[t.LINEAR,t.NEAREST_MIPMAP_LINEAR,t.LINEAR_MIPMAP_NEAREST,t.LINEAR_MIPMAP_NEAREST],y=[t.NEAREST,t.LINEAR,t.NEAREST_MIPMAP_NEAREST,t.NEAREST_MIPMAP_LINEAR,t.LINEAR_MIPMAP_NEAREST,t.LINEAR_MIPMAP_LINEAR],b=[t.REPEAT,t.CLAMP_TO_EDGE,t.MIRRORED_REPEAT]}function i(t){return\"undefined\"!=typeof HTMLCanvasElement&&t instanceof HTMLCanvasElement||\"undefined\"!=typeof HTMLImageElement&&t instanceof HTMLImageElement||\"undefined\"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement||\"undefined\"!=typeof ImageData&&t instanceof ImageData}function a(t,e,r){var n=t.gl,i=n.getParameter(n.MAX_TEXTURE_SIZE);if(e<0||e>i||r<0||r>i)throw new Error(\"gl-texture2d: Invalid texture size\");return t._shape=[e,r],t.bind(),n.texImage2D(n.TEXTURE_2D,0,t.format,e,r,0,t.format,t.type,null),t._mipLevels=[0],t}function o(t,e,r,n,i,a){this.gl=t,this.handle=e,this.format=i,this.type=a,this._shape=[r,n],this._mipLevels=[0],this._magFilter=t.NEAREST,this._minFilter=t.NEAREST,this._wrapS=t.CLAMP_TO_EDGE,this._wrapT=t.CLAMP_TO_EDGE,this._anisoSamples=1;var o=this,s=[this._wrapS,this._wrapT];Object.defineProperties(s,[{get:function(){return o._wrapS},set:function(t){return o.wrapS=t}},{get:function(){return o._wrapT},set:function(t){return o.wrapT=t}}]),this._wrapVector=s;var l=[this._shape[0],this._shape[1]];Object.defineProperties(l,[{get:function(){return o._shape[0]},set:function(t){return o.width=t}},{get:function(){return o._shape[1]},set:function(t){return o.height=t}}]),this._shapeVector=l}function s(t,e){return 3===t.length?1===e[2]&&e[1]===t[0]*t[2]&&e[0]===t[2]:1===e[0]&&e[1]===t[0]}function l(t,e,r,n,i,a,o,l){var u=l.dtype,c=l.shape.slice();if(c.length<2||c.length>3)throw new Error(\"gl-texture2d: Invalid ndarray, must be 2d or 3d\");var h=0,f=0,d=s(c,l.stride.slice());\"float32\"===u?h=t.FLOAT:\"float64\"===u?(h=t.FLOAT,d=!1,u=\"float32\"):\"uint8\"===u?h=t.UNSIGNED_BYTE:(h=t.UNSIGNED_BYTE,d=!1,u=\"uint8\");if(2===c.length)f=t.LUMINANCE,c=[c[0],c[1],1],l=p(l.data,c,[l.stride[0],l.stride[1],1],l.offset);else{if(3!==c.length)throw new Error(\"gl-texture2d: Invalid shape for texture\");if(1===c[2])f=t.ALPHA;else if(2===c[2])f=t.LUMINANCE_ALPHA;else if(3===c[2])f=t.RGB;else{if(4!==c[2])throw new Error(\"gl-texture2d: Invalid shape for pixel coords\");f=t.RGBA}c[2]}if(f!==t.LUMINANCE&&f!==t.ALPHA||i!==t.LUMINANCE&&i!==t.ALPHA||(f=i),f!==i)throw new Error(\"gl-texture2d: Incompatible texture format for setPixels\");var g=l.size,y=o.indexOf(n)<0;if(y&&o.push(n),h===a&&d)0===l.offset&&l.data.length===g?y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,l.data):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,l.data):y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,l.data.subarray(l.offset,l.offset+g)):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,l.data.subarray(l.offset,l.offset+g));else{var b;b=a===t.FLOAT?v.mallocFloat32(g):v.mallocUint8(g);var _=p(b,c,[c[2],c[2]*c[0],1]);h===t.FLOAT&&a===t.UNSIGNED_BYTE?x(_,l):m.assign(_,l),y?t.texImage2D(t.TEXTURE_2D,n,i,c[0],c[1],0,i,a,b.subarray(0,g)):t.texSubImage2D(t.TEXTURE_2D,n,e,r,c[0],c[1],i,a,b.subarray(0,g)),a===t.FLOAT?v.freeFloat32(b):v.freeUint8(b)}}function u(t){var e=t.createTexture();return t.bindTexture(t.TEXTURE_2D,e),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),e}function c(t,e,r,n,i){var a=t.getParameter(t.MAX_TEXTURE_SIZE);if(e<0||e>a||r<0||r>a)throw new Error(\"gl-texture2d: Invalid texture shape\");if(i===t.FLOAT&&!t.getExtension(\"OES_texture_float\"))throw new Error(\"gl-texture2d: Floating point textures not supported on this platform\");var s=u(t);return t.texImage2D(t.TEXTURE_2D,0,n,e,r,0,n,i,null),new o(t,s,e,r,n,i)}function h(t,e,r,n,i,a){var s=u(t);return t.texImage2D(t.TEXTURE_2D,0,i,i,a,e),new o(t,s,r,n,i,a)}function f(t,e){var r=e.dtype,n=e.shape.slice(),i=t.getParameter(t.MAX_TEXTURE_SIZE);if(n[0]<0||n[0]>i||n[1]<0||n[1]>i)throw new Error(\"gl-texture2d: Invalid texture size\");var a=s(n,e.stride.slice()),l=0;\"float32\"===r?l=t.FLOAT:\"float64\"===r?(l=t.FLOAT,a=!1,r=\"float32\"):\"uint8\"===r?l=t.UNSIGNED_BYTE:(l=t.UNSIGNED_BYTE,a=!1,r=\"uint8\");var c=0;if(2===n.length)c=t.LUMINANCE,n=[n[0],n[1],1],e=p(e.data,n,[e.stride[0],e.stride[1],1],e.offset);else{if(3!==n.length)throw new Error(\"gl-texture2d: Invalid shape for texture\");if(1===n[2])c=t.ALPHA;else if(2===n[2])c=t.LUMINANCE_ALPHA;else if(3===n[2])c=t.RGB;else{if(4!==n[2])throw new Error(\"gl-texture2d: Invalid shape for pixel coords\");c=t.RGBA}}l!==t.FLOAT||t.getExtension(\"OES_texture_float\")||(l=t.UNSIGNED_BYTE,a=!1);var h,f,d=e.size;if(a)h=0===e.offset&&e.data.length===d?e.data:e.data.subarray(e.offset,e.offset+d);else{var g=[n[2],n[2]*n[0],1];f=v.malloc(d,r);var y=p(f,n,g,0);\"float32\"!==r&&\"float64\"!==r||l!==t.UNSIGNED_BYTE?m.assign(y,e):x(y,e),h=f.subarray(0,d)}var b=u(t);return t.texImage2D(t.TEXTURE_2D,0,c,n[0],n[1],0,c,l,h),a||v.free(f),new o(t,b,n[0],n[1],c,l)}function d(t){if(arguments.length<=1)throw new Error(\"gl-texture2d: Missing arguments for texture2d constructor\");if(g||n(t),\"number\"==typeof arguments[1])return c(t,arguments[1],arguments[2],arguments[3]||t.RGBA,arguments[4]||t.UNSIGNED_BYTE);if(Array.isArray(arguments[1]))return c(t,0|arguments[1][0],0|arguments[1][1],arguments[2]||t.RGBA,arguments[3]||t.UNSIGNED_BYTE);if(\"object\"==typeof arguments[1]){var e=arguments[1],r=i(e)?e:e.raw;if(r)return h(t,r,0|e.width,0|e.height,arguments[2]||t.RGBA,arguments[3]||t.UNSIGNED_BYTE);if(e.shape&&e.data&&e.stride)return f(t,e)}throw new Error(\"gl-texture2d: Invalid arguments for texture2d constructor\")}var p=t(\"ndarray\"),m=t(\"ndarray-ops\"),v=t(\"typedarray-pool\");e.exports=d;var g=null,y=null,b=null,x=function(t,e){m.muls(t,e,255)},_=o.prototype;Object.defineProperties(_,{minFilter:{get:function(){return this._minFilter},set:function(t){this.bind();var e=this.gl;if(this.type===e.FLOAT&&g.indexOf(t)>=0&&(e.getExtension(\"OES_texture_float_linear\")||(t=e.NEAREST)),y.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown filter mode \"+t);return e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,t),this._minFilter=t}},magFilter:{get:function(){return this._magFilter},set:function(t){this.bind();var e=this.gl;if(this.type===e.FLOAT&&g.indexOf(t)>=0&&(e.getExtension(\"OES_texture_float_linear\")||(t=e.NEAREST)),y.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown filter mode \"+t);return e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,t),this._magFilter=t}},mipSamples:{get:function(){return this._anisoSamples},set:function(t){var e=this._anisoSamples;if(this._anisoSamples=0|Math.max(t,1),e!==this._anisoSamples){var r=this.gl.getExtension(\"EXT_texture_filter_anisotropic\");r&&this.gl.texParameterf(this.gl.TEXTURE_2D,r.TEXTURE_MAX_ANISOTROPY_EXT,this._anisoSamples)}return this._anisoSamples}},wrapS:{get:function(){return this._wrapS},set:function(t){if(this.bind(),b.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);return this.gl.texParameteri(this.gl.TEXTURE_2D,this.gl.TEXTURE_WRAP_S,t),this._wrapS=t}},wrapT:{get:function(){return this._wrapT},set:function(t){if(this.bind(),b.indexOf(t)<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);return this.gl.texParameteri(this.gl.TEXTURE_2D,this.gl.TEXTURE_WRAP_T,t),this._wrapT=t}},wrap:{get:function(){return this._wrapVector},set:function(t){if(Array.isArray(t)||(t=[t,t]),2!==t.length)throw new Error(\"gl-texture2d: Must specify wrap mode for rows and columns\");for(var e=0;e<2;++e)if(b.indexOf(t[e])<0)throw new Error(\"gl-texture2d: Unknown wrap mode \"+t);this._wrapS=t[0],this._wrapT=t[1];var r=this.gl;return this.bind(),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_S,this._wrapS),r.texParameteri(r.TEXTURE_2D,r.TEXTURE_WRAP_T,this._wrapT),t}},shape:{get:function(){return this._shapeVector},set:function(t){if(Array.isArray(t)){if(2!==t.length)throw new Error(\"gl-texture2d: Invalid texture shape\")}else t=[0|t,0|t];return a(this,0|t[0],0|t[1]),[0|t[0],0|t[1]]}},width:{get:function(){return this._shape[0]},set:function(t){return t|=0,a(this,t,this._shape[1]),t}},height:{get:function(){return this._shape[1]},set:function(t){return t|=0,a(this,this._shape[0],t),t}}}),_.bind=function(t){var e=this.gl;return void 0!==t&&e.activeTexture(e.TEXTURE0+(0|t)),e.bindTexture(e.TEXTURE_2D,this.handle),void 0!==t?0|t:e.getParameter(e.ACTIVE_TEXTURE)-e.TEXTURE0},_.dispose=function(){this.gl.deleteTexture(this.handle)},_.generateMipmap=function(){this.bind(),this.gl.generateMipmap(this.gl.TEXTURE_2D);for(var t=Math.min(this._shape[0],this._shape[1]),e=0;t>0;++e,t>>>=1)this._mipLevels.indexOf(e)<0&&this._mipLevels.push(e)},_.setPixels=function(t,e,r,n){var a=this.gl;this.bind(),Array.isArray(e)?(n=r,r=0|e[1],e=0|e[0]):(e=e||0,r=r||0),n=n||0;var o=i(t)?t:t.raw;if(o){this._mipLevels.indexOf(n)<0?(a.texImage2D(a.TEXTURE_2D,0,this.format,this.format,this.type,o),this._mipLevels.push(n)):a.texSubImage2D(a.TEXTURE_2D,n,e,r,this.format,this.type,o)}else{if(!(t.shape&&t.stride&&t.data))throw new Error(\"gl-texture2d: Unsupported data type\");if(t.shape.length<2||e+t.shape[1]>this._shape[1]>>>n||r+t.shape[0]>this._shape[0]>>>n||e<0||r<0)throw new Error(\"gl-texture2d: Texture dimensions are out of bounds\");l(a,e,r,n,this.format,this.type,this._mipLevels,t)}}},{ndarray:466,\"ndarray-ops\":460,\"typedarray-pool\":540}],267:[function(t,e,r){\"use strict\";function n(t,e,r){e?e.bind():t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,null);var n=0|t.getParameter(t.MAX_VERTEX_ATTRIBS);if(r){if(r.length>n)throw new Error(\"gl-vao: Too many vertex attributes\");for(var i=0;i<r.length;++i){var a=r[i];if(a.buffer){var o=a.buffer,s=a.size||4,l=a.type||t.FLOAT,u=!!a.normalized,c=a.stride||0,h=a.offset||0;o.bind(),t.enableVertexAttribArray(i),t.vertexAttribPointer(i,s,l,u,c,h)}else{if(\"number\"==typeof a)t.vertexAttrib1f(i,a);else if(1===a.length)t.vertexAttrib1f(i,a[0]);else if(2===a.length)t.vertexAttrib2f(i,a[0],a[1]);else if(3===a.length)t.vertexAttrib3f(i,a[0],a[1],a[2]);else{if(4!==a.length)throw new Error(\"gl-vao: Invalid vertex attribute\");t.vertexAttrib4f(i,a[0],a[1],a[2],a[3])}t.disableVertexAttribArray(i)}}for(;i<n;++i)t.disableVertexAttribArray(i)}else{t.bindBuffer(t.ARRAY_BUFFER,null);for(var i=0;i<n;++i)t.disableVertexAttribArray(i)}}e.exports=n},{}],268:[function(t,e,r){\"use strict\";function n(t){this.gl=t,this._elements=null,this._attributes=null,this._elementsType=t.UNSIGNED_SHORT}function i(t){return new n(t)}var a=t(\"./do-bind.js\");n.prototype.bind=function(){a(this.gl,this._elements,this._attributes)},n.prototype.update=function(t,e,r){this._elements=e,this._attributes=t,this._elementsType=r||this.gl.UNSIGNED_SHORT},n.prototype.dispose=function(){},n.prototype.unbind=function(){},n.prototype.draw=function(t,e,r){r=r||0;var n=this.gl;this._elements?n.drawElements(t,e,this._elementsType,r):n.drawArrays(t,r,e)},e.exports=i},{\"./do-bind.js\":267}],269:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a){this.location=t,this.dimension=e,this.a=r,this.b=n,this.c=i,this.d=a}function i(t,e,r){this.gl=t,this._ext=e,this.handle=r,this._attribs=[],this._useElements=!1,this._elementsType=t.UNSIGNED_SHORT}function a(t,e){return new i(t,e,e.createVertexArrayOES())}var o=t(\"./do-bind.js\");n.prototype.bind=function(t){switch(this.dimension){case 1:t.vertexAttrib1f(this.location,this.a);break;case 2:t.vertexAttrib2f(this.location,this.a,this.b);break;case 3:t.vertexAttrib3f(this.location,this.a,this.b,this.c);break;case 4:t.vertexAttrib4f(this.location,this.a,this.b,this.c,this.d)}},i.prototype.bind=function(){this._ext.bindVertexArrayOES(this.handle);for(var t=0;t<this._attribs.length;++t)this._attribs[t].bind(this.gl)},i.prototype.unbind=function(){this._ext.bindVertexArrayOES(null)},i.prototype.dispose=function(){this._ext.deleteVertexArrayOES(this.handle)},i.prototype.update=function(t,e,r){if(this.bind(),o(this.gl,e,t),this.unbind(),this._attribs.length=0,t)for(var i=0;i<t.length;++i){var a=t[i];\"number\"==typeof a?this._attribs.push(new n(i,1,a)):Array.isArray(a)&&this._attribs.push(new n(i,a.length,a[0],a[1],a[2],a[3]))}this._useElements=!!e,this._elementsType=r||this.gl.UNSIGNED_SHORT},i.prototype.draw=function(t,e,r){r=r||0;var n=this.gl;this._useElements?n.drawElements(t,e,this._elementsType,r):n.drawArrays(t,r,e)},e.exports=a},{\"./do-bind.js\":267}],270:[function(t,e,r){\"use strict\";function n(t){this.bindVertexArrayOES=t.bindVertexArray.bind(t),this.createVertexArrayOES=t.createVertexArray.bind(t),this.deleteVertexArrayOES=t.deleteVertexArray.bind(t)}function i(t,e,r,i){var s,l=t.createVertexArray?new n(t):t.getExtension(\"OES_vertex_array_object\");return s=l?a(t,l):o(t),s.update(e,r,i),s}var a=t(\"./lib/vao-native.js\"),o=t(\"./lib/vao-emulated.js\");e.exports=i},{\"./lib/vao-emulated.js\":268,\"./lib/vao-native.js\":269}],271:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=r[0],s=r[1],l=r[2];return t[0]=i*l-a*s,t[1]=a*o-n*l,t[2]=n*s-i*o,t}e.exports=n},{}],272:[function(t,e,r){function n(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}e.exports=n},{}],273:[function(t,e,r){function n(t){var e=t[0],r=t[1],n=t[2];return Math.sqrt(e*e+r*r+n*n)}e.exports=n},{}],274:[function(t,e,r){function n(t,e,r,n){var i=e[0],a=e[1],o=e[2];return t[0]=i+n*(r[0]-i),t[1]=a+n*(r[1]-a),t[2]=o+n*(r[2]-o),t}e.exports=n},{}],275:[function(t,e,r){function n(t,e){var r=e[0],n=e[1],i=e[2],a=r*r+n*n+i*i;return a>0&&(a=1/Math.sqrt(a),t[0]=e[0]*a,t[1]=e[1]*a,t[2]=e[2]*a),t}e.exports=n},{}],276:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t}e.exports=n},{}],277:[function(t,e,r){function n(t,e,r,n){return i[0]=n,i[1]=r,i[2]=e,i[3]=t,a[0]}e.exports=n;var i=new Uint8Array(4),a=new Float32Array(i.buffer)},{}],278:[function(t,e,r){function n(t){for(var e=Array.isArray(t)?t:i(t),r=0;r<e.length;r++){var n=e[r];if(\"preprocessor\"===n.type){var o=n.data.match(/\\#define\\s+SHADER_NAME(_B64)?\\s+(.+)$/);if(o&&o[2]){var s=o[1],l=o[2];return(s?a(l):l).trim()}}}}var i=t(\"glsl-tokenizer\"),a=t(\"atob-lite\");e.exports=n},{\"atob-lite\":47,\"glsl-tokenizer\":285}],279:[function(t,e,r){function n(t){function e(t){t.length&&V.push({type:M[B],data:t,position:G,line:H,column:q})}function r(t){j=0,W+=t,F=W.length;for(var e;O=W[j],j<F;){switch(e=j,B){case h:j=E();break;case f:j=S();break;case d:j=T();break;case p:j=L();break;case m:j=I();break;case w:j=z();break;case v:j=D();break;case c:j=P();break;case x:j=A();break;case u:j=k()}if(e!==j)switch(W[e]){case\"\\n\":q=0,++H;break;default:++q}}return N+=j,W=W.slice(j),V}function n(t){return U.length&&e(U.join(\"\")),B=_,e(\"(eof)\"),V}function k(){return U=U.length?[]:U,\"/\"===R&&\"*\"===O?(G=N+j-1,B=h,R=O,j+1):\"/\"===R&&\"/\"===O?(G=N+j-1,B=f,R=O,j+1):\"#\"===O?(B=d,G=N+j,j):/\\s/.test(O)?(B=x,G=N+j,j):(Y=/\\d/.test(O),X=/[^\\w_]/.test(O),G=N+j,B=Y?m:X?p:c,j)}function A(){return/[^\\s]/g.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function T(){return\"\\r\"!==O&&\"\\n\"!==O||\"\\\\\"===R?(U.push(O),R=O,j+1):(e(U.join(\"\")),B=u,j)}function S(){return T()}function E(){return\"/\"===O&&\"*\"===R?(U.push(O),e(U.join(\"\")),B=u,j+1):(U.push(O),R=O,j+1)}function L(){if(\".\"===R&&/\\d/.test(O))return B=v,j;if(\"/\"===R&&\"*\"===O)return B=h,j;if(\"/\"===R&&\"/\"===O)return B=f,j;if(\".\"===O&&U.length){for(;C(U););return B=v,j}if(\";\"===O||\")\"===O||\"(\"===O){if(U.length)for(;C(U););return e(O),B=u,j+1}var t=2===U.length&&\"=\"!==O;if(/[\\w_\\d\\s]/.test(O)||t){for(;C(U););return B=u,j}return U.push(O),R=O,j+1}function C(t){for(var r,n,i=0;;){if(r=a.indexOf(t.slice(0,t.length+i).join(\"\")),n=a[r],-1===r){if(i--+t.length>0)continue;n=t.slice(0,1).join(\"\")}return e(n),G+=n.length,U=U.slice(n.length),U.length}}function z(){return/[^a-fA-F0-9]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function I(){return\".\"===O?(U.push(O),B=v,R=O,j+1):/[eE]/.test(O)?(U.push(O),B=v,R=O,j+1):\"x\"===O&&1===U.length&&\"0\"===U[0]?(B=w,U.push(O),R=O,j+1):/[^\\d]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function D(){return\"f\"===O&&(U.push(O),R=O,j+=1),/[eE]/.test(O)?(U.push(O),R=O,j+1):\"-\"===O&&/[eE]/.test(R)?(U.push(O),R=O,j+1):/[^\\d]/.test(O)?(e(U.join(\"\")),B=u,j):(U.push(O),R=O,j+1)}function P(){if(/[^\\d\\w_]/.test(O)){var t=U.join(\"\");return B=J.indexOf(t)>-1?b:Z.indexOf(t)>-1?y:g,e(U.join(\"\")),B=u,j}return U.push(O),R=O,j+1}var O,R,F,j=0,N=0,B=u,U=[],V=[],H=1,q=0,G=0,Y=!1,X=!1,W=\"\";t=t||{};var Z=o,J=i;return\"300 es\"===t.version&&(Z=l,J=s),function(t){return V=[],null!==t?r(t.replace?t.replace(/\\r\\n/g,\"\\n\"):t):n()}}e.exports=n;var i=t(\"./lib/literals\"),a=t(\"./lib/operators\"),o=t(\"./lib/builtins\"),s=t(\"./lib/literals-300es\"),l=t(\"./lib/builtins-300es\"),u=999,c=9999,h=0,f=1,d=2,p=3,m=4,v=5,g=6,y=7,b=8,x=9,_=10,w=11,M=[\"block-comment\",\"line-comment\",\"preprocessor\",\"operator\",\"integer\",\"float\",\"ident\",\"builtin\",\"keyword\",\"whitespace\",\"eof\",\"integer\"]},{\"./lib/builtins\":281,\"./lib/builtins-300es\":280,\"./lib/literals\":283,\"./lib/literals-300es\":282,\"./lib/operators\":284}],280:[function(t,e,r){var n=t(\"./builtins\");n=n.slice().filter(function(t){return!/^(gl\\_|texture)/.test(t)}),e.exports=n.concat([\"gl_VertexID\",\"gl_InstanceID\",\"gl_Position\",\"gl_PointSize\",\"gl_FragCoord\",\"gl_FrontFacing\",\"gl_FragDepth\",\"gl_PointCoord\",\"gl_MaxVertexAttribs\",\"gl_MaxVertexUniformVectors\",\"gl_MaxVertexOutputVectors\",\"gl_MaxFragmentInputVectors\",\"gl_MaxVertexTextureImageUnits\",\"gl_MaxCombinedTextureImageUnits\",\"gl_MaxTextureImageUnits\",\"gl_MaxFragmentUniformVectors\",\"gl_MaxDrawBuffers\",\"gl_MinProgramTexelOffset\",\"gl_MaxProgramTexelOffset\",\"gl_DepthRangeParameters\",\"gl_DepthRange\",\"trunc\",\"round\",\"roundEven\",\"isnan\",\"isinf\",\"floatBitsToInt\",\"floatBitsToUint\",\"intBitsToFloat\",\"uintBitsToFloat\",\"packSnorm2x16\",\"unpackSnorm2x16\",\"packUnorm2x16\",\"unpackUnorm2x16\",\"packHalf2x16\",\"unpackHalf2x16\",\"outerProduct\",\"transpose\",\"determinant\",\"inverse\",\"texture\",\"textureSize\",\"textureProj\",\"textureLod\",\"textureOffset\",\"texelFetch\",\"texelFetchOffset\",\"textureProjOffset\",\"textureLodOffset\",\"textureProjLod\",\"textureProjLodOffset\",\"textureGrad\",\"textureGradOffset\",\"textureProjGrad\",\"textureProjGradOffset\"])},{\"./builtins\":281}],281:[function(t,e,r){\n",
       "e.exports=[\"abs\",\"acos\",\"all\",\"any\",\"asin\",\"atan\",\"ceil\",\"clamp\",\"cos\",\"cross\",\"dFdx\",\"dFdy\",\"degrees\",\"distance\",\"dot\",\"equal\",\"exp\",\"exp2\",\"faceforward\",\"floor\",\"fract\",\"gl_BackColor\",\"gl_BackLightModelProduct\",\"gl_BackLightProduct\",\"gl_BackMaterial\",\"gl_BackSecondaryColor\",\"gl_ClipPlane\",\"gl_ClipVertex\",\"gl_Color\",\"gl_DepthRange\",\"gl_DepthRangeParameters\",\"gl_EyePlaneQ\",\"gl_EyePlaneR\",\"gl_EyePlaneS\",\"gl_EyePlaneT\",\"gl_Fog\",\"gl_FogCoord\",\"gl_FogFragCoord\",\"gl_FogParameters\",\"gl_FragColor\",\"gl_FragCoord\",\"gl_FragData\",\"gl_FragDepth\",\"gl_FragDepthEXT\",\"gl_FrontColor\",\"gl_FrontFacing\",\"gl_FrontLightModelProduct\",\"gl_FrontLightProduct\",\"gl_FrontMaterial\",\"gl_FrontSecondaryColor\",\"gl_LightModel\",\"gl_LightModelParameters\",\"gl_LightModelProducts\",\"gl_LightProducts\",\"gl_LightSource\",\"gl_LightSourceParameters\",\"gl_MaterialParameters\",\"gl_MaxClipPlanes\",\"gl_MaxCombinedTextureImageUnits\",\"gl_MaxDrawBuffers\",\"gl_MaxFragmentUniformComponents\",\"gl_MaxLights\",\"gl_MaxTextureCoords\",\"gl_MaxTextureImageUnits\",\"gl_MaxTextureUnits\",\"gl_MaxVaryingFloats\",\"gl_MaxVertexAttribs\",\"gl_MaxVertexTextureImageUnits\",\"gl_MaxVertexUniformComponents\",\"gl_ModelViewMatrix\",\"gl_ModelViewMatrixInverse\",\"gl_ModelViewMatrixInverseTranspose\",\"gl_ModelViewMatrixTranspose\",\"gl_ModelViewProjectionMatrix\",\"gl_ModelViewProjectionMatrixInverse\",\"gl_ModelViewProjectionMatrixInverseTranspose\",\"gl_ModelViewProjectionMatrixTranspose\",\"gl_MultiTexCoord0\",\"gl_MultiTexCoord1\",\"gl_MultiTexCoord2\",\"gl_MultiTexCoord3\",\"gl_MultiTexCoord4\",\"gl_MultiTexCoord5\",\"gl_MultiTexCoord6\",\"gl_MultiTexCoord7\",\"gl_Normal\",\"gl_NormalMatrix\",\"gl_NormalScale\",\"gl_ObjectPlaneQ\",\"gl_ObjectPlaneR\",\"gl_ObjectPlaneS\",\"gl_ObjectPlaneT\",\"gl_Point\",\"gl_PointCoord\",\"gl_PointParameters\",\"gl_PointSize\",\"gl_Position\",\"gl_ProjectionMatrix\",\"gl_ProjectionMatrixInverse\",\"gl_ProjectionMatrixInverseTranspose\",\"gl_ProjectionMatrixTranspose\",\"gl_SecondaryColor\",\"gl_TexCoord\",\"gl_TextureEnvColor\",\"gl_TextureMatrix\",\"gl_TextureMatrixInverse\",\"gl_TextureMatrixInverseTranspose\",\"gl_TextureMatrixTranspose\",\"gl_Vertex\",\"greaterThan\",\"greaterThanEqual\",\"inversesqrt\",\"length\",\"lessThan\",\"lessThanEqual\",\"log\",\"log2\",\"matrixCompMult\",\"max\",\"min\",\"mix\",\"mod\",\"normalize\",\"not\",\"notEqual\",\"pow\",\"radians\",\"reflect\",\"refract\",\"sign\",\"sin\",\"smoothstep\",\"sqrt\",\"step\",\"tan\",\"texture2D\",\"texture2DLod\",\"texture2DProj\",\"texture2DProjLod\",\"textureCube\",\"textureCubeLod\",\"texture2DLodEXT\",\"texture2DProjLodEXT\",\"textureCubeLodEXT\",\"texture2DGradEXT\",\"texture2DProjGradEXT\",\"textureCubeGradEXT\"]},{}],282:[function(t,e,r){var n=t(\"./literals\");e.exports=n.slice().concat([\"layout\",\"centroid\",\"smooth\",\"case\",\"mat2x2\",\"mat2x3\",\"mat2x4\",\"mat3x2\",\"mat3x3\",\"mat3x4\",\"mat4x2\",\"mat4x3\",\"mat4x4\",\"uint\",\"uvec2\",\"uvec3\",\"uvec4\",\"samplerCubeShadow\",\"sampler2DArray\",\"sampler2DArrayShadow\",\"isampler2D\",\"isampler3D\",\"isamplerCube\",\"isampler2DArray\",\"usampler2D\",\"usampler3D\",\"usamplerCube\",\"usampler2DArray\",\"coherent\",\"restrict\",\"readonly\",\"writeonly\",\"resource\",\"atomic_uint\",\"noperspective\",\"patch\",\"sample\",\"subroutine\",\"common\",\"partition\",\"active\",\"filter\",\"image1D\",\"image2D\",\"image3D\",\"imageCube\",\"iimage1D\",\"iimage2D\",\"iimage3D\",\"iimageCube\",\"uimage1D\",\"uimage2D\",\"uimage3D\",\"uimageCube\",\"image1DArray\",\"image2DArray\",\"iimage1DArray\",\"iimage2DArray\",\"uimage1DArray\",\"uimage2DArray\",\"image1DShadow\",\"image2DShadow\",\"image1DArrayShadow\",\"image2DArrayShadow\",\"imageBuffer\",\"iimageBuffer\",\"uimageBuffer\",\"sampler1DArray\",\"sampler1DArrayShadow\",\"isampler1D\",\"isampler1DArray\",\"usampler1D\",\"usampler1DArray\",\"isampler2DRect\",\"usampler2DRect\",\"samplerBuffer\",\"isamplerBuffer\",\"usamplerBuffer\",\"sampler2DMS\",\"isampler2DMS\",\"usampler2DMS\",\"sampler2DMSArray\",\"isampler2DMSArray\",\"usampler2DMSArray\"])},{\"./literals\":283}],283:[function(t,e,r){e.exports=[\"precision\",\"highp\",\"mediump\",\"lowp\",\"attribute\",\"const\",\"uniform\",\"varying\",\"break\",\"continue\",\"do\",\"for\",\"while\",\"if\",\"else\",\"in\",\"out\",\"inout\",\"float\",\"int\",\"void\",\"bool\",\"true\",\"false\",\"discard\",\"return\",\"mat2\",\"mat3\",\"mat4\",\"vec2\",\"vec3\",\"vec4\",\"ivec2\",\"ivec3\",\"ivec4\",\"bvec2\",\"bvec3\",\"bvec4\",\"sampler1D\",\"sampler2D\",\"sampler3D\",\"samplerCube\",\"sampler1DShadow\",\"sampler2DShadow\",\"struct\",\"asm\",\"class\",\"union\",\"enum\",\"typedef\",\"template\",\"this\",\"packed\",\"goto\",\"switch\",\"default\",\"inline\",\"noinline\",\"volatile\",\"public\",\"static\",\"extern\",\"external\",\"interface\",\"long\",\"short\",\"double\",\"half\",\"fixed\",\"unsigned\",\"input\",\"output\",\"hvec2\",\"hvec3\",\"hvec4\",\"dvec2\",\"dvec3\",\"dvec4\",\"fvec2\",\"fvec3\",\"fvec4\",\"sampler2DRect\",\"sampler3DRect\",\"sampler2DRectShadow\",\"sizeof\",\"cast\",\"namespace\",\"using\"]},{}],284:[function(t,e,r){e.exports=[\"<<=\",\">>=\",\"++\",\"--\",\"<<\",\">>\",\"<=\",\">=\",\"==\",\"!=\",\"&&\",\"||\",\"+=\",\"-=\",\"*=\",\"/=\",\"%=\",\"&=\",\"^^\",\"^=\",\"|=\",\"(\",\")\",\"[\",\"]\",\".\",\"!\",\"~\",\"*\",\"/\",\"%\",\"+\",\"-\",\"<\",\">\",\"&\",\"^\",\"|\",\"?\",\":\",\"=\",\",\",\";\",\"{\",\"}\"]},{}],285:[function(t,e,r){function n(t,e){var r=i(e),n=[];return n=n.concat(r(t)),n=n.concat(r(null))}var i=t(\"./index\");e.exports=n},{\"./index\":279}],286:[function(t,e,r){\"use strict\";function n(t,e,r){var n=this.cells=[];if(t instanceof ArrayBuffer){this.arrayBuffer=t;var a=new Int32Array(this.arrayBuffer);t=a[0],e=a[1],r=a[2],this.d=e+2*r;for(var o=0;o<this.d*this.d;o++){var s=a[i+o],l=a[i+o+1];n.push(s===l?null:a.subarray(s,l))}var u=a[i+n.length],c=a[i+n.length+1];this.keys=a.subarray(u,c),this.bboxes=a.subarray(c),this.insert=this._insertReadonly}else{this.d=e+2*r;for(var h=0;h<this.d*this.d;h++)n.push([]);this.keys=[],this.bboxes=[]}this.n=e,this.extent=t,this.padding=r,this.scale=e/t,this.uid=0;var f=r/e*t;this.min=-f,this.max=t+f}e.exports=n;var i=3;n.prototype.insert=function(t,e,r,n,i){this._forEachCell(e,r,n,i,this._insertCell,this.uid++),this.keys.push(t),this.bboxes.push(e),this.bboxes.push(r),this.bboxes.push(n),this.bboxes.push(i)},n.prototype._insertReadonly=function(){throw\"Cannot insert into a GridIndex created from an ArrayBuffer.\"},n.prototype._insertCell=function(t,e,r,n,i,a){this.cells[i].push(a)},n.prototype.query=function(t,e,r,n){var i=this.min,a=this.max;if(t<=i&&e<=i&&a<=r&&a<=n)return Array.prototype.slice.call(this.keys);var o=[],s={};return this._forEachCell(t,e,r,n,this._queryCell,o,s),o},n.prototype._queryCell=function(t,e,r,n,i,a,o){var s=this.cells[i];if(null!==s)for(var l=this.keys,u=this.bboxes,c=0;c<s.length;c++){var h=s[c];if(void 0===o[h]){var f=4*h;t<=u[f+2]&&e<=u[f+3]&&r>=u[f+0]&&n>=u[f+1]?(o[h]=!0,a.push(l[h])):o[h]=!1}}},n.prototype._forEachCell=function(t,e,r,n,i,a,o){for(var s=this._convertToCellCoord(t),l=this._convertToCellCoord(e),u=this._convertToCellCoord(r),c=this._convertToCellCoord(n),h=s;h<=u;h++)for(var f=l;f<=c;f++){var d=this.d*f+h;if(i.call(this,t,e,r,n,d,a,o))return}},n.prototype._convertToCellCoord=function(t){return Math.max(0,Math.min(this.d-1,Math.floor(t*this.scale)+this.padding))},n.prototype.toArrayBuffer=function(){if(this.arrayBuffer)return this.arrayBuffer;for(var t=this.cells,e=i+this.cells.length+1+1,r=0,n=0;n<this.cells.length;n++)r+=this.cells[n].length;var a=new Int32Array(e+r+this.keys.length+this.bboxes.length);a[0]=this.extent,a[1]=this.n,a[2]=this.padding;for(var o=e,s=0;s<t.length;s++){var l=t[s];a[i+s]=o,a.set(l,o),o+=l.length}return a[i+t.length]=o,a.set(this.keys,o),o+=this.keys.length,a[i+t.length+1]=o,a.set(this.bboxes,o),o+=this.bboxes.length,a.buffer}},{}],287:[function(t,e,r){(function(r){\"use strict\";var n,i=t(\"is-browser\");n=\"function\"==typeof r.matchMedia?!r.matchMedia(\"(hover: none)\").matches:i,e.exports=n}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"is-browser\":293}],288:[function(t,e,r){r.read=function(t,e,r,n,i){var a,o,s=8*i-n-1,l=(1<<s)-1,u=l>>1,c=-7,h=r?i-1:0,f=r?-1:1,d=t[e+h];for(h+=f,a=d&(1<<-c)-1,d>>=-c,c+=s;c>0;a=256*a+t[e+h],h+=f,c-=8);for(o=a&(1<<-c)-1,a>>=-c,c+=n;c>0;o=256*o+t[e+h],h+=f,c-=8);if(0===a)a=1-u;else{if(a===l)return o?NaN:1/0*(d?-1:1);o+=Math.pow(2,n),a-=u}return(d?-1:1)*o*Math.pow(2,a-n)},r.write=function(t,e,r,n,i,a){var o,s,l,u=8*a-i-1,c=(1<<u)-1,h=c>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=n?0:a-1,p=n?1:-1,m=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(s=isNaN(e)?1:0,o=c):(o=Math.floor(Math.log(e)/Math.LN2),e*(l=Math.pow(2,-o))<1&&(o--,l*=2),e+=o+h>=1?f/l:f*Math.pow(2,1-h),e*l>=2&&(o++,l/=2),o+h>=c?(s=0,o=c):o+h>=1?(s=(e*l-1)*Math.pow(2,i),o+=h):(s=e*Math.pow(2,h-1)*Math.pow(2,i),o=0));i>=8;t[r+d]=255&s,d+=p,s/=256,i-=8);for(o=o<<i|s,u+=i;u>0;t[r+d]=255&o,d+=p,o/=256,u-=8);t[r+d-p]|=128*m}},{}],289:[function(t,e,r){\"use strict\";function n(t,e,r){this.vertices=t,this.adjacent=e,this.boundary=r,this.lastVisited=-1}function i(t,e,r){this.vertices=t,this.cell=e,this.index=r}function a(t,e){return c(t.vertices,e.vertices)}function o(t){for(var e=[\"function orient(){var tuple=this.tuple;return test(\"],r=0;r<=t;++r)r>0&&e.push(\",\"),e.push(\"tuple[\",r,\"]\");e.push(\")}return orient\");var n=new Function(\"test\",e.join(\"\")),i=u[t+1];return i||(i=u),n(i)}function s(t,e,r){this.dimension=t,this.vertices=e,this.simplices=r,this.interior=r.filter(function(t){return!t.boundary}),this.tuple=new Array(t+1);for(var n=0;n<=t;++n)this.tuple[n]=this.vertices[n];var i=h[t];i||(i=h[t]=o(t)),this.orient=i}function l(t,e){var r=t.length;if(0===r)throw new Error(\"Must have at least d+1 points\");var i=t[0].length;if(r<=i)throw new Error(\"Must input at least d+1 points\");var a=t.slice(0,i+1),o=u.apply(void 0,a);if(0===o)throw new Error(\"Input not in general position\");for(var l=new Array(i+1),c=0;c<=i;++c)l[c]=c;o<0&&(l[0]=1,l[1]=0);for(var h=new n(l,new Array(i+1),!1),f=h.adjacent,d=new Array(i+2),c=0;c<=i;++c){for(var p=l.slice(),m=0;m<=i;++m)m===c&&(p[m]=-1);var v=p[0];p[0]=p[1],p[1]=v;var g=new n(p,new Array(i+1),!0);f[c]=g,d[c]=g}d[i+1]=h;for(var c=0;c<=i;++c)for(var p=f[c].vertices,y=f[c].adjacent,m=0;m<=i;++m){var b=p[m];if(b<0)y[m]=h;else for(var x=0;x<=i;++x)f[x].vertices.indexOf(b)<0&&(y[m]=f[x])}for(var _=new s(i,a,d),w=!!e,c=i+1;c<r;++c)_.insert(t[c],w);return _.boundary()}e.exports=l;var u=t(\"robust-orientation\"),c=t(\"simplicial-complex\").compareCells;n.prototype.flip=function(){var t=this.vertices[0];this.vertices[0]=this.vertices[1],this.vertices[1]=t;var e=this.adjacent[0];this.adjacent[0]=this.adjacent[1],this.adjacent[1]=e};var h=[],f=s.prototype;f.handleBoundaryDegeneracy=function(t,e){var r=this.dimension,n=this.vertices.length-1,i=this.tuple,a=this.vertices,o=[t];for(t.lastVisited=-n;o.length>0;){t=o.pop();for(var s=(t.vertices,t.adjacent),l=0;l<=r;++l){var u=s[l];if(u.boundary&&!(u.lastVisited<=-n)){for(var c=u.vertices,h=0;h<=r;++h){var f=c[h];i[h]=f<0?e:a[f]}var d=this.orient();if(d>0)return u;u.lastVisited=-n,0===d&&o.push(u)}}}return null},f.walk=function(t,e){var r=this.vertices.length-1,n=this.dimension,i=this.vertices,a=this.tuple,o=e?this.interior.length*Math.random()|0:this.interior.length-1,s=this.interior[o];t:for(;!s.boundary;){for(var l=s.vertices,u=s.adjacent,c=0;c<=n;++c)a[c]=i[l[c]];s.lastVisited=r;for(var c=0;c<=n;++c){var h=u[c];if(!(h.lastVisited>=r)){var f=a[c];a[c]=t;var d=this.orient();if(a[c]=f,d<0){s=h;continue t}h.boundary?h.lastVisited=-r:h.lastVisited=r}}return}return s},f.addPeaks=function(t,e){var r=this.vertices.length-1,o=this.dimension,s=this.vertices,l=this.tuple,u=this.interior,c=this.simplices,h=[e];e.lastVisited=r,e.vertices[e.vertices.indexOf(-1)]=r,e.boundary=!1,u.push(e);for(var f=[];h.length>0;){var e=h.pop(),d=e.vertices,p=e.adjacent,m=d.indexOf(r);if(!(m<0))for(var v=0;v<=o;++v)if(v!==m){var g=p[v];if(g.boundary&&!(g.lastVisited>=r)){var y=g.vertices;if(g.lastVisited!==-r){for(var b=0,x=0;x<=o;++x)y[x]<0?(b=x,l[x]=t):l[x]=s[y[x]];var _=this.orient();if(_>0){y[b]=r,g.boundary=!1,u.push(g),h.push(g),g.lastVisited=r;continue}g.lastVisited=-r}var w=g.adjacent,M=d.slice(),k=p.slice(),A=new n(M,k,!0);c.push(A);var T=w.indexOf(e);if(!(T<0)){w[T]=A,k[m]=g,M[v]=-1,k[v]=e,p[v]=A,A.flip();for(var x=0;x<=o;++x){var S=M[x];if(!(S<0||S===r)){for(var E=new Array(o-1),L=0,C=0;C<=o;++C){var z=M[C];z<0||C===x||(E[L++]=z)}f.push(new i(E,A,x))}}}}}}f.sort(a);for(var v=0;v+1<f.length;v+=2){var I=f[v],D=f[v+1],P=I.index,O=D.index;P<0||O<0||(I.cell.adjacent[I.index]=D.cell,D.cell.adjacent[D.index]=I.cell)}},f.insert=function(t,e){var r=this.vertices;r.push(t);var n=this.walk(t,e);if(n){for(var i=this.dimension,a=this.tuple,o=0;o<=i;++o){var s=n.vertices[o];a[o]=s<0?t:r[s]}var l=this.orient(a);l<0||(0!==l||(n=this.handleBoundaryDegeneracy(n,t)))&&this.addPeaks(t,n)}},f.boundary=function(){for(var t=this.dimension,e=[],r=this.simplices,n=r.length,i=0;i<n;++i){var a=r[i];if(a.boundary){for(var o=new Array(t),s=a.vertices,l=0,u=0,c=0;c<=t;++c)s[c]>=0?o[l++]=s[c]:u=1&c;if(u===(1&t)){var h=o[0];o[0]=o[1],o[1]=h}e.push(o)}}return e}},{\"robust-orientation\":507,\"simplicial-complex\":518}],290:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.mid=t,this.left=e,this.right=r,this.leftPoints=n,this.rightPoints=i,this.count=(e?e.count:0)+(r?r.count:0)+n.length}function i(t,e){t.mid=e.mid,t.left=e.left,t.right=e.right,t.leftPoints=e.leftPoints,t.rightPoints=e.rightPoints,t.count=e.count}function a(t,e){var r=p(e);t.mid=r.mid,t.left=r.left,t.right=r.right,t.leftPoints=r.leftPoints,t.rightPoints=r.rightPoints,t.count=r.count}function o(t,e){var r=t.intervals([]);r.push(e),a(t,r)}function s(t,e){var r=t.intervals([]),n=r.indexOf(e);return n<0?y:(r.splice(n,1),a(t,r),b)}function l(t,e,r){for(var n=0;n<t.length&&t[n][0]<=e;++n){var i=r(t[n]);if(i)return i}}function u(t,e,r){for(var n=t.length-1;n>=0&&t[n][1]>=e;--n){var i=r(t[n]);if(i)return i}}function c(t,e){for(var r=0;r<t.length;++r){var n=e(t[r]);if(n)return n}}function h(t,e){return t-e}function f(t,e){var r=t[0]-e[0];return r||t[1]-e[1]}function d(t,e){var r=t[1]-e[1];return r||t[0]-e[0]}function p(t){if(0===t.length)return null;for(var e=[],r=0;r<t.length;++r)e.push(t[r][0],t[r][1]);e.sort(h);for(var i=e[e.length>>1],a=[],o=[],s=[],r=0;r<t.length;++r){var l=t[r];l[1]<i?a.push(l):i<l[0]?o.push(l):s.push(l)}var u=s,c=s.slice();return u.sort(f),c.sort(d),new n(i,p(a),p(o),u,c)}function m(t){this.root=t}function v(t){return new m(t&&0!==t.length?p(t):null)}var g=t(\"binary-search-bounds\"),y=0,b=1;e.exports=v;var x=n.prototype;x.intervals=function(t){return t.push.apply(t,this.leftPoints),this.left&&this.left.intervals(t),this.right&&this.right.intervals(t),t},x.insert=function(t){var e=this.count-this.leftPoints.length;if(this.count+=1,t[1]<this.mid)this.left?4*(this.left.count+1)>3*(e+1)?o(this,t):this.left.insert(t):this.left=p([t]);else if(t[0]>this.mid)this.right?4*(this.right.count+1)>3*(e+1)?o(this,t):this.right.insert(t):this.right=p([t]);else{var r=g.ge(this.leftPoints,t,f),n=g.ge(this.rightPoints,t,d);this.leftPoints.splice(r,0,t),this.rightPoints.splice(n,0,t)}},x.remove=function(t){var e=this.count-this.leftPoints;if(t[1]<this.mid){if(!this.left)return y;if(4*(this.right?this.right.count:0)>3*(e-1))return s(this,t);var r=this.left.remove(t);return 2===r?(this.left=null,this.count-=1,b):(r===b&&(this.count-=1),r)}if(t[0]>this.mid){if(!this.right)return y;if(4*(this.left?this.left.count:0)>3*(e-1))return s(this,t);var r=this.right.remove(t);return 2===r?(this.right=null,this.count-=1,b):(r===b&&(this.count-=1),r)}if(1===this.count)return this.leftPoints[0]===t?2:y;if(1===this.leftPoints.length&&this.leftPoints[0]===t){if(this.left&&this.right){for(var n=this,a=this.left;a.right;)n=a,a=a.right;if(n===this)a.right=this.right;else{var o=this.left,r=this.right;n.count-=a.count,n.right=a.left,a.left=o,a.right=r}i(this,a),this.count=(this.left?this.left.count:0)+(this.right?this.right.count:0)+this.leftPoints.length}else this.left?i(this,this.left):i(this,this.right);return b}for(var o=g.ge(this.leftPoints,t,f);o<this.leftPoints.length&&this.leftPoints[o][0]===t[0];++o)if(this.leftPoints[o]===t){this.count-=1,this.leftPoints.splice(o,1);for(var r=g.ge(this.rightPoints,t,d);r<this.rightPoints.length&&this.rightPoints[r][1]===t[1];++r)if(this.rightPoints[r]===t)return this.rightPoints.splice(r,1),b}return y},x.queryPoint=function(t,e){if(t<this.mid){if(this.left){var r=this.left.queryPoint(t,e);if(r)return r}return l(this.leftPoints,t,e)}if(t>this.mid){if(this.right){var r=this.right.queryPoint(t,e);if(r)return r}return u(this.rightPoints,t,e)}return c(this.leftPoints,e)},x.queryInterval=function(t,e,r){if(t<this.mid&&this.left){var n=this.left.queryInterval(t,e,r);if(n)return n}if(e>this.mid&&this.right){var n=this.right.queryInterval(t,e,r);if(n)return n}return e<this.mid?l(this.leftPoints,e,r):t>this.mid?u(this.rightPoints,t,r):c(this.leftPoints,r)};var _=m.prototype;_.insert=function(t){this.root?this.root.insert(t):this.root=new n(t[0],null,null,[t],[t])},_.remove=function(t){if(this.root){var e=this.root.remove(t);return 2===e&&(this.root=null),e!==y}return!1},_.queryPoint=function(t,e){if(this.root)return this.root.queryPoint(t,e)},_.queryInterval=function(t,e,r){if(t<=e&&this.root)return this.root.queryInterval(t,e,r)},Object.defineProperty(_,\"count\",{get:function(){return this.root?this.root.count:0}}),Object.defineProperty(_,\"intervals\",{get:function(){return this.root?this.root.intervals([]):[]}})},{\"binary-search-bounds\":65}],291:[function(t,e,r){\"use strict\";function n(t,e){e=e||new Array(t.length);for(var r=0;r<t.length;++r)e[t[r]]=r;return e}e.exports=n},{}],292:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=r;return e}e.exports=n},{}],293:[function(t,e,r){e.exports=!0},{}],294:[function(t,e,r){function n(t){return!!t.constructor&&\"function\"==typeof t.constructor.isBuffer&&t.constructor.isBuffer(t)}function i(t){return\"function\"==typeof t.readFloatLE&&\"function\"==typeof t.slice&&n(t.slice(0,0))}e.exports=function(t){return null!=t&&(n(t)||i(t)||!!t._isBuffer)}},{}],295:[function(t,e,r){function n(t){return t||\"undefined\"==typeof navigator||(t=navigator.userAgent),t&&t.headers&&\"string\"==typeof t.headers[\"user-agent\"]&&(t=t.headers[\"user-agent\"]),\"string\"==typeof t&&(/(android|bb\\d+|meego).+mobile|avantgo|bada\\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\\-|your|zeto|zte\\-/i.test(t.substr(0,4)))}e.exports=n},{}],296:[function(t,e,r){\"use strict\";var n=Object.prototype.toString;e.exports=function(t){var e;return\"[object Object]\"===n.call(t)&&(null===(e=Object.getPrototypeOf(t))||e===Object.getPrototypeOf({}))}},{}],297:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){return new i(t,e,r,n,a)}function i(t,e,r,n,i){e=e||a,r=r||o,i=i||Array,this.nodeSize=n||64,this.points=t,this.ids=new i(t.length),this.coords=new i(2*t.length);for(var l=0;l<t.length;l++)this.ids[l]=l,this.coords[2*l]=e(t[l]),this.coords[2*l+1]=r(t[l]);s(this.ids,this.coords,this.nodeSize,0,this.ids.length-1,0)}function a(t){return t[0]}function o(t){return t[1]}var s=t(\"./sort\"),l=t(\"./range\"),u=t(\"./within\");e.exports=n,i.prototype={range:function(t,e,r,n){return l(this.ids,this.coords,t,e,r,n,this.nodeSize)},within:function(t,e,r){return u(this.ids,this.coords,t,e,r,this.nodeSize)}}},{\"./range\":298,\"./sort\":299,\"./within\":300}],298:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){for(var s,l,u=[0,t.length-1,0],c=[];u.length;){var h=u.pop(),f=u.pop(),d=u.pop();if(f-d<=o)for(var p=d;p<=f;p++)s=e[2*p],l=e[2*p+1],s>=r&&s<=i&&l>=n&&l<=a&&c.push(t[p]);else{var m=Math.floor((d+f)/2);s=e[2*m],l=e[2*m+1],s>=r&&s<=i&&l>=n&&l<=a&&c.push(t[m]);var v=(h+1)%2;(0===h?r<=s:n<=l)&&(u.push(d),u.push(m-1),u.push(v)),(0===h?i>=s:a>=l)&&(u.push(m+1),u.push(f),u.push(v))}}return c}e.exports=n},{}],299:[function(t,e,r){\"use strict\";function n(t,e,r,a,o,s){if(!(o-a<=r)){var l=Math.floor((a+o)/2);i(t,e,l,a,o,s%2),n(t,e,r,a,l-1,s+1),n(t,e,r,l+1,o,s+1)}}function i(t,e,r,n,o,s){for(;o>n;){if(o-n>600){var l=o-n+1,u=r-n+1,c=Math.log(l),h=.5*Math.exp(2*c/3),f=.5*Math.sqrt(c*h*(l-h)/l)*(u-l/2<0?-1:1);i(t,e,r,Math.max(n,Math.floor(r-u*h/l+f)),Math.min(o,Math.floor(r+(l-u)*h/l+f)),s)}var d=e[2*r+s],p=n,m=o;for(a(t,e,n,r),e[2*o+s]>d&&a(t,e,n,o);p<m;){for(a(t,e,p,m),p++,m--;e[2*p+s]<d;)p++;for(;e[2*m+s]>d;)m--}e[2*n+s]===d?a(t,e,n,m):(m++,a(t,e,m,o)),m<=r&&(n=m+1),r<=m&&(o=m-1)}}function a(t,e,r,n){o(t,r,n),o(e,2*r,2*n),o(e,2*r+1,2*n+1)}function o(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}e.exports=n},{}],300:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o){for(var s=[0,t.length-1,0],l=[],u=a*a;s.length;){var c=s.pop(),h=s.pop(),f=s.pop();if(h-f<=o)for(var d=f;d<=h;d++)i(e[2*d],e[2*d+1],r,n)<=u&&l.push(t[d]);else{var p=Math.floor((f+h)/2),m=e[2*p],v=e[2*p+1];i(m,v,r,n)<=u&&l.push(t[p]);var g=(c+1)%2;(0===c?r-a<=m:n-a<=v)&&(s.push(f),s.push(p-1),s.push(g)),(0===c?r+a>=m:n+a>=v)&&(s.push(p+1),s.push(h),s.push(g))}}return l}function i(t,e,r,n){var i=t-r,a=e-n;return i*i+a*a}e.exports=n},{}],301:[function(t,e,r){\"use strict\";function n(t,e){var r;if(h(t)){var l,u=t.stops&&\"object\"==typeof t.stops[0][0],c=u||void 0!==t.property,f=u||!c,d=t.type||e||\"exponential\";if(\"exponential\"===d)l=o;else if(\"interval\"===d)l=a;else if(\"categorical\"===d)l=i;else{if(\"identity\"!==d)throw new Error('Unknown function type \"'+d+'\"');l=s}if(u){for(var p={},m=[],v=0;v<t.stops.length;v++){var g=t.stops[v];void 0===p[g[0].zoom]&&(p[g[0].zoom]={zoom:g[0].zoom,type:t.type,property:t.property,stops:[]}),p[g[0].zoom].stops.push([g[0].value,g[1]])}for(var y in p)m.push([p[y].zoom,n(p[y])]);r=function(e,r){return o({stops:m,base:t.base},e)(e,r)},r.isFeatureConstant=!1,r.isZoomConstant=!1}else f?(r=function(e){return l(t,e)},r.isFeatureConstant=!0,r.isZoomConstant=!1):(r=function(e,r){return l(t,r[t.property])},r.isFeatureConstant=!1,r.isZoomConstant=!0)}else r=function(){return t},r.isFeatureConstant=!0,r.isZoomConstant=!0;return r}function i(t,e){for(var r=0;r<t.stops.length;r++)if(e===t.stops[r][0])return t.stops[r][1];return t.stops[0][1]}function a(t,e){for(var r=0;r<t.stops.length&&!(e<t.stops[r][0]);r++);return t.stops[Math.max(r-1,0)][1]}function o(t,e){for(var r=void 0!==t.base?t.base:1,n=0;;){if(n>=t.stops.length)break;if(e<=t.stops[n][0])break;n++}return 0===n?t.stops[n][1]:n===t.stops.length?t.stops[n-1][1]:l(e,r,t.stops[n-1][0],t.stops[n][0],t.stops[n-1][1],t.stops[n][1])}function s(t,e){return e}function l(t,e,r,n,i,a){return\"function\"==typeof i?function(){var o=i.apply(void 0,arguments),s=a.apply(void 0,arguments);return l(t,e,r,n,o,s)}:i.length?c(t,e,r,n,i,a):u(t,e,r,n,i,a)}function u(t,e,r,n,i,a){var o,s=n-r,l=t-r;return o=1===e?l/s:(Math.pow(e,l)-1)/(Math.pow(e,s)-1),i*(1-o)+a*o}function c(t,e,r,n,i,a){for(var o=[],s=0;s<i.length;s++)o[s]=u(t,e,r,n,i[s],a[s]);return o}function h(t){return\"object\"==typeof t&&(t.stops||\"identity\"===t.type)}e.exports.isFunctionDefinition=h,e.exports.interpolated=function(t){return n(t,\"exponential\")},e.exports[\"piecewise-constant\"]=function(t){return n(t,\"interval\")}},{}],302:[function(t,e,r){t(\"path\");e.exports={debug:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\n\\nvoid main() {\\n    gl_FragColor = u_color;\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, step(32767.0, a_pos.x), 1);\\n}\\n\"},fill:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_FragColor = color * opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n}\\n\"},circle:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define lowp float blur\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_extrude;\\nvarying lowp float v_antialiasblur;\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize lowp float blur\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    float t = smoothstep(1.0 - max(blur, v_antialiasblur), 1.0, length(v_extrude));\\n    gl_FragColor = color * (1.0 - t) * opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform bool u_scale_with_map;\\nuniform vec2 u_extrude_scale;\\nuniform float u_devicepixelratio;\\n\\nattribute vec2 a_pos;\\n\\n#pragma mapbox: define lowp vec4 color\\n#pragma mapbox: define mediump float radius\\n#pragma mapbox: define lowp float blur\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_extrude;\\nvarying lowp float v_antialiasblur;\\n\\nvoid main(void) {\\n    #pragma mapbox: initialize lowp vec4 color\\n    #pragma mapbox: initialize mediump float radius\\n    #pragma mapbox: initialize lowp float blur\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    // unencode the extrusion vector that we snuck into the a_pos vector\\n    v_extrude = vec2(mod(a_pos, 2.0) * 2.0 - 1.0);\\n\\n    vec2 extrude = v_extrude * radius * u_extrude_scale;\\n    // multiply a_pos by 0.5, since we had it * 2 in order to sneak\\n    // in extrusion data\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5), 0, 1);\\n\\n    if (u_scale_with_map) {\\n        gl_Position.xy += extrude;\\n    } else {\\n        gl_Position.xy += extrude * gl_Position.w;\\n    }\\n\\n    // This is a minimum blur distance that serves as a faux-antialiasing for\\n    // the circle. since blur is a ratio of the circle's size and the intent is\\n    // to keep the blur at roughly 1px, the two are inversely related.\\n    v_antialiasblur = 1.0 / u_devicepixelratio / radius;\\n}\\n\"},line:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\nuniform float u_blur;\\n\\nvarying vec2 v_linewidth;\\nvarying vec2 v_normal;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform mediump float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\nuniform mediump float u_blur;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},linepattern:{\n",
       "fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_blur;\\n\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_fade;\\nuniform float u_opacity;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_linesofar;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    float x_a = mod(v_linesofar / u_pattern_size_a.x, 1.0);\\n    float x_b = mod(v_linesofar / u_pattern_size_b.x, 1.0);\\n    float y_a = 0.5 + (v_normal.y * v_linewidth.s / u_pattern_size_a.y);\\n    float y_b = 0.5 + (v_normal.y * v_linewidth.s / u_pattern_size_b.y);\\n    vec2 pos_a = mix(u_pattern_tl_a, u_pattern_br_a, vec2(x_a, y_a));\\n    vec2 pos_b = mix(u_pattern_tl_b, u_pattern_br_b, vec2(x_b, y_b));\\n\\n    vec4 color = mix(texture2D(u_image, pos_a), texture2D(u_image, pos_b), u_fade);\\n\\n    alpha *= u_opacity;\\n\\n    gl_FragColor = color * alpha;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\n// We scale the distance before adding it to the buffers so that we can store\\n// long distances for long segments. Use this value to unscale the distance.\\n#define LINE_DISTANCE_SCALE 2.0\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform mediump float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying float v_linesofar;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n    float a_linesofar = (floor(a_data.z / 4.0) + a_data.w * 64.0) * LINE_DISTANCE_SCALE;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n    v_linesofar = a_linesofar;\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},linesdfpattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\n\\nuniform float u_blur;\\nuniform sampler2D u_image;\\nuniform float u_sdfgamma;\\nuniform float u_mix;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying vec2 v_tex_a;\\nvarying vec2 v_tex_b;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    // Calculate the distance of the pixel from the line in pixels.\\n    float dist = length(v_normal) * v_linewidth.s;\\n\\n    // Calculate the antialiasing fade factor. This is either when fading in\\n    // the line in case of an offset line (v_linewidth.t) or when fading out\\n    // (v_linewidth.s)\\n    float blur = u_blur * v_gamma_scale;\\n    float alpha = clamp(min(dist - (v_linewidth.t - blur), v_linewidth.s - dist) / blur, 0.0, 1.0);\\n\\n    float sdfdist_a = texture2D(u_image, v_tex_a).a;\\n    float sdfdist_b = texture2D(u_image, v_tex_b).a;\\n    float sdfdist = mix(sdfdist_a, sdfdist_b, u_mix);\\n    alpha *= smoothstep(0.5 - u_sdfgamma, 0.5 + u_sdfgamma, sdfdist);\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n// floor(127 / 2) == 63.0\\n// the maximum allowed miter limit is 2.0 at the moment. the extrude normal is\\n// stored in a byte (-128..127). we scale regular normals up to length 63, but\\n// there are also \\\"special\\\" normals that have a bigger length (of up to 126 in\\n// this case).\\n// #define scale 63.0\\n#define scale 0.015873016\\n\\n// We scale the distance before adding it to the buffers so that we can store\\n// long distances for long segments. Use this value to unscale the distance.\\n#define LINE_DISTANCE_SCALE 2.0\\n\\nattribute vec2 a_pos;\\nattribute vec4 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform mediump float u_ratio;\\nuniform mediump float u_linewidth;\\nuniform mediump float u_gapwidth;\\nuniform mediump float u_antialiasing;\\nuniform vec2 u_patternscale_a;\\nuniform float u_tex_y_a;\\nuniform vec2 u_patternscale_b;\\nuniform float u_tex_y_b;\\nuniform float u_extra;\\nuniform mat2 u_antialiasingmatrix;\\nuniform mediump float u_offset;\\n\\nvarying vec2 v_normal;\\nvarying vec2 v_linewidth;\\nvarying vec2 v_tex_a;\\nvarying vec2 v_tex_b;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_extrude = a_data.xy - 128.0;\\n    float a_direction = mod(a_data.z, 4.0) - 1.0;\\n    float a_linesofar = (floor(a_data.z / 4.0) + a_data.w * 64.0) * LINE_DISTANCE_SCALE;\\n\\n    // We store the texture normals in the most insignificant bit\\n    // transform y so that 0 => -1 and 1 => 1\\n    // In the texture normal, x is 0 if the normal points straight up/down and 1 if it's a round cap\\n    // y is 1 if the normal points up, and -1 if it points down\\n    mediump vec2 normal = mod(a_pos, 2.0);\\n    normal.y = sign(normal.y - 0.5);\\n    v_normal = normal;\\n\\n    float inset = u_gapwidth + (u_gapwidth > 0.0 ? u_antialiasing : 0.0);\\n    float outset = u_gapwidth + u_linewidth * (u_gapwidth > 0.0 ? 2.0 : 1.0) + u_antialiasing;\\n\\n    // Scale the extrusion vector down to a normal and then up by the line width\\n    // of this vertex.\\n    mediump vec2 dist = outset * a_extrude * scale;\\n\\n    // Calculate the offset when drawing a line that is to the side of the actual line.\\n    // We do this by creating a vector that points towards the extrude, but rotate\\n    // it when we're drawing round end points (a_direction = -1 or 1) since their\\n    // extrude vector points in another direction.\\n    mediump float u = 0.5 * a_direction;\\n    mediump float t = 1.0 - abs(u);\\n    mediump vec2 offset = u_offset * a_extrude * scale * normal.y * mat2(t, -u, u, t);\\n\\n    // Remove the texture normal bit of the position before scaling it with the\\n    // model/view matrix.\\n    gl_Position = u_matrix * vec4(floor(a_pos * 0.5) + (offset + dist) / u_ratio, 0.0, 1.0);\\n\\n    v_tex_a = vec2(a_linesofar * u_patternscale_a.x, normal.y * u_patternscale_a.y + u_tex_y_a);\\n    v_tex_b = vec2(a_linesofar * u_patternscale_b.x, normal.y * u_patternscale_b.y + u_tex_y_b);\\n\\n    // position of y on the screen\\n    float y = gl_Position.y / gl_Position.w;\\n\\n    // how much features are squished in the y direction by the tilt\\n    float squish_scale = length(a_extrude) / length(u_antialiasingmatrix * a_extrude);\\n\\n    // how much features are squished in all directions by the perspectiveness\\n    float perspective_scale = 1.0 / (1.0 - min(y * u_extra, 0.9));\\n\\n    v_linewidth = vec2(outset, inset);\\n    v_gamma_scale = perspective_scale * squish_scale;\\n}\\n\"},outline:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\n#pragma mapbox: define lowp vec4 outline_color\\n#pragma mapbox: define lowp float opacity\\n\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 outline_color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    float dist = length(v_pos - gl_FragCoord.xy);\\n    float alpha = smoothstep(1.0, 0.0, dist);\\n    gl_FragColor = outline_color * (alpha * opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_world;\\n\\nvarying vec2 v_pos;\\n\\n#pragma mapbox: define lowp vec4 outline_color\\n#pragma mapbox: define lowp float opacity\\n\\nvoid main() {\\n    #pragma mapbox: initialize lowp vec4 outline_color\\n    #pragma mapbox: initialize lowp float opacity\\n\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    v_pos = (gl_Position.xy / gl_Position.w + 1.0) / 2.0 * u_world;\\n}\\n\"},outlinepattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_mix;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    vec2 imagecoord = mod(v_pos_a, 1.0);\\n    vec2 pos = mix(u_pattern_tl_a, u_pattern_br_a, imagecoord);\\n    vec4 color1 = texture2D(u_image, pos);\\n\\n    vec2 imagecoord_b = mod(v_pos_b, 1.0);\\n    vec2 pos2 = mix(u_pattern_tl_b, u_pattern_br_b, imagecoord_b);\\n    vec4 color2 = texture2D(u_image, pos2);\\n\\n    // find distance to outline for alpha interpolation\\n\\n    float dist = length(v_pos - gl_FragCoord.xy);\\n    float alpha = smoothstep(1.0, 0.0, dist);\\n    \\n\\n    gl_FragColor = mix(color1, color2, u_mix) * alpha * u_opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pixel_coord_upper;\\nuniform vec2 u_pixel_coord_lower;\\nuniform float u_scale_a;\\nuniform float u_scale_b;\\nuniform float u_tile_units_to_pixels;\\n\\nattribute vec2 a_pos;\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_world;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\nvarying vec2 v_pos;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    vec2 scaled_size_a = u_scale_a * u_pattern_size_a;\\n    vec2 scaled_size_b = u_scale_b * u_pattern_size_b;\\n\\n    // the correct offset needs to be calculated.\\n    //\\n    // The offset depends on how many pixels are between the world origin and\\n    // the edge of the tile:\\n    // vec2 offset = mod(pixel_coord, size)\\n    //\\n    // At high zoom levels there are a ton of pixels between the world origin\\n    // and the edge of the tile. The glsl spec only guarantees 16 bits of\\n    // precision for highp floats. We need more than that.\\n    //\\n    // The pixel_coord is passed in as two 16 bit values:\\n    // pixel_coord_upper = floor(pixel_coord / 2^16)\\n    // pixel_coord_lower = mod(pixel_coord, 2^16)\\n    //\\n    // The offset is calculated in a series of steps that should preserve this precision:\\n    vec2 offset_a = mod(mod(mod(u_pixel_coord_upper, scaled_size_a) * 256.0, scaled_size_a) * 256.0 + u_pixel_coord_lower, scaled_size_a);\\n    vec2 offset_b = mod(mod(mod(u_pixel_coord_upper, scaled_size_b) * 256.0, scaled_size_b) * 256.0 + u_pixel_coord_lower, scaled_size_b);\\n\\n    v_pos_a = (u_tile_units_to_pixels * a_pos + offset_a) / scaled_size_a;\\n    v_pos_b = (u_tile_units_to_pixels * a_pos + offset_b) / scaled_size_b;\\n\\n    v_pos = (gl_Position.xy / gl_Position.w + 1.0) / 2.0 * u_world;\\n}\\n\"},pattern:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity;\\nuniform vec2 u_pattern_tl_a;\\nuniform vec2 u_pattern_br_a;\\nuniform vec2 u_pattern_tl_b;\\nuniform vec2 u_pattern_br_b;\\nuniform float u_mix;\\n\\nuniform sampler2D u_image;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\n\\nvoid main() {\\n\\n    vec2 imagecoord = mod(v_pos_a, 1.0);\\n    vec2 pos = mix(u_pattern_tl_a, u_pattern_br_a, imagecoord);\\n    vec4 color1 = texture2D(u_image, pos);\\n\\n    vec2 imagecoord_b = mod(v_pos_b, 1.0);\\n    vec2 pos2 = mix(u_pattern_tl_b, u_pattern_br_b, imagecoord_b);\\n    vec4 color2 = texture2D(u_image, pos2);\\n\\n    gl_FragColor = mix(color1, color2, u_mix) * u_opacity;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_pattern_size_a;\\nuniform vec2 u_pattern_size_b;\\nuniform vec2 u_pixel_coord_upper;\\nuniform vec2 u_pixel_coord_lower;\\nuniform float u_scale_a;\\nuniform float u_scale_b;\\nuniform float u_tile_units_to_pixels;\\n\\nattribute vec2 a_pos;\\n\\nvarying vec2 v_pos_a;\\nvarying vec2 v_pos_b;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    vec2 scaled_size_a = u_scale_a * u_pattern_size_a;\\n    vec2 scaled_size_b = u_scale_b * u_pattern_size_b;\\n\\n    // the correct offset needs to be calculated.\\n    //\\n    // The offset depends on how many pixels are between the world origin and\\n    // the edge of the tile:\\n    // vec2 offset = mod(pixel_coord, size)\\n    //\\n    // At high zoom levels there are a ton of pixels between the world origin\\n    // and the edge of the tile. The glsl spec only guarantees 16 bits of\\n    // precision for highp floats. We need more than that.\\n    //\\n    // The pixel_coord is passed in as two 16 bit values:\\n    // pixel_coord_upper = floor(pixel_coord / 2^16)\\n    // pixel_coord_lower = mod(pixel_coord, 2^16)\\n    //\\n    // The offset is calculated in a series of steps that should preserve this precision:\\n    vec2 offset_a = mod(mod(mod(u_pixel_coord_upper, scaled_size_a) * 256.0, scaled_size_a) * 256.0 + u_pixel_coord_lower, scaled_size_a);\\n    vec2 offset_b = mod(mod(mod(u_pixel_coord_upper, scaled_size_b) * 256.0, scaled_size_b) * 256.0 + u_pixel_coord_lower, scaled_size_b);\\n\\n    v_pos_a = (u_tile_units_to_pixels * a_pos + offset_a) / scaled_size_a;\\n    v_pos_b = (u_tile_units_to_pixels * a_pos + offset_b) / scaled_size_b;\\n}\\n\"},raster:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_opacity0;\\nuniform float u_opacity1;\\nuniform sampler2D u_image0;\\nuniform sampler2D u_image1;\\nvarying vec2 v_pos0;\\nvarying vec2 v_pos1;\\n\\nuniform float u_brightness_low;\\nuniform float u_brightness_high;\\n\\nuniform float u_saturation_factor;\\nuniform float u_contrast_factor;\\nuniform vec3 u_spin_weights;\\n\\nvoid main() {\\n\\n    // read and cross-fade colors from the main and parent tiles\\n    vec4 color0 = texture2D(u_image0, v_pos0);\\n    vec4 color1 = texture2D(u_image1, v_pos1);\\n    vec4 color = color0 * u_opacity0 + color1 * u_opacity1;\\n    vec3 rgb = color.rgb;\\n\\n    // spin\\n    rgb = vec3(\\n        dot(rgb, u_spin_weights.xyz),\\n        dot(rgb, u_spin_weights.zxy),\\n        dot(rgb, u_spin_weights.yzx));\\n\\n    // saturation\\n    float average = (color.r + color.g + color.b) / 3.0;\\n    rgb += (average - rgb) * u_saturation_factor;\\n\\n    // contrast\\n    rgb = (rgb - 0.5) * u_contrast_factor + 0.5;\\n\\n    // brightness\\n    vec3 u_high_vec = vec3(u_brightness_low, u_brightness_low, u_brightness_low);\\n    vec3 u_low_vec = vec3(u_brightness_high, u_brightness_high, u_brightness_high);\\n\\n    gl_FragColor = vec4(mix(u_high_vec, u_low_vec, rgb), color.a);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform mat4 u_matrix;\\nuniform vec2 u_tl_parent;\\nuniform float u_scale_parent;\\nuniform float u_buffer_scale;\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_texture_pos;\\n\\nvarying vec2 v_pos0;\\nvarying vec2 v_pos1;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos, 0, 1);\\n    v_pos0 = (((a_texture_pos / 32767.0) - 0.5) / u_buffer_scale ) + 0.5;\\n    v_pos1 = (v_pos0 * u_scale_parent) + u_tl_parent;\\n}\\n\"},icon:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform sampler2D u_texture;\\nuniform sampler2D u_fadetexture;\\nuniform lowp float u_opacity;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\n\\nvoid main() {\\n    lowp float alpha = texture2D(u_fadetexture, v_fade_tex).a * u_opacity;\\n    gl_FragColor = texture2D(u_texture, v_tex) * alpha;\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_offset;\\nattribute vec2 a_texture_pos;\\nattribute vec4 a_data;\\n\\n\\n// matrix is for the vertex position.\\nuniform mat4 u_matrix;\\n\\nuniform mediump float u_zoom;\\nuniform bool u_rotate_with_map;\\nuniform vec2 u_extrude_scale;\\n\\nuniform vec2 u_texsize;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\n\\nvoid main() {\\n    vec2 a_tex = a_texture_pos.xy;\\n    mediump float a_labelminzoom = a_data[0];\\n    mediump vec2 a_zoom = a_data.pq;\\n    mediump float a_minzoom = a_zoom[0];\\n    mediump float a_maxzoom = a_zoom[1];\\n\\n    // u_zoom is the current zoom level adjusted for the change in font size\\n    mediump float z = 2.0 - step(a_minzoom, u_zoom) - (1.0 - step(a_maxzoom, u_zoom));\\n\\n    vec2 extrude = u_extrude_scale * (a_offset / 64.0);\\n    if (u_rotate_with_map) {\\n        gl_Position = u_matrix * vec4(a_pos + extrude, 0, 1);\\n        gl_Position.z += z * gl_Position.w;\\n    } else {\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n    }\\n\\n    v_tex = a_tex / u_texsize;\\n    v_fade_tex = vec2(a_labelminzoom / 255.0, 0.0);\\n}\\n\"},sdf:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform sampler2D u_texture;\\nuniform sampler2D u_fadetexture;\\nuniform lowp vec4 u_color;\\nuniform lowp float u_opacity;\\nuniform lowp float u_buffer;\\nuniform lowp float u_gamma;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    lowp float dist = texture2D(u_texture, v_tex).a;\\n    lowp float fade_alpha = texture2D(u_fadetexture, v_fade_tex).a;\\n    lowp float gamma = u_gamma * v_gamma_scale;\\n    lowp float alpha = smoothstep(u_buffer - gamma, u_buffer + gamma, dist) * fade_alpha;\\n\\n    gl_FragColor = u_color * (alpha * u_opacity);\\n\\n#ifdef OVERDRAW_INSPECTOR\\n    gl_FragColor = vec4(1.0);\\n#endif\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nconst float PI = 3.141592653589793;\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_offset;\\nattribute vec2 a_texture_pos;\\nattribute vec4 a_data;\\n\\n\\n// matrix is for the vertex position.\\nuniform mat4 u_matrix;\\n\\nuniform mediump float u_zoom;\\nuniform bool u_rotate_with_map;\\nuniform bool u_pitch_with_map;\\nuniform mediump float u_pitch;\\nuniform mediump float u_bearing;\\nuniform mediump float u_aspect_ratio;\\nuniform vec2 u_extrude_scale;\\n\\nuniform vec2 u_texsize;\\n\\nvarying vec2 v_tex;\\nvarying vec2 v_fade_tex;\\nvarying float v_gamma_scale;\\n\\nvoid main() {\\n    vec2 a_tex = a_texture_pos.xy;\\n    mediump float a_labelminzoom = a_data[0];\\n    mediump vec2 a_zoom = a_data.pq;\\n    mediump float a_minzoom = a_zoom[0];\\n    mediump float a_maxzoom = a_zoom[1];\\n\\n    // u_zoom is the current zoom level adjusted for the change in font size\\n    mediump float z = 2.0 - step(a_minzoom, u_zoom) - (1.0 - step(a_maxzoom, u_zoom));\\n\\n    // pitch-alignment: map\\n    // rotation-alignment: map | viewport\\n    if (u_pitch_with_map) {\\n        lowp float angle = u_rotate_with_map ? (a_data[1] / 256.0 * 2.0 * PI) : u_bearing;\\n        lowp float asin = sin(angle);\\n        lowp float acos = cos(angle);\\n        mat2 RotationMatrix = mat2(acos, asin, -1.0 * asin, acos);\\n        vec2 offset = RotationMatrix * a_offset;\\n        vec2 extrude = u_extrude_scale * (offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos + extrude, 0, 1);\\n        gl_Position.z += z * gl_Position.w;\\n    // pitch-alignment: viewport\\n    // rotation-alignment: map\\n    } else if (u_rotate_with_map) {\\n        // foreshortening factor to apply on pitched maps\\n        // as a label goes from horizontal <=> vertical in angle\\n        // it goes from 0% foreshortening to up to around 70% foreshortening\\n        lowp float pitchfactor = 1.0 - cos(u_pitch * sin(u_pitch * 0.75));\\n\\n        lowp float lineangle = a_data[1] / 256.0 * 2.0 * PI;\\n\\n        // use the lineangle to position points a,b along the line\\n        // project the points and calculate the label angle in projected space\\n        // this calculation allows labels to be rendered unskewed on pitched maps\\n        vec4 a = u_matrix * vec4(a_pos, 0, 1);\\n        vec4 b = u_matrix * vec4(a_pos + vec2(cos(lineangle),sin(lineangle)), 0, 1);\\n        lowp float angle = atan((b[1]/b[3] - a[1]/a[3])/u_aspect_ratio, b[0]/b[3] - a[0]/a[3]);\\n        lowp float asin = sin(angle);\\n        lowp float acos = cos(angle);\\n        mat2 RotationMatrix = mat2(acos, -1.0 * asin, asin, acos);\\n\\n        vec2 offset = RotationMatrix * (vec2((1.0-pitchfactor)+(pitchfactor*cos(angle*2.0)), 1.0) * a_offset);\\n        vec2 extrude = u_extrude_scale * (offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n        gl_Position.z += z * gl_Position.w;\\n    // pitch-alignment: viewport\\n    // rotation-alignment: viewport\\n    } else {\\n        vec2 extrude = u_extrude_scale * (a_offset / 64.0);\\n        gl_Position = u_matrix * vec4(a_pos, 0, 1) + vec4(extrude, 0, 0);\\n    }\\n\\n    v_gamma_scale = (gl_Position.w - 0.5);\\n\\n    v_tex = a_tex / u_texsize;\\n    v_fade_tex = vec2(a_labelminzoom / 255.0, 0.0);\\n}\\n\"},collisionbox:{fragmentSource:\"#ifdef GL_ES\\nprecision mediump float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nuniform float u_zoom;\\nuniform float u_maxzoom;\\n\\nvarying float v_max_zoom;\\nvarying float v_placement_zoom;\\n\\nvoid main() {\\n\\n    float alpha = 0.5;\\n\\n    gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0) * alpha;\\n\\n    if (v_placement_zoom > u_zoom) {\\n        gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0) * alpha;\\n    }\\n\\n    if (u_zoom >= v_max_zoom) {\\n        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0) * alpha * 0.25;\\n    }\\n\\n    if (v_placement_zoom >= u_maxzoom) {\\n        gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0) * alpha * 0.2;\\n    }\\n}\\n\",vertexSource:\"#ifdef GL_ES\\nprecision highp float;\\n#else\\n#define lowp\\n#define mediump\\n#define highp\\n#endif\\n\\nattribute vec2 a_pos;\\nattribute vec2 a_extrude;\\nattribute vec2 a_data;\\n\\nuniform mat4 u_matrix;\\nuniform float u_scale;\\n\\nvarying float v_max_zoom;\\nvarying float v_placement_zoom;\\n\\nvoid main() {\\n    gl_Position = u_matrix * vec4(a_pos + a_extrude / u_scale, 0.0, 1.0);\\n\\n    v_max_zoom = a_data.x;\\n    v_placement_zoom = a_data.y;\\n}\\n\"}},e.exports.util=\"float evaluate_zoom_function_1(const vec4 values, const float t) {\\n    if (t < 1.0) {\\n        return mix(values[0], values[1], t);\\n    } else if (t < 2.0) {\\n        return mix(values[1], values[2], t - 1.0);\\n    } else {\\n        return mix(values[2], values[3], t - 2.0);\\n    }\\n}\\nvec4 evaluate_zoom_function_4(const vec4 value0, const vec4 value1, const vec4 value2, const vec4 value3, const float t) {\\n    if (t < 1.0) {\\n        return mix(value0, value1, t);\\n    } else if (t < 2.0) {\\n        return mix(value1, value2, t - 1.0);\\n    } else {\\n        return mix(value2, value3, t - 2.0);\\n    }\\n}\\n\"},{path:475}],303:[function(t,e,r){\"use strict\";function n(t,e){this.message=(t?t+\": \":\"\")+i.apply(i,Array.prototype.slice.call(arguments,2)),null!==e&&void 0!==e&&e.__line__&&(this.line=e.__line__)}var i=t(\"util\").format;e.exports=n},{util:548}],304:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)t[n]=r[n]}return t}},{}],305:[function(t,e,r){\"use strict\";e.exports=function(t){return t instanceof Number?\"number\":t instanceof String?\"string\":t instanceof Boolean?\"boolean\":Array.isArray(t)?\"array\":null===t?\"null\":typeof t}},{}],306:[function(t,e,r){\"use strict\";e.exports=function(t){return t instanceof Number||t instanceof String||t instanceof Boolean?t.valueOf():t}},{}],307:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"../util/extend\");e.exports=function(e){var r=t(\"./validate_function\"),o=t(\"./validate_object\"),s={\"*\":function(){return[]},array:t(\"./validate_array\"),boolean:t(\"./validate_boolean\"),number:t(\"./validate_number\"),color:t(\"./validate_color\"),constants:t(\"./validate_constants\"),enum:t(\"./validate_enum\"),filter:t(\"./validate_filter\"),function:t(\"./validate_function\"),layer:t(\"./validate_layer\"),object:t(\"./validate_object\"),source:t(\"./validate_source\"),string:t(\"./validate_string\")},l=e.value,u=e.valueSpec,c=e.key,h=e.styleSpec,f=e.style;if(\"string\"===i(l)&&\"@\"===l[0]){if(h.$version>7)return[new n(c,l,\"constants have been deprecated as of v8\")];if(!(l in f.constants))return[new n(c,l,'constant \"%s\" not found',l)];e=a({},e,{value:f.constants[l]})}return u.function&&\"object\"===i(l)?r(e):u.type&&s[u.type]?s[u.type](e):o(a({},e,{valueSpec:u.type?h[u.type]:u}))}},{\"../error/validation_error\":303,\"../util/extend\":304,\"../util/get_type\":305,\"./validate_array\":308,\"./validate_boolean\":309,\"./validate_color\":310,\"./validate_constants\":311,\"./validate_enum\":312,\"./validate_filter\":313,\"./validate_function\":314,\"./validate_layer\":316,\"./validate_number\":318,\"./validate_object\":319,\"./validate_source\":321,\"./validate_string\":322}],308:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"./validate\"),a=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.valueSpec,o=t.style,s=t.styleSpec,l=t.key,u=t.arrayElementValidator||i;if(\"array\"!==n(e))return[new a(l,e,\"array expected, %s found\",n(e))];if(r.length&&e.length!==r.length)return[new a(l,e,\"array length %d expected, length %d found\",r.length,e.length)];if(r[\"min-length\"]&&e.length<r[\"min-length\"])return[new a(l,e,\"array length at least %d expected, length %d found\",r[\"min-length\"],e.length)];var c={type:r.value};s.$version<7&&(c.function=r.function),\"object\"===n(r.value)&&(c=r.value);for(var h=[],f=0;f<e.length;f++)h=h.concat(u({array:e,arrayIndex:f,value:e[f],valueSpec:c,style:o,styleSpec:s,key:l+\"[\"+f+\"]\"}));return h}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307}],309:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.key,a=n(e);return\"boolean\"!==a?[new i(r,e,\"boolean expected, %s found\",a)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],310:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"csscolorparser\").parseCSSColor;e.exports=function(t){var e=t.key,r=t.value,o=i(r);return\"string\"!==o?[new n(e,r,\"color expected, %s found\",o)]:null===a(r)?[new n(e,r,'color expected, \"%s\" found',r)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305,csscolorparser:107}],311:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\");e.exports=function(t){var e=t.key,r=t.value;if(t.styleSpec.$version>7)return r?[new n(e,r,\"constants have been deprecated as of v8\")]:[];var a=i(r);if(\"object\"!==a)return[new n(e,r,\"object expected, %s found\",a)];var o=[];for(var s in r)\"@\"!==s[0]&&o.push(new n(e+\".\"+s,r[s],'constants must start with \"@\"'));return o}},{\"../error/validation_error\":303,\"../util/get_type\":305}],312:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\");e.exports=function(t){var e=t.key,r=t.value,a=t.valueSpec,o=[];return-1===a.values.indexOf(i(r))&&o.push(new n(e,r,\"expected one of [%s], %s found\",a.values.join(\", \"),r)),o}},{\"../error/validation_error\":303,\"../util/unbundle_jsonlint\":306}],313:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"./validate_enum\"),a=t(\"../util/get_type\"),o=t(\"../util/unbundle_jsonlint\");e.exports=function t(e){var r,s=e.value,l=e.key,u=e.styleSpec,c=[];if(\"array\"!==a(s))return[new n(l,s,\"array expected, %s found\",a(s))];if(s.length<1)return[new n(l,s,\"filter array must have at least 1 element\")];switch(c=c.concat(i({key:l+\"[0]\",value:s[0],valueSpec:u.filter_operator,style:e.style,styleSpec:e.styleSpec})),o(s[0])){case\"<\":case\"<=\":case\">\":case\">=\":s.length>=2&&\"$type\"==s[1]&&c.push(new n(l,s,'\"$type\" cannot be use with operator \"%s\"',s[0]));case\"==\":case\"!=\":3!=s.length&&c.push(new n(l,s,'filter array for operator \"%s\" must have 3 elements',s[0]));case\"in\":case\"!in\":s.length>=2&&(r=a(s[1]),\"string\"!==r?c.push(new n(l+\"[1]\",s[1],\"string expected, %s found\",r)):\"@\"===s[1][0]&&c.push(new n(l+\"[1]\",s[1],\"filter key cannot be a constant\")));for(var h=2;h<s.length;h++)r=a(s[h]),\"$type\"==s[1]?c=c.concat(i({key:l+\"[\"+h+\"]\",value:s[h],valueSpec:u.geometry_type,style:e.style,styleSpec:e.styleSpec})):\"string\"===r&&\"@\"===s[h][0]?c.push(new n(l+\"[\"+h+\"]\",s[h],\"filter value cannot be a constant\")):\"string\"!==r&&\"number\"!==r&&\"boolean\"!==r&&c.push(new n(l+\"[\"+h+\"]\",s[h],\"string, number, or boolean expected, %s found\",r));break;case\"any\":case\"all\":case\"none\":for(h=1;h<s.length;h++)c=c.concat(t({key:l+\"[\"+h+\"]\",value:s[h],style:e.style,styleSpec:e.styleSpec}));break;case\"has\":case\"!has\":r=a(s[1]),2!==s.length?c.push(new n(l,s,'filter array for \"%s\" operator must have 2 elements',s[0])):\"string\"!==r?c.push(new n(l+\"[1]\",s[1],\"string expected, %s found\",r)):\"@\"===s[1][0]&&c.push(new n(l+\"[1]\",s[1],\"filter key cannot be a constant\"))}return c}},{\"../error/validation_error\":303,\"../util/get_type\":305,\n",
       "\"../util/unbundle_jsonlint\":306,\"./validate_enum\":312}],314:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"./validate\"),o=t(\"./validate_object\"),s=t(\"./validate_array\"),l=t(\"./validate_number\");e.exports=function(t){function e(t){var e=[],a=t.value;return e=e.concat(s({key:t.key,value:a,valueSpec:t.valueSpec,style:t.style,styleSpec:t.styleSpec,arrayElementValidator:r})),\"array\"===i(a)&&0===a.length&&e.push(new n(t.key,a,\"array must have at least one stop\")),e}function r(t){var e=[],r=t.value,s=t.key;if(\"array\"!==i(r))return[new n(s,r,\"array expected, %s found\",i(r))];if(2!==r.length)return[new n(s,r,\"array length %d expected, length %d found\",2,r.length)];var f=i(r[0]);if(c||(c=f),f!==c)return[new n(s,r,\"%s stop key type must match previous stop key type %s\",f,c)];if(\"object\"===f){if(void 0===r[0].zoom)return[new n(s,r,\"object stop key must have zoom\")];if(void 0===r[0].value)return[new n(s,r,\"object stop key must have value\")];e=e.concat(o({key:s+\"[0]\",value:r[0],valueSpec:{zoom:{}},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{zoom:l,value:u}}))}else e=e.concat((d?l:u)({key:s+\"[0]\",value:r[0],valueSpec:{},style:t.style,styleSpec:t.styleSpec}));return e=e.concat(a({key:s+\"[1]\",value:r[1],valueSpec:h,style:t.style,styleSpec:t.styleSpec})),\"number\"===i(r[0])&&(\"piecewise-constant\"===h.function&&r[0]%1!=0&&e.push(new n(s+\"[0]\",r[0],\"zoom level for piecewise-constant functions must be an integer\")),0!==t.arrayIndex&&r[0]<t.array[t.arrayIndex-1][0]&&e.push(new n(s+\"[0]\",r[0],\"array stops must appear in ascending order\"))),e}function u(t){var e=[],r=i(t.value);return\"number\"!==r&&\"string\"!==r&&\"array\"!==r&&e.push(new n(t.key,t.value,\"property value must be a number, string or array\")),e}var c,h=t.valueSpec,f=void 0!==t.value.property||\"object\"===c,d=void 0===t.value.property||\"object\"===c,p=o({key:t.key,value:t.value,valueSpec:t.styleSpec.function,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{stops:e}});return t.styleSpec.$version>=8&&(f&&!t.valueSpec[\"property-function\"]?p.push(new n(t.key,t.value,\"property functions not supported\")):d&&!t.valueSpec[\"zoom-function\"]&&p.push(new n(t.key,t.value,\"zoom functions not supported\"))),p}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307,\"./validate_array\":308,\"./validate_number\":318,\"./validate_object\":319}],315:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"./validate_string\");e.exports=function(t){var e=t.value,r=t.key,a=i(t);return a.length?a:(-1===e.indexOf(\"{fontstack}\")&&a.push(new n(r,e,'\"glyphs\" url must include a \"{fontstack}\" token')),-1===e.indexOf(\"{range}\")&&a.push(new n(r,e,'\"glyphs\" url must include a \"{range}\" token')),a)}},{\"../error/validation_error\":303,\"./validate_string\":322}],316:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\"),a=t(\"./validate_object\"),o=t(\"./validate_filter\"),s=t(\"./validate_paint_property\"),l=t(\"./validate_layout_property\"),u=t(\"../util/extend\");e.exports=function(t){var e=[],r=t.value,c=t.key,h=t.style,f=t.styleSpec;r.type||r.ref||e.push(new n(c,r,'either \"type\" or \"ref\" is required'));var d=i(r.type),p=i(r.ref);if(r.id)for(var m=0;m<t.arrayIndex;m++){var v=h.layers[m];i(v.id)===i(r.id)&&e.push(new n(c,r.id,'duplicate layer id \"%s\", previously used at line %d',r.id,v.id.__line__))}if(\"ref\"in r){[\"type\",\"source\",\"source-layer\",\"filter\",\"layout\"].forEach(function(t){t in r&&e.push(new n(c,r[t],'\"%s\" is prohibited for ref layers',t))});var g;h.layers.forEach(function(t){t.id==p&&(g=t)}),g?g.ref?e.push(new n(c,r.ref,\"ref cannot reference another ref layer\")):d=i(g.type):e.push(new n(c,r.ref,'ref layer \"%s\" not found',p))}else if(\"background\"!==d)if(r.source){var y=h.sources&&h.sources[r.source];y?\"vector\"==y.type&&\"raster\"==d?e.push(new n(c,r.source,'layer \"%s\" requires a raster source',r.id)):\"raster\"==y.type&&\"raster\"!=d?e.push(new n(c,r.source,'layer \"%s\" requires a vector source',r.id)):\"vector\"!=y.type||r[\"source-layer\"]||e.push(new n(c,r,'layer \"%s\" must specify a \"source-layer\"',r.id)):e.push(new n(c,r.source,'source \"%s\" not found',r.source))}else e.push(new n(c,r,'missing required property \"source\"'));return e=e.concat(a({key:c,value:r,valueSpec:f.layer,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{filter:o,layout:function(t){return a({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{\"*\":function(t){return l(u({layerType:d},t))}}})},paint:function(t){return a({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{\"*\":function(t){return s(u({layerType:d},t))}}})}}}))}},{\"../error/validation_error\":303,\"../util/extend\":304,\"../util/unbundle_jsonlint\":306,\"./validate_filter\":313,\"./validate_layout_property\":317,\"./validate_object\":319,\"./validate_paint_property\":320}],317:[function(t,e,r){\"use strict\";var n=t(\"./validate\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.style,a=t.styleSpec,o=t.value,s=t.objectKey,l=a[\"layout_\"+t.layerType];if(t.valueSpec||l[s]){var u=[];return\"symbol\"===t.layerType&&(\"icon-image\"===s&&r&&!r.sprite?u.push(new i(e,o,'use of \"icon-image\" requires a style \"sprite\" property')):\"text-field\"===s&&r&&!r.glyphs&&u.push(new i(e,o,'use of \"text-field\" requires a style \"glyphs\" property'))),u.concat(n({key:t.key,value:o,valueSpec:t.valueSpec||l[s],style:r,styleSpec:a}))}return[new i(e,o,'unknown property \"%s\"',s)]}},{\"../error/validation_error\":303,\"./validate\":307}],318:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.value,a=t.valueSpec,o=n(r);return\"number\"!==o?[new i(e,r,\"number expected, %s found\",o)]:\"minimum\"in a&&r<a.minimum?[new i(e,r,\"%s is less than the minimum value %s\",r,a.minimum)]:\"maximum\"in a&&r>a.maximum?[new i(e,r,\"%s is greater than the maximum value %s\",r,a.maximum)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],319:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/get_type\"),a=t(\"./validate\");e.exports=function(t){var e=t.key,r=t.value,o=t.valueSpec,s=t.objectElementValidators||{},l=t.style,u=t.styleSpec,c=[],h=i(r);if(\"object\"!==h)return[new n(e,r,\"object expected, %s found\",h)];for(var f in r){var d=f.split(\".\")[0],p=o&&(o[d]||o[\"*\"]),m=s[d]||s[\"*\"];p||m?c=c.concat((m||a)({key:(e?e+\".\":e)+f,value:r[f],valueSpec:p,style:l,styleSpec:u,object:r,objectKey:f})):\"\"!==e&&1!==e.split(\".\").length&&c.push(new n(e,r[f],'unknown property \"%s\"',f))}for(d in o)o[d].required&&void 0===o[d].default&&void 0===r[d]&&c.push(new n(e,r,'missing required property \"%s\"',d));return c}},{\"../error/validation_error\":303,\"../util/get_type\":305,\"./validate\":307}],320:[function(t,e,r){\"use strict\";var n=t(\"./validate\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.key,r=t.style,a=t.styleSpec,o=t.value,s=t.objectKey,l=a[\"paint_\"+t.layerType],u=s.match(/^(.*)-transition$/);return u&&l[u[1]]&&l[u[1]].transition?n({key:e,value:o,valueSpec:a.transition,style:r,styleSpec:a}):t.valueSpec||l[s]?n({key:t.key,value:o,valueSpec:t.valueSpec||l[s],style:r,styleSpec:a}):[new i(e,o,'unknown property \"%s\"',s)]}},{\"../error/validation_error\":303,\"./validate\":307}],321:[function(t,e,r){\"use strict\";var n=t(\"../error/validation_error\"),i=t(\"../util/unbundle_jsonlint\"),a=t(\"./validate_object\"),o=t(\"./validate_enum\");e.exports=function(t){var e=t.value,r=t.key,s=t.styleSpec,l=t.style;if(!e.type)return[new n(r,e,'\"type\" is required')];switch(i(e.type)){case\"vector\":case\"raster\":var u=[];if(u=u.concat(a({key:r,value:e,valueSpec:s.source_tile,style:t.style,styleSpec:s})),\"url\"in e)for(var c in e)[\"type\",\"url\",\"tileSize\"].indexOf(c)<0&&u.push(new n(r+\".\"+c,e[c],'a source with a \"url\" property may not include a \"%s\" property',c));return u;case\"geojson\":return a({key:r,value:e,valueSpec:s.source_geojson,style:l,styleSpec:s});case\"video\":return a({key:r,value:e,valueSpec:s.source_video,style:l,styleSpec:s});case\"image\":return a({key:r,value:e,valueSpec:s.source_image,style:l,styleSpec:s});default:return o({key:r+\".type\",value:e.type,valueSpec:{values:[\"vector\",\"raster\",\"geojson\",\"video\",\"image\"]},style:l,styleSpec:s})}}},{\"../error/validation_error\":303,\"../util/unbundle_jsonlint\":306,\"./validate_enum\":312,\"./validate_object\":319}],322:[function(t,e,r){\"use strict\";var n=t(\"../util/get_type\"),i=t(\"../error/validation_error\");e.exports=function(t){var e=t.value,r=t.key,a=n(e);return\"string\"!==a?[new i(r,e,\"string expected, %s found\",a)]:[]}},{\"../error/validation_error\":303,\"../util/get_type\":305}],323:[function(t,e,r){\"use strict\";function n(t,e){e=e||l;var r=[];return r=r.concat(s({key:\"\",value:t,valueSpec:e.$root,styleSpec:e,style:t,objectElementValidators:{glyphs:u}})),e.$version>7&&t.constants&&(r=r.concat(o({key:\"constants\",value:t.constants,style:t,styleSpec:e}))),i(r)}function i(t){return[].concat(t).sort(function(t,e){return t.line-e.line})}function a(t){return function(){return i(t.apply(this,arguments))}}var o=t(\"./validate/validate_constants\"),s=t(\"./validate/validate\"),l=t(\"../reference/latest.min\"),u=t(\"./validate/validate_glyphs_url\");n.source=a(t(\"./validate/validate_source\")),n.layer=a(t(\"./validate/validate_layer\")),n.filter=a(t(\"./validate/validate_filter\")),n.paintProperty=a(t(\"./validate/validate_paint_property\")),n.layoutProperty=a(t(\"./validate/validate_layout_property\")),e.exports=n},{\"../reference/latest.min\":324,\"./validate/validate\":307,\"./validate/validate_constants\":311,\"./validate/validate_filter\":313,\"./validate/validate_glyphs_url\":315,\"./validate/validate_layer\":316,\"./validate/validate_layout_property\":317,\"./validate/validate_paint_property\":320,\"./validate/validate_source\":321}],324:[function(t,e,r){e.exports=t(\"./v8.min.json\")},{\"./v8.min.json\":325}],325:[function(t,e,r){e.exports={$version:8,$root:{version:{required:!0,type:\"enum\",values:[8]},name:{type:\"string\"},metadata:{type:\"*\"},center:{type:\"array\",value:\"number\"},zoom:{type:\"number\"},bearing:{type:\"number\",default:0,period:360,units:\"degrees\"},pitch:{type:\"number\",default:0,units:\"degrees\"},sources:{required:!0,type:\"sources\"},sprite:{type:\"string\"},glyphs:{type:\"string\"},transition:{type:\"transition\"},layers:{required:!0,type:\"array\",value:\"layer\"}},sources:{\"*\":{type:\"source\"}},source:[\"source_tile\",\"source_geojson\",\"source_video\",\"source_image\"],source_tile:{type:{required:!0,type:\"enum\",values:[\"vector\",\"raster\"]},url:{type:\"string\"},tiles:{type:\"array\",value:\"string\"},minzoom:{type:\"number\",default:0},maxzoom:{type:\"number\",default:22},tileSize:{type:\"number\",default:512,units:\"pixels\"},\"*\":{type:\"*\"}},source_geojson:{type:{required:!0,type:\"enum\",values:[\"geojson\"]},data:{type:\"*\"},maxzoom:{type:\"number\",default:14},buffer:{type:\"number\",default:64},tolerance:{type:\"number\",default:3},cluster:{type:\"boolean\",default:!1},clusterRadius:{type:\"number\",default:400},clusterMaxZoom:{type:\"number\"}},source_video:{type:{required:!0,type:\"enum\",values:[\"video\"]},urls:{required:!0,type:\"array\",value:\"string\"},coordinates:{required:!0,type:\"array\",length:4,value:{type:\"array\",length:2,value:\"number\"}}},source_image:{type:{required:!0,type:\"enum\",values:[\"image\"]},url:{required:!0,type:\"string\"},coordinates:{required:!0,type:\"array\",length:4,value:{type:\"array\",length:2,value:\"number\"}}},layer:{id:{type:\"string\",required:!0},type:{type:\"enum\",values:[\"fill\",\"line\",\"symbol\",\"circle\",\"raster\",\"background\"]},metadata:{type:\"*\"},ref:{type:\"string\"},source:{type:\"string\"},\"source-layer\":{type:\"string\"},minzoom:{type:\"number\",minimum:0,maximum:22},maxzoom:{type:\"number\",minimum:0,maximum:22},interactive:{type:\"boolean\",default:!1},filter:{type:\"filter\"},layout:{type:\"layout\"},paint:{type:\"paint\"},\"paint.*\":{type:\"paint\"}},layout:[\"layout_fill\",\"layout_line\",\"layout_circle\",\"layout_symbol\",\"layout_raster\",\"layout_background\"],layout_background:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_fill:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_circle:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_line:{\"line-cap\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"butt\",\"round\",\"square\"],default:\"butt\"},\"line-join\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"bevel\",\"round\",\"miter\"],default:\"miter\"},\"line-miter-limit\":{type:\"number\",default:2,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[{\"line-join\":\"miter\"}]},\"line-round-limit\":{type:\"number\",default:1.05,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[{\"line-join\":\"round\"}]},visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_symbol:{\"symbol-placement\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"point\",\"line\"],default:\"point\"},\"symbol-spacing\":{type:\"number\",default:250,minimum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"pixels\",requires:[{\"symbol-placement\":\"line\"}]},\"symbol-avoid-edges\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1},\"icon-allow-overlap\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\"]},\"icon-ignore-placement\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\"]},\"icon-optional\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\",\"text-field\"]},\"icon-rotation-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"viewport\",requires:[\"icon-image\"]},\"icon-size\":{type:\"number\",default:1,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\"]},\"icon-text-fit\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!1,values:[\"none\",\"both\",\"width\",\"height\"],default:\"none\",requires:[\"icon-image\",\"text-field\"]},\"icon-text-fit-padding\":{type:\"array\",value:\"number\",length:4,default:[0,0,0,0],units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\",\"icon-text-fit\",\"text-field\"]},\"icon-image\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,tokens:!0},\"icon-rotate\":{type:\"number\",default:0,period:360,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"degrees\",requires:[\"icon-image\"]},\"icon-padding\":{type:\"number\",default:2,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-keep-upright\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"icon-image\",{\"icon-rotation-alignment\":\"map\"},{\"symbol-placement\":\"line\"}]},\"icon-offset\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"icon-image\"]},\"text-pitch-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],requires:[\"text-field\"]},\"text-rotation-alignment\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"viewport\",requires:[\"text-field\"]},\"text-field\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:\"\",tokens:!0},\"text-font\":{type:\"array\",value:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:[\"Open Sans Regular\",\"Arial Unicode MS Regular\"],requires:[\"text-field\"]},\"text-size\":{type:\"number\",default:16,minimum:0,units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-max-width\":{type:\"number\",default:10,minimum:0,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-line-height\":{type:\"number\",default:1.2,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-letter-spacing\":{type:\"number\",default:0,units:\"em\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-justify\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"left\",\"center\",\"right\"],default:\"center\",requires:[\"text-field\"]},\"text-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"center\",\"left\",\"right\",\"top\",\"bottom\",\"top-left\",\"top-right\",\"bottom-left\",\"bottom-right\"],default:\"center\",requires:[\"text-field\"]},\"text-max-angle\":{type:\"number\",default:45,units:\"degrees\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\",{\"symbol-placement\":\"line\"}]},\"text-rotate\":{type:\"number\",default:0,period:360,units:\"degrees\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-padding\":{type:\"number\",default:2,minimum:0,units:\"pixels\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,requires:[\"text-field\"]},\"text-keep-upright\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!0,requires:[\"text-field\",{\"text-rotation-alignment\":\"map\"},{\"symbol-placement\":\"line\"}]},\"text-transform\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"none\",\"uppercase\",\"lowercase\"],default:\"none\",requires:[\"text-field\"]},\"text-offset\":{type:\"array\",value:\"number\",units:\"ems\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,length:2,default:[0,0],requires:[\"text-field\"]},\"text-allow-overlap\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\"]},\"text-ignore-placement\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\"]},\"text-optional\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!1,requires:[\"text-field\",\"icon-image\"]},visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},layout_raster:{visibility:{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,values:[\"visible\",\"none\"],default:\"visible\"}},filter:{type:\"array\",value:\"*\"},filter_operator:{type:\"enum\",values:[\"==\",\"!=\",\">\",\">=\",\"<\",\"<=\",\"in\",\"!in\",\"all\",\"any\",\"none\",\"has\",\"!has\"]},geometry_type:{type:\"enum\",values:[\"Point\",\"LineString\",\"Polygon\"]},color_operation:{type:\"enum\",values:[\"lighten\",\"saturate\",\"spin\",\"fade\",\"mix\"]},function:{stops:{type:\"array\",required:!0,value:\"function_stop\"},base:{type:\"number\",default:1,minimum:0},property:{type:\"string\",default:\"$zoom\"},type:{type:\"enum\",values:[\"exponential\",\"interval\",\"categorical\"],default:\"exponential\"}},function_stop:{type:\"array\",minimum:0,maximum:22,value:[\"number\",\"color\"],length:2},paint:[\"paint_fill\",\"paint_line\",\"paint_circle\",\"paint_symbol\",\"paint_raster\",\"paint_background\"],paint_fill:{\"fill-antialias\":{type:\"boolean\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,default:!0},\"fill-opacity\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"fill-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"fill-pattern\"}]},\"fill-outline-color\":{type:\"color\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"fill-pattern\"},{\"fill-antialias\":!0}]},\"fill-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"fill-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"fill-translate\"]},\"fill-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,transition:!0}},paint_line:{\"line-opacity\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"line-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[{\"!\":\"line-pattern\"}]},\"line-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"line-translate\"]},\"line-width\":{type:\"number\",default:1,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-gap-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-offset\":{type:\"number\",default:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"line-dasharray\":{type:\"array\",value:\"number\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,minimum:0,transition:!0,units:\"line widths\",requires:[{\"!\":\"line-pattern\"}]},\"line-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,transition:!0}},paint_circle:{\"circle-radius\":{type:\"number\",default:5,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"circle-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-blur\":{type:\"number\",default:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0},\"circle-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\"},\"circle-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"circle-translate\"]},\"circle-pitch-scale\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\"}},paint_symbol:{\"icon-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-halo-color\":{type:\"color\",default:\"rgba(0, 0, 0, 0)\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"icon-image\"]},\"icon-halo-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-halo-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"icon-image\"]},\"icon-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"icon-image\",\"icon-translate\"]},\"text-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-halo-color\":{type:\"color\",default:\"rgba(0, 0, 0, 0)\",function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,requires:[\"text-field\"]},\"text-halo-width\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-halo-blur\":{type:\"number\",default:0,minimum:0,function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-translate\":{type:\"array\",value:\"number\",length:2,default:[0,0],function:\"interpolated\",\"zoom-function\":!0,\"property-function\":!0,transition:!0,units:\"pixels\",requires:[\"text-field\"]},\"text-translate-anchor\":{type:\"enum\",function:\"piecewise-constant\",\"zoom-function\":!0,\"property-function\":!0,values:[\"map\",\"viewport\"],default:\"map\",requires:[\"text-field\",\"text-translate\"]}},paint_raster:{\"raster-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-hue-rotate\":{type:\"number\",default:0,period:360,function:\"interpolated\",\"zoom-function\":!0,transition:!0,units:\"degrees\"},\"raster-brightness-min\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,default:0,minimum:0,maximum:1,transition:!0},\"raster-brightness-max\":{type:\"number\",function:\"interpolated\",\"zoom-function\":!0,default:1,minimum:0,maximum:1,transition:!0},\"raster-saturation\":{type:\"number\",default:0,minimum:-1,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-contrast\":{type:\"number\",default:0,minimum:-1,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0},\"raster-fade-duration\":{type:\"number\",default:300,minimum:0,function:\"interpolated\",\"zoom-function\":!0,transition:!0,units:\"milliseconds\"}},paint_background:{\"background-color\":{type:\"color\",default:\"#000000\",function:\"interpolated\",\"zoom-function\":!0,transition:!0,requires:[{\"!\":\"background-pattern\"}]},\"background-pattern\":{type:\"string\",function:\"piecewise-constant\",\"zoom-function\":!0,transition:!0},\"background-opacity\":{type:\"number\",default:1,minimum:0,maximum:1,function:\"interpolated\",\"zoom-function\":!0,transition:!0}},transition:{duration:{type:\"number\",default:300,minimum:0,units:\"milliseconds\"},delay:{type:\"number\",default:0,minimum:0,units:\"milliseconds\"}}}},{}],326:[function(t,e,r){\"use strict\";function n(t){return!!(i()&&a()&&o()&&s()&&l()&&u()&&c()&&h(t&&t.failIfMajorPerformanceCaveat))}function i(){return\"undefined\"!=typeof window&&\"undefined\"!=typeof document}function a(){return Array.prototype&&Array.prototype.every&&Array.prototype.filter&&Array.prototype.forEach&&Array.prototype.indexOf&&Array.prototype.lastIndexOf&&Array.prototype.map&&Array.prototype.some&&Array.prototype.reduce&&Array.prototype.reduceRight&&Array.isArray}function o(){return Function.prototype&&Function.prototype.bind}function s(){return Object.keys&&Object.create&&Object.getPrototypeOf&&Object.getOwnPropertyNames&&Object.isSealed&&Object.isFrozen&&Object.isExtensible&&Object.getOwnPropertyDescriptor&&Object.defineProperty&&Object.defineProperties&&Object.seal&&Object.freeze&&Object.preventExtensions}function l(){return\"JSON\"in window&&\"parse\"in JSON&&\"stringify\"in JSON}function u(){return\"Worker\"in window}function c(){return\"Uint8ClampedArray\"in window}function h(t){return void 0===d[t]&&(d[t]=f(t)),d[t]}function f(t){var e=document.createElement(\"canvas\"),r=Object.create(n.webGLContextAttributes);return r.failIfMajorPerformanceCaveat=t,e.probablySupportsContext?e.probablySupportsContext(\"webgl\",r)||e.probablySupportsContext(\"experimental-webgl\",r):e.supportsContext?e.supportsContext(\"webgl\",r)||e.supportsContext(\"experimental-webgl\",r):e.getContext(\"webgl\",r)||e.getContext(\"experimental-webgl\",r)}void 0!==e&&e.exports?e.exports=n:window&&(window.mapboxgl=window.mapboxgl||{},window.mapboxgl.supported=n);var d={};n.webGLContextAttributes={antialias:!1,alpha:!0,stencil:!0,depth:!0}},{}],327:[function(t,e,r){\"use strict\";function n(t){var e=t.layoutVertexArrayType;this.layoutVertexArray=new e;var r=t.elementArrayType;r&&(this.elementArray=new r);var n=t.elementArrayType2;n&&(this.elementArray2=new n),this.paintVertexArrays=i.mapObject(t.paintVertexArrayTypes,function(t){return new t})}var i=t(\"../util/util\");e.exports=n,n.MAX_VERTEX_ARRAY_LENGTH=Math.pow(2,16)-1,n.prototype.hasCapacityFor=function(t){return this.layoutVertexArray.length+t<=n.MAX_VERTEX_ARRAY_LENGTH},n.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},n.prototype.trim=function(){this.layoutVertexArray.trim(),this.elementArray&&this.elementArray.trim(),this.elementArray2&&this.elementArray2.trim();for(var t in this.paintVertexArrays)this.paintVertexArrays[t].trim()},n.prototype.serialize=function(){return{layoutVertexArray:this.layoutVertexArray.serialize(),elementArray:this.elementArray&&this.elementArray.serialize(),elementArray2:this.elementArray2&&this.elementArray2.serialize(),paintVertexArrays:i.mapObject(this.paintVertexArrays,function(t){return t.serialize()})}},n.prototype.getTransferables=function(t){t.push(this.layoutVertexArray.arrayBuffer),this.elementArray&&t.push(this.elementArray.arrayBuffer),this.elementArray2&&t.push(this.elementArray2.arrayBuffer);for(var e in this.paintVertexArrays)t.push(this.paintVertexArrays[e].arrayBuffer)}},{\"../util/util\":441}],328:[function(t,e,r){\"use strict\";function n(t){if(this.zoom=t.zoom,this.overscaling=t.overscaling,this.layer=t.layer,this.childLayers=t.childLayers,this.type=this.layer.type,this.features=[],this.id=this.layer.id,this.index=t.index,this.sourceLayer=this.layer.sourceLayer,this.sourceLayerIndex=t.sourceLayerIndex,this.minZoom=this.layer.minzoom,this.maxZoom=this.layer.maxzoom,this.paintAttributes=i(this),t.arrays){var e=this.programInterfaces;this.bufferGroups=c.mapObject(t.arrays,function(r,n){var i=e[n],a=t.paintVertexArrayTypes[n];return r.map(function(t){return new u(t,{layoutVertexArrayType:i.layoutVertexArrayType.serialize(),elementArrayType:i.elementArrayType&&i.elementArrayType.serialize(),elementArrayType2:i.elementArrayType2&&i.elementArrayType2.serialize(),paintVertexArrayTypes:a})})})}}function i(t){var e={};for(var r in t.programInterfaces){for(var n=e[r]={},i=0;i<t.childLayers.length;i++){n[t.childLayers[i].id]={attributes:[],uniforms:[],defines:[],vertexPragmas:{define:{},initialize:{}},fragmentPragmas:{define:{},initialize:{}}}}var s=t.programInterfaces[r];if(s.paintAttributes)for(var l=0;l<s.paintAttributes.length;l++){var u=s.paintAttributes[l];u.multiplier=u.multiplier||1;for(var h=0;h<t.childLayers.length;h++){var d=t.childLayers[h],p=n[d.id],m=u.name;f(\"a_\"===u.name.slice(0,2));var v,g=u.name.slice(2);if(p.fragmentPragmas.initialize[g]=\"\",d.isPaintValueFeatureConstant(u.paintProperty))p.uniforms.push(u),p.fragmentPragmas.define[g]=p.vertexPragmas.define[g]=[\"uniform\",\"{precision}\",\"{type}\",m].join(\" \")+\";\",p.fragmentPragmas.initialize[g]=p.vertexPragmas.initialize[g]=[\"{precision}\",\"{type}\",g,\"=\",m].join(\" \")+\";\\n\";else if(d.isPaintValueZoomConstant(u.paintProperty)){p.attributes.push(c.extend({},u,{name:m})),v=[\"varying\",\"{precision}\",\"{type}\",g].join(\" \")+\";\\n\"\n",
       ";var y=[p.fragmentPragmas.define[g],\"attribute\",\"{precision}\",\"{type}\",m].join(\" \")+\";\\n\";p.fragmentPragmas.define[g]=v,p.vertexPragmas.define[g]=v+y,p.vertexPragmas.initialize[g]=[g,\"=\",m,\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\"}else{for(var b=\"u_\"+m.slice(2)+\"_t\",x=d.getPaintValueStopZoomLevels(u.paintProperty),_=0;_<x.length&&x[_]<t.zoom;)_++;for(var w=Math.max(0,Math.min(x.length-4,_-2)),M=[],k=0;k<4;k++)M.push(x[Math.min(w+k,x.length-1)]);v=[\"varying\",\"{precision}\",\"{type}\",g].join(\" \")+\";\\n\",p.vertexPragmas.define[g]=v+[\"uniform\",\"lowp\",\"float\",b].join(\" \")+\";\\n\",p.fragmentPragmas.define[g]=v,p.uniforms.push(c.extend({},u,{name:b,getValue:o(u,w),components:1}));var A=u.components;if(1===A)p.attributes.push(c.extend({},u,{getValue:a(u,M),isFunction:!0,components:4*A})),p.vertexPragmas.define[g]+=[\"attribute\",\"{precision}\",\"vec4\",m].join(\" \")+\";\\n\",p.vertexPragmas.initialize[g]=[g,\"=\",\"evaluate_zoom_function_1(\"+m+\", \"+b+\")\",\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\";else{for(var T=[],S=0;S<4;S++)T.push(m+S),p.attributes.push(c.extend({},u,{getValue:a(u,[M[S]]),isFunction:!0,name:m+S})),p.vertexPragmas.define[g]+=[\"attribute\",\"{precision}\",\"{type}\",m+S].join(\" \")+\";\\n\";p.vertexPragmas.initialize[g]=[g,\" = \",\"evaluate_zoom_function_4(\"+T.join(\", \")+\", \"+b+\")\",\"/\",u.multiplier.toFixed(1)].join(\" \")+\";\\n\"}}}}}return e}function a(t,e){return function(r,n,i){if(1===e.length)return t.getValue(r,c.extend({},n,{zoom:e[0]}),i);for(var a=[],o=0;o<e.length;o++){var s=e[o];a.push(t.getValue(r,c.extend({},n,{zoom:s}),i)[0])}return a}}function o(t,e){return function(r,n){var i=r.getPaintInterpolationT(t.paintProperty,n.zoom);return[Math.max(0,Math.min(4,i-e))]}}var s=t(\"feature-filter\"),l=t(\"./array_group\"),u=t(\"./buffer_group\"),c=t(\"../util/util\"),h=t(\"../util/struct_array\"),f=t(\"assert\");e.exports=n,n.create=function(e){return new({fill:t(\"./bucket/fill_bucket\"),line:t(\"./bucket/line_bucket\"),circle:t(\"./bucket/circle_bucket\"),symbol:t(\"./bucket/symbol_bucket\")}[e.layer.type])(e)},n.EXTENT=8192,n.prototype.populateArrays=function(){this.createArrays(),this.recalculateStyleLayers();for(var t=0;t<this.features.length;t++)this.addFeature(this.features[t]);this.trimArrays()},n.prototype.prepareArrayGroup=function(t,e){var r=this.arrayGroups[t],n=r.length&&r[r.length-1];return n&&n.hasCapacityFor(e)||(n=new l({layoutVertexArrayType:this.programInterfaces[t].layoutVertexArrayType,elementArrayType:this.programInterfaces[t].elementArrayType,elementArrayType2:this.programInterfaces[t].elementArrayType2,paintVertexArrayTypes:this.paintVertexArrayTypes[t]}),n.index=r.length,r.push(n)),n},n.prototype.createArrays=function(){this.arrayGroups={},this.paintVertexArrayTypes={};for(var t in this.programInterfaces){this.arrayGroups[t]=[];var e=this.paintVertexArrayTypes[t]={},r=this.paintAttributes[t];for(var i in r)e[i]=new n.VertexArrayType(r[i].attributes)}},n.prototype.destroy=function(t){for(var e in this.bufferGroups)for(var r=this.bufferGroups[e],n=0;n<r.length;n++)r[n].destroy(t)},n.prototype.trimArrays=function(){for(var t in this.arrayGroups)for(var e=this.arrayGroups[t],r=0;r<e.length;r++)e[r].trim()},n.prototype.isEmpty=function(){for(var t in this.arrayGroups)for(var e=this.arrayGroups[t],r=0;r<e.length;r++)if(!e[r].isEmpty())return!1;return!0},n.prototype.getTransferables=function(t){for(var e in this.arrayGroups)for(var r=this.arrayGroups[e],n=0;n<r.length;n++)r[n].getTransferables(t)},n.prototype.setUniforms=function(t,e,r,n,i){for(var a=this.paintAttributes[e][n.id].uniforms,o=0;o<a.length;o++){var s=a[o],l=r[s.name];t[\"uniform\"+s.components+\"fv\"](l,s.getValue(n,i))}},n.prototype.serialize=function(){return{layerId:this.layer.id,zoom:this.zoom,arrays:c.mapObject(this.arrayGroups,function(t){return t.map(function(t){return t.serialize()})}),paintVertexArrayTypes:c.mapObject(this.paintVertexArrayTypes,function(t){return c.mapObject(t,function(t){return t.serialize()})}),childLayerIds:this.childLayers.map(function(t){return t.id})}},n.prototype.createFilter=function(){this.filter||(this.filter=s(this.layer.filter))};var d={lastIntegerZoom:1/0,lastIntegerZoomTime:0,lastZoom:0};n.prototype.recalculateStyleLayers=function(){for(var t=0;t<this.childLayers.length;t++)this.childLayers[t].recalculate(this.zoom,d)},n.prototype.populatePaintArrays=function(t,e,r,n,i){for(var a=0;a<this.childLayers.length;a++)for(var o=this.childLayers[a],s=this.arrayGroups[t],l=n.index;l<s.length;l++){var u=s[l],c=u.layoutVertexArray.length,h=u.paintVertexArrays[o.id];h.resize(c);for(var f=this.paintAttributes[t][o.id].attributes,d=0;d<f.length;d++)for(var p=f[d],m=p.getValue(o,e,r),v=p.multiplier||1,g=p.components||1,y=l===n.index?i:0,b=y;b<c;b++)for(var x=h.get(b),_=0;_<g;_++){var w=g>1?p.name+_:p.name;x[w]=m[_]*v}}},n.VertexArrayType=function(t){return new h({members:t,alignment:4})},n.ElementArrayType=function(t){return new h({members:[{type:\"Uint16\",name:\"vertices\",components:t||3}]})}},{\"../util/struct_array\":439,\"../util/util\":441,\"./array_group\":327,\"./bucket/circle_bucket\":329,\"./bucket/fill_bucket\":330,\"./bucket/line_bucket\":331,\"./bucket/symbol_bucket\":332,\"./buffer_group\":334,assert:46,\"feature-filter\":131}],329:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=i.EXTENT;e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.addCircleVertex=function(t,e,r,n,i){return t.emplaceBack(2*e+(n+1)/2,2*r+(i+1)/2)},n.prototype.programInterfaces={circle:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"}]),elementArrayType:new i.ElementArrayType,paintAttributes:[{name:\"a_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"circle-color\",e,r)},multiplier:255,paintProperty:\"circle-color\"},{name:\"a_radius\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-radius\",e,r)]},multiplier:10,paintProperty:\"circle-radius\"},{name:\"a_blur\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-blur\",e,r)]},multiplier:10,paintProperty:\"circle-blur\"},{name:\"a_opacity\",components:1,type:\"Uint16\",isLayerConstant:!1,getValue:function(t,e,r){return[t.getPaintValue(\"circle-opacity\",e,r)]},multiplier:255,paintProperty:\"circle-opacity\"}]}},n.prototype.addFeature=function(t){for(var e={zoom:this.zoom},r=o(t),n=this.prepareArrayGroup(\"circle\",0),i=n.layoutVertexArray.length,a=0;a<r.length;a++)for(var l=0;l<r[a].length;l++){var u=r[a][l].x,c=r[a][l].y;if(!(u<0||u>=s||c<0||c>=s)){var h=this.prepareArrayGroup(\"circle\",4),f=h.layoutVertexArray,d=this.addCircleVertex(f,u,c,-1,-1);this.addCircleVertex(f,u,c,1,-1),this.addCircleVertex(f,u,c,1,1),this.addCircleVertex(f,u,c,-1,1),h.elementArray.emplaceBack(d,d+1,d+2),h.elementArray.emplaceBack(d,d+3,d+2)}}this.populatePaintArrays(\"circle\",e,t.properties,n,i)}},{\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336}],330:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=t(\"earcut\"),l=t(\"../../util/classify_rings\");e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.programInterfaces={fill:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"}]),elementArrayType:new i.ElementArrayType(1),elementArrayType2:new i.ElementArrayType(2),paintAttributes:[{name:\"a_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"fill-color\",e,r)},multiplier:255,paintProperty:\"fill-color\"},{name:\"a_outline_color\",components:4,type:\"Uint8\",getValue:function(t,e,r){return t.getPaintValue(\"fill-outline-color\",e,r)},multiplier:255,paintProperty:\"fill-outline-color\"},{name:\"a_opacity\",components:1,type:\"Uint8\",getValue:function(t,e,r){return[t.getPaintValue(\"fill-opacity\",e,r)]},multiplier:255,paintProperty:\"fill-opacity\"}]}},n.prototype.addFeature=function(t){for(var e=o(t),r=l(e,500),n=this.prepareArrayGroup(\"fill\",0),i=n.layoutVertexArray.length,a=0;a<r.length;a++)this.addPolygon(r[a]);this.populatePaintArrays(\"fill\",{zoom:this.zoom},t.properties,n,i)},n.prototype.addPolygon=function(t){for(var e=0,r=0;r<t.length;r++)e+=t[r].length;for(var n=this.prepareArrayGroup(\"fill\",e),i=[],a=[],o=n.layoutVertexArray.length,l=0;l<t.length;l++){var u=t[l];l>0&&a.push(i.length/2);for(var c=0;c<u.length;c++){var h=u[c],f=n.layoutVertexArray.emplaceBack(h.x,h.y);c>=1&&n.elementArray2.emplaceBack(f-1,f),i.push(h.x),i.push(h.y)}}for(var d=s(i,a),p=0;p<d.length;p++)n.elementArray.emplaceBack(d[p]+o)}},{\"../../util/classify_rings\":429,\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336,earcut:125}],331:[function(t,e,r){\"use strict\";function n(){i.apply(this,arguments)}var i=t(\"../bucket\"),a=t(\"../../util/util\"),o=t(\"../load_geometry\"),s=i.EXTENT,l=Math.cos(Math.PI/180*37.5),u=Math.pow(2,14)/.5;e.exports=n,n.prototype=a.inherit(i,{}),n.prototype.addLineVertex=function(t,e,r,n,i,a,o){return t.emplaceBack(e.x<<1|n,e.y<<1|i,Math.round(63*r.x)+128,Math.round(63*r.y)+128,1+(0===a?0:a<0?-1:1)|(.5*o&63)<<2,.5*o>>6)},n.prototype.programInterfaces={line:{layoutVertexArrayType:new i.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_data\",components:4,type:\"Uint8\"}]),elementArrayType:new i.ElementArrayType}},n.prototype.addFeature=function(t){for(var e=o(t,15),r=0;r<e.length;r++)this.addLine(e[r],this.layer.layout[\"line-join\"],this.layer.layout[\"line-cap\"],this.layer.layout[\"line-miter-limit\"],this.layer.layout[\"line-round-limit\"])},n.prototype.addLine=function(t,e,r,n,i){for(var a=t.length;a>2&&t[a-1].equals(t[a-2]);)a--;if(!(t.length<2)){\"bevel\"===e&&(n=1.05);var o=s/(512*this.overscaling)*15,u=t[0],c=t[a-1],h=u.equals(c);if(this.prepareArrayGroup(\"line\",10*a),2!==a||!h){this.distance=0;var f,d,p,m,v,g,y,b=r,x=h?\"butt\":r,_=!0;this.e1=this.e2=this.e3=-1,h&&(f=t[a-2],v=u.sub(f)._unit()._perp());for(var w=0;w<a;w++)if(!(p=h&&w===a-1?t[1]:t[w+1])||!t[w].equals(p)){v&&(m=v),f&&(d=f),f=t[w],v=p?p.sub(f)._unit()._perp():m,m=m||v;var M=m.add(v)._unit(),k=M.x*v.x+M.y*v.y,A=1/k,T=k<l&&d&&p;if(T&&w>0){var S=f.dist(d);if(S>2*o){var E=f.sub(f.sub(d)._mult(o/S)._round());this.distance+=E.dist(d),this.addCurrentVertex(E,this.distance,m.mult(1),0,0,!1),d=E}}var L=d&&p,C=L?e:p?b:x;if(L&&\"round\"===C&&(A<i?C=\"miter\":A<=2&&(C=\"fakeround\")),\"miter\"===C&&A>n&&(C=\"bevel\"),\"bevel\"===C&&(A>2&&(C=\"flipbevel\"),A<n&&(C=\"miter\")),d&&(this.distance+=f.dist(d)),\"miter\"===C)M._mult(A),this.addCurrentVertex(f,this.distance,M,0,0,!1);else if(\"flipbevel\"===C){if(A>100)M=v.clone();else{var z=m.x*v.y-m.y*v.x>0?-1:1,I=A*m.add(v).mag()/m.sub(v).mag();M._perp()._mult(I*z)}this.addCurrentVertex(f,this.distance,M,0,0,!1),this.addCurrentVertex(f,this.distance,M.mult(-1),0,0,!1)}else if(\"bevel\"===C||\"fakeround\"===C){var D=m.x*v.y-m.y*v.x>0,P=-Math.sqrt(A*A-1);if(D?(y=0,g=P):(g=0,y=P),_||this.addCurrentVertex(f,this.distance,m,g,y,!1),\"fakeround\"===C){for(var O,R=Math.floor(8*(.5-(k-.5))),F=0;F<R;F++)O=v.mult((F+1)/(R+1))._add(m)._unit(),this.addPieSliceVertex(f,this.distance,O,D);this.addPieSliceVertex(f,this.distance,M,D);for(var j=R-1;j>=0;j--)O=m.mult((j+1)/(R+1))._add(v)._unit(),this.addPieSliceVertex(f,this.distance,O,D)}p&&this.addCurrentVertex(f,this.distance,v,-g,-y,!1)}else\"butt\"===C?(_||this.addCurrentVertex(f,this.distance,m,0,0,!1),p&&this.addCurrentVertex(f,this.distance,v,0,0,!1)):\"square\"===C?(_||(this.addCurrentVertex(f,this.distance,m,1,1,!1),this.e1=this.e2=-1),p&&this.addCurrentVertex(f,this.distance,v,-1,-1,!1)):\"round\"===C&&(_||(this.addCurrentVertex(f,this.distance,m,0,0,!1),this.addCurrentVertex(f,this.distance,m,1,1,!0),this.e1=this.e2=-1),p&&(this.addCurrentVertex(f,this.distance,v,-1,-1,!0),this.addCurrentVertex(f,this.distance,v,0,0,!1)));if(T&&w<a-1){var N=f.dist(p);if(N>2*o){var B=f.add(p.sub(f)._mult(o/N)._round());this.distance+=B.dist(f),this.addCurrentVertex(B,this.distance,v.mult(1),0,0,!1),f=B}}_=!1}}}},n.prototype.addCurrentVertex=function(t,e,r,n,i,a){var o,s=a?1:0,l=this.arrayGroups.line[this.arrayGroups.line.length-1],c=l.layoutVertexArray,h=l.elementArray;o=r.clone(),n&&o._sub(r.perp()._mult(n)),this.e3=this.addLineVertex(c,t,o,s,0,n,e),this.e1>=0&&this.e2>=0&&h.emplaceBack(this.e1,this.e2,this.e3),this.e1=this.e2,this.e2=this.e3,o=r.mult(-1),i&&o._sub(r.perp()._mult(i)),this.e3=this.addLineVertex(c,t,o,s,1,-i,e),this.e1>=0&&this.e2>=0&&h.emplaceBack(this.e1,this.e2,this.e3),this.e1=this.e2,this.e2=this.e3,e>u/2&&(this.distance=0,this.addCurrentVertex(t,this.distance,r,n,i,a))},n.prototype.addPieSliceVertex=function(t,e,r,n){var i=n?1:0;r=r.mult(n?-1:1);var a=this.arrayGroups.line[this.arrayGroups.line.length-1],o=a.layoutVertexArray,s=a.elementArray;this.e3=this.addLineVertex(o,t,r,0,i,0,e),this.e1>=0&&this.e2>=0&&s.emplaceBack(this.e1,this.e2,this.e3),n?this.e2=this.e3:this.e1=this.e3}},{\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336}],332:[function(t,e,r){\"use strict\";function n(t){o.apply(this,arguments),this.showCollisionBoxes=t.showCollisionBoxes,this.overscaling=t.overscaling,this.collisionBoxArray=t.collisionBoxArray,this.symbolQuadsArray=t.symbolQuadsArray,this.symbolInstancesArray=t.symbolInstancesArray,this.sdfIcons=t.sdfIcons,this.iconsNeedLinear=t.iconsNeedLinear,this.adjustedTextSize=t.adjustedTextSize,this.adjustedIconSize=t.adjustedIconSize,this.fontstack=t.fontstack}function i(t,e,r,n,i,a,o,s,l,u,c){return t.emplaceBack(e,r,Math.round(64*n),Math.round(64*i),a/4,o/4,10*(u||0),c,10*(s||0),10*Math.min(l||25,25))}var a=t(\"point-geometry\"),o=t(\"../bucket\"),s=t(\"../../symbol/anchor\"),l=t(\"../../symbol/get_anchors\"),u=t(\"../../util/token\"),c=t(\"../../symbol/quads\"),h=t(\"../../symbol/shaping\"),f=t(\"../../symbol/resolve_text\"),d=t(\"../../symbol/mergelines\"),p=t(\"../../symbol/clip_line\"),m=t(\"../../util/util\"),v=t(\"../load_geometry\"),g=t(\"../../symbol/collision_feature\"),y=h.shapeText,b=h.shapeIcon,x=c.getGlyphQuads,_=c.getIconQuads,w=o.EXTENT;e.exports=n,n.MAX_QUADS=65535,n.prototype=m.inherit(o,{}),n.prototype.serialize=function(){var t=o.prototype.serialize.apply(this);return t.sdfIcons=this.sdfIcons,t.iconsNeedLinear=this.iconsNeedLinear,t.adjustedTextSize=this.adjustedTextSize,t.adjustedIconSize=this.adjustedIconSize,t.fontstack=this.fontstack,t};var M=new o.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_offset\",components:2,type:\"Int16\"},{name:\"a_texture_pos\",components:2,type:\"Uint16\"},{name:\"a_data\",components:4,type:\"Uint8\"}]),k=new o.ElementArrayType;n.prototype.addCollisionBoxVertex=function(t,e,r,n,i){return t.emplaceBack(e.x,e.y,Math.round(r.x),Math.round(r.y),10*n,10*i)},n.prototype.programInterfaces={glyph:{layoutVertexArrayType:M,elementArrayType:k},icon:{layoutVertexArrayType:M,elementArrayType:k},collisionBox:{layoutVertexArrayType:new o.VertexArrayType([{name:\"a_pos\",components:2,type:\"Int16\"},{name:\"a_extrude\",components:2,type:\"Int16\"},{name:\"a_data\",components:2,type:\"Uint8\"}])}},n.prototype.populateArrays=function(t,e,r){var n={lastIntegerZoom:1/0,lastIntegerZoomTime:0,lastZoom:0};this.adjustedTextMaxSize=this.layer.getLayoutValue(\"text-size\",{zoom:18,zoomHistory:n}),this.adjustedTextSize=this.layer.getLayoutValue(\"text-size\",{zoom:this.zoom+1,zoomHistory:n}),this.adjustedIconMaxSize=this.layer.getLayoutValue(\"icon-size\",{zoom:18,zoomHistory:n}),this.adjustedIconSize=this.layer.getLayoutValue(\"icon-size\",{zoom:this.zoom+1,zoomHistory:n});var i=512*this.overscaling;this.tilePixelRatio=w/i,this.compareText={},this.iconsNeedLinear=!1,this.symbolInstancesStartIndex=this.symbolInstancesArray.length;var a=this.layer.layout,o=this.features,s=this.textFeatures,l=.5,c=.5;switch(a[\"text-anchor\"]){case\"right\":case\"top-right\":case\"bottom-right\":l=1;break;case\"left\":case\"top-left\":case\"bottom-left\":l=0}switch(a[\"text-anchor\"]){case\"bottom\":case\"bottom-right\":case\"bottom-left\":c=1;break;case\"top\":case\"top-right\":case\"top-left\":c=0}for(var h=\"right\"===a[\"text-justify\"]?1:\"left\"===a[\"text-justify\"]?0:.5,f=24*a[\"text-line-height\"],p=\"line\"!==a[\"symbol-placement\"]?24*a[\"text-max-width\"]:0,g=24*a[\"text-letter-spacing\"],x=[24*a[\"text-offset\"][0],24*a[\"text-offset\"][1]],_=this.fontstack=a[\"text-font\"].join(\",\"),M=[],k=0;k<o.length;k++)M.push(v(o[k]));if(\"line\"===a[\"symbol-placement\"]){var A=d(o,s,M);M=A.geometries,o=A.features,s=A.textFeatures}for(var T,S,E=0;E<o.length;E++)if(M[E]){if(T=s[E]?y(s[E],e[_],p,f,l,c,h,g,x):null,a[\"icon-image\"]){var L=u(o[E].properties,a[\"icon-image\"]),C=r[L];S=b(C,a),C&&(void 0===this.sdfIcons?this.sdfIcons=C.sdf:this.sdfIcons!==C.sdf&&m.warnOnce(\"Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer\"),1!==C.pixelRatio?this.iconsNeedLinear=!0:0===a[\"icon-rotate\"]&&this.layer.isLayoutValueFeatureConstant(\"icon-rotate\")||(this.iconsNeedLinear=!0))}else S=null;(T||S)&&this.addFeature(M[E],T,S,o[E])}this.symbolInstancesEndIndex=this.symbolInstancesArray.length,this.placeFeatures(t,this.showCollisionBoxes),this.trimArrays()},n.prototype.addFeature=function(t,e,r,n){var i=this.layer.layout,a=this.adjustedTextSize/24,o=void 0!==this.adjustedTextMaxSize?this.adjustedTextMaxSize:this.adjustedTextSize,u=this.tilePixelRatio*a,c=this.tilePixelRatio*o/24,h=this.tilePixelRatio*this.adjustedIconSize,f=this.tilePixelRatio*i[\"symbol-spacing\"],d=i[\"symbol-avoid-edges\"],m=i[\"text-padding\"]*this.tilePixelRatio,v=i[\"icon-padding\"]*this.tilePixelRatio,g=i[\"text-max-angle\"]/180*Math.PI,y=\"map\"===i[\"text-rotation-alignment\"]&&\"line\"===i[\"symbol-placement\"],b=\"map\"===i[\"icon-rotation-alignment\"]&&\"line\"===i[\"symbol-placement\"],x=i[\"text-allow-overlap\"]||i[\"icon-allow-overlap\"]||i[\"text-ignore-placement\"]||i[\"icon-ignore-placement\"],_=\"line\"===i[\"symbol-placement\"],M=f/2;_&&(t=p(t,0,0,w,w));for(var k=0;k<t.length;k++){var A,T=t[k];A=_?l(T,f,g,e,r,24,c,this.overscaling,w):[new s(T[0].x,T[0].y,0)];for(var S=0,E=A.length;S<E;S++){var L=A[S];if(!(e&&_&&this.anchorIsTooClose(e.text,M,L))){var C=!(L.x<0||L.x>w||L.y<0||L.y>w);if(!d||C){var z=C||x;this.addSymbolInstance(L,T,e,r,this.layer,z,this.symbolInstancesArray.length,this.collisionBoxArray,n.index,this.sourceLayerIndex,this.index,u,m,y,h,v,b,{zoom:this.zoom},n.properties)}}}}},n.prototype.anchorIsTooClose=function(t,e,r){var n=this.compareText;if(t in n){for(var i=n[t],a=i.length-1;a>=0;a--)if(r.dist(i[a])<e)return!0}else n[t]=[];return n[t].push(r),!1},n.prototype.placeFeatures=function(t,e){this.recalculateStyleLayers(),this.createArrays();var r=this.layer.layout,n=t.maxScale,i=\"map\"===r[\"text-rotation-alignment\"]&&\"line\"===r[\"symbol-placement\"],a=\"map\"===r[\"icon-rotation-alignment\"]&&\"line\"===r[\"symbol-placement\"];if(r[\"text-allow-overlap\"]||r[\"icon-allow-overlap\"]||r[\"text-ignore-placement\"]||r[\"icon-ignore-placement\"]){var o=this.symbolInstancesArray.toArray(this.symbolInstancesStartIndex,this.symbolInstancesEndIndex),s=t.angle,l=Math.sin(s),u=Math.cos(s);this.sortedSymbolInstances=o.sort(function(t,e){return(l*t.anchorPointX+u*t.anchorPointY|0)-(l*e.anchorPointX+u*e.anchorPointY|0)||e.index-t.index})}for(var c=this.symbolInstancesStartIndex;c<this.symbolInstancesEndIndex;c++){var h=this.sortedSymbolInstances?this.sortedSymbolInstances[c-this.symbolInstancesStartIndex]:this.symbolInstancesArray.get(c),f={boxStartIndex:h.textBoxStartIndex,boxEndIndex:h.textBoxEndIndex},d={boxStartIndex:h.iconBoxStartIndex,boxEndIndex:h.iconBoxEndIndex},p=!(h.textBoxStartIndex===h.textBoxEndIndex),m=!(h.iconBoxStartIndex===h.iconBoxEndIndex),v=r[\"text-optional\"]||!p,g=r[\"icon-optional\"]||!m,y=p?t.placeCollisionFeature(f,r[\"text-allow-overlap\"],r[\"symbol-avoid-edges\"]):t.minScale,b=m?t.placeCollisionFeature(d,r[\"icon-allow-overlap\"],r[\"symbol-avoid-edges\"]):t.minScale;v||g?!g&&y?y=Math.max(b,y):!v&&b&&(b=Math.max(b,y)):b=y=Math.max(b,y),p&&(t.insertCollisionFeature(f,y,r[\"text-ignore-placement\"]),y<=n&&this.addSymbols(\"glyph\",h.glyphQuadStartIndex,h.glyphQuadEndIndex,y,r[\"text-keep-upright\"],i,t.angle)),m&&(t.insertCollisionFeature(d,b,r[\"icon-ignore-placement\"]),b<=n&&this.addSymbols(\"icon\",h.iconQuadStartIndex,h.iconQuadEndIndex,b,r[\"icon-keep-upright\"],a,t.angle))}e&&this.addToDebugBuffers(t)},n.prototype.addSymbols=function(t,e,r,n,a,o,s){for(var l=this.prepareArrayGroup(t,4*(r-e)),u=l.elementArray,c=l.layoutVertexArray,h=this.zoom,f=Math.max(Math.log(n)/Math.LN2+h,0),d=e;d<r;d++){var p=this.symbolQuadsArray.get(d).SymbolQuad,m=(p.anchorAngle+s+Math.PI)%(2*Math.PI);if(!(a&&o&&(m<=Math.PI/2||m>3*Math.PI/2))){var v=p.tl,g=p.tr,y=p.bl,b=p.br,x=p.tex,_=p.anchorPoint,w=Math.max(h+Math.log(p.minScale)/Math.LN2,f),M=Math.min(h+Math.log(p.maxScale)/Math.LN2,25);if(!(M<=w)){w===f&&(w=0);var k=Math.round(p.glyphAngle/(2*Math.PI)*256),A=i(c,_.x,_.y,v.x,v.y,x.x,x.y,w,M,f,k);i(c,_.x,_.y,g.x,g.y,x.x+x.w,x.y,w,M,f,k),i(c,_.x,_.y,y.x,y.y,x.x,x.y+x.h,w,M,f,k),i(c,_.x,_.y,b.x,b.y,x.x+x.w,x.y+x.h,w,M,f,k),u.emplaceBack(A,A+1,A+2),u.emplaceBack(A+1,A+2,A+3)}}}},n.prototype.updateIcons=function(t){this.recalculateStyleLayers();var e=this.layer.layout[\"icon-image\"];if(e)for(var r=0;r<this.features.length;r++){var n=u(this.features[r].properties,e);n&&(t[n]=!0)}},n.prototype.updateFont=function(t){this.recalculateStyleLayers();var e=this.layer.layout[\"text-font\"],r=t[e]=t[e]||{};this.textFeatures=f(this.features,this.layer.layout,r)},n.prototype.addToDebugBuffers=function(t){for(var e=this.prepareArrayGroup(\"collisionBox\",0),r=e.layoutVertexArray,n=-t.angle,i=t.yStretch,o=this.symbolInstancesStartIndex;o<this.symbolInstancesEndIndex;o++){var s=this.symbolInstancesArray.get(o);s.textCollisionFeature={boxStartIndex:s.textBoxStartIndex,boxEndIndex:s.textBoxEndIndex},s.iconCollisionFeature={boxStartIndex:s.iconBoxStartIndex,boxEndIndex:s.iconBoxEndIndex};for(var l=0;l<2;l++){var u=s[0===l?\"textCollisionFeature\":\"iconCollisionFeature\"];if(u)for(var c=u.boxStartIndex;c<u.boxEndIndex;c++){var h=this.collisionBoxArray.get(c),f=h.anchorPoint,d=new a(h.x1,h.y1*i)._rotate(n),p=new a(h.x2,h.y1*i)._rotate(n),m=new a(h.x1,h.y2*i)._rotate(n),v=new a(h.x2,h.y2*i)._rotate(n),g=Math.max(0,Math.min(25,this.zoom+Math.log(h.maxScale)/Math.LN2)),y=Math.max(0,Math.min(25,this.zoom+Math.log(h.placementScale)/Math.LN2));this.addCollisionBoxVertex(r,f,d,g,y),this.addCollisionBoxVertex(r,f,p,g,y),this.addCollisionBoxVertex(r,f,p,g,y),this.addCollisionBoxVertex(r,f,v,g,y),this.addCollisionBoxVertex(r,f,v,g,y),this.addCollisionBoxVertex(r,f,m,g,y),this.addCollisionBoxVertex(r,f,m,g,y),this.addCollisionBoxVertex(r,f,d,g,y)}}}},n.prototype.addSymbolInstance=function(t,e,r,i,a,o,s,l,u,c,h,f,d,p,v,y,b,w,M){var k,A,T,S,E,L,C,z;if(r&&(C=o?x(t,r,f,e,a,p):[],E=new g(l,e,t,u,c,h,r,f,d,p,!1)),k=this.symbolQuadsArray.length,C&&C.length)for(var I=0;I<C.length;I++)this.addSymbolQuad(C[I]);A=this.symbolQuadsArray.length;var D=E?E.boxStartIndex:this.collisionBoxArray.length,P=E?E.boxEndIndex:this.collisionBoxArray.length;i&&(z=o?_(t,i,v,e,a,b,r,w,M):[],L=new g(l,e,t,u,c,h,i,v,y,b,!0)),T=this.symbolQuadsArray.length,z&&1===z.length&&this.addSymbolQuad(z[0]),S=this.symbolQuadsArray.length;var O=L?L.boxStartIndex:this.collisionBoxArray.length,R=L?L.boxEndIndex:this.collisionBoxArray.length;return S>n.MAX_QUADS&&m.warnOnce(\"Too many symbols being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907\"),A>n.MAX_QUADS&&m.warnOnce(\"Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907\"),this.symbolInstancesArray.emplaceBack(D,P,O,R,k,A,T,S,t.x,t.y,s)},n.prototype.addSymbolQuad=function(t){return this.symbolQuadsArray.emplaceBack(t.anchorPoint.x,t.anchorPoint.y,t.tl.x,t.tl.y,t.tr.x,t.tr.y,t.bl.x,t.bl.y,t.br.x,t.br.y,t.tex.h,t.tex.w,t.tex.x,t.tex.y,t.anchorAngle,t.glyphAngle,t.maxScale,t.minScale)}},{\"../../symbol/anchor\":390,\"../../symbol/clip_line\":392,\"../../symbol/collision_feature\":394,\"../../symbol/get_anchors\":396,\"../../symbol/mergelines\":399,\"../../symbol/quads\":400,\"../../symbol/resolve_text\":401,\"../../symbol/shaping\":402,\"../../util/token\":440,\"../../util/util\":441,\"../bucket\":328,\"../load_geometry\":336,\"point-geometry\":483}],333:[function(t,e,r){\"use strict\";function n(t,e,r){this.arrayBuffer=t.arrayBuffer,this.length=t.length,this.attributes=e.members,this.itemSize=e.bytesPerElement,this.type=r,this.arrayType=e}e.exports=n,n.prototype.bind=function(t){var e=t[this.type];this.buffer?t.bindBuffer(e,this.buffer):(this.buffer=t.createBuffer(),t.bindBuffer(e,this.buffer),t.bufferData(e,this.arrayBuffer,t.STATIC_DRAW),this.arrayBuffer=null)};var i={Int8:\"BYTE\",Uint8:\"UNSIGNED_BYTE\",Int16:\"SHORT\",Uint16:\"UNSIGNED_SHORT\"};n.prototype.setVertexAttribPointers=function(t,e){for(var r=0;r<this.attributes.length;r++){var n=this.attributes[r],a=e[n.name];void 0!==a&&t.vertexAttribPointer(a,n.components,t[i[n.type]],!1,this.arrayType.bytesPerElement,n.offset)}},n.prototype.destroy=function(t){this.buffer&&t.deleteBuffer(this.buffer)},n.BufferType={VERTEX:\"ARRAY_BUFFER\",ELEMENT:\"ELEMENT_ARRAY_BUFFER\"}},{}],334:[function(t,e,r){\"use strict\";function n(t,e){this.layoutVertexBuffer=new a(t.layoutVertexArray,e.layoutVertexArrayType,a.BufferType.VERTEX),t.elementArray&&(this.elementBuffer=new a(t.elementArray,e.elementArrayType,a.BufferType.ELEMENT));var r,n=this.vaos={};t.elementArray2&&(this.elementBuffer2=new a(t.elementArray2,e.elementArrayType2,a.BufferType.ELEMENT),r=this.secondVaos={}),this.paintVertexBuffers=i.mapObject(t.paintVertexArrays,function(i,s){return n[s]=new o,t.elementArray2&&(r[s]=new o),new a(i,e.paintVertexArrayTypes[s],a.BufferType.VERTEX)})}var i=t(\"../util/util\"),a=t(\"./buffer\"),o=t(\"../render/vertex_array_object\");e.exports=n,n.prototype.destroy=function(t){this.layoutVertexBuffer.destroy(t),this.elementBuffer&&this.elementBuffer.destroy(t),this.elementBuffer2&&this.elementBuffer2.destroy(t);for(var e in this.paintVertexBuffers)this.paintVertexBuffers[e].destroy(t);for(var r in this.vaos)this.vaos[r].destroy(t);for(var n in this.secondVaos)this.secondVaos[n].destroy(t)}},{\"../render/vertex_array_object\":356,\"../util/util\":441,\"./buffer\":333}],335:[function(t,e,r){\"use strict\";function n(t,e,r){if(t.grid){var n=t,i=e;t=n.coord,e=n.overscaling,this.grid=new p(n.grid),this.featureIndexArray=new k(n.featureIndexArray),this.rawTileData=i,this.bucketLayerIDs=n.bucketLayerIDs}else this.grid=new p(h,16,0),this.featureIndexArray=new k;this.coord=t,this.overscaling=e,this.x=t.x,this.y=t.y,this.z=t.z-Math.log(e)/Math.LN2,this.setCollisionTile(r)}function i(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}function a(t,e){return e-t}function o(t){return t[\"line-gap-width\"]>0?t[\"line-gap-width\"]+2*t[\"line-width\"]:t[\"line-width\"]}function s(t,e,r,n,i){if(!e[0]&&!e[1])return t;e=u.convert(e),\"viewport\"===r&&e._rotate(-n);for(var a=[],o=0;o<t.length;o++){for(var s=t[o],l=[],c=0;c<s.length;c++)l.push(s[c].sub(e._mult(i)));a.push(l)}return a}function l(t,e){for(var r=[],n=new u(0,0),i=0;i<t.length;i++){for(var a=t[i],o=[],s=0;s<a.length;s++){var l=a[s-1],c=a[s],h=a[s+1],f=0===s?n:c.sub(l)._unit()._perp(),d=s===a.length-1?n:h.sub(c)._unit()._perp(),p=f._add(d)._unit(),m=p.x*d.x+p.y*d.y;p._mult(1/m),o.push(p._mult(e)._add(c))}r.push(o)}return r}var u=t(\"point-geometry\"),c=t(\"./load_geometry\"),h=t(\"./bucket\").EXTENT,f=t(\"feature-filter\"),d=t(\"../util/struct_array\"),p=t(\"grid-index\"),m=t(\"../util/dictionary_coder\"),v=t(\"vector-tile\"),g=t(\"pbf\"),y=t(\"../util/vectortile_to_geojson\"),b=t(\"../util/util\").arraysIntersect,x=t(\"../util/intersection_tests\"),_=x.multiPolygonIntersectsBufferedMultiPoint,w=x.multiPolygonIntersectsMultiPolygon,M=x.multiPolygonIntersectsBufferedMultiLine,k=new d({members:[{type:\"Uint32\",name:\"featureIndex\"},{type:\"Uint16\",name:\"sourceLayerIndex\"},{type:\"Uint16\",name:\"bucketIndex\"}]});e.exports=n,n.prototype.insert=function(t,e,r,n){var i=this.featureIndexArray.length;this.featureIndexArray.emplaceBack(e,r,n);for(var a=c(t),o=0;o<a.length;o++){for(var s=a[o],l=[1/0,1/0,-1/0,-1/0],u=0;u<s.length;u++){var h=s[u];l[0]=Math.min(l[0],h.x),l[1]=Math.min(l[1],h.y),l[2]=Math.max(l[2],h.x),l[3]=Math.max(l[3],h.y)}this.grid.insert(i,l[0],l[1],l[2],l[3])}},n.prototype.setCollisionTile=function(t){this.collisionTile=t},n.prototype.serialize=function(){var t={coord:this.coord,overscaling:this.overscaling,grid:this.grid.toArrayBuffer(),featureIndexArray:this.featureIndexArray.serialize(),bucketLayerIDs:this.bucketLayerIDs};return{data:t,transferables:[t.grid,t.featureIndexArray.arrayBuffer]}},n.prototype.query=function(t,e){this.vtLayers||(this.vtLayers=new v.VectorTile(new g(new Uint8Array(this.rawTileData))).layers,this.sourceLayerCoder=new m(this.vtLayers?Object.keys(this.vtLayers).sort():[\"_geojsonTileLayer\"]));var r={},n=t.params||{},s=h/t.tileSize/t.scale,l=f(n.filter),c=0;for(var d in e){var p=e[d],y=p.paint,b=0;\"line\"===p.type?b=o(y)/2+Math.abs(y[\"line-offset\"])+i(y[\"line-translate\"]):\"fill\"===p.type?b=i(y[\"fill-translate\"]):\"circle\"===p.type&&(b=y[\"circle-radius\"]+i(y[\"circle-translate\"])),c=Math.max(c,b*s)}for(var x=t.queryGeometry.map(function(t){return t.map(function(t){return new u(t.x,t.y)})}),_=1/0,w=1/0,M=-1/0,k=-1/0,A=0;A<x.length;A++)for(var T=x[A],S=0;S<T.length;S++){var E=T[S];_=Math.min(_,E.x),w=Math.min(w,E.y),M=Math.max(M,E.x),k=Math.max(k,E.y)}var L=this.grid.query(_-c,w-c,M+c,k+c);L.sort(a),this.filterMatching(r,L,this.featureIndexArray,x,l,n.layers,e,t.bearing,s);var C=this.collisionTile.queryRenderedSymbols(_,w,M,k,t.scale);return C.sort(),this.filterMatching(r,C,this.collisionTile.collisionBoxArray,x,l,n.layers,e,t.bearing,s),r},n.prototype.filterMatching=function(t,e,r,n,i,a,u,h,f){for(var d,p=0;p<e.length;p++){var m=e[p];if(m!==d){d=m;var v=r.get(m),g=this.bucketLayerIDs[v.bucketIndex];if(!a||b(a,g)){var x=this.sourceLayerCoder.decode(v.sourceLayerIndex),k=this.vtLayers[x],A=k.feature(v.featureIndex);if(i(A))for(var T=null,S=0;S<g.length;S++){var E=g[S];if(!(a&&a.indexOf(E)<0)){var L=u[E];if(L){var C;if(\"symbol\"!==L.type){T||(T=c(A));var z=L.paint;if(\"line\"===L.type){C=s(n,z[\"line-translate\"],z[\"line-translate-anchor\"],h,f);var I=o(z)/2*f;if(z[\"line-offset\"]&&(T=l(T,z[\"line-offset\"]*f)),!M(C,T,I))continue}else if(\"fill\"===L.type){if(C=s(n,z[\"fill-translate\"],z[\"fill-translate-anchor\"],h,f),!w(C,T))continue}else if(\"circle\"===L.type){C=s(n,z[\"circle-translate\"],z[\"circle-translate-anchor\"],h,f);var D=z[\"circle-radius\"]*f;if(!_(C,T,D))continue}}var P=new y(A,this.z,this.x,this.y);P.layer=L.serialize({includeRefProperties:!0});var O=t[E];void 0===O&&(O=t[E]=[]),O.push(P)}}}}}}}},{\"../util/dictionary_coder\":431,\"../util/intersection_tests\":436,\"../util/struct_array\":439,\"../util/util\":441,\"../util/vectortile_to_geojson\":442,\"./bucket\":328,\"./load_geometry\":336,\"feature-filter\":131,\"grid-index\":286,pbf:477,\"point-geometry\":483,\"vector-tile\":549}],336:[function(t,e,r){\"use strict\";function n(t){return{min:-1*Math.pow(2,t-1),max:Math.pow(2,t-1)-1}}var i=t(\"../util/util\"),a=t(\"./bucket\").EXTENT,o=t(\"assert\"),s={15:n(15),16:n(16)};e.exports=function(t,e){var r=s[e||16];o(r);for(var n=a/t.extent,l=t.loadGeometry(),u=0;u<l.length;u++)for(var c=l[u],h=0;h<c.length;h++){var f=c[h];f.x=Math.round(f.x*n),f.y=Math.round(f.y*n),(f.x<r.min||f.x>r.max||f.y<r.min||f.y>r.max)&&i.warnOnce(\"Geometry exceeds allowed extent, reduce your vector tile buffer size\")}return l}},{\"../util/util\":441,\"./bucket\":328,assert:46}],337:[function(t,e,r){\"use strict\";function n(t,e,r){this.column=t,this.row=e,this.zoom=r}e.exports=n,n.prototype={clone:function(){return new n(this.column,this.row,this.zoom)},zoomTo:function(t){return this.clone()._zoomTo(t)},sub:function(t){return this.clone()._sub(t)},_zoomTo:function(t){var e=Math.pow(2,t-this.zoom);return this.column*=e,this.row*=e,this.zoom=t,this},_sub:function(t){return t=t.zoomTo(this.zoom),this.column-=t.column,this.row-=t.row,this}}},{}],338:[function(t,e,r){\"use strict\";function n(t,e){if(isNaN(t)||isNaN(e))throw new Error(\"Invalid LngLat object: (\"+t+\", \"+e+\")\");if(this.lng=+t,this.lat=+e,this.lat>90||this.lat<-90)throw new Error(\"Invalid LngLat latitude value: must be between -90 and 90\")}e.exports=n\n",
       ";var i=t(\"../util/util\").wrap;n.prototype.wrap=function(){return new n(i(this.lng,-180,180),this.lat)},n.prototype.toArray=function(){return[this.lng,this.lat]},n.prototype.toString=function(){return\"LngLat(\"+this.lng+\", \"+this.lat+\")\"},n.convert=function(t){return t instanceof n?t:Array.isArray(t)?new n(t[0],t[1]):t}},{\"../util/util\":441}],339:[function(t,e,r){\"use strict\";function n(t,e){t&&(e?this.extend(t).extend(e):4===t.length?this.extend([t[0],t[1]]).extend([t[2],t[3]]):this.extend(t[0]).extend(t[1]))}e.exports=n;var i=t(\"./lng_lat\");n.prototype={extend:function(t){var e,r,a=this._sw,o=this._ne;if(t instanceof i)e=t,r=t;else{if(!(t instanceof n))return t?this.extend(i.convert(t)||n.convert(t)):this;if(e=t._sw,r=t._ne,!e||!r)return this}return a||o?(a.lng=Math.min(e.lng,a.lng),a.lat=Math.min(e.lat,a.lat),o.lng=Math.max(r.lng,o.lng),o.lat=Math.max(r.lat,o.lat)):(this._sw=new i(e.lng,e.lat),this._ne=new i(r.lng,r.lat)),this},getCenter:function(){return new i((this._sw.lng+this._ne.lng)/2,(this._sw.lat+this._ne.lat)/2)},getSouthWest:function(){return this._sw},getNorthEast:function(){return this._ne},getNorthWest:function(){return new i(this.getWest(),this.getNorth())},getSouthEast:function(){return new i(this.getEast(),this.getSouth())},getWest:function(){return this._sw.lng},getSouth:function(){return this._sw.lat},getEast:function(){return this._ne.lng},getNorth:function(){return this._ne.lat},toArray:function(){return[this._sw.toArray(),this._ne.toArray()]},toString:function(){return\"LngLatBounds(\"+this._sw.toString()+\", \"+this._ne.toString()+\")\"}},n.convert=function(t){return!t||t instanceof n?t:new n(t)}},{\"./lng_lat\":338}],340:[function(t,e,r){\"use strict\";function n(t,e){this.tileSize=512,this._minZoom=t||0,this._maxZoom=e||22,this.latRange=[-85.05113,85.05113],this.width=0,this.height=0,this._center=new i(0,0),this.zoom=0,this.angle=0,this._altitude=1.5,this._pitch=0,this._unmodified=!0}var i=t(\"./lng_lat\"),a=t(\"point-geometry\"),o=t(\"./coordinate\"),s=t(\"../util/util\").wrap,l=t(\"../util/interpolate\"),u=t(\"../source/tile_coord\"),c=t(\"../data/bucket\").EXTENT,h=t(\"gl-matrix\"),f=h.vec4,d=h.mat4,p=h.mat2;e.exports=n,n.prototype={get minZoom(){return this._minZoom},set minZoom(t){this._minZoom!==t&&(this._minZoom=t,this.zoom=Math.max(this.zoom,t))},get maxZoom(){return this._maxZoom},set maxZoom(t){this._maxZoom!==t&&(this._maxZoom=t,this.zoom=Math.min(this.zoom,t))},get worldSize(){return this.tileSize*this.scale},get centerPoint(){return this.size._div(2)},get size(){return new a(this.width,this.height)},get bearing(){return-this.angle/Math.PI*180},set bearing(t){var e=-s(t,-180,180)*Math.PI/180;this.angle!==e&&(this._unmodified=!1,this.angle=e,this._calcMatrices(),this.rotationMatrix=p.create(),p.rotate(this.rotationMatrix,this.rotationMatrix,this.angle))},get pitch(){return this._pitch/Math.PI*180},set pitch(t){var e=Math.min(60,t)/180*Math.PI;this._pitch!==e&&(this._unmodified=!1,this._pitch=e,this._calcMatrices())},get altitude(){return this._altitude},set altitude(t){var e=Math.max(.75,t);this._altitude!==e&&(this._unmodified=!1,this._altitude=e,this._calcMatrices())},get zoom(){return this._zoom},set zoom(t){var e=Math.min(Math.max(t,this.minZoom),this.maxZoom);this._zoom!==e&&(this._unmodified=!1,this._zoom=e,this.scale=this.zoomScale(e),this.tileZoom=Math.floor(e),this.zoomFraction=e-this.tileZoom,this._calcMatrices(),this._constrain())},get center(){return this._center},set center(t){t.lat===this._center.lat&&t.lng===this._center.lng||(this._unmodified=!1,this._center=t,this._calcMatrices(),this._constrain())},coveringZoomLevel:function(t){return(t.roundZoom?Math.round:Math.floor)(this.zoom+this.scaleZoom(this.tileSize/t.tileSize))},coveringTiles:function(t){var e=this.coveringZoomLevel(t),r=e;if(e<t.minzoom)return[];e>t.maxzoom&&(e=t.maxzoom);var n=this,i=n.locationCoordinate(n.center)._zoomTo(e),o=new a(i.column-.5,i.row-.5);return u.cover(e,[n.pointCoordinate(new a(0,0))._zoomTo(e),n.pointCoordinate(new a(n.width,0))._zoomTo(e),n.pointCoordinate(new a(n.width,n.height))._zoomTo(e),n.pointCoordinate(new a(0,n.height))._zoomTo(e)],t.reparseOverscaled?r:e).sort(function(t,e){return o.dist(t)-o.dist(e)})},resize:function(t,e){this.width=t,this.height=e,this.pixelsToGLUnits=[2/t,-2/e],this._calcMatrices(),this._constrain()},get unmodified(){return this._unmodified},zoomScale:function(t){return Math.pow(2,t)},scaleZoom:function(t){return Math.log(t)/Math.LN2},project:function(t,e){return new a(this.lngX(t.lng,e),this.latY(t.lat,e))},unproject:function(t,e){return new i(this.xLng(t.x,e),this.yLat(t.y,e))},get x(){return this.lngX(this.center.lng)},get y(){return this.latY(this.center.lat)},get point(){return new a(this.x,this.y)},lngX:function(t,e){return(180+t)*(e||this.worldSize)/360},latY:function(t,e){return(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+t*Math.PI/360)))*(e||this.worldSize)/360},xLng:function(t,e){return 360*t/(e||this.worldSize)-180},yLat:function(t,e){var r=180-360*t/(e||this.worldSize);return 360/Math.PI*Math.atan(Math.exp(r*Math.PI/180))-90},panBy:function(t){var e=this.centerPoint._add(t);this.center=this.pointLocation(e)},setLocationAtPoint:function(t,e){var r=this.locationCoordinate(t),n=this.pointCoordinate(e),i=this.pointCoordinate(this.centerPoint),a=n._sub(r);this._unmodified=!1,this.center=this.coordinateLocation(i._sub(a))},locationPoint:function(t){return this.coordinatePoint(this.locationCoordinate(t))},pointLocation:function(t){return this.coordinateLocation(this.pointCoordinate(t))},locationCoordinate:function(t){var e=this.zoomScale(this.tileZoom)/this.worldSize,r=i.convert(t);return new o(this.lngX(r.lng)*e,this.latY(r.lat)*e,this.tileZoom)},coordinateLocation:function(t){var e=this.zoomScale(t.zoom);return new i(this.xLng(t.column,e),this.yLat(t.row,e))},pointCoordinate:function(t){var e=[t.x,t.y,0,1],r=[t.x,t.y,1,1];f.transformMat4(e,e,this.pixelMatrixInverse),f.transformMat4(r,r,this.pixelMatrixInverse);var n=e[3],i=r[3],a=e[0]/n,s=r[0]/i,u=e[1]/n,c=r[1]/i,h=e[2]/n,d=r[2]/i,p=h===d?0:(0-h)/(d-h),m=this.worldSize/this.zoomScale(this.tileZoom);return new o(l(a,s,p)/m,l(u,c,p)/m,this.tileZoom)},coordinatePoint:function(t){var e=this.worldSize/this.zoomScale(t.zoom),r=[t.column*e,t.row*e,0,1];return f.transformMat4(r,r,this.pixelMatrix),new a(r[0]/r[3],r[1]/r[3])},calculatePosMatrix:function(t,e){void 0===e&&(e=1/0),t instanceof u&&(t=t.toCoordinate(e));var r=Math.min(t.zoom,e),n=this.worldSize/Math.pow(2,r),i=new Float64Array(16);return d.identity(i),d.translate(i,i,[t.column*n,t.row*n,0]),d.scale(i,i,[n/c,n/c,1]),d.multiply(i,this.projMatrix,i),new Float32Array(i)},_constrain:function(){if(this.center&&this.width&&this.height&&!this._constraining){this._constraining=!0;var t,e,r,n,i,o,s,l,u=this.size,c=this._unmodified;this.latRange&&(t=this.latY(this.latRange[1]),e=this.latY(this.latRange[0]),i=e-t<u.y?u.y/(e-t):0),this.lngRange&&(r=this.lngX(this.lngRange[0]),n=this.lngX(this.lngRange[1]),o=n-r<u.x?u.x/(n-r):0);var h=Math.max(o||0,i||0);if(h)return this.center=this.unproject(new a(o?(n+r)/2:this.x,i?(e+t)/2:this.y)),this.zoom+=this.scaleZoom(h),this._unmodified=c,void(this._constraining=!1);if(this.latRange){var f=this.y,d=u.y/2;f-d<t&&(l=t+d),f+d>e&&(l=e-d)}if(this.lngRange){var p=this.x,m=u.x/2;p-m<r&&(s=r+m),p+m>n&&(s=n-m)}void 0===s&&void 0===l||(this.center=this.unproject(new a(void 0!==s?s:this.x,void 0!==l?l:this.y))),this._unmodified=c,this._constraining=!1}},_calcMatrices:function(){if(this.height){var t=Math.atan(.5/this.altitude),e=Math.sin(t)*this.altitude/Math.sin(Math.PI/2-this._pitch-t),r=Math.cos(Math.PI/2-this._pitch)*e+this.altitude,n=new Float64Array(16);if(d.perspective(n,2*Math.atan(this.height/2/this.altitude),this.width/this.height,.1,r),d.translate(n,n,[0,0,-this.altitude]),d.scale(n,n,[1,-1,1/this.height]),d.rotateX(n,n,this._pitch),d.rotateZ(n,n,this.angle),d.translate(n,n,[-this.x,-this.y,0]),this.projMatrix=n,n=d.create(),d.scale(n,n,[this.width/2,-this.height/2,1]),d.translate(n,n,[1,-1,0]),this.pixelMatrix=d.multiply(new Float64Array(16),n,this.projMatrix),!(n=d.invert(new Float64Array(16),this.pixelMatrix)))throw new Error(\"failed to invert matrix\");this.pixelMatrixInverse=n}}}},{\"../data/bucket\":328,\"../source/tile_coord\":368,\"../util/interpolate\":435,\"../util/util\":441,\"./coordinate\":337,\"./lng_lat\":338,\"gl-matrix\":192,\"point-geometry\":483}],341:[function(t,e,r){\"use strict\";var n={\" \":[16,[]],\"!\":[10,[5,21,5,7,-1,-1,5,2,4,1,5,0,6,1,5,2]],'\"':[16,[4,21,4,14,-1,-1,12,21,12,14]],\"#\":[21,[11,25,4,-7,-1,-1,17,25,10,-7,-1,-1,4,12,18,12,-1,-1,3,6,17,6]],$:[20,[8,25,8,-4,-1,-1,12,25,12,-4,-1,-1,17,18,15,20,12,21,8,21,5,20,3,18,3,16,4,14,5,13,7,12,13,10,15,9,16,8,17,6,17,3,15,1,12,0,8,0,5,1,3,3]],\"%\":[24,[21,21,3,0,-1,-1,8,21,10,19,10,17,9,15,7,14,5,14,3,16,3,18,4,20,6,21,8,21,10,20,13,19,16,19,19,20,21,21,-1,-1,17,7,15,6,14,4,14,2,16,0,18,0,20,1,21,3,21,5,19,7,17,7]],\"&\":[26,[23,12,23,13,22,14,21,14,20,13,19,11,17,6,15,3,13,1,11,0,7,0,5,1,4,2,3,4,3,6,4,8,5,9,12,13,13,14,14,16,14,18,13,20,11,21,9,20,8,18,8,16,9,13,11,10,16,3,18,1,20,0,22,0,23,1,23,2]],\"'\":[10,[5,19,4,20,5,21,6,20,6,18,5,16,4,15]],\"(\":[14,[11,25,9,23,7,20,5,16,4,11,4,7,5,2,7,-2,9,-5,11,-7]],\")\":[14,[3,25,5,23,7,20,9,16,10,11,10,7,9,2,7,-2,5,-5,3,-7]],\"*\":[16,[8,21,8,9,-1,-1,3,18,13,12,-1,-1,13,18,3,12]],\"+\":[26,[13,18,13,0,-1,-1,4,9,22,9]],\",\":[10,[6,1,5,0,4,1,5,2,6,1,6,-1,5,-3,4,-4]],\"-\":[26,[4,9,22,9]],\".\":[10,[5,2,4,1,5,0,6,1,5,2]],\"/\":[22,[20,25,2,-7]],0:[20,[9,21,6,20,4,17,3,12,3,9,4,4,6,1,9,0,11,0,14,1,16,4,17,9,17,12,16,17,14,20,11,21,9,21]],1:[20,[6,17,8,18,11,21,11,0]],2:[20,[4,16,4,17,5,19,6,20,8,21,12,21,14,20,15,19,16,17,16,15,15,13,13,10,3,0,17,0]],3:[20,[5,21,16,21,10,13,13,13,15,12,16,11,17,8,17,6,16,3,14,1,11,0,8,0,5,1,4,2,3,4]],4:[20,[13,21,3,7,18,7,-1,-1,13,21,13,0]],5:[20,[15,21,5,21,4,12,5,13,8,14,11,14,14,13,16,11,17,8,17,6,16,3,14,1,11,0,8,0,5,1,4,2,3,4]],6:[20,[16,18,15,20,12,21,10,21,7,20,5,17,4,12,4,7,5,3,7,1,10,0,11,0,14,1,16,3,17,6,17,7,16,10,14,12,11,13,10,13,7,12,5,10,4,7]],7:[20,[17,21,7,0,-1,-1,3,21,17,21]],8:[20,[8,21,5,20,4,18,4,16,5,14,7,13,11,12,14,11,16,9,17,7,17,4,16,2,15,1,12,0,8,0,5,1,4,2,3,4,3,7,4,9,6,11,9,12,13,13,15,14,16,16,16,18,15,20,12,21,8,21]],9:[20,[16,14,15,11,13,9,10,8,9,8,6,9,4,11,3,14,3,15,4,18,6,20,9,21,10,21,13,20,15,18,16,14,16,9,15,4,13,1,10,0,8,0,5,1,4,3]],\":\":[10,[5,14,4,13,5,12,6,13,5,14,-1,-1,5,2,4,1,5,0,6,1,5,2]],\";\":[10,[5,14,4,13,5,12,6,13,5,14,-1,-1,6,1,5,0,4,1,5,2,6,1,6,-1,5,-3,4,-4]],\"<\":[24,[20,18,4,9,20,0]],\"=\":[26,[4,12,22,12,-1,-1,4,6,22,6]],\">\":[24,[4,18,20,9,4,0]],\"?\":[18,[3,16,3,17,4,19,5,20,7,21,11,21,13,20,14,19,15,17,15,15,14,13,13,12,9,10,9,7,-1,-1,9,2,8,1,9,0,10,1,9,2]],\"@\":[27,[18,13,17,15,15,16,12,16,10,15,9,14,8,11,8,8,9,6,11,5,14,5,16,6,17,8,-1,-1,12,16,10,14,9,11,9,8,10,6,11,5,-1,-1,18,16,17,8,17,6,19,5,21,5,23,7,24,10,24,12,23,15,22,17,20,19,18,20,15,21,12,21,9,20,7,19,5,17,4,15,3,12,3,9,4,6,5,4,7,2,9,1,12,0,15,0,18,1,20,2,21,3,-1,-1,19,16,18,8,18,6,19,5]],A:[18,[9,21,1,0,-1,-1,9,21,17,0,-1,-1,4,7,14,7]],B:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,15,17,13,16,12,13,11,-1,-1,4,11,13,11,16,10,17,9,18,7,18,4,17,2,16,1,13,0,4,0]],C:[21,[18,16,17,18,15,20,13,21,9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5]],D:[21,[4,21,4,0,-1,-1,4,21,11,21,14,20,16,18,17,16,18,13,18,8,17,5,16,3,14,1,11,0,4,0]],E:[19,[4,21,4,0,-1,-1,4,21,17,21,-1,-1,4,11,12,11,-1,-1,4,0,17,0]],F:[18,[4,21,4,0,-1,-1,4,21,17,21,-1,-1,4,11,12,11]],G:[21,[18,16,17,18,15,20,13,21,9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,18,8,-1,-1,13,8,18,8]],H:[22,[4,21,4,0,-1,-1,18,21,18,0,-1,-1,4,11,18,11]],I:[8,[4,21,4,0]],J:[16,[12,21,12,5,11,2,10,1,8,0,6,0,4,1,3,2,2,5,2,7]],K:[21,[4,21,4,0,-1,-1,18,21,4,7,-1,-1,9,12,18,0]],L:[17,[4,21,4,0,-1,-1,4,0,16,0]],M:[24,[4,21,4,0,-1,-1,4,21,12,0,-1,-1,20,21,12,0,-1,-1,20,21,20,0]],N:[22,[4,21,4,0,-1,-1,4,21,18,0,-1,-1,18,21,18,0]],O:[22,[9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,19,8,19,13,18,16,17,18,15,20,13,21,9,21]],P:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,14,17,12,16,11,13,10,4,10]],Q:[22,[9,21,7,20,5,18,4,16,3,13,3,8,4,5,5,3,7,1,9,0,13,0,15,1,17,3,18,5,19,8,19,13,18,16,17,18,15,20,13,21,9,21,-1,-1,12,4,18,-2]],R:[21,[4,21,4,0,-1,-1,4,21,13,21,16,20,17,19,18,17,18,15,17,13,16,12,13,11,4,11,-1,-1,11,11,18,0]],S:[20,[17,18,15,20,12,21,8,21,5,20,3,18,3,16,4,14,5,13,7,12,13,10,15,9,16,8,17,6,17,3,15,1,12,0,8,0,5,1,3,3]],T:[16,[8,21,8,0,-1,-1,1,21,15,21]],U:[22,[4,21,4,6,5,3,7,1,10,0,12,0,15,1,17,3,18,6,18,21]],V:[18,[1,21,9,0,-1,-1,17,21,9,0]],W:[24,[2,21,7,0,-1,-1,12,21,7,0,-1,-1,12,21,17,0,-1,-1,22,21,17,0]],X:[20,[3,21,17,0,-1,-1,17,21,3,0]],Y:[18,[1,21,9,11,9,0,-1,-1,17,21,9,11]],Z:[20,[17,21,3,0,-1,-1,3,21,17,21,-1,-1,3,0,17,0]],\"[\":[14,[4,25,4,-7,-1,-1,5,25,5,-7,-1,-1,4,25,11,25,-1,-1,4,-7,11,-7]],\"\\\\\":[14,[0,21,14,-3]],\"]\":[14,[9,25,9,-7,-1,-1,10,25,10,-7,-1,-1,3,25,10,25,-1,-1,3,-7,10,-7]],\"^\":[16,[6,15,8,18,10,15,-1,-1,3,12,8,17,13,12,-1,-1,8,17,8,0]],_:[16,[0,-2,16,-2]],\"`\":[10,[6,21,5,20,4,18,4,16,5,15,6,16,5,17]],a:[19,[15,14,15,0,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],b:[19,[4,21,4,0,-1,-1,4,11,6,13,8,14,11,14,13,13,15,11,16,8,16,6,15,3,13,1,11,0,8,0,6,1,4,3]],c:[18,[15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],d:[19,[15,21,15,0,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],e:[18,[3,8,15,8,15,10,14,12,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],f:[12,[10,21,8,21,6,20,5,17,5,0,-1,-1,2,14,9,14]],g:[19,[15,14,15,-2,14,-5,13,-6,11,-7,8,-7,6,-6,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],h:[19,[4,21,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0]],i:[8,[3,21,4,20,5,21,4,22,3,21,-1,-1,4,14,4,0]],j:[10,[5,21,6,20,7,21,6,22,5,21,-1,-1,6,14,6,-3,5,-6,3,-7,1,-7]],k:[17,[4,21,4,0,-1,-1,14,14,4,4,-1,-1,8,8,15,0]],l:[8,[4,21,4,0]],m:[30,[4,14,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0,-1,-1,15,10,18,13,20,14,23,14,25,13,26,10,26,0]],n:[19,[4,14,4,0,-1,-1,4,10,7,13,9,14,12,14,14,13,15,10,15,0]],o:[19,[8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3,16,6,16,8,15,11,13,13,11,14,8,14]],p:[19,[4,14,4,-7,-1,-1,4,11,6,13,8,14,11,14,13,13,15,11,16,8,16,6,15,3,13,1,11,0,8,0,6,1,4,3]],q:[19,[15,14,15,-7,-1,-1,15,11,13,13,11,14,8,14,6,13,4,11,3,8,3,6,4,3,6,1,8,0,11,0,13,1,15,3]],r:[13,[4,14,4,0,-1,-1,4,8,5,11,7,13,9,14,12,14]],s:[17,[14,11,13,13,10,14,7,14,4,13,3,11,4,9,6,8,11,7,13,6,14,4,14,3,13,1,10,0,7,0,4,1,3,3]],t:[12,[5,21,5,4,6,1,8,0,10,0,-1,-1,2,14,9,14]],u:[19,[4,14,4,4,5,1,7,0,10,0,12,1,15,4,-1,-1,15,14,15,0]],v:[16,[2,14,8,0,-1,-1,14,14,8,0]],w:[22,[3,14,7,0,-1,-1,11,14,7,0,-1,-1,11,14,15,0,-1,-1,19,14,15,0]],x:[17,[3,14,14,0,-1,-1,14,14,3,0]],y:[16,[2,14,8,0,-1,-1,14,14,8,0,6,-4,4,-6,2,-7,1,-7]],z:[17,[14,14,3,0,-1,-1,3,14,14,14,-1,-1,3,0,14,0]],\"{\":[14,[9,25,7,24,6,23,5,21,5,19,6,17,7,16,8,14,8,12,6,10,-1,-1,7,24,6,22,6,20,7,18,8,17,9,15,9,13,8,11,4,9,8,7,9,5,9,3,8,1,7,0,6,-2,6,-4,7,-6,-1,-1,6,8,8,6,8,4,7,2,6,1,5,-1,5,-3,6,-5,7,-6,9,-7]],\"|\":[8,[4,25,4,-7]],\"}\":[14,[5,25,7,24,8,23,9,21,9,19,8,17,7,16,6,14,6,12,8,10,-1,-1,7,24,8,22,8,20,7,18,6,17,5,15,5,13,6,11,10,9,6,7,5,5,5,3,6,1,7,0,8,-2,8,-4,7,-6,-1,-1,8,8,6,6,6,4,7,2,8,1,9,-1,9,-3,8,-5,7,-6,5,-7]],\"~\":[24,[3,6,3,8,4,11,6,12,8,12,10,11,14,8,16,7,18,7,20,8,21,10,-1,-1,3,8,4,10,6,11,8,11,10,10,14,7,16,6,18,6,20,7,21,10,21,12]]};e.exports=function(t,e,r,i){i=i||1;var a,o,s,l,u,c,h,f,d=[];for(a=0,o=t.length;a<o;a++)if(u=n[t[a]]){for(f=null,s=0,l=u[1].length;s<l;s+=2)-1===u[1][s]&&-1===u[1][s+1]?f=null:(c=e+u[1][s]*i,h=r-u[1][s+1]*i,f&&d.push(f.x,f.y,c,h),f={x:c,y:h});e+=u[0]*i}return d}},{}],342:[function(t,e,r){\"use strict\";var n=e.exports={};n.version=t(\"../package.json\").version,n.Map=t(\"./ui/map\"),n.Control=t(\"./ui/control/control\"),n.Navigation=t(\"./ui/control/navigation\"),n.Geolocate=t(\"./ui/control/geolocate\"),n.Attribution=t(\"./ui/control/attribution\"),n.Popup=t(\"./ui/popup\"),n.Marker=t(\"./ui/marker\"),n.Style=t(\"./style/style\"),n.LngLat=t(\"./geo/lng_lat\"),n.LngLatBounds=t(\"./geo/lng_lat_bounds\"),n.Point=t(\"point-geometry\"),n.Evented=t(\"./util/evented\"),n.util=t(\"./util/util\"),n.supported=t(\"./util/browser\").supported;var i=t(\"./util/ajax\");n.util.getJSON=i.getJSON,n.util.getArrayBuffer=i.getArrayBuffer;var a=t(\"./util/config\");n.config=a,Object.defineProperty(n,\"accessToken\",{get:function(){return a.ACCESS_TOKEN},set:function(t){a.ACCESS_TOKEN=t}})},{\"../package.json\":443,\"./geo/lng_lat\":338,\"./geo/lng_lat_bounds\":339,\"./style/style\":377,\"./ui/control/attribution\":408,\"./ui/control/control\":409,\"./ui/control/geolocate\":410,\"./ui/control/navigation\":411,\"./ui/map\":420,\"./ui/marker\":421,\"./ui/popup\":422,\"./util/ajax\":424,\"./util/browser\":425,\"./util/config\":430,\"./util/evented\":433,\"./util/util\":441,\"point-geometry\":483}],343:[function(t,e,r){\"use strict\";var n=t(\"assert\");e.exports=function(t){for(var e={define:{},initialize:{}},r=0;r<t.length;r++){var i=t[r];n(\"u_\"===i.name.slice(0,2));var a=\"{precision} \"+(1===i.components?\"float\":\"vec\"+i.components);e.define[i.name.slice(2)]=\"uniform \"+a+\" \"+i.name+\";\\n\",e.initialize[i.name.slice(2)]=a+\" \"+i.name.slice(2)+\" = \"+i.name+\";\\n\"}return e}},{assert:46}],344:[function(t,e,r){\"use strict\";function n(t,e,r){var n,s=t.gl,l=t.transform,u=r.paint[\"background-color\"],c=r.paint[\"background-pattern\"],h=r.paint[\"background-opacity\"],f=c?t.spriteAtlas.getPosition(c.from,!0):null,d=c?t.spriteAtlas.getPosition(c.to,!0):null;if(t.setDepthSublayer(0),f&&d){if(t.isOpaquePass)return;n=t.useProgram(\"pattern\"),s.uniform1i(n.u_image,0),s.uniform2fv(n.u_pattern_tl_a,f.tl),s.uniform2fv(n.u_pattern_br_a,f.br),s.uniform2fv(n.u_pattern_tl_b,d.tl),s.uniform2fv(n.u_pattern_br_b,d.br),s.uniform1f(n.u_opacity,h),s.uniform1f(n.u_mix,c.t),s.uniform2fv(n.u_pattern_size_a,f.size),s.uniform2fv(n.u_pattern_size_b,d.size),s.uniform1f(n.u_scale_a,c.fromScale),s.uniform1f(n.u_scale_b,c.toScale),s.activeTexture(s.TEXTURE0),t.spriteAtlas.bind(s,!0),t.tileExtentPatternVAO.bind(s,n,t.tileExtentBuffer)}else{if(t.isOpaquePass!==(1===u[3]))return;var p=a([{name:\"u_color\",components:4},{name:\"u_opacity\",components:1}]);n=t.useProgram(\"fill\",[],p,p),s.uniform4fv(n.u_color,u),s.uniform1f(n.u_opacity,h),t.tileExtentVAO.bind(s,n,t.tileExtentBuffer)}s.disable(s.STENCIL_TEST);for(var m=l.coveringTiles({tileSize:o}),v=0;v<m.length;v++){var g=m[v];if(f&&d){var y={coord:g,tileSize:o};s.uniform1f(n.u_tile_units_to_pixels,1/i(y,1,t.transform.tileZoom));var b=y.tileSize*Math.pow(2,t.transform.tileZoom-y.coord.z),x=b*(y.coord.x+g.w*Math.pow(2,y.coord.z)),_=b*y.coord.y;s.uniform2f(n.u_pixel_coord_upper,x>>16,_>>16),s.uniform2f(n.u_pixel_coord_lower,65535&x,65535&_)}s.uniformMatrix4fv(n.u_matrix,!1,t.transform.calculatePosMatrix(g)),s.drawArrays(s.TRIANGLE_STRIP,0,t.tileExtentBuffer.length)}s.stencilMask(0),s.stencilFunc(s.EQUAL,128,128)}var i=t(\"../source/pixels_to_tile_units\"),a=t(\"./create_uniform_pragmas\"),o=512;e.exports=n},{\"../source/pixels_to_tile_units\":362,\"./create_uniform_pragmas\":343}],345:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=t.gl;t.setDepthSublayer(0),t.depthMask(!1),a.disable(a.STENCIL_TEST);for(var o=0;o<n.length;o++){var s=n[o],l=e.getTile(s),u=l.getBucket(r);if(u){var c=u.bufferGroups.circle;if(c){var h=u.paintAttributes.circle[r.id],f=t.useProgram(\"circle\",h.defines,h.vertexPragmas,h.fragmentPragmas);\"map\"===r.paint[\"circle-pitch-scale\"]?(a.uniform1i(f.u_scale_with_map,!0),a.uniform2f(f.u_extrude_scale,t.transform.pixelsToGLUnits[0]*t.transform.altitude,t.transform.pixelsToGLUnits[1]*t.transform.altitude)):(a.uniform1i(f.u_scale_with_map,!1),a.uniform2fv(f.u_extrude_scale,t.transform.pixelsToGLUnits)),a.uniform1f(f.u_devicepixelratio,i.devicePixelRatio),a.uniformMatrix4fv(f.u_matrix,!1,t.translatePosMatrix(s.posMatrix,l,r.paint[\"circle-translate\"],r.paint[\"circle-translate-anchor\"])),u.setUniforms(a,\"circle\",f,r,{zoom:t.transform.zoom});for(var d=0;d<c.length;d++){var p=c[d];p.vaos[r.id].bind(a,f,p.layoutVertexBuffer,p.elementBuffer,p.paintVertexBuffers[r.id]),a.drawElements(a.TRIANGLES,3*p.elementBuffer.length,a.UNSIGNED_SHORT,0)}}}}}}var i=t(\"../util/browser\");e.exports=n},{\"../util/browser\":425}],346:[function(t,e,r){\"use strict\";function n(t,e,r,n){var i=t.gl;i.enable(i.STENCIL_TEST);for(var a=t.useProgram(\"collisionbox\"),o=0;o<n.length;o++){var s=n[o],l=e.getTile(s),u=l.getBucket(r);if(u){var c=u.bufferGroups.collisionBox;if(c&&c.length){var h=c[0];0!==h.layoutVertexBuffer.length&&(i.uniformMatrix4fv(a.u_matrix,!1,s.posMatrix),t.enableTileClippingMask(s),t.lineWidth(1),i.uniform1f(a.u_scale,Math.pow(2,t.transform.zoom-l.coord.z)),i.uniform1f(a.u_zoom,10*t.transform.zoom),i.uniform1f(a.u_maxzoom,10*(l.coord.z+1)),h.vaos[r.id].bind(i,a,h.layoutVertexBuffer),i.drawArrays(i.LINES,0,h.layoutVertexBuffer.length))}}}}e.exports=n},{}],347:[function(t,e,r){\"use strict\";function n(t,e,r){if(!t.isOpaquePass&&t.options.debug)for(var n=0;n<r.length;n++)i(t,e,r[n])}function i(t,e,r){var n=t.gl;n.disable(n.STENCIL_TEST),t.lineWidth(1*o.devicePixelRatio);var i=r.posMatrix,h=t.useProgram(\"debug\");n.uniformMatrix4fv(h.u_matrix,!1,i),n.uniform4f(h.u_color,1,0,0,1),t.debugVAO.bind(n,h,t.debugBuffer),n.drawArrays(n.LINE_STRIP,0,t.debugBuffer.length);for(var f=a(r.toString(),50,200,5),d=new t.PosArray,p=0;p<f.length;p+=2)d.emplaceBack(f[p],f[p+1]);var m=new u(d.serialize(),t.PosArray.serialize(),u.BufferType.VERTEX);(new c).bind(n,h,m),n.uniform4f(h.u_color,1,1,1,1);for(var v=e.getTile(r).tileSize,g=l/(Math.pow(2,t.transform.zoom-r.z)*v),y=[[-1,-1],[-1,1],[1,-1],[1,1]],b=0;b<y.length;b++){var x=y[b];n.uniformMatrix4fv(h.u_matrix,!1,s.translate([],i,[g*x[0],g*x[1],0])),n.drawArrays(n.LINES,0,m.length)}n.uniform4f(h.u_color,0,0,0,1),n.uniformMatrix4fv(h.u_matrix,!1,i),n.drawArrays(n.LINES,0,m.length)}var a=t(\"../lib/debugtext\"),o=t(\"../util/browser\"),s=t(\"gl-matrix\").mat4,l=t(\"../data/bucket\").EXTENT,u=t(\"../data/buffer\"),c=t(\"./vertex_array_object\");e.exports=n},{\"../data/bucket\":328,\"../data/buffer\":333,\"../lib/debugtext\":341,\"../util/browser\":425,\"./vertex_array_object\":356,\"gl-matrix\":192}],348:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o=t.gl;o.enable(o.STENCIL_TEST);var s;if(s=!r.paint[\"fill-pattern\"]&&(r.isPaintValueFeatureConstant(\"fill-color\")&&r.isPaintValueFeatureConstant(\"fill-opacity\")&&1===r.paint[\"fill-color\"][3]&&1===r.paint[\"fill-opacity\"]),t.isOpaquePass===s){t.setDepthSublayer(1);for(var l=0;l<n.length;l++)i(t,e,r,n[l])}if(!t.isOpaquePass&&r.paint[\"fill-antialias\"]){t.lineWidth(2),t.depthMask(!1);var u=r.getPaintProperty(\"fill-outline-color\");(u||!r.paint[\"fill-pattern\"])&&u?t.setDepthSublayer(2):t.setDepthSublayer(0);for(var c=0;c<n.length;c++)a(t,e,r,n[c])}}function i(t,e,r,n){var i=e.getTile(n),a=i.getBucket(r);if(a){var s=a.bufferGroups.fill;if(s){var l,u=t.gl,c=r.paint[\"fill-pattern\"];if(c)l=t.useProgram(\"pattern\"),o(c,r.paint[\"fill-opacity\"],i,n,t,l),u.activeTexture(u.TEXTURE0),t.spriteAtlas.bind(u,!0);else{var h=a.paintAttributes.fill[r.id];l=t.useProgram(\"fill\",h.defines,h.vertexPragmas,h.fragmentPragmas),a.setUniforms(u,\"fill\",l,r,{zoom:t.transform.zoom})}u.uniformMatrix4fv(l.u_matrix,!1,t.translatePosMatrix(n.posMatrix,i,r.paint[\"fill-translate\"],r.paint[\"fill-translate-anchor\"])),t.enableTileClippingMask(n);for(var f=0;f<s.length;f++){var d=s[f];d.vaos[r.id].bind(u,l,d.layoutVertexBuffer,d.elementBuffer,d.paintVertexBuffers[r.id]),u.drawElements(u.TRIANGLES,d.elementBuffer.length,u.UNSIGNED_SHORT,0)}}}}function a(t,e,r,n){var i=e.getTile(n),a=i.getBucket(r);if(a){var s,l=t.gl,u=a.bufferGroups.fill,c=r.paint[\"fill-pattern\"],h=r.paint[\"fill-opacity\"],f=r.getPaintProperty(\"fill-outline-color\");if(c&&!f)s=t.useProgram(\"outlinepattern\"),l.uniform2f(s.u_world,l.drawingBufferWidth,l.drawingBufferHeight);else{var d=a.paintAttributes.fill[r.id];s=t.useProgram(\"outline\",d.defines,d.vertexPragmas,d.fragmentPragmas),l.uniform2f(s.u_world,l.drawingBufferWidth,l.drawingBufferHeight),l.uniform1f(s.u_opacity,h),a.setUniforms(l,\"fill\",s,r,{zoom:t.transform.zoom})}l.uniformMatrix4fv(s.u_matrix,!1,t.translatePosMatrix(n.posMatrix,i,r.paint[\"fill-translate\"],r.paint[\"fill-translate-anchor\"])),c&&o(c,h,i,n,t,s),t.enableTileClippingMask(n);for(var p=0;p<u.length;p++){var m=u[p];m.secondVaos[r.id].bind(l,s,m.layoutVertexBuffer,m.elementBuffer2,m.paintVertexBuffers[r.id]),l.drawElements(l.LINES,2*m.elementBuffer2.length,l.UNSIGNED_SHORT,0)}}}function o(t,e,r,n,i,a){var o=i.gl,l=i.spriteAtlas.getPosition(t.from,!0),u=i.spriteAtlas.getPosition(t.to,!0);if(l&&u){o.uniform1i(a.u_image,0),o.uniform2fv(a.u_pattern_tl_a,l.tl),o.uniform2fv(a.u_pattern_br_a,l.br),o.uniform2fv(a.u_pattern_tl_b,u.tl),o.uniform2fv(a.u_pattern_br_b,u.br),o.uniform1f(a.u_opacity,e),o.uniform1f(a.u_mix,t.t),o.uniform1f(a.u_tile_units_to_pixels,1/s(r,1,i.transform.tileZoom)),o.uniform2fv(a.u_pattern_size_a,l.size),o.uniform2fv(a.u_pattern_size_b,u.size),o.uniform1f(a.u_scale_a,t.fromScale),o.uniform1f(a.u_scale_b,t.toScale);var c=r.tileSize*Math.pow(2,i.transform.tileZoom-r.coord.z),h=c*(r.coord.x+n.w*Math.pow(2,r.coord.z)),f=c*r.coord.y;o.uniform2f(a.u_pixel_coord_upper,h>>16,f>>16),o.uniform2f(a.u_pixel_coord_lower,65535&h,65535&f),o.activeTexture(o.TEXTURE0),i.spriteAtlas.bind(o,!0)}}var s=t(\"../source/pixels_to_tile_units\");e.exports=n},{\"../source/pixels_to_tile_units\":362}],349:[function(t,e,r){\"use strict\";var n=t(\"../util/browser\"),i=t(\"gl-matrix\").mat2,a=t(\"../source/pixels_to_tile_units\");e.exports=function(t,e,r,o){if(!t.isOpaquePass){t.setDepthSublayer(0),t.depthMask(!1);var s=t.gl;if(s.enable(s.STENCIL_TEST),!(r.paint[\"line-width\"]<=0)){var l=1/n.devicePixelRatio,u=r.paint[\"line-blur\"]+l,c=r.paint[\"line-color\"],h=t.transform,f=i.create();i.scale(f,f,[1,Math.cos(h._pitch)]),i.rotate(f,f,t.transform.angle);var d,p,m,v,g,y=Math.sqrt(h.height*h.height/4*(1+h.altitude*h.altitude)),b=h.height/2*Math.tan(h._pitch),x=(y+b)/y-1,_=r.paint[\"line-dasharray\"],w=r.paint[\"line-pattern\"];if(_)d=t.useProgram(\"linesdfpattern\"),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform4fv(d.u_color,c),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]),p=t.lineAtlas.getDash(_.from,\"round\"===r.layout[\"line-cap\"]),m=t.lineAtlas.getDash(_.to,\"round\"===r.layout[\"line-cap\"]),s.uniform1i(d.u_image,0),s.activeTexture(s.TEXTURE0),t.lineAtlas.bind(s),s.uniform1f(d.u_tex_y_a,p.y),s.uniform1f(d.u_tex_y_b,m.y),s.uniform1f(d.u_mix,_.t),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f);else if(w){if(v=t.spriteAtlas.getPosition(w.from,!0),g=t.spriteAtlas.getPosition(w.to,!0),!v||!g)return;d=t.useProgram(\"linepattern\"),s.uniform1i(d.u_image,0),s.activeTexture(s.TEXTURE0),t.spriteAtlas.bind(s,!0),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform2fv(d.u_pattern_tl_a,v.tl),s.uniform2fv(d.u_pattern_br_a,v.br),s.uniform2fv(d.u_pattern_tl_b,g.tl),s.uniform2fv(d.u_pattern_br_b,g.br),s.uniform1f(d.u_fade,w.t),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f)}else d=t.useProgram(\"line\"),s.uniform1f(d.u_linewidth,r.paint[\"line-width\"]/2),s.uniform1f(d.u_gapwidth,r.paint[\"line-gap-width\"]/2),s.uniform1f(d.u_antialiasing,l/2),s.uniform1f(d.u_blur,u),s.uniform1f(d.u_extra,x),s.uniform1f(d.u_offset,-r.paint[\"line-offset\"]),s.uniformMatrix2fv(d.u_antialiasingmatrix,!1,f),s.uniform4fv(d.u_color,c),s.uniform1f(d.u_opacity,r.paint[\"line-opacity\"]);for(var M=0;M<o.length;M++){var k=o[M],A=e.getTile(k),T=A.getBucket(r);if(T){var S=T.bufferGroups.line;if(S){t.enableTileClippingMask(k);var E=t.translatePosMatrix(k.posMatrix,A,r.paint[\"line-translate\"],r.paint[\"line-translate-anchor\"]);s.uniformMatrix4fv(d.u_matrix,!1,E);var L=1/a(A,1,t.transform.zoom);if(_){var C=p.width*_.fromScale,z=m.width*_.toScale,I=[1/a(A,C,t.transform.tileZoom),-p.height/2],D=[1/a(A,z,t.transform.tileZoom),-m.height/2],P=t.lineAtlas.width/(256*Math.min(C,z)*n.devicePixelRatio)/2;s.uniform1f(d.u_ratio,L),s.uniform2fv(d.u_patternscale_a,I),s.uniform2fv(d.u_patternscale_b,D),s.uniform1f(d.u_sdfgamma,P)}else w?(s.uniform1f(d.u_ratio,L),s.uniform2fv(d.u_pattern_size_a,[a(A,v.size[0]*w.fromScale,t.transform.tileZoom),g.size[1]]),s.uniform2fv(d.u_pattern_size_b,[a(A,g.size[0]*w.toScale,t.transform.tileZoom),g.size[1]])):s.uniform1f(d.u_ratio,L);for(var O=0;O<S.length;O++){var R=S[O];R.vaos[r.id].bind(s,d,R.layoutVertexBuffer,R.elementBuffer),s.drawElements(s.TRIANGLES,3*R.elementBuffer.length,s.UNSIGNED_SHORT,0)}}}}}}}},{\"../source/pixels_to_tile_units\":362,\"../util/browser\":425,\"gl-matrix\":192}],350:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=t.gl;a.enable(a.DEPTH_TEST),t.depthMask(!0),a.depthFunc(a.LESS);for(var o=n.length&&n[0].z,s=0;s<n.length;s++){var l=n[s];t.setDepthSublayer(l.z-o),i(t,e,r,l)}a.depthFunc(a.LEQUAL)}}function i(t,e,r,n){var i=t.gl;i.disable(i.STENCIL_TEST);var u=e.getTile(n),c=t.transform.calculatePosMatrix(n,e.maxzoom),h=t.useProgram(\"raster\");i.uniformMatrix4fv(h.u_matrix,!1,c),i.uniform1f(h.u_brightness_low,r.paint[\"raster-brightness-min\"]),i.uniform1f(h.u_brightness_high,r.paint[\"raster-brightness-max\"]),i.uniform1f(h.u_saturation_factor,s(r.paint[\"raster-saturation\"])),i.uniform1f(h.u_contrast_factor,o(r.paint[\"raster-contrast\"])),i.uniform3fv(h.u_spin_weights,a(r.paint[\"raster-hue-rotate\"]));var f,d,p=u.source&&u.source.findLoadedParent(n,0,{}),m=l(u,p,r,t.transform);i.activeTexture(i.TEXTURE0),i.bindTexture(i.TEXTURE_2D,u.texture),i.activeTexture(i.TEXTURE1),p?(i.bindTexture(i.TEXTURE_2D,p.texture),f=Math.pow(2,p.coord.z-u.coord.z),d=[u.coord.x*f%1,u.coord.y*f%1]):(i.bindTexture(i.TEXTURE_2D,u.texture),m[1]=0),i.uniform2fv(h.u_tl_parent,d||[0,0]),i.uniform1f(h.u_scale_parent,f||1),i.uniform1f(h.u_buffer_scale,1),i.uniform1f(h.u_opacity0,m[0]),i.uniform1f(h.u_opacity1,m[1]),i.uniform1i(h.u_image0,0),i.uniform1i(h.u_image1,1);var v=u.boundsBuffer||t.rasterBoundsBuffer;(u.boundsVAO||t.rasterBoundsVAO).bind(i,h,v),i.drawArrays(i.TRIANGLE_STRIP,0,v.length)}function a(t){t*=Math.PI/180;var e=Math.sin(t),r=Math.cos(t);return[(2*r+1)/3,(-Math.sqrt(3)*e-r+1)/3,(Math.sqrt(3)*e-r+1)/3]}function o(t){return t>0?1/(1-t):1+t}function s(t){return t>0?1-1/(1.001-t):-t}function l(t,e,r,n){var i=[1,0],a=r.paint[\"raster-fade-duration\"];if(t.source&&a>0){var o=(new Date).getTime(),s=(o-t.timeAdded)/a,l=e?(o-e.timeAdded)/a:-1,c=n.coveringZoomLevel(t.source),h=!!e&&Math.abs(e.coord.z-c)>Math.abs(t.coord.z-c);!e||h?(i[0]=u.clamp(s,0,1),i[1]=1-i[0]):(i[0]=u.clamp(1-l,0,1),i[1]=1-i[0])}var f=r.paint[\"raster-opacity\"];return i[0]*=f,i[1]*=f,i}var u=t(\"../util/util\"),c=t(\"../util/struct_array\");e.exports=n,n.RasterBoundsArray=new c({members:[{name:\"a_pos\",type:\"Int16\",components:2},{name:\"a_texture_pos\",type:\"Int16\",components:2}]})},{\"../util/struct_array\":439,\"../util/util\":441}],351:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(!t.isOpaquePass){var a=!(r.layout[\"text-allow-overlap\"]||r.layout[\"icon-allow-overlap\"]||r.layout[\"text-ignore-placement\"]||r.layout[\"icon-ignore-placement\"]),o=t.gl;a?o.disable(o.STENCIL_TEST):o.enable(o.STENCIL_TEST),t.setDepthSublayer(0),t.depthMask(!1),o.disable(o.DEPTH_TEST),i(t,e,r,n,!1,r.paint[\"icon-translate\"],r.paint[\"icon-translate-anchor\"],r.layout[\"icon-rotation-alignment\"],r.layout[\"icon-rotation-alignment\"],r.layout[\"icon-size\"],r.paint[\"icon-halo-width\"],r.paint[\"icon-halo-color\"],r.paint[\"icon-halo-blur\"],r.paint[\"icon-opacity\"],r.paint[\"icon-color\"]),\n",
       "i(t,e,r,n,!0,r.paint[\"text-translate\"],r.paint[\"text-translate-anchor\"],r.layout[\"text-rotation-alignment\"],r.layout[\"text-pitch-alignment\"],r.layout[\"text-size\"],r.paint[\"text-halo-width\"],r.paint[\"text-halo-color\"],r.paint[\"text-halo-blur\"],r.paint[\"text-opacity\"],r.paint[\"text-color\"]),o.enable(o.DEPTH_TEST),e.map.showCollisionBoxes&&s(t,e,r,n)}}function i(t,e,r,n,i,o,s,l,u,c,h,f,d,p,m){for(var v=0;v<n.length;v++){var g=e.getTile(n[v]),y=g.getBucket(r);if(y){var b=y.bufferGroups,x=i?b.glyph:b.icon;x.length&&(t.enableTileClippingMask(n[v]),a(t,r,n[v].posMatrix,g,y,x,i,i||y.sdfIcons,!i&&y.iconsNeedLinear,i?y.adjustedTextSize:y.adjustedIconSize,y.fontstack,o,s,l,u,c,h,f,d,p,m))}}}function a(t,e,r,n,i,a,s,u,c,h,f,d,p,m,v,g,y,b,x,_,w){var M,k,A,T=t.gl,S=t.transform,E=\"map\"===m,L=\"map\"===v,C=s?24:1,z=g/C;if(L?(k=l(n,1,t.transform.zoom)*z,A=1/Math.cos(S._pitch),M=[k,k]):(k=t.transform.altitude*z,A=1,M=[S.pixelsToGLUnits[0]*k,S.pixelsToGLUnits[1]*k]),s||t.style.sprite.loaded()){var I=t.useProgram(u?\"sdf\":\"icon\");if(T.uniformMatrix4fv(I.u_matrix,!1,t.translatePosMatrix(r,n,d,p)),T.uniform1i(I.u_rotate_with_map,E),T.uniform1i(I.u_pitch_with_map,L),T.uniform2fv(I.u_extrude_scale,M),T.activeTexture(T.TEXTURE0),T.uniform1i(I.u_texture,0),s){var D=f&&t.glyphSource.getGlyphAtlas(f);if(!D)return;D.updateTexture(T),T.uniform2f(I.u_texsize,D.width/4,D.height/4)}else{var P=t.options.rotating||t.options.zooming,O=1!==z||o.devicePixelRatio!==t.spriteAtlas.pixelRatio||c,R=L||t.transform.pitch;t.spriteAtlas.bind(T,u||P||O||R),T.uniform2f(I.u_texsize,t.spriteAtlas.width/4,t.spriteAtlas.height/4)}var F=Math.log(g/h)/Math.LN2||0;T.uniform1f(I.u_zoom,10*(t.transform.zoom-F)),T.activeTexture(T.TEXTURE1),t.frameHistory.bind(T),T.uniform1i(I.u_fadetexture,1);var j;if(u){var N=.105*C/g/o.devicePixelRatio;if(y){T.uniform1f(I.u_gamma,(1.19*x/z/8+N)*A),T.uniform4fv(I.u_color,b),T.uniform1f(I.u_opacity,_),T.uniform1f(I.u_buffer,(6-y/z)/8);for(var B=0;B<a.length;B++)j=a[B],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}T.uniform1f(I.u_gamma,N*A),T.uniform4fv(I.u_color,w),T.uniform1f(I.u_opacity,_),T.uniform1f(I.u_buffer,.75),T.uniform1f(I.u_pitch,S.pitch/360*2*Math.PI),T.uniform1f(I.u_bearing,S.bearing/360*2*Math.PI),T.uniform1f(I.u_aspect_ratio,S.width/S.height);for(var U=0;U<a.length;U++)j=a[U],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}else{T.uniform1f(I.u_opacity,_);for(var V=0;V<a.length;V++)j=a[V],j.vaos[e.id].bind(T,I,j.layoutVertexBuffer,j.elementBuffer),T.drawElements(T.TRIANGLES,3*j.elementBuffer.length,T.UNSIGNED_SHORT,0)}}}var o=t(\"../util/browser\"),s=t(\"./draw_collision_debug\"),l=t(\"../source/pixels_to_tile_units\");e.exports=n},{\"../source/pixels_to_tile_units\":362,\"../util/browser\":425,\"./draw_collision_debug\":346}],352:[function(t,e,r){\"use strict\";function n(){this.changeTimes=new Float64Array(256),this.changeOpacities=new Uint8Array(256),this.opacities=new Uint8ClampedArray(256),this.array=new Uint8Array(this.opacities.buffer),this.fadeDuration=300,this.previousZoom=0,this.firstFrame=!0}e.exports=n,n.prototype.record=function(t){var e=Date.now();this.firstFrame&&(e=0,this.firstFrame=!1),t=Math.floor(10*t);var r;if(t<this.previousZoom)for(r=t+1;r<=this.previousZoom;r++)this.changeTimes[r]=e,this.changeOpacities[r]=this.opacities[r];else for(r=t;r>this.previousZoom;r--)this.changeTimes[r]=e,this.changeOpacities[r]=this.opacities[r];for(r=0;r<256;r++){var n=e-this.changeTimes[r],i=n/this.fadeDuration*255;this.opacities[r]=r<=t?this.changeOpacities[r]+i:this.changeOpacities[r]-i}this.changed=!0,this.previousZoom=t},n.prototype.bind=function(t){this.texture?(t.bindTexture(t.TEXTURE_2D,this.texture),this.changed&&(t.texSubImage2D(t.TEXTURE_2D,0,0,0,256,1,t.ALPHA,t.UNSIGNED_BYTE,this.array),this.changed=!1)):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.NEAREST),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.NEAREST),t.texImage2D(t.TEXTURE_2D,0,t.ALPHA,256,1,0,t.ALPHA,t.UNSIGNED_BYTE,this.array))}},{}],353:[function(t,e,r){\"use strict\";function n(t,e){this.width=t,this.height=e,this.nextRow=0,this.bytes=4,this.data=new Uint8Array(this.width*this.height*this.bytes),this.positions={}}var i=t(\"../util/util\");e.exports=n,n.prototype.setSprite=function(t){this.sprite=t},n.prototype.getDash=function(t,e){var r=t.join(\",\")+e;return this.positions[r]||(this.positions[r]=this.addDash(t,e)),this.positions[r]},n.prototype.addDash=function(t,e){var r=e?7:0,n=2*r+1;if(this.nextRow+n>this.height)return i.warnOnce(\"LineAtlas out of space\"),null;for(var a=0,o=0;o<t.length;o++)a+=t[o];for(var s=this.width/a,l=s/2,u=t.length%2==1,c=-r;c<=r;c++)for(var h=this.nextRow+r+c,f=this.width*h,d=u?-t[t.length-1]:0,p=t[0],m=1,v=0;v<this.width;v++){for(;p<v/s;)d=p,p+=t[m],u&&m===t.length-1&&(p+=t[0]),m++;var g,y=Math.abs(v-d*s),b=Math.abs(v-p*s),x=Math.min(y,b),_=m%2==1;if(e){var w=r?c/r*(l+1):0;if(_){var M=l-Math.abs(w);g=Math.sqrt(x*x+M*M)}else g=l-Math.sqrt(x*x+w*w)}else g=(_?1:-1)*x;this.data[3+4*(f+v)]=Math.max(0,Math.min(255,g+128))}var k={y:(this.nextRow+r+.5)/this.height,height:2*r/this.height,width:a};return this.nextRow+=n,this.dirty=!0,k},n.prototype.bind=function(t){this.texture?(t.bindTexture(t.TEXTURE_2D,this.texture),this.dirty&&(this.dirty=!1,t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width,this.height,t.RGBA,t.UNSIGNED_BYTE,this.data))):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.REPEAT),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.REPEAT),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,this.width,this.height,0,t.RGBA,t.UNSIGNED_BYTE,this.data))}},{\"../util/util\":441}],354:[function(t,e,r){\"use strict\";function n(t,e){this.gl=t,this.transform=e,this.reusableTextures={},this.preFbos={},this.frameHistory=new o,this.setup(),this.numSublayers=s.maxUnderzooming+s.maxOverzooming+1,this.depthEpsilon=1/Math.pow(2,16),this.lineWidthRange=t.getParameter(t.ALIASED_LINE_WIDTH_RANGE)}var i=t(\"../util/browser\"),a=t(\"gl-matrix\").mat4,o=t(\"./frame_history\"),s=t(\"../source/source_cache\"),l=t(\"../data/bucket\").EXTENT,u=t(\"../source/pixels_to_tile_units\"),c=t(\"../util/util\"),h=t(\"../util/struct_array\"),f=t(\"../data/buffer\"),d=t(\"./vertex_array_object\"),p=t(\"./draw_raster\").RasterBoundsArray,m=t(\"./create_uniform_pragmas\");e.exports=n,c.extend(n.prototype,t(\"./painter/use_program\")),n.prototype.resize=function(t,e){var r=this.gl;this.width=t*i.devicePixelRatio,this.height=e*i.devicePixelRatio,r.viewport(0,0,this.width,this.height)},n.prototype.setup=function(){var t=this.gl;t.verbose=!0,t.enable(t.BLEND),t.blendFunc(t.ONE,t.ONE_MINUS_SRC_ALPHA),t.enable(t.STENCIL_TEST),t.enable(t.DEPTH_TEST),t.depthFunc(t.LEQUAL),this._depthMask=!1,t.depthMask(!1);var e=this.PosArray=new h({members:[{name:\"a_pos\",type:\"Int16\",components:2}]}),r=new e;r.emplaceBack(0,0),r.emplaceBack(l,0),r.emplaceBack(0,l),r.emplaceBack(l,l),this.tileExtentBuffer=new f(r.serialize(),e.serialize(),f.BufferType.VERTEX),this.tileExtentVAO=new d,this.tileExtentPatternVAO=new d;var n=new e;n.emplaceBack(0,0),n.emplaceBack(l,0),n.emplaceBack(l,l),n.emplaceBack(0,l),n.emplaceBack(0,0),this.debugBuffer=new f(n.serialize(),e.serialize(),f.BufferType.VERTEX),this.debugVAO=new d;var i=new p;i.emplaceBack(0,0,0,0),i.emplaceBack(l,0,32767,0),i.emplaceBack(0,l,0,32767),i.emplaceBack(l,l,32767,32767),this.rasterBoundsBuffer=new f(i.serialize(),p.serialize(),f.BufferType.VERTEX),this.rasterBoundsVAO=new d},n.prototype.clearColor=function(){var t=this.gl;t.clearColor(0,0,0,0),t.clear(t.COLOR_BUFFER_BIT)},n.prototype.clearStencil=function(){var t=this.gl;t.clearStencil(0),t.stencilMask(255),t.clear(t.STENCIL_BUFFER_BIT)},n.prototype.clearDepth=function(){var t=this.gl;t.clearDepth(1),this.depthMask(!0),t.clear(t.DEPTH_BUFFER_BIT)},n.prototype._renderTileClippingMasks=function(t){var e=this.gl;e.colorMask(!1,!1,!1,!1),this.depthMask(!1),e.disable(e.DEPTH_TEST),e.enable(e.STENCIL_TEST),e.stencilMask(248),e.stencilOp(e.KEEP,e.KEEP,e.REPLACE);var r=1;this._tileClippingMaskIDs={};for(var n=0;n<t.length;n++){var i=t[n],a=this._tileClippingMaskIDs[i.id]=r++<<3;e.stencilFunc(e.ALWAYS,a,248);var o=m([{name:\"u_color\",components:4},{name:\"u_opacity\",components:1}]),s=this.useProgram(\"fill\",[],o,o);e.uniformMatrix4fv(s.u_matrix,!1,i.posMatrix),this.tileExtentVAO.bind(e,s,this.tileExtentBuffer),e.drawArrays(e.TRIANGLE_STRIP,0,this.tileExtentBuffer.length)}e.stencilMask(0),e.colorMask(!0,!0,!0,!0),this.depthMask(!0),e.enable(e.DEPTH_TEST)},n.prototype.enableTileClippingMask=function(t){var e=this.gl;e.stencilFunc(e.EQUAL,this._tileClippingMaskIDs[t.id],248)},n.prototype.prepareBuffers=function(){},n.prototype.bindDefaultFramebuffer=function(){var t=this.gl;t.bindFramebuffer(t.FRAMEBUFFER,null)};var v={symbol:t(\"./draw_symbol\"),circle:t(\"./draw_circle\"),line:t(\"./draw_line\"),fill:t(\"./draw_fill\"),raster:t(\"./draw_raster\"),background:t(\"./draw_background\"),debug:t(\"./draw_debug\")};n.prototype.render=function(t,e){this.style=t,this.options=e,this.lineAtlas=t.lineAtlas,this.spriteAtlas=t.spriteAtlas,this.spriteAtlas.setSprite(t.sprite),this.glyphSource=t.glyphSource,this.frameHistory.record(this.transform.zoom),this.prepareBuffers(),this.clearColor(),this.clearDepth(),this.showOverdrawInspector(e.showOverdrawInspector),this.depthRange=(t._order.length+2)*this.numSublayers*this.depthEpsilon,this.renderPass({isOpaquePass:!0}),this.renderPass({isOpaquePass:!1})},n.prototype.renderPass=function(t){var e=this.style._groups,r=t.isOpaquePass;this.currentLayer=r?this.style._order.length:-1;for(var n=0;n<e.length;n++){var i,a=e[r?e.length-1-n:n],o=this.style.sources[a.source],s=[];if(o){for(s=o.getVisibleCoordinates(),i=0;i<s.length;i++)s[i].posMatrix=this.transform.calculatePosMatrix(s[i],o.maxzoom);this.clearStencil(),o.prepare&&o.prepare(),o.isTileClipped&&this._renderTileClippingMasks(s)}for(r?(this._showOverdrawInspector||this.gl.disable(this.gl.BLEND),this.isOpaquePass=!0):(this.gl.enable(this.gl.BLEND),this.isOpaquePass=!1,s.reverse()),i=0;i<a.length;i++){var l=a[r?a.length-1-i:i];this.currentLayer+=r?-1:1,this.renderLayer(this,o,l,s)}o&&v.debug(this,o,s)}},n.prototype.depthMask=function(t){t!==this._depthMask&&(this._depthMask=t,this.gl.depthMask(t))},n.prototype.renderLayer=function(t,e,r,n){r.isHidden(this.transform.zoom)||(\"background\"===r.type||n.length)&&(this.id=r.id,v[r.type](t,e,r,n))},n.prototype.setDepthSublayer=function(t){var e=1-((1+this.currentLayer)*this.numSublayers+t)*this.depthEpsilon,r=e-1+this.depthRange;this.gl.depthRange(r,e)},n.prototype.translatePosMatrix=function(t,e,r,n){if(!r[0]&&!r[1])return t;if(\"viewport\"===n){var i=Math.sin(-this.transform.angle),o=Math.cos(-this.transform.angle);r=[r[0]*o-r[1]*i,r[0]*i+r[1]*o]}var s=[u(e,r[0],this.transform.zoom),u(e,r[1],this.transform.zoom),0],l=new Float32Array(16);return a.translate(l,t,s),l},n.prototype.saveTexture=function(t){var e=this.reusableTextures[t.size];e?e.push(t):this.reusableTextures[t.size]=[t]},n.prototype.getTexture=function(t){var e=this.reusableTextures[t];return e&&e.length>0?e.pop():null},n.prototype.lineWidth=function(t){this.gl.lineWidth(c.clamp(t,this.lineWidthRange[0],this.lineWidthRange[1]))},n.prototype.showOverdrawInspector=function(t){if(t||this._showOverdrawInspector){this._showOverdrawInspector=t;var e=this.gl;if(t){e.blendFunc(e.CONSTANT_COLOR,e.ONE);e.blendColor(1/8,1/8,1/8,0),e.clearColor(0,0,0,1),e.clear(e.COLOR_BUFFER_BIT)}else e.blendFunc(e.ONE,e.ONE_MINUS_SRC_ALPHA)}}},{\"../data/bucket\":328,\"../data/buffer\":333,\"../source/pixels_to_tile_units\":362,\"../source/source_cache\":366,\"../util/browser\":425,\"../util/struct_array\":439,\"../util/util\":441,\"./create_uniform_pragmas\":343,\"./draw_background\":344,\"./draw_circle\":345,\"./draw_debug\":347,\"./draw_fill\":348,\"./draw_line\":349,\"./draw_raster\":350,\"./draw_symbol\":351,\"./frame_history\":352,\"./painter/use_program\":355,\"./vertex_array_object\":356,\"gl-matrix\":192}],355:[function(t,e,r){\"use strict\";function n(t,e){return t.replace(/#pragma mapbox: ([\\w]+) ([\\w]+) ([\\w]+) ([\\w]+)/g,function(t,r,n,i,a){return e[r][a].replace(/{type}/g,i).replace(/{precision}/g,n)})}var i=t(\"assert\"),a=t(\"../../util/util\"),o=t(\"mapbox-gl-shaders\"),s=o.util;e.exports._createProgram=function(t,e,r,l){for(var u=this.gl,c=u.createProgram(),h=o[t],f=\"#define MAPBOX_GL_JS;\\n\",d=0;d<e.length;d++)f+=\"#define \"+e[d]+\";\\n\";var p=u.createShader(u.FRAGMENT_SHADER);u.shaderSource(p,n(f+h.fragmentSource,l)),u.compileShader(p),i(u.getShaderParameter(p,u.COMPILE_STATUS),u.getShaderInfoLog(p)),u.attachShader(c,p);var m=u.createShader(u.VERTEX_SHADER);u.shaderSource(m,n(f+s+h.vertexSource,r)),u.compileShader(m),i(u.getShaderParameter(m,u.COMPILE_STATUS),u.getShaderInfoLog(m)),u.attachShader(c,m),u.linkProgram(c),i(u.getProgramParameter(c,u.LINK_STATUS),u.getProgramInfoLog(c));for(var v={},g=u.getProgramParameter(c,u.ACTIVE_ATTRIBUTES),y=0;y<g;y++){var b=u.getActiveAttrib(c,y);v[b.name]=u.getAttribLocation(c,b.name)}for(var x={},_=u.getProgramParameter(c,u.ACTIVE_UNIFORMS),w=0;w<_;w++){var M=u.getActiveUniform(c,w);x[M.name]=u.getUniformLocation(c,M.name)}return a.extend({program:c,definition:h,attributes:v,numAttributes:g},v,x)},e.exports._createProgramCached=function(t,e,r,n){this.cache=this.cache||{};var i=JSON.stringify({name:t,defines:e,vertexPragmas:r,fragmentPragmas:n});return this.cache[i]||(this.cache[i]=this._createProgram(t,e,r,n)),this.cache[i]},e.exports.useProgram=function(t,e,r,n){var i=this.gl;e=e||[],this._showOverdrawInspector&&(e=e.concat(\"OVERDRAW_INSPECTOR\"));var a=this._createProgramCached(t,e,r,n);return this.currentProgram!==a&&(i.useProgram(a.program),this.currentProgram=a),a}},{\"../../util/util\":441,assert:46,\"mapbox-gl-shaders\":302}],356:[function(t,e,r){\"use strict\";function n(){this.boundProgram=null,this.boundVertexBuffer=null,this.boundVertexBuffer2=null,this.boundElementBuffer=null,this.vao=null}var i=t(\"assert\");e.exports=n,n.prototype.bind=function(t,e,r,n,i){void 0===t.extVertexArrayObject&&(t.extVertexArrayObject=t.getExtension(\"OES_vertex_array_object\"));var a=!this.vao||this.boundProgram!==e||this.boundVertexBuffer!==r||this.boundVertexBuffer2!==i||this.boundElementBuffer!==n;!t.extVertexArrayObject||a?this.freshBind(t,e,r,n,i):t.extVertexArrayObject.bindVertexArrayOES(this.vao)},n.prototype.freshBind=function(t,e,r,n,a){var o,s=e.numAttributes;if(t.extVertexArrayObject)this.vao&&this.destroy(t),this.vao=t.extVertexArrayObject.createVertexArrayOES(),t.extVertexArrayObject.bindVertexArrayOES(this.vao),o=0,this.boundProgram=e,this.boundVertexBuffer=r,this.boundVertexBuffer2=a,this.boundElementBuffer=n;else{o=t.currentNumAttributes||0;for(var l=s;l<o;l++)i(0!==l),t.disableVertexAttribArray(l)}for(var u=o;u<s;u++)t.enableVertexAttribArray(u);r.bind(t),r.setVertexAttribPointers(t,e),a&&(a.bind(t),a.setVertexAttribPointers(t,e)),n&&n.bind(t),t.currentNumAttributes=s},n.prototype.unbind=function(t){var e=t.extVertexArrayObject;e&&e.bindVertexArrayOES(null)},n.prototype.destroy=function(t){var e=t.extVertexArrayObject;e&&this.vao&&(e.deleteVertexArrayOES(this.vao),this.vao=null)}},{assert:46}],357:[function(t,e,r){\"use strict\";function n(t,e,r){e=e||{},this.id=t,this.dispatcher=r,this._data=e.data,void 0!==e.maxzoom&&(this.maxzoom=e.maxzoom),e.type&&(this.type=e.type);var n=s/this.tileSize;this.workerOptions=a.extend({source:this.id,cluster:e.cluster||!1,geojsonVtOptions:{buffer:(void 0!==e.buffer?e.buffer:128)*n,tolerance:(void 0!==e.tolerance?e.tolerance:.375)*n,extent:s,maxZoom:this.maxzoom},superclusterOptions:{maxZoom:Math.min(e.clusterMaxZoom,this.maxzoom-1)||this.maxzoom-1,extent:s,radius:(e.clusterRadius||50)*n,log:!1}},e.workerOptions),this._updateWorkerData(function(t){if(t)return void this.fire(\"error\",{error:t});this.fire(\"load\")}.bind(this))}var i=t(\"../util/evented\"),a=t(\"../util/util\"),o=t(\"resolve-url\"),s=t(\"../data/bucket\").EXTENT;e.exports=n,n.prototype=a.inherit(i,{type:\"geojson\",minzoom:0,maxzoom:18,tileSize:512,isTileClipped:!0,reparseOverscaled:!0,onAdd:function(t){this.map=t},setData:function(t){return this._data=t,this._updateWorkerData(function(t){if(t)return this.fire(\"error\",{error:t});this.fire(\"change\")}.bind(this)),this},_updateWorkerData:function(t){var e=a.extend({},this.workerOptions),r=this._data;\"string\"==typeof r?e.url=\"undefined\"!=typeof window?o(window.location.href,r):r:e.data=JSON.stringify(r),this.workerID=this.dispatcher.send(this.type+\".loadData\",e,function(e){this._loaded=!0,t(e)}.bind(this))},loadTile:function(t,e){var r=t.coord.z>this.maxzoom?Math.pow(2,t.coord.z-this.maxzoom):1,n={type:this.type,uid:t.uid,coord:t.coord,zoom:t.coord.z,maxZoom:this.maxzoom,tileSize:this.tileSize,source:this.id,overscaling:r,angle:this.map.transform.angle,pitch:this.map.transform.pitch,showCollisionBoxes:this.map.showCollisionBoxes};t.workerID=this.dispatcher.send(\"load tile\",n,function(r,n){if(t.unloadVectorData(this.map.painter),!t.aborted)return r?e(r):(t.loadVectorData(n,this.map.style),t.redoWhenDone&&(t.redoWhenDone=!1,t.redoPlacement(this)),e(null))}.bind(this),this.workerID)},abortTile:function(t){t.aborted=!0},unloadTile:function(t){t.unloadVectorData(this.map.painter),this.dispatcher.send(\"remove tile\",{uid:t.uid,source:this.id},function(){},t.workerID)},serialize:function(){return{type:this.type,data:this._data}}})},{\"../data/bucket\":328,\"../util/evented\":433,\"../util/util\":441,\"resolve-url\":500}],358:[function(t,e,r){\"use strict\";function n(t,e,r){r&&(this.loadGeoJSON=r),h.call(this,t,e)}var i=t(\"../util/util\"),a=t(\"../util/ajax\"),o=t(\"geojson-rewind\"),s=t(\"./geojson_wrapper\"),l=t(\"vt-pbf\"),u=t(\"supercluster\"),c=t(\"geojson-vt\"),h=t(\"./vector_tile_worker_source\");e.exports=n,n.prototype=i.inherit(h,{_geoJSONIndexes:{},loadVectorData:function(t,e){var r=t.source,n=t.coord;if(!this._geoJSONIndexes[r])return e(null,null);var i=this._geoJSONIndexes[r].getTile(Math.min(n.z,t.maxZoom),n.x,n.y);if(!i)return e(null,null);var a=new s(i.features);a.name=\"_geojsonTileLayer\";var o=l({layers:{_geojsonTileLayer:a}});0===o.byteOffset&&o.byteLength===o.buffer.byteLength||(o=new Uint8Array(o)),e(null,{tile:a,rawTileData:o.buffer})},loadData:function(t,e){var r=function(r,n){return r?e(r):\"object\"!=typeof n?e(new Error(\"Input data is not a valid GeoJSON object.\")):(o(n,!0),void this._indexData(n,t,function(r,n){if(r)return e(r);this._geoJSONIndexes[t.source]=n,e(null)}.bind(this)))}.bind(this);this.loadGeoJSON(t,r)},loadGeoJSON:function(t,e){if(t.url)a.getJSON(t.url,e);else{if(\"string\"!=typeof t.data)return e(new Error(\"Input data is not a valid GeoJSON object.\"));try{return e(null,JSON.parse(t.data))}catch(t){return e(new Error(\"Input data is not a valid GeoJSON object.\"))}}},_indexData:function(t,e,r){try{e.cluster?r(null,u(e.superclusterOptions).load(t.features)):r(null,c(t,e.geojsonVtOptions))}catch(t){return r(t)}}})},{\"../util/ajax\":424,\"../util/util\":441,\"./geojson_wrapper\":359,\"./vector_tile_worker_source\":370,\"geojson-rewind\":137,\"geojson-vt\":141,supercluster:528,\"vt-pbf\":555}],359:[function(t,e,r){\"use strict\";function n(t){this.features=t,this.length=t.length,this.extent=s}function i(t){if(this.type=t.type,1===t.type){this.rawGeometry=[];for(var e=0;e<t.geometry.length;e++)this.rawGeometry.push([t.geometry[e]])}else this.rawGeometry=t.geometry;this.properties=t.tags,this.extent=s}var a=t(\"point-geometry\"),o=t(\"vector-tile\").VectorTileFeature,s=t(\"../data/bucket\").EXTENT;e.exports=n,n.prototype.feature=function(t){return new i(this.features[t])},i.prototype.loadGeometry=function(){var t=this.rawGeometry;this.geometry=[];for(var e=0;e<t.length;e++){for(var r=t[e],n=[],i=0;i<r.length;i++)n.push(new a(r[i][0],r[i][1]));this.geometry.push(n)}return this.geometry},i.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var t=this.geometry,e=1/0,r=-1/0,n=1/0,i=-1/0,a=0;a<t.length;a++)for(var o=t[a],s=0;s<o.length;s++){var l=o[s];e=Math.min(e,l.x),r=Math.max(r,l.x),n=Math.min(n,l.y),i=Math.max(i,l.y)}return[e,n,r,i]},i.prototype.toGeoJSON=o.prototype.toGeoJSON},{\"../data/bucket\":328,\"point-geometry\":483,\"vector-tile\":549}],360:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r,this.url=e.url,this.coordinates=e.coordinates,u.getImage(e.url,function(t,r){if(t)return this.fire(\"error\",{error:t});this.image=r,this.image.addEventListener(\"load\",function(){this.map._rerender()}.bind(this)),this._loaded=!0,this.fire(\"load\"),this.map&&this.setCoordinates(e.coordinates)}.bind(this))}var i=t(\"../util/util\"),a=t(\"./tile_coord\"),o=t(\"../geo/lng_lat\"),s=t(\"point-geometry\"),l=t(\"../util/evented\"),u=t(\"../util/ajax\"),c=t(\"../data/bucket\").EXTENT,h=t(\"../render/draw_raster\").RasterBoundsArray,f=t(\"../data/buffer\"),d=t(\"../render/vertex_array_object\");e.exports=n,n.prototype=i.inherit(l,{minzoom:0,maxzoom:22,tileSize:512,onAdd:function(t){this.map=t,this.image&&this.setCoordinates(this.coordinates)},setCoordinates:function(t){this.coordinates=t;var e=this.map,r=t.map(function(t){return e.transform.locationCoordinate(o.convert(t)).zoomTo(0)}),n=this.centerCoord=i.getCoordinatesCenter(r);return n.column=Math.round(n.column),n.row=Math.round(n.row),this.minzoom=this.maxzoom=n.zoom,this._coord=new a(n.zoom,n.column,n.row),this._tileCoords=r.map(function(t){var e=t.zoomTo(n.zoom);return new s(Math.round((e.column-n.column)*c),Math.round((e.row-n.row)*c))}),this.fire(\"change\"),this},_setTile:function(t){this._prepared=!1,this.tile=t;var e=new h;e.emplaceBack(this._tileCoords[0].x,this._tileCoords[0].y,0,0),e.emplaceBack(this._tileCoords[1].x,this._tileCoords[1].y,32767,0),e.emplaceBack(this._tileCoords[3].x,this._tileCoords[3].y,0,32767),e.emplaceBack(this._tileCoords[2].x,this._tileCoords[2].y,32767,32767),this.tile.buckets={},this.tile.boundsBuffer=new f(e.serialize(),h.serialize(),f.BufferType.VERTEX),this.tile.boundsVAO=new d,this.tile.state=\"loaded\"},prepare:function(){if(this._loaded&&this.image&&this.image.complete&&this.tile){var t=this.map.painter,e=t.gl;this._prepared?(e.bindTexture(e.TEXTURE_2D,this.tile.texture),e.texSubImage2D(e.TEXTURE_2D,0,0,0,e.RGBA,e.UNSIGNED_BYTE,this.image)):(this.tile.texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this.tile.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.CLAMP_TO_EDGE),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texImage2D(e.TEXTURE_2D,0,e.RGBA,e.RGBA,e.UNSIGNED_BYTE,this.image))}},loadTile:function(t,e){this._coord&&this._coord.toString()===t.coord.toString()?(this._setTile(t),e(null)):(t.state=\"errored\",e(null))},serialize:function(){return{type:\"image\",urls:this.url,coordinates:this.coordinates}}})},{\"../data/bucket\":328,\"../data/buffer\":333,\"../geo/lng_lat\":338,\"../render/draw_raster\":350,\"../render/vertex_array_object\":356,\"../util/ajax\":424,\"../util/evented\":433,\"../util/util\":441,\"./tile_coord\":368,\"point-geometry\":483}],361:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i=t(\"../util/ajax\"),a=t(\"../util/browser\"),o=t(\"../util/mapbox\").normalizeSourceURL;e.exports=function(t,e){var r=function(t,r){if(t)return e(t);var i=n.pick(r,[\"tiles\",\"minzoom\",\"maxzoom\",\"attribution\"]);r.vector_layers&&(i.vectorLayers=r.vector_layers,i.vectorLayerIds=i.vectorLayers.map(function(t){return t.id})),e(null,i)};t.url?i.getJSON(o(t.url),r):a.frame(r.bind(null,null,t))}},{\"../util/ajax\":424,\"../util/browser\":425,\"../util/mapbox\":438,\"../util/util\":441}],362:[function(t,e,r){\"use strict\";var n=t(\"../data/bucket\");e.exports=function(t,e,r){return e*(n.EXTENT/(t.tileSize*Math.pow(2,r-t.coord.z)))}},{\"../data/bucket\":328}],363:[function(t,e,r){\"use strict\";function n(t,e){var r=t.coord,n=e.coord;return r.z-n.z||r.y-n.y||r.w-n.w||r.x-n.x}function i(t){for(var e=t[0]||{},r=1;r<t.length;r++){var n=t[r];for(var i in n){var a=n[i],o=e[i];if(void 0===o)o=e[i]=a;else for(var s=0;s<a.length;s++)o.push(a[s])}}return e}var a=t(\"./tile_coord\");r.rendered=function(t,e,r,a,o,s){var l=t.tilesIn(r);l.sort(n);for(var u=[],c=0;c<l.length;c++){var h=l[c];h.tile.featureIndex&&u.push(h.tile.featureIndex.query({queryGeometry:h.queryGeometry,scale:h.scale,tileSize:h.tile.tileSize,bearing:s,params:a},e))}return i(u)},r.source=function(t,e){for(var r=t.getRenderableIds().map(function(e){return t.getTileByID(e)}),n=[],i={},o=0;o<r.length;o++){var s=r[o],l=new a(Math.min(s.sourceMaxZoom,s.coord.z),s.coord.x,s.coord.y,0).id;i[l]||(i[l]=!0,s.querySourceFeatures(n,e))}return n}},{\"./tile_coord\":368}],364:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r,i.extend(this,i.pick(e,[\"url\",\"scheme\",\"tileSize\"])),s(e,function(t,e){if(t)return this.fire(\"error\",t);i.extend(this,e),this.fire(\"load\")}.bind(this))}var i=t(\"../util/util\"),a=t(\"../util/ajax\"),o=t(\"../util/evented\"),s=t(\"./load_tilejson\"),l=t(\"../util/mapbox\").normalizeTileURL;e.exports=n,n.prototype=i.inherit(o,{minzoom:0,maxzoom:22,roundZoom:!0,scheme:\"xyz\",tileSize:512,_loaded:!1,onAdd:function(t){this.map=t},serialize:function(){return{type:\"raster\",url:this.url,tileSize:this.tileSize}},loadTile:function(t,e){function r(r,n){if(delete t.request,!t.aborted){if(r)return e(r);var i=this.map.painter.gl;t.texture=this.map.painter.getTexture(n.width),t.texture?(i.bindTexture(i.TEXTURE_2D,t.texture),i.texSubImage2D(i.TEXTURE_2D,0,0,0,i.RGBA,i.UNSIGNED_BYTE,n)):(t.texture=i.createTexture(),i.bindTexture(i.TEXTURE_2D,t.texture),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,i.LINEAR_MIPMAP_NEAREST),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,i.LINEAR),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,i.CLAMP_TO_EDGE),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,i.CLAMP_TO_EDGE),i.pixelStorei(i.UNPACK_PREMULTIPLY_ALPHA_WEBGL,!0),i.texImage2D(i.TEXTURE_2D,0,i.RGBA,i.RGBA,i.UNSIGNED_BYTE,n),t.texture.size=n.width),i.generateMipmap(i.TEXTURE_2D),this.map.animationLoop.set(this.map.style.rasterFadeDuration),t.state=\"loaded\",e(null)}}var n=l(t.coord.url(this.tiles,null,this.scheme),this.url,this.tileSize);t.request=a.getImage(n,r.bind(this))},abortTile:function(t){t.request&&(t.request.abort(),delete t.request)},unloadTile:function(t){t.texture&&this.map.painter.saveTexture(t.texture)}})},{\"../util/ajax\":424,\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./load_tilejson\":361}],365:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i={vector:t(\"../source/vector_tile_source\"),raster:t(\"../source/raster_tile_source\"),geojson:t(\"../source/geojson_source\"),video:t(\"../source/video_source\"),image:t(\"../source/image_source\")};r.create=function(t,e,r){if(e=new i[e.type](t,e,r),e.id!==t)throw new Error(\"Expected Source id to be \"+t+\" instead of \"+e.id);return n.bindAll([\"load\",\"abort\",\"unload\",\"serialize\",\"prepare\"],e),e},r.getType=function(t){return i[t]},r.setType=function(t,e){i[t]=e}},{\"../source/geojson_source\":357,\"../source/image_source\":360,\"../source/raster_tile_source\":364,\"../source/vector_tile_source\":369,\"../source/video_source\":371,\"../util/util\":441}],366:[function(t,e,r){\"use strict\";function n(t,e,r){this.id=t,this.dispatcher=r;var n=this._source=o.create(t,e,r).on(\"load\",function(){this.map&&this._source.onAdd&&this._source.onAdd(this.map),this._sourceLoaded=!0,this.tileSize=n.tileSize,this.minzoom=n.minzoom,this.maxzoom=n.maxzoom,this.roundZoom=n.roundZoom,this.reparseOverscaled=n.reparseOverscaled,this.isTileClipped=n.isTileClipped,this.attribution=n.attribution,this.vectorLayerIds=n.vectorLayerIds,this.fire(\"load\")}.bind(this)).on(\"error\",function(t){this._sourceErrored=!0,this.fire(\"error\",t)}.bind(this)).on(\"change\",function(){this.reload(),this.transform&&this.update(this.transform,this.map&&this.map.style.rasterFadeDuration),this.fire(\"change\")}.bind(this));this._tiles={},this._cache=new c(0,this.unloadTile.bind(this)),this._isIdRenderable=this._isIdRenderable.bind(this)}function i(t,e,r){var n=r.zoomTo(Math.min(t.z,e));return{x:(n.column-(t.x+t.w*Math.pow(2,t.z)))*d,y:(n.row-t.y)*d}}function a(t,e){return t%32-e%32}var o=t(\"./source\"),s=t(\"./tile\"),l=t(\"../util/evented\"),u=t(\"./tile_coord\"),c=t(\"../util/lru_cache\"),h=t(\"../geo/coordinate\"),f=t(\"../util/util\"),d=t(\"../data/bucket\").EXTENT;e.exports=n,n.maxOverzooming=10,n.maxUnderzooming=3,n.prototype=f.inherit(l,{onAdd:function(t){this.map=t,this._source&&this._source.onAdd&&this._source.onAdd(t)},loaded:function(){if(this._sourceErrored)return!0;if(!this._sourceLoaded)return!1;for(var t in this._tiles){var e=this._tiles[t];if(\"loaded\"!==e.state&&\"errored\"!==e.state)return!1}return!0},getSource:function(){return this._source},loadTile:function(t,e){return this._source.loadTile(t,e)},unloadTile:function(t){if(this._source.unloadTile)return this._source.unloadTile(t)},abortTile:function(t){if(this._source.abortTile)return this._source.abortTile(t)},serialize:function(){return this._source.serialize()},prepare:function(){if(this._sourceLoaded&&this._source.prepare)return this._source.prepare()},getIds:function(){return Object.keys(this._tiles).map(Number).sort(a)},getRenderableIds:function(){return this.getIds().filter(this._isIdRenderable)},_isIdRenderable:function(t){return this._tiles[t].isRenderable()&&!this._coveredTiles[t]},reload:function(){this._cache.reset();for(var t in this._tiles){var e=this._tiles[t];\"loading\"!==e.state&&(e.state=\"reloading\"),this.loadTile(this._tiles[t],this._tileLoaded.bind(this,this._tiles[t]))}},_tileLoaded:function(t,e){if(e)return t.state=\"errored\",this.fire(\"tile.error\",{tile:t,error:e}),void this._source.fire(\"tile.error\",{tile:t,error:e});t.source=this,t.timeAdded=(new Date).getTime(),this.fire(\"tile.load\",{tile:t}),this._source.fire(\"tile.load\",{tile:t})},getTile:function(t){return this.getTileByID(t.id)},getTileByID:function(t){return this._tiles[t]},getZoom:function(t){return t.zoom+t.scaleZoom(t.tileSize/this.tileSize)},findLoadedChildren:function(t,e,r){var n=!1;for(var i in this._tiles){var a=this._tiles[i];if(!(r[i]||!a.isRenderable()||a.coord.z<=t.z||a.coord.z>e)){var o=Math.pow(2,Math.min(a.coord.z,this.maxzoom)-Math.min(t.z,this.maxzoom));if(Math.floor(a.coord.x/o)===t.x&&Math.floor(a.coord.y/o)===t.y)for(r[i]=!0,n=!0;a&&a.coord.z-1>t.z;){var s=a.coord.parent(this.maxzoom).id;a=this._tiles[s],a&&a.isRenderable()&&(delete r[i],r[s]=!0)}}}return n},findLoadedParent:function(t,e,r){for(var n=t.z-1;n>=e;n--){t=t.parent(this.maxzoom);var i=this._tiles[t.id];if(i&&i.isRenderable())return r[t.id]=!0,i;if(this._cache.has(t.id))return this.addTile(t),r[t.id]=!0,this._tiles[t.id]}},updateCacheSize:function(t){var e=Math.ceil(t.width/t.tileSize)+1,r=Math.ceil(t.height/t.tileSize)+1,n=e*r;this._cache.setMaxSize(Math.floor(5*n))},update:function(t,e){if(this._sourceLoaded){var r,i,a;this.updateCacheSize(t);var o=(this.roundZoom?Math.round:Math.floor)(this.getZoom(t)),s=Math.max(o-n.maxOverzooming,this.minzoom),l=Math.max(o+n.maxUnderzooming,this.minzoom),c={},h=(new Date).getTime();this._coveredTiles={};var d=this.used?t.coveringTiles(this._source):[];for(r=0;r<d.length;r++)i=d[r],a=this.addTile(i),c[i.id]=!0,a.isRenderable()||this.findLoadedChildren(i,l,c)||this.findLoadedParent(i,s,c);for(var p={},m=Object.keys(c),v=0;v<m.length;v++){var g=m[v];i=u.fromID(g),a=this._tiles[g],a&&a.timeAdded>h-(e||0)&&(this.findLoadedChildren(i,l,c)&&(c[g]=!0),this.findLoadedParent(i,s,p))}var y;for(y in p)c[y]||(this._coveredTiles[y]=!0);for(y in p)c[y]=!0;var b=f.keysDifference(this._tiles,c);for(r=0;r<b.length;r++)this.removeTile(+b[r]);this.transform=t}},addTile:function(t){var e=this._tiles[t.id];if(e)return e;var r=t.wrapped()\n",
       ";if(e=this._tiles[r.id],e||(e=this._cache.get(r.id))&&this._redoPlacement&&this._redoPlacement(e),!e){var n=t.z,i=n>this.maxzoom?Math.pow(2,n-this.maxzoom):1;e=new s(r,this.tileSize*i,this.maxzoom),this.loadTile(e,this._tileLoaded.bind(this,e))}return e.uses++,this._tiles[t.id]=e,this.fire(\"tile.add\",{tile:e}),this._source.fire(\"tile.add\",{tile:e}),e},removeTile:function(t){var e=this._tiles[t];e&&(e.uses--,delete this._tiles[t],this.fire(\"tile.remove\",{tile:e}),this._source.fire(\"tile.remove\",{tile:e}),e.uses>0||(e.isRenderable()?this._cache.add(e.coord.wrapped().id,e):(e.aborted=!0,this.abortTile(e),this.unloadTile(e))))},clearTiles:function(){for(var t in this._tiles)this.removeTile(t);this._cache.reset()},tilesIn:function(t){for(var e={},r=this.getIds(),n=1/0,a=1/0,o=-1/0,s=-1/0,l=t[0].zoom,c=0;c<t.length;c++){var f=t[c];n=Math.min(n,f.column),a=Math.min(a,f.row),o=Math.max(o,f.column),s=Math.max(s,f.row)}for(var p=0;p<r.length;p++){var m=this._tiles[r[p]],v=u.fromID(r[p]),g=[i(v,m.sourceMaxZoom,new h(n,a,l)),i(v,m.sourceMaxZoom,new h(o,s,l))];if(g[0].x<d&&g[0].y<d&&g[1].x>=0&&g[1].y>=0){for(var y=[],b=0;b<t.length;b++)y.push(i(v,m.sourceMaxZoom,t[b]));var x=e[m.coord.id];void 0===x&&(x=e[m.coord.id]={tile:m,coord:v,queryGeometry:[],scale:Math.pow(2,this.transform.zoom-m.coord.z)}),x.queryGeometry.push(y)}}var _=[];for(var w in e)_.push(e[w]);return _},redoPlacement:function(){for(var t=this.getIds(),e=0;e<t.length;e++){this.getTileByID(t[e]).redoPlacement(this)}},getVisibleCoordinates:function(){return this.getRenderableIds().map(u.fromID)}})},{\"../data/bucket\":328,\"../geo/coordinate\":337,\"../util/evented\":433,\"../util/lru_cache\":437,\"../util/util\":441,\"./source\":365,\"./tile\":367,\"./tile_coord\":368}],367:[function(t,e,r){\"use strict\";function n(t,e,r){this.coord=t,this.uid=a.uniqueId(),this.uses=0,this.tileSize=e,this.sourceMaxZoom=r,this.buckets={},this.state=\"loading\"}function i(t,e){if(e){for(var r={},n=0;n<t.length;n++){var i=e.getLayer(t[n].layerId);if(i){var s=o.create(a.extend({layer:i,childLayers:t[n].childLayerIds.map(e.getLayer.bind(e)).filter(function(t){return t})},t[n]));r[s.id]=s}}return r}}var a=t(\"../util/util\"),o=t(\"../data/bucket\"),s=t(\"../data/feature_index\"),l=t(\"vector-tile\"),u=t(\"pbf\"),c=t(\"../util/vectortile_to_geojson\"),h=t(\"feature-filter\"),f=t(\"../symbol/collision_tile\"),d=t(\"../symbol/collision_box\"),p=t(\"../symbol/symbol_instances\"),m=t(\"../symbol/symbol_quads\");e.exports=n,n.prototype={loadVectorData:function(t,e){this.state=\"loaded\",t&&(this.collisionBoxArray=new d(t.collisionBoxArray),this.collisionTile=new f(t.collisionTile,this.collisionBoxArray),this.symbolInstancesArray=new p(t.symbolInstancesArray),this.symbolQuadsArray=new m(t.symbolQuadsArray),this.featureIndex=new s(t.featureIndex,t.rawTileData,this.collisionTile),this.rawTileData=t.rawTileData,this.buckets=i(t.buckets,e))},reloadSymbolData:function(t,e,r){if(\"unloaded\"!==this.state){this.collisionTile=new f(t.collisionTile,this.collisionBoxArray),this.featureIndex.setCollisionTile(this.collisionTile);for(var n in this.buckets){var o=this.buckets[n];\"symbol\"===o.type&&(o.destroy(e.gl),delete this.buckets[n])}a.extend(this.buckets,i(t.buckets,r))}},unloadVectorData:function(t){for(var e in this.buckets){this.buckets[e].destroy(t.gl)}this.collisionBoxArray=null,this.symbolQuadsArray=null,this.symbolInstancesArray=null,this.collisionTile=null,this.featureIndex=null,this.rawTileData=null,this.buckets=null,this.state=\"unloaded\"},redoPlacement:function(t){function e(e,r){this.reloadSymbolData(r,t.map.painter,t.map.style),t.fire(\"tile.load\",{tile:this}),this.state=\"loaded\",this.redoWhenDone&&(this.redoPlacement(t),this.redoWhenDone=!1)}if(\"loaded\"!==this.state||\"reloading\"===this.state)return void(this.redoWhenDone=!0);this.state=\"reloading\",t.dispatcher.send(\"redo placement\",{uid:this.uid,source:t.id,angle:t.map.transform.angle,pitch:t.map.transform.pitch,showCollisionBoxes:t.map.showCollisionBoxes},e.bind(this),this.workerID)},getBucket:function(t){return this.buckets&&this.buckets[t.ref||t.id]},querySourceFeatures:function(t,e){if(this.rawTileData){this.vtLayers||(this.vtLayers=new l.VectorTile(new u(new Uint8Array(this.rawTileData))).layers);var r=this.vtLayers._geojsonTileLayer||this.vtLayers[e.sourceLayer];if(r)for(var n=h(e.filter),i={z:this.coord.z,x:this.coord.x,y:this.coord.y},a=0;a<r.length;a++){var o=r.feature(a);if(n(o)){var s=new c(o,this.coord.z,this.coord.x,this.coord.y);s.tile=i,t.push(s)}}}},isRenderable:function(){return\"loaded\"===this.state||\"reloading\"===this.state}}},{\"../data/bucket\":328,\"../data/feature_index\":335,\"../symbol/collision_box\":393,\"../symbol/collision_tile\":395,\"../symbol/symbol_instances\":404,\"../symbol/symbol_quads\":405,\"../util/util\":441,\"../util/vectortile_to_geojson\":442,\"feature-filter\":131,pbf:477,\"vector-tile\":549}],368:[function(t,e,r){\"use strict\";function n(t,e,r,n){l(!isNaN(t)&&t>=0&&t%1==0),l(!isNaN(e)&&e>=0&&e%1==0),l(!isNaN(r)&&r>=0&&r%1==0),isNaN(n)&&(n=0),this.z=+t,this.x=+e,this.y=+r,this.w=+n,(n*=2)<0&&(n=-1*n-1);var i=1<<this.z;this.id=32*(i*i*n+i*this.y+this.x)+this.z,this.posMatrix=null}function i(t,e,r){for(var n,i=\"\",a=t;a>0;a--)n=1<<a-1,i+=(e&n?1:0)+(r&n?2:0);return i}function a(t,e){if(t.row>e.row){var r=t;t=e,e=r}return{x0:t.column,y0:t.row,x1:e.column,y1:e.row,dx:e.column-t.column,dy:e.row-t.row}}function o(t,e,r,n,i){var a=Math.max(r,Math.floor(e.y0)),o=Math.min(n,Math.ceil(e.y1));if(t.x0===e.x0&&t.y0===e.y0?t.x0+e.dy/t.dy*t.dx<e.x1:t.x1-e.dy/t.dy*t.dx<e.x0){var s=t;t=e,e=s}for(var l=t.dx/t.dy,u=e.dx/e.dy,c=t.dx>0,h=e.dx<0,f=a;f<o;f++){var d=l*Math.max(0,Math.min(t.dy,f+c-t.y0))+t.x0,p=u*Math.max(0,Math.min(e.dy,f+h-e.y0))+e.x0;i(Math.floor(p),Math.ceil(d),f)}}function s(t,e,r,n,i,s){var l,u=a(t,e),c=a(e,r),h=a(r,t);u.dy>c.dy&&(l=u,u=c,c=l),u.dy>h.dy&&(l=u,u=h,h=l),c.dy>h.dy&&(l=c,c=h,h=l),u.dy&&o(h,u,n,i,s),c.dy&&o(h,c,n,i,s)}var l=t(\"assert\"),u=t(\"whoots-js\"),c=t(\"../geo/coordinate\");e.exports=n,n.prototype.toString=function(){return this.z+\"/\"+this.x+\"/\"+this.y},n.prototype.toCoordinate=function(t){var e=Math.min(this.z,t),r=Math.pow(2,e),n=this.y,i=this.x+r*this.w;return new c(i,n,e)},n.fromID=function(t){var e=t%32,r=1<<e,i=(t-e)/32,a=i%r,o=(i-a)/r%r,s=Math.floor(i/(r*r));return s%2!=0&&(s=-1*s-1),s/=2,new n(e,a,o,s)},n.prototype.url=function(t,e,r){var n=u.getTileBBox(this.x,this.y,this.z),a=i(this.z,this.x,this.y);return t[(this.x+this.y)%t.length].replace(\"{prefix}\",(this.x%16).toString(16)+(this.y%16).toString(16)).replace(\"{z}\",Math.min(this.z,e||this.z)).replace(\"{x}\",this.x).replace(\"{y}\",\"tms\"===r?Math.pow(2,this.z)-this.y-1:this.y).replace(\"{quadkey}\",a).replace(\"{bbox-epsg-3857}\",n)},n.prototype.parent=function(t){return 0===this.z?null:this.z>t?new n(this.z-1,this.x,this.y,this.w):new n(this.z-1,Math.floor(this.x/2),Math.floor(this.y/2),this.w)},n.prototype.wrapped=function(){return new n(this.z,this.x,this.y,0)},n.prototype.children=function(t){if(this.z>=t)return[new n(this.z+1,this.x,this.y,this.w)];var e=this.z+1,r=2*this.x,i=2*this.y;return[new n(e,r,i,this.w),new n(e,r+1,i,this.w),new n(e,r,i+1,this.w),new n(e,r+1,i+1,this.w)]},n.cover=function(t,e,r){function i(t,e,i){var s,l,u;if(i>=0&&i<=a)for(s=t;s<e;s++)l=(s%a+a)%a,u=new n(r,l,i,Math.floor(s/a)),o[u.id]=u}var a=1<<t,o={};return s(e[0],e[1],e[2],0,a,i),s(e[2],e[3],e[0],0,a,i),Object.keys(o).map(function(t){return o[t]})}},{\"../geo/coordinate\":337,assert:46,\"whoots-js\":565}],369:[function(t,e,r){\"use strict\";function n(t,e,r){if(this.id=t,this.dispatcher=r,a.extend(this,a.pick(e,[\"url\",\"scheme\",\"tileSize\"])),this._options=a.extend({type:\"vector\"},e),512!==this.tileSize)throw new Error(\"vector tile sources must have a tileSize of 512\");o(e,function(t,e){if(t)return void this.fire(\"error\",t);a.extend(this,e),this.fire(\"load\")}.bind(this))}var i=t(\"../util/evented\"),a=t(\"../util/util\"),o=t(\"./load_tilejson\"),s=t(\"../util/mapbox\").normalizeTileURL;e.exports=n,n.prototype=a.inherit(i,{minzoom:0,maxzoom:22,scheme:\"xyz\",tileSize:512,reparseOverscaled:!0,isTileClipped:!0,onAdd:function(t){this.map=t},serialize:function(){return a.extend({},this._options)},loadTile:function(t,e){function r(r,n){if(!t.aborted){if(r)return e(r);t.loadVectorData(n,this.map.style),t.redoWhenDone&&(t.redoWhenDone=!1,t.redoPlacement(this)),e(null),t.reloadCallback&&(this.loadTile(t,t.reloadCallback),t.reloadCallback=null)}}var n=t.coord.z>this.maxzoom?Math.pow(2,t.coord.z-this.maxzoom):1,i={url:s(t.coord.url(this.tiles,this.maxzoom,this.scheme),this.url),uid:t.uid,coord:t.coord,zoom:t.coord.z,tileSize:this.tileSize*n,source:this.id,overscaling:n,angle:this.map.transform.angle,pitch:this.map.transform.pitch,showCollisionBoxes:this.map.showCollisionBoxes};t.workerID?\"loading\"===t.state?t.reloadCallback=e:(i.rawTileData=t.rawTileData,this.dispatcher.send(\"reload tile\",i,r.bind(this),t.workerID)):t.workerID=this.dispatcher.send(\"load tile\",i,r.bind(this))},abortTile:function(t){this.dispatcher.send(\"abort tile\",{uid:t.uid,source:this.id},null,t.workerID)},unloadTile:function(t){t.unloadVectorData(this.map.painter),this.dispatcher.send(\"remove tile\",{uid:t.uid,source:this.id},null,t.workerID)}})},{\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./load_tilejson\":361}],370:[function(t,e,r){\"use strict\";function n(t,e,r){this.actor=t,this.styleLayers=e,r&&(this.loadVectorData=r),this.loading={},this.loaded={}}var i=t(\"../util/ajax\"),a=t(\"vector-tile\"),o=t(\"pbf\"),s=t(\"./worker_tile\");e.exports=n,n.prototype={loadTile:function(t,e){function r(t,r){return delete this.loading[n][i],t?e(t):r?(a.data=r.tile,a.parse(a.data,this.styleLayers.getLayerFamilies(),this.actor,r.rawTileData,e),this.loaded[n]=this.loaded[n]||{},void(this.loaded[n][i]=a)):e(null,null)}var n=t.source,i=t.uid;this.loading[n]||(this.loading[n]={});var a=this.loading[n][i]=new s(t);a.abort=this.loadVectorData(t,r.bind(this))},reloadTile:function(t,e){var r=this.loaded[t.source],n=t.uid;if(r&&r[n]){var i=r[n];i.parse(i.data,this.styleLayers.getLayerFamilies(),this.actor,t.rawTileData,e)}},abortTile:function(t){var e=this.loading[t.source],r=t.uid;e&&e[r]&&e[r].abort&&(e[r].abort(),delete e[r])},removeTile:function(t){var e=this.loaded[t.source],r=t.uid;e&&e[r]&&delete e[r]},loadVectorData:function(t,e){function r(t,r){if(t)return e(t);var n=new a.VectorTile(new o(new Uint8Array(r)));e(t,{tile:n,rawTileData:r})}var n=i.getArrayBuffer(t.url,r.bind(this));return function(){n.abort()}},redoPlacement:function(t,e){var r=this.loaded[t.source],n=this.loading[t.source],i=t.uid;if(r&&r[i]){var a=r[i],o=a.redoPlacement(t.angle,t.pitch,t.showCollisionBoxes);o.result&&e(null,o.result,o.transferables)}else n&&n[i]&&(n[i].angle=t.angle)}}},{\"../util/ajax\":424,\"./worker_tile\":373,pbf:477,\"vector-tile\":549}],371:[function(t,e,r){\"use strict\";function n(t,e){this.id=t,this.urls=e.urls,this.coordinates=e.coordinates,u.getVideo(e.urls,function(t,r){if(t)return this.fire(\"error\",{error:t});this.video=r,this.video.loop=!0;var n;this.video.addEventListener(\"playing\",function(){n=this.map.style.animationLoop.set(1/0),this.map._rerender()}.bind(this)),this.video.addEventListener(\"pause\",function(){this.map.style.animationLoop.cancel(n)}.bind(this)),this.map&&(this.video.play(),this.setCoordinates(e.coordinates)),this.fire(\"load\")}.bind(this))}var i=t(\"../util/util\"),a=t(\"./tile_coord\"),o=t(\"../geo/lng_lat\"),s=t(\"point-geometry\"),l=t(\"../util/evented\"),u=t(\"../util/ajax\"),c=t(\"../data/bucket\").EXTENT,h=t(\"../render/draw_raster\").RasterBoundsArray,f=t(\"../data/buffer\"),d=t(\"../render/vertex_array_object\");e.exports=n,n.prototype=i.inherit(l,{minzoom:0,maxzoom:22,tileSize:512,roundZoom:!0,getVideo:function(){return this.video},onAdd:function(t){this.map||(this.map=t,this.video&&(this.video.play(),this.setCoordinates(this.coordinates)))},setCoordinates:function(t){this.coordinates=t;var e=this.map,r=t.map(function(t){return e.transform.locationCoordinate(o.convert(t)).zoomTo(0)}),n=this.centerCoord=i.getCoordinatesCenter(r);return n.column=Math.round(n.column),n.row=Math.round(n.row),this.minzoom=this.maxzoom=n.zoom,this._coord=new a(n.zoom,n.column,n.row),this._tileCoords=r.map(function(t){var e=t.zoomTo(n.zoom);return new s(Math.round((e.column-n.column)*c),Math.round((e.row-n.row)*c))}),this.fire(\"change\"),this},_setTile:function(t){this._prepared=!1,this.tile=t;var e=new h;e.emplaceBack(this._tileCoords[0].x,this._tileCoords[0].y,0,0),e.emplaceBack(this._tileCoords[1].x,this._tileCoords[1].y,32767,0),e.emplaceBack(this._tileCoords[3].x,this._tileCoords[3].y,0,32767),e.emplaceBack(this._tileCoords[2].x,this._tileCoords[2].y,32767,32767),this.tile.buckets={},this.tile.boundsBuffer=new f(e.serialize(),h.serialize(),f.BufferType.VERTEX),this.tile.boundsVAO=new d,this.tile.state=\"loaded\"},prepare:function(){if(!(this.video.readyState<2)&&this.tile){var t=this.map.painter.gl;this._prepared?(t.bindTexture(t.TEXTURE_2D,this.tile.texture),t.texSubImage2D(t.TEXTURE_2D,0,0,0,t.RGBA,t.UNSIGNED_BYTE,this.video)):(this._prepared=!0,this.tile.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.tile.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,this.video)),this._currentTime=this.video.currentTime}},loadTile:function(t,e){this._coord&&this._coord.toString()===t.coord.toString()?(this._setTile(t),e(null)):(t.state=\"errored\",e(null))},serialize:function(){return{type:\"video\",urls:this.urls,coordinates:this.coordinates}}})},{\"../data/bucket\":328,\"../data/buffer\":333,\"../geo/lng_lat\":338,\"../render/draw_raster\":350,\"../render/vertex_array_object\":356,\"../util/ajax\":424,\"../util/evented\":433,\"../util/util\":441,\"./tile_coord\":368,\"point-geometry\":483}],372:[function(t,e,r){\"use strict\";function n(t){this.self=t,this.actor=new a(t,this);var e={getLayers:function(){return this.layers}.bind(this),getLayerFamilies:function(){return this.layerFamilies}.bind(this)};this.workerSources={vector:new l(this.actor,e),geojson:new u(this.actor,e)},this.self.registerWorkerSource=function(t,r){if(this.workerSources[t])throw new Error('Worker source with name \"'+t+'\" already registered.');this.workerSources[t]=new r(this.actor,e)}.bind(this)}function i(t){var e={};for(var r in t){var n=t[r],i=n.ref||n.id,a=t[i];a.layout&&\"none\"===a.layout.visibility||(e[i]=e[i]||[],r===i?e[i].unshift(n):e[i].push(n))}return e}var a=t(\"../util/actor\"),o=t(\"../style/style_layer\"),s=t(\"../util/util\"),l=t(\"./vector_tile_worker_source\"),u=t(\"./geojson_worker_source\");e.exports=function(t){return new n(t)},s.extend(n.prototype,{\"set layers\":function(t){function e(t){var e=o.create(t,t.ref&&r.layers[t.ref]);e.updatePaintTransitions({},{transition:!1}),r.layers[e.id]=e}this.layers={};for(var r=this,n=[],a=0;a<t.length;a++){var s=t[a];\"fill\"!==s.type&&\"line\"!==s.type&&\"circle\"!==s.type&&\"symbol\"!==s.type||(s.ref?n.push(a):e(s))}for(var l=0;l<n.length;l++)e(t[n[l]]);this.layerFamilies=i(this.layers)},\"update layers\":function(t){function e(t){var e=a.layers[t.ref];a.layers[t.id]?a.layers[t.id].set(t,e):a.layers[t.id]=o.create(t,e),a.layers[t.id].updatePaintTransitions({},{transition:!1})}var r,n,a=this;for(r in t)n=t[r],n.ref&&e(n);for(r in t)n=t[r],n.ref||e(n);this.layerFamilies=i(this.layers)},\"load tile\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].loadTile(t,e)},\"reload tile\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].reloadTile(t,e)},\"abort tile\":function(t){var e=t.type||\"vector\";this.workerSources[e].abortTile(t)},\"remove tile\":function(t){var e=t.type||\"vector\";this.workerSources[e].removeTile(t)},\"redo placement\":function(t,e){var r=t.type||\"vector\";this.workerSources[r].redoPlacement(t,e)},\"load worker source\":function(t,e){try{this.self.importScripts(t.url),e()}catch(t){e(t)}}})},{\"../style/style_layer\":380,\"../util/actor\":423,\"../util/util\":441,\"./geojson_worker_source\":358,\"./vector_tile_worker_source\":370}],373:[function(t,e,r){\"use strict\";function n(t){this.coord=t.coord,this.uid=t.uid,this.zoom=t.zoom,this.tileSize=t.tileSize,this.source=t.source,this.overscaling=t.overscaling,this.angle=t.angle,this.pitch=t.pitch,this.showCollisionBoxes=t.showCollisionBoxes}function i(t){return!t.isEmpty()}function a(t){return t.serialize()}function o(t){var e=[];for(var r in t)t[r].getTransferables(e);return e}function s(t){return t.id}var l=t(\"../data/feature_index\"),u=t(\"../symbol/collision_tile\"),c=t(\"../data/bucket\"),h=t(\"../symbol/collision_box\"),f=t(\"../util/dictionary_coder\"),d=t(\"../util/util\"),p=t(\"../symbol/symbol_instances\"),m=t(\"../symbol/symbol_quads\");e.exports=n,n.prototype.parse=function(t,e,r,n,v){function g(t,e){for(var r=0;r<t.length;r++){var n=t.feature(r);n.index=r;for(var i in e)e[i].filter(n)&&e[i].features.push(n)}}function y(t){if(t)return v(t);if(2===++N){for(var e=P.length-1;e>=0;e--)b(E,P[e]);x()}}function b(t,e){if(e.populateArrays(A,j,F),\"symbol\"!==e.type)for(var r=0;r<e.features.length;r++){var n=e.features[r];T.insert(n,n.index,e.sourceLayerIndex,e.index)}e.features=null}function x(){E.status=\"done\",E.redoPlacementAfterDone&&(E.redoPlacement(E.angle,E.pitch,null),E.redoPlacementAfterDone=!1);var t=T.serialize(),e=A.serialize(),r=E.collisionBoxArray.serialize(),s=E.symbolInstancesArray.serialize(),l=E.symbolQuadsArray.serialize(),u=[n].concat(t.transferables).concat(e.transferables),c=D.filter(i);v(null,{buckets:c.map(a),featureIndex:t.data,collisionTile:e.data,collisionBoxArray:r,symbolInstancesArray:s,symbolQuadsArray:l,rawTileData:n},o(c).concat(u))}this.status=\"parsing\",this.data=t,this.collisionBoxArray=new h,this.symbolInstancesArray=new p,this.symbolQuadsArray=new m;var _,w,M,k,A=new u(this.angle,this.pitch,this.collisionBoxArray),T=new l(this.coord,this.overscaling,A,t.layers),S=new f(t.layers?Object.keys(t.layers).sort():[\"_geojsonTileLayer\"]),E=this,L={},C={},z=0;for(var I in e)w=e[I][0],w.source===this.source&&(w.ref||w.minzoom&&this.zoom<w.minzoom||w.maxzoom&&this.zoom>=w.maxzoom||w.layout&&\"none\"===w.layout.visibility||t.layers&&!t.layers[w.sourceLayer]||(k=c.create({layer:w,index:z++,childLayers:e[I],zoom:this.zoom,overscaling:this.overscaling,showCollisionBoxes:this.showCollisionBoxes,collisionBoxArray:this.collisionBoxArray,symbolQuadsArray:this.symbolQuadsArray,symbolInstancesArray:this.symbolInstancesArray,sourceLayerIndex:S.encode(w.sourceLayer||\"_geojsonTileLayer\")}),k.createFilter(),L[w.id]=k,t.layers&&(M=w.sourceLayer,C[M]=C[M]||{},C[M][w.id]=k)));if(t.layers)for(M in C)1===w.version&&d.warnOnce('Vector tile source \"'+this.source+'\" layer \"'+M+'\" does not use vector tile spec v2 and therefore may have some rendering errors.'),(w=t.layers[M])&&g(w,C[M]);else g(t,L);var D=[],P=this.symbolBuckets=[],O=[];T.bucketLayerIDs={};for(var R in L)k=L[R],0!==k.features.length&&(T.bucketLayerIDs[k.index]=k.childLayers.map(s),D.push(k),\"symbol\"===k.type?P.push(k):O.push(k));var F={},j={},N=0;if(P.length>0){for(_=P.length-1;_>=0;_--)P[_].updateIcons(F),P[_].updateFont(j);for(var B in j)j[B]=Object.keys(j[B]).map(Number);F=Object.keys(F),r.send(\"get glyphs\",{uid:this.uid,stacks:j},function(t,e){j=e,y(t)}),F.length?r.send(\"get icons\",{icons:F},function(t,e){F=e,y(t)}):y()}for(_=O.length-1;_>=0;_--)b(this,O[_]);if(0===P.length)return x()},n.prototype.redoPlacement=function(t,e,r){if(\"done\"!==this.status)return this.redoPlacementAfterDone=!0,this.angle=t,{};for(var n=new u(t,e,this.collisionBoxArray),s=this.symbolBuckets,l=s.length-1;l>=0;l--)s[l].placeFeatures(n,r);var c=n.serialize(),h=s.filter(i);return{result:{buckets:h.map(a),collisionTile:c.data},transferables:o(h).concat(c.transferables)}}},{\"../data/bucket\":328,\"../data/feature_index\":335,\"../symbol/collision_box\":393,\"../symbol/collision_tile\":395,\"../symbol/symbol_instances\":404,\"../symbol/symbol_quads\":405,\"../util/dictionary_coder\":431,\"../util/util\":441}],374:[function(t,e,r){\"use strict\";function n(){this.n=0,this.times=[]}e.exports=n,n.prototype.stopped=function(){return this.times=this.times.filter(function(t){return t.time>=(new Date).getTime()}),!this.times.length},n.prototype.set=function(t){return this.times.push({id:this.n,time:t+(new Date).getTime()}),this.n++},n.prototype.cancel=function(t){this.times=this.times.filter(function(e){return e.id!==t})}},{}],375:[function(t,e,r){\"use strict\";function n(t){this.base=t,this.retina=s.devicePixelRatio>1;var e=this.retina?\"@2x\":\"\";o.getJSON(l(t,e,\".json\"),function(t,e){if(t)return void this.fire(\"error\",{error:t});this.data=e,this.img&&this.fire(\"load\")}.bind(this)),o.getImage(l(t,e,\".png\"),function(t,e){if(t)return void this.fire(\"error\",{error:t});for(var r=e.getData(),n=e.data=new Uint8Array(r.length),i=0;i<r.length;i+=4){var a=r[i+3]/255;n[i+0]=r[i+0]*a,n[i+1]=r[i+1]*a,n[i+2]=r[i+2]*a,n[i+3]=r[i+3]}this.img=e,this.data&&this.fire(\"load\")}.bind(this))}function i(){}var a=t(\"../util/evented\"),o=t(\"../util/ajax\"),s=t(\"../util/browser\"),l=t(\"../util/mapbox\").normalizeSpriteURL;e.exports=n,n.prototype=Object.create(a),n.prototype.toJSON=function(){return this.base},n.prototype.loaded=function(){return!(!this.data||!this.img)},n.prototype.resize=function(){if(s.devicePixelRatio>1!==this.retina){var t=new n(this.base);t.on(\"load\",function(){this.img=t.img,this.data=t.data,this.retina=t.retina}.bind(this))}},i.prototype={x:0,y:0,width:0,height:0,pixelRatio:1,sdf:!1},n.prototype.getSpritePosition=function(t){if(!this.loaded())return new i;var e=this.data&&this.data[t];return e&&this.img?e:new i}},{\"../util/ajax\":424,\"../util/browser\":425,\"../util/evented\":433,\"../util/mapbox\":438}],376:[function(t,e,r){\"use strict\";var n=t(\"csscolorparser\").parseCSSColor,i=t(\"../util/util\"),a=t(\"./style_function\"),o={};e.exports=function t(e){if(a.isFunctionDefinition(e))return i.extend({},e,{stops:e.stops.map(function(e){return[e[0],t(e[1])]})});if(\"string\"==typeof e){if(!o[e]){var r=n(e);if(!r)throw new Error(\"Invalid color \"+e);o[e]=[r[0]/255*r[3],r[1]/255*r[3],r[2]/255*r[3],r[3]]}return o[e]}throw new Error(\"Invalid color \"+e)}},{\"../util/util\":441,\"./style_function\":379,csscolorparser:107}],377:[function(t,e,r){\"use strict\";function n(t,e,r){this.animationLoop=e||new m,this.dispatcher=new p(r||1,this),this.spriteAtlas=new l(1024,1024),this.lineAtlas=new u(256,512),this._layers={},this._order=[],this._groups=[],this.sources={},this.zoomHistory={},c.bindAll([\"_forwardSourceEvent\",\"_forwardTileEvent\",\"_forwardLayerEvent\",\"_redoPlacement\"],this),this._resetUpdates();var n=function(t,e){if(t)return void this.fire(\"error\",{error:t});if(!v.emitErrors(this,v(e))){this._loaded=!0,this.stylesheet=e,this.updateClasses();var r=e.sources;for(var n in r)this.addSource(n,r[n]);e.sprite&&(this.sprite=new o(e.sprite),this.sprite.on(\"load\",this.fire.bind(this,\"change\"))),this.glyphSource=new s(e.glyphs),this._resolve(),this.fire(\"load\")}}.bind(this);\"string\"==typeof t?h.getJSON(f(t),n):d.frame(n.bind(this,null,t)),this.on(\"source.load\",function(t){var e=t.source;if(e&&e.vectorLayerIds)for(var r in this._layers){var n=this._layers[r];n.source===e.id&&this._validateLayer(n)}})}var i=t(\"../util/evented\"),a=t(\"./style_layer\"),o=t(\"./image_sprite\"),s=t(\"../symbol/glyph_source\"),l=t(\"../symbol/sprite_atlas\"),u=t(\"../render/line_atlas\"),c=t(\"../util/util\"),h=t(\"../util/ajax\"),f=t(\"../util/mapbox\").normalizeStyleURL,d=t(\"../util/browser\"),p=t(\"../util/dispatcher\"),m=t(\"./animation_loop\"),v=t(\"./validate_style\"),g=t(\"../source/source\"),y=t(\"../source/query_features\"),b=t(\"../source/source_cache\"),x=t(\"./style_spec\"),_=t(\"./style_function\");e.exports=n,n.prototype=c.inherit(i,{_loaded:!1,_validateLayer:function(t){var e=this.sources[t.source];t.sourceLayer&&e&&e.vectorLayerIds&&-1===e.vectorLayerIds.indexOf(t.sourceLayer)&&this.fire(\"error\",{error:new Error('Source layer \"'+t.sourceLayer+'\" does not exist on source \"'+e.id+'\" as specified by style layer \"'+t.id+'\"')})},loaded:function(){if(!this._loaded)return!1;if(Object.keys(this._updates.sources).length)return!1;for(var t in this.sources)if(!this.sources[t].loaded())return!1;return!(this.sprite&&!this.sprite.loaded())},_resolve:function(){var t,e;this._layers={},this._order=this.stylesheet.layers.map(function(t){return t.id});for(var r=0;r<this.stylesheet.layers.length;r++)e=this.stylesheet.layers[r],e.ref||(t=a.create(e),this._layers[t.id]=t,t.on(\"error\",this._forwardLayerEvent));for(var n=0;n<this.stylesheet.layers.length;n++)if(e=this.stylesheet.layers[n],e.ref){var i=this.getLayer(e.ref);t=a.create(e,i),this._layers[t.id]=t,t.on(\"error\",this._forwardLayerEvent)}this._groupLayers(),this._updateWorkerLayers()},_groupLayers:function(){var t;this._groups=[];for(var e=0;e<this._order.length;++e){var r=this._layers[this._order[e]];t&&r.source===t.source||(t=[],t.source=r.source,this._groups.push(t)),t.push(r)}},_updateWorkerLayers:function(t){this.dispatcher.broadcast(t?\"update layers\":\"set layers\",this._serializeLayers(t))},_serializeLayers:function(t){t=t||this._order;for(var e=[],r={includeRefProperties:!0},n=0;n<t.length;n++)e.push(this._layers[t[n]].serialize(r));return e},_applyClasses:function(t,e){if(this._loaded){t=t||[],e=e||{transition:!0};var r=this.stylesheet.transition||{},n=this._updates.allPaintProps?this._layers:this._updates.paintProps;for(var i in n){var a=this._layers[i],o=this._updates.paintProps[i];if(this._updates.allPaintProps||o.all)a.updatePaintTransitions(t,e,r,this.animationLoop);else for(var s in o)this._layers[i].updatePaintTransition(s,t,e,r,this.animationLoop)}}},_recalculate:function(t){for(var e in this.sources)this.sources[e].used=!1;this._updateZoomHistory(t),this.rasterFadeDuration=300;for(var r in this._layers){var n=this._layers[r];n.recalculate(t,this.zoomHistory),!n.isHidden(t)&&n.source&&(this.sources[n.source].used=!0)}Math.floor(this.z)!==Math.floor(t)&&this.animationLoop.set(300),this.z=t,this.fire(\"zoom\")},_updateZoomHistory:function(t){var e=this.zoomHistory;void 0===e.lastIntegerZoom&&(e.lastIntegerZoom=Math.floor(t),e.lastIntegerZoomTime=0,e.lastZoom=t),Math.floor(e.lastZoom)<Math.floor(t)?(e.lastIntegerZoom=Math.floor(t),e.lastIntegerZoomTime=Date.now()):Math.floor(e.lastZoom)>Math.floor(t)&&(e.lastIntegerZoom=Math.floor(t+1),e.lastIntegerZoomTime=Date.now()),e.lastZoom=t},_checkLoaded:function(){if(!this._loaded)throw new Error(\"Style is not done loading\")},update:function(t,e){if(!this._updates.changed)return this;if(this._updates.allLayers)this._groupLayers(),this._updateWorkerLayers();else{var r=Object.keys(this._updates.layers);r.length&&this._updateWorkerLayers(r)}var n,i=Object.keys(this._updates.sources);for(n=0;n<i.length;n++)this._reloadSource(i[n]);for(n=0;n<this._updates.events.length;n++){var a=this._updates.events[n];this.fire(a[0],a[1])}return this._applyClasses(t,e),this._updates.changed&&this.fire(\"change\"),this._resetUpdates(),this},_resetUpdates:function(){this._updates={events:[],layers:{},sources:{},paintProps:{}}},addSource:function(t,e){if(this._checkLoaded(),void 0!==this.sources[t])throw new Error(\"There is already a source with this ID\");if(!e.type)throw new Error(\"The type property must be defined, but the only the following properties were given: \"+Object.keys(e)+\".\");return[\"vector\",\"raster\",\"geojson\",\"video\",\"image\"].indexOf(e.type)>=0&&this._handleErrors(v.source,\"sources.\"+t,e)?this:(e=new b(t,e,this.dispatcher),this.sources[t]=e,e.style=this,e.on(\"load\",this._forwardSourceEvent).on(\"error\",this._forwardSourceEvent).on(\"change\",this._forwardSourceEvent).on(\"tile.add\",this._forwardTileEvent).on(\"tile.load\",this._forwardTileEvent).on(\"tile.error\",this._forwardTileEvent).on(\"tile.remove\",this._forwardTileEvent).on(\"tile.stats\",this._forwardTileEvent),this._updates.events.push([\"source.add\",{source:e}]),this._updates.changed=!0,this)},removeSource:function(t){if(this._checkLoaded(),void 0===this.sources[t])throw new Error(\"There is no source with this ID\");var e=this.sources[t];return delete this.sources[t],delete this._updates.sources[t],e.off(\"load\",this._forwardSourceEvent).off(\"error\",this._forwardSourceEvent).off(\"change\",this._forwardSourceEvent).off(\"tile.add\",this._forwardTileEvent).off(\"tile.load\",this._forwardTileEvent).off(\"tile.error\",this._forwardTileEvent).off(\"tile.remove\",this._forwardTileEvent).off(\"tile.stats\",this._forwardTileEvent),this._updates.events.push([\"source.remove\",{source:e}]),this._updates.changed=!0,this},getSource:function(t){return this.sources[t]&&this.sources[t].getSource()},addLayer:function(t,e){if(this._checkLoaded(),!(t instanceof a)){if(this._handleErrors(v.layer,\"layers.\"+t.id,t,!1,{arrayIndex:-1}))return this;var r=t.ref&&this.getLayer(t.ref);t=a.create(t,r)}return this._validateLayer(t),t.on(\"error\",this._forwardLayerEvent),this._layers[t.id]=t,this._order.splice(e?this._order.indexOf(e):1/0,0,t.id),this._updates.allLayers=!0,t.source&&(this._updates.sources[t.source]=!0),this._updates.events.push([\"layer.add\",{layer:t}]),this.updateClasses(t.id)},removeLayer:function(t){this._checkLoaded();var e=this._layers[t];if(void 0===e)throw new Error(\"There is no layer with this ID\");for(var r in this._layers)this._layers[r].ref===t&&this.removeLayer(r);return e.off(\"error\",this._forwardLayerEvent),delete this._layers[t],delete this._updates.layers[t],delete this._updates.paintProps[t],this._order.splice(this._order.indexOf(t),1),this._updates.allLayers=!0,this._updates.events.push([\"layer.remove\",{layer:e}]),this._updates.changed=!0,this},getLayer:function(t){return this._layers[t]},getReferentLayer:function(t){var e=this.getLayer(t);return e.ref&&(e=this.getLayer(e.ref)),e},setLayerZoomRange:function(t,e,r){this._checkLoaded();var n=this.getReferentLayer(t);return n.minzoom===e&&n.maxzoom===r?this:(null!=e&&(n.minzoom=e),null!=r&&(n.maxzoom=r),this._updateLayer(n))},setFilter:function(t,e){this._checkLoaded();var r=this.getReferentLayer(t);return null!==e&&this._handleErrors(v.filter,\"layers.\"+r.id+\".filter\",e)?this:c.deepEqual(r.filter,e)?this:(r.filter=c.clone(e),this._updateLayer(r))},getFilter:function(t){return this.getReferentLayer(t).filter},setLayoutProperty:function(t,e,r){this._checkLoaded();var n=this.getReferentLayer(t);return c.deepEqual(n.getLayoutProperty(e),r)?this:(n.setLayoutProperty(e,r),this._updateLayer(n))},getLayoutProperty:function(t,e){return this.getReferentLayer(t).getLayoutProperty(e)},setPaintProperty:function(t,e,r,n){this._checkLoaded();var i=this.getLayer(t);if(c.deepEqual(i.getPaintProperty(e,n),r))return this;var a=i.isPaintValueFeatureConstant(e);return i.setPaintProperty(e,r,n),!(r&&_.isFunctionDefinition(r)&&\"$zoom\"!==r.property&&void 0!==r.property)&&a||(this._updates.layers[t]=!0,i.source&&(this._updates.sources[i.source]=!0)),this.updateClasses(t,e)},getPaintProperty:function(t,e,r){return this.getLayer(t).getPaintProperty(e,r)},updateClasses:function(t,e){if(this._updates.changed=!0,t){var r=this._updates.paintProps;r[t]||(r[t]={}),r[t][e||\"all\"]=!0}else this._updates.allPaintProps=!0;return this},serialize:function(){return c.filterObject({version:this.stylesheet.version,name:this.stylesheet.name,metadata:this.stylesheet.metadata,center:this.stylesheet.center,zoom:this.stylesheet.zoom,bearing:this.stylesheet.bearing,pitch:this.stylesheet.pitch,sprite:this.stylesheet.sprite,glyphs:this.stylesheet.glyphs,transition:this.stylesheet.transition,sources:c.mapObject(this.sources,function(t){return t.serialize()}),layers:this._order.map(function(t){return this._layers[t].serialize()},this)},function(t){return void 0!==t})},_updateLayer:function(t){return this._updates.layers[t.id]=!0,t.source&&(this._updates.sources[t.source]=!0),this._updates.changed=!0,this},_flattenRenderedFeatures:function(t){for(var e=[],r=this._order.length-1;r>=0;r--)for(var n=this._order[r],i=0;i<t.length;i++){var a=t[i][n];if(a)for(var o=0;o<a.length;o++)e.push(a[o])}return e},queryRenderedFeatures:function(t,e,r,n){\n",
       "e&&e.filter&&this._handleErrors(v.filter,\"queryRenderedFeatures.filter\",e.filter,!0);var i={};if(e&&e.layers)for(var a=0;a<e.layers.length;a++){var o=e.layers[a];i[this._layers[o].source]=!0}var s=[];for(var l in this.sources)if(!e.layers||i[l]){var u=this.sources[l],c=y.rendered(u,this._layers,t,e,r,n);s.push(c)}return this._flattenRenderedFeatures(s)},querySourceFeatures:function(t,e){e&&e.filter&&this._handleErrors(v.filter,\"querySourceFeatures.filter\",e.filter,!0);var r=this.sources[t];return r?y.source(r,e):[]},addSourceType:function(t,e,r){return g.getType(t)?r(new Error('A source type called \"'+t+'\" already exists.')):(g.setType(t,e),e.workerSourceURL?void this.dispatcher.broadcast(\"load worker source\",{name:t,url:e.workerSourceURL},r):r(null,null))},_handleErrors:function(t,e,r,n,i){var a=n?v.throwErrors:v.emitErrors,o=t.call(v,c.extend({key:e,style:this.serialize(),value:r,styleSpec:x},i));return a.call(v,this,o)},_remove:function(){this.dispatcher.remove()},_reloadSource:function(t){this.sources[t].reload()},_updateSources:function(t){for(var e in this.sources)this.sources[e].update(t)},_redoPlacement:function(){for(var t in this.sources)this.sources[t].redoPlacement&&this.sources[t].redoPlacement()},_forwardSourceEvent:function(t){this.fire(\"source.\"+t.type,c.extend({source:t.target.getSource()},t))},_forwardTileEvent:function(t){this.fire(t.type,c.extend({source:t.target},t))},_forwardLayerEvent:function(t){this.fire(\"layer.\"+t.type,c.extend({layer:{id:t.target.id}},t))},\"get sprite json\":function(t,e){var r=this.sprite;r.loaded()?e(null,{sprite:r.data,retina:r.retina}):r.on(\"load\",function(){e(null,{sprite:r.data,retina:r.retina})})},\"get icons\":function(t,e){var r=this.sprite,n=this.spriteAtlas;r.loaded()?(n.setSprite(r),n.addIcons(t.icons,e)):r.on(\"load\",function(){n.setSprite(r),n.addIcons(t.icons,e)})},\"get glyphs\":function(t,e){function r(t,r,n){t&&console.error(t),a[n]=r,0===--i&&e(null,a)}var n=t.stacks,i=Object.keys(n).length,a={};for(var o in n)this.glyphSource.getSimpleGlyphs(o,n[o],t.uid,r)}})},{\"../render/line_atlas\":353,\"../source/query_features\":363,\"../source/source\":365,\"../source/source_cache\":366,\"../symbol/glyph_source\":398,\"../symbol/sprite_atlas\":403,\"../util/ajax\":424,\"../util/browser\":425,\"../util/dispatcher\":432,\"../util/evented\":433,\"../util/mapbox\":438,\"../util/util\":441,\"./animation_loop\":374,\"./image_sprite\":375,\"./style_function\":379,\"./style_layer\":380,\"./style_spec\":387,\"./validate_style\":389}],378:[function(t,e,r){\"use strict\";function n(t,e){this.value=s.clone(e),this.isFunction=a.isFunctionDefinition(e),this.json=JSON.stringify(this.value);var r=\"color\"===t.type&&this.value?o(this.value):e;if(this.calculate=a[t.function||\"piecewise-constant\"](r),this.isFeatureConstant=this.calculate.isFeatureConstant,this.isZoomConstant=this.calculate.isZoomConstant,\"piecewise-constant\"===t.function&&t.transition&&(this.calculate=i(this.calculate)),!this.isFeatureConstant&&!this.isZoomConstant){this.stopZoomLevels=[];for(var n=[],l=this.value.stops,u=0;u<this.value.stops.length;u++){var c=l[u][0].zoom;this.stopZoomLevels.indexOf(c)<0&&(this.stopZoomLevels.push(c),n.push([c,n.length]))}this.calculateInterpolationT=a.interpolated({stops:n,base:e.base})}}function i(t){return function(e,r){var n,i,a,o=e.zoom,s=e.zoomHistory,l=e.duration,u=o%1,c=Math.min((Date.now()-s.lastIntegerZoomTime)/l,1),h=1;return o>s.lastIntegerZoom?(n=u+(1-u)*c,h*=2,i=t({zoom:o-1},r),a=t({zoom:o},r)):(n=1-(1-c)*u,a=t({zoom:o},r),i=t({zoom:o+1},r),h/=2),void 0===i||void 0===a?void 0:{from:i,fromScale:h,to:a,toScale:1,t:n}}}var a=t(\"./style_function\"),o=t(\"./parse_color\"),s=t(\"../util/util\");e.exports=n},{\"../util/util\":441,\"./parse_color\":376,\"./style_function\":379}],379:[function(t,e,r){\"use strict\";var n=t(\"mapbox-gl-function\");r.interpolated=function(t){var e=n.interpolated(t),r=function(t,r){return e(t&&t.zoom,r||{})};return r.isFeatureConstant=e.isFeatureConstant,r.isZoomConstant=e.isZoomConstant,r},r[\"piecewise-constant\"]=function(t){var e=n[\"piecewise-constant\"](t),r=function(t,r){return e(t&&t.zoom,r||{})};return r.isFeatureConstant=e.isFeatureConstant,r.isZoomConstant=e.isZoomConstant,r},r.isFunctionDefinition=n.isFunctionDefinition},{\"mapbox-gl-function\":301}],380:[function(t,e,r){\"use strict\";function n(t,e){this.set(t,e)}function i(t){return t.value}var a=t(\"../util/util\"),o=t(\"./style_transition\"),s=t(\"./style_declaration\"),l=t(\"./style_spec\"),u=t(\"./validate_style\"),c=t(\"./parse_color\"),h=t(\"../util/evented\");e.exports=n;n.create=function(e,r){return new({background:t(\"./style_layer/background_style_layer\"),circle:t(\"./style_layer/circle_style_layer\"),fill:t(\"./style_layer/fill_style_layer\"),line:t(\"./style_layer/line_style_layer\"),raster:t(\"./style_layer/raster_style_layer\"),symbol:t(\"./style_layer/symbol_style_layer\")}[(r||e).type])(e,r)},n.prototype=a.inherit(h,{set:function(t,e){this.id=t.id,this.ref=t.ref,this.metadata=t.metadata,this.type=(e||t).type,this.source=(e||t).source,this.sourceLayer=(e||t)[\"source-layer\"],this.minzoom=(e||t).minzoom,this.maxzoom=(e||t).maxzoom,this.filter=(e||t).filter,this.paint={},this.layout={},this._paintSpecifications=l[\"paint_\"+this.type],this._layoutSpecifications=l[\"layout_\"+this.type],this._paintTransitions={},this._paintTransitionOptions={},this._paintDeclarations={},this._layoutDeclarations={},this._layoutFunctions={};var r,n;for(var i in t){var a=i.match(/^paint(?:\\.(.*))?$/);if(a){var o=a[1]||\"\";for(r in t[i])this.setPaintProperty(r,t[i][r],o)}}if(this.ref)this._layoutDeclarations=e._layoutDeclarations;else for(n in t.layout)this.setLayoutProperty(n,t.layout[n]);for(r in this._paintSpecifications)this.paint[r]=this.getPaintValue(r);for(n in this._layoutSpecifications)this._updateLayoutValue(n)},setLayoutProperty:function(t,e){if(null==e)delete this._layoutDeclarations[t];else{var r=\"layers.\"+this.id+\".layout.\"+t;if(this._handleErrors(u.layoutProperty,r,t,e))return;this._layoutDeclarations[t]=new s(this._layoutSpecifications[t],e)}this._updateLayoutValue(t)},getLayoutProperty:function(t){return this._layoutDeclarations[t]&&this._layoutDeclarations[t].value},getLayoutValue:function(t,e,r){var n=this._layoutSpecifications[t],i=this._layoutDeclarations[t];return i?i.calculate(e,r):n.default},setPaintProperty:function(t,e,r){var n=\"layers.\"+this.id+(r?'[\"paint.'+r+'\"].':\".paint.\")+t;if(a.endsWith(t,\"-transition\"))if(this._paintTransitionOptions[r||\"\"]||(this._paintTransitionOptions[r||\"\"]={}),null===e||void 0===e)delete this._paintTransitionOptions[r||\"\"][t];else{if(this._handleErrors(u.paintProperty,n,t,e))return;this._paintTransitionOptions[r||\"\"][t]=e}else if(this._paintDeclarations[r||\"\"]||(this._paintDeclarations[r||\"\"]={}),null===e||void 0===e)delete this._paintDeclarations[r||\"\"][t];else{if(this._handleErrors(u.paintProperty,n,t,e))return;this._paintDeclarations[r||\"\"][t]=new s(this._paintSpecifications[t],e)}},getPaintProperty:function(t,e){return e=e||\"\",a.endsWith(t,\"-transition\")?this._paintTransitionOptions[e]&&this._paintTransitionOptions[e][t]:this._paintDeclarations[e]&&this._paintDeclarations[e][t]&&this._paintDeclarations[e][t].value},getPaintValue:function(t,e,r){var n=this._paintSpecifications[t],i=this._paintTransitions[t];return i?i.calculate(e,r):\"color\"===n.type&&n.default?c(n.default):n.default},getPaintValueStopZoomLevels:function(t){var e=this._paintTransitions[t];return e?e.declaration.stopZoomLevels:[]},getPaintInterpolationT:function(t,e){return this._paintTransitions[t].declaration.calculateInterpolationT({zoom:e})},isPaintValueFeatureConstant:function(t){var e=this._paintTransitions[t];return!e||e.declaration.isFeatureConstant},isLayoutValueFeatureConstant:function(t){var e=this._layoutDeclarations[t];return!e||e.isFeatureConstant},isPaintValueZoomConstant:function(t){var e=this._paintTransitions[t];return!e||e.declaration.isZoomConstant},isHidden:function(t){return!!(this.minzoom&&t<this.minzoom)||(!!(this.maxzoom&&t>=this.maxzoom)||(\"none\"===this.layout.visibility||0===this.paint[this.type+\"-opacity\"]))},updatePaintTransitions:function(t,e,r,n){for(var i=a.extend({},this._paintDeclarations[\"\"]),o=0;o<t.length;o++)a.extend(i,this._paintDeclarations[t[o]]);var s;for(s in i)this._applyPaintDeclaration(s,i[s],e,r,n);for(s in this._paintTransitions)s in i||this._applyPaintDeclaration(s,null,e,r,n)},updatePaintTransition:function(t,e,r,n,i){for(var a=this._paintDeclarations[\"\"][t],o=0;o<e.length;o++){var s=this._paintDeclarations[e[o]];s&&s[t]&&(a=s[t])}this._applyPaintDeclaration(t,a,r,n,i)},recalculate:function(t,e){for(var r in this._paintTransitions)this.paint[r]=this.getPaintValue(r,{zoom:t,zoomHistory:e});for(var n in this._layoutFunctions)this.layout[n]=this.getLayoutValue(n,{zoom:t,zoomHistory:e})},serialize:function(t){var e={id:this.id,ref:this.ref,metadata:this.metadata,minzoom:this.minzoom,maxzoom:this.maxzoom};for(var r in this._paintDeclarations){e[\"\"===r?\"paint\":\"paint.\"+r]=a.mapObject(this._paintDeclarations[r],i)}return(!this.ref||t&&t.includeRefProperties)&&a.extend(e,{type:this.type,source:this.source,\"source-layer\":this.sourceLayer,filter:this.filter,layout:a.mapObject(this._layoutDeclarations,i)}),a.filterObject(e,function(t,e){return void 0!==t&&!(\"layout\"===e&&!Object.keys(t).length)})},_applyPaintDeclaration:function(t,e,r,n,i){var l=r.transition?this._paintTransitions[t]:void 0,u=this._paintSpecifications[t];if(null!==e&&void 0!==e||(e=new s(u,u.default)),!l||l.declaration.json!==e.json){var c=a.extend({duration:300,delay:0},n,this.getPaintProperty(t+\"-transition\")),h=this._paintTransitions[t]=new o(u,e,l,c);h.instant()||(h.loopID=i.set(h.endTime-Date.now())),l&&i.cancel(l.loopID)}},_updateLayoutValue:function(t){var e=this._layoutDeclarations[t];e&&e.isFunction?this._layoutFunctions[t]=!0:(delete this._layoutFunctions[t],this.layout[t]=this.getLayoutValue(t))},_handleErrors:function(t,e,r,n){return u.emitErrors(this,t.call(u,{key:e,layerType:this.type,objectKey:r,value:n,styleSpec:l,style:{glyphs:!0,sprite:!0}}))}})},{\"../util/evented\":433,\"../util/util\":441,\"./parse_color\":376,\"./style_declaration\":378,\"./style_layer/background_style_layer\":381,\"./style_layer/circle_style_layer\":382,\"./style_layer/fill_style_layer\":383,\"./style_layer/line_style_layer\":384,\"./style_layer/raster_style_layer\":385,\"./style_layer/symbol_style_layer\":386,\"./style_spec\":387,\"./style_transition\":388,\"./validate_style\":389}],381:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],382:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],383:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");n.prototype=i.inherit(a,{getPaintValue:function(t,e,r){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintValue.call(this,\"fill-color\",e,r):a.prototype.getPaintValue.call(this,t,e,r)},getPaintValueStopZoomLevels:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintValueStopZoomLevels.call(this,\"fill-color\"):a.prototype.getPaintValueStopZoomLevels.call(this,arguments)},getPaintInterpolationT:function(t,e){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.getPaintInterpolationT.call(this,\"fill-color\",e):a.prototype.getPaintInterpolationT.call(this,t,e)},isPaintValueFeatureConstant:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.isPaintValueFeatureConstant.call(this,\"fill-color\"):a.prototype.isPaintValueFeatureConstant.call(this,t)},isPaintValueZoomConstant:function(t){return\"fill-outline-color\"===t&&void 0===this.getPaintProperty(\"fill-outline-color\")?a.prototype.isPaintValueZoomConstant.call(this,\"fill-color\"):a.prototype.isPaintValueZoomConstant.call(this,t)}}),e.exports=n},{\"../../util/util\":441,\"../style_layer\":380}],384:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{getPaintValue:function(t,e,r){var n=a.prototype.getPaintValue.apply(this,arguments);if(n&&\"line-dasharray\"===t){var i=Math.floor(e.zoom);this._flooredZoom!==i&&(this._flooredZoom=i,this._flooredLineWidth=this.getPaintValue(\"line-width\",e,r)),n.fromScale*=this._flooredLineWidth,n.toScale*=this._flooredLineWidth}return n}})},{\"../../util/util\":441,\"../style_layer\":380}],385:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{})},{\"../../util/util\":441,\"../style_layer\":380}],386:[function(t,e,r){\"use strict\";function n(){a.apply(this,arguments)}var i=t(\"../../util/util\"),a=t(\"../style_layer\");e.exports=n,n.prototype=i.inherit(a,{isHidden:function(){if(a.prototype.isHidden.apply(this,arguments))return!0;var t=0===this.paint[\"text-opacity\"]||!this.layout[\"text-field\"],e=0===this.paint[\"icon-opacity\"]||!this.layout[\"icon-image\"];return!(!t||!e)},getLayoutValue:function(t,e,r){return(\"text-rotation-alignment\"!==t||\"line\"!==this.getLayoutValue(\"symbol-placement\",e,r)||this.getLayoutProperty(\"text-rotation-alignment\"))&&(\"icon-rotation-alignment\"!==t||\"line\"!==this.getLayoutValue(\"symbol-placement\",e,r)||this.getLayoutProperty(\"icon-rotation-alignment\"))?\"text-pitch-alignment\"!==t||this.getLayoutProperty(\"text-pitch-alignment\")?a.prototype.getLayoutValue.apply(this,arguments):this.getLayoutValue(\"text-rotation-alignment\"):\"map\"}})},{\"../../util/util\":441,\"../style_layer\":380}],387:[function(t,e,r){\"use strict\";e.exports=t(\"mapbox-gl-style-spec/reference/latest.min\")},{\"mapbox-gl-style-spec/reference/latest.min\":324}],388:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.declaration=e,this.startTime=this.endTime=(new Date).getTime(),\"piecewise-constant\"===t.function&&t.transition?this.interp=i:this.interp=o[t.type],this.oldTransition=r,this.duration=n.duration||0,this.delay=n.delay||0,this.instant()||(this.endTime=this.startTime+this.duration+this.delay,this.ease=a.easeCubicInOut),r&&r.endTime<=this.startTime&&delete r.oldTransition}function i(t,e,r){return void 0===(t&&t.to)||void 0===(e&&e.to)?void 0:{from:t.to,fromScale:t.toScale,to:e.to,toScale:e.toScale,t:r}}var a=t(\"../util/util\"),o=t(\"../util/interpolate\");e.exports=n,n.prototype.instant=function(){return!this.oldTransition||!this.interp||0===this.duration&&0===this.delay},n.prototype.calculate=function(t,e){var r=this.declaration.calculate(a.extend({},t,{duration:this.duration}),e);if(this.instant())return r;var n=t.time||Date.now();if(n<this.endTime){var i=this.oldTransition.calculate(a.extend({},t,{time:this.startTime}),e),o=this.ease((n-this.startTime-this.delay)/this.duration);r=this.interp(i,r,o)}return r}},{\"../util/interpolate\":435,\"../util/util\":441}],389:[function(t,e,r){\"use strict\";e.exports=t(\"mapbox-gl-style-spec/lib/validate_style.min\"),e.exports.emitErrors=function(t,e){if(e&&e.length){for(var r=0;r<e.length;r++)t.fire(\"error\",{error:new Error(e[r].message)});return!0}return!1},e.exports.throwErrors=function(t,e){if(e)for(var r=0;r<e.length;r++)throw new Error(e[r].message)}},{\"mapbox-gl-style-spec/lib/validate_style.min\":323}],390:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.x=t,this.y=e,this.angle=r,void 0!==n&&(this.segment=n)}var i=t(\"point-geometry\");e.exports=n,n.prototype=Object.create(i.prototype),n.prototype.clone=function(){return new n(this.x,this.y,this.angle,this.segment)}},{\"point-geometry\":483}],391:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){if(void 0===e.segment)return!0;for(var a=e,o=e.segment+1,s=0;s>-r/2;){if(--o<0)return!1;s-=t[o].dist(a),a=t[o]}s+=t[o].dist(t[o+1]),o++;for(var l=[],u=0;s<r/2;){var c=t[o-1],h=t[o],f=t[o+1];if(!f)return!1;var d=c.angleTo(h)-h.angleTo(f);for(d=Math.abs((d+3*Math.PI)%(2*Math.PI)-Math.PI),l.push({distance:s,angleDelta:d}),u+=d;s-l[0].distance>n;)u-=l.shift().angleDelta;if(u>i)return!1;o++,s+=h.dist(f)}return!0}e.exports=n},{}],392:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){for(var o=[],s=0;s<t.length;s++)for(var l,u=t[s],c=0;c<u.length-1;c++){var h=u[c],f=u[c+1];h.x<e&&f.x<e||(h.x<e?h=new i(e,h.y+(f.y-h.y)*((e-h.x)/(f.x-h.x)))._round():f.x<e&&(f=new i(e,h.y+(f.y-h.y)*((e-h.x)/(f.x-h.x)))._round()),h.y<r&&f.y<r||(h.y<r?h=new i(h.x+(f.x-h.x)*((r-h.y)/(f.y-h.y)),r)._round():f.y<r&&(f=new i(h.x+(f.x-h.x)*((r-h.y)/(f.y-h.y)),r)._round()),h.x>=n&&f.x>=n||(h.x>=n?h=new i(n,h.y+(f.y-h.y)*((n-h.x)/(f.x-h.x)))._round():f.x>=n&&(f=new i(n,h.y+(f.y-h.y)*((n-h.x)/(f.x-h.x)))._round()),h.y>=a&&f.y>=a||(h.y>=a?h=new i(h.x+(f.x-h.x)*((a-h.y)/(f.y-h.y)),a)._round():f.y>=a&&(f=new i(h.x+(f.x-h.x)*((a-h.y)/(f.y-h.y)),a)._round()),l&&h.equals(l[l.length-1])||(l=[h],o.push(l)),l.push(f)))))}return o}var i=t(\"point-geometry\");e.exports=n},{\"point-geometry\":483}],393:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=e.exports=new n({members:[{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Int16\",name:\"x1\"},{type:\"Int16\",name:\"y1\"},{type:\"Int16\",name:\"x2\"},{type:\"Int16\",name:\"y2\"},{type:\"Float32\",name:\"maxScale\"},{type:\"Uint32\",name:\"featureIndex\"},{type:\"Uint16\",name:\"sourceLayerIndex\"},{type:\"Uint16\",name:\"bucketIndex\"},{type:\"Int16\",name:\"bbox0\"},{type:\"Int16\",name:\"bbox1\"},{type:\"Int16\",name:\"bbox2\"},{type:\"Int16\",name:\"bbox3\"},{type:\"Float32\",name:\"placementScale\"}]});i.extendAll(o.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"point-geometry\":483}],394:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u,c){var h=o.top*s-l,f=o.bottom*s+l,d=o.left*s-l,p=o.right*s+l;if(this.boxStartIndex=t.length,u){var m=f-h,v=p-d;if(m>0)if(m=Math.max(10*s,m),c){var g=e[r.segment+1].sub(e[r.segment])._unit()._mult(v),y=[r.sub(g),r.add(g)];this._addLineCollisionBoxes(t,y,r,0,v,m,n,i,a)}else this._addLineCollisionBoxes(t,e,r,r.segment,v,m,n,i,a)}else t.emplaceBack(r.x,r.y,d,h,p,f,1/0,n,i,a,0,0,0,0,0);this.boxEndIndex=t.length}e.exports=n,n.prototype._addLineCollisionBoxes=function(t,e,r,n,i,a,o,s,l){var u=a/2,c=Math.floor(i/u),h=-a/2,f=this.boxes,d=r,p=n+1,m=h;do{if(--p<0)return f;m-=e[p].dist(d),d=e[p]}while(m>-i/2);for(var v=e[p].dist(e[p+1]),g=0;g<c;g++){for(var y=-i/2+g*u;m+v<y;){if(m+=v,++p+1>=e.length)return f;v=e[p].dist(e[p+1])}var b=y-m,x=e[p],_=e[p+1],w=_.sub(x)._unit()._mult(b)._add(x)._round(),M=Math.max(Math.abs(y-h)-u/2,0),k=i/2/M;t.emplaceBack(w.x,w.y,-a/2,-a/2,a/2,a/2,k,o,s,l,0,0,0,0,0)}return f}},{}],395:[function(t,e,r){\"use strict\";function n(t,e,r){if(\"object\"==typeof t){var n=t;r=e,t=n.angle,e=n.pitch,this.grid=new o(n.grid),this.ignoredGrid=new o(n.ignoredGrid)}else this.grid=new o(a,12,6),this.ignoredGrid=new o(a,12,0);this.angle=t,this.pitch=e;var i=Math.sin(t),s=Math.cos(t);if(this.rotationMatrix=[s,-i,i,s],this.reverseRotationMatrix=[s,i,-i,s],this.yStretch=1/Math.cos(e/180*Math.PI),this.yStretch=Math.pow(this.yStretch,1.3),this.collisionBoxArray=r,0===r.length){r.emplaceBack();r.emplaceBack(0,0,0,-32767,0,32767,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(a,0,0,-32767,0,32767,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(0,0,-32767,0,32767,0,32767,0,0,0,0,0,0,0,0,0),r.emplaceBack(0,a,-32767,0,32767,0,32767,0,0,0,0,0,0,0,0,0)}this.tempCollisionBox=r.get(0),this.edges=[r.get(1),r.get(2),r.get(3),r.get(4)]}var i=t(\"point-geometry\"),a=t(\"../data/bucket\").EXTENT,o=t(\"grid-index\");e.exports=n,n.prototype.serialize=function(){var t={angle:this.angle,pitch:this.pitch,grid:this.grid.toArrayBuffer(),ignoredGrid:this.ignoredGrid.toArrayBuffer()};return{data:t,transferables:[t.grid,t.ignoredGrid]}},n.prototype.minScale=.25,n.prototype.maxScale=2,n.prototype.placeCollisionFeature=function(t,e,r){for(var n=this.collisionBoxArray,a=this.minScale,o=this.rotationMatrix,s=this.yStretch,l=t.boxStartIndex;l<t.boxEndIndex;l++){var u=n.get(l),c=u.anchorPoint._matMult(o),h=c.x,f=c.y,d=h+u.x1,p=f+u.y1*s,m=h+u.x2,v=f+u.y2*s;if(u.bbox0=d,u.bbox1=p,u.bbox2=m,u.bbox3=v,!e)for(var g=this.grid.query(d,p,m,v),y=0;y<g.length;y++){var b=n.get(g[y]),x=b.anchorPoint._matMult(o);if((a=this.getPlacementScale(a,c,u,x,b))>=this.maxScale)return a}if(r){var _;if(this.angle){var w=this.reverseRotationMatrix,M=new i(u.x1,u.y1).matMult(w),k=new i(u.x2,u.y1).matMult(w),A=new i(u.x1,u.y2).matMult(w),T=new i(u.x2,u.y2).matMult(w);_=this.tempCollisionBox,_.anchorPointX=u.anchorPoint.x,_.anchorPointY=u.anchorPoint.y,_.x1=Math.min(M.x,k.x,A.x,T.x),_.y1=Math.min(M.y,k.x,A.x,T.x),_.x2=Math.max(M.x,k.x,A.x,T.x),_.y2=Math.max(M.y,k.x,A.x,T.x),_.maxScale=u.maxScale}else _=u;for(var S=0;S<this.edges.length;S++){var E=this.edges[S];if((a=this.getPlacementScale(a,u.anchorPoint,_,E.anchorPoint,E))>=this.maxScale)return a}}}return a},n.prototype.queryRenderedSymbols=function(t,e,r,n,a){var o={},s=[],l=this.collisionBoxArray,u=this.rotationMatrix,c=new i(t,e)._matMult(u),h=this.tempCollisionBox;h.anchorX=c.x,h.anchorY=c.y,h.x1=0,h.y1=0,h.x2=r-t,h.y2=n-e,h.maxScale=a,a=h.maxScale;for(var f=[c.x+h.x1/a,c.y+h.y1/a*this.yStretch,c.x+h.x2/a,c.y+h.y2/a*this.yStretch],d=this.grid.query(f[0],f[1],f[2],f[3]),p=this.ignoredGrid.query(f[0],f[1],f[2],f[3]),m=0;m<p.length;m++)d.push(p[m]);for(var v=0;v<d.length;v++){var g=l.get(d[v]),y=g.sourceLayerIndex,b=g.featureIndex;if(void 0===o[y]&&(o[y]={}),!o[y][b]){var x=g.anchorPoint.matMult(u);this.getPlacementScale(this.minScale,c,h,x,g)>=a&&(o[y][b]=!0,s.push(d[v]))}}return s},n.prototype.getPlacementScale=function(t,e,r,n,i){var a=e.x-n.x,o=e.y-n.y,s=(i.x1-r.x2)/a,l=(i.x2-r.x1)/a,u=(i.y1-r.y2)*this.yStretch/o,c=(i.y2-r.y1)*this.yStretch/o;(isNaN(s)||isNaN(l))&&(s=l=1),(isNaN(u)||isNaN(c))&&(u=c=1);var h=Math.min(Math.max(s,l),Math.max(u,c)),f=i.maxScale,d=r.maxScale;return h>f&&(h=f),h>d&&(h=d),h>t&&h>=i.placementScale&&(t=h),t},n.prototype.insertCollisionFeature=function(t,e,r){for(var n=r?this.ignoredGrid:this.grid,i=this.collisionBoxArray,a=t.boxStartIndex;a<t.boxEndIndex;a++){var o=i.get(a);o.placementScale=e,e<this.maxScale&&n.insert(a,o.bbox0,o.bbox1,o.bbox2,o.bbox3)}}},{\"../data/bucket\":328,\"grid-index\":286,\"point-geometry\":483}],396:[function(t,e,r){\"use strict\";function n(t,e,r,n,a,o,s,l,u){var c=n?.6*o*s:0,h=Math.max(n?n.right-n.left:0,a?a.right-a.left:0),f=0===t[0].x||t[0].x===u||0===t[0].y||t[0].y===u;e-h*s<e/4&&(e=h*s+e/4);var d=2*o;return i(t,f?e/2*l%e:(h/2+d)*s*l%e,e,c,r,h*s,f,!1,u)}function i(t,e,r,n,l,u,c,h,f){for(var d=u/2,p=0,m=0;m<t.length-1;m++)p+=t[m].dist(t[m+1]);for(var v=0,g=e-r,y=[],b=0;b<t.length-1;b++){for(var x=t[b],_=t[b+1],w=x.dist(_),M=_.angleTo(x);g+r<v+w;){g+=r;var k=(g-v)/w,A=a(x.x,_.x,k),T=a(x.y,_.y,k);if(A>=0&&A<f&&T>=0&&T<f&&g-d>=0&&g+d<=p){var S=new o(A,T,M,b)._round();n&&!s(t,S,u,n,l)||y.push(S)}}v+=w}return h||y.length||c||(y=i(t,v/2,r,n,l,u,c,!0,f)),y}var a=t(\"../util/interpolate\"),o=t(\"../symbol/anchor\"),s=t(\"./check_max_angle\");e.exports=n},{\"../symbol/anchor\":390,\"../util/interpolate\":435,\"./check_max_angle\":391}],397:[function(t,e,r){\"use strict\";function n(){this.width=o,this.height=o,this.bin=new i(this.width,this.height),this.index={},this.ids={},this.data=new Uint8Array(this.width*this.height)}var i=t(\"shelf-pack\"),a=t(\"../util/util\"),o=128;e.exports=n,n.prototype.getGlyphs=function(){var t,e,r,n={};for(var i in this.ids)t=i.split(\"#\"),e=t[0],r=t[1],n[e]||(n[e]=[]),n[e].push(r);return n},n.prototype.getRects=function(){var t,e,r,n={};for(var i in this.ids)t=i.split(\"#\"),e=t[0],r=t[1],n[e]||(n[e]={}),n[e][r]=this.index[i];return n},n.prototype.addGlyph=function(t,e,r,n){if(!r)return null;var i=e+\"#\"+r.id;if(this.index[i])return this.ids[i].indexOf(t)<0&&this.ids[i].push(t),this.index[i];if(!r.bitmap)return null;var o=r.width+2*n,s=r.height+2*n,l=o+2,u=s+2;l+=4-l%4,u+=4-u%4;var c=this.bin.packOne(l,u);if(c||(this.resize(),c=this.bin.packOne(l,u)),!c)return a.warnOnce(\"glyph bitmap overflow\"),null;this.index[i]=c,this.ids[i]=[t];for(var h=this.data,f=r.bitmap,d=0;d<s;d++)for(var p=this.width*(c.y+d+1)+c.x+1,m=o*d,v=0;v<o;v++)h[p+v]=f[m+v];return this.dirty=!0,c},n.prototype.resize=function(){var t=this.width,e=this.height;if(!(t>=2048||e>=2048)){this.texture&&(this.gl&&this.gl.deleteTexture(this.texture),this.texture=null),this.width*=4,this.height*=4,this.bin.resize(this.width,this.height);for(var r=new ArrayBuffer(this.width*this.height),n=0;n<e;n++){var i=new Uint8Array(this.data.buffer,e*n,t);new Uint8Array(r,e*n*4,t).set(i)}this.data=new Uint8Array(r)}},n.prototype.bind=function(t){this.gl=t,this.texture?t.bindTexture(t.TEXTURE_2D,this.texture):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,t.LINEAR),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),t.texImage2D(t.TEXTURE_2D,0,t.ALPHA,this.width,this.height,0,t.ALPHA,t.UNSIGNED_BYTE,null))},n.prototype.updateTexture=function(t){this.bind(t),this.dirty&&(t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width,this.height,t.ALPHA,t.UNSIGNED_BYTE,this.data),this.dirty=!1)}},{\"../util/util\":441,\"shelf-pack\":513}],398:[function(t,e,r){\"use strict\";function n(t){this.url=t&&o(t),this.atlases={},this.stacks={},this.loading={}}function i(t,e,r){this.advance=t.advance,this.left=t.left-r-1,this.top=t.top+r+1,this.rect=e}function a(t,e,r,n){return n=n||\"abc\",r.replace(\"{s}\",n[t.length%n.length]).replace(\"{fontstack}\",t).replace(\"{range}\",e)}var o=t(\"../util/mapbox\").normalizeGlyphsURL,s=t(\"../util/ajax\").getArrayBuffer,l=t(\"../util/glyphs\"),u=t(\"../symbol/glyph_atlas\"),c=t(\"pbf\");e.exports=n,n.prototype.getSimpleGlyphs=function(t,e,r,n){void 0===this.stacks[t]&&(this.stacks[t]={}),void 0===this.atlases[t]&&(this.atlases[t]=new u);for(var a,o={},s=this.stacks[t],l=this.atlases[t],c={},h=0,f=0;f<e.length;f++){var d=e[f];if(a=Math.floor(d/256),s[a]){var p=s[a].glyphs[d],m=l.addGlyph(r,t,p,3);p&&(o[d]=new i(p,m,3))}else void 0===c[a]&&(c[a]=[],h++),c[a].push(d)}h||n(void 0,o,t);var v=function(e,a,s){if(!e)for(var u=this.stacks[t][a]=s.stacks[0],f=0;f<c[a].length;f++){var d=c[a][f],p=u.glyphs[d],m=l.addGlyph(r,t,p,3);p&&(o[d]=new i(p,m,3))}--h||n(void 0,o,t)}.bind(this);for(var g in c)this.loadRange(t,g,v)},n.prototype.loadRange=function(t,e,r){if(256*e>65535)return r(\"glyphs > 65535 not supported\");void 0===this.loading[t]&&(this.loading[t]={});var n=this.loading[t];if(n[e])n[e].push(r);else{n[e]=[r];var i=256*e+\"-\"+(256*e+255),o=a(t,i,this.url);s(o,function(t,r){for(var i=!t&&new l(new c(new Uint8Array(r))),a=0;a<n[e].length;a++)n[e][a](t,e,i);delete n[e]})}},n.prototype.getGlyphAtlas=function(t){return this.atlases[t]}},{\"../symbol/glyph_atlas\":397,\"../util/ajax\":424,\"../util/glyphs\":434,\"../util/mapbox\":438,pbf:477}],399:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){function n(n){c.push(t[n]),h.push(r[n]),f.push(e[n]),d++}function i(t,e,r){var n=u[t];return delete u[t],u[e]=n,h[n][0].pop(),h[n][0]=h[n][0].concat(r[0]),n}function a(t,e,r){var n=l[e];return delete l[e],l[t]=n,h[n][0].shift(),h[n][0]=r[0].concat(h[n][0]),n}function o(t,e,r){var n=r?e[0][e[0].length-1]:e[0][0];return t+\":\"+n.x+\":\"+n.y}var s,l={},u={},c=[],h=[],f=[],d=0;for(s=0;s<t.length;s++){var p=r[s],m=e[s];if(m){var v=o(m,p),g=o(m,p,!0);if(v in u&&g in l&&u[v]!==l[g]){var y=a(v,g,p),b=i(v,g,h[y]);delete l[v],delete u[g],u[o(m,h[b],!0)]=b,h[y]=null}else v in u?i(v,g,p):g in l?a(v,g,p):(n(s),l[v]=d-1,u[g]=d-1)}else n(s)}return{features:c,textFeatures:f,geometries:h}}},{}],400:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u){this.anchorPoint=t,this.tl=e,this.tr=r,this.bl=n,this.br=i,this.tex=a,this.anchorAngle=o,this.glyphAngle=s,this.minScale=l,this.maxScale=u}function i(t,e,r,i,a,o,u,c,h){var f,d,p,m,v=e.image.rect,g=a.layout,y=e.left-1,b=y+v.w/e.image.pixelRatio,x=e.top-1,_=x+v.h/e.image.pixelRatio;if(\"none\"!==g[\"icon-text-fit\"]&&u){var w=b-y,M=_-x,k=g[\"text-size\"]/24,A=u.left*k,T=u.right*k,S=u.top*k,E=u.bottom*k,L=T-A,C=E-S,z=g[\"icon-text-fit-padding\"][0],I=g[\"icon-text-fit-padding\"][1],D=g[\"icon-text-fit-padding\"][2],P=g[\"icon-text-fit-padding\"][3],O=\"width\"===g[\"icon-text-fit\"]?.5*(C-M):0,R=\"height\"===g[\"icon-text-fit\"]?.5*(L-w):0,F=\"width\"===g[\"icon-text-fit\"]||\"both\"===g[\"icon-text-fit\"]?L:w,j=\"height\"===g[\"icon-text-fit\"]||\"both\"===g[\"icon-text-fit\"]?C:M;f=new s(A+R-P,S+O-z),d=new s(A+R+I+F,S+O-z),p=new s(A+R+I+F,S+O+D+j),m=new s(A+R-P,S+O+D+j)}else f=new s(y,x),d=new s(b,x),p=new s(b,_),m=new s(y,_);var N=a.getLayoutValue(\"icon-rotate\",c,h)*Math.PI/180;if(o){var B=i[t.segment];if(t.y===B.y&&t.x===B.x&&t.segment+1<i.length){var U=i[t.segment+1];N+=Math.atan2(t.y-U.y,t.x-U.x)+Math.PI}else N+=Math.atan2(t.y-B.y,t.x-B.x)}if(N){var V=Math.sin(N),H=Math.cos(N),q=[H,-V,V,H];f=f.matMult(q),d=d.matMult(q),m=m.matMult(q),p=p.matMult(q)}return[new n(new s(t.x,t.y),f,d,m,p,e.image.rect,0,0,l,1/0)]}function a(t,e,r,i,a,u){for(var c=a.layout[\"text-rotate\"]*Math.PI/180,h=a.layout[\"text-keep-upright\"],f=e.positionedGlyphs,d=[],p=0;p<f.length;p++){var m=f[p],v=m.glyph,g=v.rect;if(g){var y,b=(m.x+v.advance/2)*r,x=l;u?(y=[],x=o(y,t,b,i,t.segment,!0),h&&(x=Math.min(x,o(y,t,b,i,t.segment,!1)))):y=[{anchorPoint:new s(t.x,t.y),offset:0,angle:0,maxScale:1/0,minScale:l}];for(var _=m.x+v.left,w=m.y-v.top,M=_+g.w,k=w+g.h,A=new s(_,w),T=new s(M,w),S=new s(_,k),E=new s(M,k),L=0;L<y.length;L++){var C=y[L],z=A,I=T,D=S,P=E;if(c){var O=Math.sin(c),R=Math.cos(c),F=[R,-O,O,R];z=z.matMult(F),I=I.matMult(F),D=D.matMult(F),P=P.matMult(F)}var j=Math.max(C.minScale,x),N=(t.angle+C.offset+2*Math.PI)%(2*Math.PI),B=(C.angle+C.offset+2*Math.PI)%(2*Math.PI);d.push(new n(C.anchorPoint,z,I,D,P,g,N,B,j,C.maxScale))}}}return d}function o(t,e,r,n,i,a){var o=!a;r<0&&(a=!a),a&&i++;var u=new s(e.x,e.y),c=n[i],h=1/0;r=Math.abs(r);for(var f=l;;){var d=u.dist(c),p=r/d,m=Math.atan2(c.y-u.y,c.x-u.x);if(a||(m+=Math.PI),t.push({anchorPoint:u,offset:o?Math.PI:0,minScale:p,maxScale:h,angle:(m+2*Math.PI)%(2*Math.PI)}),p<=f)break;for(u=c;u.equals(c);)if(i+=a?1:-1,!(c=n[i]))return p;var v=c.sub(u)._unit();u=u.sub(v._mult(d)),h=p}return f}var s=t(\"point-geometry\");e.exports={getIconQuads:i,getGlyphQuads:a,SymbolQuad:n};var l=.5},{\"point-geometry\":483}],401:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=[],a=0,o=t.length;a<o;a++){var s=i(t[a].properties,e[\"text-field\"]);if(s){s=s.toString();var l=e[\"text-transform\"];\"uppercase\"===l?s=s.toLocaleUpperCase():\"lowercase\"===l&&(s=s.toLocaleLowerCase());for(var u=0;u<s.length;u++)r[s.charCodeAt(u)]=!0;n[a]=s}else n[a]=null}return n}var i=t(\"../util/token\");e.exports=n},{\"../util/token\":440}],402:[function(t,e,r){\"use strict\";function n(t,e,r,n){this.codePoint=t,this.x=e,this.y=r,this.glyph=n}function i(t,e,r,n,i,a){this.positionedGlyphs=t,this.text=e,this.top=r,this.bottom=n,this.left=i,this.right=a}function a(t,e,r,a,s,l,u,c,h){for(var f=[],d=new i(f,t,h[1],h[1],h[0],h[0]),p=0,m=0;m<t.length;m++){var v=t.charCodeAt(m),g=e[v];g&&(f.push(new n(v,p,-17,g)),p+=g.advance+c)}return!!f.length&&(o(d,e,a,r,s,l,u,h),d)}function o(t,e,r,n,i,a,o,u){var c=null,d=0,p=0,m=0,v=0,g=t.positionedGlyphs;if(n)for(var y=0;y<g.length;y++){var b=g[y];if(b.x-=d,b.y+=r*m,b.x>n&&null!==c){var x=g[c+1].x;v=Math.max(x,v);for(var _=c+1;_<=y;_++)g[_].y+=r,g[_].x-=x;if(o){var w=c;h[g[c].codePoint]&&w--,s(g,e,p,w,o)}p=c+1,c=null,d+=x,m++}f[b.codePoint]&&(c=y)}var M=g[g.length-1],k=M.x+e[M.codePoint].advance;v=Math.max(v,k);var A=(m+1)*r;s(g,e,p,g.length-1,o),l(g,o,i,a,v,r,m,u),t.top+=-a*A,t.bottom=t.top+A,t.left+=-i*v,t.right=t.left+v}function s(t,e,r,n,i){for(var a=e[t[n].codePoint].advance,o=(t[n].x+a)*i,s=r;s<=n;s++)t[s].x-=o}\n",
       "function l(t,e,r,n,i,a,o,s){for(var l=(e-r)*i+s[0],u=(-n*(o+1)+.5)*a+s[1],c=0;c<t.length;c++)t[c].x+=l,t[c].y+=u}function u(t,e){if(!t||!t.rect)return null;var r=e[\"icon-offset\"][0],n=e[\"icon-offset\"][1],i=r-t.width/2,a=i+t.width,o=n-t.height/2;return new c(t,o,o+t.height,i,a)}function c(t,e,r,n,i){this.image=t,this.top=e,this.bottom=r,this.left=n,this.right=i}e.exports={shapeText:a,shapeIcon:u};var h={32:!0,8203:!0},f={32:!0,38:!0,43:!0,45:!0,47:!0,173:!0,183:!0,8203:!0,8208:!0,8211:!0}},{}],403:[function(t,e,r){\"use strict\";function n(t,e){this.width=t,this.height=e,this.bin=new o(t,e),this.images={},this.data=!1,this.texture=0,this.filter=0,this.pixelRatio=1,this.dirty=!0}function i(t,e,r,n,i,a,o,s,l,u,c){var h,f,d=n*e+r,p=s*a+o;if(c)for(p-=a,f=-1;f<=u;f++,d=((f+u)%u+n)*e+r,p+=a)for(h=-1;h<=l;h++)i[p+h]=t[d+(h+l)%l];else for(f=0;f<u;f++,d+=e,p+=a)for(h=0;h<l;h++)i[p+h]=t[d+h]}function a(t,e,r,n,i){this.rect=t,this.width=e,this.height=r,this.sdf=n,this.pixelRatio=i}var o=t(\"shelf-pack\"),s=t(\"../util/browser\"),l=t(\"../util/util\");e.exports=n,n.prototype.allocateImage=function(t,e){t/=this.pixelRatio,e/=this.pixelRatio;var r=t+2+(4-(t+2)%4),n=e+2+(4-(e+2)%4),i=this.bin.packOne(r,n);return i||(l.warnOnce(\"SpriteAtlas out of space.\"),null)},n.prototype.getImage=function(t,e){if(this.images[t])return this.images[t];if(!this.sprite)return null;var r=this.sprite.getSpritePosition(t);if(!r.width||!r.height)return null;var n=this.allocateImage(r.width,r.height);if(!n)return null;var i=new a(n,r.width/r.pixelRatio,r.height/r.pixelRatio,r.sdf,r.pixelRatio/this.pixelRatio);return this.images[t]=i,this.copy(n,r,e),i},n.prototype.getPosition=function(t,e){var r=this.getImage(t,e),n=r&&r.rect;if(!n)return null;var i=r.width*r.pixelRatio,a=r.height*r.pixelRatio;return{size:[r.width,r.height],tl:[(n.x+1)/this.width,(n.y+1)/this.height],br:[(n.x+1+i)/this.width,(n.y+1+a)/this.height]}},n.prototype.allocate=function(){if(!this.data){var t=Math.floor(this.width*this.pixelRatio),e=Math.floor(this.height*this.pixelRatio);this.data=new Uint32Array(t*e);for(var r=0;r<this.data.length;r++)this.data[r]=0}},n.prototype.copy=function(t,e,r){if(this.sprite.img.data){var n=new Uint32Array(this.sprite.img.data.buffer);this.allocate();var a=this.data;i(n,this.sprite.img.width,e.x,e.y,a,this.width*this.pixelRatio,(t.x+1)*this.pixelRatio,(t.y+1)*this.pixelRatio,e.width,e.height,r),this.dirty=!0}},n.prototype.setSprite=function(t){t&&(this.pixelRatio=s.devicePixelRatio>1?2:1,this.canvas&&(this.canvas.width=this.width*this.pixelRatio,this.canvas.height=this.height*this.pixelRatio)),this.sprite=t},n.prototype.addIcons=function(t,e){for(var r=0;r<t.length;r++)this.getImage(t[r]);e(null,this.images)},n.prototype.bind=function(t,e){var r=!1;this.texture?t.bindTexture(t.TEXTURE_2D,this.texture):(this.texture=t.createTexture(),t.bindTexture(t.TEXTURE_2D,this.texture),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),r=!0);var n=e?t.LINEAR:t.NEAREST;n!==this.filter&&(t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MIN_FILTER,n),t.texParameteri(t.TEXTURE_2D,t.TEXTURE_MAG_FILTER,n),this.filter=n),this.dirty&&(this.allocate(),r?t.texImage2D(t.TEXTURE_2D,0,t.RGBA,this.width*this.pixelRatio,this.height*this.pixelRatio,0,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array(this.data.buffer)):t.texSubImage2D(t.TEXTURE_2D,0,0,0,this.width*this.pixelRatio,this.height*this.pixelRatio,t.RGBA,t.UNSIGNED_BYTE,new Uint8Array(this.data.buffer)),this.dirty=!1)}},{\"../util/browser\":425,\"../util/util\":441,\"shelf-pack\":513}],404:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=e.exports=new n({members:[{type:\"Uint16\",name:\"textBoxStartIndex\"},{type:\"Uint16\",name:\"textBoxEndIndex\"},{type:\"Uint16\",name:\"iconBoxStartIndex\"},{type:\"Uint16\",name:\"iconBoxEndIndex\"},{type:\"Uint16\",name:\"glyphQuadStartIndex\"},{type:\"Uint16\",name:\"glyphQuadEndIndex\"},{type:\"Uint16\",name:\"iconQuadStartIndex\"},{type:\"Uint16\",name:\"iconQuadEndIndex\"},{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Int8\",name:\"index\"}]});i.extendAll(o.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"point-geometry\":483}],405:[function(t,e,r){\"use strict\";var n=t(\"../util/struct_array\"),i=t(\"../util/util\"),a=t(\"point-geometry\"),o=t(\"./quads\").SymbolQuad,s=e.exports=new n({members:[{type:\"Int16\",name:\"anchorPointX\"},{type:\"Int16\",name:\"anchorPointY\"},{type:\"Float32\",name:\"tlX\"},{type:\"Float32\",name:\"tlY\"},{type:\"Float32\",name:\"trX\"},{type:\"Float32\",name:\"trY\"},{type:\"Float32\",name:\"blX\"},{type:\"Float32\",name:\"blY\"},{type:\"Float32\",name:\"brX\"},{type:\"Float32\",name:\"brY\"},{type:\"Int16\",name:\"texH\"},{type:\"Int16\",name:\"texW\"},{type:\"Int16\",name:\"texX\"},{type:\"Int16\",name:\"texY\"},{type:\"Float32\",name:\"anchorAngle\"},{type:\"Float32\",name:\"glyphAngle\"},{type:\"Float32\",name:\"maxScale\"},{type:\"Float32\",name:\"minScale\"}]});i.extendAll(s.prototype.StructType.prototype,{get anchorPoint(){return new a(this.anchorPointX,this.anchorPointY)},get SymbolQuad(){return new o(this.anchorPoint,new a(this.tlX,this.tlY),new a(this.trX,this.trY),new a(this.blX,this.blY),new a(this.brX,this.brY),{x:this.texX,y:this.texY,h:this.texH,w:this.texW,height:this.texH,width:this.texW},this.anchorAngle,this.glyphAngle,this.minScale,this.maxScale)}})},{\"../util/struct_array\":439,\"../util/util\":441,\"./quads\":400,\"point-geometry\":483}],406:[function(t,e,r){\"use strict\";var n=t(\"../util/dom\"),i=t(\"point-geometry\"),a={scrollZoom:t(\"./handler/scroll_zoom\"),boxZoom:t(\"./handler/box_zoom\"),dragRotate:t(\"./handler/drag_rotate\"),dragPan:t(\"./handler/drag_pan\"),keyboard:t(\"./handler/keyboard\"),doubleClickZoom:t(\"./handler/dblclick_zoom\"),touchZoomRotate:t(\"./handler/touch_zoom_rotate\")};e.exports=function(t,e){function r(t){g(\"mouseout\",t)}function o(e){t.stop(),_=n.mousePos(b,e),g(\"mousedown\",e)}function s(e){var r=t.dragRotate&&t.dragRotate.isActive();x&&!r&&g(\"contextmenu\",x),x=null,g(\"mouseup\",e)}function l(e){if(!(t.dragPan&&t.dragPan.isActive()||t.dragRotate&&t.dragRotate.isActive())){for(var r=e.toElement||e.target;r&&r!==b;)r=r.parentNode;r===b&&g(\"mousemove\",e)}}function u(e){t.stop(),y(\"touchstart\",e),!e.touches||e.touches.length>1||(w?(clearTimeout(w),w=null,g(\"dblclick\",e)):w=setTimeout(d,300))}function c(t){y(\"touchmove\",t)}function h(t){y(\"touchend\",t)}function f(t){y(\"touchcancel\",t)}function d(){w=null}function p(t){n.mousePos(b,t).equals(_)&&g(\"click\",t)}function m(t){g(\"dblclick\",t),t.preventDefault()}function v(t){x=t,t.preventDefault()}function g(e,r){var i=n.mousePos(b,r);return t.fire(e,{lngLat:t.unproject(i),point:i,originalEvent:r})}function y(e,r){var a=n.touchPos(b,r),o=a.reduce(function(t,e,r,n){return t.add(e.div(n.length))},new i(0,0));return t.fire(e,{lngLat:t.unproject(o),point:o,lngLats:a.map(function(e){return t.unproject(e)},this),points:a,originalEvent:r})}var b=t.getCanvasContainer(),x=null,_=null,w=null;for(var M in a)t[M]=new a[M](t,e),e.interactive&&e[M]&&t[M].enable();b.addEventListener(\"mouseout\",r,!1),b.addEventListener(\"mousedown\",o,!1),b.addEventListener(\"mouseup\",s,!1),b.addEventListener(\"mousemove\",l,!1),b.addEventListener(\"touchstart\",u,!1),b.addEventListener(\"touchend\",h,!1),b.addEventListener(\"touchmove\",c,!1),b.addEventListener(\"touchcancel\",f,!1),b.addEventListener(\"click\",p,!1),b.addEventListener(\"dblclick\",m,!1),b.addEventListener(\"contextmenu\",v,!1)}},{\"../util/dom\":427,\"./handler/box_zoom\":412,\"./handler/dblclick_zoom\":413,\"./handler/drag_pan\":414,\"./handler/drag_rotate\":415,\"./handler/keyboard\":416,\"./handler/scroll_zoom\":417,\"./handler/touch_zoom_rotate\":418,\"point-geometry\":483}],407:[function(t,e,r){\"use strict\";var n=t(\"../util/util\"),i=t(\"../util/interpolate\"),a=t(\"../util/browser\"),o=t(\"../geo/lng_lat\"),s=t(\"../geo/lng_lat_bounds\"),l=t(\"point-geometry\"),u=e.exports=function(){};n.extend(u.prototype,{getCenter:function(){return this.transform.center},setCenter:function(t,e){return this.jumpTo({center:t},e),this},panBy:function(t,e,r){return this.panTo(this.transform.center,n.extend({offset:l.convert(t).mult(-1)},e),r),this},panTo:function(t,e,r){return this.easeTo(n.extend({center:t},e),r)},getZoom:function(){return this.transform.zoom},setZoom:function(t,e){return this.jumpTo({zoom:t},e),this},zoomTo:function(t,e,r){return this.easeTo(n.extend({zoom:t},e),r)},zoomIn:function(t,e){return this.zoomTo(this.getZoom()+1,t,e),this},zoomOut:function(t,e){return this.zoomTo(this.getZoom()-1,t,e),this},getBearing:function(){return this.transform.bearing},setBearing:function(t,e){return this.jumpTo({bearing:t},e),this},rotateTo:function(t,e,r){return this.easeTo(n.extend({bearing:t},e),r)},resetNorth:function(t,e){return this.rotateTo(0,n.extend({duration:1e3},t),e),this},snapToNorth:function(t,e){return Math.abs(this.getBearing())<this._bearingSnap?this.resetNorth(t,e):this},getPitch:function(){return this.transform.pitch},setPitch:function(t,e){return this.jumpTo({pitch:t},e),this},fitBounds:function(t,e,r){e=n.extend({padding:0,offset:[0,0],maxZoom:1/0},e),t=s.convert(t);var i=l.convert(e.offset),a=this.transform,o=a.project(t.getNorthWest()),u=a.project(t.getSouthEast()),c=u.sub(o),h=(a.width-2*e.padding-2*Math.abs(i.x))/c.x,f=(a.height-2*e.padding-2*Math.abs(i.y))/c.y;return e.center=a.unproject(o.add(u).div(2)),e.zoom=Math.min(a.scaleZoom(a.scale*Math.min(h,f)),e.maxZoom),e.bearing=0,e.linear?this.easeTo(e,r):this.flyTo(e,r)},jumpTo:function(t,e){this.stop();var r=this.transform,n=!1,i=!1,a=!1;return\"zoom\"in t&&r.zoom!==+t.zoom&&(n=!0,r.zoom=+t.zoom),\"center\"in t&&(r.center=o.convert(t.center)),\"bearing\"in t&&r.bearing!==+t.bearing&&(i=!0,r.bearing=+t.bearing),\"pitch\"in t&&r.pitch!==+t.pitch&&(a=!0,r.pitch=+t.pitch),this.fire(\"movestart\",e).fire(\"move\",e),n&&this.fire(\"zoomstart\",e).fire(\"zoom\",e).fire(\"zoomend\",e),i&&this.fire(\"rotate\",e),a&&this.fire(\"pitch\",e),this.fire(\"moveend\",e)},easeTo:function(t,e){this.stop(),t=n.extend({offset:[0,0],duration:500,easing:n.ease},t);var r,a,s=this.transform,u=l.convert(t.offset),c=this.getZoom(),h=this.getBearing(),f=this.getPitch(),d=\"zoom\"in t?+t.zoom:c,p=\"bearing\"in t?this._normalizeBearing(t.bearing,h):h,m=\"pitch\"in t?+t.pitch:f;\"center\"in t?(r=o.convert(t.center),a=s.centerPoint.add(u)):\"around\"in t?(r=o.convert(t.around),a=s.locationPoint(r)):(a=s.centerPoint.add(u),r=s.pointLocation(a));var v=s.locationPoint(r);return!1===t.animate&&(t.duration=0),this.zooming=d!==c,this.rotating=h!==p,this.pitching=m!==f,t.noMoveStart||this.fire(\"movestart\",e),this.zooming&&this.fire(\"zoomstart\",e),clearTimeout(this._onEaseEnd),this._ease(function(t){this.zooming&&(s.zoom=i(c,d,t)),this.rotating&&(s.bearing=i(h,p,t)),this.pitching&&(s.pitch=i(f,m,t)),s.setLocationAtPoint(r,v.add(a.sub(v)._mult(t))),this.fire(\"move\",e),this.zooming&&this.fire(\"zoom\",e),this.rotating&&this.fire(\"rotate\",e),this.pitching&&this.fire(\"pitch\",e)},function(){t.delayEndEvents?this._onEaseEnd=setTimeout(this._easeToEnd.bind(this,e),t.delayEndEvents):this._easeToEnd(e)}.bind(this),t),this},_easeToEnd:function(t){var e=this.zooming;this.zooming=!1,this.rotating=!1,this.pitching=!1,e&&this.fire(\"zoomend\",t),this.fire(\"moveend\",t)},flyTo:function(t,e){function r(t){var e=(A*A-k*k+(t?-1:1)*L*L*T*T)/(2*(t?A:k)*L*T);return Math.log(Math.sqrt(e*e+1)-e)}function a(t){return(Math.exp(t)-Math.exp(-t))/2}function s(t){return(Math.exp(t)+Math.exp(-t))/2}function u(t){return a(t)/s(t)}this.stop(),t=n.extend({offset:[0,0],speed:1.2,curve:1.42,easing:n.ease},t);var c=this.transform,h=l.convert(t.offset),f=this.getZoom(),d=this.getBearing(),p=this.getPitch(),m=\"center\"in t?o.convert(t.center):this.getCenter(),v=\"zoom\"in t?+t.zoom:f,g=\"bearing\"in t?this._normalizeBearing(t.bearing,d):d,y=\"pitch\"in t?+t.pitch:p;Math.abs(c.center.lng)+Math.abs(m.lng)>180&&(c.center.lng>0&&m.lng<0?m.lng+=360:c.center.lng<0&&m.lng>0&&(m.lng-=360));var b=c.zoomScale(v-f),x=c.point,_=\"center\"in t?c.project(m).sub(h.div(b)):x,w=c.worldSize,M=t.curve,k=Math.max(c.width,c.height),A=k/b,T=_.sub(x).mag();if(\"minZoom\"in t){var S=n.clamp(Math.min(t.minZoom,f,v),c.minZoom,c.maxZoom),E=k/c.zoomScale(S-f);M=Math.sqrt(E/T*2)}var L=M*M,C=r(0),z=function(t){return s(C)/s(C+M*t)},I=function(t){return k*((s(C)*u(C+M*t)-a(C))/L)/T},D=(r(1)-C)/M;if(Math.abs(T)<1e-6){if(Math.abs(k-A)<1e-6)return this.easeTo(t);var P=A<k?-1:1;D=Math.abs(Math.log(A/k))/M,I=function(){return 0},z=function(t){return Math.exp(P*M*t)}}if(\"duration\"in t)t.duration=+t.duration;else{var O=\"screenSpeed\"in t?+t.screenSpeed/M:+t.speed;t.duration=1e3*D/O}return this.zooming=!0,d!==g&&(this.rotating=!0),p!==y&&(this.pitching=!0),this.fire(\"movestart\",e),this.fire(\"zoomstart\",e),this._ease(function(t){var r=t*D,n=I(r);c.zoom=f+c.scaleZoom(1/z(r)),c.center=c.unproject(x.add(_.sub(x).mult(n)),w),this.rotating&&(c.bearing=i(d,g,t)),this.pitching&&(c.pitch=i(p,y,t)),this.fire(\"move\",e),this.fire(\"zoom\",e),this.rotating&&this.fire(\"rotate\",e),this.pitching&&this.fire(\"pitch\",e)},function(){this.zooming=!1,this.rotating=!1,this.pitching=!1,this.fire(\"zoomend\",e),this.fire(\"moveend\",e)},t),this},isEasing:function(){return!!this._abortFn},stop:function(){return this._abortFn&&(this._abortFn(),this._finishEase()),this},_ease:function(t,e,r){this._finishFn=e,this._abortFn=a.timed(function(e){t.call(this,r.easing(e)),1===e&&this._finishEase()},!1===r.animate?0:r.duration,this)},_finishEase:function(){delete this._abortFn;var t=this._finishFn;delete this._finishFn,t.call(this)},_normalizeBearing:function(t,e){t=n.wrap(t,-180,180);var r=Math.abs(t-e);return Math.abs(t-360-e)<r&&(t-=360),Math.abs(t+360-e)<r&&(t+=360),t},_updateEasing:function(t,e,r){var i;if(this.ease){var a=this.ease,o=(Date.now()-a.start)/a.duration,s=a.easing(o+.01)-a.easing(o),l=.27/Math.sqrt(s*s+1e-4)*.01,u=Math.sqrt(.0729-l*l);i=n.bezier(l,u,.25,1)}else i=r?n.bezier.apply(n,r):n.ease;return this.ease={start:(new Date).getTime(),to:Math.pow(2,e),duration:t,easing:i},i}})},{\"../geo/lng_lat\":338,\"../geo/lng_lat_bounds\":339,\"../util/browser\":425,\"../util/interpolate\":435,\"../util/util\":441,\"point-geometry\":483}],408:[function(t,e,r){\"use strict\";function n(t){o.setOptions(this,t)}var i=t(\"./control\"),a=t(\"../../util/dom\"),o=t(\"../../util/util\");e.exports=n,n.createAttributionString=function(t){var e=[];for(var r in t){var n=t[r];n.attribution&&e.indexOf(n.attribution)<0&&e.push(n.attribution)}return e.sort(function(t,e){return t.length-e.length}),e=e.filter(function(t,r){for(var n=r+1;n<e.length;n++)if(e[n].indexOf(t)>=0)return!1;return!0}),e.join(\" | \")},n.prototype=o.inherit(i,{options:{position:\"bottom-right\"},onAdd:function(t){var e=this._container=a.create(\"div\",\"mapboxgl-ctrl-attrib\",t.getContainer());return this._update(),t.on(\"source.load\",this._update.bind(this)),t.on(\"source.change\",this._update.bind(this)),t.on(\"source.remove\",this._update.bind(this)),t.on(\"moveend\",this._updateEditLink.bind(this)),e},_update:function(){this._map.style&&(this._container.innerHTML=n.createAttributionString(this._map.style.sources)),this._editLink=this._container.getElementsByClassName(\"mapbox-improve-map\")[0],this._updateEditLink()},_updateEditLink:function(){if(this._editLink){var t=this._map.getCenter();this._editLink.href=\"https://www.mapbox.com/map-feedback/#/\"+t.lng+\"/\"+t.lat+\"/\"+Math.round(this._map.getZoom()+1)}}})},{\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],409:[function(t,e,r){\"use strict\";function n(){}var i=t(\"../../util/util\"),a=t(\"../../util/evented\");e.exports=n,n.prototype={addTo:function(t){this._map=t;var e=this._container=this.onAdd(t);if(this.options&&this.options.position){var r=this.options.position,n=t._controlCorners[r];e.className+=\" mapboxgl-ctrl\",-1!==r.indexOf(\"bottom\")?n.insertBefore(e,n.firstChild):n.appendChild(e)}return this},remove:function(){return this._container.parentNode.removeChild(this._container),this.onRemove&&this.onRemove(this._map),this._map=null,this}},i.extend(n.prototype,a)},{\"../../util/evented\":433,\"../../util/util\":441}],410:[function(t,e,r){\"use strict\";function n(t){s.setOptions(this,t)}var i=t(\"./control\"),a=t(\"../../util/browser\"),o=t(\"../../util/dom\"),s=t(\"../../util/util\");e.exports=n;var l={enableHighAccuracy:!1,timeout:6e3};n.prototype=s.inherit(i,{options:{position:\"top-right\"},onAdd:function(t){var e=this._container=o.create(\"div\",\"mapboxgl-ctrl-group\",t.getContainer());return a.supportsGeolocation?(this._container.addEventListener(\"contextmenu\",this._onContextMenu.bind(this)),this._geolocateButton=o.create(\"button\",\"mapboxgl-ctrl-icon mapboxgl-ctrl-geolocate\",this._container),this._geolocateButton.type=\"button\",this._geolocateButton.addEventListener(\"click\",this._onClickGeolocate.bind(this)),e):e},_onContextMenu:function(t){t.preventDefault()},_onClickGeolocate:function(){navigator.geolocation.getCurrentPosition(this._success.bind(this),this._error.bind(this),l),this._timeoutId=setTimeout(this._finish.bind(this),1e4)},_success:function(t){this._map.jumpTo({center:[t.coords.longitude,t.coords.latitude],zoom:17,bearing:0,pitch:0}),this.fire(\"geolocate\",t),this._finish()},_error:function(t){this.fire(\"error\",t),this._finish()},_finish:function(){this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=void 0}})},{\"../../util/browser\":425,\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],411:[function(t,e,r){\"use strict\";function n(t){s.setOptions(this,t)}function i(t){return new MouseEvent(t.type,{button:2,buttons:2,bubbles:!0,cancelable:!0,detail:t.detail,view:t.view,screenX:t.screenX,screenY:t.screenY,clientX:t.clientX,clientY:t.clientY,movementX:t.movementX,movementY:t.movementY,ctrlKey:t.ctrlKey,shiftKey:t.shiftKey,altKey:t.altKey,metaKey:t.metaKey})}var a=t(\"./control\"),o=t(\"../../util/dom\"),s=t(\"../../util/util\");e.exports=n,n.prototype=s.inherit(a,{options:{position:\"top-right\"},onAdd:function(t){var e=\"mapboxgl-ctrl\",r=this._container=o.create(\"div\",e+\"-group\",t.getContainer());return this._container.addEventListener(\"contextmenu\",this._onContextMenu.bind(this)),this._zoomInButton=this._createButton(e+\"-icon \"+e+\"-zoom-in\",t.zoomIn.bind(t)),this._zoomOutButton=this._createButton(e+\"-icon \"+e+\"-zoom-out\",t.zoomOut.bind(t)),this._compass=this._createButton(e+\"-icon \"+e+\"-compass\",t.resetNorth.bind(t)),this._compassArrow=o.create(\"div\",\"arrow\",this._compass),this._compass.addEventListener(\"mousedown\",this._onCompassDown.bind(this)),this._onCompassMove=this._onCompassMove.bind(this),this._onCompassUp=this._onCompassUp.bind(this),t.on(\"rotate\",this._rotateCompassArrow.bind(this)),this._rotateCompassArrow(),this._el=t.getCanvasContainer(),r},_onContextMenu:function(t){t.preventDefault()},_onCompassDown:function(t){0===t.button&&(o.disableDrag(),document.addEventListener(\"mousemove\",this._onCompassMove),document.addEventListener(\"mouseup\",this._onCompassUp),this._el.dispatchEvent(i(t)),t.stopPropagation())},_onCompassMove:function(t){0===t.button&&(this._el.dispatchEvent(i(t)),t.stopPropagation())},_onCompassUp:function(t){0===t.button&&(document.removeEventListener(\"mousemove\",this._onCompassMove),document.removeEventListener(\"mouseup\",this._onCompassUp),o.enableDrag(),this._el.dispatchEvent(i(t)),t.stopPropagation())},_createButton:function(t,e){var r=o.create(\"button\",t,this._container);return r.type=\"button\",r.addEventListener(\"click\",function(){e()}),r},_rotateCompassArrow:function(){var t=\"rotate(\"+this._map.transform.angle*(180/Math.PI)+\"deg)\";this._compassArrow.style.transform=t}})},{\"../../util/dom\":427,\"../../util/util\":441,\"./control\":409}],412:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),this._container=t.getContainer(),o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../geo/lng_lat_bounds\"),o=t(\"../../util/util\");e.exports=n,n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onMouseDown,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onMouseDown),this._enabled=!1)},_onMouseDown:function(t){t.shiftKey&&0===t.button&&(document.addEventListener(\"mousemove\",this._onMouseMove,!1),document.addEventListener(\"keydown\",this._onKeyDown,!1),document.addEventListener(\"mouseup\",this._onMouseUp,!1),i.disableDrag(),this._startPos=i.mousePos(this._el,t),this._active=!0)},_onMouseMove:function(t){var e=this._startPos,r=i.mousePos(this._el,t);this._box||(this._box=i.create(\"div\",\"mapboxgl-boxzoom\",this._container),this._container.classList.add(\"mapboxgl-crosshair\"),this._fireEvent(\"boxzoomstart\",t));var n=Math.min(e.x,r.x),a=Math.max(e.x,r.x),o=Math.min(e.y,r.y),s=Math.max(e.y,r.y);i.setTransform(this._box,\"translate(\"+n+\"px,\"+o+\"px)\"),this._box.style.width=a-n+\"px\",this._box.style.height=s-o+\"px\"},_onMouseUp:function(t){if(0===t.button){var e=this._startPos,r=i.mousePos(this._el,t),n=new a(this._map.unproject(e),this._map.unproject(r));this._finish(),e.x===r.x&&e.y===r.y?this._fireEvent(\"boxzoomcancel\",t):this._map.fitBounds(n,{linear:!0}).fire(\"boxzoomend\",{originalEvent:t,boxZoomBounds:n})}},_onKeyDown:function(t){27===t.keyCode&&(this._finish(),this._fireEvent(\"boxzoomcancel\",t))},_finish:function(){this._active=!1,document.removeEventListener(\"mousemove\",this._onMouseMove,!1),document.removeEventListener(\"keydown\",this._onKeyDown,!1),document.removeEventListener(\"mouseup\",this._onMouseUp,!1),this._container.classList.remove(\"mapboxgl-crosshair\"),this._box&&(this._box.parentNode.removeChild(this._box),this._box=null),i.enableDrag()},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})}}},{\"../../geo/lng_lat_bounds\":339,\"../../util/dom\":427,\"../../util/util\":441}],413:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._onDblClick=this._onDblClick.bind(this)}e.exports=n,n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._map.on(\"dblclick\",this._onDblClick),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._map.off(\"dblclick\",this._onDblClick),this._enabled=!1)},_onDblClick:function(t){this._map.zoomTo(this._map.getZoom()+(t.originalEvent.shiftKey?-1:1),{around:t.lngLat},t)}}},{}],414:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),a.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/util\");e.exports=n;var o=a.bezier(0,0,.3,1);n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onDown),this._el.addEventListener(\"touchstart\",this._onDown),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onDown),this._el.removeEventListener(\"touchstart\",this._onDown),this._enabled=!1)},_onDown:function(t){this._ignoreEvent(t)||this.isActive()||(t.touches?(document.addEventListener(\"touchmove\",this._onMove),document.addEventListener(\"touchend\",this._onTouchEnd)):(document.addEventListener(\"mousemove\",this._onMove),document.addEventListener(\"mouseup\",this._onMouseUp)),this._active=!1,this._startPos=this._pos=i.mousePos(this._el,t),this._inertia=[[Date.now(),this._pos]])},_onMove:function(t){if(!this._ignoreEvent(t)){this.isActive()||(this._active=!0,this._fireEvent(\"dragstart\",t),this._fireEvent(\"movestart\",t));var e=i.mousePos(this._el,t),r=this._map;r.stop(),this._drainInertiaBuffer(),this._inertia.push([Date.now(),e]),r.transform.setLocationAtPoint(r.transform.pointLocation(this._pos),e),this._fireEvent(\"drag\",t),this._fireEvent(\"move\",t),this._pos=e,t.preventDefault()}},_onUp:function(t){if(this.isActive()){this._active=!1,this._fireEvent(\"dragend\",t),this._drainInertiaBuffer();var e=function(){this._fireEvent(\"moveend\",t)}.bind(this),r=this._inertia;if(r.length<2)return void e();var n=r[r.length-1],i=r[0],a=n[1].sub(i[1]),s=(n[0]-i[0])/1e3;if(0===s||n[1].equals(i[1]))return void e();var l=a.mult(.3/s),u=l.mag();u>1400&&(u=1400,l._unit()._mult(u));var c=u/750,h=l.mult(-c/2);this._map.panBy(h,{duration:1e3*c,easing:o,noMoveStart:!0},{originalEvent:t})}},_onMouseUp:function(t){this._ignoreEvent(t)||(this._onUp(t),document.removeEventListener(\"mousemove\",this._onMove),document.removeEventListener(\"mouseup\",this._onMouseUp))},_onTouchEnd:function(t){this._ignoreEvent(t)||(this._onUp(t),document.removeEventListener(\"touchmove\",this._onMove),document.removeEventListener(\"touchend\",this._onTouchEnd))},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})},_ignoreEvent:function(t){var e=this._map;if(e.boxZoom&&e.boxZoom.isActive())return!0;if(e.dragRotate&&e.dragRotate.isActive())return!0;if(t.touches)return t.touches.length>1;if(t.ctrlKey)return!0;return\"mousemove\"===t.type?!1&t.buttons:0!==t.button},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>0&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441}],415:[function(t,e,r){\"use strict\";function n(t,e){this._map=t,this._el=t.getCanvasContainer(),this._bearingSnap=e.bearingSnap,o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"point-geometry\"),o=t(\"../../util/util\");e.exports=n;var s=o.bezier(0,0,.25,1);n.prototype={_enabled:!1,_active:!1,isEnabled:function(){return this._enabled},isActive:function(){return this._active},enable:function(){this.isEnabled()||(this._el.addEventListener(\"mousedown\",this._onDown),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"mousedown\",this._onDown),this._enabled=!1)},_onDown:function(t){if(!this._ignoreEvent(t)&&!this.isActive()){document.addEventListener(\"mousemove\",this._onMove),document.addEventListener(\"mouseup\",this._onUp),this._active=!1,this._inertia=[[Date.now(),this._map.getBearing()]],this._startPos=this._pos=i.mousePos(this._el,t),this._center=this._map.transform.centerPoint;var e=this._startPos.sub(this._center);e.mag()<200&&(this._center=this._startPos.add(new a(-200,0)._rotate(e.angle()))),t.preventDefault()}},_onMove:function(t){if(!this._ignoreEvent(t)){this.isActive()||(this._active=!0,this._fireEvent(\"rotatestart\",t),this._fireEvent(\"movestart\",t));var e=this._map;e.stop();var r=this._pos,n=i.mousePos(this._el,t),a=this._center,o=r.sub(a).angleWith(n.sub(a))/Math.PI*180,s=e.getBearing()-o,l=this._inertia,u=l[l.length-1];this._drainInertiaBuffer(),l.push([Date.now(),e._normalizeBearing(s,u[1])]),e.transform.bearing=s,this._fireEvent(\"rotate\",t),this._fireEvent(\"move\",t),this._pos=n}},_onUp:function(t){if(!this._ignoreEvent(t)&&(document.removeEventListener(\"mousemove\",this._onMove),document.removeEventListener(\"mouseup\",this._onUp),this.isActive())){this._active=!1,this._fireEvent(\"rotateend\",t),this._drainInertiaBuffer();var e=this._map,r=e.getBearing(),n=this._inertia,i=function(){Math.abs(r)<this._bearingSnap?e.resetNorth({noMoveStart:!0},{originalEvent:t}):this._fireEvent(\"moveend\",t)}.bind(this);if(n.length<2)return void i();var a=n[0],o=n[n.length-1],l=n[n.length-2],u=e._normalizeBearing(r,l[1]),c=o[1]-a[1],h=c<0?-1:1,f=(o[0]-a[0])/1e3;if(0===c||0===f)return void i();var d=Math.abs(c*(.25/f));d>180&&(d=180);var p=d/180;u+=h*d*(p/2),Math.abs(e._normalizeBearing(u,0))<this._bearingSnap&&(u=e._normalizeBearing(0,u)),e.rotateTo(u,{duration:1e3*p,easing:s,noMoveStart:!0},{originalEvent:t})}},_fireEvent:function(t,e){return this._map.fire(t,{originalEvent:e})},_ignoreEvent:function(t){var e=this._map;if(e.boxZoom&&e.boxZoom.isActive())return!0;if(e.dragPan&&e.dragPan.isActive())return!0;if(t.touches)return t.touches.length>1;var r=t.ctrlKey?1:2,n=t.ctrlKey?0:2;return\"mousemove\"===t.type?t.buttons&0===r:t.button!==n},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>0&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441,\"point-geometry\":483}],416:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),this._onKeyDown=this._onKeyDown.bind(this)}e.exports=n;n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"keydown\",this._onKeyDown,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"keydown\",this._onKeyDown),this._enabled=!1)},_onKeyDown:function(t){if(!(t.altKey||t.ctrlKey||t.metaKey)){var e=this._map,r={originalEvent:t};if(!e.isEasing())switch(t.keyCode){case 61:case 107:case 171:case 187:e.zoomTo(Math.round(e.getZoom())+(t.shiftKey?2:1),r);break;case 189:case 109:case 173:e.zoomTo(Math.round(e.getZoom())-(t.shiftKey?2:1),r);break;case 37:t.shiftKey?e.easeTo({bearing:e.getBearing()-2},r):(t.preventDefault(),e.panBy([-80,0],r));break;case 39:t.shiftKey?e.easeTo({bearing:e.getBearing()+2},r):(t.preventDefault(),e.panBy([80,0],r));break;case 38:t.shiftKey?e.easeTo({pitch:e.getPitch()+5},r):(t.preventDefault(),e.panBy([0,-80],r));break;case 40:t.shiftKey?e.easeTo({pitch:Math.max(e.getPitch()-5,0)},r):(t.preventDefault(),e.panBy([0,80],r))}}}}},{}],417:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),o.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/browser\"),o=t(\"../../util/util\");e.exports=n;var s=\"undefined\"!=typeof navigator?navigator.userAgent.toLowerCase():\"\",l=-1!==s.indexOf(\"firefox\"),u=-1!==s.indexOf(\"safari\")&&-1===s.indexOf(\"chrom\");n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"wheel\",this._onWheel,!1),this._el.addEventListener(\"mousewheel\",this._onWheel,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"wheel\",this._onWheel),this._el.removeEventListener(\"mousewheel\",this._onWheel),this._enabled=!1)},_onWheel:function(t){var e;\"wheel\"===t.type?(e=t.deltaY,l&&t.deltaMode===window.WheelEvent.DOM_DELTA_PIXEL&&(e/=a.devicePixelRatio),t.deltaMode===window.WheelEvent.DOM_DELTA_LINE&&(e*=40)):\"mousewheel\"===t.type&&(e=-t.wheelDeltaY,u&&(e/=3));var r=a.now(),n=r-(this._time||0);this._pos=i.mousePos(this._el,t),this._time=r,0!==e&&e%4.000244140625==0?(this._type=\"wheel\",e=Math.floor(e/4)):0!==e&&Math.abs(e)<4?this._type=\"trackpad\":n>400?(this._type=null,this._lastValue=e,this._timeout=setTimeout(this._onTimeout,40)):this._type||(this._type=Math.abs(n*e)<200?\"trackpad\":\"wheel\",this._timeout&&(clearTimeout(this._timeout),this._timeout=null,e+=this._lastValue)),t.shiftKey&&e&&(e/=4),this._type&&this._zoom(-e,t),t.preventDefault()},_onTimeout:function(){this._type=\"wheel\",this._zoom(-this._lastValue)},_zoom:function(t,e){if(0!==t){var r=this._map,n=2/(1+Math.exp(-Math.abs(t/100)));t<0&&0!==n&&(n=1/n);var i=r.ease?r.ease.to:r.transform.scale,a=r.transform.scaleZoom(i*n);r.zoomTo(a,{duration:0,around:r.unproject(this._pos),delayEndEvents:200},{originalEvent:e})}}}},{\"../../util/browser\":425,\"../../util/dom\":427,\"../../util/util\":441}],418:[function(t,e,r){\"use strict\";function n(t){this._map=t,this._el=t.getCanvasContainer(),a.bindHandlers(this)}var i=t(\"../../util/dom\"),a=t(\"../../util/util\");e.exports=n;var o=a.bezier(0,0,.15,1);n.prototype={_enabled:!1,isEnabled:function(){return this._enabled},enable:function(){this.isEnabled()||(this._el.addEventListener(\"touchstart\",this._onStart,!1),this._enabled=!0)},disable:function(){this.isEnabled()&&(this._el.removeEventListener(\"touchstart\",this._onStart),this._enabled=!1)},disableRotation:function(){this._rotationDisabled=!0},enableRotation:function(){this._rotationDisabled=!1},_onStart:function(t){if(2===t.touches.length){var e=i.mousePos(this._el,t.touches[0]),r=i.mousePos(this._el,t.touches[1]);this._startVec=e.sub(r),this._startScale=this._map.transform.scale,this._startBearing=this._map.transform.bearing,this._gestureIntent=void 0,this._inertia=[],\n",
       "document.addEventListener(\"touchmove\",this._onMove,!1),document.addEventListener(\"touchend\",this._onEnd,!1)}},_onMove:function(t){if(2===t.touches.length){var e=i.mousePos(this._el,t.touches[0]),r=i.mousePos(this._el,t.touches[1]),n=e.add(r).div(2),a=e.sub(r),o=a.mag()/this._startVec.mag(),s=this._rotationDisabled?0:180*a.angleWith(this._startVec)/Math.PI,l=this._map;if(this._gestureIntent){var u={duration:0,around:l.unproject(n)};\"rotate\"===this._gestureIntent&&(u.bearing=this._startBearing+s),\"zoom\"!==this._gestureIntent&&\"rotate\"!==this._gestureIntent||(u.zoom=l.transform.scaleZoom(this._startScale*o)),l.stop(),this._drainInertiaBuffer(),this._inertia.push([Date.now(),o,n]),l.easeTo(u,{originalEvent:t})}else{var c=Math.abs(1-o)>.15;Math.abs(s)>4?this._gestureIntent=\"rotate\":c&&(this._gestureIntent=\"zoom\"),this._gestureIntent&&(this._startVec=a,this._startScale=l.transform.scale,this._startBearing=l.transform.bearing)}t.preventDefault()}},_onEnd:function(t){document.removeEventListener(\"touchmove\",this._onMove),document.removeEventListener(\"touchend\",this._onEnd),this._drainInertiaBuffer();var e=this._inertia,r=this._map;if(e.length<2)return void r.snapToNorth({},{originalEvent:t});var n=e[e.length-1],i=e[0],a=r.transform.scaleZoom(this._startScale*n[1]),s=r.transform.scaleZoom(this._startScale*i[1]),l=a-s,u=(n[0]-i[0])/1e3,c=n[2];if(0===u||a===s)return void r.snapToNorth({},{originalEvent:t});var h=.15*l/u;Math.abs(h)>2.5&&(h=h>0?2.5:-2.5);var f=1e3*Math.abs(h/(12*.15)),d=a+h*f/2e3;d<0&&(d=0),r.easeTo({zoom:d,duration:f,easing:o,around:r.unproject(c)},{originalEvent:t})},_drainInertiaBuffer:function(){for(var t=this._inertia,e=Date.now();t.length>2&&e-t[0][0]>160;)t.shift()}}},{\"../../util/dom\":427,\"../../util/util\":441}],419:[function(t,e,r){\"use strict\";function n(){i.bindAll([\"_onHashChange\",\"_updateHash\"],this)}e.exports=n;var i=t(\"../util/util\");n.prototype={addTo:function(t){return this._map=t,window.addEventListener(\"hashchange\",this._onHashChange,!1),this._map.on(\"moveend\",this._updateHash),this},remove:function(){return window.removeEventListener(\"hashchange\",this._onHashChange,!1),this._map.off(\"moveend\",this._updateHash),delete this._map,this},_onHashChange:function(){var t=location.hash.replace(\"#\",\"\").split(\"/\");return t.length>=3&&(this._map.jumpTo({center:[+t[2],+t[1]],zoom:+t[0],bearing:+(t[3]||0)}),!0)},_updateHash:function(){var t=this._map.getCenter(),e=this._map.getZoom(),r=this._map.getBearing(),n=Math.max(0,Math.ceil(Math.log(e)/Math.LN2)),i=\"#\"+Math.round(100*e)/100+\"/\"+t.lat.toFixed(n)+\"/\"+t.lng.toFixed(n)+(r?\"/\"+Math.round(10*r)/10:\"\");window.history.replaceState(\"\",\"\",i)}}},{\"../util/util\":441}],420:[function(t,e,r){\"use strict\";function n(t){t.parentNode&&t.parentNode.removeChild(t)}var i=t(\"../util/canvas\"),a=t(\"../util/util\"),o=t(\"../util/browser\"),s=t(\"../util/browser\").window,l=t(\"../util/evented\"),u=t(\"../util/dom\"),c=t(\"../style/style\"),h=t(\"../style/animation_loop\"),f=t(\"../render/painter\"),d=t(\"../geo/transform\"),p=t(\"./hash\"),m=t(\"./bind_handlers\"),v=t(\"./camera\"),g=t(\"../geo/lng_lat\"),y=t(\"../geo/lng_lat_bounds\"),b=t(\"point-geometry\"),x=t(\"./control/attribution\"),_={center:[0,0],zoom:0,bearing:0,pitch:0,minZoom:0,maxZoom:20,interactive:!0,scrollZoom:!0,boxZoom:!0,dragRotate:!0,dragPan:!0,keyboard:!0,doubleClickZoom:!0,touchZoomRotate:!0,bearingSnap:7,hash:!1,attributionControl:!0,failIfMajorPerformanceCaveat:!1,preserveDrawingBuffer:!1,trackResize:!0,workerCount:Math.max(o.hardwareConcurrency-1,1)},w=e.exports=function(t){if(t=a.extend({},_,t),t.workerCount<1)throw new Error(\"workerCount must an integer greater than or equal to 1.\");this._interactive=t.interactive,this._failIfMajorPerformanceCaveat=t.failIfMajorPerformanceCaveat,this._preserveDrawingBuffer=t.preserveDrawingBuffer,this._trackResize=t.trackResize,this._workerCount=t.workerCount,this._bearingSnap=t.bearingSnap,\"string\"==typeof t.container?this._container=document.getElementById(t.container):this._container=t.container,this.animationLoop=new h,this.transform=new d(t.minZoom,t.maxZoom),t.maxBounds&&this.setMaxBounds(t.maxBounds),a.bindAll([\"_forwardStyleEvent\",\"_forwardSourceEvent\",\"_forwardLayerEvent\",\"_forwardTileEvent\",\"_onStyleLoad\",\"_onStyleChange\",\"_onSourceAdd\",\"_onSourceRemove\",\"_onSourceUpdate\",\"_onWindowOnline\",\"_onWindowResize\",\"_update\",\"_render\"],this),this._setupContainer(),this._setupPainter(),this.on(\"move\",this._update.bind(this,!1)),this.on(\"zoom\",this._update.bind(this,!0)),this.on(\"moveend\",function(){this.animationLoop.set(300),this._rerender()}.bind(this)),void 0!==s&&(s.addEventListener(\"online\",this._onWindowOnline,!1),s.addEventListener(\"resize\",this._onWindowResize,!1)),m(this,t),this._hash=t.hash&&(new p).addTo(this),this._hash&&this._hash._onHashChange()||this.jumpTo({center:t.center,zoom:t.zoom,bearing:t.bearing,pitch:t.pitch}),this.stacks={},this._classes=[],this.resize(),t.classes&&this.setClasses(t.classes),t.style&&this.setStyle(t.style),t.attributionControl&&this.addControl(new x(t.attributionControl));var e=this.fire.bind(this,\"error\");this.on(\"style.error\",e),this.on(\"source.error\",e),this.on(\"tile.error\",e),this.on(\"layer.error\",e)};a.extend(w.prototype,l),a.extend(w.prototype,v.prototype),a.extend(w.prototype,{addControl:function(t){return t.addTo(this),this},addClass:function(t,e){return this._classes.indexOf(t)>=0||\"\"===t?this:(this._classes.push(t),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0))},removeClass:function(t,e){var r=this._classes.indexOf(t);return r<0||\"\"===t?this:(this._classes.splice(r,1),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0))},setClasses:function(t,e){for(var r={},n=0;n<t.length;n++)\"\"!==t[n]&&(r[t[n]]=!0);return this._classes=Object.keys(r),this._classOptions=e,this.style&&this.style.updateClasses(),this._update(!0)},hasClass:function(t){return this._classes.indexOf(t)>=0},getClasses:function(){return this._classes},resize:function(){var t=0,e=0;return this._container&&(t=this._container.offsetWidth||400,e=this._container.offsetHeight||300),this._canvas.resize(t,e),this.transform.resize(t,e),this.painter.resize(t,e),this.fire(\"movestart\").fire(\"move\").fire(\"resize\").fire(\"moveend\")},getBounds:function(){var t=new y(this.transform.pointLocation(new b(0,0)),this.transform.pointLocation(this.transform.size));return(this.transform.angle||this.transform.pitch)&&(t.extend(this.transform.pointLocation(new b(this.transform.size.x,0))),t.extend(this.transform.pointLocation(new b(0,this.transform.size.y)))),t},setMaxBounds:function(t){if(t){var e=y.convert(t);this.transform.lngRange=[e.getWest(),e.getEast()],this.transform.latRange=[e.getSouth(),e.getNorth()],this.transform._constrain(),this._update()}else null!==t&&void 0!==t||(this.transform.lngRange=[],this.transform.latRange=[],this._update());return this},setMinZoom:function(t){if((t=null===t||void 0===t?0:t)>=0&&t<=this.transform.maxZoom)return this.transform.minZoom=t,this._update(),this.getZoom()<t&&this.setZoom(t),this;throw new Error(\"minZoom must be between 0 and the current maxZoom, inclusive\")},setMaxZoom:function(t){if((t=null===t||void 0===t?20:t)>=this.transform.minZoom&&t<=20)return this.transform.maxZoom=t,this._update(),this.getZoom()>t&&this.setZoom(t),this;throw new Error(\"maxZoom must be between the current minZoom and 20, inclusive\")},project:function(t){return this.transform.locationPoint(g.convert(t))},unproject:function(t){return this.transform.pointLocation(b.convert(t))},queryRenderedFeatures:function(){var t,e={};return 2===arguments.length?(t=arguments[0],e=arguments[1]):1===arguments.length&&function(t){return t instanceof b||Array.isArray(t)}(arguments[0])?t=arguments[0]:1===arguments.length&&(e=arguments[0]),this.style.queryRenderedFeatures(this._makeQueryGeometry(t),e,this.transform.zoom,this.transform.angle)},_makeQueryGeometry:function(t){void 0===t&&(t=[b.convert([0,0]),b.convert([this.transform.width,this.transform.height])]);var e;if(t instanceof b||\"number\"==typeof t[0])e=[b.convert(t)];else{var r=[b.convert(t[0]),b.convert(t[1])];e=[r[0],new b(r[1].x,r[0].y),r[1],new b(r[0].x,r[1].y),r[0]]}return e=e.map(function(t){return this.transform.pointCoordinate(t)}.bind(this))},querySourceFeatures:function(t,e){return this.style.querySourceFeatures(t,e)},setStyle:function(t){return this.style&&(this.style.off(\"load\",this._onStyleLoad).off(\"error\",this._forwardStyleEvent).off(\"change\",this._onStyleChange).off(\"source.add\",this._onSourceAdd).off(\"source.remove\",this._onSourceRemove).off(\"source.load\",this._onSourceUpdate).off(\"source.error\",this._forwardSourceEvent).off(\"source.change\",this._onSourceUpdate).off(\"layer.add\",this._forwardLayerEvent).off(\"layer.remove\",this._forwardLayerEvent).off(\"layer.error\",this._forwardLayerEvent).off(\"tile.add\",this._forwardTileEvent).off(\"tile.remove\",this._forwardTileEvent).off(\"tile.load\",this._update).off(\"tile.error\",this._forwardTileEvent).off(\"tile.stats\",this._forwardTileEvent)._remove(),this.off(\"rotate\",this.style._redoPlacement),this.off(\"pitch\",this.style._redoPlacement)),t?(this.style=t instanceof c?t:new c(t,this.animationLoop,this._workerCount),this.style.on(\"load\",this._onStyleLoad).on(\"error\",this._forwardStyleEvent).on(\"change\",this._onStyleChange).on(\"source.add\",this._onSourceAdd).on(\"source.remove\",this._onSourceRemove).on(\"source.load\",this._onSourceUpdate).on(\"source.error\",this._forwardSourceEvent).on(\"source.change\",this._onSourceUpdate).on(\"layer.add\",this._forwardLayerEvent).on(\"layer.remove\",this._forwardLayerEvent).on(\"layer.error\",this._forwardLayerEvent).on(\"tile.add\",this._forwardTileEvent).on(\"tile.remove\",this._forwardTileEvent).on(\"tile.load\",this._update).on(\"tile.error\",this._forwardTileEvent).on(\"tile.stats\",this._forwardTileEvent),this.on(\"rotate\",this.style._redoPlacement),this.on(\"pitch\",this.style._redoPlacement),this):(this.style=null,this)},getStyle:function(){if(this.style)return this.style.serialize()},addSource:function(t,e){return this.style.addSource(t,e),this._update(!0),this},addSourceType:function(t,e,r){return this.style.addSourceType(t,e,r)},removeSource:function(t){return this.style.removeSource(t),this._update(!0),this},getSource:function(t){return this.style.getSource(t)},addLayer:function(t,e){return this.style.addLayer(t,e),this._update(!0),this},removeLayer:function(t){return this.style.removeLayer(t),this._update(!0),this},getLayer:function(t){return this.style.getLayer(t)},setFilter:function(t,e){return this.style.setFilter(t,e),this._update(!0),this},setLayerZoomRange:function(t,e,r){return this.style.setLayerZoomRange(t,e,r),this._update(!0),this},getFilter:function(t){return this.style.getFilter(t)},setPaintProperty:function(t,e,r,n){return this.style.setPaintProperty(t,e,r,n),this._update(!0),this},getPaintProperty:function(t,e,r){return this.style.getPaintProperty(t,e,r)},setLayoutProperty:function(t,e,r){return this.style.setLayoutProperty(t,e,r),this._update(!0),this},getLayoutProperty:function(t,e){return this.style.getLayoutProperty(t,e)},getContainer:function(){return this._container},getCanvasContainer:function(){return this._canvasContainer},getCanvas:function(){return this._canvas.getElement()},_setupContainer:function(){var t=this._container;t.classList.add(\"mapboxgl-map\");var e=this._canvasContainer=u.create(\"div\",\"mapboxgl-canvas-container\",t);this._interactive&&e.classList.add(\"mapboxgl-interactive\"),this._canvas=new i(this,e);var r=this._controlContainer=u.create(\"div\",\"mapboxgl-control-container\",t),n=this._controlCorners={};[\"top-left\",\"top-right\",\"bottom-left\",\"bottom-right\"].forEach(function(t){n[t]=u.create(\"div\",\"mapboxgl-ctrl-\"+t,r)})},_setupPainter:function(){var t=this._canvas.getWebGLContext({failIfMajorPerformanceCaveat:this._failIfMajorPerformanceCaveat,preserveDrawingBuffer:this._preserveDrawingBuffer});if(!t)return void this.fire(\"error\",{error:new Error(\"Failed to initialize WebGL\")});this.painter=new f(t,this.transform)},_contextLost:function(t){t.preventDefault(),this._frameId&&o.cancelFrame(this._frameId),this.fire(\"webglcontextlost\",{originalEvent:t})},_contextRestored:function(t){this._setupPainter(),this.resize(),this._update(),this.fire(\"webglcontextrestored\",{originalEvent:t})},loaded:function(){return!this._styleDirty&&!this._sourcesDirty&&!(!this.style||!this.style.loaded())},_update:function(t){return this.style?(this._styleDirty=this._styleDirty||t,this._sourcesDirty=!0,this._rerender(),this):this},_render:function(){try{this.style&&this._styleDirty&&(this._styleDirty=!1,this.style.update(this._classes,this._classOptions),this._classOptions=null,this.style._recalculate(this.transform.zoom)),this.style&&this._sourcesDirty&&(this._sourcesDirty=!1,this.style._updateSources(this.transform)),this.painter.render(this.style,{debug:this.showTileBoundaries,showOverdrawInspector:this._showOverdrawInspector,vertices:this.vertices,rotating:this.rotating,zooming:this.zooming}),this.fire(\"render\"),this.loaded()&&!this._loaded&&(this._loaded=!0,this.fire(\"load\")),this._frameId=null,this.animationLoop.stopped()||(this._styleDirty=!0),(this._sourcesDirty||this._repaint||this._styleDirty)&&this._rerender()}catch(t){this.fire(\"error\",{error:t})}return this},remove:function(){this._hash&&this._hash.remove(),o.cancelFrame(this._frameId),this.setStyle(null),void 0!==s&&s.removeEventListener(\"resize\",this._onWindowResize,!1);var t=this.painter.gl.getExtension(\"WEBGL_lose_context\");t&&t.loseContext(),n(this._canvasContainer),n(this._controlContainer),this._container.classList.remove(\"mapboxgl-map\")},_rerender:function(){this.style&&!this._frameId&&(this._frameId=o.frame(this._render))},_forwardStyleEvent:function(t){this.fire(\"style.\"+t.type,a.extend({style:t.target},t))},_forwardSourceEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_forwardLayerEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_forwardTileEvent:function(t){this.fire(t.type,a.extend({style:t.target},t))},_onStyleLoad:function(t){this.transform.unmodified&&this.jumpTo(this.style.stylesheet),this.style.update(this._classes,{transition:!1}),this._forwardStyleEvent(t)},_onStyleChange:function(t){this._update(!0),this._forwardStyleEvent(t)},_onSourceAdd:function(t){var e=t.source;e.onAdd&&e.onAdd(this),this._forwardSourceEvent(t)},_onSourceRemove:function(t){var e=t.source;e.onRemove&&e.onRemove(this),this._forwardSourceEvent(t)},_onSourceUpdate:function(t){this._update(),this._forwardSourceEvent(t)},_onWindowOnline:function(){this._update()},_onWindowResize:function(){this._trackResize&&this.stop().resize()._update()}}),a.extendAll(w.prototype,{_showTileBoundaries:!1,get showTileBoundaries(){return this._showTileBoundaries},set showTileBoundaries(t){this._showTileBoundaries!==t&&(this._showTileBoundaries=t,this._update())},_showCollisionBoxes:!1,get showCollisionBoxes(){return this._showCollisionBoxes},set showCollisionBoxes(t){this._showCollisionBoxes!==t&&(this._showCollisionBoxes=t,this.style._redoPlacement())},_showOverdrawInspector:!1,get showOverdrawInspector(){return this._showOverdrawInspector},set showOverdrawInspector(t){this._showOverdrawInspector!==t&&(this._showOverdrawInspector=t,this._update())},_repaint:!1,get repaint(){return this._repaint},set repaint(t){this._repaint=t,this._update()},_vertices:!1,get vertices(){return this._vertices},set vertices(t){this._vertices=t,this._update()}})},{\"../geo/lng_lat\":338,\"../geo/lng_lat_bounds\":339,\"../geo/transform\":340,\"../render/painter\":354,\"../style/animation_loop\":374,\"../style/style\":377,\"../util/browser\":425,\"../util/canvas\":426,\"../util/dom\":427,\"../util/evented\":433,\"../util/util\":441,\"./bind_handlers\":406,\"./camera\":407,\"./control/attribution\":408,\"./hash\":419,\"point-geometry\":483}],421:[function(t,e,r){\"use strict\";function n(t,e){t||(t=i.create(\"div\")),t.classList.add(\"mapboxgl-marker\"),this._el=t,this._offset=o.convert(e&&e.offset||[0,0]),this._update=this._update.bind(this)}e.exports=n;var i=t(\"../util/dom\"),a=t(\"../geo/lng_lat\"),o=t(\"point-geometry\");n.prototype={addTo:function(t){return this.remove(),this._map=t,t.getCanvasContainer().appendChild(this._el),t.on(\"move\",this._update),this._update(),this},remove:function(){this._map&&(this._map.off(\"move\",this._update),this._map=null);var t=this._el.parentNode;return t&&t.removeChild(this._el),this},getLngLat:function(){return this._lngLat},setLngLat:function(t){return this._lngLat=a.convert(t),this._update(),this},getElement:function(){return this._el},_update:function(){if(this._map){var t=this._map.project(this._lngLat)._add(this._offset);i.setTransform(this._el,\"translate(\"+t.x+\"px,\"+t.y+\"px)\")}}}},{\"../geo/lng_lat\":338,\"../util/dom\":427,\"point-geometry\":483}],422:[function(t,e,r){\"use strict\";function n(t){i.setOptions(this,t),i.bindAll([\"_update\",\"_onClickClose\"],this)}e.exports=n;var i=t(\"../util/util\"),a=t(\"../util/evented\"),o=t(\"../util/dom\"),s=t(\"../geo/lng_lat\");n.prototype=i.inherit(a,{options:{closeButton:!0,closeOnClick:!0},addTo:function(t){return this._map=t,this._map.on(\"move\",this._update),this.options.closeOnClick&&this._map.on(\"click\",this._onClickClose),this._update(),this},remove:function(){return this._content&&this._content.parentNode&&this._content.parentNode.removeChild(this._content),this._container&&(this._container.parentNode.removeChild(this._container),delete this._container),this._map&&(this._map.off(\"move\",this._update),this._map.off(\"click\",this._onClickClose),delete this._map),this.fire(\"close\"),this},getLngLat:function(){return this._lngLat},setLngLat:function(t){return this._lngLat=s.convert(t),this._update(),this},setText:function(t){return this.setDOMContent(document.createTextNode(t))},setHTML:function(t){var e,r=document.createDocumentFragment(),n=document.createElement(\"body\");for(n.innerHTML=t;;){if(!(e=n.firstChild))break;r.appendChild(e)}return this.setDOMContent(r)},setDOMContent:function(t){return this._createContent(),this._content.appendChild(t),this._update(),this},_createContent:function(){this._content&&this._content.parentNode&&this._content.parentNode.removeChild(this._content),this._content=o.create(\"div\",\"mapboxgl-popup-content\",this._container),this.options.closeButton&&(this._closeButton=o.create(\"button\",\"mapboxgl-popup-close-button\",this._content),this._closeButton.type=\"button\",this._closeButton.innerHTML=\"&#215;\",this._closeButton.addEventListener(\"click\",this._onClickClose))},_update:function(){if(this._map&&this._lngLat&&this._content){this._container||(this._container=o.create(\"div\",\"mapboxgl-popup\",this._map.getContainer()),this._tip=o.create(\"div\",\"mapboxgl-popup-tip\",this._container),this._container.appendChild(this._content));var t=this._map.project(this._lngLat).round(),e=this.options.anchor;if(!e){var r=this._container.offsetWidth,n=this._container.offsetHeight;e=t.y<n?[\"top\"]:t.y>this._map.transform.height-n?[\"bottom\"]:[],t.x<r/2?e.push(\"left\"):t.x>this._map.transform.width-r/2&&e.push(\"right\"),e=0===e.length?\"bottom\":e.join(\"-\")}var i={top:\"translate(-50%,0)\",\"top-left\":\"translate(0,0)\",\"top-right\":\"translate(-100%,0)\",bottom:\"translate(-50%,-100%)\",\"bottom-left\":\"translate(0,-100%)\",\"bottom-right\":\"translate(-100%,-100%)\",left:\"translate(0,-50%)\",right:\"translate(-100%,-50%)\"},a=this._container.classList;for(var s in i)a.remove(\"mapboxgl-popup-anchor-\"+s);a.add(\"mapboxgl-popup-anchor-\"+e),o.setTransform(this._container,i[e]+\" translate(\"+t.x+\"px,\"+t.y+\"px)\")}},_onClickClose:function(){this.remove()}})},{\"../geo/lng_lat\":338,\"../util/dom\":427,\"../util/evented\":433,\"../util/util\":441}],423:[function(t,e,r){\"use strict\";function n(t,e){this.target=t,this.parent=e,this.callbacks={},this.callbackID=0,this.receive=this.receive.bind(this),this.target.addEventListener(\"message\",this.receive,!1)}e.exports=n,n.prototype.receive=function(t){function e(t,e,r){this.postMessage({type:\"<response>\",id:String(i),error:t?String(t):null,data:e},r)}var r,n=t.data,i=n.id;if(\"<response>\"===n.type)r=this.callbacks[n.id],delete this.callbacks[n.id],r&&r(n.error||null,n.data);else if(void 0!==n.id&&this.parent[n.type])this.parent[n.type](n.data,e.bind(this));else if(void 0!==n.id&&this.parent.workerSources){var a=n.type.split(\".\");this.parent.workerSources[a[0]][a[1]](n.data,e.bind(this))}else this.parent[n.type](n.data)},n.prototype.send=function(t,e,r,n){var i=null;r&&(this.callbacks[i=this.callbackID++]=r),this.postMessage({type:t,id:String(i),data:e},n)},n.prototype.postMessage=function(t,e){this.target.postMessage(t,e)}},{}],424:[function(t,e,r){\"use strict\";function n(t){var e=document.createElement(\"a\");return e.href=t,e.protocol===document.location.protocol&&e.host===document.location.host}r.getJSON=function(t,e){var r=new XMLHttpRequest;return r.open(\"GET\",t,!0),r.setRequestHeader(\"Accept\",\"application/json\"),r.onerror=function(t){e(t)},r.onload=function(){if(r.status>=200&&r.status<300&&r.response){var t;try{t=JSON.parse(r.response)}catch(t){return e(t)}e(null,t)}else e(new Error(r.statusText))},r.send(),r},r.getArrayBuffer=function(t,e){var r=new XMLHttpRequest;return r.open(\"GET\",t,!0),r.responseType=\"arraybuffer\",r.onerror=function(t){e(t)},r.onload=function(){r.status>=200&&r.status<300&&r.response?e(null,r.response):e(new Error(r.statusText))},r.send(),r},r.getImage=function(t,e){return r.getArrayBuffer(t,function(t,r){if(t)return e(t);var n=new Image;n.onload=function(){e(null,n),(window.URL||window.webkitURL).revokeObjectURL(n.src)};var i=new Blob([new Uint8Array(r)],{type:\"image/png\"});return n.src=(window.URL||window.webkitURL).createObjectURL(i),n.getData=function(){var t=document.createElement(\"canvas\"),e=t.getContext(\"2d\");return t.width=n.width,t.height=n.height,e.drawImage(n,0,0),e.getImageData(0,0,n.width,n.height).data},n})},r.getVideo=function(t,e){var r=document.createElement(\"video\");r.onloadstart=function(){e(null,r)};for(var i=0;i<t.length;i++){var a=document.createElement(\"source\");n(t[i])||(r.crossOrigin=\"Anonymous\"),a.src=t[i],r.appendChild(a)}return r.getData=function(){return r},r}},{}],425:[function(t,e,r){\"use strict\";r.window=window,e.exports.now=function(){return window.performance&&window.performance.now?window.performance.now.bind(window.performance):Date.now.bind(Date)}();var n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame;r.frame=function(t){return n(t)};var i=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame;r.cancelFrame=function(t){i(t)},r.timed=function(t,n,i){function a(l){o||(l=e.exports.now(),l>=s+n?t.call(i,1):(t.call(i,(l-s)/n),r.frame(a)))}if(!n)return t.call(i,1),null;var o=!1,s=e.exports.now();return r.frame(a),function(){o=!0}},r.supported=t(\"mapbox-gl-supported\"),r.hardwareConcurrency=navigator.hardwareConcurrency||4,Object.defineProperty(r,\"devicePixelRatio\",{get:function(){return window.devicePixelRatio}}),r.supportsWebp=!1;var a=document.createElement(\"img\");a.onload=function(){r.supportsWebp=!0},a.src=\"data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=\",r.supportsGeolocation=!!navigator.geolocation},{\"mapbox-gl-supported\":326}],426:[function(t,e,r){\"use strict\";function n(t,e){this.canvas=document.createElement(\"canvas\"),t&&e&&(this.canvas.style.position=\"absolute\",this.canvas.classList.add(\"mapboxgl-canvas\"),this.canvas.addEventListener(\"webglcontextlost\",t._contextLost.bind(t),!1),this.canvas.addEventListener(\"webglcontextrestored\",t._contextRestored.bind(t),!1),this.canvas.setAttribute(\"tabindex\",0),e.appendChild(this.canvas))}var i=t(\"../util\"),a=t(\"mapbox-gl-supported\");e.exports=n,n.prototype.resize=function(t,e){var r=window.devicePixelRatio||1;this.canvas.width=r*t,this.canvas.height=r*e,this.canvas.style.width=t+\"px\",this.canvas.style.height=e+\"px\"},n.prototype.getWebGLContext=function(t){return t=i.extend({},t,a.webGLContextAttributes),this.canvas.getContext(\"webgl\",t)||this.canvas.getContext(\"experimental-webgl\",t)},n.prototype.getElement=function(){return this.canvas}},{\"../util\":441,\"mapbox-gl-supported\":326}],427:[function(t,e,r){\"use strict\";function n(t){for(var e=0;e<t.length;e++)if(t[e]in s)return t[e]}function i(t){t.preventDefault(),t.stopPropagation(),window.removeEventListener(\"click\",i,!0)}var a=t(\"point-geometry\");r.create=function(t,e,r){var n=document.createElement(t);return e&&(n.className=e),r&&r.appendChild(n),n};var o,s=document.documentElement.style,l=n([\"userSelect\",\"MozUserSelect\",\"WebkitUserSelect\",\"msUserSelect\"]);r.disableDrag=function(){l&&(o=s[l],s[l]=\"none\")},r.enableDrag=function(){l&&(s[l]=o)};var u=n([\"transform\",\"WebkitTransform\"]);r.setTransform=function(t,e){t.style[u]=e},r.suppressClick=function(){window.addEventListener(\"click\",i,!0),window.setTimeout(function(){window.removeEventListener(\"click\",i,!0)},0)},r.mousePos=function(t,e){var r=t.getBoundingClientRect();return e=e.touches?e.touches[0]:e,new a(e.clientX-r.left-t.clientLeft,e.clientY-r.top-t.clientTop)},r.touchPos=function(t,e){for(var r=t.getBoundingClientRect(),n=[],i=0;i<e.touches.length;i++)n.push(new a(e.touches[i].clientX-r.left-t.clientLeft,e.touches[i].clientY-r.top-t.clientTop));return n}},{\"point-geometry\":483}],428:[function(t,e,r){\"use strict\";var n=t(\"webworkify\");e.exports=function(){return new n(t(\"../../source/worker\"))}},{\"../../source/worker\":372,webworkify:563}],429:[function(t,e,r){\"use strict\";function n(t,e){return e.area-t.area}function i(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r.x-e.x)*(e.y+r.y);return n}var a=t(\"quickselect\");e.exports=function(t,e){var r=t.length;if(r<=1)return[t];for(var o,s,l=[],u=0;u<r;u++){var c=i(t[u]);0!==c&&(t[u].area=Math.abs(c),void 0===s&&(s=c<0),s===c<0?(o&&l.push(o),o=[t[u]]):o.push(t[u]))}if(o&&l.push(o),e>1)for(var h=0;h<l.length;h++)l[h].length<=e||(a(l[h],e,1,l[h].length-1,n),l[h]=l[h].slice(0,e));return l}},{quickselect:492}],430:[function(t,e,r){\"use strict\";e.exports={API_URL:\"https://api.mapbox.com\",REQUIRE_ACCESS_TOKEN:!0}},{}],431:[function(t,e,r){\"use strict\";function n(t){this._stringToNumber={},this._numberToString=[];for(var e=0;e<t.length;e++){var r=t[e];this._stringToNumber[r]=e,this._numberToString[e]=r}}var i=t(\"assert\");e.exports=n,n.prototype.encode=function(t){return i(t in this._stringToNumber),this._stringToNumber[t]},n.prototype.decode=function(t){return i(t<this._numberToString.length),this._numberToString[t]}},{assert:46}],432:[function(t,e,r){\"use strict\";function n(t,e){this.actors=[],this.currentActor=0;for(var r=0;r<t;r++){var n=new o,i=new a(n,e);i.name=\"Worker \"+r,this.actors.push(i)}}var i=t(\"./util\"),a=t(\"./actor\"),o=t(\"./web_worker\");e.exports=n,n.prototype={broadcast:function(t,e,r){r=r||function(){},i.asyncAll(this.actors,function(r,n){r.send(t,e,n)},r)},send:function(t,e,r,n,i){return(\"number\"!=typeof n||isNaN(n))&&(n=this.currentActor=(this.currentActor+1)%this.actors.length),this.actors[n].send(t,e,r,i),n},remove:function(){for(var t=0;t<this.actors.length;t++)this.actors[t].target.terminate();this.actors=[]}}},{\"./actor\":423,\"./util\":441,\"./web_worker\":428}],433:[function(t,e,r){\"use strict\";var n=t(\"./util\"),i={on:function(t,e){return this._events=this._events||{},this._events[t]=this._events[t]||[],this._events[t].push(e),this},off:function(t,e){if(!t)return delete this._events,this;if(!this.listens(t))return this;if(e){var r=this._events[t].indexOf(e);r>=0&&this._events[t].splice(r,1),this._events[t].length||delete this._events[t]}else delete this._events[t];return this},once:function(t,e){var r=function(n){this.off(t,r),e.call(this,n)}.bind(this);return this.on(t,r),this},fire:function(t,e){if(!this.listens(t))return n.endsWith(t,\"error\")&&console.error(e&&e.error||e||\"Empty error event\"),this;e=n.extend({},e),n.extend(e,{type:t,target:this});for(var r=this._events[t].slice(),i=0;i<r.length;i++)r[i].call(this,e);return this},listens:function(t){return!(!this._events||!this._events[t])}};e.exports=i},{\"./util\":441}],434:[function(t,e,r){\"use strict\";function n(t,e){this.stacks=t.readFields(i,[],e)}function i(t,e,r){if(1===t){var n=r.readMessage(a,{glyphs:{}});e.push(n)}}function a(t,e,r){if(1===t)e.name=r.readString();else if(2===t)e.range=r.readString();else if(3===t){var n=r.readMessage(o,{});e.glyphs[n.id]=n}}function o(t,e,r){1===t?e.id=r.readVarint():2===t?e.bitmap=r.readBytes():3===t?e.width=r.readVarint():4===t?e.height=r.readVarint():5===t?e.left=r.readSVarint():6===t?e.top=r.readSVarint():7===t&&(e.advance=r.readVarint())}e.exports=n},{}],435:[function(t,e,r){\"use strict\";function n(t,e,r){return t*(1-r)+e*r}e.exports=n,n.number=n,n.vec2=function(t,e,r){return[n(t[0],e[0],r),n(t[1],e[1],r)]},n.color=function(t,e,r){return[n(t[0],e[0],r),n(t[1],e[1],r),n(t[2],e[2],r),n(t[3],e[3],r)]},n.array=function(t,e,r){return t.map(function(t,i){return n(t,e[i],r)})}},{}],436:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<t.length;n++)for(var i=t[n],a=0;a<e.length;a++)for(var o=e[a],s=0;s<o.length;s++){var l=o[s];if(d(i,l))return!0;if(c(l,i,r))return!0}return!1}function i(t,e){if(1===t.length&&1===t[0].length)return f(e,t[0][0]);for(var r=0;r<e.length;r++)for(var n=e[r],i=0;i<n.length;i++)if(f(t,n[i]))return!0;for(var a=0;a<t.length;a++){for(var o=t[a],l=0;l<o.length;l++)if(f(e,o[l]))return!0;for(var u=0;u<e.length;u++)if(s(o,e[u]))return!0}return!1}function a(t,e,r){for(var n=0;n<e.length;n++)for(var i=e[n],a=0;a<t.length;a++){var s=t[a];if(s.length>=3)for(var l=0;l<i.length;l++)if(d(s,i[l]))return!0;if(o(s,i,r))return!0}return!1}function o(t,e,r){if(t.length>1){if(s(t,e))return!0;for(var n=0;n<e.length;n++)if(c(e[n],t,r))return!0}for(var i=0;i<t.length;i++)if(c(t[i],e,r))return!0;return!1}function s(t,e){for(var r=0;r<t.length-1;r++)for(var n=t[r],i=t[r+1],a=0;a<e.length-1;a++){var o=e[a],s=e[a+1];if(u(n,i,o,s))return!0}return!1}function l(t,e,r){return(r.y-t.y)*(e.x-t.x)>(e.y-t.y)*(r.x-t.x)}function u(t,e,r,n){return l(t,r,n)!==l(e,r,n)&&l(t,e,r)!==l(t,e,n)}function c(t,e,r){var n=r*r;if(1===e.length)return t.distSqr(e[0])<n;for(var i=1;i<e.length;i++){if(h(t,e[i-1],e[i])<n)return!0}return!1}function h(t,e,r){var n=e.distSqr(r);if(0===n)return t.distSqr(e);var i=((t.x-e.x)*(r.x-e.x)+(t.y-e.y)*(r.y-e.y))/n;return i<0?t.distSqr(e):i>1?t.distSqr(r):t.distSqr(r.sub(e)._mult(i)._add(e))}function f(t,e){for(var r,n,i,a=!1,o=0;o<t.length;o++){r=t[o];for(var s=0,l=r.length-1;s<r.length;l=s++)n=r[s],i=r[l],n.y>e.y!=i.y>e.y&&e.x<(i.x-n.x)*(e.y-n.y)/(i.y-n.y)+n.x&&(a=!a)}return a}function d(t,e){for(var r=!1,n=0,i=t.length-1;n<t.length;i=n++){var a=t[n],o=t[i];a.y>e.y!=o.y>e.y&&e.x<(o.x-a.x)*(e.y-a.y)/(o.y-a.y)+a.x&&(r=!r)}return r}e.exports={multiPolygonIntersectsBufferedMultiPoint:n,multiPolygonIntersectsMultiPolygon:i,multiPolygonIntersectsBufferedMultiLine:a}},{}],437:[function(t,e,r){\"use strict\";function n(t,e){this.max=t,this.onRemove=e,this.reset()}e.exports=n,n.prototype.reset=function(){for(var t in this.data)this.onRemove(this.data[t]);return this.data={},this.order=[],this},n.prototype.add=function(t,e){if(this.has(t))this.order.splice(this.order.indexOf(t),1),this.data[t]=e,this.order.push(t);else if(this.data[t]=e,this.order.push(t),this.order.length>this.max){var r=this.get(this.order[0]);r&&this.onRemove(r)}return this},n.prototype.has=function(t){return t in this.data},n.prototype.keys=function(){return this.order},n.prototype.get=function(t){if(!this.has(t))return null;var e=this.data[t];return delete this.data[t],this.order.splice(this.order.indexOf(t),1),e},n.prototype.setMaxSize=function(t){for(this.max=t;this.order.length>this.max;){var e=this.get(this.order[0]);e&&this.onRemove(e)}return this}},{}],438:[function(t,e,r){\"use strict\";function n(t,e,r){if(!(r=r||o.ACCESS_TOKEN)&&o.REQUIRE_ACCESS_TOKEN)throw new Error(\"An API access token is required to use Mapbox GL. See https://www.mapbox.com/developers/api/#access-tokens\");if(t=t.replace(/^mapbox:\\/\\//,o.API_URL+e),\n",
       "t+=-1!==t.indexOf(\"?\")?\"&access_token=\":\"?access_token=\",o.REQUIRE_ACCESS_TOKEN){if(\"s\"===r[0])throw new Error(\"Use a public access token (pk.*) with Mapbox GL JS, not a secret access token (sk.*). See https://www.mapbox.com/developers/api/#access-tokens\");t+=r}return t}function i(t){return t?\"?\"+t:\"\"}function a(t){return t.access_token&&\"tk.\"===t.access_token.slice(0,3)?u.extend({},t,{access_token:o.ACCESS_TOKEN}):t}var o=t(\"./config\"),s=t(\"./browser\"),l=t(\"url\"),u=t(\"./util\");e.exports.normalizeStyleURL=function(t,e){var r=l.parse(t);return\"mapbox:\"!==r.protocol?t:n(\"mapbox:/\"+r.pathname+i(r.query),\"/styles/v1/\",e)},e.exports.normalizeSourceURL=function(t,e){return\"mapbox:\"!==l.parse(t).protocol?t:n(t+\".json\",\"/v4/\",e)+\"&secure\"},e.exports.normalizeGlyphsURL=function(t,e){var r=l.parse(t);return\"mapbox:\"!==r.protocol?t:n(\"mapbox://\"+r.pathname.split(\"/\")[1]+\"/{fontstack}/{range}.pbf\"+i(r.query),\"/fonts/v1/\",e)},e.exports.normalizeSpriteURL=function(t,e,r,a){var o=l.parse(t);return\"mapbox:\"!==o.protocol?(o.pathname+=e+r,l.format(o)):n(\"mapbox:/\"+o.pathname+\"/sprite\"+e+r+i(o.query),\"/styles/v1/\",a)},e.exports.normalizeTileURL=function(t,e,r){var n=l.parse(t,!0);if(!e)return t;if(\"mapbox:\"!==l.parse(e).protocol)return t;var i=s.supportsWebp?\".webp\":\"$1\",o=s.devicePixelRatio>=2||512===r?\"@2x\":\"\";return l.format({protocol:n.protocol,hostname:n.hostname,pathname:n.pathname.replace(/(\\.(?:png|jpg)\\d*)/,o+i),query:a(n.query)})}},{\"./browser\":425,\"./config\":430,\"./util\":441,url:544}],439:[function(t,e,r){\"use strict\";function n(t){function e(){f.apply(this,arguments)}function r(){d.apply(this,arguments),this.members=e.prototype.members}var n=JSON.stringify(t);if(v[n])return v[n];void 0===t.alignment&&(t.alignment=1),e.prototype=Object.create(f.prototype);var s=0,u=0,g=[\"Uint8\"];return e.prototype.members=t.members.map(function(r){r={name:r.name,type:r.type,components:r.components||1},p(r.name.length),p(r.type in m),g.indexOf(r.type)<0&&g.push(r.type);var n=o(r.type);u=Math.max(u,n),r.offset=s=a(s,Math.max(t.alignment,n));for(var i=0;i<r.components;i++)Object.defineProperty(e.prototype,r.name+(1===r.components?\"\":i),{get:c(r,i),set:h(r,i)});return s+=n*r.components,r}),e.prototype.alignment=t.alignment,e.prototype.size=a(s,Math.max(u,t.alignment)),r.serialize=i,r.prototype=Object.create(d.prototype),r.prototype.StructType=e,r.prototype.bytesPerElement=e.prototype.size,r.prototype.emplaceBack=l(e.prototype.members,e.prototype.size),r.prototype._usedTypes=g,v[n]=r,r}function i(){return{members:this.prototype.StructType.prototype.members,alignment:this.prototype.StructType.prototype.alignment,bytesPerElement:this.prototype.bytesPerElement}}function a(t,e){return Math.ceil(t/e)*e}function o(t){return m[t].BYTES_PER_ELEMENT}function s(t){return t.toLowerCase()}function l(t,e){for(var r=[],n=[],i=\"var i = this.length;\\nthis.resize(this.length + 1);\\n\",a=0;a<t.length;a++){var l=t[a],u=o(l.type);r.indexOf(u)<0&&(r.push(u),i+=\"var o\"+u.toFixed(0)+\" = i * \"+(e/u).toFixed(0)+\";\\n\");for(var c=0;c<l.components;c++){var h=\"v\"+n.length,f=\"o\"+u.toFixed(0)+\" + \"+(l.offset/u+c).toFixed(0);i+=\"this.\"+s(l.type)+\"[\"+f+\"] = \"+h+\";\\n\",n.push(h)}}return i+=\"return i;\",new Function(n,i)}function u(t,e){var r=\"this._pos\"+o(t.type).toFixed(0),n=(t.offset/o(t.type)+e).toFixed(0),i=r+\" + \"+n;return\"this._structArray.\"+s(t.type)+\"[\"+i+\"]\"}function c(t,e){return new Function([],\"return \"+u(t,e)+\";\")}function h(t,e){return new Function([\"x\"],u(t,e)+\" = x;\")}function f(t,e){this._structArray=t,this._pos1=e*this.size,this._pos2=this._pos1/2,this._pos4=this._pos1/4,this._pos8=this._pos1/8}function d(t){void 0!==t?(this.arrayBuffer=t.arrayBuffer,this.length=t.length,this.capacity=this.arrayBuffer.byteLength/this.bytesPerElement,this._refreshViews()):(this.capacity=-1,this.resize(0))}var p=t(\"assert\");e.exports=n;var m={Int8:Int8Array,Uint8:Uint8Array,Uint8Clamped:Uint8ClampedArray,Int16:Int16Array,Uint16:Uint16Array,Int32:Int32Array,Uint32:Uint32Array,Float32:Float32Array,Float64:Float64Array},v={};d.prototype.DEFAULT_CAPACITY=128,d.prototype.RESIZE_MULTIPLIER=5,d.prototype.serialize=function(){return this.trim(),{length:this.length,arrayBuffer:this.arrayBuffer}},d.prototype.get=function(t){return new this.StructType(this,t)},d.prototype.trim=function(){this.length!==this.capacity&&(this.capacity=this.length,this.arrayBuffer=this.arrayBuffer.slice(0,this.length*this.bytesPerElement),this._refreshViews())},d.prototype.resize=function(t){if(this.length=t,t>this.capacity){this.capacity=Math.max(t,Math.floor(this.capacity*this.RESIZE_MULTIPLIER),this.DEFAULT_CAPACITY),this.arrayBuffer=new ArrayBuffer(this.capacity*this.bytesPerElement);var e=this.uint8;this._refreshViews(),e&&this.uint8.set(e)}},d.prototype._refreshViews=function(){for(var t=0;t<this._usedTypes.length;t++){var e=this._usedTypes[t];this[s(e)]=new m[e](this.arrayBuffer)}},d.prototype.toArray=function(t,e){for(var r=[],n=t;n<e;n++){var i=this.get(n);r.push(i)}return r}},{assert:46}],440:[function(t,e,r){\"use strict\";function n(t,e){return e.replace(/{([^{}]+)}/g,function(e,r){return r in t?t[r]:\"\"})}e.exports=n},{}],441:[function(t,e,r){\"use strict\";var n=t(\"unitbezier\"),i=t(\"../geo/coordinate\");r.easeCubicInOut=function(t){if(t<=0)return 0;if(t>=1)return 1;var e=t*t,r=e*t;return 4*(t<.5?r:3*(t-e)+r-.75)},r.bezier=function(t,e,r,i){var a=new n(t,e,r,i);return function(t){return a.solve(t)}},r.ease=r.bezier(.25,.1,.25,1),r.clamp=function(t,e,r){return Math.min(r,Math.max(e,t))},r.wrap=function(t,e,r){var n=r-e,i=((t-e)%n+n)%n+e;return i===e?r:i},r.coalesce=function(){for(var t=0;t<arguments.length;t++){var e=arguments[t];if(null!==e&&void 0!==e)return e}},r.asyncAll=function(t,e,r){if(!t.length)return r(null,[]);var n=t.length,i=new Array(t.length),a=null;t.forEach(function(t,o){e(t,function(t,e){t&&(a=t),i[o]=e,0==--n&&r(a,i)})})},r.keysDifference=function(t,e){var r=[];for(var n in t)n in e||r.push(n);return r},r.extend=function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)t[n]=r[n]}return t},r.extendAll=function(t,e){for(var r in e)Object.defineProperty(t,r,Object.getOwnPropertyDescriptor(e,r));return t},r.inherit=function(t,e){var n=\"function\"==typeof t?t.prototype:t,i=Object.create(n);return r.extendAll(i,e),i},r.pick=function(t,e){for(var r={},n=0;n<e.length;n++){var i=e[n];i in t&&(r[i]=t[i])}return r};var a=1;r.uniqueId=function(){return a++},r.debounce=function(t,e){var r,n;return function(){n=arguments,clearTimeout(r),r=setTimeout(function(){t.apply(null,n)},e)}},r.bindAll=function(t,e){t.forEach(function(t){e[t]&&(e[t]=e[t].bind(e))})},r.bindHandlers=function(t){for(var e in t)\"function\"==typeof t[e]&&0===e.indexOf(\"_on\")&&(t[e]=t[e].bind(t))},r.setOptions=function(t,e){t.hasOwnProperty(\"options\")||(t.options=t.options?Object.create(t.options):{});for(var r in e)t.options[r]=e[r];return t.options},r.getCoordinatesCenter=function(t){for(var e=1/0,r=1/0,n=-1/0,a=-1/0,o=0;o<t.length;o++)e=Math.min(e,t[o].column),r=Math.min(r,t[o].row),n=Math.max(n,t[o].column),a=Math.max(a,t[o].row);var s=n-e,l=a-r,u=Math.max(s,l);return new i((e+n)/2,(r+a)/2,0).zoomTo(Math.floor(-Math.log(u)/Math.LN2))},r.endsWith=function(t,e){return-1!==t.indexOf(e,t.length-e.length)},r.startsWith=function(t,e){return 0===t.indexOf(e)},r.mapObject=function(t,e,r){var n={};for(var i in t)n[i]=e.call(r||this,t[i],i,t);return n},r.filterObject=function(t,e,r){var n={};for(var i in t)e.call(r||this,t[i],i,t)&&(n[i]=t[i]);return n},r.deepEqual=function t(e,r){if(Array.isArray(e)){if(!Array.isArray(r)||e.length!==r.length)return!1;for(var n=0;n<e.length;n++)if(!t(e[n],r[n]))return!1;return!0}if(\"object\"==typeof e&&null!==e&&null!==r){if(\"object\"!=typeof r)return!1;if(Object.keys(e).length!==Object.keys(r).length)return!1;for(var i in e)if(!t(e[i],r[i]))return!1;return!0}return e===r},r.clone=function(t){return Array.isArray(t)?t.map(r.clone):\"object\"==typeof t?r.mapObject(t,r.clone):t},r.arraysIntersect=function(t,e){for(var r=0;r<t.length;r++)if(e.indexOf(t[r])>=0)return!0;return!1};var o={};r.warnOnce=function(t){o[t]||(\"undefined\"!=typeof console&&console.warn(t),o[t]=!0)}},{\"../geo/coordinate\":337,unitbezier:543}],442:[function(t,e,r){\"use strict\";function n(t,e,r,n){this._vectorTileFeature=t,t._z=e,t._x=r,t._y=n,this.properties=t.properties,null!=t.id&&(this.id=t.id)}e.exports=n,n.prototype={type:\"Feature\",get geometry(){return void 0===this._geometry&&(this._geometry=this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x,this._vectorTileFeature._y,this._vectorTileFeature._z).geometry),this._geometry},set geometry(t){this._geometry=t},toJSON:function(){var t={};for(var e in this)\"_geometry\"!==e&&\"_vectorTileFeature\"!==e&&\"toJSON\"!==e&&(t[e]=this[e]);return t}}},{}],443:[function(t,e,r){e.exports={_args:[[{raw:\"mapbox-gl@^0.22.0\",scope:null,escapedName:\"mapbox-gl\",name:\"mapbox-gl\",rawSpec:\"^0.22.0\",spec:\">=0.22.0 <0.23.0\",type:\"range\"},\"/home/etienne/Documents/plotly/plotly.js\"]],_from:\"mapbox-gl@>=0.22.0 <0.23.0\",_id:\"mapbox-gl@0.22.1\",_inCache:!0,_location:\"/mapbox-gl\",_nodeVersion:\"4.4.5\",_npmOperationalInternal:{host:\"packages-12-west.internal.npmjs.com\",tmp:\"tmp/mapbox-gl-0.22.1.tgz_1471549891670_0.8762630566488951\"},_npmUser:{name:\"lucaswoj\",email:\"lucas@lucaswoj.com\"},_npmVersion:\"2.15.5\",_phantomChildren:{},_requested:{raw:\"mapbox-gl@^0.22.0\",scope:null,escapedName:\"mapbox-gl\",name:\"mapbox-gl\",rawSpec:\"^0.22.0\",spec:\">=0.22.0 <0.23.0\",type:\"range\"},_requiredBy:[\"/\"],_resolved:\"https://registry.npmjs.org/mapbox-gl/-/mapbox-gl-0.22.1.tgz\",_shasum:\"92a965547d4c2f24c22cbc487eeda48694cb627a\",_shrinkwrap:null,_spec:\"mapbox-gl@^0.22.0\",_where:\"/home/etienne/Documents/plotly/plotly.js\",browser:{\"./js/util/ajax.js\":\"./js/util/browser/ajax.js\",\"./js/util/browser.js\":\"./js/util/browser/browser.js\",\"./js/util/canvas.js\":\"./js/util/browser/canvas.js\",\"./js/util/dom.js\":\"./js/util/browser/dom.js\",\"./js/util/web_worker.js\":\"./js/util/browser/web_worker.js\"},bugs:{url:\"https://github.com/mapbox/mapbox-gl-js/issues\"},dependencies:{csscolorparser:\"^1.0.2\",earcut:\"^2.0.3\",\"feature-filter\":\"^2.2.0\",\"geojson-rewind\":\"^0.1.0\",\"geojson-vt\":\"^2.4.0\",\"gl-matrix\":\"^2.3.1\",\"grid-index\":\"^1.0.0\",\"mapbox-gl-function\":\"^1.2.1\",\"mapbox-gl-shaders\":\"github:mapbox/mapbox-gl-shaders#de2ab007455aa2587c552694c68583f94c9f2747\",\"mapbox-gl-style-spec\":\"github:mapbox/mapbox-gl-style-spec#83b1a3e5837d785af582efd5ed1a212f2df6a4ae\",\"mapbox-gl-supported\":\"^1.2.0\",pbf:\"^1.3.2\",pngjs:\"^2.2.0\",\"point-geometry\":\"^0.0.0\",quickselect:\"^1.0.0\",request:\"^2.39.0\",\"resolve-url\":\"^0.2.1\",\"shelf-pack\":\"^1.0.0\",supercluster:\"^2.0.1\",unassertify:\"^2.0.0\",unitbezier:\"^0.0.0\",\"vector-tile\":\"^1.3.0\",\"vt-pbf\":\"^2.0.2\",webworkify:\"^1.3.0\",\"whoots-js\":\"^2.0.0\"},description:\"A WebGL interactive maps library\",devDependencies:{\"babel-preset-react\":\"^6.11.1\",babelify:\"^7.3.0\",benchmark:\"~2.1.0\",browserify:\"^13.0.0\",clipboard:\"^1.5.12\",\"concat-stream\":\"1.5.1\",coveralls:\"^2.11.8\",doctrine:\"^1.2.1\",documentation:\"https://github.com/documentationjs/documentation/archive/bb41619c734e59ef3fbc3648610032efcfdaaace.tar.gz\",\"documentation-theme-utils\":\"3.0.0\",envify:\"^3.4.0\",eslint:\"^2.5.3\",\"eslint-config-mourner\":\"^2.0.0\",\"eslint-plugin-html\":\"^1.5.1\",gl:\"^4.0.1\",handlebars:\"4.0.5\",\"highlight.js\":\"9.3.0\",istanbul:\"^0.4.2\",\"json-loader\":\"^0.5.4\",lodash:\"^4.13.1\",\"mapbox-gl-test-suite\":\"github:mapbox/mapbox-gl-test-suite#7babab52fb02788ebbc38384139bf350e8e38552\",\"memory-fs\":\"^0.3.0\",minifyify:\"^7.0.1\",\"npm-run-all\":\"^3.0.0\",nyc:\"6.4.0\",proxyquire:\"^1.7.9\",remark:\"4.2.2\",\"remark-html\":\"3.0.0\",sinon:\"^1.15.4\",st:\"^1.2.0\",tap:\"^5.7.0\",\"transform-loader\":\"^0.2.3\",\"unist-util-visit\":\"1.1.0\",vinyl:\"1.1.1\",\"vinyl-fs\":\"2.4.3\",watchify:\"^3.7.0\",webpack:\"^1.13.1\",\"webworkify-webpack\":\"^1.1.3\"},directories:{},dist:{shasum:\"92a965547d4c2f24c22cbc487eeda48694cb627a\",tarball:\"https://registry.npmjs.org/mapbox-gl/-/mapbox-gl-0.22.1.tgz\"},engines:{node:\">=4.0.0\"},gitHead:\"13a9015341f0602ccb55c98c53079838ad4b70b5\",homepage:\"https://github.com/mapbox/mapbox-gl-js#readme\",license:\"BSD-3-Clause\",main:\"js/mapbox-gl.js\",maintainers:[{name:\"aaronlidman\",email:\"aaronlidman@gmail.com\"},{name:\"ajashton\",email:\"aj.ashton@gmail.com\"},{name:\"ansis\",email:\"ansis.brammanis@gmail.com\"},{name:\"bergwerkgis\",email:\"wb@bergwerk-gis.at\"},{name:\"bhousel\",email:\"bryan@mapbox.com\"},{name:\"bsudekum\",email:\"bobby@mapbox.com\"},{name:\"camilleanne\",email:\"camille@mapbox.com\"},{name:\"dnomadb\",email:\"damon@mapbox.com\"},{name:\"dthompson\",email:\"dthompson@gmail.com\"},{name:\"emilymcafee\",email:\"emily@mapbox.com\"},{name:\"flippmoke\",email:\"flippmoke@gmail.com\"},{name:\"freenerd\",email:\"spam@freenerd.de\"},{name:\"gretacb\",email:\"carol@mapbox.com\"},{name:\"ian29\",email:\"ian.villeda@gmail.com\"},{name:\"ianshward\",email:\"ian@mapbox.com\"},{name:\"ingalls\",email:\"nicholas.ingalls@gmail.com\"},{name:\"jfirebaugh\",email:\"john.firebaugh@gmail.com\"},{name:\"jrpruit1\",email:\"jake@jakepruitt.com\"},{name:\"karenzshea\",email:\"karen@mapbox.com\"},{name:\"kkaefer\",email:\"kkaefer@gmail.com\"},{name:\"lbud\",email:\"lauren@mapbox.com\"},{name:\"lucaswoj\",email:\"lucas@lucaswoj.com\"},{name:\"lxbarth\",email:\"alex@mapbox.com\"},{name:\"lyzidiamond\",email:\"lyzi@mapbox.com\"},{name:\"mapbox-admin\",email:\"accounts@mapbox.com\"},{name:\"mateov\",email:\"matt@mapbox.com\"},{name:\"mcwhittemore\",email:\"mcwhittemore@gmail.com\"},{name:\"miccolis\",email:\"jeff@miccolis.net\"},{name:\"mikemorris\",email:\"michael.patrick.morris@gmail.com\"},{name:\"morganherlocker\",email:\"morgan.herlocker@gmail.com\"},{name:\"mourner\",email:\"agafonkin@gmail.com\"},{name:\"nickidlugash\",email:\"nicki@mapbox.com\"},{name:\"rclark\",email:\"ryan.clark.j@gmail.com\"},{name:\"samanbb\",email:\"saman@mapbox.com\"},{name:\"sbma44\",email:\"tlee@mapbox.com\"},{name:\"scothis\",email:\"scothis@gmail.com\"},{name:\"sgillies\",email:\"sean@mapbox.com\"},{name:\"springmeyer\",email:\"dane@mapbox.com\"},{name:\"themarex\",email:\"patrick@mapbox.com\"},{name:\"tmcw\",email:\"tom@macwright.org\"},{name:\"tristen\",email:\"tristen.brown@gmail.com\"},{name:\"willwhite\",email:\"will@mapbox.com\"},{name:\"yhahn\",email:\"young@mapbox.com\"}],name:\"mapbox-gl\",optionalDependencies:{},readme:\"ERROR: No README data found!\",repository:{type:\"git\",url:\"git://github.com/mapbox/mapbox-gl-js.git\"},scripts:{build:\"npm run build-docs # invoked by publisher when publishing docs on the mb-pages branch\",\"build-dev\":\"browserify js/mapbox-gl.js --debug --standalone mapboxgl > dist/mapbox-gl-dev.js && tap --no-coverage test/build/dev.test.js\",\"build-docs\":\"documentation build --github --format html -c documentation.yml --theme ./docs/_theme --output docs/api/\",\"build-min\":\"browserify js/mapbox-gl.js --debug -t unassertify --plugin [minifyify --map mapbox-gl.js.map --output dist/mapbox-gl.js.map] --standalone mapboxgl > dist/mapbox-gl.js && tap --no-coverage test/build/min.test.js\",\"build-token\":\"browserify debug/access-token-src.js --debug -t envify > debug/access-token.js\",lint:\"eslint  --ignore-path .gitignore js test bench docs/_posts/examples/*.html\",\"open-changed-examples\":\"git diff --name-only mb-pages HEAD -- docs/_posts/examples/*.html | awk '{print \\\"http://127.0.0.1:4000/mapbox-gl-js/example/\\\" substr($0,33,length($0)-37)}' | xargs open\",start:\"run-p build-token watch-dev watch-bench start-server\",\"start-bench\":\"run-p build-token watch-bench start-server\",\"start-debug\":\"run-p build-token watch-dev start-server\",\"start-docs\":\"npm run build-min && npm run build-docs && jekyll serve -w\",\"start-server\":\"st --no-cache --localhost --port 9966 --index index.html .\",test:\"npm run lint && tap --reporter dot test/js/*/*.js test/build/webpack.test.js\",\"test-suite\":\"node test/render.test.js && node test/query.test.js\",\"watch-bench\":\"node bench/download-data.js && watchify bench/index.js --plugin [minifyify --no-map] -t [babelify --presets react] -t unassertify -t envify -o bench/bench.js -v\",\"watch-dev\":\"watchify js/mapbox-gl.js --debug --standalone mapboxgl -o dist/mapbox-gl-dev.js -v\"},version:\"0.22.1\"}},{}],444:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=new Array(t),i=0;i<t;++i)n[i]=0,i===e&&(n[i]+=.5),i===r&&(n[i]+=.5);return n}function i(t,e){if(0===e||e===(1<<t+1)-1)return[];for(var r=[],i=[],a=0;a<=t;++a)if(e&1<<a){r.push(n(t,a-1,a-1)),i.push(null);for(var s=0;s<=t;++s)~e&1<<s&&(r.push(n(t,a-1,s-1)),i.push([a,s]))}var l=o(r),u=[];t:for(var a=0;a<l.length;++a){for(var c=l[a],h=[],s=0;s<c.length;++s){if(!i[c[s]])continue t;h.push(i[c[s]].slice())}u.push(h)}return u}function a(t){for(var e=1<<t+1,r=new Array(e),n=0;n<e;++n)r[n]=i(t,n);return r}e.exports=a;var o=t(\"convex-hull\")},{\"convex-hull\":102}],445:[function(t,e,r){function n(t,e,r){var n=e[0],i=e[1],a=e[2],o=e[3];return t[0]=r[0]*n+r[4]*i+r[8]*a+r[12]*o,t[1]=r[1]*n+r[5]*i+r[9]*a+r[13]*o,t[2]=r[2]*n+r[6]*i+r[10]*a+r[14]*o,t[3]=r[3]*n+r[7]*i+r[11]*a+r[15]*o,t}function i(t,e){t[0][0]=e[0],t[0][1]=e[1],t[0][2]=e[2],t[1][0]=e[4],t[1][1]=e[5],t[1][2]=e[6],t[2][0]=e[8],t[2][1]=e[9],t[2][2]=e[10]}function a(t,e,r,n,i){t[0]=e[0]*n+r[0]*i,t[1]=e[1]*n+r[1]*i,t[2]=e[2]*n+r[2]*i}var o=t(\"./normalize\"),s=t(\"gl-mat4/create\"),l=t(\"gl-mat4/clone\"),u=t(\"gl-mat4/determinant\"),c=t(\"gl-mat4/invert\"),h=t(\"gl-mat4/transpose\"),f={length:t(\"gl-vec3/length\"),normalize:t(\"gl-vec3/normalize\"),dot:t(\"gl-vec3/dot\"),cross:t(\"gl-vec3/cross\")},d=s(),p=s(),m=[0,0,0,0],v=[[0,0,0],[0,0,0],[0,0,0]],g=[0,0,0];e.exports=function(t,e,r,s,y,b){if(e||(e=[0,0,0]),r||(r=[0,0,0]),s||(s=[0,0,0]),y||(y=[0,0,0,1]),b||(b=[0,0,0,1]),!o(d,t))return!1;if(l(p,d),p[3]=0,p[7]=0,p[11]=0,p[15]=1,Math.abs(u(p)<1e-8))return!1;var x=d[3],_=d[7],w=d[11],M=d[12],k=d[13],A=d[14],T=d[15];if(0!==x||0!==_||0!==w){m[0]=x,m[1]=_,m[2]=w,m[3]=T;if(!c(p,p))return!1;h(p,p),n(y,m,p)}else y[0]=y[1]=y[2]=0,y[3]=1;if(e[0]=M,e[1]=k,e[2]=A,i(v,d),r[0]=f.length(v[0]),f.normalize(v[0],v[0]),s[0]=f.dot(v[0],v[1]),a(v[1],v[1],v[0],1,-s[0]),r[1]=f.length(v[1]),f.normalize(v[1],v[1]),s[0]/=r[1],s[1]=f.dot(v[0],v[2]),a(v[2],v[2],v[0],1,-s[1]),s[2]=f.dot(v[1],v[2]),a(v[2],v[2],v[1],1,-s[2]),r[2]=f.length(v[2]),f.normalize(v[2],v[2]),s[1]/=r[2],s[2]/=r[2],f.cross(g,v[1],v[2]),f.dot(v[0],g)<0)for(var S=0;S<3;S++)r[S]*=-1,v[S][0]*=-1,v[S][1]*=-1,v[S][2]*=-1;return b[0]=.5*Math.sqrt(Math.max(1+v[0][0]-v[1][1]-v[2][2],0)),b[1]=.5*Math.sqrt(Math.max(1-v[0][0]+v[1][1]-v[2][2],0)),b[2]=.5*Math.sqrt(Math.max(1-v[0][0]-v[1][1]+v[2][2],0)),b[3]=.5*Math.sqrt(Math.max(1+v[0][0]+v[1][1]+v[2][2],0)),v[2][1]>v[1][2]&&(b[0]=-b[0]),v[0][2]>v[2][0]&&(b[1]=-b[1]),v[1][0]>v[0][1]&&(b[2]=-b[2]),!0}},{\"./normalize\":446,\"gl-mat4/clone\":174,\"gl-mat4/create\":175,\"gl-mat4/determinant\":176,\"gl-mat4/invert\":180,\"gl-mat4/transpose\":190,\"gl-vec3/cross\":271,\"gl-vec3/dot\":272,\"gl-vec3/length\":273,\"gl-vec3/normalize\":275}],446:[function(t,e,r){e.exports=function(t,e){var r=e[15];if(0===r)return!1;for(var n=1/r,i=0;i<16;i++)t[i]=e[i]*n;return!0}},{}],447:[function(t,e,r){function n(t,e,r,n){if(0===c(e)||0===c(r))return!1;var i=u(e,f.translate,f.scale,f.skew,f.perspective,f.quaternion),a=u(r,d.translate,d.scale,d.skew,d.perspective,d.quaternion);return!(!i||!a)&&(s(p.translate,f.translate,d.translate,n),s(p.skew,f.skew,d.skew,n),s(p.scale,f.scale,d.scale,n),s(p.perspective,f.perspective,d.perspective,n),h(p.quaternion,f.quaternion,d.quaternion,n),l(t,p.translate,p.scale,p.skew,p.perspective,p.quaternion),!0)}function i(){return{translate:a(),scale:a(1),skew:a(),perspective:o(),quaternion:o()}}function a(t){return[t||0,t||0,t||0]}function o(){return[0,0,0,1]}var s=t(\"gl-vec3/lerp\"),l=t(\"mat4-recompose\"),u=t(\"mat4-decompose\"),c=t(\"gl-mat4/determinant\"),h=t(\"quat-slerp\"),f=i(),d=i(),p=i();e.exports=n},{\"gl-mat4/determinant\":176,\"gl-vec3/lerp\":274,\"mat4-decompose\":445,\"mat4-recompose\":448,\"quat-slerp\":488}],448:[function(t,e,r){var n={identity:t(\"gl-mat4/identity\"),translate:t(\"gl-mat4/translate\"),multiply:t(\"gl-mat4/multiply\"),create:t(\"gl-mat4/create\"),scale:t(\"gl-mat4/scale\"),fromRotationTranslation:t(\"gl-mat4/fromRotationTranslation\")},i=(n.create(),n.create());e.exports=function(t,e,r,a,o,s){return n.identity(t),n.fromRotationTranslation(t,s,e),t[3]=o[0],t[7]=o[1],t[11]=o[2],t[15]=o[3],n.identity(i),0!==a[2]&&(i[9]=a[2],n.multiply(t,t,i)),0!==a[1]&&(i[9]=0,i[8]=a[1],n.multiply(t,t,i)),0!==a[0]&&(i[8]=0,i[4]=a[0],n.multiply(t,t,i)),n.scale(t,t,r),t}},{\"gl-mat4/create\":175,\"gl-mat4/fromRotationTranslation\":178,\"gl-mat4/identity\":179,\"gl-mat4/multiply\":182,\"gl-mat4/scale\":188,\"gl-mat4/translate\":189}],449:[function(t,e,r){\"use strict\";function n(t){this._components=t.slice(),this._time=[0],this.prevMatrix=t.slice(),this.nextMatrix=t.slice(),this.computedMatrix=t.slice(),this.computedInverse=t.slice(),this.computedEye=[0,0,0],this.computedUp=[0,0,0],this.computedCenter=[0,0,0],this.computedRadius=[0],this._limits=[-1/0,1/0]}function i(t){return t=t||{},new n(t.matrix||[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])}var a=t(\"binary-search-bounds\"),o=t(\"mat4-interpolate\"),s=t(\"gl-mat4/invert\"),l=t(\"gl-mat4/rotateX\"),u=t(\"gl-mat4/rotateY\"),c=t(\"gl-mat4/rotateZ\"),h=t(\"gl-mat4/lookAt\"),f=t(\"gl-mat4/translate\"),d=(t(\"gl-mat4/scale\"),t(\"gl-vec3/normalize\")),p=[0,0,0];e.exports=i;var m=n.prototype;m.recalcMatrix=function(t){var e=this._time,r=a.le(e,t),n=this.computedMatrix;if(!(r<0)){var i=this._components;if(r===e.length-1)for(var l=16*r,u=0;u<16;++u)n[u]=i[l++];else{for(var c=e[r+1]-e[r],l=16*r,h=this.prevMatrix,f=!0,u=0;u<16;++u)h[u]=i[l++];for(var p=this.nextMatrix,u=0;u<16;++u)p[u]=i[l++],f=f&&h[u]===p[u];if(c<1e-6||f)for(var u=0;u<16;++u)n[u]=h[u];else o(n,h,p,(t-e[r])/c)}var m=this.computedUp;m[0]=n[1],m[1]=n[5],m[2]=n[9],d(m,m);var v=this.computedInverse;s(v,n);var g=this.computedEye,y=v[15];g[0]=v[12]/y,g[1]=v[13]/y,g[2]=v[14]/y;for(var b=this.computedCenter,x=Math.exp(this.computedRadius[0]),u=0;u<3;++u)b[u]=g[u]-n[2+4*u]*x}},m.idle=function(t){if(!(t<this.lastT())){for(var e=this._components,r=e.length-16,n=0;n<16;++n)e.push(e[r++]);this._time.push(t)}},m.flush=function(t){var e=a.gt(this._time,t)-2;e<0||(this._time.splice(0,e),this._components.splice(0,16*e))},m.lastT=function(){return this._time[this._time.length-1]},m.lookAt=function(t,e,r,n){this.recalcMatrix(t),e=e||this.computedEye,r=r||p,n=n||this.computedUp,this.setMatrix(t,h(this.computedMatrix,e,r,n));for(var i=0,a=0;a<3;++a)i+=Math.pow(r[a]-e[a],2);i=Math.log(Math.sqrt(i)),this.computedRadius[0]=i},m.rotate=function(t,e,r,n){this.recalcMatrix(t);var i=this.computedInverse;e&&u(i,i,e),r&&l(i,i,r),n&&c(i,i,n),this.setMatrix(t,s(this.computedMatrix,i))};var v=[0,0,0];m.pan=function(t,e,r,n){v[0]=-(e||0),v[1]=-(r||0),v[2]=-(n||0),this.recalcMatrix(t);var i=this.computedInverse;f(i,i,v),this.setMatrix(t,s(i,i))},m.translate=function(t,e,r,n){v[0]=e||0,v[1]=r||0,v[2]=n||0,this.recalcMatrix(t);var i=this.computedMatrix;f(i,i,v),this.setMatrix(t,i)},m.setMatrix=function(t,e){if(!(t<this.lastT())){this._time.push(t);for(var r=0;r<16;++r)this._components.push(e[r])}},m.setDistance=function(t,e){this.computedRadius[0]=e},m.setDistanceLimits=function(t,e){var r=this._limits;r[0]=t,r[1]=e},m.getDistanceLimits=function(t){var e=this._limits;return t?(t[0]=e[0],t[1]=e[1],t):e}},{\"binary-search-bounds\":65,\"gl-mat4/invert\":180,\"gl-mat4/lookAt\":181,\"gl-mat4/rotateX\":185,\"gl-mat4/rotateY\":186,\"gl-mat4/rotateZ\":187,\"gl-mat4/scale\":188,\"gl-mat4/translate\":189,\"gl-vec3/normalize\":275,\"mat4-interpolate\":447}],450:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e<3){for(var r=new Array(e),n=0;n<e;++n)r[n]=n;return 2===e&&t[0][0]===t[1][0]&&t[0][1]===t[1][1]?[0]:r}for(var a=new Array(e),n=0;n<e;++n)a[n]=n;a.sort(function(e,r){var n=t[e][0]-t[r][0];return n||t[e][1]-t[r][1]});for(var o=[a[0],a[1]],s=[a[0],a[1]],n=2;n<e;++n){for(var l=a[n],u=t[l],c=o.length;c>1&&i(t[o[c-2]],t[o[c-1]],u)<=0;)c-=1,o.pop();for(o.push(l),c=s.length;c>1&&i(t[s[c-2]],t[s[c-1]],u)>=0;)c-=1,s.pop();s.push(l)}for(var r=new Array(s.length+o.length-2),h=0,n=0,f=o.length;n<f;++n)r[h++]=o[n];for(var d=s.length-2;d>0;--d)r[h++]=s[d];return r}e.exports=n;var i=t(\"robust-orientation\")[3]},{\"robust-orientation\":507}],451:[function(t,e,r){\"use strict\";function n(t,e){function r(t){var e=!1;return\"altKey\"in t&&(e=e||t.altKey!==v.alt,v.alt=!!t.altKey),\"shiftKey\"in t&&(e=e||t.shiftKey!==v.shift,v.shift=!!t.shiftKey),\"ctrlKey\"in t&&(e=e||t.ctrlKey!==v.control,v.control=!!t.ctrlKey),\"metaKey\"in t&&(e=e||t.metaKey!==v.meta,v.meta=!!t.metaKey),e}function n(t,n){var a=i.x(n),o=i.y(n);\"buttons\"in n&&(t=0|n.buttons),(t!==d||a!==p||o!==m||r(n))&&(d=0|t,p=a||0,m=o||0,e&&e(d,p,m,v))}function a(t){n(0,t)}function o(){(d||p||m||v.shift||v.alt||v.meta||v.control)&&(p=m=0,d=0,v.shift=v.alt=v.control=v.meta=!1,e&&e(0,0,0,v))}function s(t){r(t)&&e&&e(d,p,m,v)}function l(t){0===i.buttons(t)?n(0,t):n(d,t)}function u(t){n(d|i.buttons(t),t)}function c(t){n(d&~i.buttons(t),t)}function h(){g||(g=!0,t.addEventListener(\"mousemove\",l),t.addEventListener(\"mousedown\",u),t.addEventListener(\"mouseup\",c),t.addEventListener(\"mouseleave\",a),t.addEventListener(\"mouseenter\",a),t.addEventListener(\"mouseout\",a),t.addEventListener(\"mouseover\",a),t.addEventListener(\"blur\",o),t.addEventListener(\"keyup\",s),t.addEventListener(\"keydown\",s),t.addEventListener(\"keypress\",s),t!==window&&(window.addEventListener(\"blur\",o),window.addEventListener(\"keyup\",s),window.addEventListener(\"keydown\",s),window.addEventListener(\"keypress\",s)))}function f(){g&&(g=!1,t.removeEventListener(\"mousemove\",l),t.removeEventListener(\"mousedown\",u),t.removeEventListener(\"mouseup\",c),t.removeEventListener(\"mouseleave\",a),t.removeEventListener(\"mouseenter\",a),t.removeEventListener(\"mouseout\",a),t.removeEventListener(\"mouseover\",a),t.removeEventListener(\"blur\",o),t.removeEventListener(\"keyup\",s),t.removeEventListener(\"keydown\",s),t.removeEventListener(\"keypress\",s),t!==window&&(window.removeEventListener(\"blur\",o),window.removeEventListener(\"keyup\",s),window.removeEventListener(\"keydown\",s),window.removeEventListener(\"keypress\",s)))}e||(e=t,t=window);var d=0,p=0,m=0,v={shift:!1,alt:!1,control:!1,meta:!1},g=!1;h();var y={element:t};return Object.defineProperties(y,{enabled:{get:function(){return g},set:function(t){t?h():f()},enumerable:!0},buttons:{get:function(){return d},enumerable:!0},x:{get:function(){return p},enumerable:!0},y:{get:function(){return m},enumerable:!0},mods:{get:function(){return v},enumerable:!0}}),y}e.exports=n;var i=t(\"mouse-event\")},{\"mouse-event\":453}],452:[function(t,e,r){function n(t,e,r){e=e||t.currentTarget||t.srcElement,Array.isArray(r)||(r=[0,0]);var n=t.clientX||0,a=t.clientY||0,o=i(e);return r[0]=n-o.left,r[1]=a-o.top,r}function i(t){return t===window||t===document||t===document.body?a:t.getBoundingClientRect()}var a={left:0,top:0};e.exports=n},{}],453:[function(t,e,r){\"use strict\";function n(t){if(\"object\"==typeof t){if(\"buttons\"in t)return t.buttons;if(\"which\"in t){var e=t.which;if(2===e)return 4;if(3===e)return 2;if(e>0)return 1<<e-1}else if(\"button\"in t){var e=t.button;if(1===e)return 4;if(2===e)return 2;if(e>=0)return 1<<e}}return 0}function i(t){return t.target||t.srcElement||window}function a(t){if(\"object\"==typeof t){if(\"offsetX\"in t)return t.offsetX;var e=i(t),r=e.getBoundingClientRect();return t.clientX-r.left}return 0}function o(t){if(\"object\"==typeof t){if(\"offsetY\"in t)return t.offsetY;var e=i(t),r=e.getBoundingClientRect();return t.clientY-r.top}return 0}r.buttons=n,r.element=i,r.x=a,r.y=o},{}],454:[function(t,e,r){\"use strict\";function n(t,e,r){\"function\"==typeof t&&(r=!!e,e=t,t=window);var n=i(\"ex\",t),a=function(t){r&&t.preventDefault();var i=t.deltaX||0,a=t.deltaY||0,o=t.deltaZ||0,s=t.deltaMode,l=1;switch(s){case 1:l=n;break;case 2:l=window.innerHeight}if(i*=l,a*=l,o*=l,i||a||o)return e(i,a,o,t)};return t.addEventListener(\"wheel\",a),a}var i=t(\"to-px\");e.exports=n},{\"to-px\":534}],455:[function(t,e,r){\"use strict\";function n(t){return\"a\"+t}function i(t){return\"d\"+t}function a(t,e){return\"c\"+t+\"_\"+e}function o(t){return\"s\"+t}function s(t,e){return\"t\"+t+\"_\"+e}function l(t){return\"o\"+t}function u(t){return\"x\"+t}function c(t){return\"p\"+t}function h(t,e){return\"d\"+t+\"_\"+e}function f(t){return\"i\"+t}function d(t,e){return\"u\"+t+\"_\"+e}function p(t){return\"b\"+t}function m(t){return\"y\"+t}function v(t){return\"e\"+t}function g(t){return\"v\"+t}function y(t,e,r){for(var n=0,i=0;i<t;++i)e&1<<i&&(n|=1<<r[i]);return n}function b(t,e,r,b,x,E){function L(t,e){j.push(\"for(\",f(x[t]),\"=\",e,\";\",f(x[t]),\"<\",o(x[t]),\";\",\"++\",f(x[t]),\"){\")}function C(t){for(var e=0;e<O;++e)j.push(c(e),\"+=\",d(e,x[t]),\";\");j.push(\"}\")}function z(t){for(var e=t-1;e>=0;--e)L(e,0);for(var r=[],e=0;e<O;++e)E[e]?r.push(i(e)+\".get(\"+c(e)+\")\"):r.push(i(e)+\"[\"+c(e)+\"]\");for(var e=0;e<b;++e)r.push(u(e));j.push(M,\"[\",T,\"++]=phase(\",r.join(),\");\");for(var e=0;e<t;++e)C(e);for(var n=0;n<O;++n)j.push(c(n),\"+=\",d(n,x[t]),\";\")}function I(t){for(var e=0;e<O;++e)E[e]?j.push(a(e,0),\"=\",i(e),\".get(\",c(e),\");\"):j.push(a(e,0),\"=\",i(e),\"[\",c(e),\"];\");for(var r=[],e=0;e<O;++e)r.push(a(e,0));for(var e=0;e<b;++e)r.push(u(e));j.push(p(0),\"=\",M,\"[\",T,\"]=phase(\",r.join(),\");\");for(var n=1;n<1<<R;++n)j.push(p(n),\"=\",M,\"[\",T,\"+\",v(n),\"];\");for(var o=[],n=1;n<1<<R;++n)o.push(\"(\"+p(0)+\"!==\"+p(n)+\")\");j.push(\"if(\",o.join(\"||\"),\"){\");for(var s=[],e=0;e<R;++e)s.push(f(e));for(var e=0;e<O;++e){s.push(a(e,0));for(var n=1;n<1<<R;++n)E[e]?j.push(a(e,n),\"=\",i(e),\".get(\",c(e),\"+\",h(e,n),\");\"):j.push(a(e,n),\"=\",i(e),\"[\",c(e),\"+\",h(e,n),\"];\"),s.push(a(e,n))}for(var e=0;e<1<<R;++e)s.push(p(e));for(var e=0;e<b;++e)s.push(u(e));j.push(\"vertex(\",s.join(),\");\",g(0),\"=\",w,\"[\",T,\"]=\",k,\"++;\");for(var l=(1<<R)-1,d=p(l),n=0;n<R;++n)if(0==(t&~(1<<n))){for(var m=l^1<<n,y=p(m),x=[],_=m;_>0;_=_-1&m)x.push(w+\"[\"+T+\"+\"+v(_)+\"]\");x.push(g(0));for(var _=0;_<O;++_)1&n?x.push(a(_,l),a(_,m)):x.push(a(_,m),a(_,l));1&n?x.push(d,y):x.push(y,d);for(var _=0;_<b;++_)x.push(u(_));j.push(\"if(\",d,\"!==\",y,\"){\",\"face(\",x.join(),\")}\")}j.push(\"}\",T,\"+=1;\")}function D(){for(var t=1;t<1<<R;++t)j.push(S,\"=\",v(t),\";\",v(t),\"=\",m(t),\";\",m(t),\"=\",S,\";\")}function P(t,e){if(t<0)return void I(e);z(t),j.push(\"if(\",o(x[t]),\">0){\",f(x[t]),\"=1;\"),P(t-1,e|1<<x[t]);for(var r=0;r<O;++r)j.push(c(r),\"+=\",d(r,x[t]),\";\");t===R-1&&(j.push(T,\"=0;\"),D()),L(t,2),P(t-1,e),t===R-1&&(j.push(\"if(\",f(x[R-1]),\"&1){\",T,\"=0;}\"),D()),C(t),j.push(\"}\")}var O=E.length,R=x.length;if(R<2)throw new Error(\"ndarray-extract-contour: Dimension must be at least 2\");for(var F=\"extractContour\"+x.join(\"_\"),j=[],N=[],B=[],U=0;U<O;++U)B.push(n(U));for(var U=0;U<b;++U)B.push(u(U));for(var U=0;U<R;++U)N.push(o(U)+\"=\"+n(0)+\".shape[\"+U+\"]|0\");for(var U=0;U<O;++U){N.push(i(U)+\"=\"+n(U)+\".data\",l(U)+\"=\"+n(U)+\".offset|0\");for(var V=0;V<R;++V)N.push(s(U,V)+\"=\"+n(U)+\".stride[\"+V+\"]|0\")}for(var U=0;U<O;++U){N.push(c(U)+\"=\"+l(U)),N.push(a(U,0));for(var V=1;V<1<<R;++V){for(var H=[],q=0;q<R;++q)V&1<<q&&H.push(\"-\"+s(U,q));N.push(h(U,V)+\"=(\"+H.join(\"\")+\")|0\"),N.push(a(U,V)+\"=0\")}}for(var U=0;U<O;++U)for(var V=0;V<R;++V){var G=[s(U,x[V])];V>0&&G.push(s(U,x[V-1])+\"*\"+o(x[V-1])),N.push(d(U,x[V])+\"=(\"+G.join(\"-\")+\")|0\")}for(var U=0;U<R;++U)N.push(f(U)+\"=0\");N.push(k+\"=0\");for(var Y=[\"2\"],U=R-2;U>=0;--U)Y.push(o(x[U]));N.push(A+\"=(\"+Y.join(\"*\")+\")|0\",M+\"=mallocUint32(\"+A+\")\",w+\"=mallocUint32(\"+A+\")\",T+\"=0\"),N.push(p(0)+\"=0\");for(var V=1;V<1<<R;++V){for(var X=[],W=[],q=0;q<R;++q)V&1<<q&&(0===W.length?X.push(\"1\"):X.unshift(W.join(\"*\"))),W.push(o(x[q]));var Z=\"\";X[0].indexOf(o(x[R-2]))<0&&(Z=\"-\");var J=y(R,V,x);N.push(v(J)+\"=(-\"+X.join(\"-\")+\")|0\",m(J)+\"=(\"+Z+X.join(\"-\")+\")|0\",p(J)+\"=0\")}N.push(g(0)+\"=0\",S+\"=0\"),P(R-1,0),j.push(\"freeUint32(\",w,\");freeUint32(\",M,\");\");var K=[\"'use strict';\",\"function \",F,\"(\",B.join(),\"){\",\"var \",N.join(),\";\",j.join(\"\"),\"}\",\"return \",F].join(\"\");return new Function(\"vertex\",\"face\",\"phase\",\"mallocUint32\",\"freeUint32\",K)(t,e,r,_.mallocUint32,_.freeUint32)}function x(t){function e(t){throw new Error(\"ndarray-extract-contour: \"+t)}\"object\"!=typeof t&&e(\"Must specify arguments\");var r=t.order;Array.isArray(r)||e(\"Must specify order\");var n=t.arrayArguments||1;n<1&&e(\"Must have at least one array argument\");var i=t.scalarArguments||0;i<0&&e(\"Scalar arg count must be > 0\"),\n",
       "\"function\"!=typeof t.vertex&&e(\"Must specify vertex creation function\"),\"function\"!=typeof t.cell&&e(\"Must specify cell creation function\"),\"function\"!=typeof t.phase&&e(\"Must specify phase function\");for(var a=t.getters||[],o=new Array(n),s=0;s<n;++s)a.indexOf(s)>=0?o[s]=!0:o[s]=!1;return b(t.vertex,t.cell,t.phase,i,r,o)}var _=t(\"typedarray-pool\");e.exports=x;var w=\"V\",M=\"P\",k=\"N\",A=\"Q\",T=\"X\",S=\"T\"},{\"typedarray-pool\":540}],456:[function(t,e,r){\"use strict\";var n=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{_inline_7_arg1_=_inline_7_arg2_.apply(void 0,_inline_7_arg0_)}\",args:[{name:\"_inline_7_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_7_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_7_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"cwise\",blockSize:64});e.exports=function(t,e){return n(t,e),t}},{\"cwise/lib/wrapper\":112}],457:[function(t,e,r){\"use strict\";function n(t){if(t in l)return l[t];for(var e=[],r=0;r<t;++r)e.push(\"out\",r,\"s=0.5*(inp\",r,\"l-inp\",r,\"r);\");for(var n=[\"array\"],i=[\"junk\"],r=0;r<t;++r){n.push(\"array\"),i.push(\"out\"+r+\"s\");var a=o(t);a[r]=-1,n.push({array:0,offset:a.slice()}),a[r]=1,n.push({array:0,offset:a.slice()}),i.push(\"inp\"+r+\"l\",\"inp\"+r+\"r\")}return l[t]=s({args:n,pre:c,post:c,body:{body:e.join(\"\"),args:i.map(function(t){return{name:t,lvalue:0===t.indexOf(\"out\"),rvalue:0===t.indexOf(\"inp\"),count:\"junk\"!==t|0}}),thisVars:[],localVars:[]},funcName:\"fdTemplate\"+t})}function i(t){var e=t.join(),r=u[e];if(r)return r;for(var i=t.length,a=[\"function gradient(dst,src){var s=src.shape.slice();\"],o=0;o<1<<i;++o){for(var s=[],c=0;c<i;++c)o&1<<c&&s.push(c+1);for(var d=0;d<1<<s.length;++d){for(var p=s.slice(),c=0;c<s.length;++c)d&1<<c&&(p[c]=-p[c]);!function(e){for(var r=i-e.length,n=[],o=[],s=[],l=0;l<i;++l)e.indexOf(l+1)>=0?s.push(\"0\"):e.indexOf(-(l+1))>=0?s.push(\"s[\"+l+\"]-1\"):(s.push(\"-1\"),n.push(\"1\"),o.push(\"s[\"+l+\"]-2\"));var u=\".lo(\"+n.join()+\").hi(\"+o.join()+\")\";if(0===n.length&&(u=\"\"),r>0){a.push(\"if(1\");for(var l=0;l<i;++l)e.indexOf(l+1)>=0||e.indexOf(-(l+1))>=0||a.push(\"&&s[\",l,\"]>2\");a.push(\"){grad\",r,\"(src.pick(\",s.join(),\")\",u);for(var l=0;l<i;++l)e.indexOf(l+1)>=0||e.indexOf(-(l+1))>=0||a.push(\",dst.pick(\",s.join(),\",\",l,\")\",u);a.push(\");\")}for(var l=0;l<e.length;++l){var c=Math.abs(e[l])-1,h=\"dst.pick(\"+s.join()+\",\"+c+\")\"+u;switch(t[c]){case\"clamp\":var f=s.slice(),d=s.slice();e[l]<0?f[c]=\"s[\"+c+\"]-2\":d[c]=\"1\",0===r?a.push(\"if(s[\",c,\"]>1){dst.set(\",s.join(),\",\",c,\",0.5*(src.get(\",f.join(),\")-src.get(\",d.join(),\")))}else{dst.set(\",s.join(),\",\",c,\",0)};\"):a.push(\"if(s[\",c,\"]>1){diff(\",h,\",src.pick(\",f.join(),\")\",u,\",src.pick(\",d.join(),\")\",u,\");}else{zero(\",h,\");};\");break;case\"mirror\":0===r?a.push(\"dst.set(\",s.join(),\",\",c,\",0);\"):a.push(\"zero(\",h,\");\");break;case\"wrap\":var p=s.slice(),m=s.slice();e[l]<0?(p[c]=\"s[\"+c+\"]-2\",m[c]=\"0\"):(p[c]=\"s[\"+c+\"]-1\",m[c]=\"1\"),0===r?a.push(\"if(s[\",c,\"]>2){dst.set(\",s.join(),\",\",c,\",0.5*(src.get(\",p.join(),\")-src.get(\",m.join(),\")))}else{dst.set(\",s.join(),\",\",c,\",0)};\"):a.push(\"if(s[\",c,\"]>2){diff(\",h,\",src.pick(\",p.join(),\")\",u,\",src.pick(\",m.join(),\")\",u,\");}else{zero(\",h,\");};\");break;default:throw new Error(\"ndarray-gradient: Invalid boundary condition\")}}r>0&&a.push(\"};\")}(p)}}a.push(\"return dst;};return gradient\");for(var m=[\"diff\",\"zero\"],v=[h,f],o=1;o<=i;++o)m.push(\"grad\"+o),v.push(n(o));m.push(a.join(\"\"));var g=Function.apply(void 0,m),r=g.apply(void 0,v);return l[e]=r,r}function a(t,e,r){if(Array.isArray(r)){if(r.length!==e.dimension)throw new Error(\"ndarray-gradient: invalid boundary conditions\")}else r=\"string\"==typeof r?o(e.dimension,r):o(e.dimension,\"clamp\");if(t.dimension!==e.dimension+1)throw new Error(\"ndarray-gradient: output dimension must be +1 input dimension\");if(t.shape[e.dimension]!==e.dimension)throw new Error(\"ndarray-gradient: output shape must match input shape\");for(var n=0;n<e.dimension;++n)if(t.shape[n]!==e.shape[n])throw new Error(\"ndarray-gradient: shape mismatch\");return 0===e.size?t:e.dimension<=0?(t.set(0),t):i(r)(t,e)}e.exports=a;var o=t(\"dup\"),s=t(\"cwise-compiler\"),l={},u={},c={body:\"\",args:[],thisVars:[],localVars:[]},h=s({args:[\"array\",\"array\",\"array\"],pre:c,post:c,body:{args:[{name:\"out\",lvalue:!0,rvalue:!1,count:1},{name:\"left\",lvalue:!1,rvalue:!0,count:1},{name:\"right\",lvalue:!1,rvalue:!0,count:1}],body:\"out=0.5*(left-right)\",thisVars:[],localVars:[]},funcName:\"cdiff\"}),f=s({args:[\"array\"],pre:c,post:c,body:{args:[{name:\"out\",lvalue:!0,rvalue:!1,count:1}],body:\"out=0\",thisVars:[],localVars:[]},funcName:\"zero\"})},{\"cwise-compiler\":109,dup:124}],458:[function(t,e,r){\"use strict\";function n(t,e,r){var n=e.dimension,o=a([],r);return i(t,e,function(t,e){for(var r=0;r<n;++r){t[r]=o[(n+1)*n+r];for(var i=0;i<n;++i)t[r]+=o[(n+1)*i+r]*e[i]}for(var a=o[(n+1)*(n+1)-1],i=0;i<n;++i)a+=o[(n+1)*i+n]*e[i];for(var s=1/a,r=0;r<n;++r)t[r]*=s;return t}),t}var i=t(\"ndarray-warp\"),a=t(\"gl-matrix-invert\");e.exports=n},{\"gl-matrix-invert\":191,\"ndarray-warp\":465}],459:[function(t,e,r){\"use strict\";function n(t,e){var r=Math.floor(e),n=e-r,i=0<=r&&r<t.shape[0],a=0<=r+1&&r+1<t.shape[0];return(1-n)*(i?+t.get(r):0)+n*(a?+t.get(r+1):0)}function i(t,e,r){var n=Math.floor(e),i=e-n,a=0<=n&&n<t.shape[0],o=0<=n+1&&n+1<t.shape[0],s=Math.floor(r),l=r-s,u=0<=s&&s<t.shape[1],c=0<=s+1&&s+1<t.shape[1],h=a&&u?t.get(n,s):0,f=a&&c?t.get(n,s+1):0;return(1-l)*((1-i)*h+i*(o&&u?t.get(n+1,s):0))+l*((1-i)*f+i*(o&&c?t.get(n+1,s+1):0))}function a(t,e,r,n){var i=Math.floor(e),a=e-i,o=0<=i&&i<t.shape[0],s=0<=i+1&&i+1<t.shape[0],l=Math.floor(r),u=r-l,c=0<=l&&l<t.shape[1],h=0<=l+1&&l+1<t.shape[1],f=Math.floor(n),d=n-f,p=0<=f&&f<t.shape[2],m=0<=f+1&&f+1<t.shape[2],v=o&&c&&p?t.get(i,l,f):0,g=o&&h&&p?t.get(i,l+1,f):0,y=s&&c&&p?t.get(i+1,l,f):0,b=s&&h&&p?t.get(i+1,l+1,f):0,x=o&&c&&m?t.get(i,l,f+1):0,_=o&&h&&m?t.get(i,l+1,f+1):0;return(1-d)*((1-u)*((1-a)*v+a*y)+u*((1-a)*g+a*b))+d*((1-u)*((1-a)*x+a*(s&&c&&m?t.get(i+1,l,f+1):0))+u*((1-a)*_+a*(s&&h&&m?t.get(i+1,l+1,f+1):0)))}function o(t){var e,r,n=0|t.shape.length,i=new Array(n),a=new Array(n),o=new Array(n),s=new Array(n);for(e=0;e<n;++e)r=+arguments[e+1],i[e]=Math.floor(r),a[e]=r-i[e],o[e]=0<=i[e]&&i[e]<t.shape[e],s[e]=0<=i[e]+1&&i[e]+1<t.shape[e];var l,u,c,h=0;t:for(e=0;e<1<<n;++e){for(u=1,c=t.offset,l=0;l<n;++l)if(e&1<<l){if(!s[l])continue t;u*=a[l],c+=t.stride[l]*(i[l]+1)}else{if(!o[l])continue t;u*=1-a[l],c+=t.stride[l]*i[l]}h+=u*t.data[c]}return h}function s(t,e,r,s){switch(t.shape.length){case 0:return 0;case 1:return n(t,e);case 2:return i(t,e,r);case 3:return a(t,e,r,s);default:return o.apply(void 0,arguments)}}e.exports=s,e.exports.d1=n,e.exports.d2=i,e.exports.d3=a},{}],460:[function(t,e,r){\"use strict\";function n(t){if(!t)return s;for(var e=0;e<t.args.length;++e){var r=t.args[e];t.args[e]=0===e?{name:r,lvalue:!0,rvalue:!!t.rvalue,count:t.count||1}:{name:r,lvalue:!1,rvalue:!0,count:1}}return t.thisVars||(t.thisVars=[]),t.localVars||(t.localVars=[]),t}function i(t){return o({args:t.args,pre:n(t.pre),body:n(t.body),post:n(t.proc),funcName:t.funcName})}function a(t){for(var e=[],r=0;r<t.args.length;++r)e.push(\"a\"+r);return new Function(\"P\",[\"return function \",t.funcName,\"_ndarrayops(\",e.join(\",\"),\") {P(\",e.join(\",\"),\");return a0}\"].join(\"\"))(i(t))}var o=t(\"cwise-compiler\"),s={body:\"\",args:[],thisVars:[],localVars:[]},l={add:\"+\",sub:\"-\",mul:\"*\",div:\"/\",mod:\"%\",band:\"&\",bor:\"|\",bxor:\"^\",lshift:\"<<\",rshift:\">>\",rrshift:\">>>\"};!function(){for(var t in l){var e=l[t];r[t]=a({args:[\"array\",\"array\",\"array\"],body:{args:[\"a\",\"b\",\"c\"],body:\"a=b\"+e+\"c\"},funcName:t}),r[t+\"eq\"]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a\"+e+\"=b\"},rvalue:!0,funcName:t+\"eq\"}),r[t+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],body:{args:[\"a\",\"b\",\"s\"],body:\"a=b\"+e+\"s\"},funcName:t+\"s\"}),r[t+\"seq\"]=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"s\"],body:\"a\"+e+\"=s\"},rvalue:!0,funcName:t+\"seq\"})}}();var u={not:\"!\",bnot:\"~\",neg:\"-\",recip:\"1.0/\"};!function(){for(var t in u){var e=u[t];r[t]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=\"+e+\"b\"},funcName:t}),r[t+\"eq\"]=a({args:[\"array\"],body:{args:[\"a\"],body:\"a=\"+e+\"a\"},rvalue:!0,count:2,funcName:t+\"eq\"})}}();var c={and:\"&&\",or:\"||\",eq:\"===\",neq:\"!==\",lt:\"<\",gt:\">\",leq:\"<=\",geq:\">=\"};!function(){for(var t in c){var e=c[t];r[t]=a({args:[\"array\",\"array\",\"array\"],body:{args:[\"a\",\"b\",\"c\"],body:\"a=b\"+e+\"c\"},funcName:t}),r[t+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],body:{args:[\"a\",\"b\",\"s\"],body:\"a=b\"+e+\"s\"},funcName:t+\"s\"}),r[t+\"eq\"]=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=a\"+e+\"b\"},rvalue:!0,count:2,funcName:t+\"eq\"}),r[t+\"seq\"]=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"s\"],body:\"a=a\"+e+\"s\"},rvalue:!0,count:2,funcName:t+\"seq\"})}}();var h=[\"abs\",\"acos\",\"asin\",\"atan\",\"ceil\",\"cos\",\"exp\",\"floor\",\"log\",\"round\",\"sin\",\"sqrt\",\"tan\"];!function(){for(var t=0;t<h.length;++t){var e=h[t];r[e]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b)\",thisVars:[\"this_f\"]},funcName:e}),r[e+\"eq\"]=a({args:[\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\"],body:\"a=this_f(a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"eq\"})}}();var f=[\"max\",\"min\",\"atan2\",\"pow\"];!function(){for(var t=0;t<f.length;++t){var e=f[t];r[e]=a({args:[\"array\",\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(b,c)\",thisVars:[\"this_f\"]},funcName:e}),r[e+\"s\"]=a({args:[\"array\",\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(b,c)\",thisVars:[\"this_f\"]},funcName:e+\"s\"}),r[e+\"eq\"]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(a,b)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"eq\"}),r[e+\"seq\"]=a({args:[\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(a,b)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"seq\"})}}();var d=[\"atan2\",\"pow\"];!function(){for(var t=0;t<d.length;++t){var e=d[t];r[e+\"op\"]=a({args:[\"array\",\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(c,b)\",thisVars:[\"this_f\"]},funcName:e+\"op\"}),r[e+\"ops\"]=a({args:[\"array\",\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\",\"c\"],body:\"a=this_f(c,b)\",thisVars:[\"this_f\"]},funcName:e+\"ops\"}),r[e+\"opeq\"]=a({args:[\"array\",\"array\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b,a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"opeq\"}),r[e+\"opseq\"]=a({args:[\"array\",\"scalar\"],pre:{args:[],body:\"this_f=Math.\"+e,thisVars:[\"this_f\"]},body:{args:[\"a\",\"b\"],body:\"a=this_f(b,a)\",thisVars:[\"this_f\"]},rvalue:!0,count:2,funcName:e+\"opseq\"})}}(),r.any=o({args:[\"array\"],pre:s,body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"if(a){return true}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return false\"},funcName:\"any\"}),r.all=o({args:[\"array\"],pre:s,body:{args:[{name:\"x\",lvalue:!1,rvalue:!0,count:1}],body:\"if(!x){return false}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return true\"},funcName:\"all\"}),r.sum=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"this_s+=a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"sum\"}),r.prod=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=1\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:1}],body:\"this_s*=a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"prod\"}),r.norm2squared=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:2}],body:\"this_s+=a*a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norm2squared\"}),r.norm2=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:2}],body:\"this_s+=a*a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return Math.sqrt(this_s)\"},funcName:\"norm2\"}),r.norminf=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:4}],body:\"if(-a>this_s){this_s=-a}else if(a>this_s){this_s=a}\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norminf\"}),r.norm1=o({args:[\"array\"],pre:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"this_s=0\"},body:{args:[{name:\"a\",lvalue:!1,rvalue:!0,count:3}],body:\"this_s+=a<0?-a:a\",localVars:[],thisVars:[\"this_s\"]},post:{args:[],localVars:[],thisVars:[\"this_s\"],body:\"return this_s\"},funcName:\"norm1\"}),r.sup=o({args:[\"array\"],pre:{body:\"this_h=-Infinity\",args:[],thisVars:[\"this_h\"],localVars:[]},body:{body:\"if(_inline_1_arg0_>this_h)this_h=_inline_1_arg0_\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_h\"],localVars:[]},post:{body:\"return this_h\",args:[],thisVars:[\"this_h\"],localVars:[]}}),r.inf=o({args:[\"array\"],pre:{body:\"this_h=Infinity\",args:[],thisVars:[\"this_h\"],localVars:[]},body:{body:\"if(_inline_1_arg0_<this_h)this_h=_inline_1_arg0_\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_h\"],localVars:[]},post:{body:\"return this_h\",args:[],thisVars:[\"this_h\"],localVars:[]}}),r.argmin=o({args:[\"index\",\"array\",\"shape\"],pre:{body:\"{this_v=Infinity;this_i=_inline_0_arg2_.slice(0)}\",args:[{name:\"_inline_0_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_i\",\"this_v\"],localVars:[]},body:{body:\"{if(_inline_1_arg1_<this_v){this_v=_inline_1_arg1_;for(var _inline_1_k=0;_inline_1_k<_inline_1_arg0_.length;++_inline_1_k){this_i[_inline_1_k]=_inline_1_arg0_[_inline_1_k]}}}\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_i\",\"this_v\"],localVars:[\"_inline_1_k\"]},post:{body:\"{return this_i}\",args:[],thisVars:[\"this_i\"],localVars:[]}}),r.argmax=o({args:[\"index\",\"array\",\"shape\"],pre:{body:\"{this_v=-Infinity;this_i=_inline_0_arg2_.slice(0)}\",args:[{name:\"_inline_0_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_0_arg2_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_i\",\"this_v\"],localVars:[]},body:{body:\"{if(_inline_1_arg1_>this_v){this_v=_inline_1_arg1_;for(var _inline_1_k=0;_inline_1_k<_inline_1_arg0_.length;++_inline_1_k){this_i[_inline_1_k]=_inline_1_arg0_[_inline_1_k]}}}\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:2}],thisVars:[\"this_i\",\"this_v\"],localVars:[\"_inline_1_k\"]},post:{body:\"{return this_i}\",args:[],thisVars:[\"this_i\"],localVars:[]}}),r.random=a({args:[\"array\"],pre:{args:[],body:\"this_f=Math.random\",thisVars:[\"this_f\"]},body:{args:[\"a\"],body:\"a=this_f()\",thisVars:[\"this_f\"]},funcName:\"random\"}),r.assign=a({args:[\"array\",\"array\"],body:{args:[\"a\",\"b\"],body:\"a=b\"},funcName:\"assign\"}),r.assigns=a({args:[\"array\",\"scalar\"],body:{args:[\"a\",\"b\"],body:\"a=b\"},funcName:\"assigns\"}),r.equals=o({args:[\"array\",\"array\"],pre:s,body:{args:[{name:\"x\",lvalue:!1,rvalue:!0,count:1},{name:\"y\",lvalue:!1,rvalue:!0,count:1}],body:\"if(x!==y){return false}\",localVars:[],thisVars:[]},post:{args:[],localVars:[],thisVars:[],body:\"return true\"},funcName:\"equals\"})},{\"cwise-compiler\":109}],461:[function(t,e,r){\"use strict\";var n=t(\"ndarray\"),i=t(\"./doConvert.js\");e.exports=function(t,e){for(var r=[],a=t,o=1;Array.isArray(a);)r.push(a.length),o*=a.length,a=a[0];return 0===r.length?n():(e||(e=n(new Float64Array(o),r)),i(e,t),e)}},{\"./doConvert.js\":462,ndarray:466}],462:[function(t,e,r){e.exports=t(\"cwise-compiler\")({args:[\"array\",\"scalar\",\"index\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{\\nvar _inline_1_v=_inline_1_arg1_,_inline_1_i\\nfor(_inline_1_i=0;_inline_1_i<_inline_1_arg2_.length-1;++_inline_1_i) {\\n_inline_1_v=_inline_1_v[_inline_1_arg2_[_inline_1_i]]\\n}\\n_inline_1_arg0_=_inline_1_v[_inline_1_arg2_[_inline_1_arg2_.length-1]]\\n}\",args:[{name:\"_inline_1_arg0_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg2_\",lvalue:!1,rvalue:!0,count:4}],thisVars:[],localVars:[\"_inline_1_i\",\"_inline_1_v\"]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},funcName:\"convert\",blockSize:64})},{\"cwise-compiler\":109}],463:[function(t,e,r){\"use strict\";function n(t){switch(t){case\"uint8\":return[l.mallocUint8,l.freeUint8];case\"uint16\":return[l.mallocUint16,l.freeUint16];case\"uint32\":return[l.mallocUint32,l.freeUint32];case\"int8\":return[l.mallocInt8,l.freeInt8];case\"int16\":return[l.mallocInt16,l.freeInt16];case\"int32\":return[l.mallocInt32,l.freeInt32];case\"float32\":return[l.mallocFloat,l.freeFloat];case\"float64\":return[l.mallocDouble,l.freeDouble];default:return null}}function i(t){for(var e=[],r=0;r<t;++r)e.push(\"s\"+r);for(var r=0;r<t;++r)e.push(\"n\"+r);for(var r=1;r<t;++r)e.push(\"d\"+r);for(var r=1;r<t;++r)e.push(\"e\"+r);for(var r=1;r<t;++r)e.push(\"f\"+r);return e}function a(t,e){function r(t){return\"generic\"===e?[\"data.get(\",t,\")\"].join(\"\"):[\"data[\",t,\"]\"].join(\"\")}function a(t,r){return\"generic\"===e?[\"data.set(\",t,\",\",r,\")\"].join(\"\"):[\"data[\",t,\"]=\",r].join(\"\")}var o=[\"'use strict'\"],s=[\"ndarrayInsertionSort\",t.join(\"d\"),e].join(\"\"),l=[\"left\",\"right\",\"data\",\"offset\"].concat(i(t.length)),u=n(e),c=[\"i,j,cptr,ptr=left*s0+offset\"];if(t.length>1){for(var h=[],f=1;f<t.length;++f)c.push(\"i\"+f),h.push(\"n\"+f);u?c.push(\"scratch=malloc(\"+h.join(\"*\")+\")\"):c.push(\"scratch=new Array(\"+h.join(\"*\")+\")\"),c.push(\"dptr\",\"sptr\",\"a\",\"b\")}else c.push(\"scratch\");if(o.push([\"function \",s,\"(\",l.join(\",\"),\"){var \",c.join(\",\")].join(\"\"),\"for(i=left+1;i<=right;++i){\",\"j=i;ptr+=s0\",\"cptr=ptr\"),t.length>1){o.push(\"dptr=0;sptr=ptr\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(\"scratch[dptr++]=\",r(\"sptr\"));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push(\"sptr+=d\"+d,\"}\")}o.push(\"__g:while(j--\\x3eleft){\",\"dptr=0\",\"sptr=cptr-s0\");for(var f=1;f<t.length;++f)1===f&&o.push(\"__l:\"),o.push([\"for(i\",f,\"=0;i\",f,\"<n\",f,\";++i\",f,\"){\"].join(\"\"));o.push([\"a=\",r(\"sptr\"),\"\\nb=scratch[dptr]\\nif(a<b){break __g}\\nif(a>b){break __l}\"].join(\"\"));for(var f=t.length-1;f>=1;--f)o.push(\"sptr+=e\"+f,\"dptr+=f\"+f,\"}\");o.push(\"dptr=cptr;sptr=cptr-s0\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(a(\"dptr\",r(\"sptr\")));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push([\"dptr+=d\",d,\";sptr+=d\",d].join(\"\"),\"}\")}o.push(\"cptr-=s0\\n}\"),o.push(\"dptr=cptr;sptr=0\");for(var f=t.length-1;f>=0;--f){var d=t[f];0!==d&&o.push([\"for(i\",d,\"=0;i\",d,\"<n\",d,\";++i\",d,\"){\"].join(\"\"))}o.push(a(\"dptr\",\"scratch[sptr++]\"));for(var f=0;f<t.length;++f){var d=t[f];0!==d&&o.push(\"dptr+=d\"+d,\"}\")}}else o.push(\"scratch=\"+r(\"ptr\"),\"while((j--\\x3eleft)&&(\"+r(\"cptr-s0\")+\">scratch)){\",a(\"cptr\",r(\"cptr-s0\")),\"cptr-=s0\",\"}\",a(\"cptr\",\"scratch\"));if(o.push(\"}\"),t.length>1&&u&&o.push(\"free(scratch)\"),o.push(\"} return \"+s),u){var p=new Function(\"malloc\",\"free\",o.join(\"\\n\"));return p(u[0],u[1])}var p=new Function(o.join(\"\\n\"));return p()}function o(t,e,r){function a(t){return[\"(offset+\",t,\"*s0)\"].join(\"\")}function o(t){return\"generic\"===e?[\"data.get(\",t,\")\"].join(\"\"):[\"data[\",t,\"]\"].join(\"\")}function s(t,r){return\"generic\"===e?[\"data.set(\",t,\",\",r,\")\"].join(\"\"):[\"data[\",t,\"]=\",r].join(\"\")}function l(e,r,n){if(1===e.length)_.push(\"ptr0=\"+a(e[0]));else for(var i=0;i<e.length;++i)_.push([\"b_ptr\",i,\"=s0*\",e[i]].join(\"\"));r&&_.push(\"pivot_ptr=0\"),_.push(\"ptr_shift=offset\");for(var i=t.length-1;i>=0;--i){var o=t[i];0!==o&&_.push([\"for(i\",o,\"=0;i\",o,\"<n\",o,\";++i\",o,\"){\"].join(\"\"))}if(e.length>1)for(var i=0;i<e.length;++i)_.push([\"ptr\",i,\"=b_ptr\",i,\"+ptr_shift\"].join(\"\"));_.push(n),r&&_.push(\"++pivot_ptr\");for(var i=0;i<t.length;++i){var o=t[i];0!==o&&(e.length>1?_.push(\"ptr_shift+=d\"+o):_.push(\"ptr0+=d\"+o),_.push(\"}\"))}}function c(e,r,n,i){if(1===r.length)_.push(\"ptr0=\"+a(r[0]));else{for(var o=0;o<r.length;++o)_.push([\"b_ptr\",o,\"=s0*\",r[o]].join(\"\"));_.push(\"ptr_shift=offset\")}n&&_.push(\"pivot_ptr=0\"),e&&_.push(e+\":\");for(var o=1;o<t.length;++o)_.push([\"for(i\",o,\"=0;i\",o,\"<n\",o,\";++i\",o,\"){\"].join(\"\"));if(r.length>1)for(var o=0;o<r.length;++o)_.push([\"ptr\",o,\"=b_ptr\",o,\"+ptr_shift\"].join(\"\"));_.push(i);for(var o=t.length-1;o>=1;--o)n&&_.push(\"pivot_ptr+=f\"+o),r.length>1?_.push(\"ptr_shift+=e\"+o):_.push(\"ptr0+=e\"+o),_.push(\"}\")}function h(){t.length>1&&k&&_.push(\"free(pivot1)\",\"free(pivot2)\")}function f(e,r){var n=\"el\"+e,i=\"el\"+r;if(t.length>1){var s=\"__l\"+ ++A;c(s,[n,i],!1,[\"comp=\",o(\"ptr0\"),\"-\",o(\"ptr1\"),\"\\n\",\"if(comp>0){tmp0=\",n,\";\",n,\"=\",i,\";\",i,\"=tmp0;break \",s,\"}\\n\",\"if(comp<0){break \",s,\"}\"].join(\"\"))}else _.push([\"if(\",o(a(n)),\">\",o(a(i)),\"){tmp0=\",n,\";\",n,\"=\",i,\";\",i,\"=tmp0}\"].join(\"\"))}function d(e,r){t.length>1?l([e,r],!1,s(\"ptr0\",o(\"ptr1\"))):_.push(s(a(e),o(a(r))))}function p(e,r,n){if(t.length>1){var i=\"__l\"+ ++A;c(i,[r],!0,[e,\"=\",o(\"ptr0\"),\"-pivot\",n,\"[pivot_ptr]\\n\",\"if(\",e,\"!==0){break \",i,\"}\"].join(\"\"))}else _.push([e,\"=\",o(a(r)),\"-pivot\",n].join(\"\"))}function m(e,r){t.length>1?l([e,r],!1,[\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",\"tmp\")].join(\"\")):_.push([\"ptr0=\",a(e),\"\\n\",\"ptr1=\",a(r),\"\\n\",\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",\"tmp\")].join(\"\"))}function v(e,r,n){t.length>1?(l([e,r,n],!1,[\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",o(\"ptr2\")),\"\\n\",s(\"ptr2\",\"tmp\")].join(\"\")),_.push(\"++\"+r,\"--\"+n)):_.push([\"ptr0=\",a(e),\"\\n\",\"ptr1=\",a(r),\"\\n\",\"ptr2=\",a(n),\"\\n\",\"++\",r,\"\\n\",\"--\",n,\"\\n\",\"tmp=\",o(\"ptr0\"),\"\\n\",s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",o(\"ptr2\")),\"\\n\",s(\"ptr2\",\"tmp\")].join(\"\"))}function g(t,e){m(t,e),_.push(\"--\"+e)}function y(e,r,n){t.length>1?l([e,r],!0,[s(\"ptr0\",o(\"ptr1\")),\"\\n\",s(\"ptr1\",[\"pivot\",n,\"[pivot_ptr]\"].join(\"\"))].join(\"\")):_.push(s(a(e),o(a(r))),s(a(r),\"pivot\"+n))}function b(e,r){_.push([\"if((\",r,\"-\",e,\")<=\",u,\"){\\n\",\"insertionSort(\",e,\",\",r,\",data,offset,\",i(t.length).join(\",\"),\")\\n\",\"}else{\\n\",w,\"(\",e,\",\",r,\",data,offset,\",i(t.length).join(\",\"),\")\\n\",\"}\"].join(\"\"))}function x(e,r,n){t.length>1?(_.push([\"__l\",++A,\":while(true){\"].join(\"\")),l([e],!0,[\"if(\",o(\"ptr0\"),\"!==pivot\",r,\"[pivot_ptr]){break __l\",A,\"}\"].join(\"\")),_.push(n,\"}\")):_.push([\"while(\",o(a(e)),\"===pivot\",r,\"){\",n,\"}\"].join(\"\"))}var _=[\"'use strict'\"],w=[\"ndarrayQuickSort\",t.join(\"d\"),e].join(\"\"),M=[\"left\",\"right\",\"data\",\"offset\"].concat(i(t.length)),k=n(e),A=0;_.push([\"function \",w,\"(\",M.join(\",\"),\"){\"].join(\"\"));var T=[\"sixth=((right-left+1)/6)|0\",\"index1=left+sixth\",\"index5=right-sixth\",\"index3=(left+right)>>1\",\"index2=index3-sixth\",\"index4=index3+sixth\",\"el1=index1\",\"el2=index2\",\"el3=index3\",\"el4=index4\",\"el5=index5\",\"less=left+1\",\"great=right-1\",\"pivots_are_equal=true\",\"tmp\",\"tmp0\",\"x\",\"y\",\"z\",\"k\",\"ptr0\",\"ptr1\",\"ptr2\",\"comp_pivot1=0\",\"comp_pivot2=0\",\"comp=0\"];if(t.length>1){for(var S=[],E=1;E<t.length;++E)S.push(\"n\"+E),T.push(\"i\"+E);for(var E=0;E<8;++E)T.push(\"b_ptr\"+E);T.push(\"ptr3\",\"ptr4\",\"ptr5\",\"ptr6\",\"ptr7\",\"pivot_ptr\",\"ptr_shift\",\"elementSize=\"+S.join(\"*\")),k?T.push(\"pivot1=malloc(elementSize)\",\"pivot2=malloc(elementSize)\"):T.push(\"pivot1=new Array(elementSize),pivot2=new Array(elementSize)\")}else T.push(\"pivot1\",\"pivot2\");if(_.push(\"var \"+T.join(\",\")),f(1,2),f(4,5),f(1,3),f(2,3),f(1,4),f(3,4),f(2,5),f(2,3),f(4,5),t.length>1?l([\"el1\",\"el2\",\"el3\",\"el4\",\"el5\",\"index1\",\"index3\",\"index5\"],!0,[\"pivot1[pivot_ptr]=\",o(\"ptr1\"),\"\\n\",\"pivot2[pivot_ptr]=\",o(\"ptr3\"),\"\\n\",\"pivots_are_equal=pivots_are_equal&&(pivot1[pivot_ptr]===pivot2[pivot_ptr])\\n\",\"x=\",o(\"ptr0\"),\"\\n\",\"y=\",o(\"ptr2\"),\"\\n\",\"z=\",o(\"ptr4\"),\"\\n\",s(\"ptr5\",\"x\"),\"\\n\",s(\"ptr6\",\"y\"),\"\\n\",s(\"ptr7\",\"z\")].join(\"\")):_.push([\"pivot1=\",o(a(\"el2\")),\"\\n\",\"pivot2=\",o(a(\"el4\")),\"\\n\",\"pivots_are_equal=pivot1===pivot2\\n\",\"x=\",o(a(\"el1\")),\"\\n\",\"y=\",o(a(\"el3\")),\"\\n\",\"z=\",o(a(\"el5\")),\"\\n\",s(a(\"index1\"),\"x\"),\"\\n\",s(a(\"index3\"),\"y\"),\"\\n\",s(a(\"index5\"),\"z\")].join(\"\")),d(\"index2\",\"left\"),d(\"index4\",\"right\"),_.push(\"if(pivots_are_equal){\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp\",\"k\",1),_.push(\"if(comp===0){continue}\"),_.push(\"if(comp<0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),_.push(\"while(true){\"),p(\"comp\",\"great\",1),_.push(\"if(comp>0){\"),_.push(\"great--\"),_.push(\"}else if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"break\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}else{\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp_pivot1\",\"k\",1),_.push(\"if(comp_pivot1<0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),p(\"comp_pivot2\",\"k\",2),_.push(\"if(comp_pivot2>0){\"),_.push(\"while(true){\"),p(\"comp\",\"great\",2),_.push(\"if(comp>0){\"),_.push(\"if(--great<k){break}\"),_.push(\"continue\"),_.push(\"}else{\"),p(\"comp\",\"great\",1),_.push(\"if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"}\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),y(\"left\",\"(less-1)\",1),y(\"right\",\"(great+1)\",2),b(\"left\",\"(less-2)\"),b(\"(great+2)\",\"right\"),_.push(\"if(pivots_are_equal){\"),h(),_.push(\"return\"),_.push(\"}\"),_.push(\"if(less<index1&&great>index5){\"),x(\"less\",1,\"++less\"),x(\"great\",2,\"--great\"),_.push(\"for(k=less;k<=great;++k){\"),p(\"comp_pivot1\",\"k\",1),_.push(\"if(comp_pivot1===0){\"),_.push(\"if(k!==less){\"),m(\"k\",\"less\"),_.push(\"}\"),_.push(\"++less\"),_.push(\"}else{\"),p(\"comp_pivot2\",\"k\",2),_.push(\"if(comp_pivot2===0){\"),_.push(\"while(true){\"),p(\"comp\",\"great\",2),_.push(\"if(comp===0){\"),_.push(\"if(--great<k){break}\"),_.push(\"continue\"),_.push(\"}else{\"),p(\"comp\",\"great\",1),_.push(\"if(comp<0){\"),v(\"k\",\"less\",\"great\"),_.push(\"}else{\"),g(\"k\",\"great\"),_.push(\"}\"),_.push(\"break\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),_.push(\"}\"),h(),b(\"less\",\"great\"),_.push(\"}return \"+w),t.length>1&&k){var L=new Function(\"insertionSort\",\"malloc\",\"free\",_.join(\"\\n\"));return L(r,k[0],k[1])}var L=new Function(\"insertionSort\",_.join(\"\\n\"));return L(r)}function s(t,e){var r=[\"'use strict'\"],n=[\"ndarraySortWrapper\",t.join(\"d\"),e].join(\"\"),s=[\"array\"];r.push([\"function \",n,\"(\",s.join(\",\"),\"){\"].join(\"\"));for(var l=[\"data=array.data,offset=array.offset|0,shape=array.shape,stride=array.stride\"],c=0;c<t.length;++c)l.push([\"s\",c,\"=stride[\",c,\"]|0,n\",c,\"=shape[\",c,\"]|0\"].join(\"\"));for(var h=new Array(t.length),f=[],c=0;c<t.length;++c){var d=t[c];0!==d&&(0===f.length?h[d]=\"1\":h[d]=f.join(\"*\"),f.push(\"n\"+d))}for(var p=-1,m=-1,c=0;c<t.length;++c){var v=t[c];0!==v&&(p>0?l.push([\"d\",v,\"=s\",v,\"-d\",p,\"*n\",p].join(\"\")):l.push([\"d\",v,\"=s\",v].join(\"\")),p=v);var d=t.length-1-c;0!==d&&(m>0?l.push([\"e\",d,\"=s\",d,\"-e\",m,\"*n\",m,\",f\",d,\"=\",h[d],\"-f\",m,\"*n\",m].join(\"\")):l.push([\"e\",d,\"=s\",d,\",f\",d,\"=\",h[d]].join(\"\")),m=d)}r.push(\"var \"+l.join(\",\"));var g=[\"0\",\"n0-1\",\"data\",\"offset\"].concat(i(t.length));r.push([\"if(n0<=\",u,\"){\",\"insertionSort(\",g.join(\",\"),\")}else{\",\"quickSort(\",g.join(\",\"),\")}\"].join(\"\")),r.push(\"}return \"+n);var y=new Function(\"insertionSort\",\"quickSort\",r.join(\"\\n\")),b=a(t,e);return y(b,o(t,e,b))}var l=t(\"typedarray-pool\"),u=32;e.exports=s},{\"typedarray-pool\":540}],464:[function(t,e,r){\"use strict\";function n(t){var e=t.order,r=t.dtype,n=[e,r],o=n.join(\":\"),s=a[o];return s||(a[o]=s=i(e,r)),s(t),t}var i=t(\"./lib/compile_sort.js\"),a={};e.exports=n},{\"./lib/compile_sort.js\":463}],465:[function(t,e,r){\"use strict\";var n=t(\"ndarray-linear-interpolate\"),i=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=new Array(_inline_33_arg4_)}\",args:[{name:\"_inline_33_arg0_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg1_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg2_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg3_\",lvalue:!1,rvalue:!1,count:0},{name:\"_inline_33_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_34_arg2_(this_warped,_inline_34_arg0_),_inline_34_arg1_=_inline_34_arg3_.apply(void 0,this_warped)}\",args:[{name:\"_inline_34_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_34_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_34_arg4_\",lvalue:!1,rvalue:!1,count:0}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warpND\",blockSize:64}),a=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_37_arg2_(this_warped,_inline_37_arg0_),_inline_37_arg1_=_inline_37_arg3_(_inline_37_arg4_,this_warped[0])}\",args:[{name:\"_inline_37_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_37_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_37_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp1D\",blockSize:64}),o=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0,0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_40_arg2_(this_warped,_inline_40_arg0_),_inline_40_arg1_=_inline_40_arg3_(_inline_40_arg4_,this_warped[0],this_warped[1])}\",args:[{name:\"_inline_40_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_40_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_40_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp2D\",blockSize:64}),s=t(\"cwise/lib/wrapper\")({args:[\"index\",\"array\",\"scalar\",\"scalar\",\"scalar\"],pre:{body:\"{this_warped=[0,0,0]}\",args:[],thisVars:[\"this_warped\"],localVars:[]},body:{body:\"{_inline_43_arg2_(this_warped,_inline_43_arg0_),_inline_43_arg1_=_inline_43_arg3_(_inline_43_arg4_,this_warped[0],this_warped[1],this_warped[2])}\",args:[{name:\"_inline_43_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg1_\",lvalue:!0,rvalue:!1,count:1},{name:\"_inline_43_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg3_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_43_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[\"this_warped\"],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},debug:!1,funcName:\"warp3D\",blockSize:64});e.exports=function(t,e,r){switch(e.shape.length){case 1:a(t,r,n.d1,e);break;case 2:o(t,r,n.d2,e);break;case 3:s(t,r,n.d3,e);break;default:i(t,r,n.bind(void 0,e),e.shape.length)}return t}},{\"cwise/lib/wrapper\":112,\"ndarray-linear-interpolate\":459}],466:[function(t,e,r){function n(t,e){return t[0]-e[0]}function i(){var t,e=this.stride,r=new Array(e.length);for(t=0;t<r.length;++t)r[t]=[Math.abs(e[t]),t];r.sort(n);var i=new Array(r.length);for(t=0;t<i.length;++t)i[t]=r[t][1];return i}function a(t,e){var r=[\"View\",e,\"d\",t].join(\"\");e<0&&(r=\"View_Nil\"+t);var n=\"generic\"===t;if(-1===e){\n",
       "var a=\"function \"+r+\"(a){this.data=a;};var proto=\"+r+\".prototype;proto.dtype='\"+t+\"';proto.index=function(){return -1};proto.size=0;proto.dimension=-1;proto.shape=proto.stride=proto.order=[];proto.lo=proto.hi=proto.transpose=proto.step=function(){return new \"+r+\"(this.data);};proto.get=proto.set=function(){};proto.pick=function(){return null};return function construct_\"+r+\"(a){return new \"+r+\"(a);}\",o=new Function(a);return o()}if(0===e){var a=\"function \"+r+\"(a,d) {this.data = a;this.offset = d};var proto=\"+r+\".prototype;proto.dtype='\"+t+\"';proto.index=function(){return this.offset};proto.dimension=0;proto.size=1;proto.shape=proto.stride=proto.order=[];proto.lo=proto.hi=proto.transpose=proto.step=function \"+r+\"_copy() {return new \"+r+\"(this.data,this.offset)};proto.pick=function \"+r+\"_pick(){return TrivialArray(this.data);};proto.valueOf=proto.get=function \"+r+\"_get(){return \"+(n?\"this.data.get(this.offset)\":\"this.data[this.offset]\")+\"};proto.set=function \"+r+\"_set(v){return \"+(n?\"this.data.set(this.offset,v)\":\"this.data[this.offset]=v\")+\"};return function construct_\"+r+\"(a,b,c,d){return new \"+r+\"(a,d)}\",o=new Function(\"TrivialArray\",a);return o(h[t][0])}var a=[\"'use strict'\"],s=l(e),u=s.map(function(t){return\"i\"+t}),c=\"this.offset+\"+s.map(function(t){return\"this.stride[\"+t+\"]*i\"+t}).join(\"+\"),f=s.map(function(t){return\"b\"+t}).join(\",\"),d=s.map(function(t){return\"c\"+t}).join(\",\");a.push(\"function \"+r+\"(a,\"+f+\",\"+d+\",d){this.data=a\",\"this.shape=[\"+f+\"]\",\"this.stride=[\"+d+\"]\",\"this.offset=d|0}\",\"var proto=\"+r+\".prototype\",\"proto.dtype='\"+t+\"'\",\"proto.dimension=\"+e),a.push(\"Object.defineProperty(proto,'size',{get:function \"+r+\"_size(){return \"+s.map(function(t){return\"this.shape[\"+t+\"]\"}).join(\"*\"),\"}})\"),1===e?a.push(\"proto.order=[0]\"):(a.push(\"Object.defineProperty(proto,'order',{get:\"),e<4?(a.push(\"function \"+r+\"_order(){\"),2===e?a.push(\"return (Math.abs(this.stride[0])>Math.abs(this.stride[1]))?[1,0]:[0,1]}})\"):3===e&&a.push(\"var s0=Math.abs(this.stride[0]),s1=Math.abs(this.stride[1]),s2=Math.abs(this.stride[2]);if(s0>s1){if(s1>s2){return [2,1,0];}else if(s0>s2){return [1,2,0];}else{return [1,0,2];}}else if(s0>s2){return [2,0,1];}else if(s2>s1){return [0,1,2];}else{return [0,2,1];}}})\")):a.push(\"ORDER})\")),a.push(\"proto.set=function \"+r+\"_set(\"+u.join(\",\")+\",v){\"),n?a.push(\"return this.data.set(\"+c+\",v)}\"):a.push(\"return this.data[\"+c+\"]=v}\"),a.push(\"proto.get=function \"+r+\"_get(\"+u.join(\",\")+\"){\"),n?a.push(\"return this.data.get(\"+c+\")}\"):a.push(\"return this.data[\"+c+\"]}\"),a.push(\"proto.index=function \"+r+\"_index(\",u.join(),\"){return \"+c+\"}\"),a.push(\"proto.hi=function \"+r+\"_hi(\"+u.join(\",\")+\"){return new \"+r+\"(this.data,\"+s.map(function(t){return[\"(typeof i\",t,\"!=='number'||i\",t,\"<0)?this.shape[\",t,\"]:i\",t,\"|0\"].join(\"\")}).join(\",\")+\",\"+s.map(function(t){return\"this.stride[\"+t+\"]\"}).join(\",\")+\",this.offset)}\");var p=s.map(function(t){return\"a\"+t+\"=this.shape[\"+t+\"]\"}),m=s.map(function(t){return\"c\"+t+\"=this.stride[\"+t+\"]\"});a.push(\"proto.lo=function \"+r+\"_lo(\"+u.join(\",\")+\"){var b=this.offset,d=0,\"+p.join(\",\")+\",\"+m.join(\",\"));for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'&&i\"+v+\">=0){d=i\"+v+\"|0;b+=c\"+v+\"*d;a\"+v+\"-=d}\");a.push(\"return new \"+r+\"(this.data,\"+s.map(function(t){return\"a\"+t}).join(\",\")+\",\"+s.map(function(t){return\"c\"+t}).join(\",\")+\",b)}\"),a.push(\"proto.step=function \"+r+\"_step(\"+u.join(\",\")+\"){var \"+s.map(function(t){return\"a\"+t+\"=this.shape[\"+t+\"]\"}).join(\",\")+\",\"+s.map(function(t){return\"b\"+t+\"=this.stride[\"+t+\"]\"}).join(\",\")+\",c=this.offset,d=0,ceil=Math.ceil\");for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'){d=i\"+v+\"|0;if(d<0){c+=b\"+v+\"*(a\"+v+\"-1);a\"+v+\"=ceil(-a\"+v+\"/d)}else{a\"+v+\"=ceil(a\"+v+\"/d)}b\"+v+\"*=d}\");a.push(\"return new \"+r+\"(this.data,\"+s.map(function(t){return\"a\"+t}).join(\",\")+\",\"+s.map(function(t){return\"b\"+t}).join(\",\")+\",c)}\");for(var g=new Array(e),y=new Array(e),v=0;v<e;++v)g[v]=\"a[i\"+v+\"]\",y[v]=\"b[i\"+v+\"]\";a.push(\"proto.transpose=function \"+r+\"_transpose(\"+u+\"){\"+u.map(function(t,e){return t+\"=(\"+t+\"===undefined?\"+e+\":\"+t+\"|0)\"}).join(\";\"),\"var a=this.shape,b=this.stride;return new \"+r+\"(this.data,\"+g.join(\",\")+\",\"+y.join(\",\")+\",this.offset)}\"),a.push(\"proto.pick=function \"+r+\"_pick(\"+u+\"){var a=[],b=[],c=this.offset\");for(var v=0;v<e;++v)a.push(\"if(typeof i\"+v+\"==='number'&&i\"+v+\">=0){c=(c+this.stride[\"+v+\"]*i\"+v+\")|0}else{a.push(this.shape[\"+v+\"]);b.push(this.stride[\"+v+\"])}\");a.push(\"var ctor=CTOR_LIST[a.length+1];return ctor(this.data,a,b,c)}\"),a.push(\"return function construct_\"+r+\"(data,shape,stride,offset){return new \"+r+\"(data,\"+s.map(function(t){return\"shape[\"+t+\"]\"}).join(\",\")+\",\"+s.map(function(t){return\"stride[\"+t+\"]\"}).join(\",\")+\",offset)}\");var o=new Function(\"CTOR_LIST\",\"ORDER\",a.join(\"\\n\"));return o(h[t],i)}function o(t){if(u(t))return\"buffer\";if(c)switch(Object.prototype.toString.call(t)){case\"[object Float64Array]\":return\"float64\";case\"[object Float32Array]\":return\"float32\";case\"[object Int8Array]\":return\"int8\";case\"[object Int16Array]\":return\"int16\";case\"[object Int32Array]\":return\"int32\";case\"[object Uint8Array]\":return\"uint8\";case\"[object Uint16Array]\":return\"uint16\";case\"[object Uint32Array]\":return\"uint32\";case\"[object Uint8ClampedArray]\":return\"uint8_clamped\"}return Array.isArray(t)?\"array\":\"generic\"}function s(t,e,r,n){if(void 0===t){var i=h.array[0];return i([])}\"number\"==typeof t&&(t=[t]),void 0===e&&(e=[t.length]);var s=e.length;if(void 0===r){r=new Array(s);for(var l=s-1,u=1;l>=0;--l)r[l]=u,u*=e[l]}if(void 0===n){n=0;for(var l=0;l<s;++l)r[l]<0&&(n-=(e[l]-1)*r[l])}for(var c=o(t),f=h[c];f.length<=s+1;)f.push(a(c,f.length-1));var i=f[s+1];return i(t,e,r,n)}var l=t(\"iota-array\"),u=t(\"is-buffer\"),c=\"undefined\"!=typeof Float64Array,h={float32:[],float64:[],int8:[],int16:[],int32:[],uint8:[],uint16:[],uint32:[],array:[],uint8_clamped:[],buffer:[],generic:[]};e.exports=s},{\"iota-array\":292,\"is-buffer\":294}],467:[function(t,e,r){\"use strict\";function n(t,e){if(isNaN(t)||isNaN(e))return NaN;if(t===e)return t;if(0===t)return e<0?-a:a;var r=i.hi(t),n=i.lo(t);return e>t==t>0?n===o?(r+=1,n=0):n+=1:0===n?(n=o,r-=1):n-=1,i.pack(n,r)}var i=t(\"double-bits\"),a=Math.pow(2,-1074),o=-1>>>0;e.exports=n},{\"double-bits\":123}],468:[function(t,e,r){r.vertexNormals=function(t,e,r){for(var n=e.length,i=new Array(n),a=void 0===r?1e-6:r,o=0;o<n;++o)i[o]=[0,0,0];for(var o=0;o<t.length;++o)for(var s=t[o],l=0,u=s[s.length-1],c=s[0],h=0;h<s.length;++h){l=u,u=c,c=s[(h+1)%s.length];for(var f=e[l],d=e[u],p=e[c],m=new Array(3),v=0,g=new Array(3),y=0,b=0;b<3;++b)m[b]=f[b]-d[b],v+=m[b]*m[b],g[b]=p[b]-d[b],y+=g[b]*g[b];if(v*y>a)for(var x=i[u],_=1/Math.sqrt(v*y),b=0;b<3;++b){var w=(b+1)%3,M=(b+2)%3;x[b]+=_*(g[w]*m[M]-g[M]*m[w])}}for(var o=0;o<n;++o){for(var x=i[o],k=0,b=0;b<3;++b)k+=x[b]*x[b];if(k>a)for(var _=1/Math.sqrt(k),b=0;b<3;++b)x[b]*=_;else for(var b=0;b<3;++b)x[b]=0}return i},r.faceNormals=function(t,e,r){for(var n=t.length,i=new Array(n),a=void 0===r?1e-6:r,o=0;o<n;++o){for(var s=t[o],l=new Array(3),u=0;u<3;++u)l[u]=e[s[u]];for(var c=new Array(3),h=new Array(3),u=0;u<3;++u)c[u]=l[1][u]-l[0][u],h[u]=l[2][u]-l[0][u];for(var f=new Array(3),d=0,u=0;u<3;++u){var p=(u+1)%3,m=(u+2)%3;f[u]=c[p]*h[m]-c[m]*h[p],d+=f[u]*f[u]}d=d>a?1/Math.sqrt(d):0;for(var u=0;u<3;++u)f[u]*=d;i[o]=f}return i}},{}],469:[function(t,e,r){\"use strict\";function n(t){if(null===t||void 0===t)throw new TypeError(\"Object.assign cannot be called with null or undefined\");return Object(t)}var i=Object.getOwnPropertySymbols,a=Object.prototype.hasOwnProperty,o=Object.prototype.propertyIsEnumerable;e.exports=function(){try{if(!Object.assign)return!1;var t=new String(\"abc\");if(t[5]=\"de\",\"5\"===Object.getOwnPropertyNames(t)[0])return!1;for(var e={},r=0;r<10;r++)e[\"_\"+String.fromCharCode(r)]=r;if(\"0123456789\"!==Object.getOwnPropertyNames(e).map(function(t){return e[t]}).join(\"\"))return!1;var n={};return\"abcdefghijklmnopqrst\".split(\"\").forEach(function(t){n[t]=t}),\"abcdefghijklmnopqrst\"===Object.keys(Object.assign({},n)).join(\"\")}catch(t){return!1}}()?Object.assign:function(t,e){for(var r,s,l=n(t),u=1;u<arguments.length;u++){r=Object(arguments[u]);for(var c in r)a.call(r,c)&&(l[c]=r[c]);if(i){s=i(r);for(var h=0;h<s.length;h++)o.call(r,s[h])&&(l[s[h]]=r[s[h]])}}return l}},{}],470:[function(t,e,r){\"use strict\";function n(t,e){var r,n,o;return\"string\"==typeof t?(r=i(t,e),n=r.width,o=r.height):t instanceof HTMLCanvasElement?(n=t.width,o=t.height,t=t.getContext(\"2d\"),r=t.getImageData(0,0,n,o)):t instanceof ImageData&&(n=t.width,o=t.height,r=t),a(r)}function i(t,e){e||(e={});var r=e.family||\"sans-serif\",n=l.width,i=l.height,a=e.width||e.height||e.size;a&&a!=n&&(n=i=l.width=l.height=a);var o=e.fontSize||n/2;return u.fillStyle=\"#000\",u.fillRect(0,0,n,i),u.font=o+\"px \"+r,u.textBaseline=\"middle\",u.textAlign=\"center\",u.fillStyle=\"white\",u.fillText(t,n/2,i/2),u.getImageData(0,0,n,i)}function a(t){var e,r,n,i,a,l,u,c,h,f,d,p,m,v=t.data,g=t.width,y=t.height,b=Array(y),x=Array(y),_=0,w=0,M=g,k=0,A=0,T=Array(y);for(r=0;r<y;r++)if(l=0,u=0,a=4*r*g,d=o(v.subarray(a,a+4*g),4),d[0]!==d[1]){for(_||(_=r),w=r,e=d[0];e<d[1];e++)i=4*e,n=v[a+i],l+=n,u+=e*n;b[r]=0===l?0:l/g,x[r]=0===l?0:u/l,d[0]<M&&(M=d[0]),d[1]>k&&(k=d[1]),T[r]=d}for(l=0,c=0,u=0,r=0;r<y;r++)(p=b[r])&&(c+=p*r,l+=p,u+=x[r]*p);for(f=c/l,h=u/l,A=0,m=0,r=0;r<y;r++)(d=T[r])&&(m=Math.max(s(h-d[0],f-r),s(h-d[1],f-r)))>A&&(A=m);return{center:[h,f],bounds:[M,_,k,w+1],radius:Math.sqrt(A)}}function o(t,e){var r=0,n=t.length,i=0;for(e||(e=4);!t[i]&&i<n;)i+=e;for(r=i,i=t.length;!t[i]&&i>r;)i-=e;return n=i,[r/e,n/e]}function s(t,e){return t*t+e*e}e.exports=n;var l=document.createElement(\"canvas\"),u=l.getContext(\"2d\");l.width=200,l.height=200,n.canvas=l},{}],471:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s,l,u){var c=e+a+u;if(h>0){var h=Math.sqrt(c+1);t[0]=.5*(o-l)/h,t[1]=.5*(s-n)/h,t[2]=.5*(r-a)/h,t[3]=.5*h}else{var f=Math.max(e,a,u),h=Math.sqrt(2*f-c+1);e>=f?(t[0]=.5*h,t[1]=.5*(i+r)/h,t[2]=.5*(s+n)/h,t[3]=.5*(o-l)/h):a>=f?(t[0]=.5*(r+i)/h,t[1]=.5*h,t[2]=.5*(l+o)/h,t[3]=.5*(s-n)/h):(t[0]=.5*(n+s)/h,t[1]=.5*(o+l)/h,t[2]=.5*h,t[3]=.5*(r-i)/h)}return t}e.exports=n},{}],472:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2))}function i(t,e,r,n){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2)+Math.pow(n,2))}function a(t,e){var r=e[0],n=e[1],a=e[2],o=e[3],s=i(r,n,a,o);s>1e-6?(t[0]=r/s,t[1]=n/s,t[2]=a/s,t[3]=o/s):(t[0]=t[1]=t[2]=0,t[3]=1)}function o(t,e,r){this.radius=l([r]),this.center=l(e),this.rotation=l(t),this.computedRadius=this.radius.curve(0),this.computedCenter=this.center.curve(0),this.computedRotation=this.rotation.curve(0),this.computedUp=[.1,0,0],this.computedEye=[.1,0,0],this.computedMatrix=[.1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],this.recalcMatrix(0)}function s(t){t=t||{};var e=t.center||[0,0,0],r=t.rotation||[0,0,0,1],n=t.radius||1;e=[].slice.call(e,0,3),r=[].slice.call(r,0,4),a(r,r);var i=new o(r,e,Math.log(n));return i.setDistanceLimits(t.zoomMin,t.zoomMax),(\"eye\"in t||\"up\"in t)&&i.lookAt(0,t.eye,t.center,t.up),i}e.exports=s;var l=t(\"filtered-vector\"),u=t(\"gl-mat4/lookAt\"),c=t(\"gl-mat4/fromQuat\"),h=t(\"gl-mat4/invert\"),f=t(\"./lib/quatFromFrame\"),d=o.prototype;d.lastT=function(){return Math.max(this.radius.lastT(),this.center.lastT(),this.rotation.lastT())},d.recalcMatrix=function(t){this.radius.curve(t),this.center.curve(t),this.rotation.curve(t);var e=this.computedRotation;a(e,e);var r=this.computedMatrix;c(r,e);var n=this.computedCenter,i=this.computedEye,o=this.computedUp,s=Math.exp(this.computedRadius[0]);i[0]=n[0]+s*r[2],i[1]=n[1]+s*r[6],i[2]=n[2]+s*r[10],o[0]=r[1],o[1]=r[5],o[2]=r[9];for(var l=0;l<3;++l){for(var u=0,h=0;h<3;++h)u+=r[l+4*h]*i[h];r[12+l]=-u}},d.getMatrix=function(t,e){this.recalcMatrix(t);var r=this.computedMatrix;if(e){for(var n=0;n<16;++n)e[n]=r[n];return e}return r},d.idle=function(t){this.center.idle(t),this.radius.idle(t),this.rotation.idle(t)},d.flush=function(t){this.center.flush(t),this.radius.flush(t),this.rotation.flush(t)},d.pan=function(t,e,r,i){e=e||0,r=r||0,i=i||0,this.recalcMatrix(t);var a=this.computedMatrix,o=a[1],s=a[5],l=a[9],u=n(o,s,l);o/=u,s/=u,l/=u;var c=a[0],h=a[4],f=a[8],d=c*o+h*s+f*l;c-=o*d,h-=s*d,f-=l*d;var p=n(c,h,f);c/=p,h/=p,f/=p;var m=a[2],v=a[6],g=a[10],y=m*o+v*s+g*l,b=m*c+v*h+g*f;m-=y*o+b*c,v-=y*s+b*h,g-=y*l+b*f;var x=n(m,v,g);m/=x,v/=x,g/=x;var _=c*e+o*r,w=h*e+s*r,M=f*e+l*r;this.center.move(t,_,w,M);var k=Math.exp(this.computedRadius[0]);k=Math.max(1e-4,k+i),this.radius.set(t,Math.log(k))},d.rotate=function(t,e,r,a){this.recalcMatrix(t),e=e||0,r=r||0;var o=this.computedMatrix,s=o[0],l=o[4],u=o[8],c=o[1],h=o[5],f=o[9],d=o[2],p=o[6],m=o[10],v=e*s+r*c,g=e*l+r*h,y=e*u+r*f,b=-(p*y-m*g),x=-(m*v-d*y),_=-(d*g-p*v),w=Math.sqrt(Math.max(0,1-Math.pow(b,2)-Math.pow(x,2)-Math.pow(_,2))),M=i(b,x,_,w);M>1e-6?(b/=M,x/=M,_/=M,w/=M):(b=x=_=0,w=1);var k=this.computedRotation,A=k[0],T=k[1],S=k[2],E=k[3],L=A*w+E*b+T*_-S*x,C=T*w+E*x+S*b-A*_,z=S*w+E*_+A*x-T*b,I=E*w-A*b-T*x-S*_;if(a){b=d,x=p,_=m;var D=Math.sin(a)/n(b,x,_);b*=D,x*=D,_*=D,w=Math.cos(e),L=L*w+I*b+C*_-z*x,C=C*w+I*x+z*b-L*_,z=z*w+I*_+L*x-C*b,I=I*w-L*b-C*x-z*_}var P=i(L,C,z,I);P>1e-6?(L/=P,C/=P,z/=P,I/=P):(L=C=z=0,I=1),this.rotation.set(t,L,C,z,I)},d.lookAt=function(t,e,r,n){this.recalcMatrix(t),r=r||this.computedCenter,e=e||this.computedEye,n=n||this.computedUp;var i=this.computedMatrix;u(i,e,r,n);var o=this.computedRotation;f(o,i[0],i[1],i[2],i[4],i[5],i[6],i[8],i[9],i[10]),a(o,o),this.rotation.set(t,o[0],o[1],o[2],o[3]);for(var s=0,l=0;l<3;++l)s+=Math.pow(r[l]-e[l],2);this.radius.set(t,.5*Math.log(Math.max(s,1e-6))),this.center.set(t,r[0],r[1],r[2])},d.translate=function(t,e,r,n){this.center.move(t,e||0,r||0,n||0)},d.setMatrix=function(t,e){var r=this.computedRotation;f(r,e[0],e[1],e[2],e[4],e[5],e[6],e[8],e[9],e[10]),a(r,r),this.rotation.set(t,r[0],r[1],r[2],r[3]);var n=this.computedMatrix;h(n,e);var i=n[15];if(Math.abs(i)>1e-6){var o=n[12]/i,s=n[13]/i,l=n[14]/i;this.recalcMatrix(t);var u=Math.exp(this.computedRadius[0]);this.center.set(t,o-n[2]*u,s-n[6]*u,l-n[10]*u),this.radius.idle(t)}else this.center.idle(t),this.radius.idle(t)},d.setDistance=function(t,e){e>0&&this.radius.set(t,Math.log(e))},d.setDistanceLimits=function(t,e){t=t>0?Math.log(t):-1/0,e=e>0?Math.log(e):1/0,e=Math.max(e,t),this.radius.bounds[0][0]=t,this.radius.bounds[1][0]=e},d.getDistanceLimits=function(t){var e=this.radius.bounds;return t?(t[0]=Math.exp(e[0][0]),t[1]=Math.exp(e[1][0]),t):[Math.exp(e[0][0]),Math.exp(e[1][0])]},d.toJSON=function(){return this.recalcMatrix(this.lastT()),{center:this.computedCenter.slice(),rotation:this.computedRotation.slice(),distance:Math.log(this.computedRadius[0]),zoomMin:this.radius.bounds[0][0],zoomMax:this.radius.bounds[1][0]}},d.fromJSON=function(t){var e=this.lastT(),r=t.center;r&&this.center.set(e,r[0],r[1],r[2]);var n=t.rotation;n&&this.rotation.set(e,n[0],n[1],n[2],n[3]);var i=t.distance;i&&i>0&&this.radius.set(e,Math.log(i)),this.setDistanceLimits(t.zoomMin,t.zoomMax)}},{\"./lib/quatFromFrame\":471,\"filtered-vector\":132,\"gl-mat4/fromQuat\":177,\"gl-mat4/invert\":180,\"gl-mat4/lookAt\":181}],473:[function(t,e,r){\"use strict\";var n=t(\"repeat-string\");e.exports=function(t,e,r){return r=void 0!==r?r+\"\":\" \",n(r,e)+t}},{\"repeat-string\":499}],474:[function(t,e,r){e.exports=function(t,e){e||(e=[0,\"\"]),t=String(t);var r=parseFloat(t,10);return e[0]=r,e[1]=t.match(/[\\d.\\-\\+]*\\s*(.*)/)[1]||\"\",e}},{}],475:[function(t,e,r){(function(t){function e(t,e){for(var r=0,n=t.length-1;n>=0;n--){var i=t[n];\".\"===i?t.splice(n,1):\"..\"===i?(t.splice(n,1),r++):r&&(t.splice(n,1),r--)}if(e)for(;r--;r)t.unshift(\"..\");return t}function n(t,e){if(t.filter)return t.filter(e);for(var r=[],n=0;n<t.length;n++)e(t[n],n,t)&&r.push(t[n]);return r}var i=/^(\\/?|)([\\s\\S]*?)((?:\\.{1,2}|[^\\/]+?|)(\\.[^.\\/]*|))(?:[\\/]*)$/,a=function(t){return i.exec(t).slice(1)};r.resolve=function(){for(var r=\"\",i=!1,a=arguments.length-1;a>=-1&&!i;a--){var o=a>=0?arguments[a]:t.cwd();if(\"string\"!=typeof o)throw new TypeError(\"Arguments to path.resolve must be strings\");o&&(r=o+\"/\"+r,i=\"/\"===o.charAt(0))}return r=e(n(r.split(\"/\"),function(t){return!!t}),!i).join(\"/\"),(i?\"/\":\"\")+r||\".\"},r.normalize=function(t){var i=r.isAbsolute(t),a=\"/\"===o(t,-1);return t=e(n(t.split(\"/\"),function(t){return!!t}),!i).join(\"/\"),t||i||(t=\".\"),t&&a&&(t+=\"/\"),(i?\"/\":\"\")+t},r.isAbsolute=function(t){return\"/\"===t.charAt(0)},r.join=function(){var t=Array.prototype.slice.call(arguments,0);return r.normalize(n(t,function(t,e){if(\"string\"!=typeof t)throw new TypeError(\"Arguments to path.join must be strings\");return t}).join(\"/\"))},r.relative=function(t,e){function n(t){for(var e=0;e<t.length&&\"\"===t[e];e++);for(var r=t.length-1;r>=0&&\"\"===t[r];r--);return e>r?[]:t.slice(e,r-e+1)}t=r.resolve(t).substr(1),e=r.resolve(e).substr(1);for(var i=n(t.split(\"/\")),a=n(e.split(\"/\")),o=Math.min(i.length,a.length),s=o,l=0;l<o;l++)if(i[l]!==a[l]){s=l;break}for(var u=[],l=s;l<i.length;l++)u.push(\"..\");return u=u.concat(a.slice(s)),u.join(\"/\")},r.sep=\"/\",r.delimiter=\":\",r.dirname=function(t){var e=a(t),r=e[0],n=e[1];return r||n?(n&&(n=n.substr(0,n.length-1)),r+n):\".\"},r.basename=function(t,e){var r=a(t)[2];return e&&r.substr(-1*e.length)===e&&(r=r.substr(0,r.length-e.length)),r},r.extname=function(t){return a(t)[3]};var o=\"b\"===\"ab\".substr(-1)?function(t,e,r){return t.substr(e,r)}:function(t,e,r){return e<0&&(e=t.length+e),t.substr(e,r)}}).call(this,t(\"_process\"))},{_process:486}],476:[function(t,e,r){\"use strict\";function n(t){var e;t&&t.length&&(e=t,t=e.length);var r=new Uint8Array(t||0);return e&&r.set(e),r.readUInt32LE=a.readUInt32LE,r.writeUInt32LE=a.writeUInt32LE,r.readInt32LE=a.readInt32LE,r.writeInt32LE=a.writeInt32LE,r.readFloatLE=a.readFloatLE,r.writeFloatLE=a.writeFloatLE,r.readDoubleLE=a.readDoubleLE,r.writeDoubleLE=a.writeDoubleLE,r.toString=a.toString,r.write=a.write,r.slice=a.slice,r.copy=a.copy,r._isBuffer=!0,r}function i(t){for(var e,r,n=t.length,i=[],a=0;a<n;a++){if((e=t.charCodeAt(a))>55295&&e<57344){if(!r){e>56319||a+1===n?i.push(239,191,189):r=e;continue}if(e<56320){i.push(239,191,189),r=e;continue}e=r-55296<<10|e-56320|65536,r=null}else r&&(i.push(239,191,189),r=null);e<128?i.push(e):e<2048?i.push(e>>6|192,63&e|128):e<65536?i.push(e>>12|224,e>>6&63|128,63&e|128):i.push(e>>18|240,e>>12&63|128,e>>6&63|128,63&e|128)}return i}e.exports=n;var a,o,s,l=t(\"ieee754\");a={readUInt32LE:function(t){return(this[t]|this[t+1]<<8|this[t+2]<<16)+16777216*this[t+3]},writeUInt32LE:function(t,e){this[e]=t,this[e+1]=t>>>8,this[e+2]=t>>>16,this[e+3]=t>>>24},readInt32LE:function(t){return(this[t]|this[t+1]<<8|this[t+2]<<16)+(this[t+3]<<24)},readFloatLE:function(t){return l.read(this,t,!0,23,4)},readDoubleLE:function(t){return l.read(this,t,!0,52,8)},writeFloatLE:function(t,e){return l.write(this,t,e,!0,23,4)},writeDoubleLE:function(t,e){return l.write(this,t,e,!0,52,8)},toString:function(t,e,r){var n=\"\",i=\"\";e=e||0,r=Math.min(this.length,r||this.length);for(var a=e;a<r;a++){var o=this[a];o<=127?(n+=decodeURIComponent(i)+String.fromCharCode(o),i=\"\"):i+=\"%\"+o.toString(16)}return n+=decodeURIComponent(i)},write:function(t,e){for(var r=t===o?s:i(t),n=0;n<r.length;n++)this[e+n]=r[n]},slice:function(t,e){return this.subarray(t,e)},copy:function(t,e){e=e||0;for(var r=0;r<this.length;r++)t[e+r]=this[r]}},a.writeInt32LE=a.writeUInt32LE,n.byteLength=function(t){return o=t,s=i(t),s.length},n.isBuffer=function(t){return!(!t||!t._isBuffer)}},{ieee754:288}],477:[function(t,e,r){(function(r){\"use strict\";function n(t){this.buf=v.isBuffer(t)?t:new v(t||0),this.pos=0,this.length=this.buf.length}function i(t,e){var r,n=e.buf;if(r=n[e.pos++],t+=268435456*(127&r),r<128)return t;if(r=n[e.pos++],t+=34359738368*(127&r),r<128)return t;if(r=n[e.pos++],t+=4398046511104*(127&r),r<128)return t;if(r=n[e.pos++],t+=562949953421312*(127&r),r<128)return t;if(r=n[e.pos++],t+=72057594037927940*(127&r),r<128)return t;if(r=n[e.pos++],t+=0x8000000000000000*(127&r),r<128)return t;throw new Error(\"Expected varint not more than 10 bytes\")}function a(t,e){e.realloc(10);for(var r=e.pos+10;t>=1;){if(e.pos>=r)throw new Error(\"Given varint doesn't fit into 10 bytes\");var n=255&t;e.buf[e.pos++]=n|(t>=128?128:0),t/=128}}function o(t,e,r){var n=e<=16383?1:e<=2097151?2:e<=268435455?3:Math.ceil(Math.log(e)/(7*Math.LN2));r.realloc(n);for(var i=r.pos-1;i>=t;i--)r.buf[i+n]=r.buf[i]}function s(t,e){for(var r=0;r<t.length;r++)e.writeVarint(t[r])}function l(t,e){for(var r=0;r<t.length;r++)e.writeSVarint(t[r])}function u(t,e){for(var r=0;r<t.length;r++)e.writeFloat(t[r])}function c(t,e){for(var r=0;r<t.length;r++)e.writeDouble(t[r])}function h(t,e){for(var r=0;r<t.length;r++)e.writeBoolean(t[r])}function f(t,e){for(var r=0;r<t.length;r++)e.writeFixed32(t[r])}function d(t,e){for(var r=0;r<t.length;r++)e.writeSFixed32(t[r])}function p(t,e){for(var r=0;r<t.length;r++)e.writeFixed64(t[r])}function m(t,e){for(var r=0;r<t.length;r++)e.writeSFixed64(t[r])}e.exports=n;var v=r.Buffer||t(\"./buffer\");n.Varint=0,n.Fixed64=1,n.Bytes=2,n.Fixed32=5;var g=Math.pow(2,63);n.prototype={destroy:function(){this.buf=null},readFields:function(t,e,r){for(r=r||this.length;this.pos<r;){var n=this.readVarint(),i=n>>3,a=this.pos;t(i,e,this),this.pos===a&&this.skip(n)}return e},readMessage:function(t,e){return this.readFields(t,e,this.readVarint()+this.pos)},readFixed32:function(){var t=this.buf.readUInt32LE(this.pos);return this.pos+=4,t},readSFixed32:function(){var t=this.buf.readInt32LE(this.pos);return this.pos+=4,t},readFixed64:function(){var t=this.buf.readUInt32LE(this.pos)+4294967296*this.buf.readUInt32LE(this.pos+4);return this.pos+=8,t},readSFixed64:function(){var t=this.buf.readUInt32LE(this.pos)+4294967296*this.buf.readInt32LE(this.pos+4);return this.pos+=8,t},readFloat:function(){var t=this.buf.readFloatLE(this.pos);return this.pos+=4,t},readDouble:function(){var t=this.buf.readDoubleLE(this.pos);return this.pos+=8,t},readVarint:function(){var t,e,r=this.buf;return e=r[this.pos++],t=127&e,e<128?t:(e=r[this.pos++],t|=(127&e)<<7,e<128?t:(e=r[this.pos++],t|=(127&e)<<14,e<128?t:(e=r[this.pos++],t|=(127&e)<<21,e<128?t:i(t,this))))},readVarint64:function(){var t=this.pos,e=this.readVarint();if(e<g)return e;for(var r=this.pos-2;255===this.buf[r];)r--;r<t&&(r=t),e=0;for(var n=0;n<r-t+1;n++){var i=127&~this.buf[t+n];e+=n<4?i<<7*n:i*Math.pow(2,7*n)}return-e-1},readSVarint:function(){var t=this.readVarint();return t%2==1?(t+1)/-2:t/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var t=this.readVarint()+this.pos,e=this.buf.toString(\"utf8\",this.pos,t);return this.pos=t,e},readBytes:function(){var t=this.readVarint()+this.pos,e=this.buf.slice(this.pos,t);return this.pos=t,e},readPackedVarint:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readVarint());return e},readPackedSVarint:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSVarint());return e},readPackedBoolean:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readBoolean());return e},readPackedFloat:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFloat());return e},readPackedDouble:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readDouble());return e},readPackedFixed32:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFixed32());return e},readPackedSFixed32:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSFixed32());return e},readPackedFixed64:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readFixed64());return e},readPackedSFixed64:function(){for(var t=this.readVarint()+this.pos,e=[];this.pos<t;)e.push(this.readSFixed64());return e},skip:function(t){var e=7&t;if(e===n.Varint)for(;this.buf[this.pos++]>127;);else if(e===n.Bytes)this.pos=this.readVarint()+this.pos;else if(e===n.Fixed32)this.pos+=4;else{if(e!==n.Fixed64)throw new Error(\"Unimplemented type: \"+e);this.pos+=8}},writeTag:function(t,e){this.writeVarint(t<<3|e)},realloc:function(t){for(var e=this.length||16;e<this.pos+t;)e*=2;if(e!==this.length){var r=new v(e);this.buf.copy(r),this.buf=r,this.length=e}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.slice(0,this.length)},writeFixed32:function(t){this.realloc(4),this.buf.writeUInt32LE(t,this.pos),this.pos+=4},writeSFixed32:function(t){this.realloc(4),this.buf.writeInt32LE(t,this.pos),this.pos+=4},writeFixed64:function(t){this.realloc(8),this.buf.writeInt32LE(-1&t,this.pos),this.buf.writeUInt32LE(Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8},writeSFixed64:function(t){this.realloc(8),this.buf.writeInt32LE(-1&t,this.pos),this.buf.writeInt32LE(Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8},writeVarint:function(t){if((t=+t)>268435455)return void a(t,this);this.realloc(4),this.buf[this.pos++]=127&t|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=t>>>7&127)))},writeSVarint:function(t){this.writeVarint(t<0?2*-t-1:2*t)},writeBoolean:function(t){this.writeVarint(Boolean(t))},writeString:function(t){t=String(t);var e=v.byteLength(t);this.writeVarint(e),this.realloc(e),this.buf.write(t,this.pos),this.pos+=e},writeFloat:function(t){this.realloc(4),this.buf.writeFloatLE(t,this.pos),this.pos+=4},writeDouble:function(t){this.realloc(8),this.buf.writeDoubleLE(t,this.pos),this.pos+=8},writeBytes:function(t){var e=t.length;this.writeVarint(e),this.realloc(e);for(var r=0;r<e;r++)this.buf[this.pos++]=t[r]},writeRawMessage:function(t,e){this.pos++;var r=this.pos;t(e,this);var n=this.pos-r;n>=128&&o(r,n,this),this.pos=r-1,this.writeVarint(n),this.pos+=n},writeMessage:function(t,e,r){this.writeTag(t,n.Bytes),this.writeRawMessage(e,r)},writePackedVarint:function(t,e){this.writeMessage(t,s,e)},writePackedSVarint:function(t,e){this.writeMessage(t,l,e)},writePackedBoolean:function(t,e){this.writeMessage(t,h,e)},writePackedFloat:function(t,e){this.writeMessage(t,u,e)},writePackedDouble:function(t,e){this.writeMessage(t,c,e)},writePackedFixed32:function(t,e){this.writeMessage(t,f,e)},writePackedSFixed32:function(t,e){this.writeMessage(t,d,e)},writePackedFixed64:function(t,e){this.writeMessage(t,p,e)},writePackedSFixed64:function(t,e){this.writeMessage(t,m,e)},writeBytesField:function(t,e){this.writeTag(t,n.Bytes),this.writeBytes(e)},writeFixed32Field:function(t,e){this.writeTag(t,n.Fixed32),this.writeFixed32(e)},writeSFixed32Field:function(t,e){this.writeTag(t,n.Fixed32),this.writeSFixed32(e)},writeFixed64Field:function(t,e){this.writeTag(t,n.Fixed64),this.writeFixed64(e)},writeSFixed64Field:function(t,e){this.writeTag(t,n.Fixed64),this.writeSFixed64(e)},writeVarintField:function(t,e){this.writeTag(t,n.Varint),this.writeVarint(e)},writeSVarintField:function(t,e){this.writeTag(t,n.Varint),this.writeSVarint(e)},writeStringField:function(t,e){this.writeTag(t,n.Bytes),this.writeString(e)},writeFloatField:function(t,e){this.writeTag(t,n.Fixed32),this.writeFloat(e)},writeDoubleField:function(t,e){this.writeTag(t,n.Fixed64),this.writeDouble(e)},writeBooleanField:function(t,e){this.writeVarintField(t,Boolean(e))}}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"./buffer\":476}],478:[function(t,e,r){\"use strict\";function n(t){var e=t.length;if(e<i){for(var r=1,n=0;n<e;++n)for(var o=0;o<n;++o)if(t[n]<t[o])r=-r;else if(t[n]===t[o])return 0;return r}for(var s=a.mallocUint8(e),n=0;n<e;++n)s[n]=0;for(var r=1,n=0;n<e;++n)if(!s[n]){var l=1;s[n]=1;for(var o=t[n];o!==n;o=t[o]){if(s[o])return a.freeUint8(s),0;l+=1,s[o]=1}1&l||(r=-r)}return a.freeUint8(s),r}e.exports=n;var i=32,a=t(\"typedarray-pool\")},{\"typedarray-pool\":540}],479:[function(t,e,r){\"use strict\";function n(t){var e=t.length;switch(e){case 0:case 1:return 0;case 2:return t[1]}var r,n,i,s=a.mallocUint32(e),l=a.mallocUint32(e),u=0;for(o(t,l),i=0;i<e;++i)s[i]=t[i];for(i=e-1;i>0;--i)n=l[i],r=s[i],s[i]=s[n],s[n]=r,l[i]=l[r],l[r]=n,u=(u+r)*i;return a.freeUint32(l),a.freeUint32(s),u}function i(t,e,r){switch(t){case 0:return r||[];case 1:return r?(r[0]=0,r):[0];case 2:return r?(e?(r[0]=0,r[1]=1):(r[0]=1,r[1]=0),r):e?[0,1]:[1,0]}r=r||new Array(t);var n,i,a,o=1;for(r[0]=0,a=1;a<t;++a)r[a]=a,o=o*a|0;for(a=t-1;a>0;--a)n=e/o|0,e=e-n*o|0,o=o/a|0,i=0|r[a],r[a]=0|r[n],r[n]=0|i;return r}var a=t(\"typedarray-pool\"),o=t(\"invert-permutation\");r.rank=n,r.unrank=i},{\"invert-permutation\":291,\"typedarray-pool\":540}],480:[function(t,e,r){\"use strict\";function n(t,e){function r(t,e){var r=s[e][t[e]];r.splice(r.indexOf(t),1)}function n(t,n,a){for(var o,l,u,c=0;c<2;++c)if(s[c][n].length>0){o=s[c][n][0],u=c;break}l=o[1^u];for(var h=0;h<2;++h)for(var f=s[h][n],d=0;d<f.length;++d){var p=f[d],m=p[1^h],v=i(e[t],e[n],e[l],e[m]);v>0&&(o=p,l=m,u=h)}return a?l:(o&&r(o,u),l)}for(var a=0|e.length,o=t.length,s=[new Array(a),new Array(a)],l=0;l<a;++l)s[0][l]=[],s[1][l]=[];for(var l=0;l<o;++l){var u=t[l];s[0][u[0]].push(u),s[1][u[1]].push(u)}for(var c=[],l=0;l<a;++l)s[0][l].length+s[1][l].length===0&&c.push([l]);for(var l=0;l<a;++l)for(var h=0;h<2;++h){for(var f=[];s[h][l].length>0;){var d=(s[0][l].length,function(t,a){var o=s[a][t][0],l=[t];r(o,a);for(var u=o[1^a];;){for(;u!==t;)l.push(u),u=n(l[l.length-2],u,!1);if(s[0][t].length+s[1][t].length===0)break;var c=l[l.length-1],h=t,f=l[1],d=n(c,h,!0);if(i(e[c],e[h],e[f],e[d])<0)break;l.push(t),u=n(c,h)}return l}(l,h));!function(t,e){return e[1]===e[e.length-1]}(f,d)?(f.length>0&&c.push(f),f=d):f.push.apply(f,d)}f.length>0&&c.push(f)}return c}e.exports=n;var i=t(\"compare-angle\")},{\"compare-angle\":99}],481:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(t,e.length),n=new Array(e.length),a=new Array(e.length),o=[],s=0;s<e.length;++s){var l=r[s].length;a[s]=l,n[s]=!0,l<=1&&o.push(s)}for(;o.length>0;){var u=o.pop();n[u]=!1;for(var c=r[u],s=0;s<c.length;++s){var h=c[s];0==--a[h]&&o.push(h)}}for(var f=new Array(e.length),d=[],s=0;s<e.length;++s)if(n[s]){var u=d.length;f[s]=u,d.push(e[s])}else f[s]=-1;for(var p=[],s=0;s<t.length;++s){var m=t[s];n[m[0]]&&n[m[1]]&&p.push([f[m[0]],f[m[1]]])}return[p,d]}e.exports=n;var i=t(\"edges-to-adjacency-list\")},{\"edges-to-adjacency-list\":126}],482:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t),n=0;n<t;++n)r[n]=e;return r}function i(t){for(var e=new Array(t),r=0;r<t;++r)e[r]=[];return e}function a(t,e){function r(t){for(var r=t.length,n=[0],i=0;i<r;++i){var a=e[t[i]],o=e[t[(i+1)%r]],s=u(-a[0],a[1]),l=u(-a[0],o[1]),h=u(o[0],a[1]),f=u(o[0],o[1]);n=c(n,c(c(s,l),c(h,f)))}return n[n.length-1]>0}function a(t){for(var e=t.length,r=0;r<e;++r)if(!P[t[r]])return!1;return!0}var d=f(t,e);t=d[0],e=d[1];for(var p=e.length,m=(t.length,o(t,e.length)),v=0;v<p;++v)if(m[v].length%2==1)throw new Error(\"planar-graph-to-polyline: graph must be manifold\");var g=s(t,e);g=g.filter(r);for(var y=g.length,b=new Array(y),x=new Array(y),v=0;v<y;++v){b[v]=v;var _=new Array(y),w=g[v].map(function(t){return e[t]}),M=l([w]),k=0;t:for(var A=0;A<y;++A)if(_[A]=0,v!==A){for(var T=g[A],S=T.length,E=0;E<S;++E){var L=M(e[T[E]]);if(0!==L){L<0&&(_[A]=1,k+=1);continue t}}_[A]=1,k+=1}x[v]=[k,v,_]}x.sort(function(t,e){return e[0]-t[0]});for(var v=0;v<y;++v)for(var _=x[v],C=_[1],z=_[2],A=0;A<y;++A)z[A]&&(b[A]=C);for(var I=i(y),v=0;v<y;++v)I[v].push(b[v]),I[b[v]].push(v);for(var D={},P=n(p,!1),v=0;v<y;++v)for(var T=g[v],S=T.length,A=0;A<S;++A){var O=T[A],R=T[(A+1)%S],F=Math.min(O,R)+\":\"+Math.max(O,R);if(F in D){var j=D[F];I[j].push(v),I[v].push(j),P[O]=P[R]=!0}else D[F]=v}for(var N=[],B=n(y,-1),v=0;v<y;++v)b[v]!==v||a(g[v])?B[v]=-1:(N.push(v),B[v]=0);for(var d=[];N.length>0;){var U=N.pop(),V=I[U];h(V,function(t,e){return t-e});var H,q=V.length,G=B[U];if(0===G){var T=g[U];H=[T]}for(var v=0;v<q;++v){var Y=V[v];if(!(B[Y]>=0)&&(B[Y]=1^G,N.push(Y),0===G)){var T=g[Y];a(T)||(T.reverse(),H.push(T))}}0===G&&d.push(H)}return d}e.exports=a\n",
       ";var o=t(\"edges-to-adjacency-list\"),s=t(\"planar-dual\"),l=t(\"point-in-big-polygon\"),u=t(\"two-product\"),c=t(\"robust-sum\"),h=t(\"uniq\"),f=t(\"./lib/trim-leaves\")},{\"./lib/trim-leaves\":481,\"edges-to-adjacency-list\":126,\"planar-dual\":480,\"point-in-big-polygon\":484,\"robust-sum\":512,\"two-product\":538,uniq:542}],483:[function(t,e,r){\"use strict\";function n(t,e){this.x=t,this.y=e}e.exports=n,n.prototype={clone:function(){return new n(this.x,this.y)},add:function(t){return this.clone()._add(t)},sub:function(t){return this.clone()._sub(t)},mult:function(t){return this.clone()._mult(t)},div:function(t){return this.clone()._div(t)},rotate:function(t){return this.clone()._rotate(t)},matMult:function(t){return this.clone()._matMult(t)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(t){return this.x===t.x&&this.y===t.y},dist:function(t){return Math.sqrt(this.distSqr(t))},distSqr:function(t){var e=t.x-this.x,r=t.y-this.y;return e*e+r*r},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(t){return Math.atan2(this.y-t.y,this.x-t.x)},angleWith:function(t){return this.angleWithSep(t.x,t.y)},angleWithSep:function(t,e){return Math.atan2(this.x*e-this.y*t,this.x*t+this.y*e)},_matMult:function(t){var e=t[0]*this.x+t[1]*this.y,r=t[2]*this.x+t[3]*this.y;return this.x=e,this.y=r,this},_add:function(t){return this.x+=t.x,this.y+=t.y,this},_sub:function(t){return this.x-=t.x,this.y-=t.y,this},_mult:function(t){return this.x*=t,this.y*=t,this},_div:function(t){return this.x/=t,this.y/=t,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var t=this.y;return this.y=this.x,this.x=-t,this},_rotate:function(t){var e=Math.cos(t),r=Math.sin(t),n=e*this.x-r*this.y,i=r*this.x+e*this.y;return this.x=n,this.y=i,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},n.convert=function(t){return t instanceof n?t:Array.isArray(t)?new n(t[0],t[1]):t}},{}],484:[function(t,e,r){function n(){return!0}function i(t){return function(e,r){var i=t[e];return!!i&&!!i.queryPoint(r,n)}}function a(t){for(var e={},r=0;r<t.length;++r){var n=t[r],a=n[0][0],o=n[0][1],s=n[1][1],l=[Math.min(o,s),Math.max(o,s)];a in e?e[a].push(l):e[a]=[l]}for(var u={},c=Object.keys(e),r=0;r<c.length;++r){var h=e[c[r]];u[c[r]]=d(h)}return i(u)}function o(t,e){return function(r){var n=p.le(e,r[0]);if(n<0)return 1;var i=t[n];if(!i){if(!(n>0&&e[n]===r[0]))return 1;i=t[n-1]}for(var a=1;i;){var o=i.key,s=h(r,o[0],o[1]);if(o[0][0]<o[1][0])if(s<0)i=i.left;else{if(!(s>0))return 0;a=-1,i=i.right}else if(s>0)i=i.left;else{if(!(s<0))return 0;a=1,i=i.right}}return a}}function s(t){return 1}function l(t){return function(e){return t(e[0],e[1])?0:1}}function u(t,e){return function(r){return t(r[0],r[1])?0:e(r)}}function c(t){for(var e=t.length,r=[],n=[],i=0;i<e;++i)for(var c=t[i],h=c.length,d=h-1,p=0;p<h;d=p++){var m=c[d],v=c[p];m[0]===v[0]?n.push([m,v]):r.push([m,v])}if(0===r.length)return 0===n.length?s:l(a(n));var g=f(r),y=o(g.slabs,g.coordinates);return 0===n.length?y:u(a(n),y)}e.exports=c;var h=t(\"robust-orientation\")[3],f=t(\"slab-decomposition\"),d=t(\"interval-tree-1d\"),p=t(\"binary-search-bounds\")},{\"binary-search-bounds\":65,\"interval-tree-1d\":290,\"robust-orientation\":507,\"slab-decomposition\":524}],485:[function(t,e,r){\"use strict\";function n(t,e,r,n,s){i.length<n.length&&(i=new Float64Array(n.length),a=new Float64Array(n.length),o=new Float64Array(n.length));for(var l=0;l<n.length;++l)i[l]=t[l]-n[l],a[l]=e[l]-t[l],o[l]=r[l]-t[l];for(var u=0,c=0,h=0,f=0,d=0,p=0,l=0;l<n.length;++l){var m=a[l],v=o[l],g=i[l];u+=m*m,c+=m*v,h+=v*v,f+=g*m,d+=g*v,p+=g*g}var y,b=Math.abs(u*h-c*c),x=c*d-h*f,_=c*f-u*d;if(x+_<=b)if(x<0)_<0&&f<0?(_=0,-f>=u?(x=1,y=u+2*f+p):(x=-f/u,y=f*x+p)):(x=0,d>=0?(_=0,y=p):-d>=h?(_=1,y=h+2*d+p):(_=-d/h,y=d*_+p));else if(_<0)_=0,f>=0?(x=0,y=p):-f>=u?(x=1,y=u+2*f+p):(x=-f/u,y=f*x+p);else{var w=1/b;x*=w,_*=w,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p}else{var M,k,A,T;x<0?(M=c+f,k=h+d,k>M?(A=k-M,T=u-2*c+h,A>=T?(x=1,_=0,y=u+2*f+p):(x=A/T,_=1-x,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)):(x=0,k<=0?(_=1,y=h+2*d+p):d>=0?(_=0,y=p):(_=-d/h,y=d*_+p))):_<0?(M=c+d,k=u+f,k>M?(A=k-M,T=u-2*c+h,A>=T?(_=1,x=0,y=h+2*d+p):(_=A/T,x=1-_,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)):(_=0,k<=0?(x=1,y=u+2*f+p):f>=0?(x=0,y=p):(x=-f/u,y=f*x+p))):(A=h+d-c-f,A<=0?(x=0,_=1,y=h+2*d+p):(T=u-2*c+h,A>=T?(x=1,_=0,y=u+2*f+p):(x=A/T,_=1-x,y=x*(u*x+c*_+2*f)+_*(c*x+h*_+2*d)+p)))}for(var S=1-x-_,l=0;l<n.length;++l)s[l]=S*t[l]+x*e[l]+_*r[l];return y<0?0:y}var i=new Float64Array(4),a=new Float64Array(4),o=new Float64Array(4);e.exports=n},{}],486:[function(t,e,r){function n(){throw new Error(\"setTimeout has not been defined\")}function i(){throw new Error(\"clearTimeout has not been defined\")}function a(t){if(h===setTimeout)return setTimeout(t,0);if((h===n||!h)&&setTimeout)return h=setTimeout,setTimeout(t,0);try{return h(t,0)}catch(e){try{return h.call(null,t,0)}catch(e){return h.call(this,t,0)}}}function o(t){if(f===clearTimeout)return clearTimeout(t);if((f===i||!f)&&clearTimeout)return f=clearTimeout,clearTimeout(t);try{return f(t)}catch(e){try{return f.call(null,t)}catch(e){return f.call(this,t)}}}function s(){v&&p&&(v=!1,p.length?m=p.concat(m):g=-1,m.length&&l())}function l(){if(!v){var t=a(s);v=!0;for(var e=m.length;e;){for(p=m,m=[];++g<e;)p&&p[g].run();g=-1,e=m.length}p=null,v=!1,o(t)}}function u(t,e){this.fun=t,this.array=e}function c(){}var h,f,d=e.exports={};!function(){try{h=\"function\"==typeof setTimeout?setTimeout:n}catch(t){h=n}try{f=\"function\"==typeof clearTimeout?clearTimeout:i}catch(t){f=i}}();var p,m=[],v=!1,g=-1;d.nextTick=function(t){var e=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)e[r-1]=arguments[r];m.push(new u(t,e)),1!==m.length||v||a(l)},u.prototype.run=function(){this.fun.apply(null,this.array)},d.title=\"browser\",d.browser=!0,d.env={},d.argv=[],d.version=\"\",d.versions={},d.on=c,d.addListener=c,d.once=c,d.off=c,d.removeListener=c,d.removeAllListeners=c,d.emit=c,d.prependListener=c,d.prependOnceListener=c,d.listeners=function(t){return[]},d.binding=function(t){throw new Error(\"process.binding is not supported\")},d.cwd=function(){return\"/\"},d.chdir=function(t){throw new Error(\"process.chdir is not supported\")},d.umask=function(){return 0}},{}],487:[function(e,r,n){(function(e){!function(i){function a(t){throw new RangeError(P[t])}function o(t,e){for(var r=t.length,n=[];r--;)n[r]=e(t[r]);return n}function s(t,e){var r=t.split(\"@\"),n=\"\";return r.length>1&&(n=r[0]+\"@\",t=r[1]),t=t.replace(D,\".\"),n+o(t.split(\".\"),e).join(\".\")}function l(t){for(var e,r,n=[],i=0,a=t.length;i<a;)e=t.charCodeAt(i++),e>=55296&&e<=56319&&i<a?(r=t.charCodeAt(i++),56320==(64512&r)?n.push(((1023&e)<<10)+(1023&r)+65536):(n.push(e),i--)):n.push(e);return n}function u(t){return o(t,function(t){var e=\"\";return t>65535&&(t-=65536,e+=F(t>>>10&1023|55296),t=56320|1023&t),e+=F(t)}).join(\"\")}function c(t){return t-48<10?t-22:t-65<26?t-65:t-97<26?t-97:M}function h(t,e){return t+22+75*(t<26)-((0!=e)<<5)}function f(t,e,r){var n=0;for(t=r?R(t/S):t>>1,t+=R(t/e);t>O*A>>1;n+=M)t=R(t/O);return R(n+(O+1)*t/(t+T))}function d(t){var e,r,n,i,o,s,l,h,d,p,m=[],v=t.length,g=0,y=L,b=E;for(r=t.lastIndexOf(C),r<0&&(r=0),n=0;n<r;++n)t.charCodeAt(n)>=128&&a(\"not-basic\"),m.push(t.charCodeAt(n));for(i=r>0?r+1:0;i<v;){for(o=g,s=1,l=M;i>=v&&a(\"invalid-input\"),h=c(t.charCodeAt(i++)),(h>=M||h>R((w-g)/s))&&a(\"overflow\"),g+=h*s,d=l<=b?k:l>=b+A?A:l-b,!(h<d);l+=M)p=M-d,s>R(w/p)&&a(\"overflow\"),s*=p;e=m.length+1,b=f(g-o,e,0==o),R(g/e)>w-y&&a(\"overflow\"),y+=R(g/e),g%=e,m.splice(g++,0,y)}return u(m)}function p(t){var e,r,n,i,o,s,u,c,d,p,m,v,g,y,b,x=[];for(t=l(t),v=t.length,e=L,r=0,o=E,s=0;s<v;++s)(m=t[s])<128&&x.push(F(m));for(n=i=x.length,i&&x.push(C);n<v;){for(u=w,s=0;s<v;++s)(m=t[s])>=e&&m<u&&(u=m);for(g=n+1,u-e>R((w-r)/g)&&a(\"overflow\"),r+=(u-e)*g,e=u,s=0;s<v;++s)if(m=t[s],m<e&&++r>w&&a(\"overflow\"),m==e){for(c=r,d=M;p=d<=o?k:d>=o+A?A:d-o,!(c<p);d+=M)b=c-p,y=M-p,x.push(F(h(p+b%y,0))),c=R(b/y);x.push(F(h(c,0))),o=f(r,g,n==i),r=0,++n}++r,++e}return x.join(\"\")}function m(t){return s(t,function(t){return z.test(t)?d(t.slice(4).toLowerCase()):t})}function v(t){return s(t,function(t){return I.test(t)?\"xn--\"+p(t):t})}var g=\"object\"==typeof n&&n&&!n.nodeType&&n,y=\"object\"==typeof r&&r&&!r.nodeType&&r,b=\"object\"==typeof e&&e;b.global!==b&&b.window!==b&&b.self!==b||(i=b);var x,_,w=2147483647,M=36,k=1,A=26,T=38,S=700,E=72,L=128,C=\"-\",z=/^xn--/,I=/[^\\x20-\\x7E]/,D=/[\\x2E\\u3002\\uFF0E\\uFF61]/g,P={overflow:\"Overflow: input needs wider integers to process\",\"not-basic\":\"Illegal input >= 0x80 (not a basic code point)\",\"invalid-input\":\"Invalid input\"},O=M-k,R=Math.floor,F=String.fromCharCode;if(x={version:\"1.4.1\",ucs2:{decode:l,encode:u},decode:d,encode:p,toASCII:v,toUnicode:m},\"function\"==typeof t&&\"object\"==typeof t.amd&&t.amd)t(\"punycode\",function(){return x});else if(g&&y)if(r.exports==g)y.exports=x;else for(_ in x)x.hasOwnProperty(_)&&(g[_]=x[_]);else i.punycode=x}(this)}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{}],488:[function(t,e,r){e.exports=t(\"gl-quat/slerp\")},{\"gl-quat/slerp\":230}],489:[function(t,e,r){\"use strict\";function n(t,e){return Object.prototype.hasOwnProperty.call(t,e)}e.exports=function(t,e,r,a){e=e||\"&\",r=r||\"=\";var o={};if(\"string\"!=typeof t||0===t.length)return o;var s=/\\+/g;t=t.split(e);var l=1e3;a&&\"number\"==typeof a.maxKeys&&(l=a.maxKeys);var u=t.length;l>0&&u>l&&(u=l);for(var c=0;c<u;++c){var h,f,d,p,m=t[c].replace(s,\"%20\"),v=m.indexOf(r);v>=0?(h=m.substr(0,v),f=m.substr(v+1)):(h=m,f=\"\"),d=decodeURIComponent(h),p=decodeURIComponent(f),n(o,d)?i(o[d])?o[d].push(p):o[d]=[o[d],p]:o[d]=p}return o};var i=Array.isArray||function(t){return\"[object Array]\"===Object.prototype.toString.call(t)}},{}],490:[function(t,e,r){\"use strict\";function n(t,e){if(t.map)return t.map(e);for(var r=[],n=0;n<t.length;n++)r.push(e(t[n],n));return r}var i=function(t){switch(typeof t){case\"string\":return t;case\"boolean\":return t?\"true\":\"false\";case\"number\":return isFinite(t)?t:\"\";default:return\"\"}};e.exports=function(t,e,r,s){return e=e||\"&\",r=r||\"=\",null===t&&(t=void 0),\"object\"==typeof t?n(o(t),function(o){var s=encodeURIComponent(i(o))+r;return a(t[o])?n(t[o],function(t){return s+encodeURIComponent(i(t))}).join(e):s+encodeURIComponent(i(t[o]))}).join(e):s?encodeURIComponent(i(s))+r+encodeURIComponent(i(t)):\"\"};var a=Array.isArray||function(t){return\"[object Array]\"===Object.prototype.toString.call(t)},o=Object.keys||function(t){var e=[];for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.push(r);return e}},{}],491:[function(t,e,r){\"use strict\";r.decode=r.parse=t(\"./decode\"),r.encode=r.stringify=t(\"./encode\")},{\"./decode\":489,\"./encode\":490}],492:[function(t,e,r){\"use strict\";function n(t,e,r,o,s){for(r=r||0,o=o||t.length-1,s=s||a;o>r;){if(o-r>600){var l=o-r+1,u=e-r+1,c=Math.log(l),h=.5*Math.exp(2*c/3),f=.5*Math.sqrt(c*h*(l-h)/l)*(u-l/2<0?-1:1);n(t,e,Math.max(r,Math.floor(e-u*h/l+f)),Math.min(o,Math.floor(e+(l-u)*h/l+f)),s)}var d=t[e],p=r,m=o;for(i(t,r,e),s(t[o],d)>0&&i(t,r,o);p<m;){for(i(t,p,m),p++,m--;s(t[p],d)<0;)p++;for(;s(t[m],d)>0;)m--}0===s(t[r],d)?i(t,r,m):(m++,i(t,m,o)),m<=e&&(r=m+1),e<=m&&(o=m-1)}}function i(t,e,r){var n=t[e];t[e]=t[r],t[r]=n}function a(t,e){return t<e?-1:t>e?1:0}e.exports=n},{}],493:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),a=0;a<r;++a)n[a]=i(t[a],e[a]);return n}var i=t(\"big-rat/add\");e.exports=n},{\"big-rat/add\":49}],494:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(t.length),r=0;r<t.length;++r)e[r]=i(t[r]);return e}e.exports=n;var i=t(\"big-rat\")},{\"big-rat\":52}],495:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(e),n=t.length,o=new Array(n),s=0;s<n;++s)o[s]=a(t[s],r);return o}var i=t(\"big-rat\"),a=t(\"big-rat/mul\");e.exports=n},{\"big-rat\":52,\"big-rat/mul\":61}],496:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t.length,n=new Array(r),a=0;a<r;++a)n[a]=i(t[a],e[a]);return n}var i=t(\"big-rat/sub\");e.exports=n},{\"big-rat/sub\":63}],497:[function(t,e,r){\"use strict\";function n(t){t.sort(a);for(var e=t.length,r=0,n=0;n<e;++n){var s=t[n],l=o(s);if(0!==l){if(r>0){var u=t[r-1];if(0===i(s,u)&&o(u)!==l){r-=1;continue}}t[r++]=s}}return t.length=r,t}var i=t(\"compare-cell\"),a=t(\"compare-oriented-cell\"),o=t(\"cell-orientation\");e.exports=n},{\"cell-orientation\":84,\"compare-cell\":100,\"compare-oriented-cell\":101}],498:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.createREGL=i()}(this,function(){\"use strict\";function t(t){return\"undefined\"!=typeof btoa?btoa(t):\"base64:\"+t}function e(t){var e=new Error(\"(regl) \"+t);throw console.error(e),e}function r(t,r){t||e(r)}function n(t){return t?\": \"+t:\"\"}function i(t,r,i){t in r||e(\"unknown parameter (\"+t+\")\"+n(i)+\". possible values: \"+Object.keys(r).join())}function a(t,r){Qt(t)||e(\"invalid parameter type\"+n(r)+\". must be a typed array\")}function o(t,r,i){typeof t!==r&&e(\"invalid parameter type\"+n(i)+\". expected \"+r+\", got \"+typeof t)}function s(t,r){t>=0&&(0|t)===t||e(\"invalid parameter type, (\"+t+\")\"+n(r)+\". must be a nonnegative integer\")}function l(t,r,i){r.indexOf(t)<0&&e(\"invalid value\"+n(i)+\". must be one of: \"+r)}function u(t){Object.keys(t).forEach(function(t){te.indexOf(t)<0&&e('invalid regl constructor argument \"'+t+'\". must be one of '+te)})}function c(t,e){for(t+=\"\";t.length<e;)t=\" \"+t;return t}function h(){this.name=\"unknown\",this.lines=[],this.index={},this.hasErrors=!1}function f(t,e){this.number=t,this.line=e,this.errors=[]}function d(t,e,r){this.file=t,this.line=e,this.message=r}function p(){var t=new Error,e=(t.stack||t).toString(),r=/compileProcedure.*\\n\\s*at.*\\((.*)\\)/.exec(e);if(r)return r[1];var n=/compileProcedure.*\\n\\s*at\\s+(.*)(\\n|$)/.exec(e);return n?n[1]:\"unknown\"}function m(){var t=new Error,e=(t.stack||t).toString(),r=/at REGLCommand.*\\n\\s+at.*\\((.*)\\)/.exec(e);if(r)return r[1];var n=/at REGLCommand.*\\n\\s+at\\s+(.*)\\n/.exec(e);return n?n[1]:\"unknown\"}function v(e,r){var n=e.split(\"\\n\"),i=1,a=0,o={unknown:new h,0:new h};o.unknown.name=o[0].name=r||p(),o.unknown.lines.push(new f(0,\"\"));for(var s=0;s<n.length;++s){var l=n[s],u=/^\\s*\\#\\s*(\\w+)\\s+(.+)\\s*$/.exec(l);if(u)switch(u[1]){case\"line\":var c=/(\\d+)(\\s+\\d+)?/.exec(u[2]);c&&(i=0|c[1],c[2]&&((a=0|c[2])in o||(o[a]=new h)));break;case\"define\":var d=/SHADER_NAME(_B64)?\\s+(.*)$/.exec(u[2]);d&&(o[a].name=d[1]?t(d[2]):d[2])}o[a].lines.push(new f(i++,l))}return Object.keys(o).forEach(function(t){var e=o[t];e.lines.forEach(function(t){e.index[t.number]=t})}),o}function g(t){var e=[];return t.split(\"\\n\").forEach(function(t){if(!(t.length<5)){var r=/^ERROR\\:\\s+(\\d+)\\:(\\d+)\\:\\s*(.*)$/.exec(t);r?e.push(new d(0|r[1],0|r[2],r[3].trim())):t.length>0&&e.push(new d(\"unknown\",0,t))}}),e}function y(t,e){e.forEach(function(e){var r=t[e.file];if(r){var n=r.index[e.line];if(n)return n.errors.push(e),void(r.hasErrors=!0)}t.unknown.hasErrors=!0,t.unknown.lines[0].errors.push(e)})}function b(t,e,n,i,a){if(!t.getShaderParameter(e,t.COMPILE_STATUS)){var o=t.getShaderInfoLog(e),s=i===t.FRAGMENT_SHADER?\"fragment\":\"vertex\";T(n,\"string\",s+\" shader source must be a string\",a);var l=v(n,a),u=g(o);y(l,u),Object.keys(l).forEach(function(t){function e(t,e){n.push(t),i.push(e||\"\")}var r=l[t];if(r.hasErrors){var n=[\"\"],i=[\"\"];e(\"file number \"+t+\": \"+r.name+\"\\n\",\"color:red;text-decoration:underline;font-weight:bold\"),r.lines.forEach(function(t){if(t.errors.length>0){e(c(t.number,4)+\"|  \",\"background-color:yellow; font-weight:bold\"),e(t.line+\"\\n\",\"color:red; background-color:yellow; font-weight:bold\");var r=0;t.errors.forEach(function(n){var i=n.message,a=/^\\s*\\'(.*)\\'\\s*\\:\\s*(.*)$/.exec(i);if(a){var o=a[1];switch(i=a[2],o){case\"assign\":o=\"=\"}r=Math.max(t.line.indexOf(o,r),0)}else r=0;e(c(\"| \",6)),e(c(\"^^^\",r+3)+\"\\n\",\"font-weight:bold\"),e(c(\"| \",6)),e(i+\"\\n\",\"font-weight:bold\")}),e(c(\"| \",6)+\"\\n\")}else e(c(t.number,4)+\"|  \"),e(t.line+\"\\n\",\"color:red\")}),\"undefined\"!=typeof document?(i[0]=n.join(\"%c\"),console.log.apply(console,i)):console.log(n.join(\"\"))}}),r.raise(\"Error compiling \"+s+\" shader, \"+l[0].name)}}function x(t,e,n,i,a){if(!t.getProgramParameter(e,t.LINK_STATUS)){var o=t.getProgramInfoLog(e),s=v(n,a),l=v(i,a),u='Error linking program with vertex shader, \"'+l[0].name+'\", and fragment shader \"'+s[0].name+'\"';\"undefined\"!=typeof document?console.log(\"%c\"+u+\"\\n%c\"+o,\"color:red;text-decoration:underline;font-weight:bold\",\"color:red\"):console.log(u+\"\\n\"+o),r.raise(u)}}function _(t){t._commandRef=p()}function w(t,e,r,n){function i(t){return t?n.id(t):0}function a(t,e){Object.keys(e).forEach(function(e){t[n.id(e)]=!0})}_(t),t._fragId=i(t.static.frag),t._vertId=i(t.static.vert);var o=t._uniformSet={};a(o,e.static),a(o,e.dynamic);var s=t._attributeSet={};a(s,r.static),a(s,r.dynamic),t._hasCount=\"count\"in t.static||\"count\"in t.dynamic||\"elements\"in t.static||\"elements\"in t.dynamic}function M(t,r){var n=m();e(t+\" in command \"+(r||p())+(\"unknown\"===n?\"\":\" called from \"+n))}function k(t,e,r){t||M(e,r||p())}function A(t,e,r,i){t in e||M(\"unknown parameter (\"+t+\")\"+n(r)+\". possible values: \"+Object.keys(e).join(),i||p())}function T(t,e,r,i){typeof t!==e&&M(\"invalid parameter type\"+n(r)+\". expected \"+e+\", got \"+typeof t,i||p())}function S(t){t()}function E(t,e,r){t.texture?l(t.texture._texture.internalformat,e,\"unsupported texture format for attachment\"):l(t.renderbuffer._renderbuffer.format,r,\"unsupported renderbuffer format for attachment\")}function L(t,e){return t===ue||t===le||t===ce?2:t===he?4:fe[t]*e}function C(t){return!(t&t-1||!t)}function z(t,e,n){var i,a=e.width,o=e.height,s=e.channels;r(a>0&&a<=n.maxTextureSize&&o>0&&o<=n.maxTextureSize,\"invalid texture shape\"),t.wrapS===ee&&t.wrapT===ee||r(C(a)&&C(o),\"incompatible wrap mode for texture, both width and height must be power of 2\"),1===e.mipmask?1!==a&&1!==o&&r(t.minFilter!==ne&&t.minFilter!==ae&&t.minFilter!==ie&&t.minFilter!==oe,\"min filter requires mipmap\"):(r(C(a)&&C(o),\"texture must be a square power of 2 to support mipmapping\"),r(e.mipmask===(a<<1)-1,\"missing or incomplete mipmap data\")),e.type===se&&(n.extensions.indexOf(\"oes_texture_float_linear\")<0&&r(t.minFilter===re&&t.magFilter===re,\"filter not supported, must enable oes_texture_float_linear\"),r(!t.genMipmaps,\"mipmap generation not supported with float textures\"));var l=e.images;for(i=0;i<16;++i)if(l[i]){var u=a>>i,c=o>>i;r(e.mipmask&1<<i,\"missing mipmap data\");var h=l[i];if(r(h.width===u&&h.height===c,\"invalid shape for mip images\"),r(h.format===e.format&&h.internalformat===e.internalformat&&h.type===e.type,\"incompatible type for mip image\"),h.compressed);else if(h.data){var f=Math.ceil(L(h.type,s)*u/h.unpackAlignment)*h.unpackAlignment;r(h.data.byteLength===f*c,\"invalid data for image, buffer size is inconsistent with image format\")}else h.element||h.copy}else t.genMipmaps||r(0==(e.mipmask&1<<i),\"extra mipmap data\");e.compressed&&r(!t.genMipmaps,\"mipmap generation for compressed images not supported\")}function I(t,e,n,i){var a=t.width,o=t.height,s=t.channels;r(a>0&&a<=i.maxTextureSize&&o>0&&o<=i.maxTextureSize,\"invalid texture shape\"),r(a===o,\"cube map must be square\"),r(e.wrapS===ee&&e.wrapT===ee,\"wrap mode not supported by cube map\");for(var l=0;l<n.length;++l){var u=n[l];r(u.width===a&&u.height===o,\"inconsistent cube map face shape\"),e.genMipmaps&&(r(!u.compressed,\"can not generate mipmap for compressed textures\"),r(1===u.mipmask,\"can not specify mipmaps and generate mipmaps\"));for(var c=u.images,h=0;h<16;++h){var f=c[h];if(f){var d=a>>h,p=o>>h;r(u.mipmask&1<<h,\"missing mipmap data\"),r(f.width===d&&f.height===p,\"invalid shape for mip images\"),r(f.format===t.format&&f.internalformat===t.internalformat&&f.type===t.type,\"incompatible type for mip image\"),f.compressed||(f.data?r(f.data.byteLength===d*p*Math.max(L(f.type,s),f.unpackAlignment),\"invalid data for image, buffer size is inconsistent with image format\"):f.element||f.copy)}}}}function D(t,e){this.id=pe++,this.type=t,this.data=e}function P(t){return t.replace(/\\\\/g,\"\\\\\\\\\").replace(/\"/g,'\\\\\"')}function O(t){if(0===t.length)return[];var e=t.charAt(0),r=t.charAt(t.length-1);if(t.length>1&&e===r&&('\"'===e||\"'\"===e))return['\"'+P(t.substr(1,t.length-2))+'\"'];var n=/\\[(false|true|null|\\d+|'[^']*'|\"[^\"]*\")\\]/.exec(t);if(n)return O(t.substr(0,n.index)).concat(O(n[1])).concat(O(t.substr(n.index+n[0].length)));var i=t.split(\".\");if(1===i.length)return['\"'+P(t)+'\"'];for(var a=[],o=0;o<i.length;++o)a=a.concat(O(i[o]));return a}function R(t){return\"[\"+O(t).join(\"][\")+\"]\"}function F(t,e){return new D(t,R(e+\"\"))}function j(t){return\"function\"==typeof t&&!t._reglType||t instanceof D}function N(t,e){return\"function\"==typeof t?new D(me,t):t}function B(){var t={\"\":0},e=[\"\"];return{id:function(r){var n=t[r];return n||(n=t[r]=e.length,e.push(r),n)},str:function(t){return e[t]}}}function U(t,e,r){function n(){var e=window.innerWidth,n=window.innerHeight;if(t!==document.body){var i=t.getBoundingClientRect();e=i.right-i.left,n=i.bottom-i.top}a.width=r*e,a.height=r*n,$t(a.style,{width:e+\"px\",height:n+\"px\"})}function i(){window.removeEventListener(\"resize\",n),t.removeChild(a)}var a=document.createElement(\"canvas\");return $t(a.style,{border:0,margin:0,padding:0,top:0,left:0}),t.appendChild(a),t===document.body&&(a.style.position=\"absolute\",$t(t.style,{margin:0,padding:0})),window.addEventListener(\"resize\",n,!1),n(),{canvas:a,onDestroy:i}}function V(t,e){function r(r){try{return t.getContext(r,e)}catch(t){return null}}return r(\"webgl\")||r(\"experimental-webgl\")||r(\"webgl-experimental\")}function H(t){return\"string\"==typeof t.nodeName&&\"function\"==typeof t.appendChild&&\"function\"==typeof t.getBoundingClientRect}function q(t){return\"function\"==typeof t.drawArrays||\"function\"==typeof t.drawElements}function G(t){return\"string\"==typeof t?t.split():(de(Array.isArray(t),\"invalid extension array\"),t)}function Y(t){return\"string\"==typeof t?(de(\"undefined\"!=typeof document,\"not supported outside of DOM\"),document.querySelector(t)):t}function X(t){var e,r,n,i,a=t||{},o={},s=[],l=[],u=\"undefined\"==typeof window?1:window.devicePixelRatio,c=!1,h=function(t){t&&de.raise(t)},f=function(){};if(\"string\"==typeof a?(de(\"undefined\"!=typeof document,\"selector queries only supported in DOM enviroments\"),e=document.querySelector(a),de(e,\"invalid query string for element\")):\"object\"==typeof a?H(a)?e=a:q(a)?(i=a,n=i.canvas):(de.constructor(a),\"gl\"in a?i=a.gl:\"canvas\"in a?n=Y(a.canvas):\"container\"in a&&(r=Y(a.container)),\"attributes\"in a&&(o=a.attributes,de.type(o,\"object\",\"invalid context attributes\")),\"extensions\"in a&&(s=G(a.extensions)),\"optionalExtensions\"in a&&(l=G(a.optionalExtensions)),\"onDone\"in a&&(de.type(a.onDone,\"function\",\"invalid or missing onDone callback\"),h=a.onDone),\"profile\"in a&&(c=!!a.profile),\"pixelRatio\"in a&&(u=+a.pixelRatio,de(u>0,\"invalid pixel ratio\"))):de.raise(\"invalid arguments to regl\"),e&&(\"canvas\"===e.nodeName.toLowerCase()?n=e:r=e),!i){if(!n){de(\"undefined\"!=typeof document,\"must manually specify webgl context outside of DOM environments\");var d=U(r||document.body,h,u);if(!d)return null;n=d.canvas,f=d.onDestroy}i=V(n,o)}return i?{gl:i,canvas:n,container:r,extensions:s,optionalExtensions:l,pixelRatio:u,profile:c,onDone:h,onDestroy:f}:(f(),h(\"webgl not supported, try upgrading your browser or graphics drivers http://get.webgl.org\"),null)}function W(t,e){function r(e){de.type(e,\"string\",\"extension name must be string\");var r,i=e.toLowerCase();try{r=n[i]=t.getExtension(i)}catch(t){}return!!r}for(var n={},i=0;i<e.extensions.length;++i){var a=e.extensions[i];if(!r(a))return e.onDestroy(),e.onDone('\"'+a+'\" extension is not supported by the current WebGL context, try upgrading your system or a different browser'),null}return e.optionalExtensions.forEach(r),{extensions:n,restore:function(){Object.keys(n).forEach(function(t){if(!r(t))throw new Error(\"(regl): error restoring extension \"+t)})}}}function Z(t){return!!t&&\"object\"==typeof t&&Array.isArray(t.shape)&&Array.isArray(t.stride)&&\"number\"==typeof t.offset&&t.shape.length===t.stride.length&&(Array.isArray(t.data)||Qt(t.data))}function J(t,e){for(var r=Array(t),n=0;n<t;++n)r[n]=e(n);return r}function K(t){for(var e=16;e<=1<<28;e*=16)if(t<=e)return e;return 0}function Q(t){var e,r;return e=(t>65535)<<4,t>>>=e,r=(t>255)<<3,t>>>=r,e|=r,r=(t>15)<<2,t>>>=r,e|=r,r=(t>3)<<1,t>>>=r,(e|=r)|t>>1}function $(t){var e=K(t),r=Ee[Q(e)>>2];return r.length>0?r.pop():new ArrayBuffer(e)}function tt(t){Ee[Q(t.byteLength)>>2].push(t)}function et(t,e){var r=null;switch(t){case _e:r=new Int8Array($(e),0,e);break;case we:r=new Uint8Array($(e),0,e);break;case Me:r=new Int16Array($(2*e),0,e);break;case ke:r=new Uint16Array($(2*e),0,e);break;case Ae:r=new Int32Array($(4*e),0,e);break;case Te:r=new Uint32Array($(4*e),0,e);break;case Se:r=new Float32Array($(4*e),0,e);break;default:return null}return r.length!==e?r.subarray(0,e):r}function rt(t){tt(t.buffer)}function nt(t,e,r){for(var n=0;n<e;++n)r[n]=t[n]}function it(t,e,r,n){for(var i=0,a=0;a<e;++a)for(var o=t[a],s=0;s<r;++s)n[i++]=o[s]}function at(t,e,r,n,i,a){for(var o=a,s=0;s<e;++s)for(var l=t[s],u=0;u<r;++u)for(var c=l[u],h=0;h<n;++h)i[o++]=c[h]}function ot(t,e,r,n,i){for(var a=1,o=r+1;o<e.length;++o)a*=e[o];var s=e[r];if(e.length-r==4){var l=e[r+1],u=e[r+2],c=e[r+3];for(o=0;o<s;++o)at(t[o],l,u,c,n,i),i+=a}else for(o=0;o<s;++o)ot(t[o],e,r+1,n,i),i+=a}function st(t,e,r,n){var i=1;if(e.length)for(var a=0;a<e.length;++a)i*=e[a];else i=0;var o=n||Le.allocType(r,i);switch(e.length){case 0:break;case 1:nt(t,e[0],o);break;case 2:it(t,e[0],e[1],o);break;case 3:at(t,e[0],e[1],e[2],o,0);break;default:ot(t,e,0,o,0)}return o}function lt(t){for(var e=[],r=t;r.length;r=r[0])e.push(r.length);return e}function ut(t){return 0|Kt[Object.prototype.toString.call(t)]}function ct(t,e){for(var r=0;r<e.length;++r)t[r]=e[r]}function ht(t,e,r,n,i,a,o){for(var s=0,l=0;l<r;++l)for(var u=0;u<n;++u)t[s++]=e[i*l+a*u+o]}function ft(t,e,r){function n(e){this.id=h++,this.buffer=t.createBuffer(),this.type=e,this.usage=Oe,this.byteLength=0,this.dimension=1,this.dtype=Fe,this.persistentData=null,r.profile&&(this.stats={size:0})}function i(t,e){var r=d.pop();return r||(r=new n(t)),r.bind(),s(r,e,Re,0,1,!1),r}function a(t){d.push(t)}function o(e,r,n){e.byteLength=r.byteLength,t.bufferData(e.type,r,n)}function s(t,e,r,n,i,a){var s;if(t.usage=r,Array.isArray(e)){if(t.dtype=n||je,e.length>0){var l;if(Array.isArray(e[0])){s=Pe(e);for(var u=1,c=1;c<s.length;++c)u*=s[c];t.dimension=u,l=De(e,s,t.dtype),o(t,l,r),a?t.persistentData=l:Le.freeType(l)}else if(\"number\"==typeof e[0]){t.dimension=i;var h=Le.allocType(t.dtype,e.length);ct(h,e),o(t,h,r),a?t.persistentData=h:Le.freeType(h)}else Qt(e[0])?(t.dimension=e[0].length,t.dtype=n||ut(e[0])||je,l=De(e,[e.length,e[0].length],t.dtype),o(t,l,r),a?t.persistentData=l:Le.freeType(l)):de.raise(\"invalid buffer data\")}}else if(Qt(e))t.dtype=n||ut(e),t.dimension=i,o(t,e,r),a&&(t.persistentData=new Uint8Array(new Uint8Array(e.buffer)));else if(Z(e)){s=e.shape;var f=e.stride,d=e.offset,p=0,m=0,v=0,g=0;1===s.length?(p=s[0],m=1,v=f[0],g=0):2===s.length?(p=s[0],m=s[1],v=f[0],g=f[1]):de.raise(\"invalid shape\"),t.dtype=n||ut(e.data)||je,t.dimension=m;var y=Le.allocType(t.dtype,p*m);ht(y,e.data,p,m,v,g,d),o(t,y,r),a?t.persistentData=y:Le.freeType(y)}else de.raise(\"invalid buffer data\")}function l(r){e.bufferCount--;var n=r.buffer;de(n,\"buffer must not be deleted already\"),t.deleteBuffer(n),r.buffer=null,delete f[r.id]}function u(i,a,o,u){function c(e){var n=Oe,i=null,a=0,o=0,l=1;return Array.isArray(e)||Qt(e)||Z(e)?i=e:\"number\"==typeof e?a=0|e:e&&(de.type(e,\"object\",\"buffer arguments must be an object, a number or an array\"),\"data\"in e&&(de(null===i||Array.isArray(i)||Qt(i)||Z(i),\"invalid data for buffer\"),i=e.data),\"usage\"in e&&(de.parameter(e.usage,Ie,\"invalid buffer usage\"),n=Ie[e.usage]),\"type\"in e&&(de.parameter(e.type,ze,\"invalid buffer type\"),o=ze[e.type]),\"dimension\"in e&&(de.type(e.dimension,\"number\",\"invalid dimension\"),l=0|e.dimension),\"length\"in e&&(de.nni(a,\"buffer length must be a nonnegative integer\"),a=0|e.length)),p.bind(),i?s(p,i,n,o,l,u):(t.bufferData(p.type,a,n),p.dtype=o||Fe,p.usage=n,p.dimension=l,p.byteLength=a),r.profile&&(p.stats.size=p.byteLength*Ne[p.dtype]),c}function h(e,r){de(r+e.byteLength<=p.byteLength,\"invalid buffer subdata call, buffer is too small.  Can't write data of size \"+e.byteLength+\" starting from offset \"+r+\" to a buffer of size \"+p.byteLength),t.bufferSubData(p.type,r,e)}function d(t,e){var r,n=0|(e||0);if(p.bind(),Array.isArray(t)){if(t.length>0)if(\"number\"==typeof t[0]){var i=Le.allocType(p.dtype,t.length);ct(i,t),h(i,n),Le.freeType(i)}else if(Array.isArray(t[0])||Qt(t[0])){r=Pe(t);var a=De(t,r,p.dtype);h(a,n),Le.freeType(a)}else de.raise(\"invalid buffer data\")}else if(Qt(t))h(t,n);else if(Z(t)){r=t.shape;var o=t.stride,s=0,l=0,u=0,f=0;1===r.length?(s=r[0],l=1,u=o[0],f=0):2===r.length?(s=r[0],l=r[1],u=o[0],f=o[1]):de.raise(\"invalid shape\");var d=Array.isArray(t.data)?p.dtype:ut(t.data),m=Le.allocType(d,s*l);ht(m,t.data,s,l,u,f,t.offset),h(m,n),Le.freeType(m)}else de.raise(\"invalid data for buffer subdata\");return c}e.bufferCount++;var p=new n(a);return f[p.id]=p,o||c(i),c._reglType=\"buffer\",c._buffer=p,c.subdata=d,r.profile&&(c.stats=p.stats),c.destroy=function(){l(p)},c}function c(){xe(f).forEach(function(e){e.buffer=t.createBuffer(),t.bindBuffer(e.type,e.buffer),t.bufferData(e.type,e.persistentData||e.byteLength,e.usage)})}var h=0,f={};n.prototype.bind=function(){t.bindBuffer(this.type,this.buffer)},n.prototype.destroy=function(){l(this)};var d=[];return r.profile&&(e.getTotalBufferSize=function(){var t=0;return Object.keys(f).forEach(function(e){t+=f[e].stats.size}),t}),{create:u,createStream:i,destroyStream:a,clear:function(){xe(f).forEach(l),d.forEach(l)},getBuffer:function(t){return t&&t._buffer instanceof n?t._buffer:null},restore:c,_initBuffer:s}}function dt(t,e,r,n){function i(t){this.id=h++,c[this.id]=this,this.buffer=t,this.primType=He,this.vertCount=0,this.type=0}function a(t){var e=d.pop();return e||(e=new i(r.create(null,Je,!0,!1)._buffer)),s(e,t,Ke,-1,-1,0,0),e}function o(t){d.push(t)}function s(n,i,a,o,s,l,u){if(n.buffer.bind(),i){var c=u;u||Qt(i)&&(!Z(i)||Qt(i.data))||(c=e.oes_element_index_uint?Ze:Xe),r._initBuffer(n.buffer,i,a,c,3)}else t.bufferData(Je,l,a),n.buffer.dtype=h||Ge,n.buffer.usage=a,n.buffer.dimension=3,n.buffer.byteLength=l;var h=u;if(!u){switch(n.buffer.dtype){case Ge:case qe:h=Ge;break;case Xe:case Ye:h=Xe;break;case Ze:case We:h=Ze;break;default:de.raise(\"unsupported type for element array\")}n.buffer.dtype=h}n.type=h,de(h!==Ze||!!e.oes_element_index_uint,\"32 bit element buffers not supported, enable oes_element_index_uint first\");var f=s;f<0&&(f=n.buffer.byteLength,h===Xe?f>>=1:h===Ze&&(f>>=2)),n.vertCount=f;var d=o;if(o<0){d=He;var p=n.buffer.dimension;1===p&&(d=Ue),2===p&&(d=Ve),3===p&&(d=He)}n.primType=d}function l(t){n.elementsCount--,de(null!==t.buffer,\"must not double destroy elements\"),delete c[t.id],t.buffer.destroy(),t.buffer=null}function u(t,e){function a(t){if(t)if(\"number\"==typeof t)o(t),u.primType=He,u.vertCount=0|t,u.type=Ge;else{var e=null,r=Qe,n=-1,i=-1,l=0,c=0;Array.isArray(t)||Qt(t)||Z(t)?e=t:(de.type(t,\"object\",\"invalid arguments for elements\"),\"data\"in t&&(e=t.data,de(Array.isArray(e)||Qt(e)||Z(e),\"invalid data for element buffer\")),\"usage\"in t&&(de.parameter(t.usage,Ie,\"invalid element buffer usage\"),r=Ie[t.usage]),\"primitive\"in t&&(de.parameter(t.primitive,Be,\"invalid element buffer primitive\"),n=Be[t.primitive]),\"count\"in t&&(de(\"number\"==typeof t.count&&t.count>=0,\"invalid vertex count for elements\"),i=0|t.count),\"type\"in t&&(de.parameter(t.type,f,\"invalid buffer type\"),c=f[t.type]),\"length\"in t?l=0|t.length:(l=i,c===Xe||c===Ye?l*=2:c!==Ze&&c!==We||(l*=4))),s(u,e,r,n,i,l,c)}else o(),u.primType=He,\n",
       "u.vertCount=0,u.type=Ge;return a}var o=r.create(null,Je,!0),u=new i(o._buffer);return n.elementsCount++,a(t),a._reglType=\"elements\",a._elements=u,a.subdata=function(t,e){return o.subdata(t,e),a},a.destroy=function(){l(u)},a}var c={},h=0,f={uint8:Ge,uint16:Xe};e.oes_element_index_uint&&(f.uint32=Ze),i.prototype.bind=function(){this.buffer.bind()};var d=[];return{create:u,createStream:a,destroyStream:o,getElements:function(t){return\"function\"==typeof t&&t._elements instanceof i?t._elements:null},clear:function(){xe(c).forEach(l)}}}function pt(t){for(var e=Le.allocType(er,t.length),r=0;r<t.length;++r)if(isNaN(t[r]))e[r]=65535;else if(t[r]===1/0)e[r]=31744;else if(t[r]===-1/0)e[r]=64512;else{$e[0]=t[r];var n=tr[0],i=n>>>31<<15,a=(n<<1>>>24)-127,o=n>>13&1023;if(a<-24)e[r]=i;else if(a<-14){var s=-14-a;e[r]=i+(o+1024>>s)}else e[r]=a>15?i+31744:i+(a+15<<10)+o}return e}function mt(t){return Array.isArray(t)||Qt(t)}function vt(t){return\"[object \"+t+\"]\"}function gt(t){return Array.isArray(t)&&(0===t.length||\"number\"==typeof t[0])}function yt(t){return!!Array.isArray(t)&&!(0===t.length||!mt(t[0]))}function bt(t){return Object.prototype.toString.call(t)}function xt(t){return bt(t)===dn}function _t(t){return bt(t)===pn}function wt(t){return bt(t)===mn}function Mt(t){return bt(t)===vn}function kt(t){if(!t)return!1;var e=bt(t);return gn.indexOf(e)>=0||(gt(t)||yt(t)||Z(t))}function At(t){return 0|Kt[Object.prototype.toString.call(t)]}function Tt(t,e){var r=e.length;switch(t.type){case Or:case Rr:case Fr:case jr:var n=Le.allocType(t.type,r);n.set(e),t.data=n;break;case wr:t.data=pt(e);break;default:de.raise(\"unsupported texture type, must specify a typed array\")}}function St(t,e){return Le.allocType(t.type===wr?jr:t.type,e)}function Et(t,e){t.type===wr?(t.data=pt(e),Le.freeType(e)):t.data=e}function Lt(t,e,r,n,i,a){for(var o=t.width,s=t.height,l=t.channels,u=o*s*l,c=St(t,u),h=0,f=0;f<s;++f)for(var d=0;d<o;++d)for(var p=0;p<l;++p)c[h++]=e[r*d+n*f+i*p+a];Et(t,c)}function Ct(t,e,r,n,i,a){var o;if(o=void 0!==bn[t]?bn[t]:fn[t]*yn[e],a&&(o*=6),i){for(var s=0,l=r;l>=1;)s+=o*l*l,l/=2;return s}return o*r*n}function zt(t,e,r,n,i,a,o){function s(){this.internalformat=or,this.format=or,this.type=Or,this.compressed=!1,this.premultiplyAlpha=!1,this.flipY=!1,this.unpackAlignment=1,this.colorSpace=0,this.width=0,this.height=0,this.channels=0}function l(t,e){t.internalformat=e.internalformat,t.format=e.format,t.type=e.type,t.compressed=e.compressed,t.premultiplyAlpha=e.premultiplyAlpha,t.flipY=e.flipY,t.unpackAlignment=e.unpackAlignment,t.colorSpace=e.colorSpace,t.width=e.width,t.height=e.height,t.channels=e.channels}function u(t,n){if(\"object\"==typeof n&&n){if(\"premultiplyAlpha\"in n&&(de.type(n.premultiplyAlpha,\"boolean\",\"invalid premultiplyAlpha\"),t.premultiplyAlpha=n.premultiplyAlpha),\"flipY\"in n&&(de.type(n.flipY,\"boolean\",\"invalid texture flip\"),t.flipY=n.flipY),\"alignment\"in n&&(de.oneOf(n.alignment,[1,2,4,8],\"invalid texture unpack alignment\"),t.unpackAlignment=n.alignment),\"colorSpace\"in n&&(de.parameter(n.colorSpace,j,\"invalid colorSpace\"),t.colorSpace=j[n.colorSpace]),\"type\"in n){var i=n.type;de(e.oes_texture_float||!(\"float\"===i||\"float32\"===i),\"you must enable the OES_texture_float extension in order to use floating point textures.\"),de(e.oes_texture_half_float||!(\"half float\"===i||\"float16\"===i),\"you must enable the OES_texture_half_float extension in order to use 16-bit floating point textures.\"),de(e.webgl_depth_texture||!(\"uint16\"===i||\"uint32\"===i||\"depth stencil\"===i),\"you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures.\"),de.parameter(i,N,\"invalid texture type\"),t.type=N[i]}var a=t.width,o=t.height,s=t.channels,l=!1;\"shape\"in n?(de(Array.isArray(n.shape)&&n.shape.length>=2,\"shape must be an array\"),a=n.shape[0],o=n.shape[1],3===n.shape.length&&(s=n.shape[2],de(s>0&&s<=4,\"invalid number of channels\"),l=!0),de(a>=0&&a<=r.maxTextureSize,\"invalid width\"),de(o>=0&&o<=r.maxTextureSize,\"invalid height\")):(\"radius\"in n&&(a=o=n.radius,de(a>=0&&a<=r.maxTextureSize,\"invalid radius\")),\"width\"in n&&(a=n.width,de(a>=0&&a<=r.maxTextureSize,\"invalid width\")),\"height\"in n&&(o=n.height,de(o>=0&&o<=r.maxTextureSize,\"invalid height\")),\"channels\"in n&&(s=n.channels,de(s>0&&s<=4,\"invalid number of channels\"),l=!0)),t.width=0|a,t.height=0|o,t.channels=0|s;var u=!1;if(\"format\"in n){var c=n.format;de(e.webgl_depth_texture||!(\"depth\"===c||\"depth stencil\"===c),\"you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures.\"),de.parameter(c,B,\"invalid texture format\");var h=t.internalformat=B[c];t.format=J[h],c in N&&(\"type\"in n||(t.type=N[c])),c in U&&(t.compressed=!0),u=!0}!l&&u?t.channels=fn[t.format]:l&&!u?t.channels!==hn[t.format]&&(t.format=t.internalformat=hn[t.channels]):u&&l&&de(t.channels===fn[t.format],\"number of channels inconsistent with specified format\")}}function c(e){t.pixelStorei(an,e.flipY),t.pixelStorei(on,e.premultiplyAlpha),t.pixelStorei(sn,e.colorSpace),t.pixelStorei(nn,e.unpackAlignment)}function h(){s.call(this),this.xOffset=0,this.yOffset=0,this.data=null,this.needsFree=!1,this.element=null,this.needsCopy=!1}function f(t,e){var n=null;if(kt(e)?n=e:e&&(de.type(e,\"object\",\"invalid pixel data type\"),u(t,e),\"x\"in e&&(t.xOffset=0|e.x),\"y\"in e&&(t.yOffset=0|e.y),kt(e.data)&&(n=e.data)),de(!t.compressed||n instanceof Uint8Array,\"compressed texture data must be stored in a uint8array\"),e.copy){de(!n,\"can not specify copy and data field for the same texture\");var a=i.viewportWidth,o=i.viewportHeight;t.width=t.width||a-t.xOffset,t.height=t.height||o-t.yOffset,t.needsCopy=!0,de(t.xOffset>=0&&t.xOffset<a&&t.yOffset>=0&&t.yOffset<o&&t.width>0&&t.width<=a&&t.height>0&&t.height<=o,\"copy texture read out of bounds\")}else if(n){if(Qt(n))t.channels=t.channels||4,t.data=n,\"type\"in e||t.type!==Or||(t.type=At(n));else if(gt(n))t.channels=t.channels||4,Tt(t,n),t.alignment=1,t.needsFree=!0;else if(Z(n)){var s=n.data;Array.isArray(s)||t.type!==Or||(t.type=At(s));var l,c,h,f,d,p,m=n.shape,v=n.stride;3===m.length?(h=m[2],p=v[2]):(de(2===m.length,\"invalid ndarray pixel data, must be 2 or 3D\"),h=1,p=1),l=m[0],c=m[1],f=v[0],d=v[1],t.alignment=1,t.width=l,t.height=c,t.channels=h,t.format=t.internalformat=hn[h],t.needsFree=!0,Lt(t,s,f,d,p,n.offset)}else if(xt(n)||_t(n))xt(n)?t.element=n:t.element=n.canvas,t.width=t.element.width,t.height=t.element.height,t.channels=4;else if(wt(n))t.element=n,t.width=n.naturalWidth,t.height=n.naturalHeight,t.channels=4;else if(Mt(n))t.element=n,t.width=n.videoWidth,t.height=n.videoHeight,t.channels=4;else if(yt(n)){var g=t.width||n[0].length,y=t.height||n.length,b=t.channels;b=mt(n[0][0])?b||n[0][0].length:b||1;for(var x=Ce.shape(n),_=1,w=0;w<x.length;++w)_*=x[w];var M=St(t,_);Ce.flatten(n,x,\"\",M),Et(t,M),t.alignment=1,t.width=g,t.height=y,t.channels=b,t.format=t.internalformat=hn[b],t.needsFree=!0}}else t.width=t.width||1,t.height=t.height||1,t.channels=t.channels||4;t.type===jr?de(r.extensions.indexOf(\"oes_texture_float\")>=0,\"oes_texture_float extension not enabled\"):t.type===wr&&de(r.extensions.indexOf(\"oes_texture_half_float\")>=0,\"oes_texture_half_float extension not enabled\")}function d(e,r,i){var a=e.element,o=e.data,s=e.internalformat,l=e.format,u=e.type,h=e.width,f=e.height;c(e),a?t.texImage2D(r,i,l,l,u,a):e.compressed?t.compressedTexImage2D(r,i,s,h,f,0,o):e.needsCopy?(n(),t.copyTexImage2D(r,i,l,e.xOffset,e.yOffset,h,f,0)):t.texImage2D(r,i,l,h,f,0,l,u,o)}function p(e,r,i,a,o){var s=e.element,l=e.data,u=e.internalformat,h=e.format,f=e.type,d=e.width,p=e.height;c(e),s?t.texSubImage2D(r,o,i,a,h,f,s):e.compressed?t.compressedTexSubImage2D(r,o,i,a,u,d,p,l):e.needsCopy?(n(),t.copyTexSubImage2D(r,o,i,a,e.xOffset,e.yOffset,d,p)):t.texSubImage2D(r,o,i,a,d,p,h,f,l)}function m(){return K.pop()||new h}function v(t){t.needsFree&&Le.freeType(t.data),h.call(t),K.push(t)}function g(){s.call(this),this.genMipmaps=!1,this.mipmapHint=$r,this.mipmask=0,this.images=Array(16)}function y(t,e,r){var n=t.images[0]=m();t.mipmask=1,n.width=t.width=e,n.height=t.height=r,n.channels=t.channels=4}function b(t,e){var r=null;if(kt(e))r=t.images[0]=m(),l(r,t),f(r,e),t.mipmask=1;else if(u(t,e),Array.isArray(e.mipmap))for(var n=e.mipmap,i=0;i<n.length;++i)r=t.images[i]=m(),l(r,t),r.width>>=i,r.height>>=i,f(r,n[i]),t.mipmask|=1<<i;else r=t.images[0]=m(),l(r,t),f(r,e),t.mipmask=1;l(t,t.images[0]),(t.compressed&&t.internalformat===Mr||t.internalformat===kr||t.internalformat===Ar||t.internalformat===Tr)&&de(t.width%4==0&&t.height%4==0,\"for compressed texture formats, mipmap level 0 must have width and height that are a multiple of 4\")}function x(t,e){for(var r=t.images,n=0;n<r.length;++n){if(!r[n])return;d(r[n],e,n)}}function _(){var t=Q.pop()||new g;s.call(t),t.mipmask=0;for(var e=0;e<16;++e)t.images[e]=null;return t}function w(t){for(var e=t.images,r=0;r<e.length;++r)e[r]&&v(e[r]),e[r]=null;Q.push(t)}function M(){this.minFilter=Yr,this.magFilter=Yr,this.wrapS=Vr,this.wrapT=Vr,this.anisotropic=1,this.genMipmaps=!1,this.mipmapHint=$r}function k(t,e){if(\"min\"in e){var n=e.min;de.parameter(n,F),t.minFilter=F[n],cn.indexOf(t.minFilter)>=0&&(t.genMipmaps=!0)}if(\"mag\"in e){var i=e.mag;de.parameter(i,R),t.magFilter=R[i]}var a=t.wrapS,o=t.wrapT;if(\"wrap\"in e){var s=e.wrap;\"string\"==typeof s?(de.parameter(s,O),a=o=O[s]):Array.isArray(s)&&(de.parameter(s[0],O),de.parameter(s[1],O),a=O[s[0]],o=O[s[1]])}else{if(\"wrapS\"in e){var l=e.wrapS;de.parameter(l,O),a=O[l]}if(\"wrapT\"in e){var u=e.wrapT;de.parameter(u,O),o=O[u]}}if(t.wrapS=a,t.wrapT=o,\"anisotropic\"in e){var c=e.anisotropic;de(\"number\"==typeof c&&c>=1&&c<=r.maxAnisotropic,\"aniso samples must be between 1 and \"),t.anisotropic=e.anisotropic}if(\"mipmap\"in e){var h=!1;switch(typeof e.mipmap){case\"string\":de.parameter(e.mipmap,P,\"invalid mipmap hint\"),t.mipmapHint=P[e.mipmap],t.genMipmaps=!0,h=!0;break;case\"boolean\":h=t.genMipmaps=e.mipmap;break;case\"object\":de(Array.isArray(e.mipmap),\"invalid mipmap type\"),t.genMipmaps=!1,h=!0;break;default:de.raise(\"invalid mipmap type\")}!h||\"min\"in e||(t.minFilter=Wr)}}function A(r,n){t.texParameteri(n,Gr,r.minFilter),t.texParameteri(n,qr,r.magFilter),t.texParameteri(n,Nr,r.wrapS),t.texParameteri(n,Br,r.wrapT),e.ext_texture_filter_anisotropic&&t.texParameteri(n,rn,r.anisotropic),r.genMipmaps&&(t.hint(Qr,r.mipmapHint),t.generateMipmap(n))}function T(e){s.call(this),this.mipmask=0,this.internalformat=or,this.id=$++,this.refCount=1,this.target=e,this.texture=t.createTexture(),this.unit=-1,this.bindCount=0,this.texInfo=new M,o.profile&&(this.stats={size:0})}function S(e){t.activeTexture(un),t.bindTexture(e.target,e.texture)}function E(){var e=rt[0];e?t.bindTexture(e.target,e.texture):t.bindTexture(nr,null)}function L(e){var r=e.texture;de(r,\"must not double destroy texture\");var n=e.unit,i=e.target;n>=0&&(t.activeTexture(un+n),t.bindTexture(i,null),rt[n]=null),t.deleteTexture(r),e.texture=null,e.params=null,e.pixels=null,e.refCount=0,delete tt[e.id],a.textureCount--}function C(e,n){function i(t,e){var n=c.texInfo;M.call(n);var a=_();return\"number\"==typeof t?\"number\"==typeof e?y(a,0|t,0|e):y(a,0|t,0|t):t?(de.type(t,\"object\",\"invalid arguments to regl.texture\"),k(n,t),b(a,t)):y(a,1,1),n.genMipmaps&&(a.mipmask=(a.width<<1)-1),c.mipmask=a.mipmask,l(c,a),de.texture2D(n,a,r),c.internalformat=a.internalformat,i.width=a.width,i.height=a.height,S(c),x(a,nr),A(n,nr),E(),w(a),o.profile&&(c.stats.size=Ct(c.internalformat,c.type,a.width,a.height,n.genMipmaps,!1)),i.format=q[c.internalformat],i.type=G[c.type],i.mag=Y[n.magFilter],i.min=X[n.minFilter],i.wrapS=W[n.wrapS],i.wrapT=W[n.wrapT],i}function s(t,e,r,n){de(!!t,\"must specify image data\");var a=0|e,o=0|r,s=0|n,u=m();return l(u,c),u.width=0,u.height=0,f(u,t),u.width=u.width||(c.width>>s)-a,u.height=u.height||(c.height>>s)-o,de(c.type===u.type&&c.format===u.format&&c.internalformat===u.internalformat,\"incompatible format for texture.subimage\"),de(a>=0&&o>=0&&a+u.width<=c.width&&o+u.height<=c.height,\"texture.subimage write out of bounds\"),de(c.mipmask&1<<s,\"missing mipmap data\"),de(u.data||u.element||u.needsCopy,\"missing image data\"),S(c),p(u,nr,a,o,s),E(),v(u),i}function u(e,r){var n=0|e,a=0|r||n;if(n===c.width&&a===c.height)return i;i.width=c.width=n,i.height=c.height=a,S(c);for(var s=0;c.mipmask>>s;++s)t.texImage2D(nr,s,c.format,n>>s,a>>s,0,c.format,c.type,null);return E(),o.profile&&(c.stats.size=Ct(c.internalformat,c.type,n,a,!1,!1)),i}var c=new T(nr);return tt[c.id]=c,a.textureCount++,i(e,n),i.subimage=s,i.resize=u,i._reglType=\"texture2d\",i._texture=c,o.profile&&(i.stats=c.stats),i.destroy=function(){c.decRef()},i}function z(e,n,i,s,c,h){function d(t,e,n,i,a,s){var c,h=C.texInfo;for(M.call(h),c=0;c<6;++c)z[c]=_();if(\"number\"!=typeof t&&t)if(\"object\"==typeof t)if(e)b(z[0],t),b(z[1],e),b(z[2],n),b(z[3],i),b(z[4],a),b(z[5],s);else if(k(h,t),u(C,t),\"faces\"in t){var f=t.faces;for(de(Array.isArray(f)&&6===f.length,\"cube faces must be a length 6 array\"),c=0;c<6;++c)de(\"object\"==typeof f[c]&&!!f[c],\"invalid input for cube map face\"),l(z[c],C),b(z[c],f[c])}else for(c=0;c<6;++c)b(z[c],t);else de.raise(\"invalid arguments to cube map\");else{var p=0|t||1;for(c=0;c<6;++c)y(z[c],p,p)}for(l(C,z[0]),h.genMipmaps?C.mipmask=(z[0].width<<1)-1:C.mipmask=z[0].mipmask,de.textureCube(C,h,z,r),C.internalformat=z[0].internalformat,d.width=z[0].width,d.height=z[0].height,S(C),c=0;c<6;++c)x(z[c],ar+c);for(A(h,ir),E(),o.profile&&(C.stats.size=Ct(C.internalformat,C.type,d.width,d.height,h.genMipmaps,!0)),d.format=q[C.internalformat],d.type=G[C.type],d.mag=Y[h.magFilter],d.min=X[h.minFilter],d.wrapS=W[h.wrapS],d.wrapT=W[h.wrapT],c=0;c<6;++c)w(z[c]);return d}function g(t,e,r,n,i){de(!!e,\"must specify image data\"),de(\"number\"==typeof t&&t===(0|t)&&t>=0&&t<6,\"invalid face\");var a=0|r,o=0|n,s=0|i,u=m();return l(u,C),u.width=0,u.height=0,f(u,e),u.width=u.width||(C.width>>s)-a,u.height=u.height||(C.height>>s)-o,de(C.type===u.type&&C.format===u.format&&C.internalformat===u.internalformat,\"incompatible format for texture.subimage\"),de(a>=0&&o>=0&&a+u.width<=C.width&&o+u.height<=C.height,\"texture.subimage write out of bounds\"),de(C.mipmask&1<<s,\"missing mipmap data\"),de(u.data||u.element||u.needsCopy,\"missing image data\"),S(C),p(u,ar+t,a,o,s),E(),v(u),d}function L(e){var r=0|e;if(r!==C.width){d.width=C.width=r,d.height=C.height=r,S(C);for(var n=0;n<6;++n)for(var i=0;C.mipmask>>i;++i)t.texImage2D(ar+n,i,C.format,r>>i,r>>i,0,C.format,C.type,null);return E(),o.profile&&(C.stats.size=Ct(C.internalformat,C.type,d.width,d.height,!1,!0)),d}}var C=new T(ir);tt[C.id]=C,a.cubeCount++;var z=new Array(6);return d(e,n,i,s,c,h),d.subimage=g,d.resize=L,d._reglType=\"textureCube\",d._texture=C,o.profile&&(d.stats=C.stats),d.destroy=function(){C.decRef()},d}function I(){for(var e=0;e<et;++e)t.activeTexture(un+e),t.bindTexture(nr,null),rt[e]=null;xe(tt).forEach(L),a.cubeCount=0,a.textureCount=0}function D(){xe(tt).forEach(function(e){e.texture=t.createTexture(),t.bindTexture(e.target,e.texture);for(var r=0;r<32;++r)if(0!=(e.mipmask&1<<r))if(e.target===nr)t.texImage2D(nr,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);else for(var n=0;n<6;++n)t.texImage2D(ar+n,r,e.internalformat,e.width>>r,e.height>>r,0,e.internalformat,e.type,null);A(e.texInfo,e.target)})}var P={\"don't care\":$r,\"dont care\":$r,nice:en,fast:tn},O={repeat:Ur,clamp:Vr,mirror:Hr},R={nearest:Yr,linear:Xr},F=$t({mipmap:Kr,\"nearest mipmap nearest\":Wr,\"linear mipmap nearest\":Zr,\"nearest mipmap linear\":Jr,\"linear mipmap linear\":Kr},R),j={none:0,browser:ln},N={uint8:Or,rgba4:pr,rgb565:vr,\"rgb5 a1\":mr},B={alpha:sr,luminance:ur,\"luminance alpha\":cr,rgb:lr,rgba:or,rgba4:hr,\"rgb5 a1\":fr,rgb565:dr},U={};e.ext_srgb&&(B.srgb=xr,B.srgba=_r),e.oes_texture_float&&(N.float32=N.float=jr),e.oes_texture_half_float&&(N.float16=N[\"half float\"]=wr),e.webgl_depth_texture&&($t(B,{depth:yr,\"depth stencil\":br}),$t(N,{uint16:Rr,uint32:Fr,\"depth stencil\":gr})),e.webgl_compressed_texture_s3tc&&$t(U,{\"rgb s3tc dxt1\":Mr,\"rgba s3tc dxt1\":kr,\"rgba s3tc dxt3\":Ar,\"rgba s3tc dxt5\":Tr}),e.webgl_compressed_texture_atc&&$t(U,{\"rgb atc\":Sr,\"rgba atc explicit alpha\":Er,\"rgba atc interpolated alpha\":Lr}),e.webgl_compressed_texture_pvrtc&&$t(U,{\"rgb pvrtc 4bppv1\":Cr,\"rgb pvrtc 2bppv1\":zr,\"rgba pvrtc 4bppv1\":Ir,\"rgba pvrtc 2bppv1\":Dr}),e.webgl_compressed_texture_etc1&&(U[\"rgb etc1\"]=Pr);var V=Array.prototype.slice.call(t.getParameter(rr));Object.keys(U).forEach(function(t){var e=U[t];V.indexOf(e)>=0&&(B[t]=e)});var H=Object.keys(B);r.textureFormats=H;var q=[];Object.keys(B).forEach(function(t){var e=B[t];q[e]=t});var G=[];Object.keys(N).forEach(function(t){var e=N[t];G[e]=t});var Y=[];Object.keys(R).forEach(function(t){var e=R[t];Y[e]=t});var X=[];Object.keys(F).forEach(function(t){var e=F[t];X[e]=t});var W=[];Object.keys(O).forEach(function(t){var e=O[t];W[e]=t});var J=H.reduce(function(t,e){var r=B[e];return r===ur||r===sr||r===ur||r===cr||r===yr||r===br?t[r]=r:r===fr||e.indexOf(\"rgba\")>=0?t[r]=or:t[r]=lr,t},{}),K=[],Q=[],$=0,tt={},et=r.maxTextureUnits,rt=Array(et).map(function(){return null});return $t(T.prototype,{bind:function(){var e=this;e.bindCount+=1;var r=e.unit;if(r<0){for(var n=0;n<et;++n){var i=rt[n];if(i){if(i.bindCount>0)continue;i.unit=-1}rt[n]=e,r=n;break}r>=et&&de.raise(\"insufficient number of texture units\"),o.profile&&a.maxTextureUnits<r+1&&(a.maxTextureUnits=r+1),e.unit=r,t.activeTexture(un+r),t.bindTexture(e.target,e.texture)}return r},unbind:function(){this.bindCount-=1},decRef:function(){--this.refCount<=0&&L(this)}}),o.profile&&(a.getTotalTextureSize=function(){var t=0;return Object.keys(tt).forEach(function(e){t+=tt[e].stats.size}),t}),{create2D:C,createCube:z,clear:I,getTexture:function(t){return null},restore:D}}function It(t,e,r){return wn[t]*e*r}function Dt(t,e,r,n,i,a){function o(t,e,r){this.target=t,this.texture=e,this.renderbuffer=r;var n=0,i=0;e?(n=e.width,i=e.height):r&&(n=r.width,i=r.height),this.width=n,this.height=i}function s(t){t&&(t.texture&&t.texture._texture.decRef(),t.renderbuffer&&t.renderbuffer._renderbuffer.decRef())}function l(t,e,r){if(t)if(t.texture){var n=t.texture._texture,i=Math.max(1,n.width),a=Math.max(1,n.height);de(i===e&&a===r,\"inconsistent width/height for supplied texture\"),n.refCount+=1}else{var o=t.renderbuffer._renderbuffer;de(o.width===e&&o.height===r,\"inconsistent width/height for renderbuffer\"),o.refCount+=1}}function u(e,r){r&&(r.texture?t.framebufferTexture2D(kn,e,r.target,r.texture._texture.texture,0):t.framebufferRenderbuffer(kn,e,An,r.renderbuffer._renderbuffer.renderbuffer))}function c(t){var e=Tn,r=null,n=null,i=t;\"object\"==typeof t&&(i=t.data,\"target\"in t&&(e=0|t.target)),de.type(i,\"function\",\"invalid attachment data\");var a=i._reglType;return\"texture2d\"===a?(r=i,de(e===Tn)):\"textureCube\"===a?(r=i,de(e>=Sn&&e<Sn+6,\"invalid cube map target\")):\"renderbuffer\"===a?(n=i,e=An):de.raise(\"invalid regl object for attachment\"),new o(e,r,n)}function h(t,e,r,a,s){if(r){var l=n.create2D({width:t,height:e,format:a,type:s});return l._texture.refCount=0,new o(Tn,l,null)}var u=i.create({width:t,height:e,format:a});return u._renderbuffer.refCount=0,new o(An,null,u)}function f(t){return t&&(t.texture||t.renderbuffer)}function d(t,e,r){t&&(t.texture?t.texture.resize(e,r):t.renderbuffer&&t.renderbuffer.resize(e,r))}function p(){this.id=A++,T[this.id]=this,this.framebuffer=t.createFramebuffer(),this.width=0,this.height=0,this.colorAttachments=[],this.depthAttachment=null,this.stencilAttachment=null,this.depthStencilAttachment=null}function m(t){t.colorAttachments.forEach(s),s(t.depthAttachment),s(t.stencilAttachment),s(t.depthStencilAttachment)}function v(e){var r=e.framebuffer;de(r,\"must not double destroy framebuffer\"),t.deleteFramebuffer(r),e.framebuffer=null,a.framebufferCount--,delete T[e.id]}function g(e){var n;t.bindFramebuffer(kn,e.framebuffer);var i=e.colorAttachments;for(n=0;n<i.length;++n)u(En+n,i[n]);for(n=i.length;n<r.maxColorAttachments;++n)t.framebufferTexture2D(kn,En+n,Tn,null,0);t.framebufferTexture2D(kn,zn,Tn,null,0),t.framebufferTexture2D(kn,Ln,Tn,null,0),t.framebufferTexture2D(kn,Cn,Tn,null,0),u(Ln,e.depthAttachment),u(Cn,e.stencilAttachment),u(zn,e.depthStencilAttachment);var a=t.checkFramebufferStatus(kn);a!==In&&de.raise(\"framebuffer configuration not supported, status = \"+Un[a]),t.bindFramebuffer(kn,_.next),_.cur=_.next,t.getError()}function y(t,n){function i(t,n){var a;de(_.next!==s,\"can not update framebuffer which is currently in use\");var o=e.webgl_draw_buffers,u=0,d=0,p=!0,v=!0,y=null,b=!0,x=\"rgba\",A=\"uint8\",T=1,S=null,E=null,L=null,C=!1;if(\"number\"==typeof t)u=0|t,d=0|n||u;else if(t){de.type(t,\"object\",\"invalid arguments for framebuffer\");var z=t;if(\"shape\"in z){var I=z.shape;de(Array.isArray(I)&&I.length>=2,\"invalid shape for framebuffer\"),u=I[0],d=I[1]}else\"radius\"in z&&(u=d=z.radius),\"width\"in z&&(u=z.width),\"height\"in z&&(d=z.height);(\"color\"in z||\"colors\"in z)&&(y=z.color||z.colors,Array.isArray(y)&&de(1===y.length||o,\"multiple render targets not supported\")),y||(\"colorCount\"in z&&(T=0|z.colorCount,de(T>0,\"invalid color buffer count\")),\"colorTexture\"in z&&(b=!!z.colorTexture,x=\"rgba4\"),\"colorType\"in z&&(A=z.colorType,b?(de(e.oes_texture_float||!(\"float\"===A||\"float32\"===A),\"you must enable OES_texture_float in order to use floating point framebuffer objects\"),de(e.oes_texture_half_float||!(\"half float\"===A||\"float16\"===A),\"you must enable OES_texture_half_float in order to use 16-bit floating point framebuffer objects\")):\"half float\"===A||\"float16\"===A?(de(e.ext_color_buffer_half_float,\"you must enable EXT_color_buffer_half_float to use 16-bit render buffers\"),x=\"rgba16f\"):\"float\"!==A&&\"float32\"!==A||(de(e.webgl_color_buffer_float,\"you must enable WEBGL_color_buffer_float in order to use 32-bit floating point renderbuffers\"),x=\"rgba32f\"),de.oneOf(A,k,\"invalid color type\")),\"colorFormat\"in z&&(x=z.colorFormat,w.indexOf(x)>=0?b=!0:M.indexOf(x)>=0?b=!1:b?de.oneOf(z.colorFormat,w,\"invalid color format for texture\"):de.oneOf(z.colorFormat,M,\"invalid color format for renderbuffer\"))),(\"depthTexture\"in z||\"depthStencilTexture\"in z)&&(C=!(!z.depthTexture&&!z.depthStencilTexture),de(!C||e.webgl_depth_texture,\"webgl_depth_texture extension not supported\")),\"depth\"in z&&(\"boolean\"==typeof z.depth?p=z.depth:(S=z.depth,v=!1)),\"stencil\"in z&&(\"boolean\"==typeof z.stencil?v=z.stencil:(E=z.stencil,p=!1)),\"depthStencil\"in z&&(\"boolean\"==typeof z.depthStencil?p=v=z.depthStencil:(L=z.depthStencil,p=!1,v=!1))}else u=d=1;var D=null,P=null,O=null,R=null;if(Array.isArray(y))D=y.map(c);else if(y)D=[c(y)];else for(D=new Array(T),a=0;a<T;++a)D[a]=h(u,d,b,x,A);de(e.webgl_draw_buffers||D.length<=1,\"you must enable the WEBGL_draw_buffers extension in order to use multiple color buffers.\"),de(D.length<=r.maxColorAttachments,\"too many color attachments, not supported\"),u=u||D[0].width,d=d||D[0].height,S?P=c(S):p&&!v&&(P=h(u,d,C,\"depth\",\"uint32\")),E?O=c(E):v&&!p&&(O=h(u,d,!1,\"stencil\",\"uint8\")),L?R=c(L):!S&&!E&&v&&p&&(R=h(u,d,C,\"depth stencil\",\"depth stencil\")),de(!!S+!!E+!!L<=1,\"invalid framebuffer configuration, can specify exactly one depth/stencil attachment\");var F=null;for(a=0;a<D.length;++a)if(l(D[a],u,d),de(!D[a]||D[a].texture&&Pn.indexOf(D[a].texture._texture.format)>=0||D[a].renderbuffer&&Bn.indexOf(D[a].renderbuffer._renderbuffer.format)>=0,\"framebuffer color attachment \"+a+\" is invalid\"),D[a]&&D[a].texture){var j=On[D[a].texture._texture.format]*Rn[D[a].texture._texture.type];null===F?F=j:de(F===j,\"all color attachments much have the same number of bits per pixel.\")}return l(P,u,d),de(!P||P.texture&&P.texture._texture.format===Dn||P.renderbuffer&&P.renderbuffer._renderbuffer.format===Fn,\"invalid depth attachment for framebuffer object\"),l(O,u,d),de(!O||O.renderbuffer&&O.renderbuffer._renderbuffer.format===jn,\"invalid stencil attachment for framebuffer object\"),l(R,u,d),de(!R||R.texture&&R.texture._texture.format===Nn||R.renderbuffer&&R.renderbuffer._renderbuffer.format===Nn,\"invalid depth-stencil attachment for framebuffer object\"),m(s),s.width=u,s.height=d,s.colorAttachments=D,s.depthAttachment=P,s.stencilAttachment=O,s.depthStencilAttachment=R,i.color=D.map(f),i.depth=f(P),i.stencil=f(O),i.depthStencil=f(R),i.width=s.width,i.height=s.height,g(s),i}function o(t,e){de(_.next!==s,\"can not resize a framebuffer which is currently in use\");var r=0|t,n=0|e||r;if(r===s.width&&n===s.height)return i;for(var a=s.colorAttachments,o=0;o<a.length;++o)d(a[o],r,n);return d(s.depthAttachment,r,n),d(s.stencilAttachment,r,n),d(s.depthStencilAttachment,r,n),s.width=i.width=r,s.height=i.height=n,g(s),i}var s=new p;return a.framebufferCount++,i(t,n),$t(i,{resize:o,_reglType:\"framebuffer\",_framebuffer:s,destroy:function(){v(s),m(s)},use:function(t){_.setFBO({framebuffer:i},t)}})}function b(t){function i(t){var r;de(o.indexOf(_.next)<0,\"can not update framebuffer which is currently in use\");var a=e.webgl_draw_buffers,s={color:null},l=0,u=null,c=\"rgba\",h=\"uint8\",f=1;if(\"number\"==typeof t)l=0|t;else if(t){de.type(t,\"object\",\"invalid arguments for framebuffer\");var d=t;if(\"shape\"in d){var p=d.shape;de(Array.isArray(p)&&p.length>=2,\"invalid shape for framebuffer\"),de(p[0]===p[1],\"cube framebuffer must be square\"),l=p[0]}else\"radius\"in d&&(l=0|d.radius),\"width\"in d?(l=0|d.width,\"height\"in d&&de(d.height===l,\"must be square\")):\"height\"in d&&(l=0|d.height);(\"color\"in d||\"colors\"in d)&&(u=d.color||d.colors,Array.isArray(u)&&de(1===u.length||a,\"multiple render targets not supported\")),u||(\"colorCount\"in d&&(f=0|d.colorCount,de(f>0,\"invalid color buffer count\")),\"colorType\"in d&&(de.oneOf(d.colorType,k,\"invalid color type\"),h=d.colorType),\"colorFormat\"in d&&(c=d.colorFormat,de.oneOf(d.colorFormat,w,\"invalid color format for texture\"))),\"depth\"in d&&(s.depth=d.depth),\"stencil\"in d&&(s.stencil=d.stencil),\"depthStencil\"in d&&(s.depthStencil=d.depthStencil)}else l=1;var m;if(u)if(Array.isArray(u))for(m=[],r=0;r<u.length;++r)m[r]=u[r];else m=[u];else{m=Array(f);var v={radius:l,format:c,type:h};for(r=0;r<f;++r)m[r]=n.createCube(v)}for(s.color=Array(m.length),r=0;r<m.length;++r){var g=m[r];de(\"function\"==typeof g&&\"textureCube\"===g._reglType,\"invalid cube map\"),l=l||g.width,de(g.width===l&&g.height===l,\"invalid cube map shape\"),s.color[r]={target:Sn,data:m[r]}}for(r=0;r<6;++r){for(var b=0;b<m.length;++b)s.color[b].target=Sn+r;r>0&&(s.depth=o[0].depth,s.stencil=o[0].stencil,s.depthStencil=o[0].depthStencil),o[r]?o[r](s):o[r]=y(s)}return $t(i,{width:l,height:l,color:m})}function a(t){var e,n=0|t;if(de(n>0&&n<=r.maxCubeMapSize,\"invalid radius for cube fbo\"),n===i.width)return i;var a=i.color;for(e=0;e<a.length;++e)a[e].resize(n);for(e=0;e<6;++e)o[e].resize(n);return i.width=i.height=n,i}var o=Array(6);return i(t),$t(i,{faces:o,resize:a,_reglType:\"framebufferCube\",destroy:function(){o.forEach(function(t){t.destroy()})}})}function x(){xe(T).forEach(function(e){e.framebuffer=t.createFramebuffer(),g(e)})}var _={cur:null,next:null,dirty:!1,setFBO:null},w=[\"rgba\"],M=[\"rgba4\",\"rgb565\",\"rgb5 a1\"];e.ext_srgb&&M.push(\"srgba\"),e.ext_color_buffer_half_float&&M.push(\"rgba16f\",\"rgb16f\"),e.webgl_color_buffer_float&&M.push(\"rgba32f\");var k=[\"uint8\"];e.oes_texture_half_float&&k.push(\"half float\",\"float16\"),e.oes_texture_float&&k.push(\"float\",\"float32\");var A=0,T={};return $t(_,{getFramebuffer:function(t){if(\"function\"==typeof t&&\"framebuffer\"===t._reglType){var e=t._framebuffer;if(e instanceof p)return e}return null},create:y,createCube:b,clear:function(){xe(T).forEach(v)},restore:x})}function Pt(){this.state=0,this.x=0,this.y=0,this.z=0,this.w=0,this.buffer=null,this.size=0,this.normalized=!1,this.type=Vn,this.offset=0,this.stride=0,this.divisor=0}function Ot(t,e,r,n,i){for(var a=r.maxAttributes,o=new Array(a),s=0;s<a;++s)o[s]=new Pt;return{Record:Pt,scope:{},state:o}}function Rt(t,e,r,n){function i(t,e,r,n){this.name=t,this.id=e,this.location=r,this.info=n}function a(t,e){for(var r=0;r<t.length;++r)if(t[r].id===e.id)return void(t[r].location=e.location);t.push(e)}function o(r,n,i){var a=r===Hn?c:h,o=a[n];if(!o){var s=e.str(n);o=t.createShader(r),t.shaderSource(o,s),t.compileShader(o),de.shaderError(t,o,s,r,i),a[n]=o}return o}function s(t,e){this.id=p++,this.fragId=t,this.vertId=e,this.program=null,this.uniforms=[],this.attributes=[],n.profile&&(this.stats={uniformsCount:0,attributesCount:0})}function l(r,s){var l,u,c=o(Hn,r.fragId),h=o(qn,r.vertId),f=r.program=t.createProgram();t.attachShader(f,c),t.attachShader(f,h),t.linkProgram(f),de.linkError(t,f,e.str(r.fragId),e.str(r.vertId),s);var d=t.getProgramParameter(f,Gn);n.profile&&(r.stats.uniformsCount=d);var p=r.uniforms;for(l=0;l<d;++l)if(u=t.getActiveUniform(f,l))if(u.size>1)for(var m=0;m<u.size;++m){var v=u.name.replace(\"[0]\",\"[\"+m+\"]\");a(p,new i(v,e.id(v),t.getUniformLocation(f,v),u))}else a(p,new i(u.name,e.id(u.name),t.getUniformLocation(f,u.name),u));var g=t.getProgramParameter(f,Yn);n.profile&&(r.stats.attributesCount=g);var y=r.attributes;for(l=0;l<g;++l)(u=t.getActiveAttrib(f,l))&&a(y,new i(u.name,e.id(u.name),t.getAttribLocation(f,u.name),u))}function u(){c={},h={};for(var t=0;t<d.length;++t)l(d[t])}var c={},h={},f={},d=[],p=0;return n.profile&&(r.getMaxUniformsCount=function(){var t=0;return d.forEach(function(e){e.stats.uniformsCount>t&&(t=e.stats.uniformsCount)}),t},r.getMaxAttributesCount=function(){var t=0;return d.forEach(function(e){e.stats.attributesCount>t&&(t=e.stats.attributesCount)}),t}),{clear:function(){var e=t.deleteShader.bind(t);xe(c).forEach(e),c={},xe(h).forEach(e),h={},d.forEach(function(e){t.deleteProgram(e.program)}),d.length=0,f={},r.shaderCount=0},program:function(t,e,n){de.command(t>=0,\"missing vertex shader\",n),de.command(e>=0,\"missing fragment shader\",n);var i=f[e];i||(i=f[e]={});var a=i[t];return a||(a=new s(e,t),r.shaderCount++,l(a,n),i[t]=a,d.push(a)),a},restore:u,shader:o,frag:-1,vert:-1}}function Ft(t,e,r,n,i,a){function o(o){var s;null===e.next?(de(i.preserveDrawingBuffer,'you must create a webgl context with \"preserveDrawingBuffer\":true in order to read pixels from the drawing buffer'),s=Wn):(de(null!==e.next.colorAttachments[0].texture,\"You cannot read from a renderbuffer\"),s=e.next.colorAttachments[0].texture._texture.type,a.oes_texture_float?de(s===Wn||s===Jn,\"Reading from a framebuffer is only allowed for the types 'uint8' and 'float'\"):de(s===Wn,\"Reading from a framebuffer is only allowed for the type 'uint8'\"));var l=0,u=0,c=n.framebufferWidth,h=n.framebufferHeight,f=null;Qt(o)?f=o:o&&(de.type(o,\"object\",\"invalid arguments to regl.read()\"),l=0|o.x,u=0|o.y,de(l>=0&&l<n.framebufferWidth,\"invalid x offset for regl.read\"),de(u>=0&&u<n.framebufferHeight,\"invalid y offset for regl.read\"),c=0|(o.width||n.framebufferWidth-l),h=0|(o.height||n.framebufferHeight-u),f=o.data||null),f&&(s===Wn?de(f instanceof Uint8Array,\"buffer must be 'Uint8Array' when reading from a framebuffer of type 'uint8'\"):s===Jn&&de(f instanceof Float32Array,\"buffer must be 'Float32Array' when reading from a framebuffer of type 'float'\")),de(c>0&&c+l<=n.framebufferWidth,\"invalid width for read pixels\"),de(h>0&&h+u<=n.framebufferHeight,\"invalid height for read pixels\"),r();var d=c*h*4;return f||(s===Wn?f=new Uint8Array(d):s===Jn&&(f=f||new Float32Array(d))),de.isTypedArray(f,\"data buffer for regl.read() must be a typedarray\"),de(f.byteLength>=d,\"data buffer for regl.read() too small\"),t.pixelStorei(Zn,4),t.readPixels(l,u,c,h,Xn,s,f),f}function s(t){var r;return e.setFBO({framebuffer:t.framebuffer},function(){r=o(t)}),r}function l(t){return t&&\"framebuffer\"in t?s(t):o(t)}return l}function jt(t){return Array.prototype.slice.call(t)}function Nt(t){return jt(t).join(\"\")}function Bt(){function t(t){for(var e=0;e<l.length;++e)if(l[e]===t)return s[e];var r=\"g\"+o++;return s.push(r),l.push(t),r}function e(){function t(){r.push.apply(r,jt(arguments))}function e(){var t=\"v\"+o++;return n.push(t),arguments.length>0&&(r.push(t,\"=\"),r.push.apply(r,jt(arguments)),r.push(\";\")),t}var r=[],n=[];return $t(t,{def:e,toString:function(){return Nt([n.length>0?\"var \"+n+\";\":\"\",Nt(r)])}})}function r(){function t(t,e){\n",
       "n(t,e,\"=\",r.def(t,e),\";\")}var r=e(),n=e(),i=r.toString,a=n.toString;return $t(function(){r.apply(r,jt(arguments))},{def:r.def,entry:r,exit:n,save:t,set:function(e,n,i){t(e,n),r(e,n,\"=\",i,\";\")},toString:function(){return i()+a()}})}function n(){var t=Nt(arguments),e=r(),n=r(),i=e.toString,a=n.toString;return $t(e,{then:function(){return e.apply(e,jt(arguments)),this},else:function(){return n.apply(n,jt(arguments)),this},toString:function(){var e=a();return e&&(e=\"else{\"+e+\"}\"),Nt([\"if(\",t,\"){\",i(),\"}\",e])}})}function i(t,e){function n(){var t=\"a\"+i.length;return i.push(t),t}var i=[];e=e||0;for(var a=0;a<e;++a)n();var o=r(),s=o.toString;return c[t]=$t(o,{arg:n,toString:function(){return Nt([\"function(\",i.join(),\"){\",s(),\"}\"])}})}function a(){var t=['\"use strict\";',u,\"return {\"];Object.keys(c).forEach(function(e){t.push('\"',e,'\":',c[e].toString(),\",\")}),t.push(\"}\");var e=Nt(t).replace(/;/g,\";\\n\").replace(/}/g,\"}\\n\").replace(/{/g,\"{\\n\");return Function.apply(null,s.concat(e)).apply(null,l)}var o=0,s=[],l=[],u=e(),c={};return{global:u,link:t,block:e,proc:i,scope:r,cond:n,compile:a}}function Ut(t){return Array.isArray(t)||Qt(t)||Z(t)}function Vt(t){return t.sort(function(t,e){return t===Ii?-1:e===Ii?1:t<e?-1:1})}function Ht(t,e,r,n){this.thisDep=t,this.contextDep=e,this.propDep=r,this.append=n}function qt(t){return t&&!(t.thisDep||t.contextDep||t.propDep)}function Gt(t){return new Ht(!1,!1,!1,t)}function Yt(t,e){var r=t.type;if(r===ei){var n=t.data.length;return new Ht(!0,n>=1,n>=2,e)}if(r===ai){var i=t.data;return new Ht(i.thisDep,i.contextDep,i.propDep,e)}return new Ht(r===ii,r===ni,r===ri,e)}function Xt(t,e,r,n,i,a,o,s,l,u,c,h,f,d,p){function m(t){return t.replace(\".\",\"_\")}function v(t,e,r){var n=m(t);et.push(t),tt[n]=$[n]=!!r,rt[n]=e}function g(t,e,r){var n=m(t);et.push(t),Array.isArray(r)?($[n]=r.slice(),tt[n]=r.slice()):$[n]=tt[n]=r,nt[n]=e}function y(){var t=Bt(),r=t.link,n=t.global;t.id=ot++,t.batchId=\"0\";var i=r(it),a=t.shared={props:\"a0\"};Object.keys(it).forEach(function(t){a[t]=n.def(i,\".\",t)}),de.optional(function(){t.CHECK=r(de),t.commandStr=de.guessCommand(),t.command=r(t.commandStr),t.assert=function(t,e,n){t(\"if(!(\",e,\"))\",this.CHECK,\".commandRaise(\",r(n),\",\",this.command,\");\")},at.invalidBlendCombinations=Ua});var o=t.next={},s=t.current={};Object.keys(nt).forEach(function(t){Array.isArray($[t])&&(o[t]=n.def(a.next,\".\",t),s[t]=n.def(a.current,\".\",t))});var l=t.constants={};Object.keys(at).forEach(function(t){l[t]=n.def(JSON.stringify(at[t]))}),t.invoke=function(e,n){switch(n.type){case ei:var i=[\"this\",a.context,a.props,t.batchId];return e.def(r(n.data),\".call(\",i.slice(0,Math.max(n.data.length+1,4)),\")\");case ri:return e.def(a.props,n.data);case ni:return e.def(a.context,n.data);case ii:return e.def(\"this\",n.data);case ai:return n.data.append(t,e),n.data.ref}},t.attribCache={};var c={};return t.scopeAttrib=function(t){var n=e.id(t);if(n in c)return c[n];var i=u.scope[n];return i||(i=u.scope[n]=new W),c[n]=r(i)},t}function b(t){var e,r=t.static,n=t.dynamic;if(Di in r){var i=!!r[Di];e=Gt(function(t,e){return i}),e.enable=i}else if(Di in n){var a=n[Di];e=Yt(a,function(t,e){return t.invoke(e,a)})}return e}function x(t,e){var r=t.static,n=t.dynamic;if(Pi in r){var i=r[Pi];return i?(i=s.getFramebuffer(i),de.command(i,\"invalid framebuffer object\"),Gt(function(t,e){var r=t.link(i),n=t.shared;e.set(n.framebuffer,\".next\",r);var a=n.context;return e.set(a,\".\"+Vi,r+\".width\"),e.set(a,\".\"+Hi,r+\".height\"),r})):Gt(function(t,e){var r=t.shared;e.set(r.framebuffer,\".next\",\"null\");var n=r.context;return e.set(n,\".\"+Vi,n+\".\"+Yi),e.set(n,\".\"+Hi,n+\".\"+Xi),\"null\"})}if(Pi in n){var a=n[Pi];return Yt(a,function(t,e){var r=t.invoke(e,a),n=t.shared,i=n.framebuffer,o=e.def(i,\".getFramebuffer(\",r,\")\");de.optional(function(){t.assert(e,\"!\"+r+\"||\"+o,\"invalid framebuffer object\")}),e.set(i,\".next\",o);var s=n.context;return e.set(s,\".\"+Vi,o+\"?\"+o+\".width:\"+s+\".\"+Yi),e.set(s,\".\"+Hi,o+\"?\"+o+\".height:\"+s+\".\"+Xi),o})}return null}function _(t,e,r){function n(t){if(t in i){var n=i[t];de.commandType(n,\"object\",\"invalid \"+t,r.commandStr);var o,s,l=!0,u=0|n.x,c=0|n.y;return\"width\"in n?(o=0|n.width,de.command(o>=0,\"invalid \"+t,r.commandStr)):l=!1,\"height\"in n?(s=0|n.height,de.command(s>=0,\"invalid \"+t,r.commandStr)):l=!1,new Ht(!l&&e&&e.thisDep,!l&&e&&e.contextDep,!l&&e&&e.propDep,function(t,e){var r=t.shared.context,i=o;\"width\"in n||(i=e.def(r,\".\",Vi,\"-\",u));var a=s;return\"height\"in n||(a=e.def(r,\".\",Hi,\"-\",c)),[u,c,i,a]})}if(t in a){var h=a[t],f=Yt(h,function(e,r){var n=e.invoke(r,h);de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)});var i=e.shared.context,a=r.def(n,\".x|0\"),o=r.def(n,\".y|0\"),s=r.def('\"width\" in ',n,\"?\",n,\".width|0:\",\"(\",i,\".\",Vi,\"-\",a,\")\"),l=r.def('\"height\" in ',n,\"?\",n,\".height|0:\",\"(\",i,\".\",Hi,\"-\",o,\")\");return de.optional(function(){e.assert(r,s+\">=0&&\"+l+\">=0\",\"invalid \"+t)}),[a,o,s,l]});return e&&(f.thisDep=f.thisDep||e.thisDep,f.contextDep=f.contextDep||e.contextDep,f.propDep=f.propDep||e.propDep),f}return e?new Ht(e.thisDep,e.contextDep,e.propDep,function(t,e){var r=t.shared.context;return[0,0,e.def(r,\".\",Vi),e.def(r,\".\",Hi)]}):null}var i=t.static,a=t.dynamic,o=n(Ii);if(o){var s=o;o=new Ht(o.thisDep,o.contextDep,o.propDep,function(t,e){var r=s.append(t,e),n=t.shared.context;return e.set(n,\".\"+qi,r[2]),e.set(n,\".\"+Gi,r[3]),r})}return{viewport:o,scissor_box:n(zi)}}function w(t){function r(t){if(t in i){var r=e.id(i[t]);de.optional(function(){c.shader(qa[t],r,de.guessCommand())});var n=Gt(function(){return r});return n.id=r,n}if(t in a){var o=a[t];return Yt(o,function(e,r){var n=e.invoke(r,o),i=r.def(e.shared.strings,\".id(\",n,\")\");return de.optional(function(){r(e.shared.shader,\".shader(\",qa[t],\",\",i,\",\",e.command,\");\")}),i})}return null}var n,i=t.static,a=t.dynamic,o=r(Ri),s=r(Oi),l=null;return qt(o)&&qt(s)?(l=c.program(s.id,o.id),n=Gt(function(t,e){return t.link(l)})):n=new Ht(o&&o.thisDep||s&&s.thisDep,o&&o.contextDep||s&&s.contextDep,o&&o.propDep||s&&s.propDep,function(t,e){var r,n=t.shared.shader;r=o?o.append(t,e):e.def(n,\".\",Ri);var i;i=s?s.append(t,e):e.def(n,\".\",Oi);var a=n+\".program(\"+i+\",\"+r;return de.optional(function(){a+=\",\"+t.command}),e.def(a+\")\")}),{frag:o,vert:s,progVar:n,program:l}}function M(t,e){function r(t,r){if(t in n){var a=0|n[t];return de.command(!r||a>=0,\"invalid \"+t,e.commandStr),Gt(function(t,e){return r&&(t.OFFSET=a),a})}if(t in i){var s=i[t];return Yt(s,function(e,n){var i=e.invoke(n,s);return r&&(e.OFFSET=i,de.optional(function(){e.assert(n,i+\">=0\",\"invalid \"+t)})),i})}return r&&o?Gt(function(t,e){return t.OFFSET=\"0\",0}):null}var n=t.static,i=t.dynamic,o=function(){if(Fi in n){var t=n[Fi];Ut(t)?t=a.getElements(a.create(t,!0)):t&&(t=a.getElements(t),de.command(t,\"invalid elements\",e.commandStr));var r=Gt(function(e,r){if(t){var n=e.link(t);return e.ELEMENTS=n,n}return e.ELEMENTS=null,null});return r.value=t,r}if(Fi in i){var o=i[Fi];return Yt(o,function(t,e){var r=t.shared,n=r.isBufferArgs,i=r.elements,a=t.invoke(e,o),s=e.def(\"null\"),l=e.def(n,\"(\",a,\")\"),u=t.cond(l).then(s,\"=\",i,\".createStream(\",a,\");\").else(s,\"=\",i,\".getElements(\",a,\");\");return de.optional(function(){t.assert(u.else,\"!\"+a+\"||\"+s,\"invalid elements\")}),e.entry(u),e.exit(t.cond(l).then(i,\".destroyStream(\",s,\");\")),t.ELEMENTS=s,s})}return null}(),s=r(Bi,!0);return{elements:o,primitive:function(){if(ji in n){var t=n[ji];return de.commandParameter(t,Be,\"invalid primitve\",e.commandStr),Gt(function(e,r){return Be[t]})}if(ji in i){var r=i[ji];return Yt(r,function(t,e){var n=t.constants.primTypes,i=t.invoke(e,r);return de.optional(function(){t.assert(e,i+\" in \"+n,\"invalid primitive, must be one of \"+Object.keys(Be))}),e.def(n,\"[\",i,\"]\")})}return o?qt(o)?Gt(o.value?function(t,e){return e.def(t.ELEMENTS,\".primType\")}:function(){return Aa}):new Ht(o.thisDep,o.contextDep,o.propDep,function(t,e){var r=t.ELEMENTS;return e.def(r,\"?\",r,\".primType:\",Aa)}):null}(),count:function(){if(Ni in n){var t=0|n[Ni];return de.command(\"number\"==typeof t&&t>=0,\"invalid vertex count\",e.commandStr),Gt(function(){return t})}if(Ni in i){var r=i[Ni];return Yt(r,function(t,e){var n=t.invoke(e,r);return de.optional(function(){t.assert(e,\"typeof \"+n+'===\"number\"&&'+n+\">=0&&\"+n+\"===(\"+n+\"|0)\",\"invalid vertex count\")}),n})}if(o){if(qt(o)){if(o)return s?new Ht(s.thisDep,s.contextDep,s.propDep,function(t,e){var r=e.def(t.ELEMENTS,\".vertCount-\",t.OFFSET);return de.optional(function(){t.assert(e,r+\">=0\",\"invalid vertex offset/element buffer too small\")}),r}):Gt(function(t,e){return e.def(t.ELEMENTS,\".vertCount\")});var a=Gt(function(){return-1});return de.optional(function(){a.MISSING=!0}),a}var l=new Ht(o.thisDep||s.thisDep,o.contextDep||s.contextDep,o.propDep||s.propDep,function(t,e){var r=t.ELEMENTS;return t.OFFSET?e.def(r,\"?\",r,\".vertCount-\",t.OFFSET,\":-1\"):e.def(r,\"?\",r,\".vertCount:-1\")});return de.optional(function(){l.DYNAMIC=!0}),l}return null}(),instances:r(Ui,!1),offset:s}}function k(t,e){var r=t.static,i=t.dynamic,a={};return et.forEach(function(t){function o(e,n){if(t in r){var o=e(r[t]);a[s]=Gt(function(){return o})}else if(t in i){var l=i[t];a[s]=Yt(l,function(t,e){return n(t,e,t.invoke(e,l))})}}var s=m(t);switch(t){case vi:case si:case oi:case Ai:case hi:case Ci:case xi:case wi:case Mi:case pi:return o(function(r){return de.commandType(r,\"boolean\",t,e.commandStr),r},function(e,r,n){return de.optional(function(){e.assert(r,\"typeof \"+n+'===\"boolean\"',\"invalid flag \"+t,e.commandStr)}),n});case fi:return o(function(r){return de.commandParameter(r,Va,\"invalid \"+t,e.commandStr),Va[r]},function(e,r,n){var i=e.constants.compareFuncs;return de.optional(function(){e.assert(r,n+\" in \"+i,\"invalid \"+t+\", must be one of \"+Object.keys(Va))}),r.def(i,\"[\",n,\"]\")});case di:return o(function(t){return de.command(mt(t)&&2===t.length&&\"number\"==typeof t[0]&&\"number\"==typeof t[1]&&t[0]<=t[1],\"depth range is 2d array\",e.commandStr),t},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===2&&typeof \"+r+'[0]===\"number\"&&typeof '+r+'[1]===\"number\"&&'+r+\"[0]<=\"+r+\"[1]\",\"depth range must be a 2d array\")}),[e.def(\"+\",r,\"[0]\"),e.def(\"+\",r,\"[1]\")]});case ci:return o(function(t){de.commandType(t,\"object\",\"blend.func\",e.commandStr);var r=\"srcRGB\"in t?t.srcRGB:t.src,n=\"srcAlpha\"in t?t.srcAlpha:t.src,i=\"dstRGB\"in t?t.dstRGB:t.dst,a=\"dstAlpha\"in t?t.dstAlpha:t.dst;return de.commandParameter(r,Ba,s+\".srcRGB\",e.commandStr),de.commandParameter(n,Ba,s+\".srcAlpha\",e.commandStr),de.commandParameter(i,Ba,s+\".dstRGB\",e.commandStr),de.commandParameter(a,Ba,s+\".dstAlpha\",e.commandStr),de.command(-1===Ua.indexOf(r+\", \"+i),\"unallowed blending combination (srcRGB, dstRGB) = (\"+r+\", \"+i+\")\",e.commandStr),[Ba[r],Ba[i],Ba[n],Ba[a]]},function(e,r,n){function i(i,o){var s=r.def('\"',i,o,'\" in ',n,\"?\",n,\".\",i,o,\":\",n,\".\",i);return de.optional(function(){e.assert(r,s+\" in \"+a,\"invalid \"+t+\".\"+i+o+\", must be one of \"+Object.keys(Ba))}),s}var a=e.constants.blendFuncs;de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid blend func, must be an object\")});var o=i(\"src\",\"RGB\"),s=i(\"dst\",\"RGB\");de.optional(function(){var t=e.constants.invalidBlendCombinations;e.assert(r,t+\".indexOf(\"+o+'+\", \"+'+s+\") === -1 \",\"unallowed blending combination for (srcRGB, dstRGB)\")});var l=r.def(a,\"[\",o,\"]\"),u=r.def(a,\"[\",i(\"src\",\"Alpha\"),\"]\");return[l,r.def(a,\"[\",s,\"]\"),u,r.def(a,\"[\",i(\"dst\",\"Alpha\"),\"]\")]});case ui:return o(function(r){return\"string\"==typeof r?(de.commandParameter(r,Z,\"invalid \"+t,e.commandStr),[Z[r],Z[r]]):\"object\"==typeof r?(de.commandParameter(r.rgb,Z,t+\".rgb\",e.commandStr),de.commandParameter(r.alpha,Z,t+\".alpha\",e.commandStr),[Z[r.rgb],Z[r.alpha]]):void de.commandRaise(\"invalid blend.equation\",e.commandStr)},function(e,r,n){var i=e.constants.blendEquations,a=r.def(),o=r.def(),s=e.cond(\"typeof \",n,'===\"string\"');return de.optional(function(){function r(t,r,n){e.assert(t,n+\" in \"+i,\"invalid \"+r+\", must be one of \"+Object.keys(Z))}r(s.then,t,n),e.assert(s.else,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t),r(s.else,t+\".rgb\",n+\".rgb\"),r(s.else,t+\".alpha\",n+\".alpha\")}),s.then(a,\"=\",o,\"=\",i,\"[\",n,\"];\"),s.else(a,\"=\",i,\"[\",n,\".rgb];\",o,\"=\",i,\"[\",n,\".alpha];\"),r(s),[a,o]});case li:return o(function(t){return de.command(mt(t)&&4===t.length,\"blend.color must be a 4d array\",e.commandStr),J(4,function(e){return+t[e]})},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===4\",\"blend.color must be a 4d array\")}),J(4,function(t){return e.def(\"+\",r,\"[\",t,\"]\")})});case Ti:return o(function(t){return de.commandType(t,\"number\",s,e.commandStr),0|t},function(t,e,r){return de.optional(function(){t.assert(e,\"typeof \"+r+'===\"number\"',\"invalid stencil.mask\")}),e.def(r,\"|0\")});case Si:return o(function(r){de.commandType(r,\"object\",s,e.commandStr);var n=r.cmp||\"keep\",i=r.ref||0,a=\"mask\"in r?r.mask:-1;return de.commandParameter(n,Va,t+\".cmp\",e.commandStr),de.commandType(i,\"number\",t+\".ref\",e.commandStr),de.commandType(a,\"number\",t+\".mask\",e.commandStr),[Va[n],i,a]},function(t,e,r){var n=t.constants.compareFuncs;return de.optional(function(){function i(){t.assert(e,Array.prototype.join.call(arguments,\"\"),\"invalid stencil.func\")}i(r+\"&&typeof \",r,'===\"object\"'),i('!(\"cmp\" in ',r,\")||(\",r,\".cmp in \",n,\")\")}),[e.def('\"cmp\" in ',r,\"?\",n,\"[\",r,\".cmp]\",\":\",Da),e.def(r,\".ref|0\"),e.def('\"mask\" in ',r,\"?\",r,\".mask|0:-1\")]});case Ei:case Li:return o(function(r){de.commandType(r,\"object\",s,e.commandStr);var n=r.fail||\"keep\",i=r.zfail||\"keep\",a=r.zpass||\"keep\";return de.commandParameter(n,Ha,t+\".fail\",e.commandStr),de.commandParameter(i,Ha,t+\".zfail\",e.commandStr),de.commandParameter(a,Ha,t+\".zpass\",e.commandStr),[t===Li?Sa:Ta,Ha[n],Ha[i],Ha[a]]},function(e,r,n){function i(i){return de.optional(function(){e.assert(r,'!(\"'+i+'\" in '+n+\")||(\"+n+\".\"+i+\" in \"+a+\")\",\"invalid \"+t+\".\"+i+\", must be one of \"+Object.keys(Ha))}),r.def('\"',i,'\" in ',n,\"?\",a,\"[\",n,\".\",i,\"]:\",Da)}var a=e.constants.stencilOps;return de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)}),[t===Li?Sa:Ta,i(\"fail\"),i(\"zfail\"),i(\"zpass\")]});case _i:return o(function(t){de.commandType(t,\"object\",s,e.commandStr);var r=0|t.factor,n=0|t.units;return de.commandType(r,\"number\",s+\".factor\",e.commandStr),de.commandType(n,\"number\",s+\".units\",e.commandStr),[r,n]},function(e,r,n){return de.optional(function(){e.assert(r,n+\"&&typeof \"+n+'===\"object\"',\"invalid \"+t)}),[r.def(n,\".factor|0\"),r.def(n,\".units|0\")]});case gi:return o(function(t){var r=0;return\"front\"===t?r=Ta:\"back\"===t&&(r=Sa),de.command(!!r,s,e.commandStr),r},function(t,e,r){return de.optional(function(){t.assert(e,r+'===\"front\"||'+r+'===\"back\"',\"invalid cull.face\")}),e.def(r,'===\"front\"?',Ta,\":\",Sa)});case bi:return o(function(t){return de.command(\"number\"==typeof t&&t>=n.lineWidthDims[0]&&t<=n.lineWidthDims[1],\"invalid line width, must positive number between \"+n.lineWidthDims[0]+\" and \"+n.lineWidthDims[1],e.commandStr),t},function(t,e,r){return de.optional(function(){t.assert(e,\"typeof \"+r+'===\"number\"&&'+r+\">=\"+n.lineWidthDims[0]+\"&&\"+r+\"<=\"+n.lineWidthDims[1],\"invalid line width\")}),r});case yi:return o(function(t){return de.commandParameter(t,Ga,s,e.commandStr),Ga[t]},function(t,e,r){return de.optional(function(){t.assert(e,r+'===\"cw\"||'+r+'===\"ccw\"',\"invalid frontFace, must be one of cw,ccw\")}),e.def(r+'===\"cw\"?'+Ea+\":\"+La)});case mi:return o(function(t){return de.command(mt(t)&&4===t.length,\"color.mask must be length 4 array\",e.commandStr),t.map(function(t){return!!t})},function(t,e,r){return de.optional(function(){t.assert(e,t.shared.isArrayLike+\"(\"+r+\")&&\"+r+\".length===4\",\"invalid color.mask\")}),J(4,function(t){return\"!!\"+r+\"[\"+t+\"]\"})});case ki:return o(function(t){de.command(\"object\"==typeof t&&t,s,e.commandStr);var r=\"value\"in t?t.value:1,n=!!t.invert;return de.command(\"number\"==typeof r&&r>=0&&r<=1,\"sample.coverage.value must be a number between 0 and 1\",e.commandStr),[r,n]},function(t,e,r){return de.optional(function(){t.assert(e,r+\"&&typeof \"+r+'===\"object\"',\"invalid sample.coverage\")}),[e.def('\"value\" in ',r,\"?+\",r,\".value:1\"),e.def(\"!!\",r,\".invert\")]})}}),a}function A(t,e){var r=t.static,n=t.dynamic,i={};return Object.keys(r).forEach(function(t){var n,a=r[t];if(\"number\"==typeof a||\"boolean\"==typeof a)n=Gt(function(){return a});else if(\"function\"==typeof a){var o=a._reglType;\"texture2d\"===o||\"textureCube\"===o?n=Gt(function(t){return t.link(a)}):\"framebuffer\"===o||\"framebufferCube\"===o?(de.command(a.color.length>0,'missing color attachment for framebuffer sent to uniform \"'+t+'\"',e.commandStr),n=Gt(function(t){return t.link(a.color[0])})):de.commandRaise('invalid data for uniform \"'+t+'\"',e.commandStr)}else mt(a)?n=Gt(function(e){return e.global.def(\"[\",J(a.length,function(r){return de.command(\"number\"==typeof a[r]||\"boolean\"==typeof a[r],\"invalid uniform \"+t,e.commandStr),a[r]}),\"]\")}):de.commandRaise('invalid or missing data for uniform \"'+t+'\"',e.commandStr);n.value=a,i[t]=n}),Object.keys(n).forEach(function(t){var e=n[t];i[t]=Yt(e,function(t,r){return t.invoke(r,e)})}),i}function T(t,r){var n=t.static,a=t.dynamic,o={};return Object.keys(n).forEach(function(t){var a=n[t],s=e.id(t),l=new W;if(Ut(a))l.state=$n,l.buffer=i.getBuffer(i.create(a,Zi,!1,!0)),l.type=0;else{var u=i.getBuffer(a);if(u)l.state=$n,l.buffer=u,l.type=0;else if(de.command(\"object\"==typeof a&&a,\"invalid data for attribute \"+t,r.commandStr),a.constant){var c=a.constant;l.buffer=\"null\",l.state=ti,\"number\"==typeof c?l.x=c:(de.command(mt(c)&&c.length>0&&c.length<=4,\"invalid constant for attribute \"+t,r.commandStr),Kn.forEach(function(t,e){e<c.length&&(l[t]=c[e])}))}else{u=Ut(a.buffer)?i.getBuffer(i.create(a.buffer,Zi,!1,!0)):i.getBuffer(a.buffer),de.command(!!u,'missing buffer for attribute \"'+t+'\"',r.commandStr);var h=0|a.offset;de.command(h>=0,'invalid offset for attribute \"'+t+'\"',r.commandStr);var f=0|a.stride;de.command(f>=0&&f<256,'invalid stride for attribute \"'+t+'\", must be integer betweeen [0, 255]',r.commandStr);var d=0|a.size;de.command(!(\"size\"in a)||d>0&&d<=4,'invalid size for attribute \"'+t+'\", must be 1,2,3,4',r.commandStr);var p=!!a.normalized,m=0;\"type\"in a&&(de.commandParameter(a.type,ze,\"invalid type for attribute \"+t,r.commandStr),m=ze[a.type]);var v=0|a.divisor;\"divisor\"in a&&(de.command(0===v||K,'cannot specify divisor for attribute \"'+t+'\", instancing not supported',r.commandStr),de.command(v>=0,'invalid divisor for attribute \"'+t+'\"',r.commandStr)),de.optional(function(){var e=r.commandStr,n=[\"buffer\",\"offset\",\"divisor\",\"normalized\",\"type\",\"size\",\"stride\"];Object.keys(a).forEach(function(r){de.command(n.indexOf(r)>=0,'unknown parameter \"'+r+'\" for attribute pointer \"'+t+'\" (valid parameters are '+n+\")\",e)})}),l.buffer=u,l.state=$n,l.size=d,l.normalized=p,l.type=m||u.dtype,l.offset=h,l.stride=f,l.divisor=v}}o[t]=Gt(function(t,e){var r=t.attribCache;if(s in r)return r[s];var n={isStream:!1};return Object.keys(l).forEach(function(t){n[t]=l[t]}),l.buffer&&(n.buffer=t.link(l.buffer),n.type=n.type||n.buffer+\".dtype\"),r[s]=n,n})}),Object.keys(a).forEach(function(t){function e(e,n){function i(t){n(u[t],\"=\",a,\".\",t,\"|0;\")}var a=e.invoke(n,r),o=e.shared,s=o.isBufferArgs,l=o.buffer;de.optional(function(){e.assert(n,a+\"&&(typeof \"+a+'===\"object\"||typeof '+a+'===\"function\")&&('+s+\"(\"+a+\")||\"+l+\".getBuffer(\"+a+\")||\"+l+\".getBuffer(\"+a+\".buffer)||\"+s+\"(\"+a+'.buffer)||(\"constant\" in '+a+\"&&(typeof \"+a+'.constant===\"number\"||'+o.isArrayLike+\"(\"+a+\".constant))))\",'invalid dynamic attribute \"'+t+'\"')});var u={isStream:n.def(!1)},c=new W;c.state=$n,Object.keys(c).forEach(function(t){u[t]=n.def(\"\"+c[t])});var h=u.buffer,f=u.type;return n(\"if(\",s,\"(\",a,\")){\",u.isStream,\"=true;\",h,\"=\",l,\".createStream(\",Zi,\",\",a,\");\",f,\"=\",h,\".dtype;\",\"}else{\",h,\"=\",l,\".getBuffer(\",a,\");\",\"if(\",h,\"){\",f,\"=\",h,\".dtype;\",'}else if(\"constant\" in ',a,\"){\",u.state,\"=\",ti,\";\",\"if(typeof \"+a+'.constant === \"number\"){',u[Kn[0]],\"=\",a,\".constant;\",Kn.slice(1).map(function(t){return u[t]}).join(\"=\"),\"=0;\",\"}else{\",Kn.map(function(t,e){return u[t]+\"=\"+a+\".constant.length>=\"+e+\"?\"+a+\".constant[\"+e+\"]:0;\"}).join(\"\"),\"}}else{\",\"if(\",s,\"(\",a,\".buffer)){\",h,\"=\",l,\".createStream(\",Zi,\",\",a,\".buffer);\",\"}else{\",h,\"=\",l,\".getBuffer(\",a,\".buffer);\",\"}\",f,'=\"type\" in ',a,\"?\",o.glTypes,\"[\",a,\".type]:\",h,\".dtype;\",u.normalized,\"=!!\",a,\".normalized;\"),i(\"size\"),i(\"offset\"),i(\"stride\"),i(\"divisor\"),n(\"}}\"),n.exit(\"if(\",u.isStream,\"){\",l,\".destroyStream(\",h,\");\",\"}\"),u}var r=a[t];o[t]=Yt(r,e)}),o}function S(t){var e=t.static,r=t.dynamic,n={};return Object.keys(e).forEach(function(t){var r=e[t];n[t]=Gt(function(t,e){return\"number\"==typeof r||\"boolean\"==typeof r?\"\"+r:t.link(r)})}),Object.keys(r).forEach(function(t){var e=r[t];n[t]=Yt(e,function(t,r){return t.invoke(r,e)})}),n}function E(t,e,r,n,i){function a(t){var e=u[t];e&&(h[t]=e)}var o=t.static,s=t.dynamic;de.optional(function(){function t(t){Object.keys(t).forEach(function(t){de.command(e.indexOf(t)>=0,'unknown parameter \"'+t+'\"',i.commandStr)})}var e=[Pi,Oi,Ri,Fi,ji,Bi,Ni,Ui,Di].concat(et);t(o),t(s)});var l=x(t,i),u=_(t,l,i),c=M(t,i),h=k(t,i),f=w(t,i);a(Ii),a(m(zi));var d=Object.keys(h).length>0,p={framebuffer:l,draw:c,shader:f,state:h,dirty:d};return p.profile=b(t,i),p.uniforms=A(r,i),p.attributes=T(e,i),p.context=S(n,i),p}function L(t,e,r){var n=t.shared,i=n.context,a=t.scope();Object.keys(r).forEach(function(n){e.save(i,\".\"+n);var o=r[n];a(i,\".\",n,\"=\",o.append(t,e),\";\")}),e(a)}function C(t,e,r,n){var i,a=t.shared,o=a.gl,s=a.framebuffer;Q&&(i=e.def(a.extensions,\".webgl_draw_buffers\"));var l,u=t.constants,c=u.drawBuffer,h=u.backBuffer;l=r?r.append(t,e):e.def(s,\".next\"),n||e(\"if(\",l,\"!==\",s,\".cur){\"),e(\"if(\",l,\"){\",o,\".bindFramebuffer(\",ja,\",\",l,\".framebuffer);\"),Q&&e(i,\".drawBuffersWEBGL(\",c,\"[\",l,\".colorAttachments.length]);\"),e(\"}else{\",o,\".bindFramebuffer(\",ja,\",null);\"),Q&&e(i,\".drawBuffersWEBGL(\",h,\");\"),e(\"}\",s,\".cur=\",l,\";\"),n||e(\"}\")}function z(t,e,r){var n=t.shared,i=n.gl,a=t.current,o=t.next,s=n.current,l=n.next,u=t.cond(s,\".dirty\");et.forEach(function(e){var n=m(e);if(!(n in r.state)){var c,h;if(n in o){c=o[n],h=a[n];var f=J($[n].length,function(t){return u.def(c,\"[\",t,\"]\")});u(t.cond(f.map(function(t,e){return t+\"!==\"+h+\"[\"+e+\"]\"}).join(\"||\")).then(i,\".\",nt[n],\"(\",f,\");\",f.map(function(t,e){return h+\"[\"+e+\"]=\"+t}).join(\";\"),\";\"))}else{c=u.def(l,\".\",n);var d=t.cond(c,\"!==\",s,\".\",n);u(d),n in rt?d(t.cond(c).then(i,\".enable(\",rt[n],\");\").else(i,\".disable(\",rt[n],\");\"),s,\".\",n,\"=\",c,\";\"):d(i,\".\",nt[n],\"(\",c,\");\",s,\".\",n,\"=\",c,\";\")}}}),0===Object.keys(r.state).length&&u(s,\".dirty=false;\"),e(u)}function I(t,e,r,n){var i=t.shared,a=t.current,o=i.current,s=i.gl;Vt(Object.keys(r)).forEach(function(i){var l=r[i];if(!n||n(l)){var u=l.append(t,e);if(rt[i]){var c=rt[i];qt(l)?u?e(s,\".enable(\",c,\");\"):e(s,\".disable(\",c,\");\"):e(t.cond(u).then(s,\".enable(\",c,\");\").else(s,\".disable(\",c,\");\")),e(o,\".\",i,\"=\",u,\";\")}else if(mt(u)){var h=a[i];e(s,\".\",nt[i],\"(\",u,\");\",u.map(function(t,e){return h+\"[\"+e+\"]=\"+t}).join(\";\"),\";\")}else e(s,\".\",nt[i],\"(\",u,\");\",o,\".\",i,\"=\",u,\";\")}})}function D(t,e){K&&(t.instancing=e.def(t.shared.extensions,\".angle_instanced_arrays\"))}function P(t,e,r,n,i){function a(){return\"undefined\"==typeof performance?\"Date.now()\":\"performance.now()\"}function o(t){u=e.def(),t(u,\"=\",a(),\";\"),\"string\"==typeof i?t(p,\".count+=\",i,\";\"):t(p,\".count++;\"),d&&(n?(c=e.def(),t(c,\"=\",v,\".getNumPendingQueries();\")):t(v,\".beginQuery(\",p,\");\"))}function s(t){t(p,\".cpuTime+=\",a(),\"-\",u,\";\"),d&&(n?t(v,\".pushScopeStats(\",c,\",\",v,\".getNumPendingQueries(),\",p,\");\"):t(v,\".endQuery();\"))}function l(t){var r=e.def(m,\".profile\");e(m,\".profile=\",t,\";\"),e.exit(m,\".profile=\",r,\";\")}var u,c,h,f=t.shared,p=t.stats,m=f.current,v=f.timer,g=r.profile;if(g){if(qt(g))return void(g.enable?(o(e),s(e.exit),l(\"true\")):l(\"false\"));h=g.append(t,e),l(h)}else h=e.def(m,\".profile\");var y=t.block();o(y),e(\"if(\",h,\"){\",y,\"}\");var b=t.block();s(b),e.exit(\"if(\",h,\"){\",b,\"}\")}function O(t,e,r,n,i){function a(t){switch(t){case ua:case da:case ga:return 2;case ca:case pa:case ya:return 3;case ha:case ma:case ba:return 4;default:return 1}}function o(r,n,i){function a(){e(\"if(!\",c,\".buffer){\",l,\".enableVertexAttribArray(\",u,\");}\");var r,a=i.type;if(r=i.size?e.def(i.size,\"||\",n):n,e(\"if(\",c,\".type!==\",a,\"||\",c,\".size!==\",r,\"||\",p.map(function(t){return c+\".\"+t+\"!==\"+i[t]}).join(\"||\"),\"){\",l,\".bindBuffer(\",Zi,\",\",f,\".buffer);\",l,\".vertexAttribPointer(\",[u,r,a,i.normalized,i.stride,i.offset],\");\",c,\".type=\",a,\";\",c,\".size=\",r,\";\",p.map(function(t){return c+\".\"+t+\"=\"+i[t]+\";\"}).join(\"\"),\"}\"),K){var o=i.divisor;e(\"if(\",c,\".divisor!==\",o,\"){\",t.instancing,\".vertexAttribDivisorANGLE(\",[u,o],\");\",c,\".divisor=\",o,\";}\")}}function o(){e(\"if(\",c,\".buffer){\",l,\".disableVertexAttribArray(\",u,\");\",\"}if(\",Kn.map(function(t,e){return c+\".\"+t+\"!==\"+d[e]}).join(\"||\"),\"){\",l,\".vertexAttrib4f(\",u,\",\",d,\");\",Kn.map(function(t,e){return c+\".\"+t+\"=\"+d[e]+\";\"}).join(\"\"),\"}\")}var l=s.gl,u=e.def(r,\".location\"),c=e.def(s.attributes,\"[\",u,\"]\"),h=i.state,f=i.buffer,d=[i.x,i.y,i.z,i.w],p=[\"buffer\",\"normalized\",\"offset\",\"stride\"];h===$n?a():h===ti?o():(e(\"if(\",h,\"===\",$n,\"){\"),a(),e(\"}else{\"),o(),e(\"}\"))}var s=t.shared;n.forEach(function(n){var s,l=n.name,u=r.attributes[l];if(u){if(!i(u))return;s=u.append(t,e)}else{if(!i(Ya))return;var c=t.scopeAttrib(l);de.optional(function(){t.assert(e,c+\".state\",\"missing attribute \"+l)}),s={},Object.keys(new W).forEach(function(t){s[t]=e.def(c,\".\",t)})}o(t.link(n),a(n.info.type),s)})}function R(t,r,n,i,a){for(var o,s=t.shared,l=s.gl,u=0;u<i.length;++u){var c,h=i[u],f=h.name,d=h.info.type,p=n.uniforms[f],m=t.link(h),v=m+\".location\";if(p){if(!a(p))continue;if(qt(p)){var g=p.value;if(de.command(null!==g&&void 0!==g,'missing uniform \"'+f+'\"',t.commandStr),d===Ma||d===ka){de.command(\"function\"==typeof g&&(d===Ma&&(\"texture2d\"===g._reglType||\"framebuffer\"===g._reglType)||d===ka&&(\"textureCube\"===g._reglType||\"framebufferCube\"===g._reglType)),\"invalid texture for uniform \"+f,t.commandStr);var y=t.link(g._texture||g.color[0]._texture);r(l,\".uniform1i(\",v,\",\",y+\".bind());\"),r.exit(y,\".unbind();\")}else if(d===xa||d===_a||d===wa){de.optional(function(){de.command(mt(g),\"invalid matrix for uniform \"+f,t.commandStr),de.command(d===xa&&4===g.length||d===_a&&9===g.length||d===wa&&16===g.length,\"invalid length for matrix uniform \"+f,t.commandStr)});var b=t.global.def(\"new Float32Array([\"+Array.prototype.slice.call(g)+\"])\"),x=2;d===_a?x=3:d===wa&&(x=4),r(l,\".uniformMatrix\",x,\"fv(\",v,\",false,\",b,\");\")}else{switch(d){case la:de.commandType(g,\"number\",\"uniform \"+f,t.commandStr),o=\"1f\";break;case ua:de.command(mt(g)&&2===g.length,\"uniform \"+f,t.commandStr),o=\"2f\";break;case ca:de.command(mt(g)&&3===g.length,\"uniform \"+f,t.commandStr),o=\"3f\";break;case ha:de.command(mt(g)&&4===g.length,\"uniform \"+f,t.commandStr),o=\"4f\";break;case va:de.commandType(g,\"boolean\",\"uniform \"+f,t.commandStr),o=\"1i\";break;case fa:de.commandType(g,\"number\",\"uniform \"+f,t.commandStr),o=\"1i\";break;case ga:case da:de.command(mt(g)&&2===g.length,\"uniform \"+f,t.commandStr),o=\"2i\";break;case ya:case pa:de.command(mt(g)&&3===g.length,\"uniform \"+f,t.commandStr),o=\"3i\";break;case ba:case ma:de.command(mt(g)&&4===g.length,\"uniform \"+f,t.commandStr),o=\"4i\"}r(l,\".uniform\",o,\"(\",v,\",\",mt(g)?Array.prototype.slice.call(g):g,\");\")}continue}c=p.append(t,r)}else{if(!a(Ya))continue;c=r.def(s.uniforms,\"[\",e.id(f),\"]\")}d===Ma?r(\"if(\",c,\"&&\",c,'._reglType===\"framebuffer\"){',c,\"=\",c,\".color[0];\",\"}\"):d===ka&&r(\"if(\",c,\"&&\",c,'._reglType===\"framebufferCube\"){',c,\"=\",c,\".color[0];\",\"}\"),de.optional(function(){function e(e,n){t.assert(r,e,'bad data or missing for uniform \"'+f+'\".  '+n)}function n(t){e(\"typeof \"+c+'===\"'+t+'\"',\"invalid type, expected \"+t)}function i(r,n){e(s.isArrayLike+\"(\"+c+\")&&\"+c+\".length===\"+r,\"invalid vector, should have length \"+r,t.commandStr)}function a(r){e(\"typeof \"+c+'===\"function\"&&'+c+'._reglType===\"texture'+(r===Ki?\"2d\":\"Cube\")+'\"',\"invalid texture type\",t.commandStr)}switch(d){case fa:n(\"number\");break;case da:i(2,\"number\");break;case pa:i(3,\"number\");break;case ma:i(4,\"number\");break;case la:n(\"number\");break;case ua:i(2,\"number\");break;case ca:i(3,\"number\");break;case ha:i(4,\"number\");break;case va:n(\"boolean\");break;case ga:i(2,\"boolean\");break;case ya:i(3,\"boolean\");break;case ba:i(4,\"boolean\");break;case xa:i(4,\"number\");break;case _a:i(9,\"number\");break;case wa:i(16,\"number\");break;case Ma:a(Ki);break;case ka:a(Qi)}});var _=1;switch(d){case Ma:case ka:var w=r.def(c,\"._texture\");r(l,\".uniform1i(\",v,\",\",w,\".bind());\"),r.exit(w,\".unbind();\");continue;case fa:case va:o=\"1i\";break;case da:case ga:o=\"2i\",_=2;break;case pa:case ya:o=\"3i\",_=3;break;case ma:case ba:o=\"4i\",_=4;break;case la:o=\"1f\";break;case ua:o=\"2f\",_=2;break;case ca:o=\"3f\",_=3;break;case ha:o=\"4f\",_=4;break;case xa:o=\"Matrix2fv\";break;case _a:o=\"Matrix3fv\";break;case wa:o=\"Matrix4fv\"}if(r(l,\".uniform\",o,\"(\",v,\",\"),\"M\"===o.charAt(0)){var M=Math.pow(d-xa+2,2),k=t.global.def(\"new Float32Array(\",M,\")\");r(\"false,(Array.isArray(\",c,\")||\",c,\" instanceof Float32Array)?\",c,\":(\",J(M,function(t){return k+\"[\"+t+\"]=\"+c+\"[\"+t+\"]\"}),\",\",k,\")\")}else r(_>1?J(_,function(t){return c+\"[\"+t+\"]\"}):c);r(\");\")}}function F(t,e,r,n){function i(i){var a=c[i];return a?a.contextDep&&n.contextDynamic||a.propDep?a.append(t,r):a.append(t,e):e.def(u,\".\",i)}function a(){function t(){r(v,\".drawElementsInstancedANGLE(\",[f,p,g,d+\"<<((\"+g+\"-\"+Qn+\")>>1)\",m],\");\")}function e(){r(v,\".drawArraysInstancedANGLE(\",[f,d,p,m],\");\")}h?y?t():(r(\"if(\",h,\"){\"),t(),r(\"}else{\"),e(),r(\"}\")):e()}function o(){function t(){r(l+\".drawElements(\"+[f,p,g,d+\"<<((\"+g+\"-\"+Qn+\")>>1)\"]+\");\")}function e(){r(l+\".drawArrays(\"+[f,d,p]+\");\")}h?y?t():(r(\"if(\",h,\"){\"),t(),r(\"}else{\"),e(),r(\"}\")):e()}var s=t.shared,l=s.gl,u=s.draw,c=n.draw,h=function(){var i,a=c.elements,o=e;return a?((a.contextDep&&n.contextDynamic||a.propDep)&&(o=r),i=a.append(t,o)):i=o.def(u,\".\",Fi),i&&o(\"if(\"+i+\")\"+l+\".bindBuffer(\"+Ji+\",\"+i+\".buffer.buffer);\"),i}(),f=i(ji),d=i(Bi),p=function(){var i,a=c.count,o=e;return a?((a.contextDep&&n.contextDynamic||a.propDep)&&(o=r),i=a.append(t,o),de.optional(function(){a.MISSING&&t.assert(e,\"false\",\"missing vertex count\"),a.DYNAMIC&&t.assert(o,i+\">=0\",\"missing vertex count\")})):(i=o.def(u,\".\",Ni),de.optional(function(){t.assert(o,i+\">=0\",\"missing vertex count\")})),i}();if(\"number\"==typeof p){if(0===p)return}else r(\"if(\",p,\"){\"),r.exit(\"}\");var m,v;K&&(m=i(Ui),v=t.instancing);var g=h+\".type\",y=c.elements&&qt(c.elements);K&&(\"number\"!=typeof m||m>=0)?\"string\"==typeof m?(r(\"if(\",m,\">0){\"),a(),r(\"}else if(\",m,\"<0){\"),o(),r(\"}\")):a():o()}function j(t,e,r,n,i){var a=y(),o=a.proc(\"body\",i);return de.optional(function(){a.commandStr=e.commandStr,a.command=a.link(e.commandStr)}),K&&(a.instancing=o.def(a.shared.extensions,\".angle_instanced_arrays\")),t(a,o,r,n),a.compile().body}function N(t,e,r,n){D(t,e),O(t,e,r,n.attributes,function(){return!0}),R(t,e,r,n.uniforms,function(){return!0}),F(t,e,e,r)}function B(t,e){var r=t.proc(\"draw\",1);D(t,r),L(t,r,e.context),C(t,r,e.framebuffer),z(t,r,e),I(t,r,e.state),P(t,r,e,!1,!0);var n=e.shader.progVar.append(t,r);if(r(t.shared.gl,\".useProgram(\",n,\".program);\"),e.shader.program)N(t,r,e,e.shader.program);else{var i=t.global.def(\"{}\"),a=r.def(n,\".id\"),o=r.def(i,\"[\",a,\"]\");r(t.cond(o).then(o,\".call(this,a0);\").else(o,\"=\",i,\"[\",a,\"]=\",t.link(function(r){return j(N,t,e,r,1)}),\"(\",n,\");\",o,\".call(this,a0);\"))}Object.keys(e.state).length>0&&r(t.shared.current,\".dirty=true;\")}function U(t,e,r,n){function i(){return!0}t.batchId=\"a1\",D(t,e),O(t,e,r,n.attributes,i),R(t,e,r,n.uniforms,i),F(t,e,e,r)}function V(t,e,r,n){function i(t){return t.contextDep&&o||t.propDep}function a(t){return!i(t)}D(t,e);var o=r.contextDep,s=e.def(),l=e.def();t.shared.props=l,t.batchId=s;var u=t.scope(),c=t.scope();if(e(u.entry,\"for(\",s,\"=0;\",s,\"<\",\"a1\",\";++\",s,\"){\",l,\"=\",\"a0\",\"[\",s,\"];\",c,\"}\",u.exit),r.needsContext&&L(t,c,r.context),r.needsFramebuffer&&C(t,c,r.framebuffer),I(t,c,r.state,i),\n",
       "r.profile&&i(r.profile)&&P(t,c,r,!1,!0),n)O(t,u,r,n.attributes,a),O(t,c,r,n.attributes,i),R(t,u,r,n.uniforms,a),R(t,c,r,n.uniforms,i),F(t,u,c,r);else{var h=t.global.def(\"{}\"),f=r.shader.progVar.append(t,c),d=c.def(f,\".id\"),p=c.def(h,\"[\",d,\"]\");c(t.shared.gl,\".useProgram(\",f,\".program);\",\"if(!\",p,\"){\",p,\"=\",h,\"[\",d,\"]=\",t.link(function(e){return j(U,t,r,e,2)}),\"(\",f,\");}\",p,\".call(this,a0[\",s,\"],\",s,\");\")}}function H(t,e){function r(t){return t.contextDep&&i||t.propDep}var n=t.proc(\"batch\",2);t.batchId=\"0\",D(t,n);var i=!1,a=!0;Object.keys(e.context).forEach(function(t){i=i||e.context[t].propDep}),i||(L(t,n,e.context),a=!1);var o=e.framebuffer,s=!1;o?(o.propDep?i=s=!0:o.contextDep&&i&&(s=!0),s||C(t,n,o)):C(t,n,null),e.state.viewport&&e.state.viewport.propDep&&(i=!0),z(t,n,e),I(t,n,e.state,function(t){return!r(t)}),e.profile&&r(e.profile)||P(t,n,e,!1,\"a1\"),e.contextDep=i,e.needsContext=a,e.needsFramebuffer=s;var l=e.shader.progVar;if(l.contextDep&&i||l.propDep)V(t,n,e,null);else{var u=l.append(t,n);if(n(t.shared.gl,\".useProgram(\",u,\".program);\"),e.shader.program)V(t,n,e,e.shader.program);else{var c=t.global.def(\"{}\"),h=n.def(u,\".id\"),f=n.def(c,\"[\",h,\"]\");n(t.cond(f).then(f,\".call(this,a0,a1);\").else(f,\"=\",c,\"[\",h,\"]=\",t.link(function(r){return j(V,t,e,r,2)}),\"(\",u,\");\",f,\".call(this,a0,a1);\"))}}Object.keys(e.state).length>0&&n(t.shared.current,\".dirty=true;\")}function q(t,r){function n(e){var n=r.shader[e];n&&i.set(a.shader,\".\"+e,n.append(t,i))}var i=t.proc(\"scope\",3);t.batchId=\"a2\";var a=t.shared,o=a.current;L(t,i,r.context),r.framebuffer&&r.framebuffer.append(t,i),Vt(Object.keys(r.state)).forEach(function(e){var n=r.state[e],o=n.append(t,i);mt(o)?o.forEach(function(r,n){i.set(t.next[e],\"[\"+n+\"]\",r)}):i.set(a.next,\".\"+e,o)}),P(t,i,r,!0,!0),[Fi,Bi,Ni,Ui,ji].forEach(function(e){var n=r.draw[e];n&&i.set(a.draw,\".\"+e,\"\"+n.append(t,i))}),Object.keys(r.uniforms).forEach(function(n){i.set(a.uniforms,\"[\"+e.id(n)+\"]\",r.uniforms[n].append(t,i))}),Object.keys(r.attributes).forEach(function(e){var n=r.attributes[e].append(t,i),a=t.scopeAttrib(e);Object.keys(new W).forEach(function(t){i.set(a,\".\"+t,n[t])})}),n(Oi),n(Ri),Object.keys(r.state).length>0&&(i(o,\".dirty=true;\"),i.exit(o,\".dirty=true;\")),i(\"a1(\",t.shared.context,\",a0,\",t.batchId,\");\")}function G(t){if(\"object\"==typeof t&&!mt(t)){for(var e=Object.keys(t),r=0;r<e.length;++r)if(ve.isDynamic(t[e[r]]))return!0;return!1}}function Y(t,e,r){function n(t,e){o.forEach(function(r){var n=i[r];if(ve.isDynamic(n)){var a=t.invoke(e,n);e(c,\".\",r,\"=\",a,\";\")}})}var i=e.static[r];if(i&&G(i)){var a=t.global,o=Object.keys(i),s=!1,l=!1,u=!1,c=t.global.def(\"{}\");o.forEach(function(e){var r=i[e];if(ve.isDynamic(r)){\"function\"==typeof r&&(r=i[e]=ve.unbox(r));var n=Yt(r,null);s=s||n.thisDep,u=u||n.propDep,l=l||n.contextDep}else{switch(a(c,\".\",e,\"=\"),typeof r){case\"number\":a(r);break;case\"string\":a('\"',r,'\"');break;case\"object\":Array.isArray(r)&&a(\"[\",r.join(),\"]\");break;default:a(t.link(r))}a(\";\")}}),e.dynamic[r]=new ve.DynamicVariable(ai,{thisDep:s,contextDep:l,propDep:u,ref:c,append:n}),delete e.static[r]}}function X(t,e,r,n,i){var a=y();a.stats=a.link(i),Object.keys(e.static).forEach(function(t){Y(a,e,t)}),Wi.forEach(function(e){Y(a,t,e)});var o=E(t,e,r,n,a);return B(a,o),q(a,o),H(a,o),a.compile()}var W=u.Record,Z={add:32774,subtract:32778,\"reverse subtract\":32779};r.ext_blend_minmax&&(Z.min=Ca,Z.max=za);var K=r.angle_instanced_arrays,Q=r.webgl_draw_buffers,$={dirty:!0,profile:p.profile},tt={},et=[],rt={},nt={};v(oi,ea),v(si,ta),g(li,\"blendColor\",[0,0,0,0]),g(ui,\"blendEquationSeparate\",[Ra,Ra]),g(ci,\"blendFuncSeparate\",[Oa,Pa,Oa,Pa]),v(hi,na,!0),g(fi,\"depthFunc\",Fa),g(di,\"depthRange\",[0,1]),g(pi,\"depthMask\",!0),g(mi,mi,[!0,!0,!0,!0]),v(vi,$i),g(gi,\"cullFace\",Sa),g(yi,yi,La),g(bi,bi,1),v(xi,aa),g(_i,\"polygonOffset\",[0,0]),v(wi,oa),v(Mi,sa),g(ki,\"sampleCoverage\",[1,!1]),v(Ai,ra),g(Ti,\"stencilMask\",-1),g(Si,\"stencilFunc\",[Ia,0,-1]),g(Ei,\"stencilOpSeparate\",[Ta,Da,Da,Da]),g(Li,\"stencilOpSeparate\",[Sa,Da,Da,Da]),v(Ci,ia),g(zi,\"scissor\",[0,0,t.drawingBufferWidth,t.drawingBufferHeight]),g(Ii,Ii,[0,0,t.drawingBufferWidth,t.drawingBufferHeight]);var it={gl:t,context:f,strings:e,next:tt,current:$,draw:h,elements:a,buffer:i,shader:c,attributes:u.state,uniforms:l,framebuffer:s,extensions:r,timer:d,isBufferArgs:Ut},at={primTypes:Be,compareFuncs:Va,blendFuncs:Ba,blendEquations:Z,stencilOps:Ha,glTypes:ze,orientationType:Ga};de.optional(function(){it.isArrayLike=mt}),Q&&(at.backBuffer=[Sa],at.drawBuffer=J(n.maxDrawbuffers,function(t){return 0===t?[0]:J(t,function(t){return Na+t})}));var ot=0;return{next:tt,current:$,procs:function(){var e=y(),r=e.proc(\"poll\"),i=e.proc(\"refresh\"),a=e.block();r(a),i(a);var o=e.shared,s=o.gl,l=o.next,u=o.current;a(u,\".dirty=false;\"),C(e,r),C(e,i,null,!0);var c,h=t.getExtension(\"angle_instanced_arrays\");h&&(c=e.link(h));for(var f=0;f<n.maxAttributes;++f){var d=i.def(o.attributes,\"[\",f,\"]\"),p=e.cond(d,\".buffer\");p.then(s,\".enableVertexAttribArray(\",f,\");\",s,\".bindBuffer(\",Zi,\",\",d,\".buffer.buffer);\",s,\".vertexAttribPointer(\",f,\",\",d,\".size,\",d,\".type,\",d,\".normalized,\",d,\".stride,\",d,\".offset);\").else(s,\".disableVertexAttribArray(\",f,\");\",s,\".vertexAttrib4f(\",f,\",\",d,\".x,\",d,\".y,\",d,\".z,\",d,\".w);\",d,\".buffer=null;\"),i(p),h&&i(c,\".vertexAttribDivisorANGLE(\",f,\",\",d,\".divisor);\")}return Object.keys(rt).forEach(function(t){var n=rt[t],o=a.def(l,\".\",t),c=e.block();c(\"if(\",o,\"){\",s,\".enable(\",n,\")}else{\",s,\".disable(\",n,\")}\",u,\".\",t,\"=\",o,\";\"),i(c),r(\"if(\",o,\"!==\",u,\".\",t,\"){\",c,\"}\")}),Object.keys(nt).forEach(function(t){var n,o,c=nt[t],h=$[t],f=e.block();if(f(s,\".\",c,\"(\"),mt(h)){var d=h.length;n=e.global.def(l,\".\",t),o=e.global.def(u,\".\",t),f(J(d,function(t){return n+\"[\"+t+\"]\"}),\");\",J(d,function(t){return o+\"[\"+t+\"]=\"+n+\"[\"+t+\"];\"}).join(\"\")),r(\"if(\",J(d,function(t){return n+\"[\"+t+\"]!==\"+o+\"[\"+t+\"]\"}).join(\"||\"),\"){\",f,\"}\")}else n=a.def(l,\".\",t),o=a.def(u,\".\",t),f(n,\");\",u,\".\",t,\"=\",n,\";\"),r(\"if(\",n,\"!==\",o,\"){\",f,\"}\");i(f)}),e.compile()}(),compile:X}}function Wt(){return{bufferCount:0,elementsCount:0,framebufferCount:0,shaderCount:0,textureCount:0,cubeCount:0,renderbufferCount:0,maxTextureUnits:0}}function Zt(t,e){for(var r=0;r<t.length;++r)if(t[r]===e)return r;return-1}function Jt(t){function e(){if(0===q.length)return k&&k.update(),void(J=null);J=ge.next(e),f();for(var t=q.length-1;t>=0;--t){var r=q[t];r&&r(E,null,0)}g.flush(),k&&k.update()}function r(){!J&&q.length>0&&(J=ge.next(e))}function n(){J&&(ge.cancel(e),J=null)}function i(t){t.preventDefault(),b=!0,n(),G.forEach(function(t){t()})}function a(t){g.getError(),b=!1,x.restore(),O.restore(),I.restore(),R.restore(),F.restore(),j.restore(),k&&k.restore(),N.procs.refresh(),r(),Y.forEach(function(t){t()})}function o(){q.length=0,n(),H&&(H.removeEventListener(eo,i),H.removeEventListener(ro,a)),O.clear(),j.clear(),F.clear(),R.clear(),D.clear(),I.clear(),k&&k.clear(),Z.forEach(function(t){t()})}function s(t){function e(t){var e={},r={};return Object.keys(t).forEach(function(n){var i=t[n];ve.isDynamic(i)?r[n]=ve.unbox(i,n):e[n]=i}),{dynamic:r,static:e}}function r(t){for(;d.length<t;)d.push(null);return d}function n(t,e){var n;if(b&&de.raise(\"context lost\"),\"function\"==typeof t)return f.call(this,null,t,0);if(\"function\"==typeof e){if(\"number\"==typeof t){for(n=0;n<t;++n)f.call(this,null,e,n);return}if(Array.isArray(t)){for(n=0;n<t.length;++n)f.call(this,t[n],e,n);return}return f.call(this,t,e,0)}if(\"number\"==typeof t){if(t>0)return h.call(this,r(0|t),0|t)}else{if(!Array.isArray(t))return c.call(this,t);if(t.length)return h.call(this,t,t.length)}}de(!!t,\"invalid args to regl({...})\"),de.type(t,\"object\",\"invalid args to regl({...})\");var i=e(t.context||{}),a=e(t.uniforms||{}),o=e(t.attributes||{}),s=e(function(t){function e(t){if(t in r){var e=r[t];delete r[t],Object.keys(e).forEach(function(n){r[t+\".\"+n]=e[n]})}}var r=$t({},t);return delete r.uniforms,delete r.attributes,delete r.context,\"stencil\"in r&&r.stencil.op&&(r.stencil.opBack=r.stencil.opFront=r.stencil.op,delete r.stencil.op),e(\"blend\"),e(\"depth\"),e(\"cull\"),e(\"stencil\"),e(\"polygonOffset\"),e(\"scissor\"),e(\"sample\"),r}(t)),l={gpuTime:0,cpuTime:0,count:0},u=N.compile(s,o,a,i,l),c=u.draw,h=u.batch,f=u.scope,d=[];return $t(n,{stats:l})}function l(t,e){var r=0;N.procs.poll();var n=e.color;n&&(g.clearColor(+n[0]||0,+n[1]||0,+n[2]||0,+n[3]||0),r|=Ka),\"depth\"in e&&(g.clearDepth(+e.depth),r|=Qa),\"stencil\"in e&&(g.clearStencil(0|e.stencil),r|=$a),de(!!r,\"called regl.clear with no buffer specified\"),g.clear(r)}function u(t){if(de(\"object\"==typeof t&&t,\"regl.clear() takes an object as input\"),\"framebuffer\"in t)if(t.framebuffer&&\"framebufferCube\"===t.framebuffer_reglType)for(var e=0;e<6;++e)K($t({framebuffer:t.framebuffer.faces[e]},t),l);else K(t,l);else l(null,t)}function c(t){function e(){function e(){var t=Zt(q,e);q[t]=q[q.length-1],q.length-=1,q.length<=0&&n()}var r=Zt(q,t);de(r>=0,\"cannot cancel a frame twice\"),q[r]=e}return de.type(t,\"function\",\"regl.frame() callback must be a function\"),q.push(t),r(),{cancel:e}}function h(){var t=V.viewport,e=V.scissor_box;t[0]=t[1]=e[0]=e[1]=0,E.viewportWidth=E.framebufferWidth=E.drawingBufferWidth=t[2]=e[2]=g.drawingBufferWidth,E.viewportHeight=E.framebufferHeight=E.drawingBufferHeight=t[3]=e[3]=g.drawingBufferHeight}function f(){E.tick+=1,E.time=p(),h(),N.procs.poll()}function d(){h(),N.procs.refresh(),k&&k.update()}function p(){return(ye()-A)/1e3}function m(t,e){de.type(e,\"function\",\"listener callback must be a function\");var r;switch(t){case\"frame\":return c(e);case\"lost\":r=G;break;case\"restore\":r=Y;break;case\"destroy\":r=Z;break;default:de.raise(\"invalid event, must be one of frame,lost,restore,destroy\")}return r.push(e),{cancel:function(){for(var t=0;t<r.length;++t)if(r[t]===e)return r[t]=r[r.length-1],void r.pop()}}}var v=X(t);if(!v)return null;var g=v.gl,y=g.getContextAttributes(),b=g.isContextLost(),x=W(g,v);if(!x)return null;var _=B(),w=Wt(),M=x.extensions,k=Ja(g,M),A=ye(),T=g.drawingBufferWidth,S=g.drawingBufferHeight,E={tick:0,time:0,viewportWidth:T,viewportHeight:S,framebufferWidth:T,framebufferHeight:S,drawingBufferWidth:T,drawingBufferHeight:S,pixelRatio:v.pixelRatio},L={},C={elements:null,primitive:4,count:-1,offset:0,instances:-1},z=be(g,M),I=ft(g,w,v),D=dt(g,M,I,w),P=Ot(g,M,z,I,_),O=Rt(g,_,w,v),R=zt(g,M,z,function(){N.procs.poll()},E,w,v),F=Mn(g,M,z,w,v),j=Dt(g,M,z,R,F,w),N=Xt(g,_,M,z,I,D,R,j,L,P,O,C,E,k,v),U=Ft(g,j,N.procs.poll,E,y,M),V=N.next,H=g.canvas,q=[],G=[],Y=[],Z=[v.onDestroy],J=null;H&&(H.addEventListener(eo,i,!1),H.addEventListener(ro,a,!1));var K=j.setFBO=s({framebuffer:ve.define.call(null,no,\"framebuffer\")});d();var Q=$t(s,{clear:u,prop:ve.define.bind(null,no),context:ve.define.bind(null,io),this:ve.define.bind(null,ao),draw:s({}),buffer:function(t){return I.create(t,to,!1,!1)},elements:function(t){return D.create(t,!1)},texture:R.create2D,cube:R.createCube,renderbuffer:F.create,framebuffer:j.create,framebufferCube:j.createCube,attributes:y,frame:c,on:m,limits:z,hasExtension:function(t){return z.extensions.indexOf(t.toLowerCase())>=0},read:U,destroy:o,_gl:g,_refresh:d,poll:function(){f(),k&&k.update()},now:p,stats:w});return v.onDone(null,Q),Q}var Kt={\"[object Int8Array]\":5120,\"[object Int16Array]\":5122,\"[object Int32Array]\":5124,\"[object Uint8Array]\":5121,\"[object Uint8ClampedArray]\":5121,\"[object Uint16Array]\":5123,\"[object Uint32Array]\":5125,\"[object Float32Array]\":5126,\"[object Float64Array]\":5121,\"[object ArrayBuffer]\":5121},Qt=function(t){return Object.prototype.toString.call(t)in Kt},$t=function(t,e){for(var r=Object.keys(e),n=0;n<r.length;++n)t[r[n]]=e[r[n]];return t},te=[\"gl\",\"canvas\",\"container\",\"attributes\",\"pixelRatio\",\"extensions\",\"optionalExtensions\",\"profile\",\"onDone\"],ee=33071,re=9728,ne=9984,ie=9985,ae=9986,oe=9987,se=5126,le=32819,ue=32820,ce=33635,he=34042,fe={};fe[5120]=fe[5121]=1,fe[5122]=fe[5123]=fe[36193]=fe[ce]=fe[le]=fe[ue]=2,fe[5124]=fe[5125]=fe[se]=fe[he]=4;var de=$t(r,{optional:S,raise:e,commandRaise:M,command:k,parameter:i,commandParameter:A,constructor:u,type:o,commandType:T,isTypedArray:a,nni:s,oneOf:l,shaderError:b,linkError:x,callSite:m,saveCommandRef:_,saveDrawInfo:w,framebufferFormat:E,guessCommand:p,texture2D:z,textureCube:I}),pe=0,me=0,ve={DynamicVariable:D,define:F,isDynamic:j,unbox:N,accessor:R},ge={next:\"function\"==typeof requestAnimationFrame?function(t){return requestAnimationFrame(t)}:function(t){return setTimeout(t,16)},cancel:\"function\"==typeof cancelAnimationFrame?function(t){return cancelAnimationFrame(t)}:clearTimeout},ye=\"undefined\"!=typeof performance&&performance.now?function(){return performance.now()}:function(){return+new Date},be=function(t,e){var r=1;e.ext_texture_filter_anisotropic&&(r=t.getParameter(34047));var n=1,i=1;return e.webgl_draw_buffers&&(n=t.getParameter(34852),i=t.getParameter(36063)),{colorBits:[t.getParameter(3410),t.getParameter(3411),t.getParameter(3412),t.getParameter(3413)],depthBits:t.getParameter(3414),stencilBits:t.getParameter(3415),subpixelBits:t.getParameter(3408),extensions:Object.keys(e).filter(function(t){return!!e[t]}),maxAnisotropic:r,maxDrawbuffers:n,maxColorAttachments:i,pointSizeDims:t.getParameter(33901),lineWidthDims:t.getParameter(33902),maxViewportDims:t.getParameter(3386),maxCombinedTextureUnits:t.getParameter(35661),maxCubeMapSize:t.getParameter(34076),maxRenderbufferSize:t.getParameter(34024),maxTextureUnits:t.getParameter(34930),maxTextureSize:t.getParameter(3379),maxAttributes:t.getParameter(34921),maxVertexUniforms:t.getParameter(36347),maxVertexTextureUnits:t.getParameter(35660),maxVaryingVectors:t.getParameter(36348),maxFragmentUniforms:t.getParameter(36349),glsl:t.getParameter(35724),renderer:t.getParameter(7937),vendor:t.getParameter(7936),version:t.getParameter(7938)}},xe=function(t){return Object.keys(t).map(function(e){return t[e]})},_e=5120,we=5121,Me=5122,ke=5123,Ae=5124,Te=5125,Se=5126,Ee=J(8,function(){return[]}),Le={alloc:$,free:tt,allocType:et,freeType:rt},Ce={shape:lt,flatten:st},ze={int8:5120,int16:5122,int32:5124,uint8:5121,uint16:5123,uint32:5125,float:5126,float32:5126},Ie={dynamic:35048,stream:35040,static:35044},De=Ce.flatten,Pe=Ce.shape,Oe=35044,Re=35040,Fe=5121,je=5126,Ne=[];Ne[5120]=1,Ne[5122]=2,Ne[5124]=4,Ne[5121]=1,Ne[5123]=2,Ne[5125]=4,Ne[5126]=4;var Be={points:0,point:0,lines:1,line:1,triangles:4,triangle:4,\"line loop\":2,\"line strip\":3,\"triangle strip\":5,\"triangle fan\":6},Ue=0,Ve=1,He=4,qe=5120,Ge=5121,Ye=5122,Xe=5123,We=5124,Ze=5125,Je=34963,Ke=35040,Qe=35044,$e=new Float32Array(1),tr=new Uint32Array($e.buffer),er=5123,rr=34467,nr=3553,ir=34067,ar=34069,or=6408,sr=6406,lr=6407,ur=6409,cr=6410,hr=32854,fr=32855,dr=36194,pr=32819,mr=32820,vr=33635,gr=34042,yr=6402,br=34041,xr=35904,_r=35906,wr=36193,Mr=33776,kr=33777,Ar=33778,Tr=33779,Sr=35986,Er=35987,Lr=34798,Cr=35840,zr=35841,Ir=35842,Dr=35843,Pr=36196,Or=5121,Rr=5123,Fr=5125,jr=5126,Nr=10242,Br=10243,Ur=10497,Vr=33071,Hr=33648,qr=10240,Gr=10241,Yr=9728,Xr=9729,Wr=9984,Zr=9985,Jr=9986,Kr=9987,Qr=33170,$r=4352,tn=4353,en=4354,rn=34046,nn=3317,an=37440,on=37441,sn=37443,ln=37444,un=33984,cn=[Wr,Jr,Zr,Kr],hn=[0,ur,cr,lr,or],fn={};fn[ur]=fn[sr]=fn[yr]=1,fn[br]=fn[cr]=2,fn[lr]=fn[xr]=3,fn[or]=fn[_r]=4;var dn=vt(\"HTMLCanvasElement\"),pn=vt(\"CanvasRenderingContext2D\"),mn=vt(\"HTMLImageElement\"),vn=vt(\"HTMLVideoElement\"),gn=Object.keys(Kt).concat([dn,pn,mn,vn]),yn=[];yn[Or]=1,yn[jr]=4,yn[wr]=2,yn[Rr]=2,yn[Fr]=4;var bn=[];bn[hr]=2,bn[fr]=2,bn[dr]=2,bn[br]=4,bn[Mr]=.5,bn[kr]=.5,bn[Ar]=1,bn[Tr]=1,bn[Sr]=.5,bn[Er]=1,bn[Lr]=1,bn[Cr]=.5,bn[zr]=.25,bn[Ir]=.5,bn[Dr]=.25,bn[Pr]=.5;var xn=36161,_n=32854,wn=[];wn[_n]=2,wn[32855]=2,wn[36194]=2,wn[33189]=2,wn[36168]=1,wn[34041]=4,wn[35907]=4,wn[34836]=16,wn[34842]=8,wn[34843]=6;var Mn=function(t,e,r,n,i){function a(t){this.id=h++,this.refCount=1,this.renderbuffer=t,this.format=_n,this.width=0,this.height=0,i.profile&&(this.stats={size:0})}function o(e){var r=e.renderbuffer;de(r,\"must not double destroy renderbuffer\"),t.bindRenderbuffer(xn,null),t.deleteRenderbuffer(r),e.renderbuffer=null,e.refCount=0,delete f[e.id],n.renderbufferCount--}function s(e,o){function s(e,n){var a=0,o=0,l=_n;if(\"object\"==typeof e&&e){var f=e;if(\"shape\"in f){var d=f.shape;de(Array.isArray(d)&&d.length>=2,\"invalid renderbuffer shape\"),a=0|d[0],o=0|d[1]}else\"radius\"in f&&(a=o=0|f.radius),\"width\"in f&&(a=0|f.width),\"height\"in f&&(o=0|f.height);\"format\"in f&&(de.parameter(f.format,u,\"invalid renderbuffer format\"),l=u[f.format])}else\"number\"==typeof e?(a=0|e,o=\"number\"==typeof n?0|n:a):e?de.raise(\"invalid arguments to renderbuffer constructor\"):a=o=1;if(de(a>0&&o>0&&a<=r.maxRenderbufferSize&&o<=r.maxRenderbufferSize,\"invalid renderbuffer size\"),a!==h.width||o!==h.height||l!==h.format)return s.width=h.width=a,s.height=h.height=o,h.format=l,t.bindRenderbuffer(xn,h.renderbuffer),t.renderbufferStorage(xn,l,a,o),i.profile&&(h.stats.size=It(h.format,h.width,h.height)),s.format=c[h.format],s}function l(e,n){var a=0|e,o=0|n||a;return a===h.width&&o===h.height?s:(de(a>0&&o>0&&a<=r.maxRenderbufferSize&&o<=r.maxRenderbufferSize,\"invalid renderbuffer size\"),s.width=h.width=a,s.height=h.height=o,t.bindRenderbuffer(xn,h.renderbuffer),t.renderbufferStorage(xn,h.format,a,o),i.profile&&(h.stats.size=It(h.format,h.width,h.height)),s)}var h=new a(t.createRenderbuffer());return f[h.id]=h,n.renderbufferCount++,s(e,o),s.resize=l,s._reglType=\"renderbuffer\",s._renderbuffer=h,i.profile&&(s.stats=h.stats),s.destroy=function(){h.decRef()},s}function l(){xe(f).forEach(function(e){e.renderbuffer=t.createRenderbuffer(),t.bindRenderbuffer(xn,e.renderbuffer),t.renderbufferStorage(xn,e.format,e.width,e.height)}),t.bindRenderbuffer(xn,null)}var u={rgba4:_n,rgb565:36194,\"rgb5 a1\":32855,depth:33189,stencil:36168,\"depth stencil\":34041};e.ext_srgb&&(u.srgba=35907),e.ext_color_buffer_half_float&&(u.rgba16f=34842,u.rgb16f=34843),e.webgl_color_buffer_float&&(u.rgba32f=34836);var c=[];Object.keys(u).forEach(function(t){var e=u[t];c[e]=t});var h=0,f={};return a.prototype.decRef=function(){--this.refCount<=0&&o(this)},i.profile&&(n.getTotalRenderbufferSize=function(){var t=0;return Object.keys(f).forEach(function(e){t+=f[e].stats.size}),t}),{create:s,clear:function(){xe(f).forEach(o)},restore:l}},kn=36160,An=36161,Tn=3553,Sn=34069,En=36064,Ln=36096,Cn=36128,zn=33306,In=36053,Dn=6402,Pn=[6408],On=[];On[6408]=4;var Rn=[];Rn[5121]=1,Rn[5126]=4,Rn[36193]=2;var Fn=33189,jn=36168,Nn=34041,Bn=[32854,32855,36194,35907,34842,34843,34836],Un={};Un[In]=\"complete\",Un[36054]=\"incomplete attachment\",Un[36057]=\"incomplete dimensions\",Un[36055]=\"incomplete, missing attachment\",Un[36061]=\"unsupported\";var Vn=5126,Hn=35632,qn=35633,Gn=35718,Yn=35721,Xn=6408,Wn=5121,Zn=3333,Jn=5126,Kn=\"xyzw\".split(\"\"),Qn=5121,$n=1,ti=2,ei=0,ri=1,ni=2,ii=3,ai=4,oi=\"dither\",si=\"blend.enable\",li=\"blend.color\",ui=\"blend.equation\",ci=\"blend.func\",hi=\"depth.enable\",fi=\"depth.func\",di=\"depth.range\",pi=\"depth.mask\",mi=\"colorMask\",vi=\"cull.enable\",gi=\"cull.face\",yi=\"frontFace\",bi=\"lineWidth\",xi=\"polygonOffset.enable\",_i=\"polygonOffset.offset\",wi=\"sample.alpha\",Mi=\"sample.enable\",ki=\"sample.coverage\",Ai=\"stencil.enable\",Ti=\"stencil.mask\",Si=\"stencil.func\",Ei=\"stencil.opFront\",Li=\"stencil.opBack\",Ci=\"scissor.enable\",zi=\"scissor.box\",Ii=\"viewport\",Di=\"profile\",Pi=\"framebuffer\",Oi=\"vert\",Ri=\"frag\",Fi=\"elements\",ji=\"primitive\",Ni=\"count\",Bi=\"offset\",Ui=\"instances\",Vi=Pi+\"Width\",Hi=Pi+\"Height\",qi=Ii+\"Width\",Gi=Ii+\"Height\",Yi=\"drawingBufferWidth\",Xi=\"drawingBufferHeight\",Wi=[ci,ui,Si,Ei,Li,ki,Ii,zi,_i],Zi=34962,Ji=34963,Ki=3553,Qi=34067,$i=2884,ta=3042,ea=3024,ra=2960,na=2929,ia=3089,aa=32823,oa=32926,sa=32928,la=5126,ua=35664,ca=35665,ha=35666,fa=5124,da=35667,pa=35668,ma=35669,va=35670,ga=35671,ya=35672,ba=35673,xa=35674,_a=35675,wa=35676,Ma=35678,ka=35680,Aa=4,Ta=1028,Sa=1029,Ea=2304,La=2305,Ca=32775,za=32776,Ia=519,Da=7680,Pa=0,Oa=1,Ra=32774,Fa=513,ja=36160,Na=36064,Ba={0:0,1:1,zero:0,one:1,\"src color\":768,\"one minus src color\":769,\"src alpha\":770,\"one minus src alpha\":771,\"dst color\":774,\"one minus dst color\":775,\"dst alpha\":772,\"one minus dst alpha\":773,\"constant color\":32769,\"one minus constant color\":32770,\"constant alpha\":32771,\"one minus constant alpha\":32772,\"src alpha saturate\":776},Ua=[\"constant color, constant alpha\",\"one minus constant color, constant alpha\",\"constant color, one minus constant alpha\",\"one minus constant color, one minus constant alpha\",\"constant alpha, constant color\",\"constant alpha, one minus constant color\",\"one minus constant alpha, constant color\",\"one minus constant alpha, one minus constant color\"],Va={never:512,less:513,\"<\":513,equal:514,\"=\":514,\"==\":514,\"===\":514,lequal:515,\"<=\":515,greater:516,\">\":516,notequal:517,\"!=\":517,\"!==\":517,gequal:518,\">=\":518,always:519},Ha={0:0,zero:0,keep:7680,replace:7681,increment:7682,decrement:7683,\"increment wrap\":34055,\"decrement wrap\":34056,invert:5386},qa={frag:35632,vert:35633},Ga={cw:Ea,ccw:La},Ya=new Ht(!1,!1,!1,function(){}),Xa=34918,Wa=34919,Za=35007,Ja=function(t,e){function r(){return f.pop()||h.createQueryEXT()}function n(t){f.push(t)}function i(t){var e=r();h.beginQueryEXT(Za,e),d.push(e),u(d.length-1,d.length,t)}function a(){h.endQueryEXT(Za)}function o(){this.startQueryIndex=-1,this.endQueryIndex=-1,this.sum=0,this.stats=null}function s(){return p.pop()||new o}function l(t){p.push(t)}function u(t,e,r){var n=s();n.startQueryIndex=t,n.endQueryIndex=e,n.sum=0,n.stats=r,m.push(n)}function c(){var t,e,r=d.length;if(0!==r){g.length=Math.max(g.length,r+1),v.length=Math.max(v.length,r+1),v[0]=0,g[0]=0;var i=0;for(t=0,e=0;e<d.length;++e){var a=d[e];h.getQueryObjectEXT(a,Wa)?(i+=h.getQueryObjectEXT(a,Xa),n(a)):d[t++]=a,v[e+1]=i,g[e+1]=t}for(d.length=t,t=0,e=0;e<m.length;++e){var o=m[e],s=o.startQueryIndex,u=o.endQueryIndex;o.sum+=v[u]-v[s];var c=g[s],f=g[u];f===c?(o.stats.gpuTime+=o.sum/1e6,l(o)):(o.startQueryIndex=c,o.endQueryIndex=f,m[t++]=o)}m.length=t}}var h=e.ext_disjoint_timer_query;if(!h)return null;var f=[],d=[],p=[],m=[],v=[],g=[];return{beginQuery:i,endQuery:a,pushScopeStats:u,update:c,getNumPendingQueries:function(){return d.length},clear:function(){f.push.apply(f,d);for(var t=0;t<f.length;t++)h.deleteQueryEXT(f[t]);d.length=0,f.length=0},restore:function(){d.length=0,f.length=0}}},Ka=16384,Qa=256,$a=1024,to=34962,eo=\"webglcontextlost\",ro=\"webglcontextrestored\",no=1,io=2,ao=3;return Jt})},{}],499:[function(t,e,r){\"use strict\";function n(t,e){if(\"string\"!=typeof t)throw new TypeError(\"expected a string\");if(1===e)return t;if(2===e)return t+t;var r=t.length*e;if(i!==t||void 0===i)i=t,a=\"\";else if(a.length>=r)return a.substr(0,r);for(;r>a.length&&e>1;)1&e&&(a+=t),e>>=1,t+=t;return a+=t,a=a.substr(0,r)}var i,a=\"\";e.exports=n},{}],500:[function(e,r,n){!function(e,i){\"function\"==typeof t&&t.amd?t(i):\"object\"==typeof n?r.exports=i():e.resolveUrl=i()}(this,function(){function t(){var t=arguments.length;if(0===t)throw new Error(\"resolveUrl requires at least one argument; got none.\");var e=document.createElement(\"base\");if(e.href=arguments[0],1===t)return e.href;var r=document.getElementsByTagName(\"head\")[0];r.insertBefore(e,r.firstChild);for(var n,i=document.createElement(\"a\"),a=1;a<t;a++)i.href=arguments[a],n=i.href,e.href=n;return r.removeChild(e),n}return t})},{}],501:[function(t,e,r){(function(t){e.exports=t.performance&&t.performance.now?function(){return performance.now()}:Date.now||function(){return+new Date}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{}],502:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=t[t.length-1],n=e,i=e-2;i>=0;--i){var a=r,o=t[i];r=a+o;var s=r-a,l=o-s;l&&(t[--n]=r,r=l)}for(var u=0,i=n;i<e;++i){var a=t[i],o=r;r=a+o;var s=r-a,l=o-s;l&&(t[u++]=l)}return t[u++]=r,t.length=u,t}e.exports=n},{}],503:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m[\",r,\"][\",n,\"]\"].join(\"\")}return e}function a(t){return 1&t?\"-\":\"\"}function o(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",o(t.slice(0,e)),\",\",o(t.slice(e)),\")\"].join(\"\")}function s(t){if(2===t.length)return[\"sum(prod(\",t[0][0],\",\",t[1][1],\"),prod(-\",t[0][1],\",\",t[1][0],\"))\"].join(\"\");for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",s(n(t,r)),\",\",a(r),t[0][r],\")\"].join(\"\"));return o(e)}function l(t){return new Function(\"sum\",\"scale\",\"prod\",\"compress\",[\"function robustDeterminant\",t,\"(m){return compress(\",s(i(t)),\")};return robustDeterminant\",t].join(\"\"))(c,h,u,f)}var u=t(\"two-product\"),c=t(\"robust-sum\"),h=t(\"robust-scale\"),f=t(\"robust-compress\"),d=6,p=[function(){return[0]},function(t){return[t[0][0]]}];!function(){for(;p.length<d;)p.push(l(p.length));for(var t=[],r=[\"function robustDeterminant(m){switch(m.length){\"],n=0;n<d;++n)t.push(\"det\"+n),r.push(\"case \",n,\":return det\",n,\"(m);\");r.push(\"}var det=CACHE[m.length];if(!det)det=CACHE[m.length]=gen(m.length);return det(m);}return robustDeterminant\"),t.push(\"CACHE\",\"gen\",r.join(\"\"));var i=Function.apply(void 0,t);e.exports=i.apply(void 0,p.concat([p,l]));for(var n=0;n<p.length;++n)e.exports[n]=p[n]}()},{\"robust-compress\":502,\"robust-scale\":509,\"robust-sum\":512,\"two-product\":538}],504:[function(t,e,r){\"use strict\";function n(t,e){for(var r=i(t[0],e[0]),n=1;n<t.length;++n)r=a(r,i(t[n],e[n]));return r}var i=t(\"two-product\"),a=t(\"robust-sum\");e.exports=n},{\"robust-sum\":512,\"two-product\":538}],505:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m\",n,\"[\",t-r-2,\"]\"].join(\"\")}return e}function a(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",a(t.slice(0,e)),\",\",a(t.slice(e)),\")\"].join(\"\")}function o(t,e){if(\"m\"===t.charAt(0)){if(\"w\"===e.charAt(0)){var r=t.split(\"[\");return[\"w\",e.substr(1),\"m\",r[0].substr(1)].join(\"\")}return[\"prod(\",t,\",\",e,\")\"].join(\"\")}return o(e,t)}function s(t){return!0&t?\"-\":\"\"}function l(t){if(2===t.length)return[[\"diff(\",o(t[0][0],t[1][1]),\",\",o(t[1][0],t[0][1]),\")\"].join(\"\")];for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",a(l(n(t,r))),\",\",s(r),t[0][r],\")\"].join(\"\"));return e}function u(t,e){for(var r=[],n=0;n<e-2;++n)r.push([\"prod(m\",t,\"[\",n,\"],m\",t,\"[\",n,\"])\"].join(\"\"));return a(r)}function c(t){for(var e=[],r=[],o=i(t),s=0;s<t;++s)o[0][s]=\"1\",o[t-1][s]=\"w\"+s;for(var s=0;s<t;++s)0==(1&s)?e.push.apply(e,l(n(o,s))):r.push.apply(r,l(n(o,s)));for(var c=a(e),h=a(r),f=\"exactInSphere\"+t,d=[],s=0;s<t;++s)d.push(\"m\"+s);for(var p=[\"function \",f,\"(\",d.join(),\"){\"],s=0;s<t;++s){p.push(\"var w\",s,\"=\",u(s,t),\";\");for(var b=0;b<t;++b)b!==s&&p.push(\"var w\",s,\"m\",b,\"=scale(w\",s,\",m\",b,\"[0]);\")}return p.push(\"var p=\",c,\",n=\",h,\",d=diff(p,n);return d[d.length-1];}return \",f),new Function(\"sum\",\"diff\",\"prod\",\"scale\",p.join(\"\"))(v,g,m,y)}function h(){return 0}function f(){return 0}function d(){return 0}function p(t){var e=x[t.length];return e||(e=x[t.length]=c(t.length)),e.apply(void 0,t)}var m=t(\"two-product\"),v=t(\"robust-sum\"),g=t(\"robust-subtract\"),y=t(\"robust-scale\"),b=6,x=[h,f,d];!function(){for(;x.length<=b;)x.push(c(x.length));for(var t=[],r=[\"slow\"],n=0;n<=b;++n)t.push(\"a\"+n),r.push(\"o\"+n);for(var i=[\"function testInSphere(\",t.join(),\"){switch(arguments.length){case 0:case 1:return 0;\"],n=2;n<=b;++n)i.push(\"case \",n,\":return o\",n,\"(\",t.slice(0,n).join(),\");\");i.push(\"}var s=new Array(arguments.length);for(var i=0;i<arguments.length;++i){s[i]=arguments[i]};return slow(s);}return testInSphere\"),r.push(i.join(\"\"));var a=Function.apply(void 0,r);e.exports=a.apply(void 0,[p].concat(x));for(var n=0;n<=b;++n)e.exports[n]=x[n]}()},{\"robust-scale\":509,\"robust-subtract\":511,\"robust-sum\":512,\"two-product\":538}],506:[function(t,e,r){\"use strict\";function n(t){for(var e=\"robustLinearSolve\"+t+\"d\",r=[\"function \",e,\"(A,b){return [\"],n=0;n<t;++n){r.push(\"det([\");for(var i=0;i<t;++i){i>0&&r.push(\",\"),r.push(\"[\");for(var a=0;a<t;++a)a>0&&r.push(\",\"),a===n?r.push(\"+b[\",i,\"]\"):r.push(\"+A[\",i,\"][\",a,\"]\");r.push(\"]\")}r.push(\"]),\")}r.push(\"det(A)]}return \",e);var s=new Function(\"det\",r.join(\"\"));return s(t<6?o[t]:o)}function i(){return[0]}function a(t,e){return[[e[0]],[t[0][0]]]}var o=t(\"robust-determinant\"),s=6,l=[i,a];!function(){for(;l.length<s;)l.push(n(l.length));for(var t=[],r=[\"function dispatchLinearSolve(A,b){switch(A.length){\"],i=0;i<s;++i)t.push(\"s\"+i),r.push(\"case \",i,\":return s\",i,\"(A,b);\");r.push(\"}var s=CACHE[A.length];if(!s)s=CACHE[A.length]=g(A.length);return s(A,b)}return dispatchLinearSolve\"),t.push(\"CACHE\",\"g\",r.join(\"\"));var a=Function.apply(void 0,t);e.exports=a.apply(void 0,l.concat([l,n]));for(var i=0;i<s;++i)e.exports[i]=l[i]}()},{\"robust-determinant\":503}],507:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Array(t.length-1),n=1;n<t.length;++n)for(var i=r[n-1]=new Array(t.length-1),a=0,o=0;a<t.length;++a)a!==e&&(i[o++]=t[n][a]);return r}function i(t){for(var e=new Array(t),r=0;r<t;++r){e[r]=new Array(t);for(var n=0;n<t;++n)e[r][n]=[\"m\",n,\"[\",t-r-1,\"]\"].join(\"\")}return e}function a(t){return 1&t?\"-\":\"\"}function o(t){if(1===t.length)return t[0];if(2===t.length)return[\"sum(\",t[0],\",\",t[1],\")\"].join(\"\");var e=t.length>>1;return[\"sum(\",o(t.slice(0,e)),\",\",o(t.slice(e)),\")\"].join(\"\")}function s(t){if(2===t.length)return[[\"sum(prod(\",t[0][0],\",\",t[1][1],\"),prod(-\",t[0][1],\",\",t[1][0],\"))\"].join(\"\")];for(var e=[],r=0;r<t.length;++r)e.push([\"scale(\",o(s(n(t,r))),\",\",a(r),t[0][r],\")\"].join(\"\"));return e}function l(t){for(var e=[],r=[],a=i(t),l=[],u=0;u<t;++u)0==(1&u)?e.push.apply(e,s(n(a,u))):r.push.apply(r,s(n(a,u))),l.push(\"m\"+u);var p=o(e),m=o(r),v=\"orientation\"+t+\"Exact\",g=[\"function \",v,\"(\",l.join(),\"){var p=\",p,\",n=\",m,\",d=sub(p,n);return d[d.length-1];};return \",v].join(\"\");return new Function(\"sum\",\"prod\",\"scale\",\"sub\",g)(h,c,f,d)}function u(t){var e=g[t.length];return e||(e=g[t.length]=l(t.length)),e.apply(void 0,t)}var c=t(\"two-product\"),h=t(\"robust-sum\"),f=t(\"robust-scale\"),d=t(\"robust-subtract\"),p=5,m=l(3),v=l(4),g=[function(){return 0},function(){return 0},function(t,e){return e[0]-t[0]},function(t,e,r){var n,i=(t[1]-r[1])*(e[0]-r[0]),a=(t[0]-r[0])*(e[1]-r[1]),o=i-a;if(i>0){if(a<=0)return o;n=i+a}else{if(!(i<0))return o;if(a>=0)return o;n=-(i+a)}var s=3.3306690738754716e-16*n;return o>=s||o<=-s?o:m(t,e,r)},function(t,e,r,n){var i=t[0]-n[0],a=e[0]-n[0],o=r[0]-n[0],s=t[1]-n[1],l=e[1]-n[1],u=r[1]-n[1],c=t[2]-n[2],h=e[2]-n[2],f=r[2]-n[2],d=a*u,p=o*l,m=o*s,g=i*u,y=i*l,b=a*s,x=c*(d-p)+h*(m-g)+f*(y-b),_=(Math.abs(d)+Math.abs(p))*Math.abs(c)+(Math.abs(m)+Math.abs(g))*Math.abs(h)+(Math.abs(y)+Math.abs(b))*Math.abs(f),w=7.771561172376103e-16*_;return x>w||-x>w?x:v(t,e,r,n)}];!function(){for(;g.length<=p;)g.push(l(g.length));for(var t=[],r=[\"slow\"],n=0;n<=p;++n)t.push(\"a\"+n),r.push(\"o\"+n);for(var i=[\"function getOrientation(\",t.join(),\"){switch(arguments.length){case 0:case 1:return 0;\"],n=2;n<=p;++n)i.push(\"case \",n,\":return o\",n,\"(\",t.slice(0,n).join(),\");\");i.push(\"}var s=new Array(arguments.length);for(var i=0;i<arguments.length;++i){s[i]=arguments[i]};return slow(s);}return getOrientation\"),r.push(i.join(\"\"));var a=Function.apply(void 0,r);e.exports=a.apply(void 0,[u].concat(g));for(var n=0;n<=p;++n)e.exports[n]=g[n]}()},{\"robust-scale\":509,\"robust-subtract\":511,\"robust-sum\":512,\"two-product\":538}],508:[function(t,e,r){\"use strict\";function n(t,e){if(1===t.length)return a(e,t[0]);if(1===e.length)return a(t,e[0]);if(0===t.length||0===e.length)return[0];var r=[0];if(t.length<e.length)for(var n=0;n<t.length;++n)r=i(r,a(e,t[n]));else for(var n=0;n<e.length;++n)r=i(r,a(t,e[n]));return r}var i=t(\"robust-sum\"),a=t(\"robust-scale\");e.exports=n},{\"robust-scale\":509,\"robust-sum\":512}],\n",
       "509:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length;if(1===r){var n=i(t[0],e);return n[0]?n:[n[1]]}var o=new Array(2*r),s=[.1,.1],l=[.1,.1],u=0;i(t[0],e,s),s[0]&&(o[u++]=s[0]);for(var c=1;c<r;++c){i(t[c],e,l);var h=s[1];a(h,l[0],s),s[0]&&(o[u++]=s[0]);var f=l[1],d=s[1],p=f+d,m=p-f,v=d-m;s[1]=p,v&&(o[u++]=v)}return s[1]&&(o[u++]=s[1]),0===u&&(o[u++]=0),o.length=u,o}var i=t(\"two-product\"),a=t(\"two-sum\");e.exports=n},{\"two-product\":538,\"two-sum\":539}],510:[function(t,e,r){\"use strict\";function n(t,e,r,n){for(var i=0;i<2;++i){var a=t[i],o=e[i],s=Math.min(a,o),l=Math.max(a,o),u=r[i],c=n[i],h=Math.min(u,c);if(Math.max(u,c)<s||l<h)return!1}return!0}function i(t,e,r,i){var o=a(t,r,i),s=a(e,r,i);if(o>0&&s>0||o<0&&s<0)return!1;var l=a(r,t,e),u=a(i,t,e);return!(l>0&&u>0||l<0&&u<0)&&(0!==o||0!==s||0!==l||0!==u||n(t,e,r,i))}e.exports=i;var a=t(\"robust-orientation\")[3]},{\"robust-orientation\":507}],511:[function(t,e,r){\"use strict\";function n(t,e){var r=t+e,n=r-t,i=r-n,a=e-n,o=t-i,s=o+a;return s?[s,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],-e[0]);var a,o,s=r+i,l=new Array(s),u=0,c=0,h=0,f=Math.abs,d=t[c],p=f(d),m=-e[h],v=f(m);p<v?(o=d,(c+=1)<r&&(d=t[c],p=f(d))):(o=m,(h+=1)<i&&(m=-e[h],v=f(m))),c<r&&p<v||h>=i?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=-e[h],v=f(m)));for(var g,y,b,x,_,w=a+o,M=w-a,k=o-M,A=k,T=w;c<r&&h<i;)p<v?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=-e[h],v=f(m))),o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g;for(;c<r;)a=d,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(c+=1)<r&&(d=t[c]);for(;h<i;)a=m,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(h+=1)<i&&(m=-e[h]);return A&&(l[u++]=A),T&&(l[u++]=T),u||(l[u++]=0),l.length=u,l}e.exports=i},{}],512:[function(t,e,r){\"use strict\";function n(t,e){var r=t+e,n=r-t,i=r-n,a=e-n,o=t-i,s=o+a;return s?[s,r]:[r]}function i(t,e){var r=0|t.length,i=0|e.length;if(1===r&&1===i)return n(t[0],e[0]);var a,o,s=r+i,l=new Array(s),u=0,c=0,h=0,f=Math.abs,d=t[c],p=f(d),m=e[h],v=f(m);p<v?(o=d,(c+=1)<r&&(d=t[c],p=f(d))):(o=m,(h+=1)<i&&(m=e[h],v=f(m))),c<r&&p<v||h>=i?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=e[h],v=f(m)));for(var g,y,b,x,_,w=a+o,M=w-a,k=o-M,A=k,T=w;c<r&&h<i;)p<v?(a=d,(c+=1)<r&&(d=t[c],p=f(d))):(a=m,(h+=1)<i&&(m=e[h],v=f(m))),o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g;for(;c<r;)a=d,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(c+=1)<r&&(d=t[c]);for(;h<i;)a=m,o=A,w=a+o,M=w-a,k=o-M,k&&(l[u++]=k),g=T+w,y=g-T,b=g-y,x=w-y,_=T-b,A=_+x,T=g,(h+=1)<i&&(m=e[h]);return A&&(l[u++]=A),T&&(l[u++]=T),u||(l[u++]=0),l.length=u,l}e.exports=i},{}],513:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?r.exports=i():\"function\"==typeof t&&t.amd?t(i):e.ShelfPack=i()}(this,function(){function t(t,e,r){r=r||{},this.w=t||64,this.h=e||64,this.autoResize=!!r.autoResize,this.shelves=[],this.stats={},this.count=function(t){this.stats[t]=1+(0|this.stats[t])}}function e(t,e,r){this.x=0,this.y=t,this.w=this.free=e,this.h=r}return t.prototype.pack=function(t,e){t=[].concat(t),e=e||{};for(var r,n,i,a=[],o=0;o<t.length;o++)if(r=t[o].w||t[o].width,n=t[o].h||t[o].height,r&&n){if(!(i=this.packOne(r,n)))continue;e.inPlace&&(t[o].x=i.x,t[o].y=i.y),a.push(i)}if(this.shelves.length>0){for(var s=0,l=0,u=0;u<this.shelves.length;u++){var c=this.shelves[u];l+=c.h,s=Math.max(c.w-c.free,s)}this.resize(s,l)}return a},t.prototype.packOne=function(t,r){for(var n,i,a=0,o={shelf:-1,waste:1/0},s=0;s<this.shelves.length;s++){if(n=this.shelves[s],a+=n.h,r===n.h&&t<=n.free)return this.count(r),n.alloc(t,r);r>n.h||t>n.free||r<n.h&&t<=n.free&&(i=n.h-r)<o.waste&&(o.waste=i,o.shelf=s)}if(-1!==o.shelf)return n=this.shelves[o.shelf],this.count(r),n.alloc(t,r);if(r<=this.h-a&&t<=this.w)return n=new e(a,this.w,r),this.shelves.push(n),this.count(r),n.alloc(t,r);if(this.autoResize){var l,u,c,h;return l=u=this.h,c=h=this.w,(c<=l||t>c)&&(h=2*Math.max(t,c)),(l<c||r>l)&&(u=2*Math.max(r,l)),this.resize(h,u),this.packOne(t,r)}return null},t.prototype.clear=function(){this.shelves=[],this.stats={}},t.prototype.resize=function(t,e){this.w=t,this.h=e;for(var r=0;r<this.shelves.length;r++)this.shelves[r].resize(t);return!0},e.prototype.alloc=function(t,e){if(t>this.free||e>this.h)return null;var r=this.x;return this.x+=t,this.free-=t,{x:r,y:this.y,w:t,h:e,width:t,height:e}},e.prototype.resize=function(t){return this.free+=t-this.w,this.w=t,!0},t})},{}],514:[function(t,e,r){\"use strict\";e.exports=function(t){return t<0?-1:t>0?1:0}},{}],515:[function(t,e,r){\"use strict\";function n(t){return a(i(t))}e.exports=n;var i=t(\"boundary-cells\"),a=t(\"reduce-simplicial-complex\")},{\"boundary-cells\":68,\"reduce-simplicial-complex\":497}],516:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=0,n=0;n<e;++n)r=0|Math.max(r,t[n].length);return r-1}function i(t,e){for(var r=t.length,n=h.mallocUint8(r),i=0;i<r;++i)n[i]=t[i]<e|0;return n}function a(t,e){for(var r=t.length,n=e*(e+1)/2*r|0,i=h.mallocUint32(2*n),a=0,o=0;o<r;++o)for(var s=t[o],e=s.length,l=0;l<e;++l)for(var u=0;u<l;++u){var d=s[u],p=s[l];i[a++]=0|Math.min(d,p),i[a++]=0|Math.max(d,p)}f(c(i,[a/2|0,2]));for(var m=2,o=2;o<a;o+=2)i[o-2]===i[o]&&i[o-1]===i[o+1]||(i[m++]=i[o],i[m++]=i[o+1]);return c(i,[m/2|0,2])}function o(t,e,r,n){for(var i=t.data,a=t.shape[0],o=h.mallocDouble(a),s=0,l=0;l<a;++l){var u=i[2*l],f=i[2*l+1];if(r[u]!==r[f]){var d=e[u],p=e[f];i[2*s]=u,i[2*s+1]=f,o[s++]=(p-n)/(p-d)}}return t.shape[0]=s,c(o,[s])}function s(t,e){var r=h.mallocInt32(2*e),n=t.shape[0],i=t.data;r[0]=0;for(var a=0,o=0;o<n;++o){var s=i[2*o];if(s!==a){for(r[2*a+1]=o;++a<s;)r[2*a]=o,r[2*a+1]=o;r[2*a]=o}}for(r[2*a+1]=n;++a<e;)r[2*a]=r[2*a+1]=n;return r}function l(t){for(var e=0|t.shape[0],r=t.data,n=new Array(e),i=0;i<e;++i)n[i]=[r[2*i],r[2*i+1]];return n}function u(t,e,r,u){if(r=r||0,void 0===u&&(u=n(t)),0===t.length||u<1)return{cells:[],vertexIds:[],vertexWeights:[]};var c=i(e,+r),f=a(t,u),p=o(f,e,c,+r),m=s(f,0|e.length),v=d(u)(t,f.data,m,c),g=l(f),y=[].slice.call(p.data,0,p.shape[0]);return h.free(c),h.free(f.data),h.free(p.data),h.free(m),{cells:v,vertexIds:g,vertexWeights:y}}e.exports=u;var c=t(\"ndarray\"),h=t(\"typedarray-pool\"),f=t(\"ndarray-sort\"),d=t(\"./lib/codegen\")},{\"./lib/codegen\":517,ndarray:466,\"ndarray-sort\":464,\"typedarray-pool\":540}],517:[function(t,e,r){\"use strict\";function n(t){var e=0,r=new Array(t+1);r[0]=[[]];for(var n=1;n<=t;++n)for(var i=r[n]=o(n),s=0;s<i.length;++s)e=Math.max(e,i[n].length);for(var l=[\"function B(C,E,i,j){\",\"var a=Math.min(i,j)|0,b=Math.max(i,j)|0,l=C[2*a],h=C[2*a+1];\",\"while(l<h){\",\"var m=(l+h)>>1,v=E[2*m+1];\",\"if(v===b){return m}\",\"if(b<v){h=m}else{l=m+1}\",\"}\",\"return l;\",\"};\",\"function getContour\",t,\"d(F,E,C,S){\",\"var n=F.length,R=[];\",\"for(var i=0;i<n;++i){var c=F[i],l=c.length;\"],n=t+1;n>1;--n){n<t+1&&l.push(\"else \"),l.push(\"if(l===\",n,\"){\");for(var u=[],s=0;s<n;++s)u.push(\"(S[c[\"+s+\"]]<<\"+s+\")\");l.push(\"var M=\",u.join(\"+\"),\";if(M===0||M===\",(1<<n)-1,\"){continue}switch(M){\");for(var i=r[n-1],s=0;s<i.length;++s)l.push(\"case \",s,\":\"),function(t){if(!(t.length<=0)){l.push(\"R.push(\");for(var e=0;e<t.length;++e){var r=t[e];e>0&&l.push(\",\"),l.push(\"[\");for(var n=0;n<r.length;++n){var i=r[n];n>0&&l.push(\",\"),l.push(\"B(C,E,c[\",i[0],\"],c[\",i[1],\"])\")}l.push(\"]\")}l.push(\");\")}}(i[s]),l.push(\"break;\");l.push(\"}}\")}return l.push(\"}return R;};return getContour\",t,\"d\"),new Function(\"pool\",l.join(\"\"))(a)}function i(t){var e=s[t];return e||(e=s[t]=n(t)),e}e.exports=i;var a=t(\"typedarray-pool\"),o=t(\"marching-simplex-table\"),s={}},{\"marching-simplex-table\":444,\"typedarray-pool\":540}],518:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){for(var e=0,r=Math.max,n=0,i=t.length;n<i;++n)e=r(e,t[n].length);return e-1}function i(t){for(var e=-1,r=Math.max,n=0,i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)e=r(e,a[o]);return e+1}function a(t){for(var e=new Array(t.length),r=0,n=t.length;r<n;++r)e[r]=t[r].slice(0);return e}function o(t,e){var r=t.length,n=t.length-e.length,i=Math.min;if(n)return n;switch(r){case 0:return 0;case 1:return t[0]-e[0];case 2:var a=t[0]+t[1]-e[0]-e[1];return a||i(t[0],t[1])-i(e[0],e[1]);case 3:var o=t[0]+t[1],s=e[0]+e[1];if(a=o+t[2]-(s+e[2]))return a;var l=i(t[0],t[1]),u=i(e[0],e[1]),a=i(l,t[2])-i(u,e[2]);return a||i(l+t[2],o)-i(u+e[2],s);default:var c=t.slice(0);c.sort();var h=e.slice(0);h.sort();for(var f=0;f<r;++f)if(n=c[f]-h[f])return n;return 0}}function s(t,e){return o(t[0],e[0])}function l(t,e){if(e){for(var r=t.length,n=new Array(r),i=0;i<r;++i)n[i]=[t[i],e[i]];n.sort(s);for(var i=0;i<r;++i)t[i]=n[i][0],e[i]=n[i][1];return t}return t.sort(o),t}function u(t){if(0===t.length)return[];for(var e=1,r=t.length,n=1;n<r;++n){var i=t[n];if(o(i,t[n-1])){if(n===e){e++;continue}t[e++]=i}}return t.length=e,t}function c(t,e){for(var r=0,n=t.length-1,i=-1;r<=n;){var a=r+n>>1,s=o(t[a],e);s<=0?(0===s&&(i=a),r=a+1):s>0&&(n=a-1)}return i}function h(t,e){for(var r=new Array(t.length),n=0,i=r.length;n<i;++n)r[n]=[];for(var a=[],n=0,s=e.length;n<s;++n)for(var l=e[n],u=l.length,h=1,f=1<<u;h<f;++h){a.length=b.popCount(h);for(var d=0,p=0;p<u;++p)h&1<<p&&(a[d++]=l[p]);var m=c(t,a);if(!(m<0))for(;;)if(r[m++].push(n),m>=t.length||0!==o(t[m],a))break}return r}function f(t,e){if(!e)return h(u(p(t,0)),t,0);for(var r=new Array(e),n=0;n<e;++n)r[n]=[];for(var n=0,i=t.length;n<i;++n)for(var a=t[n],o=0,s=a.length;o<s;++o)r[a[o]].push(n);return r}function d(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0|i.length,o=1,s=1<<a;o<s;++o){for(var u=[],c=0;c<a;++c)o>>>c&1&&u.push(i[c]);e.push(u)}return l(e)}function p(t,e){if(e<0)return[];for(var r=[],n=(1<<e+1)-1,i=0;i<t.length;++i)for(var a=t[i],o=n;o<1<<a.length;o=b.nextCombination(o)){for(var s=new Array(e+1),u=0,c=0;c<a.length;++c)o&1<<c&&(s[u++]=a[c]);r.push(s)}return l(r)}function m(t){for(var e=[],r=0,n=t.length;r<n;++r)for(var i=t[r],a=0,o=i.length;a<o;++a){for(var s=new Array(i.length-1),u=0,c=0;u<o;++u)u!==a&&(s[c++]=i[u]);e.push(s)}return l(e)}function v(t,e){for(var r=new x(e),n=0;n<t.length;++n)for(var i=t[n],a=0;a<i.length;++a)for(var o=a+1;o<i.length;++o)r.link(i[a],i[o]);for(var s=[],l=r.ranks,n=0;n<l.length;++n)l[n]=-1;for(var n=0;n<t.length;++n){var u=r.find(t[n][0]);l[u]<0?(l[u]=s.length,s.push([t[n].slice(0)])):s[l[u]].push(t[n].slice(0))}return s}function g(t){for(var e=u(l(p(t,0))),r=new x(e.length),n=0;n<t.length;++n)for(var i=t[n],a=0;a<i.length;++a)for(var o=c(e,[i[a]]),s=a+1;s<i.length;++s)r.link(o,c(e,[i[s]]));for(var h=[],f=r.ranks,n=0;n<f.length;++n)f[n]=-1;for(var n=0;n<t.length;++n){var d=r.find(c(e,[t[n][0]]));f[d]<0?(f[d]=h.length,h.push([t[n].slice(0)])):h[f[d]].push(t[n].slice(0))}return h}function y(t,e){return e?v(t,e):g(t)}var b=t(\"bit-twiddle\"),x=t(\"union-find\");r.dimension=n,r.countVertices=i,r.cloneCells=a,r.compareCells=o,r.normalize=l,r.unique=u,r.findCell=c,r.incidence=h,r.dual=f,r.explode=d,r.skeleton=p,r.boundary=m,r.connectedComponents=y},{\"bit-twiddle\":66,\"union-find\":541}],519:[function(t,e,r){arguments[4][66][0].apply(r,arguments)},{dup:66}],520:[function(t,e,r){arguments[4][518][0].apply(r,arguments)},{\"bit-twiddle\":519,dup:518,\"union-find\":521}],521:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n,n.prototype.length=function(){return this.roots.length},n.prototype.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},n.prototype.find=function(t){for(var e=this.roots;e[t]!==t;){var r=e[t];e[t]=e[r],t=r}return t},n.prototype.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],522:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.abs(a(t,e,r))/Math.sqrt(Math.pow(e[0]-r[0],2)+Math.pow(e[1]-r[1],2))}function i(t,e,r){function i(t){if(b[t])return 1/0;var r=v[t],i=g[t];return r<0||i<0?1/0:n(e[t],e[r],e[i])}function a(t,e){var r=k[t],n=k[e];k[t]=n,k[e]=r,A[r]=e,A[n]=t}function s(t){return y[k[t]]}function l(t){return 1&t?t-1>>1:(t>>1)-1}function u(t){for(var e=s(t);;){var r=e,n=2*t+1,i=2*(t+1),o=t;if(n<T){var l=s(n);l<r&&(o=n,r=l)}if(i<T){s(i)<r&&(o=i)}if(o===t)return t;a(t,o),t=o}}function c(t){for(var e=s(t);t>0;){var r=l(t);if(r>=0){if(e<s(r)){a(t,r),t=r;continue}}return t}}function h(){if(T>0){var t=k[0];return a(0,T-1),T-=1,u(0),t}return-1}function f(t,e){var r=k[t];return y[r]===e?t:(y[r]=-1/0,c(t),h(),y[r]=e,T+=1,c(T-1))}function d(t,e){if(t[e]<0)return e;var r=e,n=e;do{var i=t[n];if(!b[n]||i<0||i===n)break;if(n=i,i=t[n],!b[n]||i<0||i===n)break;n=i,r=t[r]}while(r!==n);for(var a=e;a!==n;a=t[a])t[a]=n;return n}for(var p=e.length,m=t.length,v=new Array(p),g=new Array(p),y=new Array(p),b=new Array(p),x=0;x<p;++x)v[x]=g[x]=-1,y[x]=1/0,b[x]=!1;for(var x=0;x<m;++x){var _=t[x];if(2!==_.length)throw new Error(\"Input must be a graph\");var w=_[1],M=_[0];-1!==g[M]?g[M]=-2:g[M]=w,-1!==v[w]?v[w]=-2:v[w]=M}for(var k=[],A=new Array(p),x=0;x<p;++x){(y[x]=i(x))<1/0?(A[x]=k.length,k.push(x)):A[x]=-1}for(var T=k.length,x=T>>1;x>=0;--x)u(x);for(;;){var S=h();if(S<0||y[S]>r)break;!function(t){if(!b[t]){b[t]=!0;var e=v[t],r=g[t];v[r]>=0&&(v[r]=e),g[e]>=0&&(g[e]=r),A[e]>=0&&f(A[e],i(e)),A[r]>=0&&f(A[r],i(r))}}(S)}for(var E=[],x=0;x<p;++x)b[x]||(A[x]=E.length,E.push(e[x].slice()));var L=(E.length,[]);return t.forEach(function(t){var e=d(v,t[0]),r=d(g,t[1]);if(e>=0&&r>=0&&e!==r){var n=A[e],i=A[r];n!==i&&L.push([n,i])}}),o.unique(o.normalize(L)),{positions:E,edges:L}}e.exports=i;var a=t(\"robust-orientation\"),o=t(\"simplicial-complex\")},{\"robust-orientation\":507,\"simplicial-complex\":520}],523:[function(t,e,r){\"use strict\";function n(t,e){var r,n;if(e[0][0]<e[1][0])r=e[0],n=e[1];else{if(!(e[0][0]>e[1][0])){var i=Math.min(t[0][1],t[1][1]),o=Math.max(t[0][1],t[1][1]),s=Math.min(e[0][1],e[1][1]),l=Math.max(e[0][1],e[1][1]);return o<s?o-s:i>l?i-l:o-l}r=e[1],n=e[0]}var u,c;t[0][1]<t[1][1]?(u=t[0],c=t[1]):(u=t[1],c=t[0]);var h=a(n,r,u);return h||((h=a(n,r,c))||c-n)}function i(t,e){var r,i;if(e[0][0]<e[1][0])r=e[0],i=e[1];else{if(!(e[0][0]>e[1][0]))return n(e,t);r=e[1],i=e[0]}var o,s;if(t[0][0]<t[1][0])o=t[0],s=t[1];else{if(!(t[0][0]>t[1][0]))return-n(t,e);o=t[1],s=t[0]}var l=a(r,i,s),u=a(r,i,o);if(l<0){if(u<=0)return l}else if(l>0){if(u>=0)return l}else if(u)return u;if(l=a(s,o,i),u=a(s,o,r),l<0){if(u<=0)return l}else if(l>0){if(u>=0)return l}else if(u)return u;return i[0]-s[0]}e.exports=i;var a=t(\"robust-orientation\")},{\"robust-orientation\":507}],524:[function(t,e,r){\"use strict\";function n(t,e,r){this.slabs=t,this.coordinates=e,this.horizontal=r}function i(t,e){return t.y-e}function a(t,e){for(var r=null;t;){var n,i,o=t.key;o[0][0]<o[1][0]?(n=o[0],i=o[1]):(n=o[1],i=o[0]);var s=h(n,i,e);if(s<0)t=t.left;else if(s>0)if(e[0]!==o[1][0])r=t,t=t.right;else{var l=a(t.right,e);if(l)return l;t=t.left}else{if(e[0]!==o[1][0])return t;var l=a(t.right,e);if(l)return l;t=t.left}}return r}function o(t,e,r,n){this.y=t,this.index=e,this.start=r,this.closed=n}function s(t,e,r,n){this.x=t,this.segment=e,this.create=r,this.index=n}function l(t){for(var e=t.length,r=2*e,i=new Array(r),a=0;a<e;++a){var l=t[a],u=l[0][0]<l[1][0];i[2*a]=new s(l[0][0],l,u,a),i[2*a+1]=new s(l[1][0],l,!u,a)}i.sort(function(t,e){var r=t.x-e.x;return r||((r=t.create-e.create)||Math.min(t.segment[0][1],t.segment[1][1])-Math.min(e.segment[0][1],e.segment[1][1]))});for(var h=c(f),d=[],p=[],m=[],a=0;a<r;){for(var v=i[a].x,g=[];a<r;){var y=i[a];if(y.x!==v)break;a+=1,y.segment[0][0]===y.x&&y.segment[1][0]===y.x?y.create&&(y.segment[0][1]<y.segment[1][1]?(g.push(new o(y.segment[0][1],y.index,!0,!0)),g.push(new o(y.segment[1][1],y.index,!1,!1))):(g.push(new o(y.segment[1][1],y.index,!0,!1)),g.push(new o(y.segment[0][1],y.index,!1,!0)))):h=y.create?h.insert(y.segment,y.index):h.remove(y.segment)}d.push(h.root),p.push(v),m.push(g)}return new n(d,p,m)}e.exports=l;var u=t(\"binary-search-bounds\"),c=t(\"functional-red-black-tree\"),h=t(\"robust-orientation\"),f=t(\"./lib/order-segments\");n.prototype.castUp=function(t){var e=u.le(this.coordinates,t[0]);if(e<0)return-1;var r=(this.slabs[e],a(this.slabs[e],t)),n=-1;if(r&&(n=r.value),this.coordinates[e]===t[0]){var o=null;if(r&&(o=r.key),e>0){var s=a(this.slabs[e-1],t);s&&(o?f(s.key,o)>0&&(o=s.key,n=s.value):(n=s.value,o=s.key))}var l=this.horizontal[e];if(l.length>0){var c=u.ge(l,t[1],i);if(c<l.length){var d=l[c];if(t[1]===d.y){if(d.closed)return d.index;for(;c<l.length-1&&l[c+1].y===t[1];)if(c+=1,d=l[c],d.closed)return d.index;if(d.y===t[1]&&!d.start){if((c+=1)>=l.length)return n;d=l[c]}}if(d.start)if(o){var p=h(o[0],o[1],[t[0],d.y]);o[0][0]>o[1][0]&&(p=-p),p>0&&(n=d.index)}else n=d.index;else d.y!==t[1]&&(n=d.index)}}}return n}},{\"./lib/order-segments\":523,\"binary-search-bounds\":65,\"functional-red-black-tree\":134,\"robust-orientation\":507}],525:[function(t,e,r){\"use strict\";function n(t,e){var r=u(l(t,e),[e[e.length-1]]);return r[r.length-1]}function i(t,e,r,n){var i=n-e,a=-e/i;a<0?a=0:a>1&&(a=1);for(var o=1-a,s=t.length,l=new Array(s),u=0;u<s;++u)l[u]=a*t[u]+o*r[u];return l}function a(t,e){for(var r=[],a=[],o=n(t[t.length-1],e),s=t[t.length-1],l=t[0],u=0;u<t.length;++u,s=l){l=t[u];var c=n(l,e);if(o<0&&c>0||o>0&&c<0){var h=i(s,c,l,o);r.push(h),a.push(h.slice())}c<0?a.push(l.slice()):c>0?r.push(l.slice()):(r.push(l.slice()),a.push(l.slice())),o=c}return{positive:r,negative:a}}function o(t,e){for(var r=[],a=n(t[t.length-1],e),o=t[t.length-1],s=t[0],l=0;l<t.length;++l,o=s){s=t[l];var u=n(s,e);(a<0&&u>0||a>0&&u<0)&&r.push(i(o,u,s,a)),u>=0&&r.push(s.slice()),a=u}return r}function s(t,e){for(var r=[],a=n(t[t.length-1],e),o=t[t.length-1],s=t[0],l=0;l<t.length;++l,o=s){s=t[l];var u=n(s,e);(a<0&&u>0||a>0&&u<0)&&r.push(i(o,u,s,a)),u<=0&&r.push(s.slice()),a=u}return r}var l=t(\"robust-dot-product\"),u=t(\"robust-sum\");e.exports=a,e.exports.positive=o,e.exports.negative=s},{\"robust-dot-product\":504,\"robust-sum\":512}],526:[function(e,r,n){!function(){\"use strict\";function e(t){return i(a(t),arguments)}function r(t,r){return e.apply(null,[t].concat(r||[]))}function i(t,r){var n,i,a,s,l,u,c,h,f,d=1,p=t.length,m=\"\";for(i=0;i<p;i++)if(\"string\"==typeof t[i])m+=t[i];else if(Array.isArray(t[i])){if(s=t[i],s[2])for(n=r[d],a=0;a<s[2].length;a++){if(!n.hasOwnProperty(s[2][a]))throw new Error(e('[sprintf] property \"%s\" does not exist',s[2][a]));n=n[s[2][a]]}else n=s[1]?r[s[1]]:r[d++];if(o.not_type.test(s[8])&&o.not_primitive.test(s[8])&&n instanceof Function&&(n=n()),o.numeric_arg.test(s[8])&&\"number\"!=typeof n&&isNaN(n))throw new TypeError(e(\"[sprintf] expecting number but found %T\",n));switch(o.number.test(s[8])&&(h=n>=0),s[8]){case\"b\":n=parseInt(n,10).toString(2);break;case\"c\":n=String.fromCharCode(parseInt(n,10));break;case\"d\":case\"i\":n=parseInt(n,10);break;case\"j\":n=JSON.stringify(n,null,s[6]?parseInt(s[6]):0);break;case\"e\":n=s[7]?parseFloat(n).toExponential(s[7]):parseFloat(n).toExponential();break;case\"f\":n=s[7]?parseFloat(n).toFixed(s[7]):parseFloat(n);break;case\"g\":n=s[7]?String(Number(n.toPrecision(s[7]))):parseFloat(n);break;case\"o\":n=(parseInt(n,10)>>>0).toString(8);break;case\"s\":n=String(n),n=s[7]?n.substring(0,s[7]):n;break;case\"t\":n=String(!!n),n=s[7]?n.substring(0,s[7]):n;break;case\"T\":n=Object.prototype.toString.call(n).slice(8,-1).toLowerCase(),n=s[7]?n.substring(0,s[7]):n;break;case\"u\":n=parseInt(n,10)>>>0;break;case\"v\":n=n.valueOf(),n=s[7]?n.substring(0,s[7]):n;break;case\"x\":n=(parseInt(n,10)>>>0).toString(16);break;case\"X\":n=(parseInt(n,10)>>>0).toString(16).toUpperCase()}o.json.test(s[8])?m+=n:(!o.number.test(s[8])||h&&!s[3]?f=\"\":(f=h?\"+\":\"-\",n=n.toString().replace(o.sign,\"\")),u=s[4]?\"0\"===s[4]?\"0\":s[4].charAt(1):\" \",c=s[6]-(f+n).length,l=s[6]&&c>0?u.repeat(c):\"\",m+=s[5]?f+n+l:\"0\"===u?f+l+n:l+f+n)}return m}function a(t){if(s[t])return s[t];for(var e,r=t,n=[],i=0;r;){if(null!==(e=o.text.exec(r)))n.push(e[0]);else if(null!==(e=o.modulo.exec(r)))n.push(\"%\");else{if(null===(e=o.placeholder.exec(r)))throw new SyntaxError(\"[sprintf] unexpected placeholder\");if(e[2]){i|=1;var a=[],l=e[2],u=[];if(null===(u=o.key.exec(l)))throw new SyntaxError(\"[sprintf] failed to parse named argument key\");for(a.push(u[1]);\"\"!==(l=l.substring(u[0].length));)if(null!==(u=o.key_access.exec(l)))a.push(u[1]);else{if(null===(u=o.index_access.exec(l)))throw new SyntaxError(\"[sprintf] failed to parse named argument key\");a.push(u[1])}e[2]=a}else i|=2;if(3===i)throw new Error(\"[sprintf] mixing positional and named placeholders is not (yet) supported\");n.push(e)}r=r.substring(e[0].length)}return s[t]=n}var o={not_string:/[^s]/,not_bool:/[^t]/,not_type:/[^T]/,not_primitive:/[^v]/,number:/[diefg]/,numeric_arg:/[bcdiefguxX]/,json:/[j]/,not_json:/[^j]/,text:/^[^\\x25]+/,modulo:/^\\x25{2}/,placeholder:/^\\x25(?:([1-9]\\d*)\\$|\\(([^\\)]+)\\))?(\\+)?(0|'[^$])?(-)?(\\d+)?(?:\\.(\\d+))?([b-gijostTuvxX])/,key:/^([a-z_][a-z_\\d]*)/i,key_access:/^\\.([a-z_][a-z_\\d]*)/i,index_access:/^\\[(\\d+)\\]/,sign:/^[\\+\\-]/},s=Object.create(null);void 0!==n&&(n.sprintf=e,n.vsprintf=r),\"undefined\"!=typeof window&&(window.sprintf=e,window.vsprintf=r,\"function\"==typeof t&&t.amd&&t(function(){return{sprintf:e,vsprintf:r}}))}()},{}],527:[function(t,e,r){\"use strict\";function n(t){for(var e=t.length,r=new Array(e),n=new Array(e),i=new Array(e),a=new Array(e),o=new Array(e),s=new Array(e),l=0;l<e;++l)r[l]=-1,n[l]=0,i[l]=!1,a[l]=0,o[l]=-1,s[l]=[];for(var u=0,c=[],h=[],l=0;l<e;++l)r[l]<0&&function(e){var l=[e],f=[e];for(r[e]=n[e]=u,i[e]=!0,u+=1;f.length>0;){e=f[f.length-1];var d=t[e];if(a[e]<d.length){for(var p=a[e];p<d.length;++p){var m=d[p];if(r[m]<0){r[m]=n[m]=u,i[m]=!0,u+=1,l.push(m),f.push(m);break}i[m]&&(n[e]=0|Math.min(n[e],n[m])),o[m]>=0&&s[e].push(o[m])}a[e]=p}else{if(n[e]===r[e]){for(var v=[],g=[],y=0,p=l.length-1;p>=0;--p){var b=l[p];if(i[b]=!1,v.push(b),g.push(s[b]),y+=s[b].length,o[b]=c.length,b===e){l.length=p;break}}c.push(v);for(var x=new Array(y),p=0;p<g.length;p++)for(var _=0;_<g[p].length;_++)x[--y]=g[p][_];h.push(x)}f.pop()}}}(l);for(var f,l=0;l<h.length;l++){var d=h[l];if(0!==d.length){d.sort(function(t,e){return t-e}),f=[d[0]];for(var p=1;p<d.length;p++)d[p]!==d[p-1]&&f.push(d[p]);h[l]=f}}return{components:c,adjacencyList:h}}e.exports=n},{}],528:[function(t,e,r){\"use strict\";function n(t){return new i(t)}function i(t){this.options=d(Object.create(this.options),t),this.trees=new Array(this.options.maxZoom+1)}function a(t,e,r,n,i){return{x:t,y:e,zoom:1/0,id:n,properties:i,parentId:-1,numPoints:r}}function o(t,e){var r=t.geometry.coordinates;return{x:u(r[0]),y:c(r[1]),zoom:1/0,id:e,parentId:-1}}function s(t){return{type:\"Feature\",properties:l(t),geometry:{type:\"Point\",coordinates:[h(t.x),f(t.y)]}}}function l(t){var e=t.numPoints,r=e>=1e4?Math.round(e/1e3)+\"k\":e>=1e3?Math.round(e/100)/10+\"k\":e;return d(d({},t.properties),{cluster:!0,cluster_id:t.id,point_count:e,point_count_abbreviated:r})}function u(t){return t/360+.5}function c(t){var e=Math.sin(t*Math.PI/180),r=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return r<0?0:r>1?1:r}function h(t){return 360*(t-.5)}function f(t){var e=(180-360*t)*Math.PI/180;return 360*Math.atan(Math.exp(e))/Math.PI-90}function d(t,e){for(var r in e)t[r]=e[r];return t}function p(t){return t.x}function m(t){return t.y}var v=t(\"kdbush\");e.exports=n,i.prototype={options:{minZoom:0,maxZoom:16,radius:40,extent:512,nodeSize:64,log:!1,reduce:null,initial:function(){return{}},map:function(t){return t}},load:function(t){var e=this.options.log;e&&console.time(\"total time\");var r=\"prepare \"+t.length+\" points\";e&&console.time(r),this.points=t;var n=t.map(o);e&&console.timeEnd(r);for(var i=this.options.maxZoom;i>=this.options.minZoom;i--){var a=+Date.now();this.trees[i+1]=v(n,p,m,this.options.nodeSize,Float32Array),n=this._cluster(n,i),e&&console.log(\"z%d: %d clusters in %dms\",i,n.length,+Date.now()-a)}return this.trees[this.options.minZoom]=v(n,p,m,this.options.nodeSize,Float32Array),e&&console.timeEnd(\"total time\"),this},getClusters:function(t,e){for(var r=this.trees[this._limitZoom(e)],n=r.range(u(t[0]),c(t[3]),u(t[2]),c(t[1])),i=[],a=0;a<n.length;a++){var o=r.points[n[a]];i.push(o.numPoints?s(o):this.points[o.id])}return i},getChildren:function(t,e){for(var r=this.trees[e+1].points[t],n=this.options.radius/(this.options.extent*Math.pow(2,e)),i=this.trees[e+1].within(r.x,r.y,n),a=[],o=0;o<i.length;o++){var l=this.trees[e+1].points[i[o]];l.parentId===t&&a.push(l.numPoints?s(l):this.points[l.id])}return a},getLeaves:function(t,e,r,n){r=r||10,n=n||0;var i=[];return this._appendLeaves(i,t,e,r,n,0),i},getTile:function(t,e,r){var n=this.trees[this._limitZoom(t)],i=Math.pow(2,t),a=this.options.extent,o=this.options.radius,s=o/a,l=(r-s)/i,u=(r+1+s)/i,c={features:[]};return this._addTileFeatures(n.range((e-s)/i,l,(e+1+s)/i,u),n.points,e,r,i,c),0===e&&this._addTileFeatures(n.range(1-s/i,l,1,u),n.points,i,r,i,c),e===i-1&&this._addTileFeatures(n.range(0,l,s/i,u),n.points,-1,r,i,c),c.features.length?c:null},getClusterExpansionZoom:function(t,e){for(;e<this.options.maxZoom;){var r=this.getChildren(t,e);if(e++,1!==r.length)break;t=r[0].properties.cluster_id}return e},_appendLeaves:function(t,e,r,n,i,a){for(var o=this.getChildren(e,r),s=0;s<o.length;s++){var l=o[s].properties;if(l.cluster?a+l.point_count<=i?a+=l.point_count:a=this._appendLeaves(t,l.cluster_id,r+1,n,i,a):a<i?a++:t.push(o[s]),t.length===n)break}return a},_addTileFeatures:function(t,e,r,n,i,a){for(var o=0;o<t.length;o++){var s=e[t[o]];a.features.push({type:1,geometry:[[Math.round(this.options.extent*(s.x*i-r)),Math.round(this.options.extent*(s.y*i-n))]],tags:s.numPoints?l(s):this.points[s.id].properties})}},_limitZoom:function(t){return Math.max(this.options.minZoom,Math.min(t,this.options.maxZoom+1))},_cluster:function(t,e){for(var r=[],n=this.options.radius/(this.options.extent*Math.pow(2,e)),i=0;i<t.length;i++){var o=t[i];if(!(o.zoom<=e)){o.zoom=e;var s=this.trees[e+1],l=s.within(o.x,o.y,n),u=o.numPoints||1,c=o.x*u,h=o.y*u,f=null;this.options.reduce&&(f=this.options.initial(),this._accumulate(f,o));for(var d=0;d<l.length;d++){var p=s.points[l[d]];if(e<p.zoom){var m=p.numPoints||1;p.zoom=e,c+=p.x*m,h+=p.y*m,u+=m,p.parentId=i,this.options.reduce&&this._accumulate(f,p)}}1===u?r.push(o):(o.parentId=i,r.push(a(c/u,h/u,u,i,f)))}}return r},_accumulate:function(t,e){var r=e.numPoints?e.properties:this.options.map(this.points[e.id].properties);this.options.reduce(t,r)}}},{kdbush:297}],529:[function(t,e,r){\"use strict\";function n(t){return t.split(\"\").map(function(t){return t in i?i[t]:\"\"}).join(\"\")}e.exports=n;var i={\" \":\" \",0:\"\\u2070\",1:\"\\xb9\",2:\"\\xb2\",3:\"\\xb3\",4:\"\\u2074\",5:\"\\u2075\",6:\"\\u2076\",7:\"\\u2077\",8:\"\\u2078\",9:\"\\u2079\",\"+\":\"\\u207a\",\"-\":\"\\u207b\",a:\"\\u1d43\",b:\"\\u1d47\",c:\"\\u1d9c\",d:\"\\u1d48\",e:\"\\u1d49\",f:\"\\u1da0\",g:\"\\u1d4d\",h:\"\\u02b0\",i:\"\\u2071\",j:\"\\u02b2\",k:\"\\u1d4f\",l:\"\\u02e1\",m:\"\\u1d50\",n:\"\\u207f\",o:\"\\u1d52\",p:\"\\u1d56\",r:\"\\u02b3\",s:\"\\u02e2\",t:\"\\u1d57\",u:\"\\u1d58\",v:\"\\u1d5b\",w:\"\\u02b7\",x:\"\\u02e3\",y:\"\\u02b8\",z:\"\\u1dbb\"}},{}],530:[function(t,e,r){\"use strict\";function n(t,e){var r=t.length,n=[\"'use strict';\"],i=\"surfaceNets\"+t.join(\"_\")+\"d\"+e;n.push(\"var contour=genContour({\",\"order:[\",t.join(),\"],\",\"scalarArguments: 3,\",\"phase:function phaseFunc(p,a,b,c) { return (p > c)|0 },\"),\"generic\"===e&&n.push(\"getters:[0],\");for(var a=[],l=[],u=0;u<r;++u)a.push(\"d\"+u),l.push(\"d\"+u);for(var u=0;u<1<<r;++u)a.push(\"v\"+u),l.push(\"v\"+u);for(var u=0;u<1<<r;++u)a.push(\"p\"+u),l.push(\"p\"+u);a.push(\"a\",\"b\",\"c\"),l.push(\"a\",\"c\"),n.push(\"vertex:function vertexFunc(\",a.join(),\"){\");for(var c=[],u=0;u<1<<r;++u)c.push(\"(p\"+u+\"<<\"+u+\")\");n.push(\"var m=(\",c.join(\"+\"),\")|0;if(m===0||m===\",(1<<(1<<r))-1,\"){return}\");var h=[],f=[];1<<(1<<r)<=128?(n.push(\"switch(m){\"),f=n):n.push(\"switch(m>>>7){\");for(var u=0;u<1<<(1<<r);++u){if(1<<(1<<r)>128&&u%128==0){h.length>0&&f.push(\"}}\");var d=\"vExtra\"+h.length;n.push(\"case \",u>>>7,\":\",d,\"(m&0x7f,\",l.join(),\");break;\"),f=[\"function \",d,\"(m,\",l.join(),\"){switch(m){\"],h.push(f)}f.push(\"case \",127&u,\":\");for(var p=new Array(r),m=new Array(r),v=new Array(r),g=new Array(r),y=0,b=0;b<r;++b)p[b]=[],m[b]=[],v[b]=0,g[b]=0;for(var b=0;b<1<<r;++b)for(var x=0;x<r;++x){var _=b^1<<x;if(!(_>b)&&!(u&1<<_)!=!(u&1<<b)){var w=1;u&1<<_?m[x].push(\"v\"+_+\"-v\"+b):(m[x].push(\"v\"+b+\"-v\"+_),w=-w),w<0?(p[x].push(\"-v\"+b+\"-v\"+_),v[x]+=2):(p[x].push(\"v\"+b+\"+v\"+_),v[x]-=2),y+=1;for(var M=0;M<r;++M)M!==x&&(_&1<<M?g[M]+=1:g[M]-=1)}}for(var k=[],x=0;x<r;++x)if(0===p[x].length)k.push(\"d\"+x+\"-0.5\");else{var A=\"\";v[x]<0?A=v[x]+\"*c\":v[x]>0&&(A=\"+\"+v[x]+\"*c\");var T=p[x].length/y*.5,S=.5+g[x]/y*.5;k.push(\"d\"+x+\"-\"+S+\"-\"+T+\"*(\"+p[x].join(\"+\")+A+\")/(\"+m[x].join(\"+\")+\")\")}f.push(\"a.push([\",k.join(),\"]);\",\"break;\")}n.push(\"}},\"),h.length>0&&f.push(\"}}\");for(var E=[],u=0;u<1<<r-1;++u)E.push(\"v\"+u);E.push(\"c0\",\"c1\",\"p0\",\"p1\",\"a\",\"b\",\"c\"),n.push(\"cell:function cellFunc(\",E.join(),\"){\");var L=s(r-1);n.push(\"if(p0){b.push(\",L.map(function(t){return\"[\"+t.map(function(t){return\"v\"+t})+\"]\"}).join(),\")}else{b.push(\",L.map(function(t){var e=t.slice();return e.reverse(),\"[\"+e.map(function(t){return\"v\"+t})+\"]\"}).join(),\")}}});function \",i,\"(array,level){var verts=[],cells=[];contour(array,verts,cells,level);return {positions:verts,cells:cells};} return \",i,\";\");for(var u=0;u<h.length;++u)n.push(h[u].join(\"\"));return new Function(\"genContour\",n.join(\"\"))(o)}function i(t,e){for(var r=l(t,e),n=r.length,i=new Array(n),a=new Array(n),o=0;o<n;++o)i[o]=[r[o]],a[o]=[o];return{positions:i,cells:a}}function a(t,e){if(t.dimension<=0)return{positions:[],cells:[]};if(1===t.dimension)return i(t,e);var r=t.order.join()+\"-\"+t.dtype,a=u[r],e=+e||0;return a||(a=u[r]=n(t.order,t.dtype)),a(t,e)}e.exports=a;var o=t(\"ndarray-extract-contour\"),s=t(\"triangulate-hypercube\"),l=t(\"zero-crossings\"),u={}},{\"ndarray-extract-contour\":455,\"triangulate-hypercube\":536,\"zero-crossings\":583}],531:[function(t,e,r){(function(r){\"use strict\";function n(t){for(var e=t.cells,r=t.positions,n=new Float32Array(6*e.length),i=0,a=0,o=0;o<e.length;++o)for(var s=e[o],l=0;l<3;++l){var u=r[s[l]];n[i++]=u[0],n[i++]=u[1]+1.4,a=Math.max(u[0],a)}return{data:n,shape:a}}function i(t,e,r){var r=r||{},o=s[t];o||(o=s[t]={\" \":{data:new Float32Array(0),shape:.2}});var l=o[e];if(!l)if(e.length<=1||!/\\d/.test(e))l=o[e]=n(a(e,{triangles:!0,font:t,textAlign:r.textAlign||\"left\",textBaseline:\"alphabetic\"}));else{for(var u=e.split(/(\\d|\\s)/),c=new Array(u.length),h=0,f=0,d=0;d<u.length;++d)c[d]=i(t,u[d]),h+=c[d].data.length,f+=c[d].shape,d>0&&(f+=.02);for(var p=new Float32Array(h),m=0,v=-.5*f,d=0;d<c.length;++d){for(var g=c[d].data,y=0;y<g.length;y+=2)p[m++]=g[y]+v,p[m++]=g[y+1];v+=c[d].shape+.02}l=o[e]={data:p,shape:f}}return l}e.exports=i;var a=t(\"vectorize-text\"),o=window||r.global||{},s=o.__TEXT_CACHE||{};o.__TEXT_CACHE={}}).call(this,t(\"_process\"))},{_process:486,\"vectorize-text\":553}],532:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){this.fontSize=t||24,this.buffer=void 0===e?3:e,this.cutoff=n||.25,this.fontFamily=i||\"sans-serif\",this.radius=r||8;var a=this.size=this.fontSize+2*this.buffer;this.canvas=document.createElement(\"canvas\"),this.canvas.width=this.canvas.height=a,this.ctx=this.canvas.getContext(\"2d\"),this.ctx.font=t+\"px \"+this.fontFamily,this.ctx.textBaseline=\"middle\",this.ctx.fillStyle=\"black\",this.gridOuter=new Float64Array(a*a),this.gridInner=new Float64Array(a*a),this.f=new Float64Array(a),this.d=new Float64Array(a),this.z=new Float64Array(a+1),this.v=new Int16Array(a),this.middle=Math.round(a/2*(navigator.userAgent.indexOf(\"Gecko/\")>=0?1.2:1))}function i(t,e,r,n,i,o,s){for(var l=0;l<e;l++){for(var u=0;u<r;u++)n[u]=t[u*e+l];for(a(n,i,o,s,r),u=0;u<r;u++)t[u*e+l]=i[u]}for(u=0;u<r;u++){for(l=0;l<e;l++)n[l]=t[u*e+l];for(a(n,i,o,s,e),l=0;l<e;l++)t[u*e+l]=Math.sqrt(i[l])}}function a(t,e,r,n,i){r[0]=0,n[0]=-o,n[1]=+o;for(var a=1,s=0;a<i;a++){for(var l=(t[a]+a*a-(t[r[s]]+r[s]*r[s]))/(2*a-2*r[s]);l<=n[s];)s--,l=(t[a]+a*a-(t[r[s]]+r[s]*r[s]))/(2*a-2*r[s]);s++,r[s]=a,n[s]=l,n[s+1]=+o}for(a=0,s=0;a<i;a++){\n",
       "for(;n[s+1]<a;)s++;e[a]=(a-r[s])*(a-r[s])+t[r[s]]}}e.exports=n;var o=1e20;n.prototype.draw=function(t){this.ctx.clearRect(0,0,this.size,this.size),this.ctx.fillText(t,this.buffer,this.middle);for(var e=this.ctx.getImageData(0,0,this.size,this.size),r=e.data,n=0;n<this.size*this.size;n++){var a=r[4*n+3]/255;this.gridOuter[n]=1===a?0:0===a?o:Math.pow(Math.max(0,.5-a),2),this.gridInner[n]=1===a?o:0===a?0:Math.pow(Math.max(0,a-.5),2)}for(i(this.gridOuter,this.size,this.size,this.f,this.d,this.v,this.z),i(this.gridInner,this.size,this.size,this.f,this.d,this.v,this.z),n=0;n<this.size*this.size;n++){var s=this.gridOuter[n]-this.gridInner[n],l=Math.max(0,Math.min(255,Math.round(255-255*(s/this.radius+this.cutoff))));r[4*n+0]=l,r[4*n+1]=l,r[4*n+2]=l,r[4*n+3]=255}return e}},{}],533:[function(e,r,n){!function(e){function n(t,e){if(t=t||\"\",e=e||{},t instanceof n)return t;if(!(this instanceof n))return new n(t,e);var r=i(t);this._originalInput=t,this._r=r.r,this._g=r.g,this._b=r.b,this._a=r.a,this._roundA=V(100*this._a)/100,this._format=e.format||r.format,this._gradientType=e.gradientType,this._r<1&&(this._r=V(this._r)),this._g<1&&(this._g=V(this._g)),this._b<1&&(this._b=V(this._b)),this._ok=r.ok,this._tc_id=U++}function i(t){var e={r:0,g:0,b:0},r=1,n=null,i=null,o=null,l=!1,c=!1;return\"string\"==typeof t&&(t=F(t)),\"object\"==typeof t&&(R(t.r)&&R(t.g)&&R(t.b)?(e=a(t.r,t.g,t.b),l=!0,c=\"%\"===String(t.r).substr(-1)?\"prgb\":\"rgb\"):R(t.h)&&R(t.s)&&R(t.v)?(n=D(t.s),i=D(t.v),e=u(t.h,n,i),l=!0,c=\"hsv\"):R(t.h)&&R(t.s)&&R(t.l)&&(n=D(t.s),o=D(t.l),e=s(t.h,n,o),l=!0,c=\"hsl\"),t.hasOwnProperty(\"a\")&&(r=t.a)),r=T(r),{ok:l,format:t.format||c,r:H(255,q(e.r,0)),g:H(255,q(e.g,0)),b:H(255,q(e.b,0)),a:r}}function a(t,e,r){return{r:255*S(t,255),g:255*S(e,255),b:255*S(r,255)}}function o(t,e,r){t=S(t,255),e=S(e,255),r=S(r,255);var n,i,a=q(t,e,r),o=H(t,e,r),s=(a+o)/2;if(a==o)n=i=0;else{var l=a-o;switch(i=s>.5?l/(2-a-o):l/(a+o),a){case t:n=(e-r)/l+(e<r?6:0);break;case e:n=(r-t)/l+2;break;case r:n=(t-e)/l+4}n/=6}return{h:n,s:i,l:s}}function s(t,e,r){function n(t,e,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?t+6*(e-t)*r:r<.5?e:r<2/3?t+(e-t)*(2/3-r)*6:t}var i,a,o;if(t=S(t,360),e=S(e,100),r=S(r,100),0===e)i=a=o=r;else{var s=r<.5?r*(1+e):r+e-r*e,l=2*r-s;i=n(l,s,t+1/3),a=n(l,s,t),o=n(l,s,t-1/3)}return{r:255*i,g:255*a,b:255*o}}function l(t,e,r){t=S(t,255),e=S(e,255),r=S(r,255);var n,i,a=q(t,e,r),o=H(t,e,r),s=a,l=a-o;if(i=0===a?0:l/a,a==o)n=0;else{switch(a){case t:n=(e-r)/l+(e<r?6:0);break;case e:n=(r-t)/l+2;break;case r:n=(t-e)/l+4}n/=6}return{h:n,s:i,v:s}}function u(t,r,n){t=6*S(t,360),r=S(r,100),n=S(n,100);var i=e.floor(t),a=t-i,o=n*(1-r),s=n*(1-a*r),l=n*(1-(1-a)*r),u=i%6;return{r:255*[n,s,o,o,l,n][u],g:255*[l,n,n,s,o,o][u],b:255*[o,o,l,n,n,s][u]}}function c(t,e,r,n){var i=[I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16))];return n&&i[0].charAt(0)==i[0].charAt(1)&&i[1].charAt(0)==i[1].charAt(1)&&i[2].charAt(0)==i[2].charAt(1)?i[0].charAt(0)+i[1].charAt(0)+i[2].charAt(0):i.join(\"\")}function h(t,e,r,n,i){var a=[I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16)),I(P(n))];return i&&a[0].charAt(0)==a[0].charAt(1)&&a[1].charAt(0)==a[1].charAt(1)&&a[2].charAt(0)==a[2].charAt(1)&&a[3].charAt(0)==a[3].charAt(1)?a[0].charAt(0)+a[1].charAt(0)+a[2].charAt(0)+a[3].charAt(0):a.join(\"\")}function f(t,e,r,n){return[I(P(n)),I(V(t).toString(16)),I(V(e).toString(16)),I(V(r).toString(16))].join(\"\")}function d(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.s-=e/100,r.s=E(r.s),n(r)}function p(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.s+=e/100,r.s=E(r.s),n(r)}function m(t){return n(t).desaturate(100)}function v(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.l+=e/100,r.l=E(r.l),n(r)}function g(t,e){e=0===e?0:e||10;var r=n(t).toRgb();return r.r=q(0,H(255,r.r-V(-e/100*255))),r.g=q(0,H(255,r.g-V(-e/100*255))),r.b=q(0,H(255,r.b-V(-e/100*255))),n(r)}function y(t,e){e=0===e?0:e||10;var r=n(t).toHsl();return r.l-=e/100,r.l=E(r.l),n(r)}function b(t,e){var r=n(t).toHsl(),i=(r.h+e)%360;return r.h=i<0?360+i:i,n(r)}function x(t){var e=n(t).toHsl();return e.h=(e.h+180)%360,n(e)}function _(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+120)%360,s:e.s,l:e.l}),n({h:(r+240)%360,s:e.s,l:e.l})]}function w(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+90)%360,s:e.s,l:e.l}),n({h:(r+180)%360,s:e.s,l:e.l}),n({h:(r+270)%360,s:e.s,l:e.l})]}function M(t){var e=n(t).toHsl(),r=e.h;return[n(t),n({h:(r+72)%360,s:e.s,l:e.l}),n({h:(r+216)%360,s:e.s,l:e.l})]}function k(t,e,r){e=e||6,r=r||30;var i=n(t).toHsl(),a=360/r,o=[n(t)];for(i.h=(i.h-(a*e>>1)+720)%360;--e;)i.h=(i.h+a)%360,o.push(n(i));return o}function A(t,e){e=e||6;for(var r=n(t).toHsv(),i=r.h,a=r.s,o=r.v,s=[],l=1/e;e--;)s.push(n({h:i,s:a,v:o})),o=(o+l)%1;return s}function T(t){return t=parseFloat(t),(isNaN(t)||t<0||t>1)&&(t=1),t}function S(t,r){C(t)&&(t=\"100%\");var n=z(t);return t=H(r,q(0,parseFloat(t))),n&&(t=parseInt(t*r,10)/100),e.abs(t-r)<1e-6?1:t%r/parseFloat(r)}function E(t){return H(1,q(0,t))}function L(t){return parseInt(t,16)}function C(t){return\"string\"==typeof t&&-1!=t.indexOf(\".\")&&1===parseFloat(t)}function z(t){return\"string\"==typeof t&&-1!=t.indexOf(\"%\")}function I(t){return 1==t.length?\"0\"+t:\"\"+t}function D(t){return t<=1&&(t=100*t+\"%\"),t}function P(t){return e.round(255*parseFloat(t)).toString(16)}function O(t){return L(t)/255}function R(t){return!!W.CSS_UNIT.exec(t)}function F(t){t=t.replace(N,\"\").replace(B,\"\").toLowerCase();var e=!1;if(Y[t])t=Y[t],e=!0;else if(\"transparent\"==t)return{r:0,g:0,b:0,a:0,format:\"name\"};var r;return(r=W.rgb.exec(t))?{r:r[1],g:r[2],b:r[3]}:(r=W.rgba.exec(t))?{r:r[1],g:r[2],b:r[3],a:r[4]}:(r=W.hsl.exec(t))?{h:r[1],s:r[2],l:r[3]}:(r=W.hsla.exec(t))?{h:r[1],s:r[2],l:r[3],a:r[4]}:(r=W.hsv.exec(t))?{h:r[1],s:r[2],v:r[3]}:(r=W.hsva.exec(t))?{h:r[1],s:r[2],v:r[3],a:r[4]}:(r=W.hex8.exec(t))?{r:L(r[1]),g:L(r[2]),b:L(r[3]),a:O(r[4]),format:e?\"name\":\"hex8\"}:(r=W.hex6.exec(t))?{r:L(r[1]),g:L(r[2]),b:L(r[3]),format:e?\"name\":\"hex\"}:(r=W.hex4.exec(t))?{r:L(r[1]+\"\"+r[1]),g:L(r[2]+\"\"+r[2]),b:L(r[3]+\"\"+r[3]),a:O(r[4]+\"\"+r[4]),format:e?\"name\":\"hex8\"}:!!(r=W.hex3.exec(t))&&{r:L(r[1]+\"\"+r[1]),g:L(r[2]+\"\"+r[2]),b:L(r[3]+\"\"+r[3]),format:e?\"name\":\"hex\"}}function j(t){var e,r;return t=t||{level:\"AA\",size:\"small\"},e=(t.level||\"AA\").toUpperCase(),r=(t.size||\"small\").toLowerCase(),\"AA\"!==e&&\"AAA\"!==e&&(e=\"AA\"),\"small\"!==r&&\"large\"!==r&&(r=\"small\"),{level:e,size:r}}var N=/^\\s+/,B=/\\s+$/,U=0,V=e.round,H=e.min,q=e.max,G=e.random;n.prototype={isDark:function(){return this.getBrightness()<128},isLight:function(){return!this.isDark()},isValid:function(){return this._ok},getOriginalInput:function(){return this._originalInput},getFormat:function(){return this._format},getAlpha:function(){return this._a},getBrightness:function(){var t=this.toRgb();return(299*t.r+587*t.g+114*t.b)/1e3},getLuminance:function(){var t,r,n,i,a,o,s=this.toRgb();return t=s.r/255,r=s.g/255,n=s.b/255,i=t<=.03928?t/12.92:e.pow((t+.055)/1.055,2.4),a=r<=.03928?r/12.92:e.pow((r+.055)/1.055,2.4),o=n<=.03928?n/12.92:e.pow((n+.055)/1.055,2.4),.2126*i+.7152*a+.0722*o},setAlpha:function(t){return this._a=T(t),this._roundA=V(100*this._a)/100,this},toHsv:function(){var t=l(this._r,this._g,this._b);return{h:360*t.h,s:t.s,v:t.v,a:this._a}},toHsvString:function(){var t=l(this._r,this._g,this._b),e=V(360*t.h),r=V(100*t.s),n=V(100*t.v);return 1==this._a?\"hsv(\"+e+\", \"+r+\"%, \"+n+\"%)\":\"hsva(\"+e+\", \"+r+\"%, \"+n+\"%, \"+this._roundA+\")\"},toHsl:function(){var t=o(this._r,this._g,this._b);return{h:360*t.h,s:t.s,l:t.l,a:this._a}},toHslString:function(){var t=o(this._r,this._g,this._b),e=V(360*t.h),r=V(100*t.s),n=V(100*t.l);return 1==this._a?\"hsl(\"+e+\", \"+r+\"%, \"+n+\"%)\":\"hsla(\"+e+\", \"+r+\"%, \"+n+\"%, \"+this._roundA+\")\"},toHex:function(t){return c(this._r,this._g,this._b,t)},toHexString:function(t){return\"#\"+this.toHex(t)},toHex8:function(t){return h(this._r,this._g,this._b,this._a,t)},toHex8String:function(t){return\"#\"+this.toHex8(t)},toRgb:function(){return{r:V(this._r),g:V(this._g),b:V(this._b),a:this._a}},toRgbString:function(){return 1==this._a?\"rgb(\"+V(this._r)+\", \"+V(this._g)+\", \"+V(this._b)+\")\":\"rgba(\"+V(this._r)+\", \"+V(this._g)+\", \"+V(this._b)+\", \"+this._roundA+\")\"},toPercentageRgb:function(){return{r:V(100*S(this._r,255))+\"%\",g:V(100*S(this._g,255))+\"%\",b:V(100*S(this._b,255))+\"%\",a:this._a}},toPercentageRgbString:function(){return 1==this._a?\"rgb(\"+V(100*S(this._r,255))+\"%, \"+V(100*S(this._g,255))+\"%, \"+V(100*S(this._b,255))+\"%)\":\"rgba(\"+V(100*S(this._r,255))+\"%, \"+V(100*S(this._g,255))+\"%, \"+V(100*S(this._b,255))+\"%, \"+this._roundA+\")\"},toName:function(){return 0===this._a?\"transparent\":!(this._a<1)&&(X[c(this._r,this._g,this._b,!0)]||!1)},toFilter:function(t){var e=\"#\"+f(this._r,this._g,this._b,this._a),r=e,i=this._gradientType?\"GradientType = 1, \":\"\";if(t){var a=n(t);r=\"#\"+f(a._r,a._g,a._b,a._a)}return\"progid:DXImageTransform.Microsoft.gradient(\"+i+\"startColorstr=\"+e+\",endColorstr=\"+r+\")\"},toString:function(t){var e=!!t;t=t||this._format;var r=!1,n=this._a<1&&this._a>=0;return e||!n||\"hex\"!==t&&\"hex6\"!==t&&\"hex3\"!==t&&\"hex4\"!==t&&\"hex8\"!==t&&\"name\"!==t?(\"rgb\"===t&&(r=this.toRgbString()),\"prgb\"===t&&(r=this.toPercentageRgbString()),\"hex\"!==t&&\"hex6\"!==t||(r=this.toHexString()),\"hex3\"===t&&(r=this.toHexString(!0)),\"hex4\"===t&&(r=this.toHex8String(!0)),\"hex8\"===t&&(r=this.toHex8String()),\"name\"===t&&(r=this.toName()),\"hsl\"===t&&(r=this.toHslString()),\"hsv\"===t&&(r=this.toHsvString()),r||this.toHexString()):\"name\"===t&&0===this._a?this.toName():this.toRgbString()},clone:function(){return n(this.toString())},_applyModification:function(t,e){var r=t.apply(null,[this].concat([].slice.call(e)));return this._r=r._r,this._g=r._g,this._b=r._b,this.setAlpha(r._a),this},lighten:function(){return this._applyModification(v,arguments)},brighten:function(){return this._applyModification(g,arguments)},darken:function(){return this._applyModification(y,arguments)},desaturate:function(){return this._applyModification(d,arguments)},saturate:function(){return this._applyModification(p,arguments)},greyscale:function(){return this._applyModification(m,arguments)},spin:function(){return this._applyModification(b,arguments)},_applyCombination:function(t,e){return t.apply(null,[this].concat([].slice.call(e)))},analogous:function(){return this._applyCombination(k,arguments)},complement:function(){return this._applyCombination(x,arguments)},monochromatic:function(){return this._applyCombination(A,arguments)},splitcomplement:function(){return this._applyCombination(M,arguments)},triad:function(){return this._applyCombination(_,arguments)},tetrad:function(){return this._applyCombination(w,arguments)}},n.fromRatio=function(t,e){if(\"object\"==typeof t){var r={};for(var i in t)t.hasOwnProperty(i)&&(r[i]=\"a\"===i?t[i]:D(t[i]));t=r}return n(t,e)},n.equals=function(t,e){return!(!t||!e)&&n(t).toRgbString()==n(e).toRgbString()},n.random=function(){return n.fromRatio({r:G(),g:G(),b:G()})},n.mix=function(t,e,r){r=0===r?0:r||50;var i=n(t).toRgb(),a=n(e).toRgb(),o=r/100;return n({r:(a.r-i.r)*o+i.r,g:(a.g-i.g)*o+i.g,b:(a.b-i.b)*o+i.b,a:(a.a-i.a)*o+i.a})},n.readability=function(t,r){var i=n(t),a=n(r);return(e.max(i.getLuminance(),a.getLuminance())+.05)/(e.min(i.getLuminance(),a.getLuminance())+.05)},n.isReadable=function(t,e,r){var i,a,o=n.readability(t,e);switch(a=!1,i=j(r),i.level+i.size){case\"AAsmall\":case\"AAAlarge\":a=o>=4.5;break;case\"AAlarge\":a=o>=3;break;case\"AAAsmall\":a=o>=7}return a},n.mostReadable=function(t,e,r){var i,a,o,s,l=null,u=0;r=r||{},a=r.includeFallbackColors,o=r.level,s=r.size;for(var c=0;c<e.length;c++)(i=n.readability(t,e[c]))>u&&(u=i,l=n(e[c]));return n.isReadable(t,l,{level:o,size:s})||!a?l:(r.includeFallbackColors=!1,n.mostReadable(t,[\"#fff\",\"#000\"],r))};var Y=n.names={aliceblue:\"f0f8ff\",antiquewhite:\"faebd7\",aqua:\"0ff\",aquamarine:\"7fffd4\",azure:\"f0ffff\",beige:\"f5f5dc\",bisque:\"ffe4c4\",black:\"000\",blanchedalmond:\"ffebcd\",blue:\"00f\",blueviolet:\"8a2be2\",brown:\"a52a2a\",burlywood:\"deb887\",burntsienna:\"ea7e5d\",cadetblue:\"5f9ea0\",chartreuse:\"7fff00\",chocolate:\"d2691e\",coral:\"ff7f50\",cornflowerblue:\"6495ed\",cornsilk:\"fff8dc\",crimson:\"dc143c\",cyan:\"0ff\",darkblue:\"00008b\",darkcyan:\"008b8b\",darkgoldenrod:\"b8860b\",darkgray:\"a9a9a9\",darkgreen:\"006400\",darkgrey:\"a9a9a9\",darkkhaki:\"bdb76b\",darkmagenta:\"8b008b\",darkolivegreen:\"556b2f\",darkorange:\"ff8c00\",darkorchid:\"9932cc\",darkred:\"8b0000\",darksalmon:\"e9967a\",darkseagreen:\"8fbc8f\",darkslateblue:\"483d8b\",darkslategray:\"2f4f4f\",darkslategrey:\"2f4f4f\",darkturquoise:\"00ced1\",darkviolet:\"9400d3\",deeppink:\"ff1493\",deepskyblue:\"00bfff\",dimgray:\"696969\",dimgrey:\"696969\",dodgerblue:\"1e90ff\",firebrick:\"b22222\",floralwhite:\"fffaf0\",forestgreen:\"228b22\",fuchsia:\"f0f\",gainsboro:\"dcdcdc\",ghostwhite:\"f8f8ff\",gold:\"ffd700\",goldenrod:\"daa520\",gray:\"808080\",green:\"008000\",greenyellow:\"adff2f\",grey:\"808080\",honeydew:\"f0fff0\",hotpink:\"ff69b4\",indianred:\"cd5c5c\",indigo:\"4b0082\",ivory:\"fffff0\",khaki:\"f0e68c\",lavender:\"e6e6fa\",lavenderblush:\"fff0f5\",lawngreen:\"7cfc00\",lemonchiffon:\"fffacd\",lightblue:\"add8e6\",lightcoral:\"f08080\",lightcyan:\"e0ffff\",lightgoldenrodyellow:\"fafad2\",lightgray:\"d3d3d3\",lightgreen:\"90ee90\",lightgrey:\"d3d3d3\",lightpink:\"ffb6c1\",lightsalmon:\"ffa07a\",lightseagreen:\"20b2aa\",lightskyblue:\"87cefa\",lightslategray:\"789\",lightslategrey:\"789\",lightsteelblue:\"b0c4de\",lightyellow:\"ffffe0\",lime:\"0f0\",limegreen:\"32cd32\",linen:\"faf0e6\",magenta:\"f0f\",maroon:\"800000\",mediumaquamarine:\"66cdaa\",mediumblue:\"0000cd\",mediumorchid:\"ba55d3\",mediumpurple:\"9370db\",mediumseagreen:\"3cb371\",mediumslateblue:\"7b68ee\",mediumspringgreen:\"00fa9a\",mediumturquoise:\"48d1cc\",mediumvioletred:\"c71585\",midnightblue:\"191970\",mintcream:\"f5fffa\",mistyrose:\"ffe4e1\",moccasin:\"ffe4b5\",navajowhite:\"ffdead\",navy:\"000080\",oldlace:\"fdf5e6\",olive:\"808000\",olivedrab:\"6b8e23\",orange:\"ffa500\",orangered:\"ff4500\",orchid:\"da70d6\",palegoldenrod:\"eee8aa\",palegreen:\"98fb98\",paleturquoise:\"afeeee\",palevioletred:\"db7093\",papayawhip:\"ffefd5\",peachpuff:\"ffdab9\",peru:\"cd853f\",pink:\"ffc0cb\",plum:\"dda0dd\",powderblue:\"b0e0e6\",purple:\"800080\",rebeccapurple:\"663399\",red:\"f00\",rosybrown:\"bc8f8f\",royalblue:\"4169e1\",saddlebrown:\"8b4513\",salmon:\"fa8072\",sandybrown:\"f4a460\",seagreen:\"2e8b57\",seashell:\"fff5ee\",sienna:\"a0522d\",silver:\"c0c0c0\",skyblue:\"87ceeb\",slateblue:\"6a5acd\",slategray:\"708090\",slategrey:\"708090\",snow:\"fffafa\",springgreen:\"00ff7f\",steelblue:\"4682b4\",tan:\"d2b48c\",teal:\"008080\",thistle:\"d8bfd8\",tomato:\"ff6347\",turquoise:\"40e0d0\",violet:\"ee82ee\",wheat:\"f5deb3\",white:\"fff\",whitesmoke:\"f5f5f5\",yellow:\"ff0\",yellowgreen:\"9acd32\"},X=n.hexNames=function(t){var e={};for(var r in t)t.hasOwnProperty(r)&&(e[t[r]]=r);return e}(Y),W=function(){var t=\"(?:[-\\\\+]?\\\\d*\\\\.\\\\d+%?)|(?:[-\\\\+]?\\\\d+%?)\",e=\"[\\\\s|\\\\(]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")\\\\s*\\\\)?\",r=\"[\\\\s|\\\\(]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")[,|\\\\s]+(\"+t+\")\\\\s*\\\\)?\";return{CSS_UNIT:new RegExp(t),rgb:new RegExp(\"rgb\"+e),rgba:new RegExp(\"rgba\"+r),hsl:new RegExp(\"hsl\"+e),hsla:new RegExp(\"hsla\"+r),hsv:new RegExp(\"hsv\"+e),hsva:new RegExp(\"hsva\"+r),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,hex4:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex8:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/}}();void 0!==r&&r.exports?r.exports=n:\"function\"==typeof t&&t.amd?t(function(){return n}):window.tinycolor=n}(Math)},{}],534:[function(t,e,r){\"use strict\";function n(t,e){var r=o(getComputedStyle(t).getPropertyValue(e));return r[0]*a(r[1],t)}function i(t,e){var r=document.createElement(\"div\");r.style[\"font-size\"]=\"128\"+t,e.appendChild(r);var i=n(r,\"font-size\")/128;return e.removeChild(r),i}function a(t,e){switch(e=e||document.body,t=(t||\"px\").trim().toLowerCase(),e!==window&&e!==document||(e=document.body),t){case\"%\":return e.clientHeight/100;case\"ch\":case\"ex\":return i(t,e);case\"em\":return n(e,\"font-size\");case\"rem\":return n(document.body,\"font-size\");case\"vw\":return window.innerWidth/100;case\"vh\":return window.innerHeight/100;case\"vmin\":return Math.min(window.innerWidth,window.innerHeight)/100;case\"vmax\":return Math.max(window.innerWidth,window.innerHeight)/100;case\"in\":return s;case\"cm\":return s/2.54;case\"mm\":return s/25.4;case\"pt\":return s/72;case\"pc\":return s/6}return 1}var o=t(\"parse-unit\");e.exports=a;var s=96},{\"parse-unit\":474}],535:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.topojson=e.topojson||{})}(this,function(t){\"use strict\";function e(t,e){var n=e.id,i=e.bbox,a=null==e.properties?{}:e.properties,o=r(t,e);return null==n&&null==i?{type:\"Feature\",properties:a,geometry:o}:null==i?{type:\"Feature\",id:n,properties:a,geometry:o}:{type:\"Feature\",id:n,bbox:i,properties:a,geometry:o}}function r(t,e){function r(t,e){e.length&&e.pop();for(var r=h[t<0?~t:t],n=0,i=r.length;n<i;++n)e.push(u(r[n].slice(),n));t<0&&c(e,i)}function n(t){return u(t.slice())}function i(t){for(var e=[],n=0,i=t.length;n<i;++n)r(t[n],e);return e.length<2&&e.push(e[0].slice()),e}function a(t){for(var e=i(t);e.length<4;)e.push(e[0].slice());return e}function o(t){return t.map(a)}function s(t){var e,r=t.type;switch(r){case\"GeometryCollection\":return{type:r,geometries:t.geometries.map(s)};case\"Point\":e=n(t.coordinates);break;case\"MultiPoint\":e=t.coordinates.map(n);break;case\"LineString\":e=i(t.arcs);break;case\"MultiLineString\":e=t.arcs.map(i);break;case\"Polygon\":e=o(t.arcs);break;case\"MultiPolygon\":e=t.arcs.map(o);break;default:return null}return{type:r,coordinates:e}}var u=l(t),h=t.arcs;return s(e)}function n(t,e,r){var n,a,o;if(arguments.length>1)n=i(t,e,r);else for(a=0,n=new Array(o=t.arcs.length);a<o;++a)n[a]=a;return{type:\"MultiLineString\",arcs:f(t,n)}}function i(t,e,r){function n(t){var e=t<0?~t:t;(c[e]||(c[e]=[])).push({i:t,g:l})}function i(t){t.forEach(n)}function a(t){t.forEach(i)}function o(t){t.forEach(a)}function s(t){switch(l=t,t.type){case\"GeometryCollection\":t.geometries.forEach(s);break;case\"LineString\":i(t.arcs);break;case\"MultiLineString\":case\"Polygon\":a(t.arcs);break;case\"MultiPolygon\":o(t.arcs)}}var l,u=[],c=[];return s(e),c.forEach(null==r?function(t){u.push(t[0].i)}:function(t){r(t[0].g,t[t.length-1].g)&&u.push(t[0].i)}),u}function a(t){for(var e,r=-1,n=t.length,i=t[n-1],a=0;++r<n;)e=i,i=t[r],a+=e[0]*i[1]-e[1]*i[0];return Math.abs(a)}function o(t,e){function n(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(n);break;case\"Polygon\":i(t.arcs);break;case\"MultiPolygon\":t.arcs.forEach(i)}}function i(t){t.forEach(function(e){e.forEach(function(e){(s[e=e<0?~e:e]||(s[e]=[])).push(t)})}),l.push(t)}function o(e){return a(r(t,{type:\"Polygon\",arcs:[e]}).coordinates[0])}var s={},l=[],u=[];return e.forEach(n),l.forEach(function(t){if(!t._){var e=[],r=[t];for(t._=1,u.push(e);t=r.pop();)e.push(t),t.forEach(function(t){t.forEach(function(t){s[t<0?~t:t].forEach(function(t){t._||(t._=1,r.push(t))})})})}}),l.forEach(function(t){delete t._}),{type:\"MultiPolygon\",arcs:u.map(function(e){var r,n=[];if(e.forEach(function(t){t.forEach(function(t){t.forEach(function(t){s[t<0?~t:t].length<2&&n.push(t)})})}),n=f(t,n),(r=n.length)>1)for(var i,a,l=1,u=o(n[0]);l<r;++l)(i=o(n[l]))>u&&(a=n[0],n[0]=n[l],n[l]=a,u=i);return n})}}var s=function(t){return t},l=function(t){if(null==(e=t.transform))return s;var e,r,n,i=e.scale[0],a=e.scale[1],o=e.translate[0],l=e.translate[1];return function(t,e){return e||(r=n=0),t[0]=(r+=t[0])*i+o,t[1]=(n+=t[1])*a+l,t}},u=function(t){function e(t){s[0]=t[0],s[1]=t[1],o(s),s[0]<u&&(u=s[0]),s[0]>h&&(h=s[0]),s[1]<c&&(c=s[1]),s[1]>f&&(f=s[1])}function r(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(r);break;case\"Point\":e(t.coordinates);break;case\"MultiPoint\":t.coordinates.forEach(e)}}var n=t.bbox;if(!n){var i,a,o=l(t),s=new Array(2),u=1/0,c=u,h=-u,f=-u;t.arcs.forEach(function(t){for(var e=-1,r=t.length;++e<r;)i=t[e],s[0]=i[0],s[1]=i[1],o(s,e),s[0]<u&&(u=s[0]),s[0]>h&&(h=s[0]),s[1]<c&&(c=s[1]),s[1]>f&&(f=s[1])});for(a in t.objects)r(t.objects[a]);n=t.bbox=[u,c,h,f]}return n},c=function(t,e){for(var r,n=t.length,i=n-e;i<--n;)r=t[i],t[i++]=t[n],t[n]=r},h=function(t,r){return\"GeometryCollection\"===r.type?{type:\"FeatureCollection\",features:r.geometries.map(function(r){return e(t,r)})}:e(t,r)},f=function(t,e){function r(e){var r,n=t.arcs[e<0?~e:e],i=n[0];return t.transform?(r=[0,0],n.forEach(function(t){r[0]+=t[0],r[1]+=t[1]})):r=n[n.length-1],e<0?[r,i]:[i,r]}function n(t,e){for(var r in t){var n=t[r];delete e[n.start],delete n.start,delete n.end,n.forEach(function(t){i[t<0?~t:t]=1}),s.push(n)}}var i={},a={},o={},s=[],l=-1;return e.forEach(function(r,n){var i,a=t.arcs[r<0?~r:r];a.length<3&&!a[1][0]&&!a[1][1]&&(i=e[++l],e[l]=r,e[n]=i)}),e.forEach(function(t){var e,n,i=r(t),s=i[0],l=i[1];if(e=o[s])if(delete o[e.end],e.push(t),e.end=l,n=a[l]){delete a[n.start];var u=n===e?e:e.concat(n);a[u.start=e.start]=o[u.end=n.end]=u}else a[e.start]=o[e.end]=e;else if(e=a[l])if(delete a[e.start],e.unshift(t),e.start=s,n=o[s]){delete o[n.end];var c=n===e?e:n.concat(e);a[c.start=n.start]=o[c.end=e.end]=c}else a[e.start]=o[e.end]=e;else e=[t],a[e.start=s]=o[e.end=l]=e}),n(o,a),n(a,o),e.forEach(function(t){i[t<0?~t:t]||s.push([t])}),s},d=function(t){return r(t,n.apply(this,arguments))},p=function(t){return r(t,o.apply(this,arguments))},m=function(t,e){for(var r=0,n=t.length;r<n;){var i=r+n>>>1;t[i]<e?r=i+1:n=i}return r},v=function(t){function e(t,e){t.forEach(function(t){t<0&&(t=~t);var r=i[t];r?r.push(e):i[t]=[e]})}function r(t,r){t.forEach(function(t){e(t,r)})}function n(t,e){\"GeometryCollection\"===t.type?t.geometries.forEach(function(t){n(t,e)}):t.type in o&&o[t.type](t.arcs,e)}var i={},a=t.map(function(){return[]}),o={LineString:e,MultiLineString:r,Polygon:r,MultiPolygon:function(t,e){t.forEach(function(t){r(t,e)})}};t.forEach(n);for(var s in i)for(var l=i[s],u=l.length,c=0;c<u;++c)for(var h=c+1;h<u;++h){var f,d=l[c],p=l[h];(f=a[d])[s=m(f,p)]!==p&&f.splice(s,0,p),(f=a[p])[s=m(f,d)]!==d&&f.splice(s,0,d)}return a},g=function(t,e){function r(t){t[0]=Math.round((t[0]-o)/s),t[1]=Math.round((t[1]-l)/c)}function n(t){switch(t.type){case\"GeometryCollection\":t.geometries.forEach(n);break;case\"Point\":r(t.coordinates);break;case\"MultiPoint\":t.coordinates.forEach(r)}}if(!((e=Math.floor(e))>=2))throw new Error(\"n must be \\u22652\");if(t.transform)throw new Error(\"already quantized\");var i,a=u(t),o=a[0],s=(a[2]-o)/(e-1)||1,l=a[1],c=(a[3]-l)/(e-1)||1;t.arcs.forEach(function(t){for(var e,r,n,i=1,a=1,u=t.length,h=t[0],f=h[0]=Math.round((h[0]-o)/s),d=h[1]=Math.round((h[1]-l)/c);i<u;++i)h=t[i],r=Math.round((h[0]-o)/s),n=Math.round((h[1]-l)/c),r===f&&n===d||(e=t[a++],e[0]=r-f,f=r,e[1]=n-d,d=n);a<2&&(e=t[a++],e[0]=0,e[1]=0),t.length=a});for(i in t.objects)n(t.objects[i]);return t.transform={scale:[s,c],translate:[o,l]},t},y=function(t){if(null==(e=t.transform))return s;var e,r,n,i=e.scale[0],a=e.scale[1],o=e.translate[0],l=e.translate[1];return function(t,e){e||(r=n=0);var s=Math.round((t[0]-o)/i),u=Math.round((t[1]-l)/a);return t[0]=s-r,r=s,t[1]=u-n,n=u,t}};t.bbox=u,t.feature=h,t.mesh=d,t.meshArcs=n,t.merge=p,t.mergeArcs=o,t.neighbors=v,t.quantize=g,t.transform=l,t.untransform=y,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],536:[function(t,e,r){\"use strict\";function n(t){if(t<0)return[];if(0===t)return[[0]];for(var e=0|Math.round(o(t+1)),r=[],n=0;n<e;++n){for(var s=i.unrank(t,n),l=[0],u=0,c=0;c<s.length;++c)u+=1<<s[c],l.push(u);a(s)<1&&(l[0]=u,l[t]=0),r.push(l)}return r}e.exports=n;var i=t(\"permutation-rank\"),a=t(\"permutation-parity\"),o=t(\"gamma\")},{gamma:135,\"permutation-parity\":478,\"permutation-rank\":479}],537:[function(t,e,r){\"use strict\";function n(t,e,r){return Math.sqrt(Math.pow(t,2)+Math.pow(e,2)+Math.pow(r,2))}function i(t){return Math.min(1,Math.max(-1,t))}function a(t){var e=Math.abs(t[0]),r=Math.abs(t[1]),n=Math.abs(t[2]),i=[0,0,0];e>Math.max(r,n)?i[2]=1:r>Math.max(e,n)?i[0]=1:i[1]=1;for(var a=0,o=0,s=0;s<3;++s)a+=t[s]*t[s],o+=i[s]*t[s];for(var s=0;s<3;++s)i[s]-=o/a*t[s];return f(i,i),i}function o(t,e,r,n,i,a,o,s){this.center=l(r),this.up=l(n),this.right=l(i),this.radius=l([a]),this.angle=l([o,s]),this.angle.bounds=[[-1/0,-Math.PI/2],[1/0,Math.PI/2]],this.setDistanceLimits(t,e),this.computedCenter=this.center.curve(0),this.computedUp=this.up.curve(0),this.computedRight=this.right.curve(0),this.computedRadius=this.radius.curve(0),this.computedAngle=this.angle.curve(0),this.computedToward=[0,0,0],this.computedEye=[0,0,0],this.computedMatrix=new Array(16);for(var u=0;u<16;++u)this.computedMatrix[u]=.5;this.recalcMatrix(0)}function s(t){t=t||{};var e=t.center||[0,0,0],r=t.up||[0,1,0],i=t.right||a(r),s=t.radius||1,l=t.theta||0,u=t.phi||0;if(e=[].slice.call(e,0,3),r=[].slice.call(r,0,3),f(r,r),i=[].slice.call(i,0,3),f(i,i),\"eye\"in t){var c=t.eye,p=[c[0]-e[0],c[1]-e[1],c[2]-e[2]];h(i,p,r),n(i[0],i[1],i[2])<1e-6?i=a(r):f(i,i),s=n(p[0],p[1],p[2]);var m=d(r,p)/s,v=d(i,p)/s;u=Math.acos(m),l=Math.acos(v)}return s=Math.log(s),new o(t.zoomMin,t.zoomMax,e,r,i,s,l,u)}e.exports=s;var l=t(\"filtered-vector\"),u=t(\"gl-mat4/invert\"),c=t(\"gl-mat4/rotate\"),h=t(\"gl-vec3/cross\"),f=t(\"gl-vec3/normalize\"),d=t(\"gl-vec3/dot\"),p=o.prototype;p.setDistanceLimits=function(t,e){t=t>0?Math.log(t):-1/0,e=e>0?Math.log(e):1/0,e=Math.max(e,t),this.radius.bounds[0][0]=t,this.radius.bounds[1][0]=e},p.getDistanceLimits=function(t){var e=this.radius.bounds[0];return t?(t[0]=Math.exp(e[0][0]),t[1]=Math.exp(e[1][0]),t):[Math.exp(e[0][0]),Math.exp(e[1][0])]},p.recalcMatrix=function(t){this.center.curve(t),this.up.curve(t),this.right.curve(t),this.radius.curve(t),this.angle.curve(t);for(var e=this.computedUp,r=this.computedRight,i=0,a=0,o=0;o<3;++o)a+=e[o]*r[o],i+=e[o]*e[o];for(var s=Math.sqrt(i),l=0,o=0;o<3;++o)r[o]-=e[o]*a/i,l+=r[o]*r[o],e[o]/=s;for(var u=Math.sqrt(l),o=0;o<3;++o)r[o]/=u;var c=this.computedToward;h(c,e,r),f(c,c);for(var d=Math.exp(this.computedRadius[0]),p=this.computedAngle[0],m=this.computedAngle[1],v=Math.cos(p),g=Math.sin(p),y=Math.cos(m),b=Math.sin(m),x=this.computedCenter,_=v*y,w=g*y,M=b,k=-v*b,A=-g*b,T=y,S=this.computedEye,E=this.computedMatrix,o=0;o<3;++o){var L=_*r[o]+w*c[o]+M*e[o];E[4*o+1]=k*r[o]+A*c[o]+T*e[o],E[4*o+2]=L,E[4*o+3]=0}var C=E[1],z=E[5],I=E[9],D=E[2],P=E[6],O=E[10],R=z*O-I*P,F=I*D-C*O,j=C*P-z*D,N=n(R,F,j);R/=N,F/=N,j/=N,E[0]=R,E[4]=F,E[8]=j;for(var o=0;o<3;++o)S[o]=x[o]+E[2+4*o]*d;for(var o=0;o<3;++o){for(var l=0,B=0;B<3;++B)l+=E[o+4*B]*S[B];E[12+o]=-l}E[15]=1},p.getMatrix=function(t,e){this.recalcMatrix(t);var r=this.computedMatrix;if(e){for(var n=0;n<16;++n)e[n]=r[n];return e}return r};var m=[0,0,0];p.rotate=function(t,e,r,n){if(this.angle.move(t,e,r),n){this.recalcMatrix(t);var i=this.computedMatrix;m[0]=i[2],m[1]=i[6],m[2]=i[10];for(var a=this.computedUp,o=this.computedRight,s=this.computedToward,l=0;l<3;++l)i[4*l]=a[l],i[4*l+1]=o[l],i[4*l+2]=s[l];c(i,i,n,m);for(var l=0;l<3;++l)a[l]=i[4*l],o[l]=i[4*l+1];this.up.set(t,a[0],a[1],a[2]),this.right.set(t,o[0],o[1],o[2])}},p.pan=function(t,e,r,i){e=e||0,r=r||0,i=i||0,this.recalcMatrix(t);var a=this.computedMatrix,o=(Math.exp(this.computedRadius[0]),a[1]),s=a[5],l=a[9],u=n(o,s,l);o/=u,s/=u,l/=u;var c=a[0],h=a[4],f=a[8],d=c*o+h*s+f*l;c-=o*d,h-=s*d,f-=l*d;var p=n(c,h,f);c/=p,h/=p,f/=p;var m=c*e+o*r,v=h*e+s*r,g=f*e+l*r;this.center.move(t,m,v,g);var y=Math.exp(this.computedRadius[0]);y=Math.max(1e-4,y+i),this.radius.set(t,Math.log(y))},p.translate=function(t,e,r,n){this.center.move(t,e||0,r||0,n||0)},p.setMatrix=function(t,e,r,a){var o=1;\"number\"==typeof r&&(o=0|r),(o<0||o>3)&&(o=1);var s=(o+2)%3;e||(this.recalcMatrix(t),e=this.computedMatrix);var l=e[o],c=e[o+4],h=e[o+8];if(a){var f=Math.abs(l),d=Math.abs(c),p=Math.abs(h),m=Math.max(f,d,p);f===m?(l=l<0?-1:1,c=h=0):p===m?(h=h<0?-1:1,l=c=0):(c=c<0?-1:1,l=h=0)}else{var v=n(l,c,h);l/=v,c/=v,h/=v}var g=e[s],y=e[s+4],b=e[s+8],x=g*l+y*c+b*h;g-=l*x,y-=c*x,b-=h*x;var _=n(g,y,b);g/=_,y/=_,b/=_;var w=c*b-h*y,M=h*g-l*b,k=l*y-c*g,A=n(w,M,k);w/=A,M/=A,k/=A,this.center.jump(t,q,G,Y),this.radius.idle(t),this.up.jump(t,l,c,h),this.right.jump(t,g,y,b);var T,S;if(2===o){var E=e[1],L=e[5],C=e[9],z=E*g+L*y+C*b,I=E*w+L*M+C*k;T=R<0?-Math.PI/2:Math.PI/2,S=Math.atan2(I,z)}else{var D=e[2],P=e[6],O=e[10],R=D*l+P*c+O*h,F=D*g+P*y+O*b,j=D*w+P*M+O*k;T=Math.asin(i(R)),S=Math.atan2(j,F)}this.angle.jump(t,S,T),this.recalcMatrix(t);var N=e[2],B=e[6],U=e[10],V=this.computedMatrix;u(V,e);var H=V[15],q=V[12]/H,G=V[13]/H,Y=V[14]/H,X=Math.exp(this.computedRadius[0]);this.center.jump(t,q-N*X,G-B*X,Y-U*X)},p.lastT=function(){return Math.max(this.center.lastT(),this.up.lastT(),this.right.lastT(),this.radius.lastT(),this.angle.lastT())},p.idle=function(t){this.center.idle(t),this.up.idle(t),this.right.idle(t),this.radius.idle(t),this.angle.idle(t)},p.flush=function(t){this.center.flush(t),this.up.flush(t),this.right.flush(t),this.radius.flush(t),this.angle.flush(t)},p.setDistance=function(t,e){e>0&&this.radius.set(t,Math.log(e))},p.lookAt=function(t,e,r,a){this.recalcMatrix(t),e=e||this.computedEye,r=r||this.computedCenter,a=a||this.computedUp;var o=a[0],s=a[1],l=a[2],u=n(o,s,l);if(!(u<1e-6)){o/=u,s/=u,l/=u;var c=e[0]-r[0],h=e[1]-r[1],f=e[2]-r[2],d=n(c,h,f);if(!(d<1e-6)){c/=d,h/=d,f/=d;var p=this.computedRight,m=p[0],v=p[1],g=p[2],y=o*m+s*v+l*g;m-=y*o,v-=y*s,g-=y*l;var b=n(m,v,g);if(!(b<.01&&(m=s*f-l*h,v=l*c-o*f,g=o*h-s*c,(b=n(m,v,g))<1e-6))){m/=b,v/=b,g/=b,this.up.set(t,o,s,l),this.right.set(t,m,v,g),this.center.set(t,r[0],r[1],r[2]),this.radius.set(t,Math.log(d));var x=s*g-l*v,_=l*m-o*g,w=o*v-s*m,M=n(x,_,w);x/=M,_/=M,w/=M;var k=o*c+s*h+l*f,A=m*c+v*h+g*f,T=x*c+_*h+w*f,S=Math.asin(i(k)),E=Math.atan2(T,A),L=this.angle._state,C=L[L.length-1],z=L[L.length-2];C%=2*Math.PI;var I=Math.abs(C+2*Math.PI-E),D=Math.abs(C-E),P=Math.abs(C-2*Math.PI-E);I<D&&(C+=2*Math.PI),P<D&&(C-=2*Math.PI),this.angle.jump(this.angle.lastT(),C,z),this.angle.set(t,E,S)}}}}},{\"filtered-vector\":132,\"gl-mat4/invert\":180,\"gl-mat4/rotate\":184,\"gl-vec3/cross\":271,\"gl-vec3/dot\":272,\"gl-vec3/normalize\":275}],538:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t*e,a=i*t,o=a-t,s=a-o,l=t-s,u=i*e,c=u-e,h=u-c,f=e-h,d=n-s*h,p=d-l*h,m=p-s*f,v=l*f-m;return r?(r[0]=v,r[1]=n,r):[v,n]}e.exports=n;var i=+(Math.pow(2,27)+1)},{}],539:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t+e,i=n-t,a=n-i,o=e-i,s=t-a;return r?(r[0]=s+o,r[1]=n,r):[s+o,n]}e.exports=n},{}],540:[function(t,e,r){(function(e,n){\"use strict\";function i(t){if(t){var e=t.length||t.byteLength,r=y.log2(e);w[r].push(t)}}function a(t){i(t.buffer)}function o(t){var t=y.nextPow2(t),e=y.log2(t),r=w[e];return r.length>0?r.pop():new ArrayBuffer(t)}function s(t){return new Uint8Array(o(t),0,t)}function l(t){return new Uint16Array(o(2*t),0,t)}function u(t){return new Uint32Array(o(4*t),0,t)}function c(t){return new Int8Array(o(t),0,t)}function h(t){return new Int16Array(o(2*t),0,t)}function f(t){return new Int32Array(o(4*t),0,t)}function d(t){return new Float32Array(o(4*t),0,t)}function p(t){return new Float64Array(o(8*t),0,t)}function m(t){return x?new Uint8ClampedArray(o(t),0,t):s(t)}function v(t){return new DataView(o(t),0,t)}function g(t){t=y.nextPow2(t);var e=y.log2(t),r=M[e];return r.length>0?r.pop():new n(t)}var y=t(\"bit-twiddle\"),b=t(\"dup\");e.__TYPEDARRAY_POOL||(e.__TYPEDARRAY_POOL={UINT8:b([32,0]),UINT16:b([32,0]),UINT32:b([32,0]),INT8:b([32,0]),INT16:b([32,0]),INT32:b([32,0]),FLOAT:b([32,0]),DOUBLE:b([32,0]),DATA:b([32,0]),UINT8C:b([32,0]),BUFFER:b([32,0])});var x=\"undefined\"!=typeof Uint8ClampedArray,_=e.__TYPEDARRAY_POOL;_.UINT8C||(_.UINT8C=b([32,0])),_.BUFFER||(_.BUFFER=b([32,0]));var w=_.DATA,M=_.BUFFER;r.free=function(t){if(n.isBuffer(t))M[y.log2(t.length)].push(t);else{if(\"[object ArrayBuffer]\"!==Object.prototype.toString.call(t)&&(t=t.buffer),!t)return;var e=t.length||t.byteLength,r=0|y.log2(e);w[r].push(t)}},r.freeUint8=r.freeUint16=r.freeUint32=r.freeInt8=r.freeInt16=r.freeInt32=r.freeFloat32=r.freeFloat=r.freeFloat64=r.freeDouble=r.freeUint8Clamped=r.freeDataView=a,r.freeArrayBuffer=i,r.freeBuffer=function(t){M[y.log2(t.length)].push(t)},r.malloc=function(t,e){\n",
       "if(void 0===e||\"arraybuffer\"===e)return o(t);switch(e){case\"uint8\":return s(t);case\"uint16\":return l(t);case\"uint32\":return u(t);case\"int8\":return c(t);case\"int16\":return h(t);case\"int32\":return f(t);case\"float\":case\"float32\":return d(t);case\"double\":case\"float64\":return p(t);case\"uint8_clamped\":return m(t);case\"buffer\":return g(t);case\"data\":case\"dataview\":return v(t);default:return null}return null},r.mallocArrayBuffer=o,r.mallocUint8=s,r.mallocUint16=l,r.mallocUint32=u,r.mallocInt8=c,r.mallocInt16=h,r.mallocInt32=f,r.mallocFloat32=r.mallocFloat=d,r.mallocFloat64=r.mallocDouble=p,r.mallocUint8Clamped=m,r.mallocDataView=v,r.mallocBuffer=g,r.clearCache=function(){for(var t=0;t<32;++t)_.UINT8[t].length=0,_.UINT16[t].length=0,_.UINT32[t].length=0,_.INT8[t].length=0,_.INT16[t].length=0,_.INT32[t].length=0,_.FLOAT[t].length=0,_.DOUBLE[t].length=0,_.UINT8C[t].length=0,w[t].length=0,M[t].length=0}}).call(this,\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{},t(\"buffer\").Buffer)},{\"bit-twiddle\":66,buffer:76,dup:124}],541:[function(t,e,r){\"use strict\";\"use restrict\";function n(t){this.roots=new Array(t),this.ranks=new Array(t);for(var e=0;e<t;++e)this.roots[e]=e,this.ranks[e]=0}e.exports=n;var i=n.prototype;Object.defineProperty(i,\"length\",{get:function(){return this.roots.length}}),i.makeSet=function(){var t=this.roots.length;return this.roots.push(t),this.ranks.push(0),t},i.find=function(t){for(var e=t,r=this.roots;r[t]!==t;)t=r[t];for(;r[e]!==t;){var n=r[e];r[e]=t,e=n}return t},i.link=function(t,e){var r=this.find(t),n=this.find(e);if(r!==n){var i=this.ranks,a=this.roots,o=i[r],s=i[n];o<s?a[r]=n:s<o?a[n]=r:(a[n]=r,++i[r])}}},{}],542:[function(t,e,r){\"use strict\";function n(t,e){for(var r=1,n=t.length,i=t[0],a=t[0],o=1;o<n;++o)if(a=i,i=t[o],e(i,a)){if(o===r){r++;continue}t[r++]=i}return t.length=r,t}function i(t){for(var e=1,r=t.length,n=t[0],i=t[0],a=1;a<r;++a,i=n)if(i=n,(n=t[a])!==i){if(a===e){e++;continue}t[e++]=n}return t.length=e,t}function a(t,e,r){return 0===t.length?t:e?(r||t.sort(e),n(t,e)):(r||t.sort(),i(t))}e.exports=a},{}],543:[function(t,e,r){function n(t,e,r,n){this.cx=3*t,this.bx=3*(r-t)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*e,this.by=3*(n-e)-this.cy,this.ay=1-this.cy-this.by,this.p1x=t,this.p1y=n,this.p2x=r,this.p2y=n}e.exports=n,n.prototype.sampleCurveX=function(t){return((this.ax*t+this.bx)*t+this.cx)*t},n.prototype.sampleCurveY=function(t){return((this.ay*t+this.by)*t+this.cy)*t},n.prototype.sampleCurveDerivativeX=function(t){return(3*this.ax*t+2*this.bx)*t+this.cx},n.prototype.solveCurveX=function(t,e){void 0===e&&(e=1e-6);var r,n,i,a,o;for(i=t,o=0;o<8;o++){if(a=this.sampleCurveX(i)-t,Math.abs(a)<e)return i;var s=this.sampleCurveDerivativeX(i);if(Math.abs(s)<1e-6)break;i-=a/s}if(r=0,n=1,(i=t)<r)return r;if(i>n)return n;for(;r<n;){if(a=this.sampleCurveX(i),Math.abs(a-t)<e)return i;t>a?r=i:n=i,i=.5*(n-r)+r}return i},n.prototype.solve=function(t,e){return this.sampleCurveY(this.solveCurveX(t,e))}},{}],544:[function(t,e,r){\"use strict\";function n(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function i(t,e,r){if(t&&u.isObject(t)&&t instanceof n)return t;var i=new n;return i.parse(t,e,r),i}function a(t){return u.isString(t)&&(t=i(t)),t instanceof n?t.format():n.prototype.format.call(t)}function o(t,e){return i(t,!1,!0).resolve(e)}function s(t,e){return t?i(t,!1,!0).resolveObject(e):e}var l=t(\"punycode\"),u=t(\"./util\");r.parse=i,r.resolve=o,r.resolveObject=s,r.format=a,r.Url=n;var c=/^([a-z0-9.+-]+:)/i,h=/:[0-9]*$/,f=/^(\\/\\/?(?!\\/)[^\\?\\s]*)(\\?[^\\s]*)?$/,d=[\"<\",\">\",'\"',\"`\",\" \",\"\\r\",\"\\n\",\"\\t\"],p=[\"{\",\"}\",\"|\",\"\\\\\",\"^\",\"`\"].concat(d),m=[\"'\"].concat(p),v=[\"%\",\"/\",\"?\",\";\",\"#\"].concat(m),g=[\"/\",\"?\",\"#\"],y=/^[+a-z0-9A-Z_-]{0,63}$/,b=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,x={javascript:!0,\"javascript:\":!0},_={javascript:!0,\"javascript:\":!0},w={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,\"http:\":!0,\"https:\":!0,\"ftp:\":!0,\"gopher:\":!0,\"file:\":!0},M=t(\"querystring\");n.prototype.parse=function(t,e,r){if(!u.isString(t))throw new TypeError(\"Parameter 'url' must be a string, not \"+typeof t);var n=t.indexOf(\"?\"),i=-1!==n&&n<t.indexOf(\"#\")?\"?\":\"#\",a=t.split(i),o=/\\\\/g;a[0]=a[0].replace(o,\"/\"),t=a.join(i);var s=t;if(s=s.trim(),!r&&1===t.split(\"#\").length){var h=f.exec(s);if(h)return this.path=s,this.href=s,this.pathname=h[1],h[2]?(this.search=h[2],this.query=e?M.parse(this.search.substr(1)):this.search.substr(1)):e&&(this.search=\"\",this.query={}),this}var d=c.exec(s);if(d){d=d[0];var p=d.toLowerCase();this.protocol=p,s=s.substr(d.length)}if(r||d||s.match(/^\\/\\/[^@\\/]+@[^@\\/]+/)){var k=\"//\"===s.substr(0,2);!k||d&&_[d]||(s=s.substr(2),this.slashes=!0)}if(!_[d]&&(k||d&&!w[d])){for(var A=-1,T=0;T<g.length;T++){var S=s.indexOf(g[T]);-1!==S&&(-1===A||S<A)&&(A=S)}var E,L;L=-1===A?s.lastIndexOf(\"@\"):s.lastIndexOf(\"@\",A),-1!==L&&(E=s.slice(0,L),s=s.slice(L+1),this.auth=decodeURIComponent(E)),A=-1;for(var T=0;T<v.length;T++){var S=s.indexOf(v[T]);-1!==S&&(-1===A||S<A)&&(A=S)}-1===A&&(A=s.length),this.host=s.slice(0,A),s=s.slice(A),this.parseHost(),this.hostname=this.hostname||\"\";var C=\"[\"===this.hostname[0]&&\"]\"===this.hostname[this.hostname.length-1];if(!C)for(var z=this.hostname.split(/\\./),T=0,I=z.length;T<I;T++){var D=z[T];if(D&&!D.match(y)){for(var P=\"\",O=0,R=D.length;O<R;O++)D.charCodeAt(O)>127?P+=\"x\":P+=D[O];if(!P.match(y)){var F=z.slice(0,T),j=z.slice(T+1),N=D.match(b);N&&(F.push(N[1]),j.unshift(N[2])),j.length&&(s=\"/\"+j.join(\".\")+s),this.hostname=F.join(\".\");break}}}this.hostname.length>255?this.hostname=\"\":this.hostname=this.hostname.toLowerCase(),C||(this.hostname=l.toASCII(this.hostname));var B=this.port?\":\"+this.port:\"\",U=this.hostname||\"\";this.host=U+B,this.href+=this.host,C&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),\"/\"!==s[0]&&(s=\"/\"+s))}if(!x[p])for(var T=0,I=m.length;T<I;T++){var V=m[T];if(-1!==s.indexOf(V)){var H=encodeURIComponent(V);H===V&&(H=escape(V)),s=s.split(V).join(H)}}var q=s.indexOf(\"#\");-1!==q&&(this.hash=s.substr(q),s=s.slice(0,q));var G=s.indexOf(\"?\");if(-1!==G?(this.search=s.substr(G),this.query=s.substr(G+1),e&&(this.query=M.parse(this.query)),s=s.slice(0,G)):e&&(this.search=\"\",this.query={}),s&&(this.pathname=s),w[p]&&this.hostname&&!this.pathname&&(this.pathname=\"/\"),this.pathname||this.search){var B=this.pathname||\"\",Y=this.search||\"\";this.path=B+Y}return this.href=this.format(),this},n.prototype.format=function(){var t=this.auth||\"\";t&&(t=encodeURIComponent(t),t=t.replace(/%3A/i,\":\"),t+=\"@\");var e=this.protocol||\"\",r=this.pathname||\"\",n=this.hash||\"\",i=!1,a=\"\";this.host?i=t+this.host:this.hostname&&(i=t+(-1===this.hostname.indexOf(\":\")?this.hostname:\"[\"+this.hostname+\"]\"),this.port&&(i+=\":\"+this.port)),this.query&&u.isObject(this.query)&&Object.keys(this.query).length&&(a=M.stringify(this.query));var o=this.search||a&&\"?\"+a||\"\";return e&&\":\"!==e.substr(-1)&&(e+=\":\"),this.slashes||(!e||w[e])&&!1!==i?(i=\"//\"+(i||\"\"),r&&\"/\"!==r.charAt(0)&&(r=\"/\"+r)):i||(i=\"\"),n&&\"#\"!==n.charAt(0)&&(n=\"#\"+n),o&&\"?\"!==o.charAt(0)&&(o=\"?\"+o),r=r.replace(/[?#]/g,function(t){return encodeURIComponent(t)}),o=o.replace(\"#\",\"%23\"),e+i+r+o+n},n.prototype.resolve=function(t){return this.resolveObject(i(t,!1,!0)).format()},n.prototype.resolveObject=function(t){if(u.isString(t)){var e=new n;e.parse(t,!1,!0),t=e}for(var r=new n,i=Object.keys(this),a=0;a<i.length;a++){var o=i[a];r[o]=this[o]}if(r.hash=t.hash,\"\"===t.href)return r.href=r.format(),r;if(t.slashes&&!t.protocol){for(var s=Object.keys(t),l=0;l<s.length;l++){var c=s[l];\"protocol\"!==c&&(r[c]=t[c])}return w[r.protocol]&&r.hostname&&!r.pathname&&(r.path=r.pathname=\"/\"),r.href=r.format(),r}if(t.protocol&&t.protocol!==r.protocol){if(!w[t.protocol]){for(var h=Object.keys(t),f=0;f<h.length;f++){var d=h[f];r[d]=t[d]}return r.href=r.format(),r}if(r.protocol=t.protocol,t.host||_[t.protocol])r.pathname=t.pathname;else{for(var p=(t.pathname||\"\").split(\"/\");p.length&&!(t.host=p.shift()););t.host||(t.host=\"\"),t.hostname||(t.hostname=\"\"),\"\"!==p[0]&&p.unshift(\"\"),p.length<2&&p.unshift(\"\"),r.pathname=p.join(\"/\")}if(r.search=t.search,r.query=t.query,r.host=t.host||\"\",r.auth=t.auth,r.hostname=t.hostname||t.host,r.port=t.port,r.pathname||r.search){var m=r.pathname||\"\",v=r.search||\"\";r.path=m+v}return r.slashes=r.slashes||t.slashes,r.href=r.format(),r}var g=r.pathname&&\"/\"===r.pathname.charAt(0),y=t.host||t.pathname&&\"/\"===t.pathname.charAt(0),b=y||g||r.host&&t.pathname,x=b,M=r.pathname&&r.pathname.split(\"/\")||[],p=t.pathname&&t.pathname.split(\"/\")||[],k=r.protocol&&!w[r.protocol];if(k&&(r.hostname=\"\",r.port=null,r.host&&(\"\"===M[0]?M[0]=r.host:M.unshift(r.host)),r.host=\"\",t.protocol&&(t.hostname=null,t.port=null,t.host&&(\"\"===p[0]?p[0]=t.host:p.unshift(t.host)),t.host=null),b=b&&(\"\"===p[0]||\"\"===M[0])),y)r.host=t.host||\"\"===t.host?t.host:r.host,r.hostname=t.hostname||\"\"===t.hostname?t.hostname:r.hostname,r.search=t.search,r.query=t.query,M=p;else if(p.length)M||(M=[]),M.pop(),M=M.concat(p),r.search=t.search,r.query=t.query;else if(!u.isNullOrUndefined(t.search)){if(k){r.hostname=r.host=M.shift();var A=!!(r.host&&r.host.indexOf(\"@\")>0)&&r.host.split(\"@\");A&&(r.auth=A.shift(),r.host=r.hostname=A.shift())}return r.search=t.search,r.query=t.query,u.isNull(r.pathname)&&u.isNull(r.search)||(r.path=(r.pathname?r.pathname:\"\")+(r.search?r.search:\"\")),r.href=r.format(),r}if(!M.length)return r.pathname=null,r.search?r.path=\"/\"+r.search:r.path=null,r.href=r.format(),r;for(var T=M.slice(-1)[0],S=(r.host||t.host||M.length>1)&&(\".\"===T||\"..\"===T)||\"\"===T,E=0,L=M.length;L>=0;L--)T=M[L],\".\"===T?M.splice(L,1):\"..\"===T?(M.splice(L,1),E++):E&&(M.splice(L,1),E--);if(!b&&!x)for(;E--;E)M.unshift(\"..\");!b||\"\"===M[0]||M[0]&&\"/\"===M[0].charAt(0)||M.unshift(\"\"),S&&\"/\"!==M.join(\"/\").substr(-1)&&M.push(\"\");var C=\"\"===M[0]||M[0]&&\"/\"===M[0].charAt(0);if(k){r.hostname=r.host=C?\"\":M.length?M.shift():\"\";var A=!!(r.host&&r.host.indexOf(\"@\")>0)&&r.host.split(\"@\");A&&(r.auth=A.shift(),r.host=r.hostname=A.shift())}return b=b||r.host&&M.length,b&&!C&&M.unshift(\"\"),M.length?r.pathname=M.join(\"/\"):(r.pathname=null,r.path=null),u.isNull(r.pathname)&&u.isNull(r.search)||(r.path=(r.pathname?r.pathname:\"\")+(r.search?r.search:\"\")),r.auth=t.auth||r.auth,r.slashes=r.slashes||t.slashes,r.href=r.format(),r},n.prototype.parseHost=function(){var t=this.host,e=h.exec(t);e&&(e=e[0],\":\"!==e&&(this.port=e.substr(1)),t=t.substr(0,t.length-e.length)),t&&(this.hostname=t)}},{\"./util\":545,punycode:487,querystring:491}],545:[function(t,e,r){\"use strict\";e.exports={isString:function(t){return\"string\"==typeof t},isObject:function(t){return\"object\"==typeof t&&null!==t},isNull:function(t){return null===t},isNullOrUndefined:function(t){return null==t}}},{}],546:[function(t,e,r){\"function\"==typeof Object.create?e.exports=function(t,e){t.super_=e,t.prototype=Object.create(e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}})}:e.exports=function(t,e){t.super_=e;var r=function(){};r.prototype=e.prototype,t.prototype=new r,t.prototype.constructor=t}},{}],547:[function(t,e,r){e.exports=function(t){return t&&\"object\"==typeof t&&\"function\"==typeof t.copy&&\"function\"==typeof t.fill&&\"function\"==typeof t.readUInt8}},{}],548:[function(t,e,r){(function(e,n){function i(t,e){var n={seen:[],stylize:o};return arguments.length>=3&&(n.depth=arguments[2]),arguments.length>=4&&(n.colors=arguments[3]),m(e)?n.showHidden=e:e&&r._extend(n,e),_(n.showHidden)&&(n.showHidden=!1),_(n.depth)&&(n.depth=2),_(n.colors)&&(n.colors=!1),_(n.customInspect)&&(n.customInspect=!0),n.colors&&(n.stylize=a),l(n,t,n.depth)}function a(t,e){var r=i.styles[e];return r?\"\\x1b[\"+i.colors[r][0]+\"m\"+t+\"\\x1b[\"+i.colors[r][1]+\"m\":t}function o(t,e){return t}function s(t){var e={};return t.forEach(function(t,r){e[t]=!0}),e}function l(t,e,n){if(t.customInspect&&e&&T(e.inspect)&&e.inspect!==r.inspect&&(!e.constructor||e.constructor.prototype!==e)){var i=e.inspect(n,t);return b(i)||(i=l(t,i,n)),i}var a=u(t,e);if(a)return a;var o=Object.keys(e),m=s(o);if(t.showHidden&&(o=Object.getOwnPropertyNames(e)),A(e)&&(o.indexOf(\"message\")>=0||o.indexOf(\"description\")>=0))return c(e);if(0===o.length){if(T(e)){var v=e.name?\": \"+e.name:\"\";return t.stylize(\"[Function\"+v+\"]\",\"special\")}if(w(e))return t.stylize(RegExp.prototype.toString.call(e),\"regexp\");if(k(e))return t.stylize(Date.prototype.toString.call(e),\"date\");if(A(e))return c(e)}var g=\"\",y=!1,x=[\"{\",\"}\"];if(p(e)&&(y=!0,x=[\"[\",\"]\"]),T(e)){g=\" [Function\"+(e.name?\": \"+e.name:\"\")+\"]\"}if(w(e)&&(g=\" \"+RegExp.prototype.toString.call(e)),k(e)&&(g=\" \"+Date.prototype.toUTCString.call(e)),A(e)&&(g=\" \"+c(e)),0===o.length&&(!y||0==e.length))return x[0]+g+x[1];if(n<0)return w(e)?t.stylize(RegExp.prototype.toString.call(e),\"regexp\"):t.stylize(\"[Object]\",\"special\");t.seen.push(e);var _;return _=y?h(t,e,n,m,o):o.map(function(r){return f(t,e,n,m,r,y)}),t.seen.pop(),d(_,g,x)}function u(t,e){if(_(e))return t.stylize(\"undefined\",\"undefined\");if(b(e)){var r=\"'\"+JSON.stringify(e).replace(/^\"|\"$/g,\"\").replace(/'/g,\"\\\\'\").replace(/\\\\\"/g,'\"')+\"'\";return t.stylize(r,\"string\")}return y(e)?t.stylize(\"\"+e,\"number\"):m(e)?t.stylize(\"\"+e,\"boolean\"):v(e)?t.stylize(\"null\",\"null\"):void 0}function c(t){return\"[\"+Error.prototype.toString.call(t)+\"]\"}function h(t,e,r,n,i){for(var a=[],o=0,s=e.length;o<s;++o)z(e,String(o))?a.push(f(t,e,r,n,String(o),!0)):a.push(\"\");return i.forEach(function(i){i.match(/^\\d+$/)||a.push(f(t,e,r,n,i,!0))}),a}function f(t,e,r,n,i,a){var o,s,u;if(u=Object.getOwnPropertyDescriptor(e,i)||{value:e[i]},u.get?s=u.set?t.stylize(\"[Getter/Setter]\",\"special\"):t.stylize(\"[Getter]\",\"special\"):u.set&&(s=t.stylize(\"[Setter]\",\"special\")),z(n,i)||(o=\"[\"+i+\"]\"),s||(t.seen.indexOf(u.value)<0?(s=v(r)?l(t,u.value,null):l(t,u.value,r-1),s.indexOf(\"\\n\")>-1&&(s=a?s.split(\"\\n\").map(function(t){return\"  \"+t}).join(\"\\n\").substr(2):\"\\n\"+s.split(\"\\n\").map(function(t){return\"   \"+t}).join(\"\\n\"))):s=t.stylize(\"[Circular]\",\"special\")),_(o)){if(a&&i.match(/^\\d+$/))return s;o=JSON.stringify(\"\"+i),o.match(/^\"([a-zA-Z_][a-zA-Z_0-9]*)\"$/)?(o=o.substr(1,o.length-2),o=t.stylize(o,\"name\")):(o=o.replace(/'/g,\"\\\\'\").replace(/\\\\\"/g,'\"').replace(/(^\"|\"$)/g,\"'\"),o=t.stylize(o,\"string\"))}return o+\": \"+s}function d(t,e,r){var n=0;return t.reduce(function(t,e){return n++,e.indexOf(\"\\n\")>=0&&n++,t+e.replace(/\\u001b\\[\\d\\d?m/g,\"\").length+1},0)>60?r[0]+(\"\"===e?\"\":e+\"\\n \")+\" \"+t.join(\",\\n  \")+\" \"+r[1]:r[0]+e+\" \"+t.join(\", \")+\" \"+r[1]}function p(t){return Array.isArray(t)}function m(t){return\"boolean\"==typeof t}function v(t){return null===t}function g(t){return null==t}function y(t){return\"number\"==typeof t}function b(t){return\"string\"==typeof t}function x(t){return\"symbol\"==typeof t}function _(t){return void 0===t}function w(t){return M(t)&&\"[object RegExp]\"===E(t)}function M(t){return\"object\"==typeof t&&null!==t}function k(t){return M(t)&&\"[object Date]\"===E(t)}function A(t){return M(t)&&(\"[object Error]\"===E(t)||t instanceof Error)}function T(t){return\"function\"==typeof t}function S(t){return null===t||\"boolean\"==typeof t||\"number\"==typeof t||\"string\"==typeof t||\"symbol\"==typeof t||void 0===t}function E(t){return Object.prototype.toString.call(t)}function L(t){return t<10?\"0\"+t.toString(10):t.toString(10)}function C(){var t=new Date,e=[L(t.getHours()),L(t.getMinutes()),L(t.getSeconds())].join(\":\");return[t.getDate(),O[t.getMonth()],e].join(\" \")}function z(t,e){return Object.prototype.hasOwnProperty.call(t,e)}var I=/%[sdj%]/g;r.format=function(t){if(!b(t)){for(var e=[],r=0;r<arguments.length;r++)e.push(i(arguments[r]));return e.join(\" \")}for(var r=1,n=arguments,a=n.length,o=String(t).replace(I,function(t){if(\"%%\"===t)return\"%\";if(r>=a)return t;switch(t){case\"%s\":return String(n[r++]);case\"%d\":return Number(n[r++]);case\"%j\":try{return JSON.stringify(n[r++])}catch(t){return\"[Circular]\"}default:return t}}),s=n[r];r<a;s=n[++r])v(s)||!M(s)?o+=\" \"+s:o+=\" \"+i(s);return o},r.deprecate=function(t,i){function a(){if(!o){if(e.throwDeprecation)throw new Error(i);e.traceDeprecation?console.trace(i):console.error(i),o=!0}return t.apply(this,arguments)}if(_(n.process))return function(){return r.deprecate(t,i).apply(this,arguments)};if(!0===e.noDeprecation)return t;var o=!1;return a};var D,P={};r.debuglog=function(t){if(_(D)&&(D=e.env.NODE_DEBUG||\"\"),t=t.toUpperCase(),!P[t])if(new RegExp(\"\\\\b\"+t+\"\\\\b\",\"i\").test(D)){var n=e.pid;P[t]=function(){var e=r.format.apply(r,arguments);console.error(\"%s %d: %s\",t,n,e)}}else P[t]=function(){};return P[t]},r.inspect=i,i.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},i.styles={special:\"cyan\",number:\"yellow\",boolean:\"yellow\",undefined:\"grey\",null:\"bold\",string:\"green\",date:\"magenta\",regexp:\"red\"},r.isArray=p,r.isBoolean=m,r.isNull=v,r.isNullOrUndefined=g,r.isNumber=y,r.isString=b,r.isSymbol=x,r.isUndefined=_,r.isRegExp=w,r.isObject=M,r.isDate=k,r.isError=A,r.isFunction=T,r.isPrimitive=S,r.isBuffer=t(\"./support/isBuffer\");var O=[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"];r.log=function(){console.log(\"%s - %s\",C(),r.format.apply(r,arguments))},r.inherits=t(\"inherits\"),r._extend=function(t,e){if(!e||!M(e))return t;for(var r=Object.keys(e),n=r.length;n--;)t[r[n]]=e[r[n]];return t}}).call(this,t(\"_process\"),\"undefined\"!=typeof global?global:\"undefined\"!=typeof self?self:\"undefined\"!=typeof window?window:{})},{\"./support/isBuffer\":547,_process:486,inherits:546}],549:[function(t,e,r){e.exports.VectorTile=t(\"./lib/vectortile.js\"),e.exports.VectorTileFeature=t(\"./lib/vectortilefeature.js\"),e.exports.VectorTileLayer=t(\"./lib/vectortilelayer.js\")},{\"./lib/vectortile.js\":550,\"./lib/vectortilefeature.js\":551,\"./lib/vectortilelayer.js\":552}],550:[function(t,e,r){\"use strict\";function n(t,e){this.layers=t.readFields(i,{},e)}function i(t,e,r){if(3===t){var n=new a(r,r.readVarint()+r.pos);n.length&&(e[n.name]=n)}}var a=t(\"./vectortilelayer\");e.exports=n},{\"./vectortilelayer\":552}],551:[function(t,e,r){\"use strict\";function n(t,e,r,n,a){this.properties={},this.extent=r,this.type=0,this._pbf=t,this._geometry=-1,this._keys=n,this._values=a,t.readFields(i,this,e)}function i(t,e,r){1==t?e.id=r.readVarint():2==t?a(r,e):3==t?e.type=r.readVarint():4==t&&(e._geometry=r.pos)}function a(t,e){for(var r=t.readVarint()+t.pos;t.pos<r;){var n=e._keys[t.readVarint()],i=e._values[t.readVarint()];e.properties[n]=i}}function o(t){var e=t.length;if(e<=1)return[t];for(var r,n,i=[],a=0;a<e;a++){var o=s(t[a]);0!==o&&(void 0===n&&(n=o<0),n===o<0?(r&&i.push(r),r=[t[a]]):r.push(t[a]))}return r&&i.push(r),i}function s(t){for(var e,r,n=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r=t[o],n+=(r.x-e.x)*(e.y+r.y);return n}var l=t(\"point-geometry\");e.exports=n,n.types=[\"Unknown\",\"Point\",\"LineString\",\"Polygon\"],n.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var e,r=t.readVarint()+t.pos,n=1,i=0,a=0,o=0,s=[];t.pos<r;){if(!i){var u=t.readVarint();n=7&u,i=u>>3}if(i--,1===n||2===n)a+=t.readSVarint(),o+=t.readSVarint(),1===n&&(e&&s.push(e),e=[]),e.push(new l(a,o));else{if(7!==n)throw new Error(\"unknown command \"+n);e&&e.push(e[0].clone())}}return e&&s.push(e),s},n.prototype.bbox=function(){var t=this._pbf;t.pos=this._geometry;for(var e=t.readVarint()+t.pos,r=1,n=0,i=0,a=0,o=1/0,s=-1/0,l=1/0,u=-1/0;t.pos<e;){if(!n){var c=t.readVarint();r=7&c,n=c>>3}if(n--,1===r||2===r)i+=t.readSVarint(),a+=t.readSVarint(),i<o&&(o=i),i>s&&(s=i),a<l&&(l=a),a>u&&(u=a);else if(7!==r)throw new Error(\"unknown command \"+r)}return[o,l,s,u]},n.prototype.toGeoJSON=function(t,e,r){function i(t){for(var e=0;e<t.length;e++){var r=t[e],n=180-360*(r.y+c)/l;t[e]=[360*(r.x+u)/l-180,360/Math.PI*Math.atan(Math.exp(n*Math.PI/180))-90]}}var a,s,l=this.extent*Math.pow(2,r),u=this.extent*t,c=this.extent*e,h=this.loadGeometry(),f=n.types[this.type];switch(this.type){case 1:var d=[];for(a=0;a<h.length;a++)d[a]=h[a][0];h=d,i(h);break;case 2:for(a=0;a<h.length;a++)i(h[a]);break;case 3:for(h=o(h),a=0;a<h.length;a++)for(s=0;s<h[a].length;s++)i(h[a][s])}1===h.length?h=h[0]:f=\"Multi\"+f;var p={type:\"Feature\",geometry:{type:f,coordinates:h},properties:this.properties};return\"id\"in this&&(p.id=this.id),p}},{\"point-geometry\":483}],552:[function(t,e,r){\"use strict\";function n(t,e){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=t,this._keys=[],this._values=[],this._features=[],t.readFields(i,this,e),this.length=this._features.length}function i(t,e,r){15===t?e.version=r.readVarint():1===t?e.name=r.readString():5===t?e.extent=r.readVarint():2===t?e._features.push(r.pos):3===t?e._keys.push(r.readString()):4===t&&e._values.push(a(r))}function a(t){for(var e=null,r=t.readVarint()+t.pos;t.pos<r;){var n=t.readVarint()>>3;e=1===n?t.readString():2===n?t.readFloat():3===n?t.readDouble():4===n?t.readVarint64():5===n?t.readVarint():6===n?t.readSVarint():7===n?t.readBoolean():null}return e}var o=t(\"./vectortilefeature.js\");e.exports=n,n.prototype.feature=function(t){if(t<0||t>=this._features.length)throw new Error(\"feature index out of bounds\");this._pbf.pos=this._features[t];var e=this._pbf.readVarint()+this._pbf.pos;return new o(this._pbf,e,this.extent,this._keys,this._values)}},{\"./vectortilefeature.js\":551}],553:[function(t,e,r){\"use strict\";function n(t,e){return\"object\"==typeof e&&null!==e||(e={}),i(t,e.canvas||a,e.context||o,e)}e.exports=n;var i=t(\"./lib/vtext\"),a=null,o=null;\"undefined\"!=typeof document&&(a=document.createElement(\"canvas\"),a.width=8192,a.height=1024,o=a.getContext(\"2d\"))},{\"./lib/vtext\":554}],554:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=e.textAlign||\"start\",i=e.textBaseline||\"alphabetic\",a=[1<<30,1<<30],o=[0,0],s=t.length,l=0;l<s;++l)for(var u=t[l],c=0;c<2;++c)a[c]=0|Math.min(a[c],u[c]),o[c]=0|Math.max(o[c],u[c]);var h=0;switch(n){case\"center\":h=-.5*(a[0]+o[0]);break;case\"right\":case\"end\":h=-o[0];break;case\"left\":case\"start\":h=-a[0];break;default:throw new Error(\"vectorize-text: Unrecognized textAlign: '\"+n+\"'\")}var f=0;switch(i){case\"hanging\":case\"top\":f=-a[1];break;case\"middle\":f=-.5*(a[1]+o[1]);break;case\"alphabetic\":case\"ideographic\":f=-3*r;break;case\"bottom\":f=-o[1];break;default:throw new Error(\"vectorize-text: Unrecoginized textBaseline: '\"+i+\"'\")}var d=1/r;return\"lineHeight\"in e?d*=+e.lineHeight:\"width\"in e?d=e.width/(o[0]-a[0]):\"height\"in e&&(d=e.height/(o[1]-a[1])),t.map(function(t){return[d*(t[0]+h),d*(t[1]+f)]})}function i(t,e,r,n){var i=0|Math.ceil(e.measureText(r).width+2*n);if(i>8192)throw new Error(\"vectorize-text: String too long (sorry, this will get fixed later)\");var a=3*n;t.height<a&&(t.height=a),e.fillStyle=\"#000\",e.fillRect(0,0,t.width,t.height),e.fillStyle=\"#fff\",e.fillText(r,n,2*n);var o=e.getImageData(0,0,i,a);return c(o.data,[a,i,4]).pick(-1,-1,0).transpose(1,0)}function a(t,e){var r=u(t,128);return e?h(r.cells,r.positions,.25):{edges:r.cells,positions:r.positions}}function o(t,e,r,i){var o=a(t,i),s=n(o.positions,e,r),l=o.edges,u=\"ccw\"===e.orientation;if(f(s,l),e.polygons||e.polygon||e.polyline){for(var c=p(l,s),h=new Array(c.length),m=0;m<c.length;++m){for(var v=c[m],g=new Array(v.length),y=0;y<v.length;++y){for(var b=v[y],x=new Array(b.length),_=0;_<b.length;++_)x[_]=s[b[_]].slice();u&&x.reverse(),g[y]=x}h[m]=g}return h}return e.triangles||e.triangulate||e.triangle?{cells:d(s,l,{delaunay:!1,exterior:!1,interior:!0}),positions:s}:{edges:l,positions:s}}function s(t,e,r){try{return o(t,e,r,!0)}catch(t){}try{return o(t,e,r,!1)}catch(t){}return e.polygons||e.polyline||e.polygon?[]:e.triangles||e.triangulate||e.triangle?{cells:[],positions:[]}:{edges:[],positions:[]}}function l(t,e,r,n){var a=n.size||64,o=n.font||\"normal\";return r.font=a+\"px \"+o,r.textAlign=\"start\",r.textBaseline=\"alphabetic\",r.direction=\"ltr\",s(i(e,r,t,a),n,a)}e.exports=l,e.exports.processPixels=s;var u=t(\"surface-nets\"),c=t(\"ndarray\"),h=t(\"simplify-planar-graph\"),f=t(\"clean-pslg\"),d=t(\"cdt2d\"),p=t(\"planar-graph-to-polyline\")},{cdt2d:78,\"clean-pslg\":88,ndarray:466,\"planar-graph-to-polyline\":482,\"simplify-planar-graph\":522,\"surface-nets\":530}],555:[function(t,e,r){function n(t){var e=[];for(var r in t.layers)e.push(a(t.layers[r]));var n=new c;return h.tile.write({layers:e},n),n.finish()}function i(t){var e={};for(var r in t)e[r]=new f(t[r].features),e[r].name=r;return n({layers:e})}function a(t){for(var e={name:t.name||\"\",version:t.version||1,extent:t.extent||4096,keys:[],values:[],features:[]},r={},n={},i=0;i<t.length;i++){var a=t.feature(i);a.geometry=l(a.loadGeometry());var o=[];for(var s in a.properties){var c=r[s];void 0===c&&(e.keys.push(s),c=e.keys.length-1,r[s]=c);var h=u(a.properties[s]),f=n[h.key];void 0===f&&(e.values.push(h),f=e.values.length-1,n[h.key]=f),o.push(c),o.push(f)}a.tags=o,e.features.push(a)}return e}function o(t,e){return(e<<3)+(7&t)}function s(t){return t<<1^t>>31}function l(t){for(var e=[],r=0,n=0,i=t.length,a=0;a<i;a++){var l=t[a];e.push(o(1,1));for(var u=0;u<l.length;u++){1===u&&e.push(o(2,l.length-1));var c=l[u].x-r,h=l[u].y-n;e.push(s(c),s(h)),r+=c,n+=h}}return e}function u(t){var e,r=typeof t;return\"string\"===r?e={string_value:t}:\"boolean\"===r?e={bool_value:t}:\"number\"===r?e=t%1!=0?{double_value:t}:t<0?{sint_value:t}:{uint_value:t}:(t=JSON.stringify(t),e={string_value:t}),e.key=r+\":\"+t,e}var c=t(\"pbf\"),h=t(\"./vector-tile-pb\"),f=t(\"./lib/geojson_wrapper\");e.exports=n,e.exports.fromVectorTileJs=n,e.exports.fromGeojsonVt=i,e.exports.GeoJSONWrapper=f},{\"./lib/geojson_wrapper\":556,\"./vector-tile-pb\":557,pbf:477}],556:[function(t,e,r){\"use strict\";function n(t){this.features=t,this.length=t.length}function i(t){this.id=\"number\"==typeof t.id?t.id:void 0,this.type=t.type,this.rawGeometry=1===t.type?[t.geometry]:t.geometry,this.properties=t.tags,this.extent=4096}var a=t(\"point-geometry\"),o=t(\"vector-tile\").VectorTileFeature;e.exports=n,n.prototype.feature=function(t){return new i(this.features[t])},i.prototype.loadGeometry=function(){var t=this.rawGeometry;this.geometry=[];for(var e=0;e<t.length;e++){for(var r=t[e],n=[],i=0;i<r.length;i++)n.push(new a(r[i][0],r[i][1]));this.geometry.push(n)}return this.geometry},i.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var t=this.geometry,e=1/0,r=-1/0,n=1/0,i=-1/0,a=0;a<t.length;a++)for(var o=t[a],s=0;s<o.length;s++){var l=o[s];e=Math.min(e,l.x),r=Math.max(r,l.x),n=Math.min(n,l.y),i=Math.max(i,l.y)}return[e,n,r,i]},i.prototype.toGeoJSON=o.prototype.toGeoJSON},{\"point-geometry\":483,\"vector-tile\":549}],557:[function(t,e,r){\"use strict\";function n(t,e){return t.readFields(i,{layers:[]},e)}function i(t,e,r){3===t&&e.layers.push(f(r,r.readVarint()+r.pos))}function a(t,e){var r;if(void 0!==t.layers)for(r=0;r<t.layers.length;r++)e.writeMessage(3,p,t.layers[r])}function o(t,e){return t.readFields(s,{},e)}function s(t,e,r){1===t?e.string_value=r.readString():2===t?e.float_value=r.readFloat():3===t?e.double_value=r.readDouble():4===t?e.int_value=r.readVarint():5===t?e.uint_value=r.readVarint():6===t?e.sint_value=r.readSVarint():7===t&&(e.bool_value=r.readBoolean())}function l(t,e){void 0!==t.string_value&&e.writeStringField(1,t.string_value),void 0!==t.float_value&&e.writeFloatField(2,t.float_value),void 0!==t.double_value&&e.writeDoubleField(3,t.double_value),void 0!==t.int_value&&e.writeVarintField(4,t.int_value),void 0!==t.uint_value&&e.writeVarintField(5,t.uint_value),void 0!==t.sint_value&&e.writeSVarintField(6,t.sint_value),void 0!==t.bool_value&&e.writeBooleanField(7,t.bool_value)}function u(t,e){var r=t.readFields(c,{},e);return void 0===r.type&&(r.type=\"Unknown\"),r}function c(t,e,r){1===t?e.id=r.readVarint():2===t?e.tags=r.readPackedVarint():3===t?e.type=r.readVarint():4===t&&(e.geometry=r.readPackedVarint())}function h(t,e){void 0!==t.id&&e.writeVarintField(1,t.id),void 0!==t.tags&&e.writePackedVarint(2,t.tags),void 0!==t.type&&e.writeVarintField(3,t.type),void 0!==t.geometry&&e.writePackedVarint(4,t.geometry)}function f(t,e){return t.readFields(d,{features:[],keys:[],values:[]},e)}function d(t,e,r){15===t?e.version=r.readVarint():1===t?e.name=r.readString():2===t?e.features.push(u(r,r.readVarint()+r.pos)):3===t?e.keys.push(r.readString()):4===t?e.values.push(o(r,r.readVarint()+r.pos)):5===t&&(e.extent=r.readVarint())}function p(t,e){void 0!==t.version&&e.writeVarintField(15,t.version),void 0!==t.name&&e.writeStringField(1,t.name);var r;if(void 0!==t.features)for(r=0;r<t.features.length;r++)e.writeMessage(2,h,t.features[r]);if(void 0!==t.keys)for(r=0;r<t.keys.length;r++)e.writeStringField(3,t.keys[r]);if(void 0!==t.values)for(r=0;r<t.values.length;r++)e.writeMessage(4,l,t.values[r]);void 0!==t.extent&&e.writeVarintField(5,t.extent)}var m=r.tile={read:n,write:a};m.GeomType={Unknown:0,Point:1,LineString:2,Polygon:3},m.value={read:o,write:l},m.feature={read:u,write:h},m.layer={read:f,write:p}},{}],558:[function(t,e,r){!function(){\"use strict\";function t(e){e.permitHostObjects___&&e.permitHostObjects___(t)}function r(t){return!(t.substr(0,d.length)==d&&\"___\"===t.substr(t.length-3))}function n(t){if(t!==Object(t))throw new TypeError(\"Not an object: \"+t);var e=t[p];if(e&&e.key===t)return e;if(f(t)){e={key:t};try{return h(t,p,{value:e,writable:!1,enumerable:!1,configurable:!1}),e}catch(t){return}}}function i(t){return t.prototype=null,Object.freeze(t)}function a(){y||\"undefined\"==typeof console||(y=!0,console.warn(\"WeakMap should be invoked as new WeakMap(), not WeakMap(). This will be an error in the future.\"))}if(\"undefined\"==typeof ses||!ses.ok||ses.ok()){\"undefined\"!=typeof ses&&(ses.weakMapPermitHostObjects=t);var o=!1;if(\"function\"==typeof WeakMap){var s=WeakMap;if(\"undefined\"!=typeof navigator&&/Firefox/.test(navigator.userAgent));else{var l=new s,u=Object.freeze({});if(l.set(u,1),1===l.get(u))return void(e.exports=WeakMap);o=!0}}var c=(Object.prototype.hasOwnProperty,Object.getOwnPropertyNames),h=Object.defineProperty,f=Object.isExtensible,d=\"weakmap:\",p=d+\"ident:\"+Math.random()+\"___\";if(\"undefined\"!=typeof crypto&&\"function\"==typeof crypto.getRandomValues&&\"function\"==typeof ArrayBuffer&&\"function\"==typeof Uint8Array){var m=new ArrayBuffer(25),v=new Uint8Array(m);crypto.getRandomValues(v),p=d+\"rand:\"+Array.prototype.map.call(v,function(t){return(t%36).toString(36)}).join(\"\")+\"___\"}if(h(Object,\"getOwnPropertyNames\",{value:function(t){return c(t).filter(r)}}),\"getPropertyNames\"in Object){var g=Object.getPropertyNames;h(Object,\"getPropertyNames\",{value:function(t){return g(t).filter(r)}})}!function(){var t=Object.freeze;h(Object,\"freeze\",{value:function(e){return n(e),t(e)}});var e=Object.seal;h(Object,\"seal\",{value:function(t){return n(t),e(t)}});var r=Object.preventExtensions;h(Object,\"preventExtensions\",{value:function(t){return n(t),r(t)}})}();var y=!1,b=0,x=function(){function t(t,e){var r,i=n(t);return i?u in i?i[u]:e:(r=s.indexOf(t),r>=0?l[r]:e)}function e(t){var e=n(t);return e?u in e:s.indexOf(t)>=0}function r(t,e){var r,i=n(t);return i?i[u]=e:(r=s.indexOf(t),r>=0?l[r]=e:(r=s.length,l[r]=e,s[r]=t)),this}function o(t){var e,r,i=n(t);return i?u in i&&delete i[u]:!((e=s.indexOf(t))<0)&&(r=s.length-1,s[e]=void 0,l[e]=l[r],s[e]=s[r],s.length=r,l.length=r,!0)}this instanceof x||a();var s=[],l=[],u=b++;return Object.create(x.prototype,{get___:{value:i(t)},has___:{value:i(e)},set___:{value:i(r)},delete___:{value:i(o)}})};x.prototype=Object.create(Object.prototype,{get:{value:function(t,e){return this.get___(t,e)},writable:!0,configurable:!0},has:{value:function(t){return this.has___(t)},writable:!0,configurable:!0},set:{value:function(t,e){return this.set___(t,e)},writable:!0,configurable:!0},delete:{value:function(t){return this.delete___(t)},writable:!0,configurable:!0}}),\"function\"==typeof s?function(){function r(){function e(t,e){return c?u.has(t)?u.get(t):c.get___(t,e):u.get(t,e)}function r(t){return u.has(t)||!!c&&c.has___(t)}function n(t){var e=!!u.delete(t);return c?c.delete___(t)||e:e}this instanceof x||a()\n",
       ";var l,u=new s,c=void 0,h=!1;return l=o?function(t,e){return u.set(t,e),u.has(t)||(c||(c=new x),c.set(t,e)),this}:function(t,e){if(h)try{u.set(t,e)}catch(r){c||(c=new x),c.set___(t,e)}else u.set(t,e);return this},Object.create(x.prototype,{get___:{value:i(e)},has___:{value:i(r)},set___:{value:i(l)},delete___:{value:i(n)},permitHostObjects___:{value:i(function(e){if(e!==t)throw new Error(\"bogus call to permitHostObjects___\");h=!0})}})}o&&\"undefined\"!=typeof Proxy&&(Proxy=void 0),r.prototype=x.prototype,e.exports=r,Object.defineProperty(WeakMap.prototype,\"constructor\",{value:WeakMap,enumerable:!1,configurable:!0,writable:!0})}():(\"undefined\"!=typeof Proxy&&(Proxy=void 0),e.exports=x)}}()},{}],559:[function(t,e,r){function n(){var t={};return function(e){if((\"object\"!=typeof e||null===e)&&\"function\"!=typeof e)throw new Error(\"Weakmap-shim: Key must be object\");var r=e.valueOf(t);return r&&r.identity===t?r:i(e,t)}}var i=t(\"./hidden-store.js\");e.exports=n},{\"./hidden-store.js\":560}],560:[function(t,e,r){function n(t,e){var r={identity:e},n=t.valueOf;return Object.defineProperty(t,\"valueOf\",{value:function(t){return t!==e?n.apply(this,arguments):r},writable:!0}),r}e.exports=n},{}],561:[function(t,e,r){function n(){var t=i();return{get:function(e,r){var n=t(e);return n.hasOwnProperty(\"value\")?n.value:r},set:function(e,r){return t(e).value=r,this},has:function(e){return\"value\"in t(e)},delete:function(e){return delete t(e).value}}}var i=t(\"./create-store.js\");e.exports=n},{\"./create-store.js\":559}],562:[function(t,e,r){var n=t(\"get-canvas-context\");e.exports=function(t){return n(\"webgl\",t)}},{\"get-canvas-context\":146}],563:[function(t,e,r){var n=arguments[3],i=arguments[4],a=arguments[5],o=JSON.stringify;e.exports=function(t,e){function r(t){v[t]=!0;for(var e in i[t][1]){var n=i[t][1][e];v[n]||r(n)}}for(var s,l=Object.keys(a),u=0,c=l.length;u<c;u++){var h=l[u],f=a[h].exports;if(f===t||f&&f.default===t){s=h;break}}if(!s){s=Math.floor(Math.pow(16,8)*Math.random()).toString(16);for(var d={},u=0,c=l.length;u<c;u++){var h=l[u];d[h]=h}i[s]=[Function([\"require\",\"module\",\"exports\"],\"(\"+t+\")(self)\"),d]}var p=Math.floor(Math.pow(16,8)*Math.random()).toString(16),m={};m[s]=s,i[p]=[Function([\"require\"],\"var f = require(\"+ o(s) +\");(f.default ? f.default : f)(self);\"),m];var v={};r(p);var g=\"(\"+n+\")({\"+Object.keys(v).map(function(t){return o(t)+\":[\"+i[t][0]+\",\"+o(i[t][1])+\"]\"}).join(\",\")+\"},{},[\"+o(p)+\"])\",y=window.URL||window.webkitURL||window.mozURL||window.msURL,b=new Blob([g],{type:\"text/javascript\"});if(e&&e.bare)return b;var x=y.createObjectURL(b),_=new Worker(x);return _.objectURL=x,_}},{}],564:[function(t,e,r){e.exports.RADIUS=6378137,e.exports.FLATTENING=1/298.257223563,e.exports.POLAR_RADIUS=6356752.3142},{}],565:[function(e,r,n){!function(e,i){\"object\"==typeof n&&void 0!==r?i(n):\"function\"==typeof t&&t.amd?t([\"exports\"],i):i(e.WhooTS=e.WhooTS||{})}(this,function(t){function e(t,e,n,i,a,o){return o=o||{},t+\"?\"+[\"bbox=\"+r(n,i,a),\"format=\"+(o.format||\"image/png\"),\"service=\"+(o.service||\"WMS\"),\"version=\"+(o.version||\"1.1.1\"),\"request=\"+(o.request||\"GetMap\"),\"srs=\"+(o.srs||\"EPSG:3857\"),\"width=\"+(o.width||256),\"height=\"+(o.height||256),\"layers=\"+e].join(\"&\")}function r(t,e,r){e=Math.pow(2,r)-e-1;var i=n(256*t,256*e,r),a=n(256*(t+1),256*(e+1),r);return i[0]+\",\"+i[1]+\",\"+a[0]+\",\"+a[1]}function n(t,e,r){var n=2*Math.PI*6378137/256/Math.pow(2,r);return[t*n-2*Math.PI*6378137/2,e*n-2*Math.PI*6378137/2]}t.getURL=e,t.getTileBBox=r,t.getMercCoords=n,Object.defineProperty(t,\"__esModule\",{value:!0})})},{}],566:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e,r,n){var i,a;if(\"object\"==typeof t)i=t,a=e||{};else{if(!(\"number\"==typeof t&&t>=1888&&t<=2111))throw new Error(\"Solar year outside range 1888-2111\");if(!(\"number\"==typeof e&&e>=1&&e<=12))throw new Error(\"Solar month outside range 1 - 12\");if(!(\"number\"==typeof r&&r>=1&&r<=31))throw new Error(\"Solar day outside range 1 - 31\");i={year:t,month:e,day:r},a=n||{}}var o=p[i.year-p[0]],s=i.year<<9|i.month<<5|i.day;a.year=s>=o?i.year:i.year-1,o=p[a.year-p[0]];var l,u=o>>9&4095,c=o>>5&15,h=31&o,f=new Date(u,c-1,h),m=new Date(i.year,i.month-1,i.day);l=Math.round((m-f)/864e5);var v,g=d[a.year-d[0]];for(v=0;v<13;v++){var y=g&1<<12-v?30:29;if(l<y)break;l-=y}var b=g>>13;return!b||v<b?(a.isIntercalary=!1,a.month=1+v):v===b?(a.isIntercalary=!0,a.month=v):(a.isIntercalary=!1,a.month=v),a.day=1+l,a}function a(t,e,r,n,i){var a,o;if(\"object\"==typeof t)o=t,a=e||{};else{if(!(\"number\"==typeof t&&t>=1888&&t<=2111))throw new Error(\"Lunar year outside range 1888-2111\");if(!(\"number\"==typeof e&&e>=1&&e<=12))throw new Error(\"Lunar month outside range 1 - 12\");if(!(\"number\"==typeof r&&r>=1&&r<=30))throw new Error(\"Lunar day outside range 1 - 30\");var s;\"object\"==typeof n?(s=!1,a=n):(s=!!n,a=i||{}),o={year:t,month:e,day:r,isIntercalary:s}}var l;l=o.day-1;var u,c=d[o.year-d[0]],h=c>>13;u=h?o.month>h?o.month:o.isIntercalary?o.month:o.month-1:o.month-1;for(var f=0;f<u;f++){l+=c&1<<12-f?30:29}var m=p[o.year-p[0]],v=m>>9&4095,g=m>>5&15,y=31&m,b=new Date(v,g-1,y+l);return a.year=b.getFullYear(),a.month=1+b.getMonth(),a.day=b.getDate(),a}var o=t(\"../main\"),s=t(\"object-assign\"),l=o.instance();n.prototype=new o.baseCalendar,s(n.prototype,{name:\"Chinese\",jdEpoch:1721425.5,hasYearZero:!1,minMonth:0,firstMonth:0,minDay:1,regionalOptions:{\"\":{name:\"Chinese\",epochs:[\"BEC\",\"EC\"],monthNumbers:function(t,e){if(\"string\"==typeof t){var r=t.match(c);return r?r[0]:\"\"}var n=this._validateYear(t),i=t.month(),a=\"\"+this.toChineseMonth(n,i);return e&&a.length<2&&(a=\"0\"+a),this.isIntercalaryMonth(n,i)&&(a+=\"i\"),a},monthNames:function(t){if(\"string\"==typeof t){var e=t.match(h);return e?e[0]:\"\"}var r=this._validateYear(t),n=t.month(),i=this.toChineseMonth(r,n),a=[\"\\u4e00\\u6708\",\"\\u4e8c\\u6708\",\"\\u4e09\\u6708\",\"\\u56db\\u6708\",\"\\u4e94\\u6708\",\"\\u516d\\u6708\",\"\\u4e03\\u6708\",\"\\u516b\\u6708\",\"\\u4e5d\\u6708\",\"\\u5341\\u6708\",\"\\u5341\\u4e00\\u6708\",\"\\u5341\\u4e8c\\u6708\"][i-1];return this.isIntercalaryMonth(r,n)&&(a=\"\\u95f0\"+a),a},monthNamesShort:function(t){if(\"string\"==typeof t){var e=t.match(f);return e?e[0]:\"\"}var r=this._validateYear(t),n=t.month(),i=this.toChineseMonth(r,n),a=[\"\\u4e00\",\"\\u4e8c\",\"\\u4e09\",\"\\u56db\",\"\\u4e94\",\"\\u516d\",\"\\u4e03\",\"\\u516b\",\"\\u4e5d\",\"\\u5341\",\"\\u5341\\u4e00\",\"\\u5341\\u4e8c\"][i-1];return this.isIntercalaryMonth(r,n)&&(a=\"\\u95f0\"+a),a},parseMonth:function(t,e){t=this._validateYear(t);var r,n=parseInt(e);if(isNaN(n))\"\\u95f0\"===e[0]&&(r=!0,e=e.substring(1)),\"\\u6708\"===e[e.length-1]&&(e=e.substring(0,e.length-1)),n=1+[\"\\u4e00\",\"\\u4e8c\",\"\\u4e09\",\"\\u56db\",\"\\u4e94\",\"\\u516d\",\"\\u4e03\",\"\\u516b\",\"\\u4e5d\",\"\\u5341\",\"\\u5341\\u4e00\",\"\\u5341\\u4e8c\"].indexOf(e);else{var i=e[e.length-1];r=\"i\"===i||\"I\"===i}return this.toMonthIndex(t,n,r)},dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:1,isRTL:!1}},_validateYear:function(t,e){if(t.year&&(t=t.year()),\"number\"!=typeof t||t<1888||t>2111)throw e.replace(/\\{0\\}/,this.local.name);return t},toMonthIndex:function(t,e,r){var n=this.intercalaryMonth(t);if(r&&e!==n||e<1||e>12)throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return n?!r&&e<=n?e-1:e:e-1},toChineseMonth:function(t,e){t.year&&(t=t.year(),e=t.month());var r=this.intercalaryMonth(t),n=r?12:11;if(e<0||e>n)throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return r?e<r?e+1:e:e+1},intercalaryMonth:function(t){return t=this._validateYear(t),d[t-d[0]]>>13},isIntercalaryMonth:function(t,e){t.year&&(t=t.year(),e=t.month());var r=this.intercalaryMonth(t);return!!r&&r===e},leapYear:function(t){return 0!==this.intercalaryMonth(t)},weekOfYear:function(t,e,r){var n,i=this._validateYear(t,o.local.invalidyear),a=p[i-p[0]],s=a>>9&4095,u=a>>5&15,c=31&a;n=l.newDate(s,u,c),n.add(4-(n.dayOfWeek()||7),\"d\");var h=this.toJD(t,e,r)-n.toJD();return 1+Math.floor(h/7)},monthsInYear:function(t){return this.leapYear(t)?13:12},daysInMonth:function(t,e){t.year&&(e=t.month(),t=t.year()),t=this._validateYear(t);var r=d[t-d[0]];if(e>(r>>13?12:11))throw o.local.invalidMonth.replace(/\\{0\\}/,this.local.name);return r&1<<12-e?30:29},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,s,r,o.local.invalidDate);t=this._validateYear(n.year()),e=n.month(),r=n.day();var i=this.isIntercalaryMonth(t,e),s=this.toChineseMonth(t,e),u=a(t,s,r,i);return l.toJD(u.year,u.month,u.day)},fromJD:function(t){var e=l.fromJD(t),r=i(e.year(),e.month(),e.day()),n=this.toMonthIndex(r.year,r.month,r.isIntercalary);return this.newDate(r.year,n,r.day)},fromString:function(t){var e=t.match(u),r=this._validateYear(+e[1]),n=+e[2],i=!!e[3],a=this.toMonthIndex(r,n,i),o=+e[4];return this.newDate(r,a,o)},add:function(t,e,r){var i=t.year(),a=t.month(),o=this.isIntercalaryMonth(i,a),s=this.toChineseMonth(i,a),l=Object.getPrototypeOf(n.prototype).add.call(this,t,e,r);if(\"y\"===r){var u=l.year(),c=l.month(),h=this.isIntercalaryMonth(u,s),f=o&&h?this.toMonthIndex(u,s,!0):this.toMonthIndex(u,s,!1);f!==c&&l.month(f)}return l}});var u=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)[-\\/](\\d?\\d)([iI]?)[-\\/](\\d?\\d)/m,c=/^\\d?\\d[iI]?/m,h=/^\\u95f0?\\u5341?[\\u4e00\\u4e8c\\u4e09\\u56db\\u4e94\\u516d\\u4e03\\u516b\\u4e5d]?\\u6708/m,f=/^\\u95f0?\\u5341?[\\u4e00\\u4e8c\\u4e09\\u56db\\u4e94\\u516d\\u4e03\\u516b\\u4e5d]?/m;o.calendars.chinese=n;var d=[1887,5780,5802,19157,2742,50359,1198,2646,46378,7466,3412,30122,5482,67949,2396,5294,43597,6732,6954,36181,2772,4954,18781,2396,54427,5274,6730,47781,5800,6868,21210,4790,59703,2350,5270,46667,3402,3496,38325,1388,4782,18735,2350,52374,6804,7498,44457,2906,1388,29294,4700,63789,6442,6804,56138,5802,2772,38235,1210,4698,22827,5418,63125,3476,5802,43701,2484,5302,27223,2646,70954,7466,3412,54698,5482,2412,38062,5294,2636,32038,6954,60245,2772,4826,43357,2394,5274,39501,6730,72357,5800,5844,53978,4790,2358,38039,5270,87627,3402,3496,54708,5484,4782,43311,2350,3222,27978,7498,68965,2904,5484,45677,4700,6444,39573,6804,6986,19285,2772,62811,1210,4698,47403,5418,5780,38570,5546,76469,2420,5302,51799,2646,5414,36501,3412,5546,18869,2412,54446,5276,6732,48422,6822,2900,28010,4826,92509,2394,5274,55883,6730,6820,47956,5812,2778,18779,2358,62615,5270,5450,46757,3492,5556,27318,4718,67887,2350,3222,52554,7498,3428,38252,5468,4700,31022,6444,64149,6804,6986,43861,2772,5338,35421,2650,70955,5418,5780,54954,5546,2740,38074,5302,2646,29991,3366,61011,3412,5546,43445,2412,5294,35406,6732,72998,6820,6996,52586,2778,2396,38045,5274,6698,23333,6820,64338,5812,2746,43355,2358,5270,39499,5450,79525,3492,5548],p=[1887,966732,967231,967733,968265,968766,969297,969798,970298,970829,971330,971830,972362,972863,973395,973896,974397,974928,975428,975929,976461,976962,977462,977994,978494,979026,979526,980026,980558,981059,981559,982091,982593,983124,983624,984124,984656,985157,985656,986189,986690,987191,987722,988222,988753,989254,989754,990286,990788,991288,991819,992319,992851,993352,993851,994383,994885,995385,995917,996418,996918,997450,997949,998481,998982,999483,1000014,1000515,1001016,1001548,1002047,1002578,1003080,1003580,1004111,1004613,1005113,1005645,1006146,1006645,1007177,1007678,1008209,1008710,1009211,1009743,1010243,1010743,1011275,1011775,1012306,1012807,1013308,1013840,1014341,1014841,1015373,1015874,1016404,1016905,1017405,1017937,1018438,1018939,1019471,1019972,1020471,1021002,1021503,1022035,1022535,1023036,1023568,1024069,1024568,1025100,1025601,1026102,1026633,1027133,1027666,1028167,1028666,1029198,1029699,1030199,1030730,1031231,1031763,1032264,1032764,1033296,1033797,1034297,1034828,1035329,1035830,1036362,1036861,1037393,1037894,1038394,1038925,1039427,1039927,1040459,1040959,1041491,1041992,1042492,1043023,1043524,1044024,1044556,1045057,1045558,1046090,1046590,1047121,1047622,1048122,1048654,1049154,1049655,1050187,1050689,1051219,1051720,1052220,1052751,1053252,1053752,1054284,1054786,1055285,1055817,1056317,1056849,1057349,1057850,1058382,1058883,1059383,1059915,1060415,1060947,1061447,1061947,1062479,1062981,1063480,1064012,1064514,1065014,1065545,1066045,1066577,1067078,1067578,1068110,1068611,1069112,1069642,1070142,1070674,1071175,1071675,1072207,1072709,1073209,1073740,1074241,1074741,1075273,1075773,1076305,1076807,1077308,1077839,1078340,1078840,1079372,1079871,1080403,1080904]},{\"../main\":580,\"object-assign\":469}],567:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Coptic\",jdEpoch:1825029.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Coptic\",epochs:[\"BAM\",\"AM\"],monthNames:[\"Thout\",\"Paopi\",\"Hathor\",\"Koiak\",\"Tobi\",\"Meshir\",\"Paremhat\",\"Paremoude\",\"Pashons\",\"Paoni\",\"Epip\",\"Mesori\",\"Pi Kogi Enavot\"],monthNamesShort:[\"Tho\",\"Pao\",\"Hath\",\"Koi\",\"Tob\",\"Mesh\",\"Pat\",\"Pad\",\"Pash\",\"Pao\",\"Epi\",\"Meso\",\"PiK\"],dayNames:[\"Tkyriaka\",\"Pesnau\",\"Pshoment\",\"Peftoou\",\"Ptiou\",\"Psoou\",\"Psabbaton\"],dayNamesShort:[\"Tky\",\"Pes\",\"Psh\",\"Pef\",\"Pti\",\"Pso\",\"Psa\"],dayNamesMin:[\"Tk\",\"Pes\",\"Psh\",\"Pef\",\"Pt\",\"Pso\",\"Psa\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==3||t%4==-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),t<0&&t++,n.day()+30*(n.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),i.calendars.coptic=n},{\"../main\":580,\"object-assign\":469}],568:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Discworld\",jdEpoch:1721425.5,daysPerMonth:[16,32,32,32,32,32,32,32,32,32,32,32,32],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Discworld\",epochs:[\"BUC\",\"UC\"],monthNames:[\"Ick\",\"Offle\",\"February\",\"March\",\"April\",\"May\",\"June\",\"Grune\",\"August\",\"Spune\",\"Sektober\",\"Ember\",\"December\"],monthNamesShort:[\"Ick\",\"Off\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Gru\",\"Aug\",\"Spu\",\"Sek\",\"Emb\",\"Dec\"],dayNames:[\"Sunday\",\"Octeday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Oct\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Oc\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:2,isRTL:!1}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),!1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),13},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),400},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/8)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]},daysInWeek:function(){return 8},dayOfWeek:function(t,e,r){return(this._validate(t,e,r,i.local.invalidDate).day()+1)%8},weekDay:function(t,e,r){var n=this.dayOfWeek(t,e,r);return n>=2&&n<=6},extraInfo:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return{century:o[Math.floor((n.year()-1)/100)+1]||\"\"}},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year()+(n.year()<0?1:0),e=n.month(),(r=n.day())+(e>1?16:0)+(e>2?32*(e-2):0)+400*(t-1)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t+.5)-Math.floor(this.jdEpoch)-1;var e=Math.floor(t/400)+1;t-=400*(e-1),t+=t>15?16:0;var r=Math.floor(t/32)+1,n=t-32*(r-1)+1;return this.newDate(e<=0?e-1:e,r,n)}});var o={20:\"Fruitbat\",21:\"Anchovy\"};i.calendars.discworld=n},{\"../main\":580,\"object-assign\":469}],569:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Ethiopian\",jdEpoch:1724220.5,daysPerMonth:[30,30,30,30,30,30,30,30,30,30,30,30,5],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Ethiopian\",epochs:[\"BEE\",\"EE\"],monthNames:[\"Meskerem\",\"Tikemet\",\"Hidar\",\"Tahesas\",\"Tir\",\"Yekatit\",\"Megabit\",\"Miazia\",\"Genbot\",\"Sene\",\"Hamle\",\"Nehase\",\"Pagume\"],monthNamesShort:[\"Mes\",\"Tik\",\"Hid\",\"Tah\",\"Tir\",\"Yek\",\"Meg\",\"Mia\",\"Gen\",\"Sen\",\"Ham\",\"Neh\",\"Pag\"],dayNames:[\"Ehud\",\"Segno\",\"Maksegno\",\"Irob\",\"Hamus\",\"Arb\",\"Kidame\"],dayNamesShort:[\"Ehu\",\"Seg\",\"Mak\",\"Iro\",\"Ham\",\"Arb\",\"Kid\"],dayNamesMin:[\"Eh\",\"Se\",\"Ma\",\"Ir\",\"Ha\",\"Ar\",\"Ki\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==3||t%4==-1},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear),13},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(13===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),t<0&&t++,n.day()+30*(n.month()-1)+365*(t-1)+Math.floor(t/4)+this.jdEpoch-1},fromJD:function(t){var e=Math.floor(t)+.5-this.jdEpoch,r=Math.floor((e-Math.floor((e+366)/1461))/365)+1;r<=0&&r--,e=Math.floor(t)+.5-this.newDate(r,1,1).toJD();var n=Math.floor(e/30)+1,i=e-30*(n-1)+1;return this.newDate(r,n,i)}}),i.calendars.ethiopian=n},{\"../main\":580,\"object-assign\":469}],570:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}var a=t(\"../main\"),o=t(\"object-assign\");n.prototype=new a.baseCalendar,o(n.prototype,{name:\"Hebrew\",jdEpoch:347995.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29,29],hasYearZero:!1,minMonth:1,firstMonth:7,minDay:1,regionalOptions:{\"\":{name:\"Hebrew\",epochs:[\"BAM\",\"AM\"],monthNames:[\"Nisan\",\"Iyar\",\"Sivan\",\"Tammuz\",\"Av\",\"Elul\",\"Tishrei\",\"Cheshvan\",\"Kislev\",\"Tevet\",\"Shevat\",\"Adar\",\"Adar II\"],monthNamesShort:[\"Nis\",\"Iya\",\"Siv\",\"Tam\",\"Av\",\"Elu\",\"Tis\",\"Che\",\"Kis\",\"Tev\",\"She\",\"Ada\",\"Ad2\"],dayNames:[\"Yom Rishon\",\"Yom Sheni\",\"Yom Shlishi\",\"Yom Revi'i\",\"Yom Chamishi\",\"Yom Shishi\",\"Yom Shabbat\"],dayNamesShort:[\"Ris\",\"She\",\"Shl\",\"Rev\",\"Cha\",\"Shi\",\"Sha\"],dayNamesMin:[\"Ri\",\"She\",\"Shl\",\"Re\",\"Ch\",\"Shi\",\"Sha\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear);return this._leapYear(e.year())},_leapYear:function(t){return t=t<0?t+1:t,i(7*t+1,19)<7},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,a.local.invalidYear),this._leapYear(t.year?t.year():t)?13:12},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return t=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear).year(),this.toJD(-1===t?1:t+1,7,1)-this.toJD(t,7,1)},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,a.local.invalidMonth),12===e&&this.leapYear(t)?30:8===e&&5===i(this.daysInYear(t),10)?30:9===e&&3===i(this.daysInYear(t),10)?29:this.daysPerMonth[e-1]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},extraInfo:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);return{yearType:(this.leapYear(n)?\"embolismic\":\"common\")+\" \"+[\"deficient\",\"regular\",\"complete\"][this.daysInYear(n)%10-3]}},toJD:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var i=t<=0?t+1:t,o=this.jdEpoch+this._delay1(i)+this._delay2(i)+r+1;if(e<7){for(var s=7;s<=this.monthsInYear(t);s++)o+=this.daysInMonth(t,s);for(var s=1;s<e;s++)o+=this.daysInMonth(t,s)}else for(var s=7;s<e;s++)o+=this.daysInMonth(t,s);return o},_delay1:function(t){var e=Math.floor((235*t-234)/19),r=12084+13753*e,n=29*e+Math.floor(r/25920);return i(3*(n+1),7)<3&&n++,n},_delay2:function(t){var e=this._delay1(t-1),r=this._delay1(t);return this._delay1(t+1)-r==356?2:r-e==382?1:0},fromJD:function(t){t=Math.floor(t)+.5;for(var e=Math.floor(98496*(t-this.jdEpoch)/35975351)-1;t>=this.toJD(-1===e?1:e+1,7,1);)e++;for(var r=t<this.toJD(e,1,1)?7:1;t>this.toJD(e,r,this.daysInMonth(e,r));)r++;var n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),a.calendars.hebrew=n},{\"../main\":580,\"object-assign\":469}],571:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Islamic\",jdEpoch:1948439.5,daysPerMonth:[30,29,30,29,30,29,30,29,30,29,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Islamic\",epochs:[\"BH\",\"AH\"],monthNames:[\"Muharram\",\"Safar\",\"Rabi' al-awwal\",\"Rabi' al-thani\",\"Jumada al-awwal\",\"Jumada al-thani\",\"Rajab\",\"Sha'aban\",\"Ramadan\",\"Shawwal\",\"Dhu al-Qi'dah\",\"Dhu al-Hijjah\"],monthNamesShort:[\"Muh\",\"Saf\",\"Rab1\",\"Rab2\",\"Jum1\",\"Jum2\",\"Raj\",\"Sha'\",\"Ram\",\"Shaw\",\"DhuQ\",\"DhuH\"],dayNames:[\"Yawm al-ahad\",\"Yawm al-ithnayn\",\"Yawm ath-thulaathaa'\",\"Yawm al-arbi'aa'\",\"Yawm al-kham\\u012bs\",\"Yawm al-jum'a\",\"Yawm as-sabt\"],dayNamesShort:[\"Aha\",\"Ith\",\"Thu\",\"Arb\",\"Kha\",\"Jum\",\"Sab\"],dayNamesMin:[\"Ah\",\"It\",\"Th\",\"Ar\",\"Kh\",\"Ju\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!1}},leapYear:function(t){return(11*this._validate(t,this.minMonth,this.minDay,i.local.invalidYear).year()+14)%30<11},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){return this.leapYear(t)?355:354},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),e=n.month(),r=n.day(),t=t<=0?t+1:t,r+Math.ceil(29.5*(e-1))+354*(t-1)+Math.floor((3+11*t)/30)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t)+.5;var e=Math.floor((30*(t-this.jdEpoch)+10646)/10631);e=e<=0?e-1:e;var r=Math.min(12,Math.ceil((t-29-this.toJD(e,1,1))/29.5)+1),n=t-this.toJD(e,r,1)+1;return this.newDate(e,r,n)}}),i.calendars.islamic=n},{\"../main\":580,\"object-assign\":469}],572:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Julian\",jdEpoch:1721423.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Julian\",epochs:[\"BC\",\"AD\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"mm/dd/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=e.year()<0?e.year()+1:e.year();return t%4==0},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);return t=n.year(),e=n.month(),r=n.day(),t<0&&t++,e<=2&&(t--,e+=12),Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r-1524.5},fromJD:function(t){var e=Math.floor(t+.5),r=e+1524,n=Math.floor((r-122.1)/365.25),i=Math.floor(365.25*n),a=Math.floor((r-i)/30.6001),o=a-Math.floor(a<14?1:13),s=n-Math.floor(o>2?4716:4715),l=r-i-Math.floor(30.6001*a);return s<=0&&s--,this.newDate(s,o,l)}}),i.calendars.julian=n},{\"../main\":580,\"object-assign\":469}],573:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}function a(t,e){return i(t-1,e)+1}var o=t(\"../main\"),s=t(\"object-assign\");n.prototype=new o.baseCalendar,s(n.prototype,{name:\"Mayan\",jdEpoch:584282.5,hasYearZero:!0,minMonth:0,firstMonth:0,minDay:0,regionalOptions:{\"\":{name:\"Mayan\",epochs:[\"\",\"\"],monthNames:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\"],monthNamesShort:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\"],dayNames:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],dayNamesShort:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],dayNamesMin:[\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\"],digits:null,dateFormat:\"YYYY.m.d\",firstDay:0,isRTL:!1,haabMonths:[\"Pop\",\"Uo\",\"Zip\",\"Zotz\",\"Tzec\",\"Xul\",\"Yaxkin\",\"Mol\",\"Chen\",\"Yax\",\"Zac\",\"Ceh\",\"Mac\",\"Kankin\",\"Muan\",\"Pax\",\"Kayab\",\"Cumku\",\"Uayeb\"],tzolkinMonths:[\"Imix\",\"Ik\",\"Akbal\",\"Kan\",\"Chicchan\",\"Cimi\",\"Manik\",\"Lamat\",\"Muluc\",\"Oc\",\"Chuen\",\"Eb\",\"Ben\",\"Ix\",\"Men\",\"Cib\",\"Caban\",\"Etznab\",\"Cauac\",\"Ahau\"]}},leapYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),!1},formatYear:function(t){t=this._validate(t,this.minMonth,this.minDay,o.local.invalidYear).year();var e=Math.floor(t/400);return t%=400,t+=t<0?400:0,e+\".\"+Math.floor(t/20)+\".\"+t%20},forYear:function(t){if(t=t.split(\".\"),t.length<3)throw\"Invalid Mayan year\";for(var e=0,r=0;r<t.length;r++){var n=parseInt(t[r],10);if(Math.abs(n)>19||r>0&&n<0)throw\"Invalid Mayan year\";e=20*e+n}return e},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),18},weekOfYear:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate),0},daysInYear:function(t){return this._validate(t,this.minMonth,this.minDay,o.local.invalidYear),360},daysInMonth:function(t,e){return this._validate(t,e,this.minDay,o.local.invalidMonth),20},daysInWeek:function(){return 5},dayOfWeek:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate).day()},weekDay:function(t,e,r){return this._validate(t,e,r,o.local.invalidDate),!0},extraInfo:function(t,e,r){var n=this._validate(t,e,r,o.local.invalidDate),i=n.toJD(),a=this._toHaab(i),s=this._toTzolkin(i);return{haabMonthName:this.local.haabMonths[a[0]-1],haabMonth:a[0],haabDay:a[1],tzolkinDayName:this.local.tzolkinMonths[s[0]-1],tzolkinDay:s[0],tzolkinTrecena:s[1]}},_toHaab:function(t){t-=this.jdEpoch;var e=i(t+8+340,365);return[Math.floor(e/20)+1,i(e,20)]},_toTzolkin:function(t){return t-=this.jdEpoch,[a(t+20,20),a(t+4,13)]},toJD:function(t,e,r){var n=this._validate(t,e,r,o.local.invalidDate);return n.day()+20*n.month()+360*n.year()+this.jdEpoch},fromJD:function(t){t=Math.floor(t)+.5-this.jdEpoch;var e=Math.floor(t/360);t%=360,t+=t<0?360:0;var r=Math.floor(t/20),n=t%20;return this.newDate(e,r,n)}}),o.calendars.mayan=n},{\"../main\":580,\"object-assign\":469}],574:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar;var o=i.instance(\"gregorian\");a(n.prototype,{name:\"Nanakshahi\",jdEpoch:2257673.5,daysPerMonth:[31,31,31,31,31,30,30,30,30,30,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Nanakshahi\",epochs:[\"BN\",\"AN\"],monthNames:[\"Chet\",\"Vaisakh\",\"Jeth\",\"Harh\",\"Sawan\",\"Bhadon\",\"Assu\",\"Katak\",\"Maghar\",\"Poh\",\"Magh\",\"Phagun\"],monthNamesShort:[\"Che\",\"Vai\",\"Jet\",\"Har\",\"Saw\",\"Bha\",\"Ass\",\"Kat\",\"Mgr\",\"Poh\",\"Mgh\",\"Pha\"],dayNames:[\"Somvaar\",\"Mangalvar\",\"Budhvaar\",\"Veervaar\",\"Shukarvaar\",\"Sanicharvaar\",\"Etvaar\"],dayNamesShort:[\"Som\",\"Mangal\",\"Budh\",\"Veer\",\"Shukar\",\"Sanichar\",\"Et\"],dayNamesMin:[\"So\",\"Ma\",\"Bu\",\"Ve\",\"Sh\",\"Sa\",\"Et\"],digits:null,dateFormat:\"dd-mm-yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear||i.regionalOptions[\"\"].invalidYear);return o.leapYear(e.year()+(e.year()<1?1:0)+1469)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(1-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidMonth),t=n.year();t<0&&t++;for(var a=n.day(),s=1;s<n.month();s++)a+=this.daysPerMonth[s-1];return a+o.toJD(t+1468,3,13)},fromJD:function(t){t=Math.floor(t+.5);for(var e=Math.floor((t-(this.jdEpoch-1))/366);t>=this.toJD(e+1,1,1);)e++;for(var r=t-Math.floor(this.toJD(e,1,1)+.5)+1,n=1;r>this.daysInMonth(e,n);)r-=this.daysInMonth(e,n),n++;return this.newDate(e,n,r)}}),i.calendars.nanakshahi=n},{\"../main\":580,\"object-assign\":469}],575:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Nepali\",jdEpoch:1700709.5,daysPerMonth:[31,31,32,32,31,30,30,29,30,29,30,30],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,daysPerYear:365,regionalOptions:{\"\":{name:\"Nepali\",epochs:[\"BBS\",\"ABS\"],monthNames:[\"Baisakh\",\"Jestha\",\"Ashadh\",\"Shrawan\",\"Bhadra\",\"Ashwin\",\"Kartik\",\"Mangsir\",\"Paush\",\"Mangh\",\"Falgun\",\"Chaitra\"],monthNamesShort:[\"Bai\",\"Je\",\"As\",\"Shra\",\"Bha\",\"Ash\",\"Kar\",\"Mang\",\"Pau\",\"Ma\",\"Fal\",\"Chai\"],dayNames:[\"Aaitabaar\",\"Sombaar\",\"Manglbaar\",\"Budhabaar\",\"Bihibaar\",\"Shukrabaar\",\"Shanibaar\"],dayNamesShort:[\"Aaita\",\"Som\",\"Mangl\",\"Budha\",\"Bihi\",\"Shukra\",\"Shani\"],dayNamesMin:[\"Aai\",\"So\",\"Man\",\"Bu\",\"Bi\",\"Shu\",\"Sha\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:1,isRTL:!1}},leapYear:function(t){return this.daysInYear(t)!==this.daysPerYear},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){if(t=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear).year(),void 0===this.NEPALI_CALENDAR_DATA[t])return this.daysPerYear;for(var e=0,r=this.minMonth;r<=12;r++)e+=this.NEPALI_CALENDAR_DATA[t][r];return e},daysInMonth:function(t,e){return t.year&&(e=t.month(),t=t.year()),this._validate(t,e,this.minDay,i.local.invalidMonth),void 0===this.NEPALI_CALENDAR_DATA[t]?this.daysPerMonth[e-1]:this.NEPALI_CALENDAR_DATA[t][e]},weekDay:function(t,e,r){return 6!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var a=i.instance(),o=0,s=e,l=t;this._createMissingCalendarData(t);var u=t-(s>9||9===s&&r>=this.NEPALI_CALENDAR_DATA[l][0]?56:57);for(9!==e&&(o=r,\n",
       "s--);9!==s;)s<=0&&(s=12,l--),o+=this.NEPALI_CALENDAR_DATA[l][s],s--;return 9===e?(o+=r-this.NEPALI_CALENDAR_DATA[l][0])<0&&(o+=a.daysInYear(u)):o+=this.NEPALI_CALENDAR_DATA[l][9]-this.NEPALI_CALENDAR_DATA[l][0],a.newDate(u,1,1).add(o,\"d\").toJD()},fromJD:function(t){var e=i.instance(),r=e.fromJD(t),n=r.year(),a=r.dayOfYear(),o=n+56;this._createMissingCalendarData(o);for(var s=9,l=this.NEPALI_CALENDAR_DATA[o][0],u=this.NEPALI_CALENDAR_DATA[o][s]-l+1;a>u;)s++,s>12&&(s=1,o++),u+=this.NEPALI_CALENDAR_DATA[o][s];var c=this.NEPALI_CALENDAR_DATA[o][s]-(u-a);return this.newDate(o,s,c)},_createMissingCalendarData:function(t){var e=this.daysPerMonth.slice(0);e.unshift(17);for(var r=t-1;r<t+2;r++)void 0===this.NEPALI_CALENDAR_DATA[r]&&(this.NEPALI_CALENDAR_DATA[r]=e)},NEPALI_CALENDAR_DATA:{1970:[18,31,31,32,31,31,31,30,29,30,29,30,30],1971:[18,31,31,32,31,32,30,30,29,30,29,30,30],1972:[17,31,32,31,32,31,30,30,30,29,29,30,30],1973:[19,30,32,31,32,31,30,30,30,29,30,29,31],1974:[19,31,31,32,30,31,31,30,29,30,29,30,30],1975:[18,31,31,32,32,30,31,30,29,30,29,30,30],1976:[17,31,32,31,32,31,30,30,30,29,29,30,31],1977:[18,31,32,31,32,31,31,29,30,29,30,29,31],1978:[18,31,31,32,31,31,31,30,29,30,29,30,30],1979:[18,31,31,32,32,31,30,30,29,30,29,30,30],1980:[17,31,32,31,32,31,30,30,30,29,29,30,31],1981:[18,31,31,31,32,31,31,29,30,30,29,30,30],1982:[18,31,31,32,31,31,31,30,29,30,29,30,30],1983:[18,31,31,32,32,31,30,30,29,30,29,30,30],1984:[17,31,32,31,32,31,30,30,30,29,29,30,31],1985:[18,31,31,31,32,31,31,29,30,30,29,30,30],1986:[18,31,31,32,31,31,31,30,29,30,29,30,30],1987:[18,31,32,31,32,31,30,30,29,30,29,30,30],1988:[17,31,32,31,32,31,30,30,30,29,29,30,31],1989:[18,31,31,31,32,31,31,30,29,30,29,30,30],1990:[18,31,31,32,31,31,31,30,29,30,29,30,30],1991:[18,31,32,31,32,31,30,30,29,30,29,30,30],1992:[17,31,32,31,32,31,30,30,30,29,30,29,31],1993:[18,31,31,31,32,31,31,30,29,30,29,30,30],1994:[18,31,31,32,31,31,31,30,29,30,29,30,30],1995:[17,31,32,31,32,31,30,30,30,29,29,30,30],1996:[17,31,32,31,32,31,30,30,30,29,30,29,31],1997:[18,31,31,32,31,31,31,30,29,30,29,30,30],1998:[18,31,31,32,31,31,31,30,29,30,29,30,30],1999:[17,31,32,31,32,31,30,30,30,29,29,30,31],2e3:[17,30,32,31,32,31,30,30,30,29,30,29,31],2001:[18,31,31,32,31,31,31,30,29,30,29,30,30],2002:[18,31,31,32,32,31,30,30,29,30,29,30,30],2003:[17,31,32,31,32,31,30,30,30,29,29,30,31],2004:[17,30,32,31,32,31,30,30,30,29,30,29,31],2005:[18,31,31,32,31,31,31,30,29,30,29,30,30],2006:[18,31,31,32,32,31,30,30,29,30,29,30,30],2007:[17,31,32,31,32,31,30,30,30,29,29,30,31],2008:[17,31,31,31,32,31,31,29,30,30,29,29,31],2009:[18,31,31,32,31,31,31,30,29,30,29,30,30],2010:[18,31,31,32,32,31,30,30,29,30,29,30,30],2011:[17,31,32,31,32,31,30,30,30,29,29,30,31],2012:[17,31,31,31,32,31,31,29,30,30,29,30,30],2013:[18,31,31,32,31,31,31,30,29,30,29,30,30],2014:[18,31,31,32,32,31,30,30,29,30,29,30,30],2015:[17,31,32,31,32,31,30,30,30,29,29,30,31],2016:[17,31,31,31,32,31,31,29,30,30,29,30,30],2017:[18,31,31,32,31,31,31,30,29,30,29,30,30],2018:[18,31,32,31,32,31,30,30,29,30,29,30,30],2019:[17,31,32,31,32,31,30,30,30,29,30,29,31],2020:[17,31,31,31,32,31,31,30,29,30,29,30,30],2021:[18,31,31,32,31,31,31,30,29,30,29,30,30],2022:[17,31,32,31,32,31,30,30,30,29,29,30,30],2023:[17,31,32,31,32,31,30,30,30,29,30,29,31],2024:[17,31,31,31,32,31,31,30,29,30,29,30,30],2025:[18,31,31,32,31,31,31,30,29,30,29,30,30],2026:[17,31,32,31,32,31,30,30,30,29,29,30,31],2027:[17,30,32,31,32,31,30,30,30,29,30,29,31],2028:[17,31,31,32,31,31,31,30,29,30,29,30,30],2029:[18,31,31,32,31,32,30,30,29,30,29,30,30],2030:[17,31,32,31,32,31,30,30,30,30,30,30,31],2031:[17,31,32,31,32,31,31,31,31,31,31,31,31],2032:[17,32,32,32,32,32,32,32,32,32,32,32,32],2033:[18,31,31,32,32,31,30,30,29,30,29,30,30],2034:[17,31,32,31,32,31,30,30,30,29,29,30,31],2035:[17,30,32,31,32,31,31,29,30,30,29,29,31],2036:[17,31,31,32,31,31,31,30,29,30,29,30,30],2037:[18,31,31,32,32,31,30,30,29,30,29,30,30],2038:[17,31,32,31,32,31,30,30,30,29,29,30,31],2039:[17,31,31,31,32,31,31,29,30,30,29,30,30],2040:[17,31,31,32,31,31,31,30,29,30,29,30,30],2041:[18,31,31,32,32,31,30,30,29,30,29,30,30],2042:[17,31,32,31,32,31,30,30,30,29,29,30,31],2043:[17,31,31,31,32,31,31,29,30,30,29,30,30],2044:[17,31,31,32,31,31,31,30,29,30,29,30,30],2045:[18,31,32,31,32,31,30,30,29,30,29,30,30],2046:[17,31,32,31,32,31,30,30,30,29,29,30,31],2047:[17,31,31,31,32,31,31,30,29,30,29,30,30],2048:[17,31,31,32,31,31,31,30,29,30,29,30,30],2049:[17,31,32,31,32,31,30,30,30,29,29,30,30],2050:[17,31,32,31,32,31,30,30,30,29,30,29,31],2051:[17,31,31,31,32,31,31,30,29,30,29,30,30],2052:[17,31,31,32,31,31,31,30,29,30,29,30,30],2053:[17,31,32,31,32,31,30,30,30,29,29,30,30],2054:[17,31,32,31,32,31,30,30,30,29,30,29,31],2055:[17,31,31,32,31,31,31,30,29,30,30,29,30],2056:[17,31,31,32,31,32,30,30,29,30,29,30,30],2057:[17,31,32,31,32,31,30,30,30,29,29,30,31],2058:[17,30,32,31,32,31,30,30,30,29,30,29,31],2059:[17,31,31,32,31,31,31,30,29,30,29,30,30],2060:[17,31,31,32,32,31,30,30,29,30,29,30,30],2061:[17,31,32,31,32,31,30,30,30,29,29,30,31],2062:[17,30,32,31,32,31,31,29,30,29,30,29,31],2063:[17,31,31,32,31,31,31,30,29,30,29,30,30],2064:[17,31,31,32,32,31,30,30,29,30,29,30,30],2065:[17,31,32,31,32,31,30,30,30,29,29,30,31],2066:[17,31,31,31,32,31,31,29,30,30,29,29,31],2067:[17,31,31,32,31,31,31,30,29,30,29,30,30],2068:[17,31,31,32,32,31,30,30,29,30,29,30,30],2069:[17,31,32,31,32,31,30,30,30,29,29,30,31],2070:[17,31,31,31,32,31,31,29,30,30,29,30,30],2071:[17,31,31,32,31,31,31,30,29,30,29,30,30],2072:[17,31,32,31,32,31,30,30,29,30,29,30,30],2073:[17,31,32,31,32,31,30,30,30,29,29,30,31],2074:[17,31,31,31,32,31,31,30,29,30,29,30,30],2075:[17,31,31,32,31,31,31,30,29,30,29,30,30],2076:[16,31,32,31,32,31,30,30,30,29,29,30,30],2077:[17,31,32,31,32,31,30,30,30,29,30,29,31],2078:[17,31,31,31,32,31,31,30,29,30,29,30,30],2079:[17,31,31,32,31,31,31,30,29,30,29,30,30],2080:[16,31,32,31,32,31,30,30,30,29,29,30,30],2081:[17,31,31,32,32,31,30,30,30,29,30,30,30],2082:[17,31,32,31,32,31,30,30,30,29,30,30,30],2083:[17,31,31,32,31,31,30,30,30,29,30,30,30],2084:[17,31,31,32,31,31,30,30,30,29,30,30,30],2085:[17,31,32,31,32,31,31,30,30,29,30,30,30],2086:[17,31,32,31,32,31,30,30,30,29,30,30,30],2087:[16,31,31,32,31,31,31,30,30,29,30,30,30],2088:[16,30,31,32,32,30,31,30,30,29,30,30,30],2089:[17,31,32,31,32,31,30,30,30,29,30,30,30],2090:[17,31,32,31,32,31,30,30,30,29,30,30,30],2091:[16,31,31,32,31,31,31,30,30,29,30,30,30],2092:[16,31,31,32,32,31,30,30,30,29,30,30,30],2093:[17,31,32,31,32,31,30,30,30,29,30,30,30],2094:[17,31,31,32,31,31,30,30,30,29,30,30,30],2095:[17,31,31,32,31,31,31,30,29,30,30,30,30],2096:[17,30,31,32,32,31,30,30,29,30,29,30,30],2097:[17,31,32,31,32,31,30,30,30,29,30,30,30],2098:[17,31,31,32,31,31,31,29,30,29,30,30,31],2099:[17,31,31,32,31,31,31,30,29,29,30,30,30],2100:[17,31,32,31,32,30,31,30,29,30,29,30,30]}}),i.calendars.nepali=n},{\"../main\":580,\"object-assign\":469}],576:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}function i(t,e){return t-e*Math.floor(t/e)}var a=t(\"../main\"),o=t(\"object-assign\");n.prototype=new a.baseCalendar,o(n.prototype,{name:\"Persian\",jdEpoch:1948320.5,daysPerMonth:[31,31,31,31,31,31,30,30,30,30,30,29],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Persian\",epochs:[\"BP\",\"AP\"],monthNames:[\"Farvardin\",\"Ordibehesht\",\"Khordad\",\"Tir\",\"Mordad\",\"Shahrivar\",\"Mehr\",\"Aban\",\"Azar\",\"Day\",\"Bahman\",\"Esfand\"],monthNamesShort:[\"Far\",\"Ord\",\"Kho\",\"Tir\",\"Mor\",\"Sha\",\"Meh\",\"Aba\",\"Aza\",\"Day\",\"Bah\",\"Esf\"],dayNames:[\"Yekshambe\",\"Doshambe\",\"Seshambe\",\"Ch\\xe6harshambe\",\"Panjshambe\",\"Jom'e\",\"Shambe\"],dayNamesShort:[\"Yek\",\"Do\",\"Se\",\"Ch\\xe6\",\"Panj\",\"Jom\",\"Sha\"],dayNamesMin:[\"Ye\",\"Do\",\"Se\",\"Ch\",\"Pa\",\"Jo\",\"Sh\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,a.local.invalidYear);return 682*((e.year()-(e.year()>0?474:473))%2820+474+38)%2816<682},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-(n.dayOfWeek()+1)%7,\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,a.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(12===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,a.local.invalidDate);t=n.year(),e=n.month(),r=n.day();var o=t-(t>=0?474:473),s=474+i(o,2820);return r+(e<=7?31*(e-1):30*(e-1)+6)+Math.floor((682*s-110)/2816)+365*(s-1)+1029983*Math.floor(o/2820)+this.jdEpoch-1},fromJD:function(t){t=Math.floor(t)+.5;var e=t-this.toJD(475,1,1),r=Math.floor(e/1029983),n=i(e,1029983),a=2820;if(1029982!==n){var o=Math.floor(n/366),s=i(n,366);a=Math.floor((2134*o+2816*s+2815)/1028522)+o+1}var l=a+2820*r+474;l=l<=0?l-1:l;var u=t-this.toJD(l,1,1)+1,c=u<=186?Math.ceil(u/31):Math.ceil((u-6)/30),h=t-this.toJD(l,c,1)+1;return this.newDate(l,c,h)}}),a.calendars.persian=n,a.calendars.jalali=n},{\"../main\":580,\"object-assign\":469}],577:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\"),o=i.instance();n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Taiwan\",jdEpoch:2419402.5,yearsOffset:1911,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Taiwan\",epochs:[\"BROC\",\"ROC\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:1,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(e.year());return o.leapYear(t)},weekOfYear:function(t,e,r){var n=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(n.year());return o.weekOfYear(t,n.month(),n.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),t=this._t2gYear(n.year());return o.toJD(t,n.month(),n.day())},fromJD:function(t){var e=o.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)},_g2tYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)}}),i.calendars.taiwan=n},{\"../main\":580,\"object-assign\":469}],578:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\"),o=i.instance();n.prototype=new i.baseCalendar,a(n.prototype,{name:\"Thai\",jdEpoch:1523098.5,yearsOffset:543,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Thai\",epochs:[\"BBE\",\"BE\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"dd/mm/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(e.year());return o.leapYear(t)},weekOfYear:function(t,e,r){var n=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear),t=this._t2gYear(n.year());return o.weekOfYear(t,n.month(),n.day())},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,i.local.invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),t=this._t2gYear(n.year());return o.toJD(t,n.month(),n.day())},fromJD:function(t){var e=o.fromJD(t),r=this._g2tYear(e.year());return this.newDate(r,e.month(),e.day())},_t2gYear:function(t){return t-this.yearsOffset-(t>=1&&t<=this.yearsOffset?1:0)},_g2tYear:function(t){return t+this.yearsOffset+(t>=-this.yearsOffset&&t<=-1?1:0)}}),i.calendars.thai=n},{\"../main\":580,\"object-assign\":469}],579:[function(t,e,r){function n(t){this.local=this.regionalOptions[t||\"\"]||this.regionalOptions[\"\"]}var i=t(\"../main\"),a=t(\"object-assign\");n.prototype=new i.baseCalendar,a(n.prototype,{name:\"UmmAlQura\",hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Umm al-Qura\",epochs:[\"BH\",\"AH\"],monthNames:[\"Al-Muharram\",\"Safar\",\"Rabi' al-awwal\",\"Rabi' Al-Thani\",\"Jumada Al-Awwal\",\"Jumada Al-Thani\",\"Rajab\",\"Sha'aban\",\"Ramadan\",\"Shawwal\",\"Dhu al-Qi'dah\",\"Dhu al-Hijjah\"],monthNamesShort:[\"Muh\",\"Saf\",\"Rab1\",\"Rab2\",\"Jum1\",\"Jum2\",\"Raj\",\"Sha'\",\"Ram\",\"Shaw\",\"DhuQ\",\"DhuH\"],dayNames:[\"Yawm al-Ahad\",\"Yawm al-Ithnain\",\"Yawm al-Thal\\u0101th\\u0101\\u2019\",\"Yawm al-Arba\\u2018\\u0101\\u2019\",\"Yawm al-Kham\\u012bs\",\"Yawm al-Jum\\u2018a\",\"Yawm al-Sabt\"],dayNamesMin:[\"Ah\",\"Ith\",\"Th\",\"Ar\",\"Kh\",\"Ju\",\"Sa\"],digits:null,dateFormat:\"yyyy/mm/dd\",firstDay:6,isRTL:!0}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,i.local.invalidYear);return 355===this.daysInYear(e.year())},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(-n.dayOfWeek(),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInYear:function(t){for(var e=0,r=1;r<=12;r++)e+=this.daysInMonth(t,r);return e},daysInMonth:function(t,e){for(var r=this._validate(t,e,this.minDay,i.local.invalidMonth),n=r.toJD()-24e5+.5,a=0,s=0;s<o.length;s++){if(o[s]>n)return o[a]-o[a-1];a++}return 30},weekDay:function(t,e,r){return 5!==this.dayOfWeek(t,e,r)},toJD:function(t,e,r){var n=this._validate(t,e,r,i.local.invalidDate),a=12*(n.year()-1)+n.month()-15292;return n.day()+o[a-1]-1+24e5-.5},fromJD:function(t){for(var e=t-24e5+.5,r=0,n=0;n<o.length&&!(o[n]>e);n++)r++;var i=r+15292,a=Math.floor((i-1)/12),s=a+1,l=i-12*a,u=e-o[r-1]+1;return this.newDate(s,l,u)},isValid:function(t,e,r){var n=i.baseCalendar.prototype.isValid.apply(this,arguments);return n&&(t=null!=t.year?t.year:t,n=t>=1276&&t<=1500),n},_validate:function(t,e,r,n){var a=i.baseCalendar.prototype._validate.apply(this,arguments);if(a.year<1276||a.year>1500)throw n.replace(/\\{0\\}/,this.local.name);return a}}),i.calendars.ummalqura=n;var o=[20,50,79,109,138,168,197,227,256,286,315,345,374,404,433,463,492,522,551,581,611,641,670,700,729,759,788,818,847,877,906,936,965,995,1024,1054,1083,1113,1142,1172,1201,1231,1260,1290,1320,1350,1379,1409,1438,1468,1497,1527,1556,1586,1615,1645,1674,1704,1733,1763,1792,1822,1851,1881,1910,1940,1969,1999,2028,2058,2087,2117,2146,2176,2205,2235,2264,2294,2323,2353,2383,2413,2442,2472,2501,2531,2560,2590,2619,2649,2678,2708,2737,2767,2796,2826,2855,2885,2914,2944,2973,3003,3032,3062,3091,3121,3150,3180,3209,3239,3268,3298,3327,3357,3386,3416,3446,3476,3505,3535,3564,3594,3623,3653,3682,3712,3741,3771,3800,3830,3859,3889,3918,3948,3977,4007,4036,4066,4095,4125,4155,4185,4214,4244,4273,4303,4332,4362,4391,4421,4450,4480,4509,4539,4568,4598,4627,4657,4686,4716,4745,4775,4804,4834,4863,4893,4922,4952,4981,5011,5040,5070,5099,5129,5158,5188,5218,5248,5277,5307,5336,5366,5395,5425,5454,5484,5513,5543,5572,5602,5631,5661,5690,5720,5749,5779,5808,5838,5867,5897,5926,5956,5985,6015,6044,6074,6103,6133,6162,6192,6221,6251,6281,6311,6340,6370,6399,6429,6458,6488,6517,6547,6576,6606,6635,6665,6694,6724,6753,6783,6812,6842,6871,6901,6930,6960,6989,7019,7048,7078,7107,7137,7166,7196,7225,7255,7284,7314,7344,7374,7403,7433,7462,7492,7521,7551,7580,7610,7639,7669,7698,7728,7757,7787,7816,7846,7875,7905,7934,7964,7993,8023,8053,8083,8112,8142,8171,8201,8230,8260,8289,8319,8348,8378,8407,8437,8466,8496,8525,8555,8584,8614,8643,8673,8702,8732,8761,8791,8821,8850,8880,8909,8938,8968,8997,9027,9056,9086,9115,9145,9175,9205,9234,9264,9293,9322,9352,9381,9410,9440,9470,9499,9529,9559,9589,9618,9648,9677,9706,9736,9765,9794,9824,9853,9883,9913,9943,9972,10002,10032,10061,10090,10120,10149,10178,10208,10237,10267,10297,10326,10356,10386,10415,10445,10474,10504,10533,10562,10592,10621,10651,10680,10710,10740,10770,10799,10829,10858,10888,10917,10947,10976,11005,11035,11064,11094,11124,11153,11183,11213,11242,11272,11301,11331,11360,11389,11419,11448,11478,11507,11537,11567,11596,11626,11655,11685,11715,11744,11774,11803,11832,11862,11891,11921,11950,11980,12010,12039,12069,12099,12128,12158,12187,12216,12246,12275,12304,12334,12364,12393,12423,12453,12483,12512,12542,12571,12600,12630,12659,12688,12718,12747,12777,12807,12837,12866,12896,12926,12955,12984,13014,13043,13072,13102,13131,13161,13191,13220,13250,13280,13310,13339,13368,13398,13427,13456,13486,13515,13545,13574,13604,13634,13664,13693,13723,13752,13782,13811,13840,13870,13899,13929,13958,13988,14018,14047,14077,14107,14136,14166,14195,14224,14254,14283,14313,14342,14372,14401,14431,14461,14490,14520,14550,14579,14609,14638,14667,14697,14726,14756,14785,14815,14844,14874,14904,14933,14963,14993,15021,15051,15081,15110,15140,15169,15199,15228,15258,15287,15317,15347,15377,15406,15436,15465,15494,15524,15553,15582,15612,15641,15671,15701,15731,15760,15790,15820,15849,15878,15908,15937,15966,15996,16025,16055,16085,16114,16144,16174,16204,16233,16262,16292,16321,16350,16380,16409,16439,16468,16498,16528,16558,16587,16617,16646,16676,16705,16734,16764,16793,16823,16852,16882,16912,16941,16971,17001,17030,17060,17089,17118,17148,17177,17207,17236,17266,17295,17325,17355,17384,17414,17444,17473,17502,17532,17561,17591,17620,17650,17679,17709,17738,17768,17798,17827,17857,17886,17916,17945,17975,18004,18034,18063,18093,18122,18152,18181,18211,18241,18270,18300,18330,18359,18388,18418,18447,18476,18506,18535,18565,18595,18625,18654,18684,18714,18743,18772,18802,18831,18860,18890,18919,18949,18979,19008,19038,19068,19098,19127,19156,19186,19215,19244,19274,19303,19333,19362,19392,19422,19452,19481,19511,19540,19570,19599,19628,19658,19687,19717,19746,19776,19806,19836,19865,19895,19924,19954,19983,20012,20042,20071,20101,20130,20160,20190,20219,20249,20279,20308,20338,20367,20396,20426,20455,20485,20514,20544,20573,20603,20633,20662,20692,20721,20751,20780,20810,20839,20869,20898,20928,20957,20987,21016,21046,21076,21105,21135,21164,21194,21223,21253,21282,21312,21341,21371,21400,21430,21459,21489,21519,21548,21578,21607,21637,21666,21696,21725,21754,21784,21813,21843,21873,21902,21932,21962,21991,22021,22050,22080,22109,22138,22168,22197,22227,22256,22286,22316,22346,22375,22405,22434,22464,22493,22522,22552,22581,22611,22640,22670,22700,22730,22759,22789,22818,22848,22877,22906,22936,22965,22994,23024,23054,23083,23113,23143,23173,23202,23232,23261,23290,23320,23349,23379,23408,23438,23467,23497,23527,23556,23586,23616,23645,23674,23704,23733,23763,23792,23822,23851,23881,23910,23940,23970,23999,24029,24058,24088,24117,24147,24176,24206,24235,24265,24294,24324,24353,24383,24413,24442,24472,24501,24531,24560,24590,24619,24648,24678,24707,24737,24767,24796,24826,24856,24885,24915,24944,24974,25003,25032,25062,25091,25121,25150,25180,25210,25240,25269,25299,25328,25358,25387,25416,25446,25475,25505,25534,25564,25594,25624,25653,25683,25712,25742,25771,25800,25830,25859,25888,25918,25948,25977,26007,26037,26067,26096,26126,26155,26184,26214,26243,26272,26302,26332,26361,26391,26421,26451,26480,26510,26539,26568,26598,26627,26656,26686,26715,26745,26775,26805,26834,26864,26893,26923,26952,26982,27011,27041,27070,27099,27129,27159,27188,27218,27248,27277,27307,27336,27366,27395,27425,27454,27484,27513,27542,27572,27602,27631,27661,27691,27720,27750,27779,27809,27838,27868,27897,27926,27956,27985,28015,28045,28074,28104,28134,28163,28193,28222,28252,28281,28310,28340,28369,28399,28428,28458,28488,28517,28547,28577,28607,28636,28665,28695,28724,28754,28783,28813,28843,28872,28901,28931,28960,28990,29019,29049,29078,29108,29137,29167,29196,29226,29255,29285,29315,29345,29375,29404,29434,29463,29492,29522,29551,29580,29610,29640,29669,29699,29729,29759,29788,29818,29847,29876,29906,29935,29964,29994,30023,30053,30082,30112,30141,30171,30200,30230,30259,30289,30318,30348,30378,30408,30437,30467,30496,30526,30555,30585,30614,30644,30673,30703,30732,30762,30791,30821,30850,30880,30909,30939,30968,30998,31027,31057,31086,31116,31145,31175,31204,31234,31263,31293,31322,31352,31381,31411,31441,31471,31500,31530,31559,31589,31618,31648,31676,31706,31736,31766,31795,31825,31854,31884,31913,31943,31972,32002,32031,32061,32090,32120,32150,32180,32209,32239,32268,32298,32327,32357,32386,32416,32445,32475,32504,32534,32563,32593,32622,32652,32681,32711,32740,32770,32799,32829,32858,32888,32917,32947,32976,33006,33035,33065,33094,33124,33153,33183,33213,33243,33272,33302,33331,33361,33390,33420,33450,33479,33509,33539,33568,33598,33627,33657,33686,33716,33745,33775,33804,33834,33863,33893,33922,33952,33981,34011,34040,34069,34099,34128,34158,34187,34217,34247,34277,34306,34336,34365,34395,34424,34454,34483,34512,34542,34571,34601,34631,34660,34690,34719,34749,34778,34808,34837,34867,34896,34926,34955,34985,35015,35044,35074,35103,35133,35162,35192,35222,35251,35280,35310,35340,35370,35399,35429,35458,35488,35517,35547,35576,35605,35635,35665,35694,35723,35753,35782,35811,35841,35871,35901,35930,35960,35989,36019,36048,36078,36107,36136,36166,36195,36225,36254,36284,36314,36343,36373,36403,36433,36462,36492,36521,36551,36580,36610,36639,36669,36698,36728,36757,36786,36816,36845,36875,36904,36934,36963,36993,37022,37052,37081,37111,37141,37170,37200,37229,37259,37288,37318,37347,37377,37406,37436,37465,37495,37524,37554,37584,37613,37643,37672,37701,37731,37760,37790,37819,37849,37878,37908,37938,37967,37997,38027,38056,38085,38115,38144,38174,38203,38233,38262,38292,38322,38351,38381,38410,38440,38469,38499,38528,38558,38587,38617,38646,38676,38705,38735,38764,38794,38823,38853,38882,38912,38941,38971,39001,39030,39059,39089,39118,39148,39178,39208,39237,39267,39297,39326,39355,39385,39414,39444,39473,39503,39532,39562,39592,39621,39650,39680,39709,39739,39768,39798,39827,39857,39886,39916,39946,39975,40005,40035,40064,40094,40123,40153,40182,40212,40241,40271,40300,40330,40359,40389,40418,40448,40477,40507,40536,40566,40595,40625,40655,40685,40714,40744,40773,40803,40832,40862,40892,40921,40951,40980,41009,41039,41068,41098,41127,41157,41186,41216,41245,41275,41304,41334,41364,41393,41422,41452,41481,41511,41540,41570,41599,41629,41658,41688,41718,41748,41777,41807,41836,41865,41894,41924,41953,41983,42012,42042,42072,42102,42131,42161,42190,42220,42249,42279,42308,42337,42367,42397,42426,42456,42485,42515,42545,42574,42604,42633,42662,42692,42721,42751,42780,42810,42839,42869,42899,42929,42958,42988,43017,43046,43076,43105,43135,43164,43194,43223,43253,43283,43312,43342,43371,43401,43430,43460,43489,43519,43548,43578,43607,43637,43666,43696,43726,43755,43785,43814,43844,43873,43903,43932,43962,43991,44021,44050,44080,44109,44139,44169,44198,44228,44258,44287,44317,44346,44375,44405,44434,44464,44493,44523,44553,44582,44612,44641,44671,44700,44730,44759,44788,44818,44847,44877,44906,44936,44966,44996,45025,45055,45084,45114,45143,45172,45202,45231,45261,45290,45320,45350,45380,45409,45439,45468,45498,45527,45556,45586,45615,45644,45674,45704,45733,45763,45793,45823,45852,45882,45911,45940,45970,45999,46028,46058,46088,46117,46147,46177,46206,46236,46265,46295,46324,46354,46383,46413,46442,46472,46501,46531,46560,46590,46620,46649,46679,46708,46738,46767,46797,46826,46856,46885,46915,46944,46974,47003,47033,47063,47092,47122,47151,47181,47210,47240,47269,47298,47328,47357,47387,47417,47446,47476,47506,47535,47565,47594,47624,47653,47682,47712,47741,47771,47800,47830,47860,47890,47919,47949,47978,48008,48037,48066,48096,48125,48155,48184,48214,48244,48273,48303,48333,48362,48392,48421,48450,48480,48509,48538,48568,48598,48627,48657,48687,48717,48746,48776,48805,48834,48864,48893,48922,48952,48982,49011,49041,49071,49100,49130,49160,49189,49218,49248,49277,49306,49336,49365,49395,49425,49455,49484,49514,49543,49573,49602,49632,49661,49690,49720,49749,49779,49809,49838,49868,49898,49927,49957,49986,50016,50045,50075,50104,50133,50163,50192,50222,50252,50281,50311,50340,50370,50400,50429,50459,50488,50518,50547,50576,50606,50635,50665,50694,50724,50754,50784,50813,50843,50872,50902,50931,50960,50990,51019,51049,51078,51108,51138,51167,51197,51227,51256,51286,51315,51345,51374,51403,51433,51462,51492,51522,51552,51582,51611,51641,51670,51699,51729,51758,51787,51816,51846,51876,51906,51936,51965,51995,52025,52054,52083,52113,52142,52171,52200,52230,52260,52290,52319,52349,52379,52408,52438,52467,52497,52526,52555,52585,52614,52644,52673,52703,52733,52762,52792,52822,52851,52881,52910,52939,52969,52998,53028,53057,53087,53116,53146,53176,53205,53235,53264,53294,53324,53353,53383,53412,53441,53471,53500,53530,53559,53589,53619,53648,53678,53708,53737,53767,53796,53825,53855,53884,53913,53943,53973,54003,54032,54062,54092,54121,54151,54180,54209,54239,54268,54297,54327,54357,54387,54416,54446,54476,54505,54535,54564,54593,54623,54652,54681,54711,54741,54770,54800,54830,54859,54889,54919,54948,54977,55007,55036,55066,55095,55125,55154,55184,55213,55243,55273,55302,55332,55361,55391,55420,55450,55479,55508,55538,55567,55597,55627,55657,55686,55716,55745,55775,55804,55834,55863,55892,55922,55951,55981,56011,56040,56070,56100,56129,56159,56188,56218,56247,56276,56306,56335,56365,56394,56424,56454,56483,56513,56543,56572,56601,56631,56660,56690,56719,56749,56778,56808,56837,56867,56897,56926,56956,56985,57015,57044,57074,57103,57133,57162,57192,57221,57251,57280,57310,57340,57369,57399,57429,57458,57487,57517,57546,57576,57605,57634,57664,57694,57723,57753,57783,57813,57842,57871,57901,57930,57959,57989,58018,58048,58077,58107,58137,58167,58196,58226,58255,58285,58314,58343,58373,58402,58432,58461,58491,58521,58551,58580,58610,58639,58669,58698,58727,58757,58786,58816,58845,58875,58905,58934,58964,58994,59023,59053,59082,59111,59141,59170,59200,59229,59259,59288,59318,59348,59377,59407,59436,59466,59495,59525,59554,59584,59613,59643,59672,59702,59731,59761,59791,59820,59850,59879,59909,59939,59968,59997,60027,60056,60086,60115,60145,60174,60204,60234,60264,60293,60323,60352,60381,60411,60440,60469,60499,60528,60558,60588,60618,60648,60677,60707,60736,60765,60795,60824,60853,60883,60912,60942,60972,61002,61031,61061,61090,61120,61149,61179,61208,61237,61267,61296,61326,61356,61385,61415,61445,61474,61504,61533,61563,61592,61621,61651,61680,61710,61739,61769,61799,61828,61858,61888,61917,61947,61976,62006,62035,62064,62094,62123,62153,62182,62212,62242,62271,62301,62331,62360,62390,62419,62448,62478,62507,62537,62566,62596,62625,62655,62685,62715,62744,62774,62803,62832,62862,62891,62921,62950,62980,63009,63039,63069,63099,63128,63157,63187,63216,63246,63275,63305,63334,63363,63393,63423,63453,63482,63512,63541,63571,63600,63630,63659,63689,63718,63747,63777,63807,63836,63866,63895,63925,63955,63984,64014,64043,64073,64102,64131,64161,64190,64220,64249,64279,64309,64339,64368,64398,64427,64457,64486,64515,64545,64574,64603,64633,64663,64692,64722,64752,64782,64811,64841,64870,64899,64929,64958,64987,65017,65047,65076,65106,65136,65166,65195,65225,65254,65283,65313,65342,65371,65401,65431,65460,65490,65520,65549,65579,65608,65638,65667,65697,65726,65755,65785,65815,65844,65874,65903,65933,65963,65992,66022,66051,66081,66110,66140,66169,66199,66228,66258,66287,66317,66346,66376,66405,66435,66465,66494,66524,66553,66583,66612,66641,66671,66700,66730,66760,66789,66819,66849,66878,66908,66937,66967,66996,67025,67055,67084,67114,67143,67173,67203,67233,67262,67292,67321,67351,67380,67409,67439,67468,67497,67527,67557,67587,67617,67646,67676,67705,67735,67764,67793,67823,67852,67882,67911,67941,67971,68e3,68030,68060,68089,68119,68148,68177,68207,68236,68266,68295,68325,68354,68384,68414,68443,68473,68502,68532,68561,68591,68620,68650,68679,68708,68738,68768,68797,68827,68857,68886,68916,68946,68975,69004,69034,69063,69092,69122,69152,69181,69211,69240,69270,69300,69330,69359,69388,69418,69447,69476,69506,69535,69565,69595,69624,69654,69684,69713,69743,69772,69802,69831,69861,69890,69919,69949,69978,70008,70038,70067,70097,70126,70156,70186,70215,70245,70274,70303,70333,70362,70392,70421,70451,70481,70510,70540,70570,70599,70629,70658,70687,70717,70746,70776,70805,70835,70864,70894,70924,70954,70983,71013,71042,71071,71101,71130,71159,71189,71218,71248,71278,71308,71337,71367,71397,71426,71455,71485,71514,71543,71573,71602,71632,71662,71691,71721,71751,71781,71810,71839,71869,71898,71927,71957,71986,72016,72046,72075,72105,72135,72164,72194,72223,72253,72282,72311,72341,72370,72400,72429,72459,72489,72518,72548,72577,72607,72637,72666,72695,72725,72754,72784,72813,72843,72872,72902,72931,72961,72991,73020,73050,73080,73109,73139,73168,73197,73227,73256,73286,73315,73345,73375,73404,73434,73464,73493,73523,73552,73581,73611,73640,73669,73699,73729,73758,73788,73818,73848,73877,73907,73936,73965,73995,74024,74053,74083,74113,74142,74172,74202,74231,74261,74291,74320,74349,74379,74408,74437,74467,74497,74526,74556,74586,74615,74645,74675,74704,74733,74763,74792,74822,74851,74881,74910,74940,74969,74999,75029,75058,75088,75117,75147,75176,75206,75235,75264,75294,75323,75353,75383,75412,75442,75472,75501,75531,75560,75590,75619,75648,75678,75707,75737,75766,75796,75826,75856,75885,75915,75944,75974,76003,76032,76062,76091,76121,76150,76180,76210,76239,76269,76299,76328,76358,76387,76416,76446,76475,76505,76534,76564,76593,76623,76653,76682,76712,76741,76771,76801,76830,76859,76889,76918,76948,76977,77007,77036,77066,77096,77125,77155,77185,77214,77243,77273,77302,77332,77361,77390,77420,77450,77479,77509,77539,77569,77598,77627,77657,77686,77715,77745,77774,77804,77833,77863,77893,77923,77952,77982,78011,78041,78070,78099,78129,78158,78188,78217,78247,78277,78307,78336,78366,78395,78425,78454,78483,78513,78542,78572,78601,78631,78661,78690,78720,78750,78779,78808,78838,78867,78897,78926,78956,78985,79015,79044,79074,79104,79133,79163,79192,79222,79251,79281,79310,79340,79369,79399,79428,79458,79487,79517,79546,79576,79606,79635,79665,79695,79724,79753,79783,79812,79841,79871,79900,79930,79960,79990]},{\"../main\":580,\"object-assign\":469}],580:[function(t,e,r){function n(){this.regionalOptions=[],this.regionalOptions[\"\"]={invalidCalendar:\"Calendar {0} not found\",invalidDate:\"Invalid {0} date\",invalidMonth:\"Invalid {0} month\",invalidYear:\"Invalid {0} year\",differentCalendars:\"Cannot mix {0} and {1} dates\"},this.local=this.regionalOptions[\"\"],this.calendars={},this._localCals={}}function i(t,e,r,n){if(this._calendar=t,this._year=e,this._month=r,this._day=n,0===this._calendar._validateLevel&&!this._calendar.isValid(this._year,this._month,this._day))throw(u.local.invalidDate||u.regionalOptions[\"\"].invalidDate).replace(/\\{0\\}/,this._calendar.local.name)}function a(t,e){return t=\"\"+t,\"000000\".substring(0,e-t.length)+t}function o(){this.shortYearCutoff=\"+10\"}function s(t){this.local=this.regionalOptions[t]||this.regionalOptions[\"\"]}var l=t(\"object-assign\");l(n.prototype,{instance:function(t,e){t=(t||\"gregorian\").toLowerCase(),e=e||\"\";var r=this._localCals[t+\"-\"+e];if(!r&&this.calendars[t]&&(r=new this.calendars[t](e),this._localCals[t+\"-\"+e]=r),!r)throw(this.local.invalidCalendar||this.regionalOptions[\"\"].invalidCalendar).replace(/\\{0\\}/,t);return r},newDate:function(t,e,r,n,i){return n=(null!=t&&t.year?t.calendar():\"string\"==typeof n?this.instance(n,i):n)||this.instance(),n.newDate(t,e,r)},substituteDigits:function(t){\n",
       "return function(e){return(e+\"\").replace(/[0-9]/g,function(e){return t[e]})}},substituteChineseDigits:function(t,e){return function(r){for(var n=\"\",i=0;r>0;){var a=r%10;n=(0===a?\"\":t[a]+e[i])+n,i++,r=Math.floor(r/10)}return 0===n.indexOf(t[1]+e[1])&&(n=n.substr(1)),n||t[0]}}}),l(i.prototype,{newDate:function(t,e,r){return this._calendar.newDate(null==t?this:t,e,r)},year:function(t){return 0===arguments.length?this._year:this.set(t,\"y\")},month:function(t){return 0===arguments.length?this._month:this.set(t,\"m\")},day:function(t){return 0===arguments.length?this._day:this.set(t,\"d\")},date:function(t,e,r){if(!this._calendar.isValid(t,e,r))throw(u.local.invalidDate||u.regionalOptions[\"\"].invalidDate).replace(/\\{0\\}/,this._calendar.local.name);return this._year=t,this._month=e,this._day=r,this},leapYear:function(){return this._calendar.leapYear(this)},epoch:function(){return this._calendar.epoch(this)},formatYear:function(){return this._calendar.formatYear(this)},monthOfYear:function(){return this._calendar.monthOfYear(this)},weekOfYear:function(){return this._calendar.weekOfYear(this)},daysInYear:function(){return this._calendar.daysInYear(this)},dayOfYear:function(){return this._calendar.dayOfYear(this)},daysInMonth:function(){return this._calendar.daysInMonth(this)},dayOfWeek:function(){return this._calendar.dayOfWeek(this)},weekDay:function(){return this._calendar.weekDay(this)},extraInfo:function(){return this._calendar.extraInfo(this)},add:function(t,e){return this._calendar.add(this,t,e)},set:function(t,e){return this._calendar.set(this,t,e)},compareTo:function(t){if(this._calendar.name!==t._calendar.name)throw(u.local.differentCalendars||u.regionalOptions[\"\"].differentCalendars).replace(/\\{0\\}/,this._calendar.local.name).replace(/\\{1\\}/,t._calendar.local.name);var e=this._year!==t._year?this._year-t._year:this._month!==t._month?this.monthOfYear()-t.monthOfYear():this._day-t._day;return 0===e?0:e<0?-1:1},calendar:function(){return this._calendar},toJD:function(){return this._calendar.toJD(this)},fromJD:function(t){return this._calendar.fromJD(t)},toJSDate:function(){return this._calendar.toJSDate(this)},fromJSDate:function(t){return this._calendar.fromJSDate(t)},toString:function(){return(this.year()<0?\"-\":\"\")+a(Math.abs(this.year()),4)+\"-\"+a(this.month(),2)+\"-\"+a(this.day(),2)}}),l(o.prototype,{_validateLevel:0,newDate:function(t,e,r){return null==t?this.today():(t.year&&(this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),r=t.day(),e=t.month(),t=t.year()),new i(this,t,e,r))},today:function(){return this.fromJSDate(new Date)},epoch:function(t){return this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear).year()<0?this.local.epochs[0]:this.local.epochs[1]},formatYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear);return(e.year()<0?\"-\":\"\")+a(Math.abs(e.year()),4)},monthsInYear:function(t){return this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear),12},monthOfYear:function(t,e){var r=this._validate(t,e,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth);return(r.month()+this.monthsInYear(r)-this.firstMonth)%this.monthsInYear(r)+this.minMonth},fromMonthOfYear:function(t,e){var r=(e+this.firstMonth-2*this.minMonth)%this.monthsInYear(t)+this.minMonth;return this._validate(t,r,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth),r},daysInYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear);return this.leapYear(e)?366:365},dayOfYear:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return n.toJD()-this.newDate(n.year(),this.fromMonthOfYear(n.year(),this.minMonth),this.minDay).toJD()+1},daysInWeek:function(){return 7},dayOfWeek:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return(Math.floor(this.toJD(n))+2)%this.daysInWeek()},extraInfo:function(t,e,r){return this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),{}},add:function(t,e,r){return this._validate(t,this.minMonth,this.minDay,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),this._correctAdd(t,this._add(t,e,r),e,r)},_add:function(t,e,r){if(this._validateLevel++,\"d\"===r||\"w\"===r){var n=t.toJD()+e*(\"w\"===r?this.daysInWeek():1),i=t.calendar().fromJD(n);return this._validateLevel--,[i.year(),i.month(),i.day()]}try{var a=t.year()+(\"y\"===r?e:0),o=t.monthOfYear()+(\"m\"===r?e:0),i=t.day();\"y\"===r?(t.month()!==this.fromMonthOfYear(a,o)&&(o=this.newDate(a,t.month(),this.minDay).monthOfYear()),o=Math.min(o,this.monthsInYear(a)),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o)))):\"m\"===r&&(!function(t){for(;o<t.minMonth;)a--,o+=t.monthsInYear(a);for(var e=t.monthsInYear(a);o>e-1+t.minMonth;)a++,o-=e,e=t.monthsInYear(a)}(this),i=Math.min(i,this.daysInMonth(a,this.fromMonthOfYear(a,o))));var s=[a,this.fromMonthOfYear(a,o),i];return this._validateLevel--,s}catch(t){throw this._validateLevel--,t}},_correctAdd:function(t,e,r,n){if(!(this.hasYearZero||\"y\"!==n&&\"m\"!==n||0!==e[0]&&t.year()>0==e[0]>0)){var i={y:[1,1,\"y\"],m:[1,this.monthsInYear(-1),\"m\"],w:[this.daysInWeek(),this.daysInYear(-1),\"d\"],d:[1,this.daysInYear(-1),\"d\"]}[n],a=r<0?-1:1;e=this._add(t,r*i[0]+a*i[1],i[2])}return t.date(e[0],e[1],e[2])},set:function(t,e,r){this._validate(t,this.minMonth,this.minDay,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);var n=\"y\"===r?e:t.year(),i=\"m\"===r?e:t.month(),a=\"d\"===r?e:t.day();return\"y\"!==r&&\"m\"!==r||(a=Math.min(a,this.daysInMonth(n,i))),t.date(n,i,a)},isValid:function(t,e,r){this._validateLevel++;var n=this.hasYearZero||0!==t;if(n){var i=this.newDate(t,e,this.minDay);n=e>=this.minMonth&&e-this.minMonth<this.monthsInYear(i)&&r>=this.minDay&&r-this.minDay<this.daysInMonth(i)}return this._validateLevel--,n},toJSDate:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);return u.instance().fromJD(this.toJD(n)).toJSDate()},fromJSDate:function(t){return this.fromJD(u.instance().fromJSDate(t).toJD())},_validate:function(t,e,r,n){if(t.year){if(0===this._validateLevel&&this.name!==t.calendar().name)throw(u.local.differentCalendars||u.regionalOptions[\"\"].differentCalendars).replace(/\\{0\\}/,this.local.name).replace(/\\{1\\}/,t.calendar().local.name);return t}try{if(1===++this._validateLevel&&!this.isValid(t,e,r))throw n.replace(/\\{0\\}/,this.local.name);var i=this.newDate(t,e,r);return this._validateLevel--,i}catch(t){throw this._validateLevel--,t}}}),s.prototype=new o,l(s.prototype,{name:\"Gregorian\",jdEpoch:1721425.5,daysPerMonth:[31,28,31,30,31,30,31,31,30,31,30,31],hasYearZero:!1,minMonth:1,firstMonth:1,minDay:1,regionalOptions:{\"\":{name:\"Gregorian\",epochs:[\"BCE\",\"CE\"],monthNames:[\"January\",\"February\",\"March\",\"April\",\"May\",\"June\",\"July\",\"August\",\"September\",\"October\",\"November\",\"December\"],monthNamesShort:[\"Jan\",\"Feb\",\"Mar\",\"Apr\",\"May\",\"Jun\",\"Jul\",\"Aug\",\"Sep\",\"Oct\",\"Nov\",\"Dec\"],dayNames:[\"Sunday\",\"Monday\",\"Tuesday\",\"Wednesday\",\"Thursday\",\"Friday\",\"Saturday\"],dayNamesShort:[\"Sun\",\"Mon\",\"Tue\",\"Wed\",\"Thu\",\"Fri\",\"Sat\"],dayNamesMin:[\"Su\",\"Mo\",\"Tu\",\"We\",\"Th\",\"Fr\",\"Sa\"],digits:null,dateFormat:\"mm/dd/yyyy\",firstDay:0,isRTL:!1}},leapYear:function(t){var e=this._validate(t,this.minMonth,this.minDay,u.local.invalidYear||u.regionalOptions[\"\"].invalidYear),t=e.year()+(e.year()<0?1:0);return t%4==0&&(t%100!=0||t%400==0)},weekOfYear:function(t,e,r){var n=this.newDate(t,e,r);return n.add(4-(n.dayOfWeek()||7),\"d\"),Math.floor((n.dayOfYear()-1)/7)+1},daysInMonth:function(t,e){var r=this._validate(t,e,this.minDay,u.local.invalidMonth||u.regionalOptions[\"\"].invalidMonth);return this.daysPerMonth[r.month()-1]+(2===r.month()&&this.leapYear(r.year())?1:0)},weekDay:function(t,e,r){return(this.dayOfWeek(t,e,r)||7)<6},toJD:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate);t=n.year(),e=n.month(),r=n.day(),t<0&&t++,e<3&&(e+=12,t--);var i=Math.floor(t/100),a=2-i+Math.floor(i/4);return Math.floor(365.25*(t+4716))+Math.floor(30.6001*(e+1))+r+a-1524.5},fromJD:function(t){var e=Math.floor(t+.5),r=Math.floor((e-1867216.25)/36524.25);r=e+1+r-Math.floor(r/4);var n=r+1524,i=Math.floor((n-122.1)/365.25),a=Math.floor(365.25*i),o=Math.floor((n-a)/30.6001),s=n-a-Math.floor(30.6001*o),l=o-(o>13.5?13:1),u=i-(l>2.5?4716:4715);return u<=0&&u--,this.newDate(u,l,s)},toJSDate:function(t,e,r){var n=this._validate(t,e,r,u.local.invalidDate||u.regionalOptions[\"\"].invalidDate),i=new Date(n.year(),n.month()-1,n.day());return i.setHours(0),i.setMinutes(0),i.setSeconds(0),i.setMilliseconds(0),i.setHours(i.getHours()>12?i.getHours()+2:0),i},fromJSDate:function(t){return this.newDate(t.getFullYear(),t.getMonth()+1,t.getDate())}});var u=e.exports=new n;u.cdate=i,u.baseCalendar=o,u.calendars.gregorian=s},{\"object-assign\":469}],581:[function(t,e,r){var n=t(\"object-assign\"),i=t(\"./main\");n(i.regionalOptions[\"\"],{invalidArguments:\"Invalid arguments\",invalidFormat:\"Cannot format a date from another calendar\",missingNumberAt:\"Missing number at position {0}\",unknownNameAt:\"Unknown name at position {0}\",unexpectedLiteralAt:\"Unexpected literal at position {0}\",unexpectedText:\"Additional text found at end\"}),i.local=i.regionalOptions[\"\"],n(i.cdate.prototype,{formatDate:function(t,e){return\"string\"!=typeof t&&(e=t,t=\"\"),this._calendar.formatDate(t||\"\",this,e)}}),n(i.baseCalendar.prototype,{UNIX_EPOCH:i.instance().newDate(1970,1,1).toJD(),SECS_PER_DAY:86400,TICKS_EPOCH:i.instance().jdEpoch,TICKS_PER_DAY:864e9,ATOM:\"yyyy-mm-dd\",COOKIE:\"D, dd M yyyy\",FULL:\"DD, MM d, yyyy\",ISO_8601:\"yyyy-mm-dd\",JULIAN:\"J\",RFC_822:\"D, d M yy\",RFC_850:\"DD, dd-M-yy\",RFC_1036:\"D, d M yy\",RFC_1123:\"D, d M yyyy\",RFC_2822:\"D, d M yyyy\",RSS:\"D, d M yy\",TICKS:\"!\",TIMESTAMP:\"@\",W3C:\"yyyy-mm-dd\",formatDate:function(t,e,r){if(\"string\"!=typeof t&&(r=e,e=t,t=\"\"),!e)return\"\";if(e.calendar()!==this)throw i.local.invalidFormat||i.regionalOptions[\"\"].invalidFormat;t=t||this.local.dateFormat,r=r||{};for(var n=r.dayNamesShort||this.local.dayNamesShort,a=r.dayNames||this.local.dayNames,o=r.monthNumbers||this.local.monthNumbers,s=r.monthNamesShort||this.local.monthNamesShort,l=r.monthNames||this.local.monthNames,u=(r.calculateWeek||this.local.calculateWeek,function(e,r){for(var n=1;v+n<t.length&&t.charAt(v+n)===e;)n++;return v+=n-1,Math.floor(n/(r||1))>1}),c=function(t,e,r,n){var i=\"\"+e;if(u(t,n))for(;i.length<r;)i=\"0\"+i;return i},h=this,f=this.local.digits,d=function(t){return r.localNumbers&&f?f(t):t},p=\"\",m=!1,v=0;v<t.length;v++)if(m)\"'\"!==t.charAt(v)||u(\"'\")?p+=t.charAt(v):m=!1;else switch(t.charAt(v)){case\"d\":p+=d(c(\"d\",e.day(),2));break;case\"D\":p+=function(t,e,r,n){return u(t)?n[e]:r[e]}(\"D\",e.dayOfWeek(),n,a);break;case\"o\":p+=c(\"o\",e.dayOfYear(),3);break;case\"w\":p+=c(\"w\",e.weekOfYear(),2);break;case\"m\":p+=function(t){return\"function\"==typeof o?o.call(h,t,u(\"m\")):d(c(\"m\",t.month(),2))}(e);break;case\"M\":p+=function(t,e){return e?\"function\"==typeof l?l.call(h,t):l[t.month()-h.minMonth]:\"function\"==typeof s?s.call(h,t):s[t.month()-h.minMonth]}(e,u(\"M\"));break;case\"y\":p+=u(\"y\",2)?e.year():(e.year()%100<10?\"0\":\"\")+e.year()%100;break;case\"Y\":u(\"Y\",2),p+=e.formatYear();break;case\"J\":p+=e.toJD();break;case\"@\":p+=(e.toJD()-this.UNIX_EPOCH)*this.SECS_PER_DAY;break;case\"!\":p+=(e.toJD()-this.TICKS_EPOCH)*this.TICKS_PER_DAY;break;case\"'\":u(\"'\")?p+=\"'\":m=!0;break;default:p+=t.charAt(v)}return p},parseDate:function(t,e,r){if(null==e)throw i.local.invalidArguments||i.regionalOptions[\"\"].invalidArguments;if(\"\"===(e=\"object\"==typeof e?e.toString():e+\"\"))return null;t=t||this.local.dateFormat,r=r||{};var n=r.shortYearCutoff||this.shortYearCutoff;n=\"string\"!=typeof n?n:this.today().year()%100+parseInt(n,10);for(var a=r.dayNamesShort||this.local.dayNamesShort,o=r.dayNames||this.local.dayNames,s=r.parseMonth||this.local.parseMonth,l=r.monthNumbers||this.local.monthNumbers,u=r.monthNamesShort||this.local.monthNamesShort,c=r.monthNames||this.local.monthNames,h=-1,f=-1,d=-1,p=-1,m=-1,v=!1,g=!1,y=function(e,r){for(var n=1;k+n<t.length&&t.charAt(k+n)===e;)n++;return k+=n-1,Math.floor(n/(r||1))>1},b=function(t,r){var n=y(t,r),a=[2,3,n?4:2,n?4:2,10,11,20][\"oyYJ@!\".indexOf(t)+1],o=new RegExp(\"^-?\\\\d{1,\"+a+\"}\"),s=e.substring(M).match(o);if(!s)throw(i.local.missingNumberAt||i.regionalOptions[\"\"].missingNumberAt).replace(/\\{0\\}/,M);return M+=s[0].length,parseInt(s[0],10)},x=this,_=function(t,r,n,a){for(var o=y(t,a)?n:r,s=0;s<o.length;s++)if(e.substr(M,o[s].length).toLowerCase()===o[s].toLowerCase())return M+=o[s].length,s+x.minMonth;throw(i.local.unknownNameAt||i.regionalOptions[\"\"].unknownNameAt).replace(/\\{0\\}/,M)},w=function(){if(e.charAt(M)!==t.charAt(k))throw(i.local.unexpectedLiteralAt||i.regionalOptions[\"\"].unexpectedLiteralAt).replace(/\\{0\\}/,M);M++},M=0,k=0;k<t.length;k++)if(g)\"'\"!==t.charAt(k)||y(\"'\")?w():g=!1;else switch(t.charAt(k)){case\"d\":p=b(\"d\");break;case\"D\":_(\"D\",a,o);break;case\"o\":m=b(\"o\");break;case\"w\":b(\"w\");break;case\"m\":d=function(){if(\"function\"==typeof l){y(\"m\");var t=l.call(x,e.substring(M));return M+=t.length,t}return b(\"m\")}();break;case\"M\":d=function(){if(\"function\"==typeof c){var t=y(\"M\")?c.call(x,e.substring(M)):u.call(x,e.substring(M));return M+=t.length,t}return _(\"M\",u,c)}();break;case\"y\":var A=k;v=!y(\"y\",2),k=A,f=b(\"y\",2);break;case\"Y\":f=b(\"Y\",2);break;case\"J\":h=b(\"J\")+.5,\".\"===e.charAt(M)&&(M++,b(\"J\"));break;case\"@\":h=b(\"@\")/this.SECS_PER_DAY+this.UNIX_EPOCH;break;case\"!\":h=b(\"!\")/this.TICKS_PER_DAY+this.TICKS_EPOCH;break;case\"*\":M=e.length;break;case\"'\":y(\"'\")?w():g=!0;break;default:w()}if(M<e.length)throw i.local.unexpectedText||i.regionalOptions[\"\"].unexpectedText;if(-1===f?f=this.today().year():f<100&&v&&(f+=-1===n?1900:this.today().year()-this.today().year()%100-(f<=n?0:100)),\"string\"==typeof d&&(d=s.call(this,f,d)),m>-1){d=1,p=m;for(var T=this.daysInMonth(f,d);p>T;T=this.daysInMonth(f,d))d++,p-=T}return h>-1?this.fromJD(h):this.newDate(f,d,p)},determineDate:function(t,e,r,n,i){r&&\"object\"!=typeof r&&(i=n,n=r,r=null),\"string\"!=typeof n&&(i=n,n=\"\");var a=this;return e=e?e.newDate():null,t=null==t?e:\"string\"==typeof t?function(t){try{return a.parseDate(n,t,i)}catch(t){}t=t.toLowerCase();for(var e=(t.match(/^c/)&&r?r.newDate():null)||a.today(),o=/([+-]?[0-9]+)\\s*(d|w|m|y)?/g,s=o.exec(t);s;)e.add(parseInt(s[1],10),s[2]||\"d\"),s=o.exec(t);return e}(t):\"number\"==typeof t?isNaN(t)||t===1/0||t===-1/0?e:a.today().add(t,\"d\"):a.newDate(t)}})},{\"./main\":580,\"object-assign\":469}],582:[function(t,e,r){e.exports=t(\"cwise-compiler\")({args:[\"array\",{offset:[1],array:0},\"scalar\",\"scalar\",\"index\"],pre:{body:\"{}\",args:[],thisVars:[],localVars:[]},post:{body:\"{}\",args:[],thisVars:[],localVars:[]},body:{body:\"{\\n        var _inline_1_da = _inline_1_arg0_ - _inline_1_arg3_\\n        var _inline_1_db = _inline_1_arg1_ - _inline_1_arg3_\\n        if((_inline_1_da >= 0) !== (_inline_1_db >= 0)) {\\n          _inline_1_arg2_.push(_inline_1_arg4_[0] + 0.5 + 0.5 * (_inline_1_da + _inline_1_db) / (_inline_1_da - _inline_1_db))\\n        }\\n      }\",args:[{name:\"_inline_1_arg0_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg1_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg2_\",lvalue:!1,rvalue:!0,count:1},{name:\"_inline_1_arg3_\",lvalue:!1,rvalue:!0,count:2},{name:\"_inline_1_arg4_\",lvalue:!1,rvalue:!0,count:1}],thisVars:[],localVars:[\"_inline_1_da\",\"_inline_1_db\"]},funcName:\"zeroCrossings\"})},{\"cwise-compiler\":109}],583:[function(t,e,r){\"use strict\";function n(t,e){var r=[];return e=+e||0,i(t.hi(t.shape[0]-1),r,e),r}e.exports=n;var i=t(\"./lib/zc-core\")},{\"./lib/zc-core\":582}],584:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"./common_defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s,l){function u(r,i){return n.coerce(t,e,o,r,i)}s=s||{},l=l||{};var c=u(\"visible\",!l.itemIsNotPlainObject),h=u(\"clicktoshow\");if(!c&&!h)return e;a(t,e,r,u);for(var f=e.showarrow,d=[\"x\",\"y\"],p=[-10,-30],m={_fullLayout:r},v=0;v<2;v++){var g=d[v],y=i.coerceRef(t,e,m,g,\"\",\"paper\");if(i.coercePosition(e,m,u,y,g,.5),f){var b=\"a\"+g,x=i.coerceRef(t,e,m,b,\"pixel\");\"pixel\"!==x&&x!==y&&(x=e[b]=\"pixel\");var _=\"pixel\"===x?p[v]:.4;i.coercePosition(e,m,u,x,b,_)}u(g+\"anchor\"),u(g+\"shift\")}if(n.noneOrAll(t,e,[\"x\",\"y\"]),f&&n.noneOrAll(t,e,[\"ax\",\"ay\"]),h){var w=u(\"xclick\"),M=u(\"yclick\");e._xclick=void 0===w?e.x:i.cleanPosition(w,m,e.xref),e._yclick=void 0===M?e.y:i.cleanPosition(M,m,e.yref)}return e}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./attributes\":586,\"./common_defaults\":589}],585:[function(t,e,r){\"use strict\";e.exports=[{path:\"\",backoff:0},{path:\"M-2.4,-3V3L0.6,0Z\",backoff:.6},{path:\"M-3.7,-2.5V2.5L1.3,0Z\",backoff:1.3},{path:\"M-4.45,-3L-1.65,-0.2V0.2L-4.45,3L1.55,0Z\",backoff:1.55},{path:\"M-2.2,-2.2L-0.2,-0.2V0.2L-2.2,2.2L-1.4,3L1.6,0L-1.4,-3Z\",backoff:1.6},{path:\"M-4.4,-2.1L-0.6,-0.2V0.2L-4.4,2.1L-4,3L2,0L-4,-3Z\",backoff:2},{path:\"M2,0A2,2 0 1,1 0,-2A2,2 0 0,1 2,0Z\",backoff:0},{path:\"M2,2V-2H-2V2Z\",backoff:0}]},{}],586:[function(t,e,r){\"use strict\";var n=t(\"./arrow_paths\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/cartesian/constants\"),o=t(\"../../lib/extend\").extendFlat;e.exports={_isLinkedToArray:\"annotation\",visible:{valType:\"boolean\",dflt:!0},text:{valType:\"string\"},textangle:{valType:\"angle\",dflt:0},font:o({},i,{}),width:{valType:\"number\",min:1,dflt:null},height:{valType:\"number\",min:1,dflt:null},opacity:{valType:\"number\",min:0,max:1,dflt:1},align:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"center\"},valign:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"middle\"},bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},bordercolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},borderpad:{valType:\"number\",min:0,dflt:1},borderwidth:{valType:\"number\",min:0,dflt:1},showarrow:{valType:\"boolean\",dflt:!0},arrowcolor:{valType:\"color\"},arrowhead:{valType:\"integer\",min:0,max:n.length,dflt:1},arrowsize:{valType:\"number\",min:.3,dflt:1},arrowwidth:{valType:\"number\",min:.1},standoff:{valType:\"number\",min:0,dflt:0},ax:{valType:\"any\"},ay:{valType:\"any\"},axref:{valType:\"enumerated\",dflt:\"pixel\",values:[\"pixel\",a.idRegex.x.toString()]},ayref:{valType:\"enumerated\",dflt:\"pixel\",values:[\"pixel\",a.idRegex.y.toString()]},xref:{valType:\"enumerated\",values:[\"paper\",a.idRegex.x.toString()]},x:{valType:\"any\"},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"auto\"},xshift:{valType:\"number\",dflt:0},yref:{valType:\"enumerated\",values:[\"paper\",a.idRegex.y.toString()]},y:{valType:\"any\"},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"auto\"},yshift:{valType:\"number\",dflt:0},clicktoshow:{valType:\"enumerated\",values:[!1,\"onoff\",\"onout\"],dflt:!1},xclick:{valType:\"any\"},yclick:{valType:\"any\"},hovertext:{valType:\"string\"},hoverlabel:{bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\"},font:o({},i,{})},captureevents:{valType:\"boolean\"},_deprecated:{ref:{valType:\"string\"}}}},{\"../../lib/extend\":716,\"../../plots/cartesian/constants\":771,\"../../plots/font_attributes\":790,\"./arrow_paths\":585}],587:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;i.filterVisible(e.annotations).forEach(function(e){var r,n,i=a.getFromId(t,e.xref),o=a.getFromId(t,e.yref),s=3*e.arrowsize*e.arrowwidth||0;i&&i.autorange&&(r=s+e.xshift,n=s-e.xshift,e.axref===e.xref?(a.expand(i,[i.r2c(e.x)],{ppadplus:r,ppadminus:n}),a.expand(i,[i.r2c(e.ax)],{ppadplus:e._xpadplus,ppadminus:e._xpadminus})):a.expand(i,[i.r2c(e.x)],{ppadplus:Math.max(e._xpadplus,r),ppadminus:Math.max(e._xpadminus,n)})),o&&o.autorange&&(r=s-e.yshift,n=s+e.yshift,e.ayref===e.yref?(a.expand(o,[o.r2c(e.y)],{ppadplus:r,ppadminus:n}),a.expand(o,[o.r2c(e.ay)],{ppadplus:e._ypadplus,ppadminus:e._ypadminus})):a.expand(o,[o.r2c(e.y)],{ppadplus:Math.max(e._ypadplus,r),ppadminus:Math.max(e._ypadminus,n)}))})}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"./draw\").draw;e.exports=function(t){var e=t._fullLayout,r=i.filterVisible(e.annotations);if(r.length&&t._fullData.length){var s={};r.forEach(function(t){s[t.xref]=!0,s[t.yref]=!0});if(a.list(t).filter(function(t){return t.autorange&&s[t._id]}).length)return i.syncOrAsync([o,n],t)}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./draw\":592}],588:[function(t,e,r){\"use strict\";function n(t,e){var r=a(t,e);return r.on.length>0||r.explicitOff.length>0}function i(t,e){var r,n=a(t,e),i=n.on,o=n.off.concat(n.explicitOff),l={};if(i.length||o.length){for(r=0;r<i.length;r++)l[\"annotations[\"+i[r]+\"].visible\"]=!0;for(r=0;r<o.length;r++)l[\"annotations[\"+o[r]+\"].visible\"]=!1;return s.update(t,{},l)}}function a(t,e){var r,n,i,a,s,l,u,c,h=t._fullLayout.annotations,f=[],d=[],p=[],m=(e||[]).length;for(r=0;r<h.length;r++)if(i=h[r],a=i.clicktoshow){for(n=0;n<m;n++)if(s=e[n],l=s.xaxis,u=s.yaxis,l._id===i.xref&&u._id===i.yref&&l.d2r(s.x)===o(i._xclick,l)&&u.d2r(s.y)===o(i._yclick,u)){c=i.visible?\"onout\"===a?d:p:f,c.push(r);break}n===m&&i.visible&&\"onout\"===a&&d.push(r)}return{on:f,off:d,explicitOff:p}}function o(t,e){return\"log\"===e.type?e.l2r(t):e.d2r(t)}var s=t(\"../../plotly\");e.exports={hasClickToShow:n,onClick:i}},{\"../../plotly\":761}],589:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../color\");e.exports=function(t,e,r,a){a(\"opacity\");var o=a(\"bgcolor\"),s=a(\"bordercolor\"),l=i.opacity(s);a(\"borderpad\");var u=a(\"borderwidth\"),c=a(\"showarrow\");a(\"text\",c?\" \":\"new text\"),a(\"textangle\"),n.coerceFont(a,\"font\",r.font),a(\"width\"),a(\"align\"),a(\"height\")&&a(\"valign\"),c&&(a(\"arrowcolor\",l?e.bordercolor:i.defaultLine),a(\"arrowhead\"),a(\"arrowsize\"),a(\"arrowwidth\",2*(l&&u||1)),a(\"standoff\"));var h=a(\"hovertext\"),f=r.hoverlabel||{};if(h){var d=a(\"hoverlabel.bgcolor\",f.bgcolor||(i.opacity(o)?i.rgb(o):i.defaultLine)),p=a(\"hoverlabel.bordercolor\",f.bordercolor||i.contrast(d));n.coerceFont(a,\"hoverlabel.font\",{family:f.font.family,size:f.font.size,color:f.font.color||p})}a(\"captureevents\",!!h)}},{\"../../lib\":725,\"../color\":603}],590:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib/to_log_range\");e.exports=function(t,e,r,a){function o(t){var r=u[t],o=null;o=s?i(r,e.range):Math.pow(10,r),n(o)||(o=null),a(c+t,o)}e=e||{};var s=\"log\"===r&&\"linear\"===e.type,l=\"linear\"===r&&\"log\"===e.type;if(s||l)for(var u,c,h=t._fullLayout.annotations,f=e._id.charAt(0),d=0;d<h.length;d++)u=h[d],c=\"annotations[\"+d+\"].\",u[f+\"ref\"]===e._id&&o(f),u[\"a\"+f+\"ref\"]===e._id&&o(\"a\"+f)}},{\"../../lib/to_log_range\":746,\"fast-isnumeric\":130}],591:[function(t,e,r){\"use strict\";var n=t(\"../../plots/array_container_defaults\"),i=t(\"./annotation_defaults\");e.exports=function(t,e){n(t,e,{name:\"annotations\",handleItemDefaults:i})}},{\"../../plots/array_container_defaults\":763,\"./annotation_defaults\":584}],592:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;e._infolayer.selectAll(\".annotation\").remove();for(var r=0;r<e.annotations.length;r++)e.annotations[r].visible&&i(t,r);return l.previousPromises(t)}function i(t,e){var r=t._fullLayout,n=r.annotations[e]||{};a(t,n,e,!1,c.getFromId(t,n.xref),c.getFromId(t,n.yref))}function a(t,e,r,n,i,a){function l(r){return r.call(f.font,F).attr({\"text-anchor\":{left:\"start\",right:\"end\"}[e.align]||\"middle\"}),p.convertToTspans(r,t,c),r}function c(){function r(t,e){return\"auto\"===e&&(e=t<1/3?\"left\":t>2/3?\"right\":\"center\"),{center:0,middle:0,left:.5,bottom:-.5,right:-.5,top:.5}[e]}var o=j.selectAll(\"a\");if(1===o.size()&&o.text()===j.text()){C.insert(\"a\",\":first-child\").attr({\"xlink:xlink:href\":o.attr(\"xlink:href\"),\"xlink:xlink:show\":o.attr(\"xlink:show\")}).style({cursor:\"pointer\"}).node().appendChild(P.node())}var l=C.select(\".annotation-text-math-group\"),c=!l.empty(),d=f.bBox((c?l:j).node()),y=d.width,L=d.height,I=e.width||y,F=e.height||L,N=Math.round(I+2*D),B=Math.round(F+2*D);e._w=I,e._h=F;for(var U=!1,V=[\"x\",\"y\"],H=0;H<V.length;H++){var q,G,Y,X,W,Z=V[H],J=e[Z+\"ref\"]||Z,K=e[\"a\"+Z+\"ref\"],Q={x:i,y:a}[Z],$=(A+(\"x\"===Z?0:-90))*Math.PI/180,tt=N*Math.cos($),et=B*Math.sin($),rt=Math.abs(tt)+Math.abs(et),nt=e[Z+\"anchor\"],it=e[Z+\"shift\"]*(\"x\"===Z?1:-1),at=k[Z];if(Q){var ot=Q.r2fraction(e[Z]);if((t._dragging||!Q.autorange)&&(ot<0||ot>1)&&(K===J?((ot=Q.r2fraction(e[\"a\"+Z]))<0||ot>1)&&(U=!0):U=!0,U))continue;q=Q._offset+Q.r2p(e[Z]),X=.5}else\"x\"===Z?(Y=e[Z],q=_.l+_.w*Y):(Y=1-e[Z],q=_.t+_.h*Y),X=e.showarrow?.5:Y;if(e.showarrow){at.head=q;var st=e[\"a\"+Z];W=tt*r(.5,e.xanchor)-et*r(.5,e.yanchor),K===J?(at.tail=Q._offset+Q.r2p(st),G=W):(at.tail=q+st,G=W+st),at.text=at.tail+W;var lt=x[\"x\"===Z?\"width\":\"height\"];if(\"paper\"===J&&(at.head=u.constrain(at.head,1,lt-1)),\"pixel\"===K){var ut=-Math.max(at.tail-3,at.text),ct=Math.min(at.tail+3,at.text)-lt;ut>0?(at.tail+=ut,at.text+=ut):ct>0&&(at.tail-=ct,at.text-=ct)}at.tail+=it,at.head+=it}else W=rt*r(X,nt),G=W,at.text=q+W;at.text+=it,W+=it,G+=it,e[\"_\"+Z+\"padplus\"]=rt/2+G,e[\"_\"+Z+\"padminus\"]=rt/2-G,e[\"_\"+Z+\"size\"]=rt,e[\"_\"+Z+\"shift\"]=W}if(U)return void C.remove();var ht=0,ft=0;if(\"left\"!==e.align&&(ht=(I-y)*(\"center\"===e.align?.5:1)),\"top\"!==e.valign&&(ft=(F-L)*(\"middle\"===e.valign?.5:1)),c)l.select(\"svg\").attr({x:D+ht-1,y:D+ft}).call(f.setClipUrl,O?M:null);else{var dt=D+ft-d.top,pt=D+ht-d.left;j.call(p.positionText,pt,dt).call(f.setClipUrl,O?M:null)}R.select(\"rect\").call(f.setRect,D,D,I,F),P.call(f.setRect,z/2,z/2,N-z,B-z),C.call(f.setTranslate,Math.round(k.x.text-N/2),Math.round(k.y.text-B/2)),S.attr({transform:\"rotate(\"+A+\",\"+k.x.text+\",\"+k.y.text+\")\"});var mt=function(r,o){T.selectAll(\".annotation-arrow-g\").remove();var l=k.x.head,c=k.y.head,d=k.x.tail+r,p=k.y.tail+o,m=k.x.text+r,y=k.y.text+o,x=u.rotationXYMatrix(A,m,y),M=u.apply2DTransform(x),E=u.apply2DTransform2(x),L=+P.attr(\"width\"),z=+P.attr(\"height\"),I=m-.5*L,D=I+L,O=y-.5*z,R=O+z,F=[[I,O,I,R],[I,R,D,R],[D,R,D,O],[D,O,I,O]].map(E);if(!F.reduce(function(t,e){return t^!!u.segmentsIntersect(l,c,l+1e6,c+1e6,e[0],e[1],e[2],e[3])},!1)){F.forEach(function(t){var e=u.segmentsIntersect(d,p,l,c,t[0],t[1],t[2],t[3]);e&&(d=e.x,p=e.y)});var j=e.arrowwidth,N=e.arrowcolor,B=T.append(\"g\").style({opacity:h.opacity(N)}).classed(\"annotation-arrow-g\",!0),U=B.append(\"path\").attr(\"d\",\"M\"+d+\",\"+p+\"L\"+l+\",\"+c).style(\"stroke-width\",j+\"px\").call(h.stroke,h.rgb(N));if(g(U,e.arrowhead,\"end\",e.arrowsize,e.standoff),w.annotationPosition&&U.node().parentNode&&!n){var V=l,H=c;if(e.standoff){var q=Math.sqrt(Math.pow(l-d,2)+Math.pow(c-p,2));V+=e.standoff*(d-l)/q,H+=e.standoff*(p-c)/q}var G,Y,X,W=B.append(\"path\").classed(\"annotation-arrow\",!0).classed(\"anndrag\",!0).attr({d:\"M3,3H-3V-3H3ZM0,0L\"+(d-V)+\",\"+(p-H),transform:\"translate(\"+V+\",\"+H+\")\"}).style(\"stroke-width\",j+6+\"px\").call(h.stroke,\"rgba(0,0,0,0)\").call(h.fill,\"rgba(0,0,0,0)\");v.init({element:W.node(),gd:t,prepFn:function(){var t=f.getTranslate(C);Y=t.x,X=t.y,G={},i&&i.autorange&&(G[i._name+\".autorange\"]=!0),a&&a.autorange&&(G[a._name+\".autorange\"]=!0)},moveFn:function(t,r){var n=M(Y,X),o=n[0]+t,s=n[1]+r;C.call(f.setTranslate,o,s),G[b+\".x\"]=i?i.p2r(i.r2p(e.x)+t):e.x+t/_.w,G[b+\".y\"]=a?a.p2r(a.r2p(e.y)+r):e.y-r/_.h,e.axref===e.xref&&(G[b+\".ax\"]=i.p2r(i.r2p(e.ax)+t)),e.ayref===e.yref&&(G[b+\".ay\"]=a.p2r(a.r2p(e.ay)+r)),B.attr(\"transform\",\"translate(\"+t+\",\"+r+\")\"),S.attr({transform:\"rotate(\"+A+\",\"+o+\",\"+s+\")\"})},doneFn:function(e){if(e){s.relayout(t,G);var r=document.querySelector(\".js-notes-box-panel\");r&&r.redraw(r.selectedObj)}}})}}};if(e.showarrow&&mt(0,0),E){var vt,gt;v.init({element:C.node(),gd:t,prepFn:function(){gt=S.attr(\"transform\"),vt={}},moveFn:function(t,r){var o=\"pointer\";if(e.showarrow)e.axref===e.xref?vt[b+\".ax\"]=i.p2r(i.r2p(e.ax)+t):vt[b+\".ax\"]=e.ax+t,e.ayref===e.yref?vt[b+\".ay\"]=a.p2r(a.r2p(e.ay)+r):vt[b+\".ay\"]=e.ay+r,mt(t,r);else{if(n)return;if(i)vt[b+\".x\"]=e.x+t/i._m;else{var s=e._xsize/_.w,l=e.x+(e._xshift-e.xshift)/_.w-s/2;vt[b+\".x\"]=v.align(l+t/_.w,s,0,1,e.xanchor)}if(a)vt[b+\".y\"]=e.y+r/a._m;else{var u=e._ysize/_.h,c=e.y-(e._yshift+e.yshift)/_.h-u/2;vt[b+\".y\"]=v.align(c-r/_.h,u,0,1,e.yanchor)}i&&a||(o=v.getCursor(i?.5:vt[b+\".x\"],a?.5:vt[b+\".y\"],e.xanchor,e.yanchor))}S.attr({transform:\"translate(\"+t+\",\"+r+\")\"+gt}),m(C,o)},doneFn:function(e){if(m(C),e){s.relayout(t,vt);var r=document.querySelector(\".js-notes-box-panel\");r&&r.redraw(r.selectedObj)}}})}}var y,b,x=t._fullLayout,_=t._fullLayout._size,w=t._context.edits;n?(y=\"annotation-\"+n,b=n+\".annotations[\"+r+\"]\"):(y=\"annotation\",b=\"annotations[\"+r+\"]\"),x._infolayer.selectAll(\".\"+y+'[data-index=\"'+r+'\"]').remove();var M=\"clip\"+x._uid+\"_ann\"+r;if(!e._input||!1===e.visible)return void o.selectAll(\"#\"+M).remove();var k={x:{},y:{}},A=+e.textangle||0,T=x._infolayer.append(\"g\").classed(y,!0).attr(\"data-index\",String(r)).style(\"opacity\",e.opacity),S=T.append(\"g\").classed(\"annotation-text-g\",!0),E=w[e.showarrow?\"annotationTail\":\"annotationPosition\"],L=e.captureevents||w.annotationText||E,C=S.append(\"g\").style(\"pointer-events\",L?\"all\":null).call(m,\"default\").on(\"click\",function(){t._dragging=!1;var i={index:r,annotation:e._input,fullAnnotation:e,event:o.event};n&&(i.subplotId=n),t.emit(\"plotly_clickannotation\",i)});e.hovertext&&C.on(\"mouseover\",function(){var r=e.hoverlabel,n=r.font,i=this.getBoundingClientRect(),a=t.getBoundingClientRect();d.loneHover({x0:i.left-a.left,x1:i.right-a.left,y:(i.top+i.bottom)/2-a.top,text:e.hovertext,color:r.bgcolor,borderColor:r.bordercolor,fontFamily:n.family,fontSize:n.size,fontColor:n.color},{container:x._hoverlayer.node(),outerContainer:x._paper.node(),gd:t})}).on(\"mouseout\",function(){d.loneUnhover(x._hoverlayer.node())});var z=e.borderwidth,I=e.borderpad,D=z+I,P=C.append(\"rect\").attr(\"class\",\"bg\").style(\"stroke-width\",z+\"px\").call(h.stroke,e.bordercolor).call(h.fill,e.bgcolor),O=e.width||e.height,R=x._defs.select(\".clips\").selectAll(\"#\"+M).data(O?[0]:[]);R.enter().append(\"clipPath\").classed(\"annclip\",!0).attr(\"id\",M).append(\"rect\"),R.exit().remove();var F=e.font,j=C.append(\"text\").classed(\"annotation-text\",!0).text(e.text);w.annotationText?j.call(p.makeEditable,{delegate:C,gd:t}).call(l).on(\"edit\",function(r){e.text=r,this.call(l);var n={};n[b+\".text\"]=e.text,i&&i.autorange&&(n[i._name+\".autorange\"]=!0),a&&a.autorange&&(n[a._name+\".autorange\"]=!0),s.relayout(t,n)}):j.call(l)}var o=t(\"d3\"),s=t(\"../../plotly\"),l=t(\"../../plots/plots\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/axes\"),h=t(\"../color\"),f=t(\"../drawing\"),d=t(\"../fx\"),p=t(\"../../lib/svg_text_utils\"),m=t(\"../../lib/setcursor\"),v=t(\"../dragelement\"),g=t(\"./draw_arrow_head\");e.exports={draw:n,drawOne:i,drawRaw:a}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"../fx\":644,\"./draw_arrow_head\":593,d3:121}],593:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../color\"),o=t(\"../drawing\"),s=t(\"./arrow_paths\");e.exports=function(t,e,r,l,u){function c(){t.style(\"stroke-dasharray\",\"0px,100px\")}function h(r,i){d.path&&(e>5&&(i=0),n.select(f.parentNode).append(\"path\").attr({class:t.attr(\"class\"),d:d.path,transform:\"translate(\"+r.x+\",\"+r.y+\")rotate(\"+180*i/Math.PI+\")scale(\"+y+\")\"}).style({fill:b,opacity:x,\"stroke-width\":0}))}i(l)||(l=1);var f=t.node(),d=s[e||0];\"string\"==typeof r&&r||(r=\"end\");var p,m,v,g,y=(o.getPx(t,\"stroke-width\")||1)*l,b=t.style(\"stroke\")||a.defaultLine,x=t.style(\"stroke-opacity\")||1,_=r.indexOf(\"start\")>=0,w=r.indexOf(\"end\")>=0,M=d.backoff*y+u;if(\"line\"===f.nodeName){p={x:+t.attr(\"x1\"),y:+t.attr(\"y1\")},m={x:+t.attr(\"x2\"),y:+t.attr(\"y2\")};var k=p.x-m.x,A=p.y-m.y;if(v=Math.atan2(A,k),g=v+Math.PI,M){if(M*M>k*k+A*A)return void c();var T=M*Math.cos(v),S=M*Math.sin(v);_&&(p.x-=T,p.y-=S,t.attr({x1:p.x,y1:p.y})),w&&(m.x+=T,m.y+=S,t.attr({x2:m.x,y2:m.y}))}}else if(\"path\"===f.nodeName){var E=f.getTotalLength(),L=\"\";if(E<M)return void c();if(_){var C=f.getPointAtLength(0),z=f.getPointAtLength(.1);v=Math.atan2(C.y-z.y,C.x-z.x),p=f.getPointAtLength(Math.min(M,E)),M&&(L=\"0px,\"+M+\"px,\")}if(w){var I=f.getPointAtLength(E),D=f.getPointAtLength(E-.1)\n",
       ";if(g=Math.atan2(I.y-D.y,I.x-D.x),m=f.getPointAtLength(Math.max(0,E-M)),M){var P=L?2*M:M;L+=E-P+\"px,\"+E+\"px\"}}else L&&(L+=E+\"px\");L&&t.style(\"stroke-dasharray\",L)}_&&h(p,v),w&&h(m,g)}},{\"../color\":603,\"../drawing\":627,\"./arrow_paths\":585,d3:121,\"fast-isnumeric\":130}],594:[function(t,e,r){\"use strict\";var n=t(\"./draw\"),i=t(\"./click\");e.exports={moduleType:\"component\",name:\"annotations\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:n.draw,drawOne:n.drawOne,drawRaw:n.drawRaw,hasClickToShow:i.hasClickToShow,onClick:i.onClick,convertCoords:t(\"./convert_coords\")}},{\"./attributes\":586,\"./calc_autorange\":587,\"./click\":588,\"./convert_coords\":590,\"./defaults\":591,\"./draw\":592}],595:[function(t,e,r){\"use strict\";var n=t(\"../annotations/attributes\");e.exports={_isLinkedToArray:\"annotation\",visible:n.visible,x:{valType:\"any\"},y:{valType:\"any\"},z:{valType:\"any\"},ax:{valType:\"number\"},ay:{valType:\"number\"},xanchor:n.xanchor,xshift:n.xshift,yanchor:n.yanchor,yshift:n.yshift,text:n.text,textangle:n.textangle,font:n.font,width:n.width,height:n.height,opacity:n.opacity,align:n.align,valign:n.valign,bgcolor:n.bgcolor,bordercolor:n.bordercolor,borderpad:n.borderpad,borderwidth:n.borderwidth,showarrow:n.showarrow,arrowcolor:n.arrowcolor,arrowhead:n.arrowhead,arrowsize:n.arrowsize,arrowwidth:n.arrowwidth,standoff:n.standoff,hovertext:n.hovertext,hoverlabel:n.hoverlabel,captureevents:n.captureevents}},{\"../annotations/attributes\":586}],596:[function(t,e,r){\"use strict\";function n(t,e){var r=e.fullSceneLayout,n=r.domain,o=e.fullLayout._size,s={pdata:null,type:\"linear\",autorange:!1,range:[-1/0,1/0]};t._xa={},i.extendFlat(t._xa,s),a.setConvert(t._xa),t._xa._offset=o.l+n.x[0]*o.w,t._xa.l2p=function(){return.5*(1+t.pdata[0]/t.pdata[3])*o.w*(n.x[1]-n.x[0])},t._ya={},i.extendFlat(t._ya,s),a.setConvert(t._ya),t._ya._offset=o.t+(1-n.y[1])*o.h,t._ya.l2p=function(){return.5*(1-t.pdata[1]/t.pdata[3])*o.h*(n.y[1]-n.y[0])}}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\");e.exports=function(t){for(var e=t.fullSceneLayout,r=e.annotations,i=0;i<r.length;i++)n(r[i],t);t.fullLayout._infolayer.selectAll(\".annotation-\"+t.id).remove()}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766}],597:[function(t,e,r){\"use strict\";function n(t,e,r,n,o){function u(r,n){return i.coerce(t,e,l,r,n)}function c(t){var n=t+\"axis\",i={_fullLayout:{}};return i._fullLayout[n]=r[n],a.coercePosition(e,i,u,t,t,.5)}return u(\"visible\",!o.itemIsNotPlainObject)?(s(t,e,n.fullLayout,u),c(\"x\"),c(\"y\"),c(\"z\"),i.noneOrAll(t,e,[\"x\",\"y\",\"z\"]),e.xref=\"x\",e.yref=\"y\",e.zref=\"z\",u(\"xanchor\"),u(\"yanchor\"),u(\"xshift\"),u(\"yshift\"),e.showarrow&&(e.axref=\"pixel\",e.ayref=\"pixel\",u(\"ax\",-10),u(\"ay\",-30),i.noneOrAll(t,e,[\"ax\",\"ay\"])),e):e}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"../annotations/common_defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r){o(t,e,{name:\"annotations\",handleItemDefaults:n,fullLayout:r.fullLayout})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"../../plots/cartesian/axes\":766,\"../annotations/common_defaults\":589,\"./attributes\":595}],598:[function(t,e,r){\"use strict\";var n=t(\"../annotations/draw\").drawRaw,i=t(\"../../plots/gl3d/project\"),a=[\"x\",\"y\",\"z\"];e.exports=function(t){for(var e=t.fullSceneLayout,r=t.dataScale,o=e.annotations,s=0;s<o.length;s++){for(var l=o[s],u=!1,c=0;c<3;c++){var h=a[c],f=l[h],d=e[h+\"axis\"],p=d.r2fraction(f);if(p<0||p>1){u=!0;break}}u?t.fullLayout._infolayer.select(\".annotation-\"+t.id+'[data-index=\"'+s+'\"]').remove():(l.pdata=i(t.glplot.cameraParams,[e.xaxis.r2l(l.x)*r[0],e.yaxis.r2l(l.y)*r[1],e.zaxis.r2l(l.z)*r[2]]),n(t.graphDiv,l,s,t.id,l._xa,l._ya))}}},{\"../../plots/gl3d/project\":818,\"../annotations/draw\":592}],599:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"annotations3d\",schema:{layout:{\"scene.annotations\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),convert:t(\"./convert\"),draw:t(\"./draw\")}},{\"./attributes\":595,\"./convert\":596,\"./defaults\":597,\"./draw\":598}],600:[function(t,e,r){\"use strict\";e.exports=t(\"world-calendars/dist/main\"),t(\"world-calendars/dist/plus\"),t(\"world-calendars/dist/calendars/chinese\"),t(\"world-calendars/dist/calendars/coptic\"),t(\"world-calendars/dist/calendars/discworld\"),t(\"world-calendars/dist/calendars/ethiopian\"),t(\"world-calendars/dist/calendars/hebrew\"),t(\"world-calendars/dist/calendars/islamic\"),t(\"world-calendars/dist/calendars/julian\"),t(\"world-calendars/dist/calendars/mayan\"),t(\"world-calendars/dist/calendars/nanakshahi\"),t(\"world-calendars/dist/calendars/nepali\"),t(\"world-calendars/dist/calendars/persian\"),t(\"world-calendars/dist/calendars/taiwan\"),t(\"world-calendars/dist/calendars/thai\"),t(\"world-calendars/dist/calendars/ummalqura\")},{\"world-calendars/dist/calendars/chinese\":566,\"world-calendars/dist/calendars/coptic\":567,\"world-calendars/dist/calendars/discworld\":568,\"world-calendars/dist/calendars/ethiopian\":569,\"world-calendars/dist/calendars/hebrew\":570,\"world-calendars/dist/calendars/islamic\":571,\"world-calendars/dist/calendars/julian\":572,\"world-calendars/dist/calendars/mayan\":573,\"world-calendars/dist/calendars/nanakshahi\":574,\"world-calendars/dist/calendars/nepali\":575,\"world-calendars/dist/calendars/persian\":576,\"world-calendars/dist/calendars/taiwan\":577,\"world-calendars/dist/calendars/thai\":578,\"world-calendars/dist/calendars/ummalqura\":579,\"world-calendars/dist/main\":580,\"world-calendars/dist/plus\":581}],601:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n,a,o,s,l,u=Math.floor((e+.05)/h)+c,f=i(r).fromJD(u),d=0;-1!==(d=t.indexOf(\"%\",d));)n=t.charAt(d+1),\"0\"===n||\"-\"===n||\"_\"===n?(o=3,a=t.charAt(d+2),\"_\"===n&&(n=\"-\")):(a=n,n=\"0\",o=2),s=b[a],s?(l=s===y?y:f.formatDate(s[n]),t=t.substr(0,d)+l+t.substr(d+o),d+=l.length):d+=o;return t}function i(t){var e=x[t];return e||(e=x[t]=s.instance(t))}function a(t){return l.extendFlat({},f,{description:t})}function o(t){return\"Sets the calendar system to use with `\"+t+\"` date data.\"}var s=t(\"./calendars\"),l=t(\"../../lib\"),u=t(\"../../constants/numerical\"),c=u.EPOCHJD,h=u.ONEDAY,f={valType:\"enumerated\",values:Object.keys(s.calendars),dflt:\"gregorian\"},d=function(t,e,r,n){var i={};return i[r]=f,l.coerce(t,e,i,r,n)},p=function(t,e,r,n){for(var i=0;i<r.length;i++)d(t,e,r[i]+\"calendar\",n.calendar)},m={chinese:\"2000-01-01\",coptic:\"2000-01-01\",discworld:\"2000-01-01\",ethiopian:\"2000-01-01\",hebrew:\"5000-01-01\",islamic:\"1000-01-01\",julian:\"2000-01-01\",mayan:\"5000-01-01\",nanakshahi:\"1000-01-01\",nepali:\"2000-01-01\",persian:\"1000-01-01\",jalali:\"1000-01-01\",taiwan:\"1000-01-01\",thai:\"2000-01-01\",ummalqura:\"1400-01-01\"},v={chinese:\"2000-01-02\",coptic:\"2000-01-03\",discworld:\"2000-01-03\",ethiopian:\"2000-01-05\",hebrew:\"5000-01-01\",islamic:\"1000-01-02\",julian:\"2000-01-03\",mayan:\"5000-01-01\",nanakshahi:\"1000-01-05\",nepali:\"2000-01-05\",persian:\"1000-01-01\",jalali:\"1000-01-01\",taiwan:\"1000-01-04\",thai:\"2000-01-04\",ummalqura:\"1400-01-06\"},g={chinese:[\"2000-01-01\",\"2001-01-01\"],coptic:[\"1700-01-01\",\"1701-01-01\"],discworld:[\"1800-01-01\",\"1801-01-01\"],ethiopian:[\"2000-01-01\",\"2001-01-01\"],hebrew:[\"5700-01-01\",\"5701-01-01\"],islamic:[\"1400-01-01\",\"1401-01-01\"],julian:[\"2000-01-01\",\"2001-01-01\"],mayan:[\"5200-01-01\",\"5201-01-01\"],nanakshahi:[\"0500-01-01\",\"0501-01-01\"],nepali:[\"2000-01-01\",\"2001-01-01\"],persian:[\"1400-01-01\",\"1401-01-01\"],jalali:[\"1400-01-01\",\"1401-01-01\"],taiwan:[\"0100-01-01\",\"0101-01-01\"],thai:[\"2500-01-01\",\"2501-01-01\"],ummalqura:[\"1400-01-01\",\"1401-01-01\"]},y=\"##\",b={d:{0:\"dd\",\"-\":\"d\"},e:{0:\"d\",\"-\":\"d\"},a:{0:\"D\",\"-\":\"D\"},A:{0:\"DD\",\"-\":\"DD\"},j:{0:\"oo\",\"-\":\"o\"},W:{0:\"ww\",\"-\":\"w\"},m:{0:\"mm\",\"-\":\"m\"},b:{0:\"M\",\"-\":\"M\"},B:{0:\"MM\",\"-\":\"MM\"},y:{0:\"yy\",\"-\":\"yy\"},Y:{0:\"yyyy\",\"-\":\"yyyy\"},U:y,w:y,c:{0:\"D M d %X yyyy\",\"-\":\"D M d %X yyyy\"},x:{0:\"mm/dd/yyyy\",\"-\":\"mm/dd/yyyy\"}},x={},_={xcalendar:a(o(\"x\"))},w=l.extendFlat({},_,{ycalendar:a(o(\"y\"))}),M=l.extendFlat({},w,{zcalendar:a(o(\"z\"))}),k=a([\"Sets the calendar system to use for `range` and `tick0`\",\"if this is a date axis. This does not set the calendar for\",\"interpreting data on this axis, that's specified in the trace\",\"or via the global `layout.calendar`\"].join(\" \"));e.exports={moduleType:\"component\",name:\"calendars\",schema:{traces:{scatter:w,bar:w,heatmap:w,contour:w,histogram:w,histogram2d:w,histogram2dcontour:w,scatter3d:M,surface:M,mesh3d:M,scattergl:w,ohlc:_,candlestick:_},layout:{calendar:a([\"Sets the default calendar system to use for interpreting and\",\"displaying dates throughout the plot.\"].join(\" \")),\"xaxis.calendar\":k,\"yaxis.calendar\":k,\"scene.xaxis.calendar\":k,\"scene.yaxis.calendar\":k,\"scene.zaxis.calendar\":k},transforms:{filter:{valuecalendar:a([\"Sets the calendar system to use for `value`, if it is a date.\"].join(\" \")),targetcalendar:a([\"Sets the calendar system to use for `target`, if it is an\",\"array of dates. If `target` is a string (eg *x*) we use the\",\"corresponding trace attribute (eg `xcalendar`) if it exists,\",\"even if `targetcalendar` is provided.\"].join(\" \"))}}},layoutAttributes:f,handleDefaults:d,handleTraceDefaults:p,CANONICAL_SUNDAY:v,CANONICAL_TICK:m,DFLTRANGE:g,getCal:i,worldCalFmt:n}},{\"../../constants/numerical\":705,\"../../lib\":725,\"./calendars\":600}],602:[function(t,e,r){\"use strict\";r.defaults=[\"#1f77b4\",\"#ff7f0e\",\"#2ca02c\",\"#d62728\",\"#9467bd\",\"#8c564b\",\"#e377c2\",\"#7f7f7f\",\"#bcbd22\",\"#17becf\"],r.defaultLine=\"#444\",r.lightLine=\"#eee\",r.background=\"#fff\",r.borderLine=\"#BEC8D9\",r.lightFraction=1e3/11},{}],603:[function(t,e,r){\"use strict\";function n(t){if(a(t)||\"string\"!=typeof t)return t;var e=t.trim();if(\"rgb\"!==e.substr(0,3))return t;var r=e.match(/^rgba?\\s*\\(([^()]*)\\)$/);if(!r)return t;var n=r[1].trim().split(/\\s*[\\s,]\\s*/),i=\"a\"===e.charAt(3)&&4===n.length;if(!i&&3!==n.length)return t;for(var o=0;o<n.length;o++){if(!n[o].length)return t;if(n[o]=Number(n[o]),!(n[o]>=0))return t;if(3===o)n[o]>1&&(n[o]=1);else if(n[o]>=1)return t}var s=Math.round(255*n[0])+\", \"+Math.round(255*n[1])+\", \"+Math.round(255*n[2]);return i?\"rgba(\"+s+\", \"+n[3]+\")\":\"rgb(\"+s+\")\"}var i=t(\"tinycolor2\"),a=t(\"fast-isnumeric\"),o=e.exports={},s=t(\"./attributes\");o.defaults=s.defaults;var l=o.defaultLine=s.defaultLine;o.lightLine=s.lightLine;var u=o.background=s.background;o.tinyRGB=function(t){var e=t.toRgb();return\"rgb(\"+Math.round(e.r)+\", \"+Math.round(e.g)+\", \"+Math.round(e.b)+\")\"},o.rgb=function(t){return o.tinyRGB(i(t))},o.opacity=function(t){return t?i(t).getAlpha():0},o.addOpacity=function(t,e){var r=i(t).toRgb();return\"rgba(\"+Math.round(r.r)+\", \"+Math.round(r.g)+\", \"+Math.round(r.b)+\", \"+e+\")\"},o.combine=function(t,e){var r=i(t).toRgb();if(1===r.a)return i(t).toRgbString();var n=i(e||u).toRgb(),a=1===n.a?n:{r:255*(1-n.a)+n.r*n.a,g:255*(1-n.a)+n.g*n.a,b:255*(1-n.a)+n.b*n.a},o={r:a.r*(1-r.a)+r.r*r.a,g:a.g*(1-r.a)+r.g*r.a,b:a.b*(1-r.a)+r.b*r.a};return i(o).toRgbString()},o.contrast=function(t,e,r){var n=i(t);return 1!==n.getAlpha()&&(n=i(o.combine(t,u))),(n.isDark()?e?n.lighten(e):u:r?n.darken(r):l).toString()},o.stroke=function(t,e){var r=i(e);t.style({stroke:o.tinyRGB(r),\"stroke-opacity\":r.getAlpha()})},o.fill=function(t,e){var r=i(e);t.style({fill:o.tinyRGB(r),\"fill-opacity\":r.getAlpha()})},o.clean=function(t){if(t&&\"object\"==typeof t){var e,r,i,a,s=Object.keys(t);for(e=0;e<s.length;e++)if(i=s[e],a=t[i],\"color\"===i.substr(i.length-5))if(Array.isArray(a))for(r=0;r<a.length;r++)a[r]=n(a[r]);else t[i]=n(a);else if(\"colorscale\"===i.substr(i.length-10)&&Array.isArray(a))for(r=0;r<a.length;r++)Array.isArray(a[r])&&(a[r][1]=n(a[r][1]));else if(Array.isArray(a)){var l=a[0];if(!Array.isArray(l)&&l&&\"object\"==typeof l)for(r=0;r<a.length;r++)o.clean(a[r])}else a&&\"object\"==typeof a&&o.clean(a)}}},{\"./attributes\":602,\"fast-isnumeric\":130,tinycolor2:533}],604:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/layout_attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../lib/extend\").extendFlat;e.exports={thicknessmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"pixels\"},thickness:{valType:\"number\",min:0,dflt:30},lenmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"fraction\"},len:{valType:\"number\",min:0,dflt:1},x:{valType:\"number\",dflt:1.02,min:-2,max:3},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},xpad:{valType:\"number\",min:0,dflt:10},y:{valType:\"number\",dflt:.5,min:-2,max:3},yanchor:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"middle\"},ypad:{valType:\"number\",min:0,dflt:10},outlinecolor:n.linecolor,outlinewidth:n.linewidth,bordercolor:n.linecolor,borderwidth:{valType:\"number\",min:0,dflt:0},bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},tickmode:n.tickmode,nticks:n.nticks,tick0:n.tick0,dtick:n.dtick,tickvals:n.tickvals,ticktext:n.ticktext,ticks:a({},n.ticks,{dflt:\"\"}),ticklen:n.ticklen,tickwidth:n.tickwidth,tickcolor:n.tickcolor,showticklabels:n.showticklabels,tickfont:n.tickfont,tickangle:n.tickangle,tickformat:n.tickformat,tickprefix:n.tickprefix,showtickprefix:n.showtickprefix,ticksuffix:n.ticksuffix,showticksuffix:n.showticksuffix,separatethousands:n.separatethousands,exponentformat:n.exponentformat,showexponent:n.showexponent,title:{valType:\"string\",dflt:\"Click to enter colorscale title\"},titlefont:a({},i,{}),titleside:{valType:\"enumerated\",values:[\"right\",\"top\",\"bottom\"],dflt:\"top\"}}},{\"../../lib/extend\":716,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/font_attributes\":790}],605:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/tick_value_defaults\"),a=t(\"../../plots/cartesian/tick_mark_defaults\"),o=t(\"../../plots/cartesian/tick_label_defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r){function l(t,e){return n.coerce(c,u,s,t,e)}var u=e.colorbar={},c=t.colorbar||{};l(\"thickness\",\"fraction\"===l(\"thicknessmode\")?30/(r.width-r.margin.l-r.margin.r):30),l(\"len\",\"fraction\"===l(\"lenmode\")?1:r.height-r.margin.t-r.margin.b),l(\"x\"),l(\"xanchor\"),l(\"xpad\"),l(\"y\"),l(\"yanchor\"),l(\"ypad\"),n.noneOrAll(c,u,[\"x\",\"y\"]),l(\"outlinecolor\"),l(\"outlinewidth\"),l(\"bordercolor\"),l(\"borderwidth\"),l(\"bgcolor\"),i(c,u,l,\"linear\"),o(c,u,l,\"linear\",{outerTicks:!1,font:r.font,noHover:!0}),a(c,u,l,\"linear\",{outerTicks:!1,font:r.font,noHover:!0}),l(\"title\"),n.coerceFont(l,\"titlefont\",r.font),l(\"titleside\")}},{\"../../lib\":725,\"../../plots/cartesian/tick_label_defaults\":784,\"../../plots/cartesian/tick_mark_defaults\":785,\"../../plots/cartesian/tick_value_defaults\":786,\"./attributes\":604}],606:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"tinycolor2\"),a=t(\"../../plotly\"),o=t(\"../../plots/plots\"),s=t(\"../../registry\"),l=t(\"../../plots/cartesian/axes\"),u=t(\"../dragelement\"),c=t(\"../../lib\"),h=t(\"../../lib/extend\").extendFlat,f=t(\"../../lib/setcursor\"),d=t(\"../drawing\"),p=t(\"../color\"),m=t(\"../titles\"),v=t(\"../../lib/svg_text_utils\"),g=t(\"../../constants/alignment\").LINE_SPACING,y=t(\"../../plots/cartesian/axis_defaults\"),b=t(\"../../plots/cartesian/position_defaults\"),x=t(\"../../plots/cartesian/layout_attributes\"),_=t(\"./attributes\");e.exports=function(t,e){function r(){function _(t,e){return c.coerce(et,rt,x,t,e)}function k(){if(-1!==[\"top\",\"bottom\"].indexOf(M.titleside)){var e=lt.select(\".cbtitle\"),r=e.select(\"text\"),a=[-M.outlinewidth/2,M.outlinewidth/2],o=e.select(\".h\"+rt._id+\"title-math-group\").node(),s=15.6;if(r.node()&&(s=parseInt(r.style(\"font-size\"),10)*g),o?(ct=d.bBox(o).height)>s&&(a[1]-=(ct-s)/2):r.node()&&!r.classed(\"js-placeholder\")&&(ct=d.bBox(r.node()).height),ct){if(ct+=5,\"top\"===M.titleside)rt.domain[1]-=ct/E.h,a[1]*=-1;else{rt.domain[0]+=ct/E.h;var u=v.lineCount(r);a[1]+=(1-u)*s}e.attr(\"transform\",\"translate(\"+a+\")\"),rt.setScale()}}lt.selectAll(\".cbfills,.cblines,.cbaxis\").attr(\"transform\",\"translate(0,\"+Math.round(E.h*(1-rt.domain[1]))+\")\");var h=lt.select(\".cbfills\").selectAll(\"rect.cbfill\").data(D);h.enter().append(\"rect\").classed(\"cbfill\",!0).style(\"stroke\",\"none\"),h.exit().remove(),h.each(function(t,e){var r=[0===e?z[0]:(D[e]+D[e-1])/2,e===D.length-1?z[1]:(D[e]+D[e+1])/2].map(rt.c2p).map(Math.round);e!==D.length-1&&(r[1]+=r[1]>r[0]?1:-1);var a=O(t).replace(\"e-\",\"\"),o=i(a).toHexString();n.select(this).attr({x:J,width:Math.max(H,2),y:n.min(r),height:Math.max(n.max(r)-n.min(r),2),fill:o})});var f=lt.select(\".cblines\").selectAll(\"path.cbline\").data(M.line.color&&M.line.width?I:[]);return f.enter().append(\"path\").classed(\"cbline\",!0),f.exit().remove(),f.each(function(t){n.select(this).attr(\"d\",\"M\"+J+\",\"+(Math.round(rt.c2p(t))+M.line.width/2%1)+\"h\"+H).call(d.lineGroupStyle,M.line.width,P(t),M.line.dash)}),rt._axislayer.selectAll(\"g.\"+rt._id+\"tick,path\").remove(),rt._pos=J+H+(M.outlinewidth||0)/2-(\"outside\"===M.ticks?1:0),rt.side=\"right\",c.syncOrAsync([function(){return l.doTicks(t,rt,!0)},function(){if(-1===[\"top\",\"bottom\"].indexOf(M.titleside)){var e=rt.titlefont.size,r=rt._offset+rt._length/2,i=E.l+(rt.position||0)*E.w+(\"right\"===rt.side?10+e*(rt.showticklabels?1:.5):-10-e*(rt.showticklabels?.5:0));A(\"h\"+rt._id+\"title\",{avoid:{selection:n.select(t).selectAll(\"g.\"+rt._id+\"tick\"),side:M.titleside,offsetLeft:E.l,offsetTop:E.t,maxShift:S.width},attributes:{x:i,y:r,\"text-anchor\":\"middle\"},transform:{rotate:\"-90\",offset:0}})}}])}function A(e,r){var n,i=w();n=s.traceIs(i,\"markerColorscale\")?\"marker.colorbar.title\":\"colorbar.title\";var a={propContainer:rt,propName:n,traceIndex:i.index,dfltName:\"colorscale\",containerGroup:lt.select(\".cbtitle\")},o=\"h\"===e.charAt(0)?e.substr(1):\"h\"+e;lt.selectAll(\".\"+o+\",.\"+o+\"-math-group\").remove(),m.draw(t,e,h(a,r||{}))}function T(){var r=H+M.outlinewidth/2+d.bBox(rt._axislayer.node()).width;if(B=ut.select(\"text\"),B.node()&&!B.classed(\"js-placeholder\")){var n,i=ut.select(\".h\"+rt._id+\"title-math-group\").node();n=i&&-1!==[\"top\",\"bottom\"].indexOf(M.titleside)?d.bBox(i).width:d.bBox(ut.node()).right-J-E.l,r=Math.max(r,n)}var a=2*M.xpad+r+M.borderwidth+M.outlinewidth/2,s=$-tt;lt.select(\".cbbg\").attr({x:J-M.xpad-(M.borderwidth+M.outlinewidth)/2,y:tt-W,width:Math.max(a,2),height:Math.max(s+2*W,2)}).call(p.fill,M.bgcolor).call(p.stroke,M.bordercolor).style({\"stroke-width\":M.borderwidth}),lt.selectAll(\".cboutline\").attr({x:J,y:tt+M.ypad+(\"top\"===M.titleside?ct:0),width:Math.max(H,2),height:Math.max(s-2*M.ypad-ct,2)}).call(p.stroke,M.outlinecolor).style({fill:\"None\",\"stroke-width\":M.outlinewidth});var l=({center:.5,right:1}[M.xanchor]||0)*a;lt.attr(\"transform\",\"translate(\"+(E.l-l)+\",\"+E.t+\")\"),o.autoMargin(t,e,{x:M.x,y:M.y,l:a*({right:1,center:.5}[M.xanchor]||0),r:a*({left:1,center:.5}[M.xanchor]||0),t:s*({bottom:1,middle:.5}[M.yanchor]||0),b:s*({top:1,middle:.5}[M.yanchor]||0)})}var S=t._fullLayout,E=S._size;if(\"function\"!=typeof M.fillcolor&&\"function\"!=typeof M.line.color)return void S._infolayer.selectAll(\"g.\"+e).remove();var L,C,z=n.extent((\"function\"==typeof M.fillcolor?M.fillcolor:M.line.color).domain()),I=[],D=[],P=\"function\"==typeof M.line.color?M.line.color:function(){return M.line.color},O=\"function\"==typeof M.fillcolor?M.fillcolor:function(){return M.fillcolor},R=M.levels.end+M.levels.size/100,F=M.levels.size,j=1.001*z[0]-.001*z[1],N=1.001*z[1]-.001*z[0];for(C=0;C<1e5&&(L=M.levels.start+C*F,!(F>0?L>=R:L<=R));C++)L>j&&L<N&&I.push(L);if(\"function\"==typeof M.fillcolor)if(M.filllevels)for(R=M.filllevels.end+M.filllevels.size/100,F=M.filllevels.size,C=0;C<1e5&&(L=M.filllevels.start+C*F,!(F>0?L>=R:L<=R));C++)L>z[0]&&L<z[1]&&D.push(L);else D=I.map(function(t){return t-M.levels.size/2}),D.push(D[D.length-1]+M.levels.size);else M.fillcolor&&\"string\"==typeof M.fillcolor&&(D=[0]);M.levels.size<0&&(I.reverse(),D.reverse());var B,U=S.height-S.margin.t-S.margin.b,V=S.width-S.margin.l-S.margin.r,H=Math.round(M.thickness*(\"fraction\"===M.thicknessmode?V:1)),q=H/E.w,G=Math.round(M.len*(\"fraction\"===M.lenmode?U:1)),Y=G/E.h,X=M.xpad/E.w,W=(M.borderwidth+M.outlinewidth)/2,Z=M.ypad/E.h,J=Math.round(M.x*E.w+M.xpad),K=M.x-q*({middle:.5,right:1}[M.xanchor]||0),Q=M.y+Y*(({top:-.5,bottom:.5}[M.yanchor]||0)-.5),$=Math.round(E.h*(1-Q)),tt=$-G,et={type:\"linear\",range:z,tickmode:M.tickmode,nticks:M.nticks,tick0:M.tick0,dtick:M.dtick,tickvals:M.tickvals,ticktext:M.ticktext,ticks:M.ticks,ticklen:M.ticklen,tickwidth:M.tickwidth,tickcolor:M.tickcolor,showticklabels:M.showticklabels,tickfont:M.tickfont,tickangle:M.tickangle,tickformat:M.tickformat,exponentformat:M.exponentformat,separatethousands:M.separatethousands,showexponent:M.showexponent,showtickprefix:M.showtickprefix,tickprefix:M.tickprefix,showticksuffix:M.showticksuffix,ticksuffix:M.ticksuffix,title:M.title,titlefont:M.titlefont,showline:!0,anchor:\"free\",position:1},rt={type:\"linear\",_id:\"y\"+e},nt={letter:\"y\",font:S.font,noHover:!0,calendar:S.calendar};if(y(et,rt,_,nt,S),b(et,rt,_,nt),rt.position=M.x+X+q,r.axis=rt,-1!==[\"top\",\"bottom\"].indexOf(M.titleside)&&(rt.titleside=M.titleside,rt.titlex=M.x+X,rt.titley=Q+(\"top\"===M.titleside?Y-Z:Z)),M.line.color&&\"auto\"===M.tickmode){rt.tickmode=\"linear\",rt.tick0=M.levels.start;var it=M.levels.size,at=c.constrain(($-tt)/50,4,15)+1,ot=(z[1]-z[0])/((M.nticks||at)*it);if(ot>1){var st=Math.pow(10,Math.floor(Math.log(ot)/Math.LN10));it*=st*c.roundUp(ot/st,[2,5,10]),(Math.abs(M.levels.start)/M.levels.size+1e-6)%1<2e-6&&(rt.tick0=0)}rt.dtick=it}rt.domain=[Q+Z,Q+Y-Z],rt.setScale();var lt=S._infolayer.selectAll(\"g.\"+e).data([0]);lt.enter().append(\"g\").classed(e,!0).each(function(){var t=n.select(this);t.append(\"rect\").classed(\"cbbg\",!0),t.append(\"g\").classed(\"cbfills\",!0),t.append(\"g\").classed(\"cblines\",!0),t.append(\"g\").classed(\"cbaxis\",!0).classed(\"crisp\",!0),t.append(\"g\").classed(\"cbtitleunshift\",!0).append(\"g\").classed(\"cbtitle\",!0),t.append(\"rect\").classed(\"cboutline\",!0),t.select(\".cbtitle\").datum(0)}),lt.attr(\"transform\",\"translate(\"+Math.round(E.l)+\",\"+Math.round(E.t)+\")\");var ut=lt.select(\".cbtitleunshift\").attr(\"transform\",\"translate(-\"+Math.round(E.l)+\",-\"+Math.round(E.t)+\")\");rt._axislayer=lt.select(\".cbaxis\");var ct=0;if(-1!==[\"top\",\"bottom\"].indexOf(M.titleside)){var ht,ft=E.l+(M.x+X)*E.w,dt=rt.titlefont.size;ht=\"top\"===M.titleside?(1-(Q+Y-Z))*E.h+E.t+3+.75*dt:(1-(Q+Z))*E.h+E.t-3-.25*dt,A(rt._id+\"title\",{attributes:{x:ft,y:ht,\"text-anchor\":\"start\"}})}var pt=c.syncOrAsync([o.previousPromises,k,o.previousPromises,T],t);if(pt&&pt.then&&(t._promises||[]).push(pt),t._context.edits.colorbarPosition){var mt,vt,gt;u.init({element:lt.node(),gd:t,prepFn:function(){mt=lt.attr(\"transform\"),f(lt)},moveFn:function(t,e){lt.attr(\"transform\",mt+\" translate(\"+t+\",\"+e+\")\"),vt=u.align(K+t/E.w,q,0,1,M.xanchor),gt=u.align(Q-e/E.h,Y,0,1,M.yanchor);var r=u.getCursor(vt,gt,M.xanchor,M.yanchor);f(lt,r)},doneFn:function(e){f(lt),e&&void 0!==vt&&void 0!==gt&&a.restyle(t,{\"colorbar.x\":vt,\"colorbar.y\":gt},w().index)}})}return pt}function w(){var r,n,i=e.substr(2);for(r=0;r<t._fullData.length;r++)if(n=t._fullData[r],n.uid===i)return n}var M={};return Object.keys(_).forEach(function(t){M[t]=null}),M.fillcolor=null,M.line={color:null,width:null,dash:null},M.levels={start:null,end:null,size:null},M.filllevels=null,Object.keys(M).forEach(function(t){r[t]=function(e){return arguments.length?(M[t]=c.isPlainObject(M[t])?c.extendFlat(M[t],e):e,r):M[t]}}),r.options=function(t){return Object.keys(t).forEach(function(e){\"function\"==typeof r[e]&&r[e](t[e])}),r},r._opts=M,r}},{\"../../constants/alignment\":699,\"../../lib\":725,\"../../lib/extend\":716,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_defaults\":768,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/cartesian/position_defaults\":780,\"../../plots/plots\":829,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"../titles\":692,\"./attributes\":604,d3:121,tinycolor2:533}],607:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t){return n.isPlainObject(t.colorbar)}},{\"../../lib\":725}],608:[function(t,e,r){\"use strict\";e.exports={zauto:{valType:\"boolean\",dflt:!0},zmin:{valType:\"number\",dflt:null},zmax:{valType:\"number\",dflt:null},colorscale:{valType:\"colorscale\"},autocolorscale:{valType:\"boolean\",dflt:!0},reversescale:{valType:\"boolean\",dflt:!1},showscale:{valType:\"boolean\",dflt:!0}}},{}],609:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./scales\"),a=t(\"./flip_scale\");e.exports=function(t,e,r,o){var s,l;r?(s=n.nestedProperty(t,r).get(),l=n.nestedProperty(t._input,r).get()):(s=t,l=t._input);var u=o+\"auto\",c=o+\"min\",h=o+\"max\",f=s[u],d=s[c],p=s[h],m=s.colorscale;!1===f&&void 0!==d||(d=n.aggNums(Math.min,null,e)),!1===f&&void 0!==p||(p=n.aggNums(Math.max,null,e)),d===p&&(d-=.5,p+=.5),s[c]=d,s[h]=p,l[c]=d,l[h]=p,l[u]=!1!==f||void 0===d&&void 0===p,s.autocolorscale&&(m=d*p<0?i.RdBu:d>=0?i.Reds:i.Blues,l.colorscale=m,s.reversescale&&(m=a(m)),s.colorscale=m)}},{\"../../lib\":725,\"./flip_scale\":614,\"./scales\":621}],610:[function(t,e,r){\"use strict\";var n=t(\"./attributes\"),i=t(\"../../lib/extend\").extendDeep;t(\"./scales.js\");e.exports=function(t){return{color:{valType:\"color\",arrayOk:!0},colorscale:i({},n.colorscale,{}),cauto:i({},n.zauto,{}),cmax:i({},n.zmax,{}),cmin:i({},n.zmin,{}),autocolorscale:i({},n.autocolorscale,{}),reversescale:i({},n.reversescale,{})}}},{\"../../lib/extend\":716,\"./attributes\":608,\"./scales.js\":621}],611:[function(t,e,r){\"use strict\";var n=t(\"./scales\");e.exports=n.RdBu},{\"./scales\":621}],612:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../colorbar/has_colorbar\"),o=t(\"../colorbar/defaults\"),s=t(\"./is_valid_scale\"),l=t(\"./flip_scale\");e.exports=function(t,e,r,u,c){var h=c.prefix,f=c.cLetter,d=h.slice(0,h.length-1),p=h?i.nestedProperty(t,d).get()||{}:t,m=h?i.nestedProperty(e,d).get()||{}:e,v=p[f+\"min\"],g=p[f+\"max\"],y=p.colorscale;u(h+f+\"auto\",!(n(v)&&n(g)&&v<g)),u(h+f+\"min\"),u(h+f+\"max\");var b;void 0!==y&&(b=!s(y)),u(h+\"autocolorscale\",b);var x=u(h+\"colorscale\");if(u(h+\"reversescale\")&&(m.colorscale=l(x)),\"marker.line.\"!==h){var _;h&&(_=a(p)),u(h+\"showscale\",_)&&o(p,m,r)}}},{\"../../lib\":725,\"../colorbar/defaults\":605,\"../colorbar/has_colorbar\":607,\"./flip_scale\":614,\"./is_valid_scale\":618,\"fast-isnumeric\":130}],613:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){for(var n=t.length,i=new Array(n),a=new Array(n),o=0;o<n;o++){var s=t[o];i[o]=e+s[0]*(r-e),a[o]=s[1]}return{domain:i,range:a}}},{}],614:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e,r=t.length,n=new Array(r),i=r-1,a=0;i>=0;i--,a++)e=t[i],n[a]=[1-e[0],e[1]];return n}},{}],615:[function(t,e,r){\"use strict\";var n=t(\"./scales\"),i=t(\"./default_scale\"),a=t(\"./is_valid_scale_array\");e.exports=function(t,e){function r(){try{t=n[t]||JSON.parse(t)}catch(r){t=e}}return e||(e=i),t?(\"string\"==typeof t&&(r(),\"string\"==typeof t&&r()),a(t)?t:e):e}},{\"./default_scale\":611,\"./is_valid_scale_array\":619,\"./scales\":621}],616:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"./is_valid_scale\");e.exports=function(t,e){var r=e?i.nestedProperty(t,e).get()||{}:t,o=r.color,s=!1;if(Array.isArray(o))for(var l=0;l<o.length;l++)if(n(o[l])){s=!0;break}return i.isPlainObject(r)&&(s||!0===r.showscale||n(r.cmin)&&n(r.cmax)||a(r.colorscale)||i.isPlainObject(r.colorbar))}},{\"../../lib\":725,\"./is_valid_scale\":618,\"fast-isnumeric\":130}],617:[function(t,e,r){\"use strict\";r.scales=t(\"./scales\"),r.defaultScale=t(\"./default_scale\"),r.attributes=t(\"./attributes\"),r.handleDefaults=t(\"./defaults\"),r.calc=t(\"./calc\"),r.hasColorscale=t(\"./has_colorscale\"),r.isValidScale=t(\"./is_valid_scale\"),r.getScale=t(\"./get_scale\"),r.flipScale=t(\"./flip_scale\"),r.extractScale=t(\"./extract_scale\"),r.makeColorScaleFunc=t(\"./make_color_scale_func\")},{\"./attributes\":608,\"./calc\":609,\"./default_scale\":611,\"./defaults\":612,\"./extract_scale\":613,\"./flip_scale\":614,\"./get_scale\":615,\"./has_colorscale\":616,\"./is_valid_scale\":618,\"./make_color_scale_func\":620,\"./scales\":621}],618:[function(t,e,r){\"use strict\";var n=t(\"./scales\"),i=t(\"./is_valid_scale_array\");e.exports=function(t){return void 0!==n[t]||i(t)}},{\"./is_valid_scale_array\":619,\"./scales\":621}],619:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\");e.exports=function(t){var e=0;if(!Array.isArray(t)||t.length<2)return!1;if(!t[0]||!t[t.length-1])return!1;if(0!=+t[0][0]||1!=+t[t.length-1][0])return!1;for(var r=0;r<t.length;r++){var i=t[r];if(2!==i.length||+i[0]<e||!n(i[1]).isValid())return!1;e=+i[0]}return!0}},{tinycolor2:533}],620:[function(t,e,r){\"use strict\";function n(t){var e={r:t[0],g:t[1],b:t[2],a:t[3]};return a(e).toRgbString()}var i=t(\"d3\"),a=t(\"tinycolor2\"),o=t(\"fast-isnumeric\"),s=t(\"../color\");e.exports=function(t,e){e=e||{};for(var r=t.domain,l=t.range,u=l.length,c=new Array(u),h=0;h<u;h++){var f=a(l[h]).toRgb();c[h]=[f.r,f.g,f.b,f.a]}var d,p=i.scale.linear().domain(r).range(c).clamp(!0),m=e.noNumericCheck,v=e.returnArray;return d=m&&v?p:m?function(t){return n(p(t))}:v?function(t){return o(t)?p(t):a(t).isValid()?t:s.defaultLine}:function(t){return o(t)?n(p(t)):a(t).isValid()?t:s.defaultLine},d.domain=p.domain,d.range=function(){return l},d}},{\"../color\":603,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],621:[function(t,e,r){\"use strict\";e.exports={Greys:[[0,\"rgb(0,0,0)\"],[1,\"rgb(255,255,255)\"]],YlGnBu:[[0,\"rgb(8,29,88)\"],[.125,\"rgb(37,52,148)\"],[.25,\"rgb(34,94,168)\"],[.375,\"rgb(29,145,192)\"],[.5,\"rgb(65,182,196)\"],[.625,\"rgb(127,205,187)\"],[.75,\"rgb(199,233,180)\"],[.875,\"rgb(237,248,217)\"],[1,\"rgb(255,255,217)\"]],Greens:[[0,\"rgb(0,68,27)\"],[.125,\"rgb(0,109,44)\"],[.25,\"rgb(35,139,69)\"],[.375,\"rgb(65,171,93)\"],[.5,\"rgb(116,196,118)\"],[.625,\"rgb(161,217,155)\"],[.75,\"rgb(199,233,192)\"],[.875,\"rgb(229,245,224)\"],[1,\"rgb(247,252,245)\"]],YlOrRd:[[0,\"rgb(128,0,38)\"],[.125,\"rgb(189,0,38)\"],[.25,\"rgb(227,26,28)\"],[.375,\"rgb(252,78,42)\"],[.5,\"rgb(253,141,60)\"],[.625,\"rgb(254,178,76)\"],[.75,\"rgb(254,217,118)\"],[.875,\"rgb(255,237,160)\"],[1,\"rgb(255,255,204)\"]],Bluered:[[0,\"rgb(0,0,255)\"],[1,\"rgb(255,0,0)\"]],RdBu:[[0,\"rgb(5,10,172)\"],[.35,\"rgb(106,137,247)\"],[.5,\"rgb(190,190,190)\"],[.6,\"rgb(220,170,132)\"],[.7,\"rgb(230,145,90)\"],[1,\"rgb(178,10,28)\"]],Reds:[[0,\"rgb(220,220,220)\"],[.2,\"rgb(245,195,157)\"],[.4,\"rgb(245,160,105)\"],[1,\"rgb(178,10,28)\"]],Blues:[[0,\"rgb(5,10,172)\"],[.35,\"rgb(40,60,190)\"],[.5,\"rgb(70,100,245)\"],[.6,\"rgb(90,120,245)\"],[.7,\"rgb(106,137,247)\"],[1,\"rgb(220,220,220)\"]],Picnic:[[0,\"rgb(0,0,255)\"],[.1,\"rgb(51,153,255)\"],[.2,\"rgb(102,204,255)\"],[.3,\"rgb(153,204,255)\"],[.4,\"rgb(204,204,255)\"],[.5,\"rgb(255,255,255)\"],[.6,\"rgb(255,204,255)\"],[.7,\"rgb(255,153,255)\"],[.8,\"rgb(255,102,204)\"],[.9,\"rgb(255,102,102)\"],[1,\"rgb(255,0,0)\"]],Rainbow:[[0,\"rgb(150,0,90)\"],[.125,\"rgb(0,0,200)\"],[.25,\"rgb(0,25,255)\"],[.375,\"rgb(0,152,255)\"],[.5,\"rgb(44,255,150)\"],[.625,\"rgb(151,255,0)\"],[.75,\"rgb(255,234,0)\"],[.875,\"rgb(255,111,0)\"],[1,\"rgb(255,0,0)\"]],Portland:[[0,\"rgb(12,51,131)\"],[.25,\"rgb(10,136,186)\"],[.5,\"rgb(242,211,56)\"],[.75,\"rgb(242,143,56)\"],[1,\"rgb(217,30,30)\"]],Jet:[[0,\"rgb(0,0,131)\"],[.125,\"rgb(0,60,170)\"],[.375,\"rgb(5,255,255)\"],[.625,\"rgb(255,255,0)\"],[.875,\"rgb(250,0,0)\"],[1,\"rgb(128,0,0)\"]],Hot:[[0,\"rgb(0,0,0)\"],[.3,\"rgb(230,0,0)\"],[.6,\"rgb(255,210,0)\"],[1,\"rgb(255,255,255)\"]],Blackbody:[[0,\"rgb(0,0,0)\"],[.2,\"rgb(230,0,0)\"],[.4,\"rgb(230,210,0)\"],[.7,\"rgb(255,255,255)\"],[1,\"rgb(160,200,255)\"]],Earth:[[0,\"rgb(0,0,130)\"],[.1,\"rgb(0,180,180)\"],[.2,\"rgb(40,210,40)\"],[.4,\"rgb(230,230,50)\"],[.6,\"rgb(120,70,20)\"],[1,\"rgb(255,255,255)\"]],Electric:[[0,\"rgb(0,0,0)\"],[.15,\"rgb(30,0,100)\"],[.4,\"rgb(120,0,100)\"],[.6,\"rgb(160,90,0)\"],[.8,\"rgb(230,200,0)\"],[1,\"rgb(255,250,220)\"]],Viridis:[[0,\"#440154\"],[.06274509803921569,\"#48186a\"],[.12549019607843137,\"#472d7b\"],[.18823529411764706,\"#424086\"],[.25098039215686274,\"#3b528b\"],[.3137254901960784,\"#33638d\"],[.3764705882352941,\"#2c728e\"],[.4392156862745098,\"#26828e\"],[.5019607843137255,\"#21918c\"],[.5647058823529412,\"#1fa088\"],[.6274509803921569,\"#28ae80\"],[.6901960784313725,\"#3fbc73\"],[.7529411764705882,\"#5ec962\"],[.8156862745098039,\"#84d44b\"],[.8784313725490196,\"#addc30\"],[.9411764705882353,\"#d8e219\"],[1,\"#fde725\"]]}},{}],622:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i){var a=(t-r)/(n-r),o=a+e/(n-r),s=(a+o)/2\n",
       ";return\"left\"===i||\"bottom\"===i?a:\"center\"===i||\"middle\"===i?s:\"right\"===i||\"top\"===i?o:a<2/3-s?a:o>4/3-s?o:s}},{}],623:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=[[\"sw-resize\",\"s-resize\",\"se-resize\"],[\"w-resize\",\"move\",\"e-resize\"],[\"nw-resize\",\"n-resize\",\"ne-resize\"]];e.exports=function(t,e,r,a){return t=\"left\"===r?0:\"center\"===r?1:\"right\"===r?2:n.constrain(Math.floor(3*t),0,2),e=\"bottom\"===a?0:\"middle\"===a?1:\"top\"===a?2:n.constrain(Math.floor(3*e),0,2),i[e][t]}},{\"../../lib\":725}],624:[function(t,e,r){\"use strict\";function n(){var t=document.createElement(\"div\");t.className=\"dragcover\";var e=t.style;return e.position=\"fixed\",e.left=0,e.right=0,e.top=0,e.bottom=0,e.zIndex=999999999,e.background=\"none\",document.body.appendChild(t),t}function i(t){t._dragging=!1,t._replotPending&&l.plot(t)}function a(t){return o(t.changedTouches?t.changedTouches[0]:t,document.body)}var o=t(\"mouse-event-offset\"),s=t(\"has-hover\"),l=t(\"../../plotly\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/constants\"),h=t(\"../../constants/interactions\"),f=e.exports={};f.align=t(\"./align\"),f.getCursor=t(\"./cursor\");var d=t(\"./unhover\");f.unhover=d.wrapped,f.unhoverRaw=d.raw,f.init=function(t){function e(e){y._dragged=!1,y._dragging=!0;var i=a(e);return l=i[0],d=i[1],g=e.target,p=(new Date).getTime(),p-y._mouseDownTime<x?b+=1:(b=1,y._mouseDownTime=p),t.prepFn&&t.prepFn(e,l,d),s?(v=n(),v.style.cursor=window.getComputedStyle(t.element).cursor):(v=document,m=window.getComputedStyle(document.documentElement).cursor,document.documentElement.style.cursor=window.getComputedStyle(t.element).cursor),v.addEventListener(\"mousemove\",r),v.addEventListener(\"mouseup\",o),v.addEventListener(\"mouseout\",o),v.addEventListener(\"touchmove\",r),v.addEventListener(\"touchend\",o),u.pauseEvent(e)}function r(e){var r=a(e),n=r[0]-l,i=r[1]-d,o=t.minDrag||c.MINDRAG;return Math.abs(n)<o&&(n=0),Math.abs(i)<o&&(i=0),(n||i)&&(y._dragged=!0,f.unhover(y)),t.moveFn&&t.moveFn(n,i,y._dragged),u.pauseEvent(e)}function o(e){if(v.removeEventListener(\"mousemove\",r),v.removeEventListener(\"mouseup\",o),v.removeEventListener(\"mouseout\",o),v.removeEventListener(\"touchmove\",r),v.removeEventListener(\"touchend\",o),s?u.removeElement(v):m&&(v.documentElement.style.cursor=m,m=null),!y._dragging)return void(y._dragged=!1);if(y._dragging=!1,(new Date).getTime()-y._mouseDownTime>x&&(b=Math.max(b-1,1)),t.doneFn&&t.doneFn(y._dragged,b,e),!y._dragged){var n;try{n=new MouseEvent(\"click\",e)}catch(t){var l=a(e);n=document.createEvent(\"MouseEvents\"),n.initMouseEvent(\"click\",e.bubbles,e.cancelable,e.view,e.detail,e.screenX,e.screenY,l[0],l[1],e.ctrlKey,e.altKey,e.shiftKey,e.metaKey,e.button,e.relatedTarget)}g.dispatchEvent(n)}return i(y),y._dragged=!1,u.pauseEvent(e)}var l,d,p,m,v,g,y=t.gd,b=1,x=h.DBLCLICKDELAY;y._mouseDownTime||(y._mouseDownTime=0),t.element.style.pointerEvents=\"all\",t.element.onmousedown=e,t.element.ontouchstart=e},f.coverSlip=n},{\"../../constants/interactions\":704,\"../../lib\":725,\"../../plotly\":761,\"../../plots/cartesian/constants\":771,\"./align\":622,\"./cursor\":623,\"./unhover\":625,\"has-hover\":287,\"mouse-event-offset\":452}],625:[function(t,e,r){\"use strict\";var n=t(\"../../lib/events\"),i=e.exports={};i.wrapped=function(t,e,r){\"string\"==typeof t&&(t=document.getElementById(t)),t._hoverTimer&&(clearTimeout(t._hoverTimer),t._hoverTimer=void 0),i.raw(t,e,r)},i.raw=function(t,e){var r=t._fullLayout,i=t._hoverdata;e||(e={}),e.target&&!1===n.triggerHandler(t,\"plotly_beforehover\",e)||(r._hoverlayer.selectAll(\"g\").remove(),r._hoverlayer.selectAll(\"line\").remove(),r._hoverlayer.selectAll(\"circle\").remove(),t._hoverdata=void 0,e.target&&i&&t.emit(\"plotly_unhover\",{event:e,points:i}))}},{\"../../lib/events\":715}],626:[function(t,e,r){\"use strict\";r.dash={valType:\"string\",values:[\"solid\",\"dot\",\"dash\",\"longdash\",\"dashdot\",\"longdashdot\"],dflt:\"solid\"}},{}],627:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){if(u.traceIs(r,\"symbols\")){var l=y(r);e.attr(\"d\",function(t){var e;e=\"various\"===t.ms||\"various\"===a.size?3:g.isBubble(r)?l(t.ms):(a.size||6)/2,t.mrc=e;var n=b.symbolNumber(t.mx||a.symbol)||0,i=n%100;return t.om=n%200>=100,b.symbolFuncs[i](e)+(n>=200?w:\"\")}).style(\"opacity\",function(t){return(t.mo+1||a.opacity+1)-1})}var h,f,d,p=!1;if(t.so?(d=o.outlierwidth,f=o.outliercolor,h=a.outliercolor):(d=(t.mlw+1||o.width+1||(t.trace?t.trace.marker.line.width:0)+1)-1,f=\"mlc\"in t?t.mlcc=i(t.mlc):Array.isArray(o.color)?c.defaultLine:o.color,Array.isArray(a.color)&&(h=c.defaultLine,p=!0),h=\"mc\"in t?t.mcc=n(t.mc):a.color||\"rgba(0,0,0,0)\"),t.om)e.call(c.stroke,h).style({\"stroke-width\":(d||1)+\"px\",fill:\"none\"});else{e.style(\"stroke-width\",d+\"px\");var m=a.gradient,v=t.mgt;if(v?p=!0:v=m&&m.type,v&&\"none\"!==v){var x=t.mgc;x?p=!0:x=m.color;var _=\"g\"+s._fullLayout._uid+\"-\"+r.uid;p&&(_+=\"-\"+t.i),e.call(b.gradient,s,_,v,h,x)}else e.call(c.fill,h);d&&e.call(c.stroke,f)}}function i(t,e,r,n){var i=t[0]-e[0],a=t[1]-e[1],s=r[0]-e[0],l=r[1]-e[1],u=Math.pow(i*i+a*a,T/2),c=Math.pow(s*s+l*l,T/2),h=(c*c*i-u*u*s)*n,f=(c*c*a-u*u*l)*n,d=3*c*(u+c),p=3*u*(u+c);return[[o.round(e[0]+(d&&h/d),2),o.round(e[1]+(d&&f/d),2)],[o.round(e[0]-(p&&h/p),2),o.round(e[1]-(p&&f/p),2)]]}function a(t){var e=t.getAttribute(\"data-unformatted\");if(null!==e)return e+t.getAttribute(\"data-math\")+t.getAttribute(\"text-anchor\")+t.getAttribute(\"style\")}var o=t(\"d3\"),s=t(\"fast-isnumeric\"),l=t(\"tinycolor2\"),u=t(\"../../registry\"),c=t(\"../color\"),h=t(\"../colorscale\"),f=t(\"../../lib\"),d=t(\"../../lib/svg_text_utils\"),p=t(\"../../constants/xmlns_namespaces\"),m=t(\"../../constants/alignment\"),v=m.LINE_SPACING,g=t(\"../../traces/scatter/subtypes\"),y=t(\"../../traces/scatter/make_bubble_size_func\"),b=e.exports={};b.font=function(t,e,r,n){f.isPlainObject(e)&&(n=e.color,r=e.size,e=e.family),e&&t.style(\"font-family\",e),r+1&&t.style(\"font-size\",r+\"px\"),n&&t.call(c.fill,n)},b.setPosition=function(t,e,r){t.attr(\"x\",e).attr(\"y\",r)},b.setSize=function(t,e,r){t.attr(\"width\",e).attr(\"height\",r)},b.setRect=function(t,e,r,n,i){t.call(b.setPosition,e,r).call(b.setSize,n,i)},b.translatePoint=function(t,e,r,n){var i=r.c2p(t.x),a=n.c2p(t.y);return!!(s(i)&&s(a)&&e.node())&&(\"text\"===e.node().nodeName?e.attr(\"x\",i).attr(\"y\",a):e.attr(\"transform\",\"translate(\"+i+\",\"+a+\")\"),!0)},b.translatePoints=function(t,e,r){t.each(function(t){var n=o.select(this);b.translatePoint(t,n,e,r)})},b.hideOutsideRangePoint=function(t,e,r,n){e.attr(\"display\",r.isPtWithinRange(t)&&n.isPtWithinRange(t)?null:\"none\")},b.hideOutsideRangePoints=function(t,e){if(e._hasClipOnAxisFalse){var r=e.xaxis,n=e.yaxis;t.each(function(t){b.hideOutsideRangePoint(t,o.select(this),r,n)})}},b.getPx=function(t,e){return Number(t.style(e).replace(/px$/,\"\"))},b.crispRound=function(t,e,r){return e&&s(e)?t._context.staticPlot?e:e<1?1:Math.round(e):r||0},b.singleLineStyle=function(t,e,r,n,i){e.style(\"fill\",\"none\");var a=(((t||[])[0]||{}).trace||{}).line||{},o=r||a.width||0,s=i||a.dash||\"\";c.stroke(e,n||a.color),b.dashLine(e,s,o)},b.lineGroupStyle=function(t,e,r,n){t.style(\"fill\",\"none\").each(function(t){var i=(((t||[])[0]||{}).trace||{}).line||{},a=e||i.width||0,s=n||i.dash||\"\";o.select(this).call(c.stroke,r||i.color).call(b.dashLine,s,a)})},b.dashLine=function(t,e,r){r=+r||0,e=b.dashStyle(e,r),t.style({\"stroke-dasharray\":e,\"stroke-width\":r+\"px\"})},b.dashStyle=function(t,e){e=+e||1;var r=Math.max(e,3);return\"solid\"===t?t=\"\":\"dot\"===t?t=r+\"px,\"+r+\"px\":\"dash\"===t?t=3*r+\"px,\"+3*r+\"px\":\"longdash\"===t?t=5*r+\"px,\"+5*r+\"px\":\"dashdot\"===t?t=3*r+\"px,\"+r+\"px,\"+r+\"px,\"+r+\"px\":\"longdashdot\"===t&&(t=5*r+\"px,\"+2*r+\"px,\"+r+\"px,\"+2*r+\"px\"),t},b.singleFillStyle=function(t){var e=o.select(t.node()),r=e.data(),n=(((r[0]||[])[0]||{}).trace||{}).fillcolor;n&&t.call(c.fill,n)},b.fillGroupStyle=function(t){t.style(\"stroke-width\",0).each(function(e){var r=o.select(this);try{r.call(c.fill,e[0].trace.fillcolor)}catch(e){f.error(e,t),r.remove()}})};var x=t(\"./symbol_defs\");b.symbolNames=[],b.symbolFuncs=[],b.symbolNeedLines={},b.symbolNoDot={},b.symbolList=[],Object.keys(x).forEach(function(t){var e=x[t];b.symbolList=b.symbolList.concat([e.n,t,e.n+100,t+\"-open\"]),b.symbolNames[e.n]=t,b.symbolFuncs[e.n]=e.f,e.needLine&&(b.symbolNeedLines[e.n]=!0),e.noDot?b.symbolNoDot[e.n]=!0:b.symbolList=b.symbolList.concat([e.n+200,t+\"-dot\",e.n+300,t+\"-open-dot\"])});var _=b.symbolNames.length,w=\"M0,0.5L0.5,0L0,-0.5L-0.5,0Z\";b.symbolNumber=function(t){if(\"string\"==typeof t){var e=0;t.indexOf(\"-open\")>0&&(e=100,t=t.replace(\"-open\",\"\")),t.indexOf(\"-dot\")>0&&(e+=200,t=t.replace(\"-dot\",\"\")),t=b.symbolNames.indexOf(t),t>=0&&(t+=e)}return t%100>=_||t>=400?0:Math.floor(Math.max(t,0))};var M={x1:1,x2:0,y1:0,y2:0},k={x1:0,x2:0,y1:1,y2:0};b.gradient=function(t,e,r,n,i,a){var s=e._fullLayout._defs.select(\".gradients\").selectAll(\"#\"+r).data([n+i+a],f.identity);s.exit().remove(),s.enter().append(\"radial\"===n?\"radialGradient\":\"linearGradient\").each(function(){var t=o.select(this);\"horizontal\"===n?t.attr(M):\"vertical\"===n&&t.attr(k),t.attr(\"id\",r);var e=l(i),s=l(a);t.append(\"stop\").attr({offset:\"0%\",\"stop-color\":c.tinyRGB(s),\"stop-opacity\":s.getAlpha()}),t.append(\"stop\").attr({offset:\"100%\",\"stop-color\":c.tinyRGB(e),\"stop-opacity\":e.getAlpha()})}),t.style({fill:\"url(#\"+r+\")\",\"fill-opacity\":null})},b.initGradients=function(t){var e=t._fullLayout._defs.selectAll(\".gradients\").data([0]);e.enter().append(\"g\").classed(\"gradients\",!0),e.selectAll(\"linearGradient,radialGradient\").remove()},b.singlePointStyle=function(t,e,r,i,a,o){var s=r.marker;n(t,e,r,i,a,s,s.line,o)},b.pointStyle=function(t,e,r){if(t.size()){var n=e.marker,i=b.tryColorscale(n,\"\"),a=b.tryColorscale(n,\"line\");t.each(function(t){b.singlePointStyle(t,o.select(this),e,i,a,r)})}},b.tryColorscale=function(t,e){var r=e?f.nestedProperty(t,e).get():t,n=r.colorscale,i=r.color;return n&&Array.isArray(i)?h.makeColorScaleFunc(h.extractScale(n,r.cmin,r.cmax)):f.identity};var A={start:1,end:-1,middle:0,bottom:1,top:-1};b.textPointStyle=function(t,e,r){t.each(function(t){var n=o.select(this),i=t.tx||e.text;if(!i||Array.isArray(i))return void n.remove();var a=t.tp||e.textposition,l=-1!==a.indexOf(\"top\")?\"top\":-1!==a.indexOf(\"bottom\")?\"bottom\":\"middle\",u=-1!==a.indexOf(\"left\")?\"end\":-1!==a.indexOf(\"right\")?\"start\":\"middle\",c=t.ts||e.textfont.size,h=t.mrc?t.mrc/.8+1:0;c=s(c)&&c>0?c:0,n.call(b.font,t.tf||e.textfont.family,c,t.tc||e.textfont.color).attr(\"text-anchor\",u).text(i).call(d.convertToTspans,r);var f=o.select(this.parentNode),p=(d.lineCount(n)-1)*v+1,m=A[u]*h,g=.75*c+A[l]*h+(A[l]-1)*p*c/2;f.attr(\"transform\",\"translate(\"+m+\",\"+g+\")\")})};var T=.5;b.smoothopen=function(t,e){if(t.length<3)return\"M\"+t.join(\"L\");var r,n=\"M\"+t[0],a=[];for(r=1;r<t.length-1;r++)a.push(i(t[r-1],t[r],t[r+1],e));for(n+=\"Q\"+a[0][0]+\" \"+t[1],r=2;r<t.length-1;r++)n+=\"C\"+a[r-2][1]+\" \"+a[r-1][0]+\" \"+t[r];return n+=\"Q\"+a[t.length-3][1]+\" \"+t[t.length-1]},b.smoothclosed=function(t,e){if(t.length<3)return\"M\"+t.join(\"L\")+\"Z\";var r,n=\"M\"+t[0],a=t.length-1,o=[i(t[a],t[0],t[1],e)];for(r=1;r<a;r++)o.push(i(t[r-1],t[r],t[r+1],e));for(o.push(i(t[a-1],t[a],t[0],e)),r=1;r<=a;r++)n+=\"C\"+o[r-1][1]+\" \"+o[r][0]+\" \"+t[r];return n+=\"C\"+o[a][1]+\" \"+o[0][0]+\" \"+t[0]+\"Z\"};var S={hv:function(t,e){return\"H\"+o.round(e[0],2)+\"V\"+o.round(e[1],2)},vh:function(t,e){return\"V\"+o.round(e[1],2)+\"H\"+o.round(e[0],2)},hvh:function(t,e){return\"H\"+o.round((t[0]+e[0])/2,2)+\"V\"+o.round(e[1],2)+\"H\"+o.round(e[0],2)},vhv:function(t,e){return\"V\"+o.round((t[1]+e[1])/2,2)+\"H\"+o.round(e[0],2)+\"V\"+o.round(e[1],2)}},E=function(t,e){return\"L\"+o.round(e[0],2)+\",\"+o.round(e[1],2)};b.steps=function(t){var e=S[t]||E;return function(t){for(var r=\"M\"+o.round(t[0][0],2)+\",\"+o.round(t[0][1],2),n=1;n<t.length;n++)r+=e(t[n-1],t[n]);return r}},b.makeTester=function(){var t=o.select(\"body\").selectAll(\"#js-plotly-tester\").data([0]);t.enter().append(\"svg\").attr(\"id\",\"js-plotly-tester\").attr(p.svgAttrs).style({position:\"absolute\",left:\"-10000px\",top:\"-10000px\",width:\"9000px\",height:\"9000px\",\"z-index\":\"1\"});var e=t.selectAll(\".js-reference-point\").data([0]);e.enter().append(\"path\").classed(\"js-reference-point\",!0).attr(\"d\",\"M0,0H1V1H0Z\").style({\"stroke-width\":0,fill:\"black\"}),b.tester=t,b.testref=e},b.savedBBoxes={};var L=0;b.bBox=function(t,e,r){r||(r=a(t));var n;if(r){if(n=b.savedBBoxes[r])return f.extendFlat({},n)}else if(1===t.childNodes.length){var i=t.childNodes[0];if(r=a(i)){var s=+i.getAttribute(\"x\")||0,l=+i.getAttribute(\"y\")||0,u=i.getAttribute(\"transform\");if(!u){var c=b.bBox(i,!1,r);return s&&(c.left+=s,c.right+=s),l&&(c.top+=l,c.bottom+=l),c}if(r+=\"~\"+s+\"~\"+l+\"~\"+u,n=b.savedBBoxes[r])return f.extendFlat({},n)}}var h,p;e?h=t:(p=b.tester.node(),h=t.cloneNode(!0),p.appendChild(h)),o.select(h).attr(\"transform\",null).call(d.positionText,0,0);var m=h.getBoundingClientRect(),v=b.testref.node().getBoundingClientRect();e||p.removeChild(h);var g={height:m.height,width:m.width,left:m.left-v.left,top:m.top-v.top,right:m.right-v.left,bottom:m.bottom-v.top};return L>=1e4&&(b.savedBBoxes={},L=0),r&&(b.savedBBoxes[r]=g),L++,f.extendFlat({},g)},b.setClipUrl=function(t,e){if(!e)return void t.attr(\"clip-path\",null);var r=\"#\"+e,n=o.select(\"base\");n.size()&&n.attr(\"href\")&&(r=window.location.href.split(\"#\")[0]+r),t.attr(\"clip-path\",\"url(\"+r+\")\")},b.getTranslate=function(t){var e=/.*\\btranslate\\((-?\\d*\\.?\\d*)[^-\\d]*(-?\\d*\\.?\\d*)[^\\d].*/,r=t.attr?\"attr\":\"getAttribute\",n=t[r](\"transform\")||\"\",i=n.replace(e,function(t,e,r){return[e,r].join(\" \")}).split(\" \");return{x:+i[0]||0,y:+i[1]||0}},b.setTranslate=function(t,e,r){var n=/(\\btranslate\\(.*?\\);?)/,i=t.attr?\"attr\":\"getAttribute\",a=t.attr?\"attr\":\"setAttribute\",o=t[i](\"transform\")||\"\";return e=e||0,r=r||0,o=o.replace(n,\"\").trim(),o+=\" translate(\"+e+\", \"+r+\")\",o=o.trim(),t[a](\"transform\",o),o},b.getScale=function(t){var e=/.*\\bscale\\((\\d*\\.?\\d*)[^\\d]*(\\d*\\.?\\d*)[^\\d].*/,r=t.attr?\"attr\":\"getAttribute\",n=t[r](\"transform\")||\"\",i=n.replace(e,function(t,e,r){return[e,r].join(\" \")}).split(\" \");return{x:+i[0]||1,y:+i[1]||1}},b.setScale=function(t,e,r){var n=/(\\bscale\\(.*?\\);?)/,i=t.attr?\"attr\":\"getAttribute\",a=t.attr?\"attr\":\"setAttribute\",o=t[i](\"transform\")||\"\";return e=e||1,r=r||1,o=o.replace(n,\"\").trim(),o+=\" scale(\"+e+\", \"+r+\")\",o=o.trim(),t[a](\"transform\",o),o},b.setPointGroupScale=function(t,e,r){var n,i,a;return e=e||1,r=r||1,i=1===e&&1===r?\"\":\" scale(\"+e+\",\"+r+\")\",a=/\\s*sc.*/,t.each(function(){n=(this.getAttribute(\"transform\")||\"\").replace(a,\"\"),n+=i,n=n.trim(),this.setAttribute(\"transform\",n)}),i};var C=/translate\\([^)]*\\)\\s*$/;b.setTextPointsScale=function(t,e,r){t.each(function(){var t,n=o.select(this),i=n.select(\"text\"),a=parseFloat(i.attr(\"x\")||0),s=parseFloat(i.attr(\"y\")||0),l=(n.attr(\"transform\")||\"\").match(C);t=1===e&&1===r?[]:[\"translate(\"+a+\",\"+s+\")\",\"scale(\"+e+\",\"+r+\")\",\"translate(\"+-a+\",\"+-s+\")\"],l&&t.push(l),n.attr(\"transform\",t.join(\" \"))})}},{\"../../constants/alignment\":699,\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../registry\":844,\"../../traces/scatter/make_bubble_size_func\":1042,\"../../traces/scatter/subtypes\":1047,\"../color\":603,\"../colorscale\":617,\"./symbol_defs\":628,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],628:[function(t,e,r){\"use strict\";var n=t(\"d3\");e.exports={circle:{n:0,f:function(t){var e=n.round(t,2);return\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"}},square:{n:1,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"}},diamond:{n:2,f:function(t){var e=n.round(1.3*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"Z\"}},cross:{n:3,f:function(t){var e=n.round(.4*t,2),r=n.round(1.2*t,2);return\"M\"+r+\",\"+e+\"H\"+e+\"V\"+r+\"H-\"+e+\"V\"+e+\"H-\"+r+\"V-\"+e+\"H-\"+e+\"V-\"+r+\"H\"+e+\"V-\"+e+\"H\"+r+\"Z\"}},x:{n:4,f:function(t){var e=n.round(.8*t/Math.sqrt(2),2),r=\"l\"+e+\",\"+e,i=\"l\"+e+\",-\"+e,a=\"l-\"+e+\",-\"+e,o=\"l-\"+e+\",\"+e;return\"M0,\"+e+r+i+a+i+a+o+a+o+r+o+r+\"Z\"}},\"triangle-up\":{n:5,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+e+\",\"+n.round(t/2,2)+\"H\"+e+\"L0,-\"+n.round(t,2)+\"Z\"}},\"triangle-down\":{n:6,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+e+\",-\"+n.round(t/2,2)+\"H\"+e+\"L0,\"+n.round(t,2)+\"Z\"}},\"triangle-left\":{n:7,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M\"+n.round(t/2,2)+\",-\"+e+\"V\"+e+\"L-\"+n.round(t,2)+\",0Z\"}},\"triangle-right\":{n:8,f:function(t){var e=n.round(2*t/Math.sqrt(3),2);return\"M-\"+n.round(t/2,2)+\",-\"+e+\"V\"+e+\"L\"+n.round(t,2)+\",0Z\"}},\"triangle-ne\":{n:9,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M-\"+r+\",-\"+e+\"H\"+e+\"V\"+r+\"Z\"}},\"triangle-se\":{n:10,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M\"+e+\",-\"+r+\"V\"+e+\"H-\"+r+\"Z\"}},\"triangle-sw\":{n:11,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M\"+r+\",\"+e+\"H-\"+e+\"V-\"+r+\"Z\"}},\"triangle-nw\":{n:12,f:function(t){var e=n.round(.6*t,2),r=n.round(1.2*t,2);return\"M-\"+e+\",\"+r+\"V-\"+e+\"H\"+r+\"Z\"}},pentagon:{n:13,f:function(t){var e=n.round(.951*t,2),r=n.round(.588*t,2),i=n.round(-t,2),a=n.round(-.309*t,2);return\"M\"+e+\",\"+a+\"L\"+r+\",\"+n.round(.809*t,2)+\"H-\"+r+\"L-\"+e+\",\"+a+\"L0,\"+i+\"Z\"}},hexagon:{n:14,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return\"M\"+i+\",-\"+r+\"V\"+r+\"L0,\"+e+\"L-\"+i+\",\"+r+\"V-\"+r+\"L0,-\"+e+\"Z\"}},hexagon2:{n:15,f:function(t){var e=n.round(t,2),r=n.round(t/2,2),i=n.round(t*Math.sqrt(3)/2,2);return\"M-\"+r+\",\"+i+\"H\"+r+\"L\"+e+\",0L\"+r+\",-\"+i+\"H-\"+r+\"L-\"+e+\",0Z\"}},octagon:{n:16,f:function(t){var e=n.round(.924*t,2),r=n.round(.383*t,2);return\"M-\"+r+\",-\"+e+\"H\"+r+\"L\"+e+\",-\"+r+\"V\"+r+\"L\"+r+\",\"+e+\"H-\"+r+\"L-\"+e+\",\"+r+\"V-\"+r+\"Z\"}},star:{n:17,f:function(t){var e=1.4*t,r=n.round(.225*e,2),i=n.round(.951*e,2),a=n.round(.363*e,2),o=n.round(.588*e,2),s=n.round(-e,2),l=n.round(-.309*e,2),u=n.round(.118*e,2),c=n.round(.809*e,2);return\"M\"+r+\",\"+l+\"H\"+i+\"L\"+a+\",\"+u+\"L\"+o+\",\"+c+\"L0,\"+n.round(.382*e,2)+\"L-\"+o+\",\"+c+\"L-\"+a+\",\"+u+\"L-\"+i+\",\"+l+\"H-\"+r+\"L0,\"+s+\"Z\"}},hexagram:{n:18,f:function(t){var e=n.round(.66*t,2),r=n.round(.38*t,2),i=n.round(.76*t,2);return\"M-\"+i+\",0l-\"+r+\",-\"+e+\"h\"+i+\"l\"+r+\",-\"+e+\"l\"+r+\",\"+e+\"h\"+i+\"l-\"+r+\",\"+e+\"l\"+r+\",\"+e+\"h-\"+i+\"l-\"+r+\",\"+e+\"l-\"+r+\",-\"+e+\"h-\"+i+\"Z\"}},\"star-triangle-up\":{n:19,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o=\"A \"+a+\",\"+a+\" 0 0 1 \";return\"M-\"+e+\",\"+r+o+e+\",\"+r+o+\"0,-\"+i+o+\"-\"+e+\",\"+r+\"Z\"}},\"star-triangle-down\":{n:20,f:function(t){var e=n.round(t*Math.sqrt(3)*.8,2),r=n.round(.8*t,2),i=n.round(1.6*t,2),a=n.round(4*t,2),o=\"A \"+a+\",\"+a+\" 0 0 1 \";return\"M\"+e+\",-\"+r+o+\"-\"+e+\",-\"+r+o+\"0,\"+i+o+e+\",-\"+r+\"Z\"}},\"star-square\":{n:21,f:function(t){var e=n.round(1.1*t,2),r=n.round(2*t,2),i=\"A \"+r+\",\"+r+\" 0 0 1 \";return\"M-\"+e+\",-\"+e+i+\"-\"+e+\",\"+e+i+e+\",\"+e+i+e+\",-\"+e+i+\"-\"+e+\",-\"+e+\"Z\"}},\"star-diamond\":{n:22,f:function(t){var e=n.round(1.4*t,2),r=n.round(1.9*t,2),i=\"A \"+r+\",\"+r+\" 0 0 1 \";return\"M-\"+e+\",0\"+i+\"0,\"+e+i+e+\",0\"+i+\"0,-\"+e+i+\"-\"+e+\",0Z\"}},\"diamond-tall\":{n:23,f:function(t){var e=n.round(.7*t,2),r=n.round(1.4*t,2);return\"M0,\"+r+\"L\"+e+\",0L0,-\"+r+\"L-\"+e+\",0Z\"}},\"diamond-wide\":{n:24,f:function(t){var e=n.round(1.4*t,2),r=n.round(.7*t,2);return\"M0,\"+r+\"L\"+e+\",0L0,-\"+r+\"L-\"+e+\",0Z\"}},hourglass:{n:25,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"H-\"+e+\"L\"+e+\",-\"+e+\"H-\"+e+\"Z\"},noDot:!0},bowtie:{n:26,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"V-\"+e+\"L-\"+e+\",\"+e+\"V-\"+e+\"Z\"},noDot:!0},\"circle-cross\":{n:27,f:function(t){var e=n.round(t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"},needLine:!0,noDot:!0},\"circle-x\":{n:28,f:function(t){var e=n.round(t,2),r=n.round(t/Math.sqrt(2),2);return\"M\"+r+\",\"+r+\"L-\"+r+\",-\"+r+\"M\"+r+\",-\"+r+\"L-\"+r+\",\"+r+\"M\"+e+\",0A\"+e+\",\"+e+\" 0 1,1 0,-\"+e+\"A\"+e+\",\"+e+\" 0 0,1 \"+e+\",0Z\"},needLine:!0,noDot:!0},\"square-cross\":{n:29,f:function(t){var e=n.round(t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"},needLine:!0,noDot:!0},\"square-x\":{n:30,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e+\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e+\"M\"+e+\",\"+e+\"H-\"+e+\"V-\"+e+\"H\"+e+\"Z\"},needLine:!0,noDot:!0},\"diamond-cross\":{n:31,f:function(t){var e=n.round(1.3*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"ZM0,-\"+e+\"V\"+e+\"M-\"+e+\",0H\"+e},needLine:!0,noDot:!0},\"diamond-x\":{n:32,f:function(t){var e=n.round(1.3*t,2),r=n.round(.65*t,2);return\"M\"+e+\",0L0,\"+e+\"L-\"+e+\",0L0,-\"+e+\"ZM-\"+r+\",-\"+r+\"L\"+r+\",\"+r+\"M-\"+r+\",\"+r+\"L\"+r+\",-\"+r},needLine:!0,noDot:!0},\"cross-thin\":{n:33,f:function(t){var e=n.round(1.4*t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e},needLine:!0,noDot:!0},\"x-thin\":{n:34,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e+\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e},needLine:!0,noDot:!0},asterisk:{n:35,f:function(t){var e=n.round(1.2*t,2),r=n.round(.85*t,2);return\"M0,\"+e+\"V-\"+e+\"M\"+e+\",0H-\"+e+\"M\"+r+\",\"+r+\"L-\"+r+\",-\"+r+\"M\"+r+\",-\"+r+\"L-\"+r+\",\"+r},needLine:!0,noDot:!0},hash:{n:36,f:function(t){var e=n.round(t/2,2),r=n.round(t,2);return\"M\"+e+\",\"+r+\"V-\"+r+\"m-\"+r+\",0V\"+r+\"M\"+r+\",\"+e+\"H-\"+r+\"m0,-\"+r+\"H\"+r},needLine:!0},\"y-up\":{n:37,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+e+\",\"+i+\"L0,0M\"+e+\",\"+i+\"L0,0M0,-\"+r+\"L0,0\"},needLine:!0,noDot:!0},\"y-down\":{n:38,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+e+\",-\"+i+\"L0,0M\"+e+\",-\"+i+\"L0,0M0,\"+r+\"L0,0\"},needLine:!0,noDot:!0},\"y-left\":{n:39,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M\"+i+\",\"+e+\"L0,0M\"+i+\",-\"+e+\"L0,0M-\"+r+\",0L0,0\"},needLine:!0,noDot:!0},\"y-right\":{n:40,f:function(t){var e=n.round(1.2*t,2),r=n.round(1.6*t,2),i=n.round(.8*t,2);return\"M-\"+i+\",\"+e+\"L0,0M-\"+i+\",-\"+e+\"L0,0M\"+r+\",0L0,0\"},needLine:!0,noDot:!0},\"line-ew\":{n:41,f:function(t){var e=n.round(1.4*t,2);return\"M\"+e+\",0H-\"+e},needLine:!0,noDot:!0},\"line-ns\":{n:42,f:function(t){var e=n.round(1.4*t,2);return\"M0,\"+e+\"V-\"+e},needLine:!0,noDot:!0},\"line-ne\":{n:43,f:function(t){var e=n.round(t,2);return\"M\"+e+\",-\"+e+\"L-\"+e+\",\"+e},needLine:!0,noDot:!0},\"line-nw\":{n:44,f:function(t){var e=n.round(t,2);return\"M\"+e+\",\"+e+\"L-\"+e+\",-\"+e},needLine:!0,noDot:!0}}},{d3:121}],629:[function(t,e,r){\"use strict\";e.exports={visible:{valType:\"boolean\"},type:{valType:\"enumerated\",values:[\"percent\",\"constant\",\"sqrt\",\"data\"]},symmetric:{valType:\"boolean\"},array:{valType:\"data_array\"},arrayminus:{valType:\"data_array\"},value:{valType:\"number\",min:0,dflt:10},valueminus:{valType:\"number\",min:0,dflt:10},traceref:{valType:\"integer\",min:0,dflt:0},tracerefminus:{valType:\"integer\",min:0,dflt:0},copy_ystyle:{valType:\"boolean\"},copy_zstyle:{valType:\"boolean\"},color:{valType:\"color\"},thickness:{valType:\"number\",min:0,dflt:2},width:{valType:\"number\",min:0},_deprecated:{opacity:{valType:\"number\"}}}},{}],630:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=e[\"error_\"+n]||{},l=a.visible&&-1!==[\"linear\",\"log\"].indexOf(r.type),u=[];if(l){for(var c=s(a),h=0;h<t.length;h++){var f=t[h],d=f[n];if(i(r.c2l(d))){var p=c(d,h);if(i(p[0])&&i(p[1])){var m=f[n+\"s\"]=d-p[0],v=f[n+\"h\"]=d+p[1];u.push(m,v)}}}o.expand(r,u,{padded:!0})}}var i=t(\"fast-isnumeric\"),a=t(\"../../registry\"),o=t(\"../../plots/cartesian/axes\"),s=t(\"./compute_error\");e.exports=function(t){for(var e=t.calcdata,r=0;r<e.length;r++){var i=e[r],s=i[0].trace;if(a.traceIs(s,\"errorBarsOK\")){var l=o.getFromId(t,s.xaxis),u=o.getFromId(t,s.yaxis);n(i,s,l,\"x\"),n(i,s,u,\"y\")}}}},{\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./compute_error\":631,\"fast-isnumeric\":130}],631:[function(t,e,r){\"use strict\";function n(t,e){return\"percent\"===t?function(t){return Math.abs(t*e/100)}:\"constant\"===t?function(){return Math.abs(e)}:\"sqrt\"===t?function(t){return Math.sqrt(Math.abs(t))}:void 0}e.exports=function(t){var e=t.type,r=t.symmetric;if(\"data\"===e){var i=t.array,a=t.arrayminus;return r||void 0===a?function(t,e){var r=+i[e];return[r,r]}:function(t,e){return[+a[e],+i[e]]}}var o=n(e,t.value),s=n(e,t.valueminus);return r||void 0===t.valueminus?function(t){var e=o(t);return[e,e]}:function(t){return[s(t),o(t)]}}},{}],632:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(t,e){return a.coerce(h,c,o,t,e)}var u=\"error_\"+s.axis,c=e[u]={},h=t[u]||{};if(!1!==l(\"visible\",void 0!==h.array||void 0!==h.value||\"sqrt\"===h.type)){var f=l(\"type\",\"array\"in h?\"data\":\"percent\"),d=!0;\"sqrt\"!==f&&(d=l(\"symmetric\",!((\"data\"===f?\"arrayminus\":\"valueminus\")in h))),\"data\"===f?(l(\"array\")||(c.array=[]),l(\"traceref\"),d||(l(\"arrayminus\")||(c.arrayminus=[]),l(\"tracerefminus\"))):\"percent\"!==f&&\"constant\"!==f||(l(\"value\"),d||l(\"valueminus\"));var p=\"copy_\"+s.inherit+\"style\";s.inherit&&(e[\"error_\"+s.inherit]||{}).visible&&l(p,!(h.color||n(h.thickness)||n(h.width))),s.inherit&&c[p]||(l(\"color\",r),l(\"thickness\"),l(\"width\",i.traceIs(e,\"gl3d\")?0:4))}}},{\"../../lib\":725,\"../../registry\":844,\"./attributes\":629,\"fast-isnumeric\":130}],633:[function(t,e,r){\"use strict\";var n=e.exports={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.calcFromTrace=function(t,e){for(var r=t.x||[],i=t.y||[],a=r.length||i.length,o=new Array(a),s=0;s<a;s++)o[s]={x:r[s],y:i[s]};return o[0].trace=t,n.calc({calcdata:[o],_fullLayout:e}),o},n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverInfo=function(t,e,r){(e.error_y||{}).visible&&(r.yerr=t.yh-t.y,e.error_y.symmetric||(r.yerrneg=t.y-t.ys)),(e.error_x||{}).visible&&(r.xerr=t.xh-t.x,e.error_x.symmetric||(r.xerrneg=t.x-t.xs))}},{\"./attributes\":629,\"./calc\":630,\"./defaults\":632,\"./plot\":634,\"./style\":635}],634:[function(t,e,r){\"use strict\";function n(t,e,r){var n={x:e.c2p(t.x),y:r.c2p(t.y)};return void 0!==t.yh&&(n.yh=r.c2p(t.yh),n.ys=r.c2p(t.ys),a(n.ys)||(n.noYS=!0,n.ys=r.c2p(t.ys,!0))),void 0!==t.xh&&(n.xh=e.c2p(t.xh),n.xs=e.c2p(t.xs),a(n.xs)||(n.noXS=!0,n.xs=e.c2p(t.xs,!0))),n}var i=t(\"d3\"),a=t(\"fast-isnumeric\"),o=t(\"../drawing\"),s=t(\"../../traces/scatter/subtypes\");e.exports=function(t,e,r){var l,u=e.xaxis,c=e.yaxis,h=r&&r.duration>0;t.each(function(t){var f,d=t[0].trace,p=d.error_x||{},m=d.error_y||{};d.ids&&(f=function(t){return t.id});var v=s.hasMarkers(d)&&d.marker.maxdisplayed>0;if(m.visible||p.visible){var g=i.select(this).selectAll(\"g.errorbar\").data(t,f);g.exit().remove(),g.style(\"opacity\",1);var y=g.enter().append(\"g\").classed(\"errorbar\",!0);h&&y.style(\"opacity\",0).transition().duration(r.duration).style(\"opacity\",1),o.setClipUrl(g,e.layerClipId),g.each(function(t){var e=i.select(this),o=n(t,u,c);if(!v||t.vis){var s;if(m.visible&&a(o.x)&&a(o.yh)&&a(o.ys)){var f=m.width;s=\"M\"+(o.x-f)+\",\"+o.yh+\"h\"+2*f+\"m-\"+f+\",0V\"+o.ys,o.noYS||(s+=\"m-\"+f+\",0h\"+2*f);var d=e.select(\"path.yerror\");l=!d.size(),l?d=e.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").classed(\"yerror\",!0):h&&(d=d.transition().duration(r.duration).ease(r.easing)),d.attr(\"d\",s)}if(p.visible&&a(o.y)&&a(o.xh)&&a(o.xs)){var g=(p.copy_ystyle?m:p).width;s=\"M\"+o.xh+\",\"+(o.y-g)+\"v\"+2*g+\"m0,-\"+g+\"H\"+o.xs,o.noXS||(s+=\"m0,-\"+g+\"v\"+2*g);var y=e.select(\"path.xerror\");l=!y.size(),l?y=e.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").classed(\"xerror\",!0):h&&(y=y.transition().duration(r.duration).ease(r.easing)),y.attr(\"d\",s)}}})}})}},{\"../../traces/scatter/subtypes\":1047,\"../drawing\":627,d3:121,\"fast-isnumeric\":130}],635:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../color\");e.exports=function(t){t.each(function(t){var e=t[0].trace,r=e.error_y||{},a=e.error_x||{},o=n.select(this);o.selectAll(\"path.yerror\").style(\"stroke-width\",r.thickness+\"px\").call(i.stroke,r.color),a.copy_ystyle&&(a=r),o.selectAll(\"path.xerror\").style(\"stroke-width\",a.thickness+\"px\").call(i.stroke,a.color)})}},{\"../color\":603,d3:121}],636:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\");e.exports={hoverlabel:{bgcolor:{valType:\"color\",arrayOk:!0},bordercolor:{valType:\"color\",arrayOk:!0},font:{family:n({},i.family,{arrayOk:!0}),size:n({},i.size,{arrayOk:!0}),color:n({},i.color,{arrayOk:!0})},namelength:{valType:\"integer\",min:-1,arrayOk:!0}}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790}],637:[function(t,e,r){\"use strict\";function n(t,e,r,n){n=n||i.identity,Array.isArray(t)&&(e[0][r]=n(t))}var i=t(\"../../lib\"),a=t(\"../../registry\");e.exports=function(t){for(var e=t.calcdata,r=t._fullLayout,o=0;o<e.length;o++){var s=e[o],l=s[0].trace;if(!a.traceIs(l,\"pie\")){var u=a.traceIs(l,\"2dMap\")?n:i.fillArray;u(l.hoverinfo,s,\"hi\",function(t){return function(e){return i.coerceHoverinfo({hoverinfo:e},{_module:t._module},r)}}(l)),l.hoverlabel&&(u(l.hoverlabel.bgcolor,s,\"hbg\"),u(l.hoverlabel.bordercolor,s,\"hbc\"),u(l.hoverlabel.font.size,s,\"hts\"),u(l.hoverlabel.font.color,s,\"htc\"),u(l.hoverlabel.font.family,s,\"htf\"),u(l.hoverlabel.namelength,s,\"hnl\"))}}}},{\"../../lib\":725,\"../../registry\":844}],638:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"./hover\").hover;e.exports=function(t,e,r){function a(){t.emit(\"plotly_click\",{points:t._hoverdata,event:e})}var o=n.getComponentMethod(\"annotations\",\"onClick\")(t,t._hoverdata);void 0!==r&&i(t,e,r,!0),t._hoverdata&&e&&e.target&&(o&&o.then?o.then(a):a(),e.stopImmediatePropagation&&e.stopImmediatePropagation())}},{\"../../registry\":844,\"./hover\":642}],639:[function(t,e,r){\"use strict\";e.exports={MAXDIST:20,YANGLE:60,HOVERARROWSIZE:6,HOVERTEXTPAD:3,HOVERFONTSIZE:13,HOVERFONT:\"Arial, sans-serif\",HOVERMINTIME:50}},{}],640:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"./hoverlabel_defaults\");e.exports=function(t,e,r,o){function s(r,a){return n.coerce(t,e,i,r,a)}a(t,e,s,o.hoverlabel)}},{\"../../lib\":725,\"./attributes\":636,\"./hoverlabel_defaults\":643}],641:[function(t,e,r){\"use strict\";function n(t,e){return function(r){var n=t(r),i=e(r);return Math.sqrt(n*n+i*i)}}var i=t(\"../../lib\"),a=t(\"./constants\");r.getSubplot=function(t){return t.subplot||t.xaxis+t.yaxis||t.geo},r.flat=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=e;return r},r.p2c=function(t,e){for(var r=new Array(t.length),n=0;n<t.length;n++)r[n]=t[n].p2c(e);return r},r.getDistanceFunction=function(t,e,r,i){return\"closest\"===t?i||n(e,r):\"x\"===t?e:r},r.getClosest=function(t,e,r){if(!1!==r.index)r.index>=0&&r.index<t.length?r.distance=0:r.index=!1;else for(var n=0;n<t.length;n++){var i=e(t[n]);i<=r.distance&&(r.index=n,r.distance=i)}return r},r.inbox=function(t,e){return t*e<0||0===t?a.MAXDIST*(.6-.3/Math.max(3,Math.abs(t-e))):1/0},r.appendArrayPointValue=function(t,e,r){var n=e._arrayAttrs;if(n)for(var a=0;a<n.length;a++){var o,s=n[a];if(o=\"ids\"===s?\"id\":\"locations\"===s?\"location\":s,void 0===t[o]){var l=i.nestedProperty(e,s).get();Array.isArray(r)?Array.isArray(l)&&Array.isArray(l[r[0]])&&(t[o]=l[r[0]][r[1]]):t[o]=l[r]}}}},{\"../../lib\":725,\"./constants\":639}],642:[function(t,e,r){\"use strict\";function n(t,e,r,n){if((\"pie\"===r||\"sankey\"===r)&&!n)return void t.emit(\"plotly_hover\",{event:e.originalEvent,points:[e]});r||(r=\"xy\");var f=Array.isArray(r)?r:[r],m=t._fullLayout,g=m._plots||[],k=g[r];if(k){var A=k.overlays.map(function(t){return t.id});f=f.concat(A)}for(var T=f.length,S=new Array(T),E=new Array(T),L=0;L<T;L++){var C=f[L],z=g[C];if(z)S[L]=x.getFromId(t,z.xaxis._id),E[L]=x.getFromId(t,z.yaxis._id);else{var I=m[C]._subplot;S[L]=I.xaxis,E[L]=I.yaxis}}var D=e.hovermode||m.hovermode;if(-1===[\"x\",\"y\",\"closest\"].indexOf(D)||!t.calcdata||t.querySelector(\".zoombox\")||t._dragging)return b.unhoverRaw(t,e);var P,O,R,F,j,N,B,U,V,H,q,G,Y,X=[],W=[];if(Array.isArray(e))for(D=\"array\",R=0;R<e.length;R++)j=t.calcdata[e[R].curveNumber||0],\"skip\"!==j[0].trace.hoverinfo&&W.push(j);else{for(F=0;F<t.calcdata.length;F++)j=t.calcdata[F],N=j[0].trace,\"skip\"!==N.hoverinfo&&-1!==f.indexOf(w.getSubplot(N))&&W.push(j);var Z,J,K=!e.target;if(K)Z=\"xpx\"in e?e.xpx:S[0]._length/2,J=\"ypx\"in e?e.ypx:E[0]._length/2;else{if(!1===p.triggerHandler(t,\"plotly_beforehover\",e))return;var Q=e.target.getBoundingClientRect();if(Z=e.clientX-Q.left,J=e.clientY-Q.top,Z<0||Z>Q.width||J<0||J>Q.height)return b.unhoverRaw(t,e)}if(P=\"xval\"in e?w.flat(f,e.xval):w.p2c(S,Z),O=\"yval\"in e?w.flat(f,e.yval):w.p2c(E,J),!h(P[0])||!h(O[0]))return d.warn(\"Fx.hover failed\",e,t),b.unhoverRaw(t,e)}var $=1/0\n",
       ";for(F=0;F<W.length;F++)if((j=W[F])&&j[0]&&j[0].trace&&!0===j[0].trace.visible&&(N=j[0].trace,-1===[\"carpet\",\"contourcarpet\"].indexOf(N._module.name))){if(B=w.getSubplot(N),U=f.indexOf(B),V=D,G={cd:j,trace:N,xa:S[U],ya:E[U],index:!1,distance:Math.min($,M.MAXDIST),color:y.defaultLine,name:N.name,x0:void 0,x1:void 0,y0:void 0,y1:void 0,xLabelVal:void 0,yLabelVal:void 0,zLabelVal:void 0,text:void 0},m[B]&&(G.subplot=m[B]._subplot),Y=X.length,\"array\"===V){var tt=e[F];\"pointNumber\"in tt?(G.index=tt.pointNumber,V=\"closest\"):(V=\"\",\"xval\"in tt&&(H=tt.xval,V=\"x\"),\"yval\"in tt&&(q=tt.yval,V=V?\"closest\":\"y\"))}else H=P[U],q=O[U];if(N._module&&N._module.hoverPoints){var et=N._module.hoverPoints(G,H,q,V);if(et)for(var rt,nt=0;nt<et.length;nt++)rt=et[nt],h(rt.x0)&&h(rt.y0)&&X.push(s(rt,D))}else d.log(\"Unrecognized trace type in hover:\",N);\"closest\"===D&&X.length>Y&&(X.splice(0,Y),$=X[0].distance)}if(0===X.length)return b.unhoverRaw(t,e);X.sort(function(t,e){return t.distance-e.distance});var it=t._hoverdata,at=[];for(R=0;R<X.length;R++){var ot=X[R],st={data:ot.trace._input,fullData:ot.trace,curveNumber:ot.trace.index,pointNumber:ot.index};ot.trace._module.eventData?st=ot.trace._module.eventData(st,ot):(st.x=ot.xVal,st.y=ot.yVal,st.xaxis=ot.xa,st.yaxis=ot.ya,void 0!==ot.zLabelVal&&(st.z=ot.zLabelVal)),w.appendArrayPointValue(st,ot.trace,ot.index),at.push(st)}if(t._hoverdata=at,u(t,e,it)&&m._hasCartesian){l(X,{hovermode:D,fullLayout:m,container:m._hoverlayer,outerContainer:m._paperdiv})}var lt=\"y\"===D&&W.length>1,ut=y.combine(m.plot_bgcolor||y.background,m.paper_bgcolor),ct={hovermode:D,rotateLabels:lt,bgColor:ut,container:m._hoverlayer,outerContainer:m._paperdiv,commonLabelOpts:m.hoverlabel},ht=i(X,ct,t);if(a(X,lt?\"xa\":\"ya\"),o(ht,lt),e.target&&e.target.tagName){var ft=_.getComponentMethod(\"annotations\",\"hasClickToShow\")(t,at);v(c.select(e.target),ft?\"pointer\":\"\")}e.target&&!n&&u(t,e,it)&&(it&&t.emit(\"plotly_unhover\",{event:e,points:it}),t.emit(\"plotly_hover\",{event:e,points:t._hoverdata,xaxes:S,yaxes:E,xvals:P,yvals:O}))}function i(t,e,r){var n,i,a=e.hovermode,o=e.rotateLabels,s=e.bgColor,l=e.container,u=e.outerContainer,h=e.commonLabelOpts||{},f=e.fontFamily||M.HOVERFONT,d=e.fontSize||M.HOVERFONTSIZE,p=t[0],v=p.xa,b=p.ya,x=\"y\"===a?\"yLabel\":\"xLabel\",_=p[x],w=(String(_)||\"\").split(\" \")[0],A=u.node().getBoundingClientRect(),T=A.top,S=A.width,E=A.height,z=p.distance<=M.MAXDIST&&(\"x\"===a||\"y\"===a);for(n=0;n<t.length;n++){i=t[n].hoverinfo||t[n].trace.hoverinfo;var I=i.split(\"+\");if(-1===I.indexOf(\"all\")&&-1===I.indexOf(a)){z=!1;break}}var D=l.selectAll(\"g.axistext\").data(z?[0]:[]);D.enter().append(\"g\").classed(\"axistext\",!0),D.exit().remove(),D.each(function(){var e=c.select(this),n=e.selectAll(\"path\").data([0]),i=e.selectAll(\"text\").data([0]);n.enter().append(\"path\").style({fill:h.bgcolor||y.defaultLine,stroke:h.bordercolor||y.background,\"stroke-width\":\"1px\"}),i.enter().append(\"text\").call(g.font,h.font.family||f,h.font.size||d,h.font.color||y.background).attr(\"data-notex\",1),i.text(_).call(m.positionText,0,0).call(m.convertToTspans,r),e.attr(\"transform\",\"\");var o=i.node().getBoundingClientRect();if(\"x\"===a){i.attr(\"text-anchor\",\"middle\").call(m.positionText,0,\"top\"===v.side?T-o.bottom-L-C:T-o.top+L+C);var s=\"top\"===v.side?\"-\":\"\";n.attr(\"d\",\"M0,0L\"+L+\",\"+s+L+\"H\"+(C+o.width/2)+\"v\"+s+(2*C+o.height)+\"H-\"+(C+o.width/2)+\"V\"+s+L+\"H-\"+L+\"Z\"),e.attr(\"transform\",\"translate(\"+(v._offset+(p.x0+p.x1)/2)+\",\"+(b._offset+(\"top\"===v.side?0:b._length))+\")\")}else{i.attr(\"text-anchor\",\"right\"===b.side?\"start\":\"end\").call(m.positionText,(\"right\"===b.side?1:-1)*(C+L),T-o.top-o.height/2);var l=\"right\"===b.side?\"\":\"-\";n.attr(\"d\",\"M0,0L\"+l+L+\",\"+L+\"V\"+(C+o.height/2)+\"h\"+l+(2*C+o.width)+\"V-\"+(C+o.height/2)+\"H\"+l+L+\"V-\"+L+\"Z\"),e.attr(\"transform\",\"translate(\"+(v._offset+(\"right\"===b.side?v._length:0))+\",\"+(b._offset+(p.y0+p.y1)/2)+\")\")}t=t.filter(function(t){return void 0!==t.zLabelVal||(t[x]||\"\").split(\" \")[0]===w})});var P=l.selectAll(\"g.hovertext\").data(t,function(t){return[t.trace.index,t.index,t.x0,t.y0,t.name,t.attr,t.xa,t.ya||\"\"].join(\",\")});return P.enter().append(\"g\").classed(\"hovertext\",!0).each(function(){var t=c.select(this);t.append(\"rect\").call(y.fill,y.addOpacity(s,.8)),t.append(\"text\").classed(\"name\",!0),t.append(\"path\").style(\"stroke-width\",\"1px\"),t.append(\"text\").classed(\"nums\",!0).call(g.font,f,d)}),P.exit().remove(),P.each(function(t){var e=c.select(this).attr(\"transform\",\"\"),n=\"\",i=\"\",l=y.opacity(t.color)?t.color:y.defaultLine,u=y.combine(l,s),h=t.borderColor||y.contrast(u);if(void 0!==t.nameOverride&&(t.name=t.nameOverride),t.name){n=m.plainText(t.name||\"\");var p=Math.round(t.nameLength);p>-1&&n.length>p&&(n=p>3?n.substr(0,p-3)+\"...\":n.substr(0,p))}void 0!==t.extraText&&(i+=t.extraText),void 0!==t.zLabel?(void 0!==t.xLabel&&(i+=\"x: \"+t.xLabel+\"<br>\"),void 0!==t.yLabel&&(i+=\"y: \"+t.yLabel+\"<br>\"),i+=(i?\"z: \":\"\")+t.zLabel):z&&t[a+\"Label\"]===_?i=t[(\"x\"===a?\"y\":\"x\")+\"Label\"]||\"\":void 0===t.xLabel?void 0!==t.yLabel&&(i=t.yLabel):i=void 0===t.yLabel?t.xLabel:\"(\"+t.xLabel+\", \"+t.yLabel+\")\",t.text&&!Array.isArray(t.text)&&(i+=(i?\"<br>\":\"\")+t.text),\"\"===i&&(\"\"===n&&e.remove(),i=n);var v=e.select(\"text.nums\").call(g.font,t.fontFamily||f,t.fontSize||d,t.fontColor||h).text(i).attr(\"data-notex\",1).call(m.positionText,0,0).call(m.convertToTspans,r),b=e.select(\"text.name\"),x=0;n&&n!==i?(b.call(g.font,t.fontFamily||f,t.fontSize||d,u).text(n).attr(\"data-notex\",1).call(m.positionText,0,0).call(m.convertToTspans,r),x=b.node().getBoundingClientRect().width+2*C):(b.remove(),e.select(\"rect\").remove()),e.select(\"path\").style({fill:u,stroke:h});var w,M,A=v.node().getBoundingClientRect(),I=t.xa._offset+(t.x0+t.x1)/2,D=t.ya._offset+(t.y0+t.y1)/2,P=Math.abs(t.x1-t.x0),O=Math.abs(t.y1-t.y0),R=A.width+L+C+x;t.ty0=T-A.top,t.bx=A.width+2*C,t.by=A.height+2*C,t.anchor=\"start\",t.txwidth=A.width,t.tx2width=x,t.offset=0,o?(t.pos=I,w=D+O/2+R<=E,M=D-O/2-R>=0,\"top\"!==t.idealAlign&&w||!M?w?(D+=O/2,t.anchor=\"start\"):t.anchor=\"middle\":(D-=O/2,t.anchor=\"end\")):(t.pos=D,w=I+P/2+R<=S,M=I-P/2-R>=0,\"left\"!==t.idealAlign&&w||!M?w?(I+=P/2,t.anchor=\"start\"):t.anchor=\"middle\":(I-=P/2,t.anchor=\"end\")),v.attr(\"text-anchor\",t.anchor),x&&b.attr(\"text-anchor\",t.anchor),e.attr(\"transform\",\"translate(\"+I+\",\"+D+\")\"+(o?\"rotate(\"+k+\")\":\"\"))}),P}function a(t,e){function r(t){var e=t[0],r=t[t.length-1];if(i=e.pmin-e.pos-e.dp+e.size,a=r.pos+r.dp+r.size-e.pmax,i>.01){for(s=t.length-1;s>=0;s--)t[s].dp+=i;n=!1}if(!(a<.01)){if(i<-.01){for(s=t.length-1;s>=0;s--)t[s].dp-=a;n=!1}if(n){var u=0;for(o=0;o<t.length;o++)l=t[o],l.pos+l.dp+l.size>e.pmax&&u++;for(o=t.length-1;o>=0&&!(u<=0);o--)l=t[o],l.pos>e.pmax-1&&(l.del=!0,u--);for(o=0;o<t.length&&!(u<=0);o++)if(l=t[o],l.pos<e.pmin+1)for(l.del=!0,u--,a=2*l.size,s=t.length-1;s>=0;s--)t[s].dp-=a;for(o=t.length-1;o>=0&&!(u<=0);o--)l=t[o],l.pos+l.dp+l.size>e.pmax&&(l.del=!0,u--)}}}for(var n,i,a,o,s,l,u,c=0,h=t.map(function(t,r){var n=t[e];return[{i:r,dp:0,pos:t.pos,posref:t.posref,size:t.by*(\"x\"===n._id.charAt(0)?T:1)/2,pmin:n._offset,pmax:n._offset+n._length}]}).sort(function(t,e){return t[0].posref-e[0].posref});!n&&c<=t.length;){for(c++,n=!0,o=0;o<h.length-1;){var f=h[o],d=h[o+1],p=f[f.length-1],m=d[0];if((i=p.pos+p.dp+p.size-m.pos-m.dp+m.size)>.01&&p.pmin===m.pmin&&p.pmax===m.pmax){for(s=d.length-1;s>=0;s--)d[s].dp+=i;for(f.push.apply(f,d),h.splice(o+1,1),u=0,s=f.length-1;s>=0;s--)u+=f[s].dp;for(a=u/f.length,s=f.length-1;s>=0;s--)f[s].dp-=a;n=!1}else o++}h.forEach(r)}for(o=h.length-1;o>=0;o--){var v=h[o];for(s=v.length-1;s>=0;s--){var g=v[s],y=t[g.i];y.offset=g.dp,y.del=g.del}}}function o(t,e){t.each(function(t){var r=c.select(this);if(t.del)return void r.remove();var n=\"end\"===t.anchor?-1:1,i=r.select(\"text.nums\"),a={start:1,end:-1,middle:0}[t.anchor],o=a*(L+C),s=o+a*(t.txwidth+C),l=0,u=t.offset;\"middle\"===t.anchor&&(o-=t.tx2width/2,s-=t.tx2width/2),e&&(u*=-E,l=t.offset*S),r.select(\"path\").attr(\"d\",\"middle\"===t.anchor?\"M-\"+t.bx/2+\",-\"+t.by/2+\"h\"+t.bx+\"v\"+t.by+\"h-\"+t.bx+\"Z\":\"M0,0L\"+(n*L+l)+\",\"+(L+u)+\"v\"+(t.by/2-L)+\"h\"+n*t.bx+\"v-\"+t.by+\"H\"+(n*L+l)+\"V\"+(u-L)+\"Z\"),i.call(m.positionText,o+l,u+t.ty0-t.by/2+C),t.tx2width&&(r.select(\"text.name\").call(m.positionText,s+a*C+l,u+t.ty0-t.by/2+C),r.select(\"rect\").call(g.setRect,s+(a-1)*t.tx2width/2+l,u-t.by/2-1,t.tx2width,t.by+2))})}function s(t,e){function r(e,r,o){var s;if(a[r])s=a[r];else if(i[r]){var l=i[r];Array.isArray(l)&&Array.isArray(l[t.index[0]])&&(s=l[t.index[0]][t.index[1]])}else s=d.nestedProperty(n,o).get();s&&(t[e]=s)}var n=t.trace||{},i=t.cd[0],a=t.cd[t.index]||{};r(\"hoverinfo\",\"hi\",\"hoverinfo\"),r(\"color\",\"hbg\",\"hoverlabel.bgcolor\"),r(\"borderColor\",\"hbc\",\"hoverlabel.bordercolor\"),r(\"fontFamily\",\"htf\",\"hoverlabel.font.family\"),r(\"fontSize\",\"hts\",\"hoverlabel.font.size\"),r(\"fontColor\",\"htc\",\"hoverlabel.font.color\"),r(\"nameLength\",\"hnl\",\"hoverlabel.namelength\"),t.posref=\"y\"===e?(t.x0+t.x1)/2:(t.y0+t.y1)/2,t.x0=d.constrain(t.x0,0,t.xa._length),t.x1=d.constrain(t.x1,0,t.xa._length),t.y0=d.constrain(t.y0,0,t.ya._length),t.y1=d.constrain(t.y1,0,t.ya._length);var o;if(void 0!==t.xLabelVal){o=\"log\"===t.xa.type&&t.xLabelVal<=0;var s=x.tickText(t.xa,t.xa.c2l(o?-t.xLabelVal:t.xLabelVal),\"hover\");o?0===t.xLabelVal?t.xLabel=\"0\":t.xLabel=\"-\"+s.text:t.xLabel=s.text,t.xVal=t.xa.c2d(t.xLabelVal)}if(void 0!==t.yLabelVal){o=\"log\"===t.ya.type&&t.yLabelVal<=0;var l=x.tickText(t.ya,t.ya.c2l(o?-t.yLabelVal:t.yLabelVal),\"hover\");o?0===t.yLabelVal?t.yLabel=\"0\":t.yLabel=\"-\"+l.text:t.yLabel=l.text,t.yVal=t.ya.c2d(t.yLabelVal)}if(void 0!==t.zLabelVal&&(t.zLabel=String(t.zLabelVal)),!(isNaN(t.xerr)||\"log\"===t.xa.type&&t.xerr<=0)){var u=x.tickText(t.xa,t.xa.c2l(t.xerr),\"hover\").text;void 0!==t.xerrneg?t.xLabel+=\" +\"+u+\" / -\"+x.tickText(t.xa,t.xa.c2l(t.xerrneg),\"hover\").text:t.xLabel+=\" \\xb1 \"+u,\"x\"===e&&(t.distance+=1)}if(!(isNaN(t.yerr)||\"log\"===t.ya.type&&t.yerr<=0)){var c=x.tickText(t.ya,t.ya.c2l(t.yerr),\"hover\").text;void 0!==t.yerrneg?t.yLabel+=\" +\"+c+\" / -\"+x.tickText(t.ya,t.ya.c2l(t.yerrneg),\"hover\").text:t.yLabel+=\" \\xb1 \"+c,\"y\"===e&&(t.distance+=1)}var h=t.hoverinfo||t.trace.hoverinfo;return\"all\"!==h&&(h=h.split(\"+\"),-1===h.indexOf(\"x\")&&(t.xLabel=void 0),-1===h.indexOf(\"y\")&&(t.yLabel=void 0),-1===h.indexOf(\"z\")&&(t.zLabel=void 0),-1===h.indexOf(\"text\")&&(t.text=void 0),-1===h.indexOf(\"name\")&&(t.name=void 0)),t}function l(t,e){var r=e.hovermode,n=e.container,i=t[0],a=i.xa,o=i.ya,s=a.showspikes,l=o.showspikes;if(n.selectAll(\".spikeline\").remove(),\"closest\"===r&&(s||l)){var u=e.fullLayout,c=a._offset+(i.x0+i.x1)/2,h=o._offset+(i.y0+i.y1)/2,d=y.combine(u.plot_bgcolor,u.paper_bgcolor),p=f.readability(i.color,d)<1.5?y.contrast(d):i.color;if(l){var m=o.spikemode,v=o.spikethickness,b=o.spikecolor||p,x=o._boundingBox,_=(x.left+x.right)/2<c?x.right:x.left;if(-1!==m.indexOf(\"toaxis\")||-1!==m.indexOf(\"across\")){var w=_,M=c;-1!==m.indexOf(\"across\")&&(w=o._counterSpan[0],M=o._counterSpan[1]),n.append(\"line\").attr({x1:w,x2:M,y1:h,y2:h,\"stroke-width\":v+2,stroke:d}).classed(\"spikeline\",!0).classed(\"crisp\",!0),n.append(\"line\").attr({x1:w,x2:M,y1:h,y2:h,\"stroke-width\":v,stroke:b,\"stroke-dasharray\":g.dashStyle(o.spikedash,v)}).classed(\"spikeline\",!0).classed(\"crisp\",!0)}-1!==m.indexOf(\"marker\")&&n.append(\"circle\").attr({cx:_+(\"right\"!==o.side?v:-v),cy:h,r:v,fill:b}).classed(\"spikeline\",!0)}if(s){var k=a.spikemode,A=a.spikethickness,T=a.spikecolor||p,S=a._boundingBox,E=(S.top+S.bottom)/2<h?S.bottom:S.top;if(-1!==k.indexOf(\"toaxis\")||-1!==k.indexOf(\"across\")){var L=E,C=h;-1!==k.indexOf(\"across\")&&(L=a._counterSpan[0],C=a._counterSpan[1]),n.append(\"line\").attr({x1:c,x2:c,y1:L,y2:C,\"stroke-width\":A+2,stroke:d}).classed(\"spikeline\",!0).classed(\"crisp\",!0),n.append(\"line\").attr({x1:c,x2:c,y1:L,y2:C,\"stroke-width\":A,stroke:T,\"stroke-dasharray\":g.dashStyle(a.spikedash,A)}).classed(\"spikeline\",!0).classed(\"crisp\",!0)}-1!==k.indexOf(\"marker\")&&n.append(\"circle\").attr({cx:c,cy:E-(\"top\"!==a.side?A:-A),r:A,fill:T}).classed(\"spikeline\",!0)}}}function u(t,e,r){if(!r||r.length!==t._hoverdata.length)return!0;for(var n=r.length-1;n>=0;n--){var i=r[n],a=t._hoverdata[n];if(i.curveNumber!==a.curveNumber||String(i.pointNumber)!==String(a.pointNumber))return!0}return!1}var c=t(\"d3\"),h=t(\"fast-isnumeric\"),f=t(\"tinycolor2\"),d=t(\"../../lib\"),p=t(\"../../lib/events\"),m=t(\"../../lib/svg_text_utils\"),v=t(\"../../lib/override_cursor\"),g=t(\"../drawing\"),y=t(\"../color\"),b=t(\"../dragelement\"),x=t(\"../../plots/cartesian/axes\"),_=t(\"../../registry\"),w=t(\"./helpers\"),M=t(\"./constants\"),k=M.YANGLE,A=Math.PI*k/180,T=1/Math.sin(A),S=Math.cos(A),E=Math.sin(A),L=M.HOVERARROWSIZE,C=M.HOVERTEXTPAD;r.hover=function(t,e,r,i){if(\"string\"==typeof t&&(t=document.getElementById(t)),void 0===t._lastHoverTime&&(t._lastHoverTime=0),void 0!==t._hoverTimer&&(clearTimeout(t._hoverTimer),t._hoverTimer=void 0),Date.now()>t._lastHoverTime+M.HOVERMINTIME)return n(t,e,r,i),void(t._lastHoverTime=Date.now());t._hoverTimer=setTimeout(function(){n(t,e,r,i),t._lastHoverTime=Date.now(),t._hoverTimer=void 0},M.HOVERMINTIME)},r.loneHover=function(t,e){var r={color:t.color||y.defaultLine,x0:t.x0||t.x||0,x1:t.x1||t.x||0,y0:t.y0||t.y||0,y1:t.y1||t.y||0,xLabel:t.xLabel,yLabel:t.yLabel,zLabel:t.zLabel,text:t.text,name:t.name,idealAlign:t.idealAlign,borderColor:t.borderColor,fontFamily:t.fontFamily,fontSize:t.fontSize,fontColor:t.fontColor,trace:{index:0,hoverinfo:\"\"},xa:{_offset:0},ya:{_offset:0},index:0},n=c.select(e.container),a=e.outerContainer?c.select(e.outerContainer):n,s={hovermode:\"closest\",rotateLabels:!1,bgColor:e.bgColor||y.background,container:n,outerContainer:a},l=i([r],s,e.gd);return o(l,s.rotateLabels),l.node()}},{\"../../lib\":725,\"../../lib/events\":715,\"../../lib/override_cursor\":735,\"../../lib/svg_text_utils\":745,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":639,\"./helpers\":641,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],643:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r,i){i=i||{},r(\"hoverlabel.bgcolor\",i.bgcolor),r(\"hoverlabel.bordercolor\",i.bordercolor),r(\"hoverlabel.namelength\",i.namelength),n.coerceFont(r,\"hoverlabel.font\",i.font)}},{\"../../lib\":725}],644:[function(t,e,r){\"use strict\";function n(t){var e=s.isD3Selection(t)?t:o.select(t);e.selectAll(\"g.hovertext\").remove(),e.selectAll(\".spikeline\").remove()}function i(t,e,r){return s.castOption(t,e,\"hoverlabel.\"+r)}function a(t,e,r){function n(r){return s.coerceHoverinfo({hoverinfo:r},{_module:t._module},e)}return s.castOption(t,r,\"hoverinfo\",n)}var o=t(\"d3\"),s=t(\"../../lib\"),l=t(\"../dragelement\"),u=t(\"./helpers\"),c=t(\"./layout_attributes\");e.exports={moduleType:\"component\",name:\"fx\",constants:t(\"./constants\"),schema:{layout:c},attributes:t(\"./attributes\"),layoutAttributes:c,supplyLayoutGlobalDefaults:t(\"./layout_global_defaults\"),supplyDefaults:t(\"./defaults\"),supplyLayoutDefaults:t(\"./layout_defaults\"),calc:t(\"./calc\"),getDistanceFunction:u.getDistanceFunction,getClosest:u.getClosest,inbox:u.inbox,appendArrayPointValue:u.appendArrayPointValue,castHoverOption:i,castHoverinfo:a,hover:t(\"./hover\").hover,unhover:l.unhover,loneHover:t(\"./hover\").loneHover,loneUnhover:n,click:t(\"./click\")}},{\"../../lib\":725,\"../dragelement\":624,\"./attributes\":636,\"./calc\":637,\"./click\":638,\"./constants\":639,\"./defaults\":640,\"./helpers\":641,\"./hover\":642,\"./layout_attributes\":645,\"./layout_defaults\":646,\"./layout_global_defaults\":647,d3:121}],645:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"./constants\");e.exports={dragmode:{valType:\"enumerated\",values:[\"zoom\",\"pan\",\"select\",\"lasso\",\"orbit\",\"turntable\"],dflt:\"zoom\"},hovermode:{valType:\"enumerated\",values:[\"x\",\"y\",\"closest\",!1]},hoverlabel:{bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\"},font:{family:n({},i.family,{dflt:a.HOVERFONT}),size:n({},i.size,{dflt:a.HOVERFONTSIZE}),color:n({},i.color)},namelength:{valType:\"integer\",min:-1,dflt:15}}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"./constants\":639}],646:[function(t,e,r){\"use strict\";function n(t){for(var e=!0,r=0;r<t.length;r++){if(\"h\"!==t[r].orientation){e=!1;break}}return e}var i=t(\"../../lib\"),a=t(\"./layout_attributes\");e.exports=function(t,e,r){function o(r,n){return i.coerce(t,e,a,r,n)}o(\"dragmode\");var s;e._has(\"cartesian\")?(e._isHoriz=n(r),s=e._isHoriz?\"y\":\"x\"):s=\"closest\",o(\"hovermode\",s),e._has(\"mapbox\")&&1===e._basePlotModules.length&&\"zoom\"===e.dragmode&&(e.dragmode=\"pan\")}},{\"../../lib\":725,\"./layout_attributes\":645}],647:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./hoverlabel_defaults\"),a=t(\"./layout_attributes\");e.exports=function(t,e){function r(r,i){return n.coerce(t,e,a,r,i)}i(t,e,r)}},{\"../../lib\":725,\"./hoverlabel_defaults\":643,\"./layout_attributes\":645}],648:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/constants\");e.exports={_isLinkedToArray:\"image\",visible:{valType:\"boolean\",dflt:!0},source:{valType:\"string\"},layer:{valType:\"enumerated\",values:[\"below\",\"above\"],dflt:\"above\"},sizex:{valType:\"number\",dflt:0},sizey:{valType:\"number\",dflt:0},sizing:{valType:\"enumerated\",values:[\"fill\",\"contain\",\"stretch\"],dflt:\"contain\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},x:{valType:\"any\",dflt:0},y:{valType:\"any\",dflt:0},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},yanchor:{valType:\"enumerated\",values:[\"top\",\"middle\",\"bottom\"],dflt:\"top\"},xref:{valType:\"enumerated\",values:[\"paper\",n.idRegex.x.toString()],dflt:\"paper\"},yref:{valType:\"enumerated\",values:[\"paper\",n.idRegex.y.toString()],dflt:\"paper\"}}},{\"../../plots/cartesian/constants\":771}],649:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib/to_log_range\");e.exports=function(t,e,r,a){e=e||{};var o=\"log\"===r&&\"linear\"===e.type,s=\"linear\"===r&&\"log\"===e.type;if(o||s)for(var l,u,c=t._fullLayout.images,h=e._id.charAt(0),f=0;f<c.length;f++)if(l=c[f],u=\"images[\"+f+\"].\",l[h+\"ref\"]===e._id){var d=l[h],p=l[\"size\"+h],m=null,v=null;if(o){m=i(d,e.range);var g=p/Math.pow(10,m)/2;v=2*Math.log(g+Math.sqrt(1+g*g))/Math.LN10}else m=Math.pow(10,d),v=m*(Math.pow(10,p/2)-Math.pow(10,-p/2));n(m)?n(v)||(v=null):(m=null,v=null),a(u+h,m),a(u+\"size\"+h,v)}}},{\"../../lib/to_log_range\":746,\"fast-isnumeric\":130}],650:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return i.coerce(t,e,s,r,n)}if(!n(\"visible\",!!n(\"source\")))return e;n(\"layer\"),n(\"xanchor\"),n(\"yanchor\"),n(\"sizex\"),n(\"sizey\"),n(\"sizing\"),n(\"opacity\");for(var o={_fullLayout:r},l=[\"x\",\"y\"],u=0;u<2;u++){var c=l[u],h=a.coerceRef(t,e,o,c,\"paper\");a.coercePosition(e,o,n,h,c,0)}return e}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\");e.exports=function(t,e){o(t,e,{name:\"images\",handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"../../plots/cartesian/axes\":766,\"./attributes\":648}],651:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../drawing\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../constants/xmlns_namespaces\");e.exports=function(t){function e(e){var r=n.select(this);if(!this.img||this.img.src!==e.source){r.attr(\"xmlns\",o.svg);var i=new Promise(function(t){function n(){r.remove(),t()}var i=new Image;this.img=i,i.setAttribute(\"crossOrigin\",\"anonymous\"),i.onerror=n,i.onload=function(){var e=document.createElement(\"canvas\");e.width=this.width,e.height=this.height,e.getContext(\"2d\").drawImage(this,0,0);var n=e.toDataURL(\"image/png\");r.attr(\"xlink:href\",n),t()},r.on(\"error\",n),i.src=e.source}.bind(this));t._promises.push(i)}}function r(e){var r=n.select(this),o=a.getFromId(t,e.xref),s=a.getFromId(t,e.yref),l=u._size,c=o?Math.abs(o.l2p(e.sizex)-o.l2p(0)):e.sizex*l.w,h=s?Math.abs(s.l2p(e.sizey)-s.l2p(0)):e.sizey*l.h,f=c*m.x[e.xanchor].offset,d=h*m.y[e.yanchor].offset,p=m.x[e.xanchor].sizing+m.y[e.yanchor].sizing,v=(o?o.r2p(e.x)+o._offset:e.x*l.w+l.l)+f,g=(s?s.r2p(e.y)+s._offset:l.h-e.y*l.h+l.t)+d;switch(e.sizing){case\"fill\":p+=\" slice\";break;case\"stretch\":p=\"none\"}r.attr({x:v,y:g,width:c,height:h,preserveAspectRatio:p,opacity:e.opacity});var y=o?o._id:\"\",b=s?s._id:\"\",x=y+b;r.call(i.setClipUrl,x?\"clip\"+u._uid+x:null)}var s,l,u=t._fullLayout,c=[],h={},f=[];for(l=0;l<u.images.length;l++){var d=u.images[l];if(d.visible)if(\"below\"===d.layer&&\"paper\"!==d.xref&&\"paper\"!==d.yref){s=d.xref+d.yref;var p=u._plots[s];if(!p){f.push(d);continue}p.mainplot&&(s=p.mainplot.id),h[s]||(h[s]=[]),h[s].push(d)}else\"above\"===d.layer?c.push(d):f.push(d)}var m={x:{left:{sizing:\"xMin\",offset:0},center:{sizing:\"xMid\",offset:-.5},right:{sizing:\"xMax\",offset:-1}},y:{top:{sizing:\"YMin\",offset:0},middle:{sizing:\"YMid\",offset:-.5},bottom:{sizing:\"YMax\",offset:-1}}},v=u._imageLowerLayer.selectAll(\"image\").data(f),g=u._imageUpperLayer.selectAll(\"image\").data(c);v.enter().append(\"image\"),g.enter().append(\"image\"),v.exit().remove(),g.exit().remove(),v.each(function(t){e.bind(this)(t),r.bind(this)(t)}),g.each(function(t){e.bind(this)(t),r.bind(this)(t)});var y=Object.keys(u._plots);for(l=0;l<y.length;l++){s=y[l];var b=u._plots[s];if(b.imagelayer){var x=b.imagelayer.selectAll(\"image\").data(h[s]||[]);x.enter().append(\"image\"),x.exit().remove(),x.each(function(t){e.bind(this)(t),r.bind(this)(t)})}}}},{\"../../constants/xmlns_namespaces\":707,\"../../plots/cartesian/axes\":766,\"../drawing\":627,d3:121}],652:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"images\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\"),convertCoords:t(\"./convert_coords\")}},{\"./attributes\":648,\"./convert_coords\":649,\"./defaults\":650,\"./draw\":651}],653:[function(t,e,r){\"use strict\";r.isRightAnchor=function(t){return\"right\"===t.xanchor||\"auto\"===t.xanchor&&t.x>=2/3},r.isCenterAnchor=function(t){return\"center\"===t.xanchor||\"auto\"===t.xanchor&&t.x>1/3&&t.x<2/3},r.isBottomAnchor=function(t){return\"bottom\"===t.yanchor||\"auto\"===t.yanchor&&t.y<=1/3},r.isMiddleAnchor=function(t){return\"middle\"===t.yanchor||\"auto\"===t.yanchor&&t.y>1/3&&t.y<2/3}},{}],654:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat;e.exports={bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.defaultLine},borderwidth:{valType:\"number\",min:0,dflt:0},font:a({},n,{}),orientation:{valType:\"enumerated\",values:[\"v\",\"h\"],dflt:\"v\"},traceorder:{valType:\"flaglist\",flags:[\"reversed\",\"grouped\"],extras:[\"normal\"]},tracegroupgap:{valType:\"number\",min:0,dflt:10},x:{valType:\"number\",min:-2,max:3,dflt:1.02},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3,dflt:1},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"auto\"}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../color/attributes\":602}],655:[function(t,e,r){\"use strict\";e.exports={scrollBarWidth:4,scrollBarHeight:20,scrollBarColor:\"#808BA4\",scrollBarMargin:4}},{}],656:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"./attributes\"),o=t(\"../../plots/layout_attributes\"),s=t(\"./helpers\");e.exports=function(t,e,r){function l(t,e){return i.coerce(d,p,a,t,e)}for(var u,c,h,f,d=t.legend||{},p=e.legend={},m=0,v=\"normal\",g=0;g<r.length;g++){var y=r[g];s.legendGetsTrace(y)&&(m++,n.traceIs(y,\"pie\")&&m++),(n.traceIs(y,\"bar\")&&\"stack\"===e.barmode||-1!==[\"tonextx\",\"tonexty\"].indexOf(y.fill))&&(v=s.isGrouped({traceorder:v})?\"grouped+reversed\":\"reversed\"),void 0!==y.legendgroup&&\"\"!==y.legendgroup&&(v=s.isReversed({traceorder:v})?\"reversed+grouped\":\"grouped\")}if(!1!==i.coerce(t,e,o,\"showlegend\",m>1)){if(l(\"bgcolor\",e.paper_bgcolor),l(\"bordercolor\"),l(\"borderwidth\"),i.coerceFont(l,\"font\",e.font),l(\"orientation\"),\"h\"===p.orientation){var b=t.xaxis;b&&b.rangeslider&&b.rangeslider.visible?(u=0,h=\"left\",c=1.1,f=\"bottom\"):(u=0,h=\"left\",c=-.1,f=\"top\")}l(\"traceorder\",v),s.isGrouped(e.legend)&&l(\"tracegroupgap\"),l(\"x\",u),l(\"xanchor\",h),l(\"y\",c),l(\"yanchor\",f),i.noneOrAll(d,p,[\"x\",\"y\"])}}},{\"../../lib\":725,\"../../plots/layout_attributes\":820,\"../../registry\":844,\"./attributes\":654,\"./helpers\":659}],657:[function(t,e,r){\"use strict\";function n(t,e){function r(r){y.convertToTspans(r,e,function(){o(t,e)})}var n=t.data()[0][0],i=e._fullLayout,a=n.trace,s=p.traceIs(a,\"pie\"),l=a.index,u=s?n.label:a.name,c=t.selectAll(\"text.legendtext\").data([0]);c.enter().append(\"text\").classed(\"legendtext\",!0),c.attr(\"text-anchor\",\"start\").classed(\"user-select-none\",!0).call(v.font,i.legend.font).text(u),e._context.edits.legendText&&!s?c.call(y.makeEditable,{gd:e}).call(r).on(\"edit\",function(t){this.text(t).call(r);var i=t;this.text()||(t=\"    \");var a,o,s=n.trace._fullInput||{},u={};if(-1!==[\"ohlc\",\"candlestick\"].indexOf(s.type))a=n.trace.transforms,o=a[a.length-1].direction,u[o+\".name\"]=t;else if(p.hasTransform(s,\"groupby\")){var c=p.getTransformIndices(s,\"groupby\"),d=c[c.length-1],m=f.keyedContainer(s,\"transforms[\"+d+\"].styles\",\"target\",\"value.name\");\"\"===i?m.remove(n.trace._group):m.set(n.trace._group,t),u=m.constructUpdate()}else u.name=t;return h.restyle(e,u,l)}):c.call(r)}function i(t,e){var r,n=1,i=t.selectAll(\"rect\").data([0]);i.enter().append(\"rect\").classed(\"legendtoggle\",!0).style(\"cursor\",\"pointer\").attr(\"pointer-events\",\"all\").call(g.fill,\"rgba(0,0,0,0)\"),i.on(\"mousedown\",function(){r=(new Date).getTime(),r-e._legendMouseDownTime<S?n+=1:(n=1,e._legendMouseDownTime=r)}),i.on(\"mouseup\",function(){if(!e._dragged&&!e._editing){var r=e._fullLayout.legend;(new Date).getTime()-e._legendMouseDownTime>S&&(n=Math.max(n-1,1)),1===n?r._clickTimeout=setTimeout(function(){a(t,e,n)},S):2===n&&(r._clickTimeout&&clearTimeout(r._clickTimeout),e._legendMouseDownTime=0,a(t,e,n))}})}function a(t,e,r){if(!e._dragged&&!e._editing){var n,i,a=e._fullLayout.hiddenlabels?e._fullLayout.hiddenlabels.slice():[],o=t.data()[0][0],s=e._fullData,l=o.trace,u=l.legendgroup,c=[];if(1===r&&T&&e.data&&e._context.showTips?(f.notifier(\"Double click on legend to isolate individual trace\",\"long\"),T=!1):T=!1,p.traceIs(l,\"pie\")){var d=o.label,m=a.indexOf(d);1===r?-1===m?a.push(d):a.splice(m,1):2===r&&(a=[],e.calcdata[0].forEach(function(t){d!==t.label&&a.push(t.label)}),e._fullLayout.hiddenlabels&&e._fullLayout.hiddenlabels.length===a.length&&-1===m&&(a=[])),h.relayout(e,\"hiddenlabels\",a)}else{var v,g=[],y=[];for(v=0;v<s.length;v++)g.push(v),y.push(!!p.traceIs(s[v],\"notLegendIsolatable\")||\"legendonly\");if(\"\"===u)c=[l.index],y[l.index]=!0;else for(v=0;v<s.length;v++)n=s[v],n.legendgroup===u&&(c.push(n.index),y[g.indexOf(v)]=!0);if(1===r)i=!0!==l.visible||\"legendonly\",h.restyle(e,\"visible\",i,c);else if(2===r){var b=!0;for(v=0;v<s.length;v++)if(s[v].visible!==y[v]){b=!1;break}b&&(y=!0);var x=[];for(v=0;v<s.length;v++)x.push(g[v]);h.restyle(e,\"visible\",y,x)}}}}function o(t,e){var r=t.data()[0][0];if(!r.trace.showlegend)return void t.remove();var n,i,a=t.select(\"g[class*=math-group]\"),o=a.node(),s=e._fullLayout.legend,l=s.font.size*_;if(o){var u=v.bBox(o);n=u.height,i=u.width,v.setTranslate(a,0,n/4)}else{var c=t.select(\".legendtext\"),h=y.lineCount(c),f=c.node();n=l*h,i=f?v.bBox(f).width:0;var d=l*(.3+(1-h)/2);y.positionText(c,40,d)}n=Math.max(n,16)+3,r.height=n,r.width=i}function s(t,e,r){var n=t._fullLayout,i=n.legend,a=i.borderwidth,o=k.isGrouped(i),s=0;if(i.width=0,i.height=0,k.isVertical(i))o&&e.each(function(t,e){v.setTranslate(this,0,e*i.tracegroupgap)}),r.each(function(t){var e=t[0],r=e.height,n=e.width;v.setTranslate(this,a,5+a+i.height+r/2),i.height+=r,i.width=Math.max(i.width,n)}),i.width+=45+2*a,i.height+=10+2*a,o&&(i.height+=(i._lgroupsLength-1)*i.tracegroupgap),s=40;else if(o){for(var l=[i.width],u=e.data(),h=0,f=u.length;h<f;h++){var d=u[h].map(function(t){return t[0].width}),p=40+Math.max.apply(null,d);i.width+=i.tracegroupgap+p,l.push(i.width)}e.each(function(t,e){v.setTranslate(this,l[e],0)}),e.each(function(){var t=c.select(this),e=t.selectAll(\"g.traces\"),r=0;e.each(function(t){var e=t[0],n=e.height;v.setTranslate(this,0,5+a+r+n/2),r+=n}),i.height=Math.max(i.height,r)}),i.height+=10+2*a,i.width+=2*a}else{var m=0,g=0,y=0,b=0;r.each(function(t){y=Math.max(40+t[0].width,y)}),r.each(function(t){var e=t[0],r=y,o=i.tracegroupgap||5;a+b+o+r>n.width-(n.margin.r+n.margin.l)&&(b=0,m+=g,i.height=i.height+g,g=0),v.setTranslate(this,a+b,5+a+e.height/2+m),i.width+=o+r,i.height=Math.max(i.height,e.height),b+=o+r,g=Math.max(e.height,g)}),i.width+=2*a,i.height+=10+2*a}i.width=Math.ceil(i.width),i.height=Math.ceil(i.height),r.each(function(e){var r=e[0];c.select(this).select(\".legendtoggle\").call(v.setRect,0,-r.height/2,(t._context.edits.legendText?0:i.width)+s,r.height)})}function l(t){var e=t._fullLayout,r=e.legend,n=\"left\";A.isRightAnchor(r)?n=\"right\":A.isCenterAnchor(r)&&(n=\"center\");var i=\"top\";A.isBottomAnchor(r)?i=\"bottom\":A.isMiddleAnchor(r)&&(i=\"middle\"),d.autoMargin(t,\"legend\",{x:r.x,y:r.y,l:r.width*({right:1,center:.5}[n]||0),r:r.width*({left:1,center:.5}[n]||0),b:r.height*({top:1,middle:.5}[i]||0),t:r.height*({bottom:1,middle:.5}[i]||0)})}function u(t){var e=t._fullLayout,r=e.legend,n=\"left\";A.isRightAnchor(r)?n=\"right\":A.isCenterAnchor(r)&&(n=\"center\"),d.autoMargin(t,\"legend\",{x:r.x,y:.5,l:r.width*({right:1,center:.5}[n]||0),r:r.width*({left:1,center:.5}[n]||0),b:0,t:0})}var c=t(\"d3\"),h=t(\"../../plotly\"),f=t(\"../../lib\"),d=t(\"../../plots/plots\"),p=t(\"../../registry\"),m=t(\"../dragelement\"),v=t(\"../drawing\"),g=t(\"../color\"),y=t(\"../../lib/svg_text_utils\"),b=t(\"./constants\"),x=t(\"../../constants/interactions\"),_=t(\"../../constants/alignment\").LINE_SPACING,w=t(\"./get_legend_data\"),M=t(\"./style\"),k=t(\"./helpers\"),A=t(\"./anchor_utils\"),T=!0,S=x.DBLCLICKDELAY;e.exports=function(t){function e(t,e){L.attr(\"data-scroll\",e).call(v.setTranslate,0,e),C.call(v.setRect,N,t,b.scrollBarWidth,b.scrollBarHeight),T.select(\"rect\").attr({y:y.borderwidth-e})}var r=t._fullLayout,o=\"legend\"+r._uid;if(r._infolayer&&t.calcdata){t._legendMouseDownTime||(t._legendMouseDownTime=0);var y=r.legend,x=r.showlegend&&w(t.calcdata,y),_=r.hiddenlabels||[];if(!r.showlegend||!x.length)return r._infolayer.selectAll(\".legend\").remove(),r._topdefs.select(\"#\"+o).remove(),void d.autoMargin(t,\"legend\");var k=r._infolayer.selectAll(\"g.legend\").data([0]);k.enter().append(\"g\").attr({class:\"legend\",\"pointer-events\":\"all\"});var T=r._topdefs.selectAll(\"#\"+o).data([0]);T.enter().append(\"clipPath\").attr(\"id\",o).append(\"rect\");var E=k.selectAll(\"rect.bg\").data([0]);E.enter().append(\"rect\").attr({class:\"bg\",\"shape-rendering\":\"crispEdges\"}),E.call(g.stroke,y.bordercolor),E.call(g.fill,y.bgcolor),E.style(\"stroke-width\",y.borderwidth+\"px\");var L=k.selectAll(\"g.scrollbox\").data([0]);L.enter().append(\"g\").attr(\"class\",\"scrollbox\");var C=k.selectAll(\"rect.scrollbar\").data([0]);C.enter().append(\"rect\").attr({class:\"scrollbar\",rx:20,ry:2,width:0,height:0}).call(g.fill,\"#808BA4\");var z=L.selectAll(\"g.groups\").data(x);z.enter().append(\"g\").attr(\"class\",\"groups\"),z.exit().remove();var I=z.selectAll(\"g.traces\").data(f.identity);I.enter().append(\"g\").attr(\"class\",\"traces\"),I.exit().remove(),I.call(M,t).style(\"opacity\",function(t){var e=t[0].trace;return p.traceIs(e,\"pie\")?-1!==_.indexOf(t[0].label)?.5:1:\"legendonly\"===e.visible?.5:1}).each(function(){c.select(this).call(n,t).call(i,t)});var D=0!==k.enter().size();D&&(s(t,z,I),l(t));var P=r.width,O=r.height;s(t,z,I),y.height>O?u(t):l(t);var R=r._size,F=R.l+R.w*y.x,j=R.t+R.h*(1-y.y);A.isRightAnchor(y)?F-=y.width:A.isCenterAnchor(y)&&(F-=y.width/2),A.isBottomAnchor(y)?j-=y.height:A.isMiddleAnchor(y)&&(j-=y.height/2);var N=y.width,B=R.w;N>B?(F=R.l,N=B):(F+N>P&&(F=P-N),F<0&&(F=0),N=Math.min(P-F,y.width));var U=y.height,V=R.h;U>V?(j=R.t,U=V):(j+U>O&&(j=O-U),j<0&&(j=0),U=Math.min(O-j,y.height)),v.setTranslate(k,F,j);var H,q,G=U-b.scrollBarHeight-2*b.scrollBarMargin,Y=y.height-U;if(y.height<=U||t._context.staticPlot)E.attr({width:N-y.borderwidth,height:U-y.borderwidth,x:y.borderwidth/2,y:y.borderwidth/2}),v.setTranslate(L,0,0),T.select(\"rect\").attr({width:N-2*y.borderwidth,height:U-2*y.borderwidth,x:y.borderwidth,y:y.borderwidth}),\n",
       "L.call(v.setClipUrl,o);else{H=b.scrollBarMargin,q=L.attr(\"data-scroll\")||0,E.attr({width:N-2*y.borderwidth+b.scrollBarWidth+b.scrollBarMargin,height:U-y.borderwidth,x:y.borderwidth/2,y:y.borderwidth/2}),T.select(\"rect\").attr({width:N-2*y.borderwidth+b.scrollBarWidth+b.scrollBarMargin,height:U-2*y.borderwidth,x:y.borderwidth,y:y.borderwidth-q}),L.call(v.setClipUrl,o),D&&e(H,q),k.on(\"wheel\",null),k.on(\"wheel\",function(){q=f.constrain(L.attr(\"data-scroll\")-c.event.deltaY/G*Y,-Y,0),H=b.scrollBarMargin-q/Y*G,e(H,q),0!==q&&q!==-Y&&c.event.preventDefault()}),C.on(\".drag\",null),L.on(\".drag\",null);var X=c.behavior.drag().on(\"drag\",function(){H=f.constrain(c.event.y-b.scrollBarHeight/2,b.scrollBarMargin,b.scrollBarMargin+G),q=-(H-b.scrollBarMargin)/G*Y,e(H,q)});C.call(X),L.call(X)}if(t._context.edits.legendPosition){var W,Z,J,K;k.classed(\"cursor-move\",!0),m.init({element:k.node(),gd:t,prepFn:function(){var t=v.getTranslate(k);J=t.x,K=t.y},moveFn:function(t,e){var r=J+t,n=K+e;v.setTranslate(k,r,n),W=m.align(r,0,R.l,R.l+R.w,y.xanchor),Z=m.align(n,0,R.t+R.h,R.t,y.yanchor)},doneFn:function(e,n,i){if(e&&void 0!==W&&void 0!==Z)h.relayout(t,{\"legend.x\":W,\"legend.y\":Z});else{var o=r._infolayer.selectAll(\"g.traces\").filter(function(){var t=this.getBoundingClientRect();return i.clientX>=t.left&&i.clientX<=t.right&&i.clientY>=t.top&&i.clientY<=t.bottom});o.size()>0&&(1===n?k._clickTimeout=setTimeout(function(){a(o,t,n)},S):2===n&&(k._clickTimeout&&clearTimeout(k._clickTimeout),a(o,t,n)))}}})}}}},{\"../../constants/alignment\":699,\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/plots\":829,\"../../registry\":844,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./anchor_utils\":653,\"./constants\":655,\"./get_legend_data\":658,\"./helpers\":659,\"./style\":661,d3:121}],658:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"./helpers\");e.exports=function(t,e){function r(t,r){if(\"\"!==t&&i.isGrouped(e))-1===l.indexOf(t)?(l.push(t),u=!0,s[t]=[[r]]):s[t].push([r]);else{var n=\"~~i\"+h;l.push(n),s[n]=[[r]],h++}}var a,o,s={},l=[],u=!1,c={},h=0;for(a=0;a<t.length;a++){var f=t[a],d=f[0],p=d.trace,m=p.legendgroup;if(i.legendGetsTrace(p)&&p.showlegend)if(n.traceIs(p,\"pie\"))for(c[m]||(c[m]={}),o=0;o<f.length;o++){var v=f[o].label;c[m][v]||(r(m,{label:v,color:f[o].color,i:f[o].i,trace:p}),c[m][v]=!0)}else r(m,d)}if(!l.length)return[];var g,y,b=l.length;if(u&&i.isGrouped(e))for(y=new Array(b),a=0;a<b;a++)g=s[l[a]],y[a]=i.isReversed(e)?g.reverse():g;else{for(y=[new Array(b)],a=0;a<b;a++)g=s[l[a]][0],y[0][i.isReversed(e)?b-a-1:a]=g;b=1}return e._lgroupsLength=b,y}},{\"../../registry\":844,\"./helpers\":659}],659:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");r.legendGetsTrace=function(t){return t.visible&&n.traceIs(t,\"showLegend\")},r.isGrouped=function(t){return-1!==(t.traceorder||\"\").indexOf(\"grouped\")},r.isVertical=function(t){return\"h\"!==t.orientation},r.isReversed=function(t){return-1!==(t.traceorder||\"\").indexOf(\"reversed\")}},{\"../../registry\":844}],660:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"legend\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\"),style:t(\"./style\")}},{\"./attributes\":654,\"./defaults\":656,\"./draw\":657,\"./style\":661}],661:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../drawing\"),s=t(\"../color\"),l=t(\"../../traces/scatter/subtypes\"),u=t(\"../../traces/pie/style_one\");e.exports=function(t,e){function r(t){var e=t[0].trace,r=e.visible&&e.fill&&\"none\"!==e.fill,i=l.hasLines(e);e&&e._module&&\"contourcarpet\"===e._module.name&&(i=e.contours.showlines,r=\"fill\"===e.contours.coloring);var a=n.select(this).select(\".legendfill\").selectAll(\"path\").data(r?[t]:[]);a.enter().append(\"path\").classed(\"js-fill\",!0),a.exit().remove(),a.attr(\"d\",\"M5,0h30v6h-30z\").call(o.fillGroupStyle);var s=n.select(this).select(\".legendlines\").selectAll(\"path\").data(i?[t]:[]);s.enter().append(\"path\").classed(\"js-line\",!0).attr(\"d\",\"M5,0h30\"),s.exit().remove(),s.call(o.lineGroupStyle)}function c(t){function r(t,e,r){var n=a.nestedProperty(h,t).get(),i=Array.isArray(n)&&e?e(n):n;if(r){if(i<r[0])return r[0];if(i>r[1])return r[1]}return i}function i(t){return t[0]}var s,u,c=t[0],h=c.trace,f=l.hasMarkers(h),d=l.hasText(h),p=l.hasLines(h);if(f||d||p){var m={},v={};f&&(m.mc=r(\"marker.color\",i),m.mo=r(\"marker.opacity\",a.mean,[.2,1]),m.ms=r(\"marker.size\",a.mean,[2,16]),m.mlc=r(\"marker.line.color\",i),m.mlw=r(\"marker.line.width\",a.mean,[0,5]),v.marker={sizeref:1,sizemin:1,sizemode:\"diameter\"}),p&&(v.line={width:r(\"line.width\",i,[0,10])}),d&&(m.tx=\"Aa\",m.tp=r(\"textposition\",i),m.ts=10,m.tc=r(\"textfont.color\",i),m.tf=r(\"textfont.family\",i)),s=[a.minExtend(c,m)],u=a.minExtend(h,v)}var g=n.select(this).select(\"g.legendpoints\"),y=g.selectAll(\"path.scatterpts\").data(f?s:[]);y.enter().append(\"path\").classed(\"scatterpts\",!0).attr(\"transform\",\"translate(20,0)\"),y.exit().remove(),y.call(o.pointStyle,u,e),f&&(s[0].mrc=3);var b=g.selectAll(\"g.pointtext\").data(d?s:[]);b.enter().append(\"g\").classed(\"pointtext\",!0).append(\"text\").attr(\"transform\",\"translate(20,0)\"),b.exit().remove(),b.selectAll(\"text\").call(o.textPointStyle,u,e)}function h(t){var e=t[0].trace,r=e.marker||{},a=r.line||{},o=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendbar\").data(i.traceIs(e,\"bar\")?[t]:[]);o.enter().append(\"path\").classed(\"legendbar\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),o.exit().remove(),o.each(function(t){var e=n.select(this),i=t[0],o=(i.mlw+1||a.width+1)-1;e.style(\"stroke-width\",o+\"px\").call(s.fill,i.mc||r.color),o&&e.call(s.stroke,i.mlc||a.color)})}function f(t){var e=t[0].trace,r=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendbox\").data(i.traceIs(e,\"box\")&&e.visible?[t]:[]);r.enter().append(\"path\").classed(\"legendbox\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),r.exit().remove(),r.each(function(){var t=e.line.width,r=n.select(this);r.style(\"stroke-width\",t+\"px\").call(s.fill,e.fillcolor),t&&r.call(s.stroke,e.line.color)})}function d(t){var e=t[0].trace,r=n.select(this).select(\"g.legendpoints\").selectAll(\"path.legendpie\").data(i.traceIs(e,\"pie\")&&e.visible?[t]:[]);r.enter().append(\"path\").classed(\"legendpie\",!0).attr(\"d\",\"M6,6H-6V-6H6Z\").attr(\"transform\",\"translate(20,0)\"),r.exit().remove(),r.size()&&r.call(u,t[0],e)}t.each(function(t){var e=n.select(this),r=e.selectAll(\"g.layers\").data([0]);r.enter().append(\"g\").classed(\"layers\",!0),r.style(\"opacity\",t[0].trace.opacity),r.selectAll(\"g.legendfill\").data([t]).enter().append(\"g\").classed(\"legendfill\",!0),r.selectAll(\"g.legendlines\").data([t]).enter().append(\"g\").classed(\"legendlines\",!0);var i=r.selectAll(\"g.legendsymbols\").data([t]);i.enter().append(\"g\").classed(\"legendsymbols\",!0),i.selectAll(\"g.legendpoints\").data([t]).enter().append(\"g\").classed(\"legendpoints\",!0)}).each(h).each(f).each(d).each(r).each(c)}},{\"../../lib\":725,\"../../registry\":844,\"../../traces/pie/style_one\":1013,\"../../traces/scatter/subtypes\":1047,\"../color\":603,\"../drawing\":627,d3:121}],662:[function(t,e,r){\"use strict\";function n(t,e){var r,n,i=e.currentTarget,a=i.getAttribute(\"data-attr\"),o=i.getAttribute(\"data-val\")||!0,s=t._fullLayout,l={},u=f.list(t,null,!0),h=\"on\";if(\"zoom\"===a){var d,p=\"in\"===o?.5:2,m=(1+p)/2,v=(1-p)/2;for(n=0;n<u.length;n++)if(r=u[n],!r.fixedrange)if(d=r._name,\"auto\"===o)l[d+\".autorange\"]=!0;else if(\"reset\"===o){if(void 0===r._rangeInitial)l[d+\".autorange\"]=!0;else{var g=r._rangeInitial.slice();l[d+\".range[0]\"]=g[0],l[d+\".range[1]\"]=g[1]}void 0!==r._showSpikeInitial&&(l[d+\".showspikes\"]=r._showSpikeInitial,\"on\"!==h||r._showSpikeInitial||(h=\"off\"))}else{var y=[r.r2l(r.range[0]),r.r2l(r.range[1])],b=[m*y[0]+v*y[1],m*y[1]+v*y[0]];l[d+\".range[0]\"]=r.l2r(b[0]),l[d+\".range[1]\"]=r.l2r(b[1])}s._cartesianSpikesEnabled=h}else{if(\"hovermode\"!==a||\"x\"!==o&&\"y\"!==o){if(\"hovermode\"===a&&\"closest\"===o){for(n=0;n<u.length;n++)r=u[n],\"on\"!==h||r.showspikes||(h=\"off\");s._cartesianSpikesEnabled=h}}else o=s._isHoriz?\"y\":\"x\",i.setAttribute(\"data-val\",o),\"closest\"!==o&&(s._cartesianSpikesEnabled=\"off\");l[a]=o}c.relayout(t,l)}function i(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=r.getAttribute(\"data-val\")||!0,a=t._fullLayout,o=h.getSubplotIds(a,\"gl3d\"),s={},l=n.split(\".\"),u=0;u<o.length;u++)s[o[u]+\".\"+l[1]]=i;c.relayout(t,s)}function a(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=t._fullLayout,a=h.getSubplotIds(i,\"gl3d\"),o={},s=0;s<a.length;s++){var l=a[s],u=l+\".camera\",f=i[l]._scene;\"resetDefault\"===n?o[u]=null:\"resetLastSave\"===n&&(o[u]=d.extendDeep({},f.cameraInitial))}c.relayout(t,o)}function o(t,e){var r=e.currentTarget,n=r._previousVal||!1,i=t.layout,a=t._fullLayout,o=h.getSubplotIds(a,\"gl3d\"),s=[\"xaxis\",\"yaxis\",\"zaxis\"],l=[\"showspikes\",\"spikesides\",\"spikethickness\",\"spikecolor\"],u={},f={},p={};if(n)p=d.extendDeep(i,n),r._previousVal=null;else{p={\"allaxes.showspikes\":!1};for(var m=0;m<o.length;m++){var v=o[m],g=a[v],y=u[v]={};y.hovermode=g.hovermode,p[v+\".hovermode\"]=!1;for(var b=0;b<3;b++){var x=s[b];f=y[x]={};for(var _=0;_<l.length;_++){var w=l[_];f[w]=g[x][w]}}}r._previousVal=d.extendDeep({},u)}c.relayout(t,p)}function s(t,e){for(var r=e.currentTarget,n=r.getAttribute(\"data-attr\"),i=r.getAttribute(\"data-val\")||!0,a=t._fullLayout,o=h.getSubplotIds(a,\"geo\"),s=0;s<o.length;s++){var l=a[o[s]]._subplot;if(\"zoom\"===n){var u=l.projection.scale(),c=\"in\"===i?2*u:.5*u;l.projection.scale(c),l.zoom.scale(c),l.render()}else\"reset\"===n&&l.zoomReset()}}function l(t){var e,r=t._fullLayout;e=r._has(\"cartesian\")?r._isHoriz?\"y\":\"x\":\"closest\";var n=!t._fullLayout.hovermode&&e;c.relayout(t,\"hovermode\",n)}function u(t){for(var e,r,n=t._fullLayout,i=f.list(t,null,!0),a={},o=0;o<i.length;o++)e=i[o],r=e._name,a[r+\".showspikes\"]=\"on\"===n._cartesianSpikesEnabled;return a}var c=t(\"../../plotly\"),h=t(\"../../plots/plots\"),f=t(\"../../plots/cartesian/axes\"),d=t(\"../../lib\"),p=t(\"../../snapshot/download\"),m=t(\"../../../build/ploticon\"),v=e.exports={};v.toImage={name:\"toImage\",title:\"Download plot as a png\",icon:m.camera,click:function(t){var e=\"png\";d.notifier(\"Taking snapshot - this may take a few seconds\",\"long\"),d.isIE()&&(d.notifier(\"IE only supports svg.  Changing format to svg.\",\"long\"),e=\"svg\"),p(t,{format:e}).then(function(t){d.notifier(\"Snapshot succeeded - \"+t,\"long\")}).catch(function(){d.notifier(\"Sorry there was a problem downloading your snapshot!\",\"long\")})}},v.sendDataToCloud={name:\"sendDataToCloud\",title:\"Save and edit plot in cloud\",icon:m.disk,click:function(t){h.sendDataToCloud(t)}},v.zoom2d={name:\"zoom2d\",title:\"Zoom\",attr:\"dragmode\",val:\"zoom\",icon:m.zoombox,click:n},v.pan2d={name:\"pan2d\",title:\"Pan\",attr:\"dragmode\",val:\"pan\",icon:m.pan,click:n},v.select2d={name:\"select2d\",title:\"Box Select\",attr:\"dragmode\",val:\"select\",icon:m.selectbox,click:n},v.lasso2d={name:\"lasso2d\",title:\"Lasso Select\",attr:\"dragmode\",val:\"lasso\",icon:m.lasso,click:n},v.zoomIn2d={name:\"zoomIn2d\",title:\"Zoom in\",attr:\"zoom\",val:\"in\",icon:m.zoom_plus,click:n},v.zoomOut2d={name:\"zoomOut2d\",title:\"Zoom out\",attr:\"zoom\",val:\"out\",icon:m.zoom_minus,click:n},v.autoScale2d={name:\"autoScale2d\",title:\"Autoscale\",attr:\"zoom\",val:\"auto\",icon:m.autoscale,click:n},v.resetScale2d={name:\"resetScale2d\",title:\"Reset axes\",attr:\"zoom\",val:\"reset\",icon:m.home,click:n},v.hoverClosestCartesian={name:\"hoverClosestCartesian\",title:\"Show closest data on hover\",attr:\"hovermode\",val:\"closest\",icon:m.tooltip_basic,gravity:\"ne\",click:n},v.hoverCompareCartesian={name:\"hoverCompareCartesian\",title:\"Compare data on hover\",attr:\"hovermode\",val:function(t){return t._fullLayout._isHoriz?\"y\":\"x\"},icon:m.tooltip_compare,gravity:\"ne\",click:n},v.zoom3d={name:\"zoom3d\",title:\"Zoom\",attr:\"scene.dragmode\",val:\"zoom\",icon:m.zoombox,click:i},v.pan3d={name:\"pan3d\",title:\"Pan\",attr:\"scene.dragmode\",val:\"pan\",icon:m.pan,click:i},v.orbitRotation={name:\"orbitRotation\",title:\"orbital rotation\",attr:\"scene.dragmode\",val:\"orbit\",icon:m[\"3d_rotate\"],click:i},v.tableRotation={name:\"tableRotation\",title:\"turntable rotation\",attr:\"scene.dragmode\",val:\"turntable\",icon:m[\"z-axis\"],click:i},v.resetCameraDefault3d={name:\"resetCameraDefault3d\",title:\"Reset camera to default\",attr:\"resetDefault\",icon:m.home,click:a},v.resetCameraLastSave3d={name:\"resetCameraLastSave3d\",title:\"Reset camera to last save\",attr:\"resetLastSave\",icon:m.movie,click:a},v.hoverClosest3d={name:\"hoverClosest3d\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:o},v.zoomInGeo={name:\"zoomInGeo\",title:\"Zoom in\",attr:\"zoom\",val:\"in\",icon:m.zoom_plus,click:s},v.zoomOutGeo={name:\"zoomOutGeo\",title:\"Zoom out\",attr:\"zoom\",val:\"out\",icon:m.zoom_minus,click:s},v.resetGeo={name:\"resetGeo\",title:\"Reset\",attr:\"reset\",val:null,icon:m.autoscale,click:s},v.hoverClosestGeo={name:\"hoverClosestGeo\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:l},v.hoverClosestGl2d={name:\"hoverClosestGl2d\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:l},v.hoverClosestPie={name:\"hoverClosestPie\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:\"closest\",icon:m.tooltip_basic,gravity:\"ne\",click:l},v.toggleHover={name:\"toggleHover\",title:\"Toggle show closest data on hover\",attr:\"hovermode\",val:null,toggle:!0,icon:m.tooltip_basic,gravity:\"ne\",click:function(t,e){l(t),o(t,e)}},v.resetViews={name:\"resetViews\",title:\"Reset views\",icon:m.home,click:function(t,e){var r=e.currentTarget;r.setAttribute(\"data-attr\",\"zoom\"),r.setAttribute(\"data-val\",\"reset\"),n(t,e),r.setAttribute(\"data-attr\",\"resetLastSave\"),a(t,e)}},v.toggleSpikelines={name:\"toggleSpikelines\",title:\"Toggle Spike Lines\",icon:m.spikeline,attr:\"_cartesianSpikesEnabled\",val:\"on\",click:function(t){var e=t._fullLayout;e._cartesianSpikesEnabled=\"closest\"===e.hovermode&&\"on\"===e._cartesianSpikesEnabled?\"off\":\"on\";var r=u(t);r.hovermode=\"closest\",c.relayout(t,r)}},v.resetViewMapbox={name:\"resetViewMapbox\",title:\"Reset view\",attr:\"reset\",icon:m.home,click:function(t){for(var e=t._fullLayout,r=h.getSubplotIds(e,\"mapbox\"),n={},i=0;i<r.length;i++)for(var a=r[i],o=e[a]._subplot,s=o.viewInitial,l=Object.keys(s),u=0;u<l.length;u++){var f=l[u];n[a+\".\"+f]=s[f]}c.relayout(t,n)}}},{\"../../../build/ploticon\":2,\"../../lib\":725,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../../snapshot/download\":846}],663:[function(t,e,r){\"use strict\";r.manage=t(\"./manage\")},{\"./manage\":664}],664:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){for(var r=[],n=0;n<t.length;n++){var i=t[n];-1===e.indexOf(i)&&r.push(f[i])}g.push(r)}var s=t._fullLayout,l=t._fullData,u=s._has(\"cartesian\"),c=s._has(\"gl3d\"),h=s._has(\"geo\"),d=s._has(\"pie\"),p=s._has(\"gl2d\"),m=s._has(\"ternary\"),v=s._has(\"mapbox\"),g=[];if(n([\"toImage\",\"sendDataToCloud\"]),(u||p||d||m)+h+c>1)return n([\"resetViews\",\"toggleHover\"]),o(g,r);c&&(n([\"zoom3d\",\"pan3d\",\"orbitRotation\",\"tableRotation\"]),n([\"resetCameraDefault3d\",\"resetCameraLastSave3d\"]),n([\"hoverClosest3d\"])),h&&(n([\"zoomInGeo\",\"zoomOutGeo\",\"resetGeo\"]),n([\"hoverClosestGeo\"]));var y=i(s),b=[];return((u||p)&&!y||m)&&(b=[\"zoom2d\",\"pan2d\"]),v&&(b=[\"pan2d\"]),a(l)&&(b.push(\"select2d\"),b.push(\"lasso2d\")),b.length&&n(b),!u&&!p||y||m||n([\"zoomIn2d\",\"zoomOut2d\",\"autoScale2d\",\"resetScale2d\"]),u&&d?n([\"toggleHover\"]):p?n([\"hoverClosestGl2d\"]):u?n([\"toggleSpikelines\",\"hoverClosestCartesian\",\"hoverCompareCartesian\"]):d?n([\"hoverClosestPie\"]):v&&n([\"resetViewMapbox\",\"toggleHover\"]),o(g,r)}function i(t){for(var e=l.list({_fullLayout:t},null,!0),r=!0,n=0;n<e.length;n++)if(!e[n].fixedrange){r=!1;break}return r}function a(t){for(var e=!1,r=0;r<t.length&&!e;r++){var n=t[r];n._module&&n._module.selectPoints&&(c.traceIs(n,\"scatter-like\")?(u.hasMarkers(n)||u.hasText(n))&&(e=!0):e=!0)}return e}function o(t,e){if(e.length)if(Array.isArray(e[0]))for(var r=0;r<e.length;r++)t.push(e[r]);else t.push(e);return t}function s(t){for(var e=0;e<t.length;e++)for(var r=t[e],n=0;n<r.length;n++){var i=r[n];if(\"string\"==typeof i){if(void 0===f[i])throw new Error([\"*modeBarButtons* configuration options\",\"invalid button name\"].join(\" \"));t[e][n]=f[i]}}return t}var l=t(\"../../plots/cartesian/axes\"),u=t(\"../../traces/scatter/subtypes\"),c=t(\"../../registry\"),h=t(\"./modebar\"),f=t(\"./buttons\");e.exports=function(t){var e=t._fullLayout,r=t._context,i=e._modeBar;if(!r.displayModeBar)return void(i&&(i.destroy(),delete e._modeBar));if(!Array.isArray(r.modeBarButtonsToRemove))throw new Error([\"*modeBarButtonsToRemove* configuration options\",\"must be an array.\"].join(\" \"));if(!Array.isArray(r.modeBarButtonsToAdd))throw new Error([\"*modeBarButtonsToAdd* configuration options\",\"must be an array.\"].join(\" \"));var a,o=r.modeBarButtons;a=Array.isArray(o)&&o.length?s(o):n(t,r.modeBarButtonsToRemove,r.modeBarButtonsToAdd),i?i.update(t,a):e._modeBar=h(t,a)}},{\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../../traces/scatter/subtypes\":1047,\"./buttons\":662,\"./modebar\":665}],665:[function(t,e,r){\"use strict\";function n(t){this.container=t.container,this.element=document.createElement(\"div\"),this.update(t.graphInfo,t.buttons),this.container.appendChild(this.element)}function i(t,e){var r=t._fullLayout,i=new n({graphInfo:t,container:r._paperdiv.node(),buttons:e});return r._privateplot&&a.select(i.element).append(\"span\").classed(\"badge-private float--left\",!0).text(\"PRIVATE\"),i}var a=t(\"d3\"),o=t(\"../../lib\"),s=t(\"../../../build/ploticon\"),l=n.prototype;l.update=function(t,e){this.graphInfo=t;var r=this.graphInfo._context;\"hover\"===r.displayModeBar?this.element.className=\"modebar modebar--hover\":this.element.className=\"modebar\";var n=!this.hasButtons(e),i=this.hasLogo!==r.displaylogo;(n||i)&&(this.removeAllButtons(),this.updateButtons(e),r.displaylogo&&(this.element.appendChild(this.getLogo()),this.hasLogo=!0)),this.updateActiveButton()},l.updateButtons=function(t){var e=this;this.buttons=t,this.buttonElements=[],this.buttonsNames=[],this.buttons.forEach(function(t){var r=e.createGroup();t.forEach(function(t){var n=t.name;if(!n)throw new Error(\"must provide button 'name' in button config\");if(-1!==e.buttonsNames.indexOf(n))throw new Error(\"button name '\"+n+\"' is taken\");e.buttonsNames.push(n);var i=e.createButton(t);e.buttonElements.push(i),r.appendChild(i)}),e.element.appendChild(r)})},l.createGroup=function(){var t=document.createElement(\"div\");return t.className=\"modebar-group\",t},l.createButton=function(t){var e=this,r=document.createElement(\"a\");r.setAttribute(\"rel\",\"tooltip\"),r.className=\"modebar-btn\";var n=t.title;void 0===n&&(n=t.name),(n||0===n)&&r.setAttribute(\"data-title\",n),void 0!==t.attr&&r.setAttribute(\"data-attr\",t.attr);var i=t.val;if(void 0!==i&&(\"function\"==typeof i&&(i=i(this.graphInfo)),r.setAttribute(\"data-val\",i)),\"function\"!=typeof t.click)throw new Error(\"must provide button 'click' function in button config\");return r.addEventListener(\"click\",function(r){t.click(e.graphInfo,r),e.updateActiveButton(r.currentTarget)}),r.setAttribute(\"data-toggle\",t.toggle||!1),t.toggle&&a.select(r).classed(\"active\",!0),r.appendChild(this.createIcon(t.icon||s.question,t.name)),r.setAttribute(\"data-gravity\",t.gravity||\"n\"),r},l.createIcon=function(t,e){var r=t.ascent-t.descent,n=\"http://www.w3.org/2000/svg\",i=document.createElementNS(n,\"svg\"),a=document.createElementNS(n,\"path\");i.setAttribute(\"height\",\"1em\"),i.setAttribute(\"width\",t.width/r+\"em\"),i.setAttribute(\"viewBox\",[0,0,t.width,r].join(\" \"));var o=\"toggleSpikelines\"===e?\"matrix(1.5 0 0 -1.5 0 \"+t.ascent+\")\":\"matrix(1 0 0 -1 0 \"+t.ascent+\")\";return a.setAttribute(\"d\",t.path),a.setAttribute(\"transform\",o),i.appendChild(a),i},l.updateActiveButton=function(t){var e=this.graphInfo._fullLayout,r=void 0!==t?t.getAttribute(\"data-attr\"):null;this.buttonElements.forEach(function(t){var n=t.getAttribute(\"data-val\")||!0,i=t.getAttribute(\"data-attr\"),s=\"true\"===t.getAttribute(\"data-toggle\"),l=a.select(t);if(s)i===r&&l.classed(\"active\",!l.classed(\"active\"));else{var u=null===i?i:o.nestedProperty(e,i).get();l.classed(\"active\",u===n)}})},l.hasButtons=function(t){var e=this.buttons;if(!e)return!1;if(t.length!==e.length)return!1;for(var r=0;r<t.length;++r){if(t[r].length!==e[r].length)return!1;for(var n=0;n<t[r].length;n++)if(t[r][n].name!==e[r][n].name)return!1}return!0},l.getLogo=function(){var t=this.createGroup(),e=document.createElement(\"a\");return e.href=\"https://plot.ly/\",e.target=\"_blank\",e.setAttribute(\"data-title\",\"Produced with Plotly\"),e.className=\"modebar-btn plotlyjsicon modebar-btn--logo\",e.appendChild(this.createIcon(s.plotlylogo)),t.appendChild(e),t},l.removeAllButtons=function(){for(;this.element.firstChild;)this.element.removeChild(this.element.firstChild);this.hasLogo=!1},l.destroy=function(){o.removeElement(this.container.querySelector(\".modebar\"))},e.exports=i},{\"../../../build/ploticon\":2,\"../../lib\":725,d3:121}],666:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"./button_attributes\");o=a(o,{_isLinkedToArray:\"button\"}),e.exports={visible:{valType:\"boolean\"},buttons:o,x:{valType:\"number\",min:-2,max:3},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"bottom\"},font:a({},n,{}),bgcolor:{valType:\"color\",dflt:i.lightLine},activecolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.defaultLine},borderwidth:{valType:\"number\",min:0,dflt:0}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../color/attributes\":602,\"./button_attributes\":667}],667:[function(t,e,r){\"use strict\";e.exports={step:{valType:\"enumerated\",values:[\"month\",\"year\",\"day\",\"hour\",\"minute\",\"second\",\"all\"],dflt:\"month\"},stepmode:{valType:\"enumerated\",values:[\"backward\",\"todate\"],dflt:\"backward\"},count:{valType:\"number\",min:0,dflt:1},label:{valType:\"string\"}}},{}],668:[function(t,e,r){\"use strict\";e.exports={yPad:.02,minButtonWidth:30,rx:3,ry:3,lightAmount:25,darkAmount:10}},{}],669:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,e){return a.coerce(i,o,l,t,e)}for(var i,o,s=t.buttons||[],u=e.buttons=[],c=0;c<s.length;c++)if(i=s[c],o={},a.isPlainObject(i)){var h=n(\"step\");\"all\"!==h&&(!r||\"gregorian\"===r||\"month\"!==h&&\"year\"!==h?n(\"stepmode\"):o.stepmode=\"backward\",n(\"count\")),n(\"label\"),o._index=c,u.push(o)}return u}function i(t,e,r){for(var n=r.filter(function(r){return e[r].anchor===t._id}),i=0,a=0;a<n.length;a++){var o=e[n[a]].domain;o&&(i=Math.max(o[1],i))}return[t.domain[0],i+u.yPad]}var a=t(\"../../lib\"),o=t(\"../color\"),s=t(\"./attributes\"),l=t(\"./button_attributes\"),u=t(\"./constants\");e.exports=function(t,e,r,l,c){function h(t,e){return a.coerce(f,d,s,t,e)}var f=t.rangeselector||{},d=e.rangeselector={};if(h(\"visible\",n(f,d,c).length>0)){var p=i(e,r,l);h(\"x\",p[0]),h(\"y\",p[1]),a.noneOrAll(t,e,[\"x\",\"y\"]),h(\"xanchor\"),h(\"yanchor\"),a.coerceFont(h,\"font\",r.font);var m=h(\"bgcolor\");h(\"activecolor\",o.contrast(m,u.lightAmount,u.darkAmount)),h(\"bordercolor\"),h(\"borderwidth\")}}},{\"../../lib\":725,\"../color\":603,\"./attributes\":666,\"./button_attributes\":667,\"./constants\":668}],670:[function(t,e,r){\"use strict\";function n(t){for(var e=g.list(t,\"x\",!0),r=[],n=0;n<e.length;n++){var i=e[n];i.rangeselector&&i.rangeselector.visible&&r.push(i)}return r}function i(t){return t._id}function a(t,e,r){if(\"all\"===e.step)return!0===t.autorange;var n=Object.keys(r);return t.range[0]===r[n[0]]&&t.range[1]===r[n[1]]}function o(t,e,r){var n=t.selectAll(\"rect\").data([0]);n.enter().append(\"rect\").classed(\"selector-rect\",!0),n.attr(\"shape-rendering\",\"crispEdges\"),n.attr({rx:x.rx,ry:x.ry}),n.call(p.stroke,e.bordercolor).call(p.fill,s(e,r)).style(\"stroke-width\",e.borderwidth+\"px\")}function s(t,e){return e.isActive||e.isHovered?t.activecolor:t.bgcolor}function l(t,e,r,n){function i(t){v.convertToTspans(t,n)}var a=t.selectAll(\"text\").data([0]);a.enter().append(\"text\").classed(\"selector-text\",!0).classed(\"user-select-none\",!0),a.attr(\"text-anchor\",\"middle\"),a.call(m.font,e.font).text(u(r)).call(i)}function u(t){return t.label?t.label:\"all\"===t.step?\"all\":t.count+t.step.charAt(0)}function c(t,e,r,n){r.width=0,r.height=0;var i=r.borderwidth;e.each(function(){var t=h.select(this),e=t.select(\".selector-text\"),n=r.font.size*b,i=Math.max(n*v.lineCount(e),16)+3;r.height=Math.max(r.height,i)}),e.each(function(){var t=h.select(this),e=t.select(\".selector-rect\"),n=t.select(\".selector-text\"),a=n.node()&&m.bBox(n.node()).width,o=r.font.size*b,s=v.lineCount(n),l=Math.max(a+10,x.minButtonWidth);t.attr(\"transform\",\"translate(\"+(i+r.width)+\",\"+i+\")\"),e.attr({x:0,y:0,width:l,height:r.height}),v.positionText(n,l/2,r.height/2-(s-1)*o/2+3),r.width+=l+5}),e.selectAll(\"rect\").attr(\"height\",r.height);var a=t._fullLayout._size;r.lx=a.l+a.w*r.x,r.ly=a.t+a.h*(1-r.y);var o=\"left\";y.isRightAnchor(r)&&(r.lx-=r.width,o=\"right\"),y.isCenterAnchor(r)&&(r.lx-=r.width/2,o=\"center\");var s=\"top\";y.isBottomAnchor(r)&&(r.ly-=r.height,s=\"bottom\"),y.isMiddleAnchor(r)&&(r.ly-=r.height/2,s=\"middle\"),r.width=Math.ceil(r.width),r.height=Math.ceil(r.height),r.lx=Math.round(r.lx),r.ly=Math.round(r.ly),d.autoMargin(t,n+\"-range-selector\",{x:r.x,y:r.y,l:r.width*({right:1,center:.5}[o]||0),r:r.width*({left:1,center:.5}[o]||0),b:r.height*({top:1,middle:.5}[s]||0),t:r.height*({bottom:1,middle:.5}[s]||0)})}var h=t(\"d3\"),f=t(\"../../plotly\"),d=t(\"../../plots/plots\"),p=t(\"../color\"),m=t(\"../drawing\"),v=t(\"../../lib/svg_text_utils\"),g=t(\"../../plots/cartesian/axis_ids\"),y=t(\"../legend/anchor_utils\"),b=t(\"../../constants/alignment\").LINE_SPACING,x=t(\"./constants\"),_=t(\"./get_update_object\");e.exports=function(t){var e=t._fullLayout,r=e._infolayer.selectAll(\".rangeselector\").data(n(t),i);r.enter().append(\"g\").classed(\"rangeselector\",!0),r.exit().remove(),r.style({cursor:\"pointer\",\"pointer-events\":\"all\"}),r.each(function(e){var r=h.select(this),n=e,i=n.rangeselector,s=r.selectAll(\"g.button\").data(i.buttons);s.enter().append(\"g\").classed(\"button\",!0),s.exit().remove(),s.each(function(e){var r=h.select(this),s=_(n,e);e.isActive=a(n,e,s),r.call(o,i,e),r.call(l,i,e,t),r.on(\"click\",function(){t._dragged||f.relayout(t,s)}),r.on(\"mouseover\",function(){e.isHovered=!0,r.call(o,i,e)}),r.on(\"mouseout\",function(){e.isHovered=!1,r.call(o,i,e)})}),c(t,s,i,n._name),r.attr(\"transform\",\"translate(\"+i.lx+\",\"+i.ly+\")\")})}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/cartesian/axis_ids\":769,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":668,\"./get_update_object\":671,d3:121}],671:[function(t,e,r){\"use strict\";function n(t,e){var r,n=t.range,a=new Date(t.r2l(n[1])),o=e.step,s=e.count;switch(e.stepmode){case\"backward\":r=t.l2r(+i.time[o].utc.offset(a,-s));break;case\"todate\":var l=i.time[o].utc.offset(a,-s);r=t.l2r(+i.time[o].utc.ceil(l))}return[r,n[1]]}var i=t(\"d3\");e.exports=function(t,e){var r=t._name,i={};if(\"all\"===e.step)i[r+\".autorange\"]=!0;else{var a=n(t,e);i[r+\".range[0]\"]=a[0],i[r+\".range[1]\"]=a[1]}return i}},{d3:121}],672:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"rangeselector\",schema:{layout:{\"xaxis.rangeselector\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),draw:t(\"./draw\")}},{\"./attributes\":666,\"./defaults\":669,\"./draw\":670}],673:[function(t,e,r){\"use strict\";var n=t(\"../color/attributes\");e.exports={bgcolor:{valType:\"color\",dflt:n.background},bordercolor:{valType:\"color\",dflt:n.defaultLine},borderwidth:{valType:\"integer\",dflt:0,min:0},autorange:{valType:\"boolean\",dflt:!0},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},thickness:{valType:\"number\",dflt:.15,min:0,max:1},visible:{valType:\"boolean\",dflt:!0}}},{\"../color/attributes\":602}],674:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"./constants\");e.exports=function(t){for(var e=n.list(t,\"x\",!0),r=0;r<e.length;r++){var a=e[r],o=a[i.name];o&&o.visible&&o.autorange&&a._min.length&&a._max.length&&(o._input.autorange=!0,o._input.range=o.range=n.getAutoRange(a))}}},{\"../../plots/cartesian/axes\":766,\"./constants\":675}],675:[function(t,e,r){\"use strict\";e.exports={name:\"rangeslider\",containerClassName:\"rangeslider-container\",bgClassName:\"rangeslider-bg\",rangePlotClassName:\"rangeslider-rangeplot\",maskMinClassName:\"rangeslider-mask-min\",maskMaxClassName:\"rangeslider-mask-max\",slideBoxClassName:\"rangeslider-slidebox\",grabberMinClassName:\"rangeslider-grabber-min\",grabAreaMinClassName:\"rangeslider-grabarea-min\",handleMinClassName:\"rangeslider-handle-min\",grabberMaxClassName:\"rangeslider-grabber-max\",grabAreaMaxClassName:\"rangeslider-grabarea-max\",handleMaxClassName:\"rangeslider-handle-max\",maskColor:\"rgba(0,0,0,0.4)\",slideBoxFill:\"transparent\",slideBoxCursor:\"ew-resize\",grabAreaFill:\"transparent\",grabAreaCursor:\"col-resize\",grabAreaWidth:10,handleWidth:4,handleRadius:1,handleStrokeWidth:1,extraPad:15}},{}],676:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){function a(t,e){return n.coerce(o,l,i,t,e)}if(t[r].rangeslider){n.isPlainObject(t[r].rangeslider)||(t[r].rangeslider={});var o=t[r].rangeslider,s=e[r],l=s.rangeslider={};if(a(\"visible\")){if(a(\"bgcolor\",e.plot_bgcolor),a(\"bordercolor\"),a(\"borderwidth\"),a(\"thickness\"),a(\"autorange\",!s.isValidRange(o.range)),a(\"range\"),l.range){var u=l.range,c=s.range;u[0]=s.l2r(Math.min(s.r2l(u[0]),s.r2l(c[0]))),u[1]=s.l2r(Math.max(s.r2l(u[1]),s.r2l(c[1])))}s.cleanRange(\"rangeslider.range\"),l._input=o}}}},{\"../../lib\":725,\"./attributes\":673}],677:[function(t,e,r){\"use strict\";function n(t){var e=w.list({_fullLayout:t},\"x\",!0),r=A.name,n=[];if(t._has(\"gl2d\"))return n;for(var i=0;i<e.length;i++){var a=e[i];a[r]&&a[r].visible&&n.push(a)}return n}function i(t,e,r,n){var i=t.select(\"rect.\"+A.slideBoxClassName).node(),o=t.select(\"rect.\"+A.grabAreaMinClassName).node(),s=t.select(\"rect.\"+A.grabAreaMaxClassName).node();t.on(\"mousedown\",function(){function l(l){var u,c,y,b=+l.clientX-f;switch(h){case i:y=\"ew-resize\",u=p+b,c=v+b;break;case o:y=\"col-resize\",u=p+b,c=v;break;case s:y=\"col-resize\",u=p,c=v+b;break;default:y=\"ew-resize\",u=d,c=d+b}if(c<u){var x=c;c=u,u=x}n._pixelMin=u,n._pixelMax=c,k(m.select(g),y),a(t,e,r,n)}function u(){g.removeEventListener(\"mousemove\",l),g.removeEventListener(\"mouseup\",u),y.removeElement(g)}var c=m.event,h=c.target,f=c.clientX,d=f-t.node().getBoundingClientRect().left,p=n.d2p(r._rl[0]),v=n.d2p(r._rl[1]),g=M.coverSlip();g.addEventListener(\"mousemove\",l),g.addEventListener(\"mouseup\",u)})}function a(t,e,r,n){function i(t){return r.l2r(y.constrain(t,n._rl[0],n._rl[1]))}var a=i(n.p2d(n._pixelMin)),o=i(n.p2d(n._pixelMax));window.requestAnimationFrame(function(){v.relayout(e,r._name+\".range\",[a,o])})}function o(t,e,r,n){function i(t){return y.constrain(t,0,n._width)}function a(t){return y.constrain(t,-o,n._width+o)}var o=A.handleWidth/2,s=i(n.d2p(r._rl[0])),l=i(n.d2p(r._rl[1]));t.select(\"rect.\"+A.slideBoxClassName).attr(\"x\",s).attr(\"width\",l-s),t.select(\"rect.\"+A.maskMinClassName).attr(\"width\",s),t.select(\"rect.\"+A.maskMaxClassName).attr(\"x\",l).attr(\"width\",n._width-l);var u=Math.round(a(s-o))-.5,c=Math.round(a(l-o))+.5;t.select(\"g.\"+A.grabberMinClassName).attr(\"transform\",\"translate(\"+u+\",0.5)\"),t.select(\"g.\"+A.grabberMaxClassName).attr(\"transform\",\"translate(\"+c+\",0.5)\")}function s(t,e,r,n){var i=t.selectAll(\"rect.\"+A.bgClassName).data([0]);i.enter().append(\"rect\").classed(A.bgClassName,!0).attr({x:0,y:0,\"shape-rendering\":\"crispEdges\"});var a=n.borderwidth%2==0?n.borderwidth:n.borderwidth-1,o=-n._offsetShift,s=b.crispRound(e,n.borderwidth);i.attr({width:n._width+a,height:n._height+a,transform:\"translate(\"+o+\",\"+o+\")\",fill:n.bgcolor,stroke:n.bordercolor,\"stroke-width\":s})}function l(t,e,r,n){\n",
       "var i=e._fullLayout,a=i._topdefs.selectAll(\"#\"+n._clipId).data([0]);a.enter().append(\"clipPath\").attr(\"id\",n._clipId).append(\"rect\").attr({x:0,y:0}),a.select(\"rect\").attr({width:n._width,height:n._height})}function u(t,e,r,n){var i=w.getSubplots(e,r),a=e.calcdata,o=t.selectAll(\"g.\"+A.rangePlotClassName).data(i,y.identity);o.enter().append(\"g\").attr(\"class\",function(t){return A.rangePlotClassName+\" \"+t}).call(b.setClipUrl,n._clipId),o.order(),o.exit().remove();var s;o.each(function(t,i){var o=m.select(this),l=0===i,u=w.getFromId(e,t,\"y\"),h=u._name,f={data:[],layout:{xaxis:{type:r.type,domain:[0,1],range:n.range.slice(),calendar:r.calendar},width:n._width,height:n._height,margin:{t:0,b:0,l:0,r:0}}};f.layout[h]={type:u.type,domain:[0,1],range:u.range.slice(),calendar:u.calendar},g.supplyDefaults(f);var d=f._fullLayout.xaxis,p=f._fullLayout[h],v={id:t,plotgroup:o,xaxis:d,yaxis:p};l?s=v:(v.mainplot=\"xy\",v.mainplotinfo=s),_.rangePlot(e,v,c(a,t))})}function c(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n],a=i[0].trace;a.xaxis+a.yaxis===e&&r.push(i)}return r}function h(t,e,r,n){var i=t.selectAll(\"rect.\"+A.maskMinClassName).data([0]);i.enter().append(\"rect\").classed(A.maskMinClassName,!0).attr({x:0,y:0}).attr(\"shape-rendering\",\"crispEdges\"),i.attr(\"height\",n._height).call(x.fill,A.maskColor);var a=t.selectAll(\"rect.\"+A.maskMaxClassName).data([0]);a.enter().append(\"rect\").classed(A.maskMaxClassName,!0).attr(\"y\",0).attr(\"shape-rendering\",\"crispEdges\"),a.attr(\"height\",n._height).call(x.fill,A.maskColor)}function f(t,e,r,n){if(!e._context.staticPlot){var i=t.selectAll(\"rect.\"+A.slideBoxClassName).data([0]);i.enter().append(\"rect\").classed(A.slideBoxClassName,!0).attr(\"y\",0).attr(\"cursor\",A.slideBoxCursor).attr(\"shape-rendering\",\"crispEdges\"),i.attr({height:n._height,fill:A.slideBoxFill})}}function d(t,e,r,n){var i=t.selectAll(\"g.\"+A.grabberMinClassName).data([0]);i.enter().append(\"g\").classed(A.grabberMinClassName,!0);var a=t.selectAll(\"g.\"+A.grabberMaxClassName).data([0]);a.enter().append(\"g\").classed(A.grabberMaxClassName,!0);var o={x:0,width:A.handleWidth,rx:A.handleRadius,fill:x.background,stroke:x.defaultLine,\"stroke-width\":A.handleStrokeWidth,\"shape-rendering\":\"crispEdges\"},s={y:Math.round(n._height/4),height:Math.round(n._height/2)},l=i.selectAll(\"rect.\"+A.handleMinClassName).data([0]);l.enter().append(\"rect\").classed(A.handleMinClassName,!0).attr(o),l.attr(s);var u=a.selectAll(\"rect.\"+A.handleMaxClassName).data([0]);if(u.enter().append(\"rect\").classed(A.handleMaxClassName,!0).attr(o),u.attr(s),!e._context.staticPlot){var c={width:A.grabAreaWidth,x:0,y:0,fill:A.grabAreaFill,cursor:A.grabAreaCursor},h=i.selectAll(\"rect.\"+A.grabAreaMinClassName).data([0]);h.enter().append(\"rect\").classed(A.grabAreaMinClassName,!0).attr(c),h.attr(\"height\",n._height);var f=a.selectAll(\"rect.\"+A.grabAreaMaxClassName).data([0]);f.enter().append(\"rect\").classed(A.grabAreaMaxClassName,!0).attr(c),f.attr(\"height\",n._height)}}function p(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(A.name)&&g.autoMargin(t,i)}}var m=t(\"d3\"),v=t(\"../../plotly\"),g=t(\"../../plots/plots\"),y=t(\"../../lib\"),b=t(\"../drawing\"),x=t(\"../color\"),_=t(\"../../plots/cartesian\"),w=t(\"../../plots/cartesian/axes\"),M=t(\"../dragelement\"),k=t(\"../../lib/setcursor\"),A=t(\"./constants\");e.exports=function(t){function e(t){return t._name}var r=t._fullLayout,a=n(r),c=r._infolayer.selectAll(\"g.\"+A.containerClassName).data(a,e);c.enter().append(\"g\").classed(A.containerClassName,!0).attr(\"pointer-events\",\"all\"),c.exit().each(function(t){var e=m.select(this),n=t[A.name];e.remove(),r._topdefs.select(\"#\"+n._clipId).remove()}),c.exit().size()&&p(t),0!==a.length&&c.each(function(e){var n=m.select(this),a=e[A.name],c=r[w.id2name(e.anchor)],p=r.margin,v=r._size,y=e.domain,b=c.domain,x=(e._boundingBox||{}).height||0;a._id=A.name+e._id,a._clipId=a._id+\"-\"+r._uid,a._width=v.w*(y[1]-y[0]),a._height=(r.height-p.b-p.t)*a.thickness,a._offsetShift=Math.floor(a.borderwidth/2);var _=Math.round(p.l+v.w*y[0]),M=Math.round(p.t+v.h*(1-b[0])+x+a._offsetShift+A.extraPad);n.attr(\"transform\",\"translate(\"+_+\",\"+M+\")\");var k=e.r2l(a.range[0]),T=e.r2l(a.range[1]),S=T-k;a.p2d=function(t){return t/a._width*S+k},a.d2p=function(t){return(t-k)/S*a._width},a._rl=[k,T],n.call(s,t,e,a).call(l,t,e,a).call(u,t,e,a).call(h,t,e,a).call(f,t,e,a).call(d,t,e,a),i(n,t,e,a),o(n,t,e,a),g.autoMargin(t,a._id,{x:y[0],y:b[0],l:0,r:0,t:0,b:a._height+p.b+x,pad:A.extraPad+2*a._offsetShift})})}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../plotly\":761,\"../../plots/cartesian\":776,\"../../plots/cartesian/axes\":766,\"../../plots/plots\":829,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":675,d3:121}],678:[function(t,e,r){\"use strict\";e.exports={moduleType:\"component\",name:\"rangeslider\",schema:{layout:{\"xaxis.rangeslider\":t(\"./attributes\")}},layoutAttributes:t(\"./attributes\"),handleDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:t(\"./draw\")}},{\"./attributes\":673,\"./calc_autorange\":674,\"./defaults\":676,\"./draw\":677}],679:[function(t,e,r){\"use strict\";var n=t(\"../annotations/attributes\"),i=t(\"../../traces/scatter/attributes\").line,a=t(\"../drawing/attributes\").dash,o=t(\"../../lib/extend\").extendFlat;e.exports={_isLinkedToArray:\"shape\",visible:{valType:\"boolean\",dflt:!0},type:{valType:\"enumerated\",values:[\"circle\",\"rect\",\"path\",\"line\"]},layer:{valType:\"enumerated\",values:[\"below\",\"above\"],dflt:\"above\"},xref:o({},n.xref,{}),x0:{valType:\"any\"},x1:{valType:\"any\"},yref:o({},n.yref,{}),y0:{valType:\"any\"},y1:{valType:\"any\"},path:{valType:\"string\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},line:{color:i.color,width:i.width,dash:a},fillcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"}}},{\"../../lib/extend\":716,\"../../traces/scatter/attributes\":1027,\"../annotations/attributes\":586,\"../drawing/attributes\":626}],680:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=\"category\"===t.type?t.r2c:t.d2c;if(void 0!==e)return[a(e),a(r)];if(n){var l,u,c,h,f,d=1/0,p=-1/0,m=n.match(o.segmentRE);for(\"date\"===t.type&&(a=s.decodeDate(a)),l=0;l<m.length;l++)u=m[l],void 0!==(c=i[u.charAt(0)].drawn)&&(!(h=m[l].substr(1).match(o.paramRE))||h.length<c||(f=a(h[c]),f<d&&(d=f),f>p&&(p=f)));return p>=d?[d,p]:void 0}}var i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"./constants\"),s=t(\"./helpers\");e.exports=function(t){var e=t._fullLayout,r=i.filterVisible(e.shapes);if(r.length&&t._fullData.length)for(var s=0;s<r.length;s++){var l,u,c=r[s],h=c.line.width/2;\"paper\"!==c.xref&&(l=a.getFromId(t,c.xref),(u=n(l,c.x0,c.x1,c.path,o.paramIsX))&&a.expand(l,u,{ppad:h})),\"paper\"!==c.yref&&(l=a.getFromId(t,c.yref),(u=n(l,c.y0,c.y1,c.path,o.paramIsY))&&a.expand(l,u,{ppad:h}))}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./constants\":681,\"./helpers\":684}],681:[function(t,e,r){\"use strict\";e.exports={segmentRE:/[MLHVQCTSZ][^MLHVQCTSZ]*/g,paramRE:/[^\\s,]+/g,paramIsX:{M:{0:!0,drawn:0},L:{0:!0,drawn:0},H:{0:!0,drawn:0},V:{},Q:{0:!0,2:!0,drawn:2},C:{0:!0,2:!0,4:!0,drawn:4},T:{0:!0,drawn:0},S:{0:!0,2:!0,drawn:2},Z:{}},paramIsY:{M:{1:!0,drawn:1},L:{1:!0,drawn:1},H:{},V:{0:!0,drawn:0},Q:{1:!0,3:!0,drawn:3},C:{1:!0,3:!0,5:!0,drawn:5},T:{1:!0,drawn:1},S:{1:!0,3:!0,drawn:5},Z:{}},numParams:{M:2,L:2,H:1,V:1,Q:4,C:6,T:2,S:4,Z:0}}},{}],682:[function(t,e,r){\"use strict\";var n=t(\"../../plots/array_container_defaults\"),i=t(\"./shape_defaults\");e.exports=function(t,e){n(t,e,{name:\"shapes\",handleItemDefaults:i})}},{\"../../plots/array_container_defaults\":763,\"./shape_defaults\":686}],683:[function(t,e,r){\"use strict\";function n(t){var e=t._fullLayout;e._shapeUpperLayer.selectAll(\"path\").remove(),e._shapeLowerLayer.selectAll(\"path\").remove(),e._shapeSubplotLayers.selectAll(\"path\").remove();for(var r=0;r<e.shapes.length;r++)e.shapes[r].visible&&i(t,r)}function i(t,e){function r(r){var n={\"data-index\":e,\"fill-rule\":\"evenodd\",d:o(t,i)},s=i.line.width?i.line.color:\"rgba(0,0,0,0)\",l=r.append(\"path\").attr(n).style(\"opacity\",i.opacity).call(f.stroke,s).call(f.fill,i.fillcolor).call(d.dashLine,i.line.dash,i.line.width),u=(i.xref+i.yref).replace(/paper/g,\"\");l.call(d.setClipUrl,u?\"clip\"+t._fullLayout._uid+u:null),t._context.edits.shapePosition&&a(t,l,i,e)}t._fullLayout._paper.selectAll('.shapelayer [data-index=\"'+e+'\"]').remove();var n=(t.layout.shapes||[])[e],i=t._fullLayout.shapes[e];if(n&&!1!==i.visible)if(\"below\"!==i.layer)r(t._fullLayout._shapeUpperLayer);else if(\"paper\"===i.xref||\"paper\"===i.yref)r(t._fullLayout._shapeLowerLayer);else{var s=t._fullLayout._plots[i.xref+i.yref];if(s){var l=s.mainplot||s;r(l.shapelayer)}else r(t._fullLayout._shapeLowerLayer)}}function a(t,e,r,n){function i(t){var r=Z.right-Z.left,n=Z.bottom-Z.top,i=t.clientX-Z.left,a=t.clientY-Z.top,o=r>Y&&n>X&&!t.shiftKey?p.getCursor(i/r,1-a/n):\"move\";m(e,o),G=o.split(\"-\")[0]}function a(e){N=h.getFromId(t,r.xref),B=h.getFromId(t,r.yref),U=g.getDataToPixel(t,N),V=g.getDataToPixel(t,B,!0),H=g.getPixelToData(t,N),q=g.getPixelToData(t,B,!0);var a=\"shapes[\"+n+\"]\";\"path\"===r.type?(F=r.path,j=a+\".path\"):(v=U(r.x0),y=V(r.y0),b=U(r.x1),x=V(r.y1),_=a+\".x0\",w=a+\".y0\",M=a+\".x1\",k=a+\".y1\"),v<b?(S=v,z=a+\".x0\",O=\"x0\",E=b,I=a+\".x1\",R=\"x1\"):(S=b,z=a+\".x1\",O=\"x1\",E=v,I=a+\".x0\",R=\"x0\"),y<x?(A=y,L=a+\".y0\",D=\"y0\",T=x,C=a+\".y1\",P=\"y1\"):(A=x,L=a+\".y1\",D=\"y1\",T=y,C=a+\".y0\",P=\"y0\"),d={},i(e),W.moveFn=\"move\"===G?c:f}function s(r){m(e),r&&u.relayout(t,d)}function c(n,i){if(\"path\"===r.type){var a=function(t){return H(U(t)+n)};N&&\"date\"===N.type&&(a=g.encodeDate(a));var s=function(t){return q(V(t)+i)};B&&\"date\"===B.type&&(s=g.encodeDate(s)),r.path=l(F,a,s),d[j]=r.path}else d[_]=r.x0=H(v+n),d[w]=r.y0=q(y+i),d[M]=r.x1=H(b+n),d[k]=r.y1=q(x+i);e.attr(\"d\",o(t,r))}function f(n,i){if(\"path\"===r.type){var a=function(t){return H(U(t)+n)};N&&\"date\"===N.type&&(a=g.encodeDate(a));var s=function(t){return q(V(t)+i)};B&&\"date\"===B.type&&(s=g.encodeDate(s)),r.path=l(F,a,s),d[j]=r.path}else{var u=~G.indexOf(\"n\")?A+i:A,c=~G.indexOf(\"s\")?T+i:T,h=~G.indexOf(\"w\")?S+n:S,f=~G.indexOf(\"e\")?E+n:E;c-u>X&&(d[L]=r[D]=q(u),d[C]=r[P]=q(c)),f-h>Y&&(d[z]=r[O]=H(h),d[I]=r[R]=H(f))}e.attr(\"d\",o(t,r))}var d,v,y,b,x,_,w,M,k,A,T,S,E,L,C,z,I,D,P,O,R,F,j,N,B,U,V,H,q,G,Y=10,X=10,W={element:e.node(),gd:t,prepFn:a,doneFn:s},Z=W.element.getBoundingClientRect();p.init(W),e.node().onmousemove=i}function o(t,e){var r,n,i,a,o=e.type,l=h.getFromId(t,e.xref),u=h.getFromId(t,e.yref),c=t._fullLayout._size;if(l?(r=g.shapePositionToRange(l),n=function(t){return l._offset+l.r2p(r(t,!0))}):n=function(t){return c.l+c.w*t},u?(i=g.shapePositionToRange(u),a=function(t){return u._offset+u.r2p(i(t,!0))}):a=function(t){return c.t+c.h*(1-t)},\"path\"===o)return l&&\"date\"===l.type&&(n=g.decodeDate(n)),u&&\"date\"===u.type&&(a=g.decodeDate(a)),s(e.path,n,a);var f=n(e.x0),d=n(e.x1),p=a(e.y0),m=a(e.y1);if(\"line\"===o)return\"M\"+f+\",\"+p+\"L\"+d+\",\"+m;if(\"rect\"===o)return\"M\"+f+\",\"+p+\"H\"+d+\"V\"+m+\"H\"+f+\"Z\";var v=(f+d)/2,y=(p+m)/2,b=Math.abs(v-f),x=Math.abs(y-p),_=\"A\"+b+\",\"+x,w=v+b+\",\"+y;return\"M\"+w+_+\" 0 1,1 \"+v+\",\"+(y-x)+_+\" 0 0,1 \"+w+\"Z\"}function s(t,e,r){return t.replace(v.segmentRE,function(t){var n=0,i=t.charAt(0),a=v.paramIsX[i],o=v.paramIsY[i],s=v.numParams[i],l=t.substr(1).replace(v.paramRE,function(t){return a[n]?t=e(t):o[n]&&(t=r(t)),n++,n>s&&(t=\"X\"),t});return n>s&&(l=l.replace(/[\\s,]*X.*/,\"\"),c.log(\"Ignoring extra params in segment \"+t)),i+l})}function l(t,e,r){return t.replace(v.segmentRE,function(t){var n=0,i=t.charAt(0),a=v.paramIsX[i],o=v.paramIsY[i],s=v.numParams[i];return i+t.substr(1).replace(v.paramRE,function(t){return n>=s?t:(a[n]?t=e(t):o[n]&&(t=r(t)),n++,t)})})}var u=t(\"../../plotly\"),c=t(\"../../lib\"),h=t(\"../../plots/cartesian/axes\"),f=t(\"../color\"),d=t(\"../drawing\"),p=t(\"../dragelement\"),m=t(\"../../lib/setcursor\"),v=t(\"./constants\"),g=t(\"./helpers\");e.exports={draw:n,drawOne:i}},{\"../../lib\":725,\"../../lib/setcursor\":741,\"../../plotly\":761,\"../../plots/cartesian/axes\":766,\"../color\":603,\"../dragelement\":624,\"../drawing\":627,\"./constants\":681,\"./helpers\":684}],684:[function(t,e,r){\"use strict\";r.rangeToShapePosition=function(t){return\"log\"===t.type?t.r2d:function(t){return t}},r.shapePositionToRange=function(t){return\"log\"===t.type?t.d2r:function(t){return t}},r.decodeDate=function(t){return function(e){return e.replace&&(e=e.replace(\"_\",\" \")),t(e)}},r.encodeDate=function(t){return function(e){return t(e).replace(\" \",\"_\")}},r.getDataToPixel=function(t,e,n){var i,a=t._fullLayout._size;if(e){var o=r.shapePositionToRange(e);i=function(t){return e._offset+e.r2p(o(t,!0))},\"date\"===e.type&&(i=r.decodeDate(i))}else i=n?function(t){return a.t+a.h*(1-t)}:function(t){return a.l+a.w*t};return i},r.getPixelToData=function(t,e,n){var i,a=t._fullLayout._size;if(e){var o=r.rangeToShapePosition(e);i=function(t){return o(e.p2r(t-e._offset))}}else i=n?function(t){return 1-(t-a.t)/a.h}:function(t){return(t-a.l)/a.w};return i}},{}],685:[function(t,e,r){\"use strict\";var n=t(\"./draw\");e.exports={moduleType:\"component\",name:\"shapes\",layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),calcAutorange:t(\"./calc_autorange\"),draw:n.draw,drawOne:n.drawOne}},{\"./attributes\":679,\"./calc_autorange\":680,\"./defaults\":682,\"./draw\":683}],686:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"./attributes\"),o=t(\"./helpers\");e.exports=function(t,e,r,s,l){function u(r,i){return n.coerce(t,e,a,r,i)}if(s=s||{},l=l||{},!u(\"visible\",!l.itemIsNotPlainObject))return e;u(\"layer\"),u(\"opacity\"),u(\"fillcolor\"),u(\"line.color\"),u(\"line.width\"),u(\"line.dash\");for(var c=t.path?\"path\":\"rect\",h=u(\"type\",c),f=[\"x\",\"y\"],d=0;d<2;d++){var p=f[d],m={_fullLayout:r},v=i.coerceRef(t,e,m,p,\"\",\"paper\");if(\"path\"!==h){var g,y,b;\"paper\"!==v?(g=i.getFromId(m,v),b=o.rangeToShapePosition(g),y=o.shapePositionToRange(g)):y=b=n.identity;var x=p+\"0\",_=p+\"1\",w=t[x],M=t[_];t[x]=y(t[x],!0),t[_]=y(t[_],!0),i.coercePosition(e,m,u,v,x,.25),i.coercePosition(e,m,u,v,_,.75),e[x]=b(e[x]),e[_]=b(e[_]),t[x]=w,t[_]=M}}return\"path\"===h?u(\"path\"):n.noneOrAll(t,e,[\"x0\",\"x1\",\"y0\",\"y1\"]),e}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"./attributes\":679,\"./helpers\":684}],687:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../../plots/pad_attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"../../lib/extend\").extendDeep,s=t(\"../../plots/animation_attributes\"),l=t(\"./constants\"),u={_isLinkedToArray:\"step\",method:{valType:\"enumerated\",values:[\"restyle\",\"relayout\",\"animate\",\"update\",\"skip\"],dflt:\"restyle\"},args:{valType:\"info_array\",freeLength:!0,items:[{valType:\"any\"},{valType:\"any\"},{valType:\"any\"}]},label:{valType:\"string\"},value:{valType:\"string\"},execute:{valType:\"boolean\",dflt:!0}};e.exports={_isLinkedToArray:\"slider\",visible:{valType:\"boolean\",dflt:!0},active:{valType:\"number\",min:0,dflt:0},steps:u,lenmode:{valType:\"enumerated\",values:[\"fraction\",\"pixels\"],dflt:\"fraction\"},len:{valType:\"number\",min:0,dflt:1},x:{valType:\"number\",min:-2,max:3,dflt:0},pad:o({},i,{},{t:{dflt:20}}),xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"left\"},y:{valType:\"number\",min:-2,max:3,dflt:0},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"top\"},transition:{duration:{valType:\"number\",min:0,dflt:150},easing:{valType:\"enumerated\",values:s.transition.easing.values,dflt:\"cubic-in-out\"}},currentvalue:{visible:{valType:\"boolean\",dflt:!0},xanchor:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\"],dflt:\"left\"},offset:{valType:\"number\",dflt:10},prefix:{valType:\"string\"},suffix:{valType:\"string\"},font:a({},n,{})},font:a({},n,{}),activebgcolor:{valType:\"color\",dflt:l.gripBgActiveColor},bgcolor:{valType:\"color\",dflt:l.railBgColor},bordercolor:{valType:\"color\",dflt:l.railBorderColor},borderwidth:{valType:\"number\",min:0,dflt:l.railBorderWidth},ticklen:{valType:\"number\",min:0,dflt:l.tickLength},tickcolor:{valType:\"color\",dflt:l.tickColor},tickwidth:{valType:\"number\",min:0,dflt:1},minorticklen:{valType:\"number\",min:0,dflt:l.minorTickLength}}},{\"../../lib/extend\":716,\"../../plots/animation_attributes\":762,\"../../plots/font_attributes\":790,\"../../plots/pad_attributes\":828,\"./constants\":688}],688:[function(t,e,r){\"use strict\";e.exports={name:\"sliders\",containerClassName:\"slider-container\",groupClassName:\"slider-group\",inputAreaClass:\"slider-input-area\",railRectClass:\"slider-rail-rect\",railTouchRectClass:\"slider-rail-touch-rect\",gripRectClass:\"slider-grip-rect\",tickRectClass:\"slider-tick-rect\",inputProxyClass:\"slider-input-proxy\",labelsClass:\"slider-labels\",labelGroupClass:\"slider-label-group\",labelClass:\"slider-label\",currentValueClass:\"slider-current-value\",railHeight:5,menuIndexAttrName:\"slider-active-index\",autoMarginIdRoot:\"slider-\",minWidth:30,minHeight:30,textPadX:40,arrowOffsetX:4,railRadius:2,railWidth:5,railBorder:4,railBorderWidth:1,railBorderColor:\"#bec8d9\",railBgColor:\"#f8fafc\",railInset:8,stepInset:10,gripRadius:10,gripWidth:20,gripHeight:20,gripBorder:20,gripBorderWidth:1,gripBorderColor:\"#bec8d9\",gripBgColor:\"#f6f8fa\",gripBgActiveColor:\"#dbdde0\",labelPadding:8,labelOffset:0,tickWidth:1,tickColor:\"#333\",tickOffset:25,tickLength:7,minorTickOffset:25,minorTickColor:\"#333\",minorTickLength:4,currentValuePadding:8,currentValueInset:0}},{}],689:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return a.coerce(t,e,s,r,n)}n(\"visible\",i(t,e).length>0)&&(n(\"active\"),n(\"x\"),n(\"y\"),a.noneOrAll(t,e,[\"x\",\"y\"]),n(\"xanchor\"),n(\"yanchor\"),n(\"len\"),n(\"lenmode\"),n(\"pad.t\"),n(\"pad.r\"),n(\"pad.b\"),n(\"pad.l\"),a.coerceFont(n,\"font\",r.font),n(\"currentvalue.visible\")&&(n(\"currentvalue.xanchor\"),n(\"currentvalue.prefix\"),n(\"currentvalue.suffix\"),n(\"currentvalue.offset\"),a.coerceFont(n,\"currentvalue.font\",e.font)),n(\"transition.duration\"),n(\"transition.easing\"),n(\"bgcolor\"),n(\"activebgcolor\"),n(\"bordercolor\"),n(\"borderwidth\"),n(\"ticklen\"),n(\"tickwidth\"),n(\"tickcolor\"),n(\"minorticklen\"))}function i(t,e){function r(t,e){return a.coerce(n,i,c,t,e)}for(var n,i,o=t.steps||[],s=e.steps=[],l=0;l<o.length;l++)n=o[l],i={},r(\"method\"),a.isPlainObject(n)&&(\"skip\"===i.method||Array.isArray(n.args))&&(r(\"args\"),r(\"label\",\"step-\"+l),r(\"value\",i.label),r(\"execute\"),s.push(i));return s}var a=t(\"../../lib\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\"),l=t(\"./constants\"),u=l.name,c=s.steps;e.exports=function(t,e){o(t,e,{name:u,handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"./attributes\":687,\"./constants\":688}],690:[function(t,e,r){\"use strict\";function n(t,e){for(var r=t[E.name],n=[],i=0;i<r.length;i++){var a=r[i];a.visible&&a.steps.length&&(a.gd=e,n.push(a))}return n}function i(t){return t._index}function a(t,e){var r=A.tester.selectAll(\"g.\"+E.labelGroupClass).data(e.steps);r.enter().append(\"g\").classed(E.labelGroupClass,!0);var n=0,i=0;r.each(function(t){var r=w.select(this),a=u(r,{step:t},e),o=a.node();if(o){var s=A.bBox(o);i=Math.max(i,s.height),n=Math.max(n,s.width)}}),r.remove(),e.inputAreaWidth=Math.max(E.railWidth,E.gripHeight);var a=t._fullLayout._size;e.lx=a.l+a.w*e.x,e.ly=a.t+a.h*(1-e.y),\"fraction\"===e.lenmode?e.outerLength=Math.round(a.w*e.len):e.outerLength=e.len,e.lenPad=Math.round(.5*E.gripWidth),e.inputAreaStart=0,e.inputAreaLength=Math.round(e.outerLength-e.pad.l-e.pad.r);var o=e.inputAreaLength-2*E.stepInset,l=o/(e.steps.length-1),c=n+E.labelPadding;if(e.labelStride=Math.max(1,Math.ceil(c/l)),e.labelHeight=i,e.currentValueMaxWidth=0,e.currentValueHeight=0,e.currentValueTotalHeight=0,e.currentValueMaxLines=1,e.currentvalue.visible){var h=A.tester.append(\"g\");r.each(function(t){var r=s(h,e,t.label),n=r.node()&&A.bBox(r.node())||{width:0,height:0},i=T.lineCount(r);e.currentValueMaxWidth=Math.max(e.currentValueMaxWidth,Math.ceil(n.width)),e.currentValueHeight=Math.max(e.currentValueHeight,Math.ceil(n.height)),e.currentValueMaxLines=Math.max(e.currentValueMaxLines,i)}),e.currentValueTotalHeight=e.currentValueHeight+e.currentvalue.offset,h.remove()}e.height=e.currentValueTotalHeight+E.tickOffset+e.ticklen+E.labelOffset+e.labelHeight+e.pad.t+e.pad.b;var f=\"left\";S.isRightAnchor(e)&&(e.lx-=e.outerLength,f=\"right\"),S.isCenterAnchor(e)&&(e.lx-=e.outerLength/2,f=\"center\");var d=\"top\";S.isBottomAnchor(e)&&(e.ly-=e.height,d=\"bottom\"),S.isMiddleAnchor(e)&&(e.ly-=e.height/2,d=\"middle\"),e.outerLength=Math.ceil(e.outerLength),e.height=Math.ceil(e.height),e.lx=Math.round(e.lx),e.ly=Math.round(e.ly),M.autoMargin(t,E.autoMarginIdRoot+e._index,{x:e.x,y:e.y,l:e.outerLength*({right:1,center:.5}[f]||0),r:e.outerLength*({left:1,center:.5}[f]||0),b:e.height*({top:1,middle:.5}[d]||0),t:e.height*({bottom:1,middle:.5}[d]||0)})}function o(t,e,r){r.active>=r.steps.length&&(r.active=0),e.call(s,r).call(x,r).call(c,r).call(p,r).call(b,t,r).call(l,t,r),A.setTranslate(e,r.lx+r.pad.l,r.ly+r.pad.t),e.call(v,r,r.active/(r.steps.length-1),!1),e.call(s,r)}function s(t,e,r){if(e.currentvalue.visible){var n,i,a=t.selectAll(\"text\").data([0]);switch(e.currentvalue.xanchor){case\"right\":n=e.inputAreaLength-E.currentValueInset-e.currentValueMaxWidth,i=\"left\";break;case\"center\":n=.5*e.inputAreaLength,i=\"middle\";break;default:n=E.currentValueInset,i=\"left\"}a.enter().append(\"text\").classed(E.labelClass,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":i,\"data-notex\":1});var o=e.currentvalue.prefix?e.currentvalue.prefix:\"\";if(\"string\"==typeof r)o+=r;else{o+=e.steps[e.active].label}e.currentvalue.suffix&&(o+=e.currentvalue.suffix),a.call(A.font,e.currentvalue.font).text(o).call(T.convertToTspans,e.gd);var s=T.lineCount(a),l=(e.currentValueMaxLines+1-s)*e.currentvalue.font.size*L;return T.positionText(a,n,l),a}}function l(t,e,r){var n=t.selectAll(\"rect.\"+E.gripRectClass).data([0]);n.enter().append(\"rect\").classed(E.gripRectClass,!0).call(d,e,t,r).style(\"pointer-events\",\"all\"),n.attr({width:E.gripWidth,height:E.gripHeight,rx:E.gripRadius,ry:E.gripRadius}).call(k.stroke,r.bordercolor).call(k.fill,r.bgcolor).style(\"stroke-width\",r.borderwidth+\"px\")}function u(t,e,r){var n=t.selectAll(\"text\").data([0]);return n.enter().append(\"text\").classed(E.labelClass,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":\"middle\",\"data-notex\":1}),n.call(A.font,r.font).text(e.step.label).call(T.convertToTspans,r.gd),n}function c(t,e){var r=t.selectAll(\"g.\"+E.labelsClass).data([0]);r.enter().append(\"g\").classed(E.labelsClass,!0);var n=r.selectAll(\"g.\"+E.labelGroupClass).data(e.labelSteps);n.enter().append(\"g\").classed(E.labelGroupClass,!0),n.exit().remove(),n.each(function(t){var r=w.select(this);r.call(u,t,e),A.setTranslate(r,g(e,t.fraction),E.tickOffset+e.ticklen+e.font.size*L+E.labelOffset+e.currentValueTotalHeight)})}function h(t,e,r,n,i){var a=Math.round(n*(r.steps.length-1));a!==r.active&&f(t,e,r,a,!0,i)}function f(t,e,r,n,i,a){var o=r.active;r._input.active=r.active=n;var l=r.steps[r.active];e.call(v,r,r.active/(r.steps.length-1),a),e.call(s,r),t.emit(\"plotly_sliderchange\",{slider:r,step:r.steps[r.active],interaction:i,previousActive:o}),l&&l.method&&i&&(e._nextMethod?(e._nextMethod.step=l,e._nextMethod.doCallback=i,e._nextMethod.doTransition=a):(e._nextMethod={step:l,doCallback:i,doTransition:a},e._nextMethodRaf=window.requestAnimationFrame(function(){var r=e._nextMethod.step;r.method&&(r.execute&&M.executeAPICommand(t,r.method,r.args),e._nextMethod=null,e._nextMethodRaf=null)})))}function d(t,e,r){function n(){return r.data()[0]}var i=r.node(),a=w.select(e);t.on(\"mousedown\",function(){var t=n();e.emit(\"plotly_sliderstart\",{slider:t});var o=r.select(\".\"+E.gripRectClass);w.event.stopPropagation(),w.event.preventDefault(),o.call(k.fill,t.activebgcolor);var s=y(t,w.mouse(i)[0]);h(e,r,t,s,!0),t._dragging=!0,a.on(\"mousemove\",function(){var t=n(),a=y(t,w.mouse(i)[0]);h(e,r,t,a,!1)}),a.on(\"mouseup\",function(){var t=n();t._dragging=!1,o.call(k.fill,t.bgcolor),a.on(\"mouseup\",null),a.on(\"mousemove\",null),e.emit(\"plotly_sliderend\",{slider:t,step:t.steps[t.active]})})})}function p(t,e){var r=t.selectAll(\"rect.\"+E.tickRectClass).data(e.steps);r.enter().append(\"rect\").classed(E.tickRectClass,!0),r.exit().remove(),r.attr({width:e.tickwidth+\"px\",\"shape-rendering\":\"crispEdges\"}),r.each(function(t,r){var n=r%e.labelStride==0,i=w.select(this);i.attr({height:n?e.ticklen:e.minorticklen}).call(k.fill,e.tickcolor),A.setTranslate(i,g(e,r/(e.steps.length-1))-.5*e.tickwidth,(n?E.tickOffset:E.minorTickOffset)+e.currentValueTotalHeight)})}function m(t){t.labelSteps=[];for(var e=t.steps.length,r=0;r<e;r+=t.labelStride)t.labelSteps.push({fraction:r/(e-1),step:t.steps[r]})}function v(t,e,r,n){var i=t.select(\"rect.\"+E.gripRectClass),a=g(e,r);if(!e._invokingCommand){var o=i;n&&e.transition.duration>0&&(o=o.transition().duration(e.transition.duration).ease(e.transition.easing)),o.attr(\"transform\",\"translate(\"+(a-.5*E.gripWidth)+\",\"+e.currentValueTotalHeight+\")\")}}function g(t,e){return t.inputAreaStart+E.stepInset+(t.inputAreaLength-2*E.stepInset)*Math.min(1,Math.max(0,e))}function y(t,e){return Math.min(1,Math.max(0,(e-E.stepInset-t.inputAreaStart)/(t.inputAreaLength-2*E.stepInset-2*t.inputAreaStart)))}function b(t,e,r){var n=t.selectAll(\"rect.\"+E.railTouchRectClass).data([0]);n.enter().append(\"rect\").classed(E.railTouchRectClass,!0).call(d,e,t,r).style(\"pointer-events\",\"all\"),n.attr({width:r.inputAreaLength,height:Math.max(r.inputAreaWidth,E.tickOffset+r.ticklen+r.labelHeight)}).call(k.fill,r.bgcolor).attr(\"opacity\",0),A.setTranslate(n,0,r.currentValueTotalHeight)}function x(t,e){var r=t.selectAll(\"rect.\"+E.railRectClass).data([0]);r.enter().append(\"rect\").classed(E.railRectClass,!0);var n=e.inputAreaLength-2*E.railInset;r.attr({width:n,height:E.railWidth,rx:E.railRadius,ry:E.railRadius,\"shape-rendering\":\"crispEdges\"}).call(k.stroke,e.bordercolor).call(k.fill,e.bgcolor).style(\"stroke-width\",e.borderwidth+\"px\"),A.setTranslate(r,E.railInset,.5*(e.inputAreaWidth-E.railWidth)+e.currentValueTotalHeight)}function _(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(E.autoMarginIdRoot)&&M.autoMargin(t,i)}}var w=t(\"d3\"),M=t(\"../../plots/plots\"),k=t(\"../color\"),A=t(\"../drawing\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../legend/anchor_utils\"),E=t(\"./constants\"),L=t(\"../../constants/alignment\").LINE_SPACING;e.exports=function(t){var e=t._fullLayout,r=n(e,t),s=e._infolayer.selectAll(\"g.\"+E.containerClassName).data(r.length>0?[0]:[]);if(s.enter().append(\"g\").classed(E.containerClassName,!0).style(\"cursor\",\"ew-resize\"),s.exit().remove(),s.exit().size()&&_(t),0!==r.length){var l=s.selectAll(\"g.\"+E.groupClassName).data(r,i);l.enter().append(\"g\").classed(E.groupClassName,!0),l.exit().each(function(e){w.select(this).remove(),e._commandObserver.remove(),delete e._commandObserver,M.autoMargin(t,E.autoMarginIdRoot+e._index)});for(var u=0;u<r.length;u++){var c=r[u];a(t,c)}l.each(function(e){if(!(e.steps.length<2)){var r=w.select(this);m(e),M.manageCommandObserver(t,e,e.steps,function(e){var n=r.data()[0];n.active!==e.index&&(n._dragging||f(t,r,n,e.index,!1,!0))}),o(t,w.select(this),e)}})}}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":688,d3:121}],691:[function(t,e,r){\"use strict\";var n=t(\"./constants\");e.exports={moduleType:\"component\",name:n.name,layoutAttributes:t(\"./attributes\"),supplyLayoutDefaults:t(\"./defaults\"),draw:t(\"./draw\")}},{\"./attributes\":687,\"./constants\":688,\"./defaults\":689,\"./draw\":690}],692:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../../plotly\"),o=t(\"../../plots/plots\"),s=t(\"../../lib\"),l=t(\"../drawing\"),u=t(\"../color\"),c=t(\"../../lib/svg_text_utils\"),h=t(\"../../constants/interactions\"),f=/Click to enter .+ title/;(e.exports={}).draw=function(t,e,r){function d(t){s.syncOrAsync([p,m],t)}function p(e){return e.attr(\"transform\",M?\"rotate(\"+[M.rotate,w.x,w.y]+\") translate(0, \"+M.offset+\")\":null),e.style({\"font-family\":T,\"font-size\":n.round(S,2)+\"px\",fill:u.rgb(E),opacity:L*u.opacity(E),\"font-weight\":o.fontWeight}).attr(w).call(c.convertToTspans,t),o.previousPromises(t)}function m(t){var e=n.select(t.node().parentNode);if(_&&_.selection&&_.side&&z){e.attr(\"transform\",null);var r=0,a={left:\"right\",right:\"left\",top:\"bottom\",bottom:\"top\"}[_.side],o=-1!==[\"left\",\"top\"].indexOf(_.side)?-1:1,u=i(_.pad)?_.pad:2,c=l.bBox(e.node()),h={left:0,top:0,right:A.width,bottom:A.height},f=_.maxShift||(h[_.side]-c[_.side])*(\"left\"===_.side||\"top\"===_.side?-1:1);if(f<0)r=f;else{var d=_.offsetLeft||0,p=_.offsetTop||0;c.left-=d,c.right-=d,c.top-=p,c.bottom-=p,_.selection.each(function(){var t=l.bBox(this);s.bBoxIntersect(c,t,u)&&(r=Math.max(r,o*(t[_.side]-c[a])+u))}),r=Math.min(f,r)}if(r>0||f<0){var m={left:[-r,0],right:[r,0],top:[0,-r],bottom:[0,r]}[_.side];e.attr(\"transform\",\"translate(\"+m+\")\")}}}var v,g=r.propContainer,y=r.propName,b=r.traceIndex,x=r.dfltName,_=r.avoid||{},w=r.attributes,M=r.transform,k=r.containerGroup,A=t._fullLayout,T=g.titlefont.family,S=g.titlefont.size,E=g.titlefont.color,L=1,C=!1,z=g.title.trim();\"title\"===y?v=\"titleText\":-1!==y.indexOf(\"axis\")?v=\"axisTitleText\":y.indexOf(!0)&&(v=\"colorbarTitleText\");var I=t._context.edits[v];\"\"===z&&(L=0),z.match(f)&&(L=.2,C=!0,I||(z=\"\"));var D=z||I;k||(k=A._infolayer.selectAll(\".g-\"+e).data([0]),k.enter().append(\"g\").classed(\"g-\"+e,!0));var P=k.selectAll(\"text\").data(D?[0]:[]);if(P.enter().append(\"text\"),P.text(z).attr(\"class\",e),P.exit().remove(),D){P.call(d);var O=\"Click to enter \"+x+\" title\";I&&(z?P.on(\".opacity\",null):function(){L=0,C=!0,z=O,P.text(z).on(\"mouseover.opacity\",function(){n.select(this).transition().duration(h.SHOW_PLACEHOLDER).style(\"opacity\",1)}).on(\"mouseout.opacity\",function(){n.select(this).transition().duration(h.HIDE_PLACEHOLDER).style(\"opacity\",0)})}(),P.call(c.makeEditable,{gd:t}).on(\"edit\",function(e){void 0!==b?a.restyle(t,y,e,b):a.relayout(t,y,e)}).on(\"cancel\",function(){this.text(this.attr(\"data-unformatted\")).call(d)}).on(\"input\",function(t){this.text(t||\" \").call(c.positionText,w.x,w.y)})),P.classed(\"js-placeholder\",C)}}},{\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,d3:121,\"fast-isnumeric\":130}],693:[function(t,e,r){\"use strict\";var n=t(\"../../plots/font_attributes\"),i=t(\"../color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=t(\"../../plots/pad_attributes\"),s={_isLinkedToArray:\"button\",method:{valType:\"enumerated\",values:[\"restyle\",\"relayout\",\"animate\",\"update\",\"skip\"],dflt:\"restyle\"},args:{valType:\"info_array\",freeLength:!0,items:[{valType:\"any\"},{valType:\"any\"},{valType:\"any\"}]},label:{valType:\"string\",dflt:\"\"},execute:{valType:\"boolean\",dflt:!0}};e.exports={_isLinkedToArray:\"updatemenu\",_arrayAttrRegexps:[/^updatemenus\\[(0|[1-9][0-9]+)\\]\\.buttons/],visible:{valType:\"boolean\"},type:{valType:\"enumerated\",values:[\"dropdown\",\"buttons\"],dflt:\"dropdown\"},direction:{valType:\"enumerated\",values:[\"left\",\"right\",\"up\",\"down\"],dflt:\"down\"},active:{valType:\"integer\",min:-1,dflt:0},showactive:{valType:\"boolean\",dflt:!0},buttons:s,x:{valType:\"number\",min:-2,max:3,dflt:-.05},xanchor:{valType:\"enumerated\",values:[\"auto\",\"left\",\"center\",\"right\"],dflt:\"right\"},y:{valType:\"number\",min:-2,max:3,dflt:1},yanchor:{valType:\"enumerated\",values:[\"auto\",\"top\",\"middle\",\"bottom\"],dflt:\"top\"},pad:a({},o,{}),font:a({},n,{}),bgcolor:{valType:\"color\"},bordercolor:{valType:\"color\",dflt:i.borderLine},borderwidth:{valType:\"number\",min:0,dflt:1}}},{\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../../plots/pad_attributes\":828,\"../color/attributes\":602}],694:[function(t,e,r){\"use strict\";e.exports={name:\"updatemenus\",containerClassName:\"updatemenu-container\",headerGroupClassName:\"updatemenu-header-group\",headerClassName:\"updatemenu-header\",headerArrowClassName:\"updatemenu-header-arrow\",dropdownButtonGroupClassName:\"updatemenu-dropdown-button-group\",dropdownButtonClassName:\"updatemenu-dropdown-button\",buttonClassName:\"updatemenu-button\",itemRectClassName:\"updatemenu-item-rect\",itemTextClassName:\"updatemenu-item-text\",\n",
       "menuIndexAttrName:\"updatemenu-active-index\",autoMarginIdRoot:\"updatemenu-\",blankHeaderOpts:{label:\"  \"},minWidth:30,minHeight:30,textPadX:24,arrowPadX:16,rx:2,ry:2,textOffsetX:12,textOffsetY:3,arrowOffsetX:4,gapButtonHeader:5,gapButton:2,activeColor:\"#F4FAFF\",hoverColor:\"#F4FAFF\",arrowSymbol:{left:\"\\u25c4\",right:\"\\u25ba\",up:\"\\u25b2\",down:\"\\u25bc\"}}},{}],695:[function(t,e,r){\"use strict\";function n(t,e,r){function n(r,n){return a.coerce(t,e,s,r,n)}n(\"visible\",i(t,e).length>0)&&(n(\"active\"),n(\"direction\"),n(\"type\"),n(\"showactive\"),n(\"x\"),n(\"y\"),a.noneOrAll(t,e,[\"x\",\"y\"]),n(\"xanchor\"),n(\"yanchor\"),n(\"pad.t\"),n(\"pad.r\"),n(\"pad.b\"),n(\"pad.l\"),a.coerceFont(n,\"font\",r.font),n(\"bgcolor\",r.paper_bgcolor),n(\"bordercolor\"),n(\"borderwidth\"))}function i(t,e){function r(t,e){return a.coerce(n,i,c,t,e)}for(var n,i,o=t.buttons||[],s=e.buttons=[],l=0;l<o.length;l++)n=o[l],i={},r(\"method\"),a.isPlainObject(n)&&(\"skip\"===i.method||Array.isArray(n.args))&&(r(\"args\"),r(\"label\"),r(\"execute\"),i._index=l,s.push(i));return s}var a=t(\"../../lib\"),o=t(\"../../plots/array_container_defaults\"),s=t(\"./attributes\"),l=t(\"./constants\"),u=l.name,c=s.buttons;e.exports=function(t,e){o(t,e,{name:u,handleItemDefaults:n})}},{\"../../lib\":725,\"../../plots/array_container_defaults\":763,\"./attributes\":693,\"./constants\":694}],696:[function(t,e,r){\"use strict\";function n(t){for(var e=t[L.name],r=[],n=0;n<e.length;n++){var i=e[n];i.visible&&r.push(i)}return r}function i(t){return t._index}function a(t){return-1==+t.attr(L.menuIndexAttrName)}function o(t,e){return+t.attr(L.menuIndexAttrName)===e._index}function s(t,e,r,n,i,a,o,s){e._input.active=e.active=o,\"buttons\"===e.type?u(t,n,null,null,e):\"dropdown\"===e.type&&(i.attr(L.menuIndexAttrName,\"-1\"),l(t,n,i,a,e),s||u(t,n,i,a,e))}function l(t,e,r,n,i){var a=e.selectAll(\"g.\"+L.headerClassName).data([0]);a.enter().append(\"g\").classed(L.headerClassName,!0).style(\"pointer-events\",\"all\");var s=i.active,l=i.buttons[s]||L.blankHeaderOpts,c={y:i.pad.t,yPad:0,x:i.pad.l,xPad:0,index:0},h={width:i.headerWidth,height:i.headerHeight};a.call(f,i,l,t).call(b,i,c,h);var d=e.selectAll(\"text.\"+L.headerArrowClassName).data([0]);d.enter().append(\"text\").classed(L.headerArrowClassName,!0).classed(\"user-select-none\",!0).attr(\"text-anchor\",\"end\").call(A.font,i.font).text(L.arrowSymbol[i.direction]),d.attr({x:i.headerWidth-L.arrowOffsetX+i.pad.l,y:i.headerHeight/2+L.textOffsetY+i.pad.t}),a.on(\"click\",function(){r.call(x),r.attr(L.menuIndexAttrName,o(r,i)?-1:String(i._index)),u(t,e,r,n,i)}),a.on(\"mouseover\",function(){a.call(v)}),a.on(\"mouseout\",function(){a.call(g,i)}),A.setTranslate(e,i.lx,i.ly)}function u(t,e,r,n,i){r||(r=e,r.attr(\"pointer-events\",\"all\"));var o=a(r)&&\"buttons\"!==i.type?[]:i.buttons,l=\"dropdown\"===i.type?L.dropdownButtonClassName:L.buttonClassName,u=r.selectAll(\"g.\"+l).data(o),d=u.enter().append(\"g\").classed(l,!0),p=u.exit();\"dropdown\"===i.type?(d.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\"),p.transition().attr(\"opacity\",\"0\").remove()):p.remove();var y=0,x=0,_=-1!==[\"up\",\"down\"].indexOf(i.direction);\"dropdown\"===i.type&&(_?x=i.headerHeight+L.gapButtonHeader:y=i.headerWidth+L.gapButtonHeader),\"dropdown\"===i.type&&\"up\"===i.direction&&(x=-L.gapButtonHeader+L.gapButton-i.openHeight),\"dropdown\"===i.type&&\"left\"===i.direction&&(y=-L.gapButtonHeader+L.gapButton-i.openWidth);var k={x:i.lx+y+i.pad.l,y:i.ly+x+i.pad.t,yPad:L.gapButton,xPad:L.gapButton,index:0},A={l:k.x+i.borderwidth,t:k.y+i.borderwidth};u.each(function(a,o){var l=w.select(this);l.call(f,i,a,t).call(b,i,k),l.on(\"click\",function(){w.event.defaultPrevented||(s(t,i,a,e,r,n,o),a.execute&&M.executeAPICommand(t,a.method,a.args),t.emit(\"plotly_buttonclicked\",{menu:i,button:a,active:i.active}))}),l.on(\"mouseover\",function(){l.call(v)}),l.on(\"mouseout\",function(){l.call(g,i),u.call(m,i)})}),u.call(m,i),_?(A.w=Math.max(i.openWidth,i.headerWidth),A.h=k.y-A.t):(A.w=k.x-A.l,A.h=Math.max(i.openHeight,i.headerHeight)),A.direction=i.direction,n&&(u.size()?c(t,e,r,n,i,A):h(n))}function c(t,e,r,n,i,a){var o,s,l,u=i.direction,c=\"up\"===u||\"down\"===u,h=i.active;if(c)for(s=0,l=0;l<h;l++)s+=i.heights[l]+L.gapButton;else for(o=0,l=0;l<h;l++)o+=i.widths[l]+L.gapButton;n.enable(a,o,s),n.hbar&&n.hbar.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\"),n.vbar&&n.vbar.attr(\"opacity\",\"0\").transition().attr(\"opacity\",\"1\")}function h(t){var e=!!t.hbar,r=!!t.vbar;e&&t.hbar.transition().attr(\"opacity\",\"0\").each(\"end\",function(){e=!1,r||t.disable()}),r&&t.vbar.transition().attr(\"opacity\",\"0\").each(\"end\",function(){r=!1,e||t.disable()})}function f(t,e,r,n){t.call(d,e).call(p,e,r,n)}function d(t,e){var r=t.selectAll(\"rect\").data([0]);r.enter().append(\"rect\").classed(L.itemRectClassName,!0).attr({rx:L.rx,ry:L.ry,\"shape-rendering\":\"crispEdges\"}),r.call(k.stroke,e.bordercolor).call(k.fill,e.bgcolor).style(\"stroke-width\",e.borderwidth+\"px\")}function p(t,e,r,n){var i=t.selectAll(\"text\").data([0]);i.enter().append(\"text\").classed(L.itemTextClassName,!0).classed(\"user-select-none\",!0).attr({\"text-anchor\":\"start\",\"data-notex\":1}),i.call(A.font,e.font).text(r.label).call(T.convertToTspans,n)}function m(t,e){var r=e.active;t.each(function(t,n){var i=w.select(this);n===r&&e.showactive&&i.select(\"rect.\"+L.itemRectClassName).call(k.fill,L.activeColor)})}function v(t){t.select(\"rect.\"+L.itemRectClassName).call(k.fill,L.hoverColor)}function g(t,e){t.select(\"rect.\"+L.itemRectClassName).call(k.fill,e.bgcolor)}function y(t,e){e.width1=0,e.height1=0,e.heights=[],e.widths=[],e.totalWidth=0,e.totalHeight=0,e.openWidth=0,e.openHeight=0,e.lx=0,e.ly=0;var r=A.tester.selectAll(\"g.\"+L.dropdownButtonClassName).data(e.buttons);r.enter().append(\"g\").classed(L.dropdownButtonClassName,!0);var n=-1!==[\"up\",\"down\"].indexOf(e.direction);r.each(function(r,i){var a=w.select(this);a.call(f,e,r,t);var o=a.select(\".\"+L.itemTextClassName),s=o.node()&&A.bBox(o.node()).width,l=Math.max(s+L.textPadX,L.minWidth),u=e.font.size*E,c=T.lineCount(o),h=Math.max(u*c,L.minHeight)+L.textOffsetY;h=Math.ceil(h),l=Math.ceil(l),e.widths[i]=l,e.heights[i]=h,e.height1=Math.max(e.height1,h),e.width1=Math.max(e.width1,l),n?(e.totalWidth=Math.max(e.totalWidth,l),e.openWidth=e.totalWidth,e.totalHeight+=h+L.gapButton,e.openHeight+=h+L.gapButton):(e.totalWidth+=l+L.gapButton,e.openWidth+=l+L.gapButton,e.totalHeight=Math.max(e.totalHeight,h),e.openHeight=e.totalHeight)}),n?e.totalHeight-=L.gapButton:e.totalWidth-=L.gapButton,e.headerWidth=e.width1+L.arrowPadX,e.headerHeight=e.height1,\"dropdown\"===e.type&&(n?(e.width1+=L.arrowPadX,e.totalHeight=e.height1):e.totalWidth=e.width1,e.totalWidth+=L.arrowPadX),r.remove();var i=e.totalWidth+e.pad.l+e.pad.r,a=e.totalHeight+e.pad.t+e.pad.b,o=t._fullLayout._size;e.lx=o.l+o.w*e.x,e.ly=o.t+o.h*(1-e.y);var s=\"left\";S.isRightAnchor(e)&&(e.lx-=i,s=\"right\"),S.isCenterAnchor(e)&&(e.lx-=i/2,s=\"center\");var l=\"top\";S.isBottomAnchor(e)&&(e.ly-=a,l=\"bottom\"),S.isMiddleAnchor(e)&&(e.ly-=a/2,l=\"middle\"),e.totalWidth=Math.ceil(e.totalWidth),e.totalHeight=Math.ceil(e.totalHeight),e.lx=Math.round(e.lx),e.ly=Math.round(e.ly),M.autoMargin(t,L.autoMarginIdRoot+e._index,{x:e.x,y:e.y,l:i*({right:1,center:.5}[s]||0),r:i*({left:1,center:.5}[s]||0),b:a*({top:1,middle:.5}[l]||0),t:a*({bottom:1,middle:.5}[l]||0)})}function b(t,e,r,n){n=n||{};var i=t.select(\".\"+L.itemRectClassName),a=t.select(\".\"+L.itemTextClassName),o=e.borderwidth,s=r.index;A.setTranslate(t,o+r.x,o+r.y);var l=-1!==[\"up\",\"down\"].indexOf(e.direction),u=n.height||(l?e.heights[s]:e.height1);i.attr({x:0,y:0,width:n.width||(l?e.width1:e.widths[s]),height:u});var c=e.font.size*E,h=T.lineCount(a),f=(h-1)*c/2;T.positionText(a,L.textOffsetX,u/2-f+L.textOffsetY),l?r.y+=e.heights[s]+r.yPad:r.x+=e.widths[s]+r.xPad,r.index++}function x(t){t.selectAll(\"g.\"+L.dropdownButtonClassName).remove()}function _(t){for(var e=t._fullLayout._pushmargin||{},r=Object.keys(e),n=0;n<r.length;n++){var i=r[n];-1!==i.indexOf(L.autoMarginIdRoot)&&M.autoMargin(t,i)}}var w=t(\"d3\"),M=t(\"../../plots/plots\"),k=t(\"../color\"),A=t(\"../drawing\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../legend/anchor_utils\"),E=t(\"../../constants/alignment\").LINE_SPACING,L=t(\"./constants\"),C=t(\"./scrollbox\");e.exports=function(t){var e=t._fullLayout,r=n(e),a=e._infolayer.selectAll(\"g.\"+L.containerClassName).data(r.length>0?[0]:[]);if(a.enter().append(\"g\").classed(L.containerClassName,!0).style(\"cursor\",\"pointer\"),a.exit().remove(),a.exit().size()&&_(t),0!==r.length){var c=a.selectAll(\"g.\"+L.headerGroupClassName).data(r,i);c.enter().append(\"g\").classed(L.headerGroupClassName,!0);var h=a.selectAll(\"g.\"+L.dropdownButtonGroupClassName).data([0]);h.enter().append(\"g\").classed(L.dropdownButtonGroupClassName,!0).style(\"pointer-events\",\"all\");for(var f=0;f<r.length;f++){var d=r[f];y(t,d)}var p=\"updatemenus\"+e._uid,m=new C(t,h,p);c.enter().size()&&h.call(x).attr(L.menuIndexAttrName,\"-1\"),c.exit().each(function(e){w.select(this).remove(),h.call(x).attr(L.menuIndexAttrName,\"-1\"),M.autoMargin(t,L.autoMarginIdRoot+e._index)}),c.each(function(e){var r=w.select(this),n=\"dropdown\"===e.type?h:null;M.manageCommandObserver(t,e,e.buttons,function(i){s(t,e,e.buttons[i.index],r,n,m,i.index,!0)}),\"dropdown\"===e.type?(l(t,r,h,m,e),o(h,e)&&u(t,r,h,m,e)):u(t,r,null,null,e)})}}},{\"../../constants/alignment\":699,\"../../lib/svg_text_utils\":745,\"../../plots/plots\":829,\"../color\":603,\"../drawing\":627,\"../legend/anchor_utils\":653,\"./constants\":694,\"./scrollbox\":698,d3:121}],697:[function(t,e,r){arguments[4][691][0].apply(r,arguments)},{\"./attributes\":693,\"./constants\":694,\"./defaults\":695,\"./draw\":696,dup:691}],698:[function(t,e,r){\"use strict\";function n(t,e,r){this.gd=t,this.container=e,this.id=r,this.position=null,this.translateX=null,this.translateY=null,this.hbar=null,this.vbar=null,this.bg=this.container.selectAll(\"rect.scrollbox-bg\").data([0]),this.bg.exit().on(\".drag\",null).on(\"wheel\",null).remove(),this.bg.enter().append(\"rect\").classed(\"scrollbox-bg\",!0).style(\"pointer-events\",\"all\").attr({opacity:0,x:0,y:0,width:0,height:0})}e.exports=n;var i=t(\"d3\"),a=t(\"../color\"),o=t(\"../drawing\"),s=t(\"../../lib\");n.barWidth=2,n.barLength=20,n.barRadius=2,n.barPad=1,n.barColor=\"#808BA4\",n.prototype.enable=function(t,e,r){var s=this.gd._fullLayout,l=s.width,u=s.height;this.position=t;var c,h,f,d,p=this.position.l,m=this.position.w,v=this.position.t,g=this.position.h,y=this.position.direction,b=\"down\"===y,x=\"left\"===y,_=\"right\"===y,w=\"up\"===y,M=m,k=g;b||x||_||w||(this.position.direction=\"down\",b=!0),b||w?(c=p,h=c+M,b?(f=v,d=Math.min(f+k,u),k=d-f):(d=v+k,f=Math.max(d-k,0),k=d-f)):(f=v,d=f+k,x?(h=p+M,c=Math.max(h-M,0),M=h-c):(c=p,h=Math.min(c+M,l),M=h-c)),this._box={l:c,t:f,w:M,h:k};var A=m>M,T=n.barLength+2*n.barPad,S=n.barWidth+2*n.barPad,E=p,L=v+g;L+S>u&&(L=u-S);var C=this.container.selectAll(\"rect.scrollbar-horizontal\").data(A?[0]:[]);C.exit().on(\".drag\",null).remove(),C.enter().append(\"rect\").classed(\"scrollbar-horizontal\",!0).call(a.fill,n.barColor),A?(this.hbar=C.attr({rx:n.barRadius,ry:n.barRadius,x:E,y:L,width:T,height:S}),this._hbarXMin=E+T/2,this._hbarTranslateMax=M-T):(delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax);var z=g>k,I=n.barWidth+2*n.barPad,D=n.barLength+2*n.barPad,P=p+m,O=v;P+I>l&&(P=l-I);var R=this.container.selectAll(\"rect.scrollbar-vertical\").data(z?[0]:[]);R.exit().on(\".drag\",null).remove(),R.enter().append(\"rect\").classed(\"scrollbar-vertical\",!0).call(a.fill,n.barColor),z?(this.vbar=R.attr({rx:n.barRadius,ry:n.barRadius,x:P,y:O,width:I,height:D}),this._vbarYMin=O+D/2,this._vbarTranslateMax=k-D):(delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax);var F=this.id,j=c-.5,N=z?h+I+.5:h+.5,B=f-.5,U=A?d+S+.5:d+.5,V=s._topdefs.selectAll(\"#\"+F).data(A||z?[0]:[]);if(V.exit().remove(),V.enter().append(\"clipPath\").attr(\"id\",F).append(\"rect\"),A||z?(this._clipRect=V.select(\"rect\").attr({x:Math.floor(j),y:Math.floor(B),width:Math.ceil(N)-Math.floor(j),height:Math.ceil(U)-Math.floor(B)}),this.container.call(o.setClipUrl,F),this.bg.attr({x:p,y:v,width:m,height:g})):(this.bg.attr({width:0,height:0}),this.container.on(\"wheel\",null).on(\".drag\",null).call(o.setClipUrl,null),delete this._clipRect),A||z){var H=i.behavior.drag().on(\"dragstart\",function(){i.event.sourceEvent.preventDefault()}).on(\"drag\",this._onBoxDrag.bind(this));this.container.on(\"wheel\",null).on(\"wheel\",this._onBoxWheel.bind(this)).on(\".drag\",null).call(H);var q=i.behavior.drag().on(\"dragstart\",function(){i.event.sourceEvent.preventDefault(),i.event.sourceEvent.stopPropagation()}).on(\"drag\",this._onBarDrag.bind(this));A&&this.hbar.on(\".drag\",null).call(q),z&&this.vbar.on(\".drag\",null).call(q)}this.setTranslate(e,r)},n.prototype.disable=function(){(this.hbar||this.vbar)&&(this.bg.attr({width:0,height:0}),this.container.on(\"wheel\",null).on(\".drag\",null).call(o.setClipUrl,null),delete this._clipRect),this.hbar&&(this.hbar.on(\".drag\",null),this.hbar.remove(),delete this.hbar,delete this._hbarXMin,delete this._hbarTranslateMax),this.vbar&&(this.vbar.on(\".drag\",null),this.vbar.remove(),delete this.vbar,delete this._vbarYMin,delete this._vbarTranslateMax)},n.prototype._onBoxDrag=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t-=i.event.dx),this.vbar&&(e-=i.event.dy),this.setTranslate(t,e)},n.prototype._onBoxWheel=function(){var t=this.translateX,e=this.translateY;this.hbar&&(t+=i.event.deltaY),this.vbar&&(e+=i.event.deltaY),this.setTranslate(t,e)},n.prototype._onBarDrag=function(){var t=this.translateX,e=this.translateY;if(this.hbar){var r=t+this._hbarXMin,n=r+this._hbarTranslateMax;t=(s.constrain(i.event.x,r,n)-r)/(n-r)*(this.position.w-this._box.w)}if(this.vbar){var a=e+this._vbarYMin,o=a+this._vbarTranslateMax;e=(s.constrain(i.event.y,a,o)-a)/(o-a)*(this.position.h-this._box.h)}this.setTranslate(t,e)},n.prototype.setTranslate=function(t,e){var r=this.position.w-this._box.w,n=this.position.h-this._box.h;if(t=s.constrain(t||0,0,r),e=s.constrain(e||0,0,n),this.translateX=t,this.translateY=e,this.container.call(o.setTranslate,this._box.l-this.position.l-t,this._box.t-this.position.t-e),this._clipRect&&this._clipRect.attr({x:Math.floor(this.position.l+t-.5),y:Math.floor(this.position.t+e-.5)}),this.hbar){var i=t/r;this.hbar.call(o.setTranslate,t+i*this._hbarTranslateMax,e)}if(this.vbar){var a=e/n;this.vbar.call(o.setTranslate,t,e+a*this._vbarTranslateMax)}}},{\"../../lib\":725,\"../color\":603,\"../drawing\":627,d3:121}],699:[function(t,e,r){\"use strict\";e.exports={FROM_BL:{left:0,center:.5,right:1,bottom:0,middle:.5,top:1},FROM_TL:{left:0,center:.5,right:1,bottom:1,middle:.5,top:0},LINE_SPACING:1.3,MID_SHIFT:.35}},{}],700:[function(t,e,r){\"use strict\";e.exports={solid:[1],dot:[1,1],dash:[4,1],longdash:[8,1],dashdot:[4,1,1,1],longdashdot:[8,1,1,1]}},{}],701:[function(t,e,r){\"use strict\";for(var n=t(\"../lib/extend\").extendFlat,i={circle:{unicode:\"\\u25cf\"},square:{unicode:\"\\u25a0\"},diamond:{unicode:\"\\u25c6\"},cross:{unicode:\"\\u271a\"},x:{unicode:\"\\u274c\"},\"triangle-up\":{unicode:\"\\u25b2\"},\"triangle-down\":{unicode:\"\\u25bc\"},\"triangle-left\":{unicode:\"\\u25c4\"},\"triangle-right\":{unicode:\"\\u25ba\"},\"triangle-ne\":{unicode:\"\\u25e5\"},\"triangle-nw\":{unicode:\"\\u25e4\"},\"triangle-se\":{unicode:\"\\u25e2\"},\"triangle-sw\":{unicode:\"\\u25e3\"},pentagon:{unicode:\"\\u2b1f\"},hexagon:{unicode:\"\\u2b22\"},hexagon2:{unicode:\"\\u2b23\"},star:{unicode:\"\\u2605\"},\"diamond-tall\":{unicode:\"\\u2666\"},bowtie:{unicode:\"\\u29d3\"},\"diamond-x\":{unicode:\"\\u2756\"},\"cross-thin\":{unicode:\"+\",noBorder:!0},asterisk:{unicode:\"\\u2733\",noBorder:!0},\"y-up\":{unicode:\"\\u2144\",noBorder:!0},\"y-down\":{unicode:\"Y\",noBorder:!0},\"line-ew\":{unicode:\"\\u2500\",noBorder:!0},\"line-ns\":{unicode:\"\\u2502\",noBorder:!0}},a={},o=Object.keys(i),s=0;s<o.length;s++){var l=o[s];a[l+\"-open\"]=n({},i[l])}var u={\"circle-cross-open\":{unicode:\"\\u2a01\",noFill:!0},\"circle-x-open\":{unicode:\"\\u2a02\",noFill:!0},\"square-cross-open\":{unicode:\"\\u229e\",noFill:!0},\"square-x-open\":{unicode:\"\\u22a0\",noFill:!0}};e.exports=n({},i,a,u)},{\"../lib/extend\":716}],702:[function(t,e,r){\"use strict\";e.exports={solid:[[],0],dot:[[.5,1],200],dash:[[.5,1],50],longdash:[[.5,1],10],dashdot:[[.5,.625,.875,1],50],longdashdot:[[.5,.7,.8,1],10]}},{}],703:[function(t,e,r){\"use strict\";e.exports={circle:\"\\u25cf\",\"circle-open\":\"\\u25cb\",square:\"\\u25a0\",\"square-open\":\"\\u25a1\",diamond:\"\\u25c6\",\"diamond-open\":\"\\u25c7\",cross:\"+\",x:\"\\u274c\"}},{}],704:[function(t,e,r){\"use strict\";e.exports={SHOW_PLACEHOLDER:100,HIDE_PLACEHOLDER:1e3,DBLCLICKDELAY:300,DESELECTDIM:.2}},{}],705:[function(t,e,r){\"use strict\";e.exports={BADNUM:void 0,FP_SAFE:Number.MAX_VALUE/1e4,ONEAVGYEAR:315576e5,ONEAVGMONTH:26298e5,ONEDAY:864e5,ONEHOUR:36e5,ONEMIN:6e4,ONESEC:1e3,EPOCHJD:2440587.5,ALMOST_EQUAL:1-1e-6,MINUS_SIGN:\"\\u2212\"}},{}],706:[function(t,e,r){\"use strict\";e.exports={entityToUnicode:{mu:\"\\u03bc\",\"#956\":\"\\u03bc\",amp:\"&\",\"#28\":\"&\",lt:\"<\",\"#60\":\"<\",gt:\">\",\"#62\":\">\",nbsp:\"\\xa0\",\"#160\":\"\\xa0\",times:\"\\xd7\",\"#215\":\"\\xd7\",plusmn:\"\\xb1\",\"#177\":\"\\xb1\",deg:\"\\xb0\",\"#176\":\"\\xb0\"}}},{}],707:[function(t,e,r){\"use strict\";r.xmlns=\"http://www.w3.org/2000/xmlns/\",r.svg=\"http://www.w3.org/2000/svg\",r.xlink=\"http://www.w3.org/1999/xlink\",r.svgAttrs={xmlns:r.svg,\"xmlns:xlink\":r.xlink}},{}],708:[function(t,e,r){\"use strict\";var n=t(\"./plotly\");r.version=\"1.30.0\",t(\"es6-promise\").polyfill(),t(\"../build/plotcss\"),t(\"./fonts/mathjax_config\"),r.plot=n.plot,r.newPlot=n.newPlot,r.restyle=n.restyle,r.relayout=n.relayout,r.redraw=n.redraw,r.update=n.update,r.extendTraces=n.extendTraces,r.prependTraces=n.prependTraces,r.addTraces=n.addTraces,r.deleteTraces=n.deleteTraces,r.moveTraces=n.moveTraces,r.purge=n.purge,r.setPlotConfig=t(\"./plot_api/set_plot_config\"),r.register=t(\"./plot_api/register\"),r.toImage=t(\"./plot_api/to_image\"),r.downloadImage=t(\"./snapshot/download\"),r.validate=t(\"./plot_api/validate\"),r.addFrames=n.addFrames,r.deleteFrames=n.deleteFrames,r.animate=n.animate,r.register(t(\"./traces/scatter\")),r.register([t(\"./components/fx\"),t(\"./components/legend\"),t(\"./components/annotations\"),t(\"./components/annotations3d\"),t(\"./components/shapes\"),t(\"./components/images\"),t(\"./components/updatemenus\"),t(\"./components/sliders\"),t(\"./components/rangeslider\"),t(\"./components/rangeselector\")]),r.Icons=t(\"../build/ploticon\"),r.Plots=n.Plots,r.Fx=t(\"./components/fx\"),r.Snapshot=t(\"./snapshot\"),r.PlotSchema=t(\"./plot_api/plot_schema\"),r.Queue=t(\"./lib/queue\"),r.d3=t(\"d3\")},{\"../build/plotcss\":1,\"../build/ploticon\":2,\"./components/annotations\":594,\"./components/annotations3d\":599,\"./components/fx\":644,\"./components/images\":652,\"./components/legend\":660,\"./components/rangeselector\":672,\"./components/rangeslider\":678,\"./components/shapes\":685,\"./components/sliders\":691,\"./components/updatemenus\":697,\"./fonts/mathjax_config\":709,\"./lib/queue\":738,\"./plot_api/plot_schema\":755,\"./plot_api/register\":756,\"./plot_api/set_plot_config\":757,\"./plot_api/to_image\":759,\"./plot_api/validate\":760,\"./plotly\":761,\"./snapshot\":849,\"./snapshot/download\":846,\"./traces/scatter\":1037,d3:121,\"es6-promise\":127}],709:[function(t,e,r){\"use strict\";\"undefined\"!=typeof MathJax?(r.MathJax=!0,MathJax.Hub.Config({messageStyle:\"none\",skipStartupTypeset:!0,displayAlign:\"left\",tex2jax:{inlineMath:[[\"$\",\"$\"],[\"\\\\(\",\"\\\\)\"]]}}),MathJax.Hub.Configured()):r.MathJax=!1},{}],710:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){Array.isArray(t)&&(e[r]=t[n])}},{}],711:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../constants/numerical\").BADNUM,a=/^['\"%,$#\\s']+|[, ]|['\"%,$#\\s']+$/g;e.exports=function(t){return\"string\"==typeof t&&(t=t.replace(a,\"\")),n(t)?Number(t):i}},{\"../constants/numerical\":705,\"fast-isnumeric\":130}],712:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"tinycolor2\"),a=t(\"../plots/attributes\"),o=t(\"../components/colorscale/get_scale\"),s=(Object.keys(t(\"../components/colorscale/scales\")),t(\"./nested_property\")),l=/^([2-9]|[1-9][0-9]+)$/;r.valObjects={data_array:{coerceFunction:function(t,e,r){Array.isArray(t)?e.set(t):void 0!==r&&e.set(r)}},enumerated:{coerceFunction:function(t,e,r,n){n.coerceNumber&&(t=+t),-1===n.values.indexOf(t)?e.set(r):e.set(t)},validateFunction:function(t,e){e.coerceNumber&&(t=+t);for(var r=e.values,n=0;n<r.length;n++){var i=String(r[n]);if(\"/\"===i.charAt(0)&&\"/\"===i.charAt(i.length-1)){if(new RegExp(i.substr(1,i.length-2)).test(t))return!0}else if(t===r[n])return!0}return!1}},boolean:{coerceFunction:function(t,e,r){!0===t||!1===t?e.set(t):e.set(r)}},number:{coerceFunction:function(t,e,r,i){!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},integer:{coerceFunction:function(t,e,r,i){t%1||!n(t)||void 0!==i.min&&t<i.min||void 0!==i.max&&t>i.max?e.set(r):e.set(+t)}},string:{coerceFunction:function(t,e,r,n){if(\"string\"!=typeof t){var i=\"number\"==typeof t;!0!==n.strict&&i?e.set(String(t)):e.set(r)}else n.noBlank&&!t?e.set(r):e.set(t)}},color:{coerceFunction:function(t,e,r){i(t).isValid()?e.set(t):e.set(r)}},colorscale:{coerceFunction:function(t,e,r){e.set(o(t,r))}},angle:{coerceFunction:function(t,e,r){\"auto\"===t?e.set(\"auto\"):n(t)?(Math.abs(t)>180&&(t-=360*Math.round(t/360)),e.set(+t)):e.set(r)}},subplotid:{coerceFunction:function(t,e,r){var n=r.length;if(\"string\"==typeof t&&t.substr(0,n)===r&&l.test(t.substr(n)))return void e.set(t);e.set(r)},validateFunction:function(t,e){var r=e.dflt,n=r.length;return t===r||\"string\"==typeof t&&!(t.substr(0,n)!==r||!l.test(t.substr(n)))}},flaglist:{coerceFunction:function(t,e,r,n){if(\"string\"!=typeof t)return void e.set(r);if(-1!==(n.extras||[]).indexOf(t))return void e.set(t);for(var i=t.split(\"+\"),a=0;a<i.length;){var o=i[a];-1===n.flags.indexOf(o)||i.indexOf(o)<a?i.splice(a,1):a++}i.length?e.set(i.join(\"+\")):e.set(r)}},any:{coerceFunction:function(t,e,r){void 0===t?e.set(r):e.set(t)}},info_array:{coerceFunction:function(t,e,n,i){if(!Array.isArray(t))return void e.set(n);var a=i.items,o=[];n=Array.isArray(n)?n:[];for(var s=0;s<a.length;s++)r.coerce(t,o,a,\"[\"+s+\"]\",n[s]);e.set(o)},validateFunction:function(t,e){if(!Array.isArray(t))return!1;var n=e.items;if(!e.freeLength&&t.length!==n.length)return!1;for(var i=0;i<t.length;i++){if(!r.validate(t[i],e.items[i]))return!1}return!0}}},r.coerce=function(t,e,n,i,a){var o=s(n,i).get(),l=s(t,i),u=s(e,i),c=l.get();return void 0===a&&(a=o.dflt),o.arrayOk&&Array.isArray(c)?(u.set(c),c):(r.valObjects[o.valType].coerceFunction(c,u,a,o),u.get())},r.coerce2=function(t,e,n,i,a){var o=s(t,i),l=r.coerce(t,e,n,i,a),u=o.get();return void 0!==u&&null!==u&&l},r.coerceFont=function(t,e,r){var n={};return r=r||{},n.family=t(e+\".family\",r.family),n.size=t(e+\".size\",r.size),n.color=t(e+\".color\",r.color),n},r.coerceHoverinfo=function(t,e,n){var i,o=e._module.attributes,s=o.hoverinfo?{hoverinfo:o.hoverinfo}:a,l=s.hoverinfo;if(1===n._dataLength){var u=\"all\"===l.dflt?l.flags.slice():l.dflt.split(\"+\");u.splice(u.indexOf(\"name\"),1),i=u.join(\"+\")}return r.coerce(t,e,s,\"hoverinfo\",i)},r.validate=function(t,e){var n=r.valObjects[e.valType];if(e.arrayOk&&Array.isArray(t))return!0;if(n.validateFunction)return n.validateFunction(t,e);var i={},a=i,o={set:function(t){a=t}};return n.coerceFunction(t,o,i,e),a!==i}},{\"../components/colorscale/get_scale\":615,\"../components/colorscale/scales\":621,\"../plots/attributes\":764,\"./nested_property\":732,\"fast-isnumeric\":130,tinycolor2:533}],713:[function(t,e,r){\"use strict\";function n(t){return t&&M.componentsRegistry.calendars&&\"string\"==typeof t&&\"gregorian\"!==t}function i(t,e){return String(t+Math.pow(10,e)).substr(1)}function a(t,e,r,n,a){if((e||r||n||a)&&(t+=\" \"+i(e,2)+\":\"+i(r,2),(n||a)&&(t+=\":\"+i(n,2),a))){for(var o=4;a%10==0;)o-=1,a/=10;t+=\".\"+i(a,o)}return t}function o(t,e,r){t=t.replace(D,function(t){var r=Math.min(+t.charAt(1)||6,6);return(e/1e3%1+2).toFixed(r).substr(2).replace(/0+$/,\"\")||\"0\"});var i=new Date(Math.floor(e+.05));if(n(r))try{t=M.getComponentMethod(\"calendars\",\"worldCalFmt\")(t,e,r)}catch(t){return\"Invalid\"}return k(t)(i)}function s(t,e){var r=m(t+.05,y),n=i(Math.floor(r/b),2)+\":\"+i(m(Math.floor(r/x),60),2);if(\"M\"!==e){d(e)||(e=0);var a=Math.min(m(t/_,60),P[e]),o=(100+a).toFixed(e).substr(1);e>0&&(o=o.replace(/0+$/,\"\").replace(/[\\.]$/,\"\")),n+=\":\"+o}return n}function l(t){return t.formatDate(\"yyyy\")}function u(t){return t.formatDate(\"M yyyy\")}function c(t){return t.formatDate(\"M d\")}function h(t){return t.formatDate(\"M d, yyyy\")}var f=t(\"d3\"),d=t(\"fast-isnumeric\"),p=t(\"./loggers\").error,m=t(\"./mod\"),v=t(\"../constants/numerical\"),g=v.BADNUM,y=v.ONEDAY,b=v.ONEHOUR,x=v.ONEMIN,_=v.ONESEC,w=v.EPOCHJD,M=t(\"../registry\"),k=f.time.format.utc,A=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)(-(\\d?\\d)(-(\\d?\\d)([ Tt]([01]?\\d|2[0-3])(:([0-5]\\d)(:([0-5]\\d(\\.\\d+)?))?(Z|z|[+\\-]\\d\\d:?\\d\\d)?)?)?)?)?\\s*$/m,T=/^\\s*(-?\\d\\d\\d\\d|\\d\\d)(-(\\d?\\di?)(-(\\d?\\d)([ Tt]([01]?\\d|2[0-3])(:([0-5]\\d)(:([0-5]\\d(\\.\\d+)?))?(Z|z|[+\\-]\\d\\d:?\\d\\d)?)?)?)?)?\\s*$/m,S=(new Date).getFullYear()-70;r.dateTick0=function(t,e){return n(t)?e?M.getComponentMethod(\"calendars\",\"CANONICAL_SUNDAY\")[t]:M.getComponentMethod(\"calendars\",\"CANONICAL_TICK\")[t]:e?\"2000-01-02\":\"2000-01-01\"},r.dfltRange=function(t){return n(t)?M.getComponentMethod(\"calendars\",\"DFLTRANGE\")[t]:[\"2000-01-01\",\"2001-01-01\"]},r.isJSDate=function(t){return\"object\"==typeof t&&null!==t&&\"function\"==typeof t.getTime};var E,L;r.dateTime2ms=function(t,e){if(r.isJSDate(t))return t=Number(t)-t.getTimezoneOffset()*x,t>=E&&t<=L?t:g;if(\"string\"!=typeof t&&\"number\"!=typeof t)return g;t=String(t);var i=n(e),a=t.charAt(0);!i||\"G\"!==a&&\"g\"!==a||(t=t.substr(1),e=\"\");var o=i&&\"chinese\"===e.substr(0,7),s=t.match(o?T:A);if(!s)return g;var l=s[1],u=s[3]||\"1\",c=Number(s[5]||1),h=Number(s[7]||0),f=Number(s[9]||0),d=Number(s[11]||0);if(i){if(2===l.length)return g;l=Number(l);var p;try{var m=M.getComponentMethod(\"calendars\",\"getCal\")(e);if(o){var v=\"i\"===u.charAt(u.length-1);u=parseInt(u,10),p=m.newDate(l,m.toMonthIndex(l,u,v),c)}else p=m.newDate(l,Number(u),c)}catch(t){return g}return p?(p.toJD()-w)*y+h*b+f*x+d*_:g}l=2===l.length?(Number(l)+2e3-S)%100+S:Number(l),u-=1;var k=new Date(Date.UTC(2e3,u,c,h,f));return k.setUTCFullYear(l),k.getUTCMonth()!==u?g:k.getUTCDate()!==c?g:k.getTime()+d*_},E=r.MIN_MS=r.dateTime2ms(\"-9999\"),L=r.MAX_MS=r.dateTime2ms(\"9999-12-31 23:59:59.9999\"),r.isDateTime=function(t,e){return r.dateTime2ms(t,e)!==g};var C=90*y,z=3*b,I=5*x;r.ms2DateTime=function(t,e,r){if(\"number\"!=typeof t||!(t>=E&&t<=L))return g;e||(e=0);var i,o,s,l,u,c,h=Math.floor(10*m(t+.05,1)),f=Math.round(t-h/10);if(n(r)){var d=Math.floor(f/y)+w,p=Math.floor(m(t,y));try{i=M.getComponentMethod(\"calendars\",\"getCal\")(r).fromJD(d).formatDate(\"yyyy-mm-dd\")}catch(t){i=k(\"G%Y-%m-%d\")(new Date(f))}if(\"-\"===i.charAt(0))for(;i.length<11;)i=\"-0\"+i.substr(1);else for(;i.length<10;)i=\"0\"+i;o=e<C?Math.floor(p/b):0,s=e<C?Math.floor(p%b/x):0,l=e<z?Math.floor(p%x/_):0,u=e<I?p%_*10+h:0}else c=new Date(f),i=k(\"%Y-%m-%d\")(c),o=e<C?c.getUTCHours():0,s=e<C?c.getUTCMinutes():0,l=e<z?c.getUTCSeconds():0,u=e<I?10*c.getUTCMilliseconds()+h:0;return a(i,o,s,l,u)},r.ms2DateTimeLocal=function(t){if(!(t>=E+y&&t<=L-y))return g;var e=Math.floor(10*m(t+.05,1)),r=new Date(Math.round(t-e/10));return a(f.time.format(\"%Y-%m-%d\")(r),r.getHours(),r.getMinutes(),r.getSeconds(),10*r.getUTCMilliseconds()+e)},r.cleanDate=function(t,e,i){if(r.isJSDate(t)||\"number\"==typeof t){if(n(i))return p(\"JS Dates and milliseconds are incompatible with world calendars\",t),e;if(!(t=r.ms2DateTimeLocal(+t))&&void 0!==e)return e}else if(!r.isDateTime(t,i))return p(\"unrecognized date\",t),e;return t};var D=/%\\d?f/g,P=[59,59.9,59.99,59.999,59.9999],O=k(\"%Y\"),R=k(\"%b %Y\"),F=k(\"%b %-d\"),j=k(\"%b %-d, %Y\");r.formatDate=function(t,e,r,i){var a,f;if(i=n(i)&&i,e)return o(e,t,i);if(i)try{var d=Math.floor((t+.05)/y)+w,p=M.getComponentMethod(\"calendars\",\"getCal\")(i).fromJD(d);\"y\"===r?f=l(p):\"m\"===r?f=u(p):\"d\"===r?(a=l(p),f=c(p)):(a=h(p),f=s(t,r))}catch(t){return\"Invalid\"}else{var m=new Date(Math.floor(t+.05));\"y\"===r?f=O(m):\"m\"===r?f=R(m):\"d\"===r?(a=O(m),f=F(m)):(a=j(m),f=s(t,r))}return f+(a?\"\\n\"+a:\"\")};var N=3*y;r.incrementMonth=function(t,e,r){r=n(r)&&r;var i=m(t,y);if(t=Math.round(t-i),r)try{var a=Math.round(t/y)+w,o=M.getComponentMethod(\"calendars\",\"getCal\")(r),s=o.fromJD(a);return e%12?o.add(s,e,\"m\"):o.add(s,e/12,\"y\"),(s.toJD()-w)*y+i}catch(e){p(\"invalid ms \"+t+\" in calendar \"+r)}var l=new Date(t+N);return l.setUTCMonth(l.getUTCMonth()+e)+i-N},r.findExactDates=function(t,e){for(var r,i,a=0,o=0,s=0,l=0,u=n(e)&&M.getComponentMethod(\"calendars\",\"getCal\")(e),c=0;c<t.length;c++)if(i=t[c],d(i)){if(!(i%y))if(u)try{r=u.fromJD(i/y+w),1===r.day()?1===r.month()?a++:o++:s++}catch(t){}else r=new Date(i),1===r.getUTCDate()?0===r.getUTCMonth()?a++:o++:s++}else l++;o+=a,s+=o;var h=t.length-l;return{exactYears:a/h,exactMonths:o/h,exactDays:s/h}}},{\"../constants/numerical\":705,\"../registry\":844,\"./loggers\":729,\"./mod\":731,d3:121,\"fast-isnumeric\":130}],714:[function(t,e,r){\"use strict\";e.exports=function(t,e){return Array.isArray(t)||(t=[]),t.length=e,t}},{}],715:[function(t,e,r){\"use strict\";var n=t(\"events\").EventEmitter,i={init:function(t){if(t._ev instanceof n)return t;var e=new n,r=new n;return t._ev=e,t._internalEv=r,t.on=e.on.bind(e),t.once=e.once.bind(e),t.removeListener=e.removeListener.bind(e),t.removeAllListeners=e.removeAllListeners.bind(e),t._internalOn=r.on.bind(r),t._internalOnce=r.once.bind(r),t._removeInternalListener=r.removeListener.bind(r),t._removeAllInternalListeners=r.removeAllListeners.bind(r),t.emit=function(n,i){\"undefined\"!=typeof jQuery&&jQuery(t).trigger(n,i),e.emit(n,i),r.emit(n,i)},t},triggerHandler:function(t,e,r){var n,i;\"undefined\"!=typeof jQuery&&(n=jQuery(t).triggerHandler(e,r));var a=t._ev;if(!a)return n;var o=a._events[e];if(!o)return n;\"function\"==typeof o&&(o=[o]);for(var s=o.pop(),l=0;l<o.length;l++)o[l](r);return i=s(r),void 0!==n?n:i},purge:function(t){return delete t._ev,delete t.on,delete t.once,delete t.removeListener,delete t.removeAllListeners,delete t.emit,delete t._ev,delete t._internalEv,delete t._internalOn,delete t._internalOnce,delete t._removeInternalListener,delete t._removeAllInternalListeners,t}};e.exports=i},{events:128}],716:[function(t,e,r){\"use strict\";function n(t,e){var r,n;for(r=0;r<t.length;r++){if(null!==(n=t[r])&&\"object\"==typeof n)return!1;void 0!==n&&(e[r]=n)}return!0}function i(t,e,r,s){var l,u,c,h,f,d,p=t[0],m=t.length;if(2===m&&o(p)&&o(t[1])&&0===p.length){if(n(t[1],p))return p;p.splice(0,p.length)}for(var v=1;v<m;v++){l=t[v];for(u in l)c=p[u],h=l[u],s&&o(h)?p[u]=h:e&&h&&(a(h)||(f=o(h)))?(f?(f=!1,d=c&&o(c)?c:[]):d=c&&a(c)?c:{},p[u]=i([d,h],e,r,s)):(void 0!==h||r)&&(p[u]=h)}return p}var a=t(\"./is_plain_object.js\"),o=Array.isArray;r.extendFlat=function(){return i(arguments,!1,!1,!1)},r.extendDeep=function(){return i(arguments,!0,!1,!1)},r.extendDeepAll=function(){return i(arguments,!0,!0,!1)},r.extendDeepNoArrays=function(){return i(arguments,!0,!1,!0)}},{\"./is_plain_object.js\":727}],717:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e={},r=[],n=0,i=0;i<t.length;i++){var a=t[i];1!==e[a]&&(e[a]=1,r[n++]=a)}return r}},{}],718:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=[],r=0;r<t.length;r++){var n=t[r];!0===n.visible&&e.push(n)}return e}},{}],719:[function(t,e,r){\"use strict\";function n(t,e){return(0,l[t])(e)}function i(t){for(var e=0;e<s.length;e++){var r=s[e];if(new RegExp(a[r]).test(t.trim().toLowerCase()))return r}return o.warn(\"Unrecognized country name: \"+t+\".\"),!1}var a=t(\"country-regex\"),o=t(\"../lib\"),s=Object.keys(a),l={\"ISO-3\":o.identity,\"USA-states\":o.identity,\"country names\":i};r.locationToFeature=function(t,e,r){var i=n(t,e);if(i){for(var a=0;a<r.length;a++){var s=r[a];if(s.id===i)return s}o.warn([\"Location with id\",i,\"does not have a matching topojson feature at this resolution.\"].join(\" \"))}return!1}},{\"../lib\":725,\"country-regex\":106}],720:[function(t,e,r){\"use strict\";var n=t(\"../constants/numerical\").BADNUM;r.calcTraceToLineCoords=function(t){for(var e=t[0].trace,r=e.connectgaps,i=[],a=[],o=0;o<t.length;o++){var s=t[o],l=s.lonlat;l[0]!==n?a.push(l):!r&&a.length>0&&(i.push(a),a=[])}return a.length>0&&i.push(a),i},r.makeLine=function(t,e){var r={};return r=1===t.length?{\n",
       "type:\"LineString\",coordinates:t[0]}:{type:\"MultiLineString\",coordinates:t},e&&(r.trace=e),r},r.makePolygon=function(t,e){var r={};if(1===t.length)r={type:\"Polygon\",coordinates:t};else{for(var n=new Array(t.length),i=0;i<t.length;i++)n[i]=[t[i]];r={type:\"MultiPolygon\",coordinates:n}}return e&&(r.trace=e),r},r.makeBlank=function(){return{type:\"Point\",coordinates:[]}}},{\"../constants/numerical\":705}],721:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o,s){var l=r-t,u=i-t,c=o-i,h=n-e,f=a-e,d=s-a,p=l*d-c*h;if(0===p)return null;var m=(u*d-c*f)/p,v=(u*h-l*f)/p;return v<0||v>1||m<0||m>1?null:{x:t+l*m,y:e+h*m}}function i(t,e,r,n,i){var a=n*t+i*e;if(a<0)return n*n+i*i;if(a>r){var o=n-t,s=i-e;return o*o+s*s}var l=n*e-i*t;return l*l/r}var a=t(\"./mod\");r.segmentsIntersect=n,r.segmentDistance=function(t,e,r,a,o,s,l,u){if(n(t,e,r,a,o,s,l,u))return 0;var c=r-t,h=a-e,f=l-o,d=u-s,p=c*c+h*h,m=f*f+d*d,v=Math.min(i(c,h,p,o-t,s-e),i(c,h,p,l-t,u-e),i(f,d,m,t-o,e-s),i(f,d,m,r-o,a-s));return Math.sqrt(v)};var o,s,l;r.getTextLocation=function(t,e,r,n){if(t===s&&n===l||(o={},s=t,l=n),o[r])return o[r];var i=t.getPointAtLength(a(r-n/2,e)),u=t.getPointAtLength(a(r+n/2,e)),c=Math.atan((u.y-i.y)/(u.x-i.x)),h=t.getPointAtLength(a(r,e)),f=(4*h.x+i.x+u.x)/6,d=(4*h.y+i.y+u.y)/6,p={x:f,y:d,theta:c};return o[r]=p,p},r.clearLocationCache=function(){s=null},r.getVisibleSegment=function(t,e,r){function n(e){var r=t.getPointAtLength(e);0===e?i=r:e===h&&(a=r);var n=r.x<o?o-r.x:r.x>s?r.x-s:0,c=r.y<l?l-r.y:r.y>u?r.y-u:0;return Math.sqrt(n*n+c*c)}for(var i,a,o=e.left,s=e.right,l=e.top,u=e.bottom,c=0,h=t.getTotalLength(),f=h,d=n(c);d;){if((c+=d+r)>f)return;d=n(c)}for(d=n(f);d;){if(f-=d+r,c>f)return;d=n(f)}return{min:c,max:f,len:f-c,total:h,isClosed:0===c&&f===h&&Math.abs(i.x-a.x)<.1&&Math.abs(i.y-a.y)<.1}}},{\"./mod\":731}],722:[function(t,e,r){\"use strict\";function n(t,e){var r=t;return r[3]*=e,r}function i(t){if(s(t))return h;var e=l(t);return e.length?e:h}function a(t){return s(t)?t:f}function o(t,e,r){var o,s,c,d,p,m=t.color,v=Array.isArray(m),g=Array.isArray(e),y=[];if(o=void 0!==t.colorscale?u.makeColorScaleFunc(u.extractScale(t.colorscale,t.cmin,t.cmax)):i,s=v?function(t,e){return void 0===t[e]?h:l(o(t[e]))}:i,c=g?function(t,e){return void 0===t[e]?f:a(t[e])}:a,v||g)for(var b=0;b<r;b++)d=s(m,b),p=c(e,b),y[b]=n(d,p);else y=n(l(m),e);return y}var s=t(\"fast-isnumeric\"),l=t(\"color-rgba\"),u=t(\"../components/colorscale\"),c=t(\"../components/color/attributes\").defaultLine,h=l(c),f=1;e.exports=o},{\"../components/color/attributes\":602,\"../components/colorscale\":617,\"color-rgba\":94,\"fast-isnumeric\":130}],723:[function(t,e,r){\"use strict\";function n(t){for(var e=0;(e=t.indexOf(\"<sup>\",e))>=0;){var r=t.indexOf(\"</sup>\",e);if(r<e)break;t=t.slice(0,e)+l(t.slice(e+5,r))+t.slice(r+6)}return t}function i(t){return t.replace(/\\<br\\>/g,\"\\n\")}function a(t){return t.replace(/\\<.*\\>/g,\"\")}function o(t){for(var e=u.entityToUnicode,r=0;(r=t.indexOf(\"&\",r))>=0;){var n=t.indexOf(\";\",r);if(n<r)r+=1;else{var i=e[t.slice(r+1,n)];t=i?t.slice(0,r)+i+t.slice(n+1):t.slice(0,r)+t.slice(n+1)}}return t}function s(t){return\"\"+o(a(n(i(t))))}var l=t(\"superscript-text\"),u=t(\"../constants/string_mappings\");e.exports=s},{\"../constants/string_mappings\":706,\"superscript-text\":529}],724:[function(t,e,r){\"use strict\";e.exports=function(t){return t}},{}],725:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=t(\"../constants/numerical\"),o=a.FP_SAFE,s=a.BADNUM,l=e.exports={};l.nestedProperty=t(\"./nested_property\"),l.keyedContainer=t(\"./keyed_container\"),l.isPlainObject=t(\"./is_plain_object\"),l.isArray=t(\"./is_array\"),l.mod=t(\"./mod\"),l.toLogRange=t(\"./to_log_range\"),l.relinkPrivateKeys=t(\"./relink_private\"),l.ensureArray=t(\"./ensure_array\");var u=t(\"./coerce\");l.valObjects=u.valObjects,l.coerce=u.coerce,l.coerce2=u.coerce2,l.coerceFont=u.coerceFont,l.coerceHoverinfo=u.coerceHoverinfo,l.validate=u.validate;var c=t(\"./dates\");l.dateTime2ms=c.dateTime2ms,l.isDateTime=c.isDateTime,l.ms2DateTime=c.ms2DateTime,l.ms2DateTimeLocal=c.ms2DateTimeLocal,l.cleanDate=c.cleanDate,l.isJSDate=c.isJSDate,l.formatDate=c.formatDate,l.incrementMonth=c.incrementMonth,l.dateTick0=c.dateTick0,l.dfltRange=c.dfltRange,l.findExactDates=c.findExactDates,l.MIN_MS=c.MIN_MS,l.MAX_MS=c.MAX_MS;var h=t(\"./search\");l.findBin=h.findBin,l.sorterAsc=h.sorterAsc,l.sorterDes=h.sorterDes,l.distinctVals=h.distinctVals,l.roundUp=h.roundUp;var f=t(\"./stats\");l.aggNums=f.aggNums,l.len=f.len,l.mean=f.mean,l.variance=f.variance,l.stdev=f.stdev,l.interp=f.interp;var d=t(\"./matrix\");l.init2dArray=d.init2dArray,l.transposeRagged=d.transposeRagged,l.dot=d.dot,l.translationMatrix=d.translationMatrix,l.rotationMatrix=d.rotationMatrix,l.rotationXYMatrix=d.rotationXYMatrix,l.apply2DTransform=d.apply2DTransform,l.apply2DTransform2=d.apply2DTransform2;var p=t(\"./geometry2d\");l.segmentsIntersect=p.segmentsIntersect,l.segmentDistance=p.segmentDistance,l.getTextLocation=p.getTextLocation,l.clearLocationCache=p.clearLocationCache,l.getVisibleSegment=p.getVisibleSegment;var m=t(\"./extend\");l.extendFlat=m.extendFlat,l.extendDeep=m.extendDeep,l.extendDeepAll=m.extendDeepAll,l.extendDeepNoArrays=m.extendDeepNoArrays;var v=t(\"./loggers\");l.log=v.log,l.warn=v.warn,l.error=v.error,l.notifier=t(\"./notifier\"),l.filterUnique=t(\"./filter_unique\"),l.filterVisible=t(\"./filter_visible\"),l.pushUnique=t(\"./push_unique\"),l.cleanNumber=t(\"./clean_number\"),l.ensureNumber=function(t){return i(t)?(t=Number(t),t<-o||t>o?s:i(t)?Number(t):s):s},l.noop=t(\"./noop\"),l.identity=t(\"./identity\"),l.swapAttrs=function(t,e,r,n){r||(r=\"x\"),n||(n=\"y\");for(var i=0;i<e.length;i++){var a=e[i],o=l.nestedProperty(t,a.replace(\"?\",r)),s=l.nestedProperty(t,a.replace(\"?\",n)),u=o.get();o.set(s.get()),s.set(u)}},l.pauseEvent=function(t){return t.stopPropagation&&t.stopPropagation(),t.preventDefault&&t.preventDefault(),t.cancelBubble=!0,!1},l.constrain=function(t,e,r){return e>r?Math.max(r,Math.min(e,t)):Math.max(e,Math.min(r,t))},l.bBoxIntersect=function(t,e,r){return r=r||0,t.left<=e.right+r&&e.left<=t.right+r&&t.top<=e.bottom+r&&e.top<=t.bottom+r},l.simpleMap=function(t,e,r,n){for(var i=t.length,a=new Array(i),o=0;o<i;o++)a[o]=e(t[o],r,n);return a},l.randstr=function t(e,r,n){if(n||(n=16),void 0===r&&(r=24),r<=0)return\"0\";var i,a,o,s=Math.log(Math.pow(2,r))/Math.log(n),l=\"\";for(i=2;s===1/0;i*=2)s=Math.log(Math.pow(2,r/i))/Math.log(n)*i;var u=s-Math.floor(s);for(i=0;i<Math.floor(s);i++)o=Math.floor(Math.random()*n).toString(n),l=o+l;u&&(a=Math.pow(n,u),o=Math.floor(Math.random()*a).toString(n),l=o+l);var c=parseInt(l,n);return e&&e.indexOf(l)>-1||c!==1/0&&c>=Math.pow(2,r)?t(e,r,n):l},l.OptionControl=function(t,e){t||(t={}),e||(e=\"opt\");var r={};return r.optionList=[],r._newoption=function(n){n[e]=t,r[n.name]=n,r.optionList.push(n)},r[\"_\"+e]=t,r},l.smooth=function(t,e){if((e=Math.round(e)||0)<2)return t;var r,n,i,a,o=t.length,s=2*o,l=2*e-1,u=new Array(l),c=new Array(o);for(r=0;r<l;r++)u[r]=(1-Math.cos(Math.PI*(r+1)/e))/(2*e);for(r=0;r<o;r++){for(a=0,n=0;n<l;n++)i=r+n+1-e,i<-o?i-=s*Math.round(i/s):i>=s&&(i-=s*Math.floor(i/s)),i<0?i=-1-i:i>=o&&(i=s-1-i),a+=t[i]*u[n];c[r]=a}return c},l.syncOrAsync=function(t,e,r){function n(){return l.syncOrAsync(t,e,r)}for(var i,a;t.length;)if(a=t.splice(0,1)[0],(i=a(e))&&i.then)return i.then(n).then(void 0,l.promiseError);return r&&r(e)},l.stripTrailingSlash=function(t){return\"/\"===t.substr(-1)?t.substr(0,t.length-1):t},l.noneOrAll=function(t,e,r){if(t){var n,i,a=!1,o=!0;for(n=0;n<r.length;n++)i=t[r[n]],void 0!==i&&null!==i?a=!0:o=!1;if(a&&!o)for(n=0;n<r.length;n++)t[r[n]]=e[r[n]]}},l.mergeArray=function(t,e,r){if(Array.isArray(t))for(var n=Math.min(t.length,e.length),i=0;i<n;i++)e[i][r]=t[i]},l.fillArray=function(t,e,r,n){if(n=n||l.identity,Array.isArray(t))for(var i=0;i<e.length;i++)e[i][r]=n(t[i])},l.castOption=function(t,e,r,n){n=n||l.identity;var i=l.nestedProperty(t,r).get();return Array.isArray(i)?n(Array.isArray(e)&&Array.isArray(i[e[0]])?i[e[0]][e[1]]:i[e]):i},l.getTargetArray=function(t,e){var r=e.target;if(\"string\"==typeof r&&r){var n=l.nestedProperty(t,r).get();return!!Array.isArray(n)&&n}return!!Array.isArray(r)&&r},l.minExtend=function(t,e){var r={};\"object\"!=typeof e&&(e={});var n,i,a,o=Object.keys(t);for(n=0;n<o.length;n++)i=o[n],a=t[i],\"_\"!==i.charAt(0)&&\"function\"!=typeof a&&(\"module\"===i?r[i]=a:Array.isArray(a)?r[i]=a.slice(0,3):r[i]=a&&\"object\"==typeof a?l.minExtend(t[i],e[i]):a);for(o=Object.keys(e),n=0;n<o.length;n++)i=o[n],\"object\"==typeof(a=e[i])&&i in r&&\"object\"==typeof r[i]||(r[i]=a);return r},l.titleCase=function(t){return t.charAt(0).toUpperCase()+t.substr(1)},l.containsAny=function(t,e){for(var r=0;r<e.length;r++)if(-1!==t.indexOf(e[r]))return!0;return!1},l.isPlotDiv=function(t){var e=n.select(t);return e.node()instanceof HTMLElement&&e.size()&&e.classed(\"js-plotly-plot\")},l.removeElement=function(t){var e=t&&t.parentNode;e&&e.removeChild(t)},l.addStyleRule=function(t,e){if(!l.styleSheet){var r=document.createElement(\"style\");r.appendChild(document.createTextNode(\"\")),document.head.appendChild(r),l.styleSheet=r.sheet}var n=l.styleSheet;n.insertRule?n.insertRule(t+\"{\"+e+\"}\",0):n.addRule?n.addRule(t,e,0):l.warn(\"addStyleRule failed\")},l.isIE=function(){return void 0!==window.navigator.msSaveBlob},l.isD3Selection=function(t){return t&&\"function\"==typeof t.classed},l.objectFromPath=function(t,e){for(var r,n=t.split(\".\"),i=r={},a=0;a<n.length;a++){var o=n[a],s=null,l=n[a].match(/(.*)\\[([0-9]+)\\]/);l?(o=l[1],s=l[2],r=r[o]=[],a===n.length-1?r[s]=e:r[s]={},r=r[s]):(a===n.length-1?r[o]=e:r[o]={},r=r[o])}return i};var g=/^([^\\[\\.]+)\\.(.+)?/,y=/^([^\\.]+)\\[([0-9]+)\\](\\.)?(.+)?/;l.expandObjectPaths=function(t){var e,r,n,i,a,o,s;if(\"object\"==typeof t&&!Array.isArray(t))for(r in t)t.hasOwnProperty(r)&&((e=r.match(g))?(i=t[r],n=e[1],delete t[r],t[n]=l.extendDeepNoArrays(t[n]||{},l.objectFromPath(r,l.expandObjectPaths(i))[n])):(e=r.match(y))?(i=t[r],n=e[1],a=parseInt(e[2]),delete t[r],t[n]=t[n]||[],\".\"===e[3]?(s=e[4],o=t[n][a]=t[n][a]||{},l.extendDeepNoArrays(o,l.objectFromPath(s,l.expandObjectPaths(i)))):t[n][a]=l.expandObjectPaths(i)):t[r]=l.expandObjectPaths(t[r]));return t},l.numSeparate=function(t,e,r){if(r||(r=!1),\"string\"!=typeof e||0===e.length)throw new Error(\"Separator string required for formatting!\");\"number\"==typeof t&&(t=String(t));var n=/(\\d+)(\\d{3})/,i=e.charAt(0),a=e.charAt(1),o=t.split(\".\"),s=o[0],l=o.length>1?i+o[1]:\"\";if(a&&(o.length>1||s.length>4||r))for(;n.test(s);)s=s.replace(n,\"$1\"+a+\"$2\");return s+l};var b=/%{([^\\s%{}]*)}/g,x=/^\\w*$/;l.templateString=function(t,e){var r={};return t.replace(b,function(t,n){return x.test(n)?e[n]||\"\":(r[n]=r[n]||l.nestedProperty(e,n).get,r[n]()||\"\")})}},{\"../constants/numerical\":705,\"./clean_number\":711,\"./coerce\":712,\"./dates\":713,\"./ensure_array\":714,\"./extend\":716,\"./filter_unique\":717,\"./filter_visible\":718,\"./geometry2d\":721,\"./identity\":724,\"./is_array\":726,\"./is_plain_object\":727,\"./keyed_container\":728,\"./loggers\":729,\"./matrix\":730,\"./mod\":731,\"./nested_property\":732,\"./noop\":733,\"./notifier\":734,\"./push_unique\":737,\"./relink_private\":739,\"./search\":740,\"./stats\":743,\"./to_log_range\":746,d3:121,\"fast-isnumeric\":130}],726:[function(t,e,r){\"use strict\";var n=\"undefined\"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer:{isView:function(){return!1}};e.exports=function(t){return Array.isArray(t)||n.isView(t)}},{}],727:[function(t,e,r){\"use strict\";e.exports=function(t){return window&&window.process&&window.process.versions?\"[object Object]\"===Object.prototype.toString.call(t):\"[object Object]\"===Object.prototype.toString.call(t)&&Object.getPrototypeOf(t)===Object.prototype}},{}],728:[function(t,e,r){\"use strict\";var n=t(\"./nested_property\"),i=/^\\w*$/;e.exports=function(t,e,r,a){r=r||\"name\",a=a||\"value\";var o,s,l={};s=e&&e.length?n(t,e).get():t,e=e||\"\",s=s||[];var u={};for(o=0;o<s.length;o++)u[s[o][r]]=o;var c=i.test(a),h={set:function(t,e){var i=null===e?4:0,o=u[t];void 0===o?(i|=3,o=s.length,u[t]=o):e!==(c?s[o][a]:n(s[o],a).get())&&(i|=2);var f=s[o]=s[o]||{};return f[r]=t,c?f[a]=e:n(f,a).set(e),null!==e&&(i&=-5),l[o]=l[o]|i,h},get:function(t){var e=u[t];return void 0===e?void 0:c?s[e][a]:n(s[e],a).get()},rename:function(t,e){var n=u[t];return void 0===n?h:(l[n]=1|l[n],u[e]=n,delete u[t],s[n][r]=e,h)},remove:function(t){var e=u[t];if(void 0===e)return h;var i=s[e];if(Object.keys(i).length>2)return l[e]=2|l[e],h.set(t,null);if(c){for(o=e;o<s.length;o++)l[o]=3|l[o];for(o=e;o<s.length;o++)u[s[o][r]]--;s.splice(e,1),delete u[t]}else n(i,a).set(null),l[e]=6|l[e];return h},constructUpdate:function(){for(var t,i,o={},u=Object.keys(l),h=0;h<u.length;h++)i=u[h],t=e+\"[\"+i+\"]\",s[i]?(1&l[i]&&(o[t+\".\"+r]=s[i][r]),2&l[i]&&(o[t+\".\"+a]=c?4&l[i]?null:s[i][a]:4&l[i]?null:n(s[i],a).get())):o[t]=null;return o}};return h}},{\"./nested_property\":732}],729:[function(t,e,r){\"use strict\";function n(t,e){if(t.apply)t.apply(t,e);else for(var r=0;r<e.length;r++)t(e[r])}var i=t(\"../plot_api/plot_config\"),a=e.exports={};a.log=function(){if(i.logging>1){for(var t=[\"LOG:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.trace||console.log,t)}},a.warn=function(){if(i.logging>0){for(var t=[\"WARN:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.trace||console.log,t)}},a.error=function(){if(i.logging>0){for(var t=[\"ERROR:\"],e=0;e<arguments.length;e++)t.push(arguments[e]);n(console.error,t)}}},{\"../plot_api/plot_config\":754}],730:[function(t,e,r){\"use strict\";r.init2dArray=function(t,e){for(var r=new Array(t),n=0;n<t;n++)r[n]=new Array(e);return r},r.transposeRagged=function(t){var e,r,n=0,i=t.length;for(e=0;e<i;e++)n=Math.max(n,t[e].length);var a=new Array(n);for(e=0;e<n;e++)for(a[e]=new Array(i),r=0;r<i;r++)a[e][r]=t[r][e];return a},r.dot=function(t,e){if(!t.length||!e.length||t.length!==e.length)return null;var n,i,a=t.length;if(t[0].length)for(n=new Array(a),i=0;i<a;i++)n[i]=r.dot(t[i],e);else if(e[0].length){var o=r.transposeRagged(e);for(n=new Array(o.length),i=0;i<o.length;i++)n[i]=r.dot(t,o[i])}else for(n=0,i=0;i<a;i++)n+=t[i]*e[i];return n},r.translationMatrix=function(t,e){return[[1,0,t],[0,1,e],[0,0,1]]},r.rotationMatrix=function(t){var e=t*Math.PI/180;return[[Math.cos(e),-Math.sin(e),0],[Math.sin(e),Math.cos(e),0],[0,0,1]]},r.rotationXYMatrix=function(t,e,n){return r.dot(r.dot(r.translationMatrix(e,n),r.rotationMatrix(t)),r.translationMatrix(-e,-n))},r.apply2DTransform=function(t){return function(){var e=arguments;3===e.length&&(e=e[0]);var n=1===arguments.length?e[0]:[e[0],e[1]];return r.dot(t,[n[0],n[1],1]).slice(0,2)}},r.apply2DTransform2=function(t){var e=r.apply2DTransform(t);return function(t){return e(t.slice(0,2)).concat(e(t.slice(2,4)))}}},{}],731:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r=t%e;return r<0?r+e:r}},{}],732:[function(t,e,r){\"use strict\";function n(t,e){return function(){var r,i,a,o,s,l=t;for(o=0;o<e.length-1;o++){if(-1===(r=e[o])){for(i=!0,a=[],s=0;s<l.length;s++)a[s]=n(l[s],e.slice(o+1))(),a[s]!==a[0]&&(i=!1);return i?a[0]:a}if(\"number\"==typeof r&&!d(l))return;if(\"object\"!=typeof(l=l[r])||null===l)return}if(\"object\"==typeof l&&null!==l&&null!==(a=l[e[o]]))return a}}function i(t,e){if(!c(t)||p(t)&&\"]\"===e.charAt(e.length-1)||e.match(g)&&void 0!==t)return!1;if(!d(t))return!0;if(e.match(v))return!0;var r=m(e);return r&&\"\"===r.index}function a(t,e,r){return function(n){var a,c,h=t,f=\"\",p=[[t,f]],m=i(n,r);for(c=0;c<e.length-1;c++){if(\"number\"==typeof(a=e[c])&&!d(h))throw\"array index but container is not an array\";if(-1===a){if(m=!s(h,e.slice(c+1),n,r))break;return}if(!l(h,a,e[c+1],m))break;if(\"object\"!=typeof(h=h[a])||null===h)throw\"container is not an object\";f=o(f,a),p.push([h,f])}m?(c===e.length-1&&delete h[e[c]],u(p)):h[e[c]]=n}}function o(t,e){var r=e;return f(e)?r=\"[\"+e+\"]\":t&&(r=\".\"+e),t+r}function s(t,e,r,n){var o,s=d(r),u=!0,c=r,h=n.replace(\"-1\",0),f=!s&&i(r,h),p=e[0];for(o=0;o<t.length;o++)h=n.replace(\"-1\",o),s&&(c=r[o%r.length],f=i(c,h)),f&&(u=!1),l(t,o,p,f)&&a(t[o],e,n.replace(\"-1\",o))(c);return u}function l(t,e,r,n){if(void 0===t[e]){if(n)return!1;t[e]=\"number\"==typeof r?[]:{}}return!0}function u(t){var e,r,n,a,s,l;for(e=t.length-1;e>=0;e--){if(n=t[e][0],a=t[e][1],l=!1,d(n))for(r=n.length-1;r>=0;r--)i(n[r],o(a,r))?l?n[r]=void 0:n.pop():l=!0;else if(\"object\"==typeof n&&null!==n)for(s=Object.keys(n),l=!1,r=s.length-1;r>=0;r--)i(n[s[r]],o(a,s[r]))?delete n[s[r]]:l=!0;if(l)return}}function c(t){return void 0===t||null===t||\"object\"==typeof t&&(d(t)?!t.length:!Object.keys(t).length)}function h(t,e,r){return{set:function(){throw\"bad container\"},get:function(){},astr:e,parts:r,obj:t}}var f=t(\"fast-isnumeric\"),d=t(\"./is_array\"),p=t(\"./is_plain_object\"),m=t(\"../plot_api/container_array_match\");e.exports=function(t,e){if(f(e))e=String(e);else if(\"string\"!=typeof e||\"[-1]\"===e.substr(e.length-4))throw\"bad property string\";for(var r,i,o,s=0,l=e.split(\".\");s<l.length;){if(r=String(l[s]).match(/^([^\\[\\]]*)((\\[\\-?[0-9]*\\])+)$/)){if(r[1])l[s]=r[1];else{if(0!==s)throw\"bad property string\";l.splice(0,1)}for(i=r[2].substr(1,r[2].length-2).split(\"][\"),o=0;o<i.length;o++)s++,l.splice(s,0,Number(i[o]))}s++}return\"object\"!=typeof t?h(t,e,l):{set:a(t,l,e),get:n(t,l),astr:e,parts:l,obj:t}};var v=/(^|\\.)((domain|range)(\\.[xy])?|args|parallels)$/,g=/(^|\\.)args\\[/},{\"../plot_api/container_array_match\":749,\"./is_array\":726,\"./is_plain_object\":727,\"fast-isnumeric\":130}],733:[function(t,e,r){\"use strict\";e.exports=function(){}},{}],734:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"fast-isnumeric\"),a=[];e.exports=function(t,e){function r(t){t.duration(700).style(\"opacity\",0).each(\"end\",function(t){var e=a.indexOf(t);-1!==e&&a.splice(e,1),n.select(this).remove()})}if(-1===a.indexOf(t)){a.push(t);var o=1e3;i(e)?o=e:\"long\"===e&&(o=3e3);var s=n.select(\"body\").selectAll(\".plotly-notifier\").data([0]);s.enter().append(\"div\").classed(\"plotly-notifier\",!0);s.selectAll(\".notifier-note\").data(a).enter().append(\"div\").classed(\"notifier-note\",!0).style(\"opacity\",0).each(function(t){var e=n.select(this);e.append(\"button\").classed(\"notifier-close\",!0).html(\"&times;\").on(\"click\",function(){e.transition().call(r)});for(var i=e.append(\"p\"),a=t.split(/<br\\s*\\/?>/g),s=0;s<a.length;s++)s&&i.append(\"br\"),i.append(\"span\").text(a[s]);e.transition().duration(700).style(\"opacity\",1).transition().delay(o).call(r)})}}},{d3:121,\"fast-isnumeric\":130}],735:[function(t,e,r){\"use strict\";var n=t(\"./setcursor\"),i=\"data-savedcursor\";e.exports=function(t,e){var r=t.attr(i);if(e){if(!r){for(var a=(t.attr(\"class\")||\"\").split(\" \"),o=0;o<a.length;o++){var s=a[o];0===s.indexOf(\"cursor-\")&&t.attr(i,s.substr(7)).classed(s,!1)}t.attr(i)||t.attr(i,\"!!\")}n(t,e)}else r&&(t.attr(i,null),\"!!\"===r?n(t):n(t,r))}},{\"./setcursor\":741}],736:[function(t,e,r){\"use strict\";var n=t(\"./matrix\").dot,i=t(\"../constants/numerical\").BADNUM,a=e.exports={};a.tester=function(t){function e(t,e){var r=t[0],n=t[1];return!(r===i||r<a||r>o||n===i||n<s||n>l)&&(!e||!c(t))}function r(t,e){var r=t[0],u=t[1];if(r===i||r<a||r>o||u===i||u<s||u>l)return!1;var c,h,f,d,p,m=n.length,v=n[0][0],g=n[0][1],y=0;for(c=1;c<m;c++)if(h=v,f=g,v=n[c][0],g=n[c][1],d=Math.min(h,v),!(r<d||r>Math.max(h,v)||u>Math.max(f,g)))if(u<Math.min(f,g))r!==d&&y++;else{if(p=v===h?u:f+(r-h)*(g-f)/(v-h),u===p)return 1!==c||!e;u<=p&&r!==d&&y++}return y%2==1}var n=t.slice(),a=n[0][0],o=a,s=n[0][1],l=s;n.push(n[0]);for(var u=1;u<n.length;u++)a=Math.min(a,n[u][0]),o=Math.max(o,n[u][0]),s=Math.min(s,n[u][1]),l=Math.max(l,n[u][1]);var c,h=!1;return 5===n.length&&(n[0][0]===n[1][0]?n[2][0]===n[3][0]&&n[0][1]===n[3][1]&&n[1][1]===n[2][1]&&(h=!0,c=function(t){return t[0]===n[0][0]}):n[0][1]===n[1][1]&&n[2][1]===n[3][1]&&n[0][0]===n[3][0]&&n[1][0]===n[2][0]&&(h=!0,c=function(t){return t[1]===n[0][1]})),{xmin:a,xmax:o,ymin:s,ymax:l,pts:n,contains:h?e:r,isRect:h}};var o=a.isSegmentBent=function(t,e,r,i){var a,o,s,l=t[e],u=[t[r][0]-l[0],t[r][1]-l[1]],c=n(u,u),h=Math.sqrt(c),f=[-u[1]/h,u[0]/h];for(a=e+1;a<r;a++)if(o=[t[a][0]-l[0],t[a][1]-l[1]],(s=n(o,u))<0||s>c||Math.abs(n(o,f))>i)return!0;return!1};a.filter=function(t,e){function r(r){t.push(r);var s=n.length,l=i;n.splice(a+1);for(var u=l+1;u<t.length;u++)(u===t.length-1||o(t,l,u+1,e))&&(n.push(t[u]),n.length<s-2&&(i=u,a=n.length-1),l=u)}var n=[t[0]],i=0,a=0;if(t.length>1){r(t.pop())}return{addPt:r,raw:t,filtered:n}}},{\"../constants/numerical\":705,\"./matrix\":730}],737:[function(t,e,r){\"use strict\";e.exports=function(t,e){if(e instanceof RegExp){var r,n=e.toString();for(r=0;r<t.length;r++)if(t[r]instanceof RegExp&&t[r].toString()===n)return t;t.push(e)}else e&&-1===t.indexOf(e)&&t.push(e);return t}},{}],738:[function(t,e,r){\"use strict\";function n(t,e){for(var r,n=[],a=0;a<e.length;a++)r=e[a],n[a]=r===t?r:\"object\"==typeof r?Array.isArray(r)?i.extendDeep([],r):i.extendDeepAll({},r):r;return n}var i=t(\"../lib\"),a=t(\"../plot_api/plot_config\"),o={};o.add=function(t,e,r,n,i){var o,s;if(t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},s=t.undoQueue.index,t.autoplay)return void(t.undoQueue.inSequence||(t.autoplay=!1));!t.undoQueue.sequence||t.undoQueue.beginSequence?(o={undo:{calls:[],args:[]},redo:{calls:[],args:[]}},t.undoQueue.queue.splice(s,t.undoQueue.queue.length-s,o),t.undoQueue.index+=1):o=t.undoQueue.queue[s-1],t.undoQueue.beginSequence=!1,o&&(o.undo.calls.unshift(e),o.undo.args.unshift(r),o.redo.calls.push(n),o.redo.args.push(i)),t.undoQueue.queue.length>a.queueLength&&(t.undoQueue.queue.shift(),t.undoQueue.index--)},o.startSequence=function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!0,t.undoQueue.beginSequence=!0},o.stopSequence=function(t){t.undoQueue=t.undoQueue||{index:0,queue:[],sequence:!1},t.undoQueue.sequence=!1,t.undoQueue.beginSequence=!1},o.undo=function(t){var e,r;if(t.framework&&t.framework.isPolar)return void t.framework.undo();if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index<=0)){for(t.undoQueue.index--,e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.undo.calls.length;r++)o.plotDo(t,e.undo.calls[r],e.undo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1}},o.redo=function(t){var e,r;if(t.framework&&t.framework.isPolar)return void t.framework.redo();if(!(void 0===t.undoQueue||isNaN(t.undoQueue.index)||t.undoQueue.index>=t.undoQueue.queue.length)){for(e=t.undoQueue.queue[t.undoQueue.index],t.undoQueue.inSequence=!0,r=0;r<e.redo.calls.length;r++)o.plotDo(t,e.redo.calls[r],e.redo.args[r]);t.undoQueue.inSequence=!1,t.autoplay=!1,t.undoQueue.index++}},o.plotDo=function(t,e,r){t.autoplay=!0,r=n(t,r),e.apply(null,r)},e.exports=o},{\"../lib\":725,\"../plot_api/plot_config\":754}],739:[function(t,e,r){\"use strict\";var n=t(\"./is_array\"),i=t(\"./is_plain_object\");e.exports=function t(e,r){for(var a=Object.keys(r||{}),o=0;o<a.length;o++){var s=a[o],l=r[s],u=e[s];if(\"_\"===s.charAt(0)||\"function\"==typeof l){if(s in e)continue;e[s]=l}else if(n(l)&&n(u)&&i(l[0]))for(var c=0;c<l.length;c++)i(l[c])&&i(u[c])&&t(u[c],l[c]);else i(l)&&i(u)&&(t(u,l),Object.keys(u).length||delete e[s])}}},{\"./is_array\":726,\"./is_plain_object\":727}],740:[function(t,e,r){\"use strict\";function n(t,e){return t<e}function i(t,e){return t<=e}function a(t,e){return t>e}function o(t,e){return t>=e}var s=t(\"fast-isnumeric\"),l=t(\"./loggers\");r.findBin=function(t,e,r){if(s(e.start))return r?Math.ceil((t-e.start)/e.size)-1:Math.floor((t-e.start)/e.size);var u,c,h=0,f=e.length,d=0;for(c=e[e.length-1]>=e[0]?r?n:i:r?o:a;h<f&&d++<100;)u=Math.floor((h+f)/2),c(e[u],t)?h=u+1:f=u;return d>90&&l.log(\"Long binary search...\"),h-1},r.sorterAsc=function(t,e){return t-e},r.sorterDes=function(t,e){return e-t},r.distinctVals=function(t){var e=t.slice();e.sort(r.sorterAsc);for(var n=e.length-1,i=e[n]-e[0]||1,a=i/(n||1)/1e4,o=[e[0]],s=0;s<n;s++)e[s+1]>e[s]+a&&(i=Math.min(i,e[s+1]-e[s]),o.push(e[s+1]));return{vals:o,minDiff:i}},r.roundUp=function(t,e,r){for(var n,i=0,a=e.length-1,o=0,s=r?0:1,l=r?1:0,u=r?Math.ceil:Math.floor;i<a&&o++<100;)n=u((i+a)/2),e[n]<=t?i=n+s:a=n-l;return e[i]}},{\"./loggers\":729,\"fast-isnumeric\":130}],741:[function(t,e,r){\"use strict\";e.exports=function(t,e){(t.attr(\"class\")||\"\").split(\" \").forEach(function(e){0===e.indexOf(\"cursor-\")&&t.classed(e,!1)}),e&&t.classed(\"cursor-\"+e,!0)}},{}],742:[function(t,e,r){\"use strict\";var n=t(\"../components/color\"),i=function(){};e.exports=function(t){for(var e in t)\"function\"==typeof t[e]&&(t[e]=i);t.destroy=function(){t.container.parentNode.removeChild(t.container)};var r=document.createElement(\"div\");return r.textContent=\"Webgl is not supported by your browser - visit http://get.webgl.org for more info\",r.style.cursor=\"pointer\",r.style.fontSize=\"24px\",r.style.color=n.defaults[0],t.container.appendChild(r),t.container.style.background=\"#FFFFFF\",t.container.onclick=function(){window.open(\"http://get.webgl.org\")},!1}},{\"../components/color\":603}],743:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");r.aggNums=function(t,e,i,a){var o,s;if(a||(a=i.length),n(e)||(e=!1),Array.isArray(i[0])){for(s=new Array(a),o=0;o<a;o++)s[o]=r.aggNums(t,e,i[o]);i=s}for(o=0;o<a;o++)n(e)?n(i[o])&&(e=t(+e,+i[o])):e=i[o];return e},r.len=function(t){return r.aggNums(function(t){return t+1},0,t)},r.mean=function(t,e){return e||(e=r.len(t)),r.aggNums(function(t,e){return t+e},0,t)/e},r.variance=function(t,e,i){return e||(e=r.len(t)),n(i)||(i=r.mean(t,e)),r.aggNums(function(t,e){return t+Math.pow(e-i,2)},0,t)/e},r.stdev=function(t,e,n){return Math.sqrt(r.variance(t,e,n))},r.interp=function(t,e){if(!n(e))throw\"n should be a finite number\";if((e=e*t.length-.5)<0)return t[0];if(e>t.length-1)return t[t.length-1];var r=e%1;return r*t[Math.ceil(e)]+(1-r)*t[Math.floor(e)]}},{\"fast-isnumeric\":130}],744:[function(t,e,r){\"use strict\";function n(t){var e=i(t);return e.length?e:[0,0,0,1]}var i=t(\"color-rgba\");e.exports=n},{\"color-rgba\":94}],745:[function(t,e,r){\"use strict\";function n(t,e){return t.node().getBoundingClientRect()[e]}function i(t){return t.replace(g,\"\\\\lt \").replace(y,\"\\\\gt \")}function a(t,e,r){var n=\"math-output-\"+f.randstr([],64),a=h.select(\"body\").append(\"div\").attr({id:n}).style({visibility:\"hidden\",position:\"absolute\"}).style({\"font-size\":e.fontSize+\"px\"}).text(i(t));MathJax.Hub.Queue([\"Typeset\",MathJax.Hub,a.node()],function(){var e=h.select(\"body\").select(\"#MathJax_SVG_glyphs\");if(a.select(\".MathJax_SVG\").empty()||!a.select(\"svg\").node())f.log(\"There was an error in the tex syntax.\",t),r();else{var n=a.select(\"svg\").node().getBoundingClientRect();r(a.select(\".MathJax_SVG\"),e,n)}a.remove()})}function o(t,e){if(!t)return null;var r=t.match(e);return r&&(r[3]||r[4])}function s(t,e){if(!t)return\"\";for(var r=0;r<e.length;r++){var n=e[r];t=t.replace(n.regExp,n.sub)}return t}function l(t){return s(t,A)}function u(t,e){function r(){c++;var e=document.createElementNS(d.svg,\"tspan\");h.select(e).attr({class:\"line\",dy:c*m+\"em\"}),t.appendChild(e),a=e;var r=u;if(u=[{node:e}],r.length>1)for(var i=1;i<r.length;i++)n(r[i])}function n(t){var e,r=t.type,n={};if(\"a\"===r){e=\"a\";var o=t.target,s=t.href,l=t.popup;s&&(n={\"xlink:xlink:show\":\"_blank\"===o||\"_\"!==o.charAt(0)?\"new\":\"replace\",target:o,\"xlink:xlink:href\":s},l&&(n.onclick='window.open(this.href.baseVal,this.target.baseVal,\"'+l+'\");return false;'))}else e=\"tspan\";t.style&&(n.style=t.style);var c=document.createElementNS(d.svg,e);if(\"sup\"===r||\"sub\"===r){i(a,w),a.appendChild(c);var f=document.createElementNS(d.svg,\"tspan\");i(f,w),h.select(f).attr(\"dy\",_[r]),n.dy=x[r],a.appendChild(c),a.appendChild(f)}else a.appendChild(c);h.select(c).attr(n),a=t.node=c,u.push(t)}function i(t,e){t.appendChild(document.createTextNode(e))}e=l(e).replace(T,\" \");var a,s=!1,u=[],c=-1;L.test(e)?r():(a=t,u=[{node:t}]);for(var p=e.split(S),v=0;v<p.length;v++){var g=p[v],y=g.match(E),k=y&&y[2].toLowerCase(),A=b[k];if(\"br\"===k)r();else if(void 0===A)i(a,g);else if(y[1])!function(t){if(1===u.length)return void f.log(\"Ignoring unexpected end tag </\"+t+\">.\",e);var r=u.pop();t!==r.type&&f.log(\"Start tag <\"+r.type+\"> doesnt match end tag <\"+t+\">. Pretending it did match.\",e),a=u[u.length-1].node}(k);else{var O=y[4],R={type:k},F=o(O,C);if(F?(F=F.replace(P,\"$1 fill:\"),A&&(F+=\";\"+A)):A&&(F=A),F&&(R.style=F),\"a\"===k){s=!0;var j=o(O,z);if(j){var N=document.createElement(\"a\");N.href=j,-1!==M.indexOf(N.protocol)&&(R.href=encodeURI(j),R.target=o(O,I)||\"_blank\",R.popup=o(O,D))}}n(R)}}return s}function c(t,e,r){var n,i,a,o=r.horizontalAlign,s=r.verticalAlign||\"top\",l=t.node().getBoundingClientRect(),u=e.node().getBoundingClientRect();return i=\"bottom\"===s?function(){return l.bottom-n.height}:\"middle\"===s?function(){return l.top+(l.height-n.height)/2}:function(){return l.top},a=\"right\"===o?function(){return l.right-n.width}:\"center\"===o?function(){return l.left+(l.width-n.width)/2}:function(){return l.left},function(){return n=this.node().getBoundingClientRect(),this.style({top:i()-u.top+\"px\",left:a()-u.left+\"px\",\"z-index\":1e3}),this}}var h=t(\"d3\"),f=t(\"../lib\"),d=t(\"../constants/xmlns_namespaces\"),p=t(\"../constants/string_mappings\"),m=t(\"../constants/alignment\").LINE_SPACING,v=/([^$]*)([$]+[^$]*[$]+)([^$]*)/;r.convertToTspans=function(t,e,i){function o(){c.empty()||(f=t.attr(\"class\")+\"-math\",c.select(\"svg.\"+f).remove()),t.text(\"\").style(\"white-space\",\"pre\"),u(t.node(),s)&&t.style(\"pointer-events\",\"all\"),r.positionText(t),i&&i.call(t)}var s=t.text(),l=!t.attr(\"data-notex\")&&\"undefined\"!=typeof MathJax&&s.match(v),c=h.select(t.node().parentNode);if(!c.empty()){var f=t.attr(\"class\")?t.attr(\"class\").split(\" \")[0]:\"text\";return f+=\"-math\",c.selectAll(\"svg.\"+f).remove(),c.selectAll(\"g.\"+f+\"-group\").remove(),t.style(\"display\",null).attr({\"data-unformatted\":s,\"data-math\":\"N\"}),l?(e&&e._promises||[]).push(new Promise(function(e){t.style(\"display\",\"none\");var r={fontSize:parseInt(t.style(\"font-size\"),10)};a(l[2],r,function(r,a,l){c.selectAll(\"svg.\"+f).remove(),c.selectAll(\"g.\"+f+\"-group\").remove();var u=r&&r.select(\"svg\");if(!u||!u.node())return o(),void e();var h=c.append(\"g\").classed(f+\"-group\",!0).attr({\"pointer-events\":\"none\",\"data-unformatted\":s,\"data-math\":\"Y\"});h.node().appendChild(u.node()),a&&a.node()&&u.node().insertBefore(a.node().cloneNode(!0),u.node().firstChild),u.attr({class:f,height:l.height,preserveAspectRatio:\"xMinYMin meet\"}).style({overflow:\"visible\",\"pointer-events\":\"none\"});var d=t.style(\"fill\")||\"black\";u.select(\"g\").attr({fill:d,stroke:d});var p=n(u,\"width\"),m=n(u,\"height\"),v=+t.attr(\"x\")-p*{start:0,middle:.5,end:1}[t.attr(\"text-anchor\")||\"start\"],g=parseInt(t.style(\"font-size\"),10)||n(t,\"height\"),y=-g/4;\"y\"===f[0]?(h.attr({transform:\"rotate(\"+[-90,+t.attr(\"x\"),+t.attr(\"y\")]+\") translate(\"+[-p/2,y-m/2]+\")\"}),u.attr({x:+t.attr(\"x\"),y:+t.attr(\"y\")})):\"l\"===f[0]?u.attr({x:t.attr(\"x\"),y:y-m/2}):\"a\"===f[0]?u.attr({x:0,y:y}):u.attr({x:v,y:+t.attr(\"y\")+y-m/2}),i&&i.call(t,h),e(h)})})):o(),t}};var g=/(<|&lt;|&#60;)/g,y=/(>|&gt;|&#62;)/g,b={sup:\"font-size:70%\",sub:\"font-size:70%\",b:\"font-weight:bold\",i:\"font-style:italic\",a:\"cursor:pointer\",span:\"\",em:\"font-style:italic;font-weight:bold\"},x={sub:\"0.3em\",sup:\"-0.6em\"},_={sub:\"-0.21em\",sup:\"0.42em\"},w=\"\\u200b\",M=[\"http:\",\"https:\",\"mailto:\",\"\",void 0,\":\"],k=new RegExp(\"</?(\"+Object.keys(b).join(\"|\")+\")( [^>]*)?/?>\",\"g\"),A=Object.keys(p.entityToUnicode).map(function(t){return{regExp:new RegExp(\"&\"+t+\";\",\"g\"),sub:p.entityToUnicode[t]}}),T=/(\\r\\n?|\\n)/g,S=/(<[^<>]*>)/,E=/<(\\/?)([^ >]*)(\\s+(.*))?>/i,L=/<br(\\s+.*)?>/i,C=/(^|[\\s\"'])style\\s*=\\s*(\"([^\"]*);?\"|'([^']*);?')/i,z=/(^|[\\s\"'])href\\s*=\\s*(\"([^\"]*)\"|'([^']*)')/i,I=/(^|[\\s\"'])target\\s*=\\s*(\"([^\"\\s]*)\"|'([^'\\s]*)')/i,D=/(^|[\\s\"'])popup\\s*=\\s*(\"([\\w=,]*)\"|'([\\w=,]*)')/i,P=/(^|;)\\s*color:/;r.plainText=function(t){return(t||\"\").replace(k,\" \")},r.lineCount=function(t){return t.selectAll(\"tspan.line\").size()||1},r.positionText=function(t,e,r){return t.each(function(){function t(t,e){return void 0===e?null===(e=n.attr(t))&&(n.attr(t,0),e=0):n.attr(t,e),e}var n=h.select(this),i=t(\"x\",e),a=t(\"y\",r);\"text\"===this.nodeName&&n.selectAll(\"tspan.line\").attr({x:i,y:a})})},r.makeEditable=function(t,e){function r(){i(),t.style({opacity:0})\n",
       ";var e,r=l.attr(\"class\");(e=r?\".\"+r.split(\" \")[0]+\"-math-group\":\"[class*=-math-group]\")&&h.select(t.node().parentNode).select(e).style({opacity:0})}function n(t){var e=t.node(),r=document.createRange();r.selectNodeContents(e);var n=window.getSelection();n.removeAllRanges(),n.addRange(r),e.focus()}function i(){var r=h.select(a),i=r.select(\".svg-container\"),o=i.append(\"div\");o.classed(\"plugin-editable editable\",!0).style({position:\"absolute\",\"font-family\":t.style(\"font-family\")||\"Arial\",\"font-size\":t.style(\"font-size\")||12,color:e.fill||t.style(\"fill\")||\"black\",opacity:1,\"background-color\":e.background||\"transparent\",outline:\"#ffffff33 1px solid\",margin:[-parseFloat(t.style(\"font-size\"))/8+1,0,0,-1].join(\"px \")+\"px\",padding:\"0\",\"box-sizing\":\"border-box\"}).attr({contenteditable:!0}).text(e.text||t.attr(\"data-unformatted\")).call(c(t,i,e)).on(\"blur\",function(){a._editing=!1,t.text(this.textContent).style({opacity:1});var e,r=h.select(this).attr(\"class\");(e=r?\".\"+r.split(\" \")[0]+\"-math-group\":\"[class*=-math-group]\")&&h.select(t.node().parentNode).select(e).style({opacity:0});var n=this.textContent;h.select(this).transition().duration(0).remove(),h.select(document).on(\"mouseup\",null),s.edit.call(t,n)}).on(\"focus\",function(){var t=this;a._editing=!0,h.select(document).on(\"mouseup\",function(){if(h.event.target===t)return!1;document.activeElement===o.node()&&o.node().blur()})}).on(\"keyup\",function(){27===h.event.which?(a._editing=!1,t.style({opacity:1}),h.select(this).style({opacity:0}).on(\"blur\",function(){return!1}).transition().remove(),s.cancel.call(t,this.textContent)):(s.input.call(t,this.textContent),h.select(this).call(c(t,i,e)))}).on(\"keydown\",function(){13===h.event.which&&this.blur()}).call(n)}var a=e.gd,o=e.delegate,s=h.dispatch(\"edit\",\"input\",\"cancel\"),l=o||t;if(t.style({\"pointer-events\":o?\"none\":\"all\"}),1!==t.size())throw new Error(\"boo\");return e.immediate?r():l.on(\"click\",r),h.rebind(t,s,\"on\")}},{\"../constants/alignment\":699,\"../constants/string_mappings\":706,\"../constants/xmlns_namespaces\":707,\"../lib\":725,d3:121}],746:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t,e){if(t>0)return Math.log(t)/Math.LN10;var r=Math.log(Math.min(e[0],e[1]))/Math.LN10;return n(r)||(r=Math.log(Math.max(e[0],e[1]))/Math.LN10-6),r}},{\"fast-isnumeric\":130}],747:[function(t,e,r){\"use strict\";var n=e.exports={},i=t(\"../plots/geo/constants\").locationmodeToLayer,a=t(\"topojson-client\").feature;n.getTopojsonName=function(t){return[t.scope.replace(/ /g,\"-\"),\"_\",t.resolution.toString(),\"m\"].join(\"\")},n.getTopojsonPath=function(t,e){return t+e+\".json\"},n.getTopojsonFeatures=function(t,e){var r=i[t.locationmode],n=e.objects[r];return a(e,n).features}},{\"../plots/geo/constants\":792,\"topojson-client\":535}],748:[function(t,e,r){\"use strict\";function n(t,e){for(var r=new Float32Array(e),n=0;n<e;n++)r[n]=t[n];return r}function i(t,e){for(var r=new Float64Array(e),n=0;n<e;n++)r[n]=t[n];return r}e.exports=function(t,e){if(t instanceof Float32Array)return n(t,e);if(t instanceof Float64Array)return i(t,e);throw new Error(\"This array type is not yet supported by `truncate`.\")}},{}],749:[function(t,e,r){\"use strict\";var n=t(\"../registry\");e.exports=function(t){for(var e,r,i=n.layoutArrayContainers,a=n.layoutArrayRegexes,o=t.split(\"[\")[0],s=0;s<a.length;s++)if((r=t.match(a[s]))&&0===r.index){e=r[0];break}if(e||(e=i[i.indexOf(o)]),!e)return!1;var l=t.substr(e.length);return l?!!(r=l.match(/^\\[(0|[1-9][0-9]*)\\](\\.(.+))?$/))&&{array:e,index:Number(r[1]),property:r[3]||\"\"}:{array:e,index:\"\",property:\"\"}}},{\"../registry\":844}],750:[function(t,e,r){\"use strict\";e.exports={traces:function(){return{docalc:!1,docalcAutorange:!1,doplot:!1,dostyle:!1,docolorbars:!1,autorangeOn:!1,clearCalc:!1,fullReplot:!1}},layout:function(){return{dolegend:!1,doticks:!1,dolayoutstyle:!1,doplot:!1,docalc:!1,domodebar:!1,docamera:!1,layoutReplot:!1}},update:function(t,e){var r=e.editType;if(r)for(var n=r.split(\"+\"),i=0;i<n.length;i++)t[n[i]]=!0}}},{}],751:[function(t,e,r){\"use strict\";function n(t,e){var r=t[e],n=e.charAt(0);r&&\"paper\"!==r&&(t[e]=f.cleanId(r,n))}function i(t){var e=\"middle\",r=\"center\";return-1!==t.indexOf(\"top\")?e=\"top\":-1!==t.indexOf(\"bottom\")&&(e=\"bottom\"),-1!==t.indexOf(\"left\")?r=\"left\":-1!==t.indexOf(\"right\")&&(r=\"right\"),e+\" \"+r}function a(t,e){return e in t&&\"object\"==typeof t[e]&&0===Object.keys(t[e]).length}function o(t){var e=t.search(p);if(e>0)return t.substr(0,e)}var s=t(\"fast-isnumeric\"),l=t(\"gl-mat4/fromQuat\"),u=t(\"../registry\"),c=t(\"../lib\"),h=t(\"../plots/plots\"),f=t(\"../plots/cartesian/axes\"),d=t(\"../components/color\");r.getGraphDiv=function(t){var e;if(\"string\"==typeof t){if(null===(e=document.getElementById(t)))throw new Error(\"No DOM element with id '\"+t+\"' exists on the page.\");return e}if(null===t||void 0===t)throw new Error(\"DOM element provided is null or undefined\");return t},r.clearPromiseQueue=function(t){Array.isArray(t._promises)&&t._promises.length>0&&c.log(\"Clearing previous rejected promises from queue.\"),t._promises=[]},r.cleanLayout=function(t){var e,r;t||(t={}),t.xaxis1&&(t.xaxis||(t.xaxis=t.xaxis1),delete t.xaxis1),t.yaxis1&&(t.yaxis||(t.yaxis=t.yaxis1),delete t.yaxis1);var i=f.list({_fullLayout:t});for(e=0;e<i.length;e++){var o=i[e];o.anchor&&\"free\"!==o.anchor&&(o.anchor=f.cleanId(o.anchor)),o.overlaying&&(o.overlaying=f.cleanId(o.overlaying)),o.type||(o.isdate?o.type=\"date\":o.islog?o.type=\"log\":!1===o.isdate&&!1===o.islog&&(o.type=\"linear\")),\"withzero\"!==o.autorange&&\"tozero\"!==o.autorange||(o.autorange=!0,o.rangemode=\"tozero\"),delete o.islog,delete o.isdate,delete o.categories,a(o,\"domain\")&&delete o.domain,void 0!==o.autotick&&(void 0===o.tickmode&&(o.tickmode=o.autotick?\"auto\":\"linear\"),delete o.autotick)}var s=Array.isArray(t.annotations)?t.annotations.length:0;for(e=0;e<s;e++){var u=t.annotations[e];c.isPlainObject(u)&&(u.ref&&(\"paper\"===u.ref?(u.xref=\"paper\",u.yref=\"paper\"):\"data\"===u.ref&&(u.xref=\"x\",u.yref=\"y\"),delete u.ref),n(u,\"xref\"),n(u,\"yref\"))}var p=Array.isArray(t.shapes)?t.shapes.length:0;for(e=0;e<p;e++){var m=t.shapes[e];c.isPlainObject(m)&&(n(m,\"xref\"),n(m,\"yref\"))}var v=t.legend;v&&(v.x>3?(v.x=1.02,v.xanchor=\"left\"):v.x<-2&&(v.x=-.02,v.xanchor=\"right\"),v.y>3?(v.y=1.02,v.yanchor=\"bottom\"):v.y<-2&&(v.y=-.02,v.yanchor=\"top\")),\"rotate\"===t.dragmode&&(t.dragmode=\"orbit\"),t.scene1&&(t.scene||(t.scene=t.scene1),delete t.scene1);var g=h.getSubplotIds(t,\"gl3d\");for(e=0;e<g.length;e++){var y=t[g[e]],b=y.cameraposition;if(Array.isArray(b)&&4===b[0].length){var x=b[0],_=b[1],w=b[2],M=l([],x),k=[];for(r=0;r<3;++r)k[r]=_[e]+w*M[2+4*r];y.camera={eye:{x:k[0],y:k[1],z:k[2]},center:{x:_[0],y:_[1],z:_[2]},up:{x:M[1],y:M[5],z:M[9]}},delete y.cameraposition}}return d.clean(t),t},r.cleanData=function(t,e){for(var n=[],o=(t.concat(Array.isArray(e)?e:[]).filter(function(t){return\"uid\"in t}).map(function(t){return t.uid})),s=0;s<t.length;s++){var l,p=t[s];if(!(\"uid\"in p)||-1!==n.indexOf(p.uid)){var m;for(l=0;l<100&&(m=c.randstr(o),-1!==n.indexOf(m));l++);p.uid=c.randstr(o),o.push(p.uid)}if(n.push(p.uid),\"histogramy\"===p.type&&\"xbins\"in p&&!(\"ybins\"in p)&&(p.ybins=p.xbins,delete p.xbins),p.error_y&&\"opacity\"in p.error_y){var v=d.defaults,g=p.error_y.color||(u.traceIs(p,\"bar\")?d.defaultLine:v[s%v.length]);p.error_y.color=d.addOpacity(d.rgb(g),d.opacity(g)*p.error_y.opacity),delete p.error_y.opacity}if(\"bardir\"in p&&(\"h\"!==p.bardir||!u.traceIs(p,\"bar\")&&\"histogram\"!==p.type.substr(0,9)||(p.orientation=\"h\",r.swapXYData(p)),delete p.bardir),\"histogramy\"===p.type&&r.swapXYData(p),\"histogramx\"!==p.type&&\"histogramy\"!==p.type||(p.type=\"histogram\"),\"scl\"in p&&(p.colorscale=p.scl,delete p.scl),\"reversescl\"in p&&(p.reversescale=p.reversescl,delete p.reversescl),p.xaxis&&(p.xaxis=f.cleanId(p.xaxis,\"x\")),p.yaxis&&(p.yaxis=f.cleanId(p.yaxis,\"y\")),u.traceIs(p,\"gl3d\")&&p.scene&&(p.scene=h.subplotsRegistry.gl3d.cleanId(p.scene)),u.traceIs(p,\"pie\")||u.traceIs(p,\"bar\")||(Array.isArray(p.textposition)?p.textposition=p.textposition.map(i):p.textposition&&(p.textposition=i(p.textposition))),u.traceIs(p,\"2dMap\")&&(\"YIGnBu\"===p.colorscale&&(p.colorscale=\"YlGnBu\"),\"YIOrRd\"===p.colorscale&&(p.colorscale=\"YlOrRd\")),u.traceIs(p,\"markerColorscale\")&&p.marker){var y=p.marker;\"YIGnBu\"===y.colorscale&&(y.colorscale=\"YlGnBu\"),\"YIOrRd\"===y.colorscale&&(y.colorscale=\"YlOrRd\")}if(\"surface\"===p.type&&c.isPlainObject(p.contours)){var b=[\"x\",\"y\",\"z\"];for(l=0;l<b.length;l++){var x=p.contours[b[l]];c.isPlainObject(x)&&(x.highlightColor&&(x.highlightcolor=x.highlightColor,delete x.highlightColor),x.highlightWidth&&(x.highlightwidth=x.highlightWidth,delete x.highlightWidth))}}if(Array.isArray(p.transforms)){var _=p.transforms;for(l=0;l<_.length;l++){var w=_[l];if(c.isPlainObject(w))switch(w.type){case\"filter\":w.filtersrc&&(w.target=w.filtersrc,delete w.filtersrc),w.calendar&&(w.valuecalendar||(w.valuecalendar=w.calendar),delete w.calendar);break;case\"groupby\":if(w.styles=w.styles||w.style,w.styles&&!Array.isArray(w.styles)){var M=w.styles,k=Object.keys(M);w.styles=[];for(var A=0;A<k.length;A++)w.styles.push({target:k[A],value:M[k[A]]})}}}}a(p,\"line\")&&delete p.line,\"marker\"in p&&(a(p.marker,\"line\")&&delete p.marker.line,a(p,\"marker\")&&delete p.marker),d.clean(p)}},r.swapXYData=function(t){var e;if(c.swapAttrs(t,[\"?\",\"?0\",\"d?\",\"?bins\",\"nbins?\",\"autobin?\",\"?src\",\"error_?\"]),Array.isArray(t.z)&&Array.isArray(t.z[0])&&(t.transpose?delete t.transpose:t.transpose=!0),t.error_x&&t.error_y){var r=t.error_y,n=\"copy_ystyle\"in r?r.copy_ystyle:!(r.color||r.thickness||r.width);c.swapAttrs(t,[\"error_?.copy_ystyle\"]),n&&c.swapAttrs(t,[\"error_?.color\",\"error_?.thickness\",\"error_?.width\"])}if(\"string\"==typeof t.hoverinfo){var i=t.hoverinfo.split(\"+\");for(e=0;e<i.length;e++)\"x\"===i[e]?i[e]=\"y\":\"y\"===i[e]&&(i[e]=\"x\");t.hoverinfo=i.join(\"+\")}},r.coerceTraceIndices=function(t,e){return s(e)?[e]:Array.isArray(e)&&e.length?e:t.data.map(function(t,e){return e})},r.manageArrayContainers=function(t,e,r){var n=t.obj,i=t.parts,a=i.length,o=i[a-1],l=s(o);if(l&&null===e){var u=i.slice(0,a-1).join(\".\");c.nestedProperty(n,u).get().splice(o,1)}else l&&void 0===t.get()?(void 0===t.get()&&(r[t.astr]=null),t.set(e)):t.set(e)};var p=/(\\.[^\\[\\]\\.]+|\\[[^\\[\\]\\.]+\\])$/;r.hasParent=function(t,e){for(var r=o(e);r;){if(r in t)return!0;r=o(r)}return!1}},{\"../components/color\":603,\"../lib\":725,\"../plots/cartesian/axes\":766,\"../plots/plots\":829,\"../registry\":844,\"fast-isnumeric\":130,\"gl-mat4/fromQuat\":177}],752:[function(t,e,r){\"use strict\";var n=t(\"../lib/nested_property\"),i=t(\"../lib/is_plain_object\"),a=t(\"../lib/noop\"),o=t(\"../lib/loggers\"),s=t(\"../lib/search\").sorterAsc,l=t(\"../registry\");r.containerArrayMatch=t(\"./container_array_match\");var u=r.isAddVal=function(t){return\"add\"===t||i(t)},c=r.isRemoveVal=function(t){return null===t||\"remove\"===t};r.applyContainerArrayChanges=function(t,e,r,i){var h=e.astr,f=l.getComponentMethod(h,\"supplyLayoutDefaults\"),d=l.getComponentMethod(h,\"draw\"),p=l.getComponentMethod(h,\"drawOne\"),m=i.replot||i.recalc||f===a||d===a,v=t.layout,g=t._fullLayout;if(r[\"\"]){Object.keys(r).length>1&&o.warn(\"Full array edits are incompatible with other edits\",h);var y=r[\"\"][\"\"];if(c(y))e.set(null);else{if(!Array.isArray(y))return o.warn(\"Unrecognized full array edit value\",h,y),!0;e.set(y)}return!m&&(f(v,g),d(t),!0)}var b,x,_,w,M,k,A,T=Object.keys(r).map(Number).sort(s),S=e.get(),E=S||[],L=n(g,h).get(),C=[],z=-1,I=E.length;for(b=0;b<T.length;b++)if(_=T[b],w=r[_],M=Object.keys(w),k=w[\"\"],A=u(k),_<0||_>E.length-(A?0:1))o.warn(\"index out of range\",h,_);else if(void 0!==k)M.length>1&&o.warn(\"Insertion & removal are incompatible with edits to the same index.\",h,_),c(k)?C.push(_):A?(\"add\"===k&&(k={}),E.splice(_,0,k),L&&L.splice(_,0,{})):o.warn(\"Unrecognized full object edit value\",h,_,k),-1===z&&(z=_);else for(x=0;x<M.length;x++)n(E[_],M[x]).set(w[M[x]]);for(b=C.length-1;b>=0;b--)E.splice(C[b],1),L&&L.splice(C[b],1);if(E.length?S||e.set(E):e.set(null),m)return!1;if(f(v,g),p!==a){var D;if(-1===z)D=T;else{for(I=Math.max(E.length,I),D=[],b=0;b<T.length&&!((_=T[b])>=z);b++)D.push(_);for(b=z;b<I;b++)D.push(b)}for(b=0;b<D.length;b++)p(t,D[b])}else d(t);return!0}},{\"../lib/is_plain_object\":727,\"../lib/loggers\":729,\"../lib/nested_property\":732,\"../lib/noop\":733,\"../lib/search\":740,\"../registry\":844,\"./container_array_match\":749}],753:[function(t,e,r){\"use strict\";function n(t,e){try{t._fullLayout._paper.style(\"background\",e)}catch(t){_.error(t)}}function i(t,e){n(t,L.combine(e,\"white\"))}function a(t,e){t._context||(t._context=_.extendDeep({},x.defaultConfig));var r,a,o,s=t._context;if(e){for(a=Object.keys(e),r=0;r<a.length;r++)\"editable\"!==(o=a[r])&&\"edits\"!==o&&o in s&&(\"setBackground\"===o&&\"opaque\"===e[o]?s[o]=i:s[o]=e[o]);e.plot3dPixelRatio&&!s.plotGlPixelRatio&&(s.plotGlPixelRatio=s.plot3dPixelRatio);var l=e.editable;if(void 0!==l)for(s.editable=l,a=Object.keys(s.edits),r=0;r<a.length;r++)s.edits[a[r]]=l;if(e.edits)for(a=Object.keys(e.edits),r=0;r<a.length;r++)(o=a[r])in s.edits&&(s.edits[o]=e.edits[o])}s.staticPlot&&(s.editable=!1,s.edits={},s.autosizable=!1,s.scrollZoom=!1,s.doubleClick=!1,s.showTips=!1,s.showLink=!1,s.displayModeBar=!1),\"hover\"!==s.displayModeBar||b||(s.displayModeBar=!0),\"transparent\"!==s.setBackground&&\"function\"==typeof s.setBackground||(s.setBackground=n)}function o(t,e,r){var n=g.select(t).selectAll(\".plot-container\").data([0]);n.enter().insert(\"div\",\":first-child\").classed(\"plot-container plotly\",!0);var i=n.selectAll(\".svg-container\").data([0]);i.enter().append(\"div\").classed(\"svg-container\",!0).style(\"position\",\"relative\"),i.html(\"\"),e&&(t.data=e),r&&(t.layout=r),T.manager.fillLayout(t),i.style({width:t._fullLayout.width+\"px\",height:t._fullLayout.height+\"px\"}),t.framework=T.manager.framework(t),t.framework({data:t.data,layout:t.layout},i.node()),t.framework.setUndoPoint();var a=t.framework.svg(),o=1,s=t._fullLayout.title;\"\"!==s&&s||(o=0);var l=function(){this.call(I.convertToTspans,t)},u=a.select(\".title-group text\").call(l);if(t._context.edits.titleText){s&&\"Click to enter title\"!==s||(o=.2,u.attr({\"data-unformatted\":\"Click to enter title\"}).text(\"Click to enter title\").style({opacity:o}).on(\"mouseover.opacity\",function(){g.select(this).transition().duration(100).style(\"opacity\",1)}).on(\"mouseout.opacity\",function(){g.select(this).transition().duration(1e3).style(\"opacity\",0)}));var c=function(){this.call(I.makeEditable,{gd:t}).on(\"edit\",function(e){t.framework({layout:{title:e}}),this.text(e).call(l),this.call(c)}).on(\"cancel\",function(){var t=this.attr(\"data-unformatted\");this.text(t).call(l)})};u.call(c)}return t._context.setBackground(t,t._fullLayout.paper_bgcolor),A.addLinks(t),Promise.resolve()}function s(t,e){var r,n,i=e+1,a=[];for(r=0;r<t.length;r++)n=t[r],n<0?a.push(i+n):a.push(n);return a}function l(t,e,r){var n,i;for(n=0;n<e.length;n++){if((i=e[n])!==parseInt(i,10))throw new Error(\"all values in \"+r+\" must be integers\");if(i>=t.data.length||i<-t.data.length)throw new Error(r+\" must be valid indices for gd.data.\");if(e.indexOf(i,n+1)>-1||i>=0&&e.indexOf(-t.data.length+i)>-1||i<0&&e.indexOf(t.data.length+i)>-1)throw new Error(\"each index in \"+r+\" must be unique.\")}}function u(t,e,r){if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array.\");if(void 0===e)throw new Error(\"currentIndices is a required argument.\");if(Array.isArray(e)||(e=[e]),l(t,e,\"currentIndices\"),void 0===r||Array.isArray(r)||(r=[r]),void 0!==r&&l(t,r,\"newIndices\"),void 0!==r&&e.length!==r.length)throw new Error(\"current and new indices must be of equal length.\")}function c(t,e,r){var n,i;if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array.\");if(void 0===e)throw new Error(\"traces must be defined.\");for(Array.isArray(e)||(e=[e]),n=0;n<e.length;n++)if(\"object\"!=typeof(i=e[n])||Array.isArray(i)||null===i)throw new Error(\"all values in traces array must be non-array objects\");if(void 0===r||Array.isArray(r)||(r=[r]),void 0!==r&&r.length!==e.length)throw new Error(\"if indices is specified, traces.length must equal indices.length\")}function h(t,e,r,n){var i=_.isPlainObject(n);if(!Array.isArray(t.data))throw new Error(\"gd.data must be an array\");if(!_.isPlainObject(e))throw new Error(\"update must be a key:value object\");if(void 0===r)throw new Error(\"indices must be an integer or array of integers\");l(t,r,\"indices\");for(var a in e){if(!Array.isArray(e[a])||e[a].length!==r.length)throw new Error(\"attribute \"+a+\" must be an array of length equal to indices array length\");if(i&&(!(a in n)||!Array.isArray(n[a])||n[a].length!==e[a].length))throw new Error(\"when maxPoints is set as a key:value object it must contain a 1:1 corrispondence with the keys and number of traces in the update object\")}}function f(t,e,r,n){var i,a,o,l,u,c=_.isPlainObject(n),h=[];Array.isArray(r)||(r=[r]),r=s(r,t.data.length-1);for(var f in e)for(var d=0;d<r.length;d++){if(i=t.data[r[d]],o=_.nestedProperty(i,f),a=o.get(),l=e[f][d],!Array.isArray(l))throw new Error(\"attribute: \"+f+\" index: \"+d+\" must be an array\");if(!Array.isArray(a))throw new Error(\"cannot extend missing or non-array attribute: \"+f);u=c?n[f][d]:n,y(u)||(u=-1),h.push({prop:o,target:a,insert:l,maxp:Math.floor(u)})}return h}function d(t,e,r,n,i,a){h(t,e,r,n);for(var o,s,l,u=f(t,e,r,n),c=[],d={},p={},m=0;m<u.length;m++)s=u[m].prop,l=u[m].maxp,o=i(u[m].target,u[m].insert),l>=0&&l<o.length&&(c=a(o,l)),l=u[m].target.length,s.set(o),Array.isArray(d[s.astr])||(d[s.astr]=[]),Array.isArray(p[s.astr])||(p[s.astr]=[]),d[s.astr].push(c),p[s.astr].push(l);return{update:d,maxPoints:p}}function p(t,e,r){function n(){return d.map(function(){})}function i(t){var e=x.Axes.id2name(t);-1===u.indexOf(e)&&u.push(e)}function a(t){return\"LAYOUT\"+t+\".autorange\"}function o(t){return\"LAYOUT\"+t+\".range\"}function s(r,i,a){if(Array.isArray(r))return void r.forEach(function(t){s(t,i,a)});if(!(r in e||P.hasParent(e,r))){var o;o=\"LAYOUT\"===r.substr(0,6)?_.nestedProperty(t.layout,r.replace(\"LAYOUT\",\"\")):_.nestedProperty(f[d[a]],r),r in v||(v[r]=n()),void 0===v[r][a]&&(v[r][a]=o.get()),void 0!==i&&o.set(i)}}var l,u,c=t._fullLayout,h=t._fullData,f=t.data,d=P.coerceTraceIndices(t,r),p=R.traces(),m={},v={},g={},y=[\"mode\",\"visible\",\"type\",\"orientation\",\"fill\",\"histfunc\",\"histnorm\",\"text\",\"x\",\"y\",\"z\",\"a\",\"b\",\"c\",\"open\",\"high\",\"low\",\"close\",\"base\",\"width\",\"offset\",\"xtype\",\"x0\",\"dx\",\"ytype\",\"y0\",\"dy\",\"xaxis\",\"yaxis\",\"line.width\",\"connectgaps\",\"transpose\",\"zsmooth\",\"showscale\",\"marker.showscale\",\"zauto\",\"marker.cauto\",\"autocolorscale\",\"marker.autocolorscale\",\"colorscale\",\"marker.colorscale\",\"reversescale\",\"marker.reversescale\",\"autobinx\",\"nbinsx\",\"xbins\",\"xbins.start\",\"xbins.end\",\"xbins.size\",\"autobiny\",\"nbinsy\",\"ybins\",\"ybins.start\",\"ybins.end\",\"ybins.size\",\"error_y\",\"error_y.visible\",\"error_y.value\",\"error_y.type\",\"error_y.traceref\",\"error_y.array\",\"error_y.symmetric\",\"error_y.arrayminus\",\"error_y.valueminus\",\"error_y.tracerefminus\",\"error_x\",\"error_x.visible\",\"error_x.value\",\"error_x.type\",\"error_x.traceref\",\"error_x.array\",\"error_x.symmetric\",\"error_x.arrayminus\",\"error_x.valueminus\",\"error_x.tracerefminus\",\"swapxy\",\"swapxyaxes\",\"orientationaxes\",\"marker.colors\",\"values\",\"labels\",\"label0\",\"dlabel\",\"sort\",\"textinfo\",\"textposition\",\"textfont.size\",\"textfont.family\",\"textfont.color\",\"insidetextfont.size\",\"insidetextfont.family\",\"insidetextfont.color\",\"outsidetextfont.size\",\"outsidetextfont.family\",\"outsidetextfont.color\",\"hole\",\"scalegroup\",\"domain\",\"domain.x\",\"domain.y\",\"domain.x[0]\",\"domain.x[1]\",\"domain.y[0]\",\"domain.y[1]\",\"tilt\",\"tiltaxis\",\"depth\",\"direction\",\"rotation\",\"pull\",\"line.showscale\",\"line.cauto\",\"line.autocolorscale\",\"line.reversescale\",\"marker.line.showscale\",\"marker.line.cauto\",\"marker.line.autocolorscale\",\"marker.line.reversescale\",\"xcalendar\",\"ycalendar\",\"cumulative\",\"cumulative.enabled\",\"cumulative.direction\",\"cumulative.currentbin\",\"a0\",\"da\",\"b0\",\"db\",\"atype\",\"btype\",\"cheaterslope\",\"carpet\",\"sum\"],b=[\"color\",\"smoothing\",\"title\",\"titlefont\",\"titlefont.size\",\"titlefont.family\",\"titlefont.color\",\"titleoffset\",\"type\",\"autorange\",\"rangemode\",\"range\",\"fixedrange\",\"cheatertype\",\"tickmode\",\"nticks\",\"tickvals\",\"ticktext\",\"ticks\",\"mirror\",\"ticklen\",\"tickwidth\",\"tickcolor\",\"showticklabels\",\"tickfont\",\"tickfont.size\",\"tickfont.family\",\"tickfont.color\",\"tickprefix\",\"showtickprefix\",\"ticksuffix\",\"showticksuffix\",\"showexponent\",\"exponentformat\",\"separatethousands\",\"tickformat\",\"categoryorder\",\"categoryarray\",\"labelpadding\",\"labelprefix\",\"labelsuffix\",\"labelfont\",\"labelfont.family\",\"labelfont.size\",\"labelfont.color\",\"showline\",\"linecolor\",\"linewidth\",\"gridcolor\",\"gridwidth\",\"showgrid\",\"minorgridcount\",\"minorgridwidth\",\"minorgridcolor\",\"startline\",\"startlinecolor\",\"startlinewidth\",\"endline\",\"endlinewidth\",\"endlinecolor\",\"tick0\",\"dtick\",\"arraytick0\",\"arraydtick\",\"hoverformat\",\"tickangle\"];for(l=0;l<b.length;l++)y.push(\"aaxis.\"+b[l]),y.push(\"baxis.\"+b[l]);for(l=0;l<d.length;l++)if(k.traceIs(h[d[l]],\"box\")){y.push(\"name\");break}var w=[\"marker\",\"marker.size\",\"textfont\",\"boxpoints\",\"jitter\",\"pointpos\",\"whiskerwidth\",\"boxmean\",\"tickwidth\"],M=[\"zmin\",\"zmax\",\"zauto\",\"xgap\",\"ygap\",\"marker.cmin\",\"marker.cmax\",\"marker.cauto\",\"line.cmin\",\"line.cmax\",\"marker.line.cmin\",\"marker.line.cmax\",\"line\",\"line.smoothing\",\"line.shape\",\"error_y.width\",\"error_x.width\",\"error_x.copy_ystyle\",\"marker.maxdisplayed\"],T=[\"type\",\"x\",\"y\",\"x0\",\"y0\",\"orientation\",\"xaxis\",\"yaxis\"],S=[\"zmin\",\"zmax\"],E=[\"cmin\",\"cmax\"],L=[\"xbins.start\",\"xbins.end\",\"xbins.size\"],C=[\"ybins.start\",\"ybins.end\",\"ybins.size\"],z=[\"contours.start\",\"contours.end\",\"contours.size\"],I=[\"cartesian\",\"pie\",\"ternary\"];c._basePlotModules.forEach(function(t){-1===I.indexOf(t.name)&&(p.docalc=!0)});for(var D in e){if(P.hasParent(e,D))throw new Error(\"cannot set \"+D+\"and a parent attribute simultaneously\");var O,F,j,N,B,U=e[D];if(m[D]=U,\"LAYOUT\"!==D.substr(0,6)){for(v[D]=n(),l=0;l<d.length;l++)if(O=f[d[l]],F=h[d[l]],j=_.nestedProperty(O,D),N=j.get(),void 0!==(B=Array.isArray(U)?U[l%U.length]:U)){if(-1!==S.indexOf(D)&&s(\"zauto\",!1,l),-1!==E.indexOf(D))s(\"cauto\",!1,l);else if(\"colorscale\"===D)s(\"autocolorscale\",!1,l);else if(\"autocolorscale\"===D)s(\"colorscale\",void 0,l);else if(\"marker.colorscale\"===D)s(\"marker.autocolorscale\",!1,l);else if(\"marker.autocolorscale\"===D)s(\"marker.colorscale\",void 0,l);else if(\"zauto\"===D)s(S,void 0,l);else if(-1!==L.indexOf(D))s(\"autobinx\",!1,l);else if(\"autobinx\"===D)s(L,void 0,l);else if(-1!==C.indexOf(D))s(\"autobiny\",!1,l);else if(\"autobiny\"===D)s(C,void 0,l);else if(-1!==z.indexOf(D))s(\"autocontour\",!1,l);else if(\"autocontour\"===D)s(z,void 0,l);else if(-1!==[\"x0\",\"dx\"].indexOf(D)&&F.x&&\"scaled\"!==F.xtype)s(\"xtype\",\"scaled\",l);else if(-1!==[\"y0\",\"dy\"].indexOf(D)&&F.y&&\"scaled\"!==F.ytype)s(\"ytype\",\"scaled\",l);else if(\"colorbar.thicknessmode\"===D&&j.get()!==B&&-1!==[\"fraction\",\"pixels\"].indexOf(B)&&F.colorbar){var V=-1!==[\"top\",\"bottom\"].indexOf(F.colorbar.orient)?c.height-c.margin.t-c.margin.b:c.width-c.margin.l-c.margin.r;s(\"colorbar.thickness\",F.colorbar.thickness*(\"fraction\"===B?1/V:V),l)}else if(\"colorbar.lenmode\"===D&&j.get()!==B&&-1!==[\"fraction\",\"pixels\"].indexOf(B)&&F.colorbar){var H=-1!==[\"top\",\"bottom\"].indexOf(F.colorbar.orient)?c.width-c.margin.l-c.margin.r:c.height-c.margin.t-c.margin.b;s(\"colorbar.len\",F.colorbar.len*(\"fraction\"===B?1/H:H),l)}else\"colorbar.tick0\"===D||\"colorbar.dtick\"===D?s(\"colorbar.tickmode\",\"linear\",l):\"colorbar.tickmode\"===D&&s([\"colorbar.tick0\",\"colorbar.dtick\"],void 0,l);if(\"type\"===D&&\"pie\"===B!=(\"pie\"===N)){var q=\"x\",G=\"y\";\"bar\"!==B&&\"bar\"!==N||\"h\"!==O.orientation||(q=\"y\",G=\"x\"),_.swapAttrs(O,[\"?\",\"?src\"],\"labels\",q),_.swapAttrs(O,[\"d?\",\"?0\"],\"label\",q),_.swapAttrs(O,[\"?\",\"?src\"],\"values\",G),\"pie\"===N?(_.nestedProperty(O,\"marker.color\").set(_.nestedProperty(O,\"marker.colors\").get()),c._pielayer.selectAll(\"g.trace\").remove()):k.traceIs(O,\"cartesian\")&&(_.nestedProperty(O,\"marker.colors\").set(_.nestedProperty(O,\"marker.color\").get()),g[O.xaxis||\"x\"]=!0,g[O.yaxis||\"y\"]=!0)}v[D][l]=N;var Y=[\"swapxy\",\"swapxyaxes\",\"orientation\",\"orientationaxes\"];if(-1!==Y.indexOf(D)){if(\"orientation\"===D){if(j.set(B),j.get()===v[D][l])continue}else\"orientationaxes\"===D&&(O.orientation={v:\"h\",h:\"v\"}[F.orientation]);P.swapXYData(O)}else if(-1!==A.dataArrayContainers.indexOf(j.parts[0]))P.manageArrayContainers(j,B,v),p.docalc=!0;else{var X=j.parts[0],W=(F._module||{}).attributes,Z=W&&W[X];if(Z||(Z=A.attributes[X]),Z){for(var J=1;J<j.parts.length;J++){var K=Z[j.parts[J]];if(!K)break;Z=K}(!Z.valType||Z.arrayOk&&(Array.isArray(B)||Array.isArray(N)))&&(p.docalc=!0),R.update(p,Z)}else p.docalc=!0;j.set(B)}}if(-1!==[\"swapxyaxes\",\"orientationaxes\"].indexOf(D)&&x.Axes.swap(t,d),\"orientationaxes\"===D){var Q=_.nestedProperty(t.layout,\"hovermode\");\"x\"===Q.get()?Q.set(\"y\"):\"y\"===Q.get()&&Q.set(\"x\")}-1!==d.indexOf(0)&&-1!==T.indexOf(D)&&(x.Axes.clearTypes(t,d),p.docalc=!0),-1!==[\"autobinx\",\"autobiny\",\"zauto\"].indexOf(D)&&!1===B||(p.dostyle=!0),(-1!==[\"colorbar\",\"line\"].indexOf(j.parts[0])||\"marker\"===j.parts[0]&&\"colorbar\"===j.parts[1])&&(p.docolorbars=!0);var $=D.indexOf(\"[\"),tt=-1===$?D:D.substr(0,$);if(-1!==y.indexOf(tt)){if(-1!==[\"orientation\",\"type\"].indexOf(D)){for(u=[],l=0;l<d.length;l++){var et=f[d[l]];k.traceIs(et,\"cartesian\")&&(i(et.xaxis||\"x\"),i(et.yaxis||\"y\"),\"type\"===D&&s([\"autobinx\",\"autobiny\"],!0,l))}s(u.map(a),!0,0),s(u.map(o),[0,1],0)}p.docalc=!0}else-1!==M.indexOf(tt)?p.doplot=!0:0===tt.indexOf(\"aaxis\")||0===tt.indexOf(\"baxis\")?p.doplot=!0:-1!==w.indexOf(tt)&&(p.docalcAutorange=!0)}else j=_.nestedProperty(t.layout,D.replace(\"LAYOUT\",\"\")),v[D]=[j.get()],j.set(Array.isArray(U)?U[0]:U),p.docalc=!0}x.Axes.list(t).forEach(function(t){t.autorange&&(p.autorangeOn=!0)});var rt=Object.keys(g);t:for(l=0;l<rt.length;l++){for(var nt=rt[l],it=nt.charAt(0),at=it+\"axis\",ot=0;ot<f.length;ot++)if(k.traceIs(f[ot],\"cartesian\")&&(f[ot][at]||it)===nt)continue t;s(\"LAYOUT\"+x.Axes.id2name(nt),null,0)}return(p.docalc||p.docalcAutorange&&p.autorangeOn)&&(p.clearCalc=!0),(p.docalc||p.doplot||p.docalcAutorange)&&(p.fullReplot=!0),{flags:p,undoit:v,redoit:m,traces:d,eventData:_.extendDeepNoArrays([],[m,d])}}function m(t,e){function r(t,n){if(Array.isArray(t))return void t.forEach(function(t){r(t,n)});if(!(t in e||P.hasParent(e,t))){var i=_.nestedProperty(l,t);t in b||(b[t]=i.get()),void 0!==n&&i.set(n)}}function n(e,r){if(!_.isPlainObject(e))return!1;var n=e[r+\"ref\"]||r,i=x.Axes.getFromId(t,n);return i||n.charAt(0)!==r||(i=x.Axes.getFromId(t,r)),(i||{}).autorange}function i(t){var e=U.name2id(t.split(\".\")[0]);return w[e]=1,e}var a,o,s,l=t.layout,u=t._fullLayout,c=Object.keys(e),h=x.Axes.list(t),f={};for(o=0;o<c.length;o++)if(0===c[o].indexOf(\"allaxes\")){for(s=0;s<h.length;s++){var d=h[s]._id.substr(1),p=-1!==d.indexOf(\"scene\")?d+\".\":\"\",m=c[o].replace(\"allaxes\",p+h[s]._name);e[m]||(e[m]=e[c[o]])}delete e[c[o]]}var v,g=R.layout(),y={},b={},w={};for(var M in e){if(P.hasParent(e,M))throw new Error(\"cannot set \"+M+\"and a parent attribute simultaneously\");var T=_.nestedProperty(l,M),S=e[M],E=T.parts.length,L=\"string\"==typeof T.parts[E-1]?E-1:E-2,C=T.parts[0],z=T.parts[L],I=T.parts[L-1]+\".\"+z,O=T.parts.slice(0,L).join(\".\"),j=_.nestedProperty(t.layout,O).get(),N=_.nestedProperty(u,O).get(),B=T.get();if(void 0!==S){if(y[M]=S,b[M]=\"reverse\"===z?S:B,-1!==[\"width\",\"height\"].indexOf(M)&&null===S)u[M]=t._initialAutoSize[M];else if(I.match(/^[xyz]axis[0-9]*\\.range(\\[[0|1]\\])?$/))r(O+\".autorange\",!1),i(I),_.nestedProperty(u,O+\"._inputRange\").set(null);else if(I.match(/^[xyz]axis[0-9]*\\.autorange$/)){r([O+\".range[0]\",O+\".range[1]\"],void 0),i(I),_.nestedProperty(u,O+\"._inputRange\").set(null);var V=_.nestedProperty(u,O).get();V._inputDomain&&(V._input.domain=V._inputDomain.slice())}else I.match(/^[xyz]axis[0-9]*\\.domain(\\[[0|1]\\])?$/)?_.nestedProperty(u,O+\"._inputDomain\").set(null):I.match(/^[xyz]axis[0-9]*\\.constrain.*$/)?g.docalc=!0:I.match(/^aspectratio\\.[xyz]$/)?r(C+\".aspectmode\",\"manual\"):I.match(/^aspectmode$/)?r([O+\".x\",O+\".y\",O+\".z\"],void 0):\"tick0\"===z||\"dtick\"===z?r(O+\".tickmode\",\"linear\"):\"tickmode\"===z?r([O+\".tick0\",O+\".dtick\"],void 0):/[xy]axis[0-9]*?$/.test(z)&&!Object.keys(S||{}).length?g.docalc=!0:/[xy]axis[0-9]*\\.categoryorder$/.test(I)?g.docalc=!0:/[xy]axis[0-9]*\\.categoryarray/.test(I)&&(g.docalc=!0);if(-1!==I.indexOf(\"rangeslider\")&&(g.docalc=!0),\"type\"===z){var H=j,q=\"linear\"===N.type&&\"log\"===S,G=\"log\"===N.type&&\"linear\"===S;if(q||G){if(H&&H.range)if(N.autorange)q&&(H.range=H.range[1]>H.range[0]?[1,2]:[2,1]);else{var Y=H.range[0],X=H.range[1];q?(Y<=0&&X<=0&&r(O+\".autorange\",!0),Y<=0?Y=X/1e6:X<=0&&(X=Y/1e6),r(O+\".range[0]\",Math.log(Y)/Math.LN10),r(O+\".range[1]\",Math.log(X)/Math.LN10)):(r(O+\".range[0]\",Math.pow(10,Y)),r(O+\".range[1]\",Math.pow(10,X)))}else r(O+\".autorange\",!0);k.getComponentMethod(\"annotations\",\"convertCoords\")(t,N,S,r),k.getComponentMethod(\"images\",\"convertCoords\")(t,N,S,r)}else r(O+\".autorange\",!0);_.nestedProperty(u,O+\"._inputRange\").set(null)}else if(z.match(F.AX_NAME_PATTERN)){var W=_.nestedProperty(u,M).get(),Z=(S||{}).type;Z&&\"-\"!==Z||(Z=\"linear\"),k.getComponentMethod(\"annotations\",\"convertCoords\")(t,W,Z,r),k.getComponentMethod(\"images\",\"convertCoords\")(t,W,Z,r)}var J=D.containerArrayMatch(M);if(J){a=J.array,o=J.index;var K=J.property,Q=_.nestedProperty(l,a),$=(Q||[])[o]||{};if(\"\"===o)-1===M.indexOf(\"updatemenus\")&&(g.docalc=!0);else if(\"\"===K){var tt=S;D.isAddVal(S)?b[M]=null:D.isRemoveVal(S)?(b[M]=$,tt=$):_.warn(\"unrecognized full object value\",e),(n(tt,\"x\")||n(tt,\"y\")&&-1===M.indexOf(\"updatemenus\"))&&(g.docalc=!0)}else!n($,\"x\")&&!n($,\"y\")||_.containsAny(M,[\"color\",\"opacity\",\"align\",\"dash\",\"updatemenus\"])||(g.docalc=!0);f[a]||(f[a]={});var et=f[a][o];et||(et=f[a][o]={}),et[K]=S,delete e[M]}else if(\"reverse\"===z)j.range?j.range.reverse():(r(O+\".autorange\",!0),j.range=[1,0]),N.autorange?g.docalc=!0:g.doplot=!0;else{var rt=String(T.parts[1]||\"\");0===C.indexOf(\"scene\")?\"camera\"===T.parts[1]?g.docamera=!0:g.doplot=!0:0===C.indexOf(\"geo\")?g.doplot=!0:0===C.indexOf(\"ternary\")?g.doplot=!0:\"paper_bgcolor\"===M?g.doplot=!0:\"margin\"===C||\"autorange\"===rt||\"rangemode\"===rt||\"type\"===rt||\"domain\"===rt||\"fixedrange\"===rt||\"scaleanchor\"===rt||\"scaleratio\"===rt||-1!==M.indexOf(\"calendar\")||M.match(/^(bar|box|font)/)?g.docalc=!0:!u._has(\"gl2d\")||-1===M.indexOf(\"axis\")&&\"plot_bgcolor\"!==M?!u._has(\"gl2d\")||\"dragmode\"!==M||\"lasso\"!==S&&\"select\"!==S||\"lasso\"===B||\"select\"===B?\"hiddenlabels\"===M?g.docalc=!0:-1!==C.indexOf(\"legend\")?g.dolegend=!0:-1!==M.indexOf(\"title\")?g.doticks=!0:-1!==C.indexOf(\"bgcolor\")?g.dolayoutstyle=!0:E>1&&_.containsAny(rt,[\"tick\",\"exponent\",\"grid\",\"zeroline\"])?g.doticks=!0:-1!==M.indexOf(\".linewidth\")&&-1!==M.indexOf(\"axis\")?g.doticks=g.dolayoutstyle=!0:E>1&&-1!==rt.indexOf(\"line\")?g.dolayoutstyle=!0:E>1&&\"mirror\"===rt?g.doticks=g.dolayoutstyle=!0:\"margin.pad\"===M?g.doticks=g.dolayoutstyle=!0:-1!==[\"hovermode\",\"dragmode\"].indexOf(M)||-1!==M.indexOf(\"spike\")?g.domodebar=!0:-1===[\"height\",\"width\",\"autosize\"].indexOf(M)&&(g.doplot=!0):g.docalc=!0:g.doplot=!0,T.set(S)}}}for(a in f){D.applyContainerArrayChanges(t,_.nestedProperty(l,a),f[a],g)||(g.doplot=!0)}var nt=u._axisConstraintGroups;for(v in w)for(o=0;o<nt.length;o++){var it=nt[o];if(it[v]){g.docalc=!0;for(var at in it)w[at]||(U.getFromId(t,at)._constraintShrinkable=!0)}}var ot=u.width,st=u.height;return t.layout.autosize&&A.plotAutoSize(t,t.layout,u),(e.height||e.width||u.width!==ot||u.height!==st)&&(g.docalc=!0),(g.doplot||g.docalc)&&(g.layoutReplot=!0),{flags:g,undoit:b,redoit:y,eventData:_.extendDeep({},y)}}function v(t){var e=g.select(t),r=t._fullLayout;if(r._container=e.selectAll(\".plot-container\").data([0]),r._container.enter().insert(\"div\",\":first-child\").classed(\"plot-container\",!0).classed(\"plotly\",!0),r._paperdiv=r._container.selectAll(\".svg-container\").data([0]),r._paperdiv.enter().append(\"div\").classed(\"svg-container\",!0).style(\"position\",\"relative\"),r._glcontainer=r._paperdiv.selectAll(\".gl-container\").data([0]),r._glcontainer.enter().append(\"div\").classed(\"gl-container\",!0),r._paperdiv.selectAll(\".main-svg\").remove(),\n",
       "r._paper=r._paperdiv.insert(\"svg\",\":first-child\").classed(\"main-svg\",!0),r._toppaper=r._paperdiv.append(\"svg\").classed(\"main-svg\",!0),!r._uid){var n=[];g.selectAll(\"defs\").each(function(){this.id&&n.push(this.id.split(\"-\")[1])}),r._uid=_.randstr(n)}r._paperdiv.selectAll(\".main-svg\").attr(z.svgAttrs),r._defs=r._paper.append(\"defs\").attr(\"id\",\"defs-\"+r._uid),r._topdefs=r._toppaper.append(\"defs\").attr(\"id\",\"topdefs-\"+r._uid),r._bgLayer=r._paper.append(\"g\").classed(\"bglayer\",!0),r._draggers=r._paper.append(\"g\").classed(\"draglayer\",!0);var i=r._paper.append(\"g\").classed(\"layer-below\",!0);r._imageLowerLayer=i.append(\"g\").classed(\"imagelayer\",!0),r._shapeLowerLayer=i.append(\"g\").classed(\"shapelayer\",!0),r._cartesianlayer=r._paper.append(\"g\").classed(\"cartesianlayer\",!0),r._ternarylayer=r._paper.append(\"g\").classed(\"ternarylayer\",!0),r._geolayer=r._paper.append(\"g\").classed(\"geolayer\",!0);var a=r._paper.append(\"g\").classed(\"layer-above\",!0);r._imageUpperLayer=a.append(\"g\").classed(\"imagelayer\",!0),r._shapeUpperLayer=a.append(\"g\").classed(\"shapelayer\",!0),r._pielayer=r._paper.append(\"g\").classed(\"pielayer\",!0),r._glimages=r._paper.append(\"g\").classed(\"glimages\",!0),r._infolayer=r._toppaper.append(\"g\").classed(\"infolayer\",!0),r._zoomlayer=r._toppaper.append(\"g\").classed(\"zoomlayer\",!0),r._hoverlayer=r._toppaper.append(\"g\").classed(\"hoverlayer\",!0),t.emit(\"plotly_framework\")}var g=t(\"d3\"),y=t(\"fast-isnumeric\"),b=t(\"has-hover\"),x=t(\"../plotly\"),_=t(\"../lib\"),w=t(\"../lib/events\"),M=t(\"../lib/queue\"),k=t(\"../registry\"),A=t(\"../plots/plots\"),T=t(\"../plots/polar\"),S=t(\"../plots/cartesian/graph_interact\"),E=t(\"../components/drawing\"),L=t(\"../components/color\"),C=t(\"../components/errorbars\"),z=t(\"../constants/xmlns_namespaces\"),I=t(\"../lib/svg_text_utils\"),D=t(\"./manage_arrays\"),P=t(\"./helpers\"),O=t(\"./subroutines\"),R=t(\"./edit_types\"),F=t(\"../plots/cartesian/constants\"),j=t(\"../plots/cartesian/constraints\"),N=j.enforce,B=j.clean,U=t(\"../plots/cartesian/axis_ids\");x.plot=function(t,e,r,n){function i(){if(m)return x.addFrames(t,m)}function s(){for(var e=M._basePlotModules,r=0;r<e.length;r++)e[r].drawFramework&&e[r].drawFramework(t);return _.syncOrAsync([O.layoutStyles],t)}function l(){var e,r,n,i=t.calcdata;for(k.getComponentMethod(\"legend\",\"draw\")(t),k.getComponentMethod(\"rangeselector\",\"draw\")(t),k.getComponentMethod(\"sliders\",\"draw\")(t),k.getComponentMethod(\"updatemenus\",\"draw\")(t),e=0;e<i.length;e++)r=i[e],n=r[0].trace,!0===n.visible&&n._module.colorbar?n._module.colorbar(t,r):A.autoMargin(t,\"cb\"+n.uid);return A.doAutoMargin(t),A.previousPromises(t)}function u(){if(JSON.stringify(M._size)!==z)return _.syncOrAsync([l,O.layoutStyles],t)}function c(){if(!T)return void N(t);var e,r,n,i=A.getSubplotIds(M,\"cartesian\"),a=M._modules,o=[];for(n=0;n<a.length;n++)_.pushUnique(o,a[n].setPositions);if(o.length)for(r=0;r<i.length;r++)for(e=M._plots[i[r]],n=0;n<o.length;n++)o[n](t,e);return C.calc(t),_.syncOrAsync([k.getComponentMethod(\"shapes\",\"calcAutorange\"),k.getComponentMethod(\"annotations\",\"calcAutorange\"),h,k.getComponentMethod(\"rangeslider\",\"calcAutorange\")],t)}function h(){if(!t._transitioning){for(var e=x.Axes.list(t,\"\",!0),r=0;r<e.length;r++){var n=e[r];B(t,n),x.Axes.doAutoRange(n)}N(t),b&&x.Axes.saveRangeInitial(t)}}function f(){return x.Axes.doTicks(t,\"redraw\")}function d(){var e,r=t.calcdata,n=M._infolayer.selectAll(\"g.rangeslider-container\");for(e=0;e<r.length;e++){var i=r[e][0].trace,a=!0===i.visible,o=i.uid;if(!a||!k.traceIs(i,\"2dMap\")){var s=\".hm\"+o+\",.contour\"+o+\",#clip\"+o;M._paper.selectAll(s).remove(),n.selectAll(s).remove()}a&&i._module.colorbar||M._infolayer.selectAll(\".cb\"+o).remove()}var l=M._basePlotModules;for(e=0;e<l.length;e++)l[e].plot(t);var u=M._paper.selectAll(\".layer-subplot\");return M._shapeSubplotLayers=u.selectAll(\".shapelayer\"),A.style(t),k.getComponentMethod(\"shapes\",\"draw\")(t),k.getComponentMethod(\"annotations\",\"draw\")(t),A.addLinks(t),M._replotting=!1,A.previousPromises(t)}function p(){k.getComponentMethod(\"shapes\",\"draw\")(t),k.getComponentMethod(\"images\",\"draw\")(t),k.getComponentMethod(\"annotations\",\"draw\")(t),k.getComponentMethod(\"legend\",\"draw\")(t),k.getComponentMethod(\"rangeslider\",\"draw\")(t),k.getComponentMethod(\"rangeselector\",\"draw\")(t),k.getComponentMethod(\"sliders\",\"draw\")(t),k.getComponentMethod(\"updatemenus\",\"draw\")(t)}var m;if(t=P.getGraphDiv(t),w.init(t),_.isPlainObject(e)){var y=e;e=y.data,r=y.layout,n=y.config,m=y.frames}if(!1===w.triggerHandler(t,\"plotly_beforeplot\",[e,r,n]))return Promise.reject();e||r||_.isPlotDiv(t)||_.warn(\"Calling Plotly.plot as if redrawing but this container doesn't yet have a plot.\",t),a(t,n),r||(r={}),g.select(t).classed(\"js-plotly-plot\",!0),E.makeTester(),t._promises=[];var b=0===(t.data||[]).length&&Array.isArray(e);if(Array.isArray(e)&&(P.cleanData(e,t.data),b?t.data=e:t.data.push.apply(t.data,e),t.empty=!1),t.layout&&!b||(t.layout=P.cleanLayout(r)),t._dragging&&!t._transitioning)return t._replotPending=!0,Promise.reject();t._replotPending=!1,A.supplyDefaults(t);var M=t._fullLayout;if(e&&e[0]&&e[0].r)return o(t,e,r);M._replotting=!0,b&&v(t),t.framework!==v&&(t.framework=v,v(t)),E.initGradients(t),b&&x.Axes.saveShowSpikeInitial(t);var T=!t.calcdata||t.calcdata.length!==(t._fullData||[]).length;T&&A.doCalcdata(t);for(var L=0;L<t.calcdata.length;L++)t.calcdata[L][0].trace=t._fullData[L];var z=JSON.stringify(M._size),I=[A.previousPromises,i,s,l,u,c,O.layoutStyles,f,d,p,S,A.rehover];return _.syncOrAsync(I,t),Promise.all(t._promises).then(function(){return t.emit(\"plotly_afterplot\"),t})},x.redraw=function(t){if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t);return P.cleanData(t.data,t.data),P.cleanLayout(t.layout),t.calcdata=void 0,x.plot(t).then(function(){return t.emit(\"plotly_redraw\"),t})},x.newPlot=function(t,e,r,n){return t=P.getGraphDiv(t),A.cleanPlot([],{},t._fullData||{},t._fullLayout||{}),A.purge(t),x.plot(t,e,r,n)},x.extendTraces=function t(e,r,n,i){e=P.getGraphDiv(e);var a=d(e,r,n,i,function(t,e){return t.concat(e)},function(t,e){return t.splice(0,t.length-e)}),o=x.redraw(e),s=[e,a.update,n,a.maxPoints];return M.add(e,x.prependTraces,s,t,arguments),o},x.prependTraces=function t(e,r,n,i){e=P.getGraphDiv(e);var a=d(e,r,n,i,function(t,e){return e.concat(t)},function(t,e){return t.splice(e,t.length)}),o=x.redraw(e),s=[e,a.update,n,a.maxPoints];return M.add(e,x.extendTraces,s,t,arguments),o},x.addTraces=function t(e,r,n){e=P.getGraphDiv(e);var i,a,o=[],s=x.deleteTraces,l=t,h=[e,o],f=[e,r];for(c(e,r,n),Array.isArray(r)||(r=[r]),r=r.map(function(t){return _.extendFlat({},t)}),P.cleanData(r,e.data),i=0;i<r.length;i++)e.data.push(r[i]);for(i=0;i<r.length;i++)o.push(-r.length+i);if(void 0===n)return a=x.redraw(e),M.add(e,s,h,l,f),a;Array.isArray(n)||(n=[n]);try{u(e,o,n)}catch(t){throw e.data.splice(e.data.length-r.length,r.length),t}return M.startSequence(e),M.add(e,s,h,l,f),a=x.moveTraces(e,o,n),M.stopSequence(e),a},x.deleteTraces=function t(e,r){e=P.getGraphDiv(e);var n,i,a=[],o=x.addTraces,u=t,c=[e,a,r],h=[e,r];if(void 0===r)throw new Error(\"indices must be an integer or array of integers.\");for(Array.isArray(r)||(r=[r]),l(e,r,\"indices\"),r=s(r,e.data.length-1),r.sort(_.sorterDes),n=0;n<r.length;n+=1)i=e.data.splice(r[n],1)[0],a.push(i);var f=x.redraw(e);return M.add(e,o,c,u,h),f},x.moveTraces=function t(e,r,n){e=P.getGraphDiv(e);var i,a=[],o=[],l=t,c=t,h=[e,n,r],f=[e,r,n];if(u(e,r,n),r=Array.isArray(r)?r:[r],void 0===n)for(n=[],i=0;i<r.length;i++)n.push(-r.length+i);for(n=Array.isArray(n)?n:[n],r=s(r,e.data.length-1),n=s(n,e.data.length-1),i=0;i<e.data.length;i++)-1===r.indexOf(i)&&a.push(e.data[i]);for(i=0;i<r.length;i++)o.push({newIndex:n[i],trace:e.data[r[i]]});for(o.sort(function(t,e){return t.newIndex-e.newIndex}),i=0;i<o.length;i+=1)a.splice(o[i].newIndex,0,o[i].trace);e.data=a;var d=x.redraw(e);return M.add(e,l,h,c,f),d},x.restyle=function t(e,r,n,i){e=P.getGraphDiv(e),P.clearPromiseQueue(e);var a={};if(\"string\"==typeof r)a[r]=n;else{if(!_.isPlainObject(r))return _.warn(\"Restyle fail.\",r,n,i),Promise.reject();a=_.extendFlat({},r),void 0===i&&(i=n)}Object.keys(a).length&&(e.changed=!0);var o=p(e,a,i),s=o.flags;s.clearCalc&&(e.calcdata=void 0);var l=[];s.fullReplot?l.push(x.plot):(l.push(A.previousPromises),A.supplyDefaults(e),s.dostyle&&l.push(O.doTraceStyle),s.docolorbars&&l.push(O.doColorBars)),l.push(A.rehover),M.add(e,t,[e,o.undoit,o.traces],t,[e,o.redoit,o.traces]);var u=_.syncOrAsync(l,e);return u&&u.then||(u=Promise.resolve()),u.then(function(){return e.emit(\"plotly_restyle\",o.eventData),e})},x.relayout=function t(e,r,n){if(e=P.getGraphDiv(e),P.clearPromiseQueue(e),e.framework&&e.framework.isPolar)return Promise.resolve(e);var i={};if(\"string\"==typeof r)i[r]=n;else{if(!_.isPlainObject(r))return _.warn(\"Relayout fail.\",r,n),Promise.reject();i=_.extendFlat({},r)}Object.keys(i).length&&(e.changed=!0);var a=m(e,i),o=a.flags;o.docalc&&(e.calcdata=void 0);var s=[A.previousPromises];o.layoutReplot?s.push(O.layoutReplot):Object.keys(i).length&&(A.supplyDefaults(e),o.dolegend&&s.push(O.doLegend),o.dolayoutstyle&&s.push(O.layoutStyles),o.doticks&&s.push(O.doTicksRelayout),o.domodebar&&s.push(O.doModeBar),o.docamera&&s.push(O.doCamera)),s.push(A.rehover),M.add(e,t,[e,a.undoit],t,[e,a.redoit]);var l=_.syncOrAsync(s,e);return l&&l.then||(l=Promise.resolve(e)),l.then(function(){return e.emit(\"plotly_relayout\",a.eventData),e})},x.update=function t(e,r,n,i){if(e=P.getGraphDiv(e),P.clearPromiseQueue(e),e.framework&&e.framework.isPolar)return Promise.resolve(e);_.isPlainObject(r)||(r={}),_.isPlainObject(n)||(n={}),Object.keys(r).length&&(e.changed=!0),Object.keys(n).length&&(e.changed=!0);var a=p(e,_.extendFlat({},r),i),o=a.flags,s=m(e,_.extendFlat({},n)),l=s.flags;(o.clearCalc||l.docalc)&&(e.calcdata=void 0);var u=[];if(o.fullReplot&&l.layoutReplot){var c=e.data,h=e.layout;e.data=void 0,e.layout=void 0,u.push(function(){return x.plot(e,c,h)})}else o.fullReplot?u.push(x.plot):l.layoutReplot?u.push(O.layoutReplot):(u.push(A.previousPromises),A.supplyDefaults(e),o.dostyle&&u.push(O.doTraceStyle),o.docolorbars&&u.push(O.doColorBars),l.dolegend&&u.push(O.doLegend),l.dolayoutstyle&&u.push(O.layoutStyles),l.doticks&&u.push(O.doTicksRelayout),l.domodebar&&u.push(O.doModeBar),l.doCamera&&u.push(O.doCamera));u.push(A.rehover),M.add(e,t,[e,a.undoit,s.undoit,a.traces],t,[e,a.redoit,s.redoit,a.traces]);var f=_.syncOrAsync(u,e);return f&&f.then||(f=Promise.resolve(e)),f.then(function(){return e.emit(\"plotly_update\",{data:a.eventData,layout:s.eventData}),e})},x.animate=function(t,e,r){function n(t){return Array.isArray(s)?t>=s.length?s[0]:s[t]:s}function i(t){return Array.isArray(l)?t>=l.length?l[0]:l[t]:l}function a(t,e){var r=0;return function(){if(t&&++r===e)return t()}}if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t+\". It's likely that you've failed to create a plot before animating it. For more details, see https://plot.ly/javascript/animations/\");var o=t._transitionData;o._frameQueue||(o._frameQueue=[]),r=A.supplyAnimationDefaults(r);var s=r.transition,l=r.frame;return void 0===o._frameWaitingCnt&&(o._frameWaitingCnt=0),new Promise(function(l,u){function c(){t.emit(\"plotly_animated\"),window.cancelAnimationFrame(o._animationRaf),o._animationRaf=null}function h(){o._currentFrame&&o._currentFrame.onComplete&&o._currentFrame.onComplete();var e=o._currentFrame=o._frameQueue.shift();if(e){var r=e.name?e.name.toString():null;t._fullLayout._currentFrame=r,o._lastFrameAt=Date.now(),o._timeToNext=e.frameOpts.duration,A.transition(t,e.frame.data,e.frame.layout,P.coerceTraceIndices(t,e.frame.traces),e.frameOpts,e.transitionOpts).then(function(){e.onComplete&&e.onComplete()}),t.emit(\"plotly_animatingframe\",{name:r,frame:e.frame,animation:{frame:e.frameOpts,transition:e.transitionOpts}})}else c()}function f(){t.emit(\"plotly_animating\"),o._lastFrameAt=-1/0,o._timeToNext=0,o._runningTransitions=0,o._currentFrame=null;var e=function(){o._animationRaf=window.requestAnimationFrame(e),Date.now()-o._lastFrameAt>o._timeToNext&&h()};e()}function d(t){return Array.isArray(s)?v>=s.length?t.transitionOpts=s[v]:t.transitionOpts=s[0]:t.transitionOpts=s,v++,t}var p,m,v=0,g=[],y=void 0===e||null===e,b=Array.isArray(e);if(y||b||!_.isPlainObject(e)){if(y||-1!==[\"string\",\"number\"].indexOf(typeof e))for(p=0;p<o._frames.length;p++)(m=o._frames[p])&&(y||String(m.group)===String(e))&&g.push({type:\"byname\",name:String(m.name),data:d({name:m.name})});else if(b)for(p=0;p<e.length;p++){var x=e[p];-1!==[\"number\",\"string\"].indexOf(typeof x)?(x=String(x),g.push({type:\"byname\",name:x,data:d({name:x})})):_.isPlainObject(x)&&g.push({type:\"object\",data:d(_.extendFlat({},x))})}}else g.push({type:\"object\",data:d(_.extendFlat({},e))});for(p=0;p<g.length;p++)if(m=g[p],\"byname\"===m.type&&!o._frameHash[m.data.name])return _.warn('animate failure: frame not found: \"'+m.data.name+'\"'),void u();-1!==[\"next\",\"immediate\"].indexOf(r.mode)&&function(){if(0!==o._frameQueue.length){for(;o._frameQueue.length;){var e=o._frameQueue.pop();e.onInterrupt&&e.onInterrupt()}t.emit(\"plotly_animationinterrupted\",[])}}(),\"reverse\"===r.direction&&g.reverse();var w=t._fullLayout._currentFrame;if(w&&r.fromcurrent){var M=-1;for(p=0;p<g.length;p++)if(m=g[p],\"byname\"===m.type&&m.name===w){M=p;break}if(M>0&&M<g.length-1){var k=[];for(p=0;p<g.length;p++)m=g[p],(\"byname\"!==g[p].type||p>M)&&k.push(m);g=k}}g.length>0?function(e){if(0!==e.length){for(var s=0;s<e.length;s++){var c;c=\"byname\"===e[s].type?A.computeFrame(t,e[s].name):e[s].data;var h=i(s),d=n(s);d.duration=Math.min(d.duration,h.duration);var p={frame:c,name:e[s].name,frameOpts:h,transitionOpts:d};s===e.length-1&&(p.onComplete=a(l,2),p.onInterrupt=u),o._frameQueue.push(p)}\"immediate\"===r.mode&&(o._lastFrameAt=-1/0),o._animationRaf||f()}}(g):(t.emit(\"plotly_animated\"),l())})},x.addFrames=function(t,e,r){t=P.getGraphDiv(t);var n=0;if(null===e||void 0===e)return Promise.resolve();if(!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t+\". It's likely that you've failed to create a plot before adding frames. For more details, see https://plot.ly/javascript/animations/\");var i,a,o,s,l=t._transitionData._frames,u=t._transitionData._frameHash;if(!Array.isArray(e))throw new Error(\"addFrames failure: frameList must be an Array of frame definitions\"+e);var c=l.length+2*e.length,h=[];for(i=e.length-1;i>=0;i--)if(_.isPlainObject(e[i])){var f=(u[e[i].name]||{}).name,d=e[i].name;f&&d&&\"number\"==typeof d&&u[f]&&(n++,_.warn('addFrames: overwriting frame \"'+u[f].name+'\" with a frame whose name of type \"number\" also equates to \"'+f+'\". This is valid but may potentially lead to unexpected behavior since all plotly.js frame names are stored internally as strings.'),n>5&&_.warn(\"addFrames: This API call has yielded too many warnings. For the rest of this call, further warnings about numeric frame names will be suppressed.\")),h.push({frame:A.supplyFrameDefaults(e[i]),index:r&&void 0!==r[i]&&null!==r[i]?r[i]:c+i})}h.sort(function(t,e){return t.index>e.index?-1:t.index<e.index?1:0});var p=[],m=[],v=l.length;for(i=h.length-1;i>=0;i--){if(a=h[i].frame,\"number\"==typeof a.name&&_.warn(\"Warning: addFrames accepts frames with numeric names, but the numbers areimplicitly cast to strings\"),!a.name)for(;u[a.name=\"frame \"+t._transitionData._counter++];);if(u[a.name]){for(o=0;o<l.length&&(l[o]||{}).name!==a.name;o++);p.push({type:\"replace\",index:o,value:a}),m.unshift({type:\"replace\",index:o,value:l[o]})}else s=Math.max(0,Math.min(h[i].index,v)),p.push({type:\"insert\",index:s,value:a}),m.unshift({type:\"delete\",index:s}),v++}var g=A.modifyFrames,y=A.modifyFrames,b=[t,m],x=[t,p];return M&&M.add(t,g,b,y,x),A.modifyFrames(t,p)},x.deleteFrames=function(t,e){if(t=P.getGraphDiv(t),!_.isPlotDiv(t))throw new Error(\"This element is not a Plotly plot: \"+t);var r,n,i=t._transitionData._frames,a=[],o=[];if(!e)for(e=[],r=0;r<i.length;r++)e.push(r);for(e=e.slice(0),e.sort(),r=e.length-1;r>=0;r--)n=e[r],a.push({type:\"delete\",index:n}),o.unshift({type:\"insert\",index:n,value:i[n]});var s=A.modifyFrames,l=A.modifyFrames,u=[t,o],c=[t,a];return M&&M.add(t,s,u,l,c),A.modifyFrames(t,a)},x.purge=function(t){t=P.getGraphDiv(t);var e=t._fullLayout||{},r=t._fullData||[];return A.cleanPlot([],{},r,e),A.purge(t),w.purge(t),e._container&&e._container.remove(),delete t._context,delete t._replotPending,delete t._mouseDownTime,delete t._legendMouseDownTime,delete t._hmpixcount,delete t._hmlumcount,t}},{\"../components/color\":603,\"../components/drawing\":627,\"../components/errorbars\":633,\"../constants/xmlns_namespaces\":707,\"../lib\":725,\"../lib/events\":715,\"../lib/queue\":738,\"../lib/svg_text_utils\":745,\"../plotly\":761,\"../plots/cartesian/axis_ids\":769,\"../plots/cartesian/constants\":771,\"../plots/cartesian/constraints\":773,\"../plots/cartesian/graph_interact\":775,\"../plots/plots\":829,\"../plots/polar\":832,\"../registry\":844,\"./edit_types\":750,\"./helpers\":751,\"./manage_arrays\":752,\"./subroutines\":758,d3:121,\"fast-isnumeric\":130,\"has-hover\":287}],754:[function(t,e,r){\"use strict\";e.exports={staticPlot:!1,editable:!1,edits:{annotationPosition:!1,annotationTail:!1,annotationText:!1,axisTitleText:!1,colorbarPosition:!1,colorbarTitleText:!1,legendPosition:!1,legendText:!1,shapePosition:!1,titleText:!1},autosizable:!1,queueLength:0,fillFrame:!1,frameMargins:0,scrollZoom:!1,doubleClick:\"reset+autosize\",showTips:!0,showAxisDragHandles:!0,showAxisRangeEntryBoxes:!0,showLink:!1,sendData:!0,linkText:\"Edit chart\",showSources:!1,displayModeBar:\"hover\",modeBarButtonsToRemove:[],modeBarButtonsToAdd:[],modeBarButtons:!1,displaylogo:!0,plotGlPixelRatio:2,setBackground:\"transparent\",topojsonURL:\"https://cdn.plot.ly/\",mapboxAccessToken:null,logging:!1,globalTransforms:[]}},{}],755:[function(t,e,r){\"use strict\";function n(t){var e,r;\"area\"===t?(e={attributes:b},r={}):(e=d.modules[t]._module,r=e.basePlotModule);var n={};n.type=null,M(n,m),M(n,e.attributes),r.attributes&&M(n,r.attributes),Object.keys(d.componentsRegistry).forEach(function(e){var r=d.componentsRegistry[e];r.schema&&r.schema.traces&&r.schema.traces[t]&&Object.keys(r.schema.traces[t]).forEach(function(e){f(n,r.schema.traces[t][e],e)})}),n.type=t;var i={meta:e.meta||{},attributes:s(n)};if(e.layoutAttributes){var a={};M(a,e.layoutAttributes),i.layoutAttributes=s(a)}return i}function i(){var t={};return M(t,v),Object.keys(d.subplotsRegistry).forEach(function(e){var r=d.subplotsRegistry[e];if(r.layoutAttributes)if(\"cartesian\"===r.name)h(t,r,\"xaxis\"),h(t,r,\"yaxis\");else{var n=\"subplot\"===r.attr?r.name:r.attr;h(t,r,n)}}),t=c(t),Object.keys(d.componentsRegistry).forEach(function(e){var r=d.componentsRegistry[e];r.layoutAttributes&&(r.schema&&r.schema.layout?Object.keys(r.schema.layout).forEach(function(e){f(t,r.schema.layout[e],e)}):f(t,r.layoutAttributes,r.name))}),{layoutAttributes:s(t)}}function a(t){var e=d.transformsRegistry[t],r=M({},e.attributes);return Object.keys(d.componentsRegistry).forEach(function(e){var n=d.componentsRegistry[e];n.schema&&n.schema.transforms&&n.schema.transforms[t]&&Object.keys(n.schema.transforms[t]).forEach(function(e){f(r,n.schema.transforms[t][e],e)})}),{attributes:s(r)}}function o(){var t={frames:p.extendDeep({},g)};return s(t),t.frames}function s(t){return l(t),u(t),t}function l(t){function e(t){return{valType:\"string\"}}function n(t,n,i){r.isValObject(t)?\"data_array\"===t.valType?(t.role=\"data\",i[n+\"src\"]=e(n)):!0===t.arrayOk&&(i[n+\"src\"]=e(n)):p.isPlainObject(t)&&(t.role=\"object\")}r.crawl(t,n)}function u(t){function e(t,e,r){if(t){var n=t[A];n&&(delete t[A],r[e]={items:{}},r[e].items[n]=t,r[e].role=\"object\")}}r.crawl(t,e)}function c(t){return w(t,{radialaxis:x.radialaxis,angularaxis:x.angularaxis}),w(t,x.layout),t}function h(t,e,r){var n=p.nestedProperty(t,r),i=M({},e.layoutAttributes);i[k]=!0,n.set(i)}function f(t,e,r){var n=p.nestedProperty(t,r);n.set(M(n.get()||{},e))}var d=t(\"../registry\"),p=t(\"../lib\"),m=t(\"../plots/attributes\"),v=t(\"../plots/layout_attributes\"),g=t(\"../plots/frame_attributes\"),y=t(\"../plots/animation_attributes\"),b=t(\"../plots/polar/area_attributes\"),x=t(\"../plots/polar/axis_attributes\"),_=t(\"./edit_types\"),w=p.extendFlat,M=p.extendDeep,k=\"_isSubplotObj\",A=\"_isLinkedToArray\",T=[k,A,\"_arrayAttrRegexps\",\"_deprecated\"];r.IS_SUBPLOT_OBJ=k,r.IS_LINKED_TO_ARRAY=A,r.DEPRECATED=\"_deprecated\",r.UNDERSCORE_ATTRS=T,r.get=function(){var t={};d.allTypes.concat(\"area\").forEach(function(e){t[e]=n(e)});var e={};return Object.keys(d.transformsRegistry).forEach(function(t){e[t]=a(t)}),{defs:{valObjects:p.valObjects,metaKeys:T.concat([\"description\",\"role\"]),editTypes:{traces:_.traces(),layout:_.layout()}},traces:t,layout:i(),transforms:e,frames:o(),animation:s(y)}},r.crawl=function(t,e,n){var i=n||0;Object.keys(t).forEach(function(n){var a=t[n];-1===T.indexOf(n)&&(e(a,n,t,i),r.isValObject(a)||p.isPlainObject(a)&&r.crawl(a,e,i+1))})},r.isValObject=function(t){return t&&void 0!==t.valType},r.findArrayAttributes=function(t){function e(e,r,o,s){if(a=a.slice(0,s).concat([r]),e&&(\"data_array\"===e.valType||!0===e.arrayOk)&&!(\"colorbar\"===a[s-1]&&(\"ticktext\"===r||\"tickvals\"===r))){var l=n(a),u=p.nestedProperty(t,l).get();Array.isArray(u)&&i.push(l)}}function n(t){return t.join(\".\")}var i=[],a=[];if(r.crawl(m,e),t._module&&t._module.attributes&&r.crawl(t._module.attributes,e),t.transforms)for(var o=t.transforms,s=0;s<o.length;s++){var l=o[s],u=l._module;u&&(a=[\"transforms[\"+s+\"]\"],r.crawl(u.attributes,e,1))}return t._fullInput&&t._fullInput._module&&t._fullInput._module.attributes&&(r.crawl(t._fullInput._module.attributes,e),i=p.filterUnique(i)),i}},{\"../lib\":725,\"../plots/animation_attributes\":762,\"../plots/attributes\":764,\"../plots/frame_attributes\":791,\"../plots/layout_attributes\":820,\"../plots/polar/area_attributes\":830,\"../plots/polar/axis_attributes\":831,\"../registry\":844,\"./edit_types\":750}],756:[function(t,e,r){\"use strict\";function n(t){o.register(t,t.name,t.categories,t.meta),o.subplotsRegistry[t.basePlotModule.name]||o.registerSubplot(t.basePlotModule)}function i(t){if(\"string\"!=typeof t.name)throw new Error(\"Transform module *name* must be a string.\");var e=\"Transform module \"+t.name,r=\"function\"==typeof t.transform,n=\"function\"==typeof t.calcTransform;if(!r&&!n)throw new Error(e+\" is missing a *transform* or *calcTransform* method.\");r&&n&&s.log([e+\" has both a *transform* and *calcTransform* methods.\",\"Please note that all *transform* methods are executed\",\"before all *calcTransform* methods.\"].join(\" \")),s.isPlainObject(t.attributes)||s.log(e+\" registered without an *attributes* object.\"),\"function\"!=typeof t.supplyDefaults&&s.log(e+\" registered without a *supplyDefaults* method.\"),o.transformsRegistry[t.name]=t}function a(t){if(\"string\"!=typeof t.name)throw new Error(\"Component module *name* must be a string.\");o.registerComponent(t)}var o=t(\"../registry\"),s=t(\"../lib\");e.exports=function(t){if(!t)throw new Error(\"No argument passed to Plotly.register.\");t&&!Array.isArray(t)&&(t=[t]);for(var e=0;e<t.length;e++){var r=t[e];if(!r)throw new Error(\"Invalid module was attempted to be registered!\");switch(r.moduleType){case\"trace\":n(r);break;case\"transform\":i(r);break;case\"component\":a(r);break;default:throw new Error(\"Invalid module was attempted to be registered!\")}}}},{\"../lib\":725,\"../registry\":844}],757:[function(t,e,r){\"use strict\";var n=t(\"../plotly\"),i=t(\"../lib\");e.exports=function(t){return i.extendFlat(n.defaultConfig,t)}},{\"../lib\":725,\"../plotly\":761}],758:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=0;n<r.length;n++){var i=r[n][0],a=r[n][1];if(!(i[0]>=t[1]||i[1]<=t[0])&&(a[0]<e[1]&&a[1]>e[0]))return!0}return!1}function i(t,e,r){return t._anchorAxis===e&&(t.mirror||t.side===r)||\"all\"===t.mirror||\"allticks\"===t.mirror||t.mirrors&&t.mirrors[e._id+r]}function a(t,e,r){var n=[],i=e._anchorAxis;if(i){var a=i._mainAxis;if(-1===n.indexOf(a)){n.push(a);for(var o=0;o<r.length;o++)r[o].overlaying===a._id&&-1===n.indexOf(r[o])&&n.push(r[o])}}return n}function o(t,e,r){for(var n=0;n<e.length;n++){var a=e[n],o=a._anchorAxis;if(o&&i(a,o,r))return p.crispRound(t,a.linewidth)}}function s(t,e,r,n,i,s){if(n)return r;var l,u=e._mainAxis,c=a(t,u,s),h=o(t,c,i);if(h)return h;for(l=0;l<s.length;l++)if(s[l].overlaying===u._id&&(c=a(t,s[l],s),h=o(t,c,i)))return h;return 0}var l=t(\"d3\"),u=t(\"../plotly\"),c=t(\"../registry\"),h=t(\"../plots/plots\"),f=t(\"../lib\"),d=t(\"../components/color\"),p=t(\"../components/drawing\"),m=t(\"../components/titles\"),v=t(\"../components/modebar\"),g=t(\"../plots/cartesian/graph_interact\"),y=t(\"../plots/cartesian/constants\");r.layoutStyles=function(t){return f.syncOrAsync([h.doAutoMargin,r.lsInner],t)},r.lsInner=function(t){var e,a=t._fullLayout,o=a._size,c=o.p,h=u.Axes.list(t),f=a._has(\"cartesian\");for(e=0;e<h.length;e++)h[e]._linepositions={};a._paperdiv.style({width:a.width+\"px\",height:a.height+\"px\"}).selectAll(\".main-svg\").call(p.setSize,a.width,a.height),t._context.setBackground(t,a.paper_bgcolor);var m=a._paper.selectAll(\"g.subplot\"),g=[],b=[];m.each(function(t){var e=a._plots[t];if(e.mainplot)return e.bg&&e.bg.remove(),void(e.bg=void 0);var r=e.xaxis.domain,i=e.yaxis.domain,o=[];n(r,i,b)?o=[0]:(g.push(t),b.push([r,i]));var s=e.plotgroup.selectAll(\".bg\").data(o);s.enter().append(\"rect\").classed(\"bg\",!0),s.exit().remove(),s.each(function(){e.bg=s;var t=e.plotgroup.node();t.insertBefore(this,t.childNodes[0])})});var x=a._bgLayer.selectAll(\".bg\").data(g);x.enter().append(\"rect\").classed(\"bg\",!0),x.exit().remove(),x.each(function(t){a._plots[t].bg=l.select(this)});var _={};return m.each(function(r){function n(t,e){return e?\"M\"+P+\",\"+t+\"H\"+R:\"\"}function l(t,e){return e?\"M\"+t+\",\"+H+\"V\"+U:\"\"}var u=a._plots[r],m=u.xaxis,v=u.yaxis;m.setScale(),v.setScale(),u.bg&&f&&u.bg.call(p.setRect,m._offset-c,v._offset-c,m._length+2*c,v._length+2*c).call(d.fill,a.plot_bgcolor).style(\"stroke-width\",0),u.clipId=\"clip\"+a._uid+r+\"plot\";var g=a._defs.selectAll(\"g.clips\").selectAll(\"#\"+u.clipId).data([0]);g.enter().append(\"clipPath\").attr({class:\"plotclip\",id:u.clipId}).append(\"rect\"),g.selectAll(\"rect\").attr({width:m._length,height:v._length}),p.setTranslate(u.plot,m._offset,v._offset);var b,x;for(u._hasClipOnAxisFalse?(b=null,x=u.clipId):(b=u.clipId,x=null),p.setClipUrl(u.plot,b),e=0;e<y.traceLayerClasses.length;e++){var w=y.traceLayerClasses[e];\"scatterlayer\"!==w&&u.plot.selectAll(\"g.\"+w).call(p.setClipUrl,x)}u.layerClipId=x;var M=!m._anchorAxis,k=M&&!_[m._id],A=i(m,v,\"bottom\"),T=i(m,v,\"top\"),S=!v._anchorAxis,E=S&&!_[v._id],L=i(v,m,\"left\"),C=i(v,m,\"right\"),z=p.crispRound(t,m.linewidth,1),I=p.crispRound(t,v.linewidth,1),D=s(t,m,I,L,\"left\",h),P=!M&&D?-c-D:0,O=s(t,m,I,C,\"right\",h),R=m._length+(!M&&O?c+O:0),F=o.h*(1-(m.position||0))+z/2%1,j=v._length+c+z/2,N=-c-z/2,B=!S&&s(t,v,z,A,\"bottom\",h),U=v._length+(B?c:0),V=!S&&s(t,v,z,T,\"top\",h),H=V?-c:0,q=o.w*(v.position||0)+I/2%1,G=-c-I/2,Y=m._length+c+I/2;m._linepositions[r]=[A?j:void 0,T?N:void 0,k?F:void 0],m._anchorAxis===v?m._linepositions[r][3]=\"top\"===m.side?N:j:k&&(m._linepositions[r][3]=F),v._linepositions[r]=[L?G:void 0,C?Y:void 0,E?q:void 0],v._anchorAxis===m?v._linepositions[r][3]=\"right\"===v.side?Y:G:E&&(v._linepositions[r][3]=q);var X=\"translate(\"+m._offset+\",\"+v._offset+\")\",W=X,Z=X;k&&(W=\"translate(\"+m._offset+\",\"+o.t+\")\",N+=v._offset-o.t,j+=v._offset-o.t),E&&(Z=\"translate(\"+o.l+\",\"+v._offset+\")\",G+=m._offset-o.l,Y+=m._offset-o.l),f&&(u.xlines.attr(\"transform\",W).attr(\"d\",n(j,A)+n(N,T)+n(F,k)||\"M0,0\").style(\"stroke-width\",z+\"px\").call(d.stroke,m.showline?m.linecolor:\"rgba(0,0,0,0)\"),u.ylines.attr(\"transform\",Z).attr(\"d\",l(G,L)+l(Y,C)+l(q,E)||\"M0,0\").style(\"stroke-width\",I+\"px\").call(d.stroke,v.showline?v.linecolor:\"rgba(0,0,0,0)\")),u.xaxislayer.attr(\"transform\",W),u.yaxislayer.attr(\"transform\",Z),u.gridlayer.attr(\"transform\",X),u.zerolinelayer.attr(\"transform\",X),u.draglayer.attr(\"transform\",X),k&&(_[m._id]=1),E&&(_[v._id]=1)}),u.Axes.makeClipPaths(t),r.drawMainTitle(t),v.manage(t),t._promises.length&&Promise.all(t._promises)},r.drawMainTitle=function(t){var e=t._fullLayout;m.draw(t,\"gtitle\",{propContainer:e,propName:\"title\",dfltName:\"Plot\",attributes:{x:e.width/2,y:e._size.t/2,\"text-anchor\":\"middle\"}})},r.doTraceStyle=function(t){for(var e=0;e<t.calcdata.length;e++){var r=t.calcdata[e],n=((r[0]||{}).trace||{})._module||{},i=n.arraysToCalcdata;i&&i(r,r[0].trace)}return h.style(t),c.getComponentMethod(\"legend\",\"draw\")(t),h.previousPromises(t)},r.doColorBars=function(t){for(var e=0;e<t.calcdata.length;e++){var r=t.calcdata[e][0];if((r.t||{}).cb){var n=r.trace,i=r.t.cb;c.traceIs(n,\"contour\")&&i.line({width:!1!==n.contours.showlines?n.line.width:0,dash:n.line.dash,color:\"line\"===n.contours.coloring?i._opts.line.color:n.line.color}),c.traceIs(n,\"markerColorscale\")?i.options(n.marker.colorbar)():i.options(n.colorbar)()}}return h.previousPromises(t)},r.layoutReplot=function(t){var e=t.layout;return t.layout=void 0,u.plot(t,\"\",e)},r.doLegend=function(t){return c.getComponentMethod(\"legend\",\"draw\")(t),h.previousPromises(t)},r.doTicksRelayout=function(t){return u.Axes.doTicks(t,\"redraw\"),r.drawMainTitle(t),h.previousPromises(t)},r.doModeBar=function(t){var e,r,n,i=t._fullLayout;for(v.manage(t),g(t),e=h.getSubplotIds(i,\"gl3d\"),n=0;n<e.length;n++)r=i[e[n]]._scene,r.updateFx(i.dragmode,i.hovermode);for(e=h.getSubplotIds(i,\"gl2d\"),n=0;n<e.length;n++)r=i._plots[e[n]]._scene2d,r.updateFx(i.dragmode);for(e=h.getSubplotIds(i,\"mapbox\"),n=0;n<e.length;n++)r=i[e[n]]._subplot,r.updateFx(i);return h.previousPromises(t)},r.doCamera=function(t){for(var e=t._fullLayout,r=h.getSubplotIds(e,\"gl3d\"),n=0;n<r.length;n++){var i=e[r[n]];i._scene.setCamera(i.camera)}}},{\"../components/color\":603,\"../components/drawing\":627,\"../components/modebar\":663,\"../components/titles\":692,\"../lib\":725,\"../plotly\":761,\"../plots/cartesian/constants\":771,\"../plots/cartesian/graph_interact\":775,\"../plots/plots\":829,\"../registry\":844,d3:121}],759:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return!(t in e)||a.validate(e[t],c[t])}function n(t,r){return a.coerce(e,y,c,t,r)}function f(){return new Promise(function(t){setTimeout(t,o.getDelay(k._fullLayout))})}function d(){return new Promise(function(t,e){var r=s(k),n=k._fullLayout.width,o=k._fullLayout.height;if(i.purge(k),document.body.removeChild(k),\"svg\"===b)return t(M?r:\"data:image/svg+xml,\"+encodeURIComponent(r));var u=document.createElement(\"canvas\");u.id=a.randstr(),l({format:b,width:n,height:o,canvas:u,svg:r,promise:!0}).then(t).catch(e)})}function p(t){return M?t.replace(h,\"\"):t}e=e||{};var m,v,g;if(a.isPlainObject(t)?(m=t.data||[],v=t.layout||{},g=t.config||{}):(t=u(t),m=a.extendDeep([],t.data),v=a.extendDeep({},t.layout),g=t._context),!r(\"width\")||!r(\"height\"))throw new Error(\"Height and width should be pixel values.\");if(!r(\"format\"))throw new Error(\"Image format is not jpeg, png, svg or webp.\");var y={},b=n(\"format\"),x=n(\"width\"),_=n(\"height\"),w=n(\"setBackground\"),M=n(\"imageDataOnly\"),k=document.createElement(\"div\");k.style.position=\"absolute\",k.style.left=\"-5000px\",document.body.appendChild(k);var A=a.extendFlat({},v);x&&(A.width=x),_&&(A.height=_);var T=a.extendFlat({},g,{staticPlot:!0,plotGlPixelRatio:g.plotGlPixelRatio||2,setBackground:w}),S=o.getRedrawFunc(k);return new Promise(function(t,e){i.plot(k,m,A,T).then(S).then(f).then(d).then(function(e){t(p(e))}).catch(function(t){e(t)})})}var i=t(\"../plotly\"),a=t(\"../lib\"),o=t(\"../snapshot/helpers\"),s=t(\"../snapshot/tosvg\"),l=t(\"../snapshot/svgtoimg\"),u=t(\"./helpers\").getGraphDiv,c={format:{valType:\"enumerated\",values:[\"png\",\"jpeg\",\"webp\",\"svg\"],dflt:\"png\"},width:{valType:\"number\",min:1},height:{valType:\"number\",min:1},setBackground:{valType:\"any\",dflt:!1},imageDataOnly:{valType:\"boolean\",dflt:!1}},h=/^data:image\\/\\w+;base64,/;e.exports=n},{\"../lib\":725,\"../plotly\":761,\"../snapshot/helpers\":848,\"../snapshot/svgtoimg\":850,\"../snapshot/tosvg\":852,\"./helpers\":751}],760:[function(t,e,r){\"use strict\";function n(t,e,r,i,a,u){u=u||[];for(var c=Object.keys(t),f=0;f<c.length;f++){var d=c[f];if(\"transforms\"!==d){var v=u.slice();v.push(d)\n",
       ";var g=t[d],y=e[d],b=l(r,d),x=\"info_array\"===(b||{}).valType,_=\"colorscale\"===(b||{}).valType;if(s(r,d))if(p(g)&&p(y))n(g,y,b,i,a,v);else if(b.items&&!x&&m(g)){var w,M,k=b.items,A=k[Object.keys(k)[0]],T=[];for(w=0;w<y.length;w++){var S=y[w]._index||w;M=v.slice(),M.push(S),p(g[S])&&p(y[w])&&(T.push(S),n(g[S],y[w],A,i,a,M))}for(w=0;w<g.length;w++)M=v.slice(),M.push(w),p(g[w])?-1===T.indexOf(w)&&i.push(o(\"unused\",a,M)):i.push(o(\"object\",a,M,g[w]))}else!p(g)&&p(y)?i.push(o(\"object\",a,v,g)):m(g)||!m(y)||x||_?d in e?h.validate(g,b)?\"enumerated\"===b.valType&&(b.coerceNumber&&g!==+y||g!==y)&&i.push(o(\"dynamic\",a,v,g,y)):i.push(o(\"value\",a,v,g)):i.push(o(\"unused\",a,v,g)):i.push(o(\"array\",a,v,g));else i.push(o(\"schema\",a,v))}}return i}function i(t,e){for(var r=0;r<e.length;r++){var n=e[r].type,i=t.traces[n].layoutAttributes;i&&h.extendFlat(t.layout.layoutAttributes,i)}return t.layout.layoutAttributes}function a(t){return m(t)?\"In data trace \"+t[1]+\", \":\"In \"+t+\", \"}function o(t,e,r,n,i){r=r||\"\";var a,o;m(e)?(a=e[0],o=e[1]):(a=e,o=null);var s=c(r),l=v[t](e,s,n,i);return h.log(l),{code:t,container:a,trace:o,path:r,astr:s,msg:l}}function s(t,e){var r=u(e),n=r.keyMinusId,i=r.id;return!!(n in t&&t[n]._isSubplotObj&&i)||e in t}function l(t,e){return t[u(e).keyMinusId]}function u(t){var e=/([2-9]|[1-9][0-9]+)$/,r=t.split(e)[0];return{keyMinusId:r,id:t.substr(r.length,t.length)}}function c(t){if(!m(t))return String(t);for(var e=\"\",r=0;r<t.length;r++){var n=t[r];\"number\"==typeof n?e=e.substr(0,e.length-1)+\"[\"+n+\"]\":e+=n,r<t.length-1&&(e+=\".\")}return e}var h=t(\"../lib\"),f=t(\"../plots/plots\"),d=t(\"./plot_schema\"),p=h.isPlainObject,m=Array.isArray;e.exports=function(t,e){var r,a,s=d.get(),l=[],u={};m(t)?(u.data=h.extendDeep([],t),r=t):(u.data=[],r=[],l.push(o(\"array\",\"data\"))),p(e)?(u.layout=h.extendDeep({},e),a=e):(u.layout={},a={},arguments.length>1&&l.push(o(\"object\",\"layout\"))),f.supplyDefaults(u);for(var c=u._fullData,v=r.length,g=0;g<v;g++){var y=r[g],b=[\"data\",g];if(p(y)){var x=c[g],_=x.type,w=s.traces[_].attributes;w.type={valType:\"enumerated\",values:[_]},!1===x.visible&&!1!==y.visible&&l.push(o(\"invisible\",b)),n(y,x,w,l,b);var M=y.transforms,k=x.transforms;if(M){m(M)||l.push(o(\"array\",b,[\"transforms\"])),b.push(\"transforms\");for(var A=0;A<M.length;A++){var T=[\"transforms\",A],S=M[A].type;if(p(M[A])){var E=s.transforms[S]?s.transforms[S].attributes:{};E.type={valType:\"enumerated\",values:Object.keys(s.transforms)},n(M[A],k[A],E,l,b,T)}else l.push(o(\"object\",b,T))}}}else l.push(o(\"object\",b))}return n(a,u._fullLayout,i(s,c),l,\"layout\"),0===l.length?void 0:l};var v={object:function(t,e){return(\"layout\"===t&&\"\"===e?\"The layout argument\":\"data\"===t[0]&&\"\"===e?\"Trace \"+t[1]+\" in the data argument\":a(t)+\"key \"+e)+\" must be linked to an object container\"},array:function(t,e){return(\"data\"===t?\"The data argument\":a(t)+\"key \"+e)+\" must be linked to an array container\"},schema:function(t,e){return a(t)+\"key \"+e+\" is not part of the schema\"},unused:function(t,e,r){var n=p(r)?\"container\":\"key\";return a(t)+n+\" \"+e+\" did not get coerced\"},dynamic:function(t,e,r,n){return[a(t)+\"key\",e,\"(set to '\"+r+\"')\",\"got reset to\",\"'\"+n+\"'\",\"during defaults.\"].join(\" \")},invisible:function(t){return\"Trace \"+t[1]+\" got defaulted to be not visible\"},value:function(t,e,r){return[a(t)+\"key \"+e,\"is set to an invalid value (\"+r+\")\"].join(\" \")}}},{\"../lib\":725,\"../plots/plots\":829,\"./plot_schema\":755}],761:[function(t,e,r){\"use strict\";r.defaultConfig=t(\"./plot_api/plot_config\"),r.Plots=t(\"./plots/plots\"),r.Axes=t(\"./plots/cartesian/axes\"),r.ModeBar=t(\"./components/modebar\"),t(\"./plot_api/plot_api\")},{\"./components/modebar\":663,\"./plot_api/plot_api\":753,\"./plot_api/plot_config\":754,\"./plots/cartesian/axes\":766,\"./plots/plots\":829}],762:[function(t,e,r){\"use strict\";e.exports={mode:{valType:\"enumerated\",dflt:\"afterall\",values:[\"immediate\",\"next\",\"afterall\"]},direction:{valType:\"enumerated\",values:[\"forward\",\"reverse\"],dflt:\"forward\"},fromcurrent:{valType:\"boolean\",dflt:!1},frame:{duration:{valType:\"number\",min:0,dflt:500},redraw:{valType:\"boolean\",dflt:!0}},transition:{duration:{valType:\"number\",min:0,dflt:500},easing:{valType:\"enumerated\",dflt:\"cubic-in-out\",values:[\"linear\",\"quad\",\"cubic\",\"sin\",\"exp\",\"circle\",\"elastic\",\"back\",\"bounce\",\"linear-in\",\"quad-in\",\"cubic-in\",\"sin-in\",\"exp-in\",\"circle-in\",\"elastic-in\",\"back-in\",\"bounce-in\",\"linear-out\",\"quad-out\",\"cubic-out\",\"sin-out\",\"exp-out\",\"circle-out\",\"elastic-out\",\"back-out\",\"bounce-out\",\"linear-in-out\",\"quad-in-out\",\"cubic-in-out\",\"sin-in-out\",\"exp-in-out\",\"circle-in-out\",\"elastic-in-out\",\"back-in-out\",\"bounce-in-out\"]}}}},{}],763:[function(t,e,r){\"use strict\";var n=t(\"../lib\");e.exports=function(t,e,r){var i,a=r.name,o=e[a],s=n.isArray(t[a])?t[a]:[],l=e[a]=[];for(i=0;i<s.length;i++){var u=s[i],c={},h={};n.isPlainObject(u)||(h.itemIsNotPlainObject=!0,u={}),r.handleItemDefaults(u,c,e,r,h),c._input=u,c._index=i,l.push(c)}if(n.isArray(o)){var f=Math.min(o.length,l.length);for(i=0;i<f;i++)n.relinkPrivateKeys(l[i],o[i])}}},{\"../lib\":725}],764:[function(t,e,r){\"use strict\";var n=t(\"../components/fx/attributes\");e.exports={type:{valType:\"enumerated\",values:[],dflt:\"scatter\"},visible:{valType:\"enumerated\",values:[!0,!1,\"legendonly\"],dflt:!0},showlegend:{valType:\"boolean\",dflt:!0},legendgroup:{valType:\"string\",dflt:\"\"},opacity:{valType:\"number\",min:0,max:1,dflt:1},name:{valType:\"string\"},uid:{valType:\"string\",dflt:\"\"},ids:{valType:\"data_array\"},customdata:{valType:\"data_array\"},hoverinfo:{valType:\"flaglist\",flags:[\"x\",\"y\",\"z\",\"text\",\"name\"],extras:[\"all\",\"none\",\"skip\"],arrayOk:!0,dflt:\"all\"},hoverlabel:n.hoverlabel,stream:{token:{valType:\"string\",noBlank:!0,strict:!0},maxpoints:{valType:\"number\",min:0,max:1e4,dflt:500}}}},{\"../components/fx/attributes\":636}],765:[function(t,e,r){\"use strict\";e.exports={xaxis:{valType:\"subplotid\",dflt:\"x\"},yaxis:{valType:\"subplotid\",dflt:\"y\"}}},{}],766:[function(t,e,r){\"use strict\";function n(t){return+t}function i(t){return String(t)}function a(t,e,r,n,i){function a(e){return(1+100*(e-t)/r.dtick)%100<2}for(var o=0,s=0,l=0,u=0,c=0;c<e.length;c++)e[c]%1==0?l++:M(e[c])||u++,a(e[c])&&o++,a(e[c]+r.dtick/2)&&s++;var h=e.length-u;if(l===h&&\"date\"!==r.type)r.dtick<1?t=n-.5*r.dtick:(t-=.5)+r.dtick<n&&(t+=r.dtick);else if(s<.1*h&&(o>.3*h||a(n)||a(i))){var f=r.dtick/2;t+=t+f<n?f:-f}return t}function o(t,e,r,n,i){var a=A.findExactDates(e,i);if(a.exactDays>.8){var o=Number(r.substr(1));a.exactYears>.8&&o%12==0?t=B.tickIncrement(t,\"M6\",\"reverse\")+1.5*P:a.exactMonths>.8?t=B.tickIncrement(t,\"M1\",\"reverse\")+15.5*P:t-=P/2;var s=B.tickIncrement(t,r);if(s<=n)return s}return t}function s(t){var e,r,n=t.tickvals,i=t.ticktext,a=new Array(n.length),o=A.simpleMap(t.range,t.r2l),s=1.0001*o[0]-1e-4*o[1],l=1.0001*o[1]-1e-4*o[0],u=Math.min(s,l),h=Math.max(s,l),f=0;Array.isArray(i)||(i=[]);var d=\"category\"===t.type?t.d2l_noadd:t.d2l;for(\"log\"===t.type&&\"L\"!==String(t.dtick).charAt(0)&&(t.dtick=\"L\"+Math.pow(10,Math.floor(Math.min(t.range[0],t.range[1]))-1)),r=0;r<n.length;r++)(e=d(n[r]))>u&&e<h&&(void 0===i[r]?a[f]=B.tickText(t,e):a[f]=c(t,e,String(i[r])),f++);return f<n.length&&a.splice(f,n.length-f),a}function l(t,e,r){return e*A.roundUp(t/e,r)}function u(t){var e=t.dtick;if(t._tickexponent=0,M(e)||\"string\"==typeof e||(e=1),\"category\"===t.type&&(t._tickround=null),\"date\"===t.type){var r=t.r2l(t.tick0),n=t.l2r(r).replace(/(^-|i)/g,\"\"),i=n.length;if(\"M\"===String(e).charAt(0))i>10||\"01-01\"!==n.substr(5)?t._tickround=\"d\":t._tickround=+e.substr(1)%12==0?\"y\":\"m\";else if(e>=P&&i<=10||e>=15*P)t._tickround=\"d\";else if(e>=R&&i<=16||e>=O)t._tickround=\"M\";else if(e>=F&&i<=19||e>=R)t._tickround=\"S\";else{var a=t.l2r(r+e).replace(/^-/,\"\").length;t._tickround=Math.max(i,a)-20}}else if(M(e)||\"L\"===e.charAt(0)){var o=t.range.map(t.r2d||Number);M(e)||(e=Number(e.substr(1))),t._tickround=2-Math.floor(Math.log(e)/Math.LN10+.01);var s=Math.max(Math.abs(o[0]),Math.abs(o[1])),l=Math.floor(Math.log(s)/Math.LN10+.01);Math.abs(l)>3&&(m(t.exponentformat)&&!v(l)?t._tickexponent=3*Math.round((l-1)/3):t._tickexponent=l)}else t._tickround=null}function c(t,e,r){var n=t.tickfont||{};return{x:e,dx:0,dy:0,text:r||\"\",fontSize:n.size,font:n.family,fontColor:n.color}}function h(t,e,r,n){var i=t._tickround,a=r&&t.hoverformat||t.tickformat;n&&(i=M(i)?4:{y:\"m\",m:\"d\",d:\"M\",M:\"S\",S:4}[i]);var o,s=A.formatDate(e.x,a,i,t.calendar),l=s.indexOf(\"\\n\");-1!==l&&(o=s.substr(l+1),s=s.substr(0,l)),n&&(\"00:00:00\"===s||\"00:00\"===s?(s=o,o=\"\"):8===s.length&&(s=s.replace(/:00$/,\"\"))),o&&(r?\"d\"===i?s+=\", \"+o:s=o+(s?\", \"+s:\"\"):t._inCalcTicks&&o===t._prevDateHead||(s+=\"<br>\"+o,t._prevDateHead=o)),e.text=s}function f(t,e,r,n,i){var a=t.dtick,o=e.x;if(\"never\"===i&&(i=\"\"),!n||\"string\"==typeof a&&\"L\"===a.charAt(0)||(a=\"L3\"),t.tickformat||\"string\"==typeof a&&\"L\"===a.charAt(0))e.text=g(Math.pow(10,o),t,i,n);else if(M(a)||\"D\"===a.charAt(0)&&A.mod(o+.01,1)<.1){var s=Math.round(o);-1!==[\"e\",\"E\",\"power\"].indexOf(t.exponentformat)||m(t.exponentformat)&&v(s)?(e.text=0===s?1:1===s?\"10\":s>1?\"10<sup>\"+s+\"</sup>\":\"10<sup>\"+j+-s+\"</sup>\",e.fontSize*=1.25):(e.text=g(Math.pow(10,o),t,\"\",\"fakehover\"),\"D1\"===a&&\"y\"===t._id.charAt(0)&&(e.dy-=e.fontSize/6))}else{if(\"D\"!==a.charAt(0))throw\"unrecognized dtick \"+String(a);e.text=String(Math.round(Math.pow(10,A.mod(o,1)))),e.fontSize*=.75}if(\"D1\"===t.dtick){var l=String(e.text).charAt(0);\"0\"!==l&&\"1\"!==l||(\"y\"===t._id.charAt(0)?e.dx-=e.fontSize/4:(e.dy+=e.fontSize/2,e.dx+=(t.range[1]>t.range[0]?1:-1)*e.fontSize*(o<0?.5:.25)))}}function d(t,e){var r=t._categories[Math.round(e.x)];void 0===r&&(r=\"\"),e.text=String(r)}function p(t,e,r,n,i){\"never\"===i?i=\"\":\"all\"===t.showexponent&&Math.abs(e.x/t.dtick)<1e-6&&(i=\"hide\"),e.text=g(e.x,t,i,n)}function m(t){return\"SI\"===t||\"B\"===t}function v(t){return t>14||t<-15}function g(t,e,r,n){var i=t<0,a=e._tickround,o=r||e.exponentformat||\"B\",s=e._tickexponent,l=e.tickformat,c=e.separatethousands;if(n){var h={exponentformat:e.exponentformat,dtick:\"none\"===e.showexponent?e.dtick:M(t)?Math.abs(t)||1:1,range:\"none\"===e.showexponent?e.range.map(e.r2d):[0,t||1]};u(h),a=(Number(h._tickround)||0)+4,s=h._tickexponent,e.hoverformat&&(l=e.hoverformat)}if(l)return w.format(l)(t).replace(/-/g,j);var f=Math.pow(10,-a)/2;if(\"none\"===o&&(s=0),(t=Math.abs(t))<f)t=\"0\",i=!1;else{if(t+=f,s&&(t*=Math.pow(10,-s),a+=s),0===a)t=String(Math.floor(t));else if(a<0){t=String(Math.round(t)),t=t.substr(0,t.length+a);for(var d=a;d<0;d++)t+=\"0\"}else{t=String(t);var p=t.indexOf(\".\")+1;p&&(t=t.substr(0,p+a).replace(/\\.?0+$/,\"\"))}t=A.numSeparate(t,e._separators,c)}if(s&&\"hide\"!==o){m(o)&&v(s)&&(o=\"power\");var g;g=s<0?j+-s:\"power\"!==o?\"+\"+s:String(s),\"e\"===o?t+=\"e\"+g:\"E\"===o?t+=\"E\"+g:\"power\"===o?t+=\"\\xd710<sup>\"+g+\"</sup>\":\"B\"===o&&9===s?t+=\"B\":m(o)&&(t+=J[s/3+5])}return i?j+t:t}function y(t,e){var r,n,i=[];for(r=0;r<e.length;r++){var a=[],o=t._fullData[e[r]].xaxis,s=t._fullData[e[r]].yaxis;if(o&&s){for(n=0;n<i.length;n++)-1===i[n].x.indexOf(o)&&-1===i[n].y.indexOf(s)||a.push(n);if(a.length){var l,u=i[a[0]];if(a.length>1)for(n=1;n<a.length;n++)l=i[a[n]],b(u.x,l.x),b(u.y,l.y);b(u.x,[o]),b(u.y,[s])}else i.push({x:[o],y:[s]})}}return i}function b(t,e){for(var r=0;r<e.length;r++)-1===t.indexOf(e[r])&&t.push(e[r])}function x(t,e,r){var n,i,a=[],o=[],s=t.layout;for(n=0;n<e.length;n++)a.push(B.getFromId(t,e[n]));for(n=0;n<r.length;n++)o.push(B.getFromId(t,r[n]));var l=Object.keys(a[0]),u=[\"anchor\",\"domain\",\"overlaying\",\"position\",\"side\",\"tickangle\"],c=[\"linear\",\"log\"];for(n=0;n<l.length;n++){var h=l[n],f=a[0][h],d=o[0][h],p=!0,m=!1,v=!1;if(\"_\"!==h.charAt(0)&&\"function\"!=typeof f&&-1===u.indexOf(h)){for(i=1;i<a.length&&p;i++){var g=a[i][h];\"type\"===h&&-1!==c.indexOf(f)&&-1!==c.indexOf(g)&&f!==g?m=!0:g!==f&&(p=!1)}for(i=1;i<o.length&&p;i++){var y=o[i][h];\"type\"===h&&-1!==c.indexOf(d)&&-1!==c.indexOf(y)&&d!==y?v=!0:o[i][h]!==d&&(p=!1)}p&&(m&&(s[a[0]._name].type=\"linear\"),v&&(s[o[0]._name].type=\"linear\"),_(s,h,a,o))}}for(n=0;n<t._fullLayout.annotations.length;n++){var b=t._fullLayout.annotations[n];-1!==e.indexOf(b.xref)&&-1!==r.indexOf(b.yref)&&A.swapAttrs(s.annotations[n],[\"?\"])}}function _(t,e,r,n){var i,a=A.nestedProperty,o=a(t[r[0]._name],e).get(),s=a(t[n[0]._name],e).get();for(\"title\"===e&&(\"Click to enter X axis title\"===o&&(o=\"Click to enter Y axis title\"),\"Click to enter Y axis title\"===s&&(s=\"Click to enter X axis title\")),i=0;i<r.length;i++)a(t,r[i]._name+\".\"+e).set(s);for(i=0;i<n.length;i++)a(t,n[i]._name+\".\"+e).set(o)}var w=t(\"d3\"),M=t(\"fast-isnumeric\"),k=t(\"../../registry\"),A=t(\"../../lib\"),T=t(\"../../lib/svg_text_utils\"),S=t(\"../../components/titles\"),E=t(\"../../components/color\"),L=t(\"../../components/drawing\"),C=t(\"../../constants/numerical\"),z=C.FP_SAFE,I=C.ONEAVGYEAR,D=C.ONEAVGMONTH,P=C.ONEDAY,O=C.ONEHOUR,R=C.ONEMIN,F=C.ONESEC,j=C.MINUS_SIGN,N=t(\"../../constants/alignment\").MID_SHIFT,B=e.exports={};B.layoutAttributes=t(\"./layout_attributes\"),B.supplyLayoutDefaults=t(\"./layout_defaults\"),B.setConvert=t(\"./set_convert\");var U=t(\"./axis_autotype\"),V=t(\"./axis_ids\");B.id2name=V.id2name,B.cleanId=V.cleanId,B.list=V.list,B.listIds=V.listIds,B.getFromId=V.getFromId,B.getFromTrace=V.getFromTrace,B.coerceRef=function(t,e,r,n,i,a){var o=n.charAt(n.length-1),s=B.listIds(r,o),l=n+\"ref\",u={};return i||(i=s[0]||a),a||(a=i),u[l]={valType:\"enumerated\",values:s.concat(a?[a]:[]),dflt:i},A.coerce(t,e,u,l)},B.coercePosition=function(t,e,r,n,i,a){var o,s;if(\"paper\"===n||\"pixel\"===n)o=A.ensureNumber,s=r(i,a);else{var l=B.getFromId(e,n);a=l.fraction2r(a),s=r(i,a),o=l.cleanPos}t[i]=o(s)},B.cleanPosition=function(t,e,r){return(\"paper\"===r||\"pixel\"===r?A.ensureNumber:B.getFromId(e,r).cleanPos)(t)};var H=B.getDataConversions=function(t,e,r,a){var o,s=\"x\"===r||\"y\"===r||\"z\"===r?r:a;if(Array.isArray(s)){if(o={type:U(a),_categories:[]},B.setConvert(o),\"category\"===o.type)for(var l=0;l<a.length;l++)o.d2c(a[l])}else o=B.getFromTrace(t,e,s);return o?{d2c:o.d2c,c2d:o.c2d}:\"ids\"===s?{d2c:i,c2d:i}:{d2c:n,c2d:n}};B.getDataToCoordFunc=function(t,e,r,n){return H(t,e,r,n).d2c},B.clearTypes=function(t,e){Array.isArray(e)&&e.length||(e=t._fullData.map(function(t,e){return e})),e.forEach(function(e){var r=t.data[e];delete(B.getFromId(t,r.xaxis)||{}).type,delete(B.getFromId(t,r.yaxis)||{}).type})},B.counterLetter=function(t){var e=t.charAt(0);return\"x\"===e?\"y\":\"y\"===e?\"x\":void 0},B.minDtick=function(t,e,r,n){-1===[\"log\",\"category\"].indexOf(t.type)&&n?void 0===t._minDtick?(t._minDtick=e,t._forceTick0=r):t._minDtick&&((t._minDtick/e+1e-6)%1<2e-6&&((r-t._forceTick0)/e%1+1.000001)%1<2e-6?(t._minDtick=e,t._forceTick0=r):((e/t._minDtick+1e-6)%1>2e-6||((r-t._forceTick0)/t._minDtick%1+1.000001)%1>2e-6)&&(t._minDtick=0)):t._minDtick=0},B.getAutoRange=function(t){var e,r=[],n=t._min[0].val,i=t._max[0].val;for(e=1;e<t._min.length&&n===i;e++)n=Math.min(n,t._min[e].val);for(e=1;e<t._max.length&&n===i;e++)i=Math.max(i,t._max[e].val);var a,o,s,l,u,c,h,f=0,d=!1;if(t.range){var p=A.simpleMap(t.range,t.r2l);d=p[1]<p[0]}for(\"reversed\"===t.autorange&&(d=!0,t.autorange=!0),e=0;e<t._min.length;e++)for(o=t._min[e],a=0;a<t._max.length;a++)s=t._max[a],h=s.val-o.val,c=t._length-o.pad-s.pad,h>0&&c>0&&h/c>f&&(l=o,u=s,f=h/c);if(n===i){var m=n-1,v=n+1;r=\"tozero\"===t.rangemode?n<0?[m,0]:[0,v]:\"nonnegative\"===t.rangemode?[Math.max(0,m),Math.max(0,v)]:[m,v]}else f&&(\"linear\"!==t.type&&\"-\"!==t.type||(\"tozero\"===t.rangemode?(l.val>=0&&(l={val:0,pad:0}),u.val<=0&&(u={val:0,pad:0})):\"nonnegative\"===t.rangemode&&(l.val-f*l.pad<0&&(l={val:0,pad:0}),u.val<0&&(u={val:1,pad:0})),f=(u.val-l.val)/(t._length-l.pad-u.pad)),r=[l.val-f*l.pad,u.val+f*u.pad]);return r[0]===r[1]&&(\"tozero\"===t.rangemode?r=r[0]<0?[r[0],0]:r[0]>0?[0,r[0]]:[0,1]:(r=[r[0]-1,r[0]+1],\"nonnegative\"===t.rangemode&&(r[0]=Math.max(0,r[0])))),d&&r.reverse(),A.simpleMap(r,t.l2r||Number)},B.doAutoRange=function(t){t._length||t.setScale();var e=t._min&&t._max&&t._min.length&&t._max.length;if(t.autorange&&e){t.range=B.getAutoRange(t),t._r=t.range.slice(),t._rl=A.simpleMap(t._r,t.r2l);var r=t._input;r.range=t.range.slice(),r.autorange=t.autorange}},B.saveRangeInitial=function(t,e){for(var r=B.list(t,\"\",!0),n=!1,i=0;i<r.length;i++){var a=r[i],o=void 0===a._rangeInitial,s=o||!(a.range[0]===a._rangeInitial[0]&&a.range[1]===a._rangeInitial[1]);(o&&!1===a.autorange||e&&s)&&(a._rangeInitial=a.range.slice(),n=!0)}return n},B.saveShowSpikeInitial=function(t,e){for(var r=B.list(t,\"\",!0),n=!1,i=\"on\",a=0;a<r.length;a++){var o=r[a],s=void 0===o._showSpikeInitial,l=s||!(o.showspikes===o._showspikes);(s||e&&l)&&(o._showSpikeInitial=o.showspikes,n=!0),\"on\"!==i||o.showspikes||(i=\"off\")}return t._fullLayout._cartesianSpikesEnabled=i,n},B.expand=function(t,e,r){function n(t){if(Array.isArray(t))return function(e){return Math.max(Number(t[e]||0),0)};var e=Math.max(Number(t||0),0);return function(){return e}}function i(r){function n(t){return M(t)&&Math.abs(t)<z}if(l=e[r],M(l)){if(h=b(r)+g,f=x(r)+g,p=l-w(r),m=l+_(r),\"log\"===t.type&&p<m/10&&(p=m/10),u=t.c2l(p),c=t.c2l(m),y&&(u=Math.min(0,u),c=Math.max(0,c)),n(u)){for(d=!0,o=0;o<t._min.length&&d;o++)s=t._min[o],s.val<=u&&s.pad>=f?d=!1:s.val>=u&&s.pad<=f&&(t._min.splice(o,1),o--);d&&t._min.push({val:u,pad:y&&0===u?0:f})}if(n(c)){for(d=!0,o=0;o<t._max.length&&d;o++)s=t._max[o],s.val>=c&&s.pad>=h?d=!1:s.val<=c&&s.pad<=h&&(t._max.splice(o,1),o--);d&&t._max.push({val:c,pad:y&&0===c?0:h})}}}if((t.autorange||!!A.nestedProperty(t,\"rangeslider.autorange\").get())&&e){t._min||(t._min=[]),t._max||(t._max=[]),r||(r={}),t._m||t.setScale();var a,o,s,l,u,c,h,f,d,p,m,v=e.length,g=r.padded?.05*t._length:0,y=r.tozero&&(\"linear\"===t.type||\"-\"===t.type);g&&\"domain\"===t.constrain&&t._inputDomain&&(g*=(t._inputDomain[1]-t._inputDomain[0])/(t.domain[1]-t.domain[0]));var b=n((t._m>0?r.ppadplus:r.ppadminus)||r.ppad||0),x=n((t._m>0?r.ppadminus:r.ppadplus)||r.ppad||0),_=n(r.vpadplus||r.vpad),w=n(r.vpadminus||r.vpad);for(a=0;a<6;a++)i(a);for(a=v-1;a>5;a--)i(a)}},B.autoBin=function(t,e,r,n,i){var s=A.aggNums(Math.min,null,t),l=A.aggNums(Math.max,null,t);if(i||(i=e.calendar),\"category\"===e.type)return{start:s-.5,end:l+.5,size:1};var u;if(r)u=(l-s)/r;else{var c=A.distinctVals(t),h=Math.pow(10,Math.floor(Math.log(c.minDiff)/Math.LN10)),f=h*A.roundUp(c.minDiff/h,[.9,1.9,4.9,9.9],!0);u=Math.max(f,2*A.stdev(t)/Math.pow(t.length,n?.25:.4)),M(u)||(u=1)}var d;d=\"log\"===e.type?{type:\"linear\",range:[s,l]}:{type:e.type,range:A.simpleMap([s,l],e.c2r,0,i),calendar:i},B.setConvert(d),B.autoTicks(d,u);var p,m=B.tickIncrement(B.tickFirst(d),d.dtick,\"reverse\",i);if(\"number\"==typeof d.dtick){m=a(m,t,d,s,l);p=m+(1+Math.floor((l-m)/d.dtick))*d.dtick}else for(\"M\"===d.dtick.charAt(0)&&(m=o(m,t,d.dtick,s,i)),p=m;p<=l;)p=B.tickIncrement(p,d.dtick,!1,i);return{start:e.c2r(m,0,i),end:e.c2r(p,0,i),size:d.dtick}},B.calcTicks=function(t){var e=A.simpleMap(t.range,t.r2l);if(\"auto\"===t.tickmode||!t.dtick){var r,n=t.nticks;n||(\"category\"===t.type?(r=t.tickfont?1.2*(t.tickfont.size||12):15,n=t._length/r):(r=\"y\"===t._id.charAt(0)?40:80,n=A.constrain(t._length/r,4,9)+1)),\"array\"===t.tickmode&&(n*=100),B.autoTicks(t,Math.abs(e[1]-e[0])/n),t._minDtick>0&&t.dtick<2*t._minDtick&&(t.dtick=t._minDtick,t.tick0=t.l2r(t._forceTick0))}if(t.tick0||(t.tick0=\"date\"===t.type?\"2000-01-01\":0),u(t),\"array\"===t.tickmode)return s(t);t._tmin=B.tickFirst(t);var i=e[1]<e[0],a=[],o=1.0001*e[1]-1e-4*e[0];\"category\"===t.type&&(o=i?Math.max(-.5,o):Math.min(t._categories.length-.5,o));for(var l=null,c=Math.max(1e3,t._length||0),h=t._tmin;(i?h>=o:h<=o)&&!(a.length>c||h===l);h=B.tickIncrement(h,t.dtick,i,t.calendar))l=h,a.push(h);t._tmax=a[a.length-1],t._prevDateHead=\"\",t._inCalcTicks=!0;for(var f=new Array(a.length),d=0;d<a.length;d++)f[d]=B.tickText(t,a[d]);return t._inCalcTicks=!1,f};var q=[2,5,10],G=[1,2,3,6,12],Y=[1,2,5,10,15,30],X=[1,2,3,7,14],W=[-.046,0,.301,.477,.602,.699,.778,.845,.903,.954,1],Z=[-.301,0,.301,.699,1];B.autoTicks=function(t,e){var r;if(\"date\"===t.type){t.tick0=A.dateTick0(t.calendar);var n=2*e;n>I?(e/=I,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=\"M\"+12*l(e,r,q)):n>D?(e/=D,t.dtick=\"M\"+l(e,1,G)):n>P?(t.dtick=l(e,P,X),t.tick0=A.dateTick0(t.calendar,!0)):n>O?t.dtick=l(e,O,G):n>R?t.dtick=l(e,R,Y):n>F?t.dtick=l(e,F,Y):(r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=l(e,r,q))}else if(\"log\"===t.type){t.tick0=0;var i=A.simpleMap(t.range,t.r2l);if(e>.7)t.dtick=Math.ceil(e);else if(Math.abs(i[1]-i[0])<1){var a=1.5*Math.abs((i[1]-i[0])/e);e=Math.abs(Math.pow(10,i[1])-Math.pow(10,i[0]))/a,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=\"L\"+l(e,r,q)}else t.dtick=e>.3?\"D2\":\"D1\"}else\"category\"===t.type?(t.tick0=0,t.dtick=Math.ceil(Math.max(e,1))):(t.tick0=0,r=Math.pow(10,Math.floor(Math.log(e)/Math.LN10)),t.dtick=l(e,r,q));if(0===t.dtick&&(t.dtick=1),!M(t.dtick)&&\"string\"!=typeof t.dtick){var o=t.dtick;throw t.dtick=1,\"ax.dtick error: \"+String(o)}},B.tickIncrement=function(t,e,r,n){var i=r?-1:1;if(M(e))return t+i*e;var a=e.charAt(0),o=i*Number(e.substr(1));if(\"M\"===a)return A.incrementMonth(t,o,n);if(\"L\"===a)return Math.log(Math.pow(10,t)+o)/Math.LN10;if(\"D\"===a){var s=\"D2\"===e?Z:W,l=t+.01*i,u=A.roundUp(A.mod(l,1),s,r);return Math.floor(l)+Math.log(w.round(Math.pow(10,u),1))/Math.LN10}throw\"unrecognized dtick \"+String(e)},B.tickFirst=function(t){var e=t.r2l||Number,r=A.simpleMap(t.range,e),n=r[1]<r[0],i=n?Math.floor:Math.ceil,a=1.0001*r[0]-1e-4*r[1],o=t.dtick,s=e(t.tick0);if(M(o)){var l=i((a-s)/o)*o+s;return\"category\"===t.type&&(l=A.constrain(l,0,t._categories.length-1)),l}var u=o.charAt(0),c=Number(o.substr(1));if(\"M\"===u){for(var h,f,d,p=0,m=s;p<10;){if(((h=B.tickIncrement(m,o,n,t.calendar))-a)*(m-a)<=0)return n?Math.min(m,h):Math.max(m,h);f=(a-(m+h)/2)/(h-m),d=u+(Math.abs(Math.round(f))||1)*c,m=B.tickIncrement(m,d,f<0?!n:n,t.calendar),p++}return A.error(\"tickFirst did not converge\",t),m}if(\"L\"===u)return Math.log(i((Math.pow(10,a)-s)/c)*c+s)/Math.LN10;if(\"D\"===u){var v=\"D2\"===o?Z:W,g=A.roundUp(A.mod(a,1),v,n);return Math.floor(a)+Math.log(w.round(Math.pow(10,g),1))/Math.LN10}throw\"unrecognized dtick \"+String(o)},B.tickText=function(t,e,r){function n(n){var i;return void 0===n||(r?\"none\"===n:(i={first:t._tmin,last:t._tmax}[n],\"all\"!==n&&e!==i))}var i,a,o=c(t,e),s=\"array\"===t.tickmode,l=r||s,u=\"category\"===t.type?t.d2l_noadd:t.d2l;if(s&&Array.isArray(t.ticktext)){var m=A.simpleMap(t.range,t.r2l),v=Math.abs(m[1]-m[0])/1e4;for(a=0;a<t.ticktext.length&&!(Math.abs(e-u(t.tickvals[a]))<v);a++);if(a<t.ticktext.length)return o.text=String(t.ticktext[a]),o}return i=r?\"never\":\"none\"!==t.exponentformat&&n(t.showexponent)?\"hide\":\"\",\"date\"===t.type?h(t,o,r,l):\"log\"===t.type?f(t,o,r,l,i):\"category\"===t.type?d(t,o):p(t,o,r,l,i),t.tickprefix&&!n(t.showtickprefix)&&(o.text=t.tickprefix+o.text),t.ticksuffix&&!n(t.showticksuffix)&&(o.text+=t.ticksuffix),o};var J=[\"f\",\"p\",\"n\",\"\\u03bc\",\"m\",\"\",\"k\",\"M\",\"G\",\"T\"];B.subplotMatch=/^x([0-9]*)y([0-9]*)$/,B.getSubplots=function(t,e){var r,n,i,a=[],o=t._fullData||t.data||[];for(r=0;r<o.length;r++){var s=o[r];if(!1!==s.visible&&\"legendonly\"!==s.visible&&(k.traceIs(s,\"cartesian\")||k.traceIs(s,\"gl2d\"))){i=(s.xaxis||\"x\")+(s.yaxis||\"y\"),-1===a.indexOf(i)&&a.push(i)}}var l=B.list(t,\"\",!0);for(r=0;r<l.length;r++){var u=l[r],c=u._id.charAt(0),h=\"free\"===u.anchor?\"x\"===c?\"y\":\"x\":u.anchor,f=B.getFromId(t,h),d=!1;for(n=0;n<a.length;n++)if(function(t,e){return-1!==t.indexOf(e._id)}(a[n],u)){d=!0;break}\"free\"===u.anchor&&d||f&&(i=\"x\"===c?u._id+f._id:f._id+u._id,-1===a.indexOf(i)&&a.push(i))}var p=B.subplotMatch,m=[];for(r=0;r<a.length;r++)i=a[r],p.test(i)&&m.push(i);return m.sort(function(t,e){var r=t.match(p),n=e.match(p);return r[1]===n[1]?+(r[2]||1)-(n[2]||1):+(r[1]||0)-(n[1]||0)}),e?B.findSubplotsWithAxis(m,e):m},B.findSubplotsWithAxis=function(t,e){for(var r=new RegExp(\"x\"===e._id.charAt(0)?\"^\"+e._id+\"y\":e._id+\"$\"),n=[],i=0;i<t.length;i++){var a=t[i];r.test(a)&&n.push(a)}return n},B.makeClipPaths=function(t){var e,r,n=t._fullLayout,i=n._defs,a={_offset:0,_length:n.width,_id:\"\"},o={_offset:0,_length:n.height,_id:\"\"},s=B.list(t,\"x\",!0),l=B.list(t,\"y\",!0),u=[];for(e=0;e<s.length;e++)for(u.push({x:s[e],y:o}),r=0;r<l.length;r++)0===e&&u.push({x:a,y:l[r]}),u.push({x:s[e],y:l[r]});var c=i.selectAll(\"g.clips\").data([0]);c.enter().append(\"g\").classed(\"clips\",!0);var h=c.selectAll(\".axesclip\").data(u,function(t){return t.x._id+t.y._id});h.enter().append(\"clipPath\").classed(\"axesclip\",!0).attr(\"id\",function(t){return\"clip\"+n._uid+t.x._id+t.y._id}).append(\"rect\"),h.exit().remove(),h.each(function(t){w.select(this).select(\"rect\").attr({x:t.x._offset||0,y:t.y._offset||0,width:t.x._length||1,height:t.y._length||1})})},B.doTicks=function(t,e,r){function n(t){var e=u.l2p(t.x);return e>1&&e<u._length-1}function i(t,e){var r=t.selectAll(\"path.\"+_).data(\"inside\"===u.ticks?q:b,x);e&&u.ticks?(r.enter().append(\"path\").classed(_,1).classed(\"ticks\",1).classed(\"crisp\",1).call(E.stroke,u.tickcolor).style(\"stroke-width\",F+\"px\").attr(\"d\",e),r.attr(\"transform\",d),r.exit().remove()):r.remove()}function a(r,n){function i(t,e){t.each(function(t){var r=y(e),n=w.select(this),i=n.select(\".text-math-group\"),a=d(t)+(M(e)&&0!=+e?\" rotate(\"+e+\",\"+f(t)+\",\"+(p(t)-t.fontSize/2)+\")\":\"\");if(i.empty())n.select(\"text\").attr({transform:a,\"text-anchor\":r});else{var o=L.bBox(i.node()).width*{end:-.5,start:.5}[r];i.attr(\"transform\",a+(o?\"translate(\"+o+\",0)\":\"\"))}})}function a(){return z.length&&Promise.all(z)}function s(){if(i(h,u.tickangle),\"x\"===g&&!M(u.tickangle)&&(\"log\"!==u.type||\"D\"!==String(u.dtick).charAt(0))){var t=[];for(h.each(function(e){var r=w.select(this),n=r.select(\".text-math-group\"),i=u.l2p(e.x);n.empty()&&(n=r.select(\"text\"));var a=L.bBox(n.node());t.push({top:0,bottom:10,height:10,left:i-a.width/2,right:i+a.width/2+2,width:a.width+2})}),v=0;v<t.length-1;v++)if(A.bBoxIntersect(t[v],t[v+1])){C=30;break}if(C){Math.abs((b[b.length-1].x-b[0].x)*u._m)/(b.length-1)<2.5*E&&(C=90),i(h,C)}u._lastangle=C}return o(),e+\" done\"}function l(){function e(t,e){t[0]=Math.min(t[0],e[0]),t[1]=Math.max(t[1],e[1])}var n=r.node().getBoundingClientRect(),i=t.getBoundingClientRect();if(u._boundingBox={width:n.width,height:n.height,left:n.left-i.left,right:n.right-i.left,top:n.top-i.top,bottom:n.bottom-i.top},m){var a=u._counterSpan=[1/0,-1/0];for(v=0;v<m.length;v++){var o=c._plots[m[v]],s=o[\"x\"===g?\"yaxis\":\"xaxis\"];e(a,[s._offset,s._offset+s._length])}\"free\"===u.anchor&&e(a,\"x\"===g?[u._boundingBox.bottom,u._boundingBox.top]:[u._boundingBox.right,u._boundingBox.left])}}var h=r.selectAll(\"g.\"+_).data(b,x);if(!u.showticklabels||!M(n))return h.remove(),void o();var f,p,y,k,S;\"x\"===g?(S=\"bottom\"===U?1:-1,f=function(t){return t.dx+P*S},k=n+(D+I)*S,p=function(t){return t.dy+k+t.fontSize*(\"bottom\"===U?1:-.2)},y=function(t){return M(t)&&0!==t&&180!==t?t*S<0?\"end\":\"start\":\"middle\"}):(S=\"right\"===U?1:-1,p=function(t){return t.dy+t.fontSize*N-P*S},f=function(t){return t.dx+n+(D+I+(90===Math.abs(u.tickangle)?t.fontSize/2:0))*S},y=function(t){return M(t)&&90===Math.abs(t)?\"middle\":\"right\"===U?\"start\":\"end\"});var E=0,C=0,z=[];h.enter().append(\"g\").classed(_,1).append(\"text\").attr(\"text-anchor\",\"middle\").each(function(e){var r=w.select(this),n=t._promises.length;r.call(T.positionText,f(e),p(e)).call(L.font,e.font,e.fontSize,e.fontColor).text(e.text).call(T.convertToTspans,t),n=t._promises[n],n?z.push(t._promises.pop().then(function(){i(r,u.tickangle)})):i(r,u.tickangle)}),h.exit().remove(),h.each(function(t){E=Math.max(E,t.fontSize)}),i(h,u._lastangle||u.tickangle);var O=A.syncOrAsync([a,s,l]);return O&&O.then&&t._promises.push(O),O}function o(){if(!r){var n,i,a,o,s=V.getFromId(t,e),l=w.select(t).selectAll(\"g.\"+e+\"tick\"),u={selection:l,side:s.side},h=e.charAt(0),f=t._fullLayout._size,d=s.titlefont.size;if(l.size()){var p=L.getTranslate(l.node().parentNode);u.offsetLeft=p.x,u.offsetTop=p.y}var m=10+1.5*d+(s.linewidth?s.linewidth-1:0);\"x\"===h?(i=\"free\"===s.anchor?{_offset:f.t+(1-(s.position||0))*f.h,_length:0}:V.getFromId(t,s.anchor),a=s._offset+s._length/2,o=\"top\"===s.side?-m-d*(s.showticklabels?1:0):i._length+m+d*(s.showticklabels?1.5:.5),o+=i._offset,s.rangeslider&&s.rangeslider.visible&&s._boundingBox&&(o+=(c.height-c.margin.b-c.margin.t)*s.rangeslider.thickness+s._boundingBox.height),u.side||(u.side=\"bottom\")):(i=\"free\"===s.anchor?{_offset:f.l+(s.position||0)*f.w,_length:0}:V.getFromId(t,s.anchor),o=s._offset+s._length/2,a=\"right\"===s.side?i._length+m+d*(s.showticklabels?1:.5):-m-d*(s.showticklabels?.5:0),a+=i._offset,n={rotate:\"-90\",offset:0},u.side||(u.side=\"left\")),S.draw(t,e+\"title\",{propContainer:s,propName:s._name+\".title\",dfltName:h.toUpperCase()+\" axis\",avoid:u,transform:n,attributes:{x:a,y:o,\"text-anchor\":\"middle\"}})}}function s(t,e){return!0===t.visible&&t.xaxis+t.yaxis===e&&(!(!k.traceIs(t,\"bar\")||t.orientation!=={x:\"h\",y:\"v\"}[g])||t.fill&&t.fill.charAt(t.fill.length-1)===g)}function l(e,r,i){var a=e.gridlayer,o=e.zerolinelayer,l=e[\"hidegrid\"+g]?[]:q,c=u._gridpath||\"M0,0\"+(\"x\"===g?\"v\":\"h\")+r._length,h=a.selectAll(\"path.\"+C).data(!1===u.showgrid?[]:l,x);if(h.enter().append(\"path\").classed(C,1).classed(\"crisp\",1).attr(\"d\",c).each(function(t){u.zeroline&&(\"linear\"===u.type||\"-\"===u.type)&&Math.abs(t.x)<u.dtick/100&&w.select(this).remove()}),h.attr(\"transform\",d).call(E.stroke,u.gridcolor||\"#ddd\").style(\"stroke-width\",O+\"px\"),h.exit().remove(),o){for(var f=!1,p=0;p<t._fullData.length;p++)if(s(t._fullData[p],i)){f=!0;break}var m=A.simpleMap(u.range,u.r2l),v=m[0]*m[1]<=0&&u.zeroline&&(\"linear\"===u.type||\"-\"===u.type)&&l.length&&(f||n({x:0})||!u.showline),y=o.selectAll(\"path.\"+z).data(v?[{x:0}]:[]);y.enter().append(\"path\").classed(z,1).classed(\"zl\",1).classed(\"crisp\",1).attr(\"d\",c),y.attr(\"transform\",d).call(E.stroke,u.zerolinecolor||E.defaultLine).style(\"stroke-width\",R+\"px\"),y.exit().remove()}}var u,c=t._fullLayout,h=!1;if(\"object\"==typeof e)u=e,e=u._id,h=!0;else if(u=B.getFromId(t,e),\"redraw\"===e&&c._paper.selectAll(\"g.subplot\").each(function(t){var e=c._plots[t],r=e.xaxis,n=e.yaxis;e.xaxislayer.selectAll(\".\"+r._id+\"tick\").remove(),e.yaxislayer.selectAll(\".\"+n._id+\"tick\").remove(),e.gridlayer.selectAll(\"path\").remove(),e.zerolinelayer.selectAll(\"path\").remove()}),!e||\"redraw\"===e)return A.syncOrAsync(B.list(t,\"\",!0).map(function(r){return function(){if(r._id){var n=B.doTicks(t,r._id);return\"redraw\"===e&&(r._r=r.range.slice(),r._rl=A.simpleMap(r._r,r.r2l)),n}}}));u.tickformat||(-1===[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"].indexOf(u.exponentformat)&&(u.exponentformat=\"e\"),-1===[\"all\",\"first\",\"last\",\"none\"].indexOf(u.showexponent)&&(u.showexponent=\"all\")),u.setScale();var f,d,p,m,v,g=e.charAt(0),y=B.counterLetter(e),b=B.calcTicks(u),x=function(t){return[t.text,t.x,u.mirror].join(\"_\")},_=e+\"tick\",C=e+\"grid\",z=e+\"zl\",I=(u.linewidth||1)/2,D=\"outside\"===u.ticks?u.ticklen:0,P=0,O=L.crispRound(t,u.gridwidth,1),R=L.crispRound(t,u.zerolinewidth,O),F=L.crispRound(t,u.tickwidth,1);if(u._counterangle&&\"outside\"===u.ticks){var j=u._counterangle*Math.PI/180;D=u.ticklen*Math.cos(j)+1,P=u.ticklen*Math.sin(j)}if(u.showticklabels&&(\"outside\"===u.ticks||u.showline)&&(D+=.2*u.tickfont.size),\"x\"===g)f=[\"bottom\",\"top\"],d=function(t){return\"translate(\"+u.l2p(t.x)+\",0)\"},p=function(t,e){if(u._counterangle){var r=u._counterangle*Math.PI/180;return\"M0,\"+t+\"l\"+Math.sin(r)*e+\",\"+Math.cos(r)*e}return\"M0,\"+t+\"v\"+e};else{if(\"y\"!==g)return void A.warn(\"Unrecognized doTicks axis:\",e);f=[\"left\",\"right\"],d=function(t){return\"translate(0,\"+u.l2p(t.x)+\")\"},p=function(t,e){if(u._counterangle){var r=u._counterangle*Math.PI/180;return\"M\"+t+\",0l\"+Math.cos(r)*e+\",\"+-Math.sin(r)*e}return\"M\"+t+\",0h\"+e}}var U=u.side||f[0],H=[-1,1,U===f[1]?1:-1];if(\"inside\"!==u.ticks==(\"x\"===g)&&(H=H.map(function(t){return-t})),u.visible){var q=b.filter(n);if(h){if(i(u._axislayer,p(u._pos+I*H[2],H[2]*u.ticklen)),u._counteraxis){l({gridlayer:u._gridlayer,zerolinelayer:u._zerolinelayer},u._counteraxis)}return a(u._axislayer,u._pos)}m=B.getSubplots(t,u);var G=m.map(function(t){var e=c._plots[t];if(c._has(\"cartesian\")){var r=e[g+\"axislayer\"],n=u._linepositions[t]||[],o=e[y+\"axis\"],s=o._id===u.anchor,h=[!1,!1,!1],d=\"\"\n",
       ";if(\"allticks\"===u.mirror?h=[!0,!0,!1]:s&&(\"ticks\"===u.mirror?h=[!0,!0,!1]:h[f.indexOf(U)]=!0),u.mirrors)for(v=0;v<2;v++){var m=u.mirrors[o._id+f[v]];\"ticks\"!==m&&\"labels\"!==m||(h[v]=!0)}return void 0!==n[2]&&(h[2]=!0),h.forEach(function(t,e){var r=n[e],i=H[e];t&&M(r)&&(d+=p(r+I*i,i*u.ticklen))}),i(r,d),l(e,o,t),a(r,n[3])}}).filter(function(t){return t&&t.then});return G.length?Promise.all(G):0}},B.swap=function(t,e){for(var r=y(t,e),n=0;n<r.length;n++)x(t,r[n].x,r[n].y)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/titles\":692,\"../../constants/alignment\":699,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../registry\":844,\"./axis_autotype\":767,\"./axis_ids\":769,\"./layout_attributes\":777,\"./layout_defaults\":778,\"./set_convert\":783,d3:121,\"fast-isnumeric\":130}],767:[function(t,e,r){\"use strict\";function n(t){if(!t)return!1;for(var e=0;e<t.length;e++)if(o(t[e]))return!0;return!1}function i(t,e){for(var r,n=0,i=0,a=Math.max(1,(t.length-1)/1e3),l=0;l<t.length;l+=a)r=t[Math.round(l)],s.isDateTime(r,e)&&(n+=1),o(r)&&(i+=1);return n>2*i}function a(t){for(var e,r=Math.max(1,(t.length-1)/1e3),n=0,i=0,a=0;a<t.length;a+=r)e=t[Math.round(a)],s.cleanNumber(e)!==l?n++:\"string\"==typeof e&&\"\"!==e&&\"None\"!==e&&i++;return i>2*n}var o=t(\"fast-isnumeric\"),s=t(\"../../lib\"),l=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e){return i(t,e)?\"date\":a(t)?\"category\":n(t)?\"linear\":\"-\"}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],768:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../../components/color/attributes\").lightFraction,s=t(\"./layout_attributes\"),l=t(\"./tick_value_defaults\"),u=t(\"./tick_mark_defaults\"),c=t(\"./tick_label_defaults\"),h=t(\"./category_order_defaults\"),f=t(\"./set_convert\"),d=t(\"./ordered_categories\");e.exports=function(t,e,r,p,m){function v(r,n){return a.coerce2(t,e,s,r,n)}var g=p.letter,y=p.font||{},b=\"Click to enter \"+(p.title||g.toUpperCase()+\" axis\")+\" title\",x=r(\"visible\",!p.cheateronly),_=e.type;if(\"date\"===_){i.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\",p.calendar)}if(f(e,m),r(\"autorange\",!e.isValidRange(t.range))&&r(\"rangemode\"),r(\"range\"),e.cleanRange(),h(t,e,r),e._initialCategories=\"category\"===_?d(g,e.categoryorder,e.categoryarray,p.data):[],!x)return e;var w=r(\"color\"),M=w===t.color?w:y.color;r(\"title\",b),a.coerceFont(r,\"titlefont\",{family:y.family,size:Math.round(1.2*y.size),color:M}),l(t,e,r,_),c(t,e,r,_,p),u(t,e,r,p);var k=v(\"linecolor\",w),A=v(\"linewidth\"),T=r(\"showline\",!!k||!!A);T||(delete e.linecolor,delete e.linewidth),(T||e.ticks)&&r(\"mirror\");var S=v(\"gridcolor\",n(w,p.bgColor,o).toRgbString()),E=v(\"gridwidth\");r(\"showgrid\",p.showGrid||!!S||!!E)||(delete e.gridcolor,delete e.gridwidth);var L=v(\"zerolinecolor\",w),C=v(\"zerolinewidth\");return r(\"zeroline\",p.showGrid||!!L||!!C)||(delete e.zerolinecolor,delete e.zerolinewidth),e}},{\"../../components/color/attributes\":602,\"../../lib\":725,\"../../registry\":844,\"./category_order_defaults\":770,\"./layout_attributes\":777,\"./ordered_categories\":779,\"./set_convert\":783,\"./tick_label_defaults\":784,\"./tick_mark_defaults\":785,\"./tick_value_defaults\":786,tinycolor2:533}],769:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,r){for(var n=Object.keys(t),i=/^[xyz]axis[0-9]*/,a=[],o=0;o<n.length;o++){var s=n[o];e&&s.charAt(0)!==e||i.test(s)&&a.push(r+s)}return a.sort()}var i=t._fullLayout;if(!i)return[];var o=n(i,\"\");if(r)return o;for(var s=a.getSubplotIds(i,\"gl3d\")||[],l=0;l<s.length;l++){var u=s[l];o=o.concat(n(i[u],u+\".\"))}return o}var i=t(\"../../registry\"),a=t(\"../plots\"),o=t(\"../../lib\"),s=t(\"./constants\");r.id2name=function(t){if(\"string\"==typeof t&&t.match(s.AX_ID_PATTERN)){var e=t.substr(1);return\"1\"===e&&(e=\"\"),t.charAt(0)+\"axis\"+e}},r.name2id=function(t){if(t.match(s.AX_NAME_PATTERN)){var e=t.substr(5);return\"1\"===e&&(e=\"\"),t.charAt(0)+e}},r.cleanId=function(t,e){if(t.match(s.AX_ID_PATTERN)&&(!e||t.charAt(0)===e)){var r=t.substr(1).replace(/^0+/,\"\");return\"1\"===r&&(r=\"\"),t.charAt(0)+r}},r.list=function(t,e,r){return n(t,e,r).map(function(e){return o.nestedProperty(t._fullLayout,e).get()})},r.listIds=function(t,e){return n(t,e,!0).map(r.name2id)},r.getFromId=function(t,e,n){var i=t._fullLayout;return\"x\"===n?e=e.replace(/y[0-9]*/,\"\"):\"y\"===n&&(e=e.replace(/x[0-9]*/,\"\")),i[r.id2name(e)]},r.getFromTrace=function(t,e,n){var a=t._fullLayout,o=null;if(i.traceIs(e,\"gl3d\")){var s=e.scene;\"scene\"===s.substr(0,5)&&(o=a[s][n+\"axis\"])}else o=r.getFromId(t,e[n+\"axis\"]||n);return o}},{\"../../lib\":725,\"../../registry\":844,\"../plots\":829,\"./constants\":771}],770:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){if(\"category\"===e.type){var n,i=t.categoryarray,a=Array.isArray(i)&&i.length>0;a&&(n=\"array\");var o=r(\"categoryorder\",n);\"array\"===o&&r(\"categoryarray\"),a||\"array\"!==o||(e.categoryorder=\"trace\")}}},{}],771:[function(t,e,r){\"use strict\";e.exports={idRegex:{x:/^x([2-9]|[1-9][0-9]+)?$/,y:/^y([2-9]|[1-9][0-9]+)?$/},attrRegex:{x:/^xaxis([2-9]|[1-9][0-9]+)?$/,y:/^yaxis([2-9]|[1-9][0-9]+)?$/},xAxisMatch:/^xaxis[0-9]*$/,yAxisMatch:/^yaxis[0-9]*$/,AX_ID_PATTERN:/^[xyz][0-9]*$/,AX_NAME_PATTERN:/^[xyz]axis[0-9]*$/,MINDRAG:8,MINSELECT:12,MINZOOM:20,DRAGGERSIZE:20,BENDPX:1.5,REDRAWDELAY:50,DFLTRANGEX:[-1,6],DFLTRANGEY:[-1,4],traceLayerClasses:[\"imagelayer\",\"maplayer\",\"barlayer\",\"carpetlayer\",\"boxlayer\",\"scatterlayer\"],layerValue2layerClass:{\"above traces\":\"above\",\"below traces\":\"below\"}}},{}],772:[function(t,e,r){\"use strict\";function n(t,e,r,n){var i,a,s,l,u=n[o(e)].type,c=[];for(a=0;a<r.length;a++)(s=r[a])!==e&&(l=n[o(s)],l.type!==u||l.fixedrange||c.push(s));for(i=0;i<t.length;i++)if(t[i][e]){var h=t[i],f=[];for(a=0;a<c.length;a++)s=c[a],h[s]||f.push(s);return{linkableAxes:f,thisGroup:h}}return{linkableAxes:c,thisGroup:null}}function i(t,e,r,n,i){var a,o,s,l,u;null===e?(e={},e[r]=1,u=t.length,t.push(e)):u=t.indexOf(e);var c=Object.keys(e);for(a=0;a<t.length;a++)if(s=t[a],a!==u&&s[n]){var h=s[n];for(o=0;o<c.length;o++)l=c[o],s[l]=h*i*e[l];return void t.splice(u,1)}if(1!==i)for(o=0;o<c.length;o++)e[c[o]]*=i;e[n]=1}var a=t(\"../../lib\"),o=t(\"./axis_ids\").id2name;e.exports=function(t,e,r,o,s){var l=s._axisConstraintGroups,u=e._id,c=u.charAt(0);if(!e.fixedrange&&(r(\"constrain\"),a.coerce(t,e,{constraintoward:{valType:\"enumerated\",values:\"x\"===c?[\"left\",\"center\",\"right\"]:[\"bottom\",\"middle\",\"top\"],dflt:\"x\"===c?\"center\":\"middle\"}},\"constraintoward\"),t.scaleanchor)){var h=n(l,u,o,s),f=a.coerce(t,e,{scaleanchor:{valType:\"enumerated\",values:h.linkableAxes}},\"scaleanchor\");if(f){var d=r(\"scaleratio\");d||(d=e.scaleratio=1),i(l,h.thisGroup,u,f,d)}else-1!==o.indexOf(t.scaleanchor)&&a.warn(\"ignored \"+e._name+'.scaleanchor: \"'+t.scaleanchor+'\" to avoid either an infinite loop and possibly inconsistent scaleratios, or because the targetaxis has fixed range.')}}},{\"../../lib\":725,\"./axis_ids\":769}],773:[function(t,e,r){\"use strict\";function n(t,e){var r=t._inputDomain,n=s[t.constraintoward],i=r[0]+(r[1]-r[0])*n;t.domain=t._input.domain=[i+(r[0]-i)/e,i+(r[1]-i)/e]}var i=t(\"./axis_ids\").id2name,a=t(\"./scale_zoom\"),o=t(\"../../constants/numerical\").ALMOST_EQUAL,s=t(\"../../constants/alignment\").FROM_BL;r.enforce=function(t){var e,r,s,l,u,c,h,f=t._fullLayout,d=f._axisConstraintGroups;for(e=0;e<d.length;e++){var p=d[e],m=Object.keys(p),v=1/0,g=0,y=1/0,b={},x={},_=!1;for(r=0;r<m.length;r++)s=m[r],x[s]=l=f[i(s)],l._inputDomain?l.domain=l._inputDomain.slice():l._inputDomain=l.domain.slice(),l._inputRange||(l._inputRange=l.range.slice()),l.setScale(),b[s]=u=Math.abs(l._m)/p[s],v=Math.min(v,u),\"domain\"!==l.constrain&&l._constraintShrinkable||(y=Math.min(y,u)),delete l._constraintShrinkable,g=Math.max(g,u),\"domain\"===l.constrain&&(_=!0);if(!(v>o*g)||_)for(r=0;r<m.length;r++)if(s=m[r],u=b[s],l=x[s],c=l.constrain,u!==y||\"domain\"===c)if(h=u/y,\"range\"===c)a(l,h);else{var w=l._inputDomain,M=(l.domain[1]-l.domain[0])/(w[1]-w[0]),k=(l.r2l(l.range[1])-l.r2l(l.range[0]))/(l.r2l(l._inputRange[1])-l.r2l(l._inputRange[0]));if((h/=M)*k<1){l.domain=l._input.domain=w.slice(),a(l,h);continue}if(k<1&&(l.range=l._input.range=l._inputRange.slice(),h*=k),l.autorange&&l._min.length&&l._max.length){var A=l.r2l(l.range[0]),T=l.r2l(l.range[1]),S=(A+T)/2,E=S,L=S,C=Math.abs(T-S),z=S-C*h*1.0001,I=S+C*h*1.0001;n(l,h),l.setScale();var D,P,O=Math.abs(l._m);for(P=0;P<l._min.length;P++)(D=l._min[P].val-l._min[P].pad/O)>z&&D<E&&(E=D);for(P=0;P<l._max.length;P++)(D=l._max[P].val+l._max[P].pad/O)<I&&D>L&&(L=D);var R=(L-E)/(2*C);h/=R,E=l.l2r(E),L=l.l2r(L),l.range=l._input.range=A<T?[E,L]:[L,E]}n(l,h)}}},r.clean=function(t,e){if(e._inputDomain){for(var r=!1,n=e._id,i=t._fullLayout._axisConstraintGroups,a=0;a<i.length;a++)if(i[a][n]){r=!0;break}r&&\"domain\"===e.constrain||(e._input.domain=e.domain=e._inputDomain,delete e._inputDomain)}}},{\"../../constants/alignment\":699,\"../../constants/numerical\":705,\"./axis_ids\":769,\"./scale_zoom\":781}],774:[function(t,e,r){\"use strict\";function n(t,e,r,n,i,a,o){var s=t.draglayer.selectAll(\".\"+e).data([0]);return s.enter().append(\"rect\").classed(\"drag\",!0).classed(e,!0).style({fill:\"transparent\",\"stroke-width\":0}).attr(\"data-subplot\",t.id),s.call(S.setRect,n,i,a,o).call(E,r),s.node()}function i(t,e){for(var r=0;r<t.length;r++)if(!t[r].fixedrange)return e;return\"\"}function a(t,e){var r,n=t.range[e],i=Math.abs(n-t.range[1-e]);return\"date\"===t.type?n:\"log\"===t.type?(r=Math.ceil(Math.max(0,-Math.log(i)/Math.LN10))+3,x.format(\".\"+r+\"g\")(Math.pow(10,n))):(r=Math.floor(Math.log(Math.abs(n))/Math.LN10)-Math.floor(Math.log(i)/Math.LN10)+4,x.format(\".\"+String(r)+\"g\")(n))}function o(t,e,r,n,i){var a,s,l,u;for(a=0;a<t.length;a++)s=t[a],s.fixedrange||(l=s._rl[0],u=s._rl[1]-l,s.range=[s.l2r(l+u*e),s.l2r(l+u*r)],n[s._name+\".range[0]\"]=s.range[0],n[s._name+\".range[1]\"]=s.range[1]);if(i&&i.length){var c=(e+(1-r))/2;o(i,c,1-c,n)}}function s(t,e){for(var r=0;r<t.length;r++){var n=t[r];n.fixedrange||(n.range=[n.l2r(n._rl[0]-e/n._m),n.l2r(n._rl[1]-e/n._m)])}}function l(t){return 1-(t>=0?Math.min(t,.9):1/(1/Math.max(t,-.3)+3.222))}function u(t,e){return t?\"nsew\"===t?\"pan\"===e?\"move\":\"crosshair\":t.toLowerCase()+\"-resize\":\"pointer\"}function c(t,e,r,n,i){return t.append(\"path\").attr(\"class\",\"zoombox\").style({fill:e>.2?\"rgba(0,0,0,0)\":\"rgba(255,255,255,0)\",\"stroke-width\":0}).attr(\"transform\",\"translate(\"+r+\", \"+n+\")\").attr(\"d\",i+\"Z\")}function h(t,e,r){return t.append(\"path\").attr(\"class\",\"zoombox-corners\").style({fill:T.background,stroke:T.defaultLine,\"stroke-width\":1,opacity:0}).attr(\"transform\",\"translate(\"+e+\", \"+r+\")\").attr(\"d\",\"M0,0Z\")}function f(t){t.selectAll(\".select-outline\").remove()}function d(t,e,r,n,i,a){t.attr(\"d\",n+\"M\"+r.l+\",\"+r.t+\"v\"+r.h+\"h\"+r.w+\"v-\"+r.h+\"h-\"+r.w+\"Z\"),i||(t.transition().style(\"fill\",a>.2?\"rgba(0,0,0,0.4)\":\"rgba(255,255,255,0.3)\").duration(200),e.transition().style(\"opacity\",1).duration(200))}function p(t){x.select(t).selectAll(\".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners\").remove()}function m(t){return-1!==[\"lasso\",\"select\"].indexOf(t)}function v(t,e){return\"M\"+(t.l-.5)+\",\"+(e-j-.5)+\"h-3v\"+(2*j+1)+\"h3ZM\"+(t.r+.5)+\",\"+(e-j-.5)+\"h3v\"+(2*j+1)+\"h-3Z\"}function g(t,e){return\"M\"+(e-j-.5)+\",\"+(t.t-.5)+\"v-3h\"+(2*j+1)+\"v3ZM\"+(e-j-.5)+\",\"+(t.b+.5)+\"v3h\"+(2*j+1)+\"v-3Z\"}function y(t){var e=Math.floor(Math.min(t.b-t.t,t.r-t.l,j)/2);return\"M\"+(t.l-3.5)+\",\"+(t.t-.5+e)+\"h3v\"+-e+\"h\"+e+\"v-3h-\"+(e+3)+\"ZM\"+(t.r+3.5)+\",\"+(t.t-.5+e)+\"h-3v\"+-e+\"h\"+-e+\"v-3h\"+(e+3)+\"ZM\"+(t.r+3.5)+\",\"+(t.b+.5-e)+\"h-3v\"+e+\"h\"+-e+\"v3h\"+(e+3)+\"ZM\"+(t.l-3.5)+\",\"+(t.b+.5-e)+\"h3v\"+e+\"h\"+e+\"v3h-\"+(e+3)+\"Z\"}function b(t,e,r){var n,i,a,o,s,l,u=!1,c={},h={};for(n=0;n<t.length;n++){for(o=t[n],i=0;i<e.length;i++)if(o[e[i]]){for(s in o)-1===(\"x\"===s.charAt(0)?e:r).indexOf(s)&&(c[s]=1);for(a=0;a<r.length;a++)o[r[a]]&&(u=!0)}for(i=0;i<r.length;i++)if(o[r[i]])for(l in o)-1===(\"x\"===l.charAt(0)?e:r).indexOf(l)&&(h[l]=1)}return u&&(k.extendFlat(c,h),h={}),{x:c,y:h,xy:u}}var x=t(\"d3\"),_=t(\"tinycolor2\"),w=t(\"../../plotly\"),M=t(\"../../registry\"),k=t(\"../../lib\"),A=t(\"../../lib/svg_text_utils\"),T=t(\"../../components/color\"),S=t(\"../../components/drawing\"),E=t(\"../../lib/setcursor\"),L=t(\"../../components/dragelement\"),C=t(\"../../constants/alignment\").FROM_TL,z=t(\"../plots\"),I=t(\"./axes\").doTicks,D=t(\"./axis_ids\").getFromId,P=t(\"./select\"),O=t(\"./scale_zoom\"),R=t(\"./constants\"),F=R.MINDRAG,j=R.MINZOOM,N=!0;e.exports=function(t,e,r,T,E,B,U,V){function H(){et=[e.xaxis],rt=[e.yaxis];var r=et[0],n=rt[0];at=r._length,ot=n._length;var a=dt._axisConstraintGroups,o=[r._id],s=[n._id];tt=[e].concat(U&&V?e.overlays:[]);for(var l=1;l<tt.length;l++){var c=tt[l].xaxis,h=tt[l].yaxis;-1===et.indexOf(c)&&(et.push(c),o.push(c._id)),-1===rt.indexOf(h)&&(rt.push(h),s.push(h._id))}st=i(et,V),lt=i(rt,U),ut=u(lt+st,dt.dragmode),nt=r._offset,it=n._offset;var f=b(a,o,s);ct=f.xy,ht=[];for(var d in f.x)ht.push(D(t,d));ft=[];for(var p in f.y)ft.push(D(t,p))}function q(e,r,n){var i=vt.getBoundingClientRect();yt=r-i.left,bt=n-i.top,xt={l:yt,r:yt,w:0,t:bt,b:bt,h:0},_t=t._hmpixcount?t._hmlumcount/t._hmpixcount:_(t._fullLayout.plot_bgcolor).getLuminance(),wt=\"M0,0H\"+at+\"V\"+ot+\"H0V0\",Mt=!1,kt=\"xy\",At=c(pt,_t,nt,it,wt),Tt=h(pt,nt,it),f(pt)}function G(e,r){function n(){kt=\"\",xt.r=xt.l,xt.t=xt.b,Tt.attr(\"d\",\"M0,0Z\")}if(t._transitioningWithDuration)return!1;var i=Math.max(0,Math.min(at,e+yt)),a=Math.max(0,Math.min(ot,r+bt)),o=Math.abs(i-yt),s=Math.abs(a-bt);xt.l=Math.min(yt,i),xt.r=Math.max(yt,i),xt.t=Math.min(bt,a),xt.b=Math.max(bt,a),ct?o>j||s>j?(kt=\"xy\",o/at>s/ot?(s=o*ot/at,bt>a?xt.t=bt-s:xt.b=bt+s):(o=s*at/ot,yt>i?xt.l=yt-o:xt.r=yt+o),Tt.attr(\"d\",y(xt))):n():!lt||s<Math.min(Math.max(.6*o,F),j)?o<F?n():(xt.t=0,xt.b=ot,kt=\"x\",Tt.attr(\"d\",v(xt,bt))):!st||o<Math.min(.6*s,j)?(xt.l=0,xt.r=at,kt=\"y\",Tt.attr(\"d\",g(xt,yt))):(kt=\"xy\",Tt.attr(\"d\",y(xt))),xt.w=xt.r-xt.l,xt.h=xt.b-xt.t,d(At,Tt,xt,wt,Mt,_t),Mt=!0}function Y(e,r){if(Math.min(xt.h,xt.w)<2*F)return 2===r&&K(),p(t);\"xy\"!==kt&&\"x\"!==kt||o(et,xt.l/at,xt.r/at,St,ht),\"xy\"!==kt&&\"y\"!==kt||o(rt,(ot-xt.b)/ot,(ot-xt.t)/ot,St,ft),p(t),Q(kt),N&&t.data&&t._context.showTips&&(k.notifier(\"Double-click to<br>zoom back out\",\"long\"),N=!1)}function X(e,r){var n=1===(U+V).length;if(e)Q();else if(2!==r||n){if(1===r&&n){var i=U?rt[0]:et[0],o=\"s\"===U||\"w\"===V?0:1,s=i._name+\".range[\"+o+\"]\",l=a(i,o),u=\"left\",c=\"middle\";if(i.fixedrange)return;U?(c=\"n\"===U?\"top\":\"bottom\",\"right\"===i.side&&(u=\"right\")):\"e\"===V&&(u=\"right\"),t._context.showAxisRangeEntryBoxes&&x.select(vt).call(A.makeEditable,{gd:t,immediate:!0,background:dt.paper_bgcolor,text:String(l),fill:i.tickfont?i.tickfont.color:\"#444\",horizontalAlign:u,verticalAlign:c}).on(\"edit\",function(e){var r=i.d2r(e);void 0!==r&&w.relayout(t,s,r)})}}else K()}function W(e){function r(t,e,r){function n(e){return t.l2r(a+(e-a)*r)}if(!t.fixedrange){var i=k.simpleMap(t.range,t.r2l),a=i[0]+(i[1]-i[0])*e;t.range=i.map(n)}}if(t._context.scrollZoom||dt._enablescrollzoom){if(t._transitioningWithDuration)return k.pauseEvent(e);var n=t.querySelector(\".plotly\");if(H(),!(n.scrollHeight-n.clientHeight>10||n.scrollWidth-n.clientWidth>10)){clearTimeout(Lt);var i=-e.deltaY;if(isFinite(i)||(i=e.wheelDelta/10),!isFinite(i))return void k.log(\"Did not find wheel motion attributes: \",e);var a,o=Math.exp(-Math.min(Math.max(i,-20),20)/100),s=zt.draglayer.select(\".nsewdrag\").node().getBoundingClientRect(),l=(e.clientX-s.left)/s.width,u=(s.bottom-e.clientY)/s.height;if(V||ct){for(V||(l=.5),a=0;a<et.length;a++)r(et[a],l,o);Et[2]*=o,Et[0]+=Et[2]*l*(1/o-1)}if(U||ct){for(U||(u=.5),a=0;a<rt.length;a++)r(rt[a],u,o);Et[3]*=o,Et[1]+=Et[3]*(1-u)*(1/o-1)}return $(Et),J(U,V),Lt=setTimeout(function(){Et=[0,0,at,ot];var t;t=ct?\"xy\":(V?\"x\":\"\")+(U?\"y\":\"\"),Q(t)},Ct),k.pauseEvent(e)}}}function Z(e,r){function n(t,e,r){for(var n,i,a=1-e,o=0;o<t.length;o++){var s=t[o];if(!s.fixedrange){n=s,i=s._rl[a]+(s._rl[e]-s._rl[a])/l(r/s._length);var u=s.l2r(i);!1!==u&&void 0!==u&&(s.range[e]=u)}}return n._length*(n._rl[e]-i)/(n._rl[e]-n._rl[a])}if(!t._transitioningWithDuration){if(H(),\"ew\"===st||\"ns\"===lt)return st&&s(et,e),lt&&s(rt,r),$([st?-e:0,lt?-r:0,at,ot]),void J(lt,st);if(ct&&st&&lt){var i=\"w\"===st==(\"n\"===lt)?1:-1,a=(e/at+i*r/ot)/2;e=a*at,r=i*a*ot}\"w\"===st?e=n(et,0,e):\"e\"===st?e=n(et,1,-e):st||(e=0),\"n\"===lt?r=n(rt,1,r):\"s\"===lt?r=n(rt,0,-r):lt||(r=0);var o=\"w\"===st?e:0,u=\"n\"===lt?r:0;if(ct){var c;if(!st&&1===lt.length){for(c=0;c<et.length;c++)et[c].range=et[c]._r.slice(),O(et[c],1-r/ot);e=r*at/ot,o=e/2}if(!lt&&1===st.length){for(c=0;c<rt.length;c++)rt[c].range=rt[c]._r.slice(),O(rt[c],1-e/at);r=e*ot/at,u=r/2}}$([o,u,at-e,ot-r]),J(lt,st)}}function J(e,r){function n(t){for(a=0;a<t.length;a++)t[a].fixedrange||o.push(t[a]._id)}function i(n,i,s){for(a=0;a<n.length;a++){var l=n[a];if((r&&-1!==o.indexOf(l.xref)||e&&-1!==o.indexOf(l.yref))&&(i(t,a),s))return}}var a,o=[];for((r||ct)&&(n(et),n(ht)),(e||ct)&&(n(rt),n(ft)),St={},a=0;a<o.length;a++){var s=o[a];I(t,s,!0);var l=D(t,s);St[l._name+\".range[0]\"]=l.range[0],St[l._name+\".range[1]\"]=l.range[1]}i(dt.annotations||[],M.getComponentMethod(\"annotations\",\"drawOne\")),i(dt.shapes||[],M.getComponentMethod(\"shapes\",\"drawOne\")),i(dt.images||[],M.getComponentMethod(\"images\",\"draw\"),!0)}function K(){if(!t._transitioningWithDuration){var e,r,n,i=t._context.doubleClick,a=(st?et:[]).concat(lt?rt:[]),o={};if(\"reset+autosize\"===i)for(i=\"autosize\",r=0;r<a.length;r++)if(e=a[r],e._rangeInitial&&(e.range[0]!==e._rangeInitial[0]||e.range[1]!==e._rangeInitial[1])||!e._rangeInitial&&!e.autorange){i=\"reset\";break}if(\"autosize\"===i)for(r=0;r<a.length;r++)e=a[r],e.fixedrange||(o[e._name+\".autorange\"]=!0);else if(\"reset\"===i)for((st||ct)&&(a=a.concat(ht)),lt&&!ct&&(a=a.concat(ft)),ct&&(st?lt||(a=a.concat(rt)):a=a.concat(et)),r=0;r<a.length;r++)e=a[r],e._rangeInitial?(n=e._rangeInitial,o[e._name+\".range[0]\"]=n[0],o[e._name+\".range[1]\"]=n[1]):o[e._name+\".autorange\"]=!0;t.emit(\"plotly_doubleclick\",null),w.relayout(t,o)}}function Q(e){void 0===e&&(e=(V?\"x\":\"\")+(U?\"y\":\"\")),$([0,0,at,ot]),k.syncOrAsync([z.previousPromises,function(){w.relayout(t,St)}],t)}function $(t){function e(t){return t.fixedrange?0:d&&-1!==ht.indexOf(t)?h:p&&-1!==(ct?ht:ft).indexOf(t)?f:0}function r(t,e){return e?(t.range=t._r.slice(),O(t,e),n(t,e)):0}function n(t,e){return t._length*(1-e)*C[t.constraintoward||\"middle\"]}var i,a,o,s,l,u=dt._plots,c=Object.keys(u),h=t[2]/et[0]._length,f=t[3]/rt[0]._length,d=V||ct,p=U||ct;for(i=0;i<c.length;i++){var m=u[c[i]],v=m.xaxis,g=m.yaxis,y=d&&!v.fixedrange&&-1!==et.indexOf(v),b=p&&!g.fixedrange&&-1!==rt.indexOf(g);if(y?(a=h,s=V?t[0]:n(v,a)):(a=e(v),s=r(v,a)),b?(o=f,l=U?t[1]:n(g,o)):(o=e(g),l=r(g,o)),a||o){a||(a=1),o||(o=1);var x=v._offset-s/a,_=g._offset-l/o;dt._defs.select(\"#\"+m.clipId+\"> rect\").call(S.setTranslate,s,l).call(S.setScale,a,o);var w=m.plot.selectAll(\".scatterlayer .points, .boxlayer .points\");m.plot.call(S.setTranslate,x,_).call(S.setScale,1/a,1/o),w.selectAll(\".point\").call(S.setPointGroupScale,a,o).call(S.hideOutsideRangePoints,m),w.selectAll(\".textpoint\").call(S.setTextPointsScale,a,o).call(S.hideOutsideRangePoints,m)}}}var tt,et,rt,nt,it,at,ot,st,lt,ut,ct,ht,ft,dt=t._fullLayout,pt=t._fullLayout._zoomlayer,mt=U+V===\"nsew\";H();var vt=n(e,U+V+\"drag\",ut,r,T,E,B);if(!lt&&!st&&!m(dt.dragmode))return vt.onmousedown=null,vt.style.pointerEvents=mt?\"all\":\"none\",vt;var gt={element:vt,gd:t,plotinfo:e,prepFn:function(e,r,n){var i=t._fullLayout.dragmode;mt?e.shiftKey&&(i=\"pan\"===i?\"zoom\":\"pan\"):i=\"pan\",gt.minDrag=\"lasso\"===i?1:void 0,\"zoom\"===i?(gt.moveFn=G,gt.doneFn=Y,gt.minDrag=1,q(e,r,n)):\"pan\"===i?(gt.moveFn=Z,gt.doneFn=X,f(pt)):m(i)&&(gt.xaxes=et,gt.yaxes=rt,P(e,r,n,gt,i))}};L.init(gt);var yt,bt,xt,_t,wt,Mt,kt,At,Tt,St={},Et=[0,0,at,ot],Lt=null,Ct=R.REDRAWDELAY,zt=e.mainplot?dt._plots[e.mainplot]:e;return U.length*V.length!=1&&(void 0!==vt.onwheel?vt.onwheel=W:void 0!==vt.onmousewheel&&(vt.onmousewheel=W)),vt}},{\"../../components/color\":603,\"../../components/dragelement\":624,\"../../components/drawing\":627,\"../../constants/alignment\":699,\"../../lib\":725,\"../../lib/setcursor\":741,\"../../lib/svg_text_utils\":745,\"../../plotly\":761,\"../../registry\":844,\"../plots\":829,\"./axes\":766,\"./axis_ids\":769,\"./constants\":771,\"./scale_zoom\":781,\"./select\":782,d3:121,tinycolor2:533}],775:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../components/fx\"),a=t(\"../../components/dragelement\"),o=t(\"./constants\"),s=t(\"./dragbox\");e.exports=function(t){var e=t._fullLayout;if((e._has(\"cartesian\")||e._has(\"gl2d\"))&&!t._context.staticPlot){Object.keys(e._plots||{}).sort(function(t,r){if((e._plots[t].mainplot&&!0)===(e._plots[r].mainplot&&!0)){var n=t.split(\"y\"),i=r.split(\"y\");return n[0]===i[0]?Number(n[1]||1)-Number(i[1]||1):Number(n[0]||1)-Number(i[0]||1)}return e._plots[t].mainplot?1:-1}).forEach(function(r){var l=e._plots[r],u=l.xaxis,c=l.yaxis,h=(u._linepositions[r]||[])[3],f=(c._linepositions[r]||[])[3],d=o.DRAGGERSIZE;if(n(h)&&\"top\"===u.side&&(h-=d),n(f)&&\"right\"!==c.side&&(f-=d),!l.mainplot){var p=s(t,l,0,0,u._length,c._length,\"ns\",\"ew\");p.onmousemove=function(e){t._fullLayout._rehover=function(){t._fullLayout._hoversubplot===r&&i.hover(t,e,r)},i.hover(t,e,r),t._fullLayout._lasthover=p,t._fullLayout._hoversubplot=r},p.onmouseout=function(e){t._dragging||(t._fullLayout._hoversubplot=null,a.unhover(t,e))},p.onclick=function(e){i.click(t,e,r)},t._context.showAxisDragHandles&&(s(t,l,-d,-d,d,d,\"n\",\"w\"),s(t,l,u._length,-d,d,d,\"n\",\"e\"),s(t,l,-d,c._length,d,d,\"s\",\"w\"),s(t,l,u._length,c._length,d,d,\"s\",\"e\"))}t._context.showAxisDragHandles&&(n(h)&&(\"free\"===u.anchor&&(h-=e._size.h*(1-c.domain[1])),s(t,l,.1*u._length,h,.8*u._length,d,\"\",\"ew\"),s(t,l,0,h,.1*u._length,d,\"\",\"w\"),s(t,l,.9*u._length,h,.1*u._length,d,\"\",\"e\")),n(f)&&(\"free\"===c.anchor&&(f-=e._size.w*u.domain[0]),s(t,l,f,.1*c._length,d,.8*c._length,\"ns\",\"\"),s(t,l,f,.9*c._length,d,.1*c._length,\"s\",\"\"),s(t,l,f,0,d,.1*c._length,\"n\",\"\")))});var r=e._hoverlayer.node();r.onmousemove=function(r){r.target=e._lasthover,i.hover(t,r,e._hoversubplot)},r.onclick=function(r){r.target=e._lasthover,i.click(t,r)},r.onmousedown=function(t){e._lasthover.onmousedown(t)}}}},{\"../../components/dragelement\":624,\"../../components/fx\":644,\"./constants\":771,\"./dragbox\":774,\"fast-isnumeric\":130}],776:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){var a=t._fullLayout,o=a._modules;e.plot&&e.plot.selectAll(\"g:not(.scatterlayer)\").selectAll(\"g.trace\").remove();for(var s=0;s<o.length;s++){var l=o[s];if(\"cartesian\"===l.basePlotModule.name){for(var u=[],c=0;c<r.length;c++){var h=r[c],f=h[0].trace;f._module===l&&!0===f.visible&&u.push(h)}l.plot(t,e,u,n,i)}}}function i(t){for(var e=t._fullLayout,r=Object.keys(e._plots),n=[],i=[],a=0;a<r.length;a++){var o=r[a],s=e._plots[o],l=s.xaxis,u=s.yaxis,c=l._mainAxis,h=u._mainAxis,f=c._id+h._id;f!==o&&-1!==r.indexOf(f)?(s.mainplot=f,s.mainplotinfo=e._plots[f],i.push(o)):n.push(o)}return n=n.concat(i)}function a(t){var e=t.plotgroup,r=t.id,n=f.layerValue2layerClass[t.xaxis.layer],i=f.layerValue2layerClass[t.yaxis.layer];if(t.mainplot){var a=t.mainplotinfo,o=a.plotgroup,l=r+\"-x\",u=r+\"-y\";t.gridlayer=s(a.overgrid,\"g\",r),t.zerolinelayer=s(a.overzero,\"g\",r),s(a.overlinesBelow,\"path\",l),s(a.overlinesBelow,\"path\",u),s(a.overaxesBelow,\"g\",l),s(a.overaxesBelow,\"g\",u),t.plot=s(a.overplot,\"g\",r),s(a.overlinesAbove,\"path\",l),s(a.overlinesAbove,\"path\",u),s(a.overaxesAbove,\"g\",l),s(a.overaxesAbove,\"g\",u),t.xlines=o.select(\".overlines-\"+n).select(\".\"+l),t.ylines=o.select(\".overlines-\"+i).select(\".\"+u),t.xaxislayer=o.select(\".overaxes-\"+n).select(\".\"+l),t.yaxislayer=o.select(\".overaxes-\"+i).select(\".\"+u)}else{var c=s(e,\"g\",\"layer-subplot\");t.shapelayer=s(c,\"g\",\"shapelayer\"),t.imagelayer=s(c,\"g\",\"imagelayer\"),t.gridlayer=s(e,\"g\",\"gridlayer\"),t.overgrid=s(e,\"g\",\"overgrid\"),t.zerolinelayer=s(e,\"g\",\"zerolinelayer\"),t.overzero=s(e,\"g\",\"overzero\"),s(e,\"path\",\"xlines-below\"),s(e,\"path\",\"ylines-below\"),t.overlinesBelow=s(e,\"g\",\"overlines-below\"),s(e,\"g\",\"xaxislayer-below\"),s(e,\"g\",\"yaxislayer-below\"),t.overaxesBelow=s(e,\"g\",\"overaxes-below\"),t.plot=s(e,\"g\",\"plot\"),t.overplot=s(e,\"g\",\"overplot\"),s(e,\"path\",\"xlines-above\"),s(e,\"path\",\"ylines-above\"),t.overlinesAbove=s(e,\"g\",\"overlines-above\"),s(e,\"g\",\"xaxislayer-above\"),s(e,\"g\",\"yaxislayer-above\"),t.overaxesAbove=s(e,\"g\",\"overaxes-above\"),t.xlines=e.select(\".xlines-\"+n),t.ylines=e.select(\".ylines-\"+i),t.xaxislayer=e.select(\".xaxislayer-\"+n),t.yaxislayer=e.select(\".yaxislayer-\"+i)}for(var h=0;h<f.traceLayerClasses.length;h++)s(t.plot,\"g\",f.traceLayerClasses[h]);t.xlines.style(\"fill\",\"none\").classed(\"crisp\",!0),t.ylines.style(\"fill\",\"none\").classed(\"crisp\",!0)}function o(t,e){if(t){var r={};t.each(function(t){var n=l.select(this),i=\"clip\"+e._uid+t+\"plot\";n.remove(),e._draggers.selectAll(\"g.\"+t).remove(),e._defs.select(\"#\"+i).remove(),r[t]=!0});for(var n=e._plots,i=Object.keys(n),a=0;a<i.length;a++)for(var o=n[i[a]],s=o.overlays||[],u=0;u<s.length;u++){var c=s[u];r[c.id]&&c.plot.selectAll(\".trace\").remove()}}}function s(t,e,r){var n=t.selectAll(\".\"+r).data([0]);return n.enter().append(e).classed(r,!0),n}var l=t(\"d3\"),u=t(\"../../lib\"),c=t(\"../plots\"),h=t(\"./axis_ids\"),f=t(\"./constants\");r.name=\"cartesian\",r.attr=[\"xaxis\",\"yaxis\"],r.idRoot=[\"x\",\"y\"],r.idRegex=f.idRegex,r.attrRegex=f.attrRegex,r.attributes=t(\"./attributes\"),r.layoutAttributes=t(\"./layout_attributes\"),r.transitionAxes=t(\"./transition_axes\"),r.plot=function(t,e,r,i){var a,o=t._fullLayout,s=c.getSubplotIds(o,\"cartesian\"),l=t.calcdata;if(!Array.isArray(e))for(e=[],a=0;a<l.length;a++)e.push(a);for(a=0;a<s.length;a++){for(var u,h=s[a],f=o._plots[h],d=[],p=0;p<l.length;p++){var m=l[p],v=m[0].trace;v.xaxis+v.yaxis===h&&((-1!==e.indexOf(v.index)||v.carpet)&&(u&&u[0].trace.xaxis+u[0].trace.yaxis===h&&-1!==[\"tonextx\",\"tonexty\",\"tonext\"].indexOf(v.fill)&&-1===d.indexOf(u)&&d.push(u),d.push(m)),u=m)}n(t,f,d,r,i)}},r.clean=function(t,e,r,n){var i,a,s,l=n._modules||[],u=e._modules||[];for(s=0;s<l.length;s++)if(\"scatter\"===l[s].name){i=!0;break}for(s=0;s<u.length;s++)if(\"scatter\"===u[s].name){a=!0;break}if(i&&!a){var c=n._plots,f=Object.keys(c||{});for(s=0;s<f.length;s++){var d=c[f[s]];d.plot&&d.plot.select(\"g.scatterlayer\").selectAll(\"g.trace\").remove()}n._infolayer.selectAll(\"g.rangeslider-container\").select(\"g.scatterlayer\").selectAll(\"g.trace\").remove()}var p=n._has&&n._has(\"cartesian\"),m=e._has&&e._has(\"cartesian\");if(p&&!m){var v=n._cartesianlayer.selectAll(\".subplot\"),g=h.listIds({_fullLayout:n});for(v.call(o,n),n._defs.selectAll(\".axesclip\").remove(),s=0;s<g.length;s++)n._infolayer.select(\".\"+g[s]+\"title\").remove()}},r.drawFramework=function(t){var e=t._fullLayout,r=i(t),n=e._cartesianlayer.selectAll(\".subplot\").data(r,u.identity);n.enter().append(\"g\").attr(\"class\",function(t){return\"subplot \"+t}),n.order(),n.exit().call(o,e),n.each(function(t){var r=e._plots[t];if(r.plotgroup=l.select(this),r.overlays=[],a(r),r.mainplot){e._plots[r.mainplot].overlays.push(r)}r.draglayer=s(e._draggers,\"g\",t)})},r.rangePlot=function(t,e,r){a(e),n(t,e,r),c.style(t)}},{\"../../lib\":725,\"../plots\":829,\"./attributes\":765,\"./axis_ids\":769,\"./constants\":771,\"./layout_attributes\":777,\"./transition_axes\":787,d3:121}],777:[function(t,e,r){\"use strict\";var n=t(\"../font_attributes\"),i=t(\"../../components/color/attributes\"),a=t(\"../../components/drawing/attributes\").dash,o=t(\"../../lib/extend\").extendFlat,s=t(\"./constants\");e.exports={visible:{valType:\"boolean\"},color:{valType:\"color\",dflt:i.defaultLine},title:{valType:\"string\"},titlefont:o({},n,{}),type:{valType:\"enumerated\",values:[\"-\",\"linear\",\"log\",\"date\",\"category\"],dflt:\"-\"},autorange:{valType:\"enumerated\",values:[!0,!1,\"reversed\"],dflt:!0},rangemode:{valType:\"enumerated\",values:[\"normal\",\"tozero\",\"nonnegative\"],dflt:\"normal\"},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},fixedrange:{valType:\"boolean\",dflt:!1},scaleanchor:{valType:\"enumerated\",values:[s.idRegex.x.toString(),s.idRegex.y.toString()]},scaleratio:{valType:\"number\",min:0,dflt:1},constrain:{valType:\"enumerated\",values:[\"range\",\"domain\"],dflt:\"range\"},constraintoward:{valType:\"enumerated\",values:[\"left\",\"center\",\"right\",\"top\",\"middle\",\"bottom\"]},tickmode:{valType:\"enumerated\",values:[\"auto\",\"linear\",\"array\"]},nticks:{valType:\"integer\",min:0,dflt:0},tick0:{valType:\"any\"},dtick:{valType:\"any\"},tickvals:{valType:\"data_array\"},ticktext:{valType:\"data_array\"},ticks:{valType:\"enumerated\",values:[\"outside\",\"inside\",\"\"]},mirror:{valType:\"enumerated\",values:[!0,\"ticks\",!1,\"all\",\"allticks\"],dflt:!1},ticklen:{valType:\"number\",min:0,dflt:5},tickwidth:{valType:\"number\",min:0,dflt:1},tickcolor:{valType:\"color\",dflt:i.defaultLine},showticklabels:{valType:\"boolean\",dflt:!0},showspikes:{valType:\"boolean\",dflt:!1},spikecolor:{valType:\"color\",dflt:null},spikethickness:{valType:\"number\",dflt:3},spikedash:o({},a,{dflt:\"dash\"}),spikemode:{valType:\"flaglist\",flags:[\"toaxis\",\"across\",\"marker\"],dflt:\"toaxis\"},tickfont:o({},n,{}),tickangle:{valType:\"angle\",dflt:\"auto\"},tickprefix:{valType:\"string\",dflt:\"\"},showtickprefix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},ticksuffix:{valType:\"string\",dflt:\"\"},showticksuffix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},showexponent:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},exponentformat:{valType:\"enumerated\",values:[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"],dflt:\"B\"},separatethousands:{valType:\"boolean\",dflt:!1},tickformat:{valType:\"string\",dflt:\"\"},hoverformat:{valType:\"string\",dflt:\"\"},showline:{valType:\"boolean\",dflt:!1},linecolor:{valType:\"color\",dflt:i.defaultLine},linewidth:{valType:\"number\",min:0,dflt:1},showgrid:{valType:\"boolean\"},gridcolor:{valType:\"color\",dflt:i.lightLine},gridwidth:{valType:\"number\",min:0,dflt:1},zeroline:{valType:\"boolean\"},zerolinecolor:{valType:\"color\",dflt:i.defaultLine},zerolinewidth:{valType:\"number\",dflt:1},anchor:{valType:\"enumerated\",values:[\"free\",s.idRegex.x.toString(),s.idRegex.y.toString()]},side:{valType:\"enumerated\",values:[\"top\",\"bottom\",\"left\",\"right\"]},overlaying:{valType:\"enumerated\",values:[\"free\",s.idRegex.x.toString(),s.idRegex.y.toString()]},layer:{valType:\"enumerated\",values:[\"above traces\",\"below traces\"],dflt:\"above traces\"},domain:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},position:{valType:\"number\",min:0,max:1,dflt:0},categoryorder:{valType:\"enumerated\",values:[\"trace\",\"category ascending\",\"category descending\",\"array\"],dflt:\"trace\"},categoryarray:{valType:\"data_array\"},_deprecated:{autotick:{valType:\"boolean\"}}}},{\"../../components/color/attributes\":602,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../font_attributes\":790,\"./constants\":771}],778:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"../layout_attributes\"),s=t(\"./constants\"),l=t(\"./layout_attributes\"),u=t(\"./type_defaults\"),c=t(\"./axis_defaults\"),h=t(\"./constraint_defaults\"),f=t(\"./position_defaults\"),d=t(\"./axis_ids\");e.exports=function(t,e,r){function p(t,e){return Number(t.substr(5)||1)-Number(e.substr(5)||1)}function m(t,e){return i.coerce(N,B,l,t,e)}function v(t){var e={x:P,y:D}[t];return i.simpleMap(e,d.name2id)}var g,y=Object.keys(t),b=[],x=[],_=[],w=[],M=[],k=[],A={},T={};for(g=0;g<r.length;g++){var S,E,L=r[g];if(n.traceIs(L,\"cartesian\"))S=b,E=x;else{if(!n.traceIs(L,\"gl2d\"))continue;S=_,E=w}var C=d.id2name(L.xaxis),z=d.id2name(L.yaxis);if(n.traceIs(L,\"carpet\")&&(\"carpet\"!==L.type||L._cheater)||C&&i.pushUnique(k,C),\"carpet\"===L.type&&L._cheater&&C&&i.pushUnique(M,C),C&&-1===S.indexOf(C)&&S.push(C),z&&-1===E.indexOf(z)&&E.push(z),n.traceIs(L,\"2dMap\")&&(A[C]=!0,A[z]=!0),n.traceIs(L,\"oriented\")){T[\"h\"===L.orientation?z:C]=!0}}if(!e._has(\"gl3d\")&&!e._has(\"geo\"))for(g=0;g<y.length;g++){var I=y[g];-1===_.indexOf(I)&&-1===b.indexOf(I)&&s.xAxisMatch.test(I)?b.push(I):-1===w.indexOf(I)&&-1===x.indexOf(I)&&s.yAxisMatch.test(I)&&x.push(I)}b.length&&x.length&&i.pushUnique(e._basePlotModules,n.subplotsRegistry.cartesian)\n",
       ";var D=b.concat(_).sort(p),P=x.concat(w).sort(p),O=D.concat(P),R=a.background;D.length&&P.length&&(R=i.coerce(t,e,o,\"plot_bgcolor\"));var F,j,N,B,U=a.combine(R,e.paper_bgcolor),V={x:v(\"x\"),y:v(\"y\")};for(g=0;g<O.length;g++){F=O[g],i.isPlainObject(t[F])||(t[F]={}),N=t[F],B=e[F]={},u(N,B,m,r,F),j=F.charAt(0);var H=function(e,r){for(var n={x:D,y:P}[e],i=[],a=0;a<n.length;a++){var o=n[a];o===r||(t[o]||{}).overlaying||i.push(d.name2id(o))}return i}(j,F),q={letter:j,font:e.font,outerTicks:A[F],showGrid:!T[F],data:r,bgColor:U,calendar:e.calendar,cheateronly:\"x\"===j&&-1!==M.indexOf(F)&&-1===k.indexOf(F)};c(N,B,m,q,e);m(\"showspikes\")&&(m(\"spikecolor\"),m(\"spikethickness\"),m(\"spikedash\"),m(\"spikemode\"));var G={letter:j,counterAxes:V[j],overlayableAxes:H};f(N,B,m,G),B._input=N}var Y=n.getComponentMethod(\"rangeslider\",\"handleDefaults\"),X=n.getComponentMethod(\"rangeselector\",\"handleDefaults\");for(g=0;g<D.length;g++)F=D[g],N=t[F],B=e[F],Y(t,e,F),\"date\"===B.type&&X(N,B,e,P,B.calendar),m(\"fixedrange\");for(g=0;g<P.length;g++){F=P[g],N=t[F],B=e[F];var W=e[d.id2name(B.anchor)];m(\"fixedrange\",W&&W.rangeslider&&W.rangeslider.visible)}e._axisConstraintGroups=[];var Z=V.x.concat(V.y);for(g=0;g<O.length;g++)F=O[g],j=F.charAt(0),N=t[F],B=e[F],h(N,B,m,Z,e)}},{\"../../components/color\":603,\"../../lib\":725,\"../../registry\":844,\"../layout_attributes\":820,\"./axis_defaults\":768,\"./axis_ids\":769,\"./constants\":771,\"./constraint_defaults\":772,\"./layout_attributes\":777,\"./position_defaults\":780,\"./type_defaults\":788}],779:[function(t,e,r){\"use strict\";function n(t,e,r){var n,a,o,s,l,u=[],c=r.map(function(e){return e[t]}),h=i.bisector(e).left;for(n=0;n<c.length;n++)for(o=c[n],a=0;a<o.length;a++)null!==(s=o[a])&&void 0!==s&&((l=h(u,s))<u.length&&u[l]===s||u.splice(l,0,s));return u}var i=t(\"d3\");e.exports=function(t,e,r,a){switch(e){case\"array\":return Array.isArray(r)?r.slice():[];case\"category ascending\":return n(t,i.ascending,a);case\"category descending\":return n(t,i.descending,a);case\"trace\":default:return[]}}},{d3:121}],780:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\");e.exports=function(t,e,r,a){var o=a.counterAxes||[],s=a.overlayableAxes||[],l=a.letter;\"free\"===i.coerce(t,e,{anchor:{valType:\"enumerated\",values:[\"free\"].concat(o),dflt:n(t.position)?\"free\":o[0]||\"free\"}},\"anchor\")&&r(\"position\"),i.coerce(t,e,{side:{valType:\"enumerated\",values:\"x\"===l?[\"bottom\",\"top\"]:[\"left\",\"right\"],dflt:\"x\"===l?\"bottom\":\"left\"}},\"side\");var u=!1;if(s.length&&(u=i.coerce(t,e,{overlaying:{valType:\"enumerated\",values:[!1].concat(s),dflt:!1}},\"overlaying\")),!u){var c=r(\"domain\");c[0]>c[1]-.01&&(e.domain=[0,1]),i.noneOrAll(t.domain,e.domain,[0,1])}return r(\"layer\"),e}},{\"../../lib\":725,\"fast-isnumeric\":130}],781:[function(t,e,r){\"use strict\";var n=t(\"../../constants/alignment\").FROM_BL;e.exports=function(t,e,r){void 0===r&&(r=n[t.constraintoward||\"center\"]);var i=[t.r2l(t.range[0]),t.r2l(t.range[1])],a=i[0]+(i[1]-i[0])*r;t.range=t._input.range=[t.l2r(a+(i[0]-a)*e),t.l2r(a+(i[1]-a)*e)]}},{\"../../constants/alignment\":699}],782:[function(t,e,r){\"use strict\";function n(t){return t._id}function i(t,e){if(Array.isArray(t))for(var r=e.cd[0].trace,n=0;n<t.length;n++){var i=t[n];i.curveNumber=r.index,i.data=r._input,i.fullData=r,s(i,r,i.pointNumber)}return t}var a=t(\"../../lib/polygon\"),o=t(\"../../components/color\"),s=t(\"../../components/fx/helpers\").appendArrayPointValue,l=t(\"./axes\"),u=t(\"./constants\"),c=a.filter,h=a.tester,f=u.MINSELECT;e.exports=function(t,e,r,a,s){function d(t){var e=\"y\"===t._id.charAt(0)?1:0;return function(r){return t.p2d(r[e])}}function p(t,e){return t-e}var m,v=a.gd._fullLayout._zoomlayer,g=a.element.getBoundingClientRect(),y=a.plotinfo,b=y.xaxis._offset,x=y.yaxis._offset,_=e-g.left,w=r-g.top,M=_,k=w,A=\"M\"+_+\",\"+w,T=a.xaxes[0]._length,S=a.yaxes[0]._length,E=a.xaxes.map(n),L=a.yaxes.map(n),C=a.xaxes.concat(a.yaxes);\"lasso\"===s&&(m=c([[_,w]],u.BENDPX));var z=v.selectAll(\"path.select-outline\").data([1,2]);z.enter().append(\"path\").attr(\"class\",function(t){return\"select-outline select-outline-\"+t}).attr(\"transform\",\"translate(\"+b+\", \"+x+\")\").attr(\"d\",A+\"Z\");var I,D,P,O,R,F=v.append(\"path\").attr(\"class\",\"zoombox-corners\").style({fill:o.background,stroke:o.defaultLine,\"stroke-width\":1}).attr(\"transform\",\"translate(\"+b+\", \"+x+\")\").attr(\"d\",\"M0,0Z\"),j=[],N=a.gd,B=[];for(I=0;I<N.calcdata.length;I++)if(D=N.calcdata[I],P=D[0].trace,P._module&&P._module.selectPoints)if(a.subplot){if(P.subplot!==a.subplot)continue;j.push({selectPoints:P._module.selectPoints,cd:D,xaxis:a.xaxes[0],yaxis:a.yaxes[0]})}else{if(-1===E.indexOf(P.xaxis))continue;if(-1===L.indexOf(P.yaxis))continue;j.push({selectPoints:P._module.selectPoints,cd:D,xaxis:l.getFromId(N,P.xaxis),yaxis:l.getFromId(N,P.yaxis)})}var U;U=y.fillRangeItems?y.fillRangeItems:\"select\"===s?function(t,e){var r=t.range={};for(I=0;I<C.length;I++){var n=C[I],i=n._id.charAt(0);r[n._id]=[n.p2d(e[i+\"min\"]),n.p2d(e[i+\"max\"])].sort(p)}}:function(t,e,r){var n=t.lassoPoints={};for(I=0;I<C.length;I++){var i=C[I];n[i._id]=r.filtered.map(d(i))}},a.moveFn=function(t,e){var r;M=Math.max(0,Math.min(T,t+_)),k=Math.max(0,Math.min(S,e+w));var n=Math.abs(M-_),o=Math.abs(k-w);for(\"select\"===s?(o<Math.min(.6*n,f)?(r=h([[_,0],[_,S],[M,S],[M,0]]),F.attr(\"d\",\"M\"+r.xmin+\",\"+(w-f)+\"h-4v\"+2*f+\"h4ZM\"+(r.xmax-1)+\",\"+(w-f)+\"h4v\"+2*f+\"h-4Z\")):n<Math.min(.6*o,f)?(r=h([[0,w],[0,k],[T,k],[T,w]]),F.attr(\"d\",\"M\"+(_-f)+\",\"+r.ymin+\"v-4h\"+2*f+\"v4ZM\"+(_-f)+\",\"+(r.ymax-1)+\"v4h\"+2*f+\"v-4Z\")):(r=h([[_,w],[_,k],[M,k],[M,w]]),F.attr(\"d\",\"M0,0Z\")),z.attr(\"d\",\"M\"+r.xmin+\",\"+r.ymin+\"H\"+(r.xmax-1)+\"V\"+(r.ymax-1)+\"H\"+r.xmin+\"Z\")):\"lasso\"===s&&(m.addPt([M,k]),r=h(m.filtered),z.attr(\"d\",\"M\"+m.filtered.join(\"L\")+\"Z\")),B=[],I=0;I<j.length;I++)O=j[I],[].push.apply(B,i(O.selectPoints(O,r),O));R={points:B},U(R,r,m),a.gd.emit(\"plotly_selecting\",R)},a.doneFn=function(t,e){if(F.remove(),t||2!==e)a.gd.emit(\"plotly_selected\",R);else{for(z.remove(),I=0;I<j.length;I++)O=j[I],O.selectPoints(O,!1);N.emit(\"plotly_deselect\",null)}}}},{\"../../components/color\":603,\"../../components/fx/helpers\":641,\"../../lib/polygon\":736,\"./axes\":766,\"./constants\":771}],783:[function(t,e,r){\"use strict\";function n(t){return Math.pow(10,t)}var i=t(\"d3\"),a=t(\"fast-isnumeric\"),o=t(\"../../lib\"),s=o.cleanNumber,l=o.ms2DateTime,u=o.dateTime2ms,c=o.ensureNumber,h=t(\"../../constants/numerical\"),f=h.FP_SAFE,d=h.BADNUM,p=t(\"./constants\"),m=t(\"./axis_ids\");e.exports=function(t,e){function r(e,r){if(e>0)return Math.log(e)/Math.LN10;if(e<=0&&r&&t.range&&2===t.range.length){var n=t.range[0],i=t.range[1];return.5*(n+i-3*M*Math.abs(n-i))}return d}function h(e,r,n){var i=u(e,n||t.calendar);if(i===d){if(!a(e))return d;i=u(new Date(+e))}return i}function v(e,r,n){return l(e,r,n||t.calendar)}function g(e){return t._categories[Math.round(e)]}function y(e){if(null!==e&&void 0!==e){if(void 0===t._categoriesMap&&(t._categoriesMap={}),void 0!==t._categoriesMap[e])return t._categoriesMap[e];t._categories.push(e);var r=t._categories.length-1;return t._categoriesMap[e]=r,r}return d}function b(e){if(t._categoriesMap){var r=t._categoriesMap[e];if(void 0!==r)return r}if(a(e))return+e}function x(e){return a(e)?i.round(t._b+t._m*e,2):d}function _(e){return(e-t._b)/t._m}e=e||{};var w=(t._id||\"x\").charAt(0),M=10;t.c2l=\"log\"===t.type?r:c,t.l2c=\"log\"===t.type?n:c,t.l2p=x,t.p2l=_,t.c2p=\"log\"===t.type?function(t,e){return x(r(t,e))}:x,t.p2c=\"log\"===t.type?function(t){return n(_(t))}:_,-1!==[\"linear\",\"-\"].indexOf(t.type)?(t.d2r=t.r2d=t.d2c=t.r2c=t.d2l=t.r2l=s,t.c2d=t.c2r=t.l2d=t.l2r=c,t.d2p=t.r2p=function(e){return t.l2p(s(e))},t.p2d=t.p2r=_,t.cleanPos=c):\"log\"===t.type?(t.d2r=t.d2l=function(t,e){return r(s(t),e)},t.r2d=t.r2c=function(t){return n(s(t))},t.d2c=t.r2l=s,t.c2d=t.l2r=c,t.c2r=r,t.l2d=n,t.d2p=function(e,r){return t.l2p(t.d2r(e,r))},t.p2d=function(t){return n(_(t))},t.r2p=function(e){return t.l2p(s(e))},t.p2r=_,t.cleanPos=c):\"date\"===t.type?(t.d2r=t.r2d=o.identity,t.d2c=t.r2c=t.d2l=t.r2l=h,t.c2d=t.c2r=t.l2d=t.l2r=v,t.d2p=t.r2p=function(e,r,n){return t.l2p(h(e,0,n))},t.p2d=t.p2r=function(t,e,r){return v(_(t),e,r)},t.cleanPos=function(e){return o.cleanDate(e,d,t.calendar)}):\"category\"===t.type&&(t.d2c=t.d2l=y,t.r2d=t.c2d=t.l2d=g,t.d2r=t.d2l_noadd=b,t.r2c=function(e){var r=b(e);return void 0!==r?r:t.fraction2r(.5)},t.l2r=t.c2r=c,t.r2l=b,t.d2p=function(e){return t.l2p(t.r2c(e))},t.p2d=function(t){return g(_(t))},t.r2p=t.d2p,t.p2r=_,t.cleanPos=function(t){return\"string\"==typeof t&&\"\"!==t?t:c(t)}),t.fraction2r=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return t.l2r(r+e*(n-r))},t.r2fraction=function(e){var r=t.r2l(t.range[0]),n=t.r2l(t.range[1]);return(t.r2l(e)-r)/(n-r)},t.cleanRange=function(e){e||(e=\"range\");var r,n,i=o.nestedProperty(t,e).get();if(n=\"date\"===t.type?o.dfltRange(t.calendar):\"y\"===w?p.DFLTRANGEY:p.DFLTRANGEX,n=n.slice(),!i||2!==i.length)return void o.nestedProperty(t,e).set(n);for(\"date\"===t.type&&(i[0]=o.cleanDate(i[0],d,t.calendar),i[1]=o.cleanDate(i[1],d,t.calendar)),r=0;r<2;r++)if(\"date\"===t.type){if(!o.isDateTime(i[r],t.calendar)){t[e]=n;break}if(t.r2l(i[0])===t.r2l(i[1])){var s=o.constrain(t.r2l(i[0]),o.MIN_MS+1e3,o.MAX_MS-1e3);i[0]=t.l2r(s-1e3),i[1]=t.l2r(s+1e3);break}}else{if(!a(i[r])){if(!a(i[1-r])){t[e]=n;break}i[r]=i[1-r]*(r?10:.1)}if(i[r]<-f?i[r]=-f:i[r]>f&&(i[r]=f),i[0]===i[1]){var l=Math.max(1,Math.abs(1e-6*i[0]));i[0]-=l,i[1]+=l}}},t.setScale=function(r){var n=e._size;if(t._categories||(t._categories=[]),t._categoriesMap||(t._categoriesMap={}),t.overlaying){var i=m.getFromId({_fullLayout:e},t.overlaying);t.domain=i.domain}var a=r&&t._r?\"_r\":\"range\",s=t.calendar;t.cleanRange(a);var l=t.r2l(t[a][0],s),u=t.r2l(t[a][1],s);if(\"y\"===w?(t._offset=n.t+(1-t.domain[1])*n.h,t._length=n.h*(t.domain[1]-t.domain[0]),t._m=t._length/(l-u),t._b=-t._m*u):(t._offset=n.l+t.domain[0]*n.w,t._length=n.w*(t.domain[1]-t.domain[0]),t._m=t._length/(u-l),t._b=-t._m*l),!isFinite(t._m)||!isFinite(t._b))throw o.notifier(\"Something went wrong with axis scaling\",\"long\"),e._replotting=!1,new Error(\"axis scaling\")},t.makeCalcdata=function(e,r){var n,i,a,o=\"date\"===t.type&&e[r+\"calendar\"];if(r in e)for(n=e[r],i=new Array(n.length),a=0;a<n.length;a++)i[a]=t.d2c(n[a],0,o);else{var s=r+\"0\"in e?t.d2c(e[r+\"0\"],0,o):0,l=e[\"d\"+r]?Number(e[\"d\"+r]):1;for(n=e[{x:\"y\",y:\"x\"}[r]],i=new Array(n.length),a=0;a<n.length;a++)i[a]=s+a*l}return i},t.isValidRange=function(e){return Array.isArray(e)&&2===e.length&&a(t.r2l(e[0]))&&a(t.r2l(e[1]))},t.isPtWithinRange=\"x\"===w?function(e){var r=e.x;return r>=t.range[0]&&r<=t.range[1]}:function(e){var r=e.y;return r>=t.range[0]&&r<=t.range[1]},t._min=[],t._max=[],t._separators=e.separators,delete t._minDtick,delete t._forceTick0}},{\"../../constants/numerical\":705,\"../../lib\":725,\"./axis_ids\":769,\"./constants\":771,d3:121,\"fast-isnumeric\":130}],784:[function(t,e,r){\"use strict\";function n(t){var e=[\"showexponent\",\"showtickprefix\",\"showticksuffix\"],r=e.filter(function(e){return void 0!==t[e]}),n=function(e){return t[e]===t[r[0]]};if(r.every(n)||1===r.length)return t[r[0]]}var i=t(\"../../lib\");e.exports=function(t,e,r,a,o){var s=n(t);if(r(\"tickprefix\")&&r(\"showtickprefix\",s),r(\"ticksuffix\")&&r(\"showticksuffix\",s),r(\"showticklabels\")){var l=o.font||{},u=e.color===t.color?e.color:l.color;i.coerceFont(r,\"tickfont\",{family:l.family,size:l.size,color:u}),r(\"tickangle\"),\"category\"!==a&&(r(\"tickformat\")||\"date\"===a||(r(\"showexponent\",s),r(\"exponentformat\"),r(\"separatethousands\")))}\"category\"===a||o.noHover||r(\"hoverformat\")}},{\"../../lib\":725}],785:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./layout_attributes\");e.exports=function(t,e,r,a){var o=n.coerce2(t,e,i,\"ticklen\"),s=n.coerce2(t,e,i,\"tickwidth\"),l=n.coerce2(t,e,i,\"tickcolor\",e.color);r(\"ticks\",a.outerTicks||o||s||l?\"outside\":\"\")||(delete e.ticklen,delete e.tickwidth,delete e.tickcolor)}},{\"../../lib\":725,\"./layout_attributes\":777}],786:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../constants/numerical\").ONEDAY;e.exports=function(t,e,r,o){var s=\"auto\";\"array\"!==t.tickmode||\"log\"!==o&&\"date\"!==o||(t.tickmode=\"auto\"),Array.isArray(t.tickvals)?s=\"array\":t.dtick&&(s=\"linear\");var l=r(\"tickmode\",s);if(\"auto\"===l)r(\"nticks\");else if(\"linear\"===l){var u=\"date\"===o?a:1,c=r(\"dtick\",u);if(n(c))e.dtick=c>0?Number(c):u;else if(\"string\"!=typeof c)e.dtick=u;else{var h=c.charAt(0),f=c.substr(1);f=n(f)?Number(f):0,(f<=0||!(\"date\"===o&&\"M\"===h&&f===Math.round(f)||\"log\"===o&&\"L\"===h||\"log\"===o&&\"D\"===h&&(1===f||2===f)))&&(e.dtick=u)}var d=\"date\"===o?i.dateTick0(e.calendar):0,p=r(\"tick0\",d);\"date\"===o?e.tick0=i.cleanDate(p,d):n(p)&&\"D1\"!==c&&\"D2\"!==c?e.tick0=Number(p):e.tick0=d}else{var m=r(\"tickvals\");void 0===m?e.tickmode=\"auto\":r(\"ticktext\")}}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],787:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../plotly\"),a=t(\"../../registry\"),o=t(\"../../components/drawing\"),s=t(\"./axes\"),l=/((x|y)([2-9]|[1-9][0-9]+)?)axis$/;e.exports=function(t,e,r,u){function c(e,r){function n(e,r,n){for(i=0;i<e.length;i++){var a=e[i];if(-1===o.indexOf(a.xref)&&-1===o.indexOf(a.yref)||r(t,i),n)return}}var i,o=[];for(o=[e._id,r._id],i=0;i<o.length;i++)s.doTicks(t,o[i],!0);n(v.annotations||[],a.getComponentMethod(\"annotations\",\"drawOne\")),n(v.shapes||[],a.getComponentMethod(\"shapes\",\"drawOne\")),n(v.images||[],a.getComponentMethod(\"images\",\"draw\"),!0)}function h(t){var e=t.xaxis,r=t.yaxis;v._defs.select(\"#\"+t.clipId+\"> rect\").call(o.setTranslate,0,0).call(o.setScale,1,1),t.plot.call(o.setTranslate,e._offset,r._offset).call(o.setScale,1,1);var n=t.plot.select(\".scatterlayer\").selectAll(\".points\");n.selectAll(\".point\").call(o.setPointGroupScale,1,1).call(o.hideOutsideRangePoints,t),n.selectAll(\".textpoint\").call(o.setTextPointsScale,1,1).call(o.hideOutsideRangePoints,t)}function f(e,r){var n,i,a,s=y[e.xaxis._id],l=y[e.yaxis._id],u=[];if(s){n=t._fullLayout[s.axisName],i=n._r,a=s.to,u[0]=(i[0]*(1-r)+r*a[0]-i[0])/(i[1]-i[0])*e.xaxis._length;var h=i[1]-i[0],f=a[1]-a[0];n.range[0]=i[0]*(1-r)+r*a[0],n.range[1]=i[1]*(1-r)+r*a[1],u[2]=e.xaxis._length*(1-r+r*f/h)}else u[0]=0,u[2]=e.xaxis._length;if(l){n=t._fullLayout[l.axisName],i=n._r,a=l.to,u[1]=(i[1]*(1-r)+r*a[1]-i[1])/(i[0]-i[1])*e.yaxis._length;var d=i[1]-i[0],p=a[1]-a[0];n.range[0]=i[0]*(1-r)+r*a[0],n.range[1]=i[1]*(1-r)+r*a[1],u[3]=e.yaxis._length*(1-r+r*p/d)}else u[1]=0,u[3]=e.yaxis._length;c(e.xaxis,e.yaxis);var m=e.xaxis,g=e.yaxis,b=!!s,x=!!l,_=b?m._length/u[2]:1,w=x?g._length/u[3]:1,M=b?u[0]:0,k=x?u[1]:0,A=b?u[0]/u[2]*m._length:0,T=x?u[1]/u[3]*g._length:0,S=m._offset-A,E=g._offset-T;v._defs.select(\"#\"+e.clipId+\"> rect\").call(o.setTranslate,M,k).call(o.setScale,1/_,1/w),e.plot.call(o.setTranslate,S,E).call(o.setScale,_,w).selectAll(\".points\").selectAll(\".point\").call(o.setPointGroupScale,1/_,1/w),e.plot.selectAll(\".points\").selectAll(\".textpoint\").call(o.setTextPointsScale,1/_,1/w)}function d(){for(var e={},r=0;r<b.length;r++){var n=t._fullLayout[y[b[r]].axisName],a=y[b[r]].to;e[n._name+\".range[0]\"]=a[0],e[n._name+\".range[1]\"]=a[1],n.range=a.slice()}return _&&_(),i.relayout(t,e).then(function(){for(var t=0;t<x.length;t++)h(x[t])})}function p(){for(var e={},r=0;r<b.length;r++){var n=t._fullLayout[b[r]+\"axis\"];e[n._name+\".range[0]\"]=n.range[0],e[n._name+\".range[1]\"]=n.range[1],n.range=n._r.slice()}return i.relayout(t,e).then(function(){for(var t=0;t<x.length;t++)h(x[t])})}function m(){M=Date.now();for(var t=Math.min(1,(M-w)/r.duration),e=A(t),n=0;n<x.length;n++)f(x[n],e);M-w>r.duration?(d(),k=window.cancelAnimationFrame(m)):k=window.requestAnimationFrame(m)}var v=t._fullLayout,g=[],y=function(t){var e,r,n,i,a,o={};for(e in t)if(r=e.split(\".\"),n=r[0].match(l)){var s=n[1],u=s+\"axis\";if(i=v[u],a={},Array.isArray(t[e])?a.to=t[e].slice(0):Array.isArray(t[e].range)&&(a.to=t[e].range.slice(0)),!a.to)continue;a.axisName=u,a.length=i._length,g.push(s),o[s]=a}return o}(e),b=Object.keys(y),x=function(t,e,r){var n,i,a,o=t._plots,s=[];for(n in o){var l=o[n];if(-1===s.indexOf(l)){var u=l.xaxis._id,c=l.yaxis._id,h=l.xaxis.range,f=l.yaxis.range;l.xaxis._r=l.xaxis.range.slice(),l.yaxis._r=l.yaxis.range.slice(),i=r[u]?r[u].to:h,a=r[c]?r[c].to:f,h[0]===i[0]&&h[1]===i[1]&&f[0]===a[0]&&f[1]===a[1]||-1===e.indexOf(u)&&-1===e.indexOf(c)||s.push(l)}}return s}(v,b,y);if(!x.length)return function(){function e(e,r,n){for(var i=0;i<e.length;i++)if(r(t,i),n)return}e(v.annotations||[],a.getComponentMethod(\"annotations\",\"drawOne\")),e(v.shapes||[],a.getComponentMethod(\"shapes\",\"drawOne\")),e(v.images||[],a.getComponentMethod(\"images\",\"draw\"),!0)}(),!1;var _;u&&(_=u());var w,M,k,A=n.ease(r.easing);return t._transitionData._interruptCallbacks.push(function(){return window.cancelAnimationFrame(k),k=null,p()}),w=Date.now(),k=window.requestAnimationFrame(m),Promise.resolve()}},{\"../../components/drawing\":627,\"../../plotly\":761,\"../../registry\":844,\"./axes\":766,d3:121}],788:[function(t,e,r){\"use strict\";function n(t,e){if(\"-\"===t.type){var r=t._id,n=r.charAt(0);-1!==r.indexOf(\"scene\")&&(r=n);var u=i(e,r,n);if(u){if(\"histogram\"===u.type&&n==={v:\"y\",h:\"x\"}[u.orientation||\"v\"])return void(t.type=\"linear\");var c=n+\"calendar\",h=u[c];if(o(u,n)){for(var f,d=a(u),p=[],m=0;m<e.length;m++)f=e[m],s.traceIs(f,\"box\")&&(f[n+\"axis\"]||n)===r&&(void 0!==f[d]?p.push(f[d][0]):void 0!==f.name?p.push(f.name):p.push(\"text\"),f[c]!==h&&(h=void 0));t.type=l(p,h)}else t.type=l(u[n]||[u[n+\"0\"]],h)}}}function i(t,e,r){for(var n=0;n<t.length;n++){var i=t[n];if((i[r+\"axis\"]||r)===e){if(o(i,r))return i;if((i[r]||[]).length||i[r+\"0\"])return i}}}function a(t){return{v:\"x\",h:\"y\"}[t.orientation||\"v\"]}function o(t,e){var r=a(t),n=s.traceIs(t,\"box\"),i=s.traceIs(t._fullInput||{},\"candlestick\");return n&&!i&&e===r&&void 0===t[r]&&void 0===t[r+\"0\"]}var s=t(\"../../registry\"),l=t(\"./axis_autotype\"),u=t(\"./axis_ids\").name2id;e.exports=function(t,e,r,i,a){a&&(e._name=a,e._id=u(a)),\"-\"===r(\"type\")&&(n(e,i),\"-\"===e.type?e.type=\"linear\":t.type=e.type)}},{\"../../registry\":844,\"./axis_autotype\":767,\"./axis_ids\":769}],789:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a,o=!1;if(\"data\"===e.type)n=t._fullData[null!==e.traces?e.traces[0]:0];else{if(\"layout\"!==e.type)return!1;n=t._fullLayout}return i=u.nestedProperty(n,e.prop).get(),a=r[e.type]=r[e.type]||{},a.hasOwnProperty(e.prop)&&a[e.prop]!==i&&(o=!0),a[e.prop]=i,{changed:o,value:i}}function i(t,e){return Array.isArray(e[0])&&1===e[0].length&&-1!==[\"string\",\"number\"].indexOf(typeof e[0][0])?[{type:\"layout\",prop:\"_currentFrame\",value:e[0][0].toString()}]:[]}function a(t,e){var r=[],n=e[0],i={};if(\"string\"==typeof n)i[n]=e[1];else{if(!u.isPlainObject(n))return r;i=n}return s(i,function(t,e,n){r.push({type:\"layout\",prop:t,value:n})},\"\",0),r}function o(t,e){var r,n,i,a,o=[];if(n=e[0],i=e[1],r=e[2],a={},\"string\"==typeof n)a[n]=i;else{if(!u.isPlainObject(n))return o;a=n,void 0===r&&(r=i)}return void 0===r&&(r=null),s(a,function(e,n,i){var a;if(Array.isArray(i)){var s=Math.min(i.length,t.data.length);r&&(s=Math.min(s,r.length)),a=[];for(var l=0;l<s;l++)a[l]=r?r[l]:l}else a=r?r.slice(0):null;if(null===a)Array.isArray(i)&&(i=i[0]);else if(Array.isArray(a)){if(!Array.isArray(i)){var u=i;i=[];for(var c=0;c<a.length;c++)i[c]=u}i.length=Math.min(a.length,i.length)}o.push({type:\"data\",prop:e,traces:a,value:i})},\"\",0),o}function s(t,e,r,n){Object.keys(t).forEach(function(i){var a=t[i];if(\"_\"!==i[0]){var o=r+(n>0?\".\":\"\")+i;u.isPlainObject(a)?s(a,e,o,n+1):e(o,i,a)}})}var l=t(\"../plotly\"),u=t(\"../lib\");r.manageCommandObserver=function(t,e,i,a){var o={},s=!0;e&&e._commandObserver&&(o=e._commandObserver),o.cache||(o.cache={}),o.lookupTable={};var l=r.hasSimpleAPICommandBindings(t,i,o.lookupTable);if(e&&e._commandObserver){if(l)return o;if(e._commandObserver.remove)return e._commandObserver.remove(),e._commandObserver=null,o}if(l){n(t,l,o.cache),o.check=function(){if(s){var e=n(t,l,o.cache);return e.changed&&a&&void 0!==o.lookupTable[e.value]&&(o.disable(),Promise.resolve(a({value:e.value,type:l.type,prop:l.prop,traces:l.traces,index:o.lookupTable[e.value]})).then(o.enable,o.enable)),e.changed}};for(var c=[\"plotly_relayout\",\"plotly_redraw\",\"plotly_restyle\",\"plotly_update\",\"plotly_animatingframe\",\"plotly_afterplot\"],h=0;h<c.length;h++)t._internalOn(c[h],o.check);o.remove=function(){for(var e=0;e<c.length;e++)t._removeInternalListener(c[e],o.check)}}else u.warn(\"Unable to automatically bind plot updates to API command\"),o.lookupTable={},o.remove=function(){};return o.disable=function(){s=!1},o.enable=function(){s=!0},e&&(e._commandObserver=o),o},r.hasSimpleAPICommandBindings=function(t,e,n){var i,a,o=e.length;for(i=0;i<o;i++){var s,l=e[i],u=l.method,c=l.args;if(Array.isArray(c)||(c=[]),!u)return!1;var h=r.computeAPICommandBindings(t,u,c);if(1!==h.length)return!1;if(a){if(s=h[0],s.type!==a.type)return!1;if(s.prop!==a.prop)return!1;if(Array.isArray(a.traces)){if(!Array.isArray(s.traces))return!1;s.traces.sort();for(var f=0;f<a.traces.length;f++)if(a.traces[f]!==s.traces[f])return!1}else if(s.prop!==a.prop)return!1}else a=h[0],Array.isArray(a.traces)&&a.traces.sort();s=h[0];var d=s.value;if(Array.isArray(d)){if(1!==d.length)return!1;d=d[0]}n&&(n[d]=i)}return a},r.executeAPICommand=function(t,e,r){if(\"skip\"===e)return Promise.resolve();var n=l[e],i=[t];Array.isArray(r)||(r=[]);for(var a=0;a<r.length;a++)i.push(r[a]);return n.apply(null,i).catch(function(t){return u.warn(\"API call to Plotly.\"+e+\" rejected.\",t),Promise.reject(t)})},r.computeAPICommandBindings=function(t,e,r){var n;switch(Array.isArray(r)||(r=[]),e){case\"restyle\":n=o(t,r);break;case\"relayout\":n=a(t,r);break;case\"update\":n=o(t,[r[0],r[2]]).concat(a(t,[r[1]]));break;case\"animate\":n=i(t,r);break;default:n=[]}return n}},{\"../lib\":725,\"../plotly\":761}],790:[function(t,e,r){\"use strict\";e.exports={family:{valType:\"string\",noBlank:!0,strict:!0},size:{valType:\"number\",min:1},color:{valType:\"color\"}}},{}],791:[function(t,e,r){\"use strict\";e.exports={_isLinkedToArray:\"frames_entry\",group:{valType:\"string\"},name:{valType:\"string\"},traces:{valType:\"any\"},baseframe:{valType:\"string\"},data:{valType:\"any\"},layout:{valType:\"any\"}}},{}],792:[function(t,e,r){\"use strict\";var n=e.exports={};n.projNames={equirectangular:\"equirectangular\",mercator:\"mercator\",orthographic:\"orthographic\",\"natural earth\":\"naturalEarth\",kavrayskiy7:\"kavrayskiy7\",miller:\"miller\",robinson:\"robinson\",eckert4:\"eckert4\",\"azimuthal equal area\":\"azimuthalEqualArea\",\"azimuthal equidistant\":\"azimuthalEquidistant\",\"conic equal area\":\"conicEqualArea\",\"conic conformal\":\"conicConformal\",\"conic equidistant\":\"conicEquidistant\",gnomonic:\"gnomonic\",stereographic:\"stereographic\",mollweide:\"mollweide\",hammer:\"hammer\",\"transverse mercator\":\"transverseMercator\",\"albers usa\":\"albersUsa\",\"winkel tripel\":\"winkel3\",aitoff:\"aitoff\",sinusoidal:\"sinusoidal\"},n.axesNames=[\"lonaxis\",\"lataxis\"],n.lonaxisSpan={orthographic:180,\"azimuthal equal area\":360,\"azimuthal equidistant\":360,\"conic conformal\":180,gnomonic:160,stereographic:180,\"transverse mercator\":180,\"*\":360},n.lataxisSpan={\"conic conformal\":150,stereographic:179.5,\"*\":180},n.scopeDefaults={world:{lonaxisRange:[-180,180],lataxisRange:[-90,90],projType:\"equirectangular\",projRotate:[0,0,0]},usa:{lonaxisRange:[-180,-50],lataxisRange:[15,80],projType:\"albers usa\"},europe:{lonaxisRange:[-30,60],lataxisRange:[30,80],projType:\"conic conformal\",projRotate:[15,0,0],projParallels:[0,60]},asia:{lonaxisRange:[22,160],lataxisRange:[-15,55],projType:\"mercator\",projRotate:[0,0,0]},africa:{lonaxisRange:[-30,60],lataxisRange:[-40,40],projType:\"mercator\",projRotate:[0,0,0]},\"north america\":{lonaxisRange:[-180,-45],lataxisRange:[5,85],projType:\"conic conformal\",projRotate:[-100,0,0],projParallels:[29.5,45.5]},\"south america\":{lonaxisRange:[-100,-30],lataxisRange:[-60,15],projType:\"mercator\",projRotate:[0,0,0]}},n.clipPad=.001,n.precision=.1,n.landColor=\"#F0DC82\",n.waterColor=\"#3399FF\",n.locationmodeToLayer={\"ISO-3\":\"countries\",\"USA-states\":\"subunits\",\"country names\":\"countries\"},n.sphereSVG={type:\"Sphere\"},n.fillLayers=[\"ocean\",\"land\",\"lakes\"],n.lineLayers=[\"subunits\",\"countries\",\"coastlines\",\"rivers\",\"frame\"],n.baseLayers=[\"ocean\",\"land\",\"lakes\",\"subunits\",\"countries\",\"coastlines\",\"rivers\",\"lataxis\",\"lonaxis\",\"frame\"],n.layerNameToAdjective={ocean:\"ocean\",land:\"land\",lakes:\"lake\",subunits:\"subunit\",countries:\"country\",coastlines:\"coastline\",rivers:\"river\",frame:\"frame\"},n.baseLayersOverChoropleth=[\"rivers\",\"lakes\"]},{}],793:[function(t,e,r){\"use strict\";function n(t){this.id=t.id,this.graphDiv=t.graphDiv,this.container=t.container,this.topojsonURL=t.topojsonURL,this.topojsonName=null,this.topojson=null,this.projectionType=null,this.projection=null,this.clipAngle=null,this.setScale=null,this.path=null,this.zoom=null,this.zoomReset=null,this.makeFramework(),this.traceHash={}}function i(t,e,r){return u.geo.graticule().extent([[t[0],e[0]],[t[1],e[1]]]).step(r)}function a(t,e,r){var n=b.layerNameToAdjective[e];t.select(\".\"+e).selectAll(\"path\").attr(\"stroke\",\"none\").call(c.fill,r[n+\"color\"])}function o(t,e,r){var n=b.layerNameToAdjective[e];t.select(\".\"+e).selectAll(\"path\").attr(\"fill\",\"none\").call(c.stroke,r[n+\"color\"]).call(h.dashLine,\"\",r[n+\"width\"])}function s(t,e,r){t.select(\".\"+e+\"graticule\").selectAll(\"path\").attr(\"fill\",\"none\").call(c.stroke,r[e].gridcolor).call(h.dashLine,\"\",r[e].gridwidth)}function l(t){var e={type:\"linear\",showexponent:\"all\",exponentformat:p.layoutAttributes.exponentformat.dflt};return p.setConvert(e,t),e}var u=t(\"d3\"),c=t(\"../../components/color\"),h=t(\"../../components/drawing\"),f=t(\"../../components/fx\"),d=t(\"../plots\"),p=t(\"../cartesian/axes\"),m=t(\"./projections\"),v=t(\"./set_scale\"),g=t(\"./zoom\"),y=t(\"./zoom_reset\"),b=t(\"./constants\"),x=t(\"../../lib/topojson_utils\"),_=t(\"topojson-client\").feature;m(u),e.exports=n;var w=n.prototype;w.plot=function(t,e,r){var n,i,a=this,o=e[a.id],s=e._size;a.projection=null,a.setScale=v(o,s),a.makeProjection(o),a.makePath(),a.adjustLayout(o,s),a.zoom=g(a,o),a.zoomReset=y(a,o),a.mockAxis=l(e),a.framework.call(a.zoom).on(\"dblclick.zoom\",a.zoomReset),a.framework.on(\"mousemove\",function(){var t=u.mouse(this),e=a.projection.invert(t);if(e&&!isNaN(e[0])&&!isNaN(e[1])){var r=u.event;r.xpx=t[0],r.ypx=t[1],a.xaxis.c2p=function(){return t[0]},a.xaxis.p2c=function(){return e[0]},a.yaxis.c2p=function(){return t[1]},a.yaxis.p2c=function(){return e[1]},f.hover(a.graphDiv,r,a.id)}}),a.framework.on(\"mouseout\",function(){f.loneUnhover(e._toppaper)}),a.framework.on(\"click\",function(){f.click(a.graphDiv,u.event)}),n=x.getTopojsonName(o),null===a.topojson||n!==a.topojsonName?(a.topojsonName=n,void 0!==PlotlyGeoAssets.topojson[a.topojsonName]?(a.topojson=PlotlyGeoAssets.topojson[a.topojsonName],a.onceTopojsonIsLoaded(t,o)):(i=x.getTopojsonPath(a.topojsonURL,a.topojsonName),r.push(new Promise(function(e,r){u.json(i,function(n,s){if(n)return void r(404===n.status?new Error([\"plotly.js could not find topojson file at\",i,\".\",\"Make sure the *topojsonURL* plot config option\",\"is set properly.\"].join(\" \")):new Error([\"unexpected error while fetching topojson file at\",i].join(\" \")));a.topojson=s,PlotlyGeoAssets.topojson[a.topojsonName]=s,a.onceTopojsonIsLoaded(t,o),e()})})))):a.onceTopojsonIsLoaded(t,o)},w.onceTopojsonIsLoaded=function(t,e){this.drawLayout(e),d.generalUpdatePerTraceModule(this,t,e),this.render()},w.makeProjection=function(t){var e,r=t.projection,n=r.type,i=null===this.projection||n!==this.projectionType;i?(this.projectionType=n,e=this.projection=u.geo[b.projNames[n]]()):e=this.projection,e.translate(r._translate0).precision(b.precision),t._isAlbersUsa||e.rotate(r._rotate).center(r._center),t._clipAngle?(this.clipAngle=t._clipAngle,e.clipAngle(t._clipAngle-b.clipPad)):this.clipAngle=null,r.parallels&&e.parallels(r.parallels),i&&this.setScale(e),e.translate(r._translate).scale(r._scale)},w.makePath=function(){this.path=u.geo.path().projection(this.projection)},w.makeFramework=function(){var t=this.graphDiv._fullLayout,e=\"clip\"+t._uid+this.id,r=t._defs.selectAll(\"g.clips\").data([0]);r.enter().append(\"g\").classed(\"clips\",!0),(this.clipDef=r.selectAll(\"#\"+e).data([0])).enter().append(\"clipPath\").attr(\"id\",e).append(\"rect\");var n=this.framework=u.select(this.container).append(\"g\");n.attr(\"class\",\"geo \"+this.id).style(\"pointer-events\",\"all\").call(h.setClipUrl,e),n.append(\"g\").attr(\"class\",\"bglayer\").append(\"rect\"),n.append(\"g\").attr(\"class\",\"baselayer\"),n.append(\"g\").attr(\"class\",\"choroplethlayer\"),n.append(\"g\").attr(\"class\",\"baselayeroverchoropleth\"),n.append(\"g\").attr(\"class\",\"scattergeolayer\"),n.on(\"dblclick.zoom\",null),this.xaxis={_id:\"x\"},this.yaxis={_id:\"y\"}},w.adjustLayout=function(t,e){var r=t.domain,n=e.l+e.w*r.x[0]+t._marginX,i=e.t+e.h*(1-r.y[1])+t._marginY;h.setTranslate(this.framework,n,i);var a={x:0,y:0,width:t._width,height:t._height};this.clipDef.select(\"rect\").attr(a),this.framework.select(\".bglayer\").select(\"rect\").attr(a).call(c.fill,t.bgcolor),this.xaxis._offset=n,this.xaxis._length=t._width,this.yaxis._offset=i,this.yaxis._length=t._height},w.drawTopo=function(t,e,r){if(!0===r[\"show\"+e]){var n=this.topojson,i=\"frame\"===e?b.sphereSVG:_(n,n.objects[e]);t.append(\"g\").datum(i).attr(\"class\",e).append(\"path\").attr(\"class\",\"basepath\")}},w.drawGraticule=function(t,e,r){var n=r[e];if(!0===n.showgrid){var a=b.scopeDefaults[r.scope],o=a.lonaxisRange,s=a.lataxisRange,l=\"lonaxis\"===e?[n.dtick]:[0,n.dtick],u=i(o,s,l);t.append(\"g\").datum(u).attr(\"class\",e+\"graticule\").append(\"path\").attr(\"class\",\"graticulepath\")}},w.drawLayout=function(t){var e,r=this.framework.select(\"g.baselayer\"),n=b.baseLayers,i=b.axesNames;r.selectAll(\"*\").remove();for(var a=0;a<n.length;a++)e=n[a],-1!==i.indexOf(e)?this.drawGraticule(r,e,t):this.drawTopo(r,e,t);this.styleLayout(t)},w.styleLayer=function(t,e,r){var n=b.fillLayers,i=b.lineLayers;-1!==n.indexOf(e)?a(t,e,r):-1!==i.indexOf(e)&&o(t,e,r)},w.styleLayout=function(t){for(var e,r=this.framework.select(\"g.baselayer\"),n=b.baseLayers,i=b.axesNames,a=0;a<n.length;a++)e=n[a],-1!==i.indexOf(e)?s(r,e,t):this.styleLayer(r,e,t)},w.isLonLatOverEdges=function(t){var e=this.clipAngle;if(null===e)return!1;var r=this.projection.rotate();return u.geo.distance(t,[-r[0],-r[1]])>e*Math.PI/180},w.render=function(){function t(t){var e=r.projection(t.lonlat);return e?\"translate(\"+e[0]+\",\"+e[1]+\")\":null}function e(t){return r.isLonLatOverEdges(t.lonlat)?\"0\":\"1.0\"}var r=this,n=r.framework,i=n.select(\"g.choroplethlayer\"),a=n.select(\"g.scattergeolayer\"),o=r.path;n.selectAll(\"path.basepath\").attr(\"d\",o),n.selectAll(\"path.graticulepath\").attr(\"d\",o),i.selectAll(\"path.choroplethlocation\").attr(\"d\",o),i.selectAll(\"path.basepath\").attr(\"d\",o),a.selectAll(\"path.js-line\").attr(\"d\",o),null!==r.clipAngle?(a.selectAll(\"path.point\").style(\"opacity\",e).attr(\"transform\",t),a.selectAll(\"text\").style(\"opacity\",e).attr(\"transform\",t)):(a.selectAll(\"path.point\").attr(\"transform\",t),a.selectAll(\"text\").attr(\"transform\",t))}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../lib/topojson_utils\":747,\"../cartesian/axes\":766,\"../plots\":829,\"./constants\":792,\"./projections\":800,\"./set_scale\":801,\"./zoom\":802,\"./zoom_reset\":803,d3:121,\"topojson-client\":535}],794:[function(t,e,r){\"use strict\";var n=t(\"./geo\"),i=t(\"../../plots/plots\");r.name=\"geo\",r.attr=\"geo\",r.idRoot=\"geo\",r.idRegex=/^geo([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^geo([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){var e=t._fullLayout,r=t.calcdata,a=i.getSubplotIds(e,\"geo\");void 0===window.PlotlyGeoAssets&&(window.PlotlyGeoAssets={topojson:{}});for(var o=0;o<a.length;o++){var s=a[o],l=i.getSubplotCalcData(r,\"geo\",s),u=e[s]._subplot;u||(u=new n({id:s,graphDiv:t,container:e._geolayer.node(),topojsonURL:t._context.topojsonURL}),e[s]._subplot=u),u.plot(l,e,t._promises)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"geo\"),o=0;o<a.length;o++){var s=a[o],l=n[s]._subplot;!e[s]&&l&&(l.framework.remove(),l.clipDef.remove())}}},{\"../../plots/plots\":829,\n",
       "\"./geo\":793,\"./layout/attributes\":795,\"./layout/defaults\":798,\"./layout/layout_attributes\":799}],795:[function(t,e,r){\"use strict\";e.exports={geo:{valType:\"subplotid\",dflt:\"geo\"}}},{}],796:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\");e.exports={range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},showgrid:{valType:\"boolean\",dflt:!1},tick0:{valType:\"number\"},dtick:{valType:\"number\"},gridcolor:{valType:\"color\",dflt:n.lightLine},gridwidth:{valType:\"number\",min:0,dflt:1}}},{\"../../../components/color/attributes\":602}],797:[function(t,e,r){\"use strict\";var n=t(\"../../../lib\"),i=t(\"../constants\"),a=t(\"./axis_attributes\");e.exports=function(t,e){function r(t,e){return n.coerce(o,s,a,t,e)}for(var o,s,l=i.axesNames,u=0;u<l.length;u++){var c=l[u];o=t[c]||{},s={};var h=function(t){var r,n,a,o,s,l,u=e.scope;return\"world\"===u?(r=e.projection,n=r.type,a=r.rotation,s=i[t+\"Span\"],l=void 0!==s[n]?s[n]/2:s[\"*\"]/2,o=\"lonaxis\"===t?a.lon:a.lat,[o-l,o+l]):i.scopeDefaults[u][t+\"Range\"]}(c),f=r(\"range\",h);n.noneOrAll(o.range,s.range,[0,1]),r(\"tick0\",f[0]),r(\"dtick\",\"lonaxis\"===c?30:10);r(\"showgrid\")&&(r(\"gridcolor\"),r(\"gridwidth\")),e[c]=s,e[c]._fullRange=h}}},{\"../../../lib\":725,\"../constants\":792,\"./axis_attributes\":796}],798:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i=r(\"scope\"),o=\"world\"!==i,l=a.scopeDefaults[i],u=r(\"resolution\"),c=r(\"projection.type\",l.projType),h=\"albers usa\"===c,f=-1!==c.indexOf(\"conic\");if(f){r(\"projection.parallels\",l.projParallels||[0,60])}if(h)e.scope=\"usa\";else{var d=l.projRotate||[0,0,0];r(\"projection.rotation.lon\",d[0]),r(\"projection.rotation.lat\",d[1]),r(\"projection.rotation.roll\",d[2]),n=r(\"showcoastlines\",!o),n&&(r(\"coastlinecolor\"),r(\"coastlinewidth\")),n=r(\"showocean\"),n&&r(\"oceancolor\")}r(\"projection.scale\"),n=r(\"showland\"),n&&r(\"landcolor\"),n=r(\"showlakes\"),n&&r(\"lakecolor\"),n=r(\"showrivers\"),n&&(r(\"rivercolor\"),r(\"riverwidth\")),n=r(\"showcountries\",o&&\"usa\"!==i),n&&(r(\"countrycolor\"),r(\"countrywidth\")),(\"usa\"===i||\"north america\"===i&&50===u)&&(r(\"showsubunits\",!0),r(\"subunitcolor\"),r(\"subunitwidth\")),o||(n=r(\"showframe\",!0))&&(r(\"framecolor\"),r(\"framewidth\")),r(\"bgcolor\"),s(t,e),e._isHighRes=50===u,e._clipAngle=a.lonaxisSpan[c]/2,e._isAlbersUsa=h,e._isConic=f,e._isScoped=o;var p=e.projection.rotation||{};e.projection._rotate=[-p.lon||0,-p.lat||0,p.roll||0]}var i=t(\"../../subplot_defaults\"),a=t(\"../constants\"),o=t(\"./layout_attributes\"),s=t(\"./axis_defaults\");e.exports=function(t,e,r){i(t,e,r,{type:\"geo\",attributes:o,handleDefaults:n,partition:\"y\"})}},{\"../../subplot_defaults\":836,\"../constants\":792,\"./axis_defaults\":797,\"./layout_attributes\":799}],799:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\"),i=t(\"../constants\"),a=t(\"./axis_attributes\");e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},resolution:{valType:\"enumerated\",values:[110,50],dflt:110,coerceNumber:!0},scope:{valType:\"enumerated\",values:Object.keys(i.scopeDefaults),dflt:\"world\"},projection:{type:{valType:\"enumerated\",values:Object.keys(i.projNames)},rotation:{lon:{valType:\"number\"},lat:{valType:\"number\"},roll:{valType:\"number\"}},parallels:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},scale:{valType:\"number\",min:0,max:10,dflt:1}},showcoastlines:{valType:\"boolean\"},coastlinecolor:{valType:\"color\",dflt:n.defaultLine},coastlinewidth:{valType:\"number\",min:0,dflt:1},showland:{valType:\"boolean\",dflt:!1},landcolor:{valType:\"color\",dflt:i.landColor},showocean:{valType:\"boolean\",dflt:!1},oceancolor:{valType:\"color\",dflt:i.waterColor},showlakes:{valType:\"boolean\",dflt:!1},lakecolor:{valType:\"color\",dflt:i.waterColor},showrivers:{valType:\"boolean\",dflt:!1},rivercolor:{valType:\"color\",dflt:i.waterColor},riverwidth:{valType:\"number\",min:0,dflt:1},showcountries:{valType:\"boolean\"},countrycolor:{valType:\"color\",dflt:n.defaultLine},countrywidth:{valType:\"number\",min:0,dflt:1},showsubunits:{valType:\"boolean\"},subunitcolor:{valType:\"color\",dflt:n.defaultLine},subunitwidth:{valType:\"number\",min:0,dflt:1},showframe:{valType:\"boolean\"},framecolor:{valType:\"color\",dflt:n.defaultLine},framewidth:{valType:\"number\",min:0,dflt:1},bgcolor:{valType:\"color\",dflt:n.background},lonaxis:a,lataxis:a}},{\"../../../components/color/attributes\":602,\"../constants\":792,\"./axis_attributes\":796}],800:[function(t,e,r){\"use strict\";function n(t){function e(t,e){return{type:\"Feature\",id:t.id,properties:t.properties,geometry:r(t.geometry,e)}}function r(e,n){if(!e)return null;if(\"GeometryCollection\"===e.type)return{type:\"GeometryCollection\",geometries:object.geometries.map(function(t){return r(t,n)})};if(!S.hasOwnProperty(e.type))return null;var i=S[e.type];return t.geo.stream(e,n(i)),i.result()}function n(){}function i(t){if((e=t.length)<4)return!1;for(var e,r=0,n=t[e-1][1]*t[0][0]-t[e-1][0]*t[0][1];++r<e;)n+=t[r-1][1]*t[r][0]-t[r-1][0]*t[r][1];return n<=0}function a(t,e){for(var r=e[0],n=e[1],i=!1,a=0,o=t.length,s=o-1;a<o;s=a++){var l=t[a],u=l[0],c=l[1],h=t[s],f=h[0],d=h[1];c>n^d>n&&r<(f-u)*(n-c)/(d-c)+u&&(i=!i)}return i}function o(t){return t?t/Math.sin(t):1}function s(t){return t>1?z:t<-1?-z:Math.asin(t)}function l(t){return t>1?0:t<-1?C:Math.acos(t)}function u(t,e){var r=(2+z)*Math.sin(e);e/=2;for(var n=0,i=1/0;n<10&&Math.abs(i)>E;n++){var a=Math.cos(e);e-=i=(e+Math.sin(e)*(a+2)-r)/(2*a*(1+a))}return[2/Math.sqrt(C*(4+C))*t*(1+Math.cos(e)),2*Math.sqrt(C/(4+C))*Math.sin(e)]}function c(t,e){function r(r,n){var i=R(r/e,n);return i[0]*=t,i}return arguments.length<2&&(e=t),1===e?R:e===1/0?f:(r.invert=function(r,n){var i=R.invert(r/t,n);return i[0]*=e,i},r)}function h(){var t=2,e=O(c),r=e(t);return r.coefficient=function(r){return arguments.length?e(t=+r):t},r}function f(t,e){return[t*Math.cos(e)/Math.cos(e/=2),2*Math.sin(e)]}function d(t,e){return[3*t/(2*C)*Math.sqrt(C*C/3-e*e),e]}function p(t,e){return[t,1.25*Math.log(Math.tan(C/4+.4*e))]}function m(t){return function(e){var r,n=t*Math.sin(e),i=30;do{e-=r=(e+Math.sin(e)-n)/(1+Math.cos(e))}while(Math.abs(r)>E&&--i>0);return e/2}}function v(t,e){var r=e*e,n=r*r;return[t*(.8707-.131979*r+n*(n*(.003971*r-.001529*n)-.013791)),e*(1.007226+r*(.015085+n*(.028874*r-.044475-.005916*n)))]}function g(t,e){var r,n=Math.min(18,36*Math.abs(e)/C),i=Math.floor(n),a=n-i,o=(r=j[i])[0],s=r[1],l=(r=j[++i])[0],u=r[1],c=(r=j[Math.min(19,++i)])[0],h=r[1];return[t*(l+a*(c-o)/2+a*a*(c-2*l+o)/2),(e>0?z:-z)*(u+a*(h-s)/2+a*a*(h-2*u+s)/2)]}function y(t,e){return[t*Math.cos(e),e]}function b(t,e){var r=Math.cos(e),n=o(l(r*Math.cos(t/=2)));return[2*r*Math.sin(t)*n,Math.sin(e)*n]}function x(t,e){var r=b(t,e);return[(r[0]+t/z)/2,(r[1]+e)/2]}t.geo.project=function(t,e){var n=e.stream;if(!n)throw new Error(\"not yet supported\");return(t&&_.hasOwnProperty(t.type)?_[t.type]:r)(t,n)};var _={Feature:e,FeatureCollection:function(t,r){return{type:\"FeatureCollection\",features:t.features.map(function(t){return e(t,r)})}}},w=[],M=[],k={point:function(t,e){w.push([t,e])},result:function(){var t=w.length?w.length<2?{type:\"Point\",coordinates:w[0]}:{type:\"MultiPoint\",coordinates:w}:null;return w=[],t}},A={lineStart:n,point:function(t,e){w.push([t,e])},lineEnd:function(){w.length&&(M.push(w),w=[])},result:function(){var t=M.length?M.length<2?{type:\"LineString\",coordinates:M[0]}:{type:\"MultiLineString\",coordinates:M}:null;return M=[],t}},T={polygonStart:n,lineStart:n,point:function(t,e){w.push([t,e])},lineEnd:function(){var t=w.length;if(t){do{w.push(w[0].slice())}while(++t<4);M.push(w),w=[]}},polygonEnd:n,result:function(){if(!M.length)return null;var t=[],e=[];return M.forEach(function(r){i(r)?t.push([r]):e.push(r)}),e.forEach(function(e){var r=e[0];t.some(function(t){if(a(t[0],r))return t.push(e),!0})||t.push([e])}),M=[],t.length?t.length>1?{type:\"MultiPolygon\",coordinates:t}:{type:\"Polygon\",coordinates:t[0]}:null}},S={Point:k,MultiPoint:k,LineString:A,MultiLineString:A,Polygon:T,MultiPolygon:T,Sphere:T},E=1e-6,L=E*E,C=Math.PI,z=C/2,I=(Math.sqrt(C),C/180),D=180/C,P=t.geo.projection,O=t.geo.projectionMutator;t.geo.interrupt=function(e){function r(t,r){for(var n=r<0?-1:1,i=l[+(r<0)],a=0,o=i.length-1;a<o&&t>i[a][2][0];++a);var s=e(t-i[a][1][0],r);return s[0]+=e(i[a][1][0],n*r>n*i[a][0][1]?i[a][0][1]:r)[0],s}function n(){s=l.map(function(t){return t.map(function(t){var r,n=e(t[0][0],t[0][1])[0],i=e(t[2][0],t[2][1])[0],a=e(t[1][0],t[0][1])[1],o=e(t[1][0],t[1][1])[1];return a>o&&(r=a,a=o,o=r),[[n,a],[i,o]]})})}function i(){for(var e=1e-6,r=[],n=0,i=l[0].length;n<i;++n){var o=l[0][n],s=180*o[0][0]/C,u=180*o[0][1]/C,c=180*o[1][1]/C,h=180*o[2][0]/C,f=180*o[2][1]/C;r.push(a([[s+e,u+e],[s+e,c-e],[h-e,c-e],[h-e,f+e]],30))}for(var n=l[1].length-1;n>=0;--n){var o=l[1][n],s=180*o[0][0]/C,u=180*o[0][1]/C,c=180*o[1][1]/C,h=180*o[2][0]/C,f=180*o[2][1]/C;r.push(a([[h-e,f-e],[h-e,c+e],[s+e,c+e],[s+e,u-e]],30))}return{type:\"Polygon\",coordinates:[t.merge(r)]}}function a(t,e){for(var r,n,i,a=-1,o=t.length,s=t[0],l=[];++a<o;){r=t[a],n=(r[0]-s[0])/e,i=(r[1]-s[1])/e;for(var u=0;u<e;++u)l.push([s[0]+u*n,s[1]+u*i]);s=r}return l.push(r),l}function o(t,e){return Math.abs(t[0]-e[0])<E&&Math.abs(t[1]-e[1])<E}var s,l=[[[[-C,0],[0,z],[C,0]]],[[[-C,0],[0,-z],[C,0]]]];e.invert&&(r.invert=function(t,n){for(var i=s[+(n<0)],a=l[+(n<0)],u=0,c=i.length;u<c;++u){var h=i[u];if(h[0][0]<=t&&t<h[1][0]&&h[0][1]<=n&&n<h[1][1]){var f=e.invert(t-e(a[u][1][0],0)[0],n);return f[0]+=a[u][1][0],o(r(f[0],f[1]),[t,n])?f:null}}});var u=t.geo.projection(r),c=u.stream;return u.stream=function(e){var r=u.rotate(),n=c(e),a=(u.rotate([0,0]),c(e));return u.rotate(r),n.sphere=function(){t.geo.stream(i(),a)},n},u.lobes=function(t){return arguments.length?(l=t.map(function(t){return t.map(function(t){return[[t[0][0]*C/180,t[0][1]*C/180],[t[1][0]*C/180,t[1][1]*C/180],[t[2][0]*C/180,t[2][1]*C/180]]})}),n(),u):l.map(function(t){return t.map(function(t){return[[180*t[0][0]/C,180*t[0][1]/C],[180*t[1][0]/C,180*t[1][1]/C],[180*t[2][0]/C,180*t[2][1]/C]]})})},u},u.invert=function(t,e){var r=.5*e*Math.sqrt((4+C)/C),n=s(r),i=Math.cos(n);return[t/(2/Math.sqrt(C*(4+C))*(1+i)),s((n+r*(i+2))/(2+z))]},(t.geo.eckert4=function(){return P(u)}).raw=u;var R=t.geo.azimuthalEqualArea.raw;f.invert=function(t,e){var r=2*s(e/2);return[t*Math.cos(r/2)/Math.cos(r),r]},(t.geo.hammer=h).raw=c,d.invert=function(t,e){return[2/3*C*t/Math.sqrt(C*C/3-e*e),e]},(t.geo.kavrayskiy7=function(){return P(d)}).raw=d,p.invert=function(t,e){return[t,2.5*Math.atan(Math.exp(.8*e))-.625*C]},(t.geo.miller=function(){return P(p)}).raw=p;var F=(m(C),function(t,e,r){function n(r,n){return[t*r*Math.cos(n=i(n)),e*Math.sin(n)]}var i=m(r);return n.invert=function(n,i){var a=s(i/e);return[n/(t*Math.cos(a)),s((2*a+Math.sin(2*a))/r)]},n}(Math.SQRT2/z,Math.SQRT2,C));(t.geo.mollweide=function(){return P(F)}).raw=F,v.invert=function(t,e){var r,n=e,i=25;do{var a=n*n,o=a*a;n-=r=(n*(1.007226+a*(.015085+o*(.028874*a-.044475-.005916*o)))-e)/(1.007226+a*(.045255+o*(.259866*a-.311325-.005916*11*o)))}while(Math.abs(r)>E&&--i>0);return[t/(.8707+(a=n*n)*(a*(a*a*a*(.003971-.001529*a)-.013791)-.131979)),n]},(t.geo.naturalEarth=function(){return P(v)}).raw=v;var j=[[.9986,-.062],[1,0],[.9986,.062],[.9954,.124],[.99,.186],[.9822,.248],[.973,.31],[.96,.372],[.9427,.434],[.9216,.4958],[.8962,.5571],[.8679,.6176],[.835,.6769],[.7986,.7346],[.7597,.7903],[.7186,.8435],[.6732,.8936],[.6213,.9394],[.5722,.9761],[.5322,1]];j.forEach(function(t){t[1]*=1.0144}),g.invert=function(t,e){var r=e/z,n=90*r,i=Math.min(18,Math.abs(n/5)),a=Math.max(0,Math.floor(i));do{var o=j[a][1],s=j[a+1][1],l=j[Math.min(19,a+2)][1],u=l-o,c=l-2*s+o,h=2*(Math.abs(r)-s)/u,f=c/u,d=h*(1-f*h*(1-2*f*h));if(d>=0||1===a){n=(e>=0?5:-5)*(d+i);var p,m=50;do{i=Math.min(18,Math.abs(n)/5),a=Math.floor(i),d=i-a,o=j[a][1],s=j[a+1][1],l=j[Math.min(19,a+2)][1],n-=(p=(e>=0?z:-z)*(s+d*(l-o)/2+d*d*(l-2*s+o)/2)-e)*D}while(Math.abs(p)>L&&--m>0);break}}while(--a>=0);var v=j[a][0],g=j[a+1][0],y=j[Math.min(19,a+2)][0];return[t/(g+d*(y-v)/2+d*d*(y-2*g+v)/2),n*I]},(t.geo.robinson=function(){return P(g)}).raw=g,y.invert=function(t,e){return[t/Math.cos(e),e]},(t.geo.sinusoidal=function(){return P(y)}).raw=y,b.invert=function(t,e){if(!(t*t+4*e*e>C*C+E)){var r=t,n=e,i=25;do{var a,o=Math.sin(r),s=Math.sin(r/2),u=Math.cos(r/2),c=Math.sin(n),h=Math.cos(n),f=Math.sin(2*n),d=c*c,p=h*h,m=s*s,v=1-p*u*u,g=v?l(h*u)*Math.sqrt(a=1/v):a=0,y=2*g*h*s-t,b=g*c-e,x=a*(p*m+g*h*u*d),_=a*(.5*o*f-2*g*c*s),w=.25*a*(f*s-g*c*p*o),M=a*(d*u+g*m*h),k=_*w-M*x;if(!k)break;var A=(b*_-y*M)/k,T=(y*w-b*x)/k;r-=A,n-=T}while((Math.abs(A)>E||Math.abs(T)>E)&&--i>0);return[r,n]}},(t.geo.aitoff=function(){return P(b)}).raw=b,x.invert=function(t,e){var r=t,n=e,i=25;do{var a,o=Math.cos(n),s=Math.sin(n),u=Math.sin(2*n),c=s*s,h=o*o,f=Math.sin(r),d=Math.cos(r/2),p=Math.sin(r/2),m=p*p,v=1-h*d*d,g=v?l(o*d)*Math.sqrt(a=1/v):a=0,y=.5*(2*g*o*p+r/z)-t,b=.5*(g*s+n)-e,x=.5*a*(h*m+g*o*d*c)+.5/z,_=a*(f*u/4-g*s*p),w=.125*a*(u*p-g*s*h*f),M=.5*a*(c*d+g*m*o)+.5,k=_*w-M*x,A=(b*_-y*M)/k,T=(y*w-b*x)/k;r-=A,n-=T}while((Math.abs(A)>E||Math.abs(T)>E)&&--i>0);return[r,n]},(t.geo.winkel3=function(){return P(x)}).raw=x}e.exports=n},{}],801:[function(t,e,r){\"use strict\";function n(t,e){var r=t.projection,n=t.lonaxis,o=t.lataxis,l=t.domain,u=t.framewidth||0,c=e.w*(l.x[1]-l.x[0]),h=e.h*(l.y[1]-l.y[0]),f=n.range[0]+s,d=n.range[1]-s,p=o.range[0]+s,m=o.range[1]-s,v=n._fullRange[0]+s,g=n._fullRange[1]-s,y=o._fullRange[0]+s,b=o._fullRange[1]-s;r._translate0=[e.l+c/2,e.t+h/2];var x=d-f,_=m-p,w=[f+x/2,p+_/2],M=r._rotate;return r._center=[w[0]+M[0],w[1]+M[1]],function(e){function n(t){return Math.min(_*c/(t[1][0]-t[0][0]),_*h/(t[1][1]-t[0][1]))}var o,s,l,x,_=e.scale(),w=r._translate0,M=i(f,p,d,m),k=i(v,y,g,b);l=a(e,M),o=n(l),x=a(e,k),r._fullScale=n(x),e.scale(o),l=a(e,M),s=[w[0]-l[0][0]+u,w[1]-l[0][1]+u],r._translate=s,e.translate(s),l=a(e,M),t._isAlbersUsa||e.clipExtent(l),o=r.scale*o,r._scale=o,t._width=Math.round(l[1][0])+u,t._height=Math.round(l[1][1])+u,t._marginX=(c-Math.round(l[1][0]))/2,t._marginY=(h-Math.round(l[1][1]))/2}}function i(t,e,r,n){var i=(r-t)/4;return{type:\"Polygon\",coordinates:[[[t,e],[t,n],[t+i,n],[t+2*i,n],[t+3*i,n],[r,n],[r,e],[r-i,e],[r-2*i,e],[r-3*i,e],[t,e]]]}}function a(t,e){return o.geo.path().projection(t).bounds(e)}var o=t(\"d3\"),s=t(\"./constants\").clipPad;e.exports=n},{\"./constants\":792,d3:121}],802:[function(t,e,r){\"use strict\";function n(t,e){return(e._isScoped?a:e._clipAngle?s:o)(t,e.projection)}function i(t,e){var r=e._fullScale;return _.behavior.zoom().translate(t.translate()).scale(t.scale()).scaleExtent([.5*r,100*r])}function a(t,e){function r(){_.select(this).style(k)}function n(){o.scale(_.event.scale).translate(_.event.translate),t.render()}function a(){_.select(this).style(A)}var o=t.projection,s=i(o,e);return s.on(\"zoomstart\",r).on(\"zoom\",n).on(\"zoomend\",a),s}function o(t,e){function r(t){return v.invert(t)}function n(t){var e=v(r(t));return Math.abs(e[0]-t[0])>y||Math.abs(e[1]-t[1])>y}function a(){_.select(this).style(k),l=_.mouse(this),u=v.rotate(),c=v.translate(),h=u,f=r(l)}function o(){if(d=_.mouse(this),n(l))return g.scale(v.scale()),void g.translate(v.translate());v.scale(_.event.scale),v.translate([c[0],_.event.translate[1]]),f?r(d)&&(m=r(d),p=[h[0]+(m[0]-f[0]),u[1],u[2]],v.rotate(p),h=p):(l=d,f=r(l)),t.render()}function s(){_.select(this).style(A)}var l,u,c,h,f,d,p,m,v=t.projection,g=i(v,e),y=2;return g.on(\"zoomstart\",a).on(\"zoom\",o).on(\"zoomend\",s),g}function s(t,e){function r(t){g++||t({type:\"zoomstart\"})}function n(t){t({type:\"zoom\"})}function a(t){--g||t({type:\"zoomend\"})}var o,s=t.projection,d={r:s.rotate(),k:s.scale()},p=i(s,e),m=x(p,\"zoomstart\",\"zoom\",\"zoomend\"),g=0,y=p.on;return p.on(\"zoomstart\",function(){_.select(this).style(k);var t=_.mouse(this),e=s.rotate(),i=e,a=s.translate(),g=u(e);o=l(s,t),y.call(p,\"zoom\",function(){var r=_.mouse(this);if(s.scale(d.k=_.event.scale),o){if(l(s,r)){s.rotate(e).translate(a);var u=l(s,r),p=h(o,u),y=v(c(g,p)),b=d.r=f(y,o,i);isFinite(b[0])&&isFinite(b[1])&&isFinite(b[2])||(b=i),s.rotate(b),i=b}}else t=r,o=l(s,t);n(m.of(this,arguments))}),r(m.of(this,arguments))}).on(\"zoomend\",function(){_.select(this).style(A),y.call(p,\"zoom\",null),a(m.of(this,arguments))}).on(\"zoom.redraw\",function(){t.render()}),_.rebind(p,m,\"on\")}function l(t,e){var r=t.invert(e);return r&&isFinite(r[0])&&isFinite(r[1])&&g(r)}function u(t){var e=.5*t[0]*w,r=.5*t[1]*w,n=.5*t[2]*w,i=Math.sin(e),a=Math.cos(e),o=Math.sin(r),s=Math.cos(r),l=Math.sin(n),u=Math.cos(n);return[a*s*u+i*o*l,i*s*u-a*o*l,a*o*u+i*s*l,a*s*l-i*o*u]}function c(t,e){var r=t[0],n=t[1],i=t[2],a=t[3],o=e[0],s=e[1],l=e[2],u=e[3];return[r*o-n*s-i*l-a*u,r*s+n*o+i*u-a*l,r*l-n*u+i*o+a*s,r*u+n*l-i*s+a*o]}function h(t,e){if(t&&e){var r=b(t,e),n=Math.sqrt(y(r,r)),i=.5*Math.acos(Math.max(-1,Math.min(1,y(t,e)))),a=Math.sin(i)/n;return n&&[Math.cos(i),r[2]*a,-r[1]*a,r[0]*a]}}function f(t,e,r){var n=m(e,2,t[0]);n=m(n,1,t[1]),n=m(n,0,t[2]-r[2]);var i,a,o=e[0],s=e[1],l=e[2],u=n[0],c=n[1],h=n[2],f=Math.atan2(s,o)*M,p=Math.sqrt(o*o+s*s);Math.abs(c)>p?(a=(c>0?90:-90)-f,i=0):(a=Math.asin(c/p)*M-f,i=Math.sqrt(p*p-c*c));var v=180-a-2*f,g=(Math.atan2(h,u)-Math.atan2(l,i))*M,y=(Math.atan2(h,u)-Math.atan2(l,-i))*M;return d(r[0],r[1],a,g)<=d(r[0],r[1],v,y)?[a,g,r[2]]:[v,y,r[2]]}function d(t,e,r,n){var i=p(r-t),a=p(n-e);return Math.sqrt(i*i+a*a)}function p(t){return(t%360+540)%360-180}function m(t,e,r){var n=r*w,i=t.slice(),a=0===e?1:0,o=2===e?1:2,s=Math.cos(n),l=Math.sin(n);return i[a]=t[a]*s-t[o]*l,i[o]=t[o]*s+t[a]*l,i}function v(t){return[Math.atan2(2*(t[0]*t[1]+t[2]*t[3]),1-2*(t[1]*t[1]+t[2]*t[2]))*M,Math.asin(Math.max(-1,Math.min(1,2*(t[0]*t[2]-t[3]*t[1]))))*M,Math.atan2(2*(t[0]*t[3]+t[1]*t[2]),1-2*(t[2]*t[2]+t[3]*t[3]))*M]}function g(t){var e=t[0]*w,r=t[1]*w,n=Math.cos(r);return[n*Math.cos(e),n*Math.sin(e),Math.sin(r)]}function y(t,e){for(var r=0,n=0,i=t.length;n<i;++n)r+=t[n]*e[n];return r}function b(t,e){return[t[1]*e[2]-t[2]*e[1],t[2]*e[0]-t[0]*e[2],t[0]*e[1]-t[1]*e[0]]}function x(t){for(var e=0,r=arguments.length,n=[];++e<r;)n.push(arguments[e]);var i=_.dispatch.apply(null,n);return i.of=function(e,r){return function(n){var a;try{a=n.sourceEvent=_.event,n.target=t,_.event=n,i[n.type].apply(e,r)}finally{_.event=a}}},i}var _=t(\"d3\"),w=Math.PI/180,M=180/Math.PI,k={cursor:\"pointer\"},A={cursor:\"auto\"};e.exports=n},{d3:121}],803:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r=t.projection,n=t.zoom;return function(){t.makeProjection(e),t.makePath(),n.scale(r.scale()),n.translate(r.translate()),t.render()}}},{}],804:[function(t,e,r){\"use strict\";function n(t,e){this.element=t,this.plot=e,this.mouseListener=null,this.wheelListener=null,this.lastInputTime=Date.now(),this.lastPos=[0,0],this.boxEnabled=!1,this.boxInited=!1,this.boxStart=[0,0],this.boxEnd=[0,0],this.dragStart=[0,0]}function i(t){function e(){t.xaxis.autorange=!1,t.yaxis.autorange=!1}function r(){for(var e=t.graphDiv._fullLayout._axisConstraintGroups,r=t.xaxis._id,n=t.yaxis._id,i=0;i<e.length;i++)if(-1!==e[i][r]){if(-1!==e[i][n])return!0;break}return!1}function i(n,i,a){function o(e,r,n){var i=Math.min(r,n),a=Math.max(r,n);i!==a?(f[e]=i,f[e+2]=a,h.dataBox=f,t.setRanges(f)):(t.selectBox.selectBox=[0,0,1,1],t.glplot.setDirty())}var s,u,f=t.calcDataBox(),d=c.viewBox,p=h.lastPos[0],m=h.lastPos[1],v=l.MINDRAG*c.pixelRatio,g=l.MINZOOM*c.pixelRatio;switch(i*=c.pixelRatio,a*=c.pixelRatio,a=d[3]-d[1]-a,t.fullLayout.dragmode){case\"zoom\":if(n){var y=i/(d[2]-d[0])*(f[2]-f[0])+f[0],b=a/(d[3]-d[1])*(f[3]-f[1])+f[1];h.boxInited||(h.boxStart[0]=y,h.boxStart[1]=b,h.dragStart[0]=i,h.dragStart[1]=a),h.boxEnd[0]=y,h.boxEnd[1]=b,h.boxInited=!0,h.boxEnabled||h.boxStart[0]===h.boxEnd[0]&&h.boxStart[1]===h.boxEnd[1]||(h.boxEnabled=!0);var x=Math.abs(h.dragStart[0]-i)<g,_=Math.abs(h.dragStart[1]-a)<g;if(!r()||x&&_)x&&(h.boxEnd[0]=h.boxStart[0]),_&&(h.boxEnd[1]=h.boxStart[1]);else{s=h.boxEnd[0]-h.boxStart[0],u=h.boxEnd[1]-h.boxStart[1];var w=(f[3]-f[1])/(f[2]-f[0]);Math.abs(s*w)>Math.abs(u)?(h.boxEnd[1]=h.boxStart[1]+Math.abs(s)*w*(u>=0?1:-1),h.boxEnd[1]<f[1]?(h.boxEnd[1]=f[1],h.boxEnd[0]=h.boxStart[0]+(f[1]-h.boxStart[1])/Math.abs(w)):h.boxEnd[1]>f[3]&&(h.boxEnd[1]=f[3],h.boxEnd[0]=h.boxStart[0]+(f[3]-h.boxStart[1])/Math.abs(w))):(h.boxEnd[0]=h.boxStart[0]+Math.abs(u)/w*(s>=0?1:-1),h.boxEnd[0]<f[0]?(h.boxEnd[0]=f[0],h.boxEnd[1]=h.boxStart[1]+(f[0]-h.boxStart[0])*Math.abs(w)):h.boxEnd[0]>f[2]&&(h.boxEnd[0]=f[2],h.boxEnd[1]=h.boxStart[1]+(f[2]-h.boxStart[0])*Math.abs(w)))}}else h.boxEnabled?(s=h.boxStart[0]!==h.boxEnd[0],u=h.boxStart[1]!==h.boxEnd[1],s||u?(s&&(o(0,h.boxStart[0],h.boxEnd[0]),t.xaxis.autorange=!1),u&&(o(1,h.boxStart[1],h.boxEnd[1]),t.yaxis.autorange=!1),t.relayoutCallback()):t.glplot.setDirty(),h.boxEnabled=!1,h.boxInited=!1):h.boxInited&&(h.boxInited=!1);break;case\"pan\":h.boxEnabled=!1,h.boxInited=!1,n?(h.panning||(h.dragStart[0]=i,h.dragStart[1]=a),Math.abs(h.dragStart[0]-i)<v&&(i=h.dragStart[0]),Math.abs(h.dragStart[1]-a)<v&&(a=h.dragStart[1]),s=(p-i)*(f[2]-f[0])/(c.viewBox[2]-c.viewBox[0]),u=(m-a)*(f[3]-f[1])/(c.viewBox[3]-c.viewBox[1]),f[0]+=s,f[2]+=s,f[1]+=u,f[3]+=u,t.setRanges(f),h.panning=!0,h.lastInputTime=Date.now(),e(),t.cameraChanged(),t.handleAnnotations()):h.panning&&(h.panning=!1,t.relayoutCallback())}h.lastPos[0]=i,h.lastPos[1]=a}var u=t.mouseContainer,c=t.glplot,h=new n(u,c);return h.mouseListener=a(u,i),u.addEventListener(\"touchstart\",function(t){var e=s(t.changedTouches[0],u);i(0,e[0],e[1]),i(1,e[0],e[1])}),u.addEventListener(\"touchmove\",function(t){t.preventDefault();var e=s(t.changedTouches[0],u);i(1,e[0],e[1])}),u.addEventListener(\"touchend\",function(){i(0,h.lastPos[0],h.lastPos[1])}),h.wheelListener=o(u,function(r,n){var i=t.calcDataBox(),a=c.viewBox,o=h.lastPos[0],s=h.lastPos[1];switch(t.fullLayout.dragmode){case\"zoom\":break;case\"pan\":var l=Math.exp(.1*n/(a[3]-a[1])),u=o/(a[2]-a[0])*(i[2]-i[0])+i[0],f=s/(a[3]-a[1])*(i[3]-i[1])+i[1];i[0]=(i[0]-u)*l+u,i[2]=(i[2]-u)*l+u,i[1]=(i[1]-f)*l+f,i[3]=(i[3]-f)*l+f,t.setRanges(i),h.lastInputTime=Date.now(),e(),t.cameraChanged(),t.handleAnnotations(),t.relayoutCallback()}return!0}),h}var a=t(\"mouse-change\"),o=t(\"mouse-wheel\"),s=t(\"mouse-event-offset\"),l=t(\"../cartesian/constants\");e.exports=i},{\"../cartesian/constants\":771,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454}],805:[function(t,e,r){\"use strict\";function n(t){this.scene=t,this.gl=t.gl,this.pixelRatio=t.pixelRatio,this.screenBox=[0,0,1,1],this.viewBox=[0,0,1,1],this.dataBox=[-1,-1,1,1],this.borderLineEnable=[!1,!1,!1,!1],this.borderLineWidth=[1,1,1,1],this.borderLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.ticks=[[],[]],this.tickEnable=[!0,!0,!1,!1],this.tickPad=[15,15,15,15],this.tickAngle=[0,0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickMarkLength=[0,0,0,0],this.tickMarkWidth=[0,0,0,0],this.tickMarkColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labels=[\"x\",\"y\"],this.labelEnable=[!0,!0,!1,!1],this.labelAngle=[0,Math.PI/2,0,3*Math.PI/2],this.labelPad=[15,15,15,15],this.labelSize=[12,12],this.labelFont=[\"sans-serif\",\"sans-serif\"],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.title=\"\",this.titleEnable=!0,this.titleCenter=[0,0,0,0],this.titleAngle=0,this.titleColor=[0,0,0,1],this.titleFont=\"sans-serif\",this.titleSize=18,this.gridLineEnable=[!0,!0],this.gridLineColor=[[0,0,0,.5],[0,0,0,.5]],this.gridLineWidth=[1,1],this.zeroLineEnable=[!0,!0],this.zeroLineWidth=[1,1],this.zeroLineColor=[[0,0,0,1],[0,0,0,1]],this.borderColor=[0,0,0,0],this.backgroundColor=[0,0,0,0],this.static=this.scene.staticPlot}function i(t){return new n(t)}var a=t(\"../plots\"),o=t(\"../cartesian/axes\"),s=t(\"../../lib/html2unicode\"),l=t(\"../../lib/str2rgbarray\"),u=n.prototype,c=[\"xaxis\",\"yaxis\"];u.merge=function(t){this.titleEnable=!1,this.backgroundColor=l(t.plot_bgcolor);var e,r,n,i,a,o,u,h,f,d,p;for(d=0;d<2;++d){for(e=c[d],r=t[this.scene[e]._name],n=/Click to enter .+ title/.test(r.title)?\"\":r.title,p=0;p<=2;p+=2)this.labelEnable[d+p]=!1,this.labels[d+p]=s(n),this.labelColor[d+p]=l(r.titlefont.color),this.labelFont[d+p]=r.titlefont.family,this.labelSize[d+p]=r.titlefont.size,this.labelPad[d+p]=this.getLabelPad(e,r),this.tickEnable[d+p]=!1,this.tickColor[d+p]=l((r.tickfont||{}).color),this.tickAngle[d+p]=\"auto\"===r.tickangle?0:Math.PI*-r.tickangle/180,this.tickPad[d+p]=this.getTickPad(r),this.tickMarkLength[d+p]=0,this.tickMarkWidth[d+p]=r.tickwidth||0,this.tickMarkColor[d+p]=l(r.tickcolor),this.borderLineEnable[d+p]=!1,this.borderLineColor[d+p]=l(r.linecolor),this.borderLineWidth[d+p]=r.linewidth||0;u=this.hasSharedAxis(r),a=this.hasAxisInDfltPos(e,r)&&!u,o=this.hasAxisInAltrPos(e,r)&&!u,i=r.mirror||!1,h=u?-1!==String(i).indexOf(\"all\"):!!i,f=u?\"allticks\"===i:-1!==String(i).indexOf(\"ticks\"),a?this.labelEnable[d]=!0:o&&(this.labelEnable[d+2]=!0),a?this.tickEnable[d]=r.showticklabels:o&&(this.tickEnable[d+2]=r.showticklabels),(a||h)&&(this.borderLineEnable[d]=r.showline),(o||h)&&(this.borderLineEnable[d+2]=r.showline),(a||f)&&(this.tickMarkLength[d]=this.getTickMarkLength(r)),(o||f)&&(this.tickMarkLength[d+2]=this.getTickMarkLength(r)),this.gridLineEnable[d]=r.showgrid,this.gridLineColor[d]=l(r.gridcolor),this.gridLineWidth[d]=r.gridwidth,this.zeroLineEnable[d]=r.zeroline,this.zeroLineColor[d]=l(r.zerolinecolor),this.zeroLineWidth[d]=r.zerolinewidth}},u.hasSharedAxis=function(t){var e=this.scene,r=a.getSubplotIds(e.fullLayout,\"gl2d\");return 0!==o.findSubplotsWithAxis(r,t).indexOf(e.id)},u.hasAxisInDfltPos=function(t,e){var r=e.side;return\"xaxis\"===t?\"bottom\"===r:\"yaxis\"===t?\"left\"===r:void 0},u.hasAxisInAltrPos=function(t,e){var r=e.side;return\"xaxis\"===t?\"top\"===r:\"yaxis\"===t?\"right\"===r:void 0},u.getLabelPad=function(t,e){var r=e.titlefont.size,n=e.showticklabels;return\"xaxis\"===t?\"top\"===e.side?r*(1.5+(n?1:0))-10:r*(1.5+(n?.5:0))-10:\"yaxis\"===t?\"right\"===e.side?10+r*(1.5+(n?1:.5)):10+r*(1.5+(n?.5:0)):void 0},u.getTickPad=function(t){return\"outside\"===t.ticks?10+t.ticklen:15},u.getTickMarkLength=function(t){if(!t.ticks)return 0;var e=t.ticklen;return\"inside\"===t.ticks?-e:e},e.exports=i},{\"../../lib/html2unicode\":723,\"../../lib/str2rgbarray\":744,\"../cartesian/axes\":766,\"../plots\":829}],806:[function(t,e,r){\"use strict\";var n=t(\"./scene2d\"),i=t(\"../plots\"),a=t(\"../../constants/xmlns_namespaces\"),o=t(\"../cartesian/constants\"),s=t(\"../cartesian\");r.name=\"gl2d\",r.attr=[\"xaxis\",\"yaxis\"],r.idRoot=[\"x\",\"y\"],r.idRegex=o.idRegex,r.attrRegex=o.attrRegex,r.attributes=t(\"../cartesian/attributes\"),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,a=i.getSubplotIds(e,\"gl2d\"),o=0;o<a.length;o++){var s=a[o],l=e._plots[s],u=i.getSubplotData(r,\"gl2d\",s),c=l._scene2d;void 0===c&&(c=new n({id:s,graphDiv:t,container:t.querySelector(\".gl-container\"),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio},e),l._scene2d=c),c.plot(u,t.calcdata,e,t.layout)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"gl2d\"),o=0;o<a.length;o++){var l=a[o],u=n._plots[l];if(u._scene2d){0===i.getSubplotData(t,\"gl2d\",l).length&&(u._scene2d.destroy(),delete n._plots[l])}}s.clean.apply(this,arguments)},r.drawFramework=function(t){t._context.staticPlot||s.drawFramework(t)},r.toSVG=function(t){for(var e=t._fullLayout,r=i.getSubplotIds(e,\"gl2d\"),n=0;n<r.length;n++){var o=e._plots[r[n]],s=o._scene2d,l=s.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:a.svg,\"xlink:href\":l,x:0,y:0,width:\"100%\",height:\"100%\",preserveAspectRatio:\"none\"}),s.destroy()}}},{\"../../constants/xmlns_namespaces\":707,\"../cartesian\":776,\"../cartesian/attributes\":765,\"../cartesian/constants\":771,\"../plots\":829,\"./scene2d\":807}],807:[function(t,e,r){\"use strict\";function n(t,e){this.container=t.container,this.graphDiv=t.graphDiv,this.pixelRatio=t.plotGlPixelRatio||window.devicePixelRatio,this.id=t.id,this.staticPlot=!!t.staticPlot,this.fullData=null,this.updateRefs(e),this.makeFramework(),this.glplotOptions=p(this),this.glplotOptions.merge(e),this.glplot=c(this.glplotOptions),this.camera=m(this),this.traces={},this.spikes=h(this.glplot),this.selectBox=f(this.glplot,{innerFill:!1,outerFill:!0}),this.lastButtonState=0,this.pickResult=null,this.isMouseOver=!0,this.bounds=[1/0,1/0,-1/0,-1/0],this.stopped=!1,this.redraw=this.draw.bind(this),this.redraw()}function i(t,e){for(var r=0;r<2;++r){var n=t[r],i=e[r];if(n.length!==i.length)return!0;for(var a=0;a<n.length;++a)if(n[a].x!==i[a].x)return!0}return!1}var a,o,s=t(\"../../registry\"),l=t(\"../../plots/cartesian/axes\"),u=t(\"../../components/fx\"),c=t(\"gl-plot2d\"),h=t(\"gl-spikes2d\"),f=t(\"gl-select-box\"),d=t(\"webgl-context\"),p=t(\"./convert\"),m=t(\"./camera\"),v=t(\"../../lib/html2unicode\"),g=t(\"../../lib/show_no_webgl_msg\"),y=t(\"../../plots/cartesian/constraints\"),b=y.enforce,x=y.clean,_=[\"xaxis\",\"yaxis\"];e.exports=n;var w=n.prototype;w.makeFramework=function(){if(this.staticPlot){if(!(o||(a=document.createElement(\"canvas\"),o=d({canvas:a,preserveDrawingBuffer:!1,premultipliedAlpha:!0,antialias:!0}))))throw new Error(\"Error creating static canvas/context for image server\");this.canvas=a,this.gl=o}else{var t=document.createElement(\"canvas\"),e=d({canvas:t,premultipliedAlpha:!0});e||g(this),this.canvas=t,this.gl=e}var r=this.canvas;r.style.width=\"100%\",r.style.height=\"100%\",r.style.position=\"absolute\",r.style.top=\"0px\",r.style.left=\"0px\",r.style[\"pointer-events\"]=\"none\",this.updateSize(r),r.className+=\"user-select-none\";var n=this.svgContainer=document.createElementNS(\"http://www.w3.org/2000/svg\",\"svg\");n.style.position=\"absolute\",n.style.top=n.style.left=\"0px\",n.style.width=n.style.height=\"100%\",n.style[\"z-index\"]=20,n.style[\"pointer-events\"]=\"none\";var i=this.mouseContainer=document.createElement(\"div\");i.style.position=\"absolute\",i.style[\"pointer-events\"]=\"auto\";var s=this.container;s.appendChild(r),s.appendChild(n),s.appendChild(i);var l=this;i.addEventListener(\"mouseout\",function(){l.isMouseOver=!1,l.unhover()}),i.addEventListener(\"mouseover\",function(){l.isMouseOver=!0})},w.toImage=function(t){t||(t=\"png\"),this.stopped=!0,this.staticPlot&&this.container.appendChild(a),this.updateSize(this.canvas),this.glplot.setDirty(),this.glplot.draw();var e=this.glplot.gl,r=e.drawingBufferWidth,n=e.drawingBufferHeight;e.bindFramebuffer(e.FRAMEBUFFER,null);var i=new Uint8Array(r*n*4);e.readPixels(0,0,r,n,e.RGBA,e.UNSIGNED_BYTE,i);for(var o=0,s=n-1;o<s;++o,--s)for(var l=0;l<r;++l)for(var u=0;u<4;++u){var c=i[4*(r*o+l)+u];i[4*(r*o+l)+u]=i[4*(r*s+l)+u],i[4*(r*s+l)+u]=c}var h=document.createElement(\"canvas\");h.width=r,h.height=n;var f=h.getContext(\"2d\"),d=f.createImageData(r,n);d.data.set(i),f.putImageData(d,0,0);var p;switch(t){case\"jpeg\":p=h.toDataURL(\"image/jpeg\");break;case\"webp\":p=h.toDataURL(\"image/webp\");break;default:p=h.toDataURL(\"image/png\")}return this.staticPlot&&this.container.removeChild(a),p},w.updateSize=function(t){t||(t=this.canvas);var e=this.pixelRatio,r=this.fullLayout,n=r.width,i=r.height,a=0|Math.ceil(e*n),o=0|Math.ceil(e*i);return t.width===a&&t.height===o||(t.width=a,t.height=o),this.redraw&&this.redraw(),t},w.computeTickMarks=function(){this.xaxis.setScale(),this.yaxis.setScale();for(var t=[l.calcTicks(this.xaxis),l.calcTicks(this.yaxis)],e=0;e<2;++e)for(var r=0;r<t[e].length;++r)t[e][r].text=v(t[e][r].text+\"\");return t},w.updateRefs=function(t){this.fullLayout=t;var e=l.subplotMatch,r=\"xaxis\"+this.id.match(e)[1],n=\"yaxis\"+this.id.match(e)[2];this.xaxis=this.fullLayout[r],this.yaxis=this.fullLayout[n]},w.relayoutCallback=function(){var t=this.graphDiv,e=this.xaxis,r=this.yaxis,n=t.layout;n.xaxis.autorange=e.autorange,n.xaxis.range=e.range.slice(0),n.yaxis.autorange=r.autorange,n.yaxis.range=r.range.slice(0);var i={lastInputTime:this.camera.lastInputTime};i[e._name]=e.range.slice(0),i[r._name]=r.range.slice(0),t.emit(\"plotly_relayout\",i)},w.cameraChanged=function(){var t=this.camera;this.glplot.setDataBox(this.calcDataBox());var e=this.computeTickMarks()\n",
       ";i(e,this.glplotOptions.ticks)&&(this.glplotOptions.ticks=e,this.glplotOptions.dataBox=t.dataBox,this.glplot.update(this.glplotOptions),this.handleAnnotations())},w.handleAnnotations=function(){for(var t=this.graphDiv,e=this.fullLayout.annotations,r=0;r<e.length;r++){var n=e[r];n.xref===this.xaxis._id&&n.yref===this.yaxis._id&&s.getComponentMethod(\"annotations\",\"drawOne\")(t,r)}},w.destroy=function(){if(this.glplot){var t=this.traces;t&&Object.keys(t).map(function(e){t[e].dispose(),delete t[e]}),this.glplot.dispose(),this.staticPlot||this.container.removeChild(this.canvas),this.container.removeChild(this.svgContainer),this.container.removeChild(this.mouseContainer),this.fullData=null,this.glplot=null,this.stopped=!0,this.camera.mouseListener.enabled=!1,this.mouseContainer.removeEventListener(\"wheel\",this.camera.wheelListener),this.camera=null}},w.plot=function(t,e,r){var n=this.glplot;this.updateRefs(r),this.updateTraces(t,e),this.updateFx(r.dragmode);var i=r.width,a=r.height;this.updateSize(this.canvas);var o=this.glplotOptions;o.merge(r),o.screenBox=[0,0,i,a];var s={_fullLayout:{_axisConstraintGroups:this.graphDiv._fullLayout._axisConstraintGroups,xaxis:this.xaxis,yaxis:this.yaxis}};x(s,this.xaxis),x(s,this.yaxis);var u=r._size,c=this.xaxis.domain,h=this.yaxis.domain;o.viewBox=[u.l+c[0]*u.w,u.b+h[0]*u.h,i-u.r-(1-c[1])*u.w,a-u.t-(1-h[1])*u.h],this.mouseContainer.style.width=u.w*(c[1]-c[0])+\"px\",this.mouseContainer.style.height=u.h*(h[1]-h[0])+\"px\",this.mouseContainer.height=u.h*(h[1]-h[0]),this.mouseContainer.style.left=u.l+c[0]*u.w+\"px\",this.mouseContainer.style.top=u.t+(1-h[1])*u.h+\"px\";var f=this.bounds;f[0]=f[1]=1/0,f[2]=f[3]=-1/0;var d,p,m=Object.keys(this.traces);for(p=0;p<m.length;++p)for(var v=this.traces[m[p]],g=0;g<2;++g)f[g]=Math.min(f[g],v.bounds[g]),f[g+2]=Math.max(f[g+2],v.bounds[g+2]);for(p=0;p<2;++p)f[p]>f[p+2]&&(f[p]=-1,f[p+2]=1),d=this[_[p]],d._length=o.viewBox[p+2]-o.viewBox[p],l.doAutoRange(d),d.setScale();b(s),o.ticks=this.computeTickMarks(),o.dataBox=this.calcDataBox(),o.merge(r),n.update(o),this.glplot.draw()},w.calcDataBox=function(){var t=this.xaxis,e=this.yaxis,r=t.range,n=e.range,i=t.r2l,a=e.r2l;return[i(r[0]),a(n[0]),i(r[1]),a(n[1])]},w.setRanges=function(t){var e=this.xaxis,r=this.yaxis,n=e.l2r,i=r.l2r;e.range=[n(t[0]),n(t[2])],r.range=[i(t[1]),i(t[3])]},w.updateTraces=function(t,e){var r,n,i,a=Object.keys(this.traces);this.fullData=t;t:for(r=0;r<a.length;r++){var o=a[r],s=this.traces[o];for(n=0;n<t.length;n++)if(i=t[n],i.uid===o&&i.type===s.type)continue t;s.dispose(),delete this.traces[o]}for(r=0;r<t.length;r++){i=t[r];var l=e[r],u=this.traces[i.uid];u?u.update(i,l):(u=i._module.plot(this,i,l),this.traces[i.uid]=u)}this.glplot.objects.sort(function(t,e){return t._trace.index-e._trace.index})},w.updateFx=function(t){this.mouseContainer.style[\"pointer-events\"]=\"lasso\"===t||\"select\"===t?\"none\":\"auto\",this.mouseContainer.style.cursor=\"pan\"===t?\"move\":\"zoom\"===t?\"crosshair\":null},w.emitPointAction=function(t,e){for(var r,n=t.trace.uid,i=t.pointIndex,a=0;a<this.fullData.length;a++)this.fullData[a].uid===n&&(r=this.fullData[a]);var o={x:t.traceCoord[0],y:t.traceCoord[1],curveNumber:r.index,pointNumber:i,data:r._input,fullData:this.fullData,xaxis:this.xaxis,yaxis:this.yaxis};u.appendArrayPointValue(o,r,i),this.graphDiv.emit(e,{points:[o]})},w.draw=function(){if(!this.stopped){requestAnimationFrame(this.redraw);var t=this.glplot,e=this.camera,r=e.mouseListener,n=1===this.lastButtonState&&0===r.buttons,i=this.fullLayout;this.lastButtonState=r.buttons,this.cameraChanged();var a,o=r.x*t.pixelRatio,s=this.canvas.height-t.pixelRatio*r.y;if(e.boxEnabled&&\"zoom\"===i.dragmode){this.selectBox.enabled=!0;for(var l=this.selectBox.selectBox=[Math.min(e.boxStart[0],e.boxEnd[0]),Math.min(e.boxStart[1],e.boxEnd[1]),Math.max(e.boxStart[0],e.boxEnd[0]),Math.max(e.boxStart[1],e.boxEnd[1])],c=0;c<2;c++)e.boxStart[c]===e.boxEnd[c]&&(l[c]=t.dataBox[c],l[c+2]=t.dataBox[c+2]);t.setDirty()}else if(!e.panning&&this.isMouseOver){this.selectBox.enabled=!1;var h=i._size,f=this.xaxis.domain,d=this.yaxis.domain;a=t.pick(o/t.pixelRatio+h.l+f[0]*h.w,s/t.pixelRatio-(h.t+(1-d[1])*h.h));var p=a&&a.object._trace.handlePick(a);if(p&&n&&this.emitPointAction(p,\"plotly_click\"),a&&\"skip\"!==a.object._trace.hoverinfo&&i.hovermode&&p&&(!this.lastPickResult||this.lastPickResult.traceUid!==p.trace.uid||this.lastPickResult.dataCoord[0]!==p.dataCoord[0]||this.lastPickResult.dataCoord[1]!==p.dataCoord[1])){var m=p;this.lastPickResult={traceUid:p.trace?p.trace.uid:null,dataCoord:p.dataCoord.slice()},this.spikes.update({center:a.dataCoord}),m.screenCoord=[((t.viewBox[2]-t.viewBox[0])*(a.dataCoord[0]-t.dataBox[0])/(t.dataBox[2]-t.dataBox[0])+t.viewBox[0])/t.pixelRatio,(this.canvas.height-(t.viewBox[3]-t.viewBox[1])*(a.dataCoord[1]-t.dataBox[1])/(t.dataBox[3]-t.dataBox[1])-t.viewBox[1])/t.pixelRatio],this.emitPointAction(p,\"plotly_hover\");var v=this.fullData[m.trace.index]||{},g=m.pointIndex,y=u.castHoverinfo(v,i,g);if(y&&\"all\"!==y){var b=y.split(\"+\");-1===b.indexOf(\"x\")&&(m.traceCoord[0]=void 0),-1===b.indexOf(\"y\")&&(m.traceCoord[1]=void 0),-1===b.indexOf(\"z\")&&(m.traceCoord[2]=void 0),-1===b.indexOf(\"text\")&&(m.textLabel=void 0),-1===b.indexOf(\"name\")&&(m.name=void 0)}u.loneHover({x:m.screenCoord[0],y:m.screenCoord[1],xLabel:this.hoverFormatter(\"xaxis\",m.traceCoord[0]),yLabel:this.hoverFormatter(\"yaxis\",m.traceCoord[1]),zLabel:m.traceCoord[2],text:m.textLabel,name:m.name,color:u.castHoverOption(v,g,\"bgcolor\")||m.color,borderColor:u.castHoverOption(v,g,\"bordercolor\"),fontFamily:u.castHoverOption(v,g,\"font.family\"),fontSize:u.castHoverOption(v,g,\"font.size\"),fontColor:u.castHoverOption(v,g,\"font.color\")},{container:this.svgContainer,gd:this.graphDiv})}}a||this.unhover(),t.draw()}},w.unhover=function(){this.lastPickResult&&(this.spikes.update({}),this.lastPickResult=null,this.graphDiv.emit(\"plotly_unhover\"),u.loneUnhover(this.svgContainer))},w.hoverFormatter=function(t,e){if(void 0!==e){var r=this[t];return l.tickText(r,r.c2l(e),\"hover\").text}}},{\"../../components/fx\":644,\"../../lib/html2unicode\":723,\"../../lib/show_no_webgl_msg\":742,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/constraints\":773,\"../../registry\":844,\"./camera\":804,\"./convert\":805,\"gl-plot2d\":218,\"gl-select-box\":252,\"gl-spikes2d\":261,\"webgl-context\":562}],808:[function(t,e,r){\"use strict\";function n(t,e){function r(e,r,n,a){var o=p.keyBindingMode;if(!1!==o){var s=\"rotate\"===o,l=\"pan\"===o,c=\"zoom\"===o,f=!!a.control,d=!!a.alt,y=!!a.shift,b=!!(1&e),x=!!(2&e),_=!!(4&e),w=1/t.clientHeight,M=w*(r-m),k=w*(n-v),A=p.flipX?1:-1,T=p.flipY?1:-1,S=i(),E=Math.PI*p.rotateSpeed;if((s&&b&&!f&&!d&&!y||b&&!f&&!d&&y)&&u.rotate(S,A*E*M,-T*E*k,0),(l&&b&&!f&&!d&&!y||x||b&&f&&!d&&!y)&&u.pan(S,-p.translateSpeed*M*h,p.translateSpeed*k*h,0),c&&b&&!f&&!d&&!y||_||b&&!f&&d&&!y){var L=-p.zoomSpeed*k/window.innerHeight*(S-u.lastT())*100;u.pan(S,0,0,h*(Math.exp(L)-1))}return m=r,v=n,g=a,!0}}t=t||document.body,e=e||{};var n=[.01,1/0];\"distanceLimits\"in e&&(n[0]=e.distanceLimits[0],n[1]=e.distanceLimits[1]),\"zoomMin\"in e&&(n[0]=e.zoomMin),\"zoomMax\"in e&&(n[1]=e.zoomMax);var u=a({center:e.center||[0,0,0],up:e.up||[0,1,0],eye:e.eye||[0,0,10],mode:e.mode||\"orbit\",distanceLimits:n}),c=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],h=0,f=t.clientWidth,d=t.clientHeight,p={keyBindingMode:\"rotate\",view:u,element:t,delay:e.delay||16,rotateSpeed:e.rotateSpeed||1,zoomSpeed:e.zoomSpeed||1,translateSpeed:e.translateSpeed||1,flipX:!!e.flipX,flipY:!!e.flipY,modes:u.modes,tick:function(){var e=i(),r=this.delay,n=e-2*r;u.idle(e-r),u.recalcMatrix(n),u.flush(e-(100+2*r));for(var a=!0,o=u.computedMatrix,s=0;s<16;++s)a=a&&c[s]===o[s],c[s]=o[s];var l=t.clientWidth===f&&t.clientHeight===d;return f=t.clientWidth,d=t.clientHeight,a?!l:(h=Math.exp(u.computedRadius[0]),!0)},lookAt:function(t,e,r){u.lookAt(u.lastT(),t,e,r)},rotate:function(t,e,r){u.rotate(u.lastT(),t,e,r)},pan:function(t,e,r){u.pan(u.lastT(),t,e,r)},translate:function(t,e,r){u.translate(u.lastT(),t,e,r)}};Object.defineProperties(p,{matrix:{get:function(){return u.computedMatrix},set:function(t){return u.setMatrix(u.lastT(),t),u.computedMatrix},enumerable:!0},mode:{get:function(){return u.getMode()},set:function(t){var e=u.computedUp.slice(),r=u.computedEye.slice(),n=u.computedCenter.slice();if(u.setMode(t),\"turntable\"===t){var a=i();u._active.lookAt(a,r,n,e),u._active.lookAt(a+500,r,n,[0,0,1]),u._active.flush(a)}return u.getMode()},enumerable:!0},center:{get:function(){return u.computedCenter},set:function(t){return u.lookAt(u.lastT(),null,t),u.computedCenter},enumerable:!0},eye:{get:function(){return u.computedEye},set:function(t){return u.lookAt(u.lastT(),t),u.computedEye},enumerable:!0},up:{get:function(){return u.computedUp},set:function(t){return u.lookAt(u.lastT(),null,null,t),u.computedUp},enumerable:!0},distance:{get:function(){return h},set:function(t){return u.setDistance(u.lastT(),t),t},enumerable:!0},distanceLimits:{get:function(){return u.getDistanceLimits(n)},set:function(t){return u.setDistanceLimits(t),t},enumerable:!0}}),t.addEventListener(\"contextmenu\",function(t){return t.preventDefault(),!1});var m=0,v=0,g={shift:!1,control:!1,alt:!1,meta:!1};return p.mouseListener=o(t,r),t.addEventListener(\"touchstart\",function(e){var n=l(e.changedTouches[0],t);r(0,n[0],n[1],g),r(1,n[0],n[1],g)}),t.addEventListener(\"touchmove\",function(e){var n=l(e.changedTouches[0],t);r(1,n[0],n[1],g)}),t.addEventListener(\"touchend\",function(){r(0,m,v,g)}),p.wheelListener=s(t,function(t,e){if(!1!==p.keyBindingMode){var r=p.flipX?1:-1,n=p.flipY?1:-1,a=i();if(Math.abs(t)>Math.abs(e))u.rotate(a,0,0,-t*r*Math.PI*p.rotateSpeed/window.innerWidth);else{var o=-p.zoomSpeed*n*e/window.innerHeight*(a-u.lastT())/100;u.pan(a,0,0,h*(Math.exp(o)-1))}}},!0),p}e.exports=n;var i=t(\"right-now\"),a=t(\"3d-view\"),o=t(\"mouse-change\"),s=t(\"mouse-wheel\"),l=t(\"mouse-event-offset\")},{\"3d-view\":36,\"mouse-change\":451,\"mouse-event-offset\":452,\"mouse-wheel\":454,\"right-now\":501}],809:[function(t,e,r){\"use strict\";var n=t(\"./scene\"),i=t(\"../plots\"),a=t(\"../../lib\"),o=t(\"../../constants/xmlns_namespaces\");r.name=\"gl3d\",r.attr=\"scene\",r.idRoot=\"scene\",r.idRegex=/^scene([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^scene([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){for(var e=t._fullLayout,r=t._fullData,o=i.getSubplotIds(e,\"gl3d\"),s=0;s<o.length;s++){var l=o[s],u=i.getSubplotData(r,\"gl3d\",l),c=e[l],h=c._scene;h||(h=new n({id:l,graphDiv:t,container:t.querySelector(\".gl-container\"),staticPlot:t._context.staticPlot,plotGlPixelRatio:t._context.plotGlPixelRatio},e),c._scene=h),h.cameraInitial||(h.cameraInitial=a.extendDeep({},c.camera)),h.plot(u,e,t.layout)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"gl3d\"),o=0;o<a.length;o++){var s=a[o];!e[s]&&n[s]._scene&&(n[s]._scene.destroy(),n._infolayer&&n._infolayer.selectAll(\".annotation-\"+s).remove())}},r.toSVG=function(t){for(var e=t._fullLayout,r=i.getSubplotIds(e,\"gl3d\"),n=e._size,a=0;a<r.length;a++){var s=e[r[a]],l=s.domain,u=s._scene,c=u.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:o.svg,\"xlink:href\":c,x:n.l+n.w*l.x[0],y:n.t+n.h*(1-l.y[1]),width:n.w*(l.x[1]-l.x[0]),height:n.h*(l.y[1]-l.y[0]),preserveAspectRatio:\"none\"}),u.destroy()}},r.cleanId=function(t){if(t.match(/^scene[0-9]*$/)){var e=t.substr(5);return\"1\"===e&&(e=\"\"),\"scene\"+e}}},{\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../plots\":829,\"./layout/attributes\":810,\"./layout/defaults\":814,\"./layout/layout_attributes\":815,\"./scene\":819}],810:[function(t,e,r){\"use strict\";e.exports={scene:{valType:\"subplotid\",dflt:\"scene\"}}},{}],811:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color\"),i=t(\"../../cartesian/layout_attributes\"),a=t(\"../../../lib/extend\").extendFlat;e.exports={visible:i.visible,showspikes:{valType:\"boolean\",dflt:!0},spikesides:{valType:\"boolean\",dflt:!0},spikethickness:{valType:\"number\",min:0,dflt:2},spikecolor:{valType:\"color\",dflt:n.defaultLine},showbackground:{valType:\"boolean\",dflt:!1},backgroundcolor:{valType:\"color\",dflt:\"rgba(204, 204, 204, 0.5)\"},showaxeslabels:{valType:\"boolean\",dflt:!0},color:i.color,categoryorder:i.categoryorder,categoryarray:i.categoryarray,title:i.title,titlefont:i.titlefont,type:i.type,autorange:i.autorange,rangemode:i.rangemode,range:i.range,tickmode:i.tickmode,nticks:i.nticks,tick0:i.tick0,dtick:i.dtick,tickvals:i.tickvals,ticktext:i.ticktext,ticks:i.ticks,mirror:i.mirror,ticklen:i.ticklen,tickwidth:i.tickwidth,tickcolor:i.tickcolor,showticklabels:i.showticklabels,tickfont:i.tickfont,tickangle:i.tickangle,tickprefix:i.tickprefix,showtickprefix:i.showtickprefix,ticksuffix:i.ticksuffix,showticksuffix:i.showticksuffix,showexponent:i.showexponent,exponentformat:i.exponentformat,separatethousands:i.separatethousands,tickformat:i.tickformat,hoverformat:i.hoverformat,showline:i.showline,linecolor:i.linecolor,linewidth:i.linewidth,showgrid:i.showgrid,gridcolor:a({},i.gridcolor,{dflt:\"rgb(204, 204, 204)\"}),gridwidth:i.gridwidth,zeroline:i.zeroline,zerolinecolor:i.zerolinecolor,zerolinewidth:i.zerolinewidth}},{\"../../../components/color\":603,\"../../../lib/extend\":716,\"../../cartesian/layout_attributes\":777}],812:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../../lib\"),a=t(\"./axis_attributes\"),o=t(\"../../cartesian/type_defaults\"),s=t(\"../../cartesian/axis_defaults\"),l=[\"xaxis\",\"yaxis\",\"zaxis\"];e.exports=function(t,e,r){function u(t,e){return i.coerce(c,h,a,t,e)}for(var c,h,f=0;f<l.length;f++){var d=l[f];c=t[d]||{},h=e[d]={_id:d[0]+r.scene,_name:d},o(c,h,u,r.data),s(c,h,u,{font:r.font,letter:d[0],data:r.data,showGrid:!0,bgColor:r.bgColor,calendar:r.calendar}),u(\"gridcolor\",n(h.color,r.bgColor,13600/187).toRgbString()),u(\"title\",d[0]),h.setScale=i.noop,u(\"showspikes\")&&(u(\"spikesides\"),u(\"spikethickness\"),u(\"spikecolor\",h.color)),u(\"showaxeslabels\"),u(\"showbackground\")&&u(\"backgroundcolor\")}}},{\"../../../lib\":725,\"../../cartesian/axis_defaults\":768,\"../../cartesian/type_defaults\":788,\"./axis_attributes\":811,tinycolor2:533}],813:[function(t,e,r){\"use strict\";function n(){this.bounds=[[-10,-10,-10],[10,10,10]],this.ticks=[[],[],[]],this.tickEnable=[!0,!0,!0],this.tickFont=[\"sans-serif\",\"sans-serif\",\"sans-serif\"],this.tickSize=[12,12,12],this.tickAngle=[0,0,0],this.tickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.tickPad=[18,18,18],this.labels=[\"x\",\"y\",\"z\"],this.labelEnable=[!0,!0,!0],this.labelFont=[\"Open Sans\",\"Open Sans\",\"Open Sans\"],this.labelSize=[20,20,20],this.labelAngle=[0,0,0],this.labelColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.labelPad=[30,30,30],this.lineEnable=[!0,!0,!0],this.lineMirror=[!1,!1,!1],this.lineWidth=[1,1,1],this.lineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.lineTickEnable=[!0,!0,!0],this.lineTickMirror=[!1,!1,!1],this.lineTickLength=[10,10,10],this.lineTickWidth=[1,1,1],this.lineTickColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.gridEnable=[!0,!0,!0],this.gridWidth=[1,1,1],this.gridColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroEnable=[!0,!0,!0],this.zeroLineColor=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.zeroLineWidth=[2,2,2],this.backgroundEnable=[!0,!0,!0],this.backgroundColor=[[.8,.8,.8,.5],[.8,.8,.8,.5],[.8,.8,.8,.5]],this._defaultTickPad=this.tickPad.slice(),this._defaultLabelPad=this.labelPad.slice(),this._defaultLineTickLength=this.lineTickLength.slice()}function i(t){var e=new n;return e.merge(t),e}var a=t(\"../../../lib/html2unicode\"),o=t(\"../../../lib/str2rgbarray\"),s=[\"xaxis\",\"yaxis\",\"zaxis\"];n.prototype.merge=function(t){for(var e=this,r=0;r<3;++r){var n=t[s[r]];n.visible?(e.labels[r]=a(n.title),\"titlefont\"in n&&(n.titlefont.color&&(e.labelColor[r]=o(n.titlefont.color)),n.titlefont.family&&(e.labelFont[r]=n.titlefont.family),n.titlefont.size&&(e.labelSize[r]=n.titlefont.size)),\"showline\"in n&&(e.lineEnable[r]=n.showline),\"linecolor\"in n&&(e.lineColor[r]=o(n.linecolor)),\"linewidth\"in n&&(e.lineWidth[r]=n.linewidth),\"showgrid\"in n&&(e.gridEnable[r]=n.showgrid),\"gridcolor\"in n&&(e.gridColor[r]=o(n.gridcolor)),\"gridwidth\"in n&&(e.gridWidth[r]=n.gridwidth),\"log\"===n.type?e.zeroEnable[r]=!1:\"zeroline\"in n&&(e.zeroEnable[r]=n.zeroline),\"zerolinecolor\"in n&&(e.zeroLineColor[r]=o(n.zerolinecolor)),\"zerolinewidth\"in n&&(e.zeroLineWidth[r]=n.zerolinewidth),\"ticks\"in n&&n.ticks?e.lineTickEnable[r]=!0:e.lineTickEnable[r]=!1,\"ticklen\"in n&&(e.lineTickLength[r]=e._defaultLineTickLength[r]=n.ticklen),\"tickcolor\"in n&&(e.lineTickColor[r]=o(n.tickcolor)),\"tickwidth\"in n&&(e.lineTickWidth[r]=n.tickwidth),\"tickangle\"in n&&(e.tickAngle[r]=\"auto\"===n.tickangle?0:Math.PI*-n.tickangle/180),\"showticklabels\"in n&&(e.tickEnable[r]=n.showticklabels),\"tickfont\"in n&&(n.tickfont.color&&(e.tickColor[r]=o(n.tickfont.color)),n.tickfont.family&&(e.tickFont[r]=n.tickfont.family),n.tickfont.size&&(e.tickSize[r]=n.tickfont.size)),\"mirror\"in n?-1!==[\"ticks\",\"all\",\"allticks\"].indexOf(n.mirror)?(e.lineTickMirror[r]=!0,e.lineMirror[r]=!0):!0===n.mirror?(e.lineTickMirror[r]=!1,e.lineMirror[r]=!0):(e.lineTickMirror[r]=!1,e.lineMirror[r]=!1):e.lineMirror[r]=!1,\"showbackground\"in n&&!1!==n.showbackground?(e.backgroundEnable[r]=!0,e.backgroundColor[r]=o(n.backgroundcolor)):e.backgroundEnable[r]=!1):(e.tickEnable[r]=!1,e.labelEnable[r]=!1,e.lineEnable[r]=!1,e.lineTickEnable[r]=!1,e.gridEnable[r]=!1,e.zeroEnable[r]=!1,e.backgroundEnable[r]=!1)}},e.exports=i},{\"../../../lib/html2unicode\":723,\"../../../lib/str2rgbarray\":744}],814:[function(t,e,r){\"use strict\";function n(t,e,r,n){for(var i=r(\"bgcolor\"),s=a.combine(i,n.paper_bgcolor),c=Object.keys(u.camera),h=0;h<c.length;h++)r(\"camera.\"+c[h]+\".x\"),r(\"camera.\"+c[h]+\".y\"),r(\"camera.\"+c[h]+\".z\");var f=!!r(\"aspectratio.x\")&&!!r(\"aspectratio.y\")&&!!r(\"aspectratio.z\"),d=f?\"manual\":\"auto\",p=r(\"aspectmode\",d);f||(t.aspectratio=e.aspectratio={x:1,y:1,z:1},\"manual\"===p&&(e.aspectmode=\"auto\")),l(t,e,{font:n.font,scene:n.id,data:n.fullData,bgColor:s,calendar:n.calendar}),o.getComponentMethod(\"annotations3d\",\"handleDefaults\")(t,e,n),r(\"dragmode\",n.getDfltFromLayout(\"dragmode\")),r(\"hovermode\",n.getDfltFromLayout(\"hovermode\"))}var i=t(\"../../../lib\"),a=t(\"../../../components/color\"),o=t(\"../../../registry\"),s=t(\"../../subplot_defaults\"),l=t(\"./axis_defaults\"),u=t(\"./layout_attributes\");e.exports=function(t,e,r){function a(e){if(!o){return i.validate(t[e],u[e])?t[e]:void 0}}var o=e._basePlotModules.length>1;s(t,e,r,{type:\"gl3d\",attributes:u,handleDefaults:n,fullLayout:e,font:e.font,fullData:r,getDfltFromLayout:a,paper_bgcolor:e.paper_bgcolor,calendar:e.calendar})}},{\"../../../components/color\":603,\"../../../lib\":725,\"../../../registry\":844,\"../../subplot_defaults\":836,\"./axis_defaults\":812,\"./layout_attributes\":815}],815:[function(t,e,r){\"use strict\";function n(t,e,r){return{x:{valType:\"number\",dflt:t},y:{valType:\"number\",dflt:e},z:{valType:\"number\",dflt:r}}}var i=t(\"./axis_attributes\"),a=t(\"../../../lib/extend\").extendFlat;e.exports={_arrayAttrRegexps:[/^scene([2-9]|[1-9][0-9]+)?\\.annotations/],bgcolor:{valType:\"color\",dflt:\"rgba(0,0,0,0)\"},camera:{up:a(n(0,0,1),{}),center:a(n(0,0,0),{}),eye:a(n(1.25,1.25,1.25),{})},domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},aspectmode:{valType:\"enumerated\",values:[\"auto\",\"cube\",\"data\",\"manual\"],dflt:\"auto\"},aspectratio:{x:{valType:\"number\",min:0},y:{valType:\"number\",min:0},z:{valType:\"number\",min:0}},xaxis:i,yaxis:i,zaxis:i,dragmode:{valType:\"enumerated\",values:[\"orbit\",\"turntable\",\"zoom\",\"pan\",!1],dflt:\"turntable\"},hovermode:{valType:\"enumerated\",values:[\"closest\",!1],dflt:\"closest\"},_deprecated:{cameraposition:{valType:\"info_array\"}}}},{\"../../../lib/extend\":716,\"./axis_attributes\":811}],816:[function(t,e,r){\"use strict\";function n(){this.enabled=[!0,!0,!0],this.colors=[[0,0,0,1],[0,0,0,1],[0,0,0,1]],this.drawSides=[!0,!0,!0],this.lineWidth=[1,1,1]}function i(t){var e=new n;return e.merge(t),e}var a=t(\"../../../lib/str2rgbarray\"),o=[\"xaxis\",\"yaxis\",\"zaxis\"];n.prototype.merge=function(t){for(var e=0;e<3;++e){var r=t[o[e]];r.visible?(this.enabled[e]=r.showspikes,this.colors[e]=a(r.spikecolor),this.drawSides[e]=r.spikesides,this.lineWidth[e]=r.spikethickness):(this.enabled[e]=!1,this.drawSides[e]=!1)}},e.exports=i},{\"../../../lib/str2rgbarray\":744}],817:[function(t,e,r){\"use strict\";function n(t){for(var e=new Array(3),r=0;r<3;++r){for(var n=t[r],i=new Array(n.length),a=0;a<n.length;++a)i[a]=n[a].x;e[r]=i}return e}function i(t){for(var e=t.axesOptions,r=t.glplot.axesPixels,i=t.fullSceneLayout,c=[[],[],[]],h=0;h<3;++h){var f=i[l[h]];if(f._length=(r[h].hi-r[h].lo)*r[h].pixelsPerDataUnit/t.dataScale[h],Math.abs(f._length)===1/0)c[h]=[];else{f.range[0]=r[h].lo/t.dataScale[h],f.range[1]=r[h].hi/t.dataScale[h],f._m=1/(t.dataScale[h]*r[h].pixelsPerDataUnit),f.range[0]===f.range[1]&&(f.range[0]-=1,f.range[1]+=1);var d=f.tickmode;if(\"auto\"===f.tickmode){f.tickmode=\"linear\";var p=f.nticks||o.constrain(f._length/40,4,9);a.autoTicks(f,Math.abs(f.range[1]-f.range[0])/p)}for(var m=a.calcTicks(f),v=0;v<m.length;++v)m[v].x=m[v].x*t.dataScale[h],m[v].text=s(m[v].text);c[h]=m,f.tickmode=d}}e.ticks=c;for(var h=0;h<3;++h){u[h]=.5*(t.glplot.bounds[0][h]+t.glplot.bounds[1][h]);for(var v=0;v<2;++v)e.bounds[v][h]=t.glplot.bounds[v][h]}t.contourLevels=n(c)}e.exports=i;var a=t(\"../../cartesian/axes\"),o=t(\"../../../lib\"),s=t(\"../../../lib/html2unicode\"),l=[\"xaxis\",\"yaxis\",\"zaxis\"],u=[0,0,0]},{\"../../../lib\":725,\"../../../lib/html2unicode\":723,\"../../cartesian/axes\":766}],818:[function(t,e,r){\"use strict\";function n(t,e){var r,n,i=[0,0,0,0];for(r=0;r<4;++r)for(n=0;n<4;++n)i[n]+=t[4*r+n]*e[r];return i}function i(t,e){return n(t.projection,n(t.view,n(t.model,[e[0],e[1],e[2],1])))}e.exports=i},{}],819:[function(t,e,r){\"use strict\";function n(t){function e(e,r){var n=t.fullSceneLayout[e];return v.tickText(n,n.d2l(r),\"hover\").text}var r,n=t.svgContainer,i=t.container.getBoundingClientRect(),a=i.width,o=i.height;n.setAttributeNS(null,\"viewBox\",\"0 0 \"+a+\" \"+o),n.setAttributeNS(null,\"width\",a),n.setAttributeNS(null,\"height\",o),k(t),t.glplot.axes.update(t.axesOptions);for(var s=Object.keys(t.traces),l=null,u=t.glplot.selection,c=0;c<s.length;++c)r=t.traces[s[c]],\"skip\"!==r.data.hoverinfo&&r.handlePick(u)&&(l=r),r.setContourLevels&&r.setContourLevels();var h;if(null!==l){var f=_(t.glplot.cameraParams,u.dataCoordinate);r=l.data;var d=u.index,p=g.castHoverinfo(r,t.fullLayout,d),m=e(\"xaxis\",u.traceCoordinate[0]),y=e(\"yaxis\",u.traceCoordinate[1]),b=e(\"zaxis\",u.traceCoordinate[2]);if(\"all\"!==p){var x=p.split(\"+\");-1===x.indexOf(\"x\")&&(m=void 0),-1===x.indexOf(\"y\")&&(y=void 0),-1===x.indexOf(\"z\")&&(b=void 0),-1===x.indexOf(\"text\")&&(u.textLabel=void 0),-1===x.indexOf(\"name\")&&(l.name=void 0)}t.fullSceneLayout.hovermode&&g.loneHover({x:(.5+.5*f[0]/f[3])*a,y:(.5-.5*f[1]/f[3])*o,xLabel:m,yLabel:y,zLabel:b,text:u.textLabel,name:l.name,color:g.castHoverOption(r,d,\"bgcolor\")||l.color,borderColor:g.castHoverOption(r,d,\"bordercolor\"),fontFamily:g.castHoverOption(r,d,\"font.family\"),fontSize:g.castHoverOption(r,d,\"font.size\"),fontColor:g.castHoverOption(r,d,\"font.color\")},{container:n,gd:t.graphDiv});var w={x:u.traceCoordinate[0],y:u.traceCoordinate[1],z:u.traceCoordinate[2],data:r._input,fullData:r,curveNumber:r.index,pointNumber:d};g.appendArrayPointValue(w,r,d);var M={points:[w]};u.buttons&&u.distance<5?t.graphDiv.emit(\"plotly_click\",M):t.graphDiv.emit(\"plotly_hover\",M),h=M}else g.loneUnhover(n),t.graphDiv.emit(\"plotly_unhover\",h);t.drawAnnotations(t)}function i(t,e,r,i){var a={canvas:r,gl:i,container:t.container,axes:t.axesOptions,spikes:t.spikeOptions,pickRadius:10,snapToData:!0,autoScale:!0,autoBounds:!1};if(t.staticMode){if(!(h||(c=document.createElement(\"canvas\"),h=d({canvas:c,preserveDrawingBuffer:!0,premultipliedAlpha:!0,antialias:!0}))))throw new Error(\"error creating static canvas/context for image server\");a.pixelRatio=t.pixelRatio,a.gl=h,a.canvas=c}try{t.glplot=f(a)}catch(e){b(t)}var o=function(t){if(!1!==t.fullSceneLayout.dragmode){var e={};e[t.id+\".camera\"]=u(t.camera),t.saveCamera(t.graphDiv.layout),t.graphDiv.emit(\"plotly_relayout\",e)}};if(t.glplot.canvas.addEventListener(\"mouseup\",o.bind(null,t)),t.glplot.canvas.addEventListener(\"wheel\",o.bind(null,t)),t.staticMode||t.glplot.canvas.addEventListener(\"webglcontextlost\",function(t){m.warn(\"Lost WebGL context.\"),t.preventDefault()}),!t.camera){var s=t.fullSceneLayout.camera;t.camera=x(t.container,{center:[s.center.x,s.center.y,s.center.z],eye:[s.eye.x,s.eye.y,s.eye.z],up:[s.up.x,s.up.y,s.up.z],zoomMin:.1,zoomMax:100,mode:\"orbit\"})}return t.glplot.camera=t.camera,t.glplot.oncontextloss=function(){t.recoverContext()},t.glplot.onrender=n.bind(null,t),t.traces={},!0}function a(t,e){var r=document.createElement(\"div\"),n=t.container;this.graphDiv=t.graphDiv;var a=document.createElementNS(\"http://www.w3.org/2000/svg\",\"svg\");a.style.position=\"absolute\",a.style.top=a.style.left=\"0px\",a.style.width=a.style.height=\"100%\",a.style[\"z-index\"]=20,a.style[\"pointer-events\"]=\"none\",r.appendChild(a),this.svgContainer=a,r.id=t.id,r.style.position=\"absolute\",r.style.top=r.style.left=\"0px\",r.style.width=r.style.height=\"100%\",n.appendChild(r),this.fullLayout=e,this.id=t.id||\"scene\",this.fullSceneLayout=e[this.id],this.plotArgs=[[],{},{}],this.axesOptions=w(e[this.id]),this.spikeOptions=M(e[this.id]),this.container=r,this.staticMode=!!t.staticPlot,this.pixelRatio=t.plotGlPixelRatio||2,this.dataScale=[1,1,1],this.contourLevels=[[],[],[]],this.convertAnnotations=p.getComponentMethod(\"annotations3d\",\"convert\"),this.drawAnnotations=p.getComponentMethod(\"annotations3d\",\"draw\"),i(this,e)}function o(t,e,r,n,i){for(var a,o=0;o<e.length;++o)if(Array.isArray(e[o]))for(var s=0;s<e[o].length;++s)a=t.d2l(e[o][s],0,i),!isNaN(a)&&isFinite(a)&&(n[0][r]=Math.min(n[0][r],a),n[1][r]=Math.max(n[1][r],a));else a=t.d2l(e[o],0,i),!isNaN(a)&&isFinite(a)&&(n[0][r]=Math.min(n[0][r],a),n[1][r]=Math.max(n[1][r],a))}function s(t,e,r){var n=t.fullSceneLayout;o(n.xaxis,e.x,0,r,e.xcalendar),o(n.yaxis,e.y,1,r,e.ycalendar),o(n.zaxis,e.z,2,r,e.zcalendar)}function l(t){return[[t.eye.x,t.eye.y,t.eye.z],[t.center.x,t.center.y,t.center.z],[t.up.x,t.up.y,t.up.z]]}function u(t){return{up:{x:t.up[0],y:t.up[1],z:t.up[2]},center:{x:t.center[0],y:t.center[1],z:t.center[2]},eye:{x:t.eye[0],y:t.eye[1],z:t.eye[2]}}}var c,h,f=t(\"gl-plot3d\"),d=t(\"webgl-context\"),p=t(\"../../registry\"),m=t(\"../../lib\"),v=t(\"../../plots/cartesian/axes\"),g=t(\"../../components/fx\"),y=t(\"../../lib/str2rgbarray\"),b=t(\"../../lib/show_no_webgl_msg\"),x=t(\"./camera\"),_=t(\"./project\"),w=t(\"./layout/convert\"),M=t(\"./layout/spikes\"),k=t(\"./layout/tick_marks\"),A=a.prototype;A.recoverContext=function(){function t(){return r.isContextLost()?void requestAnimationFrame(t):i(e,e.fullLayout,n,r)?void e.plot.apply(e,e.plotArgs):void m.error(\"Catastrophic and unrecoverable WebGL error. Context lost.\")}var e=this,r=this.glplot.gl,n=this.glplot.canvas;this.glplot.dispose(),requestAnimationFrame(t)};var T=[\"xaxis\",\"yaxis\",\"zaxis\"];A.plot=function(t,e,r){if(this.plotArgs=[t,e,r],!this.glplot.contextLost){var n,i,a,o,l,u,c=e[this.id],h=r[this.id];c.bgcolor?this.glplot.clearColor=y(c.bgcolor):this.glplot.clearColor=[0,0,0,0],this.glplot.snapToData=!0,this.fullLayout=e,this.fullSceneLayout=c,this.glplotLayout=c,this.axesOptions.merge(c),this.spikeOptions.merge(c),this.setCamera(c.camera),this.updateFx(c.dragmode,c.hovermode),this.glplot.update({}),this.setConvert(l),t?Array.isArray(t)||(t=[t]):t=[];var f=[[1/0,1/0,1/0],[-1/0,-1/0,-1/0]];for(a=0;a<t.length;++a)n=t[a],!0===n.visible&&s(this,n,f);var d=[1,1,1];for(o=0;o<3;++o)f[0][o]>f[1][o]?d[o]=1:f[1][o]===f[0][o]?d[o]=1:d[o]=1/(f[1][o]-f[0][o]);for(this.dataScale=d,this.convertAnnotations(this),a=0;a<t.length;++a)n=t[a],!0===n.visible&&(i=this.traces[n.uid],i?i.update(n):(i=n._module.plot(this,n),this.traces[n.uid]=i),i.name=n.name);var p=Object.keys(this.traces);t:for(a=0;a<p.length;++a){for(o=0;o<t.length;++o)if(t[o].uid===p[a]&&!0===t[o].visible)continue t;i=this.traces[p[a]],i.dispose(),delete this.traces[p[a]]}this.glplot.objects.sort(function(t,e){return t._trace.data.index-e._trace.data.index});var m=[[0,0,0],[0,0,0]],v=[],g={};for(a=0;a<3;++a){if(l=c[T[a]],u=l.type,u in g?(g[u].acc*=d[a],g[u].count+=1):g[u]={acc:d[a],count:1},l.autorange){m[0][a]=1/0,m[1][a]=-1/0;var b=this.glplot.objects,x=this.fullSceneLayout.annotations||[],_=l._name.charAt(0);for(o=0;o<b.length;o++){var w=b[o].bounds;m[0][a]=Math.min(m[0][a],w[0][a]/d[a]),m[1][a]=Math.max(m[1][a],w[1][a]/d[a])}for(o=0;o<x.length;o++){var M=x[o];if(M.visible){var k=l.r2l(M[_]);m[0][a]=Math.min(m[0][a],k),m[1][a]=Math.max(m[1][a],k)}}if(\"rangemode\"in l&&\"tozero\"===l.rangemode&&(m[0][a]=Math.min(m[0][a],0),m[1][a]=Math.max(m[1][a],0)),m[0][a]>m[1][a])m[0][a]=-1,m[1][a]=1;else{var A=m[1][a]-m[0][a];m[0][a]-=A/32,m[1][a]+=A/32}}else{var S=l.range;m[0][a]=l.r2l(S[0]),m[1][a]=l.r2l(S[1])}m[0][a]===m[1][a]&&(m[0][a]-=1,m[1][a]+=1),v[a]=m[1][a]-m[0][a],this.glplot.bounds[0][a]=m[0][a]*d[a],this.glplot.bounds[1][a]=m[1][a]*d[a]}var E=[1,1,1];for(a=0;a<3;++a){l=c[T[a]],u=l.type;var L=g[u];E[a]=Math.pow(L.acc,1/L.count)/d[a]}var C;if(\"auto\"===c.aspectmode)C=Math.max.apply(null,E)/Math.min.apply(null,E)<=4?E:[1,1,1];else if(\"cube\"===c.aspectmode)C=[1,1,1];else if(\"data\"===c.aspectmode)C=E;else{if(\"manual\"!==c.aspectmode)throw new Error(\"scene.js aspectRatio was not one of the enumerated types\");var z=c.aspectratio;C=[z.x,z.y,z.z]}c.aspectratio.x=h.aspectratio.x=C[0],c.aspectratio.y=h.aspectratio.y=C[1],c.aspectratio.z=h.aspectratio.z=C[2],this.glplot.aspect=C;var I=c.domain||null,D=e._size||null;if(I&&D){var P=this.container.style;P.position=\"absolute\",P.left=D.l+I.x[0]*D.w+\"px\",P.top=D.t+(1-I.y[1])*D.h+\"px\",P.width=D.w*(I.x[1]-I.x[0])+\"px\",P.height=D.h*(I.y[1]-I.y[0])+\"px\"}this.glplot.redraw()}},A.destroy=function(){this.glplot&&(this.camera.mouseListener.enabled=!1,this.container.removeEventListener(\"wheel\",this.camera.wheelListener),this.camera=this.glplot.camera=null,this.glplot.dispose(),this.container.parentNode.removeChild(this.container),this.glplot=null)},A.getCamera=function(){return this.glplot.camera.view.recalcMatrix(this.camera.view.lastT()),u(this.glplot.camera)},A.setCamera=function(t){this.glplot.camera.lookAt.apply(this,l(t))},A.saveCamera=function(t){var e=this.getCamera(),r=m.nestedProperty(t,this.id+\".camera\"),n=r.get(),i=!1;if(void 0===n)i=!0;else for(var a=0;a<3;a++)for(var o=0;o<3;o++)if(!function(t,e,r,n){var i=[\"up\",\"center\",\"eye\"],a=[\"x\",\"y\",\"z\"];return e[i[r]]&&t[i[r]][a[n]]===e[i[r]][a[n]]}(e,n,a,o)){i=!0;break}return i&&r.set(e),i},A.updateFx=function(t,e){var r=this.camera;r&&(\"orbit\"===t?(r.mode=\"orbit\",r.keyBindingMode=\"rotate\"):\"turntable\"===t?(r.up=[0,0,1],r.mode=\"turntable\",r.keyBindingMode=\"rotate\"):r.keyBindingMode=t),this.fullSceneLayout.hovermode=e},A.toImage=function(t){t||(t=\"png\"),this.staticMode&&this.container.appendChild(c),this.glplot.redraw();var e=this.glplot.gl,r=e.drawingBufferWidth,n=e.drawingBufferHeight;e.bindFramebuffer(e.FRAMEBUFFER,null);var i=new Uint8Array(r*n*4);e.readPixels(0,0,r,n,e.RGBA,e.UNSIGNED_BYTE,i);for(var a=0,o=n-1;a<o;++a,--o)for(var s=0;s<r;++s)for(var l=0;l<4;++l){var u=i[4*(r*a+s)+l];i[4*(r*a+s)+l]=i[4*(r*o+s)+l],i[4*(r*o+s)+l]=u}var h=document.createElement(\"canvas\");h.width=r,h.height=n;var f=h.getContext(\"2d\"),d=f.createImageData(r,n);d.data.set(i),f.putImageData(d,0,0);var p;switch(t){case\"jpeg\":p=h.toDataURL(\"image/jpeg\");break;case\"webp\":p=h.toDataURL(\"image/webp\");break;default:p=h.toDataURL(\"image/png\")}return this.staticMode&&this.container.removeChild(c),p},A.setConvert=function(){for(var t=0;t<3;t++){var e=this.fullSceneLayout[T[t]];v.setConvert(e,this.fullLayout),e.setScale=m.noop}},e.exports=a},{\"../../components/fx\":644,\"../../lib\":725,\"../../lib/show_no_webgl_msg\":742,\"../../lib/str2rgbarray\":744,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./camera\":808,\n",
       "\"./layout/convert\":813,\"./layout/spikes\":816,\"./layout/tick_marks\":817,\"./project\":818,\"gl-plot3d\":220,\"webgl-context\":562}],820:[function(t,e,r){\"use strict\";var n=t(\"../lib\"),i=n.extendFlat,a=t(\"./font_attributes\"),o=t(\"../components/color/attributes\");e.exports={font:{family:i({},a.family,{dflt:'\"Open Sans\", verdana, arial, sans-serif'}),size:i({},a.size,{dflt:12}),color:i({},a.color,{dflt:o.defaultLine})},title:{valType:\"string\",dflt:\"Click to enter Plot title\"},titlefont:i({},a,{}),autosize:{valType:\"boolean\",dflt:!1},width:{valType:\"number\",min:10,dflt:700},height:{valType:\"number\",min:10,dflt:450},margin:{l:{valType:\"number\",min:0,dflt:80},r:{valType:\"number\",min:0,dflt:80},t:{valType:\"number\",min:0,dflt:100},b:{valType:\"number\",min:0,dflt:80},pad:{valType:\"number\",min:0,dflt:0},autoexpand:{valType:\"boolean\",dflt:!0}},paper_bgcolor:{valType:\"color\",dflt:o.background},plot_bgcolor:{valType:\"color\",dflt:o.background},separators:{valType:\"string\",dflt:\".,\"},hidesources:{valType:\"boolean\",dflt:!1},smith:{valType:\"enumerated\",values:[!1],dflt:!1},showlegend:{valType:\"boolean\"}}},{\"../components/color/attributes\":602,\"../lib\":725,\"./font_attributes\":790}],821:[function(t,e,r){\"use strict\";e.exports={styleUrlPrefix:\"mapbox://styles/mapbox/\",styleUrlSuffix:\"v9\",controlContainerClassName:\"mapboxgl-control-container\",noAccessTokenErrorMsg:[\"Missing Mapbox access token.\",\"Mapbox trace type require a Mapbox access token to be registered.\",\"For example:\",\"  Plotly.plot(gd, data, layout, { mapboxAccessToken: 'my-access-token' });\",\"More info here: https://www.mapbox.com/help/define-access-token/\"].join(\"\\n\"),mapOnErrorMsg:\"Mapbox error.\"}},{}],822:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){var r=t.split(\" \"),i=r[0],a=r[1],o=Array.isArray(e)?n.mean(e):e,s=.5+o/100,l=1.5+o/100,u=[\"\",\"\"],c=[0,0];switch(i){case\"top\":u[0]=\"top\",c[1]=-l;break;case\"bottom\":u[0]=\"bottom\",c[1]=l}switch(a){case\"left\":u[1]=\"right\",c[0]=-s;break;case\"right\":u[1]=\"left\",c[0]=s}var h;return h=u[0]&&u[1]?u.join(\"-\"):u[0]?u[0]:u[1]?u[1]:\"center\",{anchor:h,offset:c}}},{\"../../lib\":725}],823:[function(t,e,r){\"use strict\";function n(t,e){var r=t._fullLayout,n=t._context;if(\"\"===n.mapboxAccessToken)return\"\";for(var i=n.mapboxAccessToken,a=0;a<e.length;a++){var o=r[e[a]];if(o.accesstoken){i=o.accesstoken;break}}if(!i)throw new Error(u.noAccessTokenErrorMsg);return i}var i=t(\"mapbox-gl\"),a=t(\"../../lib\"),o=t(\"../plots\"),s=t(\"../../constants/xmlns_namespaces\"),l=t(\"./mapbox\"),u=t(\"./constants\");r.name=\"mapbox\",r.attr=\"subplot\",r.idRoot=\"mapbox\",r.idRegex=/^mapbox([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^mapbox([2-9]|[1-9][0-9]+)?$/,r.attributes={subplot:{valType:\"subplotid\",dflt:\"mapbox\"}},r.layoutAttributes=t(\"./layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout_defaults\"),r.plot=function(t){var e=t._fullLayout,r=t.calcdata,s=o.getSubplotIds(e,\"mapbox\"),u=n(t,s);i.accessToken=u;for(var c=0;c<s.length;c++){var h=s[c],f=o.getSubplotCalcData(r,\"mapbox\",h),d=e[h],p=d._subplot;d.accesstoken=u,p||(p=l({gd:t,container:e._glcontainer.node(),id:h,fullLayout:e,staticPlot:t._context.staticPlot}),e[h]._subplot=p),p.viewInitial||(p.viewInitial={center:a.extendFlat({},d.center),zoom:d.zoom,bearing:d.bearing,pitch:d.pitch}),p.plot(f,e,t._promises)}},r.clean=function(t,e,r,n){for(var i=o.getSubplotIds(n,\"mapbox\"),a=0;a<i.length;a++){var s=i[a];!e[s]&&n[s]._subplot&&n[s]._subplot.destroy()}},r.toSVG=function(t){for(var e=t._fullLayout,r=o.getSubplotIds(e,\"mapbox\"),n=e._size,i=0;i<r.length;i++){var a=e[r[i]],l=a.domain,u=a._subplot,c=u.toImage(\"png\");e._glimages.append(\"svg:image\").attr({xmlns:s.svg,\"xlink:href\":c,x:n.l+n.w*l.x[0],y:n.t+n.h*(1-l.y[1]),width:n.w*(l.x[1]-l.x[0]),height:n.h*(l.y[1]-l.y[0]),preserveAspectRatio:\"none\"}),u.destroy()}}},{\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../plots\":829,\"./constants\":821,\"./layout_attributes\":825,\"./layout_defaults\":826,\"./mapbox\":827,\"mapbox-gl\":342}],824:[function(t,e,r){\"use strict\";function n(t,e){this.mapbox=t,this.map=t.map,this.uid=t.uid+\"-layer\"+e,this.idSource=this.uid+\"-source\",this.idLayer=this.uid+\"-layer\",this.sourceType=null,this.source=null,this.layerType=null,this.below=null,this.visible=!1}function i(t){var e=t.source;return s.isPlainObject(e)||\"string\"==typeof e&&e.length>0}function a(t){var e={},r={};switch(t.type){case\"circle\":s.extendFlat(r,{\"circle-radius\":t.circle.radius,\"circle-color\":t.color,\"circle-opacity\":t.opacity});break;case\"line\":s.extendFlat(r,{\"line-width\":t.line.width,\"line-color\":t.color,\"line-opacity\":t.opacity});break;case\"fill\":s.extendFlat(r,{\"fill-color\":t.color,\"fill-outline-color\":t.fill.outlinecolor,\"fill-opacity\":t.opacity});break;case\"symbol\":var n=t.symbol,i=l(n.textposition,n.iconsize);s.extendFlat(e,{\"icon-image\":n.icon+\"-15\",\"icon-size\":n.iconsize/10,\"text-field\":n.text,\"text-size\":n.textfont.size,\"text-anchor\":i.anchor,\"text-offset\":i.offset}),s.extendFlat(r,{\"icon-color\":t.color,\"text-color\":n.textfont.color,\"text-opacity\":t.opacity})}return{layout:e,paint:r}}function o(t){var e,r=t.sourcetype,n=t.source,i={type:r},a=\"string\"==typeof n;return\"geojson\"===r?e=\"data\":\"vector\"===r&&(e=a?\"url\":\"tiles\"),i[e]=n,i}var s=t(\"../../lib\"),l=t(\"./convert_text_opts\"),u=n.prototype;u.update=function(t){this.visible?this.needsNewSource(t)?(this.updateLayer(t),this.updateSource(t)):this.needsNewLayer(t)&&this.updateLayer(t):(this.updateSource(t),this.updateLayer(t)),this.updateStyle(t),this.visible=i(t)},u.needsNewSource=function(t){return this.sourceType!==t.sourcetype||this.source!==t.source||this.layerType!==t.type},u.needsNewLayer=function(t){return this.layerType!==t.type||this.below!==t.below},u.updateSource=function(t){var e=this.map;if(e.getSource(this.idSource)&&e.removeSource(this.idSource),this.sourceType=t.sourcetype,this.source=t.source,i(t)){var r=o(t);e.addSource(this.idSource,r)}},u.updateLayer=function(t){var e=this.map;if(e.getLayer(this.idLayer)&&e.removeLayer(this.idLayer),this.layerType=t.type,i(t)){e.addLayer({id:this.idLayer,source:this.idSource,\"source-layer\":t.sourcelayer||\"\",type:t.type},t.below);var r={visibility:\"visible\"};this.mapbox.setOptions(this.idLayer,\"setLayoutProperty\",r)}},u.updateStyle=function(t){var e=a(t);i(t)&&(this.mapbox.setOptions(this.idLayer,\"setLayoutProperty\",e.layout),this.mapbox.setOptions(this.idLayer,\"setPaintProperty\",e.paint))},u.dispose=function(){var t=this.map;t.removeLayer(this.idLayer),t.removeSource(this.idSource)},e.exports=function(t,e,r){var i=new n(t,e);return i.update(r),i}},{\"../../lib\":725,\"./convert_text_opts\":822}],825:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/color\").defaultLine,a=t(\"../font_attributes\"),o=t(\"../../traces/scatter/attributes\").textposition;e.exports={_arrayAttrRegexps:[/^mapbox([2-9]|[1-9][0-9]+)?\\.layers/],domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},accesstoken:{valType:\"string\",noBlank:!0,strict:!0},style:{valType:\"any\",values:[\"basic\",\"streets\",\"outdoors\",\"light\",\"dark\",\"satellite\",\"satellite-streets\"],dflt:\"basic\"},center:{lon:{valType:\"number\",dflt:0},lat:{valType:\"number\",dflt:0}},zoom:{valType:\"number\",dflt:1},bearing:{valType:\"number\",dflt:0},pitch:{valType:\"number\",dflt:0},layers:{_isLinkedToArray:\"layer\",sourcetype:{valType:\"enumerated\",values:[\"geojson\",\"vector\"],dflt:\"geojson\"},source:{valType:\"any\"},sourcelayer:{valType:\"string\",dflt:\"\"},type:{valType:\"enumerated\",values:[\"circle\",\"line\",\"fill\",\"symbol\"],dflt:\"circle\"},below:{valType:\"string\",dflt:\"\"},color:{valType:\"color\",dflt:i},opacity:{valType:\"number\",min:0,max:1,dflt:1},circle:{radius:{valType:\"number\",dflt:15}},line:{width:{valType:\"number\",dflt:2}},fill:{outlinecolor:{valType:\"color\",dflt:i}},symbol:{icon:{valType:\"string\",dflt:\"marker\"},iconsize:{valType:\"number\",dflt:10},text:{valType:\"string\",dflt:\"\"},textfont:n.extendDeep({},a,{family:{dflt:\"Open Sans Regular, Arial Unicode MS Regular\"}}),textposition:n.extendFlat({},o,{arrayOk:!1})}}}},{\"../../components/color\":603,\"../../lib\":725,\"../../traces/scatter/attributes\":1027,\"../font_attributes\":790}],826:[function(t,e,r){\"use strict\";function n(t,e,r){r(\"accesstoken\"),r(\"style\"),r(\"center.lon\"),r(\"center.lat\"),r(\"zoom\"),r(\"bearing\"),r(\"pitch\"),i(t,e),e._input=t}function i(t,e){function r(t,e){return a.coerce(n,i,s.layers,t,e)}for(var n,i,o=t.layers||[],l=e.layers=[],u=0;u<o.length;u++)if(n=o[u],i={},a.isPlainObject(n)){var c=r(\"sourcetype\");r(\"source\"),\"vector\"===c&&r(\"sourcelayer\");var h=r(\"type\");r(\"below\"),r(\"color\"),r(\"opacity\"),\"circle\"===h&&r(\"circle.radius\"),\"line\"===h&&r(\"line.width\"),\"fill\"===h&&r(\"fill.outlinecolor\"),\"symbol\"===h&&(r(\"symbol.icon\"),r(\"symbol.iconsize\"),r(\"symbol.text\"),a.coerceFont(r,\"symbol.textfont\"),r(\"symbol.textposition\")),i._index=u,l.push(i)}}var a=t(\"../../lib\"),o=t(\"../subplot_defaults\"),s=t(\"./layout_attributes\");e.exports=function(t,e,r){o(t,e,r,{type:\"mapbox\",attributes:s,handleDefaults:n,partition:\"y\"})}},{\"../../lib\":725,\"../subplot_defaults\":836,\"./layout_attributes\":825}],827:[function(t,e,r){\"use strict\";function n(t){this.id=t.id,this.gd=t.gd,this.container=t.container,this.isStatic=t.staticPlot;var e=t.fullLayout;this.uid=e._uid+\"-\"+this.id,this.opts=e[this.id],this.div=null,this.xaxis=null,this.yaxis=null,this.createFramework(e),this.map=null,this.accessToken=null,this.styleObj=null,this.traceHash={},this.layerList=[]}function i(t){var e=d.style.values,r=d.style.dflt,n={};return u.isPlainObject(t)?(n.id=t.id,n.style=t):\"string\"==typeof t?(n.id=t,n.style=-1!==e.indexOf(t)?a(t):t):(n.id=r,n.style=a(r)),n}function a(t){return f.styleUrlPrefix+t+\"-\"+f.styleUrlSuffix}function o(t){return[t.lon,t.lat]}var s=t(\"mapbox-gl\"),l=t(\"../../components/fx\"),u=t(\"../../lib\"),c=t(\"../../components/dragelement\"),h=t(\"../cartesian/select\"),f=t(\"./constants\"),d=t(\"./layout_attributes\"),p=t(\"./layers\"),m=n.prototype;e.exports=function(t){return new n(t)},m.plot=function(t,e,r){var n=this,i=n.opts=e[this.id];n.map&&i.accesstoken!==n.accessToken&&(n.map.remove(),n.map=null,n.styleObj=null,n.traceHash=[],n.layerList={});var a;a=n.map?new Promise(function(r,i){n.updateMap(t,e,r,i)}):new Promise(function(r,i){n.createMap(t,e,r,i)}),r.push(a)},m.createMap=function(t,e,r,n){function a(){l.loneUnhover(e._toppaper)}var c=this,h=c.gd,d=c.opts,p=c.styleObj=i(d.style);c.accessToken=d.accesstoken;var m=c.map=new s.Map({container:c.div,style:p.style,center:o(d.center),zoom:d.zoom,bearing:d.bearing,pitch:d.pitch,interactive:!c.isStatic,preserveDrawingBuffer:c.isStatic,doubleClickZoom:!1,boxZoom:!1}),v=f.controlContainerClassName,g=c.div.getElementsByClassName(v)[0];c.div.removeChild(g),m._canvas.canvas.style.left=\"0px\",m._canvas.canvas.style.top=\"0px\",c.rejectOnError(n),m.once(\"load\",function(){c.updateData(t),c.updateLayout(e),c.resolveOnRender(r)}),c.isStatic||(m.on(\"moveend\",function(t){if(c.map){var e=c.getView();if(d._input.center=d.center=e.center,d._input.zoom=d.zoom=e.zoom,d._input.bearing=d.bearing=e.bearing,d._input.pitch=d.pitch=e.pitch,t.originalEvent){var r={};r[c.id]=u.extendFlat({},e),h.emit(\"plotly_relayout\",r)}}}),m.on(\"mousemove\",function(t){var e=c.div.getBoundingClientRect();t.clientX=t.point.x+e.left,t.clientY=t.point.y+e.top,t.target.getBoundingClientRect=function(){return e},c.xaxis.p2c=function(){return t.lngLat.lng},c.yaxis.p2c=function(){return t.lngLat.lat},l.hover(h,t,c.id)}),m.on(\"click\",function(t){l.click(h,t.originalEvent)}),m.on(\"dragstart\",a),m.on(\"zoomstart\",a),m.on(\"dblclick\",function(){var t=c.viewInitial;m.setCenter(o(t.center)),m.setZoom(t.zoom),m.setBearing(t.bearing),m.setPitch(t.pitch);var e=c.getView();d._input.center=d.center=e.center,d._input.zoom=d.zoom=e.zoom,d._input.bearing=d.bearing=e.bearing,d._input.pitch=d.pitch=e.pitch,h.emit(\"plotly_doubleclick\",null)}))},m.updateMap=function(t,e,r,n){var a=this,o=a.map;a.rejectOnError(n);var s=i(a.opts.style);a.styleObj.id!==s.id?(a.styleObj=s,o.setStyle(s.style),o.style.once(\"load\",function(){a.traceHash={},a.updateData(t),a.updateLayout(e),a.resolveOnRender(r)})):(a.updateData(t),a.updateLayout(e),a.resolveOnRender(r))},m.updateData=function(t){var e,r,n,i,a=this.traceHash;for(n=0;n<t.length;n++){var o=t[n];r=o[0].trace,e=a[r.uid],e?e.update(o):r._module&&(a[r.uid]=r._module.plot(this,o))}var s=Object.keys(a);t:for(n=0;n<s.length;n++){var l=s[n];for(i=0;i<t.length;i++)if(r=t[i][0].trace,l===r.uid)continue t;e=a[l],e.dispose(),delete a[l]}},m.updateLayout=function(t){var e=this.map,r=this.opts;e.setCenter(o(r.center)),e.setZoom(r.zoom),e.setBearing(r.bearing),e.setPitch(r.pitch),this.updateLayers(),this.updateFramework(t),this.updateFx(t),this.map.resize()},m.resolveOnRender=function(t){var e=this.map;e.on(\"render\",function r(){e.loaded()&&(e.off(\"render\",r),t())})},m.rejectOnError=function(t){function e(){t(new Error(f.mapOnErrorMsg))}var r=this.map;r.once(\"error\",e),r.once(\"style.error\",e),r.once(\"source.error\",e),r.once(\"tile.error\",e),r.once(\"layer.error\",e)},m.createFramework=function(t){var e=this,r=e.div=document.createElement(\"div\");r.id=e.uid,r.style.position=\"absolute\",e.container.appendChild(r),e.xaxis={_id:\"x\",c2p:function(t){return e.project(t).x}},e.yaxis={_id:\"y\",c2p:function(t){return e.project(t).y}},e.updateFramework(t)},m.updateFx=function(t){function e(t){var e=r.map.unproject(t);return[e.lng,e.lat]}var r=this,n=r.map,i=r.gd;if(!r.isStatic){var a,o=t.dragmode;if(a=\"select\"===o?function(t,n){(t.range={})[r.id]=[e([n.xmin,n.ymin]),e([n.xmax,n.ymax])]}:function(t,n,i){(t.lassoPoints={})[r.id]=i.filtered.map(e)},\"select\"===o||\"lasso\"===o){n.dragPan.disable();var s={element:r.div,gd:i,plotinfo:{xaxis:r.xaxis,yaxis:r.yaxis,fillRangeItems:a},xaxes:[r.xaxis],yaxes:[r.yaxis],subplot:r.id};s.prepFn=function(t,e,r){h(t,e,r,s,o)},s.doneFn=function(e,r){2===r&&t._zoomlayer.selectAll(\".select-outline\").remove()},c.init(s)}else n.dragPan.enable(),r.div.onmousedown=null}},m.updateFramework=function(t){var e=t[this.id].domain,r=t._size,n=this.div.style;n.width=r.w*(e.x[1]-e.x[0])+\"px\",n.height=r.h*(e.y[1]-e.y[0])+\"px\",n.left=r.l+e.x[0]*r.w+\"px\",n.top=r.t+(1-e.y[1])*r.h+\"px\",this.xaxis._offset=r.l+e.x[0]*r.w,this.xaxis._length=r.w*(e.x[1]-e.x[0]),this.yaxis._offset=r.t+(1-e.y[1])*r.h,this.yaxis._length=r.h*(e.y[1]-e.y[0])},m.updateLayers=function(){var t,e=this.opts,r=e.layers,n=this.layerList;if(r.length!==n.length){for(t=0;t<n.length;t++)n[t].dispose();for(n=this.layerList=[],t=0;t<r.length;t++)n.push(p(this,t,r[t]))}else for(t=0;t<r.length;t++)n[t].update(r[t])},m.destroy=function(){this.map&&(this.map.remove(),this.map=null,this.container.removeChild(this.div))},m.toImage=function(){return this.map.getCanvas().toDataURL()},m.initSource=function(t){var e={type:\"geojson\",data:{type:\"Feature\",geometry:{type:\"Point\",coordinates:[]}}};return this.map.addSource(t,e)},m.setSourceData=function(t,e){this.map.getSource(t).setData(e)},m.setOptions=function(t,e,r){for(var n=this.map,i=Object.keys(r),a=0;a<i.length;a++){var o=i[a];n[e](t,o,r[o])}},m.project=function(t){return this.map.project(new s.LngLat(t[0],t[1]))},m.getView=function(){var t=this.map,e=t.getCenter();return{center:{lon:e.lng,lat:e.lat},zoom:t.getZoom(),bearing:t.getBearing(),pitch:t.getPitch()}}},{\"../../components/dragelement\":624,\"../../components/fx\":644,\"../../lib\":725,\"../cartesian/select\":782,\"./constants\":821,\"./layers\":824,\"./layout_attributes\":825,\"mapbox-gl\":342}],828:[function(t,e,r){\"use strict\";e.exports={t:{valType:\"number\",dflt:0},r:{valType:\"number\",dflt:0},b:{valType:\"number\",dflt:0},l:{valType:\"number\",dflt:0}}},{}],829:[function(t,e,r){\"use strict\";function n(t,e){e.text(\"\");var r=e.append(\"a\").attr({\"xlink:xlink:href\":\"#\",class:\"link--impt link--embedview\",\"font-weight\":\"bold\"}).text(t._context.linkText+\" \"+String.fromCharCode(187));if(t._context.sendData)r.on(\"click\",function(){v.sendDataToCloud(t)});else{var n=window.location.pathname.split(\"/\"),i=window.location.search;r.attr({\"xlink:xlink:show\":\"new\",\"xlink:xlink:href\":\"/\"+n[2].split(\".\")[0]+\"/\"+n[1]+i})}}function i(t,e){var r,n,i=t.trace,a=i._arrayAttrs,o={};for(r=0;r<a.length;r++)n=a[r],o[n]=d.nestedProperty(i,n).get().slice();for(t.trace=e,r=0;r<a.length;r++)n=a[r],d.nestedProperty(t.trace,n).set(o[n])}function a(t,e,r,n){for(var i=t.transforms,a=[t],o=0;o<i.length;o++){var s=i[o],l=_[s.type];l&&l.transform&&(a=l.transform(a,{transform:s,fullTrace:t,fullData:e,layout:r,fullLayout:n,transformIndex:o}))}return a}function o(t){var e,r={left:0,right:0,bottom:0,top:0};if(t)for(e in t)t.hasOwnProperty(e)&&(r.left+=t[e].left||0,r.right+=t[e].right||0,r.bottom+=t[e].bottom||0,r.top+=t[e].top||0);return r}function s(t){for(var e=0;e<t.length;e++){t[e]._categories=t[e]._initialCategories.slice(),t[e]._categoriesMap={};for(var r=0;r<t[e]._categories.length;r++)t[e]._categoriesMap[t[e]._categories[r]]=r}}var l=t(\"d3\"),u=t(\"fast-isnumeric\"),c=t(\"../plotly\"),h=t(\"../plot_api/plot_schema\"),f=t(\"../registry\"),d=t(\"../lib\"),p=t(\"../components/color\"),m=t(\"../constants/numerical\").BADNUM,v=e.exports={},g=t(\"./animation_attributes\"),y=t(\"./frame_attributes\"),b=d.relinkPrivateKeys;d.extendFlat(v,f),v.attributes=t(\"./attributes\"),v.attributes.type.values=v.allTypes,v.fontAttrs=t(\"./font_attributes\"),v.layoutAttributes=t(\"./layout_attributes\"),v.fontWeight=\"normal\";var x=v.subplotsRegistry,_=v.transformsRegistry,w=t(\"../components/errorbars\"),M=t(\"./command\");v.executeAPICommand=M.executeAPICommand,v.computeAPICommandBindings=M.computeAPICommandBindings,v.manageCommandObserver=M.manageCommandObserver,v.hasSimpleAPICommandBindings=M.hasSimpleAPICommandBindings,v.findSubplotIds=function(t,e){var r=[];if(!v.subplotsRegistry[e])return r;for(var n=v.subplotsRegistry[e].attr,i=0;i<t.length;i++){var a=t[i];v.traceIs(a,e)&&-1===r.indexOf(a[n])&&r.push(a[n])}return r},v.getSubplotIds=function(t,e){var r=v.subplotsRegistry[e];if(!r)return[];if(!(\"cartesian\"!==e||t._has&&t._has(\"cartesian\")))return[];if(!(\"gl2d\"!==e||t._has&&t._has(\"gl2d\")))return[];if(\"cartesian\"===e||\"gl2d\"===e)return Object.keys(t._plots||{});for(var n=r.idRegex,i=Object.keys(t),a=[],o=0;o<i.length;o++){var s=i[o];n.test(s)&&a.push(s)}var l=r.idRoot.length;return a.sort(function(t,e){return+(t.substr(l)||1)-+(e.substr(l)||1)}),a},v.getSubplotData=function(t,e,r){if(!v.subplotsRegistry[e])return[];for(var n,i=v.subplotsRegistry[e].attr,a=[],o=0;o<t.length;o++)if(n=t[o],\"gl2d\"===e&&v.traceIs(n,\"gl2d\")){var s=c.Axes.subplotMatch,l=\"x\"+r.match(s)[1],u=\"y\"+r.match(s)[2];n[i[0]]===l&&n[i[1]]===u&&a.push(n)}else n[i]===r&&a.push(n);return a},v.getSubplotCalcData=function(t,e,r){if(!v.subplotsRegistry[e])return[];for(var n=v.subplotsRegistry[e].attr,i=[],a=0;a<t.length;a++){var o=t[a];o[0].trace[n]===r&&i.push(o)}return i},v.redrawText=function(t){if(!(t.data&&t.data[0]&&t.data[0].r))return new Promise(function(e){setTimeout(function(){f.getComponentMethod(\"annotations\",\"draw\")(t),f.getComponentMethod(\"legend\",\"draw\")(t),(t.calcdata||[]).forEach(function(t){t[0]&&t[0].t&&t[0].t.cb&&t[0].t.cb()}),e(v.previousPromises(t))},300)})},v.resize=function(t){return new Promise(function(e,r){t&&\"none\"!==l.select(t).style(\"display\")||r(new Error(\"Resize must be passed a plot div element.\")),t._redrawTimer&&clearTimeout(t._redrawTimer),t._redrawTimer=setTimeout(function(){if(t.layout.width&&t.layout.height)return void e(t);delete t.layout.width,delete t.layout.height;var r=t.changed;t.autoplay=!0,c.relayout(t,{autosize:!0}).then(function(){t.changed=r,e(t)})},100)})},v.previousPromises=function(t){if((t._promises||[]).length)return Promise.all(t._promises).then(function(){t._promises=[]})},v.addLinks=function(t){if(t._context.showLink||t._context.showSources){var e=t._fullLayout,r=e._paper.selectAll(\"text.js-plot-link-container\").data([0]);r.enter().append(\"text\").classed(\"js-plot-link-container\",!0).style({\"font-family\":'\"Open Sans\", Arial, sans-serif',\"font-size\":\"12px\",fill:p.defaultLine,\"pointer-events\":\"all\"}).each(function(){var t=l.select(this);t.append(\"tspan\").classed(\"js-link-to-tool\",!0),t.append(\"tspan\").classed(\"js-link-spacer\",!0),t.append(\"tspan\").classed(\"js-sourcelinks\",!0)});var i=r.node(),a={y:e._paper.attr(\"height\")-9};document.body.contains(i)&&i.getComputedTextLength()>=e.width-20?(a[\"text-anchor\"]=\"start\",a.x=5):(a[\"text-anchor\"]=\"end\",a.x=e._paper.attr(\"width\")-7),r.attr(a);var o=r.select(\".js-link-to-tool\"),s=r.select(\".js-link-spacer\"),u=r.select(\".js-sourcelinks\");t._context.showSources&&t._context.showSources(t),t._context.showLink&&n(t,o),s.text(o.text()&&u.text()?\" - \":\"\")}},v.sendDataToCloud=function(t){t.emit(\"plotly_beforeexport\");var e=window.PLOTLYENV&&window.PLOTLYENV.BASE_URL||\"https://plot.ly\",r=l.select(t).append(\"div\").attr(\"id\",\"hiddenform\").style(\"display\",\"none\"),n=r.append(\"form\").attr({action:e+\"/external\",method:\"post\",target:\"_blank\"});return n.append(\"input\").attr({type:\"text\",name:\"data\"}).node().value=v.graphJson(t,!1,\"keepdata\"),n.node().submit(),r.remove(),t.emit(\"plotly_afterexport\"),!1},v.supplyDefaults=function(t){var e,r=t._fullLayout||{},n=t._fullLayout={},a=t.layout||{},o=t._fullData||[],s=t._fullData=[],l=t.data||[];if(t._transitionData||v.createTransitionData(t),r._initialAutoSizeIsDone){var u=r.width,h=r.height;v.supplyLayoutGlobalDefaults(a,n),a.width||(n.width=u),a.height||(n.height=h)}else{v.supplyLayoutGlobalDefaults(a,n);var f=!a.width||!a.height,d=n.autosize,p=t._context&&t._context.autosizable;f&&(d||p)?v.plotAutoSize(t,a,n):f&&v.sanitizeMargins(t),!d&&f&&(a.width=n.width,a.height=n.height)}n._initialAutoSizeIsDone=!0,n._dataLength=l.length,n._globalTransforms=(t._context||{}).globalTransforms,v.supplyDataDefaults(l,s,a,n),n._has=v._hasPlotType.bind(n);var m=n._modules;for(e=0;e<m.length;e++){var g=m[e];g.cleanData&&g.cleanData(s)}if(o.length===l.length)for(e=0;e<s.length;e++)b(s[e],o[e]);v.supplyLayoutModuleDefaults(a,n,s,t._transitionData),n._hasCartesian=n._has(\"cartesian\"),n._hasGeo=n._has(\"geo\"),n._hasGL3D=n._has(\"gl3d\"),n._hasGL2D=n._has(\"gl2d\"),n._hasTernary=n._has(\"ternary\"),n._hasPie=n._has(\"pie\"),v.cleanPlot(s,n,o,r),v.linkSubplots(s,n,o,r),b(n,r),v.doAutoMargin(t);var y=c.Axes.list(t);for(e=0;e<y.length;e++){y[e].setScale()}if((t.calcdata||[]).length===s.length)for(e=0;e<s.length;e++){var x=s[e],_=t.calcdata[e][0];_&&_.trace&&(_.trace._hasCalcTransform?i(_,x):_.trace=x)}},v.createTransitionData=function(t){t._transitionData||(t._transitionData={}),t._transitionData._frames||(t._transitionData._frames=[]),t._transitionData._frameHash||(t._transitionData._frameHash={}),t._transitionData._counter||(t._transitionData._counter=0),t._transitionData._interruptCallbacks||(t._transitionData._interruptCallbacks=[])},v._hasPlotType=function(t){for(var e=this._basePlotModules||[],r=0;r<e.length;r++){if(e[r].name===t)return!0}return!1},v.cleanPlot=function(t,e,r,n){var i,a,o=n._basePlotModules||[];for(i=0;i<o.length;i++){var s=o[i];s.clean&&s.clean(t,e,r,n)}var l=!!n._paper,u=!!n._infolayer;t:for(i=0;i<r.length;i++){var c=r[i],h=c.uid;for(a=0;a<t.length;a++){var f=t[a];if(h===f.uid)continue t}var d=\".hm\"+h+\",.contour\"+h+\",.carpet\"+h+\",#clip\"+h+\",.trace\"+h;l&&n._paper.selectAll(d).remove(),u&&(n._infolayer.selectAll(\".cb\"+h).remove(),n._infolayer.selectAll(\"g.rangeslider-container\").selectAll(d).remove())}n._zoomlayer&&n._zoomlayer.selectAll(\".select-outline\").remove()},v.linkSubplots=function(t,e,r,n){var i,a=n._plots||{},o=e._plots={},s={_fullData:t,_fullLayout:e},l=c.Axes.getSubplots(s);for(i=0;i<l.length;i++){var u,h=l[i],f=a[h],d=c.Axes.getFromId(s,h,\"x\"),p=c.Axes.getFromId(s,h,\"y\");f?(u=o[h]=f,u._scene2d&&u._scene2d.updateRefs(e),u.xaxis.layer!==d.layer&&(u.xlines.attr(\"d\",null),u.xaxislayer.selectAll(\"*\").remove()),u.yaxis.layer!==p.layer&&(u.ylines.attr(\"d\",null),u.yaxislayer.selectAll(\"*\").remove())):(u=o[h]={},u.id=h),u.xaxis=d,u.yaxis=p,u._hasClipOnAxisFalse=!1;for(var m=0;m<t.length;m++){var v=t[m];if(v.xaxis===u.xaxis._id&&v.yaxis===u.yaxis._id&&!1===v.cliponaxis){u._hasClipOnAxisFalse=!0;break}}}var g=c.Axes.list(s,null,!0);for(i=0;i<g.length;i++){var y=g[i],b=null;y.overlaying&&(b=c.Axes.getFromId(s,y.overlaying))&&b.overlaying&&(y.overlaying=!1,b=null),y._mainAxis=b||y,b&&(y.domain=b.domain.slice()),y._anchorAxis=\"free\"===y.anchor?null:c.Axes.getFromId(s,y.anchor)}},v.clearExpandedTraceDefaultColors=function(t){function e(t,e,i,a){n[a]=e,n.length=a+1,\"color\"===t.valType&&void 0===t.dflt&&r.push(n.join(\".\"))}var r,n,i;for(n=[],r=t._module._colorAttrs,r||(t._module._colorAttrs=r=[],h.crawl(t._module.attributes,e)),i=0;i<r.length;i++){d.nestedProperty(t,\"_input.\"+r[i]).get()||d.nestedProperty(t,r[i]).set(null)}},v.supplyDataDefaults=function(t,e,r,n){function i(t){e.push(t);var r=t._module;r&&(d.pushUnique(u,r),d.pushUnique(c,t._module.basePlotModule),h++)}var o,s,l,u=n._modules=[],c=n._basePlotModules=[],h=0;n._transformModules=[];var p={},m=[];for(o=0;o<t.length;o++){if(l=t[o],s=v.supplyTraceDefaults(l,h,n,o),s.index=o,s._input=l,s._expandedIndex=h,s.transforms&&s.transforms.length)for(var g=a(s,e,r,n),y=0;y<g.length;y++){var x=g[y],_=v.supplyTraceDefaults(x,h,n,o);b(_,x),x.uid=_.uid=s.uid+y,_.index=o,_._input=l,_._fullInput=s,_._expandedIndex=h,_._expandedInput=x,i(_)}else s._fullInput=s,s._expandedInput=s,i(s);f.traceIs(s,\"carpetAxis\")&&(p[s.carpet]=s),f.traceIs(s,\"carpetDependent\")&&m.push(o)}for(o=0;o<m.length;o++)if(s=e[m[o]],s.visible){var w=p[s.carpet];s._carpet=w,w&&w.visible?(s.xaxis=w.xaxis,s.yaxis=w.yaxis):s.visible=!1}},v.supplyAnimationDefaults=function(t){function e(e,r){return d.coerce(t||{},n,g,e,r)}t=t||{};var r,n={};if(e(\"mode\"),e(\"direction\"),e(\"fromcurrent\"),Array.isArray(t.frame))for(n.frame=[],r=0;r<t.frame.length;r++)n.frame[r]=v.supplyAnimationFrameDefaults(t.frame[r]||{});else n.frame=v.supplyAnimationFrameDefaults(t.frame||{});if(Array.isArray(t.transition))for(n.transition=[],r=0;r<t.transition.length;r++)n.transition[r]=v.supplyAnimationTransitionDefaults(t.transition[r]||{});else n.transition=v.supplyAnimationTransitionDefaults(t.transition||{});return n},v.supplyAnimationFrameDefaults=function(t){function e(e,n){return d.coerce(t||{},r,g.frame,e,n)}var r={};return e(\"duration\"),e(\"redraw\"),r},v.supplyAnimationTransitionDefaults=function(t){function e(e,n){return d.coerce(t||{},r,g.transition,e,n)}var r={};return e(\"duration\"),e(\"easing\"),r},v.supplyFrameDefaults=function(t){function e(e,n){return d.coerce(t,r,y,e,n)}var r={};return e(\"group\"),e(\"name\"),e(\"traces\"),e(\"baseframe\"),e(\"data\"),e(\"layout\"),r},v.supplyTraceDefaults=function(t,e,r,n){function i(e,r){return d.coerce(t,o,v.attributes,e,r)}function a(e,r){if(v.traceIs(o,e))return d.coerce(t,o,v.subplotsRegistry[e].attributes,r)}var o={},s=p.defaults[e%p.defaults.length],l=i(\"visible\");i(\"type\"),i(\"uid\"),i(\"name\",\"trace \"+n);for(var u=Object.keys(x),c=0;c<u.length;c++){var h=u[c];if(-1===[\"cartesian\",\"gl2d\"].indexOf(h)){var m=x[h].attr;m&&a(h,m)}}if(l){i(\"customdata\"),i(\"ids\");var g=v.getModule(o);o._module=g,v.traceIs(o,\"showLegend\")&&(i(\"showlegend\"),i(\"legendgroup\")),f.getComponentMethod(\"fx\",\"supplyDefaults\")(t,o,s,r),g&&(g.supplyDefaults(t,o,s,r),d.coerceHoverinfo(t,o,r)),v.traceIs(o,\"noOpacity\")||i(\"opacity\"),a(\"cartesian\",\"xaxis\"),a(\"cartesian\",\"yaxis\"),a(\"gl2d\",\"xaxis\"),a(\"gl2d\",\"yaxis\"),v.traceIs(o,\"notLegendIsolatable\")&&(o.visible=!!o.visible),v.supplyTransformDefaults(t,o,r)}return o},v.supplyTransformDefaults=function(t,e,r){var n=r._globalTransforms||[],i=r._transformModules||[];if(Array.isArray(t.transforms)||0!==n.length)for(var a=t.transforms||[],o=n.concat(a),s=e.transforms=[],l=0;l<o.length;l++){var u,c=o[l],h=c.type,f=_[h];f||d.warn(\"Unrecognized transform type \"+h+\".\"),f&&f.supplyDefaults?(u=f.supplyDefaults(c,e,r,t),u.type=h,u._module=f,d.pushUnique(i,f)):u=d.extendFlat({},c),s.push(u)}},v.supplyLayoutGlobalDefaults=function(t,e){function r(r,n){return d.coerce(t,e,v.layoutAttributes,r,n)}var n=d.coerceFont(r,\"font\");r(\"title\"),d.coerceFont(r,\"titlefont\",{family:n.family,size:Math.round(1.4*n.size),color:n.color}),r(\"autosize\",!(t.width&&t.height)),r(\"width\"),r(\"height\"),r(\"margin.l\"),r(\"margin.r\"),r(\"margin.t\"),r(\"margin.b\"),r(\"margin.pad\"),r(\"margin.autoexpand\"),t.width&&t.height&&v.sanitizeMargins(e),r(\"paper_bgcolor\"),r(\"separators\"),r(\"hidesources\"),r(\"smith\"),f.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\"),f.getComponentMethod(\"fx\",\"supplyLayoutGlobalDefaults\")(t,e,r)},v.plotAutoSize=function(t,e,r){var n,i,a=t._context||{},s=a.frameMargins,l=d.isPlotDiv(t);if(l&&t.emit(\"plotly_autosize\"),a.fillFrame)n=window.innerWidth,i=window.innerHeight,document.body.style.overflow=\"hidden\";else if(u(s)&&s>0){var c=o(t._boundingBoxMargins),h=c.left+c.right,f=c.bottom+c.top,p=1-2*s,m=r._container&&r._container.node?r._container.node().getBoundingClientRect():{width:r.width,height:r.height};n=Math.round(p*(m.width-h)),i=Math.round(p*(m.height-f))}else{var g=l?window.getComputedStyle(t):{};n=parseFloat(g.width)||r.width,i=parseFloat(g.height)||r.height}var y=v.layoutAttributes.width.min,b=v.layoutAttributes.height.min;n<y&&(n=y),i<b&&(i=b);var x=!e.width&&Math.abs(r.width-n)>1,_=!e.height&&Math.abs(r.height-i)>1;(_||x)&&(x&&(r.width=n),_&&(r.height=i)),t._initialAutoSize||(t._initialAutoSize={width:n,height:i}),v.sanitizeMargins(r)},v.supplyLayoutModuleDefaults=function(t,e,r,n){var i,a;c.Axes.supplyLayoutDefaults(t,e,r);var o=e._basePlotModules;for(i=0;i<o.length;i++)a=o[i],\"cartesian\"!==a.name&&a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r);var s=e._modules;for(i=0;i<s.length;i++)a=s[i],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r);var l=e._transformModules;for(i=0;i<l.length;i++)a=l[i],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r,n);var u=Object.keys(f.componentsRegistry);for(i=0;i<u.length;i++)a=f.componentsRegistry[u[i]],a.supplyLayoutDefaults&&a.supplyLayoutDefaults(t,e,r)},v.purge=function(t){var e=t._fullLayout||{};void 0!==e._glcontainer&&e._glcontainer.remove(),void 0!==e._geocontainer&&e._geocontainer.remove(),e._modeBar&&e._modeBar.destroy(),t._transitionData&&(t._transitionData._interruptCallbacks&&(t._transitionData._interruptCallbacks.length=0),t._transitionData._animationRaf&&window.cancelAnimationFrame(t._transitionData._animationRaf)),delete t.data,delete t.layout,delete t._fullData,delete t._fullLayout,delete t.calcdata,delete t.framework,delete t.empty,delete t.fid,delete t.undoqueue,delete t.undonum,delete t.autoplay,delete t.changed,delete t._promises,delete t._redrawTimer,delete t.firstscatter,delete t.hmlumcount,delete t.hmpixcount,delete t.numboxes,delete t._hoverTimer,delete t._lastHoverTime,delete t._transitionData,delete t._transitioning,delete t._initialAutoSize,t.removeAllListeners&&t.removeAllListeners()},v.style=function(t){for(var e=t._fullLayout._modules,r=0;r<e.length;r++){var n=e[r];n.style&&n.style(t)}},v.sanitizeMargins=function(t){if(t&&t.margin){var e,r=t.width,n=t.height,i=t.margin,a=r-(i.l+i.r),o=n-(i.t+i.b);a<0&&(e=(r-1)/(i.l+i.r),i.l=Math.floor(e*i.l),i.r=Math.floor(e*i.r)),o<0&&(e=(n-1)/(i.t+i.b),i.t=Math.floor(e*i.t),i.b=Math.floor(e*i.b))}},v.autoMargin=function(t,e,r){var n=t._fullLayout;if(n._pushmargin||(n._pushmargin={}),!1!==n.margin.autoexpand){if(r){var i=void 0===r.pad?12:r.pad;r.l+r.r>.5*n.width&&(r.l=r.r=0),r.b+r.t>.5*n.height&&(r.b=r.t=0),n._pushmargin[e]={l:{val:r.x,size:r.l+i},r:{val:r.x,size:r.r+i},b:{val:r.y,size:r.b+i},t:{val:r.y,size:r.t+i}}}else delete n._pushmargin[e];n._replotting||v.doAutoMargin(t)}},v.doAutoMargin=function(t){var e=t._fullLayout;e._size||(e._size={}),e._pushmargin||(e._pushmargin={});var r=e._size,n=JSON.stringify(r),i=Math.max(e.margin.l||0,0),a=Math.max(e.margin.r||0,0),o=Math.max(e.margin.t||0,0),s=Math.max(e.margin.b||0,0),l=e._pushmargin;if(!1!==e.margin.autoexpand){l.base={l:{val:0,size:i},r:{val:1,size:a},t:{val:1,size:o},b:{val:0,size:s}}\n",
       ";for(var h=Object.keys(l),f=0;f<h.length;f++)for(var d=h[f],p=l[d].l||{},m=l[d].b||{},v=p.val,g=p.size,y=m.val,b=m.size,x=0;x<h.length;x++){var _=h[x];if(u(g)&&l[_].r){var w=l[_].r.val,M=l[_].r.size;if(w>v){var k=(g*w+(M-e.width)*v)/(w-v),A=(M*(1-v)+(g-e.width)*(1-w))/(w-v);k>=0&&A>=0&&k+A>i+a&&(i=k,a=A)}}if(u(b)&&l[_].t){var T=l[_].t.val,S=l[_].t.size;if(T>y){var E=(b*T+(S-e.height)*y)/(T-y),L=(S*(1-y)+(b-e.height)*(1-T))/(T-y);E>=0&&L>=0&&E+L>s+o&&(s=E,o=L)}}}}if(r.l=Math.round(i),r.r=Math.round(a),r.t=Math.round(o),r.b=Math.round(s),r.p=Math.round(e.margin.pad),r.w=Math.round(e.width)-r.l-r.r,r.h=Math.round(e.height)-r.t-r.b,!e._replotting&&\"{}\"!==n&&n!==JSON.stringify(e._size))return c.plot(t)},v.graphJson=function(t,e,r,n,i){function a(t){if(\"function\"==typeof t)return null;if(d.isPlainObject(t)){var e,n,i={};for(e in t)if(\"function\"!=typeof t[e]&&-1===[\"_\",\"[\"].indexOf(e.charAt(0))){if(\"keepdata\"===r){if(\"src\"===e.substr(e.length-3))continue}else if(\"keepstream\"===r){if(\"string\"==typeof(n=t[e+\"src\"])&&n.indexOf(\":\")>0&&!d.isPlainObject(t.stream))continue}else if(\"keepall\"!==r&&\"string\"==typeof(n=t[e+\"src\"])&&n.indexOf(\":\")>0)continue;i[e]=a(t[e])}return i}return Array.isArray(t)?t.map(a):d.isJSDate(t)?d.ms2DateTimeLocal(+t):t}(i&&e&&!t._fullData||i&&!e&&!t._fullLayout)&&v.supplyDefaults(t);var o=i?t._fullData:t.data,s=i?t._fullLayout:t.layout,l=(t._transitionData||{})._frames,u={data:(o||[]).map(function(t){var r=a(t);return e&&delete r.fit,r})};return e||(u.layout=a(s)),t.framework&&t.framework.isPolar&&(u=t.framework.getConfig()),l&&(u.frames=a(l)),\"object\"===n?u:JSON.stringify(u)},v.modifyFrames=function(t,e){var r,n,i,a=t._transitionData._frames,o=t._transitionData._frameHash;for(r=0;r<e.length;r++)switch(n=e[r],n.type){case\"replace\":i=n.value;var s=(a[n.index]||{}).name,l=i.name;a[n.index]=o[l]=i,l!==s&&(delete o[s],o[l]=i);break;case\"insert\":i=n.value,o[i.name]=i,a.splice(n.index,0,i);break;case\"delete\":i=a[n.index],delete o[i.name],a.splice(n.index,1)}return Promise.resolve()},v.computeFrame=function(t,e){var r,n,i,a,o=t._transitionData._frameHash;if(!e)throw new Error(\"computeFrame must be given a string frame name\");var s=o[e.toString()];if(!s)return!1;for(var l=[s],u=[s.name];s.baseframe&&(s=o[s.baseframe.toString()])&&-1===u.indexOf(s.name);)l.push(s),u.push(s.name);for(var c={};s=l.pop();)if(s.layout&&(c.layout=v.extendLayout(c.layout,s.layout)),s.data){if(c.data||(c.data=[]),!(n=s.traces))for(n=[],r=0;r<s.data.length;r++)n[r]=r;for(c.traces||(c.traces=[]),r=0;r<s.data.length;r++)void 0!==(i=n[r])&&null!==i&&(a=c.traces.indexOf(i),-1===a&&(a=c.data.length,c.traces[a]=i),c.data[a]=v.extendTrace(c.data[a],s.data[r]))}return c},v.recomputeFrameHash=function(t){for(var e=t._transitionData._frameHash={},r=t._transitionData._frames,n=0;n<r.length;n++){var i=r[n];i&&i.name&&(e[i.name]=i)}},v.extendObjectWithContainers=function(t,e,r){var n,i,a,o,s,l,u,c,h=d.extendDeepNoArrays({},e||{}),f=d.expandObjectPaths(h),p={};if(r&&r.length)for(a=0;a<r.length;a++)n=d.nestedProperty(f,r[a]),i=n.get(),void 0===i?d.nestedProperty(p,r[a]).set(null):(n.set(null),d.nestedProperty(p,r[a]).set(i));if(t=d.extendDeepNoArrays(t||{},f),r&&r.length)for(a=0;a<r.length;a++)if(s=d.nestedProperty(p,r[a]),u=s.get()){for(l=d.nestedProperty(t,r[a]),c=l.get(),Array.isArray(c)||(c=[],l.set(c)),o=0;o<u.length;o++){var m=u[o];c[o]=null===m?null:v.extendObjectWithContainers(c[o],m)}l.set(c)}return t},v.dataArrayContainers=[\"transforms\"],v.layoutArrayContainers=f.layoutArrayContainers,v.extendTrace=function(t,e){return v.extendObjectWithContainers(t,e,v.dataArrayContainers)},v.extendLayout=function(t,e){return v.extendObjectWithContainers(t,e,v.layoutArrayContainers)},v.transition=function(t,e,r,n,i,a){function o(){var n;for(n=0;n<y.length;n++){var i=y[n],a=t._fullData[i],o=a._module;o&&(o.animatable&&b.push(i),t.data[y[n]]=v.extendTrace(t.data[y[n]],e[n]))}var s=d.expandObjectPaths(d.extendDeepNoArrays({},r)),l=/^[xy]axis[0-9]*$/;for(var u in s)l.test(u)&&delete s[u].range;return v.extendLayout(t.layout,s),delete t.calcdata,v.supplyDefaults(t),v.doCalcdata(t),w.calc(t),Promise.resolve()}function s(t){var e=Promise.resolve();if(!t)return e;for(;t.length;)e=e.then(t.shift());return e}function l(t){if(t)for(;t.length;)t.shift()}function u(){return t.emit(\"plotly_transitioning\",[]),new Promise(function(e){function n(){return l++,function(){u++,x||u!==l||h(e)}}t._transitioning=!0,a.duration>0&&(t._transitioningWithDuration=!0),t._transitionData._interruptCallbacks.push(function(){x=!0}),i.redraw&&t._transitionData._interruptCallbacks.push(function(){return c.redraw(t)}),t._transitionData._interruptCallbacks.push(function(){t.emit(\"plotly_transitioninterrupted\",[])});var o,s,l=0,u=0,f=t._fullLayout._basePlotModules,p=!1;if(r)for(s=0;s<f.length;s++)if(f[s].transitionAxes){var m=d.expandObjectPaths(r);p=f[s].transitionAxes(t,m,a,n)||p}for(p?(o=d.extendFlat({},a),o.duration=0):o=a,s=0;s<f.length;s++)f[s].plot(t,b,o,n);setTimeout(n())})}function h(e){if(t._transitionData)return l(t._transitionData._interruptCallbacks),Promise.resolve().then(function(){if(i.redraw)return c.redraw(t)}).then(function(){t._transitioning=!1,t._transitioningWithDuration=!1,t.emit(\"plotly_transitioned\",[])}).then(e)}function f(){if(t._transitionData)return t._transitioning=!1,s(t._transitionData._interruptCallbacks)}var p,m,g=Array.isArray(e)?e.length:0,y=n.slice(0,g),b=[],x=!1;for(p=0;p<y.length;p++){m=y[p];var _=t._fullData[m],M=_._module;if(M&&!M.animatable){var k={};for(var A in e[p])k[A]=[e[p][A]]}}var T=[v.previousPromises,f,o,v.rehover,u],S=d.syncOrAsync(T,t);return S&&S.then||(S=Promise.resolve()),S.then(function(){return t})},v.doCalcdata=function(t,e){var r,n,i,a,o=c.Axes.list(t),l=t._fullData,u=t._fullLayout,d=new Array(l.length),p=(t.calcdata||[]).slice(0);for(t.calcdata=d,t.firstscatter=!0,t.numboxes=0,t._hmpixcount=0,t._hmlumcount=0,u._piecolormap={},u._piedefaultcolorcount=0,i=0;i<l.length;i++)Array.isArray(e)&&-1===e.indexOf(i)&&(d[i]=p[i]);for(i=0;i<l.length;i++)r=l[i],r._arrayAttrs=h.findArrayAttributes(r);s(o);var v=!1;for(i=0;i<l.length;i++)if(r=l[i],!0===r.visible&&r.transforms)for(n=r._module,n&&n.calc&&n.calc(t,r),a=0;a<r.transforms.length;a++){var g=r.transforms[a];n=_[g.type],n&&n.calcTransform&&(r._hasCalcTransform=!0,v=!0,n.calcTransform(t,r,g))}if(v){for(i=0;i<o.length;i++)o[i]._min=[],o[i]._max=[],o[i]._categories=[],o[i]._categoriesMap={};s(o)}for(i=0;i<l.length;i++){var y=[];r=l[i],!0===r.visible&&(n=r._module)&&n.calc&&(y=n.calc(t,r)),Array.isArray(y)&&y[0]||(y=[{x:m,y:m}]),y[0].t||(y[0].t={}),y[0].trace=r,d[i]=y}f.getComponentMethod(\"fx\",\"calc\")(t)},v.rehover=function(t){t._fullLayout._rehover&&t._fullLayout._rehover()},v.generalUpdatePerTraceModule=function(t,e,r){var n,i=t.traceHash,a={};for(n=0;n<e.length;n++){var o=e[n],s=o[0].trace;s.visible&&(a[s.type]=a[s.type]||[],a[s.type].push(o))}var l=Object.keys(i),u=Object.keys(a);for(n=0;n<l.length;n++){var c=l[n];if(-1===u.indexOf(c)){var h=i[c][0];h[0].trace.visible=!1,a[c]=[h]}}for(u=Object.keys(a),n=0;n<u.length;n++){var f=a[u[n]];f[0][0].trace._module.plot(t,function(t){for(var e=[],r=0;r<t.length;r++){var n=t[r];!0===n[0].trace.visible&&e.push(n)}return e}(f),r)}t.traceHash=a}},{\"../components/color\":603,\"../components/errorbars\":633,\"../constants/numerical\":705,\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plotly\":761,\"../registry\":844,\"./animation_attributes\":762,\"./attributes\":764,\"./command\":789,\"./font_attributes\":790,\"./frame_attributes\":791,\"./layout_attributes\":820,d3:121,\"fast-isnumeric\":130}],830:[function(t,e,r){\"use strict\";var n=t(\"../../traces/scatter/attributes\"),i=n.marker;e.exports={r:n.r,t:n.t,marker:{color:i.color,size:i.size,symbol:i.symbol,opacity:i.opacity}}},{\"../../traces/scatter/attributes\":1027}],831:[function(t,e,r){\"use strict\";function n(t,e){return a({},e,{showline:{valType:\"boolean\"},showticklabels:{valType:\"boolean\"},tickorientation:{valType:\"enumerated\",values:[\"horizontal\",\"vertical\"]},ticklen:{valType:\"number\",min:0},tickcolor:{valType:\"color\"},ticksuffix:{valType:\"string\"},endpadding:{valType:\"number\"},visible:{valType:\"boolean\"}})}var i=t(\"../cartesian/layout_attributes\"),a=t(\"../../lib/extend\").extendFlat,o=a({},i.domain,{});e.exports={radialaxis:n(\"radial\",{range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},domain:o,orientation:{valType:\"number\"}}),angularaxis:n(\"angular\",{range:{valType:\"info_array\",items:[{valType:\"number\",dflt:0},{valType:\"number\",dflt:360}]},domain:o}),layout:{direction:{valType:\"enumerated\",values:[\"clockwise\",\"counterclockwise\"]},orientation:{valType:\"angle\"}}}},{\"../../lib/extend\":716,\"../cartesian/layout_attributes\":777}],832:[function(t,e,r){\"use strict\";(e.exports=t(\"./micropolar\")).manager=t(\"./micropolar_manager\")},{\"./micropolar\":833,\"./micropolar_manager\":834}],833:[function(t,e,r){var n=t(\"d3\"),i=t(\"../../lib\"),a=i.extendDeepAll,o=t(\"../../constants/alignment\").MID_SHIFT,s=e.exports={version:\"0.2.2\"};s.Axis=function(){function t(t){r=t||r;var c=u.data,f=u.layout;return(\"string\"==typeof r||r.nodeName)&&(r=n.select(r)),r.datum(c).each(function(t,r){function u(t,e){return l(t)%360+f.orientation}var c=t.slice();h={data:s.util.cloneJson(c),layout:s.util.cloneJson(f)};var d=0;c.forEach(function(t,e){t.color||(t.color=f.defaultColorRange[d],d=(d+1)%f.defaultColorRange.length),t.strokeColor||(t.strokeColor=\"LinePlot\"===t.geometry?t.color:n.rgb(t.color).darker().toString()),h.data[e].color=t.color,h.data[e].strokeColor=t.strokeColor,h.data[e].strokeDash=t.strokeDash,h.data[e].strokeSize=t.strokeSize});var p=c.filter(function(t,e){var r=t.visible;return void 0===r||!0===r}),m=!1,v=p.map(function(t,e){return m=m||void 0!==t.groupId,t});if(m){var g=n.nest().key(function(t,e){return void 0!==t.groupId?t.groupId:\"unstacked\"}).entries(v),y=[],b=g.map(function(t,e){if(\"unstacked\"===t.key)return t.values;var r=t.values[0].r.map(function(t,e){return 0});return t.values.forEach(function(t,e,n){t.yStack=[r],y.push(r),r=s.util.sumArrays(t.r,r)}),t.values});p=n.merge(b)}p.forEach(function(t,e){t.t=Array.isArray(t.t[0])?t.t:[t.t],t.r=Array.isArray(t.r[0])?t.r:[t.r]});var x=Math.min(f.width-f.margin.left-f.margin.right,f.height-f.margin.top-f.margin.bottom)/2;x=Math.max(10,x);var _,w=[f.margin.left+x,f.margin.top+x];if(m){_=[0,n.max(s.util.sumArrays(s.util.arrayLast(p).r[0],s.util.arrayLast(y)))]}else _=n.extent(s.util.flattenArray(p.map(function(t,e){return t.r})));f.radialAxis.domain!=s.DATAEXTENT&&(_[0]=0),i=n.scale.linear().domain(f.radialAxis.domain!=s.DATAEXTENT&&f.radialAxis.domain?f.radialAxis.domain:_).range([0,x]),h.layout.radialAxis.domain=i.domain();var M,k=s.util.flattenArray(p.map(function(t,e){return t.t})),A=\"string\"==typeof k[0];A&&(k=s.util.deduplicate(k),M=k.slice(),k=n.range(k.length),p=p.map(function(t,e){var r=t;return t.t=[k],m&&(r.yStack=t.yStack),r}));var T=p.filter(function(t,e){return\"LinePlot\"===t.geometry||\"DotPlot\"===t.geometry}).length===p.length,S=null===f.needsEndSpacing?A||!T:f.needsEndSpacing,E=f.angularAxis.domain&&f.angularAxis.domain!=s.DATAEXTENT&&!A&&f.angularAxis.domain[0]>=0,L=E?f.angularAxis.domain:n.extent(k),C=Math.abs(k[1]-k[0]);T&&!A&&(C=0);var z=L.slice();S&&A&&(z[1]+=C);var I=f.angularAxis.ticksCount||4;I>8&&(I=I/(I/8)+I%8),f.angularAxis.ticksStep&&(I=(z[1]-z[0])/I);var D=f.angularAxis.ticksStep||(z[1]-z[0])/(I*(f.minorTicks+1));M&&(D=Math.max(Math.round(D),1)),z[2]||(z[2]=D);var P=n.range.apply(this,z);if(P=P.map(function(t,e){return parseFloat(t.toPrecision(12))}),l=n.scale.linear().domain(z.slice(0,2)).range(\"clockwise\"===f.direction?[0,360]:[360,0]),h.layout.angularAxis.domain=l.domain(),h.layout.angularAxis.endPadding=S?C:0,void 0===(e=n.select(this).select(\"svg.chart-root\"))||e.empty()){var O=(new DOMParser).parseFromString(\"<svg xmlns='http://www.w3.org/2000/svg' class='chart-root'>' + '<g class='outer-group'>' + '<g class='chart-group'>' + '<circle class='background-circle'></circle>' + '<g class='geometry-group'></g>' + '<g class='radial axis-group'>' + '<circle class='outside-circle'></circle>' + '</g>' + '<g class='angular axis-group'></g>' + '<g class='guides-group'><line></line><circle r='0'></circle></g>' + '</g>' + '<g class='legend-group'></g>' + '<g class='tooltips-group'></g>' + '<g class='title-group'><text></text></g>' + '</g>' + '</svg>\",\"application/xml\"),R=this.appendChild(this.ownerDocument.importNode(O.documentElement,!0));e=n.select(R)}e.select(\".guides-group\").style({\"pointer-events\":\"none\"}),e.select(\".angular.axis-group\").style({\"pointer-events\":\"none\"}),e.select(\".radial.axis-group\").style({\"pointer-events\":\"none\"});var F,j=e.select(\".chart-group\"),N={fill:\"none\",stroke:f.tickColor},B={\"font-size\":f.font.size,\"font-family\":f.font.family,fill:f.font.color,\"text-shadow\":[\"-1px 0px\",\"1px -1px\",\"-1px 1px\",\"1px 1px\"].map(function(t,e){return\" \"+t+\" 0 \"+f.font.outlineColor}).join(\",\")};if(f.showLegend){F=e.select(\".legend-group\").attr({transform:\"translate(\"+[x,f.margin.top]+\")\"}).style({display:\"block\"});var U=p.map(function(t,e){var r=s.util.cloneJson(t);return r.symbol=\"DotPlot\"===t.geometry?t.dotType||\"circle\":\"LinePlot\"!=t.geometry?\"square\":\"line\",r.visibleInLegend=void 0===t.visibleInLegend||t.visibleInLegend,r.color=\"LinePlot\"===t.geometry?t.strokeColor:t.color,r});s.Legend().config({data:p.map(function(t,e){return t.name||\"Element\"+e}),legendConfig:a({},s.Legend.defaultConfig().legendConfig,{container:F,elements:U,reverseOrder:f.legend.reverseOrder})})();var V=F.node().getBBox();x=Math.min(f.width-V.width-f.margin.left-f.margin.right,f.height-f.margin.top-f.margin.bottom)/2,x=Math.max(10,x),w=[f.margin.left+x,f.margin.top+x],i.range([0,x]),h.layout.radialAxis.domain=i.domain(),F.attr(\"transform\",\"translate(\"+[w[0]+x,w[1]-x]+\")\")}else F=e.select(\".legend-group\").style({display:\"none\"});e.attr({width:f.width,height:f.height}).style({opacity:f.opacity}),j.attr(\"transform\",\"translate(\"+w+\")\").style({cursor:\"crosshair\"});var H=[(f.width-(f.margin.left+f.margin.right+2*x+(V?V.width:0)))/2,(f.height-(f.margin.top+f.margin.bottom+2*x))/2];if(H[0]=Math.max(0,H[0]),H[1]=Math.max(0,H[1]),e.select(\".outer-group\").attr(\"transform\",\"translate(\"+H+\")\"),f.title){var q=e.select(\"g.title-group text\").style(B).text(f.title),G=q.node().getBBox();q.attr({x:w[0]-G.width/2,y:w[1]-x-20})}var Y=e.select(\".radial.axis-group\");if(f.radialAxis.gridLinesVisible){var X=Y.selectAll(\"circle.grid-circle\").data(i.ticks(5));X.enter().append(\"circle\").attr({class:\"grid-circle\"}).style(N),X.attr(\"r\",i),X.exit().remove()}Y.select(\"circle.outside-circle\").attr({r:x}).style(N);var W=e.select(\"circle.background-circle\").attr({r:x}).style({fill:f.backgroundColor,stroke:f.stroke});if(f.radialAxis.visible){var Z=n.svg.axis().scale(i).ticks(5).tickSize(5);Y.call(Z).attr({transform:\"rotate(\"+f.radialAxis.orientation+\")\"}),Y.selectAll(\".domain\").style(N),Y.selectAll(\"g>text\").text(function(t,e){return this.textContent+f.radialAxis.ticksSuffix}).style(B).style({\"text-anchor\":\"start\"}).attr({x:0,y:0,dx:0,dy:0,transform:function(t,e){return\"horizontal\"===f.radialAxis.tickOrientation?\"rotate(\"+-f.radialAxis.orientation+\") translate(\"+[0,B[\"font-size\"]]+\")\":\"translate(\"+[0,B[\"font-size\"]]+\")\"}}),Y.selectAll(\"g>line\").style({stroke:\"black\"})}var J=e.select(\".angular.axis-group\").selectAll(\"g.angular-tick\").data(P),K=J.enter().append(\"g\").classed(\"angular-tick\",!0);J.attr({transform:function(t,e){return\"rotate(\"+u(t,e)+\")\"}}).style({display:f.angularAxis.visible?\"block\":\"none\"}),J.exit().remove(),K.append(\"line\").classed(\"grid-line\",!0).classed(\"major\",function(t,e){return e%(f.minorTicks+1)==0}).classed(\"minor\",function(t,e){return!(e%(f.minorTicks+1)==0)}).style(N),K.selectAll(\".minor\").style({stroke:f.minorTickColor}),J.select(\"line.grid-line\").attr({x1:f.tickLength?x-f.tickLength:0,x2:x}).style({display:f.angularAxis.gridLinesVisible?\"block\":\"none\"}),K.append(\"text\").classed(\"axis-text\",!0).style(B);var Q=J.select(\"text.axis-text\").attr({x:x+f.labelOffset,dy:o+\"em\",transform:function(t,e){var r=u(t,e),n=x+f.labelOffset,i=f.angularAxis.tickOrientation;return\"horizontal\"==i?\"rotate(\"+-r+\" \"+n+\" 0)\":\"radial\"==i?r<270&&r>90?\"rotate(180 \"+n+\" 0)\":null:\"rotate(\"+(r<=180&&r>0?-90:90)+\" \"+n+\" 0)\"}}).style({\"text-anchor\":\"middle\",display:f.angularAxis.labelsVisible?\"block\":\"none\"}).text(function(t,e){return e%(f.minorTicks+1)!=0?\"\":M?M[t]+f.angularAxis.ticksSuffix:t+f.angularAxis.ticksSuffix}).style(B);f.angularAxis.rewriteTicks&&Q.text(function(t,e){return e%(f.minorTicks+1)!=0?\"\":f.angularAxis.rewriteTicks(this.textContent,e)});var $=n.max(j.selectAll(\".angular-tick text\")[0].map(function(t,e){return t.getCTM().e+t.getBBox().width}));F.attr({transform:\"translate(\"+[x+$,f.margin.top]+\")\"});var tt=e.select(\"g.geometry-group\").selectAll(\"g\").size()>0,et=e.select(\"g.geometry-group\").selectAll(\"g.geometry\").data(p);if(et.enter().append(\"g\").attr({class:function(t,e){return\"geometry geometry\"+e}}),et.exit().remove(),p[0]||tt){var rt=[];p.forEach(function(t,e){var r={};r.radialScale=i,r.angularScale=l,r.container=et.filter(function(t,r){return r==e}),r.geometry=t.geometry,r.orientation=f.orientation,r.direction=f.direction,r.index=e,rt.push({data:t,geometryConfig:r})});var nt=n.nest().key(function(t,e){return void 0!==t.data.groupId||\"unstacked\"}).entries(rt),it=[];nt.forEach(function(t,e){\"unstacked\"===t.key?it=it.concat(t.values.map(function(t,e){return[t]})):it.push(t.values)}),it.forEach(function(t,e){var r;r=Array.isArray(t)?t[0].geometryConfig.geometry:t.geometryConfig.geometry;var n=t.map(function(t,e){return a(s[r].defaultConfig(),t)});s[r]().config(n)()})}var at,ot,st=e.select(\".guides-group\"),lt=e.select(\".tooltips-group\"),ut=s.tooltipPanel().config({container:lt,fontSize:8})(),ct=s.tooltipPanel().config({container:lt,fontSize:8})(),ht=s.tooltipPanel().config({container:lt,hasTick:!0})();if(!A){var ft=st.select(\"line\").attr({x1:0,y1:0,y2:0}).style({stroke:\"grey\",\"pointer-events\":\"none\"});j.on(\"mousemove.angular-guide\",function(t,e){var r=s.util.getMousePos(W).angle;ft.attr({x2:-x,transform:\"rotate(\"+r+\")\"}).style({opacity:.5});var n=(r+180+360-f.orientation)%360;at=l.invert(n);var i=s.util.convertToCartesian(x+12,r+180);ut.text(s.util.round(at)).move([i[0]+w[0],i[1]+w[1]])}).on(\"mouseout.angular-guide\",function(t,e){st.select(\"line\").style({opacity:0})})}var dt=st.select(\"circle\").style({stroke:\"grey\",fill:\"none\"});j.on(\"mousemove.radial-guide\",function(t,e){var r=s.util.getMousePos(W).radius;dt.attr({r:r}).style({opacity:.5}),ot=i.invert(s.util.getMousePos(W).radius);var n=s.util.convertToCartesian(r,f.radialAxis.orientation);ct.text(s.util.round(ot)).move([n[0]+w[0],n[1]+w[1]])}).on(\"mouseout.radial-guide\",function(t,e){dt.style({opacity:0}),ht.hide(),ut.hide(),ct.hide()}),e.selectAll(\".geometry-group .mark\").on(\"mouseover.tooltip\",function(t,r){var i=n.select(this),a=i.style(\"fill\"),o=\"black\",l=i.style(\"opacity\")||1;if(i.attr({\"data-opacity\":l}),\"none\"!=a){i.attr({\"data-fill\":a}),o=n.hsl(a).darker().toString(),i.style({fill:o,opacity:1});var u={t:s.util.round(t[0]),r:s.util.round(t[1])};A&&(u.t=M[t[0]]);var c=\"t: \"+u.t+\", r: \"+u.r,h=this.getBoundingClientRect(),f=e.node().getBoundingClientRect(),d=[h.left+h.width/2-H[0]-f.left,h.top+h.height/2-H[1]-f.top];ht.config({color:o}).text(c),ht.move(d)}else a=i.style(\"stroke\"),i.attr({\"data-stroke\":a}),o=n.hsl(a).darker().toString(),i.style({stroke:o,opacity:1})}).on(\"mousemove.tooltip\",function(t,e){if(0!=n.event.which)return!1;n.select(this).attr(\"data-fill\")&&ht.show()}).on(\"mouseout.tooltip\",function(t,e){ht.hide();var r=n.select(this),i=r.attr(\"data-fill\");i?r.style({fill:i,opacity:r.attr(\"data-opacity\")}):r.style({stroke:r.attr(\"data-stroke\"),opacity:r.attr(\"data-opacity\")})})}),d}var e,r,i,l,u={data:[],layout:{}},c={},h={},f=n.dispatch(\"hover\"),d={};return d.render=function(e){return t(e),this},d.config=function(t){if(!arguments.length)return u;var e=s.util.cloneJson(t);return e.data.forEach(function(t,e){u.data[e]||(u.data[e]={}),a(u.data[e],s.Axis.defaultConfig().data[0]),a(u.data[e],t)}),a(u.layout,s.Axis.defaultConfig().layout),a(u.layout,e.layout),this},d.getLiveConfig=function(){return h},d.getinputConfig=function(){return c},d.radialScale=function(t){return i},d.angularScale=function(t){return l},d.svg=function(){return e},n.rebind(d,f,\"on\"),d},s.Axis.defaultConfig=function(t,e){return{data:[{t:[1,2,3,4],r:[10,11,12,13],name:\"Line1\",geometry:\"LinePlot\",color:null,strokeDash:\"solid\",strokeColor:null,strokeSize:\"1\",visibleInLegend:!0,opacity:1}],layout:{defaultColorRange:n.scale.category10().range(),title:null,height:450,width:500,margin:{top:40,right:40,bottom:40,left:40},font:{size:12,color:\"gray\",outlineColor:\"white\",family:\"Tahoma, sans-serif\"},direction:\"clockwise\",orientation:0,labelOffset:10,radialAxis:{domain:null,orientation:-45,ticksSuffix:\"\",visible:!0,gridLinesVisible:!0,tickOrientation:\"horizontal\",rewriteTicks:null},angularAxis:{domain:[0,360],ticksSuffix:\"\",visible:!0,gridLinesVisible:!0,labelsVisible:!0,tickOrientation:\"horizontal\",rewriteTicks:null,ticksCount:null,ticksStep:null},minorTicks:0,tickLength:null,tickColor:\"silver\",minorTickColor:\"#eee\",backgroundColor:\"none\",needsEndSpacing:null,showLegend:!0,legend:{reverseOrder:!1},opacity:1}}},s.util={},s.DATAEXTENT=\"dataExtent\",s.AREA=\"AreaChart\",s.LINE=\"LinePlot\",s.DOT=\"DotPlot\",s.BAR=\"BarChart\",s.util._override=function(t,e){for(var r in t)r in e&&(e[r]=t[r])},s.util._extend=function(t,e){for(var r in t)e[r]=t[r]},s.util._rndSnd=function(){return 2*Math.random()-1+(2*Math.random()-1)+(2*Math.random()-1)},s.util.dataFromEquation2=function(t,e){var r=e||6;return n.range(0,360+r,r).map(function(e,r){var n=e*Math.PI/180;return[e,t(n)]})},s.util.dataFromEquation=function(t,e,r){var i=e||6,a=[],o=[];n.range(0,360+i,i).forEach(function(e,r){var n=e*Math.PI/180,i=t(n);a.push(e),o.push(i)});var s={t:a,r:o};return r&&(s.name=r),s},s.util.ensureArray=function(t,e){if(void 0===t)return null;var r=[].concat(t);return n.range(e).map(function(t,e){return r[e]||r[0]})},s.util.fillArrays=function(t,e,r){return e.forEach(function(e,n){t[e]=s.util.ensureArray(t[e],r)}),t},s.util.cloneJson=function(t){return JSON.parse(JSON.stringify(t))},s.util.validateKeys=function(t,e){\"string\"==typeof e&&(e=e.split(\".\"));var r=e.shift();return t[r]&&(!e.length||objHasKeys(t[r],e))},s.util.sumArrays=function(t,e){return n.zip(t,e).map(function(t,e){return n.sum(t)})},s.util.arrayLast=function(t){return t[t.length-1]},s.util.arrayEqual=function(t,e){for(var r=Math.max(t.length,e.length,1);r-- >=0&&t[r]===e[r];);return-2===r},s.util.flattenArray=function(t){for(var e=[];!s.util.arrayEqual(e,t);)e=t,t=[].concat.apply([],t);return t},s.util.deduplicate=function(t){return t.filter(function(t,e,r){return r.indexOf(t)==e})},s.util.convertToCartesian=function(t,e){var r=e*Math.PI/180;return[t*Math.cos(r),t*Math.sin(r)]},s.util.round=function(t,e){var r=e||2,n=Math.pow(10,r);return Math.round(t*n)/n},s.util.getMousePos=function(t){var e=n.mouse(t.node()),r=e[0],i=e[1],a={};return a.x=r,a.y=i,a.pos=e,a.angle=180*(Math.atan2(i,r)+Math.PI)/Math.PI,a.radius=Math.sqrt(r*r+i*i),a},s.util.duplicatesCount=function(t){for(var e,r={},n={},i=0,a=t.length;i<a;i++)e=t[i],e in r?(r[e]++,n[e]=r[e]):r[e]=1;return n},s.util.duplicates=function(t){return Object.keys(s.util.duplicatesCount(t))},s.util.translator=function(t,e,r,n){if(n){var i=r.slice();r=e,e=i}var a=e.reduce(function(t,e){if(void 0!==t)return t[e]},t);void 0!==a&&(e.reduce(function(t,r,n){if(void 0!==t)return n===e.length-1&&delete t[r],t[r]},t),r.reduce(function(t,e,n){return void 0===t[e]&&(t[e]={}),n===r.length-1&&(t[e]=a),t[e]},t))},s.PolyChart=function(){function t(){var t=e[0].geometryConfig,r=t.container;\"string\"==typeof r&&(r=n.select(r)),r.datum(e).each(function(e,r){function a(e,r){return{r:t.radialScale(e[1]),t:(t.angularScale(e[0])+t.orientation)*Math.PI/180}}function o(t){return{x:t.r*Math.cos(t.t),y:t.r*Math.sin(t.t)}}var s=!!e[0].data.yStack,l=e.map(function(t,e){return s?n.zip(t.data.t[0],t.data.r[0],t.data.yStack[0]):n.zip(t.data.t[0],t.data.r[0])}),u=t.angularScale,c=t.radialScale.domain()[0],h={};h.bar=function(r,i,a){var o=e[a].data,s=t.radialScale(r[1])-t.radialScale(0),l=t.radialScale(r[2]||0),c=o.barWidth;n.select(this).attr({class:\"mark bar\",d:\"M\"+[[s+l,-c/2],[s+l,c/2],[l,c/2],[l,-c/2]].join(\"L\")+\"Z\",transform:function(e,r){return\"rotate(\"+(t.orientation+u(e[0]))+\")\"}})},h.dot=function(t,r,i){var s=t[2]?[t[0],t[1]+t[2]]:t,l=n.svg.symbol().size(e[i].data.dotSize).type(e[i].data.dotType)(t,r);n.select(this).attr({class:\"mark dot\",d:l,transform:function(t,e){var r=o(a(s));return\"translate(\"+[r.x,r.y]+\")\"}})};var f=n.svg.line.radial().interpolate(e[0].data.lineInterpolation).radius(function(e){return t.radialScale(e[1])}).angle(function(e){return t.angularScale(e[0])*Math.PI/180});h.line=function(r,i,a){var o=r[2]?l[a].map(function(t,e){return[t[0],t[1]+t[2]]}):l[a];if(n.select(this).each(h.dot).style({opacity:function(t,r){return+e[a].data.dotVisible},fill:v.stroke(r,i,a)}).attr({class:\"mark dot\"}),!(i>0)){var s=n.select(this.parentNode).selectAll(\"path.line\").data([0]);s.enter().insert(\"path\"),s.attr({class:\"line\",d:f(o),transform:function(e,r){return\"rotate(\"+(t.orientation+90)+\")\"},\"pointer-events\":\"none\"}).style({fill:function(t,e){return v.fill(r,i,a)},\"fill-opacity\":0,stroke:function(t,e){return v.stroke(r,i,a)},\"stroke-width\":function(t,e){return v[\"stroke-width\"](r,i,a)},\"stroke-dasharray\":function(t,e){return v[\"stroke-dasharray\"](r,i,a)},opacity:function(t,e){return v.opacity(r,i,a)},display:function(t,e){return v.display(r,i,a)}})}};var d=t.angularScale.range(),p=Math.abs(d[1]-d[0])/l[0].length*Math.PI/180,m=n.svg.arc().startAngle(function(t){return-p/2}).endAngle(function(t){return p/2}).innerRadius(function(e){return t.radialScale(c+(e[2]||0))}).outerRadius(function(e){return t.radialScale(c+(e[2]||0))+t.radialScale(e[1])});h.arc=function(e,r,i){n.select(this).attr({class:\"mark arc\",d:m,transform:function(e,r){return\"rotate(\"+(t.orientation+u(e[0])+90)+\")\"}})};var v={fill:function(t,r,n){return e[n].data.color},stroke:function(t,r,n){return e[n].data.strokeColor},\"stroke-width\":function(t,r,n){return e[n].data.strokeSize+\"px\"},\"stroke-dasharray\":function(t,r,n){return i[e[n].data.strokeDash]},opacity:function(t,r,n){return e[n].data.opacity},display:function(t,r,n){return void 0===e[n].data.visible||e[n].data.visible?\"block\":\"none\"}},g=n.select(this).selectAll(\"g.layer\").data(l);g.enter().append(\"g\").attr({class:\"layer\"});var y=g.selectAll(\"path.mark\").data(function(t,e){return t});y.enter().append(\"path\").attr({class:\"mark\"}),y.style(v).each(h[t.geometryType]),y.exit().remove(),g.exit().remove()})}var e=[s.PolyChart.defaultConfig()],r=n.dispatch(\"hover\"),i={solid:\"none\",dash:[5,2],dot:[2,5]};return t.config=function(t){return arguments.length?(t.forEach(function(t,r){e[r]||(e[r]={}),a(e[r],s.PolyChart.defaultConfig()),a(e[r],t)}),this):e},t.getColorScale=function(){},n.rebind(t,r,\"on\"),t},s.PolyChart.defaultConfig=function(){return{data:{name:\"geom1\",t:[[1,2,3,4]],r:[[1,2,3,4]],dotType:\"circle\",dotSize:64,dotVisible:!1,barWidth:20,color:\"#ffa500\",strokeSize:1,strokeColor:\"silver\",strokeDash:\"solid\",opacity:1,index:0,visible:!0,visibleInLegend:!0},geometryConfig:{geometry:\"LinePlot\",geometryType:\"arc\",direction:\"clockwise\",orientation:0,container:\"body\",radialScale:null,angularScale:null,colorScale:n.scale.category20()}}},s.BarChart=function(){return s.PolyChart()},s.BarChart.defaultConfig=function(){return{geometryConfig:{geometryType:\"bar\"}}},s.AreaChart=function(){return s.PolyChart()},s.AreaChart.defaultConfig=function(){return{geometryConfig:{geometryType:\"arc\"}}},s.DotPlot=function(){return s.PolyChart()},s.DotPlot.defaultConfig=function(){return{geometryConfig:{geometryType:\"dot\",dotType:\"circle\"}}},s.LinePlot=function(){return s.PolyChart()},s.LinePlot.defaultConfig=function(){return{geometryConfig:{geometryType:\"line\"}}},s.Legend=function(){function t(){var r=e.legendConfig,i=e.data.map(function(t,e){return[].concat(t).map(function(t,n){var i=a({},r.elements[e]);return i.name=t,i.color=[].concat(r.elements[e].color)[n],i})}),o=n.merge(i);o=o.filter(function(t,e){return r.elements[e]&&(r.elements[e].visibleInLegend||void 0===r.elements[e].visibleInLegend)}),r.reverseOrder&&(o=o.reverse());var s=r.container;(\"string\"==typeof s||s.nodeName)&&(s=n.select(s));var l=o.map(function(t,e){return t.color}),u=r.fontSize,c=null==r.isContinuous?\"number\"==typeof o[0]:r.isContinuous,h=c?r.height:u*o.length,f=s.classed(\"legend-group\",!0),d=f.selectAll(\"svg\").data([0]),p=d.enter().append(\"svg\").attr({width:300,height:h+u,xmlns:\"http://www.w3.org/2000/svg\",\"xmlns:xlink\":\"http://www.w3.org/1999/xlink\",version:\"1.1\"});p.append(\"g\").classed(\"legend-axis\",!0),p.append(\"g\").classed(\"legend-marks\",!0);var m=n.range(o.length),v=n.scale[c?\"linear\":\"ordinal\"]().domain(m).range(l),g=n.scale[c?\"linear\":\"ordinal\"]().domain(m)[c?\"range\":\"rangePoints\"]([0,h]),y=function(t,e){var r=3*e;return\"line\"===t?\"M\"+[[-e/2,-e/12],[e/2,-e/12],[e/2,e/12],[-e/2,e/12]]+\"Z\":-1!=n.svg.symbolTypes.indexOf(t)?n.svg.symbol().type(t).size(r)():n.svg.symbol().type(\"square\").size(r)()};if(c){var b=d.select(\".legend-marks\").append(\"defs\").append(\"linearGradient\").attr({id:\"grad1\",x1:\"0%\",y1:\"0%\",x2:\"0%\",y2:\"100%\"}).selectAll(\"stop\").data(l);b.enter().append(\"stop\"),b.attr({offset:function(t,e){return e/(l.length-1)*100+\"%\"}}).style({\"stop-color\":function(t,e){return t}}),d.append(\"rect\").classed(\"legend-mark\",!0).attr({height:r.height,width:r.colorBandWidth,fill:\"url(#grad1)\"})}else{var x=d.select(\".legend-marks\").selectAll(\"path.legend-mark\").data(o);x.enter().append(\"path\").classed(\"legend-mark\",!0),x.attr({transform:function(t,e){return\"translate(\"+[u/2,g(e)+u/2]+\")\"},d:function(t,e){var r=t.symbol;return y(r,u)},fill:function(t,e){return v(e)}}),x.exit().remove()}var _=n.svg.axis().scale(g).orient(\"right\"),w=d.select(\"g.legend-axis\").attr({transform:\"translate(\"+[c?r.colorBandWidth:u,u/2]+\")\"}).call(_);return w.selectAll(\".domain\").style({fill:\"none\",stroke:\"none\"}),w.selectAll(\"line\").style({fill:\"none\",stroke:c?r.textColor:\"none\"}),w.selectAll(\"text\").style({fill:r.textColor,\"font-size\":r.fontSize}).text(function(t,e){return o[e].name}),t}var e=s.Legend.defaultConfig(),r=n.dispatch(\"hover\");return t.config=function(t){return arguments.length?(a(e,t),this):e},n.rebind(t,r,\"on\"),t},s.Legend.defaultConfig=function(t,e){return{data:[\"a\",\"b\",\"c\"],legendConfig:{elements:[{symbol:\"line\",color:\"red\"},{symbol:\"square\",color:\"yellow\"},{symbol:\"diamond\",color:\"limegreen\"}],height:150,colorBandWidth:30,fontSize:12,container:\"body\",isContinuous:null,textColor:\"grey\",reverseOrder:!1}}},s.tooltipPanel=function(){var t,e,r,i={container:null,hasTick:!1,fontSize:12,color:\"white\",padding:5},o=\"tooltip-\"+s.tooltipPanel.uid++,l=function(){t=i.container.selectAll(\"g.\"+o).data([0]);var n=t.enter().append(\"g\").classed(o,!0).style({\"pointer-events\":\"none\",display:\"none\"});return r=n.append(\"path\").style({fill:\"white\",\"fill-opacity\":.9}).attr({d:\"M0 0\"}),e=n.append(\"text\").attr({dx:i.padding+10,dy:.3*+i.fontSize}),l};return l.text=function(a){var o=n.hsl(i.color).l,s=o>=.5?\"#aaa\":\"white\",u=o>=.5?\"black\":\"white\",c=a||\"\";e.style({fill:u,\"font-size\":i.fontSize+\"px\"}).text(c);var h=i.padding,f=e.node().getBBox(),d={fill:i.color,stroke:s,\"stroke-width\":\"2px\"},p=f.width+2*h+10,m=f.height+2*h;return r.attr({d:\"M\"+[[10,-m/2],[10,-m/4],[i.hasTick?0:10,0],[10,m/4],[10,m/2],[p,m/2],[p,-m/2]].join(\"L\")+\"Z\"}).style(d),t.attr({transform:\"translate(\"+[10,-m/2+2*h]+\")\"}),t.style({display:\"block\"}),l},l.move=function(e){if(t)return t.attr({transform:\"translate(\"+[e[0],e[1]]+\")\"}).style({display:\"block\"}),l},l.hide=function(){if(t)return t.style({display:\"none\"}),l},l.show=function(){if(t)return t.style({display:\"block\"}),l},l.config=function(t){return a(i,t),l},l},s.tooltipPanel.uid=1,s.adapter={},s.adapter.plotly=function(){var t={};return t.convert=function(t,e){\n",
       "var r={};if(t.data&&(r.data=t.data.map(function(t,r){var n=a({},t);return[[n,[\"marker\",\"color\"],[\"color\"]],[n,[\"marker\",\"opacity\"],[\"opacity\"]],[n,[\"marker\",\"line\",\"color\"],[\"strokeColor\"]],[n,[\"marker\",\"line\",\"dash\"],[\"strokeDash\"]],[n,[\"marker\",\"line\",\"width\"],[\"strokeSize\"]],[n,[\"marker\",\"symbol\"],[\"dotType\"]],[n,[\"marker\",\"size\"],[\"dotSize\"]],[n,[\"marker\",\"barWidth\"],[\"barWidth\"]],[n,[\"line\",\"interpolation\"],[\"lineInterpolation\"]],[n,[\"showlegend\"],[\"visibleInLegend\"]]].forEach(function(t,r){s.util.translator.apply(null,t.concat(e))}),e||delete n.marker,e&&delete n.groupId,e?(\"LinePlot\"===n.geometry?(n.type=\"scatter\",!0===n.dotVisible?(delete n.dotVisible,n.mode=\"lines+markers\"):n.mode=\"lines\"):\"DotPlot\"===n.geometry?(n.type=\"scatter\",n.mode=\"markers\"):\"AreaChart\"===n.geometry?n.type=\"area\":\"BarChart\"===n.geometry&&(n.type=\"bar\"),delete n.geometry):(\"scatter\"===n.type?\"lines\"===n.mode?n.geometry=\"LinePlot\":\"markers\"===n.mode?n.geometry=\"DotPlot\":\"lines+markers\"===n.mode&&(n.geometry=\"LinePlot\",n.dotVisible=!0):\"area\"===n.type?n.geometry=\"AreaChart\":\"bar\"===n.type&&(n.geometry=\"BarChart\"),delete n.mode,delete n.type),n}),!e&&t.layout&&\"stack\"===t.layout.barmode)){var i=s.util.duplicates(r.data.map(function(t,e){return t.geometry}));r.data.forEach(function(t,e){var n=i.indexOf(t.geometry);-1!=n&&(r.data[e].groupId=n)})}if(t.layout){var o=a({},t.layout);if([[o,[\"plot_bgcolor\"],[\"backgroundColor\"]],[o,[\"showlegend\"],[\"showLegend\"]],[o,[\"radialaxis\"],[\"radialAxis\"]],[o,[\"angularaxis\"],[\"angularAxis\"]],[o.angularaxis,[\"showline\"],[\"gridLinesVisible\"]],[o.angularaxis,[\"showticklabels\"],[\"labelsVisible\"]],[o.angularaxis,[\"nticks\"],[\"ticksCount\"]],[o.angularaxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.angularaxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.angularaxis,[\"range\"],[\"domain\"]],[o.angularaxis,[\"endpadding\"],[\"endPadding\"]],[o.radialaxis,[\"showline\"],[\"gridLinesVisible\"]],[o.radialaxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.radialaxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.radialaxis,[\"range\"],[\"domain\"]],[o.angularAxis,[\"showline\"],[\"gridLinesVisible\"]],[o.angularAxis,[\"showticklabels\"],[\"labelsVisible\"]],[o.angularAxis,[\"nticks\"],[\"ticksCount\"]],[o.angularAxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.angularAxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.angularAxis,[\"range\"],[\"domain\"]],[o.angularAxis,[\"endpadding\"],[\"endPadding\"]],[o.radialAxis,[\"showline\"],[\"gridLinesVisible\"]],[o.radialAxis,[\"tickorientation\"],[\"tickOrientation\"]],[o.radialAxis,[\"ticksuffix\"],[\"ticksSuffix\"]],[o.radialAxis,[\"range\"],[\"domain\"]],[o.font,[\"outlinecolor\"],[\"outlineColor\"]],[o.legend,[\"traceorder\"],[\"reverseOrder\"]],[o,[\"labeloffset\"],[\"labelOffset\"]],[o,[\"defaultcolorrange\"],[\"defaultColorRange\"]]].forEach(function(t,r){s.util.translator.apply(null,t.concat(e))}),e?(void 0!==o.tickLength&&(o.angularaxis.ticklen=o.tickLength,delete o.tickLength),o.tickColor&&(o.angularaxis.tickcolor=o.tickColor,delete o.tickColor)):(o.angularAxis&&void 0!==o.angularAxis.ticklen&&(o.tickLength=o.angularAxis.ticklen),o.angularAxis&&void 0!==o.angularAxis.tickcolor&&(o.tickColor=o.angularAxis.tickcolor)),o.legend&&\"boolean\"!=typeof o.legend.reverseOrder&&(o.legend.reverseOrder=\"normal\"!=o.legend.reverseOrder),o.legend&&\"boolean\"==typeof o.legend.traceorder&&(o.legend.traceorder=o.legend.traceorder?\"reversed\":\"normal\",delete o.legend.reverseOrder),o.margin&&void 0!==o.margin.t){var l=[\"t\",\"r\",\"b\",\"l\",\"pad\"],u=[\"top\",\"right\",\"bottom\",\"left\",\"pad\"],c={};n.entries(o.margin).forEach(function(t,e){c[u[l.indexOf(t.key)]]=t.value}),o.margin=c}e&&(delete o.needsEndSpacing,delete o.minorTickColor,delete o.minorTicks,delete o.angularaxis.ticksCount,delete o.angularaxis.ticksCount,delete o.angularaxis.ticksStep,delete o.angularaxis.rewriteTicks,delete o.angularaxis.nticks,delete o.radialaxis.ticksCount,delete o.radialaxis.ticksCount,delete o.radialaxis.ticksStep,delete o.radialaxis.rewriteTicks,delete o.radialaxis.nticks),r.layout=o}return r},t}},{\"../../constants/alignment\":699,\"../../lib\":725,d3:121}],834:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"./micropolar\"),s=t(\"./undo_manager\"),l=i.extendDeepAll,u=e.exports={};u.framework=function(t){function e(e,i){return i&&(h=i),n.select(n.select(h).node().parentNode).selectAll(\".svg-container>*:not(.chart-root)\").remove(),r=r?l(r,e):e,a||(a=o.Axis()),c=o.adapter.plotly().convert(r),a.config(c).render(h),t.data=r.data,t.layout=r.layout,u.fillLayout(t),r}var r,i,a,c,h,f=new s;return e.isPolar=!0,e.svg=function(){return a.svg()},e.getConfig=function(){return r},e.getLiveConfig=function(){return o.adapter.plotly().convert(a.getLiveConfig(),!0)},e.getLiveScales=function(){return{t:a.angularScale(),r:a.radialScale()}},e.setUndoPoint=function(){var t=this,e=o.util.cloneJson(r);!function(e,r){f.add({undo:function(){r&&t(r)},redo:function(){t(e)}})}(e,i),i=o.util.cloneJson(e)},e.undo=function(){f.undo()},e.redo=function(){f.redo()},e},u.fillLayout=function(t){var e=n.select(t).selectAll(\".plot-container\"),r=e.selectAll(\".svg-container\"),i=t.framework&&t.framework.svg&&t.framework.svg(),o={width:800,height:600,paper_bgcolor:a.background,_container:e,_paperdiv:r,_paper:i};t._fullLayout=l(o,t.layout)}},{\"../../components/color\":603,\"../../lib\":725,\"./micropolar\":833,\"./undo_manager\":835,d3:121}],835:[function(t,e,r){\"use strict\";e.exports=function(){function t(t,e){return t?(i=!0,t[e](),i=!1,this):this}var e,r=[],n=-1,i=!1;return{add:function(t){return i?this:(r.splice(n+1,r.length-n),r.push(t),n=r.length-1,this)},setCallback:function(t){e=t},undo:function(){var i=r[n];return i?(t(i,\"undo\"),n-=1,e&&e(i.undo),this):this},redo:function(){var i=r[n+1];return i?(t(i,\"redo\"),n+=1,e&&e(i.redo),this):this},clear:function(){r=[],n=-1},hasUndo:function(){return-1!==n},hasRedo:function(){return n<r.length-1},getCommands:function(){return r},getPreviousCommand:function(){return r[n-1]},getIndex:function(){return n}}}},{}],836:[function(t,e,r){\"use strict\";var n=t(\"../lib\"),i=t(\"./plots\");e.exports=function(t,e,r,a){function o(t,e){return n.coerce(s,l,c,t,e)}for(var s,l,u=a.type,c=a.attributes,h=a.handleDefaults,f=a.partition||\"x\",d=i.findSubplotIds(r,u),p=d.length,m=0;m<p;m++){var v=d[m];s=t[v]?t[v]:t[v]={},e[v]=l={},o(\"domain.\"+f,[m/p,(m+1)/p]),o(\"domain.\"+{x:\"y\",y:\"x\"}[f]),a.id=v,h(s,l,o,a)}}},{\"../lib\":725,\"./plots\":829}],837:[function(t,e,r){\"use strict\";var n=t(\"./ternary\"),i=t(\"../../plots/plots\");r.name=\"ternary\",r.attr=\"subplot\",r.idRoot=\"ternary\",r.idRegex=/^ternary([2-9]|[1-9][0-9]+)?$/,r.attrRegex=/^ternary([2-9]|[1-9][0-9]+)?$/,r.attributes=t(\"./layout/attributes\"),r.layoutAttributes=t(\"./layout/layout_attributes\"),r.supplyLayoutDefaults=t(\"./layout/defaults\"),r.plot=function(t){for(var e=t._fullLayout,r=t.calcdata,a=i.getSubplotIds(e,\"ternary\"),o=0;o<a.length;o++){var s=a[o],l=i.getSubplotCalcData(r,\"ternary\",s),u=e[s]._subplot;u||(u=new n({id:s,graphDiv:t,container:e._ternarylayer.node()},e),e[s]._subplot=u),u.plot(l,e,t._promises)}},r.clean=function(t,e,r,n){for(var a=i.getSubplotIds(n,\"ternary\"),o=0;o<a.length;o++){var s=a[o],l=n[s]._subplot;!e[s]&&l&&(l.plotContainer.remove(),l.clipDef.remove(),l.clipDefRelative.remove())}}},{\"../../plots/plots\":829,\"./layout/attributes\":838,\"./layout/defaults\":841,\"./layout/layout_attributes\":842,\"./ternary\":843}],838:[function(t,e,r){\"use strict\";e.exports={subplot:{valType:\"subplotid\",dflt:\"ternary\"}}},{}],839:[function(t,e,r){\"use strict\";var n=t(\"../../cartesian/layout_attributes\"),i=t(\"../../../lib/extend\").extendFlat;e.exports={title:n.title,titlefont:n.titlefont,color:n.color,tickmode:n.tickmode,nticks:i({},n.nticks,{dflt:6,min:1}),tick0:n.tick0,dtick:n.dtick,tickvals:n.tickvals,ticktext:n.ticktext,ticks:n.ticks,ticklen:n.ticklen,tickwidth:n.tickwidth,tickcolor:n.tickcolor,showticklabels:n.showticklabels,showtickprefix:n.showtickprefix,tickprefix:n.tickprefix,showticksuffix:n.showticksuffix,ticksuffix:n.ticksuffix,showexponent:n.showexponent,exponentformat:n.exponentformat,separatethousands:n.separatethousands,tickfont:n.tickfont,tickangle:n.tickangle,tickformat:n.tickformat,hoverformat:n.hoverformat,showline:i({},n.showline,{dflt:!0}),linecolor:n.linecolor,linewidth:n.linewidth,showgrid:i({},n.showgrid,{dflt:!0}),gridcolor:n.gridcolor,gridwidth:n.gridwidth,layer:n.layer,min:{valType:\"number\",dflt:0,min:0}}},{\"../../../lib/extend\":716,\"../../cartesian/layout_attributes\":777}],840:[function(t,e,r){\"use strict\";var n=t(\"tinycolor2\").mix,i=t(\"../../../lib\"),a=t(\"./axis_attributes\"),o=t(\"../../cartesian/tick_label_defaults\"),s=t(\"../../cartesian/tick_mark_defaults\"),l=t(\"../../cartesian/tick_value_defaults\");e.exports=function(t,e,r){function u(r,n){return i.coerce(t,e,a,r,n)}e.type=\"linear\";var c=u(\"color\"),h=c===t.color?c:r.font.color,f=e._name,d=f.charAt(0).toUpperCase(),p=\"Component \"+d,m=u(\"title\",p);e._hovertitle=m===p?m:d,i.coerceFont(u,\"titlefont\",{family:r.font.family,size:Math.round(1.2*r.font.size),color:h}),u(\"min\"),l(t,e,u,\"linear\"),o(t,e,u,\"linear\",{noHover:!1}),s(t,e,u,{outerTicks:!0}),u(\"showticklabels\")&&(i.coerceFont(u,\"tickfont\",{family:r.font.family,size:r.font.size,color:h}),u(\"tickangle\"),u(\"tickformat\")),u(\"hoverformat\"),u(\"showline\")&&(u(\"linecolor\",c),u(\"linewidth\")),u(\"showgrid\")&&(u(\"gridcolor\",n(c,r.bgColor,60).toRgbString()),u(\"gridwidth\")),u(\"layer\")}},{\"../../../lib\":725,\"../../cartesian/tick_label_defaults\":784,\"../../cartesian/tick_mark_defaults\":785,\"../../cartesian/tick_value_defaults\":786,\"./axis_attributes\":839,tinycolor2:533}],841:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=r(\"bgcolor\"),o=r(\"sum\");n.bgColor=i.combine(a,n.paper_bgcolor);for(var u,c,h,f=0;f<l.length;f++)u=l[f],c=t[u]||{},h=e[u]={_name:u,type:\"linear\"},s(c,h,n);var d=e.aaxis,p=e.baxis,m=e.caxis;d.min+p.min+m.min>=o&&(d.min=0,p.min=0,m.min=0,t.aaxis&&delete t.aaxis.min,t.baxis&&delete t.baxis.min,t.caxis&&delete t.caxis.min)}var i=t(\"../../../components/color\"),a=t(\"../../subplot_defaults\"),o=t(\"./layout_attributes\"),s=t(\"./axis_defaults\"),l=[\"aaxis\",\"baxis\",\"caxis\"];e.exports=function(t,e,r){a(t,e,r,{type:\"ternary\",attributes:o,handleDefaults:n,font:e.font,paper_bgcolor:e.paper_bgcolor})}},{\"../../../components/color\":603,\"../../subplot_defaults\":836,\"./axis_defaults\":840,\"./layout_attributes\":842}],842:[function(t,e,r){\"use strict\";var n=t(\"../../../components/color/attributes\"),i=t(\"./axis_attributes\");e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},bgcolor:{valType:\"color\",dflt:n.background},sum:{valType:\"number\",dflt:1,min:0},aaxis:i,baxis:i,caxis:i}},{\"../../../components/color/attributes\":602,\"./axis_attributes\":839}],843:[function(t,e,r){\"use strict\";function n(t,e){this.id=t.id,this.graphDiv=t.graphDiv,this.init(e),this.makeFramework(e)}function i(t){a.select(t).selectAll(\".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners\").remove()}var a=t(\"d3\"),o=t(\"tinycolor2\"),s=t(\"../../plotly\"),l=t(\"../../lib\"),u=t(\"../../components/color\"),c=t(\"../../components/drawing\"),h=t(\"../cartesian/set_convert\"),f=t(\"../../lib/extend\").extendFlat,d=t(\"../plots\"),p=t(\"../cartesian/axes\"),m=t(\"../../components/dragelement\"),v=t(\"../../components/fx\"),g=t(\"../../components/titles\"),y=t(\"../cartesian/select\"),b=t(\"../cartesian/constants\");e.exports=n;var x=n.prototype;x.init=function(t){this.container=t._ternarylayer,this.defs=t._defs,this.layoutId=t._uid,this.traceHash={},this.layers={}},x.plot=function(t,e){var r=this,n=e[r.id],i=e._size;r._hasClipOnAxisFalse=!1;for(var a=0;a<t.length;a++){if(!1===t[a][0].trace.cliponaxis){r._hasClipOnAxisFalse=!0;break}}r.updateLayers(n),r.adjustLayout(n,i),d.generalUpdatePerTraceModule(r,t,n),r.layers.plotbg.select(\"path\").call(u.fill,n.bgcolor)},x.makeFramework=function(t){var e=this,r=t[e.id],n=e.defs.selectAll(\"g.clips\").data([0]);n.enter().append(\"g\").classed(\"clips\",!0);var i=e.clipId=\"clip\"+e.layoutId+e.id;e.clipDef=n.selectAll(\"#\"+i).data([0]),e.clipDef.enter().append(\"clipPath\").attr(\"id\",i).append(\"path\").attr(\"d\",\"M0,0Z\");var a=e.clipIdRelative=\"clip-relative\"+e.layoutId+e.id;e.clipDefRelative=n.selectAll(\"#\"+a).data([0]),e.clipDefRelative.enter().append(\"clipPath\").attr(\"id\",a).append(\"path\").attr(\"d\",\"M0,0Z\"),e.plotContainer=e.container.selectAll(\"g.\"+e.id).data([0]),e.plotContainer.enter().append(\"g\").classed(e.id,!0),e.updateLayers(r),c.setClipUrl(e.layers.backplot,i),c.setClipUrl(e.layers.grids,i)},x.updateLayers=function(t){var e=this,r=e.layers,n=[\"draglayer\",\"plotbg\",\"backplot\",\"grids\"];\"below traces\"===t.aaxis.layer&&n.push(\"aaxis\",\"aline\"),\"below traces\"===t.baxis.layer&&n.push(\"baxis\",\"bline\"),\"below traces\"===t.caxis.layer&&n.push(\"caxis\",\"cline\"),n.push(\"frontplot\"),\"above traces\"===t.aaxis.layer&&n.push(\"aaxis\",\"aline\"),\"above traces\"===t.baxis.layer&&n.push(\"baxis\",\"bline\"),\"above traces\"===t.caxis.layer&&n.push(\"caxis\",\"cline\");var i=e.plotContainer.selectAll(\"g.toplevel\").data(n,String),o=[\"agrid\",\"bgrid\",\"cgrid\"];i.enter().append(\"g\").attr(\"class\",function(t){return\"toplevel \"+t}).each(function(t){var e=a.select(this);r[t]=e,\"frontplot\"===t?e.append(\"g\").classed(\"scatterlayer\",!0):\"backplot\"===t?e.append(\"g\").classed(\"maplayer\",!0):\"plotbg\"===t?e.append(\"path\").attr(\"d\",\"M0,0Z\"):\"aline\"===t||\"bline\"===t||\"cline\"===t?e.append(\"path\"):\"grids\"===t&&o.forEach(function(t){r[t]=e.append(\"g\").classed(\"grid \"+t,!0)})}),i.order()};var _=Math.sqrt(4/3);x.adjustLayout=function(t,e){var r,n,i,a,o,s,l=this,d=t.domain,p=(d.x[0]+d.x[1])/2,m=(d.y[0]+d.y[1])/2,v=d.x[1]-d.x[0],g=d.y[1]-d.y[0],y=v*e.w,b=g*e.h,x=t.sum,w=t.aaxis.min,M=t.baxis.min,k=t.caxis.min;y>_*b?(a=b,i=a*_):(i=y,a=i/_),o=v*i/y,s=g*a/b,r=e.l+e.w*p-i/2,n=e.t+e.h*(1-m)-a/2,l.x0=r,l.y0=n,l.w=i,l.h=a,l.sum=x,l.xaxis={type:\"linear\",range:[w+2*k-x,x-w-2*M],domain:[p-o/2,p+o/2],_id:\"x\"},h(l.xaxis,l.graphDiv._fullLayout),l.xaxis.setScale(),l.xaxis.isPtWithinRange=function(t){return t.a>=l.aaxis.range[0]&&t.a<=l.aaxis.range[1]&&t.b>=l.baxis.range[1]&&t.b<=l.baxis.range[0]&&t.c>=l.caxis.range[1]&&t.c<=l.caxis.range[0]},l.yaxis={type:\"linear\",range:[w,x-M-k],domain:[m-s/2,m+s/2],_id:\"y\"},h(l.yaxis,l.graphDiv._fullLayout),l.yaxis.setScale(),l.yaxis.isPtWithinRange=function(){return!0};var A=l.yaxis.domain[0],T=l.aaxis=f({},t.aaxis,{visible:!0,range:[w,x-M-k],side:\"left\",_counterangle:30,tickangle:(+t.aaxis.tickangle||0)-30,domain:[A,A+s*_],_axislayer:l.layers.aaxis,_gridlayer:l.layers.agrid,_pos:0,_id:\"y\",_length:i,_gridpath:\"M0,0l\"+a+\",-\"+i/2});h(T,l.graphDiv._fullLayout),T.setScale();var S=l.baxis=f({},t.baxis,{visible:!0,range:[x-w-k,M],side:\"bottom\",_counterangle:30,domain:l.xaxis.domain,_axislayer:l.layers.baxis,_gridlayer:l.layers.bgrid,_counteraxis:l.aaxis,_pos:0,_id:\"x\",_length:i,_gridpath:\"M0,0l-\"+i/2+\",-\"+a});h(S,l.graphDiv._fullLayout),S.setScale(),T._counteraxis=S;var E=l.caxis=f({},t.caxis,{visible:!0,range:[x-w-M,k],side:\"right\",_counterangle:30,tickangle:(+t.caxis.tickangle||0)+30,domain:[A,A+s*_],_axislayer:l.layers.caxis,_gridlayer:l.layers.cgrid,_counteraxis:l.baxis,_pos:0,_id:\"y\",_length:i,_gridpath:\"M0,0l-\"+a+\",\"+i/2});h(E,l.graphDiv._fullLayout),E.setScale();var L=\"M\"+r+\",\"+(n+a)+\"h\"+i+\"l-\"+i/2+\",-\"+a+\"Z\";l.clipDef.select(\"path\").attr(\"d\",L),l.layers.plotbg.select(\"path\").attr(\"d\",L);var C=\"M0,\"+a+\"h\"+i+\"l-\"+i/2+\",-\"+a+\"Z\";l.clipDefRelative.select(\"path\").attr(\"d\",C);var z=\"translate(\"+r+\",\"+n+\")\";l.plotContainer.selectAll(\".scatterlayer,.maplayer\").attr(\"transform\",z),l.clipDefRelative.select(\"path\").attr(\"transform\",null);var I=\"translate(\"+r+\",\"+(n+a)+\")\";l.layers.baxis.attr(\"transform\",I),l.layers.bgrid.attr(\"transform\",I);var D=\"translate(\"+(r+i/2)+\",\"+n+\")rotate(30)\";l.layers.aaxis.attr(\"transform\",D),l.layers.agrid.attr(\"transform\",D);var P=\"translate(\"+(r+i/2)+\",\"+n+\")rotate(-30)\";l.layers.caxis.attr(\"transform\",P),l.layers.cgrid.attr(\"transform\",P),l.drawAxes(!0),l.plotContainer.selectAll(\".crisp\").classed(\"crisp\",!1),l.layers.aline.select(\"path\").attr(\"d\",T.showline?\"M\"+r+\",\"+(n+a)+\"l\"+i/2+\",-\"+a:\"M0,0\").call(u.stroke,T.linecolor||\"#000\").style(\"stroke-width\",(T.linewidth||0)+\"px\"),l.layers.bline.select(\"path\").attr(\"d\",S.showline?\"M\"+r+\",\"+(n+a)+\"h\"+i:\"M0,0\").call(u.stroke,S.linecolor||\"#000\").style(\"stroke-width\",(S.linewidth||0)+\"px\"),l.layers.cline.select(\"path\").attr(\"d\",E.showline?\"M\"+(r+i/2)+\",\"+n+\"l\"+i/2+\",\"+a:\"M0,0\").call(u.stroke,E.linecolor||\"#000\").style(\"stroke-width\",(E.linewidth||0)+\"px\"),l.graphDiv._context.staticPlot||l.initInteractions(),c.setClipUrl(l.layers.frontplot,l._hasClipOnAxisFalse?null:l.clipId)},x.drawAxes=function(t){var e=this,r=e.graphDiv,n=e.id.substr(7)+\"title\",i=e.aaxis,a=e.baxis,o=e.caxis;if(p.doTicks(r,i,!0),p.doTicks(r,a,!0),p.doTicks(r,o,!0),t){var s=Math.max(i.showticklabels?i.tickfont.size/2:0,(o.showticklabels?.75*o.tickfont.size:0)+(\"outside\"===o.ticks?.87*o.ticklen:0));g.draw(r,\"a\"+n,{propContainer:i,propName:e.id+\".aaxis.title\",dfltName:\"Component A\",attributes:{x:e.x0+e.w/2,y:e.y0-i.titlefont.size/3-s,\"text-anchor\":\"middle\"}});var l=(a.showticklabels?a.tickfont.size:0)+(\"outside\"===a.ticks?a.ticklen:0)+3;g.draw(r,\"b\"+n,{propContainer:a,propName:e.id+\".baxis.title\",dfltName:\"Component B\",attributes:{x:e.x0-l,y:e.y0+e.h+.83*a.titlefont.size+l,\"text-anchor\":\"middle\"}}),g.draw(r,\"c\"+n,{propContainer:o,propName:e.id+\".caxis.title\",dfltName:\"Component C\",attributes:{x:e.x0+e.w+l,y:e.y0+e.h+.83*o.titlefont.size+l,\"text-anchor\":\"middle\"}})}};var w=b.MINZOOM/2+.87,M=\"m-0.87,.5h\"+w+\"v3h-\"+(w+5.2)+\"l\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l2.6,1.5l-\"+w/2+\",\"+.87*w+\"Z\",k=\"m0.87,.5h-\"+w+\"v3h\"+(w+5.2)+\"l-\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l-2.6,1.5l\"+w/2+\",\"+.87*w+\"Z\",A=\"m0,1l\"+w/2+\",\"+.87*w+\"l2.6,-1.5l-\"+(w/2+2.6)+\",-\"+(.87*w+4.5)+\"l-\"+(w/2+2.6)+\",\"+(.87*w+4.5)+\"l2.6,1.5l\"+w/2+\",-\"+.87*w+\"Z\",T=!0;x.initInteractions=function(){function t(t,e,r){var n=F.getBoundingClientRect();w=e-n.left,S=r-n.top,E={a:R.aaxis.range[0],b:R.baxis.range[1],c:R.caxis.range[1]},C=E,L=R.aaxis.range[1]-E.a,z=o(R.graphDiv._fullLayout[R.id].bgcolor).getLuminance(),I=\"M0,\"+R.h+\"L\"+R.w/2+\", 0L\"+R.w+\",\"+R.h+\"Z\",D=!1,P=N.append(\"path\").attr(\"class\",\"zoombox\").attr(\"transform\",\"translate(\"+R.x0+\", \"+R.y0+\")\").style({fill:z>.2?\"rgba(0,0,0,0)\":\"rgba(255,255,255,0)\",\"stroke-width\":0}).attr(\"d\",I),O=N.append(\"path\").attr(\"class\",\"zoombox-corners\").attr(\"transform\",\"translate(\"+R.x0+\", \"+R.y0+\")\").style({fill:u.background,stroke:u.defaultLine,\"stroke-width\":1,opacity:0}).attr(\"d\",\"M0,0Z\"),g()}function e(t,e){return 1-e/R.h}function r(t,e){return 1-(t+(R.h-e)/Math.sqrt(3))/R.w}function n(t,e){return(t-(R.h-e)/Math.sqrt(3))/R.w}function a(t,i){var a=w+t,o=S+i,s=Math.max(0,Math.min(1,e(w,S),e(a,o))),l=Math.max(0,Math.min(1,r(w,S),r(a,o))),u=Math.max(0,Math.min(1,n(w,S),n(a,o))),c=(s/2+u)*R.w,h=(1-s/2-l)*R.w,f=(c+h)/2,d=h-c,p=(1-s)*R.h,m=p-d/_;d<b.MINZOOM?(C=E,P.attr(\"d\",I),O.attr(\"d\",\"M0,0Z\")):(C={a:E.a+s*L,b:E.b+l*L,c:E.c+u*L},P.attr(\"d\",I+\"M\"+c+\",\"+p+\"H\"+h+\"L\"+f+\",\"+m+\"L\"+c+\",\"+p+\"Z\"),O.attr(\"d\",\"M\"+w+\",\"+S+\"m0.5,0.5h5v-2h-5v-5h-2v5h-5v2h5v5h2ZM\"+c+\",\"+p+M+\"M\"+h+\",\"+p+k+\"M\"+f+\",\"+m+A)),D||(P.transition().style(\"fill\",z>.2?\"rgba(0,0,0,0.4)\":\"rgba(255,255,255,0.3)\").duration(200),O.transition().style(\"opacity\",1).duration(200),D=!0)}function h(t,e){if(C===E)return 2===e&&x(),i(j);i(j);var r={};r[R.id+\".aaxis.min\"]=C.a,r[R.id+\".baxis.min\"]=C.b,r[R.id+\".caxis.min\"]=C.c,s.relayout(j,r),T&&j.data&&j._context.showTips&&(l.notifier(\"Double-click to<br>zoom back out\",\"long\"),T=!1)}function f(){E={a:R.aaxis.range[0],b:R.baxis.range[1],c:R.caxis.range[1]},C=E}function d(t,e){var r=t/R.xaxis._m,n=e/R.yaxis._m;C={a:E.a-n,b:E.b+(r+n)/2,c:E.c-(r-n)/2};var i=[C.a,C.b,C.c].sort(),a={a:i.indexOf(C.a),b:i.indexOf(C.b),c:i.indexOf(C.c)};i[0]<0&&(i[1]+i[0]/2<0?(i[2]+=i[0]+i[1],i[0]=i[1]=0):(i[2]+=i[0]/2,i[1]+=i[0]/2,i[0]=0),C={a:i[a.a],b:i[a.b],c:i[a.c]},e=(E.a-C.a)*R.yaxis._m,t=(E.c-C.c-E.b+C.b)*R.xaxis._m);var o=\"translate(\"+(R.x0+t)+\",\"+(R.y0+e)+\")\";R.plotContainer.selectAll(\".scatterlayer,.maplayer\").attr(\"transform\",o);var s=\"translate(\"+-t+\",\"+-e+\")\";if(R.clipDefRelative.select(\"path\").attr(\"transform\",s),R.aaxis.range=[C.a,R.sum-C.b-C.c],R.baxis.range=[R.sum-C.a-C.c,C.b],R.caxis.range=[R.sum-C.a-C.b,C.c],R.drawAxes(!1),R.plotContainer.selectAll(\".crisp\").classed(\"crisp\",!1),R._hasClipOnAxisFalse){var l=R.plotContainer.select(\".scatterlayer\").selectAll(\".points\");l.selectAll(\".point\").call(c.hideOutsideRangePoints,R),l.selectAll(\".textpoint\").call(c.hideOutsideRangePoints,R)}}function p(t,e){if(t){var r={};r[R.id+\".aaxis.min\"]=C.a,r[R.id+\".baxis.min\"]=C.b,r[R.id+\".caxis.min\"]=C.c,s.relayout(j,r)}else 2===e&&x()}function g(){N.selectAll(\".select-outline\").remove()}function x(){var t={};t[R.id+\".aaxis.min\"]=0,t[R.id+\".baxis.min\"]=0,t[R.id+\".caxis.min\"]=0,j.emit(\"plotly_doubleclick\",null),s.relayout(j,t)}var w,S,E,L,C,z,I,D,P,O,R=this,F=R.layers.plotbg.select(\"path\").node(),j=R.graphDiv,N=j._fullLayout._zoomlayer,B={element:F,gd:j,plotinfo:{xaxis:R.xaxis,yaxis:R.yaxis},doubleclick:x,subplot:R.id,prepFn:function(e,r,n){B.xaxes=[R.xaxis],B.yaxes=[R.yaxis];var i=j._fullLayout.dragmode;e.shiftKey&&(i=\"pan\"===i?\"zoom\":\"pan\"),B.minDrag=\"lasso\"===i?1:void 0,\"zoom\"===i?(B.moveFn=a,B.doneFn=h,t(e,r,n)):\"pan\"===i?(B.moveFn=d,B.doneFn=p,f(),g()):\"select\"!==i&&\"lasso\"!==i||y(e,r,n,B,i)}};F.onmousemove=function(t){v.hover(j,t,R.id),j._fullLayout._lasthover=F,j._fullLayout._hoversubplot=R.id},F.onmouseout=function(t){j._dragging||m.unhover(j,t)},F.onclick=function(t){v.click(j,t,R.id)},m.init(B)}},{\"../../components/color\":603,\"../../components/dragelement\":624,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../components/titles\":692,\"../../lib\":725,\"../../lib/extend\":716,\"../../plotly\":761,\"../cartesian/axes\":766,\"../cartesian/constants\":771,\"../cartesian/select\":782,\"../cartesian/set_convert\":783,\"../plots\":829,d3:121,tinycolor2:533}],844:[function(t,e,r){\"use strict\";function n(t){if(t.layoutAttributes){var e=t.layoutAttributes._arrayAttrRegexps;if(e)for(var n=0;n<e.length;n++)s(r.layoutArrayRegexes,e[n])}}function i(t){return\"object\"==typeof t&&(t=t.type),t}var a=t(\"./lib/loggers\"),o=t(\"./lib/noop\"),s=t(\"./lib/push_unique\"),l=t(\"./plots/attributes\");r.modules={},r.allCategories={},r.allTypes=[],r.subplotsRegistry={},r.transformsRegistry={},r.componentsRegistry={},r.layoutArrayContainers=[],r.layoutArrayRegexes=[],r.register=function(t,e,n,i){if(r.modules[e])return void a.log(\"Type \"+e+\" already registered\");for(var o={},s=0;s<n.length;s++)o[n[s]]=!0,r.allCategories[n[s]]=!0;r.modules[e]={_module:t,categories:o},i&&Object.keys(i).length&&(r.modules[e].meta=i),r.allTypes.push(e)},r.registerSubplot=function(t){var e=t.name;if(r.subplotsRegistry[e])return void a.log(\"Plot type \"+e+\" already registered.\");n(t),r.subplotsRegistry[e]=t},r.registerComponent=function(t){var e=t.name;r.componentsRegistry[e]=t,t.layoutAttributes&&(t.layoutAttributes._isLinkedToArray&&s(r.layoutArrayContainers,e),n(t))},r.getModule=function(t){if(void 0!==t.r)return a.warn(\"Tried to put a polar trace on an incompatible graph of cartesian data. Ignoring this dataset.\",t),!1;var e=r.modules[i(t)];return!!e&&e._module},r.traceIs=function(t,e){if(\"various\"===(t=i(t)))return!1;var n=r.modules[t];return n||(t&&\"area\"!==t&&a.log(\"Unrecognized trace type \"+t+\".\"),n=r.modules[l.type.dflt]),!!n.categories[e]},r.getTransformIndices=function(t,e){for(var r=[],n=t.transforms||[],i=0;i<n.length;i++)n[i].type===e&&r.push(i);return r},r.hasTransform=function(t,e){for(var r=t.transforms||[],n=0;n<r.length;n++)if(r[n].type===e)return!0;return!1},r.getComponentMethod=function(t,e){var n=r.componentsRegistry[t];return n?n[e]||o:o}},{\"./lib/loggers\":729,\"./lib/noop\":733,\"./lib/push_unique\":737,\"./plots/attributes\":764}],845:[function(t,e,r){\"use strict\";function n(t){var e;switch(t){case\"themes__thumb\":e={autosize:!0,width:150,height:150,title:\"\",showlegend:!1,margin:{l:5,r:5,t:5,b:5,pad:0},annotations:[]};break;case\"thumbnail\":e={title:\"\",hidesources:!0,showlegend:!1,borderwidth:0,bordercolor:\"\",margin:{l:1,r:1,t:1,b:1,pad:0},annotations:[]};break;default:e={}}return e}function i(t){return[\"xaxis\",\"yaxis\",\"zaxis\"].indexOf(t.slice(0,5))>-1}var a=t(\"../lib\"),o=t(\"../plots/plots\"),s=a.extendFlat,l=a.extendDeep;e.exports=function(t,e){t.framework&&t.framework.isPolar&&(t=t.framework.getConfig());var r,a=t.data,u=t.layout,c=l([],a),h=l({},u,n(e.tileClass)),f=t._context||{};if(e.width&&(h.width=e.width),e.height&&(h.height=e.height),\"thumbnail\"===e.tileClass||\"themes__thumb\"===e.tileClass){h.annotations=[];var d=Object.keys(h);for(r=0;r<d.length;r++)i(d[r])&&(h[d[r]].title=\"\");for(r=0;r<c.length;r++){var p=c[r];p.showscale=!1,p.marker&&(p.marker.showscale=!1),\"pie\"===p.type&&(p.textposition=\"none\")}}if(Array.isArray(e.annotations))for(r=0;r<e.annotations.length;r++)h.annotations.push(e.annotations[r]);var m=o.getSubplotIds(h,\"gl3d\");if(m.length){var v={};for(\"thumbnail\"===e.tileClass&&(v={title:\"\",showaxeslabels:!1,showticklabels:!1,linetickenable:!1}),r=0;r<m.length;r++){var g=h[m[r]];g.xaxis||(g.xaxis={}),g.yaxis||(g.yaxis={}),g.zaxis||(g.zaxis={}),s(g.xaxis,v),s(g.yaxis,v),s(g.zaxis,v),g._scene=null}}var y=document.createElement(\"div\");e.tileClass&&(y.className=e.tileClass);var b={gd:y,td:y,layout:h,data:c,config:{staticPlot:void 0===e.staticPlot||e.staticPlot,plotGlPixelRatio:void 0===e.plotGlPixelRatio?2:e.plotGlPixelRatio,displaylogo:e.displaylogo||!1,showLink:e.showLink||!1,showTips:e.showTips||!1,mapboxAccessToken:f.mapboxAccessToken}};return\"transparent\"!==e.setBackground&&(b.config.setBackground=e.setBackground||\"opaque\"),b.gd.defaultLayout=n(e.tileClass),b}},{\"../lib\":725,\"../plots/plots\":829}],846:[function(t,e,r){\"use strict\";function n(t,e){return e=e||{},e.format=e.format||\"png\",new Promise(function(r,n){t._snapshotInProgress&&n(new Error(\"Snapshotting already in progress.\")),a.isIE()&&\"svg\"!==e.format&&n(new Error(\"Sorry IE does not support downloading from canvas. Try {format:'svg'} instead.\")),t._snapshotInProgress=!0;var s=i(t,e),l=e.filename||t.fn||\"newplot\";l+=\".\"+e.format,s.then(function(e){return t._snapshotInProgress=!1,o(e,l)}).then(function(t){r(t)}).catch(function(e){t._snapshotInProgress=!1,n(e)})})}var i=t(\"../plot_api/to_image\"),a=t(\"../lib\"),o=t(\"./filesaver\");e.exports=n},{\"../lib\":725,\"../plot_api/to_image\":759,\"./filesaver\":847}],847:[function(t,e,r){\"use strict\";var n=function(t,e){var r=document.createElement(\"a\"),n=\"download\"in r,i=/Version\\/[\\d\\.]+.*Safari/.test(navigator.userAgent);return new Promise(function(a,o){\"undefined\"!=typeof navigator&&/MSIE [1-9]\\./.test(navigator.userAgent)&&o(new Error(\"IE < 10 unsupported\")),i&&(document.location.href=\"data:application/octet-stream\"+t.slice(t.search(/[,;]/)),a(e)),e||(e=\"download\"),n&&(r.href=t,r.download=e,document.body.appendChild(r),r.click(),document.body.removeChild(r),a(e)),\"undefined\"!=typeof navigator&&navigator.msSaveBlob&&(navigator.msSaveBlob(new Blob([t]),e),a(e)),o(new Error(\"download error\"))})};e.exports=n},{}],848:[function(t,e,r){\"use strict\";r.getDelay=function(t){return t._has&&(t._has(\"gl3d\")||t._has(\"gl2d\"))?500:0},r.getRedrawFunc=function(t){if(!(t.data&&t.data[0]&&t.data[0].r))return function(){(t.calcdata||[]).forEach(function(t){t[0]&&t[0].t&&t[0].t.cb&&t[0].t.cb()})}}},{}],849:[function(t,e,r){\"use strict\";var n=t(\"./helpers\"),i={getDelay:n.getDelay,getRedrawFunc:n.getRedrawFunc,clone:t(\"./cloneplot\"),toSVG:t(\"./tosvg\"),svgToImg:t(\"./svgtoimg\"),toImage:t(\"./toimage\"),downloadImage:t(\"./download\")};e.exports=i},{\"./cloneplot\":845,\"./download\":846,\"./helpers\":848,\"./svgtoimg\":850,\"./toimage\":851,\"./tosvg\":852}],850:[function(t,e,r){\"use strict\";function n(t){var e=t.emitter||new a,r=new Promise(function(n,a){var o=window.Image,s=t.svg,l=t.format||\"png\";if(i.isIE()&&\"svg\"!==l){var u=new Error(\"Sorry IE does not support downloading from canvas. Try {format:'svg'} instead.\");return a(u),t.promise?r:e.emit(\"error\",u)}var c=t.canvas,h=c.getContext(\"2d\"),f=new o,d=\"data:image/svg+xml,\"+encodeURIComponent(s);c.height=t.height||150,c.width=t.width||300,f.onload=function(){var r;switch(\"svg\"!==l&&h.drawImage(f,0,0),l){case\"jpeg\":r=c.toDataURL(\"image/jpeg\");break;case\"png\":r=c.toDataURL(\"image/png\");break;case\"webp\":r=c.toDataURL(\"image/webp\");break;case\"svg\":r=d;break;default:var i=\"Image format is not jpeg, png, svg or webp.\";if(a(new Error(i)),!t.promise)return e.emit(\"error\",i)}n(r),t.promise||e.emit(\"success\",r)},f.onerror=function(r){if(a(r),!t.promise)return e.emit(\"error\",r)},f.src=d});return t.promise?r:e}var i=t(\"../lib\"),a=t(\"events\").EventEmitter;e.exports=n},{\"../lib\":725,events:128}],851:[function(t,e,r){\"use strict\";function n(t,e){function r(){var t=s.getDelay(f._fullLayout);setTimeout(function(){var t=u(f),r=document.createElement(\"canvas\");r.id=o.randstr(),n=c({format:e.format,width:f._fullLayout.width,height:f._fullLayout.height,canvas:r,emitter:n,svg:t}),n.clean=function(){f&&document.body.removeChild(f)}},t)}var n=new i,h=l(t,{format:\"png\"}),f=h.gd;f.style.position=\"absolute\",f.style.left=\"-5000px\",document.body.appendChild(f);var d=s.getRedrawFunc(f);return a.plot(f,h.data,h.layout,h.config).then(d).then(r).catch(function(t){n.emit(\"error\",t)}),n}var i=t(\"events\").EventEmitter,a=t(\"../plotly\"),o=t(\"../lib\"),s=t(\"./helpers\"),l=t(\"./cloneplot\"),u=t(\"./tosvg\"),c=t(\"./svgtoimg\");e.exports=n},{\"../lib\":725,\"../plotly\":761,\"./cloneplot\":845,\"./helpers\":848,\"./svgtoimg\":850,\"./tosvg\":852,events:128}],852:[function(t,e,r){\"use strict\";function n(t){var e=a.select(\"body\").append(\"div\").style({display:\"none\"}).html(\"\"),r=t.replace(/(&[^;]*;)/gi,function(t){return\"&lt;\"===t?\"&#60;\":\"&rt;\"===t?\"&#62;\":-1!==t.indexOf(\"<\")||-1!==t.indexOf(\">\")?\"\":e.html(t).text()});return e.remove(),r}function i(t){return t.replace(/&(?!\\w+;|\\#[0-9]+;| \\#x[0-9A-F]+;)/g,\"&amp;\")}var a=t(\"d3\"),o=t(\"../lib\"),s=t(\"../components/drawing\"),l=t(\"../components/color\"),u=t(\"../constants/xmlns_namespaces\"),c=/\"/g,h=new RegExp('(\"TOBESTRIPPED)|(TOBESTRIPPED\")',\"g\");e.exports=function(t,e){var r,f=t._fullLayout,d=f._paper,p=f._toppaper;d.insert(\"rect\",\":first-child\").call(s.setRect,0,0,f.width,f.height).call(l.fill,f.paper_bgcolor);var m=f._basePlotModules||[];for(r=0;r<m.length;r++){var v=m[r];v.toSVG&&v.toSVG(t)}if(p){var g=p.node().childNodes,y=Array.prototype.slice.call(g);for(r=0;r<y.length;r++){var b=y[r];b.childNodes.length&&d.node().appendChild(b)}}f._draggers&&f._draggers.remove(),d.node().style.background=\"\",d.selectAll(\"text\").attr({\"data-unformatted\":null,\"data-math\":null}).each(function(){var t=a.select(this);if(\"hidden\"===t.style(\"visibility\")||\"none\"===t.style(\"display\"))return void t.remove();t.style({visibility:null,display:null});var e=t.style(\"font-family\");e&&-1!==e.indexOf('\"')&&t.style(\"font-family\",e.replace(c,\"TOBESTRIPPED\"))}),d.selectAll(\".point,.scatterpts\").each(function(){var t=a.select(this),e=t.style(\"fill\");e&&-1!==e.indexOf(\"url(\")&&t.style(\"fill\",e.replace(c,\"TOBESTRIPPED\"))}),\"pdf\"!==e&&\"eps\"!==e||d.selectAll(\"#MathJax_SVG_glyphs path\").attr(\"stroke-width\",0),d.node().setAttributeNS(u.xmlns,\"xmlns\",u.svg),d.node().setAttributeNS(u.xmlns,\"xmlns:xlink\",u.xlink);var x=(new window.XMLSerializer).serializeToString(d.node());return x=n(x),x=i(x),x=x.replace(h,\"'\"),o.isIE()&&(x=x.replace(/\"/gi,\"'\"),x=x.replace(/(\\('#)([^']*)('\\))/gi,'(\"$2\")'),x=x.replace(/(\\\\')/gi,'\"')),x}},{\"../components/color\":603,\"../components/drawing\":627,\"../constants/xmlns_namespaces\":707,\"../lib\":725,d3:121}],853:[function(t,e,r){\"use strict\";var n=t(\"../../lib\").mergeArray;e.exports=function(t,e){n(e.text,t,\"tx\"),n(e.hovertext,t,\"htx\");var r=e.marker;if(r){n(r.opacity,t,\"mo\"),n(r.color,t,\"mc\");var i=r.line;i&&(n(i.color,t,\"mlc\"),n(i.width,t,\"mlw\"))}}},{\"../../lib\":725}],854:[function(t,e,r){\"use strict\"\n",
       ";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/color_attributes\"),a=t(\"../../components/errorbars/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../plots/font_attributes\"),l=t(\"../../lib/extend\").extendFlat,u=t(\"../../lib/extend\").extendDeep,c=u({},s);c.family.arrayOk=!0,c.size.arrayOk=!0,c.color.arrayOk=!0;var h=n.marker,f=h.line,d=l({},f.width,{dflt:0}),p=l({},{width:d},i(\"marker.line\")),m=l({},{line:p},i(\"marker\"),{showscale:h.showscale,colorbar:o});e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:n.text,hovertext:n.hovertext,textposition:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"auto\",\"none\"],dflt:\"none\",arrayOk:!0},textfont:l({},c,{}),insidetextfont:l({},c,{}),outsidetextfont:l({},c,{}),constraintext:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"both\",\"none\"],dflt:\"both\"},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"]},base:{valType:\"any\",dflt:null,arrayOk:!0},offset:{valType:\"number\",dflt:null,arrayOk:!0},width:{valType:\"number\",dflt:null,min:0,arrayOk:!0},marker:m,r:n.r,t:n.t,error_y:a,error_x:a,_deprecated:{bardir:{valType:\"enumerated\",values:[\"v\",\"h\"]}}}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/errorbars/attributes\":629,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../scatter/attributes\":1027}],855:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../components/colorscale/has_colorscale\"),o=t(\"../../components/colorscale/calc\"),s=t(\"./arrays_to_calcdata\");e.exports=function(t,e){var r,l,u,c,h,f=i.getFromId(t,e.xaxis||\"x\"),d=i.getFromId(t,e.yaxis||\"y\"),p=e.orientation||(e.x&&!e.y?\"h\":\"v\");\"h\"===p?(r=f,u=f.makeCalcdata(e,\"x\"),l=d.makeCalcdata(e,\"y\"),h=e.xcalendar):(r=d,u=d.makeCalcdata(e,\"y\"),l=f.makeCalcdata(e,\"x\"),h=e.ycalendar);var m=Math.min(l.length,u.length),v=new Array(m);for(c=0;c<m;c++)v[c]={p:l[c],s:u[c]};var g,y=e.base;if(Array.isArray(y)){for(c=0;c<Math.min(y.length,v.length);c++)g=r.d2c(y[c],0,h),v[c].b=n(g)?g:0;for(;c<v.length;c++)v[c].b=0}else for(g=r.d2c(y,0,h),g=n(g)?g:0,c=0;c<v.length;c++)v[c].b=g;return a(e,\"marker\")&&o(e,e.marker.color,\"marker\",\"c\"),a(e,\"marker.line\")&&o(e,e.marker.line.color,\"marker.line\",\"c\"),s(v,e),v}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"../../plots/cartesian/axes\":766,\"./arrays_to_calcdata\":853,\"fast-isnumeric\":130}],856:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/color\"),a=t(\"../scatter/xy_defaults\"),o=t(\"../bar/style_defaults\"),s=t(\"../../components/errorbars/defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,l,r,i)}var h=n.coerceFont;if(!a(t,e,u,c))return void(e.visible=!1);c(\"orientation\",e.x&&!e.y?\"h\":\"v\"),c(\"base\"),c(\"offset\"),c(\"width\"),c(\"text\"),c(\"hovertext\");var f=c(\"textposition\"),d=Array.isArray(f)||\"auto\"===f,p=d||\"inside\"===f,m=d||\"outside\"===f;if(p||m){var v=h(c,\"textfont\",u.font);p&&h(c,\"insidetextfont\",v),m&&h(c,\"outsidetextfont\",v),c(\"constraintext\")}o(t,e,c,r,u),s(t,e,i.defaultLine,{axis:\"y\"}),s(t,e,i.defaultLine,{axis:\"x\",inherit:\"y\"})}},{\"../../components/color\":603,\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../bar/style_defaults\":865,\"../scatter/xy_defaults\":1049,\"./attributes\":854}],857:[function(t,e,r){\"use strict\";var n=t(\"../../components/fx\"),i=t(\"../../components/errorbars\"),a=t(\"../../components/color\");e.exports=function(t,e,r,o){var s,l,u,c,h,f,d,p=t.cd,m=p[0].trace,v=p[0].t,g=t.xa,y=t.ya,b=function(t){return n.inbox(c(t)-s,h(t)-s)};\"h\"===m.orientation?(s=r,l=function(t){return t.y-t.w/2},u=function(t){return t.y+t.w/2},f=function(t){return n.inbox(t.b-e,t.x-e)+(t.x-e)/(t.x-t.b)},d=b):(s=e,l=function(t){return t.x-t.w/2},u=function(t){return t.x+t.w/2},d=function(t){return n.inbox(t.b-r,t.y-r)+(t.y-r)/(t.y-t.b)},f=b),c=\"closest\"===o?l:function(t){return Math.min(l(t),t.p-v.bargroupwidth/2)},h=\"closest\"===o?u:function(t){return Math.max(u(t),t.p+v.bargroupwidth/2)};var x=n.getDistanceFunction(o,f,d);if(n.getClosest(p,x,t),!1!==t.index){var _=t.index,w=p[_],M=w.mcc||m.marker.color,k=w.mlcc||m.marker.line.color,A=w.mlw||m.marker.line.width;a.opacity(M)?t.color=M:a.opacity(k)&&A&&(t.color=k);var T=m.base?w.b+w.s:w.s;return\"h\"===m.orientation?(t.x0=t.x1=g.c2p(w.x,!0),t.xLabelVal=T,t.y0=y.c2p(c(w),!0),t.y1=y.c2p(h(w),!0),t.yLabelVal=w.p):(t.y0=t.y1=y.c2p(w.y,!0),t.yLabelVal=T,t.x0=g.c2p(c(w),!0),t.x1=g.c2p(h(w),!0),t.xLabelVal=w.p),w.htx?t.text=w.htx:m.hovertext?t.text=m.hovertext:w.tx?t.text=w.tx:m.text&&(t.text=m.text),i.hoverInfo(w,m,t),[t]}}},{\"../../components/color\":603,\"../../components/errorbars\":633,\"../../components/fx\":644}],858:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"./layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"./set_positions\"),n.colorbar=t(\"../scatter/colorbar\"),n.arraysToCalcdata=t(\"./arrays_to_calcdata\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"bar\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"bar\",\"oriented\",\"markerColorscale\",\"errorBarsOK\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../scatter/colorbar\":1030,\"./arrays_to_calcdata\":853,\"./attributes\":854,\"./calc\":855,\"./defaults\":856,\"./hover\":857,\"./layout_attributes\":859,\"./layout_defaults\":860,\"./plot\":861,\"./set_positions\":862,\"./style\":864}],859:[function(t,e,r){\"use strict\";e.exports={barmode:{valType:\"enumerated\",values:[\"stack\",\"group\",\"overlay\",\"relative\"],dflt:\"group\"},barnorm:{valType:\"enumerated\",values:[\"\",\"fraction\",\"percent\"],dflt:\"\"},bargap:{valType:\"number\",min:0,max:1},bargroupgap:{valType:\"number\",min:0,max:1,dflt:0}}},{}],860:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\"),o=t(\"./layout_attributes\");e.exports=function(t,e,r){function s(r,n){return a.coerce(t,e,o,r,n)}for(var l=!1,u=!1,c=!1,h={},f=0;f<r.length;f++){var d=r[f];if(n.traceIs(d,\"bar\")){if(l=!0,\"overlay\"!==t.barmode&&\"stack\"!==t.barmode){var p=d.xaxis+d.yaxis;h[p]&&(c=!0),h[p]=!0}if(d.visible&&\"histogram\"===d.type){\"category\"!==i.getFromId({_fullLayout:e},d[\"v\"===d.orientation?\"xaxis\":\"yaxis\"]).type&&(u=!0)}}}if(l){\"overlay\"!==s(\"barmode\")&&s(\"barnorm\"),s(\"bargap\",u&&!c?0:.2),s(\"bargroupgap\")}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./layout_attributes\":859}],861:[function(t,e,r){\"use strict\";function n(t,e,r,n,o,f,d,p){function m(e,r,n){return e.append(\"text\").text(r).attr({class:\"bartext\",transform:\"\",\"text-anchor\":\"middle\",\"data-notex\":1}).call(k.font,n).call(w.convertToTspans,t)}var v=r[0].trace,g=v.orientation,y=s(v,n);if(y){var b=l(v,n);if(\"none\"!==b){var x,_,M,A,T=u(v,n,t._fullLayout.font),S=c(v,n,T),E=h(v,n,T),L=t._fullLayout.barmode,C=\"stack\"===L,z=\"relative\"===L,D=C||z,P=r[n],O=!D||P._outmost,R=Math.abs(f-o)-2*I,F=Math.abs(p-d)-2*I;if(\"outside\"===b&&(O||(b=\"inside\")),\"auto\"===b)if(O){x=m(e,y,S),_=k.bBox(x.node()),M=_.width,A=_.height;var j=M>0&&A>0,N=M<=R&&A<=F,B=M<=F&&A<=R,U=\"h\"===g?R>=M*(F/A):F>=A*(R/M);j&&(N||B||U)?b=\"inside\":(b=\"outside\",x.remove(),x=null)}else b=\"inside\";if(!x&&(x=m(e,y,\"outside\"===b?E:S),_=k.bBox(x.node()),M=_.width,A=_.height,M<=0||A<=0))return void x.remove();var V,H;\"outside\"===b?(H=\"both\"===v.constraintext||\"outside\"===v.constraintext,V=a(o,f,d,p,_,g,H)):(H=\"both\"===v.constraintext||\"inside\"===v.constraintext,V=i(o,f,d,p,_,g,H)),x.attr(\"transform\",V)}}}function i(t,e,r,n,i,a,s){var l,u,c,h,f,d=i.width,p=i.height,m=(i.left+i.right)/2,v=(i.top+i.bottom)/2,g=Math.abs(e-t),y=Math.abs(n-r);g>2*I&&y>2*I?(f=I,g-=2*f,y-=2*f):f=0;var b,x;return d<=g&&p<=y?(b=!1,x=1):d<=y&&p<=g?(b=!0,x=1):d<p==g<y?(b=!1,x=s?Math.min(g/d,y/p):1):(b=!0,x=s?Math.min(y/d,g/p):1),b&&(b=90),b?(l=x*p,u=x*d):(l=x*d,u=x*p),\"h\"===a?e<t?(c=e+f+l/2,h=(r+n)/2):(c=e-f-l/2,h=(r+n)/2):n>r?(c=(t+e)/2,h=n-f-u/2):(c=(t+e)/2,h=n+f+u/2),o(m,v,c,h,x,b)}function a(t,e,r,n,i,a,s){var l,u=\"h\"===a?Math.abs(n-r):Math.abs(e-t);u>2*I&&(l=I);var c=1;s&&(c=\"h\"===a?Math.min(1,u/i.height):Math.min(1,u/i.width));var h,f,d,p,m=(i.left+i.right)/2,v=(i.top+i.bottom)/2;return h=c*i.width,f=c*i.height,\"h\"===a?e<t?(d=e-l-h/2,p=(r+n)/2):(d=e+l+h/2,p=(r+n)/2):n>r?(d=(t+e)/2,p=n+l+f/2):(d=(t+e)/2,p=n-l-f/2),o(m,v,d,p,c,!1)}function o(t,e,r,n,i,a){var o,s;return i<1?o=\"scale(\"+i+\") \":(i=1,o=\"\"),s=a?\"rotate(\"+a+\" \"+t+\" \"+e+\") \":\"\",\"translate(\"+(r-i*t)+\" \"+(n-i*e)+\")\"+o+s}function s(t,e){var r=d(t.text,e);return p(S,r)}function l(t,e){var r=d(t.textposition,e);return m(E,r)}function u(t,e,r){return f(L,t.textfont,e,r)}function c(t,e,r){return f(C,t.insidetextfont,e,r)}function h(t,e,r){return f(z,t.outsidetextfont,e,r)}function f(t,e,r,n){e=e||{};var i=d(e.family,r),a=d(e.size,r),o=d(e.color,r);return{family:p(t.family,i,n.family),size:v(t.size,a,n.size),color:g(t.color,o,n.color)}}function d(t,e){var r;return Array.isArray(t)?e<t.length&&(r=t[e]):r=t,r}function p(t,e,r){if(\"string\"==typeof e){if(e||!t.noBlank)return e}else if(\"number\"==typeof e&&!t.strict)return String(e);return void 0!==r?r:t.dflt}function m(t,e,r){return t.coerceNumber&&(e=+e),-1!==t.values.indexOf(e)?e:void 0!==r?r:t.dflt}function v(t,e,r){if(b(e)){e=+e;var n=t.min,i=t.max;if(!(void 0!==n&&e<n||void 0!==i&&e>i))return e}return void 0!==r?r:t.dflt}function g(t,e,r){return x(e).isValid()?e:void 0!==r?r:t.dflt}var y=t(\"d3\"),b=t(\"fast-isnumeric\"),x=t(\"tinycolor2\"),_=t(\"../../lib\"),w=t(\"../../lib/svg_text_utils\"),M=t(\"../../components/color\"),k=t(\"../../components/drawing\"),A=t(\"../../components/errorbars\"),T=t(\"./attributes\"),S=T.text,E=T.textposition,L=T.textfont,C=T.insidetextfont,z=T.outsidetextfont,I=3;e.exports=function(t,e,r){var i=e.xaxis,a=e.yaxis,o=t._fullLayout,s=e.plot.select(\".barlayer\").selectAll(\"g.trace.bars\").data(r);s.enter().append(\"g\").attr(\"class\",\"trace bars\"),s.append(\"g\").attr(\"class\",\"points\").each(function(e){var r=e[0].t,s=e[0].trace,l=r.poffset,u=Array.isArray(l);y.select(this).selectAll(\"g.point\").data(_.identity).enter().append(\"g\").classed(\"point\",!0).each(function(r,c){function h(t){return 0===o.bargap&&0===o.bargroupgap?y.round(Math.round(t)-A,2):t}function f(t,e){return Math.abs(t-e)>=2?h(t):t>e?Math.ceil(t):Math.floor(t)}var d,p,m,v,g=r.p+(u?l[c]:l),x=g+r.w,_=r.b,w=_+r.s;if(\"h\"===s.orientation?(m=a.c2p(g,!0),v=a.c2p(x,!0),d=i.c2p(_,!0),p=i.c2p(w,!0)):(d=i.c2p(g,!0),p=i.c2p(x,!0),m=a.c2p(_,!0),v=a.c2p(w,!0)),!(b(d)&&b(p)&&b(m)&&b(v)&&d!==p&&m!==v))return void y.select(this).remove();var k=(r.mlw+1||s.marker.line.width+1||(r.trace?r.trace.marker.line.width:0)+1)-1,A=y.round(k/2%1,2);if(!t._context.staticPlot){var T=M.opacity(r.mc||s.marker.color),S=T<1||k>.01?h:f;d=S(d,p),p=S(p,d),m=S(m,v),v=S(v,m)}var E=y.select(this);E.append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").attr(\"d\",\"M\"+d+\",\"+m+\"V\"+v+\"H\"+p+\"V\"+m+\"Z\"),n(t,E,e,c,d,p,m,v)})}),s.call(A.plot,e)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/errorbars\":633,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"./attributes\":854,d3:121,\"fast-isnumeric\":130,tinycolor2:533}],862:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(n.length){var s,l,u,c,h,f=t._fullLayout.barmode,d=\"overlay\"===f,p=\"group\"===f;if(d)i(t,e,r,n);else if(p){for(s=[],l=[],u=0;u<n.length;u++)c=n[u],h=c[0].trace,void 0===h.offset?l.push(c):s.push(c);l.length&&a(t,e,r,l),s.length&&i(t,e,r,s)}else{for(s=[],l=[],u=0;u<n.length;u++)c=n[u],h=c[0].trace,void 0===h.base?l.push(c):s.push(c);l.length&&o(t,e,r,l),s.length&&i(t,e,r,s)}}}function i(t,e,r,n){for(var i=t._fullLayout.barnorm,a=!i,o=0;o<n.length;o++){var l=n[o],u=new w([l],!1,a);s(t,e,u),i?(m(t,r,u),v(t,r,u)):d(t,r,u)}}function a(t,e,r,n){var i=t._fullLayout,a=i.barnorm,o=!a,s=new w(n,!1,o);l(t,e,s),a?(m(t,r,s),v(t,r,s)):d(t,r,s)}function o(t,e,r,n){var i=t._fullLayout,a=i.barmode,o=\"stack\"===a,l=\"relative\"===a,u=t._fullLayout.barnorm,c=l,h=!(u||o||l),f=new w(n,c,h);s(t,e,f),p(t,r,f);for(var d=0;d<n.length;d++)for(var m=n[d],g=0;g<m.length;g++){var y=m[g];if(y.s!==b){var x=y.b+y.s===f.get(y.p,y.s);x&&(y._outmost=!0)}}u&&v(t,r,f)}function s(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.bargap,f=s.bargroupgap,d=r.minDiff,p=r.traces,m=d*(1-l),v=m,g=v*(1-f),y=-g/2;for(n=0;n<p.length;n++)i=p[n],a=i[0],o=a.t,o.barwidth=g,o.poffset=y,o.bargroupwidth=m;r.binWidth=p[0][0].t.barwidth/100,u(r),c(t,e,r),h(t,e,r)}function l(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.bargap,f=s.bargroupgap,d=r.positions,p=r.distinctPositions,m=r.minDiff,v=r.traces,g=d.length!==p.length,y=v.length,b=m*(1-l),x=g?b/y:b,_=x*(1-f);for(n=0;n<y;n++){i=v[n],a=i[0];var w=g?((2*n+1-y)*x-_)/2:-_/2;o=a.t,o.barwidth=_,o.poffset=w,o.bargroupwidth=b}r.binWidth=v[0][0].t.barwidth/100,u(r),c(t,e,r),h(t,e,r,g)}function u(t){var e,r,n,i,a,o,s=t.traces;for(e=0;e<s.length;e++){r=s[e],n=r[0],i=n.trace,o=n.t;var l,u=i.offset,c=o.poffset;if(Array.isArray(u)){for(l=u.slice(0,r.length),a=0;a<l.length;a++)y(l[a])||(l[a]=c);for(a=l.length;a<r.length;a++)l.push(c);o.poffset=l}else void 0!==u&&(o.poffset=u);var h=i.width,f=o.barwidth;if(Array.isArray(h)){var d=h.slice(0,r.length);for(a=0;a<d.length;a++)y(d[a])||(d[a]=f);for(a=d.length;a<r.length;a++)d.push(f);if(o.barwidth=d,void 0===u){for(l=[],a=0;a<r.length;a++)l.push(c+(f-d[a])/2);o.poffset=l}}else void 0!==h&&(o.barwidth=h,void 0===u&&(o.poffset=c+(f-h)/2))}}function c(t,e,r){for(var n=r.traces,i=g(e),a=0;a<n.length;a++)for(var o=n[a],s=o[0].t,l=s.poffset,u=Array.isArray(l),c=s.barwidth,h=Array.isArray(c),f=0;f<o.length;f++){var d=o[f],p=d.w=h?c[f]:c;d[i]=d.p+(u?l[f]:l)+p/2}}function h(t,e,r,n){var i=r.traces,a=r.distinctPositions,o=a[0],s=r.minDiff,l=s/2;_.minDtick(e,s,o,n);for(var u=Math.min.apply(Math,a)-l,c=Math.max.apply(Math,a)+l,h=0;h<i.length;h++){var f=i[h],d=f[0],p=d.trace;if(void 0!==p.width||void 0!==p.offset)for(var m=d.t,v=m.poffset,g=m.barwidth,y=Array.isArray(v),b=Array.isArray(g),x=0;x<f.length;x++){var w=f[x],M=y?v[x]:v,k=b?g[x]:g,A=w.p,T=A+M,S=T+k;u=Math.min(u,T),c=Math.max(c,S)}}_.expand(e,[u,c],{padded:!1})}function f(t,e){y(t[0])?t[0]=Math.min(t[0],e):t[0]=e,y(t[1])?t[1]=Math.max(t[1],e):t[1]=e}function d(t,e,r){for(var n=r.traces,i=g(e),a=e.l2c(e.c2l(0)),o=[a,a],s=0;s<n.length;s++)for(var l=n[s],u=0;u<l.length;u++){var c=l[u],h=c.b,d=h+c.s;c[i]=d,y(e.c2l(d))&&f(o,d),y(e.c2l(h))&&f(o,h)}_.expand(e,o,{tozero:!0,padded:!0})}function p(t,e,r){var n,i,a,o,s=t._fullLayout,l=s.barnorm,u=g(e),c=r.traces,h=e.l2c(e.c2l(0)),d=[h,h];for(n=0;n<c.length;n++)for(i=c[n],a=0;a<i.length;a++)if(o=i[a],o.s!==b){var p=r.put(o.p,o.b+o.s),m=p+o.b+o.s;o.b=p,o[u]=m,l||(y(e.c2l(m))&&f(d,m),y(e.c2l(p))&&f(d,p))}l||_.expand(e,d,{tozero:!0,padded:!0})}function m(t,e,r){for(var n=r.traces,i=0;i<n.length;i++)for(var a=n[i],o=0;o<a.length;o++){var s=a[o];s.s!==b&&r.put(s.p,s.b+s.s)}}function v(t,e,r){function n(t){y(e.c2l(t))&&(t<l-s||t>u+s||!y(l))&&(h=!0,f(c,t))}for(var i=r.traces,a=g(e),o=\"fraction\"===t._fullLayout.barnorm?1:100,s=o/1e9,l=e.l2c(e.c2l(0)),u=\"stack\"===t._fullLayout.barmode?o:l,c=[l,u],h=!1,d=0;d<i.length;d++)for(var p=i[d],m=0;m<p.length;m++){var v=p[m];if(v.s!==b){var x=Math.abs(o/r.get(v.p,v.s));v.b*=x,v.s*=x;var w=v.b,M=w+v.s;v[a]=M,n(M),n(w)}}_.expand(e,c,{tozero:!0,padded:h})}function g(t){return t._id.charAt(0)}var y=t(\"fast-isnumeric\"),b=t(\"../../constants/numerical\").BADNUM,x=t(\"../../registry\"),_=t(\"../../plots/cartesian/axes\"),w=t(\"./sieve.js\");e.exports=function(t,e){var r,i=e.xaxis,a=e.yaxis,o=t._fullData,s=t.calcdata,l=[],u=[];for(r=0;r<o.length;r++){var c=o[r];!0===c.visible&&x.traceIs(c,\"bar\")&&c.xaxis===i._id&&c.yaxis===a._id&&(\"h\"===c.orientation?l.push(s[r]):u.push(s[r]))}n(t,i,a,u),n(t,a,i,l)}},{\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"./sieve.js\":863,\"fast-isnumeric\":130}],863:[function(t,e,r){\"use strict\";function n(t,e,r){this.traces=t,this.separateNegativeValues=e,this.dontMergeOverlappingData=r;for(var n=[],o=0;o<t.length;o++)for(var s=t[o],l=0;l<s.length;l++){var u=s[l];u.p!==a&&n.push(u.p)}this.positions=n;var c=i.distinctVals(this.positions);this.distinctPositions=c.vals,this.minDiff=c.minDiff,this.binWidth=this.minDiff,this.bins={}}e.exports=n;var i=t(\"../../lib\"),a=t(\"../../constants/numerical\").BADNUM;n.prototype.put=function(t,e){var r=this.getLabel(t,e),n=this.bins[r]||0;return this.bins[r]=n+e,n},n.prototype.get=function(t,e){var r=this.getLabel(t,e);return this.bins[r]||0},n.prototype.getLabel=function(t,e){return(e<0&&this.separateNegativeValues?\"v\":\"^\")+(this.dontMergeOverlappingData?t:Math.round(t/this.binWidth))}},{\"../../constants/numerical\":705,\"../../lib\":725}],864:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/color\"),a=t(\"../../components/drawing\"),o=t(\"../../components/errorbars\");e.exports=function(t){var e=n.select(t).selectAll(\"g.trace.bars\"),r=e.size(),s=t._fullLayout;e.style(\"opacity\",function(t){return t[0].trace.opacity}).each(function(t){(\"stack\"===s.barmode&&r>1||0===s.bargap&&0===s.bargroupgap&&!t[0].trace.marker.line.width)&&n.select(this).attr(\"shape-rendering\",\"crispEdges\")}),e.selectAll(\"g.points\").each(function(t){var e=t[0].trace,r=e.marker,o=r.line,s=a.tryColorscale(r,\"\"),l=a.tryColorscale(r,\"line\");n.select(this).selectAll(\"path\").each(function(t){var e,a,u=(t.mlw+1||o.width+1)-1,c=n.select(this);e=\"mc\"in t?t.mcc=s(t.mc):Array.isArray(r.color)?i.defaultLine:r.color,c.style(\"stroke-width\",u+\"px\").call(i.fill,e),u&&(a=\"mlc\"in t?t.mlcc=l(t.mlc):Array.isArray(o.color)?i.defaultLine:o.color,c.call(i.stroke,a))})}),e.call(o.style)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/errorbars\":633,d3:121}],865:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"../../components/colorscale/has_colorscale\"),a=t(\"../../components/colorscale/defaults\");e.exports=function(t,e,r,o,s){r(\"marker.color\",o),i(t,\"marker\")&&a(t,e,s,r,{prefix:\"marker.\",cLetter:\"c\"}),r(\"marker.line.color\",n.defaultLine),i(t,\"marker.line\")&&a(t,e,s,r,{prefix:\"marker.line.\",cLetter:\"c\"}),r(\"marker.line.width\")}},{\"../../components/color\":603,\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616}],866:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/color/attributes\"),a=t(\"../../lib/extend\").extendFlat,o=n.marker,s=o.line;e.exports={y:{valType:\"data_array\"},x:{valType:\"data_array\"},x0:{valType:\"any\"},y0:{valType:\"any\"},xcalendar:n.xcalendar,ycalendar:n.ycalendar,whiskerwidth:{valType:\"number\",min:0,max:1,dflt:.5},boxpoints:{valType:\"enumerated\",values:[\"all\",\"outliers\",\"suspectedoutliers\",!1],dflt:\"outliers\"},boxmean:{valType:\"enumerated\",values:[!0,\"sd\",!1],dflt:!1},jitter:{valType:\"number\",min:0,max:1},pointpos:{valType:\"number\",min:-2,max:2},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"]},marker:{outliercolor:{valType:\"color\",dflt:\"rgba(0, 0, 0, 0)\"},symbol:a({},o.symbol,{arrayOk:!1}),opacity:a({},o.opacity,{arrayOk:!1,dflt:1}),size:a({},o.size,{arrayOk:!1}),color:a({},o.color,{arrayOk:!1}),line:{color:a({},s.color,{arrayOk:!1,dflt:i.defaultLine}),width:a({},s.width,{arrayOk:!1,dflt:0}),outliercolor:{valType:\"color\"},outlierwidth:{valType:\"number\",min:0,dflt:1}}},line:{color:{valType:\"color\"},width:{valType:\"number\",min:0,dflt:2}},fillcolor:n.fillcolor}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],867:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\");e.exports=function(t,e){var r,o,s,l,u,c,h,f,d,p=a.getFromId(t,e.xaxis||\"x\"),m=a.getFromId(t,e.yaxis||\"y\"),v=e.orientation,g=[];\"h\"===v?(r=p,o=\"x\",u=m,c=\"y\"):(r=m,o=\"y\",u=p,c=\"x\"),s=r.makeCalcdata(e,o),a.expand(r,s,{padded:!0}),h=function(t,e,r,a,o){var s;return r in e?h=a.makeCalcdata(e,r):(s=r+\"0\"in e?e[r+\"0\"]:\"name\"in e&&(\"category\"===a.type||n(e.name)&&-1!==[\"linear\",\"log\"].indexOf(a.type)||i.isDateTime(e.name)&&\"date\"===a.type)?e.name:t.numboxes,s=a.d2c(s,0,e[r+\"calendar\"]),h=o.map(function(){return s})),h}(t,e,c,u,s);var y=i.distinctVals(h);return f=y.vals,d=y.minDiff/2,l=function(t,e,r,a,o){var s,l,u,c,h=a.length,f=e.length,d=[],p=[];for(s=0;s<h;++s)l=a[s],t[s]={pos:l},p[s]=l-o,d[s]=[];for(p.push(a[h-1]+o),s=0;s<f;++s)c=e[s],n(c)&&(u=i.findBin(r[s],p))>=0&&u<f&&d[u].push(c);return d}(g,s,h,f,d),function(t,e){var r,n,a,o;for(o=0;o<e.length;++o)r=e[o].sort(i.sorterAsc),n=r.length,a=t[o],a.val=r,a.min=r[0],a.max=r[n-1],a.mean=i.mean(r,n),a.sd=i.stdev(r,n,a.mean),a.q1=i.interp(r,.25),a.med=i.interp(r,.5),a.q3=i.interp(r,.75),a.lf=Math.min(a.q1,r[Math.min(i.findBin(2.5*a.q1-1.5*a.q3,r,!0)+1,n-1)]),a.uf=Math.max(a.q3,r[Math.max(i.findBin(2.5*a.q3-1.5*a.q1,r),0)]),a.lo=4*a.q1-3*a.q3,a.uo=4*a.q3-3*a.q1}(g,l),g=g.filter(function(t){return t.val&&t.val.length}),g.length?(g[0].t={boxnum:t.numboxes,dPos:d},t.numboxes++,g):[{t:{emptybox:!0}}]}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"fast-isnumeric\":130}],868:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../registry\"),a=t(\"../../components/color\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}var u,c=l(\"y\"),h=l(\"x\");if(c&&c.length)u=\"v\",h||l(\"x0\");else{if(!h||!h.length)return void(e.visible=!1);u=\"h\",l(\"y0\")}i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],s),l(\"orientation\",u),l(\"line.color\",(t.marker||{}).color||r),l(\"line.width\",2),l(\"fillcolor\",a.addOpacity(e.line.color,.5)),l(\"whiskerwidth\"),l(\"boxmean\");var f=n.coerce2(t,e,o,\"marker.outliercolor\"),d=l(\"marker.line.outliercolor\"),p=f||d?l(\"boxpoints\",\"suspectedoutliers\"):l(\"boxpoints\");p&&(l(\"jitter\",\"all\"===p?.3:0),l(\"pointpos\",\"all\"===p?-1.5:0),l(\"marker.symbol\"),l(\"marker.opacity\"),l(\"marker.size\"),l(\"marker.color\",e.line.color),l(\"marker.line.color\"),l(\"marker.line.width\"),\"suspectedoutliers\"===p&&(l(\"marker.line.outliercolor\",e.marker.color),l(\"marker.line.outlierwidth\")))}},{\"../../components/color\":603,\"../../lib\":725,\"../../registry\":844,\"./attributes\":866}],869:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib\"),a=t(\"../../components/fx\"),o=t(\"../../components/color\");e.exports=function(t,e,r,s){var l,u,c,h,f,d,p,m,v,g=t.cd,y=g[0].trace,b=g[0].t,x=t.xa,_=t.ya,w=[];if(h=\"closest\"===s?2.5*b.bdPos:b.bdPos,\"h\"===y.orientation?(l=function(t){return a.inbox(t.min-e,t.max-e)},u=function(t){var e=t.pos+b.bPos-r;return a.inbox(e-h,e+h)},f=\"y\",d=_,m=\"x\",v=x):(l=function(t){var r=t.pos+b.bPos-e;return a.inbox(r-h,r+h)},u=function(t){return a.inbox(t.min-r,t.max-r)},f=\"x\",d=x,m=\"y\",v=_),c=a.getDistanceFunction(s,l,u),a.getClosest(g,c,t),!1!==t.index){var M=g[t.index],k=y.line.color,A=(y.marker||{}).color;o.opacity(k)&&y.line.width?t.color=k:o.opacity(A)&&y.boxpoints?t.color=A:t.color=y.fillcolor,t[f+\"0\"]=d.c2p(M.pos+b.bPos-b.bdPos,!0),t[f+\"1\"]=d.c2p(M.pos+b.bPos+b.bdPos,!0),n.tickText(d,d.c2l(M.pos),\"hover\").text,t[f+\"LabelVal\"]=M.pos;var T,S,E={},L=[\"med\",\"min\",\"q1\",\"q3\",\"max\"];y.boxmean&&L.push(\"mean\"),y.boxpoints&&[].push.apply(L,[\"lf\",\"uf\"]);for(var C=0;C<L.length;C++)(T=L[C])in M&&!(M[T]in E)&&(E[M[T]]=!0,p=v.c2p(M[T],!0),S=i.extendFlat({},t),S[m+\"0\"]=S[m+\"1\"]=p,S[m+\"LabelVal\"]=M[T],S.attr=T,\"mean\"===T&&\"sd\"in M&&\"sd\"===y.boxmean&&(S[m+\"err\"]=M.sd),t.name=\"\",w.push(S));return w}}},{\"../../components/color\":603,\"../../components/fx\":644,\"../../lib\":725,\"../../plots/cartesian/axes\":766}],870:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"./layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"./set_positions\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"box\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"symbols\",\"oriented\",\"box\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":866,\"./calc\":867,\"./defaults\":868,\"./hover\":869,\"./layout_attributes\":871,\"./layout_defaults\":872,\"./plot\":873,\"./set_positions\":874,\"./style\":875}],871:[function(t,e,r){\"use strict\";e.exports={boxmode:{valType:\"enumerated\",values:[\"group\",\"overlay\"],dflt:\"overlay\"},boxgap:{valType:\"number\",min:0,max:1,dflt:.3},boxgroupgap:{valType:\"number\",min:0,max:1,dflt:.3}}},{}],872:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"./layout_attributes\");e.exports=function(t,e,r){function o(r,n){return i.coerce(t,e,a,r,n)}for(var s,l=0;l<r.length;l++)if(n.traceIs(r[l],\"box\")){s=!0;break}s&&(o(\"boxmode\"),o(\"boxgap\"),o(\"boxgroupgap\"))}},{\"../../lib\":725,\"../../registry\":844,\"./layout_attributes\":871}],873:[function(t,e,r){\"use strict\";function n(){l=2e9}function i(){var t=l;return l=(69069*l+1)%4294967296,Math.abs(l-t)<429496729?i():l/4294967296}var a=t(\"d3\"),o=t(\"../../lib\"),s=t(\"../../components/drawing\"),l=2e9;e.exports=function(t,e,r){var l,u,c=t._fullLayout,h=e.xaxis,f=e.yaxis;e.plot.select(\".boxlayer\").selectAll(\"g.trace.boxes\").data(r).enter().append(\"g\").attr(\"class\",\"trace boxes\").each(function(e){var r=e[0].t,d=e[0].trace,p=\"group\"===c.boxmode&&t.numboxes>1,m=r.dPos*(1-c.boxgap)*(1-c.boxgroupgap)/(p?t.numboxes:1),v=p?2*r.dPos*((r.boxnum+.5)/t.numboxes-.5)*(1-c.boxgap):0,g=m*d.whiskerwidth;if(!0!==d.visible||r.emptybox)return void a.select(this).remove();\"h\"===d.orientation?(l=f,u=h):(l=h,u=f),r.bPos=v,r.bdPos=m,n(),a.select(this).selectAll(\"path.box\").data(o.identity).enter().append(\"path\").style(\"vector-effect\",\"non-scaling-stroke\").attr(\"class\",\"box\").each(function(t){var e=l.c2p(t.pos+v,!0),r=l.c2p(t.pos+v-m,!0),n=l.c2p(t.pos+v+m,!0),i=l.c2p(t.pos+v-g,!0),s=l.c2p(t.pos+v+g,!0),c=u.c2p(t.q1,!0),h=u.c2p(t.q3,!0),f=o.constrain(u.c2p(t.med,!0),Math.min(c,h)+1,Math.max(c,h)-1),p=u.c2p(!1===d.boxpoints?t.min:t.lf,!0),y=u.c2p(!1===d.boxpoints?t.max:t.uf,!0);\"h\"===d.orientation?a.select(this).attr(\"d\",\"M\"+f+\",\"+r+\"V\"+n+\"M\"+c+\",\"+r+\"V\"+n+\"H\"+h+\"V\"+r+\"ZM\"+c+\",\"+e+\"H\"+p+\"M\"+h+\",\"+e+\"H\"+y+(0===d.whiskerwidth?\"\":\"M\"+p+\",\"+i+\"V\"+s+\"M\"+y+\",\"+i+\"V\"+s)):a.select(this).attr(\"d\",\"M\"+r+\",\"+f+\"H\"+n+\"M\"+r+\",\"+c+\"H\"+n+\"V\"+h+\"H\"+r+\"ZM\"+e+\",\"+c+\"V\"+p+\"M\"+e+\",\"+h+\"V\"+y+(0===d.whiskerwidth?\"\":\"M\"+i+\",\"+p+\"H\"+s+\"M\"+i+\",\"+y+\"H\"+s))}),d.boxpoints&&a.select(this).selectAll(\"g.points\").data(function(t){return t.forEach(function(t){t.t=r,t.trace=d}),t}).enter().append(\"g\").attr(\"class\",\"points\").selectAll(\"path\").data(function(t){var e,r,n,a,s,l,u,c=\"all\"===d.boxpoints?t.val:t.val.filter(function(e){return e<t.lf||e>t.uf}),h=Math.max((t.max-t.min)/10,t.q3-t.q1),f=1e-9*h,p=.01*h,g=[],y=0;if(d.jitter){if(0===h)for(y=1,g=new Array(c.length),e=0;e<c.length;e++)g[e]=1;else for(e=0;e<c.length;e++)r=Math.max(0,e-5),a=c[r],n=Math.min(c.length-1,e+5),s=c[n],\"all\"!==d.boxpoints&&(c[e]<t.lf?s=Math.min(s,t.lf):a=Math.max(a,t.uf)),l=Math.sqrt(p*(n-r)/(s-a+f))||0,l=o.constrain(Math.abs(l),0,1),g.push(l),y=Math.max(l,y);u=2*d.jitter/y}return c.map(function(e,r){var n,a=d.pointpos;return d.jitter&&(a+=u*g[r]*(i()-.5)),n=\"h\"===d.orientation?{y:t.pos+a*m+v,x:e}:{x:t.pos+a*m+v,y:e},\"suspectedoutliers\"===d.boxpoints&&e<t.uo&&e>t.lo&&(n.so=!0),n})}).enter().append(\"path\").classed(\"point\",!0).call(s.translatePoints,h,f),d.boxmean&&a.select(this).selectAll(\"path.mean\").data(o.identity).enter().append(\"path\").attr(\"class\",\"mean\").style({fill:\"none\",\"vector-effect\":\"non-scaling-stroke\"}).each(function(t){var e=l.c2p(t.pos+v,!0),r=l.c2p(t.pos+v-m,!0),n=l.c2p(t.pos+v+m,!0),i=u.c2p(t.mean,!0),o=u.c2p(t.mean-t.sd,!0),s=u.c2p(t.mean+t.sd,!0);\"h\"===d.orientation?a.select(this).attr(\"d\",\"M\"+i+\",\"+r+\"V\"+n+(\"sd\"!==d.boxmean?\"\":\"m0,0L\"+o+\",\"+e+\"L\"+i+\",\"+r+\"L\"+s+\",\"+e+\"Z\")):a.select(this).attr(\"d\",\"M\"+r+\",\"+i+\"H\"+n+(\"sd\"!==d.boxmean?\"\":\"m0,0L\"+e+\",\"+o+\"L\"+r+\",\"+i+\"L\"+e+\",\"+s+\"Z\"))})})}},{\"../../components/drawing\":627,\"../../lib\":725,d3:121}],874:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\");e.exports=function(t,e){var r,o,s,l,u=t._fullLayout,c=e.xaxis,h=e.yaxis,f=[\"v\",\"h\"];for(o=0;o<f.length;++o){var d,p,m,v=f[o],g=[],y=[],b=0,x=0;for(r=\"h\"===v?h:c,s=0;s<t.calcdata.length;++s)d=t.calcdata[s],p=d[0].t,m=d[0].trace,!0===m.visible&&n.traceIs(m,\"box\")&&!p.emptybox&&m.orientation===v&&m.xaxis===c._id&&m.yaxis===h._id&&(g.push(s),!1!==m.boxpoints&&(b=Math.max(b,m.jitter-m.pointpos-1),x=Math.max(x,m.jitter+m.pointpos-1)));for(s=0;s<g.length;s++)for(d=t.calcdata[g[s]],l=0;l<d.length;l++)y.push(d[l].pos);if(y.length){var _=a.distinctVals(y),w=_.minDiff/2;for(y.length===_.vals.length&&(t.numboxes=1),i.minDtick(r,_.minDiff,_.vals[0],!0),o=0;o<g.length;o++){var M=g[o];t.calcdata[M][0].t.dPos=w}var k=(1-u.boxgap)*(1-u.boxgroupgap)*w/t.numboxes;i.expand(r,_.vals,{vpadminus:w+b*k,vpadplus:w+x*k})}}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844}],875:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/color\"),a=t(\"../../components/drawing\");e.exports=function(t){n.select(t).selectAll(\"g.trace.boxes\").style(\"opacity\",function(t){return t[0].trace.opacity}).each(function(e){var r=e[0].trace,o=r.line.width;n.select(this).selectAll(\"path.box\").style(\"stroke-width\",o+\"px\").call(i.stroke,r.line.color).call(i.fill,r.fillcolor),n.select(this).selectAll(\"path.mean\").style({\"stroke-width\":o,\"stroke-dasharray\":2*o+\"px,\"+o+\"px\"}).call(i.stroke,r.line.color),n.select(this).selectAll(\"g.points path\").call(a.pointStyle,r,t)})}},{\"../../components/color\":603,\"../../components/drawing\":627,d3:121}],876:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../ohlc/attributes\"),a=t(\"../box/attributes\"),o={name:i.increasing.name,showlegend:i.increasing.showlegend,line:{color:n.extendFlat({},a.line.color),width:n.extendFlat({},a.line.width)},fillcolor:n.extendFlat({},a.fillcolor)};e.exports={x:i.x,open:i.open,high:i.high,low:i.low,close:i.close,line:{width:n.extendFlat({},a.line.width,{})},increasing:n.extendDeep({},o,{line:{color:{dflt:i.increasing.line.color.dflt}}}),decreasing:n.extendDeep({},o,{line:{color:{dflt:i.decreasing.line.color.dflt}}}),text:i.text,whiskerwidth:n.extendFlat({},a.whiskerwidth,{dflt:0})}},{\"../../lib\":725,\"../box/attributes\":866,\"../ohlc/attributes\":986}],877:[function(t,e,r){\"use strict\";function n(t,e,r,n){o(t,e,r,n),r(n+\".line.color\"),r(n+\".line.width\",e.line.width),r(n+\".fillcolor\")}var i=t(\"../../lib\"),a=t(\"../ohlc/ohlc_defaults\"),o=t(\"../ohlc/direction_defaults\"),s=t(\"../ohlc/helpers\"),l=t(\"./attributes\");e.exports=function(t,e,r,o){function u(r,n){return i.coerce(t,e,l,r,n)}if(s.pushDummyTransformOpts(t,e),0===a(t,e,u,o))return void(e.visible=!1);u(\"line.width\"),n(t,e,u,\"increasing\"),n(t,e,u,\"decreasing\"),u(\"text\"),u(\"whiskerwidth\")}},{\"../../lib\":725,\"../ohlc/direction_defaults\":988,\"../ohlc/helpers\":989,\"../ohlc/ohlc_defaults\":991,\"./attributes\":876}],878:[function(t,e,r){\"use strict\";var n=t(\"../../plot_api/register\");e.exports={moduleType:\"trace\",name:\"candlestick\",basePlotModule:t(\"../../plots/cartesian\"),categories:[\"cartesian\",\"showLegend\",\"candlestick\"],meta:{},attributes:t(\"./attributes\"),supplyDefaults:t(\"./defaults\")},n(t(\"../box\")),n(t(\"./transform\"))},{\"../../plot_api/register\":756,\"../../plots/cartesian\":776,\"../box\":870,\"./attributes\":876,\"./defaults\":877,\"./transform\":879}],879:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"box\",boxpoints:!1,visible:t.visible,hoverinfo:t.hoverinfo,opacity:t.opacity,xaxis:t.xaxis,yaxis:t.yaxis,transforms:o.makeTransform(t,e,r)},i=t[r];return i&&a.extendFlat(n,{x:t.x||[0],xcalendar:t.xcalendar,y:[].concat(t.low).concat(t.high),whiskerwidth:t.whiskerwidth,text:t.text,name:i.name,showlegend:i.showlegend,line:i.line,fillcolor:i.fillcolor}),n}var i=t(\"fast-isnumeric\"),a=t(\"../../lib\"),o=t(\"../ohlc/helpers\");r.moduleType=\"transform\",r.name=\"candlestick\",r.attributes={},r.supplyDefaults=function(t,e,r,n){return o.clearEphemeralTransformOpts(n),o.copyOHLC(t,e),t},r.transform=function(t,e){for(var r=[],i=0;i<t.length;i++){\n",
       "var a=t[i];\"candlestick\"===a.type?r.push(n(a,e,\"increasing\"),n(a,e,\"decreasing\")):r.push(a)}return o.addRangeSlider(r,e.layout),r},r.calcTransform=function(t,e,r){for(var n=r.direction,a=o.getFilterFn(n),s=e.open,l=e.high,u=e.low,c=e.close,h=s.length,f=[],d=[],p=e._fullInput.x?function(t){var r=e.x[t];f.push(r,r,r,r,r,r)}:function(t){f.push(t,t,t,t,t,t)},m=0;m<h;m++)a(s[m],c[m])&&i(l[m])&&i(u[m])&&(p(m),function(t,e,r,n){d.push(r,t,n,n,n,e)}(s[m],l[m],u[m],c[m]));e.x=f,e.y=d}},{\"../../lib\":725,\"../ohlc/helpers\":989,\"fast-isnumeric\":130}],880:[function(t,e,r){\"use strict\";function n(t,e,r,n){[\"aaxis\",\"baxis\"].forEach(function(a){var o=a.charAt(0),s=t[a]||{},l={},u={tickfont:\"x\",id:o+\"axis\",letter:o,font:e.font,name:a,data:t[o],calendar:e.calendar,dfltColor:n,bgColor:r.paper_bgcolor,fullLayout:r};i(s,l,u),l._categories=l._categories||[],e[a]=l,t[a]||\"-\"===s.type||(t[a]={type:s.type})})}var i=t(\"./axis_defaults\");e.exports=function(t,e,r,i,a){i(\"a\")||(i(\"da\"),i(\"a0\")),i(\"b\")||(i(\"db\"),i(\"b0\")),n(t,e,r,a)}},{\"./axis_defaults\":885}],881:[function(t,e,r){\"use strict\";function n(t,e){if(!Array.isArray(t)||e>=10)return null;for(var r=1/0,i=-1/0,a=t.length,o=0;o<a;o++){var s=t[o];if(Array.isArray(s)){var l=n(s,e+1);l&&(r=Math.min(l[0],r),i=Math.max(l[1],i))}else r=Math.min(s,r),i=Math.max(s,i)}return[r,i]}e.exports=function(t){return n(t,0)}},{}],882:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"./axis_attributes\"),o=t(\"../../components/color/attributes\");e.exports={carpet:{valType:\"string\"},x:{valType:\"data_array\"},y:{valType:\"data_array\"},a:{valType:\"data_array\"},a0:{valType:\"number\",dflt:0},da:{valType:\"number\",dflt:1},b:{valType:\"data_array\"},b0:{valType:\"number\",dflt:0},db:{valType:\"number\",dflt:1},cheaterslope:{valType:\"number\",dflt:1},aaxis:n({},a),baxis:n({},a),font:{family:n({},i.family,{dflt:'\"Open Sans\", verdana, arial, sans-serif'}),size:n({},i.size,{dflt:12}),color:n({},i.color,{dflt:o.defaultLine})},color:{valType:\"color\",dflt:o.defaultLine}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"./axis_attributes\":884}],883:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s,l,u,c,h,f,d,p,m,v,g=Array.isArray(r)?\"a\":\"b\",y=\"a\"===g?t.aaxis:t.baxis,b=y.smoothing,x=\"a\"===g?t.a2i:t.b2j,_=\"a\"===g?r:n,w=\"a\"===g?n:r,M=\"a\"===g?e.a.length:e.b.length,k=\"a\"===g?e.b.length:e.a.length,A=Math.floor(\"a\"===g?t.b2j(w):t.a2i(w)),T=\"a\"===g?function(e){return t.evalxy([],e,A)}:function(e){return t.evalxy([],A,e)};b&&(o=Math.max(0,Math.min(k-2,A)),s=A-o,a=\"a\"===g?function(e,r){return t.dxydi([],e,o,r,s)}:function(e,r){return t.dxydj([],o,e,s,r)});var S=x(_[0]),E=x(_[1]),L=S<E?1:-1,C=1e-8*(E-S),z=L>0?Math.floor:Math.ceil,I=L>0?Math.ceil:Math.floor,D=L>0?Math.min:Math.max,P=L>0?Math.max:Math.min,O=z(S+C),R=I(E-C);c=T(S);var F=[[c]];for(i=O;i*L<R*L;i+=L)l=[],p=P(S,i),m=D(E,i+L),v=m-p,u=Math.max(0,Math.min(M-2,Math.floor(.5*(p+m)))),h=T(m),b&&(f=a(u,p-u),d=a(u,m-u),l.push([c[0]+f[0]/3*v,c[1]+f[1]/3*v]),l.push([h[0]-d[0]/3*v,h[1]-d[1]/3*v])),l.push(h),F.push(l),c=h;return F}},{}],884:[function(t,e,r){\"use strict\";var n=t(\"../../lib/extend\").extendFlat,i=t(\"../../plots/font_attributes\"),a=t(\"../../components/color/attributes\");e.exports={color:{valType:\"color\"},smoothing:{valType:\"number\",dflt:1,min:0,max:1.3},title:{valType:\"string\"},titlefont:n({},i,{}),titleoffset:{valType:\"number\",dflt:10},type:{valType:\"enumerated\",values:[\"-\",\"linear\",\"date\",\"category\"],dflt:\"-\"},autorange:{valType:\"enumerated\",values:[!0,!1,\"reversed\"],dflt:!0},rangemode:{valType:\"enumerated\",values:[\"normal\",\"tozero\",\"nonnegative\"],dflt:\"normal\"},range:{valType:\"info_array\",items:[{valType:\"any\"},{valType:\"any\"}]},fixedrange:{valType:\"boolean\",dflt:!1},cheatertype:{valType:\"enumerated\",values:[\"index\",\"value\"],dflt:\"value\"},tickmode:{valType:\"enumerated\",values:[\"linear\",\"array\"],dflt:\"array\"},nticks:{valType:\"integer\",min:0,dflt:0},tickvals:{valType:\"data_array\"},ticktext:{valType:\"data_array\"},showticklabels:{valType:\"enumerated\",values:[\"start\",\"end\",\"both\",\"none\"],dflt:\"start\"},tickfont:n({},i,{}),tickangle:{valType:\"angle\",dflt:\"auto\"},tickprefix:{valType:\"string\",dflt:\"\"},showtickprefix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},ticksuffix:{valType:\"string\",dflt:\"\"},showticksuffix:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},showexponent:{valType:\"enumerated\",values:[\"all\",\"first\",\"last\",\"none\"],dflt:\"all\"},exponentformat:{valType:\"enumerated\",values:[\"none\",\"e\",\"E\",\"power\",\"SI\",\"B\"],dflt:\"B\"},separatethousands:{valType:\"boolean\",dflt:!1},tickformat:{valType:\"string\",dflt:\"\"},categoryorder:{valType:\"enumerated\",values:[\"trace\",\"category ascending\",\"category descending\",\"array\"],dflt:\"trace\"},categoryarray:{valType:\"data_array\"},labelpadding:{valType:\"integer\",dflt:10},labelprefix:{valType:\"string\"},labelsuffix:{valType:\"string\",dflt:\"\"},showline:{valType:\"boolean\",dflt:!1},linecolor:{valType:\"color\",dflt:a.defaultLine},linewidth:{valType:\"number\",min:0,dflt:1},gridcolor:{valType:\"color\"},gridwidth:{valType:\"number\",min:0,dflt:1},showgrid:{valType:\"boolean\",dflt:!0},minorgridcount:{valType:\"integer\",min:0,dflt:0},minorgridwidth:{valType:\"number\",min:0,dflt:1},minorgridcolor:{valType:\"color\",dflt:a.lightLine},startline:{valType:\"boolean\"},startlinecolor:{valType:\"color\"},startlinewidth:{valType:\"number\",dflt:1},endline:{valType:\"boolean\"},endlinewidth:{valType:\"number\",dflt:1},endlinecolor:{valType:\"color\"},tick0:{valType:\"number\",min:0,dflt:0},dtick:{valType:\"number\",min:0,dflt:1},arraytick0:{valType:\"integer\",min:0,dflt:0},arraydtick:{valType:\"integer\",min:1,dflt:1}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/font_attributes\":790}],885:[function(t,e,r){\"use strict\";function n(t,e){if(\"-\"===t.type){var r=t._id,n=r.charAt(0),i=n+\"calendar\",a=t[i];t.type=d(e,a)}}var i=t(\"./attributes\"),a=t(\"../../components/color\").addOpacity,o=t(\"../../registry\"),s=t(\"../../lib\"),l=t(\"../../plots/cartesian/tick_value_defaults\"),u=t(\"../../plots/cartesian/tick_label_defaults\"),c=t(\"../../plots/cartesian/category_order_defaults\"),h=t(\"../../plots/cartesian/set_convert\"),f=t(\"../../plots/cartesian/ordered_categories\"),d=t(\"../../plots/cartesian/axis_autotype\");e.exports=function(t,e,r){function d(r,n){return s.coerce(t,e,g,r,n)}function p(r,n){return s.coerce2(t,e,g,r,n)}var m=r.letter,v=r.font||{},g=i[m+\"axis\"];r.noHover=!0,r.name&&(e._name=r.name,e._id=r.name);var y=d(\"type\");if(\"-\"===y&&(r.data&&n(e,r.data),\"-\"===e.type?e.type=\"linear\":y=t.type=e.type),d(\"smoothing\"),d(\"cheatertype\"),d(\"showticklabels\"),d(\"labelprefix\",m+\" = \"),d(\"labelsuffix\"),d(\"showtickprefix\"),d(\"showticksuffix\"),d(\"separatethousands\"),d(\"tickformat\"),d(\"exponentformat\"),d(\"showexponent\"),d(\"categoryorder\"),d(\"tickmode\"),d(\"tickvals\"),d(\"ticktext\"),d(\"tick0\"),d(\"dtick\"),\"array\"===e.tickmode&&(d(\"arraytick0\"),d(\"arraydtick\")),d(\"labelpadding\"),e._hovertitle=m,\"date\"===y){o.getComponentMethod(\"calendars\",\"handleDefaults\")(t,e,\"calendar\",r.calendar)}h(e,r.fullLayout);var b=d(\"color\",r.dfltColor),x=b===t.color?b:v.color;d(\"title\"),s.coerceFont(d,\"titlefont\",{family:v.family,size:Math.round(1.2*v.size),color:x}),d(\"titleoffset\"),d(\"tickangle\"),d(\"autorange\",!e.isValidRange(t.range))&&d(\"rangemode\"),d(\"range\"),e.cleanRange(),d(\"fixedrange\"),l(t,e,d,y),u(t,e,d,y,r),c(t,e,d);var _=p(\"gridcolor\",a(b,.3)),w=p(\"gridwidth\"),M=d(\"showgrid\");M||(delete e.gridcolor,delete e.gridwidth);var k=p(\"startlinecolor\",b),A=p(\"startlinewidth\",w);d(\"startline\",e.showgrid||!!k||!!A)||(delete e.startlinecolor,delete e.startlinewidth);var T=p(\"endlinecolor\",b),S=p(\"endlinewidth\",w);return d(\"endline\",e.showgrid||!!T||!!S)||(delete e.endlinecolor,delete e.endlinewidth),M?(d(\"minorgridcount\"),d(\"minorgridwidth\",w),d(\"minorgridcolor\",a(_,.06)),e.minorgridcount||(delete e.minorgridwidth,delete e.minorgridcolor)):(delete e.gridcolor,delete e.gridWidth),e._separators=r.fullLayout.separators,e._initialCategories=\"category\"===y?f(m,e.categoryorder,e.categoryarray,r.data):[],\"none\"===e.showticklabels&&(delete e.tickfont,delete e.tickangle,delete e.showexponent,delete e.exponentformat,delete e.tickformat,delete e.showticksuffix,delete e.showtickprefix),e.showticksuffix||delete e.ticksuffix,e.showtickprefix||delete e.tickprefix,d(\"tickmode\"),(!e.title||e.title&&0===e.title.length)&&(delete e.titlefont,delete e.titleoffset),e}},{\"../../components/color\":603,\"../../lib\":725,\"../../plots/cartesian/axis_autotype\":767,\"../../plots/cartesian/category_order_defaults\":770,\"../../plots/cartesian/ordered_categories\":779,\"../../plots/cartesian/set_convert\":783,\"../../plots/cartesian/tick_label_defaults\":784,\"../../plots/cartesian/tick_value_defaults\":786,\"../../registry\":844,\"./attributes\":882}],886:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"./cheater_basis\"),a=t(\"./array_minmax\"),o=t(\"./map_2d_array\"),s=t(\"./calc_gridlines\"),l=t(\"./calc_labels\"),u=t(\"./calc_clippath\"),c=t(\"../heatmap/clean_2d_array\"),h=t(\"./smooth_fill_2d_array\");e.exports=function(t,e){var r,f=n.getFromId(t,e.xaxis||\"x\"),d=n.getFromId(t,e.yaxis||\"y\"),p=e.aaxis,m=e.baxis,v=e._a=e.a,g=e._b=e.b,y={},b=e.y;if(e._cheater){var x=\"index\"===p.cheatertype?v.length:v,_=\"index\"===m.cheatertype?g.length:g;e.x=r=i(x,_,e.cheaterslope)}else r=e.x;e._x=e.x=r=c(r),e._y=e.y=b=c(b),h(r,v,g),h(b,v,g),e.setScale(),y.xp=e.xp=o(e.xp,r,f.c2p),y.yp=e.yp=o(e.yp,b,d.c2p);var w=a(r),M=a(b),k=.5*(w[1]-w[0]),A=.5*(w[1]+w[0]),T=.5*(M[1]-M[0]),S=.5*(M[1]+M[0]);return w=[A-1.3*k,A+1.3*k],M=[S-1.3*T,S+1.3*T],n.expand(f,w,{padded:!0}),n.expand(d,M,{padded:!0}),s(e,y,\"a\",\"b\"),s(e,y,\"b\",\"a\"),l(e,p),l(e,m),y.clipsegments=u(e.xctrl,e.yctrl,p,m),y.x=r,y.y=b,y.a=v,y.b=g,[y]}},{\"../../plots/cartesian/axes\":766,\"../heatmap/clean_2d_array\":946,\"./array_minmax\":881,\"./calc_clippath\":887,\"./calc_gridlines\":888,\"./calc_labels\":889,\"./cheater_basis\":891,\"./map_2d_array\":903,\"./smooth_fill_2d_array\":907}],887:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s=[],l=!!r.smoothing,u=!!n.smoothing,c=t[0].length-1,h=t.length-1;for(i=0,a=[],o=[];i<=c;i++)a[i]=t[0][i],o[i]=e[0][i];for(s.push({x:a,y:o,bicubic:l}),i=0,a=[],o=[];i<=h;i++)a[i]=t[i][c],o[i]=e[i][c];for(s.push({x:a,y:o,bicubic:u}),i=c,a=[],o=[];i>=0;i--)a[c-i]=t[h][i],o[c-i]=e[h][i];for(s.push({x:a,y:o,bicubic:l}),i=h,a=[],o=[];i>=0;i--)a[h-i]=t[i][0],o[h-i]=e[i][0];return s.push({x:a,y:o,bicubic:u}),s}},{}],888:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib/extend\").extendFlat;e.exports=function(t,e,r,a){function o(e){var n,i,o,s,l,u,c,h,f,d,p,v,g=[],y=[],b={};if(\"b\"===r)for(i=t.b2j(e),o=Math.floor(Math.max(0,Math.min(P-2,i))),s=i-o,b.length=P,b.crossLength=D,b.xy=function(e){return t.evalxy([],e,i)},b.dxy=function(e,r){return t.dxydi([],e,o,r,s)},n=0;n<D;n++)u=Math.min(D-2,n),c=n-u,h=t.evalxy([],n,i),E.smoothing&&n>0&&(f=t.dxydi([],n-1,o,0,s),g.push(l[0]+f[0]/3),y.push(l[1]+f[1]/3),d=t.dxydi([],n-1,o,1,s),g.push(h[0]-d[0]/3),y.push(h[1]-d[1]/3)),g.push(h[0]),y.push(h[1]),l=h;else for(n=t.a2i(e),u=Math.floor(Math.max(0,Math.min(D-2,n))),c=n-u,b.length=D,b.crossLength=P,b.xy=function(e){return t.evalxy([],n,e)},b.dxy=function(e,r){return t.dxydj([],u,e,c,r)},i=0;i<P;i++)o=Math.min(P-2,i),s=i-o,h=t.evalxy([],n,i),E.smoothing&&i>0&&(p=t.dxydj([],u,i-1,c,0),g.push(l[0]+p[0]/3),y.push(l[1]+p[1]/3),v=t.dxydj([],u,i-1,c,1),g.push(h[0]-v[0]/3),y.push(h[1]-v[1]/3)),g.push(h[0]),y.push(h[1]),l=h;return b.axisLetter=r,b.axis=M,b.crossAxis=E,b.value=e,b.constvar=a,b.index=m,b.x=g,b.y=y,b.smoothing=E.smoothing,b}function s(e){var n,i,o,s,l,u=[],c=[],h={};if(h.length=w.length,h.crossLength=S.length,\"b\"===r)for(o=Math.max(0,Math.min(P-2,e)),l=Math.min(1,Math.max(0,e-o)),h.xy=function(r){return t.evalxy([],r,e)},h.dxy=function(e,r){return t.dxydi([],e,o,r,l)},n=0;n<z;n++)u[n]=L[e*O][n],c[n]=C[e*O][n];else for(i=Math.max(0,Math.min(D-2,e)),s=Math.min(1,Math.max(0,e-i)),h.xy=function(r){return t.evalxy([],e,r)},h.dxy=function(e,r){return t.dxydj([],i,e,s,r)},n=0;n<I;n++)u[n]=L[n][e*O],c[n]=C[n][e*O];return h.axisLetter=r,h.axis=M,h.crossAxis=E,h.value=w[e],h.constvar=a,h.index=e,h.x=u,h.y=c,h.smoothing=E.smoothing,h}var l,u,c,h,f,d,p,m,v,g,y,b,x,_,w=t[r],M=t[r+\"axis\"],k=M._gridlines=[],A=M._minorgridlines=[],T=M._boundarylines=[],S=t[a],E=t[a+\"axis\"];if(\"array\"===M.tickmode)for(M.tickvals=[],l=0;l<w.length;l++)M.tickvals.push(w[l]);var L=t.xctrl,C=t.yctrl,z=L[0].length,I=L.length,D=t.a.length,P=t.b.length;n.calcTicks(M);var O=M.smoothing?3:1;if(\"array\"===M.tickmode){for(h=5e-15,f=[Math.floor((w.length-1-M.arraytick0)/M.arraydtick*(1+h)),Math.ceil(-M.arraytick0/M.arraydtick/(1+h))].sort(function(t,e){return t-e}),d=f[0]-1,p=f[1]+1,m=d;m<p;m++)(u=M.arraytick0+M.arraydtick*m)<0||u>w.length-1||k.push(i(s(u),{color:M.gridcolor,width:M.gridwidth}));for(m=d;m<p;m++)if(c=M.arraytick0+M.arraydtick*m,y=Math.min(c+M.arraydtick,w.length-1),!(c<0||c>w.length-1||y<0||y>w.length-1))for(b=w[c],x=w[y],l=0;l<M.minorgridcount;l++)(_=y-c)<=0||(g=b+(x-b)*(l+1)/(M.minorgridcount+1)*(M.arraydtick/_))<w[0]||g>w[w.length-1]||A.push(i(o(g),{color:M.minorgridcolor,width:M.minorgridwidth}));M.startline&&T.push(i(s(0),{color:M.startlinecolor,width:M.startlinewidth})),M.endline&&T.push(i(s(w.length-1),{color:M.endlinecolor,width:M.endlinewidth}))}else{for(h=5e-15,f=[Math.floor((w[w.length-1]-M.tick0)/M.dtick*(1+h)),Math.ceil((w[0]-M.tick0)/M.dtick/(1+h))].sort(function(t,e){return t-e}),d=f[0],p=f[1],m=d;m<=p;m++)v=M.tick0+M.dtick*m,k.push(i(o(v),{color:M.gridcolor,width:M.gridwidth}));for(m=d-1;m<p+1;m++)for(v=M.tick0+M.dtick*m,l=0;l<M.minorgridcount;l++)(g=v+M.dtick*(l+1)/(M.minorgridcount+1))<w[0]||g>w[w.length-1]||A.push(i(o(g),{color:M.minorgridcolor,width:M.minorgridwidth}));M.startline&&T.push(i(o(w[0]),{color:M.startlinecolor,width:M.startlinewidth})),M.endline&&T.push(i(o(w[w.length-1]),{color:M.endlinecolor,width:M.endlinewidth}))}}},{\"../../lib/extend\":716,\"../../plots/cartesian/axes\":766}],889:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../../lib/extend\").extendFlat;e.exports=function(t,e){var r,a,o,s=e._labels=[],l=e._gridlines;for(r=0;r<l.length;r++)o=l[r],-1!==[\"start\",\"both\"].indexOf(e.showticklabels)&&(a=n.tickText(e,o.value),i(a,{prefix:void 0,suffix:void 0,endAnchor:!0,xy:o.xy(0),dxy:o.dxy(0,0),axis:o.axis,length:o.crossAxis.length,font:o.axis.tickfont,isFirst:0===r,isLast:r===l.length-1}),s.push(a)),-1!==[\"end\",\"both\"].indexOf(e.showticklabels)&&(a=n.tickText(e,o.value),i(a,{endAnchor:!1,xy:o.xy(o.crossLength-1),dxy:o.dxy(o.crossLength-2,1),axis:o.axis,length:o.crossAxis.length,font:o.axis.tickfont,isFirst:0===r,isLast:r===l.length-1}),s.push(a))}},{\"../../lib/extend\":716,\"../../plots/cartesian/axes\":766}],890:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i=t[0]-e[0],a=t[1]-e[1],o=r[0]-e[0],s=r[1]-e[1],l=Math.pow(i*i+a*a,.25),u=Math.pow(o*o+s*s,.25),c=(u*u*i-l*l*o)*n,h=(u*u*a-l*l*s)*n,f=u*(l+u)*3,d=l*(l+u)*3;return[[e[0]+(f&&c/f),e[1]+(f&&h/f)],[e[0]-(d&&c/d),e[1]-(d&&h/d)]]}},{}],891:[function(t,e,r){\"use strict\";var n=t(\"../../lib\").isArray;e.exports=function(t,e,r){var i,a,o,s,l,u,c=[],h=n(t)?t.length:t,f=n(e)?e.length:e,d=n(t)?t:null,p=n(e)?e:null;d&&(o=(d.length-1)/(d[d.length-1]-d[0])/(h-1)),p&&(s=(p.length-1)/(p[p.length-1]-p[0])/(f-1));var m,v=1/0,g=-1/0;for(a=0;a<f;a++)for(c[a]=[],u=p?(p[a]-p[0])*s:a/(f-1),i=0;i<h;i++)l=d?(d[i]-d[0])*o:i/(h-1),m=l-u*r,v=Math.min(m,v),g=Math.max(m,g),c[a][i]=m;var y=1/(g-v),b=-v*y;for(a=0;a<f;a++)for(i=0;i<h;i++)c[a][i]=y*c[a][i]+b;return c}},{\"../../lib\":725}],892:[function(t,e,r){\"use strict\";function n(t,e,r){var n=-.5*r[0]+1.5*e[0],i=-.5*r[1]+1.5*e[1];return[(2*n+t[0])/3,(2*i+t[1])/3]}var i=t(\"./catmull_rom\"),a=t(\"../../lib\").ensureArray;e.exports=function(t,e,r,o,s,l){var u,c,h,f,d,p,m,v,g,y,b=r[0].length,x=r.length,_=s?3*b-2:b,w=l?3*x-2:x;for(t=a(t,w),e=a(e,w),h=0;h<w;h++)t[h]=a(t[h],_),e[h]=a(e[h],_);for(c=0,f=0;c<x;c++,f+=l?3:1)for(d=t[f],p=e[f],m=r[c],v=o[c],u=0,h=0;u<b;u++,h+=s?3:1)d[h]=m[u],p[h]=v[u];if(s)for(c=0,f=0;c<x;c++,f+=l?3:1){for(u=1,h=3;u<b-1;u++,h+=3)g=i([r[c][u-1],o[c][u-1]],[r[c][u],o[c][u]],[r[c][u+1],o[c][u+1]],s),t[f][h-1]=g[0][0],e[f][h-1]=g[0][1],t[f][h+1]=g[1][0],e[f][h+1]=g[1][1];y=n([t[f][0],e[f][0]],[t[f][2],e[f][2]],[t[f][3],e[f][3]]),t[f][1]=y[0],e[f][1]=y[1],y=n([t[f][_-1],e[f][_-1]],[t[f][_-3],e[f][_-3]],[t[f][_-4],e[f][_-4]]),t[f][_-2]=y[0],e[f][_-2]=y[1]}if(l)for(h=0;h<_;h++){for(f=3;f<w-3;f+=3)g=i([t[f-3][h],e[f-3][h]],[t[f][h],e[f][h]],[t[f+3][h],e[f+3][h]],l),t[f-1][h]=g[0][0],e[f-1][h]=g[0][1],t[f+1][h]=g[1][0],e[f+1][h]=g[1][1];y=n([t[0][h],e[0][h]],[t[2][h],e[2][h]],[t[3][h],e[3][h]]),t[1][h]=y[0],e[1][h]=y[1],y=n([t[w-1][h],e[w-1][h]],[t[w-3][h],e[w-3][h]],[t[w-4][h],e[w-4][h]]),t[w-2][h]=y[0],e[w-2][h]=y[1]}if(s&&l)for(f=1;f<w;f+=(f+1)%3==0?2:1){for(h=3;h<_-3;h+=3)g=i([t[f][h-3],e[f][h-3]],[t[f][h],e[f][h]],[t[f][h+3],e[f][h+3]],s),t[f][h-1]=.5*(t[f][h-1]+g[0][0]),e[f][h-1]=.5*(e[f][h-1]+g[0][1]),t[f][h+1]=.5*(t[f][h+1]+g[1][0]),e[f][h+1]=.5*(e[f][h+1]+g[1][1]);y=n([t[f][0],e[f][0]],[t[f][2],e[f][2]],[t[f][3],e[f][3]]),t[f][1]=.5*(t[f][1]+y[0]),e[f][1]=.5*(e[f][1]+y[1]),y=n([t[f][_-1],e[f][_-1]],[t[f][_-3],e[f][_-3]],[t[f][_-4],e[f][_-4]]),t[f][_-2]=.5*(t[f][_-2]+y[0]),e[f][_-2]=.5*(e[f][_-2]+y[1])}return[t,e]}},{\"../../lib\":725,\"./catmull_rom\":890}],893:[function(t,e,r){\"use strict\";e.exports={RELATIVE_CULL_TOLERANCE:1e-6}},{}],894:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3,n*=3;var f=i*i,d=1-i,p=d*d,m=d*i*2,v=-3*p,g=3*(p-m),y=3*(m-f),b=3*f,x=a*a,_=x*a,w=1-a,M=w*w,k=M*w;for(h=0;h<t.length;h++)c=t[h],o=v*c[n][r]+g*c[n][r+1]+y*c[n][r+2]+b*c[n][r+3],s=v*c[n+1][r]+g*c[n+1][r+1]+y*c[n+1][r+2]+b*c[n+1][r+3],l=v*c[n+2][r]+g*c[n+2][r+1]+y*c[n+2][r+2]+b*c[n+2][r+3],u=v*c[n+3][r]+g*c[n+3][r+1]+y*c[n+3][r+2]+b*c[n+3][r+3],e[h]=k*o+3*(M*a*s+w*x*l)+_*u;return e}:e?function(e,r,n,i,a){e||(e=[]);var o,s,l,u;r*=3;var c=i*i,h=1-i,f=h*h,d=h*i*2,p=-3*f,m=3*(f-d),v=3*(d-c),g=3*c,y=1-a;for(l=0;l<t.length;l++)u=t[l],o=p*u[n][r]+m*u[n][r+1]+v*u[n][r+2]+g*u[n][r+3],s=p*u[n+1][r]+m*u[n+1][r+1]+v*u[n+1][r+2]+g*u[n+1][r+3],e[l]=y*o+a*s;return e}:r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;n*=3;var f=a*a,d=f*a,p=1-a,m=p*p,v=m*p;for(c=0;c<t.length;c++)h=t[c],o=h[n][r+1]-h[n][r],s=h[n+1][r+1]-h[n+1][r],l=h[n+2][r+1]-h[n+2][r],u=h[n+3][r+1]-h[n+3][r],e[c]=v*o+3*(m*a*s+p*f*l)+d*u;return e}:function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c=1-a;for(l=0;l<t.length;l++)u=t[l],o=u[n][r+1]-u[n][r],s=u[n+1][r+1]-u[n+1][r],e[l]=c*o+a*s;return e}}},{}],895:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){return e&&r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3,n*=3;var f=i*i,d=f*i,p=1-i,m=p*p,v=m*p,g=a*a,y=1-a,b=y*y,x=y*a*2,_=-3*b,w=3*(b-x),M=3*(x-g),k=3*g;for(h=0;h<t.length;h++)c=t[h],o=_*c[n][r]+w*c[n+1][r]+M*c[n+2][r]+k*c[n+3][r],s=_*c[n][r+1]+w*c[n+1][r+1]+M*c[n+2][r+1]+k*c[n+3][r+1],l=_*c[n][r+2]+w*c[n+1][r+2]+M*c[n+2][r+2]+k*c[n+3][r+2],u=_*c[n][r+3]+w*c[n+1][r+3]+M*c[n+2][r+3]+k*c[n+3][r+3],e[h]=v*o+3*(m*i*s+p*f*l)+d*u;return e}:e?function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c,h;r*=3;var f=a*a,d=f*a,p=1-a,m=p*p,v=m*p;for(c=0;c<t.length;c++)h=t[c],o=h[n+1][r]-h[n][r],s=h[n+1][r+1]-h[n][r+1],l=h[n+1][r+2]-h[n][r+2],u=h[n+1][r+3]-h[n][r+3],e[c]=v*o+3*(m*a*s+p*f*l)+d*u;return e}:r?function(e,r,n,i,a){e||(e=[]);var o,s,l,u;n*=3;var c=1-i,h=a*a,f=1-a,d=f*f,p=f*a*2,m=-3*d,v=3*(d-p),g=3*(p-h),y=3*h;for(l=0;l<t.length;l++)u=t[l],o=m*u[n][r]+v*u[n+1][r]+g*u[n+2][r]+y*u[n+3][r],s=m*u[n][r+1]+v*u[n+1][r+1]+g*u[n+2][r+1]+y*u[n+3][r+1],e[l]=c*o+i*s;return e}:function(e,r,n,i,a){e||(e=[]);var o,s,l,u,c=1-i;for(l=0;l<t.length;l++)u=t[l],o=u[n+1][r]-u[n][r],s=u[n+1][r+1]-u[n][r+1],e[l]=c*o+i*s;return e}}},{}],896:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i){var a=e-2,o=r-2;return n&&i?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));f*=3,d*=3;var v=p*p,g=v*p,y=1-p,b=y*y,x=b*y,_=m*m,w=_*m,M=1-m,k=M*M,A=k*M;for(h=0;h<t.length;h++)c=t[h],i=x*c[d][f]+3*(b*p*c[d][f+1]+y*v*c[d][f+2])+g*c[d][f+3],s=x*c[d+1][f]+3*(b*p*c[d+1][f+1]+y*v*c[d+1][f+2])+g*c[d+1][f+3],l=x*c[d+2][f]+3*(b*p*c[d+2][f+1]+y*v*c[d+2][f+2])+g*c[d+2][f+3],u=x*c[d+3][f]+3*(b*p*c[d+3][f+1]+y*v*c[d+3][f+2])+g*c[d+3][f+3],e[h]=A*i+3*(k*m*s+M*_*l)+w*u;return e}:n?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));f*=3;var v=p*p,g=v*p,y=1-p,b=y*y,x=b*y,_=1-m;for(c=0;c<t.length;c++)h=t[c],i=_*h[d][f]+m*h[d+1][f],s=_*h[d][f+1]+m*h[d+1][f+1],l=_*h[d][f+2]+m*h[d+1][f+1],u=_*h[d][f+3]+m*h[d+1][f+1],e[c]=x*i+3*(b*p*s+y*v*l)+g*u;return e}:i?function(e,r,n){e||(e=[]);var i,s,l,u,c,h,f=Math.max(0,Math.min(Math.floor(r),a)),d=Math.max(0,Math.min(Math.floor(n),o)),p=Math.max(0,Math.min(1,r-f)),m=Math.max(0,Math.min(1,n-d));d*=3;var v=m*m,g=v*m,y=1-m,b=y*y,x=b*y,_=1-p;for(c=0;c<t.length;c++)h=t[c],i=_*h[d][f]+p*h[d][f+1],s=_*h[d+1][f]+p*h[d+1][f+1],l=_*h[d+2][f]+p*h[d+2][f+1],u=_*h[d+3][f]+p*h[d+3][f+1],e[c]=x*i+3*(b*m*s+y*v*l)+g*u;return e}:function(e,r,n){e||(e=[]);var i,s,l,u,c=Math.max(0,Math.min(Math.floor(r),a)),h=Math.max(0,Math.min(Math.floor(n),o)),f=Math.max(0,Math.min(1,r-c)),d=Math.max(0,Math.min(1,n-h)),p=1-d,m=1-f;for(l=0;l<t.length;l++)u=t[l],i=m*u[h][c]+f*u[h][c+1],s=m*u[h+1][c]+f*u[h+1][c+1],e[l]=p*i+d*s;return e}}},{}],897:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./xy_defaults\"),a=t(\"./ab_defaults\"),o=t(\"./set_convert\"),s=t(\"./attributes\"),l=t(\"../../components/color/attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,s,r,i)}e._clipPathId=\"clip\"+e.uid+\"carpet\";var h=c(\"color\",l.defaultLine);if(n.coerceFont(c,\"font\"),c(\"carpet\"),a(t,e,u,c,h),!e.a||!e.b)return void(e.visible=!1);e.a.length<3&&(e.aaxis.smoothing=0),e.b.length<3&&(e.baxis.smoothing=0);var f=i(t,e,c);o(e),e._cheater&&c(\"cheaterslope\"),f||(e.visible=!1)}},{\"../../components/color/attributes\":602,\"../../lib\":725,\"./ab_defaults\":880,\"./attributes\":882,\"./set_convert\":906,\"./xy_defaults\":908}],898:[function(t,e,r){\"use strict\";e.exports=function(t){return Array.isArray(t[0])}},{}],899:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.plot=t(\"./plot\"),n.calc=t(\"./calc\"),n.animatable=!0,n.moduleType=\"trace\",n.name=\"carpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"carpet\",\"carpetAxis\",\"notLegendIsolatable\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":882,\"./calc\":886,\"./defaults\":897,\"./plot\":905}],900:[function(t,e,r){\"use strict\";e.exports=function(t,e){for(var r,n=t._fullData.length,i=0;i<n;i++){var a=t._fullData[i];if(a.index!==e.index&&(\"carpet\"===a.type&&(r||(r=a),a.carpet===e.carpet)))return a}return r}},{}],901:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){if(0===t.length)return\"\";var n,i=[],a=r?3:1;for(n=0;n<t.length;n+=a)i.push(t[n]+\",\"+e[n]),r&&n<t.length-a&&(i.push(\"C\"),i.push([t[n+1]+\",\"+e[n+1],t[n+2]+\",\"+e[n+2]+\" \"].join(\" \")));return i.join(r?\"\":\"L\")}},{}],902:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){var n;for(Array.isArray(t)?t.length>e.length&&(t=t.slice(0,e.length)):t=[],n=0;n<e.length;n++)t[n]=r(e[n]);return t}},{}],903:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){var n,i;for(Array.isArray(t)?t.length>e.length&&(t=t.slice(0,e.length)):t=[],n=0;n<e.length;n++)for(Array.isArray(t[n])?t[n].length>e.length&&(t[n]=t[n].slice(0,e.length)):t[n]=[],i=0;i<e[0].length;i++)t[n][i]=r(e[n][i]);return t}},{}],904:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n,i,a){var o=i[0]*t.dpdx(e),s=i[1]*t.dpdy(r),l=1,u=1;if(a){var c=Math.sqrt(i[0]*i[0]+i[1]*i[1]),h=Math.sqrt(a[0]*a[0]+a[1]*a[1]),f=(i[0]*a[0]+i[1]*a[1])/c/h;u=Math.max(0,f)}var d=180*Math.atan2(s,o)/Math.PI;return d<-90?(d+=180,l=-l):d>90&&(d-=180,l=-l),{angle:d,flip:l,p:t.c2p(n,e,r),offsetMultplier:u}}},{}],905:[function(t,e,r){\"use strict\";function n(t,e,r){var n=t.selectAll(e+\".\"+r).data([0]);return n.enter().append(e).classed(r,!0),n}function i(t,e,r){var i=r[0],u=r[0].trace,c=e.xaxis,h=e.yaxis,f=u.aaxis,d=u.baxis,p=t._fullLayout,m=e.plot.selectAll(\".carpetlayer\"),v=n(p._defs,\"g\",\"clips\"),g=n(m,\"g\",\"carpet\"+u.uid).classed(\"trace\",!0),y=n(g,\"g\",\"minorlayer\"),b=n(g,\"g\",\"majorlayer\"),x=n(g,\"g\",\"boundarylayer\"),_=n(g,\"g\",\"labellayer\");g.style(\"opacity\",u.opacity),o(c,h,b,f,\"a\",f._gridlines),o(c,h,b,d,\"b\",d._gridlines),o(c,h,y,f,\"a\",f._minorgridlines),o(c,h,y,d,\"b\",d._minorgridlines),o(c,h,x,f,\"a-boundary\",f._boundarylines),o(c,h,x,d,\"b-boundary\",d._boundarylines),l(t,_,u,i,c,h,s(t,c,h,u,i,_,f._labels,\"a-label\"),s(t,c,h,u,i,_,d._labels,\"b-label\")),a(u,i,v,c,h)}function a(t,e,r,i,a){var o,s,l,u,c=r.select(\"#\"+t._clipPathId);c.size()||(c=r.append(\"clipPath\").classed(\"carpetclip\",!0));var h=n(c,\"path\",\"carpetboundary\"),p=e.clipsegments,m=[];for(u=0;u<p.length;u++)o=p[u],s=f([],o.x,i.c2p),l=f([],o.y,a.c2p),m.push(d(s,l,o.bicubic));var v=\"M\"+m.join(\"L\")+\"Z\";c.attr(\"id\",t._clipPathId),h.attr(\"d\",v)}function o(t,e,r,n,i,a){var o=\"const-\"+i+\"-lines\",s=r.selectAll(\".\"+o).data(a);s.enter().append(\"path\").classed(o,!0).style(\"vector-effect\",\"non-scaling-stroke\"),s.each(function(r){var n=r,i=n.x,a=n.y,o=f([],i,t.c2p),s=f([],a,e.c2p),l=\"M\"+d(o,s,n.smoothing);c.select(this).attr(\"d\",l).style(\"stroke-width\",n.width).style(\"stroke\",n.color).style(\"fill\",\"none\")}),s.exit().remove()}function s(t,e,r,n,i,a,o,s){var l=a.selectAll(\"text.\"+s).data(o);l.enter().append(\"text\").classed(s,!0);var u=0;return l.each(function(i){var a;if(\"auto\"===i.axis.tickangle)a=p(n,e,r,i.xy,i.dxy);else{var o=(i.axis.tickangle+180)*Math.PI/180;a=p(n,e,r,i.xy,[Math.cos(o),Math.sin(o)])}var s=(i.endAnchor?-1:1)*a.flip,l=c.select(this).attr({\"text-anchor\":s>0?\"start\":\"end\",\"data-notex\":1}).call(h.font,i.font).text(i.text).call(m.convertToTspans,t),f=h.bBox(this);l.attr(\"transform\",\"translate(\"+a.p[0]+\",\"+a.p[1]+\") rotate(\"+a.angle+\")translate(\"+i.axis.labelpadding*s+\",\"+.3*f.height+\")\"),u=Math.max(u,f.width+i.axis.labelpadding)}),l.exit().remove(),u}function l(t,e,r,n,i,a,o,s){var l,c,h,f;l=.5*(r.a[0]+r.a[r.a.length-1]),c=r.b[0],h=r.ab2xy(l,c,!0),f=r.dxyda_rough(l,c),u(t,e,r,n,h,f,r.aaxis,i,a,o,\"a-title\"),l=r.a[0],c=.5*(r.b[0]+r.b[r.b.length-1]),h=r.ab2xy(l,c,!0),f=r.dxydb_rough(l,c),u(t,e,r,n,h,f,r.baxis,i,a,s,\"b-title\")}function u(t,e,r,n,i,a,o,s,l,u,f){var d=[];o.title&&d.push(o.title);var v=e.selectAll(\"text.\"+f).data(d);v.enter().append(\"text\").classed(f,!0),v.each(function(){var e=p(r,s,l,i,a);-1===[\"start\",\"both\"].indexOf(o.showticklabels)&&(u=0),u+=o.titlefont.size+o.titleoffset,c.select(this).text(o.title||\"\").call(m.convertToTspans,t).attr(\"transform\",\"translate(\"+e.p[0]+\",\"+e.p[1]+\") rotate(\"+e.angle+\") translate(0,\"+u+\")\").classed(\"user-select-none\",!0).attr(\"text-anchor\",\"middle\").call(h.font,o.titlefont)}),v.exit().remove()}var c=t(\"d3\"),h=t(\"../../components/drawing\"),f=t(\"./map_1d_array\"),d=t(\"./makepath\"),p=t(\"./orient_text\"),m=t(\"../../lib/svg_text_utils\");e.exports=function(t,e,r){for(var n=0;n<r.length;n++)i(t,e,r[n])}},{\"../../components/drawing\":627,\"../../lib/svg_text_utils\":745,\"./makepath\":901,\"./map_1d_array\":902,\"./orient_text\":904,d3:121}],906:[function(t,e,r){\"use strict\";var n=t(\"./constants\"),i=t(\"../../lib/search\").findBin,a=t(\"./compute_control_points\"),o=t(\"./create_spline_evaluator\"),s=t(\"./create_i_derivative_evaluator\"),l=t(\"./create_j_derivative_evaluator\");e.exports=function(t){var e=t.a,r=t.b,u=t.a.length,c=t.b.length,h=t.aaxis,f=t.baxis,d=e[0],p=e[u-1],m=r[0],v=r[c-1],g=e[e.length-1]-e[0],y=r[r.length-1]-r[0],b=g*n.RELATIVE_CULL_TOLERANCE,x=y*n.RELATIVE_CULL_TOLERANCE;d-=b,p+=b,m-=x,v+=x,t.isVisible=function(t,e){return t>d&&t<p&&e>m&&e<v},t.isOccluded=function(t,e){return t<d||t>p||e<m||e>v},h.c2p=function(t){return t},f.c2p=function(t){return t},t.setScale=function(){var e=t.x,r=t.y,n=a(t.xctrl,t.yctrl,e,r,h.smoothing,f.smoothing);t.xctrl=n[0],t.yctrl=n[1],t.evalxy=o([t.xctrl,t.yctrl],u,c,h.smoothing,f.smoothing),t.dxydi=s([t.xctrl,t.yctrl],h.smoothing,f.smoothing),t.dxydj=l([t.xctrl,t.yctrl],h.smoothing,f.smoothing)},t.i2a=function(t){var r=Math.max(0,Math.floor(t[0]),u-2),n=t[0]-r;return(1-n)*e[r]+n*e[r+1]},t.j2b=function(t){var e=Math.max(0,Math.floor(t[1]),u-2),n=t[1]-e;return(1-n)*r[e]+n*r[e+1]},t.ij2ab=function(e){return[t.i2a(e[0]),t.j2b(e[1])]},t.a2i=function(t){var r=Math.max(0,Math.min(i(t,e),u-2)),n=e[r],a=e[r+1];return Math.max(0,Math.min(u-1,r+(t-n)/(a-n)))},t.b2j=function(t){var e=Math.max(0,Math.min(i(t,r),c-2)),n=r[e],a=r[e+1];return Math.max(0,Math.min(c-1,e+(t-n)/(a-n)))},t.ab2ij=function(e){return[t.a2i(e[0]),t.b2j(e[1])]},t.i2c=function(e,r){return t.evalxy([],e,r)},t.ab2xy=function(n,i,a){if(!a&&(n<e[0]||n>e[u-1]|i<r[0]||i>r[c-1]))return[!1,!1];var o=t.a2i(n),s=t.b2j(i),l=t.evalxy([],o,s);if(a){var h,f,d,p,m=0,v=0,g=[];n<e[0]?(h=0,f=0,m=(n-e[0])/(e[1]-e[0])):n>e[u-1]?(h=u-2,f=1,m=(n-e[u-1])/(e[u-1]-e[u-2])):(h=Math.max(0,Math.min(u-2,Math.floor(o))),f=o-h),i<r[0]?(d=0,p=0,v=(i-r[0])/(r[1]-r[0])):i>r[c-1]?(d=c-2,p=1,v=(i-r[c-1])/(r[c-1]-r[c-2])):(d=Math.max(0,Math.min(c-2,Math.floor(s))),p=s-d),m&&(t.dxydi(g,h,d,f,p),l[0]+=g[0]*m,l[1]+=g[1]*m),v&&(t.dxydj(g,h,d,f,p),l[0]+=g[0]*v,l[1]+=g[1]*v)}return l},t.c2p=function(t,e,r){return[e.c2p(t[0]),r.c2p(t[1])]},t.p2x=function(t,e,r){return[e.p2c(t[0]),r.p2c(t[1])]},t.dadi=function(t){var r=Math.max(0,Math.min(e.length-2,t));return e[r+1]-e[r]},t.dbdj=function(t){var e=Math.max(0,Math.min(r.length-2,t));return r[e+1]-r[e]},t.dxyda=function(e,r,n,i){var a=t.dxydi(null,e,r,n,i),o=t.dadi(e,n);return[a[0]/o,a[1]/o]},t.dxydb=function(e,r,n,i){var a=t.dxydj(null,e,r,n,i),o=t.dbdj(r,i);return[a[0]/o,a[1]/o]},t.dxyda_rough=function(e,r,n){var i=g*(n||.1),a=t.ab2xy(e+i,r,!0),o=t.ab2xy(e-i,r,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dxydb_rough=function(e,r,n){var i=y*(n||.1),a=t.ab2xy(e,r+i,!0),o=t.ab2xy(e,r-i,!0);return[.5*(a[0]-o[0])/i,.5*(a[1]-o[1])/i]},t.dpdx=function(t){return t._m},t.dpdy=function(t){return t._m}}},{\"../../lib/search\":740,\"./compute_control_points\":892,\"./constants\":893,\"./create_i_derivative_evaluator\":894,\"./create_j_derivative_evaluator\":895,\"./create_spline_evaluator\":896}],907:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r){var i,a,o,s=[],l=[],u=t[0].length,c=t.length,h=0;for(i=0;i<u;i++)for(a=0;a<c;a++)void 0===t[a][i]&&(s.push(i),l.push(a),t[a][i]=function(e,r){var n,i=0,a=0;return e>0&&void 0!==(n=t[r][e-1])&&(a++,i+=n),e<u-1&&void 0!==(n=t[r][e+1])&&(a++,i+=n),r>0&&void 0!==(n=t[r-1][e])&&(a++,i+=n),r<c-1&&void 0!==(n=t[r+1][e])&&(a++,i+=n),i/Math.max(1,a)}(i,a)),h=Math.max(h,Math.abs(t[a][i]));if(!s.length)return t;var f,d,p,m,v,g,y,b,x,_,w,M=0,k=0,A=s.length;do{for(M=0,o=0;o<A;o++){i=s[o],a=l[o];var T,S,E,L,C,z,I=0,D=0;0===i?(C=Math.min(u-1,2),E=e[C],L=e[1],T=t[a][C],S=t[a][1],D+=S+(S-T)*(e[0]-L)/(L-E),I++):i===u-1&&(C=Math.max(0,u-3),E=e[C],L=e[u-2],T=t[a][C],S=t[a][u-2],D+=S+(S-T)*(e[u-1]-L)/(L-E),I++),(0===i||i===u-1)&&a>0&&a<c-1&&(f=r[a+1]-r[a],d=r[a]-r[a-1],D+=(d*t[a+1][i]+f*t[a-1][i])/(d+f),I++),0===a?(z=Math.min(c-1,2),E=r[z],L=r[1],T=t[z][i],S=t[1][i],D+=S+(S-T)*(r[0]-L)/(L-E),I++):a===c-1&&(z=Math.max(0,c-3),E=r[z],L=r[c-2],T=t[z][i],S=t[c-2][i],D+=S+(S-T)*(r[c-1]-L)/(L-E),I++),(0===a||a===c-1)&&i>0&&i<u-1&&(f=e[i+1]-e[i],d=e[i]-e[i-1],D+=(d*t[a][i+1]+f*t[a][i-1])/(d+f),I++),I?D/=I:(p=e[i+1]-e[i],m=e[i]-e[i-1],v=r[a+1]-r[a],g=r[a]-r[a-1],y=p*m*(p+m),b=v*g*(v+g),D=(y*(g*t[a+1][i]+v*t[a-1][i])+b*(m*t[a][i+1]+p*t[a][i-1]))/(b*(m+p)+y*(g+v))),x=D-t[a][i],_=x/h,M+=_*_,w=I?0:.85,t[a][i]+=x*(1+w)}M=Math.sqrt(M)}while(k++<100&&M>1e-5);return n.log(\"Smoother converged to\",M,\"after\",k,\"iterations\"),t}},{\"../../lib\":725}],908:[function(t,e,r){\"use strict\"\n",
       ";var n=t(\"./has_columns\"),i=t(\"../heatmap/convert_column_xyz\");e.exports=function(t,e,r){var a=[],o=r(\"x\");o&&!n(o)&&a.push(\"x\"),e._cheater=!o;var s=r(\"y\");if(s&&!n(s)&&a.push(\"y\"),o||s)return a.length&&i(e,e.aaxis,e.baxis,\"a\",\"b\",a),!0}},{\"../heatmap/convert_column_xyz\":948,\"./has_columns\":898}],909:[function(t,e,r){\"use strict\";var n=t(\"../scattergeo/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../plots/attributes\"),s=t(\"../../lib/extend\").extendFlat,l=n.marker.line;e.exports=s({},{locations:{valType:\"data_array\"},locationmode:n.locationmode,z:{valType:\"data_array\"},text:{valType:\"data_array\"},marker:{line:{color:l.color,width:s({},l.width,{dflt:1})}},hoverinfo:s({},o.hoverinfo,{flags:[\"location\",\"z\",\"text\",\"name\"]})},i,{colorbar:a})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scattergeo/attributes\":1064}],910:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){n(e,e.z,\"\",\"z\")}},{\"../../components/colorscale/calc\":609}],911:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/colorscale/defaults\"),a=t(\"./attributes\");e.exports=function(t,e,r,o){function s(r,i){return n.coerce(t,e,a,r,i)}var l,u=s(\"locations\");if(u&&(l=u.length),!u||!l)return void(e.visible=!1);var c=s(\"z\");if(!Array.isArray(c))return void(e.visible=!1);c.length>l&&(e.z=c.slice(0,l)),s(\"locationmode\"),s(\"text\"),s(\"marker.line.color\"),s(\"marker.line.width\"),i(t,e,o,s,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":909}],912:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.location=e.location,t.z=e.z,t}},{}],913:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o=e.hoverinfo,s=\"all\"===o?a.hoverinfo.flags:o.split(\"+\"),l=-1!==s.indexOf(\"name\"),u=-1!==s.indexOf(\"location\"),c=-1!==s.indexOf(\"z\"),h=-1!==s.indexOf(\"text\"),f=!l&&u,d=[];f?t.nameOverride=r.id:(l&&(t.nameOverride=e.name),u&&d.push(r.id)),c&&d.push(function(t){return i.tickText(n,n.c2l(t),\"hover\").text}(r.z)),h&&d.push(r.tx),t.extraText=d.join(\"<br>\")}var i=t(\"../../plots/cartesian/axes\"),a=t(\"./attributes\");e.exports=function(t){var e=t.cd,r=e[0].trace,i=t.subplot,a=i.choroplethHoverPt;if(a){var o=i.projection(a.properties.ct);return t.x0=t.x1=o[0],t.y0=t.y1=o[1],t.index=a.index,t.location=a.id,t.z=a.z,n(t,r,a,i.mockAxis),[t]}}},{\"../../plots/cartesian/axes\":766,\"./attributes\":909}],914:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../heatmap/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.moduleType=\"trace\",n.name=\"choropleth\",n.basePlotModule=t(\"../../plots/geo\"),n.categories=[\"geo\",\"noOpacity\"],n.meta={},e.exports=n},{\"../../plots/geo\":794,\"../heatmap/colorbar\":947,\"./attributes\":909,\"./calc\":910,\"./defaults\":911,\"./event_data\":912,\"./hover\":913,\"./plot\":915}],915:[function(t,e,r){\"use strict\";function n(t,e){for(var r,n=[],i=t.locations,a=i.length,o=u(t,e),s=(t.marker||{}).line||{},l=0;l<a;l++)(r=c(t.locationmode,i[l],o))&&(r.z=t.z[l],void 0!==t.text&&(r.tx=t.text[l]),h(s.color,r,\"mlc\",l),h(s.width,r,\"mlw\",l),r.index=l,n.push(r));return n.length>0&&(n[0].trace=t),n}function i(t){t.framework.selectAll(\"g.trace.choropleth\").each(function(t){var e=t[0].trace,r=a.select(this),n=e.marker||{},i=n.line||{},u=l.makeColorScaleFunc(l.extractScale(e.colorscale,e.zmin,e.zmax));r.selectAll(\"path.choroplethlocation\").each(function(t){a.select(this).attr(\"fill\",function(t){return u(t.z)}).call(o.stroke,t.mlc||i.color).call(s.dashLine,\"\",t.mlw||i.width||0)})})}var a=t(\"d3\"),o=t(\"../../components/color\"),s=t(\"../../components/drawing\"),l=t(\"../../components/colorscale\"),u=t(\"../../lib/topojson_utils\").getTopojsonFeatures,c=t(\"../../lib/geo_location_utils\").locationToFeature,h=t(\"../../lib/array_to_calc_item\"),f=t(\"../../plots/geo/constants\");e.exports=function(t,e,r){function o(t){return t[0].trace.uid}var s,l=t.framework,u=l.select(\"g.choroplethlayer\"),c=l.select(\"g.baselayer\"),h=l.select(\"g.baselayeroverchoropleth\"),d=f.baseLayersOverChoropleth,p=u.selectAll(\"g.trace.choropleth\").data(e,o);p.enter().append(\"g\").attr(\"class\",\"trace choropleth\"),p.exit().remove(),p.each(function(e){var r=e[0].trace,i=n(r,t.topojson),o=a.select(this).selectAll(\"path.choroplethlocation\").data(i);o.enter().append(\"path\").classed(\"choroplethlocation\",!0).on(\"mouseover\",function(e){t.choroplethHoverPt=e}).on(\"mouseout\",function(){t.choroplethHoverPt=null}),o.exit().remove()}),h.selectAll(\"*\").remove();for(var m=0;m<d.length;m++)s=d[m],c.select(\"g.\"+s).remove(),t.drawTopo(h,s,r),t.styleLayer(h,s,r);i(t)}},{\"../../components/color\":603,\"../../components/colorscale\":617,\"../../components/drawing\":627,\"../../lib/array_to_calc_item\":710,\"../../lib/geo_location_utils\":719,\"../../lib/topojson_utils\":747,\"../../plots/geo/constants\":792,d3:121}],916:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/attributes\"),i=t(\"../scatter/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../components/drawing/attributes\").dash,l=t(\"../../plots/font_attributes\"),u=t(\"../../lib/extend\").extendFlat,c=i.line;e.exports=u({},{z:n.z,x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:n.text,transpose:n.transpose,xtype:n.xtype,ytype:n.ytype,connectgaps:n.connectgaps,autocontour:{valType:\"boolean\",dflt:!0,editType:\"docalc\"},ncontours:{valType:\"integer\",dflt:15,min:1,editType:\"docalc\"},contours:{start:{valType:\"number\",dflt:null,editType:\"doplot\"},end:{valType:\"number\",dflt:null,editType:\"doplot\"},size:{valType:\"number\",dflt:null,min:0,editType:\"doplot\"},coloring:{valType:\"enumerated\",values:[\"fill\",\"heatmap\",\"lines\",\"none\"],dflt:\"fill\",editType:\"docalc\"},showlines:{valType:\"boolean\",dflt:!0,editType:\"doplot\"},showlabels:{valType:\"boolean\",dflt:!1,editType:\"doplot\"},labelfont:u({},l,{family:u({},l.family,{editType:\"doplot\"}),size:u({},l.size,{editType:\"doplot\"}),color:u({},l.color,{editType:\"dostyle\"})}),labelformat:{valType:\"string\",dflt:\"\",editType:\"doplot\"}},line:{color:u({},c.color,{}),width:c.width,dash:s,smoothing:u({},c.smoothing,{})}},a,{autocolorscale:u({},a.autocolorscale,{dflt:!1}),zmin:u({},a.zmin,{editType:\"docalc\"}),zmax:u({},a.zmax,{editType:\"docalc\"})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/font_attributes\":790,\"../heatmap/attributes\":944,\"../scatter/attributes\":1027}],917:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"linear\",range:[t,e]};return i.autoTicks(n,(e-t)/(r||15)),n}var i=t(\"../../plots/cartesian/axes\"),a=t(\"../../lib\").extendFlat,o=t(\"../heatmap/calc\");e.exports=function(t,e){var r=o(t,e),s=e.contours;if(!1!==e.autocontour){var l=n(e.zmin,e.zmax,e.ncontours);s.size=l.dtick,s.start=i.tickFirst(l),l.range.reverse(),s.end=i.tickFirst(l),s.start===e.zmin&&(s.start+=s.size),s.end===e.zmax&&(s.end-=s.size),s.start>s.end&&(s.start=s.end=(s.start+s.end)/2),e._input.contours||(e._input.contours={}),a(e._input.contours,{start:s.start,end:s.end,size:s.size}),e._input.autocontour=!0}else{var u=s.start,c=s.end,h=e._input.contours;if(u>c&&(s.start=h.start=c,c=s.end=h.end=u,u=s.start),!(s.size>0)){var f;f=u===c?1:n(u,c,e.ncontours).dtick,h.size=s.size=f}}return r}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../heatmap/calc\":945}],918:[function(t,e,r){\"use strict\";var n=t(\"../../plots/plots\"),i=t(\"../../components/colorbar/draw\"),a=t(\"./make_color_map\"),o=t(\"./end_plus\");e.exports=function(t,e){var r=e[0].trace,s=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+s).remove(),!r.showscale)return void n.autoMargin(t,s);var l=i(t,s);e[0].t.cb=l;var u=r.contours,c=r.line,h=u.size||1,f=u.coloring,d=a(r,{isColorbar:!0});\"heatmap\"===f&&l.filllevels({start:r.zmin,end:r.zmax,size:(r.zmax-r.zmin)/254}),l.fillcolor(\"fill\"===f||\"heatmap\"===f?d:\"\").line({color:\"lines\"===f?d:c.color,width:!1!==u.showlines?c.width:0,dash:c.dash}).levels({start:u.start,end:o(u),size:h}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../plots/plots\":829,\"./end_plus\":922,\"./make_color_map\":926}],919:[function(t,e,r){\"use strict\";e.exports={BOTTOMSTART:[1,9,13,104,713],TOPSTART:[4,6,7,104,713],LEFTSTART:[8,12,14,208,1114],RIGHTSTART:[2,3,11,208,1114],NEWDELTA:[null,[-1,0],[0,-1],[-1,0],[1,0],null,[0,-1],[-1,0],[0,1],[0,1],null,[0,1],[1,0],[1,0],[0,-1]],CHOOSESADDLE:{104:[4,1],208:[2,8],713:[7,13],1114:[11,14]},SADDLEREMAINDER:{1:4,2:8,4:1,7:13,8:2,11:14,13:7,14:11},LABELDISTANCE:2,LABELINCREASE:10,LABELMIN:3,LABELMAX:10,LABELOPTIMIZER:{EDGECOST:1,ANGLECOST:1,NEIGHBORCOST:5,SAMELEVELFACTOR:10,SAMELEVELDISTANCE:5,MAXCOST:100,INITIALSEARCHPOINTS:10,ITERATIONS:5}}},{}],920:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){var a,o=n.coerce2(t,e,i,\"contours.start\"),s=n.coerce2(t,e,i,\"contours.end\"),l=!1===o||!1===s,u=r(\"contours.size\");!(a=l?e.autocontour=!0:r(\"autocontour\",!1))&&u||r(\"ncontours\")}},{\"../../lib\":725,\"./attributes\":916}],921:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../heatmap/has_columns\"),a=t(\"../heatmap/xyz_defaults\"),o=t(\"./contours_defaults\"),s=t(\"./style_defaults\"),l=t(\"./attributes\");e.exports=function(t,e,r,u){function c(r,i){return n.coerce(t,e,l,r,i)}if(!a(t,e,c,u))return void(e.visible=!1);c(\"text\"),c(\"connectgaps\",i(e)),o(t,e,c),s(t,e,c,u)}},{\"../../lib\":725,\"../heatmap/has_columns\":951,\"../heatmap/xyz_defaults\":959,\"./attributes\":916,\"./contours_defaults\":920,\"./style_defaults\":930}],922:[function(t,e,r){\"use strict\";e.exports=function(t){return t.end+t.size/1e6}},{}],923:[function(t,e,r){\"use strict\";function n(t,e,r,n){return Math.abs(t[0]-e[0])<r&&Math.abs(t[1]-e[1])<n}function i(t,e){var r=t[2]-e[2],n=t[3]-e[3];return Math.sqrt(r*r+n*n)}function a(t,e,r,a,c){function h(t){return g[t%g.length]}var f,d=e.join(\",\"),p=d,m=t.crossings[p],v=o(m,r,e),g=[s(t,e,[-v[0],-v[1]])],y=v.join(\",\"),b=t.z.length,x=t.z[0].length;for(f=0;f<1e4;f++){if(m>20?(m=u.CHOOSESADDLE[m][(v[0]||v[1])<0?0:1],t.crossings[p]=u.SADDLEREMAINDER[m]):delete t.crossings[p],!(v=u.NEWDELTA[m])){l.log(\"Found bad marching index:\",m,e,t.level);break}g.push(s(t,e,v)),e[0]+=v[0],e[1]+=v[1],n(g[g.length-1],g[g.length-2],a,c)&&g.pop(),p=e.join(\",\");var _=v[0]&&(e[0]<0||e[0]>x-2)||v[1]&&(e[1]<0||e[1]>b-2);if(p===d&&v.join(\",\")===y||r&&_)break;m=t.crossings[p]}1e4===f&&l.log(\"Infinite loop in contour?\");var w,M,k,A,T,S,E,L=n(g[0],g[g.length-1],a,c),C=0,z=.2*t.smoothing,I=[],D=0;for(f=1;f<g.length;f++)E=i(g[f],g[f-1]),C+=E,I.push(E);var P=C/I.length*z;for(f=g.length-2;f>=D;f--)if((w=I[f])<P){for(k=0,M=f-1;M>=D&&w+I[M]<P;M--)w+=I[M];if(L&&f===g.length-2)for(k=0;k<M&&w+I[k]<P;k++)w+=I[k];T=f-M+k+1,S=Math.floor((f+M+k+2)/2),A=L||f!==g.length-2?L||-1!==M?T%2?h(S):[(h(S)[0]+h(S+1)[0])/2,(h(S)[1]+h(S+1)[1])/2]:g[0]:g[g.length-1],g.splice(M+1,f-M+1,A),f=M+1,k&&(D=k),L&&(f===g.length-2?g[k]=g[g.length-1]:0===f&&(g[g.length-1]=g[0]))}for(g.splice(0,D),f=0;f<g.length;f++)g[f].length=2;if(!(g.length<2))if(L)g.pop(),t.paths.push(g);else{r||l.log(\"Unclosed interior contour?\",t.level,d,g.join(\"L\"));var O=!1;t.edgepaths.forEach(function(e,r){if(!O&&n(e[0],g[g.length-1],a,c)){g.pop(),O=!0;var i=!1;t.edgepaths.forEach(function(e,o){!i&&n(e[e.length-1],g[0],a,c)&&(i=!0,g.splice(0,1),t.edgepaths.splice(r,1),o===r?t.paths.push(g.concat(e)):t.edgepaths[o]=t.edgepaths[o].concat(g,e))}),i||(t.edgepaths[r]=g.concat(e))}}),t.edgepaths.forEach(function(e,r){!O&&n(e[e.length-1],g[0],a,c)&&(g.splice(0,1),t.edgepaths[r]=e.concat(g),O=!0)}),O||t.edgepaths.push(g)}}function o(t,e,r){var n=0,i=0;return t>20&&e?208===t||1114===t?n=0===r[0]?1:-1:i=0===r[1]?1:-1:-1!==u.BOTTOMSTART.indexOf(t)?i=1:-1!==u.LEFTSTART.indexOf(t)?n=1:-1!==u.TOPSTART.indexOf(t)?i=-1:n=-1,[n,i]}function s(t,e,r){var n=e[0]+Math.max(r[0],0),i=e[1]+Math.max(r[1],0),a=t.z[i][n],o=t.xaxis,s=t.yaxis;if(r[1]){var l=(t.level-a)/(t.z[i][n+1]-a);return[o.c2p((1-l)*t.x[n]+l*t.x[n+1],!0),s.c2p(t.y[i],!0),n+l,i]}var u=(t.level-a)/(t.z[i+1][n]-a);return[o.c2p(t.x[n],!0),s.c2p((1-u)*t.y[i]+u*t.y[i+1],!0),n,i+u]}var l=t(\"../../lib\"),u=t(\"./constants\");e.exports=function(t,e,r){var n,i,o,s,u;for(e=e||.01,r=r||.01,o=0;o<t.length;o++){for(s=t[o],u=0;u<s.starts.length;u++)i=s.starts[u],a(s,i,\"edge\",e,r);for(n=0;Object.keys(s.crossings).length&&n<1e4;)n++,i=Object.keys(s.crossings)[0].split(\",\").map(Number),a(s,i,void 0,e,r);1e4===n&&l.log(\"Infinite loop in contour?\")}}},{\"../../lib\":725,\"./constants\":919}],924:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/hover\");e.exports=function(t,e,r,i){return n(t,e,r,i,!0)}},{\"../heatmap/hover\":952}],925:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\").plot,n.style=t(\"./style\"),n.colorbar=t(\"./colorbar\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"contour\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"contour\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":916,\"./calc\":917,\"./colorbar\":918,\"./defaults\":921,\"./hover\":924,\"./plot\":928,\"./style\":929}],926:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/colorscale\"),a=t(\"./end_plus\");e.exports=function(t){var e=t.contours,r=e.start,o=a(e),s=e.size||1,l=Math.floor((o-r)/s)+1,u=\"lines\"===e.coloring?0:1;isFinite(s)||(s=1,l=1);var c,h,f=t.colorscale,d=f.length,p=new Array(d),m=new Array(d);if(\"heatmap\"===e.coloring){for(t.zauto&&!1===t.autocontour&&(t.zmin=r-s/2,t.zmax=t.zmin+l*s),h=0;h<d;h++)c=f[h],p[h]=c[0]*(t.zmax-t.zmin)+t.zmin,m[h]=c[1];var v=n.extent([t.zmin,t.zmax,e.start,e.start+s*(l-1)]),g=v[t.zmin<t.zmax?0:1],y=v[t.zmin<t.zmax?1:0];g!==t.zmin&&(p.splice(0,0,g),m.splice(0,0,Range[0])),y!==t.zmax&&(p.push(y),m.push(m[m.length-1]))}else for(h=0;h<d;h++)c=f[h],p[h]=(c[0]*(l+u-1)-u/2)*s+r,m[h]=c[1];return i.makeColorScaleFunc({domain:p,range:m},{noNumericCheck:!0})}},{\"../../components/colorscale\":617,\"./end_plus\":922,d3:121}],927:[function(t,e,r){\"use strict\";function n(t,e){var r=(e[0][0]>t?0:1)+(e[0][1]>t?0:2)+(e[1][1]>t?0:4)+(e[1][0]>t?0:8);if(5===r||10===r){return t>(e[0][0]+e[0][1]+e[1][0]+e[1][1])/4?5===r?713:1114:5===r?104:208}return 15===r?0:r}var i=t(\"./constants\");e.exports=function(t){var e,r,a,o,s,l,u,c,h,f=t[0].z,d=f.length,p=f[0].length,m=2===d||2===p;for(r=0;r<d-1;r++)for(o=[],0===r&&(o=o.concat(i.BOTTOMSTART)),r===d-2&&(o=o.concat(i.TOPSTART)),e=0;e<p-1;e++)for(a=o.slice(),0===e&&(a=a.concat(i.LEFTSTART)),e===p-2&&(a=a.concat(i.RIGHTSTART)),s=e+\",\"+r,l=[[f[r][e],f[r][e+1]],[f[r+1][e],f[r+1][e+1]]],h=0;h<t.length;h++)c=t[h],(u=n(c.level,l))&&(c.crossings[s]=u,-1!==a.indexOf(u)&&(c.starts.push([e,r]),m&&-1!==a.indexOf(u,a.indexOf(u)+1)&&c.starts.push([e,r])))}},{\"./constants\":919}],928:[function(t,e,r){\"use strict\";function n(t,e,n){var s=n[0].trace,u=n[0].x,h=n[0].y,f=s.contours,d=s.uid,p=e.xaxis,m=e.yaxis,v=t._fullLayout,g=\"contour\"+d,_=i(f,e,n[0]);if(!0!==s.visible)return v._paper.selectAll(\".\"+g+\",.hm\"+d).remove(),void v._infolayer.selectAll(\".cb\"+d).remove();\"heatmap\"===f.coloring?(s.zauto&&!1===s.autocontour&&(s._input.zmin=s.zmin=f.start-f.size/2,s._input.zmax=s.zmax=s.zmin+_.length*f.size),y(t,e,[n])):(v._paper.selectAll(\".hm\"+d).remove(),v._infolayer.selectAll(\"g.rangeslider-container\").selectAll(\".hm\"+d).remove()),b(_),x(_);var w=p.c2p(u[0],!0),M=p.c2p(u[u.length-1],!0),k=m.c2p(h[0],!0),A=m.c2p(h[h.length-1],!0),T=[[w,A],[M,A],[M,k],[w,k]],S=r.makeContourGroup(e,n,g);a(S,T,f),o(S,_,T,f),l(S,_,t,n[0],f,T),c(S,e,v._defs,n[0],T)}function i(t,e,r){for(var n=t.size,i=[],a=_(t),o=t.start;o<a;o+=n)if(i.push({level:o,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:e.xaxis,yaxis:e.yaxis,x:r.x,y:r.y,z:r.z,smoothing:r.trace.line.smoothing}),i.length>1e3){d.warn(\"Too many contours, clipping at 1000\",t);break}return i}function a(t,e,r){var n=t.selectAll(\"g.contourbg\").data([0]);n.enter().append(\"g\").classed(\"contourbg\",!0);var i=n.selectAll(\"path\").data(\"fill\"===r.coloring?[0]:[]);i.enter().append(\"path\"),i.exit().remove(),i.attr(\"d\",\"M\"+e.join(\"L\")+\"Z\").style(\"stroke\",\"none\")}function o(t,e,r,n){var i=t.selectAll(\"g.contourfill\").data([0]);i.enter().append(\"g\").classed(\"contourfill\",!0);var a=i.selectAll(\"path\").data(\"fill\"===n.coloring?e:[]);a.enter().append(\"path\"),a.exit().remove(),a.each(function(t){var e=s(t,r);e?f.select(this).attr(\"d\",e).style(\"stroke\",\"none\"):f.select(this).remove()})}function s(t,e){function r(t){return Math.abs(t[0]-e[2][0])<.01}for(var n,i,a,o,s,l,u=Math.min(t.z[0][0],t.z[0][1]),c=t.edgepaths.length||u<=t.level?\"\":\"M\"+e.join(\"L\")+\"Z\",h=0,f=t.edgepaths.map(function(t,e){return e}),m=!0;f.length;){for(l=p.smoothopen(t.edgepaths[h],t.smoothing),c+=m?l:l.replace(/^M/,\"L\"),f.splice(f.indexOf(h),1),n=t.edgepaths[h][t.edgepaths[h].length-1],o=-1,a=0;a<4;a++){if(!n){d.log(\"Missing end?\",h,t);break}for(!function(t){return Math.abs(t[1]-e[0][1])<.01}(n)||r(n)?!function(t){return Math.abs(t[0]-e[0][0])<.01}(n)?!function(t){return Math.abs(t[1]-e[2][1])<.01}(n)?r(n)&&(i=e[2]):i=e[3]:i=e[0]:i=e[1],s=0;s<t.edgepaths.length;s++){var v=t.edgepaths[s][0];Math.abs(n[0]-i[0])<.01?Math.abs(n[0]-v[0])<.01&&(v[1]-n[1])*(i[1]-v[1])>=0&&(i=v,o=s):Math.abs(n[1]-i[1])<.01?Math.abs(n[1]-v[1])<.01&&(v[0]-n[0])*(i[0]-v[0])>=0&&(i=v,o=s):d.log(\"endpt to newendpt is not vert. or horz.\",n,i,v)}if(n=i,o>=0)break;c+=\"L\"+i}if(o===t.edgepaths.length){d.log(\"unclosed perimeter path\");break}h=o,m=-1===f.indexOf(h),m&&(h=f[0],c+=\"Z\")}for(h=0;h<t.paths.length;h++)c+=p.smoothclosed(t.paths[h],t.smoothing);return c}function l(t,e,n,i,a,o){var s=t.selectAll(\"g.contourlines\").data([0]);s.enter().append(\"g\").classed(\"contourlines\",!0);var l=!1!==a.showlines,u=a.showlabels,c=l&&u,h=r.createLines(s,l||u,e),m=r.createLineClip(s,c,n._fullLayout._defs,i.trace.uid),v=t.selectAll(\"g.contourlabels\").data(u?[0]:[]);if(v.exit().remove(),v.enter().append(\"g\").classed(\"contourlabels\",!0),u){var g=[o],y=[];d.clearLocationCache();var b=r.labelFormatter(a,i.t.cb,n._fullLayout),x=p.tester.append(\"text\").attr(\"data-notex\",1).call(p.font,a.labelfont),_=e[0].xaxis._length,M=e[0].yaxis._length,k={left:Math.max(o[0][0],0),right:Math.min(o[2][0],_),top:Math.max(o[0][1],0),bottom:Math.min(o[2][1],M)};k.middle=(k.top+k.bottom)/2,k.center=(k.left+k.right)/2;var A=Math.sqrt(_*_+M*M),T=w.LABELDISTANCE*A/Math.max(1,e.length/w.LABELINCREASE);h.each(function(t){var e=r.calcTextOpts(t.level,b,x,n);f.select(this).selectAll(\"path\").each(function(){var t=this,n=d.getVisibleSegment(t,k,e.height/2);if(n&&!(n.len<(e.width+e.height)*w.LABELMIN))for(var i=Math.min(Math.ceil(n.len/T),w.LABELMAX),a=0;a<i;a++){var o=r.findBestTextLocation(t,n,e,y,k);if(!o)break;r.addLabelData(o,e,y,g)}})}),x.remove(),r.drawLabels(v,y,n,m,c?g:null)}u&&!l&&h.remove()}function u(t,e,r,n){var i=e.width/2,a=e.height/2,o=t.x,s=t.y,l=t.theta,u=Math.cos(l)*i,c=Math.sin(l)*i,h=(o>n.center?n.right-o:o-n.left)/(u+Math.abs(Math.sin(l)*a)),f=(s>n.middle?n.bottom-s:s-n.top)/(Math.abs(c)+Math.cos(l)*a);if(h<1||f<1)return 1/0;var p=M.EDGECOST*(1/(h-1)+1/(f-1));p+=M.ANGLECOST*l*l;for(var m=o-u,v=s-c,g=o+u,y=s+c,b=0;b<r.length;b++){var x=r[b],_=Math.cos(x.theta)*x.width/2,w=Math.sin(x.theta)*x.width/2,k=2*d.segmentDistance(m,v,g,y,x.x-_,x.y-w,x.x+_,x.y+w)/(e.height+x.height),A=x.level===e.level,T=A?M.SAMELEVELDISTANCE:1;if(k<=T)return 1/0;p+=M.NEIGHBORCOST*(A?M.SAMELEVELFACTOR:1)/(k-T)}return p}function c(t,e,r,n,i){var a=\"clip\"+n.trace.uid,o=r.select(\".clips\").selectAll(\"#\"+a).data(n.trace.connectgaps?[]:[0]);if(o.enter().append(\"clipPath\").classed(\"contourclip\",!0).attr(\"id\",a),o.exit().remove(),!1===n.trace.connectgaps){var l={level:.9,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:e.xaxis,yaxis:e.yaxis,x:n.x,y:n.y,z:h(n),smoothing:0};b([l]),x([l]);var u=s(l,i),c=o.selectAll(\"path\").data([0]);c.enter().append(\"path\"),c.attr(\"d\",u)}else a=null;t.call(p.setClipUrl,a),e.plot.selectAll(\".hm\"+n.trace.uid).call(p.setClipUrl,a)}function h(t){var e,r,n=t.trace._emptypoints,i=[],a=t.z.length,o=t.z[0].length,s=[];for(e=0;e<o;e++)s.push(1);for(e=0;e<a;e++)i.push(s.slice());for(e=0;e<n.length;e++)r=n[e],i[r[0]][r[1]]=0;return t.zmask=i,i}var f=t(\"d3\"),d=t(\"../../lib\"),p=t(\"../../components/drawing\"),m=t(\"../../lib/svg_text_utils\"),v=t(\"../../plots/cartesian/axes\"),g=t(\"../../plots/cartesian/set_convert\"),y=t(\"../heatmap/plot\"),b=t(\"./make_crossings\"),x=t(\"./find_all_paths\"),_=t(\"./end_plus\"),w=t(\"./constants\"),M=w.LABELOPTIMIZER;r.plot=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])},r.makeContourGroup=function(t,e,r){var n=t.plot.select(\".maplayer\").selectAll(\"g.contour.\"+r).data(e);return n.enter().append(\"g\").classed(\"contour\",!0).classed(r,!0),n.exit().remove(),n},r.createLines=function(t,e,r){var n=r[0].smoothing,i=t.selectAll(\"g.contourlevel\").data(e?r:[]);if(i.exit().remove(),i.enter().append(\"g\").classed(\"contourlevel\",!0),e){var a=i.selectAll(\"path.openline\").data(function(t){return t.pedgepaths||t.edgepaths});a.exit().remove(),a.enter().append(\"path\").classed(\"openline\",!0),a.attr(\"d\",function(t){return p.smoothopen(t,n)}).style(\"stroke-miterlimit\",1).style(\"vector-effect\",\"non-scaling-stroke\");var o=i.selectAll(\"path.closedline\").data(function(t){return t.ppaths||t.paths});o.exit().remove(),o.enter().append(\"path\").classed(\"closedline\",!0),o.attr(\"d\",function(t){return p.smoothclosed(t,n)}).style(\"stroke-miterlimit\",1).style(\"vector-effect\",\"non-scaling-stroke\")}return i},r.createLineClip=function(t,e,r,n){var i=e?\"clipline\"+n:null,a=r.select(\".clips\").selectAll(\"#\"+i).data(e?[0]:[]);return a.exit().remove(),a.enter().append(\"clipPath\").classed(\"contourlineclip\",!0).attr(\"id\",i),p.setClipUrl(t,i),a},r.labelFormatter=function(t,e,r){if(t.labelformat)return f.format(t.labelformat);var n;return e?n=e.axis:(n={type:\"linear\",_separators:\".,\",_id:\"ycontour\",nticks:(t.end-t.start)/t.size,showexponent:\"all\",range:[t.start,t.end]},g(n,r),v.calcTicks(n),n._tmin=null,n._tmax=null),function(t){return v.tickText(n,t).text}},r.calcTextOpts=function(t,e,r,n){var i=e(t);r.text(i).call(m.convertToTspans,n);var a=p.bBox(r.node(),!0);return{text:i,width:a.width,height:a.height,level:t,dy:(a.top+a.bottom)/2}},r.findBestTextLocation=function(t,e,r,n,i){var a,o,s,l,c,h=r.width;e.isClosed?(o=e.len/M.INITIALSEARCHPOINTS,a=e.min+o/2,s=e.max):(o=(e.len-h)/(M.INITIALSEARCHPOINTS+1),a=e.min+o+h/2,s=e.max-(o+h)/2);for(var f=1/0,p=0;p<M.ITERATIONS;p++){for(var m=a;m<s;m+=o){var v=d.getTextLocation(t,e.total,m,h),g=u(v,r,n,i);g<f&&(f=g,c=v,l=m)}if(f>2*M.MAXCOST)break;p&&(o/=2),a=l-o/2,s=a+1.5*o}if(f<=M.MAXCOST)return c},r.addLabelData=function(t,e,r,n){var i=e.width/2,a=e.height/2,o=t.x,s=t.y,l=t.theta,u=Math.sin(l),c=Math.cos(l),h=i*c,f=a*u,d=i*u,p=-a*c,m=[[o-h-f,s-d-p],[o+h-f,s+d-p],[o+h+f,s+d+p],[o-h+f,s-d+p]];r.push({text:e.text,x:o,y:s,dy:e.dy,theta:l,level:e.level,width:e.width,height:e.height}),n.push(m)},r.drawLabels=function(t,e,r,n,i){var a=t.selectAll(\"text\").data(e,function(t){return t.text+\",\"+t.x+\",\"+t.y+\",\"+t.theta});if(a.exit().remove(),a.enter().append(\"text\").attr({\"data-notex\":1,\"text-anchor\":\"middle\"}).each(function(t){var e=t.x+Math.sin(t.theta)*t.dy,n=t.y-Math.cos(t.theta)*t.dy;f.select(this).text(t.text).attr({x:e,y:n,transform:\"rotate(\"+180*t.theta/Math.PI+\" \"+e+\" \"+n+\")\"}).call(m.convertToTspans,r)}),i){for(var o=\"\",s=0;s<i.length;s++)o+=\"M\"+i[s].join(\"L\")+\"Z\";var l=n.selectAll(\"path\").data([0]);l.enter().append(\"path\"),l.attr(\"d\",o)}}},{\"../../components/drawing\":627,\"../../lib\":725,\"../../lib/svg_text_utils\":745,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/set_convert\":783,\"../heatmap/plot\":957,\"./constants\":919,\"./end_plus\":922,\"./find_all_paths\":923,\"./make_crossings\":927,d3:121}],929:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/drawing\"),a=t(\"../heatmap/style\"),o=t(\"./make_color_map\");e.exports=function(t){var e=n.select(t).selectAll(\"g.contour\");e.style(\"opacity\",function(t){return t.trace.opacity}),e.each(function(t){var e=n.select(this),r=t.trace,a=r.contours,s=r.line,l=a.size||1,u=a.start,c=\"constraint\"===a.type,h=!c&&\"lines\"===a.coloring,f=!c&&\"fill\"===a.coloring,d=h||f?o(r):null;e.selectAll(\"g.contourlevel\").each(function(t){n.select(this).selectAll(\"path\").call(i.lineGroupStyle,s.width,h?d(t.level):s.color,s.dash)});var p=a.labelfont;if(e.selectAll(\"g.contourlabels text\").each(function(t){i.font(n.select(this),{family:p.family,size:p.size,color:p.color||(h?d(t.level):s.color)})}),c)e.selectAll(\"g.contourfill path\").style(\"fill\",r.fillcolor);else if(f){var m;e.selectAll(\"g.contourfill path\").style(\"fill\",function(t){return void 0===m&&(m=t.level),d(t.level+.5*l)}),void 0===m&&(m=u),e.selectAll(\"g.contourbg path\").style(\"fill\",d(m-.5*l))}}),a(t)}},{\"../../components/drawing\":627,\"../heatmap/style\":958,\"./make_color_map\":926,d3:121}],930:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/defaults\"),i=t(\"../../lib\");e.exports=function(t,e,r,a,o,s){var l,u=r(\"contours.coloring\"),c=\"\";if(\"fill\"===u&&(l=r(\"contours.showlines\")),!1!==l&&(\"lines\"!==u&&(c=r(\"line.color\",o||\"#000\")),r(\"line.width\",void 0===s?.5:s),r(\"line.dash\")),r(\"line.smoothing\"),\"none\"!==u&&n(t,e,a,r,{prefix:\"\",cLetter:\"z\"}),r(\"contours.showlabels\")){var h=a.font;i.coerceFont(r,\"contours.labelfont\",{family:h.family,size:h.size,color:c}),r(\"contours.labelformat\")}}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725}],931:[function(t,e,r){\"use strict\";var n=t(\"../heatmap/attributes\"),i=t(\"../contour/attributes\"),a=i.contours,o=t(\"../scatter/attributes\"),s=t(\"../../components/colorscale/attributes\"),l=t(\"../../components/colorbar/attributes\"),u=t(\"../../lib/extend\").extendFlat,c=o.line,h=t(\"./constants\");e.exports=u({},{carpet:{valType:\"string\"},z:n.z,a:n.x,a0:n.x0,da:n.dx,b:n.y,b0:n.y0,db:n.dy,text:n.text,transpose:n.transpose,atype:n.xtype,btype:n.ytype,mode:{valType:\"flaglist\",flags:[\"lines\",\"fill\"],extras:[\"none\"]},connectgaps:n.connectgaps,fillcolor:{valType:\"color\"},autocontour:i.autocontour,ncontours:i.ncontours,contours:{type:{valType:\"enumerated\",values:[\"levels\",\"constraint\"],dflt:\"levels\",editType:\"docalc\"},start:a.start,end:a.end,size:a.size,coloring:{valType:\"enumerated\",values:[\"fill\",\"lines\",\"none\"],dflt:\"fill\",editType:\"docalc\"},showlines:a.showlines,showlabels:a.showlabels,labelfont:a.labelfont,labelformat:a.labelformat,operation:{valType:\"enumerated\",values:[].concat(h.INEQUALITY_OPS).concat(h.INTERVAL_OPS).concat(h.SET_OPS),dflt:\"=\",editType:\"docalc\"},value:{valType:\"any\",dflt:0,editType:\"docalc\"}},line:{color:u({},c.color,{}),width:c.width,dash:c.dash,smoothing:u({},c.smoothing,{})}},s,{autocolorscale:u({},s.autocolorscale,{dflt:!1})},{colorbar:l})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../contour/attributes\":916,\"../heatmap/attributes\":944,\"../scatter/attributes\":1027,\"./constants\":934}],932:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"linear\",range:[t,e]};return o.autoTicks(n,(e-t)/(r||15)),n}function i(t,e){function r(t){A=e._input.zsmooth=e.zsmooth=!1,a.notifier(\"cannot fast-zsmooth: \"+t)}var n,i,o,s,g,y,b,x,_=e.carpetTrace,w=_.aaxis,M=_.baxis,k=l.traceIs(e,\"contour\"),A=k?\"best\":e.zsmooth;if(w._minDtick=0,M._minDtick=0,c(e)&&h(e,w,M,\"a\",\"b\",[\"z\"]),n=e.a?w.makeCalcdata(e,\"a\"):[],s=e.b?M.makeCalcdata(e,\"b\"):[],i=e.a0||0,o=e.da||1,g=e.b0||0,y=e.db||1,b=f(e.z,e.transpose),e._emptypoints=m(b),e._interpz=p(b,e._emptypoints,e._interpz),\"fast\"===A)if(\"log\"===w.type||\"log\"===M.type)r(\"log axis found\");else{if(n.length){var T=(n[n.length-1]-n[0])/(n.length-1),S=Math.abs(T/100);for(x=0;x<n.length-1;x++)if(Math.abs(n[x+1]-n[x]-T)>S){r(\"a scale is not linear\");break}}if(s.length&&\"fast\"===A){var E=(s[s.length-1]-s[0])/(s.length-1),L=Math.abs(E/100);for(x=0;x<s.length-1;x++)if(Math.abs(s[x+1]-s[x]-E)>L){r(\"b scale is not linear\");break}}}var C=d(b),z=\"scaled\"===e.xtype?\"\":n,I=v(e,z,i,o,C,w),D=\"scaled\"===e.ytype?\"\":s,P=v(e,D,g,y,b.length,M),O={a:I,b:P,z:b};return\"levels\"===e.contours.type&&u(e,b,\"\",\"z\"),[O]}var a=t(\"../../lib\"),o=t(\"../../plots/cartesian/axes\"),s=t(\"../../lib\").extendFlat,l=t(\"../../registry\"),u=t(\"../../components/colorscale/calc\"),c=t(\"../heatmap/has_columns\"),h=t(\"../heatmap/convert_column_xyz\"),f=t(\"../heatmap/clean_2d_array\"),d=t(\"../heatmap/max_row_length\"),p=t(\"../heatmap/interp2d\"),m=t(\"../heatmap/find_empties\"),v=t(\"../heatmap/make_bound_array\"),g=t(\"./defaults\"),y=t(\"../carpet/lookup_carpetid\");e.exports=function(t,e){var r=e.carpetTrace=y(t,e);if(r&&r.visible&&\"legendonly\"!==r.visible){if(!e.a||!e.b){var a=t.data[r.index],l=t.data[e.index];l.a||(l.a=a.a),l.b||(l.b=a.b),g(l,e,e._defaultColor,t._fullLayout)}var u=i(t,e),c=e.contours;if(!0===e.autocontour){var h=n(e.zmin,e.zmax,e.ncontours);c.size=h.dtick,c.start=o.tickFirst(h),h.range.reverse(),c.end=o.tickFirst(h),c.start===e.zmin&&(c.start+=c.size),c.end===e.zmax&&(c.end-=c.size),c.start>c.end&&(c.start=c.end=(c.start+c.end)/2),e._input.contours=s({},c)}else{var f=c.start,d=c.end,p=e._input.contours;if(f>d&&(c.start=p.start=d,d=c.end=p.end=f,f=c.start),!(c.size>0)){var m;m=f===d?1:n(f,d,e.ncontours).dtick,p.size=c.size=m}}return u}}},{\"../../components/colorscale/calc\":609,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../carpet/lookup_carpetid\":900,\"../heatmap/clean_2d_array\":946,\"../heatmap/convert_column_xyz\":948,\"../heatmap/find_empties\":950,\"../heatmap/has_columns\":951,\"../heatmap/interp2d\":954,\"../heatmap/make_bound_array\":955,\"../heatmap/max_row_length\":956,\"./defaults\":938}],933:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){var i,a,o,s=n.a.length,l=n.b.length,u=n.z,c=-1/0,h=1/0;for(i=0;i<l;i++)h=Math.min(h,u[i][0]),h=Math.min(h,u[i][s-1]),c=Math.max(c,u[i][0]),c=Math.max(c,u[i][s-1]);for(i=1;i<s-1;i++)h=Math.min(h,u[0][i]),h=Math.min(h,u[l-1][i]),c=Math.max(c,u[0][i]),c=Math.max(c,u[l-1][i]);switch(e){case\">\":case\">=\":n.contours.value>c&&(t[0].prefixBoundary=!0);break;case\"<\":case\"<=\":n.contours.value<h&&(t[0].prefixBoundary=!0);break;case\"[]\":case\"()\":a=Math.min.apply(null,n.contours.value),o=Math.max.apply(null,n.contours.value),o<h&&(t[0].prefixBoundary=!0),a>c&&(t[0].prefixBoundary=!0);break;case\"][\":case\")(\":a=Math.min.apply(null,n.contours.value),o=Math.max.apply(null,n.contours.value),a<h&&o>c&&(t[0].prefixBoundary=!0)}}},{}],934:[function(t,e,r){\"use strict\";e.exports={INEQUALITY_OPS:[\"=\",\"<\",\">=\",\">\",\"<=\"],INTERVAL_OPS:[\"[]\",\"()\",\"[)\",\"(]\",\"][\",\")(\",\"](\",\")[\"],SET_OPS:[\"{}\",\"}{\"]}},{}],935:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return s(t)?+t:null}var n,i=Array.isArray(e);return-1!==o.INEQUALITY_OPS.indexOf(t)?n=r(i?e[0]:e):-1!==o.INTERVAL_OPS.indexOf(t)?n=i?[r(e[0]),r(e[1])]:[r(e),r(e)]:-1!==o.SET_OPS.indexOf(t)&&(n=i?e.map(r):[r(e)]),n}function i(t){return function(e){e=n(t,e);var r=Math.min(e[0],e[1]),i=Math.max(e[0],e[1]);return{start:r,end:i,size:i-r}}}function a(t){return function(e){return e=n(t,e),{start:e,end:1/0,size:1/0}}}var o=t(\"./constants\"),s=t(\"fast-isnumeric\");e.exports[\"[]\"]=i(\"[]\"),e.exports[\"()\"]=i(\"()\"),e.exports[\"[)\"]=i(\"[)\"),e.exports[\"(]\"]=i(\"(]\"),e.exports[\"][\"]=i(\"][\"),e.exports[\")(\"]=i(\")(\"),e.exports[\")[\"]=i(\")[\"),e.exports[\"](\"]=i(\"](\"),e.exports[\">\"]=a(\">\"),e.exports[\">=\"]=a(\">=\"),e.exports[\"<\"]=a(\"<\"),e.exports[\"<=\"]=a(\"<=\"),e.exports[\"=\"]=a(\"=\")},{\"./constants\":934,\"fast-isnumeric\":130}],936:[function(t,e,r){\"use strict\";var n=t(\"./constraint_mapping\"),i=t(\"fast-isnumeric\");e.exports=function(t,e){var r;-1===[\"=\",\"<\",\"<=\",\">\",\">=\"].indexOf(e.operation)?(t(\"contours.value\",[0,1]),Array.isArray(e.value)?e.value.length>2?e.value=e.value.slice(2):0===e.length?e.value=[0,1]:e.length<2?(r=parseFloat(e.value[0]),e.value=[r,r+1]):e.value=[parseFloat(e.value[0]),parseFloat(e.value[1])]:i(e.value)&&(r=parseFloat(e.value),\n",
       "e.value=[r,r+1])):(t(\"contours.value\",0),i(e.value)||(Array.isArray(e.value)?e.value=parseFloat(e.value[0]):e.value=0));var a=n[e.operation](e.value);e.start=a.start,e.end=a.end,e.size=a.size}},{\"./constraint_mapping\":935,\"fast-isnumeric\":130}],937:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){var r,i,a,o=function(t){return t.reverse()},s=function(t){return t};switch(e){case\"][\":case\")[\":case\"](\":case\")(\":var l=o;o=s,s=l;case\"[]\":case\"[)\":case\"(]\":case\"()\":if(2!==t.length)return void n.warn(\"Contour data invalid for the specified inequality range operation.\");for(i=t[0],a=t[1],r=0;r<i.edgepaths.length;r++)i.edgepaths[r]=o(i.edgepaths[r]);for(r=0;r<i.paths.length;r++)i.paths[r]=o(i.paths[r]);for(;a.edgepaths.length;)i.edgepaths.push(s(a.edgepaths.shift()));for(;a.paths.length;)i.paths.push(s(a.paths.shift()));t.pop();break;case\">=\":case\">\":if(1!==t.length)return void n.warn(\"Contour data invalid for the specified inequality operation.\");for(i=t[0],r=0;r<i.edgepaths.length;r++)i.edgepaths[r]=o(i.edgepaths[r]);for(r=0;r<i.paths.length;r++)i.paths[r]=o(i.paths[r])}}},{\"../../lib\":725}],938:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../heatmap/xyz_defaults\"),a=t(\"./attributes\"),o=t(\"../contour/style_defaults\"),s=t(\"../scatter/fillcolor_defaults\"),l=t(\"../../plots/attributes\"),u=t(\"./constraint_value_defaults\"),c=t(\"../../components/color\").addOpacity;e.exports=function(t,e,r,h){function f(r,i){return n.coerce(t,e,a,r,i)}if(f(\"carpet\"),t.a&&t.b){var d,p,m,v,g;if(!i(t,e,f,h,\"a\",\"b\"))return void(e.visible=!1);f(\"text\"),f(\"contours.type\");var y=e.contours;if(\"constraint\"===y.type){f(\"contours.operation\"),u(f,y),n.coerce(t,e,l,\"showlegend\",!0),f(\"contours.coloring\",\"=\"===y.operation?\"lines\":\"fill\"),f(\"contours.showlines\",!0),\"=\"===y.operation&&(y.coloring=\"lines\"),s(t,e,r,f);var b=e.fillcolor?c(e.fillcolor,1):r;o(t,e,f,h,b,2),\"=\"===y.operation&&(f(\"line.color\",r),\"fill\"===y.coloring&&(y.coloring=\"lines\"),\"lines\"===y.coloring&&delete e.fillcolor),delete e.showscale,delete e.autocontour,delete e.autocolorscale,delete e.colorscale,delete e.ncontours,delete e.colorbar,e.line&&(delete e.line.autocolorscale,delete e.line.colorscale,delete e.line.mincolor,delete e.line.maxcolor)}else n.coerce(t,e,l,\"showlegend\",!1),p=n.coerce2(t,e,a,\"contours.start\"),m=n.coerce2(t,e,a,\"contours.end\"),d=f(\"contours.size\"),f(\"contours.coloring\"),v=!1===p||!1===m,g=v?e.autocontour=!0:f(\"autocontour\",!1),!g&&d||f(\"ncontours\"),o(t,e,f,h),delete e.value,delete e.operation}else e._defaultColor=r}},{\"../../components/color\":603,\"../../lib\":725,\"../../plots/attributes\":764,\"../contour/style_defaults\":930,\"../heatmap/xyz_defaults\":959,\"../scatter/fillcolor_defaults\":1034,\"./attributes\":931,\"./constraint_value_defaults\":936}],939:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r){for(var i=t.size,a=[],o=r.trace.carpetTrace,s=t.start;s<t.end+i/10;s+=i)if(a.push({level:s,crossings:{},starts:[],edgepaths:[],paths:[],xaxis:o.aaxis,yaxis:o.baxis,x:r.a,y:r.b,z:r.z,smoothing:r.trace.line.smoothing}),a.length>1e3){n.warn(\"Too many contours, clipping at 1000\",t);break}return a}},{\"../../lib\":725}],940:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../contour/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"../contour/style\"),n.moduleType=\"trace\",n.name=\"contourcarpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"carpet\",\"contour\",\"symbols\",\"showLegend\",\"hasLines\",\"carpetDependent\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../contour/colorbar\":918,\"../contour/style\":929,\"./attributes\":931,\"./calc\":932,\"./defaults\":938,\"./plot\":943}],941:[function(t,e,r){\"use strict\";var n=t(\"../../components/drawing\"),i=t(\"../carpet/axis_aligned_line\"),a=t(\"../../lib\");e.exports=function(t,e,r,o,s,l,u,c){function h(t){return Math.abs(t[1]-r[0][1])<S}function f(t){return Math.abs(t[1]-r[2][1])<S}function d(t){return Math.abs(t[0]-r[0][0])<T}function p(t){return Math.abs(t[0]-r[2][0])<T}function m(t,e){var r,n,a,o,m=\"\";for(h(t)&&!p(t)||f(t)&&!d(t)?(o=s.aaxis,a=i(s,l,[t[0],e[0]],.5*(t[1]+e[1]))):(o=s.baxis,a=i(s,l,.5*(t[0]+e[0]),[t[1],e[1]])),r=1;r<a.length;r++)for(m+=o.smoothing?\"C\":\"L\",n=0;n<a[r].length;n++){var v=a[r][n];m+=[u.c2p(v[0]),c.c2p(v[1])]+\" \"}return m}var v,g,y,b,x,_,w,M=\"\",k=e.edgepaths.map(function(t,e){return e}),A=!0,T=1e-4*Math.abs(r[0][0]-r[2][0]),S=1e-4*Math.abs(r[0][1]-r[2][1]);for(v=0,g=null;k.length;){var E=e.edgepaths[v][0];for(g&&(M+=m(g,E)),w=n.smoothopen(e.edgepaths[v].map(o),e.smoothing),M+=A?w:w.replace(/^M/,\"L\"),k.splice(k.indexOf(v),1),g=e.edgepaths[v][e.edgepaths[v].length-1],x=-1,b=0;b<4;b++){if(!g){a.log(\"Missing end?\",v,e);break}for(h(g)&&!p(g)?y=r[1]:d(g)?y=r[0]:f(g)?y=r[3]:p(g)&&(y=r[2]),_=0;_<e.edgepaths.length;_++){var L=e.edgepaths[_][0];Math.abs(g[0]-y[0])<T?Math.abs(g[0]-L[0])<T&&(L[1]-g[1])*(y[1]-L[1])>=0&&(y=L,x=_):Math.abs(g[1]-y[1])<S?Math.abs(g[1]-L[1])<S&&(L[0]-g[0])*(y[0]-L[0])>=0&&(y=L,x=_):a.log(\"endpt to newendpt is not vert. or horz.\",g,y,L)}if(x>=0)break;M+=m(g,y),g=y}if(x===e.edgepaths.length){a.log(\"unclosed perimeter path\");break}v=x,A=-1===k.indexOf(v),A&&(v=k[0],M+=m(g,y)+\"Z\",g=null)}for(v=0;v<e.paths.length;v++)M+=n.smoothclosed(e.paths[v].map(o),e.smoothing);return M}},{\"../../components/drawing\":627,\"../../lib\":725,\"../carpet/axis_aligned_line\":883}],942:[function(t,e,r){\"use strict\";e.exports=function(t,e){var r,n,i,a,o,s,l,u,c;for(r=0;r<t.length;r++){for(a=t[r],o=a.pedgepaths=[],s=a.ppaths=[],n=0;n<a.edgepaths.length;n++){for(c=a.edgepaths[n],l=[],i=0;i<c.length;i++)l[i]=e(c[i]);o.push(l)}for(n=0;n<a.paths.length;n++){for(c=a.paths[n],u=[],i=0;i<c.length;i++)u[i]=e(c[i]);s.push(u)}}}},{}],943:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){var e=o.ab2xy(t[0],t[1],!0);return[_.c2p(e[0]),T.c2p(e[1])]}var a=r[0].trace,o=a.carpetTrace=k(t,a),s=t.calcdata[o.index][0];if(o.visible&&\"legendonly\"!==o.visible){var l=r[0].a,h=r[0].b,m=a.contours,b=a.uid,_=e.xaxis,T=e.yaxis,S=t._fullLayout,E=\"contour\"+b,L=w(m,e,r[0]),C=\"constraint\"===a.contours.type;if(!0!==a.visible)return void S._infolayer.selectAll(\".cb\"+b).remove();var z=[[l[0],h[h.length-1]],[l[l.length-1],h[h.length-1]],[l[l.length-1],h[0]],[l[0],h[0]]];v(L);var I=1e-8*(l[l.length-1]-l[0]),D=1e-8*(h[h.length-1]-h[0]);g(L,I,D),\"constraint\"===a.contours.type&&(x(L,a.contours.operation),A(L,a.contours.operation,z,a)),M(L,n);var P,O,R,F,j=y.makeContourGroup(e,r,E),N=[];for(F=s.clipsegments.length-1;F>=0;F--)P=s.clipsegments[F],O=f([],P.x,_.c2p),R=f([],P.y,T.c2p),O.reverse(),R.reverse(),N.push(d(O,R,P.bicubic));var B=\"M\"+N.join(\"L\")+\"Z\";u(j,s.clipsegments,_,T,C,m.coloring),c(a,j,_,T,L,z,n,o,s,m.coloring,B),i(j,L,t,r[0],m,e,o),p.setClipUrl(j,o._clipPathId)}}function i(t,e,r,n,i,o,s){var l=t.selectAll(\"g.contourlines\").data([0]);l.enter().append(\"g\").classed(\"contourlines\",!0);var u=!1!==i.showlines,c=i.showlabels,f=u&&c,d=y.createLines(l,u||c,e),v=y.createLineClip(l,f,r._fullLayout._defs,n.trace.uid),g=t.selectAll(\"g.contourlabels\").data(c?[0]:[]);if(g.exit().remove(),g.enter().append(\"g\").classed(\"contourlabels\",!0),c){var x=o.xaxis,_=o.yaxis,w=x._length,M=_._length,k=[[[0,0],[w,0],[w,M],[0,M]]],A=[];m.clearLocationCache();var T=y.labelFormatter(i,n.t.cb,r._fullLayout),S=p.tester.append(\"text\").attr(\"data-notex\",1).call(p.font,i.labelfont),E={left:0,right:w,center:w/2,top:0,bottom:M,middle:M/2},L=Math.sqrt(w*w+M*M),C=b.LABELDISTANCE*L/Math.max(1,e.length/b.LABELINCREASE);d.each(function(t){var e=y.calcTextOpts(t.level,T,S,r);h.select(this).selectAll(\"path\").each(function(r){var n=this,i=m.getVisibleSegment(n,E,e.height/2);if(i&&(a(n,r,t,i,s,e.height),!(i.len<(e.width+e.height)*b.LABELMIN)))for(var o=Math.min(Math.ceil(i.len/C),b.LABELMAX),l=0;l<o;l++){var u=y.findBestTextLocation(n,i,e,A,E);if(!u)break;y.addLabelData(u,e,A,k)}})}),S.remove(),y.drawLabels(g,A,r,v,f?k:null)}c&&!u&&d.remove()}function a(t,e,r,n,i,a){function u(t,e){var r,n=0;return(Math.abs(t[0]-f)<.1||Math.abs(t[0]-d)<.1)&&(r=s(i.dxydb_rough(t[0],t[1],.1)),n=Math.max(n,a*l(e,r)/2)),(Math.abs(t[1]-p)<.1||Math.abs(t[1]-m)<.1)&&(r=s(i.dxyda_rough(t[0],t[1],.1)),n=Math.max(n,a*l(e,r)/2)),n}for(var c,h=0;h<r.pedgepaths.length;h++)e===r.pedgepaths[h]&&(c=r.edgepaths[h]);if(c){var f=i.a[0],d=i.a[i.a.length-1],p=i.b[0],m=i.b[i.b.length-1],v=o(t,0,1),g=o(t,n.total,n.total-1),y=u(c[0],v),b=n.total-u(c[c.length-1],g);n.min<y&&(n.min=y),n.max>b&&(n.max=b),n.len=n.max-n.min}}function o(t,e,r){var n=t.getPointAtLength(e),i=t.getPointAtLength(r),a=i.x-n.x,o=i.y-n.y,s=Math.sqrt(a*a+o*o);return[a/s,o/s]}function s(t){var e=Math.sqrt(t[0]*t[0]+t[1]*t[1]);return[t[0]/e,t[1]/e]}function l(t,e){var r=Math.abs(t[0]*e[0]+t[1]*e[1]);return Math.sqrt(1-r*r)/r}function u(t,e,r,n,i,a){var o,s,l,u,c=t.selectAll(\"g.contourbg\").data([0]);c.enter().append(\"g\").classed(\"contourbg\",!0);var h=c.selectAll(\"path\").data(\"fill\"!==a||i?[]:[0]);h.enter().append(\"path\"),h.exit().remove();var p=[];for(u=0;u<e.length;u++)o=e[u],s=f([],o.x,r.c2p),l=f([],o.y,n.c2p),p.push(d(s,l,o.bicubic));h.attr(\"d\",\"M\"+p.join(\"L\")+\"Z\").style(\"stroke\",\"none\")}function c(t,e,r,n,i,a,o,s,l,u,c){var f=e.selectAll(\"g.contourfill\").data([0]);f.enter().append(\"g\").classed(\"contourfill\",!0);var d=f.selectAll(\"path\").data(\"fill\"===u?i:[]);d.enter().append(\"path\"),d.exit().remove(),d.each(function(e){var i=_(t,e,a,o,s,l,r,n);e.prefixBoundary&&(i=c+i),i?h.select(this).attr(\"d\",i).style(\"stroke\",\"none\"):h.select(this).remove()})}var h=t(\"d3\"),f=t(\"../carpet/map_1d_array\"),d=t(\"../carpet/makepath\"),p=t(\"../../components/drawing\"),m=t(\"../../lib\"),v=t(\"../contour/make_crossings\"),g=t(\"../contour/find_all_paths\"),y=t(\"../contour/plot\"),b=t(\"../contour/constants\"),x=t(\"./convert_to_constraints\"),_=t(\"./join_all_paths\"),w=t(\"./empty_pathinfo\"),M=t(\"./map_pathinfo\"),k=t(\"../carpet/lookup_carpetid\"),A=t(\"./close_boundaries\");e.exports=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])}},{\"../../components/drawing\":627,\"../../lib\":725,\"../carpet/lookup_carpetid\":900,\"../carpet/makepath\":901,\"../carpet/map_1d_array\":902,\"../contour/constants\":919,\"../contour/find_all_paths\":923,\"../contour/make_crossings\":927,\"../contour/plot\":928,\"./close_boundaries\":933,\"./convert_to_constraints\":937,\"./empty_pathinfo\":939,\"./join_all_paths\":941,\"./map_pathinfo\":942,d3:121}],944:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports=o({},{z:{valType:\"data_array\"},x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:{valType:\"data_array\"},transpose:{valType:\"boolean\",dflt:!1},xtype:{valType:\"enumerated\",values:[\"array\",\"scaled\"]},ytype:{valType:\"enumerated\",values:[\"array\",\"scaled\"]},zsmooth:{valType:\"enumerated\",values:[\"fast\",\"best\",!1],dflt:!1},connectgaps:{valType:\"boolean\",dflt:!1},xgap:{valType:\"number\",dflt:0,min:0},ygap:{valType:\"number\",dflt:0,min:0}},i,{autocolorscale:o({},i.autocolorscale,{dflt:!1})},{colorbar:a})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],945:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../histogram2d/calc\"),s=t(\"../../components/colorscale/calc\"),l=t(\"./has_columns\"),u=t(\"./convert_column_xyz\"),c=t(\"./max_row_length\"),h=t(\"./clean_2d_array\"),f=t(\"./interp2d\"),d=t(\"./find_empties\"),p=t(\"./make_bound_array\");e.exports=function(t,e){function r(t){E=e._input.zsmooth=e.zsmooth=!1,i.notifier(\"cannot fast-zsmooth: \"+t)}var m,v,g,y,b,x,_,w,M=a.getFromId(t,e.xaxis||\"x\"),k=a.getFromId(t,e.yaxis||\"y\"),A=n.traceIs(e,\"contour\"),T=n.traceIs(e,\"histogram\"),S=n.traceIs(e,\"gl2d\"),E=A?\"best\":e.zsmooth;if(M._minDtick=0,k._minDtick=0,T){var L=o(t,e);m=L.x,v=L.x0,g=L.dx,y=L.y,b=L.y0,x=L.dy,_=L.z}else l(e)?(u(e,M,k,\"x\",\"y\",[\"z\"]),m=e.x,y=e.y):(m=e.x?M.makeCalcdata(e,\"x\"):[],y=e.y?k.makeCalcdata(e,\"y\"):[]),v=e.x0||0,g=e.dx||1,b=e.y0||0,x=e.dy||1,_=h(e.z,e.transpose),(A||e.connectgaps)&&(e._emptypoints=d(_),e._interpz=f(_,e._emptypoints,e._interpz));if(\"fast\"===E)if(\"log\"===M.type||\"log\"===k.type)r(\"log axis found\");else if(!T){if(m.length){var C=(m[m.length-1]-m[0])/(m.length-1),z=Math.abs(C/100);for(w=0;w<m.length-1;w++)if(Math.abs(m[w+1]-m[w]-C)>z){r(\"x scale is not linear\");break}}if(y.length&&\"fast\"===E){var I=(y[y.length-1]-y[0])/(y.length-1),D=Math.abs(I/100);for(w=0;w<y.length-1;w++)if(Math.abs(y[w+1]-y[w]-I)>D){r(\"y scale is not linear\");break}}}var P=c(_),O=\"scaled\"===e.xtype?\"\":m,R=p(e,O,v,g,P,M),F=\"scaled\"===e.ytype?\"\":y,j=p(e,F,b,x,_.length,k);S||(a.expand(M,R),a.expand(k,j));var N={x:R,y:j,z:_,text:e.text};if(s(e,_,\"\",\"z\"),A&&e.contours&&\"heatmap\"===e.contours.coloring){var B={type:\"contour\"===e.type?\"heatmap\":\"histogram2d\",xcalendar:e.xcalendar,ycalendar:e.ycalendar};N.xfill=p(B,O,v,g,P,M),N.yfill=p(B,F,b,x,_.length,k)}return[N]}},{\"../../components/colorscale/calc\":609,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../registry\":844,\"../histogram2d/calc\":973,\"./clean_2d_array\":946,\"./convert_column_xyz\":948,\"./find_empties\":950,\"./has_columns\":951,\"./interp2d\":954,\"./make_bound_array\":955,\"./max_row_length\":956}],946:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t,e){var r,i,a,o,s,l;if(e){for(r=0,s=0;s<t.length;s++)r=Math.max(r,t[s].length);if(0===r)return!1;a=function(t){return t.length},o=function(t,e,r){return t[r][e]}}else r=t.length,a=function(t,e){return t[e].length},o=function(t,e,r){return t[e][r]};var u=new Array(r);for(s=0;s<r;s++)for(i=a(t,s),u[s]=new Array(i),l=0;l<i;l++)u[s][l]=function(t){if(n(t))return+t}(o(t,s,l));return u}},{\"fast-isnumeric\":130}],947:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.zmin,c=r.zmax;if(n(u)||(u=i.aggNums(Math.min,null,r.z)),n(c)||(c=i.aggNums(Math.max,null,r.z)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var h=e[0].t.cb=s(t,l),f=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});h.fillcolor(f).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],948:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e,r,a,o,s){a=a||\"x\",o=o||\"y\",s=s||[\"z\"];var l,u,c,h,f,d=t[a].slice(),p=t[o].slice(),m=t.text,v=Math.min(d.length,p.length),g=void 0!==m&&!Array.isArray(m[0]),y=t[a+\"calendar\"],b=t[o+\"calendar\"];for(l=0;l<s.length;l++)(c=t[s[l]])&&(v=Math.min(v,c.length));for(v<d.length&&(d=d.slice(0,v)),v<p.length&&(p=p.slice(0,v)),l=0;l<v;l++)d[l]=e.d2c(d[l],0,y),p[l]=r.d2c(p[l],0,b);var x=n.distinctVals(d),_=x.vals,w=n.distinctVals(p),M=w.vals,k=[];for(l=0;l<s.length;l++)k[l]=n.init2dArray(M.length,_.length);var A,T,S;for(g&&(S=n.init2dArray(M.length,_.length)),l=0;l<v;l++)if(d[l]!==i&&p[l]!==i){for(A=n.findBin(d[l]+x.minDiff/2,_),T=n.findBin(p[l]+w.minDiff/2,M),u=0;u<s.length;u++)f=s[u],c=t[f],h=k[u],h[T][A]=c[l];g&&(S[T][A]=m[l])}for(t[a]=_,t[o]=M,u=0;u<s.length;u++)t[s[u]]=k[u];g&&(t.text=S)}},{\"../../constants/numerical\":705,\"../../lib\":725}],949:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./has_columns\"),a=t(\"./xyz_defaults\"),o=t(\"../../components/colorscale/defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,i){return n.coerce(t,e,s,r,i)}if(!a(t,e,u,l))return void(e.visible=!1);u(\"text\"),!1===u(\"zsmooth\")&&(u(\"xgap\"),u(\"ygap\")),u(\"connectgaps\",i(e)&&!1!==e.zsmooth),o(t,e,l,u,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":944,\"./has_columns\":951,\"./xyz_defaults\":959}],950:[function(t,e,r){\"use strict\";var n=t(\"./max_row_length\");e.exports=function(t){var e,r,i,a,o,s,l,u,c=[],h={},f=[],d=t[0],p=[],m=[0,0,0],v=n(t);for(r=0;r<t.length;r++)for(e=p,p=d,d=t[r+1]||[],i=0;i<v;i++)void 0===p[i]&&(s=(void 0!==p[i-1]?1:0)+(void 0!==p[i+1]?1:0)+(void 0!==e[i]?1:0)+(void 0!==d[i]?1:0),s?(0===r&&s++,0===i&&s++,r===t.length-1&&s++,i===p.length-1&&s++,s<4&&(h[[r,i]]=[r,i,s]),c.push([r,i,s])):f.push([r,i]));for(;f.length;){for(l={},u=!1,o=f.length-1;o>=0;o--)a=f[o],r=a[0],i=a[1],(s=((h[[r-1,i]]||m)[2]+(h[[r+1,i]]||m)[2]+(h[[r,i-1]]||m)[2]+(h[[r,i+1]]||m)[2])/20)&&(l[a]=[r,i,s],f.splice(o,1),u=!0);if(!u)throw\"findEmpties iterated with no new neighbors\";for(a in l)h[a]=l[a],c.push(l[a])}return c.sort(function(t,e){return e[2]-t[2]})}},{\"./max_row_length\":956}],951:[function(t,e,r){\"use strict\";e.exports=function(t){return!Array.isArray(t.z[0])}},{}],952:[function(t,e,r){\"use strict\";var n=t(\"../../components/fx\"),i=t(\"../../lib\"),a=n.constants.MAXDIST;e.exports=function(t,e,r,o,s){if(!(t.distance<a)){var l,u,c,h,f=t.cd[0],d=f.trace,p=t.xa,m=t.ya,v=f.x,g=f.y,y=f.z,b=f.zmask,x=v,_=g;if(!1!==t.index){try{c=Math.round(t.index[1]),h=Math.round(t.index[0])}catch(e){return void i.error(\"Error hovering on heatmap, pointNumber must be [row,col], found:\",t.index)}if(c<0||c>=y[0].length||h<0||h>y.length)return}else{if(n.inbox(e-v[0],e-v[v.length-1])>a||n.inbox(r-g[0],r-g[g.length-1])>a)return;if(s){var w;for(x=[2*v[0]-v[1]],w=1;w<v.length;w++)x.push((v[w]+v[w-1])/2);for(x.push([2*v[v.length-1]-v[v.length-2]]),_=[2*g[0]-g[1]],w=1;w<g.length;w++)_.push((g[w]+g[w-1])/2);_.push([2*g[g.length-1]-g[g.length-2]])}c=Math.max(0,Math.min(x.length-2,i.findBin(e,x))),h=Math.max(0,Math.min(_.length-2,i.findBin(r,_)))}var M=p.c2p(v[c]),k=p.c2p(v[c+1]),A=m.c2p(g[h]),T=m.c2p(g[h+1]);s?(k=M,l=v[c],T=A,u=g[h]):(l=(v[c]+v[c+1])/2,u=(g[h]+g[h+1])/2,d.zsmooth&&(M=k=(M+k)/2,A=T=(A+T)/2));var S=y[h][c];b&&!b[h][c]&&(S=void 0);var E;return Array.isArray(f.text)&&Array.isArray(f.text[h])&&(E=f.text[h][c]),[i.extendFlat(t,{index:[h,c],distance:a+10,x0:M,x1:k,y0:A,y1:T,xLabelVal:l,yLabelVal:u,zLabelVal:S,text:E})]}}},{\"../../components/fx\":644,\"../../lib\":725}],953:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.moduleType=\"trace\",n.name=\"heatmap\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./attributes\":944,\"./calc\":945,\"./colorbar\":947,\"./defaults\":949,\"./hover\":952,\"./plot\":957,\"./style\":958}],954:[function(t,e,r){\"use strict\";function n(t){return.5-.25*Math.min(1,.5*t)}function i(t,e,r){var n,i,a,s,l,u,c,h,f,d,p,m,v,g=0;for(s=0;s<e.length;s++){for(n=e[s],i=n[0],a=n[1],p=t[i][a],d=0,f=0,l=0;l<4;l++)u=o[l],(c=t[i+u[0]])&&void 0!==(h=c[a+u[1]])&&(0===d?m=v=h:(m=Math.min(m,h),v=Math.max(v,h)),f++,d+=h);if(0===f)throw\"iterateInterp2d order is wrong: no defined neighbors\";t[i][a]=d/f,void 0===p?f<4&&(g=1):(t[i][a]=(1+r)*t[i][a]-r*p,v>m&&(g=Math.max(g,Math.abs(t[i][a]-p)/(v-m))))}return g}var a=t(\"../../lib\"),o=[[-1,0],[1,0],[0,-1],[0,1]];e.exports=function(t,e,r){var o,s,l=1;if(Array.isArray(r))for(o=0;o<e.length;o++)s=e[o],t[s[0]][s[1]]=r[s[0]][s[1]];else i(t,e);for(o=0;o<e.length&&!(e[o][2]<4);o++);for(e=e.slice(o),o=0;o<100&&l>.01;o++)l=i(t,e,n(l));return l>.01&&a.log(\"interp2d didn't converge quickly\",l),t}},{\"../../lib\":725}],955:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i,a,o){var s,l,u,c=[],h=n.traceIs(t,\"contour\"),f=n.traceIs(t,\"histogram\"),d=n.traceIs(t,\"gl2d\");if(Array.isArray(e)&&e.length>1&&!f&&\"category\"!==o.type){var p=e.length;if(!(p<=a))return h?e.slice(0,a):e.slice(0,a+1);if(h||d)c=e.slice(0,a);else if(1===a)c=[e[0]-.5,e[0]+.5];else{for(c=[1.5*e[0]-.5*e[1]],u=1;u<p;u++)c.push(.5*(e[u-1]+e[u]));c.push(1.5*e[p-1]-.5*e[p-2])}if(p<a){var m=c[c.length-1],v=m-c[c.length-2];for(u=p;u<a;u++)m+=v,c.push(m)}}else{l=i||1;var g=t[o._id.charAt(0)+\"calendar\"];for(s=f||\"category\"===o.type?o.r2c(r,0,g)||0:Array.isArray(e)&&1===e.length?e[0]:void 0===r?0:o.d2c(r,0,g),u=h||d?0:-.5;u<a;u++)c.push(s+l*u)}return c}},{\"../../registry\":844}],956:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=0,r=0;r<t.length;r++)e=Math.max(e,t[r].length);return e}},{}],957:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t,e){var r=e.length-2,n=o.constrain(o.findBin(t,e),0,r),i=e[n],a=e[n+1],s=o.constrain(n+(t-i)/(a-i)-.5,0,r),l=Math.round(s),u=Math.abs(s-l);return s&&s!==r&&u?{bin0:l,frac:u,bin1:Math.round(l+u/(s-l))}:{bin0:l,bin1:l,frac:0}}function c(t,e){if(void 0!==t){var r=q(t);return r[0]=Math.round(r[0]),r[1]=Math.round(r[1]),r[2]=Math.round(r[2]),rt+=e,nt+=r[0]*e,it+=r[1]*e,at+=r[2]*e,r}return[0,0,0,0]}function h(t,e,r){t[e]=r[0],t[e+1]=r[1],t[e+2]=r[2],t[e+3]=Math.round(255*r[3])}var f=r[0].trace,d=f.uid,p=e.xaxis,m=e.yaxis,v=t._fullLayout,g=\"hm\"+d;if(v._paper.selectAll(\".contour\"+d).remove(),v._infolayer.selectAll(\"g.rangeslider-container\").selectAll(\".contour\"+d).remove(),!0!==f.visible)return v._paper.selectAll(\".\"+g).remove(),void v._infolayer.selectAll(\".cb\"+d).remove();var y,b,x,_,w,M,k=r[0].z,A=r[0].x,T=r[0].y,S=a.traceIs(f,\"contour\"),E=S?\"best\":f.zsmooth,L=k.length,C=u(k),z=!1,I=!1;for(M=0;void 0===y&&M<A.length-1;)y=p.c2p(A[M]),M++;for(M=A.length-1;void 0===b&&M>0;)b=p.c2p(A[M]),M--;for(b<y&&(x=b,b=y,y=x,z=!0),M=0;void 0===_&&M<T.length-1;)_=m.c2p(T[M]),M++;for(M=T.length-1;void 0===w&&M>0;)w=m.c2p(T[M]),M--;if(w<_&&(x=_,_=w,w=x,I=!0),S&&(A=r[0].xfill,T=r[0].yfill),\"fast\"!==E){var D=\"best\"===E?0:.5;y=Math.max(-D*p._length,y),b=Math.min((1+D)*p._length,b),_=Math.max(-D*m._length,_),w=Math.min((1+D)*m._length,w)}var P=Math.round(b-y),O=Math.round(w-_),R=P<=0||O<=0,F=e.plot.select(\".imagelayer\").selectAll(\"g.hm.\"+g).data(R?[]:[0]);if(F.enter().append(\"g\").classed(\"hm\",!0).classed(g,!0),F.exit().remove(),!R){var j,N;\"fast\"===E?(j=C,N=L):(j=P,N=O);var B=document.createElement(\"canvas\");B.width=j,B.height=N;var U,V,H=B.getContext(\"2d\"),q=s.makeColorScaleFunc(s.extractScale(f.colorscale,f.zmin,f.zmax),{noNumericCheck:!0,returnArray:!0});\"fast\"===E?(U=z?function(t){return C-1-t}:o.identity,V=I?function(t){return L-1-t}:o.identity):(U=function(t){return o.constrain(Math.round(p.c2p(A[t])-y),0,P)},V=function(t){return o.constrain(Math.round(m.c2p(T[t])-_),0,O)});var G,Y,X,W,Z,J,K,Q=V(0),$=[Q,Q],tt=z?0:1,et=I?0:1,rt=0,nt=0,it=0,at=0;if(E){var ot,st=0;try{ot=new Uint8Array(P*O*4)}catch(t){ot=new Array(P*O*4)}if(\"best\"===E){var lt,ut,ct,ht=new Array(A.length),ft=new Array(T.length),dt=new Array(P);for(M=0;M<A.length;M++)ht[M]=Math.round(p.c2p(A[M])-y);for(M=0;M<T.length;M++)ft[M]=Math.round(m.c2p(T[M])-_);for(M=0;M<P;M++)dt[M]=n(M,ht);for(X=0;X<O;X++)for(lt=n(X,ft),ut=k[lt.bin0],ct=k[lt.bin1],M=0;M<P;M++,st+=4)K=function(t,e,r,n){var i=t[r.bin0];if(void 0===i)return c(void 0,1);var a,o=t[r.bin1],s=e[r.bin0],l=e[r.bin1],u=o-i||0,h=s-i||0;return a=void 0===o?void 0===l?0:void 0===s?2*(l-i):2*(2*l-s-i)/3:void 0===l?void 0===s?0:2*(2*i-o-s)/3:void 0===s?2*(2*l-o-i)/3:l+i-o-s,c(i+r.frac*u+n.frac*(h+r.frac*a))}(ut,ct,dt[M],lt),h(ot,st,K)}else for(X=0;X<L;X++)for(J=k[X],$=V(X),M=0;M<P;M++)K=c(J[M],1),st=4*($*P+U(M)),h(ot,st,K);var pt=H.createImageData(P,O);try{pt.data.set(ot)}catch(t){var mt=pt.data,vt=mt.length;for(X=0;X<vt;X++)mt[X]=ot[X]}H.putImageData(pt,0,0)}else for(X=0;X<L;X++)if(J=k[X],$.reverse(),$[et]=V(X+1),$[0]!==$[1]&&void 0!==$[0]&&void 0!==$[1])for(W=U(0),Y=[W,W],M=0;M<C;M++)Y.reverse(),Y[tt]=U(M+1),Y[0]!==Y[1]&&void 0!==Y[0]&&void 0!==Y[1]&&(Z=J[M],K=c(Z,(Y[1]-Y[0])*($[1]-$[0])),H.fillStyle=\"rgba(\"+K.join(\",\")+\")\",G=function(t,e,r,n,i,a,o,s,l){var u={x0:e,x1:r,y0:n,y1:i},c=2*t.xgap/3,h=2*t.ygap/3,f=t.xgap/3,d=t.ygap/3;return s===l-1&&(u.y1=i-h),a===o-1&&(u.x0=e+c),0===s&&(u.y0=n+h),0===a&&(u.x1=r-c),a>0&&a<o-1&&(u.x0=e+f,u.x1=r-f),s>0&&s<l-1&&(u.y0=n+d,u.y1=i-d),u}(f,Y[0],Y[1],$[0],$[1],M,C,X,L),H.fillRect(G.x0,G.y0,G.x1-G.x0,G.y1-G.y0));nt=Math.round(nt/rt),it=Math.round(it/rt),at=Math.round(at/rt);var gt=i(\"rgb(\"+nt+\",\"+it+\",\"+at+\")\");t._hmpixcount=(t._hmpixcount||0)+rt,t._hmlumcount=(t._hmlumcount||0)+rt*gt.getLuminance();var yt=F.selectAll(\"image\").data(r);yt.enter().append(\"svg:image\").attr({xmlns:l.svg,preserveAspectRatio:\"none\"}),yt.attr({height:O,width:P,x:y,y:_,\"xlink:href\":B.toDataURL(\"image/png\")}),yt.exit().remove()}}var i=t(\"tinycolor2\"),a=t(\"../../registry\"),o=t(\"../../lib\"),s=t(\"../../components/colorscale\"),l=t(\"../../constants/xmlns_namespaces\"),u=t(\"./max_row_length\");e.exports=function(t,e,r){for(var i=0;i<r.length;i++)n(t,e,r[i])}},{\"../../components/colorscale\":617,\"../../constants/xmlns_namespaces\":707,\"../../lib\":725,\"../../registry\":844,\"./max_row_length\":956,tinycolor2:533}],958:[function(t,e,r){\"use strict\";var n=t(\"d3\");e.exports=function(t){n.select(t).selectAll(\".hm image\").style(\"opacity\",function(t){return t.trace.opacity})}},{d3:121}],959:[function(t,e,r){\"use strict\";function n(t,e){var r=e(t);return\"scaled\"===(r?e(t+\"type\",\"array\"):\"scaled\")&&(e(t+\"0\"),e(\"d\"+t)),r}function i(t){for(var e,r=!0,n=!1,i=!1,o=0;o<t.length;o++){if(e=t[o],!Array.isArray(e)){r=!1;break}e.length>0&&(n=!0);for(var s=0;s<e.length;s++)if(a(e[s])){i=!0;break}}return r&&n&&i}var a=t(\"fast-isnumeric\"),o=t(\"../../registry\"),s=t(\"./has_columns\");e.exports=function(t,e,r,a,l,u){var c=r(\"z\");l=l||\"x\",u=u||\"y\";var h,f;if(void 0===c||!c.length)return 0;if(s(t)){if(h=r(l),f=r(u),!h||!f)return 0}else{if(h=n(l,r),f=n(u,r),!i(c))return 0;r(\"transpose\")}return o.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[l,u],a),e.z.length}},{\"../../registry\":844,\"./has_columns\":951,\"fast-isnumeric\":130}],960:[function(t,e,r){\"use strict\";for(var n=t(\"../heatmap/attributes\"),i=t(\"../../components/colorscale/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../lib/extend\").extendFlat,s=[\"z\",\"x\",\"x0\",\"dx\",\"y\",\"y0\",\"dy\",\"text\",\"transpose\",\"xtype\",\"ytype\"],l={},u=0;u<s.length;u++){var c=s[u];l[c]=n[c]}o(l,i,{autocolorscale:o({},i.autocolorscale,{dflt:!1})},{colorbar:a}),e.exports=l},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../heatmap/attributes\":944}],961:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"heatmapgl\",this.name=\"\",this.hoverinfo=\"all\",this.xData=[],this.yData=[],this.zData=[],this.textLabels=[],this.idToIndex=[],this.bounds=[0,0,0,0],this.options={z:[],x:[],y:[],shape:[0,0],colorLevels:[0],colorValues:[0,0,0,1]},this.heatmap=o(t.glplot,this.options),this.heatmap._trace=this}function i(t){for(var e=t.colorscale,r=t.zmin,n=t.zmax,i=e.length,a=new Array(i),o=new Array(4*i),s=0;s<i;s++){var u=e[s],c=l(u[1]);a[s]=r+u[0]*(n-r);for(var h=0;h<4;h++)o[4*s+h]=c[h]}return{colorLevels:a,colorValues:o}}function a(t,e,r){var i=new n(t,e.uid);return i.update(e,r),i}var o=t(\"gl-heatmap2d\"),s=t(\"../../plots/cartesian/axes\"),l=t(\"../../lib/str2rgbarray\"),u=n.prototype;u.handlePick=function(t){var e=this.options,r=e.shape,n=t.pointId,i=n%r[0],a=Math.floor(n/r[0]),o=n;return{trace:this,dataCoord:t.dataCoord,traceCoord:[e.x[i],e.y[a],e.z[o]],textLabel:this.textLabels[n],name:this.name,pointIndex:[a,i],hoverinfo:this.hoverinfo}},u.update=function(t,e){var r=e[0];this.index=t.index,this.name=t.name,this.hoverinfo=t.hoverinfo;var n=r.z;this.options.z=[].concat.apply([],n);var a=n[0].length,o=n.length;this.options.shape=[a,o],this.options.x=r.x,this.options.y=r.y;var l=i(t);this.options.colorLevels=l.colorLevels,this.options.colorValues=l.colorValues,this.textLabels=[].concat.apply([],t.text),this.heatmap.update(this.options),s.expand(this.scene.xaxis,r.x),s.expand(this.scene.yaxis,r.y)},u.dispose=function(){this.heatmap.dispose()},e.exports=a},{\"../../lib/str2rgbarray\":744,\"../../plots/cartesian/axes\":766,\"gl-heatmap2d\":165}],962:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"../heatmap/defaults\"),n.colorbar=t(\"../heatmap/colorbar\"),n.calc=t(\"../heatmap/calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"heatmapgl\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"2dMap\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../heatmap/calc\":945,\"../heatmap/colorbar\":947,\"../heatmap/defaults\":949,\"./attributes\":960,\"./convert\":961}],963:[function(t,e,r){\"use strict\";function n(t){return{start:{valType:\"any\",dflt:null},end:{valType:\"any\",dflt:null},size:{valType:\"any\",dflt:null}}}var i=t(\"../bar/attributes\");e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},text:i.text,orientation:i.orientation,histfunc:{valType:\"enumerated\",values:[\"count\",\"sum\",\"avg\",\"min\",\"max\"],dflt:\"count\"},histnorm:{valType:\"enumerated\",values:[\"\",\"percent\",\"probability\",\"density\",\"probability density\"],dflt:\"\"},cumulative:{enabled:{valType:\"boolean\",dflt:!1},direction:{valType:\"enumerated\",values:[\"increasing\",\"decreasing\"],dflt:\"increasing\"},currentbin:{valType:\"enumerated\",values:[\"include\",\"exclude\",\"half\"],dflt:\"include\"}},autobinx:{valType:\"boolean\",dflt:null},nbinsx:{valType:\"integer\",min:0,dflt:0},xbins:n(\"x\"),autobiny:{valType:\"boolean\",dflt:null},nbinsy:{valType:\"integer\",min:0,dflt:0},ybins:n(\"y\"),marker:i.marker,error_y:i.error_y,error_x:i.error_x,_deprecated:{bardir:i._deprecated.bardir}}},{\"../bar/attributes\":854}],964:[function(t,e,r){\"use strict\";e.exports=function(t,e){for(var r=t.length,n=0,i=0;i<r;i++)e[i]?(t[i]/=e[i],n+=t[i]):t[i]=null;return n}},{}],965:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){return r(\"histnorm\"),n.forEach(function(t){r(t+\"bins.start\"),r(t+\"bins.end\"),r(t+\"bins.size\"),r(\"autobin\"+t),r(\"nbins\"+t)}),e}},{}],966:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports={count:function(t,e,r){return r[t]++,1},sum:function(t,e,r,i){var a=i[e];return n(a)?(a=Number(a),r[t]+=a,a):0},avg:function(t,e,r,i,a){var o=i[e];return n(o)&&(o=Number(o),r[t]+=o,a[t]++),0},min:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]>a){var o=a-r[t];return r[t]=a,o}}return 0},max:function(t,e,r,i){var a=i[e];if(n(a)){if(a=Number(a),!n(r[t]))return r[t]=a,a;if(r[t]<a){var o=a-r[t];return r[t]=a,o}}return 0}}},{\"fast-isnumeric\":130}],967:[function(t,e,r){\"use strict\";function n(t,e,r,n){var o,s,u,h,f,d=n+\"bins\";if(e._autoBinFinished)delete e._autoBinFinished;else{var p=i(t,e),m=[],v=1/0,g=1/0,y=-1/0,b=\"autobin\"+n;for(o=0;o<p.length;o++){s=p[o],f=s._pos0=r.makeCalcdata(s,n);var x=s[d];if(s[b]||!x||null===x.start||null===x.end){u=s[n+\"calendar\"];var _=s.cumulative;x=c.autoBin(f,r,s[\"nbins\"+n],!1,u),_.enabled&&\"include\"!==_.currentbin&&(\"decreasing\"===_.direction?g=Math.min(g,r.r2c(x.start,0,u)-x.size):y=Math.max(y,r.r2c(x.end,0,u)+x.size)),m.push(s)}else h||(h={size:x.size,start:r.r2c(x.start,0,u),end:r.r2c(x.end,0,u)});v=a(v,x.size),g=Math.min(g,r.r2c(x.start,0,u)),y=Math.max(y,r.r2c(x.end,0,u)),o&&(e._autoBinFinished=1)}if(h&&l(h.size)&&l(v)){v=v>h.size/1.9?h.size:h.size/Math.ceil(h.size/v);var w=h.start+(h.size-v)/2;g=w-v*Math.ceil((w-g)/v)}for(o=0;o<m.length;o++)s=m[o],u=s[n+\"calendar\"],s._input[d]=s[d]={start:r.c2r(g,0,u),end:r.c2r(y,0,u),size:v},s._input[b]=s[b]}return f=e._pos0,delete e._pos0,[e[d],f]}function i(t,e){if(\"overlay\"===t._fullLayout.barmode)return[e];for(var r=e.xaxis,n=e.yaxis,i=e.orientation,a=[],o=t._fullData,s=0;s<o.length;s++){var l=o[s];\"histogram\"===l.type&&l.orientation===i&&l.xaxis===r&&l.yaxis===n&&a.push(l)}return a}function a(t,e){if(t===1/0)return e;var r=o(t);return o(e)<r?e:t}function o(t){return l(t)?t:\"string\"==typeof t&&\"M\"===t.charAt(0)?v*+t.substr(1):1/0}function s(t,e,r){function n(e){s=t[e],t[e]/=2}function i(e){o=t[e],t[e]=s+o/2,s+=o}var a,o,s;if(\"half\"===r)if(\"increasing\"===e)for(n(0),a=1;a<t.length;a++)i(a);else for(n(t.length-1),a=t.length-2;a>=0;a--)i(a);else if(\"increasing\"===e){for(a=1;a<t.length;a++)t[a]+=t[a-1];\"exclude\"===r&&(t.unshift(0),t.pop())\n",
       "}else{for(a=t.length-2;a>=0;a--)t[a]+=t[a+1];\"exclude\"===r&&(t.push(0),t.shift())}}var l=t(\"fast-isnumeric\"),u=t(\"../../lib\"),c=t(\"../../plots/cartesian/axes\"),h=t(\"../bar/arrays_to_calcdata\"),f=t(\"./bin_functions\"),d=t(\"./norm_functions\"),p=t(\"./average\"),m=t(\"./clean_bins\"),v=t(\"../../constants/numerical\").ONEAVGMONTH;e.exports=function(t,e){if(!0===e.visible){var r,i=[],a=[],o=c.getFromId(t,\"h\"===e.orientation?e.yaxis||\"y\":e.xaxis||\"x\"),v=\"h\"===e.orientation?\"y\":\"x\",g={x:\"y\",y:\"x\"}[v],y=e[v+\"calendar\"],b=e.cumulative;m(e,o,v);var x,_,w,M=n(t,e,o,v),k=M[0],A=M[1],T=\"string\"==typeof k.size,S=T?[]:k,E=[],L=[],C=0,z=e.histnorm,I=e.histfunc,D=-1!==z.indexOf(\"density\");b.enabled&&D&&(z=z.replace(/ ?density$/,\"\"),D=!1);var P,O=\"max\"===I||\"min\"===I,R=O?null:0,F=f.count,j=d[z],N=!1,B=function(t){return o.r2c(t,0,y)};for(Array.isArray(e[g])&&\"count\"!==I&&(P=e[g],N=\"avg\"===I,F=f[I]),r=B(k.start),_=B(k.end)+(r-c.tickIncrement(r,k.size,!1,y))/1e6;r<_&&i.length<1e6&&(x=c.tickIncrement(r,k.size,!1,y),i.push((r+x)/2),a.push(R),T&&S.push(r),D&&E.push(1/(x-r)),N&&L.push(0),!(x<=r));)r=x;T||\"date\"!==o.type||(S={start:B(S.start),end:B(S.end),size:S.size});var U=a.length;for(r=0;r<A.length;r++)(w=u.findBin(A[r],S))>=0&&w<U&&(C+=F(w,r,a,P,L));N&&(C=p(a,L)),j&&j(a,C,E),b.enabled&&s(a,b.direction,b.currentbin);var V=Math.min(i.length,a.length),H=[],q=0,G=V-1;for(r=0;r<V;r++)if(a[r]){q=r;break}for(r=V-1;r>q;r--)if(a[r]){G=r;break}for(r=q;r<=G;r++)l(i[r])&&l(a[r])&&H.push({p:i[r],s:a[r],b:0});return h(H,e),H}}},{\"../../constants/numerical\":705,\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../bar/arrays_to_calcdata\":853,\"./average\":964,\"./bin_functions\":966,\"./clean_bins\":968,\"./norm_functions\":971,\"fast-isnumeric\":130}],968:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\").cleanDate,a=t(\"../../constants/numerical\"),o=a.ONEDAY,s=a.BADNUM;e.exports=function(t,e,r){var a=e.type,l=r+\"bins\",u=t[l];u||(u=t[l]={});var c=\"date\"===a?function(t){return t||0===t?i(t,s,u.calendar):null}:function(t){return n(t)?Number(t):null};u.start=c(u.start),u.end=c(u.end);var h=\"date\"===a?o:1,f=u.size;if(n(f))u.size=f>0?Number(f):h;else if(\"string\"!=typeof f)u.size=h;else{var d=f.charAt(0),p=f.substr(1);p=n(p)?Number(p):0,(p<=0||\"date\"!==a||\"M\"!==d||p!==Math.round(p))&&(u.size=h)}var m=\"autobin\"+r;\"boolean\"!=typeof t[m]&&(t[m]=!((u.start||0===u.start)&&(u.end||0===u.end))),t[m]||delete t[\"nbins\"+r]}},{\"../../constants/numerical\":705,\"../../lib\":725,\"fast-isnumeric\":130}],969:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/color\"),o=t(\"./bin_defaults\"),s=t(\"../bar/style_defaults\"),l=t(\"../../components/errorbars/defaults\"),u=t(\"./attributes\");e.exports=function(t,e,r,c){function h(r,n){return i.coerce(t,e,u,r,n)}var f=h(\"x\"),d=h(\"y\");h(\"cumulative.enabled\")&&(h(\"cumulative.direction\"),h(\"cumulative.currentbin\")),h(\"text\");var p=h(\"orientation\",d&&!f?\"h\":\"v\"),m=e[\"v\"===p?\"x\":\"y\"];if(!m||!m.length)return void(e.visible=!1);n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],c),e[\"h\"===p?\"x\":\"y\"]&&h(\"histfunc\"),o(t,e,h,\"h\"===p?[\"y\"]:[\"x\"]),s(t,e,h,r,c),l(t,e,a.defaultLine,{axis:\"y\"}),l(t,e,a.defaultLine,{axis:\"x\",inherit:\"y\"})}},{\"../../components/color\":603,\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../../registry\":844,\"../bar/style_defaults\":865,\"./attributes\":963,\"./bin_defaults\":965}],970:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.layoutAttributes=t(\"../bar/layout_attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"../bar/layout_defaults\"),n.calc=t(\"./calc\"),n.setPositions=t(\"../bar/set_positions\"),n.plot=t(\"../bar/plot\"),n.style=t(\"../bar/style\"),n.colorbar=t(\"../scatter/colorbar\"),n.hoverPoints=t(\"../bar/hover\"),n.moduleType=\"trace\",n.name=\"histogram\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"bar\",\"histogram\",\"oriented\",\"errorBarsOK\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../bar/hover\":857,\"../bar/layout_attributes\":859,\"../bar/layout_defaults\":860,\"../bar/plot\":861,\"../bar/set_positions\":862,\"../bar/style\":864,\"../scatter/colorbar\":1030,\"./attributes\":963,\"./calc\":967,\"./defaults\":969}],971:[function(t,e,r){\"use strict\";e.exports={percent:function(t,e){for(var r=t.length,n=100/e,i=0;i<r;i++)t[i]*=n},probability:function(t,e){for(var r=t.length,n=0;n<r;n++)t[n]/=e},density:function(t,e,r,n){var i=t.length;n=n||1;for(var a=0;a<i;a++)t[a]*=r[a]*n},\"probability density\":function(t,e,r,n){var i=t.length;n&&(e/=n);for(var a=0;a<i;a++)t[a]*=r[a]/e}}},{}],972:[function(t,e,r){\"use strict\";var n=t(\"../histogram/attributes\"),i=t(\"../heatmap/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports=s({},{x:n.x,y:n.y,z:{valType:\"data_array\"},marker:{color:{valType:\"data_array\"}},histnorm:n.histnorm,histfunc:n.histfunc,autobinx:n.autobinx,nbinsx:n.nbinsx,xbins:n.xbins,autobiny:n.autobiny,nbinsy:n.nbinsy,ybins:n.ybins,xgap:i.xgap,ygap:i.ygap,zsmooth:i.zsmooth},a,{autocolorscale:s({},a.autocolorscale,{dflt:!1})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../heatmap/attributes\":944,\"../histogram/attributes\":963}],973:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../histogram/bin_functions\"),o=t(\"../histogram/norm_functions\"),s=t(\"../histogram/average\"),l=t(\"../histogram/clean_bins\");e.exports=function(t,e){var r,u,c,h,f,d,p=i.getFromId(t,e.xaxis||\"x\"),m=e.x?p.makeCalcdata(e,\"x\"):[],v=i.getFromId(t,e.yaxis||\"y\"),g=e.y?v.makeCalcdata(e,\"y\"):[],y=e.xcalendar,b=e.ycalendar,x=function(t){return p.r2c(t,0,y)},_=function(t){return v.r2c(t,0,b)},w=function(t){return p.c2r(t,0,y)},M=function(t){return v.c2r(t,0,b)};l(e,p,\"x\"),l(e,v,\"y\");var k=Math.min(m.length,g.length);m.length>k&&m.splice(k,m.length-k),g.length>k&&g.splice(k,g.length-k),!e.autobinx&&e.xbins&&null!==e.xbins.start&&null!==e.xbins.end||(e.xbins=i.autoBin(m,p,e.nbinsx,\"2d\",y),\"histogram2dcontour\"===e.type&&(e.xbins.start=w(i.tickIncrement(x(e.xbins.start),e.xbins.size,!0,y)),e.xbins.end=w(i.tickIncrement(x(e.xbins.end),e.xbins.size,!1,y))),e._input.xbins=e.xbins,e._input.autobinx=e.autobinx),!e.autobiny&&e.ybins&&null!==e.ybins.start&&null!==e.ybins.end||(e.ybins=i.autoBin(g,v,e.nbinsy,\"2d\",b),\"histogram2dcontour\"===e.type&&(e.ybins.start=M(i.tickIncrement(_(e.ybins.start),e.ybins.size,!0,b)),e.ybins.end=M(i.tickIncrement(_(e.ybins.end),e.ybins.size,!1,b))),e._input.ybins=e.ybins,e._input.autobiny=e.autobiny),f=[];var A,T,S=[],E=[],L=\"string\"==typeof e.xbins.size,C=\"string\"==typeof e.ybins.size,z=L?[]:e.xbins,I=C?[]:e.ybins,D=0,P=[],O=e.histnorm,R=e.histfunc,F=-1!==O.indexOf(\"density\"),j=\"max\"===R||\"min\"===R,N=j?null:0,B=a.count,U=o[O],V=!1,H=[],q=[],G=\"z\"in e?e.z:\"marker\"in e&&Array.isArray(e.marker.color)?e.marker.color:\"\";G&&\"count\"!==R&&(V=\"avg\"===R,B=a[R]);var Y=e.xbins,X=x(Y.start),W=x(Y.end)+(X-i.tickIncrement(X,Y.size,!1,y))/1e6;for(d=X;d<W;d=i.tickIncrement(d,Y.size,!1,y))S.push(N),L&&z.push(d),V&&E.push(0);L&&z.push(d);var Z=S.length;r=e.xbins.start;var J=x(r);for(u=(d-J)/Z,r=w(J+u/2),Y=e.ybins,X=_(Y.start),W=_(Y.end)+(X-i.tickIncrement(X,Y.size,!1,b))/1e6,d=X;d<W;d=i.tickIncrement(d,Y.size,!1,b))f.push(S.concat()),C&&I.push(d),V&&P.push(E.concat());C&&I.push(d);var K=f.length;c=e.ybins.start;var Q=_(c);for(h=(d-Q)/K,c=M(Q+h/2),F&&(H=S.map(function(t,e){return L?1/(z[e+1]-z[e]):1/u}),q=f.map(function(t,e){return C?1/(I[e+1]-I[e]):1/h})),L||\"date\"!==p.type||(z={start:x(z.start),end:x(z.end),size:z.size}),C||\"date\"!==v.type||(I={start:_(I.start),end:_(I.end),size:I.size}),d=0;d<k;d++)A=n.findBin(m[d],z),T=n.findBin(g[d],I),A>=0&&A<Z&&T>=0&&T<K&&(D+=B(A,d,f[T],G,P[T]));if(V)for(T=0;T<K;T++)D+=s(f[T],P[T]);if(U)for(T=0;T<K;T++)U(f[T],D,H,q[T]);return{x:m,x0:r,dx:u,y:g,y0:c,dy:h,z:f}}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../histogram/average\":964,\"../histogram/bin_functions\":966,\"../histogram/clean_bins\":968,\"../histogram/norm_functions\":971}],974:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./sample_defaults\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,i){return n.coerce(t,e,o,r,i)}i(t,e,l,s),!1===l(\"zsmooth\")&&(l(\"xgap\"),l(\"ygap\")),a(t,e,s,l,{prefix:\"\",cLetter:\"z\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"./attributes\":972,\"./sample_defaults\":976}],975:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../heatmap/calc\"),n.plot=t(\"../heatmap/plot\"),n.colorbar=t(\"../heatmap/colorbar\"),n.style=t(\"../heatmap/style\"),n.hoverPoints=t(\"../heatmap/hover\"),n.moduleType=\"trace\",n.name=\"histogram2d\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"histogram\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../heatmap/calc\":945,\"../heatmap/colorbar\":947,\"../heatmap/hover\":952,\"../heatmap/plot\":957,\"../heatmap/style\":958,\"./attributes\":972,\"./defaults\":974}],976:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../histogram/bin_defaults\");e.exports=function(t,e,r,a){var o=r(\"x\"),s=r(\"y\");if(!(o&&o.length&&s&&s.length))return void(e.visible=!1);n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],a),(r(\"z\")||r(\"marker.color\"))&&r(\"histfunc\"),i(t,e,r,[\"x\",\"y\"])}},{\"../../registry\":844,\"../histogram/bin_defaults\":965}],977:[function(t,e,r){\"use strict\";var n=t(\"../histogram2d/attributes\"),i=t(\"../contour/attributes\"),a=t(\"../../components/colorscale/attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports=s({},{x:n.x,y:n.y,z:n.z,marker:n.marker,histnorm:n.histnorm,histfunc:n.histfunc,autobinx:n.autobinx,nbinsx:n.nbinsx,xbins:n.xbins,autobiny:n.autobiny,nbinsy:n.nbinsy,ybins:n.ybins,autocontour:i.autocontour,ncontours:i.ncontours,contours:i.contours,line:i.line},a,{zmin:s({},a.zmin,{editType:\"docalc\"}),zmax:s({},a.zmax,{editType:\"docalc\"})},{colorbar:o})},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../contour/attributes\":916,\"../histogram2d/attributes\":972}],978:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../histogram2d/sample_defaults\"),a=t(\"../contour/contours_defaults\"),o=t(\"../contour/style_defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,i){return n.coerce(t,e,s,r,i)}i(t,e,u,l),a(t,e,u),o(t,e,u,l)}},{\"../../lib\":725,\"../contour/contours_defaults\":920,\"../contour/style_defaults\":930,\"../histogram2d/sample_defaults\":976,\"./attributes\":977}],979:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../contour/calc\"),n.plot=t(\"../contour/plot\").plot,n.style=t(\"../contour/style\"),n.colorbar=t(\"../contour/colorbar\"),n.hoverPoints=t(\"../contour/hover\"),n.moduleType=\"trace\",n.name=\"histogram2dcontour\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"2dMap\",\"contour\",\"histogram\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../contour/calc\":917,\"../contour/colorbar\":918,\"../contour/hover\":924,\"../contour/plot\":928,\"../contour/style\":929,\"./attributes\":977,\"./defaults\":978}],980:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/attributes\"),i=t(\"../../components/colorbar/attributes\"),a=t(\"../surface/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},z:{valType:\"data_array\"},i:{valType:\"data_array\"},j:{valType:\"data_array\"},k:{valType:\"data_array\"},delaunayaxis:{valType:\"enumerated\",values:[\"x\",\"y\",\"z\"],dflt:\"z\"},alphahull:{valType:\"number\",dflt:-1},intensity:{valType:\"data_array\"},color:{valType:\"color\"},vertexcolor:{valType:\"data_array\"},facecolor:{valType:\"data_array\"},opacity:o({},a.opacity),flatshading:{valType:\"boolean\",dflt:!1},contour:{show:o({},a.contours.x.show,{}),color:o({},a.contours.x.color),width:o({},a.contours.x.width)},cauto:n.zauto,cmin:n.zmin,cmax:n.zmax,colorscale:n.colorscale,reversescale:n.reversescale,autocolorscale:o({},n.autocolorscale,{dflt:!1}),showscale:n.showscale,colorbar:i,lightposition:{x:o({},a.lightposition.x,{dflt:1e5}),y:o({},a.lightposition.y,{dflt:1e5}),z:o({},a.lightposition.z,{dflt:0})},lighting:o({},{vertexnormalsepsilon:{valType:\"number\",min:0,max:1,dflt:1e-12},facenormalsepsilon:{valType:\"number\",min:0,max:1,dflt:1e-6}},a.lighting)}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716,\"../surface/attributes\":1093}],981:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){e.intensity&&n(e,e.intensity,\"\",\"c\")}},{\"../../components/colorscale/calc\":609}],982:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.cmin,c=r.cmax,h=r.intensity||[];if(n(u)||(u=i.aggNums(Math.min,null,h)),n(c)||(c=i.aggNums(Math.max,null,h)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var f=e[0].t.cb=s(t,l),d=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});f.fillcolor(d).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],983:[function(t,e,r){\"use strict\";function n(t,e,r){this.scene=t,this.uid=r,this.mesh=e,this.name=\"\",this.color=\"#fff\",this.data=null,this.showContour=!1}function i(t){return t.map(function(t){var e=t[0],r=u(t[1]),n=r.toRgb();return{index:e,rgb:[n.r,n.g,n.b,1]}})}function a(t){return t.map(d)}function o(t,e,r){for(var n=new Array(t.length),i=0;i<t.length;++i)n[i]=[t[i],e[i],r[i]];return n}function s(t,e){var r=t.glplot.gl,i=l({gl:r}),a=new n(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}var l=t(\"gl-mesh3d\"),u=t(\"tinycolor2\"),c=t(\"delaunay-triangulate\"),h=t(\"alpha-shape\"),f=t(\"convex-hull\"),d=t(\"../../lib/str2rgbarray\"),p=n.prototype;p.handlePick=function(t){if(t.object===this.mesh){var e=t.index=t.data.index;return t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]],!0}},p.update=function(t){function e(t,e,r,n){return e.map(function(e){return t.d2l(e,0,n)*r})}var r=this.scene,n=r.fullSceneLayout;this.data=t;var s,l=o(e(n.xaxis,t.x,r.dataScale[0],t.xcalendar),e(n.yaxis,t.y,r.dataScale[1],t.ycalendar),e(n.zaxis,t.z,r.dataScale[2],t.zcalendar));if(t.i&&t.j&&t.k)s=o(t.i,t.j,t.k);else if(0===t.alphahull)s=f(l);else if(t.alphahull>0)s=h(t.alphahull,l);else{var u=[\"x\",\"y\",\"z\"].indexOf(t.delaunayaxis);s=c(l.map(function(t){return[t[(u+1)%3],t[(u+2)%3]]}))}var p={positions:l,cells:s,lightPosition:[t.lightposition.x,t.lightposition.y,t.lightposition.z],ambient:t.lighting.ambient,diffuse:t.lighting.diffuse,specular:t.lighting.specular,roughness:t.lighting.roughness,fresnel:t.lighting.fresnel,vertexNormalsEpsilon:t.lighting.vertexnormalsepsilon,faceNormalsEpsilon:t.lighting.facenormalsepsilon,opacity:t.opacity,contourEnable:t.contour.show,contourColor:d(t.contour.color).slice(0,3),contourWidth:t.contour.width,useFacetNormals:t.flatshading};t.intensity?(this.color=\"#fff\",p.vertexIntensity=t.intensity,p.vertexIntensityBounds=[t.cmin,t.cmax],p.colormap=i(t.colorscale)):t.vertexcolor?(this.color=t.vertexcolor[0],p.vertexColors=a(t.vertexcolor)):t.facecolor?(this.color=t.facecolor[0],p.cellColors=a(t.facecolor)):(this.color=t.color,p.meshColor=d(t.color)),this.mesh.update(p)},p.dispose=function(){this.scene.glplot.remove(this.mesh),this.mesh.dispose()},e.exports=s},{\"../../lib/str2rgbarray\":744,\"alpha-shape\":42,\"convex-hull\":102,\"delaunay-triangulate\":122,\"gl-mesh3d\":204,tinycolor2:533}],984:[function(t,e,r){\"use strict\";var n=t(\"../../registry\"),i=t(\"../../lib\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./attributes\");e.exports=function(t,e,r,s){function l(r,n){return i.coerce(t,e,o,r,n)}function u(t){var e=t.map(function(t){var e=l(t);return e&&Array.isArray(e)?e:null});return e.every(function(t){return t&&t.length===e[0].length})&&e}var c=u([\"x\",\"y\",\"z\"]),h=u([\"i\",\"j\",\"k\"]);if(!c)return void(e.visible=!1);h&&h.forEach(function(t){for(var e=0;e<t.length;++e)t[e]|=0}),n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],s),[\"lighting.ambient\",\"lighting.diffuse\",\"lighting.specular\",\"lighting.roughness\",\"lighting.fresnel\",\"lighting.vertexnormalsepsilon\",\"lighting.facenormalsepsilon\",\"lightposition.x\",\"lightposition.y\",\"lightposition.z\",\"contour.show\",\"contour.color\",\"contour.width\",\"colorscale\",\"reversescale\",\"flatshading\",\"alphahull\",\"delaunayaxis\",\"opacity\"].forEach(function(t){l(t)}),\"intensity\"in t?(l(\"intensity\"),a(t,e,s,l,{prefix:\"\",cLetter:\"c\"})):(e.showscale=!1,\"facecolor\"in t?l(\"facecolor\"):\"vertexcolor\"in t?l(\"vertexcolor\"):l(\"color\",r))}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"../../registry\":844,\"./attributes\":980}],985:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.colorbar=t(\"./colorbar\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"mesh3d\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\"],n.meta={},e.exports=n},{\"../../plots/gl3d\":809,\"./attributes\":980,\"./calc\":981,\"./colorbar\":982,\"./convert\":983,\"./defaults\":984}],986:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/attributes\"),a=t(\"../../components/drawing/attributes\").dash,o=i.line,s={name:{valType:\"string\"},showlegend:{valType:\"boolean\",dflt:!0},line:{color:o.color,width:o.width,dash:a}};e.exports={x:{valType:\"data_array\"},open:{valType:\"data_array\",dflt:[]},high:{valType:\"data_array\",dflt:[]},low:{valType:\"data_array\",dflt:[]},close:{valType:\"data_array\",dflt:[]},line:{width:n.extendFlat({},o.width,{}),dash:n.extendFlat({},a,{})},increasing:n.extendDeep({},s,{line:{color:{dflt:\"#3D9970\"}}}),decreasing:n.extendDeep({},s,{line:{color:{dflt:\"#FF4136\"}}}),text:{valType:\"string\",dflt:\"\",arrayOk:!0},tickwidth:{valType:\"number\",min:0,max:.5,dflt:.3}}},{\"../../components/drawing/attributes\":626,\"../../lib\":725,\"../scatter/attributes\":1027}],987:[function(t,e,r){\"use strict\";function n(t,e,r,n){o(t,e,r,n),r(n+\".line.color\"),r(n+\".line.width\",e.line.width),r(n+\".line.dash\",e.line.dash)}var i=t(\"../../lib\"),a=t(\"./ohlc_defaults\"),o=t(\"./direction_defaults\"),s=t(\"./attributes\"),l=t(\"./helpers\");e.exports=function(t,e,r,o){function u(r,n){return i.coerce(t,e,s,r,n)}if(l.pushDummyTransformOpts(t,e),0===a(t,e,u,o))return void(e.visible=!1);u(\"line.width\"),u(\"line.dash\"),n(t,e,u,\"increasing\"),n(t,e,u,\"decreasing\"),u(\"text\"),u(\"tickwidth\")}},{\"../../lib\":725,\"./attributes\":986,\"./direction_defaults\":988,\"./helpers\":989,\"./ohlc_defaults\":991}],988:[function(t,e,r){\"use strict\";e.exports=function(t,e,r,n){r(n+\".showlegend\"),!1===t.showlegend&&(e[n].showlegend=!1),r(n+\".name\",e.name+\" - \"+n)}},{}],989:[function(t,e,r){\"use strict\";function n(t){function e(t,e){return t===e?e>o?a=!0:e<o&&(a=!1):a=t<e,o=e,a}function r(t,r){return i(t)&&i(r)&&e(+t,+r)}function n(t,r){return i(t)&&i(r)&&!e(+t,+r)}var a=!0,o=null;return\"increasing\"===t?r:n}var i=t(\"fast-isnumeric\"),a=t(\"../../lib\");r.pushDummyTransformOpts=function(t,e){var r={type:e.type,_ephemeral:!0};Array.isArray(t.transforms)?t.transforms.push(r):t.transforms=[r]},r.clearEphemeralTransformOpts=function(t){var e=t.transforms;if(Array.isArray(e)){for(var r=0;r<e.length;r++)e[r]._ephemeral&&e.splice(r,1);0===e.length&&delete t.transforms}},r.copyOHLC=function(t,e){t.open&&(e.open=t.open),t.high&&(e.high=t.high),t.low&&(e.low=t.low),t.close&&(e.close=t.close)},r.makeTransform=function(t,e,r){var n=a.extendFlat([],t.transforms);return n[e.transformIndex]={type:t.type,direction:r,open:t.open,high:t.high,low:t.low,close:t.close},n},r.getFilterFn=function(t){return new n(t)},r.addRangeSlider=function(t,e){for(var r=!1,n=0;n<t.length;n++)if(!0===t[n].visible){r=!0;break}r&&(e.xaxis||(e.xaxis={}),e.xaxis.rangeslider||(e.xaxis.rangeslider={}))}},{\"../../lib\":725,\"fast-isnumeric\":130}],990:[function(t,e,r){\"use strict\";var n=t(\"../../plot_api/register\");e.exports={moduleType:\"trace\",name:\"ohlc\",basePlotModule:t(\"../../plots/cartesian\"),categories:[\"cartesian\",\"showLegend\"],meta:{},attributes:t(\"./attributes\"),supplyDefaults:t(\"./defaults\")},n(t(\"../scatter\")),n(t(\"./transform\"))},{\"../../plot_api/register\":756,\"../../plots/cartesian\":776,\"../scatter\":1037,\"./attributes\":986,\"./defaults\":987,\"./transform\":992}],991:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i){var a,o=r(\"x\"),s=r(\"open\"),l=r(\"high\"),u=r(\"low\"),c=r(\"close\");return n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\"],i),a=Math.min(s.length,l.length,u.length,c.length),o&&(a=Math.min(a,o.length))<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.open=s.slice(0,a)),a<l.length&&(e.high=l.slice(0,a)),a<u.length&&(e.low=u.slice(0,a)),a<c.length&&(e.close=c.slice(0,a)),a}},{\"../../registry\":844}],992:[function(t,e,r){\"use strict\";function n(t,e,r){var n={type:\"scatter\",mode:\"lines\",connectgaps:!1,visible:t.visible,opacity:t.opacity,xaxis:t.xaxis,yaxis:t.yaxis,hoverinfo:i(t),transforms:l.makeTransform(t,e,r)},a=t[r];return a&&s.extendFlat(n,{x:t.x||[0],xcalendar:t.xcalendar,y:[].concat(t.low).concat(t.high),text:t.text,name:a.name,showlegend:a.showlegend,line:a.line}),n}function i(t){var e=t.hoverinfo;if(\"all\"===e)return\"x+text+name\";var r=e.split(\"+\"),n=r.indexOf(\"y\"),i=r.indexOf(\"text\");return-1!==n&&(r.splice(n,1),-1===i&&r.push(\"text\")),r.join(\"+\")}function a(t,e,r){var n=r._fullInput,i=n.tickwidth,a=n._minDiff;if(!a){var o=t._fullData,l=[];a=1/0;var u;for(u=0;u<o.length;u++){var c=o[u]._fullInput;if(\"ohlc\"===c.type&&!0===c.visible&&c.xaxis===e._id&&(l.push(c),c.x&&c.x.length>1)){var h=s.simpleMap(c.x,e.d2c,0,r.xcalendar),f=s.distinctVals(h).minDiff;a=Math.min(a,f)}}for(a===1/0&&(a=1),u=0;u<l.length;u++)l[u]._minDiff=a}return a*i}var o=t(\"fast-isnumeric\"),s=t(\"../../lib\"),l=t(\"./helpers\"),u=t(\"../../plots/cartesian/axes\"),c=t(\"../../plots/cartesian/axis_ids\");r.moduleType=\"transform\",r.name=\"ohlc\",r.attributes={},r.supplyDefaults=function(t,e,r,n){return l.clearEphemeralTransformOpts(n),l.copyOHLC(t,e),t},r.transform=function(t,e){for(var r=[],i=0;i<t.length;i++){var a=t[i];\"ohlc\"===a.type?r.push(n(a,e,\"increasing\"),n(a,e,\"decreasing\")):r.push(a)}return l.addRangeSlider(r,e.layout),r},r.calcTransform=function(t,e,r){var n,i=r.direction,s=l.getFilterFn(i),h=c.getFromTrace(t,e,\"x\"),f=c.getFromTrace(t,e,\"y\"),d=a(t,h,e),p=e.open,m=e.high,v=e.low,g=e.close,y=e.text,b=p.length,x=[],_=[],w=[];n=e._fullInput.x?function(t){var r=e.x[t],n=e.xcalendar,i=h.d2c(r,0,n);x.push(h.c2d(i-d,0,n),r,r,r,r,h.c2d(i+d,0,n),null)}:function(t){x.push(t-d,t,t,t,t,t+d,null)};for(var M=function(t,e){return u.tickText(t,t.c2l(e),\"hover\").text},k=e._fullInput.hoverinfo,A=k.split(\"+\"),T=\"all\"===k,S=T||-1!==A.indexOf(\"y\"),E=T||-1!==A.indexOf(\"text\"),L=Array.isArray(y)?function(t){return y[t]||\"\"}:function(){return y},C=0;C<b;C++)s(p[C],g[C])&&o(m[C])&&o(v[C])&&(n(C),function(t,e,r,n){_.push(t,t,e,r,n,n,null)}(p[C],m[C],v[C],g[C]),function(t,e,r,n,i){var a=[];S&&(a.push(\"Open: \"+M(f,e)),a.push(\"High: \"+M(f,r)),a.push(\"Low: \"+M(f,n)),a.push(\"Close: \"+M(f,i))),E&&a.push(L(t));var o=a.join(\"<br>\");w.push(o,o,o,o,o,o,null)}(C,p[C],m[C],v[C],g[C]));e.x=x,e.y=_,e.text=w}},{\"../../lib\":725,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_ids\":769,\"./helpers\":989,\"fast-isnumeric\":130}],993:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/color_attributes\"),i=t(\"../../components/colorbar/attributes\"),a=t(\"../../components/colorscale/scales\"),o=t(\"../../plots/cartesian/layout_attributes\"),s=t(\"../../plots/font_attributes\"),l=t(\"../../lib/extend\").extendDeep,u=t(\"../../lib/extend\").extendFlat;e.exports={domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},labelfont:u({},s,{}),tickfont:u({},s,{}),rangefont:u({},s,{}),dimensions:{_isLinkedToArray:\"dimension\",label:{valType:\"string\"},tickvals:o.tickvals,ticktext:o.ticktext,tickformat:{valType:\"string\",dflt:\"3s\"},visible:{valType:\"boolean\",dflt:!0},range:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},constraintrange:{valType:\"info_array\",items:[{valType:\"number\"},{valType:\"number\"}]},values:{valType:\"data_array\",dflt:[]}},line:u({},l({},n(\"line\"),{colorscale:l({},n(\"line\").colorscale,{dflt:a.Viridis}),autocolorscale:l({},n(\"line\").autocolorscale,{dflt:!1})}),{showscale:{valType:\"boolean\",dflt:!1},colorbar:i})}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/colorscale/scales\":621,\"../../lib/extend\":716,\"../../plots/cartesian/layout_attributes\":777,\"../../plots/font_attributes\":790}],994:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../plots/plots\"),a=t(\"./plot\"),o=t(\"../../constants/xmlns_namespaces\"),s=t(\"./constants\");r.name=\"parcoords\",r.attr=\"type\",r.plot=function(t){var e=i.getSubplotCalcData(t.calcdata,\"parcoords\",\"parcoords\");e.length&&a(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"parcoords\"),a=e._has&&e._has(\"parcoords\");i&&!a&&(n._paperdiv.selectAll(\".parcoords-line-layers\").remove(),n._paperdiv.selectAll(\".parcoords-line-layers\").remove(),n._paperdiv.selectAll(\".parcoords\").remove(),n._paperdiv.selectAll(\".parcoords\").remove(),n._glimages.selectAll(\"*\").remove())},r.toSVG=function(t){function e(e){var n=this,i=n.toDataURL(\"image/png\"),a=r.append(\"svg:image\"),l=t._fullLayout._size,u=t._fullData[e.model.key].domain;a.attr({xmlns:o.svg,\"xlink:href\":i,x:l.l+l.w*u.x[0]-s.overdrag,y:l.t+l.h*(1-u.y[1]),width:(u.x[1]-u.x[0])*l.w+2*s.overdrag,height:(u.y[1]-u.y[0])*l.h,preserveAspectRatio:\"none\"})}var r=t._fullLayout._glimages,i=n.select(t).selectAll(\".svg-container\");i.filter(function(t,e){return e===i.size()-1}).selectAll(\".parcoords-lines.context, .parcoords-lines.focus\").each(e),window.setTimeout(function(){n.selectAll(\"#filterBarPattern\").attr(\"id\",\"filterBarPattern\")},60)}},{\"../../constants/xmlns_namespaces\":707,\"../../plots/plots\":829,\"./constants\":997,\"./plot\":1002,d3:121}],995:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/calc\"),a=t(\"../../lib\");e.exports=function(t,e){var r=!!e.line.colorscale&&a.isArray(e.line.color),o=r?e.line.color:Array.apply(0,Array(e.dimensions.reduce(function(t,e){return Math.max(t,e.values.length)},0))).map(function(){return.5}),s=r?e.line.colorscale:[[0,e.line.color],[1,e.line.color]];return n(e,\"line\")&&i(e,e.line.color,\"line\",\"c\"),[{lineColor:o,cscale:s}]}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"../../lib\":725}],996:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=r.line,u=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+u).remove(),void 0===l||!l.showscale)return void a.autoMargin(t,u);var c=l.color,h=l.cmin,f=l.cmax;n(h)||(h=i.aggNums(Math.min,null,c)),n(f)||(f=i.aggNums(Math.max,null,c));var d=e[0].t.cb=s(t,u),p=o.makeColorScaleFunc(o.extractScale(l.colorscale,h,f),{noNumericCheck:!0});d.fillcolor(p).filllevels({start:h,end:f,size:(f-h)/254}).options(l.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],997:[function(t,e,r){\"use strict\";e.exports={maxDimensionCount:60,overdrag:45,verticalPadding:2,tickDistance:50,canvasPixelRatio:1,blockLineCount:5e3,scatter:!1,layers:[\"contextLineLayer\",\"focusLineLayer\",\"pickLineLayer\"],axisTitleOffset:28,axisExtentOffset:10,bar:{width:4,capturewidth:10,fillcolor:\"magenta\",fillopacity:1,strokecolor:\"white\",strokeopacity:1,strokewidth:1,handleheight:16,handleopacity:1,handleoverlap:0}}},{}],998:[function(t,e,r){\"use strict\";function n(t,e,r,n,i){i(\"line.color\",r),s(t,\"line\")&&a.isArray(t.line.color)?(i(\"line.colorscale\"),l(t,e,n,i,{prefix:\"line.\",cLetter:\"c\"})):i(\"line.color\",r)}function i(t,e){function r(t,e){return a.coerce(n,i,o.dimensions,t,e)}var n,i,s,l=t.dimensions||[],c=e.dimensions=[],h=1/0;for(l.length>u&&(a.log(\"parcoords traces support up to \"+u+\" dimensions at the moment\"),l.splice(u)),s=0;s<l.length;s++)if(n=l[s],i={},a.isPlainObject(n)){var f=r(\"values\"),d=r(\"visible\",f.length>0);d&&(r(\"label\"),r(\"tickvals\"),r(\"ticktext\"),r(\"tickformat\"),r(\"range\"),r(\"constraintrange\"),h=Math.min(h,i.values.length)),i._index=s,c.push(i)}if(isFinite(h))for(s=0;s<c.length;s++)i=c[s],i.visible&&i.values.length>h&&(i.values=i.values.slice(0,h));return c}var a=t(\"../../lib\"),o=t(\"./attributes\"),s=t(\"../../components/colorscale/has_colorscale\"),l=t(\"../../components/colorscale/defaults\"),u=t(\"./constants\").maxDimensionCount;e.exports=function(t,e,r,s){function l(r,n){return a.coerce(t,e,o,r,n)}var u=i(t,e);n(t,e,r,s,l),l(\"domain.x\"),l(\"domain.y\"),Array.isArray(u)&&u.length||(e.visible=!1);var c={family:s.font.family,size:Math.round(s.font.size*(10/12)),color:s.font.color};a.coerceFont(l,\"labelfont\",c),a.coerceFont(l,\"tickfont\",c),a.coerceFont(l,\"rangefont\",c)}},{\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616,\"../../lib\":725,\"./attributes\":993,\"./constants\":997}],999:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.moduleType=\"trace\",n.name=\"parcoords\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"gl\",\"noOpacity\"],n.meta={},e.exports=n},{\"./attributes\":993,\"./base_plot\":994,\"./calc\":995,\"./colorbar\":996,\"./defaults\":998,\"./plot\":1002}],1e3:[function(t,e,r){\"use strict\";function n(t){t.read({x:0,y:0,width:1,height:1,data:x})}function i(t,e,r,n,i){var a=t._gl;a.enable(a.SCISSOR_TEST),a.scissor(e,r,n,i),t.clear({color:[0,0,0,0],depth:1})}function a(t,e,r,a,o,s){function l(n){var c;c=Math.min(a,o-n*a),s.offset=g*n*a,s.count=g*c,0===n&&(window.cancelAnimationFrame(r.currentRafs[u]),delete r.currentRafs[u],i(t,s.scissorX,s.scissorY,s.scissorWidth,s.viewBoxSize[1])),r.clearOnly||(e(s),n*a+c<o&&(r.currentRafs[u]=window.requestAnimationFrame(function(){l(n+1)})),r.drawCompleted=!1)}var u=s.key;r.drawCompleted||(n(t),r.drawCompleted=!0),l(0)}function o(t){return Math.max(m,Math.min(1-m,t))}function s(t,e,r){for(var n=[],i=0;i<256;i++){var a=t(i/255);n.push((e?b:a).concat(r))}return n}function l(t,e){return(t>>>8*e)%256/255}function u(t,e,r,n){for(var i=[],a=0;a<t;a++)for(var s=0;s<v;s++)i.push(s<e?r[s].paddedUnitValues[a]:s===v-1?o(n[a]):s>=v-4?l(a,v-2-s):.5);return i}function c(t,e,r){var n,i,a,o=[];for(i=0;i<t;i++)for(a=0;a<g;a++)for(n=0;n<y;n++)o.push(e[i*v+r*y+n]),r*y+n===v-1&&a%2==0&&(o[o.length-1]*=-1);return o}function h(t,e){var r=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15],n=r.map(function(r){return c(t,e,r)}),i={};return n.forEach(function(t,e){i[\"p\"+e.toString(16)]=t}),i}function f(t,e,r){return t+e<=r}var d=t(\"regl\"),p=t(\"./constants\").verticalPadding,m=1e-6,v=64,g=2,y=4,b=[119,119,119],x=new Uint8Array(4),_=new Uint8Array(4);e.exports=function(t,e,r,n,o,l,c,m,v,g){function y(t){j[0]=t[0],j[1]=t[1]}function b(t,e,i,a,o,s,l,u,c,h,d){var v,g,y,b,x=[t,e],_=p/s,w=[0,1].map(function(){return[0,1,2,3].map(function(){return new Float32Array(16)})}),M=[0,1].map(function(){return[0,1,2,3].map(function(){return new Float32Array(16)})});for(v=0;v<2;v++)for(b=x[v],g=0;g<4;g++)for(y=0;y<16;y++){var k=y+16*g;w[v][g][y]=y+16*g===b?1:0,\n",
       "M[v][g][y]=(!m&&f(y,16*g,I)?A[0===k?0:1+(k-1)%(A.length-1)].filter[v]:v)+(2*v-1)*_}return{key:l,resolution:[r,n],viewBoxPosition:[i+z,a],viewBoxSize:[o,s],i:t,ii:e,dim1A:w[0][0],dim1B:w[0][1],dim1C:w[0][2],dim1D:w[0][3],dim2A:w[1][0],dim2B:w[1][1],dim2C:w[1][2],dim2D:w[1][3],loA:M[0][0],loB:M[0][1],loC:M[0][2],loD:M[0][3],hiA:M[1][0],hiB:M[1][1],hiC:M[1][2],hiD:M[1][3],colorClamp:j,scatter:u||0,scissorX:c===h?0:i+z,scissorWidth:(c===d?r-i+z:o+.5)+(c===h?i+z:0),scissorY:a,scissorHeight:s}}function x(t,o,s){var l,u,c,h=1/0,f=-1/0;for(l=0;l<I;l++)t[l].dim2.canvasX>f&&(f=t[l].dim2.canvasX,c=l),t[l].dim1.canvasX<h&&(h=t[l].dim1.canvasX,u=l);for(0===I&&i(O,0,0,r,n),l=0;l<I;l++){var d=t[l],p=d.dim1,m=p.crossfilterDimensionIndex,v=d.canvasX,y=d.canvasY,x=d.dim2,_=x.crossfilterDimensionIndex,w=d.panelSizeX,M=d.panelSizeY,A=v+w;if(o||!N[m]||N[m][0]!==v||N[m][1]!==A){N[m]=[v,A];var T=b(m,_,v,y,w,M,p.crossfilterDimensionIndex,g||p.scatter?1:0,l,u,c);k.clearOnly=s,a(O,F,k,o?e.blockLineCount:S,S,T)}}}function w(t,e){return O.read({x:t,y:e,width:1,height:1,data:_}),_}function M(t,e,r,n){var i=new Uint8Array(4*r*n);return O.read({x:t,y:e,width:r,height:n,data:i}),i}var k={currentRafs:{},drawCompleted:!0,clearOnly:!1},A=o.slice(),T=A.length,S=A[0]?A[0].values.length:0,E=m,L=v?e.color.map(function(t,r){return r/e.color.length}):e.color,C=Math.max(1/255,Math.pow(1/L.length,1/3)),z=e.canvasOverdrag,I=l.length,D=u(S,T,A,L),P=h(S,D),O=d({canvas:t,attributes:{preserveDrawingBuffer:!0,antialias:!v}}),R=O.texture({shape:[256,1],format:\"rgba\",type:\"uint8\",mag:\"nearest\",min:\"nearest\",data:s(c,m,Math.round(255*(m?C:1)))}),F=O({profile:!1,blend:{enable:E,func:{srcRGB:\"src alpha\",dstRGB:\"one minus src alpha\",srcAlpha:1,dstAlpha:1},equation:{rgb:\"add\",alpha:\"add\"},color:[0,0,0,0]},depth:{enable:!E,mask:!0,func:\"less\",range:[0,1]},cull:{enable:!0,face:\"back\"},scissor:{enable:!0,box:{x:O.prop(\"scissorX\"),y:O.prop(\"scissorY\"),width:O.prop(\"scissorWidth\"),height:O.prop(\"scissorHeight\")}},dither:!1,vert:v?\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec4 p0, p1, p2, p3,\\n               p4, p5, p6, p7,\\n               p8, p9, pa, pb,\\n               pc, pd, pe;\\n\\nattribute vec4 pf;\\n\\nuniform mat4 dim1A, dim2A, dim1B, dim2B, dim1C, dim2C, dim1D, dim2D,\\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\\n\\nuniform vec2 resolution,\\n             viewBoxPosition,\\n             viewBoxSize;\\n\\nuniform sampler2D palette;\\n\\nuniform vec2 colorClamp;\\n\\nuniform float scatter;\\n\\nvarying vec4 fragColor;\\n\\nvec4 zero = vec4(0, 0, 0, 0);\\nvec4 unit = vec4(1, 1, 1, 1);\\nvec2 xyProjection = vec2(1, 1);\\n\\nmat4 mclamp(mat4 m, mat4 lo, mat4 hi) {\\n    return mat4(clamp(m[0], lo[0], hi[0]),\\n                clamp(m[1], lo[1], hi[1]),\\n                clamp(m[2], lo[2], hi[2]),\\n                clamp(m[3], lo[3], hi[3]));\\n}\\n\\nbool mshow(mat4 p, mat4 lo, mat4 hi) {\\n    return mclamp(p, lo, hi) == p;\\n}\\n\\nfloat val(mat4 p, mat4 v) {\\n    return dot(matrixCompMult(p, v) * unit, unit);\\n}\\n\\nvoid main() {\\n\\n    float x = 0.5 * sign(pf[3]) + 0.5;\\n    float prominence = abs(pf[3]);\\n    float depth = 1.0 - prominence;\\n\\n    mat4 pA = mat4(p0, p1, p2, p3);\\n    mat4 pB = mat4(p4, p5, p6, p7);\\n    mat4 pC = mat4(p8, p9, pa, pb);\\n    mat4 pD = mat4(pc, pd, pe, abs(pf));\\n\\n    float show = float(mshow(pA, loA, hiA) &&\\n                       mshow(pB, loB, hiB) &&\\n                       mshow(pC, loC, hiC) &&\\n                       mshow(pD, loD, hiD));\\n\\n    vec2 yy = show * vec2(val(pA, dim2A) + val(pB, dim2B) + val(pC, dim2C) + val(pD, dim2D),\\n                          val(pA, dim1A) + val(pB, dim1B) + val(pC, dim1C) + val(pD, dim1D));\\n\\n    vec2 dimensionToggle = vec2(x, 1.0 - x);\\n\\n    vec2 scatterToggle = vec2(scatter, 1.0 - scatter);\\n\\n    float y = dot(yy, dimensionToggle);\\n    mat2 xy = mat2(viewBoxSize * yy + dimensionToggle, viewBoxSize * vec2(x, y));\\n\\n    vec2 viewBoxXY = viewBoxPosition + xy * scatterToggle;\\n\\n    float depthOrHide = depth + 2.0 * (1.0 - show);\\n\\n    gl_Position = vec4(\\n        xyProjection * (2.0 * viewBoxXY / resolution - 1.0),\\n        depthOrHide,\\n        1.0\\n    );\\n\\n    // pick coloring\\n    fragColor = vec4(pf.rgb, 1.0);\\n}\\n\":\"precision highp float;\\n#define GLSLIFY 1\\n\\nattribute vec4 p0, p1, p2, p3,\\n               p4, p5, p6, p7,\\n               p8, p9, pa, pb,\\n               pc, pd, pe;\\n\\nattribute vec4 pf;\\n\\nuniform mat4 dim1A, dim2A, dim1B, dim2B, dim1C, dim2C, dim1D, dim2D,\\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\\n\\nuniform vec2 resolution,\\n             viewBoxPosition,\\n             viewBoxSize;\\n\\nuniform sampler2D palette;\\n\\nuniform vec2 colorClamp;\\n\\nuniform float scatter;\\n\\nvarying vec4 fragColor;\\n\\nvec4 zero = vec4(0, 0, 0, 0);\\nvec4 unit = vec4(1, 1, 1, 1);\\nvec2 xyProjection = vec2(1, 1);\\n\\nmat4 mclamp(mat4 m, mat4 lo, mat4 hi) {\\n    return mat4(clamp(m[0], lo[0], hi[0]),\\n                clamp(m[1], lo[1], hi[1]),\\n                clamp(m[2], lo[2], hi[2]),\\n                clamp(m[3], lo[3], hi[3]));\\n}\\n\\nbool mshow(mat4 p, mat4 lo, mat4 hi) {\\n    return mclamp(p, lo, hi) == p;\\n}\\n\\nfloat val(mat4 p, mat4 v) {\\n    return dot(matrixCompMult(p, v) * unit, unit);\\n}\\n\\nvoid main() {\\n\\n    float x = 0.5 * sign(pf[3]) + 0.5;\\n    float prominence = abs(pf[3]);\\n    float depth = 1.0 - prominence;\\n\\n    mat4 pA = mat4(p0, p1, p2, p3);\\n    mat4 pB = mat4(p4, p5, p6, p7);\\n    mat4 pC = mat4(p8, p9, pa, pb);\\n    mat4 pD = mat4(pc, pd, pe, abs(pf));\\n\\n    float show = float(mshow(pA, loA, hiA) &&\\n                       mshow(pB, loB, hiB) &&\\n                       mshow(pC, loC, hiC) &&\\n                       mshow(pD, loD, hiD));\\n\\n    vec2 yy = show * vec2(val(pA, dim2A) + val(pB, dim2B) + val(pC, dim2C) + val(pD, dim2D),\\n                          val(pA, dim1A) + val(pB, dim1B) + val(pC, dim1C) + val(pD, dim1D));\\n\\n    vec2 dimensionToggle = vec2(x, 1.0 - x);\\n\\n    vec2 scatterToggle = vec2(scatter, 1.0 - scatter);\\n\\n    float y = dot(yy, dimensionToggle);\\n    mat2 xy = mat2(viewBoxSize * yy + dimensionToggle, viewBoxSize * vec2(x, y));\\n\\n    vec2 viewBoxXY = viewBoxPosition + xy * scatterToggle;\\n\\n    float depthOrHide = depth + 2.0 * (1.0 - show);\\n\\n    gl_Position = vec4(\\n        xyProjection * (2.0 * viewBoxXY / resolution - 1.0),\\n        depthOrHide,\\n        1.0\\n    );\\n\\n    // visible coloring\\n    float clampedColorIndex = clamp((prominence - colorClamp[0]) / (colorClamp[1] - colorClamp[0]), 0.0, 1.0);\\n    fragColor = texture2D(palette, vec2((clampedColorIndex * 255.0 + 0.5) / 256.0, 0.5));\\n}\\n\",frag:\"precision lowp float;\\n#define GLSLIFY 1\\n\\nvarying vec4 fragColor;\\n\\nvoid main() {\\n    gl_FragColor = fragColor;\\n}\\n\",primitive:\"lines\",lineWidth:1,attributes:P,uniforms:{resolution:O.prop(\"resolution\"),viewBoxPosition:O.prop(\"viewBoxPosition\"),viewBoxSize:O.prop(\"viewBoxSize\"),dim1A:O.prop(\"dim1A\"),dim2A:O.prop(\"dim2A\"),dim1B:O.prop(\"dim1B\"),dim2B:O.prop(\"dim2B\"),dim1C:O.prop(\"dim1C\"),dim2C:O.prop(\"dim2C\"),dim1D:O.prop(\"dim1D\"),dim2D:O.prop(\"dim2D\"),loA:O.prop(\"loA\"),hiA:O.prop(\"hiA\"),loB:O.prop(\"loB\"),hiB:O.prop(\"hiB\"),loC:O.prop(\"loC\"),hiC:O.prop(\"hiC\"),loD:O.prop(\"loD\"),hiD:O.prop(\"hiD\"),palette:R,colorClamp:O.prop(\"colorClamp\"),scatter:O.prop(\"scatter\")},offset:O.prop(\"offset\"),count:O.prop(\"count\")}),j=[0,1],N=[];return{setColorDomain:y,render:x,readPixel:w,readPixels:M,destroy:O.destroy}}},{\"./constants\":997,regl:498}],1001:[function(t,e,r){\"use strict\";function n(t){return t.key}function i(t){return[t]}function a(t){return!(\"visible\"in t)||t.visible}function o(t){var e=t.range?t.range[0]:w.min(t.values),r=t.range?t.range[1]:w.max(t.values);return!isNaN(e)&&isFinite(e)||(e=0),!isNaN(r)&&isFinite(r)||(r=0),e===r&&(void 0===e?(e=0,r=1):0===e?(e-=1,r+=1):(e*=.9,r*=1.1)),[e,r]}function s(t,e){var r,n,i,a,o;for(r=0,n=t.range(),i=1/0,a=n[0],o;r<n.length;r++){if((o=Math.abs(n[r]-e))>i)return a;i=o,a=n[r]}return n[n.length-1]}function l(t,e){return function(r,n){if(e){var i=e[n];return null===i||void 0===i?t(r):i}return t(r)}}function u(t,e,r){var n=o(r),i=r.ticktext;return r.tickvals?w.scale.ordinal().domain(r.tickvals.map(l(w.format(r.tickformat),i))).range(r.tickvals.map(function(t){return(t-n[0])/(n[1]-n[0])}).map(function(r){return t-e+r*(e-(t-e))})):w.scale.linear().domain(n).range([t-e,e])}function c(t,e){return w.scale.linear().range([t-e,e])}function h(t){return w.scale.linear().domain(o(t))}function f(t){var e=o(t);return t.tickvals&&w.scale.ordinal().domain(t.tickvals).range(t.tickvals.map(function(t){return(t-e[0])/(e[1]-e[0])}))}function d(t){var e=t.map(function(t){return t[0]}),r=t.map(function(t){return t[1]}),n=r.map(function(t){return w.rgb(t)}),i=function(t){return function(e){return e[t]}},a=\"rgb\".split(\"\").map(function(t){return w.scale.linear().clamp(!0).domain(e).range(n.map(i(t)))});return function(t){return a.map(function(e){return e(t)})}}function p(t){return t[0]}function m(t,e,r){var n=p(e),i=n.trace,o=n.lineColor,s=n.cscale,l=i.line,u=i.domain,c=i.dimensions,f=t.width,m=i.labelfont,v=i.tickfont,g=i.rangefont,y=_.extendDeep({},l,{color:o.map(h({values:o,range:[l.cmin,l.cmax]})),blockLineCount:x.blockLineCount,canvasOverdrag:x.overdrag*x.canvasPixelRatio}),b=Math.floor(f*(u.x[1]-u.x[0])),w=Math.floor(t.height*(u.y[1]-u.y[0])),M=t.margin||{l:80,r:80,t:100,b:80},k=b,A=w;return{key:r,colCount:c.filter(a).length,dimensions:c,tickDistance:x.tickDistance,unitToColor:d(s),lines:y,labelFont:m,tickFont:v,rangeFont:g,translateX:u.x[0]*f,translateY:t.height-u.y[1]*t.height,pad:M,canvasWidth:k*x.canvasPixelRatio+2*y.canvasOverdrag,canvasHeight:A*x.canvasPixelRatio,width:k,height:A,canvasPixelRatio:x.canvasPixelRatio}}function v(t){var e=t.width,r=t.height,n=t.dimensions,i=t.canvasPixelRatio,o=function(r){return e*r/Math.max(1,t.colCount-1)},s=x.verticalPadding/(r*i),l=1-2*s,d=function(t){return s+l*t},p={key:t.key,xScale:o,model:t},m={};return p.dimensions=n.filter(a).map(function(e,n){var a=h(e),s=m[e.label];return m[e.label]=(s||0)+1,{key:e.label+(s?\"__\"+s:\"\"),label:e.label,tickFormat:e.tickformat,tickvals:e.tickvals,ticktext:e.ticktext,ordinal:!!e.tickvals,scatter:x.scatter||e.scatter,xIndex:n,crossfilterDimensionIndex:n,visibleIndex:e._index,height:r,values:e.values,paddedUnitValues:e.values.map(a).map(d),xScale:o,x:o(n),canvasX:o(n)*i,unitScale:c(r,x.verticalPadding),domainScale:u(r,x.verticalPadding,e),ordinalScale:f(e),domainToUnitScale:a,filter:e.constraintrange?e.constraintrange.map(a):[0,1],parent:p,model:t}}),p}function g(t){return x.layers.map(function(e){return{key:e,context:\"contextLineLayer\"===e,pick:\"pickLineLayer\"===e,viewModel:t,model:t.model}})}function y(t){t.classed(\"axisExtentText\",!0).attr(\"text-anchor\",\"middle\").style(\"cursor\",\"default\").style(\"user-select\",\"none\")}var b=t(\"./lines\"),x=t(\"./constants\"),_=t(\"../../lib\"),w=t(\"d3\"),M=t(\"../../components/drawing\");e.exports=function(t,e,r,a,o){function l(t){var e=t.selectAll(\"defs\").data(i,n);e.enter().append(\"defs\");var r=e.selectAll(\"#filterBarPattern\").data(i,n);r.enter().append(\"pattern\").attr(\"id\",\"filterBarPattern\").attr(\"patternUnits\",\"userSpaceOnUse\"),r.attr(\"x\",-x.bar.width).attr(\"width\",x.bar.capturewidth).attr(\"height\",function(t){return t.model.height});var a=r.selectAll(\"rect\").data(i,n);a.enter().append(\"rect\").attr(\"shape-rendering\",\"crispEdges\"),a.attr(\"height\",function(t){return t.model.height}).attr(\"width\",x.bar.width).attr(\"x\",x.bar.width/2).attr(\"fill\",x.bar.fillcolor).attr(\"fill-opacity\",x.bar.fillopacity).attr(\"stroke\",x.bar.strokecolor).attr(\"stroke-opacity\",x.bar.strokeopacity).attr(\"stroke-width\",x.bar.strokewidth)}function u(t){return t.dimensions.some(function(t){return 0!==t.filter[0]||1!==t.filter[1]})}function c(t,e){for(var r=e.panels||(e.panels=[]),n=t.each(function(t){return t})[e.key].map(function(t){return t.__data__}),i=n.length-1,a=0;a<1;a++)for(var o=0;o<i;o++){var s=r[o+a*i]||(r[o+a*i]={}),l=n[o],u=n[o+1];s.dim1=l,s.dim2=u,s.canvasX=l.canvasX,s.panelSizeX=u.canvasX-l.canvasX,s.panelSizeY=e.model.canvasHeight/1,s.y=a*s.panelSizeY,s.canvasY=e.model.canvasHeight-s.y-s.panelSizeY}}function h(t,e){for(var r=e.panels||(e.panels=[]),n=t.each(function(t){return t})[e.key].map(function(t){return t.__data__}),i=n.length-1,a=i,o=0;o<i;o++)for(var s=0;s<i;s++){var l=r[s+o*i]||(r[s+o*i]={}),u=n[s],c=n[s+1];l.dim1=n[o+1],l.dim2=c,l.canvasX=u.canvasX,l.panelSizeX=c.canvasX-u.canvasX,l.panelSizeY=e.model.canvasHeight/a,l.y=o*l.panelSizeY,l.canvasY=e.model.canvasHeight-l.y-l.panelSizeY}}function f(t,e){return(x.scatter?h:c)(t,e)}function d(t){return t.ordinal?function(){return\"\"}:w.format(t.tickFormat)}function _(){X=!0,T=!0}function k(t){S=!1;var e=t.parent,r=t.brush.extent(),n=e.dimensions,i=n[t.xIndex].filter,a=X&&r[0]===r[1];a&&(t.brush.clear(),w.select(this).select(\"rect.extent\").attr(\"y\",-100));var o=a?[0,1]:r.slice();if(o[0]!==i[0]||o[1]!==i[1]){n[t.xIndex].filter=o,e.focusLineLayer&&e.focusLineLayer.render(e.panels,!0);var s=u(e);!W&&s?(e.contextLineLayer&&e.contextLineLayer.render(e.panels,!0),W=!0):W&&!s&&(e.contextLineLayer&&e.contextLineLayer.render(e.panels,!0,!0),W=!1)}X=!1}function A(t){var e=t.parent,r=t.brush.extent(),n=r[0]===r[1],i=e.dimensions,a=i[t.xIndex].filter;if(!n&&t.ordinal&&(a[0]=s(t.ordinalScale,a[0]),a[1]=s(t.ordinalScale,a[1]),a[0]===a[1]&&(a[0]=Math.max(0,a[0]-.05),a[1]=Math.min(1,a[1]+.05)),w.select(this).transition().duration(150).call(t.brush.extent(a)),e.focusLineLayer.render(e.panels,!0)),e.pickLineLayer&&e.pickLineLayer.render(e.panels,!0),S=!0,T=\"ending\",o&&o.filterChanged){var l=t.domainToUnitScale.invert,u=a.map(l);o.filterChanged(e.key,t.visibleIndex,u)}}var T=!1,S=!0,E=r.filter(function(t){return p(t).trace.visible}).map(m.bind(0,a)).map(v);t.selectAll(\".parcoords-line-layers\").remove();var L=t.selectAll(\".parcoords-line-layers\").data(E,n);L.enter().insert(\"div\",\".\"+e.attr(\"class\").split(\" \").join(\" .\")).classed(\"parcoords-line-layers\",!0).style(\"box-sizing\",\"content-box\"),L.style(\"transform\",function(t){return\"translate(\"+(t.model.translateX-x.overdrag)+\"px,\"+t.model.translateY+\"px)\"});var C=L.selectAll(\".parcoords-lines\").data(g,n),z={renderers:[],dimensions:[]},I=null;C.enter().append(\"canvas\").attr(\"class\",function(t){return\"parcoords-lines \"+(t.context?\"context\":t.pick?\"pick\":\"focus\")}).style(\"box-sizing\",\"content-box\").style(\"float\",\"left\").style(\"clear\",\"both\").style(\"left\",0).style(\"overflow\",\"visible\").style(\"position\",function(t,e){return\"absolute\"}).filter(function(t){return t.pick}).on(\"mousemove\",function(t){if(S&&t.lineLayer&&o&&o.hover){var e=w.event,r=this.width,n=this.height,i=w.mouse(this),a=i[0],s=i[1];if(a<0||s<0||a>=r||s>=n)return;var l=t.lineLayer.readPixel(a,n-1-s),u=0!==l[3],c=u?l[2]+256*(l[1]+256*l[0]):null,h={x:a,y:s,clientX:e.clientX,clientY:e.clientY,dataIndex:t.model.key,curveNumber:c};c!==I&&(u?o.hover(h):o.unhover&&o.unhover(h),I=c)}}),C.style(\"margin\",function(t){var e=t.model.pad;return e.t+\"px \"+e.r+\"px \"+e.b+\"px \"+e.l+\"px\"}).attr(\"width\",function(t){return t.model.canvasWidth}).attr(\"height\",function(t){return t.model.canvasHeight}).style(\"width\",function(t){return t.model.width+2*x.overdrag+\"px\"}).style(\"height\",function(t){return t.model.height+\"px\"}).style(\"opacity\",function(t){return t.pick?.01:1}),e.style(\"background\",\"rgba(255, 255, 255, 0)\");var D=e.selectAll(\".parcoords\").data(E,n);D.exit().remove(),D.enter().append(\"g\").classed(\"parcoords\",!0).attr(\"overflow\",\"visible\").style(\"box-sizing\",\"content-box\").style(\"position\",\"absolute\").style(\"left\",0).style(\"overflow\",\"visible\").style(\"shape-rendering\",\"crispEdges\").style(\"pointer-events\",\"none\").call(l),D.attr(\"width\",function(t){return t.model.width+t.model.pad.l+t.model.pad.r}).attr(\"height\",function(t){return t.model.height+t.model.pad.t+t.model.pad.b}).attr(\"transform\",function(t){return\"translate(\"+t.model.translateX+\",\"+t.model.translateY+\")\"});var P=D.selectAll(\".parcoordsControlView\").data(i,n);P.enter().append(\"g\").classed(\"parcoordsControlView\",!0).style(\"box-sizing\",\"content-box\"),P.attr(\"transform\",function(t){return\"translate(\"+t.model.pad.l+\",\"+t.model.pad.t+\")\"});var O=P.selectAll(\".yAxis\").data(function(t){return t.dimensions},n);O.enter().append(\"g\").classed(\"yAxis\",!0).each(function(t){z.dimensions.push(t)}),P.each(function(t){f(O,t)}),C.each(function(t){t.lineLayer=b(this,t.model.lines,t.model.canvasWidth,t.model.canvasHeight,t.viewModel.dimensions,t.viewModel.panels,t.model.unitToColor,t.context,t.pick,x.scatter),t.viewModel[t.key]=t.lineLayer,z.renderers.push(function(){t.lineLayer.render(t.viewModel.panels,!0)}),t.lineLayer.render(t.viewModel.panels,!t.context)}),O.attr(\"transform\",function(t){return\"translate(\"+t.xScale(t.xIndex)+\", 0)\"}),O.call(w.behavior.drag().origin(function(t){return t}).on(\"drag\",function(t){var e=t.parent;S=!1,T||(t.x=Math.max(-x.overdrag,Math.min(t.model.width+x.overdrag,w.event.x)),t.canvasX=t.x*t.model.canvasPixelRatio,O.sort(function(t,e){return t.x-e.x}).each(function(e,r){e.xIndex=r,e.x=t===e?e.x:e.xScale(e.xIndex),e.canvasX=e.x*e.model.canvasPixelRatio}),f(O,e),O.filter(function(e){return 0!==Math.abs(t.xIndex-e.xIndex)}).attr(\"transform\",function(t){return\"translate(\"+t.xScale(t.xIndex)+\", 0)\"}),w.select(this).attr(\"transform\",\"translate(\"+t.x+\", 0)\"),O.each(function(r,n,i){i===t.parent.key&&(e.dimensions[n]=r)}),e.contextLineLayer&&e.contextLineLayer.render(e.panels,!1,!u(e)),e.focusLineLayer.render&&e.focusLineLayer.render(e.panels))}).on(\"dragend\",function(t){var e=t.parent;if(T)return void(\"ending\"===T&&(T=!1));t.x=t.xScale(t.xIndex),t.canvasX=t.x*t.model.canvasPixelRatio,f(O,e),w.select(this).attr(\"transform\",function(t){return\"translate(\"+t.x+\", 0)\"}),e.contextLineLayer&&e.contextLineLayer.render(e.panels,!1,!u(e)),e.focusLineLayer&&e.focusLineLayer.render(e.panels),e.pickLineLayer&&e.pickLineLayer.render(e.panels,!0),S=!0,o&&o.axesMoved&&o.axesMoved(e.key,e.dimensions.map(function(t){return t.crossfilterDimensionIndex}))})),O.exit().remove();var R=O.selectAll(\".axisOverlays\").data(i,n);R.enter().append(\"g\").classed(\"axisOverlays\",!0),R.selectAll(\".axis\").remove();var F=R.selectAll(\".axis\").data(i,n);F.enter().append(\"g\").classed(\"axis\",!0),F.each(function(t){var e=t.model.height/t.model.tickDistance,r=t.domainScale,n=r.domain();w.select(this).call(w.svg.axis().orient(\"left\").tickSize(4).outerTickSize(2).ticks(e,t.tickFormat).tickValues(t.ordinal?n:null).tickFormat(t.ordinal?function(t){return t}:null).scale(r)),M.font(F.selectAll(\"text\"),t.model.tickFont)}),F.selectAll(\".domain, .tick>line\").attr(\"fill\",\"none\").attr(\"stroke\",\"black\").attr(\"stroke-opacity\",.25).attr(\"stroke-width\",\"1px\"),F.selectAll(\"text\").style(\"text-shadow\",\"1px 1px 1px #fff, -1px -1px 1px #fff, 1px -1px 1px #fff, -1px 1px 1px #fff\").style(\"cursor\",\"default\").style(\"user-select\",\"none\");var j=R.selectAll(\".axisHeading\").data(i,n);j.enter().append(\"g\").classed(\"axisHeading\",!0);var N=j.selectAll(\".axisTitle\").data(i,n);N.enter().append(\"text\").classed(\"axisTitle\",!0).attr(\"text-anchor\",\"middle\").style(\"cursor\",\"ew-resize\").style(\"user-select\",\"none\").style(\"pointer-events\",\"auto\"),N.attr(\"transform\",\"translate(0,\"+-x.axisTitleOffset+\")\").text(function(t){return t.label}).each(function(t){M.font(N,t.model.labelFont)});var B=R.selectAll(\".axisExtent\").data(i,n);B.enter().append(\"g\").classed(\"axisExtent\",!0);var U=B.selectAll(\".axisExtentTop\").data(i,n);U.enter().append(\"g\").classed(\"axisExtentTop\",!0),U.attr(\"transform\",\"translate(0,\"+-x.axisExtentOffset+\")\");var V=U.selectAll(\".axisExtentTopText\").data(i,n);V.enter().append(\"text\").classed(\"axisExtentTopText\",!0).attr(\"alignment-baseline\",\"after-edge\").call(y),V.text(function(t){return d(t)(t.domainScale.domain().slice(-1)[0])}).each(function(t){M.font(V,t.model.rangeFont)});var H=B.selectAll(\".axisExtentBottom\").data(i,n);H.enter().append(\"g\").classed(\"axisExtentBottom\",!0),H.attr(\"transform\",function(t){return\"translate(0,\"+(t.model.height+x.axisExtentOffset)+\")\"});var q=H.selectAll(\".axisExtentBottomText\").data(i,n);q.enter().append(\"text\").classed(\"axisExtentBottomText\",!0).attr(\"alignment-baseline\",\"before-edge\").call(y),q.text(function(t){return d(t)(t.domainScale.domain()[0])}).each(function(t){M.font(q,t.model.rangeFont)});var G=R.selectAll(\".axisBrush\").data(i,n),Y=G.enter().append(\"g\").classed(\"axisBrush\",!0);G.each(function(t){t.brush||(t.brush=w.svg.brush().y(t.unitScale).on(\"brushstart\",_).on(\"brush\",k).on(\"brushend\",A),0===t.filter[0]&&1===t.filter[1]||t.brush.extent(t.filter),w.select(this).call(t.brush))}),Y.selectAll(\"rect\").attr(\"x\",-x.bar.capturewidth/2).attr(\"width\",x.bar.capturewidth),Y.selectAll(\"rect.extent\").attr(\"fill\",\"url(#filterBarPattern)\").style(\"cursor\",\"ns-resize\").filter(function(t){return 0===t.filter[0]&&1===t.filter[1]}).attr(\"y\",-100),Y.selectAll(\".resize rect\").attr(\"height\",x.bar.handleheight).attr(\"opacity\",0).style(\"visibility\",\"visible\"),Y.selectAll(\".resize.n rect\").style(\"cursor\",\"n-resize\").attr(\"y\",x.bar.handleoverlap-x.bar.handleheight),Y.selectAll(\".resize.s rect\").style(\"cursor\",\"s-resize\").attr(\"y\",x.bar.handleoverlap);var X=!1,W=!1;return z}},{\"../../components/drawing\":627,\"../../lib\":725,\"./constants\":997,\"./lines\":1e3,d3:121}],1002:[function(t,e,r){\"use strict\";var n=t(\"./parcoords\");e.exports=function(t,e){var r=t._fullLayout,i=r._paper,a=r._paperdiv,o={},s={},l=r._size;e.forEach(function(e,r){o[r]=t.data[r].dimensions,s[r]=t.data[r].dimensions.slice()});var u=function(e,r,n){var i=s[e][r],a=i.constraintrange;a&&2===a.length||(a=i.constraintrange=[]),a[0]=n[0],a[1]=n[1],t.emit(\"plotly_restyle\")},c=function(e){t.emit(\"plotly_hover\",e)},h=function(e){t.emit(\"plotly_unhover\",e)},f=function(e,r){function n(t){return!(\"visible\"in t)||t.visible}function i(t,e,r){var n=e.indexOf(r),i=t.indexOf(n);return-1===i&&(i+=e.length),i}var a=function(t){return function(e,n){return i(r,t,e)-i(r,t,n)}}(s[e].filter(n));o[e].sort(a),s[e].filter(function(t){return!n(t)}).sort(function(t){return s[e].indexOf(t)}).forEach(function(t){o[e].splice(o[e].indexOf(t),1),o[e].splice(s[e].indexOf(t),0,t)}),t.emit(\"plotly_restyle\")};n(a,i,e,{width:l.w,height:l.h,margin:{t:l.t,r:l.r,b:l.b,l:l.l}},{filterChanged:u,hover:c,unhover:h,axesMoved:f})}},{\"./parcoords\":1001}],1003:[function(t,e,r){\"use strict\";var n=t(\"../../components/color/attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/attributes\"),o=t(\"../../lib/extend\").extendFlat;e.exports={labels:{valType:\"data_array\"},label0:{valType:\"number\",dflt:0},dlabel:{valType:\"number\",dflt:1},values:{valType:\"data_array\"},marker:{colors:{valType:\"data_array\"},line:{color:{valType:\"color\",dflt:n.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:0,arrayOk:!0}}},text:{valType:\"data_array\"},hovertext:{valType:\"string\",dflt:\"\",arrayOk:!0},scalegroup:{valType:\"string\",dflt:\"\"},textinfo:{valType:\"flaglist\",flags:[\"label\",\"text\",\"value\",\"percent\"],extras:[\"none\"]},hoverinfo:o({},a.hoverinfo,{flags:[\"label\",\"text\",\"value\",\"percent\",\"name\"]}),textposition:{valType:\"enumerated\",values:[\"inside\",\"outside\",\"auto\",\"none\"],dflt:\"auto\",arrayOk:!0},textfont:o({},i,{}),insidetextfont:o({},i,{}),outsidetextfont:o({},i,{}),domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},hole:{valType:\"number\",min:0,max:1,dflt:0},sort:{valType:\"boolean\",dflt:!0},direction:{valType:\"enumerated\",values:[\"clockwise\",\"counterclockwise\"],dflt:\"counterclockwise\"},rotation:{valType:\"number\",min:-360,max:360,dflt:0},pull:{valType:\"number\",min:0,max:1,dflt:0,arrayOk:!0}}},{\"../../components/color/attributes\":602,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/font_attributes\":790}],1004:[function(t,e,r){\"use strict\";function n(t,e){for(var r=[],n=0;n<t.length;n++){var i=t[n],a=i[0].trace;a._module===e&&!0===a.visible&&r.push(i)}return r}var i=t(\"../../registry\");r.name=\"pie\",r.plot=function(t){var e=i.getModule(\"pie\"),r=n(t.calcdata,e);r.length&&e.plot(t,r)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"pie\"),a=e._has&&e._has(\"pie\");i&&!a&&n._pielayer.selectAll(\"g.trace\").remove()}},{\"../../registry\":844}],1005:[function(t,e,r){\"use strict\";function n(t){if(!l){var e=o.defaults;l=e.slice();var r;for(r=0;r<e.length;r++)l.push(a(e[r]).lighten(20).toHexString());for(r=0;r<o.defaults.length;r++)l.push(a(e[r]).darken(20).toHexString())}return l[t%l.length]}var i=t(\"fast-isnumeric\"),a=t(\"tinycolor2\"),o=t(\"../../components/color\"),s=t(\"./helpers\");e.exports=function(t,e){var r,l,u,c,h,f,d=e.values,p=e.labels,m=[],v=t._fullLayout,g=v._piecolormap,y={},b=!1,x=0,_=v.hiddenlabels||[];if(e.dlabel)for(p=new Array(d.length),r=0;r<d.length;r++)p[r]=String(e.label0+r*e.dlabel);for(r=0;r<d.length;r++)l=d[r],i(l)&&((l=+l)<0||(u=p[r],void 0!==u&&\"\"!==u||(u=r),u=String(u),void 0===y[u]&&(y[u]=!0,c=a(e.marker.colors[r]),c.isValid()?(c=o.addOpacity(c,c.getAlpha()),g[u]||(g[u]=c)):g[u]?c=g[u]:(c=!1,b=!0),h=-1!==_.indexOf(u),h||(x+=l),m.push({v:l,label:u,color:c,i:r,hidden:h}))));if(e.sort&&m.sort(function(t,e){return e.v-t.v}),b)for(r=0;r<m.length;r++)f=m[r],!1===f.color&&(g[f.label]=f.color=n(v._piedefaultcolorcount),v._piedefaultcolorcount++);if(m[0]&&(m[0].vTotal=x),e.textinfo&&\"none\"!==e.textinfo){var w,M=-1!==e.textinfo.indexOf(\"label\"),k=-1!==e.textinfo.indexOf(\"text\"),A=-1!==e.textinfo.indexOf(\"value\"),T=-1!==e.textinfo.indexOf(\"percent\"),S=v.separators;for(r=0;r<m.length;r++)f=m[r],w=M?[f.label]:[],k&&e.text[f.i]&&w.push(e.text[f.i]),A&&w.push(s.formatPieValue(f.v,S)),T&&w.push(s.formatPiePercent(f.v/x,S)),f.text=w.join(\"<br>\")}return m};var l},{\"../../components/color\":603,\"./helpers\":1007,\"fast-isnumeric\":130,tinycolor2:533}],1006:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r,a){function o(r,a){return n.coerce(t,e,i,r,a)}var s=n.coerceFont,l=o(\"values\");if(!Array.isArray(l)||!l.length)return void(e.visible=!1);var u=o(\"labels\");Array.isArray(u)||(o(\"label0\"),o(\"dlabel\")),o(\"marker.line.width\")&&o(\"marker.line.color\");var c=o(\"marker.colors\");Array.isArray(c)||(e.marker.colors=[]),o(\"scalegroup\");var h=o(\"text\"),f=o(\"textinfo\",Array.isArray(h)?\"text+percent\":\"percent\");if(o(\"hovertext\"),f&&\"none\"!==f){var d=o(\"textposition\"),p=Array.isArray(d)||\"auto\"===d,m=p||\"inside\"===d,v=p||\"outside\"===d;if(m||v){var g=s(o,\"textfont\",a.font);m&&s(o,\"insidetextfont\",g),v&&s(o,\"outsidetextfont\",g)}}o(\"domain.x\"),o(\"domain.y\"),o(\"hole\"),o(\"sort\"),o(\"direction\"),o(\"rotation\"),o(\"pull\")}},{\"../../lib\":725,\"./attributes\":1003}],1007:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");r.formatPiePercent=function(t,e){var r=(100*t).toPrecision(3);return-1!==r.lastIndexOf(\".\")&&(r=r.replace(/[.]?0+$/,\"\")),n.numSeparate(r,e)+\"%\"},r.formatPieValue=function(t,e){var r=t.toPrecision(10);return-1!==r.lastIndexOf(\".\")&&(r=r.replace(/[.]?0+$/,\"\")),n.numSeparate(r,e)}},{\"../../lib\":725}],1008:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.supplyLayoutDefaults=t(\"./layout_defaults\"),n.layoutAttributes=t(\"./layout_attributes\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.styleOne=t(\"./style_one\"),n.moduleType=\"trace\",n.name=\"pie\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"pie\",\"showLegend\"],n.meta={},e.exports=n},{\"./attributes\":1003,\"./base_plot\":1004,\"./calc\":1005,\"./defaults\":1006,\"./layout_attributes\":1009,\"./layout_defaults\":1010,\"./plot\":1011,\"./style\":1012,\"./style_one\":1013}],1009:[function(t,e,r){\"use strict\";e.exports={hiddenlabels:{valType:\"data_array\"}}},{}],1010:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./layout_attributes\");e.exports=function(t,e){!function(r,a){n.coerce(t,e,i,r,a)}(\"hiddenlabels\")}},{\"../../lib\":725,\"./layout_attributes\":1009}],1011:[function(t,e,r){\"use strict\";function n(t,e,r){var n=Math.sqrt(t.width*t.width+t.height*t.height),a=t.width/t.height,o=Math.PI*Math.min(e.v/r.vTotal,.5),s=1-r.trace.hole,l=i(e,r),u={scale:l*r.r*2/n,rCenter:1-l,rotate:0};if(u.scale>=1)return u;var c=a+1/(2*Math.tan(o)),h=r.r*Math.min(1/(Math.sqrt(c*c+.5)+c),s/(Math.sqrt(a*a+s/2)+a)),f={scale:2*h/t.height,rCenter:Math.cos(h/r.r)-h*a/r.r,rotate:(180/Math.PI*e.midangle+720)%180-90},d=1/a,p=d+1/(2*Math.tan(o)),m=r.r*Math.min(1/(Math.sqrt(p*p+.5)+p),s/(Math.sqrt(d*d+s/2)+d)),v={scale:2*m/t.width,rCenter:Math.cos(m/r.r)-m/a/r.r,rotate:(180/Math.PI*e.midangle+810)%180-90},g=v.scale>f.scale?v:f;return u.scale<1&&g.scale>u.scale?g:u}function i(t,e){if(t.v===e.vTotal&&!e.trace.hole)return 1;var r=Math.PI*Math.min(t.v/e.vTotal,.5);return Math.min(1/(1+1/Math.sin(r)),(1-e.trace.hole)/2)}function a(t,e){var r=e.pxmid[0],n=e.pxmid[1],i=t.width/2,a=t.height/2;return r<0&&(i*=-1),n<0&&(a*=-1),{scale:1,rCenter:1,rotate:0,x:i+Math.abs(a)*(i>0?1:-1)/2,y:a/(1+r*r/(n*n)),outside:!0}}function o(t,e){function r(t,e){return t.pxmid[1]-e.pxmid[1]}function n(t,e){return e.pxmid[1]-t.pxmid[1]}var i,a,o,s,l,u,c,h,f,d,p,m,v;for(a=0;a<2;a++)for(o=a?r:n,l=a?Math.max:Math.min,c=a?1:-1,i=0;i<2;i++){for(s=i?Math.max:Math.min,u=i?1:-1,h=t[a][i],h.sort(o),f=t[1-a][i],d=f.concat(h),m=[],p=0;p<h.length;p++)void 0!==h[p].yLabelMid&&m.push(h[p]);for(v=!1,p=0;a&&p<f.length;p++)if(void 0!==f[p].yLabelMid){v=f[p];break}for(p=0;p<m.length;p++){var g=p&&m[p-1];v&&!p&&(g=v),function(t,r){r||(r={});var n,i,o,h,f,p,m=r.labelExtraY+(a?r.yLabelMax:r.yLabelMin),v=a?t.yLabelMin:t.yLabelMax,g=a?t.yLabelMax:t.yLabelMin,y=t.cyFinal+l(t.px0[1],t.px1[1]),b=m-v;if(b*c>0&&(t.labelExtraY=b),Array.isArray(e.pull))for(i=0;i<d.length;i++)(o=d[i])===t||(e.pull[t.i]||0)>=e.pull[o.i]||((t.pxmid[1]-o.pxmid[1])*c>0?(h=o.cyFinal+l(o.px0[1],o.px1[1]),(b=h-v-t.labelExtraY)*c>0&&(t.labelExtraY+=b)):(g+t.labelExtraY-y)*c>0&&(n=3*u*Math.abs(i-d.indexOf(t)),f=o.cxFinal+s(o.px0[0],o.px1[0]),(p=f+n-(t.cxFinal+t.pxmid[0])-t.labelExtraX)*u>0&&(t.labelExtraX+=p)))}(m[p],g)}}}function s(t,e){var r,n,i,a,o,s,l,c,h,f,d=[];for(i=0;i<t.length;i++){if(o=t[i][0],s=o.trace,r=e.w*(s.domain.x[1]-s.domain.x[0]),n=e.h*(s.domain.y[1]-s.domain.y[0]),l=s.tiltaxis*Math.PI/180,c=s.pull,Array.isArray(c))for(c=0,a=0;a<s.pull.length;a++)s.pull[a]>c&&(c=s.pull[a]);o.r=Math.min(r/u(s.tilt,Math.sin(l),s.depth),n/u(s.tilt,Math.cos(l),s.depth))/(2+2*c),o.cx=e.l+e.w*(s.domain.x[1]+s.domain.x[0])/2,o.cy=e.t+e.h*(2-s.domain.y[1]-s.domain.y[0])/2,s.scalegroup&&-1===d.indexOf(s.scalegroup)&&d.push(s.scalegroup)}for(a=0;a<d.length;a++){for(f=1/0,h=d[a],i=0;i<t.length;i++)o=t[i][0],o.trace.scalegroup===h&&(f=Math.min(f,o.r*o.r/o.vTotal));for(i=0;i<t.length;i++)o=t[i][0],o.trace.scalegroup===h&&(o.r=Math.sqrt(f*o.vTotal))}}function l(t){function e(t){var e=h.r*Math.sin(t),r=-h.r*Math.cos(t);return d?[e*(1-s*n*n)+r*o*s,e*o*s+r*(1-s*i*i),Math.sin(a)*(r*i-e*n)]:[e,r]}var r,n,i,a,o,s,l,u,c,h=t[0],f=h.trace,d=f.tilt,p=f.rotation*Math.PI/180,m=2*Math.PI/h.vTotal,v=\"px0\",g=\"px1\";if(\"counterclockwise\"===f.direction){for(l=0;l<t.length&&t[l].hidden;l++);if(l===t.length)return;p+=m*t[l].v,m*=-1,v=\"px1\",g=\"px0\"}for(d&&(a=d*Math.PI/180,r=f.tiltaxis*Math.PI/180,o=Math.sin(r)*Math.cos(r),s=1-Math.cos(a),n=Math.sin(r),i=Math.cos(r)),c=e(p),l=0;l<t.length;l++)u=t[l],u.hidden||(u[v]=c,p+=m*u.v/2,u.pxmid=e(p),u.midangle=p,p+=m*u.v/2,c=e(p),u[g]=c,u.largeArc=u.v>h.vTotal/2?1:0)}function u(t,e,r){if(!t)return 1;var n=Math.sin(t*Math.PI/180);return Math.max(.01,r*n*Math.abs(e)+2*Math.sqrt(1-n*n*e*e))}var c=t(\"d3\"),h=t(\"../../components/fx\"),f=t(\"../../components/color\"),d=t(\"../../components/drawing\"),p=t(\"../../lib/svg_text_utils\"),m=t(\"./helpers\");e.exports=function(t,e){var r=t._fullLayout;s(e,r._size);var u=r._pielayer.selectAll(\"g.trace\").data(e);u.enter().append(\"g\").attr({\"stroke-linejoin\":\"round\",class:\"trace\"}),u.exit().remove(),u.order(),u.each(function(e){\n",
       "var s=c.select(this),u=e[0],v=u.trace,g=(v.depth||0)*u.r*Math.sin(0)/2,y=v.tiltaxis||0,b=y*Math.PI/180,x=[g*Math.sin(b),g*Math.cos(b)],_=u.r*Math.cos(0),w=s.selectAll(\"g.part\").data(v.tilt?[\"top\",\"sides\"]:[\"top\"]);w.enter().append(\"g\").attr(\"class\",function(t){return t+\" part\"}),w.exit().remove(),w.order(),l(e),s.selectAll(\".top\").each(function(){var s=c.select(this).selectAll(\"g.slice\").data(e);s.enter().append(\"g\").classed(\"slice\",!0),s.exit().remove();var l=[[[],[]],[[],[]]],g=!1;s.each(function(e){function o(n){n.originalEvent=c.event;var a=t._fullLayout,o=t._fullData[v.index],s=h.castHoverinfo(o,a,e.i);if(\"all\"===s&&(s=\"label+text+value+percent+name\"),t._dragging||!1===a.hovermode||\"none\"===s||\"skip\"===s||!s)return void h.hover(t,n,\"pie\");var l=i(e,u),f=w+e.pxmid[0]*(1-l),d=M+e.pxmid[1]*(1-l),p=r.separators,g=[];-1!==s.indexOf(\"label\")&&g.push(e.label),-1!==s.indexOf(\"text\")&&(o.hovertext?g.push(Array.isArray(o.hovertext)?o.hovertext[e.i]:o.hovertext):o.text&&o.text[e.i]&&g.push(o.text[e.i])),-1!==s.indexOf(\"value\")&&g.push(m.formatPieValue(e.v,p)),-1!==s.indexOf(\"percent\")&&g.push(m.formatPiePercent(e.v/u.vTotal,p)),h.loneHover({x0:f-l*u.r,x1:f+l*u.r,y:d,text:g.join(\"<br>\"),name:-1!==s.indexOf(\"name\")?o.name:void 0,idealAlign:e.pxmid[0]<0?\"left\":\"right\",color:h.castHoverOption(v,e.i,\"bgcolor\")||e.color,borderColor:h.castHoverOption(v,e.i,\"bordercolor\"),fontFamily:h.castHoverOption(v,e.i,\"font.family\"),fontSize:h.castHoverOption(v,e.i,\"font.size\"),fontColor:h.castHoverOption(v,e.i,\"font.color\")},{container:a._hoverlayer.node(),outerContainer:a._paper.node(),gd:t}),h.hover(t,n,\"pie\"),T=!0}function s(e){e.originalEvent=c.event,t.emit(\"plotly_unhover\",{event:c.event,points:[e]}),T&&(h.loneUnhover(r._hoverlayer.node()),T=!1)}function f(){t._hoverdata=[e],t._hoverdata.trace=u.trace,h.click(t,c.event)}function b(t,r,n,i){return\"a\"+i*u.r+\",\"+i*_+\" \"+y+\" \"+e.largeArc+(n?\" 1 \":\" 0 \")+i*(r[0]-t[0])+\",\"+i*(r[1]-t[1])}if(e.hidden)return void c.select(this).selectAll(\"path,g\").remove();e.pointNumber=e.i,e.curveNumber=v.index,l[e.pxmid[1]<0?0:1][e.pxmid[0]<0?0:1].push(e);var w=u.cx+x[0],M=u.cy+x[1],k=c.select(this),A=k.selectAll(\"path.surface\").data([e]),T=!1;if(A.enter().append(\"path\").classed(\"surface\",!0).style({\"pointer-events\":\"all\"}),k.select(\"path.textline\").remove(),k.on(\"mouseover\",o).on(\"mouseout\",s).on(\"click\",f),v.pull){var S=+(Array.isArray(v.pull)?v.pull[e.i]:v.pull)||0;S>0&&(w+=S*e.pxmid[0],M+=S*e.pxmid[1])}e.cxFinal=w,e.cyFinal=M;var E=v.hole;if(e.v===u.vTotal){var L=\"M\"+(w+e.px0[0])+\",\"+(M+e.px0[1])+b(e.px0,e.pxmid,!0,1)+b(e.pxmid,e.px0,!0,1)+\"Z\";E?A.attr(\"d\",\"M\"+(w+E*e.px0[0])+\",\"+(M+E*e.px0[1])+b(e.px0,e.pxmid,!1,E)+b(e.pxmid,e.px0,!1,E)+\"Z\"+L):A.attr(\"d\",L)}else{var C=b(e.px0,e.px1,!0,1);if(E){var z=1-E;A.attr(\"d\",\"M\"+(w+E*e.px1[0])+\",\"+(M+E*e.px1[1])+b(e.px1,e.px0,!1,E)+\"l\"+z*e.px0[0]+\",\"+z*e.px0[1]+C+\"Z\")}else A.attr(\"d\",\"M\"+w+\",\"+M+\"l\"+e.px0[0]+\",\"+e.px0[1]+C+\"Z\")}var I=Array.isArray(v.textposition)?v.textposition[e.i]:v.textposition,D=k.selectAll(\"g.slicetext\").data(e.text&&\"none\"!==I?[0]:[]);D.enter().append(\"g\").classed(\"slicetext\",!0),D.exit().remove(),D.each(function(){var r=c.select(this).selectAll(\"text\").data([0]);r.enter().append(\"text\").attr(\"data-notex\",1),r.exit().remove(),r.text(e.text).attr({class:\"slicetext\",transform:\"\",\"text-anchor\":\"middle\"}).call(d.font,\"outside\"===I?v.outsidetextfont:v.insidetextfont).call(p.convertToTspans,t);var i,o=d.bBox(r.node());\"outside\"===I?i=a(o,e):(i=n(o,e,u),\"auto\"===I&&i.scale<1&&(r.call(d.font,v.outsidetextfont),v.outsidetextfont.family===v.insidetextfont.family&&v.outsidetextfont.size===v.insidetextfont.size||(o=d.bBox(r.node())),i=a(o,e)));var s=w+e.pxmid[0]*i.rCenter+(i.x||0),l=M+e.pxmid[1]*i.rCenter+(i.y||0);i.outside&&(e.yLabelMin=l-o.height/2,e.yLabelMid=l,e.yLabelMax=l+o.height/2,e.labelExtraX=0,e.labelExtraY=0,g=!0),r.attr(\"transform\",\"translate(\"+s+\",\"+l+\")\"+(i.scale<1?\"scale(\"+i.scale+\")\":\"\")+(i.rotate?\"rotate(\"+i.rotate+\")\":\"\")+\"translate(\"+-(o.left+o.right)/2+\",\"+-(o.top+o.bottom)/2+\")\")})}),g&&o(l,v),s.each(function(t){if(t.labelExtraX||t.labelExtraY){var e=c.select(this),r=e.select(\"g.slicetext text\");r.attr(\"transform\",\"translate(\"+t.labelExtraX+\",\"+t.labelExtraY+\")\"+r.attr(\"transform\"));var n=t.cxFinal+t.pxmid[0],i=t.cyFinal+t.pxmid[1],a=\"M\"+n+\",\"+i,o=(t.yLabelMax-t.yLabelMin)*(t.pxmid[0]<0?-1:1)/4;if(t.labelExtraX){var s=t.labelExtraX*t.pxmid[1]/t.pxmid[0],l=t.yLabelMid+t.labelExtraY-(t.cyFinal+t.pxmid[1]);Math.abs(s)>Math.abs(l)?a+=\"l\"+l*t.pxmid[0]/t.pxmid[1]+\",\"+l+\"H\"+(n+t.labelExtraX+o):a+=\"l\"+t.labelExtraX+\",\"+s+\"v\"+(l-s)+\"h\"+o}else a+=\"V\"+(t.yLabelMid+t.labelExtraY)+\"h\"+o;e.append(\"path\").classed(\"textline\",!0).call(f.stroke,v.outsidetextfont.color).attr({\"stroke-width\":Math.min(2,v.outsidetextfont.size/8),d:a,fill:\"none\"})}})})}),setTimeout(function(){u.selectAll(\"tspan\").each(function(){var t=c.select(this);t.attr(\"dy\")&&t.attr(\"dy\",t.attr(\"dy\"))})},0)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../components/fx\":644,\"../../lib/svg_text_utils\":745,\"./helpers\":1007,d3:121}],1012:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"./style_one\");e.exports=function(t){t._fullLayout._pielayer.selectAll(\".trace\").each(function(t){var e=t[0],r=e.trace,a=n.select(this);a.style({opacity:r.opacity}),a.selectAll(\".top path.surface\").each(function(t){n.select(this).call(i,t,r)})})}},{\"./style_one\":1013,d3:121}],1013:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\");e.exports=function(t,e,r){var i=r.marker.line.color;Array.isArray(i)&&(i=i[e.i]||n.defaultLine);var a=r.marker.line.width||0;Array.isArray(a)&&(a=a[e.i]||0),t.style({\"stroke-width\":a}).call(n.fill,e.color).call(n.stroke,i)}},{\"../../components/color\":603}],1014:[function(t,e,r){\"use strict\";var n=t(\"../scattergl/attributes\");e.exports={x:n.x,y:n.y,xy:{valType:\"data_array\"},indices:{valType:\"data_array\"},xbounds:{valType:\"data_array\"},ybounds:{valType:\"data_array\"},text:n.text,marker:{color:{valType:\"color\",arrayOk:!1},opacity:{valType:\"number\",min:0,max:1,dflt:1,arrayOk:!1},blend:{valType:\"boolean\",dflt:null},sizemin:{valType:\"number\",min:.1,max:2,dflt:.5},sizemax:{valType:\"number\",min:.1,dflt:20},border:{color:{valType:\"color\",arrayOk:!1},arearatio:{valType:\"number\",min:0,max:1,dflt:0}}}}},{\"../scattergl/attributes\":1071}],1015:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"pointcloud\",this.pickXData=[],this.pickYData=[],this.xData=[],this.yData=[],this.textLabels=[],this.color=\"rgb(0, 0, 0)\",this.name=\"\",this.hoverinfo=\"all\",this.idToIndex=new Int32Array(0),this.bounds=[0,0,0,0],this.pointcloudOptions={positions:new Float32Array(0),idToIndex:this.idToIndex,sizemin:.5,sizemax:12,color:[0,0,0,1],areaRatio:1,borderColor:[0,0,0,1]},this.pointcloud=a(t.glplot,this.pointcloudOptions),this.pointcloud._trace=this}function i(t,e){var r=new n(t,e.uid);return r.update(e),r}var a=t(\"gl-pointcloud2d\"),o=t(\"../../lib/str2rgbarray\"),s=t(\"../scatter/get_trace_color\"),l=[\"xaxis\",\"yaxis\"],u=n.prototype;u.handlePick=function(t){var e=this.idToIndex[t.pointId];return{trace:this,dataCoord:t.dataCoord,traceCoord:this.pickXYData?[this.pickXYData[2*e],this.pickXYData[2*e+1]]:[this.pickXData[e],this.pickYData[e]],textLabel:Array.isArray(this.textLabels)?this.textLabels[e]:this.textLabels,color:this.color,name:this.name,pointIndex:e,hoverinfo:this.hoverinfo}},u.update=function(t){this.index=t.index,this.textLabels=t.text,this.name=t.name,this.hoverinfo=t.hoverinfo,this.bounds=[1/0,1/0,-1/0,-1/0],this.updateFast(t),this.color=s(t,{})},u.updateFast=function(t){var e,r,n,i,a,s,l=this.xData=this.pickXData=t.x,u=this.yData=this.pickYData=t.y,c=this.pickXYData=t.xy,h=t.xbounds&&t.ybounds,f=t.indices,d=this.bounds;if(c){if(n=c,e=c.length>>>1,h)d[0]=t.xbounds[0],d[2]=t.xbounds[1],d[1]=t.ybounds[0],d[3]=t.ybounds[1];else for(s=0;s<e;s++)i=n[2*s],a=n[2*s+1],i<d[0]&&(d[0]=i),i>d[2]&&(d[2]=i),a<d[1]&&(d[1]=a),a>d[3]&&(d[3]=a);if(f)r=f;else for(r=new Int32Array(e),s=0;s<e;s++)r[s]=s}else for(e=l.length,n=new Float32Array(2*e),r=new Int32Array(e),s=0;s<e;s++)i=l[s],a=u[s],r[s]=s,n[2*s]=i,n[2*s+1]=a,i<d[0]&&(d[0]=i),i>d[2]&&(d[2]=i),a<d[1]&&(d[1]=a),a>d[3]&&(d[3]=a);this.idToIndex=r,this.pointcloudOptions.idToIndex=r,this.pointcloudOptions.positions=n;var p=o(t.marker.color),m=o(t.marker.border.color),v=t.opacity*t.marker.opacity;p[3]*=v,this.pointcloudOptions.color=p;var g=t.marker.blend;if(null===g){g=l.length<100||u.length<100}this.pointcloudOptions.blend=g,m[3]*=v,this.pointcloudOptions.borderColor=m;var y=t.marker.sizemin,b=Math.max(t.marker.sizemax,t.marker.sizemin);this.pointcloudOptions.sizeMin=y,this.pointcloudOptions.sizeMax=b,this.pointcloudOptions.areaRatio=t.marker.border.arearatio,this.pointcloud.update(this.pointcloudOptions),this.expandAxesFast(d,b/2)},u.expandAxesFast=function(t,e){for(var r,n,i,a=e||.5,o=0;o<2;o++)r=this.scene[l[o]],n=r._min,n||(n=[]),n.push({val:t[o],pad:a}),i=r._max,i||(i=[]),i.push({val:t[o+2],pad:a})},u.dispose=function(){this.pointcloud.dispose()},e.exports=i},{\"../../lib/str2rgbarray\":744,\"../scatter/get_trace_color\":1035,\"gl-pointcloud2d\":229}],1016:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\");e.exports=function(t,e,r){function a(r,a){return n.coerce(t,e,i,r,a)}a(\"x\"),a(\"y\"),a(\"xbounds\"),a(\"ybounds\"),t.xy&&t.xy instanceof Float32Array&&(e.xy=t.xy),t.indices&&t.indices instanceof Int32Array&&(e.indices=t.indices),a(\"text\"),a(\"marker.color\",r),a(\"marker.opacity\"),a(\"marker.blend\"),a(\"marker.sizemin\"),a(\"marker.sizemax\"),a(\"marker.border.color\",r),a(\"marker.border.arearatio\")}},{\"../../lib\":725,\"./attributes\":1014}],1017:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"../scatter3d/calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"pointcloud\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../scatter3d/calc\":1051,\"./attributes\":1014,\"./convert\":1015,\"./defaults\":1016}],1018:[function(t,e,r){\"use strict\";var n=t(\"../../components/shapes/attributes\"),i=t(\"../../plots/font_attributes\"),a=t(\"../../plots/attributes\"),o=t(\"../../components/color/attributes\"),s=t(\"../../lib/extend\").extendFlat;e.exports={hoverinfo:s({},a.hoverinfo,{flags:[\"label\",\"text\",\"value\",\"percent\",\"name\"]}),domain:{x:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]},y:{valType:\"info_array\",items:[{valType:\"number\",min:0,max:1},{valType:\"number\",min:0,max:1}],dflt:[0,1]}},orientation:{valType:\"enumerated\",values:[\"v\",\"h\"],dflt:\"h\"},valueformat:{valType:\"string\",dflt:\".3s\"},valuesuffix:{valType:\"string\",dflt:\"\"},arrangement:{valType:\"enumerated\",values:[\"snap\",\"perpendicular\",\"freeform\",\"fixed\"],dflt:\"snap\"},textfont:i,node:{label:{valType:\"data_array\",dflt:[]},color:s({},n.fillcolor,{arrayOk:!0}),line:{color:{valType:\"color\",dflt:o.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:.5,arrayOk:!0}},pad:{valType:\"number\",arrayOk:!1,min:0,dflt:20},thickness:{valType:\"number\",arrayOk:!1,min:1,dflt:20}},link:{label:{valType:\"data_array\",dflt:[]},color:s({},n.fillcolor,{arrayOk:!0}),line:{color:{valType:\"color\",dflt:o.defaultLine,arrayOk:!0},width:{valType:\"number\",min:0,dflt:0,arrayOk:!0}},source:{valType:\"data_array\",dflt:[]},target:{valType:\"data_array\",dflt:[]},value:{valType:\"data_array\",dflt:[]}}}},{\"../../components/color/attributes\":602,\"../../components/shapes/attributes\":679,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/font_attributes\":790}],1019:[function(t,e,r){\"use strict\";var n=t(\"../../plots/plots\"),i=t(\"./plot\");r.name=\"sankey\",r.attr=\"type\",r.plot=function(t){var e=n.getSubplotCalcData(t.calcdata,\"sankey\",\"sankey\");e.length&&i(t,e)},r.clean=function(t,e,r,n){var i=n._has&&n._has(\"sankey\"),a=e._has&&e._has(\"sankey\");i&&!a&&n._paperdiv.selectAll(\".sankey\").remove()}},{\"../../plots/plots\":829,\"./plot\":1024}],1020:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=t.map(function(){return[]}),a=0;a<Math.min(e.length,r.length);a++){if(e[a]===r[a])return!0;n[e[a]].push(r[a])}return i(n).components.some(function(t){return t.length>1})}var i=t(\"strongly-connected-components\"),a=t(\"../../lib\");e.exports=function(t,e){return n(e.node.label,e.link.source,e.link.target)&&(a.error(\"Circularity is present in the Sankey data. Removing all nodes and links.\"),e.link.label=[],e.link.source=[],e.link.target=[],e.link.value=[],e.link.color=[],e.node.label=[],e.node.color=[]),[{link:e.link,node:e.node}]}},{\"../../lib\":725,\"strongly-connected-components\":527}],1021:[function(t,e,r){\"use strict\";e.exports={nodeTextOffsetHorizontal:4,nodeTextOffsetVertical:3,nodePadAcross:10,sankeyIterations:50,forceIterations:5,forceTicksPerFrame:10,duration:500,ease:\"cubic-in-out\"}},{}],1022:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"../../components/color/attributes\").defaults,o=t(\"../../components/color\"),s=t(\"tinycolor2\");e.exports=function(t,e,r,l){function u(r,a){return n.coerce(t,e,i,r,a)}u(\"node.label\"),u(\"node.pad\"),u(\"node.thickness\"),u(\"node.line.color\"),u(\"node.line.width\");var c=function(t){return a[t%a.length]};u(\"node.color\",e.node.label.map(function(t,e){return o.addOpacity(c(e),.8)})),u(\"link.label\"),u(\"link.source\"),u(\"link.target\"),u(\"link.value\"),u(\"link.line.color\"),u(\"link.line.width\"),u(\"link.color\",e.link.value.map(function(){return s(l.paper_bgcolor).getLuminance()<.333?\"rgba(255, 255, 255, 0.6)\":\"rgba(0, 0, 0, 0.2)\"})),u(\"domain.x\"),u(\"domain.y\"),u(\"orientation\"),u(\"valueformat\"),u(\"valuesuffix\"),u(\"arrangement\"),n.coerceFont(u,\"textfont\",n.extendFlat({},l.font));var h=function(t,r){return-1===e.link.source.indexOf(r)&&-1===e.link.target.indexOf(r)};e.node.label.some(h)&&n.warn(\"Some of the nodes are neither sources nor targets, they will not be displayed.\")}},{\"../../components/color\":603,\"../../components/color/attributes\":602,\"../../lib\":725,\"./attributes\":1018,tinycolor2:533}],1023:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.moduleType=\"trace\",n.name=\"sankey\",n.basePlotModule=t(\"./base_plot\"),n.categories=[\"noOpacity\"],n.meta={},e.exports=n},{\"./attributes\":1018,\"./base_plot\":1019,\"./calc\":1020,\"./defaults\":1022,\"./plot\":1024}],1024:[function(t,e,r){\"use strict\";function n(t){return\"\"!==t}function i(t,e){return t.filter(function(t){return t.key===e.traceId})}function a(t,e){p.select(t).select(\"path\").style(\"fill-opacity\",e),p.select(t).select(\"rect\").style(\"fill-opacity\",e)}function o(t){p.select(t).select(\"text.name\").style(\"fill\",\"black\")}function s(t){return function(e){return-1!==t.node.sourceLinks.indexOf(e.link)||-1!==t.node.targetLinks.indexOf(e.link)}}function l(t){return function(e){return-1!==e.node.sourceLinks.indexOf(t.link)||-1!==e.node.targetLinks.indexOf(t.link)}}function u(t,e,r){e&&r&&i(r,e).selectAll(\".sankeyLink\").filter(s(e)).call(h.bind(0,e,r,!1))}function c(t,e,r){e&&r&&i(r,e).selectAll(\".sankeyLink\").filter(s(e)).call(f.bind(0,e,r,!1))}function h(t,e,r,n){var a=n.datum().link.label;n.style(\"fill-opacity\",.4),a&&i(e,t).selectAll(\".sankeyLink\").filter(function(t){return t.link.label===a}).style(\"fill-opacity\",.4),r&&i(e,t).selectAll(\".sankeyNode\").filter(l(t)).call(u)}function f(t,e,r,n){var a=n.datum().link.label;n.style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),a&&i(e,t).selectAll(\".sankeyLink\").filter(function(t){return t.link.label===a}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),r&&i(e,t).selectAll(\".sankeyNode\").filter(l(t)).call(c)}function d(t,e){var r=t.hoverlabel||{},n=y.nestedProperty(r,e).get();return!Array.isArray(n)&&n}var p=t(\"d3\"),m=t(\"./render\"),v=t(\"../../components/fx\"),g=t(\"../../components/color\"),y=t(\"../../lib\");e.exports=function(t,e){var r=t._fullLayout,i=r._paper,s=r._size,l=function(e,r){var n=r.link;n.originalEvent=p.event,t._hoverdata=[n],v.click(t,{target:!0})},y=function(e,r,n){var i=r.link;i.originalEvent=p.event,p.select(e).call(h.bind(0,r,n,!0)),v.hover(t,i,\"sankey\")},b=function(e,i){var s=i.link.trace,l=t.getBoundingClientRect(),u=e.getBoundingClientRect(),c=u.left+u.width/2,h=u.top+u.height/2,f=v.loneHover({x:c-l.left,y:h-l.top,name:p.format(i.valueFormat)(i.link.value)+i.valueSuffix,text:[i.link.label,[\"Source:\",i.link.source.label].join(\" \"),[\"Target:\",i.link.target.label].join(\" \")].filter(n).join(\"<br>\"),color:d(s,\"bgcolor\")||g.addOpacity(i.tinyColorHue,1),borderColor:d(s,\"bordercolor\"),fontFamily:d(s,\"font.family\"),fontSize:d(s,\"font.size\"),fontColor:d(s,\"font.color\"),idealAlign:p.event.x<c?\"right\":\"left\"},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t});a(f,.65),o(f)},x=function(e,n,i){p.select(e).call(f.bind(0,n,i,!0)),t.emit(\"plotly_unhover\",{event:p.event,points:[n.link]}),v.loneUnhover(r._hoverlayer.node())},_=function(e,r,n){var i=r.node;i.originalEvent=p.event,t._hoverdata=[i],p.select(e).call(c,r,n),v.click(t,{target:!0})},w=function(e,r,n){var i=r.node;i.originalEvent=p.event,p.select(e).call(u,r,n),v.hover(t,i,\"sankey\")},M=function(e,i){var s=i.node.trace,l=p.select(e).select(\".nodeRect\"),u=t.getBoundingClientRect(),c=l.node().getBoundingClientRect(),h=c.left-2-u.left,f=c.right+2-u.left,m=c.top+c.height/4-u.top,g=v.loneHover({x0:h,x1:f,y:m,name:p.format(i.valueFormat)(i.node.value)+i.valueSuffix,text:[i.node.label,[\"Incoming flow count:\",i.node.targetLinks.length].join(\" \"),[\"Outgoing flow count:\",i.node.sourceLinks.length].join(\" \")].filter(n).join(\"<br>\"),color:d(s,\"bgcolor\")||i.tinyColorHue,borderColor:d(s,\"bordercolor\"),fontFamily:d(s,\"font.family\"),fontSize:d(s,\"font.size\"),fontColor:d(s,\"font.color\"),idealAlign:\"left\"},{container:r._hoverlayer.node(),outerContainer:r._paper.node(),gd:t});a(g,.85),o(g)},k=function(e,n,i){p.select(e).call(c,n,i),t.emit(\"plotly_unhover\",{event:p.event,points:[n.node]}),v.loneUnhover(r._hoverlayer.node())};m(i,e,{width:s.w,height:s.h,margin:{t:s.t,r:s.r,b:s.b,l:s.l}},{linkEvents:{hover:y,follow:b,unhover:x,select:l},nodeEvents:{hover:w,follow:M,unhover:k,select:_}})}},{\"../../components/color\":603,\"../../components/fx\":644,\"../../lib\":725,\"./render\":1025,d3:121}],1025:[function(t,e,r){\"use strict\";function n(t){return t.key}function i(t){return[t]}function a(t){return t[0]}function o(t){var e,r=[];for(e=0;e<t.length;e++)t[e].originalX=t[e].x,t[e].originalY=t[e].y,-1===r.indexOf(t[e].x)&&r.push(t[e].x);for(r.sort(function(t,e){return t-e}),e=0;e<t.length;e++)t[e].originalLayerIndex=r.indexOf(t[e].originalX),t[e].originalLayer=t[e].originalLayerIndex/(r.length-1)}function s(t){t.lastDraggedX=t.x,t.lastDraggedY=t.y}function l(t){return function(e){return e.node.originalX===t.node.originalX}}function u(t){for(var e=0;e<t.length;e++)t[e].y=t[e].y+t[e].dy/2}function c(t){for(var e=0;e<t.length;e++)t[e].y=t[e].y-t[e].dy/2}function h(t,e,r){for(var n,i=a(e).trace,o=i.domain,s=i.node,l=i.link,c=i.arrangement,h=\"h\"===i.orientation,f=i.node.pad,d=i.node.thickness,p=i.node.line.color,m=i.node.line.width,v=i.link.line.color,g=i.link.line.width,y=i.valueformat,b=i.valuesuffix,x=i.textfont,_=t.width*(o.x[1]-o.x[0]),w=t.height*(o.y[1]-o.y[0]),M=s.label.map(function(t,e){return{pointNumber:e,label:t,color:B.isArray(s.color)?s.color[e]:s.color}}),k=l.value.map(function(t,e){return{pointNumber:e,label:l.label[e],color:B.isArray(l.color)?l.color[e]:l.color,source:l.source[e],target:l.target[e],value:t}}),A=j().size(h?[_,w]:[w,_]).nodeWidth(d).nodePadding(f).nodes(M).links(k).layout(D.sankeyIterations),T=A.nodes(),S=0;S<T.length;S++)n=T[S],n.width=_,n.height=w;return u(M),{key:r,trace:i,guid:Math.floor(1e12*(1+Math.random())),horizontal:h,width:_,height:w,nodePad:f,nodeLineColor:p,nodeLineWidth:m,linkLineColor:v,linkLineWidth:g,valueFormat:y,valueSuffix:b,textFont:x,translateX:o.x[0]*_+t.margin.l,translateY:t.height-o.y[1]*t.height+t.margin.t,dragParallel:h?w:_,dragPerpendicular:h?_:w,nodes:M,links:k,arrangement:c,sankey:A,forceLayouts:{},interactionState:{dragInProgress:!1,hovered:!1}}}function f(t,e,r){var n=O(r.color),i=r.source.label+\"|\"+r.target.label,a=t[i];t[i]=(a||0)+1;var o=i+\"__\"+t[i];return r.trace=e.trace,r.curveNumber=e.trace.index,{key:o,traceId:e.key,link:r,tinyColorHue:R.tinyRGB(n),tinyColorAlpha:n.getAlpha(),linkLineColor:e.linkLineColor,linkLineWidth:e.linkLineWidth,valueFormat:e.valueFormat,valueSuffix:e.valueSuffix,sankey:e.sankey,interactionState:e.interactionState}}function d(t,e,r){var n=O(r.color),i=D.nodePadAcross,a=e.nodePad/2,o=r.dx+.5,s=r.dy-.5,l=r.label,u=t[l];t[l]=(u||0)+1;var c=l+\"__\"+t[l];return r.trace=e.trace,r.curveNumber=e.trace.index,{key:c,traceId:e.key,node:r,nodePad:e.nodePad,nodeLineColor:e.nodeLineColor,nodeLineWidth:e.nodeLineWidth,textFont:e.textFont,size:e.horizontal?e.height:e.width,visibleWidth:Math.ceil(o),visibleHeight:Math.ceil(s),zoneX:-i,zoneY:-a,zoneWidth:o+2*i,zoneHeight:s+2*a,labelY:e.horizontal?r.dy/2+1:r.dx/2+1,left:1===r.originalLayer,sizeAcross:e.width,forceLayouts:e.forceLayouts,horizontal:e.horizontal,darkBackground:n.getBrightness()<=128,tinyColorHue:R.tinyRGB(n),tinyColorAlpha:n.getAlpha(),valueFormat:e.valueFormat,valueSuffix:e.valueSuffix,sankey:e.sankey,arrangement:e.arrangement,uniqueNodeLabelPathId:[e.guid,e.key,c].join(\" \"),interactionState:e.interactionState}}function p(t){P.select(t.node().parentNode).style(\"shape-rendering\",\"crispEdges\")}function m(t){t.attr(\"transform\",function(t){return\"translate(\"+(t.node.x-.5)+\", \"+(t.node.y-t.node.dy/2+.5)+\")\"})}function v(t){var e=t.sankey.nodes();c(e);var r=t.sankey.link()(t.link);return u(e),r}function g(t){P.select(t.node().parentNode).style(\"shape-rendering\",\"optimizeSpeed\"),t.call(m)}function y(t,e){t.call(g),e.attr(\"d\",v)}function b(t){t.attr(\"width\",function(t){return t.visibleWidth}).attr(\"height\",function(t){return t.visibleHeight})}function x(t){return t.link.dy>1||t.linkLineWidth>0}function _(t){return\"translate(\"+t.translateX+\",\"+t.translateY+\")\"+(t.horizontal?\"matrix(1 0 0 1 0 0)\":\"matrix(0 1 1 0 0 0)\")}function w(t){return\"translate(\"+(t.horizontal?0:t.labelY)+\" \"+(t.horizontal?t.labelY:0)+\")\"}function M(t){return P.svg.line()([[t.horizontal?t.left?-t.sizeAcross:t.visibleWidth+D.nodeTextOffsetHorizontal:D.nodeTextOffsetHorizontal,0],[t.horizontal?t.left?-D.nodeTextOffsetHorizontal:t.sizeAcross:t.visibleHeight-D.nodeTextOffsetHorizontal,0]])}function k(t){return t.horizontal?\"matrix(1 0 0 1 0 0)\":\"matrix(0 1 1 0 0 0)\"}function A(t){return t.horizontal?\"scale(1 1)\":\"scale(-1 1)\"}function T(t){return t.darkBackground&&!t.horizontal?\"rgb(255,255,255)\":\"rgb(0,0,0)\"}function S(t){return t.horizontal&&t.left?\"100%\":\"0%\"}function E(t,e,r){t.on(\".basic\",null).on(\"mouseover.basic\",function(t){t.interactionState.dragInProgress||(r.hover(this,t,e),t.interactionState.hovered=[this,t])}).on(\"mousemove.basic\",function(t){t.interactionState.dragInProgress||(r.follow(this,t),t.interactionState.hovered=[this,t])}).on(\"mouseout.basic\",function(t){t.interactionState.dragInProgress||(r.unhover(this,t,e),t.interactionState.hovered=!1)}).on(\"click.basic\",function(t){t.interactionState.hovered&&(r.unhover(this,t,e),t.interactionState.hovered=!1),t.interactionState.dragInProgress||r.select(this,t,e)})}function L(t,e,r){var n=P.behavior.drag().origin(function(t){return t.node}).on(\"dragstart\",function(n){if(\"fixed\"!==n.arrangement&&(this.parentNode.appendChild(this),n.interactionState.dragInProgress=n.node,s(n.node),n.interactionState.hovered&&(r.nodeEvents.unhover.apply(0,n.interactionState.hovered),n.interactionState.hovered=!1),\"snap\"===n.arrangement)){var i=n.traceId+\"|\"+Math.floor(n.node.originalX);n.forceLayouts[i]?n.forceLayouts[i].alpha(1):C(t,i,n),z(t,e,n,i)}}).on(\"drag\",function(r){if(\"fixed\"!==r.arrangement){var n=P.event.x,i=P.event.y;\"snap\"===r.arrangement?(r.node.x=n,r.node.y=i):(\"freeform\"===r.arrangement&&(r.node.x=n),r.node.y=Math.max(r.node.dy/2,Math.min(r.size-r.node.dy/2,i))),s(r.node),\"snap\"!==r.arrangement&&(r.sankey.relayout(),y(t.filter(l(r)),e),t.call(p))}}).on(\"dragend\",function(t){t.interactionState.dragInProgress=!1});t.on(\".drag\",null).call(n)}function C(t,e,r){var n=r.sankey.nodes().filter(function(t){return t.originalX===r.node.originalX});r.forceLayouts[e]=N.forceSimulation(n).alphaDecay(0).force(\"collide\",N.forceCollide().radius(function(t){return t.dy/2+r.nodePad/2}).strength(1).iterations(D.forceIterations)).force(\"constrain\",I(t,e,n,r)).stop()}function z(t,e,r,n){window.requestAnimationFrame(function i(){for(var a=0;a<D.forceTicksPerFrame;a++)r.forceLayouts[n].tick();r.sankey.relayout(),y(t.filter(l(r)),e),r.forceLayouts[n].alpha()>0&&window.requestAnimationFrame(i)})}function I(t,e,r,n){return function(){for(var i=0,a=0;a<r.length;a++){var o=r[a];o===n.interactionState.dragInProgress?(o.x=o.lastDraggedX,o.y=o.lastDraggedY):(o.vx=(o.originalX-o.x)/D.forceTicksPerFrame,o.y=Math.min(n.size-o.dy/2,Math.max(o.dy/2,o.y))),i=Math.max(i,Math.abs(o.vx),Math.abs(o.vy))}!n.interactionState.dragInProgress&&i<.1&&n.forceLayouts[e].alpha()>0&&(n.forceLayouts[e].alpha(0),window.setTimeout(function(){t.call(p)},30))}}var D=t(\"./constants\"),P=t(\"d3\"),O=t(\"tinycolor2\"),R=t(\"../../components/color\"),F=t(\"../../components/drawing\"),j=t(\"@plotly/d3-sankey\").sankey,N=t(\"d3-force\"),B=t(\"../../lib\");e.exports=function(t,e,r,s){var l=t.selectAll(\".sankey\").data(e.filter(function(t){return a(t).trace.visible}).map(h.bind(null,r)),n);l.exit().remove(),l.enter().append(\"g\").classed(\"sankey\",!0).style(\"box-sizing\",\"content-box\").style(\"position\",\"absolute\").style(\"left\",0).style(\"shape-rendering\",\"geometricPrecision\").style(\"pointer-events\",\"auto\").style(\"box-sizing\",\"content-box\").attr(\"transform\",_),l.transition().ease(D.ease).duration(D.duration).attr(\"transform\",_);var u=l.selectAll(\".sankeyLinks\").data(i,n);u.enter().append(\"g\").classed(\"sankeyLinks\",!0).style(\"fill\",\"none\");var c=u.selectAll(\".sankeyLink\").data(function(t){var e={};return t.sankey.links().filter(function(t){return t.value}).map(f.bind(null,e,t))},n);c.enter().append(\"path\").classed(\"sankeyLink\",!0).attr(\"d\",v).call(E,l,s.linkEvents),c.style(\"stroke\",function(t){return x(t)?R.tinyRGB(O(t.linkLineColor)):t.tinyColorHue}).style(\"stroke-opacity\",function(t){return x(t)?R.opacity(t.linkLineColor):t.tinyColorAlpha}).style(\"stroke-width\",function(t){return x(t)?t.linkLineWidth:1}).style(\"fill\",function(t){return t.tinyColorHue}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),c.transition().ease(D.ease).duration(D.duration).attr(\"d\",v),c.exit().transition().ease(D.ease).duration(D.duration).style(\"opacity\",0).remove();var p=l.selectAll(\".sankeyNodeSet\").data(i,n);p.enter().append(\"g\").style(\"shape-rendering\",\"geometricPrecision\").classed(\"sankeyNodeSet\",!0),p.style(\"cursor\",function(t){switch(t.arrangement){case\"fixed\":return\"default\";case\"perpendicular\":return\"ns-resize\";default:return\"move\"}});var g=p.selectAll(\".sankeyNode\").data(function(t){var e=t.sankey.nodes(),r={};return o(e),e.filter(function(t){return t.value}).map(d.bind(null,r,t))},n);g.enter().append(\"g\").classed(\"sankeyNode\",!0).call(m).call(E,l,s.nodeEvents),g.call(L,c,s),g.transition().ease(D.ease).duration(D.duration).call(m),g.exit().transition().ease(D.ease).duration(D.duration).style(\"opacity\",0).remove();var y=g.selectAll(\".nodeRect\").data(i);y.enter().append(\"rect\").classed(\"nodeRect\",!0).call(b),y.style(\"stroke-width\",function(t){return t.nodeLineWidth}).style(\"stroke\",function(t){return R.tinyRGB(O(t.nodeLineColor))}).style(\"stroke-opacity\",function(t){return R.opacity(t.nodeLineColor)}).style(\"fill\",function(t){return t.tinyColorHue}).style(\"fill-opacity\",function(t){return t.tinyColorAlpha}),y.transition().ease(D.ease).duration(D.duration).call(b);var C=g.selectAll(\".nodeCapture\").data(i);C.enter().append(\"rect\").classed(\"nodeCapture\",!0).style(\"fill-opacity\",0),C.attr(\"x\",function(t){return t.zoneX}).attr(\"y\",function(t){return t.zoneY}).attr(\"width\",function(t){return t.zoneWidth}).attr(\"height\",function(t){return t.zoneHeight});var z=g.selectAll(\".nodeCentered\").data(i);z.enter().append(\"g\").classed(\"nodeCentered\",!0).attr(\"transform\",w),z.transition().ease(D.ease).duration(D.duration).attr(\"transform\",w);var I=z.selectAll(\".nodeLabelGuide\").data(i);I.enter().append(\"path\").classed(\"nodeLabelGuide\",!0).attr(\"id\",function(t){return t.uniqueNodeLabelPathId}).attr(\"d\",M).attr(\"transform\",k),I.transition().ease(D.ease).duration(D.duration).attr(\"d\",M).attr(\"transform\",k);var P=z.selectAll(\".nodeLabel\").data(i);P.enter().append(\"text\").classed(\"nodeLabel\",!0).attr(\"transform\",A).style(\"user-select\",\"none\").style(\"cursor\",\"default\").style(\"fill\",\"black\"),P.style(\"text-shadow\",function(t){return t.horizontal?\"-1px 1px 1px #fff, 1px 1px 1px #fff, 1px -1px 1px #fff, -1px -1px 1px #fff\":\"none\"}).each(function(t){F.font(P,t.textFont)}),P.transition().ease(D.ease).duration(D.duration).attr(\"transform\",A);var j=P.selectAll(\".nodeLabelTextPath\").data(i);j.enter().append(\"textPath\").classed(\"nodeLabelTextPath\",!0).attr(\"alignment-baseline\",\"middle\").attr(\"xlink:href\",function(t){return\"#\"+t.uniqueNodeLabelPathId}).attr(\"startOffset\",S).style(\"fill\",T),j.text(function(t){return t.horizontal||t.node.dy>5?t.node.label:\"\"}).attr(\"text-anchor\",function(t){return t.horizontal&&t.left?\"end\":\"start\"}),j.transition().ease(D.ease).duration(D.duration).attr(\"startOffset\",S).style(\"fill\",T)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../lib\":725,\"./constants\":1021,\"@plotly/d3-sankey\":37,d3:121,\"d3-force\":117,tinycolor2:533}],1026:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e){for(var r=0;r<t.length;r++)t[r].i=r;n.mergeArray(e.text,t,\"tx\"),n.mergeArray(e.hovertext,t,\"htx\"),n.mergeArray(e.customdata,t,\"data\"),n.mergeArray(e.textposition,t,\"tp\"),e.textfont&&(n.mergeArray(e.textfont.size,t,\"ts\"),n.mergeArray(e.textfont.color,t,\"tc\"),n.mergeArray(e.textfont.family,t,\"tf\"));var i=e.marker;if(i){n.mergeArray(i.size,t,\"ms\"),n.mergeArray(i.opacity,t,\"mo\"),n.mergeArray(i.symbol,t,\"mx\"),n.mergeArray(i.color,t,\"mc\");var a=i.line;i.line&&(n.mergeArray(a.color,t,\"mlc\"),n.mergeArray(a.width,t,\"mlw\"));var o=i.gradient;o&&\"none\"!==o.type&&(n.mergeArray(o.type,t,\"mgt\"),n.mergeArray(o.color,t,\"mgc\"))}}},{\"../../lib\":725}],1027:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/color_attributes\"),i=t(\"../../components/errorbars/attributes\"),a=t(\"../../components/colorbar/attributes\"),o=t(\"../../components/drawing/attributes\").dash,s=t(\"../../components/drawing\"),l=(t(\"./constants\"),t(\"../../lib/extend\").extendFlat);e.exports={x:{valType:\"data_array\"},x0:{valType:\"any\",dflt:0},dx:{valType:\"number\",dflt:1},y:{valType:\"data_array\"},y0:{valType:\"any\",dflt:0},dy:{valType:\"number\",dflt:1},text:{valType:\"string\",dflt:\"\",arrayOk:!0},hovertext:{valType:\"string\",dflt:\"\",arrayOk:!0},mode:{valType:\"flaglist\",flags:[\"lines\",\"markers\",\"text\"],extras:[\"none\"]},hoveron:{valType:\"flaglist\",flags:[\"points\",\"fills\"]},line:{color:{valType:\"color\"},width:{valType:\"number\",min:0,dflt:2},shape:{valType:\"enumerated\",values:[\"linear\",\"spline\",\"hv\",\"vh\",\"hvh\",\"vhv\"],dflt:\"linear\"},smoothing:{valType:\"number\",min:0,max:1.3,dflt:1},dash:o,simplify:{valType:\"boolean\",dflt:!0}},connectgaps:{valType:\"boolean\",dflt:!1},cliponaxis:{valType:\"boolean\",dflt:!0,editType:\"doplot\"},fill:{valType:\"enumerated\",values:[\"none\",\"tozeroy\",\"tozerox\",\"tonexty\",\"tonextx\",\"toself\",\"tonext\"],dflt:\"none\"},fillcolor:{valType:\"color\"},marker:l({},{symbol:{valType:\"enumerated\",values:s.symbolList,dflt:\"circle\",arrayOk:!0},opacity:{valType:\"number\",min:0,max:1,arrayOk:!0},size:{valType:\"number\",min:0,dflt:6,arrayOk:!0},maxdisplayed:{valType:\"number\",min:0,dflt:0},sizeref:{valType:\"number\",dflt:1},sizemin:{valType:\"number\",min:0,dflt:0},sizemode:{valType:\"enumerated\",values:[\"diameter\",\"area\"],dflt:\"diameter\"},showscale:{valType:\"boolean\",dflt:!1},colorbar:a,line:l({},{width:{valType:\"number\",min:0,arrayOk:!0}},n(\"marker.line\")),gradient:{type:{valType:\"enumerated\",\n",
       "values:[\"radial\",\"horizontal\",\"vertical\",\"none\"],arrayOk:!0,dflt:\"none\"},color:{valType:\"color\",arrayOk:!0}}},n(\"marker\")),textposition:{valType:\"enumerated\",values:[\"top left\",\"top center\",\"top right\",\"middle left\",\"middle center\",\"middle right\",\"bottom left\",\"bottom center\",\"bottom right\"],dflt:\"middle center\",arrayOk:!0},textfont:{family:{valType:\"string\",noBlank:!0,strict:!0,arrayOk:!0},size:{valType:\"number\",min:1,arrayOk:!0},color:{valType:\"color\",arrayOk:!0}},r:{valType:\"data_array\"},t:{valType:\"data_array\"},error_y:i,error_x:i}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/drawing\":627,\"../../components/drawing/attributes\":626,\"../../components/errorbars/attributes\":629,\"../../lib/extend\":716,\"./constants\":1032}],1028:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../constants/numerical\").BADNUM,o=t(\"./subtypes\"),s=t(\"./colorscale_calc\"),l=t(\"./arrays_to_calcdata\");e.exports=function(t,e){var r,u,c,h=i.getFromId(t,e.xaxis||\"x\"),f=i.getFromId(t,e.yaxis||\"y\"),d=h.makeCalcdata(e,\"x\"),p=f.makeCalcdata(e,\"y\"),m=Math.min(d.length,p.length);h._minDtick=0,f._minDtick=0,d.length>m&&d.splice(m,d.length-m),p.length>m&&p.splice(m,p.length-m);var v={padded:!0},g={padded:!0};if(o.hasMarkers(e)){if(r=e.marker,u=r.size,Array.isArray(u)){var y={type:\"linear\"};i.setConvert(y),u=y.makeCalcdata(e.marker,\"size\"),u.length>m&&u.splice(m,u.length-m)}var b,x=1.6*(e.marker.sizeref||1);b=\"area\"===e.marker.sizemode?function(t){return Math.max(Math.sqrt((t||0)/x),3)}:function(t){return Math.max((t||0)/x,3)},v.ppad=g.ppad=Array.isArray(u)?u.map(b):b(u)}s(e),!(\"tozerox\"===e.fill||\"tonextx\"===e.fill&&t.firstscatter)||d[0]===d[m-1]&&p[0]===p[m-1]?e.error_y.visible||-1===[\"tonexty\",\"tozeroy\"].indexOf(e.fill)&&(o.hasMarkers(e)||o.hasText(e))||(v.padded=!1,v.ppad=0):v.tozero=!0,!(\"tozeroy\"===e.fill||\"tonexty\"===e.fill&&t.firstscatter)||d[0]===d[m-1]&&p[0]===p[m-1]?-1!==[\"tonextx\",\"tozerox\"].indexOf(e.fill)&&(g.padded=!1):g.tozero=!0,i.expand(h,d,v),i.expand(f,p,g);var _=new Array(m);for(c=0;c<m;c++)_[c]=n(d[c])&&n(p[c])?{x:d[c],y:p[c]}:{x:a,y:a},e.ids&&(_[c].id=String(e.ids[c]));return l(_,e),t.firstscatter=!1,_}},{\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"./arrays_to_calcdata\":1026,\"./colorscale_calc\":1031,\"./subtypes\":1047,\"fast-isnumeric\":130}],1029:[function(t,e,r){\"use strict\";e.exports=function(t){for(var e=0;e<t.length;e++){var r=t[e];if(\"scatter\"===r.type){var n=r.fill;if(\"none\"!==n&&\"toself\"!==n&&(r.opacity=void 0,\"tonexty\"===n||\"tonextx\"===n))for(var i=e-1;i>=0;i--){var a=t[i];if(\"scatter\"===a.type&&a.xaxis===r.xaxis&&a.yaxis===r.yaxis){a.opacity=void 0;break}}}}}},{}],1030:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=r.marker,u=\"cb\"+r.uid;if(t._fullLayout._infolayer.selectAll(\".\"+u).remove(),void 0===l||!l.showscale)return void a.autoMargin(t,u);var c=l.color,h=l.cmin,f=l.cmax;n(h)||(h=i.aggNums(Math.min,null,c)),n(f)||(f=i.aggNums(Math.max,null,c));var d=e[0].t.cb=s(t,u),p=o.makeColorScaleFunc(o.extractScale(l.colorscale,h,f),{noNumericCheck:!0});d.fillcolor(p).filllevels({start:h,end:f,size:(f-h)/254}).options(l.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],1031:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/calc\"),a=t(\"./subtypes\");e.exports=function(t){a.hasLines(t)&&n(t,\"line\")&&i(t,t.line.color,\"line\",\"c\"),a.hasMarkers(t)&&(n(t,\"marker\")&&i(t,t.marker.color,\"marker\",\"c\"),n(t,\"marker.line\")&&i(t,t.marker.line.color,\"marker.line\",\"c\"))}},{\"../../components/colorscale/calc\":609,\"../../components/colorscale/has_colorscale\":616,\"./subtypes\":1047}],1032:[function(t,e,r){\"use strict\";e.exports={PTS_LINESONLY:20}},{}],1033:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"./attributes\"),a=t(\"./constants\"),o=t(\"./subtypes\"),s=t(\"./xy_defaults\"),l=t(\"./marker_defaults\"),u=t(\"./line_defaults\"),c=t(\"./line_shape_defaults\"),h=t(\"./text_defaults\"),f=t(\"./fillcolor_defaults\"),d=t(\"../../components/errorbars/defaults\");e.exports=function(t,e,r,p){function m(r,a){return n.coerce(t,e,i,r,a)}var v=s(t,e,p,m),g=v<a.PTS_LINESONLY?\"lines+markers\":\"lines\";if(!v)return void(e.visible=!1);m(\"text\"),m(\"hovertext\"),m(\"mode\",g),o.hasLines(e)&&(u(t,e,r,p,m),c(t,e,m),m(\"connectgaps\"),m(\"line.simplify\")),o.hasMarkers(e)&&l(t,e,r,p,m,{gradient:!0}),o.hasText(e)&&h(t,e,p,m);var y=[];(o.hasMarkers(e)||o.hasText(e))&&(m(\"marker.maxdisplayed\"),y.push(\"points\")),m(\"fill\"),\"none\"!==e.fill&&(f(t,e,r,m),o.hasLines(e)||c(t,e,m)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||y.push(\"fills\"),m(\"hoveron\",y.join(\"+\")||\"points\"),d(t,e,r,{axis:\"y\"}),d(t,e,r,{axis:\"x\",inherit:\"y\"}),m(\"cliponaxis\")}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"./attributes\":1027,\"./constants\":1032,\"./fillcolor_defaults\":1034,\"./line_defaults\":1038,\"./line_shape_defaults\":1040,\"./marker_defaults\":1043,\"./subtypes\":1047,\"./text_defaults\":1048,\"./xy_defaults\":1049}],1034:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\");e.exports=function(t,e,r,i){var a=!1;if(e.marker){var o=e.marker.color,s=(e.marker.line||{}).color;o&&!Array.isArray(o)?a=o:s&&!Array.isArray(s)&&(a=s)}i(\"fillcolor\",n.addOpacity((e.line||{}).color||a||r,.5))}},{\"../../components/color\":603}],1035:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"./subtypes\");e.exports=function(t,e){var r,a;if(\"lines\"===t.mode)return r=t.line.color,r&&n.opacity(r)?r:t.fillcolor;if(\"none\"===t.mode)return t.fill?t.fillcolor:\"\";var o=e.mcc||(t.marker||{}).color,s=e.mlcc||((t.marker||{}).line||{}).color;return a=o&&n.opacity(o)?o:s&&n.opacity(s)&&(e.mlw||((t.marker||{}).line||{}).width)?s:\"\",a?n.opacity(a)<.3?n.addOpacity(a,.3):a:(r=(t.line||{}).color,r&&n.opacity(r)&&i.hasLines(t)&&t.line.width?r:t.fillcolor)}},{\"../../components/color\":603,\"./subtypes\":1047}],1036:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../../components/fx\"),a=t(\"../../components/errorbars\"),o=t(\"./get_trace_color\"),s=t(\"../../components/color\"),l=i.constants.MAXDIST;e.exports=function(t,e,r,u){var c=t.cd,h=c[0].trace,f=t.xa,d=t.ya,p=f.c2p(e),m=d.c2p(r),v=[p,m],g=h.hoveron||\"\";if(-1!==g.indexOf(\"points\")){var y=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(f.c2p(t.x)-p)-e,1-3/e)},b=function(t){var e=Math.max(3,t.mrc||0);return Math.max(Math.abs(d.c2p(t.y)-m)-e,1-3/e)},x=function(t){var e=Math.max(3,t.mrc||0),r=f.c2p(t.x)-p,n=d.c2p(t.y)-m;return Math.max(Math.sqrt(r*r+n*n)-e,1-3/e)},_=i.getDistanceFunction(u,y,b,x);if(i.getClosest(c,_,t),!1!==t.index){var w=c[t.index],M=f.c2p(w.x,!0),k=d.c2p(w.y,!0),A=w.mrc||1;return n.extendFlat(t,{color:o(h,w),x0:M-A,x1:M+A,xLabelVal:w.x,y0:k-A,y1:k+A,yLabelVal:w.y}),w.htx?t.text=w.htx:h.hovertext?t.text=h.hovertext:w.tx?t.text=w.tx:h.text&&(t.text=h.text),a.hoverInfo(w,h,t),[t]}}if(-1!==g.indexOf(\"fills\")&&h._polygons){var T,S,E,L,C,z,I,D,P,O=h._polygons,R=[],F=!1,j=1/0,N=-1/0,B=1/0,U=-1/0;for(T=0;T<O.length;T++)E=O[T],E.contains(v)&&(F=!F,R.push(E),B=Math.min(B,E.ymin),U=Math.max(U,E.ymax));if(F){B=Math.max(B,0),U=Math.min(U,d._length);var V=(B+U)/2;for(T=0;T<R.length;T++)for(L=R[T].pts,S=1;S<L.length;S++)D=L[S-1][1],P=L[S][1],D>V!=P>=V&&(z=L[S-1][0],I=L[S][0],C=z+(I-z)*(V-D)/(P-D),j=Math.min(j,C),N=Math.max(N,C));j=Math.max(j,0),N=Math.min(N,f._length);var H=s.defaultLine;return s.opacity(h.fillcolor)?H=h.fillcolor:s.opacity((h.line||{}).color)&&(H=h.line.color),n.extendFlat(t,{distance:l+10,x0:j,x1:N,y0:V,y1:V,color:H}),delete t.index,h.text&&!Array.isArray(h.text)?t.text=String(h.text):t.text=h.name,[t]}}}},{\"../../components/color\":603,\"../../components/errorbars\":633,\"../../components/fx\":644,\"../../lib\":725,\"./get_trace_color\":1035}],1037:[function(t,e,r){\"use strict\";var n={},i=t(\"./subtypes\");n.hasLines=i.hasLines,n.hasMarkers=i.hasMarkers,n.hasText=i.hasText,n.isBubble=i.isBubble,n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.cleanData=t(\"./clean_data\"),n.calc=t(\"./calc\"),n.arraysToCalcdata=t(\"./arrays_to_calcdata\"),n.plot=t(\"./plot\"),n.colorbar=t(\"./colorbar\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.animatable=!0,n.moduleType=\"trace\",n.name=\"scatter\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"cartesian\",\"symbols\",\"markerColorscale\",\"errorBarsOK\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"./arrays_to_calcdata\":1026,\"./attributes\":1027,\"./calc\":1028,\"./clean_data\":1029,\"./colorbar\":1030,\"./defaults\":1033,\"./hover\":1036,\"./plot\":1044,\"./select\":1045,\"./style\":1046,\"./subtypes\":1047}],1038:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/has_colorscale\"),i=t(\"../../components/colorscale/defaults\");e.exports=function(t,e,r,a,o,s){var l=(t.marker||{}).color;if(o(\"line.color\",r),n(t,\"line\"))i(t,e,a,o,{prefix:\"line.\",cLetter:\"c\"});else{o(\"line.color\",!Array.isArray(l)&&l||r)}o(\"line.width\"),(s||{}).noDash||o(\"line.dash\")}},{\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616}],1039:[function(t,e,r){\"use strict\";var n=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e){function r(e){var r=_.c2p(t[e].x),i=w.c2p(t[e].y);return r!==n&&i!==n&&[r,i]}function i(t){var e=t[0]/_._length,r=t[1]/w._length;return(1+10*Math.max(0,-e,e-1,-r,r-1))*A}var a,o,s,l,u,c,h,f,d,p,m,v,g,y,b,x,_=e.xaxis,w=e.yaxis,M=e.simplify,k=e.connectGaps,A=e.baseTolerance,T=e.linear,S=[],E=.2,L=new Array(t.length),C=0;for(M||(A=E=-1),a=0;a<t.length;a++)if(o=r(a)){for(C=0,L[C++]=o,a++;a<t.length;a++){if(!(l=r(a))){if(k)continue;break}if(T){if(!((h=function(t,e){var r=t[0]-e[0],n=t[1]-e[1];return Math.sqrt(r*r+n*n)}(l,o))<i(l)*E)){for(d=[(l[0]-o[0])/h,(l[1]-o[1])/h],u=o,m=h,v=y=b=0,f=!1,s=l,a++;a<t.length;a++){if(!(c=r(a))){if(k)continue;break}if(p=[c[0]-o[0],c[1]-o[1]],x=p[0]*d[1]-p[1]*d[0],y=Math.min(y,x),(b=Math.max(b,x))-y>i(c))break;s=c,g=p[0]*d[0]+p[1]*d[1],g>m?(m=g,l=c,f=!1):g<v&&(v=g,u=c,f=!0)}if(f?(L[C++]=l,s!==u&&(L[C++]=u)):(u!==o&&(L[C++]=u),s!==l&&(L[C++]=l)),L[C++]=s,a>=t.length||!c)break;L[C++]=c,o=c}}else L[C++]=l}S.push(L.slice(0,C))}return S}},{\"../../constants/numerical\":705}],1040:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){\"spline\"===r(\"line.shape\")&&r(\"line.smoothing\")}},{}],1041:[function(t,e,r){\"use strict\";e.exports=function(t,e,r){for(var n,i,a=null,o=0;o<r.length;++o)n=r[o],i=n[0].trace,!0===i.visible?(i._nexttrace=null,-1!==[\"tonextx\",\"tonexty\",\"tonext\"].indexOf(i.fill)&&(i._prevtrace=a,a&&(a._nexttrace=i)),a=i):i._prevtrace=i._nexttrace=null}},{}],1042:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\");e.exports=function(t){var e=t.marker,r=e.sizeref||1,i=e.sizemin||0,a=\"area\"===e.sizemode?function(t){return Math.sqrt(t/r)}:function(t){return t/r};return function(t){var e=a(t/2);return n(e)&&e>0?Math.max(e,i):0}}},{\"fast-isnumeric\":130}],1043:[function(t,e,r){\"use strict\";var n=t(\"../../components/color\"),i=t(\"../../components/colorscale/has_colorscale\"),a=t(\"../../components/colorscale/defaults\"),o=t(\"./subtypes\");e.exports=function(t,e,r,s,l,u){var c,h=o.isBubble(t),f=(t.line||{}).color;if(u=u||{},f&&(r=f),l(\"marker.symbol\"),l(\"marker.opacity\",h?.7:1),l(\"marker.size\"),l(\"marker.color\",r),i(t,\"marker\")&&a(t,e,s,l,{prefix:\"marker.\",cLetter:\"c\"}),u.noLine||(c=f&&!Array.isArray(f)&&e.marker.color!==f?f:h?n.background:n.defaultLine,l(\"marker.line.color\",c),i(t,\"marker.line\")&&a(t,e,s,l,{prefix:\"marker.line.\",cLetter:\"c\"}),l(\"marker.line.width\",h?1:0)),h&&(l(\"marker.sizeref\"),l(\"marker.sizemin\"),l(\"marker.sizemode\")),u.gradient){\"none\"!==l(\"marker.gradient.type\")&&l(\"marker.gradient.color\")}}},{\"../../components/color\":603,\"../../components/colorscale/defaults\":612,\"../../components/colorscale/has_colorscale\":616,\"./subtypes\":1047}],1044:[function(t,e,r){\"use strict\";function n(t,e,r){var n;e.selectAll(\"g.trace\").each(function(t){var e=o.select(this);if(n=t[0].trace,n._nexttrace){if(n._nextFill=e.select(\".js-fill.js-tonext\"),!n._nextFill.size()){var i=\":first-child\";e.select(\".js-fill.js-tozero\").size()&&(i+=\" + *\"),n._nextFill=e.insert(\"path\",i).attr(\"class\",\"js-fill js-tonext\")}}else e.selectAll(\".js-fill.js-tonext\").remove(),n._nextFill=null;n.fill&&(\"tozero\"===n.fill.substr(0,6)||\"toself\"===n.fill||\"to\"===n.fill.substr(0,2)&&!n._prevtrace)?(n._ownFill=e.select(\".js-fill.js-tozero\"),n._ownFill.size()||(n._ownFill=e.insert(\"path\",\":first-child\").attr(\"class\",\"js-fill js-tozero\"))):(e.selectAll(\".js-fill.js-tozero\").remove(),n._ownFill=null),e.selectAll(\".js-fill\").call(l.setClipUrl,r.layerClipId)})}function i(t,e,r,n,i,f,p){function m(t){return M?t.transition():t}function v(t){return t.filter(function(t){return t.vis})}function g(t){return t.id}function y(t){if(t.ids)return g}function b(){return!1}function x(e){var n,i,a,u=e[0].trace,h=o.select(this),f=c.hasMarkers(u),d=c.hasText(u),p=y(u),g=b,x=b;f&&(g=u.marker.maxdisplayed||u._needsCull?v:s.identity),d&&(x=u.marker.maxdisplayed||u._needsCull?v:s.identity),i=h.selectAll(\"path.point\"),n=i.data(g,p);var _=n.enter().append(\"path\").classed(\"point\",!0);M&&_.call(l.pointStyle,u,t).call(l.translatePoints,k,A).style(\"opacity\",0).transition().style(\"opacity\",1);var w=f&&l.tryColorscale(u.marker,\"\"),T=f&&l.tryColorscale(u.marker,\"line\");n.order(),n.each(function(e){var n=o.select(this),i=m(n);a=l.translatePoint(e,i,k,A),a?(l.singlePointStyle(e,i,u,w,T,t),r.layerClipId&&l.hideOutsideRangePoint(e,i,k,A),u.customdata&&n.classed(\"plotly-customdata\",null!==e.data&&void 0!==e.data)):i.remove()}),M?n.exit().transition().style(\"opacity\",0).remove():n.exit().remove(),i=h.selectAll(\"g\"),n=i.data(x,p),n.enter().append(\"g\").classed(\"textpoint\",!0).append(\"text\"),n.order(),n.each(function(t){var e=o.select(this),n=m(e.select(\"text\"));a=l.translatePoint(t,n,k,A),a?r.layerClipId&&l.hideOutsideRangePoint(t,e,k,A):e.remove()}),n.selectAll(\"text\").call(l.textPointStyle,u,t).each(function(t){var e=k.c2p(t.x),r=A.c2p(t.y);o.select(this).selectAll(\"tspan.line\").each(function(){m(o.select(this)).attr({x:e,y:r})})}),n.exit().remove()}var _,w;a(t,e,r,n,i);var M=!!p&&p.duration>0,k=r.xaxis,A=r.yaxis,T=n[0].trace,S=T.line,E=o.select(f);if(E.call(u.plot,r,p),!0===T.visible){m(E).style(\"opacity\",T.opacity);var L,C,z=T.fill.charAt(T.fill.length-1);\"x\"!==z&&\"y\"!==z&&(z=\"\"),n[0].node3=E;var I=\"\",D=[],P=T._prevtrace;P&&(I=P._prevRevpath||\"\",C=P._nextFill,D=P._polygons);var O,R,F,j,N,B,U,V,H,q=\"\",G=\"\",Y=[],X=s.noop;if(L=T._ownFill,c.hasLines(T)||\"none\"!==T.fill){for(C&&C.datum(n),-1!==[\"hv\",\"vh\",\"hvh\",\"vhv\"].indexOf(S.shape)?(F=l.steps(S.shape),j=l.steps(S.shape.split(\"\").reverse().join(\"\"))):F=j=\"spline\"===S.shape?function(t){var e=t[t.length-1];return t.length>1&&t[0][0]===e[0]&&t[0][1]===e[1]?l.smoothclosed(t.slice(1),S.smoothing):l.smoothopen(t,S.smoothing)}:function(t){return\"M\"+t.join(\"L\")},N=function(t){return j(t.reverse())},Y=h(n,{xaxis:k,yaxis:A,connectGaps:T.connectgaps,baseTolerance:Math.max(S.width||1,3)/4,linear:\"linear\"===S.shape,simplify:S.simplify}),H=T._polygons=new Array(Y.length),w=0;w<Y.length;w++)T._polygons[w]=d(Y[w]);Y.length&&(B=Y[0][0],U=Y[Y.length-1],V=U[U.length-1]),X=function(t){return function(e){if(O=F(e),R=N(e),q?z?(q+=\"L\"+O.substr(1),G=R+\"L\"+G.substr(1)):(q+=\"Z\"+O,G=R+\"Z\"+G):(q=O,G=R),c.hasLines(T)&&e.length>1){var r=o.select(this);if(r.datum(n),t)m(r.style(\"opacity\",0).attr(\"d\",O).call(l.lineGroupStyle)).style(\"opacity\",1);else{var i=m(r);i.attr(\"d\",O),l.singleLineStyle(n,i)}}}}}var W=E.selectAll(\".js-line\").data(Y);m(W.exit()).style(\"opacity\",0).remove(),W.each(X(!1)),W.enter().append(\"path\").classed(\"js-line\",!0).style(\"vector-effect\",\"non-scaling-stroke\").call(l.lineGroupStyle).each(X(!0)),l.setClipUrl(W,r.layerClipId),Y.length&&(L?B&&V&&(z?(\"y\"===z?B[1]=V[1]=A.c2p(0,!0):\"x\"===z&&(B[0]=V[0]=k.c2p(0,!0)),m(L).attr(\"d\",\"M\"+V+\"L\"+B+\"L\"+q.substr(1)).call(l.singleFillStyle)):m(L).attr(\"d\",q+\"Z\").call(l.singleFillStyle)):\"tonext\"===T.fill.substr(0,6)&&q&&I&&(\"tonext\"===T.fill?m(C).attr(\"d\",q+\"Z\"+I+\"Z\").call(l.singleFillStyle):m(C).attr(\"d\",q+\"L\"+I.substr(1)+\"Z\").call(l.singleFillStyle),T._polygons=T._polygons.concat(D)),T._prevRevpath=G,T._prevPolygons=H);var Z=E.selectAll(\".points\");_=Z.data([n]),Z.each(x),_.enter().append(\"g\").classed(\"points\",!0).each(x),_.exit().remove(),_.each(function(t){var e=!1===t[0].trace.cliponaxis;l.setClipUrl(o.select(this),e?null:r.layerClipId)})}}function a(t,e,r,n,i){var a=r.xaxis,l=r.yaxis,u=o.extent(s.simpleMap(a.range,a.r2c)),h=o.extent(s.simpleMap(l.range,l.r2c)),f=n[0].trace;if(c.hasMarkers(f)){var d=f.marker.maxdisplayed;if(0!==d){var p=n.filter(function(t){return t.x>=u[0]&&t.x<=u[1]&&t.y>=h[0]&&t.y<=h[1]}),m=Math.ceil(p.length/d),v=0;i.forEach(function(t,r){var n=t[0].trace;c.hasMarkers(n)&&n.marker.maxdisplayed>0&&r<e&&v++});var g=Math.round(v*m/3+Math.floor(v/3)*m/7.1);n.forEach(function(t){delete t.vis}),p.forEach(function(t,e){0===Math.round((e+g)%m)&&(t.vis=!0)})}}}var o=t(\"d3\"),s=t(\"../../lib\"),l=t(\"../../components/drawing\"),u=t(\"../../components/errorbars\"),c=t(\"./subtypes\"),h=t(\"./line_points\"),f=t(\"./link_traces\"),d=t(\"../../lib/polygon\").tester;e.exports=function(t,e,r,a,s){var l,u,c,h,d,p=e.plot.select(\"g.scatterlayer\"),m=!a,v=!!a&&a.duration>0;for(c=p.selectAll(\"g.trace\"),h=c.data(r,function(t){return t[0].trace.uid}),h.enter().append(\"g\").attr(\"class\",function(t){return\"trace scatter trace\"+t[0].trace.uid}).style(\"stroke-miterlimit\",2),f(t,e,r),n(t,p,e),l=0,u={};l<r.length;l++)u[r[l][0].trace.uid]=l;if(p.selectAll(\"g.trace\").sort(function(t,e){return u[t[0].trace.uid]>u[e[0].trace.uid]?1:-1}),v){s&&(d=s());o.transition().duration(a.duration).ease(a.easing).each(\"end\",function(){d&&d()}).each(\"interrupt\",function(){d&&d()}).each(function(){p.selectAll(\"g.trace\").each(function(n,o){i(t,o,e,n,r,this,a)})})}else p.selectAll(\"g.trace\").each(function(n,o){i(t,o,e,n,r,this,a)});m&&h.exit().remove(),p.selectAll(\"path:not([d])\").remove()}},{\"../../components/drawing\":627,\"../../components/errorbars\":633,\"../../lib\":725,\"../../lib/polygon\":736,\"./line_points\":1039,\"./link_traces\":1041,\"./subtypes\":1047,d3:121}],1045:[function(t,e,r){\"use strict\";var n=t(\"./subtypes\"),i=t(\"../../constants/interactions\").DESELECTDIM;e.exports=function(t,e){var r,a,o,s,l=t.cd,u=t.xaxis,c=t.yaxis,h=[],f=l[0].trace,d=f.marker,p=!n.hasMarkers(f)&&!n.hasText(f);if(!0===f.visible&&!p){var m=Array.isArray(d.opacity)?1:d.opacity;if(!1===e)for(r=0;r<l.length;r++)l[r].dim=0;else for(r=0;r<l.length;r++)a=l[r],o=u.c2p(a.x),s=c.c2p(a.y),e.contains([o,s])?(h.push({pointNumber:r,x:a.x,y:a.y}),a.dim=0):a.dim=1;return l[0].node3.selectAll(\"path.point\").style(\"opacity\",function(t){return((t.mo+1||m+1)-1)*(t.dim?i:1)}),l[0].node3.selectAll(\"text\").style(\"opacity\",function(t){return t.dim?i:1}),h}}},{\"../../constants/interactions\":704,\"./subtypes\":1047}],1046:[function(t,e,r){\"use strict\";var n=t(\"d3\"),i=t(\"../../components/drawing\"),a=t(\"../../components/errorbars\");e.exports=function(t){var e=n.select(t).selectAll(\"g.trace.scatter\");e.style(\"opacity\",function(t){return t[0].trace.opacity}),e.selectAll(\"g.points\").each(function(e){var r=n.select(this),a=r.selectAll(\"path.point\"),o=e.trace||e[0].trace;a.call(i.pointStyle,o,t),r.selectAll(\"text\").call(i.textPointStyle,o,t)}),e.selectAll(\"g.trace path.js-line\").call(i.lineGroupStyle),e.selectAll(\"g.trace path.js-fill\").call(i.fillGroupStyle),e.call(a.style)}},{\"../../components/drawing\":627,\"../../components/errorbars\":633,d3:121}],1047:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports={hasLines:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"lines\")},hasMarkers:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"markers\")},hasText:function(t){return t.visible&&t.mode&&-1!==t.mode.indexOf(\"text\")},isBubble:function(t){return n.isPlainObject(t.marker)&&Array.isArray(t.marker.size)}}},{\"../../lib\":725}],1048:[function(t,e,r){\"use strict\";var n=t(\"../../lib\");e.exports=function(t,e,r,i){i(\"textposition\"),n.coerceFont(i,\"textfont\",r.font)}},{\"../../lib\":725}],1049:[function(t,e,r){\"use strict\";var n=t(\"../../registry\");e.exports=function(t,e,r,i){var a,o=i(\"x\"),s=i(\"y\");if(n.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\"],r),o)s?(a=Math.min(o.length,s.length),a<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.y=s.slice(0,a))):(a=o.length,i(\"y0\"),i(\"dy\"));else{if(!s)return 0;a=e.y.length,i(\"x0\"),i(\"dx\")}return a}},{\"../../registry\":844}],1050:[function(t,e,r){\"use strict\";function n(t){return{show:{valType:\"boolean\",dflt:!1},opacity:{valType:\"number\",min:0,max:1,dflt:1},scale:{valType:\"number\",min:0,max:10,dflt:2/3}}}var i=t(\"../scatter/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/errorbars/attributes\"),s=t(\"../../constants/gl3d_dashes\"),l=t(\"../../constants/gl3d_markers\"),u=t(\"../../lib/extend\").extendFlat,c=i.line,h=i.marker,f=h.line;e.exports={x:{valType:\"data_array\"},y:{valType:\"data_array\"},z:{valType:\"data_array\"},text:u({},i.text,{}),hovertext:u({},i.hovertext,{}),mode:u({},i.mode,{dflt:\"lines+markers\"}),surfaceaxis:{valType:\"enumerated\",values:[-1,0,1,2],dflt:-1},surfacecolor:{valType:\"color\"},projection:{x:n(\"x\"),y:n(\"y\"),z:n(\"z\")},connectgaps:i.connectgaps,line:u({},{width:c.width,dash:{valType:\"enumerated\",values:Object.keys(s),dflt:\"solid\"},showscale:{valType:\"boolean\",dflt:!1}},a(\"line\")),marker:u({},{symbol:{valType:\"enumerated\",values:Object.keys(l),dflt:\"circle\",arrayOk:!0},size:u({},h.size,{dflt:8}),sizeref:h.sizeref,sizemin:h.sizemin,sizemode:h.sizemode,opacity:u({},h.opacity,{arrayOk:!1}),showscale:h.showscale,colorbar:h.colorbar,line:u({},{width:u({},f.width,{arrayOk:!1})},a(\"marker.line\"))},a(\"marker\")),textposition:u({},i.textposition,{dflt:\"top center\"}),textfont:i.textfont,error_x:o,error_y:o,error_z:o}},{\"../../components/colorscale/color_attributes\":610,\"../../components/errorbars/attributes\":629,\"../../constants/gl3d_dashes\":702,\"../../constants/gl3d_markers\":703,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],1051:[function(t,e,r){\"use strict\";var n=t(\"../scatter/arrays_to_calcdata\"),i=t(\"../scatter/colorscale_calc\");e.exports=function(t,e){var r=[{x:!1,y:!1,trace:e,t:{}}];return n(r,e),i(e),r}},{\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031}],1052:[function(t,e,r){\"use strict\";function n(t,e,r){if(!e||!e.visible)return null;for(var n=o(e),i=new Array(t.length),a=0;a<t.length;a++){var s=n(+t[a],a);i[a]=[-s[0]*r,s[1]*r]}return i}function i(t){for(var e=0;e<t.length;e++)if(t[e])return t[e].length;return 0}function a(t,e){var r=[n(t.x,t.error_x,e[0]),n(t.y,t.error_y,e[1]),n(t.z,t.error_z,e[2])],a=i(r);if(0===a)return null;for(var o=new Array(a),s=0;s<a;s++){for(var l=[[0,0,0],[0,0,0]],u=0;u<3;u++)if(r[u])for(var c=0;c<2;c++)l[c][u]=r[u][s][c];o[s]=l}return o}var o=t(\"../../components/errorbars/compute_error\");e.exports=a},{\"../../components/errorbars/compute_error\":631}],1053:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.linePlot=null,this.scatterPlot=null,this.errorBars=null,this.textMarkers=null,this.delaunayMesh=null,this.color=null,this.mode=\"\",this.dataPoints=[],this.axesBounds=[[-1/0,-1/0,-1/0],[1/0,1/0,1/0]],this.textLabels=null,this.data=null}function i(t,e,r){var n,i=(r+1)%3,a=(r+2)%3,o=[],s=[];for(n=0;n<t.length;++n){var l=t[n];!isNaN(l[i])&&isFinite(l[i])&&!isNaN(l[a])&&isFinite(l[a])&&(o.push([l[i],l[a]]),s.push(n))}var u=g(o);for(n=0;n<u.length;++n)for(var c=u[n],h=0;h<c.length;++h)c[h]=s[c[h]];return{positions:t,cells:u,meshColor:e}}function a(t){for(var e=[0,0,0],r=[[0,0,0],[0,0,0],[0,0,0]],n=[0,0,0],i=0;i<3;i++){var a=t[i];a&&!1!==a.copy_zstyle&&(a=t[2]),a&&(e[i]=a.width/2,r[i]=b(a.color),n=a.thickness)}return{capSize:e,color:r,lineWidth:n}}function o(t){var e=[0,0];return Array.isArray(t)?[0,-1]:(t.indexOf(\"bottom\")>=0&&(e[1]+=1),t.indexOf(\"top\")>=0&&(e[1]-=1),t.indexOf(\"left\")>=0&&(e[0]-=1),t.indexOf(\"right\")>=0&&(e[0]+=1),e)}function s(t,e){return e(4*t)}function l(t){return M[t]}function u(t,e,r,n,i){var a=null;if(Array.isArray(t)){a=[];for(var o=0;o<e;o++)void 0===t[o]?a[o]=n:a[o]=r(t[o],i)}else a=r(t,y.identity);return a}function c(t,e){var r,n,i,c,h,f,d=[],p=t.fullSceneLayout,m=t.dataScale,v=p.xaxis,g=p.yaxis,w=p.zaxis,M=e.marker,A=e.line,T=e.x||[],S=e.y||[],E=e.z||[],L=T.length,C=e.xcalendar,z=e.ycalendar,I=e.zcalendar;for(n=0;n<L;n++)i=v.d2l(T[n],0,C)*m[0],c=g.d2l(S[n],0,z)*m[1],h=w.d2l(E[n],0,I)*m[2],d[n]=[i,c,h];if(Array.isArray(e.text))f=e.text;else if(void 0!==e.text)for(f=new Array(L),n=0;n<L;n++)f[n]=e.text;if(r={position:d,mode:e.mode,text:f},\"line\"in e&&(r.lineColor=x(A,1,L),r.lineWidth=A.width,r.lineDashes=A.dash),\"marker\"in e){var D=_(e);r.scatterColor=x(M,1,L),r.scatterSize=u(M.size,L,s,20,D),r.scatterMarker=u(M.symbol,L,l,\"\\u25cf\"),r.scatterLineWidth=M.line.width,r.scatterLineColor=x(M.line,1,L),r.scatterAngle=0}\"textposition\"in e&&(r.textOffset=o(e.textposition),r.textColor=x(e.textfont,1,L),r.textSize=u(e.textfont.size,L,y.identity,12),r.textFont=e.textfont.family,r.textAngle=0);var P=[\"x\",\"y\",\"z\"];for(r.project=[!1,!1,!1],r.projectScale=[1,1,1],r.projectOpacity=[1,1,1],n=0;n<3;++n){var O=e.projection[P[n]];(r.project[n]=O.show)&&(r.projectOpacity[n]=O.opacity,r.projectScale[n]=O.scale)}r.errorBounds=k(e,m);var R=a([e.error_x,e.error_y,e.error_z]);return r.errorColor=R.color,r.errorLineWidth=R.lineWidth,r.errorCapSize=R.capSize,r.delaunayAxis=e.surfaceaxis,r.delaunayColor=b(e.surfacecolor),r}function h(t){if(Array.isArray(t)){var e=t[0];return Array.isArray(e)&&(t=e),\"rgb(\"+t.slice(0,3).map(function(t){return Math.round(255*t)})+\")\"}return null}function f(t,e){var r=new n(t,e.uid);return r.update(e),r}var d=t(\"gl-line3d\"),p=t(\"gl-scatter3d\"),m=t(\"gl-error3d\"),v=t(\"gl-mesh3d\"),g=t(\"delaunay-triangulate\"),y=t(\"../../lib\"),b=t(\"../../lib/str2rgbarray\"),x=t(\"../../lib/gl_format_color\"),_=t(\"../scatter/make_bubble_size_func\"),w=t(\"../../constants/gl3d_dashes\"),M=t(\"../../constants/gl3d_markers\"),k=t(\"./calc_errors\"),A=n.prototype;A.handlePick=function(t){if(t.object&&(t.object===this.linePlot||t.object===this.delaunayMesh||t.object===this.textMarkers||t.object===this.scatterPlot)){t.object.highlight&&t.object.highlight(null),this.scatterPlot&&(t.object=this.scatterPlot,this.scatterPlot.highlight(t.data)),this.textLabels?void 0!==this.textLabels[t.data.index]?t.textLabel=this.textLabels[t.data.index]:t.textLabel=this.textLabels:t.textLabel=\"\";var e=t.index=t.data.index;return t.traceCoordinate=[this.data.x[e],this.data.y[e],this.data.z[e]],!0}},A.update=function(t){var e,r,n,a,o=this.scene.glplot.gl,s=w.solid;this.data=t;var l=c(this.scene,t);\"mode\"in l&&(this.mode=l.mode),\"lineDashes\"in l&&l.lineDashes in w&&(s=w[l.lineDashes]),this.color=h(l.scatterColor)||h(l.lineColor),this.dataPoints=l.position,e={gl:o,position:l.position,color:l.lineColor,lineWidth:l.lineWidth||1,dashes:s[0],dashScale:s[1],opacity:t.opacity,connectGaps:t.connectgaps},-1!==this.mode.indexOf(\"lines\")?this.linePlot?this.linePlot.update(e):(this.linePlot=d(e),this.linePlot._trace=this,this.scene.glplot.add(this.linePlot)):this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose(),this.linePlot=null);var u=t.opacity;if(t.marker&&t.marker.opacity&&(u*=t.marker.opacity),r={gl:o,position:l.position,color:l.scatterColor,size:l.scatterSize,glyph:l.scatterMarker,opacity:u,orthographic:!0,lineWidth:l.scatterLineWidth,lineColor:l.scatterLineColor,project:l.project,projectScale:l.projectScale,projectOpacity:l.projectOpacity},-1!==this.mode.indexOf(\"markers\")?this.scatterPlot?this.scatterPlot.update(r):(this.scatterPlot=p(r),this.scatterPlot._trace=this,this.scatterPlot.highlightScale=1,this.scene.glplot.add(this.scatterPlot)):this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose(),this.scatterPlot=null),a={gl:o,position:l.position,glyph:l.text,color:l.textColor,size:l.textSize,angle:l.textAngle,alignment:l.textOffset,font:l.textFont,orthographic:!0,lineWidth:0,project:!1,opacity:t.opacity},this.textLabels=t.hovertext||t.text,-1!==this.mode.indexOf(\"text\")?this.textMarkers?this.textMarkers.update(a):(this.textMarkers=p(a),this.textMarkers._trace=this,this.textMarkers.highlightScale=1,this.scene.glplot.add(this.textMarkers)):this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose(),this.textMarkers=null),n={gl:o,position:l.position,color:l.errorColor,error:l.errorBounds,lineWidth:l.errorLineWidth,capSize:l.errorCapSize,opacity:t.opacity},this.errorBars?l.errorBounds?this.errorBars.update(n):(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose(),this.errorBars=null):l.errorBounds&&(this.errorBars=m(n),this.errorBars._trace=this,this.scene.glplot.add(this.errorBars)),l.delaunayAxis>=0){var f=i(l.position,l.delaunayColor,l.delaunayAxis);f.opacity=t.opacity,this.delaunayMesh?this.delaunayMesh.update(f):(f.gl=o,this.delaunayMesh=v(f),this.delaunayMesh._trace=this,this.scene.glplot.add(this.delaunayMesh))}else this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose(),this.delaunayMesh=null)},A.dispose=function(){this.linePlot&&(this.scene.glplot.remove(this.linePlot),this.linePlot.dispose()),this.scatterPlot&&(this.scene.glplot.remove(this.scatterPlot),this.scatterPlot.dispose()),this.errorBars&&(this.scene.glplot.remove(this.errorBars),this.errorBars.dispose()),this.textMarkers&&(this.scene.glplot.remove(this.textMarkers),this.textMarkers.dispose()),this.delaunayMesh&&(this.scene.glplot.remove(this.delaunayMesh),this.delaunayMesh.dispose())},e.exports=f},{\"../../constants/gl3d_dashes\":702,\"../../constants/gl3d_markers\":703,\"../../lib\":725,\"../../lib/gl_format_color\":722,\"../../lib/str2rgbarray\":744,\"../scatter/make_bubble_size_func\":1042,\"./calc_errors\":1052,\"delaunay-triangulate\":122,\"gl-error3d\":160,\"gl-line3d\":171,\"gl-mesh3d\":204,\"gl-scatter3d\":250}],1054:[function(t,e,r){\"use strict\";function n(t,e,r,n){var a=0,o=r(\"x\"),s=r(\"y\"),l=r(\"z\");return i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],n),o&&s&&l&&(a=Math.min(o.length,s.length,l.length),a<o.length&&(e.x=o.slice(0,a)),a<s.length&&(e.y=s.slice(0,a)),a<l.length&&(e.z=l.slice(0,a))),a}var i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../scatter/subtypes\"),s=t(\"../scatter/marker_defaults\"),l=t(\"../scatter/line_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../../components/errorbars/defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,i){function f(r,n){return a.coerce(t,e,h,r,n)}if(!n(t,e,f,i))return void(e.visible=!1);f(\"text\"),f(\"hovertext\"),f(\"mode\"),o.hasLines(e)&&(f(\"connectgaps\"),l(t,e,r,i,f)),o.hasMarkers(e)&&s(t,e,r,i,f),o.hasText(e)&&u(t,e,i,f);var d=(e.line||{}).color,p=(e.marker||{}).color;f(\"surfaceaxis\")>=0&&f(\"surfacecolor\",d||p);for(var m=[\"x\",\"y\",\"z\"],v=0;v<3;++v){var g=\"projection.\"+m[v];f(g+\".show\")&&(f(g+\".opacity\"),f(g+\".scale\"))}c(t,e,r,{axis:\"z\"}),c(t,e,r,{axis:\"y\",inherit:\"z\"}),c(t,e,r,{axis:\"x\",inherit:\"z\"})}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../../registry\":844,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1050}],1055:[function(t,e,r){\"use strict\";var n={};n.plot=t(\"./convert\"),n.attributes=t(\"./attributes\"),n.markerSymbols=t(\"../../constants/gl3d_markers\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.moduleType=\"trace\",n.name=\"scatter3d\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\",\"symbols\",\"markerColorscale\",\"showLegend\"],n.meta={},e.exports=n},{\"../../constants/gl3d_markers\":703,\"../../plots/gl3d\":809,\"../scatter/colorbar\":1030,\"./attributes\":1050,\"./calc\":1051,\"./convert\":1053,\"./defaults\":1054}],\n",
       "1056:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../lib/extend\").extendFlat,l=n.marker,u=n.line,c=l.line;e.exports={carpet:{valType:\"string\"},a:{valType:\"data_array\"},b:{valType:\"data_array\"},sum:{valType:\"number\",dflt:0,min:0},mode:s({},n.mode,{dflt:\"markers\"}),text:s({},n.text,{}),line:{color:u.color,width:u.width,dash:u.dash,shape:s({},u.shape,{values:[\"linear\",\"spline\"]}),smoothing:u.smoothing},connectgaps:n.connectgaps,fill:s({},n.fill,{values:[\"none\",\"toself\",\"tonext\"]}),fillcolor:n.fillcolor,marker:s({},{symbol:l.symbol,opacity:l.opacity,maxdisplayed:l.maxdisplayed,size:l.size,sizeref:l.sizeref,sizemin:l.sizemin,sizemode:l.sizemode,line:s({},{width:c.width},a(\"marker\".line)),gradient:l.gradient},a(\"marker\"),{showscale:l.showscale,colorbar:o}),textfont:n.textfont,textposition:n.textposition,hoverinfo:s({},i.hoverinfo,{flags:[\"a\",\"b\",\"text\",\"name\"]}),hoveron:n.hoveron}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1057:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/colorscale_calc\"),s=t(\"../scatter/arrays_to_calcdata\"),l=t(\"../carpet/lookup_carpetid\");e.exports=function(t,e){var r=e.carpetTrace=l(t,e);if(r&&r.visible&&\"legendonly\"!==r.visible){var u;e.xaxis=r.xaxis,e.yaxis=r.yaxis;var c,h,f=e.a.length,d=new Array(f),p=!1;for(u=0;u<f;u++)if(c=e.a[u],h=e.b[u],n(c)&&n(h)){var m=r.ab2xy(+c,+h,!0),v=r.isVisible(+c,+h);v||(p=!0),d[u]={x:m[0],y:m[1],a:c,b:h,vis:v}}else d[u]={x:!1,y:!1};e._needsCull=p,d[0].carpet=r,d[0].trace=e;var g,y;if(a.hasMarkers(e)&&(g=e.marker,y=g.size,Array.isArray(y))){var b={type:\"linear\"};i.setConvert(b),y=b.makeCalcdata(e.marker,\"size\"),y.length>f&&y.splice(f,y.length-f)}return o(e),s(d,e),d}}},{\"../../plots/cartesian/axes\":766,\"../carpet/lookup_carpetid\":900,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1058:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/line_shape_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../scatter/fillcolor_defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}d(\"carpet\"),e.xaxis=\"x\",e.yaxis=\"y\";var p,m=d(\"a\"),v=d(\"b\");if(!(p=Math.min(m.length,v.length)))return void(e.visible=!1);m&&p<m.length&&(e.a=m.slice(0,p)),v&&p<v.length&&(e.b=v.slice(0,p)),d(\"sum\"),d(\"text\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(s(t,e,r,f,d),l(t,e,d),d(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,f,d,{gradient:!0}),a.hasText(e)&&u(t,e,f,d);var g=[];(a.hasMarkers(e)||a.hasText(e))&&(d(\"marker.maxdisplayed\"),g.push(\"points\")),d(\"fill\"),\"none\"!==e.fill&&(c(t,e,r,d),a.hasLines(e)||l(t,e,d)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||g.push(\"fills\"),d(\"hoveron\",g.join(\"+\")||\"points\")}},{\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/line_shape_defaults\":1040,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1056}],1059:[function(t,e,r){\"use strict\";var n=t(\"../scatter/hover\");e.exports=function(t,e,r,i){function a(t,e){v.push((t.labelprefix&&t.labelprefix.length>0?t.labelprefix:t._hovertitle+\": \")+e.toFixed(3)+t.labelsuffix)}var o=n(t,e,r,i);if(o&&!1!==o[0].index){var s=o[0];if(void 0===s.index){var l=1-s.y0/t.ya._length,u=t.xa._length,c=u*l/2,h=u-c;return s.x0=Math.max(Math.min(s.x0,h),c),s.x1=Math.max(Math.min(s.x1,h),c),o}var f=s.cd[s.index];s.a=f.a,s.b=f.b,s.xLabelVal=void 0,s.yLabelVal=void 0;var d=s.trace,p=d._carpet,m=d.hoverinfo.split(\"+\"),v=[];-1!==m.indexOf(\"all\")&&(m=[\"a\",\"b\"]),-1!==m.indexOf(\"a\")&&a(p.aaxis,f.a),-1!==m.indexOf(\"b\")&&a(p.baxis,f.b);var g=p.ab2ij([f.a,f.b]),y=Math.floor(g[0]),b=g[0]-y,x=Math.floor(g[1]),_=g[1]-x,w=p.evalxy([],y,x,b,_);return v.push(\"y: \"+w[1].toFixed(3)),s.extraText=v.join(\"<br>\"),o}}},{\"../scatter/hover\":1036}],1060:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattercarpet\",n.basePlotModule=t(\"../../plots/cartesian\"),n.categories=[\"carpet\",\"symbols\",\"markerColorscale\",\"showLegend\",\"carpetDependent\"],n.meta={},e.exports=n},{\"../../plots/cartesian\":776,\"../scatter/colorbar\":1030,\"./attributes\":1056,\"./calc\":1057,\"./defaults\":1058,\"./hover\":1059,\"./plot\":1061,\"./select\":1062,\"./style\":1063}],1061:[function(t,e,r){\"use strict\";var n=t(\"../scatter/plot\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../../components/drawing\");e.exports=function(t,e,r){var o,s,l,u=r[0][0].carpet,c={xaxis:i.getFromId(t,u.xaxis||\"x\"),yaxis:i.getFromId(t,u.yaxis||\"y\"),plot:e.plot};for(n(t,c,r),o=0;o<r.length;o++)s=r[o][0].trace,l=c.plot.selectAll(\"g.trace\"+s.uid+\" .js-line\"),a.setClipUrl(l,u._clipPathId)}},{\"../../components/drawing\":627,\"../../plots/cartesian/axes\":766,\"../scatter/plot\":1044}],1062:[function(t,e,r){\"use strict\";var n=t(\"../scatter/select\");e.exports=function(t,e){var r=n(t,e);if(r){var i,a,o,s=t.cd;for(o=0;o<r.length;o++)i=r[o],a=s[i.pointNumber],i.a=a.a,i.b=a.b,i.c=a.c,delete i.x,delete i.y;return r}}},{\"../scatter/select\":1045}],1063:[function(t,e,r){\"use strict\";var n=t(\"../scatter/style\");e.exports=function(t){for(var e=t._fullLayout._modules,r=0;r<e.length;r++)if(\"scatter\"===e[r].name)return;n(t)}},{\"../scatter/style\":1046}],1064:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/drawing/attributes\").dash,s=t(\"../../lib/extend\").extendFlat,l=n.marker,u=n.line,c=l.line;e.exports={lon:{valType:\"data_array\"},lat:{valType:\"data_array\"},locations:{valType:\"data_array\"},locationmode:{valType:\"enumerated\",values:[\"ISO-3\",\"USA-states\",\"country names\"],dflt:\"ISO-3\"},mode:s({},n.mode,{dflt:\"markers\"}),text:s({},n.text,{}),hovertext:s({},n.hovertext,{}),textfont:n.textfont,textposition:n.textposition,line:{color:u.color,width:u.width,dash:o},connectgaps:n.connectgaps,marker:s({},{symbol:l.symbol,opacity:l.opacity,size:l.size,sizeref:l.sizeref,sizemin:l.sizemin,sizemode:l.sizemode,showscale:l.showscale,colorbar:l.colorbar,line:s({},{width:c.width},a(\"marker.line\")),gradient:l.gradient},a(\"marker\")),fill:{valType:\"enumerated\",values:[\"none\",\"toself\"],dflt:\"none\"},fillcolor:n.fillcolor,hoverinfo:s({},i.hoverinfo,{flags:[\"lon\",\"lat\",\"location\",\"text\",\"name\"]})}},{\"../../components/colorscale/color_attributes\":610,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1065:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../constants/numerical\").BADNUM,a=t(\"../scatter/colorscale_calc\"),o=t(\"../scatter/arrays_to_calcdata\");e.exports=function(t,e){for(var r=Array.isArray(e.locations),s=r?e.locations.length:e.lon.length,l=new Array(s),u=0;u<s;u++){var c=l[u]={};if(r){var h=e.locations[u];c.loc=\"string\"==typeof h?h:null}else{var f=e.lon[u],d=e.lat[u];n(f)&&n(d)?c.lonlat=[+f,+d]:c.lonlat=[i,i]}}return o(l,e),a(e),l}},{\"../../constants/numerical\":705,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"fast-isnumeric\":130}],1066:[function(t,e,r){\"use strict\";function n(t,e,r){var n,i,a=0,o=r(\"locations\");return o?(r(\"locationmode\"),a=o.length):(n=r(\"lon\")||[],i=r(\"lat\")||[],a=Math.min(n.length,i.length),a<n.length&&(e.lon=n.slice(0,a)),a<i.length&&(e.lat=i.slice(0,a)),a)}var i=t(\"../../lib\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/text_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"./attributes\");e.exports=function(t,e,r,h){function f(r,n){return i.coerce(t,e,c,r,n)}if(!n(t,e,f))return void(e.visible=!1);f(\"text\"),f(\"hovertext\"),f(\"mode\"),a.hasLines(e)&&(s(t,e,r,h,f),f(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,h,f,{gradient:!0}),a.hasText(e)&&l(t,e,h,f),f(\"fill\"),\"none\"!==e.fill&&u(t,e,r,f)}},{\"../../lib\":725,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1064}],1067:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t.location=e.loc?e.loc:null,t}},{}],1068:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){return a.tickText(r,r.c2l(t),\"hover\").text+\"\\xb0\"}var i=t.hoverinfo,o=\"all\"===i?l.hoverinfo.flags:i.split(\"+\"),s=-1!==o.indexOf(\"location\")&&Array.isArray(t.locations),u=-1!==o.indexOf(\"lon\"),c=-1!==o.indexOf(\"lat\"),h=-1!==o.indexOf(\"text\"),f=[];if(s?f.push(e.loc):u&&c?f.push(\"(\"+n(e.lonlat[0])+\", \"+n(e.lonlat[1])+\")\"):u?f.push(\"lon: \"+n(e.lonlat[0])):c&&f.push(\"lat: \"+n(e.lonlat[1])),h){var d;e.htx?d=e.htx:t.hovertext?d=t.hovertext:e.tx?d=e.tx:t.text&&(d=t.text),Array.isArray(d)||f.push(d)}return f.join(\"<br>\")}var i=t(\"../../components/fx\"),a=t(\"../../plots/cartesian/axes\"),o=t(\"../../constants/numerical\").BADNUM,s=t(\"../scatter/get_trace_color\"),l=t(\"./attributes\");e.exports=function(t){function e(t){return h.projection(t)}function r(t){var r=t.lonlat;if(r[0]===o)return 1/0;if(h.isLonLatOverEdges(r))return 1/0;var n=e(r),i=u.c2p(),a=c.c2p(),s=Math.abs(i-n[0]),l=Math.abs(a-n[1]),f=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(s*s+l*l)-f,1-3/f)}var a=t.cd,l=a[0].trace,u=t.xa,c=t.ya,h=t.subplot;if(i.getClosest(a,r,t),!1!==t.index){var f=a[t.index],d=f.lonlat,p=e(d),m=f.mrc||1;return t.x0=p[0]-m,t.x1=p[0]+m,t.y0=p[1]-m,t.y1=p[1]+m,t.loc=f.loc,t.lon=d[0],t.lat=d[1],t.color=s(l,f),t.extraText=n(l,f,h.mockAxis),[t]}}},{\"../../components/fx\":644,\"../../constants/numerical\":705,\"../../plots/cartesian/axes\":766,\"../scatter/get_trace_color\":1035,\"./attributes\":1064}],1069:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.moduleType=\"trace\",n.name=\"scattergeo\",n.basePlotModule=t(\"../../plots/geo\"),n.categories=[\"geo\",\"symbols\",\"markerColorscale\",\"showLegend\"],n.meta={},e.exports=n},{\"../../plots/geo\":794,\"../scatter/colorbar\":1030,\"./attributes\":1064,\"./calc\":1065,\"./defaults\":1066,\"./event_data\":1067,\"./hover\":1068,\"./plot\":1070}],1070:[function(t,e,r){\"use strict\";function n(t,e){var r=t[0].trace;if(Array.isArray(r.locations))for(var n=c(r,e),i=r.locationmode,a=0;a<t.length;a++){var o=t[a],s=h(i,o.loc,n);o.lonlat=s?s.properties.ct:[u,u]}}function i(t){var e=t.framework.selectAll(\"g.trace.scattergeo\");e.style(\"opacity\",function(t){return t[0].trace.opacity}),e.each(function(e){var r=e[0].trace,n=a.select(this);n.selectAll(\"path.point\").call(o.pointStyle,r,t.graphDiv),n.selectAll(\"text\").call(o.textPointStyle,r,t.graphDiv)}),e.selectAll(\"path.js-line\").style(\"fill\",\"none\").each(function(t){var e=a.select(this),r=t.trace,n=r.line||{};e.call(s.stroke,n.color).call(o.dashLine,n.dash||\"\",n.width||0),\"none\"!==r.fill&&e.call(s.fill,r.fillcolor)})}var a=t(\"d3\"),o=t(\"../../components/drawing\"),s=t(\"../../components/color\"),l=t(\"../../lib\"),u=t(\"../../constants/numerical\").BADNUM,c=t(\"../../lib/topojson_utils\").getTopojsonFeatures,h=t(\"../../lib/geo_location_utils\").locationToFeature,f=t(\"../../lib/geojson_utils\"),d=t(\"../scatter/subtypes\");e.exports=function(t,e){function r(t){return t[0].trace.uid}function o(t,e){t.lonlat[0]===u&&a.select(e).remove()}for(var s=0;s<e.length;s++)n(e[s],t.topojson);var c=t.framework.select(\".scattergeolayer\").selectAll(\"g.trace.scattergeo\").data(e,r);c.enter().append(\"g\").attr(\"class\",\"trace scattergeo\"),c.exit().remove(),c.selectAll(\"*\").remove(),c.each(function(t){var e=a.select(this),r=t[0].trace;if(d.hasLines(r)||\"none\"!==r.fill){var n=f.calcTraceToLineCoords(t),i=\"none\"!==r.fill?f.makePolygon(n,r):f.makeLine(n,r);e.selectAll(\"path.js-line\").data([i]).enter().append(\"path\").classed(\"js-line\",!0)}d.hasMarkers(r)&&e.selectAll(\"path.point\").data(l.identity).enter().append(\"path\").classed(\"point\",!0).each(function(t){o(t,this)}),d.hasText(r)&&e.selectAll(\"g\").data(l.identity).enter().append(\"g\").append(\"text\").each(function(t){o(t,this)})}),i(t)}},{\"../../components/color\":603,\"../../components/drawing\":627,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/geo_location_utils\":719,\"../../lib/geojson_utils\":720,\"../../lib/topojson_utils\":747,\"../scatter/subtypes\":1047,d3:121}],1071:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../components/colorscale/color_attributes\"),a=t(\"../../constants/gl2d_dashes\"),o=t(\"../../constants/gl2d_markers\"),s=t(\"../../lib/extend\").extendFlat,l=t(\"../../lib/extend\").extendDeep,u=n.line,c=n.marker,h=c.line;e.exports={x:n.x,x0:n.x0,dx:n.dx,y:n.y,y0:n.y0,dy:n.dy,text:s({},n.text,{}),mode:{valType:\"flaglist\",flags:[\"lines\",\"markers\"],extras:[\"none\"]},line:{color:u.color,width:u.width,dash:{valType:\"enumerated\",values:Object.keys(a),dflt:\"solid\"}},marker:l({},i(\"marker\"),{symbol:{valType:\"enumerated\",values:Object.keys(o),dflt:\"circle\",arrayOk:!0},size:c.size,sizeref:c.sizeref,sizemin:c.sizemin,sizemode:c.sizemode,opacity:c.opacity,showscale:c.showscale,colorbar:c.colorbar,line:l({},i(\"marker.line\"),{width:h.width})}),connectgaps:n.connectgaps,fill:s({},n.fill,{values:[\"none\",\"tozeroy\",\"tozerox\"]}),fillcolor:n.fillcolor,error_y:n.error_y,error_x:n.error_x}},{\"../../components/colorscale/color_attributes\":610,\"../../constants/gl2d_dashes\":700,\"../../constants/gl2d_markers\":701,\"../../lib/extend\":716,\"../scatter/attributes\":1027}],1072:[function(t,e,r){\"use strict\";var n=t(\"../../plots/cartesian/axes\"),i=t(\"../scatter/arrays_to_calcdata\"),a=t(\"../scatter/colorscale_calc\");e.exports=function(t,e){var r,o=t._fullLayout.dragmode;if(\"lasso\"===o||\"select\"===o){var s,l=n.getFromId(t,e.xaxis||\"x\"),u=n.getFromId(t,e.yaxis||\"y\"),c=l.makeCalcdata(e,\"x\"),h=u.makeCalcdata(e,\"y\"),f=Math.min(c.length,h.length);for(r=new Array(f),s=0;s<f;s++)r[s]={x:c[s],y:h[s]}}else r=[{x:!1,y:!1,trace:e,t:{}}],i(r,e);return a(e),r}},{\"../../plots/cartesian/axes\":766,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031}],1073:[function(t,e,r){\"use strict\";function n(t,e){this.scene=t,this.uid=e,this.type=\"scattergl\",this.pickXData=[],this.pickYData=[],this.xData=[],this.yData=[],this.textLabels=[],this.color=\"rgb(0, 0, 0)\",this.name=\"\",this.hoverinfo=\"all\",this.connectgaps=!0,this.index=null,this.idToIndex=[],this.bounds=[0,0,0,0],this.isVisible=!1,this.hasLines=!1,this.hasErrorX=!1,this.hasErrorY=!1,this.hasMarkers=!1,this.line=this.initObject(m,{positions:new Float64Array(0),color:[0,0,0,1],width:1,fill:[!1,!1,!1,!1],fillColor:[[0,0,0,1],[0,0,0,1],[0,0,0,1],[0,0,0,1]],dashes:[1]},0),this.errorX=this.initObject(v,{positions:new Float64Array(0),errors:new Float64Array(0),lineWidth:1,capSize:0,color:[0,0,0,1]},1),this.errorY=this.initObject(v,{positions:new Float64Array(0),errors:new Float64Array(0),lineWidth:1,capSize:0,color:[0,0,0,1]},2);var r={positions:new Float64Array(0),sizes:[],colors:[],glyphs:[],borderWidths:[],borderColors:[],size:12,color:[0,0,0,1],borderSize:1,borderColor:[0,0,0,1],snapPoints:!0},n=y.extendFlat({},r,{snapPoints:!1});this.scatter=this.initObject(d,r,3),this.fancyScatter=this.initObject(p,r,4),this.selectScatter=this.initObject(d,n,5)}function i(t,e,r){return Array.isArray(e)||(e=[e]),a(t,e,r)}function a(t,e,r){for(var n=new Array(r),i=e[0],a=0;a<r;++a)n[a]=t(a>=e.length?i:e[a]);return n}function o(t,e,r){return l(O(t,r),P(e,r),r)}function s(t,e,r,n){var i=k(t,e,n);return i=Array.isArray(i[0])?i:a(y.identity,[i],n),l(i,P(r,n),n)}function l(t,e,r){for(var n=new Array(4*r),i=0;i<r;++i){for(var a=0;a<3;++a)n[4*i+a]=t[i][a];n[4*i+3]=t[i][3]*e[i]}return n}function u(t){return\"\"===t.split(\"-open\")[1]}function c(t,e,r,n,i){var a,o=i?C:1;for(a=0;a<3;a++)t[4*r+a]=e[4*n+a];t[4*r+a]=o*e[4*n+a]}function h(t){for(var e,r=t.length,n=Math.max(1,(r-1)/Math.min(Math.max(r,1),1e3)),i=0;i<r;i+=n)if(e=t[Math.floor(i)],!(g(e)||e instanceof Date))return!1;return!0}function f(t,e,r){var i=new n(t,e.uid);return i.update(e,r),i}var d=t(\"gl-scatter2d\"),p=t(\"gl-scatter2d-sdf\"),m=t(\"gl-line2d\"),v=t(\"gl-error2d\"),g=t(\"fast-isnumeric\"),y=t(\"../../lib\"),b=t(\"../../plots/cartesian/axes\"),x=t(\"../../plots/cartesian/axis_autotype\"),_=t(\"../../components/errorbars\"),w=t(\"../../lib/str2rgbarray\"),M=t(\"../../lib/typed_array_truncate\"),k=t(\"../../lib/gl_format_color\"),A=t(\"../scatter/subtypes\"),T=t(\"../scatter/make_bubble_size_func\"),S=t(\"../scatter/get_trace_color\"),E=t(\"../../constants/gl2d_markers\"),L=t(\"../../constants/gl2d_dashes\"),C=t(\"../../constants/interactions\").DESELECTDIM,z=[\"xaxis\",\"yaxis\"],I=[0,0,0,0],D=n.prototype;D.initObject=function(t,e,r){function n(){u||(u=t(s,e),u._trace=o,u._index=r),u.update(e)}function i(){u&&u.update(l)}function a(){u&&u.dispose()}var o=this,s=o.scene.glplot,l=y.extendFlat({},e),u=null;return{options:e,update:n,clear:i,dispose:a}},D.handlePick=function(t){var e=t.pointId;(t.object!==this.line||this.connectgaps)&&(e=this.idToIndex[t.pointId]);var r=this.pickXData[e];return{trace:this,dataCoord:t.dataCoord,traceCoord:[g(r)||!y.isDateTime(r)?r:y.dateTime2ms(r),this.pickYData[e]],textLabel:Array.isArray(this.textLabels)?this.textLabels[e]:this.textLabels,color:Array.isArray(this.color)?this.color[e]:this.color,name:this.name,pointIndex:e,hoverinfo:this.hoverinfo}},D.isFancy=function(t){if(\"linear\"!==this.scene.xaxis.type&&\"date\"!==this.scene.xaxis.type)return!0;if(\"linear\"!==this.scene.yaxis.type)return!0;if(!t.x||!t.y)return!0;if(this.hasMarkers){var e=t.marker||{};if(Array.isArray(e.symbol)||\"circle\"!==e.symbol||Array.isArray(e.size)||Array.isArray(e.color)||Array.isArray(e.line.width)||Array.isArray(e.line.color)||Array.isArray(e.opacity))return!0}return!(!this.hasLines||this.connectgaps)||(!!this.hasErrorX||!!this.hasErrorY)};var P=i.bind(null,function(t){return+t}),O=i.bind(null,w),R=i.bind(null,function(t){return E[t]?t:\"circle\"});D.update=function(t,e){!0!==t.visible?(this.isVisible=!1,this.hasLines=!1,this.hasErrorX=!1,this.hasErrorY=!1,this.hasMarkers=!1):(this.isVisible=!0,this.hasLines=A.hasLines(t),this.hasErrorX=!0===t.error_x.visible,this.hasErrorY=!0===t.error_y.visible,this.hasMarkers=A.hasMarkers(t)),this.textLabels=t.text,this.name=t.name,this.hoverinfo=t.hoverinfo,this.bounds=[1/0,1/0,-1/0,-1/0],this.connectgaps=!!t.connectgaps,this.isVisible?this.isFancy(t)?this.updateFancy(t):this.updateFast(t):(this.line.clear(),this.errorX.clear(),this.errorY.clear(),this.scatter.clear(),this.fancyScatter.clear()),this.scene.glplot.objects.sort(function(t,e){return t._index-e._index}),this.index=t.index,this.color=S(t,{}),e&&e[0]&&!e[0]._glTrace&&(e[0]._glTrace=this)},D.updateFast=function(t){var e,r,n,i,a,o=this.xData=this.pickXData=t.x,s=this.yData=this.pickYData=t.y,l=o.length,u=new Array(l),c=new Float64Array(2*l),f=this.bounds,d=0,p=0,m=t.selection,v=t.xcalendar,b=h(o),_=!b&&\"date\"===x(o,v);if(b||_)for(e=0;e<l;++e)i=o[e],a=s[e],g(a)&&(b||(i=y.dateTime2ms(i,v)),c[p++]=i,c[p++]=a,u[d++]=e,f[0]=Math.min(f[0],i),f[1]=Math.min(f[1],a),f[2]=Math.max(f[2],i),f[3]=Math.max(f[3],a));if(c=M(c,p),this.idToIndex=u,m&&m.length)for(r=new Float64Array(2*m.length),e=0,n=m.length;e<n;e++)r[2*e+0]=m[e].x,r[2*e+1]=m[e].y;this.updateLines(t,c),this.updateError(\"X\",t),this.updateError(\"Y\",t);var k;if(this.hasMarkers){var A,T,S;r?(this.scatter.options.positions=null,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity*C,A[3]*=S,this.scatter.options.color=A,T[3]*=S,this.scatter.options.borderColor=T,k=t.marker.size,this.scatter.options.size=k,this.scatter.options.borderSize=t.marker.line.width,this.scatter.update(),this.scatter.options.positions=c,this.selectScatter.options.positions=r,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity,A[3]*=S,this.selectScatter.options.color=A,T[3]*=S,this.selectScatter.options.borderColor=T,k=t.marker.size,this.selectScatter.options.size=k,this.selectScatter.options.borderSize=t.marker.line.width,this.selectScatter.update()):(this.scatter.options.positions=c,A=w(t.marker.color),T=w(t.marker.line.color),S=t.opacity*t.marker.opacity,A[3]*=S,this.scatter.options.color=A,T[3]*=S,this.scatter.options.borderColor=T,k=t.marker.size,this.scatter.options.size=k,this.scatter.options.borderSize=t.marker.line.width,this.scatter.update())}else this.scatter.clear();this.fancyScatter.clear(),this.expandAxesFast(f,k)},D.updateFancy=function(t){var e=this.scene,r=e.xaxis,n=e.yaxis,a=this.bounds,o=t.selection,l=this.pickXData=r.makeCalcdata(t,\"x\").slice(),h=this.pickYData=n.makeCalcdata(t,\"y\").slice();this.xData=l.slice(),this.yData=h.slice();var f,d,p,m,v,g,y,b=_.calcFromTrace(t,e.fullLayout),x=l.length,w=new Array(x),k=new Float64Array(2*x),A=new Float64Array(4*x),S=new Float64Array(4*x),L=0,C=0,z=0,D=0,O=\"log\"===r.type?r.d2l:function(t){return t},F=\"log\"===n.type?n.d2l:function(t){return t};for(f=0;f<x;++f)this.xData[f]=d=O(l[f]),this.yData[f]=p=F(h[f]),isNaN(d)||isNaN(p)||(w[L++]=f,k[C++]=d,k[C++]=p,m=A[z++]=d-b[f].xs||0,v=A[z++]=b[f].xh-d||0,A[z++]=0,A[z++]=0,S[D++]=0,S[D++]=0,g=S[D++]=p-b[f].ys||0,y=S[D++]=b[f].yh-p||0,a[0]=Math.min(a[0],d-m),a[1]=Math.min(a[1],p-g),a[2]=Math.max(a[2],d+v),a[3]=Math.max(a[3],p+y));k=M(k,C),this.idToIndex=w,this.updateLines(t,k),this.updateError(\"X\",t,k,A),this.updateError(\"Y\",t,k,S);var j,N;if(o&&o.length)for(N={},f=0;f<o.length;f++)N[o[f].pointNumber]=!0;if(this.hasMarkers){this.scatter.options.positions=k,this.scatter.options.sizes=new Array(L),this.scatter.options.glyphs=new Array(L),this.scatter.options.borderWidths=new Array(L),this.scatter.options.colors=new Array(4*L),this.scatter.options.borderColors=new Array(4*L);var B,U,V,H,q,G,Y,X,W,Z,J=T(t),K=t.marker,Q=K.opacity,$=t.opacity,tt=R(K.symbol,x),et=s(K,Q,$,x),rt=P(K.line.width,x),nt=s(K.line,Q,$,x);for(j=i(J,K.size,x),f=0;f<L;++f)B=w[f],V=tt[B],H=E[V],q=u(V),G=N&&!N[B],Y=H.noBorder&&!q?nt:et,X=q?et:nt,U=j[B],W=rt[B],Z=H.noBorder||H.noFill?.1*U:0,this.scatter.options.sizes[f]=4*U,this.scatter.options.glyphs[f]=H.unicode,this.scatter.options.borderWidths[f]=.5*(W>Z?W-Z:0),!q||H.noBorder||H.noFill?c(this.scatter.options.colors,Y,f,B,G):c(this.scatter.options.colors,I,f,0),c(this.scatter.options.borderColors,X,f,B,G);N?(this.scatter.options.positions=null,this.fancyScatter.update(),this.scatter.options.positions=k):this.fancyScatter.update()}else this.fancyScatter.clear();this.scatter.clear(),this.expandAxesFancy(l,h,j)},D.updateLines=function(t,e){var r;if(this.hasLines){var n=e;if(!t.connectgaps){var i=0,a=this.xData,s=this.yData;for(n=new Float64Array(2*a.length),r=0;r<a.length;++r)n[i++]=a[r],n[i++]=s[r]}this.line.options.positions=n;var l=o(t.line.color,t.opacity,1),u=Math.round(.5*this.line.options.width),c=(L[t.line.dash]||[1]).slice();for(r=0;r<c.length;++r)c[r]*=u;switch(t.fill){case\"tozeroy\":this.line.options.fill=[!1,!0,!1,!1];break;case\"tozerox\":this.line.options.fill=[!0,!1,!1,!1];break;default:this.line.options.fill=[!1,!1,!1,!1]}var h=w(t.fillcolor);this.line.options.color=l,this.line.options.width=2*t.line.width,this.line.options.dashes=c,this.line.options.fillColor=[h,h,h,h],this.line.update()}else this.line.clear()},D.updateError=function(t,e,r,n){var i=this[\"error\"+t],a=e[\"error_\"+t.toLowerCase()];\"x\"===t.toLowerCase()&&a.copy_ystyle&&(a=e.error_y),this[\"hasError\"+t]?(i.options.positions=r,i.options.errors=n,i.options.capSize=a.width,i.options.lineWidth=a.thickness/2,i.options.color=o(a.color,1,1),i.update()):i.clear()},D.expandAxesFast=function(t,e){for(var r,n,i,a=e||10,o=0;o<2;o++)r=this.scene[z[o]],n=r._min,n||(n=[]),n.push({val:t[o],pad:a}),i=r._max,i||(i=[]),i.push({val:t[o+2],pad:a})},D.expandAxesFancy=function(t,e,r){var n=this.scene,i={padded:!0,ppad:r};b.expand(n.xaxis,t,i),b.expand(n.yaxis,e,i)},D.dispose=function(){this.line.dispose(),this.errorX.dispose(),this.errorY.dispose(),this.scatter.dispose(),this.fancyScatter.dispose()},e.exports=f},{\"../../components/errorbars\":633,\"../../constants/gl2d_dashes\":700,\"../../constants/gl2d_markers\":701,\"../../constants/interactions\":704,\"../../lib\":725,\"../../lib/gl_format_color\":722,\"../../lib/str2rgbarray\":744,\"../../lib/typed_array_truncate\":748,\"../../plots/cartesian/axes\":766,\"../../plots/cartesian/axis_autotype\":767,\"../scatter/get_trace_color\":1035,\"../scatter/make_bubble_size_func\":1042,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130,\"gl-error2d\":158,\"gl-line2d\":169,\"gl-scatter2d\":247,\"gl-scatter2d-sdf\":242}],1074:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/xy_defaults\"),s=t(\"../scatter/marker_defaults\"),l=t(\"../scatter/line_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"../../components/errorbars/defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}var p=o(t,e,f,d);if(!p)return void(e.visible=!1);d(\"text\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(d(\"connectgaps\"),l(t,e,r,f,d)),a.hasMarkers(e)&&s(t,e,r,f,d),d(\"fill\"),\"none\"!==e.fill&&u(t,e,r,d),c(t,e,r,{axis:\"y\"}),c(t,e,r,{axis:\"x\",inherit:\"y\"})}},{\"../../components/errorbars/defaults\":632,\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/xy_defaults\":1049,\"./attributes\":1071}],1075:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.hoverPoints=t(\"../scatter/hover\"),n.calc=t(\"./calc\"),n.plot=t(\"./convert\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattergl\",n.basePlotModule=t(\"../../plots/gl2d\"),n.categories=[\"gl2d\",\"symbols\",\"errorBarsOK\",\"markerColorscale\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/gl2d\":806,\"../scatter/colorbar\":1030,\"../scatter/hover\":1036,\"./attributes\":1071,\"./calc\":1072,\"./convert\":1073,\"./defaults\":1074,\"./select\":1076}],1076:[function(t,e,r){\"use strict\";var n=t(\"../scatter/subtypes\");e.exports=function(t,e){var r,i,a,o,s=t.cd,l=t.xaxis,u=t.yaxis,c=[],h=s[0].trace,f=s[0]._glTrace,d=f.scene,p=!n.hasMarkers(h)&&!n.hasText(h);if(!0===h.visible&&!p){if(!1===e)for(r=0;r<s.length;r++)s[r].dim=0;else for(r=0;r<s.length;r++)i=s[r],a=l.c2p(i.x),o=u.c2p(i.y),e.contains([a,o])?(c.push({pointNumber:r,x:i.x,y:i.y}),i.dim=0):i.dim=1;return h.selection=c,f.update(h,s),d.glplot.setDirty(),c}}},{\"../scatter/subtypes\":1047}],1077:[function(t,e,r){\"use strict\";var n=t(\"../scattergeo/attributes\"),i=t(\"../scatter/attributes\"),a=t(\"../../plots/mapbox/layout_attributes\"),o=t(\"../../plots/attributes\"),s=t(\"../../components/colorbar/attributes\"),l=t(\"../../lib/extend\").extendFlat,u=n.line,c=n.marker;e.exports={lon:n.lon,lat:n.lat,mode:l({},i.mode,{dflt:\"markers\"}),text:l({},i.text,{}),hovertext:l({},i.hovertext,{}),line:{color:u.color,width:u.width},connectgaps:i.connectgaps,marker:{symbol:{valType:\"string\",dflt:\"circle\",arrayOk:!0},opacity:c.opacity,size:c.size,sizeref:c.sizeref,sizemin:c.sizemin,sizemode:c.sizemode,color:c.color,colorscale:c.colorscale,cauto:c.cauto,cmax:c.cmax,cmin:c.cmin,autocolorscale:c.autocolorscale,reversescale:c.reversescale,showscale:c.showscale,colorbar:s},fill:n.fill,fillcolor:i.fillcolor,textfont:a.layers.symbol.textfont,textposition:a.layers.symbol.textposition,hoverinfo:l({},o.hoverinfo,{flags:[\"lon\",\"lat\",\"text\",\"name\"]})}},{\"../../components/colorbar/attributes\":604,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../../plots/mapbox/layout_attributes\":825,\"../scatter/attributes\":1027,\"../scattergeo/attributes\":1064}],1078:[function(t,e,r){\"use strict\";function n(){return{geojson:v.makeBlank(),layout:{visibility:\"none\"},paint:{}}}function i(t,e){function r(t,e){return a.opacity*e*(t.dim?_:1)}function n(t,r,n,i){void 0===e[r][n]&&(e[r][n]=i),t[r]=e[r][n]}var i,a=t[0].trace,o=a.marker;g.hasColorscale(a,\"marker\")?i=g.makeColorScaleFunc(g.extractScale(o.colorscale,o.cmin,o.cmax)):Array.isArray(o.color)&&(i=p.identity);var s;b.isBubble(a)&&(s=y(a));var l;Array.isArray(o.opacity)?l=function(t){return r(t,d(t.mo)?+p.constrain(t.mo,0,1):0)}:a._hasDimmedPts&&(l=function(t){return r(t,o.opacity)});for(var u=[],c=0;c<t.length;c++){var h=t[c],m=h.lonlat;if(!f(m)){var v={};if(i){var x=h.mcc=i(h.mc);n(v,w,x,c)}s&&n(v,M,s(h.ms),c),l&&n(v,k,l(h),c),u.push({type:\"Feature\",geometry:{type:\"Point\",coordinates:m},properties:v})}}return{type:\"FeatureCollection\",features:u}}function a(t){for(var e=t[0].trace,r=e.marker||{},n=r.symbol,i=e.text,a=\"circle\"!==n?u(n):c,o=b.hasText(e)?u(i):c,s=[],l=0;l<t.length;l++){var h=t[l];f(h.lonlat)||s.push({type:\"Feature\",geometry:{type:\"Point\",coordinates:h.lonlat},properties:{symbol:a(h.mx),text:o(h.tx)}})}return{type:\"FeatureCollection\",features:s}}function o(t,e){var r,n=t.marker;if(Array.isArray(n.color)){for(var i=Object.keys(e[w]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[w][s],s])}r={property:w,stops:a}}else r=n.color;return r}function s(t,e){var r,n=t.marker;if(Array.isArray(n.size)){for(var i=Object.keys(e[M]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[M][s],+s])}r={property:M,stops:a.sort(h)}}else r=n.size/2;return r}function l(t,e){var r,n=t.marker;if(Array.isArray(n.opacity)||t._hasDimmedPts){for(var i=Object.keys(e[k]),a=[],o=0;o<i.length;o++){var s=i[o];a.push([e[k][s],+s])}r={property:k,stops:a.sort(h)}}else r=t.opacity*n.opacity;return r}function u(t){return Array.isArray(t)?function(t){return t}:t?function(){return t}:c}function c(){return\"\"}function h(t,e){return t[0]-e[0]}function f(t){return t[0]===m}var d=t(\"fast-isnumeric\"),p=t(\"../../lib\"),m=t(\"../../constants/numerical\").BADNUM,v=t(\"../../lib/geojson_utils\"),g=t(\"../../components/colorscale\"),y=t(\"../scatter/make_bubble_size_func\"),b=t(\"../scatter/subtypes\"),x=t(\"../../plots/mapbox/convert_text_opts\"),_=t(\"../../constants/interactions\").DESELECTDIM,w=\"circle-color\",M=\"circle-radius\",k=\"circle-opacity\";e.exports=function(t){var e=t[0].trace,r=!0===e.visible,u=\"none\"!==e.fill,c=b.hasLines(e),h=b.hasMarkers(e),f=b.hasText(e),d=h&&\"circle\"===e.marker.symbol,m=h&&\"circle\"!==e.marker.symbol,g=n(),y=n(),_=n(),A=n(),T={fill:g,line:y,circle:_,symbol:A};if(!r)return T;var S;if((u||c)&&(S=v.calcTraceToLineCoords(t)),u&&(g.geojson=v.makePolygon(S),g.layout.visibility=\"visible\",p.extendFlat(g.paint,{\"fill-color\":e.fillcolor})),c&&(y.geojson=v.makeLine(S),y.layout.visibility=\"visible\",p.extendFlat(y.paint,{\"line-width\":e.line.width,\"line-color\":e.line.color,\"line-opacity\":e.opacity})),d){var E={};E[w]={},E[M]={},E[k]={},_.geojson=i(t,E),_.layout.visibility=\"visible\",p.extendFlat(_.paint,{\"circle-opacity\":l(e,E),\"circle-color\":o(e,E),\"circle-radius\":s(e,E)})}if((m||f)&&(A.geojson=a(t),p.extendFlat(A.layout,{visibility:\"visible\",\"icon-image\":\"{symbol}-15\",\"text-field\":\"{text}\"}),m&&(p.extendFlat(A.layout,{\"icon-size\":e.marker.size/10}),p.extendFlat(A.paint,{\"icon-opacity\":e.opacity*e.marker.opacity,\"icon-color\":e.marker.color})),f)){var L=(e.marker||{}).size,C=x(e.textposition,L);p.extendFlat(A.layout,{\"text-size\":e.textfont.size,\"text-anchor\":C.anchor,\"text-offset\":C.offset}),p.extendFlat(A.paint,{\"text-color\":e.textfont.color,\"text-opacity\":e.opacity})}return T}},{\"../../components/colorscale\":617,\"../../constants/interactions\":704,\"../../constants/numerical\":705,\"../../lib\":725,\"../../lib/geojson_utils\":720,\"../../plots/mapbox/convert_text_opts\":822,\"../scatter/make_bubble_size_func\":1042,\n",
       "\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1079:[function(t,e,r){\"use strict\";function n(t,e,r){var n=r(\"lon\")||[],i=r(\"lat\")||[],a=Math.min(n.length,i.length);return a<n.length&&(e.lon=n.slice(0,a)),a<i.length&&(e.lat=i.slice(0,a)),a}var i=t(\"../../lib\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/text_defaults\"),u=t(\"../scatter/fillcolor_defaults\"),c=t(\"./attributes\");e.exports=function(t,e,r,h){function f(r,n){return i.coerce(t,e,c,r,n)}if(!n(t,e,f))return void(e.visible=!1);if(f(\"text\"),f(\"hovertext\"),f(\"mode\"),a.hasLines(e)&&(s(t,e,r,h,f,{noDash:!0}),f(\"connectgaps\")),a.hasMarkers(e)){o(t,e,r,h,f,{noLine:!0});var d=e.marker;d.line={width:0},\"circle\"!==d.symbol&&(Array.isArray(d.size)&&(d.size=d.size[0]),Array.isArray(d.color)&&(d.color=d.color[0]))}a.hasText(e)&&l(t,e,h,f),f(\"fill\"),\"none\"!==e.fill&&u(t,e,r,f)}},{\"../../lib\":725,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1077}],1080:[function(t,e,r){\"use strict\";e.exports=function(t,e){return t.lon=e.lon,t.lat=e.lat,t}},{}],1081:[function(t,e,r){\"use strict\";function n(t,e){function r(t){return t+\"\\xb0\"}var n=t.hoverinfo.split(\"+\"),i=-1!==n.indexOf(\"all\"),a=-1!==n.indexOf(\"lon\"),o=-1!==n.indexOf(\"lat\"),s=e.lonlat,l=[];if(i||a&&o?l.push(\"(\"+r(s[0])+\", \"+r(s[1])+\")\"):a?l.push(\"lon: \"+r(s[0])):o&&l.push(\"lat: \"+r(s[1])),i||-1!==n.indexOf(\"text\")){var u;e.htx?u=e.htx:t.hovertext?u=t.hovertext:e.tx?u=e.tx:t.text&&(u=t.text),Array.isArray(u)||l.push(u)}return l.join(\"<br>\")}var i=t(\"../../components/fx\"),a=t(\"../scatter/get_trace_color\"),o=t(\"../../constants/numerical\").BADNUM;e.exports=function(t,e,r){function s(t){var e=t.lonlat;if(e[0]===o)return 1/0;var n=Math.abs(c.c2p(e)-c.c2p([p,e[1]])),i=Math.abs(h.c2p(e)-h.c2p([e[0],r])),a=Math.max(3,t.mrc||0);return Math.max(Math.sqrt(n*n+i*i)-a,1-3/a)}var l=t.cd,u=l[0].trace,c=t.xa,h=t.ya,f=e>=0?Math.floor((e+180)/360):Math.ceil((e-180)/360),d=360*f,p=e-d;if(i.getClosest(l,s,t),!1!==t.index){var m=l[t.index],v=m.lonlat,g=[v[0]+d,v[1]],y=c.c2p(g),b=h.c2p(g),x=m.mrc||1;return t.x0=y-x,t.x1=y+x,t.y0=b-x,t.y1=b+x,t.color=a(u,m),t.extraText=n(u,m),[t]}}},{\"../../components/fx\":644,\"../../constants/numerical\":705,\"../scatter/get_trace_color\":1035}],1082:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"../scattergeo/calc\"),n.plot=t(\"./plot\"),n.hoverPoints=t(\"./hover\"),n.eventData=t(\"./event_data\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scattermapbox\",n.basePlotModule=t(\"../../plots/mapbox\"),n.categories=[\"mapbox\",\"gl\",\"symbols\",\"markerColorscale\",\"showLegend\",\"scatterlike\"],n.meta={},e.exports=n},{\"../../plots/mapbox\":823,\"../scatter/colorbar\":1030,\"../scattergeo/calc\":1065,\"./attributes\":1077,\"./defaults\":1079,\"./event_data\":1080,\"./hover\":1081,\"./plot\":1083,\"./select\":1084}],1083:[function(t,e,r){\"use strict\";function n(t,e){this.mapbox=t,this.map=t.map,this.uid=e,this.idSourceFill=e+\"-source-fill\",this.idSourceLine=e+\"-source-line\",this.idSourceCircle=e+\"-source-circle\",this.idSourceSymbol=e+\"-source-symbol\",this.idLayerFill=e+\"-layer-fill\",this.idLayerLine=e+\"-layer-line\",this.idLayerCircle=e+\"-layer-circle\",this.idLayerSymbol=e+\"-layer-symbol\",this.mapbox.initSource(this.idSourceFill),this.mapbox.initSource(this.idSourceLine),this.mapbox.initSource(this.idSourceCircle),this.mapbox.initSource(this.idSourceSymbol),this.map.addLayer({id:this.idLayerFill,source:this.idSourceFill,type:\"fill\"}),this.map.addLayer({id:this.idLayerLine,source:this.idSourceLine,type:\"line\"}),this.map.addLayer({id:this.idLayerCircle,source:this.idSourceCircle,type:\"circle\"}),this.map.addLayer({id:this.idLayerSymbol,source:this.idSourceSymbol,type:\"symbol\"})}function i(t){return\"visible\"===t.layout.visibility}var a=t(\"./convert\"),o=n.prototype;o.update=function(t){var e=this.mapbox,r=a(t);e.setOptions(this.idLayerFill,\"setLayoutProperty\",r.fill.layout),e.setOptions(this.idLayerLine,\"setLayoutProperty\",r.line.layout),e.setOptions(this.idLayerCircle,\"setLayoutProperty\",r.circle.layout),e.setOptions(this.idLayerSymbol,\"setLayoutProperty\",r.symbol.layout),i(r.fill)&&(e.setSourceData(this.idSourceFill,r.fill.geojson),e.setOptions(this.idLayerFill,\"setPaintProperty\",r.fill.paint)),i(r.line)&&(e.setSourceData(this.idSourceLine,r.line.geojson),e.setOptions(this.idLayerLine,\"setPaintProperty\",r.line.paint)),i(r.circle)&&(e.setSourceData(this.idSourceCircle,r.circle.geojson),e.setOptions(this.idLayerCircle,\"setPaintProperty\",r.circle.paint)),i(r.symbol)&&(e.setSourceData(this.idSourceSymbol,r.symbol.geojson),e.setOptions(this.idLayerSymbol,\"setPaintProperty\",r.symbol.paint)),t[0].trace._glTrace=this},o.dispose=function(){var t=this.map;t.removeLayer(this.idLayerFill),t.removeLayer(this.idLayerLine),t.removeLayer(this.idLayerCircle),t.removeLayer(this.idLayerSymbol),t.removeSource(this.idSourceFill),t.removeSource(this.idSourceLine),t.removeSource(this.idSourceCircle),t.removeSource(this.idSourceSymbol)},e.exports=function(t,e){var r=e[0].trace,i=new n(t,r.uid);return i.update(e),i}},{\"./convert\":1078}],1084:[function(t,e,r){\"use strict\";var n=t(\"../scatter/subtypes\");e.exports=function(t,e){var r,i,a,o,s,l=t.cd,u=t.xaxis,c=t.yaxis,h=[],f=l[0].trace;if(f._hasDimmedPts=!1,!0===f.visible&&n.hasMarkers(f)){if(!1===e)for(s=0;s<l.length;s++)l[s].dim=0;else for(s=0;s<l.length;s++)r=l[s],i=r.lonlat,a=u.c2p(i),o=c.c2p(i),e.contains([a,o])?(f._hasDimmedPts=!0,h.push({pointNumber:s,lon:i[0],lat:i[1]}),r.dim=0):r.dim=1;return f._glTrace.update(l),h}}},{\"../scatter/subtypes\":1047}],1085:[function(t,e,r){\"use strict\";var n=t(\"../scatter/attributes\"),i=t(\"../../plots/attributes\"),a=t(\"../../components/colorscale/color_attributes\"),o=t(\"../../components/colorbar/attributes\"),s=t(\"../../components/drawing/attributes\").dash,l=t(\"../../lib/extend\").extendFlat,u=n.marker,c=n.line,h=u.line;e.exports={a:{valType:\"data_array\"},b:{valType:\"data_array\"},c:{valType:\"data_array\"},sum:{valType:\"number\",dflt:0,min:0},mode:l({},n.mode,{dflt:\"markers\"}),text:l({},n.text,{}),hovertext:l({},n.hovertext,{}),line:{color:c.color,width:c.width,dash:s,shape:l({},c.shape,{values:[\"linear\",\"spline\"]}),smoothing:c.smoothing},connectgaps:n.connectgaps,cliponaxis:n.cliponaxis,fill:l({},n.fill,{values:[\"none\",\"toself\",\"tonext\"]}),fillcolor:n.fillcolor,marker:l({},{symbol:u.symbol,opacity:u.opacity,maxdisplayed:u.maxdisplayed,size:u.size,sizeref:u.sizeref,sizemin:u.sizemin,sizemode:u.sizemode,line:l({},{width:h.width},a(\"marker\".line)),gradient:u.gradient},a(\"marker\"),{showscale:u.showscale,colorbar:o}),textfont:n.textfont,textposition:n.textposition,hoverinfo:l({},i.hoverinfo,{flags:[\"a\",\"b\",\"c\",\"text\",\"name\"]}),hoveron:n.hoveron}},{\"../../components/colorbar/attributes\":604,\"../../components/colorscale/color_attributes\":610,\"../../components/drawing/attributes\":626,\"../../lib/extend\":716,\"../../plots/attributes\":764,\"../scatter/attributes\":1027}],1086:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../plots/cartesian/axes\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/colorscale_calc\"),s=t(\"../scatter/arrays_to_calcdata\"),l=[\"a\",\"b\",\"c\"],u={a:[\"b\",\"c\"],b:[\"a\",\"c\"],c:[\"a\",\"b\"]};e.exports=function(t,e){var r,c,h,f,d,p,m=t._fullLayout[e.subplot],v=m.sum,g=e.sum||v;for(r=0;r<l.length;r++)if(h=l[r],!e[h]){for(d=e[u[h][0]],p=e[u[h][1]],f=new Array(d.length),c=0;c<d.length;c++)f[c]=g-d[c]-p[c];e[h]=f}var y,b,x,_,w,M,k=e.a.length,A=new Array(k);for(r=0;r<k;r++)y=e.a[r],b=e.b[r],x=e.c[r],n(y)&&n(b)&&n(x)?(y=+y,b=+b,x=+x,_=v/(y+b+x),1!==_&&(y*=_,b*=_,x*=_),M=y,w=x-b,A[r]={x:w,y:M,a:y,b:b,c:x}):A[r]={x:!1,y:!1};var T,S;if(a.hasMarkers(e)&&(T=e.marker,S=T.size,Array.isArray(S))){var E={type:\"linear\"};i.setConvert(E),S=E.makeCalcdata(e.marker,\"size\"),S.length>k&&S.splice(k,S.length-k)}return o(e),s(A,e),A}},{\"../../plots/cartesian/axes\":766,\"../scatter/arrays_to_calcdata\":1026,\"../scatter/colorscale_calc\":1031,\"../scatter/subtypes\":1047,\"fast-isnumeric\":130}],1087:[function(t,e,r){\"use strict\";var n=t(\"../../lib\"),i=t(\"../scatter/constants\"),a=t(\"../scatter/subtypes\"),o=t(\"../scatter/marker_defaults\"),s=t(\"../scatter/line_defaults\"),l=t(\"../scatter/line_shape_defaults\"),u=t(\"../scatter/text_defaults\"),c=t(\"../scatter/fillcolor_defaults\"),h=t(\"./attributes\");e.exports=function(t,e,r,f){function d(r,i){return n.coerce(t,e,h,r,i)}var p,m=d(\"a\"),v=d(\"b\"),g=d(\"c\");if(m?(p=m.length,v?(p=Math.min(p,v.length),g&&(p=Math.min(p,g.length))):p=g?Math.min(p,g.length):0):v&&g&&(p=Math.min(v.length,g.length)),!p)return void(e.visible=!1);m&&p<m.length&&(e.a=m.slice(0,p)),v&&p<v.length&&(e.b=v.slice(0,p)),g&&p<g.length&&(e.c=g.slice(0,p)),d(\"sum\"),d(\"text\"),d(\"hovertext\"),d(\"mode\",p<i.PTS_LINESONLY?\"lines+markers\":\"lines\"),a.hasLines(e)&&(s(t,e,r,f,d),l(t,e,d),d(\"connectgaps\")),a.hasMarkers(e)&&o(t,e,r,f,d,{gradient:!0}),a.hasText(e)&&u(t,e,f,d);var y=[];(a.hasMarkers(e)||a.hasText(e))&&(d(\"marker.maxdisplayed\"),y.push(\"points\")),d(\"fill\"),\"none\"!==e.fill&&(c(t,e,r,d),a.hasLines(e)||l(t,e,d)),\"tonext\"!==e.fill&&\"toself\"!==e.fill||y.push(\"fills\"),d(\"hoveron\",y.join(\"+\")||\"points\"),d(\"cliponaxis\")}},{\"../../lib\":725,\"../scatter/constants\":1032,\"../scatter/fillcolor_defaults\":1034,\"../scatter/line_defaults\":1038,\"../scatter/line_shape_defaults\":1040,\"../scatter/marker_defaults\":1043,\"../scatter/subtypes\":1047,\"../scatter/text_defaults\":1048,\"./attributes\":1085}],1088:[function(t,e,r){\"use strict\";var n=t(\"../scatter/hover\"),i=t(\"../../plots/cartesian/axes\");e.exports=function(t,e,r,a){function o(t,e){g.push(t._hovertitle+\": \"+i.tickText(t,e,\"hover\").text)}var s=n(t,e,r,a);if(s&&!1!==s[0].index){var l=s[0];if(void 0===l.index){var u=1-l.y0/t.ya._length,c=t.xa._length,h=c*u/2,f=c-h;return l.x0=Math.max(Math.min(l.x0,f),h),l.x1=Math.max(Math.min(l.x1,f),h),s}var d=l.cd[l.index];l.a=d.a,l.b=d.b,l.c=d.c,l.xLabelVal=void 0,l.yLabelVal=void 0;var p=l.trace,m=p._ternary,v=p.hoverinfo.split(\"+\"),g=[];return-1!==v.indexOf(\"all\")&&(v=[\"a\",\"b\",\"c\"]),-1!==v.indexOf(\"a\")&&o(m.aaxis,d.a),-1!==v.indexOf(\"b\")&&o(m.baxis,d.b),-1!==v.indexOf(\"c\")&&o(m.caxis,d.c),l.extraText=g.join(\"<br>\"),s}}},{\"../../plots/cartesian/axes\":766,\"../scatter/hover\":1036}],1089:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"../scatter/colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./plot\"),n.style=t(\"./style\"),n.hoverPoints=t(\"./hover\"),n.selectPoints=t(\"./select\"),n.moduleType=\"trace\",n.name=\"scatterternary\",n.basePlotModule=t(\"../../plots/ternary\"),n.categories=[\"ternary\",\"symbols\",\"markerColorscale\",\"showLegend\",\"scatter-like\"],n.meta={},e.exports=n},{\"../../plots/ternary\":837,\"../scatter/colorbar\":1030,\"./attributes\":1085,\"./calc\":1086,\"./defaults\":1087,\"./hover\":1088,\"./plot\":1090,\"./select\":1091,\"./style\":1092}],1090:[function(t,e,r){\"use strict\";var n=t(\"../scatter/plot\");e.exports=function(t,e){var r=t.plotContainer;r.select(\".scatterlayer\").selectAll(\"*\").remove();for(var i={xaxis:t.xaxis,yaxis:t.yaxis,plot:r,layerClipId:t._hasClipOnAxisFalse?t.clipIdRelative:null},a=0;a<e.length;a++)e[a][0].trace._ternary=t;n(t.graphDiv,i,e)}},{\"../scatter/plot\":1044}],1091:[function(t,e,r){arguments[4][1062][0].apply(r,arguments)},{\"../scatter/select\":1045,dup:1062}],1092:[function(t,e,r){arguments[4][1063][0].apply(r,arguments)},{\"../scatter/style\":1046,dup:1063}],1093:[function(t,e,r){\"use strict\";function n(t){return{valType:\"boolean\",dflt:!1}}function i(t){return{show:{valType:\"boolean\",dflt:!1},project:{x:n(\"x\"),y:n(\"y\"),z:n(\"z\")},color:{valType:\"color\",dflt:a.defaultLine},usecolormap:{valType:\"boolean\",dflt:!1},width:{valType:\"number\",min:1,max:16,dflt:2},highlight:{valType:\"boolean\",dflt:!0},highlightcolor:{valType:\"color\",dflt:a.defaultLine},highlightwidth:{valType:\"number\",min:1,max:16,dflt:2}}}var a=t(\"../../components/color\"),o=t(\"../../components/colorscale/attributes\"),s=t(\"../../components/colorbar/attributes\"),l=t(\"../../lib/extend\").extendFlat;e.exports={z:{valType:\"data_array\"},x:{valType:\"data_array\"},y:{valType:\"data_array\"},text:{valType:\"data_array\"},surfacecolor:{valType:\"data_array\"},cauto:o.zauto,cmin:o.zmin,cmax:o.zmax,colorscale:o.colorscale,autocolorscale:l({},o.autocolorscale,{dflt:!1}),reversescale:o.reversescale,showscale:o.showscale,colorbar:s,contours:{x:i(\"x\"),y:i(\"y\"),z:i(\"z\")},hidesurface:{valType:\"boolean\",dflt:!1},lightposition:{x:{valType:\"number\",min:-1e5,max:1e5,dflt:10},y:{valType:\"number\",min:-1e5,max:1e5,dflt:1e4},z:{valType:\"number\",min:-1e5,max:1e5,dflt:0}},lighting:{ambient:{valType:\"number\",min:0,max:1,dflt:.8},diffuse:{valType:\"number\",min:0,max:1,dflt:.8},specular:{valType:\"number\",min:0,max:2,dflt:.05},roughness:{valType:\"number\",min:0,max:1,dflt:.5},fresnel:{valType:\"number\",min:0,max:5,dflt:.2}},opacity:{valType:\"number\",min:0,max:1,dflt:1},_deprecated:{zauto:l({},o.zauto,{}),zmin:l({},o.zmin,{}),zmax:l({},o.zmax,{})}}},{\"../../components/color\":603,\"../../components/colorbar/attributes\":604,\"../../components/colorscale/attributes\":608,\"../../lib/extend\":716}],1094:[function(t,e,r){\"use strict\";var n=t(\"../../components/colorscale/calc\");e.exports=function(t,e){e.surfacecolor?n(e,e.surfacecolor,\"\",\"c\"):n(e,e.z,\"\",\"c\")}},{\"../../components/colorscale/calc\":609}],1095:[function(t,e,r){\"use strict\";var n=t(\"fast-isnumeric\"),i=t(\"../../lib\"),a=t(\"../../plots/plots\"),o=t(\"../../components/colorscale\"),s=t(\"../../components/colorbar/draw\");e.exports=function(t,e){var r=e[0].trace,l=\"cb\"+r.uid,u=r.cmin,c=r.cmax,h=r.surfacecolor||r.z;if(n(u)||(u=i.aggNums(Math.min,null,h)),n(c)||(c=i.aggNums(Math.max,null,h)),t._fullLayout._infolayer.selectAll(\".\"+l).remove(),!r.showscale)return void a.autoMargin(t,l);var f=e[0].t.cb=s(t,l),d=o.makeColorScaleFunc(o.extractScale(r.colorscale,u,c),{noNumericCheck:!0});f.fillcolor(d).filllevels({start:u,end:c,size:(c-u)/254}).options(r.colorbar)()}},{\"../../components/colorbar/draw\":606,\"../../components/colorscale\":617,\"../../lib\":725,\"../../plots/plots\":829,\"fast-isnumeric\":130}],1096:[function(t,e,r){\"use strict\";function n(t,e,r){this.scene=t,this.uid=r,this.surface=e,this.data=null,this.showContour=[!1,!1,!1],this.dataScale=1}function i(t,e){return void 0===e&&(e=1),t.map(function(t){var r=t[0],n=p(t[1]),i=n.toRgb();return{index:r,rgb:[i.r,i.g,i.b,e]}})}function a(t){var e=t[0].rgb,r=t[t.length-1].rgb;return e[0]===r[0]&&e[1]===r[1]&&e[2]===r[2]&&e[3]===r[3]}function o(t){var e=t.shape,r=[e[0]+2,e[1]+2],n=c(new Float32Array(r[0]*r[1]),r);return d.assign(n.lo(1,1).hi(e[0],e[1]),t),d.assign(n.lo(1).hi(e[0],1),t.hi(e[0],1)),d.assign(n.lo(1,r[1]-1).hi(e[0],1),t.lo(0,e[1]-1).hi(e[0],1)),d.assign(n.lo(0,1).hi(1,e[1]),t.hi(1)),d.assign(n.lo(r[0]-1,1).hi(1,e[1]),t.lo(e[0]-1)),n.set(0,0,t.get(0,0)),n.set(0,r[1]-1,t.get(0,e[1]-1)),n.set(r[0]-1,0,t.get(e[0]-1,0)),n.set(r[0]-1,r[1]-1,t.get(e[0]-1,e[1]-1)),n}function s(t){var e=Math.max(t[0].shape[0],t[0].shape[1]);if(e<v){for(var r=v/e,n=[0|Math.floor(t[0].shape[0]*r+1),0|Math.floor(t[0].shape[1]*r+1)],i=n[0]*n[1],a=0;a<t.length;++a){var s=o(t[a]),l=c(new Float32Array(i),n);h(l,s,[r,0,0,0,r,0,0,0,1]),t[a]=l}return r}return 1}function l(t,e){var r=t.glplot.gl,i=u({gl:r}),a=new n(t,i,e.uid);return i._trace=a,a.update(e),t.glplot.add(i),a}var u=t(\"gl-surface3d\"),c=t(\"ndarray\"),h=t(\"ndarray-homography\"),f=t(\"ndarray-fill\"),d=t(\"ndarray-ops\"),p=t(\"tinycolor2\"),m=t(\"../../lib/str2rgbarray\"),v=128,g=n.prototype;g.handlePick=function(t){if(t.object===this.surface){var e=t.index=[Math.min(0|Math.round(t.data.index[0]/this.dataScale-1),this.data.z[0].length-1),Math.min(0|Math.round(t.data.index[1]/this.dataScale-1),this.data.z.length-1)],r=[0,0,0];Array.isArray(this.data.x[0])?r[0]=this.data.x[e[1]][e[0]]:r[0]=this.data.x[e[0]],Array.isArray(this.data.y[0])?r[1]=this.data.y[e[1]][e[0]]:r[1]=this.data.y[e[1]],r[2]=this.data.z[e[1]][e[0]],t.traceCoordinate=r;var n=this.scene.fullSceneLayout;t.dataCoordinate=[n.xaxis.d2l(r[0],0,this.data.xcalendar)*this.scene.dataScale[0],n.yaxis.d2l(r[1],0,this.data.ycalendar)*this.scene.dataScale[1],n.zaxis.d2l(r[2],0,this.data.zcalendar)*this.scene.dataScale[2]];var i=this.data.text;return i&&i[e[1]]&&void 0!==i[e[1]][e[0]]?t.textLabel=i[e[1]][e[0]]:t.textLabel=\"\",t.data.dataCoordinate=t.dataCoordinate.slice(),this.surface.highlight(t.data),this.scene.glplot.spikes.position=t.dataCoordinate,!0}},g.setContourLevels=function(){for(var t=[[],[],[]],e=!1,r=0;r<3;++r)this.showContour[r]&&(e=!0,t[r]=this.scene.contourLevels[r]);e&&this.surface.update({levels:t})},g.update=function(t){var e,r=this.scene,n=r.fullSceneLayout,o=this.surface,l=t.opacity,u=i(t.colorscale,l),h=t.z,d=t.x,p=t.y,v=n.xaxis,g=n.yaxis,y=n.zaxis,b=r.dataScale,x=h[0].length,_=h.length,w=[c(new Float32Array(x*_),[x,_]),c(new Float32Array(x*_),[x,_]),c(new Float32Array(x*_),[x,_])],M=w[0],k=w[1],A=r.contourLevels;this.data=t;var T=t.xcalendar,S=t.ycalendar,E=t.zcalendar;f(w[2],function(t,e){return y.d2l(h[e][t],0,E)*b[2]}),Array.isArray(d[0])?f(M,function(t,e){return v.d2l(d[e][t],0,T)*b[0]}):f(M,function(t){return v.d2l(d[t],0,T)*b[0]}),Array.isArray(p[0])?f(k,function(t,e){return g.d2l(p[e][t],0,S)*b[1]}):f(k,function(t,e){return g.d2l(p[e],0,S)*b[1]});var L={colormap:u,levels:[[],[],[]],showContour:[!0,!0,!0],showSurface:!t.hidesurface,contourProject:[[!1,!1,!1],[!1,!1,!1],[!1,!1,!1]],contourWidth:[1,1,1],contourColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],contourTint:[1,1,1],dynamicColor:[[1,1,1,1],[1,1,1,1],[1,1,1,1]],dynamicWidth:[1,1,1],dynamicTint:[1,1,1],opacity:t.opacity};if(L.intensityBounds=[t.cmin,t.cmax],t.surfacecolor){var C=c(new Float32Array(x*_),[x,_]);f(C,function(e,r){return t.surfacecolor[r][e]}),w.push(C)}else L.intensityBounds[0]*=b[2],L.intensityBounds[1]*=b[2];this.dataScale=s(w),t.surfacecolor&&(L.intensity=w.pop());var z=[!0,!0,!0],I=[\"x\",\"y\",\"z\"];for(e=0;e<3;++e){var D=t.contours[I[e]];z[e]=D.highlight,L.showContour[e]=D.show||D.highlight,L.showContour[e]&&(L.contourProject[e]=[D.project.x,D.project.y,D.project.z],D.show?(this.showContour[e]=!0,L.levels[e]=A[e],o.highlightColor[e]=L.contourColor[e]=m(D.color),D.usecolormap?o.highlightTint[e]=L.contourTint[e]=0:o.highlightTint[e]=L.contourTint[e]=1,L.contourWidth[e]=D.width):this.showContour[e]=!1,D.highlight&&(L.dynamicColor[e]=m(D.highlightcolor),L.dynamicWidth[e]=D.highlightwidth))}a(u)&&(L.vertexColor=!0),L.coords=w,o.update(L),o.visible=t.visible,o.enableDynamic=z,o.snapToData=!0,\"lighting\"in t&&(o.ambientLight=t.lighting.ambient,o.diffuseLight=t.lighting.diffuse,o.specularLight=t.lighting.specular,o.roughness=t.lighting.roughness,o.fresnel=t.lighting.fresnel),\"lightposition\"in t&&(o.lightPosition=[t.lightposition.x,t.lightposition.y,t.lightposition.z]),l&&l<1&&(o.supportsTransparency=!0)},g.dispose=function(){this.scene.glplot.remove(this.surface),this.surface.dispose()},e.exports=l},{\"../../lib/str2rgbarray\":744,\"gl-surface3d\":265,ndarray:466,\"ndarray-fill\":456,\"ndarray-homography\":458,\"ndarray-ops\":460,tinycolor2:533}],1097:[function(t,e,r){\"use strict\";function n(t,e,r){e in t&&!(r in t)&&(t[r]=t[e])}var i=t(\"../../registry\"),a=t(\"../../lib\"),o=t(\"../../components/colorscale/defaults\"),s=t(\"./attributes\");e.exports=function(t,e,r,l){function u(r,n){return a.coerce(t,e,s,r,n)}var c,h,f=u(\"z\");if(!f)return void(e.visible=!1);var d=f[0].length,p=f.length;if(u(\"x\"),u(\"y\"),i.getComponentMethod(\"calendars\",\"handleTraceDefaults\")(t,e,[\"x\",\"y\",\"z\"],l),!Array.isArray(e.x))for(e.x=[],c=0;c<d;++c)e.x[c]=c;if(u(\"text\"),!Array.isArray(e.y))for(e.y=[],c=0;c<p;++c)e.y[c]=c;[\"lighting.ambient\",\"lighting.diffuse\",\"lighting.specular\",\"lighting.roughness\",\"lighting.fresnel\",\"lightposition.x\",\"lightposition.y\",\"lightposition.z\",\"hidesurface\",\"opacity\"].forEach(function(t){u(t)});var m=u(\"surfacecolor\");u(\"colorscale\");var v=[\"x\",\"y\",\"z\"];for(c=0;c<3;++c){var g=\"contours.\"+v[c],y=u(g+\".show\"),b=u(g+\".highlight\");if(y||b)for(h=0;h<3;++h)u(g+\".project.\"+v[h]);y&&(u(g+\".color\"),u(g+\".width\"),u(g+\".usecolormap\")),b&&(u(g+\".highlightcolor\"),u(g+\".highlightwidth\"))}m||(n(t,\"zmin\",\"cmin\"),n(t,\"zmax\",\"cmax\"),n(t,\"zauto\",\"cauto\")),o(t,e,l,u,{prefix:\"\",cLetter:\"c\"})}},{\"../../components/colorscale/defaults\":612,\"../../lib\":725,\"../../registry\":844,\"./attributes\":1093}],1098:[function(t,e,r){\"use strict\";var n={};n.attributes=t(\"./attributes\"),n.supplyDefaults=t(\"./defaults\"),n.colorbar=t(\"./colorbar\"),n.calc=t(\"./calc\"),n.plot=t(\"./convert\"),n.moduleType=\"trace\",n.name=\"surface\",n.basePlotModule=t(\"../../plots/gl3d\"),n.categories=[\"gl3d\",\"2dMap\",\"noOpacity\"],n.meta={},e.exports=n},{\"../../plots/gl3d\":809,\"./attributes\":1093,\"./calc\":1094,\"./colorbar\":1095,\"./convert\":1096,\"./defaults\":1097}],1099:[function(t,e,r){\"use strict\";function n(t,e,r,n){if(n.enabled){for(var a=n.target,o=u.nestedProperty(e,a),s=o.get(),c=l.getDataConversions(t,e,a,s),h=i(n,c),f=new Array(r.length),d=0;d<r.length;d++)f[d]=h(s,r[d]);o.set(f)}}function i(t,e){var r=t.func,n=e.d2c,i=e.c2d;switch(r){case\"count\":return a;case\"first\":return o;case\"last\":return s;case\"sum\":return function(t,e){for(var r=0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r+=o)}return i(r)};case\"avg\":return function(t,e){for(var r=0,a=0,o=0;o<e.length;o++){var s=n(t[e[o]]);s!==h&&(r+=s,a++)}return a?i(r/a):h};case\"min\":return function(t,e){for(var r=1/0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r=Math.min(r,o))}return r===1/0?h:i(r)};case\"max\":return function(t,e){for(var r=-1/0,a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&(r=Math.max(r,o))}return r===-1/0?h:i(r)};case\"median\":return function(t,e){for(var r=[],a=0;a<e.length;a++){var o=n(t[e[a]]);o!==h&&r.push(o)}if(!r.length)return h;r.sort();var s=(r.length-1)/2;return i((r[Math.floor(s)]+r[Math.ceil(s)])/2)};case\"mode\":return function(t,e){for(var r={},a=0,o=h,s=0;s<e.length;s++){var l=n(t[e[s]]);if(l!==h){var u=r[l]=(r[l]||0)+1;u>a&&(a=u,o=l)}}return a?i(o):h};case\"rms\":return function(t,e){for(var r=0,a=0,o=0;o<e.length;o++){var s=n(t[e[o]]);s!==h&&(r+=s*s,a++)}return a?i(Math.sqrt(r/a)):h};case\"stddev\":return function(e,r){var i,a=0,o=0,s=1,l=h;for(i=0;i<r.length&&l===h;i++)l=n(e[r[i]]);if(l===h)return h;for(;i<r.length;i++){var u=n(e[r[i]]);if(u!==h){var c=u-l;a+=c,o+=c*c,s++}}var f=\"sample\"===t.funcmode?s-1:s;return f?Math.sqrt((o-a*a/s)/f):0}}}function a(t,e){return e.length}function o(t,e){return t[e[0]]}function s(t,e){return t[e[e.length-1]]}var l=t(\"../plots/cartesian/axes\"),u=t(\"../lib\"),c=t(\"../plot_api/plot_schema\"),h=t(\"../constants/numerical\").BADNUM;r.moduleType=\"transform\",r.name=\"aggregate\";var f=r.attributes={enabled:{valType:\"boolean\",dflt:!0},groups:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},aggregations:{_isLinkedToArray:\"aggregation\",target:{valType:\"string\"},func:{valType:\"enumerated\",values:[\"count\",\"sum\",\"avg\",\"median\",\"mode\",\"rms\",\"stddev\",\"min\",\"max\",\"first\",\"last\"],dflt:\"first\"},funcmode:{valType:\"enumerated\",values:[\"sample\",\"population\"],dflt:\"sample\"},enabled:{valType:\"boolean\",dflt:!0}}},d=f.aggregations;r.supplyDefaults=function(t,e){function r(e,r){return u.coerce(t,a,f,e,r)}function n(t,e){return u.coerce(p[i],h,d,t,e)}var i,a={};if(!r(\"enabled\"))return a;var o=c.findArrayAttributes(e),s={};for(i=0;i<o.length;i++)s[o[i]]=1;var l=r(\"groups\");if(!Array.isArray(l)){if(!s[l])return void(a.enabled=!1);s[l]=0}var h,p=t.aggregations,m=a.aggregations=new Array(p.length);if(p)for(i=0;i<p.length;i++){h={};var v=n(\"target\"),g=n(\"func\"),y=n(\"enabled\");y&&v&&(s[v]||\"count\"===g&&void 0===s[v])?(\"stddev\"===g&&n(\"funcmode\"),s[v]=0,m[i]=h):m[i]={enabled:!1}}for(i=0;i<o.length;i++)s[o[i]]&&m.push({target:o[i],func:d.func.dflt,enabled:!0});return a},r.calcTransform=function(t,e,r){if(r.enabled){var i=r.groups,a=u.getTargetArray(e,{target:i});if(a){var o,s,l,c={},h=[];for(o=0;o<a.length;o++)s=a[o],l=c[s],void 0===l?(c[s]=h.length,h.push([o])):h[l].push(o);var f=r.aggregations;for(o=0;o<f.length;o++)n(t,e,h,f[o]);\"string\"==typeof i&&n(t,e,h,{target:i,func:\"first\",enabled:!0})}}}},{\"../constants/numerical\":705,\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plots/cartesian/axes\":766}],1100:[function(t,e,r){\"use strict\";function n(t,e,r){function n(t){return-1!==t.indexOf(a)}var i,a=t.operation,o=t.value,c=Array.isArray(o),h=function(r){return e(r,0,t.valuecalendar)},f=function(t){return e(t,0,r)};switch(n(s)?i=h(c?o[0]:o):n(l)?i=c?[h(o[0]),h(o[1])]:[h(o),h(o)]:n(u)&&(i=c?o.map(h):[h(o)]),a){case\"=\":return function(t){return f(t)===i};case\"!=\":return function(t){return f(t)!==i};case\"<\":return function(t){return f(t)<i};case\"<=\":return function(t){return f(t)<=i};case\">\":return function(t){return f(t)>i};case\">=\":return function(t){return f(t)>=i};case\"[]\":return function(t){var e=f(t);return e>=i[0]&&e<=i[1]};case\"()\":return function(t){var e=f(t);return e>i[0]&&e<i[1]};case\"[)\":return function(t){var e=f(t);return e>=i[0]&&e<i[1]};case\"(]\":return function(t){var e=f(t);return e>i[0]&&e<=i[1]};case\"][\":return function(t){var e=f(t);return e<=i[0]||e>=i[1]};case\")(\":return function(t){var e=f(t);return e<i[0]||e>i[1]};case\"](\":return function(t){var e=f(t);return e<=i[0]||e>i[1]};case\")[\":return function(t){var e=f(t);return e<i[0]||e>=i[1]};case\"{}\":return function(t){return-1!==i.indexOf(f(t))};case\"}{\":return function(t){return-1===i.indexOf(f(t))}}}var i=t(\"../lib\"),a=t(\"../registry\"),o=t(\"../plots/cartesian/axes\"),s=[\"=\",\"!=\",\"<\",\">=\",\">\",\"<=\"],l=[\"[]\",\"()\",\"[)\",\"(]\",\"][\",\")(\",\"](\",\")[\"],u=[\"{}\",\"}{\"];r.moduleType=\"transform\",r.name=\"filter\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},target:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},operation:{valType:\"enumerated\",values:[].concat(s).concat(l).concat(u),dflt:\"=\"},value:{valType:\"any\",dflt:0},preservegaps:{valType:\"boolean\",dflt:!1}},r.supplyDefaults=function(t){function e(e,a){return i.coerce(t,n,r.attributes,e,a)}var n={};if(e(\"enabled\")){e(\"preservegaps\"),e(\"operation\"),e(\"value\"),e(\"target\");var o=a.getComponentMethod(\"calendars\",\"handleDefaults\");o(t,n,\"valuecalendar\",null),o(t,n,\"targetcalendar\",null)}return n},r.calcTransform=function(t,e,r){function a(t,r){for(var n=0;n<h.length;n++){t(i.nestedProperty(e,h[n]),r)}}if(r.enabled){var s=i.getTargetArray(e,r);if(s){var l=r.target,u=s.length,c=r.targetcalendar,h=e._arrayAttrs;if(\"string\"==typeof l){var f=i.nestedProperty(e,l+\"calendar\").get();f&&(c=f)}var d,p,m=o.getDataToCoordFunc(t,e,l,s),v=n(r,m,c),g={};r.preservegaps?(d=function(t){g[t.astr]=i.extendDeep([],t.get()),t.set(new Array(u))},p=function(t,e){var r=g[t.astr][e];t.get()[e]=r}):(d=function(t){g[t.astr]=i.extendDeep([],t.get()),t.set([])},p=function(t,e){var r=g[t.astr][e];t.get().push(r)}),a(d);for(var y=0;y<u;y++){v(s[y])&&a(p,y)}}}}},{\"../lib\":725,\"../plots/cartesian/axes\":766,\"../registry\":844}],1101:[function(t,e,r){\"use strict\";function n(t,e){var r,n,s,l,u,c,h,f,d,p,m=e.transform,v=t.transforms[e.transformIndex].groups;if(!Array.isArray(v)||0===v.length)return[t];var g=i.filterUnique(v),y=new Array(g.length),b=v.length,x=a.findArrayAttributes(t),_=m.styles||[],w={};for(r=0;r<_.length;r++)w[_[r].target]=_[r].value;m.styles&&(p=i.keyedContainer(m,\"styles\",\"target\",\"value.name\"));var M={};for(r=0;r<g.length;r++){c=g[r],M[c]=r,h=y[r]=i.extendDeepNoArrays({},t),h._group=c;var k=null;for(p&&(k=p.get(c)),h.name=k||i.templateString(m.nameformat,{trace:t.name,group:c}),f=h.transforms,h.transforms=[],n=0;n<f.length;n++)h.transforms[n]=i.extendDeepNoArrays({},f[n]);for(n=0;n<x.length;n++)i.nestedProperty(h,x[n]).set([])}for(s=0;s<x.length;s++){for(l=x[s],n=0,d=[];n<g.length;n++)d[n]=i.nestedProperty(y[n],l).get();for(u=i.nestedProperty(t,l).get(),n=0;n<b;n++)d[M[v[n]]].push(u[n])}for(r=0;r<g.length;r++)c=g[r],h=y[r],o.clearExpandedTraceDefaultColors(h),h=i.extendDeepNoArrays(h,w[c]||{});return y}var i=t(\"../lib\"),a=t(\"../plot_api/plot_schema\"),o=t(\"../plots/plots\");r.moduleType=\"transform\",r.name=\"groupby\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},groups:{valType:\"data_array\",dflt:[]},nameformat:{valType:\"string\"},styles:{_isLinkedToArray:\"style\",target:{valType:\"string\"},value:{valType:\"any\",dflt:{}}}},r.supplyDefaults=function(t,e,n){function a(e,n){return i.coerce(t,s,r.attributes,e,n)}var o,s={};if(!a(\"enabled\"))return s;a(\"groups\"),a(\"nameformat\",n._dataLength>1?\"%{group} (%{trace})\":\"%{group}\");var l=t.styles,u=s.styles=[];if(l)for(o=0;o<l.length;o++)u[o]={},i.coerce(l[o],u[o],r.attributes.styles,\"target\"),i.coerce(l[o],u[o],r.attributes.styles,\"value\");return s},r.transform=function(t,e){var r,i,a,o=[];for(i=0;i<t.length;i++)for(r=n(t[i],e),a=0;a<r.length;a++)o.push(r[a]);return o}},{\"../lib\":725,\"../plot_api/plot_schema\":755,\"../plots/plots\":829}],1102:[function(t,e,r){\"use strict\";function n(t,e,r){for(var n=e.length,a=new Array(n),o=e.slice().sort(i(t,r)),s=0;s<n;s++)for(var l=e[s],u=0;u<n;u++){var c=o[u];if(l===c){a[u]=s,o[u]=null;break}}return a}function i(t,e){switch(t.order){case\"ascending\":return function(t,r){return e(t)-e(r)};case\"descending\":return function(t,r){return e(r)-e(t)}}}var a=t(\"../lib\"),o=t(\"../plots/cartesian/axes\");r.moduleType=\"transform\",r.name=\"sort\",r.attributes={enabled:{valType:\"boolean\",dflt:!0},target:{valType:\"string\",strict:!0,noBlank:!0,arrayOk:!0,dflt:\"x\"},order:{valType:\"enumerated\",values:[\"ascending\",\"descending\"],dflt:\"ascending\"}},r.supplyDefaults=function(t){function e(e,i){return a.coerce(t,n,r.attributes,e,i)}var n={};return e(\"enabled\")&&(e(\"target\"),e(\"order\")),n},r.calcTransform=function(t,e,r){if(r.enabled){var i=a.getTargetArray(e,r);if(i)for(var s=r.target,l=i.length,u=e._arrayAttrs,c=o.getDataToCoordFunc(t,e,s,i),h=n(r,i,c),f=0;f<u.length;f++){for(var d=a.nestedProperty(e,u[f]),p=d.get(),m=new Array(l),v=0;v<l;v++)m[v]=p[h[v]];d.set(m)}}}},{\"../lib\":725,\"../plots/cartesian/axes\":766}]},{},[20])(20)});\n",
       "});require(['plotly'], function(Plotly) {window.Plotly = Plotly;});}</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "<script>var waitForPlotly = setInterval( function() {if( typeof(window.Plotly) !== \"undefined\" ){MathJax.Hub.Config({ SVG: { font: \"STIX-Web\" }, displayAlign: \"center\" });MathJax.Hub.Queue([\"setRenderer\", MathJax.Hub, \"SVG\"]);clearInterval(waitForPlotly);}}, 5000 );</script>"
      ],
      "text/plain": [
       "<IPython.core.display.HTML object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "import plotly.offline as py\n",
    "py.init_notebook_mode(connected=False)\n",
    "\n",
    "from IPython.core.display import display, HTML\n",
    "# The polling here is to ensure that plotly.js has already been loaded before\n",
    "# setting display alignment in order to avoid a race condition.\n",
    "display(HTML(\n",
    "    '<script>'\n",
    "        'var waitForPlotly = setInterval( function() {'\n",
    "            'if( typeof(window.Plotly) !== \"undefined\" ){'\n",
    "                'MathJax.Hub.Config({ SVG: { font: \"STIX-Web\" }, displayAlign: \"center\" });'\n",
    "                'MathJax.Hub.Queue([\"setRenderer\", MathJax.Hub, \"SVG\"]);'\n",
    "                'clearInterval(waitForPlotly);'\n",
    "            '}}, 5000 );'\n",
    "    '</script>'\n",
    "))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "\n",
    "import plotly.graph_objs as go\n",
    "import plotly.figure_factory as ff\n",
    "import cufflinks as cf\n",
    "\n",
    "cf.set_config_file(offline=False, world_readable=True, theme='ggplot')"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# The Tips Dataset\n",
    "\n",
    "A waiter maintained a record of his tips, total bill, and information about the person who paid the bill."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Number of Records: 244\n"
     ]
    },
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style>\n",
       "    .dataframe thead tr:only-child th {\n",
       "        text-align: right;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: left;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>total_bill</th>\n",
       "      <th>tip</th>\n",
       "      <th>sex</th>\n",
       "      <th>smoker</th>\n",
       "      <th>day</th>\n",
       "      <th>time</th>\n",
       "      <th>size</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>16.99</td>\n",
       "      <td>1.01</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>10.34</td>\n",
       "      <td>1.66</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>21.01</td>\n",
       "      <td>3.50</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>23.68</td>\n",
       "      <td>3.31</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>24.59</td>\n",
       "      <td>3.61</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>4</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "   total_bill   tip     sex smoker  day    time  size\n",
       "0       16.99  1.01  Female     No  Sun  Dinner     2\n",
       "1       10.34  1.66    Male     No  Sun  Dinner     3\n",
       "2       21.01  3.50    Male     No  Sun  Dinner     3\n",
       "3       23.68  3.31    Male     No  Sun  Dinner     2\n",
       "4       24.59  3.61  Female     No  Sun  Dinner     4"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "data = sns.load_dataset(\"tips\")\n",
    "print(\"Number of Records:\", len(data))\n",
    "data.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Why did the waiter collect this information? \n",
    "\n",
    "Perhaps the waiter was interested in:\n",
    "\n",
    "1. **Predicting** the tip as a function of the bill, time of day, day of the week, or information about the table.\n",
    "1. **Infering** the relationships between tips and other factors.  For example, does the **percent tip** decrease or increase with bill size?\n",
    "\n",
    "We build models to help answer both of these questions.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# What do we do before we build models?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "# EDA: Tip Distribution\n",
    "\n",
    "Let's take a closer look at the tip data"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXgAAAEOCAYAAACD5gx6AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11b385c50>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "sns.distplot(data['tip'], rug=True)\n",
    "plt.xlabel(\"Tip in Dollars\")\n",
    "plt.savefig(\"tip_in_dollars.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown",
    "solution2_first": true
   },
   "source": [
    "### What do we observe?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown"
   },
   "source": [
    "1. The distribution is skewed right.\n",
    "1. There are a few large tip values (perhaps big bills?) \n",
    "1. There appears to be a mode around $2.00.  Perhaps there is a tradition of tipping 2 dollars for small meals (e.g., coffee?)\n",
    "1. Everyone provided a tip."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/> <br/> <br/>\n",
    "\n",
    "# EDA: Bill Distribution\n",
    "\n",
    "We also plot the total bills."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAX8AAAERCAYAAACTuqdNAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nZSBN/koplYE0+SulVAbS5K+UUhno/wNqr72NFpGM/AAAAABJRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e747860>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "sns.distplot(data['total_bill'], rug=True)\n",
    "plt.xlabel(\"Total Bill in Dollars\")\n",
    "plt.savefig(\"bill.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden",
    "solution2_first": true
   },
   "source": [
    "### What do we observe?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden"
   },
   "source": [
    "1. Like tips we see that the distribution is skewed right.\n",
    "1. The distribution also appears much smoother.  with a clear single mode around $15."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "\n",
    "# EDA: Derived Variable  _Percent Tip_\n",
    "\n",
    "In many countries it is common to tip a percentage of the bill.  \n",
    "\n",
    "$$\\Large\n",
    "\\texttt{pcttip} = \\frac{\\texttt{tip}}{\\texttt{totalbill}} * 100\n",
    "$$\n",
    "\n",
    "However, the exact percentage varies by region, dining environment, and service quality.  \n",
    "\n",
    "**Question?** What is the percentage tip that this waiter receives?  This will be our first estimation goal.  \n",
    "\n",
    "We will extend our data with an additional **derived variable** containing the **percent tip**: "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "data['pcttip'] = data['tip']/data['total_bill'] * 100"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Examining it's distribution we see:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAX8AAAEOCAYAAABhOhcDAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nUoQU/EVEipCCv4hIEfr/jJYBdg2SrrIAAAAASUVORK5CYII=\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11b385c18>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "sns.distplot(data['pcttip'], rug=True)\n",
    "plt.xlabel(\"Percent Tip\")\n",
    "plt.savefig(\"percent_tip.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "There are some **large outliers** that are skewing the plot. Why?  What might be an explanation?"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "data": [
        {
         "autobinx": false,
         "histnorm": "probability density",
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "name": "Percent Tip",
         "opacity": 0.7,
         "type": "histogram",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          32.57328990228013,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          71.0344827586207,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          41.66666666666667,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "xbins": {
          "end": 71.0344827586207,
          "size": 1,
          "start": 3.563813585135547
         },
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "mode": "lines",
         "name": "Percent Tip",
         "showlegend": false,
         "type": "scatter",
         "x": [
          3.563813585135547,
          3.698754923482517,
          3.8336962618294876,
          3.9686376001764576,
          4.1035789385234285,
          4.238520276870398,
          4.373461615217368,
          4.508402953564339,
          4.643344291911309,
          4.77828563025828,
          4.913226968605249,
          5.0481683069522205,
          5.18310964529919,
          5.3180509836461605,
          5.452992321993131,
          5.587933660340101,
          5.722874998687072,
          5.857816337034042,
          5.992757675381013,
          6.127699013727982,
          6.2626403520749525,
          6.397581690421923,
          6.532523028768893,
          6.667464367115864,
          6.802405705462834,
          6.937347043809805,
          7.072288382156774,
          7.2072297205037446,
          7.342171058850715,
          7.477112397197685,
          7.612053735544656,
          7.746995073891626,
          7.881936412238597,
          8.016877750585566,
          8.151819088932537,
          8.286760427279507,
          8.421701765626477,
          8.556643103973448,
          8.69158444232042,
          8.826525780667389,
          8.961467119014358,
          9.09640845736133,
          9.231349795708299,
          9.36629113405527,
          9.50123247240224,
          9.63617381074921,
          9.77111514909618,
          9.90605648744315,
          10.040997825790122,
          10.175939164137091,
          10.31088050248406,
          10.445821840831032,
          10.580763179178003,
          10.715704517524973,
          10.850645855871942,
          10.985587194218912,
          11.120528532565885,
          11.255469870912854,
          11.390411209259824,
          11.525352547606794,
          11.660293885953765,
          11.795235224300734,
          11.930176562647706,
          12.065117900994675,
          12.200059239341646,
          12.335000577688616,
          12.469941916035586,
          12.604883254382557,
          12.739824592729528,
          12.874765931076498,
          13.009707269423467,
          13.144648607770437,
          13.279589946117408,
          13.41453128446438,
          13.549472622811349,
          13.684413961158318,
          13.81935529950529,
          13.95429663785226,
          14.08923797619923,
          14.224179314546202,
          14.35912065289317,
          14.494061991240141,
          14.629003329587112,
          14.763944667934082,
          14.898886006281051,
          15.03382734462802,
          15.168768682974992,
          15.303710021321963,
          15.438651359668933,
          15.573592698015903,
          15.708534036362874,
          15.843475374709843,
          15.978416713056815,
          16.113358051403786,
          16.248299389750755,
          16.383240728097725,
          16.518182066444695,
          16.653123404791664,
          16.788064743138637,
          16.923006081485603,
          17.057947419832576,
          17.19288875817955,
          17.32783009652652,
          17.46277143487349,
          17.597712773220458,
          17.732654111567427,
          17.867595449914397,
          18.00253678826137,
          18.137478126608336,
          18.27241946495531,
          18.40736080330228,
          18.54230214164925,
          18.67724347999622,
          18.81218481834319,
          18.94712615669016,
          19.08206749503713,
          19.2170088333841,
          19.351950171731072,
          19.486891510078042,
          19.621832848425015,
          19.756774186771985,
          19.891715525118954,
          20.026656863465924,
          20.161598201812893,
          20.296539540159863,
          20.431480878506832,
          20.566422216853802,
          20.70136355520078,
          20.836304893547748,
          20.971246231894717,
          21.106187570241687,
          21.241128908588657,
          21.376070246935626,
          21.511011585282596,
          21.645952923629565,
          21.780894261976535,
          21.91583560032351,
          22.05077693867048,
          22.18571827701745,
          22.32065961536442,
          22.45560095371139,
          22.59054229205836,
          22.72548363040533,
          22.860424968752298,
          22.995366307099268,
          23.130307645446237,
          23.265248983793214,
          23.400190322140183,
          23.535131660487153,
          23.670072998834122,
          23.805014337181092,
          23.93995567552806,
          24.07489701387503,
          24.209838352222,
          24.34477969056897,
          24.479721028915947,
          24.614662367262916,
          24.749603705609886,
          24.884545043956855,
          25.019486382303825,
          25.154427720650794,
          25.289369058997764,
          25.424310397344733,
          25.559251735691703,
          25.69419307403868,
          25.82913441238565,
          25.96407575073262,
          26.099017089079588,
          26.233958427426558,
          26.368899765773527,
          26.503841104120497,
          26.638782442467466,
          26.773723780814436,
          26.908665119161405,
          27.043606457508382,
          27.17854779585535,
          27.31348913420232,
          27.44843047254929,
          27.58337181089626,
          27.71831314924323,
          27.8532544875902,
          27.98819582593717,
          28.123137164284138,
          28.258078502631115,
          28.393019840978084,
          28.527961179325054,
          28.662902517672023,
          28.797843856018993,
          28.932785194365962,
          29.067726532712932,
          29.2026678710599,
          29.33760920940687,
          29.472550547753848,
          29.607491886100817,
          29.742433224447787,
          29.877374562794756,
          30.012315901141726,
          30.147257239488695,
          30.282198577835665,
          30.417139916182634,
          30.552081254529604,
          30.687022592876573,
          30.82196393122355,
          30.95690526957052,
          31.09184660791749,
          31.22678794626446,
          31.361729284611428,
          31.496670622958398,
          31.631611961305367,
          31.766553299652337,
          31.901494637999306,
          32.03643597634628,
          32.17137731469325,
          32.30631865304022,
          32.44125999138719,
          32.57620132973416,
          32.71114266808113,
          32.8460840064281,
          32.98102534477507,
          33.11596668312204,
          33.25090802146901,
          33.385849359815985,
          33.520790698162955,
          33.655732036509924,
          33.790673374856894,
          33.92561471320386,
          34.06055605155083,
          34.1954973898978,
          34.33043872824477,
          34.46538006659174,
          34.60032140493872,
          34.73526274328569,
          34.87020408163266,
          35.00514541997963,
          35.140086758326596,
          35.275028096673566,
          35.409969435020535,
          35.544910773367505,
          35.67985211171448,
          35.81479345006145,
          35.94973478840842,
          36.08467612675539,
          36.21961746510236,
          36.35455880344933,
          36.4895001417963,
          36.624441480143275,
          36.75938281849024,
          36.894324156837214,
          37.029265495184184,
          37.16420683353115,
          37.29914817187812,
          37.43408951022509,
          37.56903084857206,
          37.70397218691903,
          37.83891352526601,
          37.97385486361297,
          38.10879620195995,
          38.24373754030692,
          38.378678878653886,
          38.513620217000856,
          38.648561555347825,
          38.783502893694795,
          38.918444232041765,
          39.05338557038874,
          39.188326908735704,
          39.32326824708268,
          39.45820958542965,
          39.59315092377662,
          39.72809226212359,
          39.86303360047056,
          39.99797493881753,
          40.1329162771645,
          40.267857615511474,
          40.40279895385844,
          40.53774029220541,
          40.67268163055238,
          40.80762296889935,
          40.94256430724632,
          41.0775056455933,
          41.21244698394026,
          41.34738832228723,
          41.48232966063421,
          41.61727099898117,
          41.752212337328146,
          41.88715367567511,
          42.022095014022085,
          42.157036352369055,
          42.291977690716024,
          42.426919029062994,
          42.56186036740996,
          42.69680170575693,
          42.8317430441039,
          42.96668438245088,
          43.10162572079784,
          43.23656705914482,
          43.37150839749179,
          43.50644973583876,
          43.64139107418573,
          43.776332412532696,
          43.911273750879666,
          44.046215089226635,
          44.18115642757361,
          44.316097765920574,
          44.45103910426755,
          44.58598044261452,
          44.72092178096149,
          44.85586311930846,
          44.99080445765543,
          45.1257457960024,
          45.26068713434937,
          45.395628472696345,
          45.53056981104331,
          45.665511149390284,
          45.80045248773725,
          45.93539382608422,
          46.07033516443119,
          46.20527650277817,
          46.34021784112513,
          46.4751591794721,
          46.61010051781908,
          46.74504185616604,
          46.87998319451302,
          47.014924532859986,
          47.149865871206956,
          47.284807209553925,
          47.4197485479009,
          47.554689886247864,
          47.689631224594834,
          47.82457256294181,
          47.95951390128877,
          48.09445523963575,
          48.22939657798272,
          48.36433791632969,
          48.49927925467666,
          48.63422059302363,
          48.7691619313706,
          48.90410326971757,
          49.039044608064536,
          49.173985946411506,
          49.30892728475848,
          49.443868623105445,
          49.57880996145242,
          49.71375129979939,
          49.84869263814636,
          49.98363397649333,
          50.11857531484031,
          50.25351665318727,
          50.38845799153424,
          50.523399329881215,
          50.65834066822818,
          50.793282006575154,
          50.928223344922124,
          51.06316468326909,
          51.19810602161606,
          51.33304735996304,
          51.46798869831,
          51.60293003665697,
          51.73787137500395,
          51.87281271335091,
          52.00775405169789,
          52.14269539004486,
          52.277636728391826,
          52.412578066738796,
          52.54751940508577,
          52.682460743432735,
          52.817402081779704,
          52.95234342012668,
          53.08728475847364,
          53.22222609682062,
          53.35716743516759,
          53.49210877351456,
          53.62705011186153,
          53.761991450208505,
          53.89693278855547,
          54.03187412690244,
          54.166815465249414,
          54.301756803596376,
          54.43669814194335,
          54.57163948029032,
          54.70658081863729,
          54.84152215698426,
          54.97646349533124,
          55.1114048336782,
          55.24634617202518,
          55.38128751037215,
          55.51622884871911,
          55.651170187066086,
          55.78611152541305,
          55.921052863760025,
          56.055994202106994,
          56.190935540453964,
          56.32587687880093,
          56.46081821714791,
          56.59575955549487,
          56.73070089384184,
          56.86564223218882,
          57.00058357053578,
          57.13552490888276,
          57.27046624722973,
          57.4054075855767,
          57.540348923923666,
          57.67529026227064,
          57.810231600617605,
          57.945172938964575,
          58.08011427731155,
          58.215055615658514,
          58.34999695400549,
          58.48493829235246,
          58.61987963069943,
          58.7548209690464,
          58.889762307393376,
          59.02470364574034,
          59.159644984087315,
          59.294586322434284,
          59.42952766078125,
          59.56446899912822,
          59.69941033747519,
          59.83435167582216,
          59.96929301416913,
          60.10423435251611,
          60.23917569086307,
          60.37411702921005,
          60.50905836755702,
          60.64399970590398,
          60.778941044250956,
          60.913882382597926,
          61.048823720944895,
          61.183765059291865,
          61.31870639763884,
          61.453647735985804,
          61.58858907433278,
          61.72353041267975,
          61.85847175102671,
          61.99341308937369,
          62.12835442772066,
          62.26329576606763,
          62.3982371044146,
          62.53317844276157,
          62.66811978110854,
          62.80306111945551,
          62.938002457802476,
          63.072943796149445,
          63.20788513449642,
          63.342826472843385,
          63.47776781119036,
          63.61270914953733,
          63.7476504878843,
          63.88259182623127,
          64.01753316457824,
          64.1524745029252,
          64.28741584127218,
          64.42235717961915,
          64.55729851796612,
          64.6922398563131,
          64.82718119466006,
          64.96212253300703,
          65.097063871354,
          65.23200520970097,
          65.36694654804793,
          65.50188788639491,
          65.63682922474189,
          65.77177056308885,
          65.90671190143583,
          66.04165323978279,
          66.17659457812977,
          66.31153591647673,
          66.4464772548237,
          66.58141859317067,
          66.71635993151764,
          66.85130126986462,
          66.98624260821158,
          67.12118394655856,
          67.25612528490552,
          67.3910666232525,
          67.52600796159946,
          67.66094929994644,
          67.79589063829341,
          67.93083197664038,
          68.06577331498735,
          68.20071465333432,
          68.33565599168129,
          68.47059733002827,
          68.60553866837523,
          68.74048000672221,
          68.87542134506917,
          69.01036268341615,
          69.14530402176311,
          69.28024536011009,
          69.41518669845705,
          69.55012803680401,
          69.685069375151,
          69.82001071349796,
          69.95495205184493,
          70.0898933901919,
          70.22483472853888,
          70.35977606688584,
          70.49471740523282,
          70.62965874357978,
          70.76460008192676,
          70.89954142027374
         ],
         "xaxis": "x1",
         "y": [
          0.004061065040256531,
          0.004413888978508207,
          0.004789339808663863,
          0.005187923334495055,
          0.0056100331411973615,
          0.00605593798092017,
          0.006525770588188691,
          0.007019518348559347,
          0.00753701622583154,
          0.008077942319898737,
          0.008641816378981468,
          0.009228001527295915,
          0.009835709393563723,
          0.010464008739172257,
          0.011111837589830077,
          0.011778018774303851,
          0.01246127867172563,
          0.013160268868727199,
          0.013873590333089924,
          0.014599819625412637,
          0.015337536597965358,
          0.016085352973448333,
          0.016841941158262347,
          0.01760606262682783,
          0.018376595216336316,
          0.01915255869502956,
          0.01993313801068977,
          0.02071770368758152,
          0.021505828916862448,
          0.02229730297401319,
          0.023092140693118567,
          0.023890587827517882,
          0.02469312222499421,
          0.025500450838992644,
          0.026313502681453736,
          0.02713341789444682,
          0.027961533174442842,
          0.028799363823310085,
          0.02964858272354768,
          0.030510996542605178,
          0.03138851946413958,
          0.03228314472548434,
          0.03319691421397794,
          0.03413188634424564,
          0.0350901024084771,
          0.03607355156666255,
          0.037084134627838036,
          0.038123626770297334,
          0.039193639361299666,
          0.04029558106684057,
          0.04143061849019723,
          0.04259963664352944,
          0.04380319963784442,
          0.045041512069855336,
          0.04631438168527334,
          0.04762118400147698,
          0.0489608296721662,
          0.05033173546592715,
          0.051731799802854715,
          0.05315838384191767,
          0.054608299130533576,
          0.05607780281160138,
          0.05756260132789566,
          0.059057863466529976,
          0.06055824344600759,
          0.06205791456582734,
          0.06355061371615824,
          0.06502969678708674,
          0.06648820472951214,
          0.06791893971075327,
          0.06931455048663807,
          0.07066762578878347,
          0.0719707942122969,
          0.07321682879707855,
          0.07439875423712615,
          0.07550995443815267,
          0.0765442779849296,
          0.0774961389851708,
          0.07836061073378914,
          0.07913350969506677,
          0.07981146743328535,
          0.08039198833446307,
          0.08087349125003364,
          0.08125533355161306,
          0.08153781650574733,
          0.08172217134742225,
          0.08181052593765466,
          0.08180585241836236,
          0.08171189681037241,
          0.08153309202061035,
          0.08127445621489994,
          0.0809414789566595,
          0.08053999789357176,
          0.08007606908029484,
          0.07955583424406373,
          0.07898538842295848,
          0.07837065142815776,
          0.07771724649946794,
          0.07703038933907268,
          0.0763147904264893,
          0.07557457314614326,
          0.07481320980881365,
          0.07403347713321282,
          0.07323743219009332,
          0.07242640921622669,
          0.07160103709818437,
          0.07076127672537842,
          0.06990647683748734,
          0.06903544646157093,
          0.06814654156587319,
          0.0672377631654885,
          0.06630686381221874,
          0.06535145919656712,
          0.06436914149008682,
          0.06335759106386796,
          0.06231468333273976,
          0.06123858769006774,
          0.0601278558065846,
          0.05898149695700307,
          0.05779903849587522,
          0.05658057011261719,
          0.05532677103644683,
          0.054038919915825906,
          0.052718887644250145,
          0.051369113925798564,
          0.049992568851931644,
          0.04859270117976999,
          0.04717337534824998,
          0.04573879953199846,
          0.044293447206817736,
          0.04284197478234262,
          0.04138913784744981,
          0.039939708476718815,
          0.03849839586932271,
          0.03706977234571012,
          0.035658206425225464,
          0.03426780436396405,
          0.03290236116223318,
          0.0315653216708009,
          0.030259752050017918,
          0.028988321480134766,
          0.02775329369726309,
          0.02655652764784242,
          0.02539948632307492,
          0.02428325265878568,
          0.02320855126801733,
          0.02217577471315295,
          0.02118501301880052,
          0.02023608517122076,
          0.019328571438135583,
          0.018461845466386274,
          0.017635105265368944,
          0.016847402352337573,
          0.01609766851251993,
          0.015384739804037364,
          0.01470737760721114,
          0.014064286673472773,
          0.013454130265585113,
          0.01287554259447577,
          0.012327138846377421,
          0.011807523156263556,
          0.011315294920143305,
          0.010849053851136572,
          0.010407404174806678,
          0.009988958331086682,
          0.009592340506864762,
          0.009216190268693043,
          0.008859166502987879,
          0.008519951805177731,
          0.008197257392918421,
          0.007889828554717744,
          0.0075964505865984055,
          0.007315955117772504,
          0.0070472266831716895,
          0.006789209367043516,
          0.006540913318192777,
          0.006301420923915906,
          0.0060698924259996795,
          0.00584557076780063,
          0.005627785475635947,
          0.005415955399578189,
          0.005209590167208704,
          0.005008290237819089,
          0.004811745482765651,
          0.004619732258952654,
          0.004432108985494354,
          0.0042488102772232795,
          0.004069839731607929,
          0.0038952615065696284,
          0.0037251908644240867,
          0.0035597838905499874,
          0.003399226623314702,
          0.003243723853285893,
          0.003093487863994801,
          0.0029487273928415817,
          0.002809637088716958,
          0.0026763877323784015,
          0.0025491174666662808,
          0.0024279242566706766,
          0.0023128597656595995,
          0.002203924791940908,
          0.002101066366108204,
          0.0020041765588009928,
          0.0019130929978565217,
          0.0018276010423274515,
          0.0017474375111151182,
          0.001672295817720563,
          0.0016018323215357814,
          0.0015356736716917376,
          0.0014734248930020205,
          0.001414677945934707,
          0.0013590204843982635,
          0.001306044536645361,
          0.0012553548455934743,
          0.0012065766247619416,
          0.001159362513903558,
          0.0011133985530256984,
          0.0010684090333588584,
          0.0010241601272653162,
          0.0009804622443093098,
          0.0009371711059325876,
          0.0008941875746540666,
          0.0008514563138329411,
          0.0008089633893953681,
          0.0007667329543770098,
          0.0007248231798244448,
          0.0006833216109964241,
          0.0006423401357080032,
          0.0006020097521837605,
          0.0005624753173443817,
          0.0005238904437178537,
          0.00048641269503058704,
          0.0004501992080435803,
          0.0004154028425066951,
          0.00038216893340823667,
          0.0003506326911868276,
          0.00032091726737884085,
          0.0002931324763277669,
          0.00026737413897860566,
          0.00024372399316037073,
          0.00022225009669232977,
          0.00020300763552952278,
          0.00018604003921478878,
          0.00017138030019374763,
          0.00015905239199883844,
          0.00014907268371896652,
          0.00014145125424141268,
          0.00013619301910119315,
          0.00013329859495857116,
          0.00013276484126351271,
          0.0001345850350440157,
          0.00013874865244358772,
          0.0001452407490934611,
          0.00015404095009655732,
          0.00016512207878403493,
          0.00017844847094905075,
          0.00019397403744459663,
          0.00021164015234829598,
          0.00023137345586762636,
          0.0002530836703405379,
          0.00027666153368517644,
          0.0003019769571395235,
          0.0003288775128614308,
          0.000357187351786534,
          0.00038670664303883866,
          0.0004172116132623349,
          0.00044845524774174,
          0.0004801686955064988,
          0.0005120633983123962,
          0.0005438339391581892,
          0.0005751615806308962,
          0.0006057184377910238,
          0.0006351722054802845,
          0.0006631913368565261,
          0.000689450549611927,
          0.0007136365196235169,
          0.0007354536095210952,
          0.0007546294724819934,
          0.0007709203699282949,
          0.0007841160459401385,
          0.0007940440110973731,
          0.0008005731038601201,
          0.0008036162179920371,
          0.0008031321091872811,
          0.0007991262220572571,
          0.0007916505088855917,
          0.0007808022428844794,
          0.0007667218598489521,
          0.0007495898918840708,
          0.0007296230841177507,
          0.0007070698089755887,
          0.0006822049118201197,
          0.0006553241358898414,
          0.0006267382830923024,
          0.0005967672701383592,
          0.0005657342368291118,
          0.0005339598553378139,
          0.0005017569765958483,
          0.00046942573310343553,
          0.00043724919749046594,
          0.0004054896738906579,
          0.00037438567564659377,
          0.000344149619012473,
          0.00031496623929375443,
          0.0002869917140967621,
          0.000260353458772355,
          0.00023515054229610328,
          0.00021145465814113645,
          0.00018931157441137754,
          0.00016874298069085336,
          0.00014974864565601084,
          0.00013230879928488424,
          0.0001163866561602831,
          0.00010193100149914537,
          8.887876868351526e-05,
          7.715754572673293e-05,
          6.668795778227171e-05,
          5.7385883011832395e-05,
          4.916446943062413e-05,
          4.193593035105279e-05,
          3.5613105424349974e-05,
          3.0110782775869593e-05,
          2.5346785158092945e-05,
          2.1242829289821303e-05,
          1.7725172559526937e-05,
          1.47250650515729e-05,
          1.2179027460821895e-05,
          1.0028976987214784e-05,
          8.222223868701009e-06,
          6.711360958162722e-06,
          5.454067826578978e-06,
          4.412849430495905e-06,
          3.5547275610949367e-06,
          2.8509012280304825e-06,
          2.2763899421638006e-06,
          1.809671648629874e-06,
          1.4323249082523385e-06,
          1.1286828956938805e-06,
          8.855049238302605e-07,
          6.916695464936667e-07,
          5.378918526043765e-07,
          4.16466348493636e-07,
          3.2103582695293924e-07,
          2.4638582887079993e-07,
          1.8826369862341475e-07,
          1.4322079669273577e-07,
          1.0847613960286604e-07,
          8.179956513047356e-08,
          6.141244748653898e-08,
          4.590399188604345e-08,
          3.416120172412304e-08,
          2.5310717881298547e-08,
          1.8670864352976154e-08,
          1.3712385739657255e-08,
          1.0026520757316159e-08,
          7.299214563892447e-09,
          5.2904259559312025e-09,
          3.817629590016872e-09,
          2.7427458924163194e-09,
          1.9618508902067147e-09,
          1.3971243307170989e-09,
          9.905872944769853e-10,
          6.992606477306674e-10,
          4.914440263015807e-10,
          3.438726774164501e-10,
          2.395575799972692e-10,
          1.6615400029578973e-10,
          1.1473616341600575e-10,
          7.888210349929797e-11,
          5.399397238671244e-11,
          3.679600885692664e-11,
          2.4965759780535885e-11,
          1.686465647701201e-11,
          1.1342240533667929e-11,
          7.59466909380626e-12,
          5.06299533216203e-12,
          3.36043047892033e-12,
          2.220604156223336e-12,
          1.460954062346998e-12,
          9.569561120730627e-13,
          6.240793244661887e-13,
          4.052152553369018e-13,
          2.6196627339106577e-13,
          1.6863924889955557e-13,
          1.0812596062727209e-13,
          6.909246898497551e-14,
          4.407213068313844e-14,
          2.817965324016544e-14,
          1.8250513922283737e-14,
          1.2271422669538055e-14,
          9.010781902168653e-15,
          7.788770029013387e-15,
          8.348785435264685e-15,
          1.0808556091887567e-14,
          1.568259728070787e-14,
          2.3979842981244692e-14,
          3.739298801981403e-14,
          5.861123194427245e-14,
          9.180788843537391e-14,
          1.4338145669664933e-13,
          2.2306686352951489e-13,
          3.455875717943426e-13,
          5.33095792792719e-13,
          8.187562637625731e-13,
          1.2519813910303148e-12,
          1.9060388683373703e-12,
          2.889049863569262e-12,
          4.359806906358641e-12,
          6.550406063842535e-12,
          9.798461079023034e-12,
          1.4592717492343312e-11,
          2.163730274057301e-11,
          3.194175014664065e-11,
          4.6946469015957937e-11,
          6.869668746972345e-11,
          1.0008230438481846e-10,
          1.4516684368604232e-10,
          2.0963616653755905e-10,
          3.0140719977042593e-10,
          4.3144920422037216e-10,
          6.148856529771532e-10,
          8.724643392321777e-10,
          1.2325077170824826e-09,
          1.7334856346102324e-09,
          2.4273895851450593e-09,
          3.384132501012366e-09,
          4.6972521186143505e-09,
          6.491260236510729e-09,
          8.931055894710467e-09,
          1.2233908605372807e-08,
          1.6684618987820253e-08,
          2.2654578831920058e-08,
          3.062558049288616e-08,
          4.1219365597544224e-08,
          5.523405330977864e-08,
          7.368874560518853e-08,
          9.787776637158493e-08,
          1.294361461311259e-07,
          1.7041810618590504e-07,
          2.233904141871005e-07,
          2.91542564283386e-07,
          3.7881576342592685e-07,
          4.900526630207396e-07,
          6.311696417104002e-07,
          8.093531987266391e-07,
          1.0332816350662432e-06,
          1.3133726587368053e-06,
          1.6620568287147696e-06,
          2.094075831004372e-06,
          2.6268034447645e-06,
          3.280585698956659e-06,
          4.079095141250868e-06,
          5.04969235302578e-06,
          6.223785872609035e-06,
          7.637179574264069e-06,
          9.330394350797272e-06,
          1.13489487391608e-05,
          1.3743581005709115e-05,
          1.657039328316025e-05,
          1.9890896753042463e-05,
          2.3771935736134174e-05,
          2.8285468037697128e-05,
          3.3508179144210024e-05,
          3.9520909027951444e-05,
          4.6407872514455533e-05,
          5.4255657510240266e-05,
          6.315198994441792e-05,
          7.318426007283131e-05,
          8.443781179821848e-05,
          9.699400478285368e-05,
          0.00011092806821156569,
          0.00012630677487171315,
          0.0001431859744508427,
          0.00016160803524434465,
          0.0001815992533889584,
          0.00020316729782486796,
          0.00022629876694426273,
          0.0002509569388094778,
          0.00027707980044122514,
          0.0003045784425577029,
          0.0003333359039347361,
          0.00036320654400373353,
          0.0003940160132837142,
          0.00042556187877661265,
          0.00045761494572299396,
          0.0004899212984656303,
          0.0005222050621120998,
          0.0005541718638894977,
          0.0005855129493398443,
          0.0006159098847134543,
          0.000645039754042669,
          0.0006725807384066953,
          0.0006982179467900685,
          0.0007216493535784192,
          0.0007425916878904012,
          0.0007607861152114439,
          0.0007760035525695503,
          0.0007880494649412836,
          0.0007967680026167702,
          0.0008020453565550446
         ],
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)",
          "symbol": "line-ns-open"
         },
         "mode": "markers",
         "name": "Percent Tip",
         "showlegend": false,
         "text": [
          "bill $16.99, tip $1.01",
          "bill $10.34, tip $1.66",
          "bill $21.01, tip $3.5",
          "bill $23.68, tip $3.31",
          "bill $24.59, tip $3.61",
          "bill $25.29, tip $4.71",
          "bill $8.77, tip $2.0",
          "bill $26.88, tip $3.12",
          "bill $15.04, tip $1.96",
          "bill $14.78, tip $3.23",
          "bill $10.27, tip $1.71",
          "bill $35.26, tip $5.0",
          "bill $15.42, tip $1.57",
          "bill $18.43, tip $3.0",
          "bill $14.83, tip $3.02",
          "bill $21.58, tip $3.92",
          "bill $10.33, tip $1.67",
          "bill $16.29, tip $3.71",
          "bill $16.97, tip $3.5",
          "bill $20.65, tip $3.35",
          "bill $17.92, tip $4.08",
          "bill $20.29, tip $2.75",
          "bill $15.77, tip $2.23",
          "bill $39.42, tip $7.58",
          "bill $19.82, tip $3.18",
          "bill $17.81, tip $2.34",
          "bill $13.37, tip $2.0",
          "bill $12.69, tip $2.0",
          "bill $21.7, tip $4.3",
          "bill $19.65, tip $3.0",
          "bill $9.55, tip $1.45",
          "bill $18.35, tip $2.5",
          "bill $15.06, tip $3.0",
          "bill $20.69, tip $2.45",
          "bill $17.78, tip $3.27",
          "bill $24.06, tip $3.6",
          "bill $16.31, tip $2.0",
          "bill $16.93, tip $3.07",
          "bill $18.69, tip $2.31",
          "bill $31.27, tip $5.0",
          "bill $16.04, tip $2.24",
          "bill $17.46, tip $2.54",
          "bill $13.94, tip $3.06",
          "bill $9.68, tip $1.32",
          "bill $30.4, tip $5.6",
          "bill $18.29, tip $3.0",
          "bill $22.23, tip $5.0",
          "bill $32.4, tip $6.0",
          "bill $28.55, tip $2.05",
          "bill $18.04, tip $3.0",
          "bill $12.54, tip $2.5",
          "bill $10.29, tip $2.6",
          "bill $34.81, tip $5.2",
          "bill $9.94, tip $1.56",
          "bill $25.56, tip $4.34",
          "bill $19.49, tip $3.51",
          "bill $38.01, tip $3.0",
          "bill $26.41, tip $1.5",
          "bill $11.24, tip $1.76",
          "bill $48.27, tip $6.73",
          "bill $20.29, tip $3.21",
          "bill $13.81, tip $2.0",
          "bill $11.02, tip $1.98",
          "bill $18.29, tip $3.76",
          "bill $17.59, tip $2.64",
          "bill $20.08, tip $3.15",
          "bill $16.45, tip $2.47",
          "bill $3.07, tip $1.0",
          "bill $20.23, tip $2.01",
          "bill $15.01, tip $2.09",
          "bill $12.02, tip $1.97",
          "bill $17.07, tip $3.0",
          "bill $26.86, tip $3.14",
          "bill $25.28, tip $5.0",
          "bill $14.73, tip $2.2",
          "bill $10.51, tip $1.25",
          "bill $17.92, tip $3.08",
          "bill $27.2, tip $4.0",
          "bill $22.76, tip $3.0",
          "bill $17.29, tip $2.71",
          "bill $19.44, tip $3.0",
          "bill $16.66, tip $3.4",
          "bill $10.07, tip $1.83",
          "bill $32.68, tip $5.0",
          "bill $15.98, tip $2.03",
          "bill $34.83, tip $5.17",
          "bill $13.03, tip $2.0",
          "bill $18.28, tip $4.0",
          "bill $24.71, tip $5.85",
          "bill $21.16, tip $3.0",
          "bill $28.97, tip $3.0",
          "bill $22.49, tip $3.5",
          "bill $5.75, tip $1.0",
          "bill $16.32, tip $4.3",
          "bill $22.75, tip $3.25",
          "bill $40.17, tip $4.73",
          "bill $27.28, tip $4.0",
          "bill $12.03, tip $1.5",
          "bill $21.01, tip $3.0",
          "bill $12.46, tip $1.5",
          "bill $11.35, tip $2.5",
          "bill $15.38, tip $3.0",
          "bill $44.3, tip $2.5",
          "bill $22.42, tip $3.48",
          "bill $20.92, tip $4.08",
          "bill $15.36, tip $1.64",
          "bill $20.49, tip $4.06",
          "bill $25.21, tip $4.29",
          "bill $18.24, tip $3.76",
          "bill $14.31, tip $4.0",
          "bill $14.0, tip $3.0",
          "bill $7.25, tip $1.0",
          "bill $38.07, tip $4.0",
          "bill $23.95, tip $2.55",
          "bill $25.71, tip $4.0",
          "bill $17.31, tip $3.5",
          "bill $29.93, tip $5.07",
          "bill $10.65, tip $1.5",
          "bill $12.43, tip $1.8",
          "bill $24.08, tip $2.92",
          "bill $11.69, tip $2.31",
          "bill $13.42, tip $1.68",
          "bill $14.26, tip $2.5",
          "bill $15.95, tip $2.0",
          "bill $12.48, tip $2.52",
          "bill $29.8, tip $4.2",
          "bill $8.52, tip $1.48",
          "bill $14.52, tip $2.0",
          "bill $11.38, tip $2.0",
          "bill $22.82, tip $2.18",
          "bill $19.08, tip $1.5",
          "bill $20.27, tip $2.83",
          "bill $11.17, tip $1.5",
          "bill $12.26, tip $2.0",
          "bill $18.26, tip $3.25",
          "bill $8.51, tip $1.25",
          "bill $10.33, tip $2.0",
          "bill $14.15, tip $2.0",
          "bill $16.0, tip $2.0",
          "bill $13.16, tip $2.75",
          "bill $17.47, tip $3.5",
          "bill $34.3, tip $6.7",
          "bill $41.19, tip $5.0",
          "bill $27.05, tip $5.0",
          "bill $16.43, tip $2.3",
          "bill $8.35, tip $1.5",
          "bill $18.64, tip $1.36",
          "bill $11.87, tip $1.63",
          "bill $9.78, tip $1.73",
          "bill $7.51, tip $2.0",
          "bill $14.07, tip $2.5",
          "bill $13.13, tip $2.0",
          "bill $17.26, tip $2.74",
          "bill $24.55, tip $2.0",
          "bill $19.77, tip $2.0",
          "bill $29.85, tip $5.14",
          "bill $48.17, tip $5.0",
          "bill $25.0, tip $3.75",
          "bill $13.39, tip $2.61",
          "bill $16.49, tip $2.0",
          "bill $21.5, tip $3.5",
          "bill $12.66, tip $2.5",
          "bill $16.21, tip $2.0",
          "bill $13.81, tip $2.0",
          "bill $17.51, tip $3.0",
          "bill $24.52, tip $3.48",
          "bill $20.76, tip $2.24",
          "bill $31.71, tip $4.5",
          "bill $10.59, tip $1.61",
          "bill $10.63, tip $2.0",
          "bill $50.81, tip $10.0",
          "bill $15.81, tip $3.16",
          "bill $7.25, tip $5.15",
          "bill $31.85, tip $3.18",
          "bill $16.82, tip $4.0",
          "bill $32.9, tip $3.11",
          "bill $17.89, tip $2.0",
          "bill $14.48, tip $2.0",
          "bill $9.6, tip $4.0",
          "bill $34.63, tip $3.55",
          "bill $34.65, tip $3.68",
          "bill $23.33, tip $5.65",
          "bill $45.35, tip $3.5",
          "bill $23.17, tip $6.5",
          "bill $40.55, tip $3.0",
          "bill $20.69, tip $5.0",
          "bill $20.9, tip $3.5",
          "bill $30.46, tip $2.0",
          "bill $18.15, tip $3.5",
          "bill $23.1, tip $4.0",
          "bill $15.69, tip $1.5",
          "bill $19.81, tip $4.19",
          "bill $28.44, tip $2.56",
          "bill $15.48, tip $2.02",
          "bill $16.58, tip $4.0",
          "bill $7.56, tip $1.44",
          "bill $10.34, tip $2.0",
          "bill $43.11, tip $5.0",
          "bill $13.0, tip $2.0",
          "bill $13.51, tip $2.0",
          "bill $18.71, tip $4.0",
          "bill $12.74, tip $2.01",
          "bill $13.0, tip $2.0",
          "bill $16.4, tip $2.5",
          "bill $20.53, tip $4.0",
          "bill $16.47, tip $3.23",
          "bill $26.59, tip $3.41",
          "bill $38.73, tip $3.0",
          "bill $24.27, tip $2.03",
          "bill $12.76, tip $2.23",
          "bill $30.06, tip $2.0",
          "bill $25.89, tip $5.16",
          "bill $48.33, tip $9.0",
          "bill $13.27, tip $2.5",
          "bill $28.17, tip $6.5",
          "bill $12.9, tip $1.1",
          "bill $28.15, tip $3.0",
          "bill $11.59, tip $1.5",
          "bill $7.74, tip $1.44",
          "bill $30.14, tip $3.09",
          "bill $12.16, tip $2.2",
          "bill $13.42, tip $3.48",
          "bill $8.58, tip $1.92",
          "bill $15.98, tip $3.0",
          "bill $13.42, tip $1.58",
          "bill $16.27, tip $2.5",
          "bill $10.09, tip $2.0",
          "bill $20.45, tip $3.0",
          "bill $13.28, tip $2.72",
          "bill $22.12, tip $2.88",
          "bill $24.01, tip $2.0",
          "bill $15.69, tip $3.0",
          "bill $11.61, tip $3.39",
          "bill $10.77, tip $1.47",
          "bill $15.53, tip $3.0",
          "bill $10.07, tip $1.25",
          "bill $12.6, tip $1.0",
          "bill $32.83, tip $1.17",
          "bill $35.83, tip $4.67",
          "bill $29.03, tip $5.92",
          "bill $27.18, tip $2.0",
          "bill $22.67, tip $2.0",
          "bill $17.82, tip $1.75",
          "bill $18.78, tip $3.0"
         ],
         "type": "scatter",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          32.57328990228013,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          71.0344827586207,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          41.66666666666667,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "y": [
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip"
         ],
         "yaxis": "y2"
        }
       ],
       "layout": {
        "barmode": "overlay",
        "hovermode": "closest",
        "legend": {
         "traceorder": "reversed"
        },
        "xaxis1": {
         "anchor": "y2",
         "domain": [
          0,
          1
         ],
         "zeroline": false
        },
        "yaxis1": {
         "anchor": "free",
         "domain": [
          0.35,
          1
         ],
         "position": 0
        },
        "yaxis2": {
         "anchor": "x1",
         "domain": [
          0,
          0.25
         ],
         "dtick": 1,
         "showticklabels": false
        }
       }
      },
      "text/html": [
       "<div id=\"3af46a68-c4de-417d-ad9a-241823ca9ff7\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"3af46a68-c4de-417d-ad9a-241823ca9ff7\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 71.0344827586207, \"size\": 1.0}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.698754923482517, 3.8336962618294876, 3.9686376001764576, 4.1035789385234285, 4.238520276870398, 4.373461615217368, 4.508402953564339, 4.643344291911309, 4.77828563025828, 4.913226968605249, 5.0481683069522205, 5.18310964529919, 5.3180509836461605, 5.452992321993131, 5.587933660340101, 5.722874998687072, 5.857816337034042, 5.992757675381013, 6.127699013727982, 6.2626403520749525, 6.397581690421923, 6.532523028768893, 6.667464367115864, 6.802405705462834, 6.937347043809805, 7.072288382156774, 7.2072297205037446, 7.342171058850715, 7.477112397197685, 7.612053735544656, 7.746995073891626, 7.881936412238597, 8.016877750585566, 8.151819088932537, 8.286760427279507, 8.421701765626477, 8.556643103973448, 8.69158444232042, 8.826525780667389, 8.961467119014358, 9.09640845736133, 9.231349795708299, 9.36629113405527, 9.50123247240224, 9.63617381074921, 9.77111514909618, 9.90605648744315, 10.040997825790122, 10.175939164137091, 10.31088050248406, 10.445821840831032, 10.580763179178003, 10.715704517524973, 10.850645855871942, 10.985587194218912, 11.120528532565885, 11.255469870912854, 11.390411209259824, 11.525352547606794, 11.660293885953765, 11.795235224300734, 11.930176562647706, 12.065117900994675, 12.200059239341646, 12.335000577688616, 12.469941916035586, 12.604883254382557, 12.739824592729528, 12.874765931076498, 13.009707269423467, 13.144648607770437, 13.279589946117408, 13.41453128446438, 13.549472622811349, 13.684413961158318, 13.81935529950529, 13.95429663785226, 14.08923797619923, 14.224179314546202, 14.35912065289317, 14.494061991240141, 14.629003329587112, 14.763944667934082, 14.898886006281051, 15.03382734462802, 15.168768682974992, 15.303710021321963, 15.438651359668933, 15.573592698015903, 15.708534036362874, 15.843475374709843, 15.978416713056815, 16.113358051403786, 16.248299389750755, 16.383240728097725, 16.518182066444695, 16.653123404791664, 16.788064743138637, 16.923006081485603, 17.057947419832576, 17.19288875817955, 17.32783009652652, 17.46277143487349, 17.597712773220458, 17.732654111567427, 17.867595449914397, 18.00253678826137, 18.137478126608336, 18.27241946495531, 18.40736080330228, 18.54230214164925, 18.67724347999622, 18.81218481834319, 18.94712615669016, 19.08206749503713, 19.2170088333841, 19.351950171731072, 19.486891510078042, 19.621832848425015, 19.756774186771985, 19.891715525118954, 20.026656863465924, 20.161598201812893, 20.296539540159863, 20.431480878506832, 20.566422216853802, 20.70136355520078, 20.836304893547748, 20.971246231894717, 21.106187570241687, 21.241128908588657, 21.376070246935626, 21.511011585282596, 21.645952923629565, 21.780894261976535, 21.91583560032351, 22.05077693867048, 22.18571827701745, 22.32065961536442, 22.45560095371139, 22.59054229205836, 22.72548363040533, 22.860424968752298, 22.995366307099268, 23.130307645446237, 23.265248983793214, 23.400190322140183, 23.535131660487153, 23.670072998834122, 23.805014337181092, 23.93995567552806, 24.07489701387503, 24.209838352222, 24.34477969056897, 24.479721028915947, 24.614662367262916, 24.749603705609886, 24.884545043956855, 25.019486382303825, 25.154427720650794, 25.289369058997764, 25.424310397344733, 25.559251735691703, 25.69419307403868, 25.82913441238565, 25.96407575073262, 26.099017089079588, 26.233958427426558, 26.368899765773527, 26.503841104120497, 26.638782442467466, 26.773723780814436, 26.908665119161405, 27.043606457508382, 27.17854779585535, 27.31348913420232, 27.44843047254929, 27.58337181089626, 27.71831314924323, 27.8532544875902, 27.98819582593717, 28.123137164284138, 28.258078502631115, 28.393019840978084, 28.527961179325054, 28.662902517672023, 28.797843856018993, 28.932785194365962, 29.067726532712932, 29.2026678710599, 29.33760920940687, 29.472550547753848, 29.607491886100817, 29.742433224447787, 29.877374562794756, 30.012315901141726, 30.147257239488695, 30.282198577835665, 30.417139916182634, 30.552081254529604, 30.687022592876573, 30.82196393122355, 30.95690526957052, 31.09184660791749, 31.22678794626446, 31.361729284611428, 31.496670622958398, 31.631611961305367, 31.766553299652337, 31.901494637999306, 32.03643597634628, 32.17137731469325, 32.30631865304022, 32.44125999138719, 32.57620132973416, 32.71114266808113, 32.8460840064281, 32.98102534477507, 33.11596668312204, 33.25090802146901, 33.385849359815985, 33.520790698162955, 33.655732036509924, 33.790673374856894, 33.92561471320386, 34.06055605155083, 34.1954973898978, 34.33043872824477, 34.46538006659174, 34.60032140493872, 34.73526274328569, 34.87020408163266, 35.00514541997963, 35.140086758326596, 35.275028096673566, 35.409969435020535, 35.544910773367505, 35.67985211171448, 35.81479345006145, 35.94973478840842, 36.08467612675539, 36.21961746510236, 36.35455880344933, 36.4895001417963, 36.624441480143275, 36.75938281849024, 36.894324156837214, 37.029265495184184, 37.16420683353115, 37.29914817187812, 37.43408951022509, 37.56903084857206, 37.70397218691903, 37.83891352526601, 37.97385486361297, 38.10879620195995, 38.24373754030692, 38.378678878653886, 38.513620217000856, 38.648561555347825, 38.783502893694795, 38.918444232041765, 39.05338557038874, 39.188326908735704, 39.32326824708268, 39.45820958542965, 39.59315092377662, 39.72809226212359, 39.86303360047056, 39.99797493881753, 40.1329162771645, 40.267857615511474, 40.40279895385844, 40.53774029220541, 40.67268163055238, 40.80762296889935, 40.94256430724632, 41.0775056455933, 41.21244698394026, 41.34738832228723, 41.48232966063421, 41.61727099898117, 41.752212337328146, 41.88715367567511, 42.022095014022085, 42.157036352369055, 42.291977690716024, 42.426919029062994, 42.56186036740996, 42.69680170575693, 42.8317430441039, 42.96668438245088, 43.10162572079784, 43.23656705914482, 43.37150839749179, 43.50644973583876, 43.64139107418573, 43.776332412532696, 43.911273750879666, 44.046215089226635, 44.18115642757361, 44.316097765920574, 44.45103910426755, 44.58598044261452, 44.72092178096149, 44.85586311930846, 44.99080445765543, 45.1257457960024, 45.26068713434937, 45.395628472696345, 45.53056981104331, 45.665511149390284, 45.80045248773725, 45.93539382608422, 46.07033516443119, 46.20527650277817, 46.34021784112513, 46.4751591794721, 46.61010051781908, 46.74504185616604, 46.87998319451302, 47.014924532859986, 47.149865871206956, 47.284807209553925, 47.4197485479009, 47.554689886247864, 47.689631224594834, 47.82457256294181, 47.95951390128877, 48.09445523963575, 48.22939657798272, 48.36433791632969, 48.49927925467666, 48.63422059302363, 48.7691619313706, 48.90410326971757, 49.039044608064536, 49.173985946411506, 49.30892728475848, 49.443868623105445, 49.57880996145242, 49.71375129979939, 49.84869263814636, 49.98363397649333, 50.11857531484031, 50.25351665318727, 50.38845799153424, 50.523399329881215, 50.65834066822818, 50.793282006575154, 50.928223344922124, 51.06316468326909, 51.19810602161606, 51.33304735996304, 51.46798869831, 51.60293003665697, 51.73787137500395, 51.87281271335091, 52.00775405169789, 52.14269539004486, 52.277636728391826, 52.412578066738796, 52.54751940508577, 52.682460743432735, 52.817402081779704, 52.95234342012668, 53.08728475847364, 53.22222609682062, 53.35716743516759, 53.49210877351456, 53.62705011186153, 53.761991450208505, 53.89693278855547, 54.03187412690244, 54.166815465249414, 54.301756803596376, 54.43669814194335, 54.57163948029032, 54.70658081863729, 54.84152215698426, 54.97646349533124, 55.1114048336782, 55.24634617202518, 55.38128751037215, 55.51622884871911, 55.651170187066086, 55.78611152541305, 55.921052863760025, 56.055994202106994, 56.190935540453964, 56.32587687880093, 56.46081821714791, 56.59575955549487, 56.73070089384184, 56.86564223218882, 57.00058357053578, 57.13552490888276, 57.27046624722973, 57.4054075855767, 57.540348923923666, 57.67529026227064, 57.810231600617605, 57.945172938964575, 58.08011427731155, 58.215055615658514, 58.34999695400549, 58.48493829235246, 58.61987963069943, 58.7548209690464, 58.889762307393376, 59.02470364574034, 59.159644984087315, 59.294586322434284, 59.42952766078125, 59.56446899912822, 59.69941033747519, 59.83435167582216, 59.96929301416913, 60.10423435251611, 60.23917569086307, 60.37411702921005, 60.50905836755702, 60.64399970590398, 60.778941044250956, 60.913882382597926, 61.048823720944895, 61.183765059291865, 61.31870639763884, 61.453647735985804, 61.58858907433278, 61.72353041267975, 61.85847175102671, 61.99341308937369, 62.12835442772066, 62.26329576606763, 62.3982371044146, 62.53317844276157, 62.66811978110854, 62.80306111945551, 62.938002457802476, 63.072943796149445, 63.20788513449642, 63.342826472843385, 63.47776781119036, 63.61270914953733, 63.7476504878843, 63.88259182623127, 64.01753316457824, 64.1524745029252, 64.28741584127218, 64.42235717961915, 64.55729851796612, 64.6922398563131, 64.82718119466006, 64.96212253300703, 65.097063871354, 65.23200520970097, 65.36694654804793, 65.50188788639491, 65.63682922474189, 65.77177056308885, 65.90671190143583, 66.04165323978279, 66.17659457812977, 66.31153591647673, 66.4464772548237, 66.58141859317067, 66.71635993151764, 66.85130126986462, 66.98624260821158, 67.12118394655856, 67.25612528490552, 67.3910666232525, 67.52600796159946, 67.66094929994644, 67.79589063829341, 67.93083197664038, 68.06577331498735, 68.20071465333432, 68.33565599168129, 68.47059733002827, 68.60553866837523, 68.74048000672221, 68.87542134506917, 69.01036268341615, 69.14530402176311, 69.28024536011009, 69.41518669845705, 69.55012803680401, 69.685069375151, 69.82001071349796, 69.95495205184493, 70.0898933901919, 70.22483472853888, 70.35977606688584, 70.49471740523282, 70.62965874357978, 70.76460008192676, 70.89954142027374], \"y\": [0.004061065040256531, 0.004413888978508207, 0.004789339808663863, 0.005187923334495055, 0.0056100331411973615, 0.00605593798092017, 0.006525770588188691, 0.007019518348559347, 0.00753701622583154, 0.008077942319898737, 0.008641816378981468, 0.009228001527295915, 0.009835709393563723, 0.010464008739172257, 0.011111837589830077, 0.011778018774303851, 0.01246127867172563, 0.013160268868727199, 0.013873590333089924, 0.014599819625412637, 0.015337536597965358, 0.016085352973448333, 0.016841941158262347, 0.01760606262682783, 0.018376595216336316, 0.01915255869502956, 0.01993313801068977, 0.02071770368758152, 0.021505828916862448, 0.02229730297401319, 0.023092140693118567, 0.023890587827517882, 0.02469312222499421, 0.025500450838992644, 0.026313502681453736, 0.02713341789444682, 0.027961533174442842, 0.028799363823310085, 0.02964858272354768, 0.030510996542605178, 0.03138851946413958, 0.03228314472548434, 0.03319691421397794, 0.03413188634424564, 0.0350901024084771, 0.03607355156666255, 0.037084134627838036, 0.038123626770297334, 0.039193639361299666, 0.04029558106684057, 0.04143061849019723, 0.04259963664352944, 0.04380319963784442, 0.045041512069855336, 0.04631438168527334, 0.04762118400147698, 0.0489608296721662, 0.05033173546592715, 0.051731799802854715, 0.05315838384191767, 0.054608299130533576, 0.05607780281160138, 0.05756260132789566, 0.059057863466529976, 0.06055824344600759, 0.06205791456582734, 0.06355061371615824, 0.06502969678708674, 0.06648820472951214, 0.06791893971075327, 0.06931455048663807, 0.07066762578878347, 0.0719707942122969, 0.07321682879707855, 0.07439875423712615, 0.07550995443815267, 0.0765442779849296, 0.0774961389851708, 0.07836061073378914, 0.07913350969506677, 0.07981146743328535, 0.08039198833446307, 0.08087349125003364, 0.08125533355161306, 0.08153781650574733, 0.08172217134742225, 0.08181052593765466, 0.08180585241836236, 0.08171189681037241, 0.08153309202061035, 0.08127445621489994, 0.0809414789566595, 0.08053999789357176, 0.08007606908029484, 0.07955583424406373, 0.07898538842295848, 0.07837065142815776, 0.07771724649946794, 0.07703038933907268, 0.0763147904264893, 0.07557457314614326, 0.07481320980881365, 0.07403347713321282, 0.07323743219009332, 0.07242640921622669, 0.07160103709818437, 0.07076127672537842, 0.06990647683748734, 0.06903544646157093, 0.06814654156587319, 0.0672377631654885, 0.06630686381221874, 0.06535145919656712, 0.06436914149008682, 0.06335759106386796, 0.06231468333273976, 0.06123858769006774, 0.0601278558065846, 0.05898149695700307, 0.05779903849587522, 0.05658057011261719, 0.05532677103644683, 0.054038919915825906, 0.052718887644250145, 0.051369113925798564, 0.049992568851931644, 0.04859270117976999, 0.04717337534824998, 0.04573879953199846, 0.044293447206817736, 0.04284197478234262, 0.04138913784744981, 0.039939708476718815, 0.03849839586932271, 0.03706977234571012, 0.035658206425225464, 0.03426780436396405, 0.03290236116223318, 0.0315653216708009, 0.030259752050017918, 0.028988321480134766, 0.02775329369726309, 0.02655652764784242, 0.02539948632307492, 0.02428325265878568, 0.02320855126801733, 0.02217577471315295, 0.02118501301880052, 0.02023608517122076, 0.019328571438135583, 0.018461845466386274, 0.017635105265368944, 0.016847402352337573, 0.01609766851251993, 0.015384739804037364, 0.01470737760721114, 0.014064286673472773, 0.013454130265585113, 0.01287554259447577, 0.012327138846377421, 0.011807523156263556, 0.011315294920143305, 0.010849053851136572, 0.010407404174806678, 0.009988958331086682, 0.009592340506864762, 0.009216190268693043, 0.008859166502987879, 0.008519951805177731, 0.008197257392918421, 0.007889828554717744, 0.0075964505865984055, 0.007315955117772504, 0.0070472266831716895, 0.006789209367043516, 0.006540913318192777, 0.006301420923915906, 0.0060698924259996795, 0.00584557076780063, 0.005627785475635947, 0.005415955399578189, 0.005209590167208704, 0.005008290237819089, 0.004811745482765651, 0.004619732258952654, 0.004432108985494354, 0.0042488102772232795, 0.004069839731607929, 0.0038952615065696284, 0.0037251908644240867, 0.0035597838905499874, 0.003399226623314702, 0.003243723853285893, 0.003093487863994801, 0.0029487273928415817, 0.002809637088716958, 0.0026763877323784015, 0.0025491174666662808, 0.0024279242566706766, 0.0023128597656595995, 0.002203924791940908, 0.002101066366108204, 0.0020041765588009928, 0.0019130929978565217, 0.0018276010423274515, 0.0017474375111151182, 0.001672295817720563, 0.0016018323215357814, 0.0015356736716917376, 0.0014734248930020205, 0.001414677945934707, 0.0013590204843982635, 0.001306044536645361, 0.0012553548455934743, 0.0012065766247619416, 0.001159362513903558, 0.0011133985530256984, 0.0010684090333588584, 0.0010241601272653162, 0.0009804622443093098, 0.0009371711059325876, 0.0008941875746540666, 0.0008514563138329411, 0.0008089633893953681, 0.0007667329543770098, 0.0007248231798244448, 0.0006833216109964241, 0.0006423401357080032, 0.0006020097521837605, 0.0005624753173443817, 0.0005238904437178537, 0.00048641269503058704, 0.0004501992080435803, 0.0004154028425066951, 0.00038216893340823667, 0.0003506326911868276, 0.00032091726737884085, 0.0002931324763277669, 0.00026737413897860566, 0.00024372399316037073, 0.00022225009669232977, 0.00020300763552952278, 0.00018604003921478878, 0.00017138030019374763, 0.00015905239199883844, 0.00014907268371896652, 0.00014145125424141268, 0.00013619301910119315, 0.00013329859495857116, 0.00013276484126351271, 0.0001345850350440157, 0.00013874865244358772, 0.0001452407490934611, 0.00015404095009655732, 0.00016512207878403493, 0.00017844847094905075, 0.00019397403744459663, 0.00021164015234829598, 0.00023137345586762636, 0.0002530836703405379, 0.00027666153368517644, 0.0003019769571395235, 0.0003288775128614308, 0.000357187351786534, 0.00038670664303883866, 0.0004172116132623349, 0.00044845524774174, 0.0004801686955064988, 0.0005120633983123962, 0.0005438339391581892, 0.0005751615806308962, 0.0006057184377910238, 0.0006351722054802845, 0.0006631913368565261, 0.000689450549611927, 0.0007136365196235169, 0.0007354536095210952, 0.0007546294724819934, 0.0007709203699282949, 0.0007841160459401385, 0.0007940440110973731, 0.0008005731038601201, 0.0008036162179920371, 0.0008031321091872811, 0.0007991262220572571, 0.0007916505088855917, 0.0007808022428844794, 0.0007667218598489521, 0.0007495898918840708, 0.0007296230841177507, 0.0007070698089755887, 0.0006822049118201197, 0.0006553241358898414, 0.0006267382830923024, 0.0005967672701383592, 0.0005657342368291118, 0.0005339598553378139, 0.0005017569765958483, 0.00046942573310343553, 0.00043724919749046594, 0.0004054896738906579, 0.00037438567564659377, 0.000344149619012473, 0.00031496623929375443, 0.0002869917140967621, 0.000260353458772355, 0.00023515054229610328, 0.00021145465814113645, 0.00018931157441137754, 0.00016874298069085336, 0.00014974864565601084, 0.00013230879928488424, 0.0001163866561602831, 0.00010193100149914537, 8.887876868351526e-05, 7.715754572673293e-05, 6.668795778227171e-05, 5.7385883011832395e-05, 4.916446943062413e-05, 4.193593035105279e-05, 3.5613105424349974e-05, 3.0110782775869593e-05, 2.5346785158092945e-05, 2.1242829289821303e-05, 1.7725172559526937e-05, 1.47250650515729e-05, 1.2179027460821895e-05, 1.0028976987214784e-05, 8.222223868701009e-06, 6.711360958162722e-06, 5.454067826578978e-06, 4.412849430495905e-06, 3.5547275610949367e-06, 2.8509012280304825e-06, 2.2763899421638006e-06, 1.809671648629874e-06, 1.4323249082523385e-06, 1.1286828956938805e-06, 8.855049238302605e-07, 6.916695464936667e-07, 5.378918526043765e-07, 4.16466348493636e-07, 3.2103582695293924e-07, 2.4638582887079993e-07, 1.8826369862341475e-07, 1.4322079669273577e-07, 1.0847613960286604e-07, 8.179956513047356e-08, 6.141244748653898e-08, 4.590399188604345e-08, 3.416120172412304e-08, 2.5310717881298547e-08, 1.8670864352976154e-08, 1.3712385739657255e-08, 1.0026520757316159e-08, 7.299214563892447e-09, 5.2904259559312025e-09, 3.817629590016872e-09, 2.7427458924163194e-09, 1.9618508902067147e-09, 1.3971243307170989e-09, 9.905872944769853e-10, 6.992606477306674e-10, 4.914440263015807e-10, 3.438726774164501e-10, 2.395575799972692e-10, 1.6615400029578973e-10, 1.1473616341600575e-10, 7.888210349929797e-11, 5.399397238671244e-11, 3.679600885692664e-11, 2.4965759780535885e-11, 1.686465647701201e-11, 1.1342240533667929e-11, 7.59466909380626e-12, 5.06299533216203e-12, 3.36043047892033e-12, 2.220604156223336e-12, 1.460954062346998e-12, 9.569561120730627e-13, 6.240793244661887e-13, 4.052152553369018e-13, 2.6196627339106577e-13, 1.6863924889955557e-13, 1.0812596062727209e-13, 6.909246898497551e-14, 4.407213068313844e-14, 2.817965324016544e-14, 1.8250513922283737e-14, 1.2271422669538055e-14, 9.010781902168653e-15, 7.788770029013387e-15, 8.348785435264685e-15, 1.0808556091887567e-14, 1.568259728070787e-14, 2.3979842981244692e-14, 3.739298801981403e-14, 5.861123194427245e-14, 9.180788843537391e-14, 1.4338145669664933e-13, 2.2306686352951489e-13, 3.455875717943426e-13, 5.33095792792719e-13, 8.187562637625731e-13, 1.2519813910303148e-12, 1.9060388683373703e-12, 2.889049863569262e-12, 4.359806906358641e-12, 6.550406063842535e-12, 9.798461079023034e-12, 1.4592717492343312e-11, 2.163730274057301e-11, 3.194175014664065e-11, 4.6946469015957937e-11, 6.869668746972345e-11, 1.0008230438481846e-10, 1.4516684368604232e-10, 2.0963616653755905e-10, 3.0140719977042593e-10, 4.3144920422037216e-10, 6.148856529771532e-10, 8.724643392321777e-10, 1.2325077170824826e-09, 1.7334856346102324e-09, 2.4273895851450593e-09, 3.384132501012366e-09, 4.6972521186143505e-09, 6.491260236510729e-09, 8.931055894710467e-09, 1.2233908605372807e-08, 1.6684618987820253e-08, 2.2654578831920058e-08, 3.062558049288616e-08, 4.1219365597544224e-08, 5.523405330977864e-08, 7.368874560518853e-08, 9.787776637158493e-08, 1.294361461311259e-07, 1.7041810618590504e-07, 2.233904141871005e-07, 2.91542564283386e-07, 3.7881576342592685e-07, 4.900526630207396e-07, 6.311696417104002e-07, 8.093531987266391e-07, 1.0332816350662432e-06, 1.3133726587368053e-06, 1.6620568287147696e-06, 2.094075831004372e-06, 2.6268034447645e-06, 3.280585698956659e-06, 4.079095141250868e-06, 5.04969235302578e-06, 6.223785872609035e-06, 7.637179574264069e-06, 9.330394350797272e-06, 1.13489487391608e-05, 1.3743581005709115e-05, 1.657039328316025e-05, 1.9890896753042463e-05, 2.3771935736134174e-05, 2.8285468037697128e-05, 3.3508179144210024e-05, 3.9520909027951444e-05, 4.6407872514455533e-05, 5.4255657510240266e-05, 6.315198994441792e-05, 7.318426007283131e-05, 8.443781179821848e-05, 9.699400478285368e-05, 0.00011092806821156569, 0.00012630677487171315, 0.0001431859744508427, 0.00016160803524434465, 0.0001815992533889584, 0.00020316729782486796, 0.00022629876694426273, 0.0002509569388094778, 0.00027707980044122514, 0.0003045784425577029, 0.0003333359039347361, 0.00036320654400373353, 0.0003940160132837142, 0.00042556187877661265, 0.00045761494572299396, 0.0004899212984656303, 0.0005222050621120998, 0.0005541718638894977, 0.0005855129493398443, 0.0006159098847134543, 0.000645039754042669, 0.0006725807384066953, 0.0006982179467900685, 0.0007216493535784192, 0.0007425916878904012, 0.0007607861152114439, 0.0007760035525695503, 0.0007880494649412836, 0.0007967680026167702, 0.0008020453565550446], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": [\"bill $16.99, tip $1.01\", \"bill $10.34, tip $1.66\", \"bill $21.01, tip $3.5\", \"bill $23.68, tip $3.31\", \"bill $24.59, tip $3.61\", \"bill $25.29, tip $4.71\", \"bill $8.77, tip $2.0\", \"bill $26.88, tip $3.12\", \"bill $15.04, tip $1.96\", \"bill $14.78, tip $3.23\", \"bill $10.27, tip $1.71\", \"bill $35.26, tip $5.0\", \"bill $15.42, tip $1.57\", \"bill $18.43, tip $3.0\", \"bill $14.83, tip $3.02\", \"bill $21.58, tip $3.92\", \"bill $10.33, tip $1.67\", \"bill $16.29, tip $3.71\", \"bill $16.97, tip $3.5\", \"bill $20.65, tip $3.35\", \"bill $17.92, tip $4.08\", \"bill $20.29, tip $2.75\", \"bill $15.77, tip $2.23\", \"bill $39.42, tip $7.58\", \"bill $19.82, tip $3.18\", \"bill $17.81, tip $2.34\", \"bill $13.37, tip $2.0\", \"bill $12.69, tip $2.0\", \"bill $21.7, tip $4.3\", \"bill $19.65, tip $3.0\", \"bill $9.55, tip $1.45\", \"bill $18.35, tip $2.5\", \"bill $15.06, tip $3.0\", \"bill $20.69, tip $2.45\", \"bill $17.78, tip $3.27\", \"bill $24.06, tip $3.6\", \"bill $16.31, tip $2.0\", \"bill $16.93, tip $3.07\", \"bill $18.69, tip $2.31\", \"bill $31.27, tip $5.0\", \"bill $16.04, tip $2.24\", \"bill $17.46, tip $2.54\", \"bill $13.94, tip $3.06\", \"bill $9.68, tip $1.32\", \"bill $30.4, tip $5.6\", \"bill $18.29, tip $3.0\", \"bill $22.23, tip $5.0\", \"bill $32.4, tip $6.0\", \"bill $28.55, tip $2.05\", \"bill $18.04, tip $3.0\", \"bill $12.54, tip $2.5\", \"bill $10.29, tip $2.6\", \"bill $34.81, tip $5.2\", \"bill $9.94, tip $1.56\", \"bill $25.56, tip $4.34\", \"bill $19.49, tip $3.51\", \"bill $38.01, tip $3.0\", \"bill $26.41, tip $1.5\", \"bill $11.24, tip $1.76\", \"bill $48.27, tip $6.73\", \"bill $20.29, tip $3.21\", \"bill $13.81, tip $2.0\", \"bill $11.02, tip $1.98\", \"bill $18.29, tip $3.76\", \"bill $17.59, tip $2.64\", \"bill $20.08, tip $3.15\", \"bill $16.45, tip $2.47\", \"bill $3.07, tip $1.0\", \"bill $20.23, tip $2.01\", \"bill $15.01, tip $2.09\", \"bill $12.02, tip $1.97\", \"bill $17.07, tip $3.0\", \"bill $26.86, tip $3.14\", \"bill $25.28, tip $5.0\", \"bill $14.73, tip $2.2\", \"bill $10.51, tip $1.25\", \"bill $17.92, tip $3.08\", \"bill $27.2, tip $4.0\", \"bill $22.76, tip $3.0\", \"bill $17.29, tip $2.71\", \"bill $19.44, tip $3.0\", \"bill $16.66, tip $3.4\", \"bill $10.07, tip $1.83\", \"bill $32.68, tip $5.0\", \"bill $15.98, tip $2.03\", \"bill $34.83, tip $5.17\", \"bill $13.03, tip $2.0\", \"bill $18.28, tip $4.0\", \"bill $24.71, tip $5.85\", \"bill $21.16, tip $3.0\", \"bill $28.97, tip $3.0\", \"bill $22.49, tip $3.5\", \"bill $5.75, tip $1.0\", \"bill $16.32, tip $4.3\", \"bill $22.75, tip $3.25\", \"bill $40.17, tip $4.73\", \"bill $27.28, tip $4.0\", \"bill $12.03, tip $1.5\", \"bill $21.01, tip $3.0\", \"bill $12.46, tip $1.5\", \"bill $11.35, tip $2.5\", \"bill $15.38, tip $3.0\", \"bill $44.3, tip $2.5\", \"bill $22.42, tip $3.48\", \"bill $20.92, tip $4.08\", \"bill $15.36, tip $1.64\", \"bill $20.49, tip $4.06\", \"bill $25.21, tip $4.29\", \"bill $18.24, tip $3.76\", \"bill $14.31, tip $4.0\", \"bill $14.0, tip $3.0\", \"bill $7.25, tip $1.0\", \"bill $38.07, tip $4.0\", \"bill $23.95, tip $2.55\", \"bill $25.71, tip $4.0\", \"bill $17.31, tip $3.5\", \"bill $29.93, tip $5.07\", \"bill $10.65, tip $1.5\", \"bill $12.43, tip $1.8\", \"bill $24.08, tip $2.92\", \"bill $11.69, tip $2.31\", \"bill $13.42, tip $1.68\", \"bill $14.26, tip $2.5\", \"bill $15.95, tip $2.0\", \"bill $12.48, tip $2.52\", \"bill $29.8, tip $4.2\", \"bill $8.52, tip $1.48\", \"bill $14.52, tip $2.0\", \"bill $11.38, tip $2.0\", \"bill $22.82, tip $2.18\", \"bill $19.08, tip $1.5\", \"bill $20.27, tip $2.83\", \"bill $11.17, tip $1.5\", \"bill $12.26, tip $2.0\", \"bill $18.26, tip $3.25\", \"bill $8.51, tip $1.25\", \"bill $10.33, tip $2.0\", \"bill $14.15, tip $2.0\", \"bill $16.0, tip $2.0\", \"bill $13.16, tip $2.75\", \"bill $17.47, tip $3.5\", \"bill $34.3, tip $6.7\", \"bill $41.19, tip $5.0\", \"bill $27.05, tip $5.0\", \"bill $16.43, tip $2.3\", \"bill $8.35, tip $1.5\", \"bill $18.64, tip $1.36\", \"bill $11.87, tip $1.63\", \"bill $9.78, tip $1.73\", \"bill $7.51, tip $2.0\", \"bill $14.07, tip $2.5\", \"bill $13.13, tip $2.0\", \"bill $17.26, tip $2.74\", \"bill $24.55, tip $2.0\", \"bill $19.77, tip $2.0\", \"bill $29.85, tip $5.14\", \"bill $48.17, tip $5.0\", \"bill $25.0, tip $3.75\", \"bill $13.39, tip $2.61\", \"bill $16.49, tip $2.0\", \"bill $21.5, tip $3.5\", \"bill $12.66, tip $2.5\", \"bill $16.21, tip $2.0\", \"bill $13.81, tip $2.0\", \"bill $17.51, tip $3.0\", \"bill $24.52, tip $3.48\", \"bill $20.76, tip $2.24\", \"bill $31.71, tip $4.5\", \"bill $10.59, tip $1.61\", \"bill $10.63, tip $2.0\", \"bill $50.81, tip $10.0\", \"bill $15.81, tip $3.16\", \"bill $7.25, tip $5.15\", \"bill $31.85, tip $3.18\", \"bill $16.82, tip $4.0\", \"bill $32.9, tip $3.11\", \"bill $17.89, tip $2.0\", \"bill $14.48, tip $2.0\", \"bill $9.6, tip $4.0\", \"bill $34.63, tip $3.55\", \"bill $34.65, tip $3.68\", \"bill $23.33, tip $5.65\", \"bill $45.35, tip $3.5\", \"bill $23.17, tip $6.5\", \"bill $40.55, tip $3.0\", \"bill $20.69, tip $5.0\", \"bill $20.9, tip $3.5\", \"bill $30.46, tip $2.0\", \"bill $18.15, tip $3.5\", \"bill $23.1, tip $4.0\", \"bill $15.69, tip $1.5\", \"bill $19.81, tip $4.19\", \"bill $28.44, tip $2.56\", \"bill $15.48, tip $2.02\", \"bill $16.58, tip $4.0\", \"bill $7.56, tip $1.44\", \"bill $10.34, tip $2.0\", \"bill $43.11, tip $5.0\", \"bill $13.0, tip $2.0\", \"bill $13.51, tip $2.0\", \"bill $18.71, tip $4.0\", \"bill $12.74, tip $2.01\", \"bill $13.0, tip $2.0\", \"bill $16.4, tip $2.5\", \"bill $20.53, tip $4.0\", \"bill $16.47, tip $3.23\", \"bill $26.59, tip $3.41\", \"bill $38.73, tip $3.0\", \"bill $24.27, tip $2.03\", \"bill $12.76, tip $2.23\", \"bill $30.06, tip $2.0\", \"bill $25.89, tip $5.16\", \"bill $48.33, tip $9.0\", \"bill $13.27, tip $2.5\", \"bill $28.17, tip $6.5\", \"bill $12.9, tip $1.1\", \"bill $28.15, tip $3.0\", \"bill $11.59, tip $1.5\", \"bill $7.74, tip $1.44\", \"bill $30.14, tip $3.09\", \"bill $12.16, tip $2.2\", \"bill $13.42, tip $3.48\", \"bill $8.58, tip $1.92\", \"bill $15.98, tip $3.0\", \"bill $13.42, tip $1.58\", \"bill $16.27, tip $2.5\", \"bill $10.09, tip $2.0\", \"bill $20.45, tip $3.0\", \"bill $13.28, tip $2.72\", \"bill $22.12, tip $2.88\", \"bill $24.01, tip $2.0\", \"bill $15.69, tip $3.0\", \"bill $11.61, tip $3.39\", \"bill $10.77, tip $1.47\", \"bill $15.53, tip $3.0\", \"bill $10.07, tip $1.25\", \"bill $12.6, tip $1.0\", \"bill $32.83, tip $1.17\", \"bill $35.83, tip $4.67\", \"bill $29.03, tip $5.92\", \"bill $27.18, tip $2.0\", \"bill $22.67, tip $2.0\", \"bill $17.82, tip $1.75\", \"bill $18.78, tip $3.0\"], \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<div id=\"3af46a68-c4de-417d-ad9a-241823ca9ff7\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"3af46a68-c4de-417d-ad9a-241823ca9ff7\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 71.0344827586207, \"size\": 1.0}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.698754923482517, 3.8336962618294876, 3.9686376001764576, 4.1035789385234285, 4.238520276870398, 4.373461615217368, 4.508402953564339, 4.643344291911309, 4.77828563025828, 4.913226968605249, 5.0481683069522205, 5.18310964529919, 5.3180509836461605, 5.452992321993131, 5.587933660340101, 5.722874998687072, 5.857816337034042, 5.992757675381013, 6.127699013727982, 6.2626403520749525, 6.397581690421923, 6.532523028768893, 6.667464367115864, 6.802405705462834, 6.937347043809805, 7.072288382156774, 7.2072297205037446, 7.342171058850715, 7.477112397197685, 7.612053735544656, 7.746995073891626, 7.881936412238597, 8.016877750585566, 8.151819088932537, 8.286760427279507, 8.421701765626477, 8.556643103973448, 8.69158444232042, 8.826525780667389, 8.961467119014358, 9.09640845736133, 9.231349795708299, 9.36629113405527, 9.50123247240224, 9.63617381074921, 9.77111514909618, 9.90605648744315, 10.040997825790122, 10.175939164137091, 10.31088050248406, 10.445821840831032, 10.580763179178003, 10.715704517524973, 10.850645855871942, 10.985587194218912, 11.120528532565885, 11.255469870912854, 11.390411209259824, 11.525352547606794, 11.660293885953765, 11.795235224300734, 11.930176562647706, 12.065117900994675, 12.200059239341646, 12.335000577688616, 12.469941916035586, 12.604883254382557, 12.739824592729528, 12.874765931076498, 13.009707269423467, 13.144648607770437, 13.279589946117408, 13.41453128446438, 13.549472622811349, 13.684413961158318, 13.81935529950529, 13.95429663785226, 14.08923797619923, 14.224179314546202, 14.35912065289317, 14.494061991240141, 14.629003329587112, 14.763944667934082, 14.898886006281051, 15.03382734462802, 15.168768682974992, 15.303710021321963, 15.438651359668933, 15.573592698015903, 15.708534036362874, 15.843475374709843, 15.978416713056815, 16.113358051403786, 16.248299389750755, 16.383240728097725, 16.518182066444695, 16.653123404791664, 16.788064743138637, 16.923006081485603, 17.057947419832576, 17.19288875817955, 17.32783009652652, 17.46277143487349, 17.597712773220458, 17.732654111567427, 17.867595449914397, 18.00253678826137, 18.137478126608336, 18.27241946495531, 18.40736080330228, 18.54230214164925, 18.67724347999622, 18.81218481834319, 18.94712615669016, 19.08206749503713, 19.2170088333841, 19.351950171731072, 19.486891510078042, 19.621832848425015, 19.756774186771985, 19.891715525118954, 20.026656863465924, 20.161598201812893, 20.296539540159863, 20.431480878506832, 20.566422216853802, 20.70136355520078, 20.836304893547748, 20.971246231894717, 21.106187570241687, 21.241128908588657, 21.376070246935626, 21.511011585282596, 21.645952923629565, 21.780894261976535, 21.91583560032351, 22.05077693867048, 22.18571827701745, 22.32065961536442, 22.45560095371139, 22.59054229205836, 22.72548363040533, 22.860424968752298, 22.995366307099268, 23.130307645446237, 23.265248983793214, 23.400190322140183, 23.535131660487153, 23.670072998834122, 23.805014337181092, 23.93995567552806, 24.07489701387503, 24.209838352222, 24.34477969056897, 24.479721028915947, 24.614662367262916, 24.749603705609886, 24.884545043956855, 25.019486382303825, 25.154427720650794, 25.289369058997764, 25.424310397344733, 25.559251735691703, 25.69419307403868, 25.82913441238565, 25.96407575073262, 26.099017089079588, 26.233958427426558, 26.368899765773527, 26.503841104120497, 26.638782442467466, 26.773723780814436, 26.908665119161405, 27.043606457508382, 27.17854779585535, 27.31348913420232, 27.44843047254929, 27.58337181089626, 27.71831314924323, 27.8532544875902, 27.98819582593717, 28.123137164284138, 28.258078502631115, 28.393019840978084, 28.527961179325054, 28.662902517672023, 28.797843856018993, 28.932785194365962, 29.067726532712932, 29.2026678710599, 29.33760920940687, 29.472550547753848, 29.607491886100817, 29.742433224447787, 29.877374562794756, 30.012315901141726, 30.147257239488695, 30.282198577835665, 30.417139916182634, 30.552081254529604, 30.687022592876573, 30.82196393122355, 30.95690526957052, 31.09184660791749, 31.22678794626446, 31.361729284611428, 31.496670622958398, 31.631611961305367, 31.766553299652337, 31.901494637999306, 32.03643597634628, 32.17137731469325, 32.30631865304022, 32.44125999138719, 32.57620132973416, 32.71114266808113, 32.8460840064281, 32.98102534477507, 33.11596668312204, 33.25090802146901, 33.385849359815985, 33.520790698162955, 33.655732036509924, 33.790673374856894, 33.92561471320386, 34.06055605155083, 34.1954973898978, 34.33043872824477, 34.46538006659174, 34.60032140493872, 34.73526274328569, 34.87020408163266, 35.00514541997963, 35.140086758326596, 35.275028096673566, 35.409969435020535, 35.544910773367505, 35.67985211171448, 35.81479345006145, 35.94973478840842, 36.08467612675539, 36.21961746510236, 36.35455880344933, 36.4895001417963, 36.624441480143275, 36.75938281849024, 36.894324156837214, 37.029265495184184, 37.16420683353115, 37.29914817187812, 37.43408951022509, 37.56903084857206, 37.70397218691903, 37.83891352526601, 37.97385486361297, 38.10879620195995, 38.24373754030692, 38.378678878653886, 38.513620217000856, 38.648561555347825, 38.783502893694795, 38.918444232041765, 39.05338557038874, 39.188326908735704, 39.32326824708268, 39.45820958542965, 39.59315092377662, 39.72809226212359, 39.86303360047056, 39.99797493881753, 40.1329162771645, 40.267857615511474, 40.40279895385844, 40.53774029220541, 40.67268163055238, 40.80762296889935, 40.94256430724632, 41.0775056455933, 41.21244698394026, 41.34738832228723, 41.48232966063421, 41.61727099898117, 41.752212337328146, 41.88715367567511, 42.022095014022085, 42.157036352369055, 42.291977690716024, 42.426919029062994, 42.56186036740996, 42.69680170575693, 42.8317430441039, 42.96668438245088, 43.10162572079784, 43.23656705914482, 43.37150839749179, 43.50644973583876, 43.64139107418573, 43.776332412532696, 43.911273750879666, 44.046215089226635, 44.18115642757361, 44.316097765920574, 44.45103910426755, 44.58598044261452, 44.72092178096149, 44.85586311930846, 44.99080445765543, 45.1257457960024, 45.26068713434937, 45.395628472696345, 45.53056981104331, 45.665511149390284, 45.80045248773725, 45.93539382608422, 46.07033516443119, 46.20527650277817, 46.34021784112513, 46.4751591794721, 46.61010051781908, 46.74504185616604, 46.87998319451302, 47.014924532859986, 47.149865871206956, 47.284807209553925, 47.4197485479009, 47.554689886247864, 47.689631224594834, 47.82457256294181, 47.95951390128877, 48.09445523963575, 48.22939657798272, 48.36433791632969, 48.49927925467666, 48.63422059302363, 48.7691619313706, 48.90410326971757, 49.039044608064536, 49.173985946411506, 49.30892728475848, 49.443868623105445, 49.57880996145242, 49.71375129979939, 49.84869263814636, 49.98363397649333, 50.11857531484031, 50.25351665318727, 50.38845799153424, 50.523399329881215, 50.65834066822818, 50.793282006575154, 50.928223344922124, 51.06316468326909, 51.19810602161606, 51.33304735996304, 51.46798869831, 51.60293003665697, 51.73787137500395, 51.87281271335091, 52.00775405169789, 52.14269539004486, 52.277636728391826, 52.412578066738796, 52.54751940508577, 52.682460743432735, 52.817402081779704, 52.95234342012668, 53.08728475847364, 53.22222609682062, 53.35716743516759, 53.49210877351456, 53.62705011186153, 53.761991450208505, 53.89693278855547, 54.03187412690244, 54.166815465249414, 54.301756803596376, 54.43669814194335, 54.57163948029032, 54.70658081863729, 54.84152215698426, 54.97646349533124, 55.1114048336782, 55.24634617202518, 55.38128751037215, 55.51622884871911, 55.651170187066086, 55.78611152541305, 55.921052863760025, 56.055994202106994, 56.190935540453964, 56.32587687880093, 56.46081821714791, 56.59575955549487, 56.73070089384184, 56.86564223218882, 57.00058357053578, 57.13552490888276, 57.27046624722973, 57.4054075855767, 57.540348923923666, 57.67529026227064, 57.810231600617605, 57.945172938964575, 58.08011427731155, 58.215055615658514, 58.34999695400549, 58.48493829235246, 58.61987963069943, 58.7548209690464, 58.889762307393376, 59.02470364574034, 59.159644984087315, 59.294586322434284, 59.42952766078125, 59.56446899912822, 59.69941033747519, 59.83435167582216, 59.96929301416913, 60.10423435251611, 60.23917569086307, 60.37411702921005, 60.50905836755702, 60.64399970590398, 60.778941044250956, 60.913882382597926, 61.048823720944895, 61.183765059291865, 61.31870639763884, 61.453647735985804, 61.58858907433278, 61.72353041267975, 61.85847175102671, 61.99341308937369, 62.12835442772066, 62.26329576606763, 62.3982371044146, 62.53317844276157, 62.66811978110854, 62.80306111945551, 62.938002457802476, 63.072943796149445, 63.20788513449642, 63.342826472843385, 63.47776781119036, 63.61270914953733, 63.7476504878843, 63.88259182623127, 64.01753316457824, 64.1524745029252, 64.28741584127218, 64.42235717961915, 64.55729851796612, 64.6922398563131, 64.82718119466006, 64.96212253300703, 65.097063871354, 65.23200520970097, 65.36694654804793, 65.50188788639491, 65.63682922474189, 65.77177056308885, 65.90671190143583, 66.04165323978279, 66.17659457812977, 66.31153591647673, 66.4464772548237, 66.58141859317067, 66.71635993151764, 66.85130126986462, 66.98624260821158, 67.12118394655856, 67.25612528490552, 67.3910666232525, 67.52600796159946, 67.66094929994644, 67.79589063829341, 67.93083197664038, 68.06577331498735, 68.20071465333432, 68.33565599168129, 68.47059733002827, 68.60553866837523, 68.74048000672221, 68.87542134506917, 69.01036268341615, 69.14530402176311, 69.28024536011009, 69.41518669845705, 69.55012803680401, 69.685069375151, 69.82001071349796, 69.95495205184493, 70.0898933901919, 70.22483472853888, 70.35977606688584, 70.49471740523282, 70.62965874357978, 70.76460008192676, 70.89954142027374], \"y\": [0.004061065040256531, 0.004413888978508207, 0.004789339808663863, 0.005187923334495055, 0.0056100331411973615, 0.00605593798092017, 0.006525770588188691, 0.007019518348559347, 0.00753701622583154, 0.008077942319898737, 0.008641816378981468, 0.009228001527295915, 0.009835709393563723, 0.010464008739172257, 0.011111837589830077, 0.011778018774303851, 0.01246127867172563, 0.013160268868727199, 0.013873590333089924, 0.014599819625412637, 0.015337536597965358, 0.016085352973448333, 0.016841941158262347, 0.01760606262682783, 0.018376595216336316, 0.01915255869502956, 0.01993313801068977, 0.02071770368758152, 0.021505828916862448, 0.02229730297401319, 0.023092140693118567, 0.023890587827517882, 0.02469312222499421, 0.025500450838992644, 0.026313502681453736, 0.02713341789444682, 0.027961533174442842, 0.028799363823310085, 0.02964858272354768, 0.030510996542605178, 0.03138851946413958, 0.03228314472548434, 0.03319691421397794, 0.03413188634424564, 0.0350901024084771, 0.03607355156666255, 0.037084134627838036, 0.038123626770297334, 0.039193639361299666, 0.04029558106684057, 0.04143061849019723, 0.04259963664352944, 0.04380319963784442, 0.045041512069855336, 0.04631438168527334, 0.04762118400147698, 0.0489608296721662, 0.05033173546592715, 0.051731799802854715, 0.05315838384191767, 0.054608299130533576, 0.05607780281160138, 0.05756260132789566, 0.059057863466529976, 0.06055824344600759, 0.06205791456582734, 0.06355061371615824, 0.06502969678708674, 0.06648820472951214, 0.06791893971075327, 0.06931455048663807, 0.07066762578878347, 0.0719707942122969, 0.07321682879707855, 0.07439875423712615, 0.07550995443815267, 0.0765442779849296, 0.0774961389851708, 0.07836061073378914, 0.07913350969506677, 0.07981146743328535, 0.08039198833446307, 0.08087349125003364, 0.08125533355161306, 0.08153781650574733, 0.08172217134742225, 0.08181052593765466, 0.08180585241836236, 0.08171189681037241, 0.08153309202061035, 0.08127445621489994, 0.0809414789566595, 0.08053999789357176, 0.08007606908029484, 0.07955583424406373, 0.07898538842295848, 0.07837065142815776, 0.07771724649946794, 0.07703038933907268, 0.0763147904264893, 0.07557457314614326, 0.07481320980881365, 0.07403347713321282, 0.07323743219009332, 0.07242640921622669, 0.07160103709818437, 0.07076127672537842, 0.06990647683748734, 0.06903544646157093, 0.06814654156587319, 0.0672377631654885, 0.06630686381221874, 0.06535145919656712, 0.06436914149008682, 0.06335759106386796, 0.06231468333273976, 0.06123858769006774, 0.0601278558065846, 0.05898149695700307, 0.05779903849587522, 0.05658057011261719, 0.05532677103644683, 0.054038919915825906, 0.052718887644250145, 0.051369113925798564, 0.049992568851931644, 0.04859270117976999, 0.04717337534824998, 0.04573879953199846, 0.044293447206817736, 0.04284197478234262, 0.04138913784744981, 0.039939708476718815, 0.03849839586932271, 0.03706977234571012, 0.035658206425225464, 0.03426780436396405, 0.03290236116223318, 0.0315653216708009, 0.030259752050017918, 0.028988321480134766, 0.02775329369726309, 0.02655652764784242, 0.02539948632307492, 0.02428325265878568, 0.02320855126801733, 0.02217577471315295, 0.02118501301880052, 0.02023608517122076, 0.019328571438135583, 0.018461845466386274, 0.017635105265368944, 0.016847402352337573, 0.01609766851251993, 0.015384739804037364, 0.01470737760721114, 0.014064286673472773, 0.013454130265585113, 0.01287554259447577, 0.012327138846377421, 0.011807523156263556, 0.011315294920143305, 0.010849053851136572, 0.010407404174806678, 0.009988958331086682, 0.009592340506864762, 0.009216190268693043, 0.008859166502987879, 0.008519951805177731, 0.008197257392918421, 0.007889828554717744, 0.0075964505865984055, 0.007315955117772504, 0.0070472266831716895, 0.006789209367043516, 0.006540913318192777, 0.006301420923915906, 0.0060698924259996795, 0.00584557076780063, 0.005627785475635947, 0.005415955399578189, 0.005209590167208704, 0.005008290237819089, 0.004811745482765651, 0.004619732258952654, 0.004432108985494354, 0.0042488102772232795, 0.004069839731607929, 0.0038952615065696284, 0.0037251908644240867, 0.0035597838905499874, 0.003399226623314702, 0.003243723853285893, 0.003093487863994801, 0.0029487273928415817, 0.002809637088716958, 0.0026763877323784015, 0.0025491174666662808, 0.0024279242566706766, 0.0023128597656595995, 0.002203924791940908, 0.002101066366108204, 0.0020041765588009928, 0.0019130929978565217, 0.0018276010423274515, 0.0017474375111151182, 0.001672295817720563, 0.0016018323215357814, 0.0015356736716917376, 0.0014734248930020205, 0.001414677945934707, 0.0013590204843982635, 0.001306044536645361, 0.0012553548455934743, 0.0012065766247619416, 0.001159362513903558, 0.0011133985530256984, 0.0010684090333588584, 0.0010241601272653162, 0.0009804622443093098, 0.0009371711059325876, 0.0008941875746540666, 0.0008514563138329411, 0.0008089633893953681, 0.0007667329543770098, 0.0007248231798244448, 0.0006833216109964241, 0.0006423401357080032, 0.0006020097521837605, 0.0005624753173443817, 0.0005238904437178537, 0.00048641269503058704, 0.0004501992080435803, 0.0004154028425066951, 0.00038216893340823667, 0.0003506326911868276, 0.00032091726737884085, 0.0002931324763277669, 0.00026737413897860566, 0.00024372399316037073, 0.00022225009669232977, 0.00020300763552952278, 0.00018604003921478878, 0.00017138030019374763, 0.00015905239199883844, 0.00014907268371896652, 0.00014145125424141268, 0.00013619301910119315, 0.00013329859495857116, 0.00013276484126351271, 0.0001345850350440157, 0.00013874865244358772, 0.0001452407490934611, 0.00015404095009655732, 0.00016512207878403493, 0.00017844847094905075, 0.00019397403744459663, 0.00021164015234829598, 0.00023137345586762636, 0.0002530836703405379, 0.00027666153368517644, 0.0003019769571395235, 0.0003288775128614308, 0.000357187351786534, 0.00038670664303883866, 0.0004172116132623349, 0.00044845524774174, 0.0004801686955064988, 0.0005120633983123962, 0.0005438339391581892, 0.0005751615806308962, 0.0006057184377910238, 0.0006351722054802845, 0.0006631913368565261, 0.000689450549611927, 0.0007136365196235169, 0.0007354536095210952, 0.0007546294724819934, 0.0007709203699282949, 0.0007841160459401385, 0.0007940440110973731, 0.0008005731038601201, 0.0008036162179920371, 0.0008031321091872811, 0.0007991262220572571, 0.0007916505088855917, 0.0007808022428844794, 0.0007667218598489521, 0.0007495898918840708, 0.0007296230841177507, 0.0007070698089755887, 0.0006822049118201197, 0.0006553241358898414, 0.0006267382830923024, 0.0005967672701383592, 0.0005657342368291118, 0.0005339598553378139, 0.0005017569765958483, 0.00046942573310343553, 0.00043724919749046594, 0.0004054896738906579, 0.00037438567564659377, 0.000344149619012473, 0.00031496623929375443, 0.0002869917140967621, 0.000260353458772355, 0.00023515054229610328, 0.00021145465814113645, 0.00018931157441137754, 0.00016874298069085336, 0.00014974864565601084, 0.00013230879928488424, 0.0001163866561602831, 0.00010193100149914537, 8.887876868351526e-05, 7.715754572673293e-05, 6.668795778227171e-05, 5.7385883011832395e-05, 4.916446943062413e-05, 4.193593035105279e-05, 3.5613105424349974e-05, 3.0110782775869593e-05, 2.5346785158092945e-05, 2.1242829289821303e-05, 1.7725172559526937e-05, 1.47250650515729e-05, 1.2179027460821895e-05, 1.0028976987214784e-05, 8.222223868701009e-06, 6.711360958162722e-06, 5.454067826578978e-06, 4.412849430495905e-06, 3.5547275610949367e-06, 2.8509012280304825e-06, 2.2763899421638006e-06, 1.809671648629874e-06, 1.4323249082523385e-06, 1.1286828956938805e-06, 8.855049238302605e-07, 6.916695464936667e-07, 5.378918526043765e-07, 4.16466348493636e-07, 3.2103582695293924e-07, 2.4638582887079993e-07, 1.8826369862341475e-07, 1.4322079669273577e-07, 1.0847613960286604e-07, 8.179956513047356e-08, 6.141244748653898e-08, 4.590399188604345e-08, 3.416120172412304e-08, 2.5310717881298547e-08, 1.8670864352976154e-08, 1.3712385739657255e-08, 1.0026520757316159e-08, 7.299214563892447e-09, 5.2904259559312025e-09, 3.817629590016872e-09, 2.7427458924163194e-09, 1.9618508902067147e-09, 1.3971243307170989e-09, 9.905872944769853e-10, 6.992606477306674e-10, 4.914440263015807e-10, 3.438726774164501e-10, 2.395575799972692e-10, 1.6615400029578973e-10, 1.1473616341600575e-10, 7.888210349929797e-11, 5.399397238671244e-11, 3.679600885692664e-11, 2.4965759780535885e-11, 1.686465647701201e-11, 1.1342240533667929e-11, 7.59466909380626e-12, 5.06299533216203e-12, 3.36043047892033e-12, 2.220604156223336e-12, 1.460954062346998e-12, 9.569561120730627e-13, 6.240793244661887e-13, 4.052152553369018e-13, 2.6196627339106577e-13, 1.6863924889955557e-13, 1.0812596062727209e-13, 6.909246898497551e-14, 4.407213068313844e-14, 2.817965324016544e-14, 1.8250513922283737e-14, 1.2271422669538055e-14, 9.010781902168653e-15, 7.788770029013387e-15, 8.348785435264685e-15, 1.0808556091887567e-14, 1.568259728070787e-14, 2.3979842981244692e-14, 3.739298801981403e-14, 5.861123194427245e-14, 9.180788843537391e-14, 1.4338145669664933e-13, 2.2306686352951489e-13, 3.455875717943426e-13, 5.33095792792719e-13, 8.187562637625731e-13, 1.2519813910303148e-12, 1.9060388683373703e-12, 2.889049863569262e-12, 4.359806906358641e-12, 6.550406063842535e-12, 9.798461079023034e-12, 1.4592717492343312e-11, 2.163730274057301e-11, 3.194175014664065e-11, 4.6946469015957937e-11, 6.869668746972345e-11, 1.0008230438481846e-10, 1.4516684368604232e-10, 2.0963616653755905e-10, 3.0140719977042593e-10, 4.3144920422037216e-10, 6.148856529771532e-10, 8.724643392321777e-10, 1.2325077170824826e-09, 1.7334856346102324e-09, 2.4273895851450593e-09, 3.384132501012366e-09, 4.6972521186143505e-09, 6.491260236510729e-09, 8.931055894710467e-09, 1.2233908605372807e-08, 1.6684618987820253e-08, 2.2654578831920058e-08, 3.062558049288616e-08, 4.1219365597544224e-08, 5.523405330977864e-08, 7.368874560518853e-08, 9.787776637158493e-08, 1.294361461311259e-07, 1.7041810618590504e-07, 2.233904141871005e-07, 2.91542564283386e-07, 3.7881576342592685e-07, 4.900526630207396e-07, 6.311696417104002e-07, 8.093531987266391e-07, 1.0332816350662432e-06, 1.3133726587368053e-06, 1.6620568287147696e-06, 2.094075831004372e-06, 2.6268034447645e-06, 3.280585698956659e-06, 4.079095141250868e-06, 5.04969235302578e-06, 6.223785872609035e-06, 7.637179574264069e-06, 9.330394350797272e-06, 1.13489487391608e-05, 1.3743581005709115e-05, 1.657039328316025e-05, 1.9890896753042463e-05, 2.3771935736134174e-05, 2.8285468037697128e-05, 3.3508179144210024e-05, 3.9520909027951444e-05, 4.6407872514455533e-05, 5.4255657510240266e-05, 6.315198994441792e-05, 7.318426007283131e-05, 8.443781179821848e-05, 9.699400478285368e-05, 0.00011092806821156569, 0.00012630677487171315, 0.0001431859744508427, 0.00016160803524434465, 0.0001815992533889584, 0.00020316729782486796, 0.00022629876694426273, 0.0002509569388094778, 0.00027707980044122514, 0.0003045784425577029, 0.0003333359039347361, 0.00036320654400373353, 0.0003940160132837142, 0.00042556187877661265, 0.00045761494572299396, 0.0004899212984656303, 0.0005222050621120998, 0.0005541718638894977, 0.0005855129493398443, 0.0006159098847134543, 0.000645039754042669, 0.0006725807384066953, 0.0006982179467900685, 0.0007216493535784192, 0.0007425916878904012, 0.0007607861152114439, 0.0007760035525695503, 0.0007880494649412836, 0.0007967680026167702, 0.0008020453565550446], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": [\"bill $16.99, tip $1.01\", \"bill $10.34, tip $1.66\", \"bill $21.01, tip $3.5\", \"bill $23.68, tip $3.31\", \"bill $24.59, tip $3.61\", \"bill $25.29, tip $4.71\", \"bill $8.77, tip $2.0\", \"bill $26.88, tip $3.12\", \"bill $15.04, tip $1.96\", \"bill $14.78, tip $3.23\", \"bill $10.27, tip $1.71\", \"bill $35.26, tip $5.0\", \"bill $15.42, tip $1.57\", \"bill $18.43, tip $3.0\", \"bill $14.83, tip $3.02\", \"bill $21.58, tip $3.92\", \"bill $10.33, tip $1.67\", \"bill $16.29, tip $3.71\", \"bill $16.97, tip $3.5\", \"bill $20.65, tip $3.35\", \"bill $17.92, tip $4.08\", \"bill $20.29, tip $2.75\", \"bill $15.77, tip $2.23\", \"bill $39.42, tip $7.58\", \"bill $19.82, tip $3.18\", \"bill $17.81, tip $2.34\", \"bill $13.37, tip $2.0\", \"bill $12.69, tip $2.0\", \"bill $21.7, tip $4.3\", \"bill $19.65, tip $3.0\", \"bill $9.55, tip $1.45\", \"bill $18.35, tip $2.5\", \"bill $15.06, tip $3.0\", \"bill $20.69, tip $2.45\", \"bill $17.78, tip $3.27\", \"bill $24.06, tip $3.6\", \"bill $16.31, tip $2.0\", \"bill $16.93, tip $3.07\", \"bill $18.69, tip $2.31\", \"bill $31.27, tip $5.0\", \"bill $16.04, tip $2.24\", \"bill $17.46, tip $2.54\", \"bill $13.94, tip $3.06\", \"bill $9.68, tip $1.32\", \"bill $30.4, tip $5.6\", \"bill $18.29, tip $3.0\", \"bill $22.23, tip $5.0\", \"bill $32.4, tip $6.0\", \"bill $28.55, tip $2.05\", \"bill $18.04, tip $3.0\", \"bill $12.54, tip $2.5\", \"bill $10.29, tip $2.6\", \"bill $34.81, tip $5.2\", \"bill $9.94, tip $1.56\", \"bill $25.56, tip $4.34\", \"bill $19.49, tip $3.51\", \"bill $38.01, tip $3.0\", \"bill $26.41, tip $1.5\", \"bill $11.24, tip $1.76\", \"bill $48.27, tip $6.73\", \"bill $20.29, tip $3.21\", \"bill $13.81, tip $2.0\", \"bill $11.02, tip $1.98\", \"bill $18.29, tip $3.76\", \"bill $17.59, tip $2.64\", \"bill $20.08, tip $3.15\", \"bill $16.45, tip $2.47\", \"bill $3.07, tip $1.0\", \"bill $20.23, tip $2.01\", \"bill $15.01, tip $2.09\", \"bill $12.02, tip $1.97\", \"bill $17.07, tip $3.0\", \"bill $26.86, tip $3.14\", \"bill $25.28, tip $5.0\", \"bill $14.73, tip $2.2\", \"bill $10.51, tip $1.25\", \"bill $17.92, tip $3.08\", \"bill $27.2, tip $4.0\", \"bill $22.76, tip $3.0\", \"bill $17.29, tip $2.71\", \"bill $19.44, tip $3.0\", \"bill $16.66, tip $3.4\", \"bill $10.07, tip $1.83\", \"bill $32.68, tip $5.0\", \"bill $15.98, tip $2.03\", \"bill $34.83, tip $5.17\", \"bill $13.03, tip $2.0\", \"bill $18.28, tip $4.0\", \"bill $24.71, tip $5.85\", \"bill $21.16, tip $3.0\", \"bill $28.97, tip $3.0\", \"bill $22.49, tip $3.5\", \"bill $5.75, tip $1.0\", \"bill $16.32, tip $4.3\", \"bill $22.75, tip $3.25\", \"bill $40.17, tip $4.73\", \"bill $27.28, tip $4.0\", \"bill $12.03, tip $1.5\", \"bill $21.01, tip $3.0\", \"bill $12.46, tip $1.5\", \"bill $11.35, tip $2.5\", \"bill $15.38, tip $3.0\", \"bill $44.3, tip $2.5\", \"bill $22.42, tip $3.48\", \"bill $20.92, tip $4.08\", \"bill $15.36, tip $1.64\", \"bill $20.49, tip $4.06\", \"bill $25.21, tip $4.29\", \"bill $18.24, tip $3.76\", \"bill $14.31, tip $4.0\", \"bill $14.0, tip $3.0\", \"bill $7.25, tip $1.0\", \"bill $38.07, tip $4.0\", \"bill $23.95, tip $2.55\", \"bill $25.71, tip $4.0\", \"bill $17.31, tip $3.5\", \"bill $29.93, tip $5.07\", \"bill $10.65, tip $1.5\", \"bill $12.43, tip $1.8\", \"bill $24.08, tip $2.92\", \"bill $11.69, tip $2.31\", \"bill $13.42, tip $1.68\", \"bill $14.26, tip $2.5\", \"bill $15.95, tip $2.0\", \"bill $12.48, tip $2.52\", \"bill $29.8, tip $4.2\", \"bill $8.52, tip $1.48\", \"bill $14.52, tip $2.0\", \"bill $11.38, tip $2.0\", \"bill $22.82, tip $2.18\", \"bill $19.08, tip $1.5\", \"bill $20.27, tip $2.83\", \"bill $11.17, tip $1.5\", \"bill $12.26, tip $2.0\", \"bill $18.26, tip $3.25\", \"bill $8.51, tip $1.25\", \"bill $10.33, tip $2.0\", \"bill $14.15, tip $2.0\", \"bill $16.0, tip $2.0\", \"bill $13.16, tip $2.75\", \"bill $17.47, tip $3.5\", \"bill $34.3, tip $6.7\", \"bill $41.19, tip $5.0\", \"bill $27.05, tip $5.0\", \"bill $16.43, tip $2.3\", \"bill $8.35, tip $1.5\", \"bill $18.64, tip $1.36\", \"bill $11.87, tip $1.63\", \"bill $9.78, tip $1.73\", \"bill $7.51, tip $2.0\", \"bill $14.07, tip $2.5\", \"bill $13.13, tip $2.0\", \"bill $17.26, tip $2.74\", \"bill $24.55, tip $2.0\", \"bill $19.77, tip $2.0\", \"bill $29.85, tip $5.14\", \"bill $48.17, tip $5.0\", \"bill $25.0, tip $3.75\", \"bill $13.39, tip $2.61\", \"bill $16.49, tip $2.0\", \"bill $21.5, tip $3.5\", \"bill $12.66, tip $2.5\", \"bill $16.21, tip $2.0\", \"bill $13.81, tip $2.0\", \"bill $17.51, tip $3.0\", \"bill $24.52, tip $3.48\", \"bill $20.76, tip $2.24\", \"bill $31.71, tip $4.5\", \"bill $10.59, tip $1.61\", \"bill $10.63, tip $2.0\", \"bill $50.81, tip $10.0\", \"bill $15.81, tip $3.16\", \"bill $7.25, tip $5.15\", \"bill $31.85, tip $3.18\", \"bill $16.82, tip $4.0\", \"bill $32.9, tip $3.11\", \"bill $17.89, tip $2.0\", \"bill $14.48, tip $2.0\", \"bill $9.6, tip $4.0\", \"bill $34.63, tip $3.55\", \"bill $34.65, tip $3.68\", \"bill $23.33, tip $5.65\", \"bill $45.35, tip $3.5\", \"bill $23.17, tip $6.5\", \"bill $40.55, tip $3.0\", \"bill $20.69, tip $5.0\", \"bill $20.9, tip $3.5\", \"bill $30.46, tip $2.0\", \"bill $18.15, tip $3.5\", \"bill $23.1, tip $4.0\", \"bill $15.69, tip $1.5\", \"bill $19.81, tip $4.19\", \"bill $28.44, tip $2.56\", \"bill $15.48, tip $2.02\", \"bill $16.58, tip $4.0\", \"bill $7.56, tip $1.44\", \"bill $10.34, tip $2.0\", \"bill $43.11, tip $5.0\", \"bill $13.0, tip $2.0\", \"bill $13.51, tip $2.0\", \"bill $18.71, tip $4.0\", \"bill $12.74, tip $2.01\", \"bill $13.0, tip $2.0\", \"bill $16.4, tip $2.5\", \"bill $20.53, tip $4.0\", \"bill $16.47, tip $3.23\", \"bill $26.59, tip $3.41\", \"bill $38.73, tip $3.0\", \"bill $24.27, tip $2.03\", \"bill $12.76, tip $2.23\", \"bill $30.06, tip $2.0\", \"bill $25.89, tip $5.16\", \"bill $48.33, tip $9.0\", \"bill $13.27, tip $2.5\", \"bill $28.17, tip $6.5\", \"bill $12.9, tip $1.1\", \"bill $28.15, tip $3.0\", \"bill $11.59, tip $1.5\", \"bill $7.74, tip $1.44\", \"bill $30.14, tip $3.09\", \"bill $12.16, tip $2.2\", \"bill $13.42, tip $3.48\", \"bill $8.58, tip $1.92\", \"bill $15.98, tip $3.0\", \"bill $13.42, tip $1.58\", \"bill $16.27, tip $2.5\", \"bill $10.09, tip $2.0\", \"bill $20.45, tip $3.0\", \"bill $13.28, tip $2.72\", \"bill $22.12, tip $2.88\", \"bill $24.01, tip $2.0\", \"bill $15.69, tip $3.0\", \"bill $11.61, tip $3.39\", \"bill $10.77, tip $1.47\", \"bill $15.53, tip $3.0\", \"bill $10.07, tip $1.25\", \"bill $12.6, tip $1.0\", \"bill $32.83, tip $1.17\", \"bill $35.83, tip $4.67\", \"bill $29.03, tip $5.92\", \"bill $27.18, tip $2.0\", \"bill $22.67, tip $2.0\", \"bill $17.82, tip $1.75\", \"bill $18.78, tip $3.0\"], \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "text = [\"bill $\" + str(bill) + \", tip $\" + str(tip) for \n",
    "        (bill,tip) in data[['total_bill', 'tip']].itertuples(index=False)]\n",
    "py.iplot(ff.create_distplot([data['pcttip']], group_labels=[\"Percent Tip\"], \n",
    "                            rug_text=[text]))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "We can try to remove the outliers to get a better picture."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYAAAAEOCAYAAACAfcAXAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f3a9358>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "pcttips = data['pcttip']\n",
    "# Removing data points that are greater than the 99% quantile\n",
    "sns.distplot(pcttips[pcttips < pcttips.quantile(0.99)], rug=True)\n",
    "plt.xlabel(\"Percent Tip\")\n",
    "plt.savefig(\"percent_tip.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "data": [
        {
         "autobinx": false,
         "histnorm": "probability density",
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "name": "Percent Tip",
         "opacity": 0.7,
         "type": "histogram",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "xbins": {
          "end": 29.198966408268735,
          "size": 0.5,
          "start": 3.563813585135547
         },
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "mode": "lines",
         "name": "Percent Tip",
         "showlegend": false,
         "type": "scatter",
         "x": [
          3.563813585135547,
          3.615083890781813,
          3.6663541964280797,
          3.717624502074346,
          3.768894807720612,
          3.820165113366879,
          3.871435419013145,
          3.9227057246594113,
          3.973976030305678,
          4.025246335951945,
          4.076516641598211,
          4.127786947244477,
          4.179057252890743,
          4.2303275585370095,
          4.281597864183276,
          4.332868169829543,
          4.384138475475809,
          4.435408781122075,
          4.4866790867683415,
          4.537949392414608,
          4.589219698060875,
          4.640490003707141,
          4.691760309353407,
          4.7430306149996735,
          4.79430092064594,
          4.845571226292206,
          4.896841531938473,
          4.948111837584739,
          4.9993821432310055,
          5.050652448877272,
          5.101922754523538,
          5.153193060169804,
          5.204463365816071,
          5.2557336714623375,
          5.307003977108604,
          5.35827428275487,
          5.409544588401136,
          5.460814894047402,
          5.512085199693669,
          5.563355505339936,
          5.614625810986202,
          5.665896116632468,
          5.717166422278735,
          5.7684367279250015,
          5.819707033571268,
          5.870977339217534,
          5.9222476448638,
          5.973517950510066,
          6.024788256156333,
          6.076058561802599,
          6.127328867448866,
          6.178599173095132,
          6.229869478741399,
          6.281139784387665,
          6.332410090033932,
          6.383680395680198,
          6.434950701326464,
          6.48622100697273,
          6.537491312618997,
          6.588761618265263,
          6.640031923911529,
          6.691302229557796,
          6.7425725352040615,
          6.793842840850329,
          6.845113146496596,
          6.896383452142862,
          6.947653757789128,
          6.998924063435394,
          7.050194369081661,
          7.101464674727927,
          7.152734980374193,
          7.204005286020459,
          7.2552755916667255,
          7.306545897312993,
          7.357816202959259,
          7.409086508605526,
          7.460356814251791,
          7.511627119898058,
          7.562897425544325,
          7.614167731190591,
          7.665438036836857,
          7.716708342483124,
          7.7679786481293895,
          7.819248953775656,
          7.870519259421923,
          7.921789565068189,
          7.973059870714456,
          8.02433017636072,
          8.075600482006987,
          8.126870787653255,
          8.178141093299521,
          8.229411398945787,
          8.280681704592054,
          8.33195201023832,
          8.383222315884588,
          8.434492621530854,
          8.48576292717712,
          8.537033232823386,
          8.588303538469653,
          8.639573844115919,
          8.690844149762185,
          8.742114455408451,
          8.793384761054718,
          8.844655066700984,
          8.89592537234725,
          8.947195677993516,
          8.998465983639782,
          9.049736289286049,
          9.101006594932315,
          9.152276900578583,
          9.203547206224847,
          9.254817511871114,
          9.306087817517382,
          9.357358123163648,
          9.408628428809916,
          9.45989873445618,
          9.511169040102446,
          9.562439345748714,
          9.61370965139498,
          9.664979957041245,
          9.716250262687513,
          9.76752056833378,
          9.818790873980046,
          9.870061179626312,
          9.921331485272578,
          9.972601790918844,
          10.02387209656511,
          10.075142402211377,
          10.126412707857643,
          10.17768301350391,
          10.228953319150175,
          10.280223624796442,
          10.33149393044271,
          10.382764236088974,
          10.43403454173524,
          10.485304847381508,
          10.536575153027774,
          10.587845458674042,
          10.639115764320307,
          10.690386069966573,
          10.741656375612841,
          10.792926681259107,
          10.844196986905374,
          10.89546729255164,
          10.946737598197906,
          10.998007903844172,
          11.049278209490438,
          11.100548515136705,
          11.151818820782971,
          11.203089126429237,
          11.254359432075503,
          11.30562973772177,
          11.356900043368036,
          11.408170349014302,
          11.459440654660568,
          11.510710960306836,
          11.561981265953102,
          11.613251571599369,
          11.664521877245635,
          11.715792182891901,
          11.767062488538167,
          11.818332794184434,
          11.869603099830702,
          11.920873405476966,
          11.972143711123232,
          12.0234140167695,
          12.074684322415765,
          12.125954628062033,
          12.177224933708299,
          12.228495239354565,
          12.279765545000831,
          12.331035850647098,
          12.382306156293366,
          12.43357646193963,
          12.484846767585896,
          12.536117073232164,
          12.587387378878429,
          12.638657684524697,
          12.689927990170963,
          12.741198295817227,
          12.792468601463495,
          12.843738907109762,
          12.895009212756028,
          12.946279518402294,
          12.99754982404856,
          13.048820129694828,
          13.100090435341093,
          13.151360740987359,
          13.202631046633627,
          13.253901352279891,
          13.30517165792616,
          13.356441963572426,
          13.407712269218692,
          13.458982574864958,
          13.510252880511224,
          13.561523186157492,
          13.612793491803757,
          13.664063797450023,
          13.715334103096291,
          13.766604408742555,
          13.817874714388823,
          13.86914502003509,
          13.920415325681354,
          13.971685631327622,
          14.022955936973888,
          14.074226242620156,
          14.12549654826642,
          14.176766853912687,
          14.228037159558955,
          14.27930746520522,
          14.330577770851486,
          14.381848076497754,
          14.433118382144018,
          14.484388687790286,
          14.535658993436552,
          14.586929299082817,
          14.638199604729085,
          14.689469910375351,
          14.740740216021619,
          14.792010521667883,
          14.84328082731415,
          14.894551132960418,
          14.945821438606682,
          14.99709174425295,
          15.048362049899216,
          15.09963235554548,
          15.150902661191749,
          15.202172966838015,
          15.253443272484283,
          15.304713578130547,
          15.355983883776814,
          15.407254189423082,
          15.458524495069346,
          15.509794800715612,
          15.56106510636188,
          15.612335412008145,
          15.663605717654413,
          15.714876023300679,
          15.766146328946943,
          15.817416634593211,
          15.868686940239478,
          15.919957245885746,
          15.97122755153201,
          16.022497857178276,
          16.073768162824543,
          16.12503846847081,
          16.176308774117075,
          16.227579079763345,
          16.278849385409607,
          16.330119691055877,
          16.38138999670214,
          16.43266030234841,
          16.483930607994672,
          16.535200913640942,
          16.58647121928721,
          16.637741524933475,
          16.68901183057974,
          16.740282136226007,
          16.79155244187227,
          16.84282274751854,
          16.894093053164806,
          16.945363358811072,
          16.996633664457338,
          17.047903970103604,
          17.099174275749874,
          17.150444581396137,
          17.201714887042403,
          17.25298519268867,
          17.304255498334935,
          17.3555258039812,
          17.40679610962747,
          17.458066415273734,
          17.509336720920004,
          17.560607026566267,
          17.611877332212536,
          17.6631476378588,
          17.71441794350507,
          17.765688249151335,
          17.8169585547976,
          17.868228860443867,
          17.919499166090134,
          17.970769471736396,
          18.022039777382666,
          18.073310083028932,
          18.1245803886752,
          18.175850694321465,
          18.22712099996773,
          18.278391305614,
          18.329661611260263,
          18.38093191690653,
          18.432202222552796,
          18.483472528199062,
          18.53474283384533,
          18.586013139491598,
          18.63728344513786,
          18.68855375078413,
          18.739824056430393,
          18.791094362076663,
          18.842364667722926,
          18.893634973369196,
          18.94490527901546,
          18.996175584661728,
          19.047445890307994,
          19.09871619595426,
          19.149986501600523,
          19.201256807246793,
          19.25252711289306,
          19.303797418539325,
          19.35506772418559,
          19.406338029831858,
          19.457608335478128,
          19.50887864112439,
          19.56014894677066,
          19.611419252416923,
          19.662689558063192,
          19.713959863709455,
          19.765230169355725,
          19.816500475001988,
          19.867770780648257,
          19.91904108629452,
          19.97031139194079,
          20.021581697587052,
          20.072852003233322,
          20.124122308879585,
          20.175392614525855,
          20.226662920172117,
          20.277933225818387,
          20.32920353146465,
          20.38047383711092,
          20.43174414275719,
          20.483014448403452,
          20.53428475404972,
          20.585555059695984,
          20.636825365342247,
          20.688095670988517,
          20.739365976634787,
          20.79063628228105,
          20.84190658792732,
          20.89317689357358,
          20.94444719921985,
          20.995717504866114,
          21.046987810512384,
          21.098258116158647,
          21.149528421804916,
          21.200798727451186,
          21.25206903309745,
          21.30333933874371,
          21.35460964438998,
          21.405879950036244,
          21.457150255682514,
          21.508420561328784,
          21.559690866975046,
          21.61096117262131,
          21.66223147826758,
          21.71350178391385,
          21.76477208956011,
          21.81604239520638,
          21.867312700852644,
          21.918583006498906,
          21.969853312145176,
          22.021123617791446,
          22.07239392343771,
          22.12366422908398,
          22.17493453473024,
          22.22620484037651,
          22.277475146022773,
          22.328745451669043,
          22.380015757315306,
          22.431286062961576,
          22.48255636860784,
          22.533826674254108,
          22.58509697990037,
          22.63636728554664,
          22.687637591192903,
          22.738907896839173,
          22.790178202485443,
          22.841448508131705,
          22.892718813777975,
          22.943989119424238,
          22.9952594250705,
          23.04652973071677,
          23.09780003636304,
          23.149070342009303,
          23.200340647655572,
          23.251610953301835,
          23.302881258948105,
          23.354151564594368,
          23.405421870240637,
          23.4566921758869,
          23.50796248153317,
          23.55923278717944,
          23.610503092825702,
          23.661773398471965,
          23.713043704118235,
          23.764314009764497,
          23.815584315410767,
          23.866854621057037,
          23.9181249267033,
          23.969395232349562,
          24.020665537995832,
          24.071935843642102,
          24.123206149288364,
          24.174476454934634,
          24.225746760580897,
          24.27701706622716,
          24.32828737187343,
          24.3795576775197,
          24.430827983165962,
          24.48209828881223,
          24.533368594458494,
          24.584638900104764,
          24.635909205751027,
          24.687179511397296,
          24.73844981704356,
          24.78972012268983,
          24.84099042833609,
          24.89226073398236,
          24.943531039628624,
          24.994801345274894,
          25.046071650921157,
          25.097341956567426,
          25.148612262213696,
          25.19988256785996,
          25.25115287350623,
          25.30242317915249,
          25.353693484798754,
          25.404963790445024,
          25.456234096091293,
          25.507504401737556,
          25.558774707383826,
          25.61004501303009,
          25.66131531867636,
          25.71258562432262,
          25.76385592996889,
          25.815126235615153,
          25.866396541261423,
          25.917666846907693,
          25.968937152553956,
          26.02020745820022,
          26.071477763846488,
          26.12274806949275,
          26.17401837513902,
          26.22528868078529,
          26.276558986431553,
          26.327829292077816,
          26.379099597724085,
          26.430369903370355,
          26.481640209016618,
          26.532910514662888,
          26.58418082030915,
          26.635451125955413,
          26.686721431601683,
          26.737991737247953,
          26.789262042894215,
          26.840532348540485,
          26.891802654186748,
          26.943072959833017,
          26.99434326547928,
          27.04561357112555,
          27.096883876771813,
          27.148154182418082,
          27.199424488064352,
          27.250694793710615,
          27.301965099356877,
          27.353235405003147,
          27.40450571064941,
          27.45577601629568,
          27.50704632194195,
          27.558316627588212,
          27.609586933234482,
          27.660857238880745,
          27.712127544527007,
          27.763397850173277,
          27.814668155819547,
          27.86593846146581,
          27.91720876711208,
          27.968479072758342,
          28.01974937840461,
          28.071019684050874,
          28.122289989697144,
          28.173560295343407,
          28.224830600989677,
          28.276100906635946,
          28.32737121228221,
          28.37864151792847,
          28.42991182357474,
          28.481182129221004,
          28.532452434867274,
          28.583722740513544,
          28.634993046159806,
          28.68626335180607,
          28.73753365745234,
          28.78880396309861,
          28.84007426874487,
          28.89134457439114,
          28.942614880037404,
          28.993885185683666,
          29.045155491329936,
          29.096425796976206,
          29.14769610262247
         ],
         "xaxis": "x1",
         "y": [
          0.0029325900505248513,
          0.0030431355426489364,
          0.003157425432399065,
          0.003275573601544574,
          0.0033976937239907604,
          0.0035238988210937842,
          0.0036543007980711557,
          0.003789009963503875,
          0.0039281345340783,
          0.004071780126855267,
          0.004220049241480137,
          0.004373040734859552,
          0.004530849290928275,
          0.004693564888212874,
          0.0048612722679671466,
          0.005034050405708173,
          0.005211971989020867,
          0.005395102904524191,
          0.005583501736902962,
          0.005777219282907108,
          0.005976298083204616,
          0.00618077197494665,
          0.006390665667863209,
          0.006605994346656032,
          0.0068267633023926955,
          0.0070529675955319756,
          0.007284591753126058,
          0.007521609502650344,
          0.007763983544806216,
          0.008011665367526084,
          0.008264595103283591,
          0.008522701431674594,
          0.008785901529085418,
          0.009054101067104907,
          0.009327194261163992,
          0.009605063970701348,
          0.009887581851955143,
          0.01017460856426885,
          0.010465994030572525,
          0.010761577752460163,
          0.011061189180028049,
          0.01136464813636829,
          0.011671765296326722,
          0.011982342718834646,
          0.012296174431810547,
          0.01261304706830199,
          0.012932740552200356,
          0.013255028831513754,
          0.013579680656828045,
          0.013906460402225379,
          0.014235128925566125,
          0.014565444464676244,
          0.014897163565623388,
          0.015230042038911977,
          0.015563835939087492,
          0.015898302562914517,
          0.016233201460988722,
          0.016568295457362364,
          0.016903351671512325,
          0.017238142536762834,
          0.017572446809096476,
          0.017906050560152206,
          0.01823874814811998,
          0.01857034316020517,
          0.018900649320351445,
          0.01922949135598587,
          0.019556705817682117,
          0.01988214184583298,
          0.02020566187867898,
          0.020527142296359175,
          0.020846473996029815,
          0.02116356289353705,
          0.02147833034762823,
          0.021790713503238187,
          0.022100665550990585,
          0.02240815590070246,
          0.022713170267368143,
          0.023015710668820452,
          0.023315795335013812,
          0.02361345852963933,
          0.02390875028555694,
          0.02420173605630489,
          0.02449249628671521,
          0.02478112590641226,
          0.025067733750695584,
          0.025352441913993773,
          0.02563538504171769,
          0.025916709566928136,
          0.026196572898758118,
          0.026475142569983973,
          0.026752595351518572,
          0.027029116341894723,
          0.027304898040014264,
          0.02758013940955532,
          0.027855044943451764,
          0.028129823736784364,
          0.028404688576254476,
          0.0286798550541448,
          0.02895554071431526,
          0.02923196423733426,
          0.02950934467131563,
          0.029787900714422062,
          0.030067850054315465,
          0.03034940876909266,
          0.03063279079344683,
          0.030918207452956235,
          0.03120586706852622,
          0.03149597463211508,
          0.0317887315539672,
          0.03208433548066851,
          0.032382980182446224,
          0.032684855507260996,
          0.03299014739840312,
          0.03329903797151057,
          0.033611705646188615,
          0.033928325326734066,
          0.03424906862586528,
          0.03457410412483123,
          0.03490359766283388,
          0.035237712648345194,
          0.03557661038463961,
          0.03592045040169899,
          0.036269390786575845,
          0.036623588504325955,
          0.03698319970173779,
          0.037348379986294394,
          0.03771928467309485,
          0.03809606899283547,
          0.03847888825439694,
          0.038867897956097026,
          0.03926325384024057,
          0.03966511188622005,
          0.04007362823808524,
          0.04048895906319652,
          0.040911260339296866,
          0.04134068756807125,
          0.04177739541400251,
          0.04222153726807002,
          0.04267326473656005,
          0.04313272705596588,
          0.043600070435633534,
          0.044075437330459676,
          0.04455896564655708,
          0.04505078788337601,
          0.04555103021629216,
          0.04605981152415106,
          0.0465772423666876,
          0.047103423917118546,
          0.047638446855535775,
          0.048182390229010115,
          0.04873532028455155,
          0.049297289281261966,
          0.049868334288166054,
          0.05044847597432075,
          0.05103771739787712,
          0.05163604280082013,
          0.052243416416128834,
          0.05285978129409951,
          0.05348505815455142,
          0.05411914427159877,
          0.05476191239762073,
          0.05541320973300361,
          0.056072856948157,
          0.05674064726423444,
          0.057416345598904545,
          0.05809968778343297,
          0.058790379857241844,
          0.05948809744601294,
          0.06019248522928878,
          0.060903156503408745,
          0.06161969284547546,
          0.06234164388389994,
          0.06306852718089438,
          0.06379982823208431,
          0.06453500058818366,
          0.0652734661034119,
          0.06601461531503715,
          0.06675780795808509,
          0.06750237361887236,
          0.06824761253058882,
          0.06899279651367136,
          0.06973717006317727,
          0.07047995158477789,
          0.07122033478034995,
          0.07195749018344826,
          0.0726905668441948,
          0.07341869416232295,
          0.07414098386626984,
          0.07485653213532481,
          0.07556442186091604,
          0.07626372504216307,
          0.07695350530984037,
          0.07763282057190125,
          0.07830072577270338,
          0.07895627575707155,
          0.07959852822933677,
          0.08022654679651195,
          0.0808394040838181,
          0.08143618490986784,
          0.0820159895079516,
          0.08257793677907976,
          0.08312116756170149,
          0.08364484790237803,
          0.08414817231112619,
          0.08463036698468743,
          0.0850906929806215,
          0.08552844932487547,
          0.08594297603535482,
          0.08633365704400751,
          0.08669992300006335,
          0.08704125393730347,
          0.0873571817886177,
          0.08764729273160872,
          0.08791122934963123,
          0.08814869259341204,
          0.08835944352926828,
          0.08854330486093838,
          0.08870016221313402,
          0.08882996516613022,
          0.08893272803199982,
          0.08900853036448257,
          0.08905751719593091,
          0.08907989899628722,
          0.08907595135062069,
          0.08904601435334812,
          0.08899049171890347,
          0.08890984961026137,
          0.088804615188365,
          0.08867537488714654,
          0.08852277242043312,
          0.088347506528603,
          0.08815032847437941,
          0.0879320392986098,
          0.0876934868482651,
          0.08743556259020277,
          0.08715919822545087,
          0.08686536211988702,
          0.08655505556819507,
          0.08622930890887692,
          0.085889177508877,
          0.08553573763702821,
          0.08517008224606289,
          0.08479331668333248,
          0.08440655435065822,
          0.08401091233388536,
          0.08360750702273906,
          0.08319744974148398,
          0.08278184241067955,
          0.08236177325999335,
          0.08193831261160338,
          0.08151250875318967,
          0.08108538391888327,
          0.08065793039583202,
          0.08023110677324975,
          0.07980583434995385,
          0.07938299371547765,
          0.07896342151886461,
          0.07854790743823588,
          0.07813719136316764,
          0.07773196080082859,
          0.07733284851572975,
          0.07694043041181581,
          0.07655522366451059,
          0.07617768510920048,
          0.0758082098915223,
          0.07544713038371367,
          0.07509471537018456,
          0.07475116950439212,
          0.07441663303803803,
          0.07409118182256692,
          0.07377482758193102,
          0.07346751845458464,
          0.07316913980170581,
          0.07287951527768904,
          0.07259840815802601,
          0.07232552291878434,
          0.07206050706100593,
          0.07180295317247837,
          0.07155240121847985,
          0.07130834105226394,
          0.07107021513523144,
          0.07083742145592906,
          0.07060931663623278,
          0.07038521921229342,
          0.07016441307707447,
          0.06994615107057237,
          0.06972965870309812,
          0.06951413799631005,
          0.06929877142603148,
          0.0690827259502569,
          0.0688651571051728,
          0.06864521315147178,
          0.068422039252756,
          0.0681947816673922,
          0.0679625919348222,
          0.0677246310370369,
          0.06748007351571826,
          0.06722811152542862,
          0.0669679588032076,
          0.06669885453500847,
          0.0664200670996001,
          0.06613089767085727,
          0.06583068365978828,
          0.06551880197819487,
          0.0651946721065293,
          0.06485775894931943,
          0.06450757546246033,
          0.06414368503772903,
          0.06376570363106346,
          0.0633733016224497,
          0.06296620539668148,
          0.06254419863578398,
          0.06210712331551856,
          0.0616548804001058,
          0.061187430231091175,
          0.060704792608141926,
          0.06020704656146624,
          0.05969432981749406,
          0.05916683796141696,
          0.05862482330215146,
          0.05806859344723844,
          0.057498509597109566,
          0.05691498457001473,
          0.05631848057070848,
          0.055709506717700384,
          0.05508861634549337,
          0.05445640409972168,
          0.0538135028444701,
          0.05316058040226458,
          0.052498336148291934,
          0.05182749748128951,
          0.05114881619426316,
          0.05046306476871971,
          0.04977103261643602,
          0.04907352229293691,
          0.04837134570680289,
          0.04766532034868622,
          0.04695626556348558,
          0.046244998888508054,
          0.04553233247965285,
          0.04481906964668435,
          0.044106001517536256,
          0.04339390385031473,
          0.04268353401025955,
          0.04197562812739761,
          0.0412708984489875,
          0.04057003089913823,
          0.039873682856196205,
          0.03918248115665278,
          0.03849702033244859,
          0.03781786108666395,
          0.03714552901068894,
          0.036480513544100465,
          0.03582326717663699,
          0.03517420488987949,
          0.03453370383452912,
          0.03390210323754027,
          0.033279704531826194,
          0.03266677169981601,
          0.03206353182082733,
          0.031470175811019734,
          0.03088685934363007,
          0.030313703936265892,
          0.029750798191244033,
          0.029198199174318498,
          0.028655933916643457,
          0.028124001024457973,
          0.02760237238076772,
          0.02709099492321692,
          0.026589792482405082,
          0.026098667665080445,
          0.025617503766951807,
          0.025146166700272286,
          0.024684506921874776,
          0.024232361347951214,
          0.023789555242575627,
          0.023355904067745712,
          0.02293121528356487,
          0.022515290088086597,
          0.022107925087286793,
          0.021708913886611367,
          0.021318048596550614,
          0.02093512124571067,
          0.020559925095878884,
          0.02019225585460139,
          0.019831912781800295,
          0.019478699687949665,
          0.019132425822290525,
          0.018792906650496922,
          0.018459964522091678,
          0.018133429228758612,
          0.017813138455488448,
          0.017498938127240182,
          0.017190682654481173,
          0.01688823508159412,
          0.016591467142699722,
          0.016300259229944738,
          0.01601450027973655,
          0.015734087582777476,
          0.015458926524056074,
          0.015188930259194688,
          0.014924019333731267,
          0.014664121252031245,
          0.014409170002584862,
          0.014159105546445236,
          0.013913873275512141,
          0.013673423447261005,
          0.013437710602364646,
          0.013206692971458095,
          0.012980331877058876,
          0.012758591136376597,
          0.01254143647043815,
          0.012328834924611676,
          0.01212075430524885,
          0.011917162636774534,
          0.011718027643149642,
          0.011523316257210923,
          0.011332994160965499,
          0.011147025359480837,
          0.010965371790577341,
          0.01078799297209562,
          0.010614845688084172,
          0.01044588371483468,
          0.010281057587287683,
          0.0101203144059428,
          0.009963597684037458,
          0.009810847234411045,
          0.009661999095147032,
          0.009516985492787903,
          0.00937573484164856,
          0.009238171777513533,
          0.009104217223792689,
          0.008973788488033058,
          0.008846799386535785,
          0.00872316039471345,
          0.008602778820737766,
          0.008485558999975478,
          0.008371402507686065,
          0.00826020838746033,
          0.008151873392910543,
          0.008046292240180157,
          0.007943357868920213,
          0.007842961709481495,
          0.007744993954189098,
          0.0076493438307014645,
          0.007555899875603181,
          0.007464550206538631,
          0.007375182791358654,
          0.007287685712922207,
          0.00720194742836711,
          0.007117857021834351,
          0.007035304449799128,
          0.006954180778323566,
          0.006874378411701118,
          0.006795791312107495,
          0.006718315210007214,
          0.006641847805185134,
          0.006566288958380432,
          0.006491540873591715,
          0.006417508271199899,
          0.0063440985521155575,
          0.006271221953203764,
          0.006198791694268516,
          0.006126724116894015,
          0.006054938815440525,
          0.005983358760479563,
          0.005911910414928281,
          0.00584052384310734,
          0.005769132812901247,
          0.005697674891147639,
          0.005626091532323431,
          0.005554328160532622,
          0.0054823342447357275,
          0.005410063367094482,
          0.005337473284241235,
          0.005264525981219906,
          0.005191187717788504,
          0.005117429066720693,
          0.005043224943700016,
          0.004968554628363554,
          0.004893401776025352,
          0.004817754419592635,
          0.004741604961182218,
          0.004664950152949134,
          0.004587791066656119,
          0.004510133051540262,
          0.004431985680071902,
          0.004353362681250316,
          0.004274281861140889,
          0.004194765010427158,
          0.0041148377988292125,
          0.0040345296563252,
          0.003953873641204249,
          0.0038729062950760788,
          0.0037916674850633336,
          0.003710200233506097,
          0.003628550535612026,
          0.003546767165590287,
          0.003464901471909572,
          0.0033830071624200955
         ],
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)",
          "symbol": "line-ns-open"
         },
         "mode": "markers",
         "name": "Percent Tip",
         "showlegend": false,
         "text": null,
         "type": "scatter",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "y": [
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip"
         ],
         "yaxis": "y2"
        }
       ],
       "layout": {
        "barmode": "overlay",
        "hovermode": "closest",
        "legend": {
         "traceorder": "reversed"
        },
        "xaxis1": {
         "anchor": "y2",
         "domain": [
          0,
          1
         ],
         "zeroline": false
        },
        "yaxis1": {
         "anchor": "free",
         "domain": [
          0.35,
          1
         ],
         "position": 0
        },
        "yaxis2": {
         "anchor": "x1",
         "domain": [
          0,
          0.25
         ],
         "dtick": 1,
         "showticklabels": false
        }
       }
      },
      "text/html": [
       "<div id=\"084969e3-b642-454f-9228-95ed5471c383\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"084969e3-b642-454f-9228-95ed5471c383\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 29.198966408268735, \"size\": 0.5}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.615083890781813, 3.6663541964280797, 3.717624502074346, 3.768894807720612, 3.820165113366879, 3.871435419013145, 3.9227057246594113, 3.973976030305678, 4.025246335951945, 4.076516641598211, 4.127786947244477, 4.179057252890743, 4.2303275585370095, 4.281597864183276, 4.332868169829543, 4.384138475475809, 4.435408781122075, 4.4866790867683415, 4.537949392414608, 4.589219698060875, 4.640490003707141, 4.691760309353407, 4.7430306149996735, 4.79430092064594, 4.845571226292206, 4.896841531938473, 4.948111837584739, 4.9993821432310055, 5.050652448877272, 5.101922754523538, 5.153193060169804, 5.204463365816071, 5.2557336714623375, 5.307003977108604, 5.35827428275487, 5.409544588401136, 5.460814894047402, 5.512085199693669, 5.563355505339936, 5.614625810986202, 5.665896116632468, 5.717166422278735, 5.7684367279250015, 5.819707033571268, 5.870977339217534, 5.9222476448638, 5.973517950510066, 6.024788256156333, 6.076058561802599, 6.127328867448866, 6.178599173095132, 6.229869478741399, 6.281139784387665, 6.332410090033932, 6.383680395680198, 6.434950701326464, 6.48622100697273, 6.537491312618997, 6.588761618265263, 6.640031923911529, 6.691302229557796, 6.7425725352040615, 6.793842840850329, 6.845113146496596, 6.896383452142862, 6.947653757789128, 6.998924063435394, 7.050194369081661, 7.101464674727927, 7.152734980374193, 7.204005286020459, 7.2552755916667255, 7.306545897312993, 7.357816202959259, 7.409086508605526, 7.460356814251791, 7.511627119898058, 7.562897425544325, 7.614167731190591, 7.665438036836857, 7.716708342483124, 7.7679786481293895, 7.819248953775656, 7.870519259421923, 7.921789565068189, 7.973059870714456, 8.02433017636072, 8.075600482006987, 8.126870787653255, 8.178141093299521, 8.229411398945787, 8.280681704592054, 8.33195201023832, 8.383222315884588, 8.434492621530854, 8.48576292717712, 8.537033232823386, 8.588303538469653, 8.639573844115919, 8.690844149762185, 8.742114455408451, 8.793384761054718, 8.844655066700984, 8.89592537234725, 8.947195677993516, 8.998465983639782, 9.049736289286049, 9.101006594932315, 9.152276900578583, 9.203547206224847, 9.254817511871114, 9.306087817517382, 9.357358123163648, 9.408628428809916, 9.45989873445618, 9.511169040102446, 9.562439345748714, 9.61370965139498, 9.664979957041245, 9.716250262687513, 9.76752056833378, 9.818790873980046, 9.870061179626312, 9.921331485272578, 9.972601790918844, 10.02387209656511, 10.075142402211377, 10.126412707857643, 10.17768301350391, 10.228953319150175, 10.280223624796442, 10.33149393044271, 10.382764236088974, 10.43403454173524, 10.485304847381508, 10.536575153027774, 10.587845458674042, 10.639115764320307, 10.690386069966573, 10.741656375612841, 10.792926681259107, 10.844196986905374, 10.89546729255164, 10.946737598197906, 10.998007903844172, 11.049278209490438, 11.100548515136705, 11.151818820782971, 11.203089126429237, 11.254359432075503, 11.30562973772177, 11.356900043368036, 11.408170349014302, 11.459440654660568, 11.510710960306836, 11.561981265953102, 11.613251571599369, 11.664521877245635, 11.715792182891901, 11.767062488538167, 11.818332794184434, 11.869603099830702, 11.920873405476966, 11.972143711123232, 12.0234140167695, 12.074684322415765, 12.125954628062033, 12.177224933708299, 12.228495239354565, 12.279765545000831, 12.331035850647098, 12.382306156293366, 12.43357646193963, 12.484846767585896, 12.536117073232164, 12.587387378878429, 12.638657684524697, 12.689927990170963, 12.741198295817227, 12.792468601463495, 12.843738907109762, 12.895009212756028, 12.946279518402294, 12.99754982404856, 13.048820129694828, 13.100090435341093, 13.151360740987359, 13.202631046633627, 13.253901352279891, 13.30517165792616, 13.356441963572426, 13.407712269218692, 13.458982574864958, 13.510252880511224, 13.561523186157492, 13.612793491803757, 13.664063797450023, 13.715334103096291, 13.766604408742555, 13.817874714388823, 13.86914502003509, 13.920415325681354, 13.971685631327622, 14.022955936973888, 14.074226242620156, 14.12549654826642, 14.176766853912687, 14.228037159558955, 14.27930746520522, 14.330577770851486, 14.381848076497754, 14.433118382144018, 14.484388687790286, 14.535658993436552, 14.586929299082817, 14.638199604729085, 14.689469910375351, 14.740740216021619, 14.792010521667883, 14.84328082731415, 14.894551132960418, 14.945821438606682, 14.99709174425295, 15.048362049899216, 15.09963235554548, 15.150902661191749, 15.202172966838015, 15.253443272484283, 15.304713578130547, 15.355983883776814, 15.407254189423082, 15.458524495069346, 15.509794800715612, 15.56106510636188, 15.612335412008145, 15.663605717654413, 15.714876023300679, 15.766146328946943, 15.817416634593211, 15.868686940239478, 15.919957245885746, 15.97122755153201, 16.022497857178276, 16.073768162824543, 16.12503846847081, 16.176308774117075, 16.227579079763345, 16.278849385409607, 16.330119691055877, 16.38138999670214, 16.43266030234841, 16.483930607994672, 16.535200913640942, 16.58647121928721, 16.637741524933475, 16.68901183057974, 16.740282136226007, 16.79155244187227, 16.84282274751854, 16.894093053164806, 16.945363358811072, 16.996633664457338, 17.047903970103604, 17.099174275749874, 17.150444581396137, 17.201714887042403, 17.25298519268867, 17.304255498334935, 17.3555258039812, 17.40679610962747, 17.458066415273734, 17.509336720920004, 17.560607026566267, 17.611877332212536, 17.6631476378588, 17.71441794350507, 17.765688249151335, 17.8169585547976, 17.868228860443867, 17.919499166090134, 17.970769471736396, 18.022039777382666, 18.073310083028932, 18.1245803886752, 18.175850694321465, 18.22712099996773, 18.278391305614, 18.329661611260263, 18.38093191690653, 18.432202222552796, 18.483472528199062, 18.53474283384533, 18.586013139491598, 18.63728344513786, 18.68855375078413, 18.739824056430393, 18.791094362076663, 18.842364667722926, 18.893634973369196, 18.94490527901546, 18.996175584661728, 19.047445890307994, 19.09871619595426, 19.149986501600523, 19.201256807246793, 19.25252711289306, 19.303797418539325, 19.35506772418559, 19.406338029831858, 19.457608335478128, 19.50887864112439, 19.56014894677066, 19.611419252416923, 19.662689558063192, 19.713959863709455, 19.765230169355725, 19.816500475001988, 19.867770780648257, 19.91904108629452, 19.97031139194079, 20.021581697587052, 20.072852003233322, 20.124122308879585, 20.175392614525855, 20.226662920172117, 20.277933225818387, 20.32920353146465, 20.38047383711092, 20.43174414275719, 20.483014448403452, 20.53428475404972, 20.585555059695984, 20.636825365342247, 20.688095670988517, 20.739365976634787, 20.79063628228105, 20.84190658792732, 20.89317689357358, 20.94444719921985, 20.995717504866114, 21.046987810512384, 21.098258116158647, 21.149528421804916, 21.200798727451186, 21.25206903309745, 21.30333933874371, 21.35460964438998, 21.405879950036244, 21.457150255682514, 21.508420561328784, 21.559690866975046, 21.61096117262131, 21.66223147826758, 21.71350178391385, 21.76477208956011, 21.81604239520638, 21.867312700852644, 21.918583006498906, 21.969853312145176, 22.021123617791446, 22.07239392343771, 22.12366422908398, 22.17493453473024, 22.22620484037651, 22.277475146022773, 22.328745451669043, 22.380015757315306, 22.431286062961576, 22.48255636860784, 22.533826674254108, 22.58509697990037, 22.63636728554664, 22.687637591192903, 22.738907896839173, 22.790178202485443, 22.841448508131705, 22.892718813777975, 22.943989119424238, 22.9952594250705, 23.04652973071677, 23.09780003636304, 23.149070342009303, 23.200340647655572, 23.251610953301835, 23.302881258948105, 23.354151564594368, 23.405421870240637, 23.4566921758869, 23.50796248153317, 23.55923278717944, 23.610503092825702, 23.661773398471965, 23.713043704118235, 23.764314009764497, 23.815584315410767, 23.866854621057037, 23.9181249267033, 23.969395232349562, 24.020665537995832, 24.071935843642102, 24.123206149288364, 24.174476454934634, 24.225746760580897, 24.27701706622716, 24.32828737187343, 24.3795576775197, 24.430827983165962, 24.48209828881223, 24.533368594458494, 24.584638900104764, 24.635909205751027, 24.687179511397296, 24.73844981704356, 24.78972012268983, 24.84099042833609, 24.89226073398236, 24.943531039628624, 24.994801345274894, 25.046071650921157, 25.097341956567426, 25.148612262213696, 25.19988256785996, 25.25115287350623, 25.30242317915249, 25.353693484798754, 25.404963790445024, 25.456234096091293, 25.507504401737556, 25.558774707383826, 25.61004501303009, 25.66131531867636, 25.71258562432262, 25.76385592996889, 25.815126235615153, 25.866396541261423, 25.917666846907693, 25.968937152553956, 26.02020745820022, 26.071477763846488, 26.12274806949275, 26.17401837513902, 26.22528868078529, 26.276558986431553, 26.327829292077816, 26.379099597724085, 26.430369903370355, 26.481640209016618, 26.532910514662888, 26.58418082030915, 26.635451125955413, 26.686721431601683, 26.737991737247953, 26.789262042894215, 26.840532348540485, 26.891802654186748, 26.943072959833017, 26.99434326547928, 27.04561357112555, 27.096883876771813, 27.148154182418082, 27.199424488064352, 27.250694793710615, 27.301965099356877, 27.353235405003147, 27.40450571064941, 27.45577601629568, 27.50704632194195, 27.558316627588212, 27.609586933234482, 27.660857238880745, 27.712127544527007, 27.763397850173277, 27.814668155819547, 27.86593846146581, 27.91720876711208, 27.968479072758342, 28.01974937840461, 28.071019684050874, 28.122289989697144, 28.173560295343407, 28.224830600989677, 28.276100906635946, 28.32737121228221, 28.37864151792847, 28.42991182357474, 28.481182129221004, 28.532452434867274, 28.583722740513544, 28.634993046159806, 28.68626335180607, 28.73753365745234, 28.78880396309861, 28.84007426874487, 28.89134457439114, 28.942614880037404, 28.993885185683666, 29.045155491329936, 29.096425796976206, 29.14769610262247], \"y\": [0.0029325900505248513, 0.0030431355426489364, 0.003157425432399065, 0.003275573601544574, 0.0033976937239907604, 0.0035238988210937842, 0.0036543007980711557, 0.003789009963503875, 0.0039281345340783, 0.004071780126855267, 0.004220049241480137, 0.004373040734859552, 0.004530849290928275, 0.004693564888212874, 0.0048612722679671466, 0.005034050405708173, 0.005211971989020867, 0.005395102904524191, 0.005583501736902962, 0.005777219282907108, 0.005976298083204616, 0.00618077197494665, 0.006390665667863209, 0.006605994346656032, 0.0068267633023926955, 0.0070529675955319756, 0.007284591753126058, 0.007521609502650344, 0.007763983544806216, 0.008011665367526084, 0.008264595103283591, 0.008522701431674594, 0.008785901529085418, 0.009054101067104907, 0.009327194261163992, 0.009605063970701348, 0.009887581851955143, 0.01017460856426885, 0.010465994030572525, 0.010761577752460163, 0.011061189180028049, 0.01136464813636829, 0.011671765296326722, 0.011982342718834646, 0.012296174431810547, 0.01261304706830199, 0.012932740552200356, 0.013255028831513754, 0.013579680656828045, 0.013906460402225379, 0.014235128925566125, 0.014565444464676244, 0.014897163565623388, 0.015230042038911977, 0.015563835939087492, 0.015898302562914517, 0.016233201460988722, 0.016568295457362364, 0.016903351671512325, 0.017238142536762834, 0.017572446809096476, 0.017906050560152206, 0.01823874814811998, 0.01857034316020517, 0.018900649320351445, 0.01922949135598587, 0.019556705817682117, 0.01988214184583298, 0.02020566187867898, 0.020527142296359175, 0.020846473996029815, 0.02116356289353705, 0.02147833034762823, 0.021790713503238187, 0.022100665550990585, 0.02240815590070246, 0.022713170267368143, 0.023015710668820452, 0.023315795335013812, 0.02361345852963933, 0.02390875028555694, 0.02420173605630489, 0.02449249628671521, 0.02478112590641226, 0.025067733750695584, 0.025352441913993773, 0.02563538504171769, 0.025916709566928136, 0.026196572898758118, 0.026475142569983973, 0.026752595351518572, 0.027029116341894723, 0.027304898040014264, 0.02758013940955532, 0.027855044943451764, 0.028129823736784364, 0.028404688576254476, 0.0286798550541448, 0.02895554071431526, 0.02923196423733426, 0.02950934467131563, 0.029787900714422062, 0.030067850054315465, 0.03034940876909266, 0.03063279079344683, 0.030918207452956235, 0.03120586706852622, 0.03149597463211508, 0.0317887315539672, 0.03208433548066851, 0.032382980182446224, 0.032684855507260996, 0.03299014739840312, 0.03329903797151057, 0.033611705646188615, 0.033928325326734066, 0.03424906862586528, 0.03457410412483123, 0.03490359766283388, 0.035237712648345194, 0.03557661038463961, 0.03592045040169899, 0.036269390786575845, 0.036623588504325955, 0.03698319970173779, 0.037348379986294394, 0.03771928467309485, 0.03809606899283547, 0.03847888825439694, 0.038867897956097026, 0.03926325384024057, 0.03966511188622005, 0.04007362823808524, 0.04048895906319652, 0.040911260339296866, 0.04134068756807125, 0.04177739541400251, 0.04222153726807002, 0.04267326473656005, 0.04313272705596588, 0.043600070435633534, 0.044075437330459676, 0.04455896564655708, 0.04505078788337601, 0.04555103021629216, 0.04605981152415106, 0.0465772423666876, 0.047103423917118546, 0.047638446855535775, 0.048182390229010115, 0.04873532028455155, 0.049297289281261966, 0.049868334288166054, 0.05044847597432075, 0.05103771739787712, 0.05163604280082013, 0.052243416416128834, 0.05285978129409951, 0.05348505815455142, 0.05411914427159877, 0.05476191239762073, 0.05541320973300361, 0.056072856948157, 0.05674064726423444, 0.057416345598904545, 0.05809968778343297, 0.058790379857241844, 0.05948809744601294, 0.06019248522928878, 0.060903156503408745, 0.06161969284547546, 0.06234164388389994, 0.06306852718089438, 0.06379982823208431, 0.06453500058818366, 0.0652734661034119, 0.06601461531503715, 0.06675780795808509, 0.06750237361887236, 0.06824761253058882, 0.06899279651367136, 0.06973717006317727, 0.07047995158477789, 0.07122033478034995, 0.07195749018344826, 0.0726905668441948, 0.07341869416232295, 0.07414098386626984, 0.07485653213532481, 0.07556442186091604, 0.07626372504216307, 0.07695350530984037, 0.07763282057190125, 0.07830072577270338, 0.07895627575707155, 0.07959852822933677, 0.08022654679651195, 0.0808394040838181, 0.08143618490986784, 0.0820159895079516, 0.08257793677907976, 0.08312116756170149, 0.08364484790237803, 0.08414817231112619, 0.08463036698468743, 0.0850906929806215, 0.08552844932487547, 0.08594297603535482, 0.08633365704400751, 0.08669992300006335, 0.08704125393730347, 0.0873571817886177, 0.08764729273160872, 0.08791122934963123, 0.08814869259341204, 0.08835944352926828, 0.08854330486093838, 0.08870016221313402, 0.08882996516613022, 0.08893272803199982, 0.08900853036448257, 0.08905751719593091, 0.08907989899628722, 0.08907595135062069, 0.08904601435334812, 0.08899049171890347, 0.08890984961026137, 0.088804615188365, 0.08867537488714654, 0.08852277242043312, 0.088347506528603, 0.08815032847437941, 0.0879320392986098, 0.0876934868482651, 0.08743556259020277, 0.08715919822545087, 0.08686536211988702, 0.08655505556819507, 0.08622930890887692, 0.085889177508877, 0.08553573763702821, 0.08517008224606289, 0.08479331668333248, 0.08440655435065822, 0.08401091233388536, 0.08360750702273906, 0.08319744974148398, 0.08278184241067955, 0.08236177325999335, 0.08193831261160338, 0.08151250875318967, 0.08108538391888327, 0.08065793039583202, 0.08023110677324975, 0.07980583434995385, 0.07938299371547765, 0.07896342151886461, 0.07854790743823588, 0.07813719136316764, 0.07773196080082859, 0.07733284851572975, 0.07694043041181581, 0.07655522366451059, 0.07617768510920048, 0.0758082098915223, 0.07544713038371367, 0.07509471537018456, 0.07475116950439212, 0.07441663303803803, 0.07409118182256692, 0.07377482758193102, 0.07346751845458464, 0.07316913980170581, 0.07287951527768904, 0.07259840815802601, 0.07232552291878434, 0.07206050706100593, 0.07180295317247837, 0.07155240121847985, 0.07130834105226394, 0.07107021513523144, 0.07083742145592906, 0.07060931663623278, 0.07038521921229342, 0.07016441307707447, 0.06994615107057237, 0.06972965870309812, 0.06951413799631005, 0.06929877142603148, 0.0690827259502569, 0.0688651571051728, 0.06864521315147178, 0.068422039252756, 0.0681947816673922, 0.0679625919348222, 0.0677246310370369, 0.06748007351571826, 0.06722811152542862, 0.0669679588032076, 0.06669885453500847, 0.0664200670996001, 0.06613089767085727, 0.06583068365978828, 0.06551880197819487, 0.0651946721065293, 0.06485775894931943, 0.06450757546246033, 0.06414368503772903, 0.06376570363106346, 0.0633733016224497, 0.06296620539668148, 0.06254419863578398, 0.06210712331551856, 0.0616548804001058, 0.061187430231091175, 0.060704792608141926, 0.06020704656146624, 0.05969432981749406, 0.05916683796141696, 0.05862482330215146, 0.05806859344723844, 0.057498509597109566, 0.05691498457001473, 0.05631848057070848, 0.055709506717700384, 0.05508861634549337, 0.05445640409972168, 0.0538135028444701, 0.05316058040226458, 0.052498336148291934, 0.05182749748128951, 0.05114881619426316, 0.05046306476871971, 0.04977103261643602, 0.04907352229293691, 0.04837134570680289, 0.04766532034868622, 0.04695626556348558, 0.046244998888508054, 0.04553233247965285, 0.04481906964668435, 0.044106001517536256, 0.04339390385031473, 0.04268353401025955, 0.04197562812739761, 0.0412708984489875, 0.04057003089913823, 0.039873682856196205, 0.03918248115665278, 0.03849702033244859, 0.03781786108666395, 0.03714552901068894, 0.036480513544100465, 0.03582326717663699, 0.03517420488987949, 0.03453370383452912, 0.03390210323754027, 0.033279704531826194, 0.03266677169981601, 0.03206353182082733, 0.031470175811019734, 0.03088685934363007, 0.030313703936265892, 0.029750798191244033, 0.029198199174318498, 0.028655933916643457, 0.028124001024457973, 0.02760237238076772, 0.02709099492321692, 0.026589792482405082, 0.026098667665080445, 0.025617503766951807, 0.025146166700272286, 0.024684506921874776, 0.024232361347951214, 0.023789555242575627, 0.023355904067745712, 0.02293121528356487, 0.022515290088086597, 0.022107925087286793, 0.021708913886611367, 0.021318048596550614, 0.02093512124571067, 0.020559925095878884, 0.02019225585460139, 0.019831912781800295, 0.019478699687949665, 0.019132425822290525, 0.018792906650496922, 0.018459964522091678, 0.018133429228758612, 0.017813138455488448, 0.017498938127240182, 0.017190682654481173, 0.01688823508159412, 0.016591467142699722, 0.016300259229944738, 0.01601450027973655, 0.015734087582777476, 0.015458926524056074, 0.015188930259194688, 0.014924019333731267, 0.014664121252031245, 0.014409170002584862, 0.014159105546445236, 0.013913873275512141, 0.013673423447261005, 0.013437710602364646, 0.013206692971458095, 0.012980331877058876, 0.012758591136376597, 0.01254143647043815, 0.012328834924611676, 0.01212075430524885, 0.011917162636774534, 0.011718027643149642, 0.011523316257210923, 0.011332994160965499, 0.011147025359480837, 0.010965371790577341, 0.01078799297209562, 0.010614845688084172, 0.01044588371483468, 0.010281057587287683, 0.0101203144059428, 0.009963597684037458, 0.009810847234411045, 0.009661999095147032, 0.009516985492787903, 0.00937573484164856, 0.009238171777513533, 0.009104217223792689, 0.008973788488033058, 0.008846799386535785, 0.00872316039471345, 0.008602778820737766, 0.008485558999975478, 0.008371402507686065, 0.00826020838746033, 0.008151873392910543, 0.008046292240180157, 0.007943357868920213, 0.007842961709481495, 0.007744993954189098, 0.0076493438307014645, 0.007555899875603181, 0.007464550206538631, 0.007375182791358654, 0.007287685712922207, 0.00720194742836711, 0.007117857021834351, 0.007035304449799128, 0.006954180778323566, 0.006874378411701118, 0.006795791312107495, 0.006718315210007214, 0.006641847805185134, 0.006566288958380432, 0.006491540873591715, 0.006417508271199899, 0.0063440985521155575, 0.006271221953203764, 0.006198791694268516, 0.006126724116894015, 0.006054938815440525, 0.005983358760479563, 0.005911910414928281, 0.00584052384310734, 0.005769132812901247, 0.005697674891147639, 0.005626091532323431, 0.005554328160532622, 0.0054823342447357275, 0.005410063367094482, 0.005337473284241235, 0.005264525981219906, 0.005191187717788504, 0.005117429066720693, 0.005043224943700016, 0.004968554628363554, 0.004893401776025352, 0.004817754419592635, 0.004741604961182218, 0.004664950152949134, 0.004587791066656119, 0.004510133051540262, 0.004431985680071902, 0.004353362681250316, 0.004274281861140889, 0.004194765010427158, 0.0041148377988292125, 0.0040345296563252, 0.003953873641204249, 0.0038729062950760788, 0.0037916674850633336, 0.003710200233506097, 0.003628550535612026, 0.003546767165590287, 0.003464901471909572, 0.0033830071624200955], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": null, \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<div id=\"084969e3-b642-454f-9228-95ed5471c383\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"084969e3-b642-454f-9228-95ed5471c383\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 29.198966408268735, \"size\": 0.5}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.615083890781813, 3.6663541964280797, 3.717624502074346, 3.768894807720612, 3.820165113366879, 3.871435419013145, 3.9227057246594113, 3.973976030305678, 4.025246335951945, 4.076516641598211, 4.127786947244477, 4.179057252890743, 4.2303275585370095, 4.281597864183276, 4.332868169829543, 4.384138475475809, 4.435408781122075, 4.4866790867683415, 4.537949392414608, 4.589219698060875, 4.640490003707141, 4.691760309353407, 4.7430306149996735, 4.79430092064594, 4.845571226292206, 4.896841531938473, 4.948111837584739, 4.9993821432310055, 5.050652448877272, 5.101922754523538, 5.153193060169804, 5.204463365816071, 5.2557336714623375, 5.307003977108604, 5.35827428275487, 5.409544588401136, 5.460814894047402, 5.512085199693669, 5.563355505339936, 5.614625810986202, 5.665896116632468, 5.717166422278735, 5.7684367279250015, 5.819707033571268, 5.870977339217534, 5.9222476448638, 5.973517950510066, 6.024788256156333, 6.076058561802599, 6.127328867448866, 6.178599173095132, 6.229869478741399, 6.281139784387665, 6.332410090033932, 6.383680395680198, 6.434950701326464, 6.48622100697273, 6.537491312618997, 6.588761618265263, 6.640031923911529, 6.691302229557796, 6.7425725352040615, 6.793842840850329, 6.845113146496596, 6.896383452142862, 6.947653757789128, 6.998924063435394, 7.050194369081661, 7.101464674727927, 7.152734980374193, 7.204005286020459, 7.2552755916667255, 7.306545897312993, 7.357816202959259, 7.409086508605526, 7.460356814251791, 7.511627119898058, 7.562897425544325, 7.614167731190591, 7.665438036836857, 7.716708342483124, 7.7679786481293895, 7.819248953775656, 7.870519259421923, 7.921789565068189, 7.973059870714456, 8.02433017636072, 8.075600482006987, 8.126870787653255, 8.178141093299521, 8.229411398945787, 8.280681704592054, 8.33195201023832, 8.383222315884588, 8.434492621530854, 8.48576292717712, 8.537033232823386, 8.588303538469653, 8.639573844115919, 8.690844149762185, 8.742114455408451, 8.793384761054718, 8.844655066700984, 8.89592537234725, 8.947195677993516, 8.998465983639782, 9.049736289286049, 9.101006594932315, 9.152276900578583, 9.203547206224847, 9.254817511871114, 9.306087817517382, 9.357358123163648, 9.408628428809916, 9.45989873445618, 9.511169040102446, 9.562439345748714, 9.61370965139498, 9.664979957041245, 9.716250262687513, 9.76752056833378, 9.818790873980046, 9.870061179626312, 9.921331485272578, 9.972601790918844, 10.02387209656511, 10.075142402211377, 10.126412707857643, 10.17768301350391, 10.228953319150175, 10.280223624796442, 10.33149393044271, 10.382764236088974, 10.43403454173524, 10.485304847381508, 10.536575153027774, 10.587845458674042, 10.639115764320307, 10.690386069966573, 10.741656375612841, 10.792926681259107, 10.844196986905374, 10.89546729255164, 10.946737598197906, 10.998007903844172, 11.049278209490438, 11.100548515136705, 11.151818820782971, 11.203089126429237, 11.254359432075503, 11.30562973772177, 11.356900043368036, 11.408170349014302, 11.459440654660568, 11.510710960306836, 11.561981265953102, 11.613251571599369, 11.664521877245635, 11.715792182891901, 11.767062488538167, 11.818332794184434, 11.869603099830702, 11.920873405476966, 11.972143711123232, 12.0234140167695, 12.074684322415765, 12.125954628062033, 12.177224933708299, 12.228495239354565, 12.279765545000831, 12.331035850647098, 12.382306156293366, 12.43357646193963, 12.484846767585896, 12.536117073232164, 12.587387378878429, 12.638657684524697, 12.689927990170963, 12.741198295817227, 12.792468601463495, 12.843738907109762, 12.895009212756028, 12.946279518402294, 12.99754982404856, 13.048820129694828, 13.100090435341093, 13.151360740987359, 13.202631046633627, 13.253901352279891, 13.30517165792616, 13.356441963572426, 13.407712269218692, 13.458982574864958, 13.510252880511224, 13.561523186157492, 13.612793491803757, 13.664063797450023, 13.715334103096291, 13.766604408742555, 13.817874714388823, 13.86914502003509, 13.920415325681354, 13.971685631327622, 14.022955936973888, 14.074226242620156, 14.12549654826642, 14.176766853912687, 14.228037159558955, 14.27930746520522, 14.330577770851486, 14.381848076497754, 14.433118382144018, 14.484388687790286, 14.535658993436552, 14.586929299082817, 14.638199604729085, 14.689469910375351, 14.740740216021619, 14.792010521667883, 14.84328082731415, 14.894551132960418, 14.945821438606682, 14.99709174425295, 15.048362049899216, 15.09963235554548, 15.150902661191749, 15.202172966838015, 15.253443272484283, 15.304713578130547, 15.355983883776814, 15.407254189423082, 15.458524495069346, 15.509794800715612, 15.56106510636188, 15.612335412008145, 15.663605717654413, 15.714876023300679, 15.766146328946943, 15.817416634593211, 15.868686940239478, 15.919957245885746, 15.97122755153201, 16.022497857178276, 16.073768162824543, 16.12503846847081, 16.176308774117075, 16.227579079763345, 16.278849385409607, 16.330119691055877, 16.38138999670214, 16.43266030234841, 16.483930607994672, 16.535200913640942, 16.58647121928721, 16.637741524933475, 16.68901183057974, 16.740282136226007, 16.79155244187227, 16.84282274751854, 16.894093053164806, 16.945363358811072, 16.996633664457338, 17.047903970103604, 17.099174275749874, 17.150444581396137, 17.201714887042403, 17.25298519268867, 17.304255498334935, 17.3555258039812, 17.40679610962747, 17.458066415273734, 17.509336720920004, 17.560607026566267, 17.611877332212536, 17.6631476378588, 17.71441794350507, 17.765688249151335, 17.8169585547976, 17.868228860443867, 17.919499166090134, 17.970769471736396, 18.022039777382666, 18.073310083028932, 18.1245803886752, 18.175850694321465, 18.22712099996773, 18.278391305614, 18.329661611260263, 18.38093191690653, 18.432202222552796, 18.483472528199062, 18.53474283384533, 18.586013139491598, 18.63728344513786, 18.68855375078413, 18.739824056430393, 18.791094362076663, 18.842364667722926, 18.893634973369196, 18.94490527901546, 18.996175584661728, 19.047445890307994, 19.09871619595426, 19.149986501600523, 19.201256807246793, 19.25252711289306, 19.303797418539325, 19.35506772418559, 19.406338029831858, 19.457608335478128, 19.50887864112439, 19.56014894677066, 19.611419252416923, 19.662689558063192, 19.713959863709455, 19.765230169355725, 19.816500475001988, 19.867770780648257, 19.91904108629452, 19.97031139194079, 20.021581697587052, 20.072852003233322, 20.124122308879585, 20.175392614525855, 20.226662920172117, 20.277933225818387, 20.32920353146465, 20.38047383711092, 20.43174414275719, 20.483014448403452, 20.53428475404972, 20.585555059695984, 20.636825365342247, 20.688095670988517, 20.739365976634787, 20.79063628228105, 20.84190658792732, 20.89317689357358, 20.94444719921985, 20.995717504866114, 21.046987810512384, 21.098258116158647, 21.149528421804916, 21.200798727451186, 21.25206903309745, 21.30333933874371, 21.35460964438998, 21.405879950036244, 21.457150255682514, 21.508420561328784, 21.559690866975046, 21.61096117262131, 21.66223147826758, 21.71350178391385, 21.76477208956011, 21.81604239520638, 21.867312700852644, 21.918583006498906, 21.969853312145176, 22.021123617791446, 22.07239392343771, 22.12366422908398, 22.17493453473024, 22.22620484037651, 22.277475146022773, 22.328745451669043, 22.380015757315306, 22.431286062961576, 22.48255636860784, 22.533826674254108, 22.58509697990037, 22.63636728554664, 22.687637591192903, 22.738907896839173, 22.790178202485443, 22.841448508131705, 22.892718813777975, 22.943989119424238, 22.9952594250705, 23.04652973071677, 23.09780003636304, 23.149070342009303, 23.200340647655572, 23.251610953301835, 23.302881258948105, 23.354151564594368, 23.405421870240637, 23.4566921758869, 23.50796248153317, 23.55923278717944, 23.610503092825702, 23.661773398471965, 23.713043704118235, 23.764314009764497, 23.815584315410767, 23.866854621057037, 23.9181249267033, 23.969395232349562, 24.020665537995832, 24.071935843642102, 24.123206149288364, 24.174476454934634, 24.225746760580897, 24.27701706622716, 24.32828737187343, 24.3795576775197, 24.430827983165962, 24.48209828881223, 24.533368594458494, 24.584638900104764, 24.635909205751027, 24.687179511397296, 24.73844981704356, 24.78972012268983, 24.84099042833609, 24.89226073398236, 24.943531039628624, 24.994801345274894, 25.046071650921157, 25.097341956567426, 25.148612262213696, 25.19988256785996, 25.25115287350623, 25.30242317915249, 25.353693484798754, 25.404963790445024, 25.456234096091293, 25.507504401737556, 25.558774707383826, 25.61004501303009, 25.66131531867636, 25.71258562432262, 25.76385592996889, 25.815126235615153, 25.866396541261423, 25.917666846907693, 25.968937152553956, 26.02020745820022, 26.071477763846488, 26.12274806949275, 26.17401837513902, 26.22528868078529, 26.276558986431553, 26.327829292077816, 26.379099597724085, 26.430369903370355, 26.481640209016618, 26.532910514662888, 26.58418082030915, 26.635451125955413, 26.686721431601683, 26.737991737247953, 26.789262042894215, 26.840532348540485, 26.891802654186748, 26.943072959833017, 26.99434326547928, 27.04561357112555, 27.096883876771813, 27.148154182418082, 27.199424488064352, 27.250694793710615, 27.301965099356877, 27.353235405003147, 27.40450571064941, 27.45577601629568, 27.50704632194195, 27.558316627588212, 27.609586933234482, 27.660857238880745, 27.712127544527007, 27.763397850173277, 27.814668155819547, 27.86593846146581, 27.91720876711208, 27.968479072758342, 28.01974937840461, 28.071019684050874, 28.122289989697144, 28.173560295343407, 28.224830600989677, 28.276100906635946, 28.32737121228221, 28.37864151792847, 28.42991182357474, 28.481182129221004, 28.532452434867274, 28.583722740513544, 28.634993046159806, 28.68626335180607, 28.73753365745234, 28.78880396309861, 28.84007426874487, 28.89134457439114, 28.942614880037404, 28.993885185683666, 29.045155491329936, 29.096425796976206, 29.14769610262247], \"y\": [0.0029325900505248513, 0.0030431355426489364, 0.003157425432399065, 0.003275573601544574, 0.0033976937239907604, 0.0035238988210937842, 0.0036543007980711557, 0.003789009963503875, 0.0039281345340783, 0.004071780126855267, 0.004220049241480137, 0.004373040734859552, 0.004530849290928275, 0.004693564888212874, 0.0048612722679671466, 0.005034050405708173, 0.005211971989020867, 0.005395102904524191, 0.005583501736902962, 0.005777219282907108, 0.005976298083204616, 0.00618077197494665, 0.006390665667863209, 0.006605994346656032, 0.0068267633023926955, 0.0070529675955319756, 0.007284591753126058, 0.007521609502650344, 0.007763983544806216, 0.008011665367526084, 0.008264595103283591, 0.008522701431674594, 0.008785901529085418, 0.009054101067104907, 0.009327194261163992, 0.009605063970701348, 0.009887581851955143, 0.01017460856426885, 0.010465994030572525, 0.010761577752460163, 0.011061189180028049, 0.01136464813636829, 0.011671765296326722, 0.011982342718834646, 0.012296174431810547, 0.01261304706830199, 0.012932740552200356, 0.013255028831513754, 0.013579680656828045, 0.013906460402225379, 0.014235128925566125, 0.014565444464676244, 0.014897163565623388, 0.015230042038911977, 0.015563835939087492, 0.015898302562914517, 0.016233201460988722, 0.016568295457362364, 0.016903351671512325, 0.017238142536762834, 0.017572446809096476, 0.017906050560152206, 0.01823874814811998, 0.01857034316020517, 0.018900649320351445, 0.01922949135598587, 0.019556705817682117, 0.01988214184583298, 0.02020566187867898, 0.020527142296359175, 0.020846473996029815, 0.02116356289353705, 0.02147833034762823, 0.021790713503238187, 0.022100665550990585, 0.02240815590070246, 0.022713170267368143, 0.023015710668820452, 0.023315795335013812, 0.02361345852963933, 0.02390875028555694, 0.02420173605630489, 0.02449249628671521, 0.02478112590641226, 0.025067733750695584, 0.025352441913993773, 0.02563538504171769, 0.025916709566928136, 0.026196572898758118, 0.026475142569983973, 0.026752595351518572, 0.027029116341894723, 0.027304898040014264, 0.02758013940955532, 0.027855044943451764, 0.028129823736784364, 0.028404688576254476, 0.0286798550541448, 0.02895554071431526, 0.02923196423733426, 0.02950934467131563, 0.029787900714422062, 0.030067850054315465, 0.03034940876909266, 0.03063279079344683, 0.030918207452956235, 0.03120586706852622, 0.03149597463211508, 0.0317887315539672, 0.03208433548066851, 0.032382980182446224, 0.032684855507260996, 0.03299014739840312, 0.03329903797151057, 0.033611705646188615, 0.033928325326734066, 0.03424906862586528, 0.03457410412483123, 0.03490359766283388, 0.035237712648345194, 0.03557661038463961, 0.03592045040169899, 0.036269390786575845, 0.036623588504325955, 0.03698319970173779, 0.037348379986294394, 0.03771928467309485, 0.03809606899283547, 0.03847888825439694, 0.038867897956097026, 0.03926325384024057, 0.03966511188622005, 0.04007362823808524, 0.04048895906319652, 0.040911260339296866, 0.04134068756807125, 0.04177739541400251, 0.04222153726807002, 0.04267326473656005, 0.04313272705596588, 0.043600070435633534, 0.044075437330459676, 0.04455896564655708, 0.04505078788337601, 0.04555103021629216, 0.04605981152415106, 0.0465772423666876, 0.047103423917118546, 0.047638446855535775, 0.048182390229010115, 0.04873532028455155, 0.049297289281261966, 0.049868334288166054, 0.05044847597432075, 0.05103771739787712, 0.05163604280082013, 0.052243416416128834, 0.05285978129409951, 0.05348505815455142, 0.05411914427159877, 0.05476191239762073, 0.05541320973300361, 0.056072856948157, 0.05674064726423444, 0.057416345598904545, 0.05809968778343297, 0.058790379857241844, 0.05948809744601294, 0.06019248522928878, 0.060903156503408745, 0.06161969284547546, 0.06234164388389994, 0.06306852718089438, 0.06379982823208431, 0.06453500058818366, 0.0652734661034119, 0.06601461531503715, 0.06675780795808509, 0.06750237361887236, 0.06824761253058882, 0.06899279651367136, 0.06973717006317727, 0.07047995158477789, 0.07122033478034995, 0.07195749018344826, 0.0726905668441948, 0.07341869416232295, 0.07414098386626984, 0.07485653213532481, 0.07556442186091604, 0.07626372504216307, 0.07695350530984037, 0.07763282057190125, 0.07830072577270338, 0.07895627575707155, 0.07959852822933677, 0.08022654679651195, 0.0808394040838181, 0.08143618490986784, 0.0820159895079516, 0.08257793677907976, 0.08312116756170149, 0.08364484790237803, 0.08414817231112619, 0.08463036698468743, 0.0850906929806215, 0.08552844932487547, 0.08594297603535482, 0.08633365704400751, 0.08669992300006335, 0.08704125393730347, 0.0873571817886177, 0.08764729273160872, 0.08791122934963123, 0.08814869259341204, 0.08835944352926828, 0.08854330486093838, 0.08870016221313402, 0.08882996516613022, 0.08893272803199982, 0.08900853036448257, 0.08905751719593091, 0.08907989899628722, 0.08907595135062069, 0.08904601435334812, 0.08899049171890347, 0.08890984961026137, 0.088804615188365, 0.08867537488714654, 0.08852277242043312, 0.088347506528603, 0.08815032847437941, 0.0879320392986098, 0.0876934868482651, 0.08743556259020277, 0.08715919822545087, 0.08686536211988702, 0.08655505556819507, 0.08622930890887692, 0.085889177508877, 0.08553573763702821, 0.08517008224606289, 0.08479331668333248, 0.08440655435065822, 0.08401091233388536, 0.08360750702273906, 0.08319744974148398, 0.08278184241067955, 0.08236177325999335, 0.08193831261160338, 0.08151250875318967, 0.08108538391888327, 0.08065793039583202, 0.08023110677324975, 0.07980583434995385, 0.07938299371547765, 0.07896342151886461, 0.07854790743823588, 0.07813719136316764, 0.07773196080082859, 0.07733284851572975, 0.07694043041181581, 0.07655522366451059, 0.07617768510920048, 0.0758082098915223, 0.07544713038371367, 0.07509471537018456, 0.07475116950439212, 0.07441663303803803, 0.07409118182256692, 0.07377482758193102, 0.07346751845458464, 0.07316913980170581, 0.07287951527768904, 0.07259840815802601, 0.07232552291878434, 0.07206050706100593, 0.07180295317247837, 0.07155240121847985, 0.07130834105226394, 0.07107021513523144, 0.07083742145592906, 0.07060931663623278, 0.07038521921229342, 0.07016441307707447, 0.06994615107057237, 0.06972965870309812, 0.06951413799631005, 0.06929877142603148, 0.0690827259502569, 0.0688651571051728, 0.06864521315147178, 0.068422039252756, 0.0681947816673922, 0.0679625919348222, 0.0677246310370369, 0.06748007351571826, 0.06722811152542862, 0.0669679588032076, 0.06669885453500847, 0.0664200670996001, 0.06613089767085727, 0.06583068365978828, 0.06551880197819487, 0.0651946721065293, 0.06485775894931943, 0.06450757546246033, 0.06414368503772903, 0.06376570363106346, 0.0633733016224497, 0.06296620539668148, 0.06254419863578398, 0.06210712331551856, 0.0616548804001058, 0.061187430231091175, 0.060704792608141926, 0.06020704656146624, 0.05969432981749406, 0.05916683796141696, 0.05862482330215146, 0.05806859344723844, 0.057498509597109566, 0.05691498457001473, 0.05631848057070848, 0.055709506717700384, 0.05508861634549337, 0.05445640409972168, 0.0538135028444701, 0.05316058040226458, 0.052498336148291934, 0.05182749748128951, 0.05114881619426316, 0.05046306476871971, 0.04977103261643602, 0.04907352229293691, 0.04837134570680289, 0.04766532034868622, 0.04695626556348558, 0.046244998888508054, 0.04553233247965285, 0.04481906964668435, 0.044106001517536256, 0.04339390385031473, 0.04268353401025955, 0.04197562812739761, 0.0412708984489875, 0.04057003089913823, 0.039873682856196205, 0.03918248115665278, 0.03849702033244859, 0.03781786108666395, 0.03714552901068894, 0.036480513544100465, 0.03582326717663699, 0.03517420488987949, 0.03453370383452912, 0.03390210323754027, 0.033279704531826194, 0.03266677169981601, 0.03206353182082733, 0.031470175811019734, 0.03088685934363007, 0.030313703936265892, 0.029750798191244033, 0.029198199174318498, 0.028655933916643457, 0.028124001024457973, 0.02760237238076772, 0.02709099492321692, 0.026589792482405082, 0.026098667665080445, 0.025617503766951807, 0.025146166700272286, 0.024684506921874776, 0.024232361347951214, 0.023789555242575627, 0.023355904067745712, 0.02293121528356487, 0.022515290088086597, 0.022107925087286793, 0.021708913886611367, 0.021318048596550614, 0.02093512124571067, 0.020559925095878884, 0.02019225585460139, 0.019831912781800295, 0.019478699687949665, 0.019132425822290525, 0.018792906650496922, 0.018459964522091678, 0.018133429228758612, 0.017813138455488448, 0.017498938127240182, 0.017190682654481173, 0.01688823508159412, 0.016591467142699722, 0.016300259229944738, 0.01601450027973655, 0.015734087582777476, 0.015458926524056074, 0.015188930259194688, 0.014924019333731267, 0.014664121252031245, 0.014409170002584862, 0.014159105546445236, 0.013913873275512141, 0.013673423447261005, 0.013437710602364646, 0.013206692971458095, 0.012980331877058876, 0.012758591136376597, 0.01254143647043815, 0.012328834924611676, 0.01212075430524885, 0.011917162636774534, 0.011718027643149642, 0.011523316257210923, 0.011332994160965499, 0.011147025359480837, 0.010965371790577341, 0.01078799297209562, 0.010614845688084172, 0.01044588371483468, 0.010281057587287683, 0.0101203144059428, 0.009963597684037458, 0.009810847234411045, 0.009661999095147032, 0.009516985492787903, 0.00937573484164856, 0.009238171777513533, 0.009104217223792689, 0.008973788488033058, 0.008846799386535785, 0.00872316039471345, 0.008602778820737766, 0.008485558999975478, 0.008371402507686065, 0.00826020838746033, 0.008151873392910543, 0.008046292240180157, 0.007943357868920213, 0.007842961709481495, 0.007744993954189098, 0.0076493438307014645, 0.007555899875603181, 0.007464550206538631, 0.007375182791358654, 0.007287685712922207, 0.00720194742836711, 0.007117857021834351, 0.007035304449799128, 0.006954180778323566, 0.006874378411701118, 0.006795791312107495, 0.006718315210007214, 0.006641847805185134, 0.006566288958380432, 0.006491540873591715, 0.006417508271199899, 0.0063440985521155575, 0.006271221953203764, 0.006198791694268516, 0.006126724116894015, 0.006054938815440525, 0.005983358760479563, 0.005911910414928281, 0.00584052384310734, 0.005769132812901247, 0.005697674891147639, 0.005626091532323431, 0.005554328160532622, 0.0054823342447357275, 0.005410063367094482, 0.005337473284241235, 0.005264525981219906, 0.005191187717788504, 0.005117429066720693, 0.005043224943700016, 0.004968554628363554, 0.004893401776025352, 0.004817754419592635, 0.004741604961182218, 0.004664950152949134, 0.004587791066656119, 0.004510133051540262, 0.004431985680071902, 0.004353362681250316, 0.004274281861140889, 0.004194765010427158, 0.0041148377988292125, 0.0040345296563252, 0.003953873641204249, 0.0038729062950760788, 0.0037916674850633336, 0.003710200233506097, 0.003628550535612026, 0.003546767165590287, 0.003464901471909572, 0.0033830071624200955], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": null, \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "pcttips = data['pcttip']\n",
    "# Removing data points that are greater than the 99% quantile\n",
    "# sns.distplot(pcttips[pcttips < pcttips.quantile(0.99)], rug=True)\n",
    "py.iplot(ff.create_distplot([pcttips[pcttips < pcttips.quantile(0.99)]], group_labels=[\"Percent Tip\"], \n",
    "                            bin_size=.5))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden",
    "solution2_first": true
   },
   "source": [
    "### Observations?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden"
   },
   "source": [
    "1. This distribution is more symmetric than before (perhaps slightly skewed to the right) and appears to be centered around $15\\%$ which is the customary amount to tip in the United States.\n",
    "1. How many modes do we see? One and maybe two?  Is this something we would expect (15% or 20% tips?)."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "\n",
    "# Defining the Model\n",
    "\n",
    "Let's begin with the goal of **estimating the percentage tip** that this waiter receives.  The percentage tip could depend on a lot of factors including the time of day, to the characteristics of the patrons, and the service of the waiter.  \n",
    "\n",
    "However, let's start simple by ignoring these factors and defining the percentage tip as a constant value:\n",
    "\n",
    "$$\\Large\n",
    "\\text{percentage tip} = \\theta^*\n",
    "$$\n",
    "\n",
    "Here the parameter $\\theta^*$ is the true tip rate. We don't know this value but we believe that such a value exists.  The $*$ character indicates that this is the unknown quantity that the universe determines.  I like to remember that the star $*$ quantity is determined by the universe.\n",
    "\n",
    "Is this model correct? Maybe ... probably not.  However, this model probably provides reasonable predictions about future tips and might provide some insight into common tipping practices.  \n",
    "\n",
    "How do we estimate the value for $\\theta^*$ from our data?  This is the fundamental question of estimation.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown",
    "solution2_first": true
   },
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "## How do we estimate the parameter $\\theta^*$ of our tip model?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown"
   },
   "source": [
    "There are actually many ways we could estimate this parameter. \n",
    "1. 15.0 <-- thats what Wikipedia suggests.\n",
    "1. Pick a data point at random \n",
    "1. Look at the histogram and choose the **mode** for our estimate\n",
    "1. We could choose the mean for our estimate. This is the balance point of the histogram.\n",
    "1. We could choose the median for our estimate.\n",
    "\n",
    "**Which of these strategies is best?**  It depends on our goals."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "# Optimizing an Objective Function\n",
    "\n",
    "One method to estimate the value for the parameter $\\theta^*$ is to define an objective function which characterizes the quality of our choice of $\\theta^*$ with respect to the data.  We can then choose the *best* parameter $\\theta$ with respect to this objective function. \n",
    "\n",
    "**How do we define an objective function?**\n",
    "\n",
    "Perhaps a natural objective function would penalize parameter values for $\\theta^*$ that are inconsistent with the data.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "# Loss Functions\n",
    "\n",
    "At the core of most estimation procedures is a **loss function** which measures how well a model fits the data.  Suppose we observed a single tip percentage $y$ and our model predicts $\\theta$ as our guess for $\\theta^*$, then any of the following might be appropriate **loss functions**\n",
    "\n",
    "1. **Squared Loss** (also known as the $L^2$ loss pronounced \"ell-two\"):\n",
    "$$\\Large\n",
    "L\\left(\\theta, y \\right) = \\left( y - \\theta \\right)^2\n",
    "$$\n",
    "1. **Absolute Loss** (also known as the $L^1$ loss pronounced \"ell-one\"):\n",
    "$$\\Large\n",
    "L\\left(\\theta, y \\right) = \\left| y - \\theta \\right|\n",
    "$$\n",
    "1. **Huber Loss** (combines both Squared and Absolute Loss):\n",
    "\n",
    "$$\\Large\n",
    "L_\\alpha\\left( \\theta, y \\right) = \n",
    "\\begin{cases} \n",
    "      \\frac{1}{2}\\left( y - \\theta \\right)^2 & \\left| y - \\theta \\right| < \\alpha \\\\\n",
    "       \\alpha \\left(\\left| y - \\theta \\right| - \\frac{\\alpha}{2} \\right) & \\text{otherwise}\n",
    "\\end{cases}\n",
    "$$\n",
    "\n",
    "These loss functions effectively measure the **error** in our estimate relative to the data.  Let's examine how they work on a real observations."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Visualizing the Loss\n",
    "\n",
    "Suppose we observe a single tip percentage for $16\\%$:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "y_obs = 16"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "We will try a range of possible $\\theta$ values"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "thetas = np.linspace(0, 50, 200)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Squared Loss \n",
    "\n",
    "$$\\Large\n",
    "L\\left(\\theta, y \\right) = \\left( y - \\theta \\right)^2\n",
    "$$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def squared_loss(est, y_obs):\n",
    "    return (est - y_obs)**2"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 15,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAZUAAAERCAYAAACzejr1AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\njDlJU9sN1AAAAABJRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f2ee6d8>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = squared_loss(thetas, y_obs)\n",
    "plt.plot(thetas, loss, label=\"Squared Loss\")\n",
    "plt.vlines(y_obs, -100, 0, colors=\"r\", label=\"Observation\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend(loc=4)\n",
    "plt.savefig(\"l2_plt.pdf\")\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "From the above plot we see that the value for $\\theta$ that minimizes the loss corresponds to $\\theta = y = 16\\%$.  Let's look at the other loss functions:"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Absolute Loss\n",
    "\n",
    "$$\\Large\n",
    "L\\left(\\theta, y \\right) = \\left| y - \\theta \\right|\n",
    "$$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 16,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def abs_loss(est, y_obs):\n",
    "    return np.abs(y_obs - est)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 17,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYYAAAEPCAYAAABGP2P1AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e8005c0>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = abs_loss(thetas, y_obs)\n",
    "plt.plot(thetas, loss, label=\"Abs Loss\")\n",
    "plt.vlines(y_obs, -5, -2,colors=\"r\", label=\"Observation\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend()\n",
    "plt.savefig(\"l1_plt.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Again we see that the loss function is minimized when $\\theta = y = 16\\%$ = "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Huber Loss\n",
    "\n",
    "$$\\Large\n",
    "L_\\alpha\\left( \\theta, y \\right) = \n",
    "\\begin{cases} \n",
    "      \\frac{1}{2}\\left( y - \\theta \\right)^2 & \\left| y - \\theta \\right| < \\alpha \\\\\n",
    "       \\alpha \\left(\\left| y - \\theta \\right| - \\frac{\\alpha}{2} \\right) & \\text{otherwise}\n",
    "\\end{cases}\n",
    "$$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 18,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def huber_loss(est, y_obs, alpha = 1):\n",
    "    d = abs_loss(est, y_obs)\n",
    "    return np.where(d < alpha, \n",
    "                    squared_loss(est, y_obs) / 2.0,\n",
    "                    alpha * (d - alpha / 2.0))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 19,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAY4AAAEPCAYAAABV6CMBAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nAAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e7ef748>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = huber_loss(thetas, y_obs, alpha=5)\n",
    "plt.plot(thetas, loss, label=\"Huber Loss\")\n",
    "plt.vlines(y_obs, -20, -5,colors=\"r\", label=\"Observation\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend()\n",
    "plt.savefig('huber_loss.pdf')"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Comparing all the loss functions at once.\n",
    "\n",
    "In the following plot we plot all three loss functions. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 20,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAY4AAAEUCAYAAAA8+dFZAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz\nAAALEgAACxIB0t1+/AAAIABJREFUeJzsnXd4FGXXh+/Z3fTeSQ+BZBAURUBAEAQLCKKIFEERpImI\nogKK7fW1fCAigoBSBFRQQToqKDZERCkixVdgkhDSSO892TLfH5OEIiVlN7tJ5r4uL5NhM3Oe3dnn\nN8855zlHkGUZFRUVFRWV2qKxtgEqKioqKk0LVThUVFRUVOqEKhwqKioqKnVCFQ4VFRUVlTqhCoeK\nioqKSp1QhUNFRUVFpU7orG1ANaIozgTmAJUXHL4H+B+wBugHFACvS5K0uvEtVFFRUVEBGxIOoBPw\nkiRJ7154UBTFzUAxEAB0BL4VRfEfSZIOWMFGFRUVlRaPLbmqOgHHLjwgiqIrMAR4TZKkckmSDgFf\nAI9awT4VFRUVFWxkxSGKojMgAtNFUfwMyAPmA0cBvSRJ8Re8XAKGNr6VKioqKipgI8KB4ob6DVgG\nPAh0A74GFgBll7y2FHCu7YllWZYFQTCTmU2fnIIyxr3xPQALn+1D2xBPK1vUPMjILWXi//0AwNKZ\nfQkPdLeyRSr1QZZlzr5ylqQ5SQD4P+RPu3Xt0OhsyTnTaFxx4rQJ4ZAk6SzQ54JD+0RRXAf0Bhwv\nebkzSsyjVuTklKCp52eu0Qh4erqQn1+CydQ8anrJsoydToPeYCIuMQdv54tvgeY45qthrvHGnM2t\n+dleI5ObW+tbtNFpaZ8x1H7M6fPOkflOGgAeg70IeD+U/MLSxjLTrDT0c/b2dr3iv9mEcIiieDNw\ntyRJb19w2BFIAvqKohgmSVJS9cuBk7U9tyzLGI0Ns89kkjEam88XzM/TidTsEtJzSq84ruY25mvR\n0PGm5yiTi4erPTqNpkm8dy3tM4arjzlrYVqNaLgN8CB4eWtMAtDE3yNLfM42IRwoK4jXRFGMA7YC\nfYGHUFYhnsBcURQnAR2A0cBAaxnaHPCvEo6s/Eu9gCr1JbPqvQzwdLKyJSr1IXtJOplzUwFwvcuD\nkI8iEexUF/eVsAnHnSRJMcAI4D9AEfAh8JgkSX8BkwA7IAXYAsySJOmgtWxtDvhVTW6ZeapwmIvq\n99LPSxWOpkb28gwy3jwHgGtfd0JXR6JxsImp0WaxlRUHkiR9jRIQv/R4LoqoqJgJ/6rJLVNdcZiN\nauHwV1ccTYqcVZlk/CcFAJfeboR+0gaNoyoa10J9h1ogAVXCkVtYQaW+gQEgFWRZrnH7+XvVOuFP\nxcrkfpJF+kvJADj3dCVsbVs0TuqUWBvUd6kFEuB9fnJTVx0Np7BUT0WVAPurrqomQd7n2aQ9r+Tb\nOHdzJWxdWzTO6nRYW9R3qgXi4+6ITqsE/jJyVeFoKJl559M1/VRXlc2TvyGH1OcSAXDq7ELY+rZo\nXbVWtqppoQpHC0SjEWomuIy8ppmjbktUxzdcHHW4OtlZ2RqVq5G3OYdz0xNABqdOzoR/GaWKRj1Q\nhaOFElDli8/IVYWjoaRXvYcXugBVbI/MjZkkP3EWZHDsWCUa7qpo1AebyapSaVwCvKtWHKpwNJjq\n9zBADYzbLAVf55E44QyYwLGDE+Ebo9B6qtNffVHfuRZK9dNxhrqXo8GkV8WJWnmr8Q1bpGh3PkkT\n48EIDu0cCd8Uhc5bnfoaguqqaqFUPx0XlFRSVmGwsjVNF5Ms1wTHVVeV7VH0UwHJE+LBIOPczpnI\nbSI6XzUO1VBU4WihBFyQNqruIK8/+UUVVBpMALRShcOmKN5TSPK4M8iVMvZtHLjx5xux81dFwxyo\nwtFC8XRzwN5O+fjVzKr6c2GMSN3DYTsU7yskaWwccoWMXbg9kdtEHAIdrG1Ws0EVjhaKRhDw91Se\nkNPVAHm9Sa9arXm5OeBor/rNbYGSP4pIGnMGuVzGLsyeiG0i9sH21jarWaEKRwvmfGaV6qqqL+cz\nqtTVhi1QerCYpFFxyKUm7ILtiNgajX2IKhrmRhWOFky1Tz5TdVXVG3UPh+1QeqSExFGxmEpN6FrZ\nEbFVxD5MdU9ZAlU4WjDVPnnVVVV/1D0ctkHZsRISR8ZiKjah89cRsS0a+9aqaFgKVThaMNUrjpJy\nA8Vleitb0/QwGE1k5ZcDakaVNSn7u5TEEbGYCo1ofXVEbI3Goc2lHadVzIkqHC2YC5+S1cyqupNd\nUI5JVlpyBqib/6xC+ckyEofHYMw3ovXREbElGodo9bOwNKpwtGDcnO1wclBq9ailR+pOtYtPIwhq\nVVwrUC6VkTAsBmOuEa2XlohNUThep34OjYEqHC0YQRAuKHaoZlbVlWqx9fV0RKdVv0qNSUVsOYlD\nYzBmG9B4aAnfFI3j9aq7sLFQ7/YWzvmaVeqKo65UC4ca32hcKuLLSRgagyHLgMZNQ8TGKJw6qp9B\nY6IKRwunev+BuuKoO+lqRlWjU5lQoYhGhh6Ni4bwDVE4dXKxtlktDlU4WjjVT8vpuaXIVYFeldpR\nXVlYrYrbOFQmV4lGqh7BWUPY+rY4d3W1tlktEpurkSCKYgDwNzBekqRvRFH0AtYA/YAC4HVJklZb\n08bmRKCP8rRWoTeSV1SBn7oDulaUVxrIK6oA1M1/jYH+XCUJD8SgT6lEcBII/7wtLt3drG1Wi8UW\nVxyrAZ8Lfv8IKAYCgGHAO6IodreGYc2RC/3zaTlqnKO2XFhRWI1xWBZ9WiUJQ2PQJ1UiOAqErW2L\nS09VNKyJTQmHKIpTgBIguep3V2AI8JokSeWSJB0CvgAetZ6VzQsHey0+7soO27ScEitb03Sojm/Y\n6TR4uqk7lC2FPkNPwtAYKs9WINgLhH3SBtc+7tY2q8VjM64qURSjgRlAN+CvqsNRgF6SpPgLXioB\nQ2t7XkEQ0NRTHjUa4aL/N1cCfV3IKawgPbe0xYy5mvqON/2CjCo7nU09f12TpvIZG7L0JA6LofJM\nBYKdQPgnbXC/y7Ne52oqYzYnlhyzTQiHKIo6YB3wtCRJuaIoVv+TC3Bpuk8pUGvfgI+PC4LQsDfO\n07N5Z21EBnvyv/hcsgsrasba3Md8KXUdb05RJQARQR54ezfNAK0tf8aV2ZUcH36KCqkcQSfQfmN7\n/Ib4Nfi8tjxmS2GJMduEcACvAsckSfr2kuOlwKVFZ5xRYh61IienpEErDk9PF/LzSzCZmm/GkZeL\n0hUtKb2Q/PySFjHmaur7GSekFgDg625Pbm6tb0ebwNbva0OegfgHJMr/LgMthH7UGm1vpwa9z7Y+\nZkvQ0DFf7YHIVoRjJBAoiuLIqt/dgQ3APMBeFMUwSZKSqv5NBE7W9sSyLGM0Nsw4k0nGaGy+N1t1\ncDe/uJLiUj2ens1/zJdSl/GaTHJNIkErb5cm+z7Z4mdsLDCQMCxWEQ0NhHzYGrdBXmaz0xbHbGks\nMWabEA5Jktpd+LsoignAtKp03JuAuaIoTgI6AKOBgY1uZDOmlc/5pWxaTgkhQfXzI7cUsgvKMBiV\nPuOBPmpGlbkwFhlJfCiO8uOlIEDwkgg8HvC2tlkql6EpRPUmAXZACrAFmCVJ0kHrmtS8cHe2w8VR\neYZIzVYzq65FatVqQxDUXePmwlhsJPGhWMqOKPdf0KJwPIf7XOOvVKyFTaw4LkWSpIgLfs4FRljP\nmuaPIAi08nHmzLlCdS9HLahOW/b3dGpyGVW2iKnESNLDcZQdVt7XwAVheI3ytbJVKldDvetVAAj0\nVtxV6orj2qRlK+Ia6NPyMnTMjanURNKjZyj9Qwl8B74diveYhmdPqVgWVThUAAj0VVwu6orj2lSv\nOKrfM5X6YSo3kTQ2jpJ9RQC0eisE7/H+VrZKpTaowqECnF9xZOaVoTeYrGyN7SLLck2MI0hdcdQb\nU4WJ5MfOULJXEY2A14LxmRxgZatUaosqHCrA+adnkyyTlt209iU0JgUllZRVGADVVVVfTJUmUibG\nU/xTIQD+Lwfh+2QrK1ulUhdU4VABwNfDEZ1W2WGfnKkKx5VIuyAGpKbi1h1ZL5My+SxFu5UNlH7P\nB+I3PdDKVqnUFVU4VADQajQ15cFTMousbI3tUu2m8nJzwMnBJpMSbRbZIJMy9SxFu/IB8H2uFf4z\ng6xslUp9UIVDpYbAauHIUFccV6ImMK6uNuqEbJQ5Ny2Bwh15APg+FYD/C6poNFVU4VCpodpnr644\nrkx11pka36g9skkm9ZlECrbmAuDzuD/+rwQ3uPioivVQhUOlhuqn6JTMYkxqG9nLklq14ghSVxy1\nQjbJpM5IJP/LHAC8J/oR8EaIKhpNHFU4VGoI8lWeossrjeQUlFvZGtujtNxAQbFSTl1dcVwbWZZJ\neyGJ/M8V0fAa60ur/wtVRaMZoAqHSg2BPs5oqr7UKWpm1b+4sENioK8qHFdDlmXSX0om79NsADwf\n8SVwXpgqGs0EVThUarDTaQnwdgIgJUstPXIp1W4qF0cd7s52VrbGdpFlmYz/pJC7OgsAz5E+BL0b\nhtCCuu/ZAiUlJRQVWSZeqQqHykWE+CvNW85lqSuOSzlXJaZBvg3vKtlckWWZjDfPkbMiEwCPod4E\nLQpXRaMRycrK4j//eYno6AjatWtHZWWl2a+hJqKrXESInwuHT6krjstRLaYhfk2zVWxjkDkvlZyl\nGQC43+9F8NIIBK0qGo1Bbm4OH3ywmNWrV1BaqmT/OTs7YzKZ0GrNey1VOFQuonpSTMspwWA0odOq\ni9JqUqp2jYf4qfGNy5H5birZ76UD4DbIk5APWyPoVNGwNAUF+SxbtpSVK5dRXKy4ptzc3HnyyaeY\nPXsWRqO2eXYAVLEdqoXDYJTJzCurybRq6RSX6WsyqoLVFce/yHo/jax30gBw6+9ByIrWCHaqaFiS\noqJCVq5cxrJlSyksVEq4uLi48vjjTzBlyjR8fLzx8HBtUK/2K6EKh8pF+HspzYn0BhPnsktU4aji\nwiyzYHXFcRHZH6ST+X+pALje6U7Iqkg09upK1VIUFxezZs1KPvjgffLylJ34zs7OjB8/mSefnI6P\nj+U7J6rCoXIRGo1AaIAb8ecKOJdVTNd2an8EgJSq+IaXmwMujmpGVTU5KzLIeP0cAC63uxO6pg0a\nB1U0LEFpaSmffrqGJUveIztbSXN2dHRk7NgJPPXUs/j7N953VRUOlX8R3qpaONQAeTXnauIbqpuq\nmpzVmaS/mgKAy21uhH3aBo2jKhrmpry8nM8++4RFixaQmakkHtjb2zNmzDimT59Bq1aNX11YFQ6V\nfxHeyh04HwxWOb/iUN1UCrlrs0h/MRkA5x6uhK1tg8ZJFQ1zUllZyRdfrGPRondJTVVWdTqdjlGj\nxvDsszMJCQm1mm2qcKj8i/BARTgy80qp1BuxtzNzLl8TQ5blmtWXmlEFeeuzSZuZBIBTVxfCPm+L\nxqVl3yPmRK/Xs3Hjet577x2Sk5X3WavVMmLEKJ577nnCwyOsayA2JByiKI4AXgdCgUTgZUmStoui\n6AWsAfoBBcDrkiSttp6lzZ+wVm4AyLJSDTa86veWSk5BOeWVRkB1VeVvzCH1mUQAnDq7EL4hCq2r\nKhrmwGg0snnzlyxYMI+EhLMACILAgw+OYObMF4iMbGtlC89jE8IhimI08DFwlyRJv4uieCewUxTF\nYGA5UAwEAB2Bb0VR/EeSpAPWs7h54+fphKO9lvJKI+eyi1u8cFS77DSC0KL7cBRszeXc0wkgg+NN\nzoRvaIvWTRWNhmIymdixYyvz588lLi625vj99w9l1qwXiY4WrWjd5bEJ4ZAkKUYUxQBJkopFUdSh\niEQRUAkMAaIlSSoHDomi+AXwKKAKh4UQBIEQP1fi1AA5cH7HeIC3E3a6ljlRFnyVR8qTZ8EEjtc7\nEf5lFFoPm5g+miwmk4mdO79m/vw5nD59qub4wIGDef75l2jfvoMVrbs6NvPJV4lGayAWpYbWE0Ab\nQC9JUvyFLwWG1va8giCgqUfMrvJcJalvpmAcFYhd35bzlKmpqikU4q8IR2p2CdpmXDKieryaq9RS\nqsmo8ndtFu9FbcZ8IQU780iZchaM4Njeicit0eh8mlZKcl3HbElkWea773Yxb94c/v77RM3x/v0H\n8MILL3PjjTeZ5TqWHLPNCEcVyYATcBvwFfAOUHbJa0qBWs/kPj71K0iXujWVvE255G3Opd3adrR6\npFWdz9GUiQr34pej50jNLcXbu/n79T09rxz0ru76Fx3u3azei6uNuZrsb7JJmhAPBhnn9s7ctOcm\n7P3tG8E6y1CbMVsKWZbZvXs3//nPfzh8+HDN8f79+/P666/TrVs3i1zXEmO2KeGQJMlQ9ePPoihu\nAboAjpe8zBkl5lErcnJK6rXisLvTBacbnSk7XsrpsacpLa/Ec6h33U/UxNBoBDw9XfBxVSaHrLwy\nklPzmu2mt+rx5ueXYDL9u56PwWiq2TXu7WJnkfINjc21xlxN0U8FJDwSh6yXcWjrSPjmKIp1lZBr\n/mqrlqa2Y7YEsizz6697efvttzh06GDN8dtu68Ps2S/RvfutAGa/txo65qs9JNmEcIiiOBB4TpKk\nOy84bA+cAQaKohgmSVJS9cuBk7U9tyzLGI31MMpFQ+st0SQ+GEvJ8RKSpsRj0oDHYK96nKzpEXpB\n9lBiWhFiWPMet8kkX7YQ3LmsEoxVX7ogXxezF4uzJlcaM0Dx3kKSxsQhV8rYt3YgfGsUGl9dkx//\n1cZsCf74Yz9vv/0Wf/yxv+ZYt249mD37FXr2vA3A4vZYYsw2IRzAX0AXURTHAJ8DA4CBQDcgDJgr\niuIkoAMwuurfLI7OS8eNP97IX72PUn6qjJTH4xF0bXC/x7MxLm9VXJ3t8HZ3ILewgqSM4mYvHFei\neuOfvZ0GP08nK1vTOJTsLyLp0TjkChm7MHsitkZj16rpuqesweHDB5k3bw6//rqn5ljnzl144YVX\n6NOnb5Pv52ITWz0lSUoHBgPTgXzgDWCIJEmngUmAHZACbAFmSZJ08ErnMjf2vvZEbovGIdoRDJAy\nMZ6i7/Mb6/JWJcxfScNNyrRMF7GmQEqmEhgP9nWpaavbnCk5UETiw3HIZTJ2ofZEbIvGLlgVjdpy\n7NhfjBr1IIMG3VUjGh073sTnn29k166fuP32fk1eNMB2VhxIkrQPJaZx6fFcYETjW3QenZ8d4Vui\nSRgiUXmmguTx8YSubYNbPw9rmmVxQv1dORaXTXJG0/fr15ekDEU0Q/2b/16W0sPFJI2KQy41oQuy\nI2JLNPahDtY2q0nw998nmD9/Dt99t6vmWPv21/P88y9xzz2DmoVYXIhNrDiaAnYBdkRsjcY+wgG5\nUiZ57BmK9xZa2yyLEhagTJbnspWmTi0NWZZrhCM8oPlkU12O0r9KSHwoFlOJCd0F97rK1Tl9+hTj\nx4/hjjt61YhGdLTIqlWf8vPPvzFw4L3NTjRAFY46YRdYtXQPs0eukEl6NI6S/c3XjRNWNVkaTTKp\nLbDgYX5xJYWleuC8iDZHyk6UkjgyFlORCZ2fjoht0ThEXprMqHIhcXGxTJkynj59uvPNNzsAiIxs\nw4cffsTevQe4774H0NQnnbOJ0HxHZiHsgquChSH2yGUySQ/HUXKgebpyfD0ccXJQdkontUB3VfVq\nQxCUzX/NkfL/lZI4LAZTgRGtr47wrdE4tFVF40qcPRvPtGmP06tXV7Zu3Ywsy4SFRbB48TJ+++0w\nw4aNRGvuBt82iCoc9cA+zIGILdHoAu0wlZpIGhVL6eHmN7EKglDj22+JAfLEKuEI9HHBoRlWCC4/\nVUbC8FiM+Ua03loiNkfjKLaMzLG6kpycxLPPTuPWWzuzceN6TCYTwcEhLFiwmD/+OMJDDz2MTmcz\nIWOLowpHPbFv7UDEtmh0AXaYSkwkPhRL6V/Nz51T7a5qiQHy6lVWWDOMb5ScKiH+AQljjgGtp5bw\nTdE4tldF41JSU88xa9azdO/eic8/X4vRaKRVq0DefnsBBw4cZcyYcdjZNc/NsVej5UikBXCIdCRi\nq5JtZcgykDgylogt0Th1bD61rc6n5BYjy3KzDPRdiWpXVVgzy6iqiCvn9P0xGLIMaNy1hG+KwumG\n5nPPmoOMjHQWL36PtWs/pqKiAgA/P3+mT3+OMWMew8mpZYusKhwNxCHKUUnVHRqDMdtA4rAYIrZG\n43h98/giVj9tl1UYyC4obzmb4Mr1ZBeUA80ro6rybAUJQyT06Xo0rhrCv4zC6Ua1OVU12dnZLFmy\nkE8+WUVZmVImz9vbm2nTnuWxxybi4qK+V6AKh1lwbOdExKYoRTzyjCQMj1XE47qmP8kG+bqg1QgY\nTTJJGcUtRjguTAYIbSYZVZWJFSQMldCn6dG4aGi9MQrHzupECJCbm8OHHy5h1aoVlJYqLmdPT0+m\nTn2aiRMfx9W1edwD5kKNcZgJxw7OhG+ORuOhxZhjIOHBGCpiLi3s2/TQaTUE+yqTS7XrpiVQPVYf\nd0dcnZq+D7sypZKEB2PQn9MjOGvouKsjLt3UybCgIJ958/6PLl06snjxe5SWluDm5s6sWS/y559/\n88wzM1XRuAzqisOMON3gTMTGKBKGKW6rhKExROwQcWjTtNMbQwNcScosJjmz5QTIa+IbzcBNpU+t\nJOEBCX1SJYKjQOvP2+LZ27NZVPqtL0VFhXz00XKWLVtKQYFSQsjZ2YXJk5/giSem4eXV/CthNwRV\nOMyMUycXwr+MInFELIZMRTxabxexb910d+GG+buxn/QWlZKbWOWqCm/ibip9eiUJQ2PQJ1YiOAiE\nrW2La293a5tlNUpKSli5cgUffLCIvLw8AJycnBg/fjJPPjkdX19fK1vYNFCFwwI4d3ElfH0UiSNj\nMaTpSRgqEbFdxD68aYpH9VN3bmEFRaWVuDk376J3FXojaTmKnzusCfdbN2TqSXgwlsr4CgR7gdBP\n2uB6e8sUjbKyMhYu/Ii5c+eSlZUFgIODA+PGTWDatGcJCAiwsoVNCzXGYSGcu7kS9kVbBCcB/Tk9\nCQ/GUJnS9BrggFJuozoJNyG9+a86UrKKkavaFzTVFYchW0/CsBgqY8tBB6GrI3G7o3kX5bwcFRUV\nrF69gs6dO/Lcc8+RlZWFnZ0djz02kUOHjvPmm2+rolEPVOGwIC63uhH2WVsERwF9UpWfObXpiYeT\ng45WPkp68dnU5l3YEc5nVLk52+Hp2vRWV4ZcAwnDYqk4XQ5aCF0ZiVv/5t9D5kIqKyv59NM1dOt2\nEy++OIuMjHR0Oh2PPjqOgwePMW/eewQGBlnbzCaLKhwWxvU2d8I+bYvgIKBPrPI3Z+itbVadiQxU\nXBxn05q/cCSmK2MMC3BrchsejfkGEofHUHGyDDQQsrw17ve2nCZcBoOBL75Yx623dmbWrGdITT2H\nRqNh1KiHkSSJhQuXEBISam0zmzyqcDQCrn3dCf24DYKdQGV8BQlDYzBkNi3xiLhAOGS5abcPvRbx\nqYo7rnVg04oHGAuNJI6MpfxvRTSCP2iNx/0tIzvIaDSyceN6evbswjPPPElSUiKCIPDggyPYv/8w\nS5cuJzIy0tpmNhtU4Wgk3O70IGR1JOigMrachGExGLKbjnhEBimTaGGpntzCCitbYznKKw2cy1Zc\nVZFNSDiMRYpolB0tBQGC34/A88HmLxomk4nt27fQu3c3pk17nLNn4wG4774H+PXXgyxbtoo2baKs\nbGXzQxWORsR9gCehKyJBCxWny0kYFosh12Bts2pFiJ8rWo3itmnO7qrE9KKawHjroKYhHMZiI0mj\n4yg7omSCBS0Mx3Okj5WtsiyyLPPNN1/Rt++tTJ78GLGxMQDcc8+97NnzO6tWfYootrOylc0XVTga\nGffBXoQsaw0aqDhZRuLwGIz5ti8edjpNTVpucxaOs2nnd4x7uNh+YNxUaiJpTBylB5VVUuD8MLxG\nN9+9CLIss3v3t9x5Z2/Gj3+EU6dOAnDXXf354Ye9fPrpF3TocL2VrWz+qMJhBTyGeBO8NAIEKP+7\njMSRsRgLjdY265pEtIAAeXxqAXDeNWfLmMqqRGO/Ihqt5obiPdbPylZZBlmW+fnnH7nnnn6MGTOS\nv/8+DsDtt/dj164f+fzzTdx4YycrW9lyUIXDSngO8yH4/QgQoOyo0rrTWGTb4tG6lTKZJqQXYTI1\nzwB5tSjaemDcVG4iedwZSvYpK6SAN0LwmeBvZassw759exk8uD8PPTSUv/46AkDPnrfx1VffsXHj\ndrp0ucXKFrY8bGbnuCiKvYAFQDsgG3hHkqQVoih6AWuAfkAB8LokSautZ6n58HzIB9kgk/pcImVH\nSkgaFUvYhii0rrbZba7a519eaSQtt7Sm+GFzoaC4gpyqwL8trzhMFSaSJ8RTvEcRuYBXg/Gd0vw2\nsR048Dvz5v0f+/fvqzl2yy3dmT37FXr16m1Fy1RsYsVRJQ5fAe8DXsBwYK4oincCHwHFQAAwDHhH\nFMXu1rLV3Hg94kvgvDAASg+VkPRIHKZSk5WtujyB3s442CuiltAM3VXxVWPSCALhNlpqRNbLpEyK\np/gHxaXm/2IQvk+1srJV5uXPPw8xfPj93HffgBrRuPnmzmzYsJWvv96tioYNYBPCAYQDOyVJ+kKS\nJJMkSX8Be4BbgSHAa5IklUuSdAj4AnjUiraaHe/H/Gg1R9mUVPp7MUlj4jCV2Z54aDQCrasm1OYY\n54iv2hUf4mebPcZlg0zK4/EUfaeIht/MQPyeDbSyVebj+PGjjB49jIED72Tv3j0A3HDDjXz22Zd8\n++3P9Ot3Z5PbkNlcsQlXlSRJx4Ax1b9XrUBuA04AekmS4i98OTC0tucWBAFNPeVRU5V+Wv1/S+L/\neACCUSbt1RRK9hWR/NgZIta1RePYuNp+rTFHBrlzOimfs2lFaLVN/0t84Xir63BFBrvb3Nhkg0zS\ntAQKv1FKgPs/24qA2UH1mkgb876uDf/739+8/fb/8e23O2uOtW/fgRdeeIlBgwabRSxsbcyNgSXH\nbBPCcSGiKHoAXwNHUFYd0y95SSlQ676sPj4uDb7xPD0bx5fv/UpbnOzsiZ8dT/HPhaROTuD6Ldej\ncWj8heHl0QUQAAAgAElEQVSVxtwxOoBdB5JIzizGzd0JO53tPZnXB3d355pVVMcof7y9bacPh2yU\nOT3uNAVbcwEInRlK5DuRTea+vhInT57ktddeY/PmzTXH2rVrx+uvv86wYcPQ1PeJ7ypYe8zWwBJj\ntinhEEWxNfANcAYYCVwHXNoFyRkl5lErcnJKGrTi8PR0IT+/pNGyiFwneRNQUE7G3FRyd+Zy7IET\nhH8ciWDXOOJxrTH7uyt7GwxGE0dPpdM2uGlXXK0e7+n4LErLlf00AR4ONtPkSDbJpDydQN76HAB8\nH/fHc7Y/eXkl9T6nNe7rC4mLi2X+/LfZsmVTTfmayMg2zJo1mwcfHI5WqyU/v9Ss17T2mK1BQ8d8\ntYcnmxEOURRvBr4DPgNmSpJkEkUxFrAXRTFMkqSk6pcCJ2t7XlmWMTYwy9VkkjEaG+9m8302EFOl\nTNaCNAq/zSdxYjwhKyIR7BpvmX2lMXu42OPl5kBeUQVSYn5Nim5TJy5FiRs42GsJ8HJu1M/7Ssgm\nmbRZSTWi4T3eD/83QjCZABpuX2Pf1wkJZ1mwYB6bNm3ApAyCsLBwZsx4geHDH0KnU6YjS9rU2GO2\nBSwx5joJhyiKvkCJJEllVRP9IOBPSZK+bYgRoigGoIjGAkmS5lUflySpSBTFHSgZVpOADsBoYGBD\nrtcU8Hs+ENkgk/1+OoXf5JPy5FlCPmyNoLOuj1YQBKJCPDh0KpPYlHwGdAuzqj3m4sw5RThat3Kz\nCT+4LMukzU4mb102AF5jfGk1J7RJBoeTk5NYuHA+GzZ8jsGgrOqCg0N49tlZPPTQw9jb2/4OfZWL\nqbVwiKI4BFgPDBZFMQH4BUgGXhBF8UVJkpY0wI4JgB/wqiiKr15w/H1gErAcSEFxUc2SJOlgA67V\nJBAEAf+XgpArZXKWZVC4PY9zOoHgJREIVg7cRoV4VglHAbIsN8nJ7FJiqlYcbWzA9SbLMumvpJD3\nidKpznO0D4HzwxBsQNDqQlpaKosWvctnn32KXq8U9AwIaMUzz8zkkUfG4uDQNDtiqtRtxfEGSlrs\nj6IozgWSJUnqIIriYJQJvt7CIUnSHGDOVV4yor7nbsoIgkDAf4ORjTK5KzMp2JyLoBMIWhRu1Ukk\nKkSZXIvL9KTnlhLo07QDjkWllaRkKjGN6FDrNjySZZmM/54j96NMADyGexO0wLqfd13JyMhgyZL3\n+PTTNVRUKBsqfX39mD79OR59dDxOTk5WtlClodRFOKJRVhwAg4EdVT+fAJrXDiQbQhAEWr0ZgqyX\nyfs4i/wNOQh2glWfQEP8XHG011JeaSQ2paDJC8eps0q2kiBg1WC/LMtkzkklZ1kGAO4PeBG82Por\nzNqSnZ3N0qWL+PjjjygrKwPA29ubJ598hvHjJ+Hi0rTvE5Xz1EU4zgGdquIc7YHHq44PAs6a2zCV\n8wiCQODcUDDI5K3LVvzeWoHAedbxeWs0Am2DPfjf2VxiU/LpfWPTbsH5T7wSfA71d8XJwXr5Ilnv\npJH9fjoA7oM9CfmgdZMQjby8XJYtW8rKlcsoLVWyvTw8PJk69SkmTZqCq6tt7sJXqT91+Za8C2xG\nSec4IEnSflEUXwNe5oLNeyqWQdAoqwzZIJO/Poe8T7IQ7ARavRViFfGIClGEozobqSnzz1lFOKJD\nrOemynovjawFaQC43eNJyPJIqydCXIuCgnxWrPiQFSs+pKhI2QPj5ubO449P5fHHp+Lh0bL6nLck\nai0ckiQtE0XxAEp5kN1Vh3cD2yRJOmEJ41QuRtAIBL0XjmyQKdiUS+5HmQg6JQ7S2OIRVTXJZuSV\nUVBS2SR6V1yOCr2RuGRlN7a14htZi9PJfDsVANe7PQj5qHWjpl7XleLiIj76aDkffriEggLlvXN2\ndmHSpClMnfoUXl7Nv/NgS6eu6/LjwAlJkoyiKIYCUcBR85ulciUErUDw4ghkg0zhtjxylmUg2An4\nv1y/8hP1pXWQO1qNgNEkE5eST2exaZb0PnOuAGPV5qgoKwhH9rIMMt86B4BrP3dCV0eisbeVEnIX\nU1JSwpo1H/HBB4vIzVXiQk5OTjz22CSmTXsGX9/m20BK5WJqfYdWlT1PA/qIohgIHAIWA3+Jotgs\ns55iYiSKi21jB/GFCFqBkA9a436vMtFlL04n6520RrXBwU5bU0E2tgm7q6Qk5Ym5lbdzo6+aclZl\nkvFaCgAuvd0I/biNVcrLXIuysjJWrPiArl078uab/yE3NxcHBwcmT36CQ4dO8N//vqWKRgujLnfp\nAmADcABl30U5SqnzycB/zW6Zldm582t69OhCREQEixcvpKSk/iUeLIGgEwhZEYnbACULKGtBGlnv\nNa54VKflxqbkN+p1zUmMldxUuZ9kkf5SMgDOPV0JW9sWjZNtiUZFRQWrV6+kW7ebePXVF8nOzsLO\nzo5x4yZw8OAx3nprHgEBza8PiMq1qcud2hFlZ3cpcB+wXZKkSpRChK0tYZw1CQwMxNHRkZycHF5/\n/T907dqRFSs+qEkztAUEO4GQjyJxvUuZwDPfTiVrcXqjXb9tsDLZJqYXU1Fp290LL4fBaCKuase4\nGNZ4wpH3WTZpzysVdJy7uRK2ri0aZ9sRDb1ez9q1H9O9eydefHEm6elpaLVaHnlkLAcOHOWddxYS\nFBRsbTNVrEhd7tYcIKKqEGFnYFfV8VuAVHMbZm1uvrkLhw4dY8qUKdjZ2ZGdncWrr75It243sXr1\nypqNTdZG46AhdHUkrn2VmlGZb50ju2ofgKWpXnGYZJnYc01v1ZGYUUSlXqmZ1FgrjvwNOaTOSATA\nqYsLYevb2kzHR4PBwPr1n9GjR2dmzpzOuXMpaDQaRo4cze+/H+G995YQGto8SsyoNIy6CMcqlE1/\nB4BY4CdRFJ8C1gKLLGCb1QkODmbZsmUcOnSUhx9+FK1WS3p6Gi++OJPu3Tuxdu3HNaUUrInGUUPo\nJ21w6a3EHDJeSyGnauexJXF3sSfET9nUdSohz+LXMzexycpqw8fDET/PS4swm5/8zTmcm54AMjjd\n7Ey4jbQJNhqNbNq0gZ49uzB9+lSSkhIQBIGhQ4fz22+HWbJkOa1bR1rbTBUbotbCIUnSf4HHgLlA\nH0mSTCjlz4c1sE6VzRMWFs7ChUvZv/9PRowYhUaj4dy5FGbOnE6PHp0vKt5mLTROGsLWtsW5p1IK\nOf3lZHI/zrL4ddtHKKmXJ5ugcEhJis0dWvtYPCOtYHsu56YlgAyOHZ0J/zIKrbt1RcNkMrFjx1b6\n9OnOk09O5uxZpV/a4MFD2Lv3AMuXr6Zt2yir2qhim9TJsSpJ0nbgYyBcFMUewCFJknZe48+aDZGR\nbVi6dAX79h3igQceRBAEkpISePrpJ+jVqyubN3+JsaE13BuAxllD2Lq2OHdTxCPthSRy11lWPNpH\neAGQlFFEUWmlRa9lTgxGE6erAuMdo/wseq3Cb/JIeeIsmMCxgxPhm6LQelhvh7osy2zbto0+fW5l\n0qRxxMRIAAwYMIiff97P6tVradfuOqvZp2L71CUd10EUxaVAFoq7aj+QJoriZ6IoNs3dX/UkKiqa\nFSs+5pdf/uDee+8HID7+DFOnTqJPn+7s2LG1pt9AY6N11RK2vi1OnRUXUtrMJPI2ZFvsetGhnmg1\nAjJwOqnpxDnOnCuoCeh3iraccBR+l0/y5HgwgsN1joRvjkbnZR3RkGWZ77//ln79bmPo0KGcPPkP\nAHfeeTc//LCXtWvXc/31N1jFNpWmRV1WHPNQ+mDcB3gA3sAQ4FbgTfObZvtcd1171qxZx08//caA\nAUqLkJgYiUmTxtG3b0927vy6psNZY6J11RL+ZRROnZxBhtTpieRvzrHItRztdbQJUgLzJxNyLXIN\nS/BPla2BPs74e9e6E3GdKPqxgJQJ8WAA+yhHIjZFo/NpfNGQZZk9e35i4MA7eOSRkZw4cRyA22/v\nx86dP/DFF5u58cZOjW6XStOlLsIxCpgoSdJ3kiQVSZKUX+WmmkwLr1V1ww0dWbt2A7t37+GOO+4C\n4NSpf3jssYe5664+/PDDd40uIFp3RTwcOyricW5aAgXbLTOxn49zNCHhOFsd37BMeYziPYUkP3YG\nWS9j38aBiK3R6PztLHKtq/Hbb79y330DGDnyAY4c+ROAnj17sXfvXrZs2UHXrt0a3SaVpk9dhMOe\ny6fdnkNZgbR4OnXqzPr1W/jmmx/o3bsvACdOHOPhh0cwcOAd7NnzU6MKiNZTR/jGKBw7OIEJUp44\nS+HX5g9iVwtHVn45mfm2s8/lShSX6UlIU4ryXW8B4Sj+tZCksXHIFTL2EYpo2AU0rmgcOPAHQ4fe\ny9Ch93Lw4B8AdO3ajS1bvmbHjl307t27Ue1RaV7URTj2AS+JoljzDaj6+SXgd3Mb1pS55ZZubN68\ng+3bd9GjR08Ajhz5k5EjH+C++wbw22+/NpotOm8d4ZuicGjnCEZIfjyewm/NG4uICHTD0V7JEDrV\nBFYdpxLzkAGtRqBduJdZz13yexFJY+KQy2XswuwJ3xqNXWDjhQCPHDnMiBFDuO++/jX3WadON7Nh\nwxa++eZ7brutT7Po2KhiXeoiHM8BdwMJoijuFEVxJ5AA3A5MN79pTZ9bb+3F9u272LRpB507dwXg\n4MELnwQPNIodOl87IjZHYx/lCAZImRhP0Q/mqy+l02poF6ZMwE0hLfefqsZNbYI9zNp/o/RgMUmj\n45DLZOxC7InYGo19SOOIhrKyHc4999zBL7/8DMD113dk3bov+e67PfTrd5cqGCpmoy77OOKA64C3\nUQTjNEqNKlGSpJOWMK45IAgCffr0ZdeuH1m/fjM33aQEIX/77VcGD76bESOGcOTIYYvbofO3Uyay\nSAdkvUzyY2co/tl84nFdVVruqcQ8TFZICKgtsizXCEeHCPOtNkr/LCZxVCymUhO6QDsitkRjH2b5\nntr//PM/xo4dzZ139uaHH5RuB0rSxmf8+OOv9O9/jyoYKmanrvs48iRJWiJJ0pOSJM2QJOkjwFkU\nxfssZF+zQRAE7rjjbnbv/oW1azfQoYOS9vjLLz9zzz138PDDwzlx4phFbbALUMTDLtweuVImadwZ\nin8tNMu5q+McxWV6kjNsr6JwNRl5ZeQUlgPKxj9zUHashMSRsZiKTeiq3mP71pYVDUk6zcSJY+nb\n91a+/fYbQEkTX7nyY/bs+Z17770PjcZ26l+pNC/McWd1BraZ4TwtAkEQGDBgID/9tI/Vq9fVbLT6\n4Yfd3Hlnb8aNe5h//vmfxa5vF2RPxDYRuzB75HKZpDFxlPxe1ODzBvk44+WmTJYnzlhu30hDqV5t\nuDjqiGjV8JamZX+XkjA8FlORCa2vjoit0Ti0sVz5kvj4OJ54YiK9e3fjq6+Ur11ERGuWLl3Br78e\nZMiQB1XBULE4NneHiaJ4iyiKqRf87iWK4jZRFAtEUUwSRXGCNe0zFxqNhsGD72fPnt9Zvnw1bdq0\nBWDXrq/p21fZ0StJpy1ybfsq/7tdsB1ymUzS6DhKDjRslSAIAje2UZ7gj5+xzJ4Rc1AtHNdFeKPR\nNMyFU/5PKYnDYjAVGNH6VIlGlGVEIyHhLE8//QQ9e3Zly5aNyLJMaGgYixZ9wO+/H2HEiFFotdav\ne6XSMrAZ4RBFURBFcTzwPUrqbzUfAcUovT+GAe+IotjdCiZaBK1Wy9Chw9m37xBLliwnPDwCgB07\nttK7dzeeeGIi8fFxZr+ufZgDEVtFdIF2mEpNJI2KpfTPholHx7ZKM5+zqYUUlNhe+ZEKvbFmr8kN\nDUzDLT9dRsKwWIx5RrReWiI2ReHYzskcZl5ESkoyM2Y8za23KjXRjEYjQUHBzJ+/iD/++IvRo8eg\n01mvfIlKy8RmhAMlrXc68H/VB0RRdEXZnf6aJEnlkiQdAr4AHrWOiZZDp9PVlK9euHApoaFhyLLM\nli0b6dmzK9OnTyUxMcGs17RvXbUxLcAOU4mJxJGxlP5V/4ZV14V7YafTIAN/2+Cq41RCHpUGEwJw\nY9v6d6yriC0n8cEYjDkGNB5awjdF43i9eXefp6WlMnv2DLp378S6dZ9gMBgICGjF3LnzOXDgKGPH\njsfevkVV+lGxIa76qCKK4t21OEdnM9myBpgD9LngWBSglyQp/oJjEjDUTNe0Oezs7Hj44UcZPvwh\nvvhiHQsXzictLZX16z9j06YNjBo1hmefnUlISKhZrufQxpGILVGcHRKDMdvA2WExePzsDBF1d+M4\n2Gm5LtyLE2dyOB6XTa+OgWax0Vwci1MKPkYGu+NezzaxFfHlJAyNwZBlQOOmIWJjFE4dzScaGRkZ\nLF26kE8+WV3T88XX15ennnqOceMm4ORk/lWNikpdudYa97tanqfB+ZeSJKUBiKJ44WEX4NKtyKVA\nrb+pgiBQ31hhtQ+8ob7w+uDk5MCECRN5+OFH+PTTj1m06F0yMzNZt+5jvvzyc8aMGcczz8wgKCio\nwddyvs6ZNttFztwvYcwxcPyu47TZLuLQoe6T1M3Rvpw4k8P/zuZiNJmwt7MNv7tJljkep6yCbo72\nQ6u9+LOtzWdckVBB4tAYDBl6NC4aWm+KxqWLq1nsy8nJZsmSRaxatbKmy6SXlxdPPfUMEyZMxtXV\nPNcB697X1kIds5mRZdmm/ouOjr49Ojo6u+rnm6Ojo0sv+fdp0dHRP9b2fCaTSW4OlJSUyO+++67s\n6+srowi17ODgID/zzDNyenq6Wa5RdKxI3ue9T97DHvk339/kor+L6nyOnIIyefCM7fK9z22XD/yd\naha7zMGphBz53ucUuxLTCur896VnS+Xfw36X97BH3uuyV87bl2cWu3JycuSXX35ZdnV1rflcPT09\n5TfffFMuKKi7nSoqZuSK86qtR9ViAXtRFMMkSUqqOiYCtd5wmJNT0qAVh6enC/n5JZhM1t/U9thj\njzN8+MOsWrWCpUvfJy8vj0WLFrFy5UomTJjMU09Nx8en/r57QiFyazTxQ2LQZ+s51u8YkV+JOEbX\nbeXRNtiD2JQCfjmSTFRQw1NezcFPB5V2rQFeTrjYCeTmKokAtfmMK89VEj/4NJVJlQhOGiLWR2Fq\nr6s5R30oLCxg+fIP+fDDpRQVKXtpXF3dmDJlKlOnTsPDwxODgQZd40rY2n3dGKhjrvuYvb2vvMq1\naeGQJKlIFMUdwFxRFCcBHYDRKOXda4UsyzS0t5LJJGM02sbN5uTkUuXvnsiKFR+yfPkHFBYWsGTJ\nItasWcXkyVOYMmUaXl71yxpyvMGZjt935NgdxzFkGYgfEkPEjmgcImufZnpztB+xKQUcjcmiotKI\nTmvdHAxZljl8Smml26WdP0qrlIs/zyt9xvq0ShLuj6EysRLBUSBsXRucurvW+34oLi5m1arlfPjh\nYvLzlZphzs7OTJw4halTn8LbW0lpboz7zZbu68ZCHbN5sKWsqisxCbADUoAtwCxJkg5a1yTr4+bm\nzsyZs/nzzxM899wsXFxcKSkpZuHCd+nSpSPz58+lsLB+JUXcu7rTelMUGhcNhgw9CQ/EUHm2otZ/\nf3NVY6SScgOnk6xfuyohvahmt3gX0b/Wf6fP0JMwNIbKhAoEe4GwT9rg2tu9XjaUlpaydOn7dO16\nA3PmvEF+fj6Ojo488cRTHD78N6+88t8a0VBRsXUE2YbrCpmDrKyieg9QqxXw9nYlN7fY5p9ScnJy\n+PDDxaxevYLS0lIAPD09mTr1aSZOnFLr4OqFYy7cX0TSQ0r9JbsQeyK2177+0uufHCYxvYheNwQy\nfpB125Bu2hPHtweT8PN05O3He1xUu+lKn7EhSxHMiphyBDuB0E/a4HZX3bsHlJeXs3btGt5//z2y\nspRVj729PY8++hjTp88gIKBVwwdYR5rSfW0u1DHXfcx+fm5XjKo3hRWHSi3w8fHh1Vdf59ChE0yZ\nMg1HR0fy8/OZM+cNuna9gaVL368RlNri0t2VsM/bIjgJ6FMqlafvlNpt7OvePgCAIzFZ6A3WaaML\nSjbVoWo3lehfq4J/hhwDCcNiqYgpBx2ErIqss2hUVFSwZs1H3HLLjbzyymyysjKxs7Nj7NgJHDp0\nnDlz5ltFNFRUzIEqHM0Mf39/3nhjDocOHWfChMnY29uTk5PDG2+8SteuHVm58kPKy8trfT6Xnm6E\nrW2L4CigT6okcWgM+rRri8ct1wUgAGUVBv6Ot95mwLiUgho3VbcqMbsahjwDicNjqDhVBloIXRGJ\n+z2etb6eXq9n3bpP6NHjZmbPnkF6ehparZaHH36UP/74i/nzFxIUFFzv8aio2AKqcDRTWrUKZO7c\ndzl48BiPPjoenU5HVlYmr7wym1tuuZE1az6q2WB2LVz7uBP2SRsEe4HKhAoSHohBn6G/6t94uTkQ\nHapMuAdOZjR4PPXl9/+lAxDi50JYwNUzvIwFBhJHxFL+vzLQQMiy1rgPrl3pdYPBwIYNn9OjR2dm\nzHialJRkNBoNI0aMYv/+P1m4cClhYeENHo+Kii2gCkczJzg4hHffXcSBA0cZPXoMWq2W9PQ0Zs+e\nQY8eN7Nu3Sfo9VcXAQDXfh6EftwGwU6gMr5C2T2defW/69ZBecI/FptNcdm1r2Fu9AYjh08rbqoe\nHa7uFjIWGkgcGUv58VIQIHhJBB5Drp2ZZjQa2bJlI7fddgtPP/0ESUkJCILAAw88yL59h1i6dAWR\nkW3MMh4VFVtBFY4WQlhYOIsWfcD+/YcZPvwhNBrNvwroGQyGq57D7S4PQlZFgg4qY8tJGB6DIefK\nf3NLuwDsdBoMRhMHrbDqOBaXQ1mFAYGru6kMRQbOjoyl7C9FNILeD8dz+NUznEwmE199tY3bb+/B\nE09M5MwZpRDlvffezy+//MGKFR8TFRVtzuGoqNgMqnC0MCIj2/LBByurejcMRRAEEhMTePrpJ7jt\ntlvYvHkjxqtsfHG/x5PQFZGghYpT5SQOi8GQd3nxcHbU0UVUUnN/O5FmkfFcjV+PnQOgfYQX3u6X\n34diKjHy96C/KT2kFHcMWhCO10NX3kQpyzK7dn1Dv369mDhxbE3pe6XHym+sWbOO665rb+aRqKjY\nFqpwtFCio0VWrvyEPXt+Z9AgpYHjmTNxPP74BDp27MiOHdswmS6fDeU+2IuQZa1BA+X/lJE4PBZj\n/uXFo1dHpZZWYkYRSRkNbxhVW7Lyy/inqv95n5suH4w2lZo4OzqOgn3KfpfAeWF4PXJ50ZBlmR9/\n3M3dd9/OuHGjOXlSabZ1xx13sXv3Htau3cANN3S0wEhUVGwPVThaOO3bd+Djjz/jp5/20b//PQCc\nPHmS8eMfpV+/Xuza9Q2X2+vjMcSb4CURIED5iVISR8ZiLPz3SkUM88TPU3na33P0nEXHciG/Hld6\ngbk723FT1L/FwFRuImlsHCW/KWIWNCcU78f8/vU6WZb55ZefGTjwTkaPHs7x40cB6N27L9988wPr\n12+hUydzFYhWUWkaqMKhAsANN9zIunVf8v33exgwYAAAJ0/+j3HjRnP33bfz44+7/yUgnsN9CFqk\nZAqVHS0l8aFYjMUXi4dGEOjbKQSAP/5Jp6Tc8kFyvcHEvirXWM8bAv9V8sRUYSJ53BlK9iqi0ebd\nNvg+/u8YyP79+7j//nsYMWIIR44cBqBHj55s376LzZt3cMst3Sw8EhUV20QVDpWL6Ny5C99++y27\ndn3PbbcprVGOHz/K6NHDGTjwTn755eeLBMRrlC+BC8IAKPuzhKRRcf8Sj14dA7HXaajUmxol1nHw\nZAaFJZUIAvTtdLGbylRpInlCPMU/K4UFW70aTOiMi3ubHDx4gAcfHMwDDwziwIHfAejS5RY2b/6K\n7dt3ceutvSw+BpXLk5SUyOzZzzFgQF/uuqs3Y8eO4ptvtlvbrGsyYcIYdu36+rL/1qtXF4t0+bQk\nqnCoXJZu3XqwZcvXbNu2k27degBw5MhhRowYwv3338P+/ftqXus9xo/At5XJt/RgMUlj4jCVno+P\nuDrZ0b0qHfanIykYrxA7MQeyLPP9YaWQ8s3Rfvh6nq/sK+tlUiafpfh7Jabh90IQ/s+cbzb1119/\nMnLkAwwefDf79u0F4KabOrF+/WZ27vyB3r1vr9XOcxXLYDKZmDHjadq1a8+OHd+ye/cvPPPMTD74\nYDG//PKTtc1rUdh0dVwV69Oz52189dV37N27h3nz3uLIkT85cOB3HnhgELfd1ocXXniFW27phvd4\nf2QjpL+cTOn+YpIejSNsXVs0TsqzyV1dQvj1eCrZBeUcOpV5zX0V9eVkQh4pWUqGVP+uYTXHZYNM\nyhNnKdqlVKT1ey4Q/xmKaBw9epQXX3yJ3bvP9y3r0OEGXnjhZfr3v6dFioXBaCK3sPYVBhqCt7tj\nrSooFxTkk5Z2jrvuGoCDgxI369SpM1OnPl2zF8loNLJq1XJ27Nha1U1zLIsXL+CPP45w8OBBnnrq\nKXbuPC8ygwbdwZtvzuPmm7vw55+HWL16OcnJSVRW6rnllu688srrODo6Mm3aZAIDgzh48A9EsR3z\n57/P3r0/s2rVcrKyMhHF65gxY3bNJs/Dhw/y/vsLyMhIo2/fO9Hra1eq51JSUpJZvHgBJ04cx83N\nnSFDhjJ69KMIgsDhwwdZunQhGRnp+PsH8PDDY+nffyB6vZ758+ewf/+v2Nvbc/31HZk580U8PGpf\nAeFaqMKhck0EQeD22/vRp09ffvrpe+bNm8Px40fZt28v+/btpW/fO3jhhZe5eVIXZL1Mxn9TKPm1\niOTHzhD6SRs0jhqC/VzpFOXL0dhsdv2RSLf2AWjMPCHLsszX+88CEBnkTptgpZKtbJQ5Ny2Bwq+U\nLCvfp1vh90IgJ0/+w/z5c9i587wLoV2765g16yUGDRqMpr6NXJo4BqOJl1YeILugcYTD18OROZO7\nX1M8vLy86dSpM88++yT9+w+kU6fOXHddBwYPHlLzmm3bNvHTT9+zatVanJ1dePnlWbWyoaysjJdf\nnoLBZfUAACAASURBVMWrr75Br159yMzMYOrUifz443fce69y/piY03zxxRZAif/NnfsG77yziPbt\nr2fr1o08//wzfPbZJgoLC3jppVk8//xL9O17Jzt2bL2im+pq6PV6nn32Sfr2vYO33nqHtLRUZs2a\njouLC0OGDGPu3Dd4+unnuP32Ozhy5DCzZ8+gV6/e7NnzIwkJZ9m2bSfe3q5MmTKVTZs2MHHilDrb\ncCVa5jdDpV4IgsCdd/bn++9/4dNP19O+/fUA7NnzEwMG9OORR0aQdls6/q8ocYXinwtJnhCPqVJx\nTQ3qEQHAuewSjsZkmd2+04l5xKQobqj7erZGEARFNKYnULA1FwCfKf4UjCjm8ccfo2/fW2tEo02b\ntixfvpo9e35n8OD7W6xo2DrvvruYYcNG8tdffzJjxlMMHNiP1157iYICZSX5888/MmzYQwQFBePp\n6cnkyU/W6rz29vasWfM5vXr1obi4mOzsLDw8PMnKOn+f3nrrbbi6uuLq6srOnV8xYMC9dOx4Ezqd\njhEjRmM0Gvnrrz/5/fffCA0N5a67BqDT6XjwwRGEhIRe5eqX5/jxoxQVFTF58pPY29sTHh7B6NGP\nsmvXNzU2//DDdxw5cpiOHW9i9+5fcHFxxd7egZSUZHbt+pq8vDwWLHjfrKIB6opDpR4IgsA99wyi\nf/972LnzK955Zw6SdJrvv/+O77//jkGD7mPm+FmwxkDxDwWkTDpL6KpIIoPc6RDhxT8JeWz9NZ6b\nonzRmmmClmWZbb8pq43Wge7cEOmNbJJJfTaRgo2KaGiH2/NG1hts7b2pZo9KRERrXn/9vwwYcB+C\nYBv90a2NTqthzuTuNueqAnBwcGDEiNGMGDGaiooKTpw4xrJlS5g79w3efvs98vPz8Pc/33MlJCSk\nVufVarXs3/8rX375BQBt20ZRXl520V4mH5/z1QQyMtL5668jfPfdNzXH9Ho9GRnp5OXl4ut7cd+X\nVq0CqSt5ebn8f3t3Hl/TtTZw/JeZqIgkJKgYaymqtKiqUpoSQ81Ctaj2vR2uoUVpaUsVVUMJV6uD\n4fYa2qamCheJqVVaaqpqa7kVYzMgkUSCRJLz/rFPjiQicmQ+5/n6+MhZ++yz15PEec5ae+/1VKlS\nBWfnm2/Tfn7VLMvzf/TRv1iy5DMmT55ISkoKPXr05tVXR9KpUxeSk5PZtCmUefPmULdufcaNm2D5\noFcYJHGIu+bo6MjTT/eia9enWb9+DbNnzyAi4iSbNm3gvw6hzGjwIY+caMWVzfGcfyWCez+rS98n\n6vH7vw8QFXuV3UejeOI2N+dZ66C+yF/m0UbPtnXABJFvnCX+a2Nl3t/v+4PX1owiPcO44qtmTX/G\njBnPM88Mwte3sl3VacgPZydHqlZ2L+luZLN9exiffvoxISHrcXBwwM3NjZYtHyE1NZW5c2cC4OdX\nnejom1fuXbp0yfK1k5MTN27cvFE1LS2N5GTjfNhvv/3K0qVf8MUXX1KzpnFubNSo7J/Ss57r8vb2\nYdCgwdk+yZ87d5YqVaqyY0c4MTHZrx68dMn6Ebavrx+XLl0iLS3NkjyioiKpXNmL1NRUIiPPM2nS\nVEwmE8eOHWXixHHcf38jlLqfhx9uQb9+/XFwuMHcucFMmzbZMs1WGGQ8LgrMycmJvn2D+PHHX1iw\nYBG1atXGZDLx1ok3+YqvAEgMjef88FPU8qlIq/uNT2Prd5/iaiHc13EjLZ2QncbljI3reNGkdmWi\nxp8lfoXxprHRYSMj/zeC9Ix0qlWrzqxZ8/jpp0M8++wQXFxcCnx8UTxatGjFtWvJzJ//EZcvx2Ey\nmTh//hyrV3/NY489DsDTT/ckJOQrzpw5zdWrySxZ8qll/5o1a3L9+jUOHvyF9PR0Vqz4t2V5neTk\nZJycHHFzcyM9PZ3Nmzfy66+Hb7t+W2BgN0JD16H1cUwmE99/v5MhQwZw4UI0bdo8TkxMDKGh60lL\nSyM0dD2nT5/KM7a4uDguXIix/L18+TKNGjXBy8uLL75YRGpqKmfOnGbVquV06hSIg4MDkye/TWio\ncSlylSpGrZlKlSqxe/f3vPfe28TFxVKpUiXKl3enUiXri5DlRUYcotA4OzszcOCz9O0bxDffrGLu\n3Fl8fv5znHAiiCAS113mREoyfT6qx+H/XSIxOZXVu04yJLBhgY67ce8ZLiVcx9HBgQEd6hHxmiYl\nxChatZGNzDXNpUrVqrz++liee+55ypXLf/10UXpUquTJJ58s5vPPFzF48ACuXbtK5cpedOrUhWHD\n/gFAhw4BXLp0iTFjRmAymWjXroNlf19fX4YPH8X06e9x/fp1unfvwX33KQBatWpNhw4BDBkyECcn\nR5RqRJcu3Tlz5nSufWne/GFGjBjN1KmTiImJxs/PjylTZuDvXxuAWbPmMXfuLObPn0OLFq1o2rRZ\nnrG9/vo/sz1+4IEHWbRoCTNnziM4eDY9enSmXLly9O7dj6CgQTg6OjJt2kwWLpzHggVzcXd3p1+/\nAbRs2ZrmzVsQGXme554bQEpKCkrdz4QJk+/yu547KR2bByk3WbCYU1JSWLnyPwTPm0O/mL70pS8A\nJ+r9xZU3a7HruPHm/uag5ij//NW9yOlM9BWmfnmADJOJR+q7U/WT0zQ4dh8Am9nMUq+ljBg1muef\nfxF391unXuRnbNsxR0T8xZAhA/npp4N2E3MmKR0ryiQ3NzdeeOEf7P/lV/ym3svWcmEANDhZn/hX\nfuDsni+5nhTH56F/cOWq9de5X09NY/HGP7h+NYGz+1YSO3KzJWnsct2F60R39h84yj//OTLXpCGE\nuDsyVSWKXLly5Xjp5X+S/Gwye/vtovohP57MeJKK+yoy/cAbeD/YlnluqUwc1j7fV9eYTCYWhuxj\nx3dL+ftgGOPTRtMeY4mUyEZRDF7/f3h4Fu68rhDCICMOUWwq3FOBgM1d8XjZmJZqRSs+SV+A26ET\nLJoUxMAXRnIxy1Uwt5OQEM/zw8czd0JfUvftZ2HaPEvScB9QkYBt3SRpCMCoP/PjjwdKuhs2p8wk\nDqVUc6XUfqVUslLqiFKqdUn3SVjPwcGBmlPrUm2OP7hADWqwkIW8lPYChzavo3nzJkyb/j7x8Zdv\n2TcpKYm58+bQtFkTdq7+kudSgvicL6iDURuk6js1qL3gPhyc7W+JECGKU5lIHEqpckAosAzwBBYA\nG5RS95Rox8Rd8xpShTqhDXGt72a56moVqxiWMpjv5n9L8+ZNmDPnQxITE7h69Soff7yAhx5qwn9m\nLGZAch++5muGMhRXXHCu7kLttQ2oMsrPLteVEqK4lYmrqpRSXYDPtNb+Wdp+A6ZqrUPy2leuqrJO\ncceccS2DS/OjubQoBtO1m3fpxhDDSU4SSxyOTo54pFekPvWpRpY7cF0c8H6xClXGV8fpnru761t+\nxhKzrSrKq6rKysnxhsAfOdq0uT1PDg4O3O2qFo6ODtn+tQfFHbPTPU5Ue7sGPv9XldglF7j4nwuY\nLqbja/4DQM7Cgl5O+Az0wecVX1xruBbo+PIztg8Sc+EqK4mjAnA1R9tV4I7XWHp7Vyjw9IWnZ4UC\n7V8WFXvMXuA7pzKmmQ1IPJjIXxuiObs3hivn4riRkkqlOj7UbOWH6lEdj9YeOLoU7iyr/Iztg8Rc\nOMpK4rgKlM/R5g4k3WnH2NjkAo04PD0rEB+fTEaGfQxvS0XM9Z2oM6YGdcbcuo5VBhB/JedniLtX\nKuItZrYS85Qp77JtWxhr126kShWjXvzixZ8REXGSDz6Yle251sb86KMPs2LFN9SrV79I+l4cCvpz\n9vK6/SnkspI4/gRG5GhTwKo77WgymUjPOdVhpYwMk93Mi2ayt5jtLV4o2zEnJiayZ8+PdOgQwNq1\nqy2LDWZkmMz/53OPy5qYy/L3J6uiiKOsJI4dgJtSaiTwKTAY8AW2lmivhLBRqamp/P33+WI5Vo0a\n9+Lqat25qi1bNtGsWXP69OnP22+PZ+jQFy0LViYmJvLmm6M5fPgQtWrV4q23JtGgwX2kpqYybdoU\nfvzxe5ydXXjggaaMGzfR6sp4Ba3KV5BjlxZlInForVPMV1Z9CnwA/AX00Fonl2zPhLA9qamptGnz\nMGfPnimW4/n712Lv3oNWJY/Q0HW8/PJwHnjgQTw9Pdm5cxudOnUB4PDhg0ybNpPp02ezYsW/eeut\nMYSErOW77zZz+nQEq1dvxMHBgbffHm91ZbyCVuUryLFLkzKROAC01keBNiXdDyFEyfrtt19JSkri\n0UfbAtCrVz/WrAmxJI6WLR+hffuOAAwePIyQkK84duwYbm5unDt3js2bN9KmzePMnh1sdaXHrFX5\nnJ2ds1TlC6VXr36WqnwVK3pYqvI5OjpaqvIV5NilSZlJHEKI4uHq6srevQdL7VTVhg3rSEiIp3fv\nrgCkp6eRkJDA8eN/AuDre/NeHycnJ7y9vbl06SJBQX24cCGWjRs3MH/+HOrWrce4cROtqoxX0Kp8\n//3v3R+7NJHEIYS4haurK3Xq1C3pbtwiKSmJHTvCCQ7+hBo1bpaFnT//I9as+QY/v2rExd1c7ywt\nLY2LFy9SrVo1Tp8+zcMPt6Rnz34kJMSzbNliqyvjFbQqX+/ed3/s0qTsjpWEEHZn69ZN3HuvP02b\nNsPb28fyt3v3nmzfHkZCQjz79//M3r0/cuPGDZYu/RxfX18aNmzE9u3bmTRpInFxsVSs6EH58uXz\nrIxXVFX58nPs0q5MLDlSELLkiHXsLWZ7ixfKdsxDhz5DQEBnBg9+Plt7RkYGfft2Jz7+Mq1bt+HK\nlStofZzGjZswbtxE/P1rUrGiG+++O5mdO3eYK+M1ZPz4t/H3r3XLcdq2bXFLW2ZVvvPnzxEcPJtj\nx36zVOUbPHgYjo6OHDp0gIUL53Hu3Dnc3d3p2zeIIUNeIC0tjeDg2ezadedjF5aiXHJEEkceyvJ/\nsLtlbzHbW7wgMUvM+SMVAIUQQhQaSRxCCCGsIolDCCGEVSRxCCGEsIokDlFqOZ6KoEpVD6pU9cDx\nVERJd0cIYSaJQwghhFUkcQghhLCKJA4hhBBWkcQhhBDCKpI4hBBlRtu2LYiI+OuW9m7dnuTQoQN3\n3H/q1MksXBhcFF27bd9skSQOIYQQVpFl1YUQt8hIzSDt7xvFciznGi44uhbeZ9h+/Z5m9OjxPPbY\n4wAsXBhMYmI88+Z9BEB0dBQjRryE1n/SpElT3nzzXfz8/AD4/vsdLF78KRcvXkCp+xk79i38/WsR\nFRXJ888/Q7t2Hdi9exejR4+nc+eu+e6TrZWblcQhhMgmIzWDv9r8zo2zqcVyPBd/V+rvbZzv5PHK\nKy/i6Jh9/b3k5PxXkd63by9z5izg/vsbM2/ebKZMmciiRUv5449jzJjxPrNmBdOoURPWrg1h/PjX\nWbHiW8sx/PyqsWFDGBkZGfk+ni2Wm5XEIYQoUz79dAl169bP1tat25P53v+ppwJ58MHmALz66ki6\ndu1ITEw0mzZtIDCwO02bNgMgKGgQ3377NYcOHaBmTX8AOnXqYlW1QrDNcrOSOIQQ2Ti6OlJ/b+My\nO1V1J35+N0vLengYRZViYy8RExPNoUMH2bJlo2X7jRs3iImJtiQOb29vq49ni+VmJXEIIW7h6OqI\nax23ku7GXXF0dCQt7WbSS0xMyLY9Li7W8nVCQjzXrl3Dz68a3t4+DBo0ONtU0LlzZ6lSpSqXL8eZ\nW25bouK2bLHcbOkY92ShlJqvlJqToy1AKXVMKZWslNqtlGpQUv0TQpRuNWvWYs+e3aSnp3PixHH2\n7Pkh2/atWzfz++/HSEm5zsKFwTz66GN4eXkTGNiN0NB1aH0ck8nE99/vZMiQAVy4EJ3vY9tLudlS\nM+JQSnkDHwFDzf9mtvsCa4Fnga3ABGCdUqqJ1to+SnkJIfLtlVeGM2vWB3Tp0pEGDRRdujxNYmK8\nZXvbtu2YPfsDoqMjadGiFRMnvgdA8+YPM2LEaKZOnURMTDR+fn5MmTIDf//aREVF5uvYr7/+z2yP\nM8vNzpw5j+Dg2fTo0dlSbjYoaBCOjo5MmzaThQvnsWDBXNzd3enXbwAtW7amefMWREaeZ8iQgZZy\nsxMmTC6071NBlJrSsUqpP4E9gCdwWmv9hrn9VeAZrXU782Mn4BLQWWu9/06vK6VjrVOaYnY8FYH3\nI8aJyth9R8ioU7fQj1Ga4i0uErPEnB95lY4tthGHUsoZuCeXTRla60TgSa11pFLq3zm2NwT+yHyg\ntU5XSp00t98xcTg4OHC3FyJkXvKX89I/W1aaYnZ0utkHJycHHJwKv0+lKd7iIjHbh6KMuTinqp4A\nwnNpPwPU1lrfbixYAUjM0XYVcM/PQb29K+DgULBvnKdnhQLtXxaVipi9moJ5RFzUtzyViniLmcRs\nH4oi5mJLHFrrbdzNJQlGkiifo80dSMrPzrGxyQUacXh6ViA+PpmMDPsY3tpbzPYWL0jMEnP+eHnl\nNkFkKDUnx/PwJ9A/84H5HEd9skxf5cVkMpGeXrAOZGSY7GZeNJO9xWxv8YLEbC+KIuZSdzluLtYB\nLZRSfZRSrsA7wHngcMl2Swgh7FOpTxxa62igJzAZiAUCgD5yKa4QQpSMUjdVpbV+Ppe2ncCDxd8b\nIYQQOZX6EYcQQtgSk8mU7xsKSytJHEKIMufgwV947bVX6dSpPYGBHRg+/B/s3r3Lsr00V+P7+OP5\nrFkTAkB0dDRPPfU4165dK+FeWUcShxCiTAkL28I777xJQEBn1q3bxMaN4QQFDWLWrA8ICVlV0t27\no4SEm8uf+Pn5ER6+m/Llc95xULqVunMcQojSwfFURLEcx5qlZFJSrhMcPJvx4yfSoUOApb19+w5U\nrFiRsWNH8tRTgQCEh28lPHw0ycnJ9OsXxLhxYwBuW3EP4MiRQyxcGMz582epWbMWo0ePsyxj3rZt\nC3r37k94+BaCgp5h+fJlfPfdVjw8PABYsuQzzpw5zfvvz2Dbtq2sWrXcMiXVsWMAb7wxgW++WUlY\n2GYcHByIjo5i+PDX6N+/B2FhP+Du7k54+Ba+/HIJFy9eoE6deowcOYbGjZsQFRXJsGGDeO655wkJ\n+YqMjAw6dQpk1KixBf8B3AVJHEKIXGWuE1bULl7IuTDE7f3221GuX7/G448/ccu2hx5qgbe3Dz/9\ntAeAY8eOsnTpCq5cucLo0cOpW7cWAQFdb1tx78qVJMaPH80770yhTZu2/PDDLsaNe42vvlqLh4ex\nKm1qagqhoWHcuJHKzz/v5YcfdtC9ey8AwsO3MGrUWKKiIpk5cxrz5y+iUaMmnDoVwcsvD6NDhwAG\nDnyOkyf/olIlT0aMeD3buY59+35i9uwZzJo1jyZNmrJlyybGjh3BypWrAUhKSiIqKpLVq0M5cUIz\ncuRLdOz4FE2aNL3bb/1dk6kqIUSZERcXh4dHpWxFkbLy8vImNtaot/Hyy8Px8KhEjRr30r//QDZt\n2gRgqbh38OAvlop7FSrcQ3j4Fh566GHatXsCZ2dnOnYMoG7d+uzcud3y+gEBnXBxccHdvQKBgd3Y\nti0MgD/+OEZSUhKtWrXGx6cK//nPNzRq1ISEhHgSExOpWLGipXDT7YSF/ZfAwK40a/YQzs7OdO/e\nk1q16mQ7d/Pss0NxdXWlSZMH8PevzblzZwvy7bxrMuIQQuQqdt+Rku7CLby8vLh8OY4bN27g4uJy\ny/aYmChLlb6slf6qVq3KxYsXgdtX3IuJiWbfvp8IDHzCsl9aWpqllKxxfB/L1wEBnfj442AuX44j\nPHwrAQGdcXZ2JiMjgw0b1rFp0wbKly9PgwYNSUtL404rkV++fJl69bKXGvLz8+PChZsJx9OzsuVr\nZ2fnO75mUZHEIYTIVVEsY19QTZs2o2LFioSFbaZbtx7Ztu3b9xMJCQm0bt0GgNjYWHx8qgAQHR1F\n9erV86y45+PjQ8eOT/Huu+9bXjMy8u9sxZOyrpfq4VGJVq0eZdeuHezcuY0PPzTKCG3bFsaOHeEs\nW7YSb28j0fTv3/OOsfn6+hETE5WtLTIykgceKH23sMlUlRCizHB1dWXMmLf417/msXHjepKTk7h+\n/Tq7dm1n2rTJvPTScLy8jBHH4sWLuHLlCmfPniYk5Cv69u2bZ8W9J5/sxJ49uzlwYD8mk4mjR48w\ndOgz/Pnn7ZfFCwzsxvLly6hQoQINGzYC4OrVJJydnXFxcSU1NZWVK78kKupv0tLSAHBxcSE5OTnX\n19qyZRO//nqEtLQ0Nm78jtOnI3I9n1PSZMQhhChTOnYMoHLlyixfvoyFC+djMmVQv34D3nhjAu3b\nd7A8r2HDRjzzTG9cXd0YOHAQXbp0IS4u6bYV9wCmTp3BokX/4ty5s3h6ejJy5GhatGh12760adOW\nWbOm0atXX0tbly7dOXDgF/r1exo3NzeaNXuIdu06cObMKQA6dAhg0qQJxMREMW7cRMt+Dz7YnLFj\nJzB79nRiYqKpXbsOc+YswNfXr9TdMFhqKgAWFakAaB17i9ne4gWJWWLOn7wqAMpUlRBCCKtI4hBC\nCGEVSRxCCCGsIolDCCGEVSRxCCGEsIokDiGEEFaRxCGEEMIqkjiEEEJYRRKHEEIIq0jiEEIIYZVS\ns1aVUuod4CXAAzgCjNBaHzNvCwCCgTrAIeBFrfWJkuqrEELYs1Ix4lBKPQ8MAZ4AfIBtwCallKNS\nyhdYC0wAKpu3rVNK3XYdFSGEEEWnVCQOjGQxXWsdobVOA+YD/sC9QB/giNY6VGudCkwDqgMtS6y3\nQghhx4ptqkop5Qzck8umDK31nBxtPYBY4DzQELAsiK+1TldKnTS377/TcR0cHHC8y/To6OiQ7V97\nYG8x21u8IDHbi6KMuTjPcTwBhOfSfgaonflAKdUe+BR4WWudoZSqAOSsZn8VcM/PQX187inwd83T\ns0JBX6LMsbeY7S1ekJjtRVHEXGyJQ2u9DcjzTVwpNRj4BBiptV5lbr4KlM/xVHcgqdA7KYQQ4o5K\nyzkOlFLvYlw51VNr/e8sm/4EVJbnOQH1yTJ9JYQQoviUistxlVLDgNFAG6318Ryb1wEzlVJ9gI0Y\nV1edBw4Xby+FEEJAKSkdq5Q6gXGPRkqOTS211n8qpTpgjEbqYtzjIfdxCCFECSkViUMIIUTZUWrO\ncQghhCgbJHEIIYSwiiQOIYQQVikVV1WVRkqp5sBnQGPgf8ArWuufS7ZXRUMp1QpYr7Wubn5cGVgK\ndAQSgCla6yUl2MVCo5RqC3yEsfLAJWCW1vozG485CJgC1MS44fZtrfV6W44ZwLzO3W/AC1rrjbYc\nr1LqDeADIDVLcxfgGEUQs4w4cqGUKgeEAssAT2ABsEEplduSKWWWUspBKfUCEAa4Ztn0BcYNlr5A\nP2CWUqp1CXSxUJnfODZgrIVWGegPzDCvvmyrMTfA+D1+UWt9D/Aa8I1SygcbjTmLJYB3lse2HG9z\nYKLW+p4sf3dTRDHLiCN3HTDW0FpkfrxUKTUa6AqElFy3Ct1EIAiYDrwJYE6OvYAGWuvrwH6l1CqM\n1YvL+oirFrApy6oEh5RSO4E22GjMWusTSilfrXWSeb04X+AKxidTm4wZQCn1CpAMnDM/tuXfazAS\nx7KsDUUZsySO3GVbWNFMm9ttyVKM4W37LG33ATe01hFZ2jTGKsVlmtb6CDA487F5BPI4cBQbjRnA\nnDTqYEy5OgKvAvWw0ZjNo6yxwCMY9XvAhn+vlVLuGKtrvKaUWgFcBmZj3CRdJDHLVFXuKmCskZVV\nvhdWLCu01lFa65w38lQAruVos7nYlVKVMKYjDwI7sf2Yz2Gs+RaAcY7naWwwZvOoajkwSmsdl2WT\nLf9e+wI/AoswylG8BMwFulNEMcuII3f2vLDiVaBcjjabit386XsjcBIYANyPjcdsrnMDsEMptQZo\ngW3G/C5G/Z7NOdpt9vdaa32K7LMGu5VSy4F2FFHMMuLIXbaFFc0U9rGw4v8AV6WUf5Y2m4ldKfUQ\nsA/YCvTSWl/DhmNWSnVVSm3L0eyKkTRtMeYBwEClVLxSKh7jE/jXQDdsM16UUg8ppd7K0VwOOEsR\nxSxLjuRCKeUGRAAfYtQGGWz+uo7WOrkk+1YUlFJPAKu11j7mx2uA68A/MC5H3gJ01VrvK7FOFoIs\nl2d+pLWemWObrcbsBxwHRgIrgUDgK4z5/+nYYMxZKaVOAyPMl+Pa6s+4AfArxvvUWoyLe9ZjjELe\npghilhFHLrTWKRjXQD8DxGH8p+thi0njNv4BuGCsQrwGGFfW/3OZvQhUAd5VSiVl+TsdG41Zax2N\ncT7jNSAeeB9jpHUcG405DzYZr3nB1yBgEsYVc58Aw7TWhyiimGXEIYQQwioy4hBCCGEVSRxCCCGs\nIolDCCGEVSRxCCGEsIokDiGEEFaRxCGEEMIqkjiEEEJYRdaqEnZDKeUBTMCoS3AvEImxHMUMrXWS\n+TkmoIvWestdHqNA++fxuu2BLzHXVdBabyqk130BGAfUwVhJdojW+q/CeG1hu2TEIeyCUsoTowZB\nO2A40AgYhVHMaYN5VdXCUA3YUUivldUE4HeMpf0L5fXN6xtNB8Zg1HNwIkdNByFyIyMOYS9mmP8N\nMC9sCHBKKXUS4w25L/BNQQ9iXuKjKFQCwrTWZwrjxZRSDwDTgECt9TZz24fAWqVUZa315cI4jrBN\nkjiEzTMvWvks8GaWpAGA1vq4eZHHo1maHzGvX9UYYyXRF7XWh82vVQ2YA3TCWANoA/Ba5htt1qkq\n86qkC4AnMarRfQlM0FpnKKWqm7d1BhKB74DxmVNmOfp/GqN6YWul1FCtde28+qGUqg2cwlhifAyw\nQ2vdL8fLjgMOZyYNs8yk541RDEiIXMlUlbAHdYGKwP7cNmqtd2utE7I0vYKxquiDGG/qiwGUUi7A\ndozzDJ0wFsJsAqzI+ZrmZBWOsYT5YxjLfQ8BxiqlHIB1QArGKrV9gGYYFRlz0xLj/MNHQEsrwK9x\newAAArBJREFU+tHZ/Prv5uibM9AbWJ3j+Zk1aBIQIg+yyKGweUqpNsAe4L47nfg1jxhe01ovMD/u\nhbGqqDNGRbVvgZpa64vm7fdjjEoe1FofzRxxYJwvWA3cq7WONT+3J+CJUY1vLVBFa33DvK0BRlnP\nmlrr87n062dgi9b6PaXU03n1AyPZncI4ib4ml9dqiZFErwPpWTY5AcmZy+sLcTsyVSXswSXzv5Xz\n+fyTWb6OxxiZu2JUCjyV+WYNoLX+Uyl1GeNke9bprkZARGbSMD/3OwCl1AjAA7isVM56YSiMJbDz\ncqd+/GxujshtZ/MxMjBGOVkTRzCQluseQmQhiUPYg5MYdVVaAb/k3KiUWoQx3/+5uSk953MAB4xP\n6LlxMv/NKjWP/jib+9Qll21ReeyXKb/9yFlvOpMHEK+11pkN5qm1xzCuOBMiT3KOQ9g8rXU6sAoY\nqZTKVkteKdUE+D/yV4f5OFBHKVU1y/6NMd6IdY7nnjA/1zPLc4crpcIwShPfCyRorf8yT5+5YJzD\n8CjkfuTmIuCe4xLkkRgjs2/zsb+wczLiEPZiCsYn/O1KqUkY0zgtMK5M2k7+LsXdhnEeYaVSahxG\nXedPgJ+AgzmeG4ZxnmGJ+Xi+wESM5BCOkTy+UkqNxxjNfAakaq3zM+K4Uz9q3WH/HRijqveVUp9j\nnESfiFFS9EY+ji/snIw4hF3QWl/CmIo5gnGV1O8Y9zEsA/qYRyV3eo0MoCfGpbU/Av8FDgPdtNam\nHM9NB3oA7hjTY8vNx52X5XUSge8xEsn/MK50yk8s+e7HbfaPxbg8eSBGAhsEdNZa/5znjkKYyVVV\nQgghrCIjDiGEEFaRxCGEEMIqkjiEEEJYRRKHEEIIq0jiEEIIYRVJHEIIIawiiUMIIYRVJHEIIYSw\niiQOIYQQVvl/2u/kK1VQlR8AAAAASUVORK5CYII=\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11ee13e80>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "plt.plot(thetas, squared_loss(thetas, y_obs), label=\"Squared Loss\")\n",
    "plt.plot(thetas, abs_loss(thetas, y_obs), color='k', label=\"Abs Loss\")\n",
    "plt.plot(thetas, huber_loss(thetas, y_obs, alpha=2), color='m', label=\"Huber Loss\")\n",
    "plt.vlines(y_obs, -10, -5, colors=\"r\", label=\"Observation\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.ylim([-20, 50])\n",
    "plt.legend()\n",
    "plt.savefig(\"loss_functions_compared.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown",
    "solution2_first": true
   },
   "source": [
    "### What do we observe?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "shown"
   },
   "source": [
    "1. All the loss functions have the same minimizer.\n",
    "1. Different shapes around the minimum \n",
    "    1. Abs loss is pointy \n",
    "    1. Huber and Squared Loss are smooth.\n",
    "1. Different behavior far away from minimum\n",
    "    1. Squared loss penalizes errors more than the Abs or Huber loss."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "# Average Loss of the Data\n",
    "\n",
    "The loss functions we have examined so far define the loss of the model with respect to a single data point.   How can we extend this notion of loss to the entire dataset? \n",
    "\n",
    "A simple and intuitive way to extend the loss to the entire dataset is to compute the average loss over all the data points. More formally, let the dataset $\\mathcal{D}$ be the set of observations:\n",
    "\n",
    "$$\\Large\n",
    "\\mathcal{D} = \\{y_1, \\ldots, y_n\\}\n",
    "$$\n",
    "\n",
    "where $y_i$ correspond to a single tip percentage and there are $n=244$ observations in our dataset.\n",
    "\n",
    "Then we can define the average loss over the dataset as:\n",
    "\n",
    "$$\\Large\n",
    "L\\left(\\theta, \\mathcal{D}\\right) = \\frac{1}{n} \\sum_{i=1}^n L(\\theta, y_i)\n",
    "$$\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Plotting the Average Loss"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 21,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def avg_loss(loss, est, data):\n",
    "    return np.mean(np.array([loss(est, y_obs) for y_obs in data]), axis=0)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Average Squared Loss"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 22,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Minimizing Theta 16.0804020101\n"
     ]
    },
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAZUAAAEPCAYAAACKplkeAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e999c50>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = avg_loss(squared_loss, thetas, data['pcttip'])\n",
    "plt.plot(thetas, loss, label=\"Squared Loss\")\n",
    "plt.vlines(data['pcttip'], -100, -30, colors=\"r\", linewidth=0.4, label=\"Observations\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend(loc=5)\n",
    "print(\"Minimizing Theta\", thetas[np.argmin(loss)])\n",
    "plt.savefig(\"l2_avg_loss.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Average Absolute Loss"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 23,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Minimizing Theta 15.5778894472\n"
     ]
    },
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYYAAAEPCAYAAABGP2P1AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x10e661e10>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = avg_loss(abs_loss, thetas, data['pcttip'])\n",
    "plt.plot(thetas, loss, label=\"Absolute Loss\")\n",
    "plt.vlines(data['pcttip'], -5, -2, colors=\"r\", linewidth=0.4, label=\"Observations\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend(loc=5)\n",
    "print(\"Minimizing Theta\", thetas[np.argmin(loss)])\n",
    "plt.savefig(\"l1_avg_loss.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Average Huber"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 24,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Minimizing Theta 15.5778894472\n"
     ]
    },
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYYAAAEPCAYAAABGP2P1AAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nQghh5/8BFxJOT//5k+MAAAAASUVORK5CYII=\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e98c470>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "loss = avg_loss(huber_loss, thetas, data['pcttip'])\n",
    "plt.plot(thetas, loss, label=\"Huber Loss\")\n",
    "plt.vlines(data['pcttip'], -5, -2, colors=\"r\", linewidth=0.4, label=\"Observations\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend(loc=5)\n",
    "print(\"Minimizing Theta\", thetas[np.argmin(loss)])\n",
    "plt.savefig(\"huber_avg_loss.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 25,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAY4AAAEUCAYAAAA8+dFZAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f2be3c8>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "a = plt.plot(thetas, avg_loss(squared_loss, thetas, data['pcttip'])/10, label=\"Squared Loss / 10 \")\n",
    "plt.vlines(thetas[np.argmin(avg_loss(squared_loss, thetas, data['pcttip']))], 0, 20, linestyle='--',\n",
    "           color = a[0].get_color())\n",
    "a = plt.plot(thetas, avg_loss(abs_loss, thetas, data['pcttip']), label=\"Absolute Loss\")\n",
    "plt.vlines(thetas[np.argmin(avg_loss(abs_loss, thetas, data['pcttip']))], 0, 20,\n",
    "           color = a[0].get_color(),linewidth=4)\n",
    "a = plt.plot(thetas, avg_loss(huber_loss, thetas, data['pcttip']), label=\"Huber Loss\")\n",
    "plt.vlines(thetas[np.argmin(avg_loss(abs_loss, thetas, data['pcttip']))], 0, 20, linestyle='--',\n",
    "           color = a[0].get_color(),linewidth=2)\n",
    "\n",
    "plt.vlines(data['pcttip'], -5, -2, colors=\"r\", linewidth=0.4, label=\"Observations\")\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Loss\")\n",
    "plt.legend(loc=5)\n",
    "plt.ylim([-7,15])\n",
    "plt.xlim([5,30])\n",
    "plt.savefig(\"all_loss.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## What do we observe?"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "1. The Absolute loss appears smoother.  This is due to averaging.  If we zoom in we see that it is still pointy.\n",
    "1. **The minimizing $\\theta$ values are not all the same.** ** *Why?!* ** "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "In the following plot we sample 5 data points at random and plot the various loss functions.  A sample of 5 points is used to make it easier to visualize the corners in the absolute loss."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 26,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "data": [
        {
         "name": "Squared Loss - 20",
         "type": "scatter",
         "x": [
          0,
          0.25125628140703515,
          0.5025125628140703,
          0.7537688442211055,
          1.0050251256281406,
          1.2562814070351758,
          1.507537688442211,
          1.758793969849246,
          2.0100502512562812,
          2.2613065326633164,
          2.5125628140703515,
          2.7638190954773867,
          3.015075376884422,
          3.266331658291457,
          3.517587939698492,
          3.7688442211055273,
          4.0201005025125625,
          4.271356783919598,
          4.522613065326633,
          4.773869346733668,
          5.025125628140703,
          5.276381909547738,
          5.527638190954773,
          5.7788944723618085,
          6.030150753768844,
          6.281407035175879,
          6.532663316582914,
          6.783919597989949,
          7.035175879396984,
          7.2864321608040195,
          7.537688442211055,
          7.78894472361809,
          8.040201005025125,
          8.146639511201629,
          8.29145728643216,
          8.542713567839195,
          8.793969849246231,
          9.045226130653266,
          9.2964824120603,
          9.547738693467336,
          9.798994974874372,
          10.050251256281406,
          10.30150753768844,
          10.552763819095476,
          10.804020100502512,
          11.055276381909547,
          11.306532663316581,
          11.557788944723617,
          11.809045226130653,
          12.060301507537687,
          12.311557788944722,
          12.562814070351758,
          12.814070351758794,
          13.065326633165828,
          13.316582914572862,
          13.567839195979898,
          13.819095477386934,
          14.070351758793969,
          14.321608040201003,
          14.572864321608039,
          14.824120603015075,
          15.07537688442211,
          15.326633165829143,
          15.384615384615385,
          15.57788944723618,
          15.829145728643216,
          16.044399596367306,
          16.08040201005025,
          16.331658291457284,
          16.58291457286432,
          16.834170854271356,
          17.08542713567839,
          17.336683417085425,
          17.587939698492463,
          17.839195979899497,
          18.09045226130653,
          18.341708542713565,
          18.5929648241206,
          18.844221105527637,
          19.09547738693467,
          19.346733668341706,
          19.597989949748744,
          19.849246231155778,
          19.930475086906142,
          20.100502512562812,
          20.351758793969847,
          20.60301507537688,
          20.85427135678392,
          21.105527638190953,
          21.356783919597987,
          21.608040201005025,
          21.85929648241206,
          22.110552763819094,
          22.361809045226128,
          22.613065326633162,
          22.80501710376283,
          22.8643216080402,
          23.115577889447234,
          23.36683417085427,
          23.618090452261306,
          23.86934673366834,
          24.120603015075375,
          24.37185929648241,
          24.623115577889443,
          24.87437185929648,
          25.125628140703515,
          25.37688442211055,
          25.628140703517587,
          25.87939698492462,
          26.130653266331656,
          26.38190954773869,
          26.633165829145725,
          26.884422110552762,
          27.135678391959797,
          27.38693467336683,
          27.63819095477387,
          27.889447236180903,
          28.140703517587937,
          28.39195979899497,
          28.643216080402006,
          28.894472361809044,
          29.145728643216078,
          29.396984924623112,
          29.64824120603015,
          29.899497487437184,
          30.15075376884422,
          30.402010050251253,
          30.653266331658287,
          30.904522613065325,
          31.15577889447236,
          31.407035175879393,
          31.65829145728643,
          31.909547738693465,
          32.1608040201005,
          32.41206030150754,
          32.66331658291457,
          32.914572864321606,
          33.16582914572864,
          33.417085427135675,
          33.66834170854271,
          33.91959798994974,
          34.17085427135678,
          34.42211055276382,
          34.67336683417085,
          34.92462311557789,
          35.175879396984925,
          35.427135678391956,
          35.678391959798994,
          35.929648241206024,
          36.18090452261306,
          36.4321608040201,
          36.68341708542713,
          36.93467336683417,
          37.1859296482412,
          37.43718592964824,
          37.688442211055275,
          37.939698492462306,
          38.19095477386934,
          38.44221105527638,
          38.69346733668341,
          38.94472361809045,
          39.19597989949749,
          39.44723618090452,
          39.698492462311556,
          39.94974874371859,
          40.201005025125625,
          40.45226130653266,
          40.70351758793969,
          40.95477386934673,
          41.20603015075376,
          41.4572864321608,
          41.70854271356784,
          41.95979899497487,
          42.211055276381906,
          42.462311557788944,
          42.713567839195974,
          42.96482412060301,
          43.21608040201005,
          43.46733668341708,
          43.71859296482412,
          43.96984924623115,
          44.22110552763819,
          44.472361809045225,
          44.723618090452256,
          44.97487437185929,
          45.226130653266324,
          45.47738693467336,
          45.7286432160804,
          45.97989949748743,
          46.23115577889447,
          46.482412060301506,
          46.73366834170854,
          46.984924623115575,
          47.23618090452261,
          47.48743718592964,
          47.73869346733668,
          47.98994974874371,
          48.24120603015075,
          48.49246231155779,
          48.74371859296482,
          48.994974874371856,
          49.24623115577889,
          49.497487437185924,
          49.74874371859296,
          50
         ],
         "y": [
          265.719982899775,
          257.7025808738721,
          249.81143828586193,
          242.04655513574482,
          234.40793142352084,
          226.8955671491898,
          219.50946231275168,
          212.2496169142067,
          205.11603095355466,
          198.10870443079548,
          191.22763734592925,
          184.47282969895593,
          177.84428148987587,
          171.34199271868877,
          164.96596338539442,
          158.71619348999315,
          152.59268303248504,
          146.59543201286968,
          140.7244404311476,
          134.97970828731812,
          129.36123558138192,
          123.8690223133386,
          118.50306848318826,
          113.26337409093077,
          108.14993913656639,
          103.16276362009492,
          98.30184754151657,
          93.56719090083101,
          88.95879369803862,
          84.47665593313917,
          80.12077760613252,
          75.89115871701898,
          71.78779926579857,
          70.08758507248933,
          67.81069925247103,
          63.959858677036436,
          60.23527753949486,
          56.63695583984632,
          53.1648935780906,
          49.81909075422797,
          46.59954736825837,
          43.506263420181654,
          40.539238909998005,
          37.69847383770731,
          34.983968203309516,
          32.39572200680478,
          29.933735248193052,
          27.598007927474264,
          25.388540044648472,
          23.305331599715657,
          21.34838259267582,
          19.517693023528906,
          17.813262892275063,
          16.235092198914188,
          14.783180943446297,
          13.457529125871382,
          12.2581367461894,
          11.185003804400488,
          10.238130300504537,
          9.417516234501548,
          8.723161606391521,
          8.155066416174478,
          7.713230663850453,
          7.629198901535609,
          7.397654349419369,
          7.208337472881311,
          7.146565851011282,
          7.145280034236194,
          7.2084820334840884,
          7.397943470624966,
          7.713664345658806,
          8.155644658585665,
          8.723884409405457,
          9.418383598118297,
          10.239142224724027,
          11.186160289222812,
          12.259437791614559,
          13.45897473189931,
          14.784771110077003,
          16.236826926147685,
          17.81514218011135,
          19.51971687196805,
          21.350551001717697,
          21.969450303447523,
          23.307644569360306,
          25.3909975748959,
          27.600610018324474,
          29.936481899646054,
          32.398613218860625,
          34.98700397596818,
          37.70165417096872,
          40.54256380386224,
          43.50973287464868,
          46.6031613833282,
          49.82284932990059,
          52.36766270050214,
          53.16879671436611,
          56.64100353672444,
          60.23946979697577,
          63.964195495120265,
          67.81518063115756,
          71.79242520508798,
          75.89592921691117,
          80.12569266662757,
          84.48171555423687,
          88.96399787973914,
          93.57253964313436,
          98.30734084442267,
          103.16840148360387,
          108.15572156067799,
          113.26930107564522,
          118.50914002850527,
          123.87523841925872,
          129.36759624790477,
          134.98621351444373,
          140.73109021887595,
          146.60222636120102,
          152.599621941419,
          158.72327695953007,
          164.97319141553405,
          171.34936530943102,
          177.85179864122088,
          184.4804914109041,
          191.23544361848016,
          198.11665526394913,
          205.12412634731078,
          212.25785686856582,
          219.5178468277136,
          226.90409622475454,
          234.41660505968855,
          242.05537333251533,
          249.82040104323517,
          257.71168819184805,
          265.7292347783537,
          273.87304080275237,
          282.1431062650443,
          290.5394311652291,
          299.06201550330627,
          307.7108592792773,
          316.4859624931412,
          325.38732514489715,
          334.41494723454736,
          343.5688287620901,
          352.8489697275255,
          362.2553701308543,
          371.78802997207606,
          381.44694925119035,
          391.2321279681978,
          401.1435661230983,
          411.1812637158919,
          421.34522074657843,
          431.635437215158,
          442.0519131216304,
          452.59464846599565,
          463.26364324825386,
          474.05889746840535,
          484.9804111264499,
          496.0281842223875,
          507.2022167562176,
          518.5025087279411,
          529.9290601375575,
          541.4818709850667,
          553.1609412704686,
          564.9662709937642,
          576.8978601549518,
          588.9557087540335,
          601.1398167910083,
          613.4501842658744,
          625.8868111786351,
          638.4496975292883,
          651.1388433178345,
          663.9542485442734,
          676.8959132086044,
          689.9638373108303,
          703.1580208509494,
          716.4784638289594,
          729.9251662448637,
          743.4981280986614,
          757.1973493903508,
          771.0228301199339,
          784.9745702874093,
          799.0525698927783,
          813.2568289360411,
          827.5873474171954,
          842.0441253362433,
          856.627162693184,
          871.3364594880175,
          886.1720157207452,
          901.133831391365,
          916.2219064998774,
          931.436241046283,
          946.7768350305815,
          962.2436884527729,
          977.8368013128593,
          993.5561736108365,
          1009.4018053467075,
          1025.3736965204703,
          1041.4718471321278,
          1057.6962571816775,
          1074.0469266691193,
          1090.523855594456,
          1107.1270439576833,
          1123.8564917588049,
          1140.71219899782,
          1157.6941656747274
         ]
        },
        {
         "name": "Abs. Loss",
         "type": "scatter",
         "x": [
          0,
          0.25125628140703515,
          0.5025125628140703,
          0.7537688442211055,
          1.0050251256281406,
          1.2562814070351758,
          1.507537688442211,
          1.758793969849246,
          2.0100502512562812,
          2.2613065326633164,
          2.5125628140703515,
          2.7638190954773867,
          3.015075376884422,
          3.266331658291457,
          3.517587939698492,
          3.7688442211055273,
          4.0201005025125625,
          4.271356783919598,
          4.522613065326633,
          4.773869346733668,
          5.025125628140703,
          5.276381909547738,
          5.527638190954773,
          5.7788944723618085,
          6.030150753768844,
          6.281407035175879,
          6.532663316582914,
          6.783919597989949,
          7.035175879396984,
          7.2864321608040195,
          7.537688442211055,
          7.78894472361809,
          8.040201005025125,
          8.146639511201629,
          8.29145728643216,
          8.542713567839195,
          8.793969849246231,
          9.045226130653266,
          9.2964824120603,
          9.547738693467336,
          9.798994974874372,
          10.050251256281406,
          10.30150753768844,
          10.552763819095476,
          10.804020100502512,
          11.055276381909547,
          11.306532663316581,
          11.557788944723617,
          11.809045226130653,
          12.060301507537687,
          12.311557788944722,
          12.562814070351758,
          12.814070351758794,
          13.065326633165828,
          13.316582914572862,
          13.567839195979898,
          13.819095477386934,
          14.070351758793969,
          14.321608040201003,
          14.572864321608039,
          14.824120603015075,
          15.07537688442211,
          15.326633165829143,
          15.384615384615385,
          15.57788944723618,
          15.829145728643216,
          16.044399596367306,
          16.08040201005025,
          16.331658291457284,
          16.58291457286432,
          16.834170854271356,
          17.08542713567839,
          17.336683417085425,
          17.587939698492463,
          17.839195979899497,
          18.09045226130653,
          18.341708542713565,
          18.5929648241206,
          18.844221105527637,
          19.09547738693467,
          19.346733668341706,
          19.597989949748744,
          19.849246231155778,
          19.930475086906142,
          20.100502512562812,
          20.351758793969847,
          20.60301507537688,
          20.85427135678392,
          21.105527638190953,
          21.356783919597987,
          21.608040201005025,
          21.85929648241206,
          22.110552763819094,
          22.361809045226128,
          22.613065326633162,
          22.80501710376283,
          22.8643216080402,
          23.115577889447234,
          23.36683417085427,
          23.618090452261306,
          23.86934673366834,
          24.120603015075375,
          24.37185929648241,
          24.623115577889443,
          24.87437185929648,
          25.125628140703515,
          25.37688442211055,
          25.628140703517587,
          25.87939698492462,
          26.130653266331656,
          26.38190954773869,
          26.633165829145725,
          26.884422110552762,
          27.135678391959797,
          27.38693467336683,
          27.63819095477387,
          27.889447236180903,
          28.140703517587937,
          28.39195979899497,
          28.643216080402006,
          28.894472361809044,
          29.145728643216078,
          29.396984924623112,
          29.64824120603015,
          29.899497487437184,
          30.15075376884422,
          30.402010050251253,
          30.653266331658287,
          30.904522613065325,
          31.15577889447236,
          31.407035175879393,
          31.65829145728643,
          31.909547738693465,
          32.1608040201005,
          32.41206030150754,
          32.66331658291457,
          32.914572864321606,
          33.16582914572864,
          33.417085427135675,
          33.66834170854271,
          33.91959798994974,
          34.17085427135678,
          34.42211055276382,
          34.67336683417085,
          34.92462311557789,
          35.175879396984925,
          35.427135678391956,
          35.678391959798994,
          35.929648241206024,
          36.18090452261306,
          36.4321608040201,
          36.68341708542713,
          36.93467336683417,
          37.1859296482412,
          37.43718592964824,
          37.688442211055275,
          37.939698492462306,
          38.19095477386934,
          38.44221105527638,
          38.69346733668341,
          38.94472361809045,
          39.19597989949749,
          39.44723618090452,
          39.698492462311556,
          39.94974874371859,
          40.201005025125625,
          40.45226130653266,
          40.70351758793969,
          40.95477386934673,
          41.20603015075376,
          41.4572864321608,
          41.70854271356784,
          41.95979899497487,
          42.211055276381906,
          42.462311557788944,
          42.713567839195974,
          42.96482412060301,
          43.21608040201005,
          43.46733668341708,
          43.71859296482412,
          43.96984924623115,
          44.22110552763819,
          44.472361809045225,
          44.723618090452256,
          44.97487437185929,
          45.226130653266324,
          45.47738693467336,
          45.7286432160804,
          45.97989949748743,
          46.23115577889447,
          46.482412060301506,
          46.73366834170854,
          46.984924623115575,
          47.23618090452261,
          47.48743718592964,
          47.73869346733668,
          47.98994974874371,
          48.24120603015075,
          48.49246231155779,
          48.74371859296482,
          48.994974874371856,
          49.24623115577889,
          49.497487437185924,
          49.74874371859296,
          50
         ],
         "y": [
          16.46222933657066,
          16.210973055163624,
          15.959716773756588,
          15.708460492349554,
          15.457204210942518,
          15.205947929535483,
          14.954691648128446,
          14.703435366721411,
          14.452179085314375,
          14.200922803907343,
          13.949666522500308,
          13.69841024109327,
          13.447153959686236,
          13.1958976782792,
          12.944641396872166,
          12.69338511546513,
          12.442128834058096,
          12.190872552651062,
          11.939616271244025,
          11.68835998983699,
          11.437103708429955,
          11.185847427022921,
          10.934591145615885,
          10.683334864208849,
          10.432078582801815,
          10.18082230139478,
          9.929566019987746,
          9.678309738580708,
          9.427053457173674,
          9.175797175766638,
          8.924540894359604,
          8.673284612952568,
          8.422028331545533,
          8.315589825369027,
          8.22869916023071,
          8.07794539138649,
          7.927191622542269,
          7.776437853698046,
          7.625684084853828,
          7.474930316009605,
          7.324176547165384,
          7.1734227783211635,
          7.022669009476942,
          6.8719152406327195,
          6.7211614717885,
          6.570407702944278,
          6.419653934100059,
          6.268900165255836,
          6.118146396411615,
          5.967392627567395,
          5.816638858723174,
          5.665885089878952,
          5.5151313210347315,
          5.3643775521905095,
          5.21362378334629,
          5.062870014502067,
          4.912116245657846,
          4.761362476813626,
          4.610608707969405,
          4.459854939125183,
          4.309101170280963,
          4.158347401436741,
          4.007593632592521,
          3.9728043013207754,
          3.934149488796616,
          3.88389823251521,
          3.8408474589703916,
          3.84804794170698,
          3.8982991979883876,
          3.948550454269794,
          3.9988017105512013,
          4.049052966832609,
          4.099304223114015,
          4.149555479395422,
          4.1998067356768285,
          4.250057991958236,
          4.300309248239643,
          4.3505605045210505,
          4.4008117608024575,
          4.451063017083864,
          4.501314273365272,
          4.551565529646679,
          4.601816785928085,
          4.618062557078159,
          4.72007901247216,
          4.8708327813163805,
          5.021586550160602,
          5.1723403190048245,
          5.323094087849045,
          5.473847856693266,
          5.624601625537489,
          5.775355394381708,
          5.926109163225929,
          6.076862932070149,
          6.22761670091437,
          6.342787767192171,
          6.402092271469542,
          6.653348552876575,
          6.90460483428361,
          7.155861115690648,
          7.407117397097681,
          7.6583736785047165,
          7.90962995991175,
          8.160886241318785,
          8.412142522725823,
          8.663398804132857,
          8.914655085539891,
          9.16591136694693,
          9.417167648353963,
          9.668423929760998,
          9.919680211168032,
          10.170936492575066,
          10.422192773982104,
          10.673449055389138,
          10.924705336796173,
          11.17596161820321,
          11.427217899610245,
          11.678474181017279,
          11.929730462424313,
          12.180986743831347,
          12.432243025238385,
          12.68349930664542,
          12.934755588052454,
          13.186011869459492,
          13.437268150866526,
          13.688524432273562,
          13.939780713680594,
          14.191036995087629,
          14.442293276494667,
          14.6935495579017,
          14.944805839308737,
          15.196062120715771,
          15.447318402122807,
          15.698574683529841,
          15.94983096493688,
          16.20108724634391,
          16.452343527750948,
          16.70359980915798,
          16.954856090565016,
          17.206112371972054,
          17.457368653379085,
          17.708624934786123,
          17.95988121619316,
          18.21113749760019,
          18.46239377900723,
          18.713650060414267,
          18.964906341821298,
          19.216162623228335,
          19.467418904635366,
          19.718675186042404,
          19.96993146744944,
          20.221187748856472,
          20.47244403026351,
          20.72370031167054,
          20.97495659307758,
          21.226212874484617,
          21.477469155891647,
          21.728725437298685,
          21.979981718705723,
          22.231238000112754,
          22.48249428151979,
          22.73375056292683,
          22.98500684433386,
          23.236263125740898,
          23.48751940714793,
          23.738775688554966,
          23.990031969962004,
          24.241288251369035,
          24.492544532776073,
          24.743800814183103,
          24.99505709559014,
          25.24631337699718,
          25.49756965840421,
          25.748825939811248,
          26.000082221218285,
          26.251338502625316,
          26.50259478403235,
          26.75385106543939,
          27.005107346846422,
          27.25636362825346,
          27.50761990966049,
          27.758876191067532,
          28.010132472474567,
          28.261388753881597,
          28.512645035288635,
          28.763901316695666,
          29.0151575981027,
          29.26641387950974,
          29.517670160916772,
          29.76892644232381,
          30.020182723730848,
          30.271439005137882,
          30.522695286544916,
          30.77395156795195,
          31.025207849358985,
          31.276464130766023,
          31.52772041217305,
          31.77897669358009,
          32.03023297498713,
          32.28148925639416,
          32.5327455378012,
          32.78400181920823,
          33.035258100615266,
          33.286514382022304,
          33.53777066342934
         ]
        },
        {
         "name": "Huber Loss",
         "type": "scatter",
         "x": [
          0,
          0.25125628140703515,
          0.5025125628140703,
          0.7537688442211055,
          1.0050251256281406,
          1.2562814070351758,
          1.507537688442211,
          1.758793969849246,
          2.0100502512562812,
          2.2613065326633164,
          2.5125628140703515,
          2.7638190954773867,
          3.015075376884422,
          3.266331658291457,
          3.517587939698492,
          3.7688442211055273,
          4.0201005025125625,
          4.271356783919598,
          4.522613065326633,
          4.773869346733668,
          5.025125628140703,
          5.276381909547738,
          5.527638190954773,
          5.7788944723618085,
          6.030150753768844,
          6.281407035175879,
          6.532663316582914,
          6.783919597989949,
          7.035175879396984,
          7.2864321608040195,
          7.537688442211055,
          7.78894472361809,
          8.040201005025125,
          8.146639511201629,
          8.29145728643216,
          8.542713567839195,
          8.793969849246231,
          9.045226130653266,
          9.2964824120603,
          9.547738693467336,
          9.798994974874372,
          10.050251256281406,
          10.30150753768844,
          10.552763819095476,
          10.804020100502512,
          11.055276381909547,
          11.306532663316581,
          11.557788944723617,
          11.809045226130653,
          12.060301507537687,
          12.311557788944722,
          12.562814070351758,
          12.814070351758794,
          13.065326633165828,
          13.316582914572862,
          13.567839195979898,
          13.819095477386934,
          14.070351758793969,
          14.321608040201003,
          14.572864321608039,
          14.824120603015075,
          15.07537688442211,
          15.326633165829143,
          15.384615384615385,
          15.57788944723618,
          15.829145728643216,
          16.044399596367306,
          16.08040201005025,
          16.331658291457284,
          16.58291457286432,
          16.834170854271356,
          17.08542713567839,
          17.336683417085425,
          17.587939698492463,
          17.839195979899497,
          18.09045226130653,
          18.341708542713565,
          18.5929648241206,
          18.844221105527637,
          19.09547738693467,
          19.346733668341706,
          19.597989949748744,
          19.849246231155778,
          19.930475086906142,
          20.100502512562812,
          20.351758793969847,
          20.60301507537688,
          20.85427135678392,
          21.105527638190953,
          21.356783919597987,
          21.608040201005025,
          21.85929648241206,
          22.110552763819094,
          22.361809045226128,
          22.613065326633162,
          22.80501710376283,
          22.8643216080402,
          23.115577889447234,
          23.36683417085427,
          23.618090452261306,
          23.86934673366834,
          24.120603015075375,
          24.37185929648241,
          24.623115577889443,
          24.87437185929648,
          25.125628140703515,
          25.37688442211055,
          25.628140703517587,
          25.87939698492462,
          26.130653266331656,
          26.38190954773869,
          26.633165829145725,
          26.884422110552762,
          27.135678391959797,
          27.38693467336683,
          27.63819095477387,
          27.889447236180903,
          28.140703517587937,
          28.39195979899497,
          28.643216080402006,
          28.894472361809044,
          29.145728643216078,
          29.396984924623112,
          29.64824120603015,
          29.899497487437184,
          30.15075376884422,
          30.402010050251253,
          30.653266331658287,
          30.904522613065325,
          31.15577889447236,
          31.407035175879393,
          31.65829145728643,
          31.909547738693465,
          32.1608040201005,
          32.41206030150754,
          32.66331658291457,
          32.914572864321606,
          33.16582914572864,
          33.417085427135675,
          33.66834170854271,
          33.91959798994974,
          34.17085427135678,
          34.42211055276382,
          34.67336683417085,
          34.92462311557789,
          35.175879396984925,
          35.427135678391956,
          35.678391959798994,
          35.929648241206024,
          36.18090452261306,
          36.4321608040201,
          36.68341708542713,
          36.93467336683417,
          37.1859296482412,
          37.43718592964824,
          37.688442211055275,
          37.939698492462306,
          38.19095477386934,
          38.44221105527638,
          38.69346733668341,
          38.94472361809045,
          39.19597989949749,
          39.44723618090452,
          39.698492462311556,
          39.94974874371859,
          40.201005025125625,
          40.45226130653266,
          40.70351758793969,
          40.95477386934673,
          41.20603015075376,
          41.4572864321608,
          41.70854271356784,
          41.95979899497487,
          42.211055276381906,
          42.462311557788944,
          42.713567839195974,
          42.96482412060301,
          43.21608040201005,
          43.46733668341708,
          43.71859296482412,
          43.96984924623115,
          44.22110552763819,
          44.472361809045225,
          44.723618090452256,
          44.97487437185929,
          45.226130653266324,
          45.47738693467336,
          45.7286432160804,
          45.97989949748743,
          46.23115577889447,
          46.482412060301506,
          46.73366834170854,
          46.984924623115575,
          47.23618090452261,
          47.48743718592964,
          47.73869346733668,
          47.98994974874371,
          48.24120603015075,
          48.49246231155779,
          48.74371859296482,
          48.994974874371856,
          49.24623115577889,
          49.497487437185924,
          49.74874371859296,
          50
         ],
         "y": [
          15.962229336570658,
          15.710973055163624,
          15.459716773756588,
          15.208460492349554,
          14.957204210942518,
          14.705947929535483,
          14.454691648128446,
          14.203435366721411,
          13.952179085314375,
          13.700922803907343,
          13.449666522500308,
          13.19841024109327,
          12.947153959686236,
          12.6958976782792,
          12.444641396872166,
          12.19338511546513,
          11.942128834058096,
          11.690872552651062,
          11.439616271244025,
          11.18835998983699,
          10.937103708429955,
          10.685847427022921,
          10.434591145615885,
          10.183334864208849,
          9.932078582801815,
          9.68082230139478,
          9.429566019987746,
          9.178309738580708,
          8.927053457173674,
          8.677751374254925,
          8.439832821003964,
          8.214540211542303,
          8.001873545869941,
          7.915589825369028,
          7.801832823986876,
          7.6144180458931086,
          7.439629211588641,
          7.277466321073471,
          7.125684084853828,
          6.974930316009605,
          6.824176547165384,
          6.6734227783211635,
          6.522669009476942,
          6.37191524063272,
          6.2211614717885,
          6.070407702944278,
          5.919653934100059,
          5.768900165255836,
          5.618146396411615,
          5.467392627567395,
          5.316638858723174,
          5.165885089878952,
          5.0151313210347315,
          4.8643775521905095,
          4.71362378334629,
          4.562870014502067,
          4.412116245657846,
          4.261362476813626,
          4.110608707969405,
          3.9633987053530695,
          3.828417653981018,
          3.7061585056357877,
          3.604298961377927,
          3.5843789795781023,
          3.527691304698662,
          3.4763355355979932,
          3.4524221372277184,
          3.450231654075922,
          3.449379660132447,
          3.4698472969615493,
          3.5032213229515263,
          3.549052966832609,
          3.5993042231140153,
          3.649555479395423,
          3.6998067356768303,
          3.7500579919582364,
          3.800309248239644,
          3.85056050452105,
          3.9008117608024575,
          3.953785592985335,
          4.018641394027147,
          4.096123138858258,
          4.186230827478664,
          4.2180625570781585,
          4.288964459888371,
          4.404324036087374,
          4.532309556075677,
          4.672921019853279,
          4.823094087849045,
          4.973847856693266,
          5.124601625537489,
          5.275650019476363,
          5.435444367182531,
          5.607864658677997,
          5.792910893962761,
          5.94278776719217,
          5.9905830730368255,
          6.200881195900186,
          6.423805262552845,
          6.659355272994804,
          6.907117397097681,
          7.1583736785047165,
          7.40962995991175,
          7.660886241318785,
          7.912142522725823,
          8.163398804132857,
          8.414655085539891,
          8.66591136694693,
          8.917167648353963,
          9.168423929760998,
          9.419680211168032,
          9.670936492575066,
          9.922192773982104,
          10.173449055389138,
          10.424705336796173,
          10.67596161820321,
          10.927217899610245,
          11.178474181017279,
          11.429730462424313,
          11.680986743831347,
          11.932243025238385,
          12.18349930664542,
          12.434755588052454,
          12.686011869459492,
          12.937268150866526,
          13.188524432273562,
          13.439780713680594,
          13.691036995087629,
          13.942293276494667,
          14.1935495579017,
          14.444805839308737,
          14.696062120715771,
          14.947318402122807,
          15.198574683529841,
          15.44983096493688,
          15.701087246343912,
          15.952343527750946,
          16.20359980915798,
          16.454856090565016,
          16.706112371972054,
          16.957368653379085,
          17.208624934786123,
          17.45988121619316,
          17.71113749760019,
          17.96239377900723,
          18.213650060414267,
          18.464906341821298,
          18.716162623228335,
          18.967418904635366,
          19.218675186042404,
          19.46993146744944,
          19.721187748856472,
          19.97244403026351,
          20.22370031167054,
          20.47495659307758,
          20.726212874484617,
          20.977469155891647,
          21.228725437298685,
          21.479981718705723,
          21.731238000112754,
          21.98249428151979,
          22.23375056292683,
          22.48500684433386,
          22.736263125740898,
          22.98751940714793,
          23.238775688554966,
          23.490031969962004,
          23.741288251369035,
          23.992544532776073,
          24.243800814183103,
          24.49505709559014,
          24.74631337699718,
          24.99756965840421,
          25.248825939811248,
          25.500082221218285,
          25.751338502625316,
          26.00259478403235,
          26.25385106543939,
          26.505107346846422,
          26.75636362825346,
          27.00761990966049,
          27.258876191067532,
          27.510132472474567,
          27.761388753881597,
          28.012645035288635,
          28.263901316695666,
          28.5151575981027,
          28.76641387950974,
          29.017670160916772,
          29.26892644232381,
          29.520182723730848,
          29.771439005137882,
          30.022695286544916,
          30.27395156795195,
          30.525207849358985,
          30.776464130766023,
          31.02772041217305,
          31.27897669358009,
          31.530232974987133,
          31.78148925639416,
          32.0327455378012,
          32.28400181920823,
          32.535258100615266,
          32.786514382022304,
          33.03777066342934
         ]
        },
        {
         "line": {
          "color": "red",
          "width": 0.5
         },
         "mode": "lines",
         "showlegend": false,
         "type": "scatter",
         "x": [
          16.044399596367306,
          16.044399596367306
         ],
         "y": [
          0,
          20
         ]
        },
        {
         "line": {
          "color": "red",
          "width": 0.5
         },
         "mode": "lines",
         "showlegend": false,
         "type": "scatter",
         "x": [
          22.80501710376283,
          22.80501710376283
         ],
         "y": [
          0,
          20
         ]
        },
        {
         "line": {
          "color": "red",
          "width": 0.5
         },
         "mode": "lines",
         "showlegend": false,
         "type": "scatter",
         "x": [
          8.146639511201629,
          8.146639511201629
         ],
         "y": [
          0,
          20
         ]
        },
        {
         "line": {
          "color": "red",
          "width": 0.5
         },
         "mode": "lines",
         "showlegend": false,
         "type": "scatter",
         "x": [
          19.930475086906142,
          19.930475086906142
         ],
         "y": [
          0,
          20
         ]
        },
        {
         "line": {
          "color": "red",
          "width": 0.5
         },
         "mode": "lines",
         "showlegend": false,
         "type": "scatter",
         "x": [
          15.384615384615385,
          15.384615384615385
         ],
         "y": [
          0,
          20
         ]
        }
       ],
       "layout": {
        "xaxis": {
         "title": "Theta Values"
        },
        "yaxis": {
         "range": [
          0,
          20
         ]
        }
       }
      },
      "text/html": [
       "<div id=\"ba7f8f4b-c7b3-43ff-a64d-fafaa8266a20\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"ba7f8f4b-c7b3-43ff-a64d-fafaa8266a20\", [{\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [265.719982899775, 257.7025808738721, 249.81143828586193, 242.04655513574482, 234.40793142352084, 226.8955671491898, 219.50946231275168, 212.2496169142067, 205.11603095355466, 198.10870443079548, 191.22763734592925, 184.47282969895593, 177.84428148987587, 171.34199271868877, 164.96596338539442, 158.71619348999315, 152.59268303248504, 146.59543201286968, 140.7244404311476, 134.97970828731812, 129.36123558138192, 123.8690223133386, 118.50306848318826, 113.26337409093077, 108.14993913656639, 103.16276362009492, 98.30184754151657, 93.56719090083101, 88.95879369803862, 84.47665593313917, 80.12077760613252, 75.89115871701898, 71.78779926579857, 70.08758507248933, 67.81069925247103, 63.959858677036436, 60.23527753949486, 56.63695583984632, 53.1648935780906, 49.81909075422797, 46.59954736825837, 43.506263420181654, 40.539238909998005, 37.69847383770731, 34.983968203309516, 32.39572200680478, 29.933735248193052, 27.598007927474264, 25.388540044648472, 23.305331599715657, 21.34838259267582, 19.517693023528906, 17.813262892275063, 16.235092198914188, 14.783180943446297, 13.457529125871382, 12.2581367461894, 11.185003804400488, 10.238130300504537, 9.417516234501548, 8.723161606391521, 8.155066416174478, 7.713230663850453, 7.629198901535609, 7.397654349419369, 7.208337472881311, 7.146565851011282, 7.145280034236194, 7.2084820334840884, 7.397943470624966, 7.713664345658806, 8.155644658585665, 8.723884409405457, 9.418383598118297, 10.239142224724027, 11.186160289222812, 12.259437791614559, 13.45897473189931, 14.784771110077003, 16.236826926147685, 17.81514218011135, 19.51971687196805, 21.350551001717697, 21.969450303447523, 23.307644569360306, 25.3909975748959, 27.600610018324474, 29.936481899646054, 32.398613218860625, 34.98700397596818, 37.70165417096872, 40.54256380386224, 43.50973287464868, 46.6031613833282, 49.82284932990059, 52.36766270050214, 53.16879671436611, 56.64100353672444, 60.23946979697577, 63.964195495120265, 67.81518063115756, 71.79242520508798, 75.89592921691117, 80.12569266662757, 84.48171555423687, 88.96399787973914, 93.57253964313436, 98.30734084442267, 103.16840148360387, 108.15572156067799, 113.26930107564522, 118.50914002850527, 123.87523841925872, 129.36759624790477, 134.98621351444373, 140.73109021887595, 146.60222636120102, 152.599621941419, 158.72327695953007, 164.97319141553405, 171.34936530943102, 177.85179864122088, 184.4804914109041, 191.23544361848016, 198.11665526394913, 205.12412634731078, 212.25785686856582, 219.5178468277136, 226.90409622475454, 234.41660505968855, 242.05537333251533, 249.82040104323517, 257.71168819184805, 265.7292347783537, 273.87304080275237, 282.1431062650443, 290.5394311652291, 299.06201550330627, 307.7108592792773, 316.4859624931412, 325.38732514489715, 334.41494723454736, 343.5688287620901, 352.8489697275255, 362.2553701308543, 371.78802997207606, 381.44694925119035, 391.2321279681978, 401.1435661230983, 411.1812637158919, 421.34522074657843, 431.635437215158, 442.0519131216304, 452.59464846599565, 463.26364324825386, 474.05889746840535, 484.9804111264499, 496.0281842223875, 507.2022167562176, 518.5025087279411, 529.9290601375575, 541.4818709850667, 553.1609412704686, 564.9662709937642, 576.8978601549518, 588.9557087540335, 601.1398167910083, 613.4501842658744, 625.8868111786351, 638.4496975292883, 651.1388433178345, 663.9542485442734, 676.8959132086044, 689.9638373108303, 703.1580208509494, 716.4784638289594, 729.9251662448637, 743.4981280986614, 757.1973493903508, 771.0228301199339, 784.9745702874093, 799.0525698927783, 813.2568289360411, 827.5873474171954, 842.0441253362433, 856.627162693184, 871.3364594880175, 886.1720157207452, 901.133831391365, 916.2219064998774, 931.436241046283, 946.7768350305815, 962.2436884527729, 977.8368013128593, 993.5561736108365, 1009.4018053467075, 1025.3736965204703, 1041.4718471321278, 1057.6962571816775, 1074.0469266691193, 1090.523855594456, 1107.1270439576833, 1123.8564917588049, 1140.71219899782, 1157.6941656747274], \"name\": \"Squared Loss - 20\"}, {\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [16.46222933657066, 16.210973055163624, 15.959716773756588, 15.708460492349554, 15.457204210942518, 15.205947929535483, 14.954691648128446, 14.703435366721411, 14.452179085314375, 14.200922803907343, 13.949666522500308, 13.69841024109327, 13.447153959686236, 13.1958976782792, 12.944641396872166, 12.69338511546513, 12.442128834058096, 12.190872552651062, 11.939616271244025, 11.68835998983699, 11.437103708429955, 11.185847427022921, 10.934591145615885, 10.683334864208849, 10.432078582801815, 10.18082230139478, 9.929566019987746, 9.678309738580708, 9.427053457173674, 9.175797175766638, 8.924540894359604, 8.673284612952568, 8.422028331545533, 8.315589825369027, 8.22869916023071, 8.07794539138649, 7.927191622542269, 7.776437853698046, 7.625684084853828, 7.474930316009605, 7.324176547165384, 7.1734227783211635, 7.022669009476942, 6.8719152406327195, 6.7211614717885, 6.570407702944278, 6.419653934100059, 6.268900165255836, 6.118146396411615, 5.967392627567395, 5.816638858723174, 5.665885089878952, 5.5151313210347315, 5.3643775521905095, 5.21362378334629, 5.062870014502067, 4.912116245657846, 4.761362476813626, 4.610608707969405, 4.459854939125183, 4.309101170280963, 4.158347401436741, 4.007593632592521, 3.9728043013207754, 3.934149488796616, 3.88389823251521, 3.8408474589703916, 3.84804794170698, 3.8982991979883876, 3.948550454269794, 3.9988017105512013, 4.049052966832609, 4.099304223114015, 4.149555479395422, 4.1998067356768285, 4.250057991958236, 4.300309248239643, 4.3505605045210505, 4.4008117608024575, 4.451063017083864, 4.501314273365272, 4.551565529646679, 4.601816785928085, 4.618062557078159, 4.72007901247216, 4.8708327813163805, 5.021586550160602, 5.1723403190048245, 5.323094087849045, 5.473847856693266, 5.624601625537489, 5.775355394381708, 5.926109163225929, 6.076862932070149, 6.22761670091437, 6.342787767192171, 6.402092271469542, 6.653348552876575, 6.90460483428361, 7.155861115690648, 7.407117397097681, 7.6583736785047165, 7.90962995991175, 8.160886241318785, 8.412142522725823, 8.663398804132857, 8.914655085539891, 9.16591136694693, 9.417167648353963, 9.668423929760998, 9.919680211168032, 10.170936492575066, 10.422192773982104, 10.673449055389138, 10.924705336796173, 11.17596161820321, 11.427217899610245, 11.678474181017279, 11.929730462424313, 12.180986743831347, 12.432243025238385, 12.68349930664542, 12.934755588052454, 13.186011869459492, 13.437268150866526, 13.688524432273562, 13.939780713680594, 14.191036995087629, 14.442293276494667, 14.6935495579017, 14.944805839308737, 15.196062120715771, 15.447318402122807, 15.698574683529841, 15.94983096493688, 16.20108724634391, 16.452343527750948, 16.70359980915798, 16.954856090565016, 17.206112371972054, 17.457368653379085, 17.708624934786123, 17.95988121619316, 18.21113749760019, 18.46239377900723, 18.713650060414267, 18.964906341821298, 19.216162623228335, 19.467418904635366, 19.718675186042404, 19.96993146744944, 20.221187748856472, 20.47244403026351, 20.72370031167054, 20.97495659307758, 21.226212874484617, 21.477469155891647, 21.728725437298685, 21.979981718705723, 22.231238000112754, 22.48249428151979, 22.73375056292683, 22.98500684433386, 23.236263125740898, 23.48751940714793, 23.738775688554966, 23.990031969962004, 24.241288251369035, 24.492544532776073, 24.743800814183103, 24.99505709559014, 25.24631337699718, 25.49756965840421, 25.748825939811248, 26.000082221218285, 26.251338502625316, 26.50259478403235, 26.75385106543939, 27.005107346846422, 27.25636362825346, 27.50761990966049, 27.758876191067532, 28.010132472474567, 28.261388753881597, 28.512645035288635, 28.763901316695666, 29.0151575981027, 29.26641387950974, 29.517670160916772, 29.76892644232381, 30.020182723730848, 30.271439005137882, 30.522695286544916, 30.77395156795195, 31.025207849358985, 31.276464130766023, 31.52772041217305, 31.77897669358009, 32.03023297498713, 32.28148925639416, 32.5327455378012, 32.78400181920823, 33.035258100615266, 33.286514382022304, 33.53777066342934], \"name\": \"Abs. Loss\"}, {\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [15.962229336570658, 15.710973055163624, 15.459716773756588, 15.208460492349554, 14.957204210942518, 14.705947929535483, 14.454691648128446, 14.203435366721411, 13.952179085314375, 13.700922803907343, 13.449666522500308, 13.19841024109327, 12.947153959686236, 12.6958976782792, 12.444641396872166, 12.19338511546513, 11.942128834058096, 11.690872552651062, 11.439616271244025, 11.18835998983699, 10.937103708429955, 10.685847427022921, 10.434591145615885, 10.183334864208849, 9.932078582801815, 9.68082230139478, 9.429566019987746, 9.178309738580708, 8.927053457173674, 8.677751374254925, 8.439832821003964, 8.214540211542303, 8.001873545869941, 7.915589825369028, 7.801832823986876, 7.6144180458931086, 7.439629211588641, 7.277466321073471, 7.125684084853828, 6.974930316009605, 6.824176547165384, 6.6734227783211635, 6.522669009476942, 6.37191524063272, 6.2211614717885, 6.070407702944278, 5.919653934100059, 5.768900165255836, 5.618146396411615, 5.467392627567395, 5.316638858723174, 5.165885089878952, 5.0151313210347315, 4.8643775521905095, 4.71362378334629, 4.562870014502067, 4.412116245657846, 4.261362476813626, 4.110608707969405, 3.9633987053530695, 3.828417653981018, 3.7061585056357877, 3.604298961377927, 3.5843789795781023, 3.527691304698662, 3.4763355355979932, 3.4524221372277184, 3.450231654075922, 3.449379660132447, 3.4698472969615493, 3.5032213229515263, 3.549052966832609, 3.5993042231140153, 3.649555479395423, 3.6998067356768303, 3.7500579919582364, 3.800309248239644, 3.85056050452105, 3.9008117608024575, 3.953785592985335, 4.018641394027147, 4.096123138858258, 4.186230827478664, 4.2180625570781585, 4.288964459888371, 4.404324036087374, 4.532309556075677, 4.672921019853279, 4.823094087849045, 4.973847856693266, 5.124601625537489, 5.275650019476363, 5.435444367182531, 5.607864658677997, 5.792910893962761, 5.94278776719217, 5.9905830730368255, 6.200881195900186, 6.423805262552845, 6.659355272994804, 6.907117397097681, 7.1583736785047165, 7.40962995991175, 7.660886241318785, 7.912142522725823, 8.163398804132857, 8.414655085539891, 8.66591136694693, 8.917167648353963, 9.168423929760998, 9.419680211168032, 9.670936492575066, 9.922192773982104, 10.173449055389138, 10.424705336796173, 10.67596161820321, 10.927217899610245, 11.178474181017279, 11.429730462424313, 11.680986743831347, 11.932243025238385, 12.18349930664542, 12.434755588052454, 12.686011869459492, 12.937268150866526, 13.188524432273562, 13.439780713680594, 13.691036995087629, 13.942293276494667, 14.1935495579017, 14.444805839308737, 14.696062120715771, 14.947318402122807, 15.198574683529841, 15.44983096493688, 15.701087246343912, 15.952343527750946, 16.20359980915798, 16.454856090565016, 16.706112371972054, 16.957368653379085, 17.208624934786123, 17.45988121619316, 17.71113749760019, 17.96239377900723, 18.213650060414267, 18.464906341821298, 18.716162623228335, 18.967418904635366, 19.218675186042404, 19.46993146744944, 19.721187748856472, 19.97244403026351, 20.22370031167054, 20.47495659307758, 20.726212874484617, 20.977469155891647, 21.228725437298685, 21.479981718705723, 21.731238000112754, 21.98249428151979, 22.23375056292683, 22.48500684433386, 22.736263125740898, 22.98751940714793, 23.238775688554966, 23.490031969962004, 23.741288251369035, 23.992544532776073, 24.243800814183103, 24.49505709559014, 24.74631337699718, 24.99756965840421, 25.248825939811248, 25.500082221218285, 25.751338502625316, 26.00259478403235, 26.25385106543939, 26.505107346846422, 26.75636362825346, 27.00761990966049, 27.258876191067532, 27.510132472474567, 27.761388753881597, 28.012645035288635, 28.263901316695666, 28.5151575981027, 28.76641387950974, 29.017670160916772, 29.26892644232381, 29.520182723730848, 29.771439005137882, 30.022695286544916, 30.27395156795195, 30.525207849358985, 30.776464130766023, 31.02772041217305, 31.27897669358009, 31.530232974987133, 31.78148925639416, 32.0327455378012, 32.28400181920823, 32.535258100615266, 32.786514382022304, 33.03777066342934], \"name\": \"Huber Loss\"}, {\"type\": \"scatter\", \"x\": [16.044399596367306, 16.044399596367306], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [22.80501710376283, 22.80501710376283], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [8.146639511201629, 8.146639511201629], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [19.930475086906142, 19.930475086906142], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [15.384615384615385, 15.384615384615385], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}], {\"xaxis\": {\"title\": \"Theta Values\"}, \"yaxis\": {\"range\": [0, 20]}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<div id=\"ba7f8f4b-c7b3-43ff-a64d-fafaa8266a20\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"ba7f8f4b-c7b3-43ff-a64d-fafaa8266a20\", [{\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [265.719982899775, 257.7025808738721, 249.81143828586193, 242.04655513574482, 234.40793142352084, 226.8955671491898, 219.50946231275168, 212.2496169142067, 205.11603095355466, 198.10870443079548, 191.22763734592925, 184.47282969895593, 177.84428148987587, 171.34199271868877, 164.96596338539442, 158.71619348999315, 152.59268303248504, 146.59543201286968, 140.7244404311476, 134.97970828731812, 129.36123558138192, 123.8690223133386, 118.50306848318826, 113.26337409093077, 108.14993913656639, 103.16276362009492, 98.30184754151657, 93.56719090083101, 88.95879369803862, 84.47665593313917, 80.12077760613252, 75.89115871701898, 71.78779926579857, 70.08758507248933, 67.81069925247103, 63.959858677036436, 60.23527753949486, 56.63695583984632, 53.1648935780906, 49.81909075422797, 46.59954736825837, 43.506263420181654, 40.539238909998005, 37.69847383770731, 34.983968203309516, 32.39572200680478, 29.933735248193052, 27.598007927474264, 25.388540044648472, 23.305331599715657, 21.34838259267582, 19.517693023528906, 17.813262892275063, 16.235092198914188, 14.783180943446297, 13.457529125871382, 12.2581367461894, 11.185003804400488, 10.238130300504537, 9.417516234501548, 8.723161606391521, 8.155066416174478, 7.713230663850453, 7.629198901535609, 7.397654349419369, 7.208337472881311, 7.146565851011282, 7.145280034236194, 7.2084820334840884, 7.397943470624966, 7.713664345658806, 8.155644658585665, 8.723884409405457, 9.418383598118297, 10.239142224724027, 11.186160289222812, 12.259437791614559, 13.45897473189931, 14.784771110077003, 16.236826926147685, 17.81514218011135, 19.51971687196805, 21.350551001717697, 21.969450303447523, 23.307644569360306, 25.3909975748959, 27.600610018324474, 29.936481899646054, 32.398613218860625, 34.98700397596818, 37.70165417096872, 40.54256380386224, 43.50973287464868, 46.6031613833282, 49.82284932990059, 52.36766270050214, 53.16879671436611, 56.64100353672444, 60.23946979697577, 63.964195495120265, 67.81518063115756, 71.79242520508798, 75.89592921691117, 80.12569266662757, 84.48171555423687, 88.96399787973914, 93.57253964313436, 98.30734084442267, 103.16840148360387, 108.15572156067799, 113.26930107564522, 118.50914002850527, 123.87523841925872, 129.36759624790477, 134.98621351444373, 140.73109021887595, 146.60222636120102, 152.599621941419, 158.72327695953007, 164.97319141553405, 171.34936530943102, 177.85179864122088, 184.4804914109041, 191.23544361848016, 198.11665526394913, 205.12412634731078, 212.25785686856582, 219.5178468277136, 226.90409622475454, 234.41660505968855, 242.05537333251533, 249.82040104323517, 257.71168819184805, 265.7292347783537, 273.87304080275237, 282.1431062650443, 290.5394311652291, 299.06201550330627, 307.7108592792773, 316.4859624931412, 325.38732514489715, 334.41494723454736, 343.5688287620901, 352.8489697275255, 362.2553701308543, 371.78802997207606, 381.44694925119035, 391.2321279681978, 401.1435661230983, 411.1812637158919, 421.34522074657843, 431.635437215158, 442.0519131216304, 452.59464846599565, 463.26364324825386, 474.05889746840535, 484.9804111264499, 496.0281842223875, 507.2022167562176, 518.5025087279411, 529.9290601375575, 541.4818709850667, 553.1609412704686, 564.9662709937642, 576.8978601549518, 588.9557087540335, 601.1398167910083, 613.4501842658744, 625.8868111786351, 638.4496975292883, 651.1388433178345, 663.9542485442734, 676.8959132086044, 689.9638373108303, 703.1580208509494, 716.4784638289594, 729.9251662448637, 743.4981280986614, 757.1973493903508, 771.0228301199339, 784.9745702874093, 799.0525698927783, 813.2568289360411, 827.5873474171954, 842.0441253362433, 856.627162693184, 871.3364594880175, 886.1720157207452, 901.133831391365, 916.2219064998774, 931.436241046283, 946.7768350305815, 962.2436884527729, 977.8368013128593, 993.5561736108365, 1009.4018053467075, 1025.3736965204703, 1041.4718471321278, 1057.6962571816775, 1074.0469266691193, 1090.523855594456, 1107.1270439576833, 1123.8564917588049, 1140.71219899782, 1157.6941656747274], \"name\": \"Squared Loss - 20\"}, {\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [16.46222933657066, 16.210973055163624, 15.959716773756588, 15.708460492349554, 15.457204210942518, 15.205947929535483, 14.954691648128446, 14.703435366721411, 14.452179085314375, 14.200922803907343, 13.949666522500308, 13.69841024109327, 13.447153959686236, 13.1958976782792, 12.944641396872166, 12.69338511546513, 12.442128834058096, 12.190872552651062, 11.939616271244025, 11.68835998983699, 11.437103708429955, 11.185847427022921, 10.934591145615885, 10.683334864208849, 10.432078582801815, 10.18082230139478, 9.929566019987746, 9.678309738580708, 9.427053457173674, 9.175797175766638, 8.924540894359604, 8.673284612952568, 8.422028331545533, 8.315589825369027, 8.22869916023071, 8.07794539138649, 7.927191622542269, 7.776437853698046, 7.625684084853828, 7.474930316009605, 7.324176547165384, 7.1734227783211635, 7.022669009476942, 6.8719152406327195, 6.7211614717885, 6.570407702944278, 6.419653934100059, 6.268900165255836, 6.118146396411615, 5.967392627567395, 5.816638858723174, 5.665885089878952, 5.5151313210347315, 5.3643775521905095, 5.21362378334629, 5.062870014502067, 4.912116245657846, 4.761362476813626, 4.610608707969405, 4.459854939125183, 4.309101170280963, 4.158347401436741, 4.007593632592521, 3.9728043013207754, 3.934149488796616, 3.88389823251521, 3.8408474589703916, 3.84804794170698, 3.8982991979883876, 3.948550454269794, 3.9988017105512013, 4.049052966832609, 4.099304223114015, 4.149555479395422, 4.1998067356768285, 4.250057991958236, 4.300309248239643, 4.3505605045210505, 4.4008117608024575, 4.451063017083864, 4.501314273365272, 4.551565529646679, 4.601816785928085, 4.618062557078159, 4.72007901247216, 4.8708327813163805, 5.021586550160602, 5.1723403190048245, 5.323094087849045, 5.473847856693266, 5.624601625537489, 5.775355394381708, 5.926109163225929, 6.076862932070149, 6.22761670091437, 6.342787767192171, 6.402092271469542, 6.653348552876575, 6.90460483428361, 7.155861115690648, 7.407117397097681, 7.6583736785047165, 7.90962995991175, 8.160886241318785, 8.412142522725823, 8.663398804132857, 8.914655085539891, 9.16591136694693, 9.417167648353963, 9.668423929760998, 9.919680211168032, 10.170936492575066, 10.422192773982104, 10.673449055389138, 10.924705336796173, 11.17596161820321, 11.427217899610245, 11.678474181017279, 11.929730462424313, 12.180986743831347, 12.432243025238385, 12.68349930664542, 12.934755588052454, 13.186011869459492, 13.437268150866526, 13.688524432273562, 13.939780713680594, 14.191036995087629, 14.442293276494667, 14.6935495579017, 14.944805839308737, 15.196062120715771, 15.447318402122807, 15.698574683529841, 15.94983096493688, 16.20108724634391, 16.452343527750948, 16.70359980915798, 16.954856090565016, 17.206112371972054, 17.457368653379085, 17.708624934786123, 17.95988121619316, 18.21113749760019, 18.46239377900723, 18.713650060414267, 18.964906341821298, 19.216162623228335, 19.467418904635366, 19.718675186042404, 19.96993146744944, 20.221187748856472, 20.47244403026351, 20.72370031167054, 20.97495659307758, 21.226212874484617, 21.477469155891647, 21.728725437298685, 21.979981718705723, 22.231238000112754, 22.48249428151979, 22.73375056292683, 22.98500684433386, 23.236263125740898, 23.48751940714793, 23.738775688554966, 23.990031969962004, 24.241288251369035, 24.492544532776073, 24.743800814183103, 24.99505709559014, 25.24631337699718, 25.49756965840421, 25.748825939811248, 26.000082221218285, 26.251338502625316, 26.50259478403235, 26.75385106543939, 27.005107346846422, 27.25636362825346, 27.50761990966049, 27.758876191067532, 28.010132472474567, 28.261388753881597, 28.512645035288635, 28.763901316695666, 29.0151575981027, 29.26641387950974, 29.517670160916772, 29.76892644232381, 30.020182723730848, 30.271439005137882, 30.522695286544916, 30.77395156795195, 31.025207849358985, 31.276464130766023, 31.52772041217305, 31.77897669358009, 32.03023297498713, 32.28148925639416, 32.5327455378012, 32.78400181920823, 33.035258100615266, 33.286514382022304, 33.53777066342934], \"name\": \"Abs. Loss\"}, {\"type\": \"scatter\", \"x\": [0.0, 0.25125628140703515, 0.5025125628140703, 0.7537688442211055, 1.0050251256281406, 1.2562814070351758, 1.507537688442211, 1.758793969849246, 2.0100502512562812, 2.2613065326633164, 2.5125628140703515, 2.7638190954773867, 3.015075376884422, 3.266331658291457, 3.517587939698492, 3.7688442211055273, 4.0201005025125625, 4.271356783919598, 4.522613065326633, 4.773869346733668, 5.025125628140703, 5.276381909547738, 5.527638190954773, 5.7788944723618085, 6.030150753768844, 6.281407035175879, 6.532663316582914, 6.783919597989949, 7.035175879396984, 7.2864321608040195, 7.537688442211055, 7.78894472361809, 8.040201005025125, 8.146639511201629, 8.29145728643216, 8.542713567839195, 8.793969849246231, 9.045226130653266, 9.2964824120603, 9.547738693467336, 9.798994974874372, 10.050251256281406, 10.30150753768844, 10.552763819095476, 10.804020100502512, 11.055276381909547, 11.306532663316581, 11.557788944723617, 11.809045226130653, 12.060301507537687, 12.311557788944722, 12.562814070351758, 12.814070351758794, 13.065326633165828, 13.316582914572862, 13.567839195979898, 13.819095477386934, 14.070351758793969, 14.321608040201003, 14.572864321608039, 14.824120603015075, 15.07537688442211, 15.326633165829143, 15.384615384615385, 15.57788944723618, 15.829145728643216, 16.044399596367306, 16.08040201005025, 16.331658291457284, 16.58291457286432, 16.834170854271356, 17.08542713567839, 17.336683417085425, 17.587939698492463, 17.839195979899497, 18.09045226130653, 18.341708542713565, 18.5929648241206, 18.844221105527637, 19.09547738693467, 19.346733668341706, 19.597989949748744, 19.849246231155778, 19.930475086906142, 20.100502512562812, 20.351758793969847, 20.60301507537688, 20.85427135678392, 21.105527638190953, 21.356783919597987, 21.608040201005025, 21.85929648241206, 22.110552763819094, 22.361809045226128, 22.613065326633162, 22.80501710376283, 22.8643216080402, 23.115577889447234, 23.36683417085427, 23.618090452261306, 23.86934673366834, 24.120603015075375, 24.37185929648241, 24.623115577889443, 24.87437185929648, 25.125628140703515, 25.37688442211055, 25.628140703517587, 25.87939698492462, 26.130653266331656, 26.38190954773869, 26.633165829145725, 26.884422110552762, 27.135678391959797, 27.38693467336683, 27.63819095477387, 27.889447236180903, 28.140703517587937, 28.39195979899497, 28.643216080402006, 28.894472361809044, 29.145728643216078, 29.396984924623112, 29.64824120603015, 29.899497487437184, 30.15075376884422, 30.402010050251253, 30.653266331658287, 30.904522613065325, 31.15577889447236, 31.407035175879393, 31.65829145728643, 31.909547738693465, 32.1608040201005, 32.41206030150754, 32.66331658291457, 32.914572864321606, 33.16582914572864, 33.417085427135675, 33.66834170854271, 33.91959798994974, 34.17085427135678, 34.42211055276382, 34.67336683417085, 34.92462311557789, 35.175879396984925, 35.427135678391956, 35.678391959798994, 35.929648241206024, 36.18090452261306, 36.4321608040201, 36.68341708542713, 36.93467336683417, 37.1859296482412, 37.43718592964824, 37.688442211055275, 37.939698492462306, 38.19095477386934, 38.44221105527638, 38.69346733668341, 38.94472361809045, 39.19597989949749, 39.44723618090452, 39.698492462311556, 39.94974874371859, 40.201005025125625, 40.45226130653266, 40.70351758793969, 40.95477386934673, 41.20603015075376, 41.4572864321608, 41.70854271356784, 41.95979899497487, 42.211055276381906, 42.462311557788944, 42.713567839195974, 42.96482412060301, 43.21608040201005, 43.46733668341708, 43.71859296482412, 43.96984924623115, 44.22110552763819, 44.472361809045225, 44.723618090452256, 44.97487437185929, 45.226130653266324, 45.47738693467336, 45.7286432160804, 45.97989949748743, 46.23115577889447, 46.482412060301506, 46.73366834170854, 46.984924623115575, 47.23618090452261, 47.48743718592964, 47.73869346733668, 47.98994974874371, 48.24120603015075, 48.49246231155779, 48.74371859296482, 48.994974874371856, 49.24623115577889, 49.497487437185924, 49.74874371859296, 50.0], \"y\": [15.962229336570658, 15.710973055163624, 15.459716773756588, 15.208460492349554, 14.957204210942518, 14.705947929535483, 14.454691648128446, 14.203435366721411, 13.952179085314375, 13.700922803907343, 13.449666522500308, 13.19841024109327, 12.947153959686236, 12.6958976782792, 12.444641396872166, 12.19338511546513, 11.942128834058096, 11.690872552651062, 11.439616271244025, 11.18835998983699, 10.937103708429955, 10.685847427022921, 10.434591145615885, 10.183334864208849, 9.932078582801815, 9.68082230139478, 9.429566019987746, 9.178309738580708, 8.927053457173674, 8.677751374254925, 8.439832821003964, 8.214540211542303, 8.001873545869941, 7.915589825369028, 7.801832823986876, 7.6144180458931086, 7.439629211588641, 7.277466321073471, 7.125684084853828, 6.974930316009605, 6.824176547165384, 6.6734227783211635, 6.522669009476942, 6.37191524063272, 6.2211614717885, 6.070407702944278, 5.919653934100059, 5.768900165255836, 5.618146396411615, 5.467392627567395, 5.316638858723174, 5.165885089878952, 5.0151313210347315, 4.8643775521905095, 4.71362378334629, 4.562870014502067, 4.412116245657846, 4.261362476813626, 4.110608707969405, 3.9633987053530695, 3.828417653981018, 3.7061585056357877, 3.604298961377927, 3.5843789795781023, 3.527691304698662, 3.4763355355979932, 3.4524221372277184, 3.450231654075922, 3.449379660132447, 3.4698472969615493, 3.5032213229515263, 3.549052966832609, 3.5993042231140153, 3.649555479395423, 3.6998067356768303, 3.7500579919582364, 3.800309248239644, 3.85056050452105, 3.9008117608024575, 3.953785592985335, 4.018641394027147, 4.096123138858258, 4.186230827478664, 4.2180625570781585, 4.288964459888371, 4.404324036087374, 4.532309556075677, 4.672921019853279, 4.823094087849045, 4.973847856693266, 5.124601625537489, 5.275650019476363, 5.435444367182531, 5.607864658677997, 5.792910893962761, 5.94278776719217, 5.9905830730368255, 6.200881195900186, 6.423805262552845, 6.659355272994804, 6.907117397097681, 7.1583736785047165, 7.40962995991175, 7.660886241318785, 7.912142522725823, 8.163398804132857, 8.414655085539891, 8.66591136694693, 8.917167648353963, 9.168423929760998, 9.419680211168032, 9.670936492575066, 9.922192773982104, 10.173449055389138, 10.424705336796173, 10.67596161820321, 10.927217899610245, 11.178474181017279, 11.429730462424313, 11.680986743831347, 11.932243025238385, 12.18349930664542, 12.434755588052454, 12.686011869459492, 12.937268150866526, 13.188524432273562, 13.439780713680594, 13.691036995087629, 13.942293276494667, 14.1935495579017, 14.444805839308737, 14.696062120715771, 14.947318402122807, 15.198574683529841, 15.44983096493688, 15.701087246343912, 15.952343527750946, 16.20359980915798, 16.454856090565016, 16.706112371972054, 16.957368653379085, 17.208624934786123, 17.45988121619316, 17.71113749760019, 17.96239377900723, 18.213650060414267, 18.464906341821298, 18.716162623228335, 18.967418904635366, 19.218675186042404, 19.46993146744944, 19.721187748856472, 19.97244403026351, 20.22370031167054, 20.47495659307758, 20.726212874484617, 20.977469155891647, 21.228725437298685, 21.479981718705723, 21.731238000112754, 21.98249428151979, 22.23375056292683, 22.48500684433386, 22.736263125740898, 22.98751940714793, 23.238775688554966, 23.490031969962004, 23.741288251369035, 23.992544532776073, 24.243800814183103, 24.49505709559014, 24.74631337699718, 24.99756965840421, 25.248825939811248, 25.500082221218285, 25.751338502625316, 26.00259478403235, 26.25385106543939, 26.505107346846422, 26.75636362825346, 27.00761990966049, 27.258876191067532, 27.510132472474567, 27.761388753881597, 28.012645035288635, 28.263901316695666, 28.5151575981027, 28.76641387950974, 29.017670160916772, 29.26892644232381, 29.520182723730848, 29.771439005137882, 30.022695286544916, 30.27395156795195, 30.525207849358985, 30.776464130766023, 31.02772041217305, 31.27897669358009, 31.530232974987133, 31.78148925639416, 32.0327455378012, 32.28400181920823, 32.535258100615266, 32.786514382022304, 33.03777066342934], \"name\": \"Huber Loss\"}, {\"type\": \"scatter\", \"x\": [16.044399596367306, 16.044399596367306], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [22.80501710376283, 22.80501710376283], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [8.146639511201629, 8.146639511201629], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [19.930475086906142, 19.930475086906142], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}, {\"type\": \"scatter\", \"x\": [15.384615384615385, 15.384615384615385], \"y\": [0, 20], \"mode\": \"lines\", \"showlegend\": false, \"line\": {\"color\": \"red\", \"width\": 0.5}}], {\"xaxis\": {\"title\": \"Theta Values\"}, \"yaxis\": {\"range\": [0, 20]}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "np.random.seed(42) # seed the generator so plot doesn't change\n",
    "tmp = data['pcttip'].sample(5)\n",
    "loss_top = 20 # Need a top for the red lines\n",
    "# Add the data points to the candidate thetas to enable visualization of corners\n",
    "theta_sharp = np.sort(np.hstack((thetas, tmp)))\n",
    "\n",
    "lines = [ # Plot the Loss functions\n",
    "    go.Scatter(x = theta_sharp, y = avg_loss(squared_loss, theta_sharp, data['pcttip'])-30, name='Squared Loss - 20'),\n",
    "    go.Scatter(x = theta_sharp, y = avg_loss(abs_loss, theta_sharp, tmp), name='Abs. Loss'),\n",
    "    go.Scatter(x = theta_sharp, y = avg_loss(huber_loss, theta_sharp, tmp), name='Huber Loss')\n",
    "] + [ # Plot the red liens corresponding to data points\n",
    "    go.Scatter(x = [yobs, yobs], y=[0, loss_top], \n",
    "               mode='lines', showlegend=False, \n",
    "               line=dict(color='red', width = 0.5)) for yobs in tmp\n",
    "]\n",
    "\n",
    "# Assemble the plot\n",
    "py.iplot(go.Figure(data = lines, \n",
    "                   layout=dict(xaxis=dict(title=\"Theta Values\"), \n",
    "                               yaxis=dict(range=[0, loss_top]))))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "In the above plot observe:\n",
    "1. The extreme sharp slope of the Squared Loss\n",
    "1. The corners in the absolute loss.\n",
    "1. The Huber loss is very similar to the absolute loss but smoother\n",
    "1. In the above plot the minimizers for the loss functions seem to align.  Why?\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/> </br> <br/> \n",
    "\n",
    "## Dealing with Outliers\n",
    "\n",
    "The differences in the above loss functions largely reduces to their sensitivity to outliers.  Recall the distribution of tips (plotted below for interactive exploration)."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 27,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "data": [
        {
         "autobinx": false,
         "histnorm": "probability density",
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "name": "Percent Tip",
         "opacity": 0.7,
         "type": "histogram",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          32.57328990228013,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          71.0344827586207,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          41.66666666666667,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "xbins": {
          "end": 71.0344827586207,
          "size": 1,
          "start": 3.563813585135547
         },
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)"
         },
         "mode": "lines",
         "name": "Percent Tip",
         "showlegend": false,
         "type": "scatter",
         "x": [
          3.563813585135547,
          3.698754923482517,
          3.8336962618294876,
          3.9686376001764576,
          4.1035789385234285,
          4.238520276870398,
          4.373461615217368,
          4.508402953564339,
          4.643344291911309,
          4.77828563025828,
          4.913226968605249,
          5.0481683069522205,
          5.18310964529919,
          5.3180509836461605,
          5.452992321993131,
          5.587933660340101,
          5.722874998687072,
          5.857816337034042,
          5.992757675381013,
          6.127699013727982,
          6.2626403520749525,
          6.397581690421923,
          6.532523028768893,
          6.667464367115864,
          6.802405705462834,
          6.937347043809805,
          7.072288382156774,
          7.2072297205037446,
          7.342171058850715,
          7.477112397197685,
          7.612053735544656,
          7.746995073891626,
          7.881936412238597,
          8.016877750585566,
          8.151819088932537,
          8.286760427279507,
          8.421701765626477,
          8.556643103973448,
          8.69158444232042,
          8.826525780667389,
          8.961467119014358,
          9.09640845736133,
          9.231349795708299,
          9.36629113405527,
          9.50123247240224,
          9.63617381074921,
          9.77111514909618,
          9.90605648744315,
          10.040997825790122,
          10.175939164137091,
          10.31088050248406,
          10.445821840831032,
          10.580763179178003,
          10.715704517524973,
          10.850645855871942,
          10.985587194218912,
          11.120528532565885,
          11.255469870912854,
          11.390411209259824,
          11.525352547606794,
          11.660293885953765,
          11.795235224300734,
          11.930176562647706,
          12.065117900994675,
          12.200059239341646,
          12.335000577688616,
          12.469941916035586,
          12.604883254382557,
          12.739824592729528,
          12.874765931076498,
          13.009707269423467,
          13.144648607770437,
          13.279589946117408,
          13.41453128446438,
          13.549472622811349,
          13.684413961158318,
          13.81935529950529,
          13.95429663785226,
          14.08923797619923,
          14.224179314546202,
          14.35912065289317,
          14.494061991240141,
          14.629003329587112,
          14.763944667934082,
          14.898886006281051,
          15.03382734462802,
          15.168768682974992,
          15.303710021321963,
          15.438651359668933,
          15.573592698015903,
          15.708534036362874,
          15.843475374709843,
          15.978416713056815,
          16.113358051403786,
          16.248299389750755,
          16.383240728097725,
          16.518182066444695,
          16.653123404791664,
          16.788064743138637,
          16.923006081485603,
          17.057947419832576,
          17.19288875817955,
          17.32783009652652,
          17.46277143487349,
          17.597712773220458,
          17.732654111567427,
          17.867595449914397,
          18.00253678826137,
          18.137478126608336,
          18.27241946495531,
          18.40736080330228,
          18.54230214164925,
          18.67724347999622,
          18.81218481834319,
          18.94712615669016,
          19.08206749503713,
          19.2170088333841,
          19.351950171731072,
          19.486891510078042,
          19.621832848425015,
          19.756774186771985,
          19.891715525118954,
          20.026656863465924,
          20.161598201812893,
          20.296539540159863,
          20.431480878506832,
          20.566422216853802,
          20.70136355520078,
          20.836304893547748,
          20.971246231894717,
          21.106187570241687,
          21.241128908588657,
          21.376070246935626,
          21.511011585282596,
          21.645952923629565,
          21.780894261976535,
          21.91583560032351,
          22.05077693867048,
          22.18571827701745,
          22.32065961536442,
          22.45560095371139,
          22.59054229205836,
          22.72548363040533,
          22.860424968752298,
          22.995366307099268,
          23.130307645446237,
          23.265248983793214,
          23.400190322140183,
          23.535131660487153,
          23.670072998834122,
          23.805014337181092,
          23.93995567552806,
          24.07489701387503,
          24.209838352222,
          24.34477969056897,
          24.479721028915947,
          24.614662367262916,
          24.749603705609886,
          24.884545043956855,
          25.019486382303825,
          25.154427720650794,
          25.289369058997764,
          25.424310397344733,
          25.559251735691703,
          25.69419307403868,
          25.82913441238565,
          25.96407575073262,
          26.099017089079588,
          26.233958427426558,
          26.368899765773527,
          26.503841104120497,
          26.638782442467466,
          26.773723780814436,
          26.908665119161405,
          27.043606457508382,
          27.17854779585535,
          27.31348913420232,
          27.44843047254929,
          27.58337181089626,
          27.71831314924323,
          27.8532544875902,
          27.98819582593717,
          28.123137164284138,
          28.258078502631115,
          28.393019840978084,
          28.527961179325054,
          28.662902517672023,
          28.797843856018993,
          28.932785194365962,
          29.067726532712932,
          29.2026678710599,
          29.33760920940687,
          29.472550547753848,
          29.607491886100817,
          29.742433224447787,
          29.877374562794756,
          30.012315901141726,
          30.147257239488695,
          30.282198577835665,
          30.417139916182634,
          30.552081254529604,
          30.687022592876573,
          30.82196393122355,
          30.95690526957052,
          31.09184660791749,
          31.22678794626446,
          31.361729284611428,
          31.496670622958398,
          31.631611961305367,
          31.766553299652337,
          31.901494637999306,
          32.03643597634628,
          32.17137731469325,
          32.30631865304022,
          32.44125999138719,
          32.57620132973416,
          32.71114266808113,
          32.8460840064281,
          32.98102534477507,
          33.11596668312204,
          33.25090802146901,
          33.385849359815985,
          33.520790698162955,
          33.655732036509924,
          33.790673374856894,
          33.92561471320386,
          34.06055605155083,
          34.1954973898978,
          34.33043872824477,
          34.46538006659174,
          34.60032140493872,
          34.73526274328569,
          34.87020408163266,
          35.00514541997963,
          35.140086758326596,
          35.275028096673566,
          35.409969435020535,
          35.544910773367505,
          35.67985211171448,
          35.81479345006145,
          35.94973478840842,
          36.08467612675539,
          36.21961746510236,
          36.35455880344933,
          36.4895001417963,
          36.624441480143275,
          36.75938281849024,
          36.894324156837214,
          37.029265495184184,
          37.16420683353115,
          37.29914817187812,
          37.43408951022509,
          37.56903084857206,
          37.70397218691903,
          37.83891352526601,
          37.97385486361297,
          38.10879620195995,
          38.24373754030692,
          38.378678878653886,
          38.513620217000856,
          38.648561555347825,
          38.783502893694795,
          38.918444232041765,
          39.05338557038874,
          39.188326908735704,
          39.32326824708268,
          39.45820958542965,
          39.59315092377662,
          39.72809226212359,
          39.86303360047056,
          39.99797493881753,
          40.1329162771645,
          40.267857615511474,
          40.40279895385844,
          40.53774029220541,
          40.67268163055238,
          40.80762296889935,
          40.94256430724632,
          41.0775056455933,
          41.21244698394026,
          41.34738832228723,
          41.48232966063421,
          41.61727099898117,
          41.752212337328146,
          41.88715367567511,
          42.022095014022085,
          42.157036352369055,
          42.291977690716024,
          42.426919029062994,
          42.56186036740996,
          42.69680170575693,
          42.8317430441039,
          42.96668438245088,
          43.10162572079784,
          43.23656705914482,
          43.37150839749179,
          43.50644973583876,
          43.64139107418573,
          43.776332412532696,
          43.911273750879666,
          44.046215089226635,
          44.18115642757361,
          44.316097765920574,
          44.45103910426755,
          44.58598044261452,
          44.72092178096149,
          44.85586311930846,
          44.99080445765543,
          45.1257457960024,
          45.26068713434937,
          45.395628472696345,
          45.53056981104331,
          45.665511149390284,
          45.80045248773725,
          45.93539382608422,
          46.07033516443119,
          46.20527650277817,
          46.34021784112513,
          46.4751591794721,
          46.61010051781908,
          46.74504185616604,
          46.87998319451302,
          47.014924532859986,
          47.149865871206956,
          47.284807209553925,
          47.4197485479009,
          47.554689886247864,
          47.689631224594834,
          47.82457256294181,
          47.95951390128877,
          48.09445523963575,
          48.22939657798272,
          48.36433791632969,
          48.49927925467666,
          48.63422059302363,
          48.7691619313706,
          48.90410326971757,
          49.039044608064536,
          49.173985946411506,
          49.30892728475848,
          49.443868623105445,
          49.57880996145242,
          49.71375129979939,
          49.84869263814636,
          49.98363397649333,
          50.11857531484031,
          50.25351665318727,
          50.38845799153424,
          50.523399329881215,
          50.65834066822818,
          50.793282006575154,
          50.928223344922124,
          51.06316468326909,
          51.19810602161606,
          51.33304735996304,
          51.46798869831,
          51.60293003665697,
          51.73787137500395,
          51.87281271335091,
          52.00775405169789,
          52.14269539004486,
          52.277636728391826,
          52.412578066738796,
          52.54751940508577,
          52.682460743432735,
          52.817402081779704,
          52.95234342012668,
          53.08728475847364,
          53.22222609682062,
          53.35716743516759,
          53.49210877351456,
          53.62705011186153,
          53.761991450208505,
          53.89693278855547,
          54.03187412690244,
          54.166815465249414,
          54.301756803596376,
          54.43669814194335,
          54.57163948029032,
          54.70658081863729,
          54.84152215698426,
          54.97646349533124,
          55.1114048336782,
          55.24634617202518,
          55.38128751037215,
          55.51622884871911,
          55.651170187066086,
          55.78611152541305,
          55.921052863760025,
          56.055994202106994,
          56.190935540453964,
          56.32587687880093,
          56.46081821714791,
          56.59575955549487,
          56.73070089384184,
          56.86564223218882,
          57.00058357053578,
          57.13552490888276,
          57.27046624722973,
          57.4054075855767,
          57.540348923923666,
          57.67529026227064,
          57.810231600617605,
          57.945172938964575,
          58.08011427731155,
          58.215055615658514,
          58.34999695400549,
          58.48493829235246,
          58.61987963069943,
          58.7548209690464,
          58.889762307393376,
          59.02470364574034,
          59.159644984087315,
          59.294586322434284,
          59.42952766078125,
          59.56446899912822,
          59.69941033747519,
          59.83435167582216,
          59.96929301416913,
          60.10423435251611,
          60.23917569086307,
          60.37411702921005,
          60.50905836755702,
          60.64399970590398,
          60.778941044250956,
          60.913882382597926,
          61.048823720944895,
          61.183765059291865,
          61.31870639763884,
          61.453647735985804,
          61.58858907433278,
          61.72353041267975,
          61.85847175102671,
          61.99341308937369,
          62.12835442772066,
          62.26329576606763,
          62.3982371044146,
          62.53317844276157,
          62.66811978110854,
          62.80306111945551,
          62.938002457802476,
          63.072943796149445,
          63.20788513449642,
          63.342826472843385,
          63.47776781119036,
          63.61270914953733,
          63.7476504878843,
          63.88259182623127,
          64.01753316457824,
          64.1524745029252,
          64.28741584127218,
          64.42235717961915,
          64.55729851796612,
          64.6922398563131,
          64.82718119466006,
          64.96212253300703,
          65.097063871354,
          65.23200520970097,
          65.36694654804793,
          65.50188788639491,
          65.63682922474189,
          65.77177056308885,
          65.90671190143583,
          66.04165323978279,
          66.17659457812977,
          66.31153591647673,
          66.4464772548237,
          66.58141859317067,
          66.71635993151764,
          66.85130126986462,
          66.98624260821158,
          67.12118394655856,
          67.25612528490552,
          67.3910666232525,
          67.52600796159946,
          67.66094929994644,
          67.79589063829341,
          67.93083197664038,
          68.06577331498735,
          68.20071465333432,
          68.33565599168129,
          68.47059733002827,
          68.60553866837523,
          68.74048000672221,
          68.87542134506917,
          69.01036268341615,
          69.14530402176311,
          69.28024536011009,
          69.41518669845705,
          69.55012803680401,
          69.685069375151,
          69.82001071349796,
          69.95495205184493,
          70.0898933901919,
          70.22483472853888,
          70.35977606688584,
          70.49471740523282,
          70.62965874357978,
          70.76460008192676,
          70.89954142027374
         ],
         "xaxis": "x1",
         "y": [
          0.004061065040256531,
          0.004413888978508207,
          0.004789339808663863,
          0.005187923334495055,
          0.0056100331411973615,
          0.00605593798092017,
          0.006525770588188691,
          0.007019518348559347,
          0.00753701622583154,
          0.008077942319898737,
          0.008641816378981468,
          0.009228001527295915,
          0.009835709393563723,
          0.010464008739172257,
          0.011111837589830077,
          0.011778018774303851,
          0.01246127867172563,
          0.013160268868727199,
          0.013873590333089924,
          0.014599819625412637,
          0.015337536597965358,
          0.016085352973448333,
          0.016841941158262347,
          0.01760606262682783,
          0.018376595216336316,
          0.01915255869502956,
          0.01993313801068977,
          0.02071770368758152,
          0.021505828916862448,
          0.02229730297401319,
          0.023092140693118567,
          0.023890587827517882,
          0.02469312222499421,
          0.025500450838992644,
          0.026313502681453736,
          0.02713341789444682,
          0.027961533174442842,
          0.028799363823310085,
          0.02964858272354768,
          0.030510996542605178,
          0.03138851946413958,
          0.03228314472548434,
          0.03319691421397794,
          0.03413188634424564,
          0.0350901024084771,
          0.03607355156666255,
          0.037084134627838036,
          0.038123626770297334,
          0.039193639361299666,
          0.04029558106684057,
          0.04143061849019723,
          0.04259963664352944,
          0.04380319963784442,
          0.045041512069855336,
          0.04631438168527334,
          0.04762118400147698,
          0.0489608296721662,
          0.05033173546592715,
          0.051731799802854715,
          0.05315838384191767,
          0.054608299130533576,
          0.05607780281160138,
          0.05756260132789566,
          0.059057863466529976,
          0.06055824344600759,
          0.06205791456582734,
          0.06355061371615824,
          0.06502969678708674,
          0.06648820472951214,
          0.06791893971075327,
          0.06931455048663807,
          0.07066762578878347,
          0.0719707942122969,
          0.07321682879707855,
          0.07439875423712615,
          0.07550995443815267,
          0.0765442779849296,
          0.0774961389851708,
          0.07836061073378914,
          0.07913350969506677,
          0.07981146743328535,
          0.08039198833446307,
          0.08087349125003364,
          0.08125533355161306,
          0.08153781650574733,
          0.08172217134742225,
          0.08181052593765466,
          0.08180585241836236,
          0.08171189681037241,
          0.08153309202061035,
          0.08127445621489994,
          0.0809414789566595,
          0.08053999789357176,
          0.08007606908029484,
          0.07955583424406373,
          0.07898538842295848,
          0.07837065142815776,
          0.07771724649946794,
          0.07703038933907268,
          0.0763147904264893,
          0.07557457314614326,
          0.07481320980881365,
          0.07403347713321282,
          0.07323743219009332,
          0.07242640921622669,
          0.07160103709818437,
          0.07076127672537842,
          0.06990647683748734,
          0.06903544646157093,
          0.06814654156587319,
          0.0672377631654885,
          0.06630686381221874,
          0.06535145919656712,
          0.06436914149008682,
          0.06335759106386796,
          0.06231468333273976,
          0.06123858769006774,
          0.0601278558065846,
          0.05898149695700307,
          0.05779903849587522,
          0.05658057011261719,
          0.05532677103644683,
          0.054038919915825906,
          0.052718887644250145,
          0.051369113925798564,
          0.049992568851931644,
          0.04859270117976999,
          0.04717337534824998,
          0.04573879953199846,
          0.044293447206817736,
          0.04284197478234262,
          0.04138913784744981,
          0.039939708476718815,
          0.03849839586932271,
          0.03706977234571012,
          0.035658206425225464,
          0.03426780436396405,
          0.03290236116223318,
          0.0315653216708009,
          0.030259752050017918,
          0.028988321480134766,
          0.02775329369726309,
          0.02655652764784242,
          0.02539948632307492,
          0.02428325265878568,
          0.02320855126801733,
          0.02217577471315295,
          0.02118501301880052,
          0.02023608517122076,
          0.019328571438135583,
          0.018461845466386274,
          0.017635105265368944,
          0.016847402352337573,
          0.01609766851251993,
          0.015384739804037364,
          0.01470737760721114,
          0.014064286673472773,
          0.013454130265585113,
          0.01287554259447577,
          0.012327138846377421,
          0.011807523156263556,
          0.011315294920143305,
          0.010849053851136572,
          0.010407404174806678,
          0.009988958331086682,
          0.009592340506864762,
          0.009216190268693043,
          0.008859166502987879,
          0.008519951805177731,
          0.008197257392918421,
          0.007889828554717744,
          0.0075964505865984055,
          0.007315955117772504,
          0.0070472266831716895,
          0.006789209367043516,
          0.006540913318192777,
          0.006301420923915906,
          0.0060698924259996795,
          0.00584557076780063,
          0.005627785475635947,
          0.005415955399578189,
          0.005209590167208704,
          0.005008290237819089,
          0.004811745482765651,
          0.004619732258952654,
          0.004432108985494354,
          0.0042488102772232795,
          0.004069839731607929,
          0.0038952615065696284,
          0.0037251908644240867,
          0.0035597838905499874,
          0.003399226623314702,
          0.003243723853285893,
          0.003093487863994801,
          0.0029487273928415817,
          0.002809637088716958,
          0.0026763877323784015,
          0.0025491174666662808,
          0.0024279242566706766,
          0.0023128597656595995,
          0.002203924791940908,
          0.002101066366108204,
          0.0020041765588009928,
          0.0019130929978565217,
          0.0018276010423274515,
          0.0017474375111151182,
          0.001672295817720563,
          0.0016018323215357814,
          0.0015356736716917376,
          0.0014734248930020205,
          0.001414677945934707,
          0.0013590204843982635,
          0.001306044536645361,
          0.0012553548455934743,
          0.0012065766247619416,
          0.001159362513903558,
          0.0011133985530256984,
          0.0010684090333588584,
          0.0010241601272653162,
          0.0009804622443093098,
          0.0009371711059325876,
          0.0008941875746540666,
          0.0008514563138329411,
          0.0008089633893953681,
          0.0007667329543770098,
          0.0007248231798244448,
          0.0006833216109964241,
          0.0006423401357080032,
          0.0006020097521837605,
          0.0005624753173443817,
          0.0005238904437178537,
          0.00048641269503058704,
          0.0004501992080435803,
          0.0004154028425066951,
          0.00038216893340823667,
          0.0003506326911868276,
          0.00032091726737884085,
          0.0002931324763277669,
          0.00026737413897860566,
          0.00024372399316037073,
          0.00022225009669232977,
          0.00020300763552952278,
          0.00018604003921478878,
          0.00017138030019374763,
          0.00015905239199883844,
          0.00014907268371896652,
          0.00014145125424141268,
          0.00013619301910119315,
          0.00013329859495857116,
          0.00013276484126351271,
          0.0001345850350440157,
          0.00013874865244358772,
          0.0001452407490934611,
          0.00015404095009655732,
          0.00016512207878403493,
          0.00017844847094905075,
          0.00019397403744459663,
          0.00021164015234829598,
          0.00023137345586762636,
          0.0002530836703405379,
          0.00027666153368517644,
          0.0003019769571395235,
          0.0003288775128614308,
          0.000357187351786534,
          0.00038670664303883866,
          0.0004172116132623349,
          0.00044845524774174,
          0.0004801686955064988,
          0.0005120633983123962,
          0.0005438339391581892,
          0.0005751615806308962,
          0.0006057184377910238,
          0.0006351722054802845,
          0.0006631913368565261,
          0.000689450549611927,
          0.0007136365196235169,
          0.0007354536095210952,
          0.0007546294724819934,
          0.0007709203699282949,
          0.0007841160459401385,
          0.0007940440110973731,
          0.0008005731038601201,
          0.0008036162179920371,
          0.0008031321091872811,
          0.0007991262220572571,
          0.0007916505088855917,
          0.0007808022428844794,
          0.0007667218598489521,
          0.0007495898918840708,
          0.0007296230841177507,
          0.0007070698089755887,
          0.0006822049118201197,
          0.0006553241358898414,
          0.0006267382830923024,
          0.0005967672701383592,
          0.0005657342368291118,
          0.0005339598553378139,
          0.0005017569765958483,
          0.00046942573310343553,
          0.00043724919749046594,
          0.0004054896738906579,
          0.00037438567564659377,
          0.000344149619012473,
          0.00031496623929375443,
          0.0002869917140967621,
          0.000260353458772355,
          0.00023515054229610328,
          0.00021145465814113645,
          0.00018931157441137754,
          0.00016874298069085336,
          0.00014974864565601084,
          0.00013230879928488424,
          0.0001163866561602831,
          0.00010193100149914537,
          8.887876868351526e-05,
          7.715754572673293e-05,
          6.668795778227171e-05,
          5.7385883011832395e-05,
          4.916446943062413e-05,
          4.193593035105279e-05,
          3.5613105424349974e-05,
          3.0110782775869593e-05,
          2.5346785158092945e-05,
          2.1242829289821303e-05,
          1.7725172559526937e-05,
          1.47250650515729e-05,
          1.2179027460821895e-05,
          1.0028976987214784e-05,
          8.222223868701009e-06,
          6.711360958162722e-06,
          5.454067826578978e-06,
          4.412849430495905e-06,
          3.5547275610949367e-06,
          2.8509012280304825e-06,
          2.2763899421638006e-06,
          1.809671648629874e-06,
          1.4323249082523385e-06,
          1.1286828956938805e-06,
          8.855049238302605e-07,
          6.916695464936667e-07,
          5.378918526043765e-07,
          4.16466348493636e-07,
          3.2103582695293924e-07,
          2.4638582887079993e-07,
          1.8826369862341475e-07,
          1.4322079669273577e-07,
          1.0847613960286604e-07,
          8.179956513047356e-08,
          6.141244748653898e-08,
          4.590399188604345e-08,
          3.416120172412304e-08,
          2.5310717881298547e-08,
          1.8670864352976154e-08,
          1.3712385739657255e-08,
          1.0026520757316159e-08,
          7.299214563892447e-09,
          5.2904259559312025e-09,
          3.817629590016872e-09,
          2.7427458924163194e-09,
          1.9618508902067147e-09,
          1.3971243307170989e-09,
          9.905872944769853e-10,
          6.992606477306674e-10,
          4.914440263015807e-10,
          3.438726774164501e-10,
          2.395575799972692e-10,
          1.6615400029578973e-10,
          1.1473616341600575e-10,
          7.888210349929797e-11,
          5.399397238671244e-11,
          3.679600885692664e-11,
          2.4965759780535885e-11,
          1.686465647701201e-11,
          1.1342240533667929e-11,
          7.59466909380626e-12,
          5.06299533216203e-12,
          3.36043047892033e-12,
          2.220604156223336e-12,
          1.460954062346998e-12,
          9.569561120730627e-13,
          6.240793244661887e-13,
          4.052152553369018e-13,
          2.6196627339106577e-13,
          1.6863924889955557e-13,
          1.0812596062727209e-13,
          6.909246898497551e-14,
          4.407213068313844e-14,
          2.817965324016544e-14,
          1.8250513922283737e-14,
          1.2271422669538055e-14,
          9.010781902168653e-15,
          7.788770029013387e-15,
          8.348785435264685e-15,
          1.0808556091887567e-14,
          1.568259728070787e-14,
          2.3979842981244692e-14,
          3.739298801981403e-14,
          5.861123194427245e-14,
          9.180788843537391e-14,
          1.4338145669664933e-13,
          2.2306686352951489e-13,
          3.455875717943426e-13,
          5.33095792792719e-13,
          8.187562637625731e-13,
          1.2519813910303148e-12,
          1.9060388683373703e-12,
          2.889049863569262e-12,
          4.359806906358641e-12,
          6.550406063842535e-12,
          9.798461079023034e-12,
          1.4592717492343312e-11,
          2.163730274057301e-11,
          3.194175014664065e-11,
          4.6946469015957937e-11,
          6.869668746972345e-11,
          1.0008230438481846e-10,
          1.4516684368604232e-10,
          2.0963616653755905e-10,
          3.0140719977042593e-10,
          4.3144920422037216e-10,
          6.148856529771532e-10,
          8.724643392321777e-10,
          1.2325077170824826e-09,
          1.7334856346102324e-09,
          2.4273895851450593e-09,
          3.384132501012366e-09,
          4.6972521186143505e-09,
          6.491260236510729e-09,
          8.931055894710467e-09,
          1.2233908605372807e-08,
          1.6684618987820253e-08,
          2.2654578831920058e-08,
          3.062558049288616e-08,
          4.1219365597544224e-08,
          5.523405330977864e-08,
          7.368874560518853e-08,
          9.787776637158493e-08,
          1.294361461311259e-07,
          1.7041810618590504e-07,
          2.233904141871005e-07,
          2.91542564283386e-07,
          3.7881576342592685e-07,
          4.900526630207396e-07,
          6.311696417104002e-07,
          8.093531987266391e-07,
          1.0332816350662432e-06,
          1.3133726587368053e-06,
          1.6620568287147696e-06,
          2.094075831004372e-06,
          2.6268034447645e-06,
          3.280585698956659e-06,
          4.079095141250868e-06,
          5.04969235302578e-06,
          6.223785872609035e-06,
          7.637179574264069e-06,
          9.330394350797272e-06,
          1.13489487391608e-05,
          1.3743581005709115e-05,
          1.657039328316025e-05,
          1.9890896753042463e-05,
          2.3771935736134174e-05,
          2.8285468037697128e-05,
          3.3508179144210024e-05,
          3.9520909027951444e-05,
          4.6407872514455533e-05,
          5.4255657510240266e-05,
          6.315198994441792e-05,
          7.318426007283131e-05,
          8.443781179821848e-05,
          9.699400478285368e-05,
          0.00011092806821156569,
          0.00012630677487171315,
          0.0001431859744508427,
          0.00016160803524434465,
          0.0001815992533889584,
          0.00020316729782486796,
          0.00022629876694426273,
          0.0002509569388094778,
          0.00027707980044122514,
          0.0003045784425577029,
          0.0003333359039347361,
          0.00036320654400373353,
          0.0003940160132837142,
          0.00042556187877661265,
          0.00045761494572299396,
          0.0004899212984656303,
          0.0005222050621120998,
          0.0005541718638894977,
          0.0005855129493398443,
          0.0006159098847134543,
          0.000645039754042669,
          0.0006725807384066953,
          0.0006982179467900685,
          0.0007216493535784192,
          0.0007425916878904012,
          0.0007607861152114439,
          0.0007760035525695503,
          0.0007880494649412836,
          0.0007967680026167702,
          0.0008020453565550446
         ],
         "yaxis": "y1"
        },
        {
         "legendgroup": "Percent Tip",
         "marker": {
          "color": "rgb(31, 119, 180)",
          "symbol": "line-ns-open"
         },
         "mode": "markers",
         "name": "Percent Tip",
         "showlegend": false,
         "text": [
          "$16.99",
          "$10.34",
          "$21.01",
          "$23.68",
          "$24.59",
          "$25.29",
          "$8.77",
          "$26.88",
          "$15.04",
          "$14.78",
          "$10.27",
          "$35.26",
          "$15.42",
          "$18.43",
          "$14.83",
          "$21.58",
          "$10.33",
          "$16.29",
          "$16.97",
          "$20.65",
          "$17.92",
          "$20.29",
          "$15.77",
          "$39.42",
          "$19.82",
          "$17.81",
          "$13.37",
          "$12.69",
          "$21.7",
          "$19.65",
          "$9.55",
          "$18.35",
          "$15.06",
          "$20.69",
          "$17.78",
          "$24.06",
          "$16.31",
          "$16.93",
          "$18.69",
          "$31.27",
          "$16.04",
          "$17.46",
          "$13.94",
          "$9.68",
          "$30.4",
          "$18.29",
          "$22.23",
          "$32.4",
          "$28.55",
          "$18.04",
          "$12.54",
          "$10.29",
          "$34.81",
          "$9.94",
          "$25.56",
          "$19.49",
          "$38.01",
          "$26.41",
          "$11.24",
          "$48.27",
          "$20.29",
          "$13.81",
          "$11.02",
          "$18.29",
          "$17.59",
          "$20.08",
          "$16.45",
          "$3.07",
          "$20.23",
          "$15.01",
          "$12.02",
          "$17.07",
          "$26.86",
          "$25.28",
          "$14.73",
          "$10.51",
          "$17.92",
          "$27.2",
          "$22.76",
          "$17.29",
          "$19.44",
          "$16.66",
          "$10.07",
          "$32.68",
          "$15.98",
          "$34.83",
          "$13.03",
          "$18.28",
          "$24.71",
          "$21.16",
          "$28.97",
          "$22.49",
          "$5.75",
          "$16.32",
          "$22.75",
          "$40.17",
          "$27.28",
          "$12.03",
          "$21.01",
          "$12.46",
          "$11.35",
          "$15.38",
          "$44.3",
          "$22.42",
          "$20.92",
          "$15.36",
          "$20.49",
          "$25.21",
          "$18.24",
          "$14.31",
          "$14.0",
          "$7.25",
          "$38.07",
          "$23.95",
          "$25.71",
          "$17.31",
          "$29.93",
          "$10.65",
          "$12.43",
          "$24.08",
          "$11.69",
          "$13.42",
          "$14.26",
          "$15.95",
          "$12.48",
          "$29.8",
          "$8.52",
          "$14.52",
          "$11.38",
          "$22.82",
          "$19.08",
          "$20.27",
          "$11.17",
          "$12.26",
          "$18.26",
          "$8.51",
          "$10.33",
          "$14.15",
          "$16.0",
          "$13.16",
          "$17.47",
          "$34.3",
          "$41.19",
          "$27.05",
          "$16.43",
          "$8.35",
          "$18.64",
          "$11.87",
          "$9.78",
          "$7.51",
          "$14.07",
          "$13.13",
          "$17.26",
          "$24.55",
          "$19.77",
          "$29.85",
          "$48.17",
          "$25.0",
          "$13.39",
          "$16.49",
          "$21.5",
          "$12.66",
          "$16.21",
          "$13.81",
          "$17.51",
          "$24.52",
          "$20.76",
          "$31.71",
          "$10.59",
          "$10.63",
          "$50.81",
          "$15.81",
          "$7.25",
          "$31.85",
          "$16.82",
          "$32.9",
          "$17.89",
          "$14.48",
          "$9.6",
          "$34.63",
          "$34.65",
          "$23.33",
          "$45.35",
          "$23.17",
          "$40.55",
          "$20.69",
          "$20.9",
          "$30.46",
          "$18.15",
          "$23.1",
          "$15.69",
          "$19.81",
          "$28.44",
          "$15.48",
          "$16.58",
          "$7.56",
          "$10.34",
          "$43.11",
          "$13.0",
          "$13.51",
          "$18.71",
          "$12.74",
          "$13.0",
          "$16.4",
          "$20.53",
          "$16.47",
          "$26.59",
          "$38.73",
          "$24.27",
          "$12.76",
          "$30.06",
          "$25.89",
          "$48.33",
          "$13.27",
          "$28.17",
          "$12.9",
          "$28.15",
          "$11.59",
          "$7.74",
          "$30.14",
          "$12.16",
          "$13.42",
          "$8.58",
          "$15.98",
          "$13.42",
          "$16.27",
          "$10.09",
          "$20.45",
          "$13.28",
          "$22.12",
          "$24.01",
          "$15.69",
          "$11.61",
          "$10.77",
          "$15.53",
          "$10.07",
          "$12.6",
          "$32.83",
          "$35.83",
          "$29.03",
          "$27.18",
          "$22.67",
          "$17.82",
          "$18.78"
         ],
         "type": "scatter",
         "x": [
          5.9446733372572105,
          16.054158607350097,
          16.658733936220845,
          13.97804054054054,
          14.680764538430255,
          18.62396204033215,
          22.80501710376283,
          11.607142857142858,
          13.031914893617023,
          21.853856562922868,
          16.65043816942551,
          14.180374361883155,
          10.181582360570687,
          16.277807921866522,
          20.364126770060686,
          18.164967562557923,
          16.16650532429816,
          22.774708410067525,
          20.624631703005306,
          16.222760290556902,
          22.767857142857142,
          13.553474618038445,
          14.140773620798985,
          19.228817858954844,
          16.044399596367306,
          13.138686131386862,
          14.958863126402393,
          15.760441292356187,
          19.81566820276498,
          15.267175572519085,
          15.18324607329843,
          13.623978201634875,
          19.9203187250996,
          11.841469308844852,
          18.391451068616423,
          14.962593516209477,
          12.262415695892091,
          18.13349084465446,
          12.359550561797752,
          15.98976654940838,
          13.965087281795514,
          14.547537227949597,
          21.951219512195124,
          13.636363636363638,
          18.421052631578945,
          16.402405686167302,
          22.492127755285647,
          18.51851851851852,
          7.180385288966725,
          16.629711751662974,
          19.936204146730464,
          25.26724975704568,
          14.938236139040505,
          15.694164989939638,
          16.97965571205008,
          18.009235505387377,
          7.892659826361484,
          5.679666792881484,
          15.658362989323843,
          13.942407292314066,
          15.82060128141942,
          14.482259232440258,
          17.96733212341198,
          20.55768179332969,
          15.008527572484368,
          15.687250996015937,
          15.01519756838906,
          32.57328990228013,
          9.935739001482945,
          13.924050632911392,
          16.38935108153078,
          17.57469244288225,
          11.69024571854058,
          19.77848101265823,
          14.935505770536322,
          11.893434823977165,
          17.1875,
          14.705882352941178,
          13.181019332161686,
          15.6737998843262,
          15.432098765432098,
          20.408163265306122,
          18.17279046673287,
          15.299877600979192,
          12.703379224030037,
          14.843525696238874,
          15.349194167306218,
          21.88183807439825,
          23.674625657628486,
          14.177693761814744,
          10.355540214014498,
          15.562472209871055,
          17.391304347826086,
          26.348039215686274,
          14.285714285714285,
          11.77495643515061,
          14.662756598240467,
          12.468827930174564,
          14.27891480247501,
          12.03852327447833,
          22.026431718061676,
          19.505851755526656,
          5.643340857787811,
          15.521855486173058,
          19.50286806883365,
          10.677083333333332,
          19.814543679843826,
          17.017056723522412,
          20.614035087719298,
          27.952480782669458,
          21.428571428571427,
          13.793103448275861,
          10.506960861570791,
          10.647181628392484,
          15.558148580318942,
          20.219526285384173,
          16.93952555963916,
          14.084507042253522,
          14.481094127111827,
          12.12624584717608,
          19.760479041916167,
          12.518628912071533,
          17.53155680224404,
          12.539184952978058,
          20.192307692307693,
          14.093959731543624,
          17.370892018779344,
          13.774104683195592,
          17.57469244288225,
          9.55302366345311,
          7.8616352201257875,
          13.961519486926493,
          13.428827215756492,
          16.31321370309951,
          17.798466593647316,
          14.688601645123384,
          19.36108422071636,
          14.13427561837456,
          12.5,
          20.89665653495441,
          20.034344590726963,
          19.533527696793005,
          12.138868657441128,
          18.484288354898336,
          13.998782714546559,
          17.964071856287426,
          7.296137339055794,
          13.732097725358045,
          17.68916155419223,
          26.63115845539281,
          17.768301350390903,
          15.232292460015232,
          15.874855156431053,
          8.146639511201629,
          10.116337885685383,
          17.219430485762143,
          10.379904504878555,
          15,
          19.49215832710978,
          12.128562765312312,
          16.27906976744186,
          19.747235387045812,
          12.338062924120912,
          14.482259232440258,
          17.133066818960593,
          14.192495921696574,
          10.789980732177264,
          14.191106906338694,
          15.203021718602455,
          18.814675446848543,
          19.681165124975397,
          19.987349778621127,
          71.0344827586207,
          9.98430141287284,
          23.781212841854934,
          9.45288753799392,
          11.179429849077696,
          13.812154696132598,
          41.66666666666667,
          10.2512272596015,
          10.620490620490623,
          24.21774539219889,
          7.717750826901875,
          28.05351747949935,
          7.398273736128237,
          24.166263895601737,
          16.74641148325359,
          6.5659881812212735,
          19.28374655647383,
          17.316017316017316,
          9.560229445506693,
          21.150933871781934,
          9.0014064697609,
          13.049095607235142,
          24.12545235223161,
          19.047619047619047,
          19.342359767891683,
          11.59823706796567,
          15.384615384615385,
          14.803849000740193,
          21.378941742383752,
          15.777080062794347,
          15.384615384615385,
          15.243902439024392,
          19.48368241597662,
          19.611414693381906,
          12.82437006393381,
          7.74593338497289,
          8.364235681911826,
          17.476489028213166,
          6.653359946773121,
          19.930475086906142,
          18.6219739292365,
          18.839487565938207,
          23.074192403265883,
          8.527131782945736,
          10.657193605683837,
          12.94219154443486,
          18.6046511627907,
          10.252156602521566,
          18.092105263157894,
          25.93144560357675,
          22.377622377622377,
          18.773466833541928,
          11.773472429210134,
          15.365703749231715,
          19.821605550049554,
          14.66992665036675,
          20.481927710843376,
          13.019891500904157,
          8.329862557267804,
          19.120458891013385,
          29.198966408268735,
          13.649025069637883,
          19.31745009658725,
          12.413108242303872,
          7.936507936507936,
          3.563813585135547,
          13.033770583310075,
          20.39269720978298,
          7.358351729212656,
          8.822232024702249,
          9.820426487093153,
          15.974440894568689
         ],
         "xaxis": "x1",
         "y": [
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip",
          "Percent Tip"
         ],
         "yaxis": "y2"
        }
       ],
       "layout": {
        "barmode": "overlay",
        "hovermode": "closest",
        "legend": {
         "traceorder": "reversed"
        },
        "xaxis1": {
         "anchor": "y2",
         "domain": [
          0,
          1
         ],
         "zeroline": false
        },
        "yaxis1": {
         "anchor": "free",
         "domain": [
          0.35,
          1
         ],
         "position": 0
        },
        "yaxis2": {
         "anchor": "x1",
         "domain": [
          0,
          0.25
         ],
         "dtick": 1,
         "showticklabels": false
        }
       }
      },
      "text/html": [
       "<div id=\"59a309fd-5abb-444e-8a12-f334e2c2c2c3\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"59a309fd-5abb-444e-8a12-f334e2c2c2c3\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 71.0344827586207, \"size\": 1.0}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.698754923482517, 3.8336962618294876, 3.9686376001764576, 4.1035789385234285, 4.238520276870398, 4.373461615217368, 4.508402953564339, 4.643344291911309, 4.77828563025828, 4.913226968605249, 5.0481683069522205, 5.18310964529919, 5.3180509836461605, 5.452992321993131, 5.587933660340101, 5.722874998687072, 5.857816337034042, 5.992757675381013, 6.127699013727982, 6.2626403520749525, 6.397581690421923, 6.532523028768893, 6.667464367115864, 6.802405705462834, 6.937347043809805, 7.072288382156774, 7.2072297205037446, 7.342171058850715, 7.477112397197685, 7.612053735544656, 7.746995073891626, 7.881936412238597, 8.016877750585566, 8.151819088932537, 8.286760427279507, 8.421701765626477, 8.556643103973448, 8.69158444232042, 8.826525780667389, 8.961467119014358, 9.09640845736133, 9.231349795708299, 9.36629113405527, 9.50123247240224, 9.63617381074921, 9.77111514909618, 9.90605648744315, 10.040997825790122, 10.175939164137091, 10.31088050248406, 10.445821840831032, 10.580763179178003, 10.715704517524973, 10.850645855871942, 10.985587194218912, 11.120528532565885, 11.255469870912854, 11.390411209259824, 11.525352547606794, 11.660293885953765, 11.795235224300734, 11.930176562647706, 12.065117900994675, 12.200059239341646, 12.335000577688616, 12.469941916035586, 12.604883254382557, 12.739824592729528, 12.874765931076498, 13.009707269423467, 13.144648607770437, 13.279589946117408, 13.41453128446438, 13.549472622811349, 13.684413961158318, 13.81935529950529, 13.95429663785226, 14.08923797619923, 14.224179314546202, 14.35912065289317, 14.494061991240141, 14.629003329587112, 14.763944667934082, 14.898886006281051, 15.03382734462802, 15.168768682974992, 15.303710021321963, 15.438651359668933, 15.573592698015903, 15.708534036362874, 15.843475374709843, 15.978416713056815, 16.113358051403786, 16.248299389750755, 16.383240728097725, 16.518182066444695, 16.653123404791664, 16.788064743138637, 16.923006081485603, 17.057947419832576, 17.19288875817955, 17.32783009652652, 17.46277143487349, 17.597712773220458, 17.732654111567427, 17.867595449914397, 18.00253678826137, 18.137478126608336, 18.27241946495531, 18.40736080330228, 18.54230214164925, 18.67724347999622, 18.81218481834319, 18.94712615669016, 19.08206749503713, 19.2170088333841, 19.351950171731072, 19.486891510078042, 19.621832848425015, 19.756774186771985, 19.891715525118954, 20.026656863465924, 20.161598201812893, 20.296539540159863, 20.431480878506832, 20.566422216853802, 20.70136355520078, 20.836304893547748, 20.971246231894717, 21.106187570241687, 21.241128908588657, 21.376070246935626, 21.511011585282596, 21.645952923629565, 21.780894261976535, 21.91583560032351, 22.05077693867048, 22.18571827701745, 22.32065961536442, 22.45560095371139, 22.59054229205836, 22.72548363040533, 22.860424968752298, 22.995366307099268, 23.130307645446237, 23.265248983793214, 23.400190322140183, 23.535131660487153, 23.670072998834122, 23.805014337181092, 23.93995567552806, 24.07489701387503, 24.209838352222, 24.34477969056897, 24.479721028915947, 24.614662367262916, 24.749603705609886, 24.884545043956855, 25.019486382303825, 25.154427720650794, 25.289369058997764, 25.424310397344733, 25.559251735691703, 25.69419307403868, 25.82913441238565, 25.96407575073262, 26.099017089079588, 26.233958427426558, 26.368899765773527, 26.503841104120497, 26.638782442467466, 26.773723780814436, 26.908665119161405, 27.043606457508382, 27.17854779585535, 27.31348913420232, 27.44843047254929, 27.58337181089626, 27.71831314924323, 27.8532544875902, 27.98819582593717, 28.123137164284138, 28.258078502631115, 28.393019840978084, 28.527961179325054, 28.662902517672023, 28.797843856018993, 28.932785194365962, 29.067726532712932, 29.2026678710599, 29.33760920940687, 29.472550547753848, 29.607491886100817, 29.742433224447787, 29.877374562794756, 30.012315901141726, 30.147257239488695, 30.282198577835665, 30.417139916182634, 30.552081254529604, 30.687022592876573, 30.82196393122355, 30.95690526957052, 31.09184660791749, 31.22678794626446, 31.361729284611428, 31.496670622958398, 31.631611961305367, 31.766553299652337, 31.901494637999306, 32.03643597634628, 32.17137731469325, 32.30631865304022, 32.44125999138719, 32.57620132973416, 32.71114266808113, 32.8460840064281, 32.98102534477507, 33.11596668312204, 33.25090802146901, 33.385849359815985, 33.520790698162955, 33.655732036509924, 33.790673374856894, 33.92561471320386, 34.06055605155083, 34.1954973898978, 34.33043872824477, 34.46538006659174, 34.60032140493872, 34.73526274328569, 34.87020408163266, 35.00514541997963, 35.140086758326596, 35.275028096673566, 35.409969435020535, 35.544910773367505, 35.67985211171448, 35.81479345006145, 35.94973478840842, 36.08467612675539, 36.21961746510236, 36.35455880344933, 36.4895001417963, 36.624441480143275, 36.75938281849024, 36.894324156837214, 37.029265495184184, 37.16420683353115, 37.29914817187812, 37.43408951022509, 37.56903084857206, 37.70397218691903, 37.83891352526601, 37.97385486361297, 38.10879620195995, 38.24373754030692, 38.378678878653886, 38.513620217000856, 38.648561555347825, 38.783502893694795, 38.918444232041765, 39.05338557038874, 39.188326908735704, 39.32326824708268, 39.45820958542965, 39.59315092377662, 39.72809226212359, 39.86303360047056, 39.99797493881753, 40.1329162771645, 40.267857615511474, 40.40279895385844, 40.53774029220541, 40.67268163055238, 40.80762296889935, 40.94256430724632, 41.0775056455933, 41.21244698394026, 41.34738832228723, 41.48232966063421, 41.61727099898117, 41.752212337328146, 41.88715367567511, 42.022095014022085, 42.157036352369055, 42.291977690716024, 42.426919029062994, 42.56186036740996, 42.69680170575693, 42.8317430441039, 42.96668438245088, 43.10162572079784, 43.23656705914482, 43.37150839749179, 43.50644973583876, 43.64139107418573, 43.776332412532696, 43.911273750879666, 44.046215089226635, 44.18115642757361, 44.316097765920574, 44.45103910426755, 44.58598044261452, 44.72092178096149, 44.85586311930846, 44.99080445765543, 45.1257457960024, 45.26068713434937, 45.395628472696345, 45.53056981104331, 45.665511149390284, 45.80045248773725, 45.93539382608422, 46.07033516443119, 46.20527650277817, 46.34021784112513, 46.4751591794721, 46.61010051781908, 46.74504185616604, 46.87998319451302, 47.014924532859986, 47.149865871206956, 47.284807209553925, 47.4197485479009, 47.554689886247864, 47.689631224594834, 47.82457256294181, 47.95951390128877, 48.09445523963575, 48.22939657798272, 48.36433791632969, 48.49927925467666, 48.63422059302363, 48.7691619313706, 48.90410326971757, 49.039044608064536, 49.173985946411506, 49.30892728475848, 49.443868623105445, 49.57880996145242, 49.71375129979939, 49.84869263814636, 49.98363397649333, 50.11857531484031, 50.25351665318727, 50.38845799153424, 50.523399329881215, 50.65834066822818, 50.793282006575154, 50.928223344922124, 51.06316468326909, 51.19810602161606, 51.33304735996304, 51.46798869831, 51.60293003665697, 51.73787137500395, 51.87281271335091, 52.00775405169789, 52.14269539004486, 52.277636728391826, 52.412578066738796, 52.54751940508577, 52.682460743432735, 52.817402081779704, 52.95234342012668, 53.08728475847364, 53.22222609682062, 53.35716743516759, 53.49210877351456, 53.62705011186153, 53.761991450208505, 53.89693278855547, 54.03187412690244, 54.166815465249414, 54.301756803596376, 54.43669814194335, 54.57163948029032, 54.70658081863729, 54.84152215698426, 54.97646349533124, 55.1114048336782, 55.24634617202518, 55.38128751037215, 55.51622884871911, 55.651170187066086, 55.78611152541305, 55.921052863760025, 56.055994202106994, 56.190935540453964, 56.32587687880093, 56.46081821714791, 56.59575955549487, 56.73070089384184, 56.86564223218882, 57.00058357053578, 57.13552490888276, 57.27046624722973, 57.4054075855767, 57.540348923923666, 57.67529026227064, 57.810231600617605, 57.945172938964575, 58.08011427731155, 58.215055615658514, 58.34999695400549, 58.48493829235246, 58.61987963069943, 58.7548209690464, 58.889762307393376, 59.02470364574034, 59.159644984087315, 59.294586322434284, 59.42952766078125, 59.56446899912822, 59.69941033747519, 59.83435167582216, 59.96929301416913, 60.10423435251611, 60.23917569086307, 60.37411702921005, 60.50905836755702, 60.64399970590398, 60.778941044250956, 60.913882382597926, 61.048823720944895, 61.183765059291865, 61.31870639763884, 61.453647735985804, 61.58858907433278, 61.72353041267975, 61.85847175102671, 61.99341308937369, 62.12835442772066, 62.26329576606763, 62.3982371044146, 62.53317844276157, 62.66811978110854, 62.80306111945551, 62.938002457802476, 63.072943796149445, 63.20788513449642, 63.342826472843385, 63.47776781119036, 63.61270914953733, 63.7476504878843, 63.88259182623127, 64.01753316457824, 64.1524745029252, 64.28741584127218, 64.42235717961915, 64.55729851796612, 64.6922398563131, 64.82718119466006, 64.96212253300703, 65.097063871354, 65.23200520970097, 65.36694654804793, 65.50188788639491, 65.63682922474189, 65.77177056308885, 65.90671190143583, 66.04165323978279, 66.17659457812977, 66.31153591647673, 66.4464772548237, 66.58141859317067, 66.71635993151764, 66.85130126986462, 66.98624260821158, 67.12118394655856, 67.25612528490552, 67.3910666232525, 67.52600796159946, 67.66094929994644, 67.79589063829341, 67.93083197664038, 68.06577331498735, 68.20071465333432, 68.33565599168129, 68.47059733002827, 68.60553866837523, 68.74048000672221, 68.87542134506917, 69.01036268341615, 69.14530402176311, 69.28024536011009, 69.41518669845705, 69.55012803680401, 69.685069375151, 69.82001071349796, 69.95495205184493, 70.0898933901919, 70.22483472853888, 70.35977606688584, 70.49471740523282, 70.62965874357978, 70.76460008192676, 70.89954142027374], \"y\": [0.004061065040256531, 0.004413888978508207, 0.004789339808663863, 0.005187923334495055, 0.0056100331411973615, 0.00605593798092017, 0.006525770588188691, 0.007019518348559347, 0.00753701622583154, 0.008077942319898737, 0.008641816378981468, 0.009228001527295915, 0.009835709393563723, 0.010464008739172257, 0.011111837589830077, 0.011778018774303851, 0.01246127867172563, 0.013160268868727199, 0.013873590333089924, 0.014599819625412637, 0.015337536597965358, 0.016085352973448333, 0.016841941158262347, 0.01760606262682783, 0.018376595216336316, 0.01915255869502956, 0.01993313801068977, 0.02071770368758152, 0.021505828916862448, 0.02229730297401319, 0.023092140693118567, 0.023890587827517882, 0.02469312222499421, 0.025500450838992644, 0.026313502681453736, 0.02713341789444682, 0.027961533174442842, 0.028799363823310085, 0.02964858272354768, 0.030510996542605178, 0.03138851946413958, 0.03228314472548434, 0.03319691421397794, 0.03413188634424564, 0.0350901024084771, 0.03607355156666255, 0.037084134627838036, 0.038123626770297334, 0.039193639361299666, 0.04029558106684057, 0.04143061849019723, 0.04259963664352944, 0.04380319963784442, 0.045041512069855336, 0.04631438168527334, 0.04762118400147698, 0.0489608296721662, 0.05033173546592715, 0.051731799802854715, 0.05315838384191767, 0.054608299130533576, 0.05607780281160138, 0.05756260132789566, 0.059057863466529976, 0.06055824344600759, 0.06205791456582734, 0.06355061371615824, 0.06502969678708674, 0.06648820472951214, 0.06791893971075327, 0.06931455048663807, 0.07066762578878347, 0.0719707942122969, 0.07321682879707855, 0.07439875423712615, 0.07550995443815267, 0.0765442779849296, 0.0774961389851708, 0.07836061073378914, 0.07913350969506677, 0.07981146743328535, 0.08039198833446307, 0.08087349125003364, 0.08125533355161306, 0.08153781650574733, 0.08172217134742225, 0.08181052593765466, 0.08180585241836236, 0.08171189681037241, 0.08153309202061035, 0.08127445621489994, 0.0809414789566595, 0.08053999789357176, 0.08007606908029484, 0.07955583424406373, 0.07898538842295848, 0.07837065142815776, 0.07771724649946794, 0.07703038933907268, 0.0763147904264893, 0.07557457314614326, 0.07481320980881365, 0.07403347713321282, 0.07323743219009332, 0.07242640921622669, 0.07160103709818437, 0.07076127672537842, 0.06990647683748734, 0.06903544646157093, 0.06814654156587319, 0.0672377631654885, 0.06630686381221874, 0.06535145919656712, 0.06436914149008682, 0.06335759106386796, 0.06231468333273976, 0.06123858769006774, 0.0601278558065846, 0.05898149695700307, 0.05779903849587522, 0.05658057011261719, 0.05532677103644683, 0.054038919915825906, 0.052718887644250145, 0.051369113925798564, 0.049992568851931644, 0.04859270117976999, 0.04717337534824998, 0.04573879953199846, 0.044293447206817736, 0.04284197478234262, 0.04138913784744981, 0.039939708476718815, 0.03849839586932271, 0.03706977234571012, 0.035658206425225464, 0.03426780436396405, 0.03290236116223318, 0.0315653216708009, 0.030259752050017918, 0.028988321480134766, 0.02775329369726309, 0.02655652764784242, 0.02539948632307492, 0.02428325265878568, 0.02320855126801733, 0.02217577471315295, 0.02118501301880052, 0.02023608517122076, 0.019328571438135583, 0.018461845466386274, 0.017635105265368944, 0.016847402352337573, 0.01609766851251993, 0.015384739804037364, 0.01470737760721114, 0.014064286673472773, 0.013454130265585113, 0.01287554259447577, 0.012327138846377421, 0.011807523156263556, 0.011315294920143305, 0.010849053851136572, 0.010407404174806678, 0.009988958331086682, 0.009592340506864762, 0.009216190268693043, 0.008859166502987879, 0.008519951805177731, 0.008197257392918421, 0.007889828554717744, 0.0075964505865984055, 0.007315955117772504, 0.0070472266831716895, 0.006789209367043516, 0.006540913318192777, 0.006301420923915906, 0.0060698924259996795, 0.00584557076780063, 0.005627785475635947, 0.005415955399578189, 0.005209590167208704, 0.005008290237819089, 0.004811745482765651, 0.004619732258952654, 0.004432108985494354, 0.0042488102772232795, 0.004069839731607929, 0.0038952615065696284, 0.0037251908644240867, 0.0035597838905499874, 0.003399226623314702, 0.003243723853285893, 0.003093487863994801, 0.0029487273928415817, 0.002809637088716958, 0.0026763877323784015, 0.0025491174666662808, 0.0024279242566706766, 0.0023128597656595995, 0.002203924791940908, 0.002101066366108204, 0.0020041765588009928, 0.0019130929978565217, 0.0018276010423274515, 0.0017474375111151182, 0.001672295817720563, 0.0016018323215357814, 0.0015356736716917376, 0.0014734248930020205, 0.001414677945934707, 0.0013590204843982635, 0.001306044536645361, 0.0012553548455934743, 0.0012065766247619416, 0.001159362513903558, 0.0011133985530256984, 0.0010684090333588584, 0.0010241601272653162, 0.0009804622443093098, 0.0009371711059325876, 0.0008941875746540666, 0.0008514563138329411, 0.0008089633893953681, 0.0007667329543770098, 0.0007248231798244448, 0.0006833216109964241, 0.0006423401357080032, 0.0006020097521837605, 0.0005624753173443817, 0.0005238904437178537, 0.00048641269503058704, 0.0004501992080435803, 0.0004154028425066951, 0.00038216893340823667, 0.0003506326911868276, 0.00032091726737884085, 0.0002931324763277669, 0.00026737413897860566, 0.00024372399316037073, 0.00022225009669232977, 0.00020300763552952278, 0.00018604003921478878, 0.00017138030019374763, 0.00015905239199883844, 0.00014907268371896652, 0.00014145125424141268, 0.00013619301910119315, 0.00013329859495857116, 0.00013276484126351271, 0.0001345850350440157, 0.00013874865244358772, 0.0001452407490934611, 0.00015404095009655732, 0.00016512207878403493, 0.00017844847094905075, 0.00019397403744459663, 0.00021164015234829598, 0.00023137345586762636, 0.0002530836703405379, 0.00027666153368517644, 0.0003019769571395235, 0.0003288775128614308, 0.000357187351786534, 0.00038670664303883866, 0.0004172116132623349, 0.00044845524774174, 0.0004801686955064988, 0.0005120633983123962, 0.0005438339391581892, 0.0005751615806308962, 0.0006057184377910238, 0.0006351722054802845, 0.0006631913368565261, 0.000689450549611927, 0.0007136365196235169, 0.0007354536095210952, 0.0007546294724819934, 0.0007709203699282949, 0.0007841160459401385, 0.0007940440110973731, 0.0008005731038601201, 0.0008036162179920371, 0.0008031321091872811, 0.0007991262220572571, 0.0007916505088855917, 0.0007808022428844794, 0.0007667218598489521, 0.0007495898918840708, 0.0007296230841177507, 0.0007070698089755887, 0.0006822049118201197, 0.0006553241358898414, 0.0006267382830923024, 0.0005967672701383592, 0.0005657342368291118, 0.0005339598553378139, 0.0005017569765958483, 0.00046942573310343553, 0.00043724919749046594, 0.0004054896738906579, 0.00037438567564659377, 0.000344149619012473, 0.00031496623929375443, 0.0002869917140967621, 0.000260353458772355, 0.00023515054229610328, 0.00021145465814113645, 0.00018931157441137754, 0.00016874298069085336, 0.00014974864565601084, 0.00013230879928488424, 0.0001163866561602831, 0.00010193100149914537, 8.887876868351526e-05, 7.715754572673293e-05, 6.668795778227171e-05, 5.7385883011832395e-05, 4.916446943062413e-05, 4.193593035105279e-05, 3.5613105424349974e-05, 3.0110782775869593e-05, 2.5346785158092945e-05, 2.1242829289821303e-05, 1.7725172559526937e-05, 1.47250650515729e-05, 1.2179027460821895e-05, 1.0028976987214784e-05, 8.222223868701009e-06, 6.711360958162722e-06, 5.454067826578978e-06, 4.412849430495905e-06, 3.5547275610949367e-06, 2.8509012280304825e-06, 2.2763899421638006e-06, 1.809671648629874e-06, 1.4323249082523385e-06, 1.1286828956938805e-06, 8.855049238302605e-07, 6.916695464936667e-07, 5.378918526043765e-07, 4.16466348493636e-07, 3.2103582695293924e-07, 2.4638582887079993e-07, 1.8826369862341475e-07, 1.4322079669273577e-07, 1.0847613960286604e-07, 8.179956513047356e-08, 6.141244748653898e-08, 4.590399188604345e-08, 3.416120172412304e-08, 2.5310717881298547e-08, 1.8670864352976154e-08, 1.3712385739657255e-08, 1.0026520757316159e-08, 7.299214563892447e-09, 5.2904259559312025e-09, 3.817629590016872e-09, 2.7427458924163194e-09, 1.9618508902067147e-09, 1.3971243307170989e-09, 9.905872944769853e-10, 6.992606477306674e-10, 4.914440263015807e-10, 3.438726774164501e-10, 2.395575799972692e-10, 1.6615400029578973e-10, 1.1473616341600575e-10, 7.888210349929797e-11, 5.399397238671244e-11, 3.679600885692664e-11, 2.4965759780535885e-11, 1.686465647701201e-11, 1.1342240533667929e-11, 7.59466909380626e-12, 5.06299533216203e-12, 3.36043047892033e-12, 2.220604156223336e-12, 1.460954062346998e-12, 9.569561120730627e-13, 6.240793244661887e-13, 4.052152553369018e-13, 2.6196627339106577e-13, 1.6863924889955557e-13, 1.0812596062727209e-13, 6.909246898497551e-14, 4.407213068313844e-14, 2.817965324016544e-14, 1.8250513922283737e-14, 1.2271422669538055e-14, 9.010781902168653e-15, 7.788770029013387e-15, 8.348785435264685e-15, 1.0808556091887567e-14, 1.568259728070787e-14, 2.3979842981244692e-14, 3.739298801981403e-14, 5.861123194427245e-14, 9.180788843537391e-14, 1.4338145669664933e-13, 2.2306686352951489e-13, 3.455875717943426e-13, 5.33095792792719e-13, 8.187562637625731e-13, 1.2519813910303148e-12, 1.9060388683373703e-12, 2.889049863569262e-12, 4.359806906358641e-12, 6.550406063842535e-12, 9.798461079023034e-12, 1.4592717492343312e-11, 2.163730274057301e-11, 3.194175014664065e-11, 4.6946469015957937e-11, 6.869668746972345e-11, 1.0008230438481846e-10, 1.4516684368604232e-10, 2.0963616653755905e-10, 3.0140719977042593e-10, 4.3144920422037216e-10, 6.148856529771532e-10, 8.724643392321777e-10, 1.2325077170824826e-09, 1.7334856346102324e-09, 2.4273895851450593e-09, 3.384132501012366e-09, 4.6972521186143505e-09, 6.491260236510729e-09, 8.931055894710467e-09, 1.2233908605372807e-08, 1.6684618987820253e-08, 2.2654578831920058e-08, 3.062558049288616e-08, 4.1219365597544224e-08, 5.523405330977864e-08, 7.368874560518853e-08, 9.787776637158493e-08, 1.294361461311259e-07, 1.7041810618590504e-07, 2.233904141871005e-07, 2.91542564283386e-07, 3.7881576342592685e-07, 4.900526630207396e-07, 6.311696417104002e-07, 8.093531987266391e-07, 1.0332816350662432e-06, 1.3133726587368053e-06, 1.6620568287147696e-06, 2.094075831004372e-06, 2.6268034447645e-06, 3.280585698956659e-06, 4.079095141250868e-06, 5.04969235302578e-06, 6.223785872609035e-06, 7.637179574264069e-06, 9.330394350797272e-06, 1.13489487391608e-05, 1.3743581005709115e-05, 1.657039328316025e-05, 1.9890896753042463e-05, 2.3771935736134174e-05, 2.8285468037697128e-05, 3.3508179144210024e-05, 3.9520909027951444e-05, 4.6407872514455533e-05, 5.4255657510240266e-05, 6.315198994441792e-05, 7.318426007283131e-05, 8.443781179821848e-05, 9.699400478285368e-05, 0.00011092806821156569, 0.00012630677487171315, 0.0001431859744508427, 0.00016160803524434465, 0.0001815992533889584, 0.00020316729782486796, 0.00022629876694426273, 0.0002509569388094778, 0.00027707980044122514, 0.0003045784425577029, 0.0003333359039347361, 0.00036320654400373353, 0.0003940160132837142, 0.00042556187877661265, 0.00045761494572299396, 0.0004899212984656303, 0.0005222050621120998, 0.0005541718638894977, 0.0005855129493398443, 0.0006159098847134543, 0.000645039754042669, 0.0006725807384066953, 0.0006982179467900685, 0.0007216493535784192, 0.0007425916878904012, 0.0007607861152114439, 0.0007760035525695503, 0.0007880494649412836, 0.0007967680026167702, 0.0008020453565550446], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": [\"$16.99\", \"$10.34\", \"$21.01\", \"$23.68\", \"$24.59\", \"$25.29\", \"$8.77\", \"$26.88\", \"$15.04\", \"$14.78\", \"$10.27\", \"$35.26\", \"$15.42\", \"$18.43\", \"$14.83\", \"$21.58\", \"$10.33\", \"$16.29\", \"$16.97\", \"$20.65\", \"$17.92\", \"$20.29\", \"$15.77\", \"$39.42\", \"$19.82\", \"$17.81\", \"$13.37\", \"$12.69\", \"$21.7\", \"$19.65\", \"$9.55\", \"$18.35\", \"$15.06\", \"$20.69\", \"$17.78\", \"$24.06\", \"$16.31\", \"$16.93\", \"$18.69\", \"$31.27\", \"$16.04\", \"$17.46\", \"$13.94\", \"$9.68\", \"$30.4\", \"$18.29\", \"$22.23\", \"$32.4\", \"$28.55\", \"$18.04\", \"$12.54\", \"$10.29\", \"$34.81\", \"$9.94\", \"$25.56\", \"$19.49\", \"$38.01\", \"$26.41\", \"$11.24\", \"$48.27\", \"$20.29\", \"$13.81\", \"$11.02\", \"$18.29\", \"$17.59\", \"$20.08\", \"$16.45\", \"$3.07\", \"$20.23\", \"$15.01\", \"$12.02\", \"$17.07\", \"$26.86\", \"$25.28\", \"$14.73\", \"$10.51\", \"$17.92\", \"$27.2\", \"$22.76\", \"$17.29\", \"$19.44\", \"$16.66\", \"$10.07\", \"$32.68\", \"$15.98\", \"$34.83\", \"$13.03\", \"$18.28\", \"$24.71\", \"$21.16\", \"$28.97\", \"$22.49\", \"$5.75\", \"$16.32\", \"$22.75\", \"$40.17\", \"$27.28\", \"$12.03\", \"$21.01\", \"$12.46\", \"$11.35\", \"$15.38\", \"$44.3\", \"$22.42\", \"$20.92\", \"$15.36\", \"$20.49\", \"$25.21\", \"$18.24\", \"$14.31\", \"$14.0\", \"$7.25\", \"$38.07\", \"$23.95\", \"$25.71\", \"$17.31\", \"$29.93\", \"$10.65\", \"$12.43\", \"$24.08\", \"$11.69\", \"$13.42\", \"$14.26\", \"$15.95\", \"$12.48\", \"$29.8\", \"$8.52\", \"$14.52\", \"$11.38\", \"$22.82\", \"$19.08\", \"$20.27\", \"$11.17\", \"$12.26\", \"$18.26\", \"$8.51\", \"$10.33\", \"$14.15\", \"$16.0\", \"$13.16\", \"$17.47\", \"$34.3\", \"$41.19\", \"$27.05\", \"$16.43\", \"$8.35\", \"$18.64\", \"$11.87\", \"$9.78\", \"$7.51\", \"$14.07\", \"$13.13\", \"$17.26\", \"$24.55\", \"$19.77\", \"$29.85\", \"$48.17\", \"$25.0\", \"$13.39\", \"$16.49\", \"$21.5\", \"$12.66\", \"$16.21\", \"$13.81\", \"$17.51\", \"$24.52\", \"$20.76\", \"$31.71\", \"$10.59\", \"$10.63\", \"$50.81\", \"$15.81\", \"$7.25\", \"$31.85\", \"$16.82\", \"$32.9\", \"$17.89\", \"$14.48\", \"$9.6\", \"$34.63\", \"$34.65\", \"$23.33\", \"$45.35\", \"$23.17\", \"$40.55\", \"$20.69\", \"$20.9\", \"$30.46\", \"$18.15\", \"$23.1\", \"$15.69\", \"$19.81\", \"$28.44\", \"$15.48\", \"$16.58\", \"$7.56\", \"$10.34\", \"$43.11\", \"$13.0\", \"$13.51\", \"$18.71\", \"$12.74\", \"$13.0\", \"$16.4\", \"$20.53\", \"$16.47\", \"$26.59\", \"$38.73\", \"$24.27\", \"$12.76\", \"$30.06\", \"$25.89\", \"$48.33\", \"$13.27\", \"$28.17\", \"$12.9\", \"$28.15\", \"$11.59\", \"$7.74\", \"$30.14\", \"$12.16\", \"$13.42\", \"$8.58\", \"$15.98\", \"$13.42\", \"$16.27\", \"$10.09\", \"$20.45\", \"$13.28\", \"$22.12\", \"$24.01\", \"$15.69\", \"$11.61\", \"$10.77\", \"$15.53\", \"$10.07\", \"$12.6\", \"$32.83\", \"$35.83\", \"$29.03\", \"$27.18\", \"$22.67\", \"$17.82\", \"$18.78\"], \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<div id=\"59a309fd-5abb-444e-8a12-f334e2c2c2c3\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"59a309fd-5abb-444e-8a12-f334e2c2c2c3\", [{\"type\": \"histogram\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"histnorm\": \"probability density\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"marker\": {\"color\": \"rgb(31, 119, 180)\"}, \"autobinx\": false, \"xbins\": {\"start\": 3.563813585135547, \"end\": 71.0344827586207, \"size\": 1.0}, \"opacity\": 0.7}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 3.698754923482517, 3.8336962618294876, 3.9686376001764576, 4.1035789385234285, 4.238520276870398, 4.373461615217368, 4.508402953564339, 4.643344291911309, 4.77828563025828, 4.913226968605249, 5.0481683069522205, 5.18310964529919, 5.3180509836461605, 5.452992321993131, 5.587933660340101, 5.722874998687072, 5.857816337034042, 5.992757675381013, 6.127699013727982, 6.2626403520749525, 6.397581690421923, 6.532523028768893, 6.667464367115864, 6.802405705462834, 6.937347043809805, 7.072288382156774, 7.2072297205037446, 7.342171058850715, 7.477112397197685, 7.612053735544656, 7.746995073891626, 7.881936412238597, 8.016877750585566, 8.151819088932537, 8.286760427279507, 8.421701765626477, 8.556643103973448, 8.69158444232042, 8.826525780667389, 8.961467119014358, 9.09640845736133, 9.231349795708299, 9.36629113405527, 9.50123247240224, 9.63617381074921, 9.77111514909618, 9.90605648744315, 10.040997825790122, 10.175939164137091, 10.31088050248406, 10.445821840831032, 10.580763179178003, 10.715704517524973, 10.850645855871942, 10.985587194218912, 11.120528532565885, 11.255469870912854, 11.390411209259824, 11.525352547606794, 11.660293885953765, 11.795235224300734, 11.930176562647706, 12.065117900994675, 12.200059239341646, 12.335000577688616, 12.469941916035586, 12.604883254382557, 12.739824592729528, 12.874765931076498, 13.009707269423467, 13.144648607770437, 13.279589946117408, 13.41453128446438, 13.549472622811349, 13.684413961158318, 13.81935529950529, 13.95429663785226, 14.08923797619923, 14.224179314546202, 14.35912065289317, 14.494061991240141, 14.629003329587112, 14.763944667934082, 14.898886006281051, 15.03382734462802, 15.168768682974992, 15.303710021321963, 15.438651359668933, 15.573592698015903, 15.708534036362874, 15.843475374709843, 15.978416713056815, 16.113358051403786, 16.248299389750755, 16.383240728097725, 16.518182066444695, 16.653123404791664, 16.788064743138637, 16.923006081485603, 17.057947419832576, 17.19288875817955, 17.32783009652652, 17.46277143487349, 17.597712773220458, 17.732654111567427, 17.867595449914397, 18.00253678826137, 18.137478126608336, 18.27241946495531, 18.40736080330228, 18.54230214164925, 18.67724347999622, 18.81218481834319, 18.94712615669016, 19.08206749503713, 19.2170088333841, 19.351950171731072, 19.486891510078042, 19.621832848425015, 19.756774186771985, 19.891715525118954, 20.026656863465924, 20.161598201812893, 20.296539540159863, 20.431480878506832, 20.566422216853802, 20.70136355520078, 20.836304893547748, 20.971246231894717, 21.106187570241687, 21.241128908588657, 21.376070246935626, 21.511011585282596, 21.645952923629565, 21.780894261976535, 21.91583560032351, 22.05077693867048, 22.18571827701745, 22.32065961536442, 22.45560095371139, 22.59054229205836, 22.72548363040533, 22.860424968752298, 22.995366307099268, 23.130307645446237, 23.265248983793214, 23.400190322140183, 23.535131660487153, 23.670072998834122, 23.805014337181092, 23.93995567552806, 24.07489701387503, 24.209838352222, 24.34477969056897, 24.479721028915947, 24.614662367262916, 24.749603705609886, 24.884545043956855, 25.019486382303825, 25.154427720650794, 25.289369058997764, 25.424310397344733, 25.559251735691703, 25.69419307403868, 25.82913441238565, 25.96407575073262, 26.099017089079588, 26.233958427426558, 26.368899765773527, 26.503841104120497, 26.638782442467466, 26.773723780814436, 26.908665119161405, 27.043606457508382, 27.17854779585535, 27.31348913420232, 27.44843047254929, 27.58337181089626, 27.71831314924323, 27.8532544875902, 27.98819582593717, 28.123137164284138, 28.258078502631115, 28.393019840978084, 28.527961179325054, 28.662902517672023, 28.797843856018993, 28.932785194365962, 29.067726532712932, 29.2026678710599, 29.33760920940687, 29.472550547753848, 29.607491886100817, 29.742433224447787, 29.877374562794756, 30.012315901141726, 30.147257239488695, 30.282198577835665, 30.417139916182634, 30.552081254529604, 30.687022592876573, 30.82196393122355, 30.95690526957052, 31.09184660791749, 31.22678794626446, 31.361729284611428, 31.496670622958398, 31.631611961305367, 31.766553299652337, 31.901494637999306, 32.03643597634628, 32.17137731469325, 32.30631865304022, 32.44125999138719, 32.57620132973416, 32.71114266808113, 32.8460840064281, 32.98102534477507, 33.11596668312204, 33.25090802146901, 33.385849359815985, 33.520790698162955, 33.655732036509924, 33.790673374856894, 33.92561471320386, 34.06055605155083, 34.1954973898978, 34.33043872824477, 34.46538006659174, 34.60032140493872, 34.73526274328569, 34.87020408163266, 35.00514541997963, 35.140086758326596, 35.275028096673566, 35.409969435020535, 35.544910773367505, 35.67985211171448, 35.81479345006145, 35.94973478840842, 36.08467612675539, 36.21961746510236, 36.35455880344933, 36.4895001417963, 36.624441480143275, 36.75938281849024, 36.894324156837214, 37.029265495184184, 37.16420683353115, 37.29914817187812, 37.43408951022509, 37.56903084857206, 37.70397218691903, 37.83891352526601, 37.97385486361297, 38.10879620195995, 38.24373754030692, 38.378678878653886, 38.513620217000856, 38.648561555347825, 38.783502893694795, 38.918444232041765, 39.05338557038874, 39.188326908735704, 39.32326824708268, 39.45820958542965, 39.59315092377662, 39.72809226212359, 39.86303360047056, 39.99797493881753, 40.1329162771645, 40.267857615511474, 40.40279895385844, 40.53774029220541, 40.67268163055238, 40.80762296889935, 40.94256430724632, 41.0775056455933, 41.21244698394026, 41.34738832228723, 41.48232966063421, 41.61727099898117, 41.752212337328146, 41.88715367567511, 42.022095014022085, 42.157036352369055, 42.291977690716024, 42.426919029062994, 42.56186036740996, 42.69680170575693, 42.8317430441039, 42.96668438245088, 43.10162572079784, 43.23656705914482, 43.37150839749179, 43.50644973583876, 43.64139107418573, 43.776332412532696, 43.911273750879666, 44.046215089226635, 44.18115642757361, 44.316097765920574, 44.45103910426755, 44.58598044261452, 44.72092178096149, 44.85586311930846, 44.99080445765543, 45.1257457960024, 45.26068713434937, 45.395628472696345, 45.53056981104331, 45.665511149390284, 45.80045248773725, 45.93539382608422, 46.07033516443119, 46.20527650277817, 46.34021784112513, 46.4751591794721, 46.61010051781908, 46.74504185616604, 46.87998319451302, 47.014924532859986, 47.149865871206956, 47.284807209553925, 47.4197485479009, 47.554689886247864, 47.689631224594834, 47.82457256294181, 47.95951390128877, 48.09445523963575, 48.22939657798272, 48.36433791632969, 48.49927925467666, 48.63422059302363, 48.7691619313706, 48.90410326971757, 49.039044608064536, 49.173985946411506, 49.30892728475848, 49.443868623105445, 49.57880996145242, 49.71375129979939, 49.84869263814636, 49.98363397649333, 50.11857531484031, 50.25351665318727, 50.38845799153424, 50.523399329881215, 50.65834066822818, 50.793282006575154, 50.928223344922124, 51.06316468326909, 51.19810602161606, 51.33304735996304, 51.46798869831, 51.60293003665697, 51.73787137500395, 51.87281271335091, 52.00775405169789, 52.14269539004486, 52.277636728391826, 52.412578066738796, 52.54751940508577, 52.682460743432735, 52.817402081779704, 52.95234342012668, 53.08728475847364, 53.22222609682062, 53.35716743516759, 53.49210877351456, 53.62705011186153, 53.761991450208505, 53.89693278855547, 54.03187412690244, 54.166815465249414, 54.301756803596376, 54.43669814194335, 54.57163948029032, 54.70658081863729, 54.84152215698426, 54.97646349533124, 55.1114048336782, 55.24634617202518, 55.38128751037215, 55.51622884871911, 55.651170187066086, 55.78611152541305, 55.921052863760025, 56.055994202106994, 56.190935540453964, 56.32587687880093, 56.46081821714791, 56.59575955549487, 56.73070089384184, 56.86564223218882, 57.00058357053578, 57.13552490888276, 57.27046624722973, 57.4054075855767, 57.540348923923666, 57.67529026227064, 57.810231600617605, 57.945172938964575, 58.08011427731155, 58.215055615658514, 58.34999695400549, 58.48493829235246, 58.61987963069943, 58.7548209690464, 58.889762307393376, 59.02470364574034, 59.159644984087315, 59.294586322434284, 59.42952766078125, 59.56446899912822, 59.69941033747519, 59.83435167582216, 59.96929301416913, 60.10423435251611, 60.23917569086307, 60.37411702921005, 60.50905836755702, 60.64399970590398, 60.778941044250956, 60.913882382597926, 61.048823720944895, 61.183765059291865, 61.31870639763884, 61.453647735985804, 61.58858907433278, 61.72353041267975, 61.85847175102671, 61.99341308937369, 62.12835442772066, 62.26329576606763, 62.3982371044146, 62.53317844276157, 62.66811978110854, 62.80306111945551, 62.938002457802476, 63.072943796149445, 63.20788513449642, 63.342826472843385, 63.47776781119036, 63.61270914953733, 63.7476504878843, 63.88259182623127, 64.01753316457824, 64.1524745029252, 64.28741584127218, 64.42235717961915, 64.55729851796612, 64.6922398563131, 64.82718119466006, 64.96212253300703, 65.097063871354, 65.23200520970097, 65.36694654804793, 65.50188788639491, 65.63682922474189, 65.77177056308885, 65.90671190143583, 66.04165323978279, 66.17659457812977, 66.31153591647673, 66.4464772548237, 66.58141859317067, 66.71635993151764, 66.85130126986462, 66.98624260821158, 67.12118394655856, 67.25612528490552, 67.3910666232525, 67.52600796159946, 67.66094929994644, 67.79589063829341, 67.93083197664038, 68.06577331498735, 68.20071465333432, 68.33565599168129, 68.47059733002827, 68.60553866837523, 68.74048000672221, 68.87542134506917, 69.01036268341615, 69.14530402176311, 69.28024536011009, 69.41518669845705, 69.55012803680401, 69.685069375151, 69.82001071349796, 69.95495205184493, 70.0898933901919, 70.22483472853888, 70.35977606688584, 70.49471740523282, 70.62965874357978, 70.76460008192676, 70.89954142027374], \"y\": [0.004061065040256531, 0.004413888978508207, 0.004789339808663863, 0.005187923334495055, 0.0056100331411973615, 0.00605593798092017, 0.006525770588188691, 0.007019518348559347, 0.00753701622583154, 0.008077942319898737, 0.008641816378981468, 0.009228001527295915, 0.009835709393563723, 0.010464008739172257, 0.011111837589830077, 0.011778018774303851, 0.01246127867172563, 0.013160268868727199, 0.013873590333089924, 0.014599819625412637, 0.015337536597965358, 0.016085352973448333, 0.016841941158262347, 0.01760606262682783, 0.018376595216336316, 0.01915255869502956, 0.01993313801068977, 0.02071770368758152, 0.021505828916862448, 0.02229730297401319, 0.023092140693118567, 0.023890587827517882, 0.02469312222499421, 0.025500450838992644, 0.026313502681453736, 0.02713341789444682, 0.027961533174442842, 0.028799363823310085, 0.02964858272354768, 0.030510996542605178, 0.03138851946413958, 0.03228314472548434, 0.03319691421397794, 0.03413188634424564, 0.0350901024084771, 0.03607355156666255, 0.037084134627838036, 0.038123626770297334, 0.039193639361299666, 0.04029558106684057, 0.04143061849019723, 0.04259963664352944, 0.04380319963784442, 0.045041512069855336, 0.04631438168527334, 0.04762118400147698, 0.0489608296721662, 0.05033173546592715, 0.051731799802854715, 0.05315838384191767, 0.054608299130533576, 0.05607780281160138, 0.05756260132789566, 0.059057863466529976, 0.06055824344600759, 0.06205791456582734, 0.06355061371615824, 0.06502969678708674, 0.06648820472951214, 0.06791893971075327, 0.06931455048663807, 0.07066762578878347, 0.0719707942122969, 0.07321682879707855, 0.07439875423712615, 0.07550995443815267, 0.0765442779849296, 0.0774961389851708, 0.07836061073378914, 0.07913350969506677, 0.07981146743328535, 0.08039198833446307, 0.08087349125003364, 0.08125533355161306, 0.08153781650574733, 0.08172217134742225, 0.08181052593765466, 0.08180585241836236, 0.08171189681037241, 0.08153309202061035, 0.08127445621489994, 0.0809414789566595, 0.08053999789357176, 0.08007606908029484, 0.07955583424406373, 0.07898538842295848, 0.07837065142815776, 0.07771724649946794, 0.07703038933907268, 0.0763147904264893, 0.07557457314614326, 0.07481320980881365, 0.07403347713321282, 0.07323743219009332, 0.07242640921622669, 0.07160103709818437, 0.07076127672537842, 0.06990647683748734, 0.06903544646157093, 0.06814654156587319, 0.0672377631654885, 0.06630686381221874, 0.06535145919656712, 0.06436914149008682, 0.06335759106386796, 0.06231468333273976, 0.06123858769006774, 0.0601278558065846, 0.05898149695700307, 0.05779903849587522, 0.05658057011261719, 0.05532677103644683, 0.054038919915825906, 0.052718887644250145, 0.051369113925798564, 0.049992568851931644, 0.04859270117976999, 0.04717337534824998, 0.04573879953199846, 0.044293447206817736, 0.04284197478234262, 0.04138913784744981, 0.039939708476718815, 0.03849839586932271, 0.03706977234571012, 0.035658206425225464, 0.03426780436396405, 0.03290236116223318, 0.0315653216708009, 0.030259752050017918, 0.028988321480134766, 0.02775329369726309, 0.02655652764784242, 0.02539948632307492, 0.02428325265878568, 0.02320855126801733, 0.02217577471315295, 0.02118501301880052, 0.02023608517122076, 0.019328571438135583, 0.018461845466386274, 0.017635105265368944, 0.016847402352337573, 0.01609766851251993, 0.015384739804037364, 0.01470737760721114, 0.014064286673472773, 0.013454130265585113, 0.01287554259447577, 0.012327138846377421, 0.011807523156263556, 0.011315294920143305, 0.010849053851136572, 0.010407404174806678, 0.009988958331086682, 0.009592340506864762, 0.009216190268693043, 0.008859166502987879, 0.008519951805177731, 0.008197257392918421, 0.007889828554717744, 0.0075964505865984055, 0.007315955117772504, 0.0070472266831716895, 0.006789209367043516, 0.006540913318192777, 0.006301420923915906, 0.0060698924259996795, 0.00584557076780063, 0.005627785475635947, 0.005415955399578189, 0.005209590167208704, 0.005008290237819089, 0.004811745482765651, 0.004619732258952654, 0.004432108985494354, 0.0042488102772232795, 0.004069839731607929, 0.0038952615065696284, 0.0037251908644240867, 0.0035597838905499874, 0.003399226623314702, 0.003243723853285893, 0.003093487863994801, 0.0029487273928415817, 0.002809637088716958, 0.0026763877323784015, 0.0025491174666662808, 0.0024279242566706766, 0.0023128597656595995, 0.002203924791940908, 0.002101066366108204, 0.0020041765588009928, 0.0019130929978565217, 0.0018276010423274515, 0.0017474375111151182, 0.001672295817720563, 0.0016018323215357814, 0.0015356736716917376, 0.0014734248930020205, 0.001414677945934707, 0.0013590204843982635, 0.001306044536645361, 0.0012553548455934743, 0.0012065766247619416, 0.001159362513903558, 0.0011133985530256984, 0.0010684090333588584, 0.0010241601272653162, 0.0009804622443093098, 0.0009371711059325876, 0.0008941875746540666, 0.0008514563138329411, 0.0008089633893953681, 0.0007667329543770098, 0.0007248231798244448, 0.0006833216109964241, 0.0006423401357080032, 0.0006020097521837605, 0.0005624753173443817, 0.0005238904437178537, 0.00048641269503058704, 0.0004501992080435803, 0.0004154028425066951, 0.00038216893340823667, 0.0003506326911868276, 0.00032091726737884085, 0.0002931324763277669, 0.00026737413897860566, 0.00024372399316037073, 0.00022225009669232977, 0.00020300763552952278, 0.00018604003921478878, 0.00017138030019374763, 0.00015905239199883844, 0.00014907268371896652, 0.00014145125424141268, 0.00013619301910119315, 0.00013329859495857116, 0.00013276484126351271, 0.0001345850350440157, 0.00013874865244358772, 0.0001452407490934611, 0.00015404095009655732, 0.00016512207878403493, 0.00017844847094905075, 0.00019397403744459663, 0.00021164015234829598, 0.00023137345586762636, 0.0002530836703405379, 0.00027666153368517644, 0.0003019769571395235, 0.0003288775128614308, 0.000357187351786534, 0.00038670664303883866, 0.0004172116132623349, 0.00044845524774174, 0.0004801686955064988, 0.0005120633983123962, 0.0005438339391581892, 0.0005751615806308962, 0.0006057184377910238, 0.0006351722054802845, 0.0006631913368565261, 0.000689450549611927, 0.0007136365196235169, 0.0007354536095210952, 0.0007546294724819934, 0.0007709203699282949, 0.0007841160459401385, 0.0007940440110973731, 0.0008005731038601201, 0.0008036162179920371, 0.0008031321091872811, 0.0007991262220572571, 0.0007916505088855917, 0.0007808022428844794, 0.0007667218598489521, 0.0007495898918840708, 0.0007296230841177507, 0.0007070698089755887, 0.0006822049118201197, 0.0006553241358898414, 0.0006267382830923024, 0.0005967672701383592, 0.0005657342368291118, 0.0005339598553378139, 0.0005017569765958483, 0.00046942573310343553, 0.00043724919749046594, 0.0004054896738906579, 0.00037438567564659377, 0.000344149619012473, 0.00031496623929375443, 0.0002869917140967621, 0.000260353458772355, 0.00023515054229610328, 0.00021145465814113645, 0.00018931157441137754, 0.00016874298069085336, 0.00014974864565601084, 0.00013230879928488424, 0.0001163866561602831, 0.00010193100149914537, 8.887876868351526e-05, 7.715754572673293e-05, 6.668795778227171e-05, 5.7385883011832395e-05, 4.916446943062413e-05, 4.193593035105279e-05, 3.5613105424349974e-05, 3.0110782775869593e-05, 2.5346785158092945e-05, 2.1242829289821303e-05, 1.7725172559526937e-05, 1.47250650515729e-05, 1.2179027460821895e-05, 1.0028976987214784e-05, 8.222223868701009e-06, 6.711360958162722e-06, 5.454067826578978e-06, 4.412849430495905e-06, 3.5547275610949367e-06, 2.8509012280304825e-06, 2.2763899421638006e-06, 1.809671648629874e-06, 1.4323249082523385e-06, 1.1286828956938805e-06, 8.855049238302605e-07, 6.916695464936667e-07, 5.378918526043765e-07, 4.16466348493636e-07, 3.2103582695293924e-07, 2.4638582887079993e-07, 1.8826369862341475e-07, 1.4322079669273577e-07, 1.0847613960286604e-07, 8.179956513047356e-08, 6.141244748653898e-08, 4.590399188604345e-08, 3.416120172412304e-08, 2.5310717881298547e-08, 1.8670864352976154e-08, 1.3712385739657255e-08, 1.0026520757316159e-08, 7.299214563892447e-09, 5.2904259559312025e-09, 3.817629590016872e-09, 2.7427458924163194e-09, 1.9618508902067147e-09, 1.3971243307170989e-09, 9.905872944769853e-10, 6.992606477306674e-10, 4.914440263015807e-10, 3.438726774164501e-10, 2.395575799972692e-10, 1.6615400029578973e-10, 1.1473616341600575e-10, 7.888210349929797e-11, 5.399397238671244e-11, 3.679600885692664e-11, 2.4965759780535885e-11, 1.686465647701201e-11, 1.1342240533667929e-11, 7.59466909380626e-12, 5.06299533216203e-12, 3.36043047892033e-12, 2.220604156223336e-12, 1.460954062346998e-12, 9.569561120730627e-13, 6.240793244661887e-13, 4.052152553369018e-13, 2.6196627339106577e-13, 1.6863924889955557e-13, 1.0812596062727209e-13, 6.909246898497551e-14, 4.407213068313844e-14, 2.817965324016544e-14, 1.8250513922283737e-14, 1.2271422669538055e-14, 9.010781902168653e-15, 7.788770029013387e-15, 8.348785435264685e-15, 1.0808556091887567e-14, 1.568259728070787e-14, 2.3979842981244692e-14, 3.739298801981403e-14, 5.861123194427245e-14, 9.180788843537391e-14, 1.4338145669664933e-13, 2.2306686352951489e-13, 3.455875717943426e-13, 5.33095792792719e-13, 8.187562637625731e-13, 1.2519813910303148e-12, 1.9060388683373703e-12, 2.889049863569262e-12, 4.359806906358641e-12, 6.550406063842535e-12, 9.798461079023034e-12, 1.4592717492343312e-11, 2.163730274057301e-11, 3.194175014664065e-11, 4.6946469015957937e-11, 6.869668746972345e-11, 1.0008230438481846e-10, 1.4516684368604232e-10, 2.0963616653755905e-10, 3.0140719977042593e-10, 4.3144920422037216e-10, 6.148856529771532e-10, 8.724643392321777e-10, 1.2325077170824826e-09, 1.7334856346102324e-09, 2.4273895851450593e-09, 3.384132501012366e-09, 4.6972521186143505e-09, 6.491260236510729e-09, 8.931055894710467e-09, 1.2233908605372807e-08, 1.6684618987820253e-08, 2.2654578831920058e-08, 3.062558049288616e-08, 4.1219365597544224e-08, 5.523405330977864e-08, 7.368874560518853e-08, 9.787776637158493e-08, 1.294361461311259e-07, 1.7041810618590504e-07, 2.233904141871005e-07, 2.91542564283386e-07, 3.7881576342592685e-07, 4.900526630207396e-07, 6.311696417104002e-07, 8.093531987266391e-07, 1.0332816350662432e-06, 1.3133726587368053e-06, 1.6620568287147696e-06, 2.094075831004372e-06, 2.6268034447645e-06, 3.280585698956659e-06, 4.079095141250868e-06, 5.04969235302578e-06, 6.223785872609035e-06, 7.637179574264069e-06, 9.330394350797272e-06, 1.13489487391608e-05, 1.3743581005709115e-05, 1.657039328316025e-05, 1.9890896753042463e-05, 2.3771935736134174e-05, 2.8285468037697128e-05, 3.3508179144210024e-05, 3.9520909027951444e-05, 4.6407872514455533e-05, 5.4255657510240266e-05, 6.315198994441792e-05, 7.318426007283131e-05, 8.443781179821848e-05, 9.699400478285368e-05, 0.00011092806821156569, 0.00012630677487171315, 0.0001431859744508427, 0.00016160803524434465, 0.0001815992533889584, 0.00020316729782486796, 0.00022629876694426273, 0.0002509569388094778, 0.00027707980044122514, 0.0003045784425577029, 0.0003333359039347361, 0.00036320654400373353, 0.0003940160132837142, 0.00042556187877661265, 0.00045761494572299396, 0.0004899212984656303, 0.0005222050621120998, 0.0005541718638894977, 0.0005855129493398443, 0.0006159098847134543, 0.000645039754042669, 0.0006725807384066953, 0.0006982179467900685, 0.0007216493535784192, 0.0007425916878904012, 0.0007607861152114439, 0.0007760035525695503, 0.0007880494649412836, 0.0007967680026167702, 0.0008020453565550446], \"xaxis\": \"x1\", \"yaxis\": \"y1\", \"mode\": \"lines\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"marker\": {\"color\": \"rgb(31, 119, 180)\"}}, {\"type\": \"scatter\", \"x\": [5.9446733372572105, 16.054158607350097, 16.658733936220845, 13.97804054054054, 14.680764538430255, 18.62396204033215, 22.80501710376283, 11.607142857142858, 13.031914893617023, 21.853856562922868, 16.65043816942551, 14.180374361883155, 10.181582360570687, 16.277807921866522, 20.364126770060686, 18.164967562557923, 16.16650532429816, 22.774708410067525, 20.624631703005306, 16.222760290556902, 22.767857142857142, 13.553474618038445, 14.140773620798985, 19.228817858954844, 16.044399596367306, 13.138686131386862, 14.958863126402393, 15.760441292356187, 19.81566820276498, 15.267175572519085, 15.18324607329843, 13.623978201634875, 19.9203187250996, 11.841469308844852, 18.391451068616423, 14.962593516209477, 12.262415695892091, 18.13349084465446, 12.359550561797752, 15.98976654940838, 13.965087281795514, 14.547537227949597, 21.951219512195124, 13.636363636363638, 18.421052631578945, 16.402405686167302, 22.492127755285647, 18.51851851851852, 7.180385288966725, 16.629711751662974, 19.936204146730464, 25.26724975704568, 14.938236139040505, 15.694164989939638, 16.97965571205008, 18.009235505387377, 7.892659826361484, 5.679666792881484, 15.658362989323843, 13.942407292314066, 15.82060128141942, 14.482259232440258, 17.96733212341198, 20.55768179332969, 15.008527572484368, 15.687250996015937, 15.01519756838906, 32.57328990228013, 9.935739001482945, 13.924050632911392, 16.38935108153078, 17.57469244288225, 11.69024571854058, 19.77848101265823, 14.935505770536322, 11.893434823977165, 17.1875, 14.705882352941178, 13.181019332161686, 15.6737998843262, 15.432098765432098, 20.408163265306122, 18.17279046673287, 15.299877600979192, 12.703379224030037, 14.843525696238874, 15.349194167306218, 21.88183807439825, 23.674625657628486, 14.177693761814744, 10.355540214014498, 15.562472209871055, 17.391304347826086, 26.348039215686274, 14.285714285714285, 11.77495643515061, 14.662756598240467, 12.468827930174564, 14.27891480247501, 12.03852327447833, 22.026431718061676, 19.505851755526656, 5.643340857787811, 15.521855486173058, 19.50286806883365, 10.677083333333332, 19.814543679843826, 17.017056723522412, 20.614035087719298, 27.952480782669458, 21.428571428571427, 13.793103448275861, 10.506960861570791, 10.647181628392484, 15.558148580318942, 20.219526285384173, 16.93952555963916, 14.084507042253522, 14.481094127111827, 12.12624584717608, 19.760479041916167, 12.518628912071533, 17.53155680224404, 12.539184952978058, 20.192307692307693, 14.093959731543624, 17.370892018779344, 13.774104683195592, 17.57469244288225, 9.55302366345311, 7.8616352201257875, 13.961519486926493, 13.428827215756492, 16.31321370309951, 17.798466593647316, 14.688601645123384, 19.36108422071636, 14.13427561837456, 12.5, 20.89665653495441, 20.034344590726963, 19.533527696793005, 12.138868657441128, 18.484288354898336, 13.998782714546559, 17.964071856287426, 7.296137339055794, 13.732097725358045, 17.68916155419223, 26.63115845539281, 17.768301350390903, 15.232292460015232, 15.874855156431053, 8.146639511201629, 10.116337885685383, 17.219430485762143, 10.379904504878555, 15.0, 19.49215832710978, 12.128562765312312, 16.27906976744186, 19.747235387045812, 12.338062924120912, 14.482259232440258, 17.133066818960593, 14.192495921696574, 10.789980732177264, 14.191106906338694, 15.203021718602455, 18.814675446848543, 19.681165124975397, 19.987349778621127, 71.0344827586207, 9.98430141287284, 23.781212841854934, 9.45288753799392, 11.179429849077696, 13.812154696132598, 41.66666666666667, 10.2512272596015, 10.620490620490623, 24.21774539219889, 7.717750826901875, 28.05351747949935, 7.398273736128237, 24.166263895601737, 16.74641148325359, 6.5659881812212735, 19.28374655647383, 17.316017316017316, 9.560229445506693, 21.150933871781934, 9.0014064697609, 13.049095607235142, 24.12545235223161, 19.047619047619047, 19.342359767891683, 11.59823706796567, 15.384615384615385, 14.803849000740193, 21.378941742383752, 15.777080062794347, 15.384615384615385, 15.243902439024392, 19.48368241597662, 19.611414693381906, 12.82437006393381, 7.74593338497289, 8.364235681911826, 17.476489028213166, 6.653359946773121, 19.930475086906142, 18.6219739292365, 18.839487565938207, 23.074192403265883, 8.527131782945736, 10.657193605683837, 12.94219154443486, 18.6046511627907, 10.252156602521566, 18.092105263157894, 25.93144560357675, 22.377622377622377, 18.773466833541928, 11.773472429210134, 15.365703749231715, 19.821605550049554, 14.66992665036675, 20.481927710843376, 13.019891500904157, 8.329862557267804, 19.120458891013385, 29.198966408268735, 13.649025069637883, 19.31745009658725, 12.413108242303872, 7.936507936507936, 3.563813585135547, 13.033770583310075, 20.39269720978298, 7.358351729212656, 8.822232024702249, 9.820426487093153, 15.974440894568689], \"y\": [\"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\", \"Percent Tip\"], \"xaxis\": \"x1\", \"yaxis\": \"y2\", \"mode\": \"markers\", \"name\": \"Percent Tip\", \"legendgroup\": \"Percent Tip\", \"showlegend\": false, \"text\": [\"$16.99\", \"$10.34\", \"$21.01\", \"$23.68\", \"$24.59\", \"$25.29\", \"$8.77\", \"$26.88\", \"$15.04\", \"$14.78\", \"$10.27\", \"$35.26\", \"$15.42\", \"$18.43\", \"$14.83\", \"$21.58\", \"$10.33\", \"$16.29\", \"$16.97\", \"$20.65\", \"$17.92\", \"$20.29\", \"$15.77\", \"$39.42\", \"$19.82\", \"$17.81\", \"$13.37\", \"$12.69\", \"$21.7\", \"$19.65\", \"$9.55\", \"$18.35\", \"$15.06\", \"$20.69\", \"$17.78\", \"$24.06\", \"$16.31\", \"$16.93\", \"$18.69\", \"$31.27\", \"$16.04\", \"$17.46\", \"$13.94\", \"$9.68\", \"$30.4\", \"$18.29\", \"$22.23\", \"$32.4\", \"$28.55\", \"$18.04\", \"$12.54\", \"$10.29\", \"$34.81\", \"$9.94\", \"$25.56\", \"$19.49\", \"$38.01\", \"$26.41\", \"$11.24\", \"$48.27\", \"$20.29\", \"$13.81\", \"$11.02\", \"$18.29\", \"$17.59\", \"$20.08\", \"$16.45\", \"$3.07\", \"$20.23\", \"$15.01\", \"$12.02\", \"$17.07\", \"$26.86\", \"$25.28\", \"$14.73\", \"$10.51\", \"$17.92\", \"$27.2\", \"$22.76\", \"$17.29\", \"$19.44\", \"$16.66\", \"$10.07\", \"$32.68\", \"$15.98\", \"$34.83\", \"$13.03\", \"$18.28\", \"$24.71\", \"$21.16\", \"$28.97\", \"$22.49\", \"$5.75\", \"$16.32\", \"$22.75\", \"$40.17\", \"$27.28\", \"$12.03\", \"$21.01\", \"$12.46\", \"$11.35\", \"$15.38\", \"$44.3\", \"$22.42\", \"$20.92\", \"$15.36\", \"$20.49\", \"$25.21\", \"$18.24\", \"$14.31\", \"$14.0\", \"$7.25\", \"$38.07\", \"$23.95\", \"$25.71\", \"$17.31\", \"$29.93\", \"$10.65\", \"$12.43\", \"$24.08\", \"$11.69\", \"$13.42\", \"$14.26\", \"$15.95\", \"$12.48\", \"$29.8\", \"$8.52\", \"$14.52\", \"$11.38\", \"$22.82\", \"$19.08\", \"$20.27\", \"$11.17\", \"$12.26\", \"$18.26\", \"$8.51\", \"$10.33\", \"$14.15\", \"$16.0\", \"$13.16\", \"$17.47\", \"$34.3\", \"$41.19\", \"$27.05\", \"$16.43\", \"$8.35\", \"$18.64\", \"$11.87\", \"$9.78\", \"$7.51\", \"$14.07\", \"$13.13\", \"$17.26\", \"$24.55\", \"$19.77\", \"$29.85\", \"$48.17\", \"$25.0\", \"$13.39\", \"$16.49\", \"$21.5\", \"$12.66\", \"$16.21\", \"$13.81\", \"$17.51\", \"$24.52\", \"$20.76\", \"$31.71\", \"$10.59\", \"$10.63\", \"$50.81\", \"$15.81\", \"$7.25\", \"$31.85\", \"$16.82\", \"$32.9\", \"$17.89\", \"$14.48\", \"$9.6\", \"$34.63\", \"$34.65\", \"$23.33\", \"$45.35\", \"$23.17\", \"$40.55\", \"$20.69\", \"$20.9\", \"$30.46\", \"$18.15\", \"$23.1\", \"$15.69\", \"$19.81\", \"$28.44\", \"$15.48\", \"$16.58\", \"$7.56\", \"$10.34\", \"$43.11\", \"$13.0\", \"$13.51\", \"$18.71\", \"$12.74\", \"$13.0\", \"$16.4\", \"$20.53\", \"$16.47\", \"$26.59\", \"$38.73\", \"$24.27\", \"$12.76\", \"$30.06\", \"$25.89\", \"$48.33\", \"$13.27\", \"$28.17\", \"$12.9\", \"$28.15\", \"$11.59\", \"$7.74\", \"$30.14\", \"$12.16\", \"$13.42\", \"$8.58\", \"$15.98\", \"$13.42\", \"$16.27\", \"$10.09\", \"$20.45\", \"$13.28\", \"$22.12\", \"$24.01\", \"$15.69\", \"$11.61\", \"$10.77\", \"$15.53\", \"$10.07\", \"$12.6\", \"$32.83\", \"$35.83\", \"$29.03\", \"$27.18\", \"$22.67\", \"$17.82\", \"$18.78\"], \"marker\": {\"color\": \"rgb(31, 119, 180)\", \"symbol\": \"line-ns-open\"}}], {\"barmode\": \"overlay\", \"hovermode\": \"closest\", \"legend\": {\"traceorder\": \"reversed\"}, \"xaxis1\": {\"domain\": [0.0, 1.0], \"anchor\": \"y2\", \"zeroline\": false}, \"yaxis1\": {\"domain\": [0.35, 1], \"anchor\": \"free\", \"position\": 0.0}, \"yaxis2\": {\"domain\": [0, 0.25], \"anchor\": \"x1\", \"dtick\": 1, \"showticklabels\": false}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "py.iplot(ff.create_distplot([data['pcttip']], group_labels=[\"Percent Tip\"], \n",
    "                            rug_text=[[\"$\" + str(s) for s in data['total_bill'].values]]))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Role of each data point in the loss\n",
    "\n",
    "Below we plot the contribution of each data point to the loss function (holding $\\theta=15\\%$)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 28,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAZEAAAESCAYAAAA8BeghAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz\nAAALEgAACxIB0t1+/AAAIABJREFUeJzs3Xd4VFX6wPHvpPceQmgKKoeuiCAiilgQUBEEWVfF1Z+s\noisqKuqiK1YsqBQLsALurh0EaVIV7KIgSuegID29QMqkTPn9cSchCUm4CTOTDHk/z5OHzJk7574z\nQE5Oe4/F6XQihBBC1IdfQwcghBDCd0kjIoQQot6kERFCCFFv0ogIIYSoN2lEhBBC1Js0IkIIIeot\nwJs3U0p1B2YBnYHfgTFa6/VVrrEAzwCjgUhgI3Cf1nq76/lHgElASYWXDdJaf+v5dyCEEKIir/VE\nlFIhwFLgXSAGmA4sUUpFVLn0TmAE0BOIBr4F3qvwfHdggtY6osKXNCBCCNEAvNkT6Q84tNYzXI/n\nKqXGAYOBeRWumwN8pLUuUEpFYjQ4mRWe747RENVLRkaez+yutFgsxMeHk5VVgK9sCpWYvUNi9g6J\n2ZCYGGmp6TlvNiIdgB1VyrSr/HiB1k6gQCl1OzAXOAZcBaCUCgMU8IBS6n0gB5istZ5rNgiLxYKf\nj8wE+flZsFgsBARYcDgaOhpzJGbvkJi9Q2I+OW82IuFAYZWyQiCshus/Aj4E7gdWKaXOxhje+g6Y\nAQwHLgSWKqVStNYrzAQRHx+OxVJjo9ooxcSEN3QIdSYxe4fE7B0Sc8282YgUAqFVysKA/Oou1loX\nu759VSl1H3CZ1noh0K/CZd8qpd4DhgKmGpGsrAKf6onExISTm1uAw+EbXWmJ2TskZu+QmA1xcVWn\nro/zZiOyE7ivSpnC6G0cL1DqGSBAa/2E67EFCAJylVLnAwO01i9VeEkIJ/ZwauR0OrHb6xF9A3I4\nnNjtvvEPuIzE7B0Ss3dIzDXzZiOyFghWSo0FZgKjgCRgVZXr1gMfKKU+AXYBEzDmRX4A2gATlVJ/\nAAsxJutvonLvRAghRAWZuVYAEmKqDgadOq8N7LiGpwYBfwWygbHAENcqrJlKqZmu61YA/wQWAanA\nBcBArXWR1no3MBJ4CsgD3gbu0Fpv8tb7EEIIX7PrQC67DuR6pG6vbjbUWm8B+lRTPqbK41kYmxKr\nq2Mpxn4TIYQQJugDOQD07Zbs9rq92ogIIYTwPk/1QkAaESGEOC199s1eFn37Z6Wy/3tpLQBDLj6T\noZe0c8t9fGSxqxBCiLoYdmk7rutz5gnl7mxAQBoRIYQ4bWUdKzqhrGfHJLfew3QjopTyU0r5u75v\nrZQapZTq4tZofFxmrrV8KZ0QQjSkLzYe5IdtqQB0OjOWMdd3JjIskI270t16H1ONiFKqL5AC9FNK\nJQM/Y2Th3aSUGunWiHyYJ5fRVXTgwH4ef/whBg7sz1VXXcrf/vZXli1b5PH7nqo77xzF8uXVL6zr\n2/cC9u79w8sRCXF6+nlHKu+v3g1AhzNiGDfyXHp1TOK50Re6/V5meyKvAR9jbAS8EyjC2Ch4F/C0\n26PyUfpATvlSOk9xOBw8/PD9dOjQicWLV7Bq1Vc8+OAjvPXWdL766kuP3lsI0fj9mXKMV97biNMJ\nrZtFMPaGbvi7cj1FhQVxfd+2br2f2dVZ3YAbtdaFSqkhwCKtdYlSah1GMsTTjs3uILua8cTabN+X\nDUB6juksLADERYUQ4G+uPT96NJeUlMNcddVAgoNDAOjevQf33ns/paWlANjtdmbPnsnixQsJDAzk\nllv+xvTpr/HddxvZtGkj//rXY3z++fEG55prruC5517m/PMvYOPGn5kzZyYHDx6gpKSUXr168+ST\nzxASEsJ9991FcnILfvrpR5TqwOTJ0/j667XMnj2TjIx0lOrIo4/+k7i4zgBs2PAT06a9RlpaCv37\nX0lpacmJb8iEQ4cOMn36a2zZspnIyCiGDr2Bm2++DYvFwoYNP/Hmm1NIS0ulWbMkbrnlb1x99WBK\nS0uZPHkS33//DQEBgXTt2o3x4ycQHR1TrxiE8AVZR4uY8slmikvsxEYG8+CN5xIa7NlFuGZrzwLO\ndM2J9ACecJX3Ao54IrCGZLM7mPDv9WQerVsjUubxWetPflEFCdEhTLqrt6mGJDY2ju7dezBu3D+4\n+urBdO/eg44dO3PddUPLr/nss/l8+eVqZs/+H2Fh4TzxxHhTcVitVp54Yjz/+tez9O3bj/T0NO69\ndzRffLGSa6816t+9excffrgAgB07tvHii8/yyitT6dSpCwsXzuPhhx9g5coVZGdnMWHCeB59dAL9\n+1/J4sULaxzKqk1paSnjxv2D/v2v4PnnXyEl5Qjjxz9AeHg4Q4eO4MUXn+X++x/issuu4JdfNvD4\n4w/Tt++lrFv3Bfv2/cmnny7DYrHwxBOPMn/+x4wePebkNxXCBxUW2Zg6fzNHC0oIDfbnob+cS2xk\nsMfva3Y4azawGGM463fgS1cOrP8BUz0Um6jBq69OZ8SIv7Bp00YefngsgwdfzsSJEzh61JiPWbv2\nC0aMuIkWLVoSExPDXXf9w1S9QUFBzJ37AX379iM/P5/MzAyio2PIyMgov6ZPn0uIiIggIiKCzz9f\nwsCB19Kt23kEBAQwcuTN2O12fvrpJ77//jtat27NVVcNJCAggOHDR9KqVes6v9fNm38lLy+Pu+76\nB0FBQZxxxpncfPNtLF++rDzmNWtW8ssvG+jW7TxWrfqK8PAIgoKCOXToICtWLCM3N5fJk6dKAyJO\nWza7g7cXbeVwZgF+FguP3daTNkmRXrm3qZ6I1vpppdRvwJkYpw46lFJ7gBFa6889GWBDCPD3Y9Jd\nvU0PZ6VlFzJl/pZKZeNGdiMptqajUiqry3AWQHBwMCNH3szIkTdTXFzMli2/MWPGG7z44rO89NLr\n5Obm0KxZs/LrW7VqZapef39/vv/+Gz75xEisfPbZ51BUZMVR4WSb+Pj48u/T0lLZtOkXVq5cVl5W\nWlpKSkoKWVlZJCQcjwGgefO6p1zIyckmMTGRgIDj/1SbN08mI8NYYfLaa28wZ84sJk6cQHFxMUOG\nDOOee8YyYMAgCgoKWL58CdOmvUq7dmcxfvwEOnWSBYXi9OJ0OvnfKs2OfcZ87G0DFT06JJGdXe0p\nG25nerBMa12+/EcpFY6RALHqSYWnjQB/P5qZbAR+2JZKZFggtw5QALy/WrP3SB5d2yW4Pa4vv1zN\nzJlvMW/eIiwWC8HBwfTseSElJSW8/vrLADRv3oLU1JTy12RmHj9d2N/fn9JSW/ljm81GQUEBAFu3\nbmbu3Hd4553/0rp1GwDuv7/yb+8VD/SKj0/g5ptHVfoN/8iRg7Rv35ZPP/2MtLSUSq/NzMygrpKS\nmpOZmYnNZitvSFJSjhAbG0dJSQlHjhziqaeew+l0sm3bFiZMGE/Hjp1QqiM9elzAsGEjOHo0l3ff\nnc3zz08sH4oT4nSx7Mf9fLfF+L82uPcZ9D+/pVfvb3aJbyel1C9Kqb5KqRhgE/A1sF8p1d+jEfqI\n50ZfSM8OzejZoZlHltGVueCCXlitBUyb9ho5Odk4nU4OHTrIp59+zMUXXwLAddddz7x5H7F//z4K\nCwuYM2dm+etbtmxFUZGVX37ZgN1u5/33/4PddcBKQUEB/v5+BAcHY7fbWbFiGZs3/4rNZqs2loED\nr2Hp0s/QehdOp5Ovv17HLbeMJCUlhYsvvoS0tDSWLl2EzWZj6dJF7Nv3Z7X1lMnOziY9Pa38Kycn\nh06duhAXF8c778ygpKSE/fv38eGH7zFgwEAsFgsTJz7B0qXG7zeJic2wWCxER0fz7bdf8/TTT5Cd\nnUVkZBShoaFER0e7469AiEbjx+2pfPbNXgB6dWzGDf3ctxPdLLM9kTeAPRhnov8fEAUkYyz3fRVj\nsr3JqppCwBPL6MpER8fw9tuz+fe/ZzBq1F+wWguJjY1jwIBB3HHH3wHo3/9KMjMzeeih+3A6nVx6\n6fF2PiEhkXvuuZ8XXniaoqIirr12COecY/SgevXqTf/+V3LbbTfh7++HUp0YNOha9u/fV20s3bv3\n4L77xvHcc0+RlpZK8+bNee65F2nXrh3Z2fm88soUXn/9FaZNe5ULLuhFt27n1freHnzw3kqPu3Y9\nlxkz5vDyy1OYOnUyQ4ZcTUhICMOGjWDkyJvx8/Pj+edf5s03pzB9+uuEhYUxYsRf6NmzN927X8CR\nI4e47babKC4uRqkO/POfE0/hkxeicdEHcnh3+U4Azm4VzZ3XdMSvAY7+tjidJz/5SilVAHTRWv+p\nlPoa2Km1HqOUOgPYpbV2/0knHpKRkeczx5P5+1uIi4sgOzv/lE4o27v3D2677Sa++26jG6Ornrti\n9iaJ2TskZvdJySpg0nu/UFBko1lsKE+M6kFkWBDgmZgTEyNrbJ3MzubmA3FKqUSM80CWu8oVUPeB\nbiGEEPVyrKCEqfM3U1BkIyI0kHE3nlvegDQEs8NZC4D5gBWj0ViplLoZmIZx1K0QQggPKym1M33B\nFjJyiwjw92Ps8K4kxZlbAOQpZnsiYzFyZa0BrtBal7he+zTGUbWiEWvX7myvDGUJITzH4XTyztId\n7D1yDIDR13bknFYNn4HB7D4RO65NhUqpZq4kjB9qrR21v1IIIYQ7zF/3B7/sNmYPRlx2Fr3cnNK9\nvuqSCv4RpVQmRjbfQ0CmUup5j0UmhBACgLWbDrHq54MA9DuvBYMubNPAER1nqieilPoXcD/wJPA9\n4A9cDDytlMrTWr9ssp7uwCygM0b6lDFa6/VVrrEAzwCjgUhgI3Cf1nq72TqEEOJ0sfmPTD5YY6R1\n79IujlsHtK+06behme2J/B34u9Z6ptZ6q9b6N631W8DdgKmEREqpEGAp8C4QgzHHskQpFVHl0juB\nEUBPIBr4FnivjnUIIYTP25+ax8zF28vTut9zfZfytO6NhdnVWbHA9mrKtwHNTdbRH3BorctSx89V\nSo0DBgPzKlw3ByM/V4FSKhKjscisYx01slgseOrvINNqpIJPCI1zS31+fpZKf/oCidk7JGbvaMiY\ns44WMe3TzRSXGmndH/rLuUSEBZ70dd6O2WwjshGjN/JolfK7gN9M1tGBE3NtaVf58QKtnUCBUup2\nYC5wDLiqLnXUJj4+3GNdwS1/bgWgfUv3jlfGxIS7tT5PS01NJSEhoVLSRF/ga58zSMze4u2YC6yl\nTJvzM7n5Rlr3Z+66iLYt6pa2x1sxm/1f/iiwTil1OfCTq+xCoD1GL8CMcKDqaU2FQE2LnD8CPsSY\ni1mllDq7HnWcICurwGM9kU0Hjc5at+iubqnPz89CTEw4ubkFOBzV7zx95pl/8cUXq1m4cBmJiYkA\nzJ49i7179zBp0ituiQPguecmEh0dw/33j6v1upycbIYPH8Ly5WsICalbIgOz93A3M59zYyMxe0dD\nxGyzO3j9k83sT83Dz2LhnqFdiA7xN52V1xMxx8XVPGNgdonvBteE9t1AR4zjcVcBQ7TWZg+lKgSq\n/lQJw9gNX909i13fvqqUug+4rK51VMfpdOLKN1grm8NGTtFRs9UCsDPrdwBS8zJPcmVlsSHRBPjV\n/FfhcDirTV9w7Ngxvv/+O/r3v5KFCz8tz6brcDhd79N9/+idTuPrZHUWFRVhtVprjNkd9/CU+sTc\n0CRm7/BWzE6nk/+s2MX2P42h8Vuvbk+XtvH1ure3Yq5LKvjfgUcqlimlwpVS3bTWW2p4WUU7gfuq\nlCmM3kbFOp8BArTWT7geW4AgINdsHafK5rDx7PrJZBXV77z0p9ebWqxWLj4klqd6j6+1IanOypWf\nc9553bnhhht54olH+dvf7iQw0BgzPXbsGI89No5ff93EGWecweOPP8VZZ51d67Gx2dlZTJ/+Ohs2\nrCc4OIQrrxzA6NH3EBRUOaXCCy88TXR0DPfd9yAA33//LVOmvMKnny7l9ttvBeDaawfw1lvvcNZZ\n5/C//83l88+XUFRURJ8+fXnggYcJD6/bWgibzca7777D8uVLKSkppnv3Hjz44HgSEhLJy8tj0qSn\n+e23XwkLC6NnzwsZN+5RgoODWb16JXPnziI3N5dWrVpz11330qtX7zrdWwhv+fzH/XzrSus+qHcb\nLjvPu2nd6+NUB3b6Ar+avHYtEKyUGquUClRK/R+QhNGjqWg9cI9SqptSKgiYiDEv8kMd6mgSli79\njGuuGULXrucSExPDunVflD/366+/MHjwdSxf/iUXX3wpjz/+EDabjVWrPi8/NvaTTxZhtRYxf/7H\nAEyYMB6LxcL8+UuYNetdfv31F+bMmVWnmP7zn/cBWLZsNe3bd+CTTz7g66/X8dZb7zBv3iKKi4uY\nMmVynd/rnDmz+O67r3n77dksWPA5kZFRPPnkYzidTj7++H38/PxYsmQV7777IVrvZM2aFRQVFfHi\ni8/w9NOTWLlyHcOGjeDll5/HTNJRIbxt/fZUFrrSuvfs0Izh/c5q4IjM8drMp9a6WCk1CCPX1iTg\nD4zhsAKl1EzXNWO01iuUUv8EFmGszPoBGKi1LgKoqQ53xhrgF8BTvcebHs5KL8zg7S1zK5Xd2+1O\nmoWZO5TqZMNZ1dm6dTP5+flcdFFfAIYOHcGCBfMYMGAQAD17Xki/fpcDMGrUHcyb9xHbt2+tdGxs\nnz6XMHnyVPz8/Dh8+BDbtm3hpZdeJywsnLCwcEaPvocXXniae+4ZW6fYKlq2bDF3330fSUnGIr57\n7rmfkSOvZ/z4CQQHmz//edWq5YwdO47k5BYA3H//wwwceBkHDuwnKCgIrXfxxReruPDCi5gzx2hU\nioqKCAoKYsmShdhs13H11YMZPPi6RrXGXggw0rrPLUvr3jKa0dc2TFr3+vDq8hnXsFefasrHVHk8\nC2NDoek63C3AL4DEsPiTXwj8nPoLEYHh/EUNA+AT/Rn78g7QOUF5LL4lSz7j6NFchg0z1jXY7TaO\nHj3Krl3GP8SkpONH0fr7+xMfH09mZmaNx8Y6HA5CQ0OJiTmei6d582Sys7NqPJTKjLS0VJ5/fiIv\nvvhMeVlAQABpaam0aXOG6XpycrLLGxDAdchUDOnpadx66+0AfPTRe7z44rN063Yejz32JK1bt2H6\n9Fn8979zePjhsQQEBHDTTaMYNer2er8fIdwtJauANxduxWZ30iw2lLHDuxIY4N/QYZnmW2swG7En\nL3yYyCBjnP+cmHZ8c/hHj90rPz+ftWvXMHXq27Rsefz89GnTXmPBgk9cP/yPT+7bbDYyMjJo3jyZ\ngwcPVHts7LRpM7BarRw9mkt0tNGQHDlymKio6BOW6vr5+WGzlZY/Pnas5h5bfHwCjz32JD169CyP\n5ciRQ5XiNiMpqTmpqSl06NAJgMLCQo4ezSUuLp69e/dw9dXX8Le/3UlmZgbTpr3GlCmTee65Fyks\nLGDSpMnYbDY2bvyZCRMeoXv3HnTp4p4VdEKcimOFjSute33UOCeilGp/si+gbj8JTlPXtBtQ3oAA\nRAZFcE3bq2p5xalZtepzWrVqQ7du5xEfn1D+de211/Pll6s5ejSXn39ezw8/fEdpaSlz5/6bpKQk\nOnToWOOxsYmJzejRoxfTp79GYWEhGRnpzJkziwEDBp5w/9at27Bp00by8/PJyclm0aLj55aXTeyX\nnds+aNC1vPvuO+XnpP/732/z8MMP1DgvYbUWVjoiNz09DbvdzsCB1/Cf/8whNTWVoqIi3njjdc48\nsx3t2p3F0qWf8eqrkygoyCc6Oobg4GCio6OxWot4+OH7+emnHwkICCA+PgGwEBUV5f6/FCHqqKTU\nzhufNq607vVRW09kF+AEahqYK3tOZim9bMmSRVx55dUnlF9wQS+io2NYunQRvXv34cMP/8fEiRPo\n3LkLkya9ir+/PyNH/rXGY2MnTnyOadNeZeTIIQAMGDCIu++uuhgOrr9+ONu3b2XEiOuIjY1l2LAR\nzJv3EWD0PPr168fIkUN55ZWpjBp1B6Wlpdx99+3k5+fRvn0HXnllSo0bERcvXsjixQsrlX388Wfc\neuvtFBcXc++9d1JQkM/551/A5MlTsVgs3HXXP3jllRe48cbrsdlsdO9+Po899iRxcfH861/PMH36\na6SnpxETE8tDDz1ap2E0ITzB4XTyzrId7Glkad3ro8bjcV1H35qitd7vtog8rCkej+tNErN3SMze\n4amY5639g5U/HwCMtO6De7vvFxtvH49bY0/ElxoGIYTwFWs3HSpvQC49t3Glda+PxpUOUgghTmOV\n0rq3bXxp3etDGhEhhPCCimndWyVGcM/QLgT4+/6PYN9/B0II0chlHytiqiute0xEEA/e2I3Q4NNj\nh0Wd3oVSqgVGrqr1QJTWOs0jUQkhxGmisMjGlPmbOZpfQnCQPw/eeC5xUSENHZbbmD0eNxzjsKiR\ngAMjBfzrSql44AatdYbnQhRCCN9kszuYsWgrhzMKjLTu13ehTVJkQ4flVmaHs17B2FjYAbC6yv4J\nhABTPBCXEEL4NKfTyXurNNv3GdnAbx3Qnm5nmUul5EvMNiLXA+O01rvLCrTWOzHOVz9xS3MTVZqZ\nQWmmdMpSU1NPKd+WEKeD5esrpHW/sA2XdW/8ad3rw2wjEoWRjr0qB3DyQ3+biEK9i0K9y6v3fO65\nf3HZZb3JrNB4zZkziyefrHqS8al54YWnefPNqSe9Ljs7i4EDB1JSUuKxewjR2K3fkcqCr4207hd0\naMbwy3wjrXt9mG1EVgNPKKXKUks6XfMhrwBrPBKZD7LqXVi92IgcO3aMH374nv79r6yUv6ohFRcX\nY7VaT36hEKep3Qdzmft5hbTu1/hOWvf6MLs6ayzwGZCBcRztSow5kp3A7R6JrIE5bTZKs7Pr9JqC\nHTsAKElPr9PrAuPisNSQS6o2crKhnGwoGpeUrALeWLDFSOseY6R1Dwr0nbTu9WH2jPUUoLdS6nKM\nM9YDMBqQNVpr30iCUwdOm40/n3wcW2bdzkovs29C3YaSAhISaPv8S3VuSJYu/Yy77/5HpZMNyw6l\n+vXXX3j++Zd54YXJvP/+f3j88Yf46KOFlU42tFgsPPHEo8yf/zGjR49hwoTxJCe3YP78JRQUFDBh\nwiPMmTOrTodS/ec/73PDDdexbNlqgoND+fDD/5WfbBgZGcnLLz/PlCmTefLJZ05eWQVz5szihx++\n5e23ZxMbG8e0aa/y5JOPMWPGnEonG1qtVh54YAxr1qzgyisH8uKLzzBjxlw6dOjI558v4eWXn+fT\nT5f6/C5h0fhUTOseHhLAgyN9L617fdRps6HWeq3W+i2t9TSt9erTsQHxFTWdbFim7GTDgIAARo26\ng4KCghNONszNzWXy5KmMHj2m/GTDBx54hLCwcBITmzF69D2sWLHslOJctmwxd9zxd5KSmhMWFs49\n99zP6tUrKC4urlM9q1Yt5/bbR5Oc3IKQkBDuv/9hdu7cfsLJhjZbKXPmvM+11w4FKD/ZcNu2LVx9\n9WBpQIRHlJTaeWNBWVp3C2OHd6O5D6Z1rw+z+0Qc1JzyvQQ4DHwMTNRa290UW4OxBATQ9vmXTA9n\nlaSlcmTa65XKWjzwMEFJSaZeX5/hLDnZUE42FI2Dw+lk9rId7DlsrD2685pOtG/tm2nd68PsT667\ngeeAiUDZkX29gGeAdzCGtv6Fcb7IE26OsUFYAgIIatbM1LXHfvwe/8hImt0yCoD0D96j+M89RHT1\nzOl5crKhnGwoGo9Pv9rDRtd+6+H92nFhJ3O/PJ4uzA5nPQLcqbWepbXe4vqaDfwfcJPW+hOMhua2\n2ipRSnVXSv2slCpQSv2mlKp2hlMp9Xel1O9KqWNKqQ1KqUsqPPeIUqpEKZVf4euS6urxpjOefYHI\nC3oReUEvznj2BY/eS042lJMNReOwbtMhVv5UltY92a3ngvgKsz2RlsDeasoPAmXJ8A8BcTVVoJQK\nAZYCLwCzgVHAEqVUO611foXr+gOTgKuALa7rliqlztJaZwHdgQla61dNxu5xCdcPq/Q4IDKK+CFD\nPXY/OdlQTjYUDW/Lnkzed6V179w2jlsHqCY531bjyYYVKaVWAqXAbVrrHFdZDPBfIExrfZVSapzr\n+e411DEImKW1blOhbCvwnNZ6XoWyUUCy1vqVCmVZwDCt9TdKqR3A/VrrL+rxfuVkQw+TmL1DYvaO\nmmLen5rHSx9sorjUTqvEcP55a49Gk5W30ZxsWMVdwHLgsFJqD8YwWFtAAzcopQZi9B5G1FJHB2BH\nlTLtKj9eoPV7FR8rpS4GIoEdSqkwjCzCDyil3gdygMla67km3wcWiwU/H0mA7+dnqfSnL5CYvUNi\n9o7qYs46VsS0T7e40roH89BN5xER1ngSd3j7cza7T+SAUupc4AqgK0avZJvWei2AUiofaK21rm1j\nRThQWKWsEGPzYrWUUp2ABcBTWutMpVRb4DtgBjAcuBBjqCtFa73CzHuJjw/3uS5nTEx4Q4dQZxKz\nd0jM3lEWc2FRKdPnbiA3v5jQYH+euesi2rWMbuDoquetz9l0/0trbVdKfQl85SqyKKWigB5a63Um\nqigEQquUhQH51VyLUmoA8Anwmtb6JVcMfwL9Klz2rVLqPWAoYKoRycoq8KmeSExMOLm5BTgcvtH9\nl5i9Q2L2jooxl5TamTJvM/tSjmGxwD1DuxAT6k92drU/whqMJz7nuLiaM0yY3SfSD5gFnFPN06UY\nKeFPZidQdZZWAR9Wc787gGnA3VrrjyqUnw8MKGtUXEI4sYdTI6fTid3HdrI4HE6fGUMuIzF7h8Ts\nHXa7g/+u2MW2vcbesVsHKLq0jW/U78Nbn7PZnsgUYBdGI7AQYylvC+BZ4B6TdawFgpVSY4GZGKuu\nkoBVFS9SSl0BvI3RWHxbpY58YKJS6g9XHP2Bm6jcOxFCCLf6/Mf9fLPZSOs+8MI29D9N07rXh9mB\nnU4Yy2q/ADYBVq312xiNyiNmKtBaFwODgL8C2RhJHYdorQuUUjOVUjNdlz4GBAErquwFGeg6z2Qk\n8BSQh9HY3KG13mTyfQghRJ188+sh5q/bA8AFKpERp3Fa9/ow2xMpAsqSHWngXIwexA/Av83eTGu9\nBehTTfk2n2nWAAAgAElEQVSYCt8POEkdSzH2mwghhEftPpjLlI9+BeCsllGMvrbTaZ3WvT7M9kS+\nAyYopSKBjcBQ19kiF1PDxLgQQviy1OxCps7fjM3uIDEmlLHDu532ad3rw2wj8jDQF2O/yPscP+nw\nfeBNz4QmhBAN41hhCVPnbabAaiMyLJBHbjqPqCaQ1r0+zDYiVq21AmZora0Y+zNGAX201pM8Fp0Q\nQnhZWVr39FwrAf4WnrjjQprHN4207vVhdk5kvVJqiNZ6I4DWugBjdZQQQpw2HE4nsz/fWZ7WffR1\nnejcLr7R7QVpTMz2RI5h7DgXQojT1oKv9rBxl3G89fB+7bioc/MGjqjxM9sTWYOx5HYNRjZfa8Un\ntdYT3B2YEEJ407pfD7PCldb9km5NM617fZhtRLoAP2FMqJ9X5bnGu2VTCCFM2LIni/dXawA6nxnL\nqKubZlr3+jCbgLG/pwMRQoiGcCAtjxmLt+F0QqvEcO4Z2pUAfx9JsNcImE7AqJTqDDwAtAduAYYB\nWmu9xkOxCSGER2UfK2Lq/M0Ul9iJjgjiwRvPJSykcZwL4itMNbeufFYbMCbXewPBGLmzliul/uK5\n8IQQwjOsxTamzt9Cbn4JwYH+PDjiXOKizOSSFRWZ7bNNAsZrrW/ByNpbNpk+HiOPlRBC+Ayb3cGM\nRds4lJHvSuvemTOaRzZ0WD7JbCPSherP61gCtHNfOEII4VlOp5P3V2u2/Wmkdb/lqvZ0OyuhgaPy\nXWYbkcNAt2rKLwcOuC8cIYTwrOXrK6R179WGy89v1cAR+TazM0gvAv9WSp0F+AMDlVJnAv/AmGwX\nQohG7+edaSz4ei8APVQiI/pLWvdTZaonorV+F7gdGAIUAC9gJGS8RWs922PRCSGEm+w+mMvsZTsB\nOKtFFH+XtO5uYfZ43HO01suB5R6ORwgh3C4tu5A3FmxxpXUPYewISevuLmaHs3YppTZhnIf+sdY6\nxYMxCSGE2xwrLGHKvM0UFNkIDwngwRvPlbTubmR2Yr0dMA/jaNsDSql1Sqm/K6ViPReaEEKcmlKb\nnTcXbC1P637fDV1Jjpdcsu5kdk5kv9Z6sta6F8aO9eXA/wFHlFKLPRmgEELUh8PpZPaynfxx+CgA\n/ze4I6qN/N7rbvXZ358JpACHMPaPtDD7QqVUd2AW0Bn4HRijtV5fzXV/Bx4FkjDOdH9Ia/1tXeoQ\nQjRtC77ewwZXWvcbLm1Hb0nr7hFm055EKaVGKaWWAOnAk8A2oIfWuqfJOkKApcC7QAwwHViilIqo\ncl1/jB3yN7quexNYqpSKN1uHEKJp++rXw6xYfzyt+zUXSVp3TzHbE0nH6IHMA54tO+GwjvoDDq31\nDNfjuUqpccBgV71lWgGTtda/uR7/Vyn1OkbPI9xkHUKIJspI674bgE6S1t3jzDYig4F1WusTzg5R\nSvXUWm8wUUcHYEeVMu0qP16g9XtV6r8YiHS9dpSZOmpjsVjw85Esz35+lkp/+gKJ2Tsk5uodSMtj\n5uJtOJxOWiWGM3Z4N4KD6r+UVz7nkzN7nsjaio+VUokYP9DvADph7GI/mXCgsEpZIRBW0wuUUp2A\nBcBTWutMpVSd66gqPj7c534riYnxvdUkErN3SMzHZeZamTp/C0UlduKignnm7j40izX9o6FW8jnX\nrC7nifgD12I0HIOAQOAH4FaTVRQCoVXKwoD8Gu43APgEeE1r/VJ96qhOVlaBT/VEYmLCyc0twOHw\njQMkJWbvkJgrsxbbeOF/v5B1tIjgQH8eGNGNAKeD7GzTPxqqJZ+zIS6u5mnnkzYiSqkuGA3HLUAi\nxvxIAHCtaxe7WTuB+6pWj7GBseo97wCmAXdrrT+qTx01cTqd2O1mr24cHA4ndrtv/AMuIzF7h8Rs\npHV/c8FWDqYbad3HXN+Z1s0i3XoP+ZxrVmMjopS6F6Px6IGRqfdjjKGl74FiYF8d77UWCFZKjQVm\nYgyHJQGrqtz3CuBtYEDZst661iGEaBqMtO67K6V1P/dsSevuTbX1RN7E2Idxs9b644pPKKXqfCOt\ndbFSahDGD/9JwB/AEK11gVJqpuuaMcBjQBCwosp9RmitV9ZUR50DEkL4vBU/HeCbzUcAuLpXa0nr\n3gBqa0T+AdwMfKCUmgIsAhYC6+p7M631FqBPNeVjKnw/oD51CCGalp93pvHpV3sAI637jf3PbuCI\nmqYap5i11jO01pcAZwFvAJdgDBulu17X3SsRCiFEFb8fkrTujcVJ1ylprfdprSdprbsA5wNzgCPA\ne0qpP5RSj3k6SCGEKGOkdd+Kze4gITqEscMlrXtDqtNiV631b1rr8UAb4ArgK4wcV0II4XF5hSVM\nmb+ZfGsp4SEBjBt5LlHhkta9IdUnASOunevrgHWuVVxCCOFRpTY7byzYSnqOpHVvTE55253WusQd\ngQghRE0cTidzPpe07o2Rj+zdFkI0ZQu/3svPO4207sMkrXujIo2IEKJR++q3wyxfvx+Avt2SuVbS\nujcqdZoTUUq1wEgzsh6I0lqneSQqIYQAtu7N4v1Vx9O63yZp3RsdU42IK3vuHGAk4MA4Ivd1pVQ8\ncIPWOsNzIQohmqIDaXm8vchI694yIZx7h3YlwF8GTxobs38jr2AcFtUBsLrK/gmEAFM8EJcQognL\nyStm2qdbKC6xEx0exIM3nktYSL0WkwoPM9uIXA+M01rvLivQWu8ExgADPRGYEKJpshbbmDp/Mzl5\nxQQH+vPgjecSHx3S0GGJGphtRKKAY9WUOzDOFRFCiFNmdziYsXhbeVr3u6/vzBnNIxs6LFELs43I\nauAJ18FUAE7XfMgrwBqPRCaEaFLK07rvNdK633xle86TtO6NntlGZCzGZHoGxkmCKzHOGIkDHvBM\naEKIpmTlTwf4+jcjrfuAnq25ooekdfcFZs9YTwF6K6UuBzq6XrcTWONKgSKEEPW2YVc688vSurdP\nZOTlktbdV9Q1AeNa4N/ADIzki4FKKcl+JoSotz8OHeWdpTsAaNciitHXSVp3X2J2n8h5wDvAeVRu\neCyAE5A8zEKIOkvLKWT6gi3lad3vH96NYEnr7lPMLryeg7E6awSQ67lwhBBNRV5hCVPmGWndw4Il\nrbuvMtuIdAK6aa1/92QwQoimodRm542FRlp3fz8LY4dLWndfZXZOZDtwpgfjEEI0EeVp3Q+50rpf\nI2ndfVmNPRGl1IAKD5cA/1FKTQL2AvaK12qtV5u5mVKqOzAL6Az8DozRWq+v5fpxwMVa6xEVyh4B\nJgEVzzEZpLX+1kwMQoiGteCrPcfTul/SloskrbtPq204a2U1ZW9UU2ZqYl0pFQIsBV4AZgOjgCVK\nqXZa6/wq14YDE4FHgIVVquoOTNBav3qyewohGpdV6/ex7AdXWveuyVzb58yGDUicshobEa21u9Nl\n9gccWusZrsdzXT2NwcC8Ktd+BhRg9FoSqzzXHXjXzbEJITxs654s3l6wBYCOZ8Ry20BJ6346MLvE\ndy0wTGt9tEp5IrBKa32+iWo6ADuqlGlXeVW3a62PKKWepkIjopQKwzjP5AGl1PtADjBZaz3XzPsA\nsFgs+PlINmk/P0ulP32BxOwdvhbzgbQ83ly4FYfDScvEcMaO6EpwUONfyutrnzN4P+ba5kSuBfq4\nHvYDnlVKFVS57Gygjcl7hQOFVcoKMdKoVKK1PlJDHUnAdxibHYcDFwJLlVIpWusVZoKIjw/3ud9+\nYmJ8b9WKxOwdvhBz1lErU+dvoajETmxkMM/e1YdmcSf8t2/UfOFzrspbMdfWE9kGPISxodACXEDl\nyWwnkA/8zeS9CoHQKmVhrjpM0Vr/idGglflWKfUeMBQw1YhkZRX4VE8kJiac3NwCHA7fyC4jMXuH\nr8RsLbYx6b1fyDpaRFCgH0/d2ZsgPyfZ2ab/2zcoX/mcK/JEzHFxETU+V9ucyD7gcgCl1LvAA1rr\n6tLBm7UTuK9KmQI+NFuBUup8YIDW+qUKxSGc2MOpkdPpxG4/+XWNicPhxG73jX/AZSRm72jMMdsd\nDt5auI0DaUZa93uHduHs1jFkZ+c32phr0pg/55p4K2azCRjvcMO91gLBSqmxwEyM1VlJwKo61JEP\nTFRK/YGxaqs/cBOVeydCiAbmdDr5YM3vbN2bBRhp3bu3r7pGRpwOvDawo7UuBgYBfwWyMdLLD9Fa\nFyilZiqlZpqoYzfGOe9PAXnA28AdWutNnotcCFFXK38+wFe/HgYkrfvpzquHFmutt3B8sr5i+Zga\nrn+6mrKlGPtNhBCN0IZd6cxfZ6R1P799IiP7S1r301mNPRGl1F1KqZpnU4QQooqKad3bJkfx9+s6\n+dTyWFF3tQ1nTQXiAZRSdteeECGEqNYJad1HSFr3pqC24ax9wAKl1FaMJb7TlVLW6i7UWv+fB2IT\nQviIfGspUyukdX/wxnOJlrTuTUJtPZHhwAYg2PU4BGOfR3VfQogmqtRm540FW0hzpXW/74autEjw\nvc15on5q2yeyE7gHQCmVjLEKSg6kEkKUK0vr/ntZWvfBHelwhqR1b0rM7hPpr5SyuFKhdMLI2rsL\nWKG1LvJkgEKIxuuzb/aWp3UfeklbLuoiad2bGrMJGFsBnwNnYSRN9AfOAQ4rpfprrQ97LkQhRGP0\nzeYjfP6jkdb94q7NuU7SujdJZjcbvgmkAm201j201ucBZ2BMvk/xUGxCiEZq259Z/G+lBoy07n8b\n2MHnEpsK9zDbiFwBPKK1zi4r0FpnAuOBATW+Sghx2jmYns/bn23D4XTSIiGcfwzrQoC/j2Q1FW5n\n9m/+GNWkbHeVOdwXjhCiMcvJK2bq/M0UldiJDg/iwRu7ERYS2NBhiQZkthH5DHhbKdW5rEAp1RVj\nmGuxJwITQjQu1mIb0+ZvJievmKBAP+4f0Y2EaFnh39SZzZ31T4ysuVuVUmVp10OBJcCDnghMCNF4\n2B0OZi3ZzoF0I637mCFdaJsc1dBhiUbA7BLfPOAqpVQXoCNQBOzSWv/uyeCEEA2vLK37lj1GWve/\nXnEO552T0MBRicaiTll8tdbbME48FEI0Eat+Plie1v2qC1pz5QWtGzgi0ZjIkgohRI027kpn3ro/\nAOh+TgJ/uVzSuovKpBERQlTrj8NHeWdZWVr3SO4a0lnSuosTSCMihDhBek4h0z/dQqmtLK37uZLW\nXVTL9JyIUsofaA0EYqSGL+c6tlYIcRrIt5YyZf4WSesuTDGbO2sQMAdIchVZAGeFP+VXFCFOA+Vp\n3bML8fez8A9J6y5OwmxPZCrwPfAsxu71elFKdQdmAZ2B34ExWuv1tVw/DrhYaz2ivnUIIcxxOJ3M\nXb6rPK37HYM70FHSuouTMNuItAEGaq3/rO+NlFIhwFLgBWA2MApYopRqp7XOr3JtODAReARjk2Od\n6xBC1M2ib/fy0440AIb2bUufLskNHJHwBWYn1n8CepzivfoDDq31DK11qdZ6LpAGDK7m2s8wUs3P\nOoU6hBAmfbP5CMt+cKV179Kc6y4+s2EDEj7DbE/kU2CWUuoSjCGkkopPaq3/baKODsCOKmXaVV7V\n7VrrI0qpp4HEetZRLYvFgp+PrEkrW07pS8sqJWbvcGfMW/ceT+ve6cxY/u/ajh7JytvUP2dv8XbM\nZhuRhzHmQoZU85wTMNOIhAOFVcoKqSY7sNb6yKnWUZP4+HCfO/cgJsb3JjYlZu841Zj3pRzjrYVG\nWvfWSZH8a/RFRIR6NitvU/ycG4K3YjabO6utG+5ViJG0saIwoC5zGadcR1ZWgU/1RGJiwsnNLcDh\ncDZ0OKZIzN7hjphz8op59t0NWIttRIcH8cCIrpRYi8m2Frs5WkNT/Zy9zRMxx8VF1PhcXfaJWIBr\nqP8Z6zuB+6pWC3xoNgZ31OF0OrHb63DHRsDhcGK3+8Y/4DISs3fUN+aiEhuvf/Ib2RXSusdFhnjl\n/Telz7kheStms/tEWgPLOLUz1tcCwUqpscBMjJVVScCqOsTrjjqEaNLsDgczF2/nQFo+FuDuIZ0l\nrbuoN7MDO29wimesa62LgUHAX4FsYCwwRGtdoJSaqZSaeSp1mHwfQjRpTqeTDyukdb/pynPofk7i\nSV4lRM3MDmddAfSpesa6Umo88LXZm2mttwB9qikfU8P1T5utQwhxcqt+Psg6V1r3Ky9oxVWS1l2c\nIjljXYgmompa95suP6eBIxKnAzljXYgmYE/VtO7XSVp34R5yxroQp7n0nEKmL6iS1j1IcqYK95Az\n1oU4DWXmWgEICQ5gyvwt5BWWEhocwAOS1l24WY2NiFKqPfC71trp+h6MdCebXd9bysrlPBEhGpdd\nB3KxOxz8uC21PK37fcO60FLSugs3q60nsgtoDqS7vq9u14qcJyJEI7TrQA67D+aSedTYC3z7oA50\nPDOugaMSp6PaGpG2QGaF74UQPuLX3zOwFhupGa7v25aLu0pad+EZNTYiWuv9FR5OBB5wzY2UU0rF\nYpx4eINnwhNCmLXo270s+X7fCeWLv/sTp9PJ0EvaeT8ocdqrbU7kUo6nWP8bsF0plVflsg4YGxGF\nEA3I6XSSHB9OcKAfxaWVt24NufhMaUCEx9Q2nJULPI4x72EBHgAqpi50YmTPHe+x6IQQJ5WWXcj7\nqzXb9+VU+3zPjklejkg0JbUNZ20B2gEopX4GBmitc70VmBCidqU2O4u+3cvS7/djsxu9j8SYEAqL\nbNw20BhEeH+1ZuOudFr2lWnNpqw0MwOAwAT350kzu9kwDjgT+M3tEQgh6mz7n9l8sGY3hzOM3KMx\nEUHcfGV7DmXkc3mPVkSFGXtBVJsY1m0yk2RbnM4K9S4AohuwEQmi+iW+QggvOlpQwidrf2f99jQA\nLBa4okcrhl3SjtDgAC7o0KzS9VFhQVwvvZAmz1rWiFx8idvrNtuIfAisUUp9BOwFrBWfNHnGuhCi\nnhxOJ1//doRPv9qDtdgGwNmtYxh11Tm0bhbZwNGJxsxutVKwfRtYPHOkq9lG5C9AAad2xroQoh4O\npOXxv1WavUeOARAa7M+Nl53NDVcqjuYW+NyJe8L9nHY7pZkZlKSlYktPIzsnk6yNm7BlZVW6bvfo\n2wGIu+56Eq4f5pZ7e/OMdSFEHViLbSz+7k/WbDyI09VO9OrYjJuuOIf46BD8JQtvk+J0OrHn51Ga\nmkpJagolaWmUpKYYjzPSMXvutzsbEKjbGesRwO1UPmP9A611utuiEULgdDrZtDuDD7/4nZy8YgCa\nxYRy69Xt6dI2voGjE57mKC2hND3daChSU41GIi2VktRUHIUnOcTVYiEwMZGI1q2wxCdCUDDZy5ZU\nuiSyZy+3xmv2jPUuwGrABmzAaESuAZ5QSl2qtd7h1qiEaKIyc618sGY3m13H1wb4Wxjc+wyuuegM\nAgMkRd3pwul0YsvJNhoJVwNh9C5SjSEoZ+1DlP4RkQQmJRHUPJmg5s0Jat6cwKRkAhMTCQwJIi4u\nguzsfNIWLsQ/MpIve4RjwcLlv+STv3EDwUNauu29mO2JTAO+AO7UWpcCKKWCMFKevA4MdFtEQjRB\nNruD1RsOsuS7PymxGXs+Op4Ry60D2pMcL5l3fZXdanU1EimVG4y0VJwlJbW+1hIQQGCzJFcD0dzV\nWCQTlNQc/4iIStcW2YrJLMomM3c32cVZ5P2Zx6bD22j35362XBWGNcT4N6Xjgun2+xri94ZxTbsB\nbnmPZhuRi4DzyxoQAK11iVLqReAnt0QiRBO1+2Au763SHM40hiqiwgL5yxXn0LtTEhaLzHs0dsak\ndiYlaa75iQpzFvajJ9+fHRAb62okXL2KpOYENm9OYHwCFj9jRZXD6eBYSR6Hrdlk5u0iMz2LTGu2\n6yuLvNL8auvO6Fa5sbGG+BF/3fVua0DAfCOSDrTEmAepqAVQeOLl1VNKdQdmAZ2B34ExWuv11Vz3\nV+AFIAlYh9EDSnM99wgwCeNskzKDtNbfmo1DiMYgr7CE+V/t4bstKYCRW6hf95YM79eO8JDAhg1O\nVOJ0OrHlHav3pLYlOKS8gQhqbjQSQc2TCWqWhF9ICAAl9hIyrdkcKsom07qbjD9+JMtqNBZZRdmU\nOmwnjdPP4kd8SBwtohOJDogh0BLIlwe/qXTN+Unn1v+DqIbZRuQ94N9KqfuBn11lvYGpwAdmKlBK\nhQBLMRqH2cAoYIlSqp3WOr/Cdd2AmcAAYAvwBvAuMNh1SXdggtb6VZOxC9GoOJ1Ovtuawvx1e8i3\nGp371s0iuO1qxVktoxs4uqat6qS2LS2VQ1kZFBw6jKPAxKR2QqKrkUgmqMKchX90DADHSvLJtGYZ\nX0W7ydz7o9FIWLM4WlI1v231wgPCiA+NIyE0joTQeOPPkHgSQuOJDYkmMMC/fE5kye+riAgM5y/K\nWI31if6MTelbuKbtVaf0OVVkthF5DuOAqkWAH8YvTaXA2xhJGs3oDzi01jNcj+cqpcZhNA7zKlx3\nC7BYa/0TgFLqMSBDKZXk6o10x2hU6sViseDnmT03bufnWsLp50NLOSXm2h3KyOe/KzS7DxrDHMGB\n/tzQrx1X9WyFfx3+YcrnXH9OpxNbtjGpXZyWSklKSvkQVKmpSe2I4/MTzZMJTnYNQTVrht0Psopy\nyCg0GooM6x9kHvyJTJ1FhjWbUkdprXWD0ZuIC4khITSexNA4EsLij38fGk9YYGjtr6/wOVv8LEzs\n8wiRQcawVof4s/j64A/4+7vv78DiPMkHVpFSKhpoj3HG+h6tdV2GssYBV2utB1Yo+xTYorV+tkLZ\nYuBHrfVLFcoyMc4s2QjkAcuBnkAOMFlrPddsHE6n0ynjzMLbikpsfLJmN5999Qd2h/F/7qKuyfz9\n+q4kxtb+Q0HUj62wEOvhI66vwxQdSTG+P3IER3Fxra+1BAQQ2iKZ0JYtCGnRgtCWLQht2ZKQ5GSs\nwZCWn0l6QSap+Zmk52eSVpBJWn4G2VZzOWrDAkNJikggKTyRZhEJNI9IoFl4AkkRCcSHxRHg1+hW\n4tX4Q7Mu+0SSMHoJHTFSwv+mlPpIa33UZBXhnDh/UgiE1eG6JOA7YAYwHLgQWKqUStFarzATRFZW\ngU/1RGJiwsnNLcDh8I1dyRLziX77PZP3Vunyo2oTokMYdbXivHMSwGknO7v6SdHayOdsKJvULnYN\nP5X3KtJSseWam9QuG3IKbp5MUPMk/JOacTTMj6ziHPYXZXPMfoxDuTvJ2PMdmduyKbbX3gABWLAQ\nGxJDYpgx3JQYGl+pZxEWEFr9ookSOFZiPbG8DjzxOcfFRdT4nNl9In0xfvvPBDZh7BN5HHhGKXW5\n1nq7iWoKgaq/coVhnEli6jqt9Z9Avwrl3yql3gOGAqYaEafTaXZjZ6PhcDh9LrWFxAzZx4r46Ivf\n+WW3kYbb38/CgF6tGdKnLcFB/m65V1P4nE91p7YlOKTS/ERgUnPsiTHkRvqT5SgoX+GUad1DZu4G\nctOO4jSRbzbYP8jVMMQbcxQh8eXzFHEhMQT41fzj1eEAT+e09da/DbM9kanAf4AHtdYOAKWUP/AW\nxrxIv5pfWm4ncF+VMoWR3LHqdar8AqUSMFLR71RKnY9xrslLFa4PoQ4rxITwNLvDwZcbD/HZd39S\nXGL8gDunVTSjrla0Sqz5N7qm7pR3apdNaic1JyApiaLYCI5GB5AZWExmUY6rodhHpnUTRfuKThqP\nBQsxIdEkRyYSExhDfEgcCSFxxLsajvDAMFmCjflGpBNwc1kDAqC1tiulXgd+NVnHWiBYKTUWY/XV\nKIzhqVVVrvsI+FopNRdjDuRFYIXWOkspFQ9MVEr9ASzEmKy/CXONmBAet+fIUd5bqTmQbnSww0MC\nGNn/bC7uloyf/MDB6XRSmpVFUcrxDXh12antFxHhWiabDInxWGPDyI0KJCPUTqYt19Wr2E920Wac\n2U7Irj2eIP8gEkIqrHIqX+0UR1xoHCGBgeUrnXytx+ctZhuR74FhwMtVyvthcrOh1rpYKTUIowGZ\nBPwBDNFaFyilZrquGaO1/k0p9XdgLsaKsG+BO1zP71ZKjcRYJvxf4BBwh9Z6k8n3IcQpy8w1xqwT\nYo6PuhYWlbLg67189evh8kGKvl2TubH/WUS6DohqSirt1E5Lo9TVUJSmpZma1A5slkRgUhL2hBgK\nY8M4GhVIeriDNEsBWdYsMqwHsNo0FAMZtccSExxt9CIqLYs1GovIwAjpTZwiU6uzlFLPAI8CX2H8\nULdhLLUdjjEcdaTsWq31BE8E6i4ZGXk+8+uEv7/F534Lagoxl20O7NstGafTyU870vh47R8cKzD2\nv7ZICGfUgPaoNrGNJmZPcMdObf9mzbAlRFMYE0ZuVADp4Q6OBBaRWZJDdlEODqfjpPUE+gW4hpiM\neYn48onsOOJC4gjyr//GzcbwOdeVJ2JOTIw85dVZlwLrMeYfKu5S+R44w/UFcvqhaAL0gRwAzm4V\nzXurNDv3G4+DAvy47uIzubpXGwL8G3YJoLvO1K40qV0hUaD5Se1g/JolYo+PpjAujML4EA4FlnAw\npJg0ey4FpTkYK/VdapjdjAqKPN6LCKncm4gKipTeRAMye55If08HIoSv2HUgh8JiGz/tTMPm+k2v\n21nx3HJVexJjGseej7qeqX2qk9qW+Fhs8dEUxISSGxVAWriDwyHFHPLLw04JJ4w5VZnXDvALqDDk\ndHxeIsG18inYv+kNCfqKUz1P5MOynFZCnM4WfbuXJd/vq/a5C1Qi9wzt0qh+G87dvgWofKZ2Wfrx\nUtcS2bpOahMWSml8NIWxoeS4hp4OhhSRElKC3d+CcfhpzQ1OZFAEzV0rncpWOSW4Go7o4Cj8PHR8\nq/AsOU9EiJPIKyzB389CcKAfxaWVx+gH927DiMvObqDIqucosmLdsR0cDjIXf2ZMaptMP+7098cW\nF0lBTIWGIrSYrAgoCvYDHJzYUBiNp7/Fn/jQ2Er7Jcr+jA+JJTw41OfmF8TJyXkiQtTgSGYBazYe\n5KXLv6kAABk2SURBVIdtqZTaqp/gvahLspejMjjtdqwpKeTt2kPxEaORKNi+tfxM7bLf6bOXLq72\n9aWRoa6hJ3/SwhykhNvIiQogL8wPp58FIylF2XzH8R5CeGBYlXmJ43/GBEdLb6IJkvNERJNT3RLd\nMk6nkx37cli94SBb92aVlwcH+dMiPoz0HCu3DewAwPurNRt3pdOyb1uPxHmqk9plcmOD2d06iKwI\nCzlR/uRG+lMaWPGHvb/rqyyVeGyFXdgVJ7FjCQ1oHHM+ovHw6nkiQjQGuw4Yy0/7VmhESkrtfPPb\nEVb9fIBDGceHa+KjgrmiR2suPbcFqzcc4PIerQgtNNLFqdEXsm7T4VOO54RJ7fIG4+ST2k4LFEYG\nkxPpT0aEk5JACxduq/xfcmmfcLKjj/9XDwsIJbnifomQyr0J/8aX/E80Yl47T0SIhrDbtRy3fYU9\nG2VLdPt2S+ZYQQlf/XaYr349Qm7+8U1w7VpEMaBna3qoxPIU7UMvaQfA4Z9+AaBl/4Fcb7IXYkxq\n51Q6KrUkNYXStDRKszJPOqldHOxPdpQ/2ZF+5Eb6kxMVQE6UP0cj/F2T2oYLt+RTGGxhXc9IAPpv\nyKN3ejjJF99YPokdFlg156kQ9Vff80T4//bOPDyq6vzjn1kyM9mTSUIkLEIEDosg4IKi4oYrWlFb\nl1qtS21da1vXav09tU/92V9bu9jn0dq6/For/lpREJdaEKkiFUUQUJbDFnay78kkme33x7mTTIYs\nw5CE0byf58mT3HPPnPvNzc1973vec98XE2Q/lHoigjDgrPiiFOhsRPZu3UMoFOIFu42PNpQRCJp4\nh80Gx48r4LyTRjKmh+JQVRvXAsaIxBJq8XV66e5QgtpBu43aTDs1mcZA1GQ5qMl0UpvlsILaHXic\nHoZmFHC0K6f9Bbv8VC+Uvc9z4zQ+j+m/b4iLO5sVo4ZMieNsCcKhE68ROR64A7iXBOuJCEJ/0l2c\no2aDWTi4MNPdvkR3cvNWAJavdwMmu+7FpxVz+uRCvJmeXo9l27YTwmEa16/teFPbmoKK503thlQ7\ntZaBaDcWnYLaHanE8z1eilO9HW9kW7GKLHc6eXmZB610emvGThz79nNzVCW7DRMKGdWrKkFIjHiN\nyCLgXK31WswS30FH2Y69ABQWDz/CSoQIEcMRrK5i4/rtuPMLyD9tYqc+IyqM11DTMBGH3UYwFObo\nNvO3/DxtIpNGe7nriskMG5rT6YYcG9SuW/4BLdu3AeC2xt7/5O+61dbmtFGT6TDGIstJTabjoKB2\nJJV4fmoeY2JetPN6cntMJd7TOyk/mXFPeyW7sTnFfLDvo277CsLhEq8RKcF4IGv7UUtSs3XlfwAo\nLL7yCCsZ3EQb87Xr1gHg2bcb3+ZN1B41Ck6byC9eWs2WPSb4/T2feRf2GSvfFcCIRmvVVQ5cNWsU\ntopSKks2Ub1tJ61RpVJDzb072i0pNkrzU9q9CTMF5aAp1Y7NZifbndVuHMbFvD+RkZLe5y8ozik+\nr9N2piujT+tpC0Is8RqRTcA8pdTDwA6gU+ktrfU3+1pYstGy/Qvrp+6NyIqlbwEwVplyKLmebPzV\n1aR4vYedw2iw4K+saD9nn65cDMApF1/bvj/amFduNGs88isryasppTTYyhsrSmjyBdr7Z7eYOMTZ\nFas4qW5Tp2M9uO2vND/yV0p60eRz26jJdNLssTFmb+e4xvzz8nAXFbUn/RtvLYstSM3D68kl5TCS\n/wnCl4F4jUgIs0JrUBIKhckpMwHa6voWvFldz5vXrnwfgG315QDke/Jp2rKZ9HHjyZk8gZKVS3Fn\n55BW3QS+FkZf/I1BZ1yat2ha9u7GM3wkexsOUFOizTnxFpJTOJzazze1n7O2FSvMh6KMSLQx9xzY\nSSgcJrumkcxWP45wBa8tWcXFZR+S76/vdNxYAxJLwA51mZ3jFLXWz+7MHPJTvUxaXUZzxe5OK59u\nCk5l1Ixv9dXpEYQvHfEmYLyxv4UkIyv+8DwF6z4AIMtqq/zRrVQCuwrHc/S1V1OsRuB0mHX1BeWm\nAk69w7xOU2FPx71vPxWtPipbKnGuWEVjqhtbfSuOQJDN9hDBoQWkeQsByCk08Rb/rt3kFgwjc8L4\ngftl+5id81+mdv8uguNGkeYtpLm6zPyen67Fv30HKccUs6++nPT95TSmuqnJzaZyzFjCW/e0n7O8\nmoNrTeeUlWILh1nwg58yqbFzxaGsFj837H37kHQuPTGDA0VppBYeRa4nlzyPl6LUPKZEpetwWcn/\nPvr81yyYO4JLj/s6AAuGzeeC/WUStBYGNd3WE7HK3z6IqRnShlne+0T0W+tfRg6lnshbOxZTtWgh\nJ3/R/dx4m8NOc0YW9oIhZG7bQhjweRyE7GDDSZqvleZUN9VFOQzbXkbQYcMZCGMDGjJdtKSm4M/N\nxu6wkamM0bCtWkdKTi6+Efm07d1L2OUi1OzDkefl1BvuPdxT0GdU+arZ8u838W/cjKOiGntrgJDb\nCUMLyNb7sQWC1A/JpM2bhaOyFn9uNrkHanA3+GjNTMUf9JPRHCDosOFzO6gbmod3fy1pvlZ8Hhdp\nPjN1VJ93FNlVpXHrCtqgPs1OblPnVCVbhrsZXtHWyZNIm3U66pobyc/L6jWn01s7FjNr+Mz2oHVD\nWyMf7PvoiMQcpM7FwCCaDYnWE3kMuB3zMmEAY1CKge/2iaovAXOKz2PBtAr4Ykmn9ia3jfRW88dx\nBUO46mrBWtppA9JbIukozPeM5lYytpkArz3Q8UdNb2zD4/Pja2oFGzSGzD5vaRXByhrCu0rIaQoQ\nsoM9BH5XKeWzzQqh/ZtWU79+HbS1gcsFbW2ECvOZfM13yUv19snvv61mB7p6G46lK0hr6Hh2sKV6\nCNfV05rhImN3JXl1bTgi9+uGAMHqPTit7czKRnyNPlJbgviaWvE0B7CFwdPgwwPYwuacuAIBsrd1\nJIRO93XEHg7FgAC8fuExzF5XTbiphjXjzZLf6Zt9jKyz8epBnkRN3PmeJGgtCAfTkxG5BviW1noR\ngFJqAfCmUuo2rXV8SXu+AuSsqz3oDeA96hhCZ0+idu9u2krLmL6mlKzm3iuwQSTfqcERBod1Aw0D\njt1lhG02UgJhUgJBXK1gD2MiUoCjJcS2VcsBCK36lLzKJmxhk/rCFobWPZWsqv8VaT4/7rFjCTQ2\nEDxQSrChgao8F+GLZ/MNdWknPa/o19nTsJ9xG6vIKqmAjHRjJHwtNDjaaPT7mLC9qcNIAEE7OIMQ\ncEBK0NIYhTOqb0ogTEpjABvgCnQEvG2H+IDkt0NKD6d4w2gPY/a0YA/DjH15+EPl/G2Ol6nHmlI4\nfztmGeeu9nHvGfd3LH89Q5a/CsLh0pMRGQp8GrX9byAF8+b64ScM+pLQGK5h2aUjmDvVPL2+VjSf\nEzfbmHvsZXCs6bMk6yWy3l7Swyi9YwMymjvbZod1ow1H9YkUGzqqurnjZm11SG2Dos0HcAahsbyW\nNH8Qd2sYexjyy1s5ULGId0Nvk+Zrw+90ELTbGOb3k+e2k9sUxtMWJmSvI2gHRwhyrAd0d8e9H+gw\nEo6Y9ojG/mBvTjaFTfUsOzGTsbtaGLunjZpMF7VZcFRFG20ZWbw818vkDXWMyvKxcuZEbh9/OUPT\nTbxpZtFJ/P3oBcyyDAiIJyEIfUFPRsSJmcYCQGsdUkq10PGu1SGjlJoGPANMArYCt2qtV3bR7xrM\ndFohsAyTgr7sUMboK+yXnMR9UfPgY88s5oOxnZ9enZ+sIAyUez1461pwRtmCihwHQ2oPz3GLvjGP\ntKZ8unqQt9Fxw89sNNNGkc+6gJGV0em9oyxAc6i9nz3UYSScPTz592f5pTbLwwkBtWkpeJv9DK2v\nZ/7lxphXvb6AV6a1Mq4kiPOi0ynImoDvnYVcdPb3WDLmfaodLn4YYxyGphfyg+m39qNqQRicxF3Z\n8HBRSnmANzDG4VngOmCRUqpYa90Y1W8K8EfgPGA98AfgBeCieMfoS+KdB2+54w5qP/gXbxRNZWbj\ncoaXlbPgjDzO+bSBEMGDbrqHexPu7fOxU0yJHLO/DIXf3rWBCmOmykI2WHhqNsMrAzhCBbwVKuLS\nAx9z35nWVNQtUzg5Jqg97Nv3AHD5mDn9pFoQhK7ozYhcp5RqiNp2ANcopToVTNZa/ymOY50FhLTW\nT1vbzyulfghcBPwjqt+1wOta648BlFIPABVKqUJgepxjDChn/eIpAEoa8/jJ8cP58ydNbAy1ccPE\n81mz4ymyG3ezaNIorlqzg12FKRxVHSCtLUyYjht19M99cfPuaYxo+9LfBV278piCdqjNsJPWEiJo\nt7Nw2MmcW7WKkN3GvoxccLq54Mzv8XbJMtwOF7dPmsOLi0/gRJmKEoSkoycjshu4M6atDPhOTFsY\niMeIjAdiy+hqqz22X/t8kda6SilVDahDGKNbbDYb9n4qvnbFmccAcP85V7e3bTr128xL38dtXzuW\n34z6DYG6PK5aswmdmkHACXZ3MzqjiEs27sAWhuZUW7fTX311w+8Pw9FdnDxgVVQtz0thf54be7Ob\ngmYf84ouwDV6PSn2FO6efiUvL5mKw2Fn7PAc3C4H08cMZ/qY69rHeei64/tBtcFuJT2MfP8yIJoH\nBtHcO90aEa31qD4+VjoHF7BqBmKLG/TUL94xuiUvr+/zFfXEzXOncPNck4bb/o/ZzJxYyOppsyge\nlk19fQufbizF3mznxXFn0DryQ07eUE9aSxluf4i6NCfexgC7s90Mq28lJdTZY4lmIH6j3hZUhQA/\nJv4SWVR2INfDq2d7af1sNjlpLqZMyefzhlaeuuI4fvvyMDwuJ6dMHcEpU0f0t/xeyclJP9ISDhnR\nPDCI5u4ZsJgI5mYfW1szDYiNZfTUL94xuqWqqqnfPJHeePreMw5qW5CbyjnHD2fp6r18seNcQtPS\neC61nFAojNNhp7nVeCWzst9jVcoJ3LBvEaltIbO0F7OKKohZNtcVh2pc4ll5G7CZjtXpTrKbA2CH\n8ows5hXM7dTPDgzxphJY62PMsCyOLc7jslnF7ft/cv0JAFRX90s4K27sdhs5OenU1jYRCn05XigT\nzQODaDZ4vRnd7htII7KJg6fHFDCvi36qvYNS+YDXas+Mc4xuCYfD8ZamHhC+duro9u+Rn2+6yKQz\nX7SihDf/s5Mb54ynrGoUD08o5NEXsvEHw6Q4bNhs4A+GOa1qLTNq1tPmtLEtP4fx5TU4g8aAHM4l\nVOWxkdEWJpAC4aCTIG7+OOoKHHYIRgXG7cCwIemkN7TS1hoAu51nHziry7dlk/mt31AonNT6ukI0\nDwyiuXsG0oi8B7iVUndhVl9dh1nC+6+Yfi8D7yulnse8p/I48E8rNhLvGF8JLptVzM1zp3RKX/DM\nfWd10fNsbvnlMjwuB9PG5vPU5nL8wRB3bZ2HKxxof++jK68kjMlp47K2W+0p/L74GgCK8tOorPXh\ndjlxpTj41W0zOakXzdEpFwRB+OrTbe6s/iBq+e5kYBtwm9Z6pVLqjwBa61utflcCP8e82LgcuFFr\nXd7TGPFqOJTcWUcaydszMIjmgUE0DwwDnTtrQI1IMiBGpH8RzQODaB4YRLOhJyNyhELMgiAIwlcB\nMSKCIAhCwogREQRBEBJGjIggCIKQMIMusC4IgiD0HeKJCIIgCAkjRkQQBEFIGDEigiAIQsKIEREE\nQRASRoyIIAiCkDBiRARBEISEESMiCIIgJIwYEUEQBCFhxIgIgiAICTOQRamEOFBKnQQs1FoXWdu5\nwPPA2UAd8KjW+rkjKLEdpdRpwBPAeKAS+KXW+pkk13wl8CgwAtgFPKy1XpjMmiMopQqBz4GbtNZv\nJrtmpdS9wH9j6p5FuBD4giTVrZQajqlXNAuox1zTTybruVZKXQs8E9OcBjwLPMAAaBZPJElQStmU\nUjcBi+koNAjwZ0wN+ULg68AvlVInHwGJnbD+qRYBvwdygW8AjyulZpO8mscBLwA3a60zgLuBv1sl\nmJNScwzPAXlR28mueRrwkNY6I+prOUmqWyllAxZiSnHnAecDP1VKzSRJNWutX4o+v8BcoBT4GQOk\nWTyR5OEh4ErgMcwTBEqpyEUxTmvdAnyilJoHXA/EXc2xnzgaeEtrHalvv0YptQyYSZJq1lpvUUoV\naq0blVJOzD9XA+ZJOSk1R1BK3Qo0AXus7WS+NiJMwxjtdpJc9wygCHhQax0ENiilTgFaSF7N7Vjn\n9n+B24FaBkizeCLJw/PAVGBVVNtYwK+13hHVpjHTR0cUrfVarfV1kW3LMzkdU8o9KTUDWAZkNObG\n8CLwMHAMSazZ8qDuAW6Lak7aawNAKZUGKOBupVSpUmqT5Wkns+7pwAbME3upUmoLcDLgJXk1R3M/\n8LnWeiEDeJ7FiCQJWusDWuvYlMrpgC+mrRkz55k0KKWygTeA1cAykl/zHiAVmI2J6VxCkmq2PKYX\nge9rraujdiX7tVEIfAg8DYwEvgv8BriY5NXtBc7CxPdGAjcAfwAySF7NQLsXchcm3gcDeH3IdFZy\n0wx4YtrSMPOcSYH1VP8msB24CphAkmvWWgesH99TSr0KnEDyan4EWKu1/mdMe1JfG1rrEuCMqKbl\nSqkXMQHrZNXdClRrrR+3tv9jXR+PkryaI8wFdmmtI1NVA3Z9iCeS3GwFXEqpkVFtCth4hPR0Qik1\nHfgY+BcwV2vtI4k1K6UuUkq9G9PswhjApNSMMcxXK6VqlVK1mCfk/wPmkLyaUUpNV0o9GNPsAXaT\nvLo14FRKOaLaHMBnJK/mCJcA/4jaHrD/QylKlWQopc4E5mut863tVzHz97cAk4B3gIu01h8fMZF0\nWm76hNb6f2L2Javmo4DNGLf/JeAC4GVMQPUxklBzLEqpncCd1hLfpDzP0B7HWQdcB7yGmSZaiPFO\nHiYJdSulUjE33+cxq5tOwjwgnQvcRxJqjqCU2gXcoLVeFtU2INeHeCLJzy1ACrAXeBW4L0ku3JuB\nAuARpVRj1NdjJKlmrXUp5ontbszqlZ9hPKjNJKnmXkhazVrrLZjVhv+FWQH3FHCj1noNSarb8qTP\nxBiPcmAeJha1kiTVDGB5TiOAAzG7BkSzeCKCIAhCwognIgiCICSMGBFBEAQhYcSICIIgCAkjRkQQ\nBEFIGDEigiAIQsKIEREEQRASRoyIIAiCkDCSO0sYlCilsoAfY+osDAf2Y9KJPK61brT6hIELtdbv\nJHiMw/p8D+OeAfwFq06E1vqtPhr3Jsyb2aOBNcD1WuttfTG28NVFPBFh0KGUysHUVJgF3AFMBL6P\nKay1yMqc2xcMBd7ro7Gi+TEmZfn4vhrfynP1GPAjTB0QBzG1QAShK8QTEQYjkSyts61UFwAlSqnt\nmJvzFcDfD/cgVpqV/iAbWKy13tUXgymlJgM/By7QWr9rtf0CeE0plau1rumL4whfTcSICIMKpZQb\nuBZ4IMqAAKC13mwlwFwf1TzDygc2CZMB9Wat9WfWWEOBXwPnYXIULQLujtx0o6ezrGyqTwLnYCoU\n/gX4sdY6pJQqsvadj6nr/Tpwf2RaLUb/TkxVyZOVUt/WWo/qSYdSahRQgkkp/yPgPa3112OGvQ/4\nLGJALCIGMA8QIyJ0i0xnCYONYiAT+KSrnVrr5VrruqimWzFZZ4/D3OCfBVBKpQBLMXGJ84ALgWOB\nv8WOaRmuJZi086di0rtfD9xj1fVegKllMQO4HFPh8vlu9J+IiVc8AZx4CDrOt8Z/JEabE7gMmB/T\nP9X6Xocg9IAkYBQGFUqpmcAKYGxvQWPLk7hba/2ktT0Xkw3VianQ9wowQmtdYe2fgPFWjtNar494\nIpj4wnxguNa6yup7KZCDqbL4GlCgtfZb+8ZhaluM0Frv7ULXSuAdrfVPlVKX9KQDY/hKMAH4V7sY\n60SMQW0BglG7HEBTpCSBIHSHTGcJg41K63tunP23R/1ci/HeXZgKjiWRGzeA1nqTUqoGE6iPnhKb\nCOyIGBCr7+sASqk7gSygRikVe2yFSePdE73piFS629HVh61jhDDeT7QR+R0Q6PITghCFGBFhsLEd\nqMbUjFgVu1Mp9TQmPvAnqykY2wewYZ7cu8JhfUXT1oMep6Xpwi72xdaH6Ip4dcTW246QBdRqrXWk\nwZp+OxWzck0QekRiIsKgQmsdxBQbusuqZNeOUupY4DvEV4d6MzBaKTUk6vOTMDdlHdN3i9U3J6rv\nHUqpxcAmzHsqdVrrbdYUWwom5pHVxzq6ogJIi1nWfBfGY3sljs8LgxzxRITByKOYJ/+lSqn/wkz1\nnIBZ4bSU+Jb3vouJO7yklLoPUz/8KeAjYHVM38WYuMRz1vEKgYcwhmIJxpC8rJS6H+PlPAO0aa3j\n8UR603F0L59/D+Nt/Uwp9SdMAP4hTBlVfxzHFwY54okIgw6tdSVmumYtZrXVBsx7Ei8Al1veSm9j\nhIBLMct1PwTeBj4D5mitwzF9g8DXgDTMFNqL1nF/GzVOPfA+xqhsxayYiud3iVtHN5+vwix5vhpj\nzL4JnG+VhBWEXpHVWYIgCELCiCciCIIgJIwYEUEQBCFhxIgIgiAICSNGRBAEQUgYMSKCIAhCwogR\nEQRBEBJGjIggCIKQMGJEBEEQhIT5f2iE4PPu3kvIAAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11ed52b38>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "yobs = np.sort(data['pcttip'])\n",
    "theta_est = 15.0\n",
    "\n",
    "plt.plot(yobs, squared_loss(yobs, theta_est) / np.sum(squared_loss(yobs, theta_est)), '-*', label='Squared Loss')\n",
    "plt.plot(yobs, abs_loss(yobs, theta_est) / np.sum(abs_loss(yobs, theta_est)), '-*', label='Absolute Loss')\n",
    "plt.plot(yobs, huber_loss(yobs, theta_est) / np.sum(huber_loss(yobs, theta_est)), '-*', label='Absolute Loss')\n",
    "plt.xlabel(r\"Choice for $\\theta$\")\n",
    "plt.ylabel(r\"Proportion of the Average Loss\")\n",
    "plt.legend()\n",
    "# plt.ylim([-7,15])\n",
    "# plt.xlim([5,30])\n",
    "plt.savefig(\"prop_loss.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 29,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "application/vnd.plotly.v1+json": {
       "data": [
        {
         "mode": "lines+markers",
         "name": "Squared Loss",
         "type": "scatter",
         "x": [
          3.563813585135547,
          5.643340857787811,
          5.679666792881484,
          5.9446733372572105,
          6.5659881812212735,
          6.653359946773121,
          7.180385288966725,
          7.296137339055794,
          7.358351729212656,
          7.398273736128237,
          7.717750826901875,
          7.74593338497289,
          7.8616352201257875,
          7.892659826361484,
          7.936507936507936,
          8.146639511201629,
          8.329862557267804,
          8.364235681911826,
          8.527131782945736,
          8.822232024702249,
          9.0014064697609,
          9.45288753799392,
          9.55302366345311,
          9.560229445506693,
          9.820426487093153,
          9.935739001482945,
          9.98430141287284,
          10.116337885685383,
          10.181582360570687,
          10.2512272596015,
          10.252156602521566,
          10.355540214014498,
          10.379904504878555,
          10.506960861570791,
          10.620490620490623,
          10.647181628392484,
          10.657193605683837,
          10.677083333333332,
          10.789980732177264,
          11.179429849077696,
          11.59823706796567,
          11.607142857142858,
          11.69024571854058,
          11.773472429210134,
          11.77495643515061,
          11.841469308844852,
          11.893434823977165,
          12.03852327447833,
          12.12624584717608,
          12.128562765312312,
          12.138868657441128,
          12.262415695892091,
          12.338062924120912,
          12.359550561797752,
          12.413108242303872,
          12.468827930174564,
          12.5,
          12.518628912071533,
          12.539184952978058,
          12.703379224030037,
          12.82437006393381,
          12.94219154443486,
          13.019891500904157,
          13.031914893617023,
          13.033770583310075,
          13.049095607235142,
          13.138686131386862,
          13.181019332161686,
          13.428827215756492,
          13.553474618038445,
          13.623978201634875,
          13.636363636363638,
          13.649025069637883,
          13.732097725358045,
          13.774104683195592,
          13.793103448275861,
          13.812154696132598,
          13.924050632911392,
          13.942407292314066,
          13.961519486926493,
          13.965087281795514,
          13.97804054054054,
          13.998782714546559,
          14.084507042253522,
          14.093959731543624,
          14.13427561837456,
          14.140773620798985,
          14.177693761814744,
          14.180374361883155,
          14.191106906338694,
          14.192495921696574,
          14.27891480247501,
          14.285714285714285,
          14.481094127111827,
          14.482259232440258,
          14.482259232440258,
          14.547537227949597,
          14.662756598240467,
          14.66992665036675,
          14.680764538430255,
          14.688601645123384,
          14.705882352941178,
          14.803849000740193,
          14.843525696238874,
          14.935505770536322,
          14.938236139040505,
          14.958863126402393,
          14.962593516209477,
          15,
          15.008527572484368,
          15.01519756838906,
          15.18324607329843,
          15.203021718602455,
          15.232292460015232,
          15.243902439024392,
          15.267175572519085,
          15.299877600979192,
          15.349194167306218,
          15.365703749231715,
          15.384615384615385,
          15.384615384615385,
          15.432098765432098,
          15.521855486173058,
          15.558148580318942,
          15.562472209871055,
          15.658362989323843,
          15.6737998843262,
          15.687250996015937,
          15.694164989939638,
          15.760441292356187,
          15.777080062794347,
          15.82060128141942,
          15.874855156431053,
          15.974440894568689,
          15.98976654940838,
          16.044399596367306,
          16.054158607350097,
          16.16650532429816,
          16.222760290556902,
          16.277807921866522,
          16.27906976744186,
          16.31321370309951,
          16.38935108153078,
          16.402405686167302,
          16.629711751662974,
          16.65043816942551,
          16.658733936220845,
          16.74641148325359,
          16.93952555963916,
          16.97965571205008,
          17.017056723522412,
          17.133066818960593,
          17.1875,
          17.219430485762143,
          17.316017316017316,
          17.370892018779344,
          17.391304347826086,
          17.476489028213166,
          17.53155680224404,
          17.57469244288225,
          17.57469244288225,
          17.68916155419223,
          17.768301350390903,
          17.798466593647316,
          17.964071856287426,
          17.96733212341198,
          18.009235505387377,
          18.092105263157894,
          18.13349084465446,
          18.164967562557923,
          18.17279046673287,
          18.391451068616423,
          18.421052631578945,
          18.484288354898336,
          18.51851851851852,
          18.6046511627907,
          18.6219739292365,
          18.62396204033215,
          18.773466833541928,
          18.814675446848543,
          18.839487565938207,
          19.047619047619047,
          19.120458891013385,
          19.228817858954844,
          19.28374655647383,
          19.31745009658725,
          19.342359767891683,
          19.36108422071636,
          19.48368241597662,
          19.49215832710978,
          19.50286806883365,
          19.505851755526656,
          19.533527696793005,
          19.611414693381906,
          19.681165124975397,
          19.747235387045812,
          19.760479041916167,
          19.77848101265823,
          19.814543679843826,
          19.81566820276498,
          19.821605550049554,
          19.9203187250996,
          19.930475086906142,
          19.936204146730464,
          19.987349778621127,
          20.034344590726963,
          20.192307692307693,
          20.219526285384173,
          20.364126770060686,
          20.39269720978298,
          20.408163265306122,
          20.481927710843376,
          20.55768179332969,
          20.614035087719298,
          20.624631703005306,
          20.89665653495441,
          21.150933871781934,
          21.378941742383752,
          21.428571428571427,
          21.853856562922868,
          21.88183807439825,
          21.951219512195124,
          22.026431718061676,
          22.377622377622377,
          22.492127755285647,
          22.767857142857142,
          22.774708410067525,
          22.80501710376283,
          23.074192403265883,
          23.674625657628486,
          23.781212841854934,
          24.12545235223161,
          24.166263895601737,
          24.21774539219889,
          25.26724975704568,
          25.93144560357675,
          26.348039215686274,
          26.63115845539281,
          27.952480782669458,
          28.05351747949935,
          29.198966408268735,
          32.57328990228013,
          41.66666666666667,
          71.0344827586207
         ],
         "y": [
          0.013990560267220856,
          0.009365139957748176,
          0.009292563394622172,
          0.008771641996688898,
          0.007609236199251186,
          0.007452397730256058,
          0.006540988185875729,
          0.006348771821221102,
          0.006246643814399054,
          0.006181546040012114,
          0.005672881667228368,
          0.005629058131459496,
          0.005450924028916626,
          0.005403645617210096,
          0.005337176656027988,
          0.005024349104297025,
          0.004759290569655516,
          0.004710364989933486,
          0.0044819415152254505,
          0.004082590689720647,
          0.0038492092813884795,
          0.0032915965347911137,
          0.0031738297879104153,
          0.0031654380501643592,
          0.0028698596451182615,
          0.002743499053484528,
          0.0026911351891110314,
          0.0025513137660900702,
          0.0024835993348221643,
          0.00241232283181547,
          0.0024113787328249245,
          0.0023075072199292604,
          0.0022833608968422007,
          0.0021594992531224007,
          0.002051745910011001,
          0.002026813305028562,
          0.002017500225717943,
          0.0019990625447126775,
          0.001896010864866101,
          0.001561453341610984,
          0.0012378862634423481,
          0.0012314131943482066,
          0.0011718287800243743,
          0.0011136363950864233,
          0.001112612220997048,
          0.001067192728070354,
          0.001032365764437102,
          0.0009381867658118173,
          0.000883429461606648,
          0.000882005534214494,
          0.0008756856735125374,
          0.0008016922017543702,
          0.0007579982887463532,
          0.0007458102813451496,
          0.0007158617683965838,
          0.0006853556446664555,
          0.0006685789088427937,
          0.000658652114069298,
          0.0006477845746038661,
          0.000564223581436289,
          0.0005063405472814997,
          0.0004529836737066684,
          0.00041942144341087817,
          0.00041434337990302556,
          0.00041356238700189155,
          0.00040714080218268265,
          0.00037060551801376847,
          0.0003539393276522486,
          0.00026407090275971305,
          0.0002238333382717981,
          0.00020254581885990278,
          0.0001989160389945496,
          0.00019523929681805223,
          0.00017196664431954427,
          0.00016076052901498142,
          0.00015581624986110316,
          0.0001509358569580077,
          0.00012383868268262623,
          0.000119649131345077,
          0.00011536374813934479,
          0.0001145724243759177,
          0.00011172233158746517,
          0.00010723321636682618,
          8.965668366945602e-05,
          8.78147875404526e-05,
          8.017370476003168e-05,
          7.897467703231363e-05,
          7.233355742769805e-05,
          7.186273210428237e-05,
          6.999304854503208e-05,
          6.975287355336095e-05,
          5.562189944857379e-05,
          5.457787010961597e-05,
          2.880380265493944e-05,
          2.867460084791252e-05,
          2.867460084791252e-05,
          2.1899709734640262e-05,
          1.2166329590486593e-05,
          1.1654498109083369e-05,
          1.0901717172820031e-05,
          1.0373021605545461e-05,
          9.253687319623377e-06,
          4.115794709600514e-06,
          2.619139982885996e-06,
          4.449532381089761e-07,
          4.080764458367932e-07,
          1.8102360909140373e-07,
          1.4968091441184892e-07,
          0,
          7.778995029009563e-09,
          2.470704848783973e-08,
          3.5920469870120693e-06,
          4.409178229324721e-06,
          5.772220080068808e-06,
          6.363630304274168e-06,
          7.636004086777467e-06,
          9.619681883186375e-06,
          1.3043874650510656e-05,
          1.4306436789628011e-05,
          1.5824352872018823e-05,
          1.5824352872018823e-05,
          1.997278861959871e-05,
          2.913219187707208e-05,
          3.332516463511929e-05,
          3.38434629618449e-05,
          4.63664100609558e-05,
          4.8566244166941544e-05,
          5.052466127522655e-05,
          5.154636770320996e-05,
          6.185916269826535e-05,
          6.459578613021892e-05,
          7.203391787311553e-05,
          8.187380355801327e-05,
          0.00010157425797156363,
          0.00010479442981008501,
          0.00011668258591706747,
          0.00011887336951331677,
          0.00014556136031576862,
          0.0001599393430014916,
          0.0001746641630814302,
          0.00017500929793397104,
          0.00018447752631126093,
          0.00020648887670539804,
          0.00021038752408122306,
          0.0002841150562914436,
          0.0002913876712714737,
          0.0002943242966290006,
          0.0003262614871658843,
          0.000402405278821891,
          0.0004192296489881089,
          0.00043522003338437377,
          0.0004867226701419317,
          0.000511880727082764,
          0.0005269334261871628,
          0.0005737943387373659,
          0.0006013069231506399,
          0.000611705466691705,
          0.000656062887760596,
          0.0006855640055101849,
          0.0007091259385194013,
          0.0007091259385194013,
          0.0007735821537338366,
          0.0008197838982992843,
          0.0008377470527619863,
          0.0009398317452139874,
          0.0009419003777148441,
          0.0009686904304665381,
          0.0010227775689984283,
          0.0010503390568529377,
          0.001071546893150699,
          0.0010768505610186429,
          0.0012303927566921257,
          0.0012519649373344266,
          0.0012986760566612442,
          0.001324318167858703,
          0.0013899498786326128,
          0.0014033412615780537,
          0.0014048822798771311,
          0.0015231887698510464,
          0.0015566387697467507,
          0.0015769545833248524,
          0.0017525560512976633,
          0.0018162006468863815,
          0.0019129808148289637,
          0.00196299951102866,
          0.001994009888465842,
          0.0020170852762607674,
          0.002034518308322882,
          0.0021505143343307975,
          0.0021586526435631455,
          0.0021689577882651424,
          0.002171833126586587,
          0.0021985948250196406,
          0.002274788441218646,
          0.0023441239735331296,
          0.0024107611684166604,
          0.0024242308285639014,
          0.0024426001763378545,
          0.00247960736217498,
          0.0024807658108825497,
          0.002486886767515863,
          0.00258975766413803,
          0.0026004600855452377,
          0.0026065069052765262,
          0.0026608004800675014,
          0.0027111811254176806,
          0.0028839883109254253,
          0.0029143038686193358,
          0.0030780149201937437,
          0.0031108905166891626,
          0.0031287599415900165,
          0.0032146912144736133,
          0.003304151938554088,
          0.003371497950901918,
          0.0033842375164415805,
          0.0037194979075518384,
          0.004047200972256309,
          0.0043528121630961834,
          0.00442080747887888,
          0.005025076496295149,
          0.005066190943188079,
          0.005168858714646611,
          0.005281317964078603,
          0.0058224463984723,
          0.006004585088642985,
          0.006454685919682532,
          0.006466077035527038,
          0.006516589629961786,
          0.006973821757336627,
          0.008049597028373462,
          0.008248626944192821,
          0.008908025639778482,
          0.008987882113583107,
          0.009089124890622038,
          0.011276670949670947,
          0.012782854652087032,
          0.01377572011819693,
          0.014471668291356833,
          0.017946450606105755,
          0.018227527615088914,
          0.021566820227930623,
          0.03303534159131845,
          0.07606942251722455,
          0.33587941615467354
         ]
        },
        {
         "mode": "lines+markers",
         "name": "Absolute Loss",
         "type": "scatter",
         "x": [
          3.563813585135547,
          5.643340857787811,
          5.679666792881484,
          5.9446733372572105,
          6.5659881812212735,
          6.653359946773121,
          7.180385288966725,
          7.296137339055794,
          7.358351729212656,
          7.398273736128237,
          7.717750826901875,
          7.74593338497289,
          7.8616352201257875,
          7.892659826361484,
          7.936507936507936,
          8.146639511201629,
          8.329862557267804,
          8.364235681911826,
          8.527131782945736,
          8.822232024702249,
          9.0014064697609,
          9.45288753799392,
          9.55302366345311,
          9.560229445506693,
          9.820426487093153,
          9.935739001482945,
          9.98430141287284,
          10.116337885685383,
          10.181582360570687,
          10.2512272596015,
          10.252156602521566,
          10.355540214014498,
          10.379904504878555,
          10.506960861570791,
          10.620490620490623,
          10.647181628392484,
          10.657193605683837,
          10.677083333333332,
          10.789980732177264,
          11.179429849077696,
          11.59823706796567,
          11.607142857142858,
          11.69024571854058,
          11.773472429210134,
          11.77495643515061,
          11.841469308844852,
          11.893434823977165,
          12.03852327447833,
          12.12624584717608,
          12.128562765312312,
          12.138868657441128,
          12.262415695892091,
          12.338062924120912,
          12.359550561797752,
          12.413108242303872,
          12.468827930174564,
          12.5,
          12.518628912071533,
          12.539184952978058,
          12.703379224030037,
          12.82437006393381,
          12.94219154443486,
          13.019891500904157,
          13.031914893617023,
          13.033770583310075,
          13.049095607235142,
          13.138686131386862,
          13.181019332161686,
          13.428827215756492,
          13.553474618038445,
          13.623978201634875,
          13.636363636363638,
          13.649025069637883,
          13.732097725358045,
          13.774104683195592,
          13.793103448275861,
          13.812154696132598,
          13.924050632911392,
          13.942407292314066,
          13.961519486926493,
          13.965087281795514,
          13.97804054054054,
          13.998782714546559,
          14.084507042253522,
          14.093959731543624,
          14.13427561837456,
          14.140773620798985,
          14.177693761814744,
          14.180374361883155,
          14.191106906338694,
          14.192495921696574,
          14.27891480247501,
          14.285714285714285,
          14.481094127111827,
          14.482259232440258,
          14.482259232440258,
          14.547537227949597,
          14.662756598240467,
          14.66992665036675,
          14.680764538430255,
          14.688601645123384,
          14.705882352941178,
          14.803849000740193,
          14.843525696238874,
          14.935505770536322,
          14.938236139040505,
          14.958863126402393,
          14.962593516209477,
          15,
          15.008527572484368,
          15.01519756838906,
          15.18324607329843,
          15.203021718602455,
          15.232292460015232,
          15.243902439024392,
          15.267175572519085,
          15.299877600979192,
          15.349194167306218,
          15.365703749231715,
          15.384615384615385,
          15.384615384615385,
          15.432098765432098,
          15.521855486173058,
          15.558148580318942,
          15.562472209871055,
          15.658362989323843,
          15.6737998843262,
          15.687250996015937,
          15.694164989939638,
          15.760441292356187,
          15.777080062794347,
          15.82060128141942,
          15.874855156431053,
          15.974440894568689,
          15.98976654940838,
          16.044399596367306,
          16.054158607350097,
          16.16650532429816,
          16.222760290556902,
          16.277807921866522,
          16.27906976744186,
          16.31321370309951,
          16.38935108153078,
          16.402405686167302,
          16.629711751662974,
          16.65043816942551,
          16.658733936220845,
          16.74641148325359,
          16.93952555963916,
          16.97965571205008,
          17.017056723522412,
          17.133066818960593,
          17.1875,
          17.219430485762143,
          17.316017316017316,
          17.370892018779344,
          17.391304347826086,
          17.476489028213166,
          17.53155680224404,
          17.57469244288225,
          17.57469244288225,
          17.68916155419223,
          17.768301350390903,
          17.798466593647316,
          17.964071856287426,
          17.96733212341198,
          18.009235505387377,
          18.092105263157894,
          18.13349084465446,
          18.164967562557923,
          18.17279046673287,
          18.391451068616423,
          18.421052631578945,
          18.484288354898336,
          18.51851851851852,
          18.6046511627907,
          18.6219739292365,
          18.62396204033215,
          18.773466833541928,
          18.814675446848543,
          18.839487565938207,
          19.047619047619047,
          19.120458891013385,
          19.228817858954844,
          19.28374655647383,
          19.31745009658725,
          19.342359767891683,
          19.36108422071636,
          19.48368241597662,
          19.49215832710978,
          19.50286806883365,
          19.505851755526656,
          19.533527696793005,
          19.611414693381906,
          19.681165124975397,
          19.747235387045812,
          19.760479041916167,
          19.77848101265823,
          19.814543679843826,
          19.81566820276498,
          19.821605550049554,
          19.9203187250996,
          19.930475086906142,
          19.936204146730464,
          19.987349778621127,
          20.034344590726963,
          20.192307692307693,
          20.219526285384173,
          20.364126770060686,
          20.39269720978298,
          20.408163265306122,
          20.481927710843376,
          20.55768179332969,
          20.614035087719298,
          20.624631703005306,
          20.89665653495441,
          21.150933871781934,
          21.378941742383752,
          21.428571428571427,
          21.853856562922868,
          21.88183807439825,
          21.951219512195124,
          22.026431718061676,
          22.377622377622377,
          22.492127755285647,
          22.767857142857142,
          22.774708410067525,
          22.80501710376283,
          23.074192403265883,
          23.674625657628486,
          23.781212841854934,
          24.12545235223161,
          24.166263895601737,
          24.21774539219889,
          25.26724975704568,
          25.93144560357675,
          26.348039215686274,
          26.63115845539281,
          27.952480782669458,
          28.05351747949935,
          29.198966408268735,
          32.57328990228013,
          41.66666666666667,
          71.0344827586207
         ],
         "y": [
          0.011743198517057653,
          0.0096078449386436,
          0.009570543809434277,
          0.009298422986457949,
          0.008660428528376955,
          0.008570711209120285,
          0.008029537517787703,
          0.007910678026201805,
          0.00784679344897245,
          0.007805799708978874,
          0.007477746041216819,
          0.007448806903453529,
          0.007329998974857477,
          0.007298141492238464,
          0.007253116250136926,
          0.007037343552245029,
          0.006849201760497172,
          0.006813905866245076,
          0.00664663671001573,
          0.006343614304148493,
          0.0061596298008203074,
          0.005696028420200765,
          0.005593204073225463,
          0.005585804847114923,
          0.005318622641259186,
          0.005200214485003502,
          0.00515034838307661,
          0.005014767302506392,
          0.004947771295889759,
          0.0048762567327871285,
          0.004875302441032442,
          0.0047691434270805645,
          0.0047441250604708645,
          0.004613657790581691,
          0.004497080249063444,
          0.004469672703134976,
          0.004459391947591519,
          0.0044389682668499525,
          0.0043230400615383874,
          0.003923135921631207,
          0.003493085541778546,
          0.0034839406707118372,
          0.0033986068572073153,
          0.0033131458696141125,
          0.0033116220245378507,
          0.003243323568094692,
          0.003189963003820684,
          0.003040979556458116,
          0.0029509020124021935,
          0.00294852289504309,
          0.0029379403343210327,
          0.002811076592677362,
          0.002733398563819633,
          0.0027113340760832527,
          0.0026563386036870485,
          0.0025991230833870694,
          0.0025671141784192487,
          0.002547985160696306,
          0.002526877279070983,
          0.0023582751025778836,
          0.002234036182347553,
          0.002113051705100916,
          0.0020332658411349592,
          0.002020919672372599,
          0.002019014165443887,
          0.0020032777309628253,
          0.0019112820890420676,
          0.0018678124250713002,
          0.0016133519724711829,
          0.0014853583269907311,
          0.001412962027358826,
          0.001400244097319588,
          0.001387242759368619,
          0.0013019399624333516,
          0.001258805299610541,
          0.0012392964999265348,
          0.0012197338085306912,
          0.001104833950205753,
          0.0010859844939573465,
          0.0010663592196492385,
          0.0010626956449316567,
          0.0010493946472592201,
          0.0010280956356663843,
          0.0009400699808295833,
          0.0009303635277492584,
          0.0008889653338695622,
          0.0008822928882075039,
          0.0008443816012191864,
          0.0008416290386422708,
          0.0008306083718253389,
          0.0008291820674176366,
          0.0007404432137658592,
          0.0007334611938340721,
          0.0005328362494224977,
          0.0005316398660593112,
          0.0005316398660593112,
          0.00046460943893498634,
          0.00034629692729409465,
          0.0003389343903047409,
          0.00032780555185996227,
          0.0003197580527760756,
          0.0003020134327552047,
          0.00020141680452438136,
          0.0001606749614973866,
          6.622562035297302e-05,
          6.34219532732137e-05,
          4.224122058730248e-05,
          3.8410685961384584e-05,
          0,
          8.756500892847895e-06,
          1.56055573156217e-05,
          0.00018816543716162012,
          0.00020847197294056254,
          0.0002385285070579957,
          0.00025045016374822146,
          0.00027434808013640884,
          0.00030792801650561367,
          0.00035856851916523774,
          0.000375521311901525,
          0.000394940642833731,
          0.000394940642833731,
          0.0004436987468872768,
          0.0005358650470562908,
          0.0005731324536805327,
          0.0005775721539707174,
          0.0006760371857758869,
          0.0006918884945884157,
          0.000705700710402105,
          0.0007128003151345205,
          0.0007808558493852103,
          0.0007979412987865156,
          0.0008426308737443181,
          0.0008983412304549385,
          0.001000600414591527,
          0.0010163374969245388,
          0.0010724372047079408,
          0.001082458202892449,
          0.0011978209428829408,
          0.0012555861114786657,
          0.0013121115334079937,
          0.001313407254074965,
          0.0013484678066084796,
          0.0014266491440799133,
          0.001440054208342343,
          0.0016734624577721961,
          0.0016947452901346144,
          0.0017032637623590802,
          0.001793295072005791,
          0.001991593425422488,
          0.002032800898716964,
          0.0020712059654521033,
          0.0021903304297877534,
          0.002246224906116843,
          0.002279012587206367,
          0.002378192355765018,
          0.002434540206763796,
          0.0024555005184879763,
          0.00254297203881029,
          0.002599518144205748,
          0.002643811790076765,
          0.002643811790076765,
          0.0027613539015307253,
          0.002842618258690256,
          0.002873593308153857,
          0.003043644355251565,
          0.0030469921464359143,
          0.0030900204528330195,
          0.0031751149048869646,
          0.003217611510103749,
          0.003249933241631782,
          0.0032579661569213506,
          0.0034824968494641326,
          0.003512893086257917,
          0.003577826415024239,
          0.0036129755103678322,
          0.003701420443302174,
          0.0037192082510431584,
          0.0037212497343159234,
          0.0038747680840721084,
          0.003917082970269071,
          0.003942561187353752,
          0.00415628009839307,
          0.004231075376285646,
          0.004342343313470205,
          0.00439874660875144,
          0.0044333549430266754,
          0.004458933331180823,
          0.004478160454512572,
          0.004604049880633062,
          0.004612753333291045,
          0.004623750585221666,
          0.004626814370987097,
          0.004655233291477474,
          0.004735211216780618,
          0.004806834145538423,
          0.004874678108151558,
          0.004888277297828269,
          0.004906762543560844,
          0.004943793337258348,
          0.004944948048752287,
          0.00495104478811086,
          0.005052407984617964,
          0.005062837000775854,
          0.005068719861057466,
          0.005121238531773759,
          0.0051694949511613755,
          0.005331698678255364,
          0.005359647972736666,
          0.0055081303545044145,
          0.005537467786862324,
          0.005553349039029395,
          0.005629093740630162,
          0.005706881492319665,
          0.005764747628730945,
          0.005775628717268531,
          0.006054956238459993,
          0.006316059821108244,
          0.006550188716073487,
          0.006601150744506639,
          0.0070378529438124456,
          0.007066585637749267,
          0.007137829666824255,
          0.007215060994852341,
          0.007575679603447013,
          0.007693258954848866,
          0.007976390482945522,
          0.007983425677023887,
          0.00801454802794972,
          0.008290949519083535,
          0.008907501807270995,
          0.009016950396017194,
          0.009370431247161219,
          0.009412338403812672,
          0.009465201955748988,
          0.01054288096987342,
          0.011224907599824257,
          0.011652684947138354,
          0.011943404712911925,
          0.013300198825157445,
          0.013403947919946512,
          0.014580147194226123,
          0.018045056667846057,
          0.027382551236471993,
          0.05753876606801765
         ]
        },
        {
         "mode": "lines+markers",
         "name": "Huber Loss",
         "type": "scatter",
         "x": [
          3.563813585135547,
          5.643340857787811,
          5.679666792881484,
          5.9446733372572105,
          6.5659881812212735,
          6.653359946773121,
          7.180385288966725,
          7.296137339055794,
          7.358351729212656,
          7.398273736128237,
          7.717750826901875,
          7.74593338497289,
          7.8616352201257875,
          7.892659826361484,
          7.936507936507936,
          8.146639511201629,
          8.329862557267804,
          8.364235681911826,
          8.527131782945736,
          8.822232024702249,
          9.0014064697609,
          9.45288753799392,
          9.55302366345311,
          9.560229445506693,
          9.820426487093153,
          9.935739001482945,
          9.98430141287284,
          10.116337885685383,
          10.181582360570687,
          10.2512272596015,
          10.252156602521566,
          10.355540214014498,
          10.379904504878555,
          10.506960861570791,
          10.620490620490623,
          10.647181628392484,
          10.657193605683837,
          10.677083333333332,
          10.789980732177264,
          11.179429849077696,
          11.59823706796567,
          11.607142857142858,
          11.69024571854058,
          11.773472429210134,
          11.77495643515061,
          11.841469308844852,
          11.893434823977165,
          12.03852327447833,
          12.12624584717608,
          12.128562765312312,
          12.138868657441128,
          12.262415695892091,
          12.338062924120912,
          12.359550561797752,
          12.413108242303872,
          12.468827930174564,
          12.5,
          12.518628912071533,
          12.539184952978058,
          12.703379224030037,
          12.82437006393381,
          12.94219154443486,
          13.019891500904157,
          13.031914893617023,
          13.033770583310075,
          13.049095607235142,
          13.138686131386862,
          13.181019332161686,
          13.428827215756492,
          13.553474618038445,
          13.623978201634875,
          13.636363636363638,
          13.649025069637883,
          13.732097725358045,
          13.774104683195592,
          13.793103448275861,
          13.812154696132598,
          13.924050632911392,
          13.942407292314066,
          13.961519486926493,
          13.965087281795514,
          13.97804054054054,
          13.998782714546559,
          14.084507042253522,
          14.093959731543624,
          14.13427561837456,
          14.140773620798985,
          14.177693761814744,
          14.180374361883155,
          14.191106906338694,
          14.192495921696574,
          14.27891480247501,
          14.285714285714285,
          14.481094127111827,
          14.482259232440258,
          14.482259232440258,
          14.547537227949597,
          14.662756598240467,
          14.66992665036675,
          14.680764538430255,
          14.688601645123384,
          14.705882352941178,
          14.803849000740193,
          14.843525696238874,
          14.935505770536322,
          14.938236139040505,
          14.958863126402393,
          14.962593516209477,
          15,
          15.008527572484368,
          15.01519756838906,
          15.18324607329843,
          15.203021718602455,
          15.232292460015232,
          15.243902439024392,
          15.267175572519085,
          15.299877600979192,
          15.349194167306218,
          15.365703749231715,
          15.384615384615385,
          15.384615384615385,
          15.432098765432098,
          15.521855486173058,
          15.558148580318942,
          15.562472209871055,
          15.658362989323843,
          15.6737998843262,
          15.687250996015937,
          15.694164989939638,
          15.760441292356187,
          15.777080062794347,
          15.82060128141942,
          15.874855156431053,
          15.974440894568689,
          15.98976654940838,
          16.044399596367306,
          16.054158607350097,
          16.16650532429816,
          16.222760290556902,
          16.277807921866522,
          16.27906976744186,
          16.31321370309951,
          16.38935108153078,
          16.402405686167302,
          16.629711751662974,
          16.65043816942551,
          16.658733936220845,
          16.74641148325359,
          16.93952555963916,
          16.97965571205008,
          17.017056723522412,
          17.133066818960593,
          17.1875,
          17.219430485762143,
          17.316017316017316,
          17.370892018779344,
          17.391304347826086,
          17.476489028213166,
          17.53155680224404,
          17.57469244288225,
          17.57469244288225,
          17.68916155419223,
          17.768301350390903,
          17.798466593647316,
          17.964071856287426,
          17.96733212341198,
          18.009235505387377,
          18.092105263157894,
          18.13349084465446,
          18.164967562557923,
          18.17279046673287,
          18.391451068616423,
          18.421052631578945,
          18.484288354898336,
          18.51851851851852,
          18.6046511627907,
          18.6219739292365,
          18.62396204033215,
          18.773466833541928,
          18.814675446848543,
          18.839487565938207,
          19.047619047619047,
          19.120458891013385,
          19.228817858954844,
          19.28374655647383,
          19.31745009658725,
          19.342359767891683,
          19.36108422071636,
          19.48368241597662,
          19.49215832710978,
          19.50286806883365,
          19.505851755526656,
          19.533527696793005,
          19.611414693381906,
          19.681165124975397,
          19.747235387045812,
          19.760479041916167,
          19.77848101265823,
          19.814543679843826,
          19.81566820276498,
          19.821605550049554,
          19.9203187250996,
          19.930475086906142,
          19.936204146730464,
          19.987349778621127,
          20.034344590726963,
          20.192307692307693,
          20.219526285384173,
          20.364126770060686,
          20.39269720978298,
          20.408163265306122,
          20.481927710843376,
          20.55768179332969,
          20.614035087719298,
          20.624631703005306,
          20.89665653495441,
          21.150933871781934,
          21.378941742383752,
          21.428571428571427,
          21.853856562922868,
          21.88183807439825,
          21.951219512195124,
          22.026431718061676,
          22.377622377622377,
          22.492127755285647,
          22.767857142857142,
          22.774708410067525,
          22.80501710376283,
          23.074192403265883,
          23.674625657628486,
          23.781212841854934,
          24.12545235223161,
          24.166263895601737,
          24.21774539219889,
          25.26724975704568,
          25.93144560357675,
          26.348039215686274,
          26.63115845539281,
          27.952480782669458,
          28.05351747949935,
          29.198966408268735,
          32.57328990228013,
          41.66666666666667,
          71.0344827586207
         ],
         "y": [
          0.012702630861316217,
          0.010287212331632276,
          0.010245018926483303,
          0.009937207758921051,
          0.009215536345126885,
          0.009114052039409667,
          0.008501900040304669,
          0.008367451384443836,
          0.008295187946125852,
          0.008248817621237985,
          0.007877737667148246,
          0.007845002980821289,
          0.0077106126507582905,
          0.007674576860430678,
          0.007623646276767651,
          0.007379573642635055,
          0.007166755880466962,
          0.007126830709357081,
          0.006937623159148448,
          0.006594857473203013,
          0.006386742253781761,
          0.005862336658167391,
          0.00574602625622859,
          0.00573765657542566,
          0.0054354317554475605,
          0.005301493630362857,
          0.005245087277890412,
          0.0050917238922692344,
          0.005015940941177438,
          0.004935046796710442,
          0.004933967343635178,
          0.004813884912329921,
          0.004785585230767874,
          0.004638006364020364,
          0.00450613895022311,
          0.004475136733560728,
          0.00446350759275246,
          0.004440405218791437,
          0.004309272305697706,
          0.0038569182415307155,
          0.003370464069868324,
          0.0033601197918764303,
          0.003263593916053795,
          0.0031669241864668925,
          0.003165200479596621,
          0.003087944254253303,
          0.0030275851188835265,
          0.0028590615624039446,
          0.002757169786156429,
          0.002754478632704578,
          0.0027425081030845854,
          0.002599005389806185,
          0.00251113940257627,
          0.0024861810195406977,
          0.002423972547642956,
          0.002359252854700713,
          0.0023230457820380265,
          0.0023014078742321607,
          0.0022775315621705087,
          0.002086816157769454,
          0.001946282527617606,
          0.0018094301809618864,
          0.0017191799028916164,
          0.0017052144570279114,
          0.0017030590309708037,
          0.0016852586648764241,
          0.001581197220255809,
          0.0015320262385057476,
          0.0012441917091354053,
          0.0010994108980788612,
          0.0010175193718327349,
          0.0010031334058800544,
          0.0009884268612989095,
          0.0008919360700621996,
          0.0008431440269518185,
          0.0008210765264099931,
          0.0007989480659219161,
          0.0006689783739413309,
          0.0006476566938424861,
          0.0006254574423025414,
          0.0006213133668917138,
          0.000606267860346073,
          0.0005821753504285826,
          0.0004867520546077487,
          0.0004767522789248577,
          0.000435268336059984,
          0.0004287587353686386,
          0.0003927036586009074,
          0.00039014751683707794,
          0.0003799968813609027,
          0.0003786929554752171,
          0.00030197496415989357,
          0.0002963068599538307,
          0.00015637774618674967,
          0.00015567630104673931,
          0.00015567630104673931,
          0.0001188949699271666,
          6.605180654503601e-05,
          6.32730396423425e-05,
          5.918614224218186e-05,
          5.631581910395745e-05,
          5.023887936933412e-05,
          2.234492119547642e-05,
          1.4219483877802429e-05,
          2.415680504672731e-06,
          2.2154739648903182e-06,
          9.82789124596731e-07,
          8.126275659954498e-07,
          0,
          4.223267756716973e-08,
          1.3413619735353107e-07,
          1.9501460232700422e-05,
          2.3937719692689417e-05,
          3.133776388584821e-05,
          3.454856903685402e-05,
          4.14563703017976e-05,
          5.2225888017192985e-05,
          7.081605660978731e-05,
          7.767058981504227e-05,
          8.591145643631772e-05,
          8.591145643631772e-05,
          0.00010843358798188433,
          0.00015816059295334895,
          0.00018092451886899262,
          0.00018373839470187038,
          0.00025172630124444754,
          0.0002636693458347701,
          0.00027430172160667753,
          0.0002798486332553436,
          0.0003358374781149024,
          0.00035069478739372994,
          0.0003910768956774369,
          0.00044449828467156327,
          0.0005514533522698171,
          0.0005689358777708611,
          0.0006323325930421372,
          0.0006436679076923543,
          0.0007741611911583645,
          0.000839502622201395,
          0.0009034417060638933,
          0.0009049073685845807,
          0.0009445663314404208,
          0.0010330016393505176,
          0.0010481648614690414,
          0.001312186059809731,
          0.001336260268489739,
          0.0013458959915210763,
          0.0014477354694280044,
          0.0016720418897278417,
          0.001718653980373204,
          0.0017620961113455837,
          0.0018968444927863314,
          0.0019600698785945847,
          0.00199715786872867,
          0.0021093456830410216,
          0.0021730839064369816,
          0.0021967932938837848,
          0.0022957372501175165,
          0.002359699730211839,
          0.0024098027642318887,
          0.0024098027642318887,
          0.0025427612573330335,
          0.0026346839422083735,
          0.0026697215627638536,
          0.002862075866193557,
          0.0028658627410895615,
          0.0029145344784651003,
          0.0030107895990887567,
          0.0030588598993551517,
          0.0030954208277341713,
          0.003104507310007621,
          0.0033584866044593627,
          0.003392869497450273,
          0.00346631923761589,
          0.003506078356224059,
          0.0036061233942101933,
          0.0036262441839727674,
          0.003628553420520253,
          0.003802206660150475,
          0.0038500714078132593,
          0.0038788912521105934,
          0.004120640732424594,
          0.004205245877905358,
          0.004331107299616558,
          0.004394908239158718,
          0.004434055672508835,
          0.004462988825936692,
          0.004484737706514361,
          0.004627138316706771,
          0.0046369832815101805,
          0.004649422891679355,
          0.004652888512072911,
          0.004685034751384273,
          0.004775502280835002,
          0.004856519003789297,
          0.004933261125599709,
          0.004948643933892382,
          0.004969553634992741,
          0.005011441248440013,
          0.005012747407554407,
          0.005019643772337371,
          0.005134301384803168,
          0.005146098231530936,
          0.005152752665660903,
          0.00521215948787754,
          0.005266745037897607,
          0.005450222796319987,
          0.005481837815239649,
          0.005649794588243863,
          0.005682979807987786,
          0.005700943985511687,
          0.005786623077546533,
          0.005874613178442527,
          0.005940068819860392,
          0.005952377031082413,
          0.006268340100316896,
          0.006563689047709417,
          0.0068285254087459306,
          0.006886171425327005,
          0.0073801498440863,
          0.007412651010190267,
          0.007493239138403148,
          0.007580599837201184,
          0.007988515827393003,
          0.008121516444693668,
          0.008441782440084613,
          0.00844974034378196,
          0.00848494458530594,
          0.008797597857375637,
          0.00949501482684684,
          0.009618818281215122,
          0.010018660352510806,
          0.010066063894353026,
          0.010125860831114535,
          0.011344884175108452,
          0.012116362854974043,
          0.01260024587169155,
          0.012929095349498591,
          0.014463841479044932,
          0.014581197915245803,
          0.01591166306650465,
          0.019831017046502142,
          0.03039318231499752,
          0.06450457296503866
         ]
        }
       ],
       "layout": {
        "xaxis": {
         "title": "Theta Values"
        },
        "yaxis": {
         "title": "Fraction of the Loss"
        }
       }
      },
      "text/html": [
       "<div id=\"5ddf5148-5f9d-458e-9cf5-27a8cd063b9e\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"5ddf5148-5f9d-458e-9cf5-27a8cd063b9e\", [{\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.013990560267220856, 0.009365139957748176, 0.009292563394622172, 0.008771641996688898, 0.007609236199251186, 0.007452397730256058, 0.006540988185875729, 0.006348771821221102, 0.006246643814399054, 0.006181546040012114, 0.005672881667228368, 0.005629058131459496, 0.005450924028916626, 0.005403645617210096, 0.005337176656027988, 0.005024349104297025, 0.004759290569655516, 0.004710364989933486, 0.0044819415152254505, 0.004082590689720647, 0.0038492092813884795, 0.0032915965347911137, 0.0031738297879104153, 0.0031654380501643592, 0.0028698596451182615, 0.002743499053484528, 0.0026911351891110314, 0.0025513137660900702, 0.0024835993348221643, 0.00241232283181547, 0.0024113787328249245, 0.0023075072199292604, 0.0022833608968422007, 0.0021594992531224007, 0.002051745910011001, 0.002026813305028562, 0.002017500225717943, 0.0019990625447126775, 0.001896010864866101, 0.001561453341610984, 0.0012378862634423481, 0.0012314131943482066, 0.0011718287800243743, 0.0011136363950864233, 0.001112612220997048, 0.001067192728070354, 0.001032365764437102, 0.0009381867658118173, 0.000883429461606648, 0.000882005534214494, 0.0008756856735125374, 0.0008016922017543702, 0.0007579982887463532, 0.0007458102813451496, 0.0007158617683965838, 0.0006853556446664555, 0.0006685789088427937, 0.000658652114069298, 0.0006477845746038661, 0.000564223581436289, 0.0005063405472814997, 0.0004529836737066684, 0.00041942144341087817, 0.00041434337990302556, 0.00041356238700189155, 0.00040714080218268265, 0.00037060551801376847, 0.0003539393276522486, 0.00026407090275971305, 0.0002238333382717981, 0.00020254581885990278, 0.0001989160389945496, 0.00019523929681805223, 0.00017196664431954427, 0.00016076052901498142, 0.00015581624986110316, 0.0001509358569580077, 0.00012383868268262623, 0.000119649131345077, 0.00011536374813934479, 0.0001145724243759177, 0.00011172233158746517, 0.00010723321636682618, 8.965668366945602e-05, 8.78147875404526e-05, 8.017370476003168e-05, 7.897467703231363e-05, 7.233355742769805e-05, 7.186273210428237e-05, 6.999304854503208e-05, 6.975287355336095e-05, 5.562189944857379e-05, 5.457787010961597e-05, 2.880380265493944e-05, 2.867460084791252e-05, 2.867460084791252e-05, 2.1899709734640262e-05, 1.2166329590486593e-05, 1.1654498109083369e-05, 1.0901717172820031e-05, 1.0373021605545461e-05, 9.253687319623377e-06, 4.115794709600514e-06, 2.619139982885996e-06, 4.449532381089761e-07, 4.080764458367932e-07, 1.8102360909140373e-07, 1.4968091441184892e-07, 0.0, 7.778995029009563e-09, 2.470704848783973e-08, 3.5920469870120693e-06, 4.409178229324721e-06, 5.772220080068808e-06, 6.363630304274168e-06, 7.636004086777467e-06, 9.619681883186375e-06, 1.3043874650510656e-05, 1.4306436789628011e-05, 1.5824352872018823e-05, 1.5824352872018823e-05, 1.997278861959871e-05, 2.913219187707208e-05, 3.332516463511929e-05, 3.38434629618449e-05, 4.63664100609558e-05, 4.8566244166941544e-05, 5.052466127522655e-05, 5.154636770320996e-05, 6.185916269826535e-05, 6.459578613021892e-05, 7.203391787311553e-05, 8.187380355801327e-05, 0.00010157425797156363, 0.00010479442981008501, 0.00011668258591706747, 0.00011887336951331677, 0.00014556136031576862, 0.0001599393430014916, 0.0001746641630814302, 0.00017500929793397104, 0.00018447752631126093, 0.00020648887670539804, 0.00021038752408122306, 0.0002841150562914436, 0.0002913876712714737, 0.0002943242966290006, 0.0003262614871658843, 0.000402405278821891, 0.0004192296489881089, 0.00043522003338437377, 0.0004867226701419317, 0.000511880727082764, 0.0005269334261871628, 0.0005737943387373659, 0.0006013069231506399, 0.000611705466691705, 0.000656062887760596, 0.0006855640055101849, 0.0007091259385194013, 0.0007091259385194013, 0.0007735821537338366, 0.0008197838982992843, 0.0008377470527619863, 0.0009398317452139874, 0.0009419003777148441, 0.0009686904304665381, 0.0010227775689984283, 0.0010503390568529377, 0.001071546893150699, 0.0010768505610186429, 0.0012303927566921257, 0.0012519649373344266, 0.0012986760566612442, 0.001324318167858703, 0.0013899498786326128, 0.0014033412615780537, 0.0014048822798771311, 0.0015231887698510464, 0.0015566387697467507, 0.0015769545833248524, 0.0017525560512976633, 0.0018162006468863815, 0.0019129808148289637, 0.00196299951102866, 0.001994009888465842, 0.0020170852762607674, 0.002034518308322882, 0.0021505143343307975, 0.0021586526435631455, 0.0021689577882651424, 0.002171833126586587, 0.0021985948250196406, 0.002274788441218646, 0.0023441239735331296, 0.0024107611684166604, 0.0024242308285639014, 0.0024426001763378545, 0.00247960736217498, 0.0024807658108825497, 0.002486886767515863, 0.00258975766413803, 0.0026004600855452377, 0.0026065069052765262, 0.0026608004800675014, 0.0027111811254176806, 0.0028839883109254253, 0.0029143038686193358, 0.0030780149201937437, 0.0031108905166891626, 0.0031287599415900165, 0.0032146912144736133, 0.003304151938554088, 0.003371497950901918, 0.0033842375164415805, 0.0037194979075518384, 0.004047200972256309, 0.0043528121630961834, 0.00442080747887888, 0.005025076496295149, 0.005066190943188079, 0.005168858714646611, 0.005281317964078603, 0.0058224463984723, 0.006004585088642985, 0.006454685919682532, 0.006466077035527038, 0.006516589629961786, 0.006973821757336627, 0.008049597028373462, 0.008248626944192821, 0.008908025639778482, 0.008987882113583107, 0.009089124890622038, 0.011276670949670947, 0.012782854652087032, 0.01377572011819693, 0.014471668291356833, 0.017946450606105755, 0.018227527615088914, 0.021566820227930623, 0.03303534159131845, 0.07606942251722455, 0.33587941615467354], \"name\": \"Squared Loss\", \"mode\": \"lines+markers\"}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.011743198517057653, 0.0096078449386436, 0.009570543809434277, 0.009298422986457949, 0.008660428528376955, 0.008570711209120285, 0.008029537517787703, 0.007910678026201805, 0.00784679344897245, 0.007805799708978874, 0.007477746041216819, 0.007448806903453529, 0.007329998974857477, 0.007298141492238464, 0.007253116250136926, 0.007037343552245029, 0.006849201760497172, 0.006813905866245076, 0.00664663671001573, 0.006343614304148493, 0.0061596298008203074, 0.005696028420200765, 0.005593204073225463, 0.005585804847114923, 0.005318622641259186, 0.005200214485003502, 0.00515034838307661, 0.005014767302506392, 0.004947771295889759, 0.0048762567327871285, 0.004875302441032442, 0.0047691434270805645, 0.0047441250604708645, 0.004613657790581691, 0.004497080249063444, 0.004469672703134976, 0.004459391947591519, 0.0044389682668499525, 0.0043230400615383874, 0.003923135921631207, 0.003493085541778546, 0.0034839406707118372, 0.0033986068572073153, 0.0033131458696141125, 0.0033116220245378507, 0.003243323568094692, 0.003189963003820684, 0.003040979556458116, 0.0029509020124021935, 0.00294852289504309, 0.0029379403343210327, 0.002811076592677362, 0.002733398563819633, 0.0027113340760832527, 0.0026563386036870485, 0.0025991230833870694, 0.0025671141784192487, 0.002547985160696306, 0.002526877279070983, 0.0023582751025778836, 0.002234036182347553, 0.002113051705100916, 0.0020332658411349592, 0.002020919672372599, 0.002019014165443887, 0.0020032777309628253, 0.0019112820890420676, 0.0018678124250713002, 0.0016133519724711829, 0.0014853583269907311, 0.001412962027358826, 0.001400244097319588, 0.001387242759368619, 0.0013019399624333516, 0.001258805299610541, 0.0012392964999265348, 0.0012197338085306912, 0.001104833950205753, 0.0010859844939573465, 0.0010663592196492385, 0.0010626956449316567, 0.0010493946472592201, 0.0010280956356663843, 0.0009400699808295833, 0.0009303635277492584, 0.0008889653338695622, 0.0008822928882075039, 0.0008443816012191864, 0.0008416290386422708, 0.0008306083718253389, 0.0008291820674176366, 0.0007404432137658592, 0.0007334611938340721, 0.0005328362494224977, 0.0005316398660593112, 0.0005316398660593112, 0.00046460943893498634, 0.00034629692729409465, 0.0003389343903047409, 0.00032780555185996227, 0.0003197580527760756, 0.0003020134327552047, 0.00020141680452438136, 0.0001606749614973866, 6.622562035297302e-05, 6.34219532732137e-05, 4.224122058730248e-05, 3.8410685961384584e-05, 0.0, 8.756500892847895e-06, 1.56055573156217e-05, 0.00018816543716162012, 0.00020847197294056254, 0.0002385285070579957, 0.00025045016374822146, 0.00027434808013640884, 0.00030792801650561367, 0.00035856851916523774, 0.000375521311901525, 0.000394940642833731, 0.000394940642833731, 0.0004436987468872768, 0.0005358650470562908, 0.0005731324536805327, 0.0005775721539707174, 0.0006760371857758869, 0.0006918884945884157, 0.000705700710402105, 0.0007128003151345205, 0.0007808558493852103, 0.0007979412987865156, 0.0008426308737443181, 0.0008983412304549385, 0.001000600414591527, 0.0010163374969245388, 0.0010724372047079408, 0.001082458202892449, 0.0011978209428829408, 0.0012555861114786657, 0.0013121115334079937, 0.001313407254074965, 0.0013484678066084796, 0.0014266491440799133, 0.001440054208342343, 0.0016734624577721961, 0.0016947452901346144, 0.0017032637623590802, 0.001793295072005791, 0.001991593425422488, 0.002032800898716964, 0.0020712059654521033, 0.0021903304297877534, 0.002246224906116843, 0.002279012587206367, 0.002378192355765018, 0.002434540206763796, 0.0024555005184879763, 0.00254297203881029, 0.002599518144205748, 0.002643811790076765, 0.002643811790076765, 0.0027613539015307253, 0.002842618258690256, 0.002873593308153857, 0.003043644355251565, 0.0030469921464359143, 0.0030900204528330195, 0.0031751149048869646, 0.003217611510103749, 0.003249933241631782, 0.0032579661569213506, 0.0034824968494641326, 0.003512893086257917, 0.003577826415024239, 0.0036129755103678322, 0.003701420443302174, 0.0037192082510431584, 0.0037212497343159234, 0.0038747680840721084, 0.003917082970269071, 0.003942561187353752, 0.00415628009839307, 0.004231075376285646, 0.004342343313470205, 0.00439874660875144, 0.0044333549430266754, 0.004458933331180823, 0.004478160454512572, 0.004604049880633062, 0.004612753333291045, 0.004623750585221666, 0.004626814370987097, 0.004655233291477474, 0.004735211216780618, 0.004806834145538423, 0.004874678108151558, 0.004888277297828269, 0.004906762543560844, 0.004943793337258348, 0.004944948048752287, 0.00495104478811086, 0.005052407984617964, 0.005062837000775854, 0.005068719861057466, 0.005121238531773759, 0.0051694949511613755, 0.005331698678255364, 0.005359647972736666, 0.0055081303545044145, 0.005537467786862324, 0.005553349039029395, 0.005629093740630162, 0.005706881492319665, 0.005764747628730945, 0.005775628717268531, 0.006054956238459993, 0.006316059821108244, 0.006550188716073487, 0.006601150744506639, 0.0070378529438124456, 0.007066585637749267, 0.007137829666824255, 0.007215060994852341, 0.007575679603447013, 0.007693258954848866, 0.007976390482945522, 0.007983425677023887, 0.00801454802794972, 0.008290949519083535, 0.008907501807270995, 0.009016950396017194, 0.009370431247161219, 0.009412338403812672, 0.009465201955748988, 0.01054288096987342, 0.011224907599824257, 0.011652684947138354, 0.011943404712911925, 0.013300198825157445, 0.013403947919946512, 0.014580147194226123, 0.018045056667846057, 0.027382551236471993, 0.05753876606801765], \"name\": \"Absolute Loss\", \"mode\": \"lines+markers\"}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.012702630861316217, 0.010287212331632276, 0.010245018926483303, 0.009937207758921051, 0.009215536345126885, 0.009114052039409667, 0.008501900040304669, 0.008367451384443836, 0.008295187946125852, 0.008248817621237985, 0.007877737667148246, 0.007845002980821289, 0.0077106126507582905, 0.007674576860430678, 0.007623646276767651, 0.007379573642635055, 0.007166755880466962, 0.007126830709357081, 0.006937623159148448, 0.006594857473203013, 0.006386742253781761, 0.005862336658167391, 0.00574602625622859, 0.00573765657542566, 0.0054354317554475605, 0.005301493630362857, 0.005245087277890412, 0.0050917238922692344, 0.005015940941177438, 0.004935046796710442, 0.004933967343635178, 0.004813884912329921, 0.004785585230767874, 0.004638006364020364, 0.00450613895022311, 0.004475136733560728, 0.00446350759275246, 0.004440405218791437, 0.004309272305697706, 0.0038569182415307155, 0.003370464069868324, 0.0033601197918764303, 0.003263593916053795, 0.0031669241864668925, 0.003165200479596621, 0.003087944254253303, 0.0030275851188835265, 0.0028590615624039446, 0.002757169786156429, 0.002754478632704578, 0.0027425081030845854, 0.002599005389806185, 0.00251113940257627, 0.0024861810195406977, 0.002423972547642956, 0.002359252854700713, 0.0023230457820380265, 0.0023014078742321607, 0.0022775315621705087, 0.002086816157769454, 0.001946282527617606, 0.0018094301809618864, 0.0017191799028916164, 0.0017052144570279114, 0.0017030590309708037, 0.0016852586648764241, 0.001581197220255809, 0.0015320262385057476, 0.0012441917091354053, 0.0010994108980788612, 0.0010175193718327349, 0.0010031334058800544, 0.0009884268612989095, 0.0008919360700621996, 0.0008431440269518185, 0.0008210765264099931, 0.0007989480659219161, 0.0006689783739413309, 0.0006476566938424861, 0.0006254574423025414, 0.0006213133668917138, 0.000606267860346073, 0.0005821753504285826, 0.0004867520546077487, 0.0004767522789248577, 0.000435268336059984, 0.0004287587353686386, 0.0003927036586009074, 0.00039014751683707794, 0.0003799968813609027, 0.0003786929554752171, 0.00030197496415989357, 0.0002963068599538307, 0.00015637774618674967, 0.00015567630104673931, 0.00015567630104673931, 0.0001188949699271666, 6.605180654503601e-05, 6.32730396423425e-05, 5.918614224218186e-05, 5.631581910395745e-05, 5.023887936933412e-05, 2.234492119547642e-05, 1.4219483877802429e-05, 2.415680504672731e-06, 2.2154739648903182e-06, 9.82789124596731e-07, 8.126275659954498e-07, 0.0, 4.223267756716973e-08, 1.3413619735353107e-07, 1.9501460232700422e-05, 2.3937719692689417e-05, 3.133776388584821e-05, 3.454856903685402e-05, 4.14563703017976e-05, 5.2225888017192985e-05, 7.081605660978731e-05, 7.767058981504227e-05, 8.591145643631772e-05, 8.591145643631772e-05, 0.00010843358798188433, 0.00015816059295334895, 0.00018092451886899262, 0.00018373839470187038, 0.00025172630124444754, 0.0002636693458347701, 0.00027430172160667753, 0.0002798486332553436, 0.0003358374781149024, 0.00035069478739372994, 0.0003910768956774369, 0.00044449828467156327, 0.0005514533522698171, 0.0005689358777708611, 0.0006323325930421372, 0.0006436679076923543, 0.0007741611911583645, 0.000839502622201395, 0.0009034417060638933, 0.0009049073685845807, 0.0009445663314404208, 0.0010330016393505176, 0.0010481648614690414, 0.001312186059809731, 0.001336260268489739, 0.0013458959915210763, 0.0014477354694280044, 0.0016720418897278417, 0.001718653980373204, 0.0017620961113455837, 0.0018968444927863314, 0.0019600698785945847, 0.00199715786872867, 0.0021093456830410216, 0.0021730839064369816, 0.0021967932938837848, 0.0022957372501175165, 0.002359699730211839, 0.0024098027642318887, 0.0024098027642318887, 0.0025427612573330335, 0.0026346839422083735, 0.0026697215627638536, 0.002862075866193557, 0.0028658627410895615, 0.0029145344784651003, 0.0030107895990887567, 0.0030588598993551517, 0.0030954208277341713, 0.003104507310007621, 0.0033584866044593627, 0.003392869497450273, 0.00346631923761589, 0.003506078356224059, 0.0036061233942101933, 0.0036262441839727674, 0.003628553420520253, 0.003802206660150475, 0.0038500714078132593, 0.0038788912521105934, 0.004120640732424594, 0.004205245877905358, 0.004331107299616558, 0.004394908239158718, 0.004434055672508835, 0.004462988825936692, 0.004484737706514361, 0.004627138316706771, 0.0046369832815101805, 0.004649422891679355, 0.004652888512072911, 0.004685034751384273, 0.004775502280835002, 0.004856519003789297, 0.004933261125599709, 0.004948643933892382, 0.004969553634992741, 0.005011441248440013, 0.005012747407554407, 0.005019643772337371, 0.005134301384803168, 0.005146098231530936, 0.005152752665660903, 0.00521215948787754, 0.005266745037897607, 0.005450222796319987, 0.005481837815239649, 0.005649794588243863, 0.005682979807987786, 0.005700943985511687, 0.005786623077546533, 0.005874613178442527, 0.005940068819860392, 0.005952377031082413, 0.006268340100316896, 0.006563689047709417, 0.0068285254087459306, 0.006886171425327005, 0.0073801498440863, 0.007412651010190267, 0.007493239138403148, 0.007580599837201184, 0.007988515827393003, 0.008121516444693668, 0.008441782440084613, 0.00844974034378196, 0.00848494458530594, 0.008797597857375637, 0.00949501482684684, 0.009618818281215122, 0.010018660352510806, 0.010066063894353026, 0.010125860831114535, 0.011344884175108452, 0.012116362854974043, 0.01260024587169155, 0.012929095349498591, 0.014463841479044932, 0.014581197915245803, 0.01591166306650465, 0.019831017046502142, 0.03039318231499752, 0.06450457296503866], \"name\": \"Huber Loss\", \"mode\": \"lines+markers\"}], {\"xaxis\": {\"title\": \"Theta Values\"}, \"yaxis\": {\"title\": \"Fraction of the Loss\"}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ],
      "text/vnd.plotly.v1+html": [
       "<div id=\"5ddf5148-5f9d-458e-9cf5-27a8cd063b9e\" style=\"height: 525px; width: 100%;\" class=\"plotly-graph-div\"></div><script type=\"text/javascript\">require([\"plotly\"], function(Plotly) { window.PLOTLYENV=window.PLOTLYENV || {};window.PLOTLYENV.BASE_URL=\"https://plot.ly\";Plotly.newPlot(\"5ddf5148-5f9d-458e-9cf5-27a8cd063b9e\", [{\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.013990560267220856, 0.009365139957748176, 0.009292563394622172, 0.008771641996688898, 0.007609236199251186, 0.007452397730256058, 0.006540988185875729, 0.006348771821221102, 0.006246643814399054, 0.006181546040012114, 0.005672881667228368, 0.005629058131459496, 0.005450924028916626, 0.005403645617210096, 0.005337176656027988, 0.005024349104297025, 0.004759290569655516, 0.004710364989933486, 0.0044819415152254505, 0.004082590689720647, 0.0038492092813884795, 0.0032915965347911137, 0.0031738297879104153, 0.0031654380501643592, 0.0028698596451182615, 0.002743499053484528, 0.0026911351891110314, 0.0025513137660900702, 0.0024835993348221643, 0.00241232283181547, 0.0024113787328249245, 0.0023075072199292604, 0.0022833608968422007, 0.0021594992531224007, 0.002051745910011001, 0.002026813305028562, 0.002017500225717943, 0.0019990625447126775, 0.001896010864866101, 0.001561453341610984, 0.0012378862634423481, 0.0012314131943482066, 0.0011718287800243743, 0.0011136363950864233, 0.001112612220997048, 0.001067192728070354, 0.001032365764437102, 0.0009381867658118173, 0.000883429461606648, 0.000882005534214494, 0.0008756856735125374, 0.0008016922017543702, 0.0007579982887463532, 0.0007458102813451496, 0.0007158617683965838, 0.0006853556446664555, 0.0006685789088427937, 0.000658652114069298, 0.0006477845746038661, 0.000564223581436289, 0.0005063405472814997, 0.0004529836737066684, 0.00041942144341087817, 0.00041434337990302556, 0.00041356238700189155, 0.00040714080218268265, 0.00037060551801376847, 0.0003539393276522486, 0.00026407090275971305, 0.0002238333382717981, 0.00020254581885990278, 0.0001989160389945496, 0.00019523929681805223, 0.00017196664431954427, 0.00016076052901498142, 0.00015581624986110316, 0.0001509358569580077, 0.00012383868268262623, 0.000119649131345077, 0.00011536374813934479, 0.0001145724243759177, 0.00011172233158746517, 0.00010723321636682618, 8.965668366945602e-05, 8.78147875404526e-05, 8.017370476003168e-05, 7.897467703231363e-05, 7.233355742769805e-05, 7.186273210428237e-05, 6.999304854503208e-05, 6.975287355336095e-05, 5.562189944857379e-05, 5.457787010961597e-05, 2.880380265493944e-05, 2.867460084791252e-05, 2.867460084791252e-05, 2.1899709734640262e-05, 1.2166329590486593e-05, 1.1654498109083369e-05, 1.0901717172820031e-05, 1.0373021605545461e-05, 9.253687319623377e-06, 4.115794709600514e-06, 2.619139982885996e-06, 4.449532381089761e-07, 4.080764458367932e-07, 1.8102360909140373e-07, 1.4968091441184892e-07, 0.0, 7.778995029009563e-09, 2.470704848783973e-08, 3.5920469870120693e-06, 4.409178229324721e-06, 5.772220080068808e-06, 6.363630304274168e-06, 7.636004086777467e-06, 9.619681883186375e-06, 1.3043874650510656e-05, 1.4306436789628011e-05, 1.5824352872018823e-05, 1.5824352872018823e-05, 1.997278861959871e-05, 2.913219187707208e-05, 3.332516463511929e-05, 3.38434629618449e-05, 4.63664100609558e-05, 4.8566244166941544e-05, 5.052466127522655e-05, 5.154636770320996e-05, 6.185916269826535e-05, 6.459578613021892e-05, 7.203391787311553e-05, 8.187380355801327e-05, 0.00010157425797156363, 0.00010479442981008501, 0.00011668258591706747, 0.00011887336951331677, 0.00014556136031576862, 0.0001599393430014916, 0.0001746641630814302, 0.00017500929793397104, 0.00018447752631126093, 0.00020648887670539804, 0.00021038752408122306, 0.0002841150562914436, 0.0002913876712714737, 0.0002943242966290006, 0.0003262614871658843, 0.000402405278821891, 0.0004192296489881089, 0.00043522003338437377, 0.0004867226701419317, 0.000511880727082764, 0.0005269334261871628, 0.0005737943387373659, 0.0006013069231506399, 0.000611705466691705, 0.000656062887760596, 0.0006855640055101849, 0.0007091259385194013, 0.0007091259385194013, 0.0007735821537338366, 0.0008197838982992843, 0.0008377470527619863, 0.0009398317452139874, 0.0009419003777148441, 0.0009686904304665381, 0.0010227775689984283, 0.0010503390568529377, 0.001071546893150699, 0.0010768505610186429, 0.0012303927566921257, 0.0012519649373344266, 0.0012986760566612442, 0.001324318167858703, 0.0013899498786326128, 0.0014033412615780537, 0.0014048822798771311, 0.0015231887698510464, 0.0015566387697467507, 0.0015769545833248524, 0.0017525560512976633, 0.0018162006468863815, 0.0019129808148289637, 0.00196299951102866, 0.001994009888465842, 0.0020170852762607674, 0.002034518308322882, 0.0021505143343307975, 0.0021586526435631455, 0.0021689577882651424, 0.002171833126586587, 0.0021985948250196406, 0.002274788441218646, 0.0023441239735331296, 0.0024107611684166604, 0.0024242308285639014, 0.0024426001763378545, 0.00247960736217498, 0.0024807658108825497, 0.002486886767515863, 0.00258975766413803, 0.0026004600855452377, 0.0026065069052765262, 0.0026608004800675014, 0.0027111811254176806, 0.0028839883109254253, 0.0029143038686193358, 0.0030780149201937437, 0.0031108905166891626, 0.0031287599415900165, 0.0032146912144736133, 0.003304151938554088, 0.003371497950901918, 0.0033842375164415805, 0.0037194979075518384, 0.004047200972256309, 0.0043528121630961834, 0.00442080747887888, 0.005025076496295149, 0.005066190943188079, 0.005168858714646611, 0.005281317964078603, 0.0058224463984723, 0.006004585088642985, 0.006454685919682532, 0.006466077035527038, 0.006516589629961786, 0.006973821757336627, 0.008049597028373462, 0.008248626944192821, 0.008908025639778482, 0.008987882113583107, 0.009089124890622038, 0.011276670949670947, 0.012782854652087032, 0.01377572011819693, 0.014471668291356833, 0.017946450606105755, 0.018227527615088914, 0.021566820227930623, 0.03303534159131845, 0.07606942251722455, 0.33587941615467354], \"name\": \"Squared Loss\", \"mode\": \"lines+markers\"}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.011743198517057653, 0.0096078449386436, 0.009570543809434277, 0.009298422986457949, 0.008660428528376955, 0.008570711209120285, 0.008029537517787703, 0.007910678026201805, 0.00784679344897245, 0.007805799708978874, 0.007477746041216819, 0.007448806903453529, 0.007329998974857477, 0.007298141492238464, 0.007253116250136926, 0.007037343552245029, 0.006849201760497172, 0.006813905866245076, 0.00664663671001573, 0.006343614304148493, 0.0061596298008203074, 0.005696028420200765, 0.005593204073225463, 0.005585804847114923, 0.005318622641259186, 0.005200214485003502, 0.00515034838307661, 0.005014767302506392, 0.004947771295889759, 0.0048762567327871285, 0.004875302441032442, 0.0047691434270805645, 0.0047441250604708645, 0.004613657790581691, 0.004497080249063444, 0.004469672703134976, 0.004459391947591519, 0.0044389682668499525, 0.0043230400615383874, 0.003923135921631207, 0.003493085541778546, 0.0034839406707118372, 0.0033986068572073153, 0.0033131458696141125, 0.0033116220245378507, 0.003243323568094692, 0.003189963003820684, 0.003040979556458116, 0.0029509020124021935, 0.00294852289504309, 0.0029379403343210327, 0.002811076592677362, 0.002733398563819633, 0.0027113340760832527, 0.0026563386036870485, 0.0025991230833870694, 0.0025671141784192487, 0.002547985160696306, 0.002526877279070983, 0.0023582751025778836, 0.002234036182347553, 0.002113051705100916, 0.0020332658411349592, 0.002020919672372599, 0.002019014165443887, 0.0020032777309628253, 0.0019112820890420676, 0.0018678124250713002, 0.0016133519724711829, 0.0014853583269907311, 0.001412962027358826, 0.001400244097319588, 0.001387242759368619, 0.0013019399624333516, 0.001258805299610541, 0.0012392964999265348, 0.0012197338085306912, 0.001104833950205753, 0.0010859844939573465, 0.0010663592196492385, 0.0010626956449316567, 0.0010493946472592201, 0.0010280956356663843, 0.0009400699808295833, 0.0009303635277492584, 0.0008889653338695622, 0.0008822928882075039, 0.0008443816012191864, 0.0008416290386422708, 0.0008306083718253389, 0.0008291820674176366, 0.0007404432137658592, 0.0007334611938340721, 0.0005328362494224977, 0.0005316398660593112, 0.0005316398660593112, 0.00046460943893498634, 0.00034629692729409465, 0.0003389343903047409, 0.00032780555185996227, 0.0003197580527760756, 0.0003020134327552047, 0.00020141680452438136, 0.0001606749614973866, 6.622562035297302e-05, 6.34219532732137e-05, 4.224122058730248e-05, 3.8410685961384584e-05, 0.0, 8.756500892847895e-06, 1.56055573156217e-05, 0.00018816543716162012, 0.00020847197294056254, 0.0002385285070579957, 0.00025045016374822146, 0.00027434808013640884, 0.00030792801650561367, 0.00035856851916523774, 0.000375521311901525, 0.000394940642833731, 0.000394940642833731, 0.0004436987468872768, 0.0005358650470562908, 0.0005731324536805327, 0.0005775721539707174, 0.0006760371857758869, 0.0006918884945884157, 0.000705700710402105, 0.0007128003151345205, 0.0007808558493852103, 0.0007979412987865156, 0.0008426308737443181, 0.0008983412304549385, 0.001000600414591527, 0.0010163374969245388, 0.0010724372047079408, 0.001082458202892449, 0.0011978209428829408, 0.0012555861114786657, 0.0013121115334079937, 0.001313407254074965, 0.0013484678066084796, 0.0014266491440799133, 0.001440054208342343, 0.0016734624577721961, 0.0016947452901346144, 0.0017032637623590802, 0.001793295072005791, 0.001991593425422488, 0.002032800898716964, 0.0020712059654521033, 0.0021903304297877534, 0.002246224906116843, 0.002279012587206367, 0.002378192355765018, 0.002434540206763796, 0.0024555005184879763, 0.00254297203881029, 0.002599518144205748, 0.002643811790076765, 0.002643811790076765, 0.0027613539015307253, 0.002842618258690256, 0.002873593308153857, 0.003043644355251565, 0.0030469921464359143, 0.0030900204528330195, 0.0031751149048869646, 0.003217611510103749, 0.003249933241631782, 0.0032579661569213506, 0.0034824968494641326, 0.003512893086257917, 0.003577826415024239, 0.0036129755103678322, 0.003701420443302174, 0.0037192082510431584, 0.0037212497343159234, 0.0038747680840721084, 0.003917082970269071, 0.003942561187353752, 0.00415628009839307, 0.004231075376285646, 0.004342343313470205, 0.00439874660875144, 0.0044333549430266754, 0.004458933331180823, 0.004478160454512572, 0.004604049880633062, 0.004612753333291045, 0.004623750585221666, 0.004626814370987097, 0.004655233291477474, 0.004735211216780618, 0.004806834145538423, 0.004874678108151558, 0.004888277297828269, 0.004906762543560844, 0.004943793337258348, 0.004944948048752287, 0.00495104478811086, 0.005052407984617964, 0.005062837000775854, 0.005068719861057466, 0.005121238531773759, 0.0051694949511613755, 0.005331698678255364, 0.005359647972736666, 0.0055081303545044145, 0.005537467786862324, 0.005553349039029395, 0.005629093740630162, 0.005706881492319665, 0.005764747628730945, 0.005775628717268531, 0.006054956238459993, 0.006316059821108244, 0.006550188716073487, 0.006601150744506639, 0.0070378529438124456, 0.007066585637749267, 0.007137829666824255, 0.007215060994852341, 0.007575679603447013, 0.007693258954848866, 0.007976390482945522, 0.007983425677023887, 0.00801454802794972, 0.008290949519083535, 0.008907501807270995, 0.009016950396017194, 0.009370431247161219, 0.009412338403812672, 0.009465201955748988, 0.01054288096987342, 0.011224907599824257, 0.011652684947138354, 0.011943404712911925, 0.013300198825157445, 0.013403947919946512, 0.014580147194226123, 0.018045056667846057, 0.027382551236471993, 0.05753876606801765], \"name\": \"Absolute Loss\", \"mode\": \"lines+markers\"}, {\"type\": \"scatter\", \"x\": [3.563813585135547, 5.643340857787811, 5.679666792881484, 5.9446733372572105, 6.5659881812212735, 6.653359946773121, 7.180385288966725, 7.296137339055794, 7.358351729212656, 7.398273736128237, 7.717750826901875, 7.74593338497289, 7.8616352201257875, 7.892659826361484, 7.936507936507936, 8.146639511201629, 8.329862557267804, 8.364235681911826, 8.527131782945736, 8.822232024702249, 9.0014064697609, 9.45288753799392, 9.55302366345311, 9.560229445506693, 9.820426487093153, 9.935739001482945, 9.98430141287284, 10.116337885685383, 10.181582360570687, 10.2512272596015, 10.252156602521566, 10.355540214014498, 10.379904504878555, 10.506960861570791, 10.620490620490623, 10.647181628392484, 10.657193605683837, 10.677083333333332, 10.789980732177264, 11.179429849077696, 11.59823706796567, 11.607142857142858, 11.69024571854058, 11.773472429210134, 11.77495643515061, 11.841469308844852, 11.893434823977165, 12.03852327447833, 12.12624584717608, 12.128562765312312, 12.138868657441128, 12.262415695892091, 12.338062924120912, 12.359550561797752, 12.413108242303872, 12.468827930174564, 12.5, 12.518628912071533, 12.539184952978058, 12.703379224030037, 12.82437006393381, 12.94219154443486, 13.019891500904157, 13.031914893617023, 13.033770583310075, 13.049095607235142, 13.138686131386862, 13.181019332161686, 13.428827215756492, 13.553474618038445, 13.623978201634875, 13.636363636363638, 13.649025069637883, 13.732097725358045, 13.774104683195592, 13.793103448275861, 13.812154696132598, 13.924050632911392, 13.942407292314066, 13.961519486926493, 13.965087281795514, 13.97804054054054, 13.998782714546559, 14.084507042253522, 14.093959731543624, 14.13427561837456, 14.140773620798985, 14.177693761814744, 14.180374361883155, 14.191106906338694, 14.192495921696574, 14.27891480247501, 14.285714285714285, 14.481094127111827, 14.482259232440258, 14.482259232440258, 14.547537227949597, 14.662756598240467, 14.66992665036675, 14.680764538430255, 14.688601645123384, 14.705882352941178, 14.803849000740193, 14.843525696238874, 14.935505770536322, 14.938236139040505, 14.958863126402393, 14.962593516209477, 15.0, 15.008527572484368, 15.01519756838906, 15.18324607329843, 15.203021718602455, 15.232292460015232, 15.243902439024392, 15.267175572519085, 15.299877600979192, 15.349194167306218, 15.365703749231715, 15.384615384615385, 15.384615384615385, 15.432098765432098, 15.521855486173058, 15.558148580318942, 15.562472209871055, 15.658362989323843, 15.6737998843262, 15.687250996015937, 15.694164989939638, 15.760441292356187, 15.777080062794347, 15.82060128141942, 15.874855156431053, 15.974440894568689, 15.98976654940838, 16.044399596367306, 16.054158607350097, 16.16650532429816, 16.222760290556902, 16.277807921866522, 16.27906976744186, 16.31321370309951, 16.38935108153078, 16.402405686167302, 16.629711751662974, 16.65043816942551, 16.658733936220845, 16.74641148325359, 16.93952555963916, 16.97965571205008, 17.017056723522412, 17.133066818960593, 17.1875, 17.219430485762143, 17.316017316017316, 17.370892018779344, 17.391304347826086, 17.476489028213166, 17.53155680224404, 17.57469244288225, 17.57469244288225, 17.68916155419223, 17.768301350390903, 17.798466593647316, 17.964071856287426, 17.96733212341198, 18.009235505387377, 18.092105263157894, 18.13349084465446, 18.164967562557923, 18.17279046673287, 18.391451068616423, 18.421052631578945, 18.484288354898336, 18.51851851851852, 18.6046511627907, 18.6219739292365, 18.62396204033215, 18.773466833541928, 18.814675446848543, 18.839487565938207, 19.047619047619047, 19.120458891013385, 19.228817858954844, 19.28374655647383, 19.31745009658725, 19.342359767891683, 19.36108422071636, 19.48368241597662, 19.49215832710978, 19.50286806883365, 19.505851755526656, 19.533527696793005, 19.611414693381906, 19.681165124975397, 19.747235387045812, 19.760479041916167, 19.77848101265823, 19.814543679843826, 19.81566820276498, 19.821605550049554, 19.9203187250996, 19.930475086906142, 19.936204146730464, 19.987349778621127, 20.034344590726963, 20.192307692307693, 20.219526285384173, 20.364126770060686, 20.39269720978298, 20.408163265306122, 20.481927710843376, 20.55768179332969, 20.614035087719298, 20.624631703005306, 20.89665653495441, 21.150933871781934, 21.378941742383752, 21.428571428571427, 21.853856562922868, 21.88183807439825, 21.951219512195124, 22.026431718061676, 22.377622377622377, 22.492127755285647, 22.767857142857142, 22.774708410067525, 22.80501710376283, 23.074192403265883, 23.674625657628486, 23.781212841854934, 24.12545235223161, 24.166263895601737, 24.21774539219889, 25.26724975704568, 25.93144560357675, 26.348039215686274, 26.63115845539281, 27.952480782669458, 28.05351747949935, 29.198966408268735, 32.57328990228013, 41.66666666666667, 71.0344827586207], \"y\": [0.012702630861316217, 0.010287212331632276, 0.010245018926483303, 0.009937207758921051, 0.009215536345126885, 0.009114052039409667, 0.008501900040304669, 0.008367451384443836, 0.008295187946125852, 0.008248817621237985, 0.007877737667148246, 0.007845002980821289, 0.0077106126507582905, 0.007674576860430678, 0.007623646276767651, 0.007379573642635055, 0.007166755880466962, 0.007126830709357081, 0.006937623159148448, 0.006594857473203013, 0.006386742253781761, 0.005862336658167391, 0.00574602625622859, 0.00573765657542566, 0.0054354317554475605, 0.005301493630362857, 0.005245087277890412, 0.0050917238922692344, 0.005015940941177438, 0.004935046796710442, 0.004933967343635178, 0.004813884912329921, 0.004785585230767874, 0.004638006364020364, 0.00450613895022311, 0.004475136733560728, 0.00446350759275246, 0.004440405218791437, 0.004309272305697706, 0.0038569182415307155, 0.003370464069868324, 0.0033601197918764303, 0.003263593916053795, 0.0031669241864668925, 0.003165200479596621, 0.003087944254253303, 0.0030275851188835265, 0.0028590615624039446, 0.002757169786156429, 0.002754478632704578, 0.0027425081030845854, 0.002599005389806185, 0.00251113940257627, 0.0024861810195406977, 0.002423972547642956, 0.002359252854700713, 0.0023230457820380265, 0.0023014078742321607, 0.0022775315621705087, 0.002086816157769454, 0.001946282527617606, 0.0018094301809618864, 0.0017191799028916164, 0.0017052144570279114, 0.0017030590309708037, 0.0016852586648764241, 0.001581197220255809, 0.0015320262385057476, 0.0012441917091354053, 0.0010994108980788612, 0.0010175193718327349, 0.0010031334058800544, 0.0009884268612989095, 0.0008919360700621996, 0.0008431440269518185, 0.0008210765264099931, 0.0007989480659219161, 0.0006689783739413309, 0.0006476566938424861, 0.0006254574423025414, 0.0006213133668917138, 0.000606267860346073, 0.0005821753504285826, 0.0004867520546077487, 0.0004767522789248577, 0.000435268336059984, 0.0004287587353686386, 0.0003927036586009074, 0.00039014751683707794, 0.0003799968813609027, 0.0003786929554752171, 0.00030197496415989357, 0.0002963068599538307, 0.00015637774618674967, 0.00015567630104673931, 0.00015567630104673931, 0.0001188949699271666, 6.605180654503601e-05, 6.32730396423425e-05, 5.918614224218186e-05, 5.631581910395745e-05, 5.023887936933412e-05, 2.234492119547642e-05, 1.4219483877802429e-05, 2.415680504672731e-06, 2.2154739648903182e-06, 9.82789124596731e-07, 8.126275659954498e-07, 0.0, 4.223267756716973e-08, 1.3413619735353107e-07, 1.9501460232700422e-05, 2.3937719692689417e-05, 3.133776388584821e-05, 3.454856903685402e-05, 4.14563703017976e-05, 5.2225888017192985e-05, 7.081605660978731e-05, 7.767058981504227e-05, 8.591145643631772e-05, 8.591145643631772e-05, 0.00010843358798188433, 0.00015816059295334895, 0.00018092451886899262, 0.00018373839470187038, 0.00025172630124444754, 0.0002636693458347701, 0.00027430172160667753, 0.0002798486332553436, 0.0003358374781149024, 0.00035069478739372994, 0.0003910768956774369, 0.00044449828467156327, 0.0005514533522698171, 0.0005689358777708611, 0.0006323325930421372, 0.0006436679076923543, 0.0007741611911583645, 0.000839502622201395, 0.0009034417060638933, 0.0009049073685845807, 0.0009445663314404208, 0.0010330016393505176, 0.0010481648614690414, 0.001312186059809731, 0.001336260268489739, 0.0013458959915210763, 0.0014477354694280044, 0.0016720418897278417, 0.001718653980373204, 0.0017620961113455837, 0.0018968444927863314, 0.0019600698785945847, 0.00199715786872867, 0.0021093456830410216, 0.0021730839064369816, 0.0021967932938837848, 0.0022957372501175165, 0.002359699730211839, 0.0024098027642318887, 0.0024098027642318887, 0.0025427612573330335, 0.0026346839422083735, 0.0026697215627638536, 0.002862075866193557, 0.0028658627410895615, 0.0029145344784651003, 0.0030107895990887567, 0.0030588598993551517, 0.0030954208277341713, 0.003104507310007621, 0.0033584866044593627, 0.003392869497450273, 0.00346631923761589, 0.003506078356224059, 0.0036061233942101933, 0.0036262441839727674, 0.003628553420520253, 0.003802206660150475, 0.0038500714078132593, 0.0038788912521105934, 0.004120640732424594, 0.004205245877905358, 0.004331107299616558, 0.004394908239158718, 0.004434055672508835, 0.004462988825936692, 0.004484737706514361, 0.004627138316706771, 0.0046369832815101805, 0.004649422891679355, 0.004652888512072911, 0.004685034751384273, 0.004775502280835002, 0.004856519003789297, 0.004933261125599709, 0.004948643933892382, 0.004969553634992741, 0.005011441248440013, 0.005012747407554407, 0.005019643772337371, 0.005134301384803168, 0.005146098231530936, 0.005152752665660903, 0.00521215948787754, 0.005266745037897607, 0.005450222796319987, 0.005481837815239649, 0.005649794588243863, 0.005682979807987786, 0.005700943985511687, 0.005786623077546533, 0.005874613178442527, 0.005940068819860392, 0.005952377031082413, 0.006268340100316896, 0.006563689047709417, 0.0068285254087459306, 0.006886171425327005, 0.0073801498440863, 0.007412651010190267, 0.007493239138403148, 0.007580599837201184, 0.007988515827393003, 0.008121516444693668, 0.008441782440084613, 0.00844974034378196, 0.00848494458530594, 0.008797597857375637, 0.00949501482684684, 0.009618818281215122, 0.010018660352510806, 0.010066063894353026, 0.010125860831114535, 0.011344884175108452, 0.012116362854974043, 0.01260024587169155, 0.012929095349498591, 0.014463841479044932, 0.014581197915245803, 0.01591166306650465, 0.019831017046502142, 0.03039318231499752, 0.06450457296503866], \"name\": \"Huber Loss\", \"mode\": \"lines+markers\"}], {\"xaxis\": {\"title\": \"Theta Values\"}, \"yaxis\": {\"title\": \"Fraction of the Loss\"}}, {\"showLink\": true, \"linkText\": \"Export to plot.ly\"})});</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "yobs = np.sort(data['pcttip'])\n",
    "theta_est = 15.0\n",
    "\n",
    "lines = [ # Plot the Loss functions\n",
    "    go.Scatter(x = yobs, y = squared_loss(yobs, theta_est) / np.sum(squared_loss(yobs, theta_est)) , \n",
    "               name='Squared Loss', mode='lines+markers'),\n",
    "    go.Scatter(x = yobs, y = abs_loss(yobs, theta_est) / np.sum(abs_loss(yobs, theta_est)) , \n",
    "               name='Absolute Loss', mode='lines+markers'),\n",
    "    go.Scatter(x = yobs, y = huber_loss(yobs, theta_est) / np.sum(huber_loss(yobs, theta_est)) , \n",
    "               name='Huber Loss', mode='lines+markers')\n",
    "] \n",
    "\n",
    "# Assemble the plot\n",
    "py.iplot(go.Figure(data = lines, \n",
    "                   layout=dict(xaxis=dict(title=\"Theta Values\"),\n",
    "                               yaxis=dict(title=\"Fraction of the Loss\"))))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Observations:\n",
    "\n",
    "Notice that the squared loss is much more sensitive to the far right data point than the Huber or Absolute loss functions."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/>\n",
    "\n",
    "## High Level Distinctions Between Loss Functions (so far)\n",
    "\n",
    "1. The squared loss is sensitive to outliers but computationally convenient (more on that soon).\n",
    "1. The absolute loss is much less sensitive to outliers but can be computationally challenging due to the corners.\n",
    "1. The Huber loss is less sensitive to outliers and slightly easier to optimize than the absolute loss (smooth)."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/> \n",
    "\n",
    "# Summary of the Model Design and Estimation (so far)\n",
    "\n",
    "1. **Define the model:** This is usually based on intuition about the problem.  Try to keep models simple and introduce one or more parameters (e.g., $\\theta$) that can be used to fit the model to data.\n",
    "    <br/><br/>\n",
    "1. **Define the objective/loss function:** This quantifies how well a model with a particular assignment for the parameters fits the data.\n",
    "    1. So far we covered three loss functions: \n",
    "        1. *Squared ($L_2$) Loss*: common and easy to optimize -- sensitive to outliers\n",
    "        1. *Absolute ($L_1$) Loss*: robust to outliers -- can be difficult to optimize \n",
    "        1. *Huber Loss*: robust to outliers and slightly easier to optimize.\n",
    "    1. We will soon see that there are actually many more loss functions. \n",
    "    1. The choice of loss function will depend on the estimation task. \n",
    "    <br/><br/>\n",
    "1. **Optimize the Loss Function:** Find the parameters $\\theta$ that minimize the loss on the data. \n",
    "    1. So far we have done this graphically. \n",
    "    1. In the following we will explore computational and analytic approaches."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/> \n",
    "\n",
    "# Minimizing the Average Squared Loss Analytically \n",
    "\n",
    "In some cases, it is possible to use calculus to analytically compute the parameters $\\theta$ that minimize the loss function.  In particular, the use of the squared loss can often lead to a simple closed form estimator."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Using our earlier definition for the squared loss and data we can state the formal estimator $\\hat{\\theta}$:\n",
    "\n",
    "$$\\Large\n",
    "\\hat{\\hspace{0pt}\\theta} = \\arg \\min_{\\theta} \\frac{1}{n}\\sum_{i=1}^n \\left( \\theta - y_i \\right)^2\n",
    "$$\n",
    "\n",
    "To solve for the minimum of the loss function we will need to use some basic concepts from calculus."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Quick Review of Calculus:\n",
    "\n",
    "Suppose we wanted to minimize the function:\n",
    "\n",
    "$$\\Large \n",
    "f(\\theta) = (\\theta - 3)^2\n",
    "$$\n",
    "\n",
    "which looks like:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 30,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXgAAAEBCAYAAABysL6vAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\ngFHhDOiPAAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e861cc0>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "plt.plot(thetas, (thetas-3)**3,'k', label=\"f\")\n",
    "plt.plot(thetas, 3*(thetas-3)**2, '-.', label=r\"$\\partial f / \\partial \\theta$\")\n",
    "plt.plot([3],[0], 'ro', label=\"Minimizer\")\n",
    "plt.legend(); plt.ylim(-5,10); _= plt.xlim(0, 6)\n",
    "plt.savefig(\"calc_cubic.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 31,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYAAAAEBCAYAAABxK3LCAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f163390>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "plt.plot(thetas, -(3-thetas)**2,'k', label=\"f\")\n",
    "plt.plot(thetas, (3-thetas), '-.', label=r\"$\\partial f / \\partial \\theta$\")\n",
    "plt.plot([3],[0], 'ro', label=\"Minimizer\")\n",
    "plt.legend(); plt.ylim(-10,4); _= plt.xlim(0, 6)\n",
    "plt.savefig(\"calc_concave.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 32,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXgAAAEBCAYAAABysL6vAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f3b0940>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "f = lambda theta: (theta - 3)**2\n",
    "df = lambda theta: 2 * (theta - 3)\n",
    "ddf = lambda theta: 2 * np.ones(theta.shape)\n",
    "thetas = np.linspace(0, 6, 100)\n",
    "plt.plot(thetas, f(thetas), 'k', label=\"f\")\n",
    "plt.plot(thetas, df(thetas), '-.', label=r\"$\\partial f / \\partial \\theta$\")\n",
    "# plt.plot(thetas, ddf(thetas), '--', label=r\"$\\partial^2 f / \\partial \\theta^2$\")\n",
    "plt.plot([3],[0], 'ro', label=\"Minimizer\")\n",
    "plt.legend(); plt.ylim(-5,10); _= plt.xlim(0, 6)\n",
    "plt.savefig(\"calc_rev.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Finding the extreme point\n",
    "\n",
    "We can find extreme points (local maximum and minimum) of $f(\\theta) = (\\theta - 3)^2$ by taking the derivative:\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) = 2 (\\theta - 3)\n",
    "$$\n",
    "\n",
    "and setting to zero and solving for $\\theta$\n",
    "\n",
    "\\begin{align}\n",
    "\\Large\n",
    "2 (\\theta - 3) &= \n",
    "\\Large 0 \\\\ \n",
    "\\Large\n",
    "\\theta - 3 &= \n",
    "\\Large 0 \\\\ \n",
    "\\Large\n",
    "\\theta &= \n",
    "\\Large 3 \n",
    "\\end{align}\n",
    "\n",
    "Is this a minimum or a maximum.\n",
    "\n",
    "### Minimum or maximum?\n",
    "\n",
    "To determine if the extreme point is a minimum or a maximum we examine the second derivative: \n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial^2}{\\partial \\theta^2} f(\\theta) = 2 \n",
    "$$\n",
    "\n",
    "If the second derivative is **positive** at the extreme point (when the first derivative is negative) then the point is a maximum (the function is curved upwards). "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Taking the derivative of the average loss:\n",
    "\n",
    "To simplify notation we define the function that we want to minimize:\n",
    "\n",
    "$$\\Large\n",
    "f(\\theta) =  \\frac{1}{n}\\sum_{i=1}^n \\left(y_i - \\theta\\right)^2\n",
    "$$\n",
    "\n",
    "and take the first derivative:\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) =  \n",
    "-\\frac{2}{n}\\sum_{i=1}^n \\left( y_i - \\theta \\right) \n",
    "$$\n",
    "\n",
    "Setting the derivative equal to zero:\n",
    "\n",
    "\\begin{align}\n",
    "0 &= -\\frac{2}{n}\\sum_{i=1}^n \\left( y_i - \\theta \\right)   \\\\\n",
    "0 &= \\sum_{i=1}^n \\left( y_i - \\theta \\right)  \\\\\n",
    "0 &= \\left(\\sum_{i=1}^n y_i\\right) - \\left(\\sum_{i=1}^n \\theta\\right)    \\\\\n",
    "0 &= \\left(\\sum_{i=1}^n y_i\\right) - n \\theta     \\\\\n",
    "n \\theta  &= \\sum_{i=1}^n y_i \\\\\n",
    "\\theta  &= \\frac{1}{n} \\sum_{i=1}^n y_i \\\\\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Thus the value for $\\theta$ that minimizes the average squared loss is:\n",
    "\n",
    "$$\\Large\n",
    "\\hat{\\hspace{0pt}\\theta} = \\frac{1}{n} \\sum_{i=1}^n y_i \\\\\n",
    "$$\n",
    "\n",
    "## The minimizer is the **mean** of the observations!\n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "### Verify that this is the minimizer\n",
    "\n",
    "While we have already graphically seen that the squared loss is curved upwards we can double check by taking the second derivative:\n",
    "\n",
    "\n",
    "$$\\Large\n",
    "f(\\theta) =  \\frac{1}{n}\\sum_{i=1}^n \\left( \\theta - y_i \\right)^2\n",
    "$$\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) =  \n",
    "\\frac{2}{n}\\sum_{i=1}^n \\left( \\theta - y_i \\right) \n",
    "$$\n",
    "\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial^2}{\\partial \\theta^2} f(\\theta) =  \n",
    "\\frac{2}{n}\\sum_{i=1}^n 1 = 2\n",
    "$$\n",
    "\n",
    "which is positive when the derivative is zero (and indeed everywhere) and therefore our extreme point is a minimizer."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/> \n",
    "\n",
    "# Minimizing the Average Absolute Loss Analytically \n",
    "\n",
    "Minimize the absolute loss analytically can be a bit more challenging.  However for our simple constant models we can actually derive an expression for the optimal $\\theta$"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Just as with the average squared loss, we want to minimize:\n",
    "\n",
    "$$\\Large\n",
    "f(\\theta) = \\frac{1}{n}\\sum_{i=1}^n \\left|  y_i - \\theta \\right|\n",
    "$$\n",
    "\n",
    "Just as before we take the first and second derivative of the loss function with respect to $\\theta$.\n",
    "\n",
    "### How do we take the derivative of the absolute value?\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Plotting the Derivatives"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 33,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAX8AAAD8CAYAAACfF6SlAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nsEP/BwPImHRBVAVPAAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f3b06a0>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "f = lambda theta: np.abs(3 - theta)\n",
    "df = lambda theta: -np.sign(3 - theta)\n",
    "ddf = lambda theta: np.zeros(theta.shape)\n",
    "thetas = np.linspace(2, 4, 1000)\n",
    "plt.plot(thetas, f(thetas), 'k', label=\"f\")\n",
    "plt.plot(thetas, df(thetas), '.', label=r\"$\\partial f / \\partial \\theta$\")\n",
    "# plt.plot(thetas, ddf(thetas), '--', label=r\"$\\partial^2 f / \\partial \\theta^2$\")\n",
    "plt.plot([3],[0], 'ro', label=\"Minimizer\")\n",
    "plt.legend(); \n",
    "plt.savefig(\"l1_deriv.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) = \\frac{1}{n}\\sum_{i=1}^n \\textbf{sign}(y_i -\\theta)\n",
    "$$\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial^2}{\\partial \\theta^2} f(\\theta) = 0\n",
    "$$\n",
    "\n",
    "**It is important to note that both of the above equations are not defined at $\\theta = y_i$**"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Convention:\n",
    "\n",
    "We will set set the sign of 0 to be zero implying that the gradient is zero for $\\theta = y_i$: \n",
    "\n",
    "$$\\Large\n",
    "\\textbf{sign}(0) = 0\n",
    "$$\n",
    "\n",
    "This is actually consistent with python:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 34,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "0"
      ]
     },
     "execution_count": 34,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "np.sign(0)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Setting the Derivative to Zero\n",
    "\n",
    "While the derivative of the absolute value function is not defined around zero, we can define $\\textbf{sign}(0) = 0$ and still attempt to find a $\\theta$ value that sets the derivative to zero. \n",
    "\n",
    "Notice that we can rewrite the derivative as:\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) \n",
    "= -\\frac{1}{n}\\sum_{i=1}^n \\textbf{sign}(y_i - \\theta)\n",
    "= -\\frac{1}{n}\\left( \\sum_{y_i < \\theta} -1 + \\sum_{y_i > \\theta} +1 \\right)\n",
    "$$\n",
    "\n",
    "### What value of $\\theta$ sets $\\frac{\\partial}{\\partial \\theta} f(\\theta) = 0$?\n",
    "\n",
    "$$\\Large\n",
    " \\frac{1}{n}\\left( \\sum_{y_i < \\theta} -1 + \\sum_{y_i > \\theta} +1 \\right) = 0\n",
    "$$\n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Notice that we for the above equation to be zero we need the number of data points to the left of $\\theta$ to equal the number of data points to the right of $\\theta$.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Illustration of Loss"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 35,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXQAAAESCAYAAADtzi4UAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\ndCGE0Akp6EIIoRNS0IUQQif+B8ycqeefkof7AAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11ea31ac8>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "x = np.array([5,10,30,40])\n",
    "plt.plot(thetas, avg_loss(abs_loss, thetas, x)-10, '-k', label=\"Absolute Loss\")\n",
    "plt.plot(thetas, [np.mean(-np.sign(x - u)) for u in thetas], '.', label='derivative')\n",
    "plt.vlines(x, -3, -2, colors=\"r\", label=\"Observations\")\n",
    "plt.xlabel(r'Percent Tip ($\\theta$)')\n",
    "plt.legend(loc=9)\n",
    "plt.savefig(\"abslos_4.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 36,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXQAAAEWCAYAAAB2X2wCAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nAABJRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11ea56d68>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "x = np.array([5,10,20, 30,40])\n",
    "plt.plot(thetas, avg_loss(abs_loss, thetas, x)-10, '-k', label=\"Absolute Loss\")\n",
    "plt.plot(thetas, [np.mean(-np.sign(x - u)) for u in thetas], '.', label='derivative')\n",
    "plt.vlines(x, -3, -2, colors=\"r\", label=\"Observations\")\n",
    "plt.xlabel(r'Percent Tip ($\\theta$)')\n",
    "plt.legend(loc=9)\n",
    "plt.savefig(\"abslos_5.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Notice that $\\frac{\\partial}{\\partial \\theta} f(\\theta) $ is zero precisely when half of the data points are above and below $\\theta$.  \n",
    "\n",
    "### The median  of the data minimizes the average absolute loss!\n",
    "\n",
    "\n",
    "$$\\Large\n",
    "\\hat{\\hspace{0pt}\\theta} = \\arg\\min_\\theta \\frac{1}{n}\\sum_{i=1}^n \\left| y_i - \\theta \\right| = \\textbf{median}(\\mathcal{D})\n",
    "$$\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/> \n",
    "\n",
    "# Minimizing the Average Huber Loss Analytically \n",
    "\n",
    "Recall that the Huber loss has the form:\n",
    "\n",
    "$$\\Large\n",
    "f(\\theta) =\\frac{1}{n}\\sum_{i=1}^n \n",
    "\\begin{cases} \n",
    "      \\frac{1}{2}\\left( y_i - \\theta \\right)^2 & \\left| y_i - \\theta \\right| < \\alpha \\\\\n",
    "       \\alpha \\left(\\left| y_i - \\theta  \\right| - \\frac{\\alpha}{2} \\right) & \\text{otherwise}\n",
    "\\end{cases}\n",
    "$$\n",
    "\n",
    "Taking the derivative we get:\n",
    "\n",
    "$$\\Large\n",
    "\\frac{\\partial}{\\partial \\theta} f(\\theta) =\\frac{1}{n}\\sum_{i=1}^n \n",
    "\\begin{cases} \n",
    "      -\\left(y_i - \\theta  \\right) & \\left| \\theta - y_i \\right| < \\alpha \\\\\n",
    "        -\\alpha  \\, \\textbf{sign}(y_i - \\theta) & \\text{otherwise}\n",
    "\\end{cases}\n",
    "$$\n",
    "\n",
    "Unfortunately this is difficult to solve analytically. However we can get a plot of what the derivative looks like\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Derivative at a single point"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 37,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAX8AAAD8CAYAAACfF6SlAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nAAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11edf3160>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "alpha =1.0\n",
    "f = lambda theta: huber_loss(theta, 3, alpha = alpha)\n",
    "\n",
    "def huber_loss_derivative(est, y_obs, alpha=1):\n",
    "    d = abs_loss(est, y_obs)\n",
    "    return np.where(d < alpha, \n",
    "                    est - y_obs,\n",
    "                    alpha * np.sign(est-y_obs))\n",
    "\n",
    "df = lambda theta: huber_loss_derivative(theta, 3.0, alpha=alpha)\n",
    "thetas = np.linspace(1, 5, 1000)\n",
    "plt.plot(thetas, f(thetas), 'k', label=\"f\")\n",
    "plt.plot(thetas, df(thetas), '.', label=r\"$\\partial f / \\partial \\theta$\")\n",
    "# plt.plot(thetas, ddf(thetas), '--', label=r\"$\\partial^2 f / \\partial \\theta^2$\")\n",
    "plt.plot([3],[0], 'ro', label=\"Minimizer\")\n",
    "plt.legend(); "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Derivative on 4 and 5 test points. \n",
    "\n",
    "Notice that for the default $\\alpha=1$ alpha value the curves look similar to the absolute loss but with smooth corners."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 38,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXQAAAESCAYAAADtzi4UAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nSKALIYRJ/D/mWjvIkDTDTwAAAABJRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11e8f9320>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "x = np.array([5,10,30,40])\n",
    "plt.plot(thetas, avg_loss(huber_loss, thetas, x)-10, '-k', label=\"Huber Loss\")\n",
    "plt.plot(thetas, avg_loss(huber_loss_derivative, thetas, x), '.', label='derivative')\n",
    "plt.vlines(x, -3, -2, colors=\"r\", label=\"Observations\")\n",
    "plt.xlabel(r'Percent Tip ($\\theta$)')\n",
    "plt.legend(loc=9)\n",
    "plt.savefig(\"huberloss_4.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 39,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXQAAAESCAYAAADtzi4UAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\ngg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11b3fdc50>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "thetas = np.linspace(0, 50, 200)\n",
    "x = np.array([5,10,20, 30,40])\n",
    "plt.plot(thetas, avg_loss(huber_loss, thetas, x)-10, '-k', label=\"Huber Loss\")\n",
    "plt.plot(thetas, avg_loss(huber_loss_derivative, thetas, x), '.', label='derivative')\n",
    "plt.vlines(x, -3, -2, colors=\"r\", label=\"Observations\")\n",
    "plt.xlabel(r'Percent Tip ($\\theta$)')\n",
    "plt.legend(loc=9)\n",
    "plt.savefig(\"huberloss_5.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Using a Different value for $\\alpha$ and 4 test points\n",
    "\n",
    "Notice in the following figure that the larger $\\alpha$ value results in a unique estimator."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 40,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXwAAAEXCAYAAACu1P9TAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\nAABJRU5ErkJggg==\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11f3e41d0>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "alpha = 10\n",
    "huber_alpha = lambda a, b: huber_loss(a,b,alpha=alpha)\n",
    "huber_derivative_alpha = lambda a, b: huber_loss_derivative(a,b,alpha)\n",
    "thetas = np.linspace(0, 50, 200)\n",
    "x = np.array([5,10,30,40])\n",
    "plt.plot(thetas, avg_loss(huber_alpha, thetas, x)-80, '-k', label=\"Huber Loss\")\n",
    "plt.plot(thetas, avg_loss(huber_derivative_alpha, thetas, x), '.', label='derivative')\n",
    "plt.vlines(x, -10, -2, colors=\"r\", label=\"Observations\")\n",
    "plt.xlabel(r'Percent Tip ($\\theta$)')\n",
    "plt.ylim([-20,50])\n",
    "plt.legend(loc=9)\n",
    "plt.savefig(\"huberloss_4_alpha_10.pdf\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Solving for the Numerical Minimizer\n",
    "\n",
    "Because the loss function is smoother and convex, the Huber loss can be efficiently minimized **using convex optimization**.  "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 41,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 3.4999248461189802\n",
       " hess_inv: array([[ 5.08333333]])\n",
       "      jac: array([  4.36809059e-17])\n",
       "  message: 'Optimization terminated successfully.'\n",
       "     nfev: 10\n",
       "      nit: 7\n",
       "     njev: 10\n",
       "   status: 0\n",
       "  success: True\n",
       "        x: array([ 15.53063381])"
      ]
     },
     "execution_count": 41,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "from scipy.optimize import minimize\n",
    "\n",
    "def huber_loss_derivative(est, y_obs, alpha=1):\n",
    "    d = abs_loss(est, y_obs)\n",
    "    return np.where(d < alpha, \n",
    "                    -(y_obs - est),\n",
    "                    -alpha * np.sign(y_obs-est))\n",
    "\n",
    "f = lambda theta: data['pcttip'].apply(\n",
    "    lambda y: huber_loss(theta, y)).mean()\n",
    "df = lambda theta: data['pcttip'].apply(\n",
    "    lambda y: huber_loss_derivative(theta, y)).mean()\n",
    "minimize(f, x0=0.0, jac=df)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "# Improving the Model\n",
    "\n",
    "So far we have taken a very simple model that the percentage tip is constant:\n",
    "\n",
    "$$\\Large\n",
    "\\text{percentage tip} = \\theta\n",
    "$$\n",
    "\n",
    "We then defined several loss functions and used those to estimate the value of $\\theta$.  How can we improve this model? Recall that we do have additional information:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 42,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style>\n",
       "    .dataframe thead tr:only-child th {\n",
       "        text-align: right;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: left;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>total_bill</th>\n",
       "      <th>tip</th>\n",
       "      <th>sex</th>\n",
       "      <th>smoker</th>\n",
       "      <th>day</th>\n",
       "      <th>time</th>\n",
       "      <th>size</th>\n",
       "      <th>pcttip</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>16.99</td>\n",
       "      <td>1.01</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "      <td>5.944673</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>10.34</td>\n",
       "      <td>1.66</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "      <td>16.054159</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>21.01</td>\n",
       "      <td>3.50</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "      <td>16.658734</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>23.68</td>\n",
       "      <td>3.31</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "      <td>13.978041</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>24.59</td>\n",
       "      <td>3.61</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>4</td>\n",
       "      <td>14.680765</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "   total_bill   tip     sex smoker  day    time  size     pcttip\n",
       "0       16.99  1.01  Female     No  Sun  Dinner     2   5.944673\n",
       "1       10.34  1.66    Male     No  Sun  Dinner     3  16.054159\n",
       "2       21.01  3.50    Male     No  Sun  Dinner     3  16.658734\n",
       "3       23.68  3.31    Male     No  Sun  Dinner     2  13.978041\n",
       "4       24.59  3.61  Female     No  Sun  Dinner     4  14.680765"
      ]
     },
     "execution_count": 42,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "data.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden",
    "solution2_first": true
   },
   "source": [
    "### Question\n",
    "What might be some alternative models:"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "solution2": "hidden"
   },
   "source": [
    "1. $\\Large \\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{total bill}$\n",
    "1. $\\Large \\texttt{percentage tip} = \\theta_1 * \\texttt{(size < 4)} + \\theta_2 * \\texttt{(size >= 4)}$\n",
    "1. $\\Large \\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{is Dinner}$\n",
    "1. $\\Large \\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{is Female}$\n",
    "1. $\\Large \\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{is Male} + \\theta_3 *\\texttt{is Smoker} + \\theta_4 * \\texttt{table size}$\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/> \n",
    "\n",
    "##  $\\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{total bill}$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 43,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "image/png": "iVBORw0KGgoAAAANSUhEUgAAAjgAAAFgCAYAAAC2QAPxAAAABHNCSVQICAgIfAhkiAAAAAlwSFlz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\ngiAIQ8f/B9TCgIMIHe65AAAAAElFTkSuQmCC\n",
      "text/plain": [
       "<matplotlib.figure.Figure at 0x11eaac860>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "sns.lmplot(x = \"total_bill\", y = \"pcttip\", data = data, aspect=1.6)\n",
    "plt.ylabel(\"Percent Tip\")\n",
    "plt.savefig(\"ptip_total_bill.pdf\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 44,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def f(theta, total_bill):\n",
    "    return theta[0] + theta[1] * total_bill"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 45,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 32.88596927218132\n",
       " hess_inv: array([[ 2.95408075, -0.12416698],\n",
       "       [-0.12416698,  0.00627127]])\n",
       "      jac: array([  0.00000000e+00,   4.76837158e-07])\n",
       "  message: 'Optimization terminated successfully.'\n",
       "     nfev: 40\n",
       "      nit: 9\n",
       "     njev: 10\n",
       "   status: 0\n",
       "  success: True\n",
       "        x: array([ 20.67658208,  -0.23230249])"
      ]
     },
     "execution_count": 45,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def l2(theta):\n",
    "    return np.mean(squared_loss(f(theta, data['total_bill']), data['pcttip']).values)\n",
    "\n",
    "minimize(l2, np.array([0.0,0.0]))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 46,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 3.7712728395448254\n",
       " hess_inv: array([[ 619.60004604,  -23.55174969],\n",
       "       [ -23.55174969,    0.90352092]])\n",
       "      jac: array([-0.00032526, -0.06675968])\n",
       "  message: 'Desired error not necessarily achieved due to precision loss.'\n",
       "     nfev: 480\n",
       "      nit: 11\n",
       "     njev: 117\n",
       "   status: 2\n",
       "  success: False\n",
       "        x: array([ 18.75624561,  -0.16260019])"
      ]
     },
     "execution_count": 46,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def l1(theta):\n",
    "    return np.mean(abs_loss(f(theta, data['total_bill']), data['pcttip']).values)\n",
    "\n",
    "minimize(l1, np.array([0.0,0.0]))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 47,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 3.3024895452509297\n",
       " hess_inv: array([[ 30.5492218 ,  -1.22160317],\n",
       "       [ -1.22160317,   0.05944545]])\n",
       "      jac: array([ -2.08616257e-07,  -5.51342964e-06])\n",
       "  message: 'Optimization terminated successfully.'\n",
       "     nfev: 56\n",
       "      nit: 11\n",
       "     njev: 14\n",
       "   status: 0\n",
       "  success: True\n",
       "        x: array([ 18.84706833,  -0.16844153])"
      ]
     },
     "execution_count": 47,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def huber(theta):\n",
    "    return np.mean(huber_loss(f(theta, data['total_bill']), data['pcttip']))\n",
    "\n",
    "minimize(huber, np.array([0.0,0.0]))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "<br/><br/><br/>\n",
    "\n",
    "## $\\texttt{percentage tip} = \\theta_1 + \\theta_2 * \\texttt{is Male} + \\theta_3 *\\texttt{is Smoker} + \\theta_4 * \\texttt{table size}$"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 48,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style>\n",
       "    .dataframe thead tr:only-child th {\n",
       "        text-align: right;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: left;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>total_bill</th>\n",
       "      <th>tip</th>\n",
       "      <th>sex</th>\n",
       "      <th>smoker</th>\n",
       "      <th>day</th>\n",
       "      <th>time</th>\n",
       "      <th>size</th>\n",
       "      <th>pcttip</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>16.99</td>\n",
       "      <td>1.01</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "      <td>5.944673</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>10.34</td>\n",
       "      <td>1.66</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "      <td>16.054159</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>21.01</td>\n",
       "      <td>3.50</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>3</td>\n",
       "      <td>16.658734</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>23.68</td>\n",
       "      <td>3.31</td>\n",
       "      <td>Male</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>2</td>\n",
       "      <td>13.978041</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>24.59</td>\n",
       "      <td>3.61</td>\n",
       "      <td>Female</td>\n",
       "      <td>No</td>\n",
       "      <td>Sun</td>\n",
       "      <td>Dinner</td>\n",
       "      <td>4</td>\n",
       "      <td>14.680765</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "   total_bill   tip     sex smoker  day    time  size     pcttip\n",
       "0       16.99  1.01  Female     No  Sun  Dinner     2   5.944673\n",
       "1       10.34  1.66    Male     No  Sun  Dinner     3  16.054159\n",
       "2       21.01  3.50    Male     No  Sun  Dinner     3  16.658734\n",
       "3       23.68  3.31    Male     No  Sun  Dinner     2  13.978041\n",
       "4       24.59  3.61  Female     No  Sun  Dinner     4  14.680765"
      ]
     },
     "execution_count": 48,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "data.head()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 49,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "def f(theta, data):\n",
    "    return (\n",
    "        theta[0] + \n",
    "        theta[1] * (data['sex'] == 'Male') +\n",
    "        theta[2] * (data['smoker'] == \"Yes\") +\n",
    "        theta[3] * data['size']\n",
    "    )"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 50,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 36.25888793122608\n",
       " hess_inv: array([[ 5.00852276, -1.03468734, -1.13297213, -1.36869473],\n",
       "       [-1.03468734,  2.06166674,  0.00679159, -0.11857307],\n",
       "       [-1.13297213,  0.00679159,  2.08462848,  0.14029876],\n",
       "       [-1.36869473, -0.11857307,  0.14029876,  0.55080528]])\n",
       "      jac: array([  3.81469727e-06,   3.33786011e-06,   4.76837158e-07,\n",
       "         8.10623169e-06])\n",
       "  message: 'Optimization terminated successfully.'\n",
       "     nfev: 84\n",
       "      nit: 13\n",
       "     njev: 14\n",
       "   status: 0\n",
       "  success: True\n",
       "        x: array([ 18.73866929,  -0.73513124,   0.16122391,  -0.87437012])"
      ]
     },
     "execution_count": 50,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def l2(theta):\n",
    "    return np.mean(squared_loss(f(theta, data), data['pcttip']).values)\n",
    "\n",
    "minimize(l2, np.zeros(4))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 51,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 3.90957158852356\n",
       " hess_inv: array([[ 443.57329609, -215.55179077, -211.52560242, -109.7383045 ],\n",
       "       [-215.55179077,  104.77953797,  102.80962477,   53.31466531],\n",
       "       [-211.52560242,  102.80962477,  100.96345597,   52.31890909],\n",
       "       [-109.7383045 ,   53.31466531,   52.31890909,   27.15457305]])\n",
       "      jac: array([ 0.00750431,  0.00340596,  0.00340596,  0.01979941])\n",
       "  message: 'Desired error not necessarily achieved due to precision loss.'\n",
       "     nfev: 1104\n",
       "      nit: 31\n",
       "     njev: 182\n",
       "   status: 2\n",
       "  success: False\n",
       "        x: array([ 18.02471408,  -0.72038142,  -0.9579457 ,  -0.77126898])"
      ]
     },
     "execution_count": 51,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def l1(theta):\n",
    "    return np.mean(abs_loss(f(theta, data), data['pcttip']).values)\n",
    "\n",
    "minimize(l1, np.zeros(4))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 52,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "      fun: 3.4476306812527757\n",
       " hess_inv: array([[ 77.24012512, -19.71060902, -26.073196  , -20.40690306],\n",
       "       [-19.71060902,  20.85365616,   4.85116291,   2.01663757],\n",
       "       [-26.073196  ,   4.85116291,  28.8990574 ,   5.65213441],\n",
       "       [-20.40690306,   2.01663757,   5.65213441,   6.76874477]])\n",
       "      jac: array([ -1.19209290e-07,  -8.94069672e-08,  -1.19209290e-07,\n",
       "        -1.78813934e-07])\n",
       "  message: 'Optimization terminated successfully.'\n",
       "     nfev: 150\n",
       "      nit: 21\n",
       "     njev: 25\n",
       "   status: 0\n",
       "  success: True\n",
       "        x: array([ 18.53021329,  -0.90174037,  -0.87843472,  -0.84144212])"
      ]
     },
     "execution_count": 52,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "def huber(theta):\n",
    "    return np.mean(huber_loss(f(theta, data), data['pcttip']))\n",
    "\n",
    "minimize(huber, np.zeros(4))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "We could use the same loss framework as before and compute the best parameters for each model and then choose the model with the smallest average loss. \n",
    "\n",
    "_**Warning:** There are some issues with this approach that we will revisit later_"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.6.1"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
